!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_N2OCLIM


!**   NITROUS OXIDE CLIMATOLOGY FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_N2OCLIM* FROM *SUECRAD*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG3

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLN2O(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: RGHG3(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG3(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLN2O(:,:,:)=RGHG3(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG3(:, 1, 1) = (/ &
  & 0.89619007E-07_JPRB, 0.89708664E-07_JPRB, 0.89658251E-07_JPRB, 0.89647870E-07_JPRB, 0.89650072E-07_JPRB, 0.89661647E-07_JPRB, &
  & 0.89681933E-07_JPRB, 0.89717233E-07_JPRB, 0.89762921E-07_JPRB, 0.89813270E-07_JPRB, 0.89870447E-07_JPRB, 0.89934730E-07_JPRB, &
  & 0.90009443E-07_JPRB, 0.90100322E-07_JPRB, 0.90212197E-07_JPRB, 0.90348706E-07_JPRB, 0.90513808E-07_JPRB, 0.90702329E-07_JPRB, &
  & 0.90900890E-07_JPRB, 0.91091252E-07_JPRB, 0.91255721E-07_JPRB, 0.91385331E-07_JPRB, 0.91482036E-07_JPRB, 0.91554035E-07_JPRB, &
  & 0.91609330E-07_JPRB, 0.91652446E-07_JPRB, 0.91690346E-07_JPRB, 0.91726513E-07_JPRB, 0.91758551E-07_JPRB, 0.91787555E-07_JPRB, &
  & 0.91814506E-07_JPRB, 0.91840171E-07_JPRB, 0.91865026E-07_JPRB, 0.91889547E-07_JPRB, 0.91914664E-07_JPRB, 0.91941637E-07_JPRB, &
  & 0.91972247E-07_JPRB, 0.92009032E-07_JPRB, 0.92053867E-07_JPRB, 0.92102631E-07_JPRB, 0.92149818E-07_JPRB, 0.92192359E-07_JPRB, &
  & 0.92229087E-07_JPRB, 0.92259484E-07_JPRB, 0.92281510E-07_JPRB, 0.92293341E-07_JPRB, 0.92295210E-07_JPRB, 0.92289007E-07_JPRB, &
  & 0.92277972E-07_JPRB, 0.92265893E-07_JPRB, 0.92255945E-07_JPRB, 0.92250311E-07_JPRB, 0.92250232E-07_JPRB, 0.92255853E-07_JPRB, &
  & 0.92266092E-07_JPRB, 0.92278896E-07_JPRB, 0.92292268E-07_JPRB, 0.92304759E-07_JPRB, 0.92316043E-07_JPRB, 0.92325564E-07_JPRB, &
  & 0.92333707E-07_JPRB, 0.92340329E-07_JPRB, 0.92345381E-07_JPRB, 0.92349836E-07_JPRB /)

RGHG3(:, 2, 1) = (/ &
  & 0.89688704E-07_JPRB, 0.89521379E-07_JPRB, 0.89457409E-07_JPRB, 0.89449117E-07_JPRB, 0.89473744E-07_JPRB, 0.89524434E-07_JPRB, &
  & 0.89592092E-07_JPRB, 0.89674437E-07_JPRB, 0.89773984E-07_JPRB, 0.89882420E-07_JPRB, 0.90015106E-07_JPRB, 0.90185118E-07_JPRB, &
  & 0.90401542E-07_JPRB, 0.90686598E-07_JPRB, 0.91044441E-07_JPRB, 0.91471684E-07_JPRB, 0.91939775E-07_JPRB, 0.92405465E-07_JPRB, &
  & 0.92817416E-07_JPRB, 0.93137338E-07_JPRB, 0.93351716E-07_JPRB, 0.93470909E-07_JPRB, 0.93518366E-07_JPRB, 0.93517691E-07_JPRB, &
  & 0.93486435E-07_JPRB, 0.93436128E-07_JPRB, 0.93368627E-07_JPRB, 0.93286701E-07_JPRB, 0.93197833E-07_JPRB, 0.93109122E-07_JPRB, &
  & 0.93024468E-07_JPRB, 0.92945534E-07_JPRB, 0.92873549E-07_JPRB, 0.92810453E-07_JPRB, 0.92760786E-07_JPRB, 0.92729557E-07_JPRB, &
  & 0.92721429E-07_JPRB, 0.92739192E-07_JPRB, 0.92781519E-07_JPRB, 0.92839038E-07_JPRB, 0.92897309E-07_JPRB, 0.92942422E-07_JPRB, &
  & 0.92964093E-07_JPRB, 0.92957727E-07_JPRB, 0.92923266E-07_JPRB, 0.92865562E-07_JPRB, 0.92795531E-07_JPRB, 0.92727532E-07_JPRB, &
  & 0.92672892E-07_JPRB, 0.92633670E-07_JPRB, 0.92603457E-07_JPRB, 0.92575235E-07_JPRB, 0.92547793E-07_JPRB, 0.92524601E-07_JPRB, &
  & 0.92508337E-07_JPRB, 0.92498965E-07_JPRB, 0.92495299E-07_JPRB, 0.92496116E-07_JPRB, 0.92500088E-07_JPRB, 0.92505658E-07_JPRB, &
  & 0.92513204E-07_JPRB, 0.92521219E-07_JPRB, 0.92528524E-07_JPRB, 0.92540503E-07_JPRB /)

RGHG3(:, 3, 1) = (/ &
  & 0.89749363E-07_JPRB, 0.89534325E-07_JPRB, 0.89484864E-07_JPRB, 0.89493803E-07_JPRB, 0.89542858E-07_JPRB, 0.89629360E-07_JPRB, &
  & 0.89755957E-07_JPRB, 0.89904781E-07_JPRB, 0.90077691E-07_JPRB, 0.90290285E-07_JPRB, 0.90548610E-07_JPRB, 0.90889429E-07_JPRB, &
  & 0.91330683E-07_JPRB, 0.91866710E-07_JPRB, 0.92487703E-07_JPRB, 0.93140393E-07_JPRB, 0.93780528E-07_JPRB, 0.94352657E-07_JPRB, &
  & 0.94814411E-07_JPRB, 0.95146127E-07_JPRB, 0.95351602E-07_JPRB, 0.95451199E-07_JPRB, 0.95474292E-07_JPRB, 0.95447149E-07_JPRB, &
  & 0.95387954E-07_JPRB, 0.95306085E-07_JPRB, 0.95207383E-07_JPRB, 0.95093711E-07_JPRB, 0.94969870E-07_JPRB, 0.94839798E-07_JPRB, &
  & 0.94705037E-07_JPRB, 0.94566467E-07_JPRB, 0.94426539E-07_JPRB, 0.94291920E-07_JPRB, 0.94176016E-07_JPRB, 0.94093416E-07_JPRB, &
  & 0.94054329E-07_JPRB, 0.94061193E-07_JPRB, 0.94110078E-07_JPRB, 0.94185069E-07_JPRB, 0.94257622E-07_JPRB, 0.94299459E-07_JPRB, &
  & 0.94292162E-07_JPRB, 0.94231488E-07_JPRB, 0.94122285E-07_JPRB, 0.93974208E-07_JPRB, 0.93801091E-07_JPRB, 0.93618510E-07_JPRB, &
  & 0.93437635E-07_JPRB, 0.93264433E-07_JPRB, 0.93106465E-07_JPRB, 0.92975569E-07_JPRB, 0.92878324E-07_JPRB, 0.92810808E-07_JPRB, &
  & 0.92766271E-07_JPRB, 0.92741004E-07_JPRB, 0.92732435E-07_JPRB, 0.92737125E-07_JPRB, 0.92749367E-07_JPRB, 0.92763429E-07_JPRB, &
  & 0.92777967E-07_JPRB, 0.92793016E-07_JPRB, 0.92809110E-07_JPRB, 0.92838420E-07_JPRB /)

RGHG3(:, 4, 1) = (/ &
  & 0.89900233E-07_JPRB, 0.89718753E-07_JPRB, 0.89677670E-07_JPRB, 0.89705111E-07_JPRB, 0.89784322E-07_JPRB, 0.89912398E-07_JPRB, &
  & 0.90099640E-07_JPRB, 0.90333614E-07_JPRB, 0.90622649E-07_JPRB, 0.90977395E-07_JPRB, 0.91421242E-07_JPRB, 0.91978556E-07_JPRB, &
  & 0.92645173E-07_JPRB, 0.93394561E-07_JPRB, 0.94171384E-07_JPRB, 0.94929447E-07_JPRB, 0.95621374E-07_JPRB, 0.96218521E-07_JPRB, &
  & 0.96689419E-07_JPRB, 0.97025683E-07_JPRB, 0.97238555E-07_JPRB, 0.97346174E-07_JPRB, 0.97375306E-07_JPRB, 0.97351524E-07_JPRB, &
  & 0.97292940E-07_JPRB, 0.97210844E-07_JPRB, 0.97108313E-07_JPRB, 0.96983108E-07_JPRB, 0.96837056E-07_JPRB, 0.96672807E-07_JPRB, &
  & 0.96494965E-07_JPRB, 0.96306600E-07_JPRB, 0.96112075E-07_JPRB, 0.95926886E-07_JPRB, 0.95775270E-07_JPRB, 0.95678217E-07_JPRB, &
  & 0.95646683E-07_JPRB, 0.95688762E-07_JPRB, 0.95797517E-07_JPRB, 0.95937658E-07_JPRB, 0.96050329E-07_JPRB, 0.96080569E-07_JPRB, &
  & 0.96005529E-07_JPRB, 0.95838317E-07_JPRB, 0.95604541E-07_JPRB, 0.95331316E-07_JPRB, 0.95043177E-07_JPRB, 0.94757652E-07_JPRB, &
  & 0.94482232E-07_JPRB, 0.94219729E-07_JPRB, 0.93976041E-07_JPRB, 0.93756675E-07_JPRB, 0.93562505E-07_JPRB, 0.93398270E-07_JPRB, &
  & 0.93272682E-07_JPRB, 0.93189129E-07_JPRB, 0.93144777E-07_JPRB, 0.93133764E-07_JPRB, 0.93140955E-07_JPRB, 0.93157524E-07_JPRB, &
  & 0.93180901E-07_JPRB, 0.93207916E-07_JPRB, 0.93240111E-07_JPRB, 0.93291739E-07_JPRB /)

RGHG3(:, 5, 1) = (/ &
  & 0.90227445E-07_JPRB, 0.90066322E-07_JPRB, 0.90047536E-07_JPRB, 0.90094588E-07_JPRB, 0.90204836E-07_JPRB, 0.90394366E-07_JPRB, &
  & 0.90679798E-07_JPRB, 0.91051156E-07_JPRB, 0.91512675E-07_JPRB, 0.92097238E-07_JPRB, 0.92813295E-07_JPRB, 0.93638299E-07_JPRB, &
  & 0.94539288E-07_JPRB, 0.95463093E-07_JPRB, 0.96371913E-07_JPRB, 0.97226135E-07_JPRB, 0.97999219E-07_JPRB, 0.98668792E-07_JPRB, &
  & 0.99220337E-07_JPRB, 0.99656837E-07_JPRB, 0.99987275E-07_JPRB, 0.10022865E-06_JPRB, 0.10039563E-06_JPRB, 0.10050879E-06_JPRB, &
  & 0.10058295E-06_JPRB, 0.10062703E-06_JPRB, 0.10064112E-06_JPRB, 0.10060984E-06_JPRB, 0.10051669E-06_JPRB, 0.10035464E-06_JPRB, &
  & 0.10012705E-06_JPRB, 0.99852237E-07_JPRB, 0.99561809E-07_JPRB, 0.99293153E-07_JPRB, 0.99090137E-07_JPRB, 0.98989851E-07_JPRB, &
  & 0.99018237E-07_JPRB, 0.99171203E-07_JPRB, 0.99405078E-07_JPRB, 0.99625908E-07_JPRB, 0.99705645E-07_JPRB, 0.99558527E-07_JPRB, &
  & 0.99195645E-07_JPRB, 0.98694017E-07_JPRB, 0.98132560E-07_JPRB, 0.97570123E-07_JPRB, 0.97040228E-07_JPRB, 0.96552590E-07_JPRB, &
  & 0.96099825E-07_JPRB, 0.95674565E-07_JPRB, 0.95278772E-07_JPRB, 0.94916885E-07_JPRB, 0.94594924E-07_JPRB, 0.94321784E-07_JPRB, &
  & 0.94103314E-07_JPRB, 0.93943385E-07_JPRB, 0.93844541E-07_JPRB, 0.93801816E-07_JPRB, 0.93792899E-07_JPRB, 0.93805198E-07_JPRB, &
  & 0.93829868E-07_JPRB, 0.93862297E-07_JPRB, 0.93904170E-07_JPRB, 0.93978265E-07_JPRB /)

RGHG3(:, 6, 1) = (/ &
  & 0.91020709E-07_JPRB, 0.90859778E-07_JPRB, 0.90857228E-07_JPRB, 0.90948603E-07_JPRB, 0.91132684E-07_JPRB, 0.91430465E-07_JPRB, &
  & 0.91875748E-07_JPRB, 0.92455949E-07_JPRB, 0.93187722E-07_JPRB, 0.94056496E-07_JPRB, 0.95067925E-07_JPRB, 0.96181481E-07_JPRB, &
  & 0.97333086E-07_JPRB, 0.98474857E-07_JPRB, 0.99563728E-07_JPRB, 0.10057890E-06_JPRB, 0.10151209E-06_JPRB, 0.10235386E-06_JPRB, &
  & 0.10310698E-06_JPRB, 0.10378965E-06_JPRB, 0.10441849E-06_JPRB, 0.10500175E-06_JPRB, 0.10554217E-06_JPRB, 0.10603431E-06_JPRB, &
  & 0.10648026E-06_JPRB, 0.10687599E-06_JPRB, 0.10721450E-06_JPRB, 0.10747885E-06_JPRB, 0.10763922E-06_JPRB, 0.10767938E-06_JPRB, &
  & 0.10759662E-06_JPRB, 0.10741217E-06_JPRB, 0.10716645E-06_JPRB, 0.10691583E-06_JPRB, 0.10671889E-06_JPRB, 0.10661465E-06_JPRB, &
  & 0.10661667E-06_JPRB, 0.10669579E-06_JPRB, 0.10676303E-06_JPRB, 0.10666177E-06_JPRB, 0.10622820E-06_JPRB, 0.10543428E-06_JPRB, &
  & 0.10440883E-06_JPRB, 0.10331583E-06_JPRB, 0.10226228E-06_JPRB, 0.10129160E-06_JPRB, 0.10040851E-06_JPRB, 0.99595454E-07_JPRB, &
  & 0.98831656E-07_JPRB, 0.98113247E-07_JPRB, 0.97446367E-07_JPRB, 0.96836331E-07_JPRB, 0.96291799E-07_JPRB, 0.95824134E-07_JPRB, &
  & 0.95443724E-07_JPRB, 0.95158988E-07_JPRB, 0.94969010E-07_JPRB, 0.94860169E-07_JPRB, 0.94806580E-07_JPRB, 0.94790636E-07_JPRB, &
  & 0.94798345E-07_JPRB, 0.94821601E-07_JPRB, 0.94855189E-07_JPRB, 0.94916139E-07_JPRB /)

RGHG3(:, 7, 1) = (/ &
  & 0.92474636E-07_JPRB, 0.92503349E-07_JPRB, 0.92619516E-07_JPRB, 0.92823200E-07_JPRB, 0.93136578E-07_JPRB, 0.93591844E-07_JPRB, &
  & 0.94237137E-07_JPRB, 0.95074775E-07_JPRB, 0.96092151E-07_JPRB, 0.97300273E-07_JPRB, 0.98652620E-07_JPRB, 0.10009753E-06_JPRB, &
  & 0.10156904E-06_JPRB, 0.10302727E-06_JPRB, 0.10443362E-06_JPRB, 0.10575918E-06_JPRB, 0.10699768E-06_JPRB, 0.10815944E-06_JPRB, &
  & 0.10925762E-06_JPRB, 0.11031835E-06_JPRB, 0.11136377E-06_JPRB, 0.11240598E-06_JPRB, 0.11343835E-06_JPRB, 0.11443559E-06_JPRB, &
  & 0.11538039E-06_JPRB, 0.11626447E-06_JPRB, 0.11708637E-06_JPRB, 0.11783850E-06_JPRB, 0.11851181E-06_JPRB, 0.11908173E-06_JPRB, &
  & 0.11953156E-06_JPRB, 0.11984544E-06_JPRB, 0.12001436E-06_JPRB, 0.12004007E-06_JPRB, 0.11993377E-06_JPRB, 0.11970397E-06_JPRB, &
  & 0.11934785E-06_JPRB, 0.11882992E-06_JPRB, 0.11805809E-06_JPRB, 0.11688084E-06_JPRB, 0.11521097E-06_JPRB, 0.11316745E-06_JPRB, &
  & 0.11105134E-06_JPRB, 0.10910759E-06_JPRB, 0.10742860E-06_JPRB, 0.10599827E-06_JPRB, 0.10475131E-06_JPRB, 0.10361583E-06_JPRB, &
  & 0.10254834E-06_JPRB, 0.10153341E-06_JPRB, 0.10056325E-06_JPRB, 0.99645405E-07_JPRB, 0.98804662E-07_JPRB, 0.98067432E-07_JPRB, &
  & 0.97455896E-07_JPRB, 0.96980784E-07_JPRB, 0.96641052E-07_JPRB, 0.96419207E-07_JPRB, 0.96286911E-07_JPRB, 0.96218471E-07_JPRB, &
  & 0.96190021E-07_JPRB, 0.96187406E-07_JPRB, 0.96202299E-07_JPRB, 0.96254297E-07_JPRB /)

RGHG3(:, 8, 1) = (/ &
  & 0.95499821E-07_JPRB, 0.95648595E-07_JPRB, 0.95910799E-07_JPRB, 0.96258319E-07_JPRB, 0.96746859E-07_JPRB, 0.97413000E-07_JPRB, &
  & 0.98317166E-07_JPRB, 0.99441792E-07_JPRB, 0.10078497E-06_JPRB, 0.10232640E-06_JPRB, 0.10407596E-06_JPRB, 0.10596892E-06_JPRB, &
  & 0.10793660E-06_JPRB, 0.10990789E-06_JPRB, 0.11183629E-06_JPRB, 0.11369785E-06_JPRB, 0.11548106E-06_JPRB, 0.11719112E-06_JPRB, &
  & 0.11884981E-06_JPRB, 0.12048565E-06_JPRB, 0.12211557E-06_JPRB, 0.12373582E-06_JPRB, 0.12533836E-06_JPRB, 0.12688315E-06_JPRB, &
  & 0.12834568E-06_JPRB, 0.12971576E-06_JPRB, 0.13101956E-06_JPRB, 0.13228201E-06_JPRB, 0.13350812E-06_JPRB, 0.13468217E-06_JPRB, &
  & 0.13573883E-06_JPRB, 0.13658840E-06_JPRB, 0.13711978E-06_JPRB, 0.13723356E-06_JPRB, 0.13686640E-06_JPRB, 0.13600265E-06_JPRB, &
  & 0.13468680E-06_JPRB, 0.13294928E-06_JPRB, 0.13075410E-06_JPRB, 0.12802117E-06_JPRB, 0.12472100E-06_JPRB, 0.12114867E-06_JPRB, &
  & 0.11780901E-06_JPRB, 0.11501055E-06_JPRB, 0.11276698E-06_JPRB, 0.11093796E-06_JPRB, 0.10937089E-06_JPRB, 0.10796205E-06_JPRB, &
  & 0.10665484E-06_JPRB, 0.10540249E-06_JPRB, 0.10417777E-06_JPRB, 0.10299393E-06_JPRB, 0.10188083E-06_JPRB, 0.10087505E-06_JPRB, &
  & 0.10000934E-06_JPRB, 0.99309595E-07_JPRB, 0.98781157E-07_JPRB, 0.98411945E-07_JPRB, 0.98172791E-07_JPRB, 0.98028949E-07_JPRB, &
  & 0.97944906E-07_JPRB, 0.97895807E-07_JPRB, 0.97866739E-07_JPRB, 0.97850005E-07_JPRB /)

RGHG3(:, 9, 1) = (/ &
  & 0.10102643E-06_JPRB, 0.10147589E-06_JPRB, 0.10183207E-06_JPRB, 0.10224817E-06_JPRB, 0.10283221E-06_JPRB, 0.10364474E-06_JPRB, &
  & 0.10475010E-06_JPRB, 0.10614732E-06_JPRB, 0.10780456E-06_JPRB, 0.10973436E-06_JPRB, 0.11190794E-06_JPRB, 0.11430059E-06_JPRB, &
  & 0.11685114E-06_JPRB, 0.11949034E-06_JPRB, 0.12214014E-06_JPRB, 0.12475297E-06_JPRB, 0.12730533E-06_JPRB, 0.12978903E-06_JPRB, &
  & 0.13220480E-06_JPRB, 0.13455728E-06_JPRB, 0.13686514E-06_JPRB, 0.13910351E-06_JPRB, 0.14123691E-06_JPRB, 0.14323510E-06_JPRB, &
  & 0.14506821E-06_JPRB, 0.14674202E-06_JPRB, 0.14830717E-06_JPRB, 0.14981224E-06_JPRB, 0.15127526E-06_JPRB, 0.15264779E-06_JPRB, &
  & 0.15381221E-06_JPRB, 0.15459172E-06_JPRB, 0.15478939E-06_JPRB, 0.15424109E-06_JPRB, 0.15287115E-06_JPRB, 0.15075528E-06_JPRB, &
  & 0.14804924E-06_JPRB, 0.14490539E-06_JPRB, 0.14134197E-06_JPRB, 0.13724981E-06_JPRB, 0.13263192E-06_JPRB, 0.12786438E-06_JPRB, &
  & 0.12357506E-06_JPRB, 0.12011583E-06_JPRB, 0.11741199E-06_JPRB, 0.11525455E-06_JPRB, 0.11346313E-06_JPRB, 0.11190767E-06_JPRB, &
  & 0.11047278E-06_JPRB, 0.10907475E-06_JPRB, 0.10769293E-06_JPRB, 0.10633596E-06_JPRB, 0.10502821E-06_JPRB, 0.10381183E-06_JPRB, &
  & 0.10273388E-06_JPRB, 0.10182838E-06_JPRB, 0.10112133E-06_JPRB, 0.10061153E-06_JPRB, 0.10027546E-06_JPRB, 0.10006140E-06_JPRB, &
  & 0.99928812E-07_JPRB, 0.99843604E-07_JPRB, 0.99782241E-07_JPRB, 0.99710853E-07_JPRB /)

RGHG3(:,10, 1) = (/ &
  & 0.11219253E-06_JPRB, 0.11222853E-06_JPRB, 0.11214820E-06_JPRB, 0.11234692E-06_JPRB, 0.11269455E-06_JPRB, 0.11336427E-06_JPRB, &
  & 0.11441765E-06_JPRB, 0.11585843E-06_JPRB, 0.11767174E-06_JPRB, 0.11986175E-06_JPRB, 0.12242685E-06_JPRB, 0.12531714E-06_JPRB, &
  & 0.12845636E-06_JPRB, 0.13177444E-06_JPRB, 0.13520460E-06_JPRB, 0.13867319E-06_JPRB, 0.14211855E-06_JPRB, 0.14549583E-06_JPRB, &
  & 0.14878344E-06_JPRB, 0.15194257E-06_JPRB, 0.15494587E-06_JPRB, 0.15776743E-06_JPRB, 0.16035774E-06_JPRB, 0.16265321E-06_JPRB, &
  & 0.16466903E-06_JPRB, 0.16639785E-06_JPRB, 0.16790041E-06_JPRB, 0.16922264E-06_JPRB, 0.17035839E-06_JPRB, 0.17123651E-06_JPRB, &
  & 0.17169577E-06_JPRB, 0.17152749E-06_JPRB, 0.17051327E-06_JPRB, 0.16849687E-06_JPRB, 0.16549768E-06_JPRB, 0.16173991E-06_JPRB, &
  & 0.15756341E-06_JPRB, 0.15317364E-06_JPRB, 0.14859263E-06_JPRB, 0.14369590E-06_JPRB, 0.13845388E-06_JPRB, 0.13312909E-06_JPRB, &
  & 0.12824626E-06_JPRB, 0.12421971E-06_JPRB, 0.12112278E-06_JPRB, 0.11875290E-06_JPRB, 0.11685972E-06_JPRB, 0.11522289E-06_JPRB, &
  & 0.11369922E-06_JPRB, 0.11222824E-06_JPRB, 0.11077395E-06_JPRB, 0.10932109E-06_JPRB, 0.10789538E-06_JPRB, 0.10654438E-06_JPRB, &
  & 0.10531628E-06_JPRB, 0.10427045E-06_JPRB, 0.10344382E-06_JPRB, 0.10285252E-06_JPRB, 0.10245380E-06_JPRB, 0.10220447E-06_JPRB, &
  & 0.10203827E-06_JPRB, 0.10191751E-06_JPRB, 0.10181953E-06_JPRB, 0.10169307E-06_JPRB /)

RGHG3(:,11, 1) = (/ &
  & 0.12974604E-06_JPRB, 0.12842517E-06_JPRB, 0.12736524E-06_JPRB, 0.12697484E-06_JPRB, 0.12674985E-06_JPRB, 0.12696759E-06_JPRB, &
  & 0.12767202E-06_JPRB, 0.12888643E-06_JPRB, 0.13059490E-06_JPRB, 0.13280544E-06_JPRB, 0.13552034E-06_JPRB, 0.13871326E-06_JPRB, &
  & 0.14232000E-06_JPRB, 0.14624021E-06_JPRB, 0.15037035E-06_JPRB, 0.15462741E-06_JPRB, 0.15891075E-06_JPRB, 0.16312528E-06_JPRB, &
  & 0.16719579E-06_JPRB, 0.17106808E-06_JPRB, 0.17466643E-06_JPRB, 0.17792388E-06_JPRB, 0.18082001E-06_JPRB, 0.18328222E-06_JPRB, &
  & 0.18530281E-06_JPRB, 0.18689346E-06_JPRB, 0.18805238E-06_JPRB, 0.18881360E-06_JPRB, 0.18912817E-06_JPRB, 0.18892497E-06_JPRB, &
  & 0.18805079E-06_JPRB, 0.18632753E-06_JPRB, 0.18357886E-06_JPRB, 0.17972668E-06_JPRB, 0.17490883E-06_JPRB, 0.16953541E-06_JPRB, &
  & 0.16410196E-06_JPRB, 0.15883731E-06_JPRB, 0.15368074E-06_JPRB, 0.14856282E-06_JPRB, 0.14330436E-06_JPRB, 0.13787488E-06_JPRB, &
  & 0.13273616E-06_JPRB, 0.12844782E-06_JPRB, 0.12511542E-06_JPRB, 0.12252823E-06_JPRB, 0.12041465E-06_JPRB, 0.11858302E-06_JPRB, &
  & 0.11691456E-06_JPRB, 0.11531266E-06_JPRB, 0.11372038E-06_JPRB, 0.11214023E-06_JPRB, 0.11059606E-06_JPRB, 0.10912541E-06_JPRB, &
  & 0.10779556E-06_JPRB, 0.10666800E-06_JPRB, 0.10579451E-06_JPRB, 0.10516936E-06_JPRB, 0.10476833E-06_JPRB, 0.10450308E-06_JPRB, &
  & 0.10432879E-06_JPRB, 0.10420091E-06_JPRB, 0.10407975E-06_JPRB, 0.10391801E-06_JPRB /)

RGHG3(:,12, 1) = (/ &
  & 0.14909452E-06_JPRB, 0.14652454E-06_JPRB, 0.14479539E-06_JPRB, 0.14382977E-06_JPRB, 0.14318711E-06_JPRB, 0.14299880E-06_JPRB, &
  & 0.14335508E-06_JPRB, 0.14428539E-06_JPRB, 0.14579521E-06_JPRB, 0.14790515E-06_JPRB, 0.15062437E-06_JPRB, 0.15392880E-06_JPRB, &
  & 0.15776500E-06_JPRB, 0.16205344E-06_JPRB, 0.16667177E-06_JPRB, 0.17147582E-06_JPRB, 0.17633725E-06_JPRB, 0.18112269E-06_JPRB, &
  & 0.18570955E-06_JPRB, 0.19000542E-06_JPRB, 0.19394656E-06_JPRB, 0.19742707E-06_JPRB, 0.20042457E-06_JPRB, 0.20289735E-06_JPRB, &
  & 0.20477924E-06_JPRB, 0.20608546E-06_JPRB, 0.20673620E-06_JPRB, 0.20674290E-06_JPRB, 0.20602259E-06_JPRB, 0.20452238E-06_JPRB, &
  & 0.20213392E-06_JPRB, 0.19876201E-06_JPRB, 0.19432423E-06_JPRB, 0.18886323E-06_JPRB, 0.18264744E-06_JPRB, 0.17620371E-06_JPRB, &
  & 0.17003170E-06_JPRB, 0.16440222E-06_JPRB, 0.15924617E-06_JPRB, 0.15431677E-06_JPRB, 0.14942191E-06_JPRB, 0.14457557E-06_JPRB, &
  & 0.13992378E-06_JPRB, 0.13571005E-06_JPRB, 0.13213599E-06_JPRB, 0.12915572E-06_JPRB, 0.12661737E-06_JPRB, 0.12434741E-06_JPRB, &
  & 0.12220619E-06_JPRB, 0.12012457E-06_JPRB, 0.11808886E-06_JPRB, 0.11610398E-06_JPRB, 0.11419904E-06_JPRB, 0.11244374E-06_JPRB, &
  & 0.11090393E-06_JPRB, 0.10964530E-06_JPRB, 0.10869252E-06_JPRB, 0.10804142E-06_JPRB, 0.10760772E-06_JPRB, 0.10733816E-06_JPRB, &
  & 0.10715046E-06_JPRB, 0.10700241E-06_JPRB, 0.10686760E-06_JPRB, 0.10663935E-06_JPRB /)

RGHG3(:,13, 1) = (/ &
  & 0.16653023E-06_JPRB, 0.16345864E-06_JPRB, 0.16178318E-06_JPRB, 0.16066454E-06_JPRB, 0.15997185E-06_JPRB, 0.15971267E-06_JPRB, &
  & 0.15997199E-06_JPRB, 0.16078633E-06_JPRB, 0.16217120E-06_JPRB, 0.16417337E-06_JPRB, 0.16682472E-06_JPRB, 0.17011936E-06_JPRB, &
  & 0.17399805E-06_JPRB, 0.17837243E-06_JPRB, 0.18313058E-06_JPRB, 0.18812618E-06_JPRB, 0.19318830E-06_JPRB, 0.19816282E-06_JPRB, &
  & 0.20290985E-06_JPRB, 0.20730999E-06_JPRB, 0.21128169E-06_JPRB, 0.21473960E-06_JPRB, 0.21763670E-06_JPRB, 0.21993812E-06_JPRB, &
  & 0.22155810E-06_JPRB, 0.22246910E-06_JPRB, 0.22256241E-06_JPRB, 0.22180519E-06_JPRB, 0.22011135E-06_JPRB, 0.21744980E-06_JPRB, &
  & 0.21377657E-06_JPRB, 0.20908870E-06_JPRB, 0.20345671E-06_JPRB, 0.19705631E-06_JPRB, 0.19031043E-06_JPRB, 0.18379092E-06_JPRB, &
  & 0.17793244E-06_JPRB, 0.17286925E-06_JPRB, 0.16846303E-06_JPRB, 0.16446205E-06_JPRB, 0.16066983E-06_JPRB, 0.15696587E-06_JPRB, &
  & 0.15331099E-06_JPRB, 0.14972579E-06_JPRB, 0.14625718E-06_JPRB, 0.14292667E-06_JPRB, 0.13970001E-06_JPRB, 0.13652794E-06_JPRB, &
  & 0.13337848E-06_JPRB, 0.13023404E-06_JPRB, 0.12710900E-06_JPRB, 0.12407730E-06_JPRB, 0.12124320E-06_JPRB, 0.11870991E-06_JPRB, &
  & 0.11656924E-06_JPRB, 0.11487425E-06_JPRB, 0.11362829E-06_JPRB, 0.11276403E-06_JPRB, 0.11221138E-06_JPRB, 0.11183781E-06_JPRB, &
  & 0.11157680E-06_JPRB, 0.11136041E-06_JPRB, 0.11112289E-06_JPRB, 0.11073381E-06_JPRB /)

RGHG3(:,14, 1) = (/ &
  & 0.18136902E-06_JPRB, 0.17849956E-06_JPRB, 0.17720104E-06_JPRB, 0.17640282E-06_JPRB, 0.17596973E-06_JPRB, 0.17592080E-06_JPRB, &
  & 0.17632559E-06_JPRB, 0.17721995E-06_JPRB, 0.17863000E-06_JPRB, 0.18060422E-06_JPRB, 0.18318764E-06_JPRB, 0.18638463E-06_JPRB, &
  & 0.19015519E-06_JPRB, 0.19441030E-06_JPRB, 0.19903280E-06_JPRB, 0.20388268E-06_JPRB, 0.20880067E-06_JPRB, 0.21361976E-06_JPRB, &
  & 0.21820041E-06_JPRB, 0.22241875E-06_JPRB, 0.22617859E-06_JPRB, 0.22939628E-06_JPRB, 0.23202949E-06_JPRB, 0.23400727E-06_JPRB, &
  & 0.23526837E-06_JPRB, 0.23571951E-06_JPRB, 0.23526523E-06_JPRB, 0.23383389E-06_JPRB, 0.23135884E-06_JPRB, 0.22783571E-06_JPRB, &
  & 0.22331243E-06_JPRB, 0.21793124E-06_JPRB, 0.21191471E-06_JPRB, 0.20563940E-06_JPRB, 0.19953328E-06_JPRB, 0.19406460E-06_JPRB, &
  & 0.18957134E-06_JPRB, 0.18596745E-06_JPRB, 0.18306940E-06_JPRB, 0.18061894E-06_JPRB, 0.17836383E-06_JPRB, 0.17610562E-06_JPRB, &
  & 0.17369176E-06_JPRB, 0.17101638E-06_JPRB, 0.16802424E-06_JPRB, 0.16471392E-06_JPRB, 0.16109483E-06_JPRB, 0.15716618E-06_JPRB, &
  & 0.15293114E-06_JPRB, 0.14844076E-06_JPRB, 0.14381489E-06_JPRB, 0.13922391E-06_JPRB, 0.13486341E-06_JPRB, 0.13093954E-06_JPRB, &
  & 0.12760574E-06_JPRB, 0.12493425E-06_JPRB, 0.12291382E-06_JPRB, 0.12147109E-06_JPRB, 0.12047070E-06_JPRB, 0.11979193E-06_JPRB, &
  & 0.11927533E-06_JPRB, 0.11883523E-06_JPRB, 0.11836108E-06_JPRB, 0.11752774E-06_JPRB /)

RGHG3(:,15, 1) = (/ &
  & 0.19378484E-06_JPRB, 0.19185042E-06_JPRB, 0.19106550E-06_JPRB, 0.19069600E-06_JPRB, 0.19066761E-06_JPRB, 0.19099728E-06_JPRB, &
  & 0.19173564E-06_JPRB, 0.19289976E-06_JPRB, 0.19450547E-06_JPRB, 0.19658594E-06_JPRB, 0.19917044E-06_JPRB, 0.20225944E-06_JPRB, &
  & 0.20582206E-06_JPRB, 0.20979444E-06_JPRB, 0.21408043E-06_JPRB, 0.21855732E-06_JPRB, 0.22308335E-06_JPRB, 0.22751129E-06_JPRB, &
  & 0.23170369E-06_JPRB, 0.23553871E-06_JPRB, 0.23891766E-06_JPRB, 0.24175517E-06_JPRB, 0.24399921E-06_JPRB, 0.24556707E-06_JPRB, &
  & 0.24639138E-06_JPRB, 0.24636086E-06_JPRB, 0.24538650E-06_JPRB, 0.24338766E-06_JPRB, 0.24034387E-06_JPRB, 0.23631759E-06_JPRB, &
  & 0.23144035E-06_JPRB, 0.22598627E-06_JPRB, 0.22033339E-06_JPRB, 0.21488133E-06_JPRB, 0.21017313E-06_JPRB, 0.20653702E-06_JPRB, &
  & 0.20399213E-06_JPRB, 0.20231774E-06_JPRB, 0.20112918E-06_JPRB, 0.20015946E-06_JPRB, 0.19917715E-06_JPRB, 0.19797810E-06_JPRB, &
  & 0.19642889E-06_JPRB, 0.19444943E-06_JPRB, 0.19199481E-06_JPRB, 0.18904439E-06_JPRB, 0.18557404E-06_JPRB, 0.18155878E-06_JPRB, &
  & 0.17698972E-06_JPRB, 0.17190607E-06_JPRB, 0.16641040E-06_JPRB, 0.16072099E-06_JPRB, 0.15509188E-06_JPRB, 0.14982763E-06_JPRB, &
  & 0.14514855E-06_JPRB, 0.14121115E-06_JPRB, 0.13804768E-06_JPRB, 0.13562781E-06_JPRB, 0.13384498E-06_JPRB, 0.13253032E-06_JPRB, &
  & 0.13154028E-06_JPRB, 0.13064539E-06_JPRB, 0.12972494E-06_JPRB, 0.12806210E-06_JPRB /)

RGHG3(:,16, 1) = (/ &
  & 0.20436585E-06_JPRB, 0.20340981E-06_JPRB, 0.20322912E-06_JPRB, 0.20340534E-06_JPRB, 0.20390107E-06_JPRB, 0.20473050E-06_JPRB, &
  & 0.20591430E-06_JPRB, 0.20745622E-06_JPRB, 0.20934417E-06_JPRB, 0.21159799E-06_JPRB, 0.21423051E-06_JPRB, 0.21723484E-06_JPRB, &
  & 0.22058610E-06_JPRB, 0.22423562E-06_JPRB, 0.22811409E-06_JPRB, 0.23212527E-06_JPRB, 0.23615313E-06_JPRB, 0.24007400E-06_JPRB, &
  & 0.24376030E-06_JPRB, 0.24710690E-06_JPRB, 0.25000500E-06_JPRB, 0.25237864E-06_JPRB, 0.25415193E-06_JPRB, 0.25524855E-06_JPRB, &
  & 0.25559220E-06_JPRB, 0.25507995E-06_JPRB, 0.25363377E-06_JPRB, 0.25121298E-06_JPRB, 0.24784472E-06_JPRB, 0.24365823E-06_JPRB, &
  & 0.23892443E-06_JPRB, 0.23397877E-06_JPRB, 0.22922144E-06_JPRB, 0.22519679E-06_JPRB, 0.22220203E-06_JPRB, 0.22044166E-06_JPRB, &
  & 0.21970109E-06_JPRB, 0.21960354E-06_JPRB, 0.21975522E-06_JPRB, 0.21982687E-06_JPRB, 0.21959761E-06_JPRB, 0.21895546E-06_JPRB, &
  & 0.21784301E-06_JPRB, 0.21623281E-06_JPRB, 0.21412308E-06_JPRB, 0.21151570E-06_JPRB, 0.20837916E-06_JPRB, 0.20465637E-06_JPRB, &
  & 0.20030163E-06_JPRB, 0.19531743E-06_JPRB, 0.18979955E-06_JPRB, 0.18391705E-06_JPRB, 0.17791895E-06_JPRB, 0.17206705E-06_JPRB, &
  & 0.16663927E-06_JPRB, 0.16183039E-06_JPRB, 0.15774572E-06_JPRB, 0.15438887E-06_JPRB, 0.15174447E-06_JPRB, 0.14970138E-06_JPRB, &
  & 0.14801896E-06_JPRB, 0.14659877E-06_JPRB, 0.14496179E-06_JPRB, 0.14238033E-06_JPRB /)

RGHG3(:,17, 1) = (/ &
  & 0.21357816E-06_JPRB, 0.21361633E-06_JPRB, 0.21400177E-06_JPRB, 0.21466204E-06_JPRB, 0.21562245E-06_JPRB, 0.21689652E-06_JPRB, &
  & 0.21850140E-06_JPRB, 0.22041095E-06_JPRB, 0.22260572E-06_JPRB, 0.22507564E-06_JPRB, 0.22781472E-06_JPRB, 0.23079923E-06_JPRB, &
  & 0.23400145E-06_JPRB, 0.23738671E-06_JPRB, 0.24090062E-06_JPRB, 0.24447212E-06_JPRB, 0.24801227E-06_JPRB, 0.25141398E-06_JPRB, &
  & 0.25457771E-06_JPRB, 0.25740201E-06_JPRB, 0.25977974E-06_JPRB, 0.26164298E-06_JPRB, 0.26290522E-06_JPRB, 0.26349909E-06_JPRB, &
  & 0.26335277E-06_JPRB, 0.26239294E-06_JPRB, 0.26058467E-06_JPRB, 0.25793315E-06_JPRB, 0.25455273E-06_JPRB, 0.25063915E-06_JPRB, &
  & 0.24649549E-06_JPRB, 0.24248530E-06_JPRB, 0.23904366E-06_JPRB, 0.23649429E-06_JPRB, 0.23512021E-06_JPRB, 0.23482919E-06_JPRB, &
  & 0.23541452E-06_JPRB, 0.23638208E-06_JPRB, 0.23729663E-06_JPRB, 0.23787251E-06_JPRB, 0.23797857E-06_JPRB, 0.23754484E-06_JPRB, &
  & 0.23656629E-06_JPRB, 0.23508377E-06_JPRB, 0.23314317E-06_JPRB, 0.23075640E-06_JPRB, 0.22789739E-06_JPRB, 0.22450466E-06_JPRB, &
  & 0.22051742E-06_JPRB, 0.21592501E-06_JPRB, 0.21078372E-06_JPRB, 0.20523395E-06_JPRB, 0.19945969E-06_JPRB, 0.19370813E-06_JPRB, &
  & 0.18821757E-06_JPRB, 0.18319928E-06_JPRB, 0.17876548E-06_JPRB, 0.17495448E-06_JPRB, 0.17175623E-06_JPRB, 0.16910380E-06_JPRB, &
  & 0.16693181E-06_JPRB, 0.16486287E-06_JPRB, 0.16276402E-06_JPRB, 0.15892726E-06_JPRB /)

RGHG3(:,18, 1) = (/ &
  & 0.22164880E-06_JPRB, 0.22243887E-06_JPRB, 0.22327966E-06_JPRB, 0.22434432E-06_JPRB, 0.22569691E-06_JPRB, 0.22736731E-06_JPRB, &
  & 0.22934648E-06_JPRB, 0.23160440E-06_JPRB, 0.23408664E-06_JPRB, 0.23676996E-06_JPRB, 0.23963247E-06_JPRB, 0.24263755E-06_JPRB, &
  & 0.24574985E-06_JPRB, 0.24894220E-06_JPRB, 0.25216968E-06_JPRB, 0.25537730E-06_JPRB, 0.25850201E-06_JPRB, 0.26144320E-06_JPRB, &
  & 0.26412386E-06_JPRB, 0.26645574E-06_JPRB, 0.26833243E-06_JPRB, 0.26968888E-06_JPRB, 0.27045024E-06_JPRB, 0.27055901E-06_JPRB, &
  & 0.26997026E-06_JPRB, 0.26866155E-06_JPRB, 0.26664998E-06_JPRB, 0.26403015E-06_JPRB, 0.26094730E-06_JPRB, 0.25769543E-06_JPRB, &
  & 0.25450336E-06_JPRB, 0.25173895E-06_JPRB, 0.24969100E-06_JPRB, 0.24854887E-06_JPRB, 0.24835367E-06_JPRB, 0.24908201E-06_JPRB, &
  & 0.25033893E-06_JPRB, 0.25173372E-06_JPRB, 0.25288105E-06_JPRB, 0.25356391E-06_JPRB, 0.25366174E-06_JPRB, 0.25316629E-06_JPRB, &
  & 0.25214544E-06_JPRB, 0.25067123E-06_JPRB, 0.24880018E-06_JPRB, 0.24655458E-06_JPRB, 0.24391025E-06_JPRB, 0.24080992E-06_JPRB, &
  & 0.23720015E-06_JPRB, 0.23306339E-06_JPRB, 0.22844391E-06_JPRB, 0.22343919E-06_JPRB, 0.21819611E-06_JPRB, 0.21289711E-06_JPRB, &
  & 0.20776591E-06_JPRB, 0.20298700E-06_JPRB, 0.19865905E-06_JPRB, 0.19480012E-06_JPRB, 0.19141116E-06_JPRB, 0.18849254E-06_JPRB, &
  & 0.18589353E-06_JPRB, 0.18351756E-06_JPRB, 0.18083664E-06_JPRB, 0.17629056E-06_JPRB /)

RGHG3(:,19, 1) = (/ &
  & 0.22900889E-06_JPRB, 0.23033530E-06_JPRB, 0.23149559E-06_JPRB, 0.23283725E-06_JPRB, 0.23445786E-06_JPRB, 0.23638808E-06_JPRB, &
  & 0.23862435E-06_JPRB, 0.24111367E-06_JPRB, 0.24379872E-06_JPRB, 0.24663416E-06_JPRB, 0.24958132E-06_JPRB, 0.25260260E-06_JPRB, &
  & 0.25565259E-06_JPRB, 0.25870256E-06_JPRB, 0.26171634E-06_JPRB, 0.26463877E-06_JPRB, 0.26742998E-06_JPRB, 0.27000328E-06_JPRB, &
  & 0.27227708E-06_JPRB, 0.27418258E-06_JPRB, 0.27562871E-06_JPRB, 0.27654505E-06_JPRB, 0.27687770E-06_JPRB, 0.27658783E-06_JPRB, &
  & 0.27567089E-06_JPRB, 0.27416107E-06_JPRB, 0.27214935E-06_JPRB, 0.26978904E-06_JPRB, 0.26732866E-06_JPRB, 0.26493956E-06_JPRB, &
  & 0.26296652E-06_JPRB, 0.26151073E-06_JPRB, 0.26072124E-06_JPRB, 0.26066749E-06_JPRB, 0.26129646E-06_JPRB, 0.26243600E-06_JPRB, &
  & 0.26386274E-06_JPRB, 0.26520880E-06_JPRB, 0.26618719E-06_JPRB, 0.26664100E-06_JPRB, 0.26654237E-06_JPRB, 0.26590459E-06_JPRB, &
  & 0.26478529E-06_JPRB, 0.26326595E-06_JPRB, 0.26141601E-06_JPRB, 0.25925641E-06_JPRB, 0.25676678E-06_JPRB, 0.25390560E-06_JPRB, &
  & 0.25063537E-06_JPRB, 0.24694532E-06_JPRB, 0.24286899E-06_JPRB, 0.23848398E-06_JPRB, 0.23389458E-06_JPRB, 0.22925403E-06_JPRB, &
  & 0.22473608E-06_JPRB, 0.22048800E-06_JPRB, 0.21657357E-06_JPRB, 0.21299634E-06_JPRB, 0.20974301E-06_JPRB, 0.20678154E-06_JPRB, &
  & 0.20407249E-06_JPRB, 0.20145259E-06_JPRB, 0.19843446E-06_JPRB, 0.19339711E-06_JPRB /)

RGHG3(:,20, 1) = (/ &
  & 0.23547190E-06_JPRB, 0.23722184E-06_JPRB, 0.23859593E-06_JPRB, 0.24011604E-06_JPRB, 0.24190859E-06_JPRB, 0.24400856E-06_JPRB, &
  & 0.24639903E-06_JPRB, 0.24903159E-06_JPRB, 0.25183297E-06_JPRB, 0.25474731E-06_JPRB, 0.25773656E-06_JPRB, 0.26074414E-06_JPRB, &
  & 0.26373388E-06_JPRB, 0.26666658E-06_JPRB, 0.26951588E-06_JPRB, 0.27222623E-06_JPRB, 0.27475417E-06_JPRB, 0.27704419E-06_JPRB, &
  & 0.27901172E-06_JPRB, 0.28058852E-06_JPRB, 0.28170220E-06_JPRB, 0.28229118E-06_JPRB, 0.28231599E-06_JPRB, 0.28176791E-06_JPRB, &
  & 0.28068308E-06_JPRB, 0.27915760E-06_JPRB, 0.27735217E-06_JPRB, 0.27547031E-06_JPRB, 0.27370842E-06_JPRB, 0.27235575E-06_JPRB, &
  & 0.27146260E-06_JPRB, 0.27113683E-06_JPRB, 0.27135147E-06_JPRB, 0.27200329E-06_JPRB, 0.27303565E-06_JPRB, 0.27428808E-06_JPRB, &
  & 0.27553995E-06_JPRB, 0.27657731E-06_JPRB, 0.27722706E-06_JPRB, 0.27735612E-06_JPRB, 0.27696589E-06_JPRB, 0.27610599E-06_JPRB, &
  & 0.27486786E-06_JPRB, 0.27330549E-06_JPRB, 0.27146780E-06_JPRB, 0.26936618E-06_JPRB, 0.26700278E-06_JPRB, 0.26435021E-06_JPRB, &
  & 0.26138926E-06_JPRB, 0.25811806E-06_JPRB, 0.25456913E-06_JPRB, 0.25080064E-06_JPRB, 0.24689550E-06_JPRB, 0.24297077E-06_JPRB, &
  & 0.23915635E-06_JPRB, 0.23555009E-06_JPRB, 0.23219279E-06_JPRB, 0.22906130E-06_JPRB, 0.22613406E-06_JPRB, 0.22338617E-06_JPRB, &
  & 0.22077744E-06_JPRB, 0.21808411E-06_JPRB, 0.21516124E-06_JPRB, 0.20951570E-06_JPRB /)

RGHG3(:,21, 1) = (/ &
  & 0.24115349E-06_JPRB, 0.24330754E-06_JPRB, 0.24484129E-06_JPRB, 0.24645448E-06_JPRB, 0.24831360E-06_JPRB, 0.25047018E-06_JPRB, &
  & 0.25291800E-06_JPRB, 0.25559578E-06_JPRB, 0.25843096E-06_JPRB, 0.26136439E-06_JPRB, 0.26433568E-06_JPRB, 0.26730177E-06_JPRB, &
  & 0.27021522E-06_JPRB, 0.27304284E-06_JPRB, 0.27575174E-06_JPRB, 0.27830058E-06_JPRB, 0.28063945E-06_JPRB, 0.28271762E-06_JPRB, &
  & 0.28446988E-06_JPRB, 0.28582622E-06_JPRB, 0.28672423E-06_JPRB, 0.28711653E-06_JPRB, 0.28698196E-06_JPRB, 0.28633838E-06_JPRB, &
  & 0.28526398E-06_JPRB, 0.28389650E-06_JPRB, 0.28242678E-06_JPRB, 0.28106416E-06_JPRB, 0.28006571E-06_JPRB, 0.27952220E-06_JPRB, &
  & 0.27950938E-06_JPRB, 0.27995765E-06_JPRB, 0.28075974E-06_JPRB, 0.28180227E-06_JPRB, 0.28294068E-06_JPRB, 0.28405069E-06_JPRB, &
  & 0.28501231E-06_JPRB, 0.28567547E-06_JPRB, 0.28592962E-06_JPRB, 0.28573754E-06_JPRB, 0.28512241E-06_JPRB, 0.28412975E-06_JPRB, &
  & 0.28281832E-06_JPRB, 0.28123364E-06_JPRB, 0.27942110E-06_JPRB, 0.27738639E-06_JPRB, 0.27515821E-06_JPRB, 0.27271491E-06_JPRB, &
  & 0.27005655E-06_JPRB, 0.26718749E-06_JPRB, 0.26413966E-06_JPRB, 0.26095918E-06_JPRB, 0.25771297E-06_JPRB, 0.25448580E-06_JPRB, &
  & 0.25135407E-06_JPRB, 0.24838198E-06_JPRB, 0.24557971E-06_JPRB, 0.24293030E-06_JPRB, 0.24039852E-06_JPRB, 0.23795130E-06_JPRB, &
  & 0.23551574E-06_JPRB, 0.23307042E-06_JPRB, 0.22994757E-06_JPRB, 0.22474497E-06_JPRB /)

RGHG3(:,22, 1) = (/ &
  & 0.24667514E-06_JPRB, 0.24881501E-06_JPRB, 0.25037750E-06_JPRB, 0.25201805E-06_JPRB, 0.25388442E-06_JPRB, 0.25602935E-06_JPRB, &
  & 0.25844446E-06_JPRB, 0.26108816E-06_JPRB, 0.26388622E-06_JPRB, 0.26676693E-06_JPRB, 0.26968465E-06_JPRB, 0.27257173E-06_JPRB, &
  & 0.27539363E-06_JPRB, 0.27811467E-06_JPRB, 0.28070590E-06_JPRB, 0.28312783E-06_JPRB, 0.28533111E-06_JPRB, 0.28726686E-06_JPRB, &
  & 0.28888189E-06_JPRB, 0.29011923E-06_JPRB, 0.29092317E-06_JPRB, 0.29125425E-06_JPRB, 0.29111047E-06_JPRB, 0.29053425E-06_JPRB, &
  & 0.28962077E-06_JPRB, 0.28854060E-06_JPRB, 0.28746942E-06_JPRB, 0.28663578E-06_JPRB, 0.28618479E-06_JPRB, 0.28623276E-06_JPRB, &
  & 0.28673600E-06_JPRB, 0.28758055E-06_JPRB, 0.28862192E-06_JPRB, 0.28972974E-06_JPRB, 0.29078285E-06_JPRB, 0.29168572E-06_JPRB, &
  & 0.29234906E-06_JPRB, 0.29268608E-06_JPRB, 0.29265044E-06_JPRB, 0.29222653E-06_JPRB, 0.29144738E-06_JPRB, 0.29036335E-06_JPRB, &
  & 0.28902755E-06_JPRB, 0.28746894E-06_JPRB, 0.28571515E-06_JPRB, 0.28378565E-06_JPRB, 0.28170820E-06_JPRB, 0.27948877E-06_JPRB, &
  & 0.27712736E-06_JPRB, 0.27464446E-06_JPRB, 0.27206551E-06_JPRB, 0.26943241E-06_JPRB, 0.26679044E-06_JPRB, 0.26418130E-06_JPRB, &
  & 0.26165364E-06_JPRB, 0.25923504E-06_JPRB, 0.25693043E-06_JPRB, 0.25470806E-06_JPRB, 0.25254070E-06_JPRB, 0.25039239E-06_JPRB, &
  & 0.24823325E-06_JPRB, 0.24587143E-06_JPRB, 0.24321051E-06_JPRB, 0.23796106E-06_JPRB /)

RGHG3(:,23, 1) = (/ &
  & 0.25155228E-06_JPRB, 0.25377196E-06_JPRB, 0.25531881E-06_JPRB, 0.25692307E-06_JPRB, 0.25874857E-06_JPRB, 0.26083799E-06_JPRB, &
  & 0.26318577E-06_JPRB, 0.26574142E-06_JPRB, 0.26844589E-06_JPRB, 0.27123804E-06_JPRB, 0.27405221E-06_JPRB, 0.27684067E-06_JPRB, &
  & 0.27955571E-06_JPRB, 0.28216431E-06_JPRB, 0.28463899E-06_JPRB, 0.28695135E-06_JPRB, 0.28906331E-06_JPRB, 0.29092672E-06_JPRB, &
  & 0.29248801E-06_JPRB, 0.29369545E-06_JPRB, 0.29450638E-06_JPRB, 0.29489996E-06_JPRB, 0.29488325E-06_JPRB, 0.29450493E-06_JPRB, &
  & 0.29388272E-06_JPRB, 0.29315058E-06_JPRB, 0.29247929E-06_JPRB, 0.29203781E-06_JPRB, 0.29197042E-06_JPRB, 0.29230966E-06_JPRB, &
  & 0.29299525E-06_JPRB, 0.29390492E-06_JPRB, 0.29492185E-06_JPRB, 0.29591160E-06_JPRB, 0.29677494E-06_JPRB, 0.29743845E-06_JPRB, &
  & 0.29784675E-06_JPRB, 0.29793614E-06_JPRB, 0.29769831E-06_JPRB, 0.29713235E-06_JPRB, 0.29628103E-06_JPRB, 0.29518429E-06_JPRB, &
  & 0.29387664E-06_JPRB, 0.29238348E-06_JPRB, 0.29072416E-06_JPRB, 0.28892683E-06_JPRB, 0.28702453E-06_JPRB, 0.28503445E-06_JPRB, &
  & 0.28296509E-06_JPRB, 0.28084210E-06_JPRB, 0.27869055E-06_JPRB, 0.27653823E-06_JPRB, 0.27440572E-06_JPRB, 0.27231835E-06_JPRB, &
  & 0.27029080E-06_JPRB, 0.26833450E-06_JPRB, 0.26643420E-06_JPRB, 0.26457167E-06_JPRB, 0.26271485E-06_JPRB, 0.26083092E-06_JPRB, &
  & 0.25887465E-06_JPRB, 0.25680984E-06_JPRB, 0.25419300E-06_JPRB, 0.24949762E-06_JPRB /)

RGHG3(:,24, 1) = (/ &
  & 0.25616666E-06_JPRB, 0.25832242E-06_JPRB, 0.25981356E-06_JPRB, 0.26135118E-06_JPRB, 0.26308985E-06_JPRB, 0.26508337E-06_JPRB, &
  & 0.26732047E-06_JPRB, 0.26975795E-06_JPRB, 0.27233727E-06_JPRB, 0.27499752E-06_JPRB, 0.27768962E-06_JPRB, 0.28035228E-06_JPRB, &
  & 0.28295091E-06_JPRB, 0.28545361E-06_JPRB, 0.28783495E-06_JPRB, 0.29005923E-06_JPRB, 0.29209323E-06_JPRB, 0.29390205E-06_JPRB, &
  & 0.29544728E-06_JPRB, 0.29668990E-06_JPRB, 0.29759519E-06_JPRB, 0.29814149E-06_JPRB, 0.29833924E-06_JPRB, 0.29825475E-06_JPRB, &
  & 0.29796840E-06_JPRB, 0.29759630E-06_JPRB, 0.29727076E-06_JPRB, 0.29711688E-06_JPRB, 0.29723023E-06_JPRB, 0.29762697E-06_JPRB, &
  & 0.29826160E-06_JPRB, 0.29905331E-06_JPRB, 0.29988098E-06_JPRB, 0.30065323E-06_JPRB, 0.30128388E-06_JPRB, 0.30172157E-06_JPRB, &
  & 0.30191757E-06_JPRB, 0.30183304E-06_JPRB, 0.30147240E-06_JPRB, 0.30084675E-06_JPRB, 0.29998384E-06_JPRB, 0.29892237E-06_JPRB, &
  & 0.29768333E-06_JPRB, 0.29628509E-06_JPRB, 0.29474739E-06_JPRB, 0.29309973E-06_JPRB, 0.29138039E-06_JPRB, 0.28961620E-06_JPRB, &
  & 0.28782125E-06_JPRB, 0.28602153E-06_JPRB, 0.28423477E-06_JPRB, 0.28247820E-06_JPRB, 0.28076326E-06_JPRB, 0.27909292E-06_JPRB, &
  & 0.27746694E-06_JPRB, 0.27587419E-06_JPRB, 0.27430514E-06_JPRB, 0.27272765E-06_JPRB, 0.27111915E-06_JPRB, 0.26945057E-06_JPRB, &
  & 0.26769271E-06_JPRB, 0.26576282E-06_JPRB, 0.26343275E-06_JPRB, 0.25907244E-06_JPRB /)

RGHG3(:,25, 1) = (/ &
  & 0.26045817E-06_JPRB, 0.26253539E-06_JPRB, 0.26396191E-06_JPRB, 0.26541264E-06_JPRB, 0.26704870E-06_JPRB, 0.26891905E-06_JPRB, &
  & 0.27101996E-06_JPRB, 0.27330981E-06_JPRB, 0.27573242E-06_JPRB, 0.27823964E-06_JPRB, 0.28077656E-06_JPRB, 0.28329399E-06_JPRB, &
  & 0.28575184E-06_JPRB, 0.28812096E-06_JPRB, 0.29038270E-06_JPRB, 0.29251879E-06_JPRB, 0.29450217E-06_JPRB, 0.29630121E-06_JPRB, &
  & 0.29788015E-06_JPRB, 0.29919977E-06_JPRB, 0.30022980E-06_JPRB, 0.30096217E-06_JPRB, 0.30141629E-06_JPRB, 0.30163611E-06_JPRB, &
  & 0.30167669E-06_JPRB, 0.30163014E-06_JPRB, 0.30157383E-06_JPRB, 0.30159316E-06_JPRB, 0.30176821E-06_JPRB, 0.30210501E-06_JPRB, &
  & 0.30259332E-06_JPRB, 0.30316491E-06_JPRB, 0.30375364E-06_JPRB, 0.30428328E-06_JPRB, 0.30468846E-06_JPRB, 0.30492885E-06_JPRB, &
  & 0.30495784E-06_JPRB, 0.30475638E-06_JPRB, 0.30432744E-06_JPRB, 0.30368818E-06_JPRB, 0.30285915E-06_JPRB, 0.30186419E-06_JPRB, &
  & 0.30072098E-06_JPRB, 0.29943791E-06_JPRB, 0.29803476E-06_JPRB, 0.29654316E-06_JPRB, 0.29500393E-06_JPRB, 0.29344488E-06_JPRB, &
  & 0.29189019E-06_JPRB, 0.29035954E-06_JPRB, 0.28887035E-06_JPRB, 0.28743031E-06_JPRB, 0.28604137E-06_JPRB, 0.28469486E-06_JPRB, &
  & 0.28337706E-06_JPRB, 0.28207691E-06_JPRB, 0.28076653E-06_JPRB, 0.27942653E-06_JPRB, 0.27802454E-06_JPRB, 0.27653573E-06_JPRB, &
  & 0.27494548E-06_JPRB, 0.27318688E-06_JPRB, 0.27108430E-06_JPRB, 0.26700582E-06_JPRB /)

RGHG3(:,26, 1) = (/ &
  & 0.26452270E-06_JPRB, 0.26649610E-06_JPRB, 0.26784355E-06_JPRB, 0.26920270E-06_JPRB, 0.27072588E-06_JPRB, 0.27246443E-06_JPRB, &
  & 0.27441382E-06_JPRB, 0.27653664E-06_JPRB, 0.27878542E-06_JPRB, 0.28111515E-06_JPRB, 0.28348248E-06_JPRB, 0.28584276E-06_JPRB, &
  & 0.28816049E-06_JPRB, 0.29041490E-06_JPRB, 0.29257993E-06_JPRB, 0.29463473E-06_JPRB, 0.29655820E-06_JPRB, 0.29832384E-06_JPRB, &
  & 0.29990372E-06_JPRB, 0.30127339E-06_JPRB, 0.30241577E-06_JPRB, 0.30332342E-06_JPRB, 0.30400565E-06_JPRB, 0.30448913E-06_JPRB, &
  & 0.30480837E-06_JPRB, 0.30501531E-06_JPRB, 0.30516358E-06_JPRB, 0.30531112E-06_JPRB, 0.30549208E-06_JPRB, 0.30574071E-06_JPRB, &
  & 0.30605543E-06_JPRB, 0.30641056E-06_JPRB, 0.30677251E-06_JPRB, 0.30707963E-06_JPRB, 0.30729223E-06_JPRB, 0.30736996E-06_JPRB, &
  & 0.30727549E-06_JPRB, 0.30699985E-06_JPRB, 0.30654445E-06_JPRB, 0.30592440E-06_JPRB, 0.30515363E-06_JPRB, 0.30424334E-06_JPRB, &
  & 0.30320524E-06_JPRB, 0.30204501E-06_JPRB, 0.30077896E-06_JPRB, 0.29943664E-06_JPRB, 0.29805980E-06_JPRB, 0.29667547E-06_JPRB, &
  & 0.29532183E-06_JPRB, 0.29400891E-06_JPRB, 0.29275455E-06_JPRB, 0.29155765E-06_JPRB, 0.29041297E-06_JPRB, 0.28931049E-06_JPRB, &
  & 0.28823212E-06_JPRB, 0.28715792E-06_JPRB, 0.28606777E-06_JPRB, 0.28492533E-06_JPRB, 0.28370891E-06_JPRB, 0.28239185E-06_JPRB, &
  & 0.28094834E-06_JPRB, 0.27938083E-06_JPRB, 0.27736436E-06_JPRB, 0.27373102E-06_JPRB /)

RGHG3(:,27, 1) = (/ &
  & 0.26839442E-06_JPRB, 0.27028011E-06_JPRB, 0.27153584E-06_JPRB, 0.27279839E-06_JPRB, 0.27420452E-06_JPRB, 0.27580481E-06_JPRB, &
  & 0.27759310E-06_JPRB, 0.27953732E-06_JPRB, 0.28159252E-06_JPRB, 0.28372619E-06_JPRB, 0.28590063E-06_JPRB, 0.28808000E-06_JPRB, &
  & 0.29023346E-06_JPRB, 0.29233561E-06_JPRB, 0.29437589E-06_JPRB, 0.29633486E-06_JPRB, 0.29819134E-06_JPRB, 0.29992387E-06_JPRB, &
  & 0.30151151E-06_JPRB, 0.30293188E-06_JPRB, 0.30416783E-06_JPRB, 0.30521048E-06_JPRB, 0.30606611E-06_JPRB, 0.30674789E-06_JPRB, &
  & 0.30727679E-06_JPRB, 0.30767461E-06_JPRB, 0.30797133E-06_JPRB, 0.30819845E-06_JPRB, 0.30838635E-06_JPRB, 0.30856799E-06_JPRB, &
  & 0.30875540E-06_JPRB, 0.30894230E-06_JPRB, 0.30912372E-06_JPRB, 0.30925457E-06_JPRB, 0.30931483E-06_JPRB, 0.30926921E-06_JPRB, &
  & 0.30909030E-06_JPRB, 0.30877473E-06_JPRB, 0.30832152E-06_JPRB, 0.30774004E-06_JPRB, 0.30703870E-06_JPRB, 0.30622203E-06_JPRB, &
  & 0.30529290E-06_JPRB, 0.30425420E-06_JPRB, 0.30311810E-06_JPRB, 0.30190898E-06_JPRB, 0.30066582E-06_JPRB, 0.29943294E-06_JPRB, &
  & 0.29823784E-06_JPRB, 0.29709855E-06_JPRB, 0.29602180E-06_JPRB, 0.29500694E-06_JPRB, 0.29404572E-06_JPRB, 0.29312577E-06_JPRB, &
  & 0.29222838E-06_JPRB, 0.29133636E-06_JPRB, 0.29041911E-06_JPRB, 0.28945323E-06_JPRB, 0.28840387E-06_JPRB, 0.28724870E-06_JPRB, &
  & 0.28598447E-06_JPRB, 0.28453925E-06_JPRB, 0.28284194E-06_JPRB, 0.27943707E-06_JPRB /)

RGHG3(:,28, 1) = (/ &
  & 0.27213827E-06_JPRB, 0.27392264E-06_JPRB, 0.27509705E-06_JPRB, 0.27625521E-06_JPRB, 0.27754277E-06_JPRB, 0.27899995E-06_JPRB, &
  & 0.28062470E-06_JPRB, 0.28238097E-06_JPRB, 0.28423446E-06_JPRB, 0.28616356E-06_JPRB, 0.28813449E-06_JPRB, 0.29012926E-06_JPRB, &
  & 0.29211580E-06_JPRB, 0.29407644E-06_JPRB, 0.29599190E-06_JPRB, 0.29784530E-06_JPRB, 0.29962030E-06_JPRB, 0.30129971E-06_JPRB, &
  & 0.30286341E-06_JPRB, 0.30429123E-06_JPRB, 0.30556890E-06_JPRB, 0.30668900E-06_JPRB, 0.30765455E-06_JPRB, 0.30847016E-06_JPRB, &
  & 0.30914271E-06_JPRB, 0.30967485E-06_JPRB, 0.31008076E-06_JPRB, 0.31037476E-06_JPRB, 0.31058107E-06_JPRB, 0.31072693E-06_JPRB, &
  & 0.31083371E-06_JPRB, 0.31090860E-06_JPRB, 0.31096164E-06_JPRB, 0.31096681E-06_JPRB, 0.31091594E-06_JPRB, 0.31078437E-06_JPRB, &
  & 0.31055356E-06_JPRB, 0.31022168E-06_JPRB, 0.30978802E-06_JPRB, 0.30925719E-06_JPRB, 0.30863049E-06_JPRB, 0.30790784E-06_JPRB, &
  & 0.30708429E-06_JPRB, 0.30615965E-06_JPRB, 0.30513888E-06_JPRB, 0.30404576E-06_JPRB, 0.30292335E-06_JPRB, 0.30180962E-06_JPRB, &
  & 0.30074148E-06_JPRB, 0.29973330E-06_JPRB, 0.29879163E-06_JPRB, 0.29791494E-06_JPRB, 0.29708951E-06_JPRB, 0.29630633E-06_JPRB, &
  & 0.29554607E-06_JPRB, 0.29479031E-06_JPRB, 0.29401653E-06_JPRB, 0.29319267E-06_JPRB, 0.29229616E-06_JPRB, 0.29130240E-06_JPRB, &
  & 0.29019864E-06_JPRB, 0.28898737E-06_JPRB, 0.28742684E-06_JPRB, 0.28448869E-06_JPRB /)

RGHG3(:,29, 1) = (/ &
  & 0.27578415E-06_JPRB, 0.27747120E-06_JPRB, 0.27854651E-06_JPRB, 0.27960695E-06_JPRB, 0.28076786E-06_JPRB, 0.28208251E-06_JPRB, &
  & 0.28353770E-06_JPRB, 0.28510647E-06_JPRB, 0.28675581E-06_JPRB, 0.28847239E-06_JPRB, 0.29023983E-06_JPRB, 0.29204236E-06_JPRB, &
  & 0.29385805E-06_JPRB, 0.29566635E-06_JPRB, 0.29745240E-06_JPRB, 0.29919960E-06_JPRB, 0.30089060E-06_JPRB, 0.30250516E-06_JPRB, &
  & 0.30402342E-06_JPRB, 0.30542850E-06_JPRB, 0.30670935E-06_JPRB, 0.30786100E-06_JPRB, 0.30888489E-06_JPRB, 0.30977938E-06_JPRB, &
  & 0.31054066E-06_JPRB, 0.31116139E-06_JPRB, 0.31164171E-06_JPRB, 0.31199079E-06_JPRB, 0.31222189E-06_JPRB, 0.31235965E-06_JPRB, &
  & 0.31242737E-06_JPRB, 0.31243908E-06_JPRB, 0.31241049E-06_JPRB, 0.31233424E-06_JPRB, 0.31220833E-06_JPRB, 0.31202302E-06_JPRB, &
  & 0.31176518E-06_JPRB, 0.31143540E-06_JPRB, 0.31103244E-06_JPRB, 0.31055777E-06_JPRB, 0.31000590E-06_JPRB, 0.30937068E-06_JPRB, &
  & 0.30864402E-06_JPRB, 0.30781993E-06_JPRB, 0.30690282E-06_JPRB, 0.30591383E-06_JPRB, 0.30488937E-06_JPRB, 0.30387801E-06_JPRB, &
  & 0.30290732E-06_JPRB, 0.30200309E-06_JPRB, 0.30116581E-06_JPRB, 0.30039098E-06_JPRB, 0.29966876E-06_JPRB, 0.29898439E-06_JPRB, &
  & 0.29832506E-06_JPRB, 0.29767227E-06_JPRB, 0.29700303E-06_JPRB, 0.29629453E-06_JPRB, 0.29551998E-06_JPRB, 0.29466679E-06_JPRB, &
  & 0.29372987E-06_JPRB, 0.29268273E-06_JPRB, 0.29139989E-06_JPRB, 0.28889650E-06_JPRB /)

RGHG3(:,30, 1) = (/ &
  & 0.27934931E-06_JPRB, 0.28091154E-06_JPRB, 0.28190007E-06_JPRB, 0.28284651E-06_JPRB, 0.28388709E-06_JPRB, 0.28505218E-06_JPRB, &
  & 0.28634418E-06_JPRB, 0.28772655E-06_JPRB, 0.28917933E-06_JPRB, 0.29068818E-06_JPRB, 0.29225589E-06_JPRB, 0.29386902E-06_JPRB, &
  & 0.29551234E-06_JPRB, 0.29717245E-06_JPRB, 0.29883165E-06_JPRB, 0.30047028E-06_JPRB, 0.30206877E-06_JPRB, 0.30360718E-06_JPRB, &
  & 0.30506550E-06_JPRB, 0.30642872E-06_JPRB, 0.30768859E-06_JPRB, 0.30884155E-06_JPRB, 0.30988460E-06_JPRB, 0.31081473E-06_JPRB, &
  & 0.31162153E-06_JPRB, 0.31228879E-06_JPRB, 0.31281755E-06_JPRB, 0.31320408E-06_JPRB, 0.31345959E-06_JPRB, 0.31360361E-06_JPRB, &
  & 0.31365880E-06_JPRB, 0.31364149E-06_JPRB, 0.31356745E-06_JPRB, 0.31344473E-06_JPRB, 0.31327508E-06_JPRB, 0.31306035E-06_JPRB, &
  & 0.31279487E-06_JPRB, 0.31248015E-06_JPRB, 0.31211525E-06_JPRB, 0.31169623E-06_JPRB, 0.31121331E-06_JPRB, 0.31065551E-06_JPRB, &
  & 0.31001241E-06_JPRB, 0.30927578E-06_JPRB, 0.30844799E-06_JPRB, 0.30754856E-06_JPRB, 0.30661337E-06_JPRB, 0.30568233E-06_JPRB, &
  & 0.30479762E-06_JPRB, 0.30397388E-06_JPRB, 0.30321740E-06_JPRB, 0.30252099E-06_JPRB, 0.30187175E-06_JPRB, 0.30126114E-06_JPRB, &
  & 0.30067304E-06_JPRB, 0.30009306E-06_JPRB, 0.29950169E-06_JPRB, 0.29887622E-06_JPRB, 0.29820134E-06_JPRB, 0.29746354E-06_JPRB, &
  & 0.29667032E-06_JPRB, 0.29580266E-06_JPRB, 0.29475061E-06_JPRB, 0.29266724E-06_JPRB /)

RGHG3(:,31, 1) = (/ &
  & 0.28281360E-06_JPRB, 0.28424219E-06_JPRB, 0.28512480E-06_JPRB, 0.28596878E-06_JPRB, 0.28687958E-06_JPRB, 0.28790637E-06_JPRB, &
  & 0.28903696E-06_JPRB, 0.29024844E-06_JPRB, 0.29151531E-06_JPRB, 0.29283174E-06_JPRB, 0.29420855E-06_JPRB, 0.29563944E-06_JPRB, &
  & 0.29711677E-06_JPRB, 0.29862889E-06_JPRB, 0.30016250E-06_JPRB, 0.30169545E-06_JPRB, 0.30320547E-06_JPRB, 0.30466828E-06_JPRB, &
  & 0.30606421E-06_JPRB, 0.30737874E-06_JPRB, 0.30860218E-06_JPRB, 0.30973283E-06_JPRB, 0.31076678E-06_JPRB, 0.31169643E-06_JPRB, &
  & 0.31250889E-06_JPRB, 0.31319141E-06_JPRB, 0.31373773E-06_JPRB, 0.31414277E-06_JPRB, 0.31441556E-06_JPRB, 0.31456889E-06_JPRB, &
  & 0.31462540E-06_JPRB, 0.31460027E-06_JPRB, 0.31450662E-06_JPRB, 0.31436406E-06_JPRB, 0.31417537E-06_JPRB, 0.31395234E-06_JPRB, &
  & 0.31369385E-06_JPRB, 0.31340301E-06_JPRB, 0.31307644E-06_JPRB, 0.31270784E-06_JPRB, 0.31228410E-06_JPRB, 0.31179169E-06_JPRB, &
  & 0.31121735E-06_JPRB, 0.31055276E-06_JPRB, 0.30980178E-06_JPRB, 0.30898019E-06_JPRB, 0.30812114E-06_JPRB, 0.30726869E-06_JPRB, &
  & 0.30645188E-06_JPRB, 0.30569717E-06_JPRB, 0.30500343E-06_JPRB, 0.30436388E-06_JPRB, 0.30377080E-06_JPRB, 0.30321061E-06_JPRB, &
  & 0.30267424E-06_JPRB, 0.30214522E-06_JPRB, 0.30160868E-06_JPRB, 0.30104675E-06_JPRB, 0.30044501E-06_JPRB, 0.29980293E-06_JPRB, &
  & 0.29912263E-06_JPRB, 0.29840362E-06_JPRB, 0.29751368E-06_JPRB, 0.29585587E-06_JPRB /)

RGHG3(:,32, 1) = (/ &
  & 0.28613206E-06_JPRB, 0.28741962E-06_JPRB, 0.28820202E-06_JPRB, 0.28893749E-06_JPRB, 0.28973398E-06_JPRB, 0.29062528E-06_JPRB, &
  & 0.29161285E-06_JPRB, 0.29266579E-06_JPRB, 0.29376633E-06_JPRB, 0.29490815E-06_JPRB, 0.29610888E-06_JPRB, 0.29736697E-06_JPRB, &
  & 0.29868761E-06_JPRB, 0.30006598E-06_JPRB, 0.30148539E-06_JPRB, 0.30292227E-06_JPRB, 0.30435001E-06_JPRB, 0.30574225E-06_JPRB, &
  & 0.30707491E-06_JPRB, 0.30833556E-06_JPRB, 0.30951486E-06_JPRB, 0.31060796E-06_JPRB, 0.31160738E-06_JPRB, 0.31250863E-06_JPRB, &
  & 0.31329489E-06_JPRB, 0.31395879E-06_JPRB, 0.31449505E-06_JPRB, 0.31489836E-06_JPRB, 0.31517661E-06_JPRB, 0.31533648E-06_JPRB, &
  & 0.31540000E-06_JPRB, 0.31537792E-06_JPRB, 0.31528401E-06_JPRB, 0.31514080E-06_JPRB, 0.31495279E-06_JPRB, 0.31473729E-06_JPRB, &
  & 0.31449747E-06_JPRB, 0.31423406E-06_JPRB, 0.31394455E-06_JPRB, 0.31361884E-06_JPRB, 0.31324316E-06_JPRB, 0.31280172E-06_JPRB, &
  & 0.31228154E-06_JPRB, 0.31167465E-06_JPRB, 0.31098432E-06_JPRB, 0.31023015E-06_JPRB, 0.30944196E-06_JPRB, 0.30865408E-06_JPRB, &
  & 0.30790437E-06_JPRB, 0.30720577E-06_JPRB, 0.30656298E-06_JPRB, 0.30596965E-06_JPRB, 0.30541651E-06_JPRB, 0.30489579E-06_JPRB, &
  & 0.30439435E-06_JPRB, 0.30390291E-06_JPRB, 0.30340658E-06_JPRB, 0.30289087E-06_JPRB, 0.30234804E-06_JPRB, 0.30177674E-06_JPRB, &
  & 0.30118900E-06_JPRB, 0.30056523E-06_JPRB, 0.29984827E-06_JPRB, 0.29844628E-06_JPRB /)

RGHG3(:,33, 1) = (/ &
  & 0.28927238E-06_JPRB, 0.29040973E-06_JPRB, 0.29109586E-06_JPRB, 0.29173628E-06_JPRB, 0.29242429E-06_JPRB, 0.29320086E-06_JPRB, &
  & 0.29405925E-06_JPRB, 0.29497531E-06_JPRB, 0.29592721E-06_JPRB, 0.29691546E-06_JPRB, 0.29795402E-06_JPRB, 0.29905297E-06_JPRB, &
  & 0.30022366E-06_JPRB, 0.30146978E-06_JPRB, 0.30278360E-06_JPRB, 0.30413838E-06_JPRB, 0.30549981E-06_JPRB, 0.30683503E-06_JPRB, &
  & 0.30811736E-06_JPRB, 0.30932776E-06_JPRB, 0.31045738E-06_JPRB, 0.31149972E-06_JPRB, 0.31245096E-06_JPRB, 0.31329560E-06_JPRB, &
  & 0.31403044E-06_JPRB, 0.31464717E-06_JPRB, 0.31514699E-06_JPRB, 0.31553009E-06_JPRB, 0.31579972E-06_JPRB, 0.31595957E-06_JPRB, &
  & 0.31603079E-06_JPRB, 0.31601763E-06_JPRB, 0.31593748E-06_JPRB, 0.31580714E-06_JPRB, 0.31563465E-06_JPRB, 0.31543843E-06_JPRB, &
  & 0.31522248E-06_JPRB, 0.31498885E-06_JPRB, 0.31473394E-06_JPRB, 0.31444620E-06_JPRB, 0.31410906E-06_JPRB, 0.31370598E-06_JPRB, &
  & 0.31322514E-06_JPRB, 0.31265989E-06_JPRB, 0.31201935E-06_JPRB, 0.31132046E-06_JPRB, 0.31059110E-06_JPRB, 0.30986772E-06_JPRB, &
  & 0.30917357E-06_JPRB, 0.30852715E-06_JPRB, 0.30792802E-06_JPRB, 0.30737201E-06_JPRB, 0.30685277E-06_JPRB, 0.30635971E-06_JPRB, &
  & 0.30588680E-06_JPRB, 0.30542262E-06_JPRB, 0.30495698E-06_JPRB, 0.30447711E-06_JPRB, 0.30397848E-06_JPRB, 0.30346314E-06_JPRB, &
  & 0.30293572E-06_JPRB, 0.30239812E-06_JPRB, 0.30174630E-06_JPRB, 0.30057953E-06_JPRB /)

RGHG3(:,34, 1) = (/ &
  & 0.29218876E-06_JPRB, 0.29319671E-06_JPRB, 0.29379257E-06_JPRB, 0.29434707E-06_JPRB, 0.29494609E-06_JPRB, 0.29562005E-06_JPRB, &
  & 0.29636922E-06_JPRB, 0.29716622E-06_JPRB, 0.29799014E-06_JPRB, 0.29884274E-06_JPRB, 0.29973651E-06_JPRB, 0.30069026E-06_JPRB, &
  & 0.30172575E-06_JPRB, 0.30285446E-06_JPRB, 0.30407105E-06_JPRB, 0.30535148E-06_JPRB, 0.30665544E-06_JPRB, 0.30794442E-06_JPRB, &
  & 0.30918514E-06_JPRB, 0.31034890E-06_JPRB, 0.31142866E-06_JPRB, 0.31241962E-06_JPRB, 0.31330373E-06_JPRB, 0.31407833E-06_JPRB, &
  & 0.31473581E-06_JPRB, 0.31528350E-06_JPRB, 0.31572674E-06_JPRB, 0.31606950E-06_JPRB, 0.31631572E-06_JPRB, 0.31646817E-06_JPRB, &
  & 0.31654292E-06_JPRB, 0.31654241E-06_JPRB, 0.31648440E-06_JPRB, 0.31637654E-06_JPRB, 0.31623142E-06_JPRB, 0.31606393E-06_JPRB, &
  & 0.31587786E-06_JPRB, 0.31567674E-06_JPRB, 0.31545520E-06_JPRB, 0.31519969E-06_JPRB, 0.31489338E-06_JPRB, 0.31451890E-06_JPRB, &
  & 0.31406461E-06_JPRB, 0.31353034E-06_JPRB, 0.31292495E-06_JPRB, 0.31227165E-06_JPRB, 0.31159718E-06_JPRB, 0.31092577E-06_JPRB, &
  & 0.31028515E-06_JPRB, 0.30968198E-06_JPRB, 0.30912088E-06_JPRB, 0.30859761E-06_JPRB, 0.30810361E-06_JPRB, 0.30763533E-06_JPRB, &
  & 0.30718363E-06_JPRB, 0.30674238E-06_JPRB, 0.30629917E-06_JPRB, 0.30584823E-06_JPRB, 0.30538382E-06_JPRB, 0.30490827E-06_JPRB, &
  & 0.30442882E-06_JPRB, 0.30392826E-06_JPRB, 0.30336554E-06_JPRB, 0.30230626E-06_JPRB /)

RGHG3(:,35, 1) = (/ &
  & 0.29489078E-06_JPRB, 0.29576935E-06_JPRB, 0.29628876E-06_JPRB, 0.29677085E-06_JPRB, 0.29728992E-06_JPRB, 0.29788103E-06_JPRB, &
  & 0.29853581E-06_JPRB, 0.29923149E-06_JPRB, 0.29994476E-06_JPRB, 0.30067866E-06_JPRB, 0.30144344E-06_JPRB, 0.30226477E-06_JPRB, &
  & 0.30317307E-06_JPRB, 0.30419110E-06_JPRB, 0.30532033E-06_JPRB, 0.30653661E-06_JPRB, 0.30779410E-06_JPRB, 0.30904749E-06_JPRB, &
  & 0.31025368E-06_JPRB, 0.31137904E-06_JPRB, 0.31241453E-06_JPRB, 0.31334278E-06_JPRB, 0.31415357E-06_JPRB, 0.31483947E-06_JPRB, &
  & 0.31540711E-06_JPRB, 0.31586742E-06_JPRB, 0.31623463E-06_JPRB, 0.31652203E-06_JPRB, 0.31672852E-06_JPRB, 0.31686463E-06_JPRB, &
  & 0.31693520E-06_JPRB, 0.31694810E-06_JPRB, 0.31691209E-06_JPRB, 0.31683328E-06_JPRB, 0.31672283E-06_JPRB, 0.31658928E-06_JPRB, &
  & 0.31643896E-06_JPRB, 0.31627371E-06_JPRB, 0.31608627E-06_JPRB, 0.31586271E-06_JPRB, 0.31558579E-06_JPRB, 0.31523700E-06_JPRB, &
  & 0.31480650E-06_JPRB, 0.31429417E-06_JPRB, 0.31371928E-06_JPRB, 0.31310518E-06_JPRB, 0.31247299E-06_JPRB, 0.31185243E-06_JPRB, &
  & 0.31125293E-06_JPRB, 0.31068916E-06_JPRB, 0.31015992E-06_JPRB, 0.30966106E-06_JPRB, 0.30918974E-06_JPRB, 0.30873997E-06_JPRB, &
  & 0.30830753E-06_JPRB, 0.30788271E-06_JPRB, 0.30746062E-06_JPRB, 0.30703140E-06_JPRB, 0.30659476E-06_JPRB, 0.30615053E-06_JPRB, &
  & 0.30570123E-06_JPRB, 0.30524609E-06_JPRB, 0.30470679E-06_JPRB, 0.30375799E-06_JPRB /)

RGHG3(:,36, 1) = (/ &
  & 0.29737853E-06_JPRB, 0.29814453E-06_JPRB, 0.29859314E-06_JPRB, 0.29901017E-06_JPRB, 0.29946602E-06_JPRB, 0.29998290E-06_JPRB, &
  & 0.30055941E-06_JPRB, 0.30116738E-06_JPRB, 0.30178666E-06_JPRB, 0.30241446E-06_JPRB, 0.30306529E-06_JPRB, 0.30376583E-06_JPRB, &
  & 0.30455431E-06_JPRB, 0.30546443E-06_JPRB, 0.30650835E-06_JPRB, 0.30766202E-06_JPRB, 0.30888083E-06_JPRB, 0.31010848E-06_JPRB, &
  & 0.31129133E-06_JPRB, 0.31239023E-06_JPRB, 0.31337979E-06_JPRB, 0.31424170E-06_JPRB, 0.31496367E-06_JPRB, 0.31554706E-06_JPRB, &
  & 0.31600689E-06_JPRB, 0.31636739E-06_JPRB, 0.31664950E-06_JPRB, 0.31686858E-06_JPRB, 0.31703021E-06_JPRB, 0.31714109E-06_JPRB, &
  & 0.31720290E-06_JPRB, 0.31722337E-06_JPRB, 0.31720398E-06_JPRB, 0.31715217E-06_JPRB, 0.31707270E-06_JPRB, 0.31697286E-06_JPRB, &
  & 0.31685758E-06_JPRB, 0.31672687E-06_JPRB, 0.31657456E-06_JPRB, 0.31638811E-06_JPRB, 0.31614806E-06_JPRB, 0.31583522E-06_JPRB, &
  & 0.31543635E-06_JPRB, 0.31495495E-06_JPRB, 0.31441041E-06_JPRB, 0.31382871E-06_JPRB, 0.31323967E-06_JPRB, 0.31265597E-06_JPRB, &
  & 0.31209640E-06_JPRB, 0.31156279E-06_JPRB, 0.31105719E-06_JPRB, 0.31057937E-06_JPRB, 0.31012502E-06_JPRB, 0.30969250E-06_JPRB, &
  & 0.30927504E-06_JPRB, 0.30886787E-06_JPRB, 0.30846178E-06_JPRB, 0.30805350E-06_JPRB, 0.30763803E-06_JPRB, 0.30721796E-06_JPRB, &
  & 0.30679695E-06_JPRB, 0.30636235E-06_JPRB, 0.30587262E-06_JPRB, 0.30498484E-06_JPRB /)

RGHG3(:,37, 1) = (/ &
  & 0.29967822E-06_JPRB, 0.30033158E-06_JPRB, 0.30071706E-06_JPRB, 0.30107987E-06_JPRB, 0.30147820E-06_JPRB, 0.30193647E-06_JPRB, &
  & 0.30244487E-06_JPRB, 0.30297863E-06_JPRB, 0.30351515E-06_JPRB, 0.30405025E-06_JPRB, 0.30459907E-06_JPRB, 0.30518774E-06_JPRB, &
  & 0.30586483E-06_JPRB, 0.30666763E-06_JPRB, 0.30762789E-06_JPRB, 0.30872536E-06_JPRB, 0.30990671E-06_JPRB, 0.31111111E-06_JPRB, &
  & 0.31227520E-06_JPRB, 0.31334514E-06_JPRB, 0.31428010E-06_JPRB, 0.31505846E-06_JPRB, 0.31566924E-06_JPRB, 0.31613459E-06_JPRB, &
  & 0.31648173E-06_JPRB, 0.31674460E-06_JPRB, 0.31694657E-06_JPRB, 0.31710647E-06_JPRB, 0.31722709E-06_JPRB, 0.31731460E-06_JPRB, &
  & 0.31736806E-06_JPRB, 0.31738998E-06_JPRB, 0.31738199E-06_JPRB, 0.31734743E-06_JPRB, 0.31729024E-06_JPRB, 0.31721612E-06_JPRB, &
  & 0.31712779E-06_JPRB, 0.31702564E-06_JPRB, 0.31690462E-06_JPRB, 0.31675359E-06_JPRB, 0.31655532E-06_JPRB, 0.31628952E-06_JPRB, &
  & 0.31593956E-06_JPRB, 0.31550246E-06_JPRB, 0.31499613E-06_JPRB, 0.31445350E-06_JPRB, 0.31389931E-06_JPRB, 0.31335446E-06_JPRB, &
  & 0.31282434E-06_JPRB, 0.31231593E-06_JPRB, 0.31183092E-06_JPRB, 0.31136838E-06_JPRB, 0.31092904E-06_JPRB, 0.31051036E-06_JPRB, &
  & 0.31010978E-06_JPRB, 0.30971987E-06_JPRB, 0.30933384E-06_JPRB, 0.30894319E-06_JPRB, 0.30854733E-06_JPRB, 0.30814681E-06_JPRB, &
  & 0.30774584E-06_JPRB, 0.30734108E-06_JPRB, 0.30687718E-06_JPRB, 0.30606191E-06_JPRB /)

RGHG3(:,38, 1) = (/ &
  & 0.30178839E-06_JPRB, 0.30234082E-06_JPRB, 0.30266872E-06_JPRB, 0.30298395E-06_JPRB, 0.30333575E-06_JPRB, 0.30374386E-06_JPRB, &
  & 0.30419545E-06_JPRB, 0.30466458E-06_JPRB, 0.30512828E-06_JPRB, 0.30558249E-06_JPRB, 0.30603741E-06_JPRB, 0.30653075E-06_JPRB, &
  & 0.30709668E-06_JPRB, 0.30779862E-06_JPRB, 0.30866542E-06_JPRB, 0.30970270E-06_JPRB, 0.31085008E-06_JPRB, 0.31203106E-06_JPRB, &
  & 0.31316907E-06_JPRB, 0.31419370E-06_JPRB, 0.31504953E-06_JPRB, 0.31571361E-06_JPRB, 0.31620431E-06_JPRB, 0.31655495E-06_JPRB, &
  & 0.31680656E-06_JPRB, 0.31699523E-06_JPRB, 0.31714001E-06_JPRB, 0.31725742E-06_JPRB, 0.31735078E-06_JPRB, 0.31742107E-06_JPRB, &
  & 0.31746822E-06_JPRB, 0.31748991E-06_JPRB, 0.31748814E-06_JPRB, 0.31746370E-06_JPRB, 0.31742087E-06_JPRB, 0.31736317E-06_JPRB, &
  & 0.31729348E-06_JPRB, 0.31721191E-06_JPRB, 0.31711431E-06_JPRB, 0.31699179E-06_JPRB, 0.31682924E-06_JPRB, 0.31660801E-06_JPRB, &
  & 0.31631055E-06_JPRB, 0.31592774E-06_JPRB, 0.31547384E-06_JPRB, 0.31497444E-06_JPRB, 0.31446109E-06_JPRB, 0.31394816E-06_JPRB, &
  & 0.31344666E-06_JPRB, 0.31296054E-06_JPRB, 0.31249127E-06_JPRB, 0.31204308E-06_JPRB, 0.31161724E-06_JPRB, 0.31121607E-06_JPRB, &
  & 0.31083579E-06_JPRB, 0.31046790E-06_JPRB, 0.31010379E-06_JPRB, 0.30973428E-06_JPRB, 0.30935581E-06_JPRB, 0.30897093E-06_JPRB, &
  & 0.30858811E-06_JPRB, 0.30820320E-06_JPRB, 0.30777392E-06_JPRB, 0.30702139E-06_JPRB /)

RGHG3(:,39, 1) = (/ &
  & 0.30370924E-06_JPRB, 0.30416714E-06_JPRB, 0.30444687E-06_JPRB, 0.30472069E-06_JPRB, 0.30503637E-06_JPRB, 0.30540207E-06_JPRB, &
  & 0.30580588E-06_JPRB, 0.30621752E-06_JPRB, 0.30661761E-06_JPRB, 0.30699803E-06_JPRB, 0.30737911E-06_JPRB, 0.30777989E-06_JPRB, &
  & 0.30825734E-06_JPRB, 0.30885218E-06_JPRB, 0.30963071E-06_JPRB, 0.31059534E-06_JPRB, 0.31170057E-06_JPRB, 0.31285123E-06_JPRB, &
  & 0.31394379E-06_JPRB, 0.31489037E-06_JPRB, 0.31563633E-06_JPRB, 0.31618251E-06_JPRB, 0.31656234E-06_JPRB, 0.31682691E-06_JPRB, &
  & 0.31701387E-06_JPRB, 0.31715410E-06_JPRB, 0.31726401E-06_JPRB, 0.31735539E-06_JPRB, 0.31743119E-06_JPRB, 0.31749087E-06_JPRB, &
  & 0.31753314E-06_JPRB, 0.31755457E-06_JPRB, 0.31755590E-06_JPRB, 0.31753768E-06_JPRB, 0.31750349E-06_JPRB, 0.31745657E-06_JPRB, &
  & 0.31739947E-06_JPRB, 0.31733208E-06_JPRB, 0.31725114E-06_JPRB, 0.31714907E-06_JPRB, 0.31701381E-06_JPRB, 0.31682899E-06_JPRB, &
  & 0.31657740E-06_JPRB, 0.31624944E-06_JPRB, 0.31584850E-06_JPRB, 0.31539992E-06_JPRB, 0.31492576E-06_JPRB, 0.31444765E-06_JPRB, &
  & 0.31397374E-06_JPRB, 0.31350703E-06_JPRB, 0.31305422E-06_JPRB, 0.31261968E-06_JPRB, 0.31221009E-06_JPRB, 0.31182915E-06_JPRB, &
  & 0.31147209E-06_JPRB, 0.31113251E-06_JPRB, 0.31079534E-06_JPRB, 0.31045047E-06_JPRB, 0.31009051E-06_JPRB, 0.30972095E-06_JPRB, &
  & 0.30935300E-06_JPRB, 0.30898966E-06_JPRB, 0.30858905E-06_JPRB, 0.30789732E-06_JPRB /)

RGHG3(:,40, 1) = (/ &
  & 0.30542532E-06_JPRB, 0.30580756E-06_JPRB, 0.30604573E-06_JPRB, 0.30628851E-06_JPRB, 0.30657134E-06_JPRB, 0.30690555E-06_JPRB, &
  & 0.30726585E-06_JPRB, 0.30762737E-06_JPRB, 0.30796932E-06_JPRB, 0.30829278E-06_JPRB, 0.30860357E-06_JPRB, 0.30894117E-06_JPRB, &
  & 0.30932898E-06_JPRB, 0.30984069E-06_JPRB, 0.31052187E-06_JPRB, 0.31141559E-06_JPRB, 0.31246469E-06_JPRB, 0.31356052E-06_JPRB, &
  & 0.31458219E-06_JPRB, 0.31542567E-06_JPRB, 0.31605629E-06_JPRB, 0.31649671E-06_JPRB, 0.31679571E-06_JPRB, 0.31700148E-06_JPRB, &
  & 0.31714819E-06_JPRB, 0.31725898E-06_JPRB, 0.31734811E-06_JPRB, 0.31742366E-06_JPRB, 0.31748834E-06_JPRB, 0.31754104E-06_JPRB, &
  & 0.31757935E-06_JPRB, 0.31760024E-06_JPRB, 0.31760322E-06_JPRB, 0.31758884E-06_JPRB, 0.31756014E-06_JPRB, 0.31752046E-06_JPRB, &
  & 0.31747206E-06_JPRB, 0.31741473E-06_JPRB, 0.31734558E-06_JPRB, 0.31725841E-06_JPRB, 0.31714305E-06_JPRB, 0.31698542E-06_JPRB, &
  & 0.31677112E-06_JPRB, 0.31648796E-06_JPRB, 0.31613911E-06_JPRB, 0.31573651E-06_JPRB, 0.31530669E-06_JPRB, 0.31486363E-06_JPRB, &
  & 0.31441650E-06_JPRB, 0.31397249E-06_JPRB, 0.31353554E-06_JPRB, 0.31311538E-06_JPRB, 0.31272350E-06_JPRB, 0.31236362E-06_JPRB, &
  & 0.31203672E-06_JPRB, 0.31172706E-06_JPRB, 0.31142261E-06_JPRB, 0.31110562E-06_JPRB, 0.31076948E-06_JPRB, 0.31041748E-06_JPRB, &
  & 0.31006633E-06_JPRB, 0.30972291E-06_JPRB, 0.30934996E-06_JPRB, 0.30871348E-06_JPRB /)

RGHG3(:,41, 1) = (/ &
  & 0.30693997E-06_JPRB, 0.30726167E-06_JPRB, 0.30746685E-06_JPRB, 0.30768282E-06_JPRB, 0.30794396E-06_JPRB, 0.30824845E-06_JPRB, &
  & 0.30857308E-06_JPRB, 0.30888907E-06_JPRB, 0.30918380E-06_JPRB, 0.30945489E-06_JPRB, 0.30971978E-06_JPRB, 0.30999399E-06_JPRB, &
  & 0.31032579E-06_JPRB, 0.31075047E-06_JPRB, 0.31134977E-06_JPRB, 0.31215802E-06_JPRB, 0.31314346E-06_JPRB, 0.31417227E-06_JPRB, &
  & 0.31509396E-06_JPRB, 0.31582840E-06_JPRB, 0.31635457E-06_JPRB, 0.31671249E-06_JPRB, 0.31695447E-06_JPRB, 0.31712034E-06_JPRB, &
  & 0.31724190E-06_JPRB, 0.31733396E-06_JPRB, 0.31741007E-06_JPRB, 0.31747578E-06_JPRB, 0.31753282E-06_JPRB, 0.31758066E-06_JPRB, &
  & 0.31761584E-06_JPRB, 0.31763579E-06_JPRB, 0.31763935E-06_JPRB, 0.31762733E-06_JPRB, 0.31760237E-06_JPRB, 0.31756773E-06_JPRB, &
  & 0.31752560E-06_JPRB, 0.31747575E-06_JPRB, 0.31741553E-06_JPRB, 0.31733967E-06_JPRB, 0.31723957E-06_JPRB, 0.31710329E-06_JPRB, &
  & 0.31691764E-06_JPRB, 0.31667236E-06_JPRB, 0.31636512E-06_JPRB, 0.31600928E-06_JPRB, 0.31561902E-06_JPRB, 0.31521103E-06_JPRB, &
  & 0.31479445E-06_JPRB, 0.31437239E-06_JPRB, 0.31395192E-06_JPRB, 0.31354773E-06_JPRB, 0.31317160E-06_JPRB, 0.31283832E-06_JPRB, &
  & 0.31253938E-06_JPRB, 0.31226500E-06_JPRB, 0.31199340E-06_JPRB, 0.31171021E-06_JPRB, 0.31140243E-06_JPRB, 0.31107496E-06_JPRB, &
  & 0.31074569E-06_JPRB, 0.31042435E-06_JPRB, 0.31007826E-06_JPRB, 0.30949190E-06_JPRB /)

RGHG3(:,42, 1) = (/ &
  & 0.30826774E-06_JPRB, 0.30854147E-06_JPRB, 0.30872283E-06_JPRB, 0.30891772E-06_JPRB, 0.30915874E-06_JPRB, 0.30944125E-06_JPRB, &
  & 0.30973342E-06_JPRB, 0.31001125E-06_JPRB, 0.31026548E-06_JPRB, 0.31049876E-06_JPRB, 0.31072153E-06_JPRB, 0.31095735E-06_JPRB, &
  & 0.31123119E-06_JPRB, 0.31160056E-06_JPRB, 0.31211769E-06_JPRB, 0.31284875E-06_JPRB, 0.31375507E-06_JPRB, 0.31469725E-06_JPRB, &
  & 0.31551971E-06_JPRB, 0.31613970E-06_JPRB, 0.31657592E-06_JPRB, 0.31686929E-06_JPRB, 0.31706952E-06_JPRB, 0.31720822E-06_JPRB, &
  & 0.31731227E-06_JPRB, 0.31739211E-06_JPRB, 0.31745981E-06_JPRB, 0.31751875E-06_JPRB, 0.31757077E-06_JPRB, 0.31761451E-06_JPRB, &
  & 0.31764685E-06_JPRB, 0.31766538E-06_JPRB, 0.31766908E-06_JPRB, 0.31765845E-06_JPRB, 0.31763599E-06_JPRB, 0.31760496E-06_JPRB, &
  & 0.31756750E-06_JPRB, 0.31752342E-06_JPRB, 0.31747027E-06_JPRB, 0.31740350E-06_JPRB, 0.31731565E-06_JPRB, 0.31719657E-06_JPRB, &
  & 0.31703507E-06_JPRB, 0.31682058E-06_JPRB, 0.31655100E-06_JPRB, 0.31623219E-06_JPRB, 0.31588067E-06_JPRB, 0.31550803E-06_JPRB, &
  & 0.31512124E-06_JPRB, 0.31472374E-06_JPRB, 0.31432333E-06_JPRB, 0.31393213E-06_JPRB, 0.31357735E-06_JPRB, 0.31326692E-06_JPRB, &
  & 0.31300027E-06_JPRB, 0.31275835E-06_JPRB, 0.31252236E-06_JPRB, 0.31227330E-06_JPRB, 0.31199968E-06_JPRB, 0.31170424E-06_JPRB, &
  & 0.31140252E-06_JPRB, 0.31110781E-06_JPRB, 0.31078847E-06_JPRB, 0.31024769E-06_JPRB /)

RGHG3(:,43, 1) = (/ &
  & 0.30943053E-06_JPRB, 0.30967135E-06_JPRB, 0.30983099E-06_JPRB, 0.31001036E-06_JPRB, 0.31023581E-06_JPRB, 0.31049848E-06_JPRB, &
  & 0.31076388E-06_JPRB, 0.31101010E-06_JPRB, 0.31123298E-06_JPRB, 0.31143497E-06_JPRB, 0.31162864E-06_JPRB, 0.31182924E-06_JPRB, &
  & 0.31206702E-06_JPRB, 0.31237698E-06_JPRB, 0.31283454E-06_JPRB, 0.31348367E-06_JPRB, 0.31430844E-06_JPRB, 0.31515066E-06_JPRB, &
  & 0.31586058E-06_JPRB, 0.31638515E-06_JPRB, 0.31674580E-06_JPRB, 0.31698926E-06_JPRB, 0.31715780E-06_JPRB, 0.31727728E-06_JPRB, &
  & 0.31736869E-06_JPRB, 0.31744042E-06_JPRB, 0.31750210E-06_JPRB, 0.31755673E-06_JPRB, 0.31760462E-06_JPRB, 0.31764517E-06_JPRB, &
  & 0.31767462E-06_JPRB, 0.31769150E-06_JPRB, 0.31769483E-06_JPRB, 0.31768491E-06_JPRB, 0.31766416E-06_JPRB, 0.31763579E-06_JPRB, &
  & 0.31760186E-06_JPRB, 0.31756232E-06_JPRB, 0.31751495E-06_JPRB, 0.31745577E-06_JPRB, 0.31737838E-06_JPRB, 0.31727404E-06_JPRB, &
  & 0.31713259E-06_JPRB, 0.31694464E-06_JPRB, 0.31670589E-06_JPRB, 0.31642230E-06_JPRB, 0.31610514E-06_JPRB, 0.31576576E-06_JPRB, &
  & 0.31541015E-06_JPRB, 0.31504015E-06_JPRB, 0.31465919E-06_JPRB, 0.31428965E-06_JPRB, 0.31395388E-06_JPRB, 0.31367188E-06_JPRB, &
  & 0.31343529E-06_JPRB, 0.31322548E-06_JPRB, 0.31302241E-06_JPRB, 0.31280786E-06_JPRB, 0.31257093E-06_JPRB, 0.31231230E-06_JPRB, &
  & 0.31204607E-06_JPRB, 0.31178132E-06_JPRB, 0.31149156E-06_JPRB, 0.31099631E-06_JPRB /)

RGHG3(:,44, 1) = (/ &
  & 0.31045863E-06_JPRB, 0.31067387E-06_JPRB, 0.31081987E-06_JPRB, 0.31098511E-06_JPRB, 0.31119760E-06_JPRB, 0.31144367E-06_JPRB, &
  & 0.31168713E-06_JPRB, 0.31190962E-06_JPRB, 0.31210755E-06_JPRB, 0.31228677E-06_JPRB, 0.31245582E-06_JPRB, 0.31263073E-06_JPRB, &
  & 0.31283355E-06_JPRB, 0.31310492E-06_JPRB, 0.31349546E-06_JPRB, 0.31408027E-06_JPRB, 0.31481633E-06_JPRB, 0.31555427E-06_JPRB, &
  & 0.31615269E-06_JPRB, 0.31658300E-06_JPRB, 0.31688097E-06_JPRB, 0.31708439E-06_JPRB, 0.31722882E-06_JPRB, 0.31733373E-06_JPRB, &
  & 0.31741595E-06_JPRB, 0.31748218E-06_JPRB, 0.31753979E-06_JPRB, 0.31759109E-06_JPRB, 0.31763631E-06_JPRB, 0.31767360E-06_JPRB, &
  & 0.31770037E-06_JPRB, 0.31771526E-06_JPRB, 0.31771776E-06_JPRB, 0.31770816E-06_JPRB, 0.31768855E-06_JPRB, 0.31766206E-06_JPRB, &
  & 0.31763091E-06_JPRB, 0.31759504E-06_JPRB, 0.31755243E-06_JPRB, 0.31749966E-06_JPRB, 0.31743124E-06_JPRB, 0.31733973E-06_JPRB, &
  & 0.31721623E-06_JPRB, 0.31705201E-06_JPRB, 0.31684183E-06_JPRB, 0.31658882E-06_JPRB, 0.31630270E-06_JPRB, 0.31599527E-06_JPRB, &
  & 0.31567046E-06_JPRB, 0.31532855E-06_JPRB, 0.31497561E-06_JPRB, 0.31462801E-06_JPRB, 0.31432060E-06_JPRB, 0.31406753E-06_JPRB, &
  & 0.31386043E-06_JPRB, 0.31368054E-06_JPRB, 0.31350689E-06_JPRB, 0.31332502E-06_JPRB, 0.31312393E-06_JPRB, 0.31290446E-06_JPRB, &
  & 0.31267746E-06_JPRB, 0.31244733E-06_JPRB, 0.31219093E-06_JPRB, 0.31174508E-06_JPRB /)

RGHG3(:,45, 1) = (/ &
  & 0.31137992E-06_JPRB, 0.31157697E-06_JPRB, 0.31171203E-06_JPRB, 0.31186656E-06_JPRB, 0.31206770E-06_JPRB, 0.31230110E-06_JPRB, &
  & 0.31252858E-06_JPRB, 0.31273294E-06_JPRB, 0.31291410E-06_JPRB, 0.31307457E-06_JPRB, 0.31322401E-06_JPRB, 0.31337618E-06_JPRB, &
  & 0.31354995E-06_JPRB, 0.31378067E-06_JPRB, 0.31412088E-06_JPRB, 0.31462477E-06_JPRB, 0.31527085E-06_JPRB, 0.31589792E-06_JPRB, &
  & 0.31639220E-06_JPRB, 0.31674446E-06_JPRB, 0.31698931E-06_JPRB, 0.31716218E-06_JPRB, 0.31728661E-06_JPRB, 0.31738159E-06_JPRB, &
  & 0.31745662E-06_JPRB, 0.31751898E-06_JPRB, 0.31757403E-06_JPRB, 0.31762323E-06_JPRB, 0.31766575E-06_JPRB, 0.31770054E-06_JPRB, &
  & 0.31772439E-06_JPRB, 0.31773723E-06_JPRB, 0.31773862E-06_JPRB, 0.31772888E-06_JPRB, 0.31770992E-06_JPRB, 0.31768479E-06_JPRB, &
  & 0.31765566E-06_JPRB, 0.31762275E-06_JPRB, 0.31758410E-06_JPRB, 0.31753683E-06_JPRB, 0.31747618E-06_JPRB, 0.31739589E-06_JPRB, &
  & 0.31728848E-06_JPRB, 0.31714569E-06_JPRB, 0.31696226E-06_JPRB, 0.31673804E-06_JPRB, 0.31648256E-06_JPRB, 0.31620476E-06_JPRB, &
  & 0.31591057E-06_JPRB, 0.31559958E-06_JPRB, 0.31527404E-06_JPRB, 0.31496023E-06_JPRB, 0.31468306E-06_JPRB, 0.31446302E-06_JPRB, &
  & 0.31428524E-06_JPRB, 0.31413163E-06_JPRB, 0.31398548E-06_JPRB, 0.31383186E-06_JPRB, 0.31366426E-06_JPRB, 0.31348259E-06_JPRB, &
  & 0.31329421E-06_JPRB, 0.31310151E-06_JPRB, 0.31288209E-06_JPRB, 0.31249351E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART2',0,ZHOOK_HANDLE)



RGHG3(:,46, 1) = (/ &
  & 0.31221501E-06_JPRB, 0.31240330E-06_JPRB, 0.31252918E-06_JPRB, 0.31267683E-06_JPRB, 0.31286839E-06_JPRB, 0.31309037E-06_JPRB, &
  & 0.31330725E-06_JPRB, 0.31350089E-06_JPRB, 0.31366841E-06_JPRB, 0.31381413E-06_JPRB, 0.31394632E-06_JPRB, 0.31407558E-06_JPRB, &
  & 0.31422485E-06_JPRB, 0.31441488E-06_JPRB, 0.31470549E-06_JPRB, 0.31513406E-06_JPRB, 0.31567907E-06_JPRB, 0.31619351E-06_JPRB, &
  & 0.31659101E-06_JPRB, 0.31687529E-06_JPRB, 0.31707802E-06_JPRB, 0.31722521E-06_JPRB, 0.31733583E-06_JPRB, 0.31742201E-06_JPRB, &
  & 0.31749232E-06_JPRB, 0.31755258E-06_JPRB, 0.31760550E-06_JPRB, 0.31765316E-06_JPRB, 0.31769395E-06_JPRB, 0.31772558E-06_JPRB, &
  & 0.31774687E-06_JPRB, 0.31775750E-06_JPRB, 0.31775761E-06_JPRB, 0.31774744E-06_JPRB, 0.31772879E-06_JPRB, 0.31770460E-06_JPRB, &
  & 0.31767709E-06_JPRB, 0.31764645E-06_JPRB, 0.31761107E-06_JPRB, 0.31756841E-06_JPRB, 0.31751441E-06_JPRB, 0.31744412E-06_JPRB, &
  & 0.31735118E-06_JPRB, 0.31722885E-06_JPRB, 0.31707103E-06_JPRB, 0.31687631E-06_JPRB, 0.31665033E-06_JPRB, 0.31640317E-06_JPRB, &
  & 0.31613976E-06_JPRB, 0.31585887E-06_JPRB, 0.31556948E-06_JPRB, 0.31528583E-06_JPRB, 0.31505033E-06_JPRB, 0.31486005E-06_JPRB, &
  & 0.31471183E-06_JPRB, 0.31458339E-06_JPRB, 0.31446027E-06_JPRB, 0.31433308E-06_JPRB, 0.31419407E-06_JPRB, 0.31404562E-06_JPRB, &
  & 0.31389337E-06_JPRB, 0.31373636E-06_JPRB, 0.31355495E-06_JPRB, 0.31322995E-06_JPRB /)

RGHG3(:,47, 1) = (/ &
  & 0.31298802E-06_JPRB, 0.31316529E-06_JPRB, 0.31328847E-06_JPRB, 0.31342762E-06_JPRB, 0.31361193E-06_JPRB, 0.31382717E-06_JPRB, &
  & 0.31403590E-06_JPRB, 0.31422258E-06_JPRB, 0.31437966E-06_JPRB, 0.31451174E-06_JPRB, 0.31462551E-06_JPRB, 0.31473678E-06_JPRB, &
  & 0.31485564E-06_JPRB, 0.31501776E-06_JPRB, 0.31524343E-06_JPRB, 0.31559927E-06_JPRB, 0.31603255E-06_JPRB, 0.31644078E-06_JPRB, &
  & 0.31675313E-06_JPRB, 0.31698190E-06_JPRB, 0.31714995E-06_JPRB, 0.31727825E-06_JPRB, 0.31737670E-06_JPRB, 0.31745770E-06_JPRB, &
  & 0.31752464E-06_JPRB, 0.31758307E-06_JPRB, 0.31763551E-06_JPRB, 0.31768175E-06_JPRB, 0.31772009E-06_JPRB, 0.31774945E-06_JPRB, &
  & 0.31776784E-06_JPRB, 0.31777628E-06_JPRB, 0.31777498E-06_JPRB, 0.31776406E-06_JPRB, 0.31774539E-06_JPRB, 0.31772186E-06_JPRB, &
  & 0.31769554E-06_JPRB, 0.31766672E-06_JPRB, 0.31763400E-06_JPRB, 0.31759507E-06_JPRB, 0.31754672E-06_JPRB, 0.31748493E-06_JPRB, &
  & 0.31740498E-06_JPRB, 0.31730158E-06_JPRB, 0.31716914E-06_JPRB, 0.31700512E-06_JPRB, 0.31681120E-06_JPRB, 0.31659704E-06_JPRB, &
  & 0.31636586E-06_JPRB, 0.31612024E-06_JPRB, 0.31586112E-06_JPRB, 0.31562217E-06_JPRB, 0.31541578E-06_JPRB, 0.31526281E-06_JPRB, &
  & 0.31513895E-06_JPRB, 0.31503350E-06_JPRB, 0.31493238E-06_JPRB, 0.31482617E-06_JPRB, 0.31471262E-06_JPRB, 0.31459243E-06_JPRB, &
  & 0.31447064E-06_JPRB, 0.31434553E-06_JPRB, 0.31420046E-06_JPRB, 0.31393677E-06_JPRB /)

RGHG3(:,48, 1) = (/ &
  & 0.31370308E-06_JPRB, 0.31387870E-06_JPRB, 0.31399480E-06_JPRB, 0.31413188E-06_JPRB, 0.31430892E-06_JPRB, 0.31451737E-06_JPRB, &
  & 0.31472425E-06_JPRB, 0.31490390E-06_JPRB, 0.31505203E-06_JPRB, 0.31516817E-06_JPRB, 0.31526577E-06_JPRB, 0.31535419E-06_JPRB, &
  & 0.31545241E-06_JPRB, 0.31557224E-06_JPRB, 0.31575439E-06_JPRB, 0.31601010E-06_JPRB, 0.31634039E-06_JPRB, 0.31664504E-06_JPRB, &
  & 0.31688541E-06_JPRB, 0.31706821E-06_JPRB, 0.31720950E-06_JPRB, 0.31732174E-06_JPRB, 0.31741291E-06_JPRB, 0.31748897E-06_JPRB, &
  & 0.31755417E-06_JPRB, 0.31761223E-06_JPRB, 0.31766356E-06_JPRB, 0.31770884E-06_JPRB, 0.31774516E-06_JPRB, 0.31777142E-06_JPRB, &
  & 0.31778723E-06_JPRB, 0.31779348E-06_JPRB, 0.31779066E-06_JPRB, 0.31777896E-06_JPRB, 0.31776017E-06_JPRB, 0.31773703E-06_JPRB, &
  & 0.31771162E-06_JPRB, 0.31768420E-06_JPRB, 0.31765350E-06_JPRB, 0.31761766E-06_JPRB, 0.31757389E-06_JPRB, 0.31751946E-06_JPRB, &
  & 0.31745100E-06_JPRB, 0.31736488E-06_JPRB, 0.31725781E-06_JPRB, 0.31712540E-06_JPRB, 0.31696922E-06_JPRB, 0.31679096E-06_JPRB, &
  & 0.31659752E-06_JPRB, 0.31638641E-06_JPRB, 0.31616872E-06_JPRB, 0.31595982E-06_JPRB, 0.31579566E-06_JPRB, 0.31566765E-06_JPRB, &
  & 0.31556922E-06_JPRB, 0.31548331E-06_JPRB, 0.31540017E-06_JPRB, 0.31531343E-06_JPRB, 0.31521992E-06_JPRB, 0.31512283E-06_JPRB, &
  & 0.31502546E-06_JPRB, 0.31492650E-06_JPRB, 0.31481090E-06_JPRB, 0.31460218E-06_JPRB /)

RGHG3(:,49, 1) = (/ &
  & 0.31437284E-06_JPRB, 0.31454027E-06_JPRB, 0.31465714E-06_JPRB, 0.31478817E-06_JPRB, 0.31496290E-06_JPRB, 0.31516930E-06_JPRB, &
  & 0.31537326E-06_JPRB, 0.31554896E-06_JPRB, 0.31568226E-06_JPRB, 0.31578213E-06_JPRB, 0.31585955E-06_JPRB, 0.31592833E-06_JPRB, &
  & 0.31599882E-06_JPRB, 0.31608442E-06_JPRB, 0.31620306E-06_JPRB, 0.31637524E-06_JPRB, 0.31659491E-06_JPRB, 0.31681313E-06_JPRB, &
  & 0.31699318E-06_JPRB, 0.31713901E-06_JPRB, 0.31725847E-06_JPRB, 0.31735894E-06_JPRB, 0.31744401E-06_JPRB, 0.31751784E-06_JPRB, &
  & 0.31758211E-06_JPRB, 0.31763977E-06_JPRB, 0.31769082E-06_JPRB, 0.31773448E-06_JPRB, 0.31776818E-06_JPRB, 0.31779189E-06_JPRB, &
  & 0.31780505E-06_JPRB, 0.31780934E-06_JPRB, 0.31780493E-06_JPRB, 0.31779237E-06_JPRB, 0.31777319E-06_JPRB, 0.31775028E-06_JPRB, &
  & 0.31772558E-06_JPRB, 0.31769923E-06_JPRB, 0.31767021E-06_JPRB, 0.31763682E-06_JPRB, 0.31759697E-06_JPRB, 0.31754863E-06_JPRB, &
  & 0.31749005E-06_JPRB, 0.31741985E-06_JPRB, 0.31733632E-06_JPRB, 0.31723783E-06_JPRB, 0.31712122E-06_JPRB, 0.31698758E-06_JPRB, &
  & 0.31683550E-06_JPRB, 0.31666616E-06_JPRB, 0.31648580E-06_JPRB, 0.31631890E-06_JPRB, 0.31618487E-06_JPRB, 0.31608496E-06_JPRB, &
  & 0.31600666E-06_JPRB, 0.31593774E-06_JPRB, 0.31586998E-06_JPRB, 0.31579822E-06_JPRB, 0.31572119E-06_JPRB, 0.31564133E-06_JPRB, &
  & 0.31556254E-06_JPRB, 0.31548257E-06_JPRB, 0.31539020E-06_JPRB, 0.31522248E-06_JPRB /)

RGHG3(:,50, 1) = (/ &
  & 0.31498968E-06_JPRB, 0.31515697E-06_JPRB, 0.31526608E-06_JPRB, 0.31539895E-06_JPRB, 0.31557019E-06_JPRB, 0.31577946E-06_JPRB, &
  & 0.31598063E-06_JPRB, 0.31614329E-06_JPRB, 0.31625598E-06_JPRB, 0.31633112E-06_JPRB, 0.31638535E-06_JPRB, 0.31643003E-06_JPRB, &
  & 0.31647076E-06_JPRB, 0.31652044E-06_JPRB, 0.31657973E-06_JPRB, 0.31667523E-06_JPRB, 0.31680375E-06_JPRB, 0.31694918E-06_JPRB, &
  & 0.31708157E-06_JPRB, 0.31719756E-06_JPRB, 0.31730005E-06_JPRB, 0.31739091E-06_JPRB, 0.31747223E-06_JPRB, 0.31754445E-06_JPRB, &
  & 0.31760899E-06_JPRB, 0.31766646E-06_JPRB, 0.31771665E-06_JPRB, 0.31775829E-06_JPRB, 0.31778956E-06_JPRB, 0.31781039E-06_JPRB, &
  & 0.31782128E-06_JPRB, 0.31782366E-06_JPRB, 0.31781778E-06_JPRB, 0.31780434E-06_JPRB, 0.31778487E-06_JPRB, 0.31776210E-06_JPRB, &
  & 0.31773786E-06_JPRB, 0.31771236E-06_JPRB, 0.31768462E-06_JPRB, 0.31765325E-06_JPRB, 0.31761641E-06_JPRB, 0.31757321E-06_JPRB, &
  & 0.31752325E-06_JPRB, 0.31746708E-06_JPRB, 0.31740552E-06_JPRB, 0.31733879E-06_JPRB, 0.31726358E-06_JPRB, 0.31717664E-06_JPRB, &
  & 0.31707262E-06_JPRB, 0.31695129E-06_JPRB, 0.31681697E-06_JPRB, 0.31669234E-06_JPRB, 0.31659059E-06_JPRB, 0.31651669E-06_JPRB, &
  & 0.31645573E-06_JPRB, 0.31640178E-06_JPRB, 0.31634772E-06_JPRB, 0.31628826E-06_JPRB, 0.31622429E-06_JPRB, 0.31615775E-06_JPRB, &
  & 0.31609176E-06_JPRB, 0.31602556E-06_JPRB, 0.31594774E-06_JPRB, 0.31580740E-06_JPRB /)

RGHG3(:,51, 1) = (/ &
  & 0.31555697E-06_JPRB, 0.31570801E-06_JPRB, 0.31582289E-06_JPRB, 0.31594712E-06_JPRB, 0.31612427E-06_JPRB, 0.31632547E-06_JPRB, &
  & 0.31651587E-06_JPRB, 0.31664479E-06_JPRB, 0.31672141E-06_JPRB, 0.31676598E-06_JPRB, 0.31679411E-06_JPRB, 0.31681350E-06_JPRB, &
  & 0.31683078E-06_JPRB, 0.31684559E-06_JPRB, 0.31686912E-06_JPRB, 0.31690237E-06_JPRB, 0.31697004E-06_JPRB, 0.31705918E-06_JPRB, &
  & 0.31715501E-06_JPRB, 0.31724784E-06_JPRB, 0.31733626E-06_JPRB, 0.31742002E-06_JPRB, 0.31749818E-06_JPRB, 0.31756991E-06_JPRB, &
  & 0.31763437E-06_JPRB, 0.31769201E-06_JPRB, 0.31774061E-06_JPRB, 0.31778023E-06_JPRB, 0.31780871E-06_JPRB, 0.31782724E-06_JPRB, &
  & 0.31783608E-06_JPRB, 0.31783665E-06_JPRB, 0.31782940E-06_JPRB, 0.31781511E-06_JPRB, 0.31779535E-06_JPRB, 0.31777265E-06_JPRB, &
  & 0.31774877E-06_JPRB, 0.31772390E-06_JPRB, 0.31769716E-06_JPRB, 0.31766734E-06_JPRB, 0.31763318E-06_JPRB, 0.31759427E-06_JPRB, &
  & 0.31755184E-06_JPRB, 0.31750793E-06_JPRB, 0.31746589E-06_JPRB, 0.31742587E-06_JPRB, 0.31738639E-06_JPRB, 0.31734075E-06_JPRB, &
  & 0.31728487E-06_JPRB, 0.31721362E-06_JPRB, 0.31713307E-06_JPRB, 0.31705270E-06_JPRB, 0.31698949E-06_JPRB, 0.31693736E-06_JPRB, &
  & 0.31689643E-06_JPRB, 0.31685744E-06_JPRB, 0.31681603E-06_JPRB, 0.31677089E-06_JPRB, 0.31671897E-06_JPRB, 0.31666445E-06_JPRB, &
  & 0.31661014E-06_JPRB, 0.31655344E-06_JPRB, 0.31648676E-06_JPRB, 0.31636316E-06_JPRB /)

RGHG3(:,52, 1) = (/ &
  & 0.31604554E-06_JPRB, 0.31620195E-06_JPRB, 0.31629716E-06_JPRB, 0.31642892E-06_JPRB, 0.31658578E-06_JPRB, 0.31677337E-06_JPRB, &
  & 0.31691187E-06_JPRB, 0.31699312E-06_JPRB, 0.31703183E-06_JPRB, 0.31705068E-06_JPRB, 0.31705997E-06_JPRB, 0.31706480E-06_JPRB, &
  & 0.31706648E-06_JPRB, 0.31706657E-06_JPRB, 0.31706628E-06_JPRB, 0.31707248E-06_JPRB, 0.31709610E-06_JPRB, 0.31714882E-06_JPRB, &
  & 0.31721700E-06_JPRB, 0.31729192E-06_JPRB, 0.31736965E-06_JPRB, 0.31744742E-06_JPRB, 0.31752319E-06_JPRB, 0.31759436E-06_JPRB, &
  & 0.31765907E-06_JPRB, 0.31771543E-06_JPRB, 0.31776295E-06_JPRB, 0.31779987E-06_JPRB, 0.31782619E-06_JPRB, 0.31784242E-06_JPRB, &
  & 0.31784947E-06_JPRB, 0.31784839E-06_JPRB, 0.31783989E-06_JPRB, 0.31782477E-06_JPRB, 0.31780468E-06_JPRB, 0.31778211E-06_JPRB, &
  & 0.31775855E-06_JPRB, 0.31773425E-06_JPRB, 0.31770836E-06_JPRB, 0.31767985E-06_JPRB, 0.31764785E-06_JPRB, 0.31761283E-06_JPRB, &
  & 0.31757688E-06_JPRB, 0.31754408E-06_JPRB, 0.31751748E-06_JPRB, 0.31749846E-06_JPRB, 0.31748291E-06_JPRB, 0.31746640E-06_JPRB, &
  & 0.31744332E-06_JPRB, 0.31741206E-06_JPRB, 0.31737318E-06_JPRB, 0.31733458E-06_JPRB, 0.31729937E-06_JPRB, 0.31727259E-06_JPRB, &
  & 0.31724778E-06_JPRB, 0.31722413E-06_JPRB, 0.31719873E-06_JPRB, 0.31716741E-06_JPRB, 0.31713228E-06_JPRB, 0.31709340E-06_JPRB, &
  & 0.31705321E-06_JPRB, 0.31701123E-06_JPRB, 0.31695842E-06_JPRB, 0.31685687E-06_JPRB /)

RGHG3(:,53, 1) = (/ &
  & 0.31647062E-06_JPRB, 0.31659459E-06_JPRB, 0.31670154E-06_JPRB, 0.31680213E-06_JPRB, 0.31694620E-06_JPRB, 0.31707279E-06_JPRB, &
  & 0.31715959E-06_JPRB, 0.31719730E-06_JPRB, 0.31721265E-06_JPRB, 0.31721822E-06_JPRB, 0.31721942E-06_JPRB, 0.31721822E-06_JPRB, &
  & 0.31721470E-06_JPRB, 0.31720987E-06_JPRB, 0.31720077E-06_JPRB, 0.31719378E-06_JPRB, 0.31719645E-06_JPRB, 0.31722240E-06_JPRB, &
  & 0.31727080E-06_JPRB, 0.31733231E-06_JPRB, 0.31740120E-06_JPRB, 0.31747436E-06_JPRB, 0.31754766E-06_JPRB, 0.31761786E-06_JPRB, &
  & 0.31768158E-06_JPRB, 0.31773737E-06_JPRB, 0.31778271E-06_JPRB, 0.31781775E-06_JPRB, 0.31784174E-06_JPRB, 0.31785621E-06_JPRB, &
  & 0.31786172E-06_JPRB, 0.31785910E-06_JPRB, 0.31784938E-06_JPRB, 0.31783350E-06_JPRB, 0.31781320E-06_JPRB, 0.31779069E-06_JPRB, &
  & 0.31776750E-06_JPRB, 0.31774374E-06_JPRB, 0.31771862E-06_JPRB, 0.31769125E-06_JPRB, 0.31766129E-06_JPRB, 0.31762963E-06_JPRB, &
  & 0.31759978E-06_JPRB, 0.31757600E-06_JPRB, 0.31756198E-06_JPRB, 0.31755638E-06_JPRB, 0.31755519E-06_JPRB, 0.31755332E-06_JPRB, &
  & 0.31754752E-06_JPRB, 0.31753623E-06_JPRB, 0.31752023E-06_JPRB, 0.31750216E-06_JPRB, 0.31748652E-06_JPRB, 0.31747220E-06_JPRB, &
  & 0.31746004E-06_JPRB, 0.31744736E-06_JPRB, 0.31743264E-06_JPRB, 0.31741556E-06_JPRB, 0.31739427E-06_JPRB, 0.31737136E-06_JPRB, &
  & 0.31734780E-06_JPRB, 0.31732262E-06_JPRB, 0.31729186E-06_JPRB, 0.31722573E-06_JPRB /)

RGHG3(:,54, 1) = (/ &
  & 0.31679375E-06_JPRB, 0.31692440E-06_JPRB, 0.31699454E-06_JPRB, 0.31709033E-06_JPRB, 0.31717917E-06_JPRB, 0.31726108E-06_JPRB, &
  & 0.31730073E-06_JPRB, 0.31731616E-06_JPRB, 0.31732037E-06_JPRB, 0.31732054E-06_JPRB, 0.31731895E-06_JPRB, 0.31731599E-06_JPRB, &
  & 0.31731213E-06_JPRB, 0.31730511E-06_JPRB, 0.31729732E-06_JPRB, 0.31728320E-06_JPRB, 0.31727541E-06_JPRB, 0.31728507E-06_JPRB, &
  & 0.31731861E-06_JPRB, 0.31736963E-06_JPRB, 0.31743215E-06_JPRB, 0.31750096E-06_JPRB, 0.31757176E-06_JPRB, 0.31764031E-06_JPRB, &
  & 0.31770281E-06_JPRB, 0.31775693E-06_JPRB, 0.31780093E-06_JPRB, 0.31783378E-06_JPRB, 0.31785609E-06_JPRB, 0.31786880E-06_JPRB, &
  & 0.31787280E-06_JPRB, 0.31786880E-06_JPRB, 0.31785802E-06_JPRB, 0.31784148E-06_JPRB, 0.31782099E-06_JPRB, 0.31779859E-06_JPRB, &
  & 0.31777574E-06_JPRB, 0.31775244E-06_JPRB, 0.31772811E-06_JPRB, 0.31770188E-06_JPRB, 0.31767377E-06_JPRB, 0.31764557E-06_JPRB, &
  & 0.31762104E-06_JPRB, 0.31760516E-06_JPRB, 0.31759987E-06_JPRB, 0.31760266E-06_JPRB, 0.31760862E-06_JPRB, 0.31761340E-06_JPRB, &
  & 0.31761471E-06_JPRB, 0.31761172E-06_JPRB, 0.31760516E-06_JPRB, 0.31759697E-06_JPRB, 0.31758867E-06_JPRB, 0.31758179E-06_JPRB, &
  & 0.31757503E-06_JPRB, 0.31756807E-06_JPRB, 0.31756025E-06_JPRB, 0.31755013E-06_JPRB, 0.31753854E-06_JPRB, 0.31752569E-06_JPRB, &
  & 0.31751318E-06_JPRB, 0.31750164E-06_JPRB, 0.31749016E-06_JPRB, 0.31747487E-06_JPRB /)

RGHG3(:,55, 1) = (/ &
  & 0.31705457E-06_JPRB, 0.31714811E-06_JPRB, 0.31722007E-06_JPRB, 0.31727410E-06_JPRB, 0.31733319E-06_JPRB, 0.31737147E-06_JPRB, &
  & 0.31738833E-06_JPRB, 0.31739211E-06_JPRB, 0.31739179E-06_JPRB, 0.31739006E-06_JPRB, 0.31738773E-06_JPRB, 0.31738483E-06_JPRB, &
  & 0.31738071E-06_JPRB, 0.31737579E-06_JPRB, 0.31736607E-06_JPRB, 0.31735544E-06_JPRB, 0.31734041E-06_JPRB, 0.31733947E-06_JPRB, &
  & 0.31736209E-06_JPRB, 0.31740535E-06_JPRB, 0.31746231E-06_JPRB, 0.31752731E-06_JPRB, 0.31759529E-06_JPRB, 0.31766166E-06_JPRB, &
  & 0.31772251E-06_JPRB, 0.31777523E-06_JPRB, 0.31781741E-06_JPRB, 0.31784873E-06_JPRB, 0.31786914E-06_JPRB, 0.31788039E-06_JPRB, &
  & 0.31788301E-06_JPRB, 0.31787783E-06_JPRB, 0.31786610E-06_JPRB, 0.31784899E-06_JPRB, 0.31782821E-06_JPRB, 0.31780596E-06_JPRB, &
  & 0.31778342E-06_JPRB, 0.31776071E-06_JPRB, 0.31773712E-06_JPRB, 0.31771214E-06_JPRB, 0.31768613E-06_JPRB, 0.31766103E-06_JPRB, &
  & 0.31764142E-06_JPRB, 0.31763147E-06_JPRB, 0.31763227E-06_JPRB, 0.31764012E-06_JPRB, 0.31764947E-06_JPRB, 0.31765691E-06_JPRB, &
  & 0.31766081E-06_JPRB, 0.31766101E-06_JPRB, 0.31765836E-06_JPRB, 0.31765421E-06_JPRB, 0.31765001E-06_JPRB, 0.31764586E-06_JPRB, &
  & 0.31764210E-06_JPRB, 0.31763807E-06_JPRB, 0.31763312E-06_JPRB, 0.31762724E-06_JPRB, 0.31761982E-06_JPRB, 0.31761192E-06_JPRB, &
  & 0.31760402E-06_JPRB, 0.31759620E-06_JPRB, 0.31758765E-06_JPRB, 0.31757259E-06_JPRB /)

RGHG3(:,56, 1) = (/ &
  & 0.31723488E-06_JPRB, 0.31732060E-06_JPRB, 0.31736170E-06_JPRB, 0.31739950E-06_JPRB, 0.31742775E-06_JPRB, 0.31744437E-06_JPRB, &
  & 0.31744804E-06_JPRB, 0.31744690E-06_JPRB, 0.31744477E-06_JPRB, 0.31744256E-06_JPRB, 0.31744028E-06_JPRB, 0.31743764E-06_JPRB, &
  & 0.31743463E-06_JPRB, 0.31742960E-06_JPRB, 0.31742354E-06_JPRB, 0.31741052E-06_JPRB, 0.31739683E-06_JPRB, 0.31738844E-06_JPRB, &
  & 0.31740308E-06_JPRB, 0.31743971E-06_JPRB, 0.31749195E-06_JPRB, 0.31755323E-06_JPRB, 0.31761817E-06_JPRB, 0.31768232E-06_JPRB, &
  & 0.31774132E-06_JPRB, 0.31779223E-06_JPRB, 0.31783304E-06_JPRB, 0.31786237E-06_JPRB, 0.31788133E-06_JPRB, 0.31789108E-06_JPRB, &
  & 0.31789247E-06_JPRB, 0.31788633E-06_JPRB, 0.31787377E-06_JPRB, 0.31785612E-06_JPRB, 0.31783520E-06_JPRB, 0.31781309E-06_JPRB, &
  & 0.31779101E-06_JPRB, 0.31776875E-06_JPRB, 0.31774607E-06_JPRB, 0.31772231E-06_JPRB, 0.31769835E-06_JPRB, 0.31767647E-06_JPRB, &
  & 0.31766092E-06_JPRB, 0.31765569E-06_JPRB, 0.31766072E-06_JPRB, 0.31767121E-06_JPRB, 0.31768232E-06_JPRB, 0.31769054E-06_JPRB, &
  & 0.31769525E-06_JPRB, 0.31769665E-06_JPRB, 0.31769557E-06_JPRB, 0.31769326E-06_JPRB, 0.31769059E-06_JPRB, 0.31768818E-06_JPRB, &
  & 0.31768573E-06_JPRB, 0.31768309E-06_JPRB, 0.31768002E-06_JPRB, 0.31767598E-06_JPRB, 0.31767127E-06_JPRB, 0.31766587E-06_JPRB, &
  & 0.31766052E-06_JPRB, 0.31765541E-06_JPRB, 0.31764998E-06_JPRB, 0.31764159E-06_JPRB /)

RGHG3(:,57, 1) = (/ &
  & 0.31736835E-06_JPRB, 0.31743022E-06_JPRB, 0.31746058E-06_JPRB, 0.31748010E-06_JPRB, 0.31749244E-06_JPRB, 0.31749605E-06_JPRB, &
  & 0.31749374E-06_JPRB, 0.31749062E-06_JPRB, 0.31748789E-06_JPRB, 0.31748567E-06_JPRB, 0.31748363E-06_JPRB, 0.31748149E-06_JPRB, &
  & 0.31747879E-06_JPRB, 0.31747544E-06_JPRB, 0.31746893E-06_JPRB, 0.31746038E-06_JPRB, 0.31744418E-06_JPRB, 0.31743315E-06_JPRB, &
  & 0.31744196E-06_JPRB, 0.31747345E-06_JPRB, 0.31752111E-06_JPRB, 0.31757867E-06_JPRB, 0.31764074E-06_JPRB, 0.31770233E-06_JPRB, &
  & 0.31775934E-06_JPRB, 0.31780854E-06_JPRB, 0.31784748E-06_JPRB, 0.31787539E-06_JPRB, 0.31789273E-06_JPRB, 0.31790114E-06_JPRB, &
  & 0.31790137E-06_JPRB, 0.31789440E-06_JPRB, 0.31788122E-06_JPRB, 0.31786323E-06_JPRB, 0.31784228E-06_JPRB, 0.31782039E-06_JPRB, &
  & 0.31779851E-06_JPRB, 0.31777697E-06_JPRB, 0.31775505E-06_JPRB, 0.31773268E-06_JPRB, 0.31771083E-06_JPRB, 0.31769181E-06_JPRB, &
  & 0.31767993E-06_JPRB, 0.31767817E-06_JPRB, 0.31768576E-06_JPRB, 0.31769827E-06_JPRB, 0.31770989E-06_JPRB, 0.31771827E-06_JPRB, &
  & 0.31772299E-06_JPRB, 0.31772456E-06_JPRB, 0.31772404E-06_JPRB, 0.31772254E-06_JPRB, 0.31772083E-06_JPRB, 0.31771907E-06_JPRB, &
  & 0.31771742E-06_JPRB, 0.31771555E-06_JPRB, 0.31771327E-06_JPRB, 0.31771052E-06_JPRB, 0.31770696E-06_JPRB, 0.31770304E-06_JPRB, &
  & 0.31769900E-06_JPRB, 0.31769497E-06_JPRB, 0.31769051E-06_JPRB, 0.31768272E-06_JPRB /)

RGHG3(:,58, 1) = (/ &
  & 0.31746396E-06_JPRB, 0.31750886E-06_JPRB, 0.31752728E-06_JPRB, 0.31753643E-06_JPRB, 0.31753981E-06_JPRB, 0.31753703E-06_JPRB, &
  & 0.31753231E-06_JPRB, 0.31752839E-06_JPRB, 0.31752572E-06_JPRB, 0.31752370E-06_JPRB, 0.31752194E-06_JPRB, 0.31752012E-06_JPRB, &
  & 0.31751807E-06_JPRB, 0.31751483E-06_JPRB, 0.31751037E-06_JPRB, 0.31750085E-06_JPRB, 0.31748783E-06_JPRB, 0.31747430E-06_JPRB, &
  & 0.31747933E-06_JPRB, 0.31750650E-06_JPRB, 0.31755016E-06_JPRB, 0.31760419E-06_JPRB, 0.31766311E-06_JPRB, 0.31772225E-06_JPRB, &
  & 0.31777697E-06_JPRB, 0.31782406E-06_JPRB, 0.31786124E-06_JPRB, 0.31788733E-06_JPRB, 0.31790336E-06_JPRB, 0.31791058E-06_JPRB, &
  & 0.31790987E-06_JPRB, 0.31790228E-06_JPRB, 0.31788863E-06_JPRB, 0.31787044E-06_JPRB, 0.31784953E-06_JPRB, 0.31782776E-06_JPRB, &
  & 0.31780638E-06_JPRB, 0.31778538E-06_JPRB, 0.31776440E-06_JPRB, 0.31774340E-06_JPRB, 0.31772362E-06_JPRB, 0.31770733E-06_JPRB, &
  & 0.31769838E-06_JPRB, 0.31769918E-06_JPRB, 0.31770875E-06_JPRB, 0.31772180E-06_JPRB, 0.31773402E-06_JPRB, 0.31774212E-06_JPRB, &
  & 0.31774647E-06_JPRB, 0.31774786E-06_JPRB, 0.31774749E-06_JPRB, 0.31774630E-06_JPRB, 0.31774488E-06_JPRB, 0.31774351E-06_JPRB, &
  & 0.31774218E-06_JPRB, 0.31774073E-06_JPRB, 0.31773902E-06_JPRB, 0.31773675E-06_JPRB, 0.31773408E-06_JPRB, 0.31773095E-06_JPRB, &
  & 0.31772777E-06_JPRB, 0.31772450E-06_JPRB, 0.31772092E-06_JPRB, 0.31771492E-06_JPRB /)

RGHG3(:,59, 1) = (/ &
  & 0.31753513E-06_JPRB, 0.31756755E-06_JPRB, 0.31757625E-06_JPRB, 0.31757946E-06_JPRB, 0.31757781E-06_JPRB, 0.31757227E-06_JPRB, &
  & 0.31756639E-06_JPRB, 0.31756244E-06_JPRB, 0.31755982E-06_JPRB, 0.31755803E-06_JPRB, 0.31755656E-06_JPRB, 0.31755513E-06_JPRB, &
  & 0.31755329E-06_JPRB, 0.31755087E-06_JPRB, 0.31754630E-06_JPRB, 0.31753922E-06_JPRB, 0.31752543E-06_JPRB, 0.31751264E-06_JPRB, &
  & 0.31751549E-06_JPRB, 0.31753916E-06_JPRB, 0.31757901E-06_JPRB, 0.31762966E-06_JPRB, 0.31768553E-06_JPRB, 0.31774198E-06_JPRB, &
  & 0.31779422E-06_JPRB, 0.31783912E-06_JPRB, 0.31787414E-06_JPRB, 0.31789872E-06_JPRB, 0.31791330E-06_JPRB, 0.31791953E-06_JPRB, &
  & 0.31791808E-06_JPRB, 0.31790995E-06_JPRB, 0.31789602E-06_JPRB, 0.31787781E-06_JPRB, 0.31785703E-06_JPRB, 0.31783566E-06_JPRB, &
  & 0.31781462E-06_JPRB, 0.31779427E-06_JPRB, 0.31777427E-06_JPRB, 0.31775460E-06_JPRB, 0.31773675E-06_JPRB, 0.31772282E-06_JPRB, &
  & 0.31771634E-06_JPRB, 0.31771913E-06_JPRB, 0.31772964E-06_JPRB, 0.31774354E-06_JPRB, 0.31775542E-06_JPRB, 0.31776329E-06_JPRB, &
  & 0.31776713E-06_JPRB, 0.31776824E-06_JPRB, 0.31776784E-06_JPRB, 0.31776671E-06_JPRB, 0.31776543E-06_JPRB, 0.31776415E-06_JPRB, &
  & 0.31776293E-06_JPRB, 0.31776165E-06_JPRB, 0.31776008E-06_JPRB, 0.31775824E-06_JPRB, 0.31775591E-06_JPRB, 0.31775335E-06_JPRB, &
  & 0.31775068E-06_JPRB, 0.31774789E-06_JPRB, 0.31774476E-06_JPRB, 0.31773916E-06_JPRB /)

RGHG3(:,60, 1) = (/ &
  & 0.31760857E-06_JPRB, 0.31761388E-06_JPRB, 0.31761562E-06_JPRB, 0.31761459E-06_JPRB, 0.31761044E-06_JPRB, 0.31760408E-06_JPRB, &
  & 0.31759811E-06_JPRB, 0.31759402E-06_JPRB, 0.31759157E-06_JPRB, 0.31758998E-06_JPRB, 0.31758879E-06_JPRB, 0.31758765E-06_JPRB, &
  & 0.31758626E-06_JPRB, 0.31758401E-06_JPRB, 0.31758043E-06_JPRB, 0.31757298E-06_JPRB, 0.31756085E-06_JPRB, 0.31754857E-06_JPRB, &
  & 0.31755047E-06_JPRB, 0.31757148E-06_JPRB, 0.31760800E-06_JPRB, 0.31765526E-06_JPRB, 0.31770810E-06_JPRB, 0.31776156E-06_JPRB, &
  & 0.31781121E-06_JPRB, 0.31785359E-06_JPRB, 0.31788647E-06_JPRB, 0.31790924E-06_JPRB, 0.31792271E-06_JPRB, 0.31792803E-06_JPRB, &
  & 0.31792592E-06_JPRB, 0.31791757E-06_JPRB, 0.31790367E-06_JPRB, 0.31788551E-06_JPRB, 0.31786504E-06_JPRB, 0.31784398E-06_JPRB, &
  & 0.31782349E-06_JPRB, 0.31780374E-06_JPRB, 0.31778455E-06_JPRB, 0.31776625E-06_JPRB, 0.31775011E-06_JPRB, 0.31773840E-06_JPRB, &
  & 0.31773391E-06_JPRB, 0.31773803E-06_JPRB, 0.31774945E-06_JPRB, 0.31776312E-06_JPRB, 0.31777518E-06_JPRB, 0.31778262E-06_JPRB, &
  & 0.31778609E-06_JPRB, 0.31778677E-06_JPRB, 0.31778606E-06_JPRB, 0.31778481E-06_JPRB, 0.31778345E-06_JPRB, 0.31778222E-06_JPRB, &
  & 0.31778097E-06_JPRB, 0.31777969E-06_JPRB, 0.31777830E-06_JPRB, 0.31777654E-06_JPRB, 0.31777455E-06_JPRB, 0.31777216E-06_JPRB, &
  & 0.31776975E-06_JPRB, 0.31776725E-06_JPRB, 0.31776446E-06_JPRB, 0.31775974E-06_JPRB /)

RGHG3(:,61, 1) = (/ &
  & 0.31764256E-06_JPRB, 0.31764685E-06_JPRB, 0.31764674E-06_JPRB, 0.31764449E-06_JPRB, 0.31764017E-06_JPRB, 0.31763366E-06_JPRB, &
  & 0.31762778E-06_JPRB, 0.31762389E-06_JPRB, 0.31762158E-06_JPRB, 0.31762028E-06_JPRB, 0.31761937E-06_JPRB, 0.31761857E-06_JPRB, &
  & 0.31761749E-06_JPRB, 0.31761579E-06_JPRB, 0.31761226E-06_JPRB, 0.31760561E-06_JPRB, 0.31759379E-06_JPRB, 0.31758296E-06_JPRB, &
  & 0.31758464E-06_JPRB, 0.31760342E-06_JPRB, 0.31763705E-06_JPRB, 0.31768118E-06_JPRB, 0.31773072E-06_JPRB, 0.31778126E-06_JPRB, &
  & 0.31782790E-06_JPRB, 0.31786763E-06_JPRB, 0.31789816E-06_JPRB, 0.31791939E-06_JPRB, 0.31793149E-06_JPRB, 0.31793607E-06_JPRB, &
  & 0.31793365E-06_JPRB, 0.31792524E-06_JPRB, 0.31791146E-06_JPRB, 0.31789355E-06_JPRB, 0.31787351E-06_JPRB, 0.31785288E-06_JPRB, &
  & 0.31783301E-06_JPRB, 0.31781377E-06_JPRB, 0.31779553E-06_JPRB, 0.31777830E-06_JPRB, 0.31776383E-06_JPRB, 0.31775403E-06_JPRB, &
  & 0.31775116E-06_JPRB, 0.31775636E-06_JPRB, 0.31776801E-06_JPRB, 0.31778174E-06_JPRB, 0.31779334E-06_JPRB, 0.31780053E-06_JPRB, &
  & 0.31780363E-06_JPRB, 0.31780397E-06_JPRB, 0.31780297E-06_JPRB, 0.31780149E-06_JPRB, 0.31779999E-06_JPRB, 0.31779868E-06_JPRB, &
  & 0.31779740E-06_JPRB, 0.31779607E-06_JPRB, 0.31779453E-06_JPRB, 0.31779280E-06_JPRB, 0.31779069E-06_JPRB, 0.31778845E-06_JPRB, &
  & 0.31778609E-06_JPRB, 0.31778370E-06_JPRB, 0.31778103E-06_JPRB, 0.31777634E-06_JPRB /)

RGHG3(:,62, 1) = (/ &
  & 0.31767209E-06_JPRB, 0.31767485E-06_JPRB, 0.31767425E-06_JPRB, 0.31767186E-06_JPRB, 0.31766746E-06_JPRB, 0.31766174E-06_JPRB, &
  & 0.31765609E-06_JPRB, 0.31765217E-06_JPRB, 0.31765001E-06_JPRB, 0.31764898E-06_JPRB, 0.31764853E-06_JPRB, 0.31764824E-06_JPRB, &
  & 0.31764773E-06_JPRB, 0.31764645E-06_JPRB, 0.31764336E-06_JPRB, 0.31763668E-06_JPRB, 0.31762559E-06_JPRB, 0.31761647E-06_JPRB, &
  & 0.31761823E-06_JPRB, 0.31763523E-06_JPRB, 0.31766626E-06_JPRB, 0.31770719E-06_JPRB, 0.31775363E-06_JPRB, 0.31780081E-06_JPRB, &
  & 0.31784435E-06_JPRB, 0.31788119E-06_JPRB, 0.31790944E-06_JPRB, 0.31792882E-06_JPRB, 0.31793979E-06_JPRB, 0.31794374E-06_JPRB, &
  & 0.31794110E-06_JPRB, 0.31793283E-06_JPRB, 0.31791939E-06_JPRB, 0.31790208E-06_JPRB, 0.31788247E-06_JPRB, 0.31786243E-06_JPRB, &
  & 0.31784299E-06_JPRB, 0.31782452E-06_JPRB, 0.31780689E-06_JPRB, 0.31779095E-06_JPRB, 0.31777782E-06_JPRB, 0.31776958E-06_JPRB, &
  & 0.31776810E-06_JPRB, 0.31777412E-06_JPRB, 0.31778580E-06_JPRB, 0.31779913E-06_JPRB, 0.31781059E-06_JPRB, 0.31781752E-06_JPRB, &
  & 0.31782031E-06_JPRB, 0.31782028E-06_JPRB, 0.31781889E-06_JPRB, 0.31781710E-06_JPRB, 0.31781536E-06_JPRB, 0.31781383E-06_JPRB, &
  & 0.31781235E-06_JPRB, 0.31781087E-06_JPRB, 0.31780928E-06_JPRB, 0.31780741E-06_JPRB, 0.31780530E-06_JPRB, 0.31780297E-06_JPRB, &
  & 0.31780056E-06_JPRB, 0.31779814E-06_JPRB, 0.31779547E-06_JPRB, 0.31779098E-06_JPRB /)

RGHG3(:,63, 1) = (/ &
  & 0.31769773E-06_JPRB, 0.31770026E-06_JPRB, 0.31769957E-06_JPRB, 0.31769730E-06_JPRB, 0.31769358E-06_JPRB, 0.31768838E-06_JPRB, &
  & 0.31768312E-06_JPRB, 0.31767922E-06_JPRB, 0.31767718E-06_JPRB, 0.31767649E-06_JPRB, 0.31767661E-06_JPRB, 0.31767706E-06_JPRB, &
  & 0.31767729E-06_JPRB, 0.31767661E-06_JPRB, 0.31767354E-06_JPRB, 0.31766706E-06_JPRB, 0.31765705E-06_JPRB, 0.31764941E-06_JPRB, &
  & 0.31765137E-06_JPRB, 0.31766689E-06_JPRB, 0.31769542E-06_JPRB, 0.31773342E-06_JPRB, 0.31777640E-06_JPRB, 0.31782031E-06_JPRB, &
  & 0.31786047E-06_JPRB, 0.31789438E-06_JPRB, 0.31792021E-06_JPRB, 0.31793778E-06_JPRB, 0.31794764E-06_JPRB, 0.31795108E-06_JPRB, &
  & 0.31794841E-06_JPRB, 0.31794042E-06_JPRB, 0.31792757E-06_JPRB, 0.31791083E-06_JPRB, 0.31789196E-06_JPRB, 0.31787249E-06_JPRB, &
  & 0.31785365E-06_JPRB, 0.31783560E-06_JPRB, 0.31781886E-06_JPRB, 0.31780385E-06_JPRB, 0.31779203E-06_JPRB, 0.31778521E-06_JPRB, &
  & 0.31778487E-06_JPRB, 0.31779138E-06_JPRB, 0.31780294E-06_JPRB, 0.31781590E-06_JPRB, 0.31782690E-06_JPRB, 0.31783370E-06_JPRB, &
  & 0.31783628E-06_JPRB, 0.31783594E-06_JPRB, 0.31783415E-06_JPRB, 0.31783196E-06_JPRB, 0.31782994E-06_JPRB, 0.31782812E-06_JPRB, &
  & 0.31782645E-06_JPRB, 0.31782477E-06_JPRB, 0.31782287E-06_JPRB, 0.31782082E-06_JPRB, 0.31781843E-06_JPRB, 0.31781593E-06_JPRB, &
  & 0.31781335E-06_JPRB, 0.31781082E-06_JPRB, 0.31780803E-06_JPRB, 0.31780331E-06_JPRB /)

RGHG3(:,64, 1) = (/ &
  & 0.31772134E-06_JPRB, 0.31772385E-06_JPRB, 0.31772333E-06_JPRB, 0.31772143E-06_JPRB, 0.31771813E-06_JPRB, 0.31771373E-06_JPRB, &
  & 0.31770884E-06_JPRB, 0.31770514E-06_JPRB, 0.31770310E-06_JPRB, 0.31770278E-06_JPRB, 0.31770367E-06_JPRB, 0.31770506E-06_JPRB, &
  & 0.31770605E-06_JPRB, 0.31770583E-06_JPRB, 0.31770284E-06_JPRB, 0.31769673E-06_JPRB, 0.31768784E-06_JPRB, 0.31768153E-06_JPRB, &
  & 0.31768377E-06_JPRB, 0.31769818E-06_JPRB, 0.31772441E-06_JPRB, 0.31775940E-06_JPRB, 0.31779908E-06_JPRB, 0.31783929E-06_JPRB, &
  & 0.31787613E-06_JPRB, 0.31790694E-06_JPRB, 0.31793041E-06_JPRB, 0.31794605E-06_JPRB, 0.31795483E-06_JPRB, 0.31795767E-06_JPRB, &
  & 0.31795520E-06_JPRB, 0.31794778E-06_JPRB, 0.31793559E-06_JPRB, 0.31791981E-06_JPRB, 0.31790171E-06_JPRB, 0.31788295E-06_JPRB, &
  & 0.31786470E-06_JPRB, 0.31784725E-06_JPRB, 0.31783125E-06_JPRB, 0.31781718E-06_JPRB, 0.31780647E-06_JPRB, 0.31780078E-06_JPRB, &
  & 0.31780132E-06_JPRB, 0.31780826E-06_JPRB, 0.31781948E-06_JPRB, 0.31783188E-06_JPRB, 0.31784242E-06_JPRB, 0.31784896E-06_JPRB, &
  & 0.31785154E-06_JPRB, 0.31785100E-06_JPRB, 0.31784890E-06_JPRB, 0.31784634E-06_JPRB, 0.31784390E-06_JPRB, 0.31784177E-06_JPRB, &
  & 0.31783975E-06_JPRB, 0.31783773E-06_JPRB, 0.31783560E-06_JPRB, 0.31783318E-06_JPRB, 0.31783054E-06_JPRB, 0.31782770E-06_JPRB, &
  & 0.31782486E-06_JPRB, 0.31782213E-06_JPRB, 0.31781906E-06_JPRB, 0.31781391E-06_JPRB /)

RGHG3(:,65, 1) = (/ &
  & 0.31774363E-06_JPRB, 0.31774624E-06_JPRB, 0.31774601E-06_JPRB, 0.31774445E-06_JPRB, 0.31774169E-06_JPRB, 0.31773777E-06_JPRB, &
  & 0.31773354E-06_JPRB, 0.31772998E-06_JPRB, 0.31772831E-06_JPRB, 0.31772845E-06_JPRB, 0.31773007E-06_JPRB, 0.31773229E-06_JPRB, &
  & 0.31773399E-06_JPRB, 0.31773402E-06_JPRB, 0.31773132E-06_JPRB, 0.31772575E-06_JPRB, 0.31771793E-06_JPRB, 0.31771299E-06_JPRB, &
  & 0.31771543E-06_JPRB, 0.31772876E-06_JPRB, 0.31775286E-06_JPRB, 0.31778487E-06_JPRB, 0.31782105E-06_JPRB, 0.31785765E-06_JPRB, &
  & 0.31789091E-06_JPRB, 0.31791865E-06_JPRB, 0.31793962E-06_JPRB, 0.31795352E-06_JPRB, 0.31796134E-06_JPRB, 0.31796370E-06_JPRB, &
  & 0.31796139E-06_JPRB, 0.31795452E-06_JPRB, 0.31794332E-06_JPRB, 0.31792851E-06_JPRB, 0.31791149E-06_JPRB, 0.31789347E-06_JPRB, &
  & 0.31787596E-06_JPRB, 0.31785919E-06_JPRB, 0.31784393E-06_JPRB, 0.31783080E-06_JPRB, 0.31782110E-06_JPRB, 0.31781630E-06_JPRB, &
  & 0.31781758E-06_JPRB, 0.31782463E-06_JPRB, 0.31783551E-06_JPRB, 0.31784720E-06_JPRB, 0.31785711E-06_JPRB, 0.31786345E-06_JPRB, &
  & 0.31786607E-06_JPRB, 0.31786550E-06_JPRB, 0.31786317E-06_JPRB, 0.31786021E-06_JPRB, 0.31785740E-06_JPRB, 0.31785481E-06_JPRB, &
  & 0.31785237E-06_JPRB, 0.31784998E-06_JPRB, 0.31784742E-06_JPRB, 0.31784469E-06_JPRB, 0.31784171E-06_JPRB, 0.31783856E-06_JPRB, &
  & 0.31783549E-06_JPRB, 0.31783239E-06_JPRB, 0.31782901E-06_JPRB, 0.31782307E-06_JPRB /)

RGHG3(:,66, 1) = (/ &
  & 0.31776392E-06_JPRB, 0.31776733E-06_JPRB, 0.31776750E-06_JPRB, 0.31776645E-06_JPRB, 0.31776420E-06_JPRB, 0.31776091E-06_JPRB, &
  & 0.31775713E-06_JPRB, 0.31775411E-06_JPRB, 0.31775286E-06_JPRB, 0.31775363E-06_JPRB, 0.31775593E-06_JPRB, 0.31775875E-06_JPRB, &
  & 0.31776079E-06_JPRB, 0.31776113E-06_JPRB, 0.31775892E-06_JPRB, 0.31775400E-06_JPRB, 0.31774707E-06_JPRB, 0.31774314E-06_JPRB, &
  & 0.31774584E-06_JPRB, 0.31775829E-06_JPRB, 0.31778029E-06_JPRB, 0.31780928E-06_JPRB, 0.31784202E-06_JPRB, 0.31787485E-06_JPRB, &
  & 0.31790472E-06_JPRB, 0.31792936E-06_JPRB, 0.31794798E-06_JPRB, 0.31796009E-06_JPRB, 0.31796691E-06_JPRB, 0.31796901E-06_JPRB, &
  & 0.31796691E-06_JPRB, 0.31796066E-06_JPRB, 0.31795042E-06_JPRB, 0.31793678E-06_JPRB, 0.31792084E-06_JPRB, 0.31790387E-06_JPRB, &
  & 0.31788727E-06_JPRB, 0.31787130E-06_JPRB, 0.31785686E-06_JPRB, 0.31784452E-06_JPRB, 0.31783577E-06_JPRB, 0.31783179E-06_JPRB, &
  & 0.31783344E-06_JPRB, 0.31784049E-06_JPRB, 0.31785092E-06_JPRB, 0.31786195E-06_JPRB, 0.31787121E-06_JPRB, 0.31787715E-06_JPRB, &
  & 0.31787982E-06_JPRB, 0.31787928E-06_JPRB, 0.31787687E-06_JPRB, 0.31787368E-06_JPRB, 0.31787042E-06_JPRB, 0.31786752E-06_JPRB, &
  & 0.31786468E-06_JPRB, 0.31786175E-06_JPRB, 0.31785879E-06_JPRB, 0.31785564E-06_JPRB, 0.31785231E-06_JPRB, 0.31784884E-06_JPRB, &
  & 0.31784541E-06_JPRB, 0.31784202E-06_JPRB, 0.31783793E-06_JPRB, 0.31783094E-06_JPRB /)

RGHG3(:,67, 1) = (/ &
  & 0.31778356E-06_JPRB, 0.31778751E-06_JPRB, 0.31778808E-06_JPRB, 0.31778745E-06_JPRB, 0.31778575E-06_JPRB, 0.31778305E-06_JPRB, &
  & 0.31777989E-06_JPRB, 0.31777745E-06_JPRB, 0.31777682E-06_JPRB, 0.31777824E-06_JPRB, 0.31778112E-06_JPRB, 0.31778427E-06_JPRB, &
  & 0.31778660E-06_JPRB, 0.31778717E-06_JPRB, 0.31778538E-06_JPRB, 0.31778126E-06_JPRB, 0.31777495E-06_JPRB, 0.31777245E-06_JPRB, &
  & 0.31777523E-06_JPRB, 0.31778657E-06_JPRB, 0.31780635E-06_JPRB, 0.31783236E-06_JPRB, 0.31786152E-06_JPRB, 0.31789077E-06_JPRB, &
  & 0.31791717E-06_JPRB, 0.31793905E-06_JPRB, 0.31795520E-06_JPRB, 0.31796600E-06_JPRB, 0.31797185E-06_JPRB, 0.31797356E-06_JPRB, &
  & 0.31797163E-06_JPRB, 0.31796606E-06_JPRB, 0.31795685E-06_JPRB, 0.31794437E-06_JPRB, 0.31792976E-06_JPRB, 0.31791396E-06_JPRB, &
  & 0.31789830E-06_JPRB, 0.31788329E-06_JPRB, 0.31786971E-06_JPRB, 0.31785842E-06_JPRB, 0.31785049E-06_JPRB, 0.31784708E-06_JPRB, &
  & 0.31784901E-06_JPRB, 0.31785586E-06_JPRB, 0.31786576E-06_JPRB, 0.31787599E-06_JPRB, 0.31788457E-06_JPRB, 0.31789020E-06_JPRB, &
  & 0.31789273E-06_JPRB, 0.31789227E-06_JPRB, 0.31788986E-06_JPRB, 0.31788662E-06_JPRB, 0.31788315E-06_JPRB, 0.31787985E-06_JPRB, &
  & 0.31787658E-06_JPRB, 0.31787337E-06_JPRB, 0.31786993E-06_JPRB, 0.31786647E-06_JPRB, 0.31786283E-06_JPRB, 0.31785908E-06_JPRB, &
  & 0.31785538E-06_JPRB, 0.31785140E-06_JPRB, 0.31784674E-06_JPRB, 0.31783782E-06_JPRB /)

RGHG3(:,68, 1) = (/ &
  & 0.31780175E-06_JPRB, 0.31780661E-06_JPRB, 0.31780775E-06_JPRB, 0.31780758E-06_JPRB, 0.31780638E-06_JPRB, 0.31780428E-06_JPRB, &
  & 0.31780192E-06_JPRB, 0.31780019E-06_JPRB, 0.31780021E-06_JPRB, 0.31780229E-06_JPRB, 0.31780542E-06_JPRB, 0.31780888E-06_JPRB, &
  & 0.31781138E-06_JPRB, 0.31781207E-06_JPRB, 0.31781062E-06_JPRB, 0.31780741E-06_JPRB, 0.31780132E-06_JPRB, 0.31779987E-06_JPRB, &
  & 0.31780246E-06_JPRB, 0.31781283E-06_JPRB, 0.31783063E-06_JPRB, 0.31785376E-06_JPRB, 0.31787957E-06_JPRB, 0.31790523E-06_JPRB, &
  & 0.31792857E-06_JPRB, 0.31794764E-06_JPRB, 0.31796174E-06_JPRB, 0.31797103E-06_JPRB, 0.31797614E-06_JPRB, 0.31797757E-06_JPRB, &
  & 0.31797572E-06_JPRB, 0.31797077E-06_JPRB, 0.31796259E-06_JPRB, 0.31795136E-06_JPRB, 0.31793800E-06_JPRB, 0.31792348E-06_JPRB, &
  & 0.31790898E-06_JPRB, 0.31789509E-06_JPRB, 0.31788250E-06_JPRB, 0.31787198E-06_JPRB, 0.31786490E-06_JPRB, 0.31786217E-06_JPRB, &
  & 0.31786416E-06_JPRB, 0.31787062E-06_JPRB, 0.31787982E-06_JPRB, 0.31788935E-06_JPRB, 0.31789730E-06_JPRB, 0.31790250E-06_JPRB, &
  & 0.31790489E-06_JPRB, 0.31790458E-06_JPRB, 0.31790222E-06_JPRB, 0.31789901E-06_JPRB, 0.31789540E-06_JPRB, 0.31789202E-06_JPRB, &
  & 0.31788852E-06_JPRB, 0.31788488E-06_JPRB, 0.31788124E-06_JPRB, 0.31787738E-06_JPRB, 0.31787357E-06_JPRB, 0.31786968E-06_JPRB, &
  & 0.31786567E-06_JPRB, 0.31786143E-06_JPRB, 0.31785555E-06_JPRB, 0.31784464E-06_JPRB /)

RGHG3(:,69, 1) = (/ &
  & 0.31781926E-06_JPRB, 0.31782514E-06_JPRB, 0.31782673E-06_JPRB, 0.31782710E-06_JPRB, 0.31782642E-06_JPRB, 0.31782497E-06_JPRB, &
  & 0.31782329E-06_JPRB, 0.31782241E-06_JPRB, 0.31782312E-06_JPRB, 0.31782577E-06_JPRB, 0.31782898E-06_JPRB, 0.31783247E-06_JPRB, &
  & 0.31783500E-06_JPRB, 0.31783583E-06_JPRB, 0.31783463E-06_JPRB, 0.31783230E-06_JPRB, 0.31782628E-06_JPRB, 0.31782596E-06_JPRB, &
  & 0.31782832E-06_JPRB, 0.31783745E-06_JPRB, 0.31785305E-06_JPRB, 0.31787337E-06_JPRB, 0.31789600E-06_JPRB, 0.31791853E-06_JPRB, &
  & 0.31793874E-06_JPRB, 0.31795540E-06_JPRB, 0.31796756E-06_JPRB, 0.31797560E-06_JPRB, 0.31797998E-06_JPRB, 0.31798109E-06_JPRB, &
  & 0.31797939E-06_JPRB, 0.31797495E-06_JPRB, 0.31796776E-06_JPRB, 0.31795773E-06_JPRB, 0.31794573E-06_JPRB, 0.31793255E-06_JPRB, &
  & 0.31791919E-06_JPRB, 0.31790651E-06_JPRB, 0.31789486E-06_JPRB, 0.31788548E-06_JPRB, 0.31787917E-06_JPRB, 0.31787690E-06_JPRB, &
  & 0.31787897E-06_JPRB, 0.31788497E-06_JPRB, 0.31789344E-06_JPRB, 0.31790216E-06_JPRB, 0.31790944E-06_JPRB, 0.31791424E-06_JPRB, &
  & 0.31791646E-06_JPRB, 0.31791618E-06_JPRB, 0.31791393E-06_JPRB, 0.31791089E-06_JPRB, 0.31790722E-06_JPRB, 0.31790381E-06_JPRB, &
  & 0.31790009E-06_JPRB, 0.31789648E-06_JPRB, 0.31789259E-06_JPRB, 0.31788878E-06_JPRB, 0.31788491E-06_JPRB, 0.31788090E-06_JPRB, &
  & 0.31787681E-06_JPRB, 0.31787198E-06_JPRB, 0.31786527E-06_JPRB, 0.31785166E-06_JPRB /)

RGHG3(:,70, 1) = (/ &
  & 0.31783586E-06_JPRB, 0.31784296E-06_JPRB, 0.31784529E-06_JPRB, 0.31784617E-06_JPRB, 0.31784600E-06_JPRB, 0.31784515E-06_JPRB, &
  & 0.31784435E-06_JPRB, 0.31784424E-06_JPRB, 0.31784558E-06_JPRB, 0.31784845E-06_JPRB, 0.31785171E-06_JPRB, 0.31785515E-06_JPRB, &
  & 0.31785757E-06_JPRB, 0.31785839E-06_JPRB, 0.31785731E-06_JPRB, 0.31785555E-06_JPRB, 0.31784981E-06_JPRB, 0.31784987E-06_JPRB, &
  & 0.31785163E-06_JPRB, 0.31785976E-06_JPRB, 0.31787351E-06_JPRB, 0.31789125E-06_JPRB, 0.31791100E-06_JPRB, 0.31793047E-06_JPRB, &
  & 0.31794801E-06_JPRB, 0.31796228E-06_JPRB, 0.31797271E-06_JPRB, 0.31797967E-06_JPRB, 0.31798328E-06_JPRB, 0.31798425E-06_JPRB, &
  & 0.31798263E-06_JPRB, 0.31797879E-06_JPRB, 0.31797242E-06_JPRB, 0.31796350E-06_JPRB, 0.31795292E-06_JPRB, 0.31794110E-06_JPRB, &
  & 0.31792899E-06_JPRB, 0.31791751E-06_JPRB, 0.31790694E-06_JPRB, 0.31789864E-06_JPRB, 0.31789310E-06_JPRB, 0.31789131E-06_JPRB, &
  & 0.31789332E-06_JPRB, 0.31789892E-06_JPRB, 0.31790660E-06_JPRB, 0.31791453E-06_JPRB, 0.31792109E-06_JPRB, 0.31792544E-06_JPRB, &
  & 0.31792752E-06_JPRB, 0.31792720E-06_JPRB, 0.31792507E-06_JPRB, 0.31792229E-06_JPRB, 0.31791873E-06_JPRB, 0.31791544E-06_JPRB, &
  & 0.31791171E-06_JPRB, 0.31790816E-06_JPRB, 0.31790432E-06_JPRB, 0.31790057E-06_JPRB, 0.31789679E-06_JPRB, 0.31789284E-06_JPRB, &
  & 0.31788872E-06_JPRB, 0.31788372E-06_JPRB, 0.31787604E-06_JPRB, 0.31786027E-06_JPRB /)

RGHG3(:,71, 1) = (/ &
  & 0.31785208E-06_JPRB, 0.31786067E-06_JPRB, 0.31786360E-06_JPRB, 0.31786504E-06_JPRB, 0.31786530E-06_JPRB, 0.31786504E-06_JPRB, &
  & 0.31786499E-06_JPRB, 0.31786561E-06_JPRB, 0.31786743E-06_JPRB, 0.31787039E-06_JPRB, 0.31787357E-06_JPRB, 0.31787661E-06_JPRB, &
  & 0.31787889E-06_JPRB, 0.31787957E-06_JPRB, 0.31787860E-06_JPRB, 0.31787695E-06_JPRB, 0.31787204E-06_JPRB, 0.31787212E-06_JPRB, &
  & 0.31787363E-06_JPRB, 0.31788056E-06_JPRB, 0.31789233E-06_JPRB, 0.31790768E-06_JPRB, 0.31792445E-06_JPRB, 0.31794130E-06_JPRB, &
  & 0.31795608E-06_JPRB, 0.31796847E-06_JPRB, 0.31797731E-06_JPRB, 0.31798334E-06_JPRB, 0.31798629E-06_JPRB, 0.31798706E-06_JPRB, &
  & 0.31798555E-06_JPRB, 0.31798217E-06_JPRB, 0.31797663E-06_JPRB, 0.31796893E-06_JPRB, 0.31795969E-06_JPRB, 0.31794923E-06_JPRB, &
  & 0.31793829E-06_JPRB, 0.31792814E-06_JPRB, 0.31791865E-06_JPRB, 0.31791137E-06_JPRB, 0.31790657E-06_JPRB, 0.31790537E-06_JPRB, &
  & 0.31790722E-06_JPRB, 0.31791222E-06_JPRB, 0.31791922E-06_JPRB, 0.31792635E-06_JPRB, 0.31793221E-06_JPRB, 0.31793599E-06_JPRB, &
  & 0.31793786E-06_JPRB, 0.31793763E-06_JPRB, 0.31793570E-06_JPRB, 0.31793323E-06_JPRB, 0.31792985E-06_JPRB, 0.31792692E-06_JPRB, &
  & 0.31792331E-06_JPRB, 0.31792004E-06_JPRB, 0.31791632E-06_JPRB, 0.31791288E-06_JPRB, 0.31790921E-06_JPRB, 0.31790535E-06_JPRB, &
  & 0.31790137E-06_JPRB, 0.31789634E-06_JPRB, 0.31788832E-06_JPRB, 0.31787107E-06_JPRB /)

RGHG3(:,72, 1) = (/ &
  & 0.31786826E-06_JPRB, 0.31787829E-06_JPRB, 0.31788181E-06_JPRB, 0.31788369E-06_JPRB, 0.31788443E-06_JPRB, 0.31788460E-06_JPRB, &
  & 0.31788525E-06_JPRB, 0.31788639E-06_JPRB, 0.31788858E-06_JPRB, 0.31789145E-06_JPRB, 0.31789418E-06_JPRB, 0.31789696E-06_JPRB, &
  & 0.31789884E-06_JPRB, 0.31789938E-06_JPRB, 0.31789841E-06_JPRB, 0.31789665E-06_JPRB, 0.31789273E-06_JPRB, 0.31789224E-06_JPRB, &
  & 0.31789341E-06_JPRB, 0.31789941E-06_JPRB, 0.31790950E-06_JPRB, 0.31792248E-06_JPRB, 0.31793667E-06_JPRB, 0.31795105E-06_JPRB, &
  & 0.31796353E-06_JPRB, 0.31797393E-06_JPRB, 0.31798135E-06_JPRB, 0.31798658E-06_JPRB, 0.31798896E-06_JPRB, 0.31798959E-06_JPRB, &
  & 0.31798814E-06_JPRB, 0.31798527E-06_JPRB, 0.31798047E-06_JPRB, 0.31797390E-06_JPRB, 0.31796594E-06_JPRB, 0.31795682E-06_JPRB, &
  & 0.31794727E-06_JPRB, 0.31793834E-06_JPRB, 0.31792996E-06_JPRB, 0.31792376E-06_JPRB, 0.31791976E-06_JPRB, 0.31791896E-06_JPRB, &
  & 0.31792061E-06_JPRB, 0.31792496E-06_JPRB, 0.31793124E-06_JPRB, 0.31793766E-06_JPRB, 0.31794269E-06_JPRB, 0.31794605E-06_JPRB, &
  & 0.31794775E-06_JPRB, 0.31794752E-06_JPRB, 0.31794579E-06_JPRB, 0.31794357E-06_JPRB, 0.31794050E-06_JPRB, 0.31793792E-06_JPRB, &
  & 0.31793471E-06_JPRB, 0.31793164E-06_JPRB, 0.31792837E-06_JPRB, 0.31792507E-06_JPRB, 0.31792194E-06_JPRB, 0.31791822E-06_JPRB, &
  & 0.31791461E-06_JPRB, 0.31790967E-06_JPRB, 0.31790151E-06_JPRB, 0.31788358E-06_JPRB /)

RGHG3(:,73, 1) = (/ &
  & 0.31788636E-06_JPRB, 0.31789642E-06_JPRB, 0.31790003E-06_JPRB, 0.31790211E-06_JPRB, 0.31790307E-06_JPRB, 0.31790358E-06_JPRB, &
  & 0.31790472E-06_JPRB, 0.31790628E-06_JPRB, 0.31790856E-06_JPRB, 0.31791112E-06_JPRB, 0.31791365E-06_JPRB, 0.31791566E-06_JPRB, &
  & 0.31791740E-06_JPRB, 0.31791782E-06_JPRB, 0.31791674E-06_JPRB, 0.31791478E-06_JPRB, 0.31791166E-06_JPRB, 0.31791106E-06_JPRB, &
  & 0.31791191E-06_JPRB, 0.31791686E-06_JPRB, 0.31792524E-06_JPRB, 0.31793604E-06_JPRB, 0.31794775E-06_JPRB, 0.31795980E-06_JPRB, &
  & 0.31796998E-06_JPRB, 0.31797876E-06_JPRB, 0.31798493E-06_JPRB, 0.31798945E-06_JPRB, 0.31799124E-06_JPRB, 0.31799181E-06_JPRB, &
  & 0.31799033E-06_JPRB, 0.31798785E-06_JPRB, 0.31798385E-06_JPRB, 0.31797856E-06_JPRB, 0.31797180E-06_JPRB, 0.31796401E-06_JPRB, &
  & 0.31795571E-06_JPRB, 0.31794818E-06_JPRB, 0.31794076E-06_JPRB, 0.31793567E-06_JPRB, 0.31793229E-06_JPRB, 0.31793195E-06_JPRB, &
  & 0.31793331E-06_JPRB, 0.31793712E-06_JPRB, 0.31794264E-06_JPRB, 0.31794821E-06_JPRB, 0.31795258E-06_JPRB, 0.31795543E-06_JPRB, &
  & 0.31795699E-06_JPRB, 0.31795679E-06_JPRB, 0.31795526E-06_JPRB, 0.31795338E-06_JPRB, 0.31795051E-06_JPRB, 0.31794843E-06_JPRB, &
  & 0.31794542E-06_JPRB, 0.31794289E-06_JPRB, 0.31793988E-06_JPRB, 0.31793726E-06_JPRB, 0.31793437E-06_JPRB, 0.31793121E-06_JPRB, &
  & 0.31792780E-06_JPRB, 0.31792325E-06_JPRB, 0.31791524E-06_JPRB, 0.31789705E-06_JPRB /)

RGHG3(:,74, 1) = (/ &
  & 0.31790421E-06_JPRB, 0.31791430E-06_JPRB, 0.31791768E-06_JPRB, 0.31791990E-06_JPRB, 0.31792092E-06_JPRB, 0.31792163E-06_JPRB, &
  & 0.31792302E-06_JPRB, 0.31792467E-06_JPRB, 0.31792683E-06_JPRB, 0.31792922E-06_JPRB, 0.31793107E-06_JPRB, 0.31793300E-06_JPRB, &
  & 0.31793434E-06_JPRB, 0.31793468E-06_JPRB, 0.31793348E-06_JPRB, 0.31793141E-06_JPRB, 0.31792885E-06_JPRB, 0.31792814E-06_JPRB, &
  & 0.31792851E-06_JPRB, 0.31793275E-06_JPRB, 0.31793957E-06_JPRB, 0.31794823E-06_JPRB, 0.31795767E-06_JPRB, 0.31796770E-06_JPRB, &
  & 0.31797578E-06_JPRB, 0.31798311E-06_JPRB, 0.31798811E-06_JPRB, 0.31799209E-06_JPRB, 0.31799328E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799249E-06_JPRB, 0.31799036E-06_JPRB, 0.31798695E-06_JPRB, 0.31798268E-06_JPRB, 0.31797725E-06_JPRB, 0.31797080E-06_JPRB, &
  & 0.31796378E-06_JPRB, 0.31795761E-06_JPRB, 0.31795111E-06_JPRB, 0.31794715E-06_JPRB, 0.31794434E-06_JPRB, 0.31794445E-06_JPRB, &
  & 0.31794534E-06_JPRB, 0.31794838E-06_JPRB, 0.31795318E-06_JPRB, 0.31795810E-06_JPRB, 0.31796171E-06_JPRB, 0.31796409E-06_JPRB, &
  & 0.31796549E-06_JPRB, 0.31796534E-06_JPRB, 0.31796398E-06_JPRB, 0.31796245E-06_JPRB, 0.31795986E-06_JPRB, 0.31795815E-06_JPRB, &
  & 0.31795560E-06_JPRB, 0.31795329E-06_JPRB, 0.31795093E-06_JPRB, 0.31794869E-06_JPRB, 0.31794656E-06_JPRB, 0.31794357E-06_JPRB, &
  & 0.31794087E-06_JPRB, 0.31793655E-06_JPRB, 0.31792888E-06_JPRB, 0.31791126E-06_JPRB /)

RGHG3(:,75, 1) = (/ &
  & 0.31792169E-06_JPRB, 0.31793138E-06_JPRB, 0.31793451E-06_JPRB, 0.31793672E-06_JPRB, 0.31793766E-06_JPRB, 0.31793832E-06_JPRB, &
  & 0.31793991E-06_JPRB, 0.31794150E-06_JPRB, 0.31794349E-06_JPRB, 0.31794542E-06_JPRB, 0.31794715E-06_JPRB, 0.31794849E-06_JPRB, &
  & 0.31794991E-06_JPRB, 0.31795003E-06_JPRB, 0.31794858E-06_JPRB, 0.31794656E-06_JPRB, 0.31794454E-06_JPRB, 0.31794386E-06_JPRB, &
  & 0.31794383E-06_JPRB, 0.31794735E-06_JPRB, 0.31795261E-06_JPRB, 0.31795938E-06_JPRB, 0.31796668E-06_JPRB, 0.31797487E-06_JPRB, &
  & 0.31798101E-06_JPRB, 0.31798695E-06_JPRB, 0.31799087E-06_JPRB, 0.31799445E-06_JPRB, 0.31799505E-06_JPRB, 0.31799570E-06_JPRB, &
  & 0.31799428E-06_JPRB, 0.31799257E-06_JPRB, 0.31798970E-06_JPRB, 0.31798652E-06_JPRB, 0.31798228E-06_JPRB, 0.31797720E-06_JPRB, &
  & 0.31797143E-06_JPRB, 0.31796668E-06_JPRB, 0.31796100E-06_JPRB, 0.31795813E-06_JPRB, 0.31795577E-06_JPRB, 0.31795634E-06_JPRB, &
  & 0.31795656E-06_JPRB, 0.31795869E-06_JPRB, 0.31796293E-06_JPRB, 0.31796711E-06_JPRB, 0.31797018E-06_JPRB, 0.31797208E-06_JPRB, &
  & 0.31797333E-06_JPRB, 0.31797319E-06_JPRB, 0.31797200E-06_JPRB, 0.31797089E-06_JPRB, 0.31796822E-06_JPRB, 0.31796711E-06_JPRB, &
  & 0.31796466E-06_JPRB, 0.31796299E-06_JPRB, 0.31796088E-06_JPRB, 0.31795955E-06_JPRB, 0.31795798E-06_JPRB, 0.31795565E-06_JPRB, &
  & 0.31795338E-06_JPRB, 0.31794943E-06_JPRB, 0.31794241E-06_JPRB, 0.31792572E-06_JPRB /)

RGHG3(:,76, 1) = (/ &
  & 0.31793832E-06_JPRB, 0.31794775E-06_JPRB, 0.31795025E-06_JPRB, 0.31795250E-06_JPRB, 0.31795309E-06_JPRB, 0.31795352E-06_JPRB, &
  & 0.31795528E-06_JPRB, 0.31795668E-06_JPRB, 0.31795827E-06_JPRB, 0.31796006E-06_JPRB, 0.31796114E-06_JPRB, 0.31796242E-06_JPRB, &
  & 0.31796361E-06_JPRB, 0.31796387E-06_JPRB, 0.31796230E-06_JPRB, 0.31796017E-06_JPRB, 0.31795872E-06_JPRB, 0.31795813E-06_JPRB, &
  & 0.31795756E-06_JPRB, 0.31796060E-06_JPRB, 0.31796446E-06_JPRB, 0.31796941E-06_JPRB, 0.31797475E-06_JPRB, 0.31798126E-06_JPRB, &
  & 0.31798564E-06_JPRB, 0.31799038E-06_JPRB, 0.31799328E-06_JPRB, 0.31799652E-06_JPRB, 0.31799661E-06_JPRB, 0.31799735E-06_JPRB, &
  & 0.31799587E-06_JPRB, 0.31799448E-06_JPRB, 0.31799217E-06_JPRB, 0.31798999E-06_JPRB, 0.31798695E-06_JPRB, 0.31798325E-06_JPRB, &
  & 0.31797856E-06_JPRB, 0.31797521E-06_JPRB, 0.31797009E-06_JPRB, 0.31796841E-06_JPRB, 0.31796654E-06_JPRB, 0.31796750E-06_JPRB, &
  & 0.31796694E-06_JPRB, 0.31796822E-06_JPRB, 0.31797182E-06_JPRB, 0.31797549E-06_JPRB, 0.31797791E-06_JPRB, 0.31797927E-06_JPRB, &
  & 0.31798041E-06_JPRB, 0.31798032E-06_JPRB, 0.31797919E-06_JPRB, 0.31797856E-06_JPRB, 0.31797589E-06_JPRB, 0.31797529E-06_JPRB, &
  & 0.31797302E-06_JPRB, 0.31797171E-06_JPRB, 0.31797020E-06_JPRB, 0.31796964E-06_JPRB, 0.31796893E-06_JPRB, 0.31796696E-06_JPRB, &
  & 0.31796537E-06_JPRB, 0.31796171E-06_JPRB, 0.31795551E-06_JPRB, 0.31794036E-06_JPRB /)

RGHG3(:,77, 1) = (/ &
  & 0.31795449E-06_JPRB, 0.31796301E-06_JPRB, 0.31796483E-06_JPRB, 0.31796702E-06_JPRB, 0.31796728E-06_JPRB, 0.31796722E-06_JPRB, &
  & 0.31796918E-06_JPRB, 0.31797020E-06_JPRB, 0.31797143E-06_JPRB, 0.31797290E-06_JPRB, 0.31797350E-06_JPRB, 0.31797433E-06_JPRB, &
  & 0.31797580E-06_JPRB, 0.31797620E-06_JPRB, 0.31797441E-06_JPRB, 0.31797239E-06_JPRB, 0.31797154E-06_JPRB, 0.31797117E-06_JPRB, &
  & 0.31797001E-06_JPRB, 0.31797265E-06_JPRB, 0.31797521E-06_JPRB, 0.31797845E-06_JPRB, 0.31798191E-06_JPRB, 0.31798692E-06_JPRB, &
  & 0.31798965E-06_JPRB, 0.31799348E-06_JPRB, 0.31799541E-06_JPRB, 0.31799837E-06_JPRB, 0.31799792E-06_JPRB, 0.31799880E-06_JPRB, &
  & 0.31799721E-06_JPRB, 0.31799618E-06_JPRB, 0.31799425E-06_JPRB, 0.31799303E-06_JPRB, 0.31799127E-06_JPRB, 0.31798885E-06_JPRB, &
  & 0.31798521E-06_JPRB, 0.31798322E-06_JPRB, 0.31797867E-06_JPRB, 0.31797813E-06_JPRB, 0.31797651E-06_JPRB, 0.31797796E-06_JPRB, &
  & 0.31797651E-06_JPRB, 0.31797680E-06_JPRB, 0.31797995E-06_JPRB, 0.31798302E-06_JPRB, 0.31798493E-06_JPRB, 0.31798567E-06_JPRB, &
  & 0.31798680E-06_JPRB, 0.31798677E-06_JPRB, 0.31798567E-06_JPRB, 0.31798550E-06_JPRB, 0.31798251E-06_JPRB, 0.31798277E-06_JPRB, &
  & 0.31798041E-06_JPRB, 0.31797967E-06_JPRB, 0.31797845E-06_JPRB, 0.31797885E-06_JPRB, 0.31797902E-06_JPRB, 0.31797751E-06_JPRB, &
  & 0.31797668E-06_JPRB, 0.31797330E-06_JPRB, 0.31796799E-06_JPRB, 0.31795480E-06_JPRB /)

RGHG3(:,78, 1) = (/ &
  & 0.31796975E-06_JPRB, 0.31797666E-06_JPRB, 0.31797725E-06_JPRB, 0.31797947E-06_JPRB, 0.31797930E-06_JPRB, 0.31797867E-06_JPRB, &
  & 0.31798089E-06_JPRB, 0.31798143E-06_JPRB, 0.31798220E-06_JPRB, 0.31798345E-06_JPRB, 0.31798334E-06_JPRB, 0.31798390E-06_JPRB, &
  & 0.31798561E-06_JPRB, 0.31798643E-06_JPRB, 0.31798450E-06_JPRB, 0.31798251E-06_JPRB, 0.31798231E-06_JPRB, 0.31798226E-06_JPRB, &
  & 0.31798055E-06_JPRB, 0.31798299E-06_JPRB, 0.31798433E-06_JPRB, 0.31798609E-06_JPRB, 0.31798777E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799601E-06_JPRB, 0.31799726E-06_JPRB, 0.31799988E-06_JPRB, 0.31799900E-06_JPRB, 0.31800002E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799760E-06_JPRB, 0.31799593E-06_JPRB, 0.31799561E-06_JPRB, 0.31799499E-06_JPRB, 0.31799371E-06_JPRB, &
  & 0.31799095E-06_JPRB, 0.31799030E-06_JPRB, 0.31798609E-06_JPRB, 0.31798669E-06_JPRB, 0.31798521E-06_JPRB, 0.31798706E-06_JPRB, &
  & 0.31798461E-06_JPRB, 0.31798405E-06_JPRB, 0.31798677E-06_JPRB, 0.31798947E-06_JPRB, 0.31799087E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799212E-06_JPRB, 0.31799095E-06_JPRB, 0.31799132E-06_JPRB, 0.31798791E-06_JPRB, 0.31798902E-06_JPRB, &
  & 0.31798663E-06_JPRB, 0.31798638E-06_JPRB, 0.31798544E-06_JPRB, 0.31798666E-06_JPRB, 0.31798766E-06_JPRB, 0.31798655E-06_JPRB, &
  & 0.31798641E-06_JPRB, 0.31798325E-06_JPRB, 0.31797916E-06_JPRB, 0.31796884E-06_JPRB /)

RGHG3(:,79, 1) = (/ &
  & 0.31797981E-06_JPRB, 0.31798442E-06_JPRB, 0.31798385E-06_JPRB, 0.31798595E-06_JPRB, 0.31798544E-06_JPRB, 0.31798444E-06_JPRB, &
  & 0.31798703E-06_JPRB, 0.31798731E-06_JPRB, 0.31798783E-06_JPRB, 0.31798913E-06_JPRB, 0.31798865E-06_JPRB, 0.31798899E-06_JPRB, &
  & 0.31799104E-06_JPRB, 0.31799212E-06_JPRB, 0.31798993E-06_JPRB, 0.31798783E-06_JPRB, 0.31798811E-06_JPRB, 0.31798825E-06_JPRB, &
  & 0.31798604E-06_JPRB, 0.31798857E-06_JPRB, 0.31798922E-06_JPRB, 0.31799007E-06_JPRB, 0.31799081E-06_JPRB, 0.31799405E-06_JPRB, &
  & 0.31799468E-06_JPRB, 0.31799743E-06_JPRB, 0.31799823E-06_JPRB, 0.31800093E-06_JPRB, 0.31799971E-06_JPRB, 0.31800087E-06_JPRB, &
  & 0.31799900E-06_JPRB, 0.31799843E-06_JPRB, 0.31799669E-06_JPRB, 0.31799701E-06_JPRB, 0.31799701E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799419E-06_JPRB, 0.31799442E-06_JPRB, 0.31799004E-06_JPRB, 0.31799135E-06_JPRB, 0.31798987E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31798896E-06_JPRB, 0.31798771E-06_JPRB, 0.31799038E-06_JPRB, 0.31799300E-06_JPRB, 0.31799419E-06_JPRB, 0.31799391E-06_JPRB, &
  & 0.31799519E-06_JPRB, 0.31799507E-06_JPRB, 0.31799385E-06_JPRB, 0.31799459E-06_JPRB, 0.31799058E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31798967E-06_JPRB, 0.31798967E-06_JPRB, 0.31798888E-06_JPRB, 0.31799078E-06_JPRB, 0.31799232E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799178E-06_JPRB, 0.31798865E-06_JPRB, 0.31798541E-06_JPRB, 0.31797762E-06_JPRB /)

RGHG3(:,80, 1) = (/ &
  & 0.31798672E-06_JPRB, 0.31798822E-06_JPRB, 0.31798675E-06_JPRB, 0.31798882E-06_JPRB, 0.31798811E-06_JPRB, 0.31798686E-06_JPRB, &
  & 0.31798979E-06_JPRB, 0.31798999E-06_JPRB, 0.31799044E-06_JPRB, 0.31799175E-06_JPRB, 0.31799107E-06_JPRB, 0.31799138E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799496E-06_JPRB, 0.31799249E-06_JPRB, 0.31799021E-06_JPRB, 0.31799073E-06_JPRB, 0.31799095E-06_JPRB, &
  & 0.31798839E-06_JPRB, 0.31799109E-06_JPRB, 0.31799141E-06_JPRB, 0.31799186E-06_JPRB, 0.31799203E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799536E-06_JPRB, 0.31799811E-06_JPRB, 0.31799868E-06_JPRB, 0.31800155E-06_JPRB, 0.31800005E-06_JPRB, 0.31800136E-06_JPRB, &
  & 0.31799931E-06_JPRB, 0.31799883E-06_JPRB, 0.31799701E-06_JPRB, 0.31799766E-06_JPRB, 0.31799806E-06_JPRB, 0.31799809E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799641E-06_JPRB, 0.31799181E-06_JPRB, 0.31799362E-06_JPRB, 0.31799203E-06_JPRB, 0.31799453E-06_JPRB, &
  & 0.31799090E-06_JPRB, 0.31798928E-06_JPRB, 0.31799192E-06_JPRB, 0.31799465E-06_JPRB, 0.31799567E-06_JPRB, 0.31799522E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799649E-06_JPRB, 0.31799519E-06_JPRB, 0.31799610E-06_JPRB, 0.31799166E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799090E-06_JPRB, 0.31799107E-06_JPRB, 0.31799024E-06_JPRB, 0.31799260E-06_JPRB, 0.31799448E-06_JPRB, 0.31799371E-06_JPRB, &
  & 0.31799431E-06_JPRB, 0.31799107E-06_JPRB, 0.31798839E-06_JPRB, 0.31798308E-06_JPRB /)

RGHG3(:,81, 1) = (/ &
  & 0.31799161E-06_JPRB, 0.31798993E-06_JPRB, 0.31798794E-06_JPRB, 0.31799007E-06_JPRB, 0.31798930E-06_JPRB, 0.31798788E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31799104E-06_JPRB, 0.31799146E-06_JPRB, 0.31799300E-06_JPRB, 0.31799220E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799499E-06_JPRB, 0.31799635E-06_JPRB, 0.31799360E-06_JPRB, 0.31799121E-06_JPRB, 0.31799186E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31798945E-06_JPRB, 0.31799223E-06_JPRB, 0.31799235E-06_JPRB, 0.31799257E-06_JPRB, 0.31799252E-06_JPRB, 0.31799547E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799848E-06_JPRB, 0.31799897E-06_JPRB, 0.31800190E-06_JPRB, 0.31800022E-06_JPRB, 0.31800158E-06_JPRB, &
  & 0.31799951E-06_JPRB, 0.31799894E-06_JPRB, 0.31799706E-06_JPRB, 0.31799789E-06_JPRB, 0.31799854E-06_JPRB, 0.31799874E-06_JPRB, &
  & 0.31799655E-06_JPRB, 0.31799729E-06_JPRB, 0.31799266E-06_JPRB, 0.31799470E-06_JPRB, 0.31799311E-06_JPRB, 0.31799576E-06_JPRB, &
  & 0.31799166E-06_JPRB, 0.31798979E-06_JPRB, 0.31799266E-06_JPRB, 0.31799541E-06_JPRB, 0.31799641E-06_JPRB, 0.31799578E-06_JPRB, &
  & 0.31799726E-06_JPRB, 0.31799723E-06_JPRB, 0.31799573E-06_JPRB, 0.31799675E-06_JPRB, 0.31799200E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799135E-06_JPRB, 0.31799163E-06_JPRB, 0.31799084E-06_JPRB, 0.31799334E-06_JPRB, 0.31799556E-06_JPRB, 0.31799476E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799217E-06_JPRB, 0.31798967E-06_JPRB, 0.31798658E-06_JPRB /)

RGHG3(:,82, 1) = (/ &
  & 0.31799203E-06_JPRB, 0.31799050E-06_JPRB, 0.31798842E-06_JPRB, 0.31799070E-06_JPRB, 0.31798984E-06_JPRB, 0.31798831E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799166E-06_JPRB, 0.31799217E-06_JPRB, 0.31799360E-06_JPRB, 0.31799271E-06_JPRB, 0.31799300E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799712E-06_JPRB, 0.31799419E-06_JPRB, 0.31799172E-06_JPRB, 0.31799246E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31798984E-06_JPRB, 0.31799283E-06_JPRB, 0.31799286E-06_JPRB, 0.31799289E-06_JPRB, 0.31799277E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799865E-06_JPRB, 0.31799908E-06_JPRB, 0.31800209E-06_JPRB, 0.31800030E-06_JPRB, 0.31800181E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31799905E-06_JPRB, 0.31799712E-06_JPRB, 0.31799803E-06_JPRB, 0.31799877E-06_JPRB, 0.31799911E-06_JPRB, &
  & 0.31799703E-06_JPRB, 0.31799777E-06_JPRB, 0.31799317E-06_JPRB, 0.31799522E-06_JPRB, 0.31799365E-06_JPRB, 0.31799638E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31798999E-06_JPRB, 0.31799291E-06_JPRB, 0.31799576E-06_JPRB, 0.31799678E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799760E-06_JPRB, 0.31799760E-06_JPRB, 0.31799601E-06_JPRB, 0.31799712E-06_JPRB, 0.31799217E-06_JPRB, 0.31799482E-06_JPRB, &
  & 0.31799152E-06_JPRB, 0.31799198E-06_JPRB, 0.31799104E-06_JPRB, 0.31799374E-06_JPRB, 0.31799607E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799621E-06_JPRB, 0.31799266E-06_JPRB, 0.31799010E-06_JPRB, 0.31798680E-06_JPRB /)

RGHG3(:,83, 1) = (/ &
  & 0.31799235E-06_JPRB, 0.31799084E-06_JPRB, 0.31798874E-06_JPRB, 0.31799107E-06_JPRB, 0.31799024E-06_JPRB, 0.31798862E-06_JPRB, &
  & 0.31799186E-06_JPRB, 0.31799206E-06_JPRB, 0.31799237E-06_JPRB, 0.31799402E-06_JPRB, 0.31799311E-06_JPRB, 0.31799345E-06_JPRB, &
  & 0.31799601E-06_JPRB, 0.31799755E-06_JPRB, 0.31799456E-06_JPRB, 0.31799195E-06_JPRB, 0.31799283E-06_JPRB, 0.31799323E-06_JPRB, &
  & 0.31799016E-06_JPRB, 0.31799311E-06_JPRB, 0.31799308E-06_JPRB, 0.31799308E-06_JPRB, 0.31799289E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799877E-06_JPRB, 0.31799919E-06_JPRB, 0.31800224E-06_JPRB, 0.31800036E-06_JPRB, 0.31800192E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31799902E-06_JPRB, 0.31799709E-06_JPRB, 0.31799811E-06_JPRB, 0.31799894E-06_JPRB, 0.31799925E-06_JPRB, &
  & 0.31799732E-06_JPRB, 0.31799797E-06_JPRB, 0.31799351E-06_JPRB, 0.31799556E-06_JPRB, 0.31799402E-06_JPRB, 0.31799675E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31798999E-06_JPRB, 0.31799311E-06_JPRB, 0.31799598E-06_JPRB, 0.31799701E-06_JPRB, 0.31799630E-06_JPRB, &
  & 0.31799792E-06_JPRB, 0.31799783E-06_JPRB, 0.31799618E-06_JPRB, 0.31799732E-06_JPRB, 0.31799223E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799206E-06_JPRB, 0.31799112E-06_JPRB, 0.31799394E-06_JPRB, 0.31799635E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799291E-06_JPRB, 0.31799033E-06_JPRB, 0.31798695E-06_JPRB /)

RGHG3(:,84, 1) = (/ &
  & 0.31799257E-06_JPRB, 0.31799107E-06_JPRB, 0.31798891E-06_JPRB, 0.31799132E-06_JPRB, 0.31799044E-06_JPRB, 0.31798871E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31799223E-06_JPRB, 0.31799280E-06_JPRB, 0.31799411E-06_JPRB, 0.31799331E-06_JPRB, 0.31799368E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799777E-06_JPRB, 0.31799485E-06_JPRB, 0.31799215E-06_JPRB, 0.31799297E-06_JPRB, 0.31799337E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31799345E-06_JPRB, 0.31799323E-06_JPRB, 0.31799311E-06_JPRB, 0.31799289E-06_JPRB, 0.31799581E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799877E-06_JPRB, 0.31799919E-06_JPRB, 0.31800241E-06_JPRB, 0.31800042E-06_JPRB, 0.31800204E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31799908E-06_JPRB, 0.31799706E-06_JPRB, 0.31799817E-06_JPRB, 0.31799902E-06_JPRB, 0.31799937E-06_JPRB, &
  & 0.31799749E-06_JPRB, 0.31799809E-06_JPRB, 0.31799382E-06_JPRB, 0.31799578E-06_JPRB, 0.31799425E-06_JPRB, 0.31799698E-06_JPRB, &
  & 0.31799240E-06_JPRB, 0.31798993E-06_JPRB, 0.31799308E-06_JPRB, 0.31799613E-06_JPRB, 0.31799718E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799794E-06_JPRB, 0.31799627E-06_JPRB, 0.31799743E-06_JPRB, 0.31799220E-06_JPRB, 0.31799510E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799209E-06_JPRB, 0.31799112E-06_JPRB, 0.31799402E-06_JPRB, 0.31799664E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799695E-06_JPRB, 0.31799308E-06_JPRB, 0.31799038E-06_JPRB, 0.31798695E-06_JPRB /)

RGHG3(:,85, 1) = (/ &
  & 0.31799274E-06_JPRB, 0.31799118E-06_JPRB, 0.31798902E-06_JPRB, 0.31799152E-06_JPRB, 0.31799067E-06_JPRB, 0.31798891E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799243E-06_JPRB, 0.31799294E-06_JPRB, 0.31799419E-06_JPRB, 0.31799374E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799777E-06_JPRB, 0.31799505E-06_JPRB, 0.31799232E-06_JPRB, 0.31799314E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799038E-06_JPRB, 0.31799348E-06_JPRB, 0.31799331E-06_JPRB, 0.31799320E-06_JPRB, 0.31799286E-06_JPRB, 0.31799581E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799885E-06_JPRB, 0.31799919E-06_JPRB, 0.31800255E-06_JPRB, 0.31800045E-06_JPRB, 0.31800212E-06_JPRB, &
  & 0.31799965E-06_JPRB, 0.31799908E-06_JPRB, 0.31799703E-06_JPRB, 0.31799826E-06_JPRB, 0.31799905E-06_JPRB, 0.31799942E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799823E-06_JPRB, 0.31799399E-06_JPRB, 0.31799595E-06_JPRB, 0.31799448E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31799229E-06_JPRB, 0.31798982E-06_JPRB, 0.31799311E-06_JPRB, 0.31799618E-06_JPRB, 0.31799735E-06_JPRB, 0.31799649E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31799803E-06_JPRB, 0.31799635E-06_JPRB, 0.31799752E-06_JPRB, 0.31799215E-06_JPRB, 0.31799527E-06_JPRB, &
  & 0.31799155E-06_JPRB, 0.31799209E-06_JPRB, 0.31799112E-06_JPRB, 0.31799408E-06_JPRB, 0.31799681E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799723E-06_JPRB, 0.31799323E-06_JPRB, 0.31799044E-06_JPRB, 0.31798695E-06_JPRB /)

RGHG3(:,86, 1) = (/ &
  & 0.31799291E-06_JPRB, 0.31799132E-06_JPRB, 0.31798908E-06_JPRB, 0.31799166E-06_JPRB, 0.31799073E-06_JPRB, 0.31798893E-06_JPRB, &
  & 0.31799232E-06_JPRB, 0.31799266E-06_JPRB, 0.31799320E-06_JPRB, 0.31799405E-06_JPRB, 0.31799394E-06_JPRB, 0.31799445E-06_JPRB, &
  & 0.31799627E-06_JPRB, 0.31799743E-06_JPRB, 0.31799516E-06_JPRB, 0.31799260E-06_JPRB, 0.31799325E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799044E-06_JPRB, 0.31799360E-06_JPRB, 0.31799340E-06_JPRB, 0.31799320E-06_JPRB, 0.31799271E-06_JPRB, 0.31799590E-06_JPRB, &
  & 0.31799561E-06_JPRB, 0.31799894E-06_JPRB, 0.31799917E-06_JPRB, 0.31800261E-06_JPRB, 0.31800042E-06_JPRB, 0.31800221E-06_JPRB, &
  & 0.31799965E-06_JPRB, 0.31799914E-06_JPRB, 0.31799706E-06_JPRB, 0.31799826E-06_JPRB, 0.31799914E-06_JPRB, 0.31799956E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799843E-06_JPRB, 0.31799388E-06_JPRB, 0.31799610E-06_JPRB, 0.31799442E-06_JPRB, 0.31799763E-06_JPRB, &
  & 0.31799240E-06_JPRB, 0.31798970E-06_JPRB, 0.31799308E-06_JPRB, 0.31799624E-06_JPRB, 0.31799749E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31799811E-06_JPRB, 0.31799632E-06_JPRB, 0.31799755E-06_JPRB, 0.31799212E-06_JPRB, 0.31799530E-06_JPRB, &
  & 0.31799146E-06_JPRB, 0.31799206E-06_JPRB, 0.31799109E-06_JPRB, 0.31799416E-06_JPRB, 0.31799698E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799743E-06_JPRB, 0.31799337E-06_JPRB, 0.31799047E-06_JPRB, 0.31798689E-06_JPRB /)

RGHG3(:,87, 1) = (/ &
  & 0.31799300E-06_JPRB, 0.31799141E-06_JPRB, 0.31798908E-06_JPRB, 0.31799178E-06_JPRB, 0.31799090E-06_JPRB, 0.31798930E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799277E-06_JPRB, 0.31799328E-06_JPRB, 0.31799408E-06_JPRB, 0.31799414E-06_JPRB, 0.31799468E-06_JPRB, &
  & 0.31799624E-06_JPRB, 0.31799712E-06_JPRB, 0.31799516E-06_JPRB, 0.31799283E-06_JPRB, 0.31799331E-06_JPRB, 0.31799354E-06_JPRB, &
  & 0.31799050E-06_JPRB, 0.31799362E-06_JPRB, 0.31799340E-06_JPRB, 0.31799314E-06_JPRB, 0.31799254E-06_JPRB, 0.31799590E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799902E-06_JPRB, 0.31799908E-06_JPRB, 0.31800280E-06_JPRB, 0.31800039E-06_JPRB, 0.31800221E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31799919E-06_JPRB, 0.31799703E-06_JPRB, 0.31799823E-06_JPRB, 0.31799922E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799877E-06_JPRB, 0.31799368E-06_JPRB, 0.31799638E-06_JPRB, 0.31799431E-06_JPRB, 0.31799800E-06_JPRB, &
  & 0.31799217E-06_JPRB, 0.31798953E-06_JPRB, 0.31799306E-06_JPRB, 0.31799624E-06_JPRB, 0.31799752E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799814E-06_JPRB, 0.31799638E-06_JPRB, 0.31799763E-06_JPRB, 0.31799203E-06_JPRB, 0.31799530E-06_JPRB, &
  & 0.31799144E-06_JPRB, 0.31799198E-06_JPRB, 0.31799104E-06_JPRB, 0.31799411E-06_JPRB, 0.31799706E-06_JPRB, 0.31799655E-06_JPRB, &
  & 0.31799760E-06_JPRB, 0.31799340E-06_JPRB, 0.31799041E-06_JPRB, 0.31798683E-06_JPRB /)

RGHG3(:,88, 1) = (/ &
  & 0.31799306E-06_JPRB, 0.31799146E-06_JPRB, 0.31798916E-06_JPRB, 0.31799183E-06_JPRB, 0.31799087E-06_JPRB, 0.31798922E-06_JPRB, &
  & 0.31799240E-06_JPRB, 0.31799286E-06_JPRB, 0.31799340E-06_JPRB, 0.31799414E-06_JPRB, 0.31799422E-06_JPRB, 0.31799479E-06_JPRB, &
  & 0.31799618E-06_JPRB, 0.31799703E-06_JPRB, 0.31799524E-06_JPRB, 0.31799297E-06_JPRB, 0.31799343E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799047E-06_JPRB, 0.31799368E-06_JPRB, 0.31799348E-06_JPRB, 0.31799317E-06_JPRB, 0.31799254E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799541E-06_JPRB, 0.31799908E-06_JPRB, 0.31799905E-06_JPRB, 0.31800298E-06_JPRB, 0.31800039E-06_JPRB, 0.31800229E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31799919E-06_JPRB, 0.31799695E-06_JPRB, 0.31799820E-06_JPRB, 0.31799922E-06_JPRB, 0.31799979E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799902E-06_JPRB, 0.31799334E-06_JPRB, 0.31799664E-06_JPRB, 0.31799408E-06_JPRB, 0.31799831E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31798933E-06_JPRB, 0.31799303E-06_JPRB, 0.31799630E-06_JPRB, 0.31799760E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799851E-06_JPRB, 0.31799811E-06_JPRB, 0.31799638E-06_JPRB, 0.31799769E-06_JPRB, 0.31799198E-06_JPRB, 0.31799533E-06_JPRB, &
  & 0.31799135E-06_JPRB, 0.31799189E-06_JPRB, 0.31799098E-06_JPRB, 0.31799416E-06_JPRB, 0.31799715E-06_JPRB, 0.31799661E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799343E-06_JPRB, 0.31799041E-06_JPRB, 0.31798680E-06_JPRB /)

RGHG3(:,89, 1) = (/ &
  & 0.31799306E-06_JPRB, 0.31799155E-06_JPRB, 0.31798919E-06_JPRB, 0.31799195E-06_JPRB, 0.31799107E-06_JPRB, 0.31798913E-06_JPRB, &
  & 0.31799226E-06_JPRB, 0.31799280E-06_JPRB, 0.31799340E-06_JPRB, 0.31799414E-06_JPRB, 0.31799419E-06_JPRB, 0.31799476E-06_JPRB, &
  & 0.31799644E-06_JPRB, 0.31799735E-06_JPRB, 0.31799533E-06_JPRB, 0.31799289E-06_JPRB, 0.31799345E-06_JPRB, 0.31799362E-06_JPRB, &
  & 0.31799038E-06_JPRB, 0.31799382E-06_JPRB, 0.31799351E-06_JPRB, 0.31799317E-06_JPRB, 0.31799243E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799536E-06_JPRB, 0.31799919E-06_JPRB, 0.31799894E-06_JPRB, 0.31800306E-06_JPRB, 0.31800033E-06_JPRB, 0.31800238E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31799925E-06_JPRB, 0.31799686E-06_JPRB, 0.31799817E-06_JPRB, 0.31799931E-06_JPRB, 0.31799999E-06_JPRB, &
  & 0.31799786E-06_JPRB, 0.31799934E-06_JPRB, 0.31799308E-06_JPRB, 0.31799681E-06_JPRB, 0.31799394E-06_JPRB, 0.31799857E-06_JPRB, &
  & 0.31799198E-06_JPRB, 0.31798922E-06_JPRB, 0.31799297E-06_JPRB, 0.31799630E-06_JPRB, 0.31799766E-06_JPRB, 0.31799672E-06_JPRB, &
  & 0.31799860E-06_JPRB, 0.31799817E-06_JPRB, 0.31799641E-06_JPRB, 0.31799775E-06_JPRB, 0.31799195E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799138E-06_JPRB, 0.31799192E-06_JPRB, 0.31799090E-06_JPRB, 0.31799419E-06_JPRB, 0.31799729E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799786E-06_JPRB, 0.31799345E-06_JPRB, 0.31799036E-06_JPRB, 0.31798675E-06_JPRB /)

RGHG3(:,90, 1) = (/ &
  & 0.31799297E-06_JPRB, 0.31799158E-06_JPRB, 0.31798913E-06_JPRB, 0.31799212E-06_JPRB, 0.31799098E-06_JPRB, 0.31798854E-06_JPRB, &
  & 0.31799260E-06_JPRB, 0.31799269E-06_JPRB, 0.31799317E-06_JPRB, 0.31799414E-06_JPRB, 0.31799402E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799672E-06_JPRB, 0.31799794E-06_JPRB, 0.31799533E-06_JPRB, 0.31799260E-06_JPRB, 0.31799351E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799004E-06_JPRB, 0.31799397E-06_JPRB, 0.31799351E-06_JPRB, 0.31799320E-06_JPRB, 0.31799232E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799931E-06_JPRB, 0.31799885E-06_JPRB, 0.31800332E-06_JPRB, 0.31800022E-06_JPRB, 0.31800261E-06_JPRB, &
  & 0.31799954E-06_JPRB, 0.31799934E-06_JPRB, 0.31799675E-06_JPRB, 0.31799823E-06_JPRB, 0.31799939E-06_JPRB, 0.31800016E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799973E-06_JPRB, 0.31799277E-06_JPRB, 0.31799709E-06_JPRB, 0.31799379E-06_JPRB, 0.31799900E-06_JPRB, &
  & 0.31799189E-06_JPRB, 0.31798902E-06_JPRB, 0.31799297E-06_JPRB, 0.31799630E-06_JPRB, 0.31799772E-06_JPRB, 0.31799667E-06_JPRB, &
  & 0.31799874E-06_JPRB, 0.31799829E-06_JPRB, 0.31799638E-06_JPRB, 0.31799797E-06_JPRB, 0.31799181E-06_JPRB, 0.31799559E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31799189E-06_JPRB, 0.31799078E-06_JPRB, 0.31799433E-06_JPRB, 0.31799743E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799343E-06_JPRB, 0.31799030E-06_JPRB, 0.31798666E-06_JPRB /)

RGHG3(:,91, 1) = (/ &
  & 0.31799289E-06_JPRB, 0.31799189E-06_JPRB, 0.31798871E-06_JPRB, 0.31799243E-06_JPRB, 0.31799129E-06_JPRB, 0.31798763E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799243E-06_JPRB, 0.31799266E-06_JPRB, 0.31799513E-06_JPRB, 0.31799340E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799755E-06_JPRB, 0.31799937E-06_JPRB, 0.31799516E-06_JPRB, 0.31799186E-06_JPRB, 0.31799357E-06_JPRB, 0.31799408E-06_JPRB, &
  & 0.31798939E-06_JPRB, 0.31799433E-06_JPRB, 0.31799348E-06_JPRB, 0.31799323E-06_JPRB, 0.31799200E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31799502E-06_JPRB, 0.31799956E-06_JPRB, 0.31799851E-06_JPRB, 0.31800388E-06_JPRB, 0.31799982E-06_JPRB, 0.31800298E-06_JPRB, &
  & 0.31799928E-06_JPRB, 0.31799956E-06_JPRB, 0.31799630E-06_JPRB, 0.31799820E-06_JPRB, 0.31799945E-06_JPRB, 0.31800056E-06_JPRB, &
  & 0.31799726E-06_JPRB, 0.31800045E-06_JPRB, 0.31799192E-06_JPRB, 0.31799755E-06_JPRB, 0.31799325E-06_JPRB, 0.31799979E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31798851E-06_JPRB, 0.31799303E-06_JPRB, 0.31799644E-06_JPRB, 0.31799792E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31799888E-06_JPRB, 0.31799834E-06_JPRB, 0.31799613E-06_JPRB, 0.31799843E-06_JPRB, 0.31799112E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31799200E-06_JPRB, 0.31799050E-06_JPRB, 0.31799436E-06_JPRB, 0.31799769E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799314E-06_JPRB, 0.31799013E-06_JPRB, 0.31798655E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG3(:, 1, 2) = (/ &
  & 0.88938982E-07_JPRB, 0.88949939E-07_JPRB, 0.88947488E-07_JPRB, 0.88958842E-07_JPRB, 0.88970637E-07_JPRB, 0.88986894E-07_JPRB, &
  & 0.89007905E-07_JPRB, 0.89047148E-07_JPRB, 0.89106813E-07_JPRB, 0.89187104E-07_JPRB, 0.89292506E-07_JPRB, 0.89427047E-07_JPRB, &
  & 0.89596149E-07_JPRB, 0.89807060E-07_JPRB, 0.90059778E-07_JPRB, 0.90351683E-07_JPRB, 0.90682946E-07_JPRB, 0.91044804E-07_JPRB, &
  & 0.91390177E-07_JPRB, 0.91669079E-07_JPRB, 0.91863157E-07_JPRB, 0.91985363E-07_JPRB, 0.92059764E-07_JPRB, 0.92105914E-07_JPRB, &
  & 0.92132680E-07_JPRB, 0.92147168E-07_JPRB, 0.92153940E-07_JPRB, 0.92156299E-07_JPRB, 0.92158409E-07_JPRB, 0.92163241E-07_JPRB, &
  & 0.92171867E-07_JPRB, 0.92184109E-07_JPRB, 0.92199535E-07_JPRB, 0.92218144E-07_JPRB, 0.92240846E-07_JPRB, 0.92268230E-07_JPRB, &
  & 0.92300468E-07_JPRB, 0.92340613E-07_JPRB, 0.92385264E-07_JPRB, 0.92424926E-07_JPRB, 0.92455970E-07_JPRB, 0.92478722E-07_JPRB, &
  & 0.92493728E-07_JPRB, 0.92501594E-07_JPRB, 0.92502155E-07_JPRB, 0.92492677E-07_JPRB, 0.92470849E-07_JPRB, 0.92436508E-07_JPRB, &
  & 0.92392952E-07_JPRB, 0.92346177E-07_JPRB, 0.92302358E-07_JPRB, 0.92265708E-07_JPRB, 0.92238054E-07_JPRB, 0.92219153E-07_JPRB, &
  & 0.92207337E-07_JPRB, 0.92200374E-07_JPRB, 0.92196437E-07_JPRB, 0.92194263E-07_JPRB, 0.92193140E-07_JPRB, 0.92192863E-07_JPRB, &
  & 0.92193474E-07_JPRB, 0.92194810E-07_JPRB, 0.92194938E-07_JPRB, 0.92196146E-07_JPRB /)

RGHG3(:, 2, 2) = (/ &
  & 0.88887091E-07_JPRB, 0.88837979E-07_JPRB, 0.88841574E-07_JPRB, 0.88860133E-07_JPRB, 0.88893927E-07_JPRB, 0.88938805E-07_JPRB, &
  & 0.89006001E-07_JPRB, 0.89108880E-07_JPRB, 0.89258322E-07_JPRB, 0.89461359E-07_JPRB, 0.89724935E-07_JPRB, 0.90062983E-07_JPRB, &
  & 0.90485862E-07_JPRB, 0.91000359E-07_JPRB, 0.91594778E-07_JPRB, 0.92236291E-07_JPRB, 0.92880512E-07_JPRB, 0.93456265E-07_JPRB, &
  & 0.93882150E-07_JPRB, 0.94128481E-07_JPRB, 0.94223573E-07_JPRB, 0.94217988E-07_JPRB, 0.94154700E-07_JPRB, 0.94059963E-07_JPRB, &
  & 0.93948479E-07_JPRB, 0.93820624E-07_JPRB, 0.93677386E-07_JPRB, 0.93532464E-07_JPRB, 0.93402114E-07_JPRB, 0.93291703E-07_JPRB, &
  & 0.93199219E-07_JPRB, 0.93121059E-07_JPRB, 0.93056158E-07_JPRB, 0.93005674E-07_JPRB, 0.92974815E-07_JPRB, 0.92967817E-07_JPRB, &
  & 0.92988017E-07_JPRB, 0.93037634E-07_JPRB, 0.93107261E-07_JPRB, 0.93176403E-07_JPRB, 0.93226582E-07_JPRB, 0.93247607E-07_JPRB, &
  & 0.93235613E-07_JPRB, 0.93191375E-07_JPRB, 0.93118516E-07_JPRB, 0.93021896E-07_JPRB, 0.92910035E-07_JPRB, 0.92796284E-07_JPRB, &
  & 0.92694734E-07_JPRB, 0.92611515E-07_JPRB, 0.92542223E-07_JPRB, 0.92479127E-07_JPRB, 0.92419199E-07_JPRB, 0.92364566E-07_JPRB, &
  & 0.92318061E-07_JPRB, 0.92281027E-07_JPRB, 0.92253472E-07_JPRB, 0.92234785E-07_JPRB, 0.92223914E-07_JPRB, 0.92219928E-07_JPRB, &
  & 0.92221939E-07_JPRB, 0.92225676E-07_JPRB, 0.92227666E-07_JPRB, 0.92229683E-07_JPRB /)

RGHG3(:, 3, 2) = (/ &
  & 0.88909012E-07_JPRB, 0.88842654E-07_JPRB, 0.88850904E-07_JPRB, 0.88898418E-07_JPRB, 0.88977004E-07_JPRB, 0.89089532E-07_JPRB, &
  & 0.89253369E-07_JPRB, 0.89492410E-07_JPRB, 0.89816979E-07_JPRB, 0.90228504E-07_JPRB, 0.90728278E-07_JPRB, 0.91319116E-07_JPRB, &
  & 0.92000754E-07_JPRB, 0.92755869E-07_JPRB, 0.93545495E-07_JPRB, 0.94320818E-07_JPRB, 0.95022827E-07_JPRB, 0.95582955E-07_JPRB, &
  & 0.95951933E-07_JPRB, 0.96127749E-07_JPRB, 0.96155659E-07_JPRB, 0.96093267E-07_JPRB, 0.95984568E-07_JPRB, 0.95853956E-07_JPRB, &
  & 0.95712217E-07_JPRB, 0.95564587E-07_JPRB, 0.95412460E-07_JPRB, 0.95261498E-07_JPRB, 0.95115666E-07_JPRB, 0.94973245E-07_JPRB, &
  & 0.94829183E-07_JPRB, 0.94683784E-07_JPRB, 0.94541193E-07_JPRB, 0.94415356E-07_JPRB, 0.94321038E-07_JPRB, 0.94271449E-07_JPRB, &
  & 0.94276892E-07_JPRB, 0.94336549E-07_JPRB, 0.94428799E-07_JPRB, 0.94515819E-07_JPRB, 0.94561848E-07_JPRB, 0.94544532E-07_JPRB, &
  & 0.94458741E-07_JPRB, 0.94314835E-07_JPRB, 0.94129589E-07_JPRB, 0.93917492E-07_JPRB, 0.93692698E-07_JPRB, 0.93470305E-07_JPRB, &
  & 0.93260525E-07_JPRB, 0.93064507E-07_JPRB, 0.92882630E-07_JPRB, 0.92721365E-07_JPRB, 0.92586880E-07_JPRB, 0.92478203E-07_JPRB, &
  & 0.92391005E-07_JPRB, 0.92322658E-07_JPRB, 0.92272245E-07_JPRB, 0.92239546E-07_JPRB, 0.92224077E-07_JPRB, 0.92223729E-07_JPRB, &
  & 0.92236419E-07_JPRB, 0.92246758E-07_JPRB, 0.92253913E-07_JPRB, 0.92260017E-07_JPRB /)

RGHG3(:, 4, 2) = (/ &
  & 0.89027708E-07_JPRB, 0.88986290E-07_JPRB, 0.89031147E-07_JPRB, 0.89145772E-07_JPRB, 0.89314071E-07_JPRB, 0.89538119E-07_JPRB, &
  & 0.89837613E-07_JPRB, 0.90235893E-07_JPRB, 0.90742020E-07_JPRB, 0.91356689E-07_JPRB, 0.92063928E-07_JPRB, 0.92852169E-07_JPRB, &
  & 0.93698581E-07_JPRB, 0.94566779E-07_JPRB, 0.95424355E-07_JPRB, 0.96228923E-07_JPRB, 0.96932737E-07_JPRB, 0.97492929E-07_JPRB, &
  & 0.97871862E-07_JPRB, 0.98076939E-07_JPRB, 0.98139488E-07_JPRB, 0.98107634E-07_JPRB, 0.98027797E-07_JPRB, 0.97933523E-07_JPRB, &
  & 0.97845657E-07_JPRB, 0.97769245E-07_JPRB, 0.97698624E-07_JPRB, 0.97617438E-07_JPRB, 0.97508490E-07_JPRB, 0.97360498E-07_JPRB, &
  & 0.97174421E-07_JPRB, 0.96960022E-07_JPRB, 0.96740919E-07_JPRB, 0.96548987E-07_JPRB, 0.96423605E-07_JPRB, 0.96393705E-07_JPRB, &
  & 0.96474594E-07_JPRB, 0.96659598E-07_JPRB, 0.96906447E-07_JPRB, 0.97132570E-07_JPRB, 0.97229915E-07_JPRB, 0.97121521E-07_JPRB, &
  & 0.96811391E-07_JPRB, 0.96370798E-07_JPRB, 0.95879741E-07_JPRB, 0.95388557E-07_JPRB, 0.94929497E-07_JPRB, 0.94520992E-07_JPRB, &
  & 0.94162942E-07_JPRB, 0.93845010E-07_JPRB, 0.93562861E-07_JPRB, 0.93316466E-07_JPRB, 0.93101804E-07_JPRB, 0.92915826E-07_JPRB, &
  & 0.92760402E-07_JPRB, 0.92637819E-07_JPRB, 0.92547893E-07_JPRB, 0.92489834E-07_JPRB, 0.92461235E-07_JPRB, 0.92457142E-07_JPRB, &
  & 0.92470742E-07_JPRB, 0.92483596E-07_JPRB, 0.92495355E-07_JPRB, 0.92512913E-07_JPRB /)

RGHG3(:, 5, 2) = (/ &
  & 0.89291198E-07_JPRB, 0.89307512E-07_JPRB, 0.89425711E-07_JPRB, 0.89644374E-07_JPRB, 0.89940428E-07_JPRB, 0.90314856E-07_JPRB, &
  & 0.90790628E-07_JPRB, 0.91381779E-07_JPRB, 0.92099761E-07_JPRB, 0.92945847E-07_JPRB, 0.93873240E-07_JPRB, 0.94845738E-07_JPRB, &
  & 0.95841216E-07_JPRB, 0.96828408E-07_JPRB, 0.97769600E-07_JPRB, 0.98638210E-07_JPRB, 0.99416496E-07_JPRB, 0.10007791E-06_JPRB, &
  & 0.10062074E-06_JPRB, 0.10105749E-06_JPRB, 0.10142038E-06_JPRB, 0.10175009E-06_JPRB, 0.10208620E-06_JPRB, 0.10245315E-06_JPRB, &
  & 0.10285793E-06_JPRB, 0.10327501E-06_JPRB, 0.10366599E-06_JPRB, 0.10397331E-06_JPRB, 0.10415017E-06_JPRB, 0.10415685E-06_JPRB, &
  & 0.10399302E-06_JPRB, 0.10369700E-06_JPRB, 0.10334834E-06_JPRB, 0.10305072E-06_JPRB, 0.10289371E-06_JPRB, 0.10292643E-06_JPRB, &
  & 0.10315565E-06_JPRB, 0.10353487E-06_JPRB, 0.10395279E-06_JPRB, 0.10420551E-06_JPRB, 0.10405008E-06_JPRB, 0.10337251E-06_JPRB, &
  & 0.10229337E-06_JPRB, 0.10105880E-06_JPRB, 0.99851597E-07_JPRB, 0.98757724E-07_JPRB, 0.97805732E-07_JPRB, 0.96990064E-07_JPRB, &
  & 0.96282932E-07_JPRB, 0.95659317E-07_JPRB, 0.95110153E-07_JPRB, 0.94630337E-07_JPRB, 0.94216247E-07_JPRB, 0.93868820E-07_JPRB, &
  & 0.93587545E-07_JPRB, 0.93369415E-07_JPRB, 0.93210993E-07_JPRB, 0.93108611E-07_JPRB, 0.93055803E-07_JPRB, 0.93041486E-07_JPRB, &
  & 0.93047291E-07_JPRB, 0.93055746E-07_JPRB, 0.93063640E-07_JPRB, 0.93077787E-07_JPRB /)

RGHG3(:, 6, 2) = (/ &
  & 0.89870916E-07_JPRB, 0.90000370E-07_JPRB, 0.90235432E-07_JPRB, 0.90609262E-07_JPRB, 0.91090406E-07_JPRB, 0.91668859E-07_JPRB, &
  & 0.92373938E-07_JPRB, 0.93219604E-07_JPRB, 0.94210719E-07_JPRB, 0.95345690E-07_JPRB, 0.96578027E-07_JPRB, 0.97829464E-07_JPRB, &
  & 0.99064842E-07_JPRB, 0.10025524E-06_JPRB, 0.10137410E-06_JPRB, 0.10240527E-06_JPRB, 0.10334701E-06_JPRB, 0.10421132E-06_JPRB, &
  & 0.10501516E-06_JPRB, 0.10580704E-06_JPRB, 0.10662722E-06_JPRB, 0.10752056E-06_JPRB, 0.10851564E-06_JPRB, 0.10961463E-06_JPRB, &
  & 0.11078119E-06_JPRB, 0.11196163E-06_JPRB, 0.11309878E-06_JPRB, 0.11415256E-06_JPRB, 0.11504461E-06_JPRB, 0.11573599E-06_JPRB, &
  & 0.11618620E-06_JPRB, 0.11642204E-06_JPRB, 0.11651255E-06_JPRB, 0.11655754E-06_JPRB, 0.11664245E-06_JPRB, 0.11680727E-06_JPRB, &
  & 0.11703419E-06_JPRB, 0.11722939E-06_JPRB, 0.11719592E-06_JPRB, 0.11663706E-06_JPRB, 0.11529411E-06_JPRB, 0.11320800E-06_JPRB, &
  & 0.11078154E-06_JPRB, 0.10841353E-06_JPRB, 0.10630238E-06_JPRB, 0.10448167E-06_JPRB, 0.10292185E-06_JPRB, 0.10156523E-06_JPRB, &
  & 0.10035561E-06_JPRB, 0.99262394E-07_JPRB, 0.98275521E-07_JPRB, 0.97392444E-07_JPRB, 0.96618763E-07_JPRB, 0.95962442E-07_JPRB, &
  & 0.95427225E-07_JPRB, 0.95012787E-07_JPRB, 0.94711979E-07_JPRB, 0.94511201E-07_JPRB, 0.94391943E-07_JPRB, 0.94331071E-07_JPRB, &
  & 0.94302905E-07_JPRB, 0.94288225E-07_JPRB, 0.94280267E-07_JPRB, 0.94272792E-07_JPRB /)

RGHG3(:, 7, 2) = (/ &
  & 0.91061196E-07_JPRB, 0.91395059E-07_JPRB, 0.91799535E-07_JPRB, 0.92393400E-07_JPRB, 0.93132520E-07_JPRB, 0.94006346E-07_JPRB, &
  & 0.95033840E-07_JPRB, 0.96236768E-07_JPRB, 0.97628117E-07_JPRB, 0.99203405E-07_JPRB, 0.10087516E-06_JPRB, 0.10256718E-06_JPRB, &
  & 0.10422984E-06_JPRB, 0.10581167E-06_JPRB, 0.10727241E-06_JPRB, 0.10860511E-06_JPRB, 0.10983169E-06_JPRB, 0.11098246E-06_JPRB, &
  & 0.11210767E-06_JPRB, 0.11326405E-06_JPRB, 0.11451478E-06_JPRB, 0.11590844E-06_JPRB, 0.11747457E-06_JPRB, 0.11920453E-06_JPRB, &
  & 0.12104353E-06_JPRB, 0.12293293E-06_JPRB, 0.12483068E-06_JPRB, 0.12669192E-06_JPRB, 0.12849443E-06_JPRB, 0.13015574E-06_JPRB, &
  & 0.13162783E-06_JPRB, 0.13284776E-06_JPRB, 0.13378819E-06_JPRB, 0.13444439E-06_JPRB, 0.13482865E-06_JPRB, 0.13493300E-06_JPRB, &
  & 0.13471758E-06_JPRB, 0.13407774E-06_JPRB, 0.13281800E-06_JPRB, 0.13068727E-06_JPRB, 0.12756715E-06_JPRB, 0.12377566E-06_JPRB, &
  & 0.11993937E-06_JPRB, 0.11652048E-06_JPRB, 0.11363809E-06_JPRB, 0.11123938E-06_JPRB, 0.10921196E-06_JPRB, 0.10743398E-06_JPRB, &
  & 0.10581749E-06_JPRB, 0.10431654E-06_JPRB, 0.10290883E-06_JPRB, 0.10159644E-06_JPRB, 0.10040395E-06_JPRB, 0.99362680E-07_JPRB, &
  & 0.98496280E-07_JPRB, 0.97813214E-07_JPRB, 0.97305559E-07_JPRB, 0.96954153E-07_JPRB, 0.96729650E-07_JPRB, 0.96595798E-07_JPRB, &
  & 0.96515706E-07_JPRB, 0.96463964E-07_JPRB, 0.96426362E-07_JPRB, 0.96394395E-07_JPRB /)

RGHG3(:, 8, 2) = (/ &
  & 0.93099757E-07_JPRB, 0.93991218E-07_JPRB, 0.94708454E-07_JPRB, 0.95599688E-07_JPRB, 0.96687153E-07_JPRB, 0.97947442E-07_JPRB, &
  & 0.99411260E-07_JPRB, 0.10109765E-06_JPRB, 0.10303041E-06_JPRB, 0.10516882E-06_JPRB, 0.10743788E-06_JPRB, 0.10974931E-06_JPRB, &
  & 0.11203278E-06_JPRB, 0.11421469E-06_JPRB, 0.11624407E-06_JPRB, 0.11809954E-06_JPRB, 0.11980063E-06_JPRB, 0.12138841E-06_JPRB, &
  & 0.12291808E-06_JPRB, 0.12446286E-06_JPRB, 0.12608037E-06_JPRB, 0.12782252E-06_JPRB, 0.12972538E-06_JPRB, 0.13177822E-06_JPRB, &
  & 0.13395722E-06_JPRB, 0.13620438E-06_JPRB, 0.13851233E-06_JPRB, 0.14087502E-06_JPRB, 0.14324493E-06_JPRB, 0.14555931E-06_JPRB, &
  & 0.14768445E-06_JPRB, 0.14947358E-06_JPRB, 0.15077765E-06_JPRB, 0.15149693E-06_JPRB, 0.15158675E-06_JPRB, 0.15103862E-06_JPRB, &
  & 0.14985797E-06_JPRB, 0.14799687E-06_JPRB, 0.14533421E-06_JPRB, 0.14171907E-06_JPRB, 0.13714401E-06_JPRB, 0.13207426E-06_JPRB, &
  & 0.12726136E-06_JPRB, 0.12317204E-06_JPRB, 0.11987115E-06_JPRB, 0.11721325E-06_JPRB, 0.11499176E-06_JPRB, 0.11303625E-06_JPRB, &
  & 0.11124185E-06_JPRB, 0.10954171E-06_JPRB, 0.10789622E-06_JPRB, 0.10631069E-06_JPRB, 0.10482297E-06_JPRB, 0.10348229E-06_JPRB, &
  & 0.10233086E-06_JPRB, 0.10139465E-06_JPRB, 0.10067723E-06_JPRB, 0.10016274E-06_JPRB, 0.99816653E-07_JPRB, 0.99593379E-07_JPRB, &
  & 0.99443319E-07_JPRB, 0.99330180E-07_JPRB, 0.99225694E-07_JPRB, 0.99060223E-07_JPRB /)

RGHG3(:, 9, 2) = (/ &
  & 0.96699409E-07_JPRB, 0.98289135E-07_JPRB, 0.99486833E-07_JPRB, 0.10081749E-06_JPRB, 0.10233799E-06_JPRB, 0.10407789E-06_JPRB, &
  & 0.10604000E-06_JPRB, 0.10827041E-06_JPRB, 0.11077724E-06_JPRB, 0.11353809E-06_JPRB, 0.11649195E-06_JPRB, 0.11954764E-06_JPRB, &
  & 0.12261216E-06_JPRB, 0.12558445E-06_JPRB, 0.12839352E-06_JPRB, 0.13101000E-06_JPRB, 0.13342640E-06_JPRB, 0.13566675E-06_JPRB, &
  & 0.13777095E-06_JPRB, 0.13979826E-06_JPRB, 0.14180861E-06_JPRB, 0.14382947E-06_JPRB, 0.14588132E-06_JPRB, 0.14797479E-06_JPRB, &
  & 0.15008538E-06_JPRB, 0.15222470E-06_JPRB, 0.15442062E-06_JPRB, 0.15669363E-06_JPRB, 0.15901790E-06_JPRB, 0.16127345E-06_JPRB, &
  & 0.16326810E-06_JPRB, 0.16476440E-06_JPRB, 0.16553916E-06_JPRB, 0.16544702E-06_JPRB, 0.16445757E-06_JPRB, 0.16265555E-06_JPRB, &
  & 0.16014096E-06_JPRB, 0.15697844E-06_JPRB, 0.15314235E-06_JPRB, 0.14850804E-06_JPRB, 0.14309117E-06_JPRB, 0.13731206E-06_JPRB, &
  & 0.13195744E-06_JPRB, 0.12755497E-06_JPRB, 0.12413359E-06_JPRB, 0.12143761E-06_JPRB, 0.11920989E-06_JPRB, 0.11727328E-06_JPRB, &
  & 0.11550803E-06_JPRB, 0.11381354E-06_JPRB, 0.11213962E-06_JPRB, 0.11048851E-06_JPRB, 0.10889190E-06_JPRB, 0.10740546E-06_JPRB, &
  & 0.10609040E-06_JPRB, 0.10498938E-06_JPRB, 0.10412629E-06_JPRB, 0.10349575E-06_JPRB, 0.10307022E-06_JPRB, 0.10278591E-06_JPRB, &
  & 0.10259406E-06_JPRB, 0.10244704E-06_JPRB, 0.10231261E-06_JPRB, 0.10212511E-06_JPRB /)

RGHG3(:,10, 2) = (/ &
  & 0.10327077E-06_JPRB, 0.10587401E-06_JPRB, 0.10763667E-06_JPRB, 0.10930877E-06_JPRB, 0.11121957E-06_JPRB, 0.11333369E-06_JPRB, &
  & 0.11571482E-06_JPRB, 0.11837946E-06_JPRB, 0.12135631E-06_JPRB, 0.12463877E-06_JPRB, 0.12817290E-06_JPRB, 0.13187275E-06_JPRB, &
  & 0.13565116E-06_JPRB, 0.13942240E-06_JPRB, 0.14309842E-06_JPRB, 0.14660318E-06_JPRB, 0.14990523E-06_JPRB, 0.15297638E-06_JPRB, &
  & 0.15582521E-06_JPRB, 0.15846538E-06_JPRB, 0.16092108E-06_JPRB, 0.16321403E-06_JPRB, 0.16533814E-06_JPRB, 0.16729130E-06_JPRB, &
  & 0.16910080E-06_JPRB, 0.17079486E-06_JPRB, 0.17245273E-06_JPRB, 0.17411182E-06_JPRB, 0.17574247E-06_JPRB, 0.17720922E-06_JPRB, &
  & 0.17827655E-06_JPRB, 0.17865698E-06_JPRB, 0.17809192E-06_JPRB, 0.17644469E-06_JPRB, 0.17377093E-06_JPRB, 0.17029454E-06_JPRB, &
  & 0.16631176E-06_JPRB, 0.16196677E-06_JPRB, 0.15723766E-06_JPRB, 0.15202868E-06_JPRB, 0.14624976E-06_JPRB, 0.14021673E-06_JPRB, &
  & 0.13465826E-06_JPRB, 0.13010661E-06_JPRB, 0.12658536E-06_JPRB, 0.12387841E-06_JPRB, 0.12173209E-06_JPRB, 0.11993589E-06_JPRB, &
  & 0.11830643E-06_JPRB, 0.11673330E-06_JPRB, 0.11517020E-06_JPRB, 0.11359955E-06_JPRB, 0.11204129E-06_JPRB, 0.11055117E-06_JPRB, &
  & 0.10919114E-06_JPRB, 0.10803015E-06_JPRB, 0.10710809E-06_JPRB, 0.10644341E-06_JPRB, 0.10598801E-06_JPRB, 0.10569616E-06_JPRB, &
  & 0.10548902E-06_JPRB, 0.10532924E-06_JPRB, 0.10517978E-06_JPRB, 0.10495845E-06_JPRB /)

RGHG3(:,11, 2) = (/ &
  & 0.11520474E-06_JPRB, 0.11907441E-06_JPRB, 0.12108156E-06_JPRB, 0.12284126E-06_JPRB, 0.12469104E-06_JPRB, 0.12677431E-06_JPRB, &
  & 0.12913763E-06_JPRB, 0.13183846E-06_JPRB, 0.13489904E-06_JPRB, 0.13833441E-06_JPRB, 0.14212272E-06_JPRB, 0.14619556E-06_JPRB, &
  & 0.15047037E-06_JPRB, 0.15484954E-06_JPRB, 0.15924250E-06_JPRB, 0.16355655E-06_JPRB, 0.16768780E-06_JPRB, 0.17157542E-06_JPRB, &
  & 0.17515737E-06_JPRB, 0.17841731E-06_JPRB, 0.18133063E-06_JPRB, 0.18387578E-06_JPRB, 0.18606337E-06_JPRB, 0.18787387E-06_JPRB, &
  & 0.18935447E-06_JPRB, 0.19053422E-06_JPRB, 0.19148746E-06_JPRB, 0.19224225E-06_JPRB, 0.19276338E-06_JPRB, 0.19292220E-06_JPRB, &
  & 0.19249872E-06_JPRB, 0.19122876E-06_JPRB, 0.18887148E-06_JPRB, 0.18532049E-06_JPRB, 0.18071000E-06_JPRB, 0.17545298E-06_JPRB, &
  & 0.16999864E-06_JPRB, 0.16464895E-06_JPRB, 0.15935407E-06_JPRB, 0.15390313E-06_JPRB, 0.14816544E-06_JPRB, 0.14226502E-06_JPRB, &
  & 0.13662986E-06_JPRB, 0.13188584E-06_JPRB, 0.12828126E-06_JPRB, 0.12560086E-06_JPRB, 0.12352288E-06_JPRB, 0.12177657E-06_JPRB, &
  & 0.12020649E-06_JPRB, 0.11872251E-06_JPRB, 0.11725480E-06_JPRB, 0.11577288E-06_JPRB, 0.11429042E-06_JPRB, 0.11284638E-06_JPRB, &
  & 0.11151249E-06_JPRB, 0.11036071E-06_JPRB, 0.10945790E-06_JPRB, 0.10880411E-06_JPRB, 0.10838340E-06_JPRB, 0.10809808E-06_JPRB, &
  & 0.10790694E-06_JPRB, 0.10775295E-06_JPRB, 0.10760574E-06_JPRB, 0.10738571E-06_JPRB /)

RGHG3(:,12, 2) = (/ &
  & 0.13504206E-06_JPRB, 0.13834453E-06_JPRB, 0.13972763E-06_JPRB, 0.14096381E-06_JPRB, 0.14225617E-06_JPRB, 0.14381851E-06_JPRB, &
  & 0.14572791E-06_JPRB, 0.14803052E-06_JPRB, 0.15077072E-06_JPRB, 0.15397124E-06_JPRB, 0.15763283E-06_JPRB, 0.16171587E-06_JPRB, &
  & 0.16615100E-06_JPRB, 0.17083794E-06_JPRB, 0.17565695E-06_JPRB, 0.18047912E-06_JPRB, 0.18518497E-06_JPRB, 0.18963513E-06_JPRB, &
  & 0.19374454E-06_JPRB, 0.19743833E-06_JPRB, 0.20066460E-06_JPRB, 0.20338989E-06_JPRB, 0.20561350E-06_JPRB, 0.20732136E-06_JPRB, &
  & 0.20853840E-06_JPRB, 0.20927618E-06_JPRB, 0.20955905E-06_JPRB, 0.20938852E-06_JPRB, 0.20871543E-06_JPRB, 0.20743991E-06_JPRB, &
  & 0.20539478E-06_JPRB, 0.20239108E-06_JPRB, 0.19826621E-06_JPRB, 0.19299645E-06_JPRB, 0.18682576E-06_JPRB, 0.18025398E-06_JPRB, &
  & 0.17384517E-06_JPRB, 0.16786987E-06_JPRB, 0.16231186E-06_JPRB, 0.15694654E-06_JPRB, 0.15149416E-06_JPRB, 0.14590299E-06_JPRB, &
  & 0.14051892E-06_JPRB, 0.13579790E-06_JPRB, 0.13200231E-06_JPRB, 0.12905242E-06_JPRB, 0.12670256E-06_JPRB, 0.12473777E-06_JPRB, &
  & 0.12298713E-06_JPRB, 0.12132885E-06_JPRB, 0.11970215E-06_JPRB, 0.11809206E-06_JPRB, 0.11650263E-06_JPRB, 0.11497327E-06_JPRB, &
  & 0.11356968E-06_JPRB, 0.11237726E-06_JPRB, 0.11144509E-06_JPRB, 0.11079976E-06_JPRB, 0.11036418E-06_JPRB, 0.11009493E-06_JPRB, &
  & 0.10990159E-06_JPRB, 0.10975383E-06_JPRB, 0.10961351E-06_JPRB, 0.10940862E-06_JPRB /)

RGHG3(:,13, 2) = (/ &
  & 0.15711971E-06_JPRB, 0.15877497E-06_JPRB, 0.15937239E-06_JPRB, 0.15998789E-06_JPRB, 0.16077594E-06_JPRB, 0.16185274E-06_JPRB, &
  & 0.16329383E-06_JPRB, 0.16515826E-06_JPRB, 0.16748552E-06_JPRB, 0.17031815E-06_JPRB, 0.17367296E-06_JPRB, 0.17752581E-06_JPRB, &
  & 0.18182287E-06_JPRB, 0.18647485E-06_JPRB, 0.19135905E-06_JPRB, 0.19633126E-06_JPRB, 0.20124051E-06_JPRB, 0.20592290E-06_JPRB, &
  & 0.21023098E-06_JPRB, 0.21409944E-06_JPRB, 0.21742453E-06_JPRB, 0.22018867E-06_JPRB, 0.22235746E-06_JPRB, 0.22393290E-06_JPRB, &
  & 0.22491112E-06_JPRB, 0.22527027E-06_JPRB, 0.22499334E-06_JPRB, 0.22403771E-06_JPRB, 0.22235355E-06_JPRB, 0.21985896E-06_JPRB, &
  & 0.21645873E-06_JPRB, 0.21205756E-06_JPRB, 0.20661474E-06_JPRB, 0.20020748E-06_JPRB, 0.19315449E-06_JPRB, 0.18606697E-06_JPRB, &
  & 0.17954837E-06_JPRB, 0.17381220E-06_JPRB, 0.16873132E-06_JPRB, 0.16406017E-06_JPRB, 0.15954785E-06_JPRB, 0.15501826E-06_JPRB, &
  & 0.15045826E-06_JPRB, 0.14605985E-06_JPRB, 0.14206850E-06_JPRB, 0.13857901E-06_JPRB, 0.13552685E-06_JPRB, 0.13277703E-06_JPRB, &
  & 0.13021460E-06_JPRB, 0.12776341E-06_JPRB, 0.12538447E-06_JPRB, 0.12306553E-06_JPRB, 0.12083287E-06_JPRB, 0.11874747E-06_JPRB, &
  & 0.11688941E-06_JPRB, 0.11533601E-06_JPRB, 0.11414536E-06_JPRB, 0.11329684E-06_JPRB, 0.11275699E-06_JPRB, 0.11239381E-06_JPRB, &
  & 0.11215246E-06_JPRB, 0.11195731E-06_JPRB, 0.11177233E-06_JPRB, 0.11149326E-06_JPRB /)

RGHG3(:,14, 2) = (/ &
  & 0.17603648E-06_JPRB, 0.17674752E-06_JPRB, 0.17707771E-06_JPRB, 0.17746039E-06_JPRB, 0.17805428E-06_JPRB, 0.17893535E-06_JPRB, &
  & 0.18015932E-06_JPRB, 0.18177006E-06_JPRB, 0.18381178E-06_JPRB, 0.18633267E-06_JPRB, 0.18936244E-06_JPRB, 0.19289588E-06_JPRB, &
  & 0.19689244E-06_JPRB, 0.20127280E-06_JPRB, 0.20592806E-06_JPRB, 0.21071872E-06_JPRB, 0.21550500E-06_JPRB, 0.22008912E-06_JPRB, &
  & 0.22432582E-06_JPRB, 0.22810019E-06_JPRB, 0.23131685E-06_JPRB, 0.23394576E-06_JPRB, 0.23594912E-06_JPRB, 0.23731712E-06_JPRB, &
  & 0.23802183E-06_JPRB, 0.23802102E-06_JPRB, 0.23726695E-06_JPRB, 0.23570287E-06_JPRB, 0.23327455E-06_JPRB, 0.22994013E-06_JPRB, &
  & 0.22567883E-06_JPRB, 0.22051925E-06_JPRB, 0.21456928E-06_JPRB, 0.20806351E-06_JPRB, 0.20137468E-06_JPRB, 0.19503804E-06_JPRB, &
  & 0.18953574E-06_JPRB, 0.18501477E-06_JPRB, 0.18132394E-06_JPRB, 0.17814455E-06_JPRB, 0.17515087E-06_JPRB, 0.17210139E-06_JPRB, &
  & 0.16882692E-06_JPRB, 0.16521287E-06_JPRB, 0.16134588E-06_JPRB, 0.15739721E-06_JPRB, 0.15346758E-06_JPRB, 0.14956922E-06_JPRB, &
  & 0.14569184E-06_JPRB, 0.14181863E-06_JPRB, 0.13795986E-06_JPRB, 0.13416646E-06_JPRB, 0.13052053E-06_JPRB, 0.12712712E-06_JPRB, &
  & 0.12411371E-06_JPRB, 0.12158814E-06_JPRB, 0.11960714E-06_JPRB, 0.11817546E-06_JPRB, 0.11719534E-06_JPRB, 0.11656192E-06_JPRB, &
  & 0.11610234E-06_JPRB, 0.11574312E-06_JPRB, 0.11538300E-06_JPRB, 0.11483706E-06_JPRB /)

RGHG3(:,15, 2) = (/ &
  & 0.19137988E-06_JPRB, 0.19198220E-06_JPRB, 0.19236468E-06_JPRB, 0.19285145E-06_JPRB, 0.19354336E-06_JPRB, 0.19449440E-06_JPRB, &
  & 0.19574344E-06_JPRB, 0.19731318E-06_JPRB, 0.19924256E-06_JPRB, 0.20157292E-06_JPRB, 0.20434203E-06_JPRB, 0.20755226E-06_JPRB, &
  & 0.21117680E-06_JPRB, 0.21515777E-06_JPRB, 0.21940647E-06_JPRB, 0.22380657E-06_JPRB, 0.22822408E-06_JPRB, 0.23247775E-06_JPRB, &
  & 0.23642689E-06_JPRB, 0.23992405E-06_JPRB, 0.24288889E-06_JPRB, 0.24525525E-06_JPRB, 0.24699514E-06_JPRB, 0.24807994E-06_JPRB, &
  & 0.24846653E-06_JPRB, 0.24809987E-06_JPRB, 0.24692150E-06_JPRB, 0.24487250E-06_JPRB, 0.24193491E-06_JPRB, 0.23811729E-06_JPRB, &
  & 0.23348383E-06_JPRB, 0.22817738E-06_JPRB, 0.22243239E-06_JPRB, 0.21654014E-06_JPRB, 0.21097063E-06_JPRB, 0.20626472E-06_JPRB, &
  & 0.20265671E-06_JPRB, 0.20010152E-06_JPRB, 0.19828612E-06_JPRB, 0.19684489E-06_JPRB, 0.19542649E-06_JPRB, 0.19383080E-06_JPRB, &
  & 0.19177391E-06_JPRB, 0.18905436E-06_JPRB, 0.18567818E-06_JPRB, 0.18178562E-06_JPRB, 0.17751788E-06_JPRB, 0.17296274E-06_JPRB, &
  & 0.16814695E-06_JPRB, 0.16310011E-06_JPRB, 0.15787334E-06_JPRB, 0.15255453E-06_JPRB, 0.14727647E-06_JPRB, 0.14223420E-06_JPRB, &
  & 0.13762539E-06_JPRB, 0.13363189E-06_JPRB, 0.13034970E-06_JPRB, 0.12783519E-06_JPRB, 0.12603226E-06_JPRB, 0.12476025E-06_JPRB, &
  & 0.12385404E-06_JPRB, 0.12308291E-06_JPRB, 0.12233166E-06_JPRB, 0.12111607E-06_JPRB /)

RGHG3(:,16, 2) = (/ &
  & 0.20397508E-06_JPRB, 0.20492936E-06_JPRB, 0.20558520E-06_JPRB, 0.20633338E-06_JPRB, 0.20727249E-06_JPRB, 0.20844676E-06_JPRB, &
  & 0.20986502E-06_JPRB, 0.21154881E-06_JPRB, 0.21351276E-06_JPRB, 0.21579282E-06_JPRB, 0.21840903E-06_JPRB, 0.22136177E-06_JPRB, &
  & 0.22463097E-06_JPRB, 0.22818344E-06_JPRB, 0.23196114E-06_JPRB, 0.23587582E-06_JPRB, 0.23980320E-06_JPRB, 0.24360389E-06_JPRB, &
  & 0.24713142E-06_JPRB, 0.25024718E-06_JPRB, 0.25285297E-06_JPRB, 0.25487643E-06_JPRB, 0.25627958E-06_JPRB, 0.25702320E-06_JPRB, &
  & 0.25705836E-06_JPRB, 0.25632789E-06_JPRB, 0.25477584E-06_JPRB, 0.25238751E-06_JPRB, 0.24916835E-06_JPRB, 0.24519326E-06_JPRB, &
  & 0.24063087E-06_JPRB, 0.23569621E-06_JPRB, 0.23068802E-06_JPRB, 0.22601674E-06_JPRB, 0.22211798E-06_JPRB, 0.21923012E-06_JPRB, &
  & 0.21750895E-06_JPRB, 0.21674359E-06_JPRB, 0.21651356E-06_JPRB, 0.21641861E-06_JPRB, 0.21618797E-06_JPRB, 0.21553032E-06_JPRB, &
  & 0.21421911E-06_JPRB, 0.21213116E-06_JPRB, 0.20928114E-06_JPRB, 0.20577315E-06_JPRB, 0.20171505E-06_JPRB, 0.19717309E-06_JPRB, &
  & 0.19218501E-06_JPRB, 0.18677549E-06_JPRB, 0.18099675E-06_JPRB, 0.17494685E-06_JPRB, 0.16877125E-06_JPRB, 0.16266867E-06_JPRB, &
  & 0.15689400E-06_JPRB, 0.15167488E-06_JPRB, 0.14717672E-06_JPRB, 0.14347913E-06_JPRB, 0.14063605E-06_JPRB, 0.13853942E-06_JPRB, &
  & 0.13689504E-06_JPRB, 0.13554246E-06_JPRB, 0.13409175E-06_JPRB, 0.13183897E-06_JPRB /)

RGHG3(:,17, 2) = (/ &
  & 0.21462063E-06_JPRB, 0.21601487E-06_JPRB, 0.21698192E-06_JPRB, 0.21802812E-06_JPRB, 0.21926850E-06_JPRB, 0.22073304E-06_JPRB, &
  & 0.22242226E-06_JPRB, 0.22431846E-06_JPRB, 0.22642496E-06_JPRB, 0.22875241E-06_JPRB, 0.23131685E-06_JPRB, 0.23411349E-06_JPRB, &
  & 0.23711156E-06_JPRB, 0.24028918E-06_JPRB, 0.24362782E-06_JPRB, 0.24705636E-06_JPRB, 0.25047876E-06_JPRB, 0.25379038E-06_JPRB, &
  & 0.25684281E-06_JPRB, 0.25951076E-06_JPRB, 0.26169300E-06_JPRB, 0.26331443E-06_JPRB, 0.26432815E-06_JPRB, 0.26469570E-06_JPRB, &
  & 0.26436908E-06_JPRB, 0.26330542E-06_JPRB, 0.26148726E-06_JPRB, 0.25892129E-06_JPRB, 0.25570884E-06_JPRB, 0.25198264E-06_JPRB, &
  & 0.24787641E-06_JPRB, 0.24371704E-06_JPRB, 0.23982216E-06_JPRB, 0.23653634E-06_JPRB, 0.23414080E-06_JPRB, 0.23287689E-06_JPRB, &
  & 0.23266492E-06_JPRB, 0.23315803E-06_JPRB, 0.23391759E-06_JPRB, 0.23457359E-06_JPRB, 0.23488170E-06_JPRB, 0.23464452E-06_JPRB, &
  & 0.23370318E-06_JPRB, 0.23197789E-06_JPRB, 0.22950735E-06_JPRB, 0.22639651E-06_JPRB, 0.22272705E-06_JPRB, 0.21853434E-06_JPRB, &
  & 0.21383585E-06_JPRB, 0.20864701E-06_JPRB, 0.20302072E-06_JPRB, 0.19703852E-06_JPRB, 0.19082319E-06_JPRB, 0.18457069E-06_JPRB, &
  & 0.17851009E-06_JPRB, 0.17287483E-06_JPRB, 0.16781433E-06_JPRB, 0.16344984E-06_JPRB, 0.15985634E-06_JPRB, 0.15697653E-06_JPRB, &
  & 0.15470657E-06_JPRB, 0.15262636E-06_JPRB, 0.15050705E-06_JPRB, 0.14691688E-06_JPRB /)

RGHG3(:,18, 2) = (/ &
  & 0.22343552E-06_JPRB, 0.22548252E-06_JPRB, 0.22679487E-06_JPRB, 0.22814208E-06_JPRB, 0.22967184E-06_JPRB, 0.23142104E-06_JPRB, &
  & 0.23337098E-06_JPRB, 0.23550352E-06_JPRB, 0.23779572E-06_JPRB, 0.24023845E-06_JPRB, 0.24282514E-06_JPRB, 0.24555658E-06_JPRB, &
  & 0.24838749E-06_JPRB, 0.25128344E-06_JPRB, 0.25426428E-06_JPRB, 0.25727360E-06_JPRB, 0.26023542E-06_JPRB, 0.26306503E-06_JPRB, &
  & 0.26563731E-06_JPRB, 0.26783982E-06_JPRB, 0.26957250E-06_JPRB, 0.27076985E-06_JPRB, 0.27138111E-06_JPRB, 0.27137324E-06_JPRB, &
  & 0.27071974E-06_JPRB, 0.26941942E-06_JPRB, 0.26749527E-06_JPRB, 0.26503665E-06_JPRB, 0.26211444E-06_JPRB, 0.25889008E-06_JPRB, &
  & 0.25564935E-06_JPRB, 0.25257333E-06_JPRB, 0.24992551E-06_JPRB, 0.24796552E-06_JPRB, 0.24689541E-06_JPRB, 0.24676496E-06_JPRB, &
  & 0.24743233E-06_JPRB, 0.24854660E-06_JPRB, 0.24969773E-06_JPRB, 0.25058549E-06_JPRB, 0.25100317E-06_JPRB, 0.25079351E-06_JPRB, &
  & 0.24988350E-06_JPRB, 0.24827040E-06_JPRB, 0.24601474E-06_JPRB, 0.24319533E-06_JPRB, 0.23987303E-06_JPRB, 0.23607002E-06_JPRB, &
  & 0.23178278E-06_JPRB, 0.22703472E-06_JPRB, 0.22187261E-06_JPRB, 0.21637537E-06_JPRB, 0.21065188E-06_JPRB, 0.20485741E-06_JPRB, &
  & 0.19919307E-06_JPRB, 0.19384260E-06_JPRB, 0.18892703E-06_JPRB, 0.18451492E-06_JPRB, 0.18067966E-06_JPRB, 0.17747477E-06_JPRB, &
  & 0.17469542E-06_JPRB, 0.17219389E-06_JPRB, 0.16942596E-06_JPRB, 0.16479237E-06_JPRB /)

RGHG3(:,19, 2) = (/ &
  & 0.23105585E-06_JPRB, 0.23348093E-06_JPRB, 0.23510107E-06_JPRB, 0.23671717E-06_JPRB, 0.23850666E-06_JPRB, 0.24050644E-06_JPRB, &
  & 0.24269573E-06_JPRB, 0.24503422E-06_JPRB, 0.24749676E-06_JPRB, 0.25006162E-06_JPRB, 0.25270231E-06_JPRB, 0.25540902E-06_JPRB, &
  & 0.25814634E-06_JPRB, 0.26085803E-06_JPRB, 0.26356867E-06_JPRB, 0.26624872E-06_JPRB, 0.26882722E-06_JPRB, 0.27123252E-06_JPRB, &
  & 0.27336762E-06_JPRB, 0.27513809E-06_JPRB, 0.27645774E-06_JPRB, 0.27726304E-06_JPRB, 0.27751435E-06_JPRB, 0.27719335E-06_JPRB, &
  & 0.27630696E-06_JPRB, 0.27489693E-06_JPRB, 0.27304023E-06_JPRB, 0.27083328E-06_JPRB, 0.26846911E-06_JPRB, 0.26612852E-06_JPRB, &
  & 0.26395495E-06_JPRB, 0.26208465E-06_JPRB, 0.26069566E-06_JPRB, 0.25993054E-06_JPRB, 0.25984090E-06_JPRB, 0.26039118E-06_JPRB, &
  & 0.26142703E-06_JPRB, 0.26262606E-06_JPRB, 0.26367854E-06_JPRB, 0.26435416E-06_JPRB, 0.26452113E-06_JPRB, 0.26410652E-06_JPRB, &
  & 0.26308456E-06_JPRB, 0.26146324E-06_JPRB, 0.25929495E-06_JPRB, 0.25664852E-06_JPRB, 0.25357616E-06_JPRB, 0.25009126E-06_JPRB, &
  & 0.24618524E-06_JPRB, 0.24189157E-06_JPRB, 0.23726872E-06_JPRB, 0.23238711E-06_JPRB, 0.22734038E-06_JPRB, 0.22225909E-06_JPRB, &
  & 0.21730015E-06_JPRB, 0.21259997E-06_JPRB, 0.20822407E-06_JPRB, 0.20420755E-06_JPRB, 0.20059227E-06_JPRB, 0.19737384E-06_JPRB, &
  & 0.19450864E-06_JPRB, 0.19175310E-06_JPRB, 0.18862977E-06_JPRB, 0.18339446E-06_JPRB /)

RGHG3(:,20, 2) = (/ &
  & 0.23806415E-06_JPRB, 0.24054415E-06_JPRB, 0.24226404E-06_JPRB, 0.24401371E-06_JPRB, 0.24594496E-06_JPRB, 0.24810024E-06_JPRB, &
  & 0.25044724E-06_JPRB, 0.25294037E-06_JPRB, 0.25552961E-06_JPRB, 0.25818233E-06_JPRB, 0.26086826E-06_JPRB, 0.26355690E-06_JPRB, &
  & 0.26622556E-06_JPRB, 0.26881904E-06_JPRB, 0.27133513E-06_JPRB, 0.27376296E-06_JPRB, 0.27604193E-06_JPRB, 0.27811143E-06_JPRB, &
  & 0.27989458E-06_JPRB, 0.28131544E-06_JPRB, 0.28230423E-06_JPRB, 0.28280905E-06_JPRB, 0.28280056E-06_JPRB, 0.28228195E-06_JPRB, &
  & 0.28129176E-06_JPRB, 0.27991189E-06_JPRB, 0.27826749E-06_JPRB, 0.27654147E-06_JPRB, 0.27489961E-06_JPRB, 0.27344768E-06_JPRB, &
  & 0.27233358E-06_JPRB, 0.27161332E-06_JPRB, 0.27133888E-06_JPRB, 0.27150472E-06_JPRB, 0.27206642E-06_JPRB, 0.27294314E-06_JPRB, &
  & 0.27397604E-06_JPRB, 0.27495634E-06_JPRB, 0.27566409E-06_JPRB, 0.27593777E-06_JPRB, 0.27571386E-06_JPRB, 0.27497646E-06_JPRB, &
  & 0.27373576E-06_JPRB, 0.27201563E-06_JPRB, 0.26986797E-06_JPRB, 0.26733679E-06_JPRB, 0.26445670E-06_JPRB, 0.26121768E-06_JPRB, &
  & 0.25764842E-06_JPRB, 0.25378924E-06_JPRB, 0.24969785E-06_JPRB, 0.24544181E-06_JPRB, 0.24110278E-06_JPRB, 0.23678302E-06_JPRB, &
  & 0.23259317E-06_JPRB, 0.22862206E-06_JPRB, 0.22490813E-06_JPRB, 0.22144138E-06_JPRB, 0.21823280E-06_JPRB, 0.21528055E-06_JPRB, &
  & 0.21252609E-06_JPRB, 0.20973621E-06_JPRB, 0.20663823E-06_JPRB, 0.20093334E-06_JPRB /)

RGHG3(:,21, 2) = (/ &
  & 0.24393469E-06_JPRB, 0.24676643E-06_JPRB, 0.24859838E-06_JPRB, 0.25040495E-06_JPRB, 0.25238705E-06_JPRB, 0.25457652E-06_JPRB, &
  & 0.25696198E-06_JPRB, 0.25949208E-06_JPRB, 0.26211944E-06_JPRB, 0.26479623E-06_JPRB, 0.26747995E-06_JPRB, 0.27013294E-06_JPRB, &
  & 0.27272560E-06_JPRB, 0.27522049E-06_JPRB, 0.27759356E-06_JPRB, 0.27982912E-06_JPRB, 0.28188848E-06_JPRB, 0.28371491E-06_JPRB, &
  & 0.28524997E-06_JPRB, 0.28643100E-06_JPRB, 0.28720254E-06_JPRB, 0.28752652E-06_JPRB, 0.28739140E-06_JPRB, 0.28681177E-06_JPRB, &
  & 0.28585990E-06_JPRB, 0.28464692E-06_JPRB, 0.28333412E-06_JPRB, 0.28209587E-06_JPRB, 0.28108252E-06_JPRB, 0.28044045E-06_JPRB, &
  & 0.28020827E-06_JPRB, 0.28037201E-06_JPRB, 0.28088772E-06_JPRB, 0.28162719E-06_JPRB, 0.28254200E-06_JPRB, 0.28352437E-06_JPRB, &
  & 0.28442543E-06_JPRB, 0.28507569E-06_JPRB, 0.28535490E-06_JPRB, 0.28519702E-06_JPRB, 0.28459553E-06_JPRB, 0.28356831E-06_JPRB, &
  & 0.28214481E-06_JPRB, 0.28035439E-06_JPRB, 0.27822540E-06_JPRB, 0.27579105E-06_JPRB, 0.27305978E-06_JPRB, 0.27005041E-06_JPRB, &
  & 0.26680911E-06_JPRB, 0.26336886E-06_JPRB, 0.25979122E-06_JPRB, 0.25613656E-06_JPRB, 0.25246979E-06_JPRB, 0.24886165E-06_JPRB, &
  & 0.24538605E-06_JPRB, 0.24209450E-06_JPRB, 0.23898957E-06_JPRB, 0.23606154E-06_JPRB, 0.23329068E-06_JPRB, 0.23065826E-06_JPRB, &
  & 0.22808482E-06_JPRB, 0.22549213E-06_JPRB, 0.22228477E-06_JPRB, 0.21684627E-06_JPRB /)

RGHG3(:,22, 2) = (/ &
  & 0.24940579E-06_JPRB, 0.25218662E-06_JPRB, 0.25400058E-06_JPRB, 0.25582898E-06_JPRB, 0.25782316E-06_JPRB, 0.26002908E-06_JPRB, &
  & 0.26240951E-06_JPRB, 0.26492432E-06_JPRB, 0.26752392E-06_JPRB, 0.27016270E-06_JPRB, 0.27279975E-06_JPRB, 0.27538991E-06_JPRB, &
  & 0.27790065E-06_JPRB, 0.28030095E-06_JPRB, 0.28256261E-06_JPRB, 0.28466172E-06_JPRB, 0.28656552E-06_JPRB, 0.28823101E-06_JPRB, &
  & 0.28960943E-06_JPRB, 0.29065436E-06_JPRB, 0.29132553E-06_JPRB, 0.29159423E-06_JPRB, 0.29145622E-06_JPRB, 0.29095060E-06_JPRB, &
  & 0.29014180E-06_JPRB, 0.28917600E-06_JPRB, 0.28820367E-06_JPRB, 0.28740297E-06_JPRB, 0.28691142E-06_JPRB, 0.28684030E-06_JPRB, &
  & 0.28718770E-06_JPRB, 0.28789776E-06_JPRB, 0.28881036E-06_JPRB, 0.28984763E-06_JPRB, 0.29087462E-06_JPRB, 0.29177397E-06_JPRB, &
  & 0.29244109E-06_JPRB, 0.29277373E-06_JPRB, 0.29270748E-06_JPRB, 0.29223071E-06_JPRB, 0.29136817E-06_JPRB, 0.29015817E-06_JPRB, &
  & 0.28863883E-06_JPRB, 0.28683053E-06_JPRB, 0.28475822E-06_JPRB, 0.28243099E-06_JPRB, 0.27986826E-06_JPRB, 0.27712196E-06_JPRB, &
  & 0.27420731E-06_JPRB, 0.27117875E-06_JPRB, 0.26809178E-06_JPRB, 0.26499487E-06_JPRB, 0.26193442E-06_JPRB, 0.25895190E-06_JPRB, &
  & 0.25608750E-06_JPRB, 0.25336308E-06_JPRB, 0.25077654E-06_JPRB, 0.24829473E-06_JPRB, 0.24589744E-06_JPRB, 0.24355256E-06_JPRB, &
  & 0.24122045E-06_JPRB, 0.23869953E-06_JPRB, 0.23579656E-06_JPRB, 0.23032190E-06_JPRB /)

RGHG3(:,23, 2) = (/ &
  & 0.25424814E-06_JPRB, 0.25703332E-06_JPRB, 0.25885097E-06_JPRB, 0.26061073E-06_JPRB, 0.26254341E-06_JPRB, 0.26468354E-06_JPRB, &
  & 0.26701022E-06_JPRB, 0.26946148E-06_JPRB, 0.27198860E-06_JPRB, 0.27454954E-06_JPRB, 0.27710286E-06_JPRB, 0.27960584E-06_JPRB, &
  & 0.28202487E-06_JPRB, 0.28432785E-06_JPRB, 0.28649157E-06_JPRB, 0.28848996E-06_JPRB, 0.29029368E-06_JPRB, 0.29186953E-06_JPRB, &
  & 0.29317974E-06_JPRB, 0.29418624E-06_JPRB, 0.29485631E-06_JPRB, 0.29517335E-06_JPRB, 0.29514385E-06_JPRB, 0.29479776E-06_JPRB, &
  & 0.29422520E-06_JPRB, 0.29354240E-06_JPRB, 0.29289157E-06_JPRB, 0.29242830E-06_JPRB, 0.29229295E-06_JPRB, 0.29254386E-06_JPRB, &
  & 0.29317951E-06_JPRB, 0.29407491E-06_JPRB, 0.29511887E-06_JPRB, 0.29617257E-06_JPRB, 0.29711492E-06_JPRB, 0.29784863E-06_JPRB, &
  & 0.29828576E-06_JPRB, 0.29836860E-06_JPRB, 0.29806395E-06_JPRB, 0.29739451E-06_JPRB, 0.29639585E-06_JPRB, 0.29511401E-06_JPRB, &
  & 0.29358367E-06_JPRB, 0.29182260E-06_JPRB, 0.28984158E-06_JPRB, 0.28765430E-06_JPRB, 0.28530854E-06_JPRB, 0.28282724E-06_JPRB, &
  & 0.28024800E-06_JPRB, 0.27762141E-06_JPRB, 0.27499433E-06_JPRB, 0.27240233E-06_JPRB, 0.26986930E-06_JPRB, 0.26741540E-06_JPRB, &
  & 0.26505370E-06_JPRB, 0.26278906E-06_JPRB, 0.26060530E-06_JPRB, 0.25848001E-06_JPRB, 0.25637871E-06_JPRB, 0.25426849E-06_JPRB, &
  & 0.25209019E-06_JPRB, 0.24977487E-06_JPRB, 0.24687495E-06_JPRB, 0.24173102E-06_JPRB /)

RGHG3(:,24, 2) = (/ &
  & 0.25871924E-06_JPRB, 0.26141649E-06_JPRB, 0.26316840E-06_JPRB, 0.26489175E-06_JPRB, 0.26674383E-06_JPRB, 0.26878510E-06_JPRB, &
  & 0.27100072E-06_JPRB, 0.27334229E-06_JPRB, 0.27575877E-06_JPRB, 0.27820525E-06_JPRB, 0.28064983E-06_JPRB, 0.28305027E-06_JPRB, &
  & 0.28537272E-06_JPRB, 0.28758754E-06_JPRB, 0.28966790E-06_JPRB, 0.29158977E-06_JPRB, 0.29332850E-06_JPRB, 0.29485679E-06_JPRB, &
  & 0.29614642E-06_JPRB, 0.29717128E-06_JPRB, 0.29790908E-06_JPRB, 0.29834811E-06_JPRB, 0.29848806E-06_JPRB, 0.29837051E-06_JPRB, &
  & 0.29806458E-06_JPRB, 0.29766576E-06_JPRB, 0.29729810E-06_JPRB, 0.29708741E-06_JPRB, 0.29714144E-06_JPRB, 0.29752570E-06_JPRB, &
  & 0.29819927E-06_JPRB, 0.29907127E-06_JPRB, 0.30003417E-06_JPRB, 0.30095185E-06_JPRB, 0.30171603E-06_JPRB, 0.30224706E-06_JPRB, &
  & 0.30247770E-06_JPRB, 0.30236984E-06_JPRB, 0.30191620E-06_JPRB, 0.30115100E-06_JPRB, 0.30011086E-06_JPRB, 0.29884049E-06_JPRB, &
  & 0.29736668E-06_JPRB, 0.29569901E-06_JPRB, 0.29384810E-06_JPRB, 0.29184122E-06_JPRB, 0.28971758E-06_JPRB, 0.28750543E-06_JPRB, &
  & 0.28525415E-06_JPRB, 0.28300343E-06_JPRB, 0.28079256E-06_JPRB, 0.27864138E-06_JPRB, 0.27655733E-06_JPRB, 0.27454007E-06_JPRB, &
  & 0.27258289E-06_JPRB, 0.27067924E-06_JPRB, 0.26881455E-06_JPRB, 0.26695591E-06_JPRB, 0.26507516E-06_JPRB, 0.26313819E-06_JPRB, &
  & 0.26110305E-06_JPRB, 0.25884825E-06_JPRB, 0.25613062E-06_JPRB, 0.25111260E-06_JPRB /)

RGHG3(:,25, 2) = (/ &
  & 0.26285448E-06_JPRB, 0.26545894E-06_JPRB, 0.26712442E-06_JPRB, 0.26875404E-06_JPRB, 0.27051939E-06_JPRB, 0.27245449E-06_JPRB, &
  & 0.27454178E-06_JPRB, 0.27674287E-06_JPRB, 0.27901424E-06_JPRB, 0.28132266E-06_JPRB, 0.28363337E-06_JPRB, 0.28591234E-06_JPRB, &
  & 0.28812616E-06_JPRB, 0.29024386E-06_JPRB, 0.29224279E-06_JPRB, 0.29409841E-06_JPRB, 0.29579022E-06_JPRB, 0.29729912E-06_JPRB, &
  & 0.29860621E-06_JPRB, 0.29969084E-06_JPRB, 0.30053315E-06_JPRB, 0.30112167E-06_JPRB, 0.30146094E-06_JPRB, 0.30158481E-06_JPRB, &
  & 0.30154249E-06_JPRB, 0.30140575E-06_JPRB, 0.30127686E-06_JPRB, 0.30123903E-06_JPRB, 0.30139466E-06_JPRB, 0.30177503E-06_JPRB, &
  & 0.30236464E-06_JPRB, 0.30309553E-06_JPRB, 0.30386809E-06_JPRB, 0.30457423E-06_JPRB, 0.30512913E-06_JPRB, 0.30545650E-06_JPRB, &
  & 0.30551149E-06_JPRB, 0.30526405E-06_JPRB, 0.30472529E-06_JPRB, 0.30392908E-06_JPRB, 0.30291056E-06_JPRB, 0.30170267E-06_JPRB, &
  & 0.30032442E-06_JPRB, 0.29878203E-06_JPRB, 0.29708579E-06_JPRB, 0.29526629E-06_JPRB, 0.29335658E-06_JPRB, 0.29140753E-06_JPRB, &
  & 0.28945954E-06_JPRB, 0.28754908E-06_JPRB, 0.28570031E-06_JPRB, 0.28392347E-06_JPRB, 0.28221052E-06_JPRB, 0.28054677E-06_JPRB, &
  & 0.27891514E-06_JPRB, 0.27730101E-06_JPRB, 0.27568109E-06_JPRB, 0.27403019E-06_JPRB, 0.27231681E-06_JPRB, 0.27050731E-06_JPRB, &
  & 0.26856313E-06_JPRB, 0.26641243E-06_JPRB, 0.26376179E-06_JPRB, 0.25891327E-06_JPRB /)

RGHG3(:,26, 2) = (/ &
  & 0.26674016E-06_JPRB, 0.26921930E-06_JPRB, 0.27080503E-06_JPRB, 0.27233739E-06_JPRB, 0.27398835E-06_JPRB, 0.27579665E-06_JPRB, &
  & 0.27774607E-06_JPRB, 0.27979456E-06_JPRB, 0.28190618E-06_JPRB, 0.28405751E-06_JPRB, 0.28622179E-06_JPRB, 0.28836931E-06_JPRB, &
  & 0.29046723E-06_JPRB, 0.29248886E-06_JPRB, 0.29440730E-06_JPRB, 0.29620122E-06_JPRB, 0.29785446E-06_JPRB, 0.29935202E-06_JPRB, &
  & 0.30067804E-06_JPRB, 0.30181639E-06_JPRB, 0.30275396E-06_JPRB, 0.30348417E-06_JPRB, 0.30401088E-06_JPRB, 0.30435632E-06_JPRB, &
  & 0.30454848E-06_JPRB, 0.30463787E-06_JPRB, 0.30469411E-06_JPRB, 0.30478657E-06_JPRB, 0.30497895E-06_JPRB, 0.30530489E-06_JPRB, &
  & 0.30576120E-06_JPRB, 0.30630633E-06_JPRB, 0.30686493E-06_JPRB, 0.30735211E-06_JPRB, 0.30770292E-06_JPRB, 0.30785043E-06_JPRB, &
  & 0.30776360E-06_JPRB, 0.30742260E-06_JPRB, 0.30684626E-06_JPRB, 0.30606549E-06_JPRB, 0.30510333E-06_JPRB, 0.30398442E-06_JPRB, &
  & 0.30272113E-06_JPRB, 0.30131545E-06_JPRB, 0.29977804E-06_JPRB, 0.29813913E-06_JPRB, 0.29643991E-06_JPRB, 0.29473043E-06_JPRB, &
  & 0.29305238E-06_JPRB, 0.29143186E-06_JPRB, 0.28988660E-06_JPRB, 0.28841563E-06_JPRB, 0.28700128E-06_JPRB, 0.28562198E-06_JPRB, &
  & 0.28425256E-06_JPRB, 0.28286834E-06_JPRB, 0.28144848E-06_JPRB, 0.27996168E-06_JPRB, 0.27837973E-06_JPRB, 0.27667221E-06_JPRB, &
  & 0.27480655E-06_JPRB, 0.27272182E-06_JPRB, 0.27015494E-06_JPRB, 0.26547644E-06_JPRB /)

RGHG3(:,27, 2) = (/ &
  & 0.27043325E-06_JPRB, 0.27277989E-06_JPRB, 0.27427325E-06_JPRB, 0.27570582E-06_JPRB, 0.27723269E-06_JPRB, 0.27890371E-06_JPRB, &
  & 0.28069962E-06_JPRB, 0.28258688E-06_JPRB, 0.28452996E-06_JPRB, 0.28651232E-06_JPRB, 0.28851937E-06_JPRB, 0.29052265E-06_JPRB, &
  & 0.29249867E-06_JPRB, 0.29441549E-06_JPRB, 0.29625258E-06_JPRB, 0.29798838E-06_JPRB, 0.29960464E-06_JPRB, 0.30108478E-06_JPRB, &
  & 0.30241668E-06_JPRB, 0.30359104E-06_JPRB, 0.30460097E-06_JPRB, 0.30544234E-06_JPRB, 0.30611682E-06_JPRB, 0.30663642E-06_JPRB, &
  & 0.30701685E-06_JPRB, 0.30728850E-06_JPRB, 0.30749050E-06_JPRB, 0.30767592E-06_JPRB, 0.30788564E-06_JPRB, 0.30815403E-06_JPRB, &
  & 0.30848494E-06_JPRB, 0.30885496E-06_JPRB, 0.30921592E-06_JPRB, 0.30950878E-06_JPRB, 0.30968309E-06_JPRB, 0.30968667E-06_JPRB, &
  & 0.30949724E-06_JPRB, 0.30910522E-06_JPRB, 0.30852718E-06_JPRB, 0.30778645E-06_JPRB, 0.30690154E-06_JPRB, 0.30588649E-06_JPRB, &
  & 0.30474661E-06_JPRB, 0.30348042E-06_JPRB, 0.30210143E-06_JPRB, 0.30063245E-06_JPRB, 0.29912090E-06_JPRB, 0.29762214E-06_JPRB, &
  & 0.29616780E-06_JPRB, 0.29478608E-06_JPRB, 0.29348504E-06_JPRB, 0.29225410E-06_JPRB, 0.29107599E-06_JPRB, 0.28991820E-06_JPRB, &
  & 0.28875434E-06_JPRB, 0.28755954E-06_JPRB, 0.28630257E-06_JPRB, 0.28495739E-06_JPRB, 0.28349083E-06_JPRB, 0.28187503E-06_JPRB, &
  & 0.28009129E-06_JPRB, 0.27808929E-06_JPRB, 0.27564204E-06_JPRB, 0.27115362E-06_JPRB /)

RGHG3(:,28, 2) = (/ &
  & 0.27396058E-06_JPRB, 0.27618134E-06_JPRB, 0.27757176E-06_JPRB, 0.27889160E-06_JPRB, 0.28029720E-06_JPRB, 0.28182185E-06_JPRB, &
  & 0.28346213E-06_JPRB, 0.28518338E-06_JPRB, 0.28695416E-06_JPRB, 0.28876534E-06_JPRB, 0.29060581E-06_JPRB, 0.29246121E-06_JPRB, &
  & 0.29430328E-06_JPRB, 0.29611195E-06_JPRB, 0.29786145E-06_JPRB, 0.29952980E-06_JPRB, 0.30109808E-06_JPRB, 0.30255225E-06_JPRB, &
  & 0.30388145E-06_JPRB, 0.30507638E-06_JPRB, 0.30613177E-06_JPRB, 0.30704652E-06_JPRB, 0.30782357E-06_JPRB, 0.30846800E-06_JPRB, &
  & 0.30898653E-06_JPRB, 0.30939202E-06_JPRB, 0.30970608E-06_JPRB, 0.30995943E-06_JPRB, 0.31018303E-06_JPRB, 0.31040503E-06_JPRB, &
  & 0.31063445E-06_JPRB, 0.31086373E-06_JPRB, 0.31106671E-06_JPRB, 0.31120368E-06_JPRB, 0.31123926E-06_JPRB, 0.31113697E-06_JPRB, &
  & 0.31088143E-06_JPRB, 0.31046923E-06_JPRB, 0.30991379E-06_JPRB, 0.30923528E-06_JPRB, 0.30844203E-06_JPRB, 0.30753625E-06_JPRB, &
  & 0.30651890E-06_JPRB, 0.30538968E-06_JPRB, 0.30415450E-06_JPRB, 0.30284292E-06_JPRB, 0.30150144E-06_JPRB, 0.30017355E-06_JPRB, &
  & 0.29890566E-06_JPRB, 0.29771243E-06_JPRB, 0.29660077E-06_JPRB, 0.29555622E-06_JPRB, 0.29455410E-06_JPRB, 0.29356681E-06_JPRB, &
  & 0.29256495E-06_JPRB, 0.29151860E-06_JPRB, 0.29040118E-06_JPRB, 0.28917771E-06_JPRB, 0.28781909E-06_JPRB, 0.28630089E-06_JPRB, &
  & 0.28461648E-06_JPRB, 0.28273317E-06_JPRB, 0.28045298E-06_JPRB, 0.27621999E-06_JPRB /)

RGHG3(:,29, 2) = (/ &
  & 0.27735067E-06_JPRB, 0.27943460E-06_JPRB, 0.28071909E-06_JPRB, 0.28192994E-06_JPRB, 0.28320022E-06_JPRB, 0.28458538E-06_JPRB, &
  & 0.28606942E-06_JPRB, 0.28762767E-06_JPRB, 0.28922767E-06_JPRB, 0.29086900E-06_JPRB, 0.29254119E-06_JPRB, 0.29424351E-06_JPRB, &
  & 0.29595992E-06_JPRB, 0.29765908E-06_JPRB, 0.29931982E-06_JPRB, 0.30091974E-06_JPRB, 0.30243947E-06_JPRB, 0.30386019E-06_JPRB, &
  & 0.30516972E-06_JPRB, 0.30636011E-06_JPRB, 0.30743050E-06_JPRB, 0.30838126E-06_JPRB, 0.30921657E-06_JPRB, 0.30993874E-06_JPRB, &
  & 0.31054637E-06_JPRB, 0.31104051E-06_JPRB, 0.31142849E-06_JPRB, 0.31172985E-06_JPRB, 0.31196453E-06_JPRB, 0.31215455E-06_JPRB, &
  & 0.31231443E-06_JPRB, 0.31244241E-06_JPRB, 0.31253046E-06_JPRB, 0.31255274E-06_JPRB, 0.31248868E-06_JPRB, 0.31231588E-06_JPRB, &
  & 0.31202472E-06_JPRB, 0.31161875E-06_JPRB, 0.31110903E-06_JPRB, 0.31050422E-06_JPRB, 0.30980323E-06_JPRB, 0.30900515E-06_JPRB, &
  & 0.30810580E-06_JPRB, 0.30710157E-06_JPRB, 0.30600305E-06_JPRB, 0.30483261E-06_JPRB, 0.30363228E-06_JPRB, 0.30245468E-06_JPRB, &
  & 0.30133069E-06_JPRB, 0.30028696E-06_JPRB, 0.29931900E-06_JPRB, 0.29841155E-06_JPRB, 0.29754358E-06_JPRB, 0.29668365E-06_JPRB, &
  & 0.29580335E-06_JPRB, 0.29487745E-06_JPRB, 0.29386959E-06_JPRB, 0.29275390E-06_JPRB, 0.29149578E-06_JPRB, 0.29008407E-06_JPRB, &
  & 0.28851971E-06_JPRB, 0.28681316E-06_JPRB, 0.28472226E-06_JPRB, 0.28091642E-06_JPRB /)

RGHG3(:,30, 2) = (/ &
  & 0.28060191E-06_JPRB, 0.28255218E-06_JPRB, 0.28372622E-06_JPRB, 0.28481463E-06_JPRB, 0.28596315E-06_JPRB, 0.28720422E-06_JPRB, &
  & 0.28854058E-06_JPRB, 0.28994074E-06_JPRB, 0.29138027E-06_JPRB, 0.29285397E-06_JPRB, 0.29436507E-06_JPRB, 0.29591035E-06_JPRB, &
  & 0.29748890E-06_JPRB, 0.29908426E-06_JPRB, 0.30066582E-06_JPRB, 0.30220554E-06_JPRB, 0.30367701E-06_JPRB, 0.30506112E-06_JPRB, &
  & 0.30634126E-06_JPRB, 0.30751193E-06_JPRB, 0.30857387E-06_JPRB, 0.30953180E-06_JPRB, 0.31039028E-06_JPRB, 0.31114857E-06_JPRB, &
  & 0.31180204E-06_JPRB, 0.31234043E-06_JPRB, 0.31277122E-06_JPRB, 0.31309816E-06_JPRB, 0.31333911E-06_JPRB, 0.31350874E-06_JPRB, &
  & 0.31362555E-06_JPRB, 0.31368577E-06_JPRB, 0.31369814E-06_JPRB, 0.31364289E-06_JPRB, 0.31351593E-06_JPRB, 0.31330484E-06_JPRB, &
  & 0.31300763E-06_JPRB, 0.31262789E-06_JPRB, 0.31216939E-06_JPRB, 0.31163606E-06_JPRB, 0.31102508E-06_JPRB, 0.31032764E-06_JPRB, &
  & 0.30953680E-06_JPRB, 0.30864723E-06_JPRB, 0.30766731E-06_JPRB, 0.30662130E-06_JPRB, 0.30554870E-06_JPRB, 0.30448950E-06_JPRB, &
  & 0.30348932E-06_JPRB, 0.30255836E-06_JPRB, 0.30169878E-06_JPRB, 0.30089643E-06_JPRB, 0.30012382E-06_JPRB, 0.29935936E-06_JPRB, &
  & 0.29857225E-06_JPRB, 0.29773571E-06_JPRB, 0.29682104E-06_JPRB, 0.29579422E-06_JPRB, 0.29463271E-06_JPRB, 0.29332847E-06_JPRB, &
  & 0.29192168E-06_JPRB, 0.29039356E-06_JPRB, 0.28861729E-06_JPRB, 0.28523468E-06_JPRB /)

RGHG3(:,31, 2) = (/ &
  & 0.28372565E-06_JPRB, 0.28551540E-06_JPRB, 0.28658306E-06_JPRB, 0.28756119E-06_JPRB, 0.28857988E-06_JPRB, 0.28969220E-06_JPRB, &
  & 0.29088844E-06_JPRB, 0.29214141E-06_JPRB, 0.29343124E-06_JPRB, 0.29474973E-06_JPRB, 0.29610626E-06_JPRB, 0.29751183E-06_JPRB, &
  & 0.29896177E-06_JPRB, 0.30044583E-06_JPRB, 0.30194437E-06_JPRB, 0.30342329E-06_JPRB, 0.30484932E-06_JPRB, 0.30619444E-06_JPRB, &
  & 0.30744206E-06_JPRB, 0.30858476E-06_JPRB, 0.30962528E-06_JPRB, 0.31056962E-06_JPRB, 0.31142281E-06_JPRB, 0.31218252E-06_JPRB, &
  & 0.31284330E-06_JPRB, 0.31339150E-06_JPRB, 0.31383448E-06_JPRB, 0.31416670E-06_JPRB, 0.31440646E-06_JPRB, 0.31456329E-06_JPRB, &
  & 0.31465228E-06_JPRB, 0.31467277E-06_JPRB, 0.31463983E-06_JPRB, 0.31453899E-06_JPRB, 0.31437881E-06_JPRB, 0.31415283E-06_JPRB, &
  & 0.31386392E-06_JPRB, 0.31351610E-06_JPRB, 0.31311174E-06_JPRB, 0.31265159E-06_JPRB, 0.31212517E-06_JPRB, 0.31151998E-06_JPRB, &
  & 0.31082450E-06_JPRB, 0.31003336E-06_JPRB, 0.30915851E-06_JPRB, 0.30822008E-06_JPRB, 0.30725369E-06_JPRB, 0.30630460E-06_JPRB, &
  & 0.30539934E-06_JPRB, 0.30456277E-06_JPRB, 0.30378749E-06_JPRB, 0.30306012E-06_JPRB, 0.30236237E-06_JPRB, 0.30166655E-06_JPRB, &
  & 0.30095043E-06_JPRB, 0.30018700E-06_JPRB, 0.29934583E-06_JPRB, 0.29839896E-06_JPRB, 0.29732570E-06_JPRB, 0.29614213E-06_JPRB, &
  & 0.29488669E-06_JPRB, 0.29359623E-06_JPRB, 0.29205862E-06_JPRB, 0.28924046E-06_JPRB /)

RGHG3(:,32, 2) = (/ &
  & 0.28668745E-06_JPRB, 0.28833452E-06_JPRB, 0.28928829E-06_JPRB, 0.29015607E-06_JPRB, 0.29106417E-06_JPRB, 0.29205154E-06_JPRB, &
  & 0.29312105E-06_JPRB, 0.29424041E-06_JPRB, 0.29539132E-06_JPRB, 0.29656519E-06_JPRB, 0.29777820E-06_JPRB, 0.29904507E-06_JPRB, &
  & 0.30037677E-06_JPRB, 0.30176361E-06_JPRB, 0.30318239E-06_JPRB, 0.30460120E-06_JPRB, 0.30598139E-06_JPRB, 0.30728992E-06_JPRB, &
  & 0.30850441E-06_JPRB, 0.30961607E-06_JPRB, 0.31062643E-06_JPRB, 0.31154315E-06_JPRB, 0.31236763E-06_JPRB, 0.31310407E-06_JPRB, &
  & 0.31373767E-06_JPRB, 0.31426944E-06_JPRB, 0.31469648E-06_JPRB, 0.31501833E-06_JPRB, 0.31524780E-06_JPRB, 0.31539454E-06_JPRB, &
  & 0.31546455E-06_JPRB, 0.31546753E-06_JPRB, 0.31541060E-06_JPRB, 0.31529171E-06_JPRB, 0.31512133E-06_JPRB, 0.31489887E-06_JPRB, &
  & 0.31463222E-06_JPRB, 0.31432444E-06_JPRB, 0.31397508E-06_JPRB, 0.31357882E-06_JPRB, 0.31312356E-06_JPRB, 0.31259421E-06_JPRB, &
  & 0.31197695E-06_JPRB, 0.31126865E-06_JPRB, 0.31047756E-06_JPRB, 0.30963082E-06_JPRB, 0.30876024E-06_JPRB, 0.30789852E-06_JPRB, &
  & 0.30708296E-06_JPRB, 0.30632086E-06_JPRB, 0.30561287E-06_JPRB, 0.30494789E-06_JPRB, 0.30430414E-06_JPRB, 0.30366414E-06_JPRB, &
  & 0.30300387E-06_JPRB, 0.30229967E-06_JPRB, 0.30152410E-06_JPRB, 0.30064916E-06_JPRB, 0.29966628E-06_JPRB, 0.29859754E-06_JPRB, &
  & 0.29750828E-06_JPRB, 0.29639645E-06_JPRB, 0.29514419E-06_JPRB, 0.29276976E-06_JPRB /)

RGHG3(:,33, 2) = (/ &
  & 0.28948222E-06_JPRB, 0.29096961E-06_JPRB, 0.29183434E-06_JPRB, 0.29260622E-06_JPRB, 0.29340893E-06_JPRB, 0.29428966E-06_JPRB, &
  & 0.29524392E-06_JPRB, 0.29624221E-06_JPRB, 0.29726641E-06_JPRB, 0.29830787E-06_JPRB, 0.29938795E-06_JPRB, 0.30052709E-06_JPRB, &
  & 0.30173888E-06_JPRB, 0.30302641E-06_JPRB, 0.30437224E-06_JPRB, 0.30573901E-06_JPRB, 0.30708114E-06_JPRB, 0.30835889E-06_JPRB, &
  & 0.30954413E-06_JPRB, 0.31062328E-06_JPRB, 0.31159919E-06_JPRB, 0.31247475E-06_JPRB, 0.31325737E-06_JPRB, 0.31394333E-06_JPRB, &
  & 0.31453135E-06_JPRB, 0.31502145E-06_JPRB, 0.31541197E-06_JPRB, 0.31570968E-06_JPRB, 0.31592054E-06_JPRB, 0.31605560E-06_JPRB, &
  & 0.31611444E-06_JPRB, 0.31611296E-06_JPRB, 0.31605018E-06_JPRB, 0.31593419E-06_JPRB, 0.31577147E-06_JPRB, 0.31556894E-06_JPRB, &
  & 0.31533432E-06_JPRB, 0.31506849E-06_JPRB, 0.31476978E-06_JPRB, 0.31442983E-06_JPRB, 0.31403266E-06_JPRB, 0.31356109E-06_JPRB, &
  & 0.31300428E-06_JPRB, 0.31235729E-06_JPRB, 0.31163583E-06_JPRB, 0.31086324E-06_JPRB, 0.31006977E-06_JPRB, 0.30929161E-06_JPRB, &
  & 0.30854699E-06_JPRB, 0.30785228E-06_JPRB, 0.30720230E-06_JPRB, 0.30658614E-06_JPRB, 0.30599008E-06_JPRB, 0.30539405E-06_JPRB, &
  & 0.30478168E-06_JPRB, 0.30412943E-06_JPRB, 0.30341269E-06_JPRB, 0.30260847E-06_JPRB, 0.30171310E-06_JPRB, 0.30076032E-06_JPRB, &
  & 0.29980561E-06_JPRB, 0.29887175E-06_JPRB, 0.29780028E-06_JPRB, 0.29584342E-06_JPRB /)

RGHG3(:,34, 2) = (/ &
  & 0.29207723E-06_JPRB, 0.29344758E-06_JPRB, 0.29421611E-06_JPRB, 0.29490604E-06_JPRB, 0.29562293E-06_JPRB, 0.29640651E-06_JPRB, &
  & 0.29725837E-06_JPRB, 0.29814913E-06_JPRB, 0.29905672E-06_JPRB, 0.29997759E-06_JPRB, 0.30093477E-06_JPRB, 0.30195488E-06_JPRB, &
  & 0.30306168E-06_JPRB, 0.30425946E-06_JPRB, 0.30553372E-06_JPRB, 0.30684680E-06_JPRB, 0.30815224E-06_JPRB, 0.30940282E-06_JPRB, &
  & 0.31055913E-06_JPRB, 0.31160735E-06_JPRB, 0.31254405E-06_JPRB, 0.31337316E-06_JPRB, 0.31409635E-06_JPRB, 0.31472112E-06_JPRB, &
  & 0.31524240E-06_JPRB, 0.31567436E-06_JPRB, 0.31601343E-06_JPRB, 0.31627368E-06_JPRB, 0.31645899E-06_JPRB, 0.31657760E-06_JPRB, &
  & 0.31663120E-06_JPRB, 0.31663174E-06_JPRB, 0.31657814E-06_JPRB, 0.31647843E-06_JPRB, 0.31633755E-06_JPRB, 0.31616557E-06_JPRB, &
  & 0.31596716E-06_JPRB, 0.31574447E-06_JPRB, 0.31549439E-06_JPRB, 0.31520435E-06_JPRB, 0.31485555E-06_JPRB, 0.31443014E-06_JPRB, &
  & 0.31391482E-06_JPRB, 0.31331507E-06_JPRB, 0.31264386E-06_JPRB, 0.31193036E-06_JPRB, 0.31120487E-06_JPRB, 0.31049069E-06_JPRB, &
  & 0.30981292E-06_JPRB, 0.30917420E-06_JPRB, 0.30857402E-06_JPRB, 0.30800263E-06_JPRB, 0.30744465E-06_JPRB, 0.30688852E-06_JPRB, &
  & 0.30631699E-06_JPRB, 0.30571084E-06_JPRB, 0.30504864E-06_JPRB, 0.30431312E-06_JPRB, 0.30350435E-06_JPRB, 0.30265639E-06_JPRB, &
  & 0.30182525E-06_JPRB, 0.30100827E-06_JPRB, 0.30010688E-06_JPRB, 0.29842661E-06_JPRB /)

RGHG3(:,35, 2) = (/ &
  & 0.29449706E-06_JPRB, 0.29574048E-06_JPRB, 0.29644400E-06_JPRB, 0.29706254E-06_JPRB, 0.29770260E-06_JPRB, 0.29840635E-06_JPRB, &
  & 0.29916683E-06_JPRB, 0.29995999E-06_JPRB, 0.30076103E-06_JPRB, 0.30157219E-06_JPRB, 0.30241480E-06_JPRB, 0.30331995E-06_JPRB, &
  & 0.30431741E-06_JPRB, 0.30542617E-06_JPRB, 0.30663554E-06_JPRB, 0.30790454E-06_JPRB, 0.30918017E-06_JPRB, 0.31040594E-06_JPRB, &
  & 0.31153758E-06_JPRB, 0.31255448E-06_JPRB, 0.31344979E-06_JPRB, 0.31422402E-06_JPRB, 0.31488077E-06_JPRB, 0.31542913E-06_JPRB, &
  & 0.31587214E-06_JPRB, 0.31623091E-06_JPRB, 0.31650495E-06_JPRB, 0.31671814E-06_JPRB, 0.31686909E-06_JPRB, 0.31696740E-06_JPRB, &
  & 0.31701606E-06_JPRB, 0.31702109E-06_JPRB, 0.31698372E-06_JPRB, 0.31690732E-06_JPRB, 0.31679718E-06_JPRB, 0.31666025E-06_JPRB, &
  & 0.31650114E-06_JPRB, 0.31632260E-06_JPRB, 0.31611748E-06_JPRB, 0.31587280E-06_JPRB, 0.31556934E-06_JPRB, 0.31518536E-06_JPRB, &
  & 0.31471171E-06_JPRB, 0.31414623E-06_JPRB, 0.31351661E-06_JPRB, 0.31285018E-06_JPRB, 0.31217559E-06_JPRB, 0.31152123E-06_JPRB, &
  & 0.31089462E-06_JPRB, 0.31030595E-06_JPRB, 0.30974908E-06_JPRB, 0.30921387E-06_JPRB, 0.30869177E-06_JPRB, 0.30816929E-06_JPRB, &
  & 0.30763312E-06_JPRB, 0.30706767E-06_JPRB, 0.30645666E-06_JPRB, 0.30578440E-06_JPRB, 0.30505871E-06_JPRB, 0.30430789E-06_JPRB, &
  & 0.30357501E-06_JPRB, 0.30286796E-06_JPRB, 0.30207136E-06_JPRB, 0.30063131E-06_JPRB /)

RGHG3(:,36, 2) = (/ &
  & 0.29674138E-06_JPRB, 0.29788828E-06_JPRB, 0.29851958E-06_JPRB, 0.29907966E-06_JPRB, 0.29965932E-06_JPRB, 0.30029045E-06_JPRB, &
  & 0.30097189E-06_JPRB, 0.30167666E-06_JPRB, 0.30238127E-06_JPRB, 0.30308908E-06_JPRB, 0.30382495E-06_JPRB, 0.30462274E-06_JPRB, &
  & 0.30551860E-06_JPRB, 0.30653874E-06_JPRB, 0.30768004E-06_JPRB, 0.30890416E-06_JPRB, 0.31015071E-06_JPRB, 0.31135383E-06_JPRB, &
  & 0.31246185E-06_JPRB, 0.31344766E-06_JPRB, 0.31429647E-06_JPRB, 0.31500758E-06_JPRB, 0.31558486E-06_JPRB, 0.31604353E-06_JPRB, &
  & 0.31639590E-06_JPRB, 0.31667022E-06_JPRB, 0.31687654E-06_JPRB, 0.31703556E-06_JPRB, 0.31715129E-06_JPRB, 0.31722814E-06_JPRB, &
  & 0.31727006E-06_JPRB, 0.31727876E-06_JPRB, 0.31725529E-06_JPRB, 0.31720057E-06_JPRB, 0.31711855E-06_JPRB, 0.31701393E-06_JPRB, &
  & 0.31689112E-06_JPRB, 0.31675052E-06_JPRB, 0.31658575E-06_JPRB, 0.31638484E-06_JPRB, 0.31612751E-06_JPRB, 0.31579367E-06_JPRB, &
  & 0.31536445E-06_JPRB, 0.31484635E-06_JPRB, 0.31425500E-06_JPRB, 0.31363089E-06_JPRB, 0.31300453E-06_JPRB, 0.31239387E-06_JPRB, &
  & 0.31181455E-06_JPRB, 0.31126584E-06_JPRB, 0.31074396E-06_JPRB, 0.31024246E-06_JPRB, 0.30974968E-06_JPRB, 0.30925679E-06_JPRB, &
  & 0.30875239E-06_JPRB, 0.30822474E-06_JPRB, 0.30765872E-06_JPRB, 0.30704865E-06_JPRB, 0.30639731E-06_JPRB, 0.30573452E-06_JPRB, &
  & 0.30509196E-06_JPRB, 0.30446563E-06_JPRB, 0.30377083E-06_JPRB, 0.30250351E-06_JPRB /)

RGHG3(:,37, 2) = (/ &
  & 0.29884808E-06_JPRB, 0.29988462E-06_JPRB, 0.30046311E-06_JPRB, 0.30097044E-06_JPRB, 0.30149647E-06_JPRB, 0.30207016E-06_JPRB, &
  & 0.30268100E-06_JPRB, 0.30330563E-06_JPRB, 0.30392181E-06_JPRB, 0.30453475E-06_JPRB, 0.30516878E-06_JPRB, 0.30585943E-06_JPRB, &
  & 0.30665333E-06_JPRB, 0.30758332E-06_JPRB, 0.30865831E-06_JPRB, 0.30983790E-06_JPRB, 0.31105367E-06_JPRB, 0.31223362E-06_JPRB, &
  & 0.31331845E-06_JPRB, 0.31426529E-06_JPRB, 0.31505405E-06_JPRB, 0.31568666E-06_JPRB, 0.31616511E-06_JPRB, 0.31652428E-06_JPRB, &
  & 0.31678448E-06_JPRB, 0.31698065E-06_JPRB, 0.31712631E-06_JPRB, 0.31724139E-06_JPRB, 0.31732736E-06_JPRB, 0.31738767E-06_JPRB, &
  & 0.31742337E-06_JPRB, 0.31743363E-06_JPRB, 0.31741894E-06_JPRB, 0.31737912E-06_JPRB, 0.31731699E-06_JPRB, 0.31723599E-06_JPRB, &
  & 0.31713972E-06_JPRB, 0.31702791E-06_JPRB, 0.31689552E-06_JPRB, 0.31673176E-06_JPRB, 0.31651939E-06_JPRB, 0.31623642E-06_JPRB, &
  & 0.31586748E-06_JPRB, 0.31540162E-06_JPRB, 0.31486383E-06_JPRB, 0.31428382E-06_JPRB, 0.31369916E-06_JPRB, 0.31313115E-06_JPRB, &
  & 0.31258801E-06_JPRB, 0.31207264E-06_JPRB, 0.31158157E-06_JPRB, 0.31110682E-06_JPRB, 0.31064130E-06_JPRB, 0.31017595E-06_JPRB, &
  & 0.30970205E-06_JPRB, 0.30921024E-06_JPRB, 0.30869069E-06_JPRB, 0.30813601E-06_JPRB, 0.30755578E-06_JPRB, 0.30696975E-06_JPRB, &
  & 0.30640405E-06_JPRB, 0.30585318E-06_JPRB, 0.30524134E-06_JPRB, 0.30413119E-06_JPRB /)

RGHG3(:,38, 2) = (/ &
  & 0.30081839E-06_JPRB, 0.30175724E-06_JPRB, 0.30227375E-06_JPRB, 0.30274026E-06_JPRB, 0.30322275E-06_JPRB, 0.30374673E-06_JPRB, &
  & 0.30429752E-06_JPRB, 0.30484881E-06_JPRB, 0.30538436E-06_JPRB, 0.30590880E-06_JPRB, 0.30644702E-06_JPRB, 0.30703902E-06_JPRB, &
  & 0.30772776E-06_JPRB, 0.30856475E-06_JPRB, 0.30956258E-06_JPRB, 0.31069260E-06_JPRB, 0.31187568E-06_JPRB, 0.31302676E-06_JPRB, &
  & 0.31407689E-06_JPRB, 0.31497109E-06_JPRB, 0.31568010E-06_JPRB, 0.31620948E-06_JPRB, 0.31658882E-06_JPRB, 0.31685406E-06_JPRB, &
  & 0.31704135E-06_JPRB, 0.31717960E-06_JPRB, 0.31728445E-06_JPRB, 0.31736914E-06_JPRB, 0.31743593E-06_JPRB, 0.31748522E-06_JPRB, &
  & 0.31751625E-06_JPRB, 0.31752720E-06_JPRB, 0.31751756E-06_JPRB, 0.31748667E-06_JPRB, 0.31743707E-06_JPRB, 0.31737162E-06_JPRB, &
  & 0.31729346E-06_JPRB, 0.31720180E-06_JPRB, 0.31709283E-06_JPRB, 0.31695717E-06_JPRB, 0.31678005E-06_JPRB, 0.31654372E-06_JPRB, &
  & 0.31622838E-06_JPRB, 0.31582587E-06_JPRB, 0.31534367E-06_JPRB, 0.31481630E-06_JPRB, 0.31427518E-06_JPRB, 0.31374441E-06_JPRB, &
  & 0.31323393E-06_JPRB, 0.31274689E-06_JPRB, 0.31227970E-06_JPRB, 0.31182907E-06_JPRB, 0.31138788E-06_JPRB, 0.31095001E-06_JPRB, &
  & 0.31050880E-06_JPRB, 0.31005573E-06_JPRB, 0.30958293E-06_JPRB, 0.30908515E-06_JPRB, 0.30856825E-06_JPRB, 0.30805066E-06_JPRB, &
  & 0.30755047E-06_JPRB, 0.30706590E-06_JPRB, 0.30652220E-06_JPRB, 0.30555393E-06_JPRB /)

RGHG3(:,39, 2) = (/ &
  & 0.30266165E-06_JPRB, 0.30348798E-06_JPRB, 0.30396083E-06_JPRB, 0.30438403E-06_JPRB, 0.30483517E-06_JPRB, 0.30531703E-06_JPRB, &
  & 0.30581467E-06_JPRB, 0.30629991E-06_JPRB, 0.30676043E-06_JPRB, 0.30720400E-06_JPRB, 0.30765779E-06_JPRB, 0.30815318E-06_JPRB, &
  & 0.30874713E-06_JPRB, 0.30948468E-06_JPRB, 0.31040409E-06_JPRB, 0.31147414E-06_JPRB, 0.31261561E-06_JPRB, 0.31372755E-06_JPRB, &
  & 0.31471868E-06_JPRB, 0.31553373E-06_JPRB, 0.31614340E-06_JPRB, 0.31657356E-06_JPRB, 0.31686568E-06_JPRB, 0.31706404E-06_JPRB, &
  & 0.31720325E-06_JPRB, 0.31730579E-06_JPRB, 0.31738563E-06_JPRB, 0.31745225E-06_JPRB, 0.31750702E-06_JPRB, 0.31754934E-06_JPRB, &
  & 0.31757730E-06_JPRB, 0.31758833E-06_JPRB, 0.31758145E-06_JPRB, 0.31755613E-06_JPRB, 0.31751441E-06_JPRB, 0.31745938E-06_JPRB, &
  & 0.31739341E-06_JPRB, 0.31731619E-06_JPRB, 0.31722382E-06_JPRB, 0.31710846E-06_JPRB, 0.31695819E-06_JPRB, 0.31675691E-06_JPRB, &
  & 0.31648864E-06_JPRB, 0.31614070E-06_JPRB, 0.31571770E-06_JPRB, 0.31524220E-06_JPRB, 0.31474576E-06_JPRB, 0.31425162E-06_JPRB, &
  & 0.31377220E-06_JPRB, 0.31330796E-06_JPRB, 0.31286206E-06_JPRB, 0.31243115E-06_JPRB, 0.31201236E-06_JPRB, 0.31160246E-06_JPRB, &
  & 0.31119498E-06_JPRB, 0.31078528E-06_JPRB, 0.31036217E-06_JPRB, 0.30992126E-06_JPRB, 0.30946489E-06_JPRB, 0.30900770E-06_JPRB, &
  & 0.30856677E-06_JPRB, 0.30813476E-06_JPRB, 0.30766148E-06_JPRB, 0.30680772E-06_JPRB /)

RGHG3(:,40, 2) = (/ &
  & 0.30434978E-06_JPRB, 0.30508349E-06_JPRB, 0.30550271E-06_JPRB, 0.30590050E-06_JPRB, 0.30631983E-06_JPRB, 0.30677006E-06_JPRB, &
  & 0.30721910E-06_JPRB, 0.30764323E-06_JPRB, 0.30803702E-06_JPRB, 0.30841048E-06_JPRB, 0.30878650E-06_JPRB, 0.30920384E-06_JPRB, &
  & 0.30970216E-06_JPRB, 0.31034625E-06_JPRB, 0.31117554E-06_JPRB, 0.31217979E-06_JPRB, 0.31326942E-06_JPRB, 0.31432498E-06_JPRB, &
  & 0.31524169E-06_JPRB, 0.31595496E-06_JPRB, 0.31646829E-06_JPRB, 0.31681327E-06_JPRB, 0.31704428E-06_JPRB, 0.31719878E-06_JPRB, &
  & 0.31730855E-06_JPRB, 0.31738978E-06_JPRB, 0.31745512E-06_JPRB, 0.31751057E-06_JPRB, 0.31755795E-06_JPRB, 0.31759569E-06_JPRB, &
  & 0.31762144E-06_JPRB, 0.31763219E-06_JPRB, 0.31762681E-06_JPRB, 0.31760499E-06_JPRB, 0.31756855E-06_JPRB, 0.31752057E-06_JPRB, &
  & 0.31746339E-06_JPRB, 0.31739643E-06_JPRB, 0.31731639E-06_JPRB, 0.31721640E-06_JPRB, 0.31708618E-06_JPRB, 0.31691226E-06_JPRB, &
  & 0.31668014E-06_JPRB, 0.31637745E-06_JPRB, 0.31600530E-06_JPRB, 0.31557980E-06_JPRB, 0.31512906E-06_JPRB, 0.31467340E-06_JPRB, &
  & 0.31422141E-06_JPRB, 0.31378053E-06_JPRB, 0.31335091E-06_JPRB, 0.31293524E-06_JPRB, 0.31253643E-06_JPRB, 0.31215242E-06_JPRB, &
  & 0.31178200E-06_JPRB, 0.31141579E-06_JPRB, 0.31104548E-06_JPRB, 0.31066085E-06_JPRB, 0.31026386E-06_JPRB, 0.30986433E-06_JPRB, &
  & 0.30947527E-06_JPRB, 0.30909703E-06_JPRB, 0.30867275E-06_JPRB, 0.30792881E-06_JPRB /)

RGHG3(:,41, 2) = (/ &
  & 0.30587910E-06_JPRB, 0.30652356E-06_JPRB, 0.30690646E-06_JPRB, 0.30727330E-06_JPRB, 0.30767367E-06_JPRB, 0.30809250E-06_JPRB, &
  & 0.30849770E-06_JPRB, 0.30886858E-06_JPRB, 0.30920208E-06_JPRB, 0.30951543E-06_JPRB, 0.30982909E-06_JPRB, 0.31017467E-06_JPRB, &
  & 0.31059784E-06_JPRB, 0.31115135E-06_JPRB, 0.31189276E-06_JPRB, 0.31282224E-06_JPRB, 0.31384658E-06_JPRB, 0.31483376E-06_JPRB, &
  & 0.31565622E-06_JPRB, 0.31627138E-06_JPRB, 0.31669603E-06_JPRB, 0.31697724E-06_JPRB, 0.31716507E-06_JPRB, 0.31729107E-06_JPRB, &
  & 0.31738250E-06_JPRB, 0.31745066E-06_JPRB, 0.31750687E-06_JPRB, 0.31755567E-06_JPRB, 0.31759797E-06_JPRB, 0.31763261E-06_JPRB, &
  & 0.31765623E-06_JPRB, 0.31766641E-06_JPRB, 0.31766183E-06_JPRB, 0.31764216E-06_JPRB, 0.31760931E-06_JPRB, 0.31756650E-06_JPRB, &
  & 0.31751583E-06_JPRB, 0.31745685E-06_JPRB, 0.31738628E-06_JPRB, 0.31729826E-06_JPRB, 0.31718395E-06_JPRB, 0.31703152E-06_JPRB, &
  & 0.31682828E-06_JPRB, 0.31656327E-06_JPRB, 0.31623404E-06_JPRB, 0.31585512E-06_JPRB, 0.31544621E-06_JPRB, 0.31502711E-06_JPRB, &
  & 0.31460650E-06_JPRB, 0.31418574E-06_JPRB, 0.31376933E-06_JPRB, 0.31336697E-06_JPRB, 0.31298242E-06_JPRB, 0.31262465E-06_JPRB, &
  & 0.31228836E-06_JPRB, 0.31196689E-06_JPRB, 0.31164660E-06_JPRB, 0.31131825E-06_JPRB, 0.31097861E-06_JPRB, 0.31063502E-06_JPRB, &
  & 0.31029833E-06_JPRB, 0.30996398E-06_JPRB, 0.30959424E-06_JPRB, 0.30893688E-06_JPRB /)

RGHG3(:,42, 2) = (/ &
  & 0.30725005E-06_JPRB, 0.30782024E-06_JPRB, 0.30816773E-06_JPRB, 0.30851112E-06_JPRB, 0.30889004E-06_JPRB, 0.30928121E-06_JPRB, &
  & 0.30964671E-06_JPRB, 0.30996893E-06_JPRB, 0.31025365E-06_JPRB, 0.31051647E-06_JPRB, 0.31077894E-06_JPRB, 0.31106907E-06_JPRB, &
  & 0.31142451E-06_JPRB, 0.31190228E-06_JPRB, 0.31255860E-06_JPRB, 0.31340849E-06_JPRB, 0.31436230E-06_JPRB, 0.31525872E-06_JPRB, &
  & 0.31598955E-06_JPRB, 0.31650967E-06_JPRB, 0.31686318E-06_JPRB, 0.31709578E-06_JPRB, 0.31725250E-06_JPRB, 0.31735951E-06_JPRB, &
  & 0.31743855E-06_JPRB, 0.31749838E-06_JPRB, 0.31754897E-06_JPRB, 0.31759296E-06_JPRB, 0.31763201E-06_JPRB, 0.31766385E-06_JPRB, &
  & 0.31768570E-06_JPRB, 0.31769491E-06_JPRB, 0.31769059E-06_JPRB, 0.31767235E-06_JPRB, 0.31764213E-06_JPRB, 0.31760311E-06_JPRB, &
  & 0.31755738E-06_JPRB, 0.31750457E-06_JPRB, 0.31744176E-06_JPRB, 0.31736374E-06_JPRB, 0.31726250E-06_JPRB, 0.31712798E-06_JPRB, &
  & 0.31694898E-06_JPRB, 0.31671436E-06_JPRB, 0.31642216E-06_JPRB, 0.31608175E-06_JPRB, 0.31571437E-06_JPRB, 0.31533239E-06_JPRB, &
  & 0.31494173E-06_JPRB, 0.31454229E-06_JPRB, 0.31414081E-06_JPRB, 0.31374526E-06_JPRB, 0.31337731E-06_JPRB, 0.31304191E-06_JPRB, &
  & 0.31274013E-06_JPRB, 0.31245975E-06_JPRB, 0.31218713E-06_JPRB, 0.31191018E-06_JPRB, 0.31162500E-06_JPRB, 0.31133547E-06_JPRB, &
  & 0.31104781E-06_JPRB, 0.31075996E-06_JPRB, 0.31043291E-06_JPRB, 0.30985586E-06_JPRB /)

RGHG3(:,43, 2) = (/ &
  & 0.30847704E-06_JPRB, 0.30898519E-06_JPRB, 0.30930045E-06_JPRB, 0.30962030E-06_JPRB, 0.30997612E-06_JPRB, 0.31033943E-06_JPRB, &
  & 0.31066921E-06_JPRB, 0.31095135E-06_JPRB, 0.31119669E-06_JPRB, 0.31141929E-06_JPRB, 0.31164177E-06_JPRB, 0.31188651E-06_JPRB, &
  & 0.31218994E-06_JPRB, 0.31260075E-06_JPRB, 0.31318339E-06_JPRB, 0.31395368E-06_JPRB, 0.31482449E-06_JPRB, 0.31562971E-06_JPRB, &
  & 0.31625615E-06_JPRB, 0.31669626E-06_JPRB, 0.31699017E-06_JPRB, 0.31718596E-06_JPRB, 0.31731980E-06_JPRB, 0.31741351E-06_JPRB, &
  & 0.31748385E-06_JPRB, 0.31753831E-06_JPRB, 0.31758489E-06_JPRB, 0.31762610E-06_JPRB, 0.31766228E-06_JPRB, 0.31769210E-06_JPRB, &
  & 0.31771174E-06_JPRB, 0.31771984E-06_JPRB, 0.31771532E-06_JPRB, 0.31769798E-06_JPRB, 0.31766962E-06_JPRB, 0.31763355E-06_JPRB, &
  & 0.31759166E-06_JPRB, 0.31754382E-06_JPRB, 0.31748743E-06_JPRB, 0.31741774E-06_JPRB, 0.31732790E-06_JPRB, 0.31720884E-06_JPRB, &
  & 0.31705071E-06_JPRB, 0.31684320E-06_JPRB, 0.31658257E-06_JPRB, 0.31627846E-06_JPRB, 0.31594632E-06_JPRB, 0.31560006E-06_JPRB, &
  & 0.31523993E-06_JPRB, 0.31486519E-06_JPRB, 0.31447681E-06_JPRB, 0.31409644E-06_JPRB, 0.31374165E-06_JPRB, 0.31343203E-06_JPRB, &
  & 0.31316256E-06_JPRB, 0.31291989E-06_JPRB, 0.31268902E-06_JPRB, 0.31245770E-06_JPRB, 0.31222075E-06_JPRB, 0.31198039E-06_JPRB, &
  & 0.31173965E-06_JPRB, 0.31149293E-06_JPRB, 0.31120982E-06_JPRB, 0.31070229E-06_JPRB /)

RGHG3(:,44, 2) = (/ &
  & 0.30957756E-06_JPRB, 0.31003796E-06_JPRB, 0.31032022E-06_JPRB, 0.31061575E-06_JPRB, 0.31094623E-06_JPRB, 0.31128292E-06_JPRB, &
  & 0.31158129E-06_JPRB, 0.31183484E-06_JPRB, 0.31204786E-06_JPRB, 0.31224147E-06_JPRB, 0.31243076E-06_JPRB, 0.31264020E-06_JPRB, &
  & 0.31289957E-06_JPRB, 0.31325609E-06_JPRB, 0.31376928E-06_JPRB, 0.31446538E-06_JPRB, 0.31524516E-06_JPRB, 0.31594672E-06_JPRB, &
  & 0.31647824E-06_JPRB, 0.31684374E-06_JPRB, 0.31709035E-06_JPRB, 0.31725705E-06_JPRB, 0.31737400E-06_JPRB, 0.31745770E-06_JPRB, &
  & 0.31752199E-06_JPRB, 0.31757295E-06_JPRB, 0.31761698E-06_JPRB, 0.31765609E-06_JPRB, 0.31769054E-06_JPRB, 0.31771793E-06_JPRB, &
  & 0.31773570E-06_JPRB, 0.31774226E-06_JPRB, 0.31773715E-06_JPRB, 0.31772026E-06_JPRB, 0.31769326E-06_JPRB, 0.31765933E-06_JPRB, &
  & 0.31762059E-06_JPRB, 0.31757693E-06_JPRB, 0.31752586E-06_JPRB, 0.31746333E-06_JPRB, 0.31738335E-06_JPRB, 0.31727797E-06_JPRB, &
  & 0.31713842E-06_JPRB, 0.31695504E-06_JPRB, 0.31672317E-06_JPRB, 0.31645007E-06_JPRB, 0.31615207E-06_JPRB, 0.31583849E-06_JPRB, &
  & 0.31550968E-06_JPRB, 0.31515989E-06_JPRB, 0.31479476E-06_JPRB, 0.31442963E-06_JPRB, 0.31409871E-06_JPRB, 0.31381518E-06_JPRB, &
  & 0.31357692E-06_JPRB, 0.31336816E-06_JPRB, 0.31317248E-06_JPRB, 0.31297964E-06_JPRB, 0.31278398E-06_JPRB, 0.31258639E-06_JPRB, &
  & 0.31238699E-06_JPRB, 0.31217971E-06_JPRB, 0.31193514E-06_JPRB, 0.31149250E-06_JPRB /)

RGHG3(:,45, 2) = (/ &
  & 0.31058187E-06_JPRB, 0.31098483E-06_JPRB, 0.31125040E-06_JPRB, 0.31151438E-06_JPRB, 0.31182259E-06_JPRB, 0.31213281E-06_JPRB, &
  & 0.31241180E-06_JPRB, 0.31263974E-06_JPRB, 0.31283369E-06_JPRB, 0.31300220E-06_JPRB, 0.31316716E-06_JPRB, 0.31334665E-06_JPRB, &
  & 0.31356723E-06_JPRB, 0.31387660E-06_JPRB, 0.31432486E-06_JPRB, 0.31494022E-06_JPRB, 0.31562556E-06_JPRB, 0.31621943E-06_JPRB, &
  & 0.31665900E-06_JPRB, 0.31696271E-06_JPRB, 0.31716982E-06_JPRB, 0.31731480E-06_JPRB, 0.31741786E-06_JPRB, 0.31749511E-06_JPRB, &
  & 0.31755488E-06_JPRB, 0.31760348E-06_JPRB, 0.31764623E-06_JPRB, 0.31768400E-06_JPRB, 0.31771663E-06_JPRB, 0.31774215E-06_JPRB, &
  & 0.31775767E-06_JPRB, 0.31776267E-06_JPRB, 0.31775670E-06_JPRB, 0.31773988E-06_JPRB, 0.31771378E-06_JPRB, 0.31768155E-06_JPRB, &
  & 0.31764534E-06_JPRB, 0.31760496E-06_JPRB, 0.31755837E-06_JPRB, 0.31750193E-06_JPRB, 0.31743045E-06_JPRB, 0.31733725E-06_JPRB, &
  & 0.31721490E-06_JPRB, 0.31705414E-06_JPRB, 0.31684982E-06_JPRB, 0.31660687E-06_JPRB, 0.31633948E-06_JPRB, 0.31605751E-06_JPRB, &
  & 0.31575843E-06_JPRB, 0.31543789E-06_JPRB, 0.31509660E-06_JPRB, 0.31476091E-06_JPRB, 0.31445532E-06_JPRB, 0.31420430E-06_JPRB, &
  & 0.31399577E-06_JPRB, 0.31381657E-06_JPRB, 0.31365133E-06_JPRB, 0.31348955E-06_JPRB, 0.31332800E-06_JPRB, 0.31316597E-06_JPRB, &
  & 0.31300206E-06_JPRB, 0.31282909E-06_JPRB, 0.31262181E-06_JPRB, 0.31223917E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART4',0,ZHOOK_HANDLE)



RGHG3(:,46, 2) = (/ &
  & 0.31148673E-06_JPRB, 0.31186667E-06_JPRB, 0.31209419E-06_JPRB, 0.31234526E-06_JPRB, 0.31262408E-06_JPRB, 0.31291759E-06_JPRB, &
  & 0.31317745E-06_JPRB, 0.31339434E-06_JPRB, 0.31356939E-06_JPRB, 0.31372119E-06_JPRB, 0.31386475E-06_JPRB, 0.31401692E-06_JPRB, &
  & 0.31420723E-06_JPRB, 0.31446314E-06_JPRB, 0.31485493E-06_JPRB, 0.31538121E-06_JPRB, 0.31596016E-06_JPRB, 0.31645041E-06_JPRB, &
  & 0.31680770E-06_JPRB, 0.31705787E-06_JPRB, 0.31723422E-06_JPRB, 0.31736099E-06_JPRB, 0.31745509E-06_JPRB, 0.31752663E-06_JPRB, &
  & 0.31758367E-06_JPRB, 0.31763145E-06_JPRB, 0.31767280E-06_JPRB, 0.31771000E-06_JPRB, 0.31774138E-06_JPRB, 0.31776452E-06_JPRB, &
  & 0.31777796E-06_JPRB, 0.31778120E-06_JPRB, 0.31777421E-06_JPRB, 0.31775721E-06_JPRB, 0.31773166E-06_JPRB, 0.31770071E-06_JPRB, &
  & 0.31766649E-06_JPRB, 0.31762892E-06_JPRB, 0.31758589E-06_JPRB, 0.31753461E-06_JPRB, 0.31747041E-06_JPRB, 0.31738810E-06_JPRB, &
  & 0.31728138E-06_JPRB, 0.31714254E-06_JPRB, 0.31696547E-06_JPRB, 0.31675287E-06_JPRB, 0.31651686E-06_JPRB, 0.31626513E-06_JPRB, &
  & 0.31599754E-06_JPRB, 0.31570559E-06_JPRB, 0.31539778E-06_JPRB, 0.31508938E-06_JPRB, 0.31482330E-06_JPRB, 0.31460041E-06_JPRB, &
  & 0.31442354E-06_JPRB, 0.31427058E-06_JPRB, 0.31413038E-06_JPRB, 0.31399497E-06_JPRB, 0.31386062E-06_JPRB, 0.31372741E-06_JPRB, &
  & 0.31359303E-06_JPRB, 0.31345024E-06_JPRB, 0.31327573E-06_JPRB, 0.31295048E-06_JPRB /)

RGHG3(:,47, 2) = (/ &
  & 0.31233139E-06_JPRB, 0.31266620E-06_JPRB, 0.31288761E-06_JPRB, 0.31310893E-06_JPRB, 0.31337365E-06_JPRB, 0.31364928E-06_JPRB, &
  & 0.31389985E-06_JPRB, 0.31410474E-06_JPRB, 0.31426768E-06_JPRB, 0.31440410E-06_JPRB, 0.31452737E-06_JPRB, 0.31465885E-06_JPRB, &
  & 0.31481193E-06_JPRB, 0.31503404E-06_JPRB, 0.31534336E-06_JPRB, 0.31578688E-06_JPRB, 0.31625117E-06_JPRB, 0.31664175E-06_JPRB, &
  & 0.31692829E-06_JPRB, 0.31713486E-06_JPRB, 0.31728558E-06_JPRB, 0.31739938E-06_JPRB, 0.31748544E-06_JPRB, 0.31755425E-06_JPRB, &
  & 0.31760970E-06_JPRB, 0.31765657E-06_JPRB, 0.31769835E-06_JPRB, 0.31773442E-06_JPRB, 0.31776432E-06_JPRB, 0.31778546E-06_JPRB, &
  & 0.31779649E-06_JPRB, 0.31779791E-06_JPRB, 0.31778970E-06_JPRB, 0.31777230E-06_JPRB, 0.31774704E-06_JPRB, 0.31771708E-06_JPRB, &
  & 0.31768457E-06_JPRB, 0.31764912E-06_JPRB, 0.31760928E-06_JPRB, 0.31756210E-06_JPRB, 0.31750420E-06_JPRB, 0.31743127E-06_JPRB, &
  & 0.31733907E-06_JPRB, 0.31722138E-06_JPRB, 0.31707273E-06_JPRB, 0.31689356E-06_JPRB, 0.31669089E-06_JPRB, 0.31647315E-06_JPRB, &
  & 0.31623657E-06_JPRB, 0.31597909E-06_JPRB, 0.31570013E-06_JPRB, 0.31543289E-06_JPRB, 0.31519403E-06_JPRB, 0.31500952E-06_JPRB, &
  & 0.31485703E-06_JPRB, 0.31472911E-06_JPRB, 0.31461096E-06_JPRB, 0.31449650E-06_JPRB, 0.31438472E-06_JPRB, 0.31427473E-06_JPRB, &
  & 0.31416440E-06_JPRB, 0.31404636E-06_JPRB, 0.31390152E-06_JPRB, 0.31362779E-06_JPRB /)

RGHG3(:,48, 2) = (/ &
  & 0.31310796E-06_JPRB, 0.31342236E-06_JPRB, 0.31361887E-06_JPRB, 0.31383064E-06_JPRB, 0.31407660E-06_JPRB, 0.31434112E-06_JPRB, &
  & 0.31458433E-06_JPRB, 0.31477913E-06_JPRB, 0.31493099E-06_JPRB, 0.31505004E-06_JPRB, 0.31515754E-06_JPRB, 0.31526363E-06_JPRB, &
  & 0.31539321E-06_JPRB, 0.31555962E-06_JPRB, 0.31581408E-06_JPRB, 0.31614022E-06_JPRB, 0.31650086E-06_JPRB, 0.31679957E-06_JPRB, &
  & 0.31702592E-06_JPRB, 0.31719637E-06_JPRB, 0.31732739E-06_JPRB, 0.31743008E-06_JPRB, 0.31751213E-06_JPRB, 0.31757833E-06_JPRB, &
  & 0.31763332E-06_JPRB, 0.31768084E-06_JPRB, 0.31772191E-06_JPRB, 0.31775778E-06_JPRB, 0.31778583E-06_JPRB, 0.31780451E-06_JPRB, &
  & 0.31781346E-06_JPRB, 0.31781303E-06_JPRB, 0.31780357E-06_JPRB, 0.31778546E-06_JPRB, 0.31776037E-06_JPRB, 0.31773118E-06_JPRB, &
  & 0.31769986E-06_JPRB, 0.31766632E-06_JPRB, 0.31762877E-06_JPRB, 0.31758520E-06_JPRB, 0.31753240E-06_JPRB, 0.31746782E-06_JPRB, &
  & 0.31738873E-06_JPRB, 0.31729144E-06_JPRB, 0.31717207E-06_JPRB, 0.31702953E-06_JPRB, 0.31686744E-06_JPRB, 0.31668705E-06_JPRB, &
  & 0.31648864E-06_JPRB, 0.31626448E-06_JPRB, 0.31602391E-06_JPRB, 0.31578526E-06_JPRB, 0.31558670E-06_JPRB, 0.31542677E-06_JPRB, &
  & 0.31530192E-06_JPRB, 0.31519377E-06_JPRB, 0.31509413E-06_JPRB, 0.31499769E-06_JPRB, 0.31490328E-06_JPRB, 0.31481150E-06_JPRB, &
  & 0.31471993E-06_JPRB, 0.31462184E-06_JPRB, 0.31450114E-06_JPRB, 0.31427135E-06_JPRB /)

RGHG3(:,49, 2) = (/ &
  & 0.31383172E-06_JPRB, 0.31412205E-06_JPRB, 0.31430847E-06_JPRB, 0.31450614E-06_JPRB, 0.31474161E-06_JPRB, 0.31499926E-06_JPRB, &
  & 0.31523447E-06_JPRB, 0.31542027E-06_JPRB, 0.31555530E-06_JPRB, 0.31565963E-06_JPRB, 0.31574655E-06_JPRB, 0.31583252E-06_JPRB, &
  & 0.31592799E-06_JPRB, 0.31605322E-06_JPRB, 0.31622324E-06_JPRB, 0.31645430E-06_JPRB, 0.31670538E-06_JPRB, 0.31692826E-06_JPRB, &
  & 0.31710516E-06_JPRB, 0.31724608E-06_JPRB, 0.31736099E-06_JPRB, 0.31745600E-06_JPRB, 0.31753450E-06_JPRB, 0.31760035E-06_JPRB, &
  & 0.31765575E-06_JPRB, 0.31770358E-06_JPRB, 0.31774516E-06_JPRB, 0.31777969E-06_JPRB, 0.31780573E-06_JPRB, 0.31782201E-06_JPRB, &
  & 0.31782872E-06_JPRB, 0.31782650E-06_JPRB, 0.31781582E-06_JPRB, 0.31779706E-06_JPRB, 0.31777191E-06_JPRB, 0.31774334E-06_JPRB, &
  & 0.31771313E-06_JPRB, 0.31768096E-06_JPRB, 0.31764537E-06_JPRB, 0.31760453E-06_JPRB, 0.31755624E-06_JPRB, 0.31749889E-06_JPRB, &
  & 0.31743170E-06_JPRB, 0.31735343E-06_JPRB, 0.31726319E-06_JPRB, 0.31716002E-06_JPRB, 0.31704320E-06_JPRB, 0.31690979E-06_JPRB, &
  & 0.31675336E-06_JPRB, 0.31657098E-06_JPRB, 0.31636750E-06_JPRB, 0.31616759E-06_JPRB, 0.31599942E-06_JPRB, 0.31586782E-06_JPRB, &
  & 0.31576366E-06_JPRB, 0.31567316E-06_JPRB, 0.31558830E-06_JPRB, 0.31550539E-06_JPRB, 0.31542424E-06_JPRB, 0.31534560E-06_JPRB, &
  & 0.31526756E-06_JPRB, 0.31518391E-06_JPRB, 0.31508085E-06_JPRB, 0.31488480E-06_JPRB /)

RGHG3(:,50, 2) = (/ &
  & 0.31450210E-06_JPRB, 0.31477427E-06_JPRB, 0.31494778E-06_JPRB, 0.31513855E-06_JPRB, 0.31536803E-06_JPRB, 0.31562266E-06_JPRB, &
  & 0.31584858E-06_JPRB, 0.31601797E-06_JPRB, 0.31613266E-06_JPRB, 0.31621386E-06_JPRB, 0.31627800E-06_JPRB, 0.31633675E-06_JPRB, &
  & 0.31639703E-06_JPRB, 0.31647289E-06_JPRB, 0.31656862E-06_JPRB, 0.31670959E-06_JPRB, 0.31687298E-06_JPRB, 0.31703240E-06_JPRB, &
  & 0.31716957E-06_JPRB, 0.31728700E-06_JPRB, 0.31738901E-06_JPRB, 0.31747786E-06_JPRB, 0.31755502E-06_JPRB, 0.31762079E-06_JPRB, &
  & 0.31767746E-06_JPRB, 0.31772592E-06_JPRB, 0.31776719E-06_JPRB, 0.31780027E-06_JPRB, 0.31782415E-06_JPRB, 0.31783784E-06_JPRB, &
  & 0.31784245E-06_JPRB, 0.31783864E-06_JPRB, 0.31782668E-06_JPRB, 0.31780726E-06_JPRB, 0.31778214E-06_JPRB, 0.31775406E-06_JPRB, &
  & 0.31772464E-06_JPRB, 0.31769363E-06_JPRB, 0.31765956E-06_JPRB, 0.31762102E-06_JPRB, 0.31757637E-06_JPRB, 0.31752526E-06_JPRB, &
  & 0.31746862E-06_JPRB, 0.31740791E-06_JPRB, 0.31734419E-06_JPRB, 0.31727893E-06_JPRB, 0.31720748E-06_JPRB, 0.31712355E-06_JPRB, &
  & 0.31701765E-06_JPRB, 0.31688504E-06_JPRB, 0.31672920E-06_JPRB, 0.31657552E-06_JPRB, 0.31644012E-06_JPRB, 0.31633815E-06_JPRB, &
  & 0.31625154E-06_JPRB, 0.31617671E-06_JPRB, 0.31610401E-06_JPRB, 0.31603082E-06_JPRB, 0.31595863E-06_JPRB, 0.31588846E-06_JPRB, &
  & 0.31581865E-06_JPRB, 0.31574393E-06_JPRB, 0.31565187E-06_JPRB, 0.31547700E-06_JPRB /)

RGHG3(:,51, 2) = (/ &
  & 0.31512141E-06_JPRB, 0.31536615E-06_JPRB, 0.31553819E-06_JPRB, 0.31571707E-06_JPRB, 0.31594740E-06_JPRB, 0.31619075E-06_JPRB, &
  & 0.31640079E-06_JPRB, 0.31653511E-06_JPRB, 0.31661710E-06_JPRB, 0.31666826E-06_JPRB, 0.31670442E-06_JPRB, 0.31673312E-06_JPRB, &
  & 0.31676180E-06_JPRB, 0.31679147E-06_JPRB, 0.31683882E-06_JPRB, 0.31690428E-06_JPRB, 0.31700699E-06_JPRB, 0.31711687E-06_JPRB, &
  & 0.31722359E-06_JPRB, 0.31732182E-06_JPRB, 0.31741325E-06_JPRB, 0.31749761E-06_JPRB, 0.31757358E-06_JPRB, 0.31764068E-06_JPRB, &
  & 0.31769815E-06_JPRB, 0.31774752E-06_JPRB, 0.31778768E-06_JPRB, 0.31781917E-06_JPRB, 0.31784049E-06_JPRB, 0.31785206E-06_JPRB, &
  & 0.31785478E-06_JPRB, 0.31784941E-06_JPRB, 0.31783634E-06_JPRB, 0.31781627E-06_JPRB, 0.31779112E-06_JPRB, 0.31776349E-06_JPRB, &
  & 0.31773482E-06_JPRB, 0.31770469E-06_JPRB, 0.31767186E-06_JPRB, 0.31763523E-06_JPRB, 0.31759373E-06_JPRB, 0.31754811E-06_JPRB, &
  & 0.31750096E-06_JPRB, 0.31745537E-06_JPRB, 0.31741513E-06_JPRB, 0.31737946E-06_JPRB, 0.31734513E-06_JPRB, 0.31730241E-06_JPRB, &
  & 0.31724440E-06_JPRB, 0.31716544E-06_JPRB, 0.31707003E-06_JPRB, 0.31696766E-06_JPRB, 0.31688137E-06_JPRB, 0.31680511E-06_JPRB, &
  & 0.31674438E-06_JPRB, 0.31668506E-06_JPRB, 0.31662526E-06_JPRB, 0.31656302E-06_JPRB, 0.31649859E-06_JPRB, 0.31643498E-06_JPRB, &
  & 0.31637109E-06_JPRB, 0.31630211E-06_JPRB, 0.31621613E-06_JPRB, 0.31605470E-06_JPRB /)

RGHG3(:,52, 2) = (/ &
  & 0.31566199E-06_JPRB, 0.31590568E-06_JPRB, 0.31605097E-06_JPRB, 0.31623472E-06_JPRB, 0.31644214E-06_JPRB, 0.31666593E-06_JPRB, &
  & 0.31681947E-06_JPRB, 0.31690746E-06_JPRB, 0.31695146E-06_JPRB, 0.31697567E-06_JPRB, 0.31698968E-06_JPRB, 0.31699926E-06_JPRB, &
  & 0.31700597E-06_JPRB, 0.31701404E-06_JPRB, 0.31702507E-06_JPRB, 0.31705642E-06_JPRB, 0.31710957E-06_JPRB, 0.31718668E-06_JPRB, &
  & 0.31726927E-06_JPRB, 0.31735334E-06_JPRB, 0.31743599E-06_JPRB, 0.31751654E-06_JPRB, 0.31759208E-06_JPRB, 0.31765956E-06_JPRB, &
  & 0.31771845E-06_JPRB, 0.31776733E-06_JPRB, 0.31780681E-06_JPRB, 0.31783588E-06_JPRB, 0.31785524E-06_JPRB, 0.31786485E-06_JPRB, &
  & 0.31786595E-06_JPRB, 0.31785902E-06_JPRB, 0.31784487E-06_JPRB, 0.31782423E-06_JPRB, 0.31779913E-06_JPRB, 0.31777193E-06_JPRB, &
  & 0.31774380E-06_JPRB, 0.31771455E-06_JPRB, 0.31768272E-06_JPRB, 0.31764776E-06_JPRB, 0.31760902E-06_JPRB, 0.31756846E-06_JPRB, &
  & 0.31752964E-06_JPRB, 0.31749755E-06_JPRB, 0.31747479E-06_JPRB, 0.31746072E-06_JPRB, 0.31744872E-06_JPRB, 0.31743278E-06_JPRB, &
  & 0.31740683E-06_JPRB, 0.31736920E-06_JPRB, 0.31732077E-06_JPRB, 0.31727006E-06_JPRB, 0.31722070E-06_JPRB, 0.31718099E-06_JPRB, &
  & 0.31714194E-06_JPRB, 0.31710488E-06_JPRB, 0.31706418E-06_JPRB, 0.31701779E-06_JPRB, 0.31696896E-06_JPRB, 0.31691832E-06_JPRB, &
  & 0.31686582E-06_JPRB, 0.31680781E-06_JPRB, 0.31673360E-06_JPRB, 0.31658860E-06_JPRB /)

RGHG3(:,53, 2) = (/ &
  & 0.31614513E-06_JPRB, 0.31634303E-06_JPRB, 0.31650009E-06_JPRB, 0.31664555E-06_JPRB, 0.31683348E-06_JPRB, 0.31698892E-06_JPRB, &
  & 0.31708637E-06_JPRB, 0.31712972E-06_JPRB, 0.31714950E-06_JPRB, 0.31715834E-06_JPRB, 0.31716218E-06_JPRB, 0.31716309E-06_JPRB, &
  & 0.31716198E-06_JPRB, 0.31715999E-06_JPRB, 0.31715854E-06_JPRB, 0.31716468E-06_JPRB, 0.31719429E-06_JPRB, 0.31724451E-06_JPRB, &
  & 0.31731025E-06_JPRB, 0.31738247E-06_JPRB, 0.31745881E-06_JPRB, 0.31753589E-06_JPRB, 0.31761030E-06_JPRB, 0.31767837E-06_JPRB, &
  & 0.31773698E-06_JPRB, 0.31778575E-06_JPRB, 0.31782346E-06_JPRB, 0.31785100E-06_JPRB, 0.31786831E-06_JPRB, 0.31787633E-06_JPRB, &
  & 0.31787604E-06_JPRB, 0.31786769E-06_JPRB, 0.31785245E-06_JPRB, 0.31783131E-06_JPRB, 0.31780630E-06_JPRB, 0.31777941E-06_JPRB, &
  & 0.31775184E-06_JPRB, 0.31772328E-06_JPRB, 0.31769258E-06_JPRB, 0.31765907E-06_JPRB, 0.31762315E-06_JPRB, 0.31758717E-06_JPRB, &
  & 0.31755619E-06_JPRB, 0.31753467E-06_JPRB, 0.31752509E-06_JPRB, 0.31752359E-06_JPRB, 0.31752407E-06_JPRB, 0.31752114E-06_JPRB, &
  & 0.31751185E-06_JPRB, 0.31749551E-06_JPRB, 0.31747339E-06_JPRB, 0.31744844E-06_JPRB, 0.31742593E-06_JPRB, 0.31740421E-06_JPRB, &
  & 0.31738517E-06_JPRB, 0.31736454E-06_JPRB, 0.31734106E-06_JPRB, 0.31731417E-06_JPRB, 0.31728342E-06_JPRB, 0.31725119E-06_JPRB, &
  & 0.31721709E-06_JPRB, 0.31717821E-06_JPRB, 0.31712699E-06_JPRB, 0.31702029E-06_JPRB /)

RGHG3(:,54, 2) = (/ &
  & 0.31652215E-06_JPRB, 0.31672454E-06_JPRB, 0.31683334E-06_JPRB, 0.31696749E-06_JPRB, 0.31709118E-06_JPRB, 0.31719225E-06_JPRB, &
  & 0.31723994E-06_JPRB, 0.31726006E-06_JPRB, 0.31726731E-06_JPRB, 0.31726967E-06_JPRB, 0.31726952E-06_JPRB, 0.31726773E-06_JPRB, &
  & 0.31726466E-06_JPRB, 0.31725921E-06_JPRB, 0.31725403E-06_JPRB, 0.31725051E-06_JPRB, 0.31726086E-06_JPRB, 0.31729522E-06_JPRB, &
  & 0.31734720E-06_JPRB, 0.31741118E-06_JPRB, 0.31748186E-06_JPRB, 0.31755610E-06_JPRB, 0.31762903E-06_JPRB, 0.31769605E-06_JPRB, &
  & 0.31775448E-06_JPRB, 0.31780212E-06_JPRB, 0.31783887E-06_JPRB, 0.31786448E-06_JPRB, 0.31788016E-06_JPRB, 0.31788676E-06_JPRB, &
  & 0.31788505E-06_JPRB, 0.31787550E-06_JPRB, 0.31785936E-06_JPRB, 0.31783779E-06_JPRB, 0.31781278E-06_JPRB, 0.31778629E-06_JPRB, &
  & 0.31775920E-06_JPRB, 0.31773129E-06_JPRB, 0.31770165E-06_JPRB, 0.31766984E-06_JPRB, 0.31763653E-06_JPRB, 0.31760536E-06_JPRB, &
  & 0.31758077E-06_JPRB, 0.31756824E-06_JPRB, 0.31756716E-06_JPRB, 0.31757281E-06_JPRB, 0.31757929E-06_JPRB, 0.31758219E-06_JPRB, &
  & 0.31758020E-06_JPRB, 0.31757321E-06_JPRB, 0.31756247E-06_JPRB, 0.31755036E-06_JPRB, 0.31753814E-06_JPRB, 0.31752782E-06_JPRB, &
  & 0.31751728E-06_JPRB, 0.31750639E-06_JPRB, 0.31749374E-06_JPRB, 0.31747820E-06_JPRB, 0.31746106E-06_JPRB, 0.31744270E-06_JPRB, &
  & 0.31742354E-06_JPRB, 0.31740291E-06_JPRB, 0.31737750E-06_JPRB, 0.31733057E-06_JPRB /)

RGHG3(:,55, 2) = (/ &
  & 0.31684087E-06_JPRB, 0.31699082E-06_JPRB, 0.31709649E-06_JPRB, 0.31717821E-06_JPRB, 0.31725966E-06_JPRB, 0.31731199E-06_JPRB, &
  & 0.31733543E-06_JPRB, 0.31734277E-06_JPRB, 0.31734479E-06_JPRB, 0.31734456E-06_JPRB, 0.31734322E-06_JPRB, 0.31734101E-06_JPRB, &
  & 0.31733737E-06_JPRB, 0.31733282E-06_JPRB, 0.31732486E-06_JPRB, 0.31731852E-06_JPRB, 0.31731923E-06_JPRB, 0.31733967E-06_JPRB, &
  & 0.31738202E-06_JPRB, 0.31743900E-06_JPRB, 0.31750557E-06_JPRB, 0.31757651E-06_JPRB, 0.31764756E-06_JPRB, 0.31771313E-06_JPRB, &
  & 0.31777049E-06_JPRB, 0.31781732E-06_JPRB, 0.31785262E-06_JPRB, 0.31787698E-06_JPRB, 0.31789108E-06_JPRB, 0.31789628E-06_JPRB, &
  & 0.31789332E-06_JPRB, 0.31788275E-06_JPRB, 0.31786578E-06_JPRB, 0.31784370E-06_JPRB, 0.31781883E-06_JPRB, 0.31779274E-06_JPRB, &
  & 0.31776611E-06_JPRB, 0.31773894E-06_JPRB, 0.31771046E-06_JPRB, 0.31768039E-06_JPRB, 0.31765012E-06_JPRB, 0.31762298E-06_JPRB, &
  & 0.31760447E-06_JPRB, 0.31759822E-06_JPRB, 0.31760274E-06_JPRB, 0.31761257E-06_JPRB, 0.31762150E-06_JPRB, 0.31762679E-06_JPRB, &
  & 0.31762784E-06_JPRB, 0.31762497E-06_JPRB, 0.31761942E-06_JPRB, 0.31761260E-06_JPRB, 0.31760621E-06_JPRB, 0.31759998E-06_JPRB, &
  & 0.31759430E-06_JPRB, 0.31758807E-06_JPRB, 0.31758060E-06_JPRB, 0.31757182E-06_JPRB, 0.31756144E-06_JPRB, 0.31755059E-06_JPRB, &
  & 0.31753927E-06_JPRB, 0.31752666E-06_JPRB, 0.31751077E-06_JPRB, 0.31747715E-06_JPRB /)

RGHG3(:,56, 2) = (/ &
  & 0.31706941E-06_JPRB, 0.31720234E-06_JPRB, 0.31726498E-06_JPRB, 0.31732020E-06_JPRB, 0.31736437E-06_JPRB, 0.31739086E-06_JPRB, &
  & 0.31740007E-06_JPRB, 0.31740228E-06_JPRB, 0.31740205E-06_JPRB, 0.31740095E-06_JPRB, 0.31739938E-06_JPRB, 0.31739714E-06_JPRB, &
  & 0.31739427E-06_JPRB, 0.31738938E-06_JPRB, 0.31738367E-06_JPRB, 0.31737409E-06_JPRB, 0.31736965E-06_JPRB, 0.31738139E-06_JPRB, &
  & 0.31741541E-06_JPRB, 0.31746688E-06_JPRB, 0.31752916E-06_JPRB, 0.31759743E-06_JPRB, 0.31766564E-06_JPRB, 0.31772973E-06_JPRB, &
  & 0.31778569E-06_JPRB, 0.31783134E-06_JPRB, 0.31786550E-06_JPRB, 0.31788846E-06_JPRB, 0.31790131E-06_JPRB, 0.31790515E-06_JPRB, &
  & 0.31790097E-06_JPRB, 0.31788954E-06_JPRB, 0.31787184E-06_JPRB, 0.31784950E-06_JPRB, 0.31782471E-06_JPRB, 0.31779888E-06_JPRB, &
  & 0.31777284E-06_JPRB, 0.31774650E-06_JPRB, 0.31771924E-06_JPRB, 0.31769110E-06_JPRB, 0.31766362E-06_JPRB, 0.31764074E-06_JPRB, &
  & 0.31762684E-06_JPRB, 0.31762539E-06_JPRB, 0.31763383E-06_JPRB, 0.31764546E-06_JPRB, 0.31765575E-06_JPRB, 0.31766177E-06_JPRB, &
  & 0.31766382E-06_JPRB, 0.31766257E-06_JPRB, 0.31765939E-06_JPRB, 0.31765538E-06_JPRB, 0.31765126E-06_JPRB, 0.31764773E-06_JPRB, &
  & 0.31764409E-06_JPRB, 0.31764023E-06_JPRB, 0.31763562E-06_JPRB, 0.31762983E-06_JPRB, 0.31762335E-06_JPRB, 0.31761644E-06_JPRB, &
  & 0.31760936E-06_JPRB, 0.31760223E-06_JPRB, 0.31759430E-06_JPRB, 0.31758211E-06_JPRB /)

RGHG3(:,57, 2) = (/ &
  & 0.31724562E-06_JPRB, 0.31733663E-06_JPRB, 0.31738125E-06_JPRB, 0.31741229E-06_JPRB, 0.31743460E-06_JPRB, 0.31744639E-06_JPRB, &
  & 0.31744941E-06_JPRB, 0.31744912E-06_JPRB, 0.31744807E-06_JPRB, 0.31744679E-06_JPRB, 0.31744528E-06_JPRB, 0.31744352E-06_JPRB, &
  & 0.31744091E-06_JPRB, 0.31743750E-06_JPRB, 0.31743110E-06_JPRB, 0.31742371E-06_JPRB, 0.31741516E-06_JPRB, 0.31742039E-06_JPRB, &
  & 0.31744821E-06_JPRB, 0.31749448E-06_JPRB, 0.31755312E-06_JPRB, 0.31761783E-06_JPRB, 0.31768406E-06_JPRB, 0.31774576E-06_JPRB, &
  & 0.31780039E-06_JPRB, 0.31784467E-06_JPRB, 0.31787755E-06_JPRB, 0.31789924E-06_JPRB, 0.31791075E-06_JPRB, 0.31791350E-06_JPRB, &
  & 0.31790825E-06_JPRB, 0.31789597E-06_JPRB, 0.31787778E-06_JPRB, 0.31785527E-06_JPRB, 0.31783057E-06_JPRB, 0.31780519E-06_JPRB, &
  & 0.31777969E-06_JPRB, 0.31775423E-06_JPRB, 0.31772822E-06_JPRB, 0.31770207E-06_JPRB, 0.31767757E-06_JPRB, 0.31765819E-06_JPRB, &
  & 0.31764836E-06_JPRB, 0.31765035E-06_JPRB, 0.31766089E-06_JPRB, 0.31767422E-06_JPRB, 0.31768457E-06_JPRB, 0.31769076E-06_JPRB, &
  & 0.31769304E-06_JPRB, 0.31769252E-06_JPRB, 0.31769042E-06_JPRB, 0.31768764E-06_JPRB, 0.31768496E-06_JPRB, 0.31768235E-06_JPRB, &
  & 0.31767988E-06_JPRB, 0.31767718E-06_JPRB, 0.31767382E-06_JPRB, 0.31766990E-06_JPRB, 0.31766518E-06_JPRB, 0.31766024E-06_JPRB, &
  & 0.31765524E-06_JPRB, 0.31764981E-06_JPRB, 0.31764370E-06_JPRB, 0.31763255E-06_JPRB /)

RGHG3(:,58, 2) = (/ &
  & 0.31736917E-06_JPRB, 0.31743275E-06_JPRB, 0.31745901E-06_JPRB, 0.31747510E-06_JPRB, 0.31748638E-06_JPRB, 0.31749033E-06_JPRB, &
  & 0.31749028E-06_JPRB, 0.31748897E-06_JPRB, 0.31748777E-06_JPRB, 0.31748658E-06_JPRB, 0.31748539E-06_JPRB, 0.31748391E-06_JPRB, &
  & 0.31748201E-06_JPRB, 0.31747874E-06_JPRB, 0.31747425E-06_JPRB, 0.31746563E-06_JPRB, 0.31745725E-06_JPRB, 0.31745819E-06_JPRB, &
  & 0.31748067E-06_JPRB, 0.31752251E-06_JPRB, 0.31757702E-06_JPRB, 0.31763895E-06_JPRB, 0.31770205E-06_JPRB, 0.31776216E-06_JPRB, &
  & 0.31781474E-06_JPRB, 0.31785751E-06_JPRB, 0.31788900E-06_JPRB, 0.31790924E-06_JPRB, 0.31791964E-06_JPRB, 0.31792135E-06_JPRB, &
  & 0.31791527E-06_JPRB, 0.31790245E-06_JPRB, 0.31788380E-06_JPRB, 0.31786124E-06_JPRB, 0.31783674E-06_JPRB, 0.31781167E-06_JPRB, &
  & 0.31778694E-06_JPRB, 0.31776230E-06_JPRB, 0.31773774E-06_JPRB, 0.31771367E-06_JPRB, 0.31769184E-06_JPRB, 0.31767573E-06_JPRB, &
  & 0.31766905E-06_JPRB, 0.31767340E-06_JPRB, 0.31768570E-06_JPRB, 0.31769935E-06_JPRB, 0.31771003E-06_JPRB, 0.31771589E-06_JPRB, &
  & 0.31771799E-06_JPRB, 0.31771759E-06_JPRB, 0.31771586E-06_JPRB, 0.31771373E-06_JPRB, 0.31771154E-06_JPRB, 0.31770963E-06_JPRB, &
  & 0.31770767E-06_JPRB, 0.31770554E-06_JPRB, 0.31770304E-06_JPRB, 0.31769986E-06_JPRB, 0.31769619E-06_JPRB, 0.31769230E-06_JPRB, &
  & 0.31768826E-06_JPRB, 0.31768417E-06_JPRB, 0.31767928E-06_JPRB, 0.31767118E-06_JPRB /)

RGHG3(:,59, 2) = (/ &
  & 0.31746055E-06_JPRB, 0.31750125E-06_JPRB, 0.31751512E-06_JPRB, 0.31752344E-06_JPRB, 0.31752742E-06_JPRB, 0.31752779E-06_JPRB, &
  & 0.31752637E-06_JPRB, 0.31752489E-06_JPRB, 0.31752364E-06_JPRB, 0.31752268E-06_JPRB, 0.31752171E-06_JPRB, 0.31752060E-06_JPRB, &
  & 0.31751892E-06_JPRB, 0.31751651E-06_JPRB, 0.31751182E-06_JPRB, 0.31750500E-06_JPRB, 0.31749533E-06_JPRB, 0.31749437E-06_JPRB, &
  & 0.31751301E-06_JPRB, 0.31755070E-06_JPRB, 0.31760158E-06_JPRB, 0.31766004E-06_JPRB, 0.31772072E-06_JPRB, 0.31777816E-06_JPRB, &
  & 0.31782889E-06_JPRB, 0.31786985E-06_JPRB, 0.31789969E-06_JPRB, 0.31791873E-06_JPRB, 0.31792797E-06_JPRB, 0.31792879E-06_JPRB, &
  & 0.31792206E-06_JPRB, 0.31790890E-06_JPRB, 0.31789011E-06_JPRB, 0.31786752E-06_JPRB, 0.31784319E-06_JPRB, 0.31781872E-06_JPRB, &
  & 0.31779467E-06_JPRB, 0.31777100E-06_JPRB, 0.31774778E-06_JPRB, 0.31772561E-06_JPRB, 0.31770642E-06_JPRB, 0.31769315E-06_JPRB, &
  & 0.31768897E-06_JPRB, 0.31769520E-06_JPRB, 0.31770813E-06_JPRB, 0.31772251E-06_JPRB, 0.31773288E-06_JPRB, 0.31773854E-06_JPRB, &
  & 0.31774027E-06_JPRB, 0.31773979E-06_JPRB, 0.31773820E-06_JPRB, 0.31773615E-06_JPRB, 0.31773422E-06_JPRB, 0.31773237E-06_JPRB, &
  & 0.31773072E-06_JPRB, 0.31772890E-06_JPRB, 0.31772663E-06_JPRB, 0.31772399E-06_JPRB, 0.31772083E-06_JPRB, 0.31771754E-06_JPRB, &
  & 0.31771424E-06_JPRB, 0.31771066E-06_JPRB, 0.31770662E-06_JPRB, 0.31769918E-06_JPRB /)

RGHG3(:,60, 2) = (/ &
  & 0.31754445E-06_JPRB, 0.31755491E-06_JPRB, 0.31755980E-06_JPRB, 0.31756221E-06_JPRB, 0.31756298E-06_JPRB, 0.31756159E-06_JPRB, &
  & 0.31755957E-06_JPRB, 0.31755795E-06_JPRB, 0.31755690E-06_JPRB, 0.31755610E-06_JPRB, 0.31755545E-06_JPRB, 0.31755465E-06_JPRB, &
  & 0.31755349E-06_JPRB, 0.31755127E-06_JPRB, 0.31754755E-06_JPRB, 0.31754024E-06_JPRB, 0.31753132E-06_JPRB, 0.31752944E-06_JPRB, &
  & 0.31754527E-06_JPRB, 0.31757943E-06_JPRB, 0.31762667E-06_JPRB, 0.31768192E-06_JPRB, 0.31773953E-06_JPRB, 0.31779464E-06_JPRB, &
  & 0.31784293E-06_JPRB, 0.31788176E-06_JPRB, 0.31791001E-06_JPRB, 0.31792754E-06_JPRB, 0.31793584E-06_JPRB, 0.31793604E-06_JPRB, &
  & 0.31792888E-06_JPRB, 0.31791546E-06_JPRB, 0.31789671E-06_JPRB, 0.31787420E-06_JPRB, 0.31785032E-06_JPRB, 0.31782636E-06_JPRB, &
  & 0.31780300E-06_JPRB, 0.31778032E-06_JPRB, 0.31775852E-06_JPRB, 0.31773817E-06_JPRB, 0.31772120E-06_JPRB, 0.31771040E-06_JPRB, &
  & 0.31770847E-06_JPRB, 0.31771583E-06_JPRB, 0.31772944E-06_JPRB, 0.31774363E-06_JPRB, 0.31775411E-06_JPRB, 0.31775932E-06_JPRB, &
  & 0.31776082E-06_JPRB, 0.31776011E-06_JPRB, 0.31775835E-06_JPRB, 0.31775633E-06_JPRB, 0.31775440E-06_JPRB, 0.31775269E-06_JPRB, &
  & 0.31775099E-06_JPRB, 0.31774914E-06_JPRB, 0.31774698E-06_JPRB, 0.31774442E-06_JPRB, 0.31774158E-06_JPRB, 0.31773862E-06_JPRB, &
  & 0.31773561E-06_JPRB, 0.31773260E-06_JPRB, 0.31772896E-06_JPRB, 0.31772313E-06_JPRB /)

RGHG3(:,61, 2) = (/ &
  & 0.31758498E-06_JPRB, 0.31759251E-06_JPRB, 0.31759475E-06_JPRB, 0.31759552E-06_JPRB, 0.31759495E-06_JPRB, 0.31759294E-06_JPRB, &
  & 0.31759078E-06_JPRB, 0.31758930E-06_JPRB, 0.31758842E-06_JPRB, 0.31758790E-06_JPRB, 0.31758751E-06_JPRB, 0.31758708E-06_JPRB, &
  & 0.31758623E-06_JPRB, 0.31758455E-06_JPRB, 0.31758083E-06_JPRB, 0.31757415E-06_JPRB, 0.31756534E-06_JPRB, 0.31756352E-06_JPRB, &
  & 0.31757747E-06_JPRB, 0.31760851E-06_JPRB, 0.31765228E-06_JPRB, 0.31770429E-06_JPRB, 0.31775875E-06_JPRB, 0.31781099E-06_JPRB, &
  & 0.31785672E-06_JPRB, 0.31789335E-06_JPRB, 0.31791973E-06_JPRB, 0.31793593E-06_JPRB, 0.31794326E-06_JPRB, 0.31794298E-06_JPRB, &
  & 0.31793562E-06_JPRB, 0.31792223E-06_JPRB, 0.31790375E-06_JPRB, 0.31788164E-06_JPRB, 0.31785805E-06_JPRB, 0.31783469E-06_JPRB, &
  & 0.31781215E-06_JPRB, 0.31779041E-06_JPRB, 0.31776986E-06_JPRB, 0.31775119E-06_JPRB, 0.31773627E-06_JPRB, 0.31772765E-06_JPRB, &
  & 0.31772740E-06_JPRB, 0.31773570E-06_JPRB, 0.31774948E-06_JPRB, 0.31776369E-06_JPRB, 0.31777390E-06_JPRB, 0.31777896E-06_JPRB, &
  & 0.31778012E-06_JPRB, 0.31777904E-06_JPRB, 0.31777699E-06_JPRB, 0.31777472E-06_JPRB, 0.31777267E-06_JPRB, 0.31777074E-06_JPRB, &
  & 0.31776895E-06_JPRB, 0.31776699E-06_JPRB, 0.31776477E-06_JPRB, 0.31776221E-06_JPRB, 0.31775943E-06_JPRB, 0.31775659E-06_JPRB, &
  & 0.31775375E-06_JPRB, 0.31775082E-06_JPRB, 0.31774766E-06_JPRB, 0.31774198E-06_JPRB /)

RGHG3(:,62, 2) = (/ &
  & 0.31761954E-06_JPRB, 0.31762437E-06_JPRB, 0.31762562E-06_JPRB, 0.31762562E-06_JPRB, 0.31762460E-06_JPRB, 0.31762266E-06_JPRB, &
  & 0.31762056E-06_JPRB, 0.31761908E-06_JPRB, 0.31761837E-06_JPRB, 0.31761812E-06_JPRB, 0.31761817E-06_JPRB, 0.31761823E-06_JPRB, &
  & 0.31761800E-06_JPRB, 0.31761672E-06_JPRB, 0.31761337E-06_JPRB, 0.31760658E-06_JPRB, 0.31759865E-06_JPRB, 0.31759723E-06_JPRB, &
  & 0.31760968E-06_JPRB, 0.31763787E-06_JPRB, 0.31767851E-06_JPRB, 0.31772717E-06_JPRB, 0.31777839E-06_JPRB, 0.31782736E-06_JPRB, &
  & 0.31787033E-06_JPRB, 0.31790438E-06_JPRB, 0.31792882E-06_JPRB, 0.31794366E-06_JPRB, 0.31795020E-06_JPRB, 0.31794957E-06_JPRB, &
  & 0.31794229E-06_JPRB, 0.31792928E-06_JPRB, 0.31791126E-06_JPRB, 0.31788971E-06_JPRB, 0.31786661E-06_JPRB, 0.31784387E-06_JPRB, &
  & 0.31782201E-06_JPRB, 0.31780121E-06_JPRB, 0.31778177E-06_JPRB, 0.31776460E-06_JPRB, 0.31775153E-06_JPRB, 0.31774479E-06_JPRB, &
  & 0.31774604E-06_JPRB, 0.31775511E-06_JPRB, 0.31776884E-06_JPRB, 0.31778259E-06_JPRB, 0.31779265E-06_JPRB, 0.31779746E-06_JPRB, &
  & 0.31779845E-06_JPRB, 0.31779706E-06_JPRB, 0.31779467E-06_JPRB, 0.31779211E-06_JPRB, 0.31778973E-06_JPRB, 0.31778762E-06_JPRB, &
  & 0.31778555E-06_JPRB, 0.31778342E-06_JPRB, 0.31778103E-06_JPRB, 0.31777836E-06_JPRB, 0.31777552E-06_JPRB, 0.31777267E-06_JPRB, &
  & 0.31776983E-06_JPRB, 0.31776705E-06_JPRB, 0.31776386E-06_JPRB, 0.31775875E-06_JPRB /)

RGHG3(:,63, 2) = (/ &
  & 0.31764887E-06_JPRB, 0.31765299E-06_JPRB, 0.31765387E-06_JPRB, 0.31765370E-06_JPRB, 0.31765273E-06_JPRB, 0.31765094E-06_JPRB, &
  & 0.31764898E-06_JPRB, 0.31764756E-06_JPRB, 0.31764699E-06_JPRB, 0.31764714E-06_JPRB, 0.31764779E-06_JPRB, 0.31764861E-06_JPRB, &
  & 0.31764918E-06_JPRB, 0.31764844E-06_JPRB, 0.31764506E-06_JPRB, 0.31763855E-06_JPRB, 0.31763147E-06_JPRB, 0.31763048E-06_JPRB, &
  & 0.31764185E-06_JPRB, 0.31766760E-06_JPRB, 0.31770517E-06_JPRB, 0.31775048E-06_JPRB, 0.31779820E-06_JPRB, 0.31784390E-06_JPRB, &
  & 0.31788363E-06_JPRB, 0.31791512E-06_JPRB, 0.31793752E-06_JPRB, 0.31795093E-06_JPRB, 0.31795670E-06_JPRB, 0.31795585E-06_JPRB, &
  & 0.31794883E-06_JPRB, 0.31793641E-06_JPRB, 0.31791916E-06_JPRB, 0.31789833E-06_JPRB, 0.31787602E-06_JPRB, 0.31785382E-06_JPRB, &
  & 0.31783270E-06_JPRB, 0.31781266E-06_JPRB, 0.31779433E-06_JPRB, 0.31777853E-06_JPRB, 0.31776705E-06_JPRB, 0.31776199E-06_JPRB, &
  & 0.31776437E-06_JPRB, 0.31777387E-06_JPRB, 0.31778745E-06_JPRB, 0.31780081E-06_JPRB, 0.31781042E-06_JPRB, 0.31781519E-06_JPRB, &
  & 0.31781610E-06_JPRB, 0.31781440E-06_JPRB, 0.31781173E-06_JPRB, 0.31780880E-06_JPRB, 0.31780610E-06_JPRB, 0.31780360E-06_JPRB, &
  & 0.31780127E-06_JPRB, 0.31779882E-06_JPRB, 0.31779609E-06_JPRB, 0.31779319E-06_JPRB, 0.31779018E-06_JPRB, 0.31778723E-06_JPRB, &
  & 0.31778436E-06_JPRB, 0.31778143E-06_JPRB, 0.31777824E-06_JPRB, 0.31777287E-06_JPRB /)

RGHG3(:,64, 2) = (/ &
  & 0.31767564E-06_JPRB, 0.31767951E-06_JPRB, 0.31768042E-06_JPRB, 0.31768036E-06_JPRB, 0.31767959E-06_JPRB, 0.31767817E-06_JPRB, &
  & 0.31767644E-06_JPRB, 0.31767519E-06_JPRB, 0.31767479E-06_JPRB, 0.31767536E-06_JPRB, 0.31767669E-06_JPRB, 0.31767851E-06_JPRB, &
  & 0.31767979E-06_JPRB, 0.31767931E-06_JPRB, 0.31767610E-06_JPRB, 0.31766999E-06_JPRB, 0.31766388E-06_JPRB, 0.31766334E-06_JPRB, &
  & 0.31767379E-06_JPRB, 0.31769738E-06_JPRB, 0.31773209E-06_JPRB, 0.31777390E-06_JPRB, 0.31781798E-06_JPRB, 0.31786004E-06_JPRB, &
  & 0.31789654E-06_JPRB, 0.31792524E-06_JPRB, 0.31794559E-06_JPRB, 0.31795761E-06_JPRB, 0.31796270E-06_JPRB, 0.31796179E-06_JPRB, &
  & 0.31795523E-06_JPRB, 0.31794349E-06_JPRB, 0.31792717E-06_JPRB, 0.31790745E-06_JPRB, 0.31788591E-06_JPRB, 0.31786459E-06_JPRB, &
  & 0.31784401E-06_JPRB, 0.31782480E-06_JPRB, 0.31780741E-06_JPRB, 0.31779291E-06_JPRB, 0.31778282E-06_JPRB, 0.31777918E-06_JPRB, &
  & 0.31778248E-06_JPRB, 0.31779228E-06_JPRB, 0.31780547E-06_JPRB, 0.31781823E-06_JPRB, 0.31782747E-06_JPRB, 0.31783210E-06_JPRB, &
  & 0.31783293E-06_JPRB, 0.31783117E-06_JPRB, 0.31782818E-06_JPRB, 0.31782491E-06_JPRB, 0.31782179E-06_JPRB, 0.31781889E-06_JPRB, &
  & 0.31781613E-06_JPRB, 0.31781326E-06_JPRB, 0.31781019E-06_JPRB, 0.31780698E-06_JPRB, 0.31780371E-06_JPRB, 0.31780053E-06_JPRB, &
  & 0.31779743E-06_JPRB, 0.31779439E-06_JPRB, 0.31779089E-06_JPRB, 0.31778518E-06_JPRB /)

RGHG3(:,65, 2) = (/ &
  & 0.31770003E-06_JPRB, 0.31770429E-06_JPRB, 0.31770549E-06_JPRB, 0.31770571E-06_JPRB, 0.31770529E-06_JPRB, 0.31770423E-06_JPRB, &
  & 0.31770287E-06_JPRB, 0.31770182E-06_JPRB, 0.31770176E-06_JPRB, 0.31770281E-06_JPRB, 0.31770497E-06_JPRB, 0.31770756E-06_JPRB, &
  & 0.31770946E-06_JPRB, 0.31770927E-06_JPRB, 0.31770637E-06_JPRB, 0.31770082E-06_JPRB, 0.31769557E-06_JPRB, 0.31769548E-06_JPRB, &
  & 0.31770537E-06_JPRB, 0.31772700E-06_JPRB, 0.31775880E-06_JPRB, 0.31779715E-06_JPRB, 0.31783733E-06_JPRB, 0.31787565E-06_JPRB, &
  & 0.31790864E-06_JPRB, 0.31793462E-06_JPRB, 0.31795284E-06_JPRB, 0.31796361E-06_JPRB, 0.31796813E-06_JPRB, 0.31796708E-06_JPRB, &
  & 0.31796100E-06_JPRB, 0.31795014E-06_JPRB, 0.31793502E-06_JPRB, 0.31791654E-06_JPRB, 0.31789608E-06_JPRB, 0.31787550E-06_JPRB, &
  & 0.31785581E-06_JPRB, 0.31783736E-06_JPRB, 0.31782099E-06_JPRB, 0.31780769E-06_JPRB, 0.31779894E-06_JPRB, 0.31779641E-06_JPRB, &
  & 0.31780039E-06_JPRB, 0.31781016E-06_JPRB, 0.31782292E-06_JPRB, 0.31783492E-06_JPRB, 0.31784364E-06_JPRB, 0.31784822E-06_JPRB, &
  & 0.31784901E-06_JPRB, 0.31784720E-06_JPRB, 0.31784398E-06_JPRB, 0.31784037E-06_JPRB, 0.31783696E-06_JPRB, 0.31783367E-06_JPRB, &
  & 0.31783046E-06_JPRB, 0.31782719E-06_JPRB, 0.31782372E-06_JPRB, 0.31782017E-06_JPRB, 0.31781664E-06_JPRB, 0.31781320E-06_JPRB, &
  & 0.31780979E-06_JPRB, 0.31780627E-06_JPRB, 0.31780235E-06_JPRB, 0.31779561E-06_JPRB /)

RGHG3(:,66, 2) = (/ &
  & 0.31772277E-06_JPRB, 0.31772777E-06_JPRB, 0.31772942E-06_JPRB, 0.31773004E-06_JPRB, 0.31772996E-06_JPRB, 0.31772930E-06_JPRB, &
  & 0.31772828E-06_JPRB, 0.31772774E-06_JPRB, 0.31772817E-06_JPRB, 0.31772979E-06_JPRB, 0.31773280E-06_JPRB, 0.31773590E-06_JPRB, &
  & 0.31773811E-06_JPRB, 0.31773817E-06_JPRB, 0.31773561E-06_JPRB, 0.31773070E-06_JPRB, 0.31772640E-06_JPRB, 0.31772680E-06_JPRB, &
  & 0.31773615E-06_JPRB, 0.31775596E-06_JPRB, 0.31778487E-06_JPRB, 0.31781951E-06_JPRB, 0.31785592E-06_JPRB, 0.31789037E-06_JPRB, &
  & 0.31791996E-06_JPRB, 0.31794315E-06_JPRB, 0.31795935E-06_JPRB, 0.31796890E-06_JPRB, 0.31797279E-06_JPRB, 0.31797174E-06_JPRB, &
  & 0.31796620E-06_JPRB, 0.31795634E-06_JPRB, 0.31794244E-06_JPRB, 0.31792530E-06_JPRB, 0.31790611E-06_JPRB, 0.31788665E-06_JPRB, &
  & 0.31786777E-06_JPRB, 0.31785032E-06_JPRB, 0.31783495E-06_JPRB, 0.31782275E-06_JPRB, 0.31781508E-06_JPRB, 0.31781354E-06_JPRB, &
  & 0.31781798E-06_JPRB, 0.31782753E-06_JPRB, 0.31783964E-06_JPRB, 0.31785095E-06_JPRB, 0.31785910E-06_JPRB, 0.31786340E-06_JPRB, &
  & 0.31786422E-06_JPRB, 0.31786243E-06_JPRB, 0.31785922E-06_JPRB, 0.31785541E-06_JPRB, 0.31785174E-06_JPRB, 0.31784813E-06_JPRB, &
  & 0.31784458E-06_JPRB, 0.31784083E-06_JPRB, 0.31783702E-06_JPRB, 0.31783304E-06_JPRB, 0.31782926E-06_JPRB, 0.31782554E-06_JPRB, &
  & 0.31782173E-06_JPRB, 0.31781778E-06_JPRB, 0.31781303E-06_JPRB, 0.31780488E-06_JPRB /)

RGHG3(:,67, 2) = (/ &
  & 0.31774442E-06_JPRB, 0.31775028E-06_JPRB, 0.31775238E-06_JPRB, 0.31775346E-06_JPRB, 0.31775383E-06_JPRB, 0.31775363E-06_JPRB, &
  & 0.31775306E-06_JPRB, 0.31775298E-06_JPRB, 0.31775392E-06_JPRB, 0.31775627E-06_JPRB, 0.31775969E-06_JPRB, 0.31776318E-06_JPRB, &
  & 0.31776568E-06_JPRB, 0.31776602E-06_JPRB, 0.31776383E-06_JPRB, 0.31775960E-06_JPRB, 0.31775619E-06_JPRB, 0.31775696E-06_JPRB, &
  & 0.31776580E-06_JPRB, 0.31778376E-06_JPRB, 0.31780976E-06_JPRB, 0.31784089E-06_JPRB, 0.31787340E-06_JPRB, 0.31790407E-06_JPRB, &
  & 0.31793030E-06_JPRB, 0.31795085E-06_JPRB, 0.31796506E-06_JPRB, 0.31797356E-06_JPRB, 0.31797680E-06_JPRB, 0.31797586E-06_JPRB, &
  & 0.31797074E-06_JPRB, 0.31796182E-06_JPRB, 0.31794929E-06_JPRB, 0.31793351E-06_JPRB, 0.31791581E-06_JPRB, 0.31789756E-06_JPRB, &
  & 0.31787982E-06_JPRB, 0.31786340E-06_JPRB, 0.31784916E-06_JPRB, 0.31783799E-06_JPRB, 0.31783145E-06_JPRB, 0.31783063E-06_JPRB, &
  & 0.31783520E-06_JPRB, 0.31784441E-06_JPRB, 0.31785575E-06_JPRB, 0.31786624E-06_JPRB, 0.31787386E-06_JPRB, 0.31787789E-06_JPRB, &
  & 0.31787863E-06_JPRB, 0.31787695E-06_JPRB, 0.31787368E-06_JPRB, 0.31786985E-06_JPRB, 0.31786612E-06_JPRB, 0.31786226E-06_JPRB, &
  & 0.31785842E-06_JPRB, 0.31785441E-06_JPRB, 0.31785024E-06_JPRB, 0.31784597E-06_JPRB, 0.31784185E-06_JPRB, 0.31783782E-06_JPRB, &
  & 0.31783370E-06_JPRB, 0.31782898E-06_JPRB, 0.31782338E-06_JPRB, 0.31781292E-06_JPRB /)

RGHG3(:,68, 2) = (/ &
  & 0.31776418E-06_JPRB, 0.31777142E-06_JPRB, 0.31777432E-06_JPRB, 0.31777600E-06_JPRB, 0.31777694E-06_JPRB, 0.31777725E-06_JPRB, &
  & 0.31777725E-06_JPRB, 0.31777768E-06_JPRB, 0.31777921E-06_JPRB, 0.31778202E-06_JPRB, 0.31778586E-06_JPRB, 0.31778964E-06_JPRB, &
  & 0.31779217E-06_JPRB, 0.31779274E-06_JPRB, 0.31779095E-06_JPRB, 0.31778734E-06_JPRB, 0.31778467E-06_JPRB, 0.31778578E-06_JPRB, &
  & 0.31779382E-06_JPRB, 0.31781002E-06_JPRB, 0.31783318E-06_JPRB, 0.31786072E-06_JPRB, 0.31788957E-06_JPRB, 0.31791660E-06_JPRB, &
  & 0.31793974E-06_JPRB, 0.31795776E-06_JPRB, 0.31797018E-06_JPRB, 0.31797751E-06_JPRB, 0.31798029E-06_JPRB, 0.31797939E-06_JPRB, &
  & 0.31797472E-06_JPRB, 0.31796674E-06_JPRB, 0.31795554E-06_JPRB, 0.31794121E-06_JPRB, 0.31792499E-06_JPRB, 0.31790816E-06_JPRB, &
  & 0.31789162E-06_JPRB, 0.31787638E-06_JPRB, 0.31786331E-06_JPRB, 0.31785331E-06_JPRB, 0.31784768E-06_JPRB, 0.31784739E-06_JPRB, &
  & 0.31785214E-06_JPRB, 0.31786081E-06_JPRB, 0.31787124E-06_JPRB, 0.31788096E-06_JPRB, 0.31788787E-06_JPRB, 0.31789159E-06_JPRB, &
  & 0.31789230E-06_JPRB, 0.31789065E-06_JPRB, 0.31788750E-06_JPRB, 0.31788369E-06_JPRB, 0.31788002E-06_JPRB, 0.31787596E-06_JPRB, &
  & 0.31787212E-06_JPRB, 0.31786794E-06_JPRB, 0.31786365E-06_JPRB, 0.31785913E-06_JPRB, 0.31785495E-06_JPRB, 0.31785063E-06_JPRB, &
  & 0.31784609E-06_JPRB, 0.31784091E-06_JPRB, 0.31783395E-06_JPRB, 0.31782091E-06_JPRB /)

RGHG3(:,69, 2) = (/ &
  & 0.31778302E-06_JPRB, 0.31779194E-06_JPRB, 0.31779558E-06_JPRB, 0.31779791E-06_JPRB, 0.31779942E-06_JPRB, 0.31780030E-06_JPRB, &
  & 0.31780084E-06_JPRB, 0.31780189E-06_JPRB, 0.31780394E-06_JPRB, 0.31780718E-06_JPRB, 0.31781113E-06_JPRB, 0.31781505E-06_JPRB, &
  & 0.31781761E-06_JPRB, 0.31781835E-06_JPRB, 0.31781684E-06_JPRB, 0.31781380E-06_JPRB, 0.31781164E-06_JPRB, 0.31781292E-06_JPRB, &
  & 0.31782008E-06_JPRB, 0.31783441E-06_JPRB, 0.31785484E-06_JPRB, 0.31787914E-06_JPRB, 0.31790444E-06_JPRB, 0.31792817E-06_JPRB, &
  & 0.31794829E-06_JPRB, 0.31796395E-06_JPRB, 0.31797461E-06_JPRB, 0.31798109E-06_JPRB, 0.31798348E-06_JPRB, 0.31798248E-06_JPRB, &
  & 0.31797836E-06_JPRB, 0.31797123E-06_JPRB, 0.31796122E-06_JPRB, 0.31794846E-06_JPRB, 0.31793371E-06_JPRB, 0.31791825E-06_JPRB, &
  & 0.31790313E-06_JPRB, 0.31788926E-06_JPRB, 0.31787741E-06_JPRB, 0.31786851E-06_JPRB, 0.31786379E-06_JPRB, 0.31786394E-06_JPRB, &
  & 0.31786865E-06_JPRB, 0.31787664E-06_JPRB, 0.31788625E-06_JPRB, 0.31789494E-06_JPRB, 0.31790128E-06_JPRB, 0.31790461E-06_JPRB, &
  & 0.31790535E-06_JPRB, 0.31790375E-06_JPRB, 0.31790069E-06_JPRB, 0.31789702E-06_JPRB, 0.31789349E-06_JPRB, 0.31788949E-06_JPRB, &
  & 0.31788562E-06_JPRB, 0.31788142E-06_JPRB, 0.31787718E-06_JPRB, 0.31787275E-06_JPRB, 0.31786840E-06_JPRB, 0.31786408E-06_JPRB, &
  & 0.31785942E-06_JPRB, 0.31785370E-06_JPRB, 0.31784558E-06_JPRB, 0.31782957E-06_JPRB /)

RGHG3(:,70, 2) = (/ &
  & 0.31780118E-06_JPRB, 0.31781190E-06_JPRB, 0.31781661E-06_JPRB, 0.31781966E-06_JPRB, 0.31782176E-06_JPRB, 0.31782315E-06_JPRB, &
  & 0.31782429E-06_JPRB, 0.31782582E-06_JPRB, 0.31782812E-06_JPRB, 0.31783168E-06_JPRB, 0.31783560E-06_JPRB, 0.31783941E-06_JPRB, &
  & 0.31784185E-06_JPRB, 0.31784271E-06_JPRB, 0.31784151E-06_JPRB, 0.31783884E-06_JPRB, 0.31783696E-06_JPRB, 0.31783833E-06_JPRB, &
  & 0.31784441E-06_JPRB, 0.31785703E-06_JPRB, 0.31787491E-06_JPRB, 0.31789608E-06_JPRB, 0.31791802E-06_JPRB, 0.31793860E-06_JPRB, &
  & 0.31795599E-06_JPRB, 0.31796944E-06_JPRB, 0.31797873E-06_JPRB, 0.31798430E-06_JPRB, 0.31798623E-06_JPRB, 0.31798533E-06_JPRB, &
  & 0.31798155E-06_JPRB, 0.31797524E-06_JPRB, 0.31796657E-06_JPRB, 0.31795526E-06_JPRB, 0.31794210E-06_JPRB, 0.31792811E-06_JPRB, &
  & 0.31791427E-06_JPRB, 0.31790179E-06_JPRB, 0.31789125E-06_JPRB, 0.31788349E-06_JPRB, 0.31787957E-06_JPRB, 0.31788002E-06_JPRB, &
  & 0.31788463E-06_JPRB, 0.31789193E-06_JPRB, 0.31790051E-06_JPRB, 0.31790836E-06_JPRB, 0.31791407E-06_JPRB, 0.31791708E-06_JPRB, &
  & 0.31791771E-06_JPRB, 0.31791626E-06_JPRB, 0.31791339E-06_JPRB, 0.31790998E-06_JPRB, 0.31790668E-06_JPRB, 0.31790279E-06_JPRB, &
  & 0.31789907E-06_JPRB, 0.31789500E-06_JPRB, 0.31789097E-06_JPRB, 0.31788653E-06_JPRB, 0.31788241E-06_JPRB, 0.31787818E-06_JPRB, &
  & 0.31787354E-06_JPRB, 0.31786760E-06_JPRB, 0.31785871E-06_JPRB, 0.31784046E-06_JPRB /)

RGHG3(:,71, 2) = (/ &
  & 0.31781903E-06_JPRB, 0.31783199E-06_JPRB, 0.31783748E-06_JPRB, 0.31784128E-06_JPRB, 0.31784393E-06_JPRB, 0.31784583E-06_JPRB, &
  & 0.31784739E-06_JPRB, 0.31784927E-06_JPRB, 0.31785191E-06_JPRB, 0.31785535E-06_JPRB, 0.31785908E-06_JPRB, 0.31786254E-06_JPRB, &
  & 0.31786487E-06_JPRB, 0.31786576E-06_JPRB, 0.31786479E-06_JPRB, 0.31786240E-06_JPRB, 0.31786061E-06_JPRB, 0.31786203E-06_JPRB, &
  & 0.31786715E-06_JPRB, 0.31787795E-06_JPRB, 0.31789344E-06_JPRB, 0.31791160E-06_JPRB, 0.31793041E-06_JPRB, 0.31794798E-06_JPRB, &
  & 0.31796282E-06_JPRB, 0.31797444E-06_JPRB, 0.31798226E-06_JPRB, 0.31798697E-06_JPRB, 0.31798862E-06_JPRB, 0.31798766E-06_JPRB, &
  & 0.31798439E-06_JPRB, 0.31797887E-06_JPRB, 0.31797160E-06_JPRB, 0.31796156E-06_JPRB, 0.31794991E-06_JPRB, 0.31793746E-06_JPRB, &
  & 0.31792518E-06_JPRB, 0.31791410E-06_JPRB, 0.31790466E-06_JPRB, 0.31789807E-06_JPRB, 0.31789489E-06_JPRB, 0.31789565E-06_JPRB, &
  & 0.31790006E-06_JPRB, 0.31790660E-06_JPRB, 0.31791419E-06_JPRB, 0.31792115E-06_JPRB, 0.31792626E-06_JPRB, 0.31792877E-06_JPRB, &
  & 0.31792945E-06_JPRB, 0.31792817E-06_JPRB, 0.31792553E-06_JPRB, 0.31792240E-06_JPRB, 0.31791944E-06_JPRB, 0.31791595E-06_JPRB, &
  & 0.31791245E-06_JPRB, 0.31790867E-06_JPRB, 0.31790495E-06_JPRB, 0.31790077E-06_JPRB, 0.31789682E-06_JPRB, 0.31789287E-06_JPRB, &
  & 0.31788838E-06_JPRB, 0.31788247E-06_JPRB, 0.31787326E-06_JPRB, 0.31785396E-06_JPRB /)

RGHG3(:,72, 2) = (/ &
  & 0.31783730E-06_JPRB, 0.31785234E-06_JPRB, 0.31785868E-06_JPRB, 0.31786300E-06_JPRB, 0.31786595E-06_JPRB, 0.31786828E-06_JPRB, &
  & 0.31787022E-06_JPRB, 0.31787229E-06_JPRB, 0.31787485E-06_JPRB, 0.31787818E-06_JPRB, 0.31788142E-06_JPRB, 0.31788460E-06_JPRB, &
  & 0.31788656E-06_JPRB, 0.31788736E-06_JPRB, 0.31788647E-06_JPRB, 0.31788431E-06_JPRB, 0.31788269E-06_JPRB, 0.31788383E-06_JPRB, &
  & 0.31788815E-06_JPRB, 0.31789727E-06_JPRB, 0.31791043E-06_JPRB, 0.31792581E-06_JPRB, 0.31794173E-06_JPRB, 0.31795651E-06_JPRB, &
  & 0.31796910E-06_JPRB, 0.31797885E-06_JPRB, 0.31798530E-06_JPRB, 0.31798930E-06_JPRB, 0.31799073E-06_JPRB, 0.31798987E-06_JPRB, &
  & 0.31798692E-06_JPRB, 0.31798220E-06_JPRB, 0.31797620E-06_JPRB, 0.31796753E-06_JPRB, 0.31795739E-06_JPRB, 0.31794647E-06_JPRB, &
  & 0.31793562E-06_JPRB, 0.31792595E-06_JPRB, 0.31791780E-06_JPRB, 0.31791217E-06_JPRB, 0.31790975E-06_JPRB, 0.31791072E-06_JPRB, &
  & 0.31791487E-06_JPRB, 0.31792050E-06_JPRB, 0.31792703E-06_JPRB, 0.31793326E-06_JPRB, 0.31793778E-06_JPRB, 0.31793977E-06_JPRB, &
  & 0.31794048E-06_JPRB, 0.31793945E-06_JPRB, 0.31793709E-06_JPRB, 0.31793428E-06_JPRB, 0.31793184E-06_JPRB, 0.31792854E-06_JPRB, &
  & 0.31792544E-06_JPRB, 0.31792200E-06_JPRB, 0.31791879E-06_JPRB, 0.31791498E-06_JPRB, 0.31791137E-06_JPRB, 0.31790768E-06_JPRB, &
  & 0.31790358E-06_JPRB, 0.31789784E-06_JPRB, 0.31788866E-06_JPRB, 0.31786888E-06_JPRB /)

RGHG3(:,73, 2) = (/ &
  & 0.31785791E-06_JPRB, 0.31787366E-06_JPRB, 0.31788002E-06_JPRB, 0.31788457E-06_JPRB, 0.31788761E-06_JPRB, 0.31789011E-06_JPRB, &
  & 0.31789213E-06_JPRB, 0.31789423E-06_JPRB, 0.31789671E-06_JPRB, 0.31789952E-06_JPRB, 0.31790245E-06_JPRB, 0.31790506E-06_JPRB, &
  & 0.31790677E-06_JPRB, 0.31790751E-06_JPRB, 0.31790663E-06_JPRB, 0.31790455E-06_JPRB, 0.31790310E-06_JPRB, 0.31790381E-06_JPRB, &
  & 0.31790759E-06_JPRB, 0.31791507E-06_JPRB, 0.31792604E-06_JPRB, 0.31793886E-06_JPRB, 0.31795199E-06_JPRB, 0.31796426E-06_JPRB, &
  & 0.31797450E-06_JPRB, 0.31798274E-06_JPRB, 0.31798794E-06_JPRB, 0.31799132E-06_JPRB, 0.31799266E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31798925E-06_JPRB, 0.31798518E-06_JPRB, 0.31798047E-06_JPRB, 0.31797302E-06_JPRB, 0.31796435E-06_JPRB, 0.31795491E-06_JPRB, &
  & 0.31794571E-06_JPRB, 0.31793738E-06_JPRB, 0.31793044E-06_JPRB, 0.31792592E-06_JPRB, 0.31792408E-06_JPRB, 0.31792507E-06_JPRB, &
  & 0.31792882E-06_JPRB, 0.31793348E-06_JPRB, 0.31793905E-06_JPRB, 0.31794437E-06_JPRB, 0.31794843E-06_JPRB, 0.31795000E-06_JPRB, &
  & 0.31795071E-06_JPRB, 0.31794997E-06_JPRB, 0.31794789E-06_JPRB, 0.31794545E-06_JPRB, 0.31794335E-06_JPRB, 0.31794059E-06_JPRB, &
  & 0.31793780E-06_JPRB, 0.31793479E-06_JPRB, 0.31793221E-06_JPRB, 0.31792877E-06_JPRB, 0.31792555E-06_JPRB, 0.31792226E-06_JPRB, &
  & 0.31791859E-06_JPRB, 0.31791328E-06_JPRB, 0.31790435E-06_JPRB, 0.31788494E-06_JPRB /)

RGHG3(:,74, 2) = (/ &
  & 0.31787883E-06_JPRB, 0.31789494E-06_JPRB, 0.31790094E-06_JPRB, 0.31790557E-06_JPRB, 0.31790847E-06_JPRB, 0.31791080E-06_JPRB, &
  & 0.31791279E-06_JPRB, 0.31791467E-06_JPRB, 0.31791672E-06_JPRB, 0.31791936E-06_JPRB, 0.31792163E-06_JPRB, 0.31792405E-06_JPRB, &
  & 0.31792538E-06_JPRB, 0.31792607E-06_JPRB, 0.31792524E-06_JPRB, 0.31792325E-06_JPRB, 0.31792192E-06_JPRB, 0.31792226E-06_JPRB, &
  & 0.31792550E-06_JPRB, 0.31793155E-06_JPRB, 0.31794028E-06_JPRB, 0.31795054E-06_JPRB, 0.31796120E-06_JPRB, 0.31797114E-06_JPRB, &
  & 0.31797939E-06_JPRB, 0.31798621E-06_JPRB, 0.31799016E-06_JPRB, 0.31799297E-06_JPRB, 0.31799425E-06_JPRB, 0.31799331E-06_JPRB, &
  & 0.31799132E-06_JPRB, 0.31798791E-06_JPRB, 0.31798444E-06_JPRB, 0.31797808E-06_JPRB, 0.31797097E-06_JPRB, 0.31796284E-06_JPRB, &
  & 0.31795520E-06_JPRB, 0.31794832E-06_JPRB, 0.31794261E-06_JPRB, 0.31793914E-06_JPRB, 0.31793780E-06_JPRB, 0.31793863E-06_JPRB, &
  & 0.31794198E-06_JPRB, 0.31794556E-06_JPRB, 0.31795005E-06_JPRB, 0.31795469E-06_JPRB, 0.31795821E-06_JPRB, 0.31795935E-06_JPRB, &
  & 0.31796014E-06_JPRB, 0.31795977E-06_JPRB, 0.31795796E-06_JPRB, 0.31795580E-06_JPRB, 0.31795426E-06_JPRB, 0.31795165E-06_JPRB, &
  & 0.31794931E-06_JPRB, 0.31794676E-06_JPRB, 0.31794482E-06_JPRB, 0.31794181E-06_JPRB, 0.31793903E-06_JPRB, 0.31793616E-06_JPRB, &
  & 0.31793306E-06_JPRB, 0.31792823E-06_JPRB, 0.31791987E-06_JPRB, 0.31790154E-06_JPRB /)

RGHG3(:,75, 2) = (/ &
  & 0.31789983E-06_JPRB, 0.31791564E-06_JPRB, 0.31792112E-06_JPRB, 0.31792553E-06_JPRB, 0.31792803E-06_JPRB, 0.31793004E-06_JPRB, &
  & 0.31793198E-06_JPRB, 0.31793348E-06_JPRB, 0.31793516E-06_JPRB, 0.31793724E-06_JPRB, 0.31793920E-06_JPRB, 0.31794110E-06_JPRB, &
  & 0.31794218E-06_JPRB, 0.31794281E-06_JPRB, 0.31794210E-06_JPRB, 0.31794028E-06_JPRB, 0.31793905E-06_JPRB, 0.31793914E-06_JPRB, &
  & 0.31794195E-06_JPRB, 0.31794650E-06_JPRB, 0.31795327E-06_JPRB, 0.31796128E-06_JPRB, 0.31796955E-06_JPRB, 0.31797740E-06_JPRB, &
  & 0.31798373E-06_JPRB, 0.31798928E-06_JPRB, 0.31799217E-06_JPRB, 0.31799439E-06_JPRB, 0.31799578E-06_JPRB, 0.31799473E-06_JPRB, &
  & 0.31799314E-06_JPRB, 0.31799024E-06_JPRB, 0.31798805E-06_JPRB, 0.31798268E-06_JPRB, 0.31797705E-06_JPRB, 0.31797020E-06_JPRB, &
  & 0.31796424E-06_JPRB, 0.31795869E-06_JPRB, 0.31795426E-06_JPRB, 0.31795173E-06_JPRB, 0.31795076E-06_JPRB, 0.31795136E-06_JPRB, &
  & 0.31795429E-06_JPRB, 0.31795668E-06_JPRB, 0.31796026E-06_JPRB, 0.31796404E-06_JPRB, 0.31796739E-06_JPRB, 0.31796787E-06_JPRB, &
  & 0.31796870E-06_JPRB, 0.31796881E-06_JPRB, 0.31796708E-06_JPRB, 0.31796529E-06_JPRB, 0.31796426E-06_JPRB, 0.31796191E-06_JPRB, &
  & 0.31795986E-06_JPRB, 0.31795767E-06_JPRB, 0.31795653E-06_JPRB, 0.31795400E-06_JPRB, 0.31795176E-06_JPRB, 0.31794940E-06_JPRB, &
  & 0.31794696E-06_JPRB, 0.31794266E-06_JPRB, 0.31793491E-06_JPRB, 0.31791834E-06_JPRB /)

RGHG3(:,76, 2) = (/ &
  & 0.31792038E-06_JPRB, 0.31793553E-06_JPRB, 0.31793991E-06_JPRB, 0.31794426E-06_JPRB, 0.31794636E-06_JPRB, 0.31794792E-06_JPRB, &
  & 0.31794954E-06_JPRB, 0.31795054E-06_JPRB, 0.31795162E-06_JPRB, 0.31795327E-06_JPRB, 0.31795460E-06_JPRB, 0.31795645E-06_JPRB, &
  & 0.31795719E-06_JPRB, 0.31795784E-06_JPRB, 0.31795739E-06_JPRB, 0.31795568E-06_JPRB, 0.31795477E-06_JPRB, 0.31795463E-06_JPRB, &
  & 0.31795696E-06_JPRB, 0.31796031E-06_JPRB, 0.31796503E-06_JPRB, 0.31797100E-06_JPRB, 0.31797714E-06_JPRB, 0.31798308E-06_JPRB, &
  & 0.31798754E-06_JPRB, 0.31799203E-06_JPRB, 0.31799388E-06_JPRB, 0.31799550E-06_JPRB, 0.31799712E-06_JPRB, 0.31799593E-06_JPRB, &
  & 0.31799470E-06_JPRB, 0.31799226E-06_JPRB, 0.31799132E-06_JPRB, 0.31798692E-06_JPRB, 0.31798274E-06_JPRB, 0.31797705E-06_JPRB, &
  & 0.31797271E-06_JPRB, 0.31796864E-06_JPRB, 0.31796526E-06_JPRB, 0.31796367E-06_JPRB, 0.31796301E-06_JPRB, 0.31796336E-06_JPRB, &
  & 0.31796574E-06_JPRB, 0.31796696E-06_JPRB, 0.31796949E-06_JPRB, 0.31797265E-06_JPRB, 0.31797566E-06_JPRB, 0.31797543E-06_JPRB, &
  & 0.31797646E-06_JPRB, 0.31797705E-06_JPRB, 0.31797543E-06_JPRB, 0.31797381E-06_JPRB, 0.31797353E-06_JPRB, 0.31797120E-06_JPRB, &
  & 0.31796955E-06_JPRB, 0.31796773E-06_JPRB, 0.31796750E-06_JPRB, 0.31796549E-06_JPRB, 0.31796370E-06_JPRB, 0.31796174E-06_JPRB, &
  & 0.31796003E-06_JPRB, 0.31795634E-06_JPRB, 0.31794929E-06_JPRB, 0.31793525E-06_JPRB /)

RGHG3(:,77, 2) = (/ &
  & 0.31794059E-06_JPRB, 0.31795423E-06_JPRB, 0.31795744E-06_JPRB, 0.31796154E-06_JPRB, 0.31796313E-06_JPRB, 0.31796404E-06_JPRB, &
  & 0.31796537E-06_JPRB, 0.31796566E-06_JPRB, 0.31796600E-06_JPRB, 0.31796714E-06_JPRB, 0.31796796E-06_JPRB, 0.31796966E-06_JPRB, &
  & 0.31797018E-06_JPRB, 0.31797103E-06_JPRB, 0.31797097E-06_JPRB, 0.31796958E-06_JPRB, 0.31796887E-06_JPRB, 0.31796867E-06_JPRB, &
  & 0.31797060E-06_JPRB, 0.31797276E-06_JPRB, 0.31797575E-06_JPRB, 0.31797975E-06_JPRB, 0.31798390E-06_JPRB, 0.31798808E-06_JPRB, &
  & 0.31799090E-06_JPRB, 0.31799445E-06_JPRB, 0.31799536E-06_JPRB, 0.31799644E-06_JPRB, 0.31799840E-06_JPRB, 0.31799692E-06_JPRB, &
  & 0.31799604E-06_JPRB, 0.31799388E-06_JPRB, 0.31799431E-06_JPRB, 0.31799064E-06_JPRB, 0.31798791E-06_JPRB, 0.31798325E-06_JPRB, &
  & 0.31798049E-06_JPRB, 0.31797779E-06_JPRB, 0.31797543E-06_JPRB, 0.31797495E-06_JPRB, 0.31797444E-06_JPRB, 0.31797433E-06_JPRB, &
  & 0.31797620E-06_JPRB, 0.31797620E-06_JPRB, 0.31797785E-06_JPRB, 0.31798015E-06_JPRB, 0.31798311E-06_JPRB, 0.31798217E-06_JPRB, &
  & 0.31798336E-06_JPRB, 0.31798453E-06_JPRB, 0.31798288E-06_JPRB, 0.31798140E-06_JPRB, 0.31798197E-06_JPRB, 0.31797958E-06_JPRB, &
  & 0.31797831E-06_JPRB, 0.31797674E-06_JPRB, 0.31797768E-06_JPRB, 0.31797597E-06_JPRB, 0.31797472E-06_JPRB, 0.31797316E-06_JPRB, &
  & 0.31797228E-06_JPRB, 0.31796904E-06_JPRB, 0.31796282E-06_JPRB, 0.31795193E-06_JPRB /)

RGHG3(:,78, 2) = (/ &
  & 0.31796014E-06_JPRB, 0.31797109E-06_JPRB, 0.31797228E-06_JPRB, 0.31797637E-06_JPRB, 0.31797731E-06_JPRB, 0.31797762E-06_JPRB, &
  & 0.31797873E-06_JPRB, 0.31797822E-06_JPRB, 0.31797774E-06_JPRB, 0.31797842E-06_JPRB, 0.31797862E-06_JPRB, 0.31798038E-06_JPRB, &
  & 0.31798058E-06_JPRB, 0.31798174E-06_JPRB, 0.31798211E-06_JPRB, 0.31798106E-06_JPRB, 0.31798072E-06_JPRB, 0.31798041E-06_JPRB, &
  & 0.31798220E-06_JPRB, 0.31798339E-06_JPRB, 0.31798473E-06_JPRB, 0.31798717E-06_JPRB, 0.31798947E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799652E-06_JPRB, 0.31799655E-06_JPRB, 0.31799712E-06_JPRB, 0.31799954E-06_JPRB, 0.31799780E-06_JPRB, &
  & 0.31799723E-06_JPRB, 0.31799519E-06_JPRB, 0.31799692E-06_JPRB, 0.31799377E-06_JPRB, 0.31799237E-06_JPRB, 0.31798857E-06_JPRB, &
  & 0.31798729E-06_JPRB, 0.31798581E-06_JPRB, 0.31798442E-06_JPRB, 0.31798476E-06_JPRB, 0.31798419E-06_JPRB, 0.31798353E-06_JPRB, &
  & 0.31798507E-06_JPRB, 0.31798390E-06_JPRB, 0.31798470E-06_JPRB, 0.31798649E-06_JPRB, 0.31798947E-06_JPRB, 0.31798771E-06_JPRB, &
  & 0.31798902E-06_JPRB, 0.31799092E-06_JPRB, 0.31798908E-06_JPRB, 0.31798771E-06_JPRB, 0.31798916E-06_JPRB, 0.31798660E-06_JPRB, &
  & 0.31798564E-06_JPRB, 0.31798436E-06_JPRB, 0.31798635E-06_JPRB, 0.31798490E-06_JPRB, 0.31798405E-06_JPRB, 0.31798282E-06_JPRB, &
  & 0.31798280E-06_JPRB, 0.31797993E-06_JPRB, 0.31797481E-06_JPRB, 0.31796839E-06_JPRB /)

RGHG3(:,79, 2) = (/ &
  & 0.31797293E-06_JPRB, 0.31798066E-06_JPRB, 0.31798012E-06_JPRB, 0.31798425E-06_JPRB, 0.31798493E-06_JPRB, 0.31798467E-06_JPRB, &
  & 0.31798587E-06_JPRB, 0.31798464E-06_JPRB, 0.31798356E-06_JPRB, 0.31798402E-06_JPRB, 0.31798385E-06_JPRB, 0.31798592E-06_JPRB, &
  & 0.31798598E-06_JPRB, 0.31798749E-06_JPRB, 0.31798814E-06_JPRB, 0.31798723E-06_JPRB, 0.31798709E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31798868E-06_JPRB, 0.31798913E-06_JPRB, 0.31798953E-06_JPRB, 0.31799115E-06_JPRB, 0.31799246E-06_JPRB, 0.31799445E-06_JPRB, &
  & 0.31799502E-06_JPRB, 0.31799760E-06_JPRB, 0.31799715E-06_JPRB, 0.31799735E-06_JPRB, 0.31800028E-06_JPRB, 0.31799823E-06_JPRB, &
  & 0.31799775E-06_JPRB, 0.31799573E-06_JPRB, 0.31799843E-06_JPRB, 0.31799544E-06_JPRB, 0.31799476E-06_JPRB, 0.31799124E-06_JPRB, &
  & 0.31799087E-06_JPRB, 0.31799019E-06_JPRB, 0.31798925E-06_JPRB, 0.31799024E-06_JPRB, 0.31798953E-06_JPRB, 0.31798848E-06_JPRB, &
  & 0.31798984E-06_JPRB, 0.31798791E-06_JPRB, 0.31798817E-06_JPRB, 0.31798965E-06_JPRB, 0.31799294E-06_JPRB, 0.31799047E-06_JPRB, &
  & 0.31799200E-06_JPRB, 0.31799456E-06_JPRB, 0.31799243E-06_JPRB, 0.31799092E-06_JPRB, 0.31799306E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31798930E-06_JPRB, 0.31798808E-06_JPRB, 0.31799107E-06_JPRB, 0.31798959E-06_JPRB, 0.31798888E-06_JPRB, 0.31798783E-06_JPRB, &
  & 0.31798839E-06_JPRB, 0.31798569E-06_JPRB, 0.31798118E-06_JPRB, 0.31797924E-06_JPRB /)

RGHG3(:,80, 2) = (/ &
  & 0.31798149E-06_JPRB, 0.31798533E-06_JPRB, 0.31798351E-06_JPRB, 0.31798783E-06_JPRB, 0.31798828E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31798893E-06_JPRB, 0.31798746E-06_JPRB, 0.31798598E-06_JPRB, 0.31798641E-06_JPRB, 0.31798606E-06_JPRB, 0.31798831E-06_JPRB, &
  & 0.31798834E-06_JPRB, 0.31799010E-06_JPRB, 0.31799090E-06_JPRB, 0.31798999E-06_JPRB, 0.31798996E-06_JPRB, 0.31798965E-06_JPRB, &
  & 0.31799166E-06_JPRB, 0.31799186E-06_JPRB, 0.31799175E-06_JPRB, 0.31799289E-06_JPRB, 0.31799374E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799806E-06_JPRB, 0.31799726E-06_JPRB, 0.31799738E-06_JPRB, 0.31800067E-06_JPRB, 0.31799837E-06_JPRB, &
  & 0.31799797E-06_JPRB, 0.31799578E-06_JPRB, 0.31799914E-06_JPRB, 0.31799618E-06_JPRB, 0.31799581E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799215E-06_JPRB, 0.31799146E-06_JPRB, 0.31799280E-06_JPRB, 0.31799203E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31799198E-06_JPRB, 0.31798956E-06_JPRB, 0.31798959E-06_JPRB, 0.31799095E-06_JPRB, 0.31799453E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31799630E-06_JPRB, 0.31799385E-06_JPRB, 0.31799226E-06_JPRB, 0.31799487E-06_JPRB, 0.31799163E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31798962E-06_JPRB, 0.31799317E-06_JPRB, 0.31799169E-06_JPRB, 0.31799101E-06_JPRB, 0.31798999E-06_JPRB, &
  & 0.31799084E-06_JPRB, 0.31798825E-06_JPRB, 0.31798405E-06_JPRB, 0.31798683E-06_JPRB /)

RGHG3(:,81, 2) = (/ &
  & 0.31798757E-06_JPRB, 0.31798740E-06_JPRB, 0.31798493E-06_JPRB, 0.31798942E-06_JPRB, 0.31798976E-06_JPRB, 0.31798916E-06_JPRB, &
  & 0.31799041E-06_JPRB, 0.31798851E-06_JPRB, 0.31798703E-06_JPRB, 0.31798740E-06_JPRB, 0.31798692E-06_JPRB, 0.31798947E-06_JPRB, &
  & 0.31798945E-06_JPRB, 0.31799129E-06_JPRB, 0.31799215E-06_JPRB, 0.31799127E-06_JPRB, 0.31799127E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799308E-06_JPRB, 0.31799269E-06_JPRB, 0.31799360E-06_JPRB, 0.31799419E-06_JPRB, 0.31799578E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799829E-06_JPRB, 0.31799729E-06_JPRB, 0.31799729E-06_JPRB, 0.31800090E-06_JPRB, 0.31799840E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799581E-06_JPRB, 0.31799945E-06_JPRB, 0.31799649E-06_JPRB, 0.31799624E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799303E-06_JPRB, 0.31799246E-06_JPRB, 0.31799394E-06_JPRB, 0.31799314E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799303E-06_JPRB, 0.31799021E-06_JPRB, 0.31799019E-06_JPRB, 0.31799146E-06_JPRB, 0.31799527E-06_JPRB, 0.31799195E-06_JPRB, &
  & 0.31799377E-06_JPRB, 0.31799709E-06_JPRB, 0.31799448E-06_JPRB, 0.31799283E-06_JPRB, 0.31799570E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799152E-06_JPRB, 0.31799021E-06_JPRB, 0.31799414E-06_JPRB, 0.31799260E-06_JPRB, 0.31799203E-06_JPRB, 0.31799095E-06_JPRB, &
  & 0.31799192E-06_JPRB, 0.31798928E-06_JPRB, 0.31798518E-06_JPRB, 0.31799243E-06_JPRB /)

RGHG3(:,82, 2) = (/ &
  & 0.31798811E-06_JPRB, 0.31798811E-06_JPRB, 0.31798552E-06_JPRB, 0.31799030E-06_JPRB, 0.31799050E-06_JPRB, 0.31798976E-06_JPRB, &
  & 0.31799101E-06_JPRB, 0.31798928E-06_JPRB, 0.31798743E-06_JPRB, 0.31798788E-06_JPRB, 0.31798743E-06_JPRB, 0.31798990E-06_JPRB, &
  & 0.31798993E-06_JPRB, 0.31799186E-06_JPRB, 0.31799283E-06_JPRB, 0.31799195E-06_JPRB, 0.31799192E-06_JPRB, 0.31799152E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799365E-06_JPRB, 0.31799317E-06_JPRB, 0.31799399E-06_JPRB, 0.31799453E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799834E-06_JPRB, 0.31799723E-06_JPRB, 0.31799715E-06_JPRB, 0.31800101E-06_JPRB, 0.31799837E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799576E-06_JPRB, 0.31799959E-06_JPRB, 0.31799672E-06_JPRB, 0.31799644E-06_JPRB, 0.31799314E-06_JPRB, &
  & 0.31799343E-06_JPRB, 0.31799345E-06_JPRB, 0.31799297E-06_JPRB, 0.31799459E-06_JPRB, 0.31799377E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799348E-06_JPRB, 0.31799047E-06_JPRB, 0.31799036E-06_JPRB, 0.31799163E-06_JPRB, 0.31799564E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799755E-06_JPRB, 0.31799482E-06_JPRB, 0.31799308E-06_JPRB, 0.31799613E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31799053E-06_JPRB, 0.31799465E-06_JPRB, 0.31799306E-06_JPRB, 0.31799243E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799243E-06_JPRB, 0.31798973E-06_JPRB, 0.31798550E-06_JPRB, 0.31799286E-06_JPRB /)

RGHG3(:,83, 2) = (/ &
  & 0.31798845E-06_JPRB, 0.31798854E-06_JPRB, 0.31798589E-06_JPRB, 0.31799075E-06_JPRB, 0.31799104E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799149E-06_JPRB, 0.31798925E-06_JPRB, 0.31798771E-06_JPRB, 0.31798808E-06_JPRB, 0.31798754E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31799223E-06_JPRB, 0.31799320E-06_JPRB, 0.31799235E-06_JPRB, 0.31799232E-06_JPRB, 0.31799181E-06_JPRB, &
  & 0.31799425E-06_JPRB, 0.31799405E-06_JPRB, 0.31799343E-06_JPRB, 0.31799416E-06_JPRB, 0.31799465E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799587E-06_JPRB, 0.31799840E-06_JPRB, 0.31799715E-06_JPRB, 0.31799706E-06_JPRB, 0.31800107E-06_JPRB, 0.31799831E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31799567E-06_JPRB, 0.31799962E-06_JPRB, 0.31799686E-06_JPRB, 0.31799658E-06_JPRB, 0.31799337E-06_JPRB, &
  & 0.31799365E-06_JPRB, 0.31799371E-06_JPRB, 0.31799328E-06_JPRB, 0.31799493E-06_JPRB, 0.31799416E-06_JPRB, 0.31799252E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799055E-06_JPRB, 0.31799044E-06_JPRB, 0.31799169E-06_JPRB, 0.31799593E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799411E-06_JPRB, 0.31799777E-06_JPRB, 0.31799499E-06_JPRB, 0.31799323E-06_JPRB, 0.31799644E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799200E-06_JPRB, 0.31799067E-06_JPRB, 0.31799499E-06_JPRB, 0.31799331E-06_JPRB, 0.31799271E-06_JPRB, 0.31799163E-06_JPRB, &
  & 0.31799269E-06_JPRB, 0.31798993E-06_JPRB, 0.31798561E-06_JPRB, 0.31799320E-06_JPRB /)

RGHG3(:,84, 2) = (/ &
  & 0.31798874E-06_JPRB, 0.31798885E-06_JPRB, 0.31798606E-06_JPRB, 0.31799107E-06_JPRB, 0.31799127E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31798982E-06_JPRB, 0.31798788E-06_JPRB, 0.31798822E-06_JPRB, 0.31798794E-06_JPRB, 0.31799019E-06_JPRB, &
  & 0.31799041E-06_JPRB, 0.31799237E-06_JPRB, 0.31799345E-06_JPRB, 0.31799266E-06_JPRB, 0.31799254E-06_JPRB, 0.31799212E-06_JPRB, &
  & 0.31799459E-06_JPRB, 0.31799422E-06_JPRB, 0.31799348E-06_JPRB, 0.31799422E-06_JPRB, 0.31799462E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799848E-06_JPRB, 0.31799706E-06_JPRB, 0.31799698E-06_JPRB, 0.31800121E-06_JPRB, 0.31799829E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799556E-06_JPRB, 0.31799962E-06_JPRB, 0.31799689E-06_JPRB, 0.31799658E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799391E-06_JPRB, 0.31799351E-06_JPRB, 0.31799519E-06_JPRB, 0.31799439E-06_JPRB, 0.31799266E-06_JPRB, &
  & 0.31799399E-06_JPRB, 0.31799055E-06_JPRB, 0.31799041E-06_JPRB, 0.31799175E-06_JPRB, 0.31799607E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799797E-06_JPRB, 0.31799507E-06_JPRB, 0.31799323E-06_JPRB, 0.31799661E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799206E-06_JPRB, 0.31799070E-06_JPRB, 0.31799522E-06_JPRB, 0.31799351E-06_JPRB, 0.31799291E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799289E-06_JPRB, 0.31799004E-06_JPRB, 0.31798564E-06_JPRB, 0.31799345E-06_JPRB /)

RGHG3(:,85, 2) = (/ &
  & 0.31798891E-06_JPRB, 0.31798905E-06_JPRB, 0.31798615E-06_JPRB, 0.31799127E-06_JPRB, 0.31799146E-06_JPRB, 0.31799067E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31798942E-06_JPRB, 0.31798817E-06_JPRB, 0.31798828E-06_JPRB, 0.31798817E-06_JPRB, 0.31799030E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31799243E-06_JPRB, 0.31799354E-06_JPRB, 0.31799286E-06_JPRB, 0.31799266E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799485E-06_JPRB, 0.31799439E-06_JPRB, 0.31799357E-06_JPRB, 0.31799425E-06_JPRB, 0.31799456E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799854E-06_JPRB, 0.31799701E-06_JPRB, 0.31799689E-06_JPRB, 0.31800130E-06_JPRB, 0.31799817E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799550E-06_JPRB, 0.31799962E-06_JPRB, 0.31799695E-06_JPRB, 0.31799664E-06_JPRB, 0.31799362E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799397E-06_JPRB, 0.31799365E-06_JPRB, 0.31799533E-06_JPRB, 0.31799453E-06_JPRB, 0.31799269E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799053E-06_JPRB, 0.31799036E-06_JPRB, 0.31799169E-06_JPRB, 0.31799624E-06_JPRB, 0.31799212E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799809E-06_JPRB, 0.31799510E-06_JPRB, 0.31799325E-06_JPRB, 0.31799681E-06_JPRB, 0.31799280E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799070E-06_JPRB, 0.31799539E-06_JPRB, 0.31799365E-06_JPRB, 0.31799308E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799303E-06_JPRB, 0.31799007E-06_JPRB, 0.31798564E-06_JPRB, 0.31799365E-06_JPRB /)

RGHG3(:,86, 2) = (/ &
  & 0.31798902E-06_JPRB, 0.31798922E-06_JPRB, 0.31798618E-06_JPRB, 0.31799149E-06_JPRB, 0.31799149E-06_JPRB, 0.31799064E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31798976E-06_JPRB, 0.31798845E-06_JPRB, 0.31798854E-06_JPRB, 0.31798862E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31799229E-06_JPRB, 0.31799345E-06_JPRB, 0.31799300E-06_JPRB, 0.31799280E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799499E-06_JPRB, 0.31799448E-06_JPRB, 0.31799360E-06_JPRB, 0.31799425E-06_JPRB, 0.31799456E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799860E-06_JPRB, 0.31799689E-06_JPRB, 0.31799681E-06_JPRB, 0.31800136E-06_JPRB, 0.31799814E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799539E-06_JPRB, 0.31799954E-06_JPRB, 0.31799698E-06_JPRB, 0.31799664E-06_JPRB, 0.31799368E-06_JPRB, &
  & 0.31799391E-06_JPRB, 0.31799405E-06_JPRB, 0.31799374E-06_JPRB, 0.31799559E-06_JPRB, 0.31799470E-06_JPRB, 0.31799266E-06_JPRB, &
  & 0.31799431E-06_JPRB, 0.31799041E-06_JPRB, 0.31799030E-06_JPRB, 0.31799163E-06_JPRB, 0.31799630E-06_JPRB, 0.31799203E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799820E-06_JPRB, 0.31799516E-06_JPRB, 0.31799320E-06_JPRB, 0.31799689E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799067E-06_JPRB, 0.31799544E-06_JPRB, 0.31799377E-06_JPRB, 0.31799320E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799010E-06_JPRB, 0.31798561E-06_JPRB, 0.31799377E-06_JPRB /)

RGHG3(:,87, 2) = (/ &
  & 0.31798908E-06_JPRB, 0.31798930E-06_JPRB, 0.31798615E-06_JPRB, 0.31799161E-06_JPRB, 0.31799161E-06_JPRB, 0.31799073E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31798953E-06_JPRB, 0.31798874E-06_JPRB, 0.31798874E-06_JPRB, 0.31798891E-06_JPRB, 0.31799019E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31799220E-06_JPRB, 0.31799331E-06_JPRB, 0.31799306E-06_JPRB, 0.31799286E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799507E-06_JPRB, 0.31799453E-06_JPRB, 0.31799357E-06_JPRB, 0.31799419E-06_JPRB, 0.31799453E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799871E-06_JPRB, 0.31799686E-06_JPRB, 0.31799669E-06_JPRB, 0.31800147E-06_JPRB, 0.31799811E-06_JPRB, &
  & 0.31799775E-06_JPRB, 0.31799533E-06_JPRB, 0.31799959E-06_JPRB, 0.31799698E-06_JPRB, 0.31799675E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799411E-06_JPRB, 0.31799374E-06_JPRB, 0.31799581E-06_JPRB, 0.31799476E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799436E-06_JPRB, 0.31799027E-06_JPRB, 0.31799024E-06_JPRB, 0.31799161E-06_JPRB, 0.31799641E-06_JPRB, 0.31799206E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799829E-06_JPRB, 0.31799522E-06_JPRB, 0.31799317E-06_JPRB, 0.31799695E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799061E-06_JPRB, 0.31799550E-06_JPRB, 0.31799385E-06_JPRB, 0.31799320E-06_JPRB, 0.31799192E-06_JPRB, &
  & 0.31799308E-06_JPRB, 0.31799010E-06_JPRB, 0.31798552E-06_JPRB, 0.31799388E-06_JPRB /)

RGHG3(:,88, 2) = (/ &
  & 0.31798916E-06_JPRB, 0.31798930E-06_JPRB, 0.31798612E-06_JPRB, 0.31799155E-06_JPRB, 0.31799152E-06_JPRB, 0.31799073E-06_JPRB, &
  & 0.31799104E-06_JPRB, 0.31798982E-06_JPRB, 0.31798879E-06_JPRB, 0.31798879E-06_JPRB, 0.31798902E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31799215E-06_JPRB, 0.31799328E-06_JPRB, 0.31799314E-06_JPRB, 0.31799283E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799453E-06_JPRB, 0.31799351E-06_JPRB, 0.31799414E-06_JPRB, 0.31799442E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799567E-06_JPRB, 0.31799877E-06_JPRB, 0.31799684E-06_JPRB, 0.31799664E-06_JPRB, 0.31800153E-06_JPRB, 0.31799806E-06_JPRB, &
  & 0.31799769E-06_JPRB, 0.31799516E-06_JPRB, 0.31799968E-06_JPRB, 0.31799703E-06_JPRB, 0.31799681E-06_JPRB, 0.31799345E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799414E-06_JPRB, 0.31799365E-06_JPRB, 0.31799607E-06_JPRB, 0.31799496E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31799439E-06_JPRB, 0.31799016E-06_JPRB, 0.31799016E-06_JPRB, 0.31799152E-06_JPRB, 0.31799649E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31799408E-06_JPRB, 0.31799831E-06_JPRB, 0.31799527E-06_JPRB, 0.31799314E-06_JPRB, 0.31799701E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799055E-06_JPRB, 0.31799556E-06_JPRB, 0.31799388E-06_JPRB, 0.31799325E-06_JPRB, 0.31799181E-06_JPRB, &
  & 0.31799308E-06_JPRB, 0.31799010E-06_JPRB, 0.31798550E-06_JPRB, 0.31799394E-06_JPRB /)

RGHG3(:,89, 2) = (/ &
  & 0.31798919E-06_JPRB, 0.31798925E-06_JPRB, 0.31798612E-06_JPRB, 0.31799169E-06_JPRB, 0.31799172E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31798953E-06_JPRB, 0.31798868E-06_JPRB, 0.31798868E-06_JPRB, 0.31798885E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31799223E-06_JPRB, 0.31799337E-06_JPRB, 0.31799320E-06_JPRB, 0.31799291E-06_JPRB, 0.31799243E-06_JPRB, &
  & 0.31799524E-06_JPRB, 0.31799459E-06_JPRB, 0.31799351E-06_JPRB, 0.31799411E-06_JPRB, 0.31799439E-06_JPRB, 0.31799624E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799883E-06_JPRB, 0.31799675E-06_JPRB, 0.31799652E-06_JPRB, 0.31800161E-06_JPRB, 0.31799794E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799505E-06_JPRB, 0.31799982E-06_JPRB, 0.31799698E-06_JPRB, 0.31799698E-06_JPRB, 0.31799325E-06_JPRB, &
  & 0.31799382E-06_JPRB, 0.31799419E-06_JPRB, 0.31799357E-06_JPRB, 0.31799627E-06_JPRB, 0.31799499E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799451E-06_JPRB, 0.31799001E-06_JPRB, 0.31799013E-06_JPRB, 0.31799152E-06_JPRB, 0.31799661E-06_JPRB, 0.31799192E-06_JPRB, &
  & 0.31799399E-06_JPRB, 0.31799837E-06_JPRB, 0.31799530E-06_JPRB, 0.31799308E-06_JPRB, 0.31799712E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799055E-06_JPRB, 0.31799559E-06_JPRB, 0.31799391E-06_JPRB, 0.31799328E-06_JPRB, 0.31799178E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799013E-06_JPRB, 0.31798538E-06_JPRB, 0.31799399E-06_JPRB /)

RGHG3(:,90, 2) = (/ &
  & 0.31798919E-06_JPRB, 0.31798925E-06_JPRB, 0.31798598E-06_JPRB, 0.31799181E-06_JPRB, 0.31799175E-06_JPRB, 0.31799073E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31798973E-06_JPRB, 0.31798822E-06_JPRB, 0.31798834E-06_JPRB, 0.31798842E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799070E-06_JPRB, 0.31799246E-06_JPRB, 0.31799365E-06_JPRB, 0.31799325E-06_JPRB, 0.31799289E-06_JPRB, 0.31799235E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799459E-06_JPRB, 0.31799345E-06_JPRB, 0.31799414E-06_JPRB, 0.31799428E-06_JPRB, 0.31799630E-06_JPRB, &
  & 0.31799541E-06_JPRB, 0.31799894E-06_JPRB, 0.31799669E-06_JPRB, 0.31799632E-06_JPRB, 0.31800190E-06_JPRB, 0.31799783E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799470E-06_JPRB, 0.31800022E-06_JPRB, 0.31799689E-06_JPRB, 0.31799718E-06_JPRB, 0.31799294E-06_JPRB, &
  & 0.31799382E-06_JPRB, 0.31799428E-06_JPRB, 0.31799348E-06_JPRB, 0.31799652E-06_JPRB, 0.31799510E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799470E-06_JPRB, 0.31798993E-06_JPRB, 0.31799010E-06_JPRB, 0.31799144E-06_JPRB, 0.31799692E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799399E-06_JPRB, 0.31799860E-06_JPRB, 0.31799533E-06_JPRB, 0.31799297E-06_JPRB, 0.31799738E-06_JPRB, 0.31799266E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799036E-06_JPRB, 0.31799578E-06_JPRB, 0.31799397E-06_JPRB, 0.31799337E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799325E-06_JPRB, 0.31799013E-06_JPRB, 0.31798524E-06_JPRB, 0.31799416E-06_JPRB /)

RGHG3(:,91, 2) = (/ &
  & 0.31798928E-06_JPRB, 0.31798953E-06_JPRB, 0.31798515E-06_JPRB, 0.31799223E-06_JPRB, 0.31799192E-06_JPRB, 0.31799050E-06_JPRB, &
  & 0.31799303E-06_JPRB, 0.31798987E-06_JPRB, 0.31798712E-06_JPRB, 0.31798825E-06_JPRB, 0.31798695E-06_JPRB, 0.31799129E-06_JPRB, &
  & 0.31799024E-06_JPRB, 0.31799294E-06_JPRB, 0.31799422E-06_JPRB, 0.31799328E-06_JPRB, 0.31799289E-06_JPRB, 0.31799198E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799465E-06_JPRB, 0.31799334E-06_JPRB, 0.31799416E-06_JPRB, 0.31799416E-06_JPRB, 0.31799649E-06_JPRB, &
  & 0.31799519E-06_JPRB, 0.31799934E-06_JPRB, 0.31799655E-06_JPRB, 0.31799590E-06_JPRB, 0.31800266E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799800E-06_JPRB, 0.31799377E-06_JPRB, 0.31800130E-06_JPRB, 0.31799652E-06_JPRB, 0.31799772E-06_JPRB, 0.31799229E-06_JPRB, &
  & 0.31799391E-06_JPRB, 0.31799442E-06_JPRB, 0.31799320E-06_JPRB, 0.31799681E-06_JPRB, 0.31799522E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799519E-06_JPRB, 0.31798959E-06_JPRB, 0.31798999E-06_JPRB, 0.31799115E-06_JPRB, 0.31799760E-06_JPRB, 0.31799124E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799919E-06_JPRB, 0.31799527E-06_JPRB, 0.31799252E-06_JPRB, 0.31799794E-06_JPRB, 0.31799235E-06_JPRB, &
  & 0.31799235E-06_JPRB, 0.31798993E-06_JPRB, 0.31799630E-06_JPRB, 0.31799388E-06_JPRB, 0.31799340E-06_JPRB, 0.31799152E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31799004E-06_JPRB, 0.31798479E-06_JPRB, 0.31799433E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG3(:, 1, 3) = (/ &
  & 0.89247351E-07_JPRB, 0.89312380E-07_JPRB, 0.89416773E-07_JPRB, 0.89567180E-07_JPRB, 0.89753833E-07_JPRB, 0.89982855E-07_JPRB, &
  & 0.90258617E-07_JPRB, 0.90580471E-07_JPRB, 0.90946045E-07_JPRB, 0.91352753E-07_JPRB, 0.91783242E-07_JPRB, 0.92228539E-07_JPRB, &
  & 0.92664962E-07_JPRB, 0.93062205E-07_JPRB, 0.93396096E-07_JPRB, 0.93644026E-07_JPRB, 0.93782653E-07_JPRB, 0.93842893E-07_JPRB, &
  & 0.93844037E-07_JPRB, 0.93813284E-07_JPRB, 0.93771021E-07_JPRB, 0.93723543E-07_JPRB, 0.93672533E-07_JPRB, 0.93614069E-07_JPRB, &
  & 0.93524058E-07_JPRB, 0.93328616E-07_JPRB, 0.93086967E-07_JPRB, 0.92937668E-07_JPRB, 0.92877031E-07_JPRB, 0.92878068E-07_JPRB, &
  & 0.92922676E-07_JPRB, 0.93005376E-07_JPRB, 0.93117578E-07_JPRB, 0.93239912E-07_JPRB, 0.93378311E-07_JPRB, 0.93555656E-07_JPRB, &
  & 0.93765713E-07_JPRB, 0.93992689E-07_JPRB, 0.94160271E-07_JPRB, 0.94254787E-07_JPRB, 0.94292687E-07_JPRB, 0.94293611E-07_JPRB, &
  & 0.94267115E-07_JPRB, 0.94217413E-07_JPRB, 0.94147346E-07_JPRB, 0.94058976E-07_JPRB, 0.93952274E-07_JPRB, 0.93824774E-07_JPRB, &
  & 0.93674331E-07_JPRB, 0.93501122E-07_JPRB, 0.93310000E-07_JPRB, 0.93111446E-07_JPRB, 0.92920239E-07_JPRB, 0.92750199E-07_JPRB, &
  & 0.92608325E-07_JPRB, 0.92494361E-07_JPRB, 0.92404321E-07_JPRB, 0.92333934E-07_JPRB, 0.92279947E-07_JPRB, 0.92240143E-07_JPRB, &
  & 0.92208566E-07_JPRB, 0.92182958E-07_JPRB, 0.92166211E-07_JPRB, 0.92155936E-07_JPRB /)

RGHG3(:, 2, 3) = (/ &
  & 0.89214325E-07_JPRB, 0.89286452E-07_JPRB, 0.89404764E-07_JPRB, 0.89580219E-07_JPRB, 0.89818855E-07_JPRB, 0.90120913E-07_JPRB, &
  & 0.90481890E-07_JPRB, 0.90897750E-07_JPRB, 0.91364242E-07_JPRB, 0.91873375E-07_JPRB, 0.92404250E-07_JPRB, 0.92932659E-07_JPRB, &
  & 0.93434203E-07_JPRB, 0.93882811E-07_JPRB, 0.94252343E-07_JPRB, 0.94517155E-07_JPRB, 0.94671229E-07_JPRB, 0.94723603E-07_JPRB, &
  & 0.94700269E-07_JPRB, 0.94632668E-07_JPRB, 0.94533860E-07_JPRB, 0.94415299E-07_JPRB, 0.94291494E-07_JPRB, 0.94154650E-07_JPRB, &
  & 0.94020876E-07_JPRB, 0.93879997E-07_JPRB, 0.93741725E-07_JPRB, 0.93636089E-07_JPRB, 0.93578116E-07_JPRB, 0.93568133E-07_JPRB, &
  & 0.93610922E-07_JPRB, 0.93717333E-07_JPRB, 0.93895800E-07_JPRB, 0.94149456E-07_JPRB, 0.94458827E-07_JPRB, 0.94822944E-07_JPRB, &
  & 0.95228373E-07_JPRB, 0.95631485E-07_JPRB, 0.95941864E-07_JPRB, 0.96118441E-07_JPRB, 0.96167504E-07_JPRB, 0.96113801E-07_JPRB, &
  & 0.95978713E-07_JPRB, 0.95779072E-07_JPRB, 0.95529430E-07_JPRB, 0.95243422E-07_JPRB, 0.94929440E-07_JPRB, 0.94597098E-07_JPRB, &
  & 0.94264273E-07_JPRB, 0.93951328E-07_JPRB, 0.93667190E-07_JPRB, 0.93404893E-07_JPRB, 0.93154377E-07_JPRB, 0.92912728E-07_JPRB, &
  & 0.92681617E-07_JPRB, 0.92463551E-07_JPRB, 0.92262376E-07_JPRB, 0.92085472E-07_JPRB, 0.91938333E-07_JPRB, 0.91818663E-07_JPRB, &
  & 0.91720999E-07_JPRB, 0.91641425E-07_JPRB, 0.91576183E-07_JPRB, 0.91506742E-07_JPRB /)

RGHG3(:, 3, 3) = (/ &
  & 0.89214673E-07_JPRB, 0.89335479E-07_JPRB, 0.89490236E-07_JPRB, 0.89700272E-07_JPRB, 0.89973206E-07_JPRB, 0.90316384E-07_JPRB, &
  & 0.90730467E-07_JPRB, 0.91200796E-07_JPRB, 0.91713964E-07_JPRB, 0.92262809E-07_JPRB, 0.92840416E-07_JPRB, 0.93426017E-07_JPRB, &
  & 0.93993243E-07_JPRB, 0.94511236E-07_JPRB, 0.94950039E-07_JPRB, 0.95286858E-07_JPRB, 0.95504426E-07_JPRB, 0.95605529E-07_JPRB, &
  & 0.95610680E-07_JPRB, 0.95546845E-07_JPRB, 0.95448542E-07_JPRB, 0.95337214E-07_JPRB, 0.95216947E-07_JPRB, 0.95098017E-07_JPRB, &
  & 0.94987946E-07_JPRB, 0.94918143E-07_JPRB, 0.94909986E-07_JPRB, 0.94951417E-07_JPRB, 0.95029755E-07_JPRB, 0.95143584E-07_JPRB, &
  & 0.95293366E-07_JPRB, 0.95497235E-07_JPRB, 0.95787740E-07_JPRB, 0.96177743E-07_JPRB, 0.96665971E-07_JPRB, 0.97218447E-07_JPRB, &
  & 0.97833777E-07_JPRB, 0.98474104E-07_JPRB, 0.99059221E-07_JPRB, 0.99444719E-07_JPRB, 0.99550249E-07_JPRB, 0.99378333E-07_JPRB, &
  & 0.98977154E-07_JPRB, 0.98413182E-07_JPRB, 0.97758154E-07_JPRB, 0.97072217E-07_JPRB, 0.96392775E-07_JPRB, 0.95748348E-07_JPRB, &
  & 0.95163834E-07_JPRB, 0.94639361E-07_JPRB, 0.94159489E-07_JPRB, 0.93717290E-07_JPRB, 0.93314604E-07_JPRB, 0.92948206E-07_JPRB, &
  & 0.92608161E-07_JPRB, 0.92285802E-07_JPRB, 0.91981093E-07_JPRB, 0.91708792E-07_JPRB, 0.91482008E-07_JPRB, 0.91297011E-07_JPRB, &
  & 0.91147804E-07_JPRB, 0.91025896E-07_JPRB, 0.90923358E-07_JPRB, 0.90798331E-07_JPRB /)

RGHG3(:, 4, 3) = (/ &
  & 0.89178620E-07_JPRB, 0.89264297E-07_JPRB, 0.89406264E-07_JPRB, 0.89630809E-07_JPRB, 0.89952671E-07_JPRB, 0.90369433E-07_JPRB, &
  & 0.90870039E-07_JPRB, 0.91439553E-07_JPRB, 0.92052275E-07_JPRB, 0.92694499E-07_JPRB, 0.93352327E-07_JPRB, 0.94011909E-07_JPRB, &
  & 0.94655704E-07_JPRB, 0.95264035E-07_JPRB, 0.95820937E-07_JPRB, 0.96306913E-07_JPRB, 0.96707723E-07_JPRB, 0.97010442E-07_JPRB, &
  & 0.97216137E-07_JPRB, 0.97352668E-07_JPRB, 0.97455079E-07_JPRB, 0.97555215E-07_JPRB, 0.97695576E-07_JPRB, 0.97915830E-07_JPRB, &
  & 0.98225541E-07_JPRB, 0.98607870E-07_JPRB, 0.99019765E-07_JPRB, 0.99434033E-07_JPRB, 0.99829222E-07_JPRB, 0.10017015E-06_JPRB, &
  & 0.10042982E-06_JPRB, 0.10065411E-06_JPRB, 0.10093573E-06_JPRB, 0.10136595E-06_JPRB, 0.10198073E-06_JPRB, 0.10278029E-06_JPRB, &
  & 0.10368750E-06_JPRB, 0.10461059E-06_JPRB, 0.10539788E-06_JPRB, 0.10586379E-06_JPRB, 0.10582528E-06_JPRB, 0.10521732E-06_JPRB, &
  & 0.10413612E-06_JPRB, 0.10277398E-06_JPRB, 0.10133180E-06_JPRB, 0.99949219E-07_JPRB, 0.98686890E-07_JPRB, 0.97570229E-07_JPRB, &
  & 0.96610663E-07_JPRB, 0.95787016E-07_JPRB, 0.95077112E-07_JPRB, 0.94465861E-07_JPRB, 0.93934823E-07_JPRB, 0.93463498E-07_JPRB, &
  & 0.93036562E-07_JPRB, 0.92645593E-07_JPRB, 0.92288737E-07_JPRB, 0.91971373E-07_JPRB, 0.91703029E-07_JPRB, 0.91481056E-07_JPRB, &
  & 0.91307342E-07_JPRB, 0.91171323E-07_JPRB, 0.91061949E-07_JPRB, 0.90955432E-07_JPRB /)

RGHG3(:, 5, 3) = (/ &
  & 0.89085631E-07_JPRB, 0.89162469E-07_JPRB, 0.89362551E-07_JPRB, 0.89674998E-07_JPRB, 0.90105956E-07_JPRB, 0.90651803E-07_JPRB, &
  & 0.91293515E-07_JPRB, 0.92004697E-07_JPRB, 0.92763763E-07_JPRB, 0.93546959E-07_JPRB, 0.94340926E-07_JPRB, 0.95132734E-07_JPRB, &
  & 0.95911112E-07_JPRB, 0.96670433E-07_JPRB, 0.97407636E-07_JPRB, 0.98133256E-07_JPRB, 0.98855679E-07_JPRB, 0.99587474E-07_JPRB, &
  & 0.10034467E-06_JPRB, 0.10115006E-06_JPRB, 0.10204258E-06_JPRB, 0.10306786E-06_JPRB, 0.10425527E-06_JPRB, 0.10557978E-06_JPRB, &
  & 0.10696188E-06_JPRB, 0.10831145E-06_JPRB, 0.10956538E-06_JPRB, 0.11067808E-06_JPRB, 0.11160231E-06_JPRB, 0.11227475E-06_JPRB, &
  & 0.11268138E-06_JPRB, 0.11284765E-06_JPRB, 0.11291531E-06_JPRB, 0.11306088E-06_JPRB, 0.11339036E-06_JPRB, 0.11391579E-06_JPRB, &
  & 0.11456432E-06_JPRB, 0.11518080E-06_JPRB, 0.11555072E-06_JPRB, 0.11541033E-06_JPRB, 0.11453074E-06_JPRB, 0.11288085E-06_JPRB, &
  & 0.11068431E-06_JPRB, 0.10832768E-06_JPRB, 0.10607894E-06_JPRB, 0.10405603E-06_JPRB, 0.10227966E-06_JPRB, 0.10072933E-06_JPRB, &
  & 0.99380273E-07_JPRB, 0.98198441E-07_JPRB, 0.97161411E-07_JPRB, 0.96253025E-07_JPRB, 0.95455576E-07_JPRB, 0.94754647E-07_JPRB, &
  & 0.94138606E-07_JPRB, 0.93596249E-07_JPRB, 0.93118679E-07_JPRB, 0.92705704E-07_JPRB, 0.92359684E-07_JPRB, 0.92076910E-07_JPRB, &
  & 0.91851796E-07_JPRB, 0.91671353E-07_JPRB, 0.91532335E-07_JPRB, 0.91406207E-07_JPRB /)

RGHG3(:, 6, 3) = (/ &
  & 0.89041272E-07_JPRB, 0.89284171E-07_JPRB, 0.89629850E-07_JPRB, 0.90105765E-07_JPRB, 0.90719880E-07_JPRB, 0.91462837E-07_JPRB, &
  & 0.92315375E-07_JPRB, 0.93248659E-07_JPRB, 0.94229122E-07_JPRB, 0.95239749E-07_JPRB, 0.96265467E-07_JPRB, 0.97282800E-07_JPRB, &
  & 0.98277837E-07_JPRB, 0.99246577E-07_JPRB, 0.10020488E-06_JPRB, 0.10117682E-06_JPRB, 0.10220295E-06_JPRB, 0.10332934E-06_JPRB, &
  & 0.10460504E-06_JPRB, 0.10608680E-06_JPRB, 0.10782067E-06_JPRB, 0.10983716E-06_JPRB, 0.11210442E-06_JPRB, 0.11450703E-06_JPRB, &
  & 0.11689844E-06_JPRB, 0.11914477E-06_JPRB, 0.12121515E-06_JPRB, 0.12308787E-06_JPRB, 0.12472145E-06_JPRB, 0.12605616E-06_JPRB, &
  & 0.12704284E-06_JPRB, 0.12764613E-06_JPRB, 0.12792837E-06_JPRB, 0.12802651E-06_JPRB, 0.12804317E-06_JPRB, 0.12801118E-06_JPRB, &
  & 0.12788449E-06_JPRB, 0.12753793E-06_JPRB, 0.12677721E-06_JPRB, 0.12536573E-06_JPRB, 0.12315509E-06_JPRB, 0.12024931E-06_JPRB, &
  & 0.11710002E-06_JPRB, 0.11409287E-06_JPRB, 0.11141518E-06_JPRB, 0.10907667E-06_JPRB, 0.10703067E-06_JPRB, 0.10521519E-06_JPRB, &
  & 0.10358394E-06_JPRB, 0.10210297E-06_JPRB, 0.10075758E-06_JPRB, 0.99535953E-07_JPRB, 0.98430739E-07_JPRB, 0.97437869E-07_JPRB, &
  & 0.96552597E-07_JPRB, 0.95771284E-07_JPRB, 0.95091551E-07_JPRB, 0.94511527E-07_JPRB, 0.94030952E-07_JPRB, 0.93645447E-07_JPRB, &
  & 0.93343232E-07_JPRB, 0.93108028E-07_JPRB, 0.92901466E-07_JPRB, 0.92665402E-07_JPRB /)

RGHG3(:, 7, 3) = (/ &
  & 0.89306710E-07_JPRB, 0.89968424E-07_JPRB, 0.90579384E-07_JPRB, 0.91304940E-07_JPRB, 0.92183555E-07_JPRB, 0.93222035E-07_JPRB, &
  & 0.94399788E-07_JPRB, 0.95684641E-07_JPRB, 0.97039134E-07_JPRB, 0.98433077E-07_JPRB, 0.99834409E-07_JPRB, 0.10120225E-06_JPRB, &
  & 0.10251279E-06_JPRB, 0.10375125E-06_JPRB, 0.10492745E-06_JPRB, 0.10607783E-06_JPRB, 0.10726292E-06_JPRB, 0.10855860E-06_JPRB, &
  & 0.11004406E-06_JPRB, 0.11179488E-06_JPRB, 0.11387430E-06_JPRB, 0.11632080E-06_JPRB, 0.11912745E-06_JPRB, 0.12220401E-06_JPRB, &
  & 0.12532361E-06_JPRB, 0.12836045E-06_JPRB, 0.13118976E-06_JPRB, 0.13380904E-06_JPRB, 0.13616400E-06_JPRB, 0.13819155E-06_JPRB, &
  & 0.13977971E-06_JPRB, 0.14086285E-06_JPRB, 0.14142370E-06_JPRB, 0.14152830E-06_JPRB, 0.14124842E-06_JPRB, 0.14063481E-06_JPRB, &
  & 0.13967075E-06_JPRB, 0.13826599E-06_JPRB, 0.13628338E-06_JPRB, 0.13359590E-06_JPRB, 0.13018997E-06_JPRB, 0.12639580E-06_JPRB, &
  & 0.12267984E-06_JPRB, 0.11936540E-06_JPRB, 0.11652288E-06_JPRB, 0.11409809E-06_JPRB, 0.11200168E-06_JPRB, 0.11012326E-06_JPRB, &
  & 0.10839406E-06_JPRB, 0.10677951E-06_JPRB, 0.10526074E-06_JPRB, 0.10382914E-06_JPRB, 0.10248679E-06_JPRB, 0.10124269E-06_JPRB, &
  & 0.10010756E-06_JPRB, 0.99091871E-07_JPRB, 0.98202278E-07_JPRB, 0.97442467E-07_JPRB, 0.96812961E-07_JPRB, 0.96308078E-07_JPRB, &
  & 0.95910906E-07_JPRB, 0.95587339E-07_JPRB, 0.95308458E-07_JPRB, 0.94911776E-07_JPRB /)

RGHG3(:, 8, 3) = (/ &
  & 0.90301107E-07_JPRB, 0.91677435E-07_JPRB, 0.92726310E-07_JPRB, 0.93840285E-07_JPRB, 0.95131504E-07_JPRB, 0.96631226E-07_JPRB, &
  & 0.98327583E-07_JPRB, 0.10017955E-06_JPRB, 0.10214491E-06_JPRB, 0.10417797E-06_JPRB, 0.10621713E-06_JPRB, 0.10819767E-06_JPRB, &
  & 0.11006838E-06_JPRB, 0.11178203E-06_JPRB, 0.11333363E-06_JPRB, 0.11475633E-06_JPRB, 0.11611839E-06_JPRB, 0.11750924E-06_JPRB, &
  & 0.11903241E-06_JPRB, 0.12078957E-06_JPRB, 0.12286570E-06_JPRB, 0.12531899E-06_JPRB, 0.12816650E-06_JPRB, 0.13131672E-06_JPRB, &
  & 0.13467049E-06_JPRB, 0.13798298E-06_JPRB, 0.14118490E-06_JPRB, 0.14415575E-06_JPRB, 0.14684700E-06_JPRB, 0.14914363E-06_JPRB, &
  & 0.15092751E-06_JPRB, 0.15206955E-06_JPRB, 0.15252891E-06_JPRB, 0.15234049E-06_JPRB, 0.15157197E-06_JPRB, 0.15029045E-06_JPRB, &
  & 0.14851207E-06_JPRB, 0.14619839E-06_JPRB, 0.14326511E-06_JPRB, 0.13966910E-06_JPRB, 0.13552551E-06_JPRB, 0.13119251E-06_JPRB, &
  & 0.12714898E-06_JPRB, 0.12370447E-06_JPRB, 0.12087123E-06_JPRB, 0.11851300E-06_JPRB, 0.11644798E-06_JPRB, 0.11458260E-06_JPRB, &
  & 0.11285250E-06_JPRB, 0.11121297E-06_JPRB, 0.10964228E-06_JPRB, 0.10813358E-06_JPRB, 0.10669449E-06_JPRB, 0.10533874E-06_JPRB, &
  & 0.10408144E-06_JPRB, 0.10293873E-06_JPRB, 0.10192298E-06_JPRB, 0.10104569E-06_JPRB, 0.10031435E-06_JPRB, 0.99726897E-07_JPRB, &
  & 0.99261904E-07_JPRB, 0.98888258E-07_JPRB, 0.98527366E-07_JPRB, 0.98028607E-07_JPRB /)

RGHG3(:, 9, 3) = (/ &
  & 0.92566296E-07_JPRB, 0.95003216E-07_JPRB, 0.96678107E-07_JPRB, 0.98357539E-07_JPRB, 0.10021399E-06_JPRB, 0.10231678E-06_JPRB, &
  & 0.10466810E-06_JPRB, 0.10724437E-06_JPRB, 0.10999641E-06_JPRB, 0.11285332E-06_JPRB, 0.11573992E-06_JPRB, 0.11857873E-06_JPRB, &
  & 0.12129017E-06_JPRB, 0.12378807E-06_JPRB, 0.12604866E-06_JPRB, 0.12808107E-06_JPRB, 0.12992327E-06_JPRB, 0.13164676E-06_JPRB, &
  & 0.13335358E-06_JPRB, 0.13515128E-06_JPRB, 0.13713890E-06_JPRB, 0.13937354E-06_JPRB, 0.14185926E-06_JPRB, 0.14457119E-06_JPRB, &
  & 0.14738960E-06_JPRB, 0.15024048E-06_JPRB, 0.15300691E-06_JPRB, 0.15563860E-06_JPRB, 0.15801751E-06_JPRB, 0.16000013E-06_JPRB, &
  & 0.16140396E-06_JPRB, 0.16208226E-06_JPRB, 0.16195273E-06_JPRB, 0.16104485E-06_JPRB, 0.15945464E-06_JPRB, 0.15728405E-06_JPRB, &
  & 0.15461771E-06_JPRB, 0.15147944E-06_JPRB, 0.14788228E-06_JPRB, 0.14381081E-06_JPRB, 0.13936186E-06_JPRB, 0.13486506E-06_JPRB, &
  & 0.13076732E-06_JPRB, 0.12725657E-06_JPRB, 0.12433338E-06_JPRB, 0.12186052E-06_JPRB, 0.11975719E-06_JPRB, 0.11791856E-06_JPRB, &
  & 0.11624022E-06_JPRB, 0.11466272E-06_JPRB, 0.11315066E-06_JPRB, 0.11169168E-06_JPRB, 0.11028610E-06_JPRB, 0.10894565E-06_JPRB, &
  & 0.10769099E-06_JPRB, 0.10654118E-06_JPRB, 0.10551535E-06_JPRB, 0.10462746E-06_JPRB, 0.10388931E-06_JPRB, 0.10329759E-06_JPRB, &
  & 0.10283342E-06_JPRB, 0.10244497E-06_JPRB, 0.10208532E-06_JPRB, 0.10151786E-06_JPRB /)

RGHG3(:,10, 3) = (/ &
  & 0.96756096E-07_JPRB, 0.10053814E-06_JPRB, 0.10300003E-06_JPRB, 0.10532865E-06_JPRB, 0.10783207E-06_JPRB, 0.11060413E-06_JPRB, &
  & 0.11367375E-06_JPRB, 0.11700917E-06_JPRB, 0.12056294E-06_JPRB, 0.12427749E-06_JPRB, 0.12807567E-06_JPRB, 0.13185593E-06_JPRB, &
  & 0.13551697E-06_JPRB, 0.13898064E-06_JPRB, 0.14219825E-06_JPRB, 0.14514565E-06_JPRB, 0.14781845E-06_JPRB, 0.15023582E-06_JPRB, &
  & 0.15243907E-06_JPRB, 0.15450134E-06_JPRB, 0.15647991E-06_JPRB, 0.15842562E-06_JPRB, 0.16034788E-06_JPRB, 0.16224369E-06_JPRB, &
  & 0.16410054E-06_JPRB, 0.16589360E-06_JPRB, 0.16762071E-06_JPRB, 0.16923558E-06_JPRB, 0.17064909E-06_JPRB, 0.17170348E-06_JPRB, &
  & 0.17218417E-06_JPRB, 0.17189066E-06_JPRB, 0.17071768E-06_JPRB, 0.16870183E-06_JPRB, 0.16598517E-06_JPRB, 0.16275131E-06_JPRB, &
  & 0.15916066E-06_JPRB, 0.15531705E-06_JPRB, 0.15120999E-06_JPRB, 0.14688433E-06_JPRB, 0.14239153E-06_JPRB, 0.13786243E-06_JPRB, &
  & 0.13353551E-06_JPRB, 0.12973659E-06_JPRB, 0.12658043E-06_JPRB, 0.12404732E-06_JPRB, 0.12194593E-06_JPRB, 0.12012956E-06_JPRB, &
  & 0.11850860E-06_JPRB, 0.11701756E-06_JPRB, 0.11560950E-06_JPRB, 0.11426098E-06_JPRB, 0.11296410E-06_JPRB, 0.11172931E-06_JPRB, &
  & 0.11057006E-06_JPRB, 0.10950993E-06_JPRB, 0.10856689E-06_JPRB, 0.10775896E-06_JPRB, 0.10709429E-06_JPRB, 0.10657039E-06_JPRB, &
  & 0.10615233E-06_JPRB, 0.10581386E-06_JPRB, 0.10546940E-06_JPRB, 0.10495986E-06_JPRB /)

RGHG3(:,11, 3) = (/ &
  & 0.10364153E-06_JPRB, 0.10911521E-06_JPRB, 0.11247480E-06_JPRB, 0.11554314E-06_JPRB, 0.11869716E-06_JPRB, 0.12208557E-06_JPRB, &
  & 0.12574361E-06_JPRB, 0.12967264E-06_JPRB, 0.13383321E-06_JPRB, 0.13816357E-06_JPRB, 0.14260529E-06_JPRB, 0.14707504E-06_JPRB, &
  & 0.15150761E-06_JPRB, 0.15581183E-06_JPRB, 0.15992589E-06_JPRB, 0.16379691E-06_JPRB, 0.16737386E-06_JPRB, 0.17060511E-06_JPRB, &
  & 0.17345972E-06_JPRB, 0.17592285E-06_JPRB, 0.17800994E-06_JPRB, 0.17974267E-06_JPRB, 0.18115834E-06_JPRB, 0.18228000E-06_JPRB, &
  & 0.18315049E-06_JPRB, 0.18381046E-06_JPRB, 0.18430741E-06_JPRB, 0.18464392E-06_JPRB, 0.18475539E-06_JPRB, 0.18449558E-06_JPRB, &
  & 0.18366933E-06_JPRB, 0.18208519E-06_JPRB, 0.17961491E-06_JPRB, 0.17627229E-06_JPRB, 0.17221220E-06_JPRB, 0.16778178E-06_JPRB, &
  & 0.16326088E-06_JPRB, 0.15878156E-06_JPRB, 0.15442404E-06_JPRB, 0.15002111E-06_JPRB, 0.14549254E-06_JPRB, 0.14093055E-06_JPRB, &
  & 0.13656457E-06_JPRB, 0.13260545E-06_JPRB, 0.12923007E-06_JPRB, 0.12640901E-06_JPRB, 0.12409770E-06_JPRB, 0.12216771E-06_JPRB, &
  & 0.12049802E-06_JPRB, 0.11899816E-06_JPRB, 0.11761728E-06_JPRB, 0.11632115E-06_JPRB, 0.11509627E-06_JPRB, 0.11394334E-06_JPRB, &
  & 0.11287817E-06_JPRB, 0.11191761E-06_JPRB, 0.11108154E-06_JPRB, 0.11037986E-06_JPRB, 0.10981586E-06_JPRB, 0.10937120E-06_JPRB, &
  & 0.10903129E-06_JPRB, 0.10873636E-06_JPRB, 0.10846287E-06_JPRB, 0.10801378E-06_JPRB /)

RGHG3(:,12, 3) = (/ &
  & 0.11454402E-06_JPRB, 0.12195679E-06_JPRB, 0.12640534E-06_JPRB, 0.13004781E-06_JPRB, 0.13369666E-06_JPRB, 0.13741007E-06_JPRB, &
  & 0.14130073E-06_JPRB, 0.14538162E-06_JPRB, 0.14965856E-06_JPRB, 0.15412512E-06_JPRB, 0.15874829E-06_JPRB, 0.16347566E-06_JPRB, &
  & 0.16823441E-06_JPRB, 0.17296864E-06_JPRB, 0.17760827E-06_JPRB, 0.18206633E-06_JPRB, 0.18625251E-06_JPRB, 0.19008617E-06_JPRB, &
  & 0.19342390E-06_JPRB, 0.19623879E-06_JPRB, 0.19846178E-06_JPRB, 0.20012661E-06_JPRB, 0.20123275E-06_JPRB, 0.20184378E-06_JPRB, &
  & 0.20201446E-06_JPRB, 0.20181554E-06_JPRB, 0.20129568E-06_JPRB, 0.20047403E-06_JPRB, 0.19932082E-06_JPRB, 0.19773771E-06_JPRB, &
  & 0.19558438E-06_JPRB, 0.19272481E-06_JPRB, 0.18907825E-06_JPRB, 0.18465860E-06_JPRB, 0.17969482E-06_JPRB, 0.17443548E-06_JPRB, &
  & 0.16917858E-06_JPRB, 0.16423563E-06_JPRB, 0.15960704E-06_JPRB, 0.15524843E-06_JPRB, 0.15095627E-06_JPRB, 0.14661725E-06_JPRB, &
  & 0.14228462E-06_JPRB, 0.13815409E-06_JPRB, 0.13441679E-06_JPRB, 0.13121701E-06_JPRB, 0.12849537E-06_JPRB, 0.12617143E-06_JPRB, &
  & 0.12414202E-06_JPRB, 0.12233292E-06_JPRB, 0.12069185E-06_JPRB, 0.11918445E-06_JPRB, 0.11779293E-06_JPRB, 0.11651977E-06_JPRB, &
  & 0.11537372E-06_JPRB, 0.11437263E-06_JPRB, 0.11352491E-06_JPRB, 0.11283243E-06_JPRB, 0.11228510E-06_JPRB, 0.11186905E-06_JPRB, &
  & 0.11153813E-06_JPRB, 0.11127914E-06_JPRB, 0.11101261E-06_JPRB, 0.11063394E-06_JPRB /)

RGHG3(:,13, 3) = (/ &
  & 0.13064226E-06_JPRB, 0.13981395E-06_JPRB, 0.14481297E-06_JPRB, 0.14865125E-06_JPRB, 0.15222876E-06_JPRB, 0.15573737E-06_JPRB, &
  & 0.15930524E-06_JPRB, 0.16300230E-06_JPRB, 0.16687432E-06_JPRB, 0.17096259E-06_JPRB, 0.17528482E-06_JPRB, 0.17981161E-06_JPRB, &
  & 0.18449198E-06_JPRB, 0.18923176E-06_JPRB, 0.19396275E-06_JPRB, 0.19858899E-06_JPRB, 0.20297081E-06_JPRB, 0.20701819E-06_JPRB, &
  & 0.21056924E-06_JPRB, 0.21354103E-06_JPRB, 0.21586042E-06_JPRB, 0.21750559E-06_JPRB, 0.21848899E-06_JPRB, 0.21886353E-06_JPRB, &
  & 0.21868159E-06_JPRB, 0.21799663E-06_JPRB, 0.21683661E-06_JPRB, 0.21521457E-06_JPRB, 0.21311422E-06_JPRB, 0.21049449E-06_JPRB, &
  & 0.20729208E-06_JPRB, 0.20344737E-06_JPRB, 0.19896416E-06_JPRB, 0.19392169E-06_JPRB, 0.18846848E-06_JPRB, 0.18299738E-06_JPRB, &
  & 0.17787957E-06_JPRB, 0.17328168E-06_JPRB, 0.16917902E-06_JPRB, 0.16538090E-06_JPRB, 0.16171407E-06_JPRB, 0.15801338E-06_JPRB, &
  & 0.15412921E-06_JPRB, 0.15009897E-06_JPRB, 0.14607615E-06_JPRB, 0.14220173E-06_JPRB, 0.13864687E-06_JPRB, 0.13544518E-06_JPRB, &
  & 0.13256376E-06_JPRB, 0.12994600E-06_JPRB, 0.12754541E-06_JPRB, 0.12533707E-06_JPRB, 0.12330953E-06_JPRB, 0.12146766E-06_JPRB, &
  & 0.11983002E-06_JPRB, 0.11841428E-06_JPRB, 0.11722720E-06_JPRB, 0.11626322E-06_JPRB, 0.11550593E-06_JPRB, 0.11491804E-06_JPRB, &
  & 0.11447830E-06_JPRB, 0.11410371E-06_JPRB, 0.11377419E-06_JPRB, 0.11327246E-06_JPRB /)

RGHG3(:,14, 3) = (/ &
  & 0.15098637E-06_JPRB, 0.16020563E-06_JPRB, 0.16481738E-06_JPRB, 0.16824828E-06_JPRB, 0.17131393E-06_JPRB, 0.17428343E-06_JPRB, &
  & 0.17729273E-06_JPRB, 0.18041793E-06_JPRB, 0.18372273E-06_JPRB, 0.18726158E-06_JPRB, 0.19106794E-06_JPRB, 0.19513097E-06_JPRB, &
  & 0.19942566E-06_JPRB, 0.20387637E-06_JPRB, 0.20839431E-06_JPRB, 0.21286176E-06_JPRB, 0.21714112E-06_JPRB, 0.22110802E-06_JPRB, &
  & 0.22462885E-06_JPRB, 0.22758221E-06_JPRB, 0.22987862E-06_JPRB, 0.23149329E-06_JPRB, 0.23241716E-06_JPRB, 0.23267856E-06_JPRB, &
  & 0.23231789E-06_JPRB, 0.23138873E-06_JPRB, 0.22990784E-06_JPRB, 0.22786935E-06_JPRB, 0.22526483E-06_JPRB, 0.22209535E-06_JPRB, &
  & 0.21836124E-06_JPRB, 0.21410638E-06_JPRB, 0.20941052E-06_JPRB, 0.20440723E-06_JPRB, 0.19935028E-06_JPRB, 0.19458415E-06_JPRB, &
  & 0.19041083E-06_JPRB, 0.18692147E-06_JPRB, 0.18398278E-06_JPRB, 0.18135940E-06_JPRB, 0.17885955E-06_JPRB, 0.17623475E-06_JPRB, &
  & 0.17320247E-06_JPRB, 0.16964327E-06_JPRB, 0.16559125E-06_JPRB, 0.16118405E-06_JPRB, 0.15668684E-06_JPRB, 0.15233822E-06_JPRB, &
  & 0.14825605E-06_JPRB, 0.14445462E-06_JPRB, 0.14090537E-06_JPRB, 0.13757685E-06_JPRB, 0.13445518E-06_JPRB, 0.13155655E-06_JPRB, &
  & 0.12891716E-06_JPRB, 0.12657837E-06_JPRB, 0.12456651E-06_JPRB, 0.12288240E-06_JPRB, 0.12151710E-06_JPRB, 0.12045106E-06_JPRB, &
  & 0.11959750E-06_JPRB, 0.11892175E-06_JPRB, 0.11825485E-06_JPRB, 0.11735287E-06_JPRB /)

RGHG3(:,15, 3) = (/ &
  & 0.17172178E-06_JPRB, 0.17949327E-06_JPRB, 0.18322318E-06_JPRB, 0.18607562E-06_JPRB, 0.18864361E-06_JPRB, 0.19114913E-06_JPRB, &
  & 0.19369958E-06_JPRB, 0.19636569E-06_JPRB, 0.19919801E-06_JPRB, 0.20224986E-06_JPRB, 0.20555815E-06_JPRB, 0.20912944E-06_JPRB, &
  & 0.21292763E-06_JPRB, 0.21690529E-06_JPRB, 0.22100996E-06_JPRB, 0.22512626E-06_JPRB, 0.22912661E-06_JPRB, 0.23286741E-06_JPRB, &
  & 0.23621014E-06_JPRB, 0.23902678E-06_JPRB, 0.24122076E-06_JPRB, 0.24273839E-06_JPRB, 0.24358073E-06_JPRB, 0.24376342E-06_JPRB, &
  & 0.24331501E-06_JPRB, 0.24227211E-06_JPRB, 0.24065073E-06_JPRB, 0.23846687E-06_JPRB, 0.23572029E-06_JPRB, 0.23242801E-06_JPRB, &
  & 0.22864918E-06_JPRB, 0.22448020E-06_JPRB, 0.22010278E-06_JPRB, 0.21570577E-06_JPRB, 0.21155543E-06_JPRB, 0.20795612E-06_JPRB, &
  & 0.20509421E-06_JPRB, 0.20299710E-06_JPRB, 0.20144921E-06_JPRB, 0.20016708E-06_JPRB, 0.19891618E-06_JPRB, 0.19738172E-06_JPRB, &
  & 0.19528244E-06_JPRB, 0.19242117E-06_JPRB, 0.18870143E-06_JPRB, 0.18424274E-06_JPRB, 0.17935079E-06_JPRB, 0.17435126E-06_JPRB, &
  & 0.16946629E-06_JPRB, 0.16479260E-06_JPRB, 0.16032769E-06_JPRB, 0.15602988E-06_JPRB, 0.15187076E-06_JPRB, 0.14786391E-06_JPRB, &
  & 0.14407034E-06_JPRB, 0.14057328E-06_JPRB, 0.13743372E-06_JPRB, 0.13470320E-06_JPRB, 0.13241120E-06_JPRB, 0.13053619E-06_JPRB, &
  & 0.12904994E-06_JPRB, 0.12777008E-06_JPRB, 0.12658064E-06_JPRB, 0.12482704E-06_JPRB /)

RGHG3(:,16, 3) = (/ &
  & 0.18943764E-06_JPRB, 0.19582001E-06_JPRB, 0.19896667E-06_JPRB, 0.20141002E-06_JPRB, 0.20366375E-06_JPRB, 0.20589783E-06_JPRB, &
  & 0.20819120E-06_JPRB, 0.21059698E-06_JPRB, 0.21315995E-06_JPRB, 0.21590992E-06_JPRB, 0.21886150E-06_JPRB, 0.22201020E-06_JPRB, &
  & 0.22534029E-06_JPRB, 0.22880967E-06_JPRB, 0.23239750E-06_JPRB, 0.23603602E-06_JPRB, 0.23963619E-06_JPRB, 0.24305103E-06_JPRB, &
  & 0.24613445E-06_JPRB, 0.24874151E-06_JPRB, 0.25076920E-06_JPRB, 0.25215778E-06_JPRB, 0.25289722E-06_JPRB, 0.25300722E-06_JPRB, &
  & 0.25251572E-06_JPRB, 0.25144897E-06_JPRB, 0.24985562E-06_JPRB, 0.24770870E-06_JPRB, 0.24503333E-06_JPRB, 0.24190467E-06_JPRB, &
  & 0.23841140E-06_JPRB, 0.23465972E-06_JPRB, 0.23087043E-06_JPRB, 0.22730136E-06_JPRB, 0.22420343E-06_JPRB, 0.22180740E-06_JPRB, &
  & 0.22023521E-06_JPRB, 0.21939771E-06_JPRB, 0.21904444E-06_JPRB, 0.21885185E-06_JPRB, 0.21852252E-06_JPRB, 0.21778612E-06_JPRB, &
  & 0.21640203E-06_JPRB, 0.21415279E-06_JPRB, 0.21093427E-06_JPRB, 0.20683278E-06_JPRB, 0.20212177E-06_JPRB, 0.19712932E-06_JPRB, &
  & 0.19210884E-06_JPRB, 0.18718843E-06_JPRB, 0.18238276E-06_JPRB, 0.17764845E-06_JPRB, 0.17293759E-06_JPRB, 0.16825841E-06_JPRB, &
  & 0.16367363E-06_JPRB, 0.15929011E-06_JPRB, 0.15522070E-06_JPRB, 0.15155538E-06_JPRB, 0.14838146E-06_JPRB, 0.14575005E-06_JPRB, &
  & 0.14355597E-06_JPRB, 0.14169737E-06_JPRB, 0.13984942E-06_JPRB, 0.13715535E-06_JPRB /)

RGHG3(:,17, 3) = (/ &
  & 0.20394191E-06_JPRB, 0.20947157E-06_JPRB, 0.21226823E-06_JPRB, 0.21452988E-06_JPRB, 0.21666577E-06_JPRB, 0.21882644E-06_JPRB, &
  & 0.22105895E-06_JPRB, 0.22338634E-06_JPRB, 0.22582373E-06_JPRB, 0.22839750E-06_JPRB, 0.23110418E-06_JPRB, 0.23392938E-06_JPRB, &
  & 0.23686053E-06_JPRB, 0.23988946E-06_JPRB, 0.24298336E-06_JPRB, 0.24612359E-06_JPRB, 0.24925146E-06_JPRB, 0.25225955E-06_JPRB, &
  & 0.25501009E-06_JPRB, 0.25734937E-06_JPRB, 0.25916700E-06_JPRB, 0.26039359E-06_JPRB, 0.26101984E-06_JPRB, 0.26106738E-06_JPRB, &
  & 0.26056642E-06_JPRB, 0.25957101E-06_JPRB, 0.25805343E-06_JPRB, 0.25611368E-06_JPRB, 0.25381897E-06_JPRB, 0.25112865E-06_JPRB, &
  & 0.24814139E-06_JPRB, 0.24503910E-06_JPRB, 0.24202441E-06_JPRB, 0.23932836E-06_JPRB, 0.23719055E-06_JPRB, 0.23580908E-06_JPRB, &
  & 0.23520732E-06_JPRB, 0.23522412E-06_JPRB, 0.23557199E-06_JPRB, 0.23594743E-06_JPRB, 0.23608162E-06_JPRB, 0.23576412E-06_JPRB, &
  & 0.23478050E-06_JPRB, 0.23294633E-06_JPRB, 0.23017128E-06_JPRB, 0.22652851E-06_JPRB, 0.22225350E-06_JPRB, 0.21763998E-06_JPRB, &
  & 0.21292010E-06_JPRB, 0.20821237E-06_JPRB, 0.20354217E-06_JPRB, 0.19886402E-06_JPRB, 0.19413045E-06_JPRB, 0.18933223E-06_JPRB, &
  & 0.18452562E-06_JPRB, 0.17981870E-06_JPRB, 0.17533138E-06_JPRB, 0.17120546E-06_JPRB, 0.16757184E-06_JPRB, 0.16447737E-06_JPRB, &
  & 0.16190121E-06_JPRB, 0.15962968E-06_JPRB, 0.15736239E-06_JPRB, 0.15396890E-06_JPRB /)

RGHG3(:,18, 3) = (/ &
  & 0.21592828E-06_JPRB, 0.22099968E-06_JPRB, 0.22369854E-06_JPRB, 0.22591324E-06_JPRB, 0.22802681E-06_JPRB, 0.23017220E-06_JPRB, &
  & 0.23239831E-06_JPRB, 0.23471821E-06_JPRB, 0.23712306E-06_JPRB, 0.23961707E-06_JPRB, 0.24219699E-06_JPRB, 0.24481275E-06_JPRB, &
  & 0.24746186E-06_JPRB, 0.25014782E-06_JPRB, 0.25284004E-06_JPRB, 0.25554411E-06_JPRB, 0.25821888E-06_JPRB, 0.26079334E-06_JPRB, &
  & 0.26315979E-06_JPRB, 0.26517947E-06_JPRB, 0.26674149E-06_JPRB, 0.26778025E-06_JPRB, 0.26828505E-06_JPRB, 0.26827882E-06_JPRB, &
  & 0.26780742E-06_JPRB, 0.26690608E-06_JPRB, 0.26564618E-06_JPRB, 0.26413522E-06_JPRB, 0.26223853E-06_JPRB, 0.26012674E-06_JPRB, &
  & 0.25787722E-06_JPRB, 0.25562377E-06_JPRB, 0.25350971E-06_JPRB, 0.25172272E-06_JPRB, 0.25045449E-06_JPRB, 0.24981657E-06_JPRB, &
  & 0.24979465E-06_JPRB, 0.25021686E-06_JPRB, 0.25080590E-06_JPRB, 0.25131001E-06_JPRB, 0.25150493E-06_JPRB, 0.25121398E-06_JPRB, &
  & 0.25028169E-06_JPRB, 0.24857587E-06_JPRB, 0.24604179E-06_JPRB, 0.24275280E-06_JPRB, 0.23891090E-06_JPRB, 0.23475116E-06_JPRB, &
  & 0.23047072E-06_JPRB, 0.22617908E-06_JPRB, 0.22188463E-06_JPRB, 0.21755467E-06_JPRB, 0.21314395E-06_JPRB, 0.20864192E-06_JPRB, &
  & 0.20408356E-06_JPRB, 0.19955733E-06_JPRB, 0.19518495E-06_JPRB, 0.19110625E-06_JPRB, 0.18746742E-06_JPRB, 0.18435603E-06_JPRB, &
  & 0.18171195E-06_JPRB, 0.17934991E-06_JPRB, 0.17699139E-06_JPRB, 0.17327956E-06_JPRB /)

RGHG3(:,19, 3) = (/ &
  & 0.22606356E-06_JPRB, 0.23087267E-06_JPRB, 0.23348734E-06_JPRB, 0.23569513E-06_JPRB, 0.23782447E-06_JPRB, 0.23999269E-06_JPRB, &
  & 0.24224204E-06_JPRB, 0.24459081E-06_JPRB, 0.24701666E-06_JPRB, 0.24950265E-06_JPRB, 0.25204048E-06_JPRB, 0.25455051E-06_JPRB, &
  & 0.25701374E-06_JPRB, 0.25944996E-06_JPRB, 0.26183474E-06_JPRB, 0.26418144E-06_JPRB, 0.26646211E-06_JPRB, 0.26862864E-06_JPRB, &
  & 0.27060483E-06_JPRB, 0.27228640E-06_JPRB, 0.27358135E-06_JPRB, 0.27442945E-06_JPRB, 0.27481977E-06_JPRB, 0.27478288E-06_JPRB, &
  & 0.27436934E-06_JPRB, 0.27365121E-06_JPRB, 0.27274825E-06_JPRB, 0.27153217E-06_JPRB, 0.27024424E-06_JPRB, 0.26884052E-06_JPRB, &
  & 0.26742373E-06_JPRB, 0.26608959E-06_JPRB, 0.26490358E-06_JPRB, 0.26399965E-06_JPRB, 0.26348306E-06_JPRB, 0.26337199E-06_JPRB, &
  & 0.26362122E-06_JPRB, 0.26409268E-06_JPRB, 0.26458491E-06_JPRB, 0.26487390E-06_JPRB, 0.26481550E-06_JPRB, 0.26428702E-06_JPRB, &
  & 0.26318409E-06_JPRB, 0.26141757E-06_JPRB, 0.25896065E-06_JPRB, 0.25589262E-06_JPRB, 0.25238094E-06_JPRB, 0.24862405E-06_JPRB, &
  & 0.24478479E-06_JPRB, 0.24092390E-06_JPRB, 0.23705861E-06_JPRB, 0.23316872E-06_JPRB, 0.22922607E-06_JPRB, 0.22521992E-06_JPRB, &
  & 0.22117294E-06_JPRB, 0.21714467E-06_JPRB, 0.21322580E-06_JPRB, 0.20954111E-06_JPRB, 0.20623204E-06_JPRB, 0.20337100E-06_JPRB, &
  & 0.20090117E-06_JPRB, 0.19871985E-06_JPRB, 0.19640012E-06_JPRB, 0.19294953E-06_JPRB /)

RGHG3(:,20, 3) = (/ &
  & 0.23472683E-06_JPRB, 0.23933751E-06_JPRB, 0.24188415E-06_JPRB, 0.24408502E-06_JPRB, 0.24623407E-06_JPRB, 0.24842751E-06_JPRB, &
  & 0.25069954E-06_JPRB, 0.25306605E-06_JPRB, 0.25550841E-06_JPRB, 0.25798619E-06_JPRB, 0.26049287E-06_JPRB, 0.26294234E-06_JPRB, &
  & 0.26528568E-06_JPRB, 0.26754515E-06_JPRB, 0.26970667E-06_JPRB, 0.27177390E-06_JPRB, 0.27373849E-06_JPRB, 0.27556607E-06_JPRB, &
  & 0.27720785E-06_JPRB, 0.27859505E-06_JPRB, 0.27965669E-06_JPRB, 0.28034634E-06_JPRB, 0.28065620E-06_JPRB, 0.28061345E-06_JPRB, &
  & 0.28027873E-06_JPRB, 0.27975108E-06_JPRB, 0.27903522E-06_JPRB, 0.27829824E-06_JPRB, 0.27757272E-06_JPRB, 0.27689788E-06_JPRB, &
  & 0.27629562E-06_JPRB, 0.27580174E-06_JPRB, 0.27544860E-06_JPRB, 0.27528753E-06_JPRB, 0.27532798E-06_JPRB, 0.27556473E-06_JPRB, &
  & 0.27593688E-06_JPRB, 0.27629704E-06_JPRB, 0.27649725E-06_JPRB, 0.27641531E-06_JPRB, 0.27596897E-06_JPRB, 0.27508713E-06_JPRB, &
  & 0.27371263E-06_JPRB, 0.27179277E-06_JPRB, 0.26933407E-06_JPRB, 0.26640973E-06_JPRB, 0.26317281E-06_JPRB, 0.25977076E-06_JPRB, &
  & 0.25629677E-06_JPRB, 0.25282020E-06_JPRB, 0.24936594E-06_JPRB, 0.24592740E-06_JPRB, 0.24248803E-06_JPRB, 0.23904030E-06_JPRB, &
  & 0.23559139E-06_JPRB, 0.23217204E-06_JPRB, 0.22884004E-06_JPRB, 0.22568969E-06_JPRB, 0.22282825E-06_JPRB, 0.22032104E-06_JPRB, &
  & 0.21816827E-06_JPRB, 0.21615836E-06_JPRB, 0.21417473E-06_JPRB, 0.21088698E-06_JPRB /)

RGHG3(:,21, 3) = (/ &
  & 0.24220290E-06_JPRB, 0.24663595E-06_JPRB, 0.24909892E-06_JPRB, 0.25122731E-06_JPRB, 0.25333651E-06_JPRB, 0.25551421E-06_JPRB, &
  & 0.25778544E-06_JPRB, 0.26014916E-06_JPRB, 0.26258331E-06_JPRB, 0.26504489E-06_JPRB, 0.26750183E-06_JPRB, 0.26989358E-06_JPRB, &
  & 0.27215469E-06_JPRB, 0.27428948E-06_JPRB, 0.27629713E-06_JPRB, 0.27816776E-06_JPRB, 0.27990268E-06_JPRB, 0.28148659E-06_JPRB, &
  & 0.28288900E-06_JPRB, 0.28406538E-06_JPRB, 0.28496797E-06_JPRB, 0.28556650E-06_JPRB, 0.28585274E-06_JPRB, 0.28585771E-06_JPRB, &
  & 0.28564654E-06_JPRB, 0.28526043E-06_JPRB, 0.28483166E-06_JPRB, 0.28446721E-06_JPRB, 0.28419822E-06_JPRB, 0.28406686E-06_JPRB, &
  & 0.28410332E-06_JPRB, 0.28426396E-06_JPRB, 0.28455739E-06_JPRB, 0.28491917E-06_JPRB, 0.28533174E-06_JPRB, 0.28573319E-06_JPRB, &
  & 0.28605677E-06_JPRB, 0.28619635E-06_JPRB, 0.28607491E-06_JPRB, 0.28563082E-06_JPRB, 0.28482620E-06_JPRB, 0.28363371E-06_JPRB, &
  & 0.28202774E-06_JPRB, 0.27999494E-06_JPRB, 0.27755107E-06_JPRB, 0.27477512E-06_JPRB, 0.27177154E-06_JPRB, 0.26864629E-06_JPRB, &
  & 0.26549816E-06_JPRB, 0.26239280E-06_JPRB, 0.25933960E-06_JPRB, 0.25634063E-06_JPRB, 0.25338858E-06_JPRB, 0.25047405E-06_JPRB, &
  & 0.24759379E-06_JPRB, 0.24475548E-06_JPRB, 0.24198567E-06_JPRB, 0.23933944E-06_JPRB, 0.23690649E-06_JPRB, 0.23474593E-06_JPRB, &
  & 0.23281696E-06_JPRB, 0.23109547E-06_JPRB, 0.22919794E-06_JPRB, 0.22637705E-06_JPRB /)

RGHG3(:,22, 3) = (/ &
  & 0.24869701E-06_JPRB, 0.25287324E-06_JPRB, 0.25527203E-06_JPRB, 0.25734147E-06_JPRB, 0.25937626E-06_JPRB, 0.26148641E-06_JPRB, &
  & 0.26370296E-06_JPRB, 0.26601754E-06_JPRB, 0.26840135E-06_JPRB, 0.27080733E-06_JPRB, 0.27319476E-06_JPRB, 0.27551164E-06_JPRB, &
  & 0.27770091E-06_JPRB, 0.27974261E-06_JPRB, 0.28163876E-06_JPRB, 0.28338513E-06_JPRB, 0.28497948E-06_JPRB, 0.28641526E-06_JPRB, &
  & 0.28767536E-06_JPRB, 0.28873424E-06_JPRB, 0.28956126E-06_JPRB, 0.29013572E-06_JPRB, 0.29045793E-06_JPRB, 0.29055465E-06_JPRB, &
  & 0.29045725E-06_JPRB, 0.29026344E-06_JPRB, 0.29006571E-06_JPRB, 0.28994907E-06_JPRB, 0.28998025E-06_JPRB, 0.29021203E-06_JPRB, &
  & 0.29061638E-06_JPRB, 0.29117604E-06_JPRB, 0.29181388E-06_JPRB, 0.29244092E-06_JPRB, 0.29300762E-06_JPRB, 0.29343232E-06_JPRB, &
  & 0.29364912E-06_JPRB, 0.29359231E-06_JPRB, 0.29322007E-06_JPRB, 0.29251564E-06_JPRB, 0.29147174E-06_JPRB, 0.29008916E-06_JPRB, &
  & 0.28836882E-06_JPRB, 0.28631666E-06_JPRB, 0.28395905E-06_JPRB, 0.28135068E-06_JPRB, 0.27857718E-06_JPRB, 0.27574291E-06_JPRB, &
  & 0.27293663E-06_JPRB, 0.27018427E-06_JPRB, 0.26750561E-06_JPRB, 0.26491227E-06_JPRB, 0.26239718E-06_JPRB, 0.25994726E-06_JPRB, &
  & 0.25754900E-06_JPRB, 0.25519256E-06_JPRB, 0.25288367E-06_JPRB, 0.25065506E-06_JPRB, 0.24856217E-06_JPRB, 0.24665624E-06_JPRB, &
  & 0.24495765E-06_JPRB, 0.24332516E-06_JPRB, 0.24168753E-06_JPRB, 0.23896013E-06_JPRB /)

RGHG3(:,23, 3) = (/ &
  & 0.25433306E-06_JPRB, 0.25829863E-06_JPRB, 0.26054377E-06_JPRB, 0.26251871E-06_JPRB, 0.26447898E-06_JPRB, 0.26650929E-06_JPRB, &
  & 0.26864282E-06_JPRB, 0.27087518E-06_JPRB, 0.27317287E-06_JPRB, 0.27549601E-06_JPRB, 0.27779555E-06_JPRB, 0.28002790E-06_JPRB, &
  & 0.28214819E-06_JPRB, 0.28412387E-06_JPRB, 0.28594533E-06_JPRB, 0.28761252E-06_JPRB, 0.28912601E-06_JPRB, 0.29048371E-06_JPRB, &
  & 0.29167626E-06_JPRB, 0.29269160E-06_JPRB, 0.29350815E-06_JPRB, 0.29411405E-06_JPRB, 0.29451047E-06_JPRB, 0.29471158E-06_JPRB, &
  & 0.29475848E-06_JPRB, 0.29472025E-06_JPRB, 0.29468441E-06_JPRB, 0.29473489E-06_JPRB, 0.29495141E-06_JPRB, 0.29535022E-06_JPRB, &
  & 0.29594284E-06_JPRB, 0.29665958E-06_JPRB, 0.29740585E-06_JPRB, 0.29809851E-06_JPRB, 0.29865453E-06_JPRB, 0.29900002E-06_JPRB, &
  & 0.29908034E-06_JPRB, 0.29885342E-06_JPRB, 0.29830875E-06_JPRB, 0.29744842E-06_JPRB, 0.29628629E-06_JPRB, 0.29483638E-06_JPRB, &
  & 0.29311781E-06_JPRB, 0.29114261E-06_JPRB, 0.28893189E-06_JPRB, 0.28653119E-06_JPRB, 0.28402459E-06_JPRB, 0.28150450E-06_JPRB, &
  & 0.27901370E-06_JPRB, 0.27658524E-06_JPRB, 0.27425634E-06_JPRB, 0.27202756E-06_JPRB, 0.26988943E-06_JPRB, 0.26782362E-06_JPRB, &
  & 0.26580821E-06_JPRB, 0.26382500E-06_JPRB, 0.26186703E-06_JPRB, 0.25994856E-06_JPRB, 0.25811465E-06_JPRB, 0.25640617E-06_JPRB, &
  & 0.25481728E-06_JPRB, 0.25333696E-06_JPRB, 0.25169254E-06_JPRB, 0.24916142E-06_JPRB /)

RGHG3(:,24, 3) = (/ &
  & 0.25930828E-06_JPRB, 0.26300899E-06_JPRB, 0.26513459E-06_JPRB, 0.26699311E-06_JPRB, 0.26884430E-06_JPRB, 0.27077655E-06_JPRB, &
  & 0.27281288E-06_JPRB, 0.27494067E-06_JPRB, 0.27712946E-06_JPRB, 0.27934155E-06_JPRB, 0.28154082E-06_JPRB, 0.28368169E-06_JPRB, &
  & 0.28572524E-06_JPRB, 0.28764228E-06_JPRB, 0.28941497E-06_JPRB, 0.29103728E-06_JPRB, 0.29251098E-06_JPRB, 0.29383702E-06_JPRB, &
  & 0.29501140E-06_JPRB, 0.29602802E-06_JPRB, 0.29687294E-06_JPRB, 0.29754074E-06_JPRB, 0.29802661E-06_JPRB, 0.29833976E-06_JPRB, &
  & 0.29852049E-06_JPRB, 0.29861317E-06_JPRB, 0.29869864E-06_JPRB, 0.29885979E-06_JPRB, 0.29915657E-06_JPRB, 0.29962541E-06_JPRB, &
  & 0.30025487E-06_JPRB, 0.30097132E-06_JPRB, 0.30168616E-06_JPRB, 0.30231357E-06_JPRB, 0.30276669E-06_JPRB, 0.30298315E-06_JPRB, &
  & 0.30292273E-06_JPRB, 0.30255913E-06_JPRB, 0.30190159E-06_JPRB, 0.30096473E-06_JPRB, 0.29977551E-06_JPRB, 0.29835363E-06_JPRB, &
  & 0.29672094E-06_JPRB, 0.29489075E-06_JPRB, 0.29287668E-06_JPRB, 0.29072257E-06_JPRB, 0.28849794E-06_JPRB, 0.28625684E-06_JPRB, &
  & 0.28405029E-06_JPRB, 0.28193278E-06_JPRB, 0.27991499E-06_JPRB, 0.27800195E-06_JPRB, 0.27617830E-06_JPRB, 0.27441894E-06_JPRB, &
  & 0.27269746E-06_JPRB, 0.27099122E-06_JPRB, 0.26928876E-06_JPRB, 0.26759685E-06_JPRB, 0.26594554E-06_JPRB, 0.26437064E-06_JPRB, &
  & 0.26288916E-06_JPRB, 0.26142806E-06_JPRB, 0.25988535E-06_JPRB, 0.25735557E-06_JPRB /)

RGHG3(:,25, 3) = (/ &
  & 0.26373968E-06_JPRB, 0.26718911E-06_JPRB, 0.26918087E-06_JPRB, 0.27092815E-06_JPRB, 0.27266566E-06_JPRB, 0.27448107E-06_JPRB, &
  & 0.27639857E-06_JPRB, 0.27840747E-06_JPRB, 0.28047452E-06_JPRB, 0.28256724E-06_JPRB, 0.28465507E-06_JPRB, 0.28670578E-06_JPRB, &
  & 0.28868089E-06_JPRB, 0.29054283E-06_JPRB, 0.29227212E-06_JPRB, 0.29386143E-06_JPRB, 0.29531117E-06_JPRB, 0.29662326E-06_JPRB, &
  & 0.29779704E-06_JPRB, 0.29883086E-06_JPRB, 0.29971713E-06_JPRB, 0.30044919E-06_JPRB, 0.30102106E-06_JPRB, 0.30143977E-06_JPRB, &
  & 0.30173584E-06_JPRB, 0.30194198E-06_JPRB, 0.30212848E-06_JPRB, 0.30235864E-06_JPRB, 0.30269200E-06_JPRB, 0.30316147E-06_JPRB, &
  & 0.30374031E-06_JPRB, 0.30437764E-06_JPRB, 0.30498651E-06_JPRB, 0.30548560E-06_JPRB, 0.30580088E-06_JPRB, 0.30587938E-06_JPRB, &
  & 0.30569137E-06_JPRB, 0.30522671E-06_JPRB, 0.30450758E-06_JPRB, 0.30355702E-06_JPRB, 0.30240187E-06_JPRB, 0.30106432E-06_JPRB, &
  & 0.29956510E-06_JPRB, 0.29791175E-06_JPRB, 0.29611414E-06_JPRB, 0.29420471E-06_JPRB, 0.29222889E-06_JPRB, 0.29024534E-06_JPRB, &
  & 0.28831900E-06_JPRB, 0.28647389E-06_JPRB, 0.28472903E-06_JPRB, 0.28308290E-06_JPRB, 0.28151493E-06_JPRB, 0.27999633E-06_JPRB, &
  & 0.27849779E-06_JPRB, 0.27699627E-06_JPRB, 0.27547699E-06_JPRB, 0.27394651E-06_JPRB, 0.27243036E-06_JPRB, 0.27095695E-06_JPRB, &
  & 0.26953489E-06_JPRB, 0.26814084E-06_JPRB, 0.26659626E-06_JPRB, 0.26408847E-06_JPRB /)

RGHG3(:,26, 3) = (/ &
  & 0.26776061E-06_JPRB, 0.27098497E-06_JPRB, 0.27282397E-06_JPRB, 0.27444699E-06_JPRB, 0.27607160E-06_JPRB, 0.27776440E-06_JPRB, &
  & 0.27955872E-06_JPRB, 0.28143478E-06_JPRB, 0.28336834E-06_JPRB, 0.28533290E-06_JPRB, 0.28730480E-06_JPRB, 0.28925393E-06_JPRB, &
  & 0.29115094E-06_JPRB, 0.29296180E-06_JPRB, 0.29465696E-06_JPRB, 0.29622203E-06_JPRB, 0.29765576E-06_JPRB, 0.29896034E-06_JPRB, &
  & 0.30013808E-06_JPRB, 0.30118949E-06_JPRB, 0.30211010E-06_JPRB, 0.30289513E-06_JPRB, 0.30353880E-06_JPRB, 0.30404803E-06_JPRB, &
  & 0.30444031E-06_JPRB, 0.30474590E-06_JPRB, 0.30501255E-06_JPRB, 0.30529381E-06_JPRB, 0.30564297E-06_JPRB, 0.30607032E-06_JPRB, &
  & 0.30657245E-06_JPRB, 0.30709316E-06_JPRB, 0.30756635E-06_JPRB, 0.30792131E-06_JPRB, 0.30809790E-06_JPRB, 0.30805325E-06_JPRB, &
  & 0.30776746E-06_JPRB, 0.30724345E-06_JPRB, 0.30650497E-06_JPRB, 0.30558266E-06_JPRB, 0.30450246E-06_JPRB, 0.30328243E-06_JPRB, &
  & 0.30193547E-06_JPRB, 0.30046562E-06_JPRB, 0.29887570E-06_JPRB, 0.29718879E-06_JPRB, 0.29544469E-06_JPRB, 0.29370742E-06_JPRB, &
  & 0.29201917E-06_JPRB, 0.29040979E-06_JPRB, 0.28889428E-06_JPRB, 0.28746541E-06_JPRB, 0.28610097E-06_JPRB, 0.28476947E-06_JPRB, &
  & 0.28344024E-06_JPRB, 0.28208970E-06_JPRB, 0.28070630E-06_JPRB, 0.27929343E-06_JPRB, 0.27787553E-06_JPRB, 0.27647980E-06_JPRB, &
  & 0.27511771E-06_JPRB, 0.27375333E-06_JPRB, 0.27224053E-06_JPRB, 0.26977844E-06_JPRB /)

RGHG3(:,27, 3) = (/ &
  & 0.27147959E-06_JPRB, 0.27443679E-06_JPRB, 0.27616198E-06_JPRB, 0.27766356E-06_JPRB, 0.27916158E-06_JPRB, 0.28073939E-06_JPRB, &
  & 0.28240007E-06_JPRB, 0.28414436E-06_JPRB, 0.28594053E-06_JPRB, 0.28777450E-06_JPRB, 0.28962901E-06_JPRB, 0.29148310E-06_JPRB, &
  & 0.29330221E-06_JPRB, 0.29504918E-06_JPRB, 0.29669872E-06_JPRB, 0.29823553E-06_JPRB, 0.29965429E-06_JPRB, 0.30095330E-06_JPRB, &
  & 0.30213275E-06_JPRB, 0.30319273E-06_JPRB, 0.30413318E-06_JPRB, 0.30495212E-06_JPRB, 0.30564712E-06_JPRB, 0.30622405E-06_JPRB, &
  & 0.30669418E-06_JPRB, 0.30708199E-06_JPRB, 0.30741663E-06_JPRB, 0.30773973E-06_JPRB, 0.30808172E-06_JPRB, 0.30846138E-06_JPRB, &
  & 0.30887082E-06_JPRB, 0.30927035E-06_JPRB, 0.30960891E-06_JPRB, 0.30982994E-06_JPRB, 0.30988650E-06_JPRB, 0.30974468E-06_JPRB, &
  & 0.30939236E-06_JPRB, 0.30884135E-06_JPRB, 0.30812447E-06_JPRB, 0.30726994E-06_JPRB, 0.30629090E-06_JPRB, 0.30520172E-06_JPRB, &
  & 0.30401128E-06_JPRB, 0.30271562E-06_JPRB, 0.30131997E-06_JPRB, 0.29983377E-06_JPRB, 0.29830113E-06_JPRB, 0.29677227E-06_JPRB, &
  & 0.29528712E-06_JPRB, 0.29387726E-06_JPRB, 0.29254809E-06_JPRB, 0.29129214E-06_JPRB, 0.29008623E-06_JPRB, 0.28889849E-06_JPRB, &
  & 0.28769858E-06_JPRB, 0.28646480E-06_JPRB, 0.28518335E-06_JPRB, 0.28386145E-06_JPRB, 0.28252066E-06_JPRB, 0.28118825E-06_JPRB, &
  & 0.27987900E-06_JPRB, 0.27856129E-06_JPRB, 0.27710976E-06_JPRB, 0.27466783E-06_JPRB /)

RGHG3(:,28, 3) = (/ &
  & 0.27490069E-06_JPRB, 0.27766669E-06_JPRB, 0.27923343E-06_JPRB, 0.28063062E-06_JPRB, 0.28202092E-06_JPRB, 0.28346835E-06_JPRB, &
  & 0.28500702E-06_JPRB, 0.28661424E-06_JPRB, 0.28827577E-06_JPRB, 0.28997800E-06_JPRB, 0.29171380E-06_JPRB, 0.29346216E-06_JPRB, &
  & 0.29520066E-06_JPRB, 0.29689565E-06_JPRB, 0.29851086E-06_JPRB, 0.30002187E-06_JPRB, 0.30142027E-06_JPRB, 0.30270405E-06_JPRB, &
  & 0.30387343E-06_JPRB, 0.30492902E-06_JPRB, 0.30587202E-06_JPRB, 0.30670472E-06_JPRB, 0.30742802E-06_JPRB, 0.30804762E-06_JPRB, &
  & 0.30857100E-06_JPRB, 0.30901469E-06_JPRB, 0.30939745E-06_JPRB, 0.30974601E-06_JPRB, 0.31007667E-06_JPRB, 0.31040821E-06_JPRB, &
  & 0.31073216E-06_JPRB, 0.31102331E-06_JPRB, 0.31124452E-06_JPRB, 0.31135437E-06_JPRB, 0.31131719E-06_JPRB, 0.31110858E-06_JPRB, &
  & 0.31072591E-06_JPRB, 0.31018811E-06_JPRB, 0.30952049E-06_JPRB, 0.30874659E-06_JPRB, 0.30788109E-06_JPRB, 0.30692789E-06_JPRB, &
  & 0.30588808E-06_JPRB, 0.30475775E-06_JPRB, 0.30353095E-06_JPRB, 0.30222719E-06_JPRB, 0.30087693E-06_JPRB, 0.29952596E-06_JPRB, &
  & 0.29821481E-06_JPRB, 0.29696477E-06_JPRB, 0.29578308E-06_JPRB, 0.29466170E-06_JPRB, 0.29357693E-06_JPRB, 0.29249941E-06_JPRB, &
  & 0.29140168E-06_JPRB, 0.29025847E-06_JPRB, 0.28906220E-06_JPRB, 0.28781199E-06_JPRB, 0.28653398E-06_JPRB, 0.28525616E-06_JPRB, &
  & 0.28399381E-06_JPRB, 0.28272905E-06_JPRB, 0.28130827E-06_JPRB, 0.27898167E-06_JPRB /)

RGHG3(:,29, 3) = (/ &
  & 0.27810398E-06_JPRB, 0.28063329E-06_JPRB, 0.28211144E-06_JPRB, 0.28338971E-06_JPRB, 0.28467070E-06_JPRB, 0.28601463E-06_JPRB, &
  & 0.28742210E-06_JPRB, 0.28890216E-06_JPRB, 0.29043287E-06_JPRB, 0.29200896E-06_JPRB, 0.29362891E-06_JPRB, 0.29528238E-06_JPRB, &
  & 0.29693845E-06_JPRB, 0.29856616E-06_JPRB, 0.30013632E-06_JPRB, 0.30161885E-06_JPRB, 0.30299807E-06_JPRB, 0.30426659E-06_JPRB, &
  & 0.30542242E-06_JPRB, 0.30646561E-06_JPRB, 0.30740009E-06_JPRB, 0.30822943E-06_JPRB, 0.30896032E-06_JPRB, 0.30959782E-06_JPRB, &
  & 0.31014980E-06_JPRB, 0.31062331E-06_JPRB, 0.31103195E-06_JPRB, 0.31138799E-06_JPRB, 0.31170276E-06_JPRB, 0.31198849E-06_JPRB, &
  & 0.31223982E-06_JPRB, 0.31244065E-06_JPRB, 0.31256906E-06_JPRB, 0.31259327E-06_JPRB, 0.31249041E-06_JPRB, 0.31224394E-06_JPRB, &
  & 0.31185655E-06_JPRB, 0.31134724E-06_JPRB, 0.31074615E-06_JPRB, 0.31007161E-06_JPRB, 0.30932461E-06_JPRB, 0.30850333E-06_JPRB, &
  & 0.30760646E-06_JPRB, 0.30662252E-06_JPRB, 0.30555304E-06_JPRB, 0.30440447E-06_JPRB, 0.30321215E-06_JPRB, 0.30201358E-06_JPRB, &
  & 0.30084254E-06_JPRB, 0.29972227E-06_JPRB, 0.29865697E-06_JPRB, 0.29763805E-06_JPRB, 0.29664741E-06_JPRB, 0.29565632E-06_JPRB, &
  & 0.29463968E-06_JPRB, 0.29357452E-06_JPRB, 0.29244734E-06_JPRB, 0.29126139E-06_JPRB, 0.29003542E-06_JPRB, 0.28880123E-06_JPRB, &
  & 0.28758095E-06_JPRB, 0.28635876E-06_JPRB, 0.28501819E-06_JPRB, 0.28276148E-06_JPRB /)

RGHG3(:,30, 3) = (/ &
  & 0.28105455E-06_JPRB, 0.28343220E-06_JPRB, 0.28477501E-06_JPRB, 0.28597145E-06_JPRB, 0.28715547E-06_JPRB, 0.28838622E-06_JPRB, &
  & 0.28968591E-06_JPRB, 0.29104262E-06_JPRB, 0.29244782E-06_JPRB, 0.29390418E-06_JPRB, 0.29541064E-06_JPRB, 0.29695815E-06_JPRB, &
  & 0.29852805E-06_JPRB, 0.30009033E-06_JPRB, 0.30161667E-06_JPRB, 0.30307424E-06_JPRB, 0.30443510E-06_JPRB, 0.30568773E-06_JPRB, &
  & 0.30682742E-06_JPRB, 0.30785372E-06_JPRB, 0.30877084E-06_JPRB, 0.30958591E-06_JPRB, 0.31030729E-06_JPRB, 0.31094177E-06_JPRB, &
  & 0.31149747E-06_JPRB, 0.31197473E-06_JPRB, 0.31238844E-06_JPRB, 0.31273530E-06_JPRB, 0.31302807E-06_JPRB, 0.31327161E-06_JPRB, &
  & 0.31346278E-06_JPRB, 0.31359409E-06_JPRB, 0.31365238E-06_JPRB, 0.31361685E-06_JPRB, 0.31347338E-06_JPRB, 0.31321227E-06_JPRB, &
  & 0.31284307E-06_JPRB, 0.31238821E-06_JPRB, 0.31186576E-06_JPRB, 0.31128428E-06_JPRB, 0.31064522E-06_JPRB, 0.30994275E-06_JPRB, &
  & 0.30917141E-06_JPRB, 0.30832049E-06_JPRB, 0.30738272E-06_JPRB, 0.30637256E-06_JPRB, 0.30531439E-06_JPRB, 0.30424212E-06_JPRB, &
  & 0.30319038E-06_JPRB, 0.30217353E-06_JPRB, 0.30119998E-06_JPRB, 0.30026399E-06_JPRB, 0.29934611E-06_JPRB, 0.29842593E-06_JPRB, &
  & 0.29747846E-06_JPRB, 0.29648052E-06_JPRB, 0.29541863E-06_JPRB, 0.29428872E-06_JPRB, 0.29310806E-06_JPRB, 0.29191071E-06_JPRB, &
  & 0.29072854E-06_JPRB, 0.28955216E-06_JPRB, 0.28825238E-06_JPRB, 0.28610856E-06_JPRB /)

RGHG3(:,31, 3) = (/ &
  & 0.28382013E-06_JPRB, 0.28601480E-06_JPRB, 0.28728942E-06_JPRB, 0.28838699E-06_JPRB, 0.28948330E-06_JPRB, 0.29062326E-06_JPRB, &
  & 0.29181314E-06_JPRB, 0.29306028E-06_JPRB, 0.29435165E-06_JPRB, 0.29569324E-06_JPRB, 0.29709389E-06_JPRB, 0.29855295E-06_JPRB, &
  & 0.30004779E-06_JPRB, 0.30154288E-06_JPRB, 0.30301140E-06_JPRB, 0.30442942E-06_JPRB, 0.30576638E-06_JPRB, 0.30699979E-06_JPRB, &
  & 0.30811952E-06_JPRB, 0.30912477E-06_JPRB, 0.31001889E-06_JPRB, 0.31081044E-06_JPRB, 0.31150972E-06_JPRB, 0.31212332E-06_JPRB, &
  & 0.31266254E-06_JPRB, 0.31312172E-06_JPRB, 0.31352130E-06_JPRB, 0.31384488E-06_JPRB, 0.31411122E-06_JPRB, 0.31431594E-06_JPRB, &
  & 0.31445876E-06_JPRB, 0.31453939E-06_JPRB, 0.31454803E-06_JPRB, 0.31447610E-06_JPRB, 0.31431361E-06_JPRB, 0.31406006E-06_JPRB, &
  & 0.31372670E-06_JPRB, 0.31332709E-06_JPRB, 0.31287698E-06_JPRB, 0.31238469E-06_JPRB, 0.31184285E-06_JPRB, 0.31124384E-06_JPRB, &
  & 0.31057900E-06_JPRB, 0.30983654E-06_JPRB, 0.30901481E-06_JPRB, 0.30812049E-06_JPRB, 0.30717669E-06_JPRB, 0.30621558E-06_JPRB, &
  & 0.30525993E-06_JPRB, 0.30433216E-06_JPRB, 0.30343517E-06_JPRB, 0.30256504E-06_JPRB, 0.30171020E-06_JPRB, 0.30085107E-06_JPRB, &
  & 0.29996508E-06_JPRB, 0.29903151E-06_JPRB, 0.29803027E-06_JPRB, 0.29695605E-06_JPRB, 0.29582071E-06_JPRB, 0.29466148E-06_JPRB, &
  & 0.29351145E-06_JPRB, 0.29237714E-06_JPRB, 0.29113900E-06_JPRB, 0.28907749E-06_JPRB /)

RGHG3(:,32, 3) = (/ &
  & 0.28638760E-06_JPRB, 0.28847029E-06_JPRB, 0.28963547E-06_JPRB, 0.29066774E-06_JPRB, 0.29168118E-06_JPRB, 0.29273002E-06_JPRB, &
  & 0.29383048E-06_JPRB, 0.29497323E-06_JPRB, 0.29615904E-06_JPRB, 0.29739570E-06_JPRB, 0.29869054E-06_JPRB, 0.30004591E-06_JPRB, &
  & 0.30145750E-06_JPRB, 0.30289610E-06_JPRB, 0.30432057E-06_JPRB, 0.30569956E-06_JPRB, 0.30700662E-06_JPRB, 0.30821610E-06_JPRB, &
  & 0.30931309E-06_JPRB, 0.31029302E-06_JPRB, 0.31115911E-06_JPRB, 0.31192198E-06_JPRB, 0.31258804E-06_JPRB, 0.31317165E-06_JPRB, &
  & 0.31367532E-06_JPRB, 0.31410420E-06_JPRB, 0.31447294E-06_JPRB, 0.31476594E-06_JPRB, 0.31500059E-06_JPRB, 0.31517018E-06_JPRB, &
  & 0.31527563E-06_JPRB, 0.31532022E-06_JPRB, 0.31529797E-06_JPRB, 0.31520756E-06_JPRB, 0.31504288E-06_JPRB, 0.31480835E-06_JPRB, &
  & 0.31451253E-06_JPRB, 0.31416906E-06_JPRB, 0.31379048E-06_JPRB, 0.31337720E-06_JPRB, 0.31292069E-06_JPRB, 0.31240688E-06_JPRB, &
  & 0.31182546E-06_JPRB, 0.31117014E-06_JPRB, 0.31043990E-06_JPRB, 0.30964301E-06_JPRB, 0.30879846E-06_JPRB, 0.30792771E-06_JPRB, &
  & 0.30706082E-06_JPRB, 0.30620743E-06_JPRB, 0.30537635E-06_JPRB, 0.30456710E-06_JPRB, 0.30376685E-06_JPRB, 0.30296414E-06_JPRB, &
  & 0.30213761E-06_JPRB, 0.30126549E-06_JPRB, 0.30032788E-06_JPRB, 0.29931329E-06_JPRB, 0.29823028E-06_JPRB, 0.29711336E-06_JPRB, &
  & 0.29601048E-06_JPRB, 0.29491960E-06_JPRB, 0.29372976E-06_JPRB, 0.29175564E-06_JPRB /)

RGHG3(:,33, 3) = (/ &
  & 0.28882539E-06_JPRB, 0.29076051E-06_JPRB, 0.29187061E-06_JPRB, 0.29281625E-06_JPRB, 0.29375860E-06_JPRB, 0.29473102E-06_JPRB, &
  & 0.29574335E-06_JPRB, 0.29679322E-06_JPRB, 0.29788009E-06_JPRB, 0.29901508E-06_JPRB, 0.30021309E-06_JPRB, 0.30147885E-06_JPRB, &
  & 0.30280199E-06_JPRB, 0.30416578E-06_JPRB, 0.30553798E-06_JPRB, 0.30687968E-06_JPRB, 0.30815738E-06_JPRB, 0.30934021E-06_JPRB, &
  & 0.31041043E-06_JPRB, 0.31136213E-06_JPRB, 0.31219571E-06_JPRB, 0.31292487E-06_JPRB, 0.31355165E-06_JPRB, 0.31409746E-06_JPRB, &
  & 0.31455750E-06_JPRB, 0.31494699E-06_JPRB, 0.31527512E-06_JPRB, 0.31553233E-06_JPRB, 0.31573265E-06_JPRB, 0.31587092E-06_JPRB, &
  & 0.31594823E-06_JPRB, 0.31596855E-06_JPRB, 0.31593109E-06_JPRB, 0.31583613E-06_JPRB, 0.31568283E-06_JPRB, 0.31547592E-06_JPRB, &
  & 0.31522470E-06_JPRB, 0.31493991E-06_JPRB, 0.31462503E-06_JPRB, 0.31427552E-06_JPRB, 0.31388177E-06_JPRB, 0.31343279E-06_JPRB, &
  & 0.31291711E-06_JPRB, 0.31232773E-06_JPRB, 0.31166772E-06_JPRB, 0.31094680E-06_JPRB, 0.31018087E-06_JPRB, 0.30939415E-06_JPRB, &
  & 0.30859911E-06_JPRB, 0.30781470E-06_JPRB, 0.30704530E-06_JPRB, 0.30628951E-06_JPRB, 0.30554367E-06_JPRB, 0.30479475E-06_JPRB, &
  & 0.30402580E-06_JPRB, 0.30321698E-06_JPRB, 0.30234656E-06_JPRB, 0.30139947E-06_JPRB, 0.30038021E-06_JPRB, 0.29932428E-06_JPRB, &
  & 0.29827220E-06_JPRB, 0.29723469E-06_JPRB, 0.29610192E-06_JPRB, 0.29420517E-06_JPRB /)

RGHG3(:,34, 3) = (/ &
  & 0.29111936E-06_JPRB, 0.29295472E-06_JPRB, 0.29396847E-06_JPRB, 0.29486068E-06_JPRB, 0.29573150E-06_JPRB, 0.29662851E-06_JPRB, &
  & 0.29756478E-06_JPRB, 0.29852657E-06_JPRB, 0.29952096E-06_JPRB, 0.30055790E-06_JPRB, 0.30165506E-06_JPRB, 0.30282621E-06_JPRB, &
  & 0.30407074E-06_JPRB, 0.30536742E-06_JPRB, 0.30668309E-06_JPRB, 0.30797915E-06_JPRB, 0.30921981E-06_JPRB, 0.31037092E-06_JPRB, &
  & 0.31141036E-06_JPRB, 0.31233034E-06_JPRB, 0.31312857E-06_JPRB, 0.31382064E-06_JPRB, 0.31440501E-06_JPRB, 0.31490816E-06_JPRB, &
  & 0.31532130E-06_JPRB, 0.31566563E-06_JPRB, 0.31594885E-06_JPRB, 0.31616671E-06_JPRB, 0.31633232E-06_JPRB, 0.31644228E-06_JPRB, &
  & 0.31649853E-06_JPRB, 0.31650490E-06_JPRB, 0.31646351E-06_JPRB, 0.31637592E-06_JPRB, 0.31624307E-06_JPRB, 0.31607087E-06_JPRB, &
  & 0.31586617E-06_JPRB, 0.31563414E-06_JPRB, 0.31537317E-06_JPRB, 0.31507636E-06_JPRB, 0.31473144E-06_JPRB, 0.31432694E-06_JPRB, &
  & 0.31385412E-06_JPRB, 0.31331200E-06_JPRB, 0.31270440E-06_JPRB, 0.31204434E-06_JPRB, 0.31134729E-06_JPRB, 0.31062535E-06_JPRB, &
  & 0.30989870E-06_JPRB, 0.30917448E-06_JPRB, 0.30846041E-06_JPRB, 0.30775914E-06_JPRB, 0.30706417E-06_JPRB, 0.30636895E-06_JPRB, &
  & 0.30565803E-06_JPRB, 0.30491290E-06_JPRB, 0.30411337E-06_JPRB, 0.30324202E-06_JPRB, 0.30230117E-06_JPRB, 0.30131653E-06_JPRB, &
  & 0.30033416E-06_JPRB, 0.29935688E-06_JPRB, 0.29827964E-06_JPRB, 0.29646802E-06_JPRB /)

RGHG3(:,35, 3) = (/ &
  & 0.29331309E-06_JPRB, 0.29500984E-06_JPRB, 0.29597467E-06_JPRB, 0.29679211E-06_JPRB, 0.29760380E-06_JPRB, 0.29843670E-06_JPRB, &
  & 0.29929504E-06_JPRB, 0.30017532E-06_JPRB, 0.30108015E-06_JPRB, 0.30202304E-06_JPRB, 0.30302414E-06_JPRB, 0.30409922E-06_JPRB, &
  & 0.30525391E-06_JPRB, 0.30647612E-06_JPRB, 0.30773580E-06_JPRB, 0.30898872E-06_JPRB, 0.31019073E-06_JPRB, 0.31130639E-06_JPRB, &
  & 0.31231107E-06_JPRB, 0.31319613E-06_JPRB, 0.31395712E-06_JPRB, 0.31460979E-06_JPRB, 0.31515128E-06_JPRB, 0.31560666E-06_JPRB, &
  & 0.31597045E-06_JPRB, 0.31626490E-06_JPRB, 0.31649904E-06_JPRB, 0.31667514E-06_JPRB, 0.31680585E-06_JPRB, 0.31689024E-06_JPRB, &
  & 0.31693054E-06_JPRB, 0.31693085E-06_JPRB, 0.31689348E-06_JPRB, 0.31682012E-06_JPRB, 0.31671317E-06_JPRB, 0.31657666E-06_JPRB, &
  & 0.31641520E-06_JPRB, 0.31622957E-06_JPRB, 0.31601485E-06_JPRB, 0.31576184E-06_JPRB, 0.31545665E-06_JPRB, 0.31508728E-06_JPRB, &
  & 0.31464873E-06_JPRB, 0.31413953E-06_JPRB, 0.31357337E-06_JPRB, 0.31296133E-06_JPRB, 0.31231713E-06_JPRB, 0.31165501E-06_JPRB, &
  & 0.31098176E-06_JPRB, 0.31031192E-06_JPRB, 0.30964964E-06_JPRB, 0.30899724E-06_JPRB, 0.30835406E-06_JPRB, 0.30771125E-06_JPRB, &
  & 0.30705723E-06_JPRB, 0.30637656E-06_JPRB, 0.30564976E-06_JPRB, 0.30485921E-06_JPRB, 0.30400329E-06_JPRB, 0.30310505E-06_JPRB, &
  & 0.30219854E-06_JPRB, 0.30128848E-06_JPRB, 0.30027826E-06_JPRB, 0.29855343E-06_JPRB /)

RGHG3(:,36, 3) = (/ &
  & 0.29537685E-06_JPRB, 0.29697378E-06_JPRB, 0.29785502E-06_JPRB, 0.29862872E-06_JPRB, 0.29938252E-06_JPRB, 0.30015227E-06_JPRB, &
  & 0.30094196E-06_JPRB, 0.30174238E-06_JPRB, 0.30256032E-06_JPRB, 0.30341036E-06_JPRB, 0.30431551E-06_JPRB, 0.30529799E-06_JPRB, &
  & 0.30636849E-06_JPRB, 0.30751602E-06_JPRB, 0.30871180E-06_JPRB, 0.30991279E-06_JPRB, 0.31107015E-06_JPRB, 0.31214600E-06_JPRB, &
  & 0.31311214E-06_JPRB, 0.31396189E-06_JPRB, 0.31468591E-06_JPRB, 0.31529527E-06_JPRB, 0.31579006E-06_JPRB, 0.31618984E-06_JPRB, &
  & 0.31649770E-06_JPRB, 0.31673503E-06_JPRB, 0.31691749E-06_JPRB, 0.31705045E-06_JPRB, 0.31714779E-06_JPRB, 0.31720975E-06_JPRB, &
  & 0.31723854E-06_JPRB, 0.31723715E-06_JPRB, 0.31720714E-06_JPRB, 0.31714995E-06_JPRB, 0.31706750E-06_JPRB, 0.31696285E-06_JPRB, &
  & 0.31683766E-06_JPRB, 0.31669043E-06_JPRB, 0.31651533E-06_JPRB, 0.31630108E-06_JPRB, 0.31603270E-06_JPRB, 0.31569894E-06_JPRB, &
  & 0.31529163E-06_JPRB, 0.31481841E-06_JPRB, 0.31428709E-06_JPRB, 0.31371820E-06_JPRB, 0.31312143E-06_JPRB, 0.31250519E-06_JPRB, &
  & 0.31188119E-06_JPRB, 0.31125597E-06_JPRB, 0.31063843E-06_JPRB, 0.31003356E-06_JPRB, 0.30943784E-06_JPRB, 0.30884672E-06_JPRB, &
  & 0.30824975E-06_JPRB, 0.30763235E-06_JPRB, 0.30697663E-06_JPRB, 0.30626714E-06_JPRB, 0.30549955E-06_JPRB, 0.30468985E-06_JPRB, &
  & 0.30386698E-06_JPRB, 0.30303190E-06_JPRB, 0.30209108E-06_JPRB, 0.30047033E-06_JPRB /)

RGHG3(:,37, 3) = (/ &
  & 0.29733715E-06_JPRB, 0.29881059E-06_JPRB, 0.29964448E-06_JPRB, 0.30036205E-06_JPRB, 0.30107032E-06_JPRB, 0.30178765E-06_JPRB, &
  & 0.30250879E-06_JPRB, 0.30323395E-06_JPRB, 0.30396768E-06_JPRB, 0.30472756E-06_JPRB, 0.30553795E-06_JPRB, 0.30642349E-06_JPRB, &
  & 0.30740148E-06_JPRB, 0.30847013E-06_JPRB, 0.30960300E-06_JPRB, 0.31075075E-06_JPRB, 0.31186096E-06_JPRB, 0.31289414E-06_JPRB, &
  & 0.31382223E-06_JPRB, 0.31463267E-06_JPRB, 0.31531599E-06_JPRB, 0.31587464E-06_JPRB, 0.31631026E-06_JPRB, 0.31664410E-06_JPRB, &
  & 0.31688731E-06_JPRB, 0.31706750E-06_JPRB, 0.31720015E-06_JPRB, 0.31729650E-06_JPRB, 0.31736676E-06_JPRB, 0.31741206E-06_JPRB, &
  & 0.31743346E-06_JPRB, 0.31743221E-06_JPRB, 0.31740902E-06_JPRB, 0.31736488E-06_JPRB, 0.31730136E-06_JPRB, 0.31722027E-06_JPRB, &
  & 0.31712213E-06_JPRB, 0.31700495E-06_JPRB, 0.31686184E-06_JPRB, 0.31668205E-06_JPRB, 0.31645115E-06_JPRB, 0.31615494E-06_JPRB, &
  & 0.31578929E-06_JPRB, 0.31535288E-06_JPRB, 0.31486496E-06_JPRB, 0.31433683E-06_JPRB, 0.31378340E-06_JPRB, 0.31321056E-06_JPRB, &
  & 0.31262536E-06_JPRB, 0.31203868E-06_JPRB, 0.31146058E-06_JPRB, 0.31089598E-06_JPRB, 0.31034600E-06_JPRB, 0.30980468E-06_JPRB, &
  & 0.30926253E-06_JPRB, 0.30870652E-06_JPRB, 0.30812029E-06_JPRB, 0.30748845E-06_JPRB, 0.30680656E-06_JPRB, 0.30608609E-06_JPRB, &
  & 0.30534923E-06_JPRB, 0.30459256E-06_JPRB, 0.30373144E-06_JPRB, 0.30222643E-06_JPRB /)

RGHG3(:,38, 3) = (/ &
  & 0.29918522E-06_JPRB, 0.30055264E-06_JPRB, 0.30132489E-06_JPRB, 0.30200417E-06_JPRB, 0.30267233E-06_JPRB, 0.30334090E-06_JPRB, &
  & 0.30400156E-06_JPRB, 0.30465384E-06_JPRB, 0.30530575E-06_JPRB, 0.30597693E-06_JPRB, 0.30669452E-06_JPRB, 0.30748649E-06_JPRB, &
  & 0.30837350E-06_JPRB, 0.30935820E-06_JPRB, 0.31041819E-06_JPRB, 0.31150716E-06_JPRB, 0.31256633E-06_JPRB, 0.31355353E-06_JPRB, &
  & 0.31443832E-06_JPRB, 0.31520389E-06_JPRB, 0.31583443E-06_JPRB, 0.31632945E-06_JPRB, 0.31669509E-06_JPRB, 0.31695990E-06_JPRB, &
  & 0.31714387E-06_JPRB, 0.31727643E-06_JPRB, 0.31737312E-06_JPRB, 0.31744381E-06_JPRB, 0.31749681E-06_JPRB, 0.31753189E-06_JPRB, &
  & 0.31754931E-06_JPRB, 0.31754877E-06_JPRB, 0.31753046E-06_JPRB, 0.31749514E-06_JPRB, 0.31744423E-06_JPRB, 0.31737898E-06_JPRB, &
  & 0.31729962E-06_JPRB, 0.31720359E-06_JPRB, 0.31708498E-06_JPRB, 0.31693347E-06_JPRB, 0.31673548E-06_JPRB, 0.31647886E-06_JPRB, &
  & 0.31615411E-06_JPRB, 0.31576576E-06_JPRB, 0.31532102E-06_JPRB, 0.31483893E-06_JPRB, 0.31432708E-06_JPRB, 0.31379383E-06_JPRB, &
  & 0.31324421E-06_JPRB, 0.31269073E-06_JPRB, 0.31214444E-06_JPRB, 0.31161642E-06_JPRB, 0.31110721E-06_JPRB, 0.31061271E-06_JPRB, &
  & 0.31012343E-06_JPRB, 0.30962613E-06_JPRB, 0.30910601E-06_JPRB, 0.30854827E-06_JPRB, 0.30794823E-06_JPRB, 0.30731499E-06_JPRB, &
  & 0.30666357E-06_JPRB, 0.30599048E-06_JPRB, 0.30521315E-06_JPRB, 0.30384123E-06_JPRB /)

RGHG3(:,39, 3) = (/ &
  & 0.30093651E-06_JPRB, 0.30219516E-06_JPRB, 0.30291247E-06_JPRB, 0.30355380E-06_JPRB, 0.30418551E-06_JPRB, 0.30481240E-06_JPRB, &
  & 0.30541733E-06_JPRB, 0.30600089E-06_JPRB, 0.30657429E-06_JPRB, 0.30716041E-06_JPRB, 0.30778597E-06_JPRB, 0.30848199E-06_JPRB, &
  & 0.30927504E-06_JPRB, 0.31017507E-06_JPRB, 0.31116167E-06_JPRB, 0.31218687E-06_JPRB, 0.31319422E-06_JPRB, 0.31413248E-06_JPRB, &
  & 0.31496654E-06_JPRB, 0.31567168E-06_JPRB, 0.31623387E-06_JPRB, 0.31665587E-06_JPRB, 0.31695399E-06_JPRB, 0.31716121E-06_JPRB, &
  & 0.31730175E-06_JPRB, 0.31740285E-06_JPRB, 0.31747666E-06_JPRB, 0.31753248E-06_JPRB, 0.31757540E-06_JPRB, 0.31760476E-06_JPRB, &
  & 0.31762008E-06_JPRB, 0.31762042E-06_JPRB, 0.31760533E-06_JPRB, 0.31757554E-06_JPRB, 0.31753262E-06_JPRB, 0.31747777E-06_JPRB, &
  & 0.31741129E-06_JPRB, 0.31733020E-06_JPRB, 0.31722934E-06_JPRB, 0.31709931E-06_JPRB, 0.31692844E-06_JPRB, 0.31670433E-06_JPRB, &
  & 0.31642040E-06_JPRB, 0.31607436E-06_JPRB, 0.31567748E-06_JPRB, 0.31523967E-06_JPRB, 0.31477225E-06_JPRB, 0.31427771E-06_JPRB, &
  & 0.31376365E-06_JPRB, 0.31323808E-06_JPRB, 0.31272077E-06_JPRB, 0.31222265E-06_JPRB, 0.31174957E-06_JPRB, 0.31129804E-06_JPRB, &
  & 0.31085753E-06_JPRB, 0.31041634E-06_JPRB, 0.30995784E-06_JPRB, 0.30947024E-06_JPRB, 0.30894813E-06_JPRB, 0.30839894E-06_JPRB, &
  & 0.30783423E-06_JPRB, 0.30724425E-06_JPRB, 0.30655937E-06_JPRB, 0.30533147E-06_JPRB /)

RGHG3(:,40, 3) = (/ &
  & 0.30259707E-06_JPRB, 0.30374122E-06_JPRB, 0.30440708E-06_JPRB, 0.30500576E-06_JPRB, 0.30560818E-06_JPRB, 0.30619532E-06_JPRB, &
  & 0.30674937E-06_JPRB, 0.30726832E-06_JPRB, 0.30776880E-06_JPRB, 0.30827164E-06_JPRB, 0.30880989E-06_JPRB, 0.30941413E-06_JPRB, &
  & 0.31011498E-06_JPRB, 0.31092759E-06_JPRB, 0.31183797E-06_JPRB, 0.31279615E-06_JPRB, 0.31374267E-06_JPRB, 0.31462497E-06_JPRB, &
  & 0.31540122E-06_JPRB, 0.31603901E-06_JPRB, 0.31652652E-06_JPRB, 0.31687998E-06_JPRB, 0.31712270E-06_JPRB, 0.31728899E-06_JPRB, &
  & 0.31740097E-06_JPRB, 0.31748249E-06_JPRB, 0.31754257E-06_JPRB, 0.31758944E-06_JPRB, 0.31762659E-06_JPRB, 0.31765276E-06_JPRB, &
  & 0.31766700E-06_JPRB, 0.31766791E-06_JPRB, 0.31765487E-06_JPRB, 0.31762866E-06_JPRB, 0.31759097E-06_JPRB, 0.31754342E-06_JPRB, &
  & 0.31748553E-06_JPRB, 0.31741524E-06_JPRB, 0.31732736E-06_JPRB, 0.31721390E-06_JPRB, 0.31706398E-06_JPRB, 0.31686719E-06_JPRB, &
  & 0.31661574E-06_JPRB, 0.31630961E-06_JPRB, 0.31595459E-06_JPRB, 0.31556155E-06_JPRB, 0.31513702E-06_JPRB, 0.31468375E-06_JPRB, &
  & 0.31420257E-06_JPRB, 0.31370757E-06_JPRB, 0.31321366E-06_JPRB, 0.31274161E-06_JPRB, 0.31229985E-06_JPRB, 0.31188546E-06_JPRB, &
  & 0.31149023E-06_JPRB, 0.31109920E-06_JPRB, 0.31069897E-06_JPRB, 0.31027611E-06_JPRB, 0.30982832E-06_JPRB, 0.30936027E-06_JPRB, &
  & 0.30887887E-06_JPRB, 0.30837575E-06_JPRB, 0.30778264E-06_JPRB, 0.30671305E-06_JPRB /)

RGHG3(:,41, 3) = (/ &
  & 0.30416297E-06_JPRB, 0.30519996E-06_JPRB, 0.30580293E-06_JPRB, 0.30636622E-06_JPRB, 0.30693252E-06_JPRB, 0.30748473E-06_JPRB, &
  & 0.30799168E-06_JPRB, 0.30845212E-06_JPRB, 0.30888208E-06_JPRB, 0.30930966E-06_JPRB, 0.30976304E-06_JPRB, 0.31027878E-06_JPRB, &
  & 0.31089087E-06_JPRB, 0.31161940E-06_JPRB, 0.31245352E-06_JPRB, 0.31334764E-06_JPRB, 0.31423340E-06_JPRB, 0.31505328E-06_JPRB, &
  & 0.31575834E-06_JPRB, 0.31632305E-06_JPRB, 0.31674153E-06_JPRB, 0.31703652E-06_JPRB, 0.31723772E-06_JPRB, 0.31737491E-06_JPRB, &
  & 0.31746822E-06_JPRB, 0.31753706E-06_JPRB, 0.31758844E-06_JPRB, 0.31762991E-06_JPRB, 0.31766336E-06_JPRB, 0.31768761E-06_JPRB, &
  & 0.31770111E-06_JPRB, 0.31770239E-06_JPRB, 0.31769065E-06_JPRB, 0.31766677E-06_JPRB, 0.31763284E-06_JPRB, 0.31759015E-06_JPRB, &
  & 0.31753888E-06_JPRB, 0.31747641E-06_JPRB, 0.31739870E-06_JPRB, 0.31729809E-06_JPRB, 0.31716550E-06_JPRB, 0.31699074E-06_JPRB, &
  & 0.31676785E-06_JPRB, 0.31649461E-06_JPRB, 0.31617753E-06_JPRB, 0.31582516E-06_JPRB, 0.31544147E-06_JPRB, 0.31502719E-06_JPRB, &
  & 0.31458336E-06_JPRB, 0.31411531E-06_JPRB, 0.31364578E-06_JPRB, 0.31319692E-06_JPRB, 0.31278097E-06_JPRB, 0.31240069E-06_JPRB, &
  & 0.31204428E-06_JPRB, 0.31169964E-06_JPRB, 0.31135104E-06_JPRB, 0.31098904E-06_JPRB, 0.31060983E-06_JPRB, 0.31021818E-06_JPRB, &
  & 0.30981758E-06_JPRB, 0.30939586E-06_JPRB, 0.30889743E-06_JPRB, 0.30798643E-06_JPRB /)

RGHG3(:,42, 3) = (/ &
  & 0.30563473E-06_JPRB, 0.30656034E-06_JPRB, 0.30711070E-06_JPRB, 0.30762703E-06_JPRB, 0.30816170E-06_JPRB, 0.30867858E-06_JPRB, &
  & 0.30914063E-06_JPRB, 0.30954695E-06_JPRB, 0.30991461E-06_JPRB, 0.31027176E-06_JPRB, 0.31064991E-06_JPRB, 0.31108436E-06_JPRB, &
  & 0.31161119E-06_JPRB, 0.31225923E-06_JPRB, 0.31301946E-06_JPRB, 0.31384579E-06_JPRB, 0.31467178E-06_JPRB, 0.31542527E-06_JPRB, &
  & 0.31605936E-06_JPRB, 0.31654864E-06_JPRB, 0.31690385E-06_JPRB, 0.31715163E-06_JPRB, 0.31732083E-06_JPRB, 0.31743738E-06_JPRB, &
  & 0.31751782E-06_JPRB, 0.31757793E-06_JPRB, 0.31762360E-06_JPRB, 0.31766132E-06_JPRB, 0.31769233E-06_JPRB, 0.31771518E-06_JPRB, &
  & 0.31772805E-06_JPRB, 0.31772942E-06_JPRB, 0.31771859E-06_JPRB, 0.31769656E-06_JPRB, 0.31766515E-06_JPRB, 0.31762616E-06_JPRB, &
  & 0.31757941E-06_JPRB, 0.31752330E-06_JPRB, 0.31745336E-06_JPRB, 0.31736369E-06_JPRB, 0.31724556E-06_JPRB, 0.31709055E-06_JPRB, &
  & 0.31689231E-06_JPRB, 0.31664914E-06_JPRB, 0.31636529E-06_JPRB, 0.31604793E-06_JPRB, 0.31570247E-06_JPRB, 0.31532625E-06_JPRB, &
  & 0.31491666E-06_JPRB, 0.31448005E-06_JPRB, 0.31403445E-06_JPRB, 0.31360639E-06_JPRB, 0.31321684E-06_JPRB, 0.31286532E-06_JPRB, &
  & 0.31254490E-06_JPRB, 0.31224036E-06_JPRB, 0.31193883E-06_JPRB, 0.31163057E-06_JPRB, 0.31131395E-06_JPRB, 0.31099151E-06_JPRB, &
  & 0.31066406E-06_JPRB, 0.31031954E-06_JPRB, 0.30990796E-06_JPRB, 0.30915169E-06_JPRB /)

RGHG3(:,43, 3) = (/ &
  & 0.30701057E-06_JPRB, 0.30783085E-06_JPRB, 0.30832354E-06_JPRB, 0.30879690E-06_JPRB, 0.30929456E-06_JPRB, 0.30977452E-06_JPRB, &
  & 0.31019852E-06_JPRB, 0.31055453E-06_JPRB, 0.31086807E-06_JPRB, 0.31116448E-06_JPRB, 0.31147619E-06_JPRB, 0.31183652E-06_JPRB, &
  & 0.31228873E-06_JPRB, 0.31285845E-06_JPRB, 0.31355091E-06_JPRB, 0.31431262E-06_JPRB, 0.31507071E-06_JPRB, 0.31575522E-06_JPRB, &
  & 0.31631188E-06_JPRB, 0.31673156E-06_JPRB, 0.31703115E-06_JPRB, 0.31723971E-06_JPRB, 0.31738460E-06_JPRB, 0.31748544E-06_JPRB, &
  & 0.31755664E-06_JPRB, 0.31761070E-06_JPRB, 0.31765242E-06_JPRB, 0.31768766E-06_JPRB, 0.31771674E-06_JPRB, 0.31773845E-06_JPRB, &
  & 0.31775068E-06_JPRB, 0.31775207E-06_JPRB, 0.31774172E-06_JPRB, 0.31772097E-06_JPRB, 0.31769164E-06_JPRB, 0.31765521E-06_JPRB, &
  & 0.31761220E-06_JPRB, 0.31756070E-06_JPRB, 0.31749741E-06_JPRB, 0.31741675E-06_JPRB, 0.31731165E-06_JPRB, 0.31717428E-06_JPRB, &
  & 0.31699940E-06_JPRB, 0.31678397E-06_JPRB, 0.31653082E-06_JPRB, 0.31624640E-06_JPRB, 0.31593419E-06_JPRB, 0.31559290E-06_JPRB, &
  & 0.31521819E-06_JPRB, 0.31481193E-06_JPRB, 0.31439265E-06_JPRB, 0.31399060E-06_JPRB, 0.31362475E-06_JPRB, 0.31330282E-06_JPRB, &
  & 0.31301386E-06_JPRB, 0.31274527E-06_JPRB, 0.31248419E-06_JPRB, 0.31222302E-06_JPRB, 0.31196046E-06_JPRB, 0.31169822E-06_JPRB, &
  & 0.31143460E-06_JPRB, 0.31115681E-06_JPRB, 0.31082359E-06_JPRB, 0.31020733E-06_JPRB /)

RGHG3(:,44, 3) = (/ &
  & 0.30827519E-06_JPRB, 0.30900986E-06_JPRB, 0.30944355E-06_JPRB, 0.30987709E-06_JPRB, 0.31033312E-06_JPRB, 0.31078417E-06_JPRB, &
  & 0.31116593E-06_JPRB, 0.31148502E-06_JPRB, 0.31174957E-06_JPRB, 0.31199670E-06_JPRB, 0.31225116E-06_JPRB, 0.31255098E-06_JPRB, &
  & 0.31292993E-06_JPRB, 0.31343438E-06_JPRB, 0.31405682E-06_JPRB, 0.31475651E-06_JPRB, 0.31544721E-06_JPRB, 0.31605126E-06_JPRB, &
  & 0.31653076E-06_JPRB, 0.31688188E-06_JPRB, 0.31713313E-06_JPRB, 0.31730971E-06_JPRB, 0.31743514E-06_JPRB, 0.31752393E-06_JPRB, &
  & 0.31758861E-06_JPRB, 0.31763813E-06_JPRB, 0.31767721E-06_JPRB, 0.31771069E-06_JPRB, 0.31773845E-06_JPRB, 0.31775900E-06_JPRB, &
  & 0.31777051E-06_JPRB, 0.31777162E-06_JPRB, 0.31776162E-06_JPRB, 0.31774181E-06_JPRB, 0.31771390E-06_JPRB, 0.31767951E-06_JPRB, &
  & 0.31763909E-06_JPRB, 0.31759154E-06_JPRB, 0.31753345E-06_JPRB, 0.31746075E-06_JPRB, 0.31736707E-06_JPRB, 0.31724653E-06_JPRB, &
  & 0.31709391E-06_JPRB, 0.31690598E-06_JPRB, 0.31668284E-06_JPRB, 0.31642887E-06_JPRB, 0.31614840E-06_JPRB, 0.31583946E-06_JPRB, &
  & 0.31549752E-06_JPRB, 0.31512315E-06_JPRB, 0.31473451E-06_JPRB, 0.31435883E-06_JPRB, 0.31402294E-06_JPRB, 0.31372835E-06_JPRB, &
  & 0.31346883E-06_JPRB, 0.31323160E-06_JPRB, 0.31300510E-06_JPRB, 0.31278347E-06_JPRB, 0.31256607E-06_JPRB, 0.31235348E-06_JPRB, &
  & 0.31214233E-06_JPRB, 0.31192081E-06_JPRB, 0.31165365E-06_JPRB, 0.31115746E-06_JPRB /)

RGHG3(:,45, 3) = (/ &
  & 0.30944631E-06_JPRB, 0.31008159E-06_JPRB, 0.31048361E-06_JPRB, 0.31086606E-06_JPRB, 0.31129517E-06_JPRB, 0.31170720E-06_JPRB, &
  & 0.31206565E-06_JPRB, 0.31234291E-06_JPRB, 0.31257392E-06_JPRB, 0.31277742E-06_JPRB, 0.31298833E-06_JPRB, 0.31323290E-06_JPRB, &
  & 0.31355648E-06_JPRB, 0.31399043E-06_JPRB, 0.31455588E-06_JPRB, 0.31518667E-06_JPRB, 0.31579958E-06_JPRB, 0.31631964E-06_JPRB, &
  & 0.31671647E-06_JPRB, 0.31700674E-06_JPRB, 0.31721541E-06_JPRB, 0.31736587E-06_JPRB, 0.31747572E-06_JPRB, 0.31755562E-06_JPRB, &
  & 0.31761539E-06_JPRB, 0.31766166E-06_JPRB, 0.31769915E-06_JPRB, 0.31773135E-06_JPRB, 0.31775804E-06_JPRB, 0.31777762E-06_JPRB, &
  & 0.31778819E-06_JPRB, 0.31778885E-06_JPRB, 0.31777904E-06_JPRB, 0.31775977E-06_JPRB, 0.31773294E-06_JPRB, 0.31770003E-06_JPRB, &
  & 0.31766172E-06_JPRB, 0.31761695E-06_JPRB, 0.31756352E-06_JPRB, 0.31749738E-06_JPRB, 0.31741425E-06_JPRB, 0.31730903E-06_JPRB, &
  & 0.31717832E-06_JPRB, 0.31701819E-06_JPRB, 0.31682669E-06_JPRB, 0.31660508E-06_JPRB, 0.31635557E-06_JPRB, 0.31607803E-06_JPRB, &
  & 0.31576656E-06_JPRB, 0.31542433E-06_JPRB, 0.31506582E-06_JPRB, 0.31472555E-06_JPRB, 0.31441823E-06_JPRB, 0.31415385E-06_JPRB, &
  & 0.31392173E-06_JPRB, 0.31371130E-06_JPRB, 0.31351405E-06_JPRB, 0.31332448E-06_JPRB, 0.31314323E-06_JPRB, 0.31297003E-06_JPRB, &
  & 0.31280075E-06_JPRB, 0.31262360E-06_JPRB, 0.31241012E-06_JPRB, 0.31201233E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART6',0,ZHOOK_HANDLE)



RGHG3(:,46, 3) = (/ &
  & 0.31049473E-06_JPRB, 0.31108067E-06_JPRB, 0.31142642E-06_JPRB, 0.31178965E-06_JPRB, 0.31217724E-06_JPRB, 0.31256951E-06_JPRB, &
  & 0.31289389E-06_JPRB, 0.31314718E-06_JPRB, 0.31334378E-06_JPRB, 0.31351723E-06_JPRB, 0.31369109E-06_JPRB, 0.31389567E-06_JPRB, &
  & 0.31416585E-06_JPRB, 0.31454647E-06_JPRB, 0.31504447E-06_JPRB, 0.31560540E-06_JPRB, 0.31612984E-06_JPRB, 0.31655432E-06_JPRB, &
  & 0.31687529E-06_JPRB, 0.31710854E-06_JPRB, 0.31728209E-06_JPRB, 0.31741104E-06_JPRB, 0.31750875E-06_JPRB, 0.31758171E-06_JPRB, &
  & 0.31763813E-06_JPRB, 0.31768241E-06_JPRB, 0.31771884E-06_JPRB, 0.31775028E-06_JPRB, 0.31777614E-06_JPRB, 0.31779450E-06_JPRB, &
  & 0.31780425E-06_JPRB, 0.31780422E-06_JPRB, 0.31779433E-06_JPRB, 0.31777557E-06_JPRB, 0.31774937E-06_JPRB, 0.31771751E-06_JPRB, &
  & 0.31768062E-06_JPRB, 0.31763841E-06_JPRB, 0.31758844E-06_JPRB, 0.31752828E-06_JPRB, 0.31745415E-06_JPRB, 0.31736343E-06_JPRB, &
  & 0.31725352E-06_JPRB, 0.31712207E-06_JPRB, 0.31696507E-06_JPRB, 0.31678007E-06_JPRB, 0.31656583E-06_JPRB, 0.31631922E-06_JPRB, &
  & 0.31603884E-06_JPRB, 0.31572412E-06_JPRB, 0.31540156E-06_JPRB, 0.31509060E-06_JPRB, 0.31482048E-06_JPRB, 0.31458356E-06_JPRB, &
  & 0.31437742E-06_JPRB, 0.31419160E-06_JPRB, 0.31401794E-06_JPRB, 0.31385457E-06_JPRB, 0.31370126E-06_JPRB, 0.31355853E-06_JPRB, &
  & 0.31342105E-06_JPRB, 0.31327886E-06_JPRB, 0.31310665E-06_JPRB, 0.31278736E-06_JPRB /)

RGHG3(:,47, 3) = (/ &
  & 0.31145629E-06_JPRB, 0.31197916E-06_JPRB, 0.31230928E-06_JPRB, 0.31263414E-06_JPRB, 0.31300343E-06_JPRB, 0.31336702E-06_JPRB, &
  & 0.31367051E-06_JPRB, 0.31389652E-06_JPRB, 0.31406952E-06_JPRB, 0.31421709E-06_JPRB, 0.31436377E-06_JPRB, 0.31453601E-06_JPRB, &
  & 0.31476569E-06_JPRB, 0.31509481E-06_JPRB, 0.31552682E-06_JPRB, 0.31600237E-06_JPRB, 0.31642429E-06_JPRB, 0.31675742E-06_JPRB, &
  & 0.31700483E-06_JPRB, 0.31719199E-06_JPRB, 0.31733546E-06_JPRB, 0.31744747E-06_JPRB, 0.31753547E-06_JPRB, 0.31760376E-06_JPRB, &
  & 0.31765779E-06_JPRB, 0.31770077E-06_JPRB, 0.31773709E-06_JPRB, 0.31776790E-06_JPRB, 0.31779285E-06_JPRB, 0.31781022E-06_JPRB, &
  & 0.31781875E-06_JPRB, 0.31781789E-06_JPRB, 0.31780786E-06_JPRB, 0.31778924E-06_JPRB, 0.31776352E-06_JPRB, 0.31773229E-06_JPRB, &
  & 0.31769667E-06_JPRB, 0.31765614E-06_JPRB, 0.31760942E-06_JPRB, 0.31755408E-06_JPRB, 0.31748820E-06_JPRB, 0.31741018E-06_JPRB, &
  & 0.31732023E-06_JPRB, 0.31721675E-06_JPRB, 0.31709675E-06_JPRB, 0.31695396E-06_JPRB, 0.31678152E-06_JPRB, 0.31657294E-06_JPRB, &
  & 0.31632095E-06_JPRB, 0.31603849E-06_JPRB, 0.31574075E-06_JPRB, 0.31547074E-06_JPRB, 0.31522765E-06_JPRB, 0.31502177E-06_JPRB, &
  & 0.31483933E-06_JPRB, 0.31467431E-06_JPRB, 0.31452149E-06_JPRB, 0.31437821E-06_JPRB, 0.31424702E-06_JPRB, 0.31412711E-06_JPRB, &
  & 0.31401390E-06_JPRB, 0.31389717E-06_JPRB, 0.31375708E-06_JPRB, 0.31349677E-06_JPRB /)

RGHG3(:,48, 3) = (/ &
  & 0.31232571E-06_JPRB, 0.31281169E-06_JPRB, 0.31311708E-06_JPRB, 0.31342657E-06_JPRB, 0.31377397E-06_JPRB, 0.31411784E-06_JPRB, &
  & 0.31440004E-06_JPRB, 0.31460416E-06_JPRB, 0.31475665E-06_JPRB, 0.31488378E-06_JPRB, 0.31500952E-06_JPRB, 0.31515566E-06_JPRB, &
  & 0.31535222E-06_JPRB, 0.31562587E-06_JPRB, 0.31598807E-06_JPRB, 0.31635710E-06_JPRB, 0.31667699E-06_JPRB, 0.31692215E-06_JPRB, &
  & 0.31711093E-06_JPRB, 0.31725841E-06_JPRB, 0.31737829E-06_JPRB, 0.31747675E-06_JPRB, 0.31755752E-06_JPRB, 0.31762249E-06_JPRB, &
  & 0.31767519E-06_JPRB, 0.31771796E-06_JPRB, 0.31775392E-06_JPRB, 0.31778453E-06_JPRB, 0.31780857E-06_JPRB, 0.31782452E-06_JPRB, &
  & 0.31783188E-06_JPRB, 0.31783014E-06_JPRB, 0.31781974E-06_JPRB, 0.31780115E-06_JPRB, 0.31777560E-06_JPRB, 0.31774496E-06_JPRB, &
  & 0.31771020E-06_JPRB, 0.31767138E-06_JPRB, 0.31762707E-06_JPRB, 0.31757608E-06_JPRB, 0.31751705E-06_JPRB, 0.31745060E-06_JPRB, &
  & 0.31737795E-06_JPRB, 0.31730053E-06_JPRB, 0.31721569E-06_JPRB, 0.31711772E-06_JPRB, 0.31699346E-06_JPRB, 0.31682973E-06_JPRB, &
  & 0.31661921E-06_JPRB, 0.31636364E-06_JPRB, 0.31610600E-06_JPRB, 0.31586131E-06_JPRB, 0.31565452E-06_JPRB, 0.31547214E-06_JPRB, &
  & 0.31531169E-06_JPRB, 0.31516515E-06_JPRB, 0.31502827E-06_JPRB, 0.31490148E-06_JPRB, 0.31478652E-06_JPRB, 0.31468369E-06_JPRB, &
  & 0.31458779E-06_JPRB, 0.31449028E-06_JPRB, 0.31437273E-06_JPRB, 0.31415661E-06_JPRB /)

RGHG3(:,49, 3) = (/ &
  & 0.31311487E-06_JPRB, 0.31358144E-06_JPRB, 0.31386958E-06_JPRB, 0.31416994E-06_JPRB, 0.31450193E-06_JPRB, 0.31483182E-06_JPRB, &
  & 0.31509288E-06_JPRB, 0.31527725E-06_JPRB, 0.31541077E-06_JPRB, 0.31552042E-06_JPRB, 0.31562769E-06_JPRB, 0.31574859E-06_JPRB, &
  & 0.31590830E-06_JPRB, 0.31612674E-06_JPRB, 0.31638751E-06_JPRB, 0.31665593E-06_JPRB, 0.31687705E-06_JPRB, 0.31705372E-06_JPRB, &
  & 0.31719424E-06_JPRB, 0.31731167E-06_JPRB, 0.31741251E-06_JPRB, 0.31750051E-06_JPRB, 0.31757588E-06_JPRB, 0.31763912E-06_JPRB, &
  & 0.31769127E-06_JPRB, 0.31773391E-06_JPRB, 0.31777017E-06_JPRB, 0.31780010E-06_JPRB, 0.31782315E-06_JPRB, 0.31783776E-06_JPRB, &
  & 0.31784376E-06_JPRB, 0.31784120E-06_JPRB, 0.31783023E-06_JPRB, 0.31781155E-06_JPRB, 0.31778615E-06_JPRB, 0.31775599E-06_JPRB, &
  & 0.31772205E-06_JPRB, 0.31768448E-06_JPRB, 0.31764239E-06_JPRB, 0.31759481E-06_JPRB, 0.31754183E-06_JPRB, 0.31748499E-06_JPRB, &
  & 0.31742738E-06_JPRB, 0.31737139E-06_JPRB, 0.31731685E-06_JPRB, 0.31725600E-06_JPRB, 0.31717846E-06_JPRB, 0.31706611E-06_JPRB, &
  & 0.31690388E-06_JPRB, 0.31670220E-06_JPRB, 0.31647932E-06_JPRB, 0.31628011E-06_JPRB, 0.31610159E-06_JPRB, 0.31594467E-06_JPRB, &
  & 0.31580279E-06_JPRB, 0.31567120E-06_JPRB, 0.31554691E-06_JPRB, 0.31543155E-06_JPRB, 0.31532829E-06_JPRB, 0.31523697E-06_JPRB, &
  & 0.31515319E-06_JPRB, 0.31506832E-06_JPRB, 0.31496654E-06_JPRB, 0.31478049E-06_JPRB /)

RGHG3(:,50, 3) = (/ &
  & 0.31383956E-06_JPRB, 0.31428925E-06_JPRB, 0.31457222E-06_JPRB, 0.31486528E-06_JPRB, 0.31519326E-06_JPRB, 0.31550977E-06_JPRB, &
  & 0.31574882E-06_JPRB, 0.31591125E-06_JPRB, 0.31602309E-06_JPRB, 0.31611296E-06_JPRB, 0.31619430E-06_JPRB, 0.31628764E-06_JPRB, &
  & 0.31639706E-06_JPRB, 0.31654051E-06_JPRB, 0.31671226E-06_JPRB, 0.31688091E-06_JPRB, 0.31703027E-06_JPRB, 0.31715413E-06_JPRB, &
  & 0.31725995E-06_JPRB, 0.31735419E-06_JPRB, 0.31744028E-06_JPRB, 0.31751995E-06_JPRB, 0.31759194E-06_JPRB, 0.31765430E-06_JPRB, &
  & 0.31770648E-06_JPRB, 0.31774962E-06_JPRB, 0.31778561E-06_JPRB, 0.31781482E-06_JPRB, 0.31783654E-06_JPRB, 0.31784981E-06_JPRB, &
  & 0.31785459E-06_JPRB, 0.31785115E-06_JPRB, 0.31783966E-06_JPRB, 0.31782082E-06_JPRB, 0.31779561E-06_JPRB, 0.31776577E-06_JPRB, &
  & 0.31773251E-06_JPRB, 0.31769611E-06_JPRB, 0.31765572E-06_JPRB, 0.31761112E-06_JPRB, 0.31756306E-06_JPRB, 0.31751438E-06_JPRB, &
  & 0.31746904E-06_JPRB, 0.31743050E-06_JPRB, 0.31739717E-06_JPRB, 0.31736431E-06_JPRB, 0.31731935E-06_JPRB, 0.31725068E-06_JPRB, &
  & 0.31714507E-06_JPRB, 0.31699975E-06_JPRB, 0.31684669E-06_JPRB, 0.31669578E-06_JPRB, 0.31655745E-06_JPRB, 0.31643108E-06_JPRB, &
  & 0.31630964E-06_JPRB, 0.31619263E-06_JPRB, 0.31608019E-06_JPRB, 0.31597304E-06_JPRB, 0.31587737E-06_JPRB, 0.31579359E-06_JPRB, &
  & 0.31571705E-06_JPRB, 0.31563991E-06_JPRB, 0.31554816E-06_JPRB, 0.31538030E-06_JPRB /)

RGHG3(:,51, 3) = (/ &
  & 0.31451111E-06_JPRB, 0.31493622E-06_JPRB, 0.31522495E-06_JPRB, 0.31550962E-06_JPRB, 0.31583539E-06_JPRB, 0.31612794E-06_JPRB, &
  & 0.31633689E-06_JPRB, 0.31646346E-06_JPRB, 0.31654625E-06_JPRB, 0.31660531E-06_JPRB, 0.31665863E-06_JPRB, 0.31670876E-06_JPRB, &
  & 0.31677268E-06_JPRB, 0.31684823E-06_JPRB, 0.31694302E-06_JPRB, 0.31704602E-06_JPRB, 0.31714285E-06_JPRB, 0.31723107E-06_JPRB, &
  & 0.31731210E-06_JPRB, 0.31738870E-06_JPRB, 0.31746367E-06_JPRB, 0.31753703E-06_JPRB, 0.31760646E-06_JPRB, 0.31766882E-06_JPRB, &
  & 0.31772151E-06_JPRB, 0.31776491E-06_JPRB, 0.31780064E-06_JPRB, 0.31782869E-06_JPRB, 0.31784896E-06_JPRB, 0.31786092E-06_JPRB, &
  & 0.31786448E-06_JPRB, 0.31786016E-06_JPRB, 0.31784816E-06_JPRB, 0.31782901E-06_JPRB, 0.31780397E-06_JPRB, 0.31777455E-06_JPRB, &
  & 0.31774195E-06_JPRB, 0.31770654E-06_JPRB, 0.31766766E-06_JPRB, 0.31762551E-06_JPRB, 0.31758157E-06_JPRB, 0.31753990E-06_JPRB, &
  & 0.31750488E-06_JPRB, 0.31747908E-06_JPRB, 0.31746131E-06_JPRB, 0.31744423E-06_JPRB, 0.31742127E-06_JPRB, 0.31738108E-06_JPRB, &
  & 0.31731679E-06_JPRB, 0.31723403E-06_JPRB, 0.31714046E-06_JPRB, 0.31705068E-06_JPRB, 0.31696530E-06_JPRB, 0.31687642E-06_JPRB, &
  & 0.31678809E-06_JPRB, 0.31669609E-06_JPRB, 0.31659954E-06_JPRB, 0.31650595E-06_JPRB, 0.31641889E-06_JPRB, 0.31634198E-06_JPRB, &
  & 0.31627158E-06_JPRB, 0.31620038E-06_JPRB, 0.31611461E-06_JPRB, 0.31596025E-06_JPRB /)

RGHG3(:,52, 3) = (/ &
  & 0.31510092E-06_JPRB, 0.31554487E-06_JPRB, 0.31579921E-06_JPRB, 0.31609267E-06_JPRB, 0.31638396E-06_JPRB, 0.31663470E-06_JPRB, &
  & 0.31678314E-06_JPRB, 0.31686631E-06_JPRB, 0.31691337E-06_JPRB, 0.31694566E-06_JPRB, 0.31696945E-06_JPRB, 0.31699443E-06_JPRB, &
  & 0.31701933E-06_JPRB, 0.31705574E-06_JPRB, 0.31710329E-06_JPRB, 0.31716280E-06_JPRB, 0.31722692E-06_JPRB, 0.31729081E-06_JPRB, &
  & 0.31735405E-06_JPRB, 0.31741834E-06_JPRB, 0.31748442E-06_JPRB, 0.31755295E-06_JPRB, 0.31762090E-06_JPRB, 0.31768315E-06_JPRB, &
  & 0.31773629E-06_JPRB, 0.31777972E-06_JPRB, 0.31781474E-06_JPRB, 0.31784163E-06_JPRB, 0.31786044E-06_JPRB, 0.31787116E-06_JPRB, &
  & 0.31787360E-06_JPRB, 0.31786840E-06_JPRB, 0.31785601E-06_JPRB, 0.31783654E-06_JPRB, 0.31781153E-06_JPRB, 0.31778248E-06_JPRB, &
  & 0.31775056E-06_JPRB, 0.31771609E-06_JPRB, 0.31767851E-06_JPRB, 0.31763858E-06_JPRB, 0.31759856E-06_JPRB, 0.31756278E-06_JPRB, &
  & 0.31753615E-06_JPRB, 0.31752029E-06_JPRB, 0.31751159E-06_JPRB, 0.31750508E-06_JPRB, 0.31749317E-06_JPRB, 0.31747101E-06_JPRB, &
  & 0.31743537E-06_JPRB, 0.31738881E-06_JPRB, 0.31734220E-06_JPRB, 0.31729752E-06_JPRB, 0.31725136E-06_JPRB, 0.31720566E-06_JPRB, &
  & 0.31715274E-06_JPRB, 0.31709340E-06_JPRB, 0.31702837E-06_JPRB, 0.31695745E-06_JPRB, 0.31688987E-06_JPRB, 0.31682788E-06_JPRB, &
  & 0.31676919E-06_JPRB, 0.31670834E-06_JPRB, 0.31663416E-06_JPRB, 0.31649361E-06_JPRB /)

RGHG3(:,53, 3) = (/ &
  & 0.31565850E-06_JPRB, 0.31604193E-06_JPRB, 0.31632121E-06_JPRB, 0.31655722E-06_JPRB, 0.31680597E-06_JPRB, 0.31697556E-06_JPRB, &
  & 0.31706637E-06_JPRB, 0.31711016E-06_JPRB, 0.31713378E-06_JPRB, 0.31714791E-06_JPRB, 0.31715877E-06_JPRB, 0.31716709E-06_JPRB, &
  & 0.31717775E-06_JPRB, 0.31719088E-06_JPRB, 0.31721430E-06_JPRB, 0.31724829E-06_JPRB, 0.31729087E-06_JPRB, 0.31733833E-06_JPRB, &
  & 0.31738952E-06_JPRB, 0.31744423E-06_JPRB, 0.31750449E-06_JPRB, 0.31756917E-06_JPRB, 0.31763543E-06_JPRB, 0.31769753E-06_JPRB, &
  & 0.31775070E-06_JPRB, 0.31779388E-06_JPRB, 0.31782801E-06_JPRB, 0.31785362E-06_JPRB, 0.31787110E-06_JPRB, 0.31788053E-06_JPRB, &
  & 0.31788210E-06_JPRB, 0.31787607E-06_JPRB, 0.31786308E-06_JPRB, 0.31784330E-06_JPRB, 0.31781843E-06_JPRB, 0.31778967E-06_JPRB, &
  & 0.31775846E-06_JPRB, 0.31772484E-06_JPRB, 0.31768860E-06_JPRB, 0.31765086E-06_JPRB, 0.31761425E-06_JPRB, 0.31758401E-06_JPRB, &
  & 0.31756423E-06_JPRB, 0.31755519E-06_JPRB, 0.31755297E-06_JPRB, 0.31755189E-06_JPRB, 0.31754715E-06_JPRB, 0.31753493E-06_JPRB, &
  & 0.31751458E-06_JPRB, 0.31749073E-06_JPRB, 0.31746706E-06_JPRB, 0.31744480E-06_JPRB, 0.31742417E-06_JPRB, 0.31740007E-06_JPRB, &
  & 0.31737395E-06_JPRB, 0.31734237E-06_JPRB, 0.31730409E-06_JPRB, 0.31726267E-06_JPRB, 0.31722016E-06_JPRB, 0.31717997E-06_JPRB, &
  & 0.31714140E-06_JPRB, 0.31709925E-06_JPRB, 0.31704431E-06_JPRB, 0.31693611E-06_JPRB /)

RGHG3(:,54, 3) = (/ &
  & 0.31611194E-06_JPRB, 0.31650913E-06_JPRB, 0.31671058E-06_JPRB, 0.31691627E-06_JPRB, 0.31707904E-06_JPRB, 0.31718349E-06_JPRB, &
  & 0.31723135E-06_JPRB, 0.31725341E-06_JPRB, 0.31726421E-06_JPRB, 0.31727058E-06_JPRB, 0.31727438E-06_JPRB, 0.31727760E-06_JPRB, &
  & 0.31728018E-06_JPRB, 0.31728493E-06_JPRB, 0.31729434E-06_JPRB, 0.31731335E-06_JPRB, 0.31734186E-06_JPRB, 0.31737795E-06_JPRB, &
  & 0.31742019E-06_JPRB, 0.31746887E-06_JPRB, 0.31752413E-06_JPRB, 0.31758623E-06_JPRB, 0.31765083E-06_JPRB, 0.31771194E-06_JPRB, &
  & 0.31776463E-06_JPRB, 0.31780718E-06_JPRB, 0.31784043E-06_JPRB, 0.31786479E-06_JPRB, 0.31788102E-06_JPRB, 0.31788937E-06_JPRB, &
  & 0.31788991E-06_JPRB, 0.31788315E-06_JPRB, 0.31786959E-06_JPRB, 0.31784964E-06_JPRB, 0.31782477E-06_JPRB, 0.31779643E-06_JPRB, &
  & 0.31776577E-06_JPRB, 0.31773314E-06_JPRB, 0.31769818E-06_JPRB, 0.31766280E-06_JPRB, 0.31762968E-06_JPRB, 0.31760410E-06_JPRB, &
  & 0.31758975E-06_JPRB, 0.31758577E-06_JPRB, 0.31758756E-06_JPRB, 0.31759001E-06_JPRB, 0.31758898E-06_JPRB, 0.31758270E-06_JPRB, &
  & 0.31757131E-06_JPRB, 0.31755783E-06_JPRB, 0.31754567E-06_JPRB, 0.31753490E-06_JPRB, 0.31752353E-06_JPRB, 0.31751242E-06_JPRB, &
  & 0.31749846E-06_JPRB, 0.31748192E-06_JPRB, 0.31746220E-06_JPRB, 0.31743906E-06_JPRB, 0.31741598E-06_JPRB, 0.31739449E-06_JPRB, &
  & 0.31737309E-06_JPRB, 0.31735001E-06_JPRB, 0.31731926E-06_JPRB, 0.31725531E-06_JPRB /)

RGHG3(:,55, 3) = (/ &
  & 0.31653121E-06_JPRB, 0.31684053E-06_JPRB, 0.31701978E-06_JPRB, 0.31714811E-06_JPRB, 0.31724974E-06_JPRB, 0.31730781E-06_JPRB, &
  & 0.31733293E-06_JPRB, 0.31734359E-06_JPRB, 0.31734857E-06_JPRB, 0.31735107E-06_JPRB, 0.31735249E-06_JPRB, 0.31735308E-06_JPRB, &
  & 0.31735325E-06_JPRB, 0.31735360E-06_JPRB, 0.31735664E-06_JPRB, 0.31736593E-06_JPRB, 0.31738458E-06_JPRB, 0.31741232E-06_JPRB, &
  & 0.31744824E-06_JPRB, 0.31749209E-06_JPRB, 0.31754445E-06_JPRB, 0.31760393E-06_JPRB, 0.31766660E-06_JPRB, 0.31772612E-06_JPRB, &
  & 0.31777779E-06_JPRB, 0.31781963E-06_JPRB, 0.31785206E-06_JPRB, 0.31787545E-06_JPRB, 0.31789045E-06_JPRB, 0.31789767E-06_JPRB, &
  & 0.31789730E-06_JPRB, 0.31788986E-06_JPRB, 0.31787559E-06_JPRB, 0.31785547E-06_JPRB, 0.31783071E-06_JPRB, 0.31780272E-06_JPRB, &
  & 0.31777273E-06_JPRB, 0.31774104E-06_JPRB, 0.31770779E-06_JPRB, 0.31767465E-06_JPRB, 0.31764506E-06_JPRB, 0.31762340E-06_JPRB, &
  & 0.31761334E-06_JPRB, 0.31761286E-06_JPRB, 0.31761735E-06_JPRB, 0.31762221E-06_JPRB, 0.31762352E-06_JPRB, 0.31762050E-06_JPRB, &
  & 0.31761351E-06_JPRB, 0.31760595E-06_JPRB, 0.31759902E-06_JPRB, 0.31759282E-06_JPRB, 0.31758714E-06_JPRB, 0.31758043E-06_JPRB, &
  & 0.31757321E-06_JPRB, 0.31756423E-06_JPRB, 0.31755320E-06_JPRB, 0.31754098E-06_JPRB, 0.31752847E-06_JPRB, 0.31751668E-06_JPRB, &
  & 0.31750574E-06_JPRB, 0.31749332E-06_JPRB, 0.31747618E-06_JPRB, 0.31743389E-06_JPRB /)

RGHG3(:,56, 3) = (/ &
  & 0.31685539E-06_JPRB, 0.31710624E-06_JPRB, 0.31721734E-06_JPRB, 0.31729735E-06_JPRB, 0.31735664E-06_JPRB, 0.31738819E-06_JPRB, &
  & 0.31740163E-06_JPRB, 0.31740689E-06_JPRB, 0.31740916E-06_JPRB, 0.31741021E-06_JPRB, 0.31741050E-06_JPRB, 0.31741021E-06_JPRB, &
  & 0.31740950E-06_JPRB, 0.31740819E-06_JPRB, 0.31740780E-06_JPRB, 0.31741124E-06_JPRB, 0.31742258E-06_JPRB, 0.31744378E-06_JPRB, &
  & 0.31747467E-06_JPRB, 0.31751514E-06_JPRB, 0.31756477E-06_JPRB, 0.31762215E-06_JPRB, 0.31768235E-06_JPRB, 0.31774019E-06_JPRB, &
  & 0.31779038E-06_JPRB, 0.31783151E-06_JPRB, 0.31786314E-06_JPRB, 0.31788542E-06_JPRB, 0.31789943E-06_JPRB, 0.31790552E-06_JPRB, &
  & 0.31790421E-06_JPRB, 0.31789614E-06_JPRB, 0.31788142E-06_JPRB, 0.31786104E-06_JPRB, 0.31783645E-06_JPRB, 0.31780888E-06_JPRB, &
  & 0.31777950E-06_JPRB, 0.31774888E-06_JPRB, 0.31771737E-06_JPRB, 0.31768687E-06_JPRB, 0.31766038E-06_JPRB, 0.31764228E-06_JPRB, &
  & 0.31763514E-06_JPRB, 0.31763733E-06_JPRB, 0.31764395E-06_JPRB, 0.31765029E-06_JPRB, 0.31765316E-06_JPRB, 0.31765191E-06_JPRB, &
  & 0.31764756E-06_JPRB, 0.31764264E-06_JPRB, 0.31763830E-06_JPRB, 0.31763460E-06_JPRB, 0.31763074E-06_JPRB, 0.31762710E-06_JPRB, &
  & 0.31762261E-06_JPRB, 0.31761738E-06_JPRB, 0.31761112E-06_JPRB, 0.31760379E-06_JPRB, 0.31759663E-06_JPRB, 0.31759043E-06_JPRB, &
  & 0.31758472E-06_JPRB, 0.31757958E-06_JPRB, 0.31757438E-06_JPRB, 0.31756883E-06_JPRB /)

RGHG3(:,57, 3) = (/ &
  & 0.31711139E-06_JPRB, 0.31727913E-06_JPRB, 0.31734768E-06_JPRB, 0.31739589E-06_JPRB, 0.31742724E-06_JPRB, 0.31744582E-06_JPRB, &
  & 0.31745301E-06_JPRB, 0.31745577E-06_JPRB, 0.31745685E-06_JPRB, 0.31745719E-06_JPRB, 0.31745714E-06_JPRB, 0.31745668E-06_JPRB, &
  & 0.31745566E-06_JPRB, 0.31745410E-06_JPRB, 0.31745208E-06_JPRB, 0.31745199E-06_JPRB, 0.31745807E-06_JPRB, 0.31747405E-06_JPRB, &
  & 0.31750074E-06_JPRB, 0.31753817E-06_JPRB, 0.31758546E-06_JPRB, 0.31764029E-06_JPRB, 0.31769824E-06_JPRB, 0.31775372E-06_JPRB, &
  & 0.31780294E-06_JPRB, 0.31784299E-06_JPRB, 0.31787380E-06_JPRB, 0.31789511E-06_JPRB, 0.31790807E-06_JPRB, 0.31791313E-06_JPRB, &
  & 0.31791095E-06_JPRB, 0.31790225E-06_JPRB, 0.31788716E-06_JPRB, 0.31786664E-06_JPRB, 0.31784222E-06_JPRB, 0.31781511E-06_JPRB, &
  & 0.31778643E-06_JPRB, 0.31775699E-06_JPRB, 0.31772734E-06_JPRB, 0.31769929E-06_JPRB, 0.31767584E-06_JPRB, 0.31766052E-06_JPRB, &
  & 0.31765575E-06_JPRB, 0.31765990E-06_JPRB, 0.31766788E-06_JPRB, 0.31767570E-06_JPRB, 0.31767948E-06_JPRB, 0.31767925E-06_JPRB, &
  & 0.31767615E-06_JPRB, 0.31767280E-06_JPRB, 0.31766967E-06_JPRB, 0.31766689E-06_JPRB, 0.31766436E-06_JPRB, 0.31766160E-06_JPRB, &
  & 0.31765870E-06_JPRB, 0.31765524E-06_JPRB, 0.31765103E-06_JPRB, 0.31764631E-06_JPRB, 0.31764165E-06_JPRB, 0.31763739E-06_JPRB, &
  & 0.31763383E-06_JPRB, 0.31763017E-06_JPRB, 0.31762607E-06_JPRB, 0.31761937E-06_JPRB /)

RGHG3(:,58, 3) = (/ &
  & 0.31730198E-06_JPRB, 0.31739529E-06_JPRB, 0.31743656E-06_JPRB, 0.31746112E-06_JPRB, 0.31748064E-06_JPRB, 0.31749050E-06_JPRB, &
  & 0.31749485E-06_JPRB, 0.31749636E-06_JPRB, 0.31749693E-06_JPRB, 0.31749704E-06_JPRB, 0.31749690E-06_JPRB, 0.31749644E-06_JPRB, &
  & 0.31749568E-06_JPRB, 0.31749394E-06_JPRB, 0.31749164E-06_JPRB, 0.31748957E-06_JPRB, 0.31749198E-06_JPRB, 0.31750389E-06_JPRB, &
  & 0.31752683E-06_JPRB, 0.31756139E-06_JPRB, 0.31760598E-06_JPRB, 0.31765842E-06_JPRB, 0.31771384E-06_JPRB, 0.31776779E-06_JPRB, &
  & 0.31781522E-06_JPRB, 0.31785436E-06_JPRB, 0.31788406E-06_JPRB, 0.31790432E-06_JPRB, 0.31791632E-06_JPRB, 0.31792052E-06_JPRB, &
  & 0.31791745E-06_JPRB, 0.31790819E-06_JPRB, 0.31789281E-06_JPRB, 0.31787224E-06_JPRB, 0.31784811E-06_JPRB, 0.31782150E-06_JPRB, &
  & 0.31779376E-06_JPRB, 0.31776551E-06_JPRB, 0.31773766E-06_JPRB, 0.31771199E-06_JPRB, 0.31769113E-06_JPRB, 0.31767831E-06_JPRB, &
  & 0.31767544E-06_JPRB, 0.31768087E-06_JPRB, 0.31769034E-06_JPRB, 0.31769881E-06_JPRB, 0.31770350E-06_JPRB, 0.31770375E-06_JPRB, &
  & 0.31770139E-06_JPRB, 0.31769846E-06_JPRB, 0.31769585E-06_JPRB, 0.31769366E-06_JPRB, 0.31769150E-06_JPRB, 0.31768946E-06_JPRB, &
  & 0.31768712E-06_JPRB, 0.31768451E-06_JPRB, 0.31768144E-06_JPRB, 0.31767786E-06_JPRB, 0.31767431E-06_JPRB, 0.31767127E-06_JPRB, &
  & 0.31766842E-06_JPRB, 0.31766567E-06_JPRB, 0.31766231E-06_JPRB, 0.31765654E-06_JPRB /)

RGHG3(:,59, 3) = (/ &
  & 0.31741530E-06_JPRB, 0.31747462E-06_JPRB, 0.31749613E-06_JPRB, 0.31751210E-06_JPRB, 0.31752205E-06_JPRB, 0.31752850E-06_JPRB, &
  & 0.31753109E-06_JPRB, 0.31753217E-06_JPRB, 0.31753262E-06_JPRB, 0.31753279E-06_JPRB, 0.31753277E-06_JPRB, 0.31753248E-06_JPRB, &
  & 0.31753180E-06_JPRB, 0.31753044E-06_JPRB, 0.31752779E-06_JPRB, 0.31752481E-06_JPRB, 0.31752478E-06_JPRB, 0.31753353E-06_JPRB, &
  & 0.31755346E-06_JPRB, 0.31758509E-06_JPRB, 0.31762704E-06_JPRB, 0.31767672E-06_JPRB, 0.31773010E-06_JPRB, 0.31778168E-06_JPRB, &
  & 0.31782787E-06_JPRB, 0.31786561E-06_JPRB, 0.31789409E-06_JPRB, 0.31791333E-06_JPRB, 0.31792430E-06_JPRB, 0.31792760E-06_JPRB, &
  & 0.31792391E-06_JPRB, 0.31791413E-06_JPRB, 0.31789858E-06_JPRB, 0.31787812E-06_JPRB, 0.31785430E-06_JPRB, 0.31782838E-06_JPRB, &
  & 0.31780161E-06_JPRB, 0.31777455E-06_JPRB, 0.31774852E-06_JPRB, 0.31772490E-06_JPRB, 0.31770648E-06_JPRB, 0.31769576E-06_JPRB, &
  & 0.31769443E-06_JPRB, 0.31770102E-06_JPRB, 0.31771111E-06_JPRB, 0.31772049E-06_JPRB, 0.31772572E-06_JPRB, 0.31772646E-06_JPRB, &
  & 0.31772436E-06_JPRB, 0.31772174E-06_JPRB, 0.31771924E-06_JPRB, 0.31771702E-06_JPRB, 0.31771503E-06_JPRB, 0.31771305E-06_JPRB, &
  & 0.31771108E-06_JPRB, 0.31770878E-06_JPRB, 0.31770617E-06_JPRB, 0.31770327E-06_JPRB, 0.31770043E-06_JPRB, 0.31769784E-06_JPRB, &
  & 0.31769559E-06_JPRB, 0.31769315E-06_JPRB, 0.31769031E-06_JPRB, 0.31768488E-06_JPRB /)

RGHG3(:,60, 3) = (/ &
  & 0.31750642E-06_JPRB, 0.31753112E-06_JPRB, 0.31754354E-06_JPRB, 0.31755121E-06_JPRB, 0.31755792E-06_JPRB, 0.31756164E-06_JPRB, &
  & 0.31756360E-06_JPRB, 0.31756446E-06_JPRB, 0.31756494E-06_JPRB, 0.31756520E-06_JPRB, 0.31756537E-06_JPRB, 0.31756537E-06_JPRB, &
  & 0.31756502E-06_JPRB, 0.31756394E-06_JPRB, 0.31756164E-06_JPRB, 0.31755809E-06_JPRB, 0.31755670E-06_JPRB, 0.31756312E-06_JPRB, &
  & 0.31758034E-06_JPRB, 0.31760933E-06_JPRB, 0.31764847E-06_JPRB, 0.31769574E-06_JPRB, 0.31774661E-06_JPRB, 0.31779615E-06_JPRB, &
  & 0.31784046E-06_JPRB, 0.31787667E-06_JPRB, 0.31790390E-06_JPRB, 0.31792194E-06_JPRB, 0.31793192E-06_JPRB, 0.31793445E-06_JPRB, &
  & 0.31793030E-06_JPRB, 0.31792013E-06_JPRB, 0.31790458E-06_JPRB, 0.31788431E-06_JPRB, 0.31786084E-06_JPRB, 0.31783566E-06_JPRB, &
  & 0.31780993E-06_JPRB, 0.31778421E-06_JPRB, 0.31775971E-06_JPRB, 0.31773814E-06_JPRB, 0.31772180E-06_JPRB, 0.31771305E-06_JPRB, &
  & 0.31771302E-06_JPRB, 0.31772029E-06_JPRB, 0.31773104E-06_JPRB, 0.31774078E-06_JPRB, 0.31774664E-06_JPRB, 0.31774769E-06_JPRB, &
  & 0.31774579E-06_JPRB, 0.31774294E-06_JPRB, 0.31774039E-06_JPRB, 0.31773800E-06_JPRB, 0.31773584E-06_JPRB, 0.31773388E-06_JPRB, &
  & 0.31773186E-06_JPRB, 0.31772970E-06_JPRB, 0.31772726E-06_JPRB, 0.31772464E-06_JPRB, 0.31772203E-06_JPRB, 0.31771987E-06_JPRB, &
  & 0.31771776E-06_JPRB, 0.31771572E-06_JPRB, 0.31771316E-06_JPRB, 0.31770855E-06_JPRB /)

RGHG3(:,61, 3) = (/ &
  & 0.31755314E-06_JPRB, 0.31757185E-06_JPRB, 0.31757929E-06_JPRB, 0.31758498E-06_JPRB, 0.31758896E-06_JPRB, 0.31759203E-06_JPRB, &
  & 0.31759365E-06_JPRB, 0.31759464E-06_JPRB, 0.31759527E-06_JPRB, 0.31759578E-06_JPRB, 0.31759620E-06_JPRB, 0.31759652E-06_JPRB, &
  & 0.31759660E-06_JPRB, 0.31759600E-06_JPRB, 0.31759379E-06_JPRB, 0.31759006E-06_JPRB, 0.31758779E-06_JPRB, 0.31759257E-06_JPRB, &
  & 0.31760760E-06_JPRB, 0.31763400E-06_JPRB, 0.31767064E-06_JPRB, 0.31771535E-06_JPRB, 0.31776358E-06_JPRB, 0.31781093E-06_JPRB, &
  & 0.31785319E-06_JPRB, 0.31788758E-06_JPRB, 0.31791325E-06_JPRB, 0.31793016E-06_JPRB, 0.31793914E-06_JPRB, 0.31794110E-06_JPRB, &
  & 0.31793655E-06_JPRB, 0.31792635E-06_JPRB, 0.31791078E-06_JPRB, 0.31789097E-06_JPRB, 0.31786792E-06_JPRB, 0.31784356E-06_JPRB, &
  & 0.31781880E-06_JPRB, 0.31779436E-06_JPRB, 0.31777148E-06_JPRB, 0.31775153E-06_JPRB, 0.31773715E-06_JPRB, 0.31773001E-06_JPRB, &
  & 0.31773115E-06_JPRB, 0.31773908E-06_JPRB, 0.31775005E-06_JPRB, 0.31776017E-06_JPRB, 0.31776645E-06_JPRB, 0.31776801E-06_JPRB, &
  & 0.31776611E-06_JPRB, 0.31776318E-06_JPRB, 0.31776017E-06_JPRB, 0.31775744E-06_JPRB, 0.31775511E-06_JPRB, 0.31775284E-06_JPRB, &
  & 0.31775070E-06_JPRB, 0.31774846E-06_JPRB, 0.31774599E-06_JPRB, 0.31774346E-06_JPRB, 0.31774113E-06_JPRB, 0.31773897E-06_JPRB, &
  & 0.31773709E-06_JPRB, 0.31773513E-06_JPRB, 0.31773283E-06_JPRB, 0.31772836E-06_JPRB /)

RGHG3(:,62, 3) = (/ &
  & 0.31759276E-06_JPRB, 0.31760521E-06_JPRB, 0.31761084E-06_JPRB, 0.31761451E-06_JPRB, 0.31761778E-06_JPRB, 0.31762022E-06_JPRB, &
  & 0.31762201E-06_JPRB, 0.31762312E-06_JPRB, 0.31762400E-06_JPRB, 0.31762482E-06_JPRB, 0.31762562E-06_JPRB, 0.31762644E-06_JPRB, &
  & 0.31762710E-06_JPRB, 0.31762713E-06_JPRB, 0.31762511E-06_JPRB, 0.31762107E-06_JPRB, 0.31761846E-06_JPRB, 0.31762201E-06_JPRB, &
  & 0.31763520E-06_JPRB, 0.31765921E-06_JPRB, 0.31769349E-06_JPRB, 0.31773547E-06_JPRB, 0.31778114E-06_JPRB, 0.31782591E-06_JPRB, &
  & 0.31786590E-06_JPRB, 0.31789824E-06_JPRB, 0.31792231E-06_JPRB, 0.31793792E-06_JPRB, 0.31794610E-06_JPRB, 0.31794758E-06_JPRB, &
  & 0.31794283E-06_JPRB, 0.31793263E-06_JPRB, 0.31791737E-06_JPRB, 0.31789804E-06_JPRB, 0.31787573E-06_JPRB, 0.31785211E-06_JPRB, &
  & 0.31782832E-06_JPRB, 0.31780510E-06_JPRB, 0.31778367E-06_JPRB, 0.31776540E-06_JPRB, 0.31775258E-06_JPRB, 0.31774695E-06_JPRB, &
  & 0.31774903E-06_JPRB, 0.31775744E-06_JPRB, 0.31776867E-06_JPRB, 0.31777887E-06_JPRB, 0.31778546E-06_JPRB, 0.31778745E-06_JPRB, &
  & 0.31778575E-06_JPRB, 0.31778256E-06_JPRB, 0.31777910E-06_JPRB, 0.31777589E-06_JPRB, 0.31777307E-06_JPRB, 0.31777051E-06_JPRB, &
  & 0.31776807E-06_JPRB, 0.31776563E-06_JPRB, 0.31776307E-06_JPRB, 0.31776045E-06_JPRB, 0.31775807E-06_JPRB, 0.31775608E-06_JPRB, &
  & 0.31775414E-06_JPRB, 0.31775230E-06_JPRB, 0.31775008E-06_JPRB, 0.31774593E-06_JPRB /)

RGHG3(:,63, 3) = (/ &
  & 0.31762400E-06_JPRB, 0.31763443E-06_JPRB, 0.31763881E-06_JPRB, 0.31764196E-06_JPRB, 0.31764455E-06_JPRB, 0.31764688E-06_JPRB, &
  & 0.31764870E-06_JPRB, 0.31765023E-06_JPRB, 0.31765154E-06_JPRB, 0.31765288E-06_JPRB, 0.31765424E-06_JPRB, 0.31765572E-06_JPRB, &
  & 0.31765708E-06_JPRB, 0.31765759E-06_JPRB, 0.31765569E-06_JPRB, 0.31765160E-06_JPRB, 0.31764873E-06_JPRB, 0.31765131E-06_JPRB, &
  & 0.31766294E-06_JPRB, 0.31768505E-06_JPRB, 0.31771702E-06_JPRB, 0.31775636E-06_JPRB, 0.31779922E-06_JPRB, 0.31784123E-06_JPRB, &
  & 0.31787846E-06_JPRB, 0.31790870E-06_JPRB, 0.31793098E-06_JPRB, 0.31794536E-06_JPRB, 0.31795270E-06_JPRB, 0.31795386E-06_JPRB, &
  & 0.31794909E-06_JPRB, 0.31793911E-06_JPRB, 0.31792430E-06_JPRB, 0.31790566E-06_JPRB, 0.31788412E-06_JPRB, 0.31786135E-06_JPRB, &
  & 0.31783853E-06_JPRB, 0.31781647E-06_JPRB, 0.31779629E-06_JPRB, 0.31777952E-06_JPRB, 0.31776818E-06_JPRB, 0.31776383E-06_JPRB, &
  & 0.31776676E-06_JPRB, 0.31777554E-06_JPRB, 0.31778677E-06_JPRB, 0.31779697E-06_JPRB, 0.31780371E-06_JPRB, 0.31780607E-06_JPRB, &
  & 0.31780468E-06_JPRB, 0.31780141E-06_JPRB, 0.31779740E-06_JPRB, 0.31779365E-06_JPRB, 0.31779035E-06_JPRB, 0.31778731E-06_JPRB, &
  & 0.31778450E-06_JPRB, 0.31778177E-06_JPRB, 0.31777898E-06_JPRB, 0.31777631E-06_JPRB, 0.31777387E-06_JPRB, 0.31777171E-06_JPRB, &
  & 0.31776986E-06_JPRB, 0.31776790E-06_JPRB, 0.31776557E-06_JPRB, 0.31776131E-06_JPRB /)

RGHG3(:,64, 3) = (/ &
  & 0.31765171E-06_JPRB, 0.31766069E-06_JPRB, 0.31766467E-06_JPRB, 0.31766743E-06_JPRB, 0.31766996E-06_JPRB, 0.31767223E-06_JPRB, &
  & 0.31767436E-06_JPRB, 0.31767621E-06_JPRB, 0.31767809E-06_JPRB, 0.31768002E-06_JPRB, 0.31768221E-06_JPRB, 0.31768460E-06_JPRB, &
  & 0.31768673E-06_JPRB, 0.31768744E-06_JPRB, 0.31768550E-06_JPRB, 0.31768144E-06_JPRB, 0.31767846E-06_JPRB, 0.31768059E-06_JPRB, &
  & 0.31769093E-06_JPRB, 0.31771123E-06_JPRB, 0.31774090E-06_JPRB, 0.31777745E-06_JPRB, 0.31781752E-06_JPRB, 0.31785657E-06_JPRB, &
  & 0.31789102E-06_JPRB, 0.31791885E-06_JPRB, 0.31793923E-06_JPRB, 0.31795219E-06_JPRB, 0.31795884E-06_JPRB, 0.31795963E-06_JPRB, &
  & 0.31795514E-06_JPRB, 0.31794559E-06_JPRB, 0.31793152E-06_JPRB, 0.31791367E-06_JPRB, 0.31789304E-06_JPRB, 0.31787124E-06_JPRB, &
  & 0.31784944E-06_JPRB, 0.31782847E-06_JPRB, 0.31780948E-06_JPRB, 0.31779399E-06_JPRB, 0.31778401E-06_JPRB, 0.31778069E-06_JPRB, &
  & 0.31778433E-06_JPRB, 0.31779331E-06_JPRB, 0.31780448E-06_JPRB, 0.31781451E-06_JPRB, 0.31782128E-06_JPRB, 0.31782389E-06_JPRB, &
  & 0.31782281E-06_JPRB, 0.31781954E-06_JPRB, 0.31781528E-06_JPRB, 0.31781099E-06_JPRB, 0.31780709E-06_JPRB, 0.31780360E-06_JPRB, &
  & 0.31780036E-06_JPRB, 0.31779723E-06_JPRB, 0.31779419E-06_JPRB, 0.31779126E-06_JPRB, 0.31778870E-06_JPRB, 0.31778654E-06_JPRB, &
  & 0.31778450E-06_JPRB, 0.31778242E-06_JPRB, 0.31777984E-06_JPRB, 0.31777506E-06_JPRB /)

RGHG3(:,65, 3) = (/ &
  & 0.31767593E-06_JPRB, 0.31768482E-06_JPRB, 0.31768872E-06_JPRB, 0.31769153E-06_JPRB, 0.31769406E-06_JPRB, 0.31769656E-06_JPRB, &
  & 0.31769895E-06_JPRB, 0.31770145E-06_JPRB, 0.31770384E-06_JPRB, 0.31770665E-06_JPRB, 0.31770963E-06_JPRB, 0.31771282E-06_JPRB, &
  & 0.31771549E-06_JPRB, 0.31771631E-06_JPRB, 0.31771441E-06_JPRB, 0.31771054E-06_JPRB, 0.31770762E-06_JPRB, 0.31770929E-06_JPRB, &
  & 0.31771870E-06_JPRB, 0.31773735E-06_JPRB, 0.31776489E-06_JPRB, 0.31779879E-06_JPRB, 0.31783566E-06_JPRB, 0.31787152E-06_JPRB, &
  & 0.31790302E-06_JPRB, 0.31792834E-06_JPRB, 0.31794687E-06_JPRB, 0.31795850E-06_JPRB, 0.31796441E-06_JPRB, 0.31796498E-06_JPRB, &
  & 0.31796074E-06_JPRB, 0.31795182E-06_JPRB, 0.31793854E-06_JPRB, 0.31792172E-06_JPRB, 0.31790222E-06_JPRB, 0.31788147E-06_JPRB, &
  & 0.31786081E-06_JPRB, 0.31784091E-06_JPRB, 0.31782315E-06_JPRB, 0.31780894E-06_JPRB, 0.31780010E-06_JPRB, 0.31779771E-06_JPRB, &
  & 0.31780169E-06_JPRB, 0.31781079E-06_JPRB, 0.31782167E-06_JPRB, 0.31783148E-06_JPRB, 0.31783816E-06_JPRB, 0.31784083E-06_JPRB, &
  & 0.31784000E-06_JPRB, 0.31783685E-06_JPRB, 0.31783247E-06_JPRB, 0.31782787E-06_JPRB, 0.31782349E-06_JPRB, 0.31781951E-06_JPRB, &
  & 0.31781579E-06_JPRB, 0.31781235E-06_JPRB, 0.31780883E-06_JPRB, 0.31780573E-06_JPRB, 0.31780300E-06_JPRB, 0.31780061E-06_JPRB, &
  & 0.31779842E-06_JPRB, 0.31779598E-06_JPRB, 0.31779297E-06_JPRB, 0.31778728E-06_JPRB /)

RGHG3(:,66, 3) = (/ &
  & 0.31769807E-06_JPRB, 0.31770736E-06_JPRB, 0.31771160E-06_JPRB, 0.31771469E-06_JPRB, 0.31771748E-06_JPRB, 0.31772015E-06_JPRB, &
  & 0.31772296E-06_JPRB, 0.31772583E-06_JPRB, 0.31772913E-06_JPRB, 0.31773254E-06_JPRB, 0.31773664E-06_JPRB, 0.31774033E-06_JPRB, &
  & 0.31774323E-06_JPRB, 0.31774402E-06_JPRB, 0.31774229E-06_JPRB, 0.31773885E-06_JPRB, 0.31773612E-06_JPRB, 0.31773754E-06_JPRB, &
  & 0.31774621E-06_JPRB, 0.31776335E-06_JPRB, 0.31778865E-06_JPRB, 0.31781971E-06_JPRB, 0.31785333E-06_JPRB, 0.31788585E-06_JPRB, &
  & 0.31791433E-06_JPRB, 0.31793715E-06_JPRB, 0.31795381E-06_JPRB, 0.31796418E-06_JPRB, 0.31796941E-06_JPRB, 0.31796981E-06_JPRB, &
  & 0.31796583E-06_JPRB, 0.31795753E-06_JPRB, 0.31794525E-06_JPRB, 0.31792962E-06_JPRB, 0.31791137E-06_JPRB, 0.31789187E-06_JPRB, &
  & 0.31787235E-06_JPRB, 0.31785368E-06_JPRB, 0.31783708E-06_JPRB, 0.31782417E-06_JPRB, 0.31781630E-06_JPRB, 0.31781462E-06_JPRB, &
  & 0.31781892E-06_JPRB, 0.31782778E-06_JPRB, 0.31783830E-06_JPRB, 0.31784776E-06_JPRB, 0.31785424E-06_JPRB, 0.31785703E-06_JPRB, &
  & 0.31785635E-06_JPRB, 0.31785331E-06_JPRB, 0.31784896E-06_JPRB, 0.31784418E-06_JPRB, 0.31783958E-06_JPRB, 0.31783520E-06_JPRB, &
  & 0.31783111E-06_JPRB, 0.31782716E-06_JPRB, 0.31782352E-06_JPRB, 0.31782011E-06_JPRB, 0.31781718E-06_JPRB, 0.31781460E-06_JPRB, &
  & 0.31781204E-06_JPRB, 0.31780922E-06_JPRB, 0.31780550E-06_JPRB, 0.31779823E-06_JPRB /)

RGHG3(:,67, 3) = (/ &
  & 0.31771890E-06_JPRB, 0.31772902E-06_JPRB, 0.31773368E-06_JPRB, 0.31773715E-06_JPRB, 0.31774030E-06_JPRB, 0.31774340E-06_JPRB, &
  & 0.31774658E-06_JPRB, 0.31775011E-06_JPRB, 0.31775392E-06_JPRB, 0.31775829E-06_JPRB, 0.31776267E-06_JPRB, 0.31776679E-06_JPRB, &
  & 0.31776983E-06_JPRB, 0.31777066E-06_JPRB, 0.31776921E-06_JPRB, 0.31776614E-06_JPRB, 0.31776369E-06_JPRB, 0.31776506E-06_JPRB, &
  & 0.31777302E-06_JPRB, 0.31778870E-06_JPRB, 0.31781170E-06_JPRB, 0.31783995E-06_JPRB, 0.31787019E-06_JPRB, 0.31789935E-06_JPRB, &
  & 0.31792484E-06_JPRB, 0.31794522E-06_JPRB, 0.31795994E-06_JPRB, 0.31796918E-06_JPRB, 0.31797381E-06_JPRB, 0.31797401E-06_JPRB, &
  & 0.31797038E-06_JPRB, 0.31796276E-06_JPRB, 0.31795147E-06_JPRB, 0.31793721E-06_JPRB, 0.31792030E-06_JPRB, 0.31790222E-06_JPRB, &
  & 0.31788403E-06_JPRB, 0.31786672E-06_JPRB, 0.31785137E-06_JPRB, 0.31783969E-06_JPRB, 0.31783276E-06_JPRB, 0.31783156E-06_JPRB, &
  & 0.31783603E-06_JPRB, 0.31784450E-06_JPRB, 0.31785453E-06_JPRB, 0.31786354E-06_JPRB, 0.31786976E-06_JPRB, 0.31787246E-06_JPRB, &
  & 0.31787187E-06_JPRB, 0.31786902E-06_JPRB, 0.31786468E-06_JPRB, 0.31785996E-06_JPRB, 0.31785515E-06_JPRB, 0.31785058E-06_JPRB, &
  & 0.31784609E-06_JPRB, 0.31784202E-06_JPRB, 0.31783807E-06_JPRB, 0.31783449E-06_JPRB, 0.31783134E-06_JPRB, 0.31782849E-06_JPRB, &
  & 0.31782568E-06_JPRB, 0.31782224E-06_JPRB, 0.31781764E-06_JPRB, 0.31780831E-06_JPRB /)

RGHG3(:,68, 3) = (/ &
  & 0.31773848E-06_JPRB, 0.31774960E-06_JPRB, 0.31775502E-06_JPRB, 0.31775906E-06_JPRB, 0.31776273E-06_JPRB, 0.31776628E-06_JPRB, &
  & 0.31777003E-06_JPRB, 0.31777407E-06_JPRB, 0.31777847E-06_JPRB, 0.31778325E-06_JPRB, 0.31778808E-06_JPRB, 0.31779220E-06_JPRB, &
  & 0.31779521E-06_JPRB, 0.31779615E-06_JPRB, 0.31779498E-06_JPRB, 0.31779237E-06_JPRB, 0.31779038E-06_JPRB, 0.31779160E-06_JPRB, &
  & 0.31779894E-06_JPRB, 0.31781312E-06_JPRB, 0.31783387E-06_JPRB, 0.31785910E-06_JPRB, 0.31788610E-06_JPRB, 0.31791194E-06_JPRB, &
  & 0.31793456E-06_JPRB, 0.31795255E-06_JPRB, 0.31796552E-06_JPRB, 0.31797364E-06_JPRB, 0.31797765E-06_JPRB, 0.31797774E-06_JPRB, &
  & 0.31797441E-06_JPRB, 0.31796745E-06_JPRB, 0.31795727E-06_JPRB, 0.31794431E-06_JPRB, 0.31792891E-06_JPRB, 0.31791234E-06_JPRB, &
  & 0.31789560E-06_JPRB, 0.31787960E-06_JPRB, 0.31786558E-06_JPRB, 0.31785524E-06_JPRB, 0.31784919E-06_JPRB, 0.31784845E-06_JPRB, &
  & 0.31785285E-06_JPRB, 0.31786081E-06_JPRB, 0.31787025E-06_JPRB, 0.31787877E-06_JPRB, 0.31788460E-06_JPRB, 0.31788716E-06_JPRB, &
  & 0.31788659E-06_JPRB, 0.31788392E-06_JPRB, 0.31787982E-06_JPRB, 0.31787516E-06_JPRB, 0.31787042E-06_JPRB, 0.31786567E-06_JPRB, &
  & 0.31786109E-06_JPRB, 0.31785680E-06_JPRB, 0.31785271E-06_JPRB, 0.31784896E-06_JPRB, 0.31784569E-06_JPRB, 0.31784268E-06_JPRB, &
  & 0.31783964E-06_JPRB, 0.31783588E-06_JPRB, 0.31783034E-06_JPRB, 0.31781843E-06_JPRB /)

RGHG3(:,69, 3) = (/ &
  & 0.31775730E-06_JPRB, 0.31777000E-06_JPRB, 0.31777603E-06_JPRB, 0.31778077E-06_JPRB, 0.31778504E-06_JPRB, 0.31778913E-06_JPRB, &
  & 0.31779331E-06_JPRB, 0.31779780E-06_JPRB, 0.31780263E-06_JPRB, 0.31780769E-06_JPRB, 0.31781255E-06_JPRB, 0.31781664E-06_JPRB, &
  & 0.31781966E-06_JPRB, 0.31782065E-06_JPRB, 0.31781971E-06_JPRB, 0.31781752E-06_JPRB, 0.31781593E-06_JPRB, 0.31781701E-06_JPRB, &
  & 0.31782363E-06_JPRB, 0.31783631E-06_JPRB, 0.31785481E-06_JPRB, 0.31787710E-06_JPRB, 0.31790091E-06_JPRB, 0.31792356E-06_JPRB, &
  & 0.31794343E-06_JPRB, 0.31795921E-06_JPRB, 0.31797060E-06_JPRB, 0.31797768E-06_JPRB, 0.31798115E-06_JPRB, 0.31798112E-06_JPRB, &
  & 0.31797802E-06_JPRB, 0.31797177E-06_JPRB, 0.31796270E-06_JPRB, 0.31795108E-06_JPRB, 0.31793715E-06_JPRB, 0.31792209E-06_JPRB, &
  & 0.31790688E-06_JPRB, 0.31789233E-06_JPRB, 0.31787982E-06_JPRB, 0.31787067E-06_JPRB, 0.31786556E-06_JPRB, 0.31786516E-06_JPRB, &
  & 0.31786934E-06_JPRB, 0.31787687E-06_JPRB, 0.31788554E-06_JPRB, 0.31789347E-06_JPRB, 0.31789884E-06_JPRB, 0.31790120E-06_JPRB, &
  & 0.31790069E-06_JPRB, 0.31789821E-06_JPRB, 0.31789421E-06_JPRB, 0.31788977E-06_JPRB, 0.31788520E-06_JPRB, 0.31788045E-06_JPRB, &
  & 0.31787582E-06_JPRB, 0.31787161E-06_JPRB, 0.31786743E-06_JPRB, 0.31786365E-06_JPRB, 0.31786033E-06_JPRB, 0.31785729E-06_JPRB, &
  & 0.31785413E-06_JPRB, 0.31785009E-06_JPRB, 0.31784364E-06_JPRB, 0.31782952E-06_JPRB /)

RGHG3(:,70, 3) = (/ &
  & 0.31777577E-06_JPRB, 0.31778995E-06_JPRB, 0.31779717E-06_JPRB, 0.31780255E-06_JPRB, 0.31780749E-06_JPRB, 0.31781198E-06_JPRB, &
  & 0.31781653E-06_JPRB, 0.31782142E-06_JPRB, 0.31782648E-06_JPRB, 0.31783159E-06_JPRB, 0.31783622E-06_JPRB, 0.31784015E-06_JPRB, &
  & 0.31784302E-06_JPRB, 0.31784404E-06_JPRB, 0.31784330E-06_JPRB, 0.31784145E-06_JPRB, 0.31784015E-06_JPRB, 0.31784106E-06_JPRB, &
  & 0.31784703E-06_JPRB, 0.31785811E-06_JPRB, 0.31787440E-06_JPRB, 0.31789381E-06_JPRB, 0.31791453E-06_JPRB, 0.31793434E-06_JPRB, &
  & 0.31795156E-06_JPRB, 0.31796523E-06_JPRB, 0.31797506E-06_JPRB, 0.31798118E-06_JPRB, 0.31798422E-06_JPRB, 0.31798413E-06_JPRB, &
  & 0.31798132E-06_JPRB, 0.31797575E-06_JPRB, 0.31796779E-06_JPRB, 0.31795744E-06_JPRB, 0.31794511E-06_JPRB, 0.31793149E-06_JPRB, &
  & 0.31791785E-06_JPRB, 0.31790483E-06_JPRB, 0.31789375E-06_JPRB, 0.31788588E-06_JPRB, 0.31788153E-06_JPRB, 0.31788147E-06_JPRB, &
  & 0.31788548E-06_JPRB, 0.31789236E-06_JPRB, 0.31790040E-06_JPRB, 0.31790756E-06_JPRB, 0.31791234E-06_JPRB, 0.31791450E-06_JPRB, &
  & 0.31791407E-06_JPRB, 0.31791180E-06_JPRB, 0.31790810E-06_JPRB, 0.31790393E-06_JPRB, 0.31789952E-06_JPRB, 0.31789480E-06_JPRB, &
  & 0.31789043E-06_JPRB, 0.31788636E-06_JPRB, 0.31788235E-06_JPRB, 0.31787866E-06_JPRB, 0.31787539E-06_JPRB, 0.31787235E-06_JPRB, &
  & 0.31786928E-06_JPRB, 0.31786516E-06_JPRB, 0.31785839E-06_JPRB, 0.31784245E-06_JPRB /)

RGHG3(:,71, 3) = (/ &
  & 0.31779373E-06_JPRB, 0.31781056E-06_JPRB, 0.31781863E-06_JPRB, 0.31782480E-06_JPRB, 0.31783017E-06_JPRB, 0.31783503E-06_JPRB, &
  & 0.31783981E-06_JPRB, 0.31784481E-06_JPRB, 0.31784992E-06_JPRB, 0.31785484E-06_JPRB, 0.31785925E-06_JPRB, 0.31786283E-06_JPRB, &
  & 0.31786544E-06_JPRB, 0.31786641E-06_JPRB, 0.31786567E-06_JPRB, 0.31786399E-06_JPRB, 0.31786308E-06_JPRB, 0.31786371E-06_JPRB, &
  & 0.31786897E-06_JPRB, 0.31787843E-06_JPRB, 0.31789261E-06_JPRB, 0.31790933E-06_JPRB, 0.31792709E-06_JPRB, 0.31794414E-06_JPRB, &
  & 0.31795898E-06_JPRB, 0.31797066E-06_JPRB, 0.31797916E-06_JPRB, 0.31798427E-06_JPRB, 0.31798692E-06_JPRB, 0.31798680E-06_JPRB, &
  & 0.31798430E-06_JPRB, 0.31797947E-06_JPRB, 0.31797251E-06_JPRB, 0.31796355E-06_JPRB, 0.31795270E-06_JPRB, 0.31794062E-06_JPRB, &
  & 0.31792848E-06_JPRB, 0.31791694E-06_JPRB, 0.31790736E-06_JPRB, 0.31790071E-06_JPRB, 0.31789719E-06_JPRB, 0.31789730E-06_JPRB, &
  & 0.31790097E-06_JPRB, 0.31790734E-06_JPRB, 0.31791450E-06_JPRB, 0.31792092E-06_JPRB, 0.31792524E-06_JPRB, 0.31792706E-06_JPRB, &
  & 0.31792669E-06_JPRB, 0.31792476E-06_JPRB, 0.31792135E-06_JPRB, 0.31791754E-06_JPRB, 0.31791350E-06_JPRB, 0.31790893E-06_JPRB, &
  & 0.31790475E-06_JPRB, 0.31790105E-06_JPRB, 0.31789733E-06_JPRB, 0.31789375E-06_JPRB, 0.31789062E-06_JPRB, 0.31788778E-06_JPRB, &
  & 0.31788500E-06_JPRB, 0.31788105E-06_JPRB, 0.31787417E-06_JPRB, 0.31785780E-06_JPRB /)

RGHG3(:,72, 3) = (/ &
  & 0.31781224E-06_JPRB, 0.31783134E-06_JPRB, 0.31784077E-06_JPRB, 0.31784731E-06_JPRB, 0.31785311E-06_JPRB, 0.31785811E-06_JPRB, &
  & 0.31786303E-06_JPRB, 0.31786789E-06_JPRB, 0.31787272E-06_JPRB, 0.31787749E-06_JPRB, 0.31788136E-06_JPRB, 0.31788457E-06_JPRB, &
  & 0.31788687E-06_JPRB, 0.31788758E-06_JPRB, 0.31788682E-06_JPRB, 0.31788522E-06_JPRB, 0.31788468E-06_JPRB, 0.31788500E-06_JPRB, &
  & 0.31788949E-06_JPRB, 0.31789739E-06_JPRB, 0.31790955E-06_JPRB, 0.31792362E-06_JPRB, 0.31793863E-06_JPRB, 0.31795312E-06_JPRB, &
  & 0.31796554E-06_JPRB, 0.31797555E-06_JPRB, 0.31798297E-06_JPRB, 0.31798723E-06_JPRB, 0.31798942E-06_JPRB, 0.31798905E-06_JPRB, &
  & 0.31798703E-06_JPRB, 0.31798282E-06_JPRB, 0.31797691E-06_JPRB, 0.31796930E-06_JPRB, 0.31795989E-06_JPRB, 0.31794937E-06_JPRB, &
  & 0.31793877E-06_JPRB, 0.31792874E-06_JPRB, 0.31792061E-06_JPRB, 0.31791507E-06_JPRB, 0.31791217E-06_JPRB, 0.31791251E-06_JPRB, &
  & 0.31791578E-06_JPRB, 0.31792140E-06_JPRB, 0.31792788E-06_JPRB, 0.31793346E-06_JPRB, 0.31793729E-06_JPRB, 0.31793871E-06_JPRB, &
  & 0.31793843E-06_JPRB, 0.31793675E-06_JPRB, 0.31793380E-06_JPRB, 0.31793047E-06_JPRB, 0.31792686E-06_JPRB, 0.31792263E-06_JPRB, &
  & 0.31791876E-06_JPRB, 0.31791549E-06_JPRB, 0.31791211E-06_JPRB, 0.31790884E-06_JPRB, 0.31790591E-06_JPRB, 0.31790336E-06_JPRB, &
  & 0.31790083E-06_JPRB, 0.31789716E-06_JPRB, 0.31789060E-06_JPRB, 0.31787434E-06_JPRB /)

RGHG3(:,73, 3) = (/ &
  & 0.31783406E-06_JPRB, 0.31785419E-06_JPRB, 0.31786385E-06_JPRB, 0.31787027E-06_JPRB, 0.31787599E-06_JPRB, 0.31788099E-06_JPRB, &
  & 0.31788568E-06_JPRB, 0.31789025E-06_JPRB, 0.31789483E-06_JPRB, 0.31789901E-06_JPRB, 0.31790245E-06_JPRB, 0.31790512E-06_JPRB, &
  & 0.31790708E-06_JPRB, 0.31790748E-06_JPRB, 0.31790648E-06_JPRB, 0.31790489E-06_JPRB, 0.31790469E-06_JPRB, 0.31790464E-06_JPRB, &
  & 0.31790844E-06_JPRB, 0.31791490E-06_JPRB, 0.31792518E-06_JPRB, 0.31793684E-06_JPRB, 0.31794912E-06_JPRB, 0.31796134E-06_JPRB, &
  & 0.31797157E-06_JPRB, 0.31797984E-06_JPRB, 0.31798623E-06_JPRB, 0.31798982E-06_JPRB, 0.31799166E-06_JPRB, 0.31799112E-06_JPRB, &
  & 0.31798953E-06_JPRB, 0.31798592E-06_JPRB, 0.31798098E-06_JPRB, 0.31797472E-06_JPRB, 0.31796688E-06_JPRB, 0.31795781E-06_JPRB, &
  & 0.31794877E-06_JPRB, 0.31794011E-06_JPRB, 0.31793334E-06_JPRB, 0.31792888E-06_JPRB, 0.31792649E-06_JPRB, 0.31792695E-06_JPRB, &
  & 0.31792968E-06_JPRB, 0.31793471E-06_JPRB, 0.31794025E-06_JPRB, 0.31794499E-06_JPRB, 0.31794846E-06_JPRB, 0.31794949E-06_JPRB, &
  & 0.31794929E-06_JPRB, 0.31794795E-06_JPRB, 0.31794536E-06_JPRB, 0.31794269E-06_JPRB, 0.31793954E-06_JPRB, 0.31793553E-06_JPRB, &
  & 0.31793218E-06_JPRB, 0.31792931E-06_JPRB, 0.31792652E-06_JPRB, 0.31792348E-06_JPRB, 0.31792086E-06_JPRB, 0.31791856E-06_JPRB, &
  & 0.31791637E-06_JPRB, 0.31791305E-06_JPRB, 0.31790702E-06_JPRB, 0.31789148E-06_JPRB /)

RGHG3(:,74, 3) = (/ &
  & 0.31785683E-06_JPRB, 0.31787746E-06_JPRB, 0.31788693E-06_JPRB, 0.31789290E-06_JPRB, 0.31789824E-06_JPRB, 0.31790290E-06_JPRB, &
  & 0.31790736E-06_JPRB, 0.31791143E-06_JPRB, 0.31791544E-06_JPRB, 0.31791930E-06_JPRB, 0.31792212E-06_JPRB, 0.31792436E-06_JPRB, &
  & 0.31792595E-06_JPRB, 0.31792598E-06_JPRB, 0.31792476E-06_JPRB, 0.31792305E-06_JPRB, 0.31792331E-06_JPRB, 0.31792283E-06_JPRB, &
  & 0.31792592E-06_JPRB, 0.31793101E-06_JPRB, 0.31793957E-06_JPRB, 0.31794895E-06_JPRB, 0.31795881E-06_JPRB, 0.31796895E-06_JPRB, &
  & 0.31797694E-06_JPRB, 0.31798379E-06_JPRB, 0.31798922E-06_JPRB, 0.31799232E-06_JPRB, 0.31799379E-06_JPRB, 0.31799303E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31798888E-06_JPRB, 0.31798479E-06_JPRB, 0.31797973E-06_JPRB, 0.31797347E-06_JPRB, 0.31796571E-06_JPRB, &
  & 0.31795821E-06_JPRB, 0.31795099E-06_JPRB, 0.31794556E-06_JPRB, 0.31794212E-06_JPRB, 0.31794008E-06_JPRB, 0.31794050E-06_JPRB, &
  & 0.31794272E-06_JPRB, 0.31794698E-06_JPRB, 0.31795173E-06_JPRB, 0.31795560E-06_JPRB, 0.31795864E-06_JPRB, 0.31795929E-06_JPRB, &
  & 0.31795923E-06_JPRB, 0.31795813E-06_JPRB, 0.31795599E-06_JPRB, 0.31795395E-06_JPRB, 0.31795130E-06_JPRB, 0.31794752E-06_JPRB, &
  & 0.31794460E-06_JPRB, 0.31794244E-06_JPRB, 0.31794008E-06_JPRB, 0.31793735E-06_JPRB, 0.31793499E-06_JPRB, 0.31793306E-06_JPRB, &
  & 0.31793141E-06_JPRB, 0.31792848E-06_JPRB, 0.31792302E-06_JPRB, 0.31790844E-06_JPRB /)

RGHG3(:,75, 3) = (/ &
  & 0.31788028E-06_JPRB, 0.31790040E-06_JPRB, 0.31790961E-06_JPRB, 0.31791441E-06_JPRB, 0.31791936E-06_JPRB, 0.31792351E-06_JPRB, &
  & 0.31792757E-06_JPRB, 0.31793098E-06_JPRB, 0.31793454E-06_JPRB, 0.31793778E-06_JPRB, 0.31794016E-06_JPRB, 0.31794201E-06_JPRB, &
  & 0.31794335E-06_JPRB, 0.31794289E-06_JPRB, 0.31794136E-06_JPRB, 0.31793965E-06_JPRB, 0.31794042E-06_JPRB, 0.31793951E-06_JPRB, &
  & 0.31794193E-06_JPRB, 0.31794576E-06_JPRB, 0.31795287E-06_JPRB, 0.31796009E-06_JPRB, 0.31796768E-06_JPRB, 0.31797603E-06_JPRB, &
  & 0.31798180E-06_JPRB, 0.31798729E-06_JPRB, 0.31799189E-06_JPRB, 0.31799442E-06_JPRB, 0.31799573E-06_JPRB, 0.31799470E-06_JPRB, &
  & 0.31799394E-06_JPRB, 0.31799152E-06_JPRB, 0.31798825E-06_JPRB, 0.31798447E-06_JPRB, 0.31797970E-06_JPRB, 0.31797327E-06_JPRB, &
  & 0.31796731E-06_JPRB, 0.31796139E-06_JPRB, 0.31795727E-06_JPRB, 0.31795469E-06_JPRB, 0.31795292E-06_JPRB, 0.31795327E-06_JPRB, &
  & 0.31795483E-06_JPRB, 0.31795850E-06_JPRB, 0.31796233E-06_JPRB, 0.31796526E-06_JPRB, 0.31796807E-06_JPRB, 0.31796827E-06_JPRB, &
  & 0.31796824E-06_JPRB, 0.31796742E-06_JPRB, 0.31796563E-06_JPRB, 0.31796424E-06_JPRB, 0.31796216E-06_JPRB, 0.31795844E-06_JPRB, &
  & 0.31795605E-06_JPRB, 0.31795446E-06_JPRB, 0.31795275E-06_JPRB, 0.31795025E-06_JPRB, 0.31794821E-06_JPRB, 0.31794684E-06_JPRB, &
  & 0.31794573E-06_JPRB, 0.31794309E-06_JPRB, 0.31793840E-06_JPRB, 0.31792484E-06_JPRB /)

RGHG3(:,76, 3) = (/ &
  & 0.31790387E-06_JPRB, 0.31792291E-06_JPRB, 0.31793107E-06_JPRB, 0.31793468E-06_JPRB, 0.31793894E-06_JPRB, 0.31794252E-06_JPRB, &
  & 0.31794616E-06_JPRB, 0.31794886E-06_JPRB, 0.31795190E-06_JPRB, 0.31795452E-06_JPRB, 0.31795631E-06_JPRB, 0.31795781E-06_JPRB, &
  & 0.31795901E-06_JPRB, 0.31795815E-06_JPRB, 0.31795645E-06_JPRB, 0.31795466E-06_JPRB, 0.31795608E-06_JPRB, 0.31795474E-06_JPRB, &
  & 0.31795653E-06_JPRB, 0.31795921E-06_JPRB, 0.31796503E-06_JPRB, 0.31797043E-06_JPRB, 0.31797580E-06_JPRB, 0.31798260E-06_JPRB, &
  & 0.31798609E-06_JPRB, 0.31799047E-06_JPRB, 0.31799436E-06_JPRB, 0.31799652E-06_JPRB, 0.31799755E-06_JPRB, 0.31799618E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799402E-06_JPRB, 0.31799135E-06_JPRB, 0.31798879E-06_JPRB, 0.31798561E-06_JPRB, 0.31798032E-06_JPRB, &
  & 0.31797575E-06_JPRB, 0.31797126E-06_JPRB, 0.31796841E-06_JPRB, 0.31796662E-06_JPRB, 0.31796498E-06_JPRB, 0.31796512E-06_JPRB, &
  & 0.31796606E-06_JPRB, 0.31796904E-06_JPRB, 0.31797214E-06_JPRB, 0.31797413E-06_JPRB, 0.31797668E-06_JPRB, 0.31797640E-06_JPRB, &
  & 0.31797640E-06_JPRB, 0.31797575E-06_JPRB, 0.31797441E-06_JPRB, 0.31797367E-06_JPRB, 0.31797208E-06_JPRB, 0.31796827E-06_JPRB, &
  & 0.31796634E-06_JPRB, 0.31796543E-06_JPRB, 0.31796446E-06_JPRB, 0.31796230E-06_JPRB, 0.31796051E-06_JPRB, 0.31795966E-06_JPRB, &
  & 0.31795921E-06_JPRB, 0.31795685E-06_JPRB, 0.31795307E-06_JPRB, 0.31794048E-06_JPRB /)

RGHG3(:,77, 3) = (/ &
  & 0.31792769E-06_JPRB, 0.31794411E-06_JPRB, 0.31795145E-06_JPRB, 0.31795315E-06_JPRB, 0.31795685E-06_JPRB, 0.31795975E-06_JPRB, &
  & 0.31796284E-06_JPRB, 0.31796478E-06_JPRB, 0.31796714E-06_JPRB, 0.31796924E-06_JPRB, 0.31797040E-06_JPRB, 0.31797157E-06_JPRB, &
  & 0.31797276E-06_JPRB, 0.31797160E-06_JPRB, 0.31796984E-06_JPRB, 0.31796804E-06_JPRB, 0.31797015E-06_JPRB, 0.31796841E-06_JPRB, &
  & 0.31796972E-06_JPRB, 0.31797120E-06_JPRB, 0.31797623E-06_JPRB, 0.31797978E-06_JPRB, 0.31798317E-06_JPRB, 0.31798857E-06_JPRB, &
  & 0.31798987E-06_JPRB, 0.31799331E-06_JPRB, 0.31799655E-06_JPRB, 0.31799829E-06_JPRB, 0.31799922E-06_JPRB, 0.31799755E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799627E-06_JPRB, 0.31799425E-06_JPRB, 0.31799280E-06_JPRB, 0.31799104E-06_JPRB, 0.31798680E-06_JPRB, &
  & 0.31798359E-06_JPRB, 0.31798049E-06_JPRB, 0.31797885E-06_JPRB, 0.31797771E-06_JPRB, 0.31797606E-06_JPRB, 0.31797603E-06_JPRB, &
  & 0.31797617E-06_JPRB, 0.31797867E-06_JPRB, 0.31798109E-06_JPRB, 0.31798209E-06_JPRB, 0.31798450E-06_JPRB, 0.31798359E-06_JPRB, &
  & 0.31798373E-06_JPRB, 0.31798325E-06_JPRB, 0.31798220E-06_JPRB, 0.31798220E-06_JPRB, 0.31798115E-06_JPRB, 0.31797697E-06_JPRB, &
  & 0.31797549E-06_JPRB, 0.31797535E-06_JPRB, 0.31797532E-06_JPRB, 0.31797330E-06_JPRB, 0.31797174E-06_JPRB, 0.31797148E-06_JPRB, &
  & 0.31797177E-06_JPRB, 0.31796969E-06_JPRB, 0.31796688E-06_JPRB, 0.31795565E-06_JPRB /)

RGHG3(:,78, 3) = (/ &
  & 0.31795116E-06_JPRB, 0.31796344E-06_JPRB, 0.31796904E-06_JPRB, 0.31796887E-06_JPRB, 0.31797191E-06_JPRB, 0.31797424E-06_JPRB, &
  & 0.31797680E-06_JPRB, 0.31797777E-06_JPRB, 0.31797970E-06_JPRB, 0.31798106E-06_JPRB, 0.31798169E-06_JPRB, 0.31798254E-06_JPRB, &
  & 0.31798388E-06_JPRB, 0.31798243E-06_JPRB, 0.31798069E-06_JPRB, 0.31797907E-06_JPRB, 0.31798186E-06_JPRB, 0.31797990E-06_JPRB, &
  & 0.31798081E-06_JPRB, 0.31798132E-06_JPRB, 0.31798578E-06_JPRB, 0.31798780E-06_JPRB, 0.31798939E-06_JPRB, 0.31799368E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799561E-06_JPRB, 0.31799840E-06_JPRB, 0.31799988E-06_JPRB, 0.31800064E-06_JPRB, 0.31799865E-06_JPRB, &
  & 0.31799948E-06_JPRB, 0.31799809E-06_JPRB, 0.31799664E-06_JPRB, 0.31799613E-06_JPRB, 0.31799578E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799044E-06_JPRB, 0.31798851E-06_JPRB, 0.31798788E-06_JPRB, 0.31798740E-06_JPRB, 0.31798564E-06_JPRB, 0.31798524E-06_JPRB, &
  & 0.31798464E-06_JPRB, 0.31798677E-06_JPRB, 0.31798851E-06_JPRB, 0.31798868E-06_JPRB, 0.31799109E-06_JPRB, 0.31798959E-06_JPRB, &
  & 0.31798984E-06_JPRB, 0.31798945E-06_JPRB, 0.31798865E-06_JPRB, 0.31798936E-06_JPRB, 0.31798882E-06_JPRB, 0.31798407E-06_JPRB, &
  & 0.31798311E-06_JPRB, 0.31798359E-06_JPRB, 0.31798439E-06_JPRB, 0.31798248E-06_JPRB, 0.31798106E-06_JPRB, 0.31798146E-06_JPRB, &
  & 0.31798248E-06_JPRB, 0.31798064E-06_JPRB, 0.31797930E-06_JPRB, 0.31797018E-06_JPRB /)

RGHG3(:,79, 3) = (/ &
  & 0.31796654E-06_JPRB, 0.31797410E-06_JPRB, 0.31797865E-06_JPRB, 0.31797671E-06_JPRB, 0.31797967E-06_JPRB, 0.31798172E-06_JPRB, &
  & 0.31798413E-06_JPRB, 0.31798456E-06_JPRB, 0.31798606E-06_JPRB, 0.31798734E-06_JPRB, 0.31798757E-06_JPRB, 0.31798845E-06_JPRB, &
  & 0.31798999E-06_JPRB, 0.31798814E-06_JPRB, 0.31798629E-06_JPRB, 0.31798470E-06_JPRB, 0.31798831E-06_JPRB, 0.31798595E-06_JPRB, &
  & 0.31798669E-06_JPRB, 0.31798660E-06_JPRB, 0.31799104E-06_JPRB, 0.31799217E-06_JPRB, 0.31799280E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799462E-06_JPRB, 0.31799684E-06_JPRB, 0.31799956E-06_JPRB, 0.31800099E-06_JPRB, 0.31800181E-06_JPRB, 0.31799937E-06_JPRB, &
  & 0.31800064E-06_JPRB, 0.31799928E-06_JPRB, 0.31799806E-06_JPRB, 0.31799817E-06_JPRB, 0.31799871E-06_JPRB, 0.31799561E-06_JPRB, &
  & 0.31799439E-06_JPRB, 0.31799306E-06_JPRB, 0.31799317E-06_JPRB, 0.31799294E-06_JPRB, 0.31799098E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31798919E-06_JPRB, 0.31799121E-06_JPRB, 0.31799271E-06_JPRB, 0.31799220E-06_JPRB, 0.31799487E-06_JPRB, 0.31799266E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799274E-06_JPRB, 0.31799200E-06_JPRB, 0.31799325E-06_JPRB, 0.31799306E-06_JPRB, 0.31798754E-06_JPRB, &
  & 0.31798683E-06_JPRB, 0.31798766E-06_JPRB, 0.31798922E-06_JPRB, 0.31798720E-06_JPRB, 0.31798578E-06_JPRB, 0.31798643E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798641E-06_JPRB, 0.31798635E-06_JPRB, 0.31797958E-06_JPRB /)

RGHG3(:,80, 3) = (/ &
  & 0.31797700E-06_JPRB, 0.31797921E-06_JPRB, 0.31798288E-06_JPRB, 0.31797993E-06_JPRB, 0.31798294E-06_JPRB, 0.31798487E-06_JPRB, &
  & 0.31798731E-06_JPRB, 0.31798737E-06_JPRB, 0.31798911E-06_JPRB, 0.31799010E-06_JPRB, 0.31799041E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799090E-06_JPRB, 0.31798885E-06_JPRB, 0.31798709E-06_JPRB, 0.31799135E-06_JPRB, 0.31798868E-06_JPRB, &
  & 0.31798939E-06_JPRB, 0.31798885E-06_JPRB, 0.31799354E-06_JPRB, 0.31799425E-06_JPRB, 0.31799442E-06_JPRB, 0.31799803E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799732E-06_JPRB, 0.31800022E-06_JPRB, 0.31800164E-06_JPRB, 0.31800246E-06_JPRB, 0.31799973E-06_JPRB, &
  & 0.31800124E-06_JPRB, 0.31799982E-06_JPRB, 0.31799883E-06_JPRB, 0.31799931E-06_JPRB, 0.31800028E-06_JPRB, 0.31799729E-06_JPRB, &
  & 0.31799635E-06_JPRB, 0.31799533E-06_JPRB, 0.31799576E-06_JPRB, 0.31799570E-06_JPRB, 0.31799357E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31799325E-06_JPRB, 0.31799470E-06_JPRB, 0.31799385E-06_JPRB, 0.31799675E-06_JPRB, 0.31799416E-06_JPRB, &
  & 0.31799459E-06_JPRB, 0.31799419E-06_JPRB, 0.31799345E-06_JPRB, 0.31799505E-06_JPRB, 0.31799499E-06_JPRB, 0.31798879E-06_JPRB, &
  & 0.31798817E-06_JPRB, 0.31798933E-06_JPRB, 0.31799127E-06_JPRB, 0.31798911E-06_JPRB, 0.31798760E-06_JPRB, 0.31798857E-06_JPRB, &
  & 0.31799070E-06_JPRB, 0.31798899E-06_JPRB, 0.31798990E-06_JPRB, 0.31798587E-06_JPRB /)

RGHG3(:,81, 3) = (/ &
  & 0.31798444E-06_JPRB, 0.31798132E-06_JPRB, 0.31798464E-06_JPRB, 0.31798120E-06_JPRB, 0.31798433E-06_JPRB, 0.31798629E-06_JPRB, &
  & 0.31798874E-06_JPRB, 0.31798882E-06_JPRB, 0.31799013E-06_JPRB, 0.31799152E-06_JPRB, 0.31799161E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799439E-06_JPRB, 0.31799212E-06_JPRB, 0.31798996E-06_JPRB, 0.31798808E-06_JPRB, 0.31799274E-06_JPRB, 0.31798982E-06_JPRB, &
  & 0.31799055E-06_JPRB, 0.31798984E-06_JPRB, 0.31799473E-06_JPRB, 0.31799519E-06_JPRB, 0.31799505E-06_JPRB, 0.31799868E-06_JPRB, &
  & 0.31799550E-06_JPRB, 0.31799760E-06_JPRB, 0.31800050E-06_JPRB, 0.31800209E-06_JPRB, 0.31800298E-06_JPRB, 0.31800002E-06_JPRB, &
  & 0.31800167E-06_JPRB, 0.31800013E-06_JPRB, 0.31799919E-06_JPRB, 0.31799985E-06_JPRB, 0.31800101E-06_JPRB, 0.31799809E-06_JPRB, &
  & 0.31799732E-06_JPRB, 0.31799644E-06_JPRB, 0.31799706E-06_JPRB, 0.31799706E-06_JPRB, 0.31799482E-06_JPRB, 0.31799397E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799425E-06_JPRB, 0.31799559E-06_JPRB, 0.31799448E-06_JPRB, 0.31799760E-06_JPRB, 0.31799476E-06_JPRB, &
  & 0.31799524E-06_JPRB, 0.31799485E-06_JPRB, 0.31799414E-06_JPRB, 0.31799590E-06_JPRB, 0.31799590E-06_JPRB, 0.31798928E-06_JPRB, &
  & 0.31798868E-06_JPRB, 0.31798999E-06_JPRB, 0.31799215E-06_JPRB, 0.31798987E-06_JPRB, 0.31798837E-06_JPRB, 0.31798945E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799010E-06_JPRB, 0.31799144E-06_JPRB, 0.31799016E-06_JPRB /)

RGHG3(:,82, 3) = (/ &
  & 0.31798504E-06_JPRB, 0.31798197E-06_JPRB, 0.31798544E-06_JPRB, 0.31798177E-06_JPRB, 0.31798504E-06_JPRB, 0.31798683E-06_JPRB, &
  & 0.31798939E-06_JPRB, 0.31798925E-06_JPRB, 0.31799118E-06_JPRB, 0.31799203E-06_JPRB, 0.31799237E-06_JPRB, 0.31799317E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799277E-06_JPRB, 0.31799050E-06_JPRB, 0.31798857E-06_JPRB, 0.31799351E-06_JPRB, 0.31799041E-06_JPRB, &
  & 0.31799112E-06_JPRB, 0.31799030E-06_JPRB, 0.31799544E-06_JPRB, 0.31799567E-06_JPRB, 0.31799539E-06_JPRB, 0.31799902E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799775E-06_JPRB, 0.31800070E-06_JPRB, 0.31800235E-06_JPRB, 0.31800317E-06_JPRB, 0.31800010E-06_JPRB, &
  & 0.31800190E-06_JPRB, 0.31800030E-06_JPRB, 0.31799939E-06_JPRB, 0.31800019E-06_JPRB, 0.31800144E-06_JPRB, 0.31799851E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799706E-06_JPRB, 0.31799772E-06_JPRB, 0.31799777E-06_JPRB, 0.31799550E-06_JPRB, 0.31799456E-06_JPRB, &
  & 0.31799257E-06_JPRB, 0.31799476E-06_JPRB, 0.31799610E-06_JPRB, 0.31799479E-06_JPRB, 0.31799814E-06_JPRB, 0.31799507E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799513E-06_JPRB, 0.31799445E-06_JPRB, 0.31799630E-06_JPRB, 0.31799635E-06_JPRB, 0.31798945E-06_JPRB, &
  & 0.31798882E-06_JPRB, 0.31799027E-06_JPRB, 0.31799266E-06_JPRB, 0.31799021E-06_JPRB, 0.31798865E-06_JPRB, 0.31798982E-06_JPRB, &
  & 0.31799235E-06_JPRB, 0.31799058E-06_JPRB, 0.31799200E-06_JPRB, 0.31799053E-06_JPRB /)

RGHG3(:,83, 3) = (/ &
  & 0.31798547E-06_JPRB, 0.31798231E-06_JPRB, 0.31798589E-06_JPRB, 0.31798203E-06_JPRB, 0.31798538E-06_JPRB, 0.31798749E-06_JPRB, &
  & 0.31798976E-06_JPRB, 0.31798987E-06_JPRB, 0.31799098E-06_JPRB, 0.31799254E-06_JPRB, 0.31799266E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799314E-06_JPRB, 0.31799078E-06_JPRB, 0.31798879E-06_JPRB, 0.31799394E-06_JPRB, 0.31799067E-06_JPRB, &
  & 0.31799144E-06_JPRB, 0.31799050E-06_JPRB, 0.31799581E-06_JPRB, 0.31799595E-06_JPRB, 0.31799559E-06_JPRB, 0.31799928E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799780E-06_JPRB, 0.31800090E-06_JPRB, 0.31800255E-06_JPRB, 0.31800343E-06_JPRB, 0.31800013E-06_JPRB, &
  & 0.31800207E-06_JPRB, 0.31800039E-06_JPRB, 0.31799951E-06_JPRB, 0.31800036E-06_JPRB, 0.31800161E-06_JPRB, 0.31799885E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799749E-06_JPRB, 0.31799817E-06_JPRB, 0.31799831E-06_JPRB, 0.31799601E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799289E-06_JPRB, 0.31799510E-06_JPRB, 0.31799641E-06_JPRB, 0.31799499E-06_JPRB, 0.31799851E-06_JPRB, 0.31799527E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799533E-06_JPRB, 0.31799456E-06_JPRB, 0.31799652E-06_JPRB, 0.31799669E-06_JPRB, 0.31798942E-06_JPRB, &
  & 0.31798882E-06_JPRB, 0.31799041E-06_JPRB, 0.31799286E-06_JPRB, 0.31799038E-06_JPRB, 0.31798879E-06_JPRB, 0.31799007E-06_JPRB, &
  & 0.31799269E-06_JPRB, 0.31799087E-06_JPRB, 0.31799237E-06_JPRB, 0.31799081E-06_JPRB /)

RGHG3(:,84, 3) = (/ &
  & 0.31798572E-06_JPRB, 0.31798245E-06_JPRB, 0.31798618E-06_JPRB, 0.31798220E-06_JPRB, 0.31798561E-06_JPRB, 0.31798746E-06_JPRB, &
  & 0.31799010E-06_JPRB, 0.31798999E-06_JPRB, 0.31799192E-06_JPRB, 0.31799266E-06_JPRB, 0.31799314E-06_JPRB, 0.31799394E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799348E-06_JPRB, 0.31799109E-06_JPRB, 0.31798902E-06_JPRB, 0.31799422E-06_JPRB, 0.31799090E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799073E-06_JPRB, 0.31799607E-06_JPRB, 0.31799618E-06_JPRB, 0.31799573E-06_JPRB, 0.31799954E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799786E-06_JPRB, 0.31800107E-06_JPRB, 0.31800275E-06_JPRB, 0.31800360E-06_JPRB, 0.31800019E-06_JPRB, &
  & 0.31800215E-06_JPRB, 0.31800047E-06_JPRB, 0.31799956E-06_JPRB, 0.31800050E-06_JPRB, 0.31800167E-06_JPRB, 0.31799911E-06_JPRB, &
  & 0.31799840E-06_JPRB, 0.31799783E-06_JPRB, 0.31799843E-06_JPRB, 0.31799851E-06_JPRB, 0.31799635E-06_JPRB, 0.31799522E-06_JPRB, &
  & 0.31799314E-06_JPRB, 0.31799530E-06_JPRB, 0.31799664E-06_JPRB, 0.31799510E-06_JPRB, 0.31799877E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799541E-06_JPRB, 0.31799465E-06_JPRB, 0.31799672E-06_JPRB, 0.31799689E-06_JPRB, 0.31798942E-06_JPRB, &
  & 0.31798879E-06_JPRB, 0.31799041E-06_JPRB, 0.31799303E-06_JPRB, 0.31799050E-06_JPRB, 0.31798885E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799286E-06_JPRB, 0.31799107E-06_JPRB, 0.31799260E-06_JPRB, 0.31799095E-06_JPRB /)

RGHG3(:,85, 3) = (/ &
  & 0.31798587E-06_JPRB, 0.31798260E-06_JPRB, 0.31798632E-06_JPRB, 0.31798226E-06_JPRB, 0.31798569E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31799016E-06_JPRB, 0.31799055E-06_JPRB, 0.31799155E-06_JPRB, 0.31799297E-06_JPRB, 0.31799328E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799354E-06_JPRB, 0.31799129E-06_JPRB, 0.31798930E-06_JPRB, 0.31799428E-06_JPRB, 0.31799104E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799073E-06_JPRB, 0.31799630E-06_JPRB, 0.31799638E-06_JPRB, 0.31799578E-06_JPRB, 0.31799973E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799780E-06_JPRB, 0.31800110E-06_JPRB, 0.31800283E-06_JPRB, 0.31800374E-06_JPRB, 0.31800016E-06_JPRB, &
  & 0.31800229E-06_JPRB, 0.31800056E-06_JPRB, 0.31799971E-06_JPRB, 0.31800067E-06_JPRB, 0.31800178E-06_JPRB, 0.31799925E-06_JPRB, &
  & 0.31799857E-06_JPRB, 0.31799806E-06_JPRB, 0.31799871E-06_JPRB, 0.31799874E-06_JPRB, 0.31799658E-06_JPRB, 0.31799547E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799547E-06_JPRB, 0.31799681E-06_JPRB, 0.31799519E-06_JPRB, 0.31799900E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799547E-06_JPRB, 0.31799470E-06_JPRB, 0.31799686E-06_JPRB, 0.31799709E-06_JPRB, 0.31798939E-06_JPRB, &
  & 0.31798871E-06_JPRB, 0.31799044E-06_JPRB, 0.31799311E-06_JPRB, 0.31799055E-06_JPRB, 0.31798885E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799115E-06_JPRB, 0.31799274E-06_JPRB, 0.31799112E-06_JPRB /)

RGHG3(:,86, 3) = (/ &
  & 0.31798598E-06_JPRB, 0.31798257E-06_JPRB, 0.31798646E-06_JPRB, 0.31798226E-06_JPRB, 0.31798601E-06_JPRB, 0.31798783E-06_JPRB, &
  & 0.31799050E-06_JPRB, 0.31799067E-06_JPRB, 0.31799215E-06_JPRB, 0.31799291E-06_JPRB, 0.31799345E-06_JPRB, 0.31799414E-06_JPRB, &
  & 0.31799505E-06_JPRB, 0.31799362E-06_JPRB, 0.31799158E-06_JPRB, 0.31798984E-06_JPRB, 0.31799419E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31799195E-06_JPRB, 0.31799078E-06_JPRB, 0.31799644E-06_JPRB, 0.31799641E-06_JPRB, 0.31799581E-06_JPRB, 0.31799993E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799777E-06_JPRB, 0.31800113E-06_JPRB, 0.31800292E-06_JPRB, 0.31800383E-06_JPRB, 0.31800022E-06_JPRB, &
  & 0.31800232E-06_JPRB, 0.31800050E-06_JPRB, 0.31799971E-06_JPRB, 0.31800062E-06_JPRB, 0.31800181E-06_JPRB, 0.31799939E-06_JPRB, &
  & 0.31799868E-06_JPRB, 0.31799823E-06_JPRB, 0.31799891E-06_JPRB, 0.31799891E-06_JPRB, 0.31799681E-06_JPRB, 0.31799556E-06_JPRB, &
  & 0.31799348E-06_JPRB, 0.31799564E-06_JPRB, 0.31799692E-06_JPRB, 0.31799524E-06_JPRB, 0.31799917E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799547E-06_JPRB, 0.31799468E-06_JPRB, 0.31799695E-06_JPRB, 0.31799718E-06_JPRB, 0.31798933E-06_JPRB, &
  & 0.31798859E-06_JPRB, 0.31799044E-06_JPRB, 0.31799323E-06_JPRB, 0.31799055E-06_JPRB, 0.31798882E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799308E-06_JPRB, 0.31799124E-06_JPRB, 0.31799277E-06_JPRB, 0.31799118E-06_JPRB /)

RGHG3(:,87, 3) = (/ &
  & 0.31798601E-06_JPRB, 0.31798257E-06_JPRB, 0.31798652E-06_JPRB, 0.31798243E-06_JPRB, 0.31798592E-06_JPRB, 0.31798865E-06_JPRB, &
  & 0.31799030E-06_JPRB, 0.31799101E-06_JPRB, 0.31799192E-06_JPRB, 0.31799294E-06_JPRB, 0.31799334E-06_JPRB, 0.31799399E-06_JPRB, &
  & 0.31799465E-06_JPRB, 0.31799348E-06_JPRB, 0.31799175E-06_JPRB, 0.31799033E-06_JPRB, 0.31799405E-06_JPRB, 0.31799138E-06_JPRB, &
  & 0.31799200E-06_JPRB, 0.31799073E-06_JPRB, 0.31799655E-06_JPRB, 0.31799655E-06_JPRB, 0.31799573E-06_JPRB, 0.31800013E-06_JPRB, &
  & 0.31799522E-06_JPRB, 0.31799775E-06_JPRB, 0.31800116E-06_JPRB, 0.31800300E-06_JPRB, 0.31800397E-06_JPRB, 0.31800022E-06_JPRB, &
  & 0.31800244E-06_JPRB, 0.31800056E-06_JPRB, 0.31799968E-06_JPRB, 0.31800073E-06_JPRB, 0.31800204E-06_JPRB, 0.31799937E-06_JPRB, &
  & 0.31799874E-06_JPRB, 0.31799823E-06_JPRB, 0.31799908E-06_JPRB, 0.31799931E-06_JPRB, 0.31799678E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799328E-06_JPRB, 0.31799573E-06_JPRB, 0.31799706E-06_JPRB, 0.31799524E-06_JPRB, 0.31799931E-06_JPRB, 0.31799547E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799544E-06_JPRB, 0.31799468E-06_JPRB, 0.31799698E-06_JPRB, 0.31799721E-06_JPRB, 0.31798919E-06_JPRB, &
  & 0.31798854E-06_JPRB, 0.31799044E-06_JPRB, 0.31799328E-06_JPRB, 0.31799050E-06_JPRB, 0.31798874E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799308E-06_JPRB, 0.31799127E-06_JPRB, 0.31799283E-06_JPRB, 0.31799127E-06_JPRB /)

RGHG3(:,88, 3) = (/ &
  & 0.31798601E-06_JPRB, 0.31798265E-06_JPRB, 0.31798643E-06_JPRB, 0.31798237E-06_JPRB, 0.31798632E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31799095E-06_JPRB, 0.31799220E-06_JPRB, 0.31799294E-06_JPRB, 0.31799340E-06_JPRB, 0.31799402E-06_JPRB, &
  & 0.31799465E-06_JPRB, 0.31799357E-06_JPRB, 0.31799186E-06_JPRB, 0.31799050E-06_JPRB, 0.31799402E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31799078E-06_JPRB, 0.31799661E-06_JPRB, 0.31799667E-06_JPRB, 0.31799570E-06_JPRB, 0.31800033E-06_JPRB, &
  & 0.31799507E-06_JPRB, 0.31799763E-06_JPRB, 0.31800118E-06_JPRB, 0.31800306E-06_JPRB, 0.31800414E-06_JPRB, 0.31800019E-06_JPRB, &
  & 0.31800255E-06_JPRB, 0.31800053E-06_JPRB, 0.31799971E-06_JPRB, 0.31800070E-06_JPRB, 0.31800229E-06_JPRB, 0.31799934E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799817E-06_JPRB, 0.31799925E-06_JPRB, 0.31799959E-06_JPRB, 0.31799686E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799587E-06_JPRB, 0.31799721E-06_JPRB, 0.31799527E-06_JPRB, 0.31799945E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799581E-06_JPRB, 0.31799544E-06_JPRB, 0.31799468E-06_JPRB, 0.31799703E-06_JPRB, 0.31799718E-06_JPRB, 0.31798908E-06_JPRB, &
  & 0.31798837E-06_JPRB, 0.31799044E-06_JPRB, 0.31799334E-06_JPRB, 0.31799050E-06_JPRB, 0.31798874E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799129E-06_JPRB, 0.31799289E-06_JPRB, 0.31799135E-06_JPRB /)

RGHG3(:,89, 3) = (/ &
  & 0.31798595E-06_JPRB, 0.31798285E-06_JPRB, 0.31798641E-06_JPRB, 0.31798248E-06_JPRB, 0.31798587E-06_JPRB, 0.31798874E-06_JPRB, &
  & 0.31799041E-06_JPRB, 0.31799107E-06_JPRB, 0.31799200E-06_JPRB, 0.31799297E-06_JPRB, 0.31799340E-06_JPRB, 0.31799408E-06_JPRB, &
  & 0.31799479E-06_JPRB, 0.31799362E-06_JPRB, 0.31799175E-06_JPRB, 0.31799027E-06_JPRB, 0.31799422E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799067E-06_JPRB, 0.31799672E-06_JPRB, 0.31799669E-06_JPRB, 0.31799564E-06_JPRB, 0.31800050E-06_JPRB, &
  & 0.31799493E-06_JPRB, 0.31799757E-06_JPRB, 0.31800121E-06_JPRB, 0.31800315E-06_JPRB, 0.31800428E-06_JPRB, 0.31800013E-06_JPRB, &
  & 0.31800269E-06_JPRB, 0.31800056E-06_JPRB, 0.31799965E-06_JPRB, 0.31800070E-06_JPRB, 0.31800263E-06_JPRB, 0.31799917E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799809E-06_JPRB, 0.31799945E-06_JPRB, 0.31799999E-06_JPRB, 0.31799675E-06_JPRB, 0.31799576E-06_JPRB, &
  & 0.31799289E-06_JPRB, 0.31799604E-06_JPRB, 0.31799732E-06_JPRB, 0.31799522E-06_JPRB, 0.31799959E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799544E-06_JPRB, 0.31799465E-06_JPRB, 0.31799701E-06_JPRB, 0.31799732E-06_JPRB, 0.31798899E-06_JPRB, &
  & 0.31798839E-06_JPRB, 0.31799053E-06_JPRB, 0.31799345E-06_JPRB, 0.31799050E-06_JPRB, 0.31798874E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31799135E-06_JPRB, 0.31799286E-06_JPRB, 0.31799132E-06_JPRB /)

RGHG3(:,90, 3) = (/ &
  & 0.31798589E-06_JPRB, 0.31798299E-06_JPRB, 0.31798632E-06_JPRB, 0.31798220E-06_JPRB, 0.31798604E-06_JPRB, 0.31798794E-06_JPRB, &
  & 0.31799070E-06_JPRB, 0.31799073E-06_JPRB, 0.31799212E-06_JPRB, 0.31799311E-06_JPRB, 0.31799354E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799385E-06_JPRB, 0.31799146E-06_JPRB, 0.31798967E-06_JPRB, 0.31799485E-06_JPRB, 0.31799132E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799041E-06_JPRB, 0.31799686E-06_JPRB, 0.31799669E-06_JPRB, 0.31799544E-06_JPRB, 0.31800082E-06_JPRB, &
  & 0.31799468E-06_JPRB, 0.31799760E-06_JPRB, 0.31800124E-06_JPRB, 0.31800320E-06_JPRB, 0.31800442E-06_JPRB, 0.31799993E-06_JPRB, &
  & 0.31800283E-06_JPRB, 0.31800045E-06_JPRB, 0.31799948E-06_JPRB, 0.31800073E-06_JPRB, 0.31800303E-06_JPRB, 0.31799905E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799797E-06_JPRB, 0.31799956E-06_JPRB, 0.31800028E-06_JPRB, 0.31799667E-06_JPRB, 0.31799584E-06_JPRB, &
  & 0.31799263E-06_JPRB, 0.31799613E-06_JPRB, 0.31799749E-06_JPRB, 0.31799513E-06_JPRB, 0.31799991E-06_JPRB, 0.31799533E-06_JPRB, &
  & 0.31799581E-06_JPRB, 0.31799547E-06_JPRB, 0.31799459E-06_JPRB, 0.31799709E-06_JPRB, 0.31799749E-06_JPRB, 0.31798874E-06_JPRB, &
  & 0.31798822E-06_JPRB, 0.31799055E-06_JPRB, 0.31799362E-06_JPRB, 0.31799053E-06_JPRB, 0.31798862E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799127E-06_JPRB, 0.31799300E-06_JPRB, 0.31799138E-06_JPRB /)

RGHG3(:,91, 3) = (/ &
  & 0.31798592E-06_JPRB, 0.31798322E-06_JPRB, 0.31798677E-06_JPRB, 0.31798143E-06_JPRB, 0.31798589E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31799112E-06_JPRB, 0.31798970E-06_JPRB, 0.31799181E-06_JPRB, 0.31799377E-06_JPRB, 0.31799308E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799755E-06_JPRB, 0.31799391E-06_JPRB, 0.31799098E-06_JPRB, 0.31798808E-06_JPRB, 0.31799627E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31799243E-06_JPRB, 0.31798990E-06_JPRB, 0.31799735E-06_JPRB, 0.31799686E-06_JPRB, 0.31799505E-06_JPRB, 0.31800155E-06_JPRB, &
  & 0.31799411E-06_JPRB, 0.31799749E-06_JPRB, 0.31800138E-06_JPRB, 0.31800329E-06_JPRB, 0.31800496E-06_JPRB, 0.31799934E-06_JPRB, &
  & 0.31800332E-06_JPRB, 0.31800039E-06_JPRB, 0.31799925E-06_JPRB, 0.31800062E-06_JPRB, 0.31800360E-06_JPRB, 0.31799865E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799777E-06_JPRB, 0.31799968E-06_JPRB, 0.31800070E-06_JPRB, 0.31799649E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799632E-06_JPRB, 0.31799772E-06_JPRB, 0.31799465E-06_JPRB, 0.31800047E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799550E-06_JPRB, 0.31799439E-06_JPRB, 0.31799721E-06_JPRB, 0.31799809E-06_JPRB, 0.31798808E-06_JPRB, &
  & 0.31798808E-06_JPRB, 0.31799053E-06_JPRB, 0.31799405E-06_JPRB, 0.31799041E-06_JPRB, 0.31798837E-06_JPRB, 0.31798999E-06_JPRB, &
  & 0.31799377E-06_JPRB, 0.31799098E-06_JPRB, 0.31799308E-06_JPRB, 0.31799135E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG3(:, 1, 4) = (/ &
  & 0.93011700E-07_JPRB, 0.93122729E-07_JPRB, 0.93222866E-07_JPRB, 0.93398377E-07_JPRB, 0.93579061E-07_JPRB, 0.93743452E-07_JPRB, &
  & 0.93875308E-07_JPRB, 0.93970520E-07_JPRB, 0.94038583E-07_JPRB, 0.94087873E-07_JPRB, 0.94117638E-07_JPRB, 0.94125660E-07_JPRB, &
  & 0.94118171E-07_JPRB, 0.94108415E-07_JPRB, 0.94105253E-07_JPRB, 0.94107897E-07_JPRB, 0.94111670E-07_JPRB, 0.94114590E-07_JPRB, &
  & 0.94117475E-07_JPRB, 0.94122527E-07_JPRB, 0.94133249E-07_JPRB, 0.94156150E-07_JPRB, 0.94205468E-07_JPRB, 0.94312853E-07_JPRB, &
  & 0.94603131E-07_JPRB, 0.95152522E-07_JPRB, 0.95784863E-07_JPRB, 0.96443380E-07_JPRB, 0.97116342E-07_JPRB, 0.97776542E-07_JPRB, &
  & 0.98391631E-07_JPRB, 0.98945890E-07_JPRB, 0.99455228E-07_JPRB, 0.99900447E-07_JPRB, 0.10025754E-06_JPRB, 0.10052432E-06_JPRB, &
  & 0.10068316E-06_JPRB, 0.10071323E-06_JPRB, 0.10062428E-06_JPRB, 0.10042161E-06_JPRB, 0.10024468E-06_JPRB, 0.10003531E-06_JPRB, &
  & 0.99802868E-07_JPRB, 0.99541865E-07_JPRB, 0.99244858E-07_JPRB, 0.98903968E-07_JPRB, 0.98513723E-07_JPRB, 0.98063310E-07_JPRB, &
  & 0.97532698E-07_JPRB, 0.96918214E-07_JPRB, 0.96269495E-07_JPRB, 0.95614610E-07_JPRB, 0.94959759E-07_JPRB, 0.94316661E-07_JPRB, &
  & 0.93706745E-07_JPRB, 0.93163479E-07_JPRB, 0.92715169E-07_JPRB, 0.92373867E-07_JPRB, 0.92134144E-07_JPRB, 0.91980418E-07_JPRB, &
  & 0.91853096E-07_JPRB, 0.91722484E-07_JPRB, 0.91586159E-07_JPRB, 0.91431694E-07_JPRB /)

RGHG3(:, 2, 4) = (/ &
  & 0.93267914E-07_JPRB, 0.93539100E-07_JPRB, 0.93727017E-07_JPRB, 0.93919439E-07_JPRB, 0.94083660E-07_JPRB, 0.94197858E-07_JPRB, &
  & 0.94256698E-07_JPRB, 0.94267399E-07_JPRB, 0.94245735E-07_JPRB, 0.94215324E-07_JPRB, 0.94205689E-07_JPRB, 0.94235865E-07_JPRB, &
  & 0.94299210E-07_JPRB, 0.94374116E-07_JPRB, 0.94447962E-07_JPRB, 0.94523294E-07_JPRB, 0.94605355E-07_JPRB, 0.94694869E-07_JPRB, &
  & 0.94790622E-07_JPRB, 0.94893451E-07_JPRB, 0.95008559E-07_JPRB, 0.95148586E-07_JPRB, 0.95333036E-07_JPRB, 0.95594856E-07_JPRB, &
  & 0.95975842E-07_JPRB, 0.96494674E-07_JPRB, 0.97113457E-07_JPRB, 0.97817939E-07_JPRB, 0.98609128E-07_JPRB, 0.99474882E-07_JPRB, &
  & 0.10037868E-06_JPRB, 0.10127595E-06_JPRB, 0.10213705E-06_JPRB, 0.10290373E-06_JPRB, 0.10354983E-06_JPRB, 0.10405765E-06_JPRB, &
  & 0.10441732E-06_JPRB, 0.10460182E-06_JPRB, 0.10456900E-06_JPRB, 0.10433166E-06_JPRB, 0.10396175E-06_JPRB, 0.10350002E-06_JPRB, &
  & 0.10296599E-06_JPRB, 0.10237179E-06_JPRB, 0.10171312E-06_JPRB, 0.10099295E-06_JPRB, 0.10021230E-06_JPRB, 0.99379847E-07_JPRB, &
  & 0.98502106E-07_JPRB, 0.97620401E-07_JPRB, 0.96785762E-07_JPRB, 0.95997528E-07_JPRB, 0.95232146E-07_JPRB, 0.94481408E-07_JPRB, &
  & 0.93745271E-07_JPRB, 0.93050090E-07_JPRB, 0.92410303E-07_JPRB, 0.91866418E-07_JPRB, 0.91425406E-07_JPRB, 0.91065949E-07_JPRB, &
  & 0.90770207E-07_JPRB, 0.90498951E-07_JPRB, 0.90242672E-07_JPRB, 0.89959947E-07_JPRB /)

RGHG3(:, 3, 4) = (/ &
  & 0.93441585E-07_JPRB, 0.93673613E-07_JPRB, 0.93807742E-07_JPRB, 0.93922282E-07_JPRB, 0.94015981E-07_JPRB, 0.94081358E-07_JPRB, &
  & 0.94140930E-07_JPRB, 0.94215260E-07_JPRB, 0.94311517E-07_JPRB, 0.94422703E-07_JPRB, 0.94538976E-07_JPRB, 0.94659363E-07_JPRB, &
  & 0.94794515E-07_JPRB, 0.94960740E-07_JPRB, 0.95163948E-07_JPRB, 0.95401106E-07_JPRB, 0.95666657E-07_JPRB, 0.95950938E-07_JPRB, &
  & 0.96242339E-07_JPRB, 0.96535715E-07_JPRB, 0.96834498E-07_JPRB, 0.97155734E-07_JPRB, 0.97522225E-07_JPRB, 0.97957823E-07_JPRB, &
  & 0.98484392E-07_JPRB, 0.99092873E-07_JPRB, 0.99781339E-07_JPRB, 0.10055163E-06_JPRB, 0.10143165E-06_JPRB, 0.10245610E-06_JPRB, &
  & 0.10362366E-06_JPRB, 0.10485629E-06_JPRB, 0.10601769E-06_JPRB, 0.10703179E-06_JPRB, 0.10784396E-06_JPRB, 0.10846598E-06_JPRB, &
  & 0.10889817E-06_JPRB, 0.10910902E-06_JPRB, 0.10906111E-06_JPRB, 0.10871485E-06_JPRB, 0.10809209E-06_JPRB, 0.10727396E-06_JPRB, &
  & 0.10633156E-06_JPRB, 0.10527040E-06_JPRB, 0.10411881E-06_JPRB, 0.10290331E-06_JPRB, 0.10166166E-06_JPRB, 0.10042655E-06_JPRB, &
  & 0.99223072E-07_JPRB, 0.98099747E-07_JPRB, 0.97064827E-07_JPRB, 0.96100678E-07_JPRB, 0.95194707E-07_JPRB, 0.94333956E-07_JPRB, &
  & 0.93508689E-07_JPRB, 0.92700901E-07_JPRB, 0.91933472E-07_JPRB, 0.91243152E-07_JPRB, 0.90663590E-07_JPRB, 0.90173714E-07_JPRB, &
  & 0.89783306E-07_JPRB, 0.89444789E-07_JPRB, 0.89136002E-07_JPRB, 0.88780830E-07_JPRB /)

RGHG3(:, 4, 4) = (/ &
  & 0.93438260E-07_JPRB, 0.93563855E-07_JPRB, 0.93642036E-07_JPRB, 0.93734783E-07_JPRB, 0.93844008E-07_JPRB, 0.93965241E-07_JPRB, &
  & 0.94102347E-07_JPRB, 0.94241429E-07_JPRB, 0.94388113E-07_JPRB, 0.94560164E-07_JPRB, 0.94769348E-07_JPRB, 0.95017619E-07_JPRB, &
  & 0.95307378E-07_JPRB, 0.95649561E-07_JPRB, 0.96065449E-07_JPRB, 0.96575924E-07_JPRB, 0.97188575E-07_JPRB, 0.97901967E-07_JPRB, &
  & 0.98709108E-07_JPRB, 0.99597273E-07_JPRB, 0.10055489E-06_JPRB, 0.10157433E-06_JPRB, 0.10266128E-06_JPRB, 0.10382817E-06_JPRB, &
  & 0.10505026E-06_JPRB, 0.10630572E-06_JPRB, 0.10756727E-06_JPRB, 0.10885502E-06_JPRB, 0.11015972E-06_JPRB, 0.11142412E-06_JPRB, &
  & 0.11255331E-06_JPRB, 0.11345379E-06_JPRB, 0.11410496E-06_JPRB, 0.11454139E-06_JPRB, 0.11482593E-06_JPRB, 0.11497412E-06_JPRB, &
  & 0.11497912E-06_JPRB, 0.11480346E-06_JPRB, 0.11438536E-06_JPRB, 0.11365190E-06_JPRB, 0.11255263E-06_JPRB, 0.11112578E-06_JPRB, &
  & 0.10948278E-06_JPRB, 0.10774733E-06_JPRB, 0.10597333E-06_JPRB, 0.10420829E-06_JPRB, 0.10249841E-06_JPRB, 0.10093574E-06_JPRB, &
  & 0.99538980E-07_JPRB, 0.98290634E-07_JPRB, 0.97174969E-07_JPRB, 0.96173324E-07_JPRB, 0.95261782E-07_JPRB, 0.94417537E-07_JPRB, &
  & 0.93615185E-07_JPRB, 0.92853384E-07_JPRB, 0.92126299E-07_JPRB, 0.91456450E-07_JPRB, 0.90859743E-07_JPRB, 0.90326438E-07_JPRB, &
  & 0.89893675E-07_JPRB, 0.89519759E-07_JPRB, 0.89198643E-07_JPRB, 0.88827711E-07_JPRB /)

RGHG3(:, 5, 4) = (/ &
  & 0.93238562E-07_JPRB, 0.93182429E-07_JPRB, 0.93194558E-07_JPRB, 0.93267595E-07_JPRB, 0.93387257E-07_JPRB, 0.93532300E-07_JPRB, &
  & 0.93724509E-07_JPRB, 0.93975480E-07_JPRB, 0.94280573E-07_JPRB, 0.94643980E-07_JPRB, 0.95083635E-07_JPRB, 0.95620464E-07_JPRB, &
  & 0.96264422E-07_JPRB, 0.97024824E-07_JPRB, 0.97918658E-07_JPRB, 0.98969224E-07_JPRB, 0.10020241E-06_JPRB, 0.10164664E-06_JPRB, &
  & 0.10332108E-06_JPRB, 0.10522707E-06_JPRB, 0.10733724E-06_JPRB, 0.10961019E-06_JPRB, 0.11196921E-06_JPRB, 0.11430996E-06_JPRB, &
  & 0.11651829E-06_JPRB, 0.11851061E-06_JPRB, 0.12029386E-06_JPRB, 0.12184880E-06_JPRB, 0.12314582E-06_JPRB, 0.12410521E-06_JPRB, &
  & 0.12465019E-06_JPRB, 0.12472644E-06_JPRB, 0.12441365E-06_JPRB, 0.12387289E-06_JPRB, 0.12322269E-06_JPRB, 0.12252494E-06_JPRB, &
  & 0.12177429E-06_JPRB, 0.12091019E-06_JPRB, 0.11983485E-06_JPRB, 0.11846480E-06_JPRB, 0.11674070E-06_JPRB, 0.11473064E-06_JPRB, &
  & 0.11249813E-06_JPRB, 0.11008810E-06_JPRB, 0.10768816E-06_JPRB, 0.10545773E-06_JPRB, 0.10349160E-06_JPRB, 0.10176561E-06_JPRB, &
  & 0.10029054E-06_JPRB, 0.99002378E-07_JPRB, 0.97854873E-07_JPRB, 0.96824579E-07_JPRB, 0.95885333E-07_JPRB, 0.95018372E-07_JPRB, &
  & 0.94212474E-07_JPRB, 0.93461431E-07_JPRB, 0.92763820E-07_JPRB, 0.92126392E-07_JPRB, 0.91550334E-07_JPRB, 0.91047816E-07_JPRB, &
  & 0.90639183E-07_JPRB, 0.90296972E-07_JPRB, 0.89985420E-07_JPRB, 0.89565710E-07_JPRB /)

RGHG3(:, 6, 4) = (/ &
  & 0.92785967E-07_JPRB, 0.92507385E-07_JPRB, 0.92468625E-07_JPRB, 0.92551879E-07_JPRB, 0.92733899E-07_JPRB, 0.92994469E-07_JPRB, &
  & 0.93347687E-07_JPRB, 0.93803678E-07_JPRB, 0.94368012E-07_JPRB, 0.95038558E-07_JPRB, 0.95820603E-07_JPRB, 0.96726048E-07_JPRB, &
  & 0.97770020E-07_JPRB, 0.98968634E-07_JPRB, 0.10034465E-06_JPRB, 0.10193212E-06_JPRB, 0.10376638E-06_JPRB, 0.10586508E-06_JPRB, &
  & 0.10822238E-06_JPRB, 0.11078924E-06_JPRB, 0.11351142E-06_JPRB, 0.11635269E-06_JPRB, 0.11926736E-06_JPRB, 0.12215435E-06_JPRB, &
  & 0.12484789E-06_JPRB, 0.12724027E-06_JPRB, 0.12930983E-06_JPRB, 0.13104909E-06_JPRB, 0.13242027E-06_JPRB, 0.13334062E-06_JPRB, &
  & 0.13372500E-06_JPRB, 0.13352525E-06_JPRB, 0.13282003E-06_JPRB, 0.13177898E-06_JPRB, 0.13055572E-06_JPRB, 0.12924990E-06_JPRB, &
  & 0.12787773E-06_JPRB, 0.12639400E-06_JPRB, 0.12472159E-06_JPRB, 0.12277097E-06_JPRB, 0.12048878E-06_JPRB, 0.11785838E-06_JPRB, &
  & 0.11507919E-06_JPRB, 0.11245068E-06_JPRB, 0.11009313E-06_JPRB, 0.10791182E-06_JPRB, 0.10588564E-06_JPRB, 0.10409062E-06_JPRB, &
  & 0.10253691E-06_JPRB, 0.10117613E-06_JPRB, 0.99951272E-07_JPRB, 0.98820408E-07_JPRB, 0.97763113E-07_JPRB, 0.96778862E-07_JPRB, &
  & 0.95866376E-07_JPRB, 0.95028220E-07_JPRB, 0.94265182E-07_JPRB, 0.93575814E-07_JPRB, 0.92976421E-07_JPRB, 0.92462834E-07_JPRB, &
  & 0.92065946E-07_JPRB, 0.91742145E-07_JPRB, 0.91455327E-07_JPRB, 0.91065431E-07_JPRB /)

RGHG3(:, 7, 4) = (/ &
  & 0.92142677E-07_JPRB, 0.91888609E-07_JPRB, 0.91993236E-07_JPRB, 0.92264607E-07_JPRB, 0.92670540E-07_JPRB, 0.93189165E-07_JPRB, &
  & 0.93819629E-07_JPRB, 0.94570531E-07_JPRB, 0.95437223E-07_JPRB, 0.96421417E-07_JPRB, 0.97518040E-07_JPRB, 0.98722388E-07_JPRB, &
  & 0.10002974E-06_JPRB, 0.10144004E-06_JPRB, 0.10296474E-06_JPRB, 0.10463533E-06_JPRB, 0.10649451E-06_JPRB, 0.10860024E-06_JPRB, &
  & 0.11098844E-06_JPRB, 0.11366642E-06_JPRB, 0.11658570E-06_JPRB, 0.11965369E-06_JPRB, 0.12283071E-06_JPRB, 0.12609485E-06_JPRB, &
  & 0.12928916E-06_JPRB, 0.13223514E-06_JPRB, 0.13482214E-06_JPRB, 0.13701326E-06_JPRB, 0.13872915E-06_JPRB, 0.13989091E-06_JPRB, &
  & 0.14039601E-06_JPRB, 0.14021060E-06_JPRB, 0.13940092E-06_JPRB, 0.13814908E-06_JPRB, 0.13661099E-06_JPRB, 0.13489412E-06_JPRB, &
  & 0.13305754E-06_JPRB, 0.13108109E-06_JPRB, 0.12889132E-06_JPRB, 0.12644664E-06_JPRB, 0.12377893E-06_JPRB, 0.12107341E-06_JPRB, &
  & 0.11839980E-06_JPRB, 0.11574910E-06_JPRB, 0.11317766E-06_JPRB, 0.11089703E-06_JPRB, 0.10900256E-06_JPRB, 0.10734902E-06_JPRB, &
  & 0.10582343E-06_JPRB, 0.10440746E-06_JPRB, 0.10308935E-06_JPRB, 0.10184786E-06_JPRB, 0.10066874E-06_JPRB, 0.99551443E-07_JPRB, &
  & 0.98503961E-07_JPRB, 0.97539449E-07_JPRB, 0.96669268E-07_JPRB, 0.95906238E-07_JPRB, 0.95250876E-07_JPRB, 0.94713386E-07_JPRB, &
  & 0.94313890E-07_JPRB, 0.94011334E-07_JPRB, 0.93742109E-07_JPRB, 0.93356462E-07_JPRB /)

RGHG3(:, 8, 4) = (/ &
  & 0.91741356E-07_JPRB, 0.92065044E-07_JPRB, 0.92606548E-07_JPRB, 0.93287369E-07_JPRB, 0.94109353E-07_JPRB, 0.95058475E-07_JPRB, &
  & 0.96125362E-07_JPRB, 0.97305360E-07_JPRB, 0.98592466E-07_JPRB, 0.99971075E-07_JPRB, 0.10141797E-06_JPRB, 0.10289791E-06_JPRB, &
  & 0.10438035E-06_JPRB, 0.10585181E-06_JPRB, 0.10733549E-06_JPRB, 0.10887773E-06_JPRB, 0.11054912E-06_JPRB, 0.11240763E-06_JPRB, &
  & 0.11451755E-06_JPRB, 0.11693010E-06_JPRB, 0.11970167E-06_JPRB, 0.12283613E-06_JPRB, 0.12622871E-06_JPRB, 0.12975589E-06_JPRB, &
  & 0.13337238E-06_JPRB, 0.13681390E-06_JPRB, 0.13990112E-06_JPRB, 0.14247557E-06_JPRB, 0.14446950E-06_JPRB, 0.14577090E-06_JPRB, &
  & 0.14630821E-06_JPRB, 0.14607829E-06_JPRB, 0.14518781E-06_JPRB, 0.14376104E-06_JPRB, 0.14198166E-06_JPRB, 0.13998091E-06_JPRB, &
  & 0.13778151E-06_JPRB, 0.13539183E-06_JPRB, 0.13284043E-06_JPRB, 0.13015956E-06_JPRB, 0.12734702E-06_JPRB, 0.12437910E-06_JPRB, &
  & 0.12145209E-06_JPRB, 0.11877312E-06_JPRB, 0.11646120E-06_JPRB, 0.11444263E-06_JPRB, 0.11258876E-06_JPRB, 0.11088115E-06_JPRB, &
  & 0.10932877E-06_JPRB, 0.10789049E-06_JPRB, 0.10652384E-06_JPRB, 0.10521789E-06_JPRB, 0.10397294E-06_JPRB, 0.10279335E-06_JPRB, &
  & 0.10168868E-06_JPRB, 0.10067320E-06_JPRB, 0.99759653E-07_JPRB, 0.98958438E-07_JPRB, 0.98285696E-07_JPRB, 0.97745193E-07_JPRB, &
  & 0.97364669E-07_JPRB, 0.97083102E-07_JPRB, 0.96840608E-07_JPRB, 0.96487923E-07_JPRB /)

RGHG3(:, 9, 4) = (/ &
  & 0.92388447E-07_JPRB, 0.93916860E-07_JPRB, 0.95193741E-07_JPRB, 0.96543857E-07_JPRB, 0.98032928E-07_JPRB, 0.99685444E-07_JPRB, &
  & 0.10149140E-06_JPRB, 0.10343481E-06_JPRB, 0.10548730E-06_JPRB, 0.10761256E-06_JPRB, 0.10975802E-06_JPRB, 0.11185546E-06_JPRB, &
  & 0.11382897E-06_JPRB, 0.11563077E-06_JPRB, 0.11726815E-06_JPRB, 0.11879846E-06_JPRB, 0.12030289E-06_JPRB, 0.12188804E-06_JPRB, &
  & 0.12366225E-06_JPRB, 0.12571373E-06_JPRB, 0.12810776E-06_JPRB, 0.13089016E-06_JPRB, 0.13402736E-06_JPRB, 0.13738497E-06_JPRB, &
  & 0.14072106E-06_JPRB, 0.14395042E-06_JPRB, 0.14683872E-06_JPRB, 0.14927598E-06_JPRB, 0.15112109E-06_JPRB, 0.15226608E-06_JPRB, &
  & 0.15261811E-06_JPRB, 0.15216281E-06_JPRB, 0.15097511E-06_JPRB, 0.14924309E-06_JPRB, 0.14714378E-06_JPRB, 0.14477907E-06_JPRB, &
  & 0.14226293E-06_JPRB, 0.13959405E-06_JPRB, 0.13674729E-06_JPRB, 0.13373990E-06_JPRB, 0.13069419E-06_JPRB, 0.12778148E-06_JPRB, &
  & 0.12501712E-06_JPRB, 0.12236897E-06_JPRB, 0.11988161E-06_JPRB, 0.11763267E-06_JPRB, 0.11568721E-06_JPRB, 0.11398980E-06_JPRB, &
  & 0.11243348E-06_JPRB, 0.11097714E-06_JPRB, 0.10960445E-06_JPRB, 0.10830097E-06_JPRB, 0.10706844E-06_JPRB, 0.10591278E-06_JPRB, &
  & 0.10483845E-06_JPRB, 0.10385792E-06_JPRB, 0.10298438E-06_JPRB, 0.10223157E-06_JPRB, 0.10160878E-06_JPRB, 0.10112383E-06_JPRB, &
  & 0.10079726E-06_JPRB, 0.10056998E-06_JPRB, 0.10038229E-06_JPRB, 0.10010901E-06_JPRB /)

RGHG3(:,10, 4) = (/ &
  & 0.95104880E-07_JPRB, 0.98308384E-07_JPRB, 0.10059920E-06_JPRB, 0.10279454E-06_JPRB, 0.10514398E-06_JPRB, 0.10768241E-06_JPRB, &
  & 0.11042399E-06_JPRB, 0.11334942E-06_JPRB, 0.11642408E-06_JPRB, 0.11960040E-06_JPRB, 0.12281244E-06_JPRB, 0.12596391E-06_JPRB, &
  & 0.12894073E-06_JPRB, 0.13165688E-06_JPRB, 0.13407509E-06_JPRB, 0.13620789E-06_JPRB, 0.13810563E-06_JPRB, 0.13984888E-06_JPRB, &
  & 0.14154348E-06_JPRB, 0.14328981E-06_JPRB, 0.14516263E-06_JPRB, 0.14719734E-06_JPRB, 0.14937471E-06_JPRB, 0.15161588E-06_JPRB, &
  & 0.15380279E-06_JPRB, 0.15580737E-06_JPRB, 0.15759647E-06_JPRB, 0.15903461E-06_JPRB, 0.16001222E-06_JPRB, 0.16043849E-06_JPRB, &
  & 0.16023695E-06_JPRB, 0.15936166E-06_JPRB, 0.15784610E-06_JPRB, 0.15576472E-06_JPRB, 0.15322024E-06_JPRB, 0.15037475E-06_JPRB, &
  & 0.14731685E-06_JPRB, 0.14418646E-06_JPRB, 0.14112067E-06_JPRB, 0.13813968E-06_JPRB, 0.13515026E-06_JPRB, 0.13210803E-06_JPRB, &
  & 0.12908767E-06_JPRB, 0.12621648E-06_JPRB, 0.12357930E-06_JPRB, 0.12120810E-06_JPRB, 0.11907848E-06_JPRB, 0.11716028E-06_JPRB, &
  & 0.11545493E-06_JPRB, 0.11391943E-06_JPRB, 0.11249767E-06_JPRB, 0.11117728E-06_JPRB, 0.10995788E-06_JPRB, 0.10884138E-06_JPRB, &
  & 0.10783026E-06_JPRB, 0.10692996E-06_JPRB, 0.10614686E-06_JPRB, 0.10548725E-06_JPRB, 0.10495563E-06_JPRB, 0.10455145E-06_JPRB, &
  & 0.10428918E-06_JPRB, 0.10411568E-06_JPRB, 0.10397750E-06_JPRB, 0.10378280E-06_JPRB /)

RGHG3(:,11, 4) = (/ &
  & 0.10070204E-06_JPRB, 0.10582933E-06_JPRB, 0.10906123E-06_JPRB, 0.11213696E-06_JPRB, 0.11528832E-06_JPRB, 0.11868084E-06_JPRB, &
  & 0.12232202E-06_JPRB, 0.12620103E-06_JPRB, 0.13027901E-06_JPRB, 0.13450214E-06_JPRB, 0.13880639E-06_JPRB, 0.14309103E-06_JPRB, &
  & 0.14723503E-06_JPRB, 0.15110865E-06_JPRB, 0.15463705E-06_JPRB, 0.15778906E-06_JPRB, 0.16055455E-06_JPRB, 0.16294788E-06_JPRB, &
  & 0.16496475E-06_JPRB, 0.16663816E-06_JPRB, 0.16800794E-06_JPRB, 0.16911274E-06_JPRB, 0.16999824E-06_JPRB, 0.17067673E-06_JPRB, &
  & 0.17115369E-06_JPRB, 0.17144359E-06_JPRB, 0.17157157E-06_JPRB, 0.17155878E-06_JPRB, 0.17135002E-06_JPRB, 0.17080326E-06_JPRB, &
  & 0.16979091E-06_JPRB, 0.16829559E-06_JPRB, 0.16629861E-06_JPRB, 0.16381701E-06_JPRB, 0.16098447E-06_JPRB, 0.15787175E-06_JPRB, &
  & 0.15460374E-06_JPRB, 0.15127112E-06_JPRB, 0.14792235E-06_JPRB, 0.14459589E-06_JPRB, 0.14133282E-06_JPRB, 0.13814680E-06_JPRB, &
  & 0.13500771E-06_JPRB, 0.13191156E-06_JPRB, 0.12894074E-06_JPRB, 0.12618143E-06_JPRB, 0.12368466E-06_JPRB, 0.12145529E-06_JPRB, &
  & 0.11944199E-06_JPRB, 0.11761441E-06_JPRB, 0.11596156E-06_JPRB, 0.11447446E-06_JPRB, 0.11314296E-06_JPRB, 0.11196184E-06_JPRB, &
  & 0.11093086E-06_JPRB, 0.11005079E-06_JPRB, 0.10931588E-06_JPRB, 0.10872005E-06_JPRB, 0.10825480E-06_JPRB, 0.10790916E-06_JPRB, &
  & 0.10769286E-06_JPRB, 0.10755296E-06_JPRB, 0.10745033E-06_JPRB, 0.10731453E-06_JPRB /)

RGHG3(:,12, 4) = (/ &
  & 0.10967646E-06_JPRB, 0.11635318E-06_JPRB, 0.12054991E-06_JPRB, 0.12427722E-06_JPRB, 0.12812461E-06_JPRB, 0.13217722E-06_JPRB, &
  & 0.13650578E-06_JPRB, 0.14109098E-06_JPRB, 0.14589676E-06_JPRB, 0.15088098E-06_JPRB, 0.15596197E-06_JPRB, 0.16104329E-06_JPRB, &
  & 0.16600883E-06_JPRB, 0.17074069E-06_JPRB, 0.17509798E-06_JPRB, 0.17901577E-06_JPRB, 0.18243655E-06_JPRB, 0.18531752E-06_JPRB, &
  & 0.18759930E-06_JPRB, 0.18927507E-06_JPRB, 0.19033359E-06_JPRB, 0.19081513E-06_JPRB, 0.19077858E-06_JPRB, 0.19030131E-06_JPRB, &
  & 0.18946999E-06_JPRB, 0.18839890E-06_JPRB, 0.18717144E-06_JPRB, 0.18584366E-06_JPRB, 0.18444530E-06_JPRB, 0.18298618E-06_JPRB, &
  & 0.18134369E-06_JPRB, 0.17938191E-06_JPRB, 0.17711562E-06_JPRB, 0.17453090E-06_JPRB, 0.17162004E-06_JPRB, 0.16845381E-06_JPRB, &
  & 0.16508356E-06_JPRB, 0.16161557E-06_JPRB, 0.15812185E-06_JPRB, 0.15468397E-06_JPRB, 0.15130327E-06_JPRB, 0.14795492E-06_JPRB, &
  & 0.14462874E-06_JPRB, 0.14130586E-06_JPRB, 0.13801024E-06_JPRB, 0.13479811E-06_JPRB, 0.13173273E-06_JPRB, 0.12885367E-06_JPRB, &
  & 0.12621597E-06_JPRB, 0.12382733E-06_JPRB, 0.12167922E-06_JPRB, 0.11976323E-06_JPRB, 0.11806482E-06_JPRB, 0.11657336E-06_JPRB, &
  & 0.11528562E-06_JPRB, 0.11420366E-06_JPRB, 0.11332194E-06_JPRB, 0.11262397E-06_JPRB, 0.11208776E-06_JPRB, 0.11169233E-06_JPRB, &
  & 0.11143051E-06_JPRB, 0.11125650E-06_JPRB, 0.11112433E-06_JPRB, 0.11097628E-06_JPRB /)

RGHG3(:,13, 4) = (/ &
  & 0.12188615E-06_JPRB, 0.13008943E-06_JPRB, 0.13487609E-06_JPRB, 0.13918402E-06_JPRB, 0.14343583E-06_JPRB, 0.14788220E-06_JPRB, &
  & 0.15255672E-06_JPRB, 0.15746194E-06_JPRB, 0.16256635E-06_JPRB, 0.16781551E-06_JPRB, 0.17315335E-06_JPRB, 0.17847883E-06_JPRB, &
  & 0.18367832E-06_JPRB, 0.18866362E-06_JPRB, 0.19329637E-06_JPRB, 0.19746975E-06_JPRB, 0.20108843E-06_JPRB, 0.20410481E-06_JPRB, &
  & 0.20644882E-06_JPRB, 0.20809244E-06_JPRB, 0.20901768E-06_JPRB, 0.20925026E-06_JPRB, 0.20885166E-06_JPRB, 0.20790529E-06_JPRB, &
  & 0.20650296E-06_JPRB, 0.20477357E-06_JPRB, 0.20283211E-06_JPRB, 0.20077704E-06_JPRB, 0.19866432E-06_JPRB, 0.19652991E-06_JPRB, &
  & 0.19439366E-06_JPRB, 0.19215858E-06_JPRB, 0.18975197E-06_JPRB, 0.18728556E-06_JPRB, 0.18461380E-06_JPRB, 0.18168683E-06_JPRB, &
  & 0.17867302E-06_JPRB, 0.17563377E-06_JPRB, 0.17256221E-06_JPRB, 0.16951910E-06_JPRB, 0.16646040E-06_JPRB, 0.16327165E-06_JPRB, &
  & 0.15992836E-06_JPRB, 0.15637164E-06_JPRB, 0.15262538E-06_JPRB, 0.14878275E-06_JPRB, 0.14495721E-06_JPRB, 0.14129643E-06_JPRB, &
  & 0.13787010E-06_JPRB, 0.13472138E-06_JPRB, 0.13185149E-06_JPRB, 0.12924686E-06_JPRB, 0.12689075E-06_JPRB, 0.12478026E-06_JPRB, &
  & 0.12291856E-06_JPRB, 0.12131343E-06_JPRB, 0.11996410E-06_JPRB, 0.11886522E-06_JPRB, 0.11800095E-06_JPRB, 0.11734340E-06_JPRB, &
  & 0.11687797E-06_JPRB, 0.11653817E-06_JPRB, 0.11628260E-06_JPRB, 0.11601622E-06_JPRB /)

RGHG3(:,14, 4) = (/ &
  & 0.13746885E-06_JPRB, 0.14659186E-06_JPRB, 0.15188824E-06_JPRB, 0.15631871E-06_JPRB, 0.16064969E-06_JPRB, 0.16504534E-06_JPRB, &
  & 0.16959844E-06_JPRB, 0.17433467E-06_JPRB, 0.17924491E-06_JPRB, 0.18430599E-06_JPRB, 0.18943750E-06_JPRB, 0.19453175E-06_JPRB, &
  & 0.19947440E-06_JPRB, 0.20418170E-06_JPRB, 0.20859014E-06_JPRB, 0.21259594E-06_JPRB, 0.21609398E-06_JPRB, 0.21901158E-06_JPRB, &
  & 0.22131039E-06_JPRB, 0.22294404E-06_JPRB, 0.22388014E-06_JPRB, 0.22413218E-06_JPRB, 0.22374650E-06_JPRB, 0.22278728E-06_JPRB, &
  & 0.22135684E-06_JPRB, 0.21957575E-06_JPRB, 0.21753729E-06_JPRB, 0.21532244E-06_JPRB, 0.21301523E-06_JPRB, 0.21064535E-06_JPRB, &
  & 0.20822687E-06_JPRB, 0.20579157E-06_JPRB, 0.20328721E-06_JPRB, 0.20071040E-06_JPRB, 0.19829753E-06_JPRB, 0.19606308E-06_JPRB, &
  & 0.19392263E-06_JPRB, 0.19190117E-06_JPRB, 0.18989455E-06_JPRB, 0.18779575E-06_JPRB, 0.18549495E-06_JPRB, 0.18286796E-06_JPRB, &
  & 0.17985013E-06_JPRB, 0.17636671E-06_JPRB, 0.17242526E-06_JPRB, 0.16815494E-06_JPRB, 0.16376356E-06_JPRB, 0.15943026E-06_JPRB, &
  & 0.15531074E-06_JPRB, 0.15145687E-06_JPRB, 0.14786940E-06_JPRB, 0.14452711E-06_JPRB, 0.14141425E-06_JPRB, 0.13853150E-06_JPRB, &
  & 0.13589576E-06_JPRB, 0.13353338E-06_JPRB, 0.13146757E-06_JPRB, 0.12971307E-06_JPRB, 0.12827911E-06_JPRB, 0.12714918E-06_JPRB, &
  & 0.12629843E-06_JPRB, 0.12567115E-06_JPRB, 0.12518369E-06_JPRB, 0.12476303E-06_JPRB /)

RGHG3(:,15, 4) = (/ &
  & 0.15557356E-06_JPRB, 0.16486996E-06_JPRB, 0.16993322E-06_JPRB, 0.17412999E-06_JPRB, 0.17808544E-06_JPRB, 0.18205924E-06_JPRB, &
  & 0.18614982E-06_JPRB, 0.19039871E-06_JPRB, 0.19481710E-06_JPRB, 0.19938167E-06_JPRB, 0.20404531E-06_JPRB, 0.20869338E-06_JPRB, &
  & 0.21318334E-06_JPRB, 0.21742217E-06_JPRB, 0.22136022E-06_JPRB, 0.22498503E-06_JPRB, 0.22821820E-06_JPRB, 0.23097387E-06_JPRB, &
  & 0.23319674E-06_JPRB, 0.23484401E-06_JPRB, 0.23587987E-06_JPRB, 0.23628986E-06_JPRB, 0.23610494E-06_JPRB, 0.23540265E-06_JPRB, &
  & 0.23426163E-06_JPRB, 0.23277576E-06_JPRB, 0.23102650E-06_JPRB, 0.22904743E-06_JPRB, 0.22687124E-06_JPRB, 0.22455637E-06_JPRB, &
  & 0.22211464E-06_JPRB, 0.21959788E-06_JPRB, 0.21712670E-06_JPRB, 0.21479265E-06_JPRB, 0.21269813E-06_JPRB, 0.21096291E-06_JPRB, &
  & 0.20962713E-06_JPRB, 0.20854235E-06_JPRB, 0.20757307E-06_JPRB, 0.20652189E-06_JPRB, 0.20517562E-06_JPRB, 0.20335551E-06_JPRB, &
  & 0.20093542E-06_JPRB, 0.19782527E-06_JPRB, 0.19407038E-06_JPRB, 0.18982168E-06_JPRB, 0.18530243E-06_JPRB, 0.18075607E-06_JPRB, &
  & 0.17634299E-06_JPRB, 0.17214163E-06_JPRB, 0.16815790E-06_JPRB, 0.16436772E-06_JPRB, 0.16074149E-06_JPRB, 0.15727447E-06_JPRB, &
  & 0.15399323E-06_JPRB, 0.15095169E-06_JPRB, 0.14820105E-06_JPRB, 0.14579834E-06_JPRB, 0.14377370E-06_JPRB, 0.14214481E-06_JPRB, &
  & 0.14089963E-06_JPRB, 0.13996355E-06_JPRB, 0.13928762E-06_JPRB, 0.13877168E-06_JPRB /)

RGHG3(:,16, 4) = (/ &
  & 0.17433607E-06_JPRB, 0.18273883E-06_JPRB, 0.18719425E-06_JPRB, 0.19080851E-06_JPRB, 0.19421273E-06_JPRB, 0.19762594E-06_JPRB, &
  & 0.20115574E-06_JPRB, 0.20485290E-06_JPRB, 0.20872412E-06_JPRB, 0.21274336E-06_JPRB, 0.21685418E-06_JPRB, 0.22096147E-06_JPRB, &
  & 0.22496860E-06_JPRB, 0.22875707E-06_JPRB, 0.23226458E-06_JPRB, 0.23547956E-06_JPRB, 0.23841133E-06_JPRB, 0.24099765E-06_JPRB, &
  & 0.24316603E-06_JPRB, 0.24486022E-06_JPRB, 0.24603827E-06_JPRB, 0.24667526E-06_JPRB, 0.24680210E-06_JPRB, 0.24647511E-06_JPRB, &
  & 0.24577326E-06_JPRB, 0.24475895E-06_JPRB, 0.24347145E-06_JPRB, 0.24192732E-06_JPRB, 0.24009563E-06_JPRB, 0.23801698E-06_JPRB, &
  & 0.23571592E-06_JPRB, 0.23325278E-06_JPRB, 0.23081225E-06_JPRB, 0.22860280E-06_JPRB, 0.22677669E-06_JPRB, 0.22546521E-06_JPRB, &
  & 0.22470378E-06_JPRB, 0.22438684E-06_JPRB, 0.22427224E-06_JPRB, 0.22407885E-06_JPRB, 0.22352505E-06_JPRB, 0.22241153E-06_JPRB, &
  & 0.22058855E-06_JPRB, 0.21799248E-06_JPRB, 0.21466259E-06_JPRB, 0.21074834E-06_JPRB, 0.20648494E-06_JPRB, 0.20209855E-06_JPRB, &
  & 0.19777310E-06_JPRB, 0.19359186E-06_JPRB, 0.18956683E-06_JPRB, 0.18566936E-06_JPRB, 0.18186526E-06_JPRB, 0.17814926E-06_JPRB, &
  & 0.17455297E-06_JPRB, 0.17114172E-06_JPRB, 0.16799953E-06_JPRB, 0.16519706E-06_JPRB, 0.16281352E-06_JPRB, 0.16087473E-06_JPRB, &
  & 0.15939231E-06_JPRB, 0.15831669E-06_JPRB, 0.15757448E-06_JPRB, 0.15721903E-06_JPRB /)

RGHG3(:,17, 4) = (/ &
  & 0.19173285E-06_JPRB, 0.19883515E-06_JPRB, 0.20254460E-06_JPRB, 0.20558205E-06_JPRB, 0.20845121E-06_JPRB, 0.21136204E-06_JPRB, &
  & 0.21441370E-06_JPRB, 0.21764998E-06_JPRB, 0.22107022E-06_JPRB, 0.22464461E-06_JPRB, 0.22829298E-06_JPRB, 0.23191497E-06_JPRB, &
  & 0.23542285E-06_JPRB, 0.23876424E-06_JPRB, 0.24188537E-06_JPRB, 0.24475494E-06_JPRB, 0.24738563E-06_JPRB, 0.24978152E-06_JPRB, &
  & 0.25188106E-06_JPRB, 0.25362090E-06_JPRB, 0.25493597E-06_JPRB, 0.25582153E-06_JPRB, 0.25627233E-06_JPRB, 0.25634483E-06_JPRB, &
  & 0.25611803E-06_JPRB, 0.25558742E-06_JPRB, 0.25481683E-06_JPRB, 0.25377454E-06_JPRB, 0.25241246E-06_JPRB, 0.25070557E-06_JPRB, &
  & 0.24870982E-06_JPRB, 0.24648452E-06_JPRB, 0.24421888E-06_JPRB, 0.24214108E-06_JPRB, 0.24049044E-06_JPRB, 0.23944017E-06_JPRB, &
  & 0.23903334E-06_JPRB, 0.23914077E-06_JPRB, 0.23950309E-06_JPRB, 0.23981400E-06_JPRB, 0.23975417E-06_JPRB, 0.23910951E-06_JPRB, &
  & 0.23773410E-06_JPRB, 0.23557239E-06_JPRB, 0.23267273E-06_JPRB, 0.22918289E-06_JPRB, 0.22530647E-06_JPRB, 0.22128278E-06_JPRB, &
  & 0.21726194E-06_JPRB, 0.21331175E-06_JPRB, 0.20946028E-06_JPRB, 0.20569315E-06_JPRB, 0.20198058E-06_JPRB, 0.19831360E-06_JPRB, &
  & 0.19472091E-06_JPRB, 0.19127580E-06_JPRB, 0.18806494E-06_JPRB, 0.18518905E-06_JPRB, 0.18272569E-06_JPRB, 0.18073887E-06_JPRB, &
  & 0.17924418E-06_JPRB, 0.17820025E-06_JPRB, 0.17756732E-06_JPRB, 0.17748511E-06_JPRB /)

RGHG3(:,18, 4) = (/ &
  & 0.20689021E-06_JPRB, 0.21276387E-06_JPRB, 0.21590415E-06_JPRB, 0.21847238E-06_JPRB, 0.22094376E-06_JPRB, 0.22348073E-06_JPRB, &
  & 0.22617029E-06_JPRB, 0.22905516E-06_JPRB, 0.23212777E-06_JPRB, 0.23534197E-06_JPRB, 0.23862361E-06_JPRB, 0.24186511E-06_JPRB, &
  & 0.24498078E-06_JPRB, 0.24791402E-06_JPRB, 0.25066649E-06_JPRB, 0.25322780E-06_JPRB, 0.25559143E-06_JPRB, 0.25777101E-06_JPRB, &
  & 0.25975532E-06_JPRB, 0.26148180E-06_JPRB, 0.26289797E-06_JPRB, 0.26396705E-06_JPRB, 0.26468862E-06_JPRB, 0.26511043E-06_JPRB, &
  & 0.26525697E-06_JPRB, 0.26518458E-06_JPRB, 0.26489741E-06_JPRB, 0.26437095E-06_JPRB, 0.26351699E-06_JPRB, 0.26232877E-06_JPRB, &
  & 0.26078729E-06_JPRB, 0.25898851E-06_JPRB, 0.25710480E-06_JPRB, 0.25535132E-06_JPRB, 0.25394453E-06_JPRB, 0.25307241E-06_JPRB, &
  & 0.25280517E-06_JPRB, 0.25303692E-06_JPRB, 0.25350590E-06_JPRB, 0.25391012E-06_JPRB, 0.25397526E-06_JPRB, 0.25347063E-06_JPRB, &
  & 0.25226979E-06_JPRB, 0.25033557E-06_JPRB, 0.24772467E-06_JPRB, 0.24456745E-06_JPRB, 0.24106970E-06_JPRB, 0.23741102E-06_JPRB, &
  & 0.23372533E-06_JPRB, 0.23007772E-06_JPRB, 0.22650643E-06_JPRB, 0.22301171E-06_JPRB, 0.21956686E-06_JPRB, 0.21616442E-06_JPRB, &
  & 0.21282784E-06_JPRB, 0.20961745E-06_JPRB, 0.20661561E-06_JPRB, 0.20391299E-06_JPRB, 0.20160859E-06_JPRB, 0.19976324E-06_JPRB, &
  & 0.19841400E-06_JPRB, 0.19751320E-06_JPRB, 0.19704861E-06_JPRB, 0.19721432E-06_JPRB /)

RGHG3(:,19, 4) = (/ &
  & 0.21978381E-06_JPRB, 0.22480336E-06_JPRB, 0.22746117E-06_JPRB, 0.22972462E-06_JPRB, 0.23190131E-06_JPRB, 0.23417093E-06_JPRB, &
  & 0.23660135E-06_JPRB, 0.23921874E-06_JPRB, 0.24201745E-06_JPRB, 0.24496032E-06_JPRB, 0.24795111E-06_JPRB, 0.25090731E-06_JPRB, &
  & 0.25373404E-06_JPRB, 0.25637388E-06_JPRB, 0.25882017E-06_JPRB, 0.26109558E-06_JPRB, 0.26321513E-06_JPRB, 0.26518373E-06_JPRB, &
  & 0.26700752E-06_JPRB, 0.26866047E-06_JPRB, 0.27009469E-06_JPRB, 0.27125913E-06_JPRB, 0.27219116E-06_JPRB, 0.27283875E-06_JPRB, &
  & 0.27330248E-06_JPRB, 0.27357754E-06_JPRB, 0.27366150E-06_JPRB, 0.27354918E-06_JPRB, 0.27318336E-06_JPRB, 0.27253927E-06_JPRB, &
  & 0.27159692E-06_JPRB, 0.27040915E-06_JPRB, 0.26909197E-06_JPRB, 0.26781967E-06_JPRB, 0.26678782E-06_JPRB, 0.26612216E-06_JPRB, &
  & 0.26591175E-06_JPRB, 0.26604678E-06_JPRB, 0.26631466E-06_JPRB, 0.26648931E-06_JPRB, 0.26634541E-06_JPRB, 0.26570109E-06_JPRB, &
  & 0.26444701E-06_JPRB, 0.26255438E-06_JPRB, 0.26006981E-06_JPRB, 0.25712774E-06_JPRB, 0.25388812E-06_JPRB, 0.25051838E-06_JPRB, &
  & 0.24713441E-06_JPRB, 0.24382373E-06_JPRB, 0.24060341E-06_JPRB, 0.23745469E-06_JPRB, 0.23436790E-06_JPRB, 0.23134706E-06_JPRB, &
  & 0.22840669E-06_JPRB, 0.22558723E-06_JPRB, 0.22294770E-06_JPRB, 0.22056929E-06_JPRB, 0.21854063E-06_JPRB, 0.21693253E-06_JPRB, &
  & 0.21576955E-06_JPRB, 0.21504069E-06_JPRB, 0.21470240E-06_JPRB, 0.21502603E-06_JPRB /)

RGHG3(:,20, 4) = (/ &
  & 0.23083467E-06_JPRB, 0.23512334E-06_JPRB, 0.23753287E-06_JPRB, 0.23953342E-06_JPRB, 0.24152411E-06_JPRB, 0.24360446E-06_JPRB, &
  & 0.24584887E-06_JPRB, 0.24827750E-06_JPRB, 0.25087996E-06_JPRB, 0.25360976E-06_JPRB, 0.25637905E-06_JPRB, 0.25909657E-06_JPRB, &
  & 0.26168900E-06_JPRB, 0.26409978E-06_JPRB, 0.26631639E-06_JPRB, 0.26835508E-06_JPRB, 0.27024905E-06_JPRB, 0.27201781E-06_JPRB, &
  & 0.27366849E-06_JPRB, 0.27519425E-06_JPRB, 0.27656716E-06_JPRB, 0.27776079E-06_JPRB, 0.27873969E-06_JPRB, 0.27955357E-06_JPRB, &
  & 0.28018283E-06_JPRB, 0.28066199E-06_JPRB, 0.28101169E-06_JPRB, 0.28121283E-06_JPRB, 0.28125754E-06_JPRB, 0.28110719E-06_JPRB, &
  & 0.28076644E-06_JPRB, 0.28023555E-06_JPRB, 0.27957651E-06_JPRB, 0.27888336E-06_JPRB, 0.27828466E-06_JPRB, 0.27786842E-06_JPRB, &
  & 0.27765128E-06_JPRB, 0.27756417E-06_JPRB, 0.27752560E-06_JPRB, 0.27733154E-06_JPRB, 0.27682523E-06_JPRB, 0.27588089E-06_JPRB, &
  & 0.27442812E-06_JPRB, 0.27244670E-06_JPRB, 0.26999373E-06_JPRB, 0.26717433E-06_JPRB, 0.26415475E-06_JPRB, 0.26107023E-06_JPRB, &
  & 0.25802370E-06_JPRB, 0.25506051E-06_JPRB, 0.25217392E-06_JPRB, 0.24936185E-06_JPRB, 0.24663865E-06_JPRB, 0.24401322E-06_JPRB, &
  & 0.24149554E-06_JPRB, 0.23910550E-06_JPRB, 0.23687382E-06_JPRB, 0.23485677E-06_JPRB, 0.23312572E-06_JPRB, 0.23174474E-06_JPRB, &
  & 0.23075802E-06_JPRB, 0.23012349E-06_JPRB, 0.22985621E-06_JPRB, 0.23011940E-06_JPRB /)

RGHG3(:,21, 4) = (/ &
  & 0.24015867E-06_JPRB, 0.24405227E-06_JPRB, 0.24616946E-06_JPRB, 0.24803987E-06_JPRB, 0.24987133E-06_JPRB, 0.25182032E-06_JPRB, &
  & 0.25393322E-06_JPRB, 0.25621625E-06_JPRB, 0.25865759E-06_JPRB, 0.26121830E-06_JPRB, 0.26380420E-06_JPRB, 0.26633825E-06_JPRB, &
  & 0.26874153E-06_JPRB, 0.27097207E-06_JPRB, 0.27301311E-06_JPRB, 0.27487710E-06_JPRB, 0.27659283E-06_JPRB, 0.27818862E-06_JPRB, &
  & 0.27968059E-06_JPRB, 0.28107152E-06_JPRB, 0.28234814E-06_JPRB, 0.28348524E-06_JPRB, 0.28447653E-06_JPRB, 0.28530835E-06_JPRB, &
  & 0.28599268E-06_JPRB, 0.28657320E-06_JPRB, 0.28706674E-06_JPRB, 0.28748775E-06_JPRB, 0.28783464E-06_JPRB, 0.28808094E-06_JPRB, &
  & 0.28821970E-06_JPRB, 0.28822328E-06_JPRB, 0.28812107E-06_JPRB, 0.28792778E-06_JPRB, 0.28770265E-06_JPRB, 0.28747360E-06_JPRB, &
  & 0.28726953E-06_JPRB, 0.28703104E-06_JPRB, 0.28669189E-06_JPRB, 0.28613735E-06_JPRB, 0.28527563E-06_JPRB, 0.28403053E-06_JPRB, &
  & 0.28236909E-06_JPRB, 0.28029447E-06_JPRB, 0.27785893E-06_JPRB, 0.27517987E-06_JPRB, 0.27238622E-06_JPRB, 0.26959424E-06_JPRB, &
  & 0.26685407E-06_JPRB, 0.26417825E-06_JPRB, 0.26157932E-06_JPRB, 0.25908247E-06_JPRB, 0.25670408E-06_JPRB, 0.25445362E-06_JPRB, &
  & 0.25233078E-06_JPRB, 0.25033623E-06_JPRB, 0.24847873E-06_JPRB, 0.24678752E-06_JPRB, 0.24531695E-06_JPRB, 0.24412282E-06_JPRB, &
  & 0.24323555E-06_JPRB, 0.24266299E-06_JPRB, 0.24235788E-06_JPRB, 0.24251005E-06_JPRB /)

RGHG3(:,22, 4) = (/ &
  & 0.24809628E-06_JPRB, 0.25156652E-06_JPRB, 0.25358131E-06_JPRB, 0.25529570E-06_JPRB, 0.25703096E-06_JPRB, 0.25886780E-06_JPRB, &
  & 0.26086482E-06_JPRB, 0.26302524E-06_JPRB, 0.26532814E-06_JPRB, 0.26773276E-06_JPRB, 0.27016716E-06_JPRB, 0.27254677E-06_JPRB, &
  & 0.27480769E-06_JPRB, 0.27690081E-06_JPRB, 0.27881455E-06_JPRB, 0.28055365E-06_JPRB, 0.28214347E-06_JPRB, 0.28361291E-06_JPRB, &
  & 0.28498016E-06_JPRB, 0.28625527E-06_JPRB, 0.28743293E-06_JPRB, 0.28850252E-06_JPRB, 0.28944237E-06_JPRB, 0.29025190E-06_JPRB, &
  & 0.29094340E-06_JPRB, 0.29154566E-06_JPRB, 0.29209363E-06_JPRB, 0.29261960E-06_JPRB, 0.29313668E-06_JPRB, 0.29363036E-06_JPRB, &
  & 0.29408181E-06_JPRB, 0.29444828E-06_JPRB, 0.29471471E-06_JPRB, 0.29485685E-06_JPRB, 0.29488427E-06_JPRB, 0.29478667E-06_JPRB, &
  & 0.29457144E-06_JPRB, 0.29419965E-06_JPRB, 0.29363360E-06_JPRB, 0.29281608E-06_JPRB, 0.29170121E-06_JPRB, 0.29025517E-06_JPRB, &
  & 0.28847413E-06_JPRB, 0.28637882E-06_JPRB, 0.28403122E-06_JPRB, 0.28151953E-06_JPRB, 0.27894981E-06_JPRB, 0.27640007E-06_JPRB, &
  & 0.27391570E-06_JPRB, 0.27151518E-06_JPRB, 0.26920566E-06_JPRB, 0.26701233E-06_JPRB, 0.26495439E-06_JPRB, 0.26303664E-06_JPRB, &
  & 0.26125093E-06_JPRB, 0.25958479E-06_JPRB, 0.25803146E-06_JPRB, 0.25660233E-06_JPRB, 0.25533151E-06_JPRB, 0.25426618E-06_JPRB, &
  & 0.25345261E-06_JPRB, 0.25286960E-06_JPRB, 0.25252234E-06_JPRB, 0.25241837E-06_JPRB /)

RGHG3(:,23, 4) = (/ &
  & 0.25475202E-06_JPRB, 0.25797803E-06_JPRB, 0.25981095E-06_JPRB, 0.26145338E-06_JPRB, 0.26309203E-06_JPRB, 0.26483838E-06_JPRB, &
  & 0.26673291E-06_JPRB, 0.26877714E-06_JPRB, 0.27094859E-06_JPRB, 0.27321255E-06_JPRB, 0.27550200E-06_JPRB, 0.27775042E-06_JPRB, &
  & 0.27989478E-06_JPRB, 0.28188799E-06_JPRB, 0.28370974E-06_JPRB, 0.28536599E-06_JPRB, 0.28687339E-06_JPRB, 0.28825829E-06_JPRB, &
  & 0.28954125E-06_JPRB, 0.29073203E-06_JPRB, 0.29183224E-06_JPRB, 0.29283308E-06_JPRB, 0.29372111E-06_JPRB, 0.29449237E-06_JPRB, &
  & 0.29515988E-06_JPRB, 0.29575295E-06_JPRB, 0.29631067E-06_JPRB, 0.29686242E-06_JPRB, 0.29744086E-06_JPRB, 0.29805148E-06_JPRB, &
  & 0.29864952E-06_JPRB, 0.29920011E-06_JPRB, 0.29964443E-06_JPRB, 0.29994905E-06_JPRB, 0.30008573E-06_JPRB, 0.30003227E-06_JPRB, &
  & 0.29978119E-06_JPRB, 0.29930868E-06_JPRB, 0.29860041E-06_JPRB, 0.29763117E-06_JPRB, 0.29638792E-06_JPRB, 0.29485864E-06_JPRB, &
  & 0.29306736E-06_JPRB, 0.29104154E-06_JPRB, 0.28883457E-06_JPRB, 0.28651706E-06_JPRB, 0.28417904E-06_JPRB, 0.28189186E-06_JPRB, &
  & 0.27968088E-06_JPRB, 0.27754237E-06_JPRB, 0.27550010E-06_JPRB, 0.27358115E-06_JPRB, 0.27179894E-06_JPRB, 0.27015346E-06_JPRB, &
  & 0.26863032E-06_JPRB, 0.26721153E-06_JPRB, 0.26588253E-06_JPRB, 0.26464235E-06_JPRB, 0.26351546E-06_JPRB, 0.26254111E-06_JPRB, &
  & 0.26175474E-06_JPRB, 0.26116868E-06_JPRB, 0.26073127E-06_JPRB, 0.26043136E-06_JPRB /)

RGHG3(:,24, 4) = (/ &
  & 0.26041354E-06_JPRB, 0.26339794E-06_JPRB, 0.26512629E-06_JPRB, 0.26665964E-06_JPRB, 0.26821755E-06_JPRB, 0.26987487E-06_JPRB, &
  & 0.27166871E-06_JPRB, 0.27359863E-06_JPRB, 0.27564352E-06_JPRB, 0.27776980E-06_JPRB, 0.27992911E-06_JPRB, 0.28206006E-06_JPRB, &
  & 0.28410486E-06_JPRB, 0.28601875E-06_JPRB, 0.28777671E-06_JPRB, 0.28937794E-06_JPRB, 0.29083614E-06_JPRB, 0.29217279E-06_JPRB, &
  & 0.29340251E-06_JPRB, 0.29453832E-06_JPRB, 0.29558424E-06_JPRB, 0.29653106E-06_JPRB, 0.29737359E-06_JPRB, 0.29810556E-06_JPRB, &
  & 0.29874295E-06_JPRB, 0.29931067E-06_JPRB, 0.29984787E-06_JPRB, 0.30039331E-06_JPRB, 0.30097732E-06_JPRB, 0.30159862E-06_JPRB, &
  & 0.30222898E-06_JPRB, 0.30282627E-06_JPRB, 0.30331825E-06_JPRB, 0.30365925E-06_JPRB, 0.30380806E-06_JPRB, 0.30373661E-06_JPRB, &
  & 0.30343233E-06_JPRB, 0.30288797E-06_JPRB, 0.30210037E-06_JPRB, 0.30106389E-06_JPRB, 0.29978278E-06_JPRB, 0.29826816E-06_JPRB, &
  & 0.29655027E-06_JPRB, 0.29465991E-06_JPRB, 0.29264342E-06_JPRB, 0.29056247E-06_JPRB, 0.28848558E-06_JPRB, 0.28645442E-06_JPRB, &
  & 0.28447963E-06_JPRB, 0.28258557E-06_JPRB, 0.28079239E-06_JPRB, 0.27911187E-06_JPRB, 0.27755834E-06_JPRB, 0.27612643E-06_JPRB, &
  & 0.27479942E-06_JPRB, 0.27355753E-06_JPRB, 0.27238417E-06_JPRB, 0.27127484E-06_JPRB, 0.27024578E-06_JPRB, 0.26933071E-06_JPRB, &
  & 0.26856995E-06_JPRB, 0.26796044E-06_JPRB, 0.26747958E-06_JPRB, 0.26698490E-06_JPRB /)

RGHG3(:,25, 4) = (/ &
  & 0.26533954E-06_JPRB, 0.26806140E-06_JPRB, 0.26969158E-06_JPRB, 0.27112318E-06_JPRB, 0.27258770E-06_JPRB, 0.27415052E-06_JPRB, &
  & 0.27583630E-06_JPRB, 0.27765131E-06_JPRB, 0.27956844E-06_JPRB, 0.28156293E-06_JPRB, 0.28359861E-06_JPRB, 0.28562414E-06_JPRB, &
  & 0.28758785E-06_JPRB, 0.28943936E-06_JPRB, 0.29115168E-06_JPRB, 0.29271760E-06_JPRB, 0.29414483E-06_JPRB, 0.29545015E-06_JPRB, &
  & 0.29664741E-06_JPRB, 0.29774867E-06_JPRB, 0.29875673E-06_JPRB, 0.29966571E-06_JPRB, 0.30047113E-06_JPRB, 0.30117019E-06_JPRB, &
  & 0.30177736E-06_JPRB, 0.30231479E-06_JPRB, 0.30282052E-06_JPRB, 0.30333598E-06_JPRB, 0.30388281E-06_JPRB, 0.30447114E-06_JPRB, &
  & 0.30507169E-06_JPRB, 0.30563717E-06_JPRB, 0.30610053E-06_JPRB, 0.30640933E-06_JPRB, 0.30651992E-06_JPRB, 0.30640302E-06_JPRB, &
  & 0.30604588E-06_JPRB, 0.30544791E-06_JPRB, 0.30462192E-06_JPRB, 0.30357893E-06_JPRB, 0.30232999E-06_JPRB, 0.30089188E-06_JPRB, &
  & 0.29930183E-06_JPRB, 0.29758812E-06_JPRB, 0.29579007E-06_JPRB, 0.29395119E-06_JPRB, 0.29211191E-06_JPRB, 0.29030554E-06_JPRB, &
  & 0.28856627E-06_JPRB, 0.28690437E-06_JPRB, 0.28532301E-06_JPRB, 0.28384571E-06_JPRB, 0.28247709E-06_JPRB, 0.28120897E-06_JPRB, &
  & 0.28002492E-06_JPRB, 0.27890673E-06_JPRB, 0.27783878E-06_JPRB, 0.27681608E-06_JPRB, 0.27585222E-06_JPRB, 0.27497796E-06_JPRB, &
  & 0.27422982E-06_JPRB, 0.27361452E-06_JPRB, 0.27308610E-06_JPRB, 0.27248774E-06_JPRB /)

RGHG3(:,26, 4) = (/ &
  & 0.26963744E-06_JPRB, 0.27220509E-06_JPRB, 0.27365792E-06_JPRB, 0.27501105E-06_JPRB, 0.27636904E-06_JPRB, 0.27782497E-06_JPRB, &
  & 0.27940578E-06_JPRB, 0.28109710E-06_JPRB, 0.28289000E-06_JPRB, 0.28476057E-06_JPRB, 0.28667779E-06_JPRB, 0.28860430E-06_JPRB, &
  & 0.29048704E-06_JPRB, 0.29228232E-06_JPRB, 0.29395630E-06_JPRB, 0.29549813E-06_JPRB, 0.29690977E-06_JPRB, 0.29820092E-06_JPRB, &
  & 0.29938144E-06_JPRB, 0.30046127E-06_JPRB, 0.30144255E-06_JPRB, 0.30232368E-06_JPRB, 0.30309999E-06_JPRB, 0.30377379E-06_JPRB, &
  & 0.30435456E-06_JPRB, 0.30486541E-06_JPRB, 0.30534164E-06_JPRB, 0.30581077E-06_JPRB, 0.30631148E-06_JPRB, 0.30683907E-06_JPRB, &
  & 0.30737240E-06_JPRB, 0.30786629E-06_JPRB, 0.30826402E-06_JPRB, 0.30851174E-06_JPRB, 0.30856523E-06_JPRB, 0.30839757E-06_JPRB, &
  & 0.30799828E-06_JPRB, 0.30738178E-06_JPRB, 0.30656022E-06_JPRB, 0.30555020E-06_JPRB, 0.30437121E-06_JPRB, 0.30305017E-06_JPRB, &
  & 0.30161439E-06_JPRB, 0.30009323E-06_JPRB, 0.29851077E-06_JPRB, 0.29689500E-06_JPRB, 0.29527354E-06_JPRB, 0.29369079E-06_JPRB, &
  & 0.29215934E-06_JPRB, 0.29068312E-06_JPRB, 0.28928480E-06_JPRB, 0.28797334E-06_JPRB, 0.28674921E-06_JPRB, 0.28560476E-06_JPRB, &
  & 0.28452388E-06_JPRB, 0.28349086E-06_JPRB, 0.28249264E-06_JPRB, 0.28152590E-06_JPRB, 0.28060367E-06_JPRB, 0.27975668E-06_JPRB, &
  & 0.27902024E-06_JPRB, 0.27839849E-06_JPRB, 0.27784324E-06_JPRB, 0.27715174E-06_JPRB /)

RGHG3(:,27, 4) = (/ &
  & 0.27356305E-06_JPRB, 0.27581558E-06_JPRB, 0.27722177E-06_JPRB, 0.27842830E-06_JPRB, 0.27969659E-06_JPRB, 0.28105049E-06_JPRB, &
  & 0.28251083E-06_JPRB, 0.28408894E-06_JPRB, 0.28575627E-06_JPRB, 0.28750304E-06_JPRB, 0.28931092E-06_JPRB, 0.29114125E-06_JPRB, &
  & 0.29295350E-06_JPRB, 0.29469672E-06_JPRB, 0.29633838E-06_JPRB, 0.29785966E-06_JPRB, 0.29925775E-06_JPRB, 0.30053783E-06_JPRB, &
  & 0.30170648E-06_JPRB, 0.30276993E-06_JPRB, 0.30373081E-06_JPRB, 0.30458904E-06_JPRB, 0.30534224E-06_JPRB, 0.30599506E-06_JPRB, &
  & 0.30655417E-06_JPRB, 0.30704328E-06_JPRB, 0.30748743E-06_JPRB, 0.30791961E-06_JPRB, 0.30836281E-06_JPRB, 0.30881449E-06_JPRB, &
  & 0.30926421E-06_JPRB, 0.30967399E-06_JPRB, 0.30999192E-06_JPRB, 0.31017103E-06_JPRB, 0.31016805E-06_JPRB, 0.30996210E-06_JPRB, &
  & 0.30954681E-06_JPRB, 0.30892818E-06_JPRB, 0.30813425E-06_JPRB, 0.30719409E-06_JPRB, 0.30612068E-06_JPRB, 0.30493661E-06_JPRB, &
  & 0.30366962E-06_JPRB, 0.30233753E-06_JPRB, 0.30095924E-06_JPRB, 0.29954401E-06_JPRB, 0.29812574E-06_JPRB, 0.29672793E-06_JPRB, &
  & 0.29536432E-06_JPRB, 0.29405481E-06_JPRB, 0.29280505E-06_JPRB, 0.29162328E-06_JPRB, 0.29051148E-06_JPRB, 0.28945882E-06_JPRB, &
  & 0.28845216E-06_JPRB, 0.28747732E-06_JPRB, 0.28652482E-06_JPRB, 0.28559299E-06_JPRB, 0.28469734E-06_JPRB, 0.28386873E-06_JPRB, &
  & 0.28314241E-06_JPRB, 0.28252003E-06_JPRB, 0.28195547E-06_JPRB, 0.28119965E-06_JPRB /)

RGHG3(:,28, 4) = (/ &
  & 0.27701375E-06_JPRB, 0.27916042E-06_JPRB, 0.28036175E-06_JPRB, 0.28151442E-06_JPRB, 0.28266572E-06_JPRB, 0.28391409E-06_JPRB, &
  & 0.28527660E-06_JPRB, 0.28673296E-06_JPRB, 0.28828427E-06_JPRB, 0.28991622E-06_JPRB, 0.29161285E-06_JPRB, 0.29335101E-06_JPRB, &
  & 0.29508666E-06_JPRB, 0.29678029E-06_JPRB, 0.29839322E-06_JPRB, 0.29989940E-06_JPRB, 0.30128621E-06_JPRB, 0.30255433E-06_JPRB, &
  & 0.30371044E-06_JPRB, 0.30475886E-06_JPRB, 0.30570078E-06_JPRB, 0.30653800E-06_JPRB, 0.30727003E-06_JPRB, 0.30790201E-06_JPRB, &
  & 0.30844132E-06_JPRB, 0.30890712E-06_JPRB, 0.30931983E-06_JPRB, 0.30971341E-06_JPRB, 0.31009597E-06_JPRB, 0.31047557E-06_JPRB, &
  & 0.31084139E-06_JPRB, 0.31116645E-06_JPRB, 0.31140490E-06_JPRB, 0.31151848E-06_JPRB, 0.31146794E-06_JPRB, 0.31123540E-06_JPRB, &
  & 0.31081470E-06_JPRB, 0.31022927E-06_JPRB, 0.30950500E-06_JPRB, 0.30865570E-06_JPRB, 0.30770136E-06_JPRB, 0.30666359E-06_JPRB, &
  & 0.30556154E-06_JPRB, 0.30440972E-06_JPRB, 0.30321047E-06_JPRB, 0.30197936E-06_JPRB, 0.30072894E-06_JPRB, 0.29948683E-06_JPRB, &
  & 0.29827203E-06_JPRB, 0.29709352E-06_JPRB, 0.29595935E-06_JPRB, 0.29488032E-06_JPRB, 0.29385171E-06_JPRB, 0.29286753E-06_JPRB, &
  & 0.29191452E-06_JPRB, 0.29098146E-06_JPRB, 0.29005972E-06_JPRB, 0.28915042E-06_JPRB, 0.28827196E-06_JPRB, 0.28745629E-06_JPRB, &
  & 0.28673983E-06_JPRB, 0.28612473E-06_JPRB, 0.28554874E-06_JPRB, 0.28477220E-06_JPRB /)

RGHG3(:,29, 4) = (/ &
  & 0.28019133E-06_JPRB, 0.28206600E-06_JPRB, 0.28325599E-06_JPRB, 0.28427067E-06_JPRB, 0.28535217E-06_JPRB, 0.28651047E-06_JPRB, &
  & 0.28776165E-06_JPRB, 0.28911771E-06_JPRB, 0.29055445E-06_JPRB, 0.29207331E-06_JPRB, 0.29366925E-06_JPRB, 0.29531520E-06_JPRB, &
  & 0.29697802E-06_JPRB, 0.29861010E-06_JPRB, 0.30017949E-06_JPRB, 0.30166368E-06_JPRB, 0.30304352E-06_JPRB, 0.30430661E-06_JPRB, &
  & 0.30545345E-06_JPRB, 0.30648732E-06_JPRB, 0.30741205E-06_JPRB, 0.30822727E-06_JPRB, 0.30893818E-06_JPRB, 0.30954675E-06_JPRB, &
  & 0.31006610E-06_JPRB, 0.31050661E-06_JPRB, 0.31089169E-06_JPRB, 0.31124469E-06_JPRB, 0.31157077E-06_JPRB, 0.31188125E-06_JPRB, &
  & 0.31216928E-06_JPRB, 0.31241370E-06_JPRB, 0.31258040E-06_JPRB, 0.31263619E-06_JPRB, 0.31254973E-06_JPRB, 0.31230707E-06_JPRB, &
  & 0.31191274E-06_JPRB, 0.31138089E-06_JPRB, 0.31072665E-06_JPRB, 0.30997839E-06_JPRB, 0.30915297E-06_JPRB, 0.30826084E-06_JPRB, &
  & 0.30731903E-06_JPRB, 0.30632950E-06_JPRB, 0.30529603E-06_JPRB, 0.30421731E-06_JPRB, 0.30311440E-06_JPRB, 0.30200144E-06_JPRB, &
  & 0.30090339E-06_JPRB, 0.29983016E-06_JPRB, 0.29879018E-06_JPRB, 0.29778846E-06_JPRB, 0.29682482E-06_JPRB, 0.29589222E-06_JPRB, &
  & 0.29498025E-06_JPRB, 0.29407758E-06_JPRB, 0.29317928E-06_JPRB, 0.29228678E-06_JPRB, 0.29142120E-06_JPRB, 0.29061678E-06_JPRB, &
  & 0.28990991E-06_JPRB, 0.28930171E-06_JPRB, 0.28873578E-06_JPRB, 0.28793804E-06_JPRB /)

RGHG3(:,30, 4) = (/ &
  & 0.28297308E-06_JPRB, 0.28479406E-06_JPRB, 0.28581755E-06_JPRB, 0.28680822E-06_JPRB, 0.28779539E-06_JPRB, 0.28887061E-06_JPRB, &
  & 0.29004016E-06_JPRB, 0.29128915E-06_JPRB, 0.29262381E-06_JPRB, 0.29403884E-06_JPRB, 0.29553232E-06_JPRB, 0.29709119E-06_JPRB, &
  & 0.29868193E-06_JPRB, 0.30026482E-06_JPRB, 0.30179694E-06_JPRB, 0.30324784E-06_JPRB, 0.30460481E-06_JPRB, 0.30585355E-06_JPRB, &
  & 0.30698715E-06_JPRB, 0.30800339E-06_JPRB, 0.30890831E-06_JPRB, 0.30969875E-06_JPRB, 0.31038658E-06_JPRB, 0.31096769E-06_JPRB, &
  & 0.31146590E-06_JPRB, 0.31187693E-06_JPRB, 0.31223507E-06_JPRB, 0.31254766E-06_JPRB, 0.31282363E-06_JPRB, 0.31307241E-06_JPRB, &
  & 0.31329142E-06_JPRB, 0.31346508E-06_JPRB, 0.31357007E-06_JPRB, 0.31357908E-06_JPRB, 0.31346934E-06_JPRB, 0.31322975E-06_JPRB, &
  & 0.31286174E-06_JPRB, 0.31237803E-06_JPRB, 0.31181162E-06_JPRB, 0.31117781E-06_JPRB, 0.31048208E-06_JPRB, 0.30972990E-06_JPRB, &
  & 0.30892826E-06_JPRB, 0.30808559E-06_JPRB, 0.30718766E-06_JPRB, 0.30624446E-06_JPRB, 0.30526292E-06_JPRB, 0.30426327E-06_JPRB, &
  & 0.30326339E-06_JPRB, 0.30227642E-06_JPRB, 0.30131139E-06_JPRB, 0.30037310E-06_JPRB, 0.29946079E-06_JPRB, 0.29857048E-06_JPRB, &
  & 0.29769186E-06_JPRB, 0.29681621E-06_JPRB, 0.29593815E-06_JPRB, 0.29506094E-06_JPRB, 0.29420849E-06_JPRB, 0.29341567E-06_JPRB, &
  & 0.29272243E-06_JPRB, 0.29212518E-06_JPRB, 0.29156129E-06_JPRB, 0.29076591E-06_JPRB /)

RGHG3(:,31, 4) = (/ &
  & 0.28553868E-06_JPRB, 0.28718318E-06_JPRB, 0.28821961E-06_JPRB, 0.28910546E-06_JPRB, 0.29004880E-06_JPRB, 0.29105371E-06_JPRB, &
  & 0.29213484E-06_JPRB, 0.29329846E-06_JPRB, 0.29453301E-06_JPRB, 0.29584871E-06_JPRB, 0.29724981E-06_JPRB, 0.29872049E-06_JPRB, &
  & 0.30023489E-06_JPRB, 0.30175508E-06_JPRB, 0.30324412E-06_JPRB, 0.30466759E-06_JPRB, 0.30600054E-06_JPRB, 0.30723044E-06_JPRB, &
  & 0.30834460E-06_JPRB, 0.30933936E-06_JPRB, 0.31021926E-06_JPRB, 0.31098190E-06_JPRB, 0.31164294E-06_JPRB, 0.31219426E-06_JPRB, &
  & 0.31266688E-06_JPRB, 0.31304779E-06_JPRB, 0.31337723E-06_JPRB, 0.31365127E-06_JPRB, 0.31388421E-06_JPRB, 0.31407973E-06_JPRB, &
  & 0.31424037E-06_JPRB, 0.31435553E-06_JPRB, 0.31440948E-06_JPRB, 0.31438319E-06_JPRB, 0.31425907E-06_JPRB, 0.31402899E-06_JPRB, &
  & 0.31369817E-06_JPRB, 0.31328793E-06_JPRB, 0.31280911E-06_JPRB, 0.31227091E-06_JPRB, 0.31168466E-06_JPRB, 0.31105304E-06_JPRB, &
  & 0.31037848E-06_JPRB, 0.30965452E-06_JPRB, 0.30887682E-06_JPRB, 0.30804063E-06_JPRB, 0.30716447E-06_JPRB, 0.30626163E-06_JPRB, &
  & 0.30534690E-06_JPRB, 0.30443493E-06_JPRB, 0.30353465E-06_JPRB, 0.30265005E-06_JPRB, 0.30178390E-06_JPRB, 0.30093202E-06_JPRB, &
  & 0.30008567E-06_JPRB, 0.29923652E-06_JPRB, 0.29837972E-06_JPRB, 0.29752090E-06_JPRB, 0.29668405E-06_JPRB, 0.29590888E-06_JPRB, &
  & 0.29522866E-06_JPRB, 0.29464582E-06_JPRB, 0.29409415E-06_JPRB, 0.29330093E-06_JPRB /)

RGHG3(:,32, 4) = (/ &
  & 0.28783364E-06_JPRB, 0.28946377E-06_JPRB, 0.29038446E-06_JPRB, 0.29126397E-06_JPRB, 0.29213734E-06_JPRB, 0.29308180E-06_JPRB, &
  & 0.29409401E-06_JPRB, 0.29517031E-06_JPRB, 0.29631528E-06_JPRB, 0.29753684E-06_JPRB, 0.29884293E-06_JPRB, 0.30022855E-06_JPRB, &
  & 0.30166692E-06_JPRB, 0.30312415E-06_JPRB, 0.30456405E-06_JPRB, 0.30594910E-06_JPRB, 0.30725263E-06_JPRB, 0.30845706E-06_JPRB, &
  & 0.30954698E-06_JPRB, 0.31051559E-06_JPRB, 0.31136497E-06_JPRB, 0.31209785E-06_JPRB, 0.31272810E-06_JPRB, 0.31324964E-06_JPRB, &
  & 0.31369177E-06_JPRB, 0.31404559E-06_JPRB, 0.31434197E-06_JPRB, 0.31458381E-06_JPRB, 0.31477751E-06_JPRB, 0.31492974E-06_JPRB, &
  & 0.31504280E-06_JPRB, 0.31511166E-06_JPRB, 0.31512693E-06_JPRB, 0.31507557E-06_JPRB, 0.31494585E-06_JPRB, 0.31473377E-06_JPRB, &
  & 0.31444895E-06_JPRB, 0.31410011E-06_JPRB, 0.31369672E-06_JPRB, 0.31324799E-06_JPRB, 0.31275511E-06_JPRB, 0.31222180E-06_JPRB, &
  & 0.31164552E-06_JPRB, 0.31102016E-06_JPRB, 0.31033647E-06_JPRB, 0.30959717E-06_JPRB, 0.30881006E-06_JPRB, 0.30799106E-06_JPRB, &
  & 0.30715452E-06_JPRB, 0.30631003E-06_JPRB, 0.30546821E-06_JPRB, 0.30463613E-06_JPRB, 0.30381477E-06_JPRB, 0.30300262E-06_JPRB, &
  & 0.30219090E-06_JPRB, 0.30137224E-06_JPRB, 0.30054096E-06_JPRB, 0.29970550E-06_JPRB, 0.29889097E-06_JPRB, 0.29813660E-06_JPRB, &
  & 0.29747929E-06_JPRB, 0.29691196E-06_JPRB, 0.29637178E-06_JPRB, 0.29558686E-06_JPRB /)

RGHG3(:,33, 4) = (/ &
  & 0.29000421E-06_JPRB, 0.29152474E-06_JPRB, 0.29245990E-06_JPRB, 0.29326225E-06_JPRB, 0.29410336E-06_JPRB, 0.29499051E-06_JPRB, &
  & 0.29593167E-06_JPRB, 0.29693268E-06_JPRB, 0.29799020E-06_JPRB, 0.29911999E-06_JPRB, 0.30033578E-06_JPRB, 0.30163366E-06_JPRB, &
  & 0.30299526E-06_JPRB, 0.30438525E-06_JPRB, 0.30576828E-06_JPRB, 0.30711118E-06_JPRB, 0.30837782E-06_JPRB, 0.30954922E-06_JPRB, &
  & 0.31060659E-06_JPRB, 0.31154576E-06_JPRB, 0.31236175E-06_JPRB, 0.31306234E-06_JPRB, 0.31366017E-06_JPRB, 0.31415235E-06_JPRB, &
  & 0.31456239E-06_JPRB, 0.31488941E-06_JPRB, 0.31515413E-06_JPRB, 0.31536572E-06_JPRB, 0.31552634E-06_JPRB, 0.31564312E-06_JPRB, &
  & 0.31571929E-06_JPRB, 0.31575345E-06_JPRB, 0.31574120E-06_JPRB, 0.31567470E-06_JPRB, 0.31554728E-06_JPRB, 0.31535893E-06_JPRB, &
  & 0.31511405E-06_JPRB, 0.31481972E-06_JPRB, 0.31448286E-06_JPRB, 0.31410733E-06_JPRB, 0.31369137E-06_JPRB, 0.31323492E-06_JPRB, &
  & 0.31273424E-06_JPRB, 0.31218224E-06_JPRB, 0.31157589E-06_JPRB, 0.31091341E-06_JPRB, 0.31020431E-06_JPRB, 0.30946137E-06_JPRB, &
  & 0.30869342E-06_JPRB, 0.30791352E-06_JPRB, 0.30712931E-06_JPRB, 0.30634826E-06_JPRB, 0.30557493E-06_JPRB, 0.30480655E-06_JPRB, &
  & 0.30403504E-06_JPRB, 0.30325259E-06_JPRB, 0.30245457E-06_JPRB, 0.30164921E-06_JPRB, 0.30086380E-06_JPRB, 0.30013945E-06_JPRB, &
  & 0.29950553E-06_JPRB, 0.29895904E-06_JPRB, 0.29843375E-06_JPRB, 0.29766008E-06_JPRB /)

RGHG3(:,34, 4) = (/ &
  & 0.29202056E-06_JPRB, 0.29352825E-06_JPRB, 0.29437990E-06_JPRB, 0.29517318E-06_JPRB, 0.29595793E-06_JPRB, 0.29679006E-06_JPRB, &
  & 0.29767216E-06_JPRB, 0.29859640E-06_JPRB, 0.29957181E-06_JPRB, 0.30061349E-06_JPRB, 0.30173663E-06_JPRB, 0.30294589E-06_JPRB, &
  & 0.30422476E-06_JPRB, 0.30554642E-06_JPRB, 0.30687258E-06_JPRB, 0.30816528E-06_JPRB, 0.30938969E-06_JPRB, 0.31052008E-06_JPRB, &
  & 0.31153760E-06_JPRB, 0.31244107E-06_JPRB, 0.31322429E-06_JPRB, 0.31389186E-06_JPRB, 0.31445728E-06_JPRB, 0.31492056E-06_JPRB, &
  & 0.31529865E-06_JPRB, 0.31559870E-06_JPRB, 0.31583340E-06_JPRB, 0.31601630E-06_JPRB, 0.31614877E-06_JPRB, 0.31623725E-06_JPRB, &
  & 0.31628633E-06_JPRB, 0.31629654E-06_JPRB, 0.31626712E-06_JPRB, 0.31619464E-06_JPRB, 0.31607613E-06_JPRB, 0.31591208E-06_JPRB, &
  & 0.31570514E-06_JPRB, 0.31546017E-06_JPRB, 0.31517939E-06_JPRB, 0.31486059E-06_JPRB, 0.31450139E-06_JPRB, 0.31409905E-06_JPRB, &
  & 0.31365232E-06_JPRB, 0.31315602E-06_JPRB, 0.31260717E-06_JPRB, 0.31200841E-06_JPRB, 0.31136605E-06_JPRB, 0.31068777E-06_JPRB, &
  & 0.30998496E-06_JPRB, 0.30926432E-06_JPRB, 0.30853565E-06_JPRB, 0.30780859E-06_JPRB, 0.30708560E-06_JPRB, 0.30636562E-06_JPRB, &
  & 0.30564081E-06_JPRB, 0.30490224E-06_JPRB, 0.30414469E-06_JPRB, 0.30337881E-06_JPRB, 0.30263152E-06_JPRB, 0.30194107E-06_JPRB, &
  & 0.30133856E-06_JPRB, 0.30081449E-06_JPRB, 0.30030500E-06_JPRB, 0.29954751E-06_JPRB /)

RGHG3(:,35, 4) = (/ &
  & 0.29396941E-06_JPRB, 0.29539024E-06_JPRB, 0.29623840E-06_JPRB, 0.29696932E-06_JPRB, 0.29772042E-06_JPRB, 0.29849934E-06_JPRB, &
  & 0.29931616E-06_JPRB, 0.30017080E-06_JPRB, 0.30106563E-06_JPRB, 0.30202025E-06_JPRB, 0.30305435E-06_JPRB, 0.30417496E-06_JPRB, &
  & 0.30537231E-06_JPRB, 0.30661727E-06_JPRB, 0.30787953E-06_JPRB, 0.30911855E-06_JPRB, 0.31029560E-06_JPRB, 0.31138251E-06_JPRB, &
  & 0.31235726E-06_JPRB, 0.31321977E-06_JPRB, 0.31396874E-06_JPRB, 0.31460419E-06_JPRB, 0.31513738E-06_JPRB, 0.31557175E-06_JPRB, &
  & 0.31591807E-06_JPRB, 0.31618868E-06_JPRB, 0.31639456E-06_JPRB, 0.31654915E-06_JPRB, 0.31665698E-06_JPRB, 0.31672334E-06_JPRB, &
  & 0.31675344E-06_JPRB, 0.31674932E-06_JPRB, 0.31671217E-06_JPRB, 0.31664121E-06_JPRB, 0.31653573E-06_JPRB, 0.31639630E-06_JPRB, &
  & 0.31622497E-06_JPRB, 0.31602357E-06_JPRB, 0.31578855E-06_JPRB, 0.31551474E-06_JPRB, 0.31519494E-06_JPRB, 0.31482907E-06_JPRB, &
  & 0.31441738E-06_JPRB, 0.31395928E-06_JPRB, 0.31345550E-06_JPRB, 0.31290790E-06_JPRB, 0.31232170E-06_JPRB, 0.31170262E-06_JPRB, &
  & 0.31105469E-06_JPRB, 0.31038908E-06_JPRB, 0.30971398E-06_JPRB, 0.30903868E-06_JPRB, 0.30836810E-06_JPRB, 0.30770059E-06_JPRB, &
  & 0.30702716E-06_JPRB, 0.30633859E-06_JPRB, 0.30563095E-06_JPRB, 0.30491219E-06_JPRB, 0.30421037E-06_JPRB, 0.30356205E-06_JPRB, &
  & 0.30299285E-06_JPRB, 0.30249382E-06_JPRB, 0.30200502E-06_JPRB, 0.30126523E-06_JPRB /)

RGHG3(:,36, 4) = (/ &
  & 0.29582196E-06_JPRB, 0.29719516E-06_JPRB, 0.29797908E-06_JPRB, 0.29868858E-06_JPRB, 0.29939144E-06_JPRB, 0.30011947E-06_JPRB, &
  & 0.30087799E-06_JPRB, 0.30166052E-06_JPRB, 0.30247796E-06_JPRB, 0.30334880E-06_JPRB, 0.30429260E-06_JPRB, 0.30532237E-06_JPRB, &
  & 0.30643412E-06_JPRB, 0.30760597E-06_JPRB, 0.30879960E-06_JPRB, 0.30997739E-06_JPRB, 0.31109946E-06_JPRB, 0.31213975E-06_JPRB, &
  & 0.31307320E-06_JPRB, 0.31389683E-06_JPRB, 0.31461204E-06_JPRB, 0.31521708E-06_JPRB, 0.31571741E-06_JPRB, 0.31611921E-06_JPRB, &
  & 0.31643071E-06_JPRB, 0.31666684E-06_JPRB, 0.31684158E-06_JPRB, 0.31696737E-06_JPRB, 0.31705235E-06_JPRB, 0.31710144E-06_JPRB, &
  & 0.31711969E-06_JPRB, 0.31710923E-06_JPRB, 0.31707216E-06_JPRB, 0.31700890E-06_JPRB, 0.31691997E-06_JPRB, 0.31680577E-06_JPRB, &
  & 0.31666696E-06_JPRB, 0.31650188E-06_JPRB, 0.31630481E-06_JPRB, 0.31606655E-06_JPRB, 0.31577918E-06_JPRB, 0.31543954E-06_JPRB, &
  & 0.31505238E-06_JPRB, 0.31462253E-06_JPRB, 0.31415320E-06_JPRB, 0.31364871E-06_JPRB, 0.31310921E-06_JPRB, 0.31253680E-06_JPRB, &
  & 0.31193835E-06_JPRB, 0.31131958E-06_JPRB, 0.31069214E-06_JPRB, 0.31006641E-06_JPRB, 0.30944722E-06_JPRB, 0.30883271E-06_JPRB, &
  & 0.30821411E-06_JPRB, 0.30758122E-06_JPRB, 0.30692848E-06_JPRB, 0.30626543E-06_JPRB, 0.30561625E-06_JPRB, 0.30501440E-06_JPRB, &
  & 0.30448379E-06_JPRB, 0.30401404E-06_JPRB, 0.30354670E-06_JPRB, 0.30283368E-06_JPRB /)

RGHG3(:,37, 4) = (/ &
  & 0.29760997E-06_JPRB, 0.29890012E-06_JPRB, 0.29964818E-06_JPRB, 0.30031404E-06_JPRB, 0.30098147E-06_JPRB, 0.30166348E-06_JPRB, &
  & 0.30236285E-06_JPRB, 0.30307740E-06_JPRB, 0.30381810E-06_JPRB, 0.30460566E-06_JPRB, 0.30546241E-06_JPRB, 0.30640231E-06_JPRB, &
  & 0.30742561E-06_JPRB, 0.30851558E-06_JPRB, 0.30963901E-06_JPRB, 0.31075243E-06_JPRB, 0.31181636E-06_JPRB, 0.31280368E-06_JPRB, &
  & 0.31369615E-06_JPRB, 0.31448408E-06_JPRB, 0.31516740E-06_JPRB, 0.31574132E-06_JPRB, 0.31620476E-06_JPRB, 0.31656467E-06_JPRB, &
  & 0.31683263E-06_JPRB, 0.31702777E-06_JPRB, 0.31716712E-06_JPRB, 0.31726435E-06_JPRB, 0.31732878E-06_JPRB, 0.31736485E-06_JPRB, &
  & 0.31737682E-06_JPRB, 0.31736602E-06_JPRB, 0.31733410E-06_JPRB, 0.31728223E-06_JPRB, 0.31721115E-06_JPRB, 0.31712077E-06_JPRB, &
  & 0.31701066E-06_JPRB, 0.31687657E-06_JPRB, 0.31671132E-06_JPRB, 0.31650518E-06_JPRB, 0.31624811E-06_JPRB, 0.31593555E-06_JPRB, &
  & 0.31557244E-06_JPRB, 0.31516686E-06_JPRB, 0.31472791E-06_JPRB, 0.31425736E-06_JPRB, 0.31375714E-06_JPRB, 0.31322713E-06_JPRB, &
  & 0.31266850E-06_JPRB, 0.31209026E-06_JPRB, 0.31150407E-06_JPRB, 0.31092230E-06_JPRB, 0.31035165E-06_JPRB, 0.30978973E-06_JPRB, &
  & 0.30922655E-06_JPRB, 0.30865141E-06_JPRB, 0.30805893E-06_JPRB, 0.30745554E-06_JPRB, 0.30686448E-06_JPRB, 0.30631500E-06_JPRB, &
  & 0.30582697E-06_JPRB, 0.30538939E-06_JPRB, 0.30494999E-06_JPRB, 0.30426796E-06_JPRB /)

RGHG3(:,38, 4) = (/ &
  & 0.29932940E-06_JPRB, 0.30051979E-06_JPRB, 0.30122825E-06_JPRB, 0.30185657E-06_JPRB, 0.30249373E-06_JPRB, 0.30313535E-06_JPRB, &
  & 0.30378030E-06_JPRB, 0.30442948E-06_JPRB, 0.30509545E-06_JPRB, 0.30580031E-06_JPRB, 0.30656861E-06_JPRB, 0.30741725E-06_JPRB, &
  & 0.30835272E-06_JPRB, 0.30936039E-06_JPRB, 0.31040688E-06_JPRB, 0.31145174E-06_JPRB, 0.31245381E-06_JPRB, 0.31338828E-06_JPRB, &
  & 0.31423750E-06_JPRB, 0.31499036E-06_JPRB, 0.31563766E-06_JPRB, 0.31617267E-06_JPRB, 0.31658908E-06_JPRB, 0.31689703E-06_JPRB, &
  & 0.31711573E-06_JPRB, 0.31726813E-06_JPRB, 0.31737486E-06_JPRB, 0.31744818E-06_JPRB, 0.31749704E-06_JPRB, 0.31752458E-06_JPRB, &
  & 0.31753373E-06_JPRB, 0.31752498E-06_JPRB, 0.31749917E-06_JPRB, 0.31745768E-06_JPRB, 0.31740129E-06_JPRB, 0.31733029E-06_JPRB, &
  & 0.31724264E-06_JPRB, 0.31713415E-06_JPRB, 0.31699702E-06_JPRB, 0.31682112E-06_JPRB, 0.31659539E-06_JPRB, 0.31631436E-06_JPRB, &
  & 0.31598017E-06_JPRB, 0.31560384E-06_JPRB, 0.31519392E-06_JPRB, 0.31475832E-06_JPRB, 0.31429479E-06_JPRB, 0.31380077E-06_JPRB, &
  & 0.31327747E-06_JPRB, 0.31273234E-06_JPRB, 0.31218053E-06_JPRB, 0.31163745E-06_JPRB, 0.31111108E-06_JPRB, 0.31059895E-06_JPRB, &
  & 0.31009068E-06_JPRB, 0.30957398E-06_JPRB, 0.30904252E-06_JPRB, 0.30850168E-06_JPRB, 0.30797196E-06_JPRB, 0.30747864E-06_JPRB, &
  & 0.30703714E-06_JPRB, 0.30663711E-06_JPRB, 0.30622846E-06_JPRB, 0.30558613E-06_JPRB /)

RGHG3(:,39, 4) = (/ &
  & 0.30095771E-06_JPRB, 0.30207059E-06_JPRB, 0.30271264E-06_JPRB, 0.30332345E-06_JPRB, 0.30392610E-06_JPRB, 0.30453728E-06_JPRB, &
  & 0.30513434E-06_JPRB, 0.30571985E-06_JPRB, 0.30631193E-06_JPRB, 0.30693673E-06_JPRB, 0.30761697E-06_JPRB, 0.30837512E-06_JPRB, &
  & 0.30921962E-06_JPRB, 0.31014150E-06_JPRB, 0.31110983E-06_JPRB, 0.31208364E-06_JPRB, 0.31302397E-06_JPRB, 0.31390351E-06_JPRB, &
  & 0.31470680E-06_JPRB, 0.31541924E-06_JPRB, 0.31602269E-06_JPRB, 0.31650475E-06_JPRB, 0.31686608E-06_JPRB, 0.31712096E-06_JPRB, &
  & 0.31729505E-06_JPRB, 0.31741382E-06_JPRB, 0.31749636E-06_JPRB, 0.31755386E-06_JPRB, 0.31759288E-06_JPRB, 0.31761553E-06_JPRB, &
  & 0.31762374E-06_JPRB, 0.31761695E-06_JPRB, 0.31759575E-06_JPRB, 0.31756147E-06_JPRB, 0.31751526E-06_JPRB, 0.31745714E-06_JPRB, &
  & 0.31738568E-06_JPRB, 0.31729638E-06_JPRB, 0.31718224E-06_JPRB, 0.31703323E-06_JPRB, 0.31683840E-06_JPRB, 0.31658990E-06_JPRB, &
  & 0.31628980E-06_JPRB, 0.31594539E-06_JPRB, 0.31557073E-06_JPRB, 0.31516959E-06_JPRB, 0.31474229E-06_JPRB, 0.31428345E-06_JPRB, &
  & 0.31379128E-06_JPRB, 0.31327406E-06_JPRB, 0.31275050E-06_JPRB, 0.31224042E-06_JPRB, 0.31175387E-06_JPRB, 0.31128832E-06_JPRB, &
  & 0.31083181E-06_JPRB, 0.31037189E-06_JPRB, 0.30990006E-06_JPRB, 0.30942181E-06_JPRB, 0.30895421E-06_JPRB, 0.30851913E-06_JPRB, &
  & 0.30812751E-06_JPRB, 0.30776749E-06_JPRB, 0.30739446E-06_JPRB, 0.30679837E-06_JPRB /)

RGHG3(:,40, 4) = (/ &
  & 0.30251158E-06_JPRB, 0.30350799E-06_JPRB, 0.30412875E-06_JPRB, 0.30469292E-06_JPRB, 0.30528713E-06_JPRB, 0.30586807E-06_JPRB, &
  & 0.30642059E-06_JPRB, 0.30694744E-06_JPRB, 0.30746912E-06_JPRB, 0.30801158E-06_JPRB, 0.30860653E-06_JPRB, 0.30927481E-06_JPRB, &
  & 0.31003088E-06_JPRB, 0.31086753E-06_JPRB, 0.31175622E-06_JPRB, 0.31265671E-06_JPRB, 0.31353198E-06_JPRB, 0.31435633E-06_JPRB, &
  & 0.31510871E-06_JPRB, 0.31577292E-06_JPRB, 0.31632422E-06_JPRB, 0.31674921E-06_JPRB, 0.31705562E-06_JPRB, 0.31726591E-06_JPRB, &
  & 0.31740666E-06_JPRB, 0.31750210E-06_JPRB, 0.31756915E-06_JPRB, 0.31761655E-06_JPRB, 0.31764978E-06_JPRB, 0.31766984E-06_JPRB, &
  & 0.31767757E-06_JPRB, 0.31767235E-06_JPRB, 0.31765421E-06_JPRB, 0.31762460E-06_JPRB, 0.31758472E-06_JPRB, 0.31753515E-06_JPRB, &
  & 0.31747425E-06_JPRB, 0.31739876E-06_JPRB, 0.31730198E-06_JPRB, 0.31717514E-06_JPRB, 0.31700759E-06_JPRB, 0.31679167E-06_JPRB, &
  & 0.31652564E-06_JPRB, 0.31621809E-06_JPRB, 0.31587820E-06_JPRB, 0.31551457E-06_JPRB, 0.31512283E-06_JPRB, 0.31469634E-06_JPRB, &
  & 0.31423218E-06_JPRB, 0.31373941E-06_JPRB, 0.31323924E-06_JPRB, 0.31275758E-06_JPRB, 0.31230667E-06_JPRB, 0.31188392E-06_JPRB, &
  & 0.31147596E-06_JPRB, 0.31106833E-06_JPRB, 0.31065329E-06_JPRB, 0.31023393E-06_JPRB, 0.30982710E-06_JPRB, 0.30944955E-06_JPRB, &
  & 0.30910829E-06_JPRB, 0.30879056E-06_JPRB, 0.30845541E-06_JPRB, 0.30791023E-06_JPRB /)

RGHG3(:,41, 4) = (/ &
  & 0.30395694E-06_JPRB, 0.30488115E-06_JPRB, 0.30543927E-06_JPRB, 0.30599725E-06_JPRB, 0.30656523E-06_JPRB, 0.30712718E-06_JPRB, &
  & 0.30764070E-06_JPRB, 0.30811060E-06_JPRB, 0.30856231E-06_JPRB, 0.30902885E-06_JPRB, 0.30953740E-06_JPRB, 0.31011811E-06_JPRB, &
  & 0.31078622E-06_JPRB, 0.31153903E-06_JPRB, 0.31235015E-06_JPRB, 0.31318027E-06_JPRB, 0.31399196E-06_JPRB, 0.31475861E-06_JPRB, &
  & 0.31545829E-06_JPRB, 0.31606470E-06_JPRB, 0.31655892E-06_JPRB, 0.31692858E-06_JPRB, 0.31718807E-06_JPRB, 0.31736340E-06_JPRB, &
  & 0.31748027E-06_JPRB, 0.31755985E-06_JPRB, 0.31761653E-06_JPRB, 0.31765759E-06_JPRB, 0.31768718E-06_JPRB, 0.31770574E-06_JPRB, &
  & 0.31771339E-06_JPRB, 0.31770915E-06_JPRB, 0.31769306E-06_JPRB, 0.31766660E-06_JPRB, 0.31763111E-06_JPRB, 0.31758688E-06_JPRB, &
  & 0.31753356E-06_JPRB, 0.31746765E-06_JPRB, 0.31738409E-06_JPRB, 0.31727492E-06_JPRB, 0.31713108E-06_JPRB, 0.31694475E-06_JPRB, &
  & 0.31671399E-06_JPRB, 0.31644174E-06_JPRB, 0.31613916E-06_JPRB, 0.31580984E-06_JPRB, 0.31545184E-06_JPRB, 0.31505672E-06_JPRB, &
  & 0.31461926E-06_JPRB, 0.31414777E-06_JPRB, 0.31366909E-06_JPRB, 0.31321264E-06_JPRB, 0.31279501E-06_JPRB, 0.31241132E-06_JPRB, &
  & 0.31204746E-06_JPRB, 0.31168790E-06_JPRB, 0.31132384E-06_JPRB, 0.31095939E-06_JPRB, 0.31060864E-06_JPRB, 0.31028597E-06_JPRB, &
  & 0.30999314E-06_JPRB, 0.30971685E-06_JPRB, 0.30941962E-06_JPRB, 0.30892784E-06_JPRB /)

RGHG3(:,42, 4) = (/ &
  & 0.30531768E-06_JPRB, 0.30615954E-06_JPRB, 0.30669247E-06_JPRB, 0.30721594E-06_JPRB, 0.30777849E-06_JPRB, 0.30831836E-06_JPRB, &
  & 0.30879301E-06_JPRB, 0.30920981E-06_JPRB, 0.30959686E-06_JPRB, 0.30998729E-06_JPRB, 0.31041583E-06_JPRB, 0.31091071E-06_JPRB, &
  & 0.31149443E-06_JPRB, 0.31216595E-06_JPRB, 0.31290142E-06_JPRB, 0.31366267E-06_JPRB, 0.31441257E-06_JPRB, 0.31512175E-06_JPRB, &
  & 0.31576343E-06_JPRB, 0.31631188E-06_JPRB, 0.31674563E-06_JPRB, 0.31706475E-06_JPRB, 0.31728507E-06_JPRB, 0.31743355E-06_JPRB, &
  & 0.31753291E-06_JPRB, 0.31760121E-06_JPRB, 0.31765080E-06_JPRB, 0.31768744E-06_JPRB, 0.31771467E-06_JPRB, 0.31773220E-06_JPRB, &
  & 0.31773982E-06_JPRB, 0.31773644E-06_JPRB, 0.31772197E-06_JPRB, 0.31769758E-06_JPRB, 0.31766490E-06_JPRB, 0.31762482E-06_JPRB, &
  & 0.31757668E-06_JPRB, 0.31751807E-06_JPRB, 0.31744443E-06_JPRB, 0.31734947E-06_JPRB, 0.31722584E-06_JPRB, 0.31706705E-06_JPRB, &
  & 0.31686957E-06_JPRB, 0.31663521E-06_JPRB, 0.31636762E-06_JPRB, 0.31607362E-06_JPRB, 0.31574768E-06_JPRB, 0.31538104E-06_JPRB, &
  & 0.31496842E-06_JPRB, 0.31451859E-06_JPRB, 0.31405924E-06_JPRB, 0.31362862E-06_JPRB, 0.31324231E-06_JPRB, 0.31289588E-06_JPRB, &
  & 0.31257193E-06_JPRB, 0.31225525E-06_JPRB, 0.31193690E-06_JPRB, 0.31162077E-06_JPRB, 0.31132072E-06_JPRB, 0.31104693E-06_JPRB, &
  & 0.31079853E-06_JPRB, 0.31056103E-06_JPRB, 0.31030078E-06_JPRB, 0.30986104E-06_JPRB /)

RGHG3(:,43, 4) = (/ &
  & 0.30660078E-06_JPRB, 0.30737607E-06_JPRB, 0.30787376E-06_JPRB, 0.30837867E-06_JPRB, 0.30892528E-06_JPRB, 0.30944292E-06_JPRB, &
  & 0.30988286E-06_JPRB, 0.31024749E-06_JPRB, 0.31057453E-06_JPRB, 0.31089661E-06_JPRB, 0.31124804E-06_JPRB, 0.31166189E-06_JPRB, &
  & 0.31216325E-06_JPRB, 0.31275789E-06_JPRB, 0.31342239E-06_JPRB, 0.31411801E-06_JPRB, 0.31480678E-06_JPRB, 0.31545747E-06_JPRB, &
  & 0.31603861E-06_JPRB, 0.31652374E-06_JPRB, 0.31689947E-06_JPRB, 0.31717195E-06_JPRB, 0.31735982E-06_JPRB, 0.31748709E-06_JPRB, &
  & 0.31757313E-06_JPRB, 0.31763324E-06_JPRB, 0.31767755E-06_JPRB, 0.31771114E-06_JPRB, 0.31773655E-06_JPRB, 0.31775335E-06_JPRB, &
  & 0.31776099E-06_JPRB, 0.31775826E-06_JPRB, 0.31774493E-06_JPRB, 0.31772223E-06_JPRB, 0.31769179E-06_JPRB, 0.31765441E-06_JPRB, &
  & 0.31761027E-06_JPRB, 0.31755707E-06_JPRB, 0.31749133E-06_JPRB, 0.31740817E-06_JPRB, 0.31730187E-06_JPRB, 0.31716772E-06_JPRB, &
  & 0.31700316E-06_JPRB, 0.31680577E-06_JPRB, 0.31657754E-06_JPRB, 0.31631672E-06_JPRB, 0.31602229E-06_JPRB, 0.31568376E-06_JPRB, &
  & 0.31529549E-06_JPRB, 0.31486647E-06_JPRB, 0.31443042E-06_JPRB, 0.31402587E-06_JPRB, 0.31367176E-06_JPRB, 0.31335989E-06_JPRB, &
  & 0.31307275E-06_JPRB, 0.31279376E-06_JPRB, 0.31251514E-06_JPRB, 0.31224116E-06_JPRB, 0.31198445E-06_JPRB, 0.31175307E-06_JPRB, &
  & 0.31154329E-06_JPRB, 0.31134064E-06_JPRB, 0.31111432E-06_JPRB, 0.31072489E-06_JPRB /)

RGHG3(:,44, 4) = (/ &
  & 0.30781075E-06_JPRB, 0.30853721E-06_JPRB, 0.30899929E-06_JPRB, 0.30948527E-06_JPRB, 0.31001025E-06_JPRB, 0.31050882E-06_JPRB, &
  & 0.31090846E-06_JPRB, 0.31122934E-06_JPRB, 0.31150014E-06_JPRB, 0.31176225E-06_JPRB, 0.31204519E-06_JPRB, 0.31238412E-06_JPRB, &
  & 0.31280888E-06_JPRB, 0.31333008E-06_JPRB, 0.31392761E-06_JPRB, 0.31456071E-06_JPRB, 0.31518965E-06_JPRB, 0.31577596E-06_JPRB, &
  & 0.31629131E-06_JPRB, 0.31670928E-06_JPRB, 0.31702837E-06_JPRB, 0.31725884E-06_JPRB, 0.31741948E-06_JPRB, 0.31752950E-06_JPRB, &
  & 0.31760536E-06_JPRB, 0.31765921E-06_JPRB, 0.31769972E-06_JPRB, 0.31773095E-06_JPRB, 0.31775514E-06_JPRB, 0.31777139E-06_JPRB, &
  & 0.31777901E-06_JPRB, 0.31777677E-06_JPRB, 0.31776437E-06_JPRB, 0.31774306E-06_JPRB, 0.31771418E-06_JPRB, 0.31767900E-06_JPRB, &
  & 0.31763756E-06_JPRB, 0.31758859E-06_JPRB, 0.31752916E-06_JPRB, 0.31745572E-06_JPRB, 0.31736440E-06_JPRB, 0.31725267E-06_JPRB, &
  & 0.31711863E-06_JPRB, 0.31696038E-06_JPRB, 0.31677138E-06_JPRB, 0.31655034E-06_JPRB, 0.31628792E-06_JPRB, 0.31597762E-06_JPRB, &
  & 0.31561405E-06_JPRB, 0.31520867E-06_JPRB, 0.31479669E-06_JPRB, 0.31442181E-06_JPRB, 0.31409985E-06_JPRB, 0.31382135E-06_JPRB, &
  & 0.31356686E-06_JPRB, 0.31332121E-06_JPRB, 0.31307661E-06_JPRB, 0.31283804E-06_JPRB, 0.31261763E-06_JPRB, 0.31242141E-06_JPRB, &
  & 0.31224420E-06_JPRB, 0.31207188E-06_JPRB, 0.31187648E-06_JPRB, 0.31153482E-06_JPRB /)

RGHG3(:,45, 4) = (/ &
  & 0.30895882E-06_JPRB, 0.30963071E-06_JPRB, 0.31007363E-06_JPRB, 0.31053065E-06_JPRB, 0.31104199E-06_JPRB, 0.31151160E-06_JPRB, &
  & 0.31187935E-06_JPRB, 0.31215421E-06_JPRB, 0.31238085E-06_JPRB, 0.31258958E-06_JPRB, 0.31281604E-06_JPRB, 0.31308812E-06_JPRB, &
  & 0.31344223E-06_JPRB, 0.31389558E-06_JPRB, 0.31443039E-06_JPRB, 0.31500389E-06_JPRB, 0.31556672E-06_JPRB, 0.31608559E-06_JPRB, &
  & 0.31652260E-06_JPRB, 0.31687262E-06_JPRB, 0.31713637E-06_JPRB, 0.31733009E-06_JPRB, 0.31746748E-06_JPRB, 0.31756400E-06_JPRB, &
  & 0.31763170E-06_JPRB, 0.31768099E-06_JPRB, 0.31771859E-06_JPRB, 0.31774823E-06_JPRB, 0.31777145E-06_JPRB, 0.31778723E-06_JPRB, &
  & 0.31779473E-06_JPRB, 0.31779285E-06_JPRB, 0.31778131E-06_JPRB, 0.31776105E-06_JPRB, 0.31773345E-06_JPRB, 0.31769972E-06_JPRB, &
  & 0.31766047E-06_JPRB, 0.31761456E-06_JPRB, 0.31756014E-06_JPRB, 0.31749479E-06_JPRB, 0.31741632E-06_JPRB, 0.31732409E-06_JPRB, &
  & 0.31721893E-06_JPRB, 0.31709649E-06_JPRB, 0.31695239E-06_JPRB, 0.31677229E-06_JPRB, 0.31654972E-06_JPRB, 0.31627144E-06_JPRB, &
  & 0.31593484E-06_JPRB, 0.31555419E-06_JPRB, 0.31517033E-06_JPRB, 0.31482625E-06_JPRB, 0.31453698E-06_JPRB, 0.31428891E-06_JPRB, &
  & 0.31406486E-06_JPRB, 0.31384775E-06_JPRB, 0.31363237E-06_JPRB, 0.31342347E-06_JPRB, 0.31323293E-06_JPRB, 0.31306533E-06_JPRB, &
  & 0.31291512E-06_JPRB, 0.31276844E-06_JPRB, 0.31260106E-06_JPRB, 0.31230411E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART8',0,ZHOOK_HANDLE)



RGHG3(:,46, 4) = (/ &
  & 0.31003367E-06_JPRB, 0.31066472E-06_JPRB, 0.31108300E-06_JPRB, 0.31152314E-06_JPRB, 0.31201108E-06_JPRB, 0.31245673E-06_JPRB, &
  & 0.31278830E-06_JPRB, 0.31302744E-06_JPRB, 0.31321312E-06_JPRB, 0.31338362E-06_JPRB, 0.31356154E-06_JPRB, 0.31378255E-06_JPRB, &
  & 0.31407453E-06_JPRB, 0.31446481E-06_JPRB, 0.31494162E-06_JPRB, 0.31545025E-06_JPRB, 0.31594510E-06_JPRB, 0.31637666E-06_JPRB, &
  & 0.31673477E-06_JPRB, 0.31701234E-06_JPRB, 0.31722706E-06_JPRB, 0.31738807E-06_JPRB, 0.31750668E-06_JPRB, 0.31759208E-06_JPRB, &
  & 0.31765359E-06_JPRB, 0.31769940E-06_JPRB, 0.31773490E-06_JPRB, 0.31776347E-06_JPRB, 0.31778600E-06_JPRB, 0.31780132E-06_JPRB, &
  & 0.31780871E-06_JPRB, 0.31780715E-06_JPRB, 0.31779638E-06_JPRB, 0.31777702E-06_JPRB, 0.31775025E-06_JPRB, 0.31771759E-06_JPRB, &
  & 0.31767973E-06_JPRB, 0.31763622E-06_JPRB, 0.31758577E-06_JPRB, 0.31752717E-06_JPRB, 0.31745952E-06_JPRB, 0.31738449E-06_JPRB, &
  & 0.31730309E-06_JPRB, 0.31721490E-06_JPRB, 0.31711039E-06_JPRB, 0.31697908E-06_JPRB, 0.31680131E-06_JPRB, 0.31656484E-06_JPRB, &
  & 0.31626206E-06_JPRB, 0.31591020E-06_JPRB, 0.31555518E-06_JPRB, 0.31524385E-06_JPRB, 0.31498502E-06_JPRB, 0.31476750E-06_JPRB, &
  & 0.31456872E-06_JPRB, 0.31437807E-06_JPRB, 0.31418725E-06_JPRB, 0.31400344E-06_JPRB, 0.31383718E-06_JPRB, 0.31369296E-06_JPRB, &
  & 0.31356450E-06_JPRB, 0.31343984E-06_JPRB, 0.31329648E-06_JPRB, 0.31304182E-06_JPRB /)

RGHG3(:,47, 4) = (/ &
  & 0.31102400E-06_JPRB, 0.31163484E-06_JPRB, 0.31202572E-06_JPRB, 0.31245463E-06_JPRB, 0.31291864E-06_JPRB, 0.31333849E-06_JPRB, &
  & 0.31363848E-06_JPRB, 0.31384405E-06_JPRB, 0.31400134E-06_JPRB, 0.31413811E-06_JPRB, 0.31428522E-06_JPRB, 0.31446137E-06_JPRB, &
  & 0.31470691E-06_JPRB, 0.31504317E-06_JPRB, 0.31545736E-06_JPRB, 0.31590037E-06_JPRB, 0.31630390E-06_JPRB, 0.31664663E-06_JPRB, &
  & 0.31691610E-06_JPRB, 0.31713128E-06_JPRB, 0.31730093E-06_JPRB, 0.31743534E-06_JPRB, 0.31753825E-06_JPRB, 0.31761513E-06_JPRB, &
  & 0.31767189E-06_JPRB, 0.31771506E-06_JPRB, 0.31774925E-06_JPRB, 0.31777714E-06_JPRB, 0.31779913E-06_JPRB, 0.31781417E-06_JPRB, &
  & 0.31782145E-06_JPRB, 0.31782008E-06_JPRB, 0.31780979E-06_JPRB, 0.31779109E-06_JPRB, 0.31776506E-06_JPRB, 0.31773317E-06_JPRB, &
  & 0.31769628E-06_JPRB, 0.31765455E-06_JPRB, 0.31760740E-06_JPRB, 0.31755428E-06_JPRB, 0.31749587E-06_JPRB, 0.31743448E-06_JPRB, &
  & 0.31737349E-06_JPRB, 0.31731105E-06_JPRB, 0.31724238E-06_JPRB, 0.31715268E-06_JPRB, 0.31702601E-06_JPRB, 0.31684121E-06_JPRB, &
  & 0.31658595E-06_JPRB, 0.31627170E-06_JPRB, 0.31595124E-06_JPRB, 0.31567268E-06_JPRB, 0.31544619E-06_JPRB, 0.31525363E-06_JPRB, &
  & 0.31508097E-06_JPRB, 0.31491112E-06_JPRB, 0.31474241E-06_JPRB, 0.31457904E-06_JPRB, 0.31443301E-06_JPRB, 0.31430756E-06_JPRB, &
  & 0.31419722E-06_JPRB, 0.31409013E-06_JPRB, 0.31396780E-06_JPRB, 0.31374930E-06_JPRB /)

RGHG3(:,48, 4) = (/ &
  & 0.31194693E-06_JPRB, 0.31251685E-06_JPRB, 0.31291401E-06_JPRB, 0.31331433E-06_JPRB, 0.31377070E-06_JPRB, 0.31416016E-06_JPRB, &
  & 0.31443290E-06_JPRB, 0.31461377E-06_JPRB, 0.31474610E-06_JPRB, 0.31486246E-06_JPRB, 0.31498087E-06_JPRB, 0.31513073E-06_JPRB, &
  & 0.31533258E-06_JPRB, 0.31561729E-06_JPRB, 0.31596824E-06_JPRB, 0.31631888E-06_JPRB, 0.31662668E-06_JPRB, 0.31687151E-06_JPRB, &
  & 0.31706776E-06_JPRB, 0.31722658E-06_JPRB, 0.31736101E-06_JPRB, 0.31747305E-06_JPRB, 0.31756383E-06_JPRB, 0.31763409E-06_JPRB, &
  & 0.31768741E-06_JPRB, 0.31772885E-06_JPRB, 0.31776199E-06_JPRB, 0.31778947E-06_JPRB, 0.31781113E-06_JPRB, 0.31782579E-06_JPRB, &
  & 0.31783298E-06_JPRB, 0.31783168E-06_JPRB, 0.31782182E-06_JPRB, 0.31780371E-06_JPRB, 0.31777824E-06_JPRB, 0.31774681E-06_JPRB, &
  & 0.31771077E-06_JPRB, 0.31767047E-06_JPRB, 0.31762590E-06_JPRB, 0.31757742E-06_JPRB, 0.31752637E-06_JPRB, 0.31747638E-06_JPRB, &
  & 0.31743008E-06_JPRB, 0.31738807E-06_JPRB, 0.31734371E-06_JPRB, 0.31728788E-06_JPRB, 0.31720424E-06_JPRB, 0.31707489E-06_JPRB, &
  & 0.31687944E-06_JPRB, 0.31662262E-06_JPRB, 0.31635057E-06_JPRB, 0.31611165E-06_JPRB, 0.31591622E-06_JPRB, 0.31575101E-06_JPRB, &
  & 0.31559847E-06_JPRB, 0.31544937E-06_JPRB, 0.31529788E-06_JPRB, 0.31515202E-06_JPRB, 0.31502191E-06_JPRB, 0.31491183E-06_JPRB, &
  & 0.31481522E-06_JPRB, 0.31472251E-06_JPRB, 0.31461622E-06_JPRB, 0.31442769E-06_JPRB /)

RGHG3(:,49, 4) = (/ &
  & 0.31278202E-06_JPRB, 0.31335014E-06_JPRB, 0.31372343E-06_JPRB, 0.31413001E-06_JPRB, 0.31456011E-06_JPRB, 0.31493204E-06_JPRB, &
  & 0.31517925E-06_JPRB, 0.31533915E-06_JPRB, 0.31545395E-06_JPRB, 0.31555064E-06_JPRB, 0.31565111E-06_JPRB, 0.31576928E-06_JPRB, &
  & 0.31593683E-06_JPRB, 0.31615858E-06_JPRB, 0.31642179E-06_JPRB, 0.31667389E-06_JPRB, 0.31688228E-06_JPRB, 0.31704883E-06_JPRB, &
  & 0.31718457E-06_JPRB, 0.31730252E-06_JPRB, 0.31740822E-06_JPRB, 0.31750326E-06_JPRB, 0.31758444E-06_JPRB, 0.31764998E-06_JPRB, &
  & 0.31770102E-06_JPRB, 0.31774121E-06_JPRB, 0.31777375E-06_JPRB, 0.31780087E-06_JPRB, 0.31782199E-06_JPRB, 0.31783657E-06_JPRB, &
  & 0.31784353E-06_JPRB, 0.31784225E-06_JPRB, 0.31783264E-06_JPRB, 0.31781494E-06_JPRB, 0.31778987E-06_JPRB, 0.31775912E-06_JPRB, &
  & 0.31772367E-06_JPRB, 0.31768457E-06_JPRB, 0.31764216E-06_JPRB, 0.31759731E-06_JPRB, 0.31755229E-06_JPRB, 0.31751080E-06_JPRB, &
  & 0.31747629E-06_JPRB, 0.31744756E-06_JPRB, 0.31742050E-06_JPRB, 0.31738580E-06_JPRB, 0.31733393E-06_JPRB, 0.31724883E-06_JPRB, &
  & 0.31711562E-06_JPRB, 0.31693159E-06_JPRB, 0.31672681E-06_JPRB, 0.31654358E-06_JPRB, 0.31638609E-06_JPRB, 0.31624944E-06_JPRB, &
  & 0.31611913E-06_JPRB, 0.31598753E-06_JPRB, 0.31585216E-06_JPRB, 0.31572020E-06_JPRB, 0.31560339E-06_JPRB, 0.31550479E-06_JPRB, &
  & 0.31541936E-06_JPRB, 0.31533725E-06_JPRB, 0.31524289E-06_JPRB, 0.31507682E-06_JPRB /)

RGHG3(:,50, 4) = (/ &
  & 0.31354315E-06_JPRB, 0.31411480E-06_JPRB, 0.31448153E-06_JPRB, 0.31488091E-06_JPRB, 0.31529916E-06_JPRB, 0.31564451E-06_JPRB, &
  & 0.31586615E-06_JPRB, 0.31600342E-06_JPRB, 0.31609858E-06_JPRB, 0.31617583E-06_JPRB, 0.31625103E-06_JPRB, 0.31634167E-06_JPRB, &
  & 0.31645288E-06_JPRB, 0.31660704E-06_JPRB, 0.31677513E-06_JPRB, 0.31693531E-06_JPRB, 0.31706830E-06_JPRB, 0.31717835E-06_JPRB, &
  & 0.31727319E-06_JPRB, 0.31736087E-06_JPRB, 0.31744571E-06_JPRB, 0.31752688E-06_JPRB, 0.31760112E-06_JPRB, 0.31766342E-06_JPRB, &
  & 0.31771316E-06_JPRB, 0.31775267E-06_JPRB, 0.31778487E-06_JPRB, 0.31781147E-06_JPRB, 0.31783216E-06_JPRB, 0.31784649E-06_JPRB, &
  & 0.31785322E-06_JPRB, 0.31785200E-06_JPRB, 0.31784268E-06_JPRB, 0.31782528E-06_JPRB, 0.31780067E-06_JPRB, 0.31777026E-06_JPRB, &
  & 0.31773553E-06_JPRB, 0.31769747E-06_JPRB, 0.31765677E-06_JPRB, 0.31761482E-06_JPRB, 0.31757452E-06_JPRB, 0.31754001E-06_JPRB, &
  & 0.31751387E-06_JPRB, 0.31749497E-06_JPRB, 0.31747783E-06_JPRB, 0.31745719E-06_JPRB, 0.31742397E-06_JPRB, 0.31737071E-06_JPRB, &
  & 0.31728570E-06_JPRB, 0.31716763E-06_JPRB, 0.31704113E-06_JPRB, 0.31691982E-06_JPRB, 0.31681458E-06_JPRB, 0.31671311E-06_JPRB, &
  & 0.31661307E-06_JPRB, 0.31650484E-06_JPRB, 0.31638916E-06_JPRB, 0.31627280E-06_JPRB, 0.31616864E-06_JPRB, 0.31608096E-06_JPRB, &
  & 0.31600433E-06_JPRB, 0.31593007E-06_JPRB, 0.31584543E-06_JPRB, 0.31569354E-06_JPRB /)

RGHG3(:,51, 4) = (/ &
  & 0.31426663E-06_JPRB, 0.31479235E-06_JPRB, 0.31519167E-06_JPRB, 0.31555834E-06_JPRB, 0.31596227E-06_JPRB, 0.31626266E-06_JPRB, &
  & 0.31644370E-06_JPRB, 0.31654849E-06_JPRB, 0.31661546E-06_JPRB, 0.31666758E-06_JPRB, 0.31671573E-06_JPRB, 0.31676637E-06_JPRB, &
  & 0.31683604E-06_JPRB, 0.31691704E-06_JPRB, 0.31701774E-06_JPRB, 0.31711272E-06_JPRB, 0.31719765E-06_JPRB, 0.31727149E-06_JPRB, &
  & 0.31733970E-06_JPRB, 0.31740663E-06_JPRB, 0.31747541E-06_JPRB, 0.31754661E-06_JPRB, 0.31761499E-06_JPRB, 0.31767541E-06_JPRB, &
  & 0.31772453E-06_JPRB, 0.31776386E-06_JPRB, 0.31779558E-06_JPRB, 0.31782170E-06_JPRB, 0.31784191E-06_JPRB, 0.31785581E-06_JPRB, &
  & 0.31786232E-06_JPRB, 0.31786109E-06_JPRB, 0.31785183E-06_JPRB, 0.31783469E-06_JPRB, 0.31781045E-06_JPRB, 0.31778058E-06_JPRB, &
  & 0.31774638E-06_JPRB, 0.31770924E-06_JPRB, 0.31766990E-06_JPRB, 0.31763034E-06_JPRB, 0.31759396E-06_JPRB, 0.31756525E-06_JPRB, &
  & 0.31754581E-06_JPRB, 0.31753314E-06_JPRB, 0.31752307E-06_JPRB, 0.31750983E-06_JPRB, 0.31748920E-06_JPRB, 0.31745472E-06_JPRB, &
  & 0.31740166E-06_JPRB, 0.31733435E-06_JPRB, 0.31726231E-06_JPRB, 0.31719964E-06_JPRB, 0.31713967E-06_JPRB, 0.31708237E-06_JPRB, &
  & 0.31701893E-06_JPRB, 0.31694645E-06_JPRB, 0.31686130E-06_JPRB, 0.31677081E-06_JPRB, 0.31668591E-06_JPRB, 0.31661193E-06_JPRB, &
  & 0.31654628E-06_JPRB, 0.31648193E-06_JPRB, 0.31640434E-06_JPRB, 0.31626922E-06_JPRB /)

RGHG3(:,52, 4) = (/ &
  & 0.31487343E-06_JPRB, 0.31546358E-06_JPRB, 0.31578173E-06_JPRB, 0.31616725E-06_JPRB, 0.31649301E-06_JPRB, 0.31673093E-06_JPRB, &
  & 0.31685508E-06_JPRB, 0.31692082E-06_JPRB, 0.31696106E-06_JPRB, 0.31698937E-06_JPRB, 0.31701421E-06_JPRB, 0.31704201E-06_JPRB, &
  & 0.31707270E-06_JPRB, 0.31711986E-06_JPRB, 0.31717298E-06_JPRB, 0.31723206E-06_JPRB, 0.31728732E-06_JPRB, 0.31733956E-06_JPRB, &
  & 0.31739023E-06_JPRB, 0.31744301E-06_JPRB, 0.31750051E-06_JPRB, 0.31756292E-06_JPRB, 0.31762755E-06_JPRB, 0.31768653E-06_JPRB, &
  & 0.31773544E-06_JPRB, 0.31777472E-06_JPRB, 0.31780610E-06_JPRB, 0.31783165E-06_JPRB, 0.31785123E-06_JPRB, 0.31786468E-06_JPRB, &
  & 0.31787084E-06_JPRB, 0.31786954E-06_JPRB, 0.31786041E-06_JPRB, 0.31784353E-06_JPRB, 0.31781963E-06_JPRB, 0.31779024E-06_JPRB, &
  & 0.31775662E-06_JPRB, 0.31772015E-06_JPRB, 0.31768207E-06_JPRB, 0.31764461E-06_JPRB, 0.31761181E-06_JPRB, 0.31758773E-06_JPRB, &
  & 0.31757332E-06_JPRB, 0.31756551E-06_JPRB, 0.31755945E-06_JPRB, 0.31755161E-06_JPRB, 0.31753771E-06_JPRB, 0.31751568E-06_JPRB, &
  & 0.31748274E-06_JPRB, 0.31744335E-06_JPRB, 0.31740797E-06_JPRB, 0.31737636E-06_JPRB, 0.31734905E-06_JPRB, 0.31732117E-06_JPRB, &
  & 0.31729010E-06_JPRB, 0.31725162E-06_JPRB, 0.31720279E-06_JPRB, 0.31714569E-06_JPRB, 0.31708865E-06_JPRB, 0.31703712E-06_JPRB, &
  & 0.31698909E-06_JPRB, 0.31693898E-06_JPRB, 0.31687901E-06_JPRB, 0.31676058E-06_JPRB /)

RGHG3(:,53, 4) = (/ &
  & 0.31547751E-06_JPRB, 0.31595849E-06_JPRB, 0.31633522E-06_JPRB, 0.31660943E-06_JPRB, 0.31687949E-06_JPRB, 0.31703308E-06_JPRB, &
  & 0.31710849E-06_JPRB, 0.31714566E-06_JPRB, 0.31716655E-06_JPRB, 0.31718133E-06_JPRB, 0.31719378E-06_JPRB, 0.31720595E-06_JPRB, &
  & 0.31722357E-06_JPRB, 0.31724483E-06_JPRB, 0.31727777E-06_JPRB, 0.31731412E-06_JPRB, 0.31735243E-06_JPRB, 0.31739069E-06_JPRB, &
  & 0.31743033E-06_JPRB, 0.31747339E-06_JPRB, 0.31752234E-06_JPRB, 0.31757904E-06_JPRB, 0.31763955E-06_JPRB, 0.31769758E-06_JPRB, &
  & 0.31774641E-06_JPRB, 0.31778541E-06_JPRB, 0.31781641E-06_JPRB, 0.31784128E-06_JPRB, 0.31786027E-06_JPRB, 0.31787309E-06_JPRB, &
  & 0.31787889E-06_JPRB, 0.31787749E-06_JPRB, 0.31786834E-06_JPRB, 0.31785169E-06_JPRB, 0.31782818E-06_JPRB, 0.31779919E-06_JPRB, &
  & 0.31776614E-06_JPRB, 0.31773038E-06_JPRB, 0.31769349E-06_JPRB, 0.31765816E-06_JPRB, 0.31762838E-06_JPRB, 0.31760848E-06_JPRB, &
  & 0.31759808E-06_JPRB, 0.31759350E-06_JPRB, 0.31759060E-06_JPRB, 0.31758580E-06_JPRB, 0.31757688E-06_JPRB, 0.31756170E-06_JPRB, &
  & 0.31754044E-06_JPRB, 0.31751881E-06_JPRB, 0.31749977E-06_JPRB, 0.31748542E-06_JPRB, 0.31747282E-06_JPRB, 0.31746040E-06_JPRB, &
  & 0.31744642E-06_JPRB, 0.31742800E-06_JPRB, 0.31740373E-06_JPRB, 0.31737358E-06_JPRB, 0.31734234E-06_JPRB, 0.31731267E-06_JPRB, &
  & 0.31728467E-06_JPRB, 0.31725483E-06_JPRB, 0.31721390E-06_JPRB, 0.31713395E-06_JPRB /)

RGHG3(:,54, 4) = (/ &
  & 0.31592862E-06_JPRB, 0.31645720E-06_JPRB, 0.31669862E-06_JPRB, 0.31695123E-06_JPRB, 0.31711903E-06_JPRB, 0.31721731E-06_JPRB, &
  & 0.31725989E-06_JPRB, 0.31728001E-06_JPRB, 0.31729135E-06_JPRB, 0.31729888E-06_JPRB, 0.31730502E-06_JPRB, 0.31731167E-06_JPRB, &
  & 0.31731895E-06_JPRB, 0.31733236E-06_JPRB, 0.31735007E-06_JPRB, 0.31737466E-06_JPRB, 0.31740177E-06_JPRB, 0.31743113E-06_JPRB, &
  & 0.31746310E-06_JPRB, 0.31749966E-06_JPRB, 0.31754303E-06_JPRB, 0.31759447E-06_JPRB, 0.31765251E-06_JPRB, 0.31770875E-06_JPRB, &
  & 0.31775701E-06_JPRB, 0.31779567E-06_JPRB, 0.31782633E-06_JPRB, 0.31785069E-06_JPRB, 0.31786897E-06_JPRB, 0.31788124E-06_JPRB, &
  & 0.31788667E-06_JPRB, 0.31788500E-06_JPRB, 0.31787584E-06_JPRB, 0.31785927E-06_JPRB, 0.31783614E-06_JPRB, 0.31780769E-06_JPRB, &
  & 0.31777509E-06_JPRB, 0.31774010E-06_JPRB, 0.31770458E-06_JPRB, 0.31767135E-06_JPRB, 0.31764472E-06_JPRB, 0.31762792E-06_JPRB, &
  & 0.31762062E-06_JPRB, 0.31761857E-06_JPRB, 0.31761783E-06_JPRB, 0.31761542E-06_JPRB, 0.31760922E-06_JPRB, 0.31759879E-06_JPRB, &
  & 0.31758495E-06_JPRB, 0.31757170E-06_JPRB, 0.31756196E-06_JPRB, 0.31755468E-06_JPRB, 0.31754860E-06_JPRB, 0.31754291E-06_JPRB, &
  & 0.31753615E-06_JPRB, 0.31752762E-06_JPRB, 0.31751551E-06_JPRB, 0.31750039E-06_JPRB, 0.31748419E-06_JPRB, 0.31746953E-06_JPRB, &
  & 0.31745540E-06_JPRB, 0.31744042E-06_JPRB, 0.31742209E-06_JPRB, 0.31738435E-06_JPRB /)

RGHG3(:,55, 4) = (/ &
  & 0.31636830E-06_JPRB, 0.31676700E-06_JPRB, 0.31700705E-06_JPRB, 0.31715732E-06_JPRB, 0.31727399E-06_JPRB, 0.31733100E-06_JPRB, &
  & 0.31735570E-06_JPRB, 0.31736710E-06_JPRB, 0.31737318E-06_JPRB, 0.31737727E-06_JPRB, 0.31738057E-06_JPRB, 0.31738369E-06_JPRB, &
  & 0.31738836E-06_JPRB, 0.31739444E-06_JPRB, 0.31740606E-06_JPRB, 0.31742175E-06_JPRB, 0.31744167E-06_JPRB, 0.31746472E-06_JPRB, &
  & 0.31749153E-06_JPRB, 0.31752342E-06_JPRB, 0.31756275E-06_JPRB, 0.31761130E-06_JPRB, 0.31766598E-06_JPRB, 0.31772046E-06_JPRB, &
  & 0.31776750E-06_JPRB, 0.31780564E-06_JPRB, 0.31783597E-06_JPRB, 0.31785967E-06_JPRB, 0.31787746E-06_JPRB, 0.31788909E-06_JPRB, &
  & 0.31789401E-06_JPRB, 0.31789199E-06_JPRB, 0.31788284E-06_JPRB, 0.31786647E-06_JPRB, 0.31784361E-06_JPRB, 0.31781568E-06_JPRB, &
  & 0.31778367E-06_JPRB, 0.31774957E-06_JPRB, 0.31771549E-06_JPRB, 0.31768457E-06_JPRB, 0.31766064E-06_JPRB, 0.31764662E-06_JPRB, &
  & 0.31764156E-06_JPRB, 0.31764148E-06_JPRB, 0.31764247E-06_JPRB, 0.31764176E-06_JPRB, 0.31763770E-06_JPRB, 0.31762991E-06_JPRB, &
  & 0.31762013E-06_JPRB, 0.31761218E-06_JPRB, 0.31760635E-06_JPRB, 0.31760237E-06_JPRB, 0.31759922E-06_JPRB, 0.31759612E-06_JPRB, &
  & 0.31759276E-06_JPRB, 0.31758819E-06_JPRB, 0.31758208E-06_JPRB, 0.31757412E-06_JPRB, 0.31756576E-06_JPRB, 0.31755781E-06_JPRB, &
  & 0.31755064E-06_JPRB, 0.31754297E-06_JPRB, 0.31753194E-06_JPRB, 0.31750690E-06_JPRB /)

RGHG3(:,56, 4) = (/ &
  & 0.31669990E-06_JPRB, 0.31704928E-06_JPRB, 0.31719250E-06_JPRB, 0.31730275E-06_JPRB, 0.31737233E-06_JPRB, 0.31740745E-06_JPRB, &
  & 0.31742229E-06_JPRB, 0.31742883E-06_JPRB, 0.31743247E-06_JPRB, 0.31743488E-06_JPRB, 0.31743676E-06_JPRB, 0.31743872E-06_JPRB, &
  & 0.31744077E-06_JPRB, 0.31744474E-06_JPRB, 0.31745088E-06_JPRB, 0.31746154E-06_JPRB, 0.31747589E-06_JPRB, 0.31749425E-06_JPRB, &
  & 0.31751705E-06_JPRB, 0.31754587E-06_JPRB, 0.31758245E-06_JPRB, 0.31762815E-06_JPRB, 0.31768050E-06_JPRB, 0.31773237E-06_JPRB, &
  & 0.31777793E-06_JPRB, 0.31781533E-06_JPRB, 0.31784521E-06_JPRB, 0.31786857E-06_JPRB, 0.31788568E-06_JPRB, 0.31789676E-06_JPRB, &
  & 0.31790117E-06_JPRB, 0.31789878E-06_JPRB, 0.31788949E-06_JPRB, 0.31787334E-06_JPRB, 0.31785089E-06_JPRB, 0.31782349E-06_JPRB, &
  & 0.31779206E-06_JPRB, 0.31775895E-06_JPRB, 0.31772637E-06_JPRB, 0.31769764E-06_JPRB, 0.31767638E-06_JPRB, 0.31766464E-06_JPRB, &
  & 0.31766129E-06_JPRB, 0.31766277E-06_JPRB, 0.31766524E-06_JPRB, 0.31766595E-06_JPRB, 0.31766325E-06_JPRB, 0.31765731E-06_JPRB, &
  & 0.31765023E-06_JPRB, 0.31764449E-06_JPRB, 0.31764080E-06_JPRB, 0.31763830E-06_JPRB, 0.31763625E-06_JPRB, 0.31763449E-06_JPRB, &
  & 0.31763238E-06_JPRB, 0.31762988E-06_JPRB, 0.31762633E-06_JPRB, 0.31762181E-06_JPRB, 0.31761695E-06_JPRB, 0.31761289E-06_JPRB, &
  & 0.31760916E-06_JPRB, 0.31760572E-06_JPRB, 0.31760243E-06_JPRB, 0.31759842E-06_JPRB /)

RGHG3(:,57, 4) = (/ &
  & 0.31697209E-06_JPRB, 0.31722533E-06_JPRB, 0.31733020E-06_JPRB, 0.31739785E-06_JPRB, 0.31744116E-06_JPRB, 0.31746345E-06_JPRB, &
  & 0.31747260E-06_JPRB, 0.31747695E-06_JPRB, 0.31747919E-06_JPRB, 0.31748067E-06_JPRB, 0.31748189E-06_JPRB, 0.31748300E-06_JPRB, &
  & 0.31748445E-06_JPRB, 0.31748633E-06_JPRB, 0.31749028E-06_JPRB, 0.31749681E-06_JPRB, 0.31750704E-06_JPRB, 0.31752154E-06_JPRB, &
  & 0.31754121E-06_JPRB, 0.31756744E-06_JPRB, 0.31760203E-06_JPRB, 0.31764552E-06_JPRB, 0.31769508E-06_JPRB, 0.31774454E-06_JPRB, &
  & 0.31778842E-06_JPRB, 0.31782494E-06_JPRB, 0.31785450E-06_JPRB, 0.31787724E-06_JPRB, 0.31789386E-06_JPRB, 0.31790429E-06_JPRB, &
  & 0.31790819E-06_JPRB, 0.31790540E-06_JPRB, 0.31789597E-06_JPRB, 0.31787994E-06_JPRB, 0.31785788E-06_JPRB, 0.31783097E-06_JPRB, &
  & 0.31780041E-06_JPRB, 0.31776835E-06_JPRB, 0.31773757E-06_JPRB, 0.31771100E-06_JPRB, 0.31769184E-06_JPRB, 0.31768215E-06_JPRB, &
  & 0.31768027E-06_JPRB, 0.31768289E-06_JPRB, 0.31768656E-06_JPRB, 0.31768843E-06_JPRB, 0.31768681E-06_JPRB, 0.31768209E-06_JPRB, &
  & 0.31767632E-06_JPRB, 0.31767217E-06_JPRB, 0.31766933E-06_JPRB, 0.31766749E-06_JPRB, 0.31766598E-06_JPRB, 0.31766453E-06_JPRB, &
  & 0.31766302E-06_JPRB, 0.31766120E-06_JPRB, 0.31765879E-06_JPRB, 0.31765575E-06_JPRB, 0.31765268E-06_JPRB, 0.31764986E-06_JPRB, &
  & 0.31764748E-06_JPRB, 0.31764512E-06_JPRB, 0.31764216E-06_JPRB, 0.31763719E-06_JPRB /)

RGHG3(:,58, 4) = (/ &
  & 0.31722314E-06_JPRB, 0.31736289E-06_JPRB, 0.31742530E-06_JPRB, 0.31746504E-06_JPRB, 0.31749340E-06_JPRB, 0.31750733E-06_JPRB, &
  & 0.31751375E-06_JPRB, 0.31751659E-06_JPRB, 0.31751824E-06_JPRB, 0.31751929E-06_JPRB, 0.31752018E-06_JPRB, 0.31752108E-06_JPRB, &
  & 0.31752197E-06_JPRB, 0.31752336E-06_JPRB, 0.31752543E-06_JPRB, 0.31752961E-06_JPRB, 0.31753672E-06_JPRB, 0.31754803E-06_JPRB, &
  & 0.31756483E-06_JPRB, 0.31758907E-06_JPRB, 0.31762150E-06_JPRB, 0.31766285E-06_JPRB, 0.31770986E-06_JPRB, 0.31775684E-06_JPRB, &
  & 0.31779916E-06_JPRB, 0.31783489E-06_JPRB, 0.31786377E-06_JPRB, 0.31788608E-06_JPRB, 0.31790205E-06_JPRB, 0.31791171E-06_JPRB, &
  & 0.31791507E-06_JPRB, 0.31791191E-06_JPRB, 0.31790228E-06_JPRB, 0.31788642E-06_JPRB, 0.31786476E-06_JPRB, 0.31783844E-06_JPRB, &
  & 0.31780871E-06_JPRB, 0.31777813E-06_JPRB, 0.31774903E-06_JPRB, 0.31772441E-06_JPRB, 0.31770736E-06_JPRB, 0.31769920E-06_JPRB, &
  & 0.31769852E-06_JPRB, 0.31770219E-06_JPRB, 0.31770674E-06_JPRB, 0.31770966E-06_JPRB, 0.31770895E-06_JPRB, 0.31770520E-06_JPRB, &
  & 0.31770045E-06_JPRB, 0.31769667E-06_JPRB, 0.31769420E-06_JPRB, 0.31769241E-06_JPRB, 0.31769093E-06_JPRB, 0.31768965E-06_JPRB, &
  & 0.31768826E-06_JPRB, 0.31768673E-06_JPRB, 0.31768474E-06_JPRB, 0.31768238E-06_JPRB, 0.31767991E-06_JPRB, 0.31767780E-06_JPRB, &
  & 0.31767584E-06_JPRB, 0.31767391E-06_JPRB, 0.31767155E-06_JPRB, 0.31766692E-06_JPRB /)

RGHG3(:,59, 4) = (/ &
  & 0.31736121E-06_JPRB, 0.31745316E-06_JPRB, 0.31748991E-06_JPRB, 0.31751696E-06_JPRB, 0.31753405E-06_JPRB, 0.31754425E-06_JPRB, &
  & 0.31754871E-06_JPRB, 0.31755098E-06_JPRB, 0.31755232E-06_JPRB, 0.31755326E-06_JPRB, 0.31755411E-06_JPRB, 0.31755491E-06_JPRB, &
  & 0.31755584E-06_JPRB, 0.31755675E-06_JPRB, 0.31755829E-06_JPRB, 0.31756076E-06_JPRB, 0.31756548E-06_JPRB, 0.31757409E-06_JPRB, &
  & 0.31758859E-06_JPRB, 0.31761064E-06_JPRB, 0.31764117E-06_JPRB, 0.31768022E-06_JPRB, 0.31772470E-06_JPRB, 0.31776955E-06_JPRB, &
  & 0.31781039E-06_JPRB, 0.31784504E-06_JPRB, 0.31787329E-06_JPRB, 0.31789494E-06_JPRB, 0.31791012E-06_JPRB, 0.31791913E-06_JPRB, &
  & 0.31792186E-06_JPRB, 0.31791831E-06_JPRB, 0.31790853E-06_JPRB, 0.31789290E-06_JPRB, 0.31787170E-06_JPRB, 0.31784603E-06_JPRB, &
  & 0.31781747E-06_JPRB, 0.31778816E-06_JPRB, 0.31776085E-06_JPRB, 0.31773814E-06_JPRB, 0.31772277E-06_JPRB, 0.31771597E-06_JPRB, &
  & 0.31771620E-06_JPRB, 0.31772072E-06_JPRB, 0.31772603E-06_JPRB, 0.31772973E-06_JPRB, 0.31772998E-06_JPRB, 0.31772703E-06_JPRB, &
  & 0.31772262E-06_JPRB, 0.31771913E-06_JPRB, 0.31771651E-06_JPRB, 0.31771458E-06_JPRB, 0.31771305E-06_JPRB, 0.31771162E-06_JPRB, &
  & 0.31771023E-06_JPRB, 0.31770867E-06_JPRB, 0.31770674E-06_JPRB, 0.31770452E-06_JPRB, 0.31770242E-06_JPRB, 0.31770048E-06_JPRB, &
  & 0.31769883E-06_JPRB, 0.31769707E-06_JPRB, 0.31769477E-06_JPRB, 0.31769025E-06_JPRB /)

RGHG3(:,60, 4) = (/ &
  & 0.31746873E-06_JPRB, 0.31751694E-06_JPRB, 0.31754087E-06_JPRB, 0.31755673E-06_JPRB, 0.31756943E-06_JPRB, 0.31757651E-06_JPRB, &
  & 0.31758032E-06_JPRB, 0.31758219E-06_JPRB, 0.31758344E-06_JPRB, 0.31758438E-06_JPRB, 0.31758523E-06_JPRB, 0.31758614E-06_JPRB, &
  & 0.31758708E-06_JPRB, 0.31758825E-06_JPRB, 0.31758941E-06_JPRB, 0.31759095E-06_JPRB, 0.31759370E-06_JPRB, 0.31760018E-06_JPRB, &
  & 0.31761240E-06_JPRB, 0.31763250E-06_JPRB, 0.31766101E-06_JPRB, 0.31769778E-06_JPRB, 0.31773993E-06_JPRB, 0.31778268E-06_JPRB, &
  & 0.31782196E-06_JPRB, 0.31785558E-06_JPRB, 0.31788289E-06_JPRB, 0.31790375E-06_JPRB, 0.31791819E-06_JPRB, 0.31792644E-06_JPRB, &
  & 0.31792862E-06_JPRB, 0.31792467E-06_JPRB, 0.31791484E-06_JPRB, 0.31789929E-06_JPRB, 0.31787869E-06_JPRB, 0.31785382E-06_JPRB, &
  & 0.31782642E-06_JPRB, 0.31779868E-06_JPRB, 0.31777302E-06_JPRB, 0.31775207E-06_JPRB, 0.31773817E-06_JPRB, 0.31773251E-06_JPRB, &
  & 0.31773359E-06_JPRB, 0.31773868E-06_JPRB, 0.31774474E-06_JPRB, 0.31774906E-06_JPRB, 0.31775008E-06_JPRB, 0.31774792E-06_JPRB, &
  & 0.31774400E-06_JPRB, 0.31774022E-06_JPRB, 0.31773732E-06_JPRB, 0.31773504E-06_JPRB, 0.31773317E-06_JPRB, 0.31773152E-06_JPRB, &
  & 0.31772993E-06_JPRB, 0.31772817E-06_JPRB, 0.31772620E-06_JPRB, 0.31772396E-06_JPRB, 0.31772183E-06_JPRB, 0.31772015E-06_JPRB, &
  & 0.31771850E-06_JPRB, 0.31771685E-06_JPRB, 0.31771469E-06_JPRB, 0.31771020E-06_JPRB /)

RGHG3(:,61, 4) = (/ &
  & 0.31752802E-06_JPRB, 0.31756298E-06_JPRB, 0.31757867E-06_JPRB, 0.31759083E-06_JPRB, 0.31759964E-06_JPRB, 0.31760572E-06_JPRB, &
  & 0.31760896E-06_JPRB, 0.31761090E-06_JPRB, 0.31761215E-06_JPRB, 0.31761317E-06_JPRB, 0.31761419E-06_JPRB, 0.31761527E-06_JPRB, &
  & 0.31761664E-06_JPRB, 0.31761797E-06_JPRB, 0.31761928E-06_JPRB, 0.31762019E-06_JPRB, 0.31762158E-06_JPRB, 0.31762622E-06_JPRB, &
  & 0.31763648E-06_JPRB, 0.31765458E-06_JPRB, 0.31768104E-06_JPRB, 0.31771569E-06_JPRB, 0.31775554E-06_JPRB, 0.31779626E-06_JPRB, &
  & 0.31783401E-06_JPRB, 0.31786627E-06_JPRB, 0.31789256E-06_JPRB, 0.31791242E-06_JPRB, 0.31792609E-06_JPRB, 0.31793365E-06_JPRB, &
  & 0.31793533E-06_JPRB, 0.31793112E-06_JPRB, 0.31792121E-06_JPRB, 0.31790589E-06_JPRB, 0.31788588E-06_JPRB, 0.31786209E-06_JPRB, &
  & 0.31783588E-06_JPRB, 0.31780959E-06_JPRB, 0.31778561E-06_JPRB, 0.31776628E-06_JPRB, 0.31775372E-06_JPRB, 0.31774894E-06_JPRB, &
  & 0.31775070E-06_JPRB, 0.31775625E-06_JPRB, 0.31776275E-06_JPRB, 0.31776761E-06_JPRB, 0.31776938E-06_JPRB, 0.31776798E-06_JPRB, &
  & 0.31776443E-06_JPRB, 0.31776062E-06_JPRB, 0.31775721E-06_JPRB, 0.31775437E-06_JPRB, 0.31775201E-06_JPRB, 0.31774988E-06_JPRB, &
  & 0.31774798E-06_JPRB, 0.31774596E-06_JPRB, 0.31774368E-06_JPRB, 0.31774135E-06_JPRB, 0.31773936E-06_JPRB, 0.31773754E-06_JPRB, &
  & 0.31773598E-06_JPRB, 0.31773425E-06_JPRB, 0.31773197E-06_JPRB, 0.31772726E-06_JPRB /)

RGHG3(:,62, 4) = (/ &
  & 0.31757509E-06_JPRB, 0.31759919E-06_JPRB, 0.31761118E-06_JPRB, 0.31761994E-06_JPRB, 0.31762738E-06_JPRB, 0.31763250E-06_JPRB, &
  & 0.31763577E-06_JPRB, 0.31763776E-06_JPRB, 0.31763926E-06_JPRB, 0.31764051E-06_JPRB, 0.31764182E-06_JPRB, 0.31764336E-06_JPRB, &
  & 0.31764506E-06_JPRB, 0.31764699E-06_JPRB, 0.31764847E-06_JPRB, 0.31764893E-06_JPRB, 0.31764921E-06_JPRB, 0.31765228E-06_JPRB, &
  & 0.31766081E-06_JPRB, 0.31767706E-06_JPRB, 0.31770156E-06_JPRB, 0.31773408E-06_JPRB, 0.31777168E-06_JPRB, 0.31781033E-06_JPRB, &
  & 0.31784629E-06_JPRB, 0.31787712E-06_JPRB, 0.31790216E-06_JPRB, 0.31792101E-06_JPRB, 0.31793383E-06_JPRB, 0.31794079E-06_JPRB, &
  & 0.31794198E-06_JPRB, 0.31793752E-06_JPRB, 0.31792766E-06_JPRB, 0.31791271E-06_JPRB, 0.31789335E-06_JPRB, 0.31787062E-06_JPRB, &
  & 0.31784577E-06_JPRB, 0.31782102E-06_JPRB, 0.31779854E-06_JPRB, 0.31778058E-06_JPRB, 0.31776926E-06_JPRB, 0.31776540E-06_JPRB, &
  & 0.31776779E-06_JPRB, 0.31777373E-06_JPRB, 0.31778049E-06_JPRB, 0.31778580E-06_JPRB, 0.31778808E-06_JPRB, 0.31778734E-06_JPRB, &
  & 0.31778444E-06_JPRB, 0.31778052E-06_JPRB, 0.31777668E-06_JPRB, 0.31777321E-06_JPRB, 0.31777017E-06_JPRB, 0.31776756E-06_JPRB, &
  & 0.31776511E-06_JPRB, 0.31776261E-06_JPRB, 0.31776008E-06_JPRB, 0.31775755E-06_JPRB, 0.31775537E-06_JPRB, 0.31775363E-06_JPRB, &
  & 0.31775187E-06_JPRB, 0.31775008E-06_JPRB, 0.31774761E-06_JPRB, 0.31774238E-06_JPRB /)

RGHG3(:,63, 4) = (/ &
  & 0.31761081E-06_JPRB, 0.31762971E-06_JPRB, 0.31763904E-06_JPRB, 0.31764642E-06_JPRB, 0.31765262E-06_JPRB, 0.31765759E-06_JPRB, &
  & 0.31766086E-06_JPRB, 0.31766322E-06_JPRB, 0.31766501E-06_JPRB, 0.31766675E-06_JPRB, 0.31766854E-06_JPRB, 0.31767053E-06_JPRB, &
  & 0.31767297E-06_JPRB, 0.31767547E-06_JPRB, 0.31767718E-06_JPRB, 0.31767718E-06_JPRB, 0.31767652E-06_JPRB, 0.31767831E-06_JPRB, &
  & 0.31768536E-06_JPRB, 0.31769977E-06_JPRB, 0.31772254E-06_JPRB, 0.31775301E-06_JPRB, 0.31778836E-06_JPRB, 0.31782483E-06_JPRB, &
  & 0.31785885E-06_JPRB, 0.31788809E-06_JPRB, 0.31791168E-06_JPRB, 0.31792945E-06_JPRB, 0.31794139E-06_JPRB, 0.31794764E-06_JPRB, &
  & 0.31794849E-06_JPRB, 0.31794394E-06_JPRB, 0.31793434E-06_JPRB, 0.31791990E-06_JPRB, 0.31790134E-06_JPRB, 0.31787977E-06_JPRB, &
  & 0.31785621E-06_JPRB, 0.31783287E-06_JPRB, 0.31781178E-06_JPRB, 0.31779530E-06_JPRB, 0.31778507E-06_JPRB, 0.31778194E-06_JPRB, &
  & 0.31778470E-06_JPRB, 0.31779084E-06_JPRB, 0.31779788E-06_JPRB, 0.31780351E-06_JPRB, 0.31780630E-06_JPRB, 0.31780613E-06_JPRB, &
  & 0.31780368E-06_JPRB, 0.31780002E-06_JPRB, 0.31779578E-06_JPRB, 0.31779183E-06_JPRB, 0.31778814E-06_JPRB, 0.31778481E-06_JPRB, &
  & 0.31778168E-06_JPRB, 0.31777876E-06_JPRB, 0.31777574E-06_JPRB, 0.31777302E-06_JPRB, 0.31777071E-06_JPRB, 0.31776872E-06_JPRB, &
  & 0.31776693E-06_JPRB, 0.31776491E-06_JPRB, 0.31776207E-06_JPRB, 0.31775616E-06_JPRB /)

RGHG3(:,64, 4) = (/ &
  & 0.31764009E-06_JPRB, 0.31765583E-06_JPRB, 0.31766399E-06_JPRB, 0.31767041E-06_JPRB, 0.31767627E-06_JPRB, 0.31768099E-06_JPRB, &
  & 0.31768471E-06_JPRB, 0.31768735E-06_JPRB, 0.31768971E-06_JPRB, 0.31769184E-06_JPRB, 0.31769432E-06_JPRB, 0.31769719E-06_JPRB, &
  & 0.31770048E-06_JPRB, 0.31770364E-06_JPRB, 0.31770526E-06_JPRB, 0.31770472E-06_JPRB, 0.31770327E-06_JPRB, 0.31770412E-06_JPRB, &
  & 0.31770986E-06_JPRB, 0.31772279E-06_JPRB, 0.31774377E-06_JPRB, 0.31777228E-06_JPRB, 0.31780536E-06_JPRB, 0.31783964E-06_JPRB, &
  & 0.31787155E-06_JPRB, 0.31789898E-06_JPRB, 0.31792109E-06_JPRB, 0.31793755E-06_JPRB, 0.31794863E-06_JPRB, 0.31795417E-06_JPRB, &
  & 0.31795480E-06_JPRB, 0.31795022E-06_JPRB, 0.31794096E-06_JPRB, 0.31792723E-06_JPRB, 0.31790972E-06_JPRB, 0.31788926E-06_JPRB, &
  & 0.31786712E-06_JPRB, 0.31784526E-06_JPRB, 0.31782548E-06_JPRB, 0.31781019E-06_JPRB, 0.31780101E-06_JPRB, 0.31779848E-06_JPRB, &
  & 0.31780149E-06_JPRB, 0.31780775E-06_JPRB, 0.31781482E-06_JPRB, 0.31782059E-06_JPRB, 0.31782378E-06_JPRB, 0.31782403E-06_JPRB, &
  & 0.31782201E-06_JPRB, 0.31781855E-06_JPRB, 0.31781437E-06_JPRB, 0.31780993E-06_JPRB, 0.31780567E-06_JPRB, 0.31780164E-06_JPRB, &
  & 0.31779800E-06_JPRB, 0.31779436E-06_JPRB, 0.31779101E-06_JPRB, 0.31778796E-06_JPRB, 0.31778546E-06_JPRB, 0.31778342E-06_JPRB, &
  & 0.31778131E-06_JPRB, 0.31777904E-06_JPRB, 0.31777574E-06_JPRB, 0.31776855E-06_JPRB /)

RGHG3(:,65, 4) = (/ &
  & 0.31766399E-06_JPRB, 0.31767894E-06_JPRB, 0.31768656E-06_JPRB, 0.31769287E-06_JPRB, 0.31769844E-06_JPRB, 0.31770338E-06_JPRB, &
  & 0.31770725E-06_JPRB, 0.31771057E-06_JPRB, 0.31771336E-06_JPRB, 0.31771643E-06_JPRB, 0.31771964E-06_JPRB, 0.31772356E-06_JPRB, &
  & 0.31772777E-06_JPRB, 0.31773106E-06_JPRB, 0.31773240E-06_JPRB, 0.31773143E-06_JPRB, 0.31772953E-06_JPRB, 0.31772962E-06_JPRB, &
  & 0.31773439E-06_JPRB, 0.31774590E-06_JPRB, 0.31776523E-06_JPRB, 0.31779169E-06_JPRB, 0.31782267E-06_JPRB, 0.31785447E-06_JPRB, &
  & 0.31788414E-06_JPRB, 0.31790970E-06_JPRB, 0.31793004E-06_JPRB, 0.31794525E-06_JPRB, 0.31795528E-06_JPRB, 0.31796026E-06_JPRB, &
  & 0.31796066E-06_JPRB, 0.31795622E-06_JPRB, 0.31794747E-06_JPRB, 0.31793454E-06_JPRB, 0.31791811E-06_JPRB, 0.31789892E-06_JPRB, &
  & 0.31787818E-06_JPRB, 0.31785780E-06_JPRB, 0.31783941E-06_JPRB, 0.31782525E-06_JPRB, 0.31781715E-06_JPRB, 0.31781511E-06_JPRB, &
  & 0.31781821E-06_JPRB, 0.31782434E-06_JPRB, 0.31783136E-06_JPRB, 0.31783728E-06_JPRB, 0.31784069E-06_JPRB, 0.31784120E-06_JPRB, &
  & 0.31783949E-06_JPRB, 0.31783622E-06_JPRB, 0.31783202E-06_JPRB, 0.31782744E-06_JPRB, 0.31782272E-06_JPRB, 0.31781840E-06_JPRB, &
  & 0.31781411E-06_JPRB, 0.31781011E-06_JPRB, 0.31780621E-06_JPRB, 0.31780294E-06_JPRB, 0.31780019E-06_JPRB, 0.31779780E-06_JPRB, &
  & 0.31779561E-06_JPRB, 0.31779288E-06_JPRB, 0.31778876E-06_JPRB, 0.31777995E-06_JPRB /)

RGHG3(:,66, 4) = (/ &
  & 0.31768445E-06_JPRB, 0.31769963E-06_JPRB, 0.31770765E-06_JPRB, 0.31771395E-06_JPRB, 0.31771970E-06_JPRB, 0.31772481E-06_JPRB, &
  & 0.31772919E-06_JPRB, 0.31773280E-06_JPRB, 0.31773655E-06_JPRB, 0.31774022E-06_JPRB, 0.31774474E-06_JPRB, 0.31774948E-06_JPRB, &
  & 0.31775429E-06_JPRB, 0.31775747E-06_JPRB, 0.31775846E-06_JPRB, 0.31775716E-06_JPRB, 0.31775491E-06_JPRB, 0.31775451E-06_JPRB, &
  & 0.31775849E-06_JPRB, 0.31776887E-06_JPRB, 0.31778657E-06_JPRB, 0.31781113E-06_JPRB, 0.31783961E-06_JPRB, 0.31786905E-06_JPRB, &
  & 0.31789634E-06_JPRB, 0.31791987E-06_JPRB, 0.31793851E-06_JPRB, 0.31795230E-06_JPRB, 0.31796128E-06_JPRB, 0.31796571E-06_JPRB, &
  & 0.31796591E-06_JPRB, 0.31796168E-06_JPRB, 0.31795366E-06_JPRB, 0.31794158E-06_JPRB, 0.31792638E-06_JPRB, 0.31790859E-06_JPRB, &
  & 0.31788940E-06_JPRB, 0.31787050E-06_JPRB, 0.31785342E-06_JPRB, 0.31784052E-06_JPRB, 0.31783324E-06_JPRB, 0.31783159E-06_JPRB, &
  & 0.31783472E-06_JPRB, 0.31784063E-06_JPRB, 0.31784737E-06_JPRB, 0.31785325E-06_JPRB, 0.31785680E-06_JPRB, 0.31785754E-06_JPRB, &
  & 0.31785618E-06_JPRB, 0.31785311E-06_JPRB, 0.31784896E-06_JPRB, 0.31784424E-06_JPRB, 0.31783941E-06_JPRB, 0.31783466E-06_JPRB, &
  & 0.31783017E-06_JPRB, 0.31782560E-06_JPRB, 0.31782147E-06_JPRB, 0.31781784E-06_JPRB, 0.31781485E-06_JPRB, 0.31781229E-06_JPRB, &
  & 0.31780974E-06_JPRB, 0.31780661E-06_JPRB, 0.31780166E-06_JPRB, 0.31779092E-06_JPRB /)

RGHG3(:,67, 4) = (/ &
  & 0.31770259E-06_JPRB, 0.31771930E-06_JPRB, 0.31772768E-06_JPRB, 0.31773453E-06_JPRB, 0.31774059E-06_JPRB, 0.31774599E-06_JPRB, &
  & 0.31775068E-06_JPRB, 0.31775502E-06_JPRB, 0.31775917E-06_JPRB, 0.31776412E-06_JPRB, 0.31776921E-06_JPRB, 0.31777483E-06_JPRB, &
  & 0.31777952E-06_JPRB, 0.31778254E-06_JPRB, 0.31778336E-06_JPRB, 0.31778194E-06_JPRB, 0.31777961E-06_JPRB, 0.31777890E-06_JPRB, &
  & 0.31778225E-06_JPRB, 0.31779157E-06_JPRB, 0.31780783E-06_JPRB, 0.31783020E-06_JPRB, 0.31785640E-06_JPRB, 0.31788321E-06_JPRB, &
  & 0.31790819E-06_JPRB, 0.31792942E-06_JPRB, 0.31794630E-06_JPRB, 0.31795861E-06_JPRB, 0.31796662E-06_JPRB, 0.31797052E-06_JPRB, &
  & 0.31797052E-06_JPRB, 0.31796665E-06_JPRB, 0.31795921E-06_JPRB, 0.31794829E-06_JPRB, 0.31793431E-06_JPRB, 0.31791802E-06_JPRB, &
  & 0.31790040E-06_JPRB, 0.31788304E-06_JPRB, 0.31786746E-06_JPRB, 0.31785567E-06_JPRB, 0.31784919E-06_JPRB, 0.31784799E-06_JPRB, &
  & 0.31785098E-06_JPRB, 0.31785655E-06_JPRB, 0.31786294E-06_JPRB, 0.31786865E-06_JPRB, 0.31787226E-06_JPRB, 0.31787326E-06_JPRB, &
  & 0.31787209E-06_JPRB, 0.31786919E-06_JPRB, 0.31786510E-06_JPRB, 0.31786044E-06_JPRB, 0.31785552E-06_JPRB, 0.31785069E-06_JPRB, &
  & 0.31784586E-06_JPRB, 0.31784111E-06_JPRB, 0.31783671E-06_JPRB, 0.31783290E-06_JPRB, 0.31782966E-06_JPRB, 0.31782679E-06_JPRB, &
  & 0.31782403E-06_JPRB, 0.31782042E-06_JPRB, 0.31781462E-06_JPRB, 0.31780218E-06_JPRB /)

RGHG3(:,68, 4) = (/ &
  & 0.31772001E-06_JPRB, 0.31773794E-06_JPRB, 0.31774769E-06_JPRB, 0.31775500E-06_JPRB, 0.31776150E-06_JPRB, 0.31776722E-06_JPRB, &
  & 0.31777222E-06_JPRB, 0.31777702E-06_JPRB, 0.31778197E-06_JPRB, 0.31778740E-06_JPRB, 0.31779331E-06_JPRB, 0.31779894E-06_JPRB, &
  & 0.31780351E-06_JPRB, 0.31780638E-06_JPRB, 0.31780709E-06_JPRB, 0.31780573E-06_JPRB, 0.31780348E-06_JPRB, 0.31780263E-06_JPRB, &
  & 0.31780544E-06_JPRB, 0.31781386E-06_JPRB, 0.31782861E-06_JPRB, 0.31784899E-06_JPRB, 0.31787255E-06_JPRB, 0.31789682E-06_JPRB, &
  & 0.31791922E-06_JPRB, 0.31793840E-06_JPRB, 0.31795346E-06_JPRB, 0.31796441E-06_JPRB, 0.31797140E-06_JPRB, 0.31797481E-06_JPRB, &
  & 0.31797472E-06_JPRB, 0.31797117E-06_JPRB, 0.31796449E-06_JPRB, 0.31795440E-06_JPRB, 0.31794184E-06_JPRB, 0.31792712E-06_JPRB, &
  & 0.31791117E-06_JPRB, 0.31789534E-06_JPRB, 0.31788127E-06_JPRB, 0.31787067E-06_JPRB, 0.31786502E-06_JPRB, 0.31786402E-06_JPRB, &
  & 0.31786692E-06_JPRB, 0.31787201E-06_JPRB, 0.31787809E-06_JPRB, 0.31788355E-06_JPRB, 0.31788713E-06_JPRB, 0.31788824E-06_JPRB, &
  & 0.31788719E-06_JPRB, 0.31788454E-06_JPRB, 0.31788059E-06_JPRB, 0.31787604E-06_JPRB, 0.31787110E-06_JPRB, 0.31786632E-06_JPRB, &
  & 0.31786141E-06_JPRB, 0.31785640E-06_JPRB, 0.31785194E-06_JPRB, 0.31784796E-06_JPRB, 0.31784458E-06_JPRB, 0.31784157E-06_JPRB, &
  & 0.31783850E-06_JPRB, 0.31783460E-06_JPRB, 0.31782818E-06_JPRB, 0.31781454E-06_JPRB /)

RGHG3(:,69, 4) = (/ &
  & 0.31773590E-06_JPRB, 0.31775713E-06_JPRB, 0.31776750E-06_JPRB, 0.31777580E-06_JPRB, 0.31778256E-06_JPRB, 0.31778865E-06_JPRB, &
  & 0.31779399E-06_JPRB, 0.31779916E-06_JPRB, 0.31780448E-06_JPRB, 0.31781050E-06_JPRB, 0.31781659E-06_JPRB, 0.31782210E-06_JPRB, &
  & 0.31782645E-06_JPRB, 0.31782918E-06_JPRB, 0.31782983E-06_JPRB, 0.31782858E-06_JPRB, 0.31782659E-06_JPRB, 0.31782574E-06_JPRB, &
  & 0.31782812E-06_JPRB, 0.31783549E-06_JPRB, 0.31784876E-06_JPRB, 0.31786698E-06_JPRB, 0.31788807E-06_JPRB, 0.31790961E-06_JPRB, &
  & 0.31792959E-06_JPRB, 0.31794667E-06_JPRB, 0.31795994E-06_JPRB, 0.31796955E-06_JPRB, 0.31797569E-06_JPRB, 0.31797856E-06_JPRB, &
  & 0.31797836E-06_JPRB, 0.31797524E-06_JPRB, 0.31796927E-06_JPRB, 0.31796026E-06_JPRB, 0.31794892E-06_JPRB, 0.31793581E-06_JPRB, &
  & 0.31792149E-06_JPRB, 0.31790725E-06_JPRB, 0.31789475E-06_JPRB, 0.31788537E-06_JPRB, 0.31788045E-06_JPRB, 0.31787971E-06_JPRB, &
  & 0.31788238E-06_JPRB, 0.31788713E-06_JPRB, 0.31789276E-06_JPRB, 0.31789784E-06_JPRB, 0.31790128E-06_JPRB, 0.31790256E-06_JPRB, &
  & 0.31790162E-06_JPRB, 0.31789921E-06_JPRB, 0.31789548E-06_JPRB, 0.31789102E-06_JPRB, 0.31788622E-06_JPRB, 0.31788150E-06_JPRB, &
  & 0.31787661E-06_JPRB, 0.31787167E-06_JPRB, 0.31786718E-06_JPRB, 0.31786317E-06_JPRB, 0.31785970E-06_JPRB, 0.31785663E-06_JPRB, &
  & 0.31785356E-06_JPRB, 0.31784944E-06_JPRB, 0.31784251E-06_JPRB, 0.31782776E-06_JPRB /)

RGHG3(:,70, 4) = (/ &
  & 0.31775227E-06_JPRB, 0.31777554E-06_JPRB, 0.31778831E-06_JPRB, 0.31779695E-06_JPRB, 0.31780419E-06_JPRB, 0.31781047E-06_JPRB, &
  & 0.31781587E-06_JPRB, 0.31782150E-06_JPRB, 0.31782702E-06_JPRB, 0.31783313E-06_JPRB, 0.31783910E-06_JPRB, 0.31784433E-06_JPRB, &
  & 0.31784845E-06_JPRB, 0.31785100E-06_JPRB, 0.31785169E-06_JPRB, 0.31785046E-06_JPRB, 0.31784867E-06_JPRB, 0.31784791E-06_JPRB, &
  & 0.31784998E-06_JPRB, 0.31785643E-06_JPRB, 0.31786809E-06_JPRB, 0.31788412E-06_JPRB, 0.31790262E-06_JPRB, 0.31792152E-06_JPRB, &
  & 0.31793920E-06_JPRB, 0.31795423E-06_JPRB, 0.31796586E-06_JPRB, 0.31797427E-06_JPRB, 0.31797964E-06_JPRB, 0.31798189E-06_JPRB, &
  & 0.31798169E-06_JPRB, 0.31797896E-06_JPRB, 0.31797364E-06_JPRB, 0.31796569E-06_JPRB, 0.31795574E-06_JPRB, 0.31794417E-06_JPRB, &
  & 0.31793141E-06_JPRB, 0.31791873E-06_JPRB, 0.31790768E-06_JPRB, 0.31789952E-06_JPRB, 0.31789540E-06_JPRB, 0.31789480E-06_JPRB, &
  & 0.31789727E-06_JPRB, 0.31790159E-06_JPRB, 0.31790677E-06_JPRB, 0.31791151E-06_JPRB, 0.31791473E-06_JPRB, 0.31791600E-06_JPRB, &
  & 0.31791512E-06_JPRB, 0.31791308E-06_JPRB, 0.31790964E-06_JPRB, 0.31790543E-06_JPRB, 0.31790077E-06_JPRB, 0.31789628E-06_JPRB, &
  & 0.31789159E-06_JPRB, 0.31788673E-06_JPRB, 0.31788244E-06_JPRB, 0.31787860E-06_JPRB, 0.31787519E-06_JPRB, 0.31787215E-06_JPRB, &
  & 0.31786908E-06_JPRB, 0.31786493E-06_JPRB, 0.31785780E-06_JPRB, 0.31784242E-06_JPRB /)

RGHG3(:,71, 4) = (/ &
  & 0.31776909E-06_JPRB, 0.31779618E-06_JPRB, 0.31780974E-06_JPRB, 0.31781903E-06_JPRB, 0.31782625E-06_JPRB, 0.31783262E-06_JPRB, &
  & 0.31783810E-06_JPRB, 0.31784376E-06_JPRB, 0.31784924E-06_JPRB, 0.31785532E-06_JPRB, 0.31786095E-06_JPRB, 0.31786581E-06_JPRB, &
  & 0.31786956E-06_JPRB, 0.31787189E-06_JPRB, 0.31787252E-06_JPRB, 0.31787138E-06_JPRB, 0.31786982E-06_JPRB, 0.31786911E-06_JPRB, &
  & 0.31787093E-06_JPRB, 0.31787647E-06_JPRB, 0.31788653E-06_JPRB, 0.31790034E-06_JPRB, 0.31791635E-06_JPRB, 0.31793263E-06_JPRB, &
  & 0.31794809E-06_JPRB, 0.31796114E-06_JPRB, 0.31797117E-06_JPRB, 0.31797848E-06_JPRB, 0.31798302E-06_JPRB, 0.31798493E-06_JPRB, &
  & 0.31798464E-06_JPRB, 0.31798237E-06_JPRB, 0.31797785E-06_JPRB, 0.31797089E-06_JPRB, 0.31796219E-06_JPRB, 0.31795210E-06_JPRB, &
  & 0.31794082E-06_JPRB, 0.31792979E-06_JPRB, 0.31792004E-06_JPRB, 0.31791313E-06_JPRB, 0.31790970E-06_JPRB, 0.31790933E-06_JPRB, &
  & 0.31791146E-06_JPRB, 0.31791538E-06_JPRB, 0.31792004E-06_JPRB, 0.31792445E-06_JPRB, 0.31792737E-06_JPRB, 0.31792865E-06_JPRB, &
  & 0.31792786E-06_JPRB, 0.31792612E-06_JPRB, 0.31792297E-06_JPRB, 0.31791910E-06_JPRB, 0.31791475E-06_JPRB, 0.31791058E-06_JPRB, &
  & 0.31790623E-06_JPRB, 0.31790165E-06_JPRB, 0.31789764E-06_JPRB, 0.31789406E-06_JPRB, 0.31789097E-06_JPRB, 0.31788798E-06_JPRB, &
  & 0.31788505E-06_JPRB, 0.31788099E-06_JPRB, 0.31787428E-06_JPRB, 0.31785945E-06_JPRB /)

RGHG3(:,72, 4) = (/ &
  & 0.31778899E-06_JPRB, 0.31781806E-06_JPRB, 0.31783279E-06_JPRB, 0.31784191E-06_JPRB, 0.31784904E-06_JPRB, 0.31785518E-06_JPRB, &
  & 0.31786053E-06_JPRB, 0.31786618E-06_JPRB, 0.31787130E-06_JPRB, 0.31787727E-06_JPRB, 0.31788227E-06_JPRB, 0.31788656E-06_JPRB, &
  & 0.31788989E-06_JPRB, 0.31789182E-06_JPRB, 0.31789227E-06_JPRB, 0.31789125E-06_JPRB, 0.31788989E-06_JPRB, 0.31788923E-06_JPRB, &
  & 0.31789071E-06_JPRB, 0.31789537E-06_JPRB, 0.31790387E-06_JPRB, 0.31791581E-06_JPRB, 0.31792916E-06_JPRB, 0.31794298E-06_JPRB, &
  & 0.31795622E-06_JPRB, 0.31796753E-06_JPRB, 0.31797597E-06_JPRB, 0.31798226E-06_JPRB, 0.31798615E-06_JPRB, 0.31798766E-06_JPRB, &
  & 0.31798729E-06_JPRB, 0.31798550E-06_JPRB, 0.31798172E-06_JPRB, 0.31797566E-06_JPRB, 0.31796824E-06_JPRB, 0.31795958E-06_JPRB, &
  & 0.31794988E-06_JPRB, 0.31794025E-06_JPRB, 0.31793189E-06_JPRB, 0.31792615E-06_JPRB, 0.31792325E-06_JPRB, 0.31792302E-06_JPRB, &
  & 0.31792499E-06_JPRB, 0.31792845E-06_JPRB, 0.31793255E-06_JPRB, 0.31793653E-06_JPRB, 0.31793911E-06_JPRB, 0.31794031E-06_JPRB, &
  & 0.31793962E-06_JPRB, 0.31793832E-06_JPRB, 0.31793545E-06_JPRB, 0.31793203E-06_JPRB, 0.31792814E-06_JPRB, 0.31792447E-06_JPRB, &
  & 0.31792052E-06_JPRB, 0.31791635E-06_JPRB, 0.31791274E-06_JPRB, 0.31790952E-06_JPRB, 0.31790674E-06_JPRB, 0.31790398E-06_JPRB, &
  & 0.31790120E-06_JPRB, 0.31789739E-06_JPRB, 0.31789116E-06_JPRB, 0.31787710E-06_JPRB /)

RGHG3(:,73, 4) = (/ &
  & 0.31781283E-06_JPRB, 0.31784217E-06_JPRB, 0.31785677E-06_JPRB, 0.31786519E-06_JPRB, 0.31787198E-06_JPRB, 0.31787786E-06_JPRB, &
  & 0.31788289E-06_JPRB, 0.31788818E-06_JPRB, 0.31789290E-06_JPRB, 0.31789833E-06_JPRB, 0.31790285E-06_JPRB, 0.31790657E-06_JPRB, &
  & 0.31790930E-06_JPRB, 0.31791078E-06_JPRB, 0.31791097E-06_JPRB, 0.31790995E-06_JPRB, 0.31790867E-06_JPRB, 0.31790822E-06_JPRB, &
  & 0.31790933E-06_JPRB, 0.31791305E-06_JPRB, 0.31792018E-06_JPRB, 0.31793016E-06_JPRB, 0.31794119E-06_JPRB, 0.31795258E-06_JPRB, &
  & 0.31796378E-06_JPRB, 0.31797333E-06_JPRB, 0.31798032E-06_JPRB, 0.31798567E-06_JPRB, 0.31798888E-06_JPRB, 0.31799004E-06_JPRB, &
  & 0.31798965E-06_JPRB, 0.31798825E-06_JPRB, 0.31798530E-06_JPRB, 0.31798012E-06_JPRB, 0.31797379E-06_JPRB, 0.31796668E-06_JPRB, &
  & 0.31795835E-06_JPRB, 0.31795017E-06_JPRB, 0.31794318E-06_JPRB, 0.31793843E-06_JPRB, 0.31793613E-06_JPRB, 0.31793599E-06_JPRB, &
  & 0.31793761E-06_JPRB, 0.31794076E-06_JPRB, 0.31794411E-06_JPRB, 0.31794764E-06_JPRB, 0.31794980E-06_JPRB, 0.31795099E-06_JPRB, &
  & 0.31795034E-06_JPRB, 0.31794954E-06_JPRB, 0.31794707E-06_JPRB, 0.31794414E-06_JPRB, 0.31794067E-06_JPRB, 0.31793752E-06_JPRB, &
  & 0.31793431E-06_JPRB, 0.31793056E-06_JPRB, 0.31792734E-06_JPRB, 0.31792447E-06_JPRB, 0.31792212E-06_JPRB, 0.31791967E-06_JPRB, &
  & 0.31791708E-06_JPRB, 0.31791342E-06_JPRB, 0.31790785E-06_JPRB, 0.31789475E-06_JPRB /)

RGHG3(:,74, 4) = (/ &
  & 0.31783793E-06_JPRB, 0.31786729E-06_JPRB, 0.31788090E-06_JPRB, 0.31788841E-06_JPRB, 0.31789460E-06_JPRB, 0.31790012E-06_JPRB, &
  & 0.31790478E-06_JPRB, 0.31790967E-06_JPRB, 0.31791330E-06_JPRB, 0.31791865E-06_JPRB, 0.31792229E-06_JPRB, 0.31792533E-06_JPRB, &
  & 0.31792754E-06_JPRB, 0.31792848E-06_JPRB, 0.31792834E-06_JPRB, 0.31792729E-06_JPRB, 0.31792612E-06_JPRB, 0.31792575E-06_JPRB, &
  & 0.31792661E-06_JPRB, 0.31792950E-06_JPRB, 0.31793530E-06_JPRB, 0.31794357E-06_JPRB, 0.31795221E-06_JPRB, 0.31796137E-06_JPRB, &
  & 0.31797066E-06_JPRB, 0.31797867E-06_JPRB, 0.31798419E-06_JPRB, 0.31798874E-06_JPRB, 0.31799141E-06_JPRB, 0.31799229E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799075E-06_JPRB, 0.31798865E-06_JPRB, 0.31798427E-06_JPRB, 0.31797904E-06_JPRB, 0.31797322E-06_JPRB, &
  & 0.31796637E-06_JPRB, 0.31795952E-06_JPRB, 0.31795369E-06_JPRB, 0.31795000E-06_JPRB, 0.31794806E-06_JPRB, 0.31794792E-06_JPRB, &
  & 0.31794940E-06_JPRB, 0.31795207E-06_JPRB, 0.31795480E-06_JPRB, 0.31795778E-06_JPRB, 0.31795958E-06_JPRB, 0.31796068E-06_JPRB, &
  & 0.31796000E-06_JPRB, 0.31795977E-06_JPRB, 0.31795764E-06_JPRB, 0.31795531E-06_JPRB, 0.31795238E-06_JPRB, 0.31794974E-06_JPRB, &
  & 0.31794718E-06_JPRB, 0.31794400E-06_JPRB, 0.31794104E-06_JPRB, 0.31793871E-06_JPRB, 0.31793695E-06_JPRB, 0.31793482E-06_JPRB, &
  & 0.31793235E-06_JPRB, 0.31792874E-06_JPRB, 0.31792382E-06_JPRB, 0.31791177E-06_JPRB /)

RGHG3(:,75, 4) = (/ &
  & 0.31786411E-06_JPRB, 0.31789196E-06_JPRB, 0.31790481E-06_JPRB, 0.31791083E-06_JPRB, 0.31791632E-06_JPRB, 0.31792143E-06_JPRB, &
  & 0.31792544E-06_JPRB, 0.31792970E-06_JPRB, 0.31793269E-06_JPRB, 0.31793707E-06_JPRB, 0.31794033E-06_JPRB, 0.31794264E-06_JPRB, &
  & 0.31794426E-06_JPRB, 0.31794480E-06_JPRB, 0.31794431E-06_JPRB, 0.31794329E-06_JPRB, 0.31794224E-06_JPRB, 0.31794210E-06_JPRB, &
  & 0.31794261E-06_JPRB, 0.31794474E-06_JPRB, 0.31794929E-06_JPRB, 0.31795602E-06_JPRB, 0.31796250E-06_JPRB, 0.31796955E-06_JPRB, &
  & 0.31797711E-06_JPRB, 0.31798353E-06_JPRB, 0.31798763E-06_JPRB, 0.31799158E-06_JPRB, 0.31799368E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799362E-06_JPRB, 0.31799297E-06_JPRB, 0.31799169E-06_JPRB, 0.31798803E-06_JPRB, 0.31798385E-06_JPRB, 0.31797936E-06_JPRB, &
  & 0.31797373E-06_JPRB, 0.31796819E-06_JPRB, 0.31796350E-06_JPRB, 0.31796074E-06_JPRB, 0.31795929E-06_JPRB, 0.31795918E-06_JPRB, &
  & 0.31796031E-06_JPRB, 0.31796259E-06_JPRB, 0.31796458E-06_JPRB, 0.31796714E-06_JPRB, 0.31796853E-06_JPRB, 0.31796964E-06_JPRB, &
  & 0.31796873E-06_JPRB, 0.31796910E-06_JPRB, 0.31796728E-06_JPRB, 0.31796566E-06_JPRB, 0.31796321E-06_JPRB, 0.31796100E-06_JPRB, &
  & 0.31795921E-06_JPRB, 0.31795645E-06_JPRB, 0.31795392E-06_JPRB, 0.31795207E-06_JPRB, 0.31795093E-06_JPRB, 0.31794906E-06_JPRB, &
  & 0.31794667E-06_JPRB, 0.31794320E-06_JPRB, 0.31793883E-06_JPRB, 0.31792800E-06_JPRB /)

RGHG3(:,76, 4) = (/ &
  & 0.31789006E-06_JPRB, 0.31791646E-06_JPRB, 0.31792754E-06_JPRB, 0.31793198E-06_JPRB, 0.31793670E-06_JPRB, 0.31794121E-06_JPRB, &
  & 0.31794468E-06_JPRB, 0.31794835E-06_JPRB, 0.31794991E-06_JPRB, 0.31795415E-06_JPRB, 0.31795625E-06_JPRB, 0.31795804E-06_JPRB, &
  & 0.31795923E-06_JPRB, 0.31795946E-06_JPRB, 0.31795875E-06_JPRB, 0.31795787E-06_JPRB, 0.31795693E-06_JPRB, 0.31795707E-06_JPRB, &
  & 0.31795719E-06_JPRB, 0.31795855E-06_JPRB, 0.31796208E-06_JPRB, 0.31796770E-06_JPRB, 0.31797214E-06_JPRB, 0.31797711E-06_JPRB, &
  & 0.31798308E-06_JPRB, 0.31798805E-06_JPRB, 0.31799075E-06_JPRB, 0.31799414E-06_JPRB, 0.31799581E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799524E-06_JPRB, 0.31799496E-06_JPRB, 0.31799462E-06_JPRB, 0.31799146E-06_JPRB, 0.31798828E-06_JPRB, 0.31798498E-06_JPRB, &
  & 0.31798066E-06_JPRB, 0.31797634E-06_JPRB, 0.31797262E-06_JPRB, 0.31797080E-06_JPRB, 0.31796966E-06_JPRB, 0.31796958E-06_JPRB, &
  & 0.31797055E-06_JPRB, 0.31797242E-06_JPRB, 0.31797359E-06_JPRB, 0.31797566E-06_JPRB, 0.31797657E-06_JPRB, 0.31797771E-06_JPRB, &
  & 0.31797657E-06_JPRB, 0.31797771E-06_JPRB, 0.31797609E-06_JPRB, 0.31797518E-06_JPRB, 0.31797316E-06_JPRB, 0.31797114E-06_JPRB, &
  & 0.31797023E-06_JPRB, 0.31796796E-06_JPRB, 0.31796566E-06_JPRB, 0.31796446E-06_JPRB, 0.31796407E-06_JPRB, 0.31796247E-06_JPRB, &
  & 0.31796020E-06_JPRB, 0.31795659E-06_JPRB, 0.31795295E-06_JPRB, 0.31794312E-06_JPRB /)

RGHG3(:,77, 4) = (/ &
  & 0.31791626E-06_JPRB, 0.31793957E-06_JPRB, 0.31794903E-06_JPRB, 0.31795150E-06_JPRB, 0.31795534E-06_JPRB, 0.31795952E-06_JPRB, &
  & 0.31796205E-06_JPRB, 0.31796512E-06_JPRB, 0.31796529E-06_JPRB, 0.31796878E-06_JPRB, 0.31797020E-06_JPRB, 0.31797140E-06_JPRB, &
  & 0.31797222E-06_JPRB, 0.31797231E-06_JPRB, 0.31797140E-06_JPRB, 0.31797074E-06_JPRB, 0.31796995E-06_JPRB, 0.31797055E-06_JPRB, &
  & 0.31797035E-06_JPRB, 0.31797106E-06_JPRB, 0.31797373E-06_JPRB, 0.31797848E-06_JPRB, 0.31798086E-06_JPRB, 0.31798396E-06_JPRB, &
  & 0.31798848E-06_JPRB, 0.31799215E-06_JPRB, 0.31799348E-06_JPRB, 0.31799647E-06_JPRB, 0.31799777E-06_JPRB, 0.31799780E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799667E-06_JPRB, 0.31799732E-06_JPRB, 0.31799462E-06_JPRB, 0.31799220E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31798695E-06_JPRB, 0.31798373E-06_JPRB, 0.31798101E-06_JPRB, 0.31798010E-06_JPRB, 0.31797919E-06_JPRB, 0.31797904E-06_JPRB, &
  & 0.31797970E-06_JPRB, 0.31798123E-06_JPRB, 0.31798166E-06_JPRB, 0.31798342E-06_JPRB, 0.31798382E-06_JPRB, 0.31798501E-06_JPRB, &
  & 0.31798348E-06_JPRB, 0.31798550E-06_JPRB, 0.31798382E-06_JPRB, 0.31798368E-06_JPRB, 0.31798206E-06_JPRB, 0.31798029E-06_JPRB, &
  & 0.31798032E-06_JPRB, 0.31797842E-06_JPRB, 0.31797632E-06_JPRB, 0.31797569E-06_JPRB, 0.31797612E-06_JPRB, 0.31797478E-06_JPRB, &
  & 0.31797256E-06_JPRB, 0.31796890E-06_JPRB, 0.31796588E-06_JPRB, 0.31795750E-06_JPRB /)

RGHG3(:,78, 4) = (/ &
  & 0.31794190E-06_JPRB, 0.31796074E-06_JPRB, 0.31796765E-06_JPRB, 0.31796813E-06_JPRB, 0.31797123E-06_JPRB, 0.31797492E-06_JPRB, &
  & 0.31797668E-06_JPRB, 0.31797887E-06_JPRB, 0.31797759E-06_JPRB, 0.31798061E-06_JPRB, 0.31798129E-06_JPRB, 0.31798206E-06_JPRB, &
  & 0.31798257E-06_JPRB, 0.31798265E-06_JPRB, 0.31798149E-06_JPRB, 0.31798129E-06_JPRB, 0.31798075E-06_JPRB, 0.31798186E-06_JPRB, &
  & 0.31798137E-06_JPRB, 0.31798146E-06_JPRB, 0.31798339E-06_JPRB, 0.31798766E-06_JPRB, 0.31798834E-06_JPRB, 0.31798970E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799567E-06_JPRB, 0.31799567E-06_JPRB, 0.31799846E-06_JPRB, 0.31799948E-06_JPRB, 0.31799925E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799817E-06_JPRB, 0.31799965E-06_JPRB, 0.31799732E-06_JPRB, 0.31799553E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799235E-06_JPRB, 0.31799001E-06_JPRB, 0.31798811E-06_JPRB, 0.31798805E-06_JPRB, 0.31798734E-06_JPRB, 0.31798723E-06_JPRB, &
  & 0.31798757E-06_JPRB, 0.31798885E-06_JPRB, 0.31798848E-06_JPRB, 0.31798999E-06_JPRB, 0.31798982E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31798911E-06_JPRB, 0.31799200E-06_JPRB, 0.31799027E-06_JPRB, 0.31799084E-06_JPRB, 0.31798965E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31798888E-06_JPRB, 0.31798714E-06_JPRB, 0.31798524E-06_JPRB, 0.31798521E-06_JPRB, 0.31798646E-06_JPRB, 0.31798544E-06_JPRB, &
  & 0.31798311E-06_JPRB, 0.31797927E-06_JPRB, 0.31797734E-06_JPRB, 0.31797103E-06_JPRB /)

RGHG3(:,79, 4) = (/ &
  & 0.31795835E-06_JPRB, 0.31797251E-06_JPRB, 0.31797785E-06_JPRB, 0.31797663E-06_JPRB, 0.31797936E-06_JPRB, 0.31798311E-06_JPRB, &
  & 0.31798425E-06_JPRB, 0.31798618E-06_JPRB, 0.31798390E-06_JPRB, 0.31798686E-06_JPRB, 0.31798706E-06_JPRB, 0.31798763E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798822E-06_JPRB, 0.31798672E-06_JPRB, 0.31798677E-06_JPRB, 0.31798635E-06_JPRB, 0.31798794E-06_JPRB, &
  & 0.31798714E-06_JPRB, 0.31798695E-06_JPRB, 0.31798859E-06_JPRB, 0.31799289E-06_JPRB, 0.31799237E-06_JPRB, 0.31799280E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799763E-06_JPRB, 0.31799692E-06_JPRB, 0.31799976E-06_JPRB, 0.31800059E-06_JPRB, 0.31800025E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31799897E-06_JPRB, 0.31800124E-06_JPRB, 0.31799905E-06_JPRB, 0.31799749E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31799541E-06_JPRB, 0.31799351E-06_JPRB, 0.31799203E-06_JPRB, 0.31799243E-06_JPRB, 0.31799172E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31799300E-06_JPRB, 0.31799215E-06_JPRB, 0.31799351E-06_JPRB, 0.31799297E-06_JPRB, 0.31799459E-06_JPRB, &
  & 0.31799192E-06_JPRB, 0.31799564E-06_JPRB, 0.31799368E-06_JPRB, 0.31799485E-06_JPRB, 0.31799379E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799360E-06_JPRB, 0.31799183E-06_JPRB, 0.31798982E-06_JPRB, 0.31799013E-06_JPRB, 0.31799209E-06_JPRB, 0.31799118E-06_JPRB, &
  & 0.31798859E-06_JPRB, 0.31798444E-06_JPRB, 0.31798342E-06_JPRB, 0.31797953E-06_JPRB /)

RGHG3(:,80, 4) = (/ &
  & 0.31796901E-06_JPRB, 0.31797833E-06_JPRB, 0.31798243E-06_JPRB, 0.31798024E-06_JPRB, 0.31798288E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31798774E-06_JPRB, 0.31798953E-06_JPRB, 0.31798669E-06_JPRB, 0.31798953E-06_JPRB, 0.31798970E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31799075E-06_JPRB, 0.31798902E-06_JPRB, 0.31798919E-06_JPRB, 0.31798879E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31798982E-06_JPRB, 0.31798942E-06_JPRB, 0.31799098E-06_JPRB, 0.31799550E-06_JPRB, 0.31799433E-06_JPRB, 0.31799422E-06_JPRB, &
  & 0.31799684E-06_JPRB, 0.31799863E-06_JPRB, 0.31799743E-06_JPRB, 0.31800036E-06_JPRB, 0.31800121E-06_JPRB, 0.31800082E-06_JPRB, &
  & 0.31799863E-06_JPRB, 0.31799948E-06_JPRB, 0.31800215E-06_JPRB, 0.31799993E-06_JPRB, 0.31799843E-06_JPRB, 0.31799854E-06_JPRB, &
  & 0.31799695E-06_JPRB, 0.31799516E-06_JPRB, 0.31799382E-06_JPRB, 0.31799453E-06_JPRB, 0.31799385E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799502E-06_JPRB, 0.31799379E-06_JPRB, 0.31799519E-06_JPRB, 0.31799442E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31799743E-06_JPRB, 0.31799533E-06_JPRB, 0.31799678E-06_JPRB, 0.31799573E-06_JPRB, 0.31799348E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799399E-06_JPRB, 0.31799181E-06_JPRB, 0.31799237E-06_JPRB, 0.31799476E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799101E-06_JPRB, 0.31798655E-06_JPRB, 0.31798621E-06_JPRB, 0.31798484E-06_JPRB /)

RGHG3(:,81, 4) = (/ &
  & 0.31797600E-06_JPRB, 0.31798078E-06_JPRB, 0.31798442E-06_JPRB, 0.31798180E-06_JPRB, 0.31798436E-06_JPRB, 0.31798839E-06_JPRB, &
  & 0.31798911E-06_JPRB, 0.31799078E-06_JPRB, 0.31798788E-06_JPRB, 0.31799118E-06_JPRB, 0.31799104E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31799192E-06_JPRB, 0.31799007E-06_JPRB, 0.31799030E-06_JPRB, 0.31798996E-06_JPRB, 0.31799223E-06_JPRB, &
  & 0.31799109E-06_JPRB, 0.31799047E-06_JPRB, 0.31799200E-06_JPRB, 0.31799675E-06_JPRB, 0.31799519E-06_JPRB, 0.31799479E-06_JPRB, &
  & 0.31799740E-06_JPRB, 0.31799917E-06_JPRB, 0.31799763E-06_JPRB, 0.31800073E-06_JPRB, 0.31800164E-06_JPRB, 0.31800107E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799968E-06_JPRB, 0.31800272E-06_JPRB, 0.31800042E-06_JPRB, 0.31799894E-06_JPRB, 0.31799919E-06_JPRB, &
  & 0.31799769E-06_JPRB, 0.31799601E-06_JPRB, 0.31799470E-06_JPRB, 0.31799544E-06_JPRB, 0.31799476E-06_JPRB, 0.31799470E-06_JPRB, &
  & 0.31799476E-06_JPRB, 0.31799593E-06_JPRB, 0.31799453E-06_JPRB, 0.31799595E-06_JPRB, 0.31799507E-06_JPRB, 0.31799698E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799834E-06_JPRB, 0.31799601E-06_JPRB, 0.31799772E-06_JPRB, 0.31799664E-06_JPRB, 0.31799422E-06_JPRB, &
  & 0.31799689E-06_JPRB, 0.31799490E-06_JPRB, 0.31799263E-06_JPRB, 0.31799340E-06_JPRB, 0.31799601E-06_JPRB, 0.31799502E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31798734E-06_JPRB, 0.31798720E-06_JPRB, 0.31798828E-06_JPRB /)

RGHG3(:,82, 4) = (/ &
  & 0.31797657E-06_JPRB, 0.31798163E-06_JPRB, 0.31798533E-06_JPRB, 0.31798243E-06_JPRB, 0.31798513E-06_JPRB, 0.31798922E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31799209E-06_JPRB, 0.31798857E-06_JPRB, 0.31799129E-06_JPRB, 0.31799155E-06_JPRB, 0.31799198E-06_JPRB, &
  & 0.31799249E-06_JPRB, 0.31799252E-06_JPRB, 0.31799061E-06_JPRB, 0.31799087E-06_JPRB, 0.31799050E-06_JPRB, 0.31799297E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799095E-06_JPRB, 0.31799254E-06_JPRB, 0.31799746E-06_JPRB, 0.31799561E-06_JPRB, 0.31799507E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799939E-06_JPRB, 0.31799777E-06_JPRB, 0.31800090E-06_JPRB, 0.31800181E-06_JPRB, 0.31800130E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31799985E-06_JPRB, 0.31800300E-06_JPRB, 0.31800067E-06_JPRB, 0.31799922E-06_JPRB, 0.31799951E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799641E-06_JPRB, 0.31799513E-06_JPRB, 0.31799593E-06_JPRB, 0.31799530E-06_JPRB, 0.31799524E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799652E-06_JPRB, 0.31799496E-06_JPRB, 0.31799638E-06_JPRB, 0.31799536E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31799388E-06_JPRB, 0.31799888E-06_JPRB, 0.31799644E-06_JPRB, 0.31799820E-06_JPRB, 0.31799709E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799743E-06_JPRB, 0.31799544E-06_JPRB, 0.31799308E-06_JPRB, 0.31799385E-06_JPRB, 0.31799661E-06_JPRB, 0.31799564E-06_JPRB, &
  & 0.31799254E-06_JPRB, 0.31798766E-06_JPRB, 0.31798751E-06_JPRB, 0.31798851E-06_JPRB /)

RGHG3(:,83, 4) = (/ &
  & 0.31797688E-06_JPRB, 0.31798211E-06_JPRB, 0.31798578E-06_JPRB, 0.31798288E-06_JPRB, 0.31798544E-06_JPRB, 0.31798976E-06_JPRB, &
  & 0.31799021E-06_JPRB, 0.31799175E-06_JPRB, 0.31798905E-06_JPRB, 0.31799237E-06_JPRB, 0.31799217E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799286E-06_JPRB, 0.31799092E-06_JPRB, 0.31799118E-06_JPRB, 0.31799087E-06_JPRB, 0.31799340E-06_JPRB, &
  & 0.31799206E-06_JPRB, 0.31799127E-06_JPRB, 0.31799277E-06_JPRB, 0.31799800E-06_JPRB, 0.31799593E-06_JPRB, 0.31799522E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799962E-06_JPRB, 0.31799783E-06_JPRB, 0.31800101E-06_JPRB, 0.31800204E-06_JPRB, 0.31800144E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31799991E-06_JPRB, 0.31800312E-06_JPRB, 0.31800079E-06_JPRB, 0.31799939E-06_JPRB, 0.31799976E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799669E-06_JPRB, 0.31799553E-06_JPRB, 0.31799621E-06_JPRB, 0.31799564E-06_JPRB, 0.31799553E-06_JPRB, &
  & 0.31799567E-06_JPRB, 0.31799684E-06_JPRB, 0.31799519E-06_JPRB, 0.31799664E-06_JPRB, 0.31799547E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799925E-06_JPRB, 0.31799664E-06_JPRB, 0.31799851E-06_JPRB, 0.31799740E-06_JPRB, 0.31799487E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799576E-06_JPRB, 0.31799325E-06_JPRB, 0.31799416E-06_JPRB, 0.31799709E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799286E-06_JPRB, 0.31798780E-06_JPRB, 0.31798766E-06_JPRB, 0.31798868E-06_JPRB /)

RGHG3(:,84, 4) = (/ &
  & 0.31797708E-06_JPRB, 0.31798240E-06_JPRB, 0.31798615E-06_JPRB, 0.31798314E-06_JPRB, 0.31798587E-06_JPRB, 0.31799004E-06_JPRB, &
  & 0.31799121E-06_JPRB, 0.31799271E-06_JPRB, 0.31798953E-06_JPRB, 0.31799169E-06_JPRB, 0.31799215E-06_JPRB, 0.31799254E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799297E-06_JPRB, 0.31799118E-06_JPRB, 0.31799129E-06_JPRB, 0.31799101E-06_JPRB, 0.31799368E-06_JPRB, &
  & 0.31799229E-06_JPRB, 0.31799141E-06_JPRB, 0.31799294E-06_JPRB, 0.31799846E-06_JPRB, 0.31799604E-06_JPRB, 0.31799527E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799971E-06_JPRB, 0.31799775E-06_JPRB, 0.31800113E-06_JPRB, 0.31800209E-06_JPRB, 0.31800150E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31799999E-06_JPRB, 0.31800329E-06_JPRB, 0.31800096E-06_JPRB, 0.31799959E-06_JPRB, 0.31799988E-06_JPRB, &
  & 0.31799840E-06_JPRB, 0.31799684E-06_JPRB, 0.31799578E-06_JPRB, 0.31799632E-06_JPRB, 0.31799590E-06_JPRB, 0.31799576E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799698E-06_JPRB, 0.31799536E-06_JPRB, 0.31799681E-06_JPRB, 0.31799556E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799405E-06_JPRB, 0.31799951E-06_JPRB, 0.31799678E-06_JPRB, 0.31799871E-06_JPRB, 0.31799760E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799595E-06_JPRB, 0.31799340E-06_JPRB, 0.31799433E-06_JPRB, 0.31799738E-06_JPRB, 0.31799635E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31798788E-06_JPRB, 0.31798774E-06_JPRB, 0.31798879E-06_JPRB /)

RGHG3(:,85, 4) = (/ &
  & 0.31797720E-06_JPRB, 0.31798260E-06_JPRB, 0.31798638E-06_JPRB, 0.31798325E-06_JPRB, 0.31798581E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31799075E-06_JPRB, 0.31799198E-06_JPRB, 0.31799004E-06_JPRB, 0.31799249E-06_JPRB, 0.31799249E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799294E-06_JPRB, 0.31799144E-06_JPRB, 0.31799141E-06_JPRB, 0.31799121E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799243E-06_JPRB, 0.31799149E-06_JPRB, 0.31799306E-06_JPRB, 0.31799880E-06_JPRB, 0.31799621E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799988E-06_JPRB, 0.31799766E-06_JPRB, 0.31800121E-06_JPRB, 0.31800226E-06_JPRB, 0.31800158E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31800013E-06_JPRB, 0.31800340E-06_JPRB, 0.31800104E-06_JPRB, 0.31799971E-06_JPRB, 0.31799999E-06_JPRB, &
  & 0.31799848E-06_JPRB, 0.31799703E-06_JPRB, 0.31799593E-06_JPRB, 0.31799641E-06_JPRB, 0.31799601E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799604E-06_JPRB, 0.31799703E-06_JPRB, 0.31799556E-06_JPRB, 0.31799692E-06_JPRB, 0.31799561E-06_JPRB, 0.31799786E-06_JPRB, &
  & 0.31799414E-06_JPRB, 0.31799979E-06_JPRB, 0.31799692E-06_JPRB, 0.31799888E-06_JPRB, 0.31799780E-06_JPRB, 0.31799513E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799613E-06_JPRB, 0.31799345E-06_JPRB, 0.31799448E-06_JPRB, 0.31799760E-06_JPRB, 0.31799655E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31798785E-06_JPRB, 0.31798777E-06_JPRB, 0.31798879E-06_JPRB /)

RGHG3(:,86, 4) = (/ &
  & 0.31797722E-06_JPRB, 0.31798268E-06_JPRB, 0.31798652E-06_JPRB, 0.31798334E-06_JPRB, 0.31798632E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31799141E-06_JPRB, 0.31799243E-06_JPRB, 0.31799053E-06_JPRB, 0.31799198E-06_JPRB, 0.31799246E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799283E-06_JPRB, 0.31799169E-06_JPRB, 0.31799152E-06_JPRB, 0.31799141E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799249E-06_JPRB, 0.31799158E-06_JPRB, 0.31799311E-06_JPRB, 0.31799902E-06_JPRB, 0.31799621E-06_JPRB, 0.31799530E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31800002E-06_JPRB, 0.31799760E-06_JPRB, 0.31800130E-06_JPRB, 0.31800238E-06_JPRB, 0.31800170E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31800010E-06_JPRB, 0.31800340E-06_JPRB, 0.31800118E-06_JPRB, 0.31799976E-06_JPRB, 0.31800008E-06_JPRB, &
  & 0.31799854E-06_JPRB, 0.31799703E-06_JPRB, 0.31799598E-06_JPRB, 0.31799649E-06_JPRB, 0.31799615E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799621E-06_JPRB, 0.31799712E-06_JPRB, 0.31799559E-06_JPRB, 0.31799706E-06_JPRB, 0.31799573E-06_JPRB, 0.31799794E-06_JPRB, &
  & 0.31799419E-06_JPRB, 0.31799999E-06_JPRB, 0.31799709E-06_JPRB, 0.31799905E-06_JPRB, 0.31799794E-06_JPRB, 0.31799510E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799621E-06_JPRB, 0.31799345E-06_JPRB, 0.31799453E-06_JPRB, 0.31799780E-06_JPRB, 0.31799686E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31798788E-06_JPRB, 0.31798766E-06_JPRB, 0.31798876E-06_JPRB /)

RGHG3(:,87, 4) = (/ &
  & 0.31797722E-06_JPRB, 0.31798280E-06_JPRB, 0.31798660E-06_JPRB, 0.31798339E-06_JPRB, 0.31798606E-06_JPRB, 0.31799075E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31799215E-06_JPRB, 0.31799092E-06_JPRB, 0.31799249E-06_JPRB, 0.31799266E-06_JPRB, 0.31799294E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799277E-06_JPRB, 0.31799183E-06_JPRB, 0.31799161E-06_JPRB, 0.31799155E-06_JPRB, 0.31799365E-06_JPRB, &
  & 0.31799254E-06_JPRB, 0.31799163E-06_JPRB, 0.31799308E-06_JPRB, 0.31799917E-06_JPRB, 0.31799630E-06_JPRB, 0.31799524E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31800008E-06_JPRB, 0.31799755E-06_JPRB, 0.31800144E-06_JPRB, 0.31800246E-06_JPRB, 0.31800184E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31800013E-06_JPRB, 0.31800352E-06_JPRB, 0.31800118E-06_JPRB, 0.31799982E-06_JPRB, 0.31800030E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799709E-06_JPRB, 0.31799595E-06_JPRB, 0.31799652E-06_JPRB, 0.31799613E-06_JPRB, 0.31799615E-06_JPRB, &
  & 0.31799624E-06_JPRB, 0.31799729E-06_JPRB, 0.31799567E-06_JPRB, 0.31799715E-06_JPRB, 0.31799570E-06_JPRB, 0.31799800E-06_JPRB, &
  & 0.31799422E-06_JPRB, 0.31800013E-06_JPRB, 0.31799709E-06_JPRB, 0.31799917E-06_JPRB, 0.31799806E-06_JPRB, 0.31799524E-06_JPRB, &
  & 0.31799851E-06_JPRB, 0.31799627E-06_JPRB, 0.31799348E-06_JPRB, 0.31799459E-06_JPRB, 0.31799789E-06_JPRB, 0.31799692E-06_JPRB, &
  & 0.31799340E-06_JPRB, 0.31798783E-06_JPRB, 0.31798754E-06_JPRB, 0.31798868E-06_JPRB /)

RGHG3(:,88, 4) = (/ &
  & 0.31797748E-06_JPRB, 0.31798285E-06_JPRB, 0.31798641E-06_JPRB, 0.31798345E-06_JPRB, 0.31798660E-06_JPRB, 0.31799053E-06_JPRB, &
  & 0.31799146E-06_JPRB, 0.31799229E-06_JPRB, 0.31799098E-06_JPRB, 0.31799215E-06_JPRB, 0.31799249E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799289E-06_JPRB, 0.31799277E-06_JPRB, 0.31799195E-06_JPRB, 0.31799169E-06_JPRB, 0.31799163E-06_JPRB, 0.31799371E-06_JPRB, &
  & 0.31799266E-06_JPRB, 0.31799175E-06_JPRB, 0.31799308E-06_JPRB, 0.31799934E-06_JPRB, 0.31799632E-06_JPRB, 0.31799524E-06_JPRB, &
  & 0.31799848E-06_JPRB, 0.31800019E-06_JPRB, 0.31799746E-06_JPRB, 0.31800147E-06_JPRB, 0.31800252E-06_JPRB, 0.31800192E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31800016E-06_JPRB, 0.31800366E-06_JPRB, 0.31800130E-06_JPRB, 0.31799976E-06_JPRB, 0.31800047E-06_JPRB, &
  & 0.31799877E-06_JPRB, 0.31799709E-06_JPRB, 0.31799576E-06_JPRB, 0.31799669E-06_JPRB, 0.31799613E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799624E-06_JPRB, 0.31799749E-06_JPRB, 0.31799556E-06_JPRB, 0.31799726E-06_JPRB, 0.31799561E-06_JPRB, 0.31799806E-06_JPRB, &
  & 0.31799425E-06_JPRB, 0.31800030E-06_JPRB, 0.31799712E-06_JPRB, 0.31799934E-06_JPRB, 0.31799811E-06_JPRB, 0.31799527E-06_JPRB, &
  & 0.31799857E-06_JPRB, 0.31799624E-06_JPRB, 0.31799345E-06_JPRB, 0.31799459E-06_JPRB, 0.31799800E-06_JPRB, 0.31799709E-06_JPRB, &
  & 0.31799343E-06_JPRB, 0.31798777E-06_JPRB, 0.31798751E-06_JPRB, 0.31798868E-06_JPRB /)

RGHG3(:,89, 4) = (/ &
  & 0.31797791E-06_JPRB, 0.31798299E-06_JPRB, 0.31798618E-06_JPRB, 0.31798348E-06_JPRB, 0.31798615E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31799226E-06_JPRB, 0.31799084E-06_JPRB, 0.31799235E-06_JPRB, 0.31799252E-06_JPRB, 0.31799280E-06_JPRB, &
  & 0.31799291E-06_JPRB, 0.31799271E-06_JPRB, 0.31799186E-06_JPRB, 0.31799163E-06_JPRB, 0.31799155E-06_JPRB, 0.31799391E-06_JPRB, &
  & 0.31799271E-06_JPRB, 0.31799172E-06_JPRB, 0.31799308E-06_JPRB, 0.31799948E-06_JPRB, 0.31799635E-06_JPRB, 0.31799516E-06_JPRB, &
  & 0.31799860E-06_JPRB, 0.31800033E-06_JPRB, 0.31799740E-06_JPRB, 0.31800153E-06_JPRB, 0.31800263E-06_JPRB, 0.31800204E-06_JPRB, &
  & 0.31799880E-06_JPRB, 0.31800013E-06_JPRB, 0.31800374E-06_JPRB, 0.31800138E-06_JPRB, 0.31799979E-06_JPRB, 0.31800064E-06_JPRB, &
  & 0.31799891E-06_JPRB, 0.31799712E-06_JPRB, 0.31799556E-06_JPRB, 0.31799684E-06_JPRB, 0.31799610E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799618E-06_JPRB, 0.31799777E-06_JPRB, 0.31799550E-06_JPRB, 0.31799735E-06_JPRB, 0.31799564E-06_JPRB, 0.31799817E-06_JPRB, &
  & 0.31799419E-06_JPRB, 0.31800050E-06_JPRB, 0.31799715E-06_JPRB, 0.31799948E-06_JPRB, 0.31799820E-06_JPRB, 0.31799533E-06_JPRB, &
  & 0.31799871E-06_JPRB, 0.31799632E-06_JPRB, 0.31799340E-06_JPRB, 0.31799465E-06_JPRB, 0.31799809E-06_JPRB, 0.31799721E-06_JPRB, &
  & 0.31799348E-06_JPRB, 0.31798777E-06_JPRB, 0.31798740E-06_JPRB, 0.31798862E-06_JPRB /)

RGHG3(:,90, 4) = (/ &
  & 0.31797833E-06_JPRB, 0.31798317E-06_JPRB, 0.31798601E-06_JPRB, 0.31798334E-06_JPRB, 0.31798626E-06_JPRB, 0.31799090E-06_JPRB, &
  & 0.31799146E-06_JPRB, 0.31799286E-06_JPRB, 0.31799027E-06_JPRB, 0.31799237E-06_JPRB, 0.31799271E-06_JPRB, 0.31799294E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799300E-06_JPRB, 0.31799172E-06_JPRB, 0.31799149E-06_JPRB, 0.31799138E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799271E-06_JPRB, 0.31799166E-06_JPRB, 0.31799300E-06_JPRB, 0.31799985E-06_JPRB, 0.31799627E-06_JPRB, 0.31799505E-06_JPRB, &
  & 0.31799868E-06_JPRB, 0.31800047E-06_JPRB, 0.31799723E-06_JPRB, 0.31800167E-06_JPRB, 0.31800272E-06_JPRB, 0.31800215E-06_JPRB, &
  & 0.31799863E-06_JPRB, 0.31800005E-06_JPRB, 0.31800408E-06_JPRB, 0.31800138E-06_JPRB, 0.31799965E-06_JPRB, 0.31800084E-06_JPRB, &
  & 0.31799897E-06_JPRB, 0.31799709E-06_JPRB, 0.31799533E-06_JPRB, 0.31799701E-06_JPRB, 0.31799598E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799797E-06_JPRB, 0.31799536E-06_JPRB, 0.31799746E-06_JPRB, 0.31799553E-06_JPRB, 0.31799829E-06_JPRB, &
  & 0.31799394E-06_JPRB, 0.31800076E-06_JPRB, 0.31799698E-06_JPRB, 0.31799962E-06_JPRB, 0.31799823E-06_JPRB, 0.31799516E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31799630E-06_JPRB, 0.31799331E-06_JPRB, 0.31799465E-06_JPRB, 0.31799826E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31798760E-06_JPRB, 0.31798734E-06_JPRB, 0.31798871E-06_JPRB /)

RGHG3(:,91, 4) = (/ &
  & 0.31797856E-06_JPRB, 0.31798362E-06_JPRB, 0.31798632E-06_JPRB, 0.31798254E-06_JPRB, 0.31798575E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799081E-06_JPRB, 0.31799559E-06_JPRB, 0.31798541E-06_JPRB, 0.31799459E-06_JPRB, 0.31799271E-06_JPRB, 0.31799289E-06_JPRB, &
  & 0.31799371E-06_JPRB, 0.31799374E-06_JPRB, 0.31799090E-06_JPRB, 0.31799141E-06_JPRB, 0.31799087E-06_JPRB, 0.31799499E-06_JPRB, &
  & 0.31799266E-06_JPRB, 0.31799146E-06_JPRB, 0.31799260E-06_JPRB, 0.31800053E-06_JPRB, 0.31799613E-06_JPRB, 0.31799473E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31800079E-06_JPRB, 0.31799672E-06_JPRB, 0.31800187E-06_JPRB, 0.31800292E-06_JPRB, 0.31800241E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799979E-06_JPRB, 0.31800479E-06_JPRB, 0.31800130E-06_JPRB, 0.31799942E-06_JPRB, 0.31800116E-06_JPRB, &
  & 0.31799894E-06_JPRB, 0.31799706E-06_JPRB, 0.31799502E-06_JPRB, 0.31799729E-06_JPRB, 0.31799593E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799840E-06_JPRB, 0.31799505E-06_JPRB, 0.31799769E-06_JPRB, 0.31799519E-06_JPRB, 0.31799877E-06_JPRB, &
  & 0.31799320E-06_JPRB, 0.31800150E-06_JPRB, 0.31799652E-06_JPRB, 0.31799982E-06_JPRB, 0.31799831E-06_JPRB, 0.31799473E-06_JPRB, &
  & 0.31799931E-06_JPRB, 0.31799632E-06_JPRB, 0.31799303E-06_JPRB, 0.31799451E-06_JPRB, 0.31799857E-06_JPRB, 0.31799749E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31798714E-06_JPRB, 0.31798729E-06_JPRB, 0.31798876E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG3(:, 1, 5) = (/ &
  & 0.96367017E-07_JPRB, 0.97016866E-07_JPRB, 0.97319074E-07_JPRB, 0.97740170E-07_JPRB, 0.98225669E-07_JPRB, 0.98937839E-07_JPRB, &
  & 0.99726769E-07_JPRB, 0.10052105E-06_JPRB, 0.10129877E-06_JPRB, 0.10205695E-06_JPRB, 0.10279263E-06_JPRB, 0.10350093E-06_JPRB, &
  & 0.10417279E-06_JPRB, 0.10479607E-06_JPRB, 0.10535915E-06_JPRB, 0.10585467E-06_JPRB, 0.10628179E-06_JPRB, 0.10664580E-06_JPRB, &
  & 0.10695591E-06_JPRB, 0.10722308E-06_JPRB, 0.10745804E-06_JPRB, 0.10767283E-06_JPRB, 0.10787193E-06_JPRB, 0.10805173E-06_JPRB, &
  & 0.10819900E-06_JPRB, 0.10830344E-06_JPRB, 0.10835929E-06_JPRB, 0.10837513E-06_JPRB, 0.10835064E-06_JPRB, 0.10828067E-06_JPRB, &
  & 0.10816357E-06_JPRB, 0.10799991E-06_JPRB, 0.10777719E-06_JPRB, 0.10749259E-06_JPRB, 0.10715483E-06_JPRB, 0.10676956E-06_JPRB, &
  & 0.10634935E-06_JPRB, 0.10591048E-06_JPRB, 0.10548957E-06_JPRB, 0.10515183E-06_JPRB, 0.10488364E-06_JPRB, 0.10462686E-06_JPRB, &
  & 0.10436707E-06_JPRB, 0.10408158E-06_JPRB, 0.10375700E-06_JPRB, 0.10336709E-06_JPRB, 0.10287010E-06_JPRB, 0.10219058E-06_JPRB, &
  & 0.10111070E-06_JPRB, 0.99838928E-07_JPRB, 0.98628462E-07_JPRB, 0.97468011E-07_JPRB, 0.96364275E-07_JPRB, 0.95324459E-07_JPRB, &
  & 0.94364019E-07_JPRB, 0.93510160E-07_JPRB, 0.92770186E-07_JPRB, 0.92160271E-07_JPRB, 0.91673030E-07_JPRB, 0.91286999E-07_JPRB, &
  & 0.90985033E-07_JPRB, 0.90741977E-07_JPRB, 0.90559610E-07_JPRB, 0.90425708E-07_JPRB /)

RGHG3(:, 2, 5) = (/ &
  & 0.96567931E-07_JPRB, 0.97149211E-07_JPRB, 0.97573164E-07_JPRB, 0.98081074E-07_JPRB, 0.98707048E-07_JPRB, 0.99526780E-07_JPRB, &
  & 0.10047403E-06_JPRB, 0.10146709E-06_JPRB, 0.10243701E-06_JPRB, 0.10334556E-06_JPRB, 0.10417182E-06_JPRB, 0.10490607E-06_JPRB, &
  & 0.10555924E-06_JPRB, 0.10615592E-06_JPRB, 0.10672187E-06_JPRB, 0.10726888E-06_JPRB, 0.10779228E-06_JPRB, 0.10828020E-06_JPRB, &
  & 0.10872319E-06_JPRB, 0.10911815E-06_JPRB, 0.10946744E-06_JPRB, 0.10977465E-06_JPRB, 0.11005103E-06_JPRB, 0.11030534E-06_JPRB, &
  & 0.11054092E-06_JPRB, 0.11076416E-06_JPRB, 0.11097470E-06_JPRB, 0.11117606E-06_JPRB, 0.11136108E-06_JPRB, 0.11150618E-06_JPRB, &
  & 0.11157340E-06_JPRB, 0.11152156E-06_JPRB, 0.11132225E-06_JPRB, 0.11097269E-06_JPRB, 0.11048582E-06_JPRB, 0.10987753E-06_JPRB, &
  & 0.10916882E-06_JPRB, 0.10838876E-06_JPRB, 0.10761568E-06_JPRB, 0.10691708E-06_JPRB, 0.10632525E-06_JPRB, 0.10579834E-06_JPRB, &
  & 0.10529776E-06_JPRB, 0.10479202E-06_JPRB, 0.10424764E-06_JPRB, 0.10363898E-06_JPRB, 0.10293027E-06_JPRB, 0.10206460E-06_JPRB, &
  & 0.10098682E-06_JPRB, 0.99825890E-07_JPRB, 0.98646979E-07_JPRB, 0.97493860E-07_JPRB, 0.96348799E-07_JPRB, 0.95244822E-07_JPRB, &
  & 0.94193119E-07_JPRB, 0.93270764E-07_JPRB, 0.92467047E-07_JPRB, 0.91815330E-07_JPRB, 0.91290211E-07_JPRB, 0.90865264E-07_JPRB, &
  & 0.90530037E-07_JPRB, 0.90264820E-07_JPRB, 0.90075361E-07_JPRB, 0.89954725E-07_JPRB /)

RGHG3(:, 3, 5) = (/ &
  & 0.96573167E-07_JPRB, 0.97045778E-07_JPRB, 0.97468941E-07_JPRB, 0.97952679E-07_JPRB, 0.98567895E-07_JPRB, 0.99331096E-07_JPRB, &
  & 0.10021795E-06_JPRB, 0.10114086E-06_JPRB, 0.10204147E-06_JPRB, 0.10292558E-06_JPRB, 0.10381186E-06_JPRB, 0.10471556E-06_JPRB, &
  & 0.10560980E-06_JPRB, 0.10644877E-06_JPRB, 0.10721946E-06_JPRB, 0.10795974E-06_JPRB, 0.10871609E-06_JPRB, 0.10949753E-06_JPRB, &
  & 0.11027524E-06_JPRB, 0.11101311E-06_JPRB, 0.11168826E-06_JPRB, 0.11229420E-06_JPRB, 0.11283298E-06_JPRB, 0.11331486E-06_JPRB, &
  & 0.11375543E-06_JPRB, 0.11415563E-06_JPRB, 0.11452589E-06_JPRB, 0.11486308E-06_JPRB, 0.11515672E-06_JPRB, 0.11537146E-06_JPRB, &
  & 0.11544142E-06_JPRB, 0.11529809E-06_JPRB, 0.11491379E-06_JPRB, 0.11430892E-06_JPRB, 0.11353698E-06_JPRB, 0.11264660E-06_JPRB, &
  & 0.11166703E-06_JPRB, 0.11060961E-06_JPRB, 0.10947106E-06_JPRB, 0.10835568E-06_JPRB, 0.10731479E-06_JPRB, 0.10635768E-06_JPRB, &
  & 0.10547001E-06_JPRB, 0.10462229E-06_JPRB, 0.10379259E-06_JPRB, 0.10295112E-06_JPRB, 0.10205520E-06_JPRB, 0.10106851E-06_JPRB, &
  & 0.10003522E-06_JPRB, 0.98966183E-07_JPRB, 0.97907986E-07_JPRB, 0.96837461E-07_JPRB, 0.95761038E-07_JPRB, 0.94671961E-07_JPRB, &
  & 0.93626426E-07_JPRB, 0.92639013E-07_JPRB, 0.91768911E-07_JPRB, 0.91050538E-07_JPRB, 0.90471374E-07_JPRB, 0.90001954E-07_JPRB, &
  & 0.89616030E-07_JPRB, 0.89298204E-07_JPRB, 0.89026180E-07_JPRB, 0.88770840E-07_JPRB /)

RGHG3(:, 4, 5) = (/ &
  & 0.96192508E-07_JPRB, 0.96412322E-07_JPRB, 0.96685561E-07_JPRB, 0.97082342E-07_JPRB, 0.97603547E-07_JPRB, 0.98287011E-07_JPRB, &
  & 0.99094649E-07_JPRB, 0.99977868E-07_JPRB, 0.10090225E-06_JPRB, 0.10184899E-06_JPRB, 0.10281580E-06_JPRB, 0.10381211E-06_JPRB, &
  & 0.10489936E-06_JPRB, 0.10612122E-06_JPRB, 0.10741212E-06_JPRB, 0.10864465E-06_JPRB, 0.10980416E-06_JPRB, 0.11100941E-06_JPRB, &
  & 0.11233492E-06_JPRB, 0.11371647E-06_JPRB, 0.11503210E-06_JPRB, 0.11619930E-06_JPRB, 0.11719416E-06_JPRB, 0.11802684E-06_JPRB, &
  & 0.11870745E-06_JPRB, 0.11926274E-06_JPRB, 0.11970437E-06_JPRB, 0.12003676E-06_JPRB, 0.12023165E-06_JPRB, 0.12022763E-06_JPRB, &
  & 0.11994869E-06_JPRB, 0.11934493E-06_JPRB, 0.11843402E-06_JPRB, 0.11732715E-06_JPRB, 0.11614831E-06_JPRB, 0.11495297E-06_JPRB, &
  & 0.11370834E-06_JPRB, 0.11237634E-06_JPRB, 0.11099466E-06_JPRB, 0.10955966E-06_JPRB, 0.10811048E-06_JPRB, 0.10667019E-06_JPRB, &
  & 0.10526040E-06_JPRB, 0.10390857E-06_JPRB, 0.10262533E-06_JPRB, 0.10142541E-06_JPRB, 0.10031297E-06_JPRB, 0.99282872E-07_JPRB, &
  & 0.98291927E-07_JPRB, 0.97333860E-07_JPRB, 0.96398082E-07_JPRB, 0.95495643E-07_JPRB, 0.94602591E-07_JPRB, 0.93722896E-07_JPRB, &
  & 0.92852552E-07_JPRB, 0.92027094E-07_JPRB, 0.91257156E-07_JPRB, 0.90597183E-07_JPRB, 0.90048161E-07_JPRB, 0.89591197E-07_JPRB, &
  & 0.89219320E-07_JPRB, 0.88910014E-07_JPRB, 0.88653607E-07_JPRB, 0.88349751E-07_JPRB /)

RGHG3(:, 5, 5) = (/ &
  & 0.95569114E-07_JPRB, 0.95542532E-07_JPRB, 0.95697260E-07_JPRB, 0.95979352E-07_JPRB, 0.96401052E-07_JPRB, 0.96958466E-07_JPRB, &
  & 0.97640338E-07_JPRB, 0.98418411E-07_JPRB, 0.99273237E-07_JPRB, 0.10026062E-06_JPRB, 0.10142959E-06_JPRB, 0.10281663E-06_JPRB, &
  & 0.10439378E-06_JPRB, 0.10613920E-06_JPRB, 0.10815074E-06_JPRB, 0.11051038E-06_JPRB, 0.11301019E-06_JPRB, 0.11529257E-06_JPRB, &
  & 0.11722559E-06_JPRB, 0.11891829E-06_JPRB, 0.12047111E-06_JPRB, 0.12188923E-06_JPRB, 0.12313592E-06_JPRB, 0.12418396E-06_JPRB, &
  & 0.12501923E-06_JPRB, 0.12563275E-06_JPRB, 0.12601836E-06_JPRB, 0.12615295E-06_JPRB, 0.12600289E-06_JPRB, 0.12552037E-06_JPRB, &
  & 0.12466307E-06_JPRB, 0.12345420E-06_JPRB, 0.12199379E-06_JPRB, 0.12040316E-06_JPRB, 0.11876521E-06_JPRB, 0.11713291E-06_JPRB, &
  & 0.11557065E-06_JPRB, 0.11408841E-06_JPRB, 0.11260418E-06_JPRB, 0.11106538E-06_JPRB, 0.10944715E-06_JPRB, 0.10777585E-06_JPRB, &
  & 0.10611125E-06_JPRB, 0.10449835E-06_JPRB, 0.10297933E-06_JPRB, 0.10155998E-06_JPRB, 0.10023553E-06_JPRB, 0.99011132E-07_JPRB, &
  & 0.97869126E-07_JPRB, 0.96820820E-07_JPRB, 0.95852670E-07_JPRB, 0.94937107E-07_JPRB, 0.94067111E-07_JPRB, 0.93239109E-07_JPRB, &
  & 0.92452147E-07_JPRB, 0.91693124E-07_JPRB, 0.90971184E-07_JPRB, 0.90336883E-07_JPRB, 0.89784280E-07_JPRB, 0.89316757E-07_JPRB, &
  & 0.88927997E-07_JPRB, 0.88604907E-07_JPRB, 0.88332172E-07_JPRB, 0.88019696E-07_JPRB /)

RGHG3(:, 6, 5) = (/ &
  & 0.94949321E-07_JPRB, 0.94879709E-07_JPRB, 0.94982603E-07_JPRB, 0.95185200E-07_JPRB, 0.95494194E-07_JPRB, 0.95930147E-07_JPRB, &
  & 0.96496926E-07_JPRB, 0.97217139E-07_JPRB, 0.98117539E-07_JPRB, 0.99260923E-07_JPRB, 0.10071311E-06_JPRB, 0.10252911E-06_JPRB, &
  & 0.10475193E-06_JPRB, 0.10731072E-06_JPRB, 0.10996242E-06_JPRB, 0.11247761E-06_JPRB, 0.11490551E-06_JPRB, 0.11735403E-06_JPRB, &
  & 0.11969148E-06_JPRB, 0.12172839E-06_JPRB, 0.12347252E-06_JPRB, 0.12503149E-06_JPRB, 0.12645569E-06_JPRB, 0.12772678E-06_JPRB, &
  & 0.12879913E-06_JPRB, 0.12963091E-06_JPRB, 0.13017494E-06_JPRB, 0.13037942E-06_JPRB, 0.13018359E-06_JPRB, 0.12953421E-06_JPRB, &
  & 0.12842685E-06_JPRB, 0.12690974E-06_JPRB, 0.12507664E-06_JPRB, 0.12309121E-06_JPRB, 0.12116294E-06_JPRB, 0.11940307E-06_JPRB, &
  & 0.11776621E-06_JPRB, 0.11615958E-06_JPRB, 0.11455282E-06_JPRB, 0.11293689E-06_JPRB, 0.11130266E-06_JPRB, 0.10965202E-06_JPRB, &
  & 0.10800059E-06_JPRB, 0.10638960E-06_JPRB, 0.10485370E-06_JPRB, 0.10340801E-06_JPRB, 0.10205855E-06_JPRB, 0.10080458E-06_JPRB, &
  & 0.99607270E-07_JPRB, 0.98457200E-07_JPRB, 0.97363724E-07_JPRB, 0.96307403E-07_JPRB, 0.95274750E-07_JPRB, 0.94284374E-07_JPRB, &
  & 0.93336467E-07_JPRB, 0.92429985E-07_JPRB, 0.91571493E-07_JPRB, 0.90813465E-07_JPRB, 0.90156711E-07_JPRB, 0.89598309E-07_JPRB, &
  & 0.89148365E-07_JPRB, 0.88780205E-07_JPRB, 0.88457085E-07_JPRB, 0.88047926E-07_JPRB /)

RGHG3(:, 7, 5) = (/ &
  & 0.94552398E-07_JPRB, 0.94586603E-07_JPRB, 0.94723632E-07_JPRB, 0.94943623E-07_JPRB, 0.95268049E-07_JPRB, 0.95714640E-07_JPRB, &
  & 0.96319489E-07_JPRB, 0.97093888E-07_JPRB, 0.98081024E-07_JPRB, 0.99347730E-07_JPRB, 0.10096323E-06_JPRB, 0.10293805E-06_JPRB, &
  & 0.10520414E-06_JPRB, 0.10766737E-06_JPRB, 0.11026789E-06_JPRB, 0.11292643E-06_JPRB, 0.11542892E-06_JPRB, 0.11766990E-06_JPRB, &
  & 0.11977178E-06_JPRB, 0.12183402E-06_JPRB, 0.12376930E-06_JPRB, 0.12553500E-06_JPRB, 0.12722690E-06_JPRB, 0.12890024E-06_JPRB, &
  & 0.13047008E-06_JPRB, 0.13182692E-06_JPRB, 0.13285465E-06_JPRB, 0.13342969E-06_JPRB, 0.13346360E-06_JPRB, 0.13293345E-06_JPRB, &
  & 0.13185476E-06_JPRB, 0.13031712E-06_JPRB, 0.12847832E-06_JPRB, 0.12650273E-06_JPRB, 0.12449287E-06_JPRB, 0.12252229E-06_JPRB, &
  & 0.12066465E-06_JPRB, 0.11895779E-06_JPRB, 0.11736652E-06_JPRB, 0.11580139E-06_JPRB, 0.11419489E-06_JPRB, 0.11254674E-06_JPRB, &
  & 0.11091436E-06_JPRB, 0.10934063E-06_JPRB, 0.10783682E-06_JPRB, 0.10641318E-06_JPRB, 0.10503499E-06_JPRB, 0.10369409E-06_JPRB, &
  & 0.10239137E-06_JPRB, 0.10110908E-06_JPRB, 0.99851221E-07_JPRB, 0.98612375E-07_JPRB, 0.97396388E-07_JPRB, 0.96221278E-07_JPRB, &
  & 0.95090890E-07_JPRB, 0.94011050E-07_JPRB, 0.92990625E-07_JPRB, 0.92112472E-07_JPRB, 0.91360100E-07_JPRB, 0.90743171E-07_JPRB, &
  & 0.90239041E-07_JPRB, 0.89831168E-07_JPRB, 0.89448484E-07_JPRB, 0.88893259E-07_JPRB /)

RGHG3(:, 8, 5) = (/ &
  & 0.94414744E-07_JPRB, 0.94563482E-07_JPRB, 0.94758221E-07_JPRB, 0.95034522E-07_JPRB, 0.95420425E-07_JPRB, 0.95946987E-07_JPRB, &
  & 0.96612602E-07_JPRB, 0.97452471E-07_JPRB, 0.98468291E-07_JPRB, 0.99701651E-07_JPRB, 0.10119552E-06_JPRB, 0.10297652E-06_JPRB, &
  & 0.10503334E-06_JPRB, 0.10727639E-06_JPRB, 0.10957750E-06_JPRB, 0.11183658E-06_JPRB, 0.11408645E-06_JPRB, 0.11630708E-06_JPRB, &
  & 0.11840748E-06_JPRB, 0.12039527E-06_JPRB, 0.12244580E-06_JPRB, 0.12461601E-06_JPRB, 0.12679739E-06_JPRB, 0.12902932E-06_JPRB, &
  & 0.13134591E-06_JPRB, 0.13348532E-06_JPRB, 0.13520616E-06_JPRB, 0.13635633E-06_JPRB, 0.13686791E-06_JPRB, 0.13667837E-06_JPRB, &
  & 0.13579653E-06_JPRB, 0.13435468E-06_JPRB, 0.13253904E-06_JPRB, 0.13054910E-06_JPRB, 0.12856923E-06_JPRB, 0.12669570E-06_JPRB, &
  & 0.12492994E-06_JPRB, 0.12321250E-06_JPRB, 0.12149164E-06_JPRB, 0.11975891E-06_JPRB, 0.11803308E-06_JPRB, 0.11633981E-06_JPRB, &
  & 0.11467250E-06_JPRB, 0.11303823E-06_JPRB, 0.11144670E-06_JPRB, 0.10990077E-06_JPRB, 0.10839708E-06_JPRB, 0.10693766E-06_JPRB, &
  & 0.10551851E-06_JPRB, 0.10411620E-06_JPRB, 0.10272700E-06_JPRB, 0.10136205E-06_JPRB, 0.10003658E-06_JPRB, 0.98760943E-07_JPRB, &
  & 0.97539939E-07_JPRB, 0.96390373E-07_JPRB, 0.95333291E-07_JPRB, 0.94447543E-07_JPRB, 0.93726889E-07_JPRB, 0.93154696E-07_JPRB, &
  & 0.92715453E-07_JPRB, 0.92359187E-07_JPRB, 0.92010282E-07_JPRB, 0.91418912E-07_JPRB /)

RGHG3(:, 9, 5) = (/ &
  & 0.94399148E-07_JPRB, 0.94646239E-07_JPRB, 0.94971497E-07_JPRB, 0.95409590E-07_JPRB, 0.95968502E-07_JPRB, 0.96649615E-07_JPRB, &
  & 0.97476843E-07_JPRB, 0.98431393E-07_JPRB, 0.99532443E-07_JPRB, 0.10078459E-06_JPRB, 0.10220257E-06_JPRB, 0.10378709E-06_JPRB, &
  & 0.10552193E-06_JPRB, 0.10738567E-06_JPRB, 0.10934113E-06_JPRB, 0.11134416E-06_JPRB, 0.11332651E-06_JPRB, 0.11530821E-06_JPRB, &
  & 0.11736991E-06_JPRB, 0.11956959E-06_JPRB, 0.12186689E-06_JPRB, 0.12436985E-06_JPRB, 0.12725837E-06_JPRB, 0.13038205E-06_JPRB, &
  & 0.13338115E-06_JPRB, 0.13620198E-06_JPRB, 0.13854205E-06_JPRB, 0.14022307E-06_JPRB, 0.14114291E-06_JPRB, 0.14129435E-06_JPRB, &
  & 0.14076130E-06_JPRB, 0.13966755E-06_JPRB, 0.13817805E-06_JPRB, 0.13647974E-06_JPRB, 0.13469378E-06_JPRB, 0.13287695E-06_JPRB, &
  & 0.13105570E-06_JPRB, 0.12923097E-06_JPRB, 0.12739363E-06_JPRB, 0.12552347E-06_JPRB, 0.12360024E-06_JPRB, 0.12163828E-06_JPRB, &
  & 0.11969823E-06_JPRB, 0.11780855E-06_JPRB, 0.11598355E-06_JPRB, 0.11421862E-06_JPRB, 0.11250071E-06_JPRB, 0.11082309E-06_JPRB, &
  & 0.10918800E-06_JPRB, 0.10757704E-06_JPRB, 0.10600208E-06_JPRB, 0.10449433E-06_JPRB, 0.10307946E-06_JPRB, 0.10175795E-06_JPRB, &
  & 0.10053397E-06_JPRB, 0.99425343E-07_JPRB, 0.98454848E-07_JPRB, 0.97705403E-07_JPRB, 0.97146149E-07_JPRB, 0.96753013E-07_JPRB, &
  & 0.96487511E-07_JPRB, 0.96307765E-07_JPRB, 0.96153727E-07_JPRB, 0.95894919E-07_JPRB /)

RGHG3(:,10, 5) = (/ &
  & 0.95346529E-07_JPRB, 0.96611195E-07_JPRB, 0.97599099E-07_JPRB, 0.98548526E-07_JPRB, 0.99571864E-07_JPRB, 0.10070892E-06_JPRB, &
  & 0.10198757E-06_JPRB, 0.10346174E-06_JPRB, 0.10511184E-06_JPRB, 0.10695106E-06_JPRB, 0.10895524E-06_JPRB, 0.11107645E-06_JPRB, &
  & 0.11324273E-06_JPRB, 0.11536633E-06_JPRB, 0.11737680E-06_JPRB, 0.11923191E-06_JPRB, 0.12096679E-06_JPRB, 0.12263590E-06_JPRB, &
  & 0.12432589E-06_JPRB, 0.12612878E-06_JPRB, 0.12821629E-06_JPRB, 0.13065765E-06_JPRB, 0.13340320E-06_JPRB, 0.13638797E-06_JPRB, &
  & 0.13953051E-06_JPRB, 0.14232447E-06_JPRB, 0.14463370E-06_JPRB, 0.14630832E-06_JPRB, 0.14735576E-06_JPRB, 0.14783132E-06_JPRB, &
  & 0.14778124E-06_JPRB, 0.14725288E-06_JPRB, 0.14634647E-06_JPRB, 0.14515436E-06_JPRB, 0.14374508E-06_JPRB, 0.14214824E-06_JPRB, &
  & 0.14036324E-06_JPRB, 0.13838412E-06_JPRB, 0.13624046E-06_JPRB, 0.13397499E-06_JPRB, 0.13163483E-06_JPRB, 0.12929023E-06_JPRB, &
  & 0.12696431E-06_JPRB, 0.12468274E-06_JPRB, 0.12245425E-06_JPRB, 0.12028062E-06_JPRB, 0.11814986E-06_JPRB, 0.11606666E-06_JPRB, &
  & 0.11402120E-06_JPRB, 0.11204062E-06_JPRB, 0.11017342E-06_JPRB, 0.10846023E-06_JPRB, 0.10690573E-06_JPRB, 0.10551369E-06_JPRB, &
  & 0.10428908E-06_JPRB, 0.10323638E-06_JPRB, 0.10236388E-06_JPRB, 0.10173461E-06_JPRB, 0.10131134E-06_JPRB, 0.10105465E-06_JPRB, &
  & 0.10092486E-06_JPRB, 0.10088171E-06_JPRB, 0.10089133E-06_JPRB, 0.10092982E-06_JPRB /)

RGHG3(:,11, 5) = (/ &
  & 0.99995169E-07_JPRB, 0.10327453E-06_JPRB, 0.10520915E-06_JPRB, 0.10696441E-06_JPRB, 0.10869078E-06_JPRB, 0.11059249E-06_JPRB, &
  & 0.11276226E-06_JPRB, 0.11525233E-06_JPRB, 0.11811319E-06_JPRB, 0.12131295E-06_JPRB, 0.12480068E-06_JPRB, 0.12846574E-06_JPRB, &
  & 0.13215571E-06_JPRB, 0.13569264E-06_JPRB, 0.13888189E-06_JPRB, 0.14157655E-06_JPRB, 0.14369465E-06_JPRB, 0.14527099E-06_JPRB, &
  & 0.14640263E-06_JPRB, 0.14726618E-06_JPRB, 0.14801995E-06_JPRB, 0.14880665E-06_JPRB, 0.14976258E-06_JPRB, 0.15090085E-06_JPRB, &
  & 0.15205501E-06_JPRB, 0.15324392E-06_JPRB, 0.15433902E-06_JPRB, 0.15537361E-06_JPRB, 0.15630475E-06_JPRB, 0.15697682E-06_JPRB, &
  & 0.15737227E-06_JPRB, 0.15757948E-06_JPRB, 0.15756164E-06_JPRB, 0.15720686E-06_JPRB, 0.15647369E-06_JPRB, 0.15528840E-06_JPRB, &
  & 0.15364093E-06_JPRB, 0.15154414E-06_JPRB, 0.14905920E-06_JPRB, 0.14628526E-06_JPRB, 0.14334105E-06_JPRB, 0.14034980E-06_JPRB, &
  & 0.13740349E-06_JPRB, 0.13453261E-06_JPRB, 0.13174007E-06_JPRB, 0.12899685E-06_JPRB, 0.12629194E-06_JPRB, 0.12361903E-06_JPRB, &
  & 0.12102164E-06_JPRB, 0.11855520E-06_JPRB, 0.11626743E-06_JPRB, 0.11417653E-06_JPRB, 0.11230551E-06_JPRB, 0.11067712E-06_JPRB, &
  & 0.10930151E-06_JPRB, 0.10817141E-06_JPRB, 0.10727484E-06_JPRB, 0.10664958E-06_JPRB, 0.10624381E-06_JPRB, 0.10601210E-06_JPRB, &
  & 0.10591016E-06_JPRB, 0.10590256E-06_JPRB, 0.10596987E-06_JPRB, 0.10615122E-06_JPRB /)

RGHG3(:,12, 5) = (/ &
  & 0.11068455E-06_JPRB, 0.11520486E-06_JPRB, 0.11787658E-06_JPRB, 0.12012693E-06_JPRB, 0.12247206E-06_JPRB, 0.12502343E-06_JPRB, &
  & 0.12799443E-06_JPRB, 0.13148522E-06_JPRB, 0.13549507E-06_JPRB, 0.14000140E-06_JPRB, 0.14488583E-06_JPRB, 0.14998541E-06_JPRB, &
  & 0.15507862E-06_JPRB, 0.15993298E-06_JPRB, 0.16429539E-06_JPRB, 0.16793942E-06_JPRB, 0.17070543E-06_JPRB, 0.17254162E-06_JPRB, &
  & 0.17347928E-06_JPRB, 0.17362244E-06_JPRB, 0.17313744E-06_JPRB, 0.17224600E-06_JPRB, 0.17113638E-06_JPRB, 0.17002071E-06_JPRB, &
  & 0.16904953E-06_JPRB, 0.16832180E-06_JPRB, 0.16790338E-06_JPRB, 0.16772557E-06_JPRB, 0.16785006E-06_JPRB, 0.16844072E-06_JPRB, &
  & 0.16929074E-06_JPRB, 0.17020989E-06_JPRB, 0.17105266E-06_JPRB, 0.17170861E-06_JPRB, 0.17186130E-06_JPRB, 0.17133722E-06_JPRB, &
  & 0.17008124E-06_JPRB, 0.16809636E-06_JPRB, 0.16547561E-06_JPRB, 0.16237432E-06_JPRB, 0.15894919E-06_JPRB, 0.15538765E-06_JPRB, &
  & 0.15180595E-06_JPRB, 0.14827623E-06_JPRB, 0.14480749E-06_JPRB, 0.14140477E-06_JPRB, 0.13806039E-06_JPRB, 0.13479260E-06_JPRB, &
  & 0.13163029E-06_JPRB, 0.12860758E-06_JPRB, 0.12576095E-06_JPRB, 0.12313740E-06_JPRB, 0.12078364E-06_JPRB, 0.11873999E-06_JPRB, &
  & 0.11702111E-06_JPRB, 0.11561738E-06_JPRB, 0.11450588E-06_JPRB, 0.11370539E-06_JPRB, 0.11315938E-06_JPRB, 0.11281897E-06_JPRB, &
  & 0.11264434E-06_JPRB, 0.11260549E-06_JPRB, 0.11270581E-06_JPRB, 0.11309300E-06_JPRB /)

RGHG3(:,13, 5) = (/ &
  & 0.12642310E-06_JPRB, 0.13093960E-06_JPRB, 0.13357408E-06_JPRB, 0.13600889E-06_JPRB, 0.13851397E-06_JPRB, 0.14140267E-06_JPRB, &
  & 0.14480413E-06_JPRB, 0.14883958E-06_JPRB, 0.15352151E-06_JPRB, 0.15875287E-06_JPRB, 0.16438770E-06_JPRB, 0.17020324E-06_JPRB, &
  & 0.17592126E-06_JPRB, 0.18127373E-06_JPRB, 0.18600227E-06_JPRB, 0.18987976E-06_JPRB, 0.19273737E-06_JPRB, 0.19452952E-06_JPRB, &
  & 0.19526873E-06_JPRB, 0.19505252E-06_JPRB, 0.19403795E-06_JPRB, 0.19243282E-06_JPRB, 0.19049000E-06_JPRB, 0.18843133E-06_JPRB, &
  & 0.18647376E-06_JPRB, 0.18475335E-06_JPRB, 0.18339063E-06_JPRB, 0.18254441E-06_JPRB, 0.18220176E-06_JPRB, 0.18236645E-06_JPRB, &
  & 0.18321782E-06_JPRB, 0.18442910E-06_JPRB, 0.18587031E-06_JPRB, 0.18697956E-06_JPRB, 0.18768196E-06_JPRB, 0.18778120E-06_JPRB, &
  & 0.18713575E-06_JPRB, 0.18567849E-06_JPRB, 0.18346353E-06_JPRB, 0.18061232E-06_JPRB, 0.17727150E-06_JPRB, 0.17361563E-06_JPRB, &
  & 0.16979300E-06_JPRB, 0.16588450E-06_JPRB, 0.16195935E-06_JPRB, 0.15804912E-06_JPRB, 0.15417986E-06_JPRB, 0.15037918E-06_JPRB, &
  & 0.14667847E-06_JPRB, 0.14312801E-06_JPRB, 0.13977626E-06_JPRB, 0.13666413E-06_JPRB, 0.13383163E-06_JPRB, 0.13131763E-06_JPRB, &
  & 0.12914515E-06_JPRB, 0.12731783E-06_JPRB, 0.12582673E-06_JPRB, 0.12469661E-06_JPRB, 0.12388227E-06_JPRB, 0.12334642E-06_JPRB, &
  & 0.12305892E-06_JPRB, 0.12300899E-06_JPRB, 0.12324192E-06_JPRB, 0.12414945E-06_JPRB /)

RGHG3(:,14, 5) = (/ &
  & 0.14530201E-06_JPRB, 0.14886471E-06_JPRB, 0.15112467E-06_JPRB, 0.15325773E-06_JPRB, 0.15563673E-06_JPRB, 0.15844505E-06_JPRB, &
  & 0.16184330E-06_JPRB, 0.16594807E-06_JPRB, 0.17072574E-06_JPRB, 0.17607830E-06_JPRB, 0.18179433E-06_JPRB, 0.18764284E-06_JPRB, &
  & 0.19332492E-06_JPRB, 0.19852973E-06_JPRB, 0.20304756E-06_JPRB, 0.20669154E-06_JPRB, 0.20933908E-06_JPRB, 0.21095761E-06_JPRB, &
  & 0.21160974E-06_JPRB, 0.21140227E-06_JPRB, 0.21047499E-06_JPRB, 0.20901362E-06_JPRB, 0.20721642E-06_JPRB, 0.20528935E-06_JPRB, &
  & 0.20338103E-06_JPRB, 0.20164262E-06_JPRB, 0.20016324E-06_JPRB, 0.19904914E-06_JPRB, 0.19849682E-06_JPRB, 0.19849249E-06_JPRB, &
  & 0.19904856E-06_JPRB, 0.20015629E-06_JPRB, 0.20124375E-06_JPRB, 0.20242540E-06_JPRB, 0.20324825E-06_JPRB, 0.20356627E-06_JPRB, &
  & 0.20334720E-06_JPRB, 0.20252712E-06_JPRB, 0.20105715E-06_JPRB, 0.19894701E-06_JPRB, 0.19624652E-06_JPRB, 0.19306651E-06_JPRB, &
  & 0.18950351E-06_JPRB, 0.18566352E-06_JPRB, 0.18163750E-06_JPRB, 0.17751802E-06_JPRB, 0.17339046E-06_JPRB, 0.16932142E-06_JPRB, &
  & 0.16538911E-06_JPRB, 0.16163945E-06_JPRB, 0.15809411E-06_JPRB, 0.15476277E-06_JPRB, 0.15166560E-06_JPRB, 0.14883128E-06_JPRB, &
  & 0.14628903E-06_JPRB, 0.14406938E-06_JPRB, 0.14219592E-06_JPRB, 0.14072114E-06_JPRB, 0.13963177E-06_JPRB, 0.13891523E-06_JPRB, &
  & 0.13856813E-06_JPRB, 0.13861455E-06_JPRB, 0.13918302E-06_JPRB, 0.14109982E-06_JPRB /)

RGHG3(:,15, 5) = (/ &
  & 0.16593779E-06_JPRB, 0.16812631E-06_JPRB, 0.16957983E-06_JPRB, 0.17119608E-06_JPRB, 0.17311307E-06_JPRB, 0.17550245E-06_JPRB, &
  & 0.17853137E-06_JPRB, 0.18224344E-06_JPRB, 0.18665568E-06_JPRB, 0.19163457E-06_JPRB, 0.19697376E-06_JPRB, 0.20239449E-06_JPRB, &
  & 0.20763403E-06_JPRB, 0.21240845E-06_JPRB, 0.21649085E-06_JPRB, 0.21981373E-06_JPRB, 0.22230293E-06_JPRB, 0.22394366E-06_JPRB, &
  & 0.22479726E-06_JPRB, 0.22497063E-06_JPRB, 0.22458994E-06_JPRB, 0.22379820E-06_JPRB, 0.22273785E-06_JPRB, 0.22153463E-06_JPRB, &
  & 0.22029455E-06_JPRB, 0.21909381E-06_JPRB, 0.21802013E-06_JPRB, 0.21710920E-06_JPRB, 0.21640813E-06_JPRB, 0.21604205E-06_JPRB, &
  & 0.21589389E-06_JPRB, 0.21597396E-06_JPRB, 0.21637369E-06_JPRB, 0.21684836E-06_JPRB, 0.21741319E-06_JPRB, 0.21788557E-06_JPRB, &
  & 0.21808327E-06_JPRB, 0.21791624E-06_JPRB, 0.21730540E-06_JPRB, 0.21615486E-06_JPRB, 0.21441284E-06_JPRB, 0.21206841E-06_JPRB, &
  & 0.20917028E-06_JPRB, 0.20579294E-06_JPRB, 0.20205501E-06_JPRB, 0.19809811E-06_JPRB, 0.19404948E-06_JPRB, 0.19003581E-06_JPRB, &
  & 0.18613781E-06_JPRB, 0.18241322E-06_JPRB, 0.17887982E-06_JPRB, 0.17553035E-06_JPRB, 0.17236108E-06_JPRB, 0.16939138E-06_JPRB, &
  & 0.16666381E-06_JPRB, 0.16423319E-06_JPRB, 0.16215158E-06_JPRB, 0.16049682E-06_JPRB, 0.15928399E-06_JPRB, 0.15852839E-06_JPRB, &
  & 0.15825502E-06_JPRB, 0.15852294E-06_JPRB, 0.15956563E-06_JPRB, 0.16262534E-06_JPRB /)

RGHG3(:,16, 5) = (/ &
  & 0.18574754E-06_JPRB, 0.18679263E-06_JPRB, 0.18747967E-06_JPRB, 0.18847213E-06_JPRB, 0.18980732E-06_JPRB, 0.19166224E-06_JPRB, &
  & 0.19409714E-06_JPRB, 0.19722195E-06_JPRB, 0.20100673E-06_JPRB, 0.20536278E-06_JPRB, 0.21009539E-06_JPRB, 0.21493119E-06_JPRB, &
  & 0.21959767E-06_JPRB, 0.22387388E-06_JPRB, 0.22755898E-06_JPRB, 0.23057649E-06_JPRB, 0.23298139E-06_JPRB, 0.23480183E-06_JPRB, &
  & 0.23608683E-06_JPRB, 0.23691148E-06_JPRB, 0.23735774E-06_JPRB, 0.23751807E-06_JPRB, 0.23748738E-06_JPRB, 0.23732866E-06_JPRB, &
  & 0.23709529E-06_JPRB, 0.23677595E-06_JPRB, 0.23638529E-06_JPRB, 0.23586213E-06_JPRB, 0.23520553E-06_JPRB, 0.23442078E-06_JPRB, &
  & 0.23356975E-06_JPRB, 0.23273576E-06_JPRB, 0.23199517E-06_JPRB, 0.23145226E-06_JPRB, 0.23116431E-06_JPRB, 0.23119699E-06_JPRB, &
  & 0.23146613E-06_JPRB, 0.23177731E-06_JPRB, 0.23189972E-06_JPRB, 0.23165039E-06_JPRB, 0.23085843E-06_JPRB, 0.22942601E-06_JPRB, &
  & 0.22732472E-06_JPRB, 0.22460809E-06_JPRB, 0.22138896E-06_JPRB, 0.21782513E-06_JPRB, 0.21407904E-06_JPRB, 0.21027726E-06_JPRB, &
  & 0.20654825E-06_JPRB, 0.20295758E-06_JPRB, 0.19952610E-06_JPRB, 0.19624352E-06_JPRB, 0.19310588E-06_JPRB, 0.19013993E-06_JPRB, &
  & 0.18740278E-06_JPRB, 0.18496331E-06_JPRB, 0.18288793E-06_JPRB, 0.18126080E-06_JPRB, 0.18011161E-06_JPRB, 0.17946743E-06_JPRB, &
  & 0.17936063E-06_JPRB, 0.17988145E-06_JPRB, 0.18134750E-06_JPRB, 0.18512517E-06_JPRB /)

RGHG3(:,17, 5) = (/ &
  & 0.20317133E-06_JPRB, 0.20329279E-06_JPRB, 0.20346914E-06_JPRB, 0.20394646E-06_JPRB, 0.20481288E-06_JPRB, 0.20613335E-06_JPRB, &
  & 0.20803623E-06_JPRB, 0.21056397E-06_JPRB, 0.21372813E-06_JPRB, 0.21742594E-06_JPRB, 0.22150492E-06_JPRB, 0.22574515E-06_JPRB, &
  & 0.22986936E-06_JPRB, 0.23369174E-06_JPRB, 0.23708770E-06_JPRB, 0.23996094E-06_JPRB, 0.24234203E-06_JPRB, 0.24433993E-06_JPRB, &
  & 0.24603281E-06_JPRB, 0.24748221E-06_JPRB, 0.24874595E-06_JPRB, 0.24985263E-06_JPRB, 0.25082198E-06_JPRB, 0.25167287E-06_JPRB, &
  & 0.25239297E-06_JPRB, 0.25291979E-06_JPRB, 0.25318832E-06_JPRB, 0.25309359E-06_JPRB, 0.25257759E-06_JPRB, 0.25158471E-06_JPRB, &
  & 0.25021504E-06_JPRB, 0.24860628E-06_JPRB, 0.24696419E-06_JPRB, 0.24554026E-06_JPRB, 0.24450401E-06_JPRB, 0.24398565E-06_JPRB, &
  & 0.24400543E-06_JPRB, 0.24442954E-06_JPRB, 0.24495779E-06_JPRB, 0.24531667E-06_JPRB, 0.24524653E-06_JPRB, 0.24455676E-06_JPRB, &
  & 0.24315804E-06_JPRB, 0.24107371E-06_JPRB, 0.23840359E-06_JPRB, 0.23529864E-06_JPRB, 0.23189399E-06_JPRB, 0.22836376E-06_JPRB, &
  & 0.22485509E-06_JPRB, 0.22146051E-06_JPRB, 0.21818536E-06_JPRB, 0.21501540E-06_JPRB, 0.21197123E-06_JPRB, 0.20910139E-06_JPRB, &
  & 0.20647279E-06_JPRB, 0.20416238E-06_JPRB, 0.20223800E-06_JPRB, 0.20077327E-06_JPRB, 0.19979488E-06_JPRB, 0.19931846E-06_JPRB, &
  & 0.19938460E-06_JPRB, 0.20007153E-06_JPRB, 0.20170742E-06_JPRB, 0.20569645E-06_JPRB /)

RGHG3(:,18, 5) = (/ &
  & 0.21793485E-06_JPRB, 0.21738225E-06_JPRB, 0.21723150E-06_JPRB, 0.21739567E-06_JPRB, 0.21790281E-06_JPRB, 0.21884632E-06_JPRB, &
  & 0.22029349E-06_JPRB, 0.22233789E-06_JPRB, 0.22496353E-06_JPRB, 0.22810573E-06_JPRB, 0.23160869E-06_JPRB, 0.23528507E-06_JPRB, &
  & 0.23893949E-06_JPRB, 0.24236257E-06_JPRB, 0.24548180E-06_JPRB, 0.24827395E-06_JPRB, 0.25072526E-06_JPRB, 0.25288597E-06_JPRB, &
  & 0.25485116E-06_JPRB, 0.25670096E-06_JPRB, 0.25846884E-06_JPRB, 0.26017551E-06_JPRB, 0.26182755E-06_JPRB, 0.26339956E-06_JPRB, &
  & 0.26482704E-06_JPRB, 0.26601339E-06_JPRB, 0.26684950E-06_JPRB, 0.26719016E-06_JPRB, 0.26693962E-06_JPRB, 0.26605045E-06_JPRB, &
  & 0.26458781E-06_JPRB, 0.26270277E-06_JPRB, 0.26062406E-06_JPRB, 0.25864384E-06_JPRB, 0.25707854E-06_JPRB, 0.25612056E-06_JPRB, &
  & 0.25584399E-06_JPRB, 0.25614304E-06_JPRB, 0.25677338E-06_JPRB, 0.25739459E-06_JPRB, 0.25768139E-06_JPRB, 0.25742139E-06_JPRB, &
  & 0.25648464E-06_JPRB, 0.25485667E-06_JPRB, 0.25261667E-06_JPRB, 0.24988836E-06_JPRB, 0.24683754E-06_JPRB, 0.24363362E-06_JPRB, &
  & 0.24041205E-06_JPRB, 0.23722964E-06_JPRB, 0.23410280E-06_JPRB, 0.23106446E-06_JPRB, 0.22816168E-06_JPRB, 0.22545677E-06_JPRB, &
  & 0.22302301E-06_JPRB, 0.22093164E-06_JPRB, 0.21923211E-06_JPRB, 0.21798022E-06_JPRB, 0.21718742E-06_JPRB, 0.21686563E-06_JPRB, &
  & 0.21703319E-06_JPRB, 0.21776043E-06_JPRB, 0.21931508E-06_JPRB, 0.22303854E-06_JPRB /)

RGHG3(:,19, 5) = (/ &
  & 0.23016842E-06_JPRB, 0.22933131E-06_JPRB, 0.22903700E-06_JPRB, 0.22903700E-06_JPRB, 0.22933830E-06_JPRB, 0.23000351E-06_JPRB, &
  & 0.23113577E-06_JPRB, 0.23278837E-06_JPRB, 0.23497684E-06_JPRB, 0.23764611E-06_JPRB, 0.24067816E-06_JPRB, 0.24389345E-06_JPRB, &
  & 0.24711844E-06_JPRB, 0.25021791E-06_JPRB, 0.25307315E-06_JPRB, 0.25568303E-06_JPRB, 0.25808890E-06_JPRB, 0.26031663E-06_JPRB, &
  & 0.26240102E-06_JPRB, 0.26440006E-06_JPRB, 0.26638378E-06_JPRB, 0.26839035E-06_JPRB, 0.27040315E-06_JPRB, 0.27236101E-06_JPRB, &
  & 0.27418594E-06_JPRB, 0.27577147E-06_JPRB, 0.27698584E-06_JPRB, 0.27770136E-06_JPRB, 0.27782372E-06_JPRB, 0.27730204E-06_JPRB, &
  & 0.27616775E-06_JPRB, 0.27452305E-06_JPRB, 0.27255172E-06_JPRB, 0.27053557E-06_JPRB, 0.26881048E-06_JPRB, 0.26762703E-06_JPRB, &
  & 0.26710282E-06_JPRB, 0.26716708E-06_JPRB, 0.26762649E-06_JPRB, 0.26815351E-06_JPRB, 0.26845950E-06_JPRB, 0.26829403E-06_JPRB, &
  & 0.26752468E-06_JPRB, 0.26612071E-06_JPRB, 0.26413426E-06_JPRB, 0.26168820E-06_JPRB, 0.25893462E-06_JPRB, 0.25602904E-06_JPRB, &
  & 0.25305090E-06_JPRB, 0.25003072E-06_JPRB, 0.24704948E-06_JPRB, 0.24419322E-06_JPRB, 0.24151146E-06_JPRB, 0.23906372E-06_JPRB, &
  & 0.23690768E-06_JPRB, 0.23509101E-06_JPRB, 0.23364100E-06_JPRB, 0.23259533E-06_JPRB, 0.23195327E-06_JPRB, 0.23171447E-06_JPRB, &
  & 0.23188929E-06_JPRB, 0.23252420E-06_JPRB, 0.23381075E-06_JPRB, 0.23702431E-06_JPRB /)

RGHG3(:,20, 5) = (/ &
  & 0.24035947E-06_JPRB, 0.23949099E-06_JPRB, 0.23919085E-06_JPRB, 0.23914549E-06_JPRB, 0.23934993E-06_JPRB, 0.23987496E-06_JPRB, &
  & 0.24079921E-06_JPRB, 0.24219162E-06_JPRB, 0.24405531E-06_JPRB, 0.24635153E-06_JPRB, 0.24898910E-06_JPRB, 0.25182331E-06_JPRB, &
  & 0.25469757E-06_JPRB, 0.25748682E-06_JPRB, 0.26012145E-06_JPRB, 0.26255151E-06_JPRB, 0.26481172E-06_JPRB, 0.26695795E-06_JPRB, &
  & 0.26902785E-06_JPRB, 0.27105611E-06_JPRB, 0.27307462E-06_JPRB, 0.27510077E-06_JPRB, 0.27714790E-06_JPRB, 0.27918770E-06_JPRB, &
  & 0.28113047E-06_JPRB, 0.28286865E-06_JPRB, 0.28431026E-06_JPRB, 0.28532043E-06_JPRB, 0.28582218E-06_JPRB, 0.28576741E-06_JPRB, &
  & 0.28516749E-06_JPRB, 0.28406899E-06_JPRB, 0.28261670E-06_JPRB, 0.28099805E-06_JPRB, 0.27947402E-06_JPRB, 0.27828978E-06_JPRB, &
  & 0.27760512E-06_JPRB, 0.27740157E-06_JPRB, 0.27753589E-06_JPRB, 0.27774280E-06_JPRB, 0.27779137E-06_JPRB, 0.27747225E-06_JPRB, &
  & 0.27664797E-06_JPRB, 0.27527904E-06_JPRB, 0.27341034E-06_JPRB, 0.27113518E-06_JPRB, 0.26857623E-06_JPRB, 0.26581930E-06_JPRB, &
  & 0.26295402E-06_JPRB, 0.26009755E-06_JPRB, 0.25735687E-06_JPRB, 0.25477101E-06_JPRB, 0.25238535E-06_JPRB, 0.25025165E-06_JPRB, &
  & 0.24840404E-06_JPRB, 0.24686486E-06_JPRB, 0.24564241E-06_JPRB, 0.24475605E-06_JPRB, 0.24420174E-06_JPRB, 0.24397644E-06_JPRB, &
  & 0.24408564E-06_JPRB, 0.24455954E-06_JPRB, 0.24554487E-06_JPRB, 0.24807321E-06_JPRB /)

RGHG3(:,21, 5) = (/ &
  & 0.24882888E-06_JPRB, 0.24813897E-06_JPRB, 0.24791416E-06_JPRB, 0.24790424E-06_JPRB, 0.24811033E-06_JPRB, 0.24858460E-06_JPRB, &
  & 0.24940752E-06_JPRB, 0.25063059E-06_JPRB, 0.25227556E-06_JPRB, 0.25431183E-06_JPRB, 0.25665460E-06_JPRB, 0.25919496E-06_JPRB, &
  & 0.26179362E-06_JPRB, 0.26433503E-06_JPRB, 0.26674849E-06_JPRB, 0.26901074E-06_JPRB, 0.27112387E-06_JPRB, 0.27312862E-06_JPRB, &
  & 0.27507340E-06_JPRB, 0.27699019E-06_JPRB, 0.27889746E-06_JPRB, 0.28081922E-06_JPRB, 0.28274437E-06_JPRB, 0.28466249E-06_JPRB, &
  & 0.28652187E-06_JPRB, 0.28823507E-06_JPRB, 0.28971462E-06_JPRB, 0.29089139E-06_JPRB, 0.29169860E-06_JPRB, 0.29207683E-06_JPRB, &
  & 0.29201277E-06_JPRB, 0.29152628E-06_JPRB, 0.29070071E-06_JPRB, 0.28964550E-06_JPRB, 0.28856005E-06_JPRB, 0.28761644E-06_JPRB, &
  & 0.28692881E-06_JPRB, 0.28650311E-06_JPRB, 0.28627457E-06_JPRB, 0.28607420E-06_JPRB, 0.28573174E-06_JPRB, 0.28509646E-06_JPRB, &
  & 0.28407328E-06_JPRB, 0.28262014E-06_JPRB, 0.28075641E-06_JPRB, 0.27854742E-06_JPRB, 0.27607078E-06_JPRB, 0.27344424E-06_JPRB, &
  & 0.27080006E-06_JPRB, 0.26823946E-06_JPRB, 0.26578579E-06_JPRB, 0.26347604E-06_JPRB, 0.26137280E-06_JPRB, 0.25951732E-06_JPRB, &
  & 0.25793040E-06_JPRB, 0.25661325E-06_JPRB, 0.25555752E-06_JPRB, 0.25477294E-06_JPRB, 0.25425049E-06_JPRB, 0.25398808E-06_JPRB, &
  & 0.25398842E-06_JPRB, 0.25427602E-06_JPRB, 0.25495231E-06_JPRB, 0.25672242E-06_JPRB /)

RGHG3(:,22, 5) = (/ &
  & 0.25593866E-06_JPRB, 0.25546458E-06_JPRB, 0.25536346E-06_JPRB, 0.25544040E-06_JPRB, 0.25569915E-06_JPRB, 0.25619607E-06_JPRB, &
  & 0.25699046E-06_JPRB, 0.25814458E-06_JPRB, 0.25966526E-06_JPRB, 0.26153322E-06_JPRB, 0.26368554E-06_JPRB, 0.26601293E-06_JPRB, &
  & 0.26841045E-06_JPRB, 0.27076553E-06_JPRB, 0.27300666E-06_JPRB, 0.27510538E-06_JPRB, 0.27707131E-06_JPRB, 0.27892946E-06_JPRB, &
  & 0.28071344E-06_JPRB, 0.28245714E-06_JPRB, 0.28417907E-06_JPRB, 0.28589238E-06_JPRB, 0.28759717E-06_JPRB, 0.28928224E-06_JPRB, &
  & 0.29093127E-06_JPRB, 0.29250043E-06_JPRB, 0.29393840E-06_JPRB, 0.29516522E-06_JPRB, 0.29612980E-06_JPRB, 0.29680425E-06_JPRB, &
  & 0.29715662E-06_JPRB, 0.29717927E-06_JPRB, 0.29690699E-06_JPRB, 0.29639349E-06_JPRB, 0.29575810E-06_JPRB, 0.29508649E-06_JPRB, &
  & 0.29448594E-06_JPRB, 0.29394658E-06_JPRB, 0.29345085E-06_JPRB, 0.29290109E-06_JPRB, 0.29219487E-06_JPRB, 0.29123515E-06_JPRB, &
  & 0.28996760E-06_JPRB, 0.28836820E-06_JPRB, 0.28645417E-06_JPRB, 0.28427311E-06_JPRB, 0.28192540E-06_JPRB, 0.27952746E-06_JPRB, &
  & 0.27716595E-06_JPRB, 0.27486749E-06_JPRB, 0.27266648E-06_JPRB, 0.27062586E-06_JPRB, 0.26878695E-06_JPRB, 0.26717717E-06_JPRB, &
  & 0.26580244E-06_JPRB, 0.26465420E-06_JPRB, 0.26371876E-06_JPRB, 0.26299489E-06_JPRB, 0.26247488E-06_JPRB, 0.26215511E-06_JPRB, &
  & 0.26204080E-06_JPRB, 0.26214732E-06_JPRB, 0.26254287E-06_JPRB, 0.26370918E-06_JPRB /)

RGHG3(:,23, 5) = (/ &
  & 0.26187394E-06_JPRB, 0.26166643E-06_JPRB, 0.26169937E-06_JPRB, 0.26187709E-06_JPRB, 0.26222139E-06_JPRB, 0.26277280E-06_JPRB, &
  & 0.26360118E-06_JPRB, 0.26474331E-06_JPRB, 0.26621220E-06_JPRB, 0.26798591E-06_JPRB, 0.27000749E-06_JPRB, 0.27219673E-06_JPRB, &
  & 0.27444656E-06_JPRB, 0.27666408E-06_JPRB, 0.27877530E-06_JPRB, 0.28074692E-06_JPRB, 0.28258086E-06_JPRB, 0.28429946E-06_JPRB, &
  & 0.28592868E-06_JPRB, 0.28749287E-06_JPRB, 0.28900422E-06_JPRB, 0.29047442E-06_JPRB, 0.29191088E-06_JPRB, 0.29332082E-06_JPRB, &
  & 0.29469834E-06_JPRB, 0.29603308E-06_JPRB, 0.29730921E-06_JPRB, 0.29850270E-06_JPRB, 0.29954577E-06_JPRB, 0.30039274E-06_JPRB, &
  & 0.30101228E-06_JPRB, 0.30138020E-06_JPRB, 0.30149658E-06_JPRB, 0.30138503E-06_JPRB, 0.30109476E-06_JPRB, 0.30067355E-06_JPRB, &
  & 0.30016818E-06_JPRB, 0.29959162E-06_JPRB, 0.29893255E-06_JPRB, 0.29814501E-06_JPRB, 0.29717759E-06_JPRB, 0.29598689E-06_JPRB, &
  & 0.29454546E-06_JPRB, 0.29284772E-06_JPRB, 0.29091845E-06_JPRB, 0.28882019E-06_JPRB, 0.28663760E-06_JPRB, 0.28444842E-06_JPRB, &
  & 0.28230158E-06_JPRB, 0.28023666E-06_JPRB, 0.27829535E-06_JPRB, 0.27651112E-06_JPRB, 0.27491316E-06_JPRB, 0.27351692E-06_JPRB, &
  & 0.27231812E-06_JPRB, 0.27130329E-06_JPRB, 0.27045533E-06_JPRB, 0.26977193E-06_JPRB, 0.26924468E-06_JPRB, 0.26887358E-06_JPRB, &
  & 0.26866209E-06_JPRB, 0.26861929E-06_JPRB, 0.26878737E-06_JPRB, 0.26947140E-06_JPRB /)

RGHG3(:,24, 5) = (/ &
  & 0.26693434E-06_JPRB, 0.26694360E-06_JPRB, 0.26709785E-06_JPRB, 0.26737294E-06_JPRB, 0.26779389E-06_JPRB, 0.26841553E-06_JPRB, &
  & 0.26928495E-06_JPRB, 0.27044462E-06_JPRB, 0.27189375E-06_JPRB, 0.27361327E-06_JPRB, 0.27555285E-06_JPRB, 0.27763807E-06_JPRB, &
  & 0.27978035E-06_JPRB, 0.28189055E-06_JPRB, 0.28389925E-06_JPRB, 0.28577082E-06_JPRB, 0.28749992E-06_JPRB, 0.28910043E-06_JPRB, &
  & 0.29059390E-06_JPRB, 0.29199606E-06_JPRB, 0.29331889E-06_JPRB, 0.29456990E-06_JPRB, 0.29576012E-06_JPRB, 0.29690574E-06_JPRB, &
  & 0.29802186E-06_JPRB, 0.29912135E-06_JPRB, 0.30020857E-06_JPRB, 0.30126944E-06_JPRB, 0.30228114E-06_JPRB, 0.30318748E-06_JPRB, &
  & 0.30393852E-06_JPRB, 0.30449573E-06_JPRB, 0.30483540E-06_JPRB, 0.30496128E-06_JPRB, 0.30487993E-06_JPRB, 0.30461669E-06_JPRB, &
  & 0.30418590E-06_JPRB, 0.30360337E-06_JPRB, 0.30285895E-06_JPRB, 0.30194980E-06_JPRB, 0.30084695E-06_JPRB, 0.29953864E-06_JPRB, &
  & 0.29802254E-06_JPRB, 0.29631042E-06_JPRB, 0.29443729E-06_JPRB, 0.29245390E-06_JPRB, 0.29042994E-06_JPRB, 0.28843112E-06_JPRB, &
  & 0.28650595E-06_JPRB, 0.28468105E-06_JPRB, 0.28298038E-06_JPRB, 0.28142847E-06_JPRB, 0.28004334E-06_JPRB, 0.27882879E-06_JPRB, &
  & 0.27777449E-06_JPRB, 0.27686377E-06_JPRB, 0.27608090E-06_JPRB, 0.27542296E-06_JPRB, 0.27488630E-06_JPRB, 0.27447254E-06_JPRB, &
  & 0.27418773E-06_JPRB, 0.27403661E-06_JPRB, 0.27403291E-06_JPRB, 0.27432705E-06_JPRB /)

RGHG3(:,25, 5) = (/ &
  & 0.27131475E-06_JPRB, 0.27149841E-06_JPRB, 0.27174758E-06_JPRB, 0.27208799E-06_JPRB, 0.27257332E-06_JPRB, 0.27324378E-06_JPRB, &
  & 0.27414902E-06_JPRB, 0.27532144E-06_JPRB, 0.27675745E-06_JPRB, 0.27843180E-06_JPRB, 0.28030342E-06_JPRB, 0.28230087E-06_JPRB, &
  & 0.28434897E-06_JPRB, 0.28636725E-06_JPRB, 0.28829029E-06_JPRB, 0.29007924E-06_JPRB, 0.29172338E-06_JPRB, 0.29323132E-06_JPRB, &
  & 0.29461748E-06_JPRB, 0.29589233E-06_JPRB, 0.29706450E-06_JPRB, 0.29814123E-06_JPRB, 0.29913238E-06_JPRB, 0.30006152E-06_JPRB, &
  & 0.30095094E-06_JPRB, 0.30183193E-06_JPRB, 0.30272940E-06_JPRB, 0.30364771E-06_JPRB, 0.30456397E-06_JPRB, 0.30544007E-06_JPRB, &
  & 0.30621845E-06_JPRB, 0.30684814E-06_JPRB, 0.30728765E-06_JPRB, 0.30752514E-06_JPRB, 0.30754501E-06_JPRB, 0.30735640E-06_JPRB, &
  & 0.30696225E-06_JPRB, 0.30638063E-06_JPRB, 0.30560554E-06_JPRB, 0.30464363E-06_JPRB, 0.30349088E-06_JPRB, 0.30215244E-06_JPRB, &
  & 0.30064101E-06_JPRB, 0.29897842E-06_JPRB, 0.29720016E-06_JPRB, 0.29536056E-06_JPRB, 0.29352213E-06_JPRB, 0.29173316E-06_JPRB, &
  & 0.29003178E-06_JPRB, 0.28843937E-06_JPRB, 0.28696468E-06_JPRB, 0.28562010E-06_JPRB, 0.28441875E-06_JPRB, 0.28335535E-06_JPRB, &
  & 0.28241760E-06_JPRB, 0.28158905E-06_JPRB, 0.28085503E-06_JPRB, 0.28021410E-06_JPRB, 0.27966556E-06_JPRB, 0.27921595E-06_JPRB, &
  & 0.27887307E-06_JPRB, 0.27863916E-06_JPRB, 0.27851604E-06_JPRB, 0.27856498E-06_JPRB /)

RGHG3(:,26, 5) = (/ &
  & 0.27518851E-06_JPRB, 0.27551064E-06_JPRB, 0.27580433E-06_JPRB, 0.27619473E-06_JPRB, 0.27670634E-06_JPRB, 0.27739935E-06_JPRB, &
  & 0.27831973E-06_JPRB, 0.27948440E-06_JPRB, 0.28089318E-06_JPRB, 0.28251790E-06_JPRB, 0.28431202E-06_JPRB, 0.28622554E-06_JPRB, &
  & 0.28818164E-06_JPRB, 0.29011551E-06_JPRB, 0.29196201E-06_JPRB, 0.29368297E-06_JPRB, 0.29526123E-06_JPRB, 0.29669951E-06_JPRB, &
  & 0.29800555E-06_JPRB, 0.29918652E-06_JPRB, 0.30024916E-06_JPRB, 0.30120077E-06_JPRB, 0.30205084E-06_JPRB, 0.30282050E-06_JPRB, &
  & 0.30353823E-06_JPRB, 0.30424096E-06_JPRB, 0.30496454E-06_JPRB, 0.30572764E-06_JPRB, 0.30652504E-06_JPRB, 0.30731960E-06_JPRB, &
  & 0.30805589E-06_JPRB, 0.30868142E-06_JPRB, 0.30914163E-06_JPRB, 0.30941231E-06_JPRB, 0.30946634E-06_JPRB, 0.30930244E-06_JPRB, &
  & 0.30892306E-06_JPRB, 0.30833752E-06_JPRB, 0.30755717E-06_JPRB, 0.30658589E-06_JPRB, 0.30543879E-06_JPRB, 0.30412752E-06_JPRB, &
  & 0.30267393E-06_JPRB, 0.30110709E-06_JPRB, 0.29946921E-06_JPRB, 0.29780685E-06_JPRB, 0.29616356E-06_JPRB, 0.29459017E-06_JPRB, &
  & 0.29311158E-06_JPRB, 0.29172864E-06_JPRB, 0.29044659E-06_JPRB, 0.28928082E-06_JPRB, 0.28822845E-06_JPRB, 0.28728633E-06_JPRB, &
  & 0.28644084E-06_JPRB, 0.28567740E-06_JPRB, 0.28498292E-06_JPRB, 0.28435636E-06_JPRB, 0.28379998E-06_JPRB, 0.28332309E-06_JPRB, &
  & 0.28293508E-06_JPRB, 0.28263673E-06_JPRB, 0.28241496E-06_JPRB, 0.28224872E-06_JPRB /)

RGHG3(:,27, 5) = (/ &
  & 0.27868541E-06_JPRB, 0.27904815E-06_JPRB, 0.27939669E-06_JPRB, 0.27978919E-06_JPRB, 0.28031326E-06_JPRB, 0.28100729E-06_JPRB, &
  & 0.28191045E-06_JPRB, 0.28305465E-06_JPRB, 0.28441679E-06_JPRB, 0.28597350E-06_JPRB, 0.28768957E-06_JPRB, 0.28950669E-06_JPRB, &
  & 0.29137541E-06_JPRB, 0.29322584E-06_JPRB, 0.29500461E-06_JPRB, 0.29666757E-06_JPRB, 0.29819233E-06_JPRB, 0.29957761E-06_JPRB, &
  & 0.30082566E-06_JPRB, 0.30194320E-06_JPRB, 0.30293481E-06_JPRB, 0.30380386E-06_JPRB, 0.30455848E-06_JPRB, 0.30521886E-06_JPRB, &
  & 0.30581299E-06_JPRB, 0.30637852E-06_JPRB, 0.30695870E-06_JPRB, 0.30757693E-06_JPRB, 0.30823989E-06_JPRB, 0.30892909E-06_JPRB, &
  & 0.30958580E-06_JPRB, 0.31016145E-06_JPRB, 0.31059668E-06_JPRB, 0.31085600E-06_JPRB, 0.31090917E-06_JPRB, 0.31074802E-06_JPRB, &
  & 0.31037317E-06_JPRB, 0.30978919E-06_JPRB, 0.30901685E-06_JPRB, 0.30807252E-06_JPRB, 0.30696438E-06_JPRB, 0.30571886E-06_JPRB, &
  & 0.30436269E-06_JPRB, 0.30293211E-06_JPRB, 0.30145895E-06_JPRB, 0.29997838E-06_JPRB, 0.29853729E-06_JPRB, 0.29716693E-06_JPRB, &
  & 0.29587682E-06_JPRB, 0.29467355E-06_JPRB, 0.29356056E-06_JPRB, 0.29253505E-06_JPRB, 0.29160074E-06_JPRB, 0.29075244E-06_JPRB, &
  & 0.28997817E-06_JPRB, 0.28926547E-06_JPRB, 0.28860364E-06_JPRB, 0.28799136E-06_JPRB, 0.28743275E-06_JPRB, 0.28693935E-06_JPRB, &
  & 0.28652204E-06_JPRB, 0.28618061E-06_JPRB, 0.28589338E-06_JPRB, 0.28558270E-06_JPRB /)

RGHG3(:,28, 5) = (/ &
  & 0.28175921E-06_JPRB, 0.28221490E-06_JPRB, 0.28254794E-06_JPRB, 0.28296085E-06_JPRB, 0.28347202E-06_JPRB, 0.28414735E-06_JPRB, &
  & 0.28503490E-06_JPRB, 0.28613249E-06_JPRB, 0.28744057E-06_JPRB, 0.28892421E-06_JPRB, 0.29054704E-06_JPRB, 0.29227533E-06_JPRB, &
  & 0.29404995E-06_JPRB, 0.29582228E-06_JPRB, 0.29753429E-06_JPRB, 0.29914423E-06_JPRB, 0.30062768E-06_JPRB, 0.30197270E-06_JPRB, &
  & 0.30318017E-06_JPRB, 0.30425494E-06_JPRB, 0.30519840E-06_JPRB, 0.30601257E-06_JPRB, 0.30670552E-06_JPRB, 0.30729487E-06_JPRB, &
  & 0.30780481E-06_JPRB, 0.30827297E-06_JPRB, 0.30873630E-06_JPRB, 0.30923090E-06_JPRB, 0.30976909E-06_JPRB, 0.31033915E-06_JPRB, &
  & 0.31089837E-06_JPRB, 0.31139766E-06_JPRB, 0.31178217E-06_JPRB, 0.31200705E-06_JPRB, 0.31204345E-06_JPRB, 0.31187659E-06_JPRB, &
  & 0.31150569E-06_JPRB, 0.31094032E-06_JPRB, 0.31019727E-06_JPRB, 0.30929718E-06_JPRB, 0.30825765E-06_JPRB, 0.30710831E-06_JPRB, &
  & 0.30587989E-06_JPRB, 0.30460157E-06_JPRB, 0.30329863E-06_JPRB, 0.30200420E-06_JPRB, 0.30074887E-06_JPRB, 0.29955302E-06_JPRB, &
  & 0.29842926E-06_JPRB, 0.29737691E-06_JPRB, 0.29638775E-06_JPRB, 0.29547004E-06_JPRB, 0.29462367E-06_JPRB, 0.29384404E-06_JPRB, &
  & 0.29312270E-06_JPRB, 0.29244873E-06_JPRB, 0.29181251E-06_JPRB, 0.29121389E-06_JPRB, 0.29065734E-06_JPRB, 0.29015473E-06_JPRB, &
  & 0.28971937E-06_JPRB, 0.28934949E-06_JPRB, 0.28901860E-06_JPRB, 0.28860998E-06_JPRB /)

RGHG3(:,29, 5) = (/ &
  & 0.28453317E-06_JPRB, 0.28497359E-06_JPRB, 0.28534930E-06_JPRB, 0.28574001E-06_JPRB, 0.28624657E-06_JPRB, 0.28690755E-06_JPRB, &
  & 0.28775577E-06_JPRB, 0.28881885E-06_JPRB, 0.29006239E-06_JPRB, 0.29146679E-06_JPRB, 0.29300489E-06_JPRB, 0.29463584E-06_JPRB, &
  & 0.29632616E-06_JPRB, 0.29802024E-06_JPRB, 0.29966941E-06_JPRB, 0.30122857E-06_JPRB, 0.30267034E-06_JPRB, 0.30398243E-06_JPRB, &
  & 0.30515909E-06_JPRB, 0.30620086E-06_JPRB, 0.30710987E-06_JPRB, 0.30788601E-06_JPRB, 0.30853920E-06_JPRB, 0.30908285E-06_JPRB, &
  & 0.30953763E-06_JPRB, 0.30993851E-06_JPRB, 0.31031621E-06_JPRB, 0.31070911E-06_JPRB, 0.31113612E-06_JPRB, 0.31159118E-06_JPRB, &
  & 0.31204627E-06_JPRB, 0.31245725E-06_JPRB, 0.31277617E-06_JPRB, 0.31295571E-06_JPRB, 0.31296713E-06_JPRB, 0.31279382E-06_JPRB, &
  & 0.31243579E-06_JPRB, 0.31190126E-06_JPRB, 0.31120840E-06_JPRB, 0.31037692E-06_JPRB, 0.30943050E-06_JPRB, 0.30839962E-06_JPRB, &
  & 0.30731496E-06_JPRB, 0.30619577E-06_JPRB, 0.30506828E-06_JPRB, 0.30394415E-06_JPRB, 0.30284912E-06_JPRB, 0.30180263E-06_JPRB, &
  & 0.30081057E-06_JPRB, 0.29986563E-06_JPRB, 0.29897325E-06_JPRB, 0.29813390E-06_JPRB, 0.29734846E-06_JPRB, 0.29661814E-06_JPRB, &
  & 0.29593431E-06_JPRB, 0.29528900E-06_JPRB, 0.29467338E-06_JPRB, 0.29408642E-06_JPRB, 0.29353345E-06_JPRB, 0.29302581E-06_JPRB, &
  & 0.29257725E-06_JPRB, 0.29218609E-06_JPRB, 0.29182067E-06_JPRB, 0.29132948E-06_JPRB /)

RGHG3(:,30, 5) = (/ &
  & 0.28692929E-06_JPRB, 0.28744819E-06_JPRB, 0.28779792E-06_JPRB, 0.28820790E-06_JPRB, 0.28869977E-06_JPRB, 0.28933931E-06_JPRB, &
  & 0.29016846E-06_JPRB, 0.29117859E-06_JPRB, 0.29236398E-06_JPRB, 0.29369326E-06_JPRB, 0.29514186E-06_JPRB, 0.29668848E-06_JPRB, &
  & 0.29828939E-06_JPRB, 0.29990832E-06_JPRB, 0.30149630E-06_JPRB, 0.30300637E-06_JPRB, 0.30440904E-06_JPRB, 0.30568717E-06_JPRB, &
  & 0.30683626E-06_JPRB, 0.30784790E-06_JPRB, 0.30872943E-06_JPRB, 0.30947538E-06_JPRB, 0.31010094E-06_JPRB, 0.31061282E-06_JPRB, &
  & 0.31103207E-06_JPRB, 0.31138654E-06_JPRB, 0.31170248E-06_JPRB, 0.31201682E-06_JPRB, 0.31235015E-06_JPRB, 0.31270278E-06_JPRB, &
  & 0.31305805E-06_JPRB, 0.31337976E-06_JPRB, 0.31362850E-06_JPRB, 0.31375939E-06_JPRB, 0.31374472E-06_JPRB, 0.31356888E-06_JPRB, &
  & 0.31322980E-06_JPRB, 0.31273967E-06_JPRB, 0.31211391E-06_JPRB, 0.31137398E-06_JPRB, 0.31053980E-06_JPRB, 0.30964256E-06_JPRB, &
  & 0.30870430E-06_JPRB, 0.30774433E-06_JPRB, 0.30676870E-06_JPRB, 0.30580009E-06_JPRB, 0.30483835E-06_JPRB, 0.30390794E-06_JPRB, &
  & 0.30301626E-06_JPRB, 0.30215614E-06_JPRB, 0.30133103E-06_JPRB, 0.30054440E-06_JPRB, 0.29980222E-06_JPRB, 0.29910558E-06_JPRB, &
  & 0.29844958E-06_JPRB, 0.29782697E-06_JPRB, 0.29722884E-06_JPRB, 0.29665426E-06_JPRB, 0.29610766E-06_JPRB, 0.29559945E-06_JPRB, &
  & 0.29514447E-06_JPRB, 0.29474015E-06_JPRB, 0.29435259E-06_JPRB, 0.29381366E-06_JPRB /)

RGHG3(:,31, 5) = (/ &
  & 0.28910250E-06_JPRB, 0.28961426E-06_JPRB, 0.29001075E-06_JPRB, 0.29040635E-06_JPRB, 0.29090037E-06_JPRB, 0.29152983E-06_JPRB, &
  & 0.29232245E-06_JPRB, 0.29329431E-06_JPRB, 0.29441478E-06_JPRB, 0.29566712E-06_JPRB, 0.29703614E-06_JPRB, 0.29849332E-06_JPRB, &
  & 0.30001516E-06_JPRB, 0.30155479E-06_JPRB, 0.30307530E-06_JPRB, 0.30453546E-06_JPRB, 0.30589845E-06_JPRB, 0.30714330E-06_JPRB, &
  & 0.30826445E-06_JPRB, 0.30924787E-06_JPRB, 0.31010273E-06_JPRB, 0.31082317E-06_JPRB, 0.31142508E-06_JPRB, 0.31191414E-06_JPRB, &
  & 0.31230829E-06_JPRB, 0.31263073E-06_JPRB, 0.31290486E-06_JPRB, 0.31315972E-06_JPRB, 0.31341955E-06_JPRB, 0.31368393E-06_JPRB, &
  & 0.31395015E-06_JPRB, 0.31418966E-06_JPRB, 0.31436991E-06_JPRB, 0.31445381E-06_JPRB, 0.31441482E-06_JPRB, 0.31423923E-06_JPRB, &
  & 0.31392705E-06_JPRB, 0.31348981E-06_JPRB, 0.31294235E-06_JPRB, 0.31230124E-06_JPRB, 0.31158834E-06_JPRB, 0.31082510E-06_JPRB, &
  & 0.31003054E-06_JPRB, 0.30921447E-06_JPRB, 0.30838342E-06_JPRB, 0.30753560E-06_JPRB, 0.30668937E-06_JPRB, 0.30585093E-06_JPRB, &
  & 0.30503321E-06_JPRB, 0.30423541E-06_JPRB, 0.30345802E-06_JPRB, 0.30271033E-06_JPRB, 0.30199953E-06_JPRB, 0.30132844E-06_JPRB, &
  & 0.30069501E-06_JPRB, 0.30009178E-06_JPRB, 0.29951113E-06_JPRB, 0.29895034E-06_JPRB, 0.29841317E-06_JPRB, 0.29790999E-06_JPRB, &
  & 0.29745362E-06_JPRB, 0.29704384E-06_JPRB, 0.29664452E-06_JPRB, 0.29607713E-06_JPRB /)

RGHG3(:,32, 5) = (/ &
  & 0.29102409E-06_JPRB, 0.29162013E-06_JPRB, 0.29200328E-06_JPRB, 0.29242636E-06_JPRB, 0.29291462E-06_JPRB, 0.29352839E-06_JPRB, &
  & 0.29429825E-06_JPRB, 0.29521610E-06_JPRB, 0.29627282E-06_JPRB, 0.29745050E-06_JPRB, 0.29873286E-06_JPRB, 0.30010804E-06_JPRB, &
  & 0.30154280E-06_JPRB, 0.30300913E-06_JPRB, 0.30446230E-06_JPRB, 0.30586506E-06_JPRB, 0.30718607E-06_JPRB, 0.30839408E-06_JPRB, &
  & 0.30948442E-06_JPRB, 0.31044087E-06_JPRB, 0.31126805E-06_JPRB, 0.31196609E-06_JPRB, 0.31254470E-06_JPRB, 0.31301522E-06_JPRB, &
  & 0.31338945E-06_JPRB, 0.31368867E-06_JPRB, 0.31393313E-06_JPRB, 0.31414572E-06_JPRB, 0.31434743E-06_JPRB, 0.31454272E-06_JPRB, &
  & 0.31473277E-06_JPRB, 0.31490043E-06_JPRB, 0.31501918E-06_JPRB, 0.31505920E-06_JPRB, 0.31499764E-06_JPRB, 0.31482520E-06_JPRB, &
  & 0.31454448E-06_JPRB, 0.31416488E-06_JPRB, 0.31369839E-06_JPRB, 0.31315875E-06_JPRB, 0.31256121E-06_JPRB, 0.31192496E-06_JPRB, &
  & 0.31125666E-06_JPRB, 0.31056749E-06_JPRB, 0.30985180E-06_JPRB, 0.30911258E-06_JPRB, 0.30835662E-06_JPRB, 0.30759594E-06_JPRB, &
  & 0.30683907E-06_JPRB, 0.30608928E-06_JPRB, 0.30535119E-06_JPRB, 0.30463440E-06_JPRB, 0.30394966E-06_JPRB, 0.30330150E-06_JPRB, &
  & 0.30268899E-06_JPRB, 0.30210560E-06_JPRB, 0.30154291E-06_JPRB, 0.30099878E-06_JPRB, 0.30047539E-06_JPRB, 0.29998171E-06_JPRB, &
  & 0.29953105E-06_JPRB, 0.29912127E-06_JPRB, 0.29871700E-06_JPRB, 0.29813182E-06_JPRB /)

RGHG3(:,33, 5) = (/ &
  & 0.29283311E-06_JPRB, 0.29344523E-06_JPRB, 0.29388173E-06_JPRB, 0.29430007E-06_JPRB, 0.29479349E-06_JPRB, 0.29539586E-06_JPRB, &
  & 0.29612718E-06_JPRB, 0.29699564E-06_JPRB, 0.29798287E-06_JPRB, 0.29907875E-06_JPRB, 0.30027894E-06_JPRB, 0.30156343E-06_JPRB, &
  & 0.30291557E-06_JPRB, 0.30429740E-06_JPRB, 0.30568054E-06_JPRB, 0.30702637E-06_JPRB, 0.30830057E-06_JPRB, 0.30947263E-06_JPRB, &
  & 0.31052863E-06_JPRB, 0.31145814E-06_JPRB, 0.31225855E-06_JPRB, 0.31293399E-06_JPRB, 0.31349092E-06_JPRB, 0.31394322E-06_JPRB, &
  & 0.31430034E-06_JPRB, 0.31458052E-06_JPRB, 0.31480209E-06_JPRB, 0.31498348E-06_JPRB, 0.31514222E-06_JPRB, 0.31528430E-06_JPRB, &
  & 0.31541379E-06_JPRB, 0.31552179E-06_JPRB, 0.31558920E-06_JPRB, 0.31559381E-06_JPRB, 0.31551841E-06_JPRB, 0.31535592E-06_JPRB, &
  & 0.31510658E-06_JPRB, 0.31478055E-06_JPRB, 0.31438839E-06_JPRB, 0.31394006E-06_JPRB, 0.31344570E-06_JPRB, 0.31291518E-06_JPRB, &
  & 0.31235751E-06_JPRB, 0.31176788E-06_JPRB, 0.31114999E-06_JPRB, 0.31049507E-06_JPRB, 0.30981616E-06_JPRB, 0.30912238E-06_JPRB, &
  & 0.30841818E-06_JPRB, 0.30771224E-06_JPRB, 0.30700900E-06_JPRB, 0.30632219E-06_JPRB, 0.30566352E-06_JPRB, 0.30503958E-06_JPRB, &
  & 0.30444963E-06_JPRB, 0.30388753E-06_JPRB, 0.30334547E-06_JPRB, 0.30282075E-06_JPRB, 0.30231470E-06_JPRB, 0.30183693E-06_JPRB, &
  & 0.30139665E-06_JPRB, 0.30099386E-06_JPRB, 0.30059138E-06_JPRB, 0.30000047E-06_JPRB /)

RGHG3(:,34, 5) = (/ &
  & 0.29450459E-06_JPRB, 0.29520021E-06_JPRB, 0.29563230E-06_JPRB, 0.29607651E-06_JPRB, 0.29656448E-06_JPRB, 0.29714812E-06_JPRB, &
  & 0.29784599E-06_JPRB, 0.29865535E-06_JPRB, 0.29957064E-06_JPRB, 0.30058615E-06_JPRB, 0.30169508E-06_JPRB, 0.30289260E-06_JPRB, &
  & 0.30415438E-06_JPRB, 0.30545726E-06_JPRB, 0.30676370E-06_JPRB, 0.30804500E-06_JPRB, 0.30926901E-06_JPRB, 0.31040295E-06_JPRB, &
  & 0.31142588E-06_JPRB, 0.31232653E-06_JPRB, 0.31310222E-06_JPRB, 0.31375470E-06_JPRB, 0.31429181E-06_JPRB, 0.31472499E-06_JPRB, &
  & 0.31506596E-06_JPRB, 0.31532878E-06_JPRB, 0.31553122E-06_JPRB, 0.31568771E-06_JPRB, 0.31581396E-06_JPRB, 0.31591640E-06_JPRB, &
  & 0.31600013E-06_JPRB, 0.31606172E-06_JPRB, 0.31608860E-06_JPRB, 0.31606558E-06_JPRB, 0.31598009E-06_JPRB, 0.31582823E-06_JPRB, &
  & 0.31561390E-06_JPRB, 0.31534034E-06_JPRB, 0.31501438E-06_JPRB, 0.31464265E-06_JPRB, 0.31423130E-06_JPRB, 0.31378750E-06_JPRB, &
  & 0.31331146E-06_JPRB, 0.31280538E-06_JPRB, 0.31226071E-06_JPRB, 0.31167872E-06_JPRB, 0.31106336E-06_JPRB, 0.31042521E-06_JPRB, &
  & 0.30977205E-06_JPRB, 0.30910630E-06_JPRB, 0.30843896E-06_JPRB, 0.30778381E-06_JPRB, 0.30715381E-06_JPRB, 0.30655715E-06_JPRB, &
  & 0.30599267E-06_JPRB, 0.30545453E-06_JPRB, 0.30493572E-06_JPRB, 0.30443408E-06_JPRB, 0.30395097E-06_JPRB, 0.30349386E-06_JPRB, &
  & 0.30307166E-06_JPRB, 0.30268177E-06_JPRB, 0.30228807E-06_JPRB, 0.30170241E-06_JPRB /)

RGHG3(:,35, 5) = (/ &
  & 0.29611667E-06_JPRB, 0.29683679E-06_JPRB, 0.29731038E-06_JPRB, 0.29775100E-06_JPRB, 0.29823809E-06_JPRB, 0.29880312E-06_JPRB, &
  & 0.29945943E-06_JPRB, 0.30021229E-06_JPRB, 0.30105465E-06_JPRB, 0.30198581E-06_JPRB, 0.30300782E-06_JPRB, 0.30411144E-06_JPRB, &
  & 0.30528437E-06_JPRB, 0.30649971E-06_JPRB, 0.30773143E-06_JPRB, 0.30894637E-06_JPRB, 0.31011325E-06_JPRB, 0.31120518E-06_JPRB, &
  & 0.31219625E-06_JPRB, 0.31306993E-06_JPRB, 0.31382217E-06_JPRB, 0.31445387E-06_JPRB, 0.31497126E-06_JPRB, 0.31538599E-06_JPRB, &
  & 0.31570968E-06_JPRB, 0.31595553E-06_JPRB, 0.31614002E-06_JPRB, 0.31627590E-06_JPRB, 0.31637688E-06_JPRB, 0.31644959E-06_JPRB, &
  & 0.31649989E-06_JPRB, 0.31652763E-06_JPRB, 0.31652542E-06_JPRB, 0.31648472E-06_JPRB, 0.31639757E-06_JPRB, 0.31626061E-06_JPRB, &
  & 0.31607598E-06_JPRB, 0.31584841E-06_JPRB, 0.31557897E-06_JPRB, 0.31526855E-06_JPRB, 0.31492030E-06_JPRB, 0.31453848E-06_JPRB, &
  & 0.31412608E-06_JPRB, 0.31367750E-06_JPRB, 0.31319377E-06_JPRB, 0.31266808E-06_JPRB, 0.31210766E-06_JPRB, 0.31152092E-06_JPRB, &
  & 0.31091122E-06_JPRB, 0.31028659E-06_JPRB, 0.30965558E-06_JPRB, 0.30903396E-06_JPRB, 0.30843654E-06_JPRB, 0.30787032E-06_JPRB, &
  & 0.30733463E-06_JPRB, 0.30682372E-06_JPRB, 0.30633171E-06_JPRB, 0.30585642E-06_JPRB, 0.30540014E-06_JPRB, 0.30496960E-06_JPRB, &
  & 0.30457110E-06_JPRB, 0.30420065E-06_JPRB, 0.30382321E-06_JPRB, 0.30325384E-06_JPRB /)

RGHG3(:,36, 5) = (/ &
  & 0.29763453E-06_JPRB, 0.29840803E-06_JPRB, 0.29888389E-06_JPRB, 0.29933693E-06_JPRB, 0.29981962E-06_JPRB, 0.30036239E-06_JPRB, &
  & 0.30098110E-06_JPRB, 0.30167595E-06_JPRB, 0.30244621E-06_JPRB, 0.30329539E-06_JPRB, 0.30422717E-06_JPRB, 0.30524015E-06_JPRB, &
  & 0.30632131E-06_JPRB, 0.30745070E-06_JPRB, 0.30860099E-06_JPRB, 0.30974724E-06_JPRB, 0.31085690E-06_JPRB, 0.31190172E-06_JPRB, &
  & 0.31285899E-06_JPRB, 0.31370826E-06_JPRB, 0.31443997E-06_JPRB, 0.31505337E-06_JPRB, 0.31555263E-06_JPRB, 0.31594786E-06_JPRB, &
  & 0.31625166E-06_JPRB, 0.31647824E-06_JPRB, 0.31664317E-06_JPRB, 0.31675975E-06_JPRB, 0.31683987E-06_JPRB, 0.31689095E-06_JPRB, &
  & 0.31691800E-06_JPRB, 0.31692363E-06_JPRB, 0.31690399E-06_JPRB, 0.31685516E-06_JPRB, 0.31677322E-06_JPRB, 0.31665638E-06_JPRB, &
  & 0.31650225E-06_JPRB, 0.31631200E-06_JPRB, 0.31608738E-06_JPRB, 0.31582465E-06_JPRB, 0.31552202E-06_JPRB, 0.31518380E-06_JPRB, &
  & 0.31481176E-06_JPRB, 0.31440760E-06_JPRB, 0.31396632E-06_JPRB, 0.31348839E-06_JPRB, 0.31297446E-06_JPRB, 0.31243073E-06_JPRB, &
  & 0.31186246E-06_JPRB, 0.31127507E-06_JPRB, 0.31068009E-06_JPRB, 0.31009407E-06_JPRB, 0.30953092E-06_JPRB, 0.30899884E-06_JPRB, &
  & 0.30849512E-06_JPRB, 0.30801459E-06_JPRB, 0.30755172E-06_JPRB, 0.30710598E-06_JPRB, 0.30668050E-06_JPRB, 0.30628109E-06_JPRB, &
  & 0.30591207E-06_JPRB, 0.30556737E-06_JPRB, 0.30521252E-06_JPRB, 0.30467100E-06_JPRB /)

RGHG3(:,37, 5) = (/ &
  & 0.29908838E-06_JPRB, 0.29988502E-06_JPRB, 0.30037853E-06_JPRB, 0.30083481E-06_JPRB, 0.30131389E-06_JPRB, 0.30184029E-06_JPRB, &
  & 0.30242191E-06_JPRB, 0.30306134E-06_JPRB, 0.30376111E-06_JPRB, 0.30452910E-06_JPRB, 0.30537302E-06_JPRB, 0.30629346E-06_JPRB, &
  & 0.30728253E-06_JPRB, 0.30832314E-06_JPRB, 0.30939160E-06_JPRB, 0.31046397E-06_JPRB, 0.31151387E-06_JPRB, 0.31251179E-06_JPRB, &
  & 0.31343427E-06_JPRB, 0.31425967E-06_JPRB, 0.31497279E-06_JPRB, 0.31556957E-06_JPRB, 0.31604870E-06_JPRB, 0.31641977E-06_JPRB, &
  & 0.31669651E-06_JPRB, 0.31689683E-06_JPRB, 0.31703769E-06_JPRB, 0.31713370E-06_JPRB, 0.31719549E-06_JPRB, 0.31723130E-06_JPRB, &
  & 0.31724420E-06_JPRB, 0.31723832E-06_JPRB, 0.31721191E-06_JPRB, 0.31716320E-06_JPRB, 0.31709101E-06_JPRB, 0.31699349E-06_JPRB, &
  & 0.31687091E-06_JPRB, 0.31671814E-06_JPRB, 0.31653190E-06_JPRB, 0.31630867E-06_JPRB, 0.31604304E-06_JPRB, 0.31573504E-06_JPRB, &
  & 0.31539184E-06_JPRB, 0.31501608E-06_JPRB, 0.31460897E-06_JPRB, 0.31416698E-06_JPRB, 0.31369225E-06_JPRB, 0.31318683E-06_JPRB, &
  & 0.31265429E-06_JPRB, 0.31210135E-06_JPRB, 0.31154107E-06_JPRB, 0.31098986E-06_JPRB, 0.31046324E-06_JPRB, 0.30996682E-06_JPRB, &
  & 0.30949772E-06_JPRB, 0.30904994E-06_JPRB, 0.30861864E-06_JPRB, 0.30820487E-06_JPRB, 0.30781297E-06_JPRB, 0.30744823E-06_JPRB, &
  & 0.30711277E-06_JPRB, 0.30679834E-06_JPRB, 0.30647206E-06_JPRB, 0.30596718E-06_JPRB /)

RGHG3(:,38, 5) = (/ &
  & 0.30047778E-06_JPRB, 0.30128308E-06_JPRB, 0.30178984E-06_JPRB, 0.30224862E-06_JPRB, 0.30273435E-06_JPRB, 0.30324483E-06_JPRB, &
  & 0.30379348E-06_JPRB, 0.30438051E-06_JPRB, 0.30501130E-06_JPRB, 0.30569944E-06_JPRB, 0.30645705E-06_JPRB, 0.30728657E-06_JPRB, &
  & 0.30818342E-06_JPRB, 0.30913361E-06_JPRB, 0.31011754E-06_JPRB, 0.31111367E-06_JPRB, 0.31209828E-06_JPRB, 0.31304685E-06_JPRB, &
  & 0.31393321E-06_JPRB, 0.31473419E-06_JPRB, 0.31542760E-06_JPRB, 0.31600044E-06_JPRB, 0.31645172E-06_JPRB, 0.31678732E-06_JPRB, &
  & 0.31702703E-06_JPRB, 0.31719338E-06_JPRB, 0.31730644E-06_JPRB, 0.31738142E-06_JPRB, 0.31742806E-06_JPRB, 0.31745347E-06_JPRB, &
  & 0.31746018E-06_JPRB, 0.31745071E-06_JPRB, 0.31742519E-06_JPRB, 0.31738287E-06_JPRB, 0.31732338E-06_JPRB, 0.31724619E-06_JPRB, &
  & 0.31714956E-06_JPRB, 0.31703081E-06_JPRB, 0.31688145E-06_JPRB, 0.31669532E-06_JPRB, 0.31646590E-06_JPRB, 0.31619089E-06_JPRB, &
  & 0.31587479E-06_JPRB, 0.31552403E-06_JPRB, 0.31514347E-06_JPRB, 0.31473260E-06_JPRB, 0.31429073E-06_JPRB, 0.31381802E-06_JPRB, &
  & 0.31331678E-06_JPRB, 0.31279458E-06_JPRB, 0.31226560E-06_JPRB, 0.31174866E-06_JPRB, 0.31125796E-06_JPRB, 0.31079841E-06_JPRB, &
  & 0.31036564E-06_JPRB, 0.30995207E-06_JPRB, 0.30955403E-06_JPRB, 0.30917377E-06_JPRB, 0.30881722E-06_JPRB, 0.30848921E-06_JPRB, &
  & 0.30818967E-06_JPRB, 0.30790844E-06_JPRB, 0.30761399E-06_JPRB, 0.30715279E-06_JPRB /)

RGHG3(:,39, 5) = (/ &
  & 0.30180362E-06_JPRB, 0.30262163E-06_JPRB, 0.30311625E-06_JPRB, 0.30359536E-06_JPRB, 0.30407722E-06_JPRB, 0.30458429E-06_JPRB, &
  & 0.30510279E-06_JPRB, 0.30563859E-06_JPRB, 0.30620282E-06_JPRB, 0.30681375E-06_JPRB, 0.30748552E-06_JPRB, 0.30822648E-06_JPRB, &
  & 0.30903229E-06_JPRB, 0.30989227E-06_JPRB, 0.31078997E-06_JPRB, 0.31170774E-06_JPRB, 0.31262542E-06_JPRB, 0.31352033E-06_JPRB, &
  & 0.31436650E-06_JPRB, 0.31513804E-06_JPRB, 0.31580342E-06_JPRB, 0.31634204E-06_JPRB, 0.31675012E-06_JPRB, 0.31704269E-06_JPRB, &
  & 0.31724198E-06_JPRB, 0.31737557E-06_JPRB, 0.31746441E-06_JPRB, 0.31752265E-06_JPRB, 0.31755889E-06_JPRB, 0.31757787E-06_JPRB, &
  & 0.31758236E-06_JPRB, 0.31757293E-06_JPRB, 0.31755039E-06_JPRB, 0.31751469E-06_JPRB, 0.31746646E-06_JPRB, 0.31740478E-06_JPRB, &
  & 0.31732887E-06_JPRB, 0.31723522E-06_JPRB, 0.31711826E-06_JPRB, 0.31696862E-06_JPRB, 0.31677789E-06_JPRB, 0.31654150E-06_JPRB, &
  & 0.31626058E-06_JPRB, 0.31594152E-06_JPRB, 0.31558841E-06_JPRB, 0.31520619E-06_JPRB, 0.31479334E-06_JPRB, 0.31434988E-06_JPRB, &
  & 0.31387680E-06_JPRB, 0.31338158E-06_JPRB, 0.31288135E-06_JPRB, 0.31239597E-06_JPRB, 0.31193997E-06_JPRB, 0.31151691E-06_JPRB, &
  & 0.31111986E-06_JPRB, 0.31074120E-06_JPRB, 0.31037689E-06_JPRB, 0.31003108E-06_JPRB, 0.30971040E-06_JPRB, 0.30941970E-06_JPRB, &
  & 0.30915652E-06_JPRB, 0.30890916E-06_JPRB, 0.30864763E-06_JPRB, 0.30823409E-06_JPRB /)

RGHG3(:,40, 5) = (/ &
  & 0.30309661E-06_JPRB, 0.30387881E-06_JPRB, 0.30438832E-06_JPRB, 0.30485711E-06_JPRB, 0.30536106E-06_JPRB, 0.30585713E-06_JPRB, &
  & 0.30635016E-06_JPRB, 0.30683759E-06_JPRB, 0.30733770E-06_JPRB, 0.30787186E-06_JPRB, 0.30846189E-06_JPRB, 0.30911548E-06_JPRB, &
  & 0.30983287E-06_JPRB, 0.31060492E-06_JPRB, 0.31141766E-06_JPRB, 0.31225585E-06_JPRB, 0.31310398E-06_JPRB, 0.31394222E-06_JPRB, &
  & 0.31474403E-06_JPRB, 0.31547532E-06_JPRB, 0.31610423E-06_JPRB, 0.31659854E-06_JPRB, 0.31695961E-06_JPRB, 0.31720884E-06_JPRB, &
  & 0.31737437E-06_JPRB, 0.31748294E-06_JPRB, 0.31755465E-06_JPRB, 0.31760175E-06_JPRB, 0.31763133E-06_JPRB, 0.31764694E-06_JPRB, &
  & 0.31765026E-06_JPRB, 0.31764191E-06_JPRB, 0.31762195E-06_JPRB, 0.31759097E-06_JPRB, 0.31754996E-06_JPRB, 0.31749872E-06_JPRB, &
  & 0.31743625E-06_JPRB, 0.31736073E-06_JPRB, 0.31726728E-06_JPRB, 0.31714839E-06_JPRB, 0.31699494E-06_JPRB, 0.31679946E-06_JPRB, &
  & 0.31656015E-06_JPRB, 0.31627843E-06_JPRB, 0.31596005E-06_JPRB, 0.31560705E-06_JPRB, 0.31522271E-06_JPRB, 0.31480573E-06_JPRB, &
  & 0.31435798E-06_JPRB, 0.31388740E-06_JPRB, 0.31341256E-06_JPRB, 0.31295622E-06_JPRB, 0.31253288E-06_JPRB, 0.31214410E-06_JPRB, &
  & 0.31178163E-06_JPRB, 0.31143645E-06_JPRB, 0.31110542E-06_JPRB, 0.31079304E-06_JPRB, 0.31050794E-06_JPRB, 0.31025343E-06_JPRB, &
  & 0.31002531E-06_JPRB, 0.30981059E-06_JPRB, 0.30958213E-06_JPRB, 0.30921598E-06_JPRB /)

RGHG3(:,41, 5) = (/ &
  & 0.30434424E-06_JPRB, 0.30510523E-06_JPRB, 0.30558189E-06_JPRB, 0.30607123E-06_JPRB, 0.30656963E-06_JPRB, 0.30707039E-06_JPRB, &
  & 0.30753569E-06_JPRB, 0.30797651E-06_JPRB, 0.30841352E-06_JPRB, 0.30887557E-06_JPRB, 0.30938429E-06_JPRB, 0.30995466E-06_JPRB, &
  & 0.31058735E-06_JPRB, 0.31127496E-06_JPRB, 0.31200565E-06_JPRB, 0.31276755E-06_JPRB, 0.31354568E-06_JPRB, 0.31432347E-06_JPRB, &
  & 0.31507480E-06_JPRB, 0.31576189E-06_JPRB, 0.31634204E-06_JPRB, 0.31679099E-06_JPRB, 0.31710763E-06_JPRB, 0.31732048E-06_JPRB, &
  & 0.31745975E-06_JPRB, 0.31755044E-06_JPRB, 0.31761039E-06_JPRB, 0.31765018E-06_JPRB, 0.31767553E-06_JPRB, 0.31768926E-06_JPRB, &
  & 0.31769207E-06_JPRB, 0.31768468E-06_JPRB, 0.31766689E-06_JPRB, 0.31763881E-06_JPRB, 0.31760271E-06_JPRB, 0.31755818E-06_JPRB, &
  & 0.31750463E-06_JPRB, 0.31744131E-06_JPRB, 0.31736423E-06_JPRB, 0.31726822E-06_JPRB, 0.31714563E-06_JPRB, 0.31698923E-06_JPRB, &
  & 0.31679315E-06_JPRB, 0.31655401E-06_JPRB, 0.31627334E-06_JPRB, 0.31595403E-06_JPRB, 0.31559750E-06_JPRB, 0.31520631E-06_JPRB, &
  & 0.31478231E-06_JPRB, 0.31433387E-06_JPRB, 0.31388211E-06_JPRB, 0.31345212E-06_JPRB, 0.31305862E-06_JPRB, 0.31270159E-06_JPRB, &
  & 0.31237144E-06_JPRB, 0.31205795E-06_JPRB, 0.31175813E-06_JPRB, 0.31147800E-06_JPRB, 0.31122624E-06_JPRB, 0.31100555E-06_JPRB, &
  & 0.31080975E-06_JPRB, 0.31062541E-06_JPRB, 0.31042708E-06_JPRB, 0.31010660E-06_JPRB /)

RGHG3(:,42, 5) = (/ &
  & 0.30557158E-06_JPRB, 0.30627865E-06_JPRB, 0.30674519E-06_JPRB, 0.30721651E-06_JPRB, 0.30772932E-06_JPRB, 0.30822099E-06_JPRB, &
  & 0.30866053E-06_JPRB, 0.30905551E-06_JPRB, 0.30943363E-06_JPRB, 0.30982497E-06_JPRB, 0.31025695E-06_JPRB, 0.31074683E-06_JPRB, &
  & 0.31129940E-06_JPRB, 0.31190820E-06_JPRB, 0.31256212E-06_JPRB, 0.31324993E-06_JPRB, 0.31396081E-06_JPRB, 0.31467684E-06_JPRB, &
  & 0.31537274E-06_JPRB, 0.31600808E-06_JPRB, 0.31653906E-06_JPRB, 0.31693952E-06_JPRB, 0.31721751E-06_JPRB, 0.31740055E-06_JPRB, &
  & 0.31751949E-06_JPRB, 0.31759700E-06_JPRB, 0.31764858E-06_JPRB, 0.31768343E-06_JPRB, 0.31770597E-06_JPRB, 0.31771845E-06_JPRB, &
  & 0.31772134E-06_JPRB, 0.31771464E-06_JPRB, 0.31769872E-06_JPRB, 0.31767274E-06_JPRB, 0.31764006E-06_JPRB, 0.31760015E-06_JPRB, &
  & 0.31755275E-06_JPRB, 0.31749755E-06_JPRB, 0.31743244E-06_JPRB, 0.31735297E-06_JPRB, 0.31725418E-06_JPRB, 0.31713003E-06_JPRB, &
  & 0.31697445E-06_JPRB, 0.31678067E-06_JPRB, 0.31654250E-06_JPRB, 0.31626075E-06_JPRB, 0.31593615E-06_JPRB, 0.31557093E-06_JPRB, &
  & 0.31517001E-06_JPRB, 0.31474283E-06_JPRB, 0.31431188E-06_JPRB, 0.31390624E-06_JPRB, 0.31354008E-06_JPRB, 0.31321241E-06_JPRB, &
  & 0.31291168E-06_JPRB, 0.31262746E-06_JPRB, 0.31235660E-06_JPRB, 0.31210604E-06_JPRB, 0.31188472E-06_JPRB, 0.31169427E-06_JPRB, &
  & 0.31152695E-06_JPRB, 0.31136926E-06_JPRB, 0.31119819E-06_JPRB, 0.31091830E-06_JPRB /)

RGHG3(:,43, 5) = (/ &
  & 0.30677361E-06_JPRB, 0.30743297E-06_JPRB, 0.30786327E-06_JPRB, 0.30832598E-06_JPRB, 0.30883317E-06_JPRB, 0.30931571E-06_JPRB, &
  & 0.30972734E-06_JPRB, 0.31007730E-06_JPRB, 0.31039949E-06_JPRB, 0.31072634E-06_JPRB, 0.31108613E-06_JPRB, 0.31149983E-06_JPRB, &
  & 0.31197712E-06_JPRB, 0.31251324E-06_JPRB, 0.31309631E-06_JPRB, 0.31371610E-06_JPRB, 0.31435971E-06_JPRB, 0.31501341E-06_JPRB, &
  & 0.31564903E-06_JPRB, 0.31622886E-06_JPRB, 0.31670547E-06_JPRB, 0.31706048E-06_JPRB, 0.31730295E-06_JPRB, 0.31746166E-06_JPRB, &
  & 0.31756431E-06_JPRB, 0.31763187E-06_JPRB, 0.31767738E-06_JPRB, 0.31770855E-06_JPRB, 0.31772916E-06_JPRB, 0.31774084E-06_JPRB, &
  & 0.31774400E-06_JPRB, 0.31773791E-06_JPRB, 0.31772350E-06_JPRB, 0.31769940E-06_JPRB, 0.31766905E-06_JPRB, 0.31763267E-06_JPRB, &
  & 0.31758952E-06_JPRB, 0.31754050E-06_JPRB, 0.31748371E-06_JPRB, 0.31741683E-06_JPRB, 0.31733612E-06_JPRB, 0.31723789E-06_JPRB, &
  & 0.31711718E-06_JPRB, 0.31696592E-06_JPRB, 0.31677553E-06_JPRB, 0.31653738E-06_JPRB, 0.31624984E-06_JPRB, 0.31591492E-06_JPRB, &
  & 0.31553841E-06_JPRB, 0.31513230E-06_JPRB, 0.31472209E-06_JPRB, 0.31433848E-06_JPRB, 0.31399821E-06_JPRB, 0.31369729E-06_JPRB, &
  & 0.31342401E-06_JPRB, 0.31316651E-06_JPRB, 0.31292197E-06_JPRB, 0.31269803E-06_JPRB, 0.31250352E-06_JPRB, 0.31233895E-06_JPRB, &
  & 0.31219568E-06_JPRB, 0.31206068E-06_JPRB, 0.31191257E-06_JPRB, 0.31166806E-06_JPRB /)

RGHG3(:,44, 5) = (/ &
  & 0.30795681E-06_JPRB, 0.30855045E-06_JPRB, 0.30895868E-06_JPRB, 0.30939290E-06_JPRB, 0.30988900E-06_JPRB, 0.31035802E-06_JPRB, &
  & 0.31073728E-06_JPRB, 0.31104548E-06_JPRB, 0.31131691E-06_JPRB, 0.31158544E-06_JPRB, 0.31187932E-06_JPRB, 0.31222368E-06_JPRB, &
  & 0.31263102E-06_JPRB, 0.31310066E-06_JPRB, 0.31362057E-06_JPRB, 0.31417540E-06_JPRB, 0.31475599E-06_JPRB, 0.31534339E-06_JPRB, &
  & 0.31591600E-06_JPRB, 0.31643032E-06_JPRB, 0.31685263E-06_JPRB, 0.31716129E-06_JPRB, 0.31737247E-06_JPRB, 0.31751023E-06_JPRB, &
  & 0.31759987E-06_JPRB, 0.31765950E-06_JPRB, 0.31770031E-06_JPRB, 0.31772873E-06_JPRB, 0.31774806E-06_JPRB, 0.31775926E-06_JPRB, &
  & 0.31776273E-06_JPRB, 0.31775747E-06_JPRB, 0.31774428E-06_JPRB, 0.31772177E-06_JPRB, 0.31769338E-06_JPRB, 0.31765961E-06_JPRB, &
  & 0.31761979E-06_JPRB, 0.31757503E-06_JPRB, 0.31752472E-06_JPRB, 0.31746703E-06_JPRB, 0.31740049E-06_JPRB, 0.31732282E-06_JPRB, &
  & 0.31723064E-06_JPRB, 0.31711784E-06_JPRB, 0.31697326E-06_JPRB, 0.31678496E-06_JPRB, 0.31654346E-06_JPRB, 0.31624597E-06_JPRB, &
  & 0.31589838E-06_JPRB, 0.31551508E-06_JPRB, 0.31512556E-06_JPRB, 0.31476529E-06_JPRB, 0.31444876E-06_JPRB, 0.31417386E-06_JPRB, &
  & 0.31392537E-06_JPRB, 0.31369254E-06_JPRB, 0.31347210E-06_JPRB, 0.31327158E-06_JPRB, 0.31310017E-06_JPRB, 0.31295690E-06_JPRB, &
  & 0.31283372E-06_JPRB, 0.31271699E-06_JPRB, 0.31258872E-06_JPRB, 0.31237371E-06_JPRB /)

RGHG3(:,45, 5) = (/ &
  & 0.30909197E-06_JPRB, 0.30964995E-06_JPRB, 0.31000809E-06_JPRB, 0.31042543E-06_JPRB, 0.31089948E-06_JPRB, 0.31134573E-06_JPRB, &
  & 0.31169503E-06_JPRB, 0.31196362E-06_JPRB, 0.31219093E-06_JPRB, 0.31240936E-06_JPRB, 0.31264773E-06_JPRB, 0.31292836E-06_JPRB, &
  & 0.31327369E-06_JPRB, 0.31368313E-06_JPRB, 0.31414405E-06_JPRB, 0.31464160E-06_JPRB, 0.31515674E-06_JPRB, 0.31567780E-06_JPRB, &
  & 0.31617509E-06_JPRB, 0.31662231E-06_JPRB, 0.31698102E-06_JPRB, 0.31724790E-06_JPRB, 0.31742940E-06_JPRB, 0.31754982E-06_JPRB, &
  & 0.31762877E-06_JPRB, 0.31768207E-06_JPRB, 0.31771933E-06_JPRB, 0.31774582E-06_JPRB, 0.31776426E-06_JPRB, 0.31777526E-06_JPRB, &
  & 0.31777901E-06_JPRB, 0.31777455E-06_JPRB, 0.31776250E-06_JPRB, 0.31774152E-06_JPRB, 0.31771464E-06_JPRB, 0.31768280E-06_JPRB, &
  & 0.31764534E-06_JPRB, 0.31760396E-06_JPRB, 0.31755818E-06_JPRB, 0.31750784E-06_JPRB, 0.31745202E-06_JPRB, 0.31739040E-06_JPRB, &
  & 0.31732122E-06_JPRB, 0.31723937E-06_JPRB, 0.31713620E-06_JPRB, 0.31699744E-06_JPRB, 0.31680852E-06_JPRB, 0.31655964E-06_JPRB, &
  & 0.31624865E-06_JPRB, 0.31589428E-06_JPRB, 0.31553034E-06_JPRB, 0.31519210E-06_JPRB, 0.31490219E-06_JPRB, 0.31465049E-06_JPRB, &
  & 0.31442696E-06_JPRB, 0.31421683E-06_JPRB, 0.31401834E-06_JPRB, 0.31383880E-06_JPRB, 0.31368654E-06_JPRB, 0.31356157E-06_JPRB, &
  & 0.31345405E-06_JPRB, 0.31335321E-06_JPRB, 0.31324052E-06_JPRB, 0.31305109E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART10',0,ZHOOK_HANDLE)



RGHG3(:,46, 5) = (/ &
  & 0.31020053E-06_JPRB, 0.31068231E-06_JPRB, 0.31103508E-06_JPRB, 0.31140576E-06_JPRB, 0.31186326E-06_JPRB, 0.31228586E-06_JPRB, &
  & 0.31260299E-06_JPRB, 0.31283776E-06_JPRB, 0.31302784E-06_JPRB, 0.31320650E-06_JPRB, 0.31339704E-06_JPRB, 0.31362825E-06_JPRB, &
  & 0.31391534E-06_JPRB, 0.31427095E-06_JPRB, 0.31468011E-06_JPRB, 0.31511914E-06_JPRB, 0.31557209E-06_JPRB, 0.31601587E-06_JPRB, &
  & 0.31643432E-06_JPRB, 0.31679795E-06_JPRB, 0.31709800E-06_JPRB, 0.31732026E-06_JPRB, 0.31747706E-06_JPRB, 0.31758208E-06_JPRB, &
  & 0.31765242E-06_JPRB, 0.31770077E-06_JPRB, 0.31773533E-06_JPRB, 0.31776045E-06_JPRB, 0.31777836E-06_JPRB, 0.31778944E-06_JPRB, &
  & 0.31779359E-06_JPRB, 0.31779001E-06_JPRB, 0.31777890E-06_JPRB, 0.31775915E-06_JPRB, 0.31773368E-06_JPRB, 0.31770321E-06_JPRB, &
  & 0.31766766E-06_JPRB, 0.31762852E-06_JPRB, 0.31758648E-06_JPRB, 0.31754138E-06_JPRB, 0.31749420E-06_JPRB, 0.31744497E-06_JPRB, &
  & 0.31739285E-06_JPRB, 0.31733532E-06_JPRB, 0.31726427E-06_JPRB, 0.31716851E-06_JPRB, 0.31703269E-06_JPRB, 0.31683896E-06_JPRB, &
  & 0.31658044E-06_JPRB, 0.31626558E-06_JPRB, 0.31593132E-06_JPRB, 0.31562359E-06_JPRB, 0.31535603E-06_JPRB, 0.31513224E-06_JPRB, &
  & 0.31493011E-06_JPRB, 0.31474252E-06_JPRB, 0.31456420E-06_JPRB, 0.31440331E-06_JPRB, 0.31426819E-06_JPRB, 0.31415777E-06_JPRB, &
  & 0.31406418E-06_JPRB, 0.31397542E-06_JPRB, 0.31387674E-06_JPRB, 0.31370848E-06_JPRB /)

RGHG3(:,47, 5) = (/ &
  & 0.31122863E-06_JPRB, 0.31169495E-06_JPRB, 0.31199070E-06_JPRB, 0.31235868E-06_JPRB, 0.31277827E-06_JPRB, 0.31317876E-06_JPRB, &
  & 0.31346940E-06_JPRB, 0.31367472E-06_JPRB, 0.31383610E-06_JPRB, 0.31398196E-06_JPRB, 0.31413856E-06_JPRB, 0.31432398E-06_JPRB, &
  & 0.31456710E-06_JPRB, 0.31487215E-06_JPRB, 0.31523044E-06_JPRB, 0.31561447E-06_JPRB, 0.31599572E-06_JPRB, 0.31635560E-06_JPRB, &
  & 0.31667898E-06_JPRB, 0.31696294E-06_JPRB, 0.31719719E-06_JPRB, 0.31738250E-06_JPRB, 0.31751588E-06_JPRB, 0.31760865E-06_JPRB, &
  & 0.31767200E-06_JPRB, 0.31771651E-06_JPRB, 0.31774894E-06_JPRB, 0.31777316E-06_JPRB, 0.31779078E-06_JPRB, 0.31780218E-06_JPRB, &
  & 0.31780678E-06_JPRB, 0.31780399E-06_JPRB, 0.31779379E-06_JPRB, 0.31777526E-06_JPRB, 0.31775090E-06_JPRB, 0.31772157E-06_JPRB, &
  & 0.31768715E-06_JPRB, 0.31764995E-06_JPRB, 0.31761047E-06_JPRB, 0.31756991E-06_JPRB, 0.31752916E-06_JPRB, 0.31748917E-06_JPRB, &
  & 0.31745006E-06_JPRB, 0.31740925E-06_JPRB, 0.31736195E-06_JPRB, 0.31729877E-06_JPRB, 0.31720668E-06_JPRB, 0.31707049E-06_JPRB, &
  & 0.31687290E-06_JPRB, 0.31661409E-06_JPRB, 0.31632493E-06_JPRB, 0.31604725E-06_JPRB, 0.31581314E-06_JPRB, 0.31561129E-06_JPRB, &
  & 0.31543476E-06_JPRB, 0.31526665E-06_JPRB, 0.31510751E-06_JPRB, 0.31496342E-06_JPRB, 0.31484299E-06_JPRB, 0.31474553E-06_JPRB, &
  & 0.31466294E-06_JPRB, 0.31458495E-06_JPRB, 0.31449753E-06_JPRB, 0.31434777E-06_JPRB /)

RGHG3(:,48, 5) = (/ &
  & 0.31221376E-06_JPRB, 0.31262476E-06_JPRB, 0.31292487E-06_JPRB, 0.31324922E-06_JPRB, 0.31366230E-06_JPRB, 0.31403772E-06_JPRB, &
  & 0.31430682E-06_JPRB, 0.31448988E-06_JPRB, 0.31462775E-06_JPRB, 0.31474980E-06_JPRB, 0.31487636E-06_JPRB, 0.31503032E-06_JPRB, &
  & 0.31522944E-06_JPRB, 0.31549024E-06_JPRB, 0.31579449E-06_JPRB, 0.31611128E-06_JPRB, 0.31640781E-06_JPRB, 0.31667145E-06_JPRB, &
  & 0.31690058E-06_JPRB, 0.31710363E-06_JPRB, 0.31728339E-06_JPRB, 0.31743247E-06_JPRB, 0.31754769E-06_JPRB, 0.31763025E-06_JPRB, &
  & 0.31768818E-06_JPRB, 0.31772976E-06_JPRB, 0.31776074E-06_JPRB, 0.31778436E-06_JPRB, 0.31780201E-06_JPRB, 0.31781369E-06_JPRB, &
  & 0.31781883E-06_JPRB, 0.31781687E-06_JPRB, 0.31780743E-06_JPRB, 0.31779010E-06_JPRB, 0.31776673E-06_JPRB, 0.31773811E-06_JPRB, &
  & 0.31770483E-06_JPRB, 0.31766891E-06_JPRB, 0.31763165E-06_JPRB, 0.31759436E-06_JPRB, 0.31755872E-06_JPRB, 0.31752580E-06_JPRB, &
  & 0.31749559E-06_JPRB, 0.31746706E-06_JPRB, 0.31743531E-06_JPRB, 0.31739438E-06_JPRB, 0.31733515E-06_JPRB, 0.31724514E-06_JPRB, &
  & 0.31710945E-06_JPRB, 0.31691980E-06_JPRB, 0.31668992E-06_JPRB, 0.31646243E-06_JPRB, 0.31626115E-06_JPRB, 0.31608991E-06_JPRB, &
  & 0.31593396E-06_JPRB, 0.31578662E-06_JPRB, 0.31564394E-06_JPRB, 0.31551491E-06_JPRB, 0.31540750E-06_JPRB, 0.31532107E-06_JPRB, &
  & 0.31524792E-06_JPRB, 0.31517882E-06_JPRB, 0.31510081E-06_JPRB, 0.31496671E-06_JPRB /)

RGHG3(:,49, 5) = (/ &
  & 0.31312698E-06_JPRB, 0.31352235E-06_JPRB, 0.31379733E-06_JPRB, 0.31412088E-06_JPRB, 0.31451171E-06_JPRB, 0.31487463E-06_JPRB, &
  & 0.31512479E-06_JPRB, 0.31528904E-06_JPRB, 0.31540714E-06_JPRB, 0.31550843E-06_JPRB, 0.31560981E-06_JPRB, 0.31573205E-06_JPRB, &
  & 0.31589155E-06_JPRB, 0.31609650E-06_JPRB, 0.31633283E-06_JPRB, 0.31656080E-06_JPRB, 0.31676342E-06_JPRB, 0.31693224E-06_JPRB, &
  & 0.31708197E-06_JPRB, 0.31721913E-06_JPRB, 0.31735212E-06_JPRB, 0.31747308E-06_JPRB, 0.31757259E-06_JPRB, 0.31764753E-06_JPRB, &
  & 0.31770156E-06_JPRB, 0.31774110E-06_JPRB, 0.31777108E-06_JPRB, 0.31779436E-06_JPRB, 0.31781204E-06_JPRB, 0.31782420E-06_JPRB, &
  & 0.31782989E-06_JPRB, 0.31782872E-06_JPRB, 0.31782005E-06_JPRB, 0.31780382E-06_JPRB, 0.31778126E-06_JPRB, 0.31775329E-06_JPRB, &
  & 0.31772080E-06_JPRB, 0.31768613E-06_JPRB, 0.31765057E-06_JPRB, 0.31761596E-06_JPRB, 0.31758401E-06_JPRB, 0.31755624E-06_JPRB, &
  & 0.31753299E-06_JPRB, 0.31751222E-06_JPRB, 0.31749119E-06_JPRB, 0.31746447E-06_JPRB, 0.31742667E-06_JPRB, 0.31736946E-06_JPRB, &
  & 0.31728325E-06_JPRB, 0.31715845E-06_JPRB, 0.31700290E-06_JPRB, 0.31683908E-06_JPRB, 0.31668509E-06_JPRB, 0.31654935E-06_JPRB, &
  & 0.31641986E-06_JPRB, 0.31629270E-06_JPRB, 0.31616685E-06_JPRB, 0.31605165E-06_JPRB, 0.31595584E-06_JPRB, 0.31587922E-06_JPRB, &
  & 0.31581413E-06_JPRB, 0.31575257E-06_JPRB, 0.31568206E-06_JPRB, 0.31556033E-06_JPRB /)

RGHG3(:,50, 5) = (/ &
  & 0.31397195E-06_JPRB, 0.31437054E-06_JPRB, 0.31462992E-06_JPRB, 0.31495009E-06_JPRB, 0.31532301E-06_JPRB, 0.31566194E-06_JPRB, &
  & 0.31588530E-06_JPRB, 0.31602323E-06_JPRB, 0.31611953E-06_JPRB, 0.31619476E-06_JPRB, 0.31627204E-06_JPRB, 0.31635690E-06_JPRB, &
  & 0.31646942E-06_JPRB, 0.31660892E-06_JPRB, 0.31675981E-06_JPRB, 0.31690308E-06_JPRB, 0.31702226E-06_JPRB, 0.31712548E-06_JPRB, &
  & 0.31721612E-06_JPRB, 0.31731020E-06_JPRB, 0.31740615E-06_JPRB, 0.31750420E-06_JPRB, 0.31759180E-06_JPRB, 0.31766126E-06_JPRB, &
  & 0.31771282E-06_JPRB, 0.31775107E-06_JPRB, 0.31778040E-06_JPRB, 0.31780343E-06_JPRB, 0.31782128E-06_JPRB, 0.31783384E-06_JPRB, &
  & 0.31784020E-06_JPRB, 0.31783972E-06_JPRB, 0.31783179E-06_JPRB, 0.31781653E-06_JPRB, 0.31779467E-06_JPRB, 0.31776739E-06_JPRB, &
  & 0.31773570E-06_JPRB, 0.31770196E-06_JPRB, 0.31766780E-06_JPRB, 0.31763506E-06_JPRB, 0.31760601E-06_JPRB, 0.31758239E-06_JPRB, &
  & 0.31756383E-06_JPRB, 0.31754911E-06_JPRB, 0.31753456E-06_JPRB, 0.31751711E-06_JPRB, 0.31749221E-06_JPRB, 0.31745606E-06_JPRB, &
  & 0.31740208E-06_JPRB, 0.31732733E-06_JPRB, 0.31723462E-06_JPRB, 0.31713350E-06_JPRB, 0.31704047E-06_JPRB, 0.31694577E-06_JPRB, &
  & 0.31685471E-06_JPRB, 0.31675634E-06_JPRB, 0.31665459E-06_JPRB, 0.31655696E-06_JPRB, 0.31647551E-06_JPRB, 0.31640877E-06_JPRB, &
  & 0.31635264E-06_JPRB, 0.31629722E-06_JPRB, 0.31623446E-06_JPRB, 0.31612043E-06_JPRB /)

RGHG3(:,51, 5) = (/ &
  & 0.31477185E-06_JPRB, 0.31512457E-06_JPRB, 0.31540984E-06_JPRB, 0.31568678E-06_JPRB, 0.31603713E-06_JPRB, 0.31631714E-06_JPRB, &
  & 0.31648955E-06_JPRB, 0.31659062E-06_JPRB, 0.31665417E-06_JPRB, 0.31670669E-06_JPRB, 0.31675174E-06_JPRB, 0.31680739E-06_JPRB, &
  & 0.31687188E-06_JPRB, 0.31695367E-06_JPRB, 0.31704235E-06_JPRB, 0.31712352E-06_JPRB, 0.31719495E-06_JPRB, 0.31725554E-06_JPRB, &
  & 0.31731608E-06_JPRB, 0.31737721E-06_JPRB, 0.31744992E-06_JPRB, 0.31752856E-06_JPRB, 0.31760629E-06_JPRB, 0.31767229E-06_JPRB, &
  & 0.31772248E-06_JPRB, 0.31776014E-06_JPRB, 0.31778910E-06_JPRB, 0.31781198E-06_JPRB, 0.31782997E-06_JPRB, 0.31784285E-06_JPRB, &
  & 0.31784981E-06_JPRB, 0.31785001E-06_JPRB, 0.31784285E-06_JPRB, 0.31782835E-06_JPRB, 0.31780726E-06_JPRB, 0.31778060E-06_JPRB, &
  & 0.31774962E-06_JPRB, 0.31771671E-06_JPRB, 0.31768354E-06_JPRB, 0.31765239E-06_JPRB, 0.31762573E-06_JPRB, 0.31760516E-06_JPRB, &
  & 0.31759066E-06_JPRB, 0.31757980E-06_JPRB, 0.31757008E-06_JPRB, 0.31755786E-06_JPRB, 0.31754129E-06_JPRB, 0.31751699E-06_JPRB, &
  & 0.31748354E-06_JPRB, 0.31743878E-06_JPRB, 0.31738659E-06_JPRB, 0.31733538E-06_JPRB, 0.31728271E-06_JPRB, 0.31723522E-06_JPRB, &
  & 0.31718201E-06_JPRB, 0.31712401E-06_JPRB, 0.31705702E-06_JPRB, 0.31698963E-06_JPRB, 0.31692835E-06_JPRB, 0.31687861E-06_JPRB, &
  & 0.31683277E-06_JPRB, 0.31678883E-06_JPRB, 0.31673190E-06_JPRB, 0.31663268E-06_JPRB /)

RGHG3(:,52, 5) = (/ &
  & 0.31543721E-06_JPRB, 0.31582383E-06_JPRB, 0.31603247E-06_JPRB, 0.31630816E-06_JPRB, 0.31656751E-06_JPRB, 0.31677561E-06_JPRB, &
  & 0.31688867E-06_JPRB, 0.31695015E-06_JPRB, 0.31699034E-06_JPRB, 0.31701845E-06_JPRB, 0.31704775E-06_JPRB, 0.31707606E-06_JPRB, &
  & 0.31711494E-06_JPRB, 0.31716112E-06_JPRB, 0.31721254E-06_JPRB, 0.31726231E-06_JPRB, 0.31730571E-06_JPRB, 0.31734669E-06_JPRB, &
  & 0.31738551E-06_JPRB, 0.31743144E-06_JPRB, 0.31748394E-06_JPRB, 0.31754851E-06_JPRB, 0.31761834E-06_JPRB, 0.31768127E-06_JPRB, &
  & 0.31773115E-06_JPRB, 0.31776864E-06_JPRB, 0.31779746E-06_JPRB, 0.31782017E-06_JPRB, 0.31783821E-06_JPRB, 0.31785132E-06_JPRB, &
  & 0.31785885E-06_JPRB, 0.31785973E-06_JPRB, 0.31785331E-06_JPRB, 0.31783955E-06_JPRB, 0.31781909E-06_JPRB, 0.31779302E-06_JPRB, &
  & 0.31776270E-06_JPRB, 0.31773052E-06_JPRB, 0.31769824E-06_JPRB, 0.31766839E-06_JPRB, 0.31764361E-06_JPRB, 0.31762588E-06_JPRB, &
  & 0.31761428E-06_JPRB, 0.31760666E-06_JPRB, 0.31759967E-06_JPRB, 0.31759123E-06_JPRB, 0.31757918E-06_JPRB, 0.31756281E-06_JPRB, &
  & 0.31754033E-06_JPRB, 0.31751335E-06_JPRB, 0.31748505E-06_JPRB, 0.31745702E-06_JPRB, 0.31743400E-06_JPRB, 0.31741001E-06_JPRB, &
  & 0.31738671E-06_JPRB, 0.31735868E-06_JPRB, 0.31732566E-06_JPRB, 0.31728854E-06_JPRB, 0.31725489E-06_JPRB, 0.31722359E-06_JPRB, &
  & 0.31719628E-06_JPRB, 0.31716473E-06_JPRB, 0.31712688E-06_JPRB, 0.31704306E-06_JPRB /)

RGHG3(:,53, 5) = (/ &
  & 0.31603557E-06_JPRB, 0.31632018E-06_JPRB, 0.31654599E-06_JPRB, 0.31672403E-06_JPRB, 0.31692790E-06_JPRB, 0.31705858E-06_JPRB, &
  & 0.31712827E-06_JPRB, 0.31716490E-06_JPRB, 0.31718687E-06_JPRB, 0.31720492E-06_JPRB, 0.31721959E-06_JPRB, 0.31723829E-06_JPRB, &
  & 0.31725924E-06_JPRB, 0.31728777E-06_JPRB, 0.31732012E-06_JPRB, 0.31735192E-06_JPRB, 0.31738205E-06_JPRB, 0.31740950E-06_JPRB, &
  & 0.31743940E-06_JPRB, 0.31747163E-06_JPRB, 0.31751387E-06_JPRB, 0.31756682E-06_JPRB, 0.31762846E-06_JPRB, 0.31768963E-06_JPRB, &
  & 0.31773908E-06_JPRB, 0.31777660E-06_JPRB, 0.31780542E-06_JPRB, 0.31782804E-06_JPRB, 0.31784612E-06_JPRB, 0.31785942E-06_JPRB, &
  & 0.31786743E-06_JPRB, 0.31786891E-06_JPRB, 0.31786314E-06_JPRB, 0.31785007E-06_JPRB, 0.31783031E-06_JPRB, 0.31780473E-06_JPRB, &
  & 0.31777509E-06_JPRB, 0.31774357E-06_JPRB, 0.31771208E-06_JPRB, 0.31768343E-06_JPRB, 0.31766047E-06_JPRB, 0.31764500E-06_JPRB, &
  & 0.31763602E-06_JPRB, 0.31763051E-06_JPRB, 0.31762588E-06_JPRB, 0.31761954E-06_JPRB, 0.31761078E-06_JPRB, 0.31759836E-06_JPRB, &
  & 0.31758302E-06_JPRB, 0.31756565E-06_JPRB, 0.31754868E-06_JPRB, 0.31753501E-06_JPRB, 0.31752253E-06_JPRB, 0.31751244E-06_JPRB, &
  & 0.31750170E-06_JPRB, 0.31748954E-06_JPRB, 0.31747447E-06_JPRB, 0.31745759E-06_JPRB, 0.31744045E-06_JPRB, 0.31742616E-06_JPRB, &
  & 0.31741132E-06_JPRB, 0.31739657E-06_JPRB, 0.31737378E-06_JPRB, 0.31732671E-06_JPRB /)

RGHG3(:,54, 5) = (/ &
  & 0.31647687E-06_JPRB, 0.31674057E-06_JPRB, 0.31686767E-06_JPRB, 0.31702058E-06_JPRB, 0.31714697E-06_JPRB, 0.31723323E-06_JPRB, &
  & 0.31727433E-06_JPRB, 0.31729587E-06_JPRB, 0.31730957E-06_JPRB, 0.31731926E-06_JPRB, 0.31732935E-06_JPRB, 0.31733924E-06_JPRB, &
  & 0.31735340E-06_JPRB, 0.31737116E-06_JPRB, 0.31739273E-06_JPRB, 0.31741507E-06_JPRB, 0.31743627E-06_JPRB, 0.31745770E-06_JPRB, &
  & 0.31747936E-06_JPRB, 0.31750616E-06_JPRB, 0.31753927E-06_JPRB, 0.31758373E-06_JPRB, 0.31764017E-06_JPRB, 0.31769753E-06_JPRB, &
  & 0.31774684E-06_JPRB, 0.31778421E-06_JPRB, 0.31781292E-06_JPRB, 0.31783554E-06_JPRB, 0.31785373E-06_JPRB, 0.31786723E-06_JPRB, &
  & 0.31787556E-06_JPRB, 0.31787755E-06_JPRB, 0.31787232E-06_JPRB, 0.31785987E-06_JPRB, 0.31784086E-06_JPRB, 0.31781599E-06_JPRB, &
  & 0.31778688E-06_JPRB, 0.31775588E-06_JPRB, 0.31772518E-06_JPRB, 0.31769778E-06_JPRB, 0.31767664E-06_JPRB, 0.31766328E-06_JPRB, &
  & 0.31765609E-06_JPRB, 0.31765245E-06_JPRB, 0.31764927E-06_JPRB, 0.31764478E-06_JPRB, 0.31763773E-06_JPRB, 0.31762829E-06_JPRB, &
  & 0.31761647E-06_JPRB, 0.31760445E-06_JPRB, 0.31759413E-06_JPRB, 0.31758560E-06_JPRB, 0.31757966E-06_JPRB, 0.31757435E-06_JPRB, &
  & 0.31756940E-06_JPRB, 0.31756372E-06_JPRB, 0.31755667E-06_JPRB, 0.31754837E-06_JPRB, 0.31754081E-06_JPRB, 0.31753370E-06_JPRB, &
  & 0.31752785E-06_JPRB, 0.31752143E-06_JPRB, 0.31751520E-06_JPRB, 0.31750639E-06_JPRB /)

RGHG3(:,55, 5) = (/ &
  & 0.31680020E-06_JPRB, 0.31698983E-06_JPRB, 0.31711056E-06_JPRB, 0.31720225E-06_JPRB, 0.31729130E-06_JPRB, 0.31734402E-06_JPRB, &
  & 0.31737000E-06_JPRB, 0.31738315E-06_JPRB, 0.31739125E-06_JPRB, 0.31739779E-06_JPRB, 0.31740342E-06_JPRB, 0.31741052E-06_JPRB, &
  & 0.31741899E-06_JPRB, 0.31743124E-06_JPRB, 0.31744631E-06_JPRB, 0.31746237E-06_JPRB, 0.31747868E-06_JPRB, 0.31749482E-06_JPRB, &
  & 0.31751304E-06_JPRB, 0.31753410E-06_JPRB, 0.31756255E-06_JPRB, 0.31760192E-06_JPRB, 0.31765154E-06_JPRB, 0.31770699E-06_JPRB, &
  & 0.31775451E-06_JPRB, 0.31779160E-06_JPRB, 0.31782028E-06_JPRB, 0.31784290E-06_JPRB, 0.31786104E-06_JPRB, 0.31787476E-06_JPRB, &
  & 0.31788329E-06_JPRB, 0.31788568E-06_JPRB, 0.31788102E-06_JPRB, 0.31786919E-06_JPRB, 0.31785095E-06_JPRB, 0.31782670E-06_JPRB, &
  & 0.31779820E-06_JPRB, 0.31776773E-06_JPRB, 0.31773794E-06_JPRB, 0.31771177E-06_JPRB, 0.31769227E-06_JPRB, 0.31768062E-06_JPRB, &
  & 0.31767513E-06_JPRB, 0.31767274E-06_JPRB, 0.31767095E-06_JPRB, 0.31766757E-06_JPRB, 0.31766200E-06_JPRB, 0.31765393E-06_JPRB, &
  & 0.31764458E-06_JPRB, 0.31763548E-06_JPRB, 0.31762795E-06_JPRB, 0.31762289E-06_JPRB, 0.31761900E-06_JPRB, 0.31761618E-06_JPRB, &
  & 0.31761351E-06_JPRB, 0.31761044E-06_JPRB, 0.31760666E-06_JPRB, 0.31760243E-06_JPRB, 0.31759811E-06_JPRB, 0.31759467E-06_JPRB, &
  & 0.31759120E-06_JPRB, 0.31758785E-06_JPRB, 0.31758310E-06_JPRB, 0.31757452E-06_JPRB /)

RGHG3(:,56, 5) = (/ &
  & 0.31707913E-06_JPRB, 0.31720106E-06_JPRB, 0.31726520E-06_JPRB, 0.31733035E-06_JPRB, 0.31738705E-06_JPRB, 0.31742127E-06_JPRB, &
  & 0.31743741E-06_JPRB, 0.31744588E-06_JPRB, 0.31745122E-06_JPRB, 0.31745520E-06_JPRB, 0.31745930E-06_JPRB, 0.31746356E-06_JPRB, &
  & 0.31746967E-06_JPRB, 0.31747794E-06_JPRB, 0.31748874E-06_JPRB, 0.31750085E-06_JPRB, 0.31751324E-06_JPRB, 0.31752649E-06_JPRB, &
  & 0.31754098E-06_JPRB, 0.31755945E-06_JPRB, 0.31758432E-06_JPRB, 0.31761874E-06_JPRB, 0.31766589E-06_JPRB, 0.31771665E-06_JPRB, &
  & 0.31776261E-06_JPRB, 0.31779885E-06_JPRB, 0.31782733E-06_JPRB, 0.31785009E-06_JPRB, 0.31786837E-06_JPRB, 0.31788215E-06_JPRB, &
  & 0.31789074E-06_JPRB, 0.31789344E-06_JPRB, 0.31788917E-06_JPRB, 0.31787806E-06_JPRB, 0.31786050E-06_JPRB, 0.31783691E-06_JPRB, &
  & 0.31780908E-06_JPRB, 0.31777932E-06_JPRB, 0.31775036E-06_JPRB, 0.31772547E-06_JPRB, 0.31770765E-06_JPRB, 0.31769750E-06_JPRB, &
  & 0.31769324E-06_JPRB, 0.31769196E-06_JPRB, 0.31769122E-06_JPRB, 0.31768883E-06_JPRB, 0.31768417E-06_JPRB, 0.31767723E-06_JPRB, &
  & 0.31766913E-06_JPRB, 0.31766160E-06_JPRB, 0.31765592E-06_JPRB, 0.31765200E-06_JPRB, 0.31764944E-06_JPRB, 0.31764745E-06_JPRB, &
  & 0.31764569E-06_JPRB, 0.31764375E-06_JPRB, 0.31764137E-06_JPRB, 0.31763861E-06_JPRB, 0.31763608E-06_JPRB, 0.31763381E-06_JPRB, &
  & 0.31763190E-06_JPRB, 0.31762985E-06_JPRB, 0.31762769E-06_JPRB, 0.31762406E-06_JPRB /)

RGHG3(:,57, 5) = (/ &
  & 0.31724517E-06_JPRB, 0.31732986E-06_JPRB, 0.31737702E-06_JPRB, 0.31741962E-06_JPRB, 0.31745503E-06_JPRB, 0.31747780E-06_JPRB, &
  & 0.31748866E-06_JPRB, 0.31749434E-06_JPRB, 0.31749789E-06_JPRB, 0.31750085E-06_JPRB, 0.31750352E-06_JPRB, 0.31750676E-06_JPRB, &
  & 0.31751088E-06_JPRB, 0.31751682E-06_JPRB, 0.31752469E-06_JPRB, 0.31753376E-06_JPRB, 0.31754362E-06_JPRB, 0.31755408E-06_JPRB, &
  & 0.31756650E-06_JPRB, 0.31758233E-06_JPRB, 0.31760473E-06_JPRB, 0.31763736E-06_JPRB, 0.31767988E-06_JPRB, 0.31772788E-06_JPRB, &
  & 0.31777105E-06_JPRB, 0.31780638E-06_JPRB, 0.31783443E-06_JPRB, 0.31785726E-06_JPRB, 0.31787565E-06_JPRB, 0.31788949E-06_JPRB, &
  & 0.31789813E-06_JPRB, 0.31790083E-06_JPRB, 0.31789699E-06_JPRB, 0.31788647E-06_JPRB, 0.31786962E-06_JPRB, 0.31784671E-06_JPRB, &
  & 0.31781957E-06_JPRB, 0.31779055E-06_JPRB, 0.31776264E-06_JPRB, 0.31773925E-06_JPRB, 0.31772288E-06_JPRB, 0.31771398E-06_JPRB, &
  & 0.31771071E-06_JPRB, 0.31771032E-06_JPRB, 0.31771035E-06_JPRB, 0.31770878E-06_JPRB, 0.31770500E-06_JPRB, 0.31769875E-06_JPRB, &
  & 0.31769153E-06_JPRB, 0.31768488E-06_JPRB, 0.31767982E-06_JPRB, 0.31767672E-06_JPRB, 0.31767451E-06_JPRB, 0.31767291E-06_JPRB, &
  & 0.31767141E-06_JPRB, 0.31766979E-06_JPRB, 0.31766785E-06_JPRB, 0.31766575E-06_JPRB, 0.31766371E-06_JPRB, 0.31766206E-06_JPRB, &
  & 0.31766047E-06_JPRB, 0.31765887E-06_JPRB, 0.31765671E-06_JPRB, 0.31765285E-06_JPRB /)

RGHG3(:,58, 5) = (/ &
  & 0.31738077E-06_JPRB, 0.31742934E-06_JPRB, 0.31745776E-06_JPRB, 0.31748317E-06_JPRB, 0.31750798E-06_JPRB, 0.31752259E-06_JPRB, &
  & 0.31753018E-06_JPRB, 0.31753419E-06_JPRB, 0.31753683E-06_JPRB, 0.31753888E-06_JPRB, 0.31754098E-06_JPRB, 0.31754331E-06_JPRB, &
  & 0.31754644E-06_JPRB, 0.31755081E-06_JPRB, 0.31755673E-06_JPRB, 0.31756375E-06_JPRB, 0.31757145E-06_JPRB, 0.31757997E-06_JPRB, &
  & 0.31759021E-06_JPRB, 0.31760428E-06_JPRB, 0.31762491E-06_JPRB, 0.31765475E-06_JPRB, 0.31769520E-06_JPRB, 0.31773934E-06_JPRB, &
  & 0.31778018E-06_JPRB, 0.31781423E-06_JPRB, 0.31784208E-06_JPRB, 0.31786470E-06_JPRB, 0.31788306E-06_JPRB, 0.31789673E-06_JPRB, &
  & 0.31790537E-06_JPRB, 0.31790813E-06_JPRB, 0.31790447E-06_JPRB, 0.31789446E-06_JPRB, 0.31787826E-06_JPRB, 0.31785623E-06_JPRB, &
  & 0.31782992E-06_JPRB, 0.31780183E-06_JPRB, 0.31777512E-06_JPRB, 0.31775303E-06_JPRB, 0.31773794E-06_JPRB, 0.31773016E-06_JPRB, &
  & 0.31772774E-06_JPRB, 0.31772802E-06_JPRB, 0.31772868E-06_JPRB, 0.31772777E-06_JPRB, 0.31772467E-06_JPRB, 0.31771930E-06_JPRB, &
  & 0.31771265E-06_JPRB, 0.31770634E-06_JPRB, 0.31770156E-06_JPRB, 0.31769838E-06_JPRB, 0.31769628E-06_JPRB, 0.31769468E-06_JPRB, &
  & 0.31769321E-06_JPRB, 0.31769162E-06_JPRB, 0.31768974E-06_JPRB, 0.31768769E-06_JPRB, 0.31768587E-06_JPRB, 0.31768428E-06_JPRB, &
  & 0.31768286E-06_JPRB, 0.31768133E-06_JPRB, 0.31767951E-06_JPRB, 0.31767581E-06_JPRB /)

RGHG3(:,59, 5) = (/ &
  & 0.31746481E-06_JPRB, 0.31749784E-06_JPRB, 0.31751628E-06_JPRB, 0.31753416E-06_JPRB, 0.31754902E-06_JPRB, 0.31755991E-06_JPRB, &
  & 0.31756531E-06_JPRB, 0.31756838E-06_JPRB, 0.31757037E-06_JPRB, 0.31757205E-06_JPRB, 0.31757369E-06_JPRB, 0.31757571E-06_JPRB, &
  & 0.31757827E-06_JPRB, 0.31758177E-06_JPRB, 0.31758648E-06_JPRB, 0.31759200E-06_JPRB, 0.31759811E-06_JPRB, 0.31760479E-06_JPRB, &
  & 0.31761326E-06_JPRB, 0.31762551E-06_JPRB, 0.31764444E-06_JPRB, 0.31767271E-06_JPRB, 0.31771009E-06_JPRB, 0.31775130E-06_JPRB, &
  & 0.31778993E-06_JPRB, 0.31782281E-06_JPRB, 0.31785012E-06_JPRB, 0.31787255E-06_JPRB, 0.31789071E-06_JPRB, 0.31790424E-06_JPRB, &
  & 0.31791265E-06_JPRB, 0.31791538E-06_JPRB, 0.31791188E-06_JPRB, 0.31790225E-06_JPRB, 0.31788665E-06_JPRB, 0.31786544E-06_JPRB, &
  & 0.31784018E-06_JPRB, 0.31781315E-06_JPRB, 0.31778774E-06_JPRB, 0.31776690E-06_JPRB, 0.31775298E-06_JPRB, 0.31774610E-06_JPRB, &
  & 0.31774442E-06_JPRB, 0.31774525E-06_JPRB, 0.31774636E-06_JPRB, 0.31774599E-06_JPRB, 0.31774357E-06_JPRB, 0.31773888E-06_JPRB, &
  & 0.31773288E-06_JPRB, 0.31772683E-06_JPRB, 0.31772188E-06_JPRB, 0.31771862E-06_JPRB, 0.31771629E-06_JPRB, 0.31771447E-06_JPRB, &
  & 0.31771282E-06_JPRB, 0.31771103E-06_JPRB, 0.31770904E-06_JPRB, 0.31770691E-06_JPRB, 0.31770486E-06_JPRB, 0.31770318E-06_JPRB, &
  & 0.31770168E-06_JPRB, 0.31770011E-06_JPRB, 0.31769804E-06_JPRB, 0.31769429E-06_JPRB /)

RGHG3(:,60, 5) = (/ &
  & 0.31753035E-06_JPRB, 0.31755050E-06_JPRB, 0.31756252E-06_JPRB, 0.31757347E-06_JPRB, 0.31758452E-06_JPRB, 0.31759191E-06_JPRB, &
  & 0.31759620E-06_JPRB, 0.31759862E-06_JPRB, 0.31760044E-06_JPRB, 0.31760186E-06_JPRB, 0.31760337E-06_JPRB, 0.31760513E-06_JPRB, &
  & 0.31760743E-06_JPRB, 0.31761056E-06_JPRB, 0.31761459E-06_JPRB, 0.31761928E-06_JPRB, 0.31762411E-06_JPRB, 0.31762926E-06_JPRB, &
  & 0.31763588E-06_JPRB, 0.31764651E-06_JPRB, 0.31766390E-06_JPRB, 0.31769019E-06_JPRB, 0.31772510E-06_JPRB, 0.31776361E-06_JPRB, &
  & 0.31780024E-06_JPRB, 0.31783196E-06_JPRB, 0.31785876E-06_JPRB, 0.31788085E-06_JPRB, 0.31789855E-06_JPRB, 0.31791174E-06_JPRB, &
  & 0.31791990E-06_JPRB, 0.31792248E-06_JPRB, 0.31791910E-06_JPRB, 0.31790987E-06_JPRB, 0.31789480E-06_JPRB, 0.31787445E-06_JPRB, &
  & 0.31785015E-06_JPRB, 0.31782463E-06_JPRB, 0.31780041E-06_JPRB, 0.31778094E-06_JPRB, 0.31776807E-06_JPRB, 0.31776199E-06_JPRB, &
  & 0.31776079E-06_JPRB, 0.31776204E-06_JPRB, 0.31776352E-06_JPRB, 0.31776355E-06_JPRB, 0.31776167E-06_JPRB, 0.31775772E-06_JPRB, &
  & 0.31775235E-06_JPRB, 0.31774661E-06_JPRB, 0.31774155E-06_JPRB, 0.31773789E-06_JPRB, 0.31773519E-06_JPRB, 0.31773305E-06_JPRB, &
  & 0.31773101E-06_JPRB, 0.31772885E-06_JPRB, 0.31772643E-06_JPRB, 0.31772396E-06_JPRB, 0.31772171E-06_JPRB, 0.31771981E-06_JPRB, &
  & 0.31771810E-06_JPRB, 0.31771631E-06_JPRB, 0.31771413E-06_JPRB, 0.31770978E-06_JPRB /)

RGHG3(:,61, 5) = (/ &
  & 0.31757554E-06_JPRB, 0.31759038E-06_JPRB, 0.31759890E-06_JPRB, 0.31760703E-06_JPRB, 0.31761454E-06_JPRB, 0.31762059E-06_JPRB, &
  & 0.31762403E-06_JPRB, 0.31762622E-06_JPRB, 0.31762778E-06_JPRB, 0.31762920E-06_JPRB, 0.31763065E-06_JPRB, 0.31763241E-06_JPRB, &
  & 0.31763477E-06_JPRB, 0.31763787E-06_JPRB, 0.31764179E-06_JPRB, 0.31764600E-06_JPRB, 0.31764992E-06_JPRB, 0.31765353E-06_JPRB, &
  & 0.31765853E-06_JPRB, 0.31766743E-06_JPRB, 0.31768317E-06_JPRB, 0.31770753E-06_JPRB, 0.31774007E-06_JPRB, 0.31777626E-06_JPRB, &
  & 0.31781110E-06_JPRB, 0.31784171E-06_JPRB, 0.31786783E-06_JPRB, 0.31788937E-06_JPRB, 0.31790660E-06_JPRB, 0.31791936E-06_JPRB, &
  & 0.31792709E-06_JPRB, 0.31792956E-06_JPRB, 0.31792621E-06_JPRB, 0.31791731E-06_JPRB, 0.31790287E-06_JPRB, 0.31788352E-06_JPRB, &
  & 0.31786050E-06_JPRB, 0.31783620E-06_JPRB, 0.31781337E-06_JPRB, 0.31779518E-06_JPRB, 0.31778330E-06_JPRB, 0.31777776E-06_JPRB, &
  & 0.31777702E-06_JPRB, 0.31777853E-06_JPRB, 0.31778026E-06_JPRB, 0.31778063E-06_JPRB, 0.31777927E-06_JPRB, 0.31777594E-06_JPRB, &
  & 0.31777131E-06_JPRB, 0.31776597E-06_JPRB, 0.31776094E-06_JPRB, 0.31775681E-06_JPRB, 0.31775363E-06_JPRB, 0.31775096E-06_JPRB, &
  & 0.31774849E-06_JPRB, 0.31774582E-06_JPRB, 0.31774292E-06_JPRB, 0.31773999E-06_JPRB, 0.31773737E-06_JPRB, 0.31773516E-06_JPRB, &
  & 0.31773308E-06_JPRB, 0.31773101E-06_JPRB, 0.31772819E-06_JPRB, 0.31772322E-06_JPRB /)

RGHG3(:,62, 5) = (/ &
  & 0.31761238E-06_JPRB, 0.31762349E-06_JPRB, 0.31762983E-06_JPRB, 0.31763574E-06_JPRB, 0.31764182E-06_JPRB, 0.31764665E-06_JPRB, &
  & 0.31764989E-06_JPRB, 0.31765194E-06_JPRB, 0.31765359E-06_JPRB, 0.31765504E-06_JPRB, 0.31765666E-06_JPRB, 0.31765862E-06_JPRB, &
  & 0.31766118E-06_JPRB, 0.31766459E-06_JPRB, 0.31766859E-06_JPRB, 0.31767249E-06_JPRB, 0.31767553E-06_JPRB, 0.31767775E-06_JPRB, &
  & 0.31768113E-06_JPRB, 0.31768849E-06_JPRB, 0.31770250E-06_JPRB, 0.31772504E-06_JPRB, 0.31775528E-06_JPRB, 0.31778927E-06_JPRB, &
  & 0.31782241E-06_JPRB, 0.31785197E-06_JPRB, 0.31787724E-06_JPRB, 0.31789818E-06_JPRB, 0.31791484E-06_JPRB, 0.31792712E-06_JPRB, &
  & 0.31793439E-06_JPRB, 0.31793661E-06_JPRB, 0.31793331E-06_JPRB, 0.31792473E-06_JPRB, 0.31791095E-06_JPRB, 0.31789250E-06_JPRB, &
  & 0.31787079E-06_JPRB, 0.31784791E-06_JPRB, 0.31782648E-06_JPRB, 0.31780954E-06_JPRB, 0.31779859E-06_JPRB, 0.31779362E-06_JPRB, &
  & 0.31779311E-06_JPRB, 0.31779487E-06_JPRB, 0.31779680E-06_JPRB, 0.31779751E-06_JPRB, 0.31779652E-06_JPRB, 0.31779371E-06_JPRB, &
  & 0.31778961E-06_JPRB, 0.31778484E-06_JPRB, 0.31777995E-06_JPRB, 0.31777563E-06_JPRB, 0.31777193E-06_JPRB, 0.31776869E-06_JPRB, &
  & 0.31776554E-06_JPRB, 0.31776221E-06_JPRB, 0.31775875E-06_JPRB, 0.31775522E-06_JPRB, 0.31775215E-06_JPRB, 0.31774954E-06_JPRB, &
  & 0.31774709E-06_JPRB, 0.31774445E-06_JPRB, 0.31774118E-06_JPRB, 0.31773473E-06_JPRB /)

RGHG3(:,63, 5) = (/ &
  & 0.31764310E-06_JPRB, 0.31765177E-06_JPRB, 0.31765688E-06_JPRB, 0.31766169E-06_JPRB, 0.31766660E-06_JPRB, 0.31767098E-06_JPRB, &
  & 0.31767397E-06_JPRB, 0.31767615E-06_JPRB, 0.31767780E-06_JPRB, 0.31767951E-06_JPRB, 0.31768133E-06_JPRB, 0.31768371E-06_JPRB, &
  & 0.31768684E-06_JPRB, 0.31769073E-06_JPRB, 0.31769508E-06_JPRB, 0.31769878E-06_JPRB, 0.31770088E-06_JPRB, 0.31770182E-06_JPRB, &
  & 0.31770375E-06_JPRB, 0.31770961E-06_JPRB, 0.31772205E-06_JPRB, 0.31774272E-06_JPRB, 0.31777088E-06_JPRB, 0.31780272E-06_JPRB, &
  & 0.31783421E-06_JPRB, 0.31786257E-06_JPRB, 0.31788704E-06_JPRB, 0.31790714E-06_JPRB, 0.31792314E-06_JPRB, 0.31793473E-06_JPRB, &
  & 0.31794161E-06_JPRB, 0.31794346E-06_JPRB, 0.31794031E-06_JPRB, 0.31793209E-06_JPRB, 0.31791905E-06_JPRB, 0.31790165E-06_JPRB, &
  & 0.31788130E-06_JPRB, 0.31785987E-06_JPRB, 0.31783992E-06_JPRB, 0.31782412E-06_JPRB, 0.31781403E-06_JPRB, 0.31780951E-06_JPRB, &
  & 0.31780920E-06_JPRB, 0.31781104E-06_JPRB, 0.31781309E-06_JPRB, 0.31781406E-06_JPRB, 0.31781343E-06_JPRB, 0.31781110E-06_JPRB, &
  & 0.31780749E-06_JPRB, 0.31780320E-06_JPRB, 0.31779862E-06_JPRB, 0.31779422E-06_JPRB, 0.31779007E-06_JPRB, 0.31778623E-06_JPRB, &
  & 0.31778237E-06_JPRB, 0.31777850E-06_JPRB, 0.31777432E-06_JPRB, 0.31777040E-06_JPRB, 0.31776682E-06_JPRB, 0.31776375E-06_JPRB, &
  & 0.31776085E-06_JPRB, 0.31775770E-06_JPRB, 0.31775338E-06_JPRB, 0.31774559E-06_JPRB /)

RGHG3(:,64, 5) = (/ &
  & 0.31766893E-06_JPRB, 0.31767652E-06_JPRB, 0.31768090E-06_JPRB, 0.31768502E-06_JPRB, 0.31768943E-06_JPRB, 0.31769341E-06_JPRB, &
  & 0.31769650E-06_JPRB, 0.31769875E-06_JPRB, 0.31770082E-06_JPRB, 0.31770278E-06_JPRB, 0.31770514E-06_JPRB, 0.31770804E-06_JPRB, &
  & 0.31771185E-06_JPRB, 0.31771640E-06_JPRB, 0.31772103E-06_JPRB, 0.31772444E-06_JPRB, 0.31772572E-06_JPRB, 0.31772549E-06_JPRB, &
  & 0.31772623E-06_JPRB, 0.31773072E-06_JPRB, 0.31774175E-06_JPRB, 0.31776077E-06_JPRB, 0.31778680E-06_JPRB, 0.31781667E-06_JPRB, &
  & 0.31784643E-06_JPRB, 0.31787357E-06_JPRB, 0.31789696E-06_JPRB, 0.31791620E-06_JPRB, 0.31793135E-06_JPRB, 0.31794218E-06_JPRB, &
  & 0.31794852E-06_JPRB, 0.31795017E-06_JPRB, 0.31794710E-06_JPRB, 0.31793931E-06_JPRB, 0.31792717E-06_JPRB, 0.31791086E-06_JPRB, &
  & 0.31789190E-06_JPRB, 0.31787192E-06_JPRB, 0.31785342E-06_JPRB, 0.31783887E-06_JPRB, 0.31782960E-06_JPRB, 0.31782548E-06_JPRB, &
  & 0.31782514E-06_JPRB, 0.31782696E-06_JPRB, 0.31782903E-06_JPRB, 0.31783017E-06_JPRB, 0.31782986E-06_JPRB, 0.31782798E-06_JPRB, &
  & 0.31782480E-06_JPRB, 0.31782091E-06_JPRB, 0.31781667E-06_JPRB, 0.31781235E-06_JPRB, 0.31780800E-06_JPRB, 0.31780357E-06_JPRB, &
  & 0.31779931E-06_JPRB, 0.31779462E-06_JPRB, 0.31779012E-06_JPRB, 0.31778561E-06_JPRB, 0.31778154E-06_JPRB, 0.31777799E-06_JPRB, &
  & 0.31777458E-06_JPRB, 0.31777068E-06_JPRB, 0.31776560E-06_JPRB, 0.31775548E-06_JPRB /)

RGHG3(:,65, 5) = (/ &
  & 0.31769119E-06_JPRB, 0.31769852E-06_JPRB, 0.31770270E-06_JPRB, 0.31770662E-06_JPRB, 0.31771083E-06_JPRB, 0.31771478E-06_JPRB, &
  & 0.31771793E-06_JPRB, 0.31772061E-06_JPRB, 0.31772285E-06_JPRB, 0.31772541E-06_JPRB, 0.31772831E-06_JPRB, 0.31773209E-06_JPRB, &
  & 0.31773664E-06_JPRB, 0.31774164E-06_JPRB, 0.31774647E-06_JPRB, 0.31774940E-06_JPRB, 0.31775002E-06_JPRB, 0.31774886E-06_JPRB, &
  & 0.31774857E-06_JPRB, 0.31775190E-06_JPRB, 0.31776153E-06_JPRB, 0.31777878E-06_JPRB, 0.31780303E-06_JPRB, 0.31783085E-06_JPRB, &
  & 0.31785893E-06_JPRB, 0.31788460E-06_JPRB, 0.31790688E-06_JPRB, 0.31792501E-06_JPRB, 0.31793923E-06_JPRB, 0.31794923E-06_JPRB, &
  & 0.31795497E-06_JPRB, 0.31795639E-06_JPRB, 0.31795355E-06_JPRB, 0.31794627E-06_JPRB, 0.31793493E-06_JPRB, 0.31791996E-06_JPRB, &
  & 0.31790242E-06_JPRB, 0.31788400E-06_JPRB, 0.31786703E-06_JPRB, 0.31785359E-06_JPRB, 0.31784509E-06_JPRB, 0.31784123E-06_JPRB, &
  & 0.31784091E-06_JPRB, 0.31784259E-06_JPRB, 0.31784467E-06_JPRB, 0.31784583E-06_JPRB, 0.31784572E-06_JPRB, 0.31784424E-06_JPRB, &
  & 0.31784151E-06_JPRB, 0.31783799E-06_JPRB, 0.31783404E-06_JPRB, 0.31782986E-06_JPRB, 0.31782537E-06_JPRB, 0.31782076E-06_JPRB, &
  & 0.31781587E-06_JPRB, 0.31781099E-06_JPRB, 0.31780587E-06_JPRB, 0.31780101E-06_JPRB, 0.31779652E-06_JPRB, 0.31779254E-06_JPRB, &
  & 0.31778856E-06_JPRB, 0.31778418E-06_JPRB, 0.31777753E-06_JPRB, 0.31776614E-06_JPRB /)

RGHG3(:,66, 5) = (/ &
  & 0.31771106E-06_JPRB, 0.31771867E-06_JPRB, 0.31772299E-06_JPRB, 0.31772692E-06_JPRB, 0.31773112E-06_JPRB, 0.31773519E-06_JPRB, &
  & 0.31773868E-06_JPRB, 0.31774152E-06_JPRB, 0.31774437E-06_JPRB, 0.31774726E-06_JPRB, 0.31775110E-06_JPRB, 0.31775562E-06_JPRB, &
  & 0.31776082E-06_JPRB, 0.31776608E-06_JPRB, 0.31777074E-06_JPRB, 0.31777347E-06_JPRB, 0.31777347E-06_JPRB, 0.31777168E-06_JPRB, &
  & 0.31777063E-06_JPRB, 0.31777299E-06_JPRB, 0.31778131E-06_JPRB, 0.31779709E-06_JPRB, 0.31781920E-06_JPRB, 0.31784529E-06_JPRB, &
  & 0.31787147E-06_JPRB, 0.31789557E-06_JPRB, 0.31791646E-06_JPRB, 0.31793348E-06_JPRB, 0.31794656E-06_JPRB, 0.31795560E-06_JPRB, &
  & 0.31796088E-06_JPRB, 0.31796205E-06_JPRB, 0.31795938E-06_JPRB, 0.31795267E-06_JPRB, 0.31794235E-06_JPRB, 0.31792862E-06_JPRB, &
  & 0.31791274E-06_JPRB, 0.31789585E-06_JPRB, 0.31788039E-06_JPRB, 0.31786806E-06_JPRB, 0.31786027E-06_JPRB, 0.31785666E-06_JPRB, &
  & 0.31785640E-06_JPRB, 0.31785785E-06_JPRB, 0.31785981E-06_JPRB, 0.31786104E-06_JPRB, 0.31786118E-06_JPRB, 0.31785993E-06_JPRB, &
  & 0.31785754E-06_JPRB, 0.31785444E-06_JPRB, 0.31785078E-06_JPRB, 0.31784671E-06_JPRB, 0.31784234E-06_JPRB, 0.31783748E-06_JPRB, &
  & 0.31783244E-06_JPRB, 0.31782707E-06_JPRB, 0.31782179E-06_JPRB, 0.31781650E-06_JPRB, 0.31781167E-06_JPRB, 0.31780738E-06_JPRB, &
  & 0.31780294E-06_JPRB, 0.31779794E-06_JPRB, 0.31779066E-06_JPRB, 0.31777736E-06_JPRB /)

RGHG3(:,67, 5) = (/ &
  & 0.31772919E-06_JPRB, 0.31773766E-06_JPRB, 0.31774223E-06_JPRB, 0.31774653E-06_JPRB, 0.31775090E-06_JPRB, 0.31775500E-06_JPRB, &
  & 0.31775875E-06_JPRB, 0.31776210E-06_JPRB, 0.31776540E-06_JPRB, 0.31776921E-06_JPRB, 0.31777364E-06_JPRB, 0.31777890E-06_JPRB, &
  & 0.31778404E-06_JPRB, 0.31778865E-06_JPRB, 0.31779348E-06_JPRB, 0.31779629E-06_JPRB, 0.31779609E-06_JPRB, 0.31779390E-06_JPRB, &
  & 0.31779237E-06_JPRB, 0.31779393E-06_JPRB, 0.31780104E-06_JPRB, 0.31781528E-06_JPRB, 0.31783577E-06_JPRB, 0.31785967E-06_JPRB, &
  & 0.31788403E-06_JPRB, 0.31790631E-06_JPRB, 0.31792570E-06_JPRB, 0.31794139E-06_JPRB, 0.31795332E-06_JPRB, 0.31796142E-06_JPRB, &
  & 0.31796606E-06_JPRB, 0.31796714E-06_JPRB, 0.31796475E-06_JPRB, 0.31795872E-06_JPRB, 0.31794929E-06_JPRB, 0.31793695E-06_JPRB, &
  & 0.31792251E-06_JPRB, 0.31790725E-06_JPRB, 0.31789318E-06_JPRB, 0.31788210E-06_JPRB, 0.31787511E-06_JPRB, 0.31787175E-06_JPRB, &
  & 0.31787144E-06_JPRB, 0.31787272E-06_JPRB, 0.31787451E-06_JPRB, 0.31787573E-06_JPRB, 0.31787599E-06_JPRB, 0.31787508E-06_JPRB, &
  & 0.31787303E-06_JPRB, 0.31787025E-06_JPRB, 0.31786692E-06_JPRB, 0.31786303E-06_JPRB, 0.31785865E-06_JPRB, 0.31785385E-06_JPRB, &
  & 0.31784865E-06_JPRB, 0.31784319E-06_JPRB, 0.31783756E-06_JPRB, 0.31783213E-06_JPRB, 0.31782699E-06_JPRB, 0.31782250E-06_JPRB, &
  & 0.31781775E-06_JPRB, 0.31781255E-06_JPRB, 0.31780411E-06_JPRB, 0.31778967E-06_JPRB /)

RGHG3(:,68, 5) = (/ &
  & 0.31774584E-06_JPRB, 0.31775539E-06_JPRB, 0.31776088E-06_JPRB, 0.31776557E-06_JPRB, 0.31777023E-06_JPRB, 0.31777495E-06_JPRB, &
  & 0.31777884E-06_JPRB, 0.31778268E-06_JPRB, 0.31778643E-06_JPRB, 0.31779078E-06_JPRB, 0.31779595E-06_JPRB, 0.31780147E-06_JPRB, &
  & 0.31780658E-06_JPRB, 0.31781167E-06_JPRB, 0.31781633E-06_JPRB, 0.31781835E-06_JPRB, 0.31781778E-06_JPRB, 0.31781551E-06_JPRB, &
  & 0.31781366E-06_JPRB, 0.31781462E-06_JPRB, 0.31782068E-06_JPRB, 0.31783347E-06_JPRB, 0.31785197E-06_JPRB, 0.31787394E-06_JPRB, &
  & 0.31789619E-06_JPRB, 0.31791666E-06_JPRB, 0.31793434E-06_JPRB, 0.31794866E-06_JPRB, 0.31795946E-06_JPRB, 0.31796674E-06_JPRB, &
  & 0.31797080E-06_JPRB, 0.31797174E-06_JPRB, 0.31796955E-06_JPRB, 0.31796415E-06_JPRB, 0.31795577E-06_JPRB, 0.31794477E-06_JPRB, &
  & 0.31793192E-06_JPRB, 0.31791819E-06_JPRB, 0.31790557E-06_JPRB, 0.31789551E-06_JPRB, 0.31788923E-06_JPRB, 0.31788619E-06_JPRB, &
  & 0.31788585E-06_JPRB, 0.31788696E-06_JPRB, 0.31788863E-06_JPRB, 0.31788980E-06_JPRB, 0.31789020E-06_JPRB, 0.31788946E-06_JPRB, &
  & 0.31788781E-06_JPRB, 0.31788545E-06_JPRB, 0.31788235E-06_JPRB, 0.31787866E-06_JPRB, 0.31787440E-06_JPRB, 0.31786968E-06_JPRB, &
  & 0.31786442E-06_JPRB, 0.31785891E-06_JPRB, 0.31785325E-06_JPRB, 0.31784774E-06_JPRB, 0.31784253E-06_JPRB, 0.31783784E-06_JPRB, &
  & 0.31783313E-06_JPRB, 0.31782764E-06_JPRB, 0.31781894E-06_JPRB, 0.31780309E-06_JPRB /)

RGHG3(:,69, 5) = (/ &
  & 0.31776125E-06_JPRB, 0.31777307E-06_JPRB, 0.31777930E-06_JPRB, 0.31778475E-06_JPRB, 0.31779001E-06_JPRB, 0.31779467E-06_JPRB, &
  & 0.31779931E-06_JPRB, 0.31780306E-06_JPRB, 0.31780763E-06_JPRB, 0.31781224E-06_JPRB, 0.31781775E-06_JPRB, 0.31782281E-06_JPRB, &
  & 0.31782622E-06_JPRB, 0.31782938E-06_JPRB, 0.31783486E-06_JPRB, 0.31783890E-06_JPRB, 0.31783884E-06_JPRB, 0.31783642E-06_JPRB, &
  & 0.31783458E-06_JPRB, 0.31783512E-06_JPRB, 0.31784023E-06_JPRB, 0.31785149E-06_JPRB, 0.31786797E-06_JPRB, 0.31788778E-06_JPRB, &
  & 0.31790807E-06_JPRB, 0.31792655E-06_JPRB, 0.31794255E-06_JPRB, 0.31795543E-06_JPRB, 0.31796503E-06_JPRB, 0.31797143E-06_JPRB, &
  & 0.31797495E-06_JPRB, 0.31797578E-06_JPRB, 0.31797387E-06_JPRB, 0.31796912E-06_JPRB, 0.31796176E-06_JPRB, 0.31795207E-06_JPRB, &
  & 0.31794067E-06_JPRB, 0.31792837E-06_JPRB, 0.31791717E-06_JPRB, 0.31790833E-06_JPRB, 0.31790270E-06_JPRB, 0.31789997E-06_JPRB, &
  & 0.31789972E-06_JPRB, 0.31790060E-06_JPRB, 0.31790211E-06_JPRB, 0.31790333E-06_JPRB, 0.31790381E-06_JPRB, 0.31790327E-06_JPRB, &
  & 0.31790194E-06_JPRB, 0.31789992E-06_JPRB, 0.31789713E-06_JPRB, 0.31789372E-06_JPRB, 0.31788966E-06_JPRB, 0.31788505E-06_JPRB, &
  & 0.31787999E-06_JPRB, 0.31787454E-06_JPRB, 0.31786885E-06_JPRB, 0.31786342E-06_JPRB, 0.31785825E-06_JPRB, 0.31785351E-06_JPRB, &
  & 0.31784882E-06_JPRB, 0.31784344E-06_JPRB, 0.31783438E-06_JPRB, 0.31781741E-06_JPRB /)

RGHG3(:,70, 5) = (/ &
  & 0.31777626E-06_JPRB, 0.31779041E-06_JPRB, 0.31779823E-06_JPRB, 0.31780439E-06_JPRB, 0.31780996E-06_JPRB, 0.31781514E-06_JPRB, &
  & 0.31781948E-06_JPRB, 0.31782406E-06_JPRB, 0.31782849E-06_JPRB, 0.31783364E-06_JPRB, 0.31783901E-06_JPRB, 0.31784396E-06_JPRB, &
  & 0.31784850E-06_JPRB, 0.31785322E-06_JPRB, 0.31785763E-06_JPRB, 0.31785925E-06_JPRB, 0.31785908E-06_JPRB, 0.31785683E-06_JPRB, &
  & 0.31785493E-06_JPRB, 0.31785524E-06_JPRB, 0.31785947E-06_JPRB, 0.31786911E-06_JPRB, 0.31788363E-06_JPRB, 0.31790134E-06_JPRB, &
  & 0.31791944E-06_JPRB, 0.31793584E-06_JPRB, 0.31795017E-06_JPRB, 0.31796156E-06_JPRB, 0.31797006E-06_JPRB, 0.31797575E-06_JPRB, &
  & 0.31797873E-06_JPRB, 0.31797941E-06_JPRB, 0.31797779E-06_JPRB, 0.31797367E-06_JPRB, 0.31796733E-06_JPRB, 0.31795886E-06_JPRB, &
  & 0.31794883E-06_JPRB, 0.31793806E-06_JPRB, 0.31792811E-06_JPRB, 0.31792041E-06_JPRB, 0.31791552E-06_JPRB, 0.31791308E-06_JPRB, &
  & 0.31791279E-06_JPRB, 0.31791359E-06_JPRB, 0.31791495E-06_JPRB, 0.31791623E-06_JPRB, 0.31791680E-06_JPRB, 0.31791646E-06_JPRB, &
  & 0.31791538E-06_JPRB, 0.31791370E-06_JPRB, 0.31791123E-06_JPRB, 0.31790813E-06_JPRB, 0.31790427E-06_JPRB, 0.31789992E-06_JPRB, &
  & 0.31789506E-06_JPRB, 0.31788983E-06_JPRB, 0.31788431E-06_JPRB, 0.31787914E-06_JPRB, 0.31787411E-06_JPRB, 0.31786954E-06_JPRB, &
  & 0.31786496E-06_JPRB, 0.31785996E-06_JPRB, 0.31785103E-06_JPRB, 0.31783290E-06_JPRB /)

RGHG3(:,71, 5) = (/ &
  & 0.31779120E-06_JPRB, 0.31780922E-06_JPRB, 0.31781804E-06_JPRB, 0.31782497E-06_JPRB, 0.31783082E-06_JPRB, 0.31783574E-06_JPRB, &
  & 0.31784054E-06_JPRB, 0.31784489E-06_JPRB, 0.31784970E-06_JPRB, 0.31785447E-06_JPRB, 0.31785973E-06_JPRB, 0.31786371E-06_JPRB, &
  & 0.31786485E-06_JPRB, 0.31786760E-06_JPRB, 0.31787420E-06_JPRB, 0.31787852E-06_JPRB, 0.31787863E-06_JPRB, 0.31787664E-06_JPRB, &
  & 0.31787479E-06_JPRB, 0.31787482E-06_JPRB, 0.31787823E-06_JPRB, 0.31788636E-06_JPRB, 0.31789884E-06_JPRB, 0.31791427E-06_JPRB, &
  & 0.31793019E-06_JPRB, 0.31794463E-06_JPRB, 0.31795722E-06_JPRB, 0.31796725E-06_JPRB, 0.31797464E-06_JPRB, 0.31797947E-06_JPRB, &
  & 0.31798197E-06_JPRB, 0.31798265E-06_JPRB, 0.31798135E-06_JPRB, 0.31797785E-06_JPRB, 0.31797239E-06_JPRB, 0.31796520E-06_JPRB, &
  & 0.31795648E-06_JPRB, 0.31794710E-06_JPRB, 0.31793854E-06_JPRB, 0.31793178E-06_JPRB, 0.31792757E-06_JPRB, 0.31792544E-06_JPRB, &
  & 0.31792527E-06_JPRB, 0.31792590E-06_JPRB, 0.31792712E-06_JPRB, 0.31792848E-06_JPRB, 0.31792914E-06_JPRB, 0.31792888E-06_JPRB, &
  & 0.31792806E-06_JPRB, 0.31792655E-06_JPRB, 0.31792450E-06_JPRB, 0.31792180E-06_JPRB, 0.31791825E-06_JPRB, 0.31791424E-06_JPRB, &
  & 0.31790975E-06_JPRB, 0.31790483E-06_JPRB, 0.31789972E-06_JPRB, 0.31789475E-06_JPRB, 0.31789011E-06_JPRB, 0.31788579E-06_JPRB, &
  & 0.31788156E-06_JPRB, 0.31787710E-06_JPRB, 0.31786885E-06_JPRB, 0.31785143E-06_JPRB /)

RGHG3(:,72, 5) = (/ &
  & 0.31780871E-06_JPRB, 0.31782864E-06_JPRB, 0.31783949E-06_JPRB, 0.31784646E-06_JPRB, 0.31785243E-06_JPRB, 0.31785709E-06_JPRB, &
  & 0.31786180E-06_JPRB, 0.31786624E-06_JPRB, 0.31787081E-06_JPRB, 0.31787553E-06_JPRB, 0.31788014E-06_JPRB, 0.31788397E-06_JPRB, &
  & 0.31788625E-06_JPRB, 0.31788912E-06_JPRB, 0.31789398E-06_JPRB, 0.31789676E-06_JPRB, 0.31789739E-06_JPRB, 0.31789557E-06_JPRB, &
  & 0.31789386E-06_JPRB, 0.31789375E-06_JPRB, 0.31789628E-06_JPRB, 0.31790293E-06_JPRB, 0.31791336E-06_JPRB, 0.31792661E-06_JPRB, &
  & 0.31794048E-06_JPRB, 0.31795301E-06_JPRB, 0.31796387E-06_JPRB, 0.31797239E-06_JPRB, 0.31797882E-06_JPRB, 0.31798294E-06_JPRB, &
  & 0.31798493E-06_JPRB, 0.31798558E-06_JPRB, 0.31798470E-06_JPRB, 0.31798152E-06_JPRB, 0.31797700E-06_JPRB, 0.31797103E-06_JPRB, &
  & 0.31796370E-06_JPRB, 0.31795548E-06_JPRB, 0.31794826E-06_JPRB, 0.31794252E-06_JPRB, 0.31793886E-06_JPRB, 0.31793698E-06_JPRB, &
  & 0.31793695E-06_JPRB, 0.31793741E-06_JPRB, 0.31793843E-06_JPRB, 0.31793985E-06_JPRB, 0.31794048E-06_JPRB, 0.31794042E-06_JPRB, &
  & 0.31793971E-06_JPRB, 0.31793846E-06_JPRB, 0.31793681E-06_JPRB, 0.31793459E-06_JPRB, 0.31793138E-06_JPRB, 0.31792777E-06_JPRB, &
  & 0.31792379E-06_JPRB, 0.31791944E-06_JPRB, 0.31791473E-06_JPRB, 0.31791041E-06_JPRB, 0.31790603E-06_JPRB, 0.31790222E-06_JPRB, &
  & 0.31789838E-06_JPRB, 0.31789452E-06_JPRB, 0.31788719E-06_JPRB, 0.31787039E-06_JPRB /)

RGHG3(:,73, 5) = (/ &
  & 0.31782827E-06_JPRB, 0.31785123E-06_JPRB, 0.31786178E-06_JPRB, 0.31786897E-06_JPRB, 0.31787454E-06_JPRB, 0.31787897E-06_JPRB, &
  & 0.31788340E-06_JPRB, 0.31788753E-06_JPRB, 0.31789210E-06_JPRB, 0.31789605E-06_JPRB, 0.31790020E-06_JPRB, 0.31790233E-06_JPRB, &
  & 0.31790023E-06_JPRB, 0.31790239E-06_JPRB, 0.31791009E-06_JPRB, 0.31791458E-06_JPRB, 0.31791504E-06_JPRB, 0.31791350E-06_JPRB, &
  & 0.31791186E-06_JPRB, 0.31791154E-06_JPRB, 0.31791350E-06_JPRB, 0.31791865E-06_JPRB, 0.31792717E-06_JPRB, 0.31793832E-06_JPRB, &
  & 0.31795020E-06_JPRB, 0.31796071E-06_JPRB, 0.31797006E-06_JPRB, 0.31797711E-06_JPRB, 0.31798248E-06_JPRB, 0.31798575E-06_JPRB, &
  & 0.31798746E-06_JPRB, 0.31798805E-06_JPRB, 0.31798763E-06_JPRB, 0.31798493E-06_JPRB, 0.31798129E-06_JPRB, 0.31797651E-06_JPRB, &
  & 0.31797038E-06_JPRB, 0.31796336E-06_JPRB, 0.31795730E-06_JPRB, 0.31795241E-06_JPRB, 0.31794934E-06_JPRB, 0.31794761E-06_JPRB, &
  & 0.31794775E-06_JPRB, 0.31794801E-06_JPRB, 0.31794895E-06_JPRB, 0.31795045E-06_JPRB, 0.31795108E-06_JPRB, 0.31795088E-06_JPRB, &
  & 0.31795045E-06_JPRB, 0.31794931E-06_JPRB, 0.31794801E-06_JPRB, 0.31794639E-06_JPRB, 0.31794355E-06_JPRB, 0.31794050E-06_JPRB, &
  & 0.31793715E-06_JPRB, 0.31793329E-06_JPRB, 0.31792939E-06_JPRB, 0.31792544E-06_JPRB, 0.31792169E-06_JPRB, 0.31791825E-06_JPRB, &
  & 0.31791498E-06_JPRB, 0.31791157E-06_JPRB, 0.31790495E-06_JPRB, 0.31788937E-06_JPRB /)

RGHG3(:,74, 5) = (/ &
  & 0.31785083E-06_JPRB, 0.31787337E-06_JPRB, 0.31788522E-06_JPRB, 0.31789139E-06_JPRB, 0.31789682E-06_JPRB, 0.31790051E-06_JPRB, &
  & 0.31790469E-06_JPRB, 0.31790853E-06_JPRB, 0.31791240E-06_JPRB, 0.31791646E-06_JPRB, 0.31791959E-06_JPRB, 0.31792234E-06_JPRB, &
  & 0.31792260E-06_JPRB, 0.31792510E-06_JPRB, 0.31792831E-06_JPRB, 0.31793115E-06_JPRB, 0.31793175E-06_JPRB, 0.31793036E-06_JPRB, &
  & 0.31792865E-06_JPRB, 0.31792831E-06_JPRB, 0.31792968E-06_JPRB, 0.31793351E-06_JPRB, 0.31794019E-06_JPRB, 0.31794940E-06_JPRB, &
  & 0.31795938E-06_JPRB, 0.31796804E-06_JPRB, 0.31797580E-06_JPRB, 0.31798137E-06_JPRB, 0.31798587E-06_JPRB, 0.31798851E-06_JPRB, &
  & 0.31798990E-06_JPRB, 0.31799044E-06_JPRB, 0.31799036E-06_JPRB, 0.31798794E-06_JPRB, 0.31798527E-06_JPRB, 0.31798149E-06_JPRB, &
  & 0.31797646E-06_JPRB, 0.31797049E-06_JPRB, 0.31796560E-06_JPRB, 0.31796145E-06_JPRB, 0.31795889E-06_JPRB, 0.31795739E-06_JPRB, &
  & 0.31795761E-06_JPRB, 0.31795764E-06_JPRB, 0.31795855E-06_JPRB, 0.31796017E-06_JPRB, 0.31796077E-06_JPRB, 0.31796043E-06_JPRB, &
  & 0.31796020E-06_JPRB, 0.31795909E-06_JPRB, 0.31795821E-06_JPRB, 0.31795713E-06_JPRB, 0.31795460E-06_JPRB, 0.31795219E-06_JPRB, &
  & 0.31794949E-06_JPRB, 0.31794642E-06_JPRB, 0.31794306E-06_JPRB, 0.31793991E-06_JPRB, 0.31793635E-06_JPRB, 0.31793351E-06_JPRB, &
  & 0.31793076E-06_JPRB, 0.31792791E-06_JPRB, 0.31792214E-06_JPRB, 0.31790745E-06_JPRB /)

RGHG3(:,75, 5) = (/ &
  & 0.31787326E-06_JPRB, 0.31789676E-06_JPRB, 0.31790779E-06_JPRB, 0.31791350E-06_JPRB, 0.31791811E-06_JPRB, 0.31792126E-06_JPRB, &
  & 0.31792496E-06_JPRB, 0.31792823E-06_JPRB, 0.31793201E-06_JPRB, 0.31793482E-06_JPRB, 0.31793746E-06_JPRB, 0.31793726E-06_JPRB, &
  & 0.31793053E-06_JPRB, 0.31792942E-06_JPRB, 0.31794167E-06_JPRB, 0.31794613E-06_JPRB, 0.31794721E-06_JPRB, 0.31794596E-06_JPRB, &
  & 0.31794431E-06_JPRB, 0.31794389E-06_JPRB, 0.31794468E-06_JPRB, 0.31794730E-06_JPRB, 0.31795230E-06_JPRB, 0.31795977E-06_JPRB, &
  & 0.31796807E-06_JPRB, 0.31797489E-06_JPRB, 0.31798123E-06_JPRB, 0.31798527E-06_JPRB, 0.31798871E-06_JPRB, 0.31799061E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799217E-06_JPRB, 0.31799260E-06_JPRB, 0.31799055E-06_JPRB, 0.31798876E-06_JPRB, 0.31798618E-06_JPRB, &
  & 0.31798206E-06_JPRB, 0.31797708E-06_JPRB, 0.31797336E-06_JPRB, 0.31796989E-06_JPRB, 0.31796770E-06_JPRB, 0.31796623E-06_JPRB, &
  & 0.31796657E-06_JPRB, 0.31796642E-06_JPRB, 0.31796728E-06_JPRB, 0.31796912E-06_JPRB, 0.31796964E-06_JPRB, 0.31796901E-06_JPRB, &
  & 0.31796893E-06_JPRB, 0.31796787E-06_JPRB, 0.31796739E-06_JPRB, 0.31796696E-06_JPRB, 0.31796463E-06_JPRB, 0.31796284E-06_JPRB, &
  & 0.31796085E-06_JPRB, 0.31795850E-06_JPRB, 0.31795594E-06_JPRB, 0.31795318E-06_JPRB, 0.31795028E-06_JPRB, 0.31794772E-06_JPRB, &
  & 0.31794562E-06_JPRB, 0.31794340E-06_JPRB, 0.31793809E-06_JPRB, 0.31792470E-06_JPRB /)

RGHG3(:,76, 5) = (/ &
  & 0.31789733E-06_JPRB, 0.31791896E-06_JPRB, 0.31793004E-06_JPRB, 0.31793431E-06_JPRB, 0.31793834E-06_JPRB, 0.31794048E-06_JPRB, &
  & 0.31794383E-06_JPRB, 0.31794653E-06_JPRB, 0.31794946E-06_JPRB, 0.31795236E-06_JPRB, 0.31795432E-06_JPRB, 0.31795568E-06_JPRB, &
  & 0.31795233E-06_JPRB, 0.31795526E-06_JPRB, 0.31795747E-06_JPRB, 0.31796043E-06_JPRB, 0.31796162E-06_JPRB, 0.31796043E-06_JPRB, &
  & 0.31795861E-06_JPRB, 0.31795827E-06_JPRB, 0.31795861E-06_JPRB, 0.31796006E-06_JPRB, 0.31796358E-06_JPRB, 0.31796955E-06_JPRB, &
  & 0.31797634E-06_JPRB, 0.31798129E-06_JPRB, 0.31798626E-06_JPRB, 0.31798874E-06_JPRB, 0.31799132E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799362E-06_JPRB, 0.31799422E-06_JPRB, 0.31799502E-06_JPRB, 0.31799294E-06_JPRB, 0.31799198E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31798726E-06_JPRB, 0.31798317E-06_JPRB, 0.31798038E-06_JPRB, 0.31797751E-06_JPRB, 0.31797572E-06_JPRB, 0.31797427E-06_JPRB, &
  & 0.31797481E-06_JPRB, 0.31797438E-06_JPRB, 0.31797509E-06_JPRB, 0.31797722E-06_JPRB, 0.31797771E-06_JPRB, 0.31797674E-06_JPRB, &
  & 0.31797677E-06_JPRB, 0.31797572E-06_JPRB, 0.31797569E-06_JPRB, 0.31797595E-06_JPRB, 0.31797356E-06_JPRB, 0.31797245E-06_JPRB, &
  & 0.31797117E-06_JPRB, 0.31796972E-06_JPRB, 0.31796770E-06_JPRB, 0.31796566E-06_JPRB, 0.31796290E-06_JPRB, 0.31796097E-06_JPRB, &
  & 0.31795946E-06_JPRB, 0.31795796E-06_JPRB, 0.31795312E-06_JPRB, 0.31794087E-06_JPRB /)

RGHG3(:,77, 5) = (/ &
  & 0.31792126E-06_JPRB, 0.31794056E-06_JPRB, 0.31795085E-06_JPRB, 0.31795375E-06_JPRB, 0.31795690E-06_JPRB, 0.31795793E-06_JPRB, &
  & 0.31796074E-06_JPRB, 0.31796262E-06_JPRB, 0.31796520E-06_JPRB, 0.31796699E-06_JPRB, 0.31796819E-06_JPRB, 0.31796696E-06_JPRB, &
  & 0.31795619E-06_JPRB, 0.31795435E-06_JPRB, 0.31796802E-06_JPRB, 0.31797256E-06_JPRB, 0.31797450E-06_JPRB, 0.31797339E-06_JPRB, &
  & 0.31797137E-06_JPRB, 0.31797123E-06_JPRB, 0.31797117E-06_JPRB, 0.31797160E-06_JPRB, 0.31797390E-06_JPRB, 0.31797850E-06_JPRB, &
  & 0.31798390E-06_JPRB, 0.31798712E-06_JPRB, 0.31799090E-06_JPRB, 0.31799189E-06_JPRB, 0.31799343E-06_JPRB, 0.31799402E-06_JPRB, &
  & 0.31799473E-06_JPRB, 0.31799524E-06_JPRB, 0.31799672E-06_JPRB, 0.31799505E-06_JPRB, 0.31799487E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799198E-06_JPRB, 0.31798854E-06_JPRB, 0.31798680E-06_JPRB, 0.31798439E-06_JPRB, 0.31798288E-06_JPRB, 0.31798140E-06_JPRB, &
  & 0.31798226E-06_JPRB, 0.31798157E-06_JPRB, 0.31798206E-06_JPRB, 0.31798461E-06_JPRB, 0.31798498E-06_JPRB, 0.31798359E-06_JPRB, &
  & 0.31798373E-06_JPRB, 0.31798263E-06_JPRB, 0.31798302E-06_JPRB, 0.31798399E-06_JPRB, 0.31798143E-06_JPRB, 0.31798106E-06_JPRB, &
  & 0.31798047E-06_JPRB, 0.31797975E-06_JPRB, 0.31797845E-06_JPRB, 0.31797680E-06_JPRB, 0.31797450E-06_JPRB, 0.31797293E-06_JPRB, &
  & 0.31797214E-06_JPRB, 0.31797154E-06_JPRB, 0.31796699E-06_JPRB, 0.31795631E-06_JPRB /)

RGHG3(:,78, 5) = (/ &
  & 0.31794542E-06_JPRB, 0.31796006E-06_JPRB, 0.31796912E-06_JPRB, 0.31797038E-06_JPRB, 0.31797282E-06_JPRB, 0.31797248E-06_JPRB, &
  & 0.31797484E-06_JPRB, 0.31797583E-06_JPRB, 0.31797779E-06_JPRB, 0.31797936E-06_JPRB, 0.31798015E-06_JPRB, 0.31797953E-06_JPRB, &
  & 0.31797092E-06_JPRB, 0.31797094E-06_JPRB, 0.31797899E-06_JPRB, 0.31798277E-06_JPRB, 0.31798513E-06_JPRB, 0.31798413E-06_JPRB, &
  & 0.31798189E-06_JPRB, 0.31798206E-06_JPRB, 0.31798174E-06_JPRB, 0.31798135E-06_JPRB, 0.31798251E-06_JPRB, 0.31798604E-06_JPRB, &
  & 0.31799033E-06_JPRB, 0.31799217E-06_JPRB, 0.31799485E-06_JPRB, 0.31799456E-06_JPRB, 0.31799541E-06_JPRB, 0.31799561E-06_JPRB, &
  & 0.31799644E-06_JPRB, 0.31799692E-06_JPRB, 0.31799865E-06_JPRB, 0.31799681E-06_JPRB, 0.31799732E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799311E-06_JPRB, 0.31799215E-06_JPRB, 0.31799024E-06_JPRB, 0.31798896E-06_JPRB, 0.31798737E-06_JPRB, &
  & 0.31798851E-06_JPRB, 0.31798754E-06_JPRB, 0.31798785E-06_JPRB, 0.31799090E-06_JPRB, 0.31799115E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31798947E-06_JPRB, 0.31798820E-06_JPRB, 0.31798896E-06_JPRB, 0.31799067E-06_JPRB, 0.31798788E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31798814E-06_JPRB, 0.31798828E-06_JPRB, 0.31798743E-06_JPRB, 0.31798635E-06_JPRB, 0.31798413E-06_JPRB, 0.31798297E-06_JPRB, &
  & 0.31798297E-06_JPRB, 0.31798314E-06_JPRB, 0.31797899E-06_JPRB, 0.31797086E-06_JPRB /)

RGHG3(:,79, 5) = (/ &
  & 0.31796094E-06_JPRB, 0.31797072E-06_JPRB, 0.31797907E-06_JPRB, 0.31797913E-06_JPRB, 0.31798129E-06_JPRB, 0.31797995E-06_JPRB, &
  & 0.31798226E-06_JPRB, 0.31798260E-06_JPRB, 0.31798447E-06_JPRB, 0.31798587E-06_JPRB, 0.31798663E-06_JPRB, 0.31798652E-06_JPRB, &
  & 0.31797825E-06_JPRB, 0.31797973E-06_JPRB, 0.31798450E-06_JPRB, 0.31798820E-06_JPRB, 0.31799112E-06_JPRB, 0.31799007E-06_JPRB, &
  & 0.31798751E-06_JPRB, 0.31798788E-06_JPRB, 0.31798740E-06_JPRB, 0.31798641E-06_JPRB, 0.31798697E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799499E-06_JPRB, 0.31799712E-06_JPRB, 0.31799587E-06_JPRB, 0.31799638E-06_JPRB, 0.31799635E-06_JPRB, &
  & 0.31799738E-06_JPRB, 0.31799783E-06_JPRB, 0.31799988E-06_JPRB, 0.31799772E-06_JPRB, 0.31799874E-06_JPRB, 0.31799976E-06_JPRB, &
  & 0.31799846E-06_JPRB, 0.31799578E-06_JPRB, 0.31799516E-06_JPRB, 0.31799340E-06_JPRB, 0.31799215E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799047E-06_JPRB, 0.31799075E-06_JPRB, 0.31799431E-06_JPRB, 0.31799453E-06_JPRB, 0.31799206E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799087E-06_JPRB, 0.31799206E-06_JPRB, 0.31799439E-06_JPRB, 0.31799112E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799280E-06_JPRB, 0.31799220E-06_JPRB, 0.31799138E-06_JPRB, 0.31798908E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31798859E-06_JPRB, 0.31798950E-06_JPRB, 0.31798555E-06_JPRB, 0.31797993E-06_JPRB /)

RGHG3(:,80, 5) = (/ &
  & 0.31797109E-06_JPRB, 0.31797578E-06_JPRB, 0.31798353E-06_JPRB, 0.31798294E-06_JPRB, 0.31798501E-06_JPRB, 0.31798308E-06_JPRB, &
  & 0.31798550E-06_JPRB, 0.31798550E-06_JPRB, 0.31798743E-06_JPRB, 0.31798882E-06_JPRB, 0.31798962E-06_JPRB, 0.31798979E-06_JPRB, &
  & 0.31798155E-06_JPRB, 0.31798388E-06_JPRB, 0.31798697E-06_JPRB, 0.31799073E-06_JPRB, 0.31799411E-06_JPRB, 0.31799294E-06_JPRB, &
  & 0.31799001E-06_JPRB, 0.31799061E-06_JPRB, 0.31799001E-06_JPRB, 0.31798862E-06_JPRB, 0.31798891E-06_JPRB, 0.31799195E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799641E-06_JPRB, 0.31799826E-06_JPRB, 0.31799647E-06_JPRB, 0.31799675E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799834E-06_JPRB, 0.31800053E-06_JPRB, 0.31799823E-06_JPRB, 0.31799948E-06_JPRB, 0.31800090E-06_JPRB, &
  & 0.31799971E-06_JPRB, 0.31799701E-06_JPRB, 0.31799664E-06_JPRB, 0.31799487E-06_JPRB, 0.31799360E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799175E-06_JPRB, 0.31799195E-06_JPRB, 0.31799595E-06_JPRB, 0.31799624E-06_JPRB, 0.31799331E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799200E-06_JPRB, 0.31799337E-06_JPRB, 0.31799613E-06_JPRB, 0.31799246E-06_JPRB, 0.31799328E-06_JPRB, &
  & 0.31799388E-06_JPRB, 0.31799493E-06_JPRB, 0.31799436E-06_JPRB, 0.31799365E-06_JPRB, 0.31799129E-06_JPRB, 0.31799033E-06_JPRB, &
  & 0.31799109E-06_JPRB, 0.31799243E-06_JPRB, 0.31798868E-06_JPRB, 0.31798567E-06_JPRB /)

RGHG3(:,81, 5) = (/ &
  & 0.31797788E-06_JPRB, 0.31797785E-06_JPRB, 0.31798558E-06_JPRB, 0.31798461E-06_JPRB, 0.31798672E-06_JPRB, 0.31798447E-06_JPRB, &
  & 0.31798692E-06_JPRB, 0.31798686E-06_JPRB, 0.31798868E-06_JPRB, 0.31799027E-06_JPRB, 0.31799098E-06_JPRB, 0.31799127E-06_JPRB, &
  & 0.31798308E-06_JPRB, 0.31798569E-06_JPRB, 0.31798797E-06_JPRB, 0.31799181E-06_JPRB, 0.31799556E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799115E-06_JPRB, 0.31799198E-06_JPRB, 0.31799124E-06_JPRB, 0.31798953E-06_JPRB, 0.31798965E-06_JPRB, 0.31799269E-06_JPRB, &
  & 0.31799664E-06_JPRB, 0.31799706E-06_JPRB, 0.31799880E-06_JPRB, 0.31799672E-06_JPRB, 0.31799692E-06_JPRB, 0.31799667E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31799848E-06_JPRB, 0.31800087E-06_JPRB, 0.31799837E-06_JPRB, 0.31799985E-06_JPRB, 0.31800153E-06_JPRB, &
  & 0.31800039E-06_JPRB, 0.31799775E-06_JPRB, 0.31799732E-06_JPRB, 0.31799553E-06_JPRB, 0.31799419E-06_JPRB, 0.31799223E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31799223E-06_JPRB, 0.31799246E-06_JPRB, 0.31799669E-06_JPRB, 0.31799698E-06_JPRB, 0.31799379E-06_JPRB, &
  & 0.31799425E-06_JPRB, 0.31799235E-06_JPRB, 0.31799388E-06_JPRB, 0.31799703E-06_JPRB, 0.31799300E-06_JPRB, 0.31799405E-06_JPRB, &
  & 0.31799473E-06_JPRB, 0.31799587E-06_JPRB, 0.31799533E-06_JPRB, 0.31799462E-06_JPRB, 0.31799223E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799371E-06_JPRB, 0.31798993E-06_JPRB, 0.31798942E-06_JPRB /)

RGHG3(:,82, 5) = (/ &
  & 0.31797839E-06_JPRB, 0.31797845E-06_JPRB, 0.31798646E-06_JPRB, 0.31798535E-06_JPRB, 0.31798746E-06_JPRB, 0.31798507E-06_JPRB, &
  & 0.31798760E-06_JPRB, 0.31798734E-06_JPRB, 0.31798959E-06_JPRB, 0.31799081E-06_JPRB, 0.31799175E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31798402E-06_JPRB, 0.31798675E-06_JPRB, 0.31798848E-06_JPRB, 0.31799240E-06_JPRB, 0.31799635E-06_JPRB, 0.31799505E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799263E-06_JPRB, 0.31799189E-06_JPRB, 0.31798999E-06_JPRB, 0.31798990E-06_JPRB, 0.31799311E-06_JPRB, &
  & 0.31799718E-06_JPRB, 0.31799738E-06_JPRB, 0.31799914E-06_JPRB, 0.31799675E-06_JPRB, 0.31799695E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799863E-06_JPRB, 0.31800101E-06_JPRB, 0.31799848E-06_JPRB, 0.31800005E-06_JPRB, 0.31800184E-06_JPRB, &
  & 0.31800073E-06_JPRB, 0.31799811E-06_JPRB, 0.31799757E-06_JPRB, 0.31799578E-06_JPRB, 0.31799448E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799246E-06_JPRB, 0.31799260E-06_JPRB, 0.31799709E-06_JPRB, 0.31799740E-06_JPRB, 0.31799397E-06_JPRB, &
  & 0.31799448E-06_JPRB, 0.31799246E-06_JPRB, 0.31799411E-06_JPRB, 0.31799746E-06_JPRB, 0.31799317E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799505E-06_JPRB, 0.31799632E-06_JPRB, 0.31799584E-06_JPRB, 0.31799519E-06_JPRB, 0.31799266E-06_JPRB, 0.31799161E-06_JPRB, &
  & 0.31799266E-06_JPRB, 0.31799433E-06_JPRB, 0.31799033E-06_JPRB, 0.31798970E-06_JPRB /)

RGHG3(:,83, 5) = (/ &
  & 0.31797873E-06_JPRB, 0.31797882E-06_JPRB, 0.31798703E-06_JPRB, 0.31798584E-06_JPRB, 0.31798803E-06_JPRB, 0.31798561E-06_JPRB, &
  & 0.31798800E-06_JPRB, 0.31798805E-06_JPRB, 0.31798965E-06_JPRB, 0.31799141E-06_JPRB, 0.31799195E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31798504E-06_JPRB, 0.31798731E-06_JPRB, 0.31798882E-06_JPRB, 0.31799271E-06_JPRB, 0.31799686E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799206E-06_JPRB, 0.31799306E-06_JPRB, 0.31799232E-06_JPRB, 0.31799027E-06_JPRB, 0.31799004E-06_JPRB, 0.31799325E-06_JPRB, &
  & 0.31799752E-06_JPRB, 0.31799755E-06_JPRB, 0.31799937E-06_JPRB, 0.31799684E-06_JPRB, 0.31799695E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799868E-06_JPRB, 0.31800116E-06_JPRB, 0.31799854E-06_JPRB, 0.31800019E-06_JPRB, 0.31800192E-06_JPRB, &
  & 0.31800087E-06_JPRB, 0.31799834E-06_JPRB, 0.31799775E-06_JPRB, 0.31799598E-06_JPRB, 0.31799459E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799254E-06_JPRB, 0.31799263E-06_JPRB, 0.31799732E-06_JPRB, 0.31799766E-06_JPRB, 0.31799408E-06_JPRB, &
  & 0.31799459E-06_JPRB, 0.31799254E-06_JPRB, 0.31799425E-06_JPRB, 0.31799772E-06_JPRB, 0.31799328E-06_JPRB, 0.31799445E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799669E-06_JPRB, 0.31799618E-06_JPRB, 0.31799544E-06_JPRB, 0.31799291E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799289E-06_JPRB, 0.31799470E-06_JPRB, 0.31799058E-06_JPRB, 0.31798984E-06_JPRB /)

RGHG3(:,84, 5) = (/ &
  & 0.31797887E-06_JPRB, 0.31797902E-06_JPRB, 0.31798743E-06_JPRB, 0.31798615E-06_JPRB, 0.31798828E-06_JPRB, 0.31798572E-06_JPRB, &
  & 0.31798828E-06_JPRB, 0.31798817E-06_JPRB, 0.31799044E-06_JPRB, 0.31799141E-06_JPRB, 0.31799215E-06_JPRB, 0.31799203E-06_JPRB, &
  & 0.31798575E-06_JPRB, 0.31798768E-06_JPRB, 0.31798902E-06_JPRB, 0.31799289E-06_JPRB, 0.31799709E-06_JPRB, 0.31799593E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799337E-06_JPRB, 0.31799260E-06_JPRB, 0.31799038E-06_JPRB, 0.31799010E-06_JPRB, 0.31799340E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799763E-06_JPRB, 0.31799954E-06_JPRB, 0.31799686E-06_JPRB, 0.31799695E-06_JPRB, 0.31799661E-06_JPRB, &
  & 0.31799809E-06_JPRB, 0.31799868E-06_JPRB, 0.31800124E-06_JPRB, 0.31799857E-06_JPRB, 0.31800033E-06_JPRB, 0.31800204E-06_JPRB, &
  & 0.31800096E-06_JPRB, 0.31799857E-06_JPRB, 0.31799783E-06_JPRB, 0.31799613E-06_JPRB, 0.31799470E-06_JPRB, 0.31799297E-06_JPRB, &
  & 0.31799374E-06_JPRB, 0.31799266E-06_JPRB, 0.31799271E-06_JPRB, 0.31799740E-06_JPRB, 0.31799783E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799470E-06_JPRB, 0.31799254E-06_JPRB, 0.31799433E-06_JPRB, 0.31799797E-06_JPRB, 0.31799334E-06_JPRB, 0.31799451E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799686E-06_JPRB, 0.31799632E-06_JPRB, 0.31799570E-06_JPRB, 0.31799306E-06_JPRB, 0.31799198E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799493E-06_JPRB, 0.31799073E-06_JPRB, 0.31798996E-06_JPRB /)

RGHG3(:,85, 5) = (/ &
  & 0.31797899E-06_JPRB, 0.31797913E-06_JPRB, 0.31798768E-06_JPRB, 0.31798638E-06_JPRB, 0.31798862E-06_JPRB, 0.31798621E-06_JPRB, &
  & 0.31798834E-06_JPRB, 0.31798879E-06_JPRB, 0.31799007E-06_JPRB, 0.31799158E-06_JPRB, 0.31799183E-06_JPRB, 0.31799124E-06_JPRB, &
  & 0.31798723E-06_JPRB, 0.31798834E-06_JPRB, 0.31798950E-06_JPRB, 0.31799289E-06_JPRB, 0.31799695E-06_JPRB, 0.31799618E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799357E-06_JPRB, 0.31799271E-06_JPRB, 0.31799038E-06_JPRB, 0.31799004E-06_JPRB, 0.31799345E-06_JPRB, &
  & 0.31799797E-06_JPRB, 0.31799766E-06_JPRB, 0.31799962E-06_JPRB, 0.31799684E-06_JPRB, 0.31799689E-06_JPRB, 0.31799655E-06_JPRB, &
  & 0.31799809E-06_JPRB, 0.31799865E-06_JPRB, 0.31800124E-06_JPRB, 0.31799857E-06_JPRB, 0.31800042E-06_JPRB, 0.31800209E-06_JPRB, &
  & 0.31800101E-06_JPRB, 0.31799865E-06_JPRB, 0.31799780E-06_JPRB, 0.31799613E-06_JPRB, 0.31799476E-06_JPRB, 0.31799308E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799266E-06_JPRB, 0.31799280E-06_JPRB, 0.31799738E-06_JPRB, 0.31799789E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799479E-06_JPRB, 0.31799257E-06_JPRB, 0.31799442E-06_JPRB, 0.31799814E-06_JPRB, 0.31799340E-06_JPRB, 0.31799465E-06_JPRB, &
  & 0.31799550E-06_JPRB, 0.31799706E-06_JPRB, 0.31799649E-06_JPRB, 0.31799578E-06_JPRB, 0.31799317E-06_JPRB, 0.31799206E-06_JPRB, &
  & 0.31799314E-06_JPRB, 0.31799519E-06_JPRB, 0.31799084E-06_JPRB, 0.31799004E-06_JPRB /)

RGHG3(:,86, 5) = (/ &
  & 0.31797899E-06_JPRB, 0.31797924E-06_JPRB, 0.31798788E-06_JPRB, 0.31798646E-06_JPRB, 0.31798857E-06_JPRB, 0.31798629E-06_JPRB, &
  & 0.31798868E-06_JPRB, 0.31798885E-06_JPRB, 0.31799055E-06_JPRB, 0.31799127E-06_JPRB, 0.31799169E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31798780E-06_JPRB, 0.31798862E-06_JPRB, 0.31798979E-06_JPRB, 0.31799283E-06_JPRB, 0.31799647E-06_JPRB, 0.31799618E-06_JPRB, &
  & 0.31799269E-06_JPRB, 0.31799374E-06_JPRB, 0.31799283E-06_JPRB, 0.31799041E-06_JPRB, 0.31799004E-06_JPRB, 0.31799348E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799772E-06_JPRB, 0.31799976E-06_JPRB, 0.31799681E-06_JPRB, 0.31799692E-06_JPRB, 0.31799649E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799868E-06_JPRB, 0.31800127E-06_JPRB, 0.31799851E-06_JPRB, 0.31800045E-06_JPRB, 0.31800224E-06_JPRB, &
  & 0.31800113E-06_JPRB, 0.31799874E-06_JPRB, 0.31799786E-06_JPRB, 0.31799613E-06_JPRB, 0.31799470E-06_JPRB, 0.31799311E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799269E-06_JPRB, 0.31799274E-06_JPRB, 0.31799740E-06_JPRB, 0.31799786E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799482E-06_JPRB, 0.31799257E-06_JPRB, 0.31799436E-06_JPRB, 0.31799820E-06_JPRB, 0.31799337E-06_JPRB, 0.31799456E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799709E-06_JPRB, 0.31799661E-06_JPRB, 0.31799593E-06_JPRB, 0.31799323E-06_JPRB, 0.31799212E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31799527E-06_JPRB, 0.31799087E-06_JPRB, 0.31799004E-06_JPRB /)

RGHG3(:,87, 5) = (/ &
  & 0.31797902E-06_JPRB, 0.31797941E-06_JPRB, 0.31798783E-06_JPRB, 0.31798663E-06_JPRB, 0.31798879E-06_JPRB, 0.31798680E-06_JPRB, &
  & 0.31798862E-06_JPRB, 0.31798928E-06_JPRB, 0.31799024E-06_JPRB, 0.31799124E-06_JPRB, 0.31799138E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31798891E-06_JPRB, 0.31798942E-06_JPRB, 0.31799024E-06_JPRB, 0.31799280E-06_JPRB, 0.31799601E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799382E-06_JPRB, 0.31799300E-06_JPRB, 0.31799044E-06_JPRB, 0.31798999E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799775E-06_JPRB, 0.31799985E-06_JPRB, 0.31799689E-06_JPRB, 0.31799689E-06_JPRB, 0.31799649E-06_JPRB, &
  & 0.31799811E-06_JPRB, 0.31799865E-06_JPRB, 0.31800133E-06_JPRB, 0.31799840E-06_JPRB, 0.31800050E-06_JPRB, 0.31800246E-06_JPRB, &
  & 0.31800144E-06_JPRB, 0.31799877E-06_JPRB, 0.31799800E-06_JPRB, 0.31799615E-06_JPRB, 0.31799465E-06_JPRB, 0.31799289E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799254E-06_JPRB, 0.31799271E-06_JPRB, 0.31799740E-06_JPRB, 0.31799789E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799482E-06_JPRB, 0.31799260E-06_JPRB, 0.31799431E-06_JPRB, 0.31799817E-06_JPRB, 0.31799334E-06_JPRB, 0.31799459E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799715E-06_JPRB, 0.31799664E-06_JPRB, 0.31799590E-06_JPRB, 0.31799323E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799331E-06_JPRB, 0.31799539E-06_JPRB, 0.31799087E-06_JPRB, 0.31799004E-06_JPRB /)

RGHG3(:,88, 5) = (/ &
  & 0.31797902E-06_JPRB, 0.31797990E-06_JPRB, 0.31798766E-06_JPRB, 0.31798658E-06_JPRB, 0.31798862E-06_JPRB, 0.31798677E-06_JPRB, &
  & 0.31798891E-06_JPRB, 0.31798928E-06_JPRB, 0.31799067E-06_JPRB, 0.31799124E-06_JPRB, 0.31799146E-06_JPRB, 0.31799124E-06_JPRB, &
  & 0.31798902E-06_JPRB, 0.31798945E-06_JPRB, 0.31799038E-06_JPRB, 0.31799271E-06_JPRB, 0.31799587E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799306E-06_JPRB, 0.31799394E-06_JPRB, 0.31799300E-06_JPRB, 0.31799041E-06_JPRB, 0.31798993E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799780E-06_JPRB, 0.31799993E-06_JPRB, 0.31799681E-06_JPRB, 0.31799689E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799863E-06_JPRB, 0.31800141E-06_JPRB, 0.31799831E-06_JPRB, 0.31800050E-06_JPRB, 0.31800269E-06_JPRB, &
  & 0.31800170E-06_JPRB, 0.31799883E-06_JPRB, 0.31799817E-06_JPRB, 0.31799613E-06_JPRB, 0.31799456E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31799374E-06_JPRB, 0.31799235E-06_JPRB, 0.31799240E-06_JPRB, 0.31799769E-06_JPRB, 0.31799792E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799476E-06_JPRB, 0.31799266E-06_JPRB, 0.31799431E-06_JPRB, 0.31799806E-06_JPRB, 0.31799334E-06_JPRB, 0.31799453E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799715E-06_JPRB, 0.31799669E-06_JPRB, 0.31799598E-06_JPRB, 0.31799317E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799337E-06_JPRB, 0.31799544E-06_JPRB, 0.31799081E-06_JPRB, 0.31799007E-06_JPRB /)

RGHG3(:,89, 5) = (/ &
  & 0.31797921E-06_JPRB, 0.31798044E-06_JPRB, 0.31798731E-06_JPRB, 0.31798669E-06_JPRB, 0.31798891E-06_JPRB, 0.31798686E-06_JPRB, &
  & 0.31798874E-06_JPRB, 0.31798930E-06_JPRB, 0.31799038E-06_JPRB, 0.31799121E-06_JPRB, 0.31799129E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31798919E-06_JPRB, 0.31798956E-06_JPRB, 0.31799027E-06_JPRB, 0.31799277E-06_JPRB, 0.31799613E-06_JPRB, 0.31799615E-06_JPRB, &
  & 0.31799291E-06_JPRB, 0.31799399E-06_JPRB, 0.31799308E-06_JPRB, 0.31799030E-06_JPRB, 0.31798984E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799783E-06_JPRB, 0.31799999E-06_JPRB, 0.31799684E-06_JPRB, 0.31799695E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799860E-06_JPRB, 0.31800150E-06_JPRB, 0.31799817E-06_JPRB, 0.31800050E-06_JPRB, 0.31800289E-06_JPRB, &
  & 0.31800195E-06_JPRB, 0.31799877E-06_JPRB, 0.31799846E-06_JPRB, 0.31799618E-06_JPRB, 0.31799453E-06_JPRB, 0.31799192E-06_JPRB, &
  & 0.31799397E-06_JPRB, 0.31799215E-06_JPRB, 0.31799223E-06_JPRB, 0.31799789E-06_JPRB, 0.31799797E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799473E-06_JPRB, 0.31799266E-06_JPRB, 0.31799425E-06_JPRB, 0.31799797E-06_JPRB, 0.31799323E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799715E-06_JPRB, 0.31799675E-06_JPRB, 0.31799604E-06_JPRB, 0.31799314E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799340E-06_JPRB, 0.31799556E-06_JPRB, 0.31799078E-06_JPRB, 0.31799007E-06_JPRB /)

RGHG3(:,90, 5) = (/ &
  & 0.31797953E-06_JPRB, 0.31798112E-06_JPRB, 0.31798692E-06_JPRB, 0.31798655E-06_JPRB, 0.31798896E-06_JPRB, 0.31798635E-06_JPRB, &
  & 0.31798885E-06_JPRB, 0.31798902E-06_JPRB, 0.31799078E-06_JPRB, 0.31799152E-06_JPRB, 0.31799163E-06_JPRB, 0.31799129E-06_JPRB, &
  & 0.31798848E-06_JPRB, 0.31798896E-06_JPRB, 0.31798979E-06_JPRB, 0.31799289E-06_JPRB, 0.31799695E-06_JPRB, 0.31799672E-06_JPRB, &
  & 0.31799263E-06_JPRB, 0.31799414E-06_JPRB, 0.31799320E-06_JPRB, 0.31799024E-06_JPRB, 0.31798970E-06_JPRB, 0.31799351E-06_JPRB, &
  & 0.31799868E-06_JPRB, 0.31799783E-06_JPRB, 0.31800025E-06_JPRB, 0.31799672E-06_JPRB, 0.31799689E-06_JPRB, 0.31799630E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799854E-06_JPRB, 0.31800175E-06_JPRB, 0.31799797E-06_JPRB, 0.31800053E-06_JPRB, 0.31800312E-06_JPRB, &
  & 0.31800224E-06_JPRB, 0.31799871E-06_JPRB, 0.31799868E-06_JPRB, 0.31799613E-06_JPRB, 0.31799465E-06_JPRB, 0.31799129E-06_JPRB, &
  & 0.31799425E-06_JPRB, 0.31799195E-06_JPRB, 0.31799192E-06_JPRB, 0.31799814E-06_JPRB, 0.31799817E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799479E-06_JPRB, 0.31799257E-06_JPRB, 0.31799425E-06_JPRB, 0.31799829E-06_JPRB, 0.31799314E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799723E-06_JPRB, 0.31799678E-06_JPRB, 0.31799615E-06_JPRB, 0.31799306E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799340E-06_JPRB, 0.31799578E-06_JPRB, 0.31799064E-06_JPRB, 0.31799004E-06_JPRB /)

RGHG3(:,91, 5) = (/ &
  & 0.31797975E-06_JPRB, 0.31798169E-06_JPRB, 0.31798669E-06_JPRB, 0.31798618E-06_JPRB, 0.31798965E-06_JPRB, 0.31798550E-06_JPRB, &
  & 0.31798916E-06_JPRB, 0.31798760E-06_JPRB, 0.31799075E-06_JPRB, 0.31799263E-06_JPRB, 0.31799431E-06_JPRB, 0.31799459E-06_JPRB, &
  & 0.31798251E-06_JPRB, 0.31798862E-06_JPRB, 0.31798842E-06_JPRB, 0.31799311E-06_JPRB, 0.31799880E-06_JPRB, 0.31799738E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799436E-06_JPRB, 0.31799328E-06_JPRB, 0.31799007E-06_JPRB, 0.31798942E-06_JPRB, 0.31799340E-06_JPRB, &
  & 0.31799908E-06_JPRB, 0.31799763E-06_JPRB, 0.31800064E-06_JPRB, 0.31799655E-06_JPRB, 0.31799695E-06_JPRB, 0.31799615E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31799826E-06_JPRB, 0.31800235E-06_JPRB, 0.31799743E-06_JPRB, 0.31800047E-06_JPRB, 0.31800340E-06_JPRB, &
  & 0.31800246E-06_JPRB, 0.31799840E-06_JPRB, 0.31799900E-06_JPRB, 0.31799604E-06_JPRB, 0.31799482E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31799485E-06_JPRB, 0.31799166E-06_JPRB, 0.31799135E-06_JPRB, 0.31799877E-06_JPRB, 0.31799883E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799502E-06_JPRB, 0.31799206E-06_JPRB, 0.31799388E-06_JPRB, 0.31799911E-06_JPRB, 0.31799254E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799746E-06_JPRB, 0.31799686E-06_JPRB, 0.31799627E-06_JPRB, 0.31799291E-06_JPRB, 0.31799198E-06_JPRB, &
  & 0.31799340E-06_JPRB, 0.31799618E-06_JPRB, 0.31799036E-06_JPRB, 0.31799004E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG3(:, 1, 6) = (/ &
  & 0.10679332E-06_JPRB, 0.10690434E-06_JPRB, 0.10694184E-06_JPRB, 0.10696697E-06_JPRB, 0.10699964E-06_JPRB, 0.10704424E-06_JPRB, &
  & 0.10707332E-06_JPRB, 0.10707380E-06_JPRB, 0.10704584E-06_JPRB, 0.10699526E-06_JPRB, 0.10692583E-06_JPRB, 0.10683968E-06_JPRB, &
  & 0.10673804E-06_JPRB, 0.10662186E-06_JPRB, 0.10649153E-06_JPRB, 0.10634700E-06_JPRB, 0.10618785E-06_JPRB, 0.10601359E-06_JPRB, &
  & 0.10582362E-06_JPRB, 0.10561712E-06_JPRB, 0.10539318E-06_JPRB, 0.10515136E-06_JPRB, 0.10489273E-06_JPRB, 0.10462001E-06_JPRB, &
  & 0.10434094E-06_JPRB, 0.10406687E-06_JPRB, 0.10380874E-06_JPRB, 0.10356897E-06_JPRB, 0.10333491E-06_JPRB, 0.10310428E-06_JPRB, &
  & 0.10287610E-06_JPRB, 0.10264974E-06_JPRB, 0.10242290E-06_JPRB, 0.10219914E-06_JPRB, 0.10198104E-06_JPRB, 0.10177162E-06_JPRB, &
  & 0.10157144E-06_JPRB, 0.10137705E-06_JPRB, 0.10119116E-06_JPRB, 0.10103228E-06_JPRB, 0.10087752E-06_JPRB, 0.10070591E-06_JPRB, &
  & 0.10050298E-06_JPRB, 0.10024488E-06_JPRB, 0.99897562E-07_JPRB, 0.99385730E-07_JPRB, 0.98585453E-07_JPRB, 0.97439788E-07_JPRB, &
  & 0.96298429E-07_JPRB, 0.95396842E-07_JPRB, 0.94576066E-07_JPRB, 0.93819132E-07_JPRB, 0.93130794E-07_JPRB, 0.92512622E-07_JPRB, &
  & 0.91958839E-07_JPRB, 0.91486179E-07_JPRB, 0.91142361E-07_JPRB, 0.90869300E-07_JPRB, 0.90638885E-07_JPRB, 0.90437702E-07_JPRB, &
  & 0.90255050E-07_JPRB, 0.90098936E-07_JPRB, 0.89978542E-07_JPRB, 0.89891039E-07_JPRB /)

RGHG3(:, 2, 6) = (/ &
  & 0.10707603E-06_JPRB, 0.10735739E-06_JPRB, 0.10750066E-06_JPRB, 0.10760880E-06_JPRB, 0.10771801E-06_JPRB, 0.10783604E-06_JPRB, &
  & 0.10793713E-06_JPRB, 0.10799580E-06_JPRB, 0.10800174E-06_JPRB, 0.10795851E-06_JPRB, 0.10786700E-06_JPRB, 0.10772930E-06_JPRB, &
  & 0.10755675E-06_JPRB, 0.10737210E-06_JPRB, 0.10719910E-06_JPRB, 0.10704969E-06_JPRB, 0.10691886E-06_JPRB, 0.10679058E-06_JPRB, &
  & 0.10664768E-06_JPRB, 0.10647731E-06_JPRB, 0.10627346E-06_JPRB, 0.10603684E-06_JPRB, 0.10577553E-06_JPRB, 0.10550289E-06_JPRB, &
  & 0.10523837E-06_JPRB, 0.10499804E-06_JPRB, 0.10478887E-06_JPRB, 0.10460239E-06_JPRB, 0.10441881E-06_JPRB, 0.10421425E-06_JPRB, &
  & 0.10396534E-06_JPRB, 0.10365515E-06_JPRB, 0.10327953E-06_JPRB, 0.10284932E-06_JPRB, 0.10238080E-06_JPRB, 0.10189292E-06_JPRB, &
  & 0.10141076E-06_JPRB, 0.10096000E-06_JPRB, 0.10057177E-06_JPRB, 0.10025671E-06_JPRB, 0.99990011E-07_JPRB, 0.99737022E-07_JPRB, &
  & 0.99472899E-07_JPRB, 0.99171203E-07_JPRB, 0.98801138E-07_JPRB, 0.98318559E-07_JPRB, 0.97679070E-07_JPRB, 0.96883426E-07_JPRB, &
  & 0.96035890E-07_JPRB, 0.95244324E-07_JPRB, 0.94500891E-07_JPRB, 0.93787691E-07_JPRB, 0.93086932E-07_JPRB, 0.92400214E-07_JPRB, &
  & 0.91742955E-07_JPRB, 0.91154163E-07_JPRB, 0.90677531E-07_JPRB, 0.90316604E-07_JPRB, 0.90032074E-07_JPRB, 0.89805930E-07_JPRB, &
  & 0.89636998E-07_JPRB, 0.89526992E-07_JPRB, 0.89466255E-07_JPRB, 0.89487216E-07_JPRB /)

RGHG3(:, 3, 6) = (/ &
  & 0.10742068E-06_JPRB, 0.10778309E-06_JPRB, 0.10795952E-06_JPRB, 0.10809310E-06_JPRB, 0.10822272E-06_JPRB, 0.10835565E-06_JPRB, &
  & 0.10846780E-06_JPRB, 0.10852645E-06_JPRB, 0.10851950E-06_JPRB, 0.10846809E-06_JPRB, 0.10841499E-06_JPRB, 0.10841639E-06_JPRB, &
  & 0.10851077E-06_JPRB, 0.10869079E-06_JPRB, 0.10891132E-06_JPRB, 0.10912379E-06_JPRB, 0.10929573E-06_JPRB, 0.10940766E-06_JPRB, &
  & 0.10944748E-06_JPRB, 0.10940808E-06_JPRB, 0.10928866E-06_JPRB, 0.10909568E-06_JPRB, 0.10884484E-06_JPRB, 0.10855901E-06_JPRB, &
  & 0.10826388E-06_JPRB, 0.10798178E-06_JPRB, 0.10771486E-06_JPRB, 0.10745092E-06_JPRB, 0.10716184E-06_JPRB, 0.10681258E-06_JPRB, &
  & 0.10637127E-06_JPRB, 0.10582426E-06_JPRB, 0.10518533E-06_JPRB, 0.10448151E-06_JPRB, 0.10374018E-06_JPRB, 0.10297972E-06_JPRB, &
  & 0.10220629E-06_JPRB, 0.10144149E-06_JPRB, 0.10071103E-06_JPRB, 0.10005711E-06_JPRB, 0.99471578E-07_JPRB, 0.98934159E-07_JPRB, &
  & 0.98421630E-07_JPRB, 0.97907687E-07_JPRB, 0.97376372E-07_JPRB, 0.96811988E-07_JPRB, 0.96208773E-07_JPRB, 0.95576610E-07_JPRB, &
  & 0.94942287E-07_JPRB, 0.94321827E-07_JPRB, 0.93708422E-07_JPRB, 0.93083536E-07_JPRB, 0.92437816E-07_JPRB, 0.91760171E-07_JPRB, &
  & 0.91071321E-07_JPRB, 0.90415824E-07_JPRB, 0.89838899E-07_JPRB, 0.89369486E-07_JPRB, 0.89003734E-07_JPRB, 0.88733458E-07_JPRB, &
  & 0.88540368E-07_JPRB, 0.88397194E-07_JPRB, 0.88323333E-07_JPRB, 0.88370093E-07_JPRB /)

RGHG3(:, 4, 6) = (/ &
  & 0.10767846E-06_JPRB, 0.10809185E-06_JPRB, 0.10831707E-06_JPRB, 0.10850452E-06_JPRB, 0.10869127E-06_JPRB, 0.10888723E-06_JPRB, &
  & 0.10907083E-06_JPRB, 0.10922597E-06_JPRB, 0.10937108E-06_JPRB, 0.10956364E-06_JPRB, 0.10984527E-06_JPRB, 0.11021243E-06_JPRB, &
  & 0.11063501E-06_JPRB, 0.11108953E-06_JPRB, 0.11155910E-06_JPRB, 0.11201161E-06_JPRB, 0.11240739E-06_JPRB, 0.11272147E-06_JPRB, &
  & 0.11294611E-06_JPRB, 0.11307696E-06_JPRB, 0.11310877E-06_JPRB, 0.11303857E-06_JPRB, 0.11287091E-06_JPRB, 0.11261732E-06_JPRB, &
  & 0.11229608E-06_JPRB, 0.11192539E-06_JPRB, 0.11151337E-06_JPRB, 0.11105050E-06_JPRB, 0.11051111E-06_JPRB, 0.10986091E-06_JPRB, &
  & 0.10907893E-06_JPRB, 0.10817890E-06_JPRB, 0.10720039E-06_JPRB, 0.10620288E-06_JPRB, 0.10522515E-06_JPRB, 0.10427616E-06_JPRB, &
  & 0.10336119E-06_JPRB, 0.10246053E-06_JPRB, 0.10157336E-06_JPRB, 0.10069468E-06_JPRB, 0.99834551E-07_JPRB, 0.98993539E-07_JPRB, &
  & 0.98167696E-07_JPRB, 0.97362211E-07_JPRB, 0.96574261E-07_JPRB, 0.95807259E-07_JPRB, 0.95071996E-07_JPRB, 0.94383310E-07_JPRB, &
  & 0.93729135E-07_JPRB, 0.93135696E-07_JPRB, 0.92542550E-07_JPRB, 0.91972140E-07_JPRB, 0.91378482E-07_JPRB, 0.90758697E-07_JPRB, &
  & 0.90132247E-07_JPRB, 0.89520505E-07_JPRB, 0.88947758E-07_JPRB, 0.88490914E-07_JPRB, 0.88150514E-07_JPRB, 0.87893525E-07_JPRB, &
  & 0.87706830E-07_JPRB, 0.87595232E-07_JPRB, 0.87546027E-07_JPRB, 0.87539391E-07_JPRB /)

RGHG3(:, 5, 6) = (/ &
  & 0.10778463E-06_JPRB, 0.10816128E-06_JPRB, 0.10841475E-06_JPRB, 0.10867992E-06_JPRB, 0.10898371E-06_JPRB, 0.10932939E-06_JPRB, &
  & 0.10970284E-06_JPRB, 0.11009635E-06_JPRB, 0.11051492E-06_JPRB, 0.11098943E-06_JPRB, 0.11153268E-06_JPRB, 0.11215153E-06_JPRB, &
  & 0.11284322E-06_JPRB, 0.11358061E-06_JPRB, 0.11432377E-06_JPRB, 0.11505787E-06_JPRB, 0.11576814E-06_JPRB, 0.11640527E-06_JPRB, &
  & 0.11691799E-06_JPRB, 0.11728596E-06_JPRB, 0.11751161E-06_JPRB, 0.11759987E-06_JPRB, 0.11755291E-06_JPRB, 0.11736864E-06_JPRB, &
  & 0.11704388E-06_JPRB, 0.11657897E-06_JPRB, 0.11597061E-06_JPRB, 0.11521666E-06_JPRB, 0.11430918E-06_JPRB, 0.11324285E-06_JPRB, &
  & 0.11203242E-06_JPRB, 0.11071972E-06_JPRB, 0.10937668E-06_JPRB, 0.10807882E-06_JPRB, 0.10688721E-06_JPRB, 0.10582502E-06_JPRB, &
  & 0.10485365E-06_JPRB, 0.10394617E-06_JPRB, 0.10306094E-06_JPRB, 0.10217980E-06_JPRB, 0.10128463E-06_JPRB, 0.10037228E-06_JPRB, &
  & 0.99462660E-07_JPRB, 0.98557791E-07_JPRB, 0.97679361E-07_JPRB, 0.96836942E-07_JPRB, 0.96030043E-07_JPRB, 0.95259885E-07_JPRB, &
  & 0.94510391E-07_JPRB, 0.93783399E-07_JPRB, 0.93054993E-07_JPRB, 0.92313407E-07_JPRB, 0.91559919E-07_JPRB, 0.90774563E-07_JPRB, &
  & 0.89985001E-07_JPRB, 0.89199290E-07_JPRB, 0.88506368E-07_JPRB, 0.87967109E-07_JPRB, 0.87550418E-07_JPRB, 0.87237396E-07_JPRB, &
  & 0.87021661E-07_JPRB, 0.86871623E-07_JPRB, 0.86777987E-07_JPRB, 0.86774499E-07_JPRB /)

RGHG3(:, 6, 6) = (/ &
  & 0.10757572E-06_JPRB, 0.10767044E-06_JPRB, 0.10787063E-06_JPRB, 0.10821208E-06_JPRB, 0.10868873E-06_JPRB, 0.10927172E-06_JPRB, &
  & 0.10992159E-06_JPRB, 0.11060904E-06_JPRB, 0.11132278E-06_JPRB, 0.11207487E-06_JPRB, 0.11291163E-06_JPRB, 0.11383698E-06_JPRB, &
  & 0.11483446E-06_JPRB, 0.11588479E-06_JPRB, 0.11695625E-06_JPRB, 0.11797790E-06_JPRB, 0.11889348E-06_JPRB, 0.11968989E-06_JPRB, &
  & 0.12036125E-06_JPRB, 0.12089151E-06_JPRB, 0.12127612E-06_JPRB, 0.12151830E-06_JPRB, 0.12161598E-06_JPRB, 0.12155667E-06_JPRB, &
  & 0.12131827E-06_JPRB, 0.12087642E-06_JPRB, 0.12020557E-06_JPRB, 0.11929035E-06_JPRB, 0.11813202E-06_JPRB, 0.11675377E-06_JPRB, &
  & 0.11519867E-06_JPRB, 0.11354916E-06_JPRB, 0.11191442E-06_JPRB, 0.11041119E-06_JPRB, 0.10910996E-06_JPRB, 0.10800438E-06_JPRB, &
  & 0.10706725E-06_JPRB, 0.10623514E-06_JPRB, 0.10545313E-06_JPRB, 0.10467066E-06_JPRB, 0.10385797E-06_JPRB, 0.10300883E-06_JPRB, &
  & 0.10212355E-06_JPRB, 0.10122467E-06_JPRB, 0.10032159E-06_JPRB, 0.99422230E-07_JPRB, 0.98528069E-07_JPRB, 0.97625751E-07_JPRB, &
  & 0.96700589E-07_JPRB, 0.95750714E-07_JPRB, 0.94772993E-07_JPRB, 0.93752732E-07_JPRB, 0.92710842E-07_JPRB, 0.91653348E-07_JPRB, &
  & 0.90581651E-07_JPRB, 0.89557204E-07_JPRB, 0.88649564E-07_JPRB, 0.87909370E-07_JPRB, 0.87326981E-07_JPRB, 0.86894005E-07_JPRB, &
  & 0.86584791E-07_JPRB, 0.86378620E-07_JPRB, 0.86254964E-07_JPRB, 0.86202228E-07_JPRB /)

RGHG3(:, 7, 6) = (/ &
  & 0.10662124E-06_JPRB, 0.10603663E-06_JPRB, 0.10604545E-06_JPRB, 0.10641126E-06_JPRB, 0.10704984E-06_JPRB, 0.10786945E-06_JPRB, &
  & 0.10881892E-06_JPRB, 0.10983918E-06_JPRB, 0.11091532E-06_JPRB, 0.11205022E-06_JPRB, 0.11327408E-06_JPRB, 0.11459274E-06_JPRB, &
  & 0.11597490E-06_JPRB, 0.11735573E-06_JPRB, 0.11866420E-06_JPRB, 0.11986785E-06_JPRB, 0.12093693E-06_JPRB, 0.12184617E-06_JPRB, &
  & 0.12260357E-06_JPRB, 0.12322772E-06_JPRB, 0.12372423E-06_JPRB, 0.12410705E-06_JPRB, 0.12438474E-06_JPRB, 0.12453933E-06_JPRB, &
  & 0.12453211E-06_JPRB, 0.12431626E-06_JPRB, 0.12383569E-06_JPRB, 0.12304409E-06_JPRB, 0.12192304E-06_JPRB, 0.12049013E-06_JPRB, &
  & 0.11881970E-06_JPRB, 0.11704171E-06_JPRB, 0.11530346E-06_JPRB, 0.11374879E-06_JPRB, 0.11245788E-06_JPRB, 0.11144430E-06_JPRB, &
  & 0.11064047E-06_JPRB, 0.10996814E-06_JPRB, 0.10934772E-06_JPRB, 0.10871958E-06_JPRB, 0.10803971E-06_JPRB, 0.10728087E-06_JPRB, &
  & 0.10644290E-06_JPRB, 0.10552375E-06_JPRB, 0.10454121E-06_JPRB, 0.10350505E-06_JPRB, 0.10241612E-06_JPRB, 0.10126620E-06_JPRB, &
  & 0.10005505E-06_JPRB, 0.98783858E-07_JPRB, 0.97461239E-07_JPRB, 0.96094894E-07_JPRB, 0.94698692E-07_JPRB, 0.93302667E-07_JPRB, &
  & 0.91933174E-07_JPRB, 0.90649927E-07_JPRB, 0.89498151E-07_JPRB, 0.88562722E-07_JPRB, 0.87830635E-07_JPRB, 0.87277442E-07_JPRB, &
  & 0.86871296E-07_JPRB, 0.86572797E-07_JPRB, 0.86331347E-07_JPRB, 0.86075786E-07_JPRB /)

RGHG3(:, 8, 6) = (/ &
  & 0.10432760E-06_JPRB, 0.10289457E-06_JPRB, 0.10269287E-06_JPRB, 0.10303706E-06_JPRB, 0.10374641E-06_JPRB, 0.10474623E-06_JPRB, &
  & 0.10591290E-06_JPRB, 0.10726187E-06_JPRB, 0.10871872E-06_JPRB, 0.11027656E-06_JPRB, 0.11193156E-06_JPRB, 0.11365415E-06_JPRB, &
  & 0.11539183E-06_JPRB, 0.11707681E-06_JPRB, 0.11865016E-06_JPRB, 0.12004894E-06_JPRB, 0.12126901E-06_JPRB, 0.12232852E-06_JPRB, &
  & 0.12324574E-06_JPRB, 0.12406225E-06_JPRB, 0.12481857E-06_JPRB, 0.12550170E-06_JPRB, 0.12612212E-06_JPRB, 0.12668501E-06_JPRB, &
  & 0.12713272E-06_JPRB, 0.12739444E-06_JPRB, 0.12739578E-06_JPRB, 0.12705827E-06_JPRB, 0.12631720E-06_JPRB, 0.12516074E-06_JPRB, &
  & 0.12365466E-06_JPRB, 0.12196357E-06_JPRB, 0.12031022E-06_JPRB, 0.11887295E-06_JPRB, 0.11775840E-06_JPRB, 0.11696338E-06_JPRB, &
  & 0.11642283E-06_JPRB, 0.11603603E-06_JPRB, 0.11569357E-06_JPRB, 0.11529468E-06_JPRB, 0.11476568E-06_JPRB, 0.11406699E-06_JPRB, &
  & 0.11318367E-06_JPRB, 0.11213032E-06_JPRB, 0.11092411E-06_JPRB, 0.10958296E-06_JPRB, 0.10812214E-06_JPRB, 0.10655251E-06_JPRB, &
  & 0.10488763E-06_JPRB, 0.10314886E-06_JPRB, 0.10135711E-06_JPRB, 0.99544195E-07_JPRB, 0.97743282E-07_JPRB, 0.95992881E-07_JPRB, &
  & 0.94344102E-07_JPRB, 0.92839194E-07_JPRB, 0.91543917E-07_JPRB, 0.90525681E-07_JPRB, 0.89745683E-07_JPRB, 0.89163876E-07_JPRB, &
  & 0.88733159E-07_JPRB, 0.88399091E-07_JPRB, 0.88085564E-07_JPRB, 0.87640437E-07_JPRB /)

RGHG3(:, 9, 6) = (/ &
  & 0.10089333E-06_JPRB, 0.99502422E-07_JPRB, 0.99478783E-07_JPRB, 0.99917990E-07_JPRB, 0.10067297E-06_JPRB, 0.10162065E-06_JPRB, &
  & 0.10282975E-06_JPRB, 0.10419132E-06_JPRB, 0.10574784E-06_JPRB, 0.10742517E-06_JPRB, 0.10920277E-06_JPRB, 0.11104704E-06_JPRB, &
  & 0.11290922E-06_JPRB, 0.11473422E-06_JPRB, 0.11647041E-06_JPRB, 0.11808807E-06_JPRB, 0.11955002E-06_JPRB, 0.12087216E-06_JPRB, &
  & 0.12209655E-06_JPRB, 0.12325195E-06_JPRB, 0.12439000E-06_JPRB, 0.12560214E-06_JPRB, 0.12685146E-06_JPRB, 0.12808016E-06_JPRB, &
  & 0.12929884E-06_JPRB, 0.13040264E-06_JPRB, 0.13124253E-06_JPRB, 0.13169370E-06_JPRB, 0.13168436E-06_JPRB, 0.13120112E-06_JPRB, &
  & 0.13032015E-06_JPRB, 0.12920590E-06_JPRB, 0.12806400E-06_JPRB, 0.12708573E-06_JPRB, 0.12637081E-06_JPRB, 0.12593432E-06_JPRB, &
  & 0.12571357E-06_JPRB, 0.12560210E-06_JPRB, 0.12547395E-06_JPRB, 0.12521176E-06_JPRB, 0.12472580E-06_JPRB, 0.12396352E-06_JPRB, &
  & 0.12290798E-06_JPRB, 0.12156086E-06_JPRB, 0.11994784E-06_JPRB, 0.11809986E-06_JPRB, 0.11605663E-06_JPRB, 0.11385177E-06_JPRB, &
  & 0.11153355E-06_JPRB, 0.10914560E-06_JPRB, 0.10674817E-06_JPRB, 0.10439923E-06_JPRB, 0.10215359E-06_JPRB, 0.10006080E-06_JPRB, &
  & 0.98173274E-07_JPRB, 0.96543189E-07_JPRB, 0.95222234E-07_JPRB, 0.94256556E-07_JPRB, 0.93577427E-07_JPRB, 0.93124292E-07_JPRB, &
  & 0.92836665E-07_JPRB, 0.92659249E-07_JPRB, 0.92530385E-07_JPRB, 0.92395823E-07_JPRB /)

RGHG3(:,10, 6) = (/ &
  & 0.98146899E-07_JPRB, 0.98061420E-07_JPRB, 0.98462564E-07_JPRB, 0.99031119E-07_JPRB, 0.99700515E-07_JPRB, 0.10053958E-06_JPRB, &
  & 0.10147622E-06_JPRB, 0.10263020E-06_JPRB, 0.10391712E-06_JPRB, 0.10534738E-06_JPRB, 0.10687482E-06_JPRB, 0.10846885E-06_JPRB, &
  & 0.11011385E-06_JPRB, 0.11178172E-06_JPRB, 0.11344962E-06_JPRB, 0.11510576E-06_JPRB, 0.11673971E-06_JPRB, 0.11834450E-06_JPRB, &
  & 0.11995769E-06_JPRB, 0.12164389E-06_JPRB, 0.12346757E-06_JPRB, 0.12544388E-06_JPRB, 0.12764234E-06_JPRB, 0.13002850E-06_JPRB, &
  & 0.13233301E-06_JPRB, 0.13441485E-06_JPRB, 0.13617239E-06_JPRB, 0.13760442E-06_JPRB, 0.13869925E-06_JPRB, 0.13945100E-06_JPRB, &
  & 0.13987085E-06_JPRB, 0.14002507E-06_JPRB, 0.14003155E-06_JPRB, 0.14001802E-06_JPRB, 0.14006059E-06_JPRB, 0.14016499E-06_JPRB, &
  & 0.14027714E-06_JPRB, 0.14030419E-06_JPRB, 0.14014218E-06_JPRB, 0.13969412E-06_JPRB, 0.13889513E-06_JPRB, 0.13772458E-06_JPRB, &
  & 0.13617090E-06_JPRB, 0.13425354E-06_JPRB, 0.13199902E-06_JPRB, 0.12944646E-06_JPRB, 0.12663007E-06_JPRB, 0.12360883E-06_JPRB, &
  & 0.12044521E-06_JPRB, 0.11723655E-06_JPRB, 0.11407683E-06_JPRB, 0.11106059E-06_JPRB, 0.10826168E-06_JPRB, 0.10575658E-06_JPRB, &
  & 0.10360441E-06_JPRB, 0.10183748E-06_JPRB, 0.10049155E-06_JPRB, 0.99573391E-07_JPRB, 0.98986185E-07_JPRB, 0.98648428E-07_JPRB, &
  & 0.98492222E-07_JPRB, 0.98464071E-07_JPRB, 0.98559617E-07_JPRB, 0.98835024E-07_JPRB /)

RGHG3(:,11, 6) = (/ &
  & 0.98142387E-07_JPRB, 0.99250506E-07_JPRB, 0.99980923E-07_JPRB, 0.10063074E-06_JPRB, 0.10130931E-06_JPRB, 0.10202391E-06_JPRB, &
  & 0.10292892E-06_JPRB, 0.10399106E-06_JPRB, 0.10532281E-06_JPRB, 0.10688017E-06_JPRB, 0.10866170E-06_JPRB, 0.11062761E-06_JPRB, &
  & 0.11271617E-06_JPRB, 0.11485866E-06_JPRB, 0.11695396E-06_JPRB, 0.11892269E-06_JPRB, 0.12072209E-06_JPRB, 0.12238452E-06_JPRB, &
  & 0.12401603E-06_JPRB, 0.12574367E-06_JPRB, 0.12770873E-06_JPRB, 0.13001616E-06_JPRB, 0.13260419E-06_JPRB, 0.13528884E-06_JPRB, &
  & 0.13795987E-06_JPRB, 0.14053914E-06_JPRB, 0.14309295E-06_JPRB, 0.14555452E-06_JPRB, 0.14789566E-06_JPRB, 0.15014959E-06_JPRB, &
  & 0.15232249E-06_JPRB, 0.15435825E-06_JPRB, 0.15617887E-06_JPRB, 0.15770078E-06_JPRB, 0.15887947E-06_JPRB, 0.15967538E-06_JPRB, &
  & 0.16004817E-06_JPRB, 0.15996049E-06_JPRB, 0.15939629E-06_JPRB, 0.15834871E-06_JPRB, 0.15683553E-06_JPRB, 0.15489256E-06_JPRB, &
  & 0.15254133E-06_JPRB, 0.14981066E-06_JPRB, 0.14672050E-06_JPRB, 0.14329925E-06_JPRB, 0.13960219E-06_JPRB, 0.13570482E-06_JPRB, &
  & 0.13172254E-06_JPRB, 0.12775308E-06_JPRB, 0.12390210E-06_JPRB, 0.12025548E-06_JPRB, 0.11691146E-06_JPRB, 0.11395502E-06_JPRB, &
  & 0.11144323E-06_JPRB, 0.10940844E-06_JPRB, 0.10787097E-06_JPRB, 0.10682473E-06_JPRB, 0.10616687E-06_JPRB, 0.10580904E-06_JPRB, &
  & 0.10568100E-06_JPRB, 0.10573584E-06_JPRB, 0.10600753E-06_JPRB, 0.10672061E-06_JPRB /)

RGHG3(:,12, 6) = (/ &
  & 0.10422239E-06_JPRB, 0.10728183E-06_JPRB, 0.10876116E-06_JPRB, 0.10979642E-06_JPRB, 0.11066013E-06_JPRB, 0.11161762E-06_JPRB, &
  & 0.11276042E-06_JPRB, 0.11439685E-06_JPRB, 0.11658077E-06_JPRB, 0.11947235E-06_JPRB, 0.12302048E-06_JPRB, 0.12711131E-06_JPRB, &
  & 0.13151363E-06_JPRB, 0.13589634E-06_JPRB, 0.13990464E-06_JPRB, 0.14320958E-06_JPRB, 0.14558206E-06_JPRB, 0.14698126E-06_JPRB, &
  & 0.14754036E-06_JPRB, 0.14755292E-06_JPRB, 0.14741823E-06_JPRB, 0.14748383E-06_JPRB, 0.14795040E-06_JPRB, 0.14889339E-06_JPRB, &
  & 0.15026389E-06_JPRB, 0.15198312E-06_JPRB, 0.15397666E-06_JPRB, 0.15638909E-06_JPRB, 0.15933072E-06_JPRB, 0.16270570E-06_JPRB, &
  & 0.16642170E-06_JPRB, 0.17026498E-06_JPRB, 0.17383627E-06_JPRB, 0.17688480E-06_JPRB, 0.17924312E-06_JPRB, 0.18077885E-06_JPRB, &
  & 0.18144846E-06_JPRB, 0.18127274E-06_JPRB, 0.18031804E-06_JPRB, 0.17866853E-06_JPRB, 0.17642354E-06_JPRB, 0.17368734E-06_JPRB, &
  & 0.17052723E-06_JPRB, 0.16699241E-06_JPRB, 0.16312632E-06_JPRB, 0.15897814E-06_JPRB, 0.15461032E-06_JPRB, 0.15011607E-06_JPRB, &
  & 0.14558120E-06_JPRB, 0.14110628E-06_JPRB, 0.13679093E-06_JPRB, 0.13274445E-06_JPRB, 0.12906136E-06_JPRB, 0.12581745E-06_JPRB, &
  & 0.12305820E-06_JPRB, 0.12081006E-06_JPRB, 0.11908903E-06_JPRB, 0.11789287E-06_JPRB, 0.11713031E-06_JPRB, 0.11672830E-06_JPRB, &
  & 0.11663175E-06_JPRB, 0.11682104E-06_JPRB, 0.11741270E-06_JPRB, 0.11904055E-06_JPRB /)

RGHG3(:,13, 6) = (/ &
  & 0.12098425E-06_JPRB, 0.12491839E-06_JPRB, 0.12666088E-06_JPRB, 0.12777933E-06_JPRB, 0.12876626E-06_JPRB, 0.12985775E-06_JPRB, &
  & 0.13139490E-06_JPRB, 0.13354531E-06_JPRB, 0.13663421E-06_JPRB, 0.14068461E-06_JPRB, 0.14562988E-06_JPRB, 0.15117959E-06_JPRB, &
  & 0.15692824E-06_JPRB, 0.16243416E-06_JPRB, 0.16724957E-06_JPRB, 0.17101264E-06_JPRB, 0.17345661E-06_JPRB, 0.17452383E-06_JPRB, &
  & 0.17433477E-06_JPRB, 0.17317356E-06_JPRB, 0.17143569E-06_JPRB, 0.16958498E-06_JPRB, 0.16806561E-06_JPRB, 0.16708725E-06_JPRB, &
  & 0.16673154E-06_JPRB, 0.16706603E-06_JPRB, 0.16821039E-06_JPRB, 0.17015267E-06_JPRB, 0.17296941E-06_JPRB, 0.17679226E-06_JPRB, &
  & 0.18134476E-06_JPRB, 0.18612926E-06_JPRB, 0.19074544E-06_JPRB, 0.19472886E-06_JPRB, 0.19773923E-06_JPRB, 0.19973986E-06_JPRB, &
  & 0.20070802E-06_JPRB, 0.20064644E-06_JPRB, 0.19962947E-06_JPRB, 0.19777502E-06_JPRB, 0.19521059E-06_JPRB, 0.19206917E-06_JPRB, &
  & 0.18846232E-06_JPRB, 0.18446855E-06_JPRB, 0.18015513E-06_JPRB, 0.17559273E-06_JPRB, 0.17087096E-06_JPRB, 0.16608355E-06_JPRB, &
  & 0.16134970E-06_JPRB, 0.15678792E-06_JPRB, 0.15249569E-06_JPRB, 0.14853872E-06_JPRB, 0.14496470E-06_JPRB, 0.14181659E-06_JPRB, &
  & 0.13912690E-06_JPRB, 0.13691950E-06_JPRB, 0.13522003E-06_JPRB, 0.13404147E-06_JPRB, 0.13332767E-06_JPRB, 0.13303872E-06_JPRB, &
  & 0.13315403E-06_JPRB, 0.13370634E-06_JPRB, 0.13499813E-06_JPRB, 0.13823156E-06_JPRB /)

RGHG3(:,14, 6) = (/ &
  & 0.14483025E-06_JPRB, 0.14716311E-06_JPRB, 0.14820833E-06_JPRB, 0.14886966E-06_JPRB, 0.14954728E-06_JPRB, 0.15048680E-06_JPRB, &
  & 0.15190830E-06_JPRB, 0.15412633E-06_JPRB, 0.15728929E-06_JPRB, 0.16151405E-06_JPRB, 0.16662261E-06_JPRB, 0.17228696E-06_JPRB, &
  & 0.17803889E-06_JPRB, 0.18338258E-06_JPRB, 0.18790234E-06_JPRB, 0.19127407E-06_JPRB, 0.19329708E-06_JPRB, 0.19395483E-06_JPRB, &
  & 0.19342482E-06_JPRB, 0.19200874E-06_JPRB, 0.19008128E-06_JPRB, 0.18805540E-06_JPRB, 0.18624554E-06_JPRB, 0.18490556E-06_JPRB, &
  & 0.18414681E-06_JPRB, 0.18402987E-06_JPRB, 0.18464368E-06_JPRB, 0.18624074E-06_JPRB, 0.18892933E-06_JPRB, 0.19261255E-06_JPRB, &
  & 0.19701864E-06_JPRB, 0.20179951E-06_JPRB, 0.20639264E-06_JPRB, 0.21041186E-06_JPRB, 0.21369425E-06_JPRB, 0.21591212E-06_JPRB, &
  & 0.21700146E-06_JPRB, 0.21706494E-06_JPRB, 0.21619610E-06_JPRB, 0.21447765E-06_JPRB, 0.21201308E-06_JPRB, 0.20893322E-06_JPRB, &
  & 0.20533832E-06_JPRB, 0.20132177E-06_JPRB, 0.19697879E-06_JPRB, 0.19241256E-06_JPRB, 0.18773612E-06_JPRB, 0.18308455E-06_JPRB, &
  & 0.17860317E-06_JPRB, 0.17438731E-06_JPRB, 0.17049241E-06_JPRB, 0.16694639E-06_JPRB, 0.16376987E-06_JPRB, 0.16098315E-06_JPRB, &
  & 0.15860799E-06_JPRB, 0.15667460E-06_JPRB, 0.15521698E-06_JPRB, 0.15427651E-06_JPRB, 0.15382705E-06_JPRB, 0.15385837E-06_JPRB, &
  & 0.15439417E-06_JPRB, 0.15547647E-06_JPRB, 0.15766310E-06_JPRB, 0.16241074E-06_JPRB /)

RGHG3(:,15, 6) = (/ &
  & 0.16951513E-06_JPRB, 0.16976830E-06_JPRB, 0.16970348E-06_JPRB, 0.16969656E-06_JPRB, 0.16981987E-06_JPRB, 0.17028411E-06_JPRB, &
  & 0.17129014E-06_JPRB, 0.17307181E-06_JPRB, 0.17581236E-06_JPRB, 0.17954937E-06_JPRB, 0.18417155E-06_JPRB, 0.18930660E-06_JPRB, &
  & 0.19451036E-06_JPRB, 0.19930891E-06_JPRB, 0.20327988E-06_JPRB, 0.20620308E-06_JPRB, 0.20800223E-06_JPRB, 0.20872882E-06_JPRB, &
  & 0.20856621E-06_JPRB, 0.20776847E-06_JPRB, 0.20660718E-06_JPRB, 0.20535548E-06_JPRB, 0.20424082E-06_JPRB, 0.20341042E-06_JPRB, &
  & 0.20298567E-06_JPRB, 0.20308960E-06_JPRB, 0.20381910E-06_JPRB, 0.20523844E-06_JPRB, 0.20745307E-06_JPRB, 0.21047119E-06_JPRB, &
  & 0.21429051E-06_JPRB, 0.21832236E-06_JPRB, 0.22216790E-06_JPRB, 0.22548441E-06_JPRB, 0.22797038E-06_JPRB, 0.22973319E-06_JPRB, &
  & 0.23076672E-06_JPRB, 0.23093916E-06_JPRB, 0.23029224E-06_JPRB, 0.22890877E-06_JPRB, 0.22684574E-06_JPRB, 0.22417082E-06_JPRB, &
  & 0.22096734E-06_JPRB, 0.21732188E-06_JPRB, 0.21334236E-06_JPRB, 0.20914516E-06_JPRB, 0.20486696E-06_JPRB, 0.20067031E-06_JPRB, &
  & 0.19667738E-06_JPRB, 0.19295976E-06_JPRB, 0.18954546E-06_JPRB, 0.18645189E-06_JPRB, 0.18369084E-06_JPRB, 0.18128004E-06_JPRB, &
  & 0.17924943E-06_JPRB, 0.17763723E-06_JPRB, 0.17649532E-06_JPRB, 0.17587230E-06_JPRB, 0.17575685E-06_JPRB, 0.17615112E-06_JPRB, &
  & 0.17709057E-06_JPRB, 0.17857846E-06_JPRB, 0.18133497E-06_JPRB, 0.18673114E-06_JPRB /)

RGHG3(:,16, 6) = (/ &
  & 0.19114724E-06_JPRB, 0.19034387E-06_JPRB, 0.18938650E-06_JPRB, 0.18881994E-06_JPRB, 0.18841610E-06_JPRB, 0.18837704E-06_JPRB, &
  & 0.18883799E-06_JPRB, 0.19002290E-06_JPRB, 0.19208841E-06_JPRB, 0.19510590E-06_JPRB, 0.19897639E-06_JPRB, 0.20341010E-06_JPRB, &
  & 0.20799212E-06_JPRB, 0.21234092E-06_JPRB, 0.21609351E-06_JPRB, 0.21898553E-06_JPRB, 0.22101169E-06_JPRB, 0.22228102E-06_JPRB, &
  & 0.22295744E-06_JPRB, 0.22324497E-06_JPRB, 0.22332580E-06_JPRB, 0.22334848E-06_JPRB, 0.22343491E-06_JPRB, 0.22368505E-06_JPRB, &
  & 0.22417041E-06_JPRB, 0.22496714E-06_JPRB, 0.22614211E-06_JPRB, 0.22775535E-06_JPRB, 0.22977157E-06_JPRB, 0.23207214E-06_JPRB, &
  & 0.23431319E-06_JPRB, 0.23650092E-06_JPRB, 0.23850168E-06_JPRB, 0.24019062E-06_JPRB, 0.24154104E-06_JPRB, 0.24242490E-06_JPRB, &
  & 0.24281312E-06_JPRB, 0.24285052E-06_JPRB, 0.24244389E-06_JPRB, 0.24150631E-06_JPRB, 0.24001002E-06_JPRB, 0.23796241E-06_JPRB, &
  & 0.23539235E-06_JPRB, 0.23237023E-06_JPRB, 0.22898679E-06_JPRB, 0.22536935E-06_JPRB, 0.22168364E-06_JPRB, 0.21804773E-06_JPRB, &
  & 0.21455540E-06_JPRB, 0.21126361E-06_JPRB, 0.20821956E-06_JPRB, 0.20544626E-06_JPRB, 0.20296331E-06_JPRB, 0.20080333E-06_JPRB, &
  & 0.19901114E-06_JPRB, 0.19763577E-06_JPRB, 0.19673044E-06_JPRB, 0.19634193E-06_JPRB, 0.19646049E-06_JPRB, 0.19707062E-06_JPRB, &
  & 0.19818887E-06_JPRB, 0.19981735E-06_JPRB, 0.20260768E-06_JPRB, 0.20781395E-06_JPRB /)

RGHG3(:,17, 6) = (/ &
  & 0.20913529E-06_JPRB, 0.20761398E-06_JPRB, 0.20621498E-06_JPRB, 0.20530931E-06_JPRB, 0.20458921E-06_JPRB, 0.20417941E-06_JPRB, &
  & 0.20421220E-06_JPRB, 0.20486931E-06_JPRB, 0.20631265E-06_JPRB, 0.20862004E-06_JPRB, 0.21177453E-06_JPRB, 0.21553515E-06_JPRB, &
  & 0.21957820E-06_JPRB, 0.22355935E-06_JPRB, 0.22724424E-06_JPRB, 0.23042490E-06_JPRB, 0.23299452E-06_JPRB, 0.23505125E-06_JPRB, &
  & 0.23675904E-06_JPRB, 0.23825204E-06_JPRB, 0.23964409E-06_JPRB, 0.24102619E-06_JPRB, 0.24247038E-06_JPRB, 0.24403261E-06_JPRB, &
  & 0.24571966E-06_JPRB, 0.24750017E-06_JPRB, 0.24925981E-06_JPRB, 0.25087934E-06_JPRB, 0.25219470E-06_JPRB, 0.25321057E-06_JPRB, &
  & 0.25384188E-06_JPRB, 0.25414036E-06_JPRB, 0.25416870E-06_JPRB, 0.25403165E-06_JPRB, 0.25383690E-06_JPRB, 0.25369707E-06_JPRB, &
  & 0.25361334E-06_JPRB, 0.25345412E-06_JPRB, 0.25315839E-06_JPRB, 0.25262770E-06_JPRB, 0.25172289E-06_JPRB, 0.25035723E-06_JPRB, &
  & 0.24849612E-06_JPRB, 0.24617100E-06_JPRB, 0.24345235E-06_JPRB, 0.24047819E-06_JPRB, 0.23737432E-06_JPRB, 0.23423469E-06_JPRB, &
  & 0.23113445E-06_JPRB, 0.22814828E-06_JPRB, 0.22533300E-06_JPRB, 0.22273338E-06_JPRB, 0.22039009E-06_JPRB, 0.21835723E-06_JPRB, &
  & 0.21669005E-06_JPRB, 0.21544021E-06_JPRB, 0.21465556E-06_JPRB, 0.21436966E-06_JPRB, 0.21455860E-06_JPRB, 0.21519489E-06_JPRB, &
  & 0.21626160E-06_JPRB, 0.21780080E-06_JPRB, 0.22019157E-06_JPRB, 0.22475092E-06_JPRB /)

RGHG3(:,18, 6) = (/ &
  & 0.22356893E-06_JPRB, 0.22160415E-06_JPRB, 0.22018605E-06_JPRB, 0.21912055E-06_JPRB, 0.21826588E-06_JPRB, 0.21765183E-06_JPRB, &
  & 0.21740871E-06_JPRB, 0.21769469E-06_JPRB, 0.21865191E-06_JPRB, 0.22041992E-06_JPRB, 0.22297243E-06_JPRB, 0.22617412E-06_JPRB, &
  & 0.22979158E-06_JPRB, 0.23354208E-06_JPRB, 0.23716672E-06_JPRB, 0.24054276E-06_JPRB, 0.24361324E-06_JPRB, 0.24635841E-06_JPRB, &
  & 0.24884216E-06_JPRB, 0.25117495E-06_JPRB, 0.25345176E-06_JPRB, 0.25574676E-06_JPRB, 0.25811008E-06_JPRB, 0.26056026E-06_JPRB, &
  & 0.26303576E-06_JPRB, 0.26538743E-06_JPRB, 0.26745130E-06_JPRB, 0.26905275E-06_JPRB, 0.27003142E-06_JPRB, 0.27031695E-06_JPRB, &
  & 0.26993501E-06_JPRB, 0.26901867E-06_JPRB, 0.26771551E-06_JPRB, 0.26626000E-06_JPRB, 0.26485822E-06_JPRB, 0.26374059E-06_JPRB, &
  & 0.26302496E-06_JPRB, 0.26270160E-06_JPRB, 0.26256936E-06_JPRB, 0.26241995E-06_JPRB, 0.26204034E-06_JPRB, 0.26127231E-06_JPRB, &
  & 0.26004460E-06_JPRB, 0.25835243E-06_JPRB, 0.25625894E-06_JPRB, 0.25386038E-06_JPRB, 0.25125013E-06_JPRB, 0.24848123E-06_JPRB, &
  & 0.24566990E-06_JPRB, 0.24290838E-06_JPRB, 0.24025559E-06_JPRB, 0.23776012E-06_JPRB, 0.23548662E-06_JPRB, 0.23350810E-06_JPRB, &
  & 0.23188872E-06_JPRB, 0.23068060E-06_JPRB, 0.22991614E-06_JPRB, 0.22961231E-06_JPRB, 0.22973538E-06_JPRB, 0.23024887E-06_JPRB, &
  & 0.23112457E-06_JPRB, 0.23238728E-06_JPRB, 0.23423017E-06_JPRB, 0.23798084E-06_JPRB /)

RGHG3(:,19, 6) = (/ &
  & 0.23515979E-06_JPRB, 0.23308520E-06_JPRB, 0.23175701E-06_JPRB, 0.23070700E-06_JPRB, 0.22982300E-06_JPRB, 0.22913339E-06_JPRB, &
  & 0.22872993E-06_JPRB, 0.22875970E-06_JPRB, 0.22938565E-06_JPRB, 0.23073594E-06_JPRB, 0.23282270E-06_JPRB, 0.23554306E-06_JPRB, &
  & 0.23873341E-06_JPRB, 0.24221208E-06_JPRB, 0.24578267E-06_JPRB, 0.24925328E-06_JPRB, 0.25251992E-06_JPRB, 0.25556184E-06_JPRB, &
  & 0.25839734E-06_JPRB, 0.26108609E-06_JPRB, 0.26372462E-06_JPRB, 0.26639637E-06_JPRB, 0.26914762E-06_JPRB, 0.27197549E-06_JPRB, &
  & 0.27478669E-06_JPRB, 0.27741731E-06_JPRB, 0.27965083E-06_JPRB, 0.28126681E-06_JPRB, 0.28214006E-06_JPRB, 0.28221908E-06_JPRB, &
  & 0.28156020E-06_JPRB, 0.28025153E-06_JPRB, 0.27845593E-06_JPRB, 0.27644415E-06_JPRB, 0.27449903E-06_JPRB, 0.27287322E-06_JPRB, &
  & 0.27178390E-06_JPRB, 0.27123755E-06_JPRB, 0.27111412E-06_JPRB, 0.27114910E-06_JPRB, 0.27108482E-06_JPRB, 0.27072485E-06_JPRB, &
  & 0.26994678E-06_JPRB, 0.26872240E-06_JPRB, 0.26709054E-06_JPRB, 0.26511432E-06_JPRB, 0.26284596E-06_JPRB, 0.26038552E-06_JPRB, &
  & 0.25784129E-06_JPRB, 0.25529093E-06_JPRB, 0.25277933E-06_JPRB, 0.25037602E-06_JPRB, 0.24816504E-06_JPRB, 0.24622483E-06_JPRB, &
  & 0.24462457E-06_JPRB, 0.24341327E-06_JPRB, 0.24261300E-06_JPRB, 0.24222544E-06_JPRB, 0.24220964E-06_JPRB, 0.24252535E-06_JPRB, &
  & 0.24314011E-06_JPRB, 0.24406023E-06_JPRB, 0.24541743E-06_JPRB, 0.24829552E-06_JPRB /)

RGHG3(:,20, 6) = (/ &
  & 0.24465371E-06_JPRB, 0.24266700E-06_JPRB, 0.24148343E-06_JPRB, 0.24052164E-06_JPRB, 0.23969059E-06_JPRB, 0.23899776E-06_JPRB, &
  & 0.23852658E-06_JPRB, 0.23840944E-06_JPRB, 0.23881566E-06_JPRB, 0.23985879E-06_JPRB, 0.24156773E-06_JPRB, 0.24388871E-06_JPRB, &
  & 0.24669816E-06_JPRB, 0.24983163E-06_JPRB, 0.25313918E-06_JPRB, 0.25647796E-06_JPRB, 0.25971701E-06_JPRB, 0.26277502E-06_JPRB, &
  & 0.26565601E-06_JPRB, 0.26840490E-06_JPRB, 0.27109016E-06_JPRB, 0.27379855E-06_JPRB, 0.27658672E-06_JPRB, 0.27945714E-06_JPRB, &
  & 0.28232625E-06_JPRB, 0.28500691E-06_JPRB, 0.28728681E-06_JPRB, 0.28896392E-06_JPRB, 0.28992943E-06_JPRB, 0.29014288E-06_JPRB, &
  & 0.28964058E-06_JPRB, 0.28847364E-06_JPRB, 0.28677442E-06_JPRB, 0.28477112E-06_JPRB, 0.28274567E-06_JPRB, 0.28099936E-06_JPRB, &
  & 0.27975716E-06_JPRB, 0.27909425E-06_JPRB, 0.27891016E-06_JPRB, 0.27895697E-06_JPRB, 0.27898241E-06_JPRB, 0.27877513E-06_JPRB, &
  & 0.27821426E-06_JPRB, 0.27725235E-06_JPRB, 0.27588970E-06_JPRB, 0.27416013E-06_JPRB, 0.27214023E-06_JPRB, 0.26993169E-06_JPRB, &
  & 0.26761438E-06_JPRB, 0.26523912E-06_JPRB, 0.26286762E-06_JPRB, 0.26059558E-06_JPRB, 0.25849090E-06_JPRB, 0.25663107E-06_JPRB, &
  & 0.25507947E-06_JPRB, 0.25387760E-06_JPRB, 0.25303984E-06_JPRB, 0.25256116E-06_JPRB, 0.25239785E-06_JPRB, 0.25250912E-06_JPRB, &
  & 0.25286712E-06_JPRB, 0.25347234E-06_JPRB, 0.25442242E-06_JPRB, 0.25644144E-06_JPRB /)

RGHG3(:,21, 6) = (/ &
  & 0.25266237E-06_JPRB, 0.25084537E-06_JPRB, 0.24980409E-06_JPRB, 0.24895414E-06_JPRB, 0.24820687E-06_JPRB, 0.24756221E-06_JPRB, &
  & 0.24708544E-06_JPRB, 0.24691482E-06_JPRB, 0.24719074E-06_JPRB, 0.24801432E-06_JPRB, 0.24942651E-06_JPRB, 0.25139818E-06_JPRB, &
  & 0.25383733E-06_JPRB, 0.25662700E-06_JPRB, 0.25962100E-06_JPRB, 0.26268239E-06_JPRB, 0.26570171E-06_JPRB, 0.26860249E-06_JPRB, &
  & 0.27135042E-06_JPRB, 0.27398090E-06_JPRB, 0.27655705E-06_JPRB, 0.27914908E-06_JPRB, 0.28182004E-06_JPRB, 0.28458109E-06_JPRB, &
  & 0.28734325E-06_JPRB, 0.28996755E-06_JPRB, 0.29223594E-06_JPRB, 0.29396594E-06_JPRB, 0.29507453E-06_JPRB, 0.29553559E-06_JPRB, &
  & 0.29535514E-06_JPRB, 0.29456760E-06_JPRB, 0.29327262E-06_JPRB, 0.29162544E-06_JPRB, 0.28988381E-06_JPRB, 0.28829965E-06_JPRB, &
  & 0.28709928E-06_JPRB, 0.28638399E-06_JPRB, 0.28604771E-06_JPRB, 0.28596554E-06_JPRB, 0.28588153E-06_JPRB, 0.28562184E-06_JPRB, &
  & 0.28505292E-06_JPRB, 0.28413010E-06_JPRB, 0.28285496E-06_JPRB, 0.28126902E-06_JPRB, 0.27943850E-06_JPRB, 0.27743056E-06_JPRB, &
  & 0.27528742E-06_JPRB, 0.27307280E-06_JPRB, 0.27088413E-06_JPRB, 0.26877490E-06_JPRB, 0.26681812E-06_JPRB, 0.26508607E-06_JPRB, &
  & 0.26362457E-06_JPRB, 0.26245866E-06_JPRB, 0.26159819E-06_JPRB, 0.26103908E-06_JPRB, 0.26074491E-06_JPRB, 0.26067863E-06_JPRB, &
  & 0.26081062E-06_JPRB, 0.26113702E-06_JPRB, 0.26172117E-06_JPRB, 0.26306779E-06_JPRB /)

RGHG3(:,22, 6) = (/ &
  & 0.25945073E-06_JPRB, 0.25787330E-06_JPRB, 0.25698009E-06_JPRB, 0.25625457E-06_JPRB, 0.25561204E-06_JPRB, 0.25505065E-06_JPRB, &
  & 0.25463689E-06_JPRB, 0.25447878E-06_JPRB, 0.25470462E-06_JPRB, 0.25540913E-06_JPRB, 0.25662834E-06_JPRB, 0.25833964E-06_JPRB, &
  & 0.26047519E-06_JPRB, 0.26292793E-06_JPRB, 0.26558911E-06_JPRB, 0.26833911E-06_JPRB, 0.27107006E-06_JPRB, 0.27371362E-06_JPRB, &
  & 0.27625262E-06_JPRB, 0.27869794E-06_JPRB, 0.28110097E-06_JPRB, 0.28352190E-06_JPRB, 0.28599868E-06_JPRB, 0.28853941E-06_JPRB, &
  & 0.29109984E-06_JPRB, 0.29353734E-06_JPRB, 0.29569708E-06_JPRB, 0.29744965E-06_JPRB, 0.29868519E-06_JPRB, 0.29937576E-06_JPRB, &
  & 0.29952838E-06_JPRB, 0.29916913E-06_JPRB, 0.29836320E-06_JPRB, 0.29722972E-06_JPRB, 0.29594287E-06_JPRB, 0.29472048E-06_JPRB, &
  & 0.29368533E-06_JPRB, 0.29295805E-06_JPRB, 0.29250441E-06_JPRB, 0.29219763E-06_JPRB, 0.29188712E-06_JPRB, 0.29144076E-06_JPRB, &
  & 0.29075824E-06_JPRB, 0.28977976E-06_JPRB, 0.28850710E-06_JPRB, 0.28697821E-06_JPRB, 0.28524209E-06_JPRB, 0.28333474E-06_JPRB, &
  & 0.28132317E-06_JPRB, 0.27929099E-06_JPRB, 0.27727748E-06_JPRB, 0.27534517E-06_JPRB, 0.27356782E-06_JPRB, 0.27198917E-06_JPRB, &
  & 0.27063720E-06_JPRB, 0.26952466E-06_JPRB, 0.26865592E-06_JPRB, 0.26803082E-06_JPRB, 0.26762643E-06_JPRB, 0.26741571E-06_JPRB, &
  & 0.26737425E-06_JPRB, 0.26749026E-06_JPRB, 0.26779654E-06_JPRB, 0.26860380E-06_JPRB /)

RGHG3(:,23, 6) = (/ &
  & 0.26528403E-06_JPRB, 0.26393812E-06_JPRB, 0.26320018E-06_JPRB, 0.26260480E-06_JPRB, 0.26208667E-06_JPRB, 0.26164503E-06_JPRB, &
  & 0.26133191E-06_JPRB, 0.26124908E-06_JPRB, 0.26150320E-06_JPRB, 0.26217427E-06_JPRB, 0.26329596E-06_JPRB, 0.26484963E-06_JPRB, &
  & 0.26677233E-06_JPRB, 0.26897573E-06_JPRB, 0.27135474E-06_JPRB, 0.27381105E-06_JPRB, 0.27626160E-06_JPRB, 0.27864812E-06_JPRB, &
  & 0.28094507E-06_JPRB, 0.28317493E-06_JPRB, 0.28536061E-06_JPRB, 0.28753419E-06_JPRB, 0.28974469E-06_JPRB, 0.29200422E-06_JPRB, &
  & 0.29426718E-06_JPRB, 0.29646094E-06_JPRB, 0.29844585E-06_JPRB, 0.30009622E-06_JPRB, 0.30137335E-06_JPRB, 0.30223288E-06_JPRB, &
  & 0.30266077E-06_JPRB, 0.30267617E-06_JPRB, 0.30232314E-06_JPRB, 0.30168965E-06_JPRB, 0.30087210E-06_JPRB, 0.30004216E-06_JPRB, &
  & 0.29925195E-06_JPRB, 0.29857975E-06_JPRB, 0.29801691E-06_JPRB, 0.29749418E-06_JPRB, 0.29693530E-06_JPRB, 0.29625059E-06_JPRB, &
  & 0.29538307E-06_JPRB, 0.29430296E-06_JPRB, 0.29299710E-06_JPRB, 0.29147583E-06_JPRB, 0.28976811E-06_JPRB, 0.28794233E-06_JPRB, &
  & 0.28607337E-06_JPRB, 0.28419842E-06_JPRB, 0.28237042E-06_JPRB, 0.28065296E-06_JPRB, 0.27907188E-06_JPRB, 0.27765725E-06_JPRB, &
  & 0.27642491E-06_JPRB, 0.27538078E-06_JPRB, 0.27452629E-06_JPRB, 0.27386264E-06_JPRB, 0.27337666E-06_JPRB, 0.27305200E-06_JPRB, &
  & 0.27287217E-06_JPRB, 0.27282388E-06_JPRB, 0.27291668E-06_JPRB, 0.27332194E-06_JPRB /)

RGHG3(:,24, 6) = (/ &
  & 0.27027431E-06_JPRB, 0.26919088E-06_JPRB, 0.26860280E-06_JPRB, 0.26814470E-06_JPRB, 0.26776019E-06_JPRB, 0.26745212E-06_JPRB, &
  & 0.26727122E-06_JPRB, 0.26730481E-06_JPRB, 0.26764641E-06_JPRB, 0.26836193E-06_JPRB, 0.26947345E-06_JPRB, 0.27095894E-06_JPRB, &
  & 0.27275917E-06_JPRB, 0.27479311E-06_JPRB, 0.27696859E-06_JPRB, 0.27919793E-06_JPRB, 0.28140735E-06_JPRB, 0.28355737E-06_JPRB, &
  & 0.28562599E-06_JPRB, 0.28761480E-06_JPRB, 0.28955182E-06_JPRB, 0.29146454E-06_JPRB, 0.29336724E-06_JPRB, 0.29527340E-06_JPRB, &
  & 0.29717191E-06_JPRB, 0.29901449E-06_JPRB, 0.30074702E-06_JPRB, 0.30227935E-06_JPRB, 0.30352061E-06_JPRB, 0.30445509E-06_JPRB, &
  & 0.30506612E-06_JPRB, 0.30535776E-06_JPRB, 0.30535551E-06_JPRB, 0.30511123E-06_JPRB, 0.30468129E-06_JPRB, 0.30415521E-06_JPRB, &
  & 0.30357828E-06_JPRB, 0.30298864E-06_JPRB, 0.30237214E-06_JPRB, 0.30171574E-06_JPRB, 0.30096606E-06_JPRB, 0.30008502E-06_JPRB, &
  & 0.29904049E-06_JPRB, 0.29781984E-06_JPRB, 0.29642572E-06_JPRB, 0.29488010E-06_JPRB, 0.29322777E-06_JPRB, 0.29152349E-06_JPRB, &
  & 0.28980546E-06_JPRB, 0.28812295E-06_JPRB, 0.28652124E-06_JPRB, 0.28501205E-06_JPRB, 0.28362089E-06_JPRB, 0.28236548E-06_JPRB, &
  & 0.28125189E-06_JPRB, 0.28028271E-06_JPRB, 0.27945916E-06_JPRB, 0.27878417E-06_JPRB, 0.27825081E-06_JPRB, 0.27784955E-06_JPRB, &
  & 0.27756886E-06_JPRB, 0.27739574E-06_JPRB, 0.27732304E-06_JPRB, 0.27741578E-06_JPRB /)

RGHG3(:,25, 6) = (/ &
  & 0.27460646E-06_JPRB, 0.27376311E-06_JPRB, 0.27331723E-06_JPRB, 0.27299183E-06_JPRB, 0.27273668E-06_JPRB, 0.27256394E-06_JPRB, &
  & 0.27252196E-06_JPRB, 0.27269152E-06_JPRB, 0.27315204E-06_JPRB, 0.27395288E-06_JPRB, 0.27510481E-06_JPRB, 0.27658024E-06_JPRB, &
  & 0.27832317E-06_JPRB, 0.28025175E-06_JPRB, 0.28228550E-06_JPRB, 0.28434408E-06_JPRB, 0.28636620E-06_JPRB, 0.28831147E-06_JPRB, &
  & 0.29016601E-06_JPRB, 0.29193745E-06_JPRB, 0.29363252E-06_JPRB, 0.29526214E-06_JPRB, 0.29683895E-06_JPRB, 0.29839254E-06_JPRB, &
  & 0.29992157E-06_JPRB, 0.30141493E-06_JPRB, 0.30283863E-06_JPRB, 0.30414927E-06_JPRB, 0.30530336E-06_JPRB, 0.30624585E-06_JPRB, &
  & 0.30695571E-06_JPRB, 0.30742231E-06_JPRB, 0.30765420E-06_JPRB, 0.30767228E-06_JPRB, 0.30751110E-06_JPRB, 0.30720449E-06_JPRB, &
  & 0.30678305E-06_JPRB, 0.30626046E-06_JPRB, 0.30563541E-06_JPRB, 0.30489895E-06_JPRB, 0.30403979E-06_JPRB, 0.30303809E-06_JPRB, &
  & 0.30188818E-06_JPRB, 0.30058976E-06_JPRB, 0.29916072E-06_JPRB, 0.29763373E-06_JPRB, 0.29605371E-06_JPRB, 0.29446056E-06_JPRB, &
  & 0.29290268E-06_JPRB, 0.29141029E-06_JPRB, 0.28999182E-06_JPRB, 0.28866828E-06_JPRB, 0.28745021E-06_JPRB, 0.28633841E-06_JPRB, &
  & 0.28533611E-06_JPRB, 0.28444234E-06_JPRB, 0.28365855E-06_JPRB, 0.28298979E-06_JPRB, 0.28243389E-06_JPRB, 0.28198693E-06_JPRB, &
  & 0.28164121E-06_JPRB, 0.28138365E-06_JPRB, 0.28119536E-06_JPRB, 0.28105029E-06_JPRB /)

RGHG3(:,26, 6) = (/ &
  & 0.27837677E-06_JPRB, 0.27775999E-06_JPRB, 0.27745872E-06_JPRB, 0.27724852E-06_JPRB, 0.27711110E-06_JPRB, 0.27706105E-06_JPRB, &
  & 0.27714881E-06_JPRB, 0.27744650E-06_JPRB, 0.27802278E-06_JPRB, 0.27891213E-06_JPRB, 0.28011345E-06_JPRB, 0.28159880E-06_JPRB, &
  & 0.28330598E-06_JPRB, 0.28516325E-06_JPRB, 0.28709013E-06_JPRB, 0.28901650E-06_JPRB, 0.29088645E-06_JPRB, 0.29266624E-06_JPRB, &
  & 0.29434210E-06_JPRB, 0.29591445E-06_JPRB, 0.29738578E-06_JPRB, 0.29875494E-06_JPRB, 0.30004563E-06_JPRB, 0.30128302E-06_JPRB, &
  & 0.30247449E-06_JPRB, 0.30363020E-06_JPRB, 0.30475189E-06_JPRB, 0.30583232E-06_JPRB, 0.30683967E-06_JPRB, 0.30773833E-06_JPRB, &
  & 0.30847968E-06_JPRB, 0.30903823E-06_JPRB, 0.30940353E-06_JPRB, 0.30957659E-06_JPRB, 0.30957071E-06_JPRB, 0.30939808E-06_JPRB, &
  & 0.30907191E-06_JPRB, 0.30859533E-06_JPRB, 0.30798122E-06_JPRB, 0.30721256E-06_JPRB, 0.30630673E-06_JPRB, 0.30525376E-06_JPRB, &
  & 0.30406909E-06_JPRB, 0.30276121E-06_JPRB, 0.30135695E-06_JPRB, 0.29988911E-06_JPRB, 0.29839856E-06_JPRB, 0.29693530E-06_JPRB, &
  & 0.29553198E-06_JPRB, 0.29420440E-06_JPRB, 0.29296370E-06_JPRB, 0.29181197E-06_JPRB, 0.29074377E-06_JPRB, 0.28976231E-06_JPRB, &
  & 0.28886188E-06_JPRB, 0.28804169E-06_JPRB, 0.28730264E-06_JPRB, 0.28665050E-06_JPRB, 0.28608738E-06_JPRB, 0.28561391E-06_JPRB, &
  & 0.28522646E-06_JPRB, 0.28491286E-06_JPRB, 0.28464621E-06_JPRB, 0.28434846E-06_JPRB /)

RGHG3(:,27, 6) = (/ &
  & 0.28170223E-06_JPRB, 0.28130407E-06_JPRB, 0.28110858E-06_JPRB, 0.28100047E-06_JPRB, 0.28095923E-06_JPRB, 0.28100993E-06_JPRB, &
  & 0.28120175E-06_JPRB, 0.28160605E-06_JPRB, 0.28227302E-06_JPRB, 0.28322981E-06_JPRB, 0.28446829E-06_JPRB, 0.28595002E-06_JPRB, &
  & 0.28762179E-06_JPRB, 0.28941020E-06_JPRB, 0.29124644E-06_JPRB, 0.29306204E-06_JPRB, 0.29480776E-06_JPRB, 0.29645059E-06_JPRB, &
  & 0.29797746E-06_JPRB, 0.29938576E-06_JPRB, 0.30066946E-06_JPRB, 0.30183170E-06_JPRB, 0.30289064E-06_JPRB, 0.30386732E-06_JPRB, &
  & 0.30478284E-06_JPRB, 0.30565641E-06_JPRB, 0.30652043E-06_JPRB, 0.30738454E-06_JPRB, 0.30823483E-06_JPRB, 0.30903925E-06_JPRB, &
  & 0.30975355E-06_JPRB, 0.31033778E-06_JPRB, 0.31076269E-06_JPRB, 0.31101291E-06_JPRB, 0.31108544E-06_JPRB, 0.31098213E-06_JPRB, &
  & 0.31070647E-06_JPRB, 0.31026002E-06_JPRB, 0.30965452E-06_JPRB, 0.30889143E-06_JPRB, 0.30797082E-06_JPRB, 0.30691788E-06_JPRB, &
  & 0.30574085E-06_JPRB, 0.30446790E-06_JPRB, 0.30312319E-06_JPRB, 0.30174616E-06_JPRB, 0.30037967E-06_JPRB, 0.29906283E-06_JPRB, &
  & 0.29782117E-06_JPRB, 0.29666131E-06_JPRB, 0.29558080E-06_JPRB, 0.29457465E-06_JPRB, 0.29364054E-06_JPRB, 0.29277123E-06_JPRB, &
  & 0.29196238E-06_JPRB, 0.29121199E-06_JPRB, 0.29052131E-06_JPRB, 0.28989621E-06_JPRB, 0.28934070E-06_JPRB, 0.28885884E-06_JPRB, &
  & 0.28845068E-06_JPRB, 0.28810501E-06_JPRB, 0.28779078E-06_JPRB, 0.28739373E-06_JPRB /)

RGHG3(:,28, 6) = (/ &
  & 0.28469537E-06_JPRB, 0.28442992E-06_JPRB, 0.28433243E-06_JPRB, 0.28429923E-06_JPRB, 0.28433277E-06_JPRB, 0.28445967E-06_JPRB, &
  & 0.28473349E-06_JPRB, 0.28520935E-06_JPRB, 0.28594221E-06_JPRB, 0.28694024E-06_JPRB, 0.28818698E-06_JPRB, 0.28965118E-06_JPRB, &
  & 0.29127256E-06_JPRB, 0.29299247E-06_JPRB, 0.29474046E-06_JPRB, 0.29645935E-06_JPRB, 0.29809848E-06_JPRB, 0.29962931E-06_JPRB, &
  & 0.30103601E-06_JPRB, 0.30231266E-06_JPRB, 0.30345268E-06_JPRB, 0.30445833E-06_JPRB, 0.30534122E-06_JPRB, 0.30612108E-06_JPRB, &
  & 0.30682421E-06_JPRB, 0.30747950E-06_JPRB, 0.30812953E-06_JPRB, 0.30880034E-06_JPRB, 0.30949568E-06_JPRB, 0.31019587E-06_JPRB, &
  & 0.31085210E-06_JPRB, 0.31141758E-06_JPRB, 0.31185266E-06_JPRB, 0.31212980E-06_JPRB, 0.31223499E-06_JPRB, 0.31216283E-06_JPRB, &
  & 0.31191306E-06_JPRB, 0.31148761E-06_JPRB, 0.31089365E-06_JPRB, 0.31014531E-06_JPRB, 0.30924545E-06_JPRB, 0.30821411E-06_JPRB, &
  & 0.30708213E-06_JPRB, 0.30587177E-06_JPRB, 0.30461729E-06_JPRB, 0.30335832E-06_JPRB, 0.30213141E-06_JPRB, 0.30097172E-06_JPRB, &
  & 0.29988891E-06_JPRB, 0.29888170E-06_JPRB, 0.29794131E-06_JPRB, 0.29706305E-06_JPRB, 0.29623843E-06_JPRB, 0.29546283E-06_JPRB, &
  & 0.29473199E-06_JPRB, 0.29404407E-06_JPRB, 0.29340040E-06_JPRB, 0.29280639E-06_JPRB, 0.29226621E-06_JPRB, 0.29178506E-06_JPRB, &
  & 0.29136447E-06_JPRB, 0.29099311E-06_JPRB, 0.29063179E-06_JPRB, 0.29010491E-06_JPRB /)

RGHG3(:,29, 6) = (/ &
  & 0.28733484E-06_JPRB, 0.28719313E-06_JPRB, 0.28716198E-06_JPRB, 0.28718642E-06_JPRB, 0.28727570E-06_JPRB, 0.28745984E-06_JPRB, &
  & 0.28778578E-06_JPRB, 0.28832008E-06_JPRB, 0.28908903E-06_JPRB, 0.29010320E-06_JPRB, 0.29134355E-06_JPRB, 0.29276953E-06_JPRB, &
  & 0.29433610E-06_JPRB, 0.29598070E-06_JPRB, 0.29764573E-06_JPRB, 0.29927347E-06_JPRB, 0.30082077E-06_JPRB, 0.30225723E-06_JPRB, &
  & 0.30356685E-06_JPRB, 0.30474015E-06_JPRB, 0.30577195E-06_JPRB, 0.30666112E-06_JPRB, 0.30741512E-06_JPRB, 0.30805450E-06_JPRB, &
  & 0.30860505E-06_JPRB, 0.30910013E-06_JPRB, 0.30958890E-06_JPRB, 0.31010174E-06_JPRB, 0.31065628E-06_JPRB, 0.31124284E-06_JPRB, &
  & 0.31182466E-06_JPRB, 0.31234526E-06_JPRB, 0.31275928E-06_JPRB, 0.31303205E-06_JPRB, 0.31314210E-06_JPRB, 0.31308048E-06_JPRB, &
  & 0.31284657E-06_JPRB, 0.31244076E-06_JPRB, 0.31187014E-06_JPRB, 0.31114593E-06_JPRB, 0.31028605E-06_JPRB, 0.30930687E-06_JPRB, &
  & 0.30824151E-06_JPRB, 0.30711865E-06_JPRB, 0.30598119E-06_JPRB, 0.30485253E-06_JPRB, 0.30377109E-06_JPRB, 0.30275689E-06_JPRB, &
  & 0.30181693E-06_JPRB, 0.30093867E-06_JPRB, 0.30011358E-06_JPRB, 0.29933443E-06_JPRB, 0.29859635E-06_JPRB, 0.29789544E-06_JPRB, &
  & 0.29722753E-06_JPRB, 0.29659316E-06_JPRB, 0.29599252E-06_JPRB, 0.29543060E-06_JPRB, 0.29491093E-06_JPRB, 0.29443893E-06_JPRB, &
  & 0.29401852E-06_JPRB, 0.29363986E-06_JPRB, 0.29326804E-06_JPRB, 0.29274608E-06_JPRB /)

RGHG3(:,30, 6) = (/ &
  & 0.28966960E-06_JPRB, 0.28962114E-06_JPRB, 0.28964180E-06_JPRB, 0.28971107E-06_JPRB, 0.28984087E-06_JPRB, 0.29006446E-06_JPRB, &
  & 0.29043585E-06_JPRB, 0.29099834E-06_JPRB, 0.29179117E-06_JPRB, 0.29280676E-06_JPRB, 0.29402173E-06_JPRB, 0.29540567E-06_JPRB, &
  & 0.29690742E-06_JPRB, 0.29847794E-06_JPRB, 0.30005990E-06_JPRB, 0.30160402E-06_JPRB, 0.30306879E-06_JPRB, 0.30442476E-06_JPRB, &
  & 0.30565485E-06_JPRB, 0.30674715E-06_JPRB, 0.30769462E-06_JPRB, 0.30849611E-06_JPRB, 0.30915760E-06_JPRB, 0.30969773E-06_JPRB, &
  & 0.31014292E-06_JPRB, 0.31052699E-06_JPRB, 0.31089695E-06_JPRB, 0.31128943E-06_JPRB, 0.31172894E-06_JPRB, 0.31220983E-06_JPRB, &
  & 0.31270596E-06_JPRB, 0.31316551E-06_JPRB, 0.31353960E-06_JPRB, 0.31378934E-06_JPRB, 0.31388913E-06_JPRB, 0.31382777E-06_JPRB, &
  & 0.31360469E-06_JPRB, 0.31322332E-06_JPRB, 0.31268721E-06_JPRB, 0.31200909E-06_JPRB, 0.31120237E-06_JPRB, 0.31029512E-06_JPRB, &
  & 0.30932333E-06_JPRB, 0.30831066E-06_JPRB, 0.30729359E-06_JPRB, 0.30629531E-06_JPRB, 0.30534628E-06_JPRB, 0.30446438E-06_JPRB, &
  & 0.30363753E-06_JPRB, 0.30286162E-06_JPRB, 0.30212664E-06_JPRB, 0.30142161E-06_JPRB, 0.30074852E-06_JPRB, 0.30010409E-06_JPRB, &
  & 0.29948680E-06_JPRB, 0.29889699E-06_JPRB, 0.29833552E-06_JPRB, 0.29780574E-06_JPRB, 0.29731089E-06_JPRB, 0.29685629E-06_JPRB, &
  & 0.29644607E-06_JPRB, 0.29607182E-06_JPRB, 0.29569767E-06_JPRB, 0.29514246E-06_JPRB /)

RGHG3(:,31, 6) = (/ &
  & 0.29174441E-06_JPRB, 0.29177181E-06_JPRB, 0.29183531E-06_JPRB, 0.29193600E-06_JPRB, 0.29209792E-06_JPRB, 0.29235403E-06_JPRB, &
  & 0.29274844E-06_JPRB, 0.29333660E-06_JPRB, 0.29413243E-06_JPRB, 0.29513322E-06_JPRB, 0.29631772E-06_JPRB, 0.29764777E-06_JPRB, &
  & 0.29908657E-06_JPRB, 0.30057882E-06_JPRB, 0.30208065E-06_JPRB, 0.30354349E-06_JPRB, 0.30493257E-06_JPRB, 0.30621715E-06_JPRB, &
  & 0.30738013E-06_JPRB, 0.30840681E-06_JPRB, 0.30928896E-06_JPRB, 0.31002395E-06_JPRB, 0.31061850E-06_JPRB, 0.31109059E-06_JPRB, &
  & 0.31146465E-06_JPRB, 0.31177569E-06_JPRB, 0.31206437E-06_JPRB, 0.31236758E-06_JPRB, 0.31271327E-06_JPRB, 0.31310205E-06_JPRB, &
  & 0.31351425E-06_JPRB, 0.31390570E-06_JPRB, 0.31422854E-06_JPRB, 0.31444267E-06_JPRB, 0.31452367E-06_JPRB, 0.31446010E-06_JPRB, &
  & 0.31425023E-06_JPRB, 0.31389797E-06_JPRB, 0.31340977E-06_JPRB, 0.31279134E-06_JPRB, 0.31206230E-06_JPRB, 0.31124333E-06_JPRB, &
  & 0.31037382E-06_JPRB, 0.30947956E-06_JPRB, 0.30858274E-06_JPRB, 0.30771281E-06_JPRB, 0.30687335E-06_JPRB, 0.30609425E-06_JPRB, &
  & 0.30535924E-06_JPRB, 0.30465839E-06_JPRB, 0.30398581E-06_JPRB, 0.30333607E-06_JPRB, 0.30271059E-06_JPRB, 0.30210930E-06_JPRB, &
  & 0.30153254E-06_JPRB, 0.30098019E-06_JPRB, 0.30045373E-06_JPRB, 0.29995559E-06_JPRB, 0.29948811E-06_JPRB, 0.29905542E-06_JPRB, &
  & 0.29866081E-06_JPRB, 0.29829579E-06_JPRB, 0.29792497E-06_JPRB, 0.29736140E-06_JPRB /)

RGHG3(:,32, 6) = (/ &
  & 0.29361451E-06_JPRB, 0.29370520E-06_JPRB, 0.29379726E-06_JPRB, 0.29392882E-06_JPRB, 0.29411598E-06_JPRB, 0.29439502E-06_JPRB, &
  & 0.29481282E-06_JPRB, 0.29540419E-06_JPRB, 0.29619264E-06_JPRB, 0.29716767E-06_JPRB, 0.29830625E-06_JPRB, 0.29958107E-06_JPRB, &
  & 0.30094816E-06_JPRB, 0.30236581E-06_JPRB, 0.30378621E-06_JPRB, 0.30517162E-06_JPRB, 0.30648982E-06_JPRB, 0.30770883E-06_JPRB, &
  & 0.30881264E-06_JPRB, 0.30978455E-06_JPRB, 0.31061447E-06_JPRB, 0.31129977E-06_JPRB, 0.31184635E-06_JPRB, 0.31227211E-06_JPRB, &
  & 0.31260075E-06_JPRB, 0.31286322E-06_JPRB, 0.31309949E-06_JPRB, 0.31333883E-06_JPRB, 0.31361225E-06_JPRB, 0.31392301E-06_JPRB, &
  & 0.31425799E-06_JPRB, 0.31458086E-06_JPRB, 0.31484802E-06_JPRB, 0.31502316E-06_JPRB, 0.31508091E-06_JPRB, 0.31501250E-06_JPRB, &
  & 0.31481875E-06_JPRB, 0.31450267E-06_JPRB, 0.31406785E-06_JPRB, 0.31352431E-06_JPRB, 0.31288039E-06_JPRB, 0.31216683E-06_JPRB, &
  & 0.31140743E-06_JPRB, 0.31062933E-06_JPRB, 0.30984475E-06_JPRB, 0.30907776E-06_JPRB, 0.30833826E-06_JPRB, 0.30763044E-06_JPRB, &
  & 0.30696276E-06_JPRB, 0.30631617E-06_JPRB, 0.30568921E-06_JPRB, 0.30507937E-06_JPRB, 0.30448876E-06_JPRB, 0.30392110E-06_JPRB, &
  & 0.30337731E-06_JPRB, 0.30285759E-06_JPRB, 0.30236293E-06_JPRB, 0.30189508E-06_JPRB, 0.30145583E-06_JPRB, 0.30104798E-06_JPRB, &
  & 0.30067346E-06_JPRB, 0.30032410E-06_JPRB, 0.29996482E-06_JPRB, 0.29942294E-06_JPRB /)

RGHG3(:,33, 6) = (/ &
  & 0.29532242E-06_JPRB, 0.29545700E-06_JPRB, 0.29558564E-06_JPRB, 0.29573994E-06_JPRB, 0.29595208E-06_JPRB, 0.29625187E-06_JPRB, &
  & 0.29667797E-06_JPRB, 0.29726954E-06_JPRB, 0.29803530E-06_JPRB, 0.29897015E-06_JPRB, 0.30005748E-06_JPRB, 0.30126517E-06_JPRB, &
  & 0.30256084E-06_JPRB, 0.30389810E-06_JPRB, 0.30524154E-06_JPRB, 0.30654979E-06_JPRB, 0.30779876E-06_JPRB, 0.30895865E-06_JPRB, &
  & 0.31000852E-06_JPRB, 0.31093339E-06_JPRB, 0.31172169E-06_JPRB, 0.31236965E-06_JPRB, 0.31288320E-06_JPRB, 0.31327897E-06_JPRB, &
  & 0.31357928E-06_JPRB, 0.31381219E-06_JPRB, 0.31401478E-06_JPRB, 0.31421050E-06_JPRB, 0.31442795E-06_JPRB, 0.31467414E-06_JPRB, &
  & 0.31494008E-06_JPRB, 0.31519696E-06_JPRB, 0.31540876E-06_JPRB, 0.31554328E-06_JPRB, 0.31558025E-06_JPRB, 0.31550942E-06_JPRB, &
  & 0.31533307E-06_JPRB, 0.31505576E-06_JPRB, 0.31468039E-06_JPRB, 0.31421055E-06_JPRB, 0.31366125E-06_JPRB, 0.31304748E-06_JPRB, &
  & 0.31239941E-06_JPRB, 0.31172721E-06_JPRB, 0.31104636E-06_JPRB, 0.31036632E-06_JPRB, 0.30970207E-06_JPRB, 0.30905539E-06_JPRB, &
  & 0.30843034E-06_JPRB, 0.30782488E-06_JPRB, 0.30722939E-06_JPRB, 0.30664933E-06_JPRB, 0.30608675E-06_JPRB, 0.30554679E-06_JPRB, &
  & 0.30503108E-06_JPRB, 0.30453998E-06_JPRB, 0.30407443E-06_JPRB, 0.30363586E-06_JPRB, 0.30322505E-06_JPRB, 0.30284409E-06_JPRB, &
  & 0.30249254E-06_JPRB, 0.30216268E-06_JPRB, 0.30182130E-06_JPRB, 0.30129550E-06_JPRB /)

RGHG3(:,34, 6) = (/ &
  & 0.29687183E-06_JPRB, 0.29707411E-06_JPRB, 0.29722781E-06_JPRB, 0.29741099E-06_JPRB, 0.29764260E-06_JPRB, 0.29795711E-06_JPRB, &
  & 0.29839094E-06_JPRB, 0.29896836E-06_JPRB, 0.29970363E-06_JPRB, 0.30059115E-06_JPRB, 0.30161519E-06_JPRB, 0.30275359E-06_JPRB, &
  & 0.30397007E-06_JPRB, 0.30522895E-06_JPRB, 0.30649255E-06_JPRB, 0.30772804E-06_JPRB, 0.30890880E-06_JPRB, 0.31001173E-06_JPRB, &
  & 0.31101374E-06_JPRB, 0.31189782E-06_JPRB, 0.31265284E-06_JPRB, 0.31327386E-06_JPRB, 0.31376578E-06_JPRB, 0.31414282E-06_JPRB, &
  & 0.31442681E-06_JPRB, 0.31464234E-06_JPRB, 0.31482196E-06_JPRB, 0.31498860E-06_JPRB, 0.31516242E-06_JPRB, 0.31535609E-06_JPRB, &
  & 0.31556175E-06_JPRB, 0.31575894E-06_JPRB, 0.31591912E-06_JPRB, 0.31601618E-06_JPRB, 0.31603258E-06_JPRB, 0.31596232E-06_JPRB, &
  & 0.31580609E-06_JPRB, 0.31556786E-06_JPRB, 0.31524934E-06_JPRB, 0.31485479E-06_JPRB, 0.31438981E-06_JPRB, 0.31387398E-06_JPRB, &
  & 0.31332092E-06_JPRB, 0.31274490E-06_JPRB, 0.31214907E-06_JPRB, 0.31154300E-06_JPRB, 0.31093893E-06_JPRB, 0.31033869E-06_JPRB, &
  & 0.30974923E-06_JPRB, 0.30917130E-06_JPRB, 0.30860286E-06_JPRB, 0.30804634E-06_JPRB, 0.30750789E-06_JPRB, 0.30699283E-06_JPRB, &
  & 0.30650247E-06_JPRB, 0.30603769E-06_JPRB, 0.30559906E-06_JPRB, 0.30518825E-06_JPRB, 0.30480589E-06_JPRB, 0.30445244E-06_JPRB, &
  & 0.30412713E-06_JPRB, 0.30382131E-06_JPRB, 0.30350239E-06_JPRB, 0.30301140E-06_JPRB /)

RGHG3(:,35, 6) = (/ &
  & 0.29832103E-06_JPRB, 0.29856832E-06_JPRB, 0.29875633E-06_JPRB, 0.29895864E-06_JPRB, 0.29920909E-06_JPRB, 0.29953566E-06_JPRB, &
  & 0.29996667E-06_JPRB, 0.30052794E-06_JPRB, 0.30122536E-06_JPRB, 0.30205803E-06_JPRB, 0.30301644E-06_JPRB, 0.30407807E-06_JPRB, &
  & 0.30521491E-06_JPRB, 0.30639168E-06_JPRB, 0.30757758E-06_JPRB, 0.30874111E-06_JPRB, 0.30985731E-06_JPRB, 0.31090522E-06_JPRB, &
  & 0.31186380E-06_JPRB, 0.31271449E-06_JPRB, 0.31344393E-06_JPRB, 0.31404633E-06_JPRB, 0.31452512E-06_JPRB, 0.31489199E-06_JPRB, &
  & 0.31516620E-06_JPRB, 0.31537209E-06_JPRB, 0.31553583E-06_JPRB, 0.31568038E-06_JPRB, 0.31582144E-06_JPRB, 0.31597003E-06_JPRB, &
  & 0.31612367E-06_JPRB, 0.31626766E-06_JPRB, 0.31638206E-06_JPRB, 0.31644635E-06_JPRB, 0.31644666E-06_JPRB, 0.31637842E-06_JPRB, &
  & 0.31624310E-06_JPRB, 0.31604191E-06_JPRB, 0.31577673E-06_JPRB, 0.31544809E-06_JPRB, 0.31506150E-06_JPRB, 0.31462559E-06_JPRB, &
  & 0.31415669E-06_JPRB, 0.31365735E-06_JPRB, 0.31313317E-06_JPRB, 0.31258733E-06_JPRB, 0.31203137E-06_JPRB, 0.31147027E-06_JPRB, &
  & 0.31090869E-06_JPRB, 0.31035529E-06_JPRB, 0.30980863E-06_JPRB, 0.30927418E-06_JPRB, 0.30875887E-06_JPRB, 0.30826743E-06_JPRB, &
  & 0.30780143E-06_JPRB, 0.30736115E-06_JPRB, 0.30694812E-06_JPRB, 0.30656381E-06_JPRB, 0.30620907E-06_JPRB, 0.30588416E-06_JPRB, &
  & 0.30558655E-06_JPRB, 0.30530703E-06_JPRB, 0.30501585E-06_JPRB, 0.30456300E-06_JPRB /)

RGHG3(:,36, 6) = (/ &
  & 0.29966509E-06_JPRB, 0.29996858E-06_JPRB, 0.30017785E-06_JPRB, 0.30040221E-06_JPRB, 0.30066695E-06_JPRB, 0.30099963E-06_JPRB, &
  & 0.30142661E-06_JPRB, 0.30196367E-06_JPRB, 0.30262007E-06_JPRB, 0.30339629E-06_JPRB, 0.30428444E-06_JPRB, 0.30526857E-06_JPRB, &
  & 0.30632285E-06_JPRB, 0.30741808E-06_JPRB, 0.30852527E-06_JPRB, 0.30961829E-06_JPRB, 0.31067287E-06_JPRB, 0.31166886E-06_JPRB, &
  & 0.31258764E-06_JPRB, 0.31341108E-06_JPRB, 0.31412327E-06_JPRB, 0.31471473E-06_JPRB, 0.31518556E-06_JPRB, 0.31554600E-06_JPRB, &
  & 0.31581394E-06_JPRB, 0.31601149E-06_JPRB, 0.31616247E-06_JPRB, 0.31628750E-06_JPRB, 0.31640087E-06_JPRB, 0.31651177E-06_JPRB, &
  & 0.31662043E-06_JPRB, 0.31671891E-06_JPRB, 0.31679335E-06_JPRB, 0.31683030E-06_JPRB, 0.31681924E-06_JPRB, 0.31675694E-06_JPRB, &
  & 0.31664257E-06_JPRB, 0.31647758E-06_JPRB, 0.31626030E-06_JPRB, 0.31599026E-06_JPRB, 0.31566728E-06_JPRB, 0.31529967E-06_JPRB, &
  & 0.31489438E-06_JPRB, 0.31445842E-06_JPRB, 0.31399014E-06_JPRB, 0.31349464E-06_JPRB, 0.31297915E-06_JPRB, 0.31244920E-06_JPRB, &
  & 0.31191416E-06_JPRB, 0.31138205E-06_JPRB, 0.31085608E-06_JPRB, 0.31034347E-06_JPRB, 0.30985078E-06_JPRB, 0.30938335E-06_JPRB, &
  & 0.30894148E-06_JPRB, 0.30852541E-06_JPRB, 0.30813661E-06_JPRB, 0.30777795E-06_JPRB, 0.30745062E-06_JPRB, 0.30715427E-06_JPRB, &
  & 0.30688562E-06_JPRB, 0.30663500E-06_JPRB, 0.30637344E-06_JPRB, 0.30596726E-06_JPRB /)

RGHG3(:,37, 6) = (/ &
  & 0.30093895E-06_JPRB, 0.30128106E-06_JPRB, 0.30151614E-06_JPRB, 0.30175718E-06_JPRB, 0.30203392E-06_JPRB, 0.30237169E-06_JPRB, &
  & 0.30278773E-06_JPRB, 0.30329815E-06_JPRB, 0.30391013E-06_JPRB, 0.30462664E-06_JPRB, 0.30544410E-06_JPRB, 0.30634888E-06_JPRB, &
  & 0.30731903E-06_JPRB, 0.30833138E-06_JPRB, 0.30936070E-06_JPRB, 0.31038283E-06_JPRB, 0.31137765E-06_JPRB, 0.31232506E-06_JPRB, &
  & 0.31320806E-06_JPRB, 0.31400762E-06_JPRB, 0.31470623E-06_JPRB, 0.31529029E-06_JPRB, 0.31575408E-06_JPRB, 0.31610602E-06_JPRB, &
  & 0.31636176E-06_JPRB, 0.31654574E-06_JPRB, 0.31668003E-06_JPRB, 0.31678474E-06_JPRB, 0.31687281E-06_JPRB, 0.31695237E-06_JPRB, &
  & 0.31702518E-06_JPRB, 0.31708734E-06_JPRB, 0.31713085E-06_JPRB, 0.31714734E-06_JPRB, 0.31713051E-06_JPRB, 0.31707651E-06_JPRB, &
  & 0.31698579E-06_JPRB, 0.31685522E-06_JPRB, 0.31668336E-06_JPRB, 0.31646584E-06_JPRB, 0.31620041E-06_JPRB, 0.31588866E-06_JPRB, &
  & 0.31553739E-06_JPRB, 0.31514918E-06_JPRB, 0.31472695E-06_JPRB, 0.31427282E-06_JPRB, 0.31379170E-06_JPRB, 0.31328995E-06_JPRB, &
  & 0.31277872E-06_JPRB, 0.31226753E-06_JPRB, 0.31176234E-06_JPRB, 0.31127104E-06_JPRB, 0.31080219E-06_JPRB, 0.31035881E-06_JPRB, &
  & 0.30994110E-06_JPRB, 0.30954877E-06_JPRB, 0.30918420E-06_JPRB, 0.30885090E-06_JPRB, 0.30855088E-06_JPRB, 0.30828357E-06_JPRB, &
  & 0.30804449E-06_JPRB, 0.30782314E-06_JPRB, 0.30759313E-06_JPRB, 0.30723410E-06_JPRB /)

RGHG3(:,38, 6) = (/ &
  & 0.30214972E-06_JPRB, 0.30252437E-06_JPRB, 0.30278284E-06_JPRB, 0.30303801E-06_JPRB, 0.30332961E-06_JPRB, 0.30366772E-06_JPRB, &
  & 0.30407105E-06_JPRB, 0.30455053E-06_JPRB, 0.30511453E-06_JPRB, 0.30576939E-06_JPRB, 0.30651466E-06_JPRB, 0.30733889E-06_JPRB, &
  & 0.30822494E-06_JPRB, 0.30915322E-06_JPRB, 0.31010381E-06_JPRB, 0.31105623E-06_JPRB, 0.31199093E-06_JPRB, 0.31289156E-06_JPRB, &
  & 0.31373997E-06_JPRB, 0.31451697E-06_JPRB, 0.31520028E-06_JPRB, 0.31576903E-06_JPRB, 0.31621516E-06_JPRB, 0.31654375E-06_JPRB, &
  & 0.31677476E-06_JPRB, 0.31693372E-06_JPRB, 0.31704607E-06_JPRB, 0.31712935E-06_JPRB, 0.31719617E-06_JPRB, 0.31725261E-06_JPRB, &
  & 0.31730110E-06_JPRB, 0.31733956E-06_JPRB, 0.31736329E-06_JPRB, 0.31736812E-06_JPRB, 0.31734945E-06_JPRB, 0.31730599E-06_JPRB, &
  & 0.31723653E-06_JPRB, 0.31713751E-06_JPRB, 0.31700651E-06_JPRB, 0.31683916E-06_JPRB, 0.31662870E-06_JPRB, 0.31637242E-06_JPRB, &
  & 0.31607226E-06_JPRB, 0.31573063E-06_JPRB, 0.31534967E-06_JPRB, 0.31493124E-06_JPRB, 0.31448101E-06_JPRB, 0.31400623E-06_JPRB, &
  & 0.31351826E-06_JPRB, 0.31302892E-06_JPRB, 0.31254484E-06_JPRB, 0.31207628E-06_JPRB, 0.31163108E-06_JPRB, 0.31121237E-06_JPRB, &
  & 0.31081905E-06_JPRB, 0.31045045E-06_JPRB, 0.31010961E-06_JPRB, 0.30980138E-06_JPRB, 0.30952873E-06_JPRB, 0.30929041E-06_JPRB, &
  & 0.30908080E-06_JPRB, 0.30888816E-06_JPRB, 0.30868873E-06_JPRB, 0.30837680E-06_JPRB /)

RGHG3(:,39, 6) = (/ &
  & 0.30330332E-06_JPRB, 0.30371160E-06_JPRB, 0.30398252E-06_JPRB, 0.30426150E-06_JPRB, 0.30456010E-06_JPRB, 0.30490270E-06_JPRB, &
  & 0.30528997E-06_JPRB, 0.30573509E-06_JPRB, 0.30624889E-06_JPRB, 0.30684043E-06_JPRB, 0.30751139E-06_JPRB, 0.30825538E-06_JPRB, &
  & 0.30905687E-06_JPRB, 0.30990151E-06_JPRB, 0.31077298E-06_JPRB, 0.31165467E-06_JPRB, 0.31252941E-06_JPRB, 0.31338143E-06_JPRB, &
  & 0.31419324E-06_JPRB, 0.31494437E-06_JPRB, 0.31560350E-06_JPRB, 0.31614539E-06_JPRB, 0.31655628E-06_JPRB, 0.31684843E-06_JPRB, &
  & 0.31704548E-06_JPRB, 0.31717727E-06_JPRB, 0.31726779E-06_JPRB, 0.31733396E-06_JPRB, 0.31738560E-06_JPRB, 0.31742778E-06_JPRB, &
  & 0.31746208E-06_JPRB, 0.31748746E-06_JPRB, 0.31750062E-06_JPRB, 0.31749963E-06_JPRB, 0.31748166E-06_JPRB, 0.31744565E-06_JPRB, &
  & 0.31739245E-06_JPRB, 0.31731614E-06_JPRB, 0.31721802E-06_JPRB, 0.31709223E-06_JPRB, 0.31693060E-06_JPRB, 0.31672872E-06_JPRB, &
  & 0.31648401E-06_JPRB, 0.31619427E-06_JPRB, 0.31585816E-06_JPRB, 0.31547876E-06_JPRB, 0.31506073E-06_JPRB, 0.31461340E-06_JPRB, &
  & 0.31415001E-06_JPRB, 0.31368307E-06_JPRB, 0.31322162E-06_JPRB, 0.31277631E-06_JPRB, 0.31235550E-06_JPRB, 0.31196106E-06_JPRB, &
  & 0.31159132E-06_JPRB, 0.31124617E-06_JPRB, 0.31092893E-06_JPRB, 0.31064582E-06_JPRB, 0.31040025E-06_JPRB, 0.31019050E-06_JPRB, &
  & 0.31000889E-06_JPRB, 0.30984387E-06_JPRB, 0.30967266E-06_JPRB, 0.30940507E-06_JPRB /)

RGHG3(:,40, 6) = (/ &
  & 0.30441350E-06_JPRB, 0.30483312E-06_JPRB, 0.30513272E-06_JPRB, 0.30541841E-06_JPRB, 0.30574057E-06_JPRB, 0.30607970E-06_JPRB, &
  & 0.30645145E-06_JPRB, 0.30686198E-06_JPRB, 0.30732409E-06_JPRB, 0.30784994E-06_JPRB, 0.30844711E-06_JPRB, 0.30911028E-06_JPRB, &
  & 0.30982920E-06_JPRB, 0.31059128E-06_JPRB, 0.31138421E-06_JPRB, 0.31219412E-06_JPRB, 0.31300661E-06_JPRB, 0.31380662E-06_JPRB, &
  & 0.31457719E-06_JPRB, 0.31529095E-06_JPRB, 0.31591756E-06_JPRB, 0.31642125E-06_JPRB, 0.31679301E-06_JPRB, 0.31704730E-06_JPRB, &
  & 0.31721416E-06_JPRB, 0.31732338E-06_JPRB, 0.31739791E-06_JPRB, 0.31745202E-06_JPRB, 0.31749411E-06_JPRB, 0.31752782E-06_JPRB, &
  & 0.31755425E-06_JPRB, 0.31757276E-06_JPRB, 0.31758054E-06_JPRB, 0.31757679E-06_JPRB, 0.31755974E-06_JPRB, 0.31752896E-06_JPRB, &
  & 0.31748556E-06_JPRB, 0.31742439E-06_JPRB, 0.31734854E-06_JPRB, 0.31725168E-06_JPRB, 0.31712793E-06_JPRB, 0.31697238E-06_JPRB, &
  & 0.31677999E-06_JPRB, 0.31654415E-06_JPRB, 0.31625973E-06_JPRB, 0.31592413E-06_JPRB, 0.31554308E-06_JPRB, 0.31512684E-06_JPRB, &
  & 0.31468920E-06_JPRB, 0.31424653E-06_JPRB, 0.31380898E-06_JPRB, 0.31338760E-06_JPRB, 0.31299115E-06_JPRB, 0.31262044E-06_JPRB, &
  & 0.31227378E-06_JPRB, 0.31195071E-06_JPRB, 0.31165649E-06_JPRB, 0.31139774E-06_JPRB, 0.31117867E-06_JPRB, 0.31099569E-06_JPRB, &
  & 0.31084042E-06_JPRB, 0.31070005E-06_JPRB, 0.31055529E-06_JPRB, 0.31032673E-06_JPRB /)

RGHG3(:,41, 6) = (/ &
  & 0.30547019E-06_JPRB, 0.30591616E-06_JPRB, 0.30621530E-06_JPRB, 0.30653308E-06_JPRB, 0.30685879E-06_JPRB, 0.30720565E-06_JPRB, &
  & 0.30755965E-06_JPRB, 0.30793515E-06_JPRB, 0.30834607E-06_JPRB, 0.30880844E-06_JPRB, 0.30933083E-06_JPRB, 0.30991541E-06_JPRB, &
  & 0.31055373E-06_JPRB, 0.31123585E-06_JPRB, 0.31195148E-06_JPRB, 0.31268999E-06_JPRB, 0.31343771E-06_JPRB, 0.31418168E-06_JPRB, &
  & 0.31490373E-06_JPRB, 0.31557684E-06_JPRB, 0.31615997E-06_JPRB, 0.31662336E-06_JPRB, 0.31695674E-06_JPRB, 0.31717988E-06_JPRB, &
  & 0.31732338E-06_JPRB, 0.31741629E-06_JPRB, 0.31747962E-06_JPRB, 0.31752577E-06_JPRB, 0.31756156E-06_JPRB, 0.31758995E-06_JPRB, &
  & 0.31761192E-06_JPRB, 0.31762633E-06_JPRB, 0.31763147E-06_JPRB, 0.31762627E-06_JPRB, 0.31761027E-06_JPRB, 0.31758276E-06_JPRB, &
  & 0.31754587E-06_JPRB, 0.31749485E-06_JPRB, 0.31743292E-06_JPRB, 0.31735624E-06_JPRB, 0.31725889E-06_JPRB, 0.31713859E-06_JPRB, &
  & 0.31698931E-06_JPRB, 0.31680270E-06_JPRB, 0.31656961E-06_JPRB, 0.31628301E-06_JPRB, 0.31594362E-06_JPRB, 0.31556129E-06_JPRB, &
  & 0.31515265E-06_JPRB, 0.31473533E-06_JPRB, 0.31432313E-06_JPRB, 0.31392619E-06_JPRB, 0.31355373E-06_JPRB, 0.31320604E-06_JPRB, &
  & 0.31288107E-06_JPRB, 0.31257952E-06_JPRB, 0.31230655E-06_JPRB, 0.31207134E-06_JPRB, 0.31187693E-06_JPRB, 0.31171888E-06_JPRB, &
  & 0.31158700E-06_JPRB, 0.31146885E-06_JPRB, 0.31134604E-06_JPRB, 0.31115258E-06_JPRB /)

RGHG3(:,42, 6) = (/ &
  & 0.30649841E-06_JPRB, 0.30694201E-06_JPRB, 0.30726406E-06_JPRB, 0.30758261E-06_JPRB, 0.30793493E-06_JPRB, 0.30827795E-06_JPRB, &
  & 0.30861742E-06_JPRB, 0.30895984E-06_JPRB, 0.30932233E-06_JPRB, 0.30972197E-06_JPRB, 0.31017356E-06_JPRB, 0.31068194E-06_JPRB, &
  & 0.31124279E-06_JPRB, 0.31184831E-06_JPRB, 0.31248919E-06_JPRB, 0.31315540E-06_JPRB, 0.31383738E-06_JPRB, 0.31452049E-06_JPRB, &
  & 0.31518934E-06_JPRB, 0.31581476E-06_JPRB, 0.31635770E-06_JPRB, 0.31678067E-06_JPRB, 0.31707941E-06_JPRB, 0.31727544E-06_JPRB, &
  & 0.31740029E-06_JPRB, 0.31748101E-06_JPRB, 0.31753621E-06_JPRB, 0.31757648E-06_JPRB, 0.31760800E-06_JPRB, 0.31763295E-06_JPRB, &
  & 0.31765208E-06_JPRB, 0.31766419E-06_JPRB, 0.31766780E-06_JPRB, 0.31766189E-06_JPRB, 0.31764694E-06_JPRB, 0.31762190E-06_JPRB, &
  & 0.31758941E-06_JPRB, 0.31754507E-06_JPRB, 0.31749323E-06_JPRB, 0.31742948E-06_JPRB, 0.31735141E-06_JPRB, 0.31725651E-06_JPRB, &
  & 0.31713992E-06_JPRB, 0.31699406E-06_JPRB, 0.31680781E-06_JPRB, 0.31657041E-06_JPRB, 0.31627661E-06_JPRB, 0.31593305E-06_JPRB, &
  & 0.31555555E-06_JPRB, 0.31516549E-06_JPRB, 0.31477927E-06_JPRB, 0.31440740E-06_JPRB, 0.31405852E-06_JPRB, 0.31373349E-06_JPRB, &
  & 0.31342952E-06_JPRB, 0.31314769E-06_JPRB, 0.31289568E-06_JPRB, 0.31268218E-06_JPRB, 0.31251056E-06_JPRB, 0.31237454E-06_JPRB, &
  & 0.31226301E-06_JPRB, 0.31216342E-06_JPRB, 0.31205991E-06_JPRB, 0.31189481E-06_JPRB /)

RGHG3(:,43, 6) = (/ &
  & 0.30749339E-06_JPRB, 0.30794888E-06_JPRB, 0.30825805E-06_JPRB, 0.30860153E-06_JPRB, 0.30895532E-06_JPRB, 0.30930593E-06_JPRB, &
  & 0.30962923E-06_JPRB, 0.30994110E-06_JPRB, 0.31025826E-06_JPRB, 0.31060074E-06_JPRB, 0.31098475E-06_JPRB, 0.31142076E-06_JPRB, &
  & 0.31190834E-06_JPRB, 0.31244113E-06_JPRB, 0.31300962E-06_JPRB, 0.31360602E-06_JPRB, 0.31421877E-06_JPRB, 0.31483879E-06_JPRB, &
  & 0.31544883E-06_JPRB, 0.31602434E-06_JPRB, 0.31652186E-06_JPRB, 0.31690837E-06_JPRB, 0.31717607E-06_JPRB, 0.31734925E-06_JPRB, &
  & 0.31745867E-06_JPRB, 0.31752964E-06_JPRB, 0.31757855E-06_JPRB, 0.31761465E-06_JPRB, 0.31764299E-06_JPRB, 0.31766555E-06_JPRB, &
  & 0.31768286E-06_JPRB, 0.31769358E-06_JPRB, 0.31769633E-06_JPRB, 0.31769042E-06_JPRB, 0.31767615E-06_JPRB, 0.31765322E-06_JPRB, &
  & 0.31762372E-06_JPRB, 0.31758486E-06_JPRB, 0.31753922E-06_JPRB, 0.31748559E-06_JPRB, 0.31742067E-06_JPRB, 0.31734430E-06_JPRB, &
  & 0.31725267E-06_JPRB, 0.31713884E-06_JPRB, 0.31699318E-06_JPRB, 0.31680304E-06_JPRB, 0.31655745E-06_JPRB, 0.31625649E-06_JPRB, &
  & 0.31591384E-06_JPRB, 0.31555260E-06_JPRB, 0.31519221E-06_JPRB, 0.31484549E-06_JPRB, 0.31452049E-06_JPRB, 0.31421774E-06_JPRB, &
  & 0.31393424E-06_JPRB, 0.31367247E-06_JPRB, 0.31343973E-06_JPRB, 0.31324680E-06_JPRB, 0.31309554E-06_JPRB, 0.31297853E-06_JPRB, &
  & 0.31288380E-06_JPRB, 0.31279978E-06_JPRB, 0.31271128E-06_JPRB, 0.31256920E-06_JPRB /)

RGHG3(:,44, 6) = (/ &
  & 0.30848827E-06_JPRB, 0.30891908E-06_JPRB, 0.30923917E-06_JPRB, 0.30956829E-06_JPRB, 0.30994323E-06_JPRB, 0.31028856E-06_JPRB, &
  & 0.31060091E-06_JPRB, 0.31088413E-06_JPRB, 0.31116110E-06_JPRB, 0.31145080E-06_JPRB, 0.31177410E-06_JPRB, 0.31214267E-06_JPRB, &
  & 0.31256195E-06_JPRB, 0.31302602E-06_JPRB, 0.31352670E-06_JPRB, 0.31405227E-06_JPRB, 0.31459678E-06_JPRB, 0.31514799E-06_JPRB, &
  & 0.31569729E-06_JPRB, 0.31621605E-06_JPRB, 0.31666895E-06_JPRB, 0.31701572E-06_JPRB, 0.31725531E-06_JPRB, 0.31740842E-06_JPRB, &
  & 0.31750520E-06_JPRB, 0.31756824E-06_JPRB, 0.31761215E-06_JPRB, 0.31764495E-06_JPRB, 0.31767095E-06_JPRB, 0.31769193E-06_JPRB, &
  & 0.31770799E-06_JPRB, 0.31771791E-06_JPRB, 0.31772035E-06_JPRB, 0.31771458E-06_JPRB, 0.31770111E-06_JPRB, 0.31767999E-06_JPRB, &
  & 0.31765276E-06_JPRB, 0.31761761E-06_JPRB, 0.31757713E-06_JPRB, 0.31753032E-06_JPRB, 0.31747555E-06_JPRB, 0.31741280E-06_JPRB, &
  & 0.31733964E-06_JPRB, 0.31725131E-06_JPRB, 0.31713961E-06_JPRB, 0.31699179E-06_JPRB, 0.31679548E-06_JPRB, 0.31654127E-06_JPRB, &
  & 0.31623870E-06_JPRB, 0.31590778E-06_JPRB, 0.31557425E-06_JPRB, 0.31525335E-06_JPRB, 0.31495239E-06_JPRB, 0.31467226E-06_JPRB, &
  & 0.31440999E-06_JPRB, 0.31416769E-06_JPRB, 0.31395476E-06_JPRB, 0.31378059E-06_JPRB, 0.31364749E-06_JPRB, 0.31354642E-06_JPRB, &
  & 0.31346582E-06_JPRB, 0.31339360E-06_JPRB, 0.31331754E-06_JPRB, 0.31319237E-06_JPRB /)

RGHG3(:,45, 6) = (/ &
  & 0.30947979E-06_JPRB, 0.30989895E-06_JPRB, 0.31017942E-06_JPRB, 0.31052309E-06_JPRB, 0.31088445E-06_JPRB, 0.31124037E-06_JPRB, &
  & 0.31153610E-06_JPRB, 0.31179638E-06_JPRB, 0.31203612E-06_JPRB, 0.31228149E-06_JPRB, 0.31254879E-06_JPRB, 0.31285788E-06_JPRB, &
  & 0.31321335E-06_JPRB, 0.31361432E-06_JPRB, 0.31404835E-06_JPRB, 0.31450816E-06_JPRB, 0.31498033E-06_JPRB, 0.31546273E-06_JPRB, &
  & 0.31594135E-06_JPRB, 0.31640221E-06_JPRB, 0.31680051E-06_JPRB, 0.31711036E-06_JPRB, 0.31732142E-06_JPRB, 0.31745728E-06_JPRB, &
  & 0.31754311E-06_JPRB, 0.31759970E-06_JPRB, 0.31763966E-06_JPRB, 0.31766996E-06_JPRB, 0.31769432E-06_JPRB, 0.31771418E-06_JPRB, &
  & 0.31772944E-06_JPRB, 0.31773894E-06_JPRB, 0.31774130E-06_JPRB, 0.31773584E-06_JPRB, 0.31772319E-06_JPRB, 0.31770367E-06_JPRB, &
  & 0.31767817E-06_JPRB, 0.31764603E-06_JPRB, 0.31760891E-06_JPRB, 0.31756753E-06_JPRB, 0.31752018E-06_JPRB, 0.31746757E-06_JPRB, &
  & 0.31740865E-06_JPRB, 0.31733993E-06_JPRB, 0.31725511E-06_JPRB, 0.31714458E-06_JPRB, 0.31699327E-06_JPRB, 0.31679087E-06_JPRB, &
  & 0.31653229E-06_JPRB, 0.31623853E-06_JPRB, 0.31593351E-06_JPRB, 0.31563951E-06_JPRB, 0.31536416E-06_JPRB, 0.31510723E-06_JPRB, &
  & 0.31486729E-06_JPRB, 0.31464623E-06_JPRB, 0.31445236E-06_JPRB, 0.31429659E-06_JPRB, 0.31417920E-06_JPRB, 0.31409184E-06_JPRB, &
  & 0.31402186E-06_JPRB, 0.31395965E-06_JPRB, 0.31389214E-06_JPRB, 0.31378079E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART12',0,ZHOOK_HANDLE)



RGHG3(:,46, 6) = (/ &
  & 0.31042072E-06_JPRB, 0.31082195E-06_JPRB, 0.31112410E-06_JPRB, 0.31143273E-06_JPRB, 0.31181756E-06_JPRB, 0.31215916E-06_JPRB, &
  & 0.31245133E-06_JPRB, 0.31268581E-06_JPRB, 0.31289625E-06_JPRB, 0.31309926E-06_JPRB, 0.31332121E-06_JPRB, 0.31357416E-06_JPRB, &
  & 0.31387316E-06_JPRB, 0.31421320E-06_JPRB, 0.31458711E-06_JPRB, 0.31497814E-06_JPRB, 0.31538207E-06_JPRB, 0.31578801E-06_JPRB, &
  & 0.31619552E-06_JPRB, 0.31658135E-06_JPRB, 0.31692576E-06_JPRB, 0.31719139E-06_JPRB, 0.31737770E-06_JPRB, 0.31749730E-06_JPRB, &
  & 0.31757435E-06_JPRB, 0.31762571E-06_JPRB, 0.31766263E-06_JPRB, 0.31769099E-06_JPRB, 0.31771418E-06_JPRB, 0.31773325E-06_JPRB, &
  & 0.31774815E-06_JPRB, 0.31775747E-06_JPRB, 0.31776005E-06_JPRB, 0.31775514E-06_JPRB, 0.31774334E-06_JPRB, 0.31772498E-06_JPRB, &
  & 0.31770094E-06_JPRB, 0.31767087E-06_JPRB, 0.31763676E-06_JPRB, 0.31759913E-06_JPRB, 0.31755752E-06_JPRB, 0.31751273E-06_JPRB, &
  & 0.31746424E-06_JPRB, 0.31741035E-06_JPRB, 0.31734660E-06_JPRB, 0.31726478E-06_JPRB, 0.31715487E-06_JPRB, 0.31700080E-06_JPRB, &
  & 0.31679642E-06_JPRB, 0.31654508E-06_JPRB, 0.31627667E-06_JPRB, 0.31601161E-06_JPRB, 0.31576238E-06_JPRB, 0.31553105E-06_JPRB, &
  & 0.31531499E-06_JPRB, 0.31511533E-06_JPRB, 0.31494147E-06_JPRB, 0.31480209E-06_JPRB, 0.31469887E-06_JPRB, 0.31462204E-06_JPRB, &
  & 0.31456119E-06_JPRB, 0.31450600E-06_JPRB, 0.31444617E-06_JPRB, 0.31434419E-06_JPRB /)

RGHG3(:,47, 6) = (/ &
  & 0.31144162E-06_JPRB, 0.31180349E-06_JPRB, 0.31205090E-06_JPRB, 0.31237158E-06_JPRB, 0.31272521E-06_JPRB, 0.31308386E-06_JPRB, &
  & 0.31335560E-06_JPRB, 0.31357339E-06_JPRB, 0.31375163E-06_JPRB, 0.31392190E-06_JPRB, 0.31409849E-06_JPRB, 0.31430500E-06_JPRB, &
  & 0.31454871E-06_JPRB, 0.31483395E-06_JPRB, 0.31514585E-06_JPRB, 0.31547413E-06_JPRB, 0.31580336E-06_JPRB, 0.31613251E-06_JPRB, &
  & 0.31645331E-06_JPRB, 0.31676328E-06_JPRB, 0.31703888E-06_JPRB, 0.31726438E-06_JPRB, 0.31742417E-06_JPRB, 0.31753061E-06_JPRB, &
  & 0.31759998E-06_JPRB, 0.31764736E-06_JPRB, 0.31768187E-06_JPRB, 0.31770895E-06_JPRB, 0.31773124E-06_JPRB, 0.31774991E-06_JPRB, &
  & 0.31776469E-06_JPRB, 0.31777407E-06_JPRB, 0.31777699E-06_JPRB, 0.31777267E-06_JPRB, 0.31776173E-06_JPRB, 0.31774451E-06_JPRB, &
  & 0.31772151E-06_JPRB, 0.31769324E-06_JPRB, 0.31766129E-06_JPRB, 0.31762670E-06_JPRB, 0.31758947E-06_JPRB, 0.31755033E-06_JPRB, &
  & 0.31750986E-06_JPRB, 0.31746683E-06_JPRB, 0.31741823E-06_JPRB, 0.31735948E-06_JPRB, 0.31728112E-06_JPRB, 0.31717309E-06_JPRB, &
  & 0.31702112E-06_JPRB, 0.31682725E-06_JPRB, 0.31660142E-06_JPRB, 0.31637344E-06_JPRB, 0.31615431E-06_JPRB, 0.31594976E-06_JPRB, &
  & 0.31575811E-06_JPRB, 0.31558096E-06_JPRB, 0.31542493E-06_JPRB, 0.31530112E-06_JPRB, 0.31520941E-06_JPRB, 0.31514165E-06_JPRB, &
  & 0.31508745E-06_JPRB, 0.31503811E-06_JPRB, 0.31498348E-06_JPRB, 0.31488952E-06_JPRB /)

RGHG3(:,48, 6) = (/ &
  & 0.31233517E-06_JPRB, 0.31271264E-06_JPRB, 0.31299089E-06_JPRB, 0.31329097E-06_JPRB, 0.31366960E-06_JPRB, 0.31401220E-06_JPRB, &
  & 0.31428246E-06_JPRB, 0.31447379E-06_JPRB, 0.31462642E-06_JPRB, 0.31476023E-06_JPRB, 0.31490003E-06_JPRB, 0.31505832E-06_JPRB, &
  & 0.31525258E-06_JPRB, 0.31548120E-06_JPRB, 0.31573424E-06_JPRB, 0.31599180E-06_JPRB, 0.31624396E-06_JPRB, 0.31648361E-06_JPRB, &
  & 0.31671243E-06_JPRB, 0.31693469E-06_JPRB, 0.31714484E-06_JPRB, 0.31732566E-06_JPRB, 0.31746350E-06_JPRB, 0.31755783E-06_JPRB, &
  & 0.31762130E-06_JPRB, 0.31766538E-06_JPRB, 0.31769818E-06_JPRB, 0.31772427E-06_JPRB, 0.31774604E-06_JPRB, 0.31776449E-06_JPRB, &
  & 0.31777921E-06_JPRB, 0.31778893E-06_JPRB, 0.31779234E-06_JPRB, 0.31778885E-06_JPRB, 0.31777870E-06_JPRB, 0.31776227E-06_JPRB, &
  & 0.31774024E-06_JPRB, 0.31771336E-06_JPRB, 0.31768323E-06_JPRB, 0.31765103E-06_JPRB, 0.31761687E-06_JPRB, 0.31758231E-06_JPRB, &
  & 0.31754752E-06_JPRB, 0.31751253E-06_JPRB, 0.31747550E-06_JPRB, 0.31743269E-06_JPRB, 0.31737926E-06_JPRB, 0.31730633E-06_JPRB, &
  & 0.31720595E-06_JPRB, 0.31706907E-06_JPRB, 0.31690573E-06_JPRB, 0.31672360E-06_JPRB, 0.31654466E-06_JPRB, 0.31637072E-06_JPRB, &
  & 0.31620499E-06_JPRB, 0.31604804E-06_JPRB, 0.31590838E-06_JPRB, 0.31579617E-06_JPRB, 0.31571358E-06_JPRB, 0.31565241E-06_JPRB, &
  & 0.31560327E-06_JPRB, 0.31555797E-06_JPRB, 0.31550721E-06_JPRB, 0.31541879E-06_JPRB /)

RGHG3(:,49, 6) = (/ &
  & 0.31325254E-06_JPRB, 0.31365178E-06_JPRB, 0.31392761E-06_JPRB, 0.31424236E-06_JPRB, 0.31461065E-06_JPRB, 0.31496236E-06_JPRB, &
  & 0.31521051E-06_JPRB, 0.31537934E-06_JPRB, 0.31550036E-06_JPRB, 0.31560290E-06_JPRB, 0.31570255E-06_JPRB, 0.31581894E-06_JPRB, &
  & 0.31596031E-06_JPRB, 0.31613115E-06_JPRB, 0.31631649E-06_JPRB, 0.31649722E-06_JPRB, 0.31666144E-06_JPRB, 0.31680821E-06_JPRB, &
  & 0.31694907E-06_JPRB, 0.31708760E-06_JPRB, 0.31723715E-06_JPRB, 0.31737812E-06_JPRB, 0.31749505E-06_JPRB, 0.31758012E-06_JPRB, &
  & 0.31763886E-06_JPRB, 0.31768059E-06_JPRB, 0.31771208E-06_JPRB, 0.31773752E-06_JPRB, 0.31775900E-06_JPRB, 0.31777745E-06_JPRB, &
  & 0.31779237E-06_JPRB, 0.31780240E-06_JPRB, 0.31780644E-06_JPRB, 0.31780365E-06_JPRB, 0.31779433E-06_JPRB, 0.31777864E-06_JPRB, &
  & 0.31775750E-06_JPRB, 0.31773180E-06_JPRB, 0.31770310E-06_JPRB, 0.31767274E-06_JPRB, 0.31764125E-06_JPRB, 0.31760976E-06_JPRB, &
  & 0.31757946E-06_JPRB, 0.31755016E-06_JPRB, 0.31752117E-06_JPRB, 0.31749011E-06_JPRB, 0.31745367E-06_JPRB, 0.31740700E-06_JPRB, &
  & 0.31734444E-06_JPRB, 0.31726228E-06_JPRB, 0.31715797E-06_JPRB, 0.31704161E-06_JPRB, 0.31691266E-06_JPRB, 0.31678272E-06_JPRB, &
  & 0.31664959E-06_JPRB, 0.31651550E-06_JPRB, 0.31639053E-06_JPRB, 0.31628832E-06_JPRB, 0.31621181E-06_JPRB, 0.31615559E-06_JPRB, &
  & 0.31610961E-06_JPRB, 0.31606695E-06_JPRB, 0.31601812E-06_JPRB, 0.31593231E-06_JPRB /)

RGHG3(:,50, 6) = (/ &
  & 0.31417960E-06_JPRB, 0.31457137E-06_JPRB, 0.31483245E-06_JPRB, 0.31513764E-06_JPRB, 0.31549044E-06_JPRB, 0.31581320E-06_JPRB, &
  & 0.31602951E-06_JPRB, 0.31616338E-06_JPRB, 0.31625282E-06_JPRB, 0.31632260E-06_JPRB, 0.31639073E-06_JPRB, 0.31646482E-06_JPRB, &
  & 0.31655929E-06_JPRB, 0.31667111E-06_JPRB, 0.31678803E-06_JPRB, 0.31689481E-06_JPRB, 0.31698482E-06_JPRB, 0.31706264E-06_JPRB, &
  & 0.31713381E-06_JPRB, 0.31721868E-06_JPRB, 0.31731201E-06_JPRB, 0.31742155E-06_JPRB, 0.31752037E-06_JPRB, 0.31759802E-06_JPRB, &
  & 0.31765364E-06_JPRB, 0.31769366E-06_JPRB, 0.31772419E-06_JPRB, 0.31774914E-06_JPRB, 0.31777046E-06_JPRB, 0.31778893E-06_JPRB, &
  & 0.31780414E-06_JPRB, 0.31781468E-06_JPRB, 0.31781937E-06_JPRB, 0.31781738E-06_JPRB, 0.31780880E-06_JPRB, 0.31779368E-06_JPRB, &
  & 0.31777341E-06_JPRB, 0.31774874E-06_JPRB, 0.31772140E-06_JPRB, 0.31769252E-06_JPRB, 0.31766285E-06_JPRB, 0.31763383E-06_JPRB, &
  & 0.31760663E-06_JPRB, 0.31758199E-06_JPRB, 0.31755872E-06_JPRB, 0.31753592E-06_JPRB, 0.31751063E-06_JPRB, 0.31748110E-06_JPRB, &
  & 0.31744381E-06_JPRB, 0.31739737E-06_JPRB, 0.31734194E-06_JPRB, 0.31727615E-06_JPRB, 0.31720589E-06_JPRB, 0.31712636E-06_JPRB, &
  & 0.31703848E-06_JPRB, 0.31694321E-06_JPRB, 0.31684448E-06_JPRB, 0.31675799E-06_JPRB, 0.31669293E-06_JPRB, 0.31664192E-06_JPRB, &
  & 0.31660073E-06_JPRB, 0.31655986E-06_JPRB, 0.31651285E-06_JPRB, 0.31642514E-06_JPRB /)

RGHG3(:,51, 6) = (/ &
  & 0.31499727E-06_JPRB, 0.31535575E-06_JPRB, 0.31561305E-06_JPRB, 0.31586791E-06_JPRB, 0.31617751E-06_JPRB, 0.31643731E-06_JPRB, &
  & 0.31660204E-06_JPRB, 0.31669438E-06_JPRB, 0.31675387E-06_JPRB, 0.31679974E-06_JPRB, 0.31684056E-06_JPRB, 0.31688876E-06_JPRB, &
  & 0.31694535E-06_JPRB, 0.31701450E-06_JPRB, 0.31708393E-06_JPRB, 0.31714404E-06_JPRB, 0.31719208E-06_JPRB, 0.31723096E-06_JPRB, &
  & 0.31727143E-06_JPRB, 0.31731400E-06_JPRB, 0.31737937E-06_JPRB, 0.31745532E-06_JPRB, 0.31754064E-06_JPRB, 0.31761255E-06_JPRB, &
  & 0.31766604E-06_JPRB, 0.31770506E-06_JPRB, 0.31773499E-06_JPRB, 0.31775960E-06_JPRB, 0.31778077E-06_JPRB, 0.31779939E-06_JPRB, &
  & 0.31781479E-06_JPRB, 0.31782585E-06_JPRB, 0.31783128E-06_JPRB, 0.31783003E-06_JPRB, 0.31782204E-06_JPRB, 0.31780775E-06_JPRB, &
  & 0.31778811E-06_JPRB, 0.31776457E-06_JPRB, 0.31773828E-06_JPRB, 0.31771069E-06_JPRB, 0.31768246E-06_JPRB, 0.31765518E-06_JPRB, &
  & 0.31763088E-06_JPRB, 0.31760936E-06_JPRB, 0.31759083E-06_JPRB, 0.31757310E-06_JPRB, 0.31755559E-06_JPRB, 0.31753581E-06_JPRB, &
  & 0.31751355E-06_JPRB, 0.31748752E-06_JPRB, 0.31745799E-06_JPRB, 0.31742627E-06_JPRB, 0.31739043E-06_JPRB, 0.31735217E-06_JPRB, &
  & 0.31730897E-06_JPRB, 0.31725645E-06_JPRB, 0.31720009E-06_JPRB, 0.31714706E-06_JPRB, 0.31710155E-06_JPRB, 0.31706708E-06_JPRB, &
  & 0.31703416E-06_JPRB, 0.31700182E-06_JPRB, 0.31695805E-06_JPRB, 0.31687722E-06_JPRB /)

RGHG3(:,52, 6) = (/ &
  & 0.31572981E-06_JPRB, 0.31602326E-06_JPRB, 0.31620135E-06_JPRB, 0.31641258E-06_JPRB, 0.31663890E-06_JPRB, 0.31683390E-06_JPRB, &
  & 0.31694398E-06_JPRB, 0.31700588E-06_JPRB, 0.31704383E-06_JPRB, 0.31707191E-06_JPRB, 0.31709945E-06_JPRB, 0.31712767E-06_JPRB, &
  & 0.31716559E-06_JPRB, 0.31720879E-06_JPRB, 0.31725290E-06_JPRB, 0.31728939E-06_JPRB, 0.31731753E-06_JPRB, 0.31734126E-06_JPRB, &
  & 0.31736212E-06_JPRB, 0.31739211E-06_JPRB, 0.31742786E-06_JPRB, 0.31748812E-06_JPRB, 0.31755690E-06_JPRB, 0.31762443E-06_JPRB, &
  & 0.31767686E-06_JPRB, 0.31771535E-06_JPRB, 0.31774493E-06_JPRB, 0.31776926E-06_JPRB, 0.31779030E-06_JPRB, 0.31780891E-06_JPRB, &
  & 0.31782466E-06_JPRB, 0.31783628E-06_JPRB, 0.31784234E-06_JPRB, 0.31784177E-06_JPRB, 0.31783460E-06_JPRB, 0.31782071E-06_JPRB, &
  & 0.31780203E-06_JPRB, 0.31777910E-06_JPRB, 0.31775406E-06_JPRB, 0.31772737E-06_JPRB, 0.31770037E-06_JPRB, 0.31767493E-06_JPRB, &
  & 0.31765248E-06_JPRB, 0.31763409E-06_JPRB, 0.31761834E-06_JPRB, 0.31760487E-06_JPRB, 0.31759143E-06_JPRB, 0.31757821E-06_JPRB, &
  & 0.31756363E-06_JPRB, 0.31754843E-06_JPRB, 0.31753248E-06_JPRB, 0.31751563E-06_JPRB, 0.31749926E-06_JPRB, 0.31748192E-06_JPRB, &
  & 0.31746225E-06_JPRB, 0.31744068E-06_JPRB, 0.31741533E-06_JPRB, 0.31739029E-06_JPRB, 0.31737039E-06_JPRB, 0.31735141E-06_JPRB, &
  & 0.31733484E-06_JPRB, 0.31731426E-06_JPRB, 0.31728743E-06_JPRB, 0.31722200E-06_JPRB /)

RGHG3(:,53, 6) = (/ &
  & 0.31626217E-06_JPRB, 0.31648361E-06_JPRB, 0.31663410E-06_JPRB, 0.31677709E-06_JPRB, 0.31694475E-06_JPRB, 0.31707560E-06_JPRB, &
  & 0.31715126E-06_JPRB, 0.31719043E-06_JPRB, 0.31721487E-06_JPRB, 0.31723380E-06_JPRB, 0.31725031E-06_JPRB, 0.31727075E-06_JPRB, &
  & 0.31729419E-06_JPRB, 0.31732483E-06_JPRB, 0.31735468E-06_JPRB, 0.31737957E-06_JPRB, 0.31739881E-06_JPRB, 0.31741348E-06_JPRB, &
  & 0.31742940E-06_JPRB, 0.31744540E-06_JPRB, 0.31747462E-06_JPRB, 0.31751304E-06_JPRB, 0.31757273E-06_JPRB, 0.31763503E-06_JPRB, &
  & 0.31768653E-06_JPRB, 0.31772484E-06_JPRB, 0.31775414E-06_JPRB, 0.31777822E-06_JPRB, 0.31779911E-06_JPRB, 0.31781778E-06_JPRB, &
  & 0.31783378E-06_JPRB, 0.31784583E-06_JPRB, 0.31785254E-06_JPRB, 0.31785282E-06_JPRB, 0.31784617E-06_JPRB, 0.31783324E-06_JPRB, &
  & 0.31781497E-06_JPRB, 0.31779308E-06_JPRB, 0.31776872E-06_JPRB, 0.31774289E-06_JPRB, 0.31771708E-06_JPRB, 0.31769287E-06_JPRB, &
  & 0.31767266E-06_JPRB, 0.31765629E-06_JPRB, 0.31764330E-06_JPRB, 0.31763201E-06_JPRB, 0.31762193E-06_JPRB, 0.31761178E-06_JPRB, &
  & 0.31760200E-06_JPRB, 0.31759197E-06_JPRB, 0.31758225E-06_JPRB, 0.31757332E-06_JPRB, 0.31756463E-06_JPRB, 0.31755633E-06_JPRB, &
  & 0.31754797E-06_JPRB, 0.31753802E-06_JPRB, 0.31752757E-06_JPRB, 0.31751762E-06_JPRB, 0.31750835E-06_JPRB, 0.31750122E-06_JPRB, &
  & 0.31749335E-06_JPRB, 0.31748510E-06_JPRB, 0.31747166E-06_JPRB, 0.31743923E-06_JPRB /)

RGHG3(:,54, 6) = (/ &
  & 0.31669703E-06_JPRB, 0.31684246E-06_JPRB, 0.31693145E-06_JPRB, 0.31703343E-06_JPRB, 0.31714376E-06_JPRB, 0.31723334E-06_JPRB, &
  & 0.31728192E-06_JPRB, 0.31730849E-06_JPRB, 0.31732472E-06_JPRB, 0.31733677E-06_JPRB, 0.31734896E-06_JPRB, 0.31736144E-06_JPRB, &
  & 0.31737937E-06_JPRB, 0.31740032E-06_JPRB, 0.31742269E-06_JPRB, 0.31744105E-06_JPRB, 0.31745486E-06_JPRB, 0.31746666E-06_JPRB, &
  & 0.31747649E-06_JPRB, 0.31749084E-06_JPRB, 0.31750776E-06_JPRB, 0.31754101E-06_JPRB, 0.31758734E-06_JPRB, 0.31764515E-06_JPRB, &
  & 0.31769582E-06_JPRB, 0.31773379E-06_JPRB, 0.31776287E-06_JPRB, 0.31778671E-06_JPRB, 0.31780752E-06_JPRB, 0.31782616E-06_JPRB, &
  & 0.31784236E-06_JPRB, 0.31785487E-06_JPRB, 0.31786209E-06_JPRB, 0.31786308E-06_JPRB, 0.31785729E-06_JPRB, 0.31784492E-06_JPRB, &
  & 0.31782753E-06_JPRB, 0.31780621E-06_JPRB, 0.31778254E-06_JPRB, 0.31775753E-06_JPRB, 0.31773254E-06_JPRB, 0.31771009E-06_JPRB, &
  & 0.31769144E-06_JPRB, 0.31767706E-06_JPRB, 0.31766575E-06_JPRB, 0.31765660E-06_JPRB, 0.31764810E-06_JPRB, 0.31764031E-06_JPRB, &
  & 0.31763250E-06_JPRB, 0.31762528E-06_JPRB, 0.31761869E-06_JPRB, 0.31761274E-06_JPRB, 0.31760786E-06_JPRB, 0.31760339E-06_JPRB, &
  & 0.31759885E-06_JPRB, 0.31759436E-06_JPRB, 0.31758938E-06_JPRB, 0.31758469E-06_JPRB, 0.31758123E-06_JPRB, 0.31757793E-06_JPRB, &
  & 0.31757531E-06_JPRB, 0.31757261E-06_JPRB, 0.31757068E-06_JPRB, 0.31757176E-06_JPRB /)

RGHG3(:,55, 6) = (/ &
  & 0.31696624E-06_JPRB, 0.31707404E-06_JPRB, 0.31714083E-06_JPRB, 0.31720785E-06_JPRB, 0.31728050E-06_JPRB, 0.31733907E-06_JPRB, &
  & 0.31737278E-06_JPRB, 0.31739035E-06_JPRB, 0.31740143E-06_JPRB, 0.31741007E-06_JPRB, 0.31741780E-06_JPRB, 0.31742766E-06_JPRB, &
  & 0.31743934E-06_JPRB, 0.31745572E-06_JPRB, 0.31747237E-06_JPRB, 0.31748675E-06_JPRB, 0.31749801E-06_JPRB, 0.31750659E-06_JPRB, &
  & 0.31751568E-06_JPRB, 0.31752464E-06_JPRB, 0.31754061E-06_JPRB, 0.31756332E-06_JPRB, 0.31760422E-06_JPRB, 0.31765629E-06_JPRB, &
  & 0.31770483E-06_JPRB, 0.31774235E-06_JPRB, 0.31777114E-06_JPRB, 0.31779493E-06_JPRB, 0.31781553E-06_JPRB, 0.31783418E-06_JPRB, &
  & 0.31785046E-06_JPRB, 0.31786340E-06_JPRB, 0.31787116E-06_JPRB, 0.31787283E-06_JPRB, 0.31786766E-06_JPRB, 0.31785621E-06_JPRB, &
  & 0.31783941E-06_JPRB, 0.31781869E-06_JPRB, 0.31779558E-06_JPRB, 0.31777117E-06_JPRB, 0.31774749E-06_JPRB, 0.31772618E-06_JPRB, &
  & 0.31770935E-06_JPRB, 0.31769662E-06_JPRB, 0.31768676E-06_JPRB, 0.31767885E-06_JPRB, 0.31767178E-06_JPRB, 0.31766493E-06_JPRB, &
  & 0.31765850E-06_JPRB, 0.31765245E-06_JPRB, 0.31764705E-06_JPRB, 0.31764279E-06_JPRB, 0.31763926E-06_JPRB, 0.31763631E-06_JPRB, &
  & 0.31763358E-06_JPRB, 0.31763062E-06_JPRB, 0.31762778E-06_JPRB, 0.31762536E-06_JPRB, 0.31762318E-06_JPRB, 0.31762158E-06_JPRB, &
  & 0.31761991E-06_JPRB, 0.31761829E-06_JPRB, 0.31761616E-06_JPRB, 0.31761320E-06_JPRB /)

RGHG3(:,56, 6) = (/ &
  & 0.31719361E-06_JPRB, 0.31725003E-06_JPRB, 0.31728888E-06_JPRB, 0.31733046E-06_JPRB, 0.31737844E-06_JPRB, 0.31741644E-06_JPRB, &
  & 0.31743878E-06_JPRB, 0.31745128E-06_JPRB, 0.31745907E-06_JPRB, 0.31746504E-06_JPRB, 0.31747109E-06_JPRB, 0.31747757E-06_JPRB, &
  & 0.31748704E-06_JPRB, 0.31749869E-06_JPRB, 0.31751199E-06_JPRB, 0.31752359E-06_JPRB, 0.31753262E-06_JPRB, 0.31754033E-06_JPRB, &
  & 0.31754678E-06_JPRB, 0.31755559E-06_JPRB, 0.31756639E-06_JPRB, 0.31758745E-06_JPRB, 0.31762127E-06_JPRB, 0.31766839E-06_JPRB, &
  & 0.31771441E-06_JPRB, 0.31775082E-06_JPRB, 0.31777927E-06_JPRB, 0.31780286E-06_JPRB, 0.31782349E-06_JPRB, 0.31784211E-06_JPRB, &
  & 0.31785854E-06_JPRB, 0.31787164E-06_JPRB, 0.31787974E-06_JPRB, 0.31788201E-06_JPRB, 0.31787764E-06_JPRB, 0.31786692E-06_JPRB, &
  & 0.31785089E-06_JPRB, 0.31783077E-06_JPRB, 0.31780806E-06_JPRB, 0.31778447E-06_JPRB, 0.31776159E-06_JPRB, 0.31774192E-06_JPRB, &
  & 0.31772657E-06_JPRB, 0.31771515E-06_JPRB, 0.31770654E-06_JPRB, 0.31769972E-06_JPRB, 0.31769343E-06_JPRB, 0.31768744E-06_JPRB, &
  & 0.31768147E-06_JPRB, 0.31767590E-06_JPRB, 0.31767112E-06_JPRB, 0.31766720E-06_JPRB, 0.31766427E-06_JPRB, 0.31766186E-06_JPRB, &
  & 0.31765947E-06_JPRB, 0.31765731E-06_JPRB, 0.31765512E-06_JPRB, 0.31765322E-06_JPRB, 0.31765182E-06_JPRB, 0.31765057E-06_JPRB, &
  & 0.31764952E-06_JPRB, 0.31764830E-06_JPRB, 0.31764696E-06_JPRB, 0.31764466E-06_JPRB /)

RGHG3(:,57, 6) = (/ &
  & 0.31732395E-06_JPRB, 0.31736536E-06_JPRB, 0.31739143E-06_JPRB, 0.31742030E-06_JPRB, 0.31744918E-06_JPRB, 0.31747498E-06_JPRB, &
  & 0.31749056E-06_JPRB, 0.31749931E-06_JPRB, 0.31750500E-06_JPRB, 0.31750955E-06_JPRB, 0.31751375E-06_JPRB, 0.31751904E-06_JPRB, &
  & 0.31752566E-06_JPRB, 0.31753507E-06_JPRB, 0.31754539E-06_JPRB, 0.31755502E-06_JPRB, 0.31756286E-06_JPRB, 0.31756906E-06_JPRB, &
  & 0.31757509E-06_JPRB, 0.31758140E-06_JPRB, 0.31759194E-06_JPRB, 0.31760874E-06_JPRB, 0.31763935E-06_JPRB, 0.31768215E-06_JPRB, &
  & 0.31772461E-06_JPRB, 0.31775957E-06_JPRB, 0.31778740E-06_JPRB, 0.31781087E-06_JPRB, 0.31783136E-06_JPRB, 0.31784998E-06_JPRB, &
  & 0.31786652E-06_JPRB, 0.31787971E-06_JPRB, 0.31788807E-06_JPRB, 0.31789079E-06_JPRB, 0.31788704E-06_JPRB, 0.31787724E-06_JPRB, &
  & 0.31786192E-06_JPRB, 0.31784228E-06_JPRB, 0.31782025E-06_JPRB, 0.31779723E-06_JPRB, 0.31777566E-06_JPRB, 0.31775718E-06_JPRB, &
  & 0.31774323E-06_JPRB, 0.31773294E-06_JPRB, 0.31772532E-06_JPRB, 0.31771924E-06_JPRB, 0.31771364E-06_JPRB, 0.31770816E-06_JPRB, &
  & 0.31770270E-06_JPRB, 0.31769736E-06_JPRB, 0.31769252E-06_JPRB, 0.31768866E-06_JPRB, 0.31768559E-06_JPRB, 0.31768309E-06_JPRB, &
  & 0.31768093E-06_JPRB, 0.31767877E-06_JPRB, 0.31767675E-06_JPRB, 0.31767510E-06_JPRB, 0.31767377E-06_JPRB, 0.31767274E-06_JPRB, &
  & 0.31767161E-06_JPRB, 0.31767047E-06_JPRB, 0.31766888E-06_JPRB, 0.31766595E-06_JPRB /)

RGHG3(:,58, 6) = (/ &
  & 0.31742371E-06_JPRB, 0.31744975E-06_JPRB, 0.31746760E-06_JPRB, 0.31748499E-06_JPRB, 0.31750528E-06_JPRB, 0.31752160E-06_JPRB, &
  & 0.31753260E-06_JPRB, 0.31753896E-06_JPRB, 0.31754328E-06_JPRB, 0.31754666E-06_JPRB, 0.31755013E-06_JPRB, 0.31755405E-06_JPRB, &
  & 0.31755960E-06_JPRB, 0.31756673E-06_JPRB, 0.31757526E-06_JPRB, 0.31758347E-06_JPRB, 0.31759021E-06_JPRB, 0.31759566E-06_JPRB, &
  & 0.31760038E-06_JPRB, 0.31760629E-06_JPRB, 0.31761456E-06_JPRB, 0.31763039E-06_JPRB, 0.31765805E-06_JPRB, 0.31769648E-06_JPRB, &
  & 0.31773556E-06_JPRB, 0.31776872E-06_JPRB, 0.31779587E-06_JPRB, 0.31781897E-06_JPRB, 0.31783958E-06_JPRB, 0.31785805E-06_JPRB, &
  & 0.31787457E-06_JPRB, 0.31788781E-06_JPRB, 0.31789619E-06_JPRB, 0.31789935E-06_JPRB, 0.31789611E-06_JPRB, 0.31788699E-06_JPRB, &
  & 0.31787243E-06_JPRB, 0.31785362E-06_JPRB, 0.31783208E-06_JPRB, 0.31780996E-06_JPRB, 0.31778936E-06_JPRB, 0.31777236E-06_JPRB, &
  & 0.31775949E-06_JPRB, 0.31775016E-06_JPRB, 0.31774331E-06_JPRB, 0.31773780E-06_JPRB, 0.31773280E-06_JPRB, 0.31772782E-06_JPRB, &
  & 0.31772268E-06_JPRB, 0.31771754E-06_JPRB, 0.31771253E-06_JPRB, 0.31770838E-06_JPRB, 0.31770503E-06_JPRB, 0.31770227E-06_JPRB, &
  & 0.31769969E-06_JPRB, 0.31769736E-06_JPRB, 0.31769528E-06_JPRB, 0.31769349E-06_JPRB, 0.31769218E-06_JPRB, 0.31769105E-06_JPRB, &
  & 0.31768997E-06_JPRB, 0.31768866E-06_JPRB, 0.31768698E-06_JPRB, 0.31768366E-06_JPRB /)

RGHG3(:,59, 6) = (/ &
  & 0.31749073E-06_JPRB, 0.31751125E-06_JPRB, 0.31752347E-06_JPRB, 0.31753626E-06_JPRB, 0.31754865E-06_JPRB, 0.31756042E-06_JPRB, &
  & 0.31756812E-06_JPRB, 0.31757310E-06_JPRB, 0.31757634E-06_JPRB, 0.31757912E-06_JPRB, 0.31758179E-06_JPRB, 0.31758523E-06_JPRB, &
  & 0.31758952E-06_JPRB, 0.31759566E-06_JPRB, 0.31760283E-06_JPRB, 0.31761002E-06_JPRB, 0.31761604E-06_JPRB, 0.31762065E-06_JPRB, &
  & 0.31762471E-06_JPRB, 0.31762912E-06_JPRB, 0.31763679E-06_JPRB, 0.31765103E-06_JPRB, 0.31767632E-06_JPRB, 0.31771148E-06_JPRB, &
  & 0.31774724E-06_JPRB, 0.31777861E-06_JPRB, 0.31780488E-06_JPRB, 0.31782778E-06_JPRB, 0.31784813E-06_JPRB, 0.31786647E-06_JPRB, &
  & 0.31788278E-06_JPRB, 0.31789585E-06_JPRB, 0.31790432E-06_JPRB, 0.31790771E-06_JPRB, 0.31790489E-06_JPRB, 0.31789642E-06_JPRB, &
  & 0.31788261E-06_JPRB, 0.31786436E-06_JPRB, 0.31784384E-06_JPRB, 0.31782253E-06_JPRB, 0.31780323E-06_JPRB, 0.31778731E-06_JPRB, &
  & 0.31777543E-06_JPRB, 0.31776705E-06_JPRB, 0.31776077E-06_JPRB, 0.31775576E-06_JPRB, 0.31775110E-06_JPRB, 0.31774650E-06_JPRB, &
  & 0.31774175E-06_JPRB, 0.31773681E-06_JPRB, 0.31773180E-06_JPRB, 0.31772734E-06_JPRB, 0.31772356E-06_JPRB, 0.31772024E-06_JPRB, &
  & 0.31771722E-06_JPRB, 0.31771441E-06_JPRB, 0.31771182E-06_JPRB, 0.31770986E-06_JPRB, 0.31770824E-06_JPRB, 0.31770696E-06_JPRB, &
  & 0.31770566E-06_JPRB, 0.31770418E-06_JPRB, 0.31770216E-06_JPRB, 0.31769846E-06_JPRB /)

RGHG3(:,60, 6) = (/ &
  & 0.31754490E-06_JPRB, 0.31755923E-06_JPRB, 0.31756815E-06_JPRB, 0.31757648E-06_JPRB, 0.31758569E-06_JPRB, 0.31759356E-06_JPRB, &
  & 0.31759956E-06_JPRB, 0.31760328E-06_JPRB, 0.31760612E-06_JPRB, 0.31760842E-06_JPRB, 0.31761090E-06_JPRB, 0.31761368E-06_JPRB, &
  & 0.31761766E-06_JPRB, 0.31762283E-06_JPRB, 0.31762926E-06_JPRB, 0.31763579E-06_JPRB, 0.31764125E-06_JPRB, 0.31764515E-06_JPRB, &
  & 0.31764807E-06_JPRB, 0.31765148E-06_JPRB, 0.31765779E-06_JPRB, 0.31767107E-06_JPRB, 0.31769457E-06_JPRB, 0.31772637E-06_JPRB, &
  & 0.31775943E-06_JPRB, 0.31778907E-06_JPRB, 0.31781460E-06_JPRB, 0.31783705E-06_JPRB, 0.31785703E-06_JPRB, 0.31787516E-06_JPRB, &
  & 0.31789128E-06_JPRB, 0.31790421E-06_JPRB, 0.31791248E-06_JPRB, 0.31791592E-06_JPRB, 0.31791348E-06_JPRB, 0.31790557E-06_JPRB, &
  & 0.31789241E-06_JPRB, 0.31787513E-06_JPRB, 0.31785541E-06_JPRB, 0.31783529E-06_JPRB, 0.31781693E-06_JPRB, 0.31780223E-06_JPRB, &
  & 0.31779135E-06_JPRB, 0.31778345E-06_JPRB, 0.31777779E-06_JPRB, 0.31777316E-06_JPRB, 0.31776889E-06_JPRB, 0.31776452E-06_JPRB, &
  & 0.31776005E-06_JPRB, 0.31775534E-06_JPRB, 0.31775051E-06_JPRB, 0.31774584E-06_JPRB, 0.31774164E-06_JPRB, 0.31773774E-06_JPRB, &
  & 0.31773413E-06_JPRB, 0.31773064E-06_JPRB, 0.31772760E-06_JPRB, 0.31772504E-06_JPRB, 0.31772319E-06_JPRB, 0.31772151E-06_JPRB, &
  & 0.31771989E-06_JPRB, 0.31771799E-06_JPRB, 0.31771557E-06_JPRB, 0.31771100E-06_JPRB /)

RGHG3(:,61, 6) = (/ &
  & 0.31758594E-06_JPRB, 0.31759737E-06_JPRB, 0.31760408E-06_JPRB, 0.31761050E-06_JPRB, 0.31761684E-06_JPRB, 0.31762298E-06_JPRB, &
  & 0.31762752E-06_JPRB, 0.31763088E-06_JPRB, 0.31763327E-06_JPRB, 0.31763551E-06_JPRB, 0.31763770E-06_JPRB, 0.31764057E-06_JPRB, &
  & 0.31764415E-06_JPRB, 0.31764921E-06_JPRB, 0.31765512E-06_JPRB, 0.31766123E-06_JPRB, 0.31766612E-06_JPRB, 0.31766916E-06_JPRB, &
  & 0.31767101E-06_JPRB, 0.31767314E-06_JPRB, 0.31767843E-06_JPRB, 0.31769065E-06_JPRB, 0.31771214E-06_JPRB, 0.31774138E-06_JPRB, &
  & 0.31777193E-06_JPRB, 0.31780016E-06_JPRB, 0.31782486E-06_JPRB, 0.31784683E-06_JPRB, 0.31786647E-06_JPRB, 0.31788429E-06_JPRB, &
  & 0.31789995E-06_JPRB, 0.31791259E-06_JPRB, 0.31792058E-06_JPRB, 0.31792399E-06_JPRB, 0.31792186E-06_JPRB, 0.31791444E-06_JPRB, &
  & 0.31790208E-06_JPRB, 0.31788562E-06_JPRB, 0.31786703E-06_JPRB, 0.31784793E-06_JPRB, 0.31783091E-06_JPRB, 0.31781713E-06_JPRB, &
  & 0.31780698E-06_JPRB, 0.31779976E-06_JPRB, 0.31779439E-06_JPRB, 0.31779004E-06_JPRB, 0.31778603E-06_JPRB, 0.31778200E-06_JPRB, &
  & 0.31777773E-06_JPRB, 0.31777330E-06_JPRB, 0.31776864E-06_JPRB, 0.31776403E-06_JPRB, 0.31775963E-06_JPRB, 0.31775522E-06_JPRB, &
  & 0.31775096E-06_JPRB, 0.31774692E-06_JPRB, 0.31774306E-06_JPRB, 0.31773999E-06_JPRB, 0.31773749E-06_JPRB, 0.31773541E-06_JPRB, &
  & 0.31773328E-06_JPRB, 0.31773089E-06_JPRB, 0.31772774E-06_JPRB, 0.31772191E-06_JPRB /)

RGHG3(:,62, 6) = (/ &
  & 0.31762065E-06_JPRB, 0.31762954E-06_JPRB, 0.31763474E-06_JPRB, 0.31763958E-06_JPRB, 0.31764466E-06_JPRB, 0.31764932E-06_JPRB, &
  & 0.31765325E-06_JPRB, 0.31765603E-06_JPRB, 0.31765842E-06_JPRB, 0.31766052E-06_JPRB, 0.31766291E-06_JPRB, 0.31766572E-06_JPRB, &
  & 0.31766973E-06_JPRB, 0.31767485E-06_JPRB, 0.31768093E-06_JPRB, 0.31768684E-06_JPRB, 0.31769105E-06_JPRB, 0.31769292E-06_JPRB, &
  & 0.31769355E-06_JPRB, 0.31769451E-06_JPRB, 0.31769875E-06_JPRB, 0.31770969E-06_JPRB, 0.31772947E-06_JPRB, 0.31775625E-06_JPRB, &
  & 0.31778490E-06_JPRB, 0.31781173E-06_JPRB, 0.31783568E-06_JPRB, 0.31785720E-06_JPRB, 0.31787647E-06_JPRB, 0.31789389E-06_JPRB, &
  & 0.31790893E-06_JPRB, 0.31792109E-06_JPRB, 0.31792871E-06_JPRB, 0.31793203E-06_JPRB, 0.31793002E-06_JPRB, 0.31792308E-06_JPRB, &
  & 0.31791146E-06_JPRB, 0.31789602E-06_JPRB, 0.31787837E-06_JPRB, 0.31786070E-06_JPRB, 0.31784475E-06_JPRB, 0.31783205E-06_JPRB, &
  & 0.31782261E-06_JPRB, 0.31781570E-06_JPRB, 0.31781079E-06_JPRB, 0.31780667E-06_JPRB, 0.31780291E-06_JPRB, 0.31779899E-06_JPRB, &
  & 0.31779507E-06_JPRB, 0.31779072E-06_JPRB, 0.31778629E-06_JPRB, 0.31778177E-06_JPRB, 0.31777728E-06_JPRB, 0.31777245E-06_JPRB, &
  & 0.31776781E-06_JPRB, 0.31776312E-06_JPRB, 0.31775883E-06_JPRB, 0.31775502E-06_JPRB, 0.31775195E-06_JPRB, 0.31774925E-06_JPRB, &
  & 0.31774658E-06_JPRB, 0.31774346E-06_JPRB, 0.31773928E-06_JPRB, 0.31773138E-06_JPRB /)

RGHG3(:,63, 6) = (/ &
  & 0.31764907E-06_JPRB, 0.31765688E-06_JPRB, 0.31766137E-06_JPRB, 0.31766550E-06_JPRB, 0.31766967E-06_JPRB, 0.31767377E-06_JPRB, &
  & 0.31767712E-06_JPRB, 0.31767985E-06_JPRB, 0.31768215E-06_JPRB, 0.31768451E-06_JPRB, 0.31768695E-06_JPRB, 0.31769031E-06_JPRB, &
  & 0.31769451E-06_JPRB, 0.31770014E-06_JPRB, 0.31770622E-06_JPRB, 0.31771162E-06_JPRB, 0.31771509E-06_JPRB, 0.31771629E-06_JPRB, &
  & 0.31771583E-06_JPRB, 0.31771566E-06_JPRB, 0.31771896E-06_JPRB, 0.31772862E-06_JPRB, 0.31774664E-06_JPRB, 0.31777145E-06_JPRB, &
  & 0.31779823E-06_JPRB, 0.31782380E-06_JPRB, 0.31784705E-06_JPRB, 0.31786800E-06_JPRB, 0.31788679E-06_JPRB, 0.31790370E-06_JPRB, &
  & 0.31791822E-06_JPRB, 0.31792973E-06_JPRB, 0.31793681E-06_JPRB, 0.31793982E-06_JPRB, 0.31793809E-06_JPRB, 0.31793158E-06_JPRB, &
  & 0.31792075E-06_JPRB, 0.31790623E-06_JPRB, 0.31788989E-06_JPRB, 0.31787337E-06_JPRB, 0.31785865E-06_JPRB, 0.31784680E-06_JPRB, &
  & 0.31783793E-06_JPRB, 0.31783165E-06_JPRB, 0.31782690E-06_JPRB, 0.31782304E-06_JPRB, 0.31781943E-06_JPRB, 0.31781576E-06_JPRB, &
  & 0.31781207E-06_JPRB, 0.31780797E-06_JPRB, 0.31780368E-06_JPRB, 0.31779922E-06_JPRB, 0.31779467E-06_JPRB, 0.31778978E-06_JPRB, &
  & 0.31778470E-06_JPRB, 0.31777981E-06_JPRB, 0.31777475E-06_JPRB, 0.31777051E-06_JPRB, 0.31776673E-06_JPRB, 0.31776344E-06_JPRB, &
  & 0.31776003E-06_JPRB, 0.31775610E-06_JPRB, 0.31775062E-06_JPRB, 0.31774064E-06_JPRB /)

RGHG3(:,64, 6) = (/ &
  & 0.31767371E-06_JPRB, 0.31768096E-06_JPRB, 0.31768505E-06_JPRB, 0.31768877E-06_JPRB, 0.31769258E-06_JPRB, 0.31769628E-06_JPRB, &
  & 0.31769954E-06_JPRB, 0.31770227E-06_JPRB, 0.31770486E-06_JPRB, 0.31770736E-06_JPRB, 0.31771049E-06_JPRB, 0.31771430E-06_JPRB, &
  & 0.31771953E-06_JPRB, 0.31772578E-06_JPRB, 0.31773226E-06_JPRB, 0.31773746E-06_JPRB, 0.31773990E-06_JPRB, 0.31773948E-06_JPRB, &
  & 0.31773783E-06_JPRB, 0.31773664E-06_JPRB, 0.31773885E-06_JPRB, 0.31774729E-06_JPRB, 0.31776378E-06_JPRB, 0.31778671E-06_JPRB, &
  & 0.31781184E-06_JPRB, 0.31783637E-06_JPRB, 0.31785882E-06_JPRB, 0.31787920E-06_JPRB, 0.31789739E-06_JPRB, 0.31791365E-06_JPRB, &
  & 0.31792734E-06_JPRB, 0.31793812E-06_JPRB, 0.31794471E-06_JPRB, 0.31794733E-06_JPRB, 0.31794565E-06_JPRB, 0.31793965E-06_JPRB, &
  & 0.31792956E-06_JPRB, 0.31791620E-06_JPRB, 0.31790103E-06_JPRB, 0.31788593E-06_JPRB, 0.31787229E-06_JPRB, 0.31786129E-06_JPRB, &
  & 0.31785305E-06_JPRB, 0.31784714E-06_JPRB, 0.31784265E-06_JPRB, 0.31783895E-06_JPRB, 0.31783551E-06_JPRB, 0.31783208E-06_JPRB, &
  & 0.31782855E-06_JPRB, 0.31782474E-06_JPRB, 0.31782065E-06_JPRB, 0.31781636E-06_JPRB, 0.31781184E-06_JPRB, 0.31780684E-06_JPRB, &
  & 0.31780164E-06_JPRB, 0.31779643E-06_JPRB, 0.31779115E-06_JPRB, 0.31778620E-06_JPRB, 0.31778191E-06_JPRB, 0.31777793E-06_JPRB, &
  & 0.31777398E-06_JPRB, 0.31776926E-06_JPRB, 0.31776278E-06_JPRB, 0.31775053E-06_JPRB /)

RGHG3(:,65, 6) = (/ &
  & 0.31769534E-06_JPRB, 0.31770264E-06_JPRB, 0.31770674E-06_JPRB, 0.31771035E-06_JPRB, 0.31771395E-06_JPRB, 0.31771748E-06_JPRB, &
  & 0.31772066E-06_JPRB, 0.31772362E-06_JPRB, 0.31772640E-06_JPRB, 0.31772959E-06_JPRB, 0.31773311E-06_JPRB, 0.31773794E-06_JPRB, &
  & 0.31774377E-06_JPRB, 0.31775031E-06_JPRB, 0.31775627E-06_JPRB, 0.31776025E-06_JPRB, 0.31776199E-06_JPRB, 0.31776162E-06_JPRB, &
  & 0.31775946E-06_JPRB, 0.31775727E-06_JPRB, 0.31775858E-06_JPRB, 0.31776585E-06_JPRB, 0.31778097E-06_JPRB, 0.31780209E-06_JPRB, &
  & 0.31782577E-06_JPRB, 0.31784913E-06_JPRB, 0.31787084E-06_JPRB, 0.31789037E-06_JPRB, 0.31790785E-06_JPRB, 0.31792320E-06_JPRB, &
  & 0.31793616E-06_JPRB, 0.31794605E-06_JPRB, 0.31795201E-06_JPRB, 0.31795432E-06_JPRB, 0.31795278E-06_JPRB, 0.31794730E-06_JPRB, &
  & 0.31793806E-06_JPRB, 0.31792575E-06_JPRB, 0.31791188E-06_JPRB, 0.31789801E-06_JPRB, 0.31788554E-06_JPRB, 0.31787542E-06_JPRB, &
  & 0.31786780E-06_JPRB, 0.31786223E-06_JPRB, 0.31785794E-06_JPRB, 0.31785436E-06_JPRB, 0.31785106E-06_JPRB, 0.31784788E-06_JPRB, &
  & 0.31784458E-06_JPRB, 0.31784106E-06_JPRB, 0.31783728E-06_JPRB, 0.31783316E-06_JPRB, 0.31782869E-06_JPRB, 0.31782378E-06_JPRB, &
  & 0.31781840E-06_JPRB, 0.31781309E-06_JPRB, 0.31780743E-06_JPRB, 0.31780218E-06_JPRB, 0.31779732E-06_JPRB, 0.31779288E-06_JPRB, &
  & 0.31778839E-06_JPRB, 0.31778330E-06_JPRB, 0.31777560E-06_JPRB, 0.31776190E-06_JPRB /)

RGHG3(:,66, 6) = (/ &
  & 0.31771469E-06_JPRB, 0.31772242E-06_JPRB, 0.31772674E-06_JPRB, 0.31773055E-06_JPRB, 0.31773419E-06_JPRB, 0.31773780E-06_JPRB, &
  & 0.31774113E-06_JPRB, 0.31774425E-06_JPRB, 0.31774749E-06_JPRB, 0.31775099E-06_JPRB, 0.31775548E-06_JPRB, 0.31776099E-06_JPRB, &
  & 0.31776781E-06_JPRB, 0.31777478E-06_JPRB, 0.31778060E-06_JPRB, 0.31778461E-06_JPRB, 0.31778572E-06_JPRB, 0.31778384E-06_JPRB, &
  & 0.31778055E-06_JPRB, 0.31777779E-06_JPRB, 0.31777824E-06_JPRB, 0.31778450E-06_JPRB, 0.31779811E-06_JPRB, 0.31781767E-06_JPRB, &
  & 0.31783981E-06_JPRB, 0.31786192E-06_JPRB, 0.31788261E-06_JPRB, 0.31790140E-06_JPRB, 0.31791788E-06_JPRB, 0.31793232E-06_JPRB, &
  & 0.31794428E-06_JPRB, 0.31795321E-06_JPRB, 0.31795864E-06_JPRB, 0.31796066E-06_JPRB, 0.31795921E-06_JPRB, 0.31795417E-06_JPRB, &
  & 0.31794590E-06_JPRB, 0.31793473E-06_JPRB, 0.31792220E-06_JPRB, 0.31790964E-06_JPRB, 0.31789824E-06_JPRB, 0.31788898E-06_JPRB, &
  & 0.31788190E-06_JPRB, 0.31787670E-06_JPRB, 0.31787263E-06_JPRB, 0.31786928E-06_JPRB, 0.31786618E-06_JPRB, 0.31786317E-06_JPRB, &
  & 0.31786007E-06_JPRB, 0.31785689E-06_JPRB, 0.31785333E-06_JPRB, 0.31784944E-06_JPRB, 0.31784515E-06_JPRB, 0.31784037E-06_JPRB, &
  & 0.31783503E-06_JPRB, 0.31782966E-06_JPRB, 0.31782386E-06_JPRB, 0.31781821E-06_JPRB, 0.31781303E-06_JPRB, 0.31780812E-06_JPRB, &
  & 0.31780331E-06_JPRB, 0.31779783E-06_JPRB, 0.31778970E-06_JPRB, 0.31777421E-06_JPRB /)

RGHG3(:,67, 6) = (/ &
  & 0.31773249E-06_JPRB, 0.31774107E-06_JPRB, 0.31774584E-06_JPRB, 0.31774991E-06_JPRB, 0.31775386E-06_JPRB, 0.31775761E-06_JPRB, &
  & 0.31776122E-06_JPRB, 0.31776460E-06_JPRB, 0.31776818E-06_JPRB, 0.31777233E-06_JPRB, 0.31777736E-06_JPRB, 0.31778376E-06_JPRB, &
  & 0.31779095E-06_JPRB, 0.31779746E-06_JPRB, 0.31780260E-06_JPRB, 0.31780584E-06_JPRB, 0.31780624E-06_JPRB, 0.31780465E-06_JPRB, &
  & 0.31780115E-06_JPRB, 0.31779797E-06_JPRB, 0.31779777E-06_JPRB, 0.31780303E-06_JPRB, 0.31781542E-06_JPRB, 0.31783333E-06_JPRB, &
  & 0.31785399E-06_JPRB, 0.31787476E-06_JPRB, 0.31789423E-06_JPRB, 0.31791191E-06_JPRB, 0.31792732E-06_JPRB, 0.31794070E-06_JPRB, &
  & 0.31795162E-06_JPRB, 0.31795963E-06_JPRB, 0.31796446E-06_JPRB, 0.31796623E-06_JPRB, 0.31796498E-06_JPRB, 0.31796046E-06_JPRB, &
  & 0.31795301E-06_JPRB, 0.31794303E-06_JPRB, 0.31793169E-06_JPRB, 0.31792041E-06_JPRB, 0.31791021E-06_JPRB, 0.31790177E-06_JPRB, &
  & 0.31789529E-06_JPRB, 0.31789048E-06_JPRB, 0.31788676E-06_JPRB, 0.31788358E-06_JPRB, 0.31788062E-06_JPRB, 0.31787786E-06_JPRB, &
  & 0.31787505E-06_JPRB, 0.31787221E-06_JPRB, 0.31786897E-06_JPRB, 0.31786536E-06_JPRB, 0.31786129E-06_JPRB, 0.31785666E-06_JPRB, &
  & 0.31785152E-06_JPRB, 0.31784612E-06_JPRB, 0.31784015E-06_JPRB, 0.31783432E-06_JPRB, 0.31782898E-06_JPRB, 0.31782375E-06_JPRB, &
  & 0.31781875E-06_JPRB, 0.31781320E-06_JPRB, 0.31780419E-06_JPRB, 0.31778760E-06_JPRB /)

RGHG3(:,68, 6) = (/ &
  & 0.31774806E-06_JPRB, 0.31775841E-06_JPRB, 0.31776386E-06_JPRB, 0.31776858E-06_JPRB, 0.31777290E-06_JPRB, 0.31777719E-06_JPRB, &
  & 0.31778086E-06_JPRB, 0.31778472E-06_JPRB, 0.31778859E-06_JPRB, 0.31779342E-06_JPRB, 0.31779905E-06_JPRB, 0.31780576E-06_JPRB, &
  & 0.31781289E-06_JPRB, 0.31781923E-06_JPRB, 0.31782417E-06_JPRB, 0.31782730E-06_JPRB, 0.31782750E-06_JPRB, 0.31782528E-06_JPRB, &
  & 0.31782142E-06_JPRB, 0.31781789E-06_JPRB, 0.31781721E-06_JPRB, 0.31782167E-06_JPRB, 0.31783262E-06_JPRB, 0.31784896E-06_JPRB, &
  & 0.31786797E-06_JPRB, 0.31788736E-06_JPRB, 0.31790549E-06_JPRB, 0.31792180E-06_JPRB, 0.31793604E-06_JPRB, 0.31794838E-06_JPRB, &
  & 0.31795821E-06_JPRB, 0.31796532E-06_JPRB, 0.31796961E-06_JPRB, 0.31797117E-06_JPRB, 0.31797009E-06_JPRB, 0.31796608E-06_JPRB, &
  & 0.31795946E-06_JPRB, 0.31795054E-06_JPRB, 0.31794045E-06_JPRB, 0.31793041E-06_JPRB, 0.31792121E-06_JPRB, 0.31791365E-06_JPRB, &
  & 0.31790776E-06_JPRB, 0.31790347E-06_JPRB, 0.31790006E-06_JPRB, 0.31789716E-06_JPRB, 0.31789443E-06_JPRB, 0.31789193E-06_JPRB, &
  & 0.31788946E-06_JPRB, 0.31788696E-06_JPRB, 0.31788406E-06_JPRB, 0.31788073E-06_JPRB, 0.31787695E-06_JPRB, 0.31787258E-06_JPRB, &
  & 0.31786757E-06_JPRB, 0.31786217E-06_JPRB, 0.31785626E-06_JPRB, 0.31785044E-06_JPRB, 0.31784495E-06_JPRB, 0.31783964E-06_JPRB, &
  & 0.31783458E-06_JPRB, 0.31782901E-06_JPRB, 0.31782011E-06_JPRB, 0.31780220E-06_JPRB /)

RGHG3(:,69, 6) = (/ &
  & 0.31776275E-06_JPRB, 0.31777523E-06_JPRB, 0.31778188E-06_JPRB, 0.31778723E-06_JPRB, 0.31779226E-06_JPRB, 0.31779661E-06_JPRB, &
  & 0.31780090E-06_JPRB, 0.31780462E-06_JPRB, 0.31780928E-06_JPRB, 0.31781417E-06_JPRB, 0.31782022E-06_JPRB, 0.31782679E-06_JPRB, &
  & 0.31783378E-06_JPRB, 0.31783961E-06_JPRB, 0.31784387E-06_JPRB, 0.31784668E-06_JPRB, 0.31784683E-06_JPRB, 0.31784487E-06_JPRB, &
  & 0.31784094E-06_JPRB, 0.31783736E-06_JPRB, 0.31783648E-06_JPRB, 0.31784026E-06_JPRB, 0.31784992E-06_JPRB, 0.31786448E-06_JPRB, &
  & 0.31788184E-06_JPRB, 0.31789961E-06_JPRB, 0.31791626E-06_JPRB, 0.31793124E-06_JPRB, 0.31794414E-06_JPRB, 0.31795537E-06_JPRB, &
  & 0.31796415E-06_JPRB, 0.31797043E-06_JPRB, 0.31797421E-06_JPRB, 0.31797560E-06_JPRB, 0.31797464E-06_JPRB, 0.31797123E-06_JPRB, &
  & 0.31796534E-06_JPRB, 0.31795747E-06_JPRB, 0.31794849E-06_JPRB, 0.31793965E-06_JPRB, 0.31793144E-06_JPRB, 0.31792479E-06_JPRB, &
  & 0.31791956E-06_JPRB, 0.31791575E-06_JPRB, 0.31791268E-06_JPRB, 0.31791012E-06_JPRB, 0.31790765E-06_JPRB, 0.31790546E-06_JPRB, &
  & 0.31790330E-06_JPRB, 0.31790105E-06_JPRB, 0.31789850E-06_JPRB, 0.31789560E-06_JPRB, 0.31789205E-06_JPRB, 0.31788801E-06_JPRB, &
  & 0.31788335E-06_JPRB, 0.31787806E-06_JPRB, 0.31787226E-06_JPRB, 0.31786664E-06_JPRB, 0.31786112E-06_JPRB, 0.31785589E-06_JPRB, &
  & 0.31785083E-06_JPRB, 0.31784549E-06_JPRB, 0.31783640E-06_JPRB, 0.31781792E-06_JPRB /)

RGHG3(:,70, 6) = (/ &
  & 0.31777697E-06_JPRB, 0.31779211E-06_JPRB, 0.31779999E-06_JPRB, 0.31780627E-06_JPRB, 0.31781164E-06_JPRB, 0.31781664E-06_JPRB, &
  & 0.31782071E-06_JPRB, 0.31782514E-06_JPRB, 0.31782963E-06_JPRB, 0.31783503E-06_JPRB, 0.31784069E-06_JPRB, 0.31784720E-06_JPRB, &
  & 0.31785385E-06_JPRB, 0.31785933E-06_JPRB, 0.31786351E-06_JPRB, 0.31786601E-06_JPRB, 0.31786584E-06_JPRB, 0.31786396E-06_JPRB, &
  & 0.31786027E-06_JPRB, 0.31785694E-06_JPRB, 0.31785561E-06_JPRB, 0.31785882E-06_JPRB, 0.31786706E-06_JPRB, 0.31787982E-06_JPRB, &
  & 0.31789537E-06_JPRB, 0.31791140E-06_JPRB, 0.31792644E-06_JPRB, 0.31794008E-06_JPRB, 0.31795167E-06_JPRB, 0.31796179E-06_JPRB, &
  & 0.31796947E-06_JPRB, 0.31797495E-06_JPRB, 0.31797819E-06_JPRB, 0.31797944E-06_JPRB, 0.31797870E-06_JPRB, 0.31797583E-06_JPRB, &
  & 0.31797074E-06_JPRB, 0.31796381E-06_JPRB, 0.31795585E-06_JPRB, 0.31794818E-06_JPRB, 0.31794093E-06_JPRB, 0.31793516E-06_JPRB, &
  & 0.31793056E-06_JPRB, 0.31792717E-06_JPRB, 0.31792456E-06_JPRB, 0.31792243E-06_JPRB, 0.31792032E-06_JPRB, 0.31791836E-06_JPRB, &
  & 0.31791646E-06_JPRB, 0.31791456E-06_JPRB, 0.31791240E-06_JPRB, 0.31790984E-06_JPRB, 0.31790665E-06_JPRB, 0.31790293E-06_JPRB, &
  & 0.31789864E-06_JPRB, 0.31789369E-06_JPRB, 0.31788812E-06_JPRB, 0.31788272E-06_JPRB, 0.31787738E-06_JPRB, 0.31787252E-06_JPRB, &
  & 0.31786757E-06_JPRB, 0.31786254E-06_JPRB, 0.31785393E-06_JPRB, 0.31783514E-06_JPRB /)

RGHG3(:,71, 6) = (/ &
  & 0.31779143E-06_JPRB, 0.31780993E-06_JPRB, 0.31781886E-06_JPRB, 0.31782599E-06_JPRB, 0.31783168E-06_JPRB, 0.31783682E-06_JPRB, &
  & 0.31784114E-06_JPRB, 0.31784543E-06_JPRB, 0.31785049E-06_JPRB, 0.31785521E-06_JPRB, 0.31786089E-06_JPRB, 0.31786684E-06_JPRB, &
  & 0.31787317E-06_JPRB, 0.31787783E-06_JPRB, 0.31788142E-06_JPRB, 0.31788377E-06_JPRB, 0.31788392E-06_JPRB, 0.31788235E-06_JPRB, &
  & 0.31787857E-06_JPRB, 0.31787565E-06_JPRB, 0.31787437E-06_JPRB, 0.31787707E-06_JPRB, 0.31788403E-06_JPRB, 0.31789486E-06_JPRB, &
  & 0.31790856E-06_JPRB, 0.31792280E-06_JPRB, 0.31793616E-06_JPRB, 0.31794835E-06_JPRB, 0.31795864E-06_JPRB, 0.31796762E-06_JPRB, &
  & 0.31797433E-06_JPRB, 0.31797902E-06_JPRB, 0.31798183E-06_JPRB, 0.31798288E-06_JPRB, 0.31798223E-06_JPRB, 0.31797990E-06_JPRB, &
  & 0.31797552E-06_JPRB, 0.31796955E-06_JPRB, 0.31796259E-06_JPRB, 0.31795594E-06_JPRB, 0.31794966E-06_JPRB, 0.31794474E-06_JPRB, &
  & 0.31794076E-06_JPRB, 0.31793792E-06_JPRB, 0.31793570E-06_JPRB, 0.31793394E-06_JPRB, 0.31793212E-06_JPRB, 0.31793056E-06_JPRB, &
  & 0.31792882E-06_JPRB, 0.31792732E-06_JPRB, 0.31792555E-06_JPRB, 0.31792337E-06_JPRB, 0.31792055E-06_JPRB, 0.31791731E-06_JPRB, &
  & 0.31791342E-06_JPRB, 0.31790887E-06_JPRB, 0.31790367E-06_JPRB, 0.31789867E-06_JPRB, 0.31789372E-06_JPRB, 0.31788920E-06_JPRB, &
  & 0.31788466E-06_JPRB, 0.31788011E-06_JPRB, 0.31787235E-06_JPRB, 0.31785513E-06_JPRB /)

RGHG3(:,72, 6) = (/ &
  & 0.31780746E-06_JPRB, 0.31782852E-06_JPRB, 0.31783935E-06_JPRB, 0.31784668E-06_JPRB, 0.31785274E-06_JPRB, 0.31785760E-06_JPRB, &
  & 0.31786203E-06_JPRB, 0.31786641E-06_JPRB, 0.31787090E-06_JPRB, 0.31787584E-06_JPRB, 0.31788039E-06_JPRB, 0.31788633E-06_JPRB, &
  & 0.31789202E-06_JPRB, 0.31789634E-06_JPRB, 0.31789969E-06_JPRB, 0.31790123E-06_JPRB, 0.31790120E-06_JPRB, 0.31790023E-06_JPRB, &
  & 0.31789679E-06_JPRB, 0.31789406E-06_JPRB, 0.31789273E-06_JPRB, 0.31789492E-06_JPRB, 0.31790054E-06_JPRB, 0.31790958E-06_JPRB, &
  & 0.31792143E-06_JPRB, 0.31793377E-06_JPRB, 0.31794539E-06_JPRB, 0.31795614E-06_JPRB, 0.31796503E-06_JPRB, 0.31797308E-06_JPRB, &
  & 0.31797879E-06_JPRB, 0.31798271E-06_JPRB, 0.31798496E-06_JPRB, 0.31798589E-06_JPRB, 0.31798544E-06_JPRB, 0.31798371E-06_JPRB, &
  & 0.31797981E-06_JPRB, 0.31797478E-06_JPRB, 0.31796873E-06_JPRB, 0.31796313E-06_JPRB, 0.31795773E-06_JPRB, 0.31795363E-06_JPRB, &
  & 0.31795022E-06_JPRB, 0.31794787E-06_JPRB, 0.31794610E-06_JPRB, 0.31794468E-06_JPRB, 0.31794306E-06_JPRB, 0.31794178E-06_JPRB, &
  & 0.31794036E-06_JPRB, 0.31793914E-06_JPRB, 0.31793778E-06_JPRB, 0.31793599E-06_JPRB, 0.31793365E-06_JPRB, 0.31793087E-06_JPRB, &
  & 0.31792752E-06_JPRB, 0.31792339E-06_JPRB, 0.31791865E-06_JPRB, 0.31791427E-06_JPRB, 0.31790978E-06_JPRB, 0.31790589E-06_JPRB, &
  & 0.31790182E-06_JPRB, 0.31789781E-06_JPRB, 0.31789105E-06_JPRB, 0.31787528E-06_JPRB /)

RGHG3(:,73, 6) = (/ &
  & 0.31782682E-06_JPRB, 0.31785081E-06_JPRB, 0.31786084E-06_JPRB, 0.31786897E-06_JPRB, 0.31787420E-06_JPRB, 0.31787931E-06_JPRB, &
  & 0.31788338E-06_JPRB, 0.31788738E-06_JPRB, 0.31789216E-06_JPRB, 0.31789563E-06_JPRB, 0.31790046E-06_JPRB, 0.31790498E-06_JPRB, &
  & 0.31791049E-06_JPRB, 0.31791336E-06_JPRB, 0.31791626E-06_JPRB, 0.31791768E-06_JPRB, 0.31791774E-06_JPRB, 0.31791683E-06_JPRB, &
  & 0.31791348E-06_JPRB, 0.31791151E-06_JPRB, 0.31791024E-06_JPRB, 0.31791197E-06_JPRB, 0.31791654E-06_JPRB, 0.31792374E-06_JPRB, &
  & 0.31793377E-06_JPRB, 0.31794417E-06_JPRB, 0.31795420E-06_JPRB, 0.31796344E-06_JPRB, 0.31797092E-06_JPRB, 0.31797808E-06_JPRB, &
  & 0.31798268E-06_JPRB, 0.31798606E-06_JPRB, 0.31798777E-06_JPRB, 0.31798854E-06_JPRB, 0.31798828E-06_JPRB, 0.31798697E-06_JPRB, &
  & 0.31798371E-06_JPRB, 0.31797941E-06_JPRB, 0.31797430E-06_JPRB, 0.31796966E-06_JPRB, 0.31796503E-06_JPRB, 0.31796185E-06_JPRB, &
  & 0.31795892E-06_JPRB, 0.31795696E-06_JPRB, 0.31795562E-06_JPRB, 0.31795457E-06_JPRB, 0.31795312E-06_JPRB, 0.31795216E-06_JPRB, &
  & 0.31795093E-06_JPRB, 0.31795003E-06_JPRB, 0.31794903E-06_JPRB, 0.31794764E-06_JPRB, 0.31794571E-06_JPRB, 0.31794349E-06_JPRB, &
  & 0.31794059E-06_JPRB, 0.31793707E-06_JPRB, 0.31793289E-06_JPRB, 0.31792911E-06_JPRB, 0.31792530E-06_JPRB, 0.31792183E-06_JPRB, &
  & 0.31791836E-06_JPRB, 0.31791492E-06_JPRB, 0.31790893E-06_JPRB, 0.31789506E-06_JPRB /)

RGHG3(:,74, 6) = (/ &
  & 0.31784941E-06_JPRB, 0.31787289E-06_JPRB, 0.31788409E-06_JPRB, 0.31789119E-06_JPRB, 0.31789628E-06_JPRB, 0.31790069E-06_JPRB, &
  & 0.31790455E-06_JPRB, 0.31790853E-06_JPRB, 0.31791208E-06_JPRB, 0.31791592E-06_JPRB, 0.31791885E-06_JPRB, 0.31792385E-06_JPRB, &
  & 0.31792814E-06_JPRB, 0.31793053E-06_JPRB, 0.31793246E-06_JPRB, 0.31793337E-06_JPRB, 0.31793320E-06_JPRB, 0.31793260E-06_JPRB, &
  & 0.31792985E-06_JPRB, 0.31792814E-06_JPRB, 0.31792683E-06_JPRB, 0.31792831E-06_JPRB, 0.31793186E-06_JPRB, 0.31793741E-06_JPRB, &
  & 0.31794571E-06_JPRB, 0.31795417E-06_JPRB, 0.31796256E-06_JPRB, 0.31797032E-06_JPRB, 0.31797649E-06_JPRB, 0.31798263E-06_JPRB, &
  & 0.31798621E-06_JPRB, 0.31798902E-06_JPRB, 0.31799027E-06_JPRB, 0.31799090E-06_JPRB, 0.31799075E-06_JPRB, 0.31798987E-06_JPRB, &
  & 0.31798697E-06_JPRB, 0.31798362E-06_JPRB, 0.31797930E-06_JPRB, 0.31797555E-06_JPRB, 0.31797168E-06_JPRB, 0.31796930E-06_JPRB, &
  & 0.31796688E-06_JPRB, 0.31796520E-06_JPRB, 0.31796432E-06_JPRB, 0.31796364E-06_JPRB, 0.31796239E-06_JPRB, 0.31796162E-06_JPRB, &
  & 0.31796048E-06_JPRB, 0.31795980E-06_JPRB, 0.31795932E-06_JPRB, 0.31795830E-06_JPRB, 0.31795682E-06_JPRB, 0.31795489E-06_JPRB, &
  & 0.31795267E-06_JPRB, 0.31794980E-06_JPRB, 0.31794610E-06_JPRB, 0.31794309E-06_JPRB, 0.31793968E-06_JPRB, 0.31793684E-06_JPRB, &
  & 0.31793394E-06_JPRB, 0.31793110E-06_JPRB, 0.31792604E-06_JPRB, 0.31791356E-06_JPRB /)

RGHG3(:,75, 6) = (/ &
  & 0.31787178E-06_JPRB, 0.31789665E-06_JPRB, 0.31790631E-06_JPRB, 0.31791339E-06_JPRB, 0.31791723E-06_JPRB, 0.31792140E-06_JPRB, &
  & 0.31792473E-06_JPRB, 0.31792806E-06_JPRB, 0.31793186E-06_JPRB, 0.31793400E-06_JPRB, 0.31793718E-06_JPRB, 0.31794036E-06_JPRB, &
  & 0.31794465E-06_JPRB, 0.31794559E-06_JPRB, 0.31794676E-06_JPRB, 0.31794764E-06_JPRB, 0.31794755E-06_JPRB, 0.31794715E-06_JPRB, &
  & 0.31794465E-06_JPRB, 0.31794355E-06_JPRB, 0.31794229E-06_JPRB, 0.31794372E-06_JPRB, 0.31794644E-06_JPRB, 0.31795037E-06_JPRB, &
  & 0.31795713E-06_JPRB, 0.31796372E-06_JPRB, 0.31797043E-06_JPRB, 0.31797694E-06_JPRB, 0.31798172E-06_JPRB, 0.31798680E-06_JPRB, &
  & 0.31798939E-06_JPRB, 0.31799175E-06_JPRB, 0.31799243E-06_JPRB, 0.31799291E-06_JPRB, 0.31799286E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31798990E-06_JPRB, 0.31798734E-06_JPRB, 0.31798385E-06_JPRB, 0.31798081E-06_JPRB, 0.31797777E-06_JPRB, 0.31797626E-06_JPRB, &
  & 0.31797416E-06_JPRB, 0.31797276E-06_JPRB, 0.31797217E-06_JPRB, 0.31797185E-06_JPRB, 0.31797077E-06_JPRB, 0.31797023E-06_JPRB, &
  & 0.31796912E-06_JPRB, 0.31796873E-06_JPRB, 0.31796867E-06_JPRB, 0.31796799E-06_JPRB, 0.31796696E-06_JPRB, 0.31796546E-06_JPRB, &
  & 0.31796378E-06_JPRB, 0.31796142E-06_JPRB, 0.31795821E-06_JPRB, 0.31795577E-06_JPRB, 0.31795290E-06_JPRB, 0.31795048E-06_JPRB, &
  & 0.31794829E-06_JPRB, 0.31794622E-06_JPRB, 0.31794178E-06_JPRB, 0.31793098E-06_JPRB /)

RGHG3(:,76, 6) = (/ &
  & 0.31789614E-06_JPRB, 0.31791933E-06_JPRB, 0.31792834E-06_JPRB, 0.31793428E-06_JPRB, 0.31793709E-06_JPRB, 0.31794048E-06_JPRB, &
  & 0.31794323E-06_JPRB, 0.31794633E-06_JPRB, 0.31794914E-06_JPRB, 0.31795096E-06_JPRB, 0.31795253E-06_JPRB, 0.31795599E-06_JPRB, &
  & 0.31795912E-06_JPRB, 0.31796029E-06_JPRB, 0.31795997E-06_JPRB, 0.31796051E-06_JPRB, 0.31796054E-06_JPRB, 0.31796066E-06_JPRB, &
  & 0.31795850E-06_JPRB, 0.31795784E-06_JPRB, 0.31795673E-06_JPRB, 0.31795807E-06_JPRB, 0.31796009E-06_JPRB, 0.31796262E-06_JPRB, &
  & 0.31796796E-06_JPRB, 0.31797276E-06_JPRB, 0.31797788E-06_JPRB, 0.31798311E-06_JPRB, 0.31798658E-06_JPRB, 0.31799067E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799414E-06_JPRB, 0.31799436E-06_JPRB, 0.31799473E-06_JPRB, 0.31799473E-06_JPRB, 0.31799485E-06_JPRB, &
  & 0.31799243E-06_JPRB, 0.31799053E-06_JPRB, 0.31798783E-06_JPRB, 0.31798552E-06_JPRB, 0.31798317E-06_JPRB, 0.31798254E-06_JPRB, &
  & 0.31798075E-06_JPRB, 0.31797956E-06_JPRB, 0.31797930E-06_JPRB, 0.31797927E-06_JPRB, 0.31797825E-06_JPRB, 0.31797799E-06_JPRB, &
  & 0.31797711E-06_JPRB, 0.31797680E-06_JPRB, 0.31797737E-06_JPRB, 0.31797691E-06_JPRB, 0.31797629E-06_JPRB, 0.31797487E-06_JPRB, &
  & 0.31797384E-06_JPRB, 0.31797214E-06_JPRB, 0.31796915E-06_JPRB, 0.31796748E-06_JPRB, 0.31796483E-06_JPRB, 0.31796299E-06_JPRB, &
  & 0.31796139E-06_JPRB, 0.31796029E-06_JPRB, 0.31795665E-06_JPRB, 0.31794707E-06_JPRB /)

RGHG3(:,77, 6) = (/ &
  & 0.31792072E-06_JPRB, 0.31794153E-06_JPRB, 0.31794903E-06_JPRB, 0.31795400E-06_JPRB, 0.31795508E-06_JPRB, 0.31795793E-06_JPRB, &
  & 0.31795975E-06_JPRB, 0.31796216E-06_JPRB, 0.31796495E-06_JPRB, 0.31796534E-06_JPRB, 0.31796645E-06_JPRB, 0.31796890E-06_JPRB, &
  & 0.31797137E-06_JPRB, 0.31797276E-06_JPRB, 0.31797123E-06_JPRB, 0.31797180E-06_JPRB, 0.31797214E-06_JPRB, 0.31797276E-06_JPRB, &
  & 0.31797077E-06_JPRB, 0.31797072E-06_JPRB, 0.31796969E-06_JPRB, 0.31797114E-06_JPRB, 0.31797268E-06_JPRB, 0.31797390E-06_JPRB, &
  & 0.31797816E-06_JPRB, 0.31798120E-06_JPRB, 0.31798490E-06_JPRB, 0.31798893E-06_JPRB, 0.31799101E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799476E-06_JPRB, 0.31799635E-06_JPRB, 0.31799610E-06_JPRB, 0.31799632E-06_JPRB, 0.31799641E-06_JPRB, 0.31799695E-06_JPRB, &
  & 0.31799459E-06_JPRB, 0.31799331E-06_JPRB, 0.31799138E-06_JPRB, 0.31798970E-06_JPRB, 0.31798803E-06_JPRB, 0.31798822E-06_JPRB, &
  & 0.31798663E-06_JPRB, 0.31798555E-06_JPRB, 0.31798561E-06_JPRB, 0.31798592E-06_JPRB, 0.31798498E-06_JPRB, 0.31798510E-06_JPRB, &
  & 0.31798422E-06_JPRB, 0.31798393E-06_JPRB, 0.31798518E-06_JPRB, 0.31798498E-06_JPRB, 0.31798470E-06_JPRB, 0.31798328E-06_JPRB, &
  & 0.31798280E-06_JPRB, 0.31798169E-06_JPRB, 0.31797890E-06_JPRB, 0.31797802E-06_JPRB, 0.31797563E-06_JPRB, 0.31797421E-06_JPRB, &
  & 0.31797330E-06_JPRB, 0.31797342E-06_JPRB, 0.31797035E-06_JPRB, 0.31796230E-06_JPRB /)

RGHG3(:,78, 6) = (/ &
  & 0.31794551E-06_JPRB, 0.31796179E-06_JPRB, 0.31796711E-06_JPRB, 0.31797106E-06_JPRB, 0.31797040E-06_JPRB, 0.31797256E-06_JPRB, &
  & 0.31797344E-06_JPRB, 0.31797543E-06_JPRB, 0.31797774E-06_JPRB, 0.31797688E-06_JPRB, 0.31797697E-06_JPRB, 0.31797975E-06_JPRB, &
  & 0.31798064E-06_JPRB, 0.31798317E-06_JPRB, 0.31798044E-06_JPRB, 0.31798089E-06_JPRB, 0.31798140E-06_JPRB, 0.31798271E-06_JPRB, &
  & 0.31798089E-06_JPRB, 0.31798152E-06_JPRB, 0.31798061E-06_JPRB, 0.31798228E-06_JPRB, 0.31798336E-06_JPRB, 0.31798345E-06_JPRB, &
  & 0.31798686E-06_JPRB, 0.31798845E-06_JPRB, 0.31799101E-06_JPRB, 0.31799402E-06_JPRB, 0.31799493E-06_JPRB, 0.31799721E-06_JPRB, &
  & 0.31799698E-06_JPRB, 0.31799823E-06_JPRB, 0.31799755E-06_JPRB, 0.31799757E-06_JPRB, 0.31799769E-06_JPRB, 0.31799868E-06_JPRB, &
  & 0.31799630E-06_JPRB, 0.31799570E-06_JPRB, 0.31799433E-06_JPRB, 0.31799308E-06_JPRB, 0.31799212E-06_JPRB, 0.31799308E-06_JPRB, &
  & 0.31799161E-06_JPRB, 0.31799055E-06_JPRB, 0.31799090E-06_JPRB, 0.31799155E-06_JPRB, 0.31799064E-06_JPRB, 0.31799107E-06_JPRB, &
  & 0.31799019E-06_JPRB, 0.31798990E-06_JPRB, 0.31799169E-06_JPRB, 0.31799175E-06_JPRB, 0.31799181E-06_JPRB, 0.31799007E-06_JPRB, &
  & 0.31799019E-06_JPRB, 0.31798965E-06_JPRB, 0.31798677E-06_JPRB, 0.31798680E-06_JPRB, 0.31798436E-06_JPRB, 0.31798356E-06_JPRB, &
  & 0.31798331E-06_JPRB, 0.31798464E-06_JPRB, 0.31798245E-06_JPRB, 0.31797671E-06_JPRB /)

RGHG3(:,79, 6) = (/ &
  & 0.31796159E-06_JPRB, 0.31797325E-06_JPRB, 0.31797691E-06_JPRB, 0.31798027E-06_JPRB, 0.31797816E-06_JPRB, 0.31798021E-06_JPRB, &
  & 0.31798032E-06_JPRB, 0.31798211E-06_JPRB, 0.31798453E-06_JPRB, 0.31798271E-06_JPRB, 0.31798231E-06_JPRB, 0.31798530E-06_JPRB, &
  & 0.31798533E-06_JPRB, 0.31798874E-06_JPRB, 0.31798501E-06_JPRB, 0.31798544E-06_JPRB, 0.31798618E-06_JPRB, 0.31798797E-06_JPRB, &
  & 0.31798612E-06_JPRB, 0.31798726E-06_JPRB, 0.31798635E-06_JPRB, 0.31798834E-06_JPRB, 0.31798933E-06_JPRB, 0.31798862E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799249E-06_JPRB, 0.31799445E-06_JPRB, 0.31799698E-06_JPRB, 0.31799712E-06_JPRB, 0.31799900E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799942E-06_JPRB, 0.31799829E-06_JPRB, 0.31799817E-06_JPRB, 0.31799837E-06_JPRB, 0.31799985E-06_JPRB, &
  & 0.31799726E-06_JPRB, 0.31799695E-06_JPRB, 0.31799595E-06_JPRB, 0.31799490E-06_JPRB, 0.31799422E-06_JPRB, 0.31799581E-06_JPRB, &
  & 0.31799433E-06_JPRB, 0.31799325E-06_JPRB, 0.31799374E-06_JPRB, 0.31799456E-06_JPRB, 0.31799354E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799300E-06_JPRB, 0.31799536E-06_JPRB, 0.31799550E-06_JPRB, 0.31799576E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799431E-06_JPRB, 0.31799397E-06_JPRB, 0.31799087E-06_JPRB, 0.31799149E-06_JPRB, 0.31798874E-06_JPRB, 0.31798825E-06_JPRB, &
  & 0.31798834E-06_JPRB, 0.31799092E-06_JPRB, 0.31798942E-06_JPRB, 0.31798635E-06_JPRB /)

RGHG3(:,80, 6) = (/ &
  & 0.31797231E-06_JPRB, 0.31797885E-06_JPRB, 0.31798123E-06_JPRB, 0.31798439E-06_JPRB, 0.31798149E-06_JPRB, 0.31798365E-06_JPRB, &
  & 0.31798331E-06_JPRB, 0.31798484E-06_JPRB, 0.31798763E-06_JPRB, 0.31798547E-06_JPRB, 0.31798467E-06_JPRB, 0.31798771E-06_JPRB, &
  & 0.31798743E-06_JPRB, 0.31799135E-06_JPRB, 0.31798697E-06_JPRB, 0.31798737E-06_JPRB, 0.31798825E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31798854E-06_JPRB, 0.31798999E-06_JPRB, 0.31798899E-06_JPRB, 0.31799129E-06_JPRB, 0.31799223E-06_JPRB, 0.31799098E-06_JPRB, &
  & 0.31799408E-06_JPRB, 0.31799436E-06_JPRB, 0.31799610E-06_JPRB, 0.31799848E-06_JPRB, 0.31799829E-06_JPRB, 0.31799996E-06_JPRB, &
  & 0.31799880E-06_JPRB, 0.31800008E-06_JPRB, 0.31799865E-06_JPRB, 0.31799846E-06_JPRB, 0.31799871E-06_JPRB, 0.31800045E-06_JPRB, &
  & 0.31799769E-06_JPRB, 0.31799749E-06_JPRB, 0.31799669E-06_JPRB, 0.31799570E-06_JPRB, 0.31799519E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799442E-06_JPRB, 0.31799496E-06_JPRB, 0.31799598E-06_JPRB, 0.31799490E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799473E-06_JPRB, 0.31799433E-06_JPRB, 0.31799709E-06_JPRB, 0.31799729E-06_JPRB, 0.31799763E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799618E-06_JPRB, 0.31799601E-06_JPRB, 0.31799263E-06_JPRB, 0.31799360E-06_JPRB, 0.31799053E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799055E-06_JPRB, 0.31799385E-06_JPRB, 0.31799289E-06_JPRB, 0.31799328E-06_JPRB /)

RGHG3(:,81, 6) = (/ &
  & 0.31797964E-06_JPRB, 0.31798123E-06_JPRB, 0.31798317E-06_JPRB, 0.31798623E-06_JPRB, 0.31798291E-06_JPRB, 0.31798507E-06_JPRB, &
  & 0.31798459E-06_JPRB, 0.31798669E-06_JPRB, 0.31798893E-06_JPRB, 0.31798606E-06_JPRB, 0.31798558E-06_JPRB, 0.31798902E-06_JPRB, &
  & 0.31798839E-06_JPRB, 0.31799260E-06_JPRB, 0.31798774E-06_JPRB, 0.31798817E-06_JPRB, 0.31798902E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31798950E-06_JPRB, 0.31799129E-06_JPRB, 0.31799016E-06_JPRB, 0.31799269E-06_JPRB, 0.31799362E-06_JPRB, 0.31799198E-06_JPRB, &
  & 0.31799530E-06_JPRB, 0.31799530E-06_JPRB, 0.31799695E-06_JPRB, 0.31799925E-06_JPRB, 0.31799885E-06_JPRB, 0.31800045E-06_JPRB, &
  & 0.31799917E-06_JPRB, 0.31800039E-06_JPRB, 0.31799885E-06_JPRB, 0.31799860E-06_JPRB, 0.31799885E-06_JPRB, 0.31800070E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799766E-06_JPRB, 0.31799689E-06_JPRB, 0.31799601E-06_JPRB, 0.31799564E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799613E-06_JPRB, 0.31799490E-06_JPRB, 0.31799550E-06_JPRB, 0.31799655E-06_JPRB, 0.31799541E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799485E-06_JPRB, 0.31799794E-06_JPRB, 0.31799817E-06_JPRB, 0.31799857E-06_JPRB, 0.31799618E-06_JPRB, &
  & 0.31799718E-06_JPRB, 0.31799703E-06_JPRB, 0.31799348E-06_JPRB, 0.31799456E-06_JPRB, 0.31799124E-06_JPRB, 0.31799104E-06_JPRB, &
  & 0.31799149E-06_JPRB, 0.31799513E-06_JPRB, 0.31799448E-06_JPRB, 0.31799874E-06_JPRB /)

RGHG3(:,82, 6) = (/ &
  & 0.31798021E-06_JPRB, 0.31798206E-06_JPRB, 0.31798407E-06_JPRB, 0.31798717E-06_JPRB, 0.31798362E-06_JPRB, 0.31798575E-06_JPRB, &
  & 0.31798527E-06_JPRB, 0.31798646E-06_JPRB, 0.31798925E-06_JPRB, 0.31798740E-06_JPRB, 0.31798652E-06_JPRB, 0.31798905E-06_JPRB, &
  & 0.31798879E-06_JPRB, 0.31799308E-06_JPRB, 0.31798811E-06_JPRB, 0.31798851E-06_JPRB, 0.31798939E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31798999E-06_JPRB, 0.31799198E-06_JPRB, 0.31799073E-06_JPRB, 0.31799348E-06_JPRB, 0.31799448E-06_JPRB, 0.31799243E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799573E-06_JPRB, 0.31799738E-06_JPRB, 0.31799976E-06_JPRB, 0.31799914E-06_JPRB, 0.31800070E-06_JPRB, &
  & 0.31799931E-06_JPRB, 0.31800059E-06_JPRB, 0.31799888E-06_JPRB, 0.31799863E-06_JPRB, 0.31799897E-06_JPRB, 0.31800084E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799775E-06_JPRB, 0.31799701E-06_JPRB, 0.31799615E-06_JPRB, 0.31799584E-06_JPRB, 0.31799777E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799516E-06_JPRB, 0.31799570E-06_JPRB, 0.31799681E-06_JPRB, 0.31799570E-06_JPRB, 0.31799684E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799516E-06_JPRB, 0.31799846E-06_JPRB, 0.31799871E-06_JPRB, 0.31799911E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31799763E-06_JPRB, 0.31799757E-06_JPRB, 0.31799379E-06_JPRB, 0.31799502E-06_JPRB, 0.31799158E-06_JPRB, 0.31799132E-06_JPRB, &
  & 0.31799186E-06_JPRB, 0.31799573E-06_JPRB, 0.31799507E-06_JPRB, 0.31799922E-06_JPRB /)

RGHG3(:,83, 6) = (/ &
  & 0.31798066E-06_JPRB, 0.31798248E-06_JPRB, 0.31798453E-06_JPRB, 0.31798771E-06_JPRB, 0.31798402E-06_JPRB, 0.31798612E-06_JPRB, &
  & 0.31798555E-06_JPRB, 0.31798794E-06_JPRB, 0.31798959E-06_JPRB, 0.31798686E-06_JPRB, 0.31798655E-06_JPRB, 0.31798959E-06_JPRB, &
  & 0.31798928E-06_JPRB, 0.31799331E-06_JPRB, 0.31798828E-06_JPRB, 0.31798868E-06_JPRB, 0.31798956E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799030E-06_JPRB, 0.31799240E-06_JPRB, 0.31799101E-06_JPRB, 0.31799397E-06_JPRB, 0.31799493E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799638E-06_JPRB, 0.31799604E-06_JPRB, 0.31799772E-06_JPRB, 0.31800005E-06_JPRB, 0.31799937E-06_JPRB, 0.31800090E-06_JPRB, &
  & 0.31799942E-06_JPRB, 0.31800067E-06_JPRB, 0.31799897E-06_JPRB, 0.31799868E-06_JPRB, 0.31799894E-06_JPRB, 0.31800082E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799772E-06_JPRB, 0.31799709E-06_JPRB, 0.31799627E-06_JPRB, 0.31799595E-06_JPRB, 0.31799777E-06_JPRB, &
  & 0.31799647E-06_JPRB, 0.31799527E-06_JPRB, 0.31799584E-06_JPRB, 0.31799695E-06_JPRB, 0.31799584E-06_JPRB, 0.31799706E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799533E-06_JPRB, 0.31799877E-06_JPRB, 0.31799900E-06_JPRB, 0.31799945E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31799792E-06_JPRB, 0.31799399E-06_JPRB, 0.31799527E-06_JPRB, 0.31799172E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799203E-06_JPRB, 0.31799615E-06_JPRB, 0.31799541E-06_JPRB, 0.31799965E-06_JPRB /)

RGHG3(:,84, 6) = (/ &
  & 0.31798089E-06_JPRB, 0.31798277E-06_JPRB, 0.31798484E-06_JPRB, 0.31798808E-06_JPRB, 0.31798430E-06_JPRB, 0.31798643E-06_JPRB, &
  & 0.31798595E-06_JPRB, 0.31798692E-06_JPRB, 0.31798942E-06_JPRB, 0.31798808E-06_JPRB, 0.31798737E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31798942E-06_JPRB, 0.31799294E-06_JPRB, 0.31798874E-06_JPRB, 0.31798882E-06_JPRB, 0.31798965E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799041E-06_JPRB, 0.31799271E-06_JPRB, 0.31799121E-06_JPRB, 0.31799436E-06_JPRB, 0.31799536E-06_JPRB, 0.31799269E-06_JPRB, &
  & 0.31799667E-06_JPRB, 0.31799627E-06_JPRB, 0.31799786E-06_JPRB, 0.31800028E-06_JPRB, 0.31799948E-06_JPRB, 0.31800101E-06_JPRB, &
  & 0.31799954E-06_JPRB, 0.31800073E-06_JPRB, 0.31799897E-06_JPRB, 0.31799860E-06_JPRB, 0.31799897E-06_JPRB, 0.31800090E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799769E-06_JPRB, 0.31799703E-06_JPRB, 0.31799630E-06_JPRB, 0.31799607E-06_JPRB, 0.31799777E-06_JPRB, &
  & 0.31799658E-06_JPRB, 0.31799539E-06_JPRB, 0.31799593E-06_JPRB, 0.31799706E-06_JPRB, 0.31799595E-06_JPRB, 0.31799718E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799541E-06_JPRB, 0.31799902E-06_JPRB, 0.31799928E-06_JPRB, 0.31799973E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31799806E-06_JPRB, 0.31799408E-06_JPRB, 0.31799544E-06_JPRB, 0.31799181E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799638E-06_JPRB, 0.31799567E-06_JPRB, 0.31799993E-06_JPRB /)

RGHG3(:,85, 6) = (/ &
  & 0.31798109E-06_JPRB, 0.31798294E-06_JPRB, 0.31798507E-06_JPRB, 0.31798831E-06_JPRB, 0.31798430E-06_JPRB, 0.31798649E-06_JPRB, &
  & 0.31798606E-06_JPRB, 0.31798828E-06_JPRB, 0.31798936E-06_JPRB, 0.31798749E-06_JPRB, 0.31798737E-06_JPRB, 0.31798956E-06_JPRB, &
  & 0.31798976E-06_JPRB, 0.31799220E-06_JPRB, 0.31798902E-06_JPRB, 0.31798902E-06_JPRB, 0.31798979E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799055E-06_JPRB, 0.31799286E-06_JPRB, 0.31799138E-06_JPRB, 0.31799462E-06_JPRB, 0.31799561E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799695E-06_JPRB, 0.31799635E-06_JPRB, 0.31799811E-06_JPRB, 0.31800050E-06_JPRB, 0.31799954E-06_JPRB, 0.31800110E-06_JPRB, &
  & 0.31799965E-06_JPRB, 0.31800084E-06_JPRB, 0.31799897E-06_JPRB, 0.31799857E-06_JPRB, 0.31799897E-06_JPRB, 0.31800096E-06_JPRB, &
  & 0.31799792E-06_JPRB, 0.31799769E-06_JPRB, 0.31799709E-06_JPRB, 0.31799635E-06_JPRB, 0.31799615E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799544E-06_JPRB, 0.31799601E-06_JPRB, 0.31799703E-06_JPRB, 0.31799610E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31799618E-06_JPRB, 0.31799550E-06_JPRB, 0.31799914E-06_JPRB, 0.31799948E-06_JPRB, 0.31799991E-06_JPRB, 0.31799718E-06_JPRB, &
  & 0.31799840E-06_JPRB, 0.31799823E-06_JPRB, 0.31799414E-06_JPRB, 0.31799553E-06_JPRB, 0.31799183E-06_JPRB, 0.31799161E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799655E-06_JPRB, 0.31799584E-06_JPRB, 0.31800019E-06_JPRB /)

RGHG3(:,86, 6) = (/ &
  & 0.31798118E-06_JPRB, 0.31798305E-06_JPRB, 0.31798515E-06_JPRB, 0.31798857E-06_JPRB, 0.31798464E-06_JPRB, 0.31798655E-06_JPRB, &
  & 0.31798652E-06_JPRB, 0.31798729E-06_JPRB, 0.31798911E-06_JPRB, 0.31798845E-06_JPRB, 0.31798822E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31798973E-06_JPRB, 0.31799129E-06_JPRB, 0.31798939E-06_JPRB, 0.31798930E-06_JPRB, 0.31798999E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799073E-06_JPRB, 0.31799294E-06_JPRB, 0.31799149E-06_JPRB, 0.31799482E-06_JPRB, 0.31799584E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799709E-06_JPRB, 0.31799649E-06_JPRB, 0.31799823E-06_JPRB, 0.31800070E-06_JPRB, 0.31799965E-06_JPRB, 0.31800121E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31800087E-06_JPRB, 0.31799897E-06_JPRB, 0.31799851E-06_JPRB, 0.31799900E-06_JPRB, 0.31800107E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799766E-06_JPRB, 0.31799709E-06_JPRB, 0.31799635E-06_JPRB, 0.31799618E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799658E-06_JPRB, 0.31799550E-06_JPRB, 0.31799604E-06_JPRB, 0.31799706E-06_JPRB, 0.31799618E-06_JPRB, 0.31799726E-06_JPRB, &
  & 0.31799630E-06_JPRB, 0.31799564E-06_JPRB, 0.31799922E-06_JPRB, 0.31799956E-06_JPRB, 0.31800002E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31799851E-06_JPRB, 0.31799834E-06_JPRB, 0.31799419E-06_JPRB, 0.31799561E-06_JPRB, 0.31799183E-06_JPRB, 0.31799166E-06_JPRB, &
  & 0.31799232E-06_JPRB, 0.31799672E-06_JPRB, 0.31799598E-06_JPRB, 0.31800030E-06_JPRB /)

RGHG3(:,87, 6) = (/ &
  & 0.31798123E-06_JPRB, 0.31798314E-06_JPRB, 0.31798515E-06_JPRB, 0.31798839E-06_JPRB, 0.31798461E-06_JPRB, 0.31798669E-06_JPRB, &
  & 0.31798646E-06_JPRB, 0.31798828E-06_JPRB, 0.31798899E-06_JPRB, 0.31798803E-06_JPRB, 0.31798803E-06_JPRB, 0.31798942E-06_JPRB, &
  & 0.31798970E-06_JPRB, 0.31799090E-06_JPRB, 0.31798950E-06_JPRB, 0.31798947E-06_JPRB, 0.31799001E-06_JPRB, 0.31799192E-06_JPRB, &
  & 0.31799084E-06_JPRB, 0.31799294E-06_JPRB, 0.31799152E-06_JPRB, 0.31799487E-06_JPRB, 0.31799590E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799723E-06_JPRB, 0.31799652E-06_JPRB, 0.31799843E-06_JPRB, 0.31800084E-06_JPRB, 0.31799968E-06_JPRB, 0.31800138E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31800090E-06_JPRB, 0.31799894E-06_JPRB, 0.31799848E-06_JPRB, 0.31799897E-06_JPRB, 0.31800121E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799763E-06_JPRB, 0.31799709E-06_JPRB, 0.31799630E-06_JPRB, 0.31799618E-06_JPRB, 0.31799794E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799544E-06_JPRB, 0.31799610E-06_JPRB, 0.31799703E-06_JPRB, 0.31799627E-06_JPRB, 0.31799721E-06_JPRB, &
  & 0.31799632E-06_JPRB, 0.31799578E-06_JPRB, 0.31799922E-06_JPRB, 0.31799956E-06_JPRB, 0.31800002E-06_JPRB, 0.31799743E-06_JPRB, &
  & 0.31799863E-06_JPRB, 0.31799840E-06_JPRB, 0.31799422E-06_JPRB, 0.31799573E-06_JPRB, 0.31799181E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799237E-06_JPRB, 0.31799684E-06_JPRB, 0.31799604E-06_JPRB, 0.31800045E-06_JPRB /)

RGHG3(:,88, 6) = (/ &
  & 0.31798135E-06_JPRB, 0.31798322E-06_JPRB, 0.31798521E-06_JPRB, 0.31798862E-06_JPRB, 0.31798498E-06_JPRB, 0.31798663E-06_JPRB, &
  & 0.31798677E-06_JPRB, 0.31798743E-06_JPRB, 0.31798885E-06_JPRB, 0.31798845E-06_JPRB, 0.31798851E-06_JPRB, 0.31798928E-06_JPRB, &
  & 0.31798976E-06_JPRB, 0.31799073E-06_JPRB, 0.31798959E-06_JPRB, 0.31798956E-06_JPRB, 0.31799013E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799095E-06_JPRB, 0.31799286E-06_JPRB, 0.31799155E-06_JPRB, 0.31799490E-06_JPRB, 0.31799604E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799735E-06_JPRB, 0.31799658E-06_JPRB, 0.31799843E-06_JPRB, 0.31800099E-06_JPRB, 0.31799971E-06_JPRB, 0.31800153E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31800099E-06_JPRB, 0.31799894E-06_JPRB, 0.31799846E-06_JPRB, 0.31799891E-06_JPRB, 0.31800141E-06_JPRB, &
  & 0.31799757E-06_JPRB, 0.31799766E-06_JPRB, 0.31799709E-06_JPRB, 0.31799613E-06_JPRB, 0.31799595E-06_JPRB, 0.31799823E-06_JPRB, &
  & 0.31799664E-06_JPRB, 0.31799530E-06_JPRB, 0.31799607E-06_JPRB, 0.31799703E-06_JPRB, 0.31799630E-06_JPRB, 0.31799718E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799601E-06_JPRB, 0.31799914E-06_JPRB, 0.31799965E-06_JPRB, 0.31800005E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799868E-06_JPRB, 0.31799843E-06_JPRB, 0.31799422E-06_JPRB, 0.31799578E-06_JPRB, 0.31799181E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799240E-06_JPRB, 0.31799698E-06_JPRB, 0.31799604E-06_JPRB, 0.31800053E-06_JPRB /)

RGHG3(:,89, 6) = (/ &
  & 0.31798152E-06_JPRB, 0.31798336E-06_JPRB, 0.31798521E-06_JPRB, 0.31798828E-06_JPRB, 0.31798473E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31798658E-06_JPRB, 0.31798817E-06_JPRB, 0.31798891E-06_JPRB, 0.31798820E-06_JPRB, 0.31798822E-06_JPRB, 0.31798939E-06_JPRB, &
  & 0.31798976E-06_JPRB, 0.31799092E-06_JPRB, 0.31798953E-06_JPRB, 0.31798953E-06_JPRB, 0.31799010E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799098E-06_JPRB, 0.31799303E-06_JPRB, 0.31799158E-06_JPRB, 0.31799499E-06_JPRB, 0.31799615E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799746E-06_JPRB, 0.31799664E-06_JPRB, 0.31799851E-06_JPRB, 0.31800113E-06_JPRB, 0.31799971E-06_JPRB, 0.31800167E-06_JPRB, &
  & 0.31799956E-06_JPRB, 0.31800107E-06_JPRB, 0.31799891E-06_JPRB, 0.31799843E-06_JPRB, 0.31799888E-06_JPRB, 0.31800153E-06_JPRB, &
  & 0.31799740E-06_JPRB, 0.31799766E-06_JPRB, 0.31799709E-06_JPRB, 0.31799601E-06_JPRB, 0.31799576E-06_JPRB, 0.31799860E-06_JPRB, &
  & 0.31799658E-06_JPRB, 0.31799522E-06_JPRB, 0.31799613E-06_JPRB, 0.31799709E-06_JPRB, 0.31799630E-06_JPRB, 0.31799712E-06_JPRB, &
  & 0.31799647E-06_JPRB, 0.31799613E-06_JPRB, 0.31799911E-06_JPRB, 0.31799962E-06_JPRB, 0.31800002E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799877E-06_JPRB, 0.31799846E-06_JPRB, 0.31799416E-06_JPRB, 0.31799590E-06_JPRB, 0.31799175E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799226E-06_JPRB, 0.31799703E-06_JPRB, 0.31799607E-06_JPRB, 0.31800059E-06_JPRB /)

RGHG3(:,90, 6) = (/ &
  & 0.31798172E-06_JPRB, 0.31798351E-06_JPRB, 0.31798510E-06_JPRB, 0.31798851E-06_JPRB, 0.31798467E-06_JPRB, 0.31798677E-06_JPRB, &
  & 0.31798652E-06_JPRB, 0.31798754E-06_JPRB, 0.31798908E-06_JPRB, 0.31798842E-06_JPRB, 0.31798834E-06_JPRB, 0.31798928E-06_JPRB, &
  & 0.31798982E-06_JPRB, 0.31799141E-06_JPRB, 0.31798928E-06_JPRB, 0.31798925E-06_JPRB, 0.31798993E-06_JPRB, 0.31799252E-06_JPRB, &
  & 0.31799075E-06_JPRB, 0.31799317E-06_JPRB, 0.31799138E-06_JPRB, 0.31799505E-06_JPRB, 0.31799632E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799763E-06_JPRB, 0.31799655E-06_JPRB, 0.31799860E-06_JPRB, 0.31800130E-06_JPRB, 0.31799962E-06_JPRB, 0.31800187E-06_JPRB, &
  & 0.31799948E-06_JPRB, 0.31800121E-06_JPRB, 0.31799888E-06_JPRB, 0.31799837E-06_JPRB, 0.31799880E-06_JPRB, 0.31800181E-06_JPRB, &
  & 0.31799726E-06_JPRB, 0.31799763E-06_JPRB, 0.31799715E-06_JPRB, 0.31799590E-06_JPRB, 0.31799541E-06_JPRB, 0.31799905E-06_JPRB, &
  & 0.31799667E-06_JPRB, 0.31799505E-06_JPRB, 0.31799615E-06_JPRB, 0.31799721E-06_JPRB, 0.31799624E-06_JPRB, 0.31799715E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799607E-06_JPRB, 0.31799911E-06_JPRB, 0.31799971E-06_JPRB, 0.31800013E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799883E-06_JPRB, 0.31799857E-06_JPRB, 0.31799402E-06_JPRB, 0.31799604E-06_JPRB, 0.31799169E-06_JPRB, 0.31799166E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799726E-06_JPRB, 0.31799601E-06_JPRB, 0.31800067E-06_JPRB /)

RGHG3(:,91, 6) = (/ &
  & 0.31798160E-06_JPRB, 0.31798339E-06_JPRB, 0.31798433E-06_JPRB, 0.31798970E-06_JPRB, 0.31798371E-06_JPRB, 0.31798723E-06_JPRB, &
  & 0.31798515E-06_JPRB, 0.31798695E-06_JPRB, 0.31799038E-06_JPRB, 0.31798882E-06_JPRB, 0.31798737E-06_JPRB, 0.31798885E-06_JPRB, &
  & 0.31798825E-06_JPRB, 0.31799613E-06_JPRB, 0.31798717E-06_JPRB, 0.31798871E-06_JPRB, 0.31798933E-06_JPRB, 0.31799382E-06_JPRB, &
  & 0.31799010E-06_JPRB, 0.31799368E-06_JPRB, 0.31799095E-06_JPRB, 0.31799522E-06_JPRB, 0.31799664E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799638E-06_JPRB, 0.31799857E-06_JPRB, 0.31800164E-06_JPRB, 0.31799937E-06_JPRB, 0.31800229E-06_JPRB, &
  & 0.31799914E-06_JPRB, 0.31800153E-06_JPRB, 0.31799865E-06_JPRB, 0.31799826E-06_JPRB, 0.31799860E-06_JPRB, 0.31800235E-06_JPRB, &
  & 0.31799692E-06_JPRB, 0.31799772E-06_JPRB, 0.31799726E-06_JPRB, 0.31799584E-06_JPRB, 0.31799507E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31799658E-06_JPRB, 0.31799459E-06_JPRB, 0.31799618E-06_JPRB, 0.31799755E-06_JPRB, 0.31799587E-06_JPRB, 0.31799746E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799561E-06_JPRB, 0.31799942E-06_JPRB, 0.31799979E-06_JPRB, 0.31800042E-06_JPRB, 0.31799729E-06_JPRB, &
  & 0.31799902E-06_JPRB, 0.31799883E-06_JPRB, 0.31799357E-06_JPRB, 0.31799641E-06_JPRB, 0.31799141E-06_JPRB, 0.31799163E-06_JPRB, &
  & 0.31799195E-06_JPRB, 0.31799763E-06_JPRB, 0.31799593E-06_JPRB, 0.31800084E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG3(:, 1, 7) = (/ &
  & 0.10188977E-06_JPRB, 0.10177420E-06_JPRB, 0.10167798E-06_JPRB, 0.10154488E-06_JPRB, 0.10134264E-06_JPRB, 0.10105032E-06_JPRB, &
  & 0.10071878E-06_JPRB, 0.10038407E-06_JPRB, 0.10006387E-06_JPRB, 0.99762651E-07_JPRB, 0.99479635E-07_JPRB, 0.99212983E-07_JPRB, &
  & 0.98961884E-07_JPRB, 0.98726510E-07_JPRB, 0.98506987E-07_JPRB, 0.98302564E-07_JPRB, 0.98111123E-07_JPRB, 0.97929160E-07_JPRB, &
  & 0.97752519E-07_JPRB, 0.97576937E-07_JPRB, 0.97398896E-07_JPRB, 0.97216144E-07_JPRB, 0.97026913E-07_JPRB, 0.96828288E-07_JPRB, &
  & 0.96619459E-07_JPRB, 0.96404683E-07_JPRB, 0.96192800E-07_JPRB, 0.95997159E-07_JPRB, 0.95819018E-07_JPRB, 0.95653348E-07_JPRB, &
  & 0.95495707E-07_JPRB, 0.95342088E-07_JPRB, 0.95191467E-07_JPRB, 0.95043276E-07_JPRB, 0.94898461E-07_JPRB, 0.94758335E-07_JPRB, &
  & 0.94622912E-07_JPRB, 0.94488669E-07_JPRB, 0.94353801E-07_JPRB, 0.94229840E-07_JPRB, 0.94112103E-07_JPRB, 0.93978642E-07_JPRB, &
  & 0.93818180E-07_JPRB, 0.93611455E-07_JPRB, 0.93337462E-07_JPRB, 0.92942422E-07_JPRB, 0.92381597E-07_JPRB, 0.91832376E-07_JPRB, &
  & 0.91454837E-07_JPRB, 0.91119134E-07_JPRB, 0.90798665E-07_JPRB, 0.90487781E-07_JPRB, 0.90187669E-07_JPRB, 0.89902386E-07_JPRB, &
  & 0.89626518E-07_JPRB, 0.89388905E-07_JPRB, 0.89231634E-07_JPRB, 0.89118338E-07_JPRB, 0.89025349E-07_JPRB, 0.88954422E-07_JPRB, &
  & 0.88906177E-07_JPRB, 0.88881634E-07_JPRB, 0.88886196E-07_JPRB, 0.88926512E-07_JPRB /)

RGHG3(:, 2, 7) = (/ &
  & 0.10179909E-06_JPRB, 0.10163156E-06_JPRB, 0.10148636E-06_JPRB, 0.10130517E-06_JPRB, 0.10105960E-06_JPRB, 0.10073600E-06_JPRB, &
  & 0.10036008E-06_JPRB, 0.99972695E-07_JPRB, 0.99606822E-07_JPRB, 0.99276605E-07_JPRB, 0.98987094E-07_JPRB, 0.98740159E-07_JPRB, &
  & 0.98533505E-07_JPRB, 0.98361113E-07_JPRB, 0.98213334E-07_JPRB, 0.98079880E-07_JPRB, 0.97950995E-07_JPRB, 0.97818130E-07_JPRB, &
  & 0.97674182E-07_JPRB, 0.97514729E-07_JPRB, 0.97338891E-07_JPRB, 0.97149723E-07_JPRB, 0.96954054E-07_JPRB, 0.96761219E-07_JPRB, &
  & 0.96582497E-07_JPRB, 0.96429652E-07_JPRB, 0.96309840E-07_JPRB, 0.96220745E-07_JPRB, 0.96149556E-07_JPRB, 0.96077045E-07_JPRB, &
  & 0.95983197E-07_JPRB, 0.95851419E-07_JPRB, 0.95668724E-07_JPRB, 0.95431218E-07_JPRB, 0.95143335E-07_JPRB, 0.94817040E-07_JPRB, &
  & 0.94471901E-07_JPRB, 0.94131508E-07_JPRB, 0.93823978E-07_JPRB, 0.93567081E-07_JPRB, 0.93351730E-07_JPRB, 0.93149225E-07_JPRB, &
  & 0.92939700E-07_JPRB, 0.92704241E-07_JPRB, 0.92424209E-07_JPRB, 0.92079034E-07_JPRB, 0.91667793E-07_JPRB, 0.91251721E-07_JPRB, &
  & 0.90892577E-07_JPRB, 0.90572321E-07_JPRB, 0.90279045E-07_JPRB, 0.89986372E-07_JPRB, 0.89693678E-07_JPRB, 0.89387427E-07_JPRB, &
  & 0.89081439E-07_JPRB, 0.88789818E-07_JPRB, 0.88547687E-07_JPRB, 0.88357062E-07_JPRB, 0.88210328E-07_JPRB, 0.88129298E-07_JPRB, &
  & 0.88108997E-07_JPRB, 0.88135678E-07_JPRB, 0.88236142E-07_JPRB, 0.88482317E-07_JPRB /)

RGHG3(:, 3, 7) = (/ &
  & 0.10180811E-06_JPRB, 0.10165353E-06_JPRB, 0.10151465E-06_JPRB, 0.10134415E-06_JPRB, 0.10111434E-06_JPRB, 0.10081591E-06_JPRB, &
  & 0.10046997E-06_JPRB, 0.10012459E-06_JPRB, 0.99831205E-07_JPRB, 0.99596406E-07_JPRB, 0.99417605E-07_JPRB, 0.99286375E-07_JPRB, &
  & 0.99193649E-07_JPRB, 0.99132322E-07_JPRB, 0.99093413E-07_JPRB, 0.99065069E-07_JPRB, 0.99033073E-07_JPRB, 0.98984323E-07_JPRB, &
  & 0.98908622E-07_JPRB, 0.98801607E-07_JPRB, 0.98664181E-07_JPRB, 0.98502248E-07_JPRB, 0.98326808E-07_JPRB, 0.98153826E-07_JPRB, &
  & 0.98000854E-07_JPRB, 0.97885426E-07_JPRB, 0.97813619E-07_JPRB, 0.97776983E-07_JPRB, 0.97755127E-07_JPRB, 0.97721809E-07_JPRB, &
  & 0.97649462E-07_JPRB, 0.97513094E-07_JPRB, 0.97295356E-07_JPRB, 0.96990611E-07_JPRB, 0.96603408E-07_JPRB, 0.96145357E-07_JPRB, &
  & 0.95628231E-07_JPRB, 0.95074355E-07_JPRB, 0.94512188E-07_JPRB, 0.93982777E-07_JPRB, 0.93497263E-07_JPRB, 0.93051966E-07_JPRB, &
  & 0.92629335E-07_JPRB, 0.92212311E-07_JPRB, 0.91790213E-07_JPRB, 0.91353542E-07_JPRB, 0.90915393E-07_JPRB, 0.90504365E-07_JPRB, &
  & 0.90140496E-07_JPRB, 0.89819366E-07_JPRB, 0.89513719E-07_JPRB, 0.89210999E-07_JPRB, 0.88897615E-07_JPRB, 0.88564761E-07_JPRB, &
  & 0.88214499E-07_JPRB, 0.87859327E-07_JPRB, 0.87512696E-07_JPRB, 0.87187111E-07_JPRB, 0.86952021E-07_JPRB, 0.86794671E-07_JPRB, &
  & 0.86722764E-07_JPRB, 0.86732136E-07_JPRB, 0.86845311E-07_JPRB, 0.87265562E-07_JPRB /)

RGHG3(:, 4, 7) = (/ &
  & 0.10206382E-06_JPRB, 0.10204258E-06_JPRB, 0.10196933E-06_JPRB, 0.10183945E-06_JPRB, 0.10164526E-06_JPRB, 0.10138844E-06_JPRB, &
  & 0.10109400E-06_JPRB, 0.10081096E-06_JPRB, 0.10061056E-06_JPRB, 0.10048109E-06_JPRB, 0.10041528E-06_JPRB, 0.10041106E-06_JPRB, &
  & 0.10045968E-06_JPRB, 0.10054296E-06_JPRB, 0.10063692E-06_JPRB, 0.10072199E-06_JPRB, 0.10078908E-06_JPRB, 0.10083407E-06_JPRB, &
  & 0.10085104E-06_JPRB, 0.10083402E-06_JPRB, 0.10077946E-06_JPRB, 0.10068786E-06_JPRB, 0.10056427E-06_JPRB, 0.10041925E-06_JPRB, &
  & 0.10026793E-06_JPRB, 0.10013015E-06_JPRB, 0.10001993E-06_JPRB, 0.99936941E-07_JPRB, 0.99867265E-07_JPRB, 0.99788799E-07_JPRB, &
  & 0.99677912E-07_JPRB, 0.99514558E-07_JPRB, 0.99281728E-07_JPRB, 0.98973445E-07_JPRB, 0.98589950E-07_JPRB, 0.98134379E-07_JPRB, &
  & 0.97616464E-07_JPRB, 0.97035468E-07_JPRB, 0.96403596E-07_JPRB, 0.95733213E-07_JPRB, 0.95053707E-07_JPRB, 0.94380241E-07_JPRB, &
  & 0.93727991E-07_JPRB, 0.93104283E-07_JPRB, 0.92504891E-07_JPRB, 0.91929195E-07_JPRB, 0.91378283E-07_JPRB, 0.90863281E-07_JPRB, &
  & 0.90388987E-07_JPRB, 0.89943612E-07_JPRB, 0.89509641E-07_JPRB, 0.89079059E-07_JPRB, 0.88632603E-07_JPRB, 0.88171078E-07_JPRB, &
  & 0.87694829E-07_JPRB, 0.87198835E-07_JPRB, 0.86723567E-07_JPRB, 0.86310173E-07_JPRB, 0.85963961E-07_JPRB, 0.85738193E-07_JPRB, &
  & 0.85603162E-07_JPRB, 0.85579579E-07_JPRB, 0.85704556E-07_JPRB, 0.86015142E-07_JPRB /)

RGHG3(:, 5, 7) = (/ &
  & 0.10255756E-06_JPRB, 0.10277982E-06_JPRB, 0.10281875E-06_JPRB, 0.10275834E-06_JPRB, 0.10261886E-06_JPRB, 0.10242294E-06_JPRB, &
  & 0.10220714E-06_JPRB, 0.10201094E-06_JPRB, 0.10192133E-06_JPRB, 0.10192086E-06_JPRB, 0.10199503E-06_JPRB, 0.10213060E-06_JPRB, &
  & 0.10231026E-06_JPRB, 0.10252199E-06_JPRB, 0.10275859E-06_JPRB, 0.10300757E-06_JPRB, 0.10325057E-06_JPRB, 0.10346908E-06_JPRB, &
  & 0.10365267E-06_JPRB, 0.10379778E-06_JPRB, 0.10390162E-06_JPRB, 0.10395809E-06_JPRB, 0.10395878E-06_JPRB, 0.10389532E-06_JPRB, &
  & 0.10376227E-06_JPRB, 0.10356608E-06_JPRB, 0.10332612E-06_JPRB, 0.10306472E-06_JPRB, 0.10279833E-06_JPRB, 0.10253867E-06_JPRB, &
  & 0.10229314E-06_JPRB, 0.10206369E-06_JPRB, 0.10184375E-06_JPRB, 0.10162069E-06_JPRB, 0.10137907E-06_JPRB, 0.10110093E-06_JPRB, &
  & 0.10076904E-06_JPRB, 0.10037594E-06_JPRB, 0.99911226E-07_JPRB, 0.99367725E-07_JPRB, 0.98737829E-07_JPRB, 0.98035144E-07_JPRB, &
  & 0.97282886E-07_JPRB, 0.96505772E-07_JPRB, 0.95726790E-07_JPRB, 0.94940120E-07_JPRB, 0.94148689E-07_JPRB, 0.93349470E-07_JPRB, &
  & 0.92549797E-07_JPRB, 0.91747857E-07_JPRB, 0.90940603E-07_JPRB, 0.90124388E-07_JPRB, 0.89303370E-07_JPRB, 0.88482025E-07_JPRB, &
  & 0.87681926E-07_JPRB, 0.86931465E-07_JPRB, 0.86247709E-07_JPRB, 0.85647798E-07_JPRB, 0.85192312E-07_JPRB, 0.84882863E-07_JPRB, &
  & 0.84729450E-07_JPRB, 0.84680643E-07_JPRB, 0.84689816E-07_JPRB, 0.84925617E-07_JPRB /)

RGHG3(:, 6, 7) = (/ &
  & 0.10330693E-06_JPRB, 0.10386307E-06_JPRB, 0.10406495E-06_JPRB, 0.10412212E-06_JPRB, 0.10409207E-06_JPRB, 0.10402128E-06_JPRB, &
  & 0.10394311E-06_JPRB, 0.10388891E-06_JPRB, 0.10392189E-06_JPRB, 0.10405039E-06_JPRB, 0.10425531E-06_JPRB, 0.10452409E-06_JPRB, &
  & 0.10484818E-06_JPRB, 0.10521727E-06_JPRB, 0.10561911E-06_JPRB, 0.10604214E-06_JPRB, 0.10648181E-06_JPRB, 0.10692675E-06_JPRB, &
  & 0.10735076E-06_JPRB, 0.10772473E-06_JPRB, 0.10803413E-06_JPRB, 0.10827399E-06_JPRB, 0.10843544E-06_JPRB, 0.10849829E-06_JPRB, &
  & 0.10843496E-06_JPRB, 0.10822542E-06_JPRB, 0.10786842E-06_JPRB, 0.10739145E-06_JPRB, 0.10684892E-06_JPRB, 0.10630527E-06_JPRB, &
  & 0.10582021E-06_JPRB, 0.10545076E-06_JPRB, 0.10523486E-06_JPRB, 0.10517760E-06_JPRB, 0.10523711E-06_JPRB, 0.10535153E-06_JPRB, &
  & 0.10546673E-06_JPRB, 0.10554416E-06_JPRB, 0.10554965E-06_JPRB, 0.10544077E-06_JPRB, 0.10517194E-06_JPRB, 0.10470587E-06_JPRB, &
  & 0.10403762E-06_JPRB, 0.10319735E-06_JPRB, 0.10221564E-06_JPRB, 0.10111511E-06_JPRB, 0.99903062E-07_JPRB, 0.98587883E-07_JPRB, &
  & 0.97189350E-07_JPRB, 0.95728176E-07_JPRB, 0.94233158E-07_JPRB, 0.92733949E-07_JPRB, 0.91261150E-07_JPRB, 0.89848726E-07_JPRB, &
  & 0.88526285E-07_JPRB, 0.87319499E-07_JPRB, 0.86251084E-07_JPRB, 0.85363354E-07_JPRB, 0.84697959E-07_JPRB, 0.84275854E-07_JPRB, &
  & 0.84022460E-07_JPRB, 0.83904155E-07_JPRB, 0.83910130E-07_JPRB, 0.84070265E-07_JPRB /)

RGHG3(:, 7, 7) = (/ &
  & 0.10439901E-06_JPRB, 0.10535582E-06_JPRB, 0.10577227E-06_JPRB, 0.10601458E-06_JPRB, 0.10616946E-06_JPRB, 0.10628888E-06_JPRB, &
  & 0.10640119E-06_JPRB, 0.10651983E-06_JPRB, 0.10668270E-06_JPRB, 0.10692568E-06_JPRB, 0.10724299E-06_JPRB, 0.10762430E-06_JPRB, &
  & 0.10805772E-06_JPRB, 0.10853587E-06_JPRB, 0.10905453E-06_JPRB, 0.10960347E-06_JPRB, 0.11016668E-06_JPRB, 0.11072780E-06_JPRB, &
  & 0.11127850E-06_JPRB, 0.11180745E-06_JPRB, 0.11229480E-06_JPRB, 0.11272417E-06_JPRB, 0.11308501E-06_JPRB, 0.11335527E-06_JPRB, &
  & 0.11349420E-06_JPRB, 0.11345290E-06_JPRB, 0.11319328E-06_JPRB, 0.11270832E-06_JPRB, 0.11203495E-06_JPRB, 0.11125984E-06_JPRB, &
  & 0.11052148E-06_JPRB, 0.10999008E-06_JPRB, 0.10980298E-06_JPRB, 0.11000803E-06_JPRB, 0.11054918E-06_JPRB, 0.11130435E-06_JPRB, &
  & 0.11215295E-06_JPRB, 0.11299704E-06_JPRB, 0.11375832E-06_JPRB, 0.11434571E-06_JPRB, 0.11465703E-06_JPRB, 0.11459697E-06_JPRB, &
  & 0.11411966E-06_JPRB, 0.11324544E-06_JPRB, 0.11203021E-06_JPRB, 0.11051068E-06_JPRB, 0.10872320E-06_JPRB, 0.10669229E-06_JPRB, &
  & 0.10446696E-06_JPRB, 0.10210215E-06_JPRB, 0.99672945E-07_JPRB, 0.97247636E-07_JPRB, 0.94896308E-07_JPRB, 0.92681290E-07_JPRB, &
  & 0.90647802E-07_JPRB, 0.88837588E-07_JPRB, 0.87275644E-07_JPRB, 0.85987807E-07_JPRB, 0.85020226E-07_JPRB, 0.84363819E-07_JPRB, &
  & 0.83942545E-07_JPRB, 0.83687432E-07_JPRB, 0.83537309E-07_JPRB, 0.83486817E-07_JPRB /)

RGHG3(:, 8, 7) = (/ &
  & 0.10594266E-06_JPRB, 0.10730784E-06_JPRB, 0.10795213E-06_JPRB, 0.10840302E-06_JPRB, 0.10876079E-06_JPRB, 0.10908668E-06_JPRB, &
  & 0.10939534E-06_JPRB, 0.10969376E-06_JPRB, 0.11000161E-06_JPRB, 0.11034608E-06_JPRB, 0.11073791E-06_JPRB, 0.11117304E-06_JPRB, &
  & 0.11164467E-06_JPRB, 0.11214716E-06_JPRB, 0.11267734E-06_JPRB, 0.11323378E-06_JPRB, 0.11381874E-06_JPRB, 0.11442958E-06_JPRB, &
  & 0.11505720E-06_JPRB, 0.11569649E-06_JPRB, 0.11634990E-06_JPRB, 0.11700248E-06_JPRB, 0.11762504E-06_JPRB, 0.11819219E-06_JPRB, &
  & 0.11866774E-06_JPRB, 0.11898913E-06_JPRB, 0.11908442E-06_JPRB, 0.11889163E-06_JPRB, 0.11839813E-06_JPRB, 0.11768695E-06_JPRB, &
  & 0.11695757E-06_JPRB, 0.11647308E-06_JPRB, 0.11643958E-06_JPRB, 0.11694915E-06_JPRB, 0.11797628E-06_JPRB, 0.11940273E-06_JPRB, &
  & 0.12105789E-06_JPRB, 0.12277896E-06_JPRB, 0.12442283E-06_JPRB, 0.12582485E-06_JPRB, 0.12681228E-06_JPRB, 0.12722769E-06_JPRB, &
  & 0.12698865E-06_JPRB, 0.12610387E-06_JPRB, 0.12462674E-06_JPRB, 0.12262369E-06_JPRB, 0.12015064E-06_JPRB, 0.11727015E-06_JPRB, &
  & 0.11407503E-06_JPRB, 0.11067630E-06_JPRB, 0.10720404E-06_JPRB, 0.10377764E-06_JPRB, 0.10050626E-06_JPRB, 0.97470647E-07_JPRB, &
  & 0.94742390E-07_JPRB, 0.92353623E-07_JPRB, 0.90330843E-07_JPRB, 0.88680366E-07_JPRB, 0.87443475E-07_JPRB, 0.86589750E-07_JPRB, &
  & 0.86003901E-07_JPRB, 0.85608029E-07_JPRB, 0.85277371E-07_JPRB, 0.84848459E-07_JPRB /)

RGHG3(:, 9, 7) = (/ &
  & 0.10786369E-06_JPRB, 0.10936324E-06_JPRB, 0.11008460E-06_JPRB, 0.11061165E-06_JPRB, 0.11110953E-06_JPRB, 0.11156932E-06_JPRB, &
  & 0.11205649E-06_JPRB, 0.11252958E-06_JPRB, 0.11300867E-06_JPRB, 0.11349221E-06_JPRB, 0.11398541E-06_JPRB, 0.11448751E-06_JPRB, &
  & 0.11499600E-06_JPRB, 0.11551147E-06_JPRB, 0.11603932E-06_JPRB, 0.11658782E-06_JPRB, 0.11716631E-06_JPRB, 0.11778501E-06_JPRB, &
  & 0.11845439E-06_JPRB, 0.11917784E-06_JPRB, 0.11995570E-06_JPRB, 0.12080069E-06_JPRB, 0.12172293E-06_JPRB, 0.12270579E-06_JPRB, &
  & 0.12370684E-06_JPRB, 0.12465503E-06_JPRB, 0.12545668E-06_JPRB, 0.12602145E-06_JPRB, 0.12630714E-06_JPRB, 0.12633876E-06_JPRB, &
  & 0.12623917E-06_JPRB, 0.12622671E-06_JPRB, 0.12654370E-06_JPRB, 0.12737463E-06_JPRB, 0.12879335E-06_JPRB, 0.13073414E-06_JPRB, &
  & 0.13303209E-06_JPRB, 0.13548299E-06_JPRB, 0.13785532E-06_JPRB, 0.13990035E-06_JPRB, 0.14138597E-06_JPRB, 0.14212296E-06_JPRB, &
  & 0.14200918E-06_JPRB, 0.14103357E-06_JPRB, 0.13924405E-06_JPRB, 0.13670734E-06_JPRB, 0.13350949E-06_JPRB, 0.12974954E-06_JPRB, &
  & 0.12556268E-06_JPRB, 0.12111927E-06_JPRB, 0.11660814E-06_JPRB, 0.11220535E-06_JPRB, 0.10806615E-06_JPRB, 0.10430906E-06_JPRB, &
  & 0.10101842E-06_JPRB, 0.98229812E-07_JPRB, 0.95952224E-07_JPRB, 0.94189879E-07_JPRB, 0.92947886E-07_JPRB, 0.92173451E-07_JPRB, &
  & 0.91740930E-07_JPRB, 0.91546241E-07_JPRB, 0.91545829E-07_JPRB, 0.91666422E-07_JPRB /)

RGHG3(:,10, 7) = (/ &
  & 0.10929500E-06_JPRB, 0.11004880E-06_JPRB, 0.11041661E-06_JPRB, 0.11081919E-06_JPRB, 0.11126814E-06_JPRB, 0.11184746E-06_JPRB, &
  & 0.11246203E-06_JPRB, 0.11316781E-06_JPRB, 0.11388853E-06_JPRB, 0.11462384E-06_JPRB, 0.11534886E-06_JPRB, 0.11605698E-06_JPRB, &
  & 0.11674609E-06_JPRB, 0.11741898E-06_JPRB, 0.11808380E-06_JPRB, 0.11875112E-06_JPRB, 0.11943767E-06_JPRB, 0.12016186E-06_JPRB, &
  & 0.12094794E-06_JPRB, 0.12183378E-06_JPRB, 0.12286391E-06_JPRB, 0.12408316E-06_JPRB, 0.12552476E-06_JPRB, 0.12719538E-06_JPRB, &
  & 0.12903406E-06_JPRB, 0.13095838E-06_JPRB, 0.13293558E-06_JPRB, 0.13491768E-06_JPRB, 0.13680190E-06_JPRB, 0.13848346E-06_JPRB, &
  & 0.13993025E-06_JPRB, 0.14122078E-06_JPRB, 0.14253979E-06_JPRB, 0.14408052E-06_JPRB, 0.14595228E-06_JPRB, 0.14815959E-06_JPRB, &
  & 0.15060944E-06_JPRB, 0.15311372E-06_JPRB, 0.15543591E-06_JPRB, 0.15732974E-06_JPRB, 0.15858294E-06_JPRB, 0.15903500E-06_JPRB, &
  & 0.15857884E-06_JPRB, 0.15719075E-06_JPRB, 0.15489944E-06_JPRB, 0.15177321E-06_JPRB, 0.14789507E-06_JPRB, 0.14337434E-06_JPRB, &
  & 0.13837629E-06_JPRB, 0.13310705E-06_JPRB, 0.12778226E-06_JPRB, 0.12261032E-06_JPRB, 0.11777410E-06_JPRB, 0.11342041E-06_JPRB, &
  & 0.10965572E-06_JPRB, 0.10652946E-06_JPRB, 0.10405346E-06_JPRB, 0.10221063E-06_JPRB, 0.10099738E-06_JPRB, 0.10033299E-06_JPRB, &
  & 0.10011202E-06_JPRB, 0.10020494E-06_JPRB, 0.10070959E-06_JPRB, 0.10185961E-06_JPRB /)

RGHG3(:,11, 7) = (/ &
  & 0.10830495E-06_JPRB, 0.10752849E-06_JPRB, 0.10740270E-06_JPRB, 0.10760483E-06_JPRB, 0.10807162E-06_JPRB, 0.10868177E-06_JPRB, &
  & 0.10950767E-06_JPRB, 0.11041108E-06_JPRB, 0.11142119E-06_JPRB, 0.11244845E-06_JPRB, 0.11346967E-06_JPRB, 0.11447050E-06_JPRB, &
  & 0.11545452E-06_JPRB, 0.11643824E-06_JPRB, 0.11744400E-06_JPRB, 0.11848336E-06_JPRB, 0.11957248E-06_JPRB, 0.12072140E-06_JPRB, &
  & 0.12195589E-06_JPRB, 0.12331037E-06_JPRB, 0.12485260E-06_JPRB, 0.12664536E-06_JPRB, 0.12873339E-06_JPRB, 0.13114573E-06_JPRB, &
  & 0.13390797E-06_JPRB, 0.13704846E-06_JPRB, 0.14051918E-06_JPRB, 0.14426875E-06_JPRB, 0.14834561E-06_JPRB, 0.15265732E-06_JPRB, &
  & 0.15695133E-06_JPRB, 0.16093958E-06_JPRB, 0.16447736E-06_JPRB, 0.16758707E-06_JPRB, 0.17032613E-06_JPRB, 0.17272799E-06_JPRB, &
  & 0.17478268E-06_JPRB, 0.17645017E-06_JPRB, 0.17765576E-06_JPRB, 0.17830205E-06_JPRB, 0.17831888E-06_JPRB, 0.17762153E-06_JPRB, &
  & 0.17615868E-06_JPRB, 0.17389789E-06_JPRB, 0.17083619E-06_JPRB, 0.16700514E-06_JPRB, 0.16247674E-06_JPRB, 0.15738473E-06_JPRB, &
  & 0.15190923E-06_JPRB, 0.14623110E-06_JPRB, 0.14056296E-06_JPRB, 0.13509614E-06_JPRB, 0.13000354E-06_JPRB, 0.12543009E-06_JPRB, &
  & 0.12148388E-06_JPRB, 0.11822293E-06_JPRB, 0.11566220E-06_JPRB, 0.11379897E-06_JPRB, 0.11263529E-06_JPRB, 0.11210742E-06_JPRB, &
  & 0.11213260E-06_JPRB, 0.11261562E-06_JPRB, 0.11381839E-06_JPRB, 0.11650009E-06_JPRB /)

RGHG3(:,12, 7) = (/ &
  & 0.10520487E-06_JPRB, 0.10459504E-06_JPRB, 0.10474223E-06_JPRB, 0.10515017E-06_JPRB, 0.10568866E-06_JPRB, 0.10642772E-06_JPRB, &
  & 0.10729381E-06_JPRB, 0.10839097E-06_JPRB, 0.10964908E-06_JPRB, 0.11108526E-06_JPRB, 0.11265946E-06_JPRB, 0.11435321E-06_JPRB, &
  & 0.11615182E-06_JPRB, 0.11802369E-06_JPRB, 0.11993509E-06_JPRB, 0.12181273E-06_JPRB, 0.12358633E-06_JPRB, 0.12521326E-06_JPRB, &
  & 0.12673962E-06_JPRB, 0.12828576E-06_JPRB, 0.13001778E-06_JPRB, 0.13207936E-06_JPRB, 0.13456001E-06_JPRB, 0.13751117E-06_JPRB, &
  & 0.14094260E-06_JPRB, 0.14489204E-06_JPRB, 0.14952229E-06_JPRB, 0.15493771E-06_JPRB, 0.16099115E-06_JPRB, 0.16758257E-06_JPRB, &
  & 0.17444285E-06_JPRB, 0.18100559E-06_JPRB, 0.18673899E-06_JPRB, 0.19143795E-06_JPRB, 0.19506611E-06_JPRB, 0.19765451E-06_JPRB, &
  & 0.19928359E-06_JPRB, 0.20003328E-06_JPRB, 0.19997432E-06_JPRB, 0.19922955E-06_JPRB, 0.19782131E-06_JPRB, 0.19579913E-06_JPRB, &
  & 0.19315257E-06_JPRB, 0.18988777E-06_JPRB, 0.18601258E-06_JPRB, 0.18155735E-06_JPRB, 0.17661313E-06_JPRB, 0.17128568E-06_JPRB, &
  & 0.16571079E-06_JPRB, 0.16009476E-06_JPRB, 0.15462480E-06_JPRB, 0.14945454E-06_JPRB, 0.14471173E-06_JPRB, 0.14049991E-06_JPRB, &
  & 0.13689477E-06_JPRB, 0.13393714E-06_JPRB, 0.13164855E-06_JPRB, 0.13004143E-06_JPRB, 0.12913587E-06_JPRB, 0.12890030E-06_JPRB, &
  & 0.12929476E-06_JPRB, 0.13023627E-06_JPRB, 0.13220387E-06_JPRB, 0.13633789E-06_JPRB /)

RGHG3(:,13, 7) = (/ &
  & 0.10612266E-06_JPRB, 0.10787262E-06_JPRB, 0.10891549E-06_JPRB, 0.10972096E-06_JPRB, 0.11052085E-06_JPRB, 0.11140287E-06_JPRB, &
  & 0.11258894E-06_JPRB, 0.11417371E-06_JPRB, 0.11635638E-06_JPRB, 0.11920120E-06_JPRB, 0.12274685E-06_JPRB, 0.12692024E-06_JPRB, &
  & 0.13150819E-06_JPRB, 0.13618167E-06_JPRB, 0.14051004E-06_JPRB, 0.14408988E-06_JPRB, 0.14664793E-06_JPRB, 0.14806473E-06_JPRB, &
  & 0.14851821E-06_JPRB, 0.14835425E-06_JPRB, 0.14805840E-06_JPRB, 0.14813141E-06_JPRB, 0.14889090E-06_JPRB, 0.15047692E-06_JPRB, &
  & 0.15295299E-06_JPRB, 0.15641271E-06_JPRB, 0.16093762E-06_JPRB, 0.16666712E-06_JPRB, 0.17367509E-06_JPRB, 0.18157547E-06_JPRB, &
  & 0.18981446E-06_JPRB, 0.19768606E-06_JPRB, 0.20458727E-06_JPRB, 0.21016832E-06_JPRB, 0.21431710E-06_JPRB, 0.21707244E-06_JPRB, &
  & 0.21854632E-06_JPRB, 0.21883635E-06_JPRB, 0.21814003E-06_JPRB, 0.21658653E-06_JPRB, 0.21431583E-06_JPRB, 0.21145692E-06_JPRB, &
  & 0.20803532E-06_JPRB, 0.20410815E-06_JPRB, 0.19973560E-06_JPRB, 0.19497408E-06_JPRB, 0.18989982E-06_JPRB, 0.18465037E-06_JPRB, &
  & 0.17942516E-06_JPRB, 0.17436912E-06_JPRB, 0.16959650E-06_JPRB, 0.16521118E-06_JPRB, 0.16128674E-06_JPRB, 0.15787516E-06_JPRB, &
  & 0.15500646E-06_JPRB, 0.15270442E-06_JPRB, 0.15098206E-06_JPRB, 0.14985876E-06_JPRB, 0.14937338E-06_JPRB, 0.14950531E-06_JPRB, &
  & 0.15026622E-06_JPRB, 0.15154428E-06_JPRB, 0.15397291E-06_JPRB, 0.15881818E-06_JPRB /)

RGHG3(:,14, 7) = (/ &
  & 0.12073897E-06_JPRB, 0.12516777E-06_JPRB, 0.12701106E-06_JPRB, 0.12795819E-06_JPRB, 0.12862806E-06_JPRB, 0.12936222E-06_JPRB, &
  & 0.13049427E-06_JPRB, 0.13234806E-06_JPRB, 0.13519221E-06_JPRB, 0.13914656E-06_JPRB, 0.14407593E-06_JPRB, 0.14962163E-06_JPRB, &
  & 0.15528647E-06_JPRB, 0.16057693E-06_JPRB, 0.16507055E-06_JPRB, 0.16846933E-06_JPRB, 0.17059790E-06_JPRB, 0.17148939E-06_JPRB, &
  & 0.17135980E-06_JPRB, 0.17058393E-06_JPRB, 0.16957648E-06_JPRB, 0.16871371E-06_JPRB, 0.16832023E-06_JPRB, 0.16864855E-06_JPRB, &
  & 0.16987318E-06_JPRB, 0.17219698E-06_JPRB, 0.17586099E-06_JPRB, 0.18099610E-06_JPRB, 0.18762391E-06_JPRB, 0.19545860E-06_JPRB, &
  & 0.20373940E-06_JPRB, 0.21177081E-06_JPRB, 0.21887456E-06_JPRB, 0.22465503E-06_JPRB, 0.22893792E-06_JPRB, 0.23170728E-06_JPRB, &
  & 0.23302941E-06_JPRB, 0.23307818E-06_JPRB, 0.23205830E-06_JPRB, 0.23015878E-06_JPRB, 0.22752738E-06_JPRB, 0.22432135E-06_JPRB, &
  & 0.22063963E-06_JPRB, 0.21654559E-06_JPRB, 0.21212175E-06_JPRB, 0.20745259E-06_JPRB, 0.20268169E-06_JPRB, 0.19795570E-06_JPRB, &
  & 0.19338970E-06_JPRB, 0.18911027E-06_JPRB, 0.18522348E-06_JPRB, 0.18178017E-06_JPRB, 0.17879560E-06_JPRB, 0.17627026E-06_JPRB, &
  & 0.17420251E-06_JPRB, 0.17259509E-06_JPRB, 0.17145710E-06_JPRB, 0.17081506E-06_JPRB, 0.17071162E-06_JPRB, 0.17113317E-06_JPRB, &
  & 0.17211950E-06_JPRB, 0.17353892E-06_JPRB, 0.17605137E-06_JPRB, 0.18088072E-06_JPRB /)

RGHG3(:,15, 7) = (/ &
  & 0.14962163E-06_JPRB, 0.15252127E-06_JPRB, 0.15340207E-06_JPRB, 0.15354080E-06_JPRB, 0.15352370E-06_JPRB, 0.15360817E-06_JPRB, &
  & 0.15410708E-06_JPRB, 0.15538245E-06_JPRB, 0.15764685E-06_JPRB, 0.16102045E-06_JPRB, 0.16536414E-06_JPRB, 0.17031670E-06_JPRB, &
  & 0.17539796E-06_JPRB, 0.18011153E-06_JPRB, 0.18404026E-06_JPRB, 0.18691902E-06_JPRB, 0.18868330E-06_JPRB, 0.18943142E-06_JPRB, &
  & 0.18942377E-06_JPRB, 0.18896910E-06_JPRB, 0.18836243E-06_JPRB, 0.18785009E-06_JPRB, 0.18763544E-06_JPRB, 0.18791172E-06_JPRB, &
  & 0.18888690E-06_JPRB, 0.19077859E-06_JPRB, 0.19383606E-06_JPRB, 0.19826294E-06_JPRB, 0.20404411E-06_JPRB, 0.21094279E-06_JPRB, &
  & 0.21843350E-06_JPRB, 0.22572810E-06_JPRB, 0.23219403E-06_JPRB, 0.23744674E-06_JPRB, 0.24122633E-06_JPRB, 0.24351772E-06_JPRB, &
  & 0.24448730E-06_JPRB, 0.24430003E-06_JPRB, 0.24314213E-06_JPRB, 0.24118555E-06_JPRB, 0.23858621E-06_JPRB, 0.23547278E-06_JPRB, &
  & 0.23193809E-06_JPRB, 0.22807419E-06_JPRB, 0.22397671E-06_JPRB, 0.21977513E-06_JPRB, 0.21558537E-06_JPRB, 0.21153380E-06_JPRB, &
  & 0.20775143E-06_JPRB, 0.20433524E-06_JPRB, 0.20132174E-06_JPRB, 0.19871143E-06_JPRB, 0.19648762E-06_JPRB, 0.19463322E-06_JPRB, &
  & 0.19313906E-06_JPRB, 0.19200837E-06_JPRB, 0.19125588E-06_JPRB, 0.19090953E-06_JPRB, 0.19101316E-06_JPRB, 0.19156276E-06_JPRB, &
  & 0.19258201E-06_JPRB, 0.19396833E-06_JPRB, 0.19627787E-06_JPRB, 0.20065558E-06_JPRB /)

RGHG3(:,16, 7) = (/ &
  & 0.17869758E-06_JPRB, 0.17890648E-06_JPRB, 0.17832421E-06_JPRB, 0.17768664E-06_JPRB, 0.17684980E-06_JPRB, 0.17619820E-06_JPRB, &
  & 0.17591509E-06_JPRB, 0.17631110E-06_JPRB, 0.17765694E-06_JPRB, 0.18004098E-06_JPRB, 0.18339401E-06_JPRB, 0.18742799E-06_JPRB, &
  & 0.19172123E-06_JPRB, 0.19586061E-06_JPRB, 0.19949303E-06_JPRB, 0.20236845E-06_JPRB, 0.20443193E-06_JPRB, 0.20580288E-06_JPRB, &
  & 0.20666252E-06_JPRB, 0.20722017E-06_JPRB, 0.20765698E-06_JPRB, 0.20812206E-06_JPRB, 0.20875102E-06_JPRB, 0.20969044E-06_JPRB, &
  & 0.21111518E-06_JPRB, 0.21322771E-06_JPRB, 0.21620569E-06_JPRB, 0.22015270E-06_JPRB, 0.22501565E-06_JPRB, 0.23055199E-06_JPRB, &
  & 0.23629750E-06_JPRB, 0.24169941E-06_JPRB, 0.24638027E-06_JPRB, 0.24999483E-06_JPRB, 0.25247198E-06_JPRB, 0.25386316E-06_JPRB, &
  & 0.25424427E-06_JPRB, 0.25375118E-06_JPRB, 0.25257040E-06_JPRB, 0.25082880E-06_JPRB, 0.24860194E-06_JPRB, 0.24595630E-06_JPRB, &
  & 0.24296619E-06_JPRB, 0.23969238E-06_JPRB, 0.23625739E-06_JPRB, 0.23274812E-06_JPRB, 0.22928236E-06_JPRB, 0.22598162E-06_JPRB, &
  & 0.22294178E-06_JPRB, 0.22019995E-06_JPRB, 0.21776721E-06_JPRB, 0.21563071E-06_JPRB, 0.21377868E-06_JPRB, 0.21220927E-06_JPRB, &
  & 0.21093271E-06_JPRB, 0.20996745E-06_JPRB, 0.20933355E-06_JPRB, 0.20905702E-06_JPRB, 0.20917334E-06_JPRB, 0.20968301E-06_JPRB, &
  & 0.21056603E-06_JPRB, 0.21179645E-06_JPRB, 0.21371706E-06_JPRB, 0.21743836E-06_JPRB /)

RGHG3(:,17, 7) = (/ &
  & 0.20143797E-06_JPRB, 0.20044965E-06_JPRB, 0.19893946E-06_JPRB, 0.19784122E-06_JPRB, 0.19652084E-06_JPRB, 0.19535858E-06_JPRB, &
  & 0.19447656E-06_JPRB, 0.19417311E-06_JPRB, 0.19469422E-06_JPRB, 0.19618470E-06_JPRB, 0.19867292E-06_JPRB, 0.20196079E-06_JPRB, &
  & 0.20575621E-06_JPRB, 0.20969867E-06_JPRB, 0.21348677E-06_JPRB, 0.21691076E-06_JPRB, 0.21985495E-06_JPRB, 0.22234143E-06_JPRB, &
  & 0.22448341E-06_JPRB, 0.22639188E-06_JPRB, 0.22818324E-06_JPRB, 0.22997367E-06_JPRB, 0.23187884E-06_JPRB, 0.23401397E-06_JPRB, &
  & 0.23647695E-06_JPRB, 0.23933643E-06_JPRB, 0.24261246E-06_JPRB, 0.24615727E-06_JPRB, 0.24977840E-06_JPRB, 0.25318465E-06_JPRB, &
  & 0.25627861E-06_JPRB, 0.25886499E-06_JPRB, 0.26085814E-06_JPRB, 0.26219104E-06_JPRB, 0.26287606E-06_JPRB, 0.26295618E-06_JPRB, &
  & 0.26257766E-06_JPRB, 0.26190492E-06_JPRB, 0.26092482E-06_JPRB, 0.25965252E-06_JPRB, 0.25808191E-06_JPRB, 0.25620767E-06_JPRB, &
  & 0.25403850E-06_JPRB, 0.25160566E-06_JPRB, 0.24897247E-06_JPRB, 0.24623435E-06_JPRB, 0.24347176E-06_JPRB, 0.24079606E-06_JPRB, &
  & 0.23825069E-06_JPRB, 0.23587016E-06_JPRB, 0.23367234E-06_JPRB, 0.23166409E-06_JPRB, 0.22985790E-06_JPRB, 0.22827642E-06_JPRB, &
  & 0.22695255E-06_JPRB, 0.22592161E-06_JPRB, 0.22521012E-06_JPRB, 0.22483933E-06_JPRB, 0.22482890E-06_JPRB, 0.22516993E-06_JPRB, &
  & 0.22582748E-06_JPRB, 0.22681203E-06_JPRB, 0.22827048E-06_JPRB, 0.23125851E-06_JPRB /)

RGHG3(:,18, 7) = (/ &
  & 0.21863491E-06_JPRB, 0.21692891E-06_JPRB, 0.21525163E-06_JPRB, 0.21390923E-06_JPRB, 0.21246316E-06_JPRB, 0.21108464E-06_JPRB, &
  & 0.20990743E-06_JPRB, 0.20917641E-06_JPRB, 0.20915702E-06_JPRB, 0.21004070E-06_JPRB, 0.21190792E-06_JPRB, 0.21468091E-06_JPRB, &
  & 0.21816987E-06_JPRB, 0.22213779E-06_JPRB, 0.22631177E-06_JPRB, 0.23044413E-06_JPRB, 0.23436067E-06_JPRB, 0.23796257E-06_JPRB, &
  & 0.24124856E-06_JPRB, 0.24429966E-06_JPRB, 0.24721319E-06_JPRB, 0.25009308E-06_JPRB, 0.25305005E-06_JPRB, 0.25617445E-06_JPRB, &
  & 0.25946758E-06_JPRB, 0.26280031E-06_JPRB, 0.26594884E-06_JPRB, 0.26871237E-06_JPRB, 0.27090954E-06_JPRB, 0.27247597E-06_JPRB, &
  & 0.27334517E-06_JPRB, 0.27363504E-06_JPRB, 0.27340209E-06_JPRB, 0.27277036E-06_JPRB, 0.27188784E-06_JPRB, 0.27095126E-06_JPRB, &
  & 0.27005285E-06_JPRB, 0.26920893E-06_JPRB, 0.26847604E-06_JPRB, 0.26776320E-06_JPRB, 0.26694821E-06_JPRB, 0.26592087E-06_JPRB, &
  & 0.26462166E-06_JPRB, 0.26302862E-06_JPRB, 0.26117559E-06_JPRB, 0.25911814E-06_JPRB, 0.25692296E-06_JPRB, 0.25466883E-06_JPRB, &
  & 0.25239922E-06_JPRB, 0.25015805E-06_JPRB, 0.24798624E-06_JPRB, 0.24592171E-06_JPRB, 0.24400182E-06_JPRB, 0.24227947E-06_JPRB, &
  & 0.24080464E-06_JPRB, 0.23962031E-06_JPRB, 0.23875140E-06_JPRB, 0.23821386E-06_JPRB, 0.23801628E-06_JPRB, 0.23813718E-06_JPRB, &
  & 0.23853869E-06_JPRB, 0.23921640E-06_JPRB, 0.24025564E-06_JPRB, 0.24252014E-06_JPRB /)

RGHG3(:,19, 7) = (/ &
  & 0.23160794E-06_JPRB, 0.22971147E-06_JPRB, 0.22815696E-06_JPRB, 0.22678893E-06_JPRB, 0.22539561E-06_JPRB, 0.22400565E-06_JPRB, &
  & 0.22274162E-06_JPRB, 0.22182063E-06_JPRB, 0.22149982E-06_JPRB, 0.22200352E-06_JPRB, 0.22346512E-06_JPRB, 0.22588671E-06_JPRB, &
  & 0.22916170E-06_JPRB, 0.23310739E-06_JPRB, 0.23749774E-06_JPRB, 0.24206912E-06_JPRB, 0.24654946E-06_JPRB, 0.25074758E-06_JPRB, &
  & 0.25458593E-06_JPRB, 0.25810908E-06_JPRB, 0.26144136E-06_JPRB, 0.26470897E-06_JPRB, 0.26799947E-06_JPRB, 0.27137017E-06_JPRB, &
  & 0.27476969E-06_JPRB, 0.27803566E-06_JPRB, 0.28092938E-06_JPRB, 0.28315992E-06_JPRB, 0.28458754E-06_JPRB, 0.28516337E-06_JPRB, &
  & 0.28497985E-06_JPRB, 0.28413021E-06_JPRB, 0.28277759E-06_JPRB, 0.28110236E-06_JPRB, 0.27930778E-06_JPRB, 0.27769738E-06_JPRB, &
  & 0.27644560E-06_JPRB, 0.27564064E-06_JPRB, 0.27522060E-06_JPRB, 0.27502159E-06_JPRB, 0.27484020E-06_JPRB, 0.27450940E-06_JPRB, &
  & 0.27390521E-06_JPRB, 0.27297239E-06_JPRB, 0.27171546E-06_JPRB, 0.27016756E-06_JPRB, 0.26838711E-06_JPRB, 0.26642945E-06_JPRB, &
  & 0.26434191E-06_JPRB, 0.26218305E-06_JPRB, 0.26001035E-06_JPRB, 0.25787929E-06_JPRB, 0.25585183E-06_JPRB, 0.25400527E-06_JPRB, &
  & 0.25239927E-06_JPRB, 0.25107502E-06_JPRB, 0.25005247E-06_JPRB, 0.24934343E-06_JPRB, 0.24895363E-06_JPRB, 0.24886029E-06_JPRB, &
  & 0.24901857E-06_JPRB, 0.24941045E-06_JPRB, 0.25010706E-06_JPRB, 0.25171047E-06_JPRB /)

RGHG3(:,20, 7) = (/ &
  & 0.24185351E-06_JPRB, 0.23995554E-06_JPRB, 0.23857652E-06_JPRB, 0.23731589E-06_JPRB, 0.23604410E-06_JPRB, 0.23474522E-06_JPRB, &
  & 0.23352217E-06_JPRB, 0.23255083E-06_JPRB, 0.23207622E-06_JPRB, 0.23235052E-06_JPRB, 0.23351240E-06_JPRB, 0.23561520E-06_JPRB, &
  & 0.23860866E-06_JPRB, 0.24235382E-06_JPRB, 0.24664726E-06_JPRB, 0.25120875E-06_JPRB, 0.25574309E-06_JPRB, 0.26000831E-06_JPRB, &
  & 0.26390714E-06_JPRB, 0.26745795E-06_JPRB, 0.27075862E-06_JPRB, 0.27394998E-06_JPRB, 0.27714520E-06_JPRB, 0.28038284E-06_JPRB, &
  & 0.28360984E-06_JPRB, 0.28666210E-06_JPRB, 0.28928110E-06_JPRB, 0.29122896E-06_JPRB, 0.29237356E-06_JPRB, 0.29270075E-06_JPRB, &
  & 0.29227397E-06_JPRB, 0.29116768E-06_JPRB, 0.28952735E-06_JPRB, 0.28757273E-06_JPRB, 0.28552057E-06_JPRB, 0.28372239E-06_JPRB, &
  & 0.28238114E-06_JPRB, 0.28162802E-06_JPRB, 0.28136898E-06_JPRB, 0.28144368E-06_JPRB, 0.28162498E-06_JPRB, 0.28169188E-06_JPRB, &
  & 0.28150220E-06_JPRB, 0.28098387E-06_JPRB, 0.28011374E-06_JPRB, 0.27890854E-06_JPRB, 0.27741231E-06_JPRB, 0.27567319E-06_JPRB, &
  & 0.27374719E-06_JPRB, 0.27169727E-06_JPRB, 0.26958492E-06_JPRB, 0.26746812E-06_JPRB, 0.26543444E-06_JPRB, 0.26355787E-06_JPRB, &
  & 0.26189895E-06_JPRB, 0.26049830E-06_JPRB, 0.25937305E-06_JPRB, 0.25853095E-06_JPRB, 0.25797749E-06_JPRB, 0.25769620E-06_JPRB, &
  & 0.25765007E-06_JPRB, 0.25781409E-06_JPRB, 0.25822132E-06_JPRB, 0.25928267E-06_JPRB /)

RGHG3(:,21, 7) = (/ &
  & 0.25029257E-06_JPRB, 0.24847799E-06_JPRB, 0.24726600E-06_JPRB, 0.24614349E-06_JPRB, 0.24500011E-06_JPRB, 0.24382413E-06_JPRB, &
  & 0.24267030E-06_JPRB, 0.24170905E-06_JPRB, 0.24116554E-06_JPRB, 0.24127203E-06_JPRB, 0.24218505E-06_JPRB, 0.24397517E-06_JPRB, &
  & 0.24661085E-06_JPRB, 0.24998587E-06_JPRB, 0.25391299E-06_JPRB, 0.25814518E-06_JPRB, 0.26239090E-06_JPRB, 0.26640976E-06_JPRB, &
  & 0.27007940E-06_JPRB, 0.27342787E-06_JPRB, 0.27654366E-06_JPRB, 0.27953504E-06_JPRB, 0.28251577E-06_JPRB, 0.28554470E-06_JPRB, &
  & 0.28857025E-06_JPRB, 0.29143931E-06_JPRB, 0.29392601E-06_JPRB, 0.29580070E-06_JPRB, 0.29694553E-06_JPRB, 0.29734841E-06_JPRB, &
  & 0.29704341E-06_JPRB, 0.29609240E-06_JPRB, 0.29460784E-06_JPRB, 0.29277552E-06_JPRB, 0.29085336E-06_JPRB, 0.28915539E-06_JPRB, &
  & 0.28787511E-06_JPRB, 0.28715374E-06_JPRB, 0.28699324E-06_JPRB, 0.28716815E-06_JPRB, 0.28745680E-06_JPRB, 0.28766112E-06_JPRB, &
  & 0.28762770E-06_JPRB, 0.28727104E-06_JPRB, 0.28657396E-06_JPRB, 0.28555411E-06_JPRB, 0.28423887E-06_JPRB, 0.28267229E-06_JPRB, &
  & 0.28090619E-06_JPRB, 0.27899901E-06_JPRB, 0.27700139E-06_JPRB, 0.27499138E-06_JPRB, 0.27304054E-06_JPRB, 0.27122013E-06_JPRB, &
  & 0.26958656E-06_JPRB, 0.26817833E-06_JPRB, 0.26701201E-06_JPRB, 0.26609359E-06_JPRB, 0.26542915E-06_JPRB, 0.26500507E-06_JPRB, &
  & 0.26479404E-06_JPRB, 0.26477451E-06_JPRB, 0.26495906E-06_JPRB, 0.26560664E-06_JPRB /)

RGHG3(:,22, 7) = (/ &
  & 0.25750762E-06_JPRB, 0.25582713E-06_JPRB, 0.25472661E-06_JPRB, 0.25372429E-06_JPRB, 0.25270114E-06_JPRB, 0.25162586E-06_JPRB, &
  & 0.25055718E-06_JPRB, 0.24962279E-06_JPRB, 0.24904872E-06_JPRB, 0.24903525E-06_JPRB, 0.24973218E-06_JPRB, 0.25120940E-06_JPRB, &
  & 0.25345580E-06_JPRB, 0.25637630E-06_JPRB, 0.25981493E-06_JPRB, 0.26354795E-06_JPRB, 0.26733028E-06_JPRB, 0.27095479E-06_JPRB, &
  & 0.27431184E-06_JPRB, 0.27739253E-06_JPRB, 0.28028057E-06_JPRB, 0.28307460E-06_JPRB, 0.28586095E-06_JPRB, 0.28870778E-06_JPRB, &
  & 0.29157101E-06_JPRB, 0.29433264E-06_JPRB, 0.29675741E-06_JPRB, 0.29865740E-06_JPRB, 0.29991978E-06_JPRB, 0.30051339E-06_JPRB, &
  & 0.30045948E-06_JPRB, 0.29982166E-06_JPRB, 0.29868514E-06_JPRB, 0.29722742E-06_JPRB, 0.29565516E-06_JPRB, 0.29420451E-06_JPRB, &
  & 0.29311522E-06_JPRB, 0.29250384E-06_JPRB, 0.29229378E-06_JPRB, 0.29239331E-06_JPRB, 0.29259431E-06_JPRB, 0.29272951E-06_JPRB, &
  & 0.29266235E-06_JPRB, 0.29232260E-06_JPRB, 0.29167404E-06_JPRB, 0.29071523E-06_JPRB, 0.28947892E-06_JPRB, 0.28801222E-06_JPRB, &
  & 0.28636808E-06_JPRB, 0.28458780E-06_JPRB, 0.28273428E-06_JPRB, 0.28086708E-06_JPRB, 0.27904940E-06_JPRB, 0.27734450E-06_JPRB, &
  & 0.27579631E-06_JPRB, 0.27443505E-06_JPRB, 0.27327610E-06_JPRB, 0.27232940E-06_JPRB, 0.27160286E-06_JPRB, 0.27108891E-06_JPRB, &
  & 0.27076311E-06_JPRB, 0.27060446E-06_JPRB, 0.27061176E-06_JPRB, 0.27093765E-06_JPRB /)

RGHG3(:,23, 7) = (/ &
  & 0.26378177E-06_JPRB, 0.26220940E-06_JPRB, 0.26124218E-06_JPRB, 0.26034303E-06_JPRB, 0.25942359E-06_JPRB, 0.25845392E-06_JPRB, &
  & 0.25746408E-06_JPRB, 0.25658935E-06_JPRB, 0.25600951E-06_JPRB, 0.25591129E-06_JPRB, 0.25643314E-06_JPRB, 0.25764146E-06_JPRB, &
  & 0.25952241E-06_JPRB, 0.26199868E-06_JPRB, 0.26493385E-06_JPRB, 0.26814561E-06_JPRB, 0.27143312E-06_JPRB, 0.27462690E-06_JPRB, &
  & 0.27763664E-06_JPRB, 0.28045861E-06_JPRB, 0.28313900E-06_JPRB, 0.28576198E-06_JPRB, 0.28839418E-06_JPRB, 0.29107767E-06_JPRB, &
  & 0.29380266E-06_JPRB, 0.29644445E-06_JPRB, 0.29882449E-06_JPRB, 0.30074938E-06_JPRB, 0.30210796E-06_JPRB, 0.30288601E-06_JPRB, &
  & 0.30310724E-06_JPRB, 0.30282339E-06_JPRB, 0.30211189E-06_JPRB, 0.30112486E-06_JPRB, 0.29999867E-06_JPRB, 0.29894539E-06_JPRB, &
  & 0.29809814E-06_JPRB, 0.29754236E-06_JPRB, 0.29727636E-06_JPRB, 0.29719939E-06_JPRB, 0.29718009E-06_JPRB, 0.29709634E-06_JPRB, &
  & 0.29685191E-06_JPRB, 0.29637840E-06_JPRB, 0.29565484E-06_JPRB, 0.29468532E-06_JPRB, 0.29348595E-06_JPRB, 0.29209116E-06_JPRB, &
  & 0.29054206E-06_JPRB, 0.28889269E-06_JPRB, 0.28719219E-06_JPRB, 0.28548928E-06_JPRB, 0.28383982E-06_JPRB, 0.28228430E-06_JPRB, &
  & 0.28085566E-06_JPRB, 0.27957662E-06_JPRB, 0.27846019E-06_JPRB, 0.27751656E-06_JPRB, 0.27675986E-06_JPRB, 0.27618796E-06_JPRB, &
  & 0.27578594E-06_JPRB, 0.27553241E-06_JPRB, 0.27541367E-06_JPRB, 0.27549913E-06_JPRB /)

RGHG3(:,24, 7) = (/ &
  & 0.26922137E-06_JPRB, 0.26785159E-06_JPRB, 0.26697703E-06_JPRB, 0.26618918E-06_JPRB, 0.26537973E-06_JPRB, 0.26451997E-06_JPRB, &
  & 0.26364356E-06_JPRB, 0.26285130E-06_JPRB, 0.26230830E-06_JPRB, 0.26218126E-06_JPRB, 0.26259170E-06_JPRB, 0.26359825E-06_JPRB, &
  & 0.26519103E-06_JPRB, 0.26729953E-06_JPRB, 0.26980604E-06_JPRB, 0.27256146E-06_JPRB, 0.27540591E-06_JPRB, 0.27821071E-06_JPRB, &
  & 0.28090284E-06_JPRB, 0.28346972E-06_JPRB, 0.28594499E-06_JPRB, 0.28838087E-06_JPRB, 0.29083552E-06_JPRB, 0.29334149E-06_JPRB, &
  & 0.29586900E-06_JPRB, 0.29832992E-06_JPRB, 0.30056862E-06_JPRB, 0.30244146E-06_JPRB, 0.30386417E-06_JPRB, 0.30479467E-06_JPRB, &
  & 0.30525652E-06_JPRB, 0.30530205E-06_JPRB, 0.30500456E-06_JPRB, 0.30446674E-06_JPRB, 0.30379988E-06_JPRB, 0.30312873E-06_JPRB, &
  & 0.30253767E-06_JPRB, 0.30207838E-06_JPRB, 0.30172538E-06_JPRB, 0.30145640E-06_JPRB, 0.30118406E-06_JPRB, 0.30084550E-06_JPRB, &
  & 0.30037154E-06_JPRB, 0.29972310E-06_JPRB, 0.29887121E-06_JPRB, 0.29782024E-06_JPRB, 0.29660066E-06_JPRB, 0.29524347E-06_JPRB, &
  & 0.29378867E-06_JPRB, 0.29227340E-06_JPRB, 0.29073141E-06_JPRB, 0.28920655E-06_JPRB, 0.28772834E-06_JPRB, 0.28632905E-06_JPRB, &
  & 0.28503396E-06_JPRB, 0.28385674E-06_JPRB, 0.28280760E-06_JPRB, 0.28189720E-06_JPRB, 0.28113956E-06_JPRB, 0.28053950E-06_JPRB, &
  & 0.28008694E-06_JPRB, 0.27976441E-06_JPRB, 0.27954889E-06_JPRB, 0.27943940E-06_JPRB /)

RGHG3(:,25, 7) = (/ &
  & 0.27400625E-06_JPRB, 0.27279054E-06_JPRB, 0.27205527E-06_JPRB, 0.27137992E-06_JPRB, 0.27069777E-06_JPRB, 0.26997503E-06_JPRB, &
  & 0.26923669E-06_JPRB, 0.26857069E-06_JPRB, 0.26811946E-06_JPRB, 0.26802877E-06_JPRB, 0.26840672E-06_JPRB, 0.26930323E-06_JPRB, &
  & 0.27070894E-06_JPRB, 0.27256041E-06_JPRB, 0.27475710E-06_JPRB, 0.27716877E-06_JPRB, 0.27966939E-06_JPRB, 0.28215425E-06_JPRB, &
  & 0.28456688E-06_JPRB, 0.28689448E-06_JPRB, 0.28915255E-06_JPRB, 0.29137618E-06_JPRB, 0.29359310E-06_JPRB, 0.29583416E-06_JPRB, &
  & 0.29807720E-06_JPRB, 0.30025433E-06_JPRB, 0.30227071E-06_JPRB, 0.30400690E-06_JPRB, 0.30538524E-06_JPRB, 0.30639256E-06_JPRB, &
  & 0.30703427E-06_JPRB, 0.30734506E-06_JPRB, 0.30738514E-06_JPRB, 0.30721932E-06_JPRB, 0.30692331E-06_JPRB, 0.30655301E-06_JPRB, &
  & 0.30616525E-06_JPRB, 0.30577928E-06_JPRB, 0.30537427E-06_JPRB, 0.30495744E-06_JPRB, 0.30448049E-06_JPRB, 0.30391692E-06_JPRB, &
  & 0.30324060E-06_JPRB, 0.30243010E-06_JPRB, 0.30147999E-06_JPRB, 0.30038487E-06_JPRB, 0.29915779E-06_JPRB, 0.29783186E-06_JPRB, &
  & 0.29644974E-06_JPRB, 0.29504250E-06_JPRB, 0.29364281E-06_JPRB, 0.29226976E-06_JPRB, 0.29095017E-06_JPRB, 0.28970521E-06_JPRB, &
  & 0.28854271E-06_JPRB, 0.28747357E-06_JPRB, 0.28650433E-06_JPRB, 0.28564517E-06_JPRB, 0.28491138E-06_JPRB, 0.28430961E-06_JPRB, &
  & 0.28383536E-06_JPRB, 0.28347279E-06_JPRB, 0.28319252E-06_JPRB, 0.28292973E-06_JPRB /)

RGHG3(:,26, 7) = (/ &
  & 0.27816890E-06_JPRB, 0.27716729E-06_JPRB, 0.27655847E-06_JPRB, 0.27601513E-06_JPRB, 0.27546935E-06_JPRB, 0.27490174E-06_JPRB, &
  & 0.27432750E-06_JPRB, 0.27382714E-06_JPRB, 0.27351766E-06_JPRB, 0.27352533E-06_JPRB, 0.27394236E-06_JPRB, 0.27481369E-06_JPRB, &
  & 0.27612799E-06_JPRB, 0.27783034E-06_JPRB, 0.27982654E-06_JPRB, 0.28200802E-06_JPRB, 0.28425936E-06_JPRB, 0.28649794E-06_JPRB, &
  & 0.28866990E-06_JPRB, 0.29075704E-06_JPRB, 0.29276177E-06_JPRB, 0.29471374E-06_JPRB, 0.29663431E-06_JPRB, 0.29852828E-06_JPRB, &
  & 0.30040738E-06_JPRB, 0.30222517E-06_JPRB, 0.30392658E-06_JPRB, 0.30545615E-06_JPRB, 0.30675264E-06_JPRB, 0.30777068E-06_JPRB, &
  & 0.30851703E-06_JPRB, 0.30901219E-06_JPRB, 0.30928936E-06_JPRB, 0.30938600E-06_JPRB, 0.30934285E-06_JPRB, 0.30918449E-06_JPRB, &
  & 0.30893352E-06_JPRB, 0.30859613E-06_JPRB, 0.30816997E-06_JPRB, 0.30764724E-06_JPRB, 0.30703512E-06_JPRB, 0.30631165E-06_JPRB, &
  & 0.30548753E-06_JPRB, 0.30454638E-06_JPRB, 0.30349932E-06_JPRB, 0.30235270E-06_JPRB, 0.30113520E-06_JPRB, 0.29987507E-06_JPRB, &
  & 0.29859478E-06_JPRB, 0.29731919E-06_JPRB, 0.29606269E-06_JPRB, 0.29484852E-06_JPRB, 0.29368834E-06_JPRB, 0.29258882E-06_JPRB, &
  & 0.29155530E-06_JPRB, 0.29059271E-06_JPRB, 0.28970624E-06_JPRB, 0.28890690E-06_JPRB, 0.28820989E-06_JPRB, 0.28762440E-06_JPRB, &
  & 0.28714888E-06_JPRB, 0.28677005E-06_JPRB, 0.28645613E-06_JPRB, 0.28611612E-06_JPRB /)

RGHG3(:,27, 7) = (/ &
  & 0.28183314E-06_JPRB, 0.28104702E-06_JPRB, 0.28057286E-06_JPRB, 0.28015842E-06_JPRB, 0.27975364E-06_JPRB, 0.27934067E-06_JPRB, &
  & 0.27894376E-06_JPRB, 0.27862279E-06_JPRB, 0.27848205E-06_JPRB, 0.27862492E-06_JPRB, 0.27912913E-06_JPRB, 0.28002847E-06_JPRB, &
  & 0.28131547E-06_JPRB, 0.28293562E-06_JPRB, 0.28480736E-06_JPRB, 0.28682709E-06_JPRB, 0.28889718E-06_JPRB, 0.29093559E-06_JPRB, &
  & 0.29289185E-06_JPRB, 0.29473435E-06_JPRB, 0.29647632E-06_JPRB, 0.29814561E-06_JPRB, 0.29972239E-06_JPRB, 0.30125159E-06_JPRB, &
  & 0.30274424E-06_JPRB, 0.30417610E-06_JPRB, 0.30554867E-06_JPRB, 0.30682713E-06_JPRB, 0.30797628E-06_JPRB, 0.30896075E-06_JPRB, &
  & 0.30975801E-06_JPRB, 0.31036271E-06_JPRB, 0.31078486E-06_JPRB, 0.31103912E-06_JPRB, 0.31114203E-06_JPRB, 0.31110238E-06_JPRB, &
  & 0.31092785E-06_JPRB, 0.31061879E-06_JPRB, 0.31018402E-06_JPRB, 0.30961081E-06_JPRB, 0.30892409E-06_JPRB, 0.30811850E-06_JPRB, &
  & 0.30721236E-06_JPRB, 0.30620893E-06_JPRB, 0.30512143E-06_JPRB, 0.30396970E-06_JPRB, 0.30278386E-06_JPRB, 0.30159453E-06_JPRB, &
  & 0.30042219E-06_JPRB, 0.29927668E-06_JPRB, 0.29816744E-06_JPRB, 0.29710051E-06_JPRB, 0.29608154E-06_JPRB, 0.29511475E-06_JPRB, &
  & 0.29419857E-06_JPRB, 0.29333563E-06_JPRB, 0.29253175E-06_JPRB, 0.29179745E-06_JPRB, 0.29114702E-06_JPRB, 0.29058904E-06_JPRB, &
  & 0.29012352E-06_JPRB, 0.28973801E-06_JPRB, 0.28939775E-06_JPRB, 0.28897233E-06_JPRB /)

RGHG3(:,28, 7) = (/ &
  & 0.28512261E-06_JPRB, 0.28451140E-06_JPRB, 0.28415866E-06_JPRB, 0.28386071E-06_JPRB, 0.28357942E-06_JPRB, 0.28331067E-06_JPRB, &
  & 0.28307278E-06_JPRB, 0.28292550E-06_JPRB, 0.28295142E-06_JPRB, 0.28323615E-06_JPRB, 0.28383880E-06_JPRB, 0.28478874E-06_JPRB, &
  & 0.28607062E-06_JPRB, 0.28763833E-06_JPRB, 0.28941332E-06_JPRB, 0.29130598E-06_JPRB, 0.29322089E-06_JPRB, 0.29508823E-06_JPRB, &
  & 0.29684458E-06_JPRB, 0.29846507E-06_JPRB, 0.29996716E-06_JPRB, 0.30135249E-06_JPRB, 0.30261444E-06_JPRB, 0.30380713E-06_JPRB, &
  & 0.30494255E-06_JPRB, 0.30603385E-06_JPRB, 0.30709865E-06_JPRB, 0.30813317E-06_JPRB, 0.30912344E-06_JPRB, 0.31003256E-06_JPRB, &
  & 0.31082064E-06_JPRB, 0.31146868E-06_JPRB, 0.31196234E-06_JPRB, 0.31229621E-06_JPRB, 0.31247092E-06_JPRB, 0.31248723E-06_JPRB, &
  & 0.31234762E-06_JPRB, 0.31205269E-06_JPRB, 0.31161289E-06_JPRB, 0.31102854E-06_JPRB, 0.31030643E-06_JPRB, 0.30947314E-06_JPRB, &
  & 0.30853573E-06_JPRB, 0.30751971E-06_JPRB, 0.30643744E-06_JPRB, 0.30532351E-06_JPRB, 0.30420702E-06_JPRB, 0.30311332E-06_JPRB, &
  & 0.30205496E-06_JPRB, 0.30103655E-06_JPRB, 0.30005657E-06_JPRB, 0.29911877E-06_JPRB, 0.29822471E-06_JPRB, 0.29737217E-06_JPRB, &
  & 0.29655928E-06_JPRB, 0.29578743E-06_JPRB, 0.29506259E-06_JPRB, 0.29439300E-06_JPRB, 0.29379095E-06_JPRB, 0.29326500E-06_JPRB, &
  & 0.29281702E-06_JPRB, 0.29243586E-06_JPRB, 0.29208613E-06_JPRB, 0.29163550E-06_JPRB /)

RGHG3(:,29, 7) = (/ &
  & 0.28803692E-06_JPRB, 0.28759212E-06_JPRB, 0.28733700E-06_JPRB, 0.28713694E-06_JPRB, 0.28696115E-06_JPRB, 0.28680972E-06_JPRB, &
  & 0.28670834E-06_JPRB, 0.28670792E-06_JPRB, 0.28687856E-06_JPRB, 0.28728778E-06_JPRB, 0.28798129E-06_JPRB, 0.28897375E-06_JPRB, &
  & 0.29025233E-06_JPRB, 0.29176820E-06_JPRB, 0.29345424E-06_JPRB, 0.29522471E-06_JPRB, 0.29699990E-06_JPRB, 0.29870759E-06_JPRB, &
  & 0.30029139E-06_JPRB, 0.30172203E-06_JPRB, 0.30300833E-06_JPRB, 0.30415302E-06_JPRB, 0.30516210E-06_JPRB, 0.30607347E-06_JPRB, &
  & 0.30691720E-06_JPRB, 0.30772455E-06_JPRB, 0.30852715E-06_JPRB, 0.30934632E-06_JPRB, 0.31017436E-06_JPRB, 0.31098824E-06_JPRB, &
  & 0.31174199E-06_JPRB, 0.31239091E-06_JPRB, 0.31290764E-06_JPRB, 0.31327133E-06_JPRB, 0.31347309E-06_JPRB, 0.31350970E-06_JPRB, &
  & 0.31338357E-06_JPRB, 0.31309673E-06_JPRB, 0.31265699E-06_JPRB, 0.31207546E-06_JPRB, 0.31135633E-06_JPRB, 0.31051744E-06_JPRB, &
  & 0.30958978E-06_JPRB, 0.30858649E-06_JPRB, 0.30754506E-06_JPRB, 0.30649483E-06_JPRB, 0.30546747E-06_JPRB, 0.30448291E-06_JPRB, &
  & 0.30354585E-06_JPRB, 0.30264715E-06_JPRB, 0.30178569E-06_JPRB, 0.30096072E-06_JPRB, 0.30017222E-06_JPRB, 0.29941776E-06_JPRB, &
  & 0.29869503E-06_JPRB, 0.29800623E-06_JPRB, 0.29735426E-06_JPRB, 0.29674715E-06_JPRB, 0.29619574E-06_JPRB, 0.29570916E-06_JPRB, &
  & 0.29529005E-06_JPRB, 0.29492861E-06_JPRB, 0.29459247E-06_JPRB, 0.29413337E-06_JPRB /)

RGHG3(:,30, 7) = (/ &
  & 0.29060953E-06_JPRB, 0.29030105E-06_JPRB, 0.29013478E-06_JPRB, 0.29001200E-06_JPRB, 0.28991766E-06_JPRB, 0.28985957E-06_JPRB, &
  & 0.28986400E-06_JPRB, 0.28997925E-06_JPRB, 0.29026526E-06_JPRB, 0.29077324E-06_JPRB, 0.29153315E-06_JPRB, 0.29255554E-06_JPRB, &
  & 0.29381715E-06_JPRB, 0.29527644E-06_JPRB, 0.29686859E-06_JPRB, 0.29852225E-06_JPRB, 0.30016210E-06_JPRB, 0.30172734E-06_JPRB, &
  & 0.30316247E-06_JPRB, 0.30443852E-06_JPRB, 0.30554949E-06_JPRB, 0.30650682E-06_JPRB, 0.30731925E-06_JPRB, 0.30801905E-06_JPRB, &
  & 0.30864231E-06_JPRB, 0.30923280E-06_JPRB, 0.30983585E-06_JPRB, 0.31047631E-06_JPRB, 0.31116417E-06_JPRB, 0.31187159E-06_JPRB, &
  & 0.31256315E-06_JPRB, 0.31318470E-06_JPRB, 0.31369169E-06_JPRB, 0.31405466E-06_JPRB, 0.31425785E-06_JPRB, 0.31429678E-06_JPRB, &
  & 0.31417528E-06_JPRB, 0.31389828E-06_JPRB, 0.31346940E-06_JPRB, 0.31290114E-06_JPRB, 0.31220117E-06_JPRB, 0.31138919E-06_JPRB, &
  & 0.31048856E-06_JPRB, 0.30953231E-06_JPRB, 0.30855395E-06_JPRB, 0.30758176E-06_JPRB, 0.30665481E-06_JPRB, 0.30577692E-06_JPRB, &
  & 0.30494991E-06_JPRB, 0.30415873E-06_JPRB, 0.30339629E-06_JPRB, 0.30266639E-06_JPRB, 0.30196662E-06_JPRB, 0.30129377E-06_JPRB, &
  & 0.30064871E-06_JPRB, 0.30003091E-06_JPRB, 0.29944425E-06_JPRB, 0.29889577E-06_JPRB, 0.29839492E-06_JPRB, 0.29794992E-06_JPRB, &
  & 0.29756268E-06_JPRB, 0.29722247E-06_JPRB, 0.29689289E-06_JPRB, 0.29640915E-06_JPRB /)

RGHG3(:,31, 7) = (/ &
  & 0.29290294E-06_JPRB, 0.29269083E-06_JPRB, 0.29258786E-06_JPRB, 0.29252351E-06_JPRB, 0.29249148E-06_JPRB, 0.29250373E-06_JPRB, &
  & 0.29258871E-06_JPRB, 0.29279329E-06_JPRB, 0.29316433E-06_JPRB, 0.29374172E-06_JPRB, 0.29454631E-06_JPRB, 0.29557549E-06_JPRB, &
  & 0.29680928E-06_JPRB, 0.29820194E-06_JPRB, 0.29969945E-06_JPRB, 0.30123775E-06_JPRB, 0.30275396E-06_JPRB, 0.30418934E-06_JPRB, &
  & 0.30549862E-06_JPRB, 0.30665018E-06_JPRB, 0.30763135E-06_JPRB, 0.30844794E-06_JPRB, 0.30911491E-06_JPRB, 0.30966279E-06_JPRB, &
  & 0.31013082E-06_JPRB, 0.31056845E-06_JPRB, 0.31102175E-06_JPRB, 0.31152231E-06_JPRB, 0.31208592E-06_JPRB, 0.31269687E-06_JPRB, &
  & 0.31331675E-06_JPRB, 0.31389033E-06_JPRB, 0.31436718E-06_JPRB, 0.31470950E-06_JPRB, 0.31489910E-06_JPRB, 0.31493224E-06_JPRB, &
  & 0.31481426E-06_JPRB, 0.31455065E-06_JPRB, 0.31414734E-06_JPRB, 0.31360622E-06_JPRB, 0.31294283E-06_JPRB, 0.31217328E-06_JPRB, &
  & 0.31132774E-06_JPRB, 0.31043305E-06_JPRB, 0.30953026E-06_JPRB, 0.30865053E-06_JPRB, 0.30781695E-06_JPRB, 0.30703785E-06_JPRB, &
  & 0.30630051E-06_JPRB, 0.30559957E-06_JPRB, 0.30491844E-06_JPRB, 0.30426224E-06_JPRB, 0.30363287E-06_JPRB, 0.30302658E-06_JPRB, &
  & 0.30244405E-06_JPRB, 0.30188573E-06_JPRB, 0.30135550E-06_JPRB, 0.30085872E-06_JPRB, 0.30040383E-06_JPRB, 0.29999731E-06_JPRB, &
  & 0.29964039E-06_JPRB, 0.29932244E-06_JPRB, 0.29901133E-06_JPRB, 0.29856335E-06_JPRB /)

RGHG3(:,32, 7) = (/ &
  & 0.29493481E-06_JPRB, 0.29479108E-06_JPRB, 0.29473756E-06_JPRB, 0.29471914E-06_JPRB, 0.29473645E-06_JPRB, 0.29480401E-06_JPRB, &
  & 0.29495311E-06_JPRB, 0.29522235E-06_JPRB, 0.29565427E-06_JPRB, 0.29627566E-06_JPRB, 0.29709824E-06_JPRB, 0.29811773E-06_JPRB, &
  & 0.29930717E-06_JPRB, 0.30062822E-06_JPRB, 0.30202983E-06_JPRB, 0.30345907E-06_JPRB, 0.30486146E-06_JPRB, 0.30618554E-06_JPRB, &
  & 0.30738875E-06_JPRB, 0.30844052E-06_JPRB, 0.30932506E-06_JPRB, 0.31004330E-06_JPRB, 0.31060966E-06_JPRB, 0.31105461E-06_JPRB, &
  & 0.31141929E-06_JPRB, 0.31175284E-06_JPRB, 0.31210038E-06_JPRB, 0.31249741E-06_JPRB, 0.31295966E-06_JPRB, 0.31348051E-06_JPRB, &
  & 0.31402368E-06_JPRB, 0.31453871E-06_JPRB, 0.31496924E-06_JPRB, 0.31527748E-06_JPRB, 0.31544408E-06_JPRB, 0.31546750E-06_JPRB, &
  & 0.31535444E-06_JPRB, 0.31511172E-06_JPRB, 0.31474113E-06_JPRB, 0.31424773E-06_JPRB, 0.31363322E-06_JPRB, 0.31292407E-06_JPRB, &
  & 0.31214728E-06_JPRB, 0.31133573E-06_JPRB, 0.31051582E-06_JPRB, 0.30972302E-06_JPRB, 0.30897422E-06_JPRB, 0.30827582E-06_JPRB, &
  & 0.30761038E-06_JPRB, 0.30697265E-06_JPRB, 0.30635510E-06_JPRB, 0.30575572E-06_JPRB, 0.30517930E-06_JPRB, 0.30462499E-06_JPRB, &
  & 0.30409274E-06_JPRB, 0.30358382E-06_JPRB, 0.30310122E-06_JPRB, 0.30264960E-06_JPRB, 0.30223543E-06_JPRB, 0.30186396E-06_JPRB, &
  & 0.30153618E-06_JPRB, 0.30124232E-06_JPRB, 0.30094964E-06_JPRB, 0.30050495E-06_JPRB /)

RGHG3(:,33, 7) = (/ &
  & 0.29670946E-06_JPRB, 0.29664247E-06_JPRB, 0.29663198E-06_JPRB, 0.29665324E-06_JPRB, 0.29671210E-06_JPRB, 0.29682658E-06_JPRB, &
  & 0.29702423E-06_JPRB, 0.29734383E-06_JPRB, 0.29781373E-06_JPRB, 0.29845555E-06_JPRB, 0.29927639E-06_JPRB, 0.30026519E-06_JPRB, &
  & 0.30140055E-06_JPRB, 0.30264275E-06_JPRB, 0.30395188E-06_JPRB, 0.30527798E-06_JPRB, 0.30657873E-06_JPRB, 0.30780603E-06_JPRB, &
  & 0.30892204E-06_JPRB, 0.30989702E-06_JPRB, 0.31071164E-06_JPRB, 0.31136332E-06_JPRB, 0.31186372E-06_JPRB, 0.31224496E-06_JPRB, &
  & 0.31254689E-06_JPRB, 0.31281380E-06_JPRB, 0.31309170E-06_JPRB, 0.31341114E-06_JPRB, 0.31379173E-06_JPRB, 0.31423031E-06_JPRB, &
  & 0.31469861E-06_JPRB, 0.31514531E-06_JPRB, 0.31551969E-06_JPRB, 0.31578364E-06_JPRB, 0.31592171E-06_JPRB, 0.31593359E-06_JPRB, &
  & 0.31582752E-06_JPRB, 0.31560970E-06_JPRB, 0.31528197E-06_JPRB, 0.31484146E-06_JPRB, 0.31429633E-06_JPRB, 0.31366170E-06_JPRB, &
  & 0.31296508E-06_JPRB, 0.31224357E-06_JPRB, 0.31151242E-06_JPRB, 0.31080197E-06_JPRB, 0.31011831E-06_JPRB, 0.30948044E-06_JPRB, &
  & 0.30887105E-06_JPRB, 0.30827735E-06_JPRB, 0.30770258E-06_JPRB, 0.30714480E-06_JPRB, 0.30660746E-06_JPRB, 0.30609340E-06_JPRB, &
  & 0.30560125E-06_JPRB, 0.30513303E-06_JPRB, 0.30469110E-06_JPRB, 0.30427805E-06_JPRB, 0.30389990E-06_JPRB, 0.30356074E-06_JPRB, &
  & 0.30326035E-06_JPRB, 0.30298918E-06_JPRB, 0.30271721E-06_JPRB, 0.30230342E-06_JPRB /)

RGHG3(:,34, 7) = (/ &
  & 0.29829656E-06_JPRB, 0.29829403E-06_JPRB, 0.29832012E-06_JPRB, 0.29837616E-06_JPRB, 0.29847178E-06_JPRB, 0.29862471E-06_JPRB, &
  & 0.29886323E-06_JPRB, 0.29921515E-06_JPRB, 0.29970630E-06_JPRB, 0.30034960E-06_JPRB, 0.30114839E-06_JPRB, 0.30209455E-06_JPRB, &
  & 0.30316431E-06_JPRB, 0.30432705E-06_JPRB, 0.30554537E-06_JPRB, 0.30677936E-06_JPRB, 0.30798748E-06_JPRB, 0.30913264E-06_JPRB, &
  & 0.31017640E-06_JPRB, 0.31109241E-06_JPRB, 0.31185908E-06_JPRB, 0.31246739E-06_JPRB, 0.31293195E-06_JPRB, 0.31327897E-06_JPRB, &
  & 0.31354853E-06_JPRB, 0.31377670E-06_JPRB, 0.31401012E-06_JPRB, 0.31427493E-06_JPRB, 0.31458981E-06_JPRB, 0.31495503E-06_JPRB, &
  & 0.31534552E-06_JPRB, 0.31571921E-06_JPRB, 0.31602843E-06_JPRB, 0.31624225E-06_JPRB, 0.31634818E-06_JPRB, 0.31634769E-06_JPRB, &
  & 0.31625032E-06_JPRB, 0.31605998E-06_JPRB, 0.31577665E-06_JPRB, 0.31539909E-06_JPRB, 0.31492664E-06_JPRB, 0.31437730E-06_JPRB, &
  & 0.31377596E-06_JPRB, 0.31313962E-06_JPRB, 0.31249760E-06_JPRB, 0.31185718E-06_JPRB, 0.31123238E-06_JPRB, 0.31063090E-06_JPRB, &
  & 0.31006118E-06_JPRB, 0.30949860E-06_JPRB, 0.30895171E-06_JPRB, 0.30842369E-06_JPRB, 0.30791605E-06_JPRB, 0.30743252E-06_JPRB, &
  & 0.30697316E-06_JPRB, 0.30653882E-06_JPRB, 0.30613046E-06_JPRB, 0.30575094E-06_JPRB, 0.30540400E-06_JPRB, 0.30509327E-06_JPRB, &
  & 0.30481749E-06_JPRB, 0.30456783E-06_JPRB, 0.30431320E-06_JPRB, 0.30392223E-06_JPRB /)

RGHG3(:,35, 7) = (/ &
  & 0.29973381E-06_JPRB, 0.29978332E-06_JPRB, 0.29984267E-06_JPRB, 0.29993004E-06_JPRB, 0.30005725E-06_JPRB, 0.30024253E-06_JPRB, &
  & 0.30050882E-06_JPRB, 0.30088165E-06_JPRB, 0.30137741E-06_JPRB, 0.30200607E-06_JPRB, 0.30277150E-06_JPRB, 0.30366272E-06_JPRB, &
  & 0.30466424E-06_JPRB, 0.30574597E-06_JPRB, 0.30687994E-06_JPRB, 0.30802809E-06_JPRB, 0.30915686E-06_JPRB, 0.31022944E-06_JPRB, &
  & 0.31121436E-06_JPRB, 0.31208339E-06_JPRB, 0.31281684E-06_JPRB, 0.31340534E-06_JPRB, 0.31385767E-06_JPRB, 0.31419376E-06_JPRB, &
  & 0.31445026E-06_JPRB, 0.31466317E-06_JPRB, 0.31486883E-06_JPRB, 0.31509342E-06_JPRB, 0.31535262E-06_JPRB, 0.31564807E-06_JPRB, &
  & 0.31596093E-06_JPRB, 0.31625541E-06_JPRB, 0.31649517E-06_JPRB, 0.31665564E-06_JPRB, 0.31672886E-06_JPRB, 0.31671703E-06_JPRB, &
  & 0.31662927E-06_JPRB, 0.31646587E-06_JPRB, 0.31622960E-06_JPRB, 0.31591358E-06_JPRB, 0.31551841E-06_JPRB, 0.31505650E-06_JPRB, &
  & 0.31454394E-06_JPRB, 0.31399995E-06_JPRB, 0.31343316E-06_JPRB, 0.31285927E-06_JPRB, 0.31227884E-06_JPRB, 0.31171004E-06_JPRB, &
  & 0.31116215E-06_JPRB, 0.31062183E-06_JPRB, 0.31009370E-06_JPRB, 0.30958694E-06_JPRB, 0.30910223E-06_JPRB, 0.30864379E-06_JPRB, &
  & 0.30821141E-06_JPRB, 0.30780515E-06_JPRB, 0.30742564E-06_JPRB, 0.30707409E-06_JPRB, 0.30675460E-06_JPRB, 0.30646942E-06_JPRB, &
  & 0.30621698E-06_JPRB, 0.30598750E-06_JPRB, 0.30575427E-06_JPRB, 0.30539118E-06_JPRB /)

RGHG3(:,36, 7) = (/ &
  & 0.30105204E-06_JPRB, 0.30114836E-06_JPRB, 0.30123707E-06_JPRB, 0.30135106E-06_JPRB, 0.30150431E-06_JPRB, 0.30171284E-06_JPRB, &
  & 0.30199712E-06_JPRB, 0.30237592E-06_JPRB, 0.30286310E-06_JPRB, 0.30346732E-06_JPRB, 0.30418869E-06_JPRB, 0.30502204E-06_JPRB, &
  & 0.30595163E-06_JPRB, 0.30695637E-06_JPRB, 0.30800879E-06_JPRB, 0.30908001E-06_JPRB, 0.31013579E-06_JPRB, 0.31114715E-06_JPRB, &
  & 0.31208432E-06_JPRB, 0.31291992E-06_JPRB, 0.31363487E-06_JPRB, 0.31421769E-06_JPRB, 0.31466817E-06_JPRB, 0.31500687E-06_JPRB, &
  & 0.31526184E-06_JPRB, 0.31546762E-06_JPRB, 0.31565529E-06_JPRB, 0.31584622E-06_JPRB, 0.31605521E-06_JPRB, 0.31628352E-06_JPRB, &
  & 0.31651788E-06_JPRB, 0.31673346E-06_JPRB, 0.31690348E-06_JPRB, 0.31701330E-06_JPRB, 0.31705707E-06_JPRB, 0.31703800E-06_JPRB, &
  & 0.31696175E-06_JPRB, 0.31682697E-06_JPRB, 0.31663691E-06_JPRB, 0.31638095E-06_JPRB, 0.31605850E-06_JPRB, 0.31568032E-06_JPRB, &
  & 0.31525326E-06_JPRB, 0.31478672E-06_JPRB, 0.31429309E-06_JPRB, 0.31377135E-06_JPRB, 0.31323208E-06_JPRB, 0.31269207E-06_JPRB, &
  & 0.31216203E-06_JPRB, 0.31163606E-06_JPRB, 0.31112350E-06_JPRB, 0.31063374E-06_JPRB, 0.31016839E-06_JPRB, 0.30973129E-06_JPRB, &
  & 0.30932210E-06_JPRB, 0.30894017E-06_JPRB, 0.30858490E-06_JPRB, 0.30825814E-06_JPRB, 0.30796286E-06_JPRB, 0.30770121E-06_JPRB, &
  & 0.30747051E-06_JPRB, 0.30726164E-06_JPRB, 0.30704717E-06_JPRB, 0.30671350E-06_JPRB /)

RGHG3(:,37, 7) = (/ &
  & 0.30228736E-06_JPRB, 0.30242541E-06_JPRB, 0.30253747E-06_JPRB, 0.30267296E-06_JPRB, 0.30284463E-06_JPRB, 0.30306791E-06_JPRB, &
  & 0.30335804E-06_JPRB, 0.30373124E-06_JPRB, 0.30419966E-06_JPRB, 0.30476988E-06_JPRB, 0.30544408E-06_JPRB, 0.30621584E-06_JPRB, &
  & 0.30707477E-06_JPRB, 0.30800291E-06_JPRB, 0.30897911E-06_JPRB, 0.30997515E-06_JPRB, 0.31096522E-06_JPRB, 0.31192010E-06_JPRB, &
  & 0.31281581E-06_JPRB, 0.31362794E-06_JPRB, 0.31433211E-06_JPRB, 0.31491285E-06_JPRB, 0.31536538E-06_JPRB, 0.31570261E-06_JPRB, &
  & 0.31595224E-06_JPRB, 0.31614556E-06_JPRB, 0.31631055E-06_JPRB, 0.31646843E-06_JPRB, 0.31662972E-06_JPRB, 0.31679733E-06_JPRB, &
  & 0.31696206E-06_JPRB, 0.31710860E-06_JPRB, 0.31722081E-06_JPRB, 0.31728950E-06_JPRB, 0.31731264E-06_JPRB, 0.31729132E-06_JPRB, &
  & 0.31723016E-06_JPRB, 0.31712520E-06_JPRB, 0.31698016E-06_JPRB, 0.31678019E-06_JPRB, 0.31653082E-06_JPRB, 0.31622747E-06_JPRB, &
  & 0.31587550E-06_JPRB, 0.31548248E-06_JPRB, 0.31504842E-06_JPRB, 0.31457782E-06_JPRB, 0.31407907E-06_JPRB, 0.31356757E-06_JPRB, &
  & 0.31305294E-06_JPRB, 0.31254032E-06_JPRB, 0.31204328E-06_JPRB, 0.31156912E-06_JPRB, 0.31112182E-06_JPRB, 0.31070462E-06_JPRB, &
  & 0.31031638E-06_JPRB, 0.30995565E-06_JPRB, 0.30962210E-06_JPRB, 0.30931704E-06_JPRB, 0.30904397E-06_JPRB, 0.30880426E-06_JPRB, &
  & 0.30859476E-06_JPRB, 0.30840508E-06_JPRB, 0.30821130E-06_JPRB, 0.30790767E-06_JPRB /)

RGHG3(:,38, 7) = (/ &
  & 0.30347167E-06_JPRB, 0.30363952E-06_JPRB, 0.30377024E-06_JPRB, 0.30391843E-06_JPRB, 0.30410320E-06_JPRB, 0.30433154E-06_JPRB, &
  & 0.30461820E-06_JPRB, 0.30497674E-06_JPRB, 0.30541736E-06_JPRB, 0.30594842E-06_JPRB, 0.30657142E-06_JPRB, 0.30728197E-06_JPRB, &
  & 0.30807053E-06_JPRB, 0.30892429E-06_JPRB, 0.30982483E-06_JPRB, 0.31074944E-06_JPRB, 0.31167360E-06_JPRB, 0.31257520E-06_JPRB, &
  & 0.31343168E-06_JPRB, 0.31421820E-06_JPRB, 0.31491024E-06_JPRB, 0.31547950E-06_JPRB, 0.31591728E-06_JPRB, 0.31623620E-06_JPRB, &
  & 0.31646314E-06_JPRB, 0.31663174E-06_JPRB, 0.31676993E-06_JPRB, 0.31689558E-06_JPRB, 0.31701828E-06_JPRB, 0.31713978E-06_JPRB, &
  & 0.31725449E-06_JPRB, 0.31735354E-06_JPRB, 0.31742695E-06_JPRB, 0.31746950E-06_JPRB, 0.31748067E-06_JPRB, 0.31746140E-06_JPRB, &
  & 0.31741433E-06_JPRB, 0.31733649E-06_JPRB, 0.31722905E-06_JPRB, 0.31708146E-06_JPRB, 0.31689478E-06_JPRB, 0.31666090E-06_JPRB, &
  & 0.31638200E-06_JPRB, 0.31605688E-06_JPRB, 0.31568467E-06_JPRB, 0.31526608E-06_JPRB, 0.31480931E-06_JPRB, 0.31432722E-06_JPRB, &
  & 0.31383189E-06_JPRB, 0.31333755E-06_JPRB, 0.31285734E-06_JPRB, 0.31240052E-06_JPRB, 0.31197180E-06_JPRB, 0.31157418E-06_JPRB, &
  & 0.31120575E-06_JPRB, 0.31086466E-06_JPRB, 0.31055029E-06_JPRB, 0.31026502E-06_JPRB, 0.31001230E-06_JPRB, 0.30979328E-06_JPRB, &
  & 0.30960385E-06_JPRB, 0.30943346E-06_JPRB, 0.30925938E-06_JPRB, 0.30898602E-06_JPRB /)

RGHG3(:,39, 7) = (/ &
  & 0.30461817E-06_JPRB, 0.30480504E-06_JPRB, 0.30494425E-06_JPRB, 0.30510338E-06_JPRB, 0.30529122E-06_JPRB, 0.30552070E-06_JPRB, &
  & 0.30579770E-06_JPRB, 0.30613418E-06_JPRB, 0.30654212E-06_JPRB, 0.30702989E-06_JPRB, 0.30759941E-06_JPRB, 0.30824870E-06_JPRB, &
  & 0.30896851E-06_JPRB, 0.30974860E-06_JPRB, 0.31057442E-06_JPRB, 0.31142650E-06_JPRB, 0.31228478E-06_JPRB, 0.31313081E-06_JPRB, &
  & 0.31394399E-06_JPRB, 0.31470105E-06_JPRB, 0.31536396E-06_JPRB, 0.31590551E-06_JPRB, 0.31631120E-06_JPRB, 0.31659653E-06_JPRB, &
  & 0.31679403E-06_JPRB, 0.31693710E-06_JPRB, 0.31705162E-06_JPRB, 0.31715339E-06_JPRB, 0.31724949E-06_JPRB, 0.31734146E-06_JPRB, &
  & 0.31742582E-06_JPRB, 0.31749653E-06_JPRB, 0.31754752E-06_JPRB, 0.31757514E-06_JPRB, 0.31758012E-06_JPRB, 0.31756284E-06_JPRB, &
  & 0.31752597E-06_JPRB, 0.31746657E-06_JPRB, 0.31738603E-06_JPRB, 0.31727683E-06_JPRB, 0.31713856E-06_JPRB, 0.31696391E-06_JPRB, &
  & 0.31675162E-06_JPRB, 0.31649461E-06_JPRB, 0.31618777E-06_JPRB, 0.31582749E-06_JPRB, 0.31541833E-06_JPRB, 0.31497154E-06_JPRB, &
  & 0.31450404E-06_JPRB, 0.31403192E-06_JPRB, 0.31357223E-06_JPRB, 0.31313527E-06_JPRB, 0.31272694E-06_JPRB, 0.31234970E-06_JPRB, &
  & 0.31200076E-06_JPRB, 0.31167789E-06_JPRB, 0.31138109E-06_JPRB, 0.31111369E-06_JPRB, 0.31087976E-06_JPRB, 0.31068006E-06_JPRB, &
  & 0.31050945E-06_JPRB, 0.31035697E-06_JPRB, 0.31020116E-06_JPRB, 0.30995844E-06_JPRB /)

RGHG3(:,40, 7) = (/ &
  & 0.30572411E-06_JPRB, 0.30592122E-06_JPRB, 0.30606719E-06_JPRB, 0.30622624E-06_JPRB, 0.30641991E-06_JPRB, 0.30664404E-06_JPRB, &
  & 0.30690796E-06_JPRB, 0.30722114E-06_JPRB, 0.30759307E-06_JPRB, 0.30803426E-06_JPRB, 0.30855028E-06_JPRB, 0.30913785E-06_JPRB, &
  & 0.30979012E-06_JPRB, 0.31049814E-06_JPRB, 0.31124941E-06_JPRB, 0.31202796E-06_JPRB, 0.31281766E-06_JPRB, 0.31360298E-06_JPRB, &
  & 0.31436750E-06_JPRB, 0.31508057E-06_JPRB, 0.31570823E-06_JPRB, 0.31621011E-06_JPRB, 0.31657771E-06_JPRB, 0.31683038E-06_JPRB, &
  & 0.31700193E-06_JPRB, 0.31712520E-06_JPRB, 0.31722305E-06_JPRB, 0.31730832E-06_JPRB, 0.31738711E-06_JPRB, 0.31746066E-06_JPRB, &
  & 0.31752660E-06_JPRB, 0.31758120E-06_JPRB, 0.31761911E-06_JPRB, 0.31763855E-06_JPRB, 0.31764000E-06_JPRB, 0.31762451E-06_JPRB, &
  & 0.31759359E-06_JPRB, 0.31754587E-06_JPRB, 0.31748209E-06_JPRB, 0.31739773E-06_JPRB, 0.31729212E-06_JPRB, 0.31716093E-06_JPRB, &
  & 0.31700108E-06_JPRB, 0.31680420E-06_JPRB, 0.31656174E-06_JPRB, 0.31626368E-06_JPRB, 0.31590858E-06_JPRB, 0.31550613E-06_JPRB, &
  & 0.31507193E-06_JPRB, 0.31462861E-06_JPRB, 0.31419398E-06_JPRB, 0.31378050E-06_JPRB, 0.31339488E-06_JPRB, 0.31303864E-06_JPRB, &
  & 0.31270918E-06_JPRB, 0.31240342E-06_JPRB, 0.31212318E-06_JPRB, 0.31187207E-06_JPRB, 0.31165573E-06_JPRB, 0.31147385E-06_JPRB, &
  & 0.31132058E-06_JPRB, 0.31118424E-06_JPRB, 0.31104599E-06_JPRB, 0.31082922E-06_JPRB /)

RGHG3(:,41, 7) = (/ &
  & 0.30679413E-06_JPRB, 0.30699385E-06_JPRB, 0.30713511E-06_JPRB, 0.30729794E-06_JPRB, 0.30748794E-06_JPRB, 0.30770980E-06_JPRB, &
  & 0.30796096E-06_JPRB, 0.30824845E-06_JPRB, 0.30858439E-06_JPRB, 0.30897962E-06_JPRB, 0.30944017E-06_JPRB, 0.30996691E-06_JPRB, &
  & 0.31055302E-06_JPRB, 0.31118992E-06_JPRB, 0.31186713E-06_JPRB, 0.31257161E-06_JPRB, 0.31328943E-06_JPRB, 0.31401103E-06_JPRB, &
  & 0.31471924E-06_JPRB, 0.31538750E-06_JPRB, 0.31596923E-06_JPRB, 0.31643145E-06_JPRB, 0.31676373E-06_JPRB, 0.31698875E-06_JPRB, &
  & 0.31714035E-06_JPRB, 0.31724892E-06_JPRB, 0.31733458E-06_JPRB, 0.31740854E-06_JPRB, 0.31747544E-06_JPRB, 0.31753677E-06_JPRB, &
  & 0.31759143E-06_JPRB, 0.31763568E-06_JPRB, 0.31766606E-06_JPRB, 0.31768047E-06_JPRB, 0.31767991E-06_JPRB, 0.31766572E-06_JPRB, &
  & 0.31763878E-06_JPRB, 0.31759879E-06_JPRB, 0.31754539E-06_JPRB, 0.31747715E-06_JPRB, 0.31739290E-06_JPRB, 0.31729076E-06_JPRB, &
  & 0.31716905E-06_JPRB, 0.31701808E-06_JPRB, 0.31683064E-06_JPRB, 0.31659118E-06_JPRB, 0.31629403E-06_JPRB, 0.31593933E-06_JPRB, &
  & 0.31554623E-06_JPRB, 0.31513542E-06_JPRB, 0.31472945E-06_JPRB, 0.31434269E-06_JPRB, 0.31398142E-06_JPRB, 0.31364803E-06_JPRB, &
  & 0.31333806E-06_JPRB, 0.31305007E-06_JPRB, 0.31278486E-06_JPRB, 0.31254945E-06_JPRB, 0.31234904E-06_JPRB, 0.31218366E-06_JPRB, &
  & 0.31204576E-06_JPRB, 0.31192405E-06_JPRB, 0.31180005E-06_JPRB, 0.31160718E-06_JPRB /)

RGHG3(:,42, 7) = (/ &
  & 0.30786867E-06_JPRB, 0.30802681E-06_JPRB, 0.30815761E-06_JPRB, 0.30831239E-06_JPRB, 0.30850680E-06_JPRB, 0.30872405E-06_JPRB, &
  & 0.30896271E-06_JPRB, 0.30922789E-06_JPRB, 0.30952870E-06_JPRB, 0.30987778E-06_JPRB, 0.31028469E-06_JPRB, 0.31075095E-06_JPRB, &
  & 0.31127161E-06_JPRB, 0.31183924E-06_JPRB, 0.31244360E-06_JPRB, 0.31307292E-06_JPRB, 0.31371889E-06_JPRB, 0.31437111E-06_JPRB, &
  & 0.31501969E-06_JPRB, 0.31563505E-06_JPRB, 0.31617617E-06_JPRB, 0.31660090E-06_JPRB, 0.31690271E-06_JPRB, 0.31710479E-06_JPRB, &
  & 0.31724045E-06_JPRB, 0.31733757E-06_JPRB, 0.31741396E-06_JPRB, 0.31747905E-06_JPRB, 0.31753737E-06_JPRB, 0.31759023E-06_JPRB, &
  & 0.31763690E-06_JPRB, 0.31767479E-06_JPRB, 0.31770006E-06_JPRB, 0.31771145E-06_JPRB, 0.31770969E-06_JPRB, 0.31769662E-06_JPRB, &
  & 0.31767274E-06_JPRB, 0.31763787E-06_JPRB, 0.31759208E-06_JPRB, 0.31753416E-06_JPRB, 0.31746444E-06_JPRB, 0.31738193E-06_JPRB, &
  & 0.31728604E-06_JPRB, 0.31716917E-06_JPRB, 0.31702450E-06_JPRB, 0.31683609E-06_JPRB, 0.31659249E-06_JPRB, 0.31628971E-06_JPRB, &
  & 0.31593885E-06_JPRB, 0.31556382E-06_JPRB, 0.31518860E-06_JPRB, 0.31483023E-06_JPRB, 0.31449594E-06_JPRB, 0.31418574E-06_JPRB, &
  & 0.31389715E-06_JPRB, 0.31362623E-06_JPRB, 0.31337697E-06_JPRB, 0.31315597E-06_JPRB, 0.31297083E-06_JPRB, 0.31282033E-06_JPRB, &
  & 0.31269622E-06_JPRB, 0.31258671E-06_JPRB, 0.31247504E-06_JPRB, 0.31230084E-06_JPRB /)

RGHG3(:,43, 7) = (/ &
  & 0.30877942E-06_JPRB, 0.30897411E-06_JPRB, 0.30911320E-06_JPRB, 0.30927947E-06_JPRB, 0.30947507E-06_JPRB, 0.30969497E-06_JPRB, &
  & 0.30992379E-06_JPRB, 0.31016793E-06_JPRB, 0.31043626E-06_JPRB, 0.31074231E-06_JPRB, 0.31109670E-06_JPRB, 0.31150398E-06_JPRB, &
  & 0.31196103E-06_JPRB, 0.31246037E-06_JPRB, 0.31299246E-06_JPRB, 0.31354878E-06_JPRB, 0.31411957E-06_JPRB, 0.31470339E-06_JPRB, &
  & 0.31528867E-06_JPRB, 0.31585350E-06_JPRB, 0.31634966E-06_JPRB, 0.31673918E-06_JPRB, 0.31701316E-06_JPRB, 0.31719551E-06_JPRB, &
  & 0.31731776E-06_JPRB, 0.31740541E-06_JPRB, 0.31747419E-06_JPRB, 0.31753231E-06_JPRB, 0.31758390E-06_JPRB, 0.31763051E-06_JPRB, &
  & 0.31767178E-06_JPRB, 0.31770492E-06_JPRB, 0.31772692E-06_JPRB, 0.31773621E-06_JPRB, 0.31773402E-06_JPRB, 0.31772186E-06_JPRB, &
  & 0.31770034E-06_JPRB, 0.31766956E-06_JPRB, 0.31762903E-06_JPRB, 0.31757889E-06_JPRB, 0.31751915E-06_JPRB, 0.31745014E-06_JPRB, &
  & 0.31737281E-06_JPRB, 0.31728044E-06_JPRB, 0.31716820E-06_JPRB, 0.31702115E-06_JPRB, 0.31682654E-06_JPRB, 0.31657322E-06_JPRB, &
  & 0.31626612E-06_JPRB, 0.31592734E-06_JPRB, 0.31558349E-06_JPRB, 0.31525471E-06_JPRB, 0.31494761E-06_JPRB, 0.31466257E-06_JPRB, &
  & 0.31439563E-06_JPRB, 0.31414399E-06_JPRB, 0.31391016E-06_JPRB, 0.31370422E-06_JPRB, 0.31353355E-06_JPRB, 0.31339681E-06_JPRB, &
  & 0.31328491E-06_JPRB, 0.31318586E-06_JPRB, 0.31308389E-06_JPRB, 0.31292367E-06_JPRB /)

RGHG3(:,44, 7) = (/ &
  & 0.30968039E-06_JPRB, 0.30989995E-06_JPRB, 0.31004788E-06_JPRB, 0.31021108E-06_JPRB, 0.31041708E-06_JPRB, 0.31063300E-06_JPRB, &
  & 0.31085611E-06_JPRB, 0.31108004E-06_JPRB, 0.31131910E-06_JPRB, 0.31158430E-06_JPRB, 0.31188907E-06_JPRB, 0.31223968E-06_JPRB, &
  & 0.31263437E-06_JPRB, 0.31306652E-06_JPRB, 0.31352891E-06_JPRB, 0.31401035E-06_JPRB, 0.31450949E-06_JPRB, 0.31501946E-06_JPRB, &
  & 0.31554083E-06_JPRB, 0.31604819E-06_JPRB, 0.31650217E-06_JPRB, 0.31685644E-06_JPRB, 0.31710491E-06_JPRB, 0.31726950E-06_JPRB, &
  & 0.31738006E-06_JPRB, 0.31745952E-06_JPRB, 0.31752182E-06_JPRB, 0.31757426E-06_JPRB, 0.31762065E-06_JPRB, 0.31766265E-06_JPRB, &
  & 0.31769980E-06_JPRB, 0.31772976E-06_JPRB, 0.31774931E-06_JPRB, 0.31775730E-06_JPRB, 0.31775497E-06_JPRB, 0.31774368E-06_JPRB, &
  & 0.31772436E-06_JPRB, 0.31769662E-06_JPRB, 0.31766038E-06_JPRB, 0.31761576E-06_JPRB, 0.31756340E-06_JPRB, 0.31750437E-06_JPRB, &
  & 0.31743969E-06_JPRB, 0.31736607E-06_JPRB, 0.31727774E-06_JPRB, 0.31716451E-06_JPRB, 0.31701200E-06_JPRB, 0.31680526E-06_JPRB, &
  & 0.31654318E-06_JPRB, 0.31623981E-06_JPRB, 0.31592791E-06_JPRB, 0.31562786E-06_JPRB, 0.31534853E-06_JPRB, 0.31508955E-06_JPRB, &
  & 0.31484640E-06_JPRB, 0.31461508E-06_JPRB, 0.31439902E-06_JPRB, 0.31420814E-06_JPRB, 0.31405173E-06_JPRB, 0.31392779E-06_JPRB, &
  & 0.31382638E-06_JPRB, 0.31373608E-06_JPRB, 0.31364178E-06_JPRB, 0.31349205E-06_JPRB /)

RGHG3(:,45, 7) = (/ &
  & 0.31070789E-06_JPRB, 0.31086341E-06_JPRB, 0.31098210E-06_JPRB, 0.31114160E-06_JPRB, 0.31133695E-06_JPRB, 0.31156031E-06_JPRB, &
  & 0.31176944E-06_JPRB, 0.31197834E-06_JPRB, 0.31218758E-06_JPRB, 0.31241592E-06_JPRB, 0.31267322E-06_JPRB, 0.31296929E-06_JPRB, &
  & 0.31330367E-06_JPRB, 0.31367131E-06_JPRB, 0.31406242E-06_JPRB, 0.31447397E-06_JPRB, 0.31489623E-06_JPRB, 0.31533662E-06_JPRB, &
  & 0.31578708E-06_JPRB, 0.31623750E-06_JPRB, 0.31664015E-06_JPRB, 0.31695933E-06_JPRB, 0.31718227E-06_JPRB, 0.31733086E-06_JPRB, &
  & 0.31743102E-06_JPRB, 0.31750344E-06_JPRB, 0.31756014E-06_JPRB, 0.31760811E-06_JPRB, 0.31765046E-06_JPRB, 0.31768886E-06_JPRB, &
  & 0.31772302E-06_JPRB, 0.31775053E-06_JPRB, 0.31776858E-06_JPRB, 0.31777577E-06_JPRB, 0.31777358E-06_JPRB, 0.31776324E-06_JPRB, &
  & 0.31774559E-06_JPRB, 0.31772038E-06_JPRB, 0.31768764E-06_JPRB, 0.31764733E-06_JPRB, 0.31760072E-06_JPRB, 0.31754868E-06_JPRB, &
  & 0.31749383E-06_JPRB, 0.31743338E-06_JPRB, 0.31736360E-06_JPRB, 0.31727672E-06_JPRB, 0.31715908E-06_JPRB, 0.31699739E-06_JPRB, &
  & 0.31677868E-06_JPRB, 0.31651587E-06_JPRB, 0.31623512E-06_JPRB, 0.31596358E-06_JPRB, 0.31571233E-06_JPRB, 0.31548018E-06_JPRB, &
  & 0.31526233E-06_JPRB, 0.31505417E-06_JPRB, 0.31485700E-06_JPRB, 0.31468286E-06_JPRB, 0.31454039E-06_JPRB, 0.31442806E-06_JPRB, &
  & 0.31433601E-06_JPRB, 0.31425296E-06_JPRB, 0.31416488E-06_JPRB, 0.31402212E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART14',0,ZHOOK_HANDLE)



RGHG3(:,46, 7) = (/ &
  & 0.31150060E-06_JPRB, 0.31174099E-06_JPRB, 0.31189467E-06_JPRB, 0.31205650E-06_JPRB, 0.31226949E-06_JPRB, 0.31248155E-06_JPRB, &
  & 0.31269076E-06_JPRB, 0.31287587E-06_JPRB, 0.31306007E-06_JPRB, 0.31324973E-06_JPRB, 0.31346292E-06_JPRB, 0.31370595E-06_JPRB, &
  & 0.31398173E-06_JPRB, 0.31428414E-06_JPRB, 0.31460846E-06_JPRB, 0.31494415E-06_JPRB, 0.31529615E-06_JPRB, 0.31565855E-06_JPRB, &
  & 0.31604031E-06_JPRB, 0.31641980E-06_JPRB, 0.31677075E-06_JPRB, 0.31704911E-06_JPRB, 0.31724815E-06_JPRB, 0.31738165E-06_JPRB, &
  & 0.31747294E-06_JPRB, 0.31753925E-06_JPRB, 0.31759149E-06_JPRB, 0.31763568E-06_JPRB, 0.31767496E-06_JPRB, 0.31771069E-06_JPRB, &
  & 0.31774255E-06_JPRB, 0.31776841E-06_JPRB, 0.31778532E-06_JPRB, 0.31779223E-06_JPRB, 0.31779035E-06_JPRB, 0.31778097E-06_JPRB, &
  & 0.31776477E-06_JPRB, 0.31774175E-06_JPRB, 0.31771157E-06_JPRB, 0.31767507E-06_JPRB, 0.31763236E-06_JPRB, 0.31758634E-06_JPRB, &
  & 0.31753788E-06_JPRB, 0.31748775E-06_JPRB, 0.31743173E-06_JPRB, 0.31736465E-06_JPRB, 0.31727632E-06_JPRB, 0.31715263E-06_JPRB, &
  & 0.31698130E-06_JPRB, 0.31676103E-06_JPRB, 0.31651723E-06_JPRB, 0.31627616E-06_JPRB, 0.31605302E-06_JPRB, 0.31584909E-06_JPRB, &
  & 0.31565790E-06_JPRB, 0.31547347E-06_JPRB, 0.31529811E-06_JPRB, 0.31514054E-06_JPRB, 0.31501185E-06_JPRB, 0.31490987E-06_JPRB, &
  & 0.31482583E-06_JPRB, 0.31474889E-06_JPRB, 0.31466581E-06_JPRB, 0.31452862E-06_JPRB /)

RGHG3(:,47, 7) = (/ &
  & 0.31254078E-06_JPRB, 0.31272054E-06_JPRB, 0.31285091E-06_JPRB, 0.31301852E-06_JPRB, 0.31322054E-06_JPRB, 0.31344578E-06_JPRB, &
  & 0.31363311E-06_JPRB, 0.31380236E-06_JPRB, 0.31395257E-06_JPRB, 0.31410605E-06_JPRB, 0.31427177E-06_JPRB, 0.31446245E-06_JPRB, &
  & 0.31467911E-06_JPRB, 0.31491817E-06_JPRB, 0.31517092E-06_JPRB, 0.31543721E-06_JPRB, 0.31571022E-06_JPRB, 0.31599933E-06_JPRB, &
  & 0.31629855E-06_JPRB, 0.31660647E-06_JPRB, 0.31689186E-06_JPRB, 0.31712983E-06_JPRB, 0.31730340E-06_JPRB, 0.31742366E-06_JPRB, &
  & 0.31750693E-06_JPRB, 0.31756832E-06_JPRB, 0.31761681E-06_JPRB, 0.31765822E-06_JPRB, 0.31769508E-06_JPRB, 0.31772885E-06_JPRB, &
  & 0.31775920E-06_JPRB, 0.31778373E-06_JPRB, 0.31779999E-06_JPRB, 0.31780695E-06_JPRB, 0.31780559E-06_JPRB, 0.31779712E-06_JPRB, &
  & 0.31778228E-06_JPRB, 0.31776088E-06_JPRB, 0.31773331E-06_JPRB, 0.31769923E-06_JPRB, 0.31766061E-06_JPRB, 0.31761806E-06_JPRB, &
  & 0.31757529E-06_JPRB, 0.31753177E-06_JPRB, 0.31748627E-06_JPRB, 0.31743406E-06_JPRB, 0.31736823E-06_JPRB, 0.31727834E-06_JPRB, &
  & 0.31715058E-06_JPRB, 0.31698215E-06_JPRB, 0.31678169E-06_JPRB, 0.31657819E-06_JPRB, 0.31638621E-06_JPRB, 0.31621113E-06_JPRB, &
  & 0.31604677E-06_JPRB, 0.31588786E-06_JPRB, 0.31573265E-06_JPRB, 0.31559230E-06_JPRB, 0.31547572E-06_JPRB, 0.31538292E-06_JPRB, &
  & 0.31530541E-06_JPRB, 0.31523354E-06_JPRB, 0.31515432E-06_JPRB, 0.31502162E-06_JPRB /)

RGHG3(:,48, 7) = (/ &
  & 0.31335549E-06_JPRB, 0.31360858E-06_JPRB, 0.31378681E-06_JPRB, 0.31397579E-06_JPRB, 0.31421064E-06_JPRB, 0.31443000E-06_JPRB, &
  & 0.31461684E-06_JPRB, 0.31475736E-06_JPRB, 0.31487792E-06_JPRB, 0.31499047E-06_JPRB, 0.31511016E-06_JPRB, 0.31524669E-06_JPRB, &
  & 0.31540378E-06_JPRB, 0.31557744E-06_JPRB, 0.31576189E-06_JPRB, 0.31595116E-06_JPRB, 0.31614800E-06_JPRB, 0.31635062E-06_JPRB, &
  & 0.31656566E-06_JPRB, 0.31678769E-06_JPRB, 0.31700728E-06_JPRB, 0.31720006E-06_JPRB, 0.31735030E-06_JPRB, 0.31745793E-06_JPRB, &
  & 0.31753470E-06_JPRB, 0.31759174E-06_JPRB, 0.31763747E-06_JPRB, 0.31767649E-06_JPRB, 0.31771162E-06_JPRB, 0.31774402E-06_JPRB, &
  & 0.31777319E-06_JPRB, 0.31779697E-06_JPRB, 0.31781295E-06_JPRB, 0.31782017E-06_JPRB, 0.31781934E-06_JPRB, 0.31781187E-06_JPRB, &
  & 0.31779811E-06_JPRB, 0.31777827E-06_JPRB, 0.31775241E-06_JPRB, 0.31772129E-06_JPRB, 0.31768499E-06_JPRB, 0.31764625E-06_JPRB, &
  & 0.31760663E-06_JPRB, 0.31756858E-06_JPRB, 0.31753046E-06_JPRB, 0.31748942E-06_JPRB, 0.31744077E-06_JPRB, 0.31737699E-06_JPRB, &
  & 0.31729033E-06_JPRB, 0.31717252E-06_JPRB, 0.31703135E-06_JPRB, 0.31687455E-06_JPRB, 0.31672369E-06_JPRB, 0.31658132E-06_JPRB, &
  & 0.31644515E-06_JPRB, 0.31630969E-06_JPRB, 0.31617444E-06_JPRB, 0.31604759E-06_JPRB, 0.31594109E-06_JPRB, 0.31585469E-06_JPRB, &
  & 0.31578199E-06_JPRB, 0.31571338E-06_JPRB, 0.31563695E-06_JPRB, 0.31550687E-06_JPRB /)

RGHG3(:,49, 7) = (/ &
  & 0.31417028E-06_JPRB, 0.31447195E-06_JPRB, 0.31467277E-06_JPRB, 0.31489145E-06_JPRB, 0.31513875E-06_JPRB, 0.31537741E-06_JPRB, &
  & 0.31554964E-06_JPRB, 0.31567271E-06_JPRB, 0.31576562E-06_JPRB, 0.31584440E-06_JPRB, 0.31592452E-06_JPRB, 0.31601326E-06_JPRB, &
  & 0.31611623E-06_JPRB, 0.31622895E-06_JPRB, 0.31634593E-06_JPRB, 0.31646277E-06_JPRB, 0.31657800E-06_JPRB, 0.31669583E-06_JPRB, &
  & 0.31682058E-06_JPRB, 0.31695856E-06_JPRB, 0.31711221E-06_JPRB, 0.31726171E-06_JPRB, 0.31738912E-06_JPRB, 0.31748613E-06_JPRB, &
  & 0.31755718E-06_JPRB, 0.31761098E-06_JPRB, 0.31765433E-06_JPRB, 0.31769170E-06_JPRB, 0.31772549E-06_JPRB, 0.31775687E-06_JPRB, &
  & 0.31778521E-06_JPRB, 0.31780840E-06_JPRB, 0.31782440E-06_JPRB, 0.31783205E-06_JPRB, 0.31783196E-06_JPRB, 0.31782528E-06_JPRB, &
  & 0.31781249E-06_JPRB, 0.31779399E-06_JPRB, 0.31777000E-06_JPRB, 0.31774084E-06_JPRB, 0.31770728E-06_JPRB, 0.31767067E-06_JPRB, &
  & 0.31763423E-06_JPRB, 0.31759953E-06_JPRB, 0.31756684E-06_JPRB, 0.31753396E-06_JPRB, 0.31749772E-06_JPRB, 0.31745390E-06_JPRB, &
  & 0.31739796E-06_JPRB, 0.31732773E-06_JPRB, 0.31724093E-06_JPRB, 0.31714706E-06_JPRB, 0.31704687E-06_JPRB, 0.31694736E-06_JPRB, &
  & 0.31684678E-06_JPRB, 0.31673761E-06_JPRB, 0.31662250E-06_JPRB, 0.31650939E-06_JPRB, 0.31641014E-06_JPRB, 0.31632899E-06_JPRB, &
  & 0.31625893E-06_JPRB, 0.31619248E-06_JPRB, 0.31611691E-06_JPRB, 0.31598665E-06_JPRB /)

RGHG3(:,50, 7) = (/ &
  & 0.31499678E-06_JPRB, 0.31526466E-06_JPRB, 0.31544894E-06_JPRB, 0.31565563E-06_JPRB, 0.31589678E-06_JPRB, 0.31611975E-06_JPRB, &
  & 0.31627422E-06_JPRB, 0.31637666E-06_JPRB, 0.31644544E-06_JPRB, 0.31650359E-06_JPRB, 0.31655628E-06_JPRB, 0.31661449E-06_JPRB, &
  & 0.31667903E-06_JPRB, 0.31674779E-06_JPRB, 0.31681367E-06_JPRB, 0.31687372E-06_JPRB, 0.31692801E-06_JPRB, 0.31697954E-06_JPRB, &
  & 0.31703581E-06_JPRB, 0.31711028E-06_JPRB, 0.31720273E-06_JPRB, 0.31731537E-06_JPRB, 0.31742138E-06_JPRB, 0.31750901E-06_JPRB, &
  & 0.31757568E-06_JPRB, 0.31762681E-06_JPRB, 0.31766842E-06_JPRB, 0.31770441E-06_JPRB, 0.31773715E-06_JPRB, 0.31776773E-06_JPRB, &
  & 0.31779553E-06_JPRB, 0.31781849E-06_JPRB, 0.31783463E-06_JPRB, 0.31784273E-06_JPRB, 0.31784344E-06_JPRB, 0.31783742E-06_JPRB, &
  & 0.31782565E-06_JPRB, 0.31780823E-06_JPRB, 0.31778589E-06_JPRB, 0.31775869E-06_JPRB, 0.31772720E-06_JPRB, 0.31769281E-06_JPRB, &
  & 0.31765825E-06_JPRB, 0.31762647E-06_JPRB, 0.31759762E-06_JPRB, 0.31757060E-06_JPRB, 0.31754288E-06_JPRB, 0.31751279E-06_JPRB, &
  & 0.31747831E-06_JPRB, 0.31743866E-06_JPRB, 0.31739515E-06_JPRB, 0.31734663E-06_JPRB, 0.31729681E-06_JPRB, 0.31724369E-06_JPRB, &
  & 0.31718292E-06_JPRB, 0.31711494E-06_JPRB, 0.31703235E-06_JPRB, 0.31694421E-06_JPRB, 0.31686301E-06_JPRB, 0.31679102E-06_JPRB, &
  & 0.31672775E-06_JPRB, 0.31666440E-06_JPRB, 0.31659016E-06_JPRB, 0.31645649E-06_JPRB /)

RGHG3(:,51, 7) = (/ &
  & 0.31562337E-06_JPRB, 0.31587541E-06_JPRB, 0.31604213E-06_JPRB, 0.31621542E-06_JPRB, 0.31642324E-06_JPRB, 0.31660682E-06_JPRB, &
  & 0.31673321E-06_JPRB, 0.31680651E-06_JPRB, 0.31685957E-06_JPRB, 0.31689802E-06_JPRB, 0.31693585E-06_JPRB, 0.31697462E-06_JPRB, &
  & 0.31701762E-06_JPRB, 0.31706060E-06_JPRB, 0.31709860E-06_JPRB, 0.31712926E-06_JPRB, 0.31715280E-06_JPRB, 0.31717292E-06_JPRB, &
  & 0.31719634E-06_JPRB, 0.31722820E-06_JPRB, 0.31728527E-06_JPRB, 0.31735976E-06_JPRB, 0.31744867E-06_JPRB, 0.31752791E-06_JPRB, &
  & 0.31759106E-06_JPRB, 0.31764029E-06_JPRB, 0.31768047E-06_JPRB, 0.31771538E-06_JPRB, 0.31774718E-06_JPRB, 0.31777708E-06_JPRB, &
  & 0.31780451E-06_JPRB, 0.31782736E-06_JPRB, 0.31784373E-06_JPRB, 0.31785243E-06_JPRB, 0.31785393E-06_JPRB, 0.31784865E-06_JPRB, &
  & 0.31783756E-06_JPRB, 0.31782145E-06_JPRB, 0.31780033E-06_JPRB, 0.31777512E-06_JPRB, 0.31774530E-06_JPRB, 0.31771273E-06_JPRB, &
  & 0.31768008E-06_JPRB, 0.31765038E-06_JPRB, 0.31762445E-06_JPRB, 0.31760129E-06_JPRB, 0.31757975E-06_JPRB, 0.31755829E-06_JPRB, &
  & 0.31753694E-06_JPRB, 0.31751540E-06_JPRB, 0.31749360E-06_JPRB, 0.31747214E-06_JPRB, 0.31744960E-06_JPRB, 0.31742564E-06_JPRB, &
  & 0.31739970E-06_JPRB, 0.31736550E-06_JPRB, 0.31732515E-06_JPRB, 0.31727717E-06_JPRB, 0.31722726E-06_JPRB, 0.31718162E-06_JPRB, &
  & 0.31713515E-06_JPRB, 0.31708581E-06_JPRB, 0.31702086E-06_JPRB, 0.31689484E-06_JPRB /)

RGHG3(:,52, 7) = (/ &
  & 0.31620857E-06_JPRB, 0.31637083E-06_JPRB, 0.31648338E-06_JPRB, 0.31661477E-06_JPRB, 0.31676987E-06_JPRB, 0.31691388E-06_JPRB, &
  & 0.31700225E-06_JPRB, 0.31705892E-06_JPRB, 0.31709260E-06_JPRB, 0.31712136E-06_JPRB, 0.31714629E-06_JPRB, 0.31717360E-06_JPRB, &
  & 0.31720359E-06_JPRB, 0.31723297E-06_JPRB, 0.31725745E-06_JPRB, 0.31727495E-06_JPRB, 0.31728683E-06_JPRB, 0.31729581E-06_JPRB, &
  & 0.31730482E-06_JPRB, 0.31732171E-06_JPRB, 0.31734885E-06_JPRB, 0.31740336E-06_JPRB, 0.31747140E-06_JPRB, 0.31754388E-06_JPRB, &
  & 0.31760430E-06_JPRB, 0.31765211E-06_JPRB, 0.31769119E-06_JPRB, 0.31772510E-06_JPRB, 0.31775619E-06_JPRB, 0.31778544E-06_JPRB, &
  & 0.31781249E-06_JPRB, 0.31783529E-06_JPRB, 0.31785203E-06_JPRB, 0.31786126E-06_JPRB, 0.31786348E-06_JPRB, 0.31785888E-06_JPRB, &
  & 0.31784890E-06_JPRB, 0.31783355E-06_JPRB, 0.31781400E-06_JPRB, 0.31778998E-06_JPRB, 0.31776202E-06_JPRB, 0.31773109E-06_JPRB, &
  & 0.31770011E-06_JPRB, 0.31767206E-06_JPRB, 0.31764836E-06_JPRB, 0.31762815E-06_JPRB, 0.31761033E-06_JPRB, 0.31759484E-06_JPRB, &
  & 0.31758077E-06_JPRB, 0.31756861E-06_JPRB, 0.31755775E-06_JPRB, 0.31754740E-06_JPRB, 0.31753780E-06_JPRB, 0.31752822E-06_JPRB, &
  & 0.31751682E-06_JPRB, 0.31750432E-06_JPRB, 0.31748718E-06_JPRB, 0.31746731E-06_JPRB, 0.31744673E-06_JPRB, 0.31742445E-06_JPRB, &
  & 0.31740188E-06_JPRB, 0.31737372E-06_JPRB, 0.31733330E-06_JPRB, 0.31723940E-06_JPRB /)

RGHG3(:,53, 7) = (/ &
  & 0.31657476E-06_JPRB, 0.31670817E-06_JPRB, 0.31679696E-06_JPRB, 0.31689177E-06_JPRB, 0.31700617E-06_JPRB, 0.31710664E-06_JPRB, &
  & 0.31717440E-06_JPRB, 0.31721066E-06_JPRB, 0.31723664E-06_JPRB, 0.31725494E-06_JPRB, 0.31727308E-06_JPRB, 0.31729232E-06_JPRB, &
  & 0.31731378E-06_JPRB, 0.31733546E-06_JPRB, 0.31735274E-06_JPRB, 0.31736454E-06_JPRB, 0.31737176E-06_JPRB, 0.31737625E-06_JPRB, &
  & 0.31738119E-06_JPRB, 0.31738824E-06_JPRB, 0.31740680E-06_JPRB, 0.31743778E-06_JPRB, 0.31749440E-06_JPRB, 0.31755809E-06_JPRB, &
  & 0.31761610E-06_JPRB, 0.31766277E-06_JPRB, 0.31770088E-06_JPRB, 0.31773402E-06_JPRB, 0.31776435E-06_JPRB, 0.31779302E-06_JPRB, &
  & 0.31781966E-06_JPRB, 0.31784242E-06_JPRB, 0.31785956E-06_JPRB, 0.31786942E-06_JPRB, 0.31787238E-06_JPRB, 0.31786868E-06_JPRB, &
  & 0.31785933E-06_JPRB, 0.31784521E-06_JPRB, 0.31782659E-06_JPRB, 0.31780399E-06_JPRB, 0.31777734E-06_JPRB, 0.31774795E-06_JPRB, &
  & 0.31771847E-06_JPRB, 0.31769224E-06_JPRB, 0.31767010E-06_JPRB, 0.31765194E-06_JPRB, 0.31763702E-06_JPRB, 0.31762474E-06_JPRB, &
  & 0.31761513E-06_JPRB, 0.31760754E-06_JPRB, 0.31760138E-06_JPRB, 0.31759643E-06_JPRB, 0.31759191E-06_JPRB, 0.31758759E-06_JPRB, &
  & 0.31758344E-06_JPRB, 0.31757787E-06_JPRB, 0.31757151E-06_JPRB, 0.31756360E-06_JPRB, 0.31755474E-06_JPRB, 0.31754610E-06_JPRB, &
  & 0.31753592E-06_JPRB, 0.31752401E-06_JPRB, 0.31750608E-06_JPRB, 0.31745910E-06_JPRB /)

RGHG3(:,54, 7) = (/ &
  & 0.31688850E-06_JPRB, 0.31696865E-06_JPRB, 0.31702598E-06_JPRB, 0.31709095E-06_JPRB, 0.31716917E-06_JPRB, 0.31724119E-06_JPRB, &
  & 0.31728590E-06_JPRB, 0.31731423E-06_JPRB, 0.31733077E-06_JPRB, 0.31734464E-06_JPRB, 0.31735709E-06_JPRB, 0.31737090E-06_JPRB, &
  & 0.31738725E-06_JPRB, 0.31740342E-06_JPRB, 0.31741678E-06_JPRB, 0.31742559E-06_JPRB, 0.31743079E-06_JPRB, 0.31743403E-06_JPRB, &
  & 0.31743650E-06_JPRB, 0.31744145E-06_JPRB, 0.31745014E-06_JPRB, 0.31747453E-06_JPRB, 0.31751460E-06_JPRB, 0.31757227E-06_JPRB, &
  & 0.31762733E-06_JPRB, 0.31767271E-06_JPRB, 0.31771003E-06_JPRB, 0.31774221E-06_JPRB, 0.31777199E-06_JPRB, 0.31779996E-06_JPRB, &
  & 0.31782619E-06_JPRB, 0.31784901E-06_JPRB, 0.31786647E-06_JPRB, 0.31787704E-06_JPRB, 0.31788076E-06_JPRB, 0.31787789E-06_JPRB, &
  & 0.31786945E-06_JPRB, 0.31785615E-06_JPRB, 0.31783858E-06_JPRB, 0.31781701E-06_JPRB, 0.31779149E-06_JPRB, 0.31776364E-06_JPRB, &
  & 0.31773567E-06_JPRB, 0.31771089E-06_JPRB, 0.31769042E-06_JPRB, 0.31767379E-06_JPRB, 0.31766058E-06_JPRB, 0.31765057E-06_JPRB, &
  & 0.31764307E-06_JPRB, 0.31763767E-06_JPRB, 0.31763375E-06_JPRB, 0.31763071E-06_JPRB, 0.31762841E-06_JPRB, 0.31762642E-06_JPRB, &
  & 0.31762420E-06_JPRB, 0.31762195E-06_JPRB, 0.31761897E-06_JPRB, 0.31761556E-06_JPRB, 0.31761203E-06_JPRB, 0.31760820E-06_JPRB, &
  & 0.31760447E-06_JPRB, 0.31760052E-06_JPRB, 0.31759711E-06_JPRB, 0.31759666E-06_JPRB /)

RGHG3(:,55, 7) = (/ &
  & 0.31708569E-06_JPRB, 0.31714845E-06_JPRB, 0.31718980E-06_JPRB, 0.31723570E-06_JPRB, 0.31728746E-06_JPRB, 0.31733572E-06_JPRB, &
  & 0.31736920E-06_JPRB, 0.31738756E-06_JPRB, 0.31740046E-06_JPRB, 0.31740976E-06_JPRB, 0.31741894E-06_JPRB, 0.31742923E-06_JPRB, &
  & 0.31744111E-06_JPRB, 0.31745407E-06_JPRB, 0.31746458E-06_JPRB, 0.31747186E-06_JPRB, 0.31747612E-06_JPRB, 0.31747840E-06_JPRB, &
  & 0.31748021E-06_JPRB, 0.31748263E-06_JPRB, 0.31748962E-06_JPRB, 0.31750375E-06_JPRB, 0.31753763E-06_JPRB, 0.31758663E-06_JPRB, &
  & 0.31763855E-06_JPRB, 0.31768235E-06_JPRB, 0.31771859E-06_JPRB, 0.31775014E-06_JPRB, 0.31777904E-06_JPRB, 0.31780661E-06_JPRB, &
  & 0.31783250E-06_JPRB, 0.31785527E-06_JPRB, 0.31787312E-06_JPRB, 0.31788434E-06_JPRB, 0.31788875E-06_JPRB, 0.31788665E-06_JPRB, &
  & 0.31787906E-06_JPRB, 0.31786652E-06_JPRB, 0.31784975E-06_JPRB, 0.31782906E-06_JPRB, 0.31780473E-06_JPRB, 0.31777805E-06_JPRB, &
  & 0.31775190E-06_JPRB, 0.31772868E-06_JPRB, 0.31770955E-06_JPRB, 0.31769423E-06_JPRB, 0.31768235E-06_JPRB, 0.31767345E-06_JPRB, &
  & 0.31766712E-06_JPRB, 0.31766268E-06_JPRB, 0.31765944E-06_JPRB, 0.31765728E-06_JPRB, 0.31765563E-06_JPRB, 0.31765421E-06_JPRB, &
  & 0.31765308E-06_JPRB, 0.31765160E-06_JPRB, 0.31764998E-06_JPRB, 0.31764807E-06_JPRB, 0.31764597E-06_JPRB, 0.31764398E-06_JPRB, &
  & 0.31764176E-06_JPRB, 0.31763949E-06_JPRB, 0.31763693E-06_JPRB, 0.31763363E-06_JPRB /)

RGHG3(:,56, 7) = (/ &
  & 0.31724508E-06_JPRB, 0.31728334E-06_JPRB, 0.31731108E-06_JPRB, 0.31734038E-06_JPRB, 0.31737591E-06_JPRB, 0.31740836E-06_JPRB, &
  & 0.31743073E-06_JPRB, 0.31744514E-06_JPRB, 0.31745381E-06_JPRB, 0.31746100E-06_JPRB, 0.31746771E-06_JPRB, 0.31747521E-06_JPRB, &
  & 0.31748465E-06_JPRB, 0.31749460E-06_JPRB, 0.31750344E-06_JPRB, 0.31750966E-06_JPRB, 0.31751333E-06_JPRB, 0.31751540E-06_JPRB, &
  & 0.31751648E-06_JPRB, 0.31751827E-06_JPRB, 0.31752194E-06_JPRB, 0.31753376E-06_JPRB, 0.31755900E-06_JPRB, 0.31760231E-06_JPRB, &
  & 0.31765012E-06_JPRB, 0.31769207E-06_JPRB, 0.31772714E-06_JPRB, 0.31775781E-06_JPRB, 0.31778623E-06_JPRB, 0.31781315E-06_JPRB, &
  & 0.31783875E-06_JPRB, 0.31786152E-06_JPRB, 0.31787954E-06_JPRB, 0.31789131E-06_JPRB, 0.31789645E-06_JPRB, 0.31789509E-06_JPRB, &
  & 0.31788821E-06_JPRB, 0.31787653E-06_JPRB, 0.31786055E-06_JPRB, 0.31784060E-06_JPRB, 0.31781715E-06_JPRB, 0.31779211E-06_JPRB, &
  & 0.31776739E-06_JPRB, 0.31774570E-06_JPRB, 0.31772797E-06_JPRB, 0.31771373E-06_JPRB, 0.31770273E-06_JPRB, 0.31769463E-06_JPRB, &
  & 0.31768866E-06_JPRB, 0.31768442E-06_JPRB, 0.31768144E-06_JPRB, 0.31767925E-06_JPRB, 0.31767772E-06_JPRB, 0.31767655E-06_JPRB, &
  & 0.31767530E-06_JPRB, 0.31767416E-06_JPRB, 0.31767280E-06_JPRB, 0.31767138E-06_JPRB, 0.31766999E-06_JPRB, 0.31766851E-06_JPRB, &
  & 0.31766706E-06_JPRB, 0.31766547E-06_JPRB, 0.31766368E-06_JPRB, 0.31766120E-06_JPRB /)

RGHG3(:,57, 7) = (/ &
  & 0.31734874E-06_JPRB, 0.31737918E-06_JPRB, 0.31739876E-06_JPRB, 0.31742010E-06_JPRB, 0.31744241E-06_JPRB, 0.31746475E-06_JPRB, &
  & 0.31748112E-06_JPRB, 0.31749096E-06_JPRB, 0.31749784E-06_JPRB, 0.31750307E-06_JPRB, 0.31750818E-06_JPRB, 0.31751409E-06_JPRB, &
  & 0.31752117E-06_JPRB, 0.31752941E-06_JPRB, 0.31753677E-06_JPRB, 0.31754237E-06_JPRB, 0.31754581E-06_JPRB, 0.31754757E-06_JPRB, &
  & 0.31754848E-06_JPRB, 0.31754919E-06_JPRB, 0.31755201E-06_JPRB, 0.31755982E-06_JPRB, 0.31758151E-06_JPRB, 0.31761903E-06_JPRB, &
  & 0.31766257E-06_JPRB, 0.31770199E-06_JPRB, 0.31773584E-06_JPRB, 0.31776580E-06_JPRB, 0.31779342E-06_JPRB, 0.31781997E-06_JPRB, &
  & 0.31784509E-06_JPRB, 0.31786777E-06_JPRB, 0.31788599E-06_JPRB, 0.31789824E-06_JPRB, 0.31790387E-06_JPRB, 0.31790319E-06_JPRB, &
  & 0.31789716E-06_JPRB, 0.31788613E-06_JPRB, 0.31787084E-06_JPRB, 0.31785160E-06_JPRB, 0.31782926E-06_JPRB, 0.31780539E-06_JPRB, &
  & 0.31778237E-06_JPRB, 0.31776219E-06_JPRB, 0.31774559E-06_JPRB, 0.31773232E-06_JPRB, 0.31772211E-06_JPRB, 0.31771438E-06_JPRB, &
  & 0.31770867E-06_JPRB, 0.31770441E-06_JPRB, 0.31770116E-06_JPRB, 0.31769886E-06_JPRB, 0.31769716E-06_JPRB, 0.31769571E-06_JPRB, &
  & 0.31769449E-06_JPRB, 0.31769309E-06_JPRB, 0.31769170E-06_JPRB, 0.31769022E-06_JPRB, 0.31768877E-06_JPRB, 0.31768747E-06_JPRB, &
  & 0.31768604E-06_JPRB, 0.31768454E-06_JPRB, 0.31768278E-06_JPRB, 0.31767982E-06_JPRB /)

RGHG3(:,58, 7) = (/ &
  & 0.31743238E-06_JPRB, 0.31745236E-06_JPRB, 0.31746612E-06_JPRB, 0.31747982E-06_JPRB, 0.31749579E-06_JPRB, 0.31751060E-06_JPRB, &
  & 0.31752217E-06_JPRB, 0.31752984E-06_JPRB, 0.31753490E-06_JPRB, 0.31753905E-06_JPRB, 0.31754314E-06_JPRB, 0.31754774E-06_JPRB, &
  & 0.31755371E-06_JPRB, 0.31756048E-06_JPRB, 0.31756713E-06_JPRB, 0.31757230E-06_JPRB, 0.31757560E-06_JPRB, 0.31757722E-06_JPRB, &
  & 0.31757764E-06_JPRB, 0.31757764E-06_JPRB, 0.31757898E-06_JPRB, 0.31758537E-06_JPRB, 0.31760348E-06_JPRB, 0.31763648E-06_JPRB, &
  & 0.31767587E-06_JPRB, 0.31771270E-06_JPRB, 0.31774505E-06_JPRB, 0.31777407E-06_JPRB, 0.31780104E-06_JPRB, 0.31782702E-06_JPRB, &
  & 0.31785189E-06_JPRB, 0.31787431E-06_JPRB, 0.31789256E-06_JPRB, 0.31790509E-06_JPRB, 0.31791120E-06_JPRB, 0.31791114E-06_JPRB, &
  & 0.31790586E-06_JPRB, 0.31789563E-06_JPRB, 0.31788085E-06_JPRB, 0.31786232E-06_JPRB, 0.31784094E-06_JPRB, 0.31781849E-06_JPRB, &
  & 0.31779706E-06_JPRB, 0.31777816E-06_JPRB, 0.31776278E-06_JPRB, 0.31775025E-06_JPRB, 0.31774067E-06_JPRB, 0.31773334E-06_JPRB, &
  & 0.31772777E-06_JPRB, 0.31772339E-06_JPRB, 0.31772001E-06_JPRB, 0.31771725E-06_JPRB, 0.31771509E-06_JPRB, 0.31771339E-06_JPRB, &
  & 0.31771162E-06_JPRB, 0.31770998E-06_JPRB, 0.31770816E-06_JPRB, 0.31770645E-06_JPRB, 0.31770492E-06_JPRB, 0.31770338E-06_JPRB, &
  & 0.31770196E-06_JPRB, 0.31770037E-06_JPRB, 0.31769849E-06_JPRB, 0.31769540E-06_JPRB /)

RGHG3(:,59, 7) = (/ &
  & 0.31749050E-06_JPRB, 0.31750722E-06_JPRB, 0.31751762E-06_JPRB, 0.31752785E-06_JPRB, 0.31753828E-06_JPRB, 0.31754902E-06_JPRB, &
  & 0.31755746E-06_JPRB, 0.31756332E-06_JPRB, 0.31756741E-06_JPRB, 0.31757082E-06_JPRB, 0.31757412E-06_JPRB, 0.31757810E-06_JPRB, &
  & 0.31758299E-06_JPRB, 0.31758913E-06_JPRB, 0.31759521E-06_JPRB, 0.31760030E-06_JPRB, 0.31760362E-06_JPRB, 0.31760510E-06_JPRB, &
  & 0.31760504E-06_JPRB, 0.31760425E-06_JPRB, 0.31760445E-06_JPRB, 0.31760914E-06_JPRB, 0.31762511E-06_JPRB, 0.31765441E-06_JPRB, &
  & 0.31768991E-06_JPRB, 0.31772416E-06_JPRB, 0.31775508E-06_JPRB, 0.31778308E-06_JPRB, 0.31780934E-06_JPRB, 0.31783472E-06_JPRB, &
  & 0.31785908E-06_JPRB, 0.31788119E-06_JPRB, 0.31789935E-06_JPRB, 0.31791200E-06_JPRB, 0.31791842E-06_JPRB, 0.31791890E-06_JPRB, &
  & 0.31791419E-06_JPRB, 0.31790469E-06_JPRB, 0.31789065E-06_JPRB, 0.31787280E-06_JPRB, 0.31785257E-06_JPRB, 0.31783151E-06_JPRB, &
  & 0.31781136E-06_JPRB, 0.31779390E-06_JPRB, 0.31777924E-06_JPRB, 0.31776773E-06_JPRB, 0.31775866E-06_JPRB, 0.31775164E-06_JPRB, &
  & 0.31774610E-06_JPRB, 0.31774172E-06_JPRB, 0.31773811E-06_JPRB, 0.31773502E-06_JPRB, 0.31773254E-06_JPRB, 0.31773010E-06_JPRB, &
  & 0.31772794E-06_JPRB, 0.31772558E-06_JPRB, 0.31772333E-06_JPRB, 0.31772123E-06_JPRB, 0.31771924E-06_JPRB, 0.31771754E-06_JPRB, &
  & 0.31771577E-06_JPRB, 0.31771390E-06_JPRB, 0.31771174E-06_JPRB, 0.31770799E-06_JPRB /)

RGHG3(:,60, 7) = (/ &
  & 0.31753899E-06_JPRB, 0.31755175E-06_JPRB, 0.31755945E-06_JPRB, 0.31756667E-06_JPRB, 0.31757449E-06_JPRB, 0.31758202E-06_JPRB, &
  & 0.31758856E-06_JPRB, 0.31759325E-06_JPRB, 0.31759674E-06_JPRB, 0.31759959E-06_JPRB, 0.31760263E-06_JPRB, 0.31760609E-06_JPRB, &
  & 0.31761073E-06_JPRB, 0.31761630E-06_JPRB, 0.31762221E-06_JPRB, 0.31762730E-06_JPRB, 0.31763076E-06_JPRB, 0.31763204E-06_JPRB, &
  & 0.31763142E-06_JPRB, 0.31762949E-06_JPRB, 0.31762852E-06_JPRB, 0.31763219E-06_JPRB, 0.31764642E-06_JPRB, 0.31767240E-06_JPRB, &
  & 0.31770455E-06_JPRB, 0.31773644E-06_JPRB, 0.31776574E-06_JPRB, 0.31779285E-06_JPRB, 0.31781832E-06_JPRB, 0.31784313E-06_JPRB, &
  & 0.31786686E-06_JPRB, 0.31788866E-06_JPRB, 0.31790645E-06_JPRB, 0.31791899E-06_JPRB, 0.31792555E-06_JPRB, 0.31792644E-06_JPRB, &
  & 0.31792223E-06_JPRB, 0.31791342E-06_JPRB, 0.31790012E-06_JPRB, 0.31788318E-06_JPRB, 0.31786408E-06_JPRB, 0.31784427E-06_JPRB, &
  & 0.31782579E-06_JPRB, 0.31780925E-06_JPRB, 0.31779570E-06_JPRB, 0.31778470E-06_JPRB, 0.31777608E-06_JPRB, 0.31776929E-06_JPRB, &
  & 0.31776383E-06_JPRB, 0.31775946E-06_JPRB, 0.31775576E-06_JPRB, 0.31775255E-06_JPRB, 0.31774957E-06_JPRB, 0.31774687E-06_JPRB, &
  & 0.31774388E-06_JPRB, 0.31774104E-06_JPRB, 0.31773808E-06_JPRB, 0.31773536E-06_JPRB, 0.31773303E-06_JPRB, 0.31773075E-06_JPRB, &
  & 0.31772859E-06_JPRB, 0.31772635E-06_JPRB, 0.31772356E-06_JPRB, 0.31771899E-06_JPRB /)

RGHG3(:,61, 7) = (/ &
  & 0.31757764E-06_JPRB, 0.31758805E-06_JPRB, 0.31759427E-06_JPRB, 0.31759990E-06_JPRB, 0.31760567E-06_JPRB, 0.31761164E-06_JPRB, &
  & 0.31761675E-06_JPRB, 0.31762079E-06_JPRB, 0.31762377E-06_JPRB, 0.31762650E-06_JPRB, 0.31762920E-06_JPRB, 0.31763261E-06_JPRB, &
  & 0.31763693E-06_JPRB, 0.31764253E-06_JPRB, 0.31764844E-06_JPRB, 0.31765370E-06_JPRB, 0.31765711E-06_JPRB, 0.31765813E-06_JPRB, &
  & 0.31765677E-06_JPRB, 0.31765390E-06_JPRB, 0.31765185E-06_JPRB, 0.31765467E-06_JPRB, 0.31766720E-06_JPRB, 0.31769054E-06_JPRB, &
  & 0.31771964E-06_JPRB, 0.31774940E-06_JPRB, 0.31777734E-06_JPRB, 0.31780343E-06_JPRB, 0.31782821E-06_JPRB, 0.31785217E-06_JPRB, &
  & 0.31787530E-06_JPRB, 0.31789648E-06_JPRB, 0.31791384E-06_JPRB, 0.31792615E-06_JPRB, 0.31793263E-06_JPRB, 0.31793380E-06_JPRB, &
  & 0.31793013E-06_JPRB, 0.31792183E-06_JPRB, 0.31790944E-06_JPRB, 0.31789347E-06_JPRB, 0.31787548E-06_JPRB, 0.31785720E-06_JPRB, &
  & 0.31783966E-06_JPRB, 0.31782460E-06_JPRB, 0.31781161E-06_JPRB, 0.31780138E-06_JPRB, 0.31779314E-06_JPRB, 0.31778657E-06_JPRB, &
  & 0.31778120E-06_JPRB, 0.31777674E-06_JPRB, 0.31777304E-06_JPRB, 0.31776966E-06_JPRB, 0.31776653E-06_JPRB, 0.31776341E-06_JPRB, &
  & 0.31776003E-06_JPRB, 0.31775642E-06_JPRB, 0.31775281E-06_JPRB, 0.31774948E-06_JPRB, 0.31774647E-06_JPRB, 0.31774371E-06_JPRB, &
  & 0.31774098E-06_JPRB, 0.31773800E-06_JPRB, 0.31773450E-06_JPRB, 0.31772822E-06_JPRB /)

RGHG3(:,62, 7) = (/ &
  & 0.31761090E-06_JPRB, 0.31761951E-06_JPRB, 0.31762443E-06_JPRB, 0.31762897E-06_JPRB, 0.31763363E-06_JPRB, 0.31763835E-06_JPRB, &
  & 0.31764282E-06_JPRB, 0.31764637E-06_JPRB, 0.31764932E-06_JPRB, 0.31765194E-06_JPRB, 0.31765478E-06_JPRB, 0.31765811E-06_JPRB, &
  & 0.31766260E-06_JPRB, 0.31766822E-06_JPRB, 0.31767448E-06_JPRB, 0.31767991E-06_JPRB, 0.31768340E-06_JPRB, 0.31768397E-06_JPRB, &
  & 0.31768158E-06_JPRB, 0.31767769E-06_JPRB, 0.31767473E-06_JPRB, 0.31767675E-06_JPRB, 0.31768775E-06_JPRB, 0.31770855E-06_JPRB, &
  & 0.31773524E-06_JPRB, 0.31776298E-06_JPRB, 0.31778967E-06_JPRB, 0.31781485E-06_JPRB, 0.31783884E-06_JPRB, 0.31786212E-06_JPRB, &
  & 0.31788448E-06_JPRB, 0.31790498E-06_JPRB, 0.31792166E-06_JPRB, 0.31793337E-06_JPRB, 0.31793968E-06_JPRB, 0.31794096E-06_JPRB, &
  & 0.31793769E-06_JPRB, 0.31793010E-06_JPRB, 0.31791848E-06_JPRB, 0.31790356E-06_JPRB, 0.31788676E-06_JPRB, 0.31786971E-06_JPRB, &
  & 0.31785379E-06_JPRB, 0.31783946E-06_JPRB, 0.31782758E-06_JPRB, 0.31781769E-06_JPRB, 0.31780985E-06_JPRB, 0.31780348E-06_JPRB, &
  & 0.31779825E-06_JPRB, 0.31779376E-06_JPRB, 0.31779004E-06_JPRB, 0.31778663E-06_JPRB, 0.31778342E-06_JPRB, 0.31778001E-06_JPRB, &
  & 0.31777611E-06_JPRB, 0.31777211E-06_JPRB, 0.31776779E-06_JPRB, 0.31776378E-06_JPRB, 0.31776020E-06_JPRB, 0.31775681E-06_JPRB, &
  & 0.31775335E-06_JPRB, 0.31774965E-06_JPRB, 0.31774485E-06_JPRB, 0.31773664E-06_JPRB /)

RGHG3(:,63, 7) = (/ &
  & 0.31763867E-06_JPRB, 0.31764648E-06_JPRB, 0.31765094E-06_JPRB, 0.31765487E-06_JPRB, 0.31765882E-06_JPRB, 0.31766299E-06_JPRB, &
  & 0.31766689E-06_JPRB, 0.31767041E-06_JPRB, 0.31767337E-06_JPRB, 0.31767621E-06_JPRB, 0.31767922E-06_JPRB, 0.31768303E-06_JPRB, &
  & 0.31768789E-06_JPRB, 0.31769397E-06_JPRB, 0.31770034E-06_JPRB, 0.31770580E-06_JPRB, 0.31770898E-06_JPRB, 0.31770895E-06_JPRB, &
  & 0.31770583E-06_JPRB, 0.31770111E-06_JPRB, 0.31769733E-06_JPRB, 0.31769855E-06_JPRB, 0.31770810E-06_JPRB, 0.31772686E-06_JPRB, &
  & 0.31775122E-06_JPRB, 0.31777731E-06_JPRB, 0.31780280E-06_JPRB, 0.31782707E-06_JPRB, 0.31785041E-06_JPRB, 0.31787280E-06_JPRB, &
  & 0.31789432E-06_JPRB, 0.31791384E-06_JPRB, 0.31792979E-06_JPRB, 0.31794085E-06_JPRB, 0.31794673E-06_JPRB, 0.31794812E-06_JPRB, &
  & 0.31794511E-06_JPRB, 0.31793803E-06_JPRB, 0.31792732E-06_JPRB, 0.31791348E-06_JPRB, 0.31789793E-06_JPRB, 0.31788227E-06_JPRB, &
  & 0.31786738E-06_JPRB, 0.31785424E-06_JPRB, 0.31784302E-06_JPRB, 0.31783384E-06_JPRB, 0.31782631E-06_JPRB, 0.31782014E-06_JPRB, &
  & 0.31781505E-06_JPRB, 0.31781059E-06_JPRB, 0.31780687E-06_JPRB, 0.31780348E-06_JPRB, 0.31780021E-06_JPRB, 0.31779666E-06_JPRB, &
  & 0.31779246E-06_JPRB, 0.31778796E-06_JPRB, 0.31778313E-06_JPRB, 0.31777859E-06_JPRB, 0.31777444E-06_JPRB, 0.31777040E-06_JPRB, &
  & 0.31776634E-06_JPRB, 0.31776176E-06_JPRB, 0.31775596E-06_JPRB, 0.31774525E-06_JPRB /)

RGHG3(:,64, 7) = (/ &
  & 0.31766322E-06_JPRB, 0.31767067E-06_JPRB, 0.31767485E-06_JPRB, 0.31767854E-06_JPRB, 0.31768224E-06_JPRB, 0.31768599E-06_JPRB, &
  & 0.31768977E-06_JPRB, 0.31769321E-06_JPRB, 0.31769648E-06_JPRB, 0.31769957E-06_JPRB, 0.31770313E-06_JPRB, 0.31770736E-06_JPRB, &
  & 0.31771293E-06_JPRB, 0.31771941E-06_JPRB, 0.31772609E-06_JPRB, 0.31773132E-06_JPRB, 0.31773402E-06_JPRB, 0.31773325E-06_JPRB, &
  & 0.31772922E-06_JPRB, 0.31772373E-06_JPRB, 0.31771961E-06_JPRB, 0.31771998E-06_JPRB, 0.31772831E-06_JPRB, 0.31774522E-06_JPRB, &
  & 0.31776770E-06_JPRB, 0.31779220E-06_JPRB, 0.31781656E-06_JPRB, 0.31783995E-06_JPRB, 0.31786249E-06_JPRB, 0.31788409E-06_JPRB, &
  & 0.31790449E-06_JPRB, 0.31792300E-06_JPRB, 0.31793783E-06_JPRB, 0.31794809E-06_JPRB, 0.31795355E-06_JPRB, 0.31795474E-06_JPRB, &
  & 0.31795210E-06_JPRB, 0.31794571E-06_JPRB, 0.31793584E-06_JPRB, 0.31792311E-06_JPRB, 0.31790887E-06_JPRB, 0.31789449E-06_JPRB, &
  & 0.31788090E-06_JPRB, 0.31786860E-06_JPRB, 0.31785822E-06_JPRB, 0.31784953E-06_JPRB, 0.31784236E-06_JPRB, 0.31783640E-06_JPRB, &
  & 0.31783145E-06_JPRB, 0.31782716E-06_JPRB, 0.31782349E-06_JPRB, 0.31782011E-06_JPRB, 0.31781678E-06_JPRB, 0.31781312E-06_JPRB, &
  & 0.31780874E-06_JPRB, 0.31780399E-06_JPRB, 0.31779877E-06_JPRB, 0.31779373E-06_JPRB, 0.31778907E-06_JPRB, 0.31778450E-06_JPRB, &
  & 0.31777984E-06_JPRB, 0.31777478E-06_JPRB, 0.31776784E-06_JPRB, 0.31775485E-06_JPRB /)

RGHG3(:,65, 7) = (/ &
  & 0.31768525E-06_JPRB, 0.31769275E-06_JPRB, 0.31769696E-06_JPRB, 0.31770054E-06_JPRB, 0.31770401E-06_JPRB, 0.31770767E-06_JPRB, &
  & 0.31771123E-06_JPRB, 0.31771492E-06_JPRB, 0.31771836E-06_JPRB, 0.31772214E-06_JPRB, 0.31772626E-06_JPRB, 0.31773143E-06_JPRB, &
  & 0.31773754E-06_JPRB, 0.31774454E-06_JPRB, 0.31775119E-06_JPRB, 0.31775596E-06_JPRB, 0.31775807E-06_JPRB, 0.31775664E-06_JPRB, &
  & 0.31775227E-06_JPRB, 0.31774658E-06_JPRB, 0.31774150E-06_JPRB, 0.31774115E-06_JPRB, 0.31774837E-06_JPRB, 0.31776369E-06_JPRB, &
  & 0.31778441E-06_JPRB, 0.31780749E-06_JPRB, 0.31783074E-06_JPRB, 0.31785322E-06_JPRB, 0.31787482E-06_JPRB, 0.31789543E-06_JPRB, &
  & 0.31791473E-06_JPRB, 0.31793178E-06_JPRB, 0.31794553E-06_JPRB, 0.31795491E-06_JPRB, 0.31795986E-06_JPRB, 0.31796097E-06_JPRB, &
  & 0.31795852E-06_JPRB, 0.31795273E-06_JPRB, 0.31794377E-06_JPRB, 0.31793223E-06_JPRB, 0.31791924E-06_JPRB, 0.31790626E-06_JPRB, &
  & 0.31789372E-06_JPRB, 0.31788250E-06_JPRB, 0.31787283E-06_JPRB, 0.31786476E-06_JPRB, 0.31785785E-06_JPRB, 0.31785223E-06_JPRB, &
  & 0.31784742E-06_JPRB, 0.31784333E-06_JPRB, 0.31783981E-06_JPRB, 0.31783651E-06_JPRB, 0.31783318E-06_JPRB, 0.31782946E-06_JPRB, &
  & 0.31782500E-06_JPRB, 0.31782011E-06_JPRB, 0.31781462E-06_JPRB, 0.31780914E-06_JPRB, 0.31780411E-06_JPRB, 0.31779905E-06_JPRB, &
  & 0.31779402E-06_JPRB, 0.31778859E-06_JPRB, 0.31778086E-06_JPRB, 0.31776594E-06_JPRB /)

RGHG3(:,66, 7) = (/ &
  & 0.31770497E-06_JPRB, 0.31771305E-06_JPRB, 0.31771748E-06_JPRB, 0.31772129E-06_JPRB, 0.31772493E-06_JPRB, 0.31772851E-06_JPRB, &
  & 0.31773220E-06_JPRB, 0.31773590E-06_JPRB, 0.31773996E-06_JPRB, 0.31774411E-06_JPRB, 0.31774920E-06_JPRB, 0.31775500E-06_JPRB, &
  & 0.31776185E-06_JPRB, 0.31776884E-06_JPRB, 0.31777526E-06_JPRB, 0.31777958E-06_JPRB, 0.31778123E-06_JPRB, 0.31777935E-06_JPRB, &
  & 0.31777441E-06_JPRB, 0.31776801E-06_JPRB, 0.31776298E-06_JPRB, 0.31776213E-06_JPRB, 0.31776838E-06_JPRB, 0.31778237E-06_JPRB, &
  & 0.31780149E-06_JPRB, 0.31782309E-06_JPRB, 0.31784509E-06_JPRB, 0.31786644E-06_JPRB, 0.31788696E-06_JPRB, 0.31790648E-06_JPRB, &
  & 0.31792442E-06_JPRB, 0.31794008E-06_JPRB, 0.31795255E-06_JPRB, 0.31796105E-06_JPRB, 0.31796549E-06_JPRB, 0.31796645E-06_JPRB, &
  & 0.31796429E-06_JPRB, 0.31795901E-06_JPRB, 0.31795099E-06_JPRB, 0.31794067E-06_JPRB, 0.31792905E-06_JPRB, 0.31791731E-06_JPRB, &
  & 0.31790597E-06_JPRB, 0.31789565E-06_JPRB, 0.31788682E-06_JPRB, 0.31787926E-06_JPRB, 0.31787283E-06_JPRB, 0.31786752E-06_JPRB, &
  & 0.31786291E-06_JPRB, 0.31785902E-06_JPRB, 0.31785561E-06_JPRB, 0.31785245E-06_JPRB, 0.31784930E-06_JPRB, 0.31784555E-06_JPRB, &
  & 0.31784117E-06_JPRB, 0.31783614E-06_JPRB, 0.31783048E-06_JPRB, 0.31782474E-06_JPRB, 0.31781937E-06_JPRB, 0.31781400E-06_JPRB, &
  & 0.31780877E-06_JPRB, 0.31780320E-06_JPRB, 0.31779496E-06_JPRB, 0.31777873E-06_JPRB /)

RGHG3(:,67, 7) = (/ &
  & 0.31772311E-06_JPRB, 0.31773214E-06_JPRB, 0.31773715E-06_JPRB, 0.31774127E-06_JPRB, 0.31774522E-06_JPRB, 0.31774906E-06_JPRB, &
  & 0.31775278E-06_JPRB, 0.31775676E-06_JPRB, 0.31776099E-06_JPRB, 0.31776605E-06_JPRB, 0.31777159E-06_JPRB, 0.31777813E-06_JPRB, &
  & 0.31778507E-06_JPRB, 0.31779200E-06_JPRB, 0.31779811E-06_JPRB, 0.31780201E-06_JPRB, 0.31780326E-06_JPRB, 0.31780115E-06_JPRB, &
  & 0.31779612E-06_JPRB, 0.31778998E-06_JPRB, 0.31778447E-06_JPRB, 0.31778296E-06_JPRB, 0.31778839E-06_JPRB, 0.31780101E-06_JPRB, &
  & 0.31781863E-06_JPRB, 0.31783870E-06_JPRB, 0.31785936E-06_JPRB, 0.31787948E-06_JPRB, 0.31789867E-06_JPRB, 0.31791680E-06_JPRB, &
  & 0.31793340E-06_JPRB, 0.31794767E-06_JPRB, 0.31795889E-06_JPRB, 0.31796651E-06_JPRB, 0.31797035E-06_JPRB, 0.31797128E-06_JPRB, &
  & 0.31796935E-06_JPRB, 0.31796469E-06_JPRB, 0.31795750E-06_JPRB, 0.31794843E-06_JPRB, 0.31793806E-06_JPRB, 0.31792757E-06_JPRB, &
  & 0.31791737E-06_JPRB, 0.31790807E-06_JPRB, 0.31790003E-06_JPRB, 0.31789304E-06_JPRB, 0.31788710E-06_JPRB, 0.31788224E-06_JPRB, &
  & 0.31787795E-06_JPRB, 0.31787437E-06_JPRB, 0.31787110E-06_JPRB, 0.31786823E-06_JPRB, 0.31786504E-06_JPRB, 0.31786146E-06_JPRB, &
  & 0.31785714E-06_JPRB, 0.31785208E-06_JPRB, 0.31784631E-06_JPRB, 0.31784046E-06_JPRB, 0.31783500E-06_JPRB, 0.31782952E-06_JPRB, &
  & 0.31782415E-06_JPRB, 0.31781849E-06_JPRB, 0.31780993E-06_JPRB, 0.31779248E-06_JPRB /)

RGHG3(:,68, 7) = (/ &
  & 0.31773871E-06_JPRB, 0.31774997E-06_JPRB, 0.31775585E-06_JPRB, 0.31776074E-06_JPRB, 0.31776517E-06_JPRB, 0.31776938E-06_JPRB, &
  & 0.31777341E-06_JPRB, 0.31777762E-06_JPRB, 0.31778254E-06_JPRB, 0.31778762E-06_JPRB, 0.31779388E-06_JPRB, 0.31780036E-06_JPRB, &
  & 0.31780723E-06_JPRB, 0.31781386E-06_JPRB, 0.31781968E-06_JPRB, 0.31782329E-06_JPRB, 0.31782434E-06_JPRB, 0.31782204E-06_JPRB, &
  & 0.31781693E-06_JPRB, 0.31781062E-06_JPRB, 0.31780527E-06_JPRB, 0.31780365E-06_JPRB, 0.31780823E-06_JPRB, 0.31781960E-06_JPRB, &
  & 0.31783571E-06_JPRB, 0.31785410E-06_JPRB, 0.31787329E-06_JPRB, 0.31789193E-06_JPRB, 0.31790978E-06_JPRB, 0.31792646E-06_JPRB, &
  & 0.31794158E-06_JPRB, 0.31795446E-06_JPRB, 0.31796458E-06_JPRB, 0.31797140E-06_JPRB, 0.31797481E-06_JPRB, 0.31797555E-06_JPRB, &
  & 0.31797379E-06_JPRB, 0.31796969E-06_JPRB, 0.31796344E-06_JPRB, 0.31795537E-06_JPRB, 0.31794622E-06_JPRB, 0.31793689E-06_JPRB, &
  & 0.31792788E-06_JPRB, 0.31791967E-06_JPRB, 0.31791237E-06_JPRB, 0.31790600E-06_JPRB, 0.31790069E-06_JPRB, 0.31789631E-06_JPRB, &
  & 0.31789244E-06_JPRB, 0.31788917E-06_JPRB, 0.31788610E-06_JPRB, 0.31788340E-06_JPRB, 0.31788042E-06_JPRB, 0.31787701E-06_JPRB, &
  & 0.31787289E-06_JPRB, 0.31786786E-06_JPRB, 0.31786220E-06_JPRB, 0.31785635E-06_JPRB, 0.31785078E-06_JPRB, 0.31784535E-06_JPRB, &
  & 0.31783998E-06_JPRB, 0.31783452E-06_JPRB, 0.31782608E-06_JPRB, 0.31780860E-06_JPRB /)

RGHG3(:,69, 7) = (/ &
  & 0.31775315E-06_JPRB, 0.31776716E-06_JPRB, 0.31777455E-06_JPRB, 0.31778015E-06_JPRB, 0.31778524E-06_JPRB, 0.31778984E-06_JPRB, &
  & 0.31779410E-06_JPRB, 0.31779868E-06_JPRB, 0.31780374E-06_JPRB, 0.31780922E-06_JPRB, 0.31781533E-06_JPRB, 0.31782184E-06_JPRB, &
  & 0.31782838E-06_JPRB, 0.31783463E-06_JPRB, 0.31784026E-06_JPRB, 0.31784356E-06_JPRB, 0.31784447E-06_JPRB, 0.31784214E-06_JPRB, &
  & 0.31783730E-06_JPRB, 0.31783159E-06_JPRB, 0.31782622E-06_JPRB, 0.31782426E-06_JPRB, 0.31782804E-06_JPRB, 0.31783799E-06_JPRB, &
  & 0.31785254E-06_JPRB, 0.31786936E-06_JPRB, 0.31788693E-06_JPRB, 0.31790401E-06_JPRB, 0.31792027E-06_JPRB, 0.31793547E-06_JPRB, &
  & 0.31794906E-06_JPRB, 0.31796060E-06_JPRB, 0.31796958E-06_JPRB, 0.31797566E-06_JPRB, 0.31797876E-06_JPRB, 0.31797936E-06_JPRB, &
  & 0.31797777E-06_JPRB, 0.31797407E-06_JPRB, 0.31796870E-06_JPRB, 0.31796162E-06_JPRB, 0.31795363E-06_JPRB, 0.31794542E-06_JPRB, &
  & 0.31793766E-06_JPRB, 0.31793041E-06_JPRB, 0.31792393E-06_JPRB, 0.31791828E-06_JPRB, 0.31791342E-06_JPRB, 0.31790958E-06_JPRB, &
  & 0.31790617E-06_JPRB, 0.31790330E-06_JPRB, 0.31790060E-06_JPRB, 0.31789813E-06_JPRB, 0.31789534E-06_JPRB, 0.31789222E-06_JPRB, &
  & 0.31788841E-06_JPRB, 0.31788352E-06_JPRB, 0.31787800E-06_JPRB, 0.31787232E-06_JPRB, 0.31786686E-06_JPRB, 0.31786163E-06_JPRB, &
  & 0.31785646E-06_JPRB, 0.31785120E-06_JPRB, 0.31784322E-06_JPRB, 0.31782565E-06_JPRB /)

RGHG3(:,70, 7) = (/ &
  & 0.31776653E-06_JPRB, 0.31778470E-06_JPRB, 0.31779334E-06_JPRB, 0.31779999E-06_JPRB, 0.31780559E-06_JPRB, 0.31781053E-06_JPRB, &
  & 0.31781502E-06_JPRB, 0.31781988E-06_JPRB, 0.31782494E-06_JPRB, 0.31783040E-06_JPRB, 0.31783622E-06_JPRB, 0.31784245E-06_JPRB, &
  & 0.31784865E-06_JPRB, 0.31785444E-06_JPRB, 0.31785984E-06_JPRB, 0.31786283E-06_JPRB, 0.31786385E-06_JPRB, 0.31786149E-06_JPRB, &
  & 0.31785686E-06_JPRB, 0.31785149E-06_JPRB, 0.31784654E-06_JPRB, 0.31784458E-06_JPRB, 0.31784762E-06_JPRB, 0.31785618E-06_JPRB, &
  & 0.31786902E-06_JPRB, 0.31788417E-06_JPRB, 0.31790012E-06_JPRB, 0.31791549E-06_JPRB, 0.31793019E-06_JPRB, 0.31794391E-06_JPRB, &
  & 0.31795599E-06_JPRB, 0.31796623E-06_JPRB, 0.31797421E-06_JPRB, 0.31797958E-06_JPRB, 0.31798217E-06_JPRB, 0.31798265E-06_JPRB, &
  & 0.31798126E-06_JPRB, 0.31797808E-06_JPRB, 0.31797353E-06_JPRB, 0.31796731E-06_JPRB, 0.31796034E-06_JPRB, 0.31795309E-06_JPRB, &
  & 0.31794653E-06_JPRB, 0.31794031E-06_JPRB, 0.31793471E-06_JPRB, 0.31792970E-06_JPRB, 0.31792541E-06_JPRB, 0.31792214E-06_JPRB, &
  & 0.31791933E-06_JPRB, 0.31791674E-06_JPRB, 0.31791441E-06_JPRB, 0.31791220E-06_JPRB, 0.31790972E-06_JPRB, 0.31790691E-06_JPRB, &
  & 0.31790344E-06_JPRB, 0.31789889E-06_JPRB, 0.31789361E-06_JPRB, 0.31788829E-06_JPRB, 0.31788329E-06_JPRB, 0.31787837E-06_JPRB, &
  & 0.31787349E-06_JPRB, 0.31786863E-06_JPRB, 0.31786118E-06_JPRB, 0.31784469E-06_JPRB /)

RGHG3(:,71, 7) = (/ &
  & 0.31778058E-06_JPRB, 0.31780277E-06_JPRB, 0.31781315E-06_JPRB, 0.31782051E-06_JPRB, 0.31782642E-06_JPRB, 0.31783165E-06_JPRB, &
  & 0.31783628E-06_JPRB, 0.31784117E-06_JPRB, 0.31784634E-06_JPRB, 0.31785112E-06_JPRB, 0.31785692E-06_JPRB, 0.31786249E-06_JPRB, &
  & 0.31786831E-06_JPRB, 0.31787360E-06_JPRB, 0.31787866E-06_JPRB, 0.31788113E-06_JPRB, 0.31788227E-06_JPRB, 0.31788005E-06_JPRB, &
  & 0.31787602E-06_JPRB, 0.31787135E-06_JPRB, 0.31786672E-06_JPRB, 0.31786459E-06_JPRB, 0.31786684E-06_JPRB, 0.31787411E-06_JPRB, &
  & 0.31788520E-06_JPRB, 0.31789864E-06_JPRB, 0.31791276E-06_JPRB, 0.31792652E-06_JPRB, 0.31793957E-06_JPRB, 0.31795167E-06_JPRB, &
  & 0.31796242E-06_JPRB, 0.31797140E-06_JPRB, 0.31797839E-06_JPRB, 0.31798308E-06_JPRB, 0.31798524E-06_JPRB, 0.31798567E-06_JPRB, &
  & 0.31798433E-06_JPRB, 0.31798160E-06_JPRB, 0.31797785E-06_JPRB, 0.31797254E-06_JPRB, 0.31796651E-06_JPRB, 0.31796034E-06_JPRB, &
  & 0.31795472E-06_JPRB, 0.31794946E-06_JPRB, 0.31794460E-06_JPRB, 0.31794031E-06_JPRB, 0.31793661E-06_JPRB, 0.31793388E-06_JPRB, &
  & 0.31793158E-06_JPRB, 0.31792942E-06_JPRB, 0.31792746E-06_JPRB, 0.31792550E-06_JPRB, 0.31792342E-06_JPRB, 0.31792101E-06_JPRB, &
  & 0.31791799E-06_JPRB, 0.31791379E-06_JPRB, 0.31790893E-06_JPRB, 0.31790404E-06_JPRB, 0.31789955E-06_JPRB, 0.31789506E-06_JPRB, &
  & 0.31789074E-06_JPRB, 0.31788625E-06_JPRB, 0.31787971E-06_JPRB, 0.31786493E-06_JPRB /)

RGHG3(:,72, 7) = (/ &
  & 0.31779561E-06_JPRB, 0.31782272E-06_JPRB, 0.31783415E-06_JPRB, 0.31784191E-06_JPRB, 0.31784836E-06_JPRB, 0.31785339E-06_JPRB, &
  & 0.31785808E-06_JPRB, 0.31786305E-06_JPRB, 0.31786743E-06_JPRB, 0.31787243E-06_JPRB, 0.31787698E-06_JPRB, 0.31788244E-06_JPRB, &
  & 0.31788736E-06_JPRB, 0.31789213E-06_JPRB, 0.31789688E-06_JPRB, 0.31789881E-06_JPRB, 0.31790012E-06_JPRB, 0.31789779E-06_JPRB, &
  & 0.31789435E-06_JPRB, 0.31789006E-06_JPRB, 0.31788593E-06_JPRB, 0.31788394E-06_JPRB, 0.31788562E-06_JPRB, 0.31789165E-06_JPRB, &
  & 0.31790094E-06_JPRB, 0.31791262E-06_JPRB, 0.31792504E-06_JPRB, 0.31793704E-06_JPRB, 0.31794843E-06_JPRB, 0.31795889E-06_JPRB, &
  & 0.31796836E-06_JPRB, 0.31797617E-06_JPRB, 0.31798226E-06_JPRB, 0.31798629E-06_JPRB, 0.31798800E-06_JPRB, 0.31798831E-06_JPRB, &
  & 0.31798709E-06_JPRB, 0.31798481E-06_JPRB, 0.31798172E-06_JPRB, 0.31797717E-06_JPRB, 0.31797208E-06_JPRB, 0.31796671E-06_JPRB, &
  & 0.31796233E-06_JPRB, 0.31795781E-06_JPRB, 0.31795372E-06_JPRB, 0.31795000E-06_JPRB, 0.31794687E-06_JPRB, 0.31794482E-06_JPRB, &
  & 0.31794306E-06_JPRB, 0.31794121E-06_JPRB, 0.31793957E-06_JPRB, 0.31793789E-06_JPRB, 0.31793610E-06_JPRB, 0.31793419E-06_JPRB, &
  & 0.31793164E-06_JPRB, 0.31792797E-06_JPRB, 0.31792359E-06_JPRB, 0.31791927E-06_JPRB, 0.31791538E-06_JPRB, 0.31791151E-06_JPRB, &
  & 0.31790762E-06_JPRB, 0.31790356E-06_JPRB, 0.31789776E-06_JPRB, 0.31788477E-06_JPRB /)

RGHG3(:,73, 7) = (/ &
  & 0.31781661E-06_JPRB, 0.31784526E-06_JPRB, 0.31785663E-06_JPRB, 0.31786456E-06_JPRB, 0.31787064E-06_JPRB, 0.31787582E-06_JPRB, &
  & 0.31788031E-06_JPRB, 0.31788466E-06_JPRB, 0.31788932E-06_JPRB, 0.31789276E-06_JPRB, 0.31789784E-06_JPRB, 0.31790177E-06_JPRB, &
  & 0.31790626E-06_JPRB, 0.31791012E-06_JPRB, 0.31791444E-06_JPRB, 0.31791552E-06_JPRB, 0.31791745E-06_JPRB, 0.31791453E-06_JPRB, &
  & 0.31791186E-06_JPRB, 0.31790839E-06_JPRB, 0.31790466E-06_JPRB, 0.31790273E-06_JPRB, 0.31790375E-06_JPRB, 0.31790861E-06_JPRB, &
  & 0.31791626E-06_JPRB, 0.31792629E-06_JPRB, 0.31793684E-06_JPRB, 0.31794710E-06_JPRB, 0.31795679E-06_JPRB, 0.31796577E-06_JPRB, &
  & 0.31797396E-06_JPRB, 0.31798055E-06_JPRB, 0.31798578E-06_JPRB, 0.31798919E-06_JPRB, 0.31799044E-06_JPRB, 0.31799053E-06_JPRB, &
  & 0.31798950E-06_JPRB, 0.31798763E-06_JPRB, 0.31798527E-06_JPRB, 0.31798152E-06_JPRB, 0.31797720E-06_JPRB, 0.31797265E-06_JPRB, &
  & 0.31796912E-06_JPRB, 0.31796540E-06_JPRB, 0.31796205E-06_JPRB, 0.31795884E-06_JPRB, 0.31795619E-06_JPRB, 0.31795474E-06_JPRB, &
  & 0.31795349E-06_JPRB, 0.31795193E-06_JPRB, 0.31795071E-06_JPRB, 0.31794931E-06_JPRB, 0.31794775E-06_JPRB, 0.31794642E-06_JPRB, &
  & 0.31794431E-06_JPRB, 0.31794124E-06_JPRB, 0.31793735E-06_JPRB, 0.31793365E-06_JPRB, 0.31793041E-06_JPRB, 0.31792715E-06_JPRB, &
  & 0.31792374E-06_JPRB, 0.31792015E-06_JPRB, 0.31791512E-06_JPRB, 0.31790370E-06_JPRB /)

RGHG3(:,74, 7) = (/ &
  & 0.31783986E-06_JPRB, 0.31786917E-06_JPRB, 0.31787999E-06_JPRB, 0.31788719E-06_JPRB, 0.31789330E-06_JPRB, 0.31789790E-06_JPRB, &
  & 0.31790194E-06_JPRB, 0.31790637E-06_JPRB, 0.31790972E-06_JPRB, 0.31791365E-06_JPRB, 0.31791683E-06_JPRB, 0.31792106E-06_JPRB, &
  & 0.31792416E-06_JPRB, 0.31792729E-06_JPRB, 0.31793132E-06_JPRB, 0.31793135E-06_JPRB, 0.31793343E-06_JPRB, 0.31793058E-06_JPRB, &
  & 0.31792834E-06_JPRB, 0.31792541E-06_JPRB, 0.31792217E-06_JPRB, 0.31792047E-06_JPRB, 0.31792101E-06_JPRB, 0.31792479E-06_JPRB, &
  & 0.31793095E-06_JPRB, 0.31793940E-06_JPRB, 0.31794806E-06_JPRB, 0.31795670E-06_JPRB, 0.31796469E-06_JPRB, 0.31797211E-06_JPRB, &
  & 0.31797893E-06_JPRB, 0.31798467E-06_JPRB, 0.31798902E-06_JPRB, 0.31799181E-06_JPRB, 0.31799254E-06_JPRB, 0.31799254E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799021E-06_JPRB, 0.31798857E-06_JPRB, 0.31798550E-06_JPRB, 0.31798186E-06_JPRB, 0.31797794E-06_JPRB, &
  & 0.31797535E-06_JPRB, 0.31797225E-06_JPRB, 0.31796952E-06_JPRB, 0.31796685E-06_JPRB, 0.31796461E-06_JPRB, 0.31796384E-06_JPRB, &
  & 0.31796301E-06_JPRB, 0.31796174E-06_JPRB, 0.31796083E-06_JPRB, 0.31795963E-06_JPRB, 0.31795838E-06_JPRB, 0.31795750E-06_JPRB, &
  & 0.31795591E-06_JPRB, 0.31795335E-06_JPRB, 0.31795003E-06_JPRB, 0.31794696E-06_JPRB, 0.31794437E-06_JPRB, 0.31794156E-06_JPRB, &
  & 0.31793869E-06_JPRB, 0.31793559E-06_JPRB, 0.31793127E-06_JPRB, 0.31792106E-06_JPRB /)

RGHG3(:,75, 7) = (/ &
  & 0.31786465E-06_JPRB, 0.31789361E-06_JPRB, 0.31790287E-06_JPRB, 0.31790947E-06_JPRB, 0.31791487E-06_JPRB, 0.31791910E-06_JPRB, &
  & 0.31792268E-06_JPRB, 0.31792621E-06_JPRB, 0.31792979E-06_JPRB, 0.31793198E-06_JPRB, 0.31793596E-06_JPRB, 0.31793843E-06_JPRB, &
  & 0.31794116E-06_JPRB, 0.31794301E-06_JPRB, 0.31794667E-06_JPRB, 0.31794650E-06_JPRB, 0.31794804E-06_JPRB, 0.31794553E-06_JPRB, &
  & 0.31794363E-06_JPRB, 0.31794156E-06_JPRB, 0.31793874E-06_JPRB, 0.31793732E-06_JPRB, 0.31793735E-06_JPRB, 0.31794028E-06_JPRB, &
  & 0.31794502E-06_JPRB, 0.31795201E-06_JPRB, 0.31795884E-06_JPRB, 0.31796569E-06_JPRB, 0.31797214E-06_JPRB, 0.31797802E-06_JPRB, &
  & 0.31798376E-06_JPRB, 0.31798845E-06_JPRB, 0.31799195E-06_JPRB, 0.31799419E-06_JPRB, 0.31799445E-06_JPRB, 0.31799439E-06_JPRB, &
  & 0.31799348E-06_JPRB, 0.31799243E-06_JPRB, 0.31799141E-06_JPRB, 0.31798899E-06_JPRB, 0.31798618E-06_JPRB, 0.31798277E-06_JPRB, &
  & 0.31798106E-06_JPRB, 0.31797848E-06_JPRB, 0.31797623E-06_JPRB, 0.31797407E-06_JPRB, 0.31797219E-06_JPRB, 0.31797202E-06_JPRB, &
  & 0.31797160E-06_JPRB, 0.31797052E-06_JPRB, 0.31797006E-06_JPRB, 0.31796895E-06_JPRB, 0.31796785E-06_JPRB, 0.31796748E-06_JPRB, &
  & 0.31796645E-06_JPRB, 0.31796441E-06_JPRB, 0.31796151E-06_JPRB, 0.31795901E-06_JPRB, 0.31795710E-06_JPRB, 0.31795480E-06_JPRB, &
  & 0.31795241E-06_JPRB, 0.31794985E-06_JPRB, 0.31794610E-06_JPRB, 0.31793718E-06_JPRB /)

RGHG3(:,76, 7) = (/ &
  & 0.31789074E-06_JPRB, 0.31791780E-06_JPRB, 0.31792504E-06_JPRB, 0.31793036E-06_JPRB, 0.31793530E-06_JPRB, 0.31793871E-06_JPRB, &
  & 0.31794150E-06_JPRB, 0.31794508E-06_JPRB, 0.31794738E-06_JPRB, 0.31794966E-06_JPRB, 0.31795210E-06_JPRB, 0.31795480E-06_JPRB, &
  & 0.31795639E-06_JPRB, 0.31795744E-06_JPRB, 0.31796017E-06_JPRB, 0.31796026E-06_JPRB, 0.31796145E-06_JPRB, 0.31795918E-06_JPRB, &
  & 0.31795781E-06_JPRB, 0.31795648E-06_JPRB, 0.31795412E-06_JPRB, 0.31795301E-06_JPRB, 0.31795258E-06_JPRB, 0.31795486E-06_JPRB, &
  & 0.31795827E-06_JPRB, 0.31796407E-06_JPRB, 0.31796904E-06_JPRB, 0.31797424E-06_JPRB, 0.31797904E-06_JPRB, 0.31798334E-06_JPRB, &
  & 0.31798814E-06_JPRB, 0.31799192E-06_JPRB, 0.31799470E-06_JPRB, 0.31799641E-06_JPRB, 0.31799613E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799513E-06_JPRB, 0.31799451E-06_JPRB, 0.31799411E-06_JPRB, 0.31799220E-06_JPRB, 0.31799001E-06_JPRB, 0.31798706E-06_JPRB, &
  & 0.31798621E-06_JPRB, 0.31798402E-06_JPRB, 0.31798234E-06_JPRB, 0.31798066E-06_JPRB, 0.31797904E-06_JPRB, 0.31797947E-06_JPRB, &
  & 0.31797933E-06_JPRB, 0.31797859E-06_JPRB, 0.31797853E-06_JPRB, 0.31797748E-06_JPRB, 0.31797637E-06_JPRB, 0.31797651E-06_JPRB, &
  & 0.31797600E-06_JPRB, 0.31797452E-06_JPRB, 0.31797202E-06_JPRB, 0.31796998E-06_JPRB, 0.31796881E-06_JPRB, 0.31796685E-06_JPRB, &
  & 0.31796500E-06_JPRB, 0.31796293E-06_JPRB, 0.31795997E-06_JPRB, 0.31795167E-06_JPRB /)

RGHG3(:,77, 7) = (/ &
  & 0.31791734E-06_JPRB, 0.31794136E-06_JPRB, 0.31794585E-06_JPRB, 0.31794980E-06_JPRB, 0.31795395E-06_JPRB, 0.31795665E-06_JPRB, &
  & 0.31795844E-06_JPRB, 0.31796139E-06_JPRB, 0.31796330E-06_JPRB, 0.31796412E-06_JPRB, 0.31796714E-06_JPRB, 0.31796861E-06_JPRB, &
  & 0.31796961E-06_JPRB, 0.31797003E-06_JPRB, 0.31797180E-06_JPRB, 0.31797231E-06_JPRB, 0.31797342E-06_JPRB, 0.31797111E-06_JPRB, &
  & 0.31797043E-06_JPRB, 0.31796998E-06_JPRB, 0.31796810E-06_JPRB, 0.31796739E-06_JPRB, 0.31796668E-06_JPRB, 0.31796839E-06_JPRB, &
  & 0.31797060E-06_JPRB, 0.31797532E-06_JPRB, 0.31797845E-06_JPRB, 0.31798217E-06_JPRB, 0.31798538E-06_JPRB, 0.31798825E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799516E-06_JPRB, 0.31799721E-06_JPRB, 0.31799846E-06_JPRB, 0.31799760E-06_JPRB, 0.31799729E-06_JPRB, &
  & 0.31799632E-06_JPRB, 0.31799613E-06_JPRB, 0.31799641E-06_JPRB, 0.31799516E-06_JPRB, 0.31799362E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31798899E-06_JPRB, 0.31798766E-06_JPRB, 0.31798638E-06_JPRB, 0.31798510E-06_JPRB, 0.31798621E-06_JPRB, &
  & 0.31798623E-06_JPRB, 0.31798578E-06_JPRB, 0.31798615E-06_JPRB, 0.31798501E-06_JPRB, 0.31798371E-06_JPRB, 0.31798430E-06_JPRB, &
  & 0.31798442E-06_JPRB, 0.31798356E-06_JPRB, 0.31798129E-06_JPRB, 0.31797981E-06_JPRB, 0.31797944E-06_JPRB, 0.31797785E-06_JPRB, &
  & 0.31797646E-06_JPRB, 0.31797495E-06_JPRB, 0.31797262E-06_JPRB, 0.31796529E-06_JPRB /)

RGHG3(:,78, 7) = (/ &
  & 0.31794420E-06_JPRB, 0.31796296E-06_JPRB, 0.31796395E-06_JPRB, 0.31796651E-06_JPRB, 0.31796998E-06_JPRB, 0.31797174E-06_JPRB, &
  & 0.31797239E-06_JPRB, 0.31797515E-06_JPRB, 0.31797609E-06_JPRB, 0.31797603E-06_JPRB, 0.31797867E-06_JPRB, 0.31798001E-06_JPRB, &
  & 0.31798035E-06_JPRB, 0.31798024E-06_JPRB, 0.31798120E-06_JPRB, 0.31798209E-06_JPRB, 0.31798328E-06_JPRB, 0.31798095E-06_JPRB, &
  & 0.31798083E-06_JPRB, 0.31798132E-06_JPRB, 0.31797973E-06_JPRB, 0.31797953E-06_JPRB, 0.31797856E-06_JPRB, 0.31797998E-06_JPRB, &
  & 0.31798118E-06_JPRB, 0.31798515E-06_JPRB, 0.31798675E-06_JPRB, 0.31798905E-06_JPRB, 0.31799087E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799803E-06_JPRB, 0.31799939E-06_JPRB, 0.31800019E-06_JPRB, 0.31799883E-06_JPRB, 0.31799848E-06_JPRB, &
  & 0.31799749E-06_JPRB, 0.31799769E-06_JPRB, 0.31799848E-06_JPRB, 0.31799763E-06_JPRB, 0.31799652E-06_JPRB, 0.31799405E-06_JPRB, &
  & 0.31799490E-06_JPRB, 0.31799317E-06_JPRB, 0.31799212E-06_JPRB, 0.31799121E-06_JPRB, 0.31799016E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799189E-06_JPRB, 0.31799166E-06_JPRB, 0.31799257E-06_JPRB, 0.31799124E-06_JPRB, 0.31798970E-06_JPRB, 0.31799073E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31799107E-06_JPRB, 0.31798885E-06_JPRB, 0.31798780E-06_JPRB, 0.31798842E-06_JPRB, 0.31798692E-06_JPRB, &
  & 0.31798618E-06_JPRB, 0.31798510E-06_JPRB, 0.31798376E-06_JPRB, 0.31797779E-06_JPRB /)

RGHG3(:,79, 7) = (/ &
  & 0.31796208E-06_JPRB, 0.31797558E-06_JPRB, 0.31797356E-06_JPRB, 0.31797504E-06_JPRB, 0.31797833E-06_JPRB, 0.31797970E-06_JPRB, &
  & 0.31797950E-06_JPRB, 0.31798243E-06_JPRB, 0.31798280E-06_JPRB, 0.31798191E-06_JPRB, 0.31798501E-06_JPRB, 0.31798601E-06_JPRB, &
  & 0.31798598E-06_JPRB, 0.31798555E-06_JPRB, 0.31798604E-06_JPRB, 0.31798723E-06_JPRB, 0.31798851E-06_JPRB, 0.31798598E-06_JPRB, &
  & 0.31798632E-06_JPRB, 0.31798746E-06_JPRB, 0.31798598E-06_JPRB, 0.31798612E-06_JPRB, 0.31798481E-06_JPRB, 0.31798629E-06_JPRB, &
  & 0.31798692E-06_JPRB, 0.31799067E-06_JPRB, 0.31799129E-06_JPRB, 0.31799283E-06_JPRB, 0.31799388E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799746E-06_JPRB, 0.31799982E-06_JPRB, 0.31800087E-06_JPRB, 0.31800138E-06_JPRB, 0.31799951E-06_JPRB, 0.31799917E-06_JPRB, &
  & 0.31799806E-06_JPRB, 0.31799854E-06_JPRB, 0.31799971E-06_JPRB, 0.31799917E-06_JPRB, 0.31799834E-06_JPRB, 0.31799581E-06_JPRB, &
  & 0.31799721E-06_JPRB, 0.31799541E-06_JPRB, 0.31799445E-06_JPRB, 0.31799368E-06_JPRB, 0.31799266E-06_JPRB, 0.31799485E-06_JPRB, &
  & 0.31799493E-06_JPRB, 0.31799485E-06_JPRB, 0.31799607E-06_JPRB, 0.31799459E-06_JPRB, 0.31799274E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799505E-06_JPRB, 0.31799516E-06_JPRB, 0.31799283E-06_JPRB, 0.31799200E-06_JPRB, 0.31799340E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31799055E-06_JPRB, 0.31799004E-06_JPRB, 0.31798592E-06_JPRB /)

RGHG3(:,80, 7) = (/ &
  & 0.31797438E-06_JPRB, 0.31798203E-06_JPRB, 0.31797768E-06_JPRB, 0.31797867E-06_JPRB, 0.31798197E-06_JPRB, 0.31798317E-06_JPRB, &
  & 0.31798265E-06_JPRB, 0.31798544E-06_JPRB, 0.31798558E-06_JPRB, 0.31798447E-06_JPRB, 0.31798803E-06_JPRB, 0.31798876E-06_JPRB, &
  & 0.31798857E-06_JPRB, 0.31798785E-06_JPRB, 0.31798805E-06_JPRB, 0.31798950E-06_JPRB, 0.31799095E-06_JPRB, 0.31798814E-06_JPRB, &
  & 0.31798874E-06_JPRB, 0.31799036E-06_JPRB, 0.31798885E-06_JPRB, 0.31798919E-06_JPRB, 0.31798766E-06_JPRB, 0.31798922E-06_JPRB, &
  & 0.31798962E-06_JPRB, 0.31799337E-06_JPRB, 0.31799354E-06_JPRB, 0.31799470E-06_JPRB, 0.31799527E-06_JPRB, 0.31799561E-06_JPRB, &
  & 0.31799851E-06_JPRB, 0.31800084E-06_JPRB, 0.31800175E-06_JPRB, 0.31800209E-06_JPRB, 0.31799993E-06_JPRB, 0.31799948E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31799894E-06_JPRB, 0.31800042E-06_JPRB, 0.31799996E-06_JPRB, 0.31799919E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799641E-06_JPRB, 0.31799544E-06_JPRB, 0.31799476E-06_JPRB, 0.31799371E-06_JPRB, 0.31799630E-06_JPRB, &
  & 0.31799644E-06_JPRB, 0.31799632E-06_JPRB, 0.31799786E-06_JPRB, 0.31799621E-06_JPRB, 0.31799408E-06_JPRB, 0.31799570E-06_JPRB, &
  & 0.31799684E-06_JPRB, 0.31799721E-06_JPRB, 0.31799459E-06_JPRB, 0.31799382E-06_JPRB, 0.31799578E-06_JPRB, 0.31799385E-06_JPRB, &
  & 0.31799360E-06_JPRB, 0.31799303E-06_JPRB, 0.31799334E-06_JPRB, 0.31799149E-06_JPRB /)

RGHG3(:,81, 7) = (/ &
  & 0.31798325E-06_JPRB, 0.31798487E-06_JPRB, 0.31797936E-06_JPRB, 0.31798007E-06_JPRB, 0.31798339E-06_JPRB, 0.31798453E-06_JPRB, &
  & 0.31798376E-06_JPRB, 0.31798717E-06_JPRB, 0.31798720E-06_JPRB, 0.31798604E-06_JPRB, 0.31798868E-06_JPRB, 0.31798993E-06_JPRB, &
  & 0.31798970E-06_JPRB, 0.31798891E-06_JPRB, 0.31798896E-06_JPRB, 0.31799047E-06_JPRB, 0.31799203E-06_JPRB, 0.31798902E-06_JPRB, &
  & 0.31798982E-06_JPRB, 0.31799178E-06_JPRB, 0.31799016E-06_JPRB, 0.31799067E-06_JPRB, 0.31798885E-06_JPRB, 0.31799055E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31799470E-06_JPRB, 0.31799451E-06_JPRB, 0.31799556E-06_JPRB, 0.31799595E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799902E-06_JPRB, 0.31800138E-06_JPRB, 0.31800226E-06_JPRB, 0.31800258E-06_JPRB, 0.31800013E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31799917E-06_JPRB, 0.31800073E-06_JPRB, 0.31800036E-06_JPRB, 0.31799956E-06_JPRB, 0.31799701E-06_JPRB, &
  & 0.31799874E-06_JPRB, 0.31799686E-06_JPRB, 0.31799587E-06_JPRB, 0.31799516E-06_JPRB, 0.31799411E-06_JPRB, 0.31799701E-06_JPRB, &
  & 0.31799712E-06_JPRB, 0.31799695E-06_JPRB, 0.31799868E-06_JPRB, 0.31799698E-06_JPRB, 0.31799470E-06_JPRB, 0.31799647E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799823E-06_JPRB, 0.31799544E-06_JPRB, 0.31799462E-06_JPRB, 0.31799684E-06_JPRB, 0.31799479E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799411E-06_JPRB, 0.31799479E-06_JPRB, 0.31799553E-06_JPRB /)

RGHG3(:,82, 7) = (/ &
  & 0.31798402E-06_JPRB, 0.31798592E-06_JPRB, 0.31798004E-06_JPRB, 0.31798075E-06_JPRB, 0.31798419E-06_JPRB, 0.31798538E-06_JPRB, &
  & 0.31798487E-06_JPRB, 0.31798726E-06_JPRB, 0.31798726E-06_JPRB, 0.31798641E-06_JPRB, 0.31798996E-06_JPRB, 0.31799053E-06_JPRB, &
  & 0.31799021E-06_JPRB, 0.31798939E-06_JPRB, 0.31798936E-06_JPRB, 0.31799095E-06_JPRB, 0.31799260E-06_JPRB, 0.31798945E-06_JPRB, &
  & 0.31799038E-06_JPRB, 0.31799263E-06_JPRB, 0.31799078E-06_JPRB, 0.31799146E-06_JPRB, 0.31798939E-06_JPRB, 0.31799129E-06_JPRB, &
  & 0.31799135E-06_JPRB, 0.31799556E-06_JPRB, 0.31799510E-06_JPRB, 0.31799598E-06_JPRB, 0.31799624E-06_JPRB, 0.31799630E-06_JPRB, &
  & 0.31799925E-06_JPRB, 0.31800170E-06_JPRB, 0.31800255E-06_JPRB, 0.31800280E-06_JPRB, 0.31800028E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31799937E-06_JPRB, 0.31800096E-06_JPRB, 0.31800059E-06_JPRB, 0.31799985E-06_JPRB, 0.31799726E-06_JPRB, &
  & 0.31799902E-06_JPRB, 0.31799715E-06_JPRB, 0.31799610E-06_JPRB, 0.31799533E-06_JPRB, 0.31799425E-06_JPRB, 0.31799735E-06_JPRB, &
  & 0.31799746E-06_JPRB, 0.31799732E-06_JPRB, 0.31799922E-06_JPRB, 0.31799743E-06_JPRB, 0.31799490E-06_JPRB, 0.31799684E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799874E-06_JPRB, 0.31799581E-06_JPRB, 0.31799502E-06_JPRB, 0.31799743E-06_JPRB, 0.31799527E-06_JPRB, &
  & 0.31799507E-06_JPRB, 0.31799459E-06_JPRB, 0.31799533E-06_JPRB, 0.31799587E-06_JPRB /)

RGHG3(:,83, 7) = (/ &
  & 0.31798459E-06_JPRB, 0.31798660E-06_JPRB, 0.31798038E-06_JPRB, 0.31798109E-06_JPRB, 0.31798453E-06_JPRB, 0.31798558E-06_JPRB, &
  & 0.31798479E-06_JPRB, 0.31798814E-06_JPRB, 0.31798817E-06_JPRB, 0.31798743E-06_JPRB, 0.31798930E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31799055E-06_JPRB, 0.31798967E-06_JPRB, 0.31798965E-06_JPRB, 0.31799118E-06_JPRB, 0.31799286E-06_JPRB, 0.31798962E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31799320E-06_JPRB, 0.31799124E-06_JPRB, 0.31799198E-06_JPRB, 0.31798970E-06_JPRB, 0.31799178E-06_JPRB, &
  & 0.31799169E-06_JPRB, 0.31799604E-06_JPRB, 0.31799547E-06_JPRB, 0.31799630E-06_JPRB, 0.31799644E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799939E-06_JPRB, 0.31800192E-06_JPRB, 0.31800286E-06_JPRB, 0.31800303E-06_JPRB, 0.31800030E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799939E-06_JPRB, 0.31800113E-06_JPRB, 0.31800073E-06_JPRB, 0.31799996E-06_JPRB, 0.31799746E-06_JPRB, &
  & 0.31799911E-06_JPRB, 0.31799723E-06_JPRB, 0.31799615E-06_JPRB, 0.31799550E-06_JPRB, 0.31799439E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799755E-06_JPRB, 0.31799951E-06_JPRB, 0.31799772E-06_JPRB, 0.31799507E-06_JPRB, 0.31799715E-06_JPRB, &
  & 0.31799848E-06_JPRB, 0.31799911E-06_JPRB, 0.31799601E-06_JPRB, 0.31799522E-06_JPRB, 0.31799783E-06_JPRB, 0.31799556E-06_JPRB, &
  & 0.31799536E-06_JPRB, 0.31799482E-06_JPRB, 0.31799564E-06_JPRB, 0.31799615E-06_JPRB /)

RGHG3(:,84, 7) = (/ &
  & 0.31798493E-06_JPRB, 0.31798703E-06_JPRB, 0.31798064E-06_JPRB, 0.31798132E-06_JPRB, 0.31798484E-06_JPRB, 0.31798601E-06_JPRB, &
  & 0.31798572E-06_JPRB, 0.31798763E-06_JPRB, 0.31798783E-06_JPRB, 0.31798737E-06_JPRB, 0.31799038E-06_JPRB, 0.31799090E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31798984E-06_JPRB, 0.31798979E-06_JPRB, 0.31799135E-06_JPRB, 0.31799291E-06_JPRB, 0.31798976E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31799345E-06_JPRB, 0.31799141E-06_JPRB, 0.31799229E-06_JPRB, 0.31798982E-06_JPRB, 0.31799215E-06_JPRB, &
  & 0.31799178E-06_JPRB, 0.31799649E-06_JPRB, 0.31799570E-06_JPRB, 0.31799641E-06_JPRB, 0.31799652E-06_JPRB, 0.31799647E-06_JPRB, &
  & 0.31799951E-06_JPRB, 0.31800209E-06_JPRB, 0.31800295E-06_JPRB, 0.31800317E-06_JPRB, 0.31800039E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799948E-06_JPRB, 0.31800118E-06_JPRB, 0.31800087E-06_JPRB, 0.31800002E-06_JPRB, 0.31799749E-06_JPRB, &
  & 0.31799917E-06_JPRB, 0.31799732E-06_JPRB, 0.31799630E-06_JPRB, 0.31799556E-06_JPRB, 0.31799453E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799772E-06_JPRB, 0.31799976E-06_JPRB, 0.31799794E-06_JPRB, 0.31799516E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31799868E-06_JPRB, 0.31799937E-06_JPRB, 0.31799624E-06_JPRB, 0.31799544E-06_JPRB, 0.31799811E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799505E-06_JPRB, 0.31799590E-06_JPRB, 0.31799638E-06_JPRB /)

RGHG3(:,85, 7) = (/ &
  & 0.31798518E-06_JPRB, 0.31798740E-06_JPRB, 0.31798072E-06_JPRB, 0.31798143E-06_JPRB, 0.31798501E-06_JPRB, 0.31798595E-06_JPRB, &
  & 0.31798538E-06_JPRB, 0.31798842E-06_JPRB, 0.31798845E-06_JPRB, 0.31798834E-06_JPRB, 0.31798962E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31799004E-06_JPRB, 0.31799004E-06_JPRB, 0.31799135E-06_JPRB, 0.31799271E-06_JPRB, 0.31798996E-06_JPRB, &
  & 0.31799107E-06_JPRB, 0.31799368E-06_JPRB, 0.31799158E-06_JPRB, 0.31799260E-06_JPRB, 0.31798993E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799195E-06_JPRB, 0.31799675E-06_JPRB, 0.31799578E-06_JPRB, 0.31799649E-06_JPRB, 0.31799652E-06_JPRB, 0.31799649E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31800218E-06_JPRB, 0.31800312E-06_JPRB, 0.31800334E-06_JPRB, 0.31800045E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799959E-06_JPRB, 0.31800127E-06_JPRB, 0.31800093E-06_JPRB, 0.31800013E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799925E-06_JPRB, 0.31799746E-06_JPRB, 0.31799624E-06_JPRB, 0.31799559E-06_JPRB, 0.31799462E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799777E-06_JPRB, 0.31799777E-06_JPRB, 0.31799988E-06_JPRB, 0.31799809E-06_JPRB, 0.31799527E-06_JPRB, 0.31799738E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31799962E-06_JPRB, 0.31799632E-06_JPRB, 0.31799553E-06_JPRB, 0.31799829E-06_JPRB, 0.31799593E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799522E-06_JPRB, 0.31799601E-06_JPRB, 0.31799652E-06_JPRB /)

RGHG3(:,86, 7) = (/ &
  & 0.31798535E-06_JPRB, 0.31798749E-06_JPRB, 0.31798069E-06_JPRB, 0.31798149E-06_JPRB, 0.31798527E-06_JPRB, 0.31798629E-06_JPRB, &
  & 0.31798643E-06_JPRB, 0.31798771E-06_JPRB, 0.31798825E-06_JPRB, 0.31798822E-06_JPRB, 0.31799007E-06_JPRB, 0.31799055E-06_JPRB, &
  & 0.31799055E-06_JPRB, 0.31799024E-06_JPRB, 0.31799033E-06_JPRB, 0.31799127E-06_JPRB, 0.31799232E-06_JPRB, 0.31799030E-06_JPRB, &
  & 0.31799127E-06_JPRB, 0.31799374E-06_JPRB, 0.31799178E-06_JPRB, 0.31799280E-06_JPRB, 0.31799001E-06_JPRB, 0.31799254E-06_JPRB, &
  & 0.31799192E-06_JPRB, 0.31799709E-06_JPRB, 0.31799593E-06_JPRB, 0.31799664E-06_JPRB, 0.31799652E-06_JPRB, 0.31799647E-06_JPRB, &
  & 0.31799971E-06_JPRB, 0.31800232E-06_JPRB, 0.31800329E-06_JPRB, 0.31800346E-06_JPRB, 0.31800047E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31799959E-06_JPRB, 0.31800136E-06_JPRB, 0.31800101E-06_JPRB, 0.31800016E-06_JPRB, 0.31799755E-06_JPRB, &
  & 0.31799939E-06_JPRB, 0.31799749E-06_JPRB, 0.31799635E-06_JPRB, 0.31799561E-06_JPRB, 0.31799482E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799786E-06_JPRB, 0.31799982E-06_JPRB, 0.31799820E-06_JPRB, 0.31799533E-06_JPRB, 0.31799740E-06_JPRB, &
  & 0.31799905E-06_JPRB, 0.31799976E-06_JPRB, 0.31799641E-06_JPRB, 0.31799564E-06_JPRB, 0.31799843E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799527E-06_JPRB, 0.31799621E-06_JPRB, 0.31799664E-06_JPRB /)

RGHG3(:,87, 7) = (/ &
  & 0.31798547E-06_JPRB, 0.31798746E-06_JPRB, 0.31798075E-06_JPRB, 0.31798169E-06_JPRB, 0.31798498E-06_JPRB, 0.31798623E-06_JPRB, &
  & 0.31798604E-06_JPRB, 0.31798857E-06_JPRB, 0.31798871E-06_JPRB, 0.31798891E-06_JPRB, 0.31798979E-06_JPRB, 0.31799041E-06_JPRB, &
  & 0.31799047E-06_JPRB, 0.31799027E-06_JPRB, 0.31799038E-06_JPRB, 0.31799118E-06_JPRB, 0.31799203E-06_JPRB, 0.31799053E-06_JPRB, &
  & 0.31799132E-06_JPRB, 0.31799371E-06_JPRB, 0.31799189E-06_JPRB, 0.31799289E-06_JPRB, 0.31799010E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799200E-06_JPRB, 0.31799721E-06_JPRB, 0.31799584E-06_JPRB, 0.31799667E-06_JPRB, 0.31799652E-06_JPRB, 0.31799638E-06_JPRB, &
  & 0.31799976E-06_JPRB, 0.31800249E-06_JPRB, 0.31800340E-06_JPRB, 0.31800363E-06_JPRB, 0.31800047E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31799954E-06_JPRB, 0.31800147E-06_JPRB, 0.31800116E-06_JPRB, 0.31800033E-06_JPRB, 0.31799743E-06_JPRB, &
  & 0.31799956E-06_JPRB, 0.31799755E-06_JPRB, 0.31799635E-06_JPRB, 0.31799567E-06_JPRB, 0.31799499E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799786E-06_JPRB, 0.31799800E-06_JPRB, 0.31799979E-06_JPRB, 0.31799823E-06_JPRB, 0.31799550E-06_JPRB, 0.31799752E-06_JPRB, &
  & 0.31799919E-06_JPRB, 0.31799996E-06_JPRB, 0.31799655E-06_JPRB, 0.31799570E-06_JPRB, 0.31799851E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799581E-06_JPRB, 0.31799539E-06_JPRB, 0.31799627E-06_JPRB, 0.31799675E-06_JPRB /)

RGHG3(:,88, 7) = (/ &
  & 0.31798552E-06_JPRB, 0.31798723E-06_JPRB, 0.31798106E-06_JPRB, 0.31798160E-06_JPRB, 0.31798544E-06_JPRB, 0.31798638E-06_JPRB, &
  & 0.31798692E-06_JPRB, 0.31798797E-06_JPRB, 0.31798857E-06_JPRB, 0.31798868E-06_JPRB, 0.31799001E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31799050E-06_JPRB, 0.31799033E-06_JPRB, 0.31799038E-06_JPRB, 0.31799107E-06_JPRB, 0.31799183E-06_JPRB, 0.31799055E-06_JPRB, &
  & 0.31799146E-06_JPRB, 0.31799374E-06_JPRB, 0.31799183E-06_JPRB, 0.31799294E-06_JPRB, 0.31799021E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799192E-06_JPRB, 0.31799738E-06_JPRB, 0.31799590E-06_JPRB, 0.31799669E-06_JPRB, 0.31799644E-06_JPRB, 0.31799632E-06_JPRB, &
  & 0.31799976E-06_JPRB, 0.31800249E-06_JPRB, 0.31800349E-06_JPRB, 0.31800377E-06_JPRB, 0.31800053E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31799959E-06_JPRB, 0.31800167E-06_JPRB, 0.31800130E-06_JPRB, 0.31800050E-06_JPRB, 0.31799721E-06_JPRB, &
  & 0.31799979E-06_JPRB, 0.31799749E-06_JPRB, 0.31799635E-06_JPRB, 0.31799570E-06_JPRB, 0.31799507E-06_JPRB, 0.31799752E-06_JPRB, &
  & 0.31799780E-06_JPRB, 0.31799803E-06_JPRB, 0.31799968E-06_JPRB, 0.31799823E-06_JPRB, 0.31799561E-06_JPRB, 0.31799755E-06_JPRB, &
  & 0.31799922E-06_JPRB, 0.31800005E-06_JPRB, 0.31799652E-06_JPRB, 0.31799573E-06_JPRB, 0.31799863E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799541E-06_JPRB, 0.31799632E-06_JPRB, 0.31799684E-06_JPRB /)

RGHG3(:,89, 7) = (/ &
  & 0.31798555E-06_JPRB, 0.31798663E-06_JPRB, 0.31798140E-06_JPRB, 0.31798174E-06_JPRB, 0.31798504E-06_JPRB, 0.31798632E-06_JPRB, &
  & 0.31798621E-06_JPRB, 0.31798857E-06_JPRB, 0.31798874E-06_JPRB, 0.31798896E-06_JPRB, 0.31798990E-06_JPRB, 0.31799047E-06_JPRB, &
  & 0.31799050E-06_JPRB, 0.31799027E-06_JPRB, 0.31799030E-06_JPRB, 0.31799112E-06_JPRB, 0.31799198E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31799138E-06_JPRB, 0.31799388E-06_JPRB, 0.31799181E-06_JPRB, 0.31799303E-06_JPRB, 0.31799019E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799195E-06_JPRB, 0.31799755E-06_JPRB, 0.31799593E-06_JPRB, 0.31799678E-06_JPRB, 0.31799644E-06_JPRB, 0.31799627E-06_JPRB, &
  & 0.31799988E-06_JPRB, 0.31800261E-06_JPRB, 0.31800363E-06_JPRB, 0.31800391E-06_JPRB, 0.31800050E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31799809E-06_JPRB, 0.31799954E-06_JPRB, 0.31800181E-06_JPRB, 0.31800136E-06_JPRB, 0.31800064E-06_JPRB, 0.31799695E-06_JPRB, &
  & 0.31799999E-06_JPRB, 0.31799752E-06_JPRB, 0.31799635E-06_JPRB, 0.31799573E-06_JPRB, 0.31799510E-06_JPRB, 0.31799749E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799809E-06_JPRB, 0.31799965E-06_JPRB, 0.31799826E-06_JPRB, 0.31799570E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799931E-06_JPRB, 0.31800016E-06_JPRB, 0.31799661E-06_JPRB, 0.31799576E-06_JPRB, 0.31799868E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799547E-06_JPRB, 0.31799630E-06_JPRB, 0.31799689E-06_JPRB /)

RGHG3(:,90, 7) = (/ &
  & 0.31798544E-06_JPRB, 0.31798595E-06_JPRB, 0.31798169E-06_JPRB, 0.31798157E-06_JPRB, 0.31798527E-06_JPRB, 0.31798635E-06_JPRB, &
  & 0.31798629E-06_JPRB, 0.31798797E-06_JPRB, 0.31798834E-06_JPRB, 0.31798834E-06_JPRB, 0.31799016E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31799070E-06_JPRB, 0.31799021E-06_JPRB, 0.31799016E-06_JPRB, 0.31799121E-06_JPRB, 0.31799243E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799132E-06_JPRB, 0.31799419E-06_JPRB, 0.31799172E-06_JPRB, 0.31799311E-06_JPRB, 0.31799007E-06_JPRB, 0.31799300E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799766E-06_JPRB, 0.31799590E-06_JPRB, 0.31799686E-06_JPRB, 0.31799635E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799988E-06_JPRB, 0.31800275E-06_JPRB, 0.31800374E-06_JPRB, 0.31800411E-06_JPRB, 0.31800042E-06_JPRB, 0.31799962E-06_JPRB, &
  & 0.31799800E-06_JPRB, 0.31799948E-06_JPRB, 0.31800198E-06_JPRB, 0.31800141E-06_JPRB, 0.31800073E-06_JPRB, 0.31799655E-06_JPRB, &
  & 0.31800042E-06_JPRB, 0.31799749E-06_JPRB, 0.31799630E-06_JPRB, 0.31799567E-06_JPRB, 0.31799496E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799783E-06_JPRB, 0.31799806E-06_JPRB, 0.31799976E-06_JPRB, 0.31799834E-06_JPRB, 0.31799564E-06_JPRB, 0.31799760E-06_JPRB, &
  & 0.31799942E-06_JPRB, 0.31800030E-06_JPRB, 0.31799649E-06_JPRB, 0.31799561E-06_JPRB, 0.31799885E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799544E-06_JPRB, 0.31799635E-06_JPRB, 0.31799686E-06_JPRB /)

RGHG3(:,91, 7) = (/ &
  & 0.31798530E-06_JPRB, 0.31798550E-06_JPRB, 0.31798211E-06_JPRB, 0.31798101E-06_JPRB, 0.31798538E-06_JPRB, 0.31798655E-06_JPRB, &
  & 0.31798419E-06_JPRB, 0.31798953E-06_JPRB, 0.31798746E-06_JPRB, 0.31798660E-06_JPRB, 0.31799169E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31798962E-06_JPRB, 0.31798911E-06_JPRB, 0.31799138E-06_JPRB, 0.31799419E-06_JPRB, 0.31798891E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31799485E-06_JPRB, 0.31799146E-06_JPRB, 0.31799345E-06_JPRB, 0.31798970E-06_JPRB, 0.31799323E-06_JPRB, &
  & 0.31799135E-06_JPRB, 0.31799820E-06_JPRB, 0.31799576E-06_JPRB, 0.31799695E-06_JPRB, 0.31799632E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799999E-06_JPRB, 0.31800286E-06_JPRB, 0.31800380E-06_JPRB, 0.31800448E-06_JPRB, 0.31800016E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31799775E-06_JPRB, 0.31799945E-06_JPRB, 0.31800221E-06_JPRB, 0.31800144E-06_JPRB, 0.31800104E-06_JPRB, 0.31799581E-06_JPRB, &
  & 0.31800127E-06_JPRB, 0.31799726E-06_JPRB, 0.31799621E-06_JPRB, 0.31799564E-06_JPRB, 0.31799419E-06_JPRB, 0.31799811E-06_JPRB, &
  & 0.31799797E-06_JPRB, 0.31799800E-06_JPRB, 0.31800025E-06_JPRB, 0.31799851E-06_JPRB, 0.31799502E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799956E-06_JPRB, 0.31800070E-06_JPRB, 0.31799635E-06_JPRB, 0.31799539E-06_JPRB, 0.31799922E-06_JPRB, 0.31799587E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799533E-06_JPRB, 0.31799641E-06_JPRB, 0.31799689E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG3(:, 1, 8) = (/ &
  & 0.95731629E-07_JPRB, 0.95703570E-07_JPRB, 0.95650293E-07_JPRB, 0.95554277E-07_JPRB, 0.95440541E-07_JPRB, 0.95308721E-07_JPRB, &
  & 0.95161113E-07_JPRB, 0.95003337E-07_JPRB, 0.94841667E-07_JPRB, 0.94682001E-07_JPRB, 0.94529000E-07_JPRB, 0.94386060E-07_JPRB, &
  & 0.94255682E-07_JPRB, 0.94139210E-07_JPRB, 0.94036395E-07_JPRB, 0.93945204E-07_JPRB, 0.93862354E-07_JPRB, 0.93784109E-07_JPRB, &
  & 0.93707484E-07_JPRB, 0.93629666E-07_JPRB, 0.93548479E-07_JPRB, 0.93463008E-07_JPRB, 0.93373430E-07_JPRB, 0.93279631E-07_JPRB, &
  & 0.93181121E-07_JPRB, 0.93078718E-07_JPRB, 0.92977224E-07_JPRB, 0.92885678E-07_JPRB, 0.92809245E-07_JPRB, 0.92740621E-07_JPRB, &
  & 0.92665381E-07_JPRB, 0.92572883E-07_JPRB, 0.92456787E-07_JPRB, 0.92318551E-07_JPRB, 0.92159389E-07_JPRB, 0.91983182E-07_JPRB, &
  & 0.91796920E-07_JPRB, 0.91608641E-07_JPRB, 0.91425839E-07_JPRB, 0.91270032E-07_JPRB, 0.91160068E-07_JPRB, 0.91070490E-07_JPRB, &
  & 0.90978574E-07_JPRB, 0.90880199E-07_JPRB, 0.90757069E-07_JPRB, 0.90608829E-07_JPRB, 0.90390330E-07_JPRB, 0.90090992E-07_JPRB, &
  & 0.89808282E-07_JPRB, 0.89563891E-07_JPRB, 0.89375796E-07_JPRB, 0.89207745E-07_JPRB, 0.89043510E-07_JPRB, 0.88882075E-07_JPRB, &
  & 0.88722032E-07_JPRB, 0.88564200E-07_JPRB, 0.88412889E-07_JPRB, 0.88268962E-07_JPRB, 0.88140254E-07_JPRB, 0.88033246E-07_JPRB, &
  & 0.87955527E-07_JPRB, 0.87904041E-07_JPRB, 0.87871250E-07_JPRB, 0.87873424E-07_JPRB /)

RGHG3(:, 2, 8) = (/ &
  & 0.95527703E-07_JPRB, 0.95429890E-07_JPRB, 0.95323344E-07_JPRB, 0.95181747E-07_JPRB, 0.95022109E-07_JPRB, 0.94855494E-07_JPRB, &
  & 0.94691970E-07_JPRB, 0.94541079E-07_JPRB, 0.94406580E-07_JPRB, 0.94292716E-07_JPRB, 0.94202832E-07_JPRB, 0.94138620E-07_JPRB, &
  & 0.94099441E-07_JPRB, 0.94081585E-07_JPRB, 0.94078118E-07_JPRB, 0.94080008E-07_JPRB, 0.94078104E-07_JPRB, 0.94064688E-07_JPRB, &
  & 0.94035045E-07_JPRB, 0.93987197E-07_JPRB, 0.93919965E-07_JPRB, 0.93835190E-07_JPRB, 0.93739786E-07_JPRB, 0.93647230E-07_JPRB, &
  & 0.93578478E-07_JPRB, 0.93555016E-07_JPRB, 0.93594949E-07_JPRB, 0.93703875E-07_JPRB, 0.93865218E-07_JPRB, 0.94043948E-07_JPRB, &
  & 0.94199635E-07_JPRB, 0.94295046E-07_JPRB, 0.94303793E-07_JPRB, 0.94211074E-07_JPRB, 0.94013359E-07_JPRB, 0.93721383E-07_JPRB, &
  & 0.93354814E-07_JPRB, 0.92936503E-07_JPRB, 0.92501836E-07_JPRB, 0.92098958E-07_JPRB, 0.91769010E-07_JPRB, 0.91494989E-07_JPRB, &
  & 0.91245035E-07_JPRB, 0.90995805E-07_JPRB, 0.90729742E-07_JPRB, 0.90434703E-07_JPRB, 0.90102212E-07_JPRB, 0.89744155E-07_JPRB, &
  & 0.89416602E-07_JPRB, 0.89139746E-07_JPRB, 0.88921034E-07_JPRB, 0.88739043E-07_JPRB, 0.88578226E-07_JPRB, 0.88428635E-07_JPRB, &
  & 0.88289184E-07_JPRB, 0.88154195E-07_JPRB, 0.88026610E-07_JPRB, 0.87907267E-07_JPRB, 0.87797474E-07_JPRB, 0.87703178E-07_JPRB, &
  & 0.87638846E-07_JPRB, 0.87610516E-07_JPRB, 0.87644146E-07_JPRB, 0.87760313E-07_JPRB /)

RGHG3(:, 3, 8) = (/ &
  & 0.95391187E-07_JPRB, 0.95272640E-07_JPRB, 0.95159159E-07_JPRB, 0.95002491E-07_JPRB, 0.94840708E-07_JPRB, 0.94711105E-07_JPRB, &
  & 0.94621228E-07_JPRB, 0.94570765E-07_JPRB, 0.94545939E-07_JPRB, 0.94541321E-07_JPRB, 0.94556029E-07_JPRB, 0.94588287E-07_JPRB, &
  & 0.94634210E-07_JPRB, 0.94691416E-07_JPRB, 0.94761198E-07_JPRB, 0.94843799E-07_JPRB, 0.94933569E-07_JPRB, 0.95019558E-07_JPRB, &
  & 0.95089931E-07_JPRB, 0.95136166E-07_JPRB, 0.95157496E-07_JPRB, 0.95157638E-07_JPRB, 0.95146248E-07_JPRB, 0.95142333E-07_JPRB, &
  & 0.95175565E-07_JPRB, 0.95279688E-07_JPRB, 0.95477873E-07_JPRB, 0.95768343E-07_JPRB, 0.96126158E-07_JPRB, 0.96510533E-07_JPRB, &
  & 0.96875596E-07_JPRB, 0.97171032E-07_JPRB, 0.97348369E-07_JPRB, 0.97374055E-07_JPRB, 0.97238427E-07_JPRB, 0.96952043E-07_JPRB, &
  & 0.96532936E-07_JPRB, 0.95998899E-07_JPRB, 0.95368890E-07_JPRB, 0.94695750E-07_JPRB, 0.94043031E-07_JPRB, 0.93445934E-07_JPRB, &
  & 0.92884967E-07_JPRB, 0.92333607E-07_JPRB, 0.91770126E-07_JPRB, 0.91181654E-07_JPRB, 0.90571994E-07_JPRB, 0.89980183E-07_JPRB, &
  & 0.89441045E-07_JPRB, 0.88988159E-07_JPRB, 0.88608971E-07_JPRB, 0.88292438E-07_JPRB, 0.88019874E-07_JPRB, 0.87774580E-07_JPRB, &
  & 0.87556664E-07_JPRB, 0.87358899E-07_JPRB, 0.87179600E-07_JPRB, 0.87017035E-07_JPRB, 0.86882054E-07_JPRB, 0.86797364E-07_JPRB, &
  & 0.86765681E-07_JPRB, 0.86786130E-07_JPRB, 0.86899313E-07_JPRB, 0.87185065E-07_JPRB /)

RGHG3(:, 4, 8) = (/ &
  & 0.95450474E-07_JPRB, 0.95381452E-07_JPRB, 0.95289074E-07_JPRB, 0.95143278E-07_JPRB, 0.94980820E-07_JPRB, 0.94877002E-07_JPRB, &
  & 0.94838640E-07_JPRB, 0.94861612E-07_JPRB, 0.94914469E-07_JPRB, 0.94982937E-07_JPRB, 0.95073091E-07_JPRB, 0.95196789E-07_JPRB, &
  & 0.95361401E-07_JPRB, 0.95559550E-07_JPRB, 0.95771640E-07_JPRB, 0.95982728E-07_JPRB, 0.96191137E-07_JPRB, 0.96398566E-07_JPRB, &
  & 0.96602299E-07_JPRB, 0.96795588E-07_JPRB, 0.96970709E-07_JPRB, 0.97124513E-07_JPRB, 0.97262912E-07_JPRB, 0.97402960E-07_JPRB, &
  & 0.97568218E-07_JPRB, 0.97791826E-07_JPRB, 0.98099200E-07_JPRB, 0.98497040E-07_JPRB, 0.98968982E-07_JPRB, 0.99490762E-07_JPRB, &
  & 0.10002843E-06_JPRB, 0.10054137E-06_JPRB, 0.10097092E-06_JPRB, 0.10125900E-06_JPRB, 0.10137506E-06_JPRB, 0.10131931E-06_JPRB, &
  & 0.10110347E-06_JPRB, 0.10074042E-06_JPRB, 0.10023825E-06_JPRB, 0.99606474E-07_JPRB, 0.98878601E-07_JPRB, 0.98085906E-07_JPRB, &
  & 0.97252375E-07_JPRB, 0.96375224E-07_JPRB, 0.95451355E-07_JPRB, 0.94482914E-07_JPRB, 0.93485504E-07_JPRB, 0.92489728E-07_JPRB, &
  & 0.91546212E-07_JPRB, 0.90669829E-07_JPRB, 0.89870497E-07_JPRB, 0.89140471E-07_JPRB, 0.88479901E-07_JPRB, 0.87884530E-07_JPRB, &
  & 0.87344922E-07_JPRB, 0.86870294E-07_JPRB, 0.86466727E-07_JPRB, 0.86142023E-07_JPRB, 0.85900140E-07_JPRB, 0.85731436E-07_JPRB, &
  & 0.85639165E-07_JPRB, 0.85624762E-07_JPRB, 0.85735387E-07_JPRB, 0.86149946E-07_JPRB /)

RGHG3(:, 5, 8) = (/ &
  & 0.95693323E-07_JPRB, 0.95748653E-07_JPRB, 0.95717432E-07_JPRB, 0.95606005E-07_JPRB, 0.95450062E-07_JPRB, 0.95351112E-07_JPRB, &
  & 0.95343040E-07_JPRB, 0.95410826E-07_JPRB, 0.95526758E-07_JPRB, 0.95682616E-07_JPRB, 0.95884836E-07_JPRB, 0.96135565E-07_JPRB, &
  & 0.96432181E-07_JPRB, 0.96776063E-07_JPRB, 0.97166264E-07_JPRB, 0.97584277E-07_JPRB, 0.98002559E-07_JPRB, 0.98406602E-07_JPRB, &
  & 0.98800427E-07_JPRB, 0.99190991E-07_JPRB, 0.99578259E-07_JPRB, 0.99958903E-07_JPRB, 0.10032962E-06_JPRB, 0.10069009E-06_JPRB, &
  & 0.10104883E-06_JPRB, 0.10141635E-06_JPRB, 0.10180990E-06_JPRB, 0.10224578E-06_JPRB, 0.10274154E-06_JPRB, 0.10330895E-06_JPRB, &
  & 0.10395182E-06_JPRB, 0.10465008E-06_JPRB, 0.10535577E-06_JPRB, 0.10600868E-06_JPRB, 0.10655501E-06_JPRB, 0.10695957E-06_JPRB, &
  & 0.10721961E-06_JPRB, 0.10733650E-06_JPRB, 0.10730801E-06_JPRB, 0.10710912E-06_JPRB, 0.10670634E-06_JPRB, 0.10608086E-06_JPRB, &
  & 0.10522970E-06_JPRB, 0.10418348E-06_JPRB, 0.10297478E-06_JPRB, 0.10162254E-06_JPRB, 0.10015417E-06_JPRB, 0.98602442E-07_JPRB, &
  & 0.96998946E-07_JPRB, 0.95393943E-07_JPRB, 0.93818649E-07_JPRB, 0.92299352E-07_JPRB, 0.90861718E-07_JPRB, 0.89535888E-07_JPRB, &
  & 0.88349168E-07_JPRB, 0.87295419E-07_JPRB, 0.86413941E-07_JPRB, 0.85703597E-07_JPRB, 0.85148315E-07_JPRB, 0.84751662E-07_JPRB, &
  & 0.84481627E-07_JPRB, 0.84335795E-07_JPRB, 0.84401989E-07_JPRB, 0.84840643E-07_JPRB /)

RGHG3(:, 6, 8) = (/ &
  & 0.96113482E-07_JPRB, 0.96376439E-07_JPRB, 0.96441909E-07_JPRB, 0.96398111E-07_JPRB, 0.96290279E-07_JPRB, 0.96207529E-07_JPRB, &
  & 0.96217761E-07_JPRB, 0.96319056E-07_JPRB, 0.96494858E-07_JPRB, 0.96738923E-07_JPRB, 0.97059115E-07_JPRB, 0.97465346E-07_JPRB, &
  & 0.97959720E-07_JPRB, 0.98526939E-07_JPRB, 0.99144600E-07_JPRB, 0.99800481E-07_JPRB, 0.10048187E-06_JPRB, 0.10116235E-06_JPRB, &
  & 0.10182333E-06_JPRB, 0.10247166E-06_JPRB, 0.10312483E-06_JPRB, 0.10379177E-06_JPRB, 0.10446983E-06_JPRB, 0.10514881E-06_JPRB, &
  & 0.10580661E-06_JPRB, 0.10641535E-06_JPRB, 0.10695074E-06_JPRB, 0.10741967E-06_JPRB, 0.10786720E-06_JPRB, 0.10835757E-06_JPRB, &
  & 0.10894087E-06_JPRB, 0.10966212E-06_JPRB, 0.11055016E-06_JPRB, 0.11158960E-06_JPRB, 0.11270702E-06_JPRB, 0.11381093E-06_JPRB, &
  & 0.11482746E-06_JPRB, 0.11571697E-06_JPRB, 0.11644116E-06_JPRB, 0.11694238E-06_JPRB, 0.11712906E-06_JPRB, 0.11691676E-06_JPRB, &
  & 0.11627134E-06_JPRB, 0.11522049E-06_JPRB, 0.11382335E-06_JPRB, 0.11212179E-06_JPRB, 0.11013953E-06_JPRB, 0.10790517E-06_JPRB, &
  & 0.10546386E-06_JPRB, 0.10288414E-06_JPRB, 0.10024377E-06_JPRB, 0.97624778E-07_JPRB, 0.95091849E-07_JPRB, 0.92719930E-07_JPRB, &
  & 0.90577423E-07_JPRB, 0.88708674E-07_JPRB, 0.87111538E-07_JPRB, 0.85814094E-07_JPRB, 0.84789377E-07_JPRB, 0.84034312E-07_JPRB, &
  & 0.83528484E-07_JPRB, 0.83228620E-07_JPRB, 0.83175088E-07_JPRB, 0.83499053E-07_JPRB /)

RGHG3(:, 7, 8) = (/ &
  & 0.96793315E-07_JPRB, 0.97324133E-07_JPRB, 0.97528385E-07_JPRB, 0.97590402E-07_JPRB, 0.97570634E-07_JPRB, 0.97537608E-07_JPRB, &
  & 0.97563948E-07_JPRB, 0.97679504E-07_JPRB, 0.97898742E-07_JPRB, 0.98232299E-07_JPRB, 0.98688041E-07_JPRB, 0.99267943E-07_JPRB, &
  & 0.99965682E-07_JPRB, 0.10076504E-06_JPRB, 0.10163536E-06_JPRB, 0.10253306E-06_JPRB, 0.10343275E-06_JPRB, 0.10433236E-06_JPRB, &
  & 0.10522900E-06_JPRB, 0.10612074E-06_JPRB, 0.10702659E-06_JPRB, 0.10797621E-06_JPRB, 0.10898451E-06_JPRB, 0.11004401E-06_JPRB, &
  & 0.11111783E-06_JPRB, 0.11213712E-06_JPRB, 0.11302060E-06_JPRB, 0.11371955E-06_JPRB, 0.11425641E-06_JPRB, 0.11470642E-06_JPRB, &
  & 0.11519143E-06_JPRB, 0.11588787E-06_JPRB, 0.11693938E-06_JPRB, 0.11836724E-06_JPRB, 0.12008985E-06_JPRB, 0.12196539E-06_JPRB, &
  & 0.12385581E-06_JPRB, 0.12565526E-06_JPRB, 0.12727027E-06_JPRB, 0.12858568E-06_JPRB, 0.12945907E-06_JPRB, 0.12974499E-06_JPRB, &
  & 0.12938575E-06_JPRB, 0.12841184E-06_JPRB, 0.12688790E-06_JPRB, 0.12485496E-06_JPRB, 0.12234605E-06_JPRB, 0.11939179E-06_JPRB, &
  & 0.11604754E-06_JPRB, 0.11241417E-06_JPRB, 0.10862013E-06_JPRB, 0.10478669E-06_JPRB, 0.10103319E-06_JPRB, 0.97462099E-07_JPRB, &
  & 0.94178901E-07_JPRB, 0.91265534E-07_JPRB, 0.88781100E-07_JPRB, 0.86735206E-07_JPRB, 0.85125869E-07_JPRB, 0.83904091E-07_JPRB, &
  & 0.83029818E-07_JPRB, 0.82463288E-07_JPRB, 0.82236639E-07_JPRB, 0.82361154E-07_JPRB /)

RGHG3(:, 8, 8) = (/ &
  & 0.97885533E-07_JPRB, 0.98743413E-07_JPRB, 0.99116662E-07_JPRB, 0.99320836E-07_JPRB, 0.99423190E-07_JPRB, 0.99479401E-07_JPRB, &
  & 0.99550022E-07_JPRB, 0.99690212E-07_JPRB, 0.99944813E-07_JPRB, 0.10033982E-06_JPRB, 0.10088783E-06_JPRB, 0.10159256E-06_JPRB, &
  & 0.10244083E-06_JPRB, 0.10340156E-06_JPRB, 0.10443379E-06_JPRB, 0.10550138E-06_JPRB, 0.10656886E-06_JPRB, 0.10761814E-06_JPRB, &
  & 0.10866698E-06_JPRB, 0.10974476E-06_JPRB, 0.11087594E-06_JPRB, 0.11210676E-06_JPRB, 0.11349361E-06_JPRB, 0.11505342E-06_JPRB, &
  & 0.11672729E-06_JPRB, 0.11839123E-06_JPRB, 0.11989563E-06_JPRB, 0.12112710E-06_JPRB, 0.12203701E-06_JPRB, 0.12268515E-06_JPRB, &
  & 0.12327298E-06_JPRB, 0.12407097E-06_JPRB, 0.12527431E-06_JPRB, 0.12696073E-06_JPRB, 0.12910581E-06_JPRB, 0.13159971E-06_JPRB, &
  & 0.13426263E-06_JPRB, 0.13691366E-06_JPRB, 0.13938660E-06_JPRB, 0.14149165E-06_JPRB, 0.14302171E-06_JPRB, 0.14380977E-06_JPRB, &
  & 0.14376486E-06_JPRB, 0.14289954E-06_JPRB, 0.14127005E-06_JPRB, 0.13892594E-06_JPRB, 0.13589943E-06_JPRB, 0.13223115E-06_JPRB, &
  & 0.12801326E-06_JPRB, 0.12338772E-06_JPRB, 0.11852923E-06_JPRB, 0.11360093E-06_JPRB, 0.10874836E-06_JPRB, 0.10410434E-06_JPRB, &
  & 0.99780102E-07_JPRB, 0.95882669E-07_JPRB, 0.92475837E-07_JPRB, 0.89612733E-07_JPRB, 0.87289713E-07_JPRB, 0.85495394E-07_JPRB, &
  & 0.84163226E-07_JPRB, 0.83202032E-07_JPRB, 0.82577408E-07_JPRB, 0.82096292E-07_JPRB /)

RGHG3(:, 9, 8) = (/ &
  & 0.99632253E-07_JPRB, 0.10089030E-06_JPRB, 0.10145098E-06_JPRB, 0.10182261E-06_JPRB, 0.10207562E-06_JPRB, 0.10226213E-06_JPRB, &
  & 0.10242751E-06_JPRB, 0.10262264E-06_JPRB, 0.10290418E-06_JPRB, 0.10331546E-06_JPRB, 0.10388194E-06_JPRB, 0.10460921E-06_JPRB, &
  & 0.10548752E-06_JPRB, 0.10648911E-06_JPRB, 0.10757255E-06_JPRB, 0.10869331E-06_JPRB, 0.10982618E-06_JPRB, 0.11096245E-06_JPRB, &
  & 0.11210741E-06_JPRB, 0.11330248E-06_JPRB, 0.11461439E-06_JPRB, 0.11609706E-06_JPRB, 0.11780810E-06_JPRB, 0.11982790E-06_JPRB, &
  & 0.12215590E-06_JPRB, 0.12466249E-06_JPRB, 0.12714878E-06_JPRB, 0.12939677E-06_JPRB, 0.13128036E-06_JPRB, 0.13283125E-06_JPRB, &
  & 0.13418543E-06_JPRB, 0.13552742E-06_JPRB, 0.13706671E-06_JPRB, 0.13898887E-06_JPRB, 0.14137383E-06_JPRB, 0.14417327E-06_JPRB, &
  & 0.14725386E-06_JPRB, 0.15041358E-06_JPRB, 0.15340903E-06_JPRB, 0.15598165E-06_JPRB, 0.15789529E-06_JPRB, 0.15895573E-06_JPRB, &
  & 0.15904651E-06_JPRB, 0.15816494E-06_JPRB, 0.15635412E-06_JPRB, 0.15364969E-06_JPRB, 0.15009689E-06_JPRB, 0.14576833E-06_JPRB, &
  & 0.14079416E-06_JPRB, 0.13536250E-06_JPRB, 0.12967458E-06_JPRB, 0.12392546E-06_JPRB, 0.11828219E-06_JPRB, 0.11289267E-06_JPRB, &
  & 0.10789565E-06_JPRB, 0.10339805E-06_JPRB, 0.99472700E-07_JPRB, 0.96150259E-07_JPRB, 0.93429264E-07_JPRB, 0.91254392E-07_JPRB, &
  & 0.89536577E-07_JPRB, 0.88140290E-07_JPRB, 0.86902084E-07_JPRB, 0.85215369E-07_JPRB /)

RGHG3(:,10, 8) = (/ &
  & 0.10240399E-06_JPRB, 0.10397741E-06_JPRB, 0.10478027E-06_JPRB, 0.10528908E-06_JPRB, 0.10569515E-06_JPRB, 0.10602358E-06_JPRB, &
  & 0.10631500E-06_JPRB, 0.10660395E-06_JPRB, 0.10693638E-06_JPRB, 0.10735759E-06_JPRB, 0.10789901E-06_JPRB, 0.10857491E-06_JPRB, &
  & 0.10938185E-06_JPRB, 0.11030037E-06_JPRB, 0.11130192E-06_JPRB, 0.11235778E-06_JPRB, 0.11344347E-06_JPRB, 0.11455447E-06_JPRB, &
  & 0.11571254E-06_JPRB, 0.11696047E-06_JPRB, 0.11837217E-06_JPRB, 0.12007733E-06_JPRB, 0.12223140E-06_JPRB, 0.12494590E-06_JPRB, &
  & 0.12823854E-06_JPRB, 0.13197310E-06_JPRB, 0.13591017E-06_JPRB, 0.13982692E-06_JPRB, 0.14358999E-06_JPRB, 0.14709887E-06_JPRB, &
  & 0.15024352E-06_JPRB, 0.15299614E-06_JPRB, 0.15549612E-06_JPRB, 0.15796394E-06_JPRB, 0.16058129E-06_JPRB, 0.16340240E-06_JPRB, &
  & 0.16634411E-06_JPRB, 0.16922617E-06_JPRB, 0.17182961E-06_JPRB, 0.17391241E-06_JPRB, 0.17530287E-06_JPRB, 0.17581911E-06_JPRB, &
  & 0.17539452E-06_JPRB, 0.17401948E-06_JPRB, 0.17168867E-06_JPRB, 0.16843917E-06_JPRB, 0.16432175E-06_JPRB, 0.15943505E-06_JPRB, &
  & 0.15392962E-06_JPRB, 0.14800642E-06_JPRB, 0.14189156E-06_JPRB, 0.13576341E-06_JPRB, 0.12978475E-06_JPRB, 0.12411098E-06_JPRB, &
  & 0.11888439E-06_JPRB, 0.11422868E-06_JPRB, 0.11022192E-06_JPRB, 0.10688550E-06_JPRB, 0.10423042E-06_JPRB, 0.10217821E-06_JPRB, &
  & 0.10064497E-06_JPRB, 0.99401070E-07_JPRB, 0.98286030E-07_JPRB, 0.96269659E-07_JPRB /)

RGHG3(:,11, 8) = (/ &
  & 0.10609624E-06_JPRB, 0.10798095E-06_JPRB, 0.10875717E-06_JPRB, 0.10935337E-06_JPRB, 0.10980560E-06_JPRB, 0.11021871E-06_JPRB, &
  & 0.11060866E-06_JPRB, 0.11100369E-06_JPRB, 0.11143153E-06_JPRB, 0.11192234E-06_JPRB, 0.11249782E-06_JPRB, 0.11316912E-06_JPRB, &
  & 0.11393437E-06_JPRB, 0.11478273E-06_JPRB, 0.11569713E-06_JPRB, 0.11666135E-06_JPRB, 0.11766926E-06_JPRB, 0.11872662E-06_JPRB, &
  & 0.11986197E-06_JPRB, 0.12113185E-06_JPRB, 0.12263696E-06_JPRB, 0.12452531E-06_JPRB, 0.12698003E-06_JPRB, 0.13021501E-06_JPRB, &
  & 0.13432592E-06_JPRB, 0.13923524E-06_JPRB, 0.14473262E-06_JPRB, 0.15071666E-06_JPRB, 0.15704350E-06_JPRB, 0.16341689E-06_JPRB, &
  & 0.16946744E-06_JPRB, 0.17487807E-06_JPRB, 0.17950242E-06_JPRB, 0.18338517E-06_JPRB, 0.18662226E-06_JPRB, 0.18932383E-06_JPRB, &
  & 0.19150065E-06_JPRB, 0.19318145E-06_JPRB, 0.19427557E-06_JPRB, 0.19477240E-06_JPRB, 0.19458925E-06_JPRB, 0.19369651E-06_JPRB, &
  & 0.19208166E-06_JPRB, 0.18968663E-06_JPRB, 0.18651373E-06_JPRB, 0.18257755E-06_JPRB, 0.17792659E-06_JPRB, 0.17265189E-06_JPRB, &
  & 0.16692249E-06_JPRB, 0.16095674E-06_JPRB, 0.15493121E-06_JPRB, 0.14900452E-06_JPRB, 0.14330868E-06_JPRB, 0.13796547E-06_JPRB, &
  & 0.13308907E-06_JPRB, 0.12878826E-06_JPRB, 0.12512632E-06_JPRB, 0.12213380E-06_JPRB, 0.11982505E-06_JPRB, 0.11810427E-06_JPRB, &
  & 0.11695692E-06_JPRB, 0.11608863E-06_JPRB, 0.11560338E-06_JPRB, 0.11466015E-06_JPRB /)

RGHG3(:,12, 8) = (/ &
  & 0.10991452E-06_JPRB, 0.11123743E-06_JPRB, 0.11185286E-06_JPRB, 0.11224646E-06_JPRB, 0.11261851E-06_JPRB, 0.11298770E-06_JPRB, &
  & 0.11340149E-06_JPRB, 0.11387554E-06_JPRB, 0.11442687E-06_JPRB, 0.11507085E-06_JPRB, 0.11582107E-06_JPRB, 0.11668241E-06_JPRB, &
  & 0.11765515E-06_JPRB, 0.11872708E-06_JPRB, 0.11988161E-06_JPRB, 0.12109615E-06_JPRB, 0.12235098E-06_JPRB, 0.12364487E-06_JPRB, &
  & 0.12500287E-06_JPRB, 0.12648287E-06_JPRB, 0.12820055E-06_JPRB, 0.13033173E-06_JPRB, 0.13312025E-06_JPRB, 0.13679588E-06_JPRB, &
  & 0.14150720E-06_JPRB, 0.14724928E-06_JPRB, 0.15399570E-06_JPRB, 0.16144438E-06_JPRB, 0.16938456E-06_JPRB, 0.17775812E-06_JPRB, &
  & 0.18615060E-06_JPRB, 0.19383864E-06_JPRB, 0.20032276E-06_JPRB, 0.20546707E-06_JPRB, 0.20930889E-06_JPRB, 0.21200162E-06_JPRB, &
  & 0.21363395E-06_JPRB, 0.21438078E-06_JPRB, 0.21426175E-06_JPRB, 0.21343934E-06_JPRB, 0.21193344E-06_JPRB, 0.20979952E-06_JPRB, &
  & 0.20704354E-06_JPRB, 0.20370670E-06_JPRB, 0.19977961E-06_JPRB, 0.19528663E-06_JPRB, 0.19029748E-06_JPRB, 0.18494202E-06_JPRB, &
  & 0.17939634E-06_JPRB, 0.17382243E-06_JPRB, 0.16839233E-06_JPRB, 0.16322167E-06_JPRB, 0.15838918E-06_JPRB, 0.15396522E-06_JPRB, &
  & 0.15001797E-06_JPRB, 0.14660151E-06_JPRB, 0.14375695E-06_JPRB, 0.14149967E-06_JPRB, 0.13985371E-06_JPRB, 0.13871573E-06_JPRB, &
  & 0.13814713E-06_JPRB, 0.13781674E-06_JPRB, 0.13809262E-06_JPRB, 0.13845748E-06_JPRB /)

RGHG3(:,13, 8) = (/ &
  & 0.11155322E-06_JPRB, 0.11173326E-06_JPRB, 0.11187424E-06_JPRB, 0.11210071E-06_JPRB, 0.11242921E-06_JPRB, 0.11291734E-06_JPRB, &
  & 0.11358621E-06_JPRB, 0.11447325E-06_JPRB, 0.11561107E-06_JPRB, 0.11704140E-06_JPRB, 0.11880727E-06_JPRB, 0.12092664E-06_JPRB, &
  & 0.12337566E-06_JPRB, 0.12605901E-06_JPRB, 0.12883972E-06_JPRB, 0.13150687E-06_JPRB, 0.13390833E-06_JPRB, 0.13591644E-06_JPRB, &
  & 0.13757651E-06_JPRB, 0.13902117E-06_JPRB, 0.14046458E-06_JPRB, 0.14217183E-06_JPRB, 0.14444288E-06_JPRB, 0.14757202E-06_JPRB, &
  & 0.15176913E-06_JPRB, 0.15712658E-06_JPRB, 0.16364405E-06_JPRB, 0.17145396E-06_JPRB, 0.18036056E-06_JPRB, 0.18973591E-06_JPRB, &
  & 0.19907208E-06_JPRB, 0.20771203E-06_JPRB, 0.21504144E-06_JPRB, 0.22080798E-06_JPRB, 0.22502635E-06_JPRB, 0.22781197E-06_JPRB, &
  & 0.22929677E-06_JPRB, 0.22964522E-06_JPRB, 0.22900096E-06_JPRB, 0.22752612E-06_JPRB, 0.22532998E-06_JPRB, 0.22252567E-06_JPRB, &
  & 0.21918001E-06_JPRB, 0.21533293E-06_JPRB, 0.21104385E-06_JPRB, 0.20637560E-06_JPRB, 0.20143590E-06_JPRB, 0.19635550E-06_JPRB, &
  & 0.19130695E-06_JPRB, 0.18647799E-06_JPRB, 0.18197365E-06_JPRB, 0.17786040E-06_JPRB, 0.17416762E-06_JPRB, 0.17091148E-06_JPRB, &
  & 0.16810083E-06_JPRB, 0.16574685E-06_JPRB, 0.16385425E-06_JPRB, 0.16242289E-06_JPRB, 0.16147877E-06_JPRB, 0.16091522E-06_JPRB, &
  & 0.16085468E-06_JPRB, 0.16098078E-06_JPRB, 0.16176766E-06_JPRB, 0.16309046E-06_JPRB /)

RGHG3(:,14, 8) = (/ &
  & 0.11167092E-06_JPRB, 0.11220655E-06_JPRB, 0.11280385E-06_JPRB, 0.11347949E-06_JPRB, 0.11434923E-06_JPRB, 0.11549454E-06_JPRB, &
  & 0.11705398E-06_JPRB, 0.11914717E-06_JPRB, 0.12188582E-06_JPRB, 0.12535443E-06_JPRB, 0.12956208E-06_JPRB, 0.13439860E-06_JPRB, &
  & 0.13956931E-06_JPRB, 0.14462083E-06_JPRB, 0.14911734E-06_JPRB, 0.15278957E-06_JPRB, 0.15556633E-06_JPRB, 0.15754338E-06_JPRB, &
  & 0.15887568E-06_JPRB, 0.15977467E-06_JPRB, 0.16044902E-06_JPRB, 0.16116255E-06_JPRB, 0.16223012E-06_JPRB, 0.16400190E-06_JPRB, &
  & 0.16678430E-06_JPRB, 0.17085306E-06_JPRB, 0.17634974E-06_JPRB, 0.18318525E-06_JPRB, 0.19133890E-06_JPRB, 0.20046039E-06_JPRB, &
  & 0.20971382E-06_JPRB, 0.21839595E-06_JPRB, 0.22590295E-06_JPRB, 0.23191834E-06_JPRB, 0.23634495E-06_JPRB, 0.23921385E-06_JPRB, &
  & 0.24065886E-06_JPRB, 0.24085037E-06_JPRB, 0.23998268E-06_JPRB, 0.23823928E-06_JPRB, 0.23577245E-06_JPRB, 0.23271888E-06_JPRB, &
  & 0.22918103E-06_JPRB, 0.22524458E-06_JPRB, 0.22098999E-06_JPRB, 0.21651275E-06_JPRB, 0.21194063E-06_JPRB, 0.20744727E-06_JPRB, &
  & 0.20320063E-06_JPRB, 0.19931005E-06_JPRB, 0.19584444E-06_JPRB, 0.19281788E-06_JPRB, 0.19021275E-06_JPRB, 0.18800176E-06_JPRB, &
  & 0.18616153E-06_JPRB, 0.18467502E-06_JPRB, 0.18353401E-06_JPRB, 0.18273698E-06_JPRB, 0.18229568E-06_JPRB, 0.18214477E-06_JPRB, &
  & 0.18238343E-06_JPRB, 0.18278891E-06_JPRB, 0.18378505E-06_JPRB, 0.18559082E-06_JPRB /)

RGHG3(:,15, 8) = (/ &
  & 0.11960620E-06_JPRB, 0.12344029E-06_JPRB, 0.12523380E-06_JPRB, 0.12640761E-06_JPRB, 0.12752858E-06_JPRB, 0.12894373E-06_JPRB, &
  & 0.13093884E-06_JPRB, 0.13375106E-06_JPRB, 0.13750665E-06_JPRB, 0.14218287E-06_JPRB, 0.14758898E-06_JPRB, 0.15337312E-06_JPRB, &
  & 0.15913568E-06_JPRB, 0.16448348E-06_JPRB, 0.16908805E-06_JPRB, 0.17276300E-06_JPRB, 0.17551142E-06_JPRB, 0.17746015E-06_JPRB, &
  & 0.17880966E-06_JPRB, 0.17975427E-06_JPRB, 0.18048287E-06_JPRB, 0.18117777E-06_JPRB, 0.18204291E-06_JPRB, 0.18332751E-06_JPRB, &
  & 0.18531965E-06_JPRB, 0.18828376E-06_JPRB, 0.19251169E-06_JPRB, 0.19814260E-06_JPRB, 0.20500809E-06_JPRB, 0.21284706E-06_JPRB, &
  & 0.22108826E-06_JPRB, 0.22900394E-06_JPRB, 0.23600823E-06_JPRB, 0.24172095E-06_JPRB, 0.24591665E-06_JPRB, 0.24861797E-06_JPRB, &
  & 0.24992417E-06_JPRB, 0.25000571E-06_JPRB, 0.24907442E-06_JPRB, 0.24732356E-06_JPRB, 0.24491459E-06_JPRB, 0.24197107E-06_JPRB, &
  & 0.23860412E-06_JPRB, 0.23490671E-06_JPRB, 0.23098551E-06_JPRB, 0.22697687E-06_JPRB, 0.22302848E-06_JPRB, 0.21928578E-06_JPRB, &
  & 0.21587896E-06_JPRB, 0.21288753E-06_JPRB, 0.21032866E-06_JPRB, 0.20817076E-06_JPRB, 0.20636367E-06_JPRB, 0.20486010E-06_JPRB, &
  & 0.20362828E-06_JPRB, 0.20265293E-06_JPRB, 0.20193292E-06_JPRB, 0.20147326E-06_JPRB, 0.20127987E-06_JPRB, 0.20133123E-06_JPRB, &
  & 0.20166496E-06_JPRB, 0.20218548E-06_JPRB, 0.20317469E-06_JPRB, 0.20507429E-06_JPRB /)

RGHG3(:,16, 8) = (/ &
  & 0.14716086E-06_JPRB, 0.15151431E-06_JPRB, 0.15248530E-06_JPRB, 0.15250397E-06_JPRB, 0.15244922E-06_JPRB, 0.15263896E-06_JPRB, &
  & 0.15350388E-06_JPRB, 0.15529807E-06_JPRB, 0.15817142E-06_JPRB, 0.16208931E-06_JPRB, 0.16684949E-06_JPRB, 0.17214755E-06_JPRB, &
  & 0.17755572E-06_JPRB, 0.18266869E-06_JPRB, 0.18719420E-06_JPRB, 0.19098664E-06_JPRB, 0.19404524E-06_JPRB, 0.19646023E-06_JPRB, &
  & 0.19836274E-06_JPRB, 0.19991010E-06_JPRB, 0.20124708E-06_JPRB, 0.20251171E-06_JPRB, 0.20384648E-06_JPRB, 0.20542060E-06_JPRB, &
  & 0.20743059E-06_JPRB, 0.21009737E-06_JPRB, 0.21359445E-06_JPRB, 0.21805702E-06_JPRB, 0.22345746E-06_JPRB, 0.22953537E-06_JPRB, &
  & 0.23592138E-06_JPRB, 0.24208842E-06_JPRB, 0.24756230E-06_JPRB, 0.25200765E-06_JPRB, 0.25526751E-06_JPRB, 0.25731012E-06_JPRB, &
  & 0.25821367E-06_JPRB, 0.25816556E-06_JPRB, 0.25734062E-06_JPRB, 0.25588079E-06_JPRB, 0.25388633E-06_JPRB, 0.25144377E-06_JPRB, &
  & 0.24862467E-06_JPRB, 0.24551414E-06_JPRB, 0.24222263E-06_JPRB, 0.23888015E-06_JPRB, 0.23563138E-06_JPRB, 0.23260634E-06_JPRB, &
  & 0.22990436E-06_JPRB, 0.22756201E-06_JPRB, 0.22556148E-06_JPRB, 0.22385834E-06_JPRB, 0.22240536E-06_JPRB, 0.22116976E-06_JPRB, &
  & 0.22013633E-06_JPRB, 0.21930492E-06_JPRB, 0.21868480E-06_JPRB, 0.21828954E-06_JPRB, 0.21812502E-06_JPRB, 0.21818735E-06_JPRB, &
  & 0.21847133E-06_JPRB, 0.21897037E-06_JPRB, 0.21983266E-06_JPRB, 0.22158520E-06_JPRB /)

RGHG3(:,17, 8) = (/ &
  & 0.18156653E-06_JPRB, 0.18180269E-06_JPRB, 0.18057092E-06_JPRB, 0.17924876E-06_JPRB, 0.17773820E-06_JPRB, 0.17663868E-06_JPRB, &
  & 0.17615164E-06_JPRB, 0.17662192E-06_JPRB, 0.17823017E-06_JPRB, 0.18101363E-06_JPRB, 0.18480421E-06_JPRB, 0.18934882E-06_JPRB, &
  & 0.19433271E-06_JPRB, 0.19939384E-06_JPRB, 0.20421209E-06_JPRB, 0.20856729E-06_JPRB, 0.21237874E-06_JPRB, 0.21567259E-06_JPRB, &
  & 0.21853310E-06_JPRB, 0.22106801E-06_JPRB, 0.22340211E-06_JPRB, 0.22565960E-06_JPRB, 0.22796142E-06_JPRB, 0.23042119E-06_JPRB, &
  & 0.23313260E-06_JPRB, 0.23615092E-06_JPRB, 0.23950503E-06_JPRB, 0.24311825E-06_JPRB, 0.24690672E-06_JPRB, 0.25070540E-06_JPRB, &
  & 0.25438015E-06_JPRB, 0.25773531E-06_JPRB, 0.26064242E-06_JPRB, 0.26293660E-06_JPRB, 0.26453102E-06_JPRB, 0.26543614E-06_JPRB, &
  & 0.26578115E-06_JPRB, 0.26562395E-06_JPRB, 0.26504622E-06_JPRB, 0.26410899E-06_JPRB, 0.26282959E-06_JPRB, 0.26121404E-06_JPRB, &
  & 0.25926761E-06_JPRB, 0.25702946E-06_JPRB, 0.25457095E-06_JPRB, 0.25199745E-06_JPRB, 0.24943301E-06_JPRB, 0.24698025E-06_JPRB, &
  & 0.24471746E-06_JPRB, 0.24267084E-06_JPRB, 0.24082686E-06_JPRB, 0.23916394E-06_JPRB, 0.23766680E-06_JPRB, 0.23633768E-06_JPRB, &
  & 0.23518830E-06_JPRB, 0.23423658E-06_JPRB, 0.23349857E-06_JPRB, 0.23298819E-06_JPRB, 0.23271042E-06_JPRB, 0.23265963E-06_JPRB, &
  & 0.23282210E-06_JPRB, 0.23320746E-06_JPRB, 0.23388390E-06_JPRB, 0.23537048E-06_JPRB /)

RGHG3(:,18, 8) = (/ &
  & 0.20694782E-06_JPRB, 0.20502280E-06_JPRB, 0.20270573E-06_JPRB, 0.20075113E-06_JPRB, 0.19853979E-06_JPRB, 0.19677415E-06_JPRB, &
  & 0.19547369E-06_JPRB, 0.19504792E-06_JPRB, 0.19571756E-06_JPRB, 0.19761315E-06_JPRB, 0.20066875E-06_JPRB, 0.20473107E-06_JPRB, &
  & 0.20952452E-06_JPRB, 0.21472842E-06_JPRB, 0.22001061E-06_JPRB, 0.22507496E-06_JPRB, 0.22971757E-06_JPRB, 0.23387518E-06_JPRB, &
  & 0.23760265E-06_JPRB, 0.24100666E-06_JPRB, 0.24420160E-06_JPRB, 0.24730170E-06_JPRB, 0.25042192E-06_JPRB, 0.25364238E-06_JPRB, &
  & 0.25693808E-06_JPRB, 0.26023190E-06_JPRB, 0.26336005E-06_JPRB, 0.26614180E-06_JPRB, 0.26843549E-06_JPRB, 0.27022296E-06_JPRB, &
  & 0.27151466E-06_JPRB, 0.27238309E-06_JPRB, 0.27287376E-06_JPRB, 0.27306572E-06_JPRB, 0.27304475E-06_JPRB, 0.27288903E-06_JPRB, &
  & 0.27263815E-06_JPRB, 0.27235575E-06_JPRB, 0.27205752E-06_JPRB, 0.27169483E-06_JPRB, 0.27118656E-06_JPRB, 0.27045053E-06_JPRB, &
  & 0.26942277E-06_JPRB, 0.26808300E-06_JPRB, 0.26646046E-06_JPRB, 0.26461703E-06_JPRB, 0.26263939E-06_JPRB, 0.26060525E-06_JPRB, &
  & 0.25858498E-06_JPRB, 0.25661598E-06_JPRB, 0.25471383E-06_JPRB, 0.25289924E-06_JPRB, 0.25119738E-06_JPRB, 0.24964129E-06_JPRB, &
  & 0.24826659E-06_JPRB, 0.24710553E-06_JPRB, 0.24617714E-06_JPRB, 0.24549053E-06_JPRB, 0.24504553E-06_JPRB, 0.24483330E-06_JPRB, &
  & 0.24484120E-06_JPRB, 0.24506332E-06_JPRB, 0.24555607E-06_JPRB, 0.24675424E-06_JPRB /)

RGHG3(:,19, 8) = (/ &
  & 0.22423434E-06_JPRB, 0.22163195E-06_JPRB, 0.21918058E-06_JPRB, 0.21707987E-06_JPRB, 0.21486181E-06_JPRB, 0.21287276E-06_JPRB, &
  & 0.21128581E-06_JPRB, 0.21043492E-06_JPRB, 0.21058861E-06_JPRB, 0.21194370E-06_JPRB, 0.21450973E-06_JPRB, 0.21822238E-06_JPRB, &
  & 0.22287040E-06_JPRB, 0.22813806E-06_JPRB, 0.23365743E-06_JPRB, 0.23907319E-06_JPRB, 0.24411764E-06_JPRB, 0.24865562E-06_JPRB, &
  & 0.25269057E-06_JPRB, 0.25634279E-06_JPRB, 0.25975896E-06_JPRB, 0.26306068E-06_JPRB, 0.26633944E-06_JPRB, 0.26965512E-06_JPRB, &
  & 0.27299336E-06_JPRB, 0.27620877E-06_JPRB, 0.27907072E-06_JPRB, 0.28131606E-06_JPRB, 0.28280704E-06_JPRB, 0.28352648E-06_JPRB, &
  & 0.28358994E-06_JPRB, 0.28312127E-06_JPRB, 0.28229573E-06_JPRB, 0.28125376E-06_JPRB, 0.28021788E-06_JPRB, 0.27932725E-06_JPRB, &
  & 0.27866426E-06_JPRB, 0.27830208E-06_JPRB, 0.27822230E-06_JPRB, 0.27830450E-06_JPRB, 0.27838917E-06_JPRB, 0.27832530E-06_JPRB, &
  & 0.27800138E-06_JPRB, 0.27736027E-06_JPRB, 0.27639004E-06_JPRB, 0.27511851E-06_JPRB, 0.27359576E-06_JPRB, 0.27188185E-06_JPRB, &
  & 0.27003975E-06_JPRB, 0.26811915E-06_JPRB, 0.26616789E-06_JPRB, 0.26423598E-06_JPRB, 0.26237785E-06_JPRB, 0.26065069E-06_JPRB, &
  & 0.25910404E-06_JPRB, 0.25777692E-06_JPRB, 0.25668959E-06_JPRB, 0.25584973E-06_JPRB, 0.25525452E-06_JPRB, 0.25489331E-06_JPRB, &
  & 0.25475256E-06_JPRB, 0.25482589E-06_JPRB, 0.25515925E-06_JPRB, 0.25607611E-06_JPRB /)

RGHG3(:,20, 8) = (/ &
  & 0.23660134E-06_JPRB, 0.23394814E-06_JPRB, 0.23172817E-06_JPRB, 0.22971889E-06_JPRB, 0.22773679E-06_JPRB, 0.22582564E-06_JPRB, &
  & 0.22424794E-06_JPRB, 0.22326888E-06_JPRB, 0.22318044E-06_JPRB, 0.22419388E-06_JPRB, 0.22639013E-06_JPRB, 0.22974564E-06_JPRB, &
  & 0.23408393E-06_JPRB, 0.23911383E-06_JPRB, 0.24446629E-06_JPRB, 0.24975998E-06_JPRB, 0.25470331E-06_JPRB, 0.25915756E-06_JPRB, &
  & 0.26312401E-06_JPRB, 0.26667354E-06_JPRB, 0.26994289E-06_JPRB, 0.27306956E-06_JPRB, 0.27614891E-06_JPRB, 0.27924185E-06_JPRB, &
  & 0.28232918E-06_JPRB, 0.28527552E-06_JPRB, 0.28784592E-06_JPRB, 0.28979653E-06_JPRB, 0.29097811E-06_JPRB, 0.29138698E-06_JPRB, &
  & 0.29110382E-06_JPRB, 0.29024517E-06_JPRB, 0.28898501E-06_JPRB, 0.28749972E-06_JPRB, 0.28601312E-06_JPRB, 0.28476057E-06_JPRB, &
  & 0.28395070E-06_JPRB, 0.28360446E-06_JPRB, 0.28364099E-06_JPRB, 0.28394803E-06_JPRB, 0.28434633E-06_JPRB, 0.28465644E-06_JPRB, &
  & 0.28474432E-06_JPRB, 0.28452769E-06_JPRB, 0.28397363E-06_JPRB, 0.28308429E-06_JPRB, 0.28188802E-06_JPRB, 0.28042649E-06_JPRB, &
  & 0.27875618E-06_JPRB, 0.27693400E-06_JPRB, 0.27502352E-06_JPRB, 0.27309079E-06_JPRB, 0.27120251E-06_JPRB, 0.26942791E-06_JPRB, &
  & 0.26782183E-06_JPRB, 0.26642238E-06_JPRB, 0.26524893E-06_JPRB, 0.26431167E-06_JPRB, 0.26361081E-06_JPRB, 0.26313916E-06_JPRB, &
  & 0.26288245E-06_JPRB, 0.26282942E-06_JPRB, 0.26300717E-06_JPRB, 0.26366254E-06_JPRB /)

RGHG3(:,21, 8) = (/ &
  & 0.24620996E-06_JPRB, 0.24363544E-06_JPRB, 0.24170635E-06_JPRB, 0.23993303E-06_JPRB, 0.23813639E-06_JPRB, 0.23643415E-06_JPRB, &
  & 0.23495760E-06_JPRB, 0.23398762E-06_JPRB, 0.23378442E-06_JPRB, 0.23455577E-06_JPRB, 0.23640624E-06_JPRB, 0.23933620E-06_JPRB, &
  & 0.24320431E-06_JPRB, 0.24774633E-06_JPRB, 0.25262636E-06_JPRB, 0.25749748E-06_JPRB, 0.26207914E-06_JPRB, 0.26621419E-06_JPRB, &
  & 0.26988920E-06_JPRB, 0.27319106E-06_JPRB, 0.27621638E-06_JPRB, 0.27909064E-06_JPRB, 0.28191576E-06_JPRB, 0.28475557E-06_JPRB, &
  & 0.28759959E-06_JPRB, 0.29033214E-06_JPRB, 0.29274312E-06_JPRB, 0.29459864E-06_JPRB, 0.29575716E-06_JPRB, 0.29620128E-06_JPRB, &
  & 0.29597547E-06_JPRB, 0.29517889E-06_JPRB, 0.29395443E-06_JPRB, 0.29248824E-06_JPRB, 0.29099817E-06_JPRB, 0.28973457E-06_JPRB, &
  & 0.28885469E-06_JPRB, 0.28845969E-06_JPRB, 0.28852514E-06_JPRB, 0.28888263E-06_JPRB, 0.28935980E-06_JPRB, 0.28978943E-06_JPRB, &
  & 0.29003579E-06_JPRB, 0.29000790E-06_JPRB, 0.28966409E-06_JPRB, 0.28898867E-06_JPRB, 0.28799326E-06_JPRB, 0.28671320E-06_JPRB, &
  & 0.28520171E-06_JPRB, 0.28351667E-06_JPRB, 0.28171783E-06_JPRB, 0.27987159E-06_JPRB, 0.27805422E-06_JPRB, 0.27633402E-06_JPRB, &
  & 0.27476327E-06_JPRB, 0.27337632E-06_JPRB, 0.27219014E-06_JPRB, 0.27121214E-06_JPRB, 0.27044771E-06_JPRB, 0.26989343E-06_JPRB, &
  & 0.26954353E-06_JPRB, 0.26938520E-06_JPRB, 0.26943164E-06_JPRB, 0.26984804E-06_JPRB /)

RGHG3(:,22, 8) = (/ &
  & 0.25411745E-06_JPRB, 0.25171178E-06_JPRB, 0.25000699E-06_JPRB, 0.24839605E-06_JPRB, 0.24682726E-06_JPRB, 0.24526361E-06_JPRB, &
  & 0.24390701E-06_JPRB, 0.24296369E-06_JPRB, 0.24268547E-06_JPRB, 0.24324899E-06_JPRB, 0.24476941E-06_JPRB, 0.24724412E-06_JPRB, &
  & 0.25055965E-06_JPRB, 0.25449901E-06_JPRB, 0.25877267E-06_JPRB, 0.26307990E-06_JPRB, 0.26717797E-06_JPRB, 0.27092986E-06_JPRB, &
  & 0.27429451E-06_JPRB, 0.27732679E-06_JPRB, 0.28012767E-06_JPRB, 0.28279052E-06_JPRB, 0.28541780E-06_JPRB, 0.28807500E-06_JPRB, &
  & 0.29076796E-06_JPRB, 0.29339364E-06_JPRB, 0.29575577E-06_JPRB, 0.29763541E-06_JPRB, 0.29889301E-06_JPRB, 0.29949891E-06_JPRB, &
  & 0.29948851E-06_JPRB, 0.29894343E-06_JPRB, 0.29797292E-06_JPRB, 0.29675908E-06_JPRB, 0.29549915E-06_JPRB, 0.29439539E-06_JPRB, &
  & 0.29361038E-06_JPRB, 0.29321825E-06_JPRB, 0.29319031E-06_JPRB, 0.29344250E-06_JPRB, 0.29381266E-06_JPRB, 0.29416921E-06_JPRB, &
  & 0.29437427E-06_JPRB, 0.29435293E-06_JPRB, 0.29405513E-06_JPRB, 0.29345526E-06_JPRB, 0.29256114E-06_JPRB, 0.29140119E-06_JPRB, &
  & 0.29001686E-06_JPRB, 0.28845940E-06_JPRB, 0.28678986E-06_JPRB, 0.28507677E-06_JPRB, 0.28338675E-06_JPRB, 0.28177976E-06_JPRB, &
  & 0.28030041E-06_JPRB, 0.27897701E-06_JPRB, 0.27782463E-06_JPRB, 0.27685206E-06_JPRB, 0.27606328E-06_JPRB, 0.27546150E-06_JPRB, &
  & 0.27504217E-06_JPRB, 0.27479877E-06_JPRB, 0.27473516E-06_JPRB, 0.27497228E-06_JPRB /)

RGHG3(:,23, 8) = (/ &
  & 0.26090942E-06_JPRB, 0.25861760E-06_JPRB, 0.25708417E-06_JPRB, 0.25564870E-06_JPRB, 0.25418649E-06_JPRB, 0.25276987E-06_JPRB, &
  & 0.25148765E-06_JPRB, 0.25056423E-06_JPRB, 0.25021265E-06_JPRB, 0.25059424E-06_JPRB, 0.25180557E-06_JPRB, 0.25384591E-06_JPRB, &
  & 0.25661876E-06_JPRB, 0.25994711E-06_JPRB, 0.26360289E-06_JPRB, 0.26734000E-06_JPRB, 0.27095132E-06_JPRB, 0.27431003E-06_JPRB, &
  & 0.27738346E-06_JPRB, 0.28019377E-06_JPRB, 0.28281389E-06_JPRB, 0.28533501E-06_JPRB, 0.28784186E-06_JPRB, 0.29039484E-06_JPRB, &
  & 0.29300620E-06_JPRB, 0.29556554E-06_JPRB, 0.29790559E-06_JPRB, 0.29982510E-06_JPRB, 0.30120779E-06_JPRB, 0.30201559E-06_JPRB, &
  & 0.30227241E-06_JPRB, 0.30204507E-06_JPRB, 0.30143076E-06_JPRB, 0.30058175E-06_JPRB, 0.29964070E-06_JPRB, 0.29880434E-06_JPRB, &
  & 0.29816937E-06_JPRB, 0.29779144E-06_JPRB, 0.29769643E-06_JPRB, 0.29777138E-06_JPRB, 0.29792807E-06_JPRB, 0.29807146E-06_JPRB, &
  & 0.29810988E-06_JPRB, 0.29796507E-06_JPRB, 0.29759008E-06_JPRB, 0.29696628E-06_JPRB, 0.29608555E-06_JPRB, 0.29497249E-06_JPRB, &
  & 0.29367121E-06_JPRB, 0.29223136E-06_JPRB, 0.29070173E-06_JPRB, 0.28913792E-06_JPRB, 0.28759541E-06_JPRB, 0.28612558E-06_JPRB, &
  & 0.28476225E-06_JPRB, 0.28352758E-06_JPRB, 0.28243437E-06_JPRB, 0.28149097E-06_JPRB, 0.28070622E-06_JPRB, 0.28008299E-06_JPRB, &
  & 0.27962321E-06_JPRB, 0.27931725E-06_JPRB, 0.27916002E-06_JPRB, 0.27918904E-06_JPRB /)

RGHG3(:,24, 8) = (/ &
  & 0.26674149E-06_JPRB, 0.26465318E-06_JPRB, 0.26324145E-06_JPRB, 0.26192495E-06_JPRB, 0.26059956E-06_JPRB, 0.25926863E-06_JPRB, &
  & 0.25806037E-06_JPRB, 0.25715423E-06_JPRB, 0.25673830E-06_JPRB, 0.25696454E-06_JPRB, 0.25791127E-06_JPRB, 0.25957257E-06_JPRB, &
  & 0.26186908E-06_JPRB, 0.26466188E-06_JPRB, 0.26776900E-06_JPRB, 0.27099873E-06_JPRB, 0.27418250E-06_JPRB, 0.27720543E-06_JPRB, &
  & 0.28002248E-06_JPRB, 0.28265507E-06_JPRB, 0.28514745E-06_JPRB, 0.28756818E-06_JPRB, 0.28998647E-06_JPRB, 0.29244961E-06_JPRB, &
  & 0.29495922E-06_JPRB, 0.29743632E-06_JPRB, 0.29971770E-06_JPRB, 0.30164802E-06_JPRB, 0.30310824E-06_JPRB, 0.30407756E-06_JPRB, &
  & 0.30458403E-06_JPRB, 0.30467911E-06_JPRB, 0.30444917E-06_JPRB, 0.30399690E-06_JPRB, 0.30344523E-06_JPRB, 0.30289857E-06_JPRB, &
  & 0.30244095E-06_JPRB, 0.30211351E-06_JPRB, 0.30190071E-06_JPRB, 0.30178279E-06_JPRB, 0.30168562E-06_JPRB, 0.30157184E-06_JPRB, &
  & 0.30136317E-06_JPRB, 0.30102916E-06_JPRB, 0.30051186E-06_JPRB, 0.29979557E-06_JPRB, 0.29888301E-06_JPRB, 0.29779468E-06_JPRB, &
  & 0.29656155E-06_JPRB, 0.29521857E-06_JPRB, 0.29381050E-06_JPRB, 0.29238385E-06_JPRB, 0.29098780E-06_JPRB, 0.28965755E-06_JPRB, &
  & 0.28841771E-06_JPRB, 0.28728380E-06_JPRB, 0.28626545E-06_JPRB, 0.28537019E-06_JPRB, 0.28460551E-06_JPRB, 0.28397852E-06_JPRB, &
  & 0.28349271E-06_JPRB, 0.28314361E-06_JPRB, 0.28291967E-06_JPRB, 0.28280658E-06_JPRB /)

RGHG3(:,25, 8) = (/ &
  & 0.27174971E-06_JPRB, 0.26986930E-06_JPRB, 0.26863518E-06_JPRB, 0.26745283E-06_JPRB, 0.26626114E-06_JPRB, 0.26504958E-06_JPRB, &
  & 0.26393235E-06_JPRB, 0.26306157E-06_JPRB, 0.26261520E-06_JPRB, 0.26272824E-06_JPRB, 0.26346893E-06_JPRB, 0.26483175E-06_JPRB, &
  & 0.26675394E-06_JPRB, 0.26912403E-06_JPRB, 0.27180323E-06_JPRB, 0.27463454E-06_JPRB, 0.27747865E-06_JPRB, 0.28023220E-06_JPRB, &
  & 0.28284637E-06_JPRB, 0.28532185E-06_JPRB, 0.28769142E-06_JPRB, 0.29000404E-06_JPRB, 0.29230466E-06_JPRB, 0.29463192E-06_JPRB, &
  & 0.29697358E-06_JPRB, 0.29926389E-06_JPRB, 0.30139068E-06_JPRB, 0.30322795E-06_JPRB, 0.30471557E-06_JPRB, 0.30580989E-06_JPRB, &
  & 0.30652063E-06_JPRB, 0.30689202E-06_JPRB, 0.30699266E-06_JPRB, 0.30689390E-06_JPRB, 0.30667240E-06_JPRB, 0.30639049E-06_JPRB, &
  & 0.30609655E-06_JPRB, 0.30581717E-06_JPRB, 0.30552437E-06_JPRB, 0.30525104E-06_JPRB, 0.30493834E-06_JPRB, 0.30458523E-06_JPRB, &
  & 0.30414284E-06_JPRB, 0.30360243E-06_JPRB, 0.30293012E-06_JPRB, 0.30210927E-06_JPRB, 0.30113668E-06_JPRB, 0.30003986E-06_JPRB, &
  & 0.29885314E-06_JPRB, 0.29760295E-06_JPRB, 0.29631684E-06_JPRB, 0.29503090E-06_JPRB, 0.29377728E-06_JPRB, 0.29258462E-06_JPRB, &
  & 0.29146750E-06_JPRB, 0.29043747E-06_JPRB, 0.28950063E-06_JPRB, 0.28866341E-06_JPRB, 0.28793391E-06_JPRB, 0.28731895E-06_JPRB, &
  & 0.28682433E-06_JPRB, 0.28644558E-06_JPRB, 0.28616694E-06_JPRB, 0.28594260E-06_JPRB /)

RGHG3(:,26, 8) = (/ &
  & 0.27605353E-06_JPRB, 0.27446686E-06_JPRB, 0.27339101E-06_JPRB, 0.27240418E-06_JPRB, 0.27135516E-06_JPRB, 0.27031498E-06_JPRB, &
  & 0.26932065E-06_JPRB, 0.26853471E-06_JPRB, 0.26810696E-06_JPRB, 0.26816377E-06_JPRB, 0.26876887E-06_JPRB, 0.26992649E-06_JPRB, &
  & 0.27158438E-06_JPRB, 0.27365795E-06_JPRB, 0.27603281E-06_JPRB, 0.27858067E-06_JPRB, 0.28117441E-06_JPRB, 0.28371736E-06_JPRB, &
  & 0.28615202E-06_JPRB, 0.28847057E-06_JPRB, 0.29068497E-06_JPRB, 0.29283078E-06_JPRB, 0.29494043E-06_JPRB, 0.29704589E-06_JPRB, &
  & 0.29913426E-06_JPRB, 0.30116564E-06_JPRB, 0.30307484E-06_JPRB, 0.30477483E-06_JPRB, 0.30619233E-06_JPRB, 0.30731212E-06_JPRB, &
  & 0.30814405E-06_JPRB, 0.30871158E-06_JPRB, 0.30905400E-06_JPRB, 0.30921530E-06_JPRB, 0.30923786E-06_JPRB, 0.30915220E-06_JPRB, &
  & 0.30897840E-06_JPRB, 0.30873255E-06_JPRB, 0.30840363E-06_JPRB, 0.30801144E-06_JPRB, 0.30754450E-06_JPRB, 0.30700789E-06_JPRB, &
  & 0.30639333E-06_JPRB, 0.30569052E-06_JPRB, 0.30488877E-06_JPRB, 0.30398357E-06_JPRB, 0.30298528E-06_JPRB, 0.30190895E-06_JPRB, &
  & 0.30077558E-06_JPRB, 0.29960725E-06_JPRB, 0.29842840E-06_JPRB, 0.29726468E-06_JPRB, 0.29614085E-06_JPRB, 0.29507322E-06_JPRB, &
  & 0.29407016E-06_JPRB, 0.29313745E-06_JPRB, 0.29227951E-06_JPRB, 0.29150297E-06_JPRB, 0.29081534E-06_JPRB, 0.29022385E-06_JPRB, &
  & 0.28973443E-06_JPRB, 0.28934255E-06_JPRB, 0.28902670E-06_JPRB, 0.28870389E-06_JPRB /)

RGHG3(:,27, 8) = (/ &
  & 0.27986209E-06_JPRB, 0.27855984E-06_JPRB, 0.27769988E-06_JPRB, 0.27686076E-06_JPRB, 0.27603812E-06_JPRB, 0.27516182E-06_JPRB, &
  & 0.27434609E-06_JPRB, 0.27368625E-06_JPRB, 0.27333257E-06_JPRB, 0.27339610E-06_JPRB, 0.27394162E-06_JPRB, 0.27497771E-06_JPRB, &
  & 0.27647121E-06_JPRB, 0.27834906E-06_JPRB, 0.28051792E-06_JPRB, 0.28286215E-06_JPRB, 0.28526529E-06_JPRB, 0.28762469E-06_JPRB, &
  & 0.28988575E-06_JPRB, 0.29201559E-06_JPRB, 0.29402884E-06_JPRB, 0.29594449E-06_JPRB, 0.29779028E-06_JPRB, 0.29960052E-06_JPRB, &
  & 0.30136459E-06_JPRB, 0.30307217E-06_JPRB, 0.30468067E-06_JPRB, 0.30615792E-06_JPRB, 0.30747717E-06_JPRB, 0.30859403E-06_JPRB, &
  & 0.30949238E-06_JPRB, 0.31017942E-06_JPRB, 0.31067339E-06_JPRB, 0.31099518E-06_JPRB, 0.31116531E-06_JPRB, 0.31119595E-06_JPRB, &
  & 0.31109514E-06_JPRB, 0.31087106E-06_JPRB, 0.31052664E-06_JPRB, 0.31006775E-06_JPRB, 0.30951318E-06_JPRB, 0.30886486E-06_JPRB, &
  & 0.30814053E-06_JPRB, 0.30733327E-06_JPRB, 0.30644773E-06_JPRB, 0.30548375E-06_JPRB, 0.30446537E-06_JPRB, 0.30341613E-06_JPRB, &
  & 0.30235537E-06_JPRB, 0.30128814E-06_JPRB, 0.30022474E-06_JPRB, 0.29918499E-06_JPRB, 0.29818446E-06_JPRB, 0.29723341E-06_JPRB, &
  & 0.29633523E-06_JPRB, 0.29549398E-06_JPRB, 0.29471386E-06_JPRB, 0.29400047E-06_JPRB, 0.29336067E-06_JPRB, 0.29280102E-06_JPRB, &
  & 0.29232737E-06_JPRB, 0.29193410E-06_JPRB, 0.29159685E-06_JPRB, 0.29119568E-06_JPRB /)

RGHG3(:,28, 8) = (/ &
  & 0.28334071E-06_JPRB, 0.28230670E-06_JPRB, 0.28160903E-06_JPRB, 0.28098441E-06_JPRB, 0.28031153E-06_JPRB, 0.27965265E-06_JPRB, &
  & 0.27901089E-06_JPRB, 0.27851343E-06_JPRB, 0.27827465E-06_JPRB, 0.27839843E-06_JPRB, 0.27894365E-06_JPRB, 0.27992806E-06_JPRB, &
  & 0.28132223E-06_JPRB, 0.28306980E-06_JPRB, 0.28508427E-06_JPRB, 0.28726413E-06_JPRB, 0.28949131E-06_JPRB, 0.29167393E-06_JPRB, &
  & 0.29374235E-06_JPRB, 0.29566365E-06_JPRB, 0.29744601E-06_JPRB, 0.29909225E-06_JPRB, 0.30065397E-06_JPRB, 0.30213988E-06_JPRB, &
  & 0.30356787E-06_JPRB, 0.30494385E-06_JPRB, 0.30626515E-06_JPRB, 0.30751846E-06_JPRB, 0.30868569E-06_JPRB, 0.30973115E-06_JPRB, &
  & 0.31063090E-06_JPRB, 0.31136756E-06_JPRB, 0.31193585E-06_JPRB, 0.31233884E-06_JPRB, 0.31258170E-06_JPRB, 0.31266811E-06_JPRB, &
  & 0.31260240E-06_JPRB, 0.31238923E-06_JPRB, 0.31203894E-06_JPRB, 0.31155392E-06_JPRB, 0.31095516E-06_JPRB, 0.31025587E-06_JPRB, &
  & 0.30947336E-06_JPRB, 0.30861730E-06_JPRB, 0.30769564E-06_JPRB, 0.30672621E-06_JPRB, 0.30573162E-06_JPRB, 0.30473757E-06_JPRB, &
  & 0.30375207E-06_JPRB, 0.30277934E-06_JPRB, 0.30182312E-06_JPRB, 0.30089419E-06_JPRB, 0.30000268E-06_JPRB, 0.29915407E-06_JPRB, &
  & 0.29835005E-06_JPRB, 0.29759258E-06_JPRB, 0.29688491E-06_JPRB, 0.29623067E-06_JPRB, 0.29563620E-06_JPRB, 0.29510889E-06_JPRB, &
  & 0.29465502E-06_JPRB, 0.29426900E-06_JPRB, 0.29392322E-06_JPRB, 0.29348985E-06_JPRB /)

RGHG3(:,29, 8) = (/ &
  & 0.28655106E-06_JPRB, 0.28574027E-06_JPRB, 0.28521828E-06_JPRB, 0.28471882E-06_JPRB, 0.28424338E-06_JPRB, 0.28373822E-06_JPRB, &
  & 0.28328299E-06_JPRB, 0.28294727E-06_JPRB, 0.28284262E-06_JPRB, 0.28305544E-06_JPRB, 0.28364002E-06_JPRB, 0.28460889E-06_JPRB, &
  & 0.28594283E-06_JPRB, 0.28758694E-06_JPRB, 0.28946718E-06_JPRB, 0.29148615E-06_JPRB, 0.29353836E-06_JPRB, 0.29553163E-06_JPRB, &
  & 0.29740104E-06_JPRB, 0.29910765E-06_JPRB, 0.30065499E-06_JPRB, 0.30204927E-06_JPRB, 0.30333010E-06_JPRB, 0.30451744E-06_JPRB, &
  & 0.30563533E-06_JPRB, 0.30671413E-06_JPRB, 0.30776474E-06_JPRB, 0.30879750E-06_JPRB, 0.30980132E-06_JPRB, 0.31075410E-06_JPRB, &
  & 0.31161193E-06_JPRB, 0.31234654E-06_JPRB, 0.31293541E-06_JPRB, 0.31336532E-06_JPRB, 0.31363265E-06_JPRB, 0.31373705E-06_JPRB, &
  & 0.31368253E-06_JPRB, 0.31347332E-06_JPRB, 0.31312177E-06_JPRB, 0.31263323E-06_JPRB, 0.31202137E-06_JPRB, 0.31130674E-06_JPRB, &
  & 0.31050612E-06_JPRB, 0.30963781E-06_JPRB, 0.30871871E-06_JPRB, 0.30777377E-06_JPRB, 0.30683023E-06_JPRB, 0.30590658E-06_JPRB, &
  & 0.30500911E-06_JPRB, 0.30413230E-06_JPRB, 0.30327664E-06_JPRB, 0.30244740E-06_JPRB, 0.30165305E-06_JPRB, 0.30089569E-06_JPRB, &
  & 0.30017534E-06_JPRB, 0.29949308E-06_JPRB, 0.29885035E-06_JPRB, 0.29825188E-06_JPRB, 0.29770447E-06_JPRB, 0.29721701E-06_JPRB, &
  & 0.29679367E-06_JPRB, 0.29642734E-06_JPRB, 0.29608836E-06_JPRB, 0.29561014E-06_JPRB /)

RGHG3(:,30, 8) = (/ &
  & 0.28948941E-06_JPRB, 0.28886757E-06_JPRB, 0.28846446E-06_JPRB, 0.28811391E-06_JPRB, 0.28775145E-06_JPRB, 0.28741005E-06_JPRB, &
  & 0.28710437E-06_JPRB, 0.28692227E-06_JPRB, 0.28694910E-06_JPRB, 0.28725893E-06_JPRB, 0.28789330E-06_JPRB, 0.28886484E-06_JPRB, &
  & 0.29014862E-06_JPRB, 0.29169885E-06_JPRB, 0.29344520E-06_JPRB, 0.29530221E-06_JPRB, 0.29717091E-06_JPRB, 0.29897626E-06_JPRB, &
  & 0.30064925E-06_JPRB, 0.30215449E-06_JPRB, 0.30348966E-06_JPRB, 0.30466396E-06_JPRB, 0.30570254E-06_JPRB, 0.30663972E-06_JPRB, &
  & 0.30750701E-06_JPRB, 0.30833786E-06_JPRB, 0.30916431E-06_JPRB, 0.31000209E-06_JPRB, 0.31085182E-06_JPRB, 0.31168946E-06_JPRB, &
  & 0.31248044E-06_JPRB, 0.31318007E-06_JPRB, 0.31375225E-06_JPRB, 0.31417511E-06_JPRB, 0.31443784E-06_JPRB, 0.31453919E-06_JPRB, &
  & 0.31448386E-06_JPRB, 0.31427720E-06_JPRB, 0.31392850E-06_JPRB, 0.31345022E-06_JPRB, 0.31284642E-06_JPRB, 0.31214009E-06_JPRB, &
  & 0.31135102E-06_JPRB, 0.31050197E-06_JPRB, 0.30961817E-06_JPRB, 0.30872394E-06_JPRB, 0.30784565E-06_JPRB, 0.30699931E-06_JPRB, &
  & 0.30618583E-06_JPRB, 0.30539690E-06_JPRB, 0.30463116E-06_JPRB, 0.30389083E-06_JPRB, 0.30317952E-06_JPRB, 0.30249979E-06_JPRB, &
  & 0.30185032E-06_JPRB, 0.30123056E-06_JPRB, 0.30064453E-06_JPRB, 0.30009704E-06_JPRB, 0.29959497E-06_JPRB, 0.29914548E-06_JPRB, &
  & 0.29875167E-06_JPRB, 0.29840496E-06_JPRB, 0.29807035E-06_JPRB, 0.29760082E-06_JPRB /)

RGHG3(:,31, 8) = (/ &
  & 0.29213447E-06_JPRB, 0.29166574E-06_JPRB, 0.29137084E-06_JPRB, 0.29110495E-06_JPRB, 0.29086470E-06_JPRB, 0.29063474E-06_JPRB, &
  & 0.29046444E-06_JPRB, 0.29041448E-06_JPRB, 0.29055917E-06_JPRB, 0.29095676E-06_JPRB, 0.29163968E-06_JPRB, 0.29260877E-06_JPRB, &
  & 0.29384398E-06_JPRB, 0.29529718E-06_JPRB, 0.29690881E-06_JPRB, 0.29860101E-06_JPRB, 0.30029383E-06_JPRB, 0.30191407E-06_JPRB, &
  & 0.30340965E-06_JPRB, 0.30473970E-06_JPRB, 0.30589749E-06_JPRB, 0.30689139E-06_JPRB, 0.30774351E-06_JPRB, 0.30848832E-06_JPRB, &
  & 0.30916348E-06_JPRB, 0.30980681E-06_JPRB, 0.31045261E-06_JPRB, 0.31112785E-06_JPRB, 0.31183848E-06_JPRB, 0.31256565E-06_JPRB, &
  & 0.31327517E-06_JPRB, 0.31391642E-06_JPRB, 0.31444895E-06_JPRB, 0.31484154E-06_JPRB, 0.31508247E-06_JPRB, 0.31516959E-06_JPRB, &
  & 0.31510896E-06_JPRB, 0.31490677E-06_JPRB, 0.31457117E-06_JPRB, 0.31410875E-06_JPRB, 0.31353309E-06_JPRB, 0.31285322E-06_JPRB, &
  & 0.31209697E-06_JPRB, 0.31129017E-06_JPRB, 0.31045718E-06_JPRB, 0.30962613E-06_JPRB, 0.30882089E-06_JPRB, 0.30805296E-06_JPRB, &
  & 0.30731726E-06_JPRB, 0.30660630E-06_JPRB, 0.30591653E-06_JPRB, 0.30524936E-06_JPRB, 0.30460490E-06_JPRB, 0.30398797E-06_JPRB, &
  & 0.30339623E-06_JPRB, 0.30282945E-06_JPRB, 0.30229336E-06_JPRB, 0.30179115E-06_JPRB, 0.30132929E-06_JPRB, 0.30091422E-06_JPRB, &
  & 0.30054906E-06_JPRB, 0.30022557E-06_JPRB, 0.29991290E-06_JPRB, 0.29944806E-06_JPRB /)

RGHG3(:,32, 8) = (/ &
  & 0.29446679E-06_JPRB, 0.29411939E-06_JPRB, 0.29390793E-06_JPRB, 0.29373217E-06_JPRB, 0.29357204E-06_JPRB, 0.29344622E-06_JPRB, &
  & 0.29338435E-06_JPRB, 0.29344588E-06_JPRB, 0.29369031E-06_JPRB, 0.29416043E-06_JPRB, 0.29487489E-06_JPRB, 0.29583379E-06_JPRB, &
  & 0.29700968E-06_JPRB, 0.29836383E-06_JPRB, 0.29983963E-06_JPRB, 0.30137502E-06_JPRB, 0.30290045E-06_JPRB, 0.30435740E-06_JPRB, &
  & 0.30569410E-06_JPRB, 0.30687994E-06_JPRB, 0.30790059E-06_JPRB, 0.30875884E-06_JPRB, 0.30947703E-06_JPRB, 0.31008494E-06_JPRB, &
  & 0.31062368E-06_JPRB, 0.31113143E-06_JPRB, 0.31164558E-06_JPRB, 0.31219287E-06_JPRB, 0.31278176E-06_JPRB, 0.31340261E-06_JPRB, &
  & 0.31402109E-06_JPRB, 0.31459101E-06_JPRB, 0.31506556E-06_JPRB, 0.31541305E-06_JPRB, 0.31562121E-06_JPRB, 0.31568814E-06_JPRB, &
  & 0.31562195E-06_JPRB, 0.31542874E-06_JPRB, 0.31511297E-06_JPRB, 0.31468198E-06_JPRB, 0.31414044E-06_JPRB, 0.31350817E-06_JPRB, &
  & 0.31280391E-06_JPRB, 0.31205252E-06_JPRB, 0.31128641E-06_JPRB, 0.31052497E-06_JPRB, 0.30979152E-06_JPRB, 0.30909041E-06_JPRB, &
  & 0.30842170E-06_JPRB, 0.30777429E-06_JPRB, 0.30714355E-06_JPRB, 0.30653396E-06_JPRB, 0.30594373E-06_JPRB, 0.30537529E-06_JPRB, &
  & 0.30483076E-06_JPRB, 0.30431087E-06_JPRB, 0.30381864E-06_JPRB, 0.30335764E-06_JPRB, 0.30293350E-06_JPRB, 0.30255256E-06_JPRB, &
  & 0.30221781E-06_JPRB, 0.30192027E-06_JPRB, 0.30162559E-06_JPRB, 0.30117616E-06_JPRB /)

RGHG3(:,33, 8) = (/ &
  & 0.29651346E-06_JPRB, 0.29627302E-06_JPRB, 0.29613125E-06_JPRB, 0.29601878E-06_JPRB, 0.29593409E-06_JPRB, 0.29588807E-06_JPRB, &
  & 0.29591661E-06_JPRB, 0.29607003E-06_JPRB, 0.29639193E-06_JPRB, 0.29691270E-06_JPRB, 0.29764368E-06_JPRB, 0.29857441E-06_JPRB, &
  & 0.29968498E-06_JPRB, 0.30093540E-06_JPRB, 0.30228253E-06_JPRB, 0.30366976E-06_JPRB, 0.30504822E-06_JPRB, 0.30636110E-06_JPRB, &
  & 0.30756897E-06_JPRB, 0.30863927E-06_JPRB, 0.30955715E-06_JPRB, 0.31032388E-06_JPRB, 0.31094925E-06_JPRB, 0.31146763E-06_JPRB, &
  & 0.31191522E-06_JPRB, 0.31233066E-06_JPRB, 0.31274823E-06_JPRB, 0.31319513E-06_JPRB, 0.31368367E-06_JPRB, 0.31420572E-06_JPRB, &
  & 0.31473348E-06_JPRB, 0.31522094E-06_JPRB, 0.31562632E-06_JPRB, 0.31591804E-06_JPRB, 0.31608658E-06_JPRB, 0.31613104E-06_JPRB, &
  & 0.31606100E-06_JPRB, 0.31587999E-06_JPRB, 0.31559284E-06_JPRB, 0.31520034E-06_JPRB, 0.31470987E-06_JPRB, 0.31413217E-06_JPRB, &
  & 0.31349376E-06_JPRB, 0.31281726E-06_JPRB, 0.31211587E-06_JPRB, 0.31142889E-06_JPRB, 0.31075663E-06_JPRB, 0.31011638E-06_JPRB, &
  & 0.30949855E-06_JPRB, 0.30890325E-06_JPRB, 0.30831822E-06_JPRB, 0.30775044E-06_JPRB, 0.30720156E-06_JPRB, 0.30667283E-06_JPRB, &
  & 0.30616764E-06_JPRB, 0.30568702E-06_JPRB, 0.30523276E-06_JPRB, 0.30480737E-06_JPRB, 0.30441663E-06_JPRB, 0.30406554E-06_JPRB, &
  & 0.30375679E-06_JPRB, 0.30348033E-06_JPRB, 0.30320416E-06_JPRB, 0.30277909E-06_JPRB /)

RGHG3(:,34, 8) = (/ &
  & 0.29832921E-06_JPRB, 0.29816624E-06_JPRB, 0.29808112E-06_JPRB, 0.29802479E-06_JPRB, 0.29799816E-06_JPRB, 0.29801856E-06_JPRB, &
  & 0.29811974E-06_JPRB, 0.29834217E-06_JPRB, 0.29872047E-06_JPRB, 0.29927244E-06_JPRB, 0.29999865E-06_JPRB, 0.30089268E-06_JPRB, &
  & 0.30192899E-06_JPRB, 0.30307953E-06_JPRB, 0.30430422E-06_JPRB, 0.30556237E-06_JPRB, 0.30680710E-06_JPRB, 0.30800260E-06_JPRB, &
  & 0.30910601E-06_JPRB, 0.31009165E-06_JPRB, 0.31093970E-06_JPRB, 0.31163879E-06_JPRB, 0.31220966E-06_JPRB, 0.31267513E-06_JPRB, &
  & 0.31306837E-06_JPRB, 0.31342364E-06_JPRB, 0.31377456E-06_JPRB, 0.31414504E-06_JPRB, 0.31454735E-06_JPRB, 0.31497842E-06_JPRB, &
  & 0.31541245E-06_JPRB, 0.31581285E-06_JPRB, 0.31614087E-06_JPRB, 0.31637114E-06_JPRB, 0.31649714E-06_JPRB, 0.31651899E-06_JPRB, &
  & 0.31644689E-06_JPRB, 0.31628133E-06_JPRB, 0.31602639E-06_JPRB, 0.31568149E-06_JPRB, 0.31524729E-06_JPRB, 0.31473652E-06_JPRB, &
  & 0.31417125E-06_JPRB, 0.31357285E-06_JPRB, 0.31294920E-06_JPRB, 0.31232037E-06_JPRB, 0.31170941E-06_JPRB, 0.31111605E-06_JPRB, &
  & 0.31053818E-06_JPRB, 0.30997947E-06_JPRB, 0.30943147E-06_JPRB, 0.30889339E-06_JPRB, 0.30837700E-06_JPRB, 0.30788044E-06_JPRB, &
  & 0.30740730E-06_JPRB, 0.30696026E-06_JPRB, 0.30653868E-06_JPRB, 0.30614521E-06_JPRB, 0.30578363E-06_JPRB, 0.30545954E-06_JPRB, &
  & 0.30517475E-06_JPRB, 0.30492063E-06_JPRB, 0.30466532E-06_JPRB, 0.30426148E-06_JPRB /)

RGHG3(:,35, 8) = (/ &
  & 0.29991307E-06_JPRB, 0.29984076E-06_JPRB, 0.29980475E-06_JPRB, 0.29979444E-06_JPRB, 0.29981621E-06_JPRB, 0.29988962E-06_JPRB, &
  & 0.30004475E-06_JPRB, 0.30031734E-06_JPRB, 0.30073068E-06_JPRB, 0.30129272E-06_JPRB, 0.30200420E-06_JPRB, 0.30284878E-06_JPRB, &
  & 0.30381278E-06_JPRB, 0.30486535E-06_JPRB, 0.30598105E-06_JPRB, 0.30712084E-06_JPRB, 0.30825544E-06_JPRB, 0.30934785E-06_JPRB, &
  & 0.31036717E-06_JPRB, 0.31128749E-06_JPRB, 0.31208398E-06_JPRB, 0.31275144E-06_JPRB, 0.31329827E-06_JPRB, 0.31373892E-06_JPRB, &
  & 0.31410372E-06_JPRB, 0.31442286E-06_JPRB, 0.31472561E-06_JPRB, 0.31503512E-06_JPRB, 0.31536297E-06_JPRB, 0.31570687E-06_JPRB, &
  & 0.31604901E-06_JPRB, 0.31635841E-06_JPRB, 0.31660687E-06_JPRB, 0.31677484E-06_JPRB, 0.31685906E-06_JPRB, 0.31686119E-06_JPRB, &
  & 0.31678883E-06_JPRB, 0.31664158E-06_JPRB, 0.31642296E-06_JPRB, 0.31612589E-06_JPRB, 0.31575377E-06_JPRB, 0.31531368E-06_JPRB, &
  & 0.31482443E-06_JPRB, 0.31430642E-06_JPRB, 0.31375330E-06_JPRB, 0.31318368E-06_JPRB, 0.31262181E-06_JPRB, 0.31206898E-06_JPRB, &
  & 0.31152217E-06_JPRB, 0.31098961E-06_JPRB, 0.31046955E-06_JPRB, 0.30995508E-06_JPRB, 0.30946231E-06_JPRB, 0.30899281E-06_JPRB, &
  & 0.30854778E-06_JPRB, 0.30813015E-06_JPRB, 0.30773859E-06_JPRB, 0.30737402E-06_JPRB, 0.30703964E-06_JPRB, 0.30674022E-06_JPRB, &
  & 0.30647752E-06_JPRB, 0.30624210E-06_JPRB, 0.30600330E-06_JPRB, 0.30562359E-06_JPRB /)

RGHG3(:,36, 8) = (/ &
  & 0.30134802E-06_JPRB, 0.30133788E-06_JPRB, 0.30134444E-06_JPRB, 0.30137275E-06_JPRB, 0.30143428E-06_JPRB, 0.30154808E-06_JPRB, &
  & 0.30174277E-06_JPRB, 0.30204652E-06_JPRB, 0.30247568E-06_JPRB, 0.30303568E-06_JPRB, 0.30371712E-06_JPRB, 0.30451173E-06_JPRB, &
  & 0.30540005E-06_JPRB, 0.30636363E-06_JPRB, 0.30737652E-06_JPRB, 0.30841568E-06_JPRB, 0.30944977E-06_JPRB, 0.31045792E-06_JPRB, &
  & 0.31141110E-06_JPRB, 0.31228086E-06_JPRB, 0.31305049E-06_JPRB, 0.31370439E-06_JPRB, 0.31424145E-06_JPRB, 0.31467400E-06_JPRB, &
  & 0.31502216E-06_JPRB, 0.31531599E-06_JPRB, 0.31558085E-06_JPRB, 0.31583716E-06_JPRB, 0.31609636E-06_JPRB, 0.31635858E-06_JPRB, &
  & 0.31661114E-06_JPRB, 0.31683405E-06_JPRB, 0.31700705E-06_JPRB, 0.31711861E-06_JPRB, 0.31716735E-06_JPRB, 0.31715561E-06_JPRB, &
  & 0.31708745E-06_JPRB, 0.31696280E-06_JPRB, 0.31678047E-06_JPRB, 0.31653431E-06_JPRB, 0.31622287E-06_JPRB, 0.31585341E-06_JPRB, &
  & 0.31544053E-06_JPRB, 0.31498928E-06_JPRB, 0.31450253E-06_JPRB, 0.31399045E-06_JPRB, 0.31347290E-06_JPRB, 0.31295266E-06_JPRB, &
  & 0.31243135E-06_JPRB, 0.31192101E-06_JPRB, 0.31141957E-06_JPRB, 0.31092569E-06_JPRB, 0.31045420E-06_JPRB, 0.31000872E-06_JPRB, &
  & 0.30959026E-06_JPRB, 0.30920060E-06_JPRB, 0.30883737E-06_JPRB, 0.30849986E-06_JPRB, 0.30819066E-06_JPRB, 0.30791423E-06_JPRB, &
  & 0.30767171E-06_JPRB, 0.30745446E-06_JPRB, 0.30723234E-06_JPRB, 0.30687480E-06_JPRB /)

RGHG3(:,37, 8) = (/ &
  & 0.30264778E-06_JPRB, 0.30269598E-06_JPRB, 0.30273972E-06_JPRB, 0.30280134E-06_JPRB, 0.30289496E-06_JPRB, 0.30304065E-06_JPRB, &
  & 0.30326240E-06_JPRB, 0.30358228E-06_JPRB, 0.30401361E-06_JPRB, 0.30455521E-06_JPRB, 0.30520204E-06_JPRB, 0.30593867E-06_JPRB, &
  & 0.30675454E-06_JPRB, 0.30763101E-06_JPRB, 0.30855225E-06_JPRB, 0.30949622E-06_JPRB, 0.31044627E-06_JPRB, 0.31137697E-06_JPRB, &
  & 0.31227444E-06_JPRB, 0.31311231E-06_JPRB, 0.31386281E-06_JPRB, 0.31450907E-06_JPRB, 0.31503905E-06_JPRB, 0.31545750E-06_JPRB, &
  & 0.31578637E-06_JPRB, 0.31604955E-06_JPRB, 0.31627471E-06_JPRB, 0.31648096E-06_JPRB, 0.31667855E-06_JPRB, 0.31686923E-06_JPRB, &
  & 0.31704636E-06_JPRB, 0.31719711E-06_JPRB, 0.31731005E-06_JPRB, 0.31737883E-06_JPRB, 0.31740345E-06_JPRB, 0.31738597E-06_JPRB, &
  & 0.31732822E-06_JPRB, 0.31722936E-06_JPRB, 0.31708603E-06_JPRB, 0.31689103E-06_JPRB, 0.31664143E-06_JPRB, 0.31634067E-06_JPRB, &
  & 0.31599404E-06_JPRB, 0.31560509E-06_JPRB, 0.31517970E-06_JPRB, 0.31472291E-06_JPRB, 0.31424514E-06_JPRB, 0.31375339E-06_JPRB, &
  & 0.31325717E-06_JPRB, 0.31276500E-06_JPRB, 0.31227901E-06_JPRB, 0.31180457E-06_JPRB, 0.31135417E-06_JPRB, 0.31093236E-06_JPRB, &
  & 0.31054026E-06_JPRB, 0.31017808E-06_JPRB, 0.30984179E-06_JPRB, 0.30952995E-06_JPRB, 0.30924494E-06_JPRB, 0.30899062E-06_JPRB, &
  & 0.30876780E-06_JPRB, 0.30856711E-06_JPRB, 0.30836119E-06_JPRB, 0.30802607E-06_JPRB /)

RGHG3(:,38, 8) = (/ &
  & 0.30384774E-06_JPRB, 0.30394767E-06_JPRB, 0.30402310E-06_JPRB, 0.30411272E-06_JPRB, 0.30423482E-06_JPRB, 0.30440546E-06_JPRB, &
  & 0.30464477E-06_JPRB, 0.30497017E-06_JPRB, 0.30538928E-06_JPRB, 0.30590371E-06_JPRB, 0.30650531E-06_JPRB, 0.30718266E-06_JPRB, &
  & 0.30792378E-06_JPRB, 0.30871740E-06_JPRB, 0.30955027E-06_JPRB, 0.31040926E-06_JPRB, 0.31127902E-06_JPRB, 0.31214640E-06_JPRB, &
  & 0.31299155E-06_JPRB, 0.31379341E-06_JPRB, 0.31452515E-06_JPRB, 0.31515228E-06_JPRB, 0.31565889E-06_JPRB, 0.31604901E-06_JPRB, &
  & 0.31634050E-06_JPRB, 0.31656623E-06_JPRB, 0.31675091E-06_JPRB, 0.31691309E-06_JPRB, 0.31706250E-06_JPRB, 0.31720120E-06_JPRB, &
  & 0.31732566E-06_JPRB, 0.31742837E-06_JPRB, 0.31750241E-06_JPRB, 0.31754479E-06_JPRB, 0.31755624E-06_JPRB, 0.31753896E-06_JPRB, &
  & 0.31749343E-06_JPRB, 0.31741928E-06_JPRB, 0.31731219E-06_JPRB, 0.31716618E-06_JPRB, 0.31697584E-06_JPRB, 0.31674128E-06_JPRB, &
  & 0.31645808E-06_JPRB, 0.31613342E-06_JPRB, 0.31576715E-06_JPRB, 0.31536177E-06_JPRB, 0.31492348E-06_JPRB, 0.31446322E-06_JPRB, &
  & 0.31399102E-06_JPRB, 0.31351721E-06_JPRB, 0.31304771E-06_JPRB, 0.31259378E-06_JPRB, 0.31216578E-06_JPRB, 0.31176870E-06_JPRB, &
  & 0.31140360E-06_JPRB, 0.31106833E-06_JPRB, 0.31075854E-06_JPRB, 0.31047171E-06_JPRB, 0.31021020E-06_JPRB, 0.30997774E-06_JPRB, &
  & 0.30977438E-06_JPRB, 0.30959049E-06_JPRB, 0.30939998E-06_JPRB, 0.30908831E-06_JPRB /)

RGHG3(:,39, 8) = (/ &
  & 0.30497390E-06_JPRB, 0.30511643E-06_JPRB, 0.30521727E-06_JPRB, 0.30533246E-06_JPRB, 0.30547702E-06_JPRB, 0.30566866E-06_JPRB, &
  & 0.30591963E-06_JPRB, 0.30623983E-06_JPRB, 0.30663804E-06_JPRB, 0.30711536E-06_JPRB, 0.30766577E-06_JPRB, 0.30827997E-06_JPRB, &
  & 0.30894753E-06_JPRB, 0.30965936E-06_JPRB, 0.31040830E-06_JPRB, 0.31118483E-06_JPRB, 0.31198036E-06_JPRB, 0.31278398E-06_JPRB, &
  & 0.31357948E-06_JPRB, 0.31434431E-06_JPRB, 0.31503941E-06_JPRB, 0.31563314E-06_JPRB, 0.31609997E-06_JPRB, 0.31644655E-06_JPRB, &
  & 0.31669992E-06_JPRB, 0.31688938E-06_JPRB, 0.31704141E-06_JPRB, 0.31717158E-06_JPRB, 0.31728828E-06_JPRB, 0.31739370E-06_JPRB, &
  & 0.31748630E-06_JPRB, 0.31756068E-06_JPRB, 0.31761260E-06_JPRB, 0.31764046E-06_JPRB, 0.31764549E-06_JPRB, 0.31762946E-06_JPRB, &
  & 0.31759322E-06_JPRB, 0.31753649E-06_JPRB, 0.31745654E-06_JPRB, 0.31734805E-06_JPRB, 0.31720754E-06_JPRB, 0.31703030E-06_JPRB, &
  & 0.31681080E-06_JPRB, 0.31655202E-06_JPRB, 0.31624703E-06_JPRB, 0.31589630E-06_JPRB, 0.31550366E-06_JPRB, 0.31507767E-06_JPRB, &
  & 0.31463247E-06_JPRB, 0.31417827E-06_JPRB, 0.31372858E-06_JPRB, 0.31329662E-06_JPRB, 0.31289272E-06_JPRB, 0.31252196E-06_JPRB, &
  & 0.31218440E-06_JPRB, 0.31187636E-06_JPRB, 0.31159234E-06_JPRB, 0.31133010E-06_JPRB, 0.31109158E-06_JPRB, 0.31088061E-06_JPRB, &
  & 0.31069615E-06_JPRB, 0.31052903E-06_JPRB, 0.31035486E-06_JPRB, 0.31006832E-06_JPRB /)

RGHG3(:,40, 8) = (/ &
  & 0.30604986E-06_JPRB, 0.30622181E-06_JPRB, 0.30634212E-06_JPRB, 0.30647283E-06_JPRB, 0.30663887E-06_JPRB, 0.30684666E-06_JPRB, &
  & 0.30710169E-06_JPRB, 0.30741285E-06_JPRB, 0.30778222E-06_JPRB, 0.30821576E-06_JPRB, 0.30871172E-06_JPRB, 0.30926080E-06_JPRB, &
  & 0.30985541E-06_JPRB, 0.31048873E-06_JPRB, 0.31115633E-06_JPRB, 0.31185380E-06_JPRB, 0.31257639E-06_JPRB, 0.31331558E-06_JPRB, &
  & 0.31405915E-06_JPRB, 0.31477563E-06_JPRB, 0.31543090E-06_JPRB, 0.31597773E-06_JPRB, 0.31640059E-06_JPRB, 0.31670788E-06_JPRB, &
  & 0.31692727E-06_JPRB, 0.31708984E-06_JPRB, 0.31721819E-06_JPRB, 0.31732648E-06_JPRB, 0.31742184E-06_JPRB, 0.31750670E-06_JPRB, &
  & 0.31757983E-06_JPRB, 0.31763787E-06_JPRB, 0.31767718E-06_JPRB, 0.31769704E-06_JPRB, 0.31769864E-06_JPRB, 0.31768386E-06_JPRB, &
  & 0.31765350E-06_JPRB, 0.31760766E-06_JPRB, 0.31754487E-06_JPRB, 0.31746160E-06_JPRB, 0.31735556E-06_JPRB, 0.31722229E-06_JPRB, &
  & 0.31705633E-06_JPRB, 0.31685761E-06_JPRB, 0.31661489E-06_JPRB, 0.31632331E-06_JPRB, 0.31598157E-06_JPRB, 0.31559645E-06_JPRB, &
  & 0.31518107E-06_JPRB, 0.31475159E-06_JPRB, 0.31432489E-06_JPRB, 0.31391716E-06_JPRB, 0.31353946E-06_JPRB, 0.31319618E-06_JPRB, &
  & 0.31288658E-06_JPRB, 0.31260532E-06_JPRB, 0.31234691E-06_JPRB, 0.31210826E-06_JPRB, 0.31189251E-06_JPRB, 0.31170242E-06_JPRB, &
  & 0.31153675E-06_JPRB, 0.31138600E-06_JPRB, 0.31122804E-06_JPRB, 0.31096681E-06_JPRB /)

RGHG3(:,41, 8) = (/ &
  & 0.30709796E-06_JPRB, 0.30728577E-06_JPRB, 0.30740853E-06_JPRB, 0.30755143E-06_JPRB, 0.30772961E-06_JPRB, 0.30794843E-06_JPRB, &
  & 0.30820709E-06_JPRB, 0.30849992E-06_JPRB, 0.30883794E-06_JPRB, 0.30922575E-06_JPRB, 0.30966441E-06_JPRB, 0.31014957E-06_JPRB, &
  & 0.31067361E-06_JPRB, 0.31123156E-06_JPRB, 0.31182137E-06_JPRB, 0.31244207E-06_JPRB, 0.31309176E-06_JPRB, 0.31376740E-06_JPRB, &
  & 0.31445231E-06_JPRB, 0.31512243E-06_JPRB, 0.31572790E-06_JPRB, 0.31623219E-06_JPRB, 0.31661364E-06_JPRB, 0.31688694E-06_JPRB, &
  & 0.31708058E-06_JPRB, 0.31722251E-06_JPRB, 0.31733384E-06_JPRB, 0.31742667E-06_JPRB, 0.31750739E-06_JPRB, 0.31757833E-06_JPRB, &
  & 0.31763940E-06_JPRB, 0.31768704E-06_JPRB, 0.31771901E-06_JPRB, 0.31773408E-06_JPRB, 0.31773388E-06_JPRB, 0.31772004E-06_JPRB, &
  & 0.31769360E-06_JPRB, 0.31765472E-06_JPRB, 0.31760288E-06_JPRB, 0.31753584E-06_JPRB, 0.31745250E-06_JPRB, 0.31734970E-06_JPRB, &
  & 0.31722345E-06_JPRB, 0.31707285E-06_JPRB, 0.31688469E-06_JPRB, 0.31665115E-06_JPRB, 0.31636418E-06_JPRB, 0.31602343E-06_JPRB, &
  & 0.31564520E-06_JPRB, 0.31524382E-06_JPRB, 0.31484350E-06_JPRB, 0.31446174E-06_JPRB, 0.31411054E-06_JPRB, 0.31379528E-06_JPRB, &
  & 0.31351325E-06_JPRB, 0.31325905E-06_JPRB, 0.31302551E-06_JPRB, 0.31281070E-06_JPRB, 0.31261681E-06_JPRB, 0.31244693E-06_JPRB, &
  & 0.31229894E-06_JPRB, 0.31216371E-06_JPRB, 0.31202100E-06_JPRB, 0.31178473E-06_JPRB /)

RGHG3(:,42, 8) = (/ &
  & 0.30817881E-06_JPRB, 0.30832305E-06_JPRB, 0.30843407E-06_JPRB, 0.30857271E-06_JPRB, 0.30875964E-06_JPRB, 0.30898877E-06_JPRB, &
  & 0.30923997E-06_JPRB, 0.30951708E-06_JPRB, 0.30982022E-06_JPRB, 0.31016162E-06_JPRB, 0.31054509E-06_JPRB, 0.31096820E-06_JPRB, &
  & 0.31142542E-06_JPRB, 0.31191260E-06_JPRB, 0.31242871E-06_JPRB, 0.31297466E-06_JPRB, 0.31355310E-06_JPRB, 0.31416104E-06_JPRB, &
  & 0.31479016E-06_JPRB, 0.31540645E-06_JPRB, 0.31596878E-06_JPRB, 0.31642929E-06_JPRB, 0.31677507E-06_JPRB, 0.31702001E-06_JPRB, &
  & 0.31719219E-06_JPRB, 0.31731810E-06_JPRB, 0.31741604E-06_JPRB, 0.31749715E-06_JPRB, 0.31756710E-06_JPRB, 0.31762841E-06_JPRB, &
  & 0.31768081E-06_JPRB, 0.31772197E-06_JPRB, 0.31774894E-06_JPRB, 0.31776111E-06_JPRB, 0.31775983E-06_JPRB, 0.31774698E-06_JPRB, &
  & 0.31772328E-06_JPRB, 0.31768926E-06_JPRB, 0.31764480E-06_JPRB, 0.31758853E-06_JPRB, 0.31752035E-06_JPRB, 0.31743861E-06_JPRB, &
  & 0.31734021E-06_JPRB, 0.31722499E-06_JPRB, 0.31708123E-06_JPRB, 0.31689834E-06_JPRB, 0.31666374E-06_JPRB, 0.31637268E-06_JPRB, &
  & 0.31603335E-06_JPRB, 0.31566438E-06_JPRB, 0.31529231E-06_JPRB, 0.31493707E-06_JPRB, 0.31461317E-06_JPRB, 0.31432532E-06_JPRB, &
  & 0.31407137E-06_JPRB, 0.31384369E-06_JPRB, 0.31363564E-06_JPRB, 0.31344396E-06_JPRB, 0.31327139E-06_JPRB, 0.31312044E-06_JPRB, &
  & 0.31298890E-06_JPRB, 0.31286785E-06_JPRB, 0.31273905E-06_JPRB, 0.31252503E-06_JPRB /)

RGHG3(:,43, 8) = (/ &
  & 0.30910718E-06_JPRB, 0.30928086E-06_JPRB, 0.30939890E-06_JPRB, 0.30954391E-06_JPRB, 0.30973970E-06_JPRB, 0.30997074E-06_JPRB, &
  & 0.31021989E-06_JPRB, 0.31047401E-06_JPRB, 0.31074484E-06_JPRB, 0.31104213E-06_JPRB, 0.31137336E-06_JPRB, 0.31173832E-06_JPRB, &
  & 0.31213301E-06_JPRB, 0.31255402E-06_JPRB, 0.31300036E-06_JPRB, 0.31347537E-06_JPRB, 0.31398167E-06_JPRB, 0.31452373E-06_JPRB, &
  & 0.31508984E-06_JPRB, 0.31565634E-06_JPRB, 0.31617083E-06_JPRB, 0.31659243E-06_JPRB, 0.31690479E-06_JPRB, 0.31712463E-06_JPRB, &
  & 0.31727888E-06_JPRB, 0.31739117E-06_JPRB, 0.31747842E-06_JPRB, 0.31755019E-06_JPRB, 0.31761189E-06_JPRB, 0.31766587E-06_JPRB, &
  & 0.31771222E-06_JPRB, 0.31774857E-06_JPRB, 0.31777233E-06_JPRB, 0.31778259E-06_JPRB, 0.31778089E-06_JPRB, 0.31776887E-06_JPRB, &
  & 0.31774744E-06_JPRB, 0.31771700E-06_JPRB, 0.31767783E-06_JPRB, 0.31762914E-06_JPRB, 0.31757145E-06_JPRB, 0.31750432E-06_JPRB, &
  & 0.31742601E-06_JPRB, 0.31733637E-06_JPRB, 0.31722664E-06_JPRB, 0.31708527E-06_JPRB, 0.31689947E-06_JPRB, 0.31665562E-06_JPRB, &
  & 0.31635867E-06_JPRB, 0.31602409E-06_JPRB, 0.31568146E-06_JPRB, 0.31535282E-06_JPRB, 0.31505533E-06_JPRB, 0.31479541E-06_JPRB, &
  & 0.31456904E-06_JPRB, 0.31436878E-06_JPRB, 0.31418600E-06_JPRB, 0.31401743E-06_JPRB, 0.31386500E-06_JPRB, 0.31373150E-06_JPRB, &
  & 0.31361452E-06_JPRB, 0.31350595E-06_JPRB, 0.31338919E-06_JPRB, 0.31319465E-06_JPRB /)

RGHG3(:,44, 8) = (/ &
  & 0.30998672E-06_JPRB, 0.31021426E-06_JPRB, 0.31034313E-06_JPRB, 0.31049174E-06_JPRB, 0.31068785E-06_JPRB, 0.31092210E-06_JPRB, &
  & 0.31115763E-06_JPRB, 0.31139098E-06_JPRB, 0.31162983E-06_JPRB, 0.31188611E-06_JPRB, 0.31216868E-06_JPRB, 0.31247990E-06_JPRB, &
  & 0.31281616E-06_JPRB, 0.31317467E-06_JPRB, 0.31355631E-06_JPRB, 0.31396192E-06_JPRB, 0.31439987E-06_JPRB, 0.31487042E-06_JPRB, &
  & 0.31537536E-06_JPRB, 0.31588300E-06_JPRB, 0.31635159E-06_JPRB, 0.31673196E-06_JPRB, 0.31701308E-06_JPRB, 0.31721044E-06_JPRB, &
  & 0.31734862E-06_JPRB, 0.31744941E-06_JPRB, 0.31752754E-06_JPRB, 0.31759174E-06_JPRB, 0.31764688E-06_JPRB, 0.31769537E-06_JPRB, &
  & 0.31773718E-06_JPRB, 0.31777014E-06_JPRB, 0.31779157E-06_JPRB, 0.31780073E-06_JPRB, 0.31779888E-06_JPRB, 0.31778774E-06_JPRB, &
  & 0.31776810E-06_JPRB, 0.31774053E-06_JPRB, 0.31770520E-06_JPRB, 0.31766220E-06_JPRB, 0.31761198E-06_JPRB, 0.31755567E-06_JPRB, &
  & 0.31749184E-06_JPRB, 0.31742124E-06_JPRB, 0.31733728E-06_JPRB, 0.31722968E-06_JPRB, 0.31708538E-06_JPRB, 0.31688785E-06_JPRB, &
  & 0.31663410E-06_JPRB, 0.31633539E-06_JPRB, 0.31602184E-06_JPRB, 0.31571952E-06_JPRB, 0.31544886E-06_JPRB, 0.31521628E-06_JPRB, &
  & 0.31501838E-06_JPRB, 0.31484535E-06_JPRB, 0.31468807E-06_JPRB, 0.31454178E-06_JPRB, 0.31440825E-06_JPRB, 0.31429022E-06_JPRB, &
  & 0.31418614E-06_JPRB, 0.31408851E-06_JPRB, 0.31398244E-06_JPRB, 0.31380478E-06_JPRB /)

RGHG3(:,45, 8) = (/ &
  & 0.31110631E-06_JPRB, 0.31122670E-06_JPRB, 0.31132114E-06_JPRB, 0.31144793E-06_JPRB, 0.31163700E-06_JPRB, 0.31185868E-06_JPRB, &
  & 0.31207830E-06_JPRB, 0.31228814E-06_JPRB, 0.31249419E-06_JPRB, 0.31271202E-06_JPRB, 0.31294923E-06_JPRB, 0.31320917E-06_JPRB, &
  & 0.31349009E-06_JPRB, 0.31379042E-06_JPRB, 0.31410846E-06_JPRB, 0.31445043E-06_JPRB, 0.31481713E-06_JPRB, 0.31522137E-06_JPRB, &
  & 0.31565366E-06_JPRB, 0.31610327E-06_JPRB, 0.31651552E-06_JPRB, 0.31685448E-06_JPRB, 0.31710488E-06_JPRB, 0.31728109E-06_JPRB, &
  & 0.31740538E-06_JPRB, 0.31749619E-06_JPRB, 0.31756673E-06_JPRB, 0.31762482E-06_JPRB, 0.31767487E-06_JPRB, 0.31771916E-06_JPRB, &
  & 0.31775761E-06_JPRB, 0.31778805E-06_JPRB, 0.31780797E-06_JPRB, 0.31781647E-06_JPRB, 0.31781474E-06_JPRB, 0.31780453E-06_JPRB, &
  & 0.31778646E-06_JPRB, 0.31776113E-06_JPRB, 0.31772893E-06_JPRB, 0.31768991E-06_JPRB, 0.31764554E-06_JPRB, 0.31759689E-06_JPRB, &
  & 0.31754431E-06_JPRB, 0.31748743E-06_JPRB, 0.31742309E-06_JPRB, 0.31734166E-06_JPRB, 0.31723232E-06_JPRB, 0.31707776E-06_JPRB, &
  & 0.31686707E-06_JPRB, 0.31660744E-06_JPRB, 0.31632419E-06_JPRB, 0.31604921E-06_JPRB, 0.31580555E-06_JPRB, 0.31560151E-06_JPRB, &
  & 0.31543243E-06_JPRB, 0.31528648E-06_JPRB, 0.31515387E-06_JPRB, 0.31502887E-06_JPRB, 0.31491248E-06_JPRB, 0.31480818E-06_JPRB, &
  & 0.31471501E-06_JPRB, 0.31462690E-06_JPRB, 0.31453033E-06_JPRB, 0.31436781E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART16',0,ZHOOK_HANDLE)



RGHG3(:,46, 8) = (/ &
  & 0.31186056E-06_JPRB, 0.31210408E-06_JPRB, 0.31224562E-06_JPRB, 0.31239941E-06_JPRB, 0.31259032E-06_JPRB, 0.31280422E-06_JPRB, &
  & 0.31300598E-06_JPRB, 0.31318604E-06_JPRB, 0.31336089E-06_JPRB, 0.31353881E-06_JPRB, 0.31373133E-06_JPRB, 0.31394137E-06_JPRB, &
  & 0.31416872E-06_JPRB, 0.31441058E-06_JPRB, 0.31466996E-06_JPRB, 0.31494545E-06_JPRB, 0.31524837E-06_JPRB, 0.31557698E-06_JPRB, &
  & 0.31594280E-06_JPRB, 0.31631606E-06_JPRB, 0.31667079E-06_JPRB, 0.31696260E-06_JPRB, 0.31718250E-06_JPRB, 0.31733967E-06_JPRB, &
  & 0.31745139E-06_JPRB, 0.31753376E-06_JPRB, 0.31759805E-06_JPRB, 0.31765120E-06_JPRB, 0.31769744E-06_JPRB, 0.31773851E-06_JPRB, &
  & 0.31777441E-06_JPRB, 0.31780314E-06_JPRB, 0.31782204E-06_JPRB, 0.31783020E-06_JPRB, 0.31782886E-06_JPRB, 0.31781951E-06_JPRB, &
  & 0.31780286E-06_JPRB, 0.31777944E-06_JPRB, 0.31774948E-06_JPRB, 0.31771395E-06_JPRB, 0.31767365E-06_JPRB, 0.31763128E-06_JPRB, &
  & 0.31758651E-06_JPRB, 0.31754038E-06_JPRB, 0.31748991E-06_JPRB, 0.31742857E-06_JPRB, 0.31734709E-06_JPRB, 0.31722990E-06_JPRB, &
  & 0.31706418E-06_JPRB, 0.31684633E-06_JPRB, 0.31659857E-06_JPRB, 0.31635312E-06_JPRB, 0.31613814E-06_JPRB, 0.31596377E-06_JPRB, &
  & 0.31582223E-06_JPRB, 0.31570247E-06_JPRB, 0.31559259E-06_JPRB, 0.31548694E-06_JPRB, 0.31538610E-06_JPRB, 0.31529353E-06_JPRB, &
  & 0.31521000E-06_JPRB, 0.31513036E-06_JPRB, 0.31504257E-06_JPRB, 0.31489469E-06_JPRB /)

RGHG3(:,47, 8) = (/ &
  & 0.31286754E-06_JPRB, 0.31307064E-06_JPRB, 0.31321287E-06_JPRB, 0.31337277E-06_JPRB, 0.31357260E-06_JPRB, 0.31378056E-06_JPRB, &
  & 0.31395680E-06_JPRB, 0.31410954E-06_JPRB, 0.31424574E-06_JPRB, 0.31438276E-06_JPRB, 0.31452797E-06_JPRB, 0.31468676E-06_JPRB, &
  & 0.31485882E-06_JPRB, 0.31504442E-06_JPRB, 0.31524181E-06_JPRB, 0.31545733E-06_JPRB, 0.31568968E-06_JPRB, 0.31595107E-06_JPRB, &
  & 0.31623205E-06_JPRB, 0.31653178E-06_JPRB, 0.31681424E-06_JPRB, 0.31705869E-06_JPRB, 0.31724829E-06_JPRB, 0.31738742E-06_JPRB, &
  & 0.31748846E-06_JPRB, 0.31756375E-06_JPRB, 0.31762295E-06_JPRB, 0.31767240E-06_JPRB, 0.31771555E-06_JPRB, 0.31775431E-06_JPRB, &
  & 0.31778848E-06_JPRB, 0.31781590E-06_JPRB, 0.31783418E-06_JPRB, 0.31784236E-06_JPRB, 0.31784160E-06_JPRB, 0.31783310E-06_JPRB, &
  & 0.31781764E-06_JPRB, 0.31779575E-06_JPRB, 0.31776787E-06_JPRB, 0.31773467E-06_JPRB, 0.31769818E-06_JPRB, 0.31765984E-06_JPRB, &
  & 0.31762156E-06_JPRB, 0.31758262E-06_JPRB, 0.31754251E-06_JPRB, 0.31749573E-06_JPRB, 0.31743517E-06_JPRB, 0.31735010E-06_JPRB, &
  & 0.31722553E-06_JPRB, 0.31705696E-06_JPRB, 0.31685087E-06_JPRB, 0.31664220E-06_JPRB, 0.31645885E-06_JPRB, 0.31631262E-06_JPRB, &
  & 0.31619820E-06_JPRB, 0.31610102E-06_JPRB, 0.31601152E-06_JPRB, 0.31592285E-06_JPRB, 0.31583502E-06_JPRB, 0.31575269E-06_JPRB, &
  & 0.31567723E-06_JPRB, 0.31560509E-06_JPRB, 0.31552548E-06_JPRB, 0.31539128E-06_JPRB /)

RGHG3(:,48, 8) = (/ &
  & 0.31367679E-06_JPRB, 0.31394333E-06_JPRB, 0.31412389E-06_JPRB, 0.31431716E-06_JPRB, 0.31454107E-06_JPRB, 0.31475199E-06_JPRB, &
  & 0.31491925E-06_JPRB, 0.31504248E-06_JPRB, 0.31514534E-06_JPRB, 0.31524070E-06_JPRB, 0.31533838E-06_JPRB, 0.31544485E-06_JPRB, &
  & 0.31556181E-06_JPRB, 0.31568894E-06_JPRB, 0.31582812E-06_JPRB, 0.31597830E-06_JPRB, 0.31614479E-06_JPRB, 0.31632547E-06_JPRB, &
  & 0.31652533E-06_JPRB, 0.31673508E-06_JPRB, 0.31694839E-06_JPRB, 0.31714245E-06_JPRB, 0.31730323E-06_JPRB, 0.31742641E-06_JPRB, &
  & 0.31751807E-06_JPRB, 0.31758748E-06_JPRB, 0.31764270E-06_JPRB, 0.31768917E-06_JPRB, 0.31773021E-06_JPRB, 0.31776733E-06_JPRB, &
  & 0.31780019E-06_JPRB, 0.31782679E-06_JPRB, 0.31784475E-06_JPRB, 0.31785319E-06_JPRB, 0.31785302E-06_JPRB, 0.31784546E-06_JPRB, &
  & 0.31783105E-06_JPRB, 0.31781050E-06_JPRB, 0.31778413E-06_JPRB, 0.31775338E-06_JPRB, 0.31771924E-06_JPRB, 0.31768457E-06_JPRB, &
  & 0.31765020E-06_JPRB, 0.31761729E-06_JPRB, 0.31758415E-06_JPRB, 0.31754797E-06_JPRB, 0.31750312E-06_JPRB, 0.31744216E-06_JPRB, &
  & 0.31735561E-06_JPRB, 0.31723434E-06_JPRB, 0.31708373E-06_JPRB, 0.31692011E-06_JPRB, 0.31677422E-06_JPRB, 0.31665860E-06_JPRB, &
  & 0.31656722E-06_JPRB, 0.31648989E-06_JPRB, 0.31641673E-06_JPRB, 0.31634193E-06_JPRB, 0.31626499E-06_JPRB, 0.31619049E-06_JPRB, &
  & 0.31612169E-06_JPRB, 0.31605558E-06_JPRB, 0.31598273E-06_JPRB, 0.31585995E-06_JPRB /)

RGHG3(:,49, 8) = (/ &
  & 0.31444443E-06_JPRB, 0.31474036E-06_JPRB, 0.31493869E-06_JPRB, 0.31514986E-06_JPRB, 0.31539128E-06_JPRB, 0.31561672E-06_JPRB, &
  & 0.31577724E-06_JPRB, 0.31588792E-06_JPRB, 0.31596954E-06_JPRB, 0.31603548E-06_JPRB, 0.31609818E-06_JPRB, 0.31616227E-06_JPRB, &
  & 0.31623185E-06_JPRB, 0.31630753E-06_JPRB, 0.31638990E-06_JPRB, 0.31647946E-06_JPRB, 0.31657470E-06_JPRB, 0.31667787E-06_JPRB, &
  & 0.31679144E-06_JPRB, 0.31692122E-06_JPRB, 0.31706614E-06_JPRB, 0.31721484E-06_JPRB, 0.31734888E-06_JPRB, 0.31745779E-06_JPRB, &
  & 0.31754169E-06_JPRB, 0.31760646E-06_JPRB, 0.31765845E-06_JPRB, 0.31770270E-06_JPRB, 0.31774218E-06_JPRB, 0.31777813E-06_JPRB, &
  & 0.31781011E-06_JPRB, 0.31783622E-06_JPRB, 0.31785407E-06_JPRB, 0.31786280E-06_JPRB, 0.31786334E-06_JPRB, 0.31785663E-06_JPRB, &
  & 0.31784333E-06_JPRB, 0.31782389E-06_JPRB, 0.31779902E-06_JPRB, 0.31776995E-06_JPRB, 0.31773826E-06_JPRB, 0.31770588E-06_JPRB, &
  & 0.31767493E-06_JPRB, 0.31764554E-06_JPRB, 0.31761786E-06_JPRB, 0.31758881E-06_JPRB, 0.31755516E-06_JPRB, 0.31751213E-06_JPRB, &
  & 0.31745398E-06_JPRB, 0.31737693E-06_JPRB, 0.31727944E-06_JPRB, 0.31717383E-06_JPRB, 0.31707390E-06_JPRB, 0.31699165E-06_JPRB, &
  & 0.31692397E-06_JPRB, 0.31686488E-06_JPRB, 0.31680594E-06_JPRB, 0.31674276E-06_JPRB, 0.31667486E-06_JPRB, 0.31660670E-06_JPRB, &
  & 0.31654264E-06_JPRB, 0.31648122E-06_JPRB, 0.31641324E-06_JPRB, 0.31629912E-06_JPRB /)

RGHG3(:,50, 8) = (/ &
  & 0.31519153E-06_JPRB, 0.31544337E-06_JPRB, 0.31561606E-06_JPRB, 0.31581126E-06_JPRB, 0.31603980E-06_JPRB, 0.31625353E-06_JPRB, &
  & 0.31640198E-06_JPRB, 0.31650114E-06_JPRB, 0.31656677E-06_JPRB, 0.31661978E-06_JPRB, 0.31666363E-06_JPRB, 0.31670606E-06_JPRB, &
  & 0.31674753E-06_JPRB, 0.31678931E-06_JPRB, 0.31683098E-06_JPRB, 0.31687213E-06_JPRB, 0.31691343E-06_JPRB, 0.31695691E-06_JPRB, &
  & 0.31700793E-06_JPRB, 0.31707617E-06_JPRB, 0.31716684E-06_JPRB, 0.31727592E-06_JPRB, 0.31738648E-06_JPRB, 0.31748317E-06_JPRB, &
  & 0.31756073E-06_JPRB, 0.31762175E-06_JPRB, 0.31767138E-06_JPRB, 0.31771393E-06_JPRB, 0.31775224E-06_JPRB, 0.31778731E-06_JPRB, &
  & 0.31781872E-06_JPRB, 0.31784438E-06_JPRB, 0.31786220E-06_JPRB, 0.31787138E-06_JPRB, 0.31787272E-06_JPRB, 0.31786678E-06_JPRB, &
  & 0.31785447E-06_JPRB, 0.31783620E-06_JPRB, 0.31781266E-06_JPRB, 0.31778524E-06_JPRB, 0.31775539E-06_JPRB, 0.31772498E-06_JPRB, &
  & 0.31769585E-06_JPRB, 0.31766979E-06_JPRB, 0.31764540E-06_JPRB, 0.31762156E-06_JPRB, 0.31759544E-06_JPRB, 0.31756460E-06_JPRB, &
  & 0.31752649E-06_JPRB, 0.31747987E-06_JPRB, 0.31742607E-06_JPRB, 0.31736818E-06_JPRB, 0.31731409E-06_JPRB, 0.31726674E-06_JPRB, &
  & 0.31722612E-06_JPRB, 0.31718690E-06_JPRB, 0.31714632E-06_JPRB, 0.31709911E-06_JPRB, 0.31704400E-06_JPRB, 0.31698585E-06_JPRB, &
  & 0.31692929E-06_JPRB, 0.31687327E-06_JPRB, 0.31681083E-06_JPRB, 0.31670268E-06_JPRB /)

RGHG3(:,51, 8) = (/ &
  & 0.31575445E-06_JPRB, 0.31597756E-06_JPRB, 0.31612950E-06_JPRB, 0.31629060E-06_JPRB, 0.31648898E-06_JPRB, 0.31666795E-06_JPRB, &
  & 0.31679409E-06_JPRB, 0.31686932E-06_JPRB, 0.31692389E-06_JPRB, 0.31696203E-06_JPRB, 0.31699631E-06_JPRB, 0.31702649E-06_JPRB, &
  & 0.31705474E-06_JPRB, 0.31707930E-06_JPRB, 0.31710005E-06_JPRB, 0.31711721E-06_JPRB, 0.31713157E-06_JPRB, 0.31714580E-06_JPRB, &
  & 0.31716505E-06_JPRB, 0.31719665E-06_JPRB, 0.31725057E-06_JPRB, 0.31732748E-06_JPRB, 0.31741757E-06_JPRB, 0.31750386E-06_JPRB, &
  & 0.31757637E-06_JPRB, 0.31763460E-06_JPRB, 0.31768235E-06_JPRB, 0.31772350E-06_JPRB, 0.31776079E-06_JPRB, 0.31779510E-06_JPRB, &
  & 0.31782596E-06_JPRB, 0.31785146E-06_JPRB, 0.31786942E-06_JPRB, 0.31787917E-06_JPRB, 0.31788122E-06_JPRB, 0.31787616E-06_JPRB, &
  & 0.31786473E-06_JPRB, 0.31784765E-06_JPRB, 0.31782537E-06_JPRB, 0.31779962E-06_JPRB, 0.31777108E-06_JPRB, 0.31774221E-06_JPRB, &
  & 0.31771498E-06_JPRB, 0.31769036E-06_JPRB, 0.31766893E-06_JPRB, 0.31764830E-06_JPRB, 0.31762730E-06_JPRB, 0.31760433E-06_JPRB, &
  & 0.31757901E-06_JPRB, 0.31755144E-06_JPRB, 0.31752268E-06_JPRB, 0.31749448E-06_JPRB, 0.31746913E-06_JPRB, 0.31744733E-06_JPRB, &
  & 0.31742775E-06_JPRB, 0.31740905E-06_JPRB, 0.31738765E-06_JPRB, 0.31736121E-06_JPRB, 0.31732796E-06_JPRB, 0.31728857E-06_JPRB, &
  & 0.31724682E-06_JPRB, 0.31720350E-06_JPRB, 0.31715061E-06_JPRB, 0.31705483E-06_JPRB /)

RGHG3(:,52, 8) = (/ &
  & 0.31626334E-06_JPRB, 0.31641292E-06_JPRB, 0.31651541E-06_JPRB, 0.31664175E-06_JPRB, 0.31679230E-06_JPRB, 0.31693793E-06_JPRB, &
  & 0.31703021E-06_JPRB, 0.31709084E-06_JPRB, 0.31712725E-06_JPRB, 0.31715757E-06_JPRB, 0.31718147E-06_JPRB, 0.31720435E-06_JPRB, &
  & 0.31722433E-06_JPRB, 0.31724073E-06_JPRB, 0.31725244E-06_JPRB, 0.31725978E-06_JPRB, 0.31726412E-06_JPRB, 0.31726753E-06_JPRB, &
  & 0.31727348E-06_JPRB, 0.31728800E-06_JPRB, 0.31731830E-06_JPRB, 0.31737198E-06_JPRB, 0.31744435E-06_JPRB, 0.31752131E-06_JPRB, &
  & 0.31758961E-06_JPRB, 0.31764563E-06_JPRB, 0.31769190E-06_JPRB, 0.31773192E-06_JPRB, 0.31776833E-06_JPRB, 0.31780192E-06_JPRB, &
  & 0.31783242E-06_JPRB, 0.31785771E-06_JPRB, 0.31787590E-06_JPRB, 0.31788630E-06_JPRB, 0.31788898E-06_JPRB, 0.31788474E-06_JPRB, &
  & 0.31787434E-06_JPRB, 0.31785822E-06_JPRB, 0.31783742E-06_JPRB, 0.31781286E-06_JPRB, 0.31778589E-06_JPRB, 0.31775818E-06_JPRB, &
  & 0.31773186E-06_JPRB, 0.31770929E-06_JPRB, 0.31768917E-06_JPRB, 0.31767098E-06_JPRB, 0.31765322E-06_JPRB, 0.31763557E-06_JPRB, &
  & 0.31761795E-06_JPRB, 0.31760109E-06_JPRB, 0.31758532E-06_JPRB, 0.31757170E-06_JPRB, 0.31756025E-06_JPRB, 0.31755110E-06_JPRB, &
  & 0.31754320E-06_JPRB, 0.31753541E-06_JPRB, 0.31752677E-06_JPRB, 0.31751554E-06_JPRB, 0.31749991E-06_JPRB, 0.31748019E-06_JPRB, &
  & 0.31745736E-06_JPRB, 0.31743076E-06_JPRB, 0.31739626E-06_JPRB, 0.31732353E-06_JPRB /)

RGHG3(:,53, 8) = (/ &
  & 0.31659306E-06_JPRB, 0.31671448E-06_JPRB, 0.31679949E-06_JPRB, 0.31689046E-06_JPRB, 0.31700765E-06_JPRB, 0.31711281E-06_JPRB, &
  & 0.31718594E-06_JPRB, 0.31722638E-06_JPRB, 0.31725565E-06_JPRB, 0.31727549E-06_JPRB, 0.31729414E-06_JPRB, 0.31731059E-06_JPRB, &
  & 0.31732571E-06_JPRB, 0.31733759E-06_JPRB, 0.31734530E-06_JPRB, 0.31734902E-06_JPRB, 0.31734993E-06_JPRB, 0.31734956E-06_JPRB, &
  & 0.31735050E-06_JPRB, 0.31735647E-06_JPRB, 0.31737426E-06_JPRB, 0.31741078E-06_JPRB, 0.31746848E-06_JPRB, 0.31753697E-06_JPRB, &
  & 0.31760146E-06_JPRB, 0.31765555E-06_JPRB, 0.31770045E-06_JPRB, 0.31773948E-06_JPRB, 0.31777495E-06_JPRB, 0.31780797E-06_JPRB, &
  & 0.31783804E-06_JPRB, 0.31786328E-06_JPRB, 0.31788173E-06_JPRB, 0.31789267E-06_JPRB, 0.31789614E-06_JPRB, 0.31789278E-06_JPRB, &
  & 0.31788323E-06_JPRB, 0.31786826E-06_JPRB, 0.31784856E-06_JPRB, 0.31782554E-06_JPRB, 0.31779973E-06_JPRB, 0.31777316E-06_JPRB, &
  & 0.31774823E-06_JPRB, 0.31772612E-06_JPRB, 0.31770750E-06_JPRB, 0.31769076E-06_JPRB, 0.31767547E-06_JPRB, 0.31766103E-06_JPRB, &
  & 0.31764819E-06_JPRB, 0.31763699E-06_JPRB, 0.31762787E-06_JPRB, 0.31762067E-06_JPRB, 0.31761545E-06_JPRB, 0.31761149E-06_JPRB, &
  & 0.31760834E-06_JPRB, 0.31760533E-06_JPRB, 0.31760192E-06_JPRB, 0.31759731E-06_JPRB, 0.31759083E-06_JPRB, 0.31758185E-06_JPRB, &
  & 0.31757088E-06_JPRB, 0.31755809E-06_JPRB, 0.31754053E-06_JPRB, 0.31749877E-06_JPRB /)

RGHG3(:,54, 8) = (/ &
  & 0.31687736E-06_JPRB, 0.31695765E-06_JPRB, 0.31701236E-06_JPRB, 0.31707924E-06_JPRB, 0.31716050E-06_JPRB, 0.31723945E-06_JPRB, &
  & 0.31728953E-06_JPRB, 0.31732179E-06_JPRB, 0.31734066E-06_JPRB, 0.31735658E-06_JPRB, 0.31736931E-06_JPRB, 0.31738205E-06_JPRB, &
  & 0.31739359E-06_JPRB, 0.31740282E-06_JPRB, 0.31740862E-06_JPRB, 0.31741092E-06_JPRB, 0.31741075E-06_JPRB, 0.31740916E-06_JPRB, &
  & 0.31740802E-06_JPRB, 0.31741018E-06_JPRB, 0.31742013E-06_JPRB, 0.31744565E-06_JPRB, 0.31749153E-06_JPRB, 0.31755189E-06_JPRB, &
  & 0.31761266E-06_JPRB, 0.31766470E-06_JPRB, 0.31770838E-06_JPRB, 0.31774636E-06_JPRB, 0.31778103E-06_JPRB, 0.31781332E-06_JPRB, &
  & 0.31784302E-06_JPRB, 0.31786826E-06_JPRB, 0.31788710E-06_JPRB, 0.31789867E-06_JPRB, 0.31790279E-06_JPRB, 0.31790029E-06_JPRB, &
  & 0.31789156E-06_JPRB, 0.31787764E-06_JPRB, 0.31785922E-06_JPRB, 0.31783713E-06_JPRB, 0.31781261E-06_JPRB, 0.31778731E-06_JPRB, &
  & 0.31776304E-06_JPRB, 0.31774223E-06_JPRB, 0.31772436E-06_JPRB, 0.31770881E-06_JPRB, 0.31769497E-06_JPRB, 0.31768289E-06_JPRB, &
  & 0.31767274E-06_JPRB, 0.31766479E-06_JPRB, 0.31765870E-06_JPRB, 0.31765455E-06_JPRB, 0.31765165E-06_JPRB, 0.31764984E-06_JPRB, &
  & 0.31764836E-06_JPRB, 0.31764705E-06_JPRB, 0.31764554E-06_JPRB, 0.31764353E-06_JPRB, 0.31764054E-06_JPRB, 0.31763648E-06_JPRB, &
  & 0.31763165E-06_JPRB, 0.31762653E-06_JPRB, 0.31762141E-06_JPRB, 0.31761581E-06_JPRB /)

RGHG3(:,55, 8) = (/ &
  & 0.31706688E-06_JPRB, 0.31712915E-06_JPRB, 0.31717167E-06_JPRB, 0.31721868E-06_JPRB, 0.31727541E-06_JPRB, 0.31732986E-06_JPRB, &
  & 0.31736849E-06_JPRB, 0.31738989E-06_JPRB, 0.31740512E-06_JPRB, 0.31741558E-06_JPRB, 0.31742564E-06_JPRB, 0.31743497E-06_JPRB, &
  & 0.31744412E-06_JPRB, 0.31745165E-06_JPRB, 0.31745645E-06_JPRB, 0.31745833E-06_JPRB, 0.31745779E-06_JPRB, 0.31745591E-06_JPRB, &
  & 0.31745373E-06_JPRB, 0.31745358E-06_JPRB, 0.31745921E-06_JPRB, 0.31747726E-06_JPRB, 0.31751392E-06_JPRB, 0.31756744E-06_JPRB, &
  & 0.31762369E-06_JPRB, 0.31767365E-06_JPRB, 0.31771580E-06_JPRB, 0.31775281E-06_JPRB, 0.31778654E-06_JPRB, 0.31781835E-06_JPRB, &
  & 0.31784765E-06_JPRB, 0.31787289E-06_JPRB, 0.31789205E-06_JPRB, 0.31790421E-06_JPRB, 0.31790913E-06_JPRB, 0.31790742E-06_JPRB, &
  & 0.31789955E-06_JPRB, 0.31788659E-06_JPRB, 0.31786917E-06_JPRB, 0.31784825E-06_JPRB, 0.31782471E-06_JPRB, 0.31780047E-06_JPRB, &
  & 0.31777753E-06_JPRB, 0.31775738E-06_JPRB, 0.31774044E-06_JPRB, 0.31772564E-06_JPRB, 0.31771299E-06_JPRB, 0.31770224E-06_JPRB, &
  & 0.31769383E-06_JPRB, 0.31768741E-06_JPRB, 0.31768292E-06_JPRB, 0.31767991E-06_JPRB, 0.31767814E-06_JPRB, 0.31767695E-06_JPRB, &
  & 0.31767615E-06_JPRB, 0.31767536E-06_JPRB, 0.31767451E-06_JPRB, 0.31767334E-06_JPRB, 0.31767158E-06_JPRB, 0.31766919E-06_JPRB, &
  & 0.31766632E-06_JPRB, 0.31766319E-06_JPRB, 0.31765967E-06_JPRB, 0.31765370E-06_JPRB /)

RGHG3(:,56, 8) = (/ &
  & 0.31722527E-06_JPRB, 0.31726466E-06_JPRB, 0.31729286E-06_JPRB, 0.31732401E-06_JPRB, 0.31736317E-06_JPRB, 0.31740086E-06_JPRB, &
  & 0.31742735E-06_JPRB, 0.31744452E-06_JPRB, 0.31745469E-06_JPRB, 0.31746322E-06_JPRB, 0.31747032E-06_JPRB, 0.31747777E-06_JPRB, &
  & 0.31748499E-06_JPRB, 0.31749130E-06_JPRB, 0.31749562E-06_JPRB, 0.31749744E-06_JPRB, 0.31749698E-06_JPRB, 0.31749499E-06_JPRB, &
  & 0.31749232E-06_JPRB, 0.31749070E-06_JPRB, 0.31749329E-06_JPRB, 0.31750625E-06_JPRB, 0.31753663E-06_JPRB, 0.31758324E-06_JPRB, &
  & 0.31763531E-06_JPRB, 0.31768244E-06_JPRB, 0.31772316E-06_JPRB, 0.31775892E-06_JPRB, 0.31779192E-06_JPRB, 0.31782318E-06_JPRB, &
  & 0.31785223E-06_JPRB, 0.31787741E-06_JPRB, 0.31789688E-06_JPRB, 0.31790958E-06_JPRB, 0.31791521E-06_JPRB, 0.31791424E-06_JPRB, &
  & 0.31790728E-06_JPRB, 0.31789526E-06_JPRB, 0.31787877E-06_JPRB, 0.31785868E-06_JPRB, 0.31783622E-06_JPRB, 0.31781312E-06_JPRB, &
  & 0.31779112E-06_JPRB, 0.31777208E-06_JPRB, 0.31775585E-06_JPRB, 0.31774189E-06_JPRB, 0.31773007E-06_JPRB, 0.31772038E-06_JPRB, &
  & 0.31771279E-06_JPRB, 0.31770711E-06_JPRB, 0.31770310E-06_JPRB, 0.31770065E-06_JPRB, 0.31769906E-06_JPRB, 0.31769815E-06_JPRB, &
  & 0.31769741E-06_JPRB, 0.31769679E-06_JPRB, 0.31769605E-06_JPRB, 0.31769508E-06_JPRB, 0.31769383E-06_JPRB, 0.31769213E-06_JPRB, &
  & 0.31769017E-06_JPRB, 0.31768806E-06_JPRB, 0.31768570E-06_JPRB, 0.31768221E-06_JPRB /)

RGHG3(:,57, 8) = (/ &
  & 0.31733012E-06_JPRB, 0.31736189E-06_JPRB, 0.31738239E-06_JPRB, 0.31740521E-06_JPRB, 0.31743008E-06_JPRB, 0.31745645E-06_JPRB, &
  & 0.31747638E-06_JPRB, 0.31748823E-06_JPRB, 0.31749659E-06_JPRB, 0.31750261E-06_JPRB, 0.31750847E-06_JPRB, 0.31751421E-06_JPRB, &
  & 0.31752023E-06_JPRB, 0.31752572E-06_JPRB, 0.31752970E-06_JPRB, 0.31753166E-06_JPRB, 0.31753143E-06_JPRB, 0.31752944E-06_JPRB, &
  & 0.31752626E-06_JPRB, 0.31752342E-06_JPRB, 0.31752393E-06_JPRB, 0.31753348E-06_JPRB, 0.31755866E-06_JPRB, 0.31760015E-06_JPRB, &
  & 0.31764739E-06_JPRB, 0.31769167E-06_JPRB, 0.31773055E-06_JPRB, 0.31776531E-06_JPRB, 0.31779751E-06_JPRB, 0.31782821E-06_JPRB, &
  & 0.31785683E-06_JPRB, 0.31788198E-06_JPRB, 0.31790171E-06_JPRB, 0.31791495E-06_JPRB, 0.31792112E-06_JPRB, 0.31792092E-06_JPRB, &
  & 0.31791478E-06_JPRB, 0.31790356E-06_JPRB, 0.31788792E-06_JPRB, 0.31786882E-06_JPRB, 0.31784731E-06_JPRB, 0.31782531E-06_JPRB, &
  & 0.31780451E-06_JPRB, 0.31778617E-06_JPRB, 0.31777080E-06_JPRB, 0.31775755E-06_JPRB, 0.31774647E-06_JPRB, 0.31773743E-06_JPRB, &
  & 0.31773035E-06_JPRB, 0.31772498E-06_JPRB, 0.31772123E-06_JPRB, 0.31771873E-06_JPRB, 0.31771725E-06_JPRB, 0.31771617E-06_JPRB, &
  & 0.31771535E-06_JPRB, 0.31771458E-06_JPRB, 0.31771378E-06_JPRB, 0.31771276E-06_JPRB, 0.31771145E-06_JPRB, 0.31770989E-06_JPRB, &
  & 0.31770807E-06_JPRB, 0.31770622E-06_JPRB, 0.31770418E-06_JPRB, 0.31770060E-06_JPRB /)

RGHG3(:,58, 8) = (/ &
  & 0.31741615E-06_JPRB, 0.31743764E-06_JPRB, 0.31745236E-06_JPRB, 0.31746686E-06_JPRB, 0.31748453E-06_JPRB, 0.31750216E-06_JPRB, &
  & 0.31751648E-06_JPRB, 0.31752609E-06_JPRB, 0.31753217E-06_JPRB, 0.31753723E-06_JPRB, 0.31754169E-06_JPRB, 0.31754649E-06_JPRB, &
  & 0.31755167E-06_JPRB, 0.31755661E-06_JPRB, 0.31756062E-06_JPRB, 0.31756281E-06_JPRB, 0.31756289E-06_JPRB, 0.31756093E-06_JPRB, &
  & 0.31755724E-06_JPRB, 0.31755332E-06_JPRB, 0.31755206E-06_JPRB, 0.31755914E-06_JPRB, 0.31758074E-06_JPRB, 0.31761738E-06_JPRB, &
  & 0.31766024E-06_JPRB, 0.31770151E-06_JPRB, 0.31773860E-06_JPRB, 0.31777211E-06_JPRB, 0.31780351E-06_JPRB, 0.31783358E-06_JPRB, &
  & 0.31786178E-06_JPRB, 0.31788673E-06_JPRB, 0.31790657E-06_JPRB, 0.31792010E-06_JPRB, 0.31792692E-06_JPRB, 0.31792740E-06_JPRB, &
  & 0.31792200E-06_JPRB, 0.31791157E-06_JPRB, 0.31789682E-06_JPRB, 0.31787857E-06_JPRB, 0.31785814E-06_JPRB, 0.31783711E-06_JPRB, &
  & 0.31781741E-06_JPRB, 0.31780002E-06_JPRB, 0.31778535E-06_JPRB, 0.31777282E-06_JPRB, 0.31776236E-06_JPRB, 0.31775389E-06_JPRB, &
  & 0.31774721E-06_JPRB, 0.31774192E-06_JPRB, 0.31773806E-06_JPRB, 0.31773538E-06_JPRB, 0.31773351E-06_JPRB, 0.31773226E-06_JPRB, &
  & 0.31773118E-06_JPRB, 0.31773021E-06_JPRB, 0.31772927E-06_JPRB, 0.31772805E-06_JPRB, 0.31772663E-06_JPRB, 0.31772490E-06_JPRB, &
  & 0.31772311E-06_JPRB, 0.31772134E-06_JPRB, 0.31771938E-06_JPRB, 0.31771634E-06_JPRB /)

RGHG3(:,59, 8) = (/ &
  & 0.31747811E-06_JPRB, 0.31749539E-06_JPRB, 0.31750602E-06_JPRB, 0.31751676E-06_JPRB, 0.31752813E-06_JPRB, 0.31754087E-06_JPRB, &
  & 0.31755152E-06_JPRB, 0.31755880E-06_JPRB, 0.31756394E-06_JPRB, 0.31756795E-06_JPRB, 0.31757185E-06_JPRB, 0.31757605E-06_JPRB, &
  & 0.31758066E-06_JPRB, 0.31758549E-06_JPRB, 0.31758952E-06_JPRB, 0.31759211E-06_JPRB, 0.31759259E-06_JPRB, 0.31759055E-06_JPRB, &
  & 0.31758623E-06_JPRB, 0.31758114E-06_JPRB, 0.31757850E-06_JPRB, 0.31758361E-06_JPRB, 0.31760234E-06_JPRB, 0.31763486E-06_JPRB, &
  & 0.31767374E-06_JPRB, 0.31771205E-06_JPRB, 0.31774732E-06_JPRB, 0.31777964E-06_JPRB, 0.31781025E-06_JPRB, 0.31783955E-06_JPRB, &
  & 0.31786720E-06_JPRB, 0.31789190E-06_JPRB, 0.31791168E-06_JPRB, 0.31792550E-06_JPRB, 0.31793263E-06_JPRB, 0.31793363E-06_JPRB, &
  & 0.31792911E-06_JPRB, 0.31791942E-06_JPRB, 0.31790549E-06_JPRB, 0.31788827E-06_JPRB, 0.31786871E-06_JPRB, 0.31784884E-06_JPRB, &
  & 0.31783011E-06_JPRB, 0.31781369E-06_JPRB, 0.31779965E-06_JPRB, 0.31778771E-06_JPRB, 0.31777782E-06_JPRB, 0.31776983E-06_JPRB, &
  & 0.31776344E-06_JPRB, 0.31775835E-06_JPRB, 0.31775437E-06_JPRB, 0.31775141E-06_JPRB, 0.31774920E-06_JPRB, 0.31774749E-06_JPRB, &
  & 0.31774604E-06_JPRB, 0.31774476E-06_JPRB, 0.31774340E-06_JPRB, 0.31774192E-06_JPRB, 0.31774010E-06_JPRB, 0.31773811E-06_JPRB, &
  & 0.31773610E-06_JPRB, 0.31773413E-06_JPRB, 0.31773209E-06_JPRB, 0.31772856E-06_JPRB /)

RGHG3(:,60, 8) = (/ &
  & 0.31752938E-06_JPRB, 0.31754195E-06_JPRB, 0.31754965E-06_JPRB, 0.31755695E-06_JPRB, 0.31756539E-06_JPRB, 0.31757435E-06_JPRB, &
  & 0.31758267E-06_JPRB, 0.31758867E-06_JPRB, 0.31759291E-06_JPRB, 0.31759649E-06_JPRB, 0.31759993E-06_JPRB, 0.31760374E-06_JPRB, &
  & 0.31760817E-06_JPRB, 0.31761289E-06_JPRB, 0.31761732E-06_JPRB, 0.31762028E-06_JPRB, 0.31762104E-06_JPRB, 0.31761891E-06_JPRB, &
  & 0.31761385E-06_JPRB, 0.31760766E-06_JPRB, 0.31760371E-06_JPRB, 0.31760743E-06_JPRB, 0.31762357E-06_JPRB, 0.31765245E-06_JPRB, &
  & 0.31768766E-06_JPRB, 0.31772345E-06_JPRB, 0.31775690E-06_JPRB, 0.31778816E-06_JPRB, 0.31781769E-06_JPRB, 0.31784631E-06_JPRB, &
  & 0.31787332E-06_JPRB, 0.31789756E-06_JPRB, 0.31791714E-06_JPRB, 0.31793098E-06_JPRB, 0.31793834E-06_JPRB, 0.31793982E-06_JPRB, &
  & 0.31793590E-06_JPRB, 0.31792706E-06_JPRB, 0.31791402E-06_JPRB, 0.31789767E-06_JPRB, 0.31787931E-06_JPRB, 0.31786047E-06_JPRB, &
  & 0.31784282E-06_JPRB, 0.31782702E-06_JPRB, 0.31781377E-06_JPRB, 0.31780240E-06_JPRB, 0.31779308E-06_JPRB, 0.31778541E-06_JPRB, &
  & 0.31777935E-06_JPRB, 0.31777441E-06_JPRB, 0.31777043E-06_JPRB, 0.31776713E-06_JPRB, 0.31776455E-06_JPRB, 0.31776227E-06_JPRB, &
  & 0.31776040E-06_JPRB, 0.31775861E-06_JPRB, 0.31775687E-06_JPRB, 0.31775483E-06_JPRB, 0.31775255E-06_JPRB, 0.31775011E-06_JPRB, &
  & 0.31774772E-06_JPRB, 0.31774550E-06_JPRB, 0.31774309E-06_JPRB, 0.31773922E-06_JPRB /)

RGHG3(:,61, 8) = (/ &
  & 0.31756986E-06_JPRB, 0.31757972E-06_JPRB, 0.31758566E-06_JPRB, 0.31759123E-06_JPRB, 0.31759720E-06_JPRB, 0.31760410E-06_JPRB, &
  & 0.31761064E-06_JPRB, 0.31761573E-06_JPRB, 0.31761957E-06_JPRB, 0.31762283E-06_JPRB, 0.31762619E-06_JPRB, 0.31762997E-06_JPRB, &
  & 0.31763449E-06_JPRB, 0.31763958E-06_JPRB, 0.31764432E-06_JPRB, 0.31764785E-06_JPRB, 0.31764873E-06_JPRB, 0.31764620E-06_JPRB, &
  & 0.31764048E-06_JPRB, 0.31763329E-06_JPRB, 0.31762838E-06_JPRB, 0.31763076E-06_JPRB, 0.31764466E-06_JPRB, 0.31767024E-06_JPRB, &
  & 0.31770224E-06_JPRB, 0.31773553E-06_JPRB, 0.31776739E-06_JPRB, 0.31779740E-06_JPRB, 0.31782616E-06_JPRB, 0.31785387E-06_JPRB, &
  & 0.31788014E-06_JPRB, 0.31790375E-06_JPRB, 0.31792294E-06_JPRB, 0.31793661E-06_JPRB, 0.31794397E-06_JPRB, 0.31794579E-06_JPRB, &
  & 0.31794258E-06_JPRB, 0.31793448E-06_JPRB, 0.31792231E-06_JPRB, 0.31790694E-06_JPRB, 0.31788963E-06_JPRB, 0.31787204E-06_JPRB, &
  & 0.31785527E-06_JPRB, 0.31784046E-06_JPRB, 0.31782776E-06_JPRB, 0.31781701E-06_JPRB, 0.31780800E-06_JPRB, 0.31780073E-06_JPRB, &
  & 0.31779490E-06_JPRB, 0.31779015E-06_JPRB, 0.31778620E-06_JPRB, 0.31778293E-06_JPRB, 0.31777989E-06_JPRB, 0.31777728E-06_JPRB, &
  & 0.31777469E-06_JPRB, 0.31777242E-06_JPRB, 0.31777000E-06_JPRB, 0.31776744E-06_JPRB, 0.31776457E-06_JPRB, 0.31776156E-06_JPRB, &
  & 0.31775869E-06_JPRB, 0.31775599E-06_JPRB, 0.31775303E-06_JPRB, 0.31774820E-06_JPRB /)

RGHG3(:,62, 8) = (/ &
  & 0.31760419E-06_JPRB, 0.31761195E-06_JPRB, 0.31761647E-06_JPRB, 0.31762073E-06_JPRB, 0.31762556E-06_JPRB, 0.31763108E-06_JPRB, &
  & 0.31763670E-06_JPRB, 0.31764137E-06_JPRB, 0.31764500E-06_JPRB, 0.31764824E-06_JPRB, 0.31765154E-06_JPRB, 0.31765546E-06_JPRB, &
  & 0.31766041E-06_JPRB, 0.31766587E-06_JPRB, 0.31767124E-06_JPRB, 0.31767490E-06_JPRB, 0.31767573E-06_JPRB, 0.31767280E-06_JPRB, &
  & 0.31766615E-06_JPRB, 0.31765830E-06_JPRB, 0.31765256E-06_JPRB, 0.31765393E-06_JPRB, 0.31766581E-06_JPRB, 0.31768835E-06_JPRB, &
  & 0.31771751E-06_JPRB, 0.31774854E-06_JPRB, 0.31777870E-06_JPRB, 0.31780769E-06_JPRB, 0.31783546E-06_JPRB, 0.31786240E-06_JPRB, &
  & 0.31788790E-06_JPRB, 0.31791072E-06_JPRB, 0.31792928E-06_JPRB, 0.31794244E-06_JPRB, 0.31794974E-06_JPRB, 0.31795176E-06_JPRB, &
  & 0.31794892E-06_JPRB, 0.31794161E-06_JPRB, 0.31793041E-06_JPRB, 0.31791609E-06_JPRB, 0.31790000E-06_JPRB, 0.31788335E-06_JPRB, &
  & 0.31786772E-06_JPRB, 0.31785362E-06_JPRB, 0.31784168E-06_JPRB, 0.31783136E-06_JPRB, 0.31782284E-06_JPRB, 0.31781585E-06_JPRB, &
  & 0.31781025E-06_JPRB, 0.31780559E-06_JPRB, 0.31780178E-06_JPRB, 0.31779845E-06_JPRB, 0.31779553E-06_JPRB, 0.31779234E-06_JPRB, &
  & 0.31778941E-06_JPRB, 0.31778632E-06_JPRB, 0.31778330E-06_JPRB, 0.31777992E-06_JPRB, 0.31777631E-06_JPRB, 0.31777267E-06_JPRB, &
  & 0.31776929E-06_JPRB, 0.31776591E-06_JPRB, 0.31776221E-06_JPRB, 0.31775591E-06_JPRB /)

RGHG3(:,63, 8) = (/ &
  & 0.31763292E-06_JPRB, 0.31763963E-06_JPRB, 0.31764355E-06_JPRB, 0.31764719E-06_JPRB, 0.31765120E-06_JPRB, 0.31765592E-06_JPRB, &
  & 0.31766092E-06_JPRB, 0.31766535E-06_JPRB, 0.31766908E-06_JPRB, 0.31767246E-06_JPRB, 0.31767615E-06_JPRB, 0.31768059E-06_JPRB, &
  & 0.31768602E-06_JPRB, 0.31769224E-06_JPRB, 0.31769790E-06_JPRB, 0.31770182E-06_JPRB, 0.31770230E-06_JPRB, 0.31769869E-06_JPRB, &
  & 0.31769156E-06_JPRB, 0.31768309E-06_JPRB, 0.31767661E-06_JPRB, 0.31767686E-06_JPRB, 0.31768684E-06_JPRB, 0.31770691E-06_JPRB, &
  & 0.31773337E-06_JPRB, 0.31776241E-06_JPRB, 0.31779106E-06_JPRB, 0.31781892E-06_JPRB, 0.31784583E-06_JPRB, 0.31787181E-06_JPRB, &
  & 0.31789637E-06_JPRB, 0.31791828E-06_JPRB, 0.31793604E-06_JPRB, 0.31794852E-06_JPRB, 0.31795557E-06_JPRB, 0.31795759E-06_JPRB, &
  & 0.31795514E-06_JPRB, 0.31794858E-06_JPRB, 0.31793823E-06_JPRB, 0.31792501E-06_JPRB, 0.31791015E-06_JPRB, 0.31789469E-06_JPRB, &
  & 0.31788002E-06_JPRB, 0.31786681E-06_JPRB, 0.31785549E-06_JPRB, 0.31784572E-06_JPRB, 0.31783750E-06_JPRB, 0.31783080E-06_JPRB, &
  & 0.31782540E-06_JPRB, 0.31782093E-06_JPRB, 0.31781724E-06_JPRB, 0.31781391E-06_JPRB, 0.31781093E-06_JPRB, 0.31780777E-06_JPRB, &
  & 0.31780414E-06_JPRB, 0.31780075E-06_JPRB, 0.31779683E-06_JPRB, 0.31779268E-06_JPRB, 0.31778828E-06_JPRB, 0.31778404E-06_JPRB, &
  & 0.31777992E-06_JPRB, 0.31777597E-06_JPRB, 0.31777105E-06_JPRB, 0.31776312E-06_JPRB /)

RGHG3(:,64, 8) = (/ &
  & 0.31765822E-06_JPRB, 0.31766450E-06_JPRB, 0.31766808E-06_JPRB, 0.31767132E-06_JPRB, 0.31767496E-06_JPRB, 0.31767911E-06_JPRB, &
  & 0.31768388E-06_JPRB, 0.31768823E-06_JPRB, 0.31769218E-06_JPRB, 0.31769602E-06_JPRB, 0.31770008E-06_JPRB, 0.31770526E-06_JPRB, &
  & 0.31771154E-06_JPRB, 0.31771827E-06_JPRB, 0.31772430E-06_JPRB, 0.31772791E-06_JPRB, 0.31772788E-06_JPRB, 0.31772379E-06_JPRB, &
  & 0.31771623E-06_JPRB, 0.31770736E-06_JPRB, 0.31770043E-06_JPRB, 0.31769974E-06_JPRB, 0.31770813E-06_JPRB, 0.31772589E-06_JPRB, &
  & 0.31775005E-06_JPRB, 0.31777697E-06_JPRB, 0.31780422E-06_JPRB, 0.31783108E-06_JPRB, 0.31785692E-06_JPRB, 0.31788190E-06_JPRB, &
  & 0.31790535E-06_JPRB, 0.31792618E-06_JPRB, 0.31794286E-06_JPRB, 0.31795452E-06_JPRB, 0.31796114E-06_JPRB, 0.31796310E-06_JPRB, &
  & 0.31796097E-06_JPRB, 0.31795514E-06_JPRB, 0.31794576E-06_JPRB, 0.31793368E-06_JPRB, 0.31791998E-06_JPRB, 0.31790569E-06_JPRB, &
  & 0.31789210E-06_JPRB, 0.31787971E-06_JPRB, 0.31786897E-06_JPRB, 0.31785970E-06_JPRB, 0.31785197E-06_JPRB, 0.31784555E-06_JPRB, &
  & 0.31784032E-06_JPRB, 0.31783608E-06_JPRB, 0.31783247E-06_JPRB, 0.31782926E-06_JPRB, 0.31782622E-06_JPRB, 0.31782292E-06_JPRB, &
  & 0.31781929E-06_JPRB, 0.31781525E-06_JPRB, 0.31781079E-06_JPRB, 0.31780581E-06_JPRB, 0.31780081E-06_JPRB, 0.31779584E-06_JPRB, &
  & 0.31779129E-06_JPRB, 0.31778632E-06_JPRB, 0.31778049E-06_JPRB, 0.31777000E-06_JPRB /)

RGHG3(:,65, 8) = (/ &
  & 0.31768093E-06_JPRB, 0.31768712E-06_JPRB, 0.31769059E-06_JPRB, 0.31769372E-06_JPRB, 0.31769713E-06_JPRB, 0.31770119E-06_JPRB, &
  & 0.31770566E-06_JPRB, 0.31771037E-06_JPRB, 0.31771458E-06_JPRB, 0.31771901E-06_JPRB, 0.31772385E-06_JPRB, 0.31772973E-06_JPRB, &
  & 0.31773666E-06_JPRB, 0.31774388E-06_JPRB, 0.31774971E-06_JPRB, 0.31775306E-06_JPRB, 0.31775258E-06_JPRB, 0.31774817E-06_JPRB, &
  & 0.31774042E-06_JPRB, 0.31773135E-06_JPRB, 0.31772396E-06_JPRB, 0.31772245E-06_JPRB, 0.31772944E-06_JPRB, 0.31774536E-06_JPRB, &
  & 0.31776739E-06_JPRB, 0.31779237E-06_JPRB, 0.31781818E-06_JPRB, 0.31784373E-06_JPRB, 0.31786857E-06_JPRB, 0.31789233E-06_JPRB, &
  & 0.31791461E-06_JPRB, 0.31793414E-06_JPRB, 0.31794951E-06_JPRB, 0.31796026E-06_JPRB, 0.31796637E-06_JPRB, 0.31796824E-06_JPRB, &
  & 0.31796640E-06_JPRB, 0.31796117E-06_JPRB, 0.31795275E-06_JPRB, 0.31794187E-06_JPRB, 0.31792939E-06_JPRB, 0.31791629E-06_JPRB, &
  & 0.31790373E-06_JPRB, 0.31789213E-06_JPRB, 0.31788207E-06_JPRB, 0.31787346E-06_JPRB, 0.31786601E-06_JPRB, 0.31785996E-06_JPRB, &
  & 0.31785498E-06_JPRB, 0.31785086E-06_JPRB, 0.31784737E-06_JPRB, 0.31784424E-06_JPRB, 0.31784128E-06_JPRB, 0.31783802E-06_JPRB, &
  & 0.31783412E-06_JPRB, 0.31782986E-06_JPRB, 0.31782486E-06_JPRB, 0.31781940E-06_JPRB, 0.31781377E-06_JPRB, 0.31780849E-06_JPRB, &
  & 0.31780311E-06_JPRB, 0.31779766E-06_JPRB, 0.31779032E-06_JPRB, 0.31777773E-06_JPRB /)

RGHG3(:,66, 8) = (/ &
  & 0.31770151E-06_JPRB, 0.31770819E-06_JPRB, 0.31771185E-06_JPRB, 0.31771512E-06_JPRB, 0.31771862E-06_JPRB, 0.31772254E-06_JPRB, &
  & 0.31772720E-06_JPRB, 0.31773169E-06_JPRB, 0.31773672E-06_JPRB, 0.31774147E-06_JPRB, 0.31774712E-06_JPRB, 0.31775383E-06_JPRB, &
  & 0.31776125E-06_JPRB, 0.31776847E-06_JPRB, 0.31777415E-06_JPRB, 0.31777708E-06_JPRB, 0.31777637E-06_JPRB, 0.31777176E-06_JPRB, &
  & 0.31776389E-06_JPRB, 0.31775468E-06_JPRB, 0.31774709E-06_JPRB, 0.31774510E-06_JPRB, 0.31775099E-06_JPRB, 0.31776520E-06_JPRB, &
  & 0.31778524E-06_JPRB, 0.31780846E-06_JPRB, 0.31783259E-06_JPRB, 0.31785675E-06_JPRB, 0.31788022E-06_JPRB, 0.31790273E-06_JPRB, &
  & 0.31792348E-06_JPRB, 0.31794158E-06_JPRB, 0.31795568E-06_JPRB, 0.31796543E-06_JPRB, 0.31797106E-06_JPRB, 0.31797273E-06_JPRB, &
  & 0.31797120E-06_JPRB, 0.31796662E-06_JPRB, 0.31795915E-06_JPRB, 0.31794946E-06_JPRB, 0.31793823E-06_JPRB, 0.31792629E-06_JPRB, &
  & 0.31791481E-06_JPRB, 0.31790415E-06_JPRB, 0.31789477E-06_JPRB, 0.31788665E-06_JPRB, 0.31787968E-06_JPRB, 0.31787397E-06_JPRB, &
  & 0.31786919E-06_JPRB, 0.31786527E-06_JPRB, 0.31786197E-06_JPRB, 0.31785905E-06_JPRB, 0.31785606E-06_JPRB, 0.31785282E-06_JPRB, &
  & 0.31784890E-06_JPRB, 0.31784438E-06_JPRB, 0.31783910E-06_JPRB, 0.31783321E-06_JPRB, 0.31782730E-06_JPRB, 0.31782150E-06_JPRB, &
  & 0.31781582E-06_JPRB, 0.31780976E-06_JPRB, 0.31780141E-06_JPRB, 0.31778657E-06_JPRB /)

RGHG3(:,67, 8) = (/ &
  & 0.31772046E-06_JPRB, 0.31772800E-06_JPRB, 0.31773214E-06_JPRB, 0.31773573E-06_JPRB, 0.31773948E-06_JPRB, 0.31774368E-06_JPRB, &
  & 0.31774820E-06_JPRB, 0.31775340E-06_JPRB, 0.31775829E-06_JPRB, 0.31776409E-06_JPRB, 0.31777017E-06_JPRB, 0.31777734E-06_JPRB, &
  & 0.31778484E-06_JPRB, 0.31779186E-06_JPRB, 0.31779729E-06_JPRB, 0.31779987E-06_JPRB, 0.31779891E-06_JPRB, 0.31779430E-06_JPRB, &
  & 0.31778666E-06_JPRB, 0.31777768E-06_JPRB, 0.31777012E-06_JPRB, 0.31776761E-06_JPRB, 0.31777262E-06_JPRB, 0.31778524E-06_JPRB, &
  & 0.31780340E-06_JPRB, 0.31782474E-06_JPRB, 0.31784717E-06_JPRB, 0.31786971E-06_JPRB, 0.31789170E-06_JPRB, 0.31791271E-06_JPRB, &
  & 0.31793189E-06_JPRB, 0.31794846E-06_JPRB, 0.31796125E-06_JPRB, 0.31797009E-06_JPRB, 0.31797518E-06_JPRB, 0.31797674E-06_JPRB, &
  & 0.31797541E-06_JPRB, 0.31797146E-06_JPRB, 0.31796489E-06_JPRB, 0.31795628E-06_JPRB, 0.31794625E-06_JPRB, 0.31793564E-06_JPRB, &
  & 0.31792521E-06_JPRB, 0.31791546E-06_JPRB, 0.31790682E-06_JPRB, 0.31789932E-06_JPRB, 0.31789281E-06_JPRB, 0.31788741E-06_JPRB, &
  & 0.31788298E-06_JPRB, 0.31787934E-06_JPRB, 0.31787621E-06_JPRB, 0.31787343E-06_JPRB, 0.31787059E-06_JPRB, 0.31786743E-06_JPRB, &
  & 0.31786348E-06_JPRB, 0.31785893E-06_JPRB, 0.31785342E-06_JPRB, 0.31784745E-06_JPRB, 0.31784120E-06_JPRB, 0.31783512E-06_JPRB, &
  & 0.31782909E-06_JPRB, 0.31782270E-06_JPRB, 0.31781354E-06_JPRB, 0.31779649E-06_JPRB /)

RGHG3(:,68, 8) = (/ &
  & 0.31773780E-06_JPRB, 0.31774698E-06_JPRB, 0.31775193E-06_JPRB, 0.31775608E-06_JPRB, 0.31776028E-06_JPRB, 0.31776474E-06_JPRB, &
  & 0.31776963E-06_JPRB, 0.31777464E-06_JPRB, 0.31778058E-06_JPRB, 0.31778617E-06_JPRB, 0.31779302E-06_JPRB, 0.31780007E-06_JPRB, &
  & 0.31780735E-06_JPRB, 0.31781403E-06_JPRB, 0.31781923E-06_JPRB, 0.31782162E-06_JPRB, 0.31782059E-06_JPRB, 0.31781607E-06_JPRB, &
  & 0.31780868E-06_JPRB, 0.31780002E-06_JPRB, 0.31779265E-06_JPRB, 0.31778998E-06_JPRB, 0.31779416E-06_JPRB, 0.31780533E-06_JPRB, &
  & 0.31782164E-06_JPRB, 0.31784111E-06_JPRB, 0.31786163E-06_JPRB, 0.31788255E-06_JPRB, 0.31790285E-06_JPRB, 0.31792217E-06_JPRB, &
  & 0.31793982E-06_JPRB, 0.31795491E-06_JPRB, 0.31796637E-06_JPRB, 0.31797418E-06_JPRB, 0.31797870E-06_JPRB, 0.31798021E-06_JPRB, &
  & 0.31797921E-06_JPRB, 0.31797566E-06_JPRB, 0.31796992E-06_JPRB, 0.31796242E-06_JPRB, 0.31795361E-06_JPRB, 0.31794428E-06_JPRB, &
  & 0.31793488E-06_JPRB, 0.31792609E-06_JPRB, 0.31791819E-06_JPRB, 0.31791126E-06_JPRB, 0.31790537E-06_JPRB, 0.31790037E-06_JPRB, &
  & 0.31789631E-06_JPRB, 0.31789301E-06_JPRB, 0.31789011E-06_JPRB, 0.31788744E-06_JPRB, 0.31788483E-06_JPRB, 0.31788176E-06_JPRB, &
  & 0.31787800E-06_JPRB, 0.31787337E-06_JPRB, 0.31786789E-06_JPRB, 0.31786183E-06_JPRB, 0.31785549E-06_JPRB, 0.31784936E-06_JPRB, &
  & 0.31784316E-06_JPRB, 0.31783668E-06_JPRB, 0.31782693E-06_JPRB, 0.31780871E-06_JPRB /)

RGHG3(:,69, 8) = (/ &
  & 0.31775340E-06_JPRB, 0.31776528E-06_JPRB, 0.31777137E-06_JPRB, 0.31777643E-06_JPRB, 0.31778117E-06_JPRB, 0.31778603E-06_JPRB, &
  & 0.31779103E-06_JPRB, 0.31779646E-06_JPRB, 0.31780229E-06_JPRB, 0.31780837E-06_JPRB, 0.31781505E-06_JPRB, 0.31782199E-06_JPRB, &
  & 0.31782889E-06_JPRB, 0.31783512E-06_JPRB, 0.31784003E-06_JPRB, 0.31784219E-06_JPRB, 0.31784120E-06_JPRB, 0.31783699E-06_JPRB, &
  & 0.31783011E-06_JPRB, 0.31782201E-06_JPRB, 0.31781508E-06_JPRB, 0.31781218E-06_JPRB, 0.31781559E-06_JPRB, 0.31782537E-06_JPRB, &
  & 0.31783989E-06_JPRB, 0.31785731E-06_JPRB, 0.31787604E-06_JPRB, 0.31789509E-06_JPRB, 0.31791356E-06_JPRB, 0.31793127E-06_JPRB, &
  & 0.31794724E-06_JPRB, 0.31796080E-06_JPRB, 0.31797100E-06_JPRB, 0.31797805E-06_JPRB, 0.31798206E-06_JPRB, 0.31798328E-06_JPRB, &
  & 0.31798248E-06_JPRB, 0.31797939E-06_JPRB, 0.31797450E-06_JPRB, 0.31796799E-06_JPRB, 0.31796031E-06_JPRB, 0.31795201E-06_JPRB, &
  & 0.31794369E-06_JPRB, 0.31793596E-06_JPRB, 0.31792888E-06_JPRB, 0.31792263E-06_JPRB, 0.31791726E-06_JPRB, 0.31791276E-06_JPRB, &
  & 0.31790913E-06_JPRB, 0.31790617E-06_JPRB, 0.31790347E-06_JPRB, 0.31790111E-06_JPRB, 0.31789870E-06_JPRB, 0.31789583E-06_JPRB, &
  & 0.31789224E-06_JPRB, 0.31788784E-06_JPRB, 0.31788250E-06_JPRB, 0.31787656E-06_JPRB, 0.31787025E-06_JPRB, 0.31786425E-06_JPRB, &
  & 0.31785808E-06_JPRB, 0.31785171E-06_JPRB, 0.31784185E-06_JPRB, 0.31782230E-06_JPRB /)

RGHG3(:,70, 8) = (/ &
  & 0.31776779E-06_JPRB, 0.31778319E-06_JPRB, 0.31779115E-06_JPRB, 0.31779700E-06_JPRB, 0.31780252E-06_JPRB, 0.31780772E-06_JPRB, &
  & 0.31781295E-06_JPRB, 0.31781835E-06_JPRB, 0.31782426E-06_JPRB, 0.31783009E-06_JPRB, 0.31783651E-06_JPRB, 0.31784305E-06_JPRB, &
  & 0.31784947E-06_JPRB, 0.31785527E-06_JPRB, 0.31785990E-06_JPRB, 0.31786186E-06_JPRB, 0.31786101E-06_JPRB, 0.31785709E-06_JPRB, &
  & 0.31785086E-06_JPRB, 0.31784339E-06_JPRB, 0.31783691E-06_JPRB, 0.31783395E-06_JPRB, 0.31783679E-06_JPRB, 0.31784515E-06_JPRB, &
  & 0.31785788E-06_JPRB, 0.31787323E-06_JPRB, 0.31789008E-06_JPRB, 0.31790731E-06_JPRB, 0.31792393E-06_JPRB, 0.31793988E-06_JPRB, &
  & 0.31795420E-06_JPRB, 0.31796625E-06_JPRB, 0.31797521E-06_JPRB, 0.31798143E-06_JPRB, 0.31798498E-06_JPRB, 0.31798606E-06_JPRB, &
  & 0.31798533E-06_JPRB, 0.31798277E-06_JPRB, 0.31797856E-06_JPRB, 0.31797296E-06_JPRB, 0.31796634E-06_JPRB, 0.31795904E-06_JPRB, &
  & 0.31795182E-06_JPRB, 0.31794502E-06_JPRB, 0.31793888E-06_JPRB, 0.31793323E-06_JPRB, 0.31792845E-06_JPRB, 0.31792447E-06_JPRB, &
  & 0.31792138E-06_JPRB, 0.31791876E-06_JPRB, 0.31791646E-06_JPRB, 0.31791441E-06_JPRB, 0.31791208E-06_JPRB, 0.31790958E-06_JPRB, &
  & 0.31790626E-06_JPRB, 0.31790216E-06_JPRB, 0.31789699E-06_JPRB, 0.31789148E-06_JPRB, 0.31788545E-06_JPRB, 0.31787982E-06_JPRB, &
  & 0.31787383E-06_JPRB, 0.31786772E-06_JPRB, 0.31785822E-06_JPRB, 0.31783904E-06_JPRB /)

RGHG3(:,71, 8) = (/ &
  & 0.31778185E-06_JPRB, 0.31780206E-06_JPRB, 0.31781155E-06_JPRB, 0.31781849E-06_JPRB, 0.31782446E-06_JPRB, 0.31782992E-06_JPRB, &
  & 0.31783517E-06_JPRB, 0.31784040E-06_JPRB, 0.31784626E-06_JPRB, 0.31785143E-06_JPRB, 0.31785748E-06_JPRB, 0.31786348E-06_JPRB, &
  & 0.31786934E-06_JPRB, 0.31787457E-06_JPRB, 0.31787883E-06_JPRB, 0.31788059E-06_JPRB, 0.31787985E-06_JPRB, 0.31787638E-06_JPRB, &
  & 0.31787079E-06_JPRB, 0.31786416E-06_JPRB, 0.31785828E-06_JPRB, 0.31785524E-06_JPRB, 0.31785748E-06_JPRB, 0.31786445E-06_JPRB, &
  & 0.31787550E-06_JPRB, 0.31788886E-06_JPRB, 0.31790381E-06_JPRB, 0.31791919E-06_JPRB, 0.31793388E-06_JPRB, 0.31794804E-06_JPRB, &
  & 0.31796071E-06_JPRB, 0.31797134E-06_JPRB, 0.31797910E-06_JPRB, 0.31798442E-06_JPRB, 0.31798760E-06_JPRB, 0.31798857E-06_JPRB, &
  & 0.31798788E-06_JPRB, 0.31798567E-06_JPRB, 0.31798223E-06_JPRB, 0.31797742E-06_JPRB, 0.31797177E-06_JPRB, 0.31796554E-06_JPRB, &
  & 0.31795918E-06_JPRB, 0.31795338E-06_JPRB, 0.31794821E-06_JPRB, 0.31794326E-06_JPRB, 0.31793905E-06_JPRB, 0.31793564E-06_JPRB, &
  & 0.31793297E-06_JPRB, 0.31793078E-06_JPRB, 0.31792879E-06_JPRB, 0.31792712E-06_JPRB, 0.31792493E-06_JPRB, 0.31792274E-06_JPRB, &
  & 0.31791981E-06_JPRB, 0.31791615E-06_JPRB, 0.31791132E-06_JPRB, 0.31790634E-06_JPRB, 0.31790080E-06_JPRB, 0.31789560E-06_JPRB, &
  & 0.31789014E-06_JPRB, 0.31788437E-06_JPRB, 0.31787593E-06_JPRB, 0.31785785E-06_JPRB /)

RGHG3(:,72, 8) = (/ &
  & 0.31779743E-06_JPRB, 0.31782218E-06_JPRB, 0.31783344E-06_JPRB, 0.31784091E-06_JPRB, 0.31784725E-06_JPRB, 0.31785274E-06_JPRB, &
  & 0.31785785E-06_JPRB, 0.31786294E-06_JPRB, 0.31786780E-06_JPRB, 0.31787309E-06_JPRB, 0.31787778E-06_JPRB, 0.31788358E-06_JPRB, &
  & 0.31788858E-06_JPRB, 0.31789330E-06_JPRB, 0.31789716E-06_JPRB, 0.31789855E-06_JPRB, 0.31789781E-06_JPRB, 0.31789494E-06_JPRB, &
  & 0.31789000E-06_JPRB, 0.31788406E-06_JPRB, 0.31787889E-06_JPRB, 0.31787584E-06_JPRB, 0.31787764E-06_JPRB, 0.31788335E-06_JPRB, &
  & 0.31789264E-06_JPRB, 0.31790398E-06_JPRB, 0.31791706E-06_JPRB, 0.31793064E-06_JPRB, 0.31794340E-06_JPRB, 0.31795582E-06_JPRB, &
  & 0.31796685E-06_JPRB, 0.31797600E-06_JPRB, 0.31798263E-06_JPRB, 0.31798714E-06_JPRB, 0.31798993E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31799013E-06_JPRB, 0.31798822E-06_JPRB, 0.31798544E-06_JPRB, 0.31798129E-06_JPRB, 0.31797683E-06_JPRB, 0.31797143E-06_JPRB, &
  & 0.31796591E-06_JPRB, 0.31796097E-06_JPRB, 0.31795673E-06_JPRB, 0.31795238E-06_JPRB, 0.31794886E-06_JPRB, 0.31794605E-06_JPRB, &
  & 0.31794386E-06_JPRB, 0.31794212E-06_JPRB, 0.31794036E-06_JPRB, 0.31793888E-06_JPRB, 0.31793698E-06_JPRB, 0.31793527E-06_JPRB, &
  & 0.31793272E-06_JPRB, 0.31792962E-06_JPRB, 0.31792527E-06_JPRB, 0.31792084E-06_JPRB, 0.31791598E-06_JPRB, 0.31791143E-06_JPRB, &
  & 0.31790654E-06_JPRB, 0.31790142E-06_JPRB, 0.31789372E-06_JPRB, 0.31787741E-06_JPRB /)

RGHG3(:,73, 8) = (/ &
  & 0.31781823E-06_JPRB, 0.31784504E-06_JPRB, 0.31785660E-06_JPRB, 0.31786419E-06_JPRB, 0.31787036E-06_JPRB, 0.31787573E-06_JPRB, &
  & 0.31788068E-06_JPRB, 0.31788500E-06_JPRB, 0.31789000E-06_JPRB, 0.31789364E-06_JPRB, 0.31789847E-06_JPRB, 0.31790293E-06_JPRB, &
  & 0.31790734E-06_JPRB, 0.31791123E-06_JPRB, 0.31791467E-06_JPRB, 0.31791566E-06_JPRB, 0.31791501E-06_JPRB, 0.31791242E-06_JPRB, &
  & 0.31790825E-06_JPRB, 0.31790310E-06_JPRB, 0.31789864E-06_JPRB, 0.31789565E-06_JPRB, 0.31789708E-06_JPRB, 0.31790154E-06_JPRB, &
  & 0.31790924E-06_JPRB, 0.31791856E-06_JPRB, 0.31792979E-06_JPRB, 0.31794167E-06_JPRB, 0.31795250E-06_JPRB, 0.31796333E-06_JPRB, &
  & 0.31797254E-06_JPRB, 0.31798032E-06_JPRB, 0.31798584E-06_JPRB, 0.31798953E-06_JPRB, 0.31799198E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799053E-06_JPRB, 0.31798831E-06_JPRB, 0.31798487E-06_JPRB, 0.31798140E-06_JPRB, 0.31797691E-06_JPRB, &
  & 0.31797202E-06_JPRB, 0.31796785E-06_JPRB, 0.31796449E-06_JPRB, 0.31796074E-06_JPRB, 0.31795790E-06_JPRB, 0.31795571E-06_JPRB, &
  & 0.31795389E-06_JPRB, 0.31795253E-06_JPRB, 0.31795105E-06_JPRB, 0.31794988E-06_JPRB, 0.31794821E-06_JPRB, 0.31794690E-06_JPRB, &
  & 0.31794480E-06_JPRB, 0.31794227E-06_JPRB, 0.31793849E-06_JPRB, 0.31793468E-06_JPRB, 0.31793058E-06_JPRB, 0.31792661E-06_JPRB, &
  & 0.31792237E-06_JPRB, 0.31791780E-06_JPRB, 0.31791095E-06_JPRB, 0.31789645E-06_JPRB /)

RGHG3(:,74, 8) = (/ &
  & 0.31784163E-06_JPRB, 0.31786885E-06_JPRB, 0.31788042E-06_JPRB, 0.31788730E-06_JPRB, 0.31789335E-06_JPRB, 0.31789824E-06_JPRB, &
  & 0.31790265E-06_JPRB, 0.31790682E-06_JPRB, 0.31791041E-06_JPRB, 0.31791436E-06_JPRB, 0.31791728E-06_JPRB, 0.31792200E-06_JPRB, &
  & 0.31792518E-06_JPRB, 0.31792845E-06_JPRB, 0.31793147E-06_JPRB, 0.31793181E-06_JPRB, 0.31793112E-06_JPRB, 0.31792905E-06_JPRB, &
  & 0.31792538E-06_JPRB, 0.31792089E-06_JPRB, 0.31791726E-06_JPRB, 0.31791444E-06_JPRB, 0.31791552E-06_JPRB, 0.31791893E-06_JPRB, &
  & 0.31792521E-06_JPRB, 0.31793249E-06_JPRB, 0.31794198E-06_JPRB, 0.31795227E-06_JPRB, 0.31796111E-06_JPRB, 0.31797035E-06_JPRB, &
  & 0.31797788E-06_JPRB, 0.31798430E-06_JPRB, 0.31798876E-06_JPRB, 0.31799175E-06_JPRB, 0.31799388E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799385E-06_JPRB, 0.31799252E-06_JPRB, 0.31799087E-06_JPRB, 0.31798797E-06_JPRB, 0.31798555E-06_JPRB, 0.31798180E-06_JPRB, &
  & 0.31797748E-06_JPRB, 0.31797401E-06_JPRB, 0.31797160E-06_JPRB, 0.31796833E-06_JPRB, 0.31796617E-06_JPRB, 0.31796446E-06_JPRB, &
  & 0.31796299E-06_JPRB, 0.31796213E-06_JPRB, 0.31796080E-06_JPRB, 0.31795983E-06_JPRB, 0.31795838E-06_JPRB, 0.31795759E-06_JPRB, &
  & 0.31795582E-06_JPRB, 0.31795386E-06_JPRB, 0.31795062E-06_JPRB, 0.31794741E-06_JPRB, 0.31794426E-06_JPRB, 0.31794085E-06_JPRB, &
  & 0.31793732E-06_JPRB, 0.31793337E-06_JPRB, 0.31792723E-06_JPRB, 0.31791441E-06_JPRB /)

RGHG3(:,75, 8) = (/ &
  & 0.31786610E-06_JPRB, 0.31789313E-06_JPRB, 0.31790364E-06_JPRB, 0.31790984E-06_JPRB, 0.31791532E-06_JPRB, 0.31791961E-06_JPRB, &
  & 0.31792354E-06_JPRB, 0.31792672E-06_JPRB, 0.31793050E-06_JPRB, 0.31793272E-06_JPRB, 0.31793593E-06_JPRB, 0.31793911E-06_JPRB, &
  & 0.31794175E-06_JPRB, 0.31794414E-06_JPRB, 0.31794687E-06_JPRB, 0.31794679E-06_JPRB, 0.31794599E-06_JPRB, 0.31794463E-06_JPRB, &
  & 0.31794150E-06_JPRB, 0.31793769E-06_JPRB, 0.31793482E-06_JPRB, 0.31793212E-06_JPRB, 0.31793294E-06_JPRB, 0.31793536E-06_JPRB, &
  & 0.31794036E-06_JPRB, 0.31794576E-06_JPRB, 0.31795355E-06_JPRB, 0.31796222E-06_JPRB, 0.31796918E-06_JPRB, 0.31797703E-06_JPRB, &
  & 0.31798291E-06_JPRB, 0.31798800E-06_JPRB, 0.31799138E-06_JPRB, 0.31799374E-06_JPRB, 0.31799550E-06_JPRB, 0.31799556E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799428E-06_JPRB, 0.31799317E-06_JPRB, 0.31799081E-06_JPRB, 0.31798945E-06_JPRB, 0.31798635E-06_JPRB, &
  & 0.31798251E-06_JPRB, 0.31797958E-06_JPRB, 0.31797796E-06_JPRB, 0.31797518E-06_JPRB, 0.31797367E-06_JPRB, 0.31797251E-06_JPRB, &
  & 0.31797137E-06_JPRB, 0.31797094E-06_JPRB, 0.31796966E-06_JPRB, 0.31796895E-06_JPRB, 0.31796770E-06_JPRB, 0.31796736E-06_JPRB, &
  & 0.31796591E-06_JPRB, 0.31796446E-06_JPRB, 0.31796168E-06_JPRB, 0.31795912E-06_JPRB, 0.31795682E-06_JPRB, 0.31795406E-06_JPRB, &
  & 0.31795116E-06_JPRB, 0.31794781E-06_JPRB, 0.31794207E-06_JPRB, 0.31793118E-06_JPRB /)

RGHG3(:,76, 8) = (/ &
  & 0.31789185E-06_JPRB, 0.31791666E-06_JPRB, 0.31792621E-06_JPRB, 0.31793098E-06_JPRB, 0.31793599E-06_JPRB, 0.31793942E-06_JPRB, &
  & 0.31794252E-06_JPRB, 0.31794536E-06_JPRB, 0.31794806E-06_JPRB, 0.31795011E-06_JPRB, 0.31795159E-06_JPRB, 0.31795520E-06_JPRB, &
  & 0.31795662E-06_JPRB, 0.31795847E-06_JPRB, 0.31796100E-06_JPRB, 0.31796031E-06_JPRB, 0.31795952E-06_JPRB, 0.31795878E-06_JPRB, &
  & 0.31795636E-06_JPRB, 0.31795318E-06_JPRB, 0.31795105E-06_JPRB, 0.31794838E-06_JPRB, 0.31794923E-06_JPRB, 0.31795088E-06_JPRB, &
  & 0.31795472E-06_JPRB, 0.31795830E-06_JPRB, 0.31796449E-06_JPRB, 0.31797174E-06_JPRB, 0.31797674E-06_JPRB, 0.31798328E-06_JPRB, &
  & 0.31798754E-06_JPRB, 0.31799127E-06_JPRB, 0.31799379E-06_JPRB, 0.31799553E-06_JPRB, 0.31799703E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799684E-06_JPRB, 0.31799584E-06_JPRB, 0.31799527E-06_JPRB, 0.31799323E-06_JPRB, 0.31799297E-06_JPRB, 0.31799058E-06_JPRB, &
  & 0.31798697E-06_JPRB, 0.31798456E-06_JPRB, 0.31798379E-06_JPRB, 0.31798137E-06_JPRB, 0.31798047E-06_JPRB, 0.31797973E-06_JPRB, &
  & 0.31797876E-06_JPRB, 0.31797887E-06_JPRB, 0.31797759E-06_JPRB, 0.31797717E-06_JPRB, 0.31797609E-06_JPRB, 0.31797634E-06_JPRB, &
  & 0.31797509E-06_JPRB, 0.31797407E-06_JPRB, 0.31797163E-06_JPRB, 0.31796975E-06_JPRB, 0.31796850E-06_JPRB, 0.31796634E-06_JPRB, &
  & 0.31796404E-06_JPRB, 0.31796128E-06_JPRB, 0.31795605E-06_JPRB, 0.31794650E-06_JPRB /)

RGHG3(:,77, 8) = (/ &
  & 0.31791780E-06_JPRB, 0.31793959E-06_JPRB, 0.31794735E-06_JPRB, 0.31795076E-06_JPRB, 0.31795497E-06_JPRB, 0.31795744E-06_JPRB, &
  & 0.31795969E-06_JPRB, 0.31796154E-06_JPRB, 0.31796424E-06_JPRB, 0.31796480E-06_JPRB, 0.31796597E-06_JPRB, 0.31796881E-06_JPRB, &
  & 0.31796947E-06_JPRB, 0.31797074E-06_JPRB, 0.31797339E-06_JPRB, 0.31797225E-06_JPRB, 0.31797163E-06_JPRB, 0.31797140E-06_JPRB, &
  & 0.31796978E-06_JPRB, 0.31796725E-06_JPRB, 0.31796594E-06_JPRB, 0.31796327E-06_JPRB, 0.31796424E-06_JPRB, 0.31796512E-06_JPRB, &
  & 0.31796810E-06_JPRB, 0.31796989E-06_JPRB, 0.31797464E-06_JPRB, 0.31798055E-06_JPRB, 0.31798362E-06_JPRB, 0.31798899E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799433E-06_JPRB, 0.31799590E-06_JPRB, 0.31799712E-06_JPRB, 0.31799840E-06_JPRB, 0.31799777E-06_JPRB, &
  & 0.31799811E-06_JPRB, 0.31799709E-06_JPRB, 0.31799712E-06_JPRB, 0.31799533E-06_JPRB, 0.31799630E-06_JPRB, 0.31799439E-06_JPRB, &
  & 0.31799107E-06_JPRB, 0.31798896E-06_JPRB, 0.31798885E-06_JPRB, 0.31798680E-06_JPRB, 0.31798655E-06_JPRB, 0.31798612E-06_JPRB, &
  & 0.31798530E-06_JPRB, 0.31798595E-06_JPRB, 0.31798461E-06_JPRB, 0.31798453E-06_JPRB, 0.31798342E-06_JPRB, 0.31798430E-06_JPRB, &
  & 0.31798319E-06_JPRB, 0.31798271E-06_JPRB, 0.31798049E-06_JPRB, 0.31797936E-06_JPRB, 0.31797913E-06_JPRB, 0.31797745E-06_JPRB, &
  & 0.31797563E-06_JPRB, 0.31797376E-06_JPRB, 0.31796850E-06_JPRB, 0.31796114E-06_JPRB /)

RGHG3(:,78, 8) = (/ &
  & 0.31794414E-06_JPRB, 0.31796054E-06_JPRB, 0.31796606E-06_JPRB, 0.31796759E-06_JPRB, 0.31797131E-06_JPRB, 0.31797265E-06_JPRB, &
  & 0.31797404E-06_JPRB, 0.31797498E-06_JPRB, 0.31797725E-06_JPRB, 0.31797683E-06_JPRB, 0.31797677E-06_JPRB, 0.31798007E-06_JPRB, &
  & 0.31797993E-06_JPRB, 0.31798078E-06_JPRB, 0.31798353E-06_JPRB, 0.31798186E-06_JPRB, 0.31798146E-06_JPRB, 0.31798172E-06_JPRB, &
  & 0.31798086E-06_JPRB, 0.31797896E-06_JPRB, 0.31797856E-06_JPRB, 0.31797578E-06_JPRB, 0.31797705E-06_JPRB, 0.31797725E-06_JPRB, &
  & 0.31797970E-06_JPRB, 0.31797987E-06_JPRB, 0.31798342E-06_JPRB, 0.31798825E-06_JPRB, 0.31798953E-06_JPRB, 0.31799394E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799698E-06_JPRB, 0.31799772E-06_JPRB, 0.31799840E-06_JPRB, 0.31799954E-06_JPRB, 0.31799865E-06_JPRB, &
  & 0.31799928E-06_JPRB, 0.31799820E-06_JPRB, 0.31799868E-06_JPRB, 0.31799703E-06_JPRB, 0.31799902E-06_JPRB, 0.31799775E-06_JPRB, &
  & 0.31799448E-06_JPRB, 0.31799260E-06_JPRB, 0.31799314E-06_JPRB, 0.31799132E-06_JPRB, 0.31799158E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799064E-06_JPRB, 0.31799189E-06_JPRB, 0.31799030E-06_JPRB, 0.31799044E-06_JPRB, 0.31798930E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31798979E-06_JPRB, 0.31798982E-06_JPRB, 0.31798771E-06_JPRB, 0.31798709E-06_JPRB, 0.31798805E-06_JPRB, 0.31798686E-06_JPRB, &
  & 0.31798550E-06_JPRB, 0.31798427E-06_JPRB, 0.31797950E-06_JPRB, 0.31797458E-06_JPRB /)

RGHG3(:,79, 8) = (/ &
  & 0.31796154E-06_JPRB, 0.31797245E-06_JPRB, 0.31797617E-06_JPRB, 0.31797637E-06_JPRB, 0.31797993E-06_JPRB, 0.31798066E-06_JPRB, &
  & 0.31798152E-06_JPRB, 0.31798177E-06_JPRB, 0.31798436E-06_JPRB, 0.31798299E-06_JPRB, 0.31798240E-06_JPRB, 0.31798592E-06_JPRB, &
  & 0.31798527E-06_JPRB, 0.31798601E-06_JPRB, 0.31798899E-06_JPRB, 0.31798692E-06_JPRB, 0.31798655E-06_JPRB, 0.31798723E-06_JPRB, &
  & 0.31798686E-06_JPRB, 0.31798521E-06_JPRB, 0.31798541E-06_JPRB, 0.31798231E-06_JPRB, 0.31798390E-06_JPRB, 0.31798373E-06_JPRB, &
  & 0.31798595E-06_JPRB, 0.31798504E-06_JPRB, 0.31798805E-06_JPRB, 0.31799254E-06_JPRB, 0.31799277E-06_JPRB, 0.31799684E-06_JPRB, &
  & 0.31799743E-06_JPRB, 0.31799854E-06_JPRB, 0.31799868E-06_JPRB, 0.31799919E-06_JPRB, 0.31800033E-06_JPRB, 0.31799908E-06_JPRB, &
  & 0.31799999E-06_JPRB, 0.31799888E-06_JPRB, 0.31799973E-06_JPRB, 0.31799803E-06_JPRB, 0.31800082E-06_JPRB, 0.31799976E-06_JPRB, &
  & 0.31799632E-06_JPRB, 0.31799442E-06_JPRB, 0.31799544E-06_JPRB, 0.31799362E-06_JPRB, 0.31799422E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799513E-06_JPRB, 0.31799320E-06_JPRB, 0.31799360E-06_JPRB, 0.31799229E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799325E-06_JPRB, 0.31799362E-06_JPRB, 0.31799132E-06_JPRB, 0.31799104E-06_JPRB, 0.31799289E-06_JPRB, 0.31799181E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31798996E-06_JPRB, 0.31798518E-06_JPRB, 0.31798322E-06_JPRB /)

RGHG3(:,80, 8) = (/ &
  & 0.31797344E-06_JPRB, 0.31797833E-06_JPRB, 0.31798069E-06_JPRB, 0.31798015E-06_JPRB, 0.31798373E-06_JPRB, 0.31798413E-06_JPRB, &
  & 0.31798476E-06_JPRB, 0.31798473E-06_JPRB, 0.31798754E-06_JPRB, 0.31798575E-06_JPRB, 0.31798476E-06_JPRB, 0.31798851E-06_JPRB, &
  & 0.31798760E-06_JPRB, 0.31798831E-06_JPRB, 0.31799158E-06_JPRB, 0.31798919E-06_JPRB, 0.31798885E-06_JPRB, 0.31798973E-06_JPRB, &
  & 0.31798965E-06_JPRB, 0.31798814E-06_JPRB, 0.31798868E-06_JPRB, 0.31798518E-06_JPRB, 0.31798706E-06_JPRB, 0.31798660E-06_JPRB, &
  & 0.31798879E-06_JPRB, 0.31798731E-06_JPRB, 0.31799019E-06_JPRB, 0.31799456E-06_JPRB, 0.31799425E-06_JPRB, 0.31799831E-06_JPRB, &
  & 0.31799851E-06_JPRB, 0.31799934E-06_JPRB, 0.31799922E-06_JPRB, 0.31799962E-06_JPRB, 0.31800073E-06_JPRB, 0.31799934E-06_JPRB, &
  & 0.31800039E-06_JPRB, 0.31799917E-06_JPRB, 0.31800025E-06_JPRB, 0.31799863E-06_JPRB, 0.31800184E-06_JPRB, 0.31800084E-06_JPRB, &
  & 0.31799718E-06_JPRB, 0.31799516E-06_JPRB, 0.31799644E-06_JPRB, 0.31799459E-06_JPRB, 0.31799536E-06_JPRB, 0.31799553E-06_JPRB, &
  & 0.31799448E-06_JPRB, 0.31799669E-06_JPRB, 0.31799442E-06_JPRB, 0.31799493E-06_JPRB, 0.31799348E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799476E-06_JPRB, 0.31799533E-06_JPRB, 0.31799280E-06_JPRB, 0.31799274E-06_JPRB, 0.31799516E-06_JPRB, 0.31799408E-06_JPRB, &
  & 0.31799303E-06_JPRB, 0.31799249E-06_JPRB, 0.31798774E-06_JPRB, 0.31798893E-06_JPRB /)

RGHG3(:,81, 8) = (/ &
  & 0.31798206E-06_JPRB, 0.31798086E-06_JPRB, 0.31798260E-06_JPRB, 0.31798172E-06_JPRB, 0.31798547E-06_JPRB, 0.31798581E-06_JPRB, &
  & 0.31798626E-06_JPRB, 0.31798635E-06_JPRB, 0.31798888E-06_JPRB, 0.31798666E-06_JPRB, 0.31798567E-06_JPRB, 0.31798979E-06_JPRB, &
  & 0.31798868E-06_JPRB, 0.31798933E-06_JPRB, 0.31799274E-06_JPRB, 0.31799019E-06_JPRB, 0.31798987E-06_JPRB, 0.31799090E-06_JPRB, &
  & 0.31799098E-06_JPRB, 0.31798936E-06_JPRB, 0.31799016E-06_JPRB, 0.31798629E-06_JPRB, 0.31798851E-06_JPRB, 0.31798788E-06_JPRB, &
  & 0.31799010E-06_JPRB, 0.31798828E-06_JPRB, 0.31799112E-06_JPRB, 0.31799556E-06_JPRB, 0.31799505E-06_JPRB, 0.31799894E-06_JPRB, &
  & 0.31799902E-06_JPRB, 0.31799979E-06_JPRB, 0.31799954E-06_JPRB, 0.31799985E-06_JPRB, 0.31800101E-06_JPRB, 0.31799948E-06_JPRB, &
  & 0.31800059E-06_JPRB, 0.31799937E-06_JPRB, 0.31800050E-06_JPRB, 0.31799894E-06_JPRB, 0.31800241E-06_JPRB, 0.31800144E-06_JPRB, &
  & 0.31799766E-06_JPRB, 0.31799556E-06_JPRB, 0.31799686E-06_JPRB, 0.31799496E-06_JPRB, 0.31799595E-06_JPRB, 0.31799615E-06_JPRB, &
  & 0.31799502E-06_JPRB, 0.31799749E-06_JPRB, 0.31799496E-06_JPRB, 0.31799553E-06_JPRB, 0.31799394E-06_JPRB, 0.31799701E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799615E-06_JPRB, 0.31799337E-06_JPRB, 0.31799334E-06_JPRB, 0.31799618E-06_JPRB, 0.31799516E-06_JPRB, &
  & 0.31799408E-06_JPRB, 0.31799371E-06_JPRB, 0.31798876E-06_JPRB, 0.31799303E-06_JPRB /)

RGHG3(:,82, 8) = (/ &
  & 0.31798268E-06_JPRB, 0.31798169E-06_JPRB, 0.31798345E-06_JPRB, 0.31798245E-06_JPRB, 0.31798632E-06_JPRB, 0.31798663E-06_JPRB, &
  & 0.31798689E-06_JPRB, 0.31798669E-06_JPRB, 0.31798936E-06_JPRB, 0.31798766E-06_JPRB, 0.31798652E-06_JPRB, 0.31798996E-06_JPRB, &
  & 0.31798911E-06_JPRB, 0.31798984E-06_JPRB, 0.31799334E-06_JPRB, 0.31799070E-06_JPRB, 0.31799033E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799169E-06_JPRB, 0.31799007E-06_JPRB, 0.31799101E-06_JPRB, 0.31798680E-06_JPRB, 0.31798928E-06_JPRB, 0.31798842E-06_JPRB, &
  & 0.31799073E-06_JPRB, 0.31798868E-06_JPRB, 0.31799155E-06_JPRB, 0.31799610E-06_JPRB, 0.31799544E-06_JPRB, 0.31799931E-06_JPRB, &
  & 0.31799928E-06_JPRB, 0.31799999E-06_JPRB, 0.31799971E-06_JPRB, 0.31799993E-06_JPRB, 0.31800116E-06_JPRB, 0.31799956E-06_JPRB, &
  & 0.31800073E-06_JPRB, 0.31799939E-06_JPRB, 0.31800067E-06_JPRB, 0.31799914E-06_JPRB, 0.31800261E-06_JPRB, 0.31800170E-06_JPRB, &
  & 0.31799786E-06_JPRB, 0.31799567E-06_JPRB, 0.31799706E-06_JPRB, 0.31799519E-06_JPRB, 0.31799624E-06_JPRB, 0.31799647E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799789E-06_JPRB, 0.31799519E-06_JPRB, 0.31799590E-06_JPRB, 0.31799414E-06_JPRB, 0.31799755E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799658E-06_JPRB, 0.31799362E-06_JPRB, 0.31799368E-06_JPRB, 0.31799678E-06_JPRB, 0.31799570E-06_JPRB, &
  & 0.31799459E-06_JPRB, 0.31799419E-06_JPRB, 0.31798905E-06_JPRB, 0.31799337E-06_JPRB /)

RGHG3(:,83, 8) = (/ &
  & 0.31798317E-06_JPRB, 0.31798220E-06_JPRB, 0.31798396E-06_JPRB, 0.31798288E-06_JPRB, 0.31798675E-06_JPRB, 0.31798703E-06_JPRB, &
  & 0.31798737E-06_JPRB, 0.31798771E-06_JPRB, 0.31798959E-06_JPRB, 0.31798734E-06_JPRB, 0.31798663E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31798947E-06_JPRB, 0.31799021E-06_JPRB, 0.31799368E-06_JPRB, 0.31799101E-06_JPRB, 0.31799061E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31799041E-06_JPRB, 0.31799152E-06_JPRB, 0.31798709E-06_JPRB, 0.31798979E-06_JPRB, 0.31798871E-06_JPRB, &
  & 0.31799115E-06_JPRB, 0.31798882E-06_JPRB, 0.31799186E-06_JPRB, 0.31799641E-06_JPRB, 0.31799564E-06_JPRB, 0.31799948E-06_JPRB, &
  & 0.31799945E-06_JPRB, 0.31800013E-06_JPRB, 0.31799982E-06_JPRB, 0.31800008E-06_JPRB, 0.31800124E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31800082E-06_JPRB, 0.31799945E-06_JPRB, 0.31800073E-06_JPRB, 0.31799928E-06_JPRB, 0.31800278E-06_JPRB, 0.31800190E-06_JPRB, &
  & 0.31799800E-06_JPRB, 0.31799578E-06_JPRB, 0.31799718E-06_JPRB, 0.31799527E-06_JPRB, 0.31799638E-06_JPRB, 0.31799667E-06_JPRB, &
  & 0.31799550E-06_JPRB, 0.31799817E-06_JPRB, 0.31799533E-06_JPRB, 0.31799615E-06_JPRB, 0.31799425E-06_JPRB, 0.31799780E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799684E-06_JPRB, 0.31799374E-06_JPRB, 0.31799379E-06_JPRB, 0.31799712E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799487E-06_JPRB, 0.31799459E-06_JPRB, 0.31798916E-06_JPRB, 0.31799360E-06_JPRB /)

RGHG3(:,84, 8) = (/ &
  & 0.31798353E-06_JPRB, 0.31798260E-06_JPRB, 0.31798430E-06_JPRB, 0.31798305E-06_JPRB, 0.31798709E-06_JPRB, 0.31798734E-06_JPRB, &
  & 0.31798757E-06_JPRB, 0.31798749E-06_JPRB, 0.31798959E-06_JPRB, 0.31798837E-06_JPRB, 0.31798757E-06_JPRB, 0.31799001E-06_JPRB, &
  & 0.31798970E-06_JPRB, 0.31799053E-06_JPRB, 0.31799362E-06_JPRB, 0.31799121E-06_JPRB, 0.31799084E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799237E-06_JPRB, 0.31799067E-06_JPRB, 0.31799183E-06_JPRB, 0.31798712E-06_JPRB, 0.31799007E-06_JPRB, 0.31798885E-06_JPRB, &
  & 0.31799149E-06_JPRB, 0.31798885E-06_JPRB, 0.31799186E-06_JPRB, 0.31799669E-06_JPRB, 0.31799581E-06_JPRB, 0.31799965E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31800022E-06_JPRB, 0.31799988E-06_JPRB, 0.31800013E-06_JPRB, 0.31800130E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31800087E-06_JPRB, 0.31799945E-06_JPRB, 0.31800082E-06_JPRB, 0.31799942E-06_JPRB, 0.31800286E-06_JPRB, 0.31800204E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799584E-06_JPRB, 0.31799721E-06_JPRB, 0.31799530E-06_JPRB, 0.31799644E-06_JPRB, 0.31799678E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799829E-06_JPRB, 0.31799541E-06_JPRB, 0.31799627E-06_JPRB, 0.31799425E-06_JPRB, 0.31799803E-06_JPRB, &
  & 0.31799615E-06_JPRB, 0.31799706E-06_JPRB, 0.31799382E-06_JPRB, 0.31799385E-06_JPRB, 0.31799738E-06_JPRB, 0.31799624E-06_JPRB, &
  & 0.31799510E-06_JPRB, 0.31799485E-06_JPRB, 0.31798925E-06_JPRB, 0.31799379E-06_JPRB /)

RGHG3(:,85, 8) = (/ &
  & 0.31798371E-06_JPRB, 0.31798280E-06_JPRB, 0.31798453E-06_JPRB, 0.31798322E-06_JPRB, 0.31798731E-06_JPRB, 0.31798757E-06_JPRB, &
  & 0.31798788E-06_JPRB, 0.31798828E-06_JPRB, 0.31798939E-06_JPRB, 0.31798811E-06_JPRB, 0.31798783E-06_JPRB, 0.31799010E-06_JPRB, &
  & 0.31799004E-06_JPRB, 0.31799090E-06_JPRB, 0.31799308E-06_JPRB, 0.31799141E-06_JPRB, 0.31799107E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799252E-06_JPRB, 0.31799078E-06_JPRB, 0.31799209E-06_JPRB, 0.31798712E-06_JPRB, 0.31799027E-06_JPRB, 0.31798893E-06_JPRB, &
  & 0.31799169E-06_JPRB, 0.31798879E-06_JPRB, 0.31799209E-06_JPRB, 0.31799684E-06_JPRB, 0.31799590E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799968E-06_JPRB, 0.31800033E-06_JPRB, 0.31799988E-06_JPRB, 0.31800016E-06_JPRB, 0.31800136E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31800087E-06_JPRB, 0.31799945E-06_JPRB, 0.31800084E-06_JPRB, 0.31799948E-06_JPRB, 0.31800298E-06_JPRB, 0.31800224E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799587E-06_JPRB, 0.31799721E-06_JPRB, 0.31799536E-06_JPRB, 0.31799652E-06_JPRB, 0.31799689E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799840E-06_JPRB, 0.31799553E-06_JPRB, 0.31799644E-06_JPRB, 0.31799433E-06_JPRB, 0.31799814E-06_JPRB, &
  & 0.31799621E-06_JPRB, 0.31799721E-06_JPRB, 0.31799382E-06_JPRB, 0.31799385E-06_JPRB, 0.31799752E-06_JPRB, 0.31799638E-06_JPRB, &
  & 0.31799522E-06_JPRB, 0.31799499E-06_JPRB, 0.31798930E-06_JPRB, 0.31799385E-06_JPRB /)

RGHG3(:,86, 8) = (/ &
  & 0.31798385E-06_JPRB, 0.31798299E-06_JPRB, 0.31798473E-06_JPRB, 0.31798334E-06_JPRB, 0.31798746E-06_JPRB, 0.31798763E-06_JPRB, &
  & 0.31798797E-06_JPRB, 0.31798808E-06_JPRB, 0.31798930E-06_JPRB, 0.31798868E-06_JPRB, 0.31798851E-06_JPRB, 0.31798982E-06_JPRB, &
  & 0.31799019E-06_JPRB, 0.31799092E-06_JPRB, 0.31799254E-06_JPRB, 0.31799161E-06_JPRB, 0.31799129E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799260E-06_JPRB, 0.31799101E-06_JPRB, 0.31799220E-06_JPRB, 0.31798717E-06_JPRB, 0.31799044E-06_JPRB, 0.31798896E-06_JPRB, &
  & 0.31799198E-06_JPRB, 0.31798868E-06_JPRB, 0.31799192E-06_JPRB, 0.31799709E-06_JPRB, 0.31799584E-06_JPRB, 0.31799988E-06_JPRB, &
  & 0.31799971E-06_JPRB, 0.31800033E-06_JPRB, 0.31799996E-06_JPRB, 0.31800019E-06_JPRB, 0.31800141E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31800096E-06_JPRB, 0.31799937E-06_JPRB, 0.31800084E-06_JPRB, 0.31799939E-06_JPRB, 0.31800315E-06_JPRB, 0.31800232E-06_JPRB, &
  & 0.31799840E-06_JPRB, 0.31799578E-06_JPRB, 0.31799721E-06_JPRB, 0.31799536E-06_JPRB, 0.31799652E-06_JPRB, 0.31799698E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799843E-06_JPRB, 0.31799559E-06_JPRB, 0.31799652E-06_JPRB, 0.31799433E-06_JPRB, 0.31799820E-06_JPRB, &
  & 0.31799627E-06_JPRB, 0.31799729E-06_JPRB, 0.31799382E-06_JPRB, 0.31799385E-06_JPRB, 0.31799766E-06_JPRB, 0.31799652E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799522E-06_JPRB, 0.31798933E-06_JPRB, 0.31799402E-06_JPRB /)

RGHG3(:,87, 8) = (/ &
  & 0.31798390E-06_JPRB, 0.31798314E-06_JPRB, 0.31798484E-06_JPRB, 0.31798356E-06_JPRB, 0.31798737E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31798805E-06_JPRB, 0.31798845E-06_JPRB, 0.31798916E-06_JPRB, 0.31798871E-06_JPRB, 0.31798874E-06_JPRB, 0.31798993E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31799101E-06_JPRB, 0.31799220E-06_JPRB, 0.31799161E-06_JPRB, 0.31799146E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799263E-06_JPRB, 0.31799112E-06_JPRB, 0.31799237E-06_JPRB, 0.31798720E-06_JPRB, 0.31799050E-06_JPRB, 0.31798899E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31798854E-06_JPRB, 0.31799189E-06_JPRB, 0.31799721E-06_JPRB, 0.31799578E-06_JPRB, 0.31800005E-06_JPRB, &
  & 0.31799971E-06_JPRB, 0.31800045E-06_JPRB, 0.31799999E-06_JPRB, 0.31800030E-06_JPRB, 0.31800153E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31800107E-06_JPRB, 0.31799934E-06_JPRB, 0.31800096E-06_JPRB, 0.31799928E-06_JPRB, 0.31800340E-06_JPRB, 0.31800263E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799561E-06_JPRB, 0.31799723E-06_JPRB, 0.31799541E-06_JPRB, 0.31799655E-06_JPRB, 0.31799701E-06_JPRB, &
  & 0.31799587E-06_JPRB, 0.31799831E-06_JPRB, 0.31799564E-06_JPRB, 0.31799655E-06_JPRB, 0.31799436E-06_JPRB, 0.31799826E-06_JPRB, &
  & 0.31799635E-06_JPRB, 0.31799732E-06_JPRB, 0.31799377E-06_JPRB, 0.31799377E-06_JPRB, 0.31799777E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799530E-06_JPRB, 0.31798930E-06_JPRB, 0.31799405E-06_JPRB /)

RGHG3(:,88, 8) = (/ &
  & 0.31798396E-06_JPRB, 0.31798328E-06_JPRB, 0.31798479E-06_JPRB, 0.31798351E-06_JPRB, 0.31798751E-06_JPRB, 0.31798774E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798828E-06_JPRB, 0.31798919E-06_JPRB, 0.31798885E-06_JPRB, 0.31798888E-06_JPRB, 0.31798987E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31799090E-06_JPRB, 0.31799203E-06_JPRB, 0.31799161E-06_JPRB, 0.31799149E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799260E-06_JPRB, 0.31799121E-06_JPRB, 0.31799243E-06_JPRB, 0.31798726E-06_JPRB, 0.31799061E-06_JPRB, 0.31798893E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31798842E-06_JPRB, 0.31799178E-06_JPRB, 0.31799743E-06_JPRB, 0.31799561E-06_JPRB, 0.31800033E-06_JPRB, &
  & 0.31799976E-06_JPRB, 0.31800050E-06_JPRB, 0.31800005E-06_JPRB, 0.31800033E-06_JPRB, 0.31800164E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31800116E-06_JPRB, 0.31799928E-06_JPRB, 0.31800110E-06_JPRB, 0.31799905E-06_JPRB, 0.31800380E-06_JPRB, 0.31800295E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799544E-06_JPRB, 0.31799732E-06_JPRB, 0.31799539E-06_JPRB, 0.31799652E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799831E-06_JPRB, 0.31799573E-06_JPRB, 0.31799658E-06_JPRB, 0.31799436E-06_JPRB, 0.31799829E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799743E-06_JPRB, 0.31799377E-06_JPRB, 0.31799379E-06_JPRB, 0.31799789E-06_JPRB, 0.31799667E-06_JPRB, &
  & 0.31799556E-06_JPRB, 0.31799541E-06_JPRB, 0.31798928E-06_JPRB, 0.31799408E-06_JPRB /)

RGHG3(:,89, 8) = (/ &
  & 0.31798399E-06_JPRB, 0.31798345E-06_JPRB, 0.31798476E-06_JPRB, 0.31798368E-06_JPRB, 0.31798746E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31798808E-06_JPRB, 0.31798851E-06_JPRB, 0.31798930E-06_JPRB, 0.31798871E-06_JPRB, 0.31798868E-06_JPRB, 0.31798993E-06_JPRB, &
  & 0.31799033E-06_JPRB, 0.31799107E-06_JPRB, 0.31799226E-06_JPRB, 0.31799163E-06_JPRB, 0.31799146E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799271E-06_JPRB, 0.31799118E-06_JPRB, 0.31799257E-06_JPRB, 0.31798720E-06_JPRB, 0.31799064E-06_JPRB, 0.31798891E-06_JPRB, &
  & 0.31799232E-06_JPRB, 0.31798828E-06_JPRB, 0.31799175E-06_JPRB, 0.31799760E-06_JPRB, 0.31799561E-06_JPRB, 0.31800053E-06_JPRB, &
  & 0.31799976E-06_JPRB, 0.31800059E-06_JPRB, 0.31800010E-06_JPRB, 0.31800042E-06_JPRB, 0.31800178E-06_JPRB, 0.31799968E-06_JPRB, &
  & 0.31800130E-06_JPRB, 0.31799917E-06_JPRB, 0.31800121E-06_JPRB, 0.31799874E-06_JPRB, 0.31800411E-06_JPRB, 0.31800329E-06_JPRB, &
  & 0.31799803E-06_JPRB, 0.31799522E-06_JPRB, 0.31799749E-06_JPRB, 0.31799544E-06_JPRB, 0.31799658E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799829E-06_JPRB, 0.31799573E-06_JPRB, 0.31799652E-06_JPRB, 0.31799436E-06_JPRB, 0.31799829E-06_JPRB, &
  & 0.31799638E-06_JPRB, 0.31799749E-06_JPRB, 0.31799371E-06_JPRB, 0.31799371E-06_JPRB, 0.31799794E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799553E-06_JPRB, 0.31798928E-06_JPRB, 0.31799416E-06_JPRB /)

RGHG3(:,90, 8) = (/ &
  & 0.31798402E-06_JPRB, 0.31798356E-06_JPRB, 0.31798464E-06_JPRB, 0.31798345E-06_JPRB, 0.31798766E-06_JPRB, 0.31798768E-06_JPRB, &
  & 0.31798794E-06_JPRB, 0.31798805E-06_JPRB, 0.31798959E-06_JPRB, 0.31798857E-06_JPRB, 0.31798828E-06_JPRB, 0.31798993E-06_JPRB, &
  & 0.31799021E-06_JPRB, 0.31799098E-06_JPRB, 0.31799280E-06_JPRB, 0.31799169E-06_JPRB, 0.31799138E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799291E-06_JPRB, 0.31799107E-06_JPRB, 0.31799283E-06_JPRB, 0.31798697E-06_JPRB, 0.31799078E-06_JPRB, 0.31798876E-06_JPRB, &
  & 0.31799263E-06_JPRB, 0.31798811E-06_JPRB, 0.31799169E-06_JPRB, 0.31799783E-06_JPRB, 0.31799539E-06_JPRB, 0.31800082E-06_JPRB, &
  & 0.31799973E-06_JPRB, 0.31800064E-06_JPRB, 0.31800005E-06_JPRB, 0.31800039E-06_JPRB, 0.31800198E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31800141E-06_JPRB, 0.31799902E-06_JPRB, 0.31800141E-06_JPRB, 0.31799837E-06_JPRB, 0.31800445E-06_JPRB, 0.31800363E-06_JPRB, &
  & 0.31799792E-06_JPRB, 0.31799490E-06_JPRB, 0.31799763E-06_JPRB, 0.31799527E-06_JPRB, 0.31799667E-06_JPRB, 0.31799715E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799837E-06_JPRB, 0.31799570E-06_JPRB, 0.31799664E-06_JPRB, 0.31799422E-06_JPRB, 0.31799846E-06_JPRB, &
  & 0.31799635E-06_JPRB, 0.31799766E-06_JPRB, 0.31799360E-06_JPRB, 0.31799365E-06_JPRB, 0.31799820E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799561E-06_JPRB, 0.31798908E-06_JPRB, 0.31799414E-06_JPRB /)

RGHG3(:,91, 8) = (/ &
  & 0.31798405E-06_JPRB, 0.31798373E-06_JPRB, 0.31798481E-06_JPRB, 0.31798271E-06_JPRB, 0.31798800E-06_JPRB, 0.31798768E-06_JPRB, &
  & 0.31798794E-06_JPRB, 0.31798706E-06_JPRB, 0.31799209E-06_JPRB, 0.31798757E-06_JPRB, 0.31798550E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31798959E-06_JPRB, 0.31799016E-06_JPRB, 0.31799536E-06_JPRB, 0.31799104E-06_JPRB, 0.31799075E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799331E-06_JPRB, 0.31799070E-06_JPRB, 0.31799340E-06_JPRB, 0.31798632E-06_JPRB, 0.31799115E-06_JPRB, 0.31798842E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31798757E-06_JPRB, 0.31799155E-06_JPRB, 0.31799846E-06_JPRB, 0.31799479E-06_JPRB, 0.31800133E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31800084E-06_JPRB, 0.31799999E-06_JPRB, 0.31800030E-06_JPRB, 0.31800235E-06_JPRB, 0.31799931E-06_JPRB, &
  & 0.31800172E-06_JPRB, 0.31799871E-06_JPRB, 0.31800175E-06_JPRB, 0.31799772E-06_JPRB, 0.31800499E-06_JPRB, 0.31800408E-06_JPRB, &
  & 0.31799769E-06_JPRB, 0.31799431E-06_JPRB, 0.31799820E-06_JPRB, 0.31799502E-06_JPRB, 0.31799681E-06_JPRB, 0.31799735E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799891E-06_JPRB, 0.31799541E-06_JPRB, 0.31799695E-06_JPRB, 0.31799365E-06_JPRB, 0.31799897E-06_JPRB, &
  & 0.31799615E-06_JPRB, 0.31799803E-06_JPRB, 0.31799337E-06_JPRB, 0.31799337E-06_JPRB, 0.31799863E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799550E-06_JPRB, 0.31799590E-06_JPRB, 0.31798862E-06_JPRB, 0.31799425E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG3(:, 1, 9) = (/ &
  & 0.93666756E-07_JPRB, 0.93666330E-07_JPRB, 0.93664354E-07_JPRB, 0.93660603E-07_JPRB, 0.93655501E-07_JPRB, 0.93649113E-07_JPRB, &
  & 0.93641674E-07_JPRB, 0.93633915E-07_JPRB, 0.93626930E-07_JPRB, 0.93622276E-07_JPRB, 0.93621665E-07_JPRB, 0.93626142E-07_JPRB, &
  & 0.93634959E-07_JPRB, 0.93645937E-07_JPRB, 0.93659594E-07_JPRB, 0.93674572E-07_JPRB, 0.93687561E-07_JPRB, 0.93694837E-07_JPRB, &
  & 0.93692606E-07_JPRB, 0.93678516E-07_JPRB, 0.93650868E-07_JPRB, 0.93613131E-07_JPRB, 0.93562740E-07_JPRB, 0.93497292E-07_JPRB, &
  & 0.93426102E-07_JPRB, 0.93354664E-07_JPRB, 0.93281479E-07_JPRB, 0.93200356E-07_JPRB, 0.93124015E-07_JPRB, 0.93094414E-07_JPRB, &
  & 0.93090037E-07_JPRB, 0.93093846E-07_JPRB, 0.93102322E-07_JPRB, 0.93113279E-07_JPRB, 0.93125941E-07_JPRB, 0.93140244E-07_JPRB, &
  & 0.93151812E-07_JPRB, 0.93157972E-07_JPRB, 0.93156224E-07_JPRB, 0.93132073E-07_JPRB, 0.93087593E-07_JPRB, 0.93035290E-07_JPRB, &
  & 0.92962935E-07_JPRB, 0.92864269E-07_JPRB, 0.92732286E-07_JPRB, 0.92560057E-07_JPRB, 0.92338858E-07_JPRB, 0.92057881E-07_JPRB, &
  & 0.91713730E-07_JPRB, 0.91294602E-07_JPRB, 0.90835762E-07_JPRB, 0.90369404E-07_JPRB, 0.89924946E-07_JPRB, 0.89539625E-07_JPRB, &
  & 0.89211390E-07_JPRB, 0.88943089E-07_JPRB, 0.88724335E-07_JPRB, 0.88544319E-07_JPRB, 0.88398274E-07_JPRB, 0.88283315E-07_JPRB, &
  & 0.88195584E-07_JPRB, 0.88131685E-07_JPRB, 0.88094573E-07_JPRB, 0.88083873E-07_JPRB /)

RGHG3(:, 2, 9) = (/ &
  & 0.93167415E-07_JPRB, 0.93128676E-07_JPRB, 0.93114544E-07_JPRB, 0.93115794E-07_JPRB, 0.93134446E-07_JPRB, 0.93172709E-07_JPRB, &
  & 0.93231044E-07_JPRB, 0.93308415E-07_JPRB, 0.93397702E-07_JPRB, 0.93493377E-07_JPRB, 0.93592973E-07_JPRB, 0.93695391E-07_JPRB, &
  & 0.93798832E-07_JPRB, 0.93900368E-07_JPRB, 0.93994899E-07_JPRB, 0.94080022E-07_JPRB, 0.94156306E-07_JPRB, 0.94220361E-07_JPRB, &
  & 0.94264863E-07_JPRB, 0.94283251E-07_JPRB, 0.94267691E-07_JPRB, 0.94207806E-07_JPRB, 0.94098766E-07_JPRB, 0.93954746E-07_JPRB, &
  & 0.93809604E-07_JPRB, 0.93656581E-07_JPRB, 0.93516014E-07_JPRB, 0.93421718E-07_JPRB, 0.93408012E-07_JPRB, 0.93485852E-07_JPRB, &
  & 0.93635919E-07_JPRB, 0.93845145E-07_JPRB, 0.94115109E-07_JPRB, 0.94425999E-07_JPRB, 0.94750646E-07_JPRB, 0.95061367E-07_JPRB, &
  & 0.95349137E-07_JPRB, 0.95611895E-07_JPRB, 0.95845330E-07_JPRB, 0.96008904E-07_JPRB, 0.96063467E-07_JPRB, 0.96002736E-07_JPRB, &
  & 0.95844463E-07_JPRB, 0.95596469E-07_JPRB, 0.95252069E-07_JPRB, 0.94813579E-07_JPRB, 0.94289028E-07_JPRB, 0.93679667E-07_JPRB, &
  & 0.93009120E-07_JPRB, 0.92308419E-07_JPRB, 0.91611255E-07_JPRB, 0.90959460E-07_JPRB, 0.90371799E-07_JPRB, 0.89867413E-07_JPRB, &
  & 0.89442366E-07_JPRB, 0.89090520E-07_JPRB, 0.88802608E-07_JPRB, 0.88566267E-07_JPRB, 0.88375039E-07_JPRB, 0.88226088E-07_JPRB, &
  & 0.88117879E-07_JPRB, 0.88050342E-07_JPRB, 0.88016776E-07_JPRB, 0.88009827E-07_JPRB /)

RGHG3(:, 3, 9) = (/ &
  & 0.92175853E-07_JPRB, 0.92229612E-07_JPRB, 0.92319247E-07_JPRB, 0.92436252E-07_JPRB, 0.92580926E-07_JPRB, 0.92757148E-07_JPRB, &
  & 0.92956839E-07_JPRB, 0.93173369E-07_JPRB, 0.93390184E-07_JPRB, 0.93600377E-07_JPRB, 0.93807039E-07_JPRB, 0.94015178E-07_JPRB, &
  & 0.94225435E-07_JPRB, 0.94435507E-07_JPRB, 0.94645642E-07_JPRB, 0.94848382E-07_JPRB, 0.95027019E-07_JPRB, 0.95173945E-07_JPRB, &
  & 0.95287191E-07_JPRB, 0.95358324E-07_JPRB, 0.95371448E-07_JPRB, 0.95313069E-07_JPRB, 0.95189449E-07_JPRB, 0.95026756E-07_JPRB, &
  & 0.94841930E-07_JPRB, 0.94663555E-07_JPRB, 0.94547168E-07_JPRB, 0.94551702E-07_JPRB, 0.94716896E-07_JPRB, 0.95049096E-07_JPRB, &
  & 0.95526538E-07_JPRB, 0.96126499E-07_JPRB, 0.96800683E-07_JPRB, 0.97498550E-07_JPRB, 0.98156143E-07_JPRB, 0.98751094E-07_JPRB, &
  & 0.99282225E-07_JPRB, 0.99762893E-07_JPRB, 0.10017948E-06_JPRB, 0.10049550E-06_JPRB, 0.10062940E-06_JPRB, 0.10053710E-06_JPRB, &
  & 0.10022561E-06_JPRB, 0.99705083E-07_JPRB, 0.98994931E-07_JPRB, 0.98117191E-07_JPRB, 0.97108369E-07_JPRB, 0.96007739E-07_JPRB, &
  & 0.94864532E-07_JPRB, 0.93745648E-07_JPRB, 0.92693725E-07_JPRB, 0.91729248E-07_JPRB, 0.90890396E-07_JPRB, 0.90174403E-07_JPRB, &
  & 0.89565148E-07_JPRB, 0.89065971E-07_JPRB, 0.88668116E-07_JPRB, 0.88363961E-07_JPRB, 0.88151268E-07_JPRB, 0.88015497E-07_JPRB, &
  & 0.87937615E-07_JPRB, 0.87898833E-07_JPRB, 0.87888317E-07_JPRB, 0.87898748E-07_JPRB /)

RGHG3(:, 4, 9) = (/ &
  & 0.91892865E-07_JPRB, 0.92039926E-07_JPRB, 0.92192479E-07_JPRB, 0.92367948E-07_JPRB, 0.92583846E-07_JPRB, 0.92831513E-07_JPRB, &
  & 0.93106323E-07_JPRB, 0.93406946E-07_JPRB, 0.93719621E-07_JPRB, 0.94034924E-07_JPRB, 0.94348408E-07_JPRB, 0.94659590E-07_JPRB, &
  & 0.94975157E-07_JPRB, 0.95295071E-07_JPRB, 0.95607909E-07_JPRB, 0.95914054E-07_JPRB, 0.96220560E-07_JPRB, 0.96514128E-07_JPRB, &
  & 0.96770464E-07_JPRB, 0.96971831E-07_JPRB, 0.97106394E-07_JPRB, 0.97169249E-07_JPRB, 0.97166627E-07_JPRB, 0.97114764E-07_JPRB, &
  & 0.97045941E-07_JPRB, 0.97007145E-07_JPRB, 0.97069567E-07_JPRB, 0.97294979E-07_JPRB, 0.97711776E-07_JPRB, 0.98315162E-07_JPRB, &
  & 0.99091935E-07_JPRB, 0.10001289E-06_JPRB, 0.10103677E-06_JPRB, 0.10207629E-06_JPRB, 0.10307073E-06_JPRB, 0.10397864E-06_JPRB, &
  & 0.10480165E-06_JPRB, 0.10554510E-06_JPRB, 0.10620283E-06_JPRB, 0.10671506E-06_JPRB, 0.10699124E-06_JPRB, 0.10692705E-06_JPRB, &
  & 0.10648198E-06_JPRB, 0.10568080E-06_JPRB, 0.10456900E-06_JPRB, 0.10321718E-06_JPRB, 0.10170080E-06_JPRB, 0.10009065E-06_JPRB, &
  & 0.98444275E-07_JPRB, 0.96811178E-07_JPRB, 0.95250869E-07_JPRB, 0.93803678E-07_JPRB, 0.92471993E-07_JPRB, 0.91291277E-07_JPRB, &
  & 0.90283365E-07_JPRB, 0.89439254E-07_JPRB, 0.88762995E-07_JPRB, 0.88253095E-07_JPRB, 0.87890939E-07_JPRB, 0.87654143E-07_JPRB, &
  & 0.87524391E-07_JPRB, 0.87485006E-07_JPRB, 0.87515886E-07_JPRB, 0.87622738E-07_JPRB /)

RGHG3(:, 5, 9) = (/ &
  & 0.91933373E-07_JPRB, 0.91967237E-07_JPRB, 0.92138727E-07_JPRB, 0.92403461E-07_JPRB, 0.92738276E-07_JPRB, 0.93139306E-07_JPRB, &
  & 0.93569469E-07_JPRB, 0.94014439E-07_JPRB, 0.94462223E-07_JPRB, 0.94918192E-07_JPRB, 0.95395407E-07_JPRB, 0.95891160E-07_JPRB, &
  & 0.96386188E-07_JPRB, 0.96869087E-07_JPRB, 0.97341342E-07_JPRB, 0.97794342E-07_JPRB, 0.98221442E-07_JPRB, 0.98634565E-07_JPRB, &
  & 0.99042524E-07_JPRB, 0.99439191E-07_JPRB, 0.99811786E-07_JPRB, 0.10014993E-06_JPRB, 0.10044423E-06_JPRB, 0.10069263E-06_JPRB, &
  & 0.10092069E-06_JPRB, 0.10116926E-06_JPRB, 0.10148988E-06_JPRB, 0.10194483E-06_JPRB, 0.10256410E-06_JPRB, 0.10335869E-06_JPRB, &
  & 0.10432472E-06_JPRB, 0.10544657E-06_JPRB, 0.10669048E-06_JPRB, 0.10800451E-06_JPRB, 0.10931957E-06_JPRB, 0.11058950E-06_JPRB, &
  & 0.11178012E-06_JPRB, 0.11286735E-06_JPRB, 0.11382054E-06_JPRB, 0.11457654E-06_JPRB, 0.11501791E-06_JPRB, 0.11502551E-06_JPRB, &
  & 0.11453886E-06_JPRB, 0.11358518E-06_JPRB, 0.11225016E-06_JPRB, 0.11064028E-06_JPRB, 0.10884990E-06_JPRB, 0.10694518E-06_JPRB, &
  & 0.10496488E-06_JPRB, 0.10293016E-06_JPRB, 0.10085623E-06_JPRB, 0.98780099E-07_JPRB, 0.96751549E-07_JPRB, 0.94801088E-07_JPRB, &
  & 0.92992437E-07_JPRB, 0.91388237E-07_JPRB, 0.90023185E-07_JPRB, 0.88917190E-07_JPRB, 0.88087617E-07_JPRB, 0.87520611E-07_JPRB, &
  & 0.87183459E-07_JPRB, 0.87030926E-07_JPRB, 0.87026407E-07_JPRB, 0.87197897E-07_JPRB /)

RGHG3(:, 6, 9) = (/ &
  & 0.92139636E-07_JPRB, 0.92272394E-07_JPRB, 0.92531025E-07_JPRB, 0.92888506E-07_JPRB, 0.93332325E-07_JPRB, 0.93840271E-07_JPRB, &
  & 0.94390209E-07_JPRB, 0.94968925E-07_JPRB, 0.95577377E-07_JPRB, 0.96218528E-07_JPRB, 0.96886296E-07_JPRB, 0.97573718E-07_JPRB, &
  & 0.98275990E-07_JPRB, 0.98974184E-07_JPRB, 0.99646030E-07_JPRB, 0.10029168E-06_JPRB, 0.10091969E-06_JPRB, 0.10153146E-06_JPRB, &
  & 0.10213617E-06_JPRB, 0.10275072E-06_JPRB, 0.10338756E-06_JPRB, 0.10405039E-06_JPRB, 0.10473518E-06_JPRB, 0.10543044E-06_JPRB, &
  & 0.10611990E-06_JPRB, 0.10680726E-06_JPRB, 0.10750750E-06_JPRB, 0.10823561E-06_JPRB, 0.10902718E-06_JPRB, 0.10991182E-06_JPRB, &
  & 0.11091658E-06_JPRB, 0.11206475E-06_JPRB, 0.11336904E-06_JPRB, 0.11482741E-06_JPRB, 0.11640822E-06_JPRB, 0.11804666E-06_JPRB, &
  & 0.11966603E-06_JPRB, 0.12118818E-06_JPRB, 0.12253403E-06_JPRB, 0.12360529E-06_JPRB, 0.12427400E-06_JPRB, 0.12441959E-06_JPRB, &
  & 0.12398658E-06_JPRB, 0.12301494E-06_JPRB, 0.12161877E-06_JPRB, 0.11991419E-06_JPRB, 0.11799271E-06_JPRB, 0.11589648E-06_JPRB, &
  & 0.11363450E-06_JPRB, 0.11120406E-06_JPRB, 0.10860921E-06_JPRB, 0.10586397E-06_JPRB, 0.10301245E-06_JPRB, 0.10014958E-06_JPRB, &
  & 0.97364229E-07_JPRB, 0.94779850E-07_JPRB, 0.92496308E-07_JPRB, 0.90598341E-07_JPRB, 0.89107949E-07_JPRB, 0.88017977E-07_JPRB, &
  & 0.87284533E-07_JPRB, 0.86852381E-07_JPRB, 0.86656875E-07_JPRB, 0.86717286E-07_JPRB /)

RGHG3(:, 7, 9) = (/ &
  & 0.92587939E-07_JPRB, 0.92905005E-07_JPRB, 0.93256212E-07_JPRB, 0.93668064E-07_JPRB, 0.94179541E-07_JPRB, 0.94776738E-07_JPRB, &
  & 0.95447206E-07_JPRB, 0.96174112E-07_JPRB, 0.96951240E-07_JPRB, 0.97774446E-07_JPRB, 0.98643724E-07_JPRB, 0.99539974E-07_JPRB, &
  & 0.10043007E-06_JPRB, 0.10129344E-06_JPRB, 0.10212724E-06_JPRB, 0.10292885E-06_JPRB, 0.10370663E-06_JPRB, 0.10448402E-06_JPRB, &
  & 0.10528321E-06_JPRB, 0.10612484E-06_JPRB, 0.10703859E-06_JPRB, 0.10805708E-06_JPRB, 0.10920322E-06_JPRB, 0.11047100E-06_JPRB, &
  & 0.11180208E-06_JPRB, 0.11311191E-06_JPRB, 0.11433571E-06_JPRB, 0.11547080E-06_JPRB, 0.11654454E-06_JPRB, 0.11760590E-06_JPRB, &
  & 0.11870149E-06_JPRB, 0.11987682E-06_JPRB, 0.12121255E-06_JPRB, 0.12276217E-06_JPRB, 0.12453722E-06_JPRB, 0.12648806E-06_JPRB, &
  & 0.12851599E-06_JPRB, 0.13049588E-06_JPRB, 0.13228970E-06_JPRB, 0.13375102E-06_JPRB, 0.13473425E-06_JPRB, 0.13509856E-06_JPRB, &
  & 0.13479276E-06_JPRB, 0.13386665E-06_JPRB, 0.13242745E-06_JPRB, 0.13059983E-06_JPRB, 0.12846691E-06_JPRB, 0.12606050E-06_JPRB, &
  & 0.12337324E-06_JPRB, 0.12038737E-06_JPRB, 0.11709945E-06_JPRB, 0.11354307E-06_JPRB, 0.10977883E-06_JPRB, 0.10591472E-06_JPRB, &
  & 0.10212244E-06_JPRB, 0.98568364E-07_JPRB, 0.95410243E-07_JPRB, 0.92721294E-07_JPRB, 0.90560619E-07_JPRB, 0.88921496E-07_JPRB, &
  & 0.87776307E-07_JPRB, 0.87024915E-07_JPRB, 0.86575923E-07_JPRB, 0.86335426E-07_JPRB /)

RGHG3(:, 8, 9) = (/ &
  & 0.93368250E-07_JPRB, 0.93932215E-07_JPRB, 0.94354185E-07_JPRB, 0.94817004E-07_JPRB, 0.95362701E-07_JPRB, 0.96019150E-07_JPRB, &
  & 0.96780383E-07_JPRB, 0.97634860E-07_JPRB, 0.98567256E-07_JPRB, 0.99570414E-07_JPRB, 0.10062371E-06_JPRB, 0.10170327E-06_JPRB, &
  & 0.10278254E-06_JPRB, 0.10382723E-06_JPRB, 0.10481568E-06_JPRB, 0.10575765E-06_JPRB, 0.10667807E-06_JPRB, 0.10760433E-06_JPRB, &
  & 0.10857157E-06_JPRB, 0.10962557E-06_JPRB, 0.11081868E-06_JPRB, 0.11221372E-06_JPRB, 0.11386814E-06_JPRB, 0.11580389E-06_JPRB, &
  & 0.11794836E-06_JPRB, 0.12013903E-06_JPRB, 0.12223524E-06_JPRB, 0.12413676E-06_JPRB, 0.12582696E-06_JPRB, 0.12732318E-06_JPRB, &
  & 0.12867551E-06_JPRB, 0.12998186E-06_JPRB, 0.13137580E-06_JPRB, 0.13298359E-06_JPRB, 0.13485960E-06_JPRB, 0.13698732E-06_JPRB, &
  & 0.13927129E-06_JPRB, 0.14156426E-06_JPRB, 0.14369333E-06_JPRB, 0.14547697E-06_JPRB, 0.14673429E-06_JPRB, 0.14732589E-06_JPRB, &
  & 0.14716919E-06_JPRB, 0.14627926E-06_JPRB, 0.14474998E-06_JPRB, 0.14269554E-06_JPRB, 0.14020056E-06_JPRB, 0.13730798E-06_JPRB, &
  & 0.13401285E-06_JPRB, 0.13029661E-06_JPRB, 0.12616547E-06_JPRB, 0.12166697E-06_JPRB, 0.11689752E-06_JPRB, 0.11202211E-06_JPRB, &
  & 0.10722147E-06_JPRB, 0.10272860E-06_JPRB, 0.98682023E-07_JPRB, 0.95225644E-07_JPRB, 0.92414609E-07_JPRB, 0.90259725E-07_JPRB, &
  & 0.88697313E-07_JPRB, 0.87619433E-07_JPRB, 0.86860311E-07_JPRB, 0.86226315E-07_JPRB /)

RGHG3(:, 9, 9) = (/ &
  & 0.94608900E-07_JPRB, 0.95391570E-07_JPRB, 0.95894670E-07_JPRB, 0.96398935E-07_JPRB, 0.96973224E-07_JPRB, 0.97668817E-07_JPRB, &
  & 0.98495974E-07_JPRB, 0.99445721E-07_JPRB, 0.10050395E-06_JPRB, 0.10164933E-06_JPRB, 0.10286369E-06_JPRB, 0.10411252E-06_JPRB, &
  & 0.10535171E-06_JPRB, 0.10654825E-06_JPRB, 0.10768903E-06_JPRB, 0.10877683E-06_JPRB, 0.10983636E-06_JPRB, 0.11090994E-06_JPRB, &
  & 0.11204793E-06_JPRB, 0.11331084E-06_JPRB, 0.11478042E-06_JPRB, 0.11657022E-06_JPRB, 0.11881035E-06_JPRB, 0.12158303E-06_JPRB, &
  & 0.12480987E-06_JPRB, 0.12824214E-06_JPRB, 0.13156085E-06_JPRB, 0.13457736E-06_JPRB, 0.13722946E-06_JPRB, 0.13954266E-06_JPRB, &
  & 0.14157625E-06_JPRB, 0.14342609E-06_JPRB, 0.14523154E-06_JPRB, 0.14711136E-06_JPRB, 0.14915827E-06_JPRB, 0.15138417E-06_JPRB, &
  & 0.15372773E-06_JPRB, 0.15604655E-06_JPRB, 0.15817216E-06_JPRB, 0.15992204E-06_JPRB, 0.16114009E-06_JPRB, 0.16168248E-06_JPRB, &
  & 0.16145101E-06_JPRB, 0.16041906E-06_JPRB, 0.15863137E-06_JPRB, 0.15617427E-06_JPRB, 0.15315322E-06_JPRB, 0.14961275E-06_JPRB, &
  & 0.14557642E-06_JPRB, 0.14105719E-06_JPRB, 0.13607166E-06_JPRB, 0.13068971E-06_JPRB, 0.12503723E-06_JPRB, 0.11928688E-06_JPRB, &
  & 0.11366743E-06_JPRB, 0.10836725E-06_JPRB, 0.10357884E-06_JPRB, 0.99413896E-07_JPRB, 0.95964232E-07_JPRB, 0.93236679E-07_JPRB, &
  & 0.91164857E-07_JPRB, 0.89638839E-07_JPRB, 0.88378130E-07_JPRB, 0.87050381E-07_JPRB /)

RGHG3(:,10, 9) = (/ &
  & 0.96420820E-07_JPRB, 0.97377658E-07_JPRB, 0.97995134E-07_JPRB, 0.98544369E-07_JPRB, 0.99180163E-07_JPRB, 0.99916399E-07_JPRB, &
  & 0.10079916E-06_JPRB, 0.10182042E-06_JPRB, 0.10296554E-06_JPRB, 0.10421575E-06_JPRB, 0.10554084E-06_JPRB, 0.10690275E-06_JPRB, &
  & 0.10826149E-06_JPRB, 0.10957534E-06_JPRB, 0.11082303E-06_JPRB, 0.11201328E-06_JPRB, 0.11317660E-06_JPRB, 0.11435792E-06_JPRB, &
  & 0.11561563E-06_JPRB, 0.11702998E-06_JPRB, 0.11871089E-06_JPRB, 0.12080403E-06_JPRB, 0.12347800E-06_JPRB, 0.12686709E-06_JPRB, &
  & 0.13093519E-06_JPRB, 0.13542808E-06_JPRB, 0.14010641E-06_JPRB, 0.14480746E-06_JPRB, 0.14940046E-06_JPRB, 0.15374529E-06_JPRB, &
  & 0.15771984E-06_JPRB, 0.16126721E-06_JPRB, 0.16437198E-06_JPRB, 0.16711152E-06_JPRB, 0.16958754E-06_JPRB, 0.17188057E-06_JPRB, &
  & 0.17397309E-06_JPRB, 0.17580010E-06_JPRB, 0.17725688E-06_JPRB, 0.17824702E-06_JPRB, 0.17869380E-06_JPRB, 0.17851166E-06_JPRB, &
  & 0.17763821E-06_JPRB, 0.17602365E-06_JPRB, 0.17365879E-06_JPRB, 0.17060520E-06_JPRB, 0.16692263E-06_JPRB, 0.16269665E-06_JPRB, &
  & 0.15797528E-06_JPRB, 0.15279250E-06_JPRB, 0.14720531E-06_JPRB, 0.14129576E-06_JPRB, 0.13519036E-06_JPRB, 0.12907350E-06_JPRB, &
  & 0.12312023E-06_JPRB, 0.11752812E-06_JPRB, 0.11243751E-06_JPRB, 0.10794946E-06_JPRB, 0.10409818E-06_JPRB, 0.10087512E-06_JPRB, &
  & 0.98253643E-07_JPRB, 0.95981378E-07_JPRB, 0.93999311E-07_JPRB, 0.91017114E-07_JPRB /)

RGHG3(:,11, 9) = (/ &
  & 0.98880449E-07_JPRB, 0.10015295E-06_JPRB, 0.10084788E-06_JPRB, 0.10153970E-06_JPRB, 0.10223648E-06_JPRB, 0.10307065E-06_JPRB, &
  & 0.10403198E-06_JPRB, 0.10514015E-06_JPRB, 0.10638014E-06_JPRB, 0.10773321E-06_JPRB, 0.10917301E-06_JPRB, 0.11066292E-06_JPRB, &
  & 0.11215498E-06_JPRB, 0.11360733E-06_JPRB, 0.11499930E-06_JPRB, 0.11633085E-06_JPRB, 0.11762711E-06_JPRB, 0.11894146E-06_JPRB, &
  & 0.12033794E-06_JPRB, 0.12190654E-06_JPRB, 0.12377367E-06_JPRB, 0.12611777E-06_JPRB, 0.12916445E-06_JPRB, 0.13311478E-06_JPRB, &
  & 0.13800459E-06_JPRB, 0.14366134E-06_JPRB, 0.14980711E-06_JPRB, 0.15613247E-06_JPRB, 0.16247991E-06_JPRB, 0.16874856E-06_JPRB, &
  & 0.17473620E-06_JPRB, 0.18015267E-06_JPRB, 0.18482035E-06_JPRB, 0.18869753E-06_JPRB, 0.19182554E-06_JPRB, 0.19427138E-06_JPRB, &
  & 0.19605844E-06_JPRB, 0.19721328E-06_JPRB, 0.19773859E-06_JPRB, 0.19766574E-06_JPRB, 0.19701569E-06_JPRB, 0.19579737E-06_JPRB, &
  & 0.19398611E-06_JPRB, 0.19155272E-06_JPRB, 0.18847709E-06_JPRB, 0.18477851E-06_JPRB, 0.18054054E-06_JPRB, 0.17582954E-06_JPRB, &
  & 0.17072421E-06_JPRB, 0.16530529E-06_JPRB, 0.15964406E-06_JPRB, 0.15382753E-06_JPRB, 0.14797389E-06_JPRB, 0.14222586E-06_JPRB, &
  & 0.13674047E-06_JPRB, 0.13164613E-06_JPRB, 0.12703246E-06_JPRB, 0.12290893E-06_JPRB, 0.11927065E-06_JPRB, 0.11605791E-06_JPRB, &
  & 0.11315546E-06_JPRB, 0.11055038E-06_JPRB, 0.10745774E-06_JPRB, 0.10284530E-06_JPRB /)

RGHG3(:,12, 9) = (/ &
  & 0.10223821E-06_JPRB, 0.10378544E-06_JPRB, 0.10475178E-06_JPRB, 0.10553831E-06_JPRB, 0.10641963E-06_JPRB, 0.10737781E-06_JPRB, &
  & 0.10849938E-06_JPRB, 0.10977416E-06_JPRB, 0.11120172E-06_JPRB, 0.11276707E-06_JPRB, 0.11444656E-06_JPRB, 0.11619915E-06_JPRB, &
  & 0.11797458E-06_JPRB, 0.11971466E-06_JPRB, 0.12138676E-06_JPRB, 0.12296432E-06_JPRB, 0.12447970E-06_JPRB, 0.12598224E-06_JPRB, &
  & 0.12754131E-06_JPRB, 0.12925369E-06_JPRB, 0.13123775E-06_JPRB, 0.13365786E-06_JPRB, 0.13671922E-06_JPRB, 0.14063446E-06_JPRB, &
  & 0.14551100E-06_JPRB, 0.15127952E-06_JPRB, 0.15780854E-06_JPRB, 0.16496791E-06_JPRB, 0.17256480E-06_JPRB, 0.18029939E-06_JPRB, &
  & 0.18778380E-06_JPRB, 0.19465708E-06_JPRB, 0.20060676E-06_JPRB, 0.20549584E-06_JPRB, 0.20929375E-06_JPRB, 0.21205487E-06_JPRB, &
  & 0.21381990E-06_JPRB, 0.21467756E-06_JPRB, 0.21469975E-06_JPRB, 0.21399133E-06_JPRB, 0.21264509E-06_JPRB, 0.21071708E-06_JPRB, &
  & 0.20823563E-06_JPRB, 0.20521168E-06_JPRB, 0.20165146E-06_JPRB, 0.19759683E-06_JPRB, 0.19311696E-06_JPRB, 0.18831577E-06_JPRB, &
  & 0.18330860E-06_JPRB, 0.17819573E-06_JPRB, 0.17307140E-06_JPRB, 0.16800226E-06_JPRB, 0.16308205E-06_JPRB, 0.15841866E-06_JPRB, &
  & 0.15410156E-06_JPRB, 0.15017814E-06_JPRB, 0.14665702E-06_JPRB, 0.14348164E-06_JPRB, 0.14061595E-06_JPRB, 0.13795176E-06_JPRB, &
  & 0.13547863E-06_JPRB, 0.13285430E-06_JPRB, 0.13002590E-06_JPRB, 0.12424833E-06_JPRB /)

RGHG3(:,13, 9) = (/ &
  & 0.10628666E-06_JPRB, 0.10828293E-06_JPRB, 0.10937214E-06_JPRB, 0.11038878E-06_JPRB, 0.11140256E-06_JPRB, 0.11258231E-06_JPRB, &
  & 0.11394602E-06_JPRB, 0.11554206E-06_JPRB, 0.11738035E-06_JPRB, 0.11945970E-06_JPRB, 0.12176112E-06_JPRB, 0.12423564E-06_JPRB, &
  & 0.12681124E-06_JPRB, 0.12938962E-06_JPRB, 0.13190618E-06_JPRB, 0.13429731E-06_JPRB, 0.13651379E-06_JPRB, 0.13858272E-06_JPRB, &
  & 0.14053106E-06_JPRB, 0.14242478E-06_JPRB, 0.14438658E-06_JPRB, 0.14657059E-06_JPRB, 0.14917475E-06_JPRB, 0.15242398E-06_JPRB, &
  & 0.15650242E-06_JPRB, 0.16153167E-06_JPRB, 0.16751065E-06_JPRB, 0.17440442E-06_JPRB, 0.18203468E-06_JPRB, 0.19008532E-06_JPRB, &
  & 0.19814766E-06_JPRB, 0.20569566E-06_JPRB, 0.21233136E-06_JPRB, 0.21781740E-06_JPRB, 0.22208084E-06_JPRB, 0.22512342E-06_JPRB, &
  & 0.22700372E-06_JPRB, 0.22781313E-06_JPRB, 0.22766866E-06_JPRB, 0.22670154E-06_JPRB, 0.22503464E-06_JPRB, 0.22276924E-06_JPRB, &
  & 0.21997288E-06_JPRB, 0.21669216E-06_JPRB, 0.21297045E-06_JPRB, 0.20887607E-06_JPRB, 0.20451219E-06_JPRB, 0.20000809E-06_JPRB, &
  & 0.19549339E-06_JPRB, 0.19108484E-06_JPRB, 0.18685296E-06_JPRB, 0.18285107E-06_JPRB, 0.17913321E-06_JPRB, 0.17575350E-06_JPRB, &
  & 0.17273530E-06_JPRB, 0.17007430E-06_JPRB, 0.16772714E-06_JPRB, 0.16562340E-06_JPRB, 0.16370754E-06_JPRB, 0.16190094E-06_JPRB, &
  & 0.16012167E-06_JPRB, 0.15830204E-06_JPRB, 0.15592111E-06_JPRB, 0.15153324E-06_JPRB /)

RGHG3(:,14, 9) = (/ &
  & 0.11060539E-06_JPRB, 0.11284740E-06_JPRB, 0.11412966E-06_JPRB, 0.11530372E-06_JPRB, 0.11660954E-06_JPRB, 0.11816242E-06_JPRB, &
  & 0.12008121E-06_JPRB, 0.12244449E-06_JPRB, 0.12529864E-06_JPRB, 0.12864464E-06_JPRB, 0.13243385E-06_JPRB, 0.13653401E-06_JPRB, &
  & 0.14075603E-06_JPRB, 0.14485107E-06_JPRB, 0.14861953E-06_JPRB, 0.15197361E-06_JPRB, 0.15492334E-06_JPRB, 0.15749833E-06_JPRB, &
  & 0.15975641E-06_JPRB, 0.16177680E-06_JPRB, 0.16364206E-06_JPRB, 0.16546019E-06_JPRB, 0.16738016E-06_JPRB, 0.16960441E-06_JPRB, &
  & 0.17238320E-06_JPRB, 0.17595683E-06_JPRB, 0.18056546E-06_JPRB, 0.18624657E-06_JPRB, 0.19294244E-06_JPRB, 0.20039556E-06_JPRB, &
  & 0.20807042E-06_JPRB, 0.21547365E-06_JPRB, 0.22214580E-06_JPRB, 0.22780590E-06_JPRB, 0.23226896E-06_JPRB, 0.23548024E-06_JPRB, &
  & 0.23747297E-06_JPRB, 0.23833850E-06_JPRB, 0.23820022E-06_JPRB, 0.23719853E-06_JPRB, 0.23546680E-06_JPRB, 0.23311998E-06_JPRB, &
  & 0.23026227E-06_JPRB, 0.22696727E-06_JPRB, 0.22332370E-06_JPRB, 0.21942783E-06_JPRB, 0.21541561E-06_JPRB, 0.21144028E-06_JPRB, &
  & 0.20763292E-06_JPRB, 0.20407788E-06_JPRB, 0.20081403E-06_JPRB, 0.19785668E-06_JPRB, 0.19521453E-06_JPRB, 0.19288363E-06_JPRB, &
  & 0.19085216E-06_JPRB, 0.18908879E-06_JPRB, 0.18754815E-06_JPRB, 0.18618034E-06_JPRB, 0.18492557E-06_JPRB, 0.18376078E-06_JPRB, &
  & 0.18256310E-06_JPRB, 0.18135196E-06_JPRB, 0.17971631E-06_JPRB, 0.17663056E-06_JPRB /)

RGHG3(:,15, 9) = (/ &
  & 0.11476136E-06_JPRB, 0.11723827E-06_JPRB, 0.11891571E-06_JPRB, 0.12057005E-06_JPRB, 0.12255279E-06_JPRB, 0.12500459E-06_JPRB, &
  & 0.12809261E-06_JPRB, 0.13189106E-06_JPRB, 0.13640479E-06_JPRB, 0.14153167E-06_JPRB, 0.14707894E-06_JPRB, 0.15276402E-06_JPRB, &
  & 0.15830359E-06_JPRB, 0.16347005E-06_JPRB, 0.16810527E-06_JPRB, 0.17213051E-06_JPRB, 0.17557804E-06_JPRB, 0.17851005E-06_JPRB, &
  & 0.18099777E-06_JPRB, 0.18312680E-06_JPRB, 0.18497958E-06_JPRB, 0.18663476E-06_JPRB, 0.18819291E-06_JPRB, 0.18980853E-06_JPRB, &
  & 0.19169180E-06_JPRB, 0.19408981E-06_JPRB, 0.19726511E-06_JPRB, 0.20147492E-06_JPRB, 0.20672027E-06_JPRB, 0.21281009E-06_JPRB, &
  & 0.21940143E-06_JPRB, 0.22596792E-06_JPRB, 0.23207770E-06_JPRB, 0.23737897E-06_JPRB, 0.24165530E-06_JPRB, 0.24479448E-06_JPRB, &
  & 0.24679335E-06_JPRB, 0.24772325E-06_JPRB, 0.24770321E-06_JPRB, 0.24685875E-06_JPRB, 0.24530135E-06_JPRB, 0.24313621E-06_JPRB, &
  & 0.24046020E-06_JPRB, 0.23737275E-06_JPRB, 0.23398401E-06_JPRB, 0.23044325E-06_JPRB, 0.22691550E-06_JPRB, 0.22355536E-06_JPRB, &
  & 0.22047018E-06_JPRB, 0.21770586E-06_JPRB, 0.21525898E-06_JPRB, 0.21310194E-06_JPRB, 0.21119979E-06_JPRB, 0.20952714E-06_JPRB, &
  & 0.20805714E-06_JPRB, 0.20676640E-06_JPRB, 0.20562649E-06_JPRB, 0.20460745E-06_JPRB, 0.20367901E-06_JPRB, 0.20282023E-06_JPRB, &
  & 0.20194342E-06_JPRB, 0.20106620E-06_JPRB, 0.19983644E-06_JPRB, 0.19751762E-06_JPRB /)

RGHG3(:,16, 9) = (/ &
  & 0.11950843E-06_JPRB, 0.12336605E-06_JPRB, 0.12597995E-06_JPRB, 0.12872300E-06_JPRB, 0.13177709E-06_JPRB, 0.13543992E-06_JPRB, &
  & 0.13978929E-06_JPRB, 0.14488549E-06_JPRB, 0.15066425E-06_JPRB, 0.15698308E-06_JPRB, 0.16363602E-06_JPRB, 0.17036811E-06_JPRB, &
  & 0.17686682E-06_JPRB, 0.18284194E-06_JPRB, 0.18814094E-06_JPRB, 0.19272255E-06_JPRB, 0.19662406E-06_JPRB, 0.19994943E-06_JPRB, &
  & 0.20278613E-06_JPRB, 0.20521858E-06_JPRB, 0.20732892E-06_JPRB, 0.20918053E-06_JPRB, 0.21082603E-06_JPRB, 0.21234500E-06_JPRB, &
  & 0.21387760E-06_JPRB, 0.21562707E-06_JPRB, 0.21780036E-06_JPRB, 0.22062054E-06_JPRB, 0.22425857E-06_JPRB, 0.22864029E-06_JPRB, &
  & 0.23351507E-06_JPRB, 0.23857311E-06_JPRB, 0.24341855E-06_JPRB, 0.24771390E-06_JPRB, 0.25124669E-06_JPRB, 0.25390335E-06_JPRB, &
  & 0.25566035E-06_JPRB, 0.25658130E-06_JPRB, 0.25674640E-06_JPRB, 0.25623493E-06_JPRB, 0.25510428E-06_JPRB, 0.25340486E-06_JPRB, &
  & 0.25119752E-06_JPRB, 0.24856482E-06_JPRB, 0.24564190E-06_JPRB, 0.24259549E-06_JPRB, 0.23961573E-06_JPRB, 0.23685477E-06_JPRB, &
  & 0.23439118E-06_JPRB, 0.23223186E-06_JPRB, 0.23033100E-06_JPRB, 0.22863100E-06_JPRB, 0.22708569E-06_JPRB, 0.22566795E-06_JPRB, &
  & 0.22436748E-06_JPRB, 0.22318413E-06_JPRB, 0.22211458E-06_JPRB, 0.22115375E-06_JPRB, 0.22028922E-06_JPRB, 0.21950157E-06_JPRB, &
  & 0.21873493E-06_JPRB, 0.21797584E-06_JPRB, 0.21690600E-06_JPRB, 0.21501958E-06_JPRB /)

RGHG3(:,17, 9) = (/ &
  & 0.12832159E-06_JPRB, 0.13534853E-06_JPRB, 0.13958369E-06_JPRB, 0.14330513E-06_JPRB, 0.14710763E-06_JPRB, 0.15130179E-06_JPRB, &
  & 0.15609491E-06_JPRB, 0.16156561E-06_JPRB, 0.16770110E-06_JPRB, 0.17439552E-06_JPRB, 0.18143584E-06_JPRB, 0.18853984E-06_JPRB, &
  & 0.19543441E-06_JPRB, 0.20184801E-06_JPRB, 0.20758813E-06_JPRB, 0.21260003E-06_JPRB, 0.21692001E-06_JPRB, 0.22064884E-06_JPRB, &
  & 0.22390714E-06_JPRB, 0.22678648E-06_JPRB, 0.22936774E-06_JPRB, 0.23170546E-06_JPRB, 0.23380935E-06_JPRB, 0.23567725E-06_JPRB, &
  & 0.23734269E-06_JPRB, 0.23891528E-06_JPRB, 0.24059443E-06_JPRB, 0.24247521E-06_JPRB, 0.24463506E-06_JPRB, 0.24719338E-06_JPRB, &
  & 0.25008086E-06_JPRB, 0.25312113E-06_JPRB, 0.25608193E-06_JPRB, 0.25875048E-06_JPRB, 0.26100614E-06_JPRB, 0.26277411E-06_JPRB, &
  & 0.26406269E-06_JPRB, 0.26486907E-06_JPRB, 0.26521502E-06_JPRB, 0.26510773E-06_JPRB, 0.26453733E-06_JPRB, 0.26348587E-06_JPRB, &
  & 0.26195977E-06_JPRB, 0.26000566E-06_JPRB, 0.25773357E-06_JPRB, 0.25530647E-06_JPRB, 0.25290495E-06_JPRB, 0.25067067E-06_JPRB, &
  & 0.24866628E-06_JPRB, 0.24687083E-06_JPRB, 0.24522726E-06_JPRB, 0.24367785E-06_JPRB, 0.24218346E-06_JPRB, 0.24073628E-06_JPRB, &
  & 0.23935232E-06_JPRB, 0.23805896E-06_JPRB, 0.23687952E-06_JPRB, 0.23582453E-06_JPRB, 0.23489187E-06_JPRB, 0.23405906E-06_JPRB, &
  & 0.23329531E-06_JPRB, 0.23251036E-06_JPRB, 0.23158975E-06_JPRB, 0.22975490E-06_JPRB /)

RGHG3(:,18, 9) = (/ &
  & 0.14629039E-06_JPRB, 0.15656944E-06_JPRB, 0.16151769E-06_JPRB, 0.16503313E-06_JPRB, 0.16828830E-06_JPRB, 0.17174102E-06_JPRB, &
  & 0.17573396E-06_JPRB, 0.18044750E-06_JPRB, 0.18590897E-06_JPRB, 0.19206085E-06_JPRB, 0.19874045E-06_JPRB, 0.20567306E-06_JPRB, &
  & 0.21251360E-06_JPRB, 0.21896471E-06_JPRB, 0.22481248E-06_JPRB, 0.22996193E-06_JPRB, 0.23444042E-06_JPRB, 0.23834031E-06_JPRB, &
  & 0.24179639E-06_JPRB, 0.24493809E-06_JPRB, 0.24785456E-06_JPRB, 0.25059975E-06_JPRB, 0.25318781E-06_JPRB, 0.25559706E-06_JPRB, &
  & 0.25777126E-06_JPRB, 0.25965767E-06_JPRB, 0.26125895E-06_JPRB, 0.26266773E-06_JPRB, 0.26396083E-06_JPRB, 0.26513140E-06_JPRB, &
  & 0.26623172E-06_JPRB, 0.26727389E-06_JPRB, 0.26831611E-06_JPRB, 0.26934822E-06_JPRB, 0.27027863E-06_JPRB, 0.27108499E-06_JPRB, &
  & 0.27176867E-06_JPRB, 0.27234691E-06_JPRB, 0.27278085E-06_JPRB, 0.27300243E-06_JPRB, 0.27293288E-06_JPRB, 0.27249888E-06_JPRB, &
  & 0.27165589E-06_JPRB, 0.27041000E-06_JPRB, 0.26883114E-06_JPRB, 0.26704126E-06_JPRB, 0.26518700E-06_JPRB, 0.26338691E-06_JPRB, &
  & 0.26169027E-06_JPRB, 0.26008431E-06_JPRB, 0.25852438E-06_JPRB, 0.25696912E-06_JPRB, 0.25540055E-06_JPRB, 0.25383503E-06_JPRB, &
  & 0.25231347E-06_JPRB, 0.25088283E-06_JPRB, 0.24957922E-06_JPRB, 0.24842197E-06_JPRB, 0.24741146E-06_JPRB, 0.24652701E-06_JPRB, &
  & 0.24572952E-06_JPRB, 0.24494949E-06_JPRB, 0.24405767E-06_JPRB, 0.24232730E-06_JPRB /)

RGHG3(:,19, 9) = (/ &
  & 0.17369725E-06_JPRB, 0.18301256E-06_JPRB, 0.18615691E-06_JPRB, 0.18820347E-06_JPRB, 0.19000814E-06_JPRB, 0.19206308E-06_JPRB, &
  & 0.19477696E-06_JPRB, 0.19831488E-06_JPRB, 0.20276134E-06_JPRB, 0.20806701E-06_JPRB, 0.21405866E-06_JPRB, 0.22045282E-06_JPRB, &
  & 0.22690935E-06_JPRB, 0.23306617E-06_JPRB, 0.23868992E-06_JPRB, 0.24366898E-06_JPRB, 0.24801076E-06_JPRB, 0.25181089E-06_JPRB, &
  & 0.25519773E-06_JPRB, 0.25831065E-06_JPRB, 0.26125085E-06_JPRB, 0.26408290E-06_JPRB, 0.26683335E-06_JPRB, 0.26947924E-06_JPRB, &
  & 0.27193815E-06_JPRB, 0.27408655E-06_JPRB, 0.27581842E-06_JPRB, 0.27707745E-06_JPRB, 0.27789287E-06_JPRB, 0.27834369E-06_JPRB, &
  & 0.27851843E-06_JPRB, 0.27849228E-06_JPRB, 0.27837771E-06_JPRB, 0.27825914E-06_JPRB, 0.27824518E-06_JPRB, 0.27835537E-06_JPRB, &
  & 0.27857442E-06_JPRB, 0.27890428E-06_JPRB, 0.27931947E-06_JPRB, 0.27971313E-06_JPRB, 0.27996080E-06_JPRB, 0.27995537E-06_JPRB, &
  & 0.27962119E-06_JPRB, 0.27893111E-06_JPRB, 0.27791438E-06_JPRB, 0.27664487E-06_JPRB, 0.27522751E-06_JPRB, 0.27375404E-06_JPRB, &
  & 0.27227364E-06_JPRB, 0.27078659E-06_JPRB, 0.26926975E-06_JPRB, 0.26770351E-06_JPRB, 0.26609274E-06_JPRB, 0.26447321E-06_JPRB, &
  & 0.26289780E-06_JPRB, 0.26141922E-06_JPRB, 0.26007532E-06_JPRB, 0.25888403E-06_JPRB, 0.25784615E-06_JPRB, 0.25694521E-06_JPRB, &
  & 0.25614247E-06_JPRB, 0.25538802E-06_JPRB, 0.25450532E-06_JPRB, 0.25297456E-06_JPRB /)

RGHG3(:,20, 9) = (/ &
  & 0.20158245E-06_JPRB, 0.20589812E-06_JPRB, 0.20719614E-06_JPRB, 0.20780266E-06_JPRB, 0.20845499E-06_JPRB, 0.20943023E-06_JPRB, &
  & 0.21110922E-06_JPRB, 0.21364784E-06_JPRB, 0.21714864E-06_JPRB, 0.22157005E-06_JPRB, 0.22676647E-06_JPRB, 0.23245663E-06_JPRB, &
  & 0.23828274E-06_JPRB, 0.24391636E-06_JPRB, 0.24909036E-06_JPRB, 0.25369422E-06_JPRB, 0.25773537E-06_JPRB, 0.26128973E-06_JPRB, &
  & 0.26447981E-06_JPRB, 0.26743277E-06_JPRB, 0.27026203E-06_JPRB, 0.27303582E-06_JPRB, 0.27578128E-06_JPRB, 0.27847639E-06_JPRB, &
  & 0.28102477E-06_JPRB, 0.28327202E-06_JPRB, 0.28506949E-06_JPRB, 0.28632587E-06_JPRB, 0.28703508E-06_JPRB, 0.28726140E-06_JPRB, &
  & 0.28709110E-06_JPRB, 0.28662174E-06_JPRB, 0.28597745E-06_JPRB, 0.28526537E-06_JPRB, 0.28464930E-06_JPRB, 0.28425552E-06_JPRB, &
  & 0.28422994E-06_JPRB, 0.28448127E-06_JPRB, 0.28488000E-06_JPRB, 0.28533992E-06_JPRB, 0.28573606E-06_JPRB, 0.28595412E-06_JPRB, &
  & 0.28590927E-06_JPRB, 0.28556144E-06_JPRB, 0.28490956E-06_JPRB, 0.28399000E-06_JPRB, 0.28287204E-06_JPRB, 0.28162816E-06_JPRB, &
  & 0.28030556E-06_JPRB, 0.27891662E-06_JPRB, 0.27745784E-06_JPRB, 0.27593103E-06_JPRB, 0.27435746E-06_JPRB, 0.27278190E-06_JPRB, &
  & 0.27125671E-06_JPRB, 0.26983002E-06_JPRB, 0.26853465E-06_JPRB, 0.26738269E-06_JPRB, 0.26637287E-06_JPRB, 0.26549077E-06_JPRB, &
  & 0.26471835E-06_JPRB, 0.26398322E-06_JPRB, 0.26321754E-06_JPRB, 0.26178907E-06_JPRB /)

RGHG3(:,21, 9) = (/ &
  & 0.22116255E-06_JPRB, 0.22300557E-06_JPRB, 0.22317889E-06_JPRB, 0.22307037E-06_JPRB, 0.22306756E-06_JPRB, 0.22343440E-06_JPRB, &
  & 0.22443359E-06_JPRB, 0.22624005E-06_JPRB, 0.22896947E-06_JPRB, 0.23260384E-06_JPRB, 0.23700069E-06_JPRB, 0.24192065E-06_JPRB, &
  & 0.24704684E-06_JPRB, 0.25204412E-06_JPRB, 0.25669021E-06_JPRB, 0.26085439E-06_JPRB, 0.26453122E-06_JPRB, 0.26779912E-06_JPRB, &
  & 0.27076175E-06_JPRB, 0.27353462E-06_JPRB, 0.27621806E-06_JPRB, 0.27888333E-06_JPRB, 0.28155412E-06_JPRB, 0.28421184E-06_JPRB, &
  & 0.28674640E-06_JPRB, 0.28900914E-06_JPRB, 0.29083918E-06_JPRB, 0.29214496E-06_JPRB, 0.29291454E-06_JPRB, 0.29318838E-06_JPRB, &
  & 0.29302953E-06_JPRB, 0.29252652E-06_JPRB, 0.29179932E-06_JPRB, 0.29098217E-06_JPRB, 0.29025983E-06_JPRB, 0.28977018E-06_JPRB, &
  & 0.28951072E-06_JPRB, 0.28954912E-06_JPRB, 0.28984260E-06_JPRB, 0.29024031E-06_JPRB, 0.29063020E-06_JPRB, 0.29088397E-06_JPRB, &
  & 0.29093951E-06_JPRB, 0.29074400E-06_JPRB, 0.29027498E-06_JPRB, 0.28954921E-06_JPRB, 0.28860890E-06_JPRB, 0.28751177E-06_JPRB, &
  & 0.28630174E-06_JPRB, 0.28500057E-06_JPRB, 0.28361850E-06_JPRB, 0.28217144E-06_JPRB, 0.28069152E-06_JPRB, 0.27922241E-06_JPRB, &
  & 0.27781050E-06_JPRB, 0.27649347E-06_JPRB, 0.27529455E-06_JPRB, 0.27422325E-06_JPRB, 0.27327906E-06_JPRB, 0.27245201E-06_JPRB, &
  & 0.27171626E-06_JPRB, 0.27105173E-06_JPRB, 0.27030507E-06_JPRB, 0.26911192E-06_JPRB /)

RGHG3(:,22, 9) = (/ &
  & 0.23520954E-06_JPRB, 0.23577338E-06_JPRB, 0.23545138E-06_JPRB, 0.23500601E-06_JPRB, 0.23466046E-06_JPRB, 0.23466239E-06_JPRB, &
  & 0.23521000E-06_JPRB, 0.23649066E-06_JPRB, 0.23860798E-06_JPRB, 0.24155133E-06_JPRB, 0.24522211E-06_JPRB, 0.24940081E-06_JPRB, &
  & 0.25381399E-06_JPRB, 0.25818582E-06_JPRB, 0.26228685E-06_JPRB, 0.26601589E-06_JPRB, 0.26935771E-06_JPRB, 0.27236072E-06_JPRB, &
  & 0.27511902E-06_JPRB, 0.27772896E-06_JPRB, 0.28028131E-06_JPRB, 0.28283989E-06_JPRB, 0.28543215E-06_JPRB, 0.28802810E-06_JPRB, &
  & 0.29053905E-06_JPRB, 0.29279582E-06_JPRB, 0.29466236E-06_JPRB, 0.29604385E-06_JPRB, 0.29692916E-06_JPRB, 0.29735017E-06_JPRB, &
  & 0.29735514E-06_JPRB, 0.29701266E-06_JPRB, 0.29642192E-06_JPRB, 0.29570018E-06_JPRB, 0.29500927E-06_JPRB, 0.29448330E-06_JPRB, &
  & 0.29419769E-06_JPRB, 0.29418547E-06_JPRB, 0.29435674E-06_JPRB, 0.29463044E-06_JPRB, 0.29489834E-06_JPRB, 0.29509164E-06_JPRB, &
  & 0.29511381E-06_JPRB, 0.29492617E-06_JPRB, 0.29450990E-06_JPRB, 0.29385910E-06_JPRB, 0.29300463E-06_JPRB, 0.29199339E-06_JPRB, &
  & 0.29086323E-06_JPRB, 0.28963674E-06_JPRB, 0.28833310E-06_JPRB, 0.28697872E-06_JPRB, 0.28561021E-06_JPRB, 0.28426953E-06_JPRB, &
  & 0.28299206E-06_JPRB, 0.28180347E-06_JPRB, 0.28071719E-06_JPRB, 0.27973698E-06_JPRB, 0.27886387E-06_JPRB, 0.27809168E-06_JPRB, &
  & 0.27741410E-06_JPRB, 0.27677987E-06_JPRB, 0.27614365E-06_JPRB, 0.27501702E-06_JPRB /)

RGHG3(:,23, 9) = (/ &
  & 0.24586774E-06_JPRB, 0.24578642E-06_JPRB, 0.24522410E-06_JPRB, 0.24457015E-06_JPRB, 0.24403428E-06_JPRB, 0.24378986E-06_JPRB, &
  & 0.24402428E-06_JPRB, 0.24490396E-06_JPRB, 0.24652394E-06_JPRB, 0.24889388E-06_JPRB, 0.25192043E-06_JPRB, 0.25543744E-06_JPRB, &
  & 0.25921250E-06_JPRB, 0.26300552E-06_JPRB, 0.26663616E-06_JPRB, 0.26998629E-06_JPRB, 0.27303378E-06_JPRB, 0.27582007E-06_JPRB, &
  & 0.27841440E-06_JPRB, 0.28089693E-06_JPRB, 0.28334753E-06_JPRB, 0.28581343E-06_JPRB, 0.28833097E-06_JPRB, 0.29085948E-06_JPRB, &
  & 0.29330940E-06_JPRB, 0.29553487E-06_JPRB, 0.29740872E-06_JPRB, 0.29886399E-06_JPRB, 0.29988973E-06_JPRB, 0.30049330E-06_JPRB, &
  & 0.30071374E-06_JPRB, 0.30060656E-06_JPRB, 0.30025308E-06_JPRB, 0.29975541E-06_JPRB, 0.29924013E-06_JPRB, 0.29880619E-06_JPRB, &
  & 0.29852538E-06_JPRB, 0.29843781E-06_JPRB, 0.29850011E-06_JPRB, 0.29861673E-06_JPRB, 0.29872984E-06_JPRB, 0.29876438E-06_JPRB, &
  & 0.29867925E-06_JPRB, 0.29842047E-06_JPRB, 0.29795945E-06_JPRB, 0.29730785E-06_JPRB, 0.29647515E-06_JPRB, 0.29549983E-06_JPRB, &
  & 0.29441682E-06_JPRB, 0.29325068E-06_JPRB, 0.29202289E-06_JPRB, 0.29076378E-06_JPRB, 0.28951081E-06_JPRB, 0.28829902E-06_JPRB, &
  & 0.28715348E-06_JPRB, 0.28609008E-06_JPRB, 0.28511343E-06_JPRB, 0.28422312E-06_JPRB, 0.28341870E-06_JPRB, 0.28269736E-06_JPRB, &
  & 0.28205136E-06_JPRB, 0.28146920E-06_JPRB, 0.28084827E-06_JPRB, 0.27990464E-06_JPRB /)

RGHG3(:,24, 9) = (/ &
  & 0.25433829E-06_JPRB, 0.25390426E-06_JPRB, 0.25319829E-06_JPRB, 0.25245683E-06_JPRB, 0.25179864E-06_JPRB, 0.25139391E-06_JPRB, &
  & 0.25140184E-06_JPRB, 0.25197050E-06_JPRB, 0.25319252E-06_JPRB, 0.25508231E-06_JPRB, 0.25757438E-06_JPRB, 0.26052811E-06_JPRB, &
  & 0.26376094E-06_JPRB, 0.26707761E-06_JPRB, 0.27031018E-06_JPRB, 0.27336128E-06_JPRB, 0.27619112E-06_JPRB, 0.27881552E-06_JPRB, &
  & 0.28128829E-06_JPRB, 0.28367211E-06_JPRB, 0.28603327E-06_JPRB, 0.28841168E-06_JPRB, 0.29083932E-06_JPRB, 0.29327336E-06_JPRB, &
  & 0.29563031E-06_JPRB, 0.29780242E-06_JPRB, 0.29967245E-06_JPRB, 0.30116450E-06_JPRB, 0.30226767E-06_JPRB, 0.30301362E-06_JPRB, &
  & 0.30343318E-06_JPRB, 0.30356594E-06_JPRB, 0.30347184E-06_JPRB, 0.30323031E-06_JPRB, 0.30292441E-06_JPRB, 0.30262115E-06_JPRB, &
  & 0.30240440E-06_JPRB, 0.30227133E-06_JPRB, 0.30221702E-06_JPRB, 0.30217100E-06_JPRB, 0.30210475E-06_JPRB, 0.30196458E-06_JPRB, &
  & 0.30171927E-06_JPRB, 0.30135061E-06_JPRB, 0.30081685E-06_JPRB, 0.30011844E-06_JPRB, 0.29927543E-06_JPRB, 0.29832026E-06_JPRB, &
  & 0.29727360E-06_JPRB, 0.29615762E-06_JPRB, 0.29499893E-06_JPRB, 0.29382943E-06_JPRB, 0.29268327E-06_JPRB, 0.29158699E-06_JPRB, &
  & 0.29055829E-06_JPRB, 0.28960255E-06_JPRB, 0.28872049E-06_JPRB, 0.28790961E-06_JPRB, 0.28716954E-06_JPRB, 0.28649958E-06_JPRB, &
  & 0.28589753E-06_JPRB, 0.28533896E-06_JPRB, 0.28477282E-06_JPRB, 0.28385583E-06_JPRB /)

RGHG3(:,25, 9) = (/ &
  & 0.26120796E-06_JPRB, 0.26059521E-06_JPRB, 0.25987822E-06_JPRB, 0.25911618E-06_JPRB, 0.25843383E-06_JPRB, 0.25793901E-06_JPRB, &
  & 0.25779511E-06_JPRB, 0.25813003E-06_JPRB, 0.25903847E-06_JPRB, 0.26054101E-06_JPRB, 0.26259571E-06_JPRB, 0.26509332E-06_JPRB, &
  & 0.26788896E-06_JPRB, 0.27082353E-06_JPRB, 0.27375737E-06_JPRB, 0.27658265E-06_JPRB, 0.27925120E-06_JPRB, 0.28176152E-06_JPRB, &
  & 0.28414212E-06_JPRB, 0.28644320E-06_JPRB, 0.28871091E-06_JPRB, 0.29097976E-06_JPRB, 0.29327458E-06_JPRB, 0.29557248E-06_JPRB, &
  & 0.29779346E-06_JPRB, 0.29983039E-06_JPRB, 0.30159919E-06_JPRB, 0.30306808E-06_JPRB, 0.30423121E-06_JPRB, 0.30509005E-06_JPRB, &
  & 0.30567145E-06_JPRB, 0.30600728E-06_JPRB, 0.30614123E-06_JPRB, 0.30612648E-06_JPRB, 0.30602465E-06_JPRB, 0.30587998E-06_JPRB, &
  & 0.30571903E-06_JPRB, 0.30555839E-06_JPRB, 0.30539212E-06_JPRB, 0.30520982E-06_JPRB, 0.30497779E-06_JPRB, 0.30468274E-06_JPRB, &
  & 0.30428794E-06_JPRB, 0.30379351E-06_JPRB, 0.30317472E-06_JPRB, 0.30242811E-06_JPRB, 0.30156156E-06_JPRB, 0.30060784E-06_JPRB, &
  & 0.29959301E-06_JPRB, 0.29853234E-06_JPRB, 0.29744558E-06_JPRB, 0.29636288E-06_JPRB, 0.29531407E-06_JPRB, 0.29432076E-06_JPRB, &
  & 0.29338958E-06_JPRB, 0.29252300E-06_JPRB, 0.29171679E-06_JPRB, 0.29096941E-06_JPRB, 0.29028072E-06_JPRB, 0.28965292E-06_JPRB, &
  & 0.28908610E-06_JPRB, 0.28856559E-06_JPRB, 0.28803385E-06_JPRB, 0.28719634E-06_JPRB /)

RGHG3(:,26, 9) = (/ &
  & 0.26690319E-06_JPRB, 0.26627856E-06_JPRB, 0.26561074E-06_JPRB, 0.26492933E-06_JPRB, 0.26427267E-06_JPRB, 0.26377910E-06_JPRB, &
  & 0.26355335E-06_JPRB, 0.26373152E-06_JPRB, 0.26440503E-06_JPRB, 0.26561079E-06_JPRB, 0.26731843E-06_JPRB, 0.26945642E-06_JPRB, &
  & 0.27190916E-06_JPRB, 0.27454658E-06_JPRB, 0.27724556E-06_JPRB, 0.27990470E-06_JPRB, 0.28245302E-06_JPRB, 0.28487398E-06_JPRB, &
  & 0.28717406E-06_JPRB, 0.28938027E-06_JPRB, 0.29153594E-06_JPRB, 0.29367021E-06_JPRB, 0.29579604E-06_JPRB, 0.29789757E-06_JPRB, &
  & 0.29991645E-06_JPRB, 0.30176670E-06_JPRB, 0.30340360E-06_JPRB, 0.30479950E-06_JPRB, 0.30594069E-06_JPRB, 0.30684970E-06_JPRB, &
  & 0.30753375E-06_JPRB, 0.30801345E-06_JPRB, 0.30831623E-06_JPRB, 0.30847195E-06_JPRB, 0.30851299E-06_JPRB, 0.30846735E-06_JPRB, &
  & 0.30835378E-06_JPRB, 0.30817876E-06_JPRB, 0.30794709E-06_JPRB, 0.30766284E-06_JPRB, 0.30731076E-06_JPRB, 0.30689279E-06_JPRB, &
  & 0.30639151E-06_JPRB, 0.30580250E-06_JPRB, 0.30511401E-06_JPRB, 0.30432872E-06_JPRB, 0.30345927E-06_JPRB, 0.30252500E-06_JPRB, &
  & 0.30154311E-06_JPRB, 0.30053189E-06_JPRB, 0.29951289E-06_JPRB, 0.29851080E-06_JPRB, 0.29754960E-06_JPRB, 0.29664236E-06_JPRB, &
  & 0.29579388E-06_JPRB, 0.29500205E-06_JPRB, 0.29426374E-06_JPRB, 0.29357602E-06_JPRB, 0.29293832E-06_JPRB, 0.29235102E-06_JPRB, &
  & 0.29181490E-06_JPRB, 0.29132289E-06_JPRB, 0.29081295E-06_JPRB, 0.29004772E-06_JPRB /)

RGHG3(:,27, 9) = (/ &
  & 0.27180306E-06_JPRB, 0.27127015E-06_JPRB, 0.27072264E-06_JPRB, 0.27013436E-06_JPRB, 0.26959020E-06_JPRB, 0.26913114E-06_JPRB, &
  & 0.26889575E-06_JPRB, 0.26899153E-06_JPRB, 0.26951196E-06_JPRB, 0.27049830E-06_JPRB, 0.27194892E-06_JPRB, 0.27380707E-06_JPRB, &
  & 0.27599020E-06_JPRB, 0.27839027E-06_JPRB, 0.28089792E-06_JPRB, 0.28340929E-06_JPRB, 0.28585205E-06_JPRB, 0.28818013E-06_JPRB, &
  & 0.29037750E-06_JPRB, 0.29247443E-06_JPRB, 0.29449131E-06_JPRB, 0.29645540E-06_JPRB, 0.29837258E-06_JPRB, 0.30024003E-06_JPRB, &
  & 0.30201761E-06_JPRB, 0.30365649E-06_JPRB, 0.30512712E-06_JPRB, 0.30640427E-06_JPRB, 0.30748515E-06_JPRB, 0.30837535E-06_JPRB, &
  & 0.30909686E-06_JPRB, 0.30965765E-06_JPRB, 0.31006613E-06_JPRB, 0.31033315E-06_JPRB, 0.31047176E-06_JPRB, 0.31049441E-06_JPRB, &
  & 0.31041048E-06_JPRB, 0.31022756E-06_JPRB, 0.30995187E-06_JPRB, 0.30959671E-06_JPRB, 0.30916385E-06_JPRB, 0.30865968E-06_JPRB, &
  & 0.30808496E-06_JPRB, 0.30743234E-06_JPRB, 0.30669986E-06_JPRB, 0.30588794E-06_JPRB, 0.30501823E-06_JPRB, 0.30411084E-06_JPRB, &
  & 0.30318103E-06_JPRB, 0.30223512E-06_JPRB, 0.30128848E-06_JPRB, 0.30036412E-06_JPRB, 0.29948106E-06_JPRB, 0.29865066E-06_JPRB, &
  & 0.29787327E-06_JPRB, 0.29714758E-06_JPRB, 0.29646947E-06_JPRB, 0.29583384E-06_JPRB, 0.29523758E-06_JPRB, 0.29468239E-06_JPRB, &
  & 0.29417345E-06_JPRB, 0.29369500E-06_JPRB, 0.29321924E-06_JPRB, 0.29248434E-06_JPRB /)

RGHG3(:,28, 9) = (/ &
  & 0.27627974E-06_JPRB, 0.27584917E-06_JPRB, 0.27540997E-06_JPRB, 0.27495949E-06_JPRB, 0.27449857E-06_JPRB, 0.27412906E-06_JPRB, &
  & 0.27391982E-06_JPRB, 0.27398943E-06_JPRB, 0.27442260E-06_JPRB, 0.27527000E-06_JPRB, 0.27653323E-06_JPRB, 0.27818348E-06_JPRB, &
  & 0.28015197E-06_JPRB, 0.28235110E-06_JPRB, 0.28468128E-06_JPRB, 0.28704773E-06_JPRB, 0.28936736E-06_JPRB, 0.29157127E-06_JPRB, &
  & 0.29364787E-06_JPRB, 0.29560726E-06_JPRB, 0.29745846E-06_JPRB, 0.29922484E-06_JPRB, 0.30091471E-06_JPRB, 0.30253102E-06_JPRB, &
  & 0.30405388E-06_JPRB, 0.30545181E-06_JPRB, 0.30670964E-06_JPRB, 0.30783124E-06_JPRB, 0.30882262E-06_JPRB, 0.30968562E-06_JPRB, &
  & 0.31041390E-06_JPRB, 0.31100979E-06_JPRB, 0.31147135E-06_JPRB, 0.31179729E-06_JPRB, 0.31198880E-06_JPRB, 0.31204877E-06_JPRB, &
  & 0.31198090E-06_JPRB, 0.31179360E-06_JPRB, 0.31149489E-06_JPRB, 0.31110005E-06_JPRB, 0.31062268E-06_JPRB, 0.31007087E-06_JPRB, &
  & 0.30945466E-06_JPRB, 0.30877263E-06_JPRB, 0.30802445E-06_JPRB, 0.30721691E-06_JPRB, 0.30636789E-06_JPRB, 0.30549785E-06_JPRB, &
  & 0.30461820E-06_JPRB, 0.30373371E-06_JPRB, 0.30285514E-06_JPRB, 0.30200135E-06_JPRB, 0.30118849E-06_JPRB, 0.30042384E-06_JPRB, &
  & 0.29970838E-06_JPRB, 0.29904007E-06_JPRB, 0.29841101E-06_JPRB, 0.29781643E-06_JPRB, 0.29725609E-06_JPRB, 0.29673538E-06_JPRB, &
  & 0.29625934E-06_JPRB, 0.29582910E-06_JPRB, 0.29538214E-06_JPRB, 0.29470149E-06_JPRB /)

RGHG3(:,29, 9) = (/ &
  & 0.28043507E-06_JPRB, 0.28012241E-06_JPRB, 0.27979337E-06_JPRB, 0.27942755E-06_JPRB, 0.27908391E-06_JPRB, 0.27878608E-06_JPRB, &
  & 0.27863118E-06_JPRB, 0.27870962E-06_JPRB, 0.27910551E-06_JPRB, 0.27986542E-06_JPRB, 0.28100555E-06_JPRB, 0.28249860E-06_JPRB, &
  & 0.28429409E-06_JPRB, 0.28631453E-06_JPRB, 0.28847262E-06_JPRB, 0.29067687E-06_JPRB, 0.29284743E-06_JPRB, 0.29489436E-06_JPRB, &
  & 0.29682994E-06_JPRB, 0.29862841E-06_JPRB, 0.30029938E-06_JPRB, 0.30186018E-06_JPRB, 0.30332257E-06_JPRB, 0.30469675E-06_JPRB, &
  & 0.30597414E-06_JPRB, 0.30714045E-06_JPRB, 0.30820385E-06_JPRB, 0.30917417E-06_JPRB, 0.31005280E-06_JPRB, 0.31084778E-06_JPRB, &
  & 0.31154812E-06_JPRB, 0.31214012E-06_JPRB, 0.31261342E-06_JPRB, 0.31295804E-06_JPRB, 0.31316813E-06_JPRB, 0.31324160E-06_JPRB, &
  & 0.31317958E-06_JPRB, 0.31299007E-06_JPRB, 0.31268414E-06_JPRB, 0.31227333E-06_JPRB, 0.31177944E-06_JPRB, 0.31120985E-06_JPRB, &
  & 0.31058173E-06_JPRB, 0.30989526E-06_JPRB, 0.30915598E-06_JPRB, 0.30836975E-06_JPRB, 0.30755373E-06_JPRB, 0.30672641E-06_JPRB, &
  & 0.30589473E-06_JPRB, 0.30506658E-06_JPRB, 0.30425323E-06_JPRB, 0.30346868E-06_JPRB, 0.30272213E-06_JPRB, 0.30201807E-06_JPRB, &
  & 0.30135649E-06_JPRB, 0.30073184E-06_JPRB, 0.30014110E-06_JPRB, 0.29958241E-06_JPRB, 0.29905843E-06_JPRB, 0.29857443E-06_JPRB, &
  & 0.29813432E-06_JPRB, 0.29772201E-06_JPRB, 0.29730964E-06_JPRB, 0.29663499E-06_JPRB /)

RGHG3(:,30, 9) = (/ &
  & 0.28430611E-06_JPRB, 0.28407570E-06_JPRB, 0.28381930E-06_JPRB, 0.28356126E-06_JPRB, 0.28329578E-06_JPRB, 0.28308349E-06_JPRB, &
  & 0.28298533E-06_JPRB, 0.28309131E-06_JPRB, 0.28347768E-06_JPRB, 0.28419225E-06_JPRB, 0.28524394E-06_JPRB, 0.28661864E-06_JPRB, &
  & 0.28826747E-06_JPRB, 0.29012463E-06_JPRB, 0.29210617E-06_JPRB, 0.29414144E-06_JPRB, 0.29613187E-06_JPRB, 0.29801583E-06_JPRB, &
  & 0.29978298E-06_JPRB, 0.30141271E-06_JPRB, 0.30290329E-06_JPRB, 0.30426892E-06_JPRB, 0.30552513E-06_JPRB, 0.30668141E-06_JPRB, &
  & 0.30774078E-06_JPRB, 0.30870677E-06_JPRB, 0.30959441E-06_JPRB, 0.31041918E-06_JPRB, 0.31118785E-06_JPRB, 0.31190004E-06_JPRB, &
  & 0.31254575E-06_JPRB, 0.31310535E-06_JPRB, 0.31356041E-06_JPRB, 0.31389538E-06_JPRB, 0.31410124E-06_JPRB, 0.31417281E-06_JPRB, &
  & 0.31411025E-06_JPRB, 0.31392153E-06_JPRB, 0.31361819E-06_JPRB, 0.31321096E-06_JPRB, 0.31271799E-06_JPRB, 0.31215615E-06_JPRB, &
  & 0.31153377E-06_JPRB, 0.31086577E-06_JPRB, 0.31015071E-06_JPRB, 0.30939987E-06_JPRB, 0.30862731E-06_JPRB, 0.30784844E-06_JPRB, &
  & 0.30707224E-06_JPRB, 0.30630304E-06_JPRB, 0.30554941E-06_JPRB, 0.30482263E-06_JPRB, 0.30413020E-06_JPRB, 0.30347286E-06_JPRB, &
  & 0.30284983E-06_JPRB, 0.30226138E-06_JPRB, 0.30170460E-06_JPRB, 0.30117931E-06_JPRB, 0.30068662E-06_JPRB, 0.30022929E-06_JPRB, &
  & 0.29980964E-06_JPRB, 0.29942930E-06_JPRB, 0.29903381E-06_JPRB, 0.29844892E-06_JPRB /)

RGHG3(:,31, 9) = (/ &
  & 0.28782458E-06_JPRB, 0.28766451E-06_JPRB, 0.28748292E-06_JPRB, 0.28729403E-06_JPRB, 0.28711582E-06_JPRB, 0.28697477E-06_JPRB, &
  & 0.28693572E-06_JPRB, 0.28708001E-06_JPRB, 0.28747533E-06_JPRB, 0.28816146E-06_JPRB, 0.28915210E-06_JPRB, 0.29042607E-06_JPRB, &
  & 0.29194422E-06_JPRB, 0.29364335E-06_JPRB, 0.29545322E-06_JPRB, 0.29730299E-06_JPRB, 0.29911448E-06_JPRB, 0.30082745E-06_JPRB, &
  & 0.30242472E-06_JPRB, 0.30388776E-06_JPRB, 0.30521264E-06_JPRB, 0.30640865E-06_JPRB, 0.30748473E-06_JPRB, 0.30845956E-06_JPRB, &
  & 0.30933845E-06_JPRB, 0.31013917E-06_JPRB, 0.31088058E-06_JPRB, 0.31157583E-06_JPRB, 0.31223661E-06_JPRB, 0.31286100E-06_JPRB, &
  & 0.31343808E-06_JPRB, 0.31394583E-06_JPRB, 0.31436318E-06_JPRB, 0.31467064E-06_JPRB, 0.31485786E-06_JPRB, 0.31491862E-06_JPRB, &
  & 0.31485300E-06_JPRB, 0.31466820E-06_JPRB, 0.31437509E-06_JPRB, 0.31398423E-06_JPRB, 0.31351007E-06_JPRB, 0.31296659E-06_JPRB, &
  & 0.31237312E-06_JPRB, 0.31173178E-06_JPRB, 0.31105509E-06_JPRB, 0.31034614E-06_JPRB, 0.30962028E-06_JPRB, 0.30889248E-06_JPRB, &
  & 0.30816975E-06_JPRB, 0.30745599E-06_JPRB, 0.30675668E-06_JPRB, 0.30607939E-06_JPRB, 0.30543026E-06_JPRB, 0.30481149E-06_JPRB, &
  & 0.30422544E-06_JPRB, 0.30367192E-06_JPRB, 0.30314897E-06_JPRB, 0.30265352E-06_JPRB, 0.30218774E-06_JPRB, 0.30175698E-06_JPRB, &
  & 0.30136786E-06_JPRB, 0.30100881E-06_JPRB, 0.30064967E-06_JPRB, 0.30005381E-06_JPRB /)

RGHG3(:,32, 9) = (/ &
  & 0.29098086E-06_JPRB, 0.29088602E-06_JPRB, 0.29075807E-06_JPRB, 0.29063443E-06_JPRB, 0.29051785E-06_JPRB, 0.29044196E-06_JPRB, &
  & 0.29046294E-06_JPRB, 0.29064802E-06_JPRB, 0.29105945E-06_JPRB, 0.29173145E-06_JPRB, 0.29266621E-06_JPRB, 0.29384972E-06_JPRB, &
  & 0.29524222E-06_JPRB, 0.29678955E-06_JPRB, 0.29842727E-06_JPRB, 0.30009630E-06_JPRB, 0.30172814E-06_JPRB, 0.30327917E-06_JPRB, &
  & 0.30472000E-06_JPRB, 0.30603721E-06_JPRB, 0.30721858E-06_JPRB, 0.30827019E-06_JPRB, 0.30920387E-06_JPRB, 0.31003117E-06_JPRB, &
  & 0.31077022E-06_JPRB, 0.31143904E-06_JPRB, 0.31205764E-06_JPRB, 0.31264318E-06_JPRB, 0.31320502E-06_JPRB, 0.31374276E-06_JPRB, &
  & 0.31424474E-06_JPRB, 0.31469034E-06_JPRB, 0.31505749E-06_JPRB, 0.31532642E-06_JPRB, 0.31548680E-06_JPRB, 0.31553239E-06_JPRB, &
  & 0.31546369E-06_JPRB, 0.31528697E-06_JPRB, 0.31500920E-06_JPRB, 0.31464526E-06_JPRB, 0.31420043E-06_JPRB, 0.31368833E-06_JPRB, &
  & 0.31312879E-06_JPRB, 0.31252964E-06_JPRB, 0.31189393E-06_JPRB, 0.31123250E-06_JPRB, 0.31055708E-06_JPRB, 0.30987835E-06_JPRB, &
  & 0.30920532E-06_JPRB, 0.30854054E-06_JPRB, 0.30788914E-06_JPRB, 0.30725613E-06_JPRB, 0.30664759E-06_JPRB, 0.30606770E-06_JPRB, &
  & 0.30551379E-06_JPRB, 0.30499024E-06_JPRB, 0.30449294E-06_JPRB, 0.30401986E-06_JPRB, 0.30357725E-06_JPRB, 0.30316977E-06_JPRB, &
  & 0.30280017E-06_JPRB, 0.30246298E-06_JPRB, 0.30210956E-06_JPRB, 0.30156662E-06_JPRB /)

RGHG3(:,33, 9) = (/ &
  & 0.29378583E-06_JPRB, 0.29374186E-06_JPRB, 0.29366169E-06_JPRB, 0.29358065E-06_JPRB, 0.29351770E-06_JPRB, 0.29349934E-06_JPRB, &
  & 0.29357139E-06_JPRB, 0.29379905E-06_JPRB, 0.29422901E-06_JPRB, 0.29488430E-06_JPRB, 0.29576887E-06_JPRB, 0.29686149E-06_JPRB, &
  & 0.29813179E-06_JPRB, 0.29953156E-06_JPRB, 0.30100864E-06_JPRB, 0.30250379E-06_JPRB, 0.30397212E-06_JPRB, 0.30536870E-06_JPRB, &
  & 0.30667201E-06_JPRB, 0.30786057E-06_JPRB, 0.30892988E-06_JPRB, 0.30987474E-06_JPRB, 0.31069848E-06_JPRB, 0.31141690E-06_JPRB, &
  & 0.31204874E-06_JPRB, 0.31261456E-06_JPRB, 0.31313476E-06_JPRB, 0.31362575E-06_JPRB, 0.31409891E-06_JPRB, 0.31455284E-06_JPRB, &
  & 0.31497839E-06_JPRB, 0.31535592E-06_JPRB, 0.31566594E-06_JPRB, 0.31589033E-06_JPRB, 0.31601968E-06_JPRB, 0.31604881E-06_JPRB, &
  & 0.31597835E-06_JPRB, 0.31581257E-06_JPRB, 0.31555695E-06_JPRB, 0.31522424E-06_JPRB, 0.31481810E-06_JPRB, 0.31434439E-06_JPRB, &
  & 0.31382643E-06_JPRB, 0.31327062E-06_JPRB, 0.31268394E-06_JPRB, 0.31206810E-06_JPRB, 0.31143969E-06_JPRB, 0.31080995E-06_JPRB, &
  & 0.31018263E-06_JPRB, 0.30956386E-06_JPRB, 0.30895509E-06_JPRB, 0.30836321E-06_JPRB, 0.30779023E-06_JPRB, 0.30724252E-06_JPRB, &
  & 0.30671947E-06_JPRB, 0.30622027E-06_JPRB, 0.30574495E-06_JPRB, 0.30529409E-06_JPRB, 0.30487232E-06_JPRB, 0.30448413E-06_JPRB, &
  & 0.30413469E-06_JPRB, 0.30381383E-06_JPRB, 0.30349054E-06_JPRB, 0.30295490E-06_JPRB /)

RGHG3(:,34, 9) = (/ &
  & 0.29620691E-06_JPRB, 0.29622524E-06_JPRB, 0.29619400E-06_JPRB, 0.29615740E-06_JPRB, 0.29614031E-06_JPRB, 0.29616939E-06_JPRB, &
  & 0.29629101E-06_JPRB, 0.29655331E-06_JPRB, 0.29699589E-06_JPRB, 0.29763532E-06_JPRB, 0.29846345E-06_JPRB, 0.29946870E-06_JPRB, &
  & 0.30062031E-06_JPRB, 0.30188244E-06_JPRB, 0.30320825E-06_JPRB, 0.30455263E-06_JPRB, 0.30587012E-06_JPRB, 0.30713494E-06_JPRB, &
  & 0.30832001E-06_JPRB, 0.30940936E-06_JPRB, 0.31039119E-06_JPRB, 0.31125128E-06_JPRB, 0.31199488E-06_JPRB, 0.31263573E-06_JPRB, &
  & 0.31319004E-06_JPRB, 0.31367617E-06_JPRB, 0.31411611E-06_JPRB, 0.31452694E-06_JPRB, 0.31491902E-06_JPRB, 0.31529413E-06_JPRB, &
  & 0.31564332E-06_JPRB, 0.31595147E-06_JPRB, 0.31620155E-06_JPRB, 0.31637936E-06_JPRB, 0.31647662E-06_JPRB, 0.31649003E-06_JPRB, &
  & 0.31641952E-06_JPRB, 0.31626760E-06_JPRB, 0.31603844E-06_JPRB, 0.31574149E-06_JPRB, 0.31537394E-06_JPRB, 0.31494693E-06_JPRB, &
  & 0.31447249E-06_JPRB, 0.31396121E-06_JPRB, 0.31342341E-06_JPRB, 0.31285546E-06_JPRB, 0.31226853E-06_JPRB, 0.31168500E-06_JPRB, &
  & 0.31109980E-06_JPRB, 0.31052028E-06_JPRB, 0.30994846E-06_JPRB, 0.30939290E-06_JPRB, 0.30885249E-06_JPRB, 0.30833525E-06_JPRB, &
  & 0.30784048E-06_JPRB, 0.30736686E-06_JPRB, 0.30691655E-06_JPRB, 0.30648846E-06_JPRB, 0.30608689E-06_JPRB, 0.30571778E-06_JPRB, &
  & 0.30538547E-06_JPRB, 0.30508218E-06_JPRB, 0.30476320E-06_JPRB, 0.30425312E-06_JPRB /)

RGHG3(:,35, 9) = (/ &
  & 0.29834757E-06_JPRB, 0.29838850E-06_JPRB, 0.29839856E-06_JPRB, 0.29840103E-06_JPRB, 0.29842329E-06_JPRB, 0.29849497E-06_JPRB, &
  & 0.29865271E-06_JPRB, 0.29894304E-06_JPRB, 0.29939252E-06_JPRB, 0.30000621E-06_JPRB, 0.30078164E-06_JPRB, 0.30169932E-06_JPRB, &
  & 0.30274225E-06_JPRB, 0.30387648E-06_JPRB, 0.30506911E-06_JPRB, 0.30627561E-06_JPRB, 0.30746580E-06_JPRB, 0.30861460E-06_JPRB, &
  & 0.30970023E-06_JPRB, 0.31070812E-06_JPRB, 0.31162102E-06_JPRB, 0.31242408E-06_JPRB, 0.31311694E-06_JPRB, 0.31370610E-06_JPRB, &
  & 0.31420439E-06_JPRB, 0.31463017E-06_JPRB, 0.31500397E-06_JPRB, 0.31534427E-06_JPRB, 0.31566307E-06_JPRB, 0.31596269E-06_JPRB, &
  & 0.31623810E-06_JPRB, 0.31647787E-06_JPRB, 0.31666889E-06_JPRB, 0.31680096E-06_JPRB, 0.31686787E-06_JPRB, 0.31686750E-06_JPRB, &
  & 0.31679949E-06_JPRB, 0.31666411E-06_JPRB, 0.31646420E-06_JPRB, 0.31620354E-06_JPRB, 0.31587837E-06_JPRB, 0.31549575E-06_JPRB, &
  & 0.31506582E-06_JPRB, 0.31460220E-06_JPRB, 0.31410934E-06_JPRB, 0.31358502E-06_JPRB, 0.31303887E-06_JPRB, 0.31249573E-06_JPRB, &
  & 0.31194986E-06_JPRB, 0.31140468E-06_JPRB, 0.31086580E-06_JPRB, 0.31034256E-06_JPRB, 0.30983398E-06_JPRB, 0.30934467E-06_JPRB, &
  & 0.30888083E-06_JPRB, 0.30843654E-06_JPRB, 0.30801141E-06_JPRB, 0.30760594E-06_JPRB, 0.30722424E-06_JPRB, 0.30687303E-06_JPRB, &
  & 0.30655653E-06_JPRB, 0.30626470E-06_JPRB, 0.30596425E-06_JPRB, 0.30546471E-06_JPRB /)

RGHG3(:,36, 9) = (/ &
  & 0.30017560E-06_JPRB, 0.30028417E-06_JPRB, 0.30032535E-06_JPRB, 0.30036017E-06_JPRB, 0.30041596E-06_JPRB, 0.30051916E-06_JPRB, &
  & 0.30070737E-06_JPRB, 0.30101410E-06_JPRB, 0.30145947E-06_JPRB, 0.30204743E-06_JPRB, 0.30276473E-06_JPRB, 0.30360329E-06_JPRB, &
  & 0.30454376E-06_JPRB, 0.30556507E-06_JPRB, 0.30663477E-06_JPRB, 0.30772429E-06_JPRB, 0.30879897E-06_JPRB, 0.30984839E-06_JPRB, &
  & 0.31085244E-06_JPRB, 0.31179275E-06_JPRB, 0.31265591E-06_JPRB, 0.31342370E-06_JPRB, 0.31408388E-06_JPRB, 0.31463816E-06_JPRB, &
  & 0.31509344E-06_JPRB, 0.31546821E-06_JPRB, 0.31578512E-06_JPRB, 0.31606260E-06_JPRB, 0.31631339E-06_JPRB, 0.31654304E-06_JPRB, &
  & 0.31674952E-06_JPRB, 0.31692520E-06_JPRB, 0.31706182E-06_JPRB, 0.31715257E-06_JPRB, 0.31719358E-06_JPRB, 0.31718369E-06_JPRB, &
  & 0.31712165E-06_JPRB, 0.31700608E-06_JPRB, 0.31683754E-06_JPRB, 0.31661480E-06_JPRB, 0.31633081E-06_JPRB, 0.31599126E-06_JPRB, &
  & 0.31560819E-06_JPRB, 0.31519119E-06_JPRB, 0.31473647E-06_JPRB, 0.31425188E-06_JPRB, 0.31374782E-06_JPRB, 0.31323913E-06_JPRB, &
  & 0.31272731E-06_JPRB, 0.31221128E-06_JPRB, 0.31170242E-06_JPRB, 0.31120837E-06_JPRB, 0.31073080E-06_JPRB, 0.31027307E-06_JPRB, &
  & 0.30984080E-06_JPRB, 0.30942664E-06_JPRB, 0.30902908E-06_JPRB, 0.30864888E-06_JPRB, 0.30828915E-06_JPRB, 0.30795695E-06_JPRB, &
  & 0.30765617E-06_JPRB, 0.30737942E-06_JPRB, 0.30708642E-06_JPRB, 0.30660243E-06_JPRB /)

RGHG3(:,37, 9) = (/ &
  & 0.30179734E-06_JPRB, 0.30195977E-06_JPRB, 0.30202642E-06_JPRB, 0.30208801E-06_JPRB, 0.30216998E-06_JPRB, 0.30230046E-06_JPRB, &
  & 0.30250862E-06_JPRB, 0.30282413E-06_JPRB, 0.30326032E-06_JPRB, 0.30381287E-06_JPRB, 0.30447563E-06_JPRB, 0.30523489E-06_JPRB, &
  & 0.30608240E-06_JPRB, 0.30699749E-06_JPRB, 0.30795931E-06_JPRB, 0.30893921E-06_JPRB, 0.30991916E-06_JPRB, 0.31087509E-06_JPRB, &
  & 0.31181020E-06_JPRB, 0.31270187E-06_JPRB, 0.31352749E-06_JPRB, 0.31426680E-06_JPRB, 0.31489975E-06_JPRB, 0.31541737E-06_JPRB, &
  & 0.31582934E-06_JPRB, 0.31615383E-06_JPRB, 0.31641605E-06_JPRB, 0.31663606E-06_JPRB, 0.31682725E-06_JPRB, 0.31699642E-06_JPRB, &
  & 0.31714387E-06_JPRB, 0.31726626E-06_JPRB, 0.31735834E-06_JPRB, 0.31741655E-06_JPRB, 0.31743900E-06_JPRB, 0.31742510E-06_JPRB, &
  & 0.31737338E-06_JPRB, 0.31728129E-06_JPRB, 0.31714720E-06_JPRB, 0.31696479E-06_JPRB, 0.31672454E-06_JPRB, 0.31643282E-06_JPRB, &
  & 0.31609710E-06_JPRB, 0.31571818E-06_JPRB, 0.31530186E-06_JPRB, 0.31485698E-06_JPRB, 0.31439129E-06_JPRB, 0.31391360E-06_JPRB, &
  & 0.31342938E-06_JPRB, 0.31294175E-06_JPRB, 0.31246020E-06_JPRB, 0.31199343E-06_JPRB, 0.31154599E-06_JPRB, 0.31112131E-06_JPRB, &
  & 0.31072199E-06_JPRB, 0.31034145E-06_JPRB, 0.30997481E-06_JPRB, 0.30962232E-06_JPRB, 0.30928703E-06_JPRB, 0.30897533E-06_JPRB, &
  & 0.30869151E-06_JPRB, 0.30842682E-06_JPRB, 0.30814644E-06_JPRB, 0.30767535E-06_JPRB /)

RGHG3(:,38, 9) = (/ &
  & 0.30330290E-06_JPRB, 0.30346018E-06_JPRB, 0.30354650E-06_JPRB, 0.30362929E-06_JPRB, 0.30373542E-06_JPRB, 0.30388745E-06_JPRB, &
  & 0.30411198E-06_JPRB, 0.30442953E-06_JPRB, 0.30484719E-06_JPRB, 0.30536228E-06_JPRB, 0.30596581E-06_JPRB, 0.30664958E-06_JPRB, &
  & 0.30740568E-06_JPRB, 0.30822244E-06_JPRB, 0.30908194E-06_JPRB, 0.30996466E-06_JPRB, 0.31085560E-06_JPRB, 0.31174127E-06_JPRB, &
  & 0.31260876E-06_JPRB, 0.31345087E-06_JPRB, 0.31424216E-06_JPRB, 0.31494716E-06_JPRB, 0.31553924E-06_JPRB, 0.31601030E-06_JPRB, &
  & 0.31636785E-06_JPRB, 0.31663927E-06_JPRB, 0.31685073E-06_JPRB, 0.31702251E-06_JPRB, 0.31716738E-06_JPRB, 0.31729189E-06_JPRB, &
  & 0.31739776E-06_JPRB, 0.31748323E-06_JPRB, 0.31754556E-06_JPRB, 0.31758304E-06_JPRB, 0.31759473E-06_JPRB, 0.31758103E-06_JPRB, &
  & 0.31754035E-06_JPRB, 0.31747106E-06_JPRB, 0.31737022E-06_JPRB, 0.31722919E-06_JPRB, 0.31703834E-06_JPRB, 0.31680017E-06_JPRB, &
  & 0.31651223E-06_JPRB, 0.31617773E-06_JPRB, 0.31580328E-06_JPRB, 0.31539747E-06_JPRB, 0.31496515E-06_JPRB, 0.31451745E-06_JPRB, &
  & 0.31405912E-06_JPRB, 0.31359670E-06_JPRB, 0.31314013E-06_JPRB, 0.31270042E-06_JPRB, 0.31228370E-06_JPRB, 0.31189421E-06_JPRB, &
  & 0.31153036E-06_JPRB, 0.31118475E-06_JPRB, 0.31085182E-06_JPRB, 0.31052946E-06_JPRB, 0.31022077E-06_JPRB, 0.30993149E-06_JPRB, &
  & 0.30966569E-06_JPRB, 0.30941567E-06_JPRB, 0.30914691E-06_JPRB, 0.30869026E-06_JPRB /)

RGHG3(:,39, 9) = (/ &
  & 0.30461109E-06_JPRB, 0.30480794E-06_JPRB, 0.30491540E-06_JPRB, 0.30502099E-06_JPRB, 0.30514860E-06_JPRB, 0.30532155E-06_JPRB, &
  & 0.30555864E-06_JPRB, 0.30587174E-06_JPRB, 0.30626643E-06_JPRB, 0.30673820E-06_JPRB, 0.30728074E-06_JPRB, 0.30788854E-06_JPRB, &
  & 0.30855682E-06_JPRB, 0.30927836E-06_JPRB, 0.31004203E-06_JPRB, 0.31083272E-06_JPRB, 0.31163813E-06_JPRB, 0.31245207E-06_JPRB, &
  & 0.31326331E-06_JPRB, 0.31405710E-06_JPRB, 0.31480121E-06_JPRB, 0.31546085E-06_JPRB, 0.31600075E-06_JPRB, 0.31641375E-06_JPRB, &
  & 0.31671897E-06_JPRB, 0.31694356E-06_JPRB, 0.31711491E-06_JPRB, 0.31725165E-06_JPRB, 0.31736519E-06_JPRB, 0.31746112E-06_JPRB, &
  & 0.31754146E-06_JPRB, 0.31760527E-06_JPRB, 0.31765060E-06_JPRB, 0.31767647E-06_JPRB, 0.31768272E-06_JPRB, 0.31766993E-06_JPRB, &
  & 0.31763770E-06_JPRB, 0.31758472E-06_JPRB, 0.31750898E-06_JPRB, 0.31740285E-06_JPRB, 0.31725722E-06_JPRB, 0.31707157E-06_JPRB, &
  & 0.31683751E-06_JPRB, 0.31655560E-06_JPRB, 0.31623037E-06_JPRB, 0.31586561E-06_JPRB, 0.31546955E-06_JPRB, 0.31505223E-06_JPRB, &
  & 0.31461943E-06_JPRB, 0.31418040E-06_JPRB, 0.31374813E-06_JPRB, 0.31333477E-06_JPRB, 0.31294951E-06_JPRB, 0.31259546E-06_JPRB, &
  & 0.31226773E-06_JPRB, 0.31195884E-06_JPRB, 0.31166047E-06_JPRB, 0.31137029E-06_JPRB, 0.31108985E-06_JPRB, 0.31082530E-06_JPRB, &
  & 0.31057937E-06_JPRB, 0.31034517E-06_JPRB, 0.31008918E-06_JPRB, 0.30965194E-06_JPRB /)

RGHG3(:,40, 9) = (/ &
  & 0.30581410E-06_JPRB, 0.30603377E-06_JPRB, 0.30616263E-06_JPRB, 0.30628595E-06_JPRB, 0.30643685E-06_JPRB, 0.30662943E-06_JPRB, &
  & 0.30687460E-06_JPRB, 0.30718138E-06_JPRB, 0.30754754E-06_JPRB, 0.30797256E-06_JPRB, 0.30845374E-06_JPRB, 0.30898656E-06_JPRB, &
  & 0.30957031E-06_JPRB, 0.31020141E-06_JPRB, 0.31087336E-06_JPRB, 0.31157725E-06_JPRB, 0.31230468E-06_JPRB, 0.31304702E-06_JPRB, &
  & 0.31379852E-06_JPRB, 0.31453666E-06_JPRB, 0.31523248E-06_JPRB, 0.31583608E-06_JPRB, 0.31631978E-06_JPRB, 0.31668139E-06_JPRB, &
  & 0.31694179E-06_JPRB, 0.31713105E-06_JPRB, 0.31727376E-06_JPRB, 0.31738682E-06_JPRB, 0.31747982E-06_JPRB, 0.31755818E-06_JPRB, &
  & 0.31762323E-06_JPRB, 0.31767468E-06_JPRB, 0.31771052E-06_JPRB, 0.31773004E-06_JPRB, 0.31773348E-06_JPRB, 0.31772160E-06_JPRB, &
  & 0.31769454E-06_JPRB, 0.31765165E-06_JPRB, 0.31759234E-06_JPRB, 0.31751011E-06_JPRB, 0.31739864E-06_JPRB, 0.31725591E-06_JPRB, &
  & 0.31707233E-06_JPRB, 0.31684596E-06_JPRB, 0.31657501E-06_JPRB, 0.31625751E-06_JPRB, 0.31590258E-06_JPRB, 0.31551815E-06_JPRB, &
  & 0.31511132E-06_JPRB, 0.31469699E-06_JPRB, 0.31428863E-06_JPRB, 0.31390192E-06_JPRB, 0.31354830E-06_JPRB, 0.31322855E-06_JPRB, &
  & 0.31293723E-06_JPRB, 0.31266384E-06_JPRB, 0.31240094E-06_JPRB, 0.31214302E-06_JPRB, 0.31189236E-06_JPRB, 0.31165345E-06_JPRB, &
  & 0.31142955E-06_JPRB, 0.31121277E-06_JPRB, 0.31097440E-06_JPRB, 0.31055822E-06_JPRB /)

RGHG3(:,41, 9) = (/ &
  & 0.30692991E-06_JPRB, 0.30716797E-06_JPRB, 0.30730564E-06_JPRB, 0.30745008E-06_JPRB, 0.30761925E-06_JPRB, 0.30782928E-06_JPRB, &
  & 0.30808360E-06_JPRB, 0.30837677E-06_JPRB, 0.30871357E-06_JPRB, 0.30909212E-06_JPRB, 0.30951190E-06_JPRB, 0.30997339E-06_JPRB, &
  & 0.31047682E-06_JPRB, 0.31102289E-06_JPRB, 0.31160846E-06_JPRB, 0.31222859E-06_JPRB, 0.31287831E-06_JPRB, 0.31355350E-06_JPRB, &
  & 0.31424236E-06_JPRB, 0.31492866E-06_JPRB, 0.31556698E-06_JPRB, 0.31611802E-06_JPRB, 0.31654935E-06_JPRB, 0.31686596E-06_JPRB, &
  & 0.31709163E-06_JPRB, 0.31725418E-06_JPRB, 0.31737642E-06_JPRB, 0.31747274E-06_JPRB, 0.31755209E-06_JPRB, 0.31761874E-06_JPRB, &
  & 0.31767439E-06_JPRB, 0.31771819E-06_JPRB, 0.31774854E-06_JPRB, 0.31776440E-06_JPRB, 0.31776619E-06_JPRB, 0.31775491E-06_JPRB, &
  & 0.31773118E-06_JPRB, 0.31769483E-06_JPRB, 0.31764569E-06_JPRB, 0.31757983E-06_JPRB, 0.31749161E-06_JPRB, 0.31738065E-06_JPRB, &
  & 0.31723786E-06_JPRB, 0.31706060E-06_JPRB, 0.31684209E-06_JPRB, 0.31657751E-06_JPRB, 0.31626715E-06_JPRB, 0.31591861E-06_JPRB, &
  & 0.31554154E-06_JPRB, 0.31515196E-06_JPRB, 0.31476745E-06_JPRB, 0.31440791E-06_JPRB, 0.31408464E-06_JPRB, 0.31379875E-06_JPRB, &
  & 0.31354176E-06_JPRB, 0.31330370E-06_JPRB, 0.31307400E-06_JPRB, 0.31284850E-06_JPRB, 0.31262715E-06_JPRB, 0.31241535E-06_JPRB, &
  & 0.31221464E-06_JPRB, 0.31201853E-06_JPRB, 0.31179786E-06_JPRB, 0.31141167E-06_JPRB /)

RGHG3(:,42, 9) = (/ &
  & 0.30798500E-06_JPRB, 0.30822599E-06_JPRB, 0.30837774E-06_JPRB, 0.30852914E-06_JPRB, 0.30871786E-06_JPRB, 0.30894444E-06_JPRB, &
  & 0.30919836E-06_JPRB, 0.30948041E-06_JPRB, 0.30978512E-06_JPRB, 0.31011808E-06_JPRB, 0.31048083E-06_JPRB, 0.31087524E-06_JPRB, &
  & 0.31130517E-06_JPRB, 0.31177248E-06_JPRB, 0.31227748E-06_JPRB, 0.31281803E-06_JPRB, 0.31339272E-06_JPRB, 0.31399813E-06_JPRB, &
  & 0.31462838E-06_JPRB, 0.31525562E-06_JPRB, 0.31584398E-06_JPRB, 0.31634042E-06_JPRB, 0.31672471E-06_JPRB, 0.31700321E-06_JPRB, &
  & 0.31720032E-06_JPRB, 0.31734223E-06_JPRB, 0.31744869E-06_JPRB, 0.31753277E-06_JPRB, 0.31760209E-06_JPRB, 0.31766078E-06_JPRB, &
  & 0.31770978E-06_JPRB, 0.31774866E-06_JPRB, 0.31777535E-06_JPRB, 0.31778899E-06_JPRB, 0.31778987E-06_JPRB, 0.31777921E-06_JPRB, &
  & 0.31775781E-06_JPRB, 0.31772575E-06_JPRB, 0.31768377E-06_JPRB, 0.31762872E-06_JPRB, 0.31755695E-06_JPRB, 0.31746845E-06_JPRB, &
  & 0.31735649E-06_JPRB, 0.31721831E-06_JPRB, 0.31704747E-06_JPRB, 0.31683166E-06_JPRB, 0.31656930E-06_JPRB, 0.31625981E-06_JPRB, &
  & 0.31591389E-06_JPRB, 0.31555138E-06_JPRB, 0.31519266E-06_JPRB, 0.31485965E-06_JPRB, 0.31456668E-06_JPRB, 0.31431225E-06_JPRB, &
  & 0.31408837E-06_JPRB, 0.31388282E-06_JPRB, 0.31368580E-06_JPRB, 0.31349077E-06_JPRB, 0.31329881E-06_JPRB, 0.31311345E-06_JPRB, &
  & 0.31293729E-06_JPRB, 0.31276252E-06_JPRB, 0.31256505E-06_JPRB, 0.31221299E-06_JPRB /)

RGHG3(:,43, 9) = (/ &
  & 0.30901168E-06_JPRB, 0.30925389E-06_JPRB, 0.30939847E-06_JPRB, 0.30955783E-06_JPRB, 0.30975491E-06_JPRB, 0.30998839E-06_JPRB, &
  & 0.31024433E-06_JPRB, 0.31050755E-06_JPRB, 0.31078298E-06_JPRB, 0.31107319E-06_JPRB, 0.31138305E-06_JPRB, 0.31171712E-06_JPRB, &
  & 0.31207995E-06_JPRB, 0.31247617E-06_JPRB, 0.31290642E-06_JPRB, 0.31337200E-06_JPRB, 0.31387262E-06_JPRB, 0.31441098E-06_JPRB, &
  & 0.31497672E-06_JPRB, 0.31555052E-06_JPRB, 0.31608084E-06_JPRB, 0.31652669E-06_JPRB, 0.31686602E-06_JPRB, 0.31711096E-06_JPRB, &
  & 0.31728428E-06_JPRB, 0.31740925E-06_JPRB, 0.31750335E-06_JPRB, 0.31757779E-06_JPRB, 0.31763960E-06_JPRB, 0.31769218E-06_JPRB, &
  & 0.31773664E-06_JPRB, 0.31777188E-06_JPRB, 0.31779609E-06_JPRB, 0.31780823E-06_JPRB, 0.31780866E-06_JPRB, 0.31779857E-06_JPRB, &
  & 0.31777890E-06_JPRB, 0.31775016E-06_JPRB, 0.31771310E-06_JPRB, 0.31766604E-06_JPRB, 0.31760572E-06_JPRB, 0.31753376E-06_JPRB, &
  & 0.31744483E-06_JPRB, 0.31733745E-06_JPRB, 0.31720469E-06_JPRB, 0.31703487E-06_JPRB, 0.31681830E-06_JPRB, 0.31654989E-06_JPRB, &
  & 0.31623864E-06_JPRB, 0.31590446E-06_JPRB, 0.31557209E-06_JPRB, 0.31526667E-06_JPRB, 0.31500190E-06_JPRB, 0.31477774E-06_JPRB, &
  & 0.31458438E-06_JPRB, 0.31440979E-06_JPRB, 0.31424278E-06_JPRB, 0.31407745E-06_JPRB, 0.31391306E-06_JPRB, 0.31375390E-06_JPRB, &
  & 0.31360150E-06_JPRB, 0.31345010E-06_JPRB, 0.31327690E-06_JPRB, 0.31296742E-06_JPRB /)

RGHG3(:,44, 9) = (/ &
  & 0.31000752E-06_JPRB, 0.31025743E-06_JPRB, 0.31040142E-06_JPRB, 0.31055461E-06_JPRB, 0.31075137E-06_JPRB, 0.31098895E-06_JPRB, &
  & 0.31123406E-06_JPRB, 0.31148062E-06_JPRB, 0.31172590E-06_JPRB, 0.31197681E-06_JPRB, 0.31223891E-06_JPRB, 0.31251798E-06_JPRB, &
  & 0.31282190E-06_JPRB, 0.31315324E-06_JPRB, 0.31351647E-06_JPRB, 0.31391087E-06_JPRB, 0.31434223E-06_JPRB, 0.31480971E-06_JPRB, &
  & 0.31531411E-06_JPRB, 0.31582226E-06_JPRB, 0.31629611E-06_JPRB, 0.31668677E-06_JPRB, 0.31698414E-06_JPRB, 0.31719875E-06_JPRB, &
  & 0.31735152E-06_JPRB, 0.31746245E-06_JPRB, 0.31754632E-06_JPRB, 0.31761311E-06_JPRB, 0.31766902E-06_JPRB, 0.31771708E-06_JPRB, &
  & 0.31775801E-06_JPRB, 0.31779072E-06_JPRB, 0.31781315E-06_JPRB, 0.31782434E-06_JPRB, 0.31782452E-06_JPRB, 0.31781494E-06_JPRB, &
  & 0.31779678E-06_JPRB, 0.31777049E-06_JPRB, 0.31773723E-06_JPRB, 0.31769596E-06_JPRB, 0.31764438E-06_JPRB, 0.31758466E-06_JPRB, &
  & 0.31751335E-06_JPRB, 0.31742960E-06_JPRB, 0.31732853E-06_JPRB, 0.31719750E-06_JPRB, 0.31702461E-06_JPRB, 0.31679909E-06_JPRB, &
  & 0.31652294E-06_JPRB, 0.31621909E-06_JPRB, 0.31591446E-06_JPRB, 0.31563559E-06_JPRB, 0.31539929E-06_JPRB, 0.31520347E-06_JPRB, &
  & 0.31503913E-06_JPRB, 0.31489319E-06_JPRB, 0.31475469E-06_JPRB, 0.31461661E-06_JPRB, 0.31447837E-06_JPRB, 0.31434337E-06_JPRB, &
  & 0.31421402E-06_JPRB, 0.31408524E-06_JPRB, 0.31393873E-06_JPRB, 0.31367637E-06_JPRB /)

RGHG3(:,45, 9) = (/ &
  & 0.31112188E-06_JPRB, 0.31129159E-06_JPRB, 0.31140476E-06_JPRB, 0.31154045E-06_JPRB, 0.31173053E-06_JPRB, 0.31195617E-06_JPRB, &
  & 0.31219076E-06_JPRB, 0.31241495E-06_JPRB, 0.31263050E-06_JPRB, 0.31284412E-06_JPRB, 0.31306186E-06_JPRB, 0.31329301E-06_JPRB, &
  & 0.31354207E-06_JPRB, 0.31381745E-06_JPRB, 0.31411815E-06_JPRB, 0.31444966E-06_JPRB, 0.31481213E-06_JPRB, 0.31521520E-06_JPRB, &
  & 0.31564522E-06_JPRB, 0.31608860E-06_JPRB, 0.31649148E-06_JPRB, 0.31682754E-06_JPRB, 0.31708359E-06_JPRB, 0.31727100E-06_JPRB, &
  & 0.31740618E-06_JPRB, 0.31750523E-06_JPRB, 0.31758083E-06_JPRB, 0.31764154E-06_JPRB, 0.31769275E-06_JPRB, 0.31773732E-06_JPRB, &
  & 0.31777557E-06_JPRB, 0.31780644E-06_JPRB, 0.31782761E-06_JPRB, 0.31783819E-06_JPRB, 0.31783819E-06_JPRB, 0.31782935E-06_JPRB, &
  & 0.31781241E-06_JPRB, 0.31778819E-06_JPRB, 0.31775775E-06_JPRB, 0.31772086E-06_JPRB, 0.31767581E-06_JPRB, 0.31762534E-06_JPRB, &
  & 0.31756758E-06_JPRB, 0.31750224E-06_JPRB, 0.31742567E-06_JPRB, 0.31732731E-06_JPRB, 0.31719472E-06_JPRB, 0.31701117E-06_JPRB, &
  & 0.31677439E-06_JPRB, 0.31650313E-06_JPRB, 0.31622676E-06_JPRB, 0.31597654E-06_JPRB, 0.31576698E-06_JPRB, 0.31559892E-06_JPRB, &
  & 0.31546202E-06_JPRB, 0.31534242E-06_JPRB, 0.31522984E-06_JPRB, 0.31511681E-06_JPRB, 0.31500184E-06_JPRB, 0.31488881E-06_JPRB, &
  & 0.31478018E-06_JPRB, 0.31467320E-06_JPRB, 0.31455218E-06_JPRB, 0.31433797E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART18',0,ZHOOK_HANDLE)



RGHG3(:,46, 9) = (/ &
  & 0.31198090E-06_JPRB, 0.31222032E-06_JPRB, 0.31235928E-06_JPRB, 0.31250701E-06_JPRB, 0.31269204E-06_JPRB, 0.31291233E-06_JPRB, &
  & 0.31312783E-06_JPRB, 0.31332695E-06_JPRB, 0.31351124E-06_JPRB, 0.31368720E-06_JPRB, 0.31386401E-06_JPRB, 0.31404829E-06_JPRB, &
  & 0.31425074E-06_JPRB, 0.31447181E-06_JPRB, 0.31471910E-06_JPRB, 0.31499025E-06_JPRB, 0.31529362E-06_JPRB, 0.31562385E-06_JPRB, &
  & 0.31598492E-06_JPRB, 0.31634124E-06_JPRB, 0.31667378E-06_JPRB, 0.31695009E-06_JPRB, 0.31716777E-06_JPRB, 0.31733077E-06_JPRB, &
  & 0.31745060E-06_JPRB, 0.31753973E-06_JPRB, 0.31760865E-06_JPRB, 0.31766447E-06_JPRB, 0.31771214E-06_JPRB, 0.31775394E-06_JPRB, &
  & 0.31779030E-06_JPRB, 0.31781977E-06_JPRB, 0.31784012E-06_JPRB, 0.31785027E-06_JPRB, 0.31785046E-06_JPRB, 0.31784214E-06_JPRB, &
  & 0.31782631E-06_JPRB, 0.31780365E-06_JPRB, 0.31777540E-06_JPRB, 0.31774186E-06_JPRB, 0.31770188E-06_JPRB, 0.31765865E-06_JPRB, &
  & 0.31761121E-06_JPRB, 0.31755962E-06_JPRB, 0.31750193E-06_JPRB, 0.31742945E-06_JPRB, 0.31733057E-06_JPRB, 0.31718906E-06_JPRB, &
  & 0.31699483E-06_JPRB, 0.31676041E-06_JPRB, 0.31651709E-06_JPRB, 0.31629381E-06_JPRB, 0.31611253E-06_JPRB, 0.31597122E-06_JPRB, &
  & 0.31585878E-06_JPRB, 0.31576334E-06_JPRB, 0.31567316E-06_JPRB, 0.31558176E-06_JPRB, 0.31548740E-06_JPRB, 0.31539312E-06_JPRB, &
  & 0.31530311E-06_JPRB, 0.31521506E-06_JPRB, 0.31511735E-06_JPRB, 0.31494710E-06_JPRB /)

RGHG3(:,47, 9) = (/ &
  & 0.31295835E-06_JPRB, 0.31317850E-06_JPRB, 0.31331848E-06_JPRB, 0.31346841E-06_JPRB, 0.31365744E-06_JPRB, 0.31386548E-06_JPRB, &
  & 0.31405963E-06_JPRB, 0.31422985E-06_JPRB, 0.31437844E-06_JPRB, 0.31451589E-06_JPRB, 0.31465029E-06_JPRB, 0.31479237E-06_JPRB, &
  & 0.31494639E-06_JPRB, 0.31512155E-06_JPRB, 0.31531619E-06_JPRB, 0.31553591E-06_JPRB, 0.31577517E-06_JPRB, 0.31603969E-06_JPRB, &
  & 0.31631058E-06_JPRB, 0.31658445E-06_JPRB, 0.31683547E-06_JPRB, 0.31705736E-06_JPRB, 0.31723835E-06_JPRB, 0.31737972E-06_JPRB, &
  & 0.31748661E-06_JPRB, 0.31756764E-06_JPRB, 0.31763108E-06_JPRB, 0.31768317E-06_JPRB, 0.31772805E-06_JPRB, 0.31776787E-06_JPRB, &
  & 0.31780280E-06_JPRB, 0.31783122E-06_JPRB, 0.31785095E-06_JPRB, 0.31786089E-06_JPRB, 0.31786132E-06_JPRB, 0.31785362E-06_JPRB, &
  & 0.31783873E-06_JPRB, 0.31781735E-06_JPRB, 0.31779072E-06_JPRB, 0.31775971E-06_JPRB, 0.31772390E-06_JPRB, 0.31768607E-06_JPRB, &
  & 0.31764645E-06_JPRB, 0.31760518E-06_JPRB, 0.31756110E-06_JPRB, 0.31750764E-06_JPRB, 0.31743613E-06_JPRB, 0.31733180E-06_JPRB, &
  & 0.31718261E-06_JPRB, 0.31699335E-06_JPRB, 0.31678570E-06_JPRB, 0.31659533E-06_JPRB, 0.31644055E-06_JPRB, 0.31632328E-06_JPRB, &
  & 0.31623358E-06_JPRB, 0.31615747E-06_JPRB, 0.31608650E-06_JPRB, 0.31601320E-06_JPRB, 0.31593584E-06_JPRB, 0.31585768E-06_JPRB, &
  & 0.31578287E-06_JPRB, 0.31571085E-06_JPRB, 0.31563232E-06_JPRB, 0.31549791E-06_JPRB /)

RGHG3(:,48, 9) = (/ &
  & 0.31382984E-06_JPRB, 0.31407856E-06_JPRB, 0.31423690E-06_JPRB, 0.31440271E-06_JPRB, 0.31459859E-06_JPRB, 0.31480278E-06_JPRB, &
  & 0.31497953E-06_JPRB, 0.31511897E-06_JPRB, 0.31523214E-06_JPRB, 0.31532971E-06_JPRB, 0.31542356E-06_JPRB, 0.31552096E-06_JPRB, &
  & 0.31563184E-06_JPRB, 0.31575888E-06_JPRB, 0.31590639E-06_JPRB, 0.31606842E-06_JPRB, 0.31624657E-06_JPRB, 0.31642753E-06_JPRB, &
  & 0.31661386E-06_JPRB, 0.31679662E-06_JPRB, 0.31697823E-06_JPRB, 0.31714771E-06_JPRB, 0.31729726E-06_JPRB, 0.31741979E-06_JPRB, &
  & 0.31751577E-06_JPRB, 0.31759015E-06_JPRB, 0.31764935E-06_JPRB, 0.31769855E-06_JPRB, 0.31774135E-06_JPRB, 0.31777972E-06_JPRB, &
  & 0.31781354E-06_JPRB, 0.31784120E-06_JPRB, 0.31786050E-06_JPRB, 0.31787030E-06_JPRB, 0.31787113E-06_JPRB, 0.31786396E-06_JPRB, &
  & 0.31784998E-06_JPRB, 0.31782963E-06_JPRB, 0.31780428E-06_JPRB, 0.31777532E-06_JPRB, 0.31774255E-06_JPRB, 0.31770884E-06_JPRB, &
  & 0.31767505E-06_JPRB, 0.31764125E-06_JPRB, 0.31760672E-06_JPRB, 0.31756699E-06_JPRB, 0.31751532E-06_JPRB, 0.31744176E-06_JPRB, &
  & 0.31733529E-06_JPRB, 0.31719523E-06_JPRB, 0.31703505E-06_JPRB, 0.31688012E-06_JPRB, 0.31675387E-06_JPRB, 0.31665957E-06_JPRB, &
  & 0.31658772E-06_JPRB, 0.31652809E-06_JPRB, 0.31647178E-06_JPRB, 0.31641289E-06_JPRB, 0.31634909E-06_JPRB, 0.31628332E-06_JPRB, &
  & 0.31622051E-06_JPRB, 0.31616082E-06_JPRB, 0.31609676E-06_JPRB, 0.31598881E-06_JPRB /)

RGHG3(:,49, 9) = (/ &
  & 0.31460775E-06_JPRB, 0.31488008E-06_JPRB, 0.31505363E-06_JPRB, 0.31523163E-06_JPRB, 0.31543951E-06_JPRB, 0.31564969E-06_JPRB, &
  & 0.31581510E-06_JPRB, 0.31593351E-06_JPRB, 0.31601786E-06_JPRB, 0.31608394E-06_JPRB, 0.31614167E-06_JPRB, 0.31620198E-06_JPRB, &
  & 0.31627044E-06_JPRB, 0.31635238E-06_JPRB, 0.31644657E-06_JPRB, 0.31655054E-06_JPRB, 0.31665382E-06_JPRB, 0.31675853E-06_JPRB, &
  & 0.31686275E-06_JPRB, 0.31697425E-06_JPRB, 0.31709558E-06_JPRB, 0.31722334E-06_JPRB, 0.31734552E-06_JPRB, 0.31745242E-06_JPRB, &
  & 0.31753942E-06_JPRB, 0.31760860E-06_JPRB, 0.31766450E-06_JPRB, 0.31771154E-06_JPRB, 0.31775284E-06_JPRB, 0.31779001E-06_JPRB, &
  & 0.31782301E-06_JPRB, 0.31785012E-06_JPRB, 0.31786908E-06_JPRB, 0.31787883E-06_JPRB, 0.31787999E-06_JPRB, 0.31787332E-06_JPRB, &
  & 0.31786013E-06_JPRB, 0.31784080E-06_JPRB, 0.31781661E-06_JPRB, 0.31778916E-06_JPRB, 0.31775878E-06_JPRB, 0.31772805E-06_JPRB, &
  & 0.31769858E-06_JPRB, 0.31766996E-06_JPRB, 0.31764239E-06_JPRB, 0.31761184E-06_JPRB, 0.31757438E-06_JPRB, 0.31752313E-06_JPRB, &
  & 0.31745185E-06_JPRB, 0.31735863E-06_JPRB, 0.31724989E-06_JPRB, 0.31714023E-06_JPRB, 0.31704684E-06_JPRB, 0.31697522E-06_JPRB, &
  & 0.31691968E-06_JPRB, 0.31687358E-06_JPRB, 0.31682873E-06_JPRB, 0.31678093E-06_JPRB, 0.31672778E-06_JPRB, 0.31667159E-06_JPRB, &
  & 0.31661762E-06_JPRB, 0.31656688E-06_JPRB, 0.31651260E-06_JPRB, 0.31642313E-06_JPRB /)

RGHG3(:,50, 9) = (/ &
  & 0.31535927E-06_JPRB, 0.31559017E-06_JPRB, 0.31573779E-06_JPRB, 0.31590142E-06_JPRB, 0.31609801E-06_JPRB, 0.31629762E-06_JPRB, &
  & 0.31644907E-06_JPRB, 0.31654849E-06_JPRB, 0.31661307E-06_JPRB, 0.31665792E-06_JPRB, 0.31669518E-06_JPRB, 0.31672988E-06_JPRB, &
  & 0.31676819E-06_JPRB, 0.31681236E-06_JPRB, 0.31686068E-06_JPRB, 0.31690840E-06_JPRB, 0.31695538E-06_JPRB, 0.31700066E-06_JPRB, &
  & 0.31705048E-06_JPRB, 0.31711210E-06_JPRB, 0.31719043E-06_JPRB, 0.31728482E-06_JPRB, 0.31738523E-06_JPRB, 0.31747911E-06_JPRB, &
  & 0.31755897E-06_JPRB, 0.31762411E-06_JPRB, 0.31767746E-06_JPRB, 0.31772279E-06_JPRB, 0.31776295E-06_JPRB, 0.31779919E-06_JPRB, &
  & 0.31783145E-06_JPRB, 0.31785802E-06_JPRB, 0.31787667E-06_JPRB, 0.31788647E-06_JPRB, 0.31788795E-06_JPRB, 0.31788193E-06_JPRB, &
  & 0.31786954E-06_JPRB, 0.31785106E-06_JPRB, 0.31782787E-06_JPRB, 0.31780178E-06_JPRB, 0.31777321E-06_JPRB, 0.31774479E-06_JPRB, &
  & 0.31771805E-06_JPRB, 0.31769366E-06_JPRB, 0.31767033E-06_JPRB, 0.31764640E-06_JPRB, 0.31761817E-06_JPRB, 0.31758233E-06_JPRB, &
  & 0.31753581E-06_JPRB, 0.31747916E-06_JPRB, 0.31741482E-06_JPRB, 0.31735027E-06_JPRB, 0.31729286E-06_JPRB, 0.31724642E-06_JPRB, &
  & 0.31720975E-06_JPRB, 0.31717641E-06_JPRB, 0.31714410E-06_JPRB, 0.31710744E-06_JPRB, 0.31706440E-06_JPRB, 0.31701774E-06_JPRB, &
  & 0.31697189E-06_JPRB, 0.31692798E-06_JPRB, 0.31688177E-06_JPRB, 0.31680290E-06_JPRB /)

RGHG3(:,51, 9) = (/ &
  & 0.31592288E-06_JPRB, 0.31611881E-06_JPRB, 0.31624836E-06_JPRB, 0.31638203E-06_JPRB, 0.31655347E-06_JPRB, 0.31672494E-06_JPRB, &
  & 0.31685011E-06_JPRB, 0.31692630E-06_JPRB, 0.31697309E-06_JPRB, 0.31700557E-06_JPRB, 0.31702965E-06_JPRB, 0.31705190E-06_JPRB, &
  & 0.31707350E-06_JPRB, 0.31709521E-06_JPRB, 0.31711556E-06_JPRB, 0.31713333E-06_JPRB, 0.31714828E-06_JPRB, 0.31716385E-06_JPRB, &
  & 0.31718452E-06_JPRB, 0.31721618E-06_JPRB, 0.31726623E-06_JPRB, 0.31733543E-06_JPRB, 0.31741780E-06_JPRB, 0.31750116E-06_JPRB, &
  & 0.31757540E-06_JPRB, 0.31763744E-06_JPRB, 0.31768894E-06_JPRB, 0.31773291E-06_JPRB, 0.31777205E-06_JPRB, 0.31780755E-06_JPRB, &
  & 0.31783910E-06_JPRB, 0.31786516E-06_JPRB, 0.31788352E-06_JPRB, 0.31789358E-06_JPRB, 0.31789534E-06_JPRB, 0.31788991E-06_JPRB, &
  & 0.31787823E-06_JPRB, 0.31786072E-06_JPRB, 0.31783856E-06_JPRB, 0.31781349E-06_JPRB, 0.31778629E-06_JPRB, 0.31775943E-06_JPRB, &
  & 0.31773513E-06_JPRB, 0.31771293E-06_JPRB, 0.31769338E-06_JPRB, 0.31767345E-06_JPRB, 0.31765160E-06_JPRB, 0.31762582E-06_JPRB, &
  & 0.31759555E-06_JPRB, 0.31756187E-06_JPRB, 0.31752751E-06_JPRB, 0.31749408E-06_JPRB, 0.31746552E-06_JPRB, 0.31744213E-06_JPRB, &
  & 0.31742218E-06_JPRB, 0.31740464E-06_JPRB, 0.31738540E-06_JPRB, 0.31736286E-06_JPRB, 0.31733464E-06_JPRB, 0.31730102E-06_JPRB, &
  & 0.31726600E-06_JPRB, 0.31723187E-06_JPRB, 0.31719233E-06_JPRB, 0.31712656E-06_JPRB /)

RGHG3(:,52, 9) = (/ &
  & 0.31641886E-06_JPRB, 0.31653764E-06_JPRB, 0.31661870E-06_JPRB, 0.31672380E-06_JPRB, 0.31685542E-06_JPRB, 0.31699443E-06_JPRB, &
  & 0.31708899E-06_JPRB, 0.31714461E-06_JPRB, 0.31717786E-06_JPRB, 0.31719944E-06_JPRB, 0.31721669E-06_JPRB, 0.31723090E-06_JPRB, &
  & 0.31724417E-06_JPRB, 0.31725563E-06_JPRB, 0.31726373E-06_JPRB, 0.31726816E-06_JPRB, 0.31727052E-06_JPRB, 0.31727305E-06_JPRB, &
  & 0.31727967E-06_JPRB, 0.31729576E-06_JPRB, 0.31732682E-06_JPRB, 0.31737784E-06_JPRB, 0.31744585E-06_JPRB, 0.31752012E-06_JPRB, &
  & 0.31758978E-06_JPRB, 0.31764938E-06_JPRB, 0.31769923E-06_JPRB, 0.31774212E-06_JPRB, 0.31778040E-06_JPRB, 0.31781511E-06_JPRB, &
  & 0.31784606E-06_JPRB, 0.31787170E-06_JPRB, 0.31788994E-06_JPRB, 0.31790000E-06_JPRB, 0.31790219E-06_JPRB, 0.31789725E-06_JPRB, &
  & 0.31788633E-06_JPRB, 0.31786976E-06_JPRB, 0.31784867E-06_JPRB, 0.31782457E-06_JPRB, 0.31779851E-06_JPRB, 0.31777307E-06_JPRB, &
  & 0.31774974E-06_JPRB, 0.31773021E-06_JPRB, 0.31771225E-06_JPRB, 0.31769554E-06_JPRB, 0.31767786E-06_JPRB, 0.31765867E-06_JPRB, &
  & 0.31763838E-06_JPRB, 0.31761840E-06_JPRB, 0.31759981E-06_JPRB, 0.31758401E-06_JPRB, 0.31757082E-06_JPRB, 0.31756073E-06_JPRB, &
  & 0.31755243E-06_JPRB, 0.31754453E-06_JPRB, 0.31753615E-06_JPRB, 0.31752535E-06_JPRB, 0.31751065E-06_JPRB, 0.31749215E-06_JPRB, &
  & 0.31747123E-06_JPRB, 0.31744850E-06_JPRB, 0.31742240E-06_JPRB, 0.31737025E-06_JPRB /)

RGHG3(:,53, 9) = (/ &
  & 0.31670913E-06_JPRB, 0.31680807E-06_JPRB, 0.31688114E-06_JPRB, 0.31695603E-06_JPRB, 0.31706332E-06_JPRB, 0.31716701E-06_JPRB, &
  & 0.31723792E-06_JPRB, 0.31727686E-06_JPRB, 0.31729971E-06_JPRB, 0.31731531E-06_JPRB, 0.31732679E-06_JPRB, 0.31733703E-06_JPRB, &
  & 0.31734569E-06_JPRB, 0.31735229E-06_JPRB, 0.31735536E-06_JPRB, 0.31735493E-06_JPRB, 0.31735232E-06_JPRB, 0.31734965E-06_JPRB, &
  & 0.31734987E-06_JPRB, 0.31735698E-06_JPRB, 0.31737684E-06_JPRB, 0.31741450E-06_JPRB, 0.31747066E-06_JPRB, 0.31753763E-06_JPRB, &
  & 0.31760297E-06_JPRB, 0.31766024E-06_JPRB, 0.31770870E-06_JPRB, 0.31775051E-06_JPRB, 0.31778791E-06_JPRB, 0.31782207E-06_JPRB, &
  & 0.31785240E-06_JPRB, 0.31787764E-06_JPRB, 0.31789577E-06_JPRB, 0.31790597E-06_JPRB, 0.31790859E-06_JPRB, 0.31790421E-06_JPRB, &
  & 0.31789395E-06_JPRB, 0.31787829E-06_JPRB, 0.31785819E-06_JPRB, 0.31783514E-06_JPRB, 0.31781016E-06_JPRB, 0.31778546E-06_JPRB, &
  & 0.31776389E-06_JPRB, 0.31774482E-06_JPRB, 0.31772916E-06_JPRB, 0.31771415E-06_JPRB, 0.31769943E-06_JPRB, 0.31768457E-06_JPRB, &
  & 0.31767050E-06_JPRB, 0.31765791E-06_JPRB, 0.31764770E-06_JPRB, 0.31763955E-06_JPRB, 0.31763386E-06_JPRB, 0.31762951E-06_JPRB, &
  & 0.31762619E-06_JPRB, 0.31762312E-06_JPRB, 0.31761957E-06_JPRB, 0.31761482E-06_JPRB, 0.31760811E-06_JPRB, 0.31759890E-06_JPRB, &
  & 0.31758813E-06_JPRB, 0.31757673E-06_JPRB, 0.31756187E-06_JPRB, 0.31753189E-06_JPRB /)

RGHG3(:,54, 9) = (/ &
  & 0.31695805E-06_JPRB, 0.31702692E-06_JPRB, 0.31707111E-06_JPRB, 0.31713239E-06_JPRB, 0.31720663E-06_JPRB, 0.31728717E-06_JPRB, &
  & 0.31733686E-06_JPRB, 0.31736471E-06_JPRB, 0.31738074E-06_JPRB, 0.31739128E-06_JPRB, 0.31739978E-06_JPRB, 0.31740683E-06_JPRB, &
  & 0.31741303E-06_JPRB, 0.31741732E-06_JPRB, 0.31741848E-06_JPRB, 0.31741638E-06_JPRB, 0.31741203E-06_JPRB, 0.31740720E-06_JPRB, &
  & 0.31740421E-06_JPRB, 0.31740649E-06_JPRB, 0.31741871E-06_JPRB, 0.31744707E-06_JPRB, 0.31749448E-06_JPRB, 0.31755411E-06_JPRB, &
  & 0.31761564E-06_JPRB, 0.31767036E-06_JPRB, 0.31771731E-06_JPRB, 0.31775818E-06_JPRB, 0.31779484E-06_JPRB, 0.31782844E-06_JPRB, &
  & 0.31785825E-06_JPRB, 0.31788312E-06_JPRB, 0.31790114E-06_JPRB, 0.31791149E-06_JPRB, 0.31791447E-06_JPRB, 0.31791072E-06_JPRB, &
  & 0.31790117E-06_JPRB, 0.31788633E-06_JPRB, 0.31786718E-06_JPRB, 0.31784515E-06_JPRB, 0.31782122E-06_JPRB, 0.31779774E-06_JPRB, &
  & 0.31777643E-06_JPRB, 0.31775917E-06_JPRB, 0.31774402E-06_JPRB, 0.31773075E-06_JPRB, 0.31771805E-06_JPRB, 0.31770608E-06_JPRB, &
  & 0.31769562E-06_JPRB, 0.31768724E-06_JPRB, 0.31768087E-06_JPRB, 0.31767667E-06_JPRB, 0.31767371E-06_JPRB, 0.31767195E-06_JPRB, &
  & 0.31767053E-06_JPRB, 0.31766916E-06_JPRB, 0.31766760E-06_JPRB, 0.31766535E-06_JPRB, 0.31766209E-06_JPRB, 0.31765765E-06_JPRB, &
  & 0.31765265E-06_JPRB, 0.31764759E-06_JPRB, 0.31764299E-06_JPRB, 0.31763742E-06_JPRB /)

RGHG3(:,55, 9) = (/ &
  & 0.31712426E-06_JPRB, 0.31717627E-06_JPRB, 0.31721706E-06_JPRB, 0.31725756E-06_JPRB, 0.31731670E-06_JPRB, 0.31737127E-06_JPRB, &
  & 0.31740851E-06_JPRB, 0.31742769E-06_JPRB, 0.31743912E-06_JPRB, 0.31744685E-06_JPRB, 0.31745282E-06_JPRB, 0.31745810E-06_JPRB, &
  & 0.31746268E-06_JPRB, 0.31746589E-06_JPRB, 0.31746646E-06_JPRB, 0.31746390E-06_JPRB, 0.31745910E-06_JPRB, 0.31745333E-06_JPRB, &
  & 0.31744847E-06_JPRB, 0.31744753E-06_JPRB, 0.31745503E-06_JPRB, 0.31747692E-06_JPRB, 0.31751679E-06_JPRB, 0.31757119E-06_JPRB, &
  & 0.31762801E-06_JPRB, 0.31768013E-06_JPRB, 0.31772544E-06_JPRB, 0.31776528E-06_JPRB, 0.31780124E-06_JPRB, 0.31783429E-06_JPRB, &
  & 0.31786368E-06_JPRB, 0.31788832E-06_JPRB, 0.31790623E-06_JPRB, 0.31791666E-06_JPRB, 0.31792013E-06_JPRB, 0.31791694E-06_JPRB, &
  & 0.31790807E-06_JPRB, 0.31789403E-06_JPRB, 0.31787582E-06_JPRB, 0.31785459E-06_JPRB, 0.31783179E-06_JPRB, 0.31780908E-06_JPRB, &
  & 0.31778916E-06_JPRB, 0.31777222E-06_JPRB, 0.31775835E-06_JPRB, 0.31774590E-06_JPRB, 0.31773465E-06_JPRB, 0.31772458E-06_JPRB, &
  & 0.31771648E-06_JPRB, 0.31771029E-06_JPRB, 0.31770611E-06_JPRB, 0.31770327E-06_JPRB, 0.31770168E-06_JPRB, 0.31770054E-06_JPRB, &
  & 0.31769980E-06_JPRB, 0.31769912E-06_JPRB, 0.31769821E-06_JPRB, 0.31769696E-06_JPRB, 0.31769503E-06_JPRB, 0.31769241E-06_JPRB, &
  & 0.31768934E-06_JPRB, 0.31768622E-06_JPRB, 0.31768258E-06_JPRB, 0.31767678E-06_JPRB /)

RGHG3(:,56, 9) = (/ &
  & 0.31726199E-06_JPRB, 0.31730019E-06_JPRB, 0.31732517E-06_JPRB, 0.31735829E-06_JPRB, 0.31739677E-06_JPRB, 0.31743741E-06_JPRB, &
  & 0.31746231E-06_JPRB, 0.31747663E-06_JPRB, 0.31748476E-06_JPRB, 0.31749039E-06_JPRB, 0.31749494E-06_JPRB, 0.31749892E-06_JPRB, &
  & 0.31750255E-06_JPRB, 0.31750523E-06_JPRB, 0.31750574E-06_JPRB, 0.31750352E-06_JPRB, 0.31749877E-06_JPRB, 0.31749249E-06_JPRB, &
  & 0.31748641E-06_JPRB, 0.31748317E-06_JPRB, 0.31748718E-06_JPRB, 0.31750432E-06_JPRB, 0.31753930E-06_JPRB, 0.31758768E-06_JPRB, &
  & 0.31764068E-06_JPRB, 0.31768971E-06_JPRB, 0.31773334E-06_JPRB, 0.31777211E-06_JPRB, 0.31780735E-06_JPRB, 0.31783989E-06_JPRB, &
  & 0.31786891E-06_JPRB, 0.31789321E-06_JPRB, 0.31791097E-06_JPRB, 0.31792155E-06_JPRB, 0.31792550E-06_JPRB, 0.31792294E-06_JPRB, &
  & 0.31791464E-06_JPRB, 0.31790140E-06_JPRB, 0.31788392E-06_JPRB, 0.31786374E-06_JPRB, 0.31784185E-06_JPRB, 0.31782037E-06_JPRB, &
  & 0.31780110E-06_JPRB, 0.31778526E-06_JPRB, 0.31777191E-06_JPRB, 0.31776051E-06_JPRB, 0.31775025E-06_JPRB, 0.31774147E-06_JPRB, &
  & 0.31773465E-06_JPRB, 0.31772964E-06_JPRB, 0.31772632E-06_JPRB, 0.31772433E-06_JPRB, 0.31772305E-06_JPRB, 0.31772237E-06_JPRB, &
  & 0.31772180E-06_JPRB, 0.31772123E-06_JPRB, 0.31772052E-06_JPRB, 0.31771953E-06_JPRB, 0.31771819E-06_JPRB, 0.31771637E-06_JPRB, &
  & 0.31771430E-06_JPRB, 0.31771216E-06_JPRB, 0.31770992E-06_JPRB, 0.31770617E-06_JPRB /)

RGHG3(:,57, 9) = (/ &
  & 0.31735826E-06_JPRB, 0.31738784E-06_JPRB, 0.31741018E-06_JPRB, 0.31743252E-06_JPRB, 0.31746106E-06_JPRB, 0.31748777E-06_JPRB, &
  & 0.31750642E-06_JPRB, 0.31751642E-06_JPRB, 0.31752256E-06_JPRB, 0.31752688E-06_JPRB, 0.31753035E-06_JPRB, 0.31753365E-06_JPRB, &
  & 0.31753669E-06_JPRB, 0.31753919E-06_JPRB, 0.31753999E-06_JPRB, 0.31753825E-06_JPRB, 0.31753385E-06_JPRB, 0.31752734E-06_JPRB, &
  & 0.31752018E-06_JPRB, 0.31751512E-06_JPRB, 0.31751651E-06_JPRB, 0.31753058E-06_JPRB, 0.31756076E-06_JPRB, 0.31760499E-06_JPRB, &
  & 0.31765336E-06_JPRB, 0.31769954E-06_JPRB, 0.31774130E-06_JPRB, 0.31777893E-06_JPRB, 0.31781352E-06_JPRB, 0.31784538E-06_JPRB, &
  & 0.31787397E-06_JPRB, 0.31789790E-06_JPRB, 0.31791561E-06_JPRB, 0.31792652E-06_JPRB, 0.31793081E-06_JPRB, 0.31792877E-06_JPRB, &
  & 0.31792109E-06_JPRB, 0.31790861E-06_JPRB, 0.31789196E-06_JPRB, 0.31787246E-06_JPRB, 0.31785166E-06_JPRB, 0.31783102E-06_JPRB, &
  & 0.31781286E-06_JPRB, 0.31779769E-06_JPRB, 0.31778526E-06_JPRB, 0.31777452E-06_JPRB, 0.31776514E-06_JPRB, 0.31775727E-06_JPRB, &
  & 0.31775122E-06_JPRB, 0.31774678E-06_JPRB, 0.31774391E-06_JPRB, 0.31774206E-06_JPRB, 0.31774107E-06_JPRB, 0.31774036E-06_JPRB, &
  & 0.31773982E-06_JPRB, 0.31773925E-06_JPRB, 0.31773851E-06_JPRB, 0.31773760E-06_JPRB, 0.31773629E-06_JPRB, 0.31773476E-06_JPRB, &
  & 0.31773305E-06_JPRB, 0.31773135E-06_JPRB, 0.31772936E-06_JPRB, 0.31772606E-06_JPRB /)

RGHG3(:,58, 9) = (/ &
  & 0.31743602E-06_JPRB, 0.31745975E-06_JPRB, 0.31747504E-06_JPRB, 0.31749207E-06_JPRB, 0.31751108E-06_JPRB, 0.31753009E-06_JPRB, &
  & 0.31754303E-06_JPRB, 0.31755076E-06_JPRB, 0.31755542E-06_JPRB, 0.31755883E-06_JPRB, 0.31756178E-06_JPRB, 0.31756457E-06_JPRB, &
  & 0.31756738E-06_JPRB, 0.31756980E-06_JPRB, 0.31757099E-06_JPRB, 0.31756989E-06_JPRB, 0.31756588E-06_JPRB, 0.31755923E-06_JPRB, &
  & 0.31755121E-06_JPRB, 0.31754459E-06_JPRB, 0.31754399E-06_JPRB, 0.31755536E-06_JPRB, 0.31758231E-06_JPRB, 0.31762190E-06_JPRB, &
  & 0.31766658E-06_JPRB, 0.31770978E-06_JPRB, 0.31774960E-06_JPRB, 0.31778603E-06_JPRB, 0.31781980E-06_JPRB, 0.31785103E-06_JPRB, &
  & 0.31787908E-06_JPRB, 0.31790256E-06_JPRB, 0.31792024E-06_JPRB, 0.31793127E-06_JPRB, 0.31793593E-06_JPRB, 0.31793442E-06_JPRB, &
  & 0.31792737E-06_JPRB, 0.31791561E-06_JPRB, 0.31789978E-06_JPRB, 0.31788122E-06_JPRB, 0.31786126E-06_JPRB, 0.31784168E-06_JPRB, &
  & 0.31782443E-06_JPRB, 0.31781005E-06_JPRB, 0.31779825E-06_JPRB, 0.31778828E-06_JPRB, 0.31777952E-06_JPRB, 0.31777230E-06_JPRB, &
  & 0.31776676E-06_JPRB, 0.31776261E-06_JPRB, 0.31775983E-06_JPRB, 0.31775798E-06_JPRB, 0.31775673E-06_JPRB, 0.31775593E-06_JPRB, &
  & 0.31775528E-06_JPRB, 0.31775457E-06_JPRB, 0.31775380E-06_JPRB, 0.31775278E-06_JPRB, 0.31775156E-06_JPRB, 0.31775005E-06_JPRB, &
  & 0.31774857E-06_JPRB, 0.31774701E-06_JPRB, 0.31774545E-06_JPRB, 0.31774280E-06_JPRB /)

RGHG3(:,59, 9) = (/ &
  & 0.31749548E-06_JPRB, 0.31751424E-06_JPRB, 0.31752674E-06_JPRB, 0.31753876E-06_JPRB, 0.31755224E-06_JPRB, 0.31756542E-06_JPRB, &
  & 0.31757511E-06_JPRB, 0.31758100E-06_JPRB, 0.31758486E-06_JPRB, 0.31758776E-06_JPRB, 0.31759032E-06_JPRB, 0.31759294E-06_JPRB, &
  & 0.31759561E-06_JPRB, 0.31759825E-06_JPRB, 0.31759990E-06_JPRB, 0.31759944E-06_JPRB, 0.31759589E-06_JPRB, 0.31758907E-06_JPRB, &
  & 0.31758026E-06_JPRB, 0.31757241E-06_JPRB, 0.31757028E-06_JPRB, 0.31757961E-06_JPRB, 0.31760322E-06_JPRB, 0.31763904E-06_JPRB, &
  & 0.31767999E-06_JPRB, 0.31772046E-06_JPRB, 0.31775855E-06_JPRB, 0.31779371E-06_JPRB, 0.31782653E-06_JPRB, 0.31785709E-06_JPRB, &
  & 0.31788451E-06_JPRB, 0.31790756E-06_JPRB, 0.31792496E-06_JPRB, 0.31793604E-06_JPRB, 0.31794102E-06_JPRB, 0.31793988E-06_JPRB, &
  & 0.31793351E-06_JPRB, 0.31792251E-06_JPRB, 0.31790756E-06_JPRB, 0.31788980E-06_JPRB, 0.31787087E-06_JPRB, 0.31785225E-06_JPRB, &
  & 0.31783583E-06_JPRB, 0.31782221E-06_JPRB, 0.31781104E-06_JPRB, 0.31780172E-06_JPRB, 0.31779362E-06_JPRB, 0.31778691E-06_JPRB, &
  & 0.31778171E-06_JPRB, 0.31777762E-06_JPRB, 0.31777472E-06_JPRB, 0.31777265E-06_JPRB, 0.31777120E-06_JPRB, 0.31777009E-06_JPRB, &
  & 0.31776921E-06_JPRB, 0.31776835E-06_JPRB, 0.31776730E-06_JPRB, 0.31776617E-06_JPRB, 0.31776477E-06_JPRB, 0.31776324E-06_JPRB, &
  & 0.31776167E-06_JPRB, 0.31776025E-06_JPRB, 0.31775869E-06_JPRB, 0.31775616E-06_JPRB /)

RGHG3(:,60, 9) = (/ &
  & 0.31754450E-06_JPRB, 0.31755934E-06_JPRB, 0.31756835E-06_JPRB, 0.31757719E-06_JPRB, 0.31758671E-06_JPRB, 0.31759623E-06_JPRB, &
  & 0.31760374E-06_JPRB, 0.31760862E-06_JPRB, 0.31761192E-06_JPRB, 0.31761448E-06_JPRB, 0.31761689E-06_JPRB, 0.31761942E-06_JPRB, &
  & 0.31762232E-06_JPRB, 0.31762519E-06_JPRB, 0.31762750E-06_JPRB, 0.31762769E-06_JPRB, 0.31762448E-06_JPRB, 0.31761755E-06_JPRB, &
  & 0.31760797E-06_JPRB, 0.31759919E-06_JPRB, 0.31759578E-06_JPRB, 0.31760322E-06_JPRB, 0.31762406E-06_JPRB, 0.31765623E-06_JPRB, &
  & 0.31769386E-06_JPRB, 0.31773180E-06_JPRB, 0.31776798E-06_JPRB, 0.31780189E-06_JPRB, 0.31783378E-06_JPRB, 0.31786351E-06_JPRB, &
  & 0.31789020E-06_JPRB, 0.31791274E-06_JPRB, 0.31792985E-06_JPRB, 0.31794090E-06_JPRB, 0.31794605E-06_JPRB, 0.31794531E-06_JPRB, &
  & 0.31793959E-06_JPRB, 0.31792933E-06_JPRB, 0.31791518E-06_JPRB, 0.31789844E-06_JPRB, 0.31788034E-06_JPRB, 0.31786274E-06_JPRB, &
  & 0.31784720E-06_JPRB, 0.31783426E-06_JPRB, 0.31782375E-06_JPRB, 0.31781497E-06_JPRB, 0.31780746E-06_JPRB, 0.31780112E-06_JPRB, &
  & 0.31779624E-06_JPRB, 0.31779214E-06_JPRB, 0.31778919E-06_JPRB, 0.31778688E-06_JPRB, 0.31778507E-06_JPRB, 0.31778362E-06_JPRB, &
  & 0.31778242E-06_JPRB, 0.31778126E-06_JPRB, 0.31778006E-06_JPRB, 0.31777853E-06_JPRB, 0.31777682E-06_JPRB, 0.31777500E-06_JPRB, &
  & 0.31777338E-06_JPRB, 0.31777191E-06_JPRB, 0.31777046E-06_JPRB, 0.31776804E-06_JPRB /)

RGHG3(:,61, 9) = (/ &
  & 0.31758395E-06_JPRB, 0.31759569E-06_JPRB, 0.31760285E-06_JPRB, 0.31760948E-06_JPRB, 0.31761655E-06_JPRB, 0.31762383E-06_JPRB, &
  & 0.31762988E-06_JPRB, 0.31763409E-06_JPRB, 0.31763713E-06_JPRB, 0.31763960E-06_JPRB, 0.31764205E-06_JPRB, 0.31764483E-06_JPRB, &
  & 0.31764793E-06_JPRB, 0.31765140E-06_JPRB, 0.31765427E-06_JPRB, 0.31765504E-06_JPRB, 0.31765205E-06_JPRB, 0.31764483E-06_JPRB, &
  & 0.31763480E-06_JPRB, 0.31762528E-06_JPRB, 0.31762096E-06_JPRB, 0.31762679E-06_JPRB, 0.31764475E-06_JPRB, 0.31767368E-06_JPRB, &
  & 0.31770819E-06_JPRB, 0.31774374E-06_JPRB, 0.31777824E-06_JPRB, 0.31781087E-06_JPRB, 0.31784177E-06_JPRB, 0.31787056E-06_JPRB, &
  & 0.31789642E-06_JPRB, 0.31791836E-06_JPRB, 0.31793496E-06_JPRB, 0.31794588E-06_JPRB, 0.31795105E-06_JPRB, 0.31795057E-06_JPRB, &
  & 0.31794545E-06_JPRB, 0.31793587E-06_JPRB, 0.31792268E-06_JPRB, 0.31790697E-06_JPRB, 0.31788994E-06_JPRB, 0.31787332E-06_JPRB, &
  & 0.31785859E-06_JPRB, 0.31784631E-06_JPRB, 0.31783631E-06_JPRB, 0.31782801E-06_JPRB, 0.31782102E-06_JPRB, 0.31781511E-06_JPRB, &
  & 0.31781036E-06_JPRB, 0.31780652E-06_JPRB, 0.31780348E-06_JPRB, 0.31780093E-06_JPRB, 0.31779877E-06_JPRB, 0.31779689E-06_JPRB, &
  & 0.31779518E-06_JPRB, 0.31779365E-06_JPRB, 0.31779194E-06_JPRB, 0.31779007E-06_JPRB, 0.31778794E-06_JPRB, 0.31778589E-06_JPRB, &
  & 0.31778404E-06_JPRB, 0.31778245E-06_JPRB, 0.31778080E-06_JPRB, 0.31777827E-06_JPRB /)

RGHG3(:,62, 9) = (/ &
  & 0.31761749E-06_JPRB, 0.31762693E-06_JPRB, 0.31763241E-06_JPRB, 0.31763756E-06_JPRB, 0.31764307E-06_JPRB, 0.31764887E-06_JPRB, &
  & 0.31765404E-06_JPRB, 0.31765805E-06_JPRB, 0.31766106E-06_JPRB, 0.31766371E-06_JPRB, 0.31766632E-06_JPRB, 0.31766933E-06_JPRB, &
  & 0.31767297E-06_JPRB, 0.31767701E-06_JPRB, 0.31768062E-06_JPRB, 0.31768178E-06_JPRB, 0.31767868E-06_JPRB, 0.31767138E-06_JPRB, &
  & 0.31766095E-06_JPRB, 0.31765109E-06_JPRB, 0.31764586E-06_JPRB, 0.31765006E-06_JPRB, 0.31766567E-06_JPRB, 0.31769144E-06_JPRB, &
  & 0.31772311E-06_JPRB, 0.31775645E-06_JPRB, 0.31778924E-06_JPRB, 0.31782056E-06_JPRB, 0.31785041E-06_JPRB, 0.31787820E-06_JPRB, &
  & 0.31790319E-06_JPRB, 0.31792433E-06_JPRB, 0.31794042E-06_JPRB, 0.31795096E-06_JPRB, 0.31795605E-06_JPRB, 0.31795582E-06_JPRB, &
  & 0.31795119E-06_JPRB, 0.31794232E-06_JPRB, 0.31793016E-06_JPRB, 0.31791538E-06_JPRB, 0.31789941E-06_JPRB, 0.31788380E-06_JPRB, &
  & 0.31786996E-06_JPRB, 0.31785837E-06_JPRB, 0.31784887E-06_JPRB, 0.31784103E-06_JPRB, 0.31783446E-06_JPRB, 0.31782889E-06_JPRB, &
  & 0.31782434E-06_JPRB, 0.31782056E-06_JPRB, 0.31781755E-06_JPRB, 0.31781488E-06_JPRB, 0.31781244E-06_JPRB, 0.31781016E-06_JPRB, &
  & 0.31780812E-06_JPRB, 0.31780598E-06_JPRB, 0.31780377E-06_JPRB, 0.31780115E-06_JPRB, 0.31779851E-06_JPRB, 0.31779607E-06_JPRB, &
  & 0.31779405E-06_JPRB, 0.31779223E-06_JPRB, 0.31779047E-06_JPRB, 0.31778751E-06_JPRB /)

RGHG3(:,63, 9) = (/ &
  & 0.31764569E-06_JPRB, 0.31765381E-06_JPRB, 0.31765853E-06_JPRB, 0.31766280E-06_JPRB, 0.31766734E-06_JPRB, 0.31767229E-06_JPRB, &
  & 0.31767701E-06_JPRB, 0.31768087E-06_JPRB, 0.31768406E-06_JPRB, 0.31768693E-06_JPRB, 0.31769002E-06_JPRB, 0.31769352E-06_JPRB, &
  & 0.31769790E-06_JPRB, 0.31770273E-06_JPRB, 0.31770674E-06_JPRB, 0.31770816E-06_JPRB, 0.31770486E-06_JPRB, 0.31769730E-06_JPRB, &
  & 0.31768676E-06_JPRB, 0.31767649E-06_JPRB, 0.31767067E-06_JPRB, 0.31767345E-06_JPRB, 0.31768681E-06_JPRB, 0.31770995E-06_JPRB, &
  & 0.31773885E-06_JPRB, 0.31777006E-06_JPRB, 0.31780112E-06_JPRB, 0.31783102E-06_JPRB, 0.31785976E-06_JPRB, 0.31788653E-06_JPRB, &
  & 0.31791058E-06_JPRB, 0.31793070E-06_JPRB, 0.31794602E-06_JPRB, 0.31795616E-06_JPRB, 0.31796105E-06_JPRB, 0.31796100E-06_JPRB, &
  & 0.31795679E-06_JPRB, 0.31794872E-06_JPRB, 0.31793735E-06_JPRB, 0.31792371E-06_JPRB, 0.31790884E-06_JPRB, 0.31789429E-06_JPRB, &
  & 0.31788130E-06_JPRB, 0.31787039E-06_JPRB, 0.31786141E-06_JPRB, 0.31785396E-06_JPRB, 0.31784771E-06_JPRB, 0.31784242E-06_JPRB, &
  & 0.31783802E-06_JPRB, 0.31783441E-06_JPRB, 0.31783142E-06_JPRB, 0.31782884E-06_JPRB, 0.31782628E-06_JPRB, 0.31782366E-06_JPRB, &
  & 0.31782099E-06_JPRB, 0.31781840E-06_JPRB, 0.31781542E-06_JPRB, 0.31781218E-06_JPRB, 0.31780877E-06_JPRB, 0.31780581E-06_JPRB, &
  & 0.31780334E-06_JPRB, 0.31780129E-06_JPRB, 0.31779911E-06_JPRB, 0.31779572E-06_JPRB /)

RGHG3(:,64, 9) = (/ &
  & 0.31767047E-06_JPRB, 0.31767780E-06_JPRB, 0.31768192E-06_JPRB, 0.31768565E-06_JPRB, 0.31768968E-06_JPRB, 0.31769412E-06_JPRB, &
  & 0.31769861E-06_JPRB, 0.31770259E-06_JPRB, 0.31770605E-06_JPRB, 0.31770946E-06_JPRB, 0.31771305E-06_JPRB, 0.31771748E-06_JPRB, &
  & 0.31772265E-06_JPRB, 0.31772800E-06_JPRB, 0.31773234E-06_JPRB, 0.31773368E-06_JPRB, 0.31773016E-06_JPRB, 0.31772257E-06_JPRB, &
  & 0.31771199E-06_JPRB, 0.31770159E-06_JPRB, 0.31769528E-06_JPRB, 0.31769696E-06_JPRB, 0.31770841E-06_JPRB, 0.31772893E-06_JPRB, &
  & 0.31775539E-06_JPRB, 0.31778444E-06_JPRB, 0.31781380E-06_JPRB, 0.31784234E-06_JPRB, 0.31786976E-06_JPRB, 0.31789540E-06_JPRB, &
  & 0.31791825E-06_JPRB, 0.31793738E-06_JPRB, 0.31795176E-06_JPRB, 0.31796128E-06_JPRB, 0.31796580E-06_JPRB, 0.31796586E-06_JPRB, &
  & 0.31796208E-06_JPRB, 0.31795477E-06_JPRB, 0.31794448E-06_JPRB, 0.31793184E-06_JPRB, 0.31791814E-06_JPRB, 0.31790466E-06_JPRB, &
  & 0.31789250E-06_JPRB, 0.31788224E-06_JPRB, 0.31787380E-06_JPRB, 0.31786666E-06_JPRB, 0.31786072E-06_JPRB, 0.31785572E-06_JPRB, &
  & 0.31785149E-06_JPRB, 0.31784811E-06_JPRB, 0.31784518E-06_JPRB, 0.31784262E-06_JPRB, 0.31783995E-06_JPRB, 0.31783713E-06_JPRB, &
  & 0.31783424E-06_JPRB, 0.31783094E-06_JPRB, 0.31782739E-06_JPRB, 0.31782329E-06_JPRB, 0.31781929E-06_JPRB, 0.31781568E-06_JPRB, &
  & 0.31781275E-06_JPRB, 0.31781008E-06_JPRB, 0.31780735E-06_JPRB, 0.31780277E-06_JPRB /)

RGHG3(:,65, 9) = (/ &
  & 0.31769275E-06_JPRB, 0.31769986E-06_JPRB, 0.31770381E-06_JPRB, 0.31770730E-06_JPRB, 0.31771100E-06_JPRB, 0.31771515E-06_JPRB, &
  & 0.31771947E-06_JPRB, 0.31772376E-06_JPRB, 0.31772765E-06_JPRB, 0.31773163E-06_JPRB, 0.31773601E-06_JPRB, 0.31774107E-06_JPRB, &
  & 0.31774701E-06_JPRB, 0.31775261E-06_JPRB, 0.31775693E-06_JPRB, 0.31775812E-06_JPRB, 0.31775468E-06_JPRB, 0.31774718E-06_JPRB, &
  & 0.31773675E-06_JPRB, 0.31772637E-06_JPRB, 0.31771981E-06_JPRB, 0.31772046E-06_JPRB, 0.31773018E-06_JPRB, 0.31774852E-06_JPRB, &
  & 0.31777267E-06_JPRB, 0.31779956E-06_JPRB, 0.31782713E-06_JPRB, 0.31785419E-06_JPRB, 0.31788028E-06_JPRB, 0.31790449E-06_JPRB, &
  & 0.31792612E-06_JPRB, 0.31794397E-06_JPRB, 0.31795730E-06_JPRB, 0.31796606E-06_JPRB, 0.31797023E-06_JPRB, 0.31797043E-06_JPRB, &
  & 0.31796702E-06_JPRB, 0.31796043E-06_JPRB, 0.31795111E-06_JPRB, 0.31793974E-06_JPRB, 0.31792717E-06_JPRB, 0.31791470E-06_JPRB, &
  & 0.31790347E-06_JPRB, 0.31789392E-06_JPRB, 0.31788582E-06_JPRB, 0.31787914E-06_JPRB, 0.31787346E-06_JPRB, 0.31786863E-06_JPRB, &
  & 0.31786468E-06_JPRB, 0.31786141E-06_JPRB, 0.31785859E-06_JPRB, 0.31785598E-06_JPRB, 0.31785342E-06_JPRB, 0.31785052E-06_JPRB, &
  & 0.31784737E-06_JPRB, 0.31784373E-06_JPRB, 0.31783946E-06_JPRB, 0.31783489E-06_JPRB, 0.31783014E-06_JPRB, 0.31782594E-06_JPRB, &
  & 0.31782221E-06_JPRB, 0.31781892E-06_JPRB, 0.31781519E-06_JPRB, 0.31780920E-06_JPRB /)

RGHG3(:,66, 9) = (/ &
  & 0.31771253E-06_JPRB, 0.31772015E-06_JPRB, 0.31772430E-06_JPRB, 0.31772788E-06_JPRB, 0.31773158E-06_JPRB, 0.31773558E-06_JPRB, &
  & 0.31774005E-06_JPRB, 0.31774439E-06_JPRB, 0.31774897E-06_JPRB, 0.31775346E-06_JPRB, 0.31775869E-06_JPRB, 0.31776455E-06_JPRB, &
  & 0.31777063E-06_JPRB, 0.31777606E-06_JPRB, 0.31778043E-06_JPRB, 0.31778160E-06_JPRB, 0.31777827E-06_JPRB, 0.31777100E-06_JPRB, &
  & 0.31776096E-06_JPRB, 0.31775076E-06_JPRB, 0.31774400E-06_JPRB, 0.31774402E-06_JPRB, 0.31775230E-06_JPRB, 0.31776861E-06_JPRB, &
  & 0.31779052E-06_JPRB, 0.31781533E-06_JPRB, 0.31784100E-06_JPRB, 0.31786635E-06_JPRB, 0.31789088E-06_JPRB, 0.31791365E-06_JPRB, &
  & 0.31793374E-06_JPRB, 0.31795025E-06_JPRB, 0.31796247E-06_JPRB, 0.31797046E-06_JPRB, 0.31797430E-06_JPRB, 0.31797452E-06_JPRB, &
  & 0.31797146E-06_JPRB, 0.31796569E-06_JPRB, 0.31795739E-06_JPRB, 0.31794710E-06_JPRB, 0.31793573E-06_JPRB, 0.31792436E-06_JPRB, &
  & 0.31791399E-06_JPRB, 0.31790506E-06_JPRB, 0.31789756E-06_JPRB, 0.31789116E-06_JPRB, 0.31788576E-06_JPRB, 0.31788124E-06_JPRB, &
  & 0.31787746E-06_JPRB, 0.31787442E-06_JPRB, 0.31787178E-06_JPRB, 0.31786919E-06_JPRB, 0.31786664E-06_JPRB, 0.31786374E-06_JPRB, &
  & 0.31786041E-06_JPRB, 0.31785646E-06_JPRB, 0.31785183E-06_JPRB, 0.31784685E-06_JPRB, 0.31784163E-06_JPRB, 0.31783674E-06_JPRB, &
  & 0.31783242E-06_JPRB, 0.31782810E-06_JPRB, 0.31782324E-06_JPRB, 0.31781485E-06_JPRB /)

RGHG3(:,67, 9) = (/ &
  & 0.31773061E-06_JPRB, 0.31773925E-06_JPRB, 0.31774391E-06_JPRB, 0.31774783E-06_JPRB, 0.31775176E-06_JPRB, 0.31775588E-06_JPRB, &
  & 0.31776028E-06_JPRB, 0.31776520E-06_JPRB, 0.31776995E-06_JPRB, 0.31777540E-06_JPRB, 0.31778114E-06_JPRB, 0.31778725E-06_JPRB, &
  & 0.31779328E-06_JPRB, 0.31779840E-06_JPRB, 0.31780274E-06_JPRB, 0.31780399E-06_JPRB, 0.31780093E-06_JPRB, 0.31779405E-06_JPRB, &
  & 0.31778450E-06_JPRB, 0.31777478E-06_JPRB, 0.31776804E-06_JPRB, 0.31776759E-06_JPRB, 0.31777464E-06_JPRB, 0.31778916E-06_JPRB, &
  & 0.31780883E-06_JPRB, 0.31783136E-06_JPRB, 0.31785513E-06_JPRB, 0.31787860E-06_JPRB, 0.31790137E-06_JPRB, 0.31792257E-06_JPRB, &
  & 0.31794104E-06_JPRB, 0.31795616E-06_JPRB, 0.31796719E-06_JPRB, 0.31797441E-06_JPRB, 0.31797791E-06_JPRB, 0.31797819E-06_JPRB, &
  & 0.31797555E-06_JPRB, 0.31797040E-06_JPRB, 0.31796307E-06_JPRB, 0.31795398E-06_JPRB, 0.31794374E-06_JPRB, 0.31793343E-06_JPRB, &
  & 0.31792408E-06_JPRB, 0.31791578E-06_JPRB, 0.31790881E-06_JPRB, 0.31790282E-06_JPRB, 0.31789779E-06_JPRB, 0.31789349E-06_JPRB, &
  & 0.31788994E-06_JPRB, 0.31788710E-06_JPRB, 0.31788463E-06_JPRB, 0.31788213E-06_JPRB, 0.31787965E-06_JPRB, 0.31787661E-06_JPRB, &
  & 0.31787326E-06_JPRB, 0.31786917E-06_JPRB, 0.31786428E-06_JPRB, 0.31785910E-06_JPRB, 0.31785345E-06_JPRB, 0.31784819E-06_JPRB, &
  & 0.31784307E-06_JPRB, 0.31783793E-06_JPRB, 0.31783151E-06_JPRB, 0.31782045E-06_JPRB /)

RGHG3(:,68, 9) = (/ &
  & 0.31774718E-06_JPRB, 0.31775767E-06_JPRB, 0.31776315E-06_JPRB, 0.31776761E-06_JPRB, 0.31777188E-06_JPRB, 0.31777620E-06_JPRB, &
  & 0.31778094E-06_JPRB, 0.31778586E-06_JPRB, 0.31779138E-06_JPRB, 0.31779689E-06_JPRB, 0.31780314E-06_JPRB, 0.31780917E-06_JPRB, &
  & 0.31781468E-06_JPRB, 0.31781951E-06_JPRB, 0.31782400E-06_JPRB, 0.31782542E-06_JPRB, 0.31782264E-06_JPRB, 0.31781619E-06_JPRB, &
  & 0.31780741E-06_JPRB, 0.31779820E-06_JPRB, 0.31779172E-06_JPRB, 0.31779095E-06_JPRB, 0.31779683E-06_JPRB, 0.31780959E-06_JPRB, &
  & 0.31782707E-06_JPRB, 0.31784757E-06_JPRB, 0.31786914E-06_JPRB, 0.31789077E-06_JPRB, 0.31791163E-06_JPRB, 0.31793107E-06_JPRB, &
  & 0.31794798E-06_JPRB, 0.31796156E-06_JPRB, 0.31797157E-06_JPRB, 0.31797794E-06_JPRB, 0.31798112E-06_JPRB, 0.31798146E-06_JPRB, &
  & 0.31797910E-06_JPRB, 0.31797467E-06_JPRB, 0.31796824E-06_JPRB, 0.31796017E-06_JPRB, 0.31795116E-06_JPRB, 0.31794195E-06_JPRB, &
  & 0.31793351E-06_JPRB, 0.31792604E-06_JPRB, 0.31791959E-06_JPRB, 0.31791399E-06_JPRB, 0.31790933E-06_JPRB, 0.31790526E-06_JPRB, &
  & 0.31790194E-06_JPRB, 0.31789935E-06_JPRB, 0.31789705E-06_JPRB, 0.31789475E-06_JPRB, 0.31789233E-06_JPRB, 0.31788937E-06_JPRB, &
  & 0.31788599E-06_JPRB, 0.31788178E-06_JPRB, 0.31787687E-06_JPRB, 0.31787155E-06_JPRB, 0.31786576E-06_JPRB, 0.31786018E-06_JPRB, &
  & 0.31785464E-06_JPRB, 0.31784867E-06_JPRB, 0.31784080E-06_JPRB, 0.31782702E-06_JPRB /)

RGHG3(:,69, 9) = (/ &
  & 0.31776256E-06_JPRB, 0.31777572E-06_JPRB, 0.31778234E-06_JPRB, 0.31778757E-06_JPRB, 0.31779226E-06_JPRB, 0.31779695E-06_JPRB, &
  & 0.31780175E-06_JPRB, 0.31780701E-06_JPRB, 0.31781244E-06_JPRB, 0.31781846E-06_JPRB, 0.31782457E-06_JPRB, 0.31783026E-06_JPRB, &
  & 0.31783514E-06_JPRB, 0.31783944E-06_JPRB, 0.31784404E-06_JPRB, 0.31784580E-06_JPRB, 0.31784344E-06_JPRB, 0.31783762E-06_JPRB, &
  & 0.31782949E-06_JPRB, 0.31782108E-06_JPRB, 0.31781502E-06_JPRB, 0.31781389E-06_JPRB, 0.31781866E-06_JPRB, 0.31782980E-06_JPRB, &
  & 0.31784532E-06_JPRB, 0.31786357E-06_JPRB, 0.31788304E-06_JPRB, 0.31790262E-06_JPRB, 0.31792160E-06_JPRB, 0.31793923E-06_JPRB, &
  & 0.31795452E-06_JPRB, 0.31796668E-06_JPRB, 0.31797555E-06_JPRB, 0.31798112E-06_JPRB, 0.31798407E-06_JPRB, 0.31798425E-06_JPRB, &
  & 0.31798228E-06_JPRB, 0.31797848E-06_JPRB, 0.31797288E-06_JPRB, 0.31796588E-06_JPRB, 0.31795793E-06_JPRB, 0.31794977E-06_JPRB, &
  & 0.31794229E-06_JPRB, 0.31793562E-06_JPRB, 0.31792979E-06_JPRB, 0.31792473E-06_JPRB, 0.31792032E-06_JPRB, 0.31791660E-06_JPRB, &
  & 0.31791367E-06_JPRB, 0.31791132E-06_JPRB, 0.31790921E-06_JPRB, 0.31790702E-06_JPRB, 0.31790486E-06_JPRB, 0.31790208E-06_JPRB, &
  & 0.31789864E-06_JPRB, 0.31789446E-06_JPRB, 0.31788954E-06_JPRB, 0.31788429E-06_JPRB, 0.31787840E-06_JPRB, 0.31787269E-06_JPRB, &
  & 0.31786692E-06_JPRB, 0.31786050E-06_JPRB, 0.31785146E-06_JPRB, 0.31783492E-06_JPRB /)

RGHG3(:,70, 9) = (/ &
  & 0.31777725E-06_JPRB, 0.31779354E-06_JPRB, 0.31780178E-06_JPRB, 0.31780789E-06_JPRB, 0.31781326E-06_JPRB, 0.31781804E-06_JPRB, &
  & 0.31782295E-06_JPRB, 0.31782827E-06_JPRB, 0.31783370E-06_JPRB, 0.31783955E-06_JPRB, 0.31784541E-06_JPRB, 0.31785052E-06_JPRB, &
  & 0.31785487E-06_JPRB, 0.31785896E-06_JPRB, 0.31786377E-06_JPRB, 0.31786541E-06_JPRB, 0.31786334E-06_JPRB, 0.31785808E-06_JPRB, &
  & 0.31785078E-06_JPRB, 0.31784319E-06_JPRB, 0.31783756E-06_JPRB, 0.31783628E-06_JPRB, 0.31784003E-06_JPRB, 0.31784961E-06_JPRB, &
  & 0.31786317E-06_JPRB, 0.31787926E-06_JPRB, 0.31789659E-06_JPRB, 0.31791413E-06_JPRB, 0.31793107E-06_JPRB, 0.31794690E-06_JPRB, &
  & 0.31796057E-06_JPRB, 0.31797137E-06_JPRB, 0.31797916E-06_JPRB, 0.31798393E-06_JPRB, 0.31798658E-06_JPRB, 0.31798677E-06_JPRB, &
  & 0.31798510E-06_JPRB, 0.31798183E-06_JPRB, 0.31797708E-06_JPRB, 0.31797103E-06_JPRB, 0.31796407E-06_JPRB, 0.31795696E-06_JPRB, &
  & 0.31795042E-06_JPRB, 0.31794457E-06_JPRB, 0.31793945E-06_JPRB, 0.31793491E-06_JPRB, 0.31793087E-06_JPRB, 0.31792760E-06_JPRB, &
  & 0.31792490E-06_JPRB, 0.31792288E-06_JPRB, 0.31792101E-06_JPRB, 0.31791905E-06_JPRB, 0.31791703E-06_JPRB, 0.31791441E-06_JPRB, &
  & 0.31791117E-06_JPRB, 0.31790719E-06_JPRB, 0.31790245E-06_JPRB, 0.31789736E-06_JPRB, 0.31789151E-06_JPRB, 0.31788579E-06_JPRB, &
  & 0.31787999E-06_JPRB, 0.31787346E-06_JPRB, 0.31786365E-06_JPRB, 0.31784523E-06_JPRB /)

RGHG3(:,71, 9) = (/ &
  & 0.31779226E-06_JPRB, 0.31781246E-06_JPRB, 0.31782190E-06_JPRB, 0.31782901E-06_JPRB, 0.31783475E-06_JPRB, 0.31783972E-06_JPRB, &
  & 0.31784461E-06_JPRB, 0.31784973E-06_JPRB, 0.31785501E-06_JPRB, 0.31786018E-06_JPRB, 0.31786573E-06_JPRB, 0.31787002E-06_JPRB, &
  & 0.31787295E-06_JPRB, 0.31787590E-06_JPRB, 0.31788142E-06_JPRB, 0.31788389E-06_JPRB, 0.31788238E-06_JPRB, 0.31787764E-06_JPRB, &
  & 0.31787118E-06_JPRB, 0.31786442E-06_JPRB, 0.31785933E-06_JPRB, 0.31785777E-06_JPRB, 0.31786072E-06_JPRB, 0.31786888E-06_JPRB, &
  & 0.31788062E-06_JPRB, 0.31789455E-06_JPRB, 0.31790984E-06_JPRB, 0.31792530E-06_JPRB, 0.31794033E-06_JPRB, 0.31795432E-06_JPRB, &
  & 0.31796631E-06_JPRB, 0.31797563E-06_JPRB, 0.31798248E-06_JPRB, 0.31798652E-06_JPRB, 0.31798885E-06_JPRB, 0.31798899E-06_JPRB, &
  & 0.31798754E-06_JPRB, 0.31798487E-06_JPRB, 0.31798089E-06_JPRB, 0.31797569E-06_JPRB, 0.31796969E-06_JPRB, 0.31796350E-06_JPRB, &
  & 0.31795787E-06_JPRB, 0.31795287E-06_JPRB, 0.31794852E-06_JPRB, 0.31794454E-06_JPRB, 0.31794099E-06_JPRB, 0.31793806E-06_JPRB, &
  & 0.31793567E-06_JPRB, 0.31793400E-06_JPRB, 0.31793232E-06_JPRB, 0.31793058E-06_JPRB, 0.31792882E-06_JPRB, 0.31792649E-06_JPRB, &
  & 0.31792348E-06_JPRB, 0.31791978E-06_JPRB, 0.31791544E-06_JPRB, 0.31791060E-06_JPRB, 0.31790495E-06_JPRB, 0.31789946E-06_JPRB, &
  & 0.31789392E-06_JPRB, 0.31788750E-06_JPRB, 0.31787761E-06_JPRB, 0.31785814E-06_JPRB /)

RGHG3(:,72, 9) = (/ &
  & 0.31780922E-06_JPRB, 0.31783244E-06_JPRB, 0.31784313E-06_JPRB, 0.31785069E-06_JPRB, 0.31785686E-06_JPRB, 0.31786169E-06_JPRB, &
  & 0.31786638E-06_JPRB, 0.31787147E-06_JPRB, 0.31787579E-06_JPRB, 0.31788085E-06_JPRB, 0.31788517E-06_JPRB, 0.31788920E-06_JPRB, &
  & 0.31789230E-06_JPRB, 0.31789494E-06_JPRB, 0.31789997E-06_JPRB, 0.31790174E-06_JPRB, 0.31790034E-06_JPRB, 0.31789602E-06_JPRB, &
  & 0.31789062E-06_JPRB, 0.31788474E-06_JPRB, 0.31788002E-06_JPRB, 0.31787846E-06_JPRB, 0.31788059E-06_JPRB, 0.31788747E-06_JPRB, &
  & 0.31789742E-06_JPRB, 0.31790933E-06_JPRB, 0.31792263E-06_JPRB, 0.31793610E-06_JPRB, 0.31794906E-06_JPRB, 0.31796128E-06_JPRB, &
  & 0.31797168E-06_JPRB, 0.31797970E-06_JPRB, 0.31798564E-06_JPRB, 0.31798882E-06_JPRB, 0.31799090E-06_JPRB, 0.31799104E-06_JPRB, &
  & 0.31798982E-06_JPRB, 0.31798754E-06_JPRB, 0.31798436E-06_JPRB, 0.31797990E-06_JPRB, 0.31797481E-06_JPRB, 0.31796958E-06_JPRB, &
  & 0.31796478E-06_JPRB, 0.31796054E-06_JPRB, 0.31795693E-06_JPRB, 0.31795352E-06_JPRB, 0.31795037E-06_JPRB, 0.31794787E-06_JPRB, &
  & 0.31794588E-06_JPRB, 0.31794451E-06_JPRB, 0.31794318E-06_JPRB, 0.31794164E-06_JPRB, 0.31794025E-06_JPRB, 0.31793809E-06_JPRB, &
  & 0.31793536E-06_JPRB, 0.31793221E-06_JPRB, 0.31792817E-06_JPRB, 0.31792388E-06_JPRB, 0.31791853E-06_JPRB, 0.31791353E-06_JPRB, &
  & 0.31790839E-06_JPRB, 0.31790242E-06_JPRB, 0.31789276E-06_JPRB, 0.31787317E-06_JPRB /)

RGHG3(:,73, 9) = (/ &
  & 0.31783046E-06_JPRB, 0.31785436E-06_JPRB, 0.31786513E-06_JPRB, 0.31787289E-06_JPRB, 0.31787900E-06_JPRB, 0.31788375E-06_JPRB, &
  & 0.31788812E-06_JPRB, 0.31789236E-06_JPRB, 0.31789673E-06_JPRB, 0.31790006E-06_JPRB, 0.31790449E-06_JPRB, 0.31790682E-06_JPRB, &
  & 0.31790691E-06_JPRB, 0.31790833E-06_JPRB, 0.31791561E-06_JPRB, 0.31791842E-06_JPRB, 0.31791726E-06_JPRB, 0.31791330E-06_JPRB, &
  & 0.31790896E-06_JPRB, 0.31790390E-06_JPRB, 0.31789983E-06_JPRB, 0.31789813E-06_JPRB, 0.31789955E-06_JPRB, 0.31790520E-06_JPRB, &
  & 0.31791359E-06_JPRB, 0.31792342E-06_JPRB, 0.31793476E-06_JPRB, 0.31794636E-06_JPRB, 0.31795730E-06_JPRB, 0.31796785E-06_JPRB, &
  & 0.31797654E-06_JPRB, 0.31798339E-06_JPRB, 0.31798851E-06_JPRB, 0.31799084E-06_JPRB, 0.31799271E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31798993E-06_JPRB, 0.31798746E-06_JPRB, 0.31798376E-06_JPRB, 0.31797947E-06_JPRB, 0.31797495E-06_JPRB, &
  & 0.31797100E-06_JPRB, 0.31796756E-06_JPRB, 0.31796463E-06_JPRB, 0.31796185E-06_JPRB, 0.31795909E-06_JPRB, 0.31795699E-06_JPRB, &
  & 0.31795543E-06_JPRB, 0.31795437E-06_JPRB, 0.31795332E-06_JPRB, 0.31795193E-06_JPRB, 0.31795082E-06_JPRB, 0.31794889E-06_JPRB, &
  & 0.31794659E-06_JPRB, 0.31794383E-06_JPRB, 0.31794048E-06_JPRB, 0.31793655E-06_JPRB, 0.31793198E-06_JPRB, 0.31792734E-06_JPRB, &
  & 0.31792302E-06_JPRB, 0.31791754E-06_JPRB, 0.31790867E-06_JPRB, 0.31788963E-06_JPRB /)

RGHG3(:,74, 9) = (/ &
  & 0.31785345E-06_JPRB, 0.31787692E-06_JPRB, 0.31788727E-06_JPRB, 0.31789475E-06_JPRB, 0.31790088E-06_JPRB, 0.31790492E-06_JPRB, &
  & 0.31790879E-06_JPRB, 0.31791279E-06_JPRB, 0.31791578E-06_JPRB, 0.31791939E-06_JPRB, 0.31792217E-06_JPRB, 0.31792473E-06_JPRB, &
  & 0.31792635E-06_JPRB, 0.31792709E-06_JPRB, 0.31793240E-06_JPRB, 0.31793428E-06_JPRB, 0.31793314E-06_JPRB, 0.31792950E-06_JPRB, &
  & 0.31792612E-06_JPRB, 0.31792194E-06_JPRB, 0.31791836E-06_JPRB, 0.31791677E-06_JPRB, 0.31791751E-06_JPRB, 0.31792212E-06_JPRB, &
  & 0.31792905E-06_JPRB, 0.31793684E-06_JPRB, 0.31794639E-06_JPRB, 0.31795616E-06_JPRB, 0.31796509E-06_JPRB, 0.31797404E-06_JPRB, &
  & 0.31798115E-06_JPRB, 0.31798677E-06_JPRB, 0.31799118E-06_JPRB, 0.31799266E-06_JPRB, 0.31799445E-06_JPRB, 0.31799451E-06_JPRB, &
  & 0.31799362E-06_JPRB, 0.31799206E-06_JPRB, 0.31799038E-06_JPRB, 0.31798731E-06_JPRB, 0.31798373E-06_JPRB, 0.31797981E-06_JPRB, &
  & 0.31797674E-06_JPRB, 0.31797398E-06_JPRB, 0.31797171E-06_JPRB, 0.31796947E-06_JPRB, 0.31796714E-06_JPRB, 0.31796537E-06_JPRB, &
  & 0.31796415E-06_JPRB, 0.31796341E-06_JPRB, 0.31796256E-06_JPRB, 0.31796137E-06_JPRB, 0.31796060E-06_JPRB, 0.31795886E-06_JPRB, &
  & 0.31795679E-06_JPRB, 0.31795472E-06_JPRB, 0.31795184E-06_JPRB, 0.31794860E-06_JPRB, 0.31794460E-06_JPRB, 0.31794070E-06_JPRB, &
  & 0.31793712E-06_JPRB, 0.31793249E-06_JPRB, 0.31792439E-06_JPRB, 0.31790660E-06_JPRB /)

RGHG3(:,75, 9) = (/ &
  & 0.31787724E-06_JPRB, 0.31789924E-06_JPRB, 0.31790864E-06_JPRB, 0.31791592E-06_JPRB, 0.31792158E-06_JPRB, 0.31792490E-06_JPRB, &
  & 0.31792820E-06_JPRB, 0.31793132E-06_JPRB, 0.31793431E-06_JPRB, 0.31793630E-06_JPRB, 0.31793900E-06_JPRB, 0.31793959E-06_JPRB, &
  & 0.31793664E-06_JPRB, 0.31793559E-06_JPRB, 0.31794571E-06_JPRB, 0.31794875E-06_JPRB, 0.31794781E-06_JPRB, 0.31794443E-06_JPRB, &
  & 0.31794215E-06_JPRB, 0.31793866E-06_JPRB, 0.31793567E-06_JPRB, 0.31793417E-06_JPRB, 0.31793434E-06_JPRB, 0.31793800E-06_JPRB, &
  & 0.31794369E-06_JPRB, 0.31794963E-06_JPRB, 0.31795742E-06_JPRB, 0.31796546E-06_JPRB, 0.31797242E-06_JPRB, 0.31797970E-06_JPRB, &
  & 0.31798527E-06_JPRB, 0.31798982E-06_JPRB, 0.31799362E-06_JPRB, 0.31799416E-06_JPRB, 0.31799590E-06_JPRB, 0.31799587E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799385E-06_JPRB, 0.31799291E-06_JPRB, 0.31799041E-06_JPRB, 0.31798763E-06_JPRB, 0.31798425E-06_JPRB, &
  & 0.31798197E-06_JPRB, 0.31797967E-06_JPRB, 0.31797813E-06_JPRB, 0.31797640E-06_JPRB, 0.31797444E-06_JPRB, 0.31797305E-06_JPRB, &
  & 0.31797219E-06_JPRB, 0.31797177E-06_JPRB, 0.31797117E-06_JPRB, 0.31796995E-06_JPRB, 0.31796949E-06_JPRB, 0.31796796E-06_JPRB, &
  & 0.31796623E-06_JPRB, 0.31796458E-06_JPRB, 0.31796236E-06_JPRB, 0.31795963E-06_JPRB, 0.31795642E-06_JPRB, 0.31795315E-06_JPRB, &
  & 0.31795059E-06_JPRB, 0.31794676E-06_JPRB, 0.31793951E-06_JPRB, 0.31792348E-06_JPRB /)

RGHG3(:,76, 9) = (/ &
  & 0.31790131E-06_JPRB, 0.31792075E-06_JPRB, 0.31792911E-06_JPRB, 0.31793562E-06_JPRB, 0.31794116E-06_JPRB, 0.31794332E-06_JPRB, &
  & 0.31794593E-06_JPRB, 0.31794875E-06_JPRB, 0.31795059E-06_JPRB, 0.31795236E-06_JPRB, 0.31795406E-06_JPRB, 0.31795472E-06_JPRB, &
  & 0.31795429E-06_JPRB, 0.31795341E-06_JPRB, 0.31795989E-06_JPRB, 0.31796233E-06_JPRB, 0.31796145E-06_JPRB, 0.31795801E-06_JPRB, &
  & 0.31795699E-06_JPRB, 0.31795429E-06_JPRB, 0.31795182E-06_JPRB, 0.31795045E-06_JPRB, 0.31794997E-06_JPRB, 0.31795292E-06_JPRB, &
  & 0.31795761E-06_JPRB, 0.31796168E-06_JPRB, 0.31796779E-06_JPRB, 0.31797413E-06_JPRB, 0.31797927E-06_JPRB, 0.31798487E-06_JPRB, &
  & 0.31798905E-06_JPRB, 0.31799260E-06_JPRB, 0.31799587E-06_JPRB, 0.31799547E-06_JPRB, 0.31799732E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31799669E-06_JPRB, 0.31799544E-06_JPRB, 0.31799524E-06_JPRB, 0.31799328E-06_JPRB, 0.31799124E-06_JPRB, 0.31798820E-06_JPRB, &
  & 0.31798672E-06_JPRB, 0.31798501E-06_JPRB, 0.31798407E-06_JPRB, 0.31798282E-06_JPRB, 0.31798115E-06_JPRB, 0.31797998E-06_JPRB, &
  & 0.31797941E-06_JPRB, 0.31797933E-06_JPRB, 0.31797887E-06_JPRB, 0.31797759E-06_JPRB, 0.31797754E-06_JPRB, 0.31797612E-06_JPRB, &
  & 0.31797470E-06_JPRB, 0.31797359E-06_JPRB, 0.31797188E-06_JPRB, 0.31796969E-06_JPRB, 0.31796733E-06_JPRB, 0.31796475E-06_JPRB, &
  & 0.31796321E-06_JPRB, 0.31796029E-06_JPRB, 0.31795395E-06_JPRB, 0.31793988E-06_JPRB /)

RGHG3(:,77, 9) = (/ &
  & 0.31792530E-06_JPRB, 0.31794133E-06_JPRB, 0.31794809E-06_JPRB, 0.31795400E-06_JPRB, 0.31795935E-06_JPRB, 0.31796014E-06_JPRB, &
  & 0.31796193E-06_JPRB, 0.31796421E-06_JPRB, 0.31796543E-06_JPRB, 0.31796600E-06_JPRB, 0.31796745E-06_JPRB, 0.31796640E-06_JPRB, &
  & 0.31796068E-06_JPRB, 0.31795619E-06_JPRB, 0.31797055E-06_JPRB, 0.31797410E-06_JPRB, 0.31797362E-06_JPRB, 0.31797001E-06_JPRB, &
  & 0.31797046E-06_JPRB, 0.31796839E-06_JPRB, 0.31796645E-06_JPRB, 0.31796523E-06_JPRB, 0.31796429E-06_JPRB, 0.31796682E-06_JPRB, &
  & 0.31797066E-06_JPRB, 0.31797285E-06_JPRB, 0.31797748E-06_JPRB, 0.31798231E-06_JPRB, 0.31798550E-06_JPRB, 0.31798945E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799519E-06_JPRB, 0.31799797E-06_JPRB, 0.31799649E-06_JPRB, 0.31799837E-06_JPRB, 0.31799840E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31799672E-06_JPRB, 0.31799726E-06_JPRB, 0.31799573E-06_JPRB, 0.31799448E-06_JPRB, 0.31799163E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31798976E-06_JPRB, 0.31798942E-06_JPRB, 0.31798874E-06_JPRB, 0.31798712E-06_JPRB, 0.31798618E-06_JPRB, &
  & 0.31798584E-06_JPRB, 0.31798606E-06_JPRB, 0.31798575E-06_JPRB, 0.31798433E-06_JPRB, 0.31798467E-06_JPRB, 0.31798334E-06_JPRB, &
  & 0.31798209E-06_JPRB, 0.31798163E-06_JPRB, 0.31798041E-06_JPRB, 0.31797867E-06_JPRB, 0.31797717E-06_JPRB, 0.31797521E-06_JPRB, &
  & 0.31797484E-06_JPRB, 0.31797293E-06_JPRB, 0.31796728E-06_JPRB, 0.31795582E-06_JPRB /)

RGHG3(:,78, 9) = (/ &
  & 0.31794940E-06_JPRB, 0.31796000E-06_JPRB, 0.31796458E-06_JPRB, 0.31796958E-06_JPRB, 0.31797521E-06_JPRB, 0.31797430E-06_JPRB, &
  & 0.31797532E-06_JPRB, 0.31797725E-06_JPRB, 0.31797759E-06_JPRB, 0.31797731E-06_JPRB, 0.31797850E-06_JPRB, 0.31797720E-06_JPRB, &
  & 0.31797393E-06_JPRB, 0.31797057E-06_JPRB, 0.31798106E-06_JPRB, 0.31798405E-06_JPRB, 0.31798365E-06_JPRB, 0.31797975E-06_JPRB, &
  & 0.31798174E-06_JPRB, 0.31798027E-06_JPRB, 0.31797887E-06_JPRB, 0.31797794E-06_JPRB, 0.31797649E-06_JPRB, 0.31797873E-06_JPRB, &
  & 0.31798197E-06_JPRB, 0.31798254E-06_JPRB, 0.31798584E-06_JPRB, 0.31798936E-06_JPRB, 0.31799090E-06_JPRB, 0.31799343E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799729E-06_JPRB, 0.31799976E-06_JPRB, 0.31799735E-06_JPRB, 0.31799956E-06_JPRB, 0.31799971E-06_JPRB, &
  & 0.31799928E-06_JPRB, 0.31799789E-06_JPRB, 0.31799905E-06_JPRB, 0.31799789E-06_JPRB, 0.31799726E-06_JPRB, 0.31799451E-06_JPRB, &
  & 0.31799445E-06_JPRB, 0.31799374E-06_JPRB, 0.31799388E-06_JPRB, 0.31799365E-06_JPRB, 0.31799212E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31799169E-06_JPRB, 0.31799146E-06_JPRB, 0.31798987E-06_JPRB, 0.31799067E-06_JPRB, 0.31798933E-06_JPRB, &
  & 0.31798820E-06_JPRB, 0.31798825E-06_JPRB, 0.31798749E-06_JPRB, 0.31798615E-06_JPRB, 0.31798547E-06_JPRB, 0.31798405E-06_JPRB, &
  & 0.31798470E-06_JPRB, 0.31798365E-06_JPRB, 0.31797921E-06_JPRB, 0.31797100E-06_JPRB /)

RGHG3(:,79, 9) = (/ &
  & 0.31796557E-06_JPRB, 0.31797020E-06_JPRB, 0.31797299E-06_JPRB, 0.31797768E-06_JPRB, 0.31798388E-06_JPRB, 0.31798155E-06_JPRB, &
  & 0.31798214E-06_JPRB, 0.31798413E-06_JPRB, 0.31798388E-06_JPRB, 0.31798282E-06_JPRB, 0.31798419E-06_JPRB, 0.31798263E-06_JPRB, &
  & 0.31798058E-06_JPRB, 0.31797779E-06_JPRB, 0.31798666E-06_JPRB, 0.31798936E-06_JPRB, 0.31798911E-06_JPRB, 0.31798473E-06_JPRB, &
  & 0.31798788E-06_JPRB, 0.31798666E-06_JPRB, 0.31798555E-06_JPRB, 0.31798479E-06_JPRB, 0.31798291E-06_JPRB, 0.31798518E-06_JPRB, &
  & 0.31798825E-06_JPRB, 0.31798774E-06_JPRB, 0.31799050E-06_JPRB, 0.31799325E-06_JPRB, 0.31799382E-06_JPRB, 0.31799559E-06_JPRB, &
  & 0.31799681E-06_JPRB, 0.31799854E-06_JPRB, 0.31800104E-06_JPRB, 0.31799777E-06_JPRB, 0.31800033E-06_JPRB, 0.31800059E-06_JPRB, &
  & 0.31800028E-06_JPRB, 0.31799860E-06_JPRB, 0.31800016E-06_JPRB, 0.31799914E-06_JPRB, 0.31799888E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799635E-06_JPRB, 0.31799587E-06_JPRB, 0.31799632E-06_JPRB, 0.31799638E-06_JPRB, 0.31799470E-06_JPRB, 0.31799374E-06_JPRB, &
  & 0.31799397E-06_JPRB, 0.31799465E-06_JPRB, 0.31799445E-06_JPRB, 0.31799254E-06_JPRB, 0.31799385E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799115E-06_JPRB, 0.31799163E-06_JPRB, 0.31799115E-06_JPRB, 0.31798984E-06_JPRB, 0.31798965E-06_JPRB, 0.31798845E-06_JPRB, &
  & 0.31798990E-06_JPRB, 0.31798965E-06_JPRB, 0.31798569E-06_JPRB, 0.31798075E-06_JPRB /)

RGHG3(:,80, 9) = (/ &
  & 0.31797683E-06_JPRB, 0.31797489E-06_JPRB, 0.31797643E-06_JPRB, 0.31798112E-06_JPRB, 0.31798788E-06_JPRB, 0.31798473E-06_JPRB, &
  & 0.31798504E-06_JPRB, 0.31798714E-06_JPRB, 0.31798652E-06_JPRB, 0.31798513E-06_JPRB, 0.31798660E-06_JPRB, 0.31798493E-06_JPRB, &
  & 0.31798356E-06_JPRB, 0.31798098E-06_JPRB, 0.31798913E-06_JPRB, 0.31799189E-06_JPRB, 0.31799158E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31798962E-06_JPRB, 0.31798868E-06_JPRB, 0.31798791E-06_JPRB, 0.31798575E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31799121E-06_JPRB, 0.31799016E-06_JPRB, 0.31799260E-06_JPRB, 0.31799510E-06_JPRB, 0.31799527E-06_JPRB, 0.31799672E-06_JPRB, &
  & 0.31799757E-06_JPRB, 0.31799914E-06_JPRB, 0.31800172E-06_JPRB, 0.31799794E-06_JPRB, 0.31800076E-06_JPRB, 0.31800107E-06_JPRB, &
  & 0.31800076E-06_JPRB, 0.31799891E-06_JPRB, 0.31800079E-06_JPRB, 0.31799985E-06_JPRB, 0.31799968E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799729E-06_JPRB, 0.31799686E-06_JPRB, 0.31799755E-06_JPRB, 0.31799780E-06_JPRB, 0.31799595E-06_JPRB, 0.31799493E-06_JPRB, &
  & 0.31799522E-06_JPRB, 0.31799601E-06_JPRB, 0.31799590E-06_JPRB, 0.31799371E-06_JPRB, 0.31799527E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799232E-06_JPRB, 0.31799303E-06_JPRB, 0.31799260E-06_JPRB, 0.31799132E-06_JPRB, 0.31799146E-06_JPRB, 0.31799027E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31799229E-06_JPRB, 0.31798879E-06_JPRB, 0.31798720E-06_JPRB /)

RGHG3(:,81, 9) = (/ &
  & 0.31798507E-06_JPRB, 0.31797688E-06_JPRB, 0.31797782E-06_JPRB, 0.31798248E-06_JPRB, 0.31798970E-06_JPRB, 0.31798606E-06_JPRB, &
  & 0.31798626E-06_JPRB, 0.31798842E-06_JPRB, 0.31798774E-06_JPRB, 0.31798609E-06_JPRB, 0.31798751E-06_JPRB, 0.31798584E-06_JPRB, &
  & 0.31798487E-06_JPRB, 0.31798234E-06_JPRB, 0.31799024E-06_JPRB, 0.31799308E-06_JPRB, 0.31799286E-06_JPRB, 0.31798757E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799101E-06_JPRB, 0.31799013E-06_JPRB, 0.31798936E-06_JPRB, 0.31798695E-06_JPRB, 0.31798939E-06_JPRB, &
  & 0.31799252E-06_JPRB, 0.31799127E-06_JPRB, 0.31799360E-06_JPRB, 0.31799601E-06_JPRB, 0.31799593E-06_JPRB, 0.31799715E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31799945E-06_JPRB, 0.31800204E-06_JPRB, 0.31799792E-06_JPRB, 0.31800096E-06_JPRB, 0.31800136E-06_JPRB, &
  & 0.31800107E-06_JPRB, 0.31799914E-06_JPRB, 0.31800110E-06_JPRB, 0.31800019E-06_JPRB, 0.31799999E-06_JPRB, 0.31799712E-06_JPRB, &
  & 0.31799766E-06_JPRB, 0.31799735E-06_JPRB, 0.31799809E-06_JPRB, 0.31799846E-06_JPRB, 0.31799652E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799667E-06_JPRB, 0.31799661E-06_JPRB, 0.31799419E-06_JPRB, 0.31799595E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799277E-06_JPRB, 0.31799362E-06_JPRB, 0.31799325E-06_JPRB, 0.31799195E-06_JPRB, 0.31799220E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799314E-06_JPRB, 0.31799348E-06_JPRB, 0.31799007E-06_JPRB, 0.31799178E-06_JPRB /)

RGHG3(:,82, 9) = (/ &
  & 0.31798581E-06_JPRB, 0.31797737E-06_JPRB, 0.31797833E-06_JPRB, 0.31798317E-06_JPRB, 0.31799061E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31798697E-06_JPRB, 0.31798899E-06_JPRB, 0.31798805E-06_JPRB, 0.31798663E-06_JPRB, 0.31798788E-06_JPRB, 0.31798632E-06_JPRB, &
  & 0.31798538E-06_JPRB, 0.31798294E-06_JPRB, 0.31799073E-06_JPRB, 0.31799371E-06_JPRB, 0.31799343E-06_JPRB, 0.31798791E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799181E-06_JPRB, 0.31799081E-06_JPRB, 0.31799007E-06_JPRB, 0.31798749E-06_JPRB, 0.31799001E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799175E-06_JPRB, 0.31799405E-06_JPRB, 0.31799635E-06_JPRB, 0.31799624E-06_JPRB, 0.31799746E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799959E-06_JPRB, 0.31800226E-06_JPRB, 0.31799806E-06_JPRB, 0.31800110E-06_JPRB, 0.31800150E-06_JPRB, &
  & 0.31800121E-06_JPRB, 0.31799925E-06_JPRB, 0.31800127E-06_JPRB, 0.31800039E-06_JPRB, 0.31800019E-06_JPRB, 0.31799726E-06_JPRB, &
  & 0.31799789E-06_JPRB, 0.31799760E-06_JPRB, 0.31799843E-06_JPRB, 0.31799880E-06_JPRB, 0.31799678E-06_JPRB, 0.31799570E-06_JPRB, &
  & 0.31799613E-06_JPRB, 0.31799701E-06_JPRB, 0.31799701E-06_JPRB, 0.31799442E-06_JPRB, 0.31799630E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799388E-06_JPRB, 0.31799348E-06_JPRB, 0.31799220E-06_JPRB, 0.31799254E-06_JPRB, 0.31799135E-06_JPRB, &
  & 0.31799365E-06_JPRB, 0.31799402E-06_JPRB, 0.31799044E-06_JPRB, 0.31799212E-06_JPRB /)

RGHG3(:,83, 9) = (/ &
  & 0.31798629E-06_JPRB, 0.31797765E-06_JPRB, 0.31797862E-06_JPRB, 0.31798351E-06_JPRB, 0.31799118E-06_JPRB, 0.31798714E-06_JPRB, &
  & 0.31798729E-06_JPRB, 0.31798936E-06_JPRB, 0.31798859E-06_JPRB, 0.31798695E-06_JPRB, 0.31798803E-06_JPRB, 0.31798641E-06_JPRB, &
  & 0.31798569E-06_JPRB, 0.31798345E-06_JPRB, 0.31799101E-06_JPRB, 0.31799411E-06_JPRB, 0.31799379E-06_JPRB, 0.31798808E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799229E-06_JPRB, 0.31799118E-06_JPRB, 0.31799047E-06_JPRB, 0.31798771E-06_JPRB, 0.31799050E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799209E-06_JPRB, 0.31799442E-06_JPRB, 0.31799664E-06_JPRB, 0.31799649E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31799973E-06_JPRB, 0.31800238E-06_JPRB, 0.31799806E-06_JPRB, 0.31800118E-06_JPRB, 0.31800170E-06_JPRB, &
  & 0.31800127E-06_JPRB, 0.31799931E-06_JPRB, 0.31800133E-06_JPRB, 0.31800050E-06_JPRB, 0.31800028E-06_JPRB, 0.31799743E-06_JPRB, &
  & 0.31799800E-06_JPRB, 0.31799772E-06_JPRB, 0.31799865E-06_JPRB, 0.31799911E-06_JPRB, 0.31799695E-06_JPRB, 0.31799584E-06_JPRB, &
  & 0.31799632E-06_JPRB, 0.31799721E-06_JPRB, 0.31799718E-06_JPRB, 0.31799448E-06_JPRB, 0.31799649E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799402E-06_JPRB, 0.31799368E-06_JPRB, 0.31799235E-06_JPRB, 0.31799271E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799391E-06_JPRB, 0.31799433E-06_JPRB, 0.31799064E-06_JPRB, 0.31799240E-06_JPRB /)

RGHG3(:,84, 9) = (/ &
  & 0.31798672E-06_JPRB, 0.31797777E-06_JPRB, 0.31797867E-06_JPRB, 0.31798373E-06_JPRB, 0.31799158E-06_JPRB, 0.31798746E-06_JPRB, &
  & 0.31798771E-06_JPRB, 0.31798936E-06_JPRB, 0.31798831E-06_JPRB, 0.31798720E-06_JPRB, 0.31798797E-06_JPRB, 0.31798666E-06_JPRB, &
  & 0.31798584E-06_JPRB, 0.31798419E-06_JPRB, 0.31799095E-06_JPRB, 0.31799425E-06_JPRB, 0.31799399E-06_JPRB, 0.31798822E-06_JPRB, &
  & 0.31799360E-06_JPRB, 0.31799254E-06_JPRB, 0.31799141E-06_JPRB, 0.31799070E-06_JPRB, 0.31798783E-06_JPRB, 0.31799067E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799235E-06_JPRB, 0.31799462E-06_JPRB, 0.31799681E-06_JPRB, 0.31799658E-06_JPRB, 0.31799763E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799979E-06_JPRB, 0.31800246E-06_JPRB, 0.31799806E-06_JPRB, 0.31800133E-06_JPRB, 0.31800172E-06_JPRB, &
  & 0.31800136E-06_JPRB, 0.31799942E-06_JPRB, 0.31800138E-06_JPRB, 0.31800056E-06_JPRB, 0.31800036E-06_JPRB, 0.31799746E-06_JPRB, &
  & 0.31799809E-06_JPRB, 0.31799780E-06_JPRB, 0.31799880E-06_JPRB, 0.31799931E-06_JPRB, 0.31799701E-06_JPRB, 0.31799593E-06_JPRB, &
  & 0.31799641E-06_JPRB, 0.31799738E-06_JPRB, 0.31799732E-06_JPRB, 0.31799456E-06_JPRB, 0.31799664E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799411E-06_JPRB, 0.31799374E-06_JPRB, 0.31799240E-06_JPRB, 0.31799283E-06_JPRB, 0.31799155E-06_JPRB, &
  & 0.31799405E-06_JPRB, 0.31799462E-06_JPRB, 0.31799084E-06_JPRB, 0.31799263E-06_JPRB /)

RGHG3(:,85, 9) = (/ &
  & 0.31798697E-06_JPRB, 0.31797794E-06_JPRB, 0.31797873E-06_JPRB, 0.31798390E-06_JPRB, 0.31799186E-06_JPRB, 0.31798757E-06_JPRB, &
  & 0.31798766E-06_JPRB, 0.31798922E-06_JPRB, 0.31798857E-06_JPRB, 0.31798743E-06_JPRB, 0.31798777E-06_JPRB, 0.31798672E-06_JPRB, &
  & 0.31798612E-06_JPRB, 0.31798535E-06_JPRB, 0.31799067E-06_JPRB, 0.31799388E-06_JPRB, 0.31799388E-06_JPRB, 0.31798871E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799271E-06_JPRB, 0.31799166E-06_JPRB, 0.31799090E-06_JPRB, 0.31798785E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31799431E-06_JPRB, 0.31799240E-06_JPRB, 0.31799476E-06_JPRB, 0.31799695E-06_JPRB, 0.31799669E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799988E-06_JPRB, 0.31800261E-06_JPRB, 0.31799806E-06_JPRB, 0.31800136E-06_JPRB, 0.31800187E-06_JPRB, &
  & 0.31800136E-06_JPRB, 0.31799937E-06_JPRB, 0.31800144E-06_JPRB, 0.31800062E-06_JPRB, 0.31800039E-06_JPRB, 0.31799749E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799789E-06_JPRB, 0.31799897E-06_JPRB, 0.31799939E-06_JPRB, 0.31799703E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799647E-06_JPRB, 0.31799746E-06_JPRB, 0.31799743E-06_JPRB, 0.31799456E-06_JPRB, 0.31799669E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799419E-06_JPRB, 0.31799379E-06_JPRB, 0.31799246E-06_JPRB, 0.31799289E-06_JPRB, 0.31799161E-06_JPRB, &
  & 0.31799428E-06_JPRB, 0.31799482E-06_JPRB, 0.31799092E-06_JPRB, 0.31799280E-06_JPRB /)

RGHG3(:,86, 9) = (/ &
  & 0.31798734E-06_JPRB, 0.31797788E-06_JPRB, 0.31797870E-06_JPRB, 0.31798385E-06_JPRB, 0.31799175E-06_JPRB, 0.31798805E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798891E-06_JPRB, 0.31798822E-06_JPRB, 0.31798754E-06_JPRB, 0.31798763E-06_JPRB, 0.31798697E-06_JPRB, &
  & 0.31798669E-06_JPRB, 0.31798658E-06_JPRB, 0.31799036E-06_JPRB, 0.31799320E-06_JPRB, 0.31799340E-06_JPRB, 0.31798930E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31799286E-06_JPRB, 0.31799178E-06_JPRB, 0.31799104E-06_JPRB, 0.31798783E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799240E-06_JPRB, 0.31799476E-06_JPRB, 0.31799706E-06_JPRB, 0.31799669E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31799993E-06_JPRB, 0.31800266E-06_JPRB, 0.31799803E-06_JPRB, 0.31800147E-06_JPRB, 0.31800192E-06_JPRB, &
  & 0.31800144E-06_JPRB, 0.31799939E-06_JPRB, 0.31800158E-06_JPRB, 0.31800073E-06_JPRB, 0.31800045E-06_JPRB, 0.31799743E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799797E-06_JPRB, 0.31799905E-06_JPRB, 0.31799954E-06_JPRB, 0.31799709E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799752E-06_JPRB, 0.31799746E-06_JPRB, 0.31799456E-06_JPRB, 0.31799678E-06_JPRB, 0.31799453E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799425E-06_JPRB, 0.31799377E-06_JPRB, 0.31799246E-06_JPRB, 0.31799289E-06_JPRB, 0.31799152E-06_JPRB, &
  & 0.31799433E-06_JPRB, 0.31799499E-06_JPRB, 0.31799098E-06_JPRB, 0.31799289E-06_JPRB /)

RGHG3(:,87, 9) = (/ &
  & 0.31798737E-06_JPRB, 0.31797788E-06_JPRB, 0.31797876E-06_JPRB, 0.31798427E-06_JPRB, 0.31799189E-06_JPRB, 0.31798788E-06_JPRB, &
  & 0.31798788E-06_JPRB, 0.31798879E-06_JPRB, 0.31798834E-06_JPRB, 0.31798766E-06_JPRB, 0.31798766E-06_JPRB, 0.31798714E-06_JPRB, &
  & 0.31798703E-06_JPRB, 0.31798720E-06_JPRB, 0.31799027E-06_JPRB, 0.31799260E-06_JPRB, 0.31799294E-06_JPRB, 0.31798982E-06_JPRB, &
  & 0.31799351E-06_JPRB, 0.31799283E-06_JPRB, 0.31799181E-06_JPRB, 0.31799107E-06_JPRB, 0.31798771E-06_JPRB, 0.31799092E-06_JPRB, &
  & 0.31799473E-06_JPRB, 0.31799226E-06_JPRB, 0.31799490E-06_JPRB, 0.31799712E-06_JPRB, 0.31799664E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31800002E-06_JPRB, 0.31800283E-06_JPRB, 0.31799800E-06_JPRB, 0.31800150E-06_JPRB, 0.31800198E-06_JPRB, &
  & 0.31800153E-06_JPRB, 0.31799925E-06_JPRB, 0.31800164E-06_JPRB, 0.31800079E-06_JPRB, 0.31800056E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31799797E-06_JPRB, 0.31799919E-06_JPRB, 0.31799971E-06_JPRB, 0.31799712E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799752E-06_JPRB, 0.31799760E-06_JPRB, 0.31799453E-06_JPRB, 0.31799684E-06_JPRB, 0.31799453E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799422E-06_JPRB, 0.31799379E-06_JPRB, 0.31799254E-06_JPRB, 0.31799294E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799442E-06_JPRB, 0.31799507E-06_JPRB, 0.31799098E-06_JPRB, 0.31799300E-06_JPRB /)

RGHG3(:,88, 9) = (/ &
  & 0.31798754E-06_JPRB, 0.31797785E-06_JPRB, 0.31797873E-06_JPRB, 0.31798390E-06_JPRB, 0.31799166E-06_JPRB, 0.31798839E-06_JPRB, &
  & 0.31798822E-06_JPRB, 0.31798879E-06_JPRB, 0.31798817E-06_JPRB, 0.31798766E-06_JPRB, 0.31798766E-06_JPRB, 0.31798726E-06_JPRB, &
  & 0.31798720E-06_JPRB, 0.31798749E-06_JPRB, 0.31799024E-06_JPRB, 0.31799254E-06_JPRB, 0.31799289E-06_JPRB, 0.31798996E-06_JPRB, &
  & 0.31799351E-06_JPRB, 0.31799289E-06_JPRB, 0.31799183E-06_JPRB, 0.31799112E-06_JPRB, 0.31798766E-06_JPRB, 0.31799095E-06_JPRB, &
  & 0.31799493E-06_JPRB, 0.31799215E-06_JPRB, 0.31799487E-06_JPRB, 0.31799729E-06_JPRB, 0.31799664E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31800008E-06_JPRB, 0.31800295E-06_JPRB, 0.31799794E-06_JPRB, 0.31800167E-06_JPRB, 0.31800209E-06_JPRB, &
  & 0.31800158E-06_JPRB, 0.31799908E-06_JPRB, 0.31800181E-06_JPRB, 0.31800087E-06_JPRB, 0.31800076E-06_JPRB, 0.31799706E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799794E-06_JPRB, 0.31799917E-06_JPRB, 0.31799976E-06_JPRB, 0.31799715E-06_JPRB, 0.31799604E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799760E-06_JPRB, 0.31799763E-06_JPRB, 0.31799448E-06_JPRB, 0.31799689E-06_JPRB, 0.31799456E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799419E-06_JPRB, 0.31799379E-06_JPRB, 0.31799246E-06_JPRB, 0.31799291E-06_JPRB, 0.31799135E-06_JPRB, &
  & 0.31799442E-06_JPRB, 0.31799516E-06_JPRB, 0.31799107E-06_JPRB, 0.31799300E-06_JPRB /)

RGHG3(:,89, 9) = (/ &
  & 0.31798714E-06_JPRB, 0.31797813E-06_JPRB, 0.31797893E-06_JPRB, 0.31798425E-06_JPRB, 0.31799215E-06_JPRB, 0.31798788E-06_JPRB, &
  & 0.31798794E-06_JPRB, 0.31798885E-06_JPRB, 0.31798828E-06_JPRB, 0.31798754E-06_JPRB, 0.31798760E-06_JPRB, 0.31798709E-06_JPRB, &
  & 0.31798697E-06_JPRB, 0.31798714E-06_JPRB, 0.31799027E-06_JPRB, 0.31799271E-06_JPRB, 0.31799306E-06_JPRB, 0.31798976E-06_JPRB, &
  & 0.31799365E-06_JPRB, 0.31799297E-06_JPRB, 0.31799189E-06_JPRB, 0.31799118E-06_JPRB, 0.31798760E-06_JPRB, 0.31799092E-06_JPRB, &
  & 0.31799505E-06_JPRB, 0.31799206E-06_JPRB, 0.31799493E-06_JPRB, 0.31799740E-06_JPRB, 0.31799661E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31800016E-06_JPRB, 0.31800317E-06_JPRB, 0.31799780E-06_JPRB, 0.31800175E-06_JPRB, 0.31800224E-06_JPRB, &
  & 0.31800167E-06_JPRB, 0.31799894E-06_JPRB, 0.31800204E-06_JPRB, 0.31800084E-06_JPRB, 0.31800090E-06_JPRB, 0.31799681E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31799800E-06_JPRB, 0.31799931E-06_JPRB, 0.31799988E-06_JPRB, 0.31799715E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799661E-06_JPRB, 0.31799766E-06_JPRB, 0.31799769E-06_JPRB, 0.31799442E-06_JPRB, 0.31799692E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799300E-06_JPRB, 0.31799422E-06_JPRB, 0.31799374E-06_JPRB, 0.31799243E-06_JPRB, 0.31799291E-06_JPRB, 0.31799129E-06_JPRB, &
  & 0.31799451E-06_JPRB, 0.31799527E-06_JPRB, 0.31799101E-06_JPRB, 0.31799306E-06_JPRB /)

RGHG3(:,90, 9) = (/ &
  & 0.31798703E-06_JPRB, 0.31797811E-06_JPRB, 0.31797870E-06_JPRB, 0.31798379E-06_JPRB, 0.31799246E-06_JPRB, 0.31798800E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798928E-06_JPRB, 0.31798834E-06_JPRB, 0.31798751E-06_JPRB, 0.31798771E-06_JPRB, 0.31798686E-06_JPRB, &
  & 0.31798652E-06_JPRB, 0.31798635E-06_JPRB, 0.31799055E-06_JPRB, 0.31799362E-06_JPRB, 0.31799371E-06_JPRB, 0.31798893E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799300E-06_JPRB, 0.31799189E-06_JPRB, 0.31799129E-06_JPRB, 0.31798737E-06_JPRB, 0.31799098E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799189E-06_JPRB, 0.31799493E-06_JPRB, 0.31799749E-06_JPRB, 0.31799658E-06_JPRB, 0.31799769E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31800016E-06_JPRB, 0.31800354E-06_JPRB, 0.31799740E-06_JPRB, 0.31800190E-06_JPRB, 0.31800232E-06_JPRB, &
  & 0.31800181E-06_JPRB, 0.31799877E-06_JPRB, 0.31800226E-06_JPRB, 0.31800090E-06_JPRB, 0.31800107E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799797E-06_JPRB, 0.31799937E-06_JPRB, 0.31799999E-06_JPRB, 0.31799718E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799664E-06_JPRB, 0.31799775E-06_JPRB, 0.31799780E-06_JPRB, 0.31799428E-06_JPRB, 0.31799706E-06_JPRB, 0.31799456E-06_JPRB, &
  & 0.31799291E-06_JPRB, 0.31799428E-06_JPRB, 0.31799379E-06_JPRB, 0.31799237E-06_JPRB, 0.31799297E-06_JPRB, 0.31799121E-06_JPRB, &
  & 0.31799462E-06_JPRB, 0.31799539E-06_JPRB, 0.31799090E-06_JPRB, 0.31799314E-06_JPRB /)

RGHG3(:,91, 9) = (/ &
  & 0.31798777E-06_JPRB, 0.31797771E-06_JPRB, 0.31797794E-06_JPRB, 0.31798345E-06_JPRB, 0.31799416E-06_JPRB, 0.31798720E-06_JPRB, &
  & 0.31798723E-06_JPRB, 0.31799078E-06_JPRB, 0.31798879E-06_JPRB, 0.31798626E-06_JPRB, 0.31798905E-06_JPRB, 0.31798618E-06_JPRB, &
  & 0.31798615E-06_JPRB, 0.31798220E-06_JPRB, 0.31799220E-06_JPRB, 0.31799564E-06_JPRB, 0.31799533E-06_JPRB, 0.31798655E-06_JPRB, &
  & 0.31799507E-06_JPRB, 0.31799306E-06_JPRB, 0.31799183E-06_JPRB, 0.31799152E-06_JPRB, 0.31798692E-06_JPRB, 0.31799092E-06_JPRB, &
  & 0.31799587E-06_JPRB, 0.31799146E-06_JPRB, 0.31799502E-06_JPRB, 0.31799775E-06_JPRB, 0.31799635E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31800002E-06_JPRB, 0.31800454E-06_JPRB, 0.31799638E-06_JPRB, 0.31800226E-06_JPRB, 0.31800246E-06_JPRB, &
  & 0.31800201E-06_JPRB, 0.31799823E-06_JPRB, 0.31800263E-06_JPRB, 0.31800084E-06_JPRB, 0.31800144E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799848E-06_JPRB, 0.31799783E-06_JPRB, 0.31799942E-06_JPRB, 0.31800025E-06_JPRB, 0.31799701E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799658E-06_JPRB, 0.31799780E-06_JPRB, 0.31799806E-06_JPRB, 0.31799385E-06_JPRB, 0.31799740E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799271E-06_JPRB, 0.31799442E-06_JPRB, 0.31799391E-06_JPRB, 0.31799226E-06_JPRB, 0.31799306E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31799487E-06_JPRB, 0.31799564E-06_JPRB, 0.31799061E-06_JPRB, 0.31799320E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG3(:, 1,10) = (/ &
  & 0.92056425E-07_JPRB, 0.92151737E-07_JPRB, 0.92236590E-07_JPRB, 0.92327959E-07_JPRB, 0.92424330E-07_JPRB, 0.92527131E-07_JPRB, &
  & 0.92637968E-07_JPRB, 0.92754689E-07_JPRB, 0.92871247E-07_JPRB, 0.92987996E-07_JPRB, 0.93107282E-07_JPRB, 0.93230987E-07_JPRB, &
  & 0.93361365E-07_JPRB, 0.93482782E-07_JPRB, 0.93591467E-07_JPRB, 0.93707435E-07_JPRB, 0.93839006E-07_JPRB, 0.93976169E-07_JPRB, &
  & 0.94106944E-07_JPRB, 0.94224887E-07_JPRB, 0.94326666E-07_JPRB, 0.94409899E-07_JPRB, 0.94474046E-07_JPRB, 0.94520992E-07_JPRB, &
  & 0.94554053E-07_JPRB, 0.94576947E-07_JPRB, 0.94592579E-07_JPRB, 0.94600523E-07_JPRB, 0.94595343E-07_JPRB, 0.94569586E-07_JPRB, &
  & 0.94517077E-07_JPRB, 0.94437951E-07_JPRB, 0.94337594E-07_JPRB, 0.94211472E-07_JPRB, 0.94053235E-07_JPRB, 0.93910593E-07_JPRB, &
  & 0.93849053E-07_JPRB, 0.93960274E-07_JPRB, 0.94396256E-07_JPRB, 0.95117230E-07_JPRB, 0.96017828E-07_JPRB, 0.96749126E-07_JPRB, &
  & 0.97256461E-07_JPRB, 0.97629560E-07_JPRB, 0.97914580E-07_JPRB, 0.98133768E-07_JPRB, 0.98294421E-07_JPRB, 0.98386536E-07_JPRB, &
  & 0.98390650E-07_JPRB, 0.98285597E-07_JPRB, 0.98057093E-07_JPRB, 0.97710121E-07_JPRB, 0.97261569E-07_JPRB, 0.96741289E-07_JPRB, &
  & 0.96193588E-07_JPRB, 0.95664497E-07_JPRB, 0.95190785E-07_JPRB, 0.94788120E-07_JPRB, 0.94457192E-07_JPRB, 0.94193901E-07_JPRB, &
  & 0.93992547E-07_JPRB, 0.93848854E-07_JPRB, 0.93770254E-07_JPRB, 0.93732183E-07_JPRB /)

RGHG3(:, 2,10) = (/ &
  & 0.90640576E-07_JPRB, 0.90789996E-07_JPRB, 0.90928239E-07_JPRB, 0.91089305E-07_JPRB, 0.91283908E-07_JPRB, 0.91521940E-07_JPRB, &
  & 0.91791406E-07_JPRB, 0.92075190E-07_JPRB, 0.92361418E-07_JPRB, 0.92634423E-07_JPRB, 0.92893373E-07_JPRB, 0.93139903E-07_JPRB, &
  & 0.93395670E-07_JPRB, 0.93668163E-07_JPRB, 0.93941559E-07_JPRB, 0.94186468E-07_JPRB, 0.94419583E-07_JPRB, 0.94652236E-07_JPRB, &
  & 0.94871837E-07_JPRB, 0.95057231E-07_JPRB, 0.95196441E-07_JPRB, 0.95289252E-07_JPRB, 0.95341683E-07_JPRB, 0.95358985E-07_JPRB, &
  & 0.95345619E-07_JPRB, 0.95307144E-07_JPRB, 0.95243351E-07_JPRB, 0.95149133E-07_JPRB, 0.95022621E-07_JPRB, 0.94874729E-07_JPRB, &
  & 0.94721521E-07_JPRB, 0.94575128E-07_JPRB, 0.94432096E-07_JPRB, 0.94295054E-07_JPRB, 0.94194149E-07_JPRB, 0.94181743E-07_JPRB, &
  & 0.94338375E-07_JPRB, 0.94726175E-07_JPRB, 0.95353933E-07_JPRB, 0.96174169E-07_JPRB, 0.97095167E-07_JPRB, 0.97935995E-07_JPRB, &
  & 0.98597724E-07_JPRB, 0.99075706E-07_JPRB, 0.99398086E-07_JPRB, 0.99592356E-07_JPRB, 0.99679369E-07_JPRB, 0.99679625E-07_JPRB, &
  & 0.99609778E-07_JPRB, 0.99483913E-07_JPRB, 0.99303527E-07_JPRB, 0.99036072E-07_JPRB, 0.98634111E-07_JPRB, 0.98080250E-07_JPRB, &
  & 0.97411061E-07_JPRB, 0.96708824E-07_JPRB, 0.96049341E-07_JPRB, 0.95481738E-07_JPRB, 0.95023623E-07_JPRB, 0.94674235E-07_JPRB, &
  & 0.94421324E-07_JPRB, 0.94250737E-07_JPRB, 0.94142024E-07_JPRB, 0.94060596E-07_JPRB /)

RGHG3(:, 3,10) = (/ &
  & 0.90299253E-07_JPRB, 0.90426298E-07_JPRB, 0.90571604E-07_JPRB, 0.90769753E-07_JPRB, 0.91033527E-07_JPRB, 0.91371660E-07_JPRB, &
  & 0.91751652E-07_JPRB, 0.92163297E-07_JPRB, 0.92579008E-07_JPRB, 0.92988486E-07_JPRB, 0.93389041E-07_JPRB, 0.93777643E-07_JPRB, &
  & 0.94138954E-07_JPRB, 0.94492592E-07_JPRB, 0.94869598E-07_JPRB, 0.95239848E-07_JPRB, 0.95582621E-07_JPRB, 0.95884410E-07_JPRB, &
  & 0.96153741E-07_JPRB, 0.96383062E-07_JPRB, 0.96534549E-07_JPRB, 0.96587797E-07_JPRB, 0.96542692E-07_JPRB, 0.96431485E-07_JPRB, &
  & 0.96270668E-07_JPRB, 0.96064753E-07_JPRB, 0.95831453E-07_JPRB, 0.95569320E-07_JPRB, 0.95293188E-07_JPRB, 0.95021846E-07_JPRB, &
  & 0.94780098E-07_JPRB, 0.94574972E-07_JPRB, 0.94415952E-07_JPRB, 0.94356672E-07_JPRB, 0.94479745E-07_JPRB, 0.94846371E-07_JPRB, &
  & 0.95467840E-07_JPRB, 0.96315077E-07_JPRB, 0.97341356E-07_JPRB, 0.98484151E-07_JPRB, 0.99632068E-07_JPRB, 0.10065850E-06_JPRB, &
  & 0.10145530E-06_JPRB, 0.10200097E-06_JPRB, 0.10231290E-06_JPRB, 0.10242424E-06_JPRB, 0.10236919E-06_JPRB, 0.10217696E-06_JPRB, &
  & 0.10187330E-06_JPRB, 0.10147181E-06_JPRB, 0.10096328E-06_JPRB, 0.10033317E-06_JPRB, 0.99593812E-07_JPRB, 0.98787581E-07_JPRB, &
  & 0.97960978E-07_JPRB, 0.97151990E-07_JPRB, 0.96407689E-07_JPRB, 0.95759987E-07_JPRB, 0.95228437E-07_JPRB, 0.94811710E-07_JPRB, &
  & 0.94501644E-07_JPRB, 0.94285021E-07_JPRB, 0.94141612E-07_JPRB, 0.94021289E-07_JPRB /)

RGHG3(:, 4,10) = (/ &
  & 0.90633442E-07_JPRB, 0.90802430E-07_JPRB, 0.90999428E-07_JPRB, 0.91278260E-07_JPRB, 0.91648047E-07_JPRB, 0.92098318E-07_JPRB, &
  & 0.92582809E-07_JPRB, 0.93065935E-07_JPRB, 0.93550895E-07_JPRB, 0.94023129E-07_JPRB, 0.94486879E-07_JPRB, 0.94954729E-07_JPRB, &
  & 0.95416496E-07_JPRB, 0.95841358E-07_JPRB, 0.96221008E-07_JPRB, 0.96582923E-07_JPRB, 0.96949620E-07_JPRB, 0.97298916E-07_JPRB, &
  & 0.97614056E-07_JPRB, 0.97869119E-07_JPRB, 0.98037447E-07_JPRB, 0.98099832E-07_JPRB, 0.97992455E-07_JPRB, 0.97704039E-07_JPRB, &
  & 0.97310718E-07_JPRB, 0.96863140E-07_JPRB, 0.96359457E-07_JPRB, 0.95871016E-07_JPRB, 0.95436697E-07_JPRB, 0.95092680E-07_JPRB, &
  & 0.94825396E-07_JPRB, 0.94664472E-07_JPRB, 0.94687522E-07_JPRB, 0.94969408E-07_JPRB, 0.95566421E-07_JPRB, 0.96479447E-07_JPRB, &
  & 0.97661427E-07_JPRB, 0.99050503E-07_JPRB, 0.10057877E-06_JPRB, 0.10215765E-06_JPRB, 0.10365387E-06_JPRB, 0.10488171E-06_JPRB, &
  & 0.10573839E-06_JPRB, 0.10621283E-06_JPRB, 0.10635472E-06_JPRB, 0.10623438E-06_JPRB, 0.10591332E-06_JPRB, 0.10544166E-06_JPRB, &
  & 0.10485448E-06_JPRB, 0.10416259E-06_JPRB, 0.10335803E-06_JPRB, 0.10244234E-06_JPRB, 0.10142889E-06_JPRB, 0.10032176E-06_JPRB, &
  & 0.99132876E-07_JPRB, 0.97925145E-07_JPRB, 0.96779488E-07_JPRB, 0.95782553E-07_JPRB, 0.94965138E-07_JPRB, 0.94330431E-07_JPRB, &
  & 0.93859825E-07_JPRB, 0.93530758E-07_JPRB, 0.93299853E-07_JPRB, 0.93107580E-07_JPRB /)

RGHG3(:, 5,10) = (/ &
  & 0.91042914E-07_JPRB, 0.91392920E-07_JPRB, 0.91770943E-07_JPRB, 0.92223814E-07_JPRB, 0.92730730E-07_JPRB, 0.93279709E-07_JPRB, &
  & 0.93826436E-07_JPRB, 0.94364580E-07_JPRB, 0.94895903E-07_JPRB, 0.95427922E-07_JPRB, 0.95961411E-07_JPRB, 0.96478985E-07_JPRB, &
  & 0.96979420E-07_JPRB, 0.97469908E-07_JPRB, 0.97938560E-07_JPRB, 0.98365597E-07_JPRB, 0.98746412E-07_JPRB, 0.99108441E-07_JPRB, &
  & 0.99485291E-07_JPRB, 0.99855740E-07_JPRB, 0.10014661E-06_JPRB, 0.10027689E-06_JPRB, 0.10020705E-06_JPRB, 0.99939903E-07_JPRB, &
  & 0.99456166E-07_JPRB, 0.98864163E-07_JPRB, 0.98301719E-07_JPRB, 0.97829997E-07_JPRB, 0.97492112E-07_JPRB, 0.97318768E-07_JPRB, &
  & 0.97352057E-07_JPRB, 0.97617885E-07_JPRB, 0.98134720E-07_JPRB, 0.98930059E-07_JPRB, 0.10001330E-06_JPRB, 0.10136989E-06_JPRB, &
  & 0.10296728E-06_JPRB, 0.10473304E-06_JPRB, 0.10658193E-06_JPRB, 0.10836600E-06_JPRB, 0.10988532E-06_JPRB, 0.11097059E-06_JPRB, &
  & 0.11155497E-06_JPRB, 0.11168271E-06_JPRB, 0.11145329E-06_JPRB, 0.11096692E-06_JPRB, 0.11029867E-06_JPRB, 0.10949489E-06_JPRB, &
  & 0.10857553E-06_JPRB, 0.10753839E-06_JPRB, 0.10637770E-06_JPRB, 0.10509345E-06_JPRB, 0.10368013E-06_JPRB, 0.10213343E-06_JPRB, &
  & 0.10048139E-06_JPRB, 0.98784511E-07_JPRB, 0.97162001E-07_JPRB, 0.95716800E-07_JPRB, 0.94538954E-07_JPRB, 0.93633084E-07_JPRB, &
  & 0.92962161E-07_JPRB, 0.92486104E-07_JPRB, 0.92151943E-07_JPRB, 0.91836831E-07_JPRB /)

RGHG3(:, 6,10) = (/ &
  & 0.91951165E-07_JPRB, 0.92507726E-07_JPRB, 0.92992032E-07_JPRB, 0.93509399E-07_JPRB, 0.94064490E-07_JPRB, 0.94653352E-07_JPRB, &
  & 0.95239528E-07_JPRB, 0.95827367E-07_JPRB, 0.96416514E-07_JPRB, 0.97017228E-07_JPRB, 0.97619164E-07_JPRB, 0.98217058E-07_JPRB, &
  & 0.98790849E-07_JPRB, 0.99322605E-07_JPRB, 0.99819545E-07_JPRB, 0.10030631E-06_JPRB, 0.10079897E-06_JPRB, 0.10129696E-06_JPRB, &
  & 0.10178405E-06_JPRB, 0.10225889E-06_JPRB, 0.10274205E-06_JPRB, 0.10321169E-06_JPRB, 0.10356849E-06_JPRB, 0.10374517E-06_JPRB, &
  & 0.10376948E-06_JPRB, 0.10372846E-06_JPRB, 0.10372691E-06_JPRB, 0.10384504E-06_JPRB, 0.10413673E-06_JPRB, 0.10463031E-06_JPRB, &
  & 0.10533383E-06_JPRB, 0.10621945E-06_JPRB, 0.10722499E-06_JPRB, 0.10831484E-06_JPRB, 0.10949184E-06_JPRB, 0.11074338E-06_JPRB, &
  & 0.11211529E-06_JPRB, 0.11360521E-06_JPRB, 0.11512931E-06_JPRB, 0.11654468E-06_JPRB, 0.11763841E-06_JPRB, 0.11824985E-06_JPRB, &
  & 0.11834075E-06_JPRB, 0.11799825E-06_JPRB, 0.11735413E-06_JPRB, 0.11650890E-06_JPRB, 0.11552268E-06_JPRB, 0.11441701E-06_JPRB, &
  & 0.11318844E-06_JPRB, 0.11182108E-06_JPRB, 0.11029402E-06_JPRB, 0.10858915E-06_JPRB, 0.10669334E-06_JPRB, 0.10461646E-06_JPRB, &
  & 0.10239774E-06_JPRB, 0.10015545E-06_JPRB, 0.98027030E-07_JPRB, 0.96189055E-07_JPRB, 0.94724946E-07_JPRB, 0.93624905E-07_JPRB, &
  & 0.92828124E-07_JPRB, 0.92270334E-07_JPRB, 0.91838018E-07_JPRB, 0.91436355E-07_JPRB /)

RGHG3(:, 7,10) = (/ &
  & 0.93226021E-07_JPRB, 0.93864436E-07_JPRB, 0.94387794E-07_JPRB, 0.94924104E-07_JPRB, 0.95500582E-07_JPRB, 0.96119329E-07_JPRB, &
  & 0.96758164E-07_JPRB, 0.97401866E-07_JPRB, 0.98068050E-07_JPRB, 0.98752963E-07_JPRB, 0.99457353E-07_JPRB, 0.10015962E-06_JPRB, &
  & 0.10084271E-06_JPRB, 0.10149850E-06_JPRB, 0.10211873E-06_JPRB, 0.10270192E-06_JPRB, 0.10326912E-06_JPRB, 0.10387161E-06_JPRB, &
  & 0.10457848E-06_JPRB, 0.10543997E-06_JPRB, 0.10644320E-06_JPRB, 0.10750548E-06_JPRB, 0.10853218E-06_JPRB, 0.10945072E-06_JPRB, &
  & 0.11025148E-06_JPRB, 0.11098835E-06_JPRB, 0.11174295E-06_JPRB, 0.11260292E-06_JPRB, 0.11360368E-06_JPRB, 0.11475443E-06_JPRB, &
  & 0.11603659E-06_JPRB, 0.11739343E-06_JPRB, 0.11869107E-06_JPRB, 0.11986376E-06_JPRB, 0.12095080E-06_JPRB, 0.12194363E-06_JPRB, &
  & 0.12292018E-06_JPRB, 0.12392765E-06_JPRB, 0.12492073E-06_JPRB, 0.12579012E-06_JPRB, 0.12635850E-06_JPRB, 0.12645116E-06_JPRB, &
  & 0.12604488E-06_JPRB, 0.12526925E-06_JPRB, 0.12425960E-06_JPRB, 0.12312063E-06_JPRB, 0.12189130E-06_JPRB, 0.12057006E-06_JPRB, &
  & 0.11913036E-06_JPRB, 0.11752694E-06_JPRB, 0.11570810E-06_JPRB, 0.11363217E-06_JPRB, 0.11128379E-06_JPRB, 0.10868332E-06_JPRB, &
  & 0.10593342E-06_JPRB, 0.10317881E-06_JPRB, 0.10064486E-06_JPRB, 0.98482026E-07_JPRB, 0.96770712E-07_JPRB, 0.95478825E-07_JPRB, &
  & 0.94543019E-07_JPRB, 0.93859072E-07_JPRB, 0.93342884E-07_JPRB, 0.92772915E-07_JPRB /)

RGHG3(:, 8,10) = (/ &
  & 0.94614137E-07_JPRB, 0.95347851E-07_JPRB, 0.95895132E-07_JPRB, 0.96473570E-07_JPRB, 0.97092858E-07_JPRB, 0.97780017E-07_JPRB, &
  & 0.98496685E-07_JPRB, 0.99243934E-07_JPRB, 0.10001540E-06_JPRB, 0.10082093E-06_JPRB, 0.10164955E-06_JPRB, 0.10248819E-06_JPRB, &
  & 0.10331402E-06_JPRB, 0.10410506E-06_JPRB, 0.10485731E-06_JPRB, 0.10558814E-06_JPRB, 0.10632989E-06_JPRB, 0.10712061E-06_JPRB, &
  & 0.10799970E-06_JPRB, 0.10902647E-06_JPRB, 0.11028376E-06_JPRB, 0.11181896E-06_JPRB, 0.11355907E-06_JPRB, 0.11541242E-06_JPRB, &
  & 0.11731731E-06_JPRB, 0.11920990E-06_JPRB, 0.12110384E-06_JPRB, 0.12300166E-06_JPRB, 0.12492703E-06_JPRB, 0.12686453E-06_JPRB, &
  & 0.12877106E-06_JPRB, 0.13057254E-06_JPRB, 0.13216361E-06_JPRB, 0.13347652E-06_JPRB, 0.13453071E-06_JPRB, 0.13533101E-06_JPRB, &
  & 0.13591574E-06_JPRB, 0.13637356E-06_JPRB, 0.13673758E-06_JPRB, 0.13696742E-06_JPRB, 0.13693993E-06_JPRB, 0.13649618E-06_JPRB, &
  & 0.13562060E-06_JPRB, 0.13441306E-06_JPRB, 0.13305269E-06_JPRB, 0.13162274E-06_JPRB, 0.13014234E-06_JPRB, 0.12858192E-06_JPRB, &
  & 0.12688514E-06_JPRB, 0.12498188E-06_JPRB, 0.12280668E-06_JPRB, 0.12031572E-06_JPRB, 0.11749948E-06_JPRB, 0.11441721E-06_JPRB, &
  & 0.11117571E-06_JPRB, 0.10800147E-06_JPRB, 0.10508606E-06_JPRB, 0.10260376E-06_JPRB, 0.10060016E-06_JPRB, 0.99050176E-07_JPRB, &
  & 0.97906494E-07_JPRB, 0.97052336E-07_JPRB, 0.96404158E-07_JPRB, 0.95640800E-07_JPRB /)

RGHG3(:, 9,10) = (/ &
  & 0.96300774E-07_JPRB, 0.97076942E-07_JPRB, 0.97677926E-07_JPRB, 0.98279585E-07_JPRB, 0.98954942E-07_JPRB, 0.99710263E-07_JPRB, &
  & 0.10052410E-06_JPRB, 0.10137409E-06_JPRB, 0.10226134E-06_JPRB, 0.10318030E-06_JPRB, 0.10412855E-06_JPRB, 0.10509201E-06_JPRB, &
  & 0.10604757E-06_JPRB, 0.10697468E-06_JPRB, 0.10786847E-06_JPRB, 0.10874125E-06_JPRB, 0.10962383E-06_JPRB, 0.11057507E-06_JPRB, &
  & 0.11169320E-06_JPRB, 0.11310969E-06_JPRB, 0.11494197E-06_JPRB, 0.11722426E-06_JPRB, 0.11989614E-06_JPRB, 0.12282848E-06_JPRB, &
  & 0.12584485E-06_JPRB, 0.12884250E-06_JPRB, 0.13172800E-06_JPRB, 0.13448334E-06_JPRB, 0.13712152E-06_JPRB, 0.13970687E-06_JPRB, &
  & 0.14233044E-06_JPRB, 0.14486946E-06_JPRB, 0.14708795E-06_JPRB, 0.14883521E-06_JPRB, 0.15004562E-06_JPRB, 0.15074818E-06_JPRB, &
  & 0.15107551E-06_JPRB, 0.15115475E-06_JPRB, 0.15105067E-06_JPRB, 0.15075520E-06_JPRB, 0.15019199E-06_JPRB, 0.14927247E-06_JPRB, &
  & 0.14794108E-06_JPRB, 0.14633018E-06_JPRB, 0.14456921E-06_JPRB, 0.14275406E-06_JPRB, 0.14088161E-06_JPRB, 0.13889652E-06_JPRB, &
  & 0.13672593E-06_JPRB, 0.13429279E-06_JPRB, 0.13152167E-06_JPRB, 0.12836733E-06_JPRB, 0.12484260E-06_JPRB, 0.12103088E-06_JPRB, &
  & 0.11713352E-06_JPRB, 0.11336807E-06_JPRB, 0.10998208E-06_JPRB, 0.10709613E-06_JPRB, 0.10476262E-06_JPRB, 0.10296233E-06_JPRB, &
  & 0.10159710E-06_JPRB, 0.10066233E-06_JPRB, 0.99823751E-07_JPRB, 0.99050183E-07_JPRB /)

RGHG3(:,10,10) = (/ &
  & 0.98287089E-07_JPRB, 0.99192476E-07_JPRB, 0.99823197E-07_JPRB, 0.10049349E-06_JPRB, 0.10123131E-06_JPRB, 0.10207829E-06_JPRB, &
  & 0.10300312E-06_JPRB, 0.10398583E-06_JPRB, 0.10501145E-06_JPRB, 0.10607604E-06_JPRB, 0.10717245E-06_JPRB, 0.10829005E-06_JPRB, &
  & 0.10940841E-06_JPRB, 0.11049819E-06_JPRB, 0.11153426E-06_JPRB, 0.11252627E-06_JPRB, 0.11353099E-06_JPRB, 0.11463410E-06_JPRB, &
  & 0.11593167E-06_JPRB, 0.11753551E-06_JPRB, 0.11956921E-06_JPRB, 0.12211746E-06_JPRB, 0.12516097E-06_JPRB, 0.12857849E-06_JPRB, &
  & 0.13223089E-06_JPRB, 0.13599087E-06_JPRB, 0.13982225E-06_JPRB, 0.14373732E-06_JPRB, 0.14780782E-06_JPRB, 0.15191948E-06_JPRB, &
  & 0.15572024E-06_JPRB, 0.15920004E-06_JPRB, 0.16226015E-06_JPRB, 0.16470932E-06_JPRB, 0.16647658E-06_JPRB, 0.16759819E-06_JPRB, &
  & 0.16815586E-06_JPRB, 0.16823705E-06_JPRB, 0.16794691E-06_JPRB, 0.16735103E-06_JPRB, 0.16646455E-06_JPRB, 0.16521781E-06_JPRB, &
  & 0.16358044E-06_JPRB, 0.16159048E-06_JPRB, 0.15935497E-06_JPRB, 0.15698292E-06_JPRB, 0.15447978E-06_JPRB, 0.15180089E-06_JPRB, &
  & 0.14886349E-06_JPRB, 0.14557602E-06_JPRB, 0.14187783E-06_JPRB, 0.13773617E-06_JPRB, 0.13320111E-06_JPRB, 0.12843938E-06_JPRB, &
  & 0.12369071E-06_JPRB, 0.11926448E-06_JPRB, 0.11536687E-06_JPRB, 0.11211770E-06_JPRB, 0.10952355E-06_JPRB, 0.10752554E-06_JPRB, &
  & 0.10611141E-06_JPRB, 0.10495927E-06_JPRB, 0.10421157E-06_JPRB, 0.10307043E-06_JPRB /)

RGHG3(:,11,10) = (/ &
  & 0.10078712E-06_JPRB, 0.10181049E-06_JPRB, 0.10257374E-06_JPRB, 0.10333408E-06_JPRB, 0.10420584E-06_JPRB, 0.10521272E-06_JPRB, &
  & 0.10634157E-06_JPRB, 0.10756539E-06_JPRB, 0.10886303E-06_JPRB, 0.11021980E-06_JPRB, 0.11162629E-06_JPRB, 0.11307354E-06_JPRB, &
  & 0.11454411E-06_JPRB, 0.11601683E-06_JPRB, 0.11746506E-06_JPRB, 0.11885807E-06_JPRB, 0.12018145E-06_JPRB, 0.12149100E-06_JPRB, &
  & 0.12289972E-06_JPRB, 0.12454669E-06_JPRB, 0.12658134E-06_JPRB, 0.12911406E-06_JPRB, 0.13216570E-06_JPRB, 0.13569874E-06_JPRB, &
  & 0.13958571E-06_JPRB, 0.14373595E-06_JPRB, 0.14812048E-06_JPRB, 0.15264261E-06_JPRB, 0.15723334E-06_JPRB, 0.16189668E-06_JPRB, &
  & 0.16672499E-06_JPRB, 0.17137927E-06_JPRB, 0.17560720E-06_JPRB, 0.17919326E-06_JPRB, 0.18199367E-06_JPRB, 0.18393152E-06_JPRB, &
  & 0.18507050E-06_JPRB, 0.18552453E-06_JPRB, 0.18545698E-06_JPRB, 0.18496011E-06_JPRB, 0.18406951E-06_JPRB, 0.18275810E-06_JPRB, &
  & 0.18097501E-06_JPRB, 0.17872513E-06_JPRB, 0.17607145E-06_JPRB, 0.17312388E-06_JPRB, 0.16993147E-06_JPRB, 0.16648232E-06_JPRB, &
  & 0.16270748E-06_JPRB, 0.15853693E-06_JPRB, 0.15390883E-06_JPRB, 0.14884189E-06_JPRB, 0.14343001E-06_JPRB, 0.13790837E-06_JPRB, &
  & 0.13260238E-06_JPRB, 0.12780509E-06_JPRB, 0.12370650E-06_JPRB, 0.12035090E-06_JPRB, 0.11769554E-06_JPRB, 0.11567241E-06_JPRB, &
  & 0.11408657E-06_JPRB, 0.11302927E-06_JPRB, 0.11187653E-06_JPRB, 0.11079324E-06_JPRB /)

RGHG3(:,12,10) = (/ &
  & 0.10391908E-06_JPRB, 0.10528036E-06_JPRB, 0.10622057E-06_JPRB, 0.10721455E-06_JPRB, 0.10832741E-06_JPRB, 0.10963218E-06_JPRB, &
  & 0.11111638E-06_JPRB, 0.11274958E-06_JPRB, 0.11449433E-06_JPRB, 0.11631933E-06_JPRB, 0.11820444E-06_JPRB, 0.12012515E-06_JPRB, &
  & 0.12206067E-06_JPRB, 0.12397334E-06_JPRB, 0.12584955E-06_JPRB, 0.12771611E-06_JPRB, 0.12956497E-06_JPRB, 0.13140418E-06_JPRB, &
  & 0.13330167E-06_JPRB, 0.13534729E-06_JPRB, 0.13763382E-06_JPRB, 0.14020445E-06_JPRB, 0.14317480E-06_JPRB, 0.14646196E-06_JPRB, &
  & 0.15003280E-06_JPRB, 0.15389480E-06_JPRB, 0.15806714E-06_JPRB, 0.16255268E-06_JPRB, 0.16742734E-06_JPRB, 0.17263089E-06_JPRB, &
  & 0.17785447E-06_JPRB, 0.18305998E-06_JPRB, 0.18800097E-06_JPRB, 0.19240592E-06_JPRB, 0.19598683E-06_JPRB, 0.19862230E-06_JPRB, &
  & 0.20032854E-06_JPRB, 0.20123814E-06_JPRB, 0.20149838E-06_JPRB, 0.20122340E-06_JPRB, 0.20046372E-06_JPRB, 0.19921559E-06_JPRB, &
  & 0.19744269E-06_JPRB, 0.19513300E-06_JPRB, 0.19230234E-06_JPRB, 0.18905547E-06_JPRB, 0.18547053E-06_JPRB, 0.18157243E-06_JPRB, &
  & 0.17735479E-06_JPRB, 0.17276984E-06_JPRB, 0.16782874E-06_JPRB, 0.16255717E-06_JPRB, 0.15710756E-06_JPRB, 0.15172073E-06_JPRB, &
  & 0.14668557E-06_JPRB, 0.14223104E-06_JPRB, 0.13845495E-06_JPRB, 0.13534709E-06_JPRB, 0.13281968E-06_JPRB, 0.13079168E-06_JPRB, &
  & 0.12923371E-06_JPRB, 0.12781535E-06_JPRB, 0.12672903E-06_JPRB, 0.12455827E-06_JPRB /)

RGHG3(:,13,10) = (/ &
  & 0.10815089E-06_JPRB, 0.11004488E-06_JPRB, 0.11144280E-06_JPRB, 0.11285276E-06_JPRB, 0.11447560E-06_JPRB, 0.11637979E-06_JPRB, &
  & 0.11858469E-06_JPRB, 0.12105772E-06_JPRB, 0.12373975E-06_JPRB, 0.12656665E-06_JPRB, 0.12948642E-06_JPRB, 0.13244650E-06_JPRB, &
  & 0.13540937E-06_JPRB, 0.13833866E-06_JPRB, 0.14115622E-06_JPRB, 0.14383937E-06_JPRB, 0.14641110E-06_JPRB, 0.14888840E-06_JPRB, &
  & 0.15131084E-06_JPRB, 0.15372466E-06_JPRB, 0.15613793E-06_JPRB, 0.15857404E-06_JPRB, 0.16105898E-06_JPRB, 0.16355082E-06_JPRB, &
  & 0.16607702E-06_JPRB, 0.16879640E-06_JPRB, 0.17182839E-06_JPRB, 0.17531413E-06_JPRB, 0.17931397E-06_JPRB, 0.18386663E-06_JPRB, &
  & 0.18897848E-06_JPRB, 0.19434201E-06_JPRB, 0.19962116E-06_JPRB, 0.20443507E-06_JPRB, 0.20849455E-06_JPRB, 0.21161313E-06_JPRB, &
  & 0.21377066E-06_JPRB, 0.21504403E-06_JPRB, 0.21557254E-06_JPRB, 0.21547582E-06_JPRB, 0.21482501E-06_JPRB, 0.21363240E-06_JPRB, &
  & 0.21189352E-06_JPRB, 0.20959966E-06_JPRB, 0.20679681E-06_JPRB, 0.20355816E-06_JPRB, 0.19997664E-06_JPRB, 0.19612959E-06_JPRB, &
  & 0.19204951E-06_JPRB, 0.18777138E-06_JPRB, 0.18330668E-06_JPRB, 0.17873191E-06_JPRB, 0.17414499E-06_JPRB, 0.16972214E-06_JPRB, &
  & 0.16563337E-06_JPRB, 0.16200194E-06_JPRB, 0.15885317E-06_JPRB, 0.15616382E-06_JPRB, 0.15384342E-06_JPRB, 0.15189462E-06_JPRB, &
  & 0.15013117E-06_JPRB, 0.14875334E-06_JPRB, 0.14698099E-06_JPRB, 0.14474125E-06_JPRB /)

RGHG3(:,14,10) = (/ &
  & 0.11353716E-06_JPRB, 0.11626834E-06_JPRB, 0.11821129E-06_JPRB, 0.12023486E-06_JPRB, 0.12251886E-06_JPRB, 0.12520186E-06_JPRB, &
  & 0.12831160E-06_JPRB, 0.13181014E-06_JPRB, 0.13560549E-06_JPRB, 0.13958783E-06_JPRB, 0.14365975E-06_JPRB, 0.14773475E-06_JPRB, &
  & 0.15175003E-06_JPRB, 0.15567288E-06_JPRB, 0.15946310E-06_JPRB, 0.16306264E-06_JPRB, 0.16647292E-06_JPRB, 0.16970183E-06_JPRB, &
  & 0.17275576E-06_JPRB, 0.17563622E-06_JPRB, 0.17829792E-06_JPRB, 0.18068786E-06_JPRB, 0.18279204E-06_JPRB, 0.18457249E-06_JPRB, &
  & 0.18607724E-06_JPRB, 0.18751344E-06_JPRB, 0.18910349E-06_JPRB, 0.19106940E-06_JPRB, 0.19374100E-06_JPRB, 0.19726615E-06_JPRB, &
  & 0.20153344E-06_JPRB, 0.20628350E-06_JPRB, 0.21120566E-06_JPRB, 0.21592180E-06_JPRB, 0.22008139E-06_JPRB, 0.22345452E-06_JPRB, &
  & 0.22591895E-06_JPRB, 0.22748809E-06_JPRB, 0.22825046E-06_JPRB, 0.22831399E-06_JPRB, 0.22775166E-06_JPRB, 0.22659336E-06_JPRB, &
  & 0.22486942E-06_JPRB, 0.22261905E-06_JPRB, 0.21990903E-06_JPRB, 0.21683579E-06_JPRB, 0.21351033E-06_JPRB, 0.21002037E-06_JPRB, &
  & 0.20643624E-06_JPRB, 0.20280542E-06_JPRB, 0.19917016E-06_JPRB, 0.19555779E-06_JPRB, 0.19202884E-06_JPRB, 0.18865936E-06_JPRB, &
  & 0.18552527E-06_JPRB, 0.18267093E-06_JPRB, 0.18010815E-06_JPRB, 0.17781338E-06_JPRB, 0.17573598E-06_JPRB, 0.17389053E-06_JPRB, &
  & 0.17217630E-06_JPRB, 0.17062882E-06_JPRB, 0.16894262E-06_JPRB, 0.16611311E-06_JPRB /)

RGHG3(:,15,10) = (/ &
  & 0.11998806E-06_JPRB, 0.12365675E-06_JPRB, 0.12631955E-06_JPRB, 0.12903951E-06_JPRB, 0.13212198E-06_JPRB, 0.13570759E-06_JPRB, &
  & 0.13984751E-06_JPRB, 0.14448932E-06_JPRB, 0.14950393E-06_JPRB, 0.15472429E-06_JPRB, 0.15998913E-06_JPRB, 0.16516526E-06_JPRB, &
  & 0.17017753E-06_JPRB, 0.17498586E-06_JPRB, 0.17958006E-06_JPRB, 0.18392657E-06_JPRB, 0.18800731E-06_JPRB, 0.19182714E-06_JPRB, &
  & 0.19536525E-06_JPRB, 0.19860205E-06_JPRB, 0.20147208E-06_JPRB, 0.20387240E-06_JPRB, 0.20572355E-06_JPRB, 0.20698552E-06_JPRB, &
  & 0.20767492E-06_JPRB, 0.20794857E-06_JPRB, 0.20808565E-06_JPRB, 0.20850791E-06_JPRB, 0.20963516E-06_JPRB, 0.21166160E-06_JPRB, &
  & 0.21460093E-06_JPRB, 0.21838771E-06_JPRB, 0.22270902E-06_JPRB, 0.22710927E-06_JPRB, 0.23117599E-06_JPRB, 0.23463508E-06_JPRB, &
  & 0.23730567E-06_JPRB, 0.23913316E-06_JPRB, 0.24014693E-06_JPRB, 0.24040884E-06_JPRB, 0.23997455E-06_JPRB, 0.23889177E-06_JPRB, &
  & 0.23722421E-06_JPRB, 0.23505250E-06_JPRB, 0.23248674E-06_JPRB, 0.22964696E-06_JPRB, 0.22665324E-06_JPRB, 0.22360511E-06_JPRB, &
  & 0.22057915E-06_JPRB, 0.21761937E-06_JPRB, 0.21472226E-06_JPRB, 0.21188910E-06_JPRB, 0.20913033E-06_JPRB, 0.20647552E-06_JPRB, &
  & 0.20395134E-06_JPRB, 0.20159092E-06_JPRB, 0.19940011E-06_JPRB, 0.19737408E-06_JPRB, 0.19549537E-06_JPRB, 0.19375088E-06_JPRB, &
  & 0.19211451E-06_JPRB, 0.19058093E-06_JPRB, 0.18878100E-06_JPRB, 0.18581618E-06_JPRB /)

RGHG3(:,16,10) = (/ &
  & 0.12743122E-06_JPRB, 0.13214802E-06_JPRB, 0.13556735E-06_JPRB, 0.13906876E-06_JPRB, 0.14299120E-06_JPRB, 0.14750664E-06_JPRB, &
  & 0.15264844E-06_JPRB, 0.15834596E-06_JPRB, 0.16443195E-06_JPRB, 0.17070329E-06_JPRB, 0.17696118E-06_JPRB, 0.18303513E-06_JPRB, &
  & 0.18881832E-06_JPRB, 0.19427276E-06_JPRB, 0.19940890E-06_JPRB, 0.20424103E-06_JPRB, 0.20874990E-06_JPRB, 0.21293778E-06_JPRB, &
  & 0.21679081E-06_JPRB, 0.22026282E-06_JPRB, 0.22328462E-06_JPRB, 0.22573093E-06_JPRB, 0.22747120E-06_JPRB, 0.22842873E-06_JPRB, &
  & 0.22859552E-06_JPRB, 0.22808591E-06_JPRB, 0.22721704E-06_JPRB, 0.22650801E-06_JPRB, 0.22633027E-06_JPRB, 0.22706938E-06_JPRB, &
  & 0.22884612E-06_JPRB, 0.23152053E-06_JPRB, 0.23490617E-06_JPRB, 0.23862560E-06_JPRB, 0.24228203E-06_JPRB, 0.24555317E-06_JPRB, &
  & 0.24822160E-06_JPRB, 0.25017908E-06_JPRB, 0.25138957E-06_JPRB, 0.25186193E-06_JPRB, 0.25162390E-06_JPRB, 0.25071640E-06_JPRB, &
  & 0.24921803E-06_JPRB, 0.24724045E-06_JPRB, 0.24491951E-06_JPRB, 0.24240177E-06_JPRB, 0.23981323E-06_JPRB, 0.23725454E-06_JPRB, &
  & 0.23478009E-06_JPRB, 0.23238785E-06_JPRB, 0.23004986E-06_JPRB, 0.22773705E-06_JPRB, 0.22543479E-06_JPRB, 0.22315032E-06_JPRB, &
  & 0.22090973E-06_JPRB, 0.21874698E-06_JPRB, 0.21669074E-06_JPRB, 0.21475353E-06_JPRB, 0.21293960E-06_JPRB, 0.21124342E-06_JPRB, &
  & 0.20961957E-06_JPRB, 0.20811829E-06_JPRB, 0.20619352E-06_JPRB, 0.20341353E-06_JPRB /)

RGHG3(:,17,10) = (/ &
  & 0.13613351E-06_JPRB, 0.14198284E-06_JPRB, 0.14614133E-06_JPRB, 0.15039031E-06_JPRB, 0.15509460E-06_JPRB, 0.16043356E-06_JPRB, &
  & 0.16641886E-06_JPRB, 0.17294543E-06_JPRB, 0.17982200E-06_JPRB, 0.18681590E-06_JPRB, 0.19369475E-06_JPRB, 0.20027507E-06_JPRB, &
  & 0.20644995E-06_JPRB, 0.21218162E-06_JPRB, 0.21748727E-06_JPRB, 0.22240961E-06_JPRB, 0.22697006E-06_JPRB, 0.23117252E-06_JPRB, &
  & 0.23502184E-06_JPRB, 0.23849236E-06_JPRB, 0.24152740E-06_JPRB, 0.24402127E-06_JPRB, 0.24583375E-06_JPRB, 0.24684928E-06_JPRB, &
  & 0.24703030E-06_JPRB, 0.24644973E-06_JPRB, 0.24535149E-06_JPRB, 0.24411725E-06_JPRB, 0.24321997E-06_JPRB, 0.24310225E-06_JPRB, &
  & 0.24382146E-06_JPRB, 0.24543593E-06_JPRB, 0.24773686E-06_JPRB, 0.25048737E-06_JPRB, 0.25340640E-06_JPRB, 0.25616657E-06_JPRB, &
  & 0.25853271E-06_JPRB, 0.26038569E-06_JPRB, 0.26164105E-06_JPRB, 0.26226297E-06_JPRB, 0.26224288E-06_JPRB, 0.26159790E-06_JPRB, &
  & 0.26039507E-06_JPRB, 0.25874598E-06_JPRB, 0.25680026E-06_JPRB, 0.25470771E-06_JPRB, 0.25259411E-06_JPRB, 0.25054086E-06_JPRB, &
  & 0.24856874E-06_JPRB, 0.24664760E-06_JPRB, 0.24472911E-06_JPRB, 0.24276508E-06_JPRB, 0.24072887E-06_JPRB, 0.23862603E-06_JPRB, &
  & 0.23648811E-06_JPRB, 0.23436850E-06_JPRB, 0.23231382E-06_JPRB, 0.23036203E-06_JPRB, 0.22852961E-06_JPRB, 0.22682006E-06_JPRB, &
  & 0.22523045E-06_JPRB, 0.22363898E-06_JPRB, 0.22189829E-06_JPRB, 0.21878652E-06_JPRB /)

RGHG3(:,18,10) = (/ &
  & 0.14672325E-06_JPRB, 0.15360540E-06_JPRB, 0.15848448E-06_JPRB, 0.16329213E-06_JPRB, 0.16859279E-06_JPRB, 0.17448266E-06_JPRB, &
  & 0.18096071E-06_JPRB, 0.18788762E-06_JPRB, 0.19504513E-06_JPRB, 0.20220800E-06_JPRB, 0.20916868E-06_JPRB, 0.21574893E-06_JPRB, &
  & 0.22185628E-06_JPRB, 0.22746326E-06_JPRB, 0.23259638E-06_JPRB, 0.23729893E-06_JPRB, 0.24162097E-06_JPRB, 0.24559466E-06_JPRB, &
  & 0.24924481E-06_JPRB, 0.25257009E-06_JPRB, 0.25553106E-06_JPRB, 0.25804945E-06_JPRB, 0.26000188E-06_JPRB, 0.26126537E-06_JPRB, &
  & 0.26176667E-06_JPRB, 0.26154831E-06_JPRB, 0.26080349E-06_JPRB, 0.25978812E-06_JPRB, 0.25885845E-06_JPRB, 0.25825224E-06_JPRB, &
  & 0.25824585E-06_JPRB, 0.25892800E-06_JPRB, 0.26023076E-06_JPRB, 0.26195244E-06_JPRB, 0.26392362E-06_JPRB, 0.26595961E-06_JPRB, &
  & 0.26783894E-06_JPRB, 0.26939824E-06_JPRB, 0.27055552E-06_JPRB, 0.27123275E-06_JPRB, 0.27139208E-06_JPRB, 0.27102175E-06_JPRB, &
  & 0.27016216E-06_JPRB, 0.26890874E-06_JPRB, 0.26739198E-06_JPRB, 0.26575344E-06_JPRB, 0.26410291E-06_JPRB, 0.26249597E-06_JPRB, &
  & 0.26093318E-06_JPRB, 0.25937484E-06_JPRB, 0.25776771E-06_JPRB, 0.25605664E-06_JPRB, 0.25421309E-06_JPRB, 0.25224105E-06_JPRB, &
  & 0.25018110E-06_JPRB, 0.24809754E-06_JPRB, 0.24605916E-06_JPRB, 0.24410932E-06_JPRB, 0.24227597E-06_JPRB, 0.24056405E-06_JPRB, &
  & 0.23896666E-06_JPRB, 0.23740225E-06_JPRB, 0.23566255E-06_JPRB, 0.23254537E-06_JPRB /)

RGHG3(:,19,10) = (/ &
  & 0.15951041E-06_JPRB, 0.16747833E-06_JPRB, 0.17266689E-06_JPRB, 0.17783779E-06_JPRB, 0.18328898E-06_JPRB, 0.18928766E-06_JPRB, &
  & 0.19574445E-06_JPRB, 0.20252652E-06_JPRB, 0.20943358E-06_JPRB, 0.21625763E-06_JPRB, 0.22281210E-06_JPRB, 0.22896685E-06_JPRB, &
  & 0.23464649E-06_JPRB, 0.23983728E-06_JPRB, 0.24456742E-06_JPRB, 0.24888573E-06_JPRB, 0.25283921E-06_JPRB, 0.25647512E-06_JPRB, &
  & 0.25983439E-06_JPRB, 0.26294430E-06_JPRB, 0.26578834E-06_JPRB, 0.26830864E-06_JPRB, 0.27040443E-06_JPRB, 0.27195912E-06_JPRB, &
  & 0.27288178E-06_JPRB, 0.27316881E-06_JPRB, 0.27292680E-06_JPRB, 0.27234717E-06_JPRB, 0.27166033E-06_JPRB, 0.27108626E-06_JPRB, &
  & 0.27080779E-06_JPRB, 0.27090044E-06_JPRB, 0.27141070E-06_JPRB, 0.27224198E-06_JPRB, 0.27330591E-06_JPRB, 0.27455118E-06_JPRB, &
  & 0.27587438E-06_JPRB, 0.27707858E-06_JPRB, 0.27805913E-06_JPRB, 0.27871732E-06_JPRB, 0.27898977E-06_JPRB, 0.27883738E-06_JPRB, &
  & 0.27828085E-06_JPRB, 0.27738113E-06_JPRB, 0.27624236E-06_JPRB, 0.27497921E-06_JPRB, 0.27368421E-06_JPRB, 0.27239969E-06_JPRB, &
  & 0.27112031E-06_JPRB, 0.26981286E-06_JPRB, 0.26842744E-06_JPRB, 0.26691754E-06_JPRB, 0.26525603E-06_JPRB, 0.26344628E-06_JPRB, &
  & 0.26152793E-06_JPRB, 0.25957013E-06_JPRB, 0.25763438E-06_JPRB, 0.25576844E-06_JPRB, 0.25400010E-06_JPRB, 0.25234229E-06_JPRB, &
  & 0.25077236E-06_JPRB, 0.24928690E-06_JPRB, 0.24752771E-06_JPRB, 0.24462071E-06_JPRB /)

RGHG3(:,20,10) = (/ &
  & 0.17439665E-06_JPRB, 0.18280291E-06_JPRB, 0.18818625E-06_JPRB, 0.19311256E-06_JPRB, 0.19834981E-06_JPRB, 0.20392673E-06_JPRB, &
  & 0.20986469E-06_JPRB, 0.21603358E-06_JPRB, 0.22226639E-06_JPRB, 0.22839188E-06_JPRB, 0.23426651E-06_JPRB, 0.23977177E-06_JPRB, &
  & 0.24485618E-06_JPRB, 0.24950791E-06_JPRB, 0.25375263E-06_JPRB, 0.25763171E-06_JPRB, 0.26119670E-06_JPRB, 0.26449590E-06_JPRB, &
  & 0.26757513E-06_JPRB, 0.27047551E-06_JPRB, 0.27320112E-06_JPRB, 0.27571033E-06_JPRB, 0.27791759E-06_JPRB, 0.27971498E-06_JPRB, &
  & 0.28100723E-06_JPRB, 0.28175720E-06_JPRB, 0.28202200E-06_JPRB, 0.28192943E-06_JPRB, 0.28162978E-06_JPRB, 0.28124518E-06_JPRB, &
  & 0.28090676E-06_JPRB, 0.28069579E-06_JPRB, 0.28067151E-06_JPRB, 0.28088022E-06_JPRB, 0.28133789E-06_JPRB, 0.28195007E-06_JPRB, &
  & 0.28271847E-06_JPRB, 0.28357999E-06_JPRB, 0.28434965E-06_JPRB, 0.28493659E-06_JPRB, 0.28524167E-06_JPRB, 0.28523161E-06_JPRB, &
  & 0.28488353E-06_JPRB, 0.28423699E-06_JPRB, 0.28336734E-06_JPRB, 0.28236269E-06_JPRB, 0.28129787E-06_JPRB, 0.28021094E-06_JPRB, &
  & 0.27910426E-06_JPRB, 0.27795349E-06_JPRB, 0.27672144E-06_JPRB, 0.27537146E-06_JPRB, 0.27388234E-06_JPRB, 0.27226213E-06_JPRB, &
  & 0.27054682E-06_JPRB, 0.26878669E-06_JPRB, 0.26703574E-06_JPRB, 0.26532788E-06_JPRB, 0.26369307E-06_JPRB, 0.26214488E-06_JPRB, &
  & 0.26070543E-06_JPRB, 0.25924081E-06_JPRB, 0.25773943E-06_JPRB, 0.25475069E-06_JPRB /)

RGHG3(:,21,10) = (/ &
  & 0.18995991E-06_JPRB, 0.19836492E-06_JPRB, 0.20337242E-06_JPRB, 0.20786293E-06_JPRB, 0.21247018E-06_JPRB, 0.21734046E-06_JPRB, &
  & 0.22246550E-06_JPRB, 0.22778019E-06_JPRB, 0.23315340E-06_JPRB, 0.23845723E-06_JPRB, 0.24356063E-06_JPRB, 0.24837595E-06_JPRB, &
  & 0.25284805E-06_JPRB, 0.25696500E-06_JPRB, 0.26074480E-06_JPRB, 0.26422305E-06_JPRB, 0.26744286E-06_JPRB, 0.27045229E-06_JPRB, &
  & 0.27329946E-06_JPRB, 0.27602363E-06_JPRB, 0.27864604E-06_JPRB, 0.28113638E-06_JPRB, 0.28342032E-06_JPRB, 0.28539037E-06_JPRB, &
  & 0.28693844E-06_JPRB, 0.28802376E-06_JPRB, 0.28867930E-06_JPRB, 0.28898032E-06_JPRB, 0.28901599E-06_JPRB, 0.28886535E-06_JPRB, &
  & 0.28860504E-06_JPRB, 0.28830715E-06_JPRB, 0.28804720E-06_JPRB, 0.28789890E-06_JPRB, 0.28795424E-06_JPRB, 0.28821842E-06_JPRB, &
  & 0.28864582E-06_JPRB, 0.28916224E-06_JPRB, 0.28971715E-06_JPRB, 0.29018474E-06_JPRB, 0.29047729E-06_JPRB, 0.29050975E-06_JPRB, &
  & 0.29027109E-06_JPRB, 0.28977334E-06_JPRB, 0.28906481E-06_JPRB, 0.28821157E-06_JPRB, 0.28727607E-06_JPRB, 0.28629762E-06_JPRB, &
  & 0.28528646E-06_JPRB, 0.28422801E-06_JPRB, 0.28309557E-06_JPRB, 0.28186625E-06_JPRB, 0.28053256E-06_JPRB, 0.27910423E-06_JPRB, &
  & 0.27760692E-06_JPRB, 0.27607780E-06_JPRB, 0.27454647E-06_JPRB, 0.27303983E-06_JPRB, 0.27157989E-06_JPRB, 0.27018288E-06_JPRB, &
  & 0.26883379E-06_JPRB, 0.26756328E-06_JPRB, 0.26598522E-06_JPRB, 0.26345151E-06_JPRB /)

RGHG3(:,22,10) = (/ &
  & 0.20490899E-06_JPRB, 0.21257608E-06_JPRB, 0.21714905E-06_JPRB, 0.22093204E-06_JPRB, 0.22486391E-06_JPRB, 0.22891436E-06_JPRB, &
  & 0.23317457E-06_JPRB, 0.23760509E-06_JPRB, 0.24212545E-06_JPRB, 0.24662620E-06_JPRB, 0.25101286E-06_JPRB, 0.25519262E-06_JPRB, &
  & 0.25911939E-06_JPRB, 0.26277024E-06_JPRB, 0.26615402E-06_JPRB, 0.26929320E-06_JPRB, 0.27223001E-06_JPRB, 0.27500707E-06_JPRB, &
  & 0.27767393E-06_JPRB, 0.28026761E-06_JPRB, 0.28280738E-06_JPRB, 0.28526952E-06_JPRB, 0.28758416E-06_JPRB, 0.28964814E-06_JPRB, &
  & 0.29136879E-06_JPRB, 0.29268261E-06_JPRB, 0.29360569E-06_JPRB, 0.29418464E-06_JPRB, 0.29447773E-06_JPRB, 0.29453869E-06_JPRB, &
  & 0.29441091E-06_JPRB, 0.29415176E-06_JPRB, 0.29383096E-06_JPRB, 0.29352546E-06_JPRB, 0.29334174E-06_JPRB, 0.29332011E-06_JPRB, &
  & 0.29350696E-06_JPRB, 0.29387834E-06_JPRB, 0.29428566E-06_JPRB, 0.29464687E-06_JPRB, 0.29487666E-06_JPRB, 0.29490880E-06_JPRB, &
  & 0.29470436E-06_JPRB, 0.29427312E-06_JPRB, 0.29364631E-06_JPRB, 0.29287057E-06_JPRB, 0.29199751E-06_JPRB, 0.29107423E-06_JPRB, &
  & 0.29011039E-06_JPRB, 0.28910154E-06_JPRB, 0.28803407E-06_JPRB, 0.28689982E-06_JPRB, 0.28570020E-06_JPRB, 0.28444694E-06_JPRB, &
  & 0.28315799E-06_JPRB, 0.28185025E-06_JPRB, 0.28054154E-06_JPRB, 0.27924165E-06_JPRB, 0.27796287E-06_JPRB, 0.27671533E-06_JPRB, &
  & 0.27552045E-06_JPRB, 0.27428194E-06_JPRB, 0.27298228E-06_JPRB, 0.27048827E-06_JPRB /)

RGHG3(:,23,10) = (/ &
  & 0.21826864E-06_JPRB, 0.22490850E-06_JPRB, 0.22881216E-06_JPRB, 0.23203742E-06_JPRB, 0.23524892E-06_JPRB, 0.23856896E-06_JPRB, &
  & 0.24205900E-06_JPRB, 0.24570957E-06_JPRB, 0.24947315E-06_JPRB, 0.25328134E-06_JPRB, 0.25704455E-06_JPRB, 0.26069159E-06_JPRB, &
  & 0.26416700E-06_JPRB, 0.26744411E-06_JPRB, 0.27051740E-06_JPRB, 0.27339803E-06_JPRB, 0.27611745E-06_JPRB, 0.27871300E-06_JPRB, &
  & 0.28123719E-06_JPRB, 0.28371767E-06_JPRB, 0.28617393E-06_JPRB, 0.28859472E-06_JPRB, 0.29090018E-06_JPRB, 0.29300611E-06_JPRB, &
  & 0.29480543E-06_JPRB, 0.29624900E-06_JPRB, 0.29734005E-06_JPRB, 0.29810570E-06_JPRB, 0.29858845E-06_JPRB, 0.29882426E-06_JPRB, &
  & 0.29884453E-06_JPRB, 0.29868832E-06_JPRB, 0.29841857E-06_JPRB, 0.29810599E-06_JPRB, 0.29786850E-06_JPRB, 0.29775904E-06_JPRB, &
  & 0.29780293E-06_JPRB, 0.29798454E-06_JPRB, 0.29822809E-06_JPRB, 0.29846765E-06_JPRB, 0.29861008E-06_JPRB, 0.29859805E-06_JPRB, &
  & 0.29839129E-06_JPRB, 0.29797411E-06_JPRB, 0.29736961E-06_JPRB, 0.29662630E-06_JPRB, 0.29578271E-06_JPRB, 0.29488274E-06_JPRB, &
  & 0.29394289E-06_JPRB, 0.29296334E-06_JPRB, 0.29194058E-06_JPRB, 0.29087994E-06_JPRB, 0.28979190E-06_JPRB, 0.28868863E-06_JPRB, &
  & 0.28757714E-06_JPRB, 0.28646235E-06_JPRB, 0.28534527E-06_JPRB, 0.28422784E-06_JPRB, 0.28311666E-06_JPRB, 0.28201828E-06_JPRB, &
  & 0.28093098E-06_JPRB, 0.27986113E-06_JPRB, 0.27857442E-06_JPRB, 0.27635903E-06_JPRB /)

RGHG3(:,24,10) = (/ &
  & 0.22966321E-06_JPRB, 0.23540014E-06_JPRB, 0.23856433E-06_JPRB, 0.24124631E-06_JPRB, 0.24386347E-06_JPRB, 0.24657601E-06_JPRB, &
  & 0.24943117E-06_JPRB, 0.25244751E-06_JPRB, 0.25559510E-06_JPRB, 0.25882869E-06_JPRB, 0.26208579E-06_JPRB, 0.26529773E-06_JPRB, &
  & 0.26841411E-06_JPRB, 0.27139887E-06_JPRB, 0.27423735E-06_JPRB, 0.27692570E-06_JPRB, 0.27948531E-06_JPRB, 0.28194222E-06_JPRB, &
  & 0.28434627E-06_JPRB, 0.28672935E-06_JPRB, 0.28910014E-06_JPRB, 0.29144110E-06_JPRB, 0.29369502E-06_JPRB, 0.29577075E-06_JPRB, &
  & 0.29757811E-06_JPRB, 0.29906943E-06_JPRB, 0.30024648E-06_JPRB, 0.30113245E-06_JPRB, 0.30175244E-06_JPRB, 0.30213212E-06_JPRB, &
  & 0.30229199E-06_JPRB, 0.30226076E-06_JPRB, 0.30209151E-06_JPRB, 0.30185149E-06_JPRB, 0.30161812E-06_JPRB, 0.30145554E-06_JPRB, &
  & 0.30142522E-06_JPRB, 0.30149707E-06_JPRB, 0.30162232E-06_JPRB, 0.30173814E-06_JPRB, 0.30178398E-06_JPRB, 0.30169792E-06_JPRB, &
  & 0.30145301E-06_JPRB, 0.30102777E-06_JPRB, 0.30042554E-06_JPRB, 0.29968720E-06_JPRB, 0.29885328E-06_JPRB, 0.29796260E-06_JPRB, &
  & 0.29703014E-06_JPRB, 0.29606821E-06_JPRB, 0.29508220E-06_JPRB, 0.29408602E-06_JPRB, 0.29309413E-06_JPRB, 0.29211441E-06_JPRB, &
  & 0.29114710E-06_JPRB, 0.29018784E-06_JPRB, 0.28922872E-06_JPRB, 0.28826403E-06_JPRB, 0.28729278E-06_JPRB, 0.28631990E-06_JPRB, &
  & 0.28535479E-06_JPRB, 0.28435750E-06_JPRB, 0.28322623E-06_JPRB, 0.28119982E-06_JPRB /)

RGHG3(:,25,10) = (/ &
  & 0.23931560E-06_JPRB, 0.24413617E-06_JPRB, 0.24680509E-06_JPRB, 0.24899441E-06_JPRB, 0.25112729E-06_JPRB, 0.25334873E-06_JPRB, &
  & 0.25570304E-06_JPRB, 0.25821129E-06_JPRB, 0.26086863E-06_JPRB, 0.26364137E-06_JPRB, 0.26648814E-06_JPRB, 0.26935086E-06_JPRB, &
  & 0.27218059E-06_JPRB, 0.27493886E-06_JPRB, 0.27759785E-06_JPRB, 0.28014588E-06_JPRB, 0.28258512E-06_JPRB, 0.28493460E-06_JPRB, &
  & 0.28723446E-06_JPRB, 0.28950740E-06_JPRB, 0.29177292E-06_JPRB, 0.29400542E-06_JPRB, 0.29616245E-06_JPRB, 0.29816070E-06_JPRB, &
  & 0.29992927E-06_JPRB, 0.30142400E-06_JPRB, 0.30263877E-06_JPRB, 0.30357970E-06_JPRB, 0.30427697E-06_JPRB, 0.30475201E-06_JPRB, &
  & 0.30502378E-06_JPRB, 0.30511220E-06_JPRB, 0.30505726E-06_JPRB, 0.30491421E-06_JPRB, 0.30473853E-06_JPRB, 0.30459208E-06_JPRB, &
  & 0.30451434E-06_JPRB, 0.30449050E-06_JPRB, 0.30451332E-06_JPRB, 0.30452040E-06_JPRB, 0.30446623E-06_JPRB, 0.30429976E-06_JPRB, &
  & 0.30399698E-06_JPRB, 0.30354465E-06_JPRB, 0.30293691E-06_JPRB, 0.30220153E-06_JPRB, 0.30137437E-06_JPRB, 0.30049344E-06_JPRB, &
  & 0.29957715E-06_JPRB, 0.29863594E-06_JPRB, 0.29768276E-06_JPRB, 0.29674007E-06_JPRB, 0.29582446E-06_JPRB, 0.29494055E-06_JPRB, &
  & 0.29408386E-06_JPRB, 0.29324417E-06_JPRB, 0.29241107E-06_JPRB, 0.29157130E-06_JPRB, 0.29072078E-06_JPRB, 0.28986094E-06_JPRB, &
  & 0.28899763E-06_JPRB, 0.28810908E-06_JPRB, 0.28710002E-06_JPRB, 0.28522669E-06_JPRB /)

RGHG3(:,26,10) = (/ &
  & 0.24753857E-06_JPRB, 0.25172017E-06_JPRB, 0.25388331E-06_JPRB, 0.25569284E-06_JPRB, 0.25745035E-06_JPRB, 0.25927639E-06_JPRB, &
  & 0.26123692E-06_JPRB, 0.26334899E-06_JPRB, 0.26561068E-06_JPRB, 0.26801709E-06_JPRB, 0.27052900E-06_JPRB, 0.27310637E-06_JPRB, &
  & 0.27570127E-06_JPRB, 0.27827292E-06_JPRB, 0.28078725E-06_JPRB, 0.28321884E-06_JPRB, 0.28556502E-06_JPRB, 0.28782185E-06_JPRB, &
  & 0.29001785E-06_JPRB, 0.29217662E-06_JPRB, 0.29431317E-06_JPRB, 0.29641404E-06_JPRB, 0.29843679E-06_JPRB, 0.30031805E-06_JPRB, &
  & 0.30200439E-06_JPRB, 0.30344481E-06_JPRB, 0.30463789E-06_JPRB, 0.30559559E-06_JPRB, 0.30633342E-06_JPRB, 0.30686965E-06_JPRB, &
  & 0.30722194E-06_JPRB, 0.30740975E-06_JPRB, 0.30746000E-06_JPRB, 0.30741370E-06_JPRB, 0.30731604E-06_JPRB, 0.30720065E-06_JPRB, &
  & 0.30709566E-06_JPRB, 0.30701725E-06_JPRB, 0.30694798E-06_JPRB, 0.30685752E-06_JPRB, 0.30671293E-06_JPRB, 0.30647632E-06_JPRB, &
  & 0.30612270E-06_JPRB, 0.30563956E-06_JPRB, 0.30502062E-06_JPRB, 0.30428512E-06_JPRB, 0.30346206E-06_JPRB, 0.30258332E-06_JPRB, &
  & 0.30167359E-06_JPRB, 0.30075313E-06_JPRB, 0.29984122E-06_JPRB, 0.29895682E-06_JPRB, 0.29811116E-06_JPRB, 0.29730555E-06_JPRB, &
  & 0.29653378E-06_JPRB, 0.29578564E-06_JPRB, 0.29504562E-06_JPRB, 0.29430180E-06_JPRB, 0.29354825E-06_JPRB, 0.29278644E-06_JPRB, &
  & 0.29201698E-06_JPRB, 0.29123575E-06_JPRB, 0.29029749E-06_JPRB, 0.28871287E-06_JPRB /)

RGHG3(:,27,10) = (/ &
  & 0.25473270E-06_JPRB, 0.25833572E-06_JPRB, 0.26019327E-06_JPRB, 0.26169278E-06_JPRB, 0.26313921E-06_JPRB, 0.26466461E-06_JPRB, &
  & 0.26630761E-06_JPRB, 0.26810071E-06_JPRB, 0.27005422E-06_JPRB, 0.27215546E-06_JPRB, 0.27439398E-06_JPRB, 0.27672800E-06_JPRB, &
  & 0.27912009E-06_JPRB, 0.28152829E-06_JPRB, 0.28391065E-06_JPRB, 0.28624353E-06_JPRB, 0.28848663E-06_JPRB, 0.29065501E-06_JPRB, &
  & 0.29274375E-06_JPRB, 0.29478792E-06_JPRB, 0.29677605E-06_JPRB, 0.29872282E-06_JPRB, 0.30058482E-06_JPRB, 0.30231936E-06_JPRB, &
  & 0.30388117E-06_JPRB, 0.30522975E-06_JPRB, 0.30636662E-06_JPRB, 0.30729680E-06_JPRB, 0.30803955E-06_JPRB, 0.30860753E-06_JPRB, &
  & 0.30901393E-06_JPRB, 0.30927475E-06_JPRB, 0.30940970E-06_JPRB, 0.30944540E-06_JPRB, 0.30941297E-06_JPRB, 0.30933657E-06_JPRB, &
  & 0.30923107E-06_JPRB, 0.30911102E-06_JPRB, 0.30897385E-06_JPRB, 0.30880469E-06_JPRB, 0.30858411E-06_JPRB, 0.30828767E-06_JPRB, &
  & 0.30789380E-06_JPRB, 0.30738741E-06_JPRB, 0.30676313E-06_JPRB, 0.30603127E-06_JPRB, 0.30522136E-06_JPRB, 0.30436561E-06_JPRB, &
  & 0.30348713E-06_JPRB, 0.30259724E-06_JPRB, 0.30171697E-06_JPRB, 0.30087273E-06_JPRB, 0.30007737E-06_JPRB, 0.29932937E-06_JPRB, &
  & 0.29862159E-06_JPRB, 0.29793964E-06_JPRB, 0.29726962E-06_JPRB, 0.29659952E-06_JPRB, 0.29592422E-06_JPRB, 0.29524671E-06_JPRB, &
  & 0.29457252E-06_JPRB, 0.29386817E-06_JPRB, 0.29310027E-06_JPRB, 0.29164724E-06_JPRB /)

RGHG3(:,28,10) = (/ &
  & 0.26113605E-06_JPRB, 0.26432735E-06_JPRB, 0.26590291E-06_JPRB, 0.26716904E-06_JPRB, 0.26839302E-06_JPRB, 0.26966859E-06_JPRB, &
  & 0.27106910E-06_JPRB, 0.27261206E-06_JPRB, 0.27430832E-06_JPRB, 0.27616872E-06_JPRB, 0.27817191E-06_JPRB, 0.28029660E-06_JPRB, &
  & 0.28250531E-06_JPRB, 0.28475714E-06_JPRB, 0.28701535E-06_JPRB, 0.28923174E-06_JPRB, 0.29136885E-06_JPRB, 0.29343920E-06_JPRB, &
  & 0.29541397E-06_JPRB, 0.29732672E-06_JPRB, 0.29916285E-06_JPRB, 0.30094060E-06_JPRB, 0.30263038E-06_JPRB, 0.30419884E-06_JPRB, &
  & 0.30561057E-06_JPRB, 0.30684177E-06_JPRB, 0.30788829E-06_JPRB, 0.30876902E-06_JPRB, 0.30949050E-06_JPRB, 0.31006317E-06_JPRB, &
  & 0.31049714E-06_JPRB, 0.31080421E-06_JPRB, 0.31099813E-06_JPRB, 0.31109442E-06_JPRB, 0.31111219E-06_JPRB, 0.31106612E-06_JPRB, &
  & 0.31096567E-06_JPRB, 0.31082260E-06_JPRB, 0.31064027E-06_JPRB, 0.31041654E-06_JPRB, 0.31014054E-06_JPRB, 0.30979908E-06_JPRB, &
  & 0.30937409E-06_JPRB, 0.30885337E-06_JPRB, 0.30822824E-06_JPRB, 0.30750539E-06_JPRB, 0.30671015E-06_JPRB, 0.30586884E-06_JPRB, &
  & 0.30500428E-06_JPRB, 0.30413742E-06_JPRB, 0.30330193E-06_JPRB, 0.30251309E-06_JPRB, 0.30177191E-06_JPRB, 0.30107813E-06_JPRB, &
  & 0.30042298E-06_JPRB, 0.29979617E-06_JPRB, 0.29918459E-06_JPRB, 0.29857790E-06_JPRB, 0.29797243E-06_JPRB, 0.29736546E-06_JPRB, &
  & 0.29675485E-06_JPRB, 0.29614617E-06_JPRB, 0.29541681E-06_JPRB, 0.29421261E-06_JPRB /)

RGHG3(:,29,10) = (/ &
  & 0.26694801E-06_JPRB, 0.26977025E-06_JPRB, 0.27116116E-06_JPRB, 0.27225173E-06_JPRB, 0.27328522E-06_JPRB, 0.27438230E-06_JPRB, &
  & 0.27558147E-06_JPRB, 0.27692224E-06_JPRB, 0.27841932E-06_JPRB, 0.28007088E-06_JPRB, 0.28187867E-06_JPRB, 0.28381584E-06_JPRB, &
  & 0.28585387E-06_JPRB, 0.28795253E-06_JPRB, 0.29008163E-06_JPRB, 0.29215838E-06_JPRB, 0.29419226E-06_JPRB, 0.29614142E-06_JPRB, &
  & 0.29799355E-06_JPRB, 0.29976380E-06_JPRB, 0.30144764E-06_JPRB, 0.30305307E-06_JPRB, 0.30456710E-06_JPRB, 0.30596581E-06_JPRB, &
  & 0.30722043E-06_JPRB, 0.30832010E-06_JPRB, 0.30926853E-06_JPRB, 0.31007585E-06_JPRB, 0.31075297E-06_JPRB, 0.31130665E-06_JPRB, &
  & 0.31174397E-06_JPRB, 0.31207244E-06_JPRB, 0.31230030E-06_JPRB, 0.31243542E-06_JPRB, 0.31248726E-06_JPRB, 0.31246392E-06_JPRB, &
  & 0.31236962E-06_JPRB, 0.31221509E-06_JPRB, 0.31200642E-06_JPRB, 0.31174955E-06_JPRB, 0.31143904E-06_JPRB, 0.31106936E-06_JPRB, &
  & 0.31062854E-06_JPRB, 0.31010185E-06_JPRB, 0.30948522E-06_JPRB, 0.30877752E-06_JPRB, 0.30800018E-06_JPRB, 0.30718010E-06_JPRB, &
  & 0.30634072E-06_JPRB, 0.30551502E-06_JPRB, 0.30472441E-06_JPRB, 0.30397626E-06_JPRB, 0.30327647E-06_JPRB, 0.30262370E-06_JPRB, &
  & 0.30201113E-06_JPRB, 0.30142843E-06_JPRB, 0.30086284E-06_JPRB, 0.30030535E-06_JPRB, 0.29974743E-06_JPRB, 0.29919036E-06_JPRB, &
  & 0.29864157E-06_JPRB, 0.29807634E-06_JPRB, 0.29746641E-06_JPRB, 0.29636561E-06_JPRB /)

RGHG3(:,30,10) = (/ &
  & 0.27224431E-06_JPRB, 0.27480584E-06_JPRB, 0.27602360E-06_JPRB, 0.27696984E-06_JPRB, 0.27786808E-06_JPRB, 0.27880702E-06_JPRB, &
  & 0.27985385E-06_JPRB, 0.28103165E-06_JPRB, 0.28235527E-06_JPRB, 0.28383914E-06_JPRB, 0.28547194E-06_JPRB, 0.28724074E-06_JPRB, &
  & 0.28911609E-06_JPRB, 0.29106539E-06_JPRB, 0.29304636E-06_JPRB, 0.29498761E-06_JPRB, 0.29689190E-06_JPRB, 0.29871364E-06_JPRB, &
  & 0.30043464E-06_JPRB, 0.30206019E-06_JPRB, 0.30359271E-06_JPRB, 0.30503421E-06_JPRB, 0.30637867E-06_JPRB, 0.30761095E-06_JPRB, &
  & 0.30871200E-06_JPRB, 0.30967868E-06_JPRB, 0.31051877E-06_JPRB, 0.31124503E-06_JPRB, 0.31186548E-06_JPRB, 0.31238415E-06_JPRB, &
  & 0.31280663E-06_JPRB, 0.31313610E-06_JPRB, 0.31337720E-06_JPRB, 0.31353167E-06_JPRB, 0.31360295E-06_JPRB, 0.31359423E-06_JPRB, &
  & 0.31350638E-06_JPRB, 0.31334940E-06_JPRB, 0.31312823E-06_JPRB, 0.31285546E-06_JPRB, 0.31252756E-06_JPRB, 0.31214540E-06_JPRB, &
  & 0.31170023E-06_JPRB, 0.31118029E-06_JPRB, 0.31057718E-06_JPRB, 0.30989219E-06_JPRB, 0.30914052E-06_JPRB, 0.30834872E-06_JPRB, &
  & 0.30754782E-06_JPRB, 0.30676443E-06_JPRB, 0.30601018E-06_JPRB, 0.30529614E-06_JPRB, 0.30463053E-06_JPRB, 0.30401316E-06_JPRB, &
  & 0.30343469E-06_JPRB, 0.30288459E-06_JPRB, 0.30235248E-06_JPRB, 0.30182682E-06_JPRB, 0.30130593E-06_JPRB, 0.30079164E-06_JPRB, &
  & 0.30028423E-06_JPRB, 0.29978278E-06_JPRB, 0.29920034E-06_JPRB, 0.29823266E-06_JPRB /)

RGHG3(:,31,10) = (/ &
  & 0.27711576E-06_JPRB, 0.27941431E-06_JPRB, 0.28050806E-06_JPRB, 0.28134235E-06_JPRB, 0.28211883E-06_JPRB, 0.28294582E-06_JPRB, &
  & 0.28386151E-06_JPRB, 0.28490294E-06_JPRB, 0.28608679E-06_JPRB, 0.28741621E-06_JPRB, 0.28889596E-06_JPRB, 0.29050776E-06_JPRB, &
  & 0.29222585E-06_JPRB, 0.29402355E-06_JPRB, 0.29585027E-06_JPRB, 0.29765329E-06_JPRB, 0.29941651E-06_JPRB, 0.30110149E-06_JPRB, &
  & 0.30268910E-06_JPRB, 0.30417698E-06_JPRB, 0.30556589E-06_JPRB, 0.30685655E-06_JPRB, 0.30804532E-06_JPRB, 0.30912383E-06_JPRB, &
  & 0.31008341E-06_JPRB, 0.31092347E-06_JPRB, 0.31165894E-06_JPRB, 0.31229945E-06_JPRB, 0.31285515E-06_JPRB, 0.31332863E-06_JPRB, &
  & 0.31372272E-06_JPRB, 0.31403835E-06_JPRB, 0.31427626E-06_JPRB, 0.31443503E-06_JPRB, 0.31451373E-06_JPRB, 0.31451216E-06_JPRB, &
  & 0.31443037E-06_JPRB, 0.31427601E-06_JPRB, 0.31405312E-06_JPRB, 0.31377681E-06_JPRB, 0.31344547E-06_JPRB, 0.31306215E-06_JPRB, &
  & 0.31262311E-06_JPRB, 0.31211536E-06_JPRB, 0.31153206E-06_JPRB, 0.31087188E-06_JPRB, 0.31014793E-06_JPRB, 0.30938764E-06_JPRB, &
  & 0.30862196E-06_JPRB, 0.30787177E-06_JPRB, 0.30715239E-06_JPRB, 0.30647990E-06_JPRB, 0.30585704E-06_JPRB, 0.30527542E-06_JPRB, &
  & 0.30472702E-06_JPRB, 0.30420324E-06_JPRB, 0.30369446E-06_JPRB, 0.30319612E-06_JPRB, 0.30270613E-06_JPRB, 0.30222409E-06_JPRB, &
  & 0.30175198E-06_JPRB, 0.30127131E-06_JPRB, 0.30075020E-06_JPRB, 0.29984358E-06_JPRB /)

RGHG3(:,32,10) = (/ &
  & 0.28155301E-06_JPRB, 0.28363229E-06_JPRB, 0.28460514E-06_JPRB, 0.28534052E-06_JPRB, 0.28603631E-06_JPRB, 0.28676089E-06_JPRB, &
  & 0.28757751E-06_JPRB, 0.28850656E-06_JPRB, 0.28956296E-06_JPRB, 0.29076099E-06_JPRB, 0.29209536E-06_JPRB, 0.29355664E-06_JPRB, &
  & 0.29512159E-06_JPRB, 0.29676417E-06_JPRB, 0.29843505E-06_JPRB, 0.30009821E-06_JPRB, 0.30171972E-06_JPRB, 0.30326962E-06_JPRB, &
  & 0.30472734E-06_JPRB, 0.30608879E-06_JPRB, 0.30734614E-06_JPRB, 0.30850140E-06_JPRB, 0.30955380E-06_JPRB, 0.31049774E-06_JPRB, &
  & 0.31133050E-06_JPRB, 0.31205732E-06_JPRB, 0.31269269E-06_JPRB, 0.31325135E-06_JPRB, 0.31374037E-06_JPRB, 0.31416315E-06_JPRB, &
  & 0.31452055E-06_JPRB, 0.31481127E-06_JPRB, 0.31503413E-06_JPRB, 0.31518553E-06_JPRB, 0.31526289E-06_JPRB, 0.31526326E-06_JPRB, &
  & 0.31518675E-06_JPRB, 0.31503777E-06_JPRB, 0.31482091E-06_JPRB, 0.31454951E-06_JPRB, 0.31422420E-06_JPRB, 0.31384883E-06_JPRB, &
  & 0.31341975E-06_JPRB, 0.31293052E-06_JPRB, 0.31236894E-06_JPRB, 0.31173752E-06_JPRB, 0.31105074E-06_JPRB, 0.31033244E-06_JPRB, &
  & 0.30960877E-06_JPRB, 0.30889888E-06_JPRB, 0.30822153E-06_JPRB, 0.30758713E-06_JPRB, 0.30699502E-06_JPRB, 0.30644100E-06_JPRB, &
  & 0.30591696E-06_JPRB, 0.30541418E-06_JPRB, 0.30492862E-06_JPRB, 0.30445335E-06_JPRB, 0.30398482E-06_JPRB, 0.30352413E-06_JPRB, &
  & 0.30307308E-06_JPRB, 0.30262996E-06_JPRB, 0.30212664E-06_JPRB, 0.30128686E-06_JPRB /)

RGHG3(:,33,10) = (/ &
  & 0.28556246E-06_JPRB, 0.28742292E-06_JPRB, 0.28829490E-06_JPRB, 0.28896511E-06_JPRB, 0.28957982E-06_JPRB, 0.29024014E-06_JPRB, &
  & 0.29097146E-06_JPRB, 0.29180597E-06_JPRB, 0.29275742E-06_JPRB, 0.29383042E-06_JPRB, 0.29503090E-06_JPRB, 0.29634677E-06_JPRB, &
  & 0.29776010E-06_JPRB, 0.29924604E-06_JPRB, 0.30076720E-06_JPRB, 0.30228523E-06_JPRB, 0.30377197E-06_JPRB, 0.30519229E-06_JPRB, &
  & 0.30653197E-06_JPRB, 0.30777619E-06_JPRB, 0.30892141E-06_JPRB, 0.30996429E-06_JPRB, 0.31090107E-06_JPRB, 0.31173249E-06_JPRB, &
  & 0.31245739E-06_JPRB, 0.31308548E-06_JPRB, 0.31363254E-06_JPRB, 0.31411230E-06_JPRB, 0.31453555E-06_JPRB, 0.31490453E-06_JPRB, &
  & 0.31521932E-06_JPRB, 0.31547779E-06_JPRB, 0.31567717E-06_JPRB, 0.31581351E-06_JPRB, 0.31588320E-06_JPRB, 0.31588195E-06_JPRB, &
  & 0.31581001E-06_JPRB, 0.31566901E-06_JPRB, 0.31546301E-06_JPRB, 0.31520278E-06_JPRB, 0.31489031E-06_JPRB, 0.31452717E-06_JPRB, &
  & 0.31411352E-06_JPRB, 0.31364357E-06_JPRB, 0.31310682E-06_JPRB, 0.31250778E-06_JPRB, 0.31186019E-06_JPRB, 0.31118427E-06_JPRB, &
  & 0.31050362E-06_JPRB, 0.30983810E-06_JPRB, 0.30920356E-06_JPRB, 0.30860699E-06_JPRB, 0.30804904E-06_JPRB, 0.30752298E-06_JPRB, &
  & 0.30702347E-06_JPRB, 0.30654388E-06_JPRB, 0.30607555E-06_JPRB, 0.30561475E-06_JPRB, 0.30516142E-06_JPRB, 0.30471915E-06_JPRB, &
  & 0.30429248E-06_JPRB, 0.30386497E-06_JPRB, 0.30339791E-06_JPRB, 0.30259704E-06_JPRB /)

RGHG3(:,34,10) = (/ &
  & 0.28913126E-06_JPRB, 0.29079422E-06_JPRB, 0.29158576E-06_JPRB, 0.29218481E-06_JPRB, 0.29276060E-06_JPRB, 0.29335558E-06_JPRB, &
  & 0.29402565E-06_JPRB, 0.29478281E-06_JPRB, 0.29563768E-06_JPRB, 0.29660302E-06_JPRB, 0.29767597E-06_JPRB, 0.29885314E-06_JPRB, &
  & 0.30011995E-06_JPRB, 0.30145495E-06_JPRB, 0.30282882E-06_JPRB, 0.30421018E-06_JPRB, 0.30556694E-06_JPRB, 0.30687082E-06_JPRB, &
  & 0.30810304E-06_JPRB, 0.30924900E-06_JPRB, 0.31030015E-06_JPRB, 0.31125120E-06_JPRB, 0.31209586E-06_JPRB, 0.31283446E-06_JPRB, &
  & 0.31347108E-06_JPRB, 0.31401450E-06_JPRB, 0.31448323E-06_JPRB, 0.31489193E-06_JPRB, 0.31525110E-06_JPRB, 0.31556505E-06_JPRB, &
  & 0.31583360E-06_JPRB, 0.31605447E-06_JPRB, 0.31622466E-06_JPRB, 0.31634067E-06_JPRB, 0.31639851E-06_JPRB, 0.31639411E-06_JPRB, &
  & 0.31632709E-06_JPRB, 0.31619615E-06_JPRB, 0.31600453E-06_JPRB, 0.31576030E-06_JPRB, 0.31546392E-06_JPRB, 0.31511675E-06_JPRB, &
  & 0.31472163E-06_JPRB, 0.31427103E-06_JPRB, 0.31376021E-06_JPRB, 0.31319564E-06_JPRB, 0.31258836E-06_JPRB, 0.31195742E-06_JPRB, &
  & 0.31132410E-06_JPRB, 0.31070311E-06_JPRB, 0.31010910E-06_JPRB, 0.30955101E-06_JPRB, 0.30902595E-06_JPRB, 0.30853101E-06_JPRB, &
  & 0.30805700E-06_JPRB, 0.30759674E-06_JPRB, 0.30714406E-06_JPRB, 0.30669864E-06_JPRB, 0.30626117E-06_JPRB, 0.30583567E-06_JPRB, &
  & 0.30542421E-06_JPRB, 0.30502156E-06_JPRB, 0.30457298E-06_JPRB, 0.30381494E-06_JPRB /)

RGHG3(:,35,10) = (/ &
  & 0.29226891E-06_JPRB, 0.29375940E-06_JPRB, 0.29447310E-06_JPRB, 0.29503718E-06_JPRB, 0.29555832E-06_JPRB, 0.29611977E-06_JPRB, &
  & 0.29673362E-06_JPRB, 0.29742426E-06_JPRB, 0.29820015E-06_JPRB, 0.29906417E-06_JPRB, 0.30002340E-06_JPRB, 0.30107077E-06_JPRB, &
  & 0.30219965E-06_JPRB, 0.30339186E-06_JPRB, 0.30462823E-06_JPRB, 0.30587913E-06_JPRB, 0.30711743E-06_JPRB, 0.30831649E-06_JPRB, &
  & 0.30945711E-06_JPRB, 0.31052153E-06_JPRB, 0.31149798E-06_JPRB, 0.31237570E-06_JPRB, 0.31314966E-06_JPRB, 0.31381711E-06_JPRB, &
  & 0.31438083E-06_JPRB, 0.31485388E-06_JPRB, 0.31525249E-06_JPRB, 0.31559486E-06_JPRB, 0.31589227E-06_JPRB, 0.31615053E-06_JPRB, &
  & 0.31637040E-06_JPRB, 0.31655068E-06_JPRB, 0.31668861E-06_JPRB, 0.31678147E-06_JPRB, 0.31682532E-06_JPRB, 0.31681742E-06_JPRB, &
  & 0.31675620E-06_JPRB, 0.31663780E-06_JPRB, 0.31646420E-06_JPRB, 0.31623901E-06_JPRB, 0.31596122E-06_JPRB, 0.31563422E-06_JPRB, &
  & 0.31525735E-06_JPRB, 0.31482662E-06_JPRB, 0.31434197E-06_JPRB, 0.31381086E-06_JPRB, 0.31324367E-06_JPRB, 0.31265742E-06_JPRB, &
  & 0.31206963E-06_JPRB, 0.31149446E-06_JPRB, 0.31094135E-06_JPRB, 0.31041998E-06_JPRB, 0.30992896E-06_JPRB, 0.30946296E-06_JPRB, &
  & 0.30901330E-06_JPRB, 0.30857632E-06_JPRB, 0.30814431E-06_JPRB, 0.30771571E-06_JPRB, 0.30729319E-06_JPRB, 0.30688176E-06_JPRB, &
  & 0.30648755E-06_JPRB, 0.30609880E-06_JPRB, 0.30567261E-06_JPRB, 0.30494917E-06_JPRB /)

RGHG3(:,36,10) = (/ &
  & 0.29502752E-06_JPRB, 0.29635555E-06_JPRB, 0.29701209E-06_JPRB, 0.29752397E-06_JPRB, 0.29802402E-06_JPRB, 0.29854166E-06_JPRB, &
  & 0.29911524E-06_JPRB, 0.29974959E-06_JPRB, 0.30045172E-06_JPRB, 0.30123061E-06_JPRB, 0.30208449E-06_JPRB, 0.30301439E-06_JPRB, &
  & 0.30401441E-06_JPRB, 0.30507607E-06_JPRB, 0.30618247E-06_JPRB, 0.30731582E-06_JPRB, 0.30844330E-06_JPRB, 0.30955096E-06_JPRB, &
  & 0.31061026E-06_JPRB, 0.31160999E-06_JPRB, 0.31253074E-06_JPRB, 0.31335813E-06_JPRB, 0.31407885E-06_JPRB, 0.31469008E-06_JPRB, &
  & 0.31519320E-06_JPRB, 0.31560160E-06_JPRB, 0.31593657E-06_JPRB, 0.31621622E-06_JPRB, 0.31645436E-06_JPRB, 0.31665769E-06_JPRB, &
  & 0.31682927E-06_JPRB, 0.31696780E-06_JPRB, 0.31707262E-06_JPRB, 0.31714143E-06_JPRB, 0.31717133E-06_JPRB, 0.31716095E-06_JPRB, &
  & 0.31710704E-06_JPRB, 0.31700463E-06_JPRB, 0.31685332E-06_JPRB, 0.31665107E-06_JPRB, 0.31639675E-06_JPRB, 0.31609088E-06_JPRB, &
  & 0.31573319E-06_JPRB, 0.31532213E-06_JPRB, 0.31486260E-06_JPRB, 0.31436434E-06_JPRB, 0.31383644E-06_JPRB, 0.31329276E-06_JPRB, &
  & 0.31274797E-06_JPRB, 0.31221396E-06_JPRB, 0.31169810E-06_JPRB, 0.31121166E-06_JPRB, 0.31075277E-06_JPRB, 0.31031826E-06_JPRB, &
  & 0.30989736E-06_JPRB, 0.30948610E-06_JPRB, 0.30907728E-06_JPRB, 0.30866696E-06_JPRB, 0.30826070E-06_JPRB, 0.30786495E-06_JPRB, &
  & 0.30748498E-06_JPRB, 0.30711394E-06_JPRB, 0.30670631E-06_JPRB, 0.30601197E-06_JPRB /)

RGHG3(:,37,10) = (/ &
  & 0.29747360E-06_JPRB, 0.29864421E-06_JPRB, 0.29923595E-06_JPRB, 0.29971864E-06_JPRB, 0.30018174E-06_JPRB, 0.30067650E-06_JPRB, &
  & 0.30120918E-06_JPRB, 0.30179348E-06_JPRB, 0.30243370E-06_JPRB, 0.30313254E-06_JPRB, 0.30389327E-06_JPRB, 0.30471375E-06_JPRB, &
  & 0.30559588E-06_JPRB, 0.30653550E-06_JPRB, 0.30752429E-06_JPRB, 0.30854699E-06_JPRB, 0.30958054E-06_JPRB, 0.31059946E-06_JPRB, &
  & 0.31159286E-06_JPRB, 0.31253788E-06_JPRB, 0.31341639E-06_JPRB, 0.31420436E-06_JPRB, 0.31488261E-06_JPRB, 0.31544010E-06_JPRB, &
  & 0.31588297E-06_JPRB, 0.31622915E-06_JPRB, 0.31650231E-06_JPRB, 0.31672332E-06_JPRB, 0.31690664E-06_JPRB, 0.31706003E-06_JPRB, &
  & 0.31718642E-06_JPRB, 0.31728740E-06_JPRB, 0.31736221E-06_JPRB, 0.31740967E-06_JPRB, 0.31742792E-06_JPRB, 0.31741692E-06_JPRB, &
  & 0.31737241E-06_JPRB, 0.31729016E-06_JPRB, 0.31716593E-06_JPRB, 0.31699437E-06_JPRB, 0.31677070E-06_JPRB, 0.31649213E-06_JPRB, &
  & 0.31615693E-06_JPRB, 0.31576758E-06_JPRB, 0.31533432E-06_JPRB, 0.31486607E-06_JPRB, 0.31437392E-06_JPRB, 0.31386966E-06_JPRB, &
  & 0.31336307E-06_JPRB, 0.31286504E-06_JPRB, 0.31238409E-06_JPRB, 0.31192877E-06_JPRB, 0.31150248E-06_JPRB, 0.31109874E-06_JPRB, &
  & 0.31070897E-06_JPRB, 0.31032670E-06_JPRB, 0.30994519E-06_JPRB, 0.30955852E-06_JPRB, 0.30917224E-06_JPRB, 0.30879340E-06_JPRB, &
  & 0.30842858E-06_JPRB, 0.30807129E-06_JPRB, 0.30767734E-06_JPRB, 0.30701059E-06_JPRB /)

RGHG3(:,38,10) = (/ &
  & 0.29967293E-06_JPRB, 0.30068753E-06_JPRB, 0.30121552E-06_JPRB, 0.30165739E-06_JPRB, 0.30209893E-06_JPRB, 0.30256339E-06_JPRB, &
  & 0.30306467E-06_JPRB, 0.30360354E-06_JPRB, 0.30418485E-06_JPRB, 0.30481146E-06_JPRB, 0.30548435E-06_JPRB, 0.30620410E-06_JPRB, &
  & 0.30697544E-06_JPRB, 0.30780296E-06_JPRB, 0.30868398E-06_JPRB, 0.30960496E-06_JPRB, 0.31055367E-06_JPRB, 0.31150088E-06_JPRB, &
  & 0.31243064E-06_JPRB, 0.31332445E-06_JPRB, 0.31416027E-06_JPRB, 0.31490450E-06_JPRB, 0.31552938E-06_JPRB, 0.31602607E-06_JPRB, &
  & 0.31640343E-06_JPRB, 0.31668688E-06_JPRB, 0.31690323E-06_JPRB, 0.31707373E-06_JPRB, 0.31721208E-06_JPRB, 0.31732577E-06_JPRB, &
  & 0.31741862E-06_JPRB, 0.31749153E-06_JPRB, 0.31754496E-06_JPRB, 0.31757756E-06_JPRB, 0.31758864E-06_JPRB, 0.31757864E-06_JPRB, &
  & 0.31754374E-06_JPRB, 0.31748118E-06_JPRB, 0.31738571E-06_JPRB, 0.31724954E-06_JPRB, 0.31706534E-06_JPRB, 0.31682430E-06_JPRB, &
  & 0.31652198E-06_JPRB, 0.31616332E-06_JPRB, 0.31575800E-06_JPRB, 0.31532085E-06_JPRB, 0.31486275E-06_JPRB, 0.31439362E-06_JPRB, &
  & 0.31392062E-06_JPRB, 0.31345371E-06_JPRB, 0.31300206E-06_JPRB, 0.31257588E-06_JPRB, 0.31217931E-06_JPRB, 0.31180718E-06_JPRB, &
  & 0.31145123E-06_JPRB, 0.31110190E-06_JPRB, 0.31075257E-06_JPRB, 0.31039431E-06_JPRB, 0.31003154E-06_JPRB, 0.30967169E-06_JPRB, &
  & 0.30932239E-06_JPRB, 0.30897826E-06_JPRB, 0.30860045E-06_JPRB, 0.30795101E-06_JPRB /)

RGHG3(:,39,10) = (/ &
  & 0.30166382E-06_JPRB, 0.30252340E-06_JPRB, 0.30298835E-06_JPRB, 0.30339618E-06_JPRB, 0.30380971E-06_JPRB, 0.30425230E-06_JPRB, &
  & 0.30472205E-06_JPRB, 0.30521909E-06_JPRB, 0.30574489E-06_JPRB, 0.30630264E-06_JPRB, 0.30689242E-06_JPRB, 0.30751730E-06_JPRB, &
  & 0.30818649E-06_JPRB, 0.30890925E-06_JPRB, 0.30969133E-06_JPRB, 0.31052267E-06_JPRB, 0.31138580E-06_JPRB, 0.31226639E-06_JPRB, &
  & 0.31313903E-06_JPRB, 0.31398420E-06_JPRB, 0.31476691E-06_JPRB, 0.31545287E-06_JPRB, 0.31601044E-06_JPRB, 0.31643606E-06_JPRB, &
  & 0.31674915E-06_JPRB, 0.31697755E-06_JPRB, 0.31714896E-06_JPRB, 0.31728231E-06_JPRB, 0.31738966E-06_JPRB, 0.31747777E-06_JPRB, &
  & 0.31754931E-06_JPRB, 0.31760553E-06_JPRB, 0.31764628E-06_JPRB, 0.31767030E-06_JPRB, 0.31767766E-06_JPRB, 0.31766882E-06_JPRB, &
  & 0.31764114E-06_JPRB, 0.31759325E-06_JPRB, 0.31752026E-06_JPRB, 0.31741558E-06_JPRB, 0.31726984E-06_JPRB, 0.31707225E-06_JPRB, &
  & 0.31681515E-06_JPRB, 0.31649836E-06_JPRB, 0.31613132E-06_JPRB, 0.31572802E-06_JPRB, 0.31530351E-06_JPRB, 0.31486687E-06_JPRB, &
  & 0.31442491E-06_JPRB, 0.31398494E-06_JPRB, 0.31355904E-06_JPRB, 0.31315926E-06_JPRB, 0.31279035E-06_JPRB, 0.31245008E-06_JPRB, &
  & 0.31212795E-06_JPRB, 0.31181497E-06_JPRB, 0.31149975E-06_JPRB, 0.31117423E-06_JPRB, 0.31083843E-06_JPRB, 0.31050095E-06_JPRB, &
  & 0.31016853E-06_JPRB, 0.30983995E-06_JPRB, 0.30947251E-06_JPRB, 0.30884493E-06_JPRB /)

RGHG3(:,40,10) = (/ &
  & 0.30346544E-06_JPRB, 0.30418209E-06_JPRB, 0.30459157E-06_JPRB, 0.30496187E-06_JPRB, 0.30535239E-06_JPRB, 0.30577283E-06_JPRB, &
  & 0.30621436E-06_JPRB, 0.30667115E-06_JPRB, 0.30714421E-06_JPRB, 0.30763479E-06_JPRB, 0.30814647E-06_JPRB, 0.30868341E-06_JPRB, &
  & 0.30925821E-06_JPRB, 0.30988616E-06_JPRB, 0.31057604E-06_JPRB, 0.31132498E-06_JPRB, 0.31211593E-06_JPRB, 0.31292700E-06_JPRB, &
  & 0.31374088E-06_JPRB, 0.31452757E-06_JPRB, 0.31525101E-06_JPRB, 0.31586524E-06_JPRB, 0.31634929E-06_JPRB, 0.31670899E-06_JPRB, &
  & 0.31696777E-06_JPRB, 0.31715516E-06_JPRB, 0.31729496E-06_JPRB, 0.31740382E-06_JPRB, 0.31749147E-06_JPRB, 0.31756386E-06_JPRB, &
  & 0.31762298E-06_JPRB, 0.31766947E-06_JPRB, 0.31770335E-06_JPRB, 0.31772254E-06_JPRB, 0.31772805E-06_JPRB, 0.31771992E-06_JPRB, &
  & 0.31769676E-06_JPRB, 0.31765822E-06_JPRB, 0.31760050E-06_JPRB, 0.31751821E-06_JPRB, 0.31740348E-06_JPRB, 0.31724525E-06_JPRB, &
  & 0.31703533E-06_JPRB, 0.31676851E-06_JPRB, 0.31644788E-06_JPRB, 0.31608508E-06_JPRB, 0.31569684E-06_JPRB, 0.31529277E-06_JPRB, &
  & 0.31487895E-06_JPRB, 0.31446484E-06_JPRB, 0.31406159E-06_JPRB, 0.31368472E-06_JPRB, 0.31334307E-06_JPRB, 0.31303290E-06_JPRB, &
  & 0.31274570E-06_JPRB, 0.31246759E-06_JPRB, 0.31218798E-06_JPRB, 0.31189592E-06_JPRB, 0.31159072E-06_JPRB, 0.31127794E-06_JPRB, &
  & 0.31096729E-06_JPRB, 0.31065431E-06_JPRB, 0.31030581E-06_JPRB, 0.30969522E-06_JPRB /)

RGHG3(:,41,10) = (/ &
  & 0.30508386E-06_JPRB, 0.30568833E-06_JPRB, 0.30604400E-06_JPRB, 0.30638290E-06_JPRB, 0.30675142E-06_JPRB, 0.30715202E-06_JPRB, &
  & 0.30756792E-06_JPRB, 0.30798620E-06_JPRB, 0.30840783E-06_JPRB, 0.30883626E-06_JPRB, 0.30927444E-06_JPRB, 0.30973075E-06_JPRB, &
  & 0.31022054E-06_JPRB, 0.31076200E-06_JPRB, 0.31136827E-06_JPRB, 0.31203820E-06_JPRB, 0.31275687E-06_JPRB, 0.31350470E-06_JPRB, &
  & 0.31425640E-06_JPRB, 0.31498234E-06_JPRB, 0.31563471E-06_JPRB, 0.31617625E-06_JPRB, 0.31659113E-06_JPRB, 0.31689464E-06_JPRB, &
  & 0.31711224E-06_JPRB, 0.31726978E-06_JPRB, 0.31738801E-06_JPRB, 0.31748030E-06_JPRB, 0.31755528E-06_JPRB, 0.31761749E-06_JPRB, &
  & 0.31766896E-06_JPRB, 0.31770963E-06_JPRB, 0.31773914E-06_JPRB, 0.31775539E-06_JPRB, 0.31775983E-06_JPRB, 0.31775213E-06_JPRB, &
  & 0.31773203E-06_JPRB, 0.31769949E-06_JPRB, 0.31765168E-06_JPRB, 0.31758515E-06_JPRB, 0.31749283E-06_JPRB, 0.31736644E-06_JPRB, &
  & 0.31719770E-06_JPRB, 0.31697928E-06_JPRB, 0.31670805E-06_JPRB, 0.31639306E-06_JPRB, 0.31604247E-06_JPRB, 0.31567185E-06_JPRB, &
  & 0.31528788E-06_JPRB, 0.31489739E-06_JPRB, 0.31451572E-06_JPRB, 0.31416235E-06_JPRB, 0.31384539E-06_JPRB, 0.31356541E-06_JPRB, &
  & 0.31330973E-06_JPRB, 0.31306604E-06_JPRB, 0.31281991E-06_JPRB, 0.31256150E-06_JPRB, 0.31228709E-06_JPRB, 0.31200295E-06_JPRB, &
  & 0.31171578E-06_JPRB, 0.31142679E-06_JPRB, 0.31109653E-06_JPRB, 0.31051664E-06_JPRB /)

RGHG3(:,42,10) = (/ &
  & 0.30654087E-06_JPRB, 0.30705365E-06_JPRB, 0.30736828E-06_JPRB, 0.30767924E-06_JPRB, 0.30802946E-06_JPRB, 0.30841554E-06_JPRB, &
  & 0.30880651E-06_JPRB, 0.30918937E-06_JPRB, 0.30956301E-06_JPRB, 0.30993249E-06_JPRB, 0.31030427E-06_JPRB, 0.31068788E-06_JPRB, &
  & 0.31110102E-06_JPRB, 0.31156443E-06_JPRB, 0.31209396E-06_JPRB, 0.31269093E-06_JPRB, 0.31334145E-06_JPRB, 0.31402340E-06_JPRB, &
  & 0.31471268E-06_JPRB, 0.31537058E-06_JPRB, 0.31595172E-06_JPRB, 0.31641932E-06_JPRB, 0.31677251E-06_JPRB, 0.31702956E-06_JPRB, &
  & 0.31721467E-06_JPRB, 0.31735021E-06_JPRB, 0.31745282E-06_JPRB, 0.31753359E-06_JPRB, 0.31759973E-06_JPRB, 0.31765509E-06_JPRB, &
  & 0.31770128E-06_JPRB, 0.31773800E-06_JPRB, 0.31776466E-06_JPRB, 0.31777896E-06_JPRB, 0.31778262E-06_JPRB, 0.31777509E-06_JPRB, &
  & 0.31775704E-06_JPRB, 0.31772842E-06_JPRB, 0.31768781E-06_JPRB, 0.31763238E-06_JPRB, 0.31755687E-06_JPRB, 0.31745481E-06_JPRB, &
  & 0.31731969E-06_JPRB, 0.31714336E-06_JPRB, 0.31692230E-06_JPRB, 0.31665246E-06_JPRB, 0.31634539E-06_JPRB, 0.31600848E-06_JPRB, &
  & 0.31565338E-06_JPRB, 0.31528916E-06_JPRB, 0.31493070E-06_JPRB, 0.31459933E-06_JPRB, 0.31430909E-06_JPRB, 0.31405688E-06_JPRB, &
  & 0.31383175E-06_JPRB, 0.31361884E-06_JPRB, 0.31340420E-06_JPRB, 0.31317705E-06_JPRB, 0.31293388E-06_JPRB, 0.31267916E-06_JPRB, &
  & 0.31242183E-06_JPRB, 0.31215865E-06_JPRB, 0.31185940E-06_JPRB, 0.31131972E-06_JPRB /)

RGHG3(:,43,10) = (/ &
  & 0.30785657E-06_JPRB, 0.30830145E-06_JPRB, 0.30858266E-06_JPRB, 0.30887216E-06_JPRB, 0.30920984E-06_JPRB, 0.30958208E-06_JPRB, &
  & 0.30995324E-06_JPRB, 0.31030243E-06_JPRB, 0.31063195E-06_JPRB, 0.31094896E-06_JPRB, 0.31126058E-06_JPRB, 0.31157981E-06_JPRB, &
  & 0.31192499E-06_JPRB, 0.31231744E-06_JPRB, 0.31277600E-06_JPRB, 0.31330427E-06_JPRB, 0.31388760E-06_JPRB, 0.31450571E-06_JPRB, &
  & 0.31512863E-06_JPRB, 0.31571582E-06_JPRB, 0.31621903E-06_JPRB, 0.31661759E-06_JPRB, 0.31691508E-06_JPRB, 0.31713313E-06_JPRB, &
  & 0.31729243E-06_JPRB, 0.31741067E-06_JPRB, 0.31750147E-06_JPRB, 0.31757381E-06_JPRB, 0.31763346E-06_JPRB, 0.31768388E-06_JPRB, &
  & 0.31772626E-06_JPRB, 0.31776017E-06_JPRB, 0.31778478E-06_JPRB, 0.31779749E-06_JPRB, 0.31780053E-06_JPRB, 0.31779314E-06_JPRB, &
  & 0.31777643E-06_JPRB, 0.31775090E-06_JPRB, 0.31771540E-06_JPRB, 0.31766828E-06_JPRB, 0.31760547E-06_JPRB, 0.31752248E-06_JPRB, &
  & 0.31741394E-06_JPRB, 0.31727416E-06_JPRB, 0.31709530E-06_JPRB, 0.31687398E-06_JPRB, 0.31660647E-06_JPRB, 0.31630663E-06_JPRB, &
  & 0.31598273E-06_JPRB, 0.31564548E-06_JPRB, 0.31531266E-06_JPRB, 0.31500736E-06_JPRB, 0.31474286E-06_JPRB, 0.31451810E-06_JPRB, &
  & 0.31432131E-06_JPRB, 0.31413634E-06_JPRB, 0.31395035E-06_JPRB, 0.31375257E-06_JPRB, 0.31353946E-06_JPRB, 0.31331595E-06_JPRB, &
  & 0.31308957E-06_JPRB, 0.31286072E-06_JPRB, 0.31259756E-06_JPRB, 0.31211837E-06_JPRB /)

RGHG3(:,44,10) = (/ &
  & 0.30906151E-06_JPRB, 0.30945534E-06_JPRB, 0.30971142E-06_JPRB, 0.30998410E-06_JPRB, 0.31030990E-06_JPRB, 0.31067466E-06_JPRB, &
  & 0.31102510E-06_JPRB, 0.31134448E-06_JPRB, 0.31163438E-06_JPRB, 0.31190322E-06_JPRB, 0.31216294E-06_JPRB, 0.31242558E-06_JPRB, &
  & 0.31270949E-06_JPRB, 0.31303955E-06_JPRB, 0.31343265E-06_JPRB, 0.31389550E-06_JPRB, 0.31441570E-06_JPRB, 0.31496668E-06_JPRB, &
  & 0.31551866E-06_JPRB, 0.31602497E-06_JPRB, 0.31645087E-06_JPRB, 0.31678155E-06_JPRB, 0.31703087E-06_JPRB, 0.31721572E-06_JPRB, &
  & 0.31735379E-06_JPRB, 0.31745827E-06_JPRB, 0.31753990E-06_JPRB, 0.31760578E-06_JPRB, 0.31766075E-06_JPRB, 0.31770750E-06_JPRB, &
  & 0.31774698E-06_JPRB, 0.31777867E-06_JPRB, 0.31780161E-06_JPRB, 0.31781317E-06_JPRB, 0.31781559E-06_JPRB, 0.31780829E-06_JPRB, &
  & 0.31779268E-06_JPRB, 0.31776926E-06_JPRB, 0.31773777E-06_JPRB, 0.31769699E-06_JPRB, 0.31764404E-06_JPRB, 0.31757591E-06_JPRB, &
  & 0.31748883E-06_JPRB, 0.31737832E-06_JPRB, 0.31723866E-06_JPRB, 0.31705872E-06_JPRB, 0.31683652E-06_JPRB, 0.31657237E-06_JPRB, &
  & 0.31628019E-06_JPRB, 0.31597295E-06_JPRB, 0.31566901E-06_JPRB, 0.31539122E-06_JPRB, 0.31515455E-06_JPRB, 0.31495739E-06_JPRB, &
  & 0.31478612E-06_JPRB, 0.31462741E-06_JPRB, 0.31446737E-06_JPRB, 0.31429676E-06_JPRB, 0.31411284E-06_JPRB, 0.31391997E-06_JPRB, &
  & 0.31372772E-06_JPRB, 0.31353463E-06_JPRB, 0.31331405E-06_JPRB, 0.31291131E-06_JPRB /)

RGHG3(:,45,10) = (/ &
  & 0.31018277E-06_JPRB, 0.31053932E-06_JPRB, 0.31077556E-06_JPRB, 0.31103127E-06_JPRB, 0.31135153E-06_JPRB, 0.31170367E-06_JPRB, &
  & 0.31203817E-06_JPRB, 0.31232790E-06_JPRB, 0.31258011E-06_JPRB, 0.31280803E-06_JPRB, 0.31302093E-06_JPRB, 0.31323407E-06_JPRB, &
  & 0.31346752E-06_JPRB, 0.31373830E-06_JPRB, 0.31407279E-06_JPRB, 0.31447541E-06_JPRB, 0.31493067E-06_JPRB, 0.31541413E-06_JPRB, &
  & 0.31588326E-06_JPRB, 0.31630461E-06_JPRB, 0.31664862E-06_JPRB, 0.31691934E-06_JPRB, 0.31712545E-06_JPRB, 0.31728294E-06_JPRB, &
  & 0.31740336E-06_JPRB, 0.31749681E-06_JPRB, 0.31757119E-06_JPRB, 0.31763221E-06_JPRB, 0.31768352E-06_JPRB, 0.31772754E-06_JPRB, &
  & 0.31776489E-06_JPRB, 0.31779490E-06_JPRB, 0.31781636E-06_JPRB, 0.31782702E-06_JPRB, 0.31782875E-06_JPRB, 0.31782145E-06_JPRB, &
  & 0.31780664E-06_JPRB, 0.31778492E-06_JPRB, 0.31775642E-06_JPRB, 0.31772052E-06_JPRB, 0.31767536E-06_JPRB, 0.31761880E-06_JPRB, &
  & 0.31754874E-06_JPRB, 0.31746271E-06_JPRB, 0.31735428E-06_JPRB, 0.31721584E-06_JPRB, 0.31703482E-06_JPRB, 0.31681088E-06_JPRB, &
  & 0.31655267E-06_JPRB, 0.31627599E-06_JPRB, 0.31600212E-06_JPRB, 0.31575581E-06_JPRB, 0.31554779E-06_JPRB, 0.31537718E-06_JPRB, &
  & 0.31523160E-06_JPRB, 0.31509637E-06_JPRB, 0.31496069E-06_JPRB, 0.31481591E-06_JPRB, 0.31465930E-06_JPRB, 0.31449713E-06_JPRB, &
  & 0.31433731E-06_JPRB, 0.31417983E-06_JPRB, 0.31400273E-06_JPRB, 0.31367955E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART20',0,ZHOOK_HANDLE)



RGHG3(:,46,10) = (/ &
  & 0.31124307E-06_JPRB, 0.31157379E-06_JPRB, 0.31179209E-06_JPRB, 0.31203913E-06_JPRB, 0.31234251E-06_JPRB, 0.31269030E-06_JPRB, &
  & 0.31300064E-06_JPRB, 0.31326172E-06_JPRB, 0.31347963E-06_JPRB, 0.31366696E-06_JPRB, 0.31383991E-06_JPRB, 0.31401174E-06_JPRB, &
  & 0.31419685E-06_JPRB, 0.31442153E-06_JPRB, 0.31469955E-06_JPRB, 0.31504302E-06_JPRB, 0.31543658E-06_JPRB, 0.31583923E-06_JPRB, &
  & 0.31622096E-06_JPRB, 0.31654807E-06_JPRB, 0.31681884E-06_JPRB, 0.31703325E-06_JPRB, 0.31720393E-06_JPRB, 0.31733802E-06_JPRB, &
  & 0.31744406E-06_JPRB, 0.31752853E-06_JPRB, 0.31759726E-06_JPRB, 0.31765444E-06_JPRB, 0.31770315E-06_JPRB, 0.31774510E-06_JPRB, &
  & 0.31778075E-06_JPRB, 0.31780934E-06_JPRB, 0.31782957E-06_JPRB, 0.31783935E-06_JPRB, 0.31784049E-06_JPRB, 0.31783318E-06_JPRB, &
  & 0.31781894E-06_JPRB, 0.31779859E-06_JPRB, 0.31777239E-06_JPRB, 0.31774027E-06_JPRB, 0.31770116E-06_JPRB, 0.31765384E-06_JPRB, &
  & 0.31759714E-06_JPRB, 0.31752978E-06_JPRB, 0.31744821E-06_JPRB, 0.31734371E-06_JPRB, 0.31720501E-06_JPRB, 0.31702359E-06_JPRB, &
  & 0.31680133E-06_JPRB, 0.31655790E-06_JPRB, 0.31631683E-06_JPRB, 0.31610003E-06_JPRB, 0.31592316E-06_JPRB, 0.31577875E-06_JPRB, &
  & 0.31565659E-06_JPRB, 0.31554399E-06_JPRB, 0.31543067E-06_JPRB, 0.31530968E-06_JPRB, 0.31517928E-06_JPRB, 0.31504487E-06_JPRB, &
  & 0.31491487E-06_JPRB, 0.31478928E-06_JPRB, 0.31464964E-06_JPRB, 0.31439990E-06_JPRB /)

RGHG3(:,47,10) = (/ &
  & 0.31226472E-06_JPRB, 0.31257477E-06_JPRB, 0.31278501E-06_JPRB, 0.31301323E-06_JPRB, 0.31331371E-06_JPRB, 0.31363541E-06_JPRB, &
  & 0.31392619E-06_JPRB, 0.31415371E-06_JPRB, 0.31433436E-06_JPRB, 0.31448644E-06_JPRB, 0.31462181E-06_JPRB, 0.31475514E-06_JPRB, &
  & 0.31490350E-06_JPRB, 0.31508000E-06_JPRB, 0.31531019E-06_JPRB, 0.31559611E-06_JPRB, 0.31591514E-06_JPRB, 0.31623361E-06_JPRB, &
  & 0.31651533E-06_JPRB, 0.31675796E-06_JPRB, 0.31695916E-06_JPRB, 0.31712861E-06_JPRB, 0.31726839E-06_JPRB, 0.31738364E-06_JPRB, &
  & 0.31747783E-06_JPRB, 0.31755502E-06_JPRB, 0.31761923E-06_JPRB, 0.31767360E-06_JPRB, 0.31772026E-06_JPRB, 0.31776065E-06_JPRB, &
  & 0.31779496E-06_JPRB, 0.31782236E-06_JPRB, 0.31784151E-06_JPRB, 0.31785055E-06_JPRB, 0.31785103E-06_JPRB, 0.31784379E-06_JPRB, &
  & 0.31782992E-06_JPRB, 0.31781059E-06_JPRB, 0.31778620E-06_JPRB, 0.31775707E-06_JPRB, 0.31772262E-06_JPRB, 0.31768238E-06_JPRB, &
  & 0.31763605E-06_JPRB, 0.31758339E-06_JPRB, 0.31752185E-06_JPRB, 0.31744571E-06_JPRB, 0.31734484E-06_JPRB, 0.31720575E-06_JPRB, &
  & 0.31702811E-06_JPRB, 0.31682060E-06_JPRB, 0.31661207E-06_JPRB, 0.31642853E-06_JPRB, 0.31627783E-06_JPRB, 0.31615892E-06_JPRB, &
  & 0.31605830E-06_JPRB, 0.31596565E-06_JPRB, 0.31587268E-06_JPRB, 0.31577275E-06_JPRB, 0.31566540E-06_JPRB, 0.31555547E-06_JPRB, &
  & 0.31545079E-06_JPRB, 0.31535097E-06_JPRB, 0.31524235E-06_JPRB, 0.31505016E-06_JPRB /)

RGHG3(:,48,10) = (/ &
  & 0.31325621E-06_JPRB, 0.31355893E-06_JPRB, 0.31375623E-06_JPRB, 0.31398011E-06_JPRB, 0.31425361E-06_JPRB, 0.31456287E-06_JPRB, &
  & 0.31481659E-06_JPRB, 0.31500895E-06_JPRB, 0.31515316E-06_JPRB, 0.31526753E-06_JPRB, 0.31536860E-06_JPRB, 0.31546782E-06_JPRB, &
  & 0.31557695E-06_JPRB, 0.31571489E-06_JPRB, 0.31589104E-06_JPRB, 0.31611228E-06_JPRB, 0.31635005E-06_JPRB, 0.31656987E-06_JPRB, &
  & 0.31676248E-06_JPRB, 0.31692781E-06_JPRB, 0.31707538E-06_JPRB, 0.31720609E-06_JPRB, 0.31732182E-06_JPRB, 0.31742147E-06_JPRB, &
  & 0.31750611E-06_JPRB, 0.31757759E-06_JPRB, 0.31763835E-06_JPRB, 0.31769048E-06_JPRB, 0.31773570E-06_JPRB, 0.31777489E-06_JPRB, &
  & 0.31780812E-06_JPRB, 0.31783432E-06_JPRB, 0.31785243E-06_JPRB, 0.31786078E-06_JPRB, 0.31786075E-06_JPRB, 0.31785351E-06_JPRB, &
  & 0.31783989E-06_JPRB, 0.31782133E-06_JPRB, 0.31779825E-06_JPRB, 0.31777134E-06_JPRB, 0.31774050E-06_JPRB, 0.31770574E-06_JPRB, &
  & 0.31766737E-06_JPRB, 0.31762553E-06_JPRB, 0.31757915E-06_JPRB, 0.31752450E-06_JPRB, 0.31745321E-06_JPRB, 0.31735610E-06_JPRB, &
  & 0.31722274E-06_JPRB, 0.31706182E-06_JPRB, 0.31689095E-06_JPRB, 0.31673758E-06_JPRB, 0.31661477E-06_JPRB, 0.31651652E-06_JPRB, &
  & 0.31643455E-06_JPRB, 0.31635901E-06_JPRB, 0.31628272E-06_JPRB, 0.31620090E-06_JPRB, 0.31611251E-06_JPRB, 0.31602298E-06_JPRB, &
  & 0.31593828E-06_JPRB, 0.31585873E-06_JPRB, 0.31577272E-06_JPRB, 0.31562286E-06_JPRB /)

RGHG3(:,49,10) = (/ &
  & 0.31421575E-06_JPRB, 0.31450782E-06_JPRB, 0.31470080E-06_JPRB, 0.31490694E-06_JPRB, 0.31516748E-06_JPRB, 0.31543874E-06_JPRB, &
  & 0.31565901E-06_JPRB, 0.31580984E-06_JPRB, 0.31591520E-06_JPRB, 0.31599504E-06_JPRB, 0.31606200E-06_JPRB, 0.31612765E-06_JPRB, &
  & 0.31620183E-06_JPRB, 0.31629278E-06_JPRB, 0.31641483E-06_JPRB, 0.31655725E-06_JPRB, 0.31670461E-06_JPRB, 0.31683740E-06_JPRB, &
  & 0.31695424E-06_JPRB, 0.31706315E-06_JPRB, 0.31716786E-06_JPRB, 0.31726984E-06_JPRB, 0.31736573E-06_JPRB, 0.31745321E-06_JPRB, &
  & 0.31753038E-06_JPRB, 0.31759743E-06_JPRB, 0.31765549E-06_JPRB, 0.31770597E-06_JPRB, 0.31774991E-06_JPRB, 0.31778796E-06_JPRB, &
  & 0.31782020E-06_JPRB, 0.31784538E-06_JPRB, 0.31786249E-06_JPRB, 0.31787019E-06_JPRB, 0.31786965E-06_JPRB, 0.31786229E-06_JPRB, &
  & 0.31784901E-06_JPRB, 0.31783094E-06_JPRB, 0.31780905E-06_JPRB, 0.31778387E-06_JPRB, 0.31775582E-06_JPRB, 0.31772518E-06_JPRB, &
  & 0.31769270E-06_JPRB, 0.31765873E-06_JPRB, 0.31762329E-06_JPRB, 0.31758344E-06_JPRB, 0.31753487E-06_JPRB, 0.31746924E-06_JPRB, &
  & 0.31738088E-06_JPRB, 0.31726748E-06_JPRB, 0.31714421E-06_JPRB, 0.31702697E-06_JPRB, 0.31692969E-06_JPRB, 0.31685124E-06_JPRB, &
  & 0.31678485E-06_JPRB, 0.31672323E-06_JPRB, 0.31666067E-06_JPRB, 0.31659312E-06_JPRB, 0.31652024E-06_JPRB, 0.31644646E-06_JPRB, &
  & 0.31637731E-06_JPRB, 0.31631265E-06_JPRB, 0.31624273E-06_JPRB, 0.31612265E-06_JPRB /)

RGHG3(:,50,10) = (/ &
  & 0.31509725E-06_JPRB, 0.31537203E-06_JPRB, 0.31554612E-06_JPRB, 0.31573200E-06_JPRB, 0.31595880E-06_JPRB, 0.31619152E-06_JPRB, &
  & 0.31636287E-06_JPRB, 0.31647221E-06_JPRB, 0.31654181E-06_JPRB, 0.31659022E-06_JPRB, 0.31662958E-06_JPRB, 0.31666644E-06_JPRB, &
  & 0.31670677E-06_JPRB, 0.31675739E-06_JPRB, 0.31681824E-06_JPRB, 0.31689189E-06_JPRB, 0.31696410E-06_JPRB, 0.31703237E-06_JPRB, &
  & 0.31709826E-06_JPRB, 0.31716718E-06_JPRB, 0.31724187E-06_JPRB, 0.31732145E-06_JPRB, 0.31740228E-06_JPRB, 0.31748002E-06_JPRB, &
  & 0.31755155E-06_JPRB, 0.31761527E-06_JPRB, 0.31767138E-06_JPRB, 0.31772043E-06_JPRB, 0.31776318E-06_JPRB, 0.31780013E-06_JPRB, &
  & 0.31783142E-06_JPRB, 0.31785555E-06_JPRB, 0.31787172E-06_JPRB, 0.31787883E-06_JPRB, 0.31787792E-06_JPRB, 0.31787044E-06_JPRB, &
  & 0.31785743E-06_JPRB, 0.31783983E-06_JPRB, 0.31781883E-06_JPRB, 0.31779513E-06_JPRB, 0.31776912E-06_JPRB, 0.31774155E-06_JPRB, &
  & 0.31771333E-06_JPRB, 0.31768536E-06_JPRB, 0.31765728E-06_JPRB, 0.31762812E-06_JPRB, 0.31759433E-06_JPRB, 0.31755181E-06_JPRB, &
  & 0.31749639E-06_JPRB, 0.31742823E-06_JPRB, 0.31735073E-06_JPRB, 0.31727566E-06_JPRB, 0.31720862E-06_JPRB, 0.31715214E-06_JPRB, &
  & 0.31710186E-06_JPRB, 0.31705412E-06_JPRB, 0.31700466E-06_JPRB, 0.31694975E-06_JPRB, 0.31689029E-06_JPRB, 0.31682956E-06_JPRB, &
  & 0.31677283E-06_JPRB, 0.31671865E-06_JPRB, 0.31666087E-06_JPRB, 0.31655870E-06_JPRB /)

RGHG3(:,51,10) = (/ &
  & 0.31584284E-06_JPRB, 0.31606876E-06_JPRB, 0.31620951E-06_JPRB, 0.31635946E-06_JPRB, 0.31653968E-06_JPRB, 0.31671894E-06_JPRB, &
  & 0.31684203E-06_JPRB, 0.31691289E-06_JPRB, 0.31695470E-06_JPRB, 0.31698261E-06_JPRB, 0.31700313E-06_JPRB, 0.31702152E-06_JPRB, &
  & 0.31703999E-06_JPRB, 0.31706026E-06_JPRB, 0.31708512E-06_JPRB, 0.31711164E-06_JPRB, 0.31714049E-06_JPRB, 0.31717036E-06_JPRB, &
  & 0.31720506E-06_JPRB, 0.31724798E-06_JPRB, 0.31730139E-06_JPRB, 0.31736428E-06_JPRB, 0.31743329E-06_JPRB, 0.31750341E-06_JPRB, &
  & 0.31757045E-06_JPRB, 0.31763167E-06_JPRB, 0.31768619E-06_JPRB, 0.31773396E-06_JPRB, 0.31777569E-06_JPRB, 0.31781167E-06_JPRB, &
  & 0.31784185E-06_JPRB, 0.31786507E-06_JPRB, 0.31788034E-06_JPRB, 0.31788690E-06_JPRB, 0.31788565E-06_JPRB, 0.31787815E-06_JPRB, &
  & 0.31786533E-06_JPRB, 0.31784819E-06_JPRB, 0.31782798E-06_JPRB, 0.31780536E-06_JPRB, 0.31778100E-06_JPRB, 0.31775554E-06_JPRB, &
  & 0.31773064E-06_JPRB, 0.31770659E-06_JPRB, 0.31768428E-06_JPRB, 0.31766203E-06_JPRB, 0.31763847E-06_JPRB, 0.31761095E-06_JPRB, &
  & 0.31757816E-06_JPRB, 0.31754030E-06_JPRB, 0.31750002E-06_JPRB, 0.31746001E-06_JPRB, 0.31742394E-06_JPRB, 0.31739100E-06_JPRB, &
  & 0.31736084E-06_JPRB, 0.31733006E-06_JPRB, 0.31729593E-06_JPRB, 0.31725699E-06_JPRB, 0.31721208E-06_JPRB, 0.31716584E-06_JPRB, &
  & 0.31712068E-06_JPRB, 0.31707768E-06_JPRB, 0.31702768E-06_JPRB, 0.31694179E-06_JPRB /)

RGHG3(:,52,10) = (/ &
  & 0.31644191E-06_JPRB, 0.31657788E-06_JPRB, 0.31667065E-06_JPRB, 0.31677786E-06_JPRB, 0.31691275E-06_JPRB, 0.31704081E-06_JPRB, &
  & 0.31712221E-06_JPRB, 0.31716641E-06_JPRB, 0.31719128E-06_JPRB, 0.31720651E-06_JPRB, 0.31721765E-06_JPRB, 0.31722630E-06_JPRB, &
  & 0.31723377E-06_JPRB, 0.31724065E-06_JPRB, 0.31724659E-06_JPRB, 0.31725261E-06_JPRB, 0.31725924E-06_JPRB, 0.31726921E-06_JPRB, &
  & 0.31728564E-06_JPRB, 0.31731193E-06_JPRB, 0.31735019E-06_JPRB, 0.31740072E-06_JPRB, 0.31746040E-06_JPRB, 0.31752455E-06_JPRB, &
  & 0.31758799E-06_JPRB, 0.31764716E-06_JPRB, 0.31770008E-06_JPRB, 0.31774681E-06_JPRB, 0.31778742E-06_JPRB, 0.31782236E-06_JPRB, &
  & 0.31785163E-06_JPRB, 0.31787397E-06_JPRB, 0.31788835E-06_JPRB, 0.31789443E-06_JPRB, 0.31789295E-06_JPRB, 0.31788542E-06_JPRB, &
  & 0.31787280E-06_JPRB, 0.31785612E-06_JPRB, 0.31783668E-06_JPRB, 0.31781502E-06_JPRB, 0.31779177E-06_JPRB, 0.31776810E-06_JPRB, &
  & 0.31774522E-06_JPRB, 0.31772470E-06_JPRB, 0.31770594E-06_JPRB, 0.31768897E-06_JPRB, 0.31767212E-06_JPRB, 0.31765438E-06_JPRB, &
  & 0.31763540E-06_JPRB, 0.31761581E-06_JPRB, 0.31759646E-06_JPRB, 0.31757847E-06_JPRB, 0.31756224E-06_JPRB, 0.31754783E-06_JPRB, &
  & 0.31753336E-06_JPRB, 0.31751813E-06_JPRB, 0.31750002E-06_JPRB, 0.31747700E-06_JPRB, 0.31744983E-06_JPRB, 0.31741951E-06_JPRB, &
  & 0.31738983E-06_JPRB, 0.31735902E-06_JPRB, 0.31732367E-06_JPRB, 0.31725310E-06_JPRB /)

RGHG3(:,53,10) = (/ &
  & 0.31678073E-06_JPRB, 0.31688992E-06_JPRB, 0.31696453E-06_JPRB, 0.31704457E-06_JPRB, 0.31714308E-06_JPRB, 0.31723204E-06_JPRB, &
  & 0.31728581E-06_JPRB, 0.31731281E-06_JPRB, 0.31732731E-06_JPRB, 0.31733629E-06_JPRB, 0.31734211E-06_JPRB, 0.31734641E-06_JPRB, &
  & 0.31734919E-06_JPRB, 0.31735027E-06_JPRB, 0.31734922E-06_JPRB, 0.31734626E-06_JPRB, 0.31734305E-06_JPRB, 0.31734274E-06_JPRB, &
  & 0.31734868E-06_JPRB, 0.31736411E-06_JPRB, 0.31739182E-06_JPRB, 0.31743281E-06_JPRB, 0.31748522E-06_JPRB, 0.31754422E-06_JPRB, &
  & 0.31760462E-06_JPRB, 0.31766149E-06_JPRB, 0.31771327E-06_JPRB, 0.31775863E-06_JPRB, 0.31779842E-06_JPRB, 0.31783242E-06_JPRB, &
  & 0.31786070E-06_JPRB, 0.31788221E-06_JPRB, 0.31789585E-06_JPRB, 0.31790151E-06_JPRB, 0.31789986E-06_JPRB, 0.31789233E-06_JPRB, &
  & 0.31787988E-06_JPRB, 0.31786371E-06_JPRB, 0.31784498E-06_JPRB, 0.31782412E-06_JPRB, 0.31780192E-06_JPRB, 0.31777935E-06_JPRB, &
  & 0.31775863E-06_JPRB, 0.31773999E-06_JPRB, 0.31772475E-06_JPRB, 0.31771111E-06_JPRB, 0.31769906E-06_JPRB, 0.31768747E-06_JPRB, &
  & 0.31767655E-06_JPRB, 0.31766641E-06_JPRB, 0.31765748E-06_JPRB, 0.31764972E-06_JPRB, 0.31764318E-06_JPRB, 0.31763699E-06_JPRB, &
  & 0.31763113E-06_JPRB, 0.31762417E-06_JPRB, 0.31761536E-06_JPRB, 0.31760385E-06_JPRB, 0.31758898E-06_JPRB, 0.31757276E-06_JPRB, &
  & 0.31755613E-06_JPRB, 0.31753967E-06_JPRB, 0.31751881E-06_JPRB, 0.31747649E-06_JPRB /)

RGHG3(:,54,10) = (/ &
  & 0.31702780E-06_JPRB, 0.31710908E-06_JPRB, 0.31715996E-06_JPRB, 0.31722061E-06_JPRB, 0.31729039E-06_JPRB, 0.31735283E-06_JPRB, &
  & 0.31738682E-06_JPRB, 0.31740382E-06_JPRB, 0.31741268E-06_JPRB, 0.31741786E-06_JPRB, 0.31742127E-06_JPRB, 0.31742331E-06_JPRB, &
  & 0.31742417E-06_JPRB, 0.31742320E-06_JPRB, 0.31741973E-06_JPRB, 0.31741322E-06_JPRB, 0.31740586E-06_JPRB, 0.31740018E-06_JPRB, &
  & 0.31739975E-06_JPRB, 0.31740805E-06_JPRB, 0.31742817E-06_JPRB, 0.31746214E-06_JPRB, 0.31750864E-06_JPRB, 0.31756343E-06_JPRB, &
  & 0.31762031E-06_JPRB, 0.31767536E-06_JPRB, 0.31772510E-06_JPRB, 0.31776972E-06_JPRB, 0.31780854E-06_JPRB, 0.31784174E-06_JPRB, &
  & 0.31786919E-06_JPRB, 0.31788980E-06_JPRB, 0.31790285E-06_JPRB, 0.31790825E-06_JPRB, 0.31790643E-06_JPRB, 0.31789892E-06_JPRB, &
  & 0.31788676E-06_JPRB, 0.31787101E-06_JPRB, 0.31785285E-06_JPRB, 0.31783281E-06_JPRB, 0.31781141E-06_JPRB, 0.31779010E-06_JPRB, &
  & 0.31777043E-06_JPRB, 0.31775426E-06_JPRB, 0.31774076E-06_JPRB, 0.31773018E-06_JPRB, 0.31772129E-06_JPRB, 0.31771367E-06_JPRB, &
  & 0.31770728E-06_JPRB, 0.31770202E-06_JPRB, 0.31769781E-06_JPRB, 0.31769440E-06_JPRB, 0.31769162E-06_JPRB, 0.31768917E-06_JPRB, &
  & 0.31768644E-06_JPRB, 0.31768326E-06_JPRB, 0.31767883E-06_JPRB, 0.31767269E-06_JPRB, 0.31766496E-06_JPRB, 0.31765637E-06_JPRB, &
  & 0.31764833E-06_JPRB, 0.31764091E-06_JPRB, 0.31763409E-06_JPRB, 0.31762556E-06_JPRB /)

RGHG3(:,55,10) = (/ &
  & 0.31719441E-06_JPRB, 0.31725438E-06_JPRB, 0.31729712E-06_JPRB, 0.31733924E-06_JPRB, 0.31739145E-06_JPRB, 0.31743249E-06_JPRB, &
  & 0.31745552E-06_JPRB, 0.31746606E-06_JPRB, 0.31747157E-06_JPRB, 0.31747487E-06_JPRB, 0.31747686E-06_JPRB, 0.31747794E-06_JPRB, &
  & 0.31747800E-06_JPRB, 0.31747649E-06_JPRB, 0.31747234E-06_JPRB, 0.31746526E-06_JPRB, 0.31745586E-06_JPRB, 0.31744733E-06_JPRB, &
  & 0.31744298E-06_JPRB, 0.31744634E-06_JPRB, 0.31746106E-06_JPRB, 0.31748962E-06_JPRB, 0.31753143E-06_JPRB, 0.31758211E-06_JPRB, &
  & 0.31763594E-06_JPRB, 0.31768809E-06_JPRB, 0.31773652E-06_JPRB, 0.31777984E-06_JPRB, 0.31781798E-06_JPRB, 0.31785044E-06_JPRB, &
  & 0.31787704E-06_JPRB, 0.31789693E-06_JPRB, 0.31790935E-06_JPRB, 0.31791450E-06_JPRB, 0.31791276E-06_JPRB, 0.31790537E-06_JPRB, &
  & 0.31789347E-06_JPRB, 0.31787809E-06_JPRB, 0.31786047E-06_JPRB, 0.31784103E-06_JPRB, 0.31782054E-06_JPRB, 0.31780016E-06_JPRB, &
  & 0.31778220E-06_JPRB, 0.31776713E-06_JPRB, 0.31775585E-06_JPRB, 0.31774701E-06_JPRB, 0.31774044E-06_JPRB, 0.31773533E-06_JPRB, &
  & 0.31773152E-06_JPRB, 0.31772862E-06_JPRB, 0.31772657E-06_JPRB, 0.31772498E-06_JPRB, 0.31772376E-06_JPRB, 0.31772254E-06_JPRB, &
  & 0.31772129E-06_JPRB, 0.31771950E-06_JPRB, 0.31771705E-06_JPRB, 0.31771356E-06_JPRB, 0.31770890E-06_JPRB, 0.31770398E-06_JPRB, &
  & 0.31769923E-06_JPRB, 0.31769471E-06_JPRB, 0.31768971E-06_JPRB, 0.31768155E-06_JPRB /)

RGHG3(:,56,10) = (/ &
  & 0.31731662E-06_JPRB, 0.31736471E-06_JPRB, 0.31739282E-06_JPRB, 0.31742653E-06_JPRB, 0.31746185E-06_JPRB, 0.31749127E-06_JPRB, &
  & 0.31750579E-06_JPRB, 0.31751281E-06_JPRB, 0.31751637E-06_JPRB, 0.31751847E-06_JPRB, 0.31751978E-06_JPRB, 0.31752040E-06_JPRB, &
  & 0.31752020E-06_JPRB, 0.31751870E-06_JPRB, 0.31751497E-06_JPRB, 0.31750784E-06_JPRB, 0.31749806E-06_JPRB, 0.31748789E-06_JPRB, &
  & 0.31748081E-06_JPRB, 0.31748070E-06_JPRB, 0.31749147E-06_JPRB, 0.31751603E-06_JPRB, 0.31755380E-06_JPRB, 0.31760055E-06_JPRB, &
  & 0.31765094E-06_JPRB, 0.31770077E-06_JPRB, 0.31774729E-06_JPRB, 0.31778958E-06_JPRB, 0.31782687E-06_JPRB, 0.31785871E-06_JPRB, &
  & 0.31788454E-06_JPRB, 0.31790358E-06_JPRB, 0.31791555E-06_JPRB, 0.31792052E-06_JPRB, 0.31791876E-06_JPRB, 0.31791160E-06_JPRB, &
  & 0.31790006E-06_JPRB, 0.31788511E-06_JPRB, 0.31786792E-06_JPRB, 0.31784910E-06_JPRB, 0.31782935E-06_JPRB, 0.31781025E-06_JPRB, &
  & 0.31779325E-06_JPRB, 0.31777989E-06_JPRB, 0.31776986E-06_JPRB, 0.31776264E-06_JPRB, 0.31775761E-06_JPRB, 0.31775406E-06_JPRB, &
  & 0.31775159E-06_JPRB, 0.31774988E-06_JPRB, 0.31774880E-06_JPRB, 0.31774800E-06_JPRB, 0.31774741E-06_JPRB, 0.31774681E-06_JPRB, &
  & 0.31774601E-06_JPRB, 0.31774493E-06_JPRB, 0.31774337E-06_JPRB, 0.31774101E-06_JPRB, 0.31773808E-06_JPRB, 0.31773493E-06_JPRB, &
  & 0.31773186E-06_JPRB, 0.31772896E-06_JPRB, 0.31772601E-06_JPRB, 0.31772132E-06_JPRB /)

RGHG3(:,57,10) = (/ &
  & 0.31740652E-06_JPRB, 0.31744207E-06_JPRB, 0.31746643E-06_JPRB, 0.31748948E-06_JPRB, 0.31751608E-06_JPRB, 0.31753547E-06_JPRB, &
  & 0.31754573E-06_JPRB, 0.31755036E-06_JPRB, 0.31755286E-06_JPRB, 0.31755434E-06_JPRB, 0.31755525E-06_JPRB, 0.31755570E-06_JPRB, &
  & 0.31755553E-06_JPRB, 0.31755434E-06_JPRB, 0.31755118E-06_JPRB, 0.31754490E-06_JPRB, 0.31753495E-06_JPRB, 0.31752376E-06_JPRB, &
  & 0.31751486E-06_JPRB, 0.31751233E-06_JPRB, 0.31752023E-06_JPRB, 0.31754143E-06_JPRB, 0.31757557E-06_JPRB, 0.31761891E-06_JPRB, &
  & 0.31766598E-06_JPRB, 0.31771319E-06_JPRB, 0.31775804E-06_JPRB, 0.31779905E-06_JPRB, 0.31783543E-06_JPRB, 0.31786635E-06_JPRB, &
  & 0.31789145E-06_JPRB, 0.31790995E-06_JPRB, 0.31792146E-06_JPRB, 0.31792624E-06_JPRB, 0.31792467E-06_JPRB, 0.31791771E-06_JPRB, &
  & 0.31790657E-06_JPRB, 0.31789207E-06_JPRB, 0.31787533E-06_JPRB, 0.31785706E-06_JPRB, 0.31783827E-06_JPRB, 0.31781997E-06_JPRB, &
  & 0.31780445E-06_JPRB, 0.31779211E-06_JPRB, 0.31778330E-06_JPRB, 0.31777722E-06_JPRB, 0.31777333E-06_JPRB, 0.31777074E-06_JPRB, &
  & 0.31776912E-06_JPRB, 0.31776801E-06_JPRB, 0.31776727E-06_JPRB, 0.31776671E-06_JPRB, 0.31776631E-06_JPRB, 0.31776585E-06_JPRB, &
  & 0.31776528E-06_JPRB, 0.31776449E-06_JPRB, 0.31776329E-06_JPRB, 0.31776153E-06_JPRB, 0.31775937E-06_JPRB, 0.31775710E-06_JPRB, &
  & 0.31775494E-06_JPRB, 0.31775292E-06_JPRB, 0.31775053E-06_JPRB, 0.31774655E-06_JPRB /)

RGHG3(:,58,10) = (/ &
  & 0.31747899E-06_JPRB, 0.31750531E-06_JPRB, 0.31752128E-06_JPRB, 0.31753945E-06_JPRB, 0.31755795E-06_JPRB, 0.31757199E-06_JPRB, &
  & 0.31757901E-06_JPRB, 0.31758245E-06_JPRB, 0.31758427E-06_JPRB, 0.31758546E-06_JPRB, 0.31758623E-06_JPRB, 0.31758663E-06_JPRB, &
  & 0.31758660E-06_JPRB, 0.31758583E-06_JPRB, 0.31758333E-06_JPRB, 0.31757781E-06_JPRB, 0.31756832E-06_JPRB, 0.31755661E-06_JPRB, &
  & 0.31754649E-06_JPRB, 0.31754229E-06_JPRB, 0.31754792E-06_JPRB, 0.31756636E-06_JPRB, 0.31759717E-06_JPRB, 0.31763693E-06_JPRB, &
  & 0.31768113E-06_JPRB, 0.31772581E-06_JPRB, 0.31776889E-06_JPRB, 0.31780849E-06_JPRB, 0.31784381E-06_JPRB, 0.31787383E-06_JPRB, &
  & 0.31789807E-06_JPRB, 0.31791600E-06_JPRB, 0.31792712E-06_JPRB, 0.31793189E-06_JPRB, 0.31793050E-06_JPRB, 0.31792393E-06_JPRB, &
  & 0.31791316E-06_JPRB, 0.31789909E-06_JPRB, 0.31788275E-06_JPRB, 0.31786522E-06_JPRB, 0.31784700E-06_JPRB, 0.31782986E-06_JPRB, &
  & 0.31781539E-06_JPRB, 0.31780417E-06_JPRB, 0.31779632E-06_JPRB, 0.31779123E-06_JPRB, 0.31778811E-06_JPRB, 0.31778626E-06_JPRB, &
  & 0.31778501E-06_JPRB, 0.31778410E-06_JPRB, 0.31778347E-06_JPRB, 0.31778291E-06_JPRB, 0.31778239E-06_JPRB, 0.31778185E-06_JPRB, &
  & 0.31778126E-06_JPRB, 0.31778055E-06_JPRB, 0.31777952E-06_JPRB, 0.31777805E-06_JPRB, 0.31777628E-06_JPRB, 0.31777449E-06_JPRB, &
  & 0.31777276E-06_JPRB, 0.31777120E-06_JPRB, 0.31776949E-06_JPRB, 0.31776656E-06_JPRB /)

RGHG3(:,59,10) = (/ &
  & 0.31753032E-06_JPRB, 0.31755155E-06_JPRB, 0.31756542E-06_JPRB, 0.31757875E-06_JPRB, 0.31759257E-06_JPRB, 0.31760280E-06_JPRB, &
  & 0.31760817E-06_JPRB, 0.31761087E-06_JPRB, 0.31761243E-06_JPRB, 0.31761351E-06_JPRB, 0.31761428E-06_JPRB, 0.31761488E-06_JPRB, &
  & 0.31761510E-06_JPRB, 0.31761468E-06_JPRB, 0.31761286E-06_JPRB, 0.31760806E-06_JPRB, 0.31759902E-06_JPRB, 0.31758717E-06_JPRB, &
  & 0.31757634E-06_JPRB, 0.31757091E-06_JPRB, 0.31757483E-06_JPRB, 0.31759075E-06_JPRB, 0.31761851E-06_JPRB, 0.31765518E-06_JPRB, &
  & 0.31769645E-06_JPRB, 0.31773874E-06_JPRB, 0.31777989E-06_JPRB, 0.31781801E-06_JPRB, 0.31785208E-06_JPRB, 0.31788102E-06_JPRB, &
  & 0.31790447E-06_JPRB, 0.31792186E-06_JPRB, 0.31793272E-06_JPRB, 0.31793743E-06_JPRB, 0.31793624E-06_JPRB, 0.31793007E-06_JPRB, &
  & 0.31791976E-06_JPRB, 0.31790614E-06_JPRB, 0.31789040E-06_JPRB, 0.31787329E-06_JPRB, 0.31785595E-06_JPRB, 0.31783972E-06_JPRB, &
  & 0.31782625E-06_JPRB, 0.31781599E-06_JPRB, 0.31780903E-06_JPRB, 0.31780471E-06_JPRB, 0.31780220E-06_JPRB, 0.31780073E-06_JPRB, &
  & 0.31779973E-06_JPRB, 0.31779888E-06_JPRB, 0.31779820E-06_JPRB, 0.31779751E-06_JPRB, 0.31779689E-06_JPRB, 0.31779626E-06_JPRB, &
  & 0.31779558E-06_JPRB, 0.31779473E-06_JPRB, 0.31779365E-06_JPRB, 0.31779228E-06_JPRB, 0.31779066E-06_JPRB, 0.31778910E-06_JPRB, &
  & 0.31778762E-06_JPRB, 0.31778626E-06_JPRB, 0.31778472E-06_JPRB, 0.31778205E-06_JPRB /)

RGHG3(:,60,10) = (/ &
  & 0.31757367E-06_JPRB, 0.31759114E-06_JPRB, 0.31760135E-06_JPRB, 0.31761181E-06_JPRB, 0.31762227E-06_JPRB, 0.31763005E-06_JPRB, &
  & 0.31763440E-06_JPRB, 0.31763676E-06_JPRB, 0.31763824E-06_JPRB, 0.31763932E-06_JPRB, 0.31764029E-06_JPRB, 0.31764108E-06_JPRB, &
  & 0.31764171E-06_JPRB, 0.31764179E-06_JPRB, 0.31764054E-06_JPRB, 0.31763648E-06_JPRB, 0.31762781E-06_JPRB, 0.31761599E-06_JPRB, &
  & 0.31760487E-06_JPRB, 0.31759879E-06_JPRB, 0.31760132E-06_JPRB, 0.31761491E-06_JPRB, 0.31763989E-06_JPRB, 0.31767348E-06_JPRB, &
  & 0.31771208E-06_JPRB, 0.31775215E-06_JPRB, 0.31779123E-06_JPRB, 0.31782770E-06_JPRB, 0.31786038E-06_JPRB, 0.31788829E-06_JPRB, &
  & 0.31791083E-06_JPRB, 0.31792760E-06_JPRB, 0.31793823E-06_JPRB, 0.31794286E-06_JPRB, 0.31794190E-06_JPRB, 0.31793616E-06_JPRB, &
  & 0.31792632E-06_JPRB, 0.31791333E-06_JPRB, 0.31789816E-06_JPRB, 0.31788173E-06_JPRB, 0.31786507E-06_JPRB, 0.31784967E-06_JPRB, &
  & 0.31783711E-06_JPRB, 0.31782773E-06_JPRB, 0.31782153E-06_JPRB, 0.31781781E-06_JPRB, 0.31781576E-06_JPRB, 0.31781457E-06_JPRB, &
  & 0.31781371E-06_JPRB, 0.31781272E-06_JPRB, 0.31781190E-06_JPRB, 0.31781099E-06_JPRB, 0.31781013E-06_JPRB, 0.31780939E-06_JPRB, &
  & 0.31780854E-06_JPRB, 0.31780758E-06_JPRB, 0.31780638E-06_JPRB, 0.31780490E-06_JPRB, 0.31780331E-06_JPRB, 0.31780178E-06_JPRB, &
  & 0.31780039E-06_JPRB, 0.31779913E-06_JPRB, 0.31779774E-06_JPRB, 0.31779538E-06_JPRB /)

RGHG3(:,61,10) = (/ &
  & 0.31760885E-06_JPRB, 0.31762329E-06_JPRB, 0.31763207E-06_JPRB, 0.31764020E-06_JPRB, 0.31764824E-06_JPRB, 0.31765472E-06_JPRB, &
  & 0.31765856E-06_JPRB, 0.31766083E-06_JPRB, 0.31766240E-06_JPRB, 0.31766365E-06_JPRB, 0.31766481E-06_JPRB, 0.31766601E-06_JPRB, &
  & 0.31766709E-06_JPRB, 0.31766774E-06_JPRB, 0.31766714E-06_JPRB, 0.31766351E-06_JPRB, 0.31765524E-06_JPRB, 0.31764370E-06_JPRB, &
  & 0.31763247E-06_JPRB, 0.31762602E-06_JPRB, 0.31762741E-06_JPRB, 0.31763915E-06_JPRB, 0.31766137E-06_JPRB, 0.31769218E-06_JPRB, &
  & 0.31772817E-06_JPRB, 0.31776577E-06_JPRB, 0.31780291E-06_JPRB, 0.31783762E-06_JPRB, 0.31786874E-06_JPRB, 0.31789546E-06_JPRB, &
  & 0.31791717E-06_JPRB, 0.31793337E-06_JPRB, 0.31794363E-06_JPRB, 0.31794826E-06_JPRB, 0.31794761E-06_JPRB, 0.31794218E-06_JPRB, &
  & 0.31793286E-06_JPRB, 0.31792050E-06_JPRB, 0.31790597E-06_JPRB, 0.31789006E-06_JPRB, 0.31787417E-06_JPRB, 0.31785973E-06_JPRB, &
  & 0.31784799E-06_JPRB, 0.31783935E-06_JPRB, 0.31783384E-06_JPRB, 0.31783063E-06_JPRB, 0.31782895E-06_JPRB, 0.31782798E-06_JPRB, &
  & 0.31782719E-06_JPRB, 0.31782619E-06_JPRB, 0.31782508E-06_JPRB, 0.31782383E-06_JPRB, 0.31782267E-06_JPRB, 0.31782159E-06_JPRB, &
  & 0.31782059E-06_JPRB, 0.31781946E-06_JPRB, 0.31781809E-06_JPRB, 0.31781644E-06_JPRB, 0.31781474E-06_JPRB, 0.31781309E-06_JPRB, &
  & 0.31781167E-06_JPRB, 0.31781036E-06_JPRB, 0.31780894E-06_JPRB, 0.31780661E-06_JPRB /)

RGHG3(:,62,10) = (/ &
  & 0.31763963E-06_JPRB, 0.31765194E-06_JPRB, 0.31765893E-06_JPRB, 0.31766550E-06_JPRB, 0.31767212E-06_JPRB, 0.31767752E-06_JPRB, &
  & 0.31768121E-06_JPRB, 0.31768357E-06_JPRB, 0.31768536E-06_JPRB, 0.31768693E-06_JPRB, 0.31768849E-06_JPRB, 0.31769017E-06_JPRB, &
  & 0.31769196E-06_JPRB, 0.31769332E-06_JPRB, 0.31769338E-06_JPRB, 0.31769000E-06_JPRB, 0.31768184E-06_JPRB, 0.31767041E-06_JPRB, &
  & 0.31765950E-06_JPRB, 0.31765285E-06_JPRB, 0.31765325E-06_JPRB, 0.31766331E-06_JPRB, 0.31768315E-06_JPRB, 0.31771131E-06_JPRB, &
  & 0.31774456E-06_JPRB, 0.31777992E-06_JPRB, 0.31781499E-06_JPRB, 0.31784788E-06_JPRB, 0.31787735E-06_JPRB, 0.31790285E-06_JPRB, &
  & 0.31792359E-06_JPRB, 0.31793911E-06_JPRB, 0.31794912E-06_JPRB, 0.31795358E-06_JPRB, 0.31795312E-06_JPRB, 0.31794818E-06_JPRB, &
  & 0.31793940E-06_JPRB, 0.31792760E-06_JPRB, 0.31791379E-06_JPRB, 0.31789864E-06_JPRB, 0.31788355E-06_JPRB, 0.31786985E-06_JPRB, &
  & 0.31785885E-06_JPRB, 0.31785100E-06_JPRB, 0.31784600E-06_JPRB, 0.31784325E-06_JPRB, 0.31784180E-06_JPRB, 0.31784094E-06_JPRB, &
  & 0.31784023E-06_JPRB, 0.31783921E-06_JPRB, 0.31783793E-06_JPRB, 0.31783640E-06_JPRB, 0.31783492E-06_JPRB, 0.31783361E-06_JPRB, &
  & 0.31783225E-06_JPRB, 0.31783082E-06_JPRB, 0.31782915E-06_JPRB, 0.31782724E-06_JPRB, 0.31782528E-06_JPRB, 0.31782352E-06_JPRB, &
  & 0.31782201E-06_JPRB, 0.31782059E-06_JPRB, 0.31781914E-06_JPRB, 0.31781664E-06_JPRB /)

RGHG3(:,63,10) = (/ &
  & 0.31766601E-06_JPRB, 0.31767698E-06_JPRB, 0.31768317E-06_JPRB, 0.31768874E-06_JPRB, 0.31769429E-06_JPRB, 0.31769920E-06_JPRB, &
  & 0.31770270E-06_JPRB, 0.31770526E-06_JPRB, 0.31770730E-06_JPRB, 0.31770921E-06_JPRB, 0.31771123E-06_JPRB, 0.31771356E-06_JPRB, &
  & 0.31771606E-06_JPRB, 0.31771810E-06_JPRB, 0.31771845E-06_JPRB, 0.31771521E-06_JPRB, 0.31770750E-06_JPRB, 0.31769676E-06_JPRB, &
  & 0.31768619E-06_JPRB, 0.31767939E-06_JPRB, 0.31767911E-06_JPRB, 0.31768761E-06_JPRB, 0.31770543E-06_JPRB, 0.31773106E-06_JPRB, &
  & 0.31776173E-06_JPRB, 0.31779470E-06_JPRB, 0.31782761E-06_JPRB, 0.31785859E-06_JPRB, 0.31788642E-06_JPRB, 0.31791063E-06_JPRB, &
  & 0.31793024E-06_JPRB, 0.31794497E-06_JPRB, 0.31795449E-06_JPRB, 0.31795886E-06_JPRB, 0.31795858E-06_JPRB, 0.31795406E-06_JPRB, &
  & 0.31794585E-06_JPRB, 0.31793473E-06_JPRB, 0.31792166E-06_JPRB, 0.31790722E-06_JPRB, 0.31789293E-06_JPRB, 0.31788008E-06_JPRB, &
  & 0.31786976E-06_JPRB, 0.31786257E-06_JPRB, 0.31785808E-06_JPRB, 0.31785561E-06_JPRB, 0.31785441E-06_JPRB, 0.31785368E-06_JPRB, &
  & 0.31785297E-06_JPRB, 0.31785191E-06_JPRB, 0.31785052E-06_JPRB, 0.31784879E-06_JPRB, 0.31784703E-06_JPRB, 0.31784535E-06_JPRB, &
  & 0.31784370E-06_JPRB, 0.31784188E-06_JPRB, 0.31783981E-06_JPRB, 0.31783753E-06_JPRB, 0.31783523E-06_JPRB, 0.31783316E-06_JPRB, &
  & 0.31783139E-06_JPRB, 0.31782977E-06_JPRB, 0.31782804E-06_JPRB, 0.31782523E-06_JPRB /)

RGHG3(:,64,10) = (/ &
  & 0.31768963E-06_JPRB, 0.31769980E-06_JPRB, 0.31770543E-06_JPRB, 0.31771035E-06_JPRB, 0.31771535E-06_JPRB, 0.31771981E-06_JPRB, &
  & 0.31772339E-06_JPRB, 0.31772606E-06_JPRB, 0.31772851E-06_JPRB, 0.31773084E-06_JPRB, 0.31773357E-06_JPRB, 0.31773681E-06_JPRB, &
  & 0.31774033E-06_JPRB, 0.31774329E-06_JPRB, 0.31774414E-06_JPRB, 0.31774078E-06_JPRB, 0.31773308E-06_JPRB, 0.31772254E-06_JPRB, &
  & 0.31771236E-06_JPRB, 0.31770557E-06_JPRB, 0.31770477E-06_JPRB, 0.31771205E-06_JPRB, 0.31772805E-06_JPRB, 0.31775130E-06_JPRB, &
  & 0.31777944E-06_JPRB, 0.31781002E-06_JPRB, 0.31784072E-06_JPRB, 0.31786971E-06_JPRB, 0.31789580E-06_JPRB, 0.31791853E-06_JPRB, &
  & 0.31793695E-06_JPRB, 0.31795076E-06_JPRB, 0.31795980E-06_JPRB, 0.31796398E-06_JPRB, 0.31796384E-06_JPRB, 0.31795963E-06_JPRB, &
  & 0.31795210E-06_JPRB, 0.31794167E-06_JPRB, 0.31792939E-06_JPRB, 0.31791581E-06_JPRB, 0.31790236E-06_JPRB, 0.31789031E-06_JPRB, &
  & 0.31788068E-06_JPRB, 0.31787405E-06_JPRB, 0.31786988E-06_JPRB, 0.31786774E-06_JPRB, 0.31786666E-06_JPRB, 0.31786601E-06_JPRB, &
  & 0.31786536E-06_JPRB, 0.31786431E-06_JPRB, 0.31786291E-06_JPRB, 0.31786098E-06_JPRB, 0.31785893E-06_JPRB, 0.31785697E-06_JPRB, &
  & 0.31785487E-06_JPRB, 0.31785265E-06_JPRB, 0.31785021E-06_JPRB, 0.31784748E-06_JPRB, 0.31784481E-06_JPRB, 0.31784242E-06_JPRB, &
  & 0.31784037E-06_JPRB, 0.31783844E-06_JPRB, 0.31783634E-06_JPRB, 0.31783276E-06_JPRB /)

RGHG3(:,65,10) = (/ &
  & 0.31771123E-06_JPRB, 0.31772106E-06_JPRB, 0.31772635E-06_JPRB, 0.31773101E-06_JPRB, 0.31773550E-06_JPRB, 0.31773976E-06_JPRB, &
  & 0.31774323E-06_JPRB, 0.31774630E-06_JPRB, 0.31774903E-06_JPRB, 0.31775210E-06_JPRB, 0.31775551E-06_JPRB, 0.31775957E-06_JPRB, &
  & 0.31776369E-06_JPRB, 0.31776659E-06_JPRB, 0.31776710E-06_JPRB, 0.31776398E-06_JPRB, 0.31775716E-06_JPRB, 0.31774769E-06_JPRB, &
  & 0.31773797E-06_JPRB, 0.31773138E-06_JPRB, 0.31773018E-06_JPRB, 0.31773649E-06_JPRB, 0.31775079E-06_JPRB, 0.31777176E-06_JPRB, &
  & 0.31779751E-06_JPRB, 0.31782571E-06_JPRB, 0.31785410E-06_JPRB, 0.31788102E-06_JPRB, 0.31790535E-06_JPRB, 0.31792641E-06_JPRB, &
  & 0.31794355E-06_JPRB, 0.31795639E-06_JPRB, 0.31796480E-06_JPRB, 0.31796878E-06_JPRB, 0.31796876E-06_JPRB, 0.31796495E-06_JPRB, &
  & 0.31795801E-06_JPRB, 0.31794841E-06_JPRB, 0.31793692E-06_JPRB, 0.31792419E-06_JPRB, 0.31791168E-06_JPRB, 0.31790040E-06_JPRB, &
  & 0.31789148E-06_JPRB, 0.31788531E-06_JPRB, 0.31788150E-06_JPRB, 0.31787948E-06_JPRB, 0.31787852E-06_JPRB, 0.31787795E-06_JPRB, &
  & 0.31787729E-06_JPRB, 0.31787624E-06_JPRB, 0.31787496E-06_JPRB, 0.31787300E-06_JPRB, 0.31787079E-06_JPRB, 0.31786848E-06_JPRB, &
  & 0.31786607E-06_JPRB, 0.31786345E-06_JPRB, 0.31786047E-06_JPRB, 0.31785731E-06_JPRB, 0.31785424E-06_JPRB, 0.31785146E-06_JPRB, &
  & 0.31784899E-06_JPRB, 0.31784660E-06_JPRB, 0.31784387E-06_JPRB, 0.31783927E-06_JPRB /)

RGHG3(:,66,10) = (/ &
  & 0.31773047E-06_JPRB, 0.31774078E-06_JPRB, 0.31774636E-06_JPRB, 0.31775090E-06_JPRB, 0.31775525E-06_JPRB, 0.31775929E-06_JPRB, &
  & 0.31776295E-06_JPRB, 0.31776608E-06_JPRB, 0.31776952E-06_JPRB, 0.31777290E-06_JPRB, 0.31777734E-06_JPRB, 0.31778211E-06_JPRB, &
  & 0.31778686E-06_JPRB, 0.31779055E-06_JPRB, 0.31779140E-06_JPRB, 0.31778831E-06_JPRB, 0.31778143E-06_JPRB, 0.31777211E-06_JPRB, &
  & 0.31776304E-06_JPRB, 0.31775670E-06_JPRB, 0.31775539E-06_JPRB, 0.31776094E-06_JPRB, 0.31777367E-06_JPRB, 0.31779251E-06_JPRB, &
  & 0.31781585E-06_JPRB, 0.31784163E-06_JPRB, 0.31786757E-06_JPRB, 0.31789227E-06_JPRB, 0.31791473E-06_JPRB, 0.31793417E-06_JPRB, &
  & 0.31794994E-06_JPRB, 0.31796168E-06_JPRB, 0.31796935E-06_JPRB, 0.31797310E-06_JPRB, 0.31797305E-06_JPRB, 0.31796975E-06_JPRB, &
  & 0.31796341E-06_JPRB, 0.31795466E-06_JPRB, 0.31794417E-06_JPRB, 0.31793238E-06_JPRB, 0.31792075E-06_JPRB, 0.31791032E-06_JPRB, &
  & 0.31790211E-06_JPRB, 0.31789631E-06_JPRB, 0.31789273E-06_JPRB, 0.31789097E-06_JPRB, 0.31789011E-06_JPRB, 0.31788954E-06_JPRB, &
  & 0.31788895E-06_JPRB, 0.31788787E-06_JPRB, 0.31788659E-06_JPRB, 0.31788474E-06_JPRB, 0.31788241E-06_JPRB, 0.31787994E-06_JPRB, &
  & 0.31787715E-06_JPRB, 0.31787420E-06_JPRB, 0.31787090E-06_JPRB, 0.31786729E-06_JPRB, 0.31786391E-06_JPRB, 0.31786078E-06_JPRB, &
  & 0.31785783E-06_JPRB, 0.31785476E-06_JPRB, 0.31785120E-06_JPRB, 0.31784481E-06_JPRB /)

RGHG3(:,67,10) = (/ &
  & 0.31774812E-06_JPRB, 0.31775971E-06_JPRB, 0.31776557E-06_JPRB, 0.31777034E-06_JPRB, 0.31777472E-06_JPRB, 0.31777881E-06_JPRB, &
  & 0.31778239E-06_JPRB, 0.31778598E-06_JPRB, 0.31778944E-06_JPRB, 0.31779388E-06_JPRB, 0.31779865E-06_JPRB, 0.31780394E-06_JPRB, &
  & 0.31780843E-06_JPRB, 0.31781144E-06_JPRB, 0.31781195E-06_JPRB, 0.31780945E-06_JPRB, 0.31780394E-06_JPRB, 0.31779584E-06_JPRB, &
  & 0.31778740E-06_JPRB, 0.31778154E-06_JPRB, 0.31778018E-06_JPRB, 0.31778501E-06_JPRB, 0.31779629E-06_JPRB, 0.31781317E-06_JPRB, &
  & 0.31783418E-06_JPRB, 0.31785734E-06_JPRB, 0.31788090E-06_JPRB, 0.31790336E-06_JPRB, 0.31792382E-06_JPRB, 0.31794150E-06_JPRB, &
  & 0.31795585E-06_JPRB, 0.31796665E-06_JPRB, 0.31797350E-06_JPRB, 0.31797691E-06_JPRB, 0.31797691E-06_JPRB, 0.31797401E-06_JPRB, &
  & 0.31796839E-06_JPRB, 0.31796046E-06_JPRB, 0.31795093E-06_JPRB, 0.31794028E-06_JPRB, 0.31792959E-06_JPRB, 0.31792001E-06_JPRB, &
  & 0.31791237E-06_JPRB, 0.31790711E-06_JPRB, 0.31790375E-06_JPRB, 0.31790205E-06_JPRB, 0.31790123E-06_JPRB, 0.31790066E-06_JPRB, &
  & 0.31790009E-06_JPRB, 0.31789909E-06_JPRB, 0.31789781E-06_JPRB, 0.31789602E-06_JPRB, 0.31789372E-06_JPRB, 0.31789114E-06_JPRB, &
  & 0.31788818E-06_JPRB, 0.31788502E-06_JPRB, 0.31788136E-06_JPRB, 0.31787744E-06_JPRB, 0.31787380E-06_JPRB, 0.31787022E-06_JPRB, &
  & 0.31786689E-06_JPRB, 0.31786317E-06_JPRB, 0.31785848E-06_JPRB, 0.31784995E-06_JPRB /)

RGHG3(:,68,10) = (/ &
  & 0.31776480E-06_JPRB, 0.31777805E-06_JPRB, 0.31778464E-06_JPRB, 0.31778967E-06_JPRB, 0.31779422E-06_JPRB, 0.31779831E-06_JPRB, &
  & 0.31780209E-06_JPRB, 0.31780570E-06_JPRB, 0.31780988E-06_JPRB, 0.31781437E-06_JPRB, 0.31781977E-06_JPRB, 0.31782506E-06_JPRB, &
  & 0.31782980E-06_JPRB, 0.31783381E-06_JPRB, 0.31783458E-06_JPRB, 0.31783196E-06_JPRB, 0.31782631E-06_JPRB, 0.31781872E-06_JPRB, &
  & 0.31781099E-06_JPRB, 0.31780559E-06_JPRB, 0.31780428E-06_JPRB, 0.31780843E-06_JPRB, 0.31781835E-06_JPRB, 0.31783327E-06_JPRB, &
  & 0.31785197E-06_JPRB, 0.31787269E-06_JPRB, 0.31789384E-06_JPRB, 0.31791402E-06_JPRB, 0.31793249E-06_JPRB, 0.31794838E-06_JPRB, &
  & 0.31796139E-06_JPRB, 0.31797106E-06_JPRB, 0.31797725E-06_JPRB, 0.31798032E-06_JPRB, 0.31798041E-06_JPRB, 0.31797794E-06_JPRB, &
  & 0.31797288E-06_JPRB, 0.31796580E-06_JPRB, 0.31795733E-06_JPRB, 0.31794769E-06_JPRB, 0.31793797E-06_JPRB, 0.31792922E-06_JPRB, &
  & 0.31792234E-06_JPRB, 0.31791748E-06_JPRB, 0.31791441E-06_JPRB, 0.31791285E-06_JPRB, 0.31791200E-06_JPRB, 0.31791151E-06_JPRB, &
  & 0.31791089E-06_JPRB, 0.31790987E-06_JPRB, 0.31790870E-06_JPRB, 0.31790699E-06_JPRB, 0.31790469E-06_JPRB, 0.31790205E-06_JPRB, &
  & 0.31789892E-06_JPRB, 0.31789560E-06_JPRB, 0.31789187E-06_JPRB, 0.31788778E-06_JPRB, 0.31788394E-06_JPRB, 0.31788022E-06_JPRB, &
  & 0.31787638E-06_JPRB, 0.31787206E-06_JPRB, 0.31786621E-06_JPRB, 0.31785538E-06_JPRB /)

RGHG3(:,69,10) = (/ &
  & 0.31778092E-06_JPRB, 0.31779635E-06_JPRB, 0.31780368E-06_JPRB, 0.31780922E-06_JPRB, 0.31781389E-06_JPRB, 0.31781801E-06_JPRB, &
  & 0.31782187E-06_JPRB, 0.31782574E-06_JPRB, 0.31783003E-06_JPRB, 0.31783500E-06_JPRB, 0.31784023E-06_JPRB, 0.31784538E-06_JPRB, &
  & 0.31784961E-06_JPRB, 0.31785251E-06_JPRB, 0.31785322E-06_JPRB, 0.31785152E-06_JPRB, 0.31784717E-06_JPRB, 0.31784052E-06_JPRB, &
  & 0.31783355E-06_JPRB, 0.31782866E-06_JPRB, 0.31782739E-06_JPRB, 0.31783091E-06_JPRB, 0.31783958E-06_JPRB, 0.31785271E-06_JPRB, &
  & 0.31786919E-06_JPRB, 0.31788755E-06_JPRB, 0.31790631E-06_JPRB, 0.31792428E-06_JPRB, 0.31794073E-06_JPRB, 0.31795497E-06_JPRB, &
  & 0.31796651E-06_JPRB, 0.31797504E-06_JPRB, 0.31798058E-06_JPRB, 0.31798342E-06_JPRB, 0.31798345E-06_JPRB, 0.31798140E-06_JPRB, &
  & 0.31797691E-06_JPRB, 0.31797074E-06_JPRB, 0.31796318E-06_JPRB, 0.31795463E-06_JPRB, 0.31794588E-06_JPRB, 0.31793809E-06_JPRB, &
  & 0.31793186E-06_JPRB, 0.31792749E-06_JPRB, 0.31792476E-06_JPRB, 0.31792322E-06_JPRB, 0.31792240E-06_JPRB, 0.31792194E-06_JPRB, &
  & 0.31792140E-06_JPRB, 0.31792050E-06_JPRB, 0.31791930E-06_JPRB, 0.31791762E-06_JPRB, 0.31791541E-06_JPRB, 0.31791288E-06_JPRB, &
  & 0.31790970E-06_JPRB, 0.31790631E-06_JPRB, 0.31790250E-06_JPRB, 0.31789835E-06_JPRB, 0.31789452E-06_JPRB, 0.31789060E-06_JPRB, &
  & 0.31788653E-06_JPRB, 0.31788164E-06_JPRB, 0.31787488E-06_JPRB, 0.31786166E-06_JPRB /)

RGHG3(:,70,10) = (/ &
  & 0.31779703E-06_JPRB, 0.31781468E-06_JPRB, 0.31782309E-06_JPRB, 0.31782895E-06_JPRB, 0.31783378E-06_JPRB, 0.31783804E-06_JPRB, &
  & 0.31784197E-06_JPRB, 0.31784597E-06_JPRB, 0.31785029E-06_JPRB, 0.31785521E-06_JPRB, 0.31786021E-06_JPRB, 0.31786510E-06_JPRB, &
  & 0.31786934E-06_JPRB, 0.31787337E-06_JPRB, 0.31787368E-06_JPRB, 0.31787167E-06_JPRB, 0.31786732E-06_JPRB, 0.31786158E-06_JPRB, &
  & 0.31785513E-06_JPRB, 0.31785075E-06_JPRB, 0.31784955E-06_JPRB, 0.31785245E-06_JPRB, 0.31785981E-06_JPRB, 0.31787121E-06_JPRB, &
  & 0.31788562E-06_JPRB, 0.31790171E-06_JPRB, 0.31791819E-06_JPRB, 0.31793402E-06_JPRB, 0.31794860E-06_JPRB, 0.31796108E-06_JPRB, &
  & 0.31797120E-06_JPRB, 0.31797867E-06_JPRB, 0.31798353E-06_JPRB, 0.31798612E-06_JPRB, 0.31798606E-06_JPRB, 0.31798439E-06_JPRB, &
  & 0.31798052E-06_JPRB, 0.31797518E-06_JPRB, 0.31796856E-06_JPRB, 0.31796100E-06_JPRB, 0.31795332E-06_JPRB, 0.31794639E-06_JPRB, &
  & 0.31794090E-06_JPRB, 0.31793709E-06_JPRB, 0.31793468E-06_JPRB, 0.31793323E-06_JPRB, 0.31793246E-06_JPRB, 0.31793209E-06_JPRB, &
  & 0.31793152E-06_JPRB, 0.31793061E-06_JPRB, 0.31792948E-06_JPRB, 0.31792800E-06_JPRB, 0.31792595E-06_JPRB, 0.31792342E-06_JPRB, &
  & 0.31792035E-06_JPRB, 0.31791706E-06_JPRB, 0.31791336E-06_JPRB, 0.31790933E-06_JPRB, 0.31790549E-06_JPRB, 0.31790157E-06_JPRB, &
  & 0.31789727E-06_JPRB, 0.31789222E-06_JPRB, 0.31788457E-06_JPRB, 0.31786956E-06_JPRB /)

RGHG3(:,71,10) = (/ &
  & 0.31781389E-06_JPRB, 0.31783389E-06_JPRB, 0.31784285E-06_JPRB, 0.31784904E-06_JPRB, 0.31785393E-06_JPRB, 0.31785834E-06_JPRB, &
  & 0.31786232E-06_JPRB, 0.31786618E-06_JPRB, 0.31787056E-06_JPRB, 0.31787505E-06_JPRB, 0.31787974E-06_JPRB, 0.31788397E-06_JPRB, &
  & 0.31788733E-06_JPRB, 0.31788997E-06_JPRB, 0.31789068E-06_JPRB, 0.31788966E-06_JPRB, 0.31788636E-06_JPRB, 0.31788124E-06_JPRB, &
  & 0.31787550E-06_JPRB, 0.31787167E-06_JPRB, 0.31787050E-06_JPRB, 0.31787280E-06_JPRB, 0.31787906E-06_JPRB, 0.31788883E-06_JPRB, &
  & 0.31790131E-06_JPRB, 0.31791529E-06_JPRB, 0.31792942E-06_JPRB, 0.31794329E-06_JPRB, 0.31795605E-06_JPRB, 0.31796677E-06_JPRB, &
  & 0.31797563E-06_JPRB, 0.31798206E-06_JPRB, 0.31798629E-06_JPRB, 0.31798857E-06_JPRB, 0.31798848E-06_JPRB, 0.31798720E-06_JPRB, &
  & 0.31798371E-06_JPRB, 0.31797924E-06_JPRB, 0.31797356E-06_JPRB, 0.31796691E-06_JPRB, 0.31796020E-06_JPRB, 0.31795415E-06_JPRB, &
  & 0.31794946E-06_JPRB, 0.31794616E-06_JPRB, 0.31794406E-06_JPRB, 0.31794275E-06_JPRB, 0.31794201E-06_JPRB, 0.31794178E-06_JPRB, &
  & 0.31794127E-06_JPRB, 0.31794042E-06_JPRB, 0.31793934E-06_JPRB, 0.31793803E-06_JPRB, 0.31793616E-06_JPRB, 0.31793377E-06_JPRB, &
  & 0.31793087E-06_JPRB, 0.31792783E-06_JPRB, 0.31792439E-06_JPRB, 0.31792052E-06_JPRB, 0.31791683E-06_JPRB, 0.31791296E-06_JPRB, &
  & 0.31790876E-06_JPRB, 0.31790353E-06_JPRB, 0.31789560E-06_JPRB, 0.31787931E-06_JPRB /)

RGHG3(:,72,10) = (/ &
  & 0.31783233E-06_JPRB, 0.31785379E-06_JPRB, 0.31786320E-06_JPRB, 0.31786936E-06_JPRB, 0.31787417E-06_JPRB, 0.31787852E-06_JPRB, &
  & 0.31788247E-06_JPRB, 0.31788625E-06_JPRB, 0.31789003E-06_JPRB, 0.31789446E-06_JPRB, 0.31789833E-06_JPRB, 0.31790211E-06_JPRB, &
  & 0.31790529E-06_JPRB, 0.31790910E-06_JPRB, 0.31790861E-06_JPRB, 0.31790717E-06_JPRB, 0.31790415E-06_JPRB, 0.31789989E-06_JPRB, &
  & 0.31789480E-06_JPRB, 0.31789125E-06_JPRB, 0.31789017E-06_JPRB, 0.31789199E-06_JPRB, 0.31789716E-06_JPRB, 0.31790552E-06_JPRB, &
  & 0.31791609E-06_JPRB, 0.31792808E-06_JPRB, 0.31794013E-06_JPRB, 0.31795201E-06_JPRB, 0.31796299E-06_JPRB, 0.31797208E-06_JPRB, &
  & 0.31797967E-06_JPRB, 0.31798504E-06_JPRB, 0.31798859E-06_JPRB, 0.31799075E-06_JPRB, 0.31799067E-06_JPRB, 0.31798956E-06_JPRB, &
  & 0.31798655E-06_JPRB, 0.31798294E-06_JPRB, 0.31797813E-06_JPRB, 0.31797231E-06_JPRB, 0.31796668E-06_JPRB, 0.31796148E-06_JPRB, &
  & 0.31795753E-06_JPRB, 0.31795472E-06_JPRB, 0.31795295E-06_JPRB, 0.31795176E-06_JPRB, 0.31795108E-06_JPRB, 0.31795108E-06_JPRB, &
  & 0.31795045E-06_JPRB, 0.31794974E-06_JPRB, 0.31794875E-06_JPRB, 0.31794758E-06_JPRB, 0.31794599E-06_JPRB, 0.31794380E-06_JPRB, &
  & 0.31794110E-06_JPRB, 0.31793857E-06_JPRB, 0.31793545E-06_JPRB, 0.31793184E-06_JPRB, 0.31792860E-06_JPRB, 0.31792484E-06_JPRB, &
  & 0.31792078E-06_JPRB, 0.31791575E-06_JPRB, 0.31790768E-06_JPRB, 0.31789114E-06_JPRB /)

RGHG3(:,73,10) = (/ &
  & 0.31785322E-06_JPRB, 0.31787459E-06_JPRB, 0.31788366E-06_JPRB, 0.31788949E-06_JPRB, 0.31789401E-06_JPRB, 0.31789830E-06_JPRB, &
  & 0.31790208E-06_JPRB, 0.31790535E-06_JPRB, 0.31790901E-06_JPRB, 0.31791240E-06_JPRB, 0.31791603E-06_JPRB, 0.31791882E-06_JPRB, &
  & 0.31792129E-06_JPRB, 0.31792354E-06_JPRB, 0.31792393E-06_JPRB, 0.31792314E-06_JPRB, 0.31792072E-06_JPRB, 0.31791717E-06_JPRB, &
  & 0.31791268E-06_JPRB, 0.31790947E-06_JPRB, 0.31790856E-06_JPRB, 0.31791006E-06_JPRB, 0.31791421E-06_JPRB, 0.31792121E-06_JPRB, &
  & 0.31793004E-06_JPRB, 0.31794016E-06_JPRB, 0.31795008E-06_JPRB, 0.31796023E-06_JPRB, 0.31796938E-06_JPRB, 0.31797700E-06_JPRB, &
  & 0.31798331E-06_JPRB, 0.31798774E-06_JPRB, 0.31799067E-06_JPRB, 0.31799269E-06_JPRB, 0.31799269E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31798908E-06_JPRB, 0.31798632E-06_JPRB, 0.31798228E-06_JPRB, 0.31797725E-06_JPRB, 0.31797259E-06_JPRB, 0.31796822E-06_JPRB, &
  & 0.31796509E-06_JPRB, 0.31796273E-06_JPRB, 0.31796120E-06_JPRB, 0.31796014E-06_JPRB, 0.31795952E-06_JPRB, 0.31795966E-06_JPRB, &
  & 0.31795904E-06_JPRB, 0.31795844E-06_JPRB, 0.31795759E-06_JPRB, 0.31795670E-06_JPRB, 0.31795540E-06_JPRB, 0.31795332E-06_JPRB, &
  & 0.31795099E-06_JPRB, 0.31794872E-06_JPRB, 0.31794619E-06_JPRB, 0.31794301E-06_JPRB, 0.31794002E-06_JPRB, 0.31793672E-06_JPRB, &
  & 0.31793283E-06_JPRB, 0.31792825E-06_JPRB, 0.31792067E-06_JPRB, 0.31790427E-06_JPRB /)

RGHG3(:,74,10) = (/ &
  & 0.31787471E-06_JPRB, 0.31789537E-06_JPRB, 0.31790370E-06_JPRB, 0.31790887E-06_JPRB, 0.31791296E-06_JPRB, 0.31791703E-06_JPRB, &
  & 0.31792052E-06_JPRB, 0.31792359E-06_JPRB, 0.31792638E-06_JPRB, 0.31792970E-06_JPRB, 0.31793218E-06_JPRB, 0.31793479E-06_JPRB, &
  & 0.31793664E-06_JPRB, 0.31793985E-06_JPRB, 0.31793883E-06_JPRB, 0.31793795E-06_JPRB, 0.31793593E-06_JPRB, 0.31793331E-06_JPRB, &
  & 0.31792942E-06_JPRB, 0.31792652E-06_JPRB, 0.31792575E-06_JPRB, 0.31792692E-06_JPRB, 0.31793013E-06_JPRB, 0.31793584E-06_JPRB, &
  & 0.31794309E-06_JPRB, 0.31795153E-06_JPRB, 0.31795946E-06_JPRB, 0.31796787E-06_JPRB, 0.31797532E-06_JPRB, 0.31798149E-06_JPRB, &
  & 0.31798660E-06_JPRB, 0.31799013E-06_JPRB, 0.31799249E-06_JPRB, 0.31799442E-06_JPRB, 0.31799451E-06_JPRB, 0.31799343E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31798930E-06_JPRB, 0.31798604E-06_JPRB, 0.31798177E-06_JPRB, 0.31797811E-06_JPRB, 0.31797458E-06_JPRB, &
  & 0.31797217E-06_JPRB, 0.31797015E-06_JPRB, 0.31796895E-06_JPRB, 0.31796787E-06_JPRB, 0.31796716E-06_JPRB, 0.31796756E-06_JPRB, &
  & 0.31796682E-06_JPRB, 0.31796651E-06_JPRB, 0.31796577E-06_JPRB, 0.31796515E-06_JPRB, 0.31796424E-06_JPRB, 0.31796242E-06_JPRB, &
  & 0.31796009E-06_JPRB, 0.31795838E-06_JPRB, 0.31795625E-06_JPRB, 0.31795355E-06_JPRB, 0.31795128E-06_JPRB, 0.31794801E-06_JPRB, &
  & 0.31794474E-06_JPRB, 0.31794067E-06_JPRB, 0.31793348E-06_JPRB, 0.31791828E-06_JPRB /)

RGHG3(:,75,10) = (/ &
  & 0.31789634E-06_JPRB, 0.31791546E-06_JPRB, 0.31792297E-06_JPRB, 0.31792726E-06_JPRB, 0.31793070E-06_JPRB, 0.31793451E-06_JPRB, &
  & 0.31793783E-06_JPRB, 0.31794013E-06_JPRB, 0.31794275E-06_JPRB, 0.31794508E-06_JPRB, 0.31794750E-06_JPRB, 0.31794912E-06_JPRB, &
  & 0.31795034E-06_JPRB, 0.31795247E-06_JPRB, 0.31795193E-06_JPRB, 0.31795128E-06_JPRB, 0.31794980E-06_JPRB, 0.31794815E-06_JPRB, &
  & 0.31794485E-06_JPRB, 0.31794229E-06_JPRB, 0.31794173E-06_JPRB, 0.31794258E-06_JPRB, 0.31794497E-06_JPRB, 0.31794940E-06_JPRB, &
  & 0.31795511E-06_JPRB, 0.31796210E-06_JPRB, 0.31796813E-06_JPRB, 0.31797501E-06_JPRB, 0.31798072E-06_JPRB, 0.31798552E-06_JPRB, &
  & 0.31798956E-06_JPRB, 0.31799220E-06_JPRB, 0.31799394E-06_JPRB, 0.31799590E-06_JPRB, 0.31799621E-06_JPRB, 0.31799505E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799200E-06_JPRB, 0.31798950E-06_JPRB, 0.31798589E-06_JPRB, 0.31798328E-06_JPRB, 0.31798044E-06_JPRB, &
  & 0.31797879E-06_JPRB, 0.31797714E-06_JPRB, 0.31797612E-06_JPRB, 0.31797498E-06_JPRB, 0.31797418E-06_JPRB, 0.31797487E-06_JPRB, &
  & 0.31797404E-06_JPRB, 0.31797393E-06_JPRB, 0.31797322E-06_JPRB, 0.31797296E-06_JPRB, 0.31797239E-06_JPRB, 0.31797057E-06_JPRB, &
  & 0.31796850E-06_JPRB, 0.31796705E-06_JPRB, 0.31796569E-06_JPRB, 0.31796350E-06_JPRB, 0.31796171E-06_JPRB, 0.31795904E-06_JPRB, &
  & 0.31795597E-06_JPRB, 0.31795258E-06_JPRB, 0.31794622E-06_JPRB, 0.31793226E-06_JPRB /)

RGHG3(:,76,10) = (/ &
  & 0.31791740E-06_JPRB, 0.31793499E-06_JPRB, 0.31794124E-06_JPRB, 0.31794437E-06_JPRB, 0.31794698E-06_JPRB, 0.31795065E-06_JPRB, &
  & 0.31795363E-06_JPRB, 0.31795548E-06_JPRB, 0.31795730E-06_JPRB, 0.31795966E-06_JPRB, 0.31796114E-06_JPRB, 0.31796245E-06_JPRB, &
  & 0.31796282E-06_JPRB, 0.31796489E-06_JPRB, 0.31796375E-06_JPRB, 0.31796341E-06_JPRB, 0.31796250E-06_JPRB, 0.31796199E-06_JPRB, &
  & 0.31795923E-06_JPRB, 0.31795682E-06_JPRB, 0.31795645E-06_JPRB, 0.31795713E-06_JPRB, 0.31795872E-06_JPRB, 0.31796208E-06_JPRB, &
  & 0.31796648E-06_JPRB, 0.31797200E-06_JPRB, 0.31797617E-06_JPRB, 0.31798155E-06_JPRB, 0.31798569E-06_JPRB, 0.31798913E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799402E-06_JPRB, 0.31799522E-06_JPRB, 0.31799732E-06_JPRB, 0.31799772E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799479E-06_JPRB, 0.31799442E-06_JPRB, 0.31799254E-06_JPRB, 0.31798959E-06_JPRB, 0.31798797E-06_JPRB, 0.31798598E-06_JPRB, &
  & 0.31798496E-06_JPRB, 0.31798371E-06_JPRB, 0.31798282E-06_JPRB, 0.31798157E-06_JPRB, 0.31798058E-06_JPRB, 0.31798155E-06_JPRB, &
  & 0.31798055E-06_JPRB, 0.31798069E-06_JPRB, 0.31797993E-06_JPRB, 0.31798015E-06_JPRB, 0.31797993E-06_JPRB, 0.31797811E-06_JPRB, &
  & 0.31797583E-06_JPRB, 0.31797489E-06_JPRB, 0.31797433E-06_JPRB, 0.31797248E-06_JPRB, 0.31797171E-06_JPRB, 0.31796890E-06_JPRB, &
  & 0.31796660E-06_JPRB, 0.31796384E-06_JPRB, 0.31795844E-06_JPRB, 0.31794633E-06_JPRB /)

RGHG3(:,77,10) = (/ &
  & 0.31793797E-06_JPRB, 0.31795344E-06_JPRB, 0.31795835E-06_JPRB, 0.31796006E-06_JPRB, 0.31796174E-06_JPRB, 0.31796534E-06_JPRB, &
  & 0.31796827E-06_JPRB, 0.31796932E-06_JPRB, 0.31797066E-06_JPRB, 0.31797248E-06_JPRB, 0.31797353E-06_JPRB, 0.31797418E-06_JPRB, &
  & 0.31797393E-06_JPRB, 0.31797535E-06_JPRB, 0.31797396E-06_JPRB, 0.31797398E-06_JPRB, 0.31797379E-06_JPRB, 0.31797441E-06_JPRB, &
  & 0.31797217E-06_JPRB, 0.31797003E-06_JPRB, 0.31796998E-06_JPRB, 0.31797049E-06_JPRB, 0.31797128E-06_JPRB, 0.31797362E-06_JPRB, &
  & 0.31797683E-06_JPRB, 0.31798112E-06_JPRB, 0.31798348E-06_JPRB, 0.31798760E-06_JPRB, 0.31799013E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799462E-06_JPRB, 0.31799556E-06_JPRB, 0.31799624E-06_JPRB, 0.31799843E-06_JPRB, 0.31799917E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799661E-06_JPRB, 0.31799536E-06_JPRB, 0.31799280E-06_JPRB, 0.31799223E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31798973E-06_JPRB, 0.31798896E-06_JPRB, 0.31798749E-06_JPRB, 0.31798629E-06_JPRB, 0.31798774E-06_JPRB, &
  & 0.31798635E-06_JPRB, 0.31798689E-06_JPRB, 0.31798601E-06_JPRB, 0.31798666E-06_JPRB, 0.31798689E-06_JPRB, 0.31798476E-06_JPRB, &
  & 0.31798245E-06_JPRB, 0.31798191E-06_JPRB, 0.31798226E-06_JPRB, 0.31798069E-06_JPRB, 0.31798069E-06_JPRB, 0.31797822E-06_JPRB, &
  & 0.31797632E-06_JPRB, 0.31797447E-06_JPRB, 0.31796992E-06_JPRB, 0.31796009E-06_JPRB /)

RGHG3(:,78,10) = (/ &
  & 0.31795796E-06_JPRB, 0.31797015E-06_JPRB, 0.31797322E-06_JPRB, 0.31797342E-06_JPRB, 0.31797413E-06_JPRB, 0.31797774E-06_JPRB, &
  & 0.31798069E-06_JPRB, 0.31798101E-06_JPRB, 0.31798160E-06_JPRB, 0.31798336E-06_JPRB, 0.31798356E-06_JPRB, 0.31798371E-06_JPRB, &
  & 0.31798285E-06_JPRB, 0.31798371E-06_JPRB, 0.31798240E-06_JPRB, 0.31798263E-06_JPRB, 0.31798308E-06_JPRB, 0.31798496E-06_JPRB, &
  & 0.31798322E-06_JPRB, 0.31798126E-06_JPRB, 0.31798157E-06_JPRB, 0.31798197E-06_JPRB, 0.31798214E-06_JPRB, 0.31798356E-06_JPRB, &
  & 0.31798578E-06_JPRB, 0.31798893E-06_JPRB, 0.31798967E-06_JPRB, 0.31799274E-06_JPRB, 0.31799385E-06_JPRB, 0.31799510E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799692E-06_JPRB, 0.31799706E-06_JPRB, 0.31799931E-06_JPRB, 0.31800033E-06_JPRB, 0.31799874E-06_JPRB, &
  & 0.31799723E-06_JPRB, 0.31799843E-06_JPRB, 0.31799763E-06_JPRB, 0.31799547E-06_JPRB, 0.31799587E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799485E-06_JPRB, 0.31799411E-06_JPRB, 0.31799246E-06_JPRB, 0.31799092E-06_JPRB, 0.31799291E-06_JPRB, &
  & 0.31799115E-06_JPRB, 0.31799203E-06_JPRB, 0.31799092E-06_JPRB, 0.31799203E-06_JPRB, 0.31799286E-06_JPRB, 0.31799036E-06_JPRB, &
  & 0.31798771E-06_JPRB, 0.31798754E-06_JPRB, 0.31798891E-06_JPRB, 0.31798751E-06_JPRB, 0.31798859E-06_JPRB, 0.31798584E-06_JPRB, &
  & 0.31798470E-06_JPRB, 0.31798353E-06_JPRB, 0.31798029E-06_JPRB, 0.31797347E-06_JPRB /)

RGHG3(:,79,10) = (/ &
  & 0.31797097E-06_JPRB, 0.31797970E-06_JPRB, 0.31798126E-06_JPRB, 0.31798015E-06_JPRB, 0.31798015E-06_JPRB, 0.31798413E-06_JPRB, &
  & 0.31798749E-06_JPRB, 0.31798709E-06_JPRB, 0.31798717E-06_JPRB, 0.31798905E-06_JPRB, 0.31798888E-06_JPRB, 0.31798874E-06_JPRB, &
  & 0.31798734E-06_JPRB, 0.31798785E-06_JPRB, 0.31798655E-06_JPRB, 0.31798703E-06_JPRB, 0.31798794E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31798928E-06_JPRB, 0.31798726E-06_JPRB, 0.31798788E-06_JPRB, 0.31798834E-06_JPRB, 0.31798814E-06_JPRB, 0.31798905E-06_JPRB, &
  & 0.31799075E-06_JPRB, 0.31799340E-06_JPRB, 0.31799314E-06_JPRB, 0.31799567E-06_JPRB, 0.31799587E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31799755E-06_JPRB, 0.31799752E-06_JPRB, 0.31799738E-06_JPRB, 0.31799993E-06_JPRB, 0.31800124E-06_JPRB, 0.31799937E-06_JPRB, &
  & 0.31799772E-06_JPRB, 0.31799951E-06_JPRB, 0.31799897E-06_JPRB, 0.31799695E-06_JPRB, 0.31799794E-06_JPRB, 0.31799794E-06_JPRB, &
  & 0.31799848E-06_JPRB, 0.31799789E-06_JPRB, 0.31799715E-06_JPRB, 0.31799507E-06_JPRB, 0.31799328E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799354E-06_JPRB, 0.31799490E-06_JPRB, 0.31799345E-06_JPRB, 0.31799507E-06_JPRB, 0.31799635E-06_JPRB, 0.31799323E-06_JPRB, &
  & 0.31799010E-06_JPRB, 0.31799024E-06_JPRB, 0.31799243E-06_JPRB, 0.31799095E-06_JPRB, 0.31799280E-06_JPRB, 0.31798970E-06_JPRB, &
  & 0.31798885E-06_JPRB, 0.31798834E-06_JPRB, 0.31798589E-06_JPRB, 0.31798211E-06_JPRB /)

RGHG3(:,80,10) = (/ &
  & 0.31797990E-06_JPRB, 0.31798442E-06_JPRB, 0.31798487E-06_JPRB, 0.31798302E-06_JPRB, 0.31798263E-06_JPRB, 0.31798692E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31798982E-06_JPRB, 0.31798973E-06_JPRB, 0.31799172E-06_JPRB, 0.31799135E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31798930E-06_JPRB, 0.31798970E-06_JPRB, 0.31798831E-06_JPRB, 0.31798893E-06_JPRB, 0.31799016E-06_JPRB, 0.31799371E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31798999E-06_JPRB, 0.31799087E-06_JPRB, 0.31799129E-06_JPRB, 0.31799092E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799556E-06_JPRB, 0.31799482E-06_JPRB, 0.31799709E-06_JPRB, 0.31799689E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31799797E-06_JPRB, 0.31799775E-06_JPRB, 0.31799743E-06_JPRB, 0.31800030E-06_JPRB, 0.31800178E-06_JPRB, 0.31799973E-06_JPRB, &
  & 0.31799792E-06_JPRB, 0.31800010E-06_JPRB, 0.31799973E-06_JPRB, 0.31799769E-06_JPRB, 0.31799897E-06_JPRB, 0.31799922E-06_JPRB, &
  & 0.31799999E-06_JPRB, 0.31799942E-06_JPRB, 0.31799863E-06_JPRB, 0.31799638E-06_JPRB, 0.31799431E-06_JPRB, 0.31799712E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799613E-06_JPRB, 0.31799453E-06_JPRB, 0.31799647E-06_JPRB, 0.31799803E-06_JPRB, 0.31799451E-06_JPRB, &
  & 0.31799101E-06_JPRB, 0.31799129E-06_JPRB, 0.31799394E-06_JPRB, 0.31799232E-06_JPRB, 0.31799479E-06_JPRB, 0.31799127E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31799041E-06_JPRB, 0.31798857E-06_JPRB, 0.31798794E-06_JPRB /)

RGHG3(:,81,10) = (/ &
  & 0.31798621E-06_JPRB, 0.31798655E-06_JPRB, 0.31798641E-06_JPRB, 0.31798425E-06_JPRB, 0.31798362E-06_JPRB, 0.31798811E-06_JPRB, &
  & 0.31799203E-06_JPRB, 0.31799101E-06_JPRB, 0.31799073E-06_JPRB, 0.31799294E-06_JPRB, 0.31799240E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31799016E-06_JPRB, 0.31799044E-06_JPRB, 0.31798908E-06_JPRB, 0.31798976E-06_JPRB, 0.31799109E-06_JPRB, 0.31799510E-06_JPRB, &
  & 0.31799357E-06_JPRB, 0.31799129E-06_JPRB, 0.31799226E-06_JPRB, 0.31799269E-06_JPRB, 0.31799226E-06_JPRB, 0.31799277E-06_JPRB, &
  & 0.31799419E-06_JPRB, 0.31799652E-06_JPRB, 0.31799561E-06_JPRB, 0.31799777E-06_JPRB, 0.31799732E-06_JPRB, 0.31799755E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799780E-06_JPRB, 0.31799740E-06_JPRB, 0.31800045E-06_JPRB, 0.31800201E-06_JPRB, 0.31799982E-06_JPRB, &
  & 0.31799809E-06_JPRB, 0.31800033E-06_JPRB, 0.31800005E-06_JPRB, 0.31799803E-06_JPRB, 0.31799948E-06_JPRB, 0.31799988E-06_JPRB, &
  & 0.31800079E-06_JPRB, 0.31800028E-06_JPRB, 0.31799942E-06_JPRB, 0.31799695E-06_JPRB, 0.31799465E-06_JPRB, 0.31799777E-06_JPRB, &
  & 0.31799499E-06_JPRB, 0.31799681E-06_JPRB, 0.31799499E-06_JPRB, 0.31799709E-06_JPRB, 0.31799885E-06_JPRB, 0.31799502E-06_JPRB, &
  & 0.31799135E-06_JPRB, 0.31799166E-06_JPRB, 0.31799459E-06_JPRB, 0.31799286E-06_JPRB, 0.31799561E-06_JPRB, 0.31799189E-06_JPRB, &
  & 0.31799132E-06_JPRB, 0.31799121E-06_JPRB, 0.31798965E-06_JPRB, 0.31799200E-06_JPRB /)

RGHG3(:,82,10) = (/ &
  & 0.31798677E-06_JPRB, 0.31798729E-06_JPRB, 0.31798709E-06_JPRB, 0.31798473E-06_JPRB, 0.31798402E-06_JPRB, 0.31798874E-06_JPRB, &
  & 0.31799274E-06_JPRB, 0.31799169E-06_JPRB, 0.31799144E-06_JPRB, 0.31799348E-06_JPRB, 0.31799291E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31799053E-06_JPRB, 0.31799073E-06_JPRB, 0.31798933E-06_JPRB, 0.31799007E-06_JPRB, 0.31799155E-06_JPRB, 0.31799587E-06_JPRB, &
  & 0.31799428E-06_JPRB, 0.31799189E-06_JPRB, 0.31799303E-06_JPRB, 0.31799348E-06_JPRB, 0.31799291E-06_JPRB, 0.31799337E-06_JPRB, &
  & 0.31799482E-06_JPRB, 0.31799715E-06_JPRB, 0.31799613E-06_JPRB, 0.31799811E-06_JPRB, 0.31799757E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799777E-06_JPRB, 0.31799738E-06_JPRB, 0.31800056E-06_JPRB, 0.31800221E-06_JPRB, 0.31799991E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31800042E-06_JPRB, 0.31800025E-06_JPRB, 0.31799817E-06_JPRB, 0.31799971E-06_JPRB, 0.31800025E-06_JPRB, &
  & 0.31800130E-06_JPRB, 0.31800079E-06_JPRB, 0.31799988E-06_JPRB, 0.31799723E-06_JPRB, 0.31799482E-06_JPRB, 0.31799817E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799709E-06_JPRB, 0.31799519E-06_JPRB, 0.31799743E-06_JPRB, 0.31799931E-06_JPRB, 0.31799522E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31799178E-06_JPRB, 0.31799493E-06_JPRB, 0.31799311E-06_JPRB, 0.31799604E-06_JPRB, 0.31799217E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799149E-06_JPRB, 0.31798996E-06_JPRB, 0.31799232E-06_JPRB /)

RGHG3(:,83,10) = (/ &
  & 0.31798720E-06_JPRB, 0.31798771E-06_JPRB, 0.31798746E-06_JPRB, 0.31798498E-06_JPRB, 0.31798425E-06_JPRB, 0.31798908E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799203E-06_JPRB, 0.31799172E-06_JPRB, 0.31799382E-06_JPRB, 0.31799328E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799081E-06_JPRB, 0.31799087E-06_JPRB, 0.31798950E-06_JPRB, 0.31799036E-06_JPRB, 0.31799186E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799476E-06_JPRB, 0.31799232E-06_JPRB, 0.31799351E-06_JPRB, 0.31799394E-06_JPRB, 0.31799328E-06_JPRB, 0.31799377E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799746E-06_JPRB, 0.31799638E-06_JPRB, 0.31799840E-06_JPRB, 0.31799772E-06_JPRB, 0.31799780E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799772E-06_JPRB, 0.31799732E-06_JPRB, 0.31800064E-06_JPRB, 0.31800235E-06_JPRB, 0.31799996E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31800047E-06_JPRB, 0.31800028E-06_JPRB, 0.31799837E-06_JPRB, 0.31799991E-06_JPRB, 0.31800045E-06_JPRB, &
  & 0.31800155E-06_JPRB, 0.31800113E-06_JPRB, 0.31800019E-06_JPRB, 0.31799743E-06_JPRB, 0.31799485E-06_JPRB, 0.31799843E-06_JPRB, &
  & 0.31799522E-06_JPRB, 0.31799729E-06_JPRB, 0.31799524E-06_JPRB, 0.31799757E-06_JPRB, 0.31799956E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31799181E-06_JPRB, 0.31799513E-06_JPRB, 0.31799323E-06_JPRB, 0.31799630E-06_JPRB, 0.31799229E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799158E-06_JPRB, 0.31799013E-06_JPRB, 0.31799260E-06_JPRB /)

RGHG3(:,84,10) = (/ &
  & 0.31798743E-06_JPRB, 0.31798800E-06_JPRB, 0.31798780E-06_JPRB, 0.31798510E-06_JPRB, 0.31798430E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799235E-06_JPRB, 0.31799215E-06_JPRB, 0.31799385E-06_JPRB, 0.31799340E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799098E-06_JPRB, 0.31799092E-06_JPRB, 0.31798962E-06_JPRB, 0.31799047E-06_JPRB, 0.31799203E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31799507E-06_JPRB, 0.31799254E-06_JPRB, 0.31799388E-06_JPRB, 0.31799431E-06_JPRB, 0.31799360E-06_JPRB, 0.31799399E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799769E-06_JPRB, 0.31799649E-06_JPRB, 0.31799857E-06_JPRB, 0.31799777E-06_JPRB, 0.31799786E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799772E-06_JPRB, 0.31799726E-06_JPRB, 0.31800064E-06_JPRB, 0.31800238E-06_JPRB, 0.31800005E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31800050E-06_JPRB, 0.31800039E-06_JPRB, 0.31799848E-06_JPRB, 0.31799993E-06_JPRB, 0.31800059E-06_JPRB, &
  & 0.31800181E-06_JPRB, 0.31800133E-06_JPRB, 0.31800039E-06_JPRB, 0.31799755E-06_JPRB, 0.31799482E-06_JPRB, 0.31799851E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799738E-06_JPRB, 0.31799530E-06_JPRB, 0.31799769E-06_JPRB, 0.31799976E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799124E-06_JPRB, 0.31799172E-06_JPRB, 0.31799516E-06_JPRB, 0.31799325E-06_JPRB, 0.31799652E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799169E-06_JPRB, 0.31799019E-06_JPRB, 0.31799277E-06_JPRB /)

RGHG3(:,85,10) = (/ &
  & 0.31798766E-06_JPRB, 0.31798825E-06_JPRB, 0.31798800E-06_JPRB, 0.31798524E-06_JPRB, 0.31798433E-06_JPRB, 0.31798970E-06_JPRB, &
  & 0.31799328E-06_JPRB, 0.31799260E-06_JPRB, 0.31799246E-06_JPRB, 0.31799374E-06_JPRB, 0.31799340E-06_JPRB, 0.31799274E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31799092E-06_JPRB, 0.31798987E-06_JPRB, 0.31799064E-06_JPRB, 0.31799215E-06_JPRB, 0.31799669E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799277E-06_JPRB, 0.31799408E-06_JPRB, 0.31799456E-06_JPRB, 0.31799382E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799800E-06_JPRB, 0.31799667E-06_JPRB, 0.31799877E-06_JPRB, 0.31799786E-06_JPRB, 0.31799780E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31799766E-06_JPRB, 0.31799721E-06_JPRB, 0.31800070E-06_JPRB, 0.31800249E-06_JPRB, 0.31800008E-06_JPRB, &
  & 0.31799831E-06_JPRB, 0.31800056E-06_JPRB, 0.31800036E-06_JPRB, 0.31799854E-06_JPRB, 0.31800002E-06_JPRB, 0.31800067E-06_JPRB, &
  & 0.31800215E-06_JPRB, 0.31800161E-06_JPRB, 0.31800056E-06_JPRB, 0.31799766E-06_JPRB, 0.31799482E-06_JPRB, 0.31799863E-06_JPRB, &
  & 0.31799533E-06_JPRB, 0.31799749E-06_JPRB, 0.31799533E-06_JPRB, 0.31799777E-06_JPRB, 0.31800002E-06_JPRB, 0.31799553E-06_JPRB, &
  & 0.31799118E-06_JPRB, 0.31799169E-06_JPRB, 0.31799527E-06_JPRB, 0.31799325E-06_JPRB, 0.31799658E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31799175E-06_JPRB, 0.31799021E-06_JPRB, 0.31799291E-06_JPRB /)

RGHG3(:,86,10) = (/ &
  & 0.31798771E-06_JPRB, 0.31798834E-06_JPRB, 0.31798811E-06_JPRB, 0.31798524E-06_JPRB, 0.31798464E-06_JPRB, 0.31798939E-06_JPRB, &
  & 0.31799325E-06_JPRB, 0.31799283E-06_JPRB, 0.31799274E-06_JPRB, 0.31799345E-06_JPRB, 0.31799317E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799141E-06_JPRB, 0.31799101E-06_JPRB, 0.31799024E-06_JPRB, 0.31799084E-06_JPRB, 0.31799232E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799289E-06_JPRB, 0.31799419E-06_JPRB, 0.31799470E-06_JPRB, 0.31799385E-06_JPRB, 0.31799422E-06_JPRB, &
  & 0.31799561E-06_JPRB, 0.31799820E-06_JPRB, 0.31799667E-06_JPRB, 0.31799894E-06_JPRB, 0.31799789E-06_JPRB, 0.31799783E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31799757E-06_JPRB, 0.31799712E-06_JPRB, 0.31800073E-06_JPRB, 0.31800255E-06_JPRB, 0.31800008E-06_JPRB, &
  & 0.31799826E-06_JPRB, 0.31800062E-06_JPRB, 0.31800042E-06_JPRB, 0.31799848E-06_JPRB, 0.31800005E-06_JPRB, 0.31800076E-06_JPRB, &
  & 0.31800238E-06_JPRB, 0.31800178E-06_JPRB, 0.31800070E-06_JPRB, 0.31799772E-06_JPRB, 0.31799479E-06_JPRB, 0.31799874E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799752E-06_JPRB, 0.31799527E-06_JPRB, 0.31799786E-06_JPRB, 0.31800016E-06_JPRB, 0.31799556E-06_JPRB, &
  & 0.31799107E-06_JPRB, 0.31799158E-06_JPRB, 0.31799527E-06_JPRB, 0.31799323E-06_JPRB, 0.31799669E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799181E-06_JPRB, 0.31799172E-06_JPRB, 0.31799019E-06_JPRB, 0.31799303E-06_JPRB /)

RGHG3(:,87,10) = (/ &
  & 0.31798774E-06_JPRB, 0.31798837E-06_JPRB, 0.31798808E-06_JPRB, 0.31798513E-06_JPRB, 0.31798447E-06_JPRB, 0.31799044E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799271E-06_JPRB, 0.31799269E-06_JPRB, 0.31799323E-06_JPRB, 0.31799300E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799118E-06_JPRB, 0.31799050E-06_JPRB, 0.31799107E-06_JPRB, 0.31799249E-06_JPRB, 0.31799618E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799308E-06_JPRB, 0.31799431E-06_JPRB, 0.31799482E-06_JPRB, 0.31799394E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799567E-06_JPRB, 0.31799851E-06_JPRB, 0.31799664E-06_JPRB, 0.31799914E-06_JPRB, 0.31799783E-06_JPRB, 0.31799775E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31799752E-06_JPRB, 0.31799703E-06_JPRB, 0.31800073E-06_JPRB, 0.31800266E-06_JPRB, 0.31800010E-06_JPRB, &
  & 0.31799823E-06_JPRB, 0.31800073E-06_JPRB, 0.31800050E-06_JPRB, 0.31799834E-06_JPRB, 0.31800010E-06_JPRB, 0.31800079E-06_JPRB, &
  & 0.31800258E-06_JPRB, 0.31800192E-06_JPRB, 0.31800073E-06_JPRB, 0.31799769E-06_JPRB, 0.31799479E-06_JPRB, 0.31799880E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799752E-06_JPRB, 0.31799530E-06_JPRB, 0.31799786E-06_JPRB, 0.31800028E-06_JPRB, 0.31799547E-06_JPRB, &
  & 0.31799098E-06_JPRB, 0.31799155E-06_JPRB, 0.31799527E-06_JPRB, 0.31799317E-06_JPRB, 0.31799675E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31799183E-06_JPRB, 0.31799172E-06_JPRB, 0.31799007E-06_JPRB, 0.31799306E-06_JPRB /)

RGHG3(:,88,10) = (/ &
  & 0.31798771E-06_JPRB, 0.31798842E-06_JPRB, 0.31798811E-06_JPRB, 0.31798521E-06_JPRB, 0.31798504E-06_JPRB, 0.31798942E-06_JPRB, &
  & 0.31799308E-06_JPRB, 0.31799291E-06_JPRB, 0.31799289E-06_JPRB, 0.31799325E-06_JPRB, 0.31799300E-06_JPRB, 0.31799249E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799118E-06_JPRB, 0.31799064E-06_JPRB, 0.31799115E-06_JPRB, 0.31799249E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799320E-06_JPRB, 0.31799442E-06_JPRB, 0.31799496E-06_JPRB, 0.31799402E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799874E-06_JPRB, 0.31799658E-06_JPRB, 0.31799937E-06_JPRB, 0.31799783E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799746E-06_JPRB, 0.31799692E-06_JPRB, 0.31800082E-06_JPRB, 0.31800266E-06_JPRB, 0.31800016E-06_JPRB, &
  & 0.31799811E-06_JPRB, 0.31800079E-06_JPRB, 0.31800059E-06_JPRB, 0.31799823E-06_JPRB, 0.31800016E-06_JPRB, 0.31800084E-06_JPRB, &
  & 0.31800272E-06_JPRB, 0.31800198E-06_JPRB, 0.31800082E-06_JPRB, 0.31799766E-06_JPRB, 0.31799479E-06_JPRB, 0.31799880E-06_JPRB, &
  & 0.31799544E-06_JPRB, 0.31799752E-06_JPRB, 0.31799524E-06_JPRB, 0.31799789E-06_JPRB, 0.31800033E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799095E-06_JPRB, 0.31799149E-06_JPRB, 0.31799530E-06_JPRB, 0.31799311E-06_JPRB, 0.31799678E-06_JPRB, 0.31799240E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799163E-06_JPRB, 0.31799007E-06_JPRB, 0.31799308E-06_JPRB /)

RGHG3(:,89,10) = (/ &
  & 0.31798771E-06_JPRB, 0.31798845E-06_JPRB, 0.31798814E-06_JPRB, 0.31798498E-06_JPRB, 0.31798416E-06_JPRB, 0.31799050E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799277E-06_JPRB, 0.31799274E-06_JPRB, 0.31799334E-06_JPRB, 0.31799311E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799155E-06_JPRB, 0.31799112E-06_JPRB, 0.31799050E-06_JPRB, 0.31799107E-06_JPRB, 0.31799252E-06_JPRB, 0.31799635E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799311E-06_JPRB, 0.31799439E-06_JPRB, 0.31799499E-06_JPRB, 0.31799402E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799897E-06_JPRB, 0.31799655E-06_JPRB, 0.31799948E-06_JPRB, 0.31799780E-06_JPRB, 0.31799775E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799749E-06_JPRB, 0.31799681E-06_JPRB, 0.31800090E-06_JPRB, 0.31800280E-06_JPRB, 0.31800016E-06_JPRB, &
  & 0.31799794E-06_JPRB, 0.31800084E-06_JPRB, 0.31800062E-06_JPRB, 0.31799809E-06_JPRB, 0.31800028E-06_JPRB, 0.31800090E-06_JPRB, &
  & 0.31800286E-06_JPRB, 0.31800204E-06_JPRB, 0.31800090E-06_JPRB, 0.31799769E-06_JPRB, 0.31799473E-06_JPRB, 0.31799885E-06_JPRB, &
  & 0.31799536E-06_JPRB, 0.31799749E-06_JPRB, 0.31799519E-06_JPRB, 0.31799792E-06_JPRB, 0.31800045E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799087E-06_JPRB, 0.31799149E-06_JPRB, 0.31799533E-06_JPRB, 0.31799306E-06_JPRB, 0.31799686E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799166E-06_JPRB, 0.31798999E-06_JPRB, 0.31799314E-06_JPRB /)

RGHG3(:,90,10) = (/ &
  & 0.31798777E-06_JPRB, 0.31798848E-06_JPRB, 0.31798825E-06_JPRB, 0.31798501E-06_JPRB, 0.31798407E-06_JPRB, 0.31798947E-06_JPRB, &
  & 0.31799368E-06_JPRB, 0.31799306E-06_JPRB, 0.31799283E-06_JPRB, 0.31799368E-06_JPRB, 0.31799334E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799132E-06_JPRB, 0.31799098E-06_JPRB, 0.31799010E-06_JPRB, 0.31799081E-06_JPRB, 0.31799237E-06_JPRB, 0.31799706E-06_JPRB, &
  & 0.31799578E-06_JPRB, 0.31799306E-06_JPRB, 0.31799448E-06_JPRB, 0.31799502E-06_JPRB, 0.31799399E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799570E-06_JPRB, 0.31799917E-06_JPRB, 0.31799644E-06_JPRB, 0.31799973E-06_JPRB, 0.31799783E-06_JPRB, 0.31799766E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799743E-06_JPRB, 0.31799658E-06_JPRB, 0.31800096E-06_JPRB, 0.31800309E-06_JPRB, 0.31800016E-06_JPRB, &
  & 0.31799775E-06_JPRB, 0.31800101E-06_JPRB, 0.31800073E-06_JPRB, 0.31799783E-06_JPRB, 0.31800036E-06_JPRB, 0.31800093E-06_JPRB, &
  & 0.31800300E-06_JPRB, 0.31800207E-06_JPRB, 0.31800099E-06_JPRB, 0.31799766E-06_JPRB, 0.31799456E-06_JPRB, 0.31799905E-06_JPRB, &
  & 0.31799527E-06_JPRB, 0.31799757E-06_JPRB, 0.31799505E-06_JPRB, 0.31799794E-06_JPRB, 0.31800067E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799067E-06_JPRB, 0.31799141E-06_JPRB, 0.31799556E-06_JPRB, 0.31799294E-06_JPRB, 0.31799706E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799166E-06_JPRB, 0.31799163E-06_JPRB, 0.31798993E-06_JPRB, 0.31799320E-06_JPRB /)

RGHG3(:,91,10) = (/ &
  & 0.31798771E-06_JPRB, 0.31798857E-06_JPRB, 0.31798865E-06_JPRB, 0.31798479E-06_JPRB, 0.31798288E-06_JPRB, 0.31798953E-06_JPRB, &
  & 0.31799499E-06_JPRB, 0.31799283E-06_JPRB, 0.31799169E-06_JPRB, 0.31799516E-06_JPRB, 0.31799397E-06_JPRB, 0.31799365E-06_JPRB, &
  & 0.31799019E-06_JPRB, 0.31799127E-06_JPRB, 0.31798896E-06_JPRB, 0.31799053E-06_JPRB, 0.31799181E-06_JPRB, 0.31799848E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799263E-06_JPRB, 0.31799451E-06_JPRB, 0.31799516E-06_JPRB, 0.31799388E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799962E-06_JPRB, 0.31799604E-06_JPRB, 0.31800010E-06_JPRB, 0.31799772E-06_JPRB, 0.31799757E-06_JPRB, &
  & 0.31799846E-06_JPRB, 0.31799752E-06_JPRB, 0.31799610E-06_JPRB, 0.31800127E-06_JPRB, 0.31800357E-06_JPRB, 0.31800010E-06_JPRB, &
  & 0.31799721E-06_JPRB, 0.31800133E-06_JPRB, 0.31800090E-06_JPRB, 0.31799749E-06_JPRB, 0.31800056E-06_JPRB, 0.31800084E-06_JPRB, &
  & 0.31800323E-06_JPRB, 0.31800212E-06_JPRB, 0.31800116E-06_JPRB, 0.31799760E-06_JPRB, 0.31799405E-06_JPRB, 0.31799959E-06_JPRB, &
  & 0.31799487E-06_JPRB, 0.31799789E-06_JPRB, 0.31799465E-06_JPRB, 0.31799800E-06_JPRB, 0.31800121E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799036E-06_JPRB, 0.31799118E-06_JPRB, 0.31799595E-06_JPRB, 0.31799257E-06_JPRB, 0.31799769E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31799158E-06_JPRB, 0.31799169E-06_JPRB, 0.31798976E-06_JPRB, 0.31799325E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG3(:, 1,11) = (/ &
  & 0.91352049E-07_JPRB, 0.91402264E-07_JPRB, 0.90972506E-07_JPRB, 0.90631772E-07_JPRB, 0.90373469E-07_JPRB, 0.90181040E-07_JPRB, &
  & 0.90030198E-07_JPRB, 0.89916441E-07_JPRB, 0.89859441E-07_JPRB, 0.89865246E-07_JPRB, 0.89929799E-07_JPRB, 0.90049944E-07_JPRB, &
  & 0.90224177E-07_JPRB, 0.90447941E-07_JPRB, 0.90715730E-07_JPRB, 0.91027864E-07_JPRB, 0.91360981E-07_JPRB, 0.91699178E-07_JPRB, &
  & 0.92030135E-07_JPRB, 0.92339690E-07_JPRB, 0.92615132E-07_JPRB, 0.92850172E-07_JPRB, 0.93046317E-07_JPRB, 0.93210673E-07_JPRB, &
  & 0.93351296E-07_JPRB, 0.93476316E-07_JPRB, 0.93594771E-07_JPRB, 0.93721432E-07_JPRB, 0.93843106E-07_JPRB, 0.93957141E-07_JPRB, &
  & 0.94062315E-07_JPRB, 0.94158203E-07_JPRB, 0.94244555E-07_JPRB, 0.94321962E-07_JPRB, 0.94391098E-07_JPRB, 0.94454826E-07_JPRB, &
  & 0.94514121E-07_JPRB, 0.94566637E-07_JPRB, 0.94613327E-07_JPRB, 0.94654268E-07_JPRB, 0.94688225E-07_JPRB, 0.94715617E-07_JPRB, &
  & 0.94736848E-07_JPRB, 0.94750384E-07_JPRB, 0.94757439E-07_JPRB, 0.94758349E-07_JPRB, 0.94752714E-07_JPRB, 0.94739633E-07_JPRB, &
  & 0.94718999E-07_JPRB, 0.94693725E-07_JPRB, 0.94671393E-07_JPRB, 0.94663015E-07_JPRB, 0.94678057E-07_JPRB, 0.94718438E-07_JPRB, &
  & 0.94776425E-07_JPRB, 0.94839976E-07_JPRB, 0.94900102E-07_JPRB, 0.94950948E-07_JPRB, 0.94992345E-07_JPRB, 0.95026479E-07_JPRB, &
  & 0.95051995E-07_JPRB, 0.95068955E-07_JPRB, 0.95079869E-07_JPRB, 0.95084658E-07_JPRB /)

RGHG3(:, 2,11) = (/ &
  & 0.91915879E-07_JPRB, 0.91434877E-07_JPRB, 0.90778663E-07_JPRB, 0.90522647E-07_JPRB, 0.90341160E-07_JPRB, 0.90255114E-07_JPRB, &
  & 0.90229506E-07_JPRB, 0.90260926E-07_JPRB, 0.90348045E-07_JPRB, 0.90481258E-07_JPRB, 0.90652506E-07_JPRB, 0.90883688E-07_JPRB, &
  & 0.91185946E-07_JPRB, 0.91573931E-07_JPRB, 0.92044786E-07_JPRB, 0.92569820E-07_JPRB, 0.93103338E-07_JPRB, 0.93605458E-07_JPRB, &
  & 0.94047209E-07_JPRB, 0.94411170E-07_JPRB, 0.94691423E-07_JPRB, 0.94893906E-07_JPRB, 0.95033158E-07_JPRB, 0.95125984E-07_JPRB, &
  & 0.95187488E-07_JPRB, 0.95228934E-07_JPRB, 0.95258535E-07_JPRB, 0.95280889E-07_JPRB, 0.95296457E-07_JPRB, 0.95303797E-07_JPRB, &
  & 0.95301708E-07_JPRB, 0.95291206E-07_JPRB, 0.95273862E-07_JPRB, 0.95251337E-07_JPRB, 0.95227712E-07_JPRB, 0.95206680E-07_JPRB, &
  & 0.95188604E-07_JPRB, 0.95174208E-07_JPRB, 0.95161745E-07_JPRB, 0.95148664E-07_JPRB, 0.95131924E-07_JPRB, 0.95108661E-07_JPRB, &
  & 0.95078128E-07_JPRB, 0.95040683E-07_JPRB, 0.94995691E-07_JPRB, 0.94944454E-07_JPRB, 0.94892407E-07_JPRB, 0.94849050E-07_JPRB, &
  & 0.94823314E-07_JPRB, 0.94816187E-07_JPRB, 0.94819413E-07_JPRB, 0.94824891E-07_JPRB, 0.94834228E-07_JPRB, 0.94854528E-07_JPRB, &
  & 0.94888620E-07_JPRB, 0.94932886E-07_JPRB, 0.94981132E-07_JPRB, 0.95029172E-07_JPRB, 0.95073410E-07_JPRB, 0.95107758E-07_JPRB, &
  & 0.95138901E-07_JPRB, 0.95162122E-07_JPRB, 0.95188291E-07_JPRB, 0.95208549E-07_JPRB /)

RGHG3(:, 3,11) = (/ &
  & 0.92449881E-07_JPRB, 0.91725219E-07_JPRB, 0.91345129E-07_JPRB, 0.91134645E-07_JPRB, 0.91045081E-07_JPRB, 0.91043134E-07_JPRB, &
  & 0.91116021E-07_JPRB, 0.91250286E-07_JPRB, 0.91440548E-07_JPRB, 0.91660866E-07_JPRB, 0.91938531E-07_JPRB, 0.92276721E-07_JPRB, &
  & 0.92696901E-07_JPRB, 0.93200633E-07_JPRB, 0.93764420E-07_JPRB, 0.94350867E-07_JPRB, 0.94916473E-07_JPRB, 0.95425953E-07_JPRB, &
  & 0.95861992E-07_JPRB, 0.96210144E-07_JPRB, 0.96465854E-07_JPRB, 0.96635986E-07_JPRB, 0.96737246E-07_JPRB, 0.96787751E-07_JPRB, &
  & 0.96803170E-07_JPRB, 0.96793528E-07_JPRB, 0.96763934E-07_JPRB, 0.96717081E-07_JPRB, 0.96655697E-07_JPRB, 0.96581260E-07_JPRB, &
  & 0.96493530E-07_JPRB, 0.96392419E-07_JPRB, 0.96280168E-07_JPRB, 0.96160413E-07_JPRB, 0.96037901E-07_JPRB, 0.95915922E-07_JPRB, &
  & 0.95799734E-07_JPRB, 0.95692599E-07_JPRB, 0.95594856E-07_JPRB, 0.95506195E-07_JPRB, 0.95428817E-07_JPRB, 0.95360214E-07_JPRB, &
  & 0.95295341E-07_JPRB, 0.95229822E-07_JPRB, 0.95165447E-07_JPRB, 0.95110117E-07_JPRB, 0.95070519E-07_JPRB, 0.95040917E-07_JPRB, &
  & 0.95003799E-07_JPRB, 0.94950096E-07_JPRB, 0.94896222E-07_JPRB, 0.94867559E-07_JPRB, 0.94872071E-07_JPRB, 0.94903498E-07_JPRB, &
  & 0.94956746E-07_JPRB, 0.95028213E-07_JPRB, 0.95112370E-07_JPRB, 0.95198914E-07_JPRB, 0.95286836E-07_JPRB, 0.95378446E-07_JPRB, &
  & 0.95458333E-07_JPRB, 0.95532172E-07_JPRB, 0.95610375E-07_JPRB, 0.95691398E-07_JPRB /)

RGHG3(:, 4,11) = (/ &
  & 0.93059363E-07_JPRB, 0.92460098E-07_JPRB, 0.92197752E-07_JPRB, 0.92079794E-07_JPRB, 0.92059643E-07_JPRB, 0.92108067E-07_JPRB, &
  & 0.92212680E-07_JPRB, 0.92374435E-07_JPRB, 0.92594654E-07_JPRB, 0.92859381E-07_JPRB, 0.93168822E-07_JPRB, 0.93573156E-07_JPRB, &
  & 0.94057746E-07_JPRB, 0.94608318E-07_JPRB, 0.95193322E-07_JPRB, 0.95781658E-07_JPRB, 0.96341296E-07_JPRB, 0.96856098E-07_JPRB, &
  & 0.97309389E-07_JPRB, 0.97677514E-07_JPRB, 0.97940834E-07_JPRB, 0.98095086E-07_JPRB, 0.98153386E-07_JPRB, 0.98137036E-07_JPRB, &
  & 0.98072135E-07_JPRB, 0.97977782E-07_JPRB, 0.97858987E-07_JPRB, 0.97717177E-07_JPRB, 0.97550732E-07_JPRB, 0.97366097E-07_JPRB, &
  & 0.97168297E-07_JPRB, 0.96956676E-07_JPRB, 0.96732585E-07_JPRB, 0.96504102E-07_JPRB, 0.96284332E-07_JPRB, 0.96087021E-07_JPRB, &
  & 0.95925351E-07_JPRB, 0.95809092E-07_JPRB, 0.95735352E-07_JPRB, 0.95686552E-07_JPRB, 0.95642449E-07_JPRB, 0.95592647E-07_JPRB, &
  & 0.95535775E-07_JPRB, 0.95471464E-07_JPRB, 0.95405959E-07_JPRB, 0.95343090E-07_JPRB, 0.95276981E-07_JPRB, 0.95198168E-07_JPRB, &
  & 0.95113954E-07_JPRB, 0.95048037E-07_JPRB, 0.95008659E-07_JPRB, 0.94983605E-07_JPRB, 0.94973970E-07_JPRB, 0.94997027E-07_JPRB, &
  & 0.95064351E-07_JPRB, 0.95176809E-07_JPRB, 0.95329042E-07_JPRB, 0.95501377E-07_JPRB, 0.95678473E-07_JPRB, 0.95853167E-07_JPRB, &
  & 0.96014162E-07_JPRB, 0.96158359E-07_JPRB, 0.96329686E-07_JPRB, 0.96552263E-07_JPRB /)

RGHG3(:, 5,11) = (/ &
  & 0.93782582E-07_JPRB, 0.93288975E-07_JPRB, 0.93149083E-07_JPRB, 0.93093519E-07_JPRB, 0.93095082E-07_JPRB, 0.93153780E-07_JPRB, &
  & 0.93269712E-07_JPRB, 0.93445863E-07_JPRB, 0.93704429E-07_JPRB, 0.94020372E-07_JPRB, 0.94417366E-07_JPRB, 0.94887227E-07_JPRB, &
  & 0.95422251E-07_JPRB, 0.96003539E-07_JPRB, 0.96603415E-07_JPRB, 0.97220905E-07_JPRB, 0.97837400E-07_JPRB, 0.98416592E-07_JPRB, &
  & 0.98938315E-07_JPRB, 0.99381154E-07_JPRB, 0.99730464E-07_JPRB, 0.99967600E-07_JPRB, 0.10008979E-06_JPRB, 0.10009633E-06_JPRB, &
  & 0.10000800E-06_JPRB, 0.99861673E-07_JPRB, 0.99703080E-07_JPRB, 0.99563316E-07_JPRB, 0.99444520E-07_JPRB, 0.99330229E-07_JPRB, &
  & 0.99202708E-07_JPRB, 0.99053629E-07_JPRB, 0.98884591E-07_JPRB, 0.98714388E-07_JPRB, 0.98580941E-07_JPRB, 0.98523479E-07_JPRB, &
  & 0.98569600E-07_JPRB, 0.98711610E-07_JPRB, 0.98893061E-07_JPRB, 0.99023268E-07_JPRB, 0.99017512E-07_JPRB, 0.98838044E-07_JPRB, &
  & 0.98507670E-07_JPRB, 0.98082054E-07_JPRB, 0.97617423E-07_JPRB, 0.97163145E-07_JPRB, 0.96753539E-07_JPRB, 0.96402474E-07_JPRB, &
  & 0.96108025E-07_JPRB, 0.95857246E-07_JPRB, 0.95641632E-07_JPRB, 0.95473894E-07_JPRB, 0.95369501E-07_JPRB, 0.95333149E-07_JPRB, &
  & 0.95374304E-07_JPRB, 0.95504994E-07_JPRB, 0.95720878E-07_JPRB, 0.95982799E-07_JPRB, 0.96264536E-07_JPRB, 0.96533483E-07_JPRB, &
  & 0.96776205E-07_JPRB, 0.96999678E-07_JPRB, 0.97237027E-07_JPRB, 0.97698205E-07_JPRB /)

RGHG3(:, 6,11) = (/ &
  & 0.94762008E-07_JPRB, 0.94383857E-07_JPRB, 0.94222173E-07_JPRB, 0.94167909E-07_JPRB, 0.94193204E-07_JPRB, 0.94281162E-07_JPRB, &
  & 0.94429652E-07_JPRB, 0.94652037E-07_JPRB, 0.94966488E-07_JPRB, 0.95344845E-07_JPRB, 0.95794022E-07_JPRB, 0.96329941E-07_JPRB, &
  & 0.96949201E-07_JPRB, 0.97627399E-07_JPRB, 0.98322303E-07_JPRB, 0.99019324E-07_JPRB, 0.99715884E-07_JPRB, 0.10041705E-06_JPRB, &
  & 0.10109006E-06_JPRB, 0.10169240E-06_JPRB, 0.10221096E-06_JPRB, 0.10265023E-06_JPRB, 0.10301639E-06_JPRB, 0.10332084E-06_JPRB, &
  & 0.10357323E-06_JPRB, 0.10378372E-06_JPRB, 0.10396658E-06_JPRB, 0.10414119E-06_JPRB, 0.10433547E-06_JPRB, 0.10457730E-06_JPRB, &
  & 0.10488078E-06_JPRB, 0.10523679E-06_JPRB, 0.10562354E-06_JPRB, 0.10602531E-06_JPRB, 0.10643708E-06_JPRB, 0.10685057E-06_JPRB, &
  & 0.10725405E-06_JPRB, 0.10760701E-06_JPRB, 0.10781450E-06_JPRB, 0.10775493E-06_JPRB, 0.10735924E-06_JPRB, 0.10664865E-06_JPRB, &
  & 0.10572953E-06_JPRB, 0.10470777E-06_JPRB, 0.10367178E-06_JPRB, 0.10266289E-06_JPRB, 0.10168493E-06_JPRB, 0.10073051E-06_JPRB, &
  & 0.99812951E-07_JPRB, 0.98961685E-07_JPRB, 0.98205938E-07_JPRB, 0.97566740E-07_JPRB, 0.97058710E-07_JPRB, 0.96705392E-07_JPRB, &
  & 0.96527437E-07_JPRB, 0.96531103E-07_JPRB, 0.96693526E-07_JPRB, 0.96951752E-07_JPRB, 0.97254372E-07_JPRB, 0.97569263E-07_JPRB, &
  & 0.97896880E-07_JPRB, 0.98235120E-07_JPRB, 0.98643646E-07_JPRB, 0.99193734E-07_JPRB /)

RGHG3(:, 7,11) = (/ &
  & 0.96049995E-07_JPRB, 0.95720175E-07_JPRB, 0.95638718E-07_JPRB, 0.95651160E-07_JPRB, 0.95718946E-07_JPRB, 0.95836263E-07_JPRB, &
  & 0.96013721E-07_JPRB, 0.96266859E-07_JPRB, 0.96639667E-07_JPRB, 0.97093967E-07_JPRB, 0.97624479E-07_JPRB, 0.98209568E-07_JPRB, &
  & 0.98851444E-07_JPRB, 0.99567714E-07_JPRB, 0.10037140E-06_JPRB, 0.10123498E-06_JPRB, 0.10210638E-06_JPRB, 0.10297755E-06_JPRB, &
  & 0.10386092E-06_JPRB, 0.10475550E-06_JPRB, 0.10563790E-06_JPRB, 0.10648888E-06_JPRB, 0.10729529E-06_JPRB, 0.10804876E-06_JPRB, &
  & 0.10875537E-06_JPRB, 0.10942386E-06_JPRB, 0.11009379E-06_JPRB, 0.11081980E-06_JPRB, 0.11163436E-06_JPRB, 0.11256592E-06_JPRB, &
  & 0.11360031E-06_JPRB, 0.11468407E-06_JPRB, 0.11571758E-06_JPRB, 0.11660195E-06_JPRB, 0.11730980E-06_JPRB, 0.11786278E-06_JPRB, &
  & 0.11825991E-06_JPRB, 0.11844080E-06_JPRB, 0.11829451E-06_JPRB, 0.11770369E-06_JPRB, 0.11663288E-06_JPRB, 0.11524389E-06_JPRB, &
  & 0.11374263E-06_JPRB, 0.11229408E-06_JPRB, 0.11093088E-06_JPRB, 0.10963011E-06_JPRB, 0.10835385E-06_JPRB, 0.10708443E-06_JPRB, &
  & 0.10581331E-06_JPRB, 0.10452847E-06_JPRB, 0.10324884E-06_JPRB, 0.10202670E-06_JPRB, 0.10094030E-06_JPRB, 0.10006232E-06_JPRB, &
  & 0.99451157E-07_JPRB, 0.99125373E-07_JPRB, 0.99053864E-07_JPRB, 0.99166058E-07_JPRB, 0.99403053E-07_JPRB, 0.99707322E-07_JPRB, &
  & 0.10003584E-06_JPRB, 0.10037488E-06_JPRB, 0.10073616E-06_JPRB, 0.10154185E-06_JPRB /)

RGHG3(:, 8,11) = (/ &
  & 0.97974038E-07_JPRB, 0.97663388E-07_JPRB, 0.97635933E-07_JPRB, 0.97686808E-07_JPRB, 0.97795535E-07_JPRB, 0.97960722E-07_JPRB, &
  & 0.98187343E-07_JPRB, 0.98499292E-07_JPRB, 0.98926833E-07_JPRB, 0.99442666E-07_JPRB, 0.10005041E-06_JPRB, 0.10074312E-06_JPRB, &
  & 0.10149972E-06_JPRB, 0.10230546E-06_JPRB, 0.10316619E-06_JPRB, 0.10413402E-06_JPRB, 0.10522302E-06_JPRB, 0.10637822E-06_JPRB, &
  & 0.10754675E-06_JPRB, 0.10872115E-06_JPRB, 0.10991937E-06_JPRB, 0.11115726E-06_JPRB, 0.11243937E-06_JPRB, 0.11375607E-06_JPRB, &
  & 0.11509543E-06_JPRB, 0.11644943E-06_JPRB, 0.11782127E-06_JPRB, 0.11923584E-06_JPRB, 0.12071467E-06_JPRB, 0.12225793E-06_JPRB, &
  & 0.12383899E-06_JPRB, 0.12539734E-06_JPRB, 0.12688332E-06_JPRB, 0.12821934E-06_JPRB, 0.12926095E-06_JPRB, 0.12991350E-06_JPRB, &
  & 0.13015840E-06_JPRB, 0.12995699E-06_JPRB, 0.12923337E-06_JPRB, 0.12790669E-06_JPRB, 0.12607136E-06_JPRB, 0.12395645E-06_JPRB, &
  & 0.12192433E-06_JPRB, 0.12008603E-06_JPRB, 0.11843545E-06_JPRB, 0.11690770E-06_JPRB, 0.11545269E-06_JPRB, 0.11402510E-06_JPRB, &
  & 0.11256807E-06_JPRB, 0.11105875E-06_JPRB, 0.10950461E-06_JPRB, 0.10794498E-06_JPRB, 0.10645257E-06_JPRB, 0.10513888E-06_JPRB, &
  & 0.10410037E-06_JPRB, 0.10339434E-06_JPRB, 0.10300797E-06_JPRB, 0.10288407E-06_JPRB, 0.10295056E-06_JPRB, 0.10313698E-06_JPRB, &
  & 0.10338418E-06_JPRB, 0.10366728E-06_JPRB, 0.10397662E-06_JPRB, 0.10436389E-06_JPRB /)

RGHG3(:, 9,11) = (/ &
  & 0.10050734E-06_JPRB, 0.10036202E-06_JPRB, 0.10038766E-06_JPRB, 0.10049206E-06_JPRB, 0.10066348E-06_JPRB, 0.10089805E-06_JPRB, &
  & 0.10120309E-06_JPRB, 0.10158740E-06_JPRB, 0.10208468E-06_JPRB, 0.10265818E-06_JPRB, 0.10332461E-06_JPRB, 0.10408651E-06_JPRB, &
  & 0.10494401E-06_JPRB, 0.10591478E-06_JPRB, 0.10696768E-06_JPRB, 0.10805744E-06_JPRB, 0.10922585E-06_JPRB, 0.11053116E-06_JPRB, &
  & 0.11197240E-06_JPRB, 0.11352446E-06_JPRB, 0.11515768E-06_JPRB, 0.11687407E-06_JPRB, 0.11864788E-06_JPRB, 0.12046613E-06_JPRB, &
  & 0.12230308E-06_JPRB, 0.12413777E-06_JPRB, 0.12598633E-06_JPRB, 0.12784966E-06_JPRB, 0.12976230E-06_JPRB, 0.13173363E-06_JPRB, &
  & 0.13376606E-06_JPRB, 0.13579464E-06_JPRB, 0.13765428E-06_JPRB, 0.13919461E-06_JPRB, 0.14032466E-06_JPRB, 0.14094884E-06_JPRB, &
  & 0.14104701E-06_JPRB, 0.14062510E-06_JPRB, 0.13963032E-06_JPRB, 0.13804083E-06_JPRB, 0.13587908E-06_JPRB, 0.13340758E-06_JPRB, &
  & 0.13089557E-06_JPRB, 0.12861392E-06_JPRB, 0.12659760E-06_JPRB, 0.12480463E-06_JPRB, 0.12313660E-06_JPRB, 0.12149567E-06_JPRB, &
  & 0.11981788E-06_JPRB, 0.11807052E-06_JPRB, 0.11624255E-06_JPRB, 0.11437428E-06_JPRB, 0.11255626E-06_JPRB, 0.11090405E-06_JPRB, &
  & 0.10953632E-06_JPRB, 0.10852044E-06_JPRB, 0.10786646E-06_JPRB, 0.10752785E-06_JPRB, 0.10743641E-06_JPRB, 0.10751160E-06_JPRB, &
  & 0.10768517E-06_JPRB, 0.10789439E-06_JPRB, 0.10820509E-06_JPRB, 0.10872271E-06_JPRB /)

RGHG3(:,10,11) = (/ &
  & 0.10436270E-06_JPRB, 0.10426801E-06_JPRB, 0.10435878E-06_JPRB, 0.10455970E-06_JPRB, 0.10485191E-06_JPRB, 0.10523209E-06_JPRB, &
  & 0.10569978E-06_JPRB, 0.10626536E-06_JPRB, 0.10694681E-06_JPRB, 0.10770601E-06_JPRB, 0.10855525E-06_JPRB, 0.10951708E-06_JPRB, &
  & 0.11059018E-06_JPRB, 0.11176665E-06_JPRB, 0.11312626E-06_JPRB, 0.11464714E-06_JPRB, 0.11627323E-06_JPRB, 0.11797454E-06_JPRB, &
  & 0.11976832E-06_JPRB, 0.12168364E-06_JPRB, 0.12366516E-06_JPRB, 0.12574721E-06_JPRB, 0.12787658E-06_JPRB, 0.13004606E-06_JPRB, &
  & 0.13217679E-06_JPRB, 0.13426013E-06_JPRB, 0.13628870E-06_JPRB, 0.13828273E-06_JPRB, 0.14030945E-06_JPRB, 0.14239143E-06_JPRB, &
  & 0.14453597E-06_JPRB, 0.14669976E-06_JPRB, 0.14876920E-06_JPRB, 0.15049319E-06_JPRB, 0.15169917E-06_JPRB, 0.15235086E-06_JPRB, &
  & 0.15244412E-06_JPRB, 0.15201471E-06_JPRB, 0.15110332E-06_JPRB, 0.14964405E-06_JPRB, 0.14760296E-06_JPRB, 0.14507877E-06_JPRB, &
  & 0.14243696E-06_JPRB, 0.13988659E-06_JPRB, 0.13754052E-06_JPRB, 0.13533598E-06_JPRB, 0.13320832E-06_JPRB, 0.13108040E-06_JPRB, &
  & 0.12889350E-06_JPRB, 0.12660797E-06_JPRB, 0.12423658E-06_JPRB, 0.12183811E-06_JPRB, 0.11953415E-06_JPRB, 0.11747390E-06_JPRB, &
  & 0.11579343E-06_JPRB, 0.11456532E-06_JPRB, 0.11377622E-06_JPRB, 0.11334697E-06_JPRB, 0.11317536E-06_JPRB, 0.11316393E-06_JPRB, &
  & 0.11323326E-06_JPRB, 0.11334598E-06_JPRB, 0.11344488E-06_JPRB, 0.11363168E-06_JPRB /)

RGHG3(:,11,11) = (/ &
  & 0.10996776E-06_JPRB, 0.10991575E-06_JPRB, 0.11012024E-06_JPRB, 0.11046975E-06_JPRB, 0.11094656E-06_JPRB, 0.11154393E-06_JPRB, &
  & 0.11226142E-06_JPRB, 0.11309864E-06_JPRB, 0.11406544E-06_JPRB, 0.11511385E-06_JPRB, 0.11624491E-06_JPRB, 0.11748506E-06_JPRB, &
  & 0.11889495E-06_JPRB, 0.12048287E-06_JPRB, 0.12224440E-06_JPRB, 0.12424903E-06_JPRB, 0.12649208E-06_JPRB, 0.12892134E-06_JPRB, &
  & 0.13148153E-06_JPRB, 0.13414909E-06_JPRB, 0.13684109E-06_JPRB, 0.13952413E-06_JPRB, 0.14212895E-06_JPRB, 0.14462184E-06_JPRB, &
  & 0.14684846E-06_JPRB, 0.14885650E-06_JPRB, 0.15061656E-06_JPRB, 0.15220958E-06_JPRB, 0.15374435E-06_JPRB, 0.15530060E-06_JPRB, &
  & 0.15698160E-06_JPRB, 0.15876006E-06_JPRB, 0.16060163E-06_JPRB, 0.16235829E-06_JPRB, 0.16377149E-06_JPRB, 0.16466831E-06_JPRB, &
  & 0.16500876E-06_JPRB, 0.16487098E-06_JPRB, 0.16436076E-06_JPRB, 0.16351123E-06_JPRB, 0.16224197E-06_JPRB, 0.16050498E-06_JPRB, &
  & 0.15834230E-06_JPRB, 0.15591641E-06_JPRB, 0.15335522E-06_JPRB, 0.15073699E-06_JPRB, 0.14803348E-06_JPRB, 0.14520927E-06_JPRB, &
  & 0.14221774E-06_JPRB, 0.13907301E-06_JPRB, 0.13581344E-06_JPRB, 0.13257754E-06_JPRB, 0.12952422E-06_JPRB, 0.12686064E-06_JPRB, &
  & 0.12471597E-06_JPRB, 0.12312773E-06_JPRB, 0.12203587E-06_JPRB, 0.12133410E-06_JPRB, 0.12091759E-06_JPRB, 0.12069592E-06_JPRB, &
  & 0.12058868E-06_JPRB, 0.12055486E-06_JPRB, 0.12054713E-06_JPRB, 0.12055399E-06_JPRB /)

RGHG3(:,12,11) = (/ &
  & 0.11801172E-06_JPRB, 0.11799971E-06_JPRB, 0.11836602E-06_JPRB, 0.11894387E-06_JPRB, 0.11970366E-06_JPRB, 0.12064349E-06_JPRB, &
  & 0.12176228E-06_JPRB, 0.12305729E-06_JPRB, 0.12453056E-06_JPRB, 0.12613313E-06_JPRB, 0.12785708E-06_JPRB, 0.12970261E-06_JPRB, &
  & 0.13169419E-06_JPRB, 0.13391981E-06_JPRB, 0.13642173E-06_JPRB, 0.13919941E-06_JPRB, 0.14226130E-06_JPRB, 0.14552836E-06_JPRB, &
  & 0.14891538E-06_JPRB, 0.15233016E-06_JPRB, 0.15565668E-06_JPRB, 0.15873989E-06_JPRB, 0.16156650E-06_JPRB, 0.16402845E-06_JPRB, &
  & 0.16598642E-06_JPRB, 0.16749291E-06_JPRB, 0.16852960E-06_JPRB, 0.16922078E-06_JPRB, 0.16976296E-06_JPRB, 0.17035423E-06_JPRB, &
  & 0.17118917E-06_JPRB, 0.17241997E-06_JPRB, 0.17397649E-06_JPRB, 0.17572408E-06_JPRB, 0.17723612E-06_JPRB, 0.17826748E-06_JPRB, &
  & 0.17892010E-06_JPRB, 0.17930383E-06_JPRB, 0.17941406E-06_JPRB, 0.17926462E-06_JPRB, 0.17887908E-06_JPRB, 0.17816038E-06_JPRB, &
  & 0.17695943E-06_JPRB, 0.17517576E-06_JPRB, 0.17282790E-06_JPRB, 0.17002883E-06_JPRB, 0.16684814E-06_JPRB, 0.16333685E-06_JPRB, &
  & 0.15952752E-06_JPRB, 0.15546547E-06_JPRB, 0.15125653E-06_JPRB, 0.14704585E-06_JPRB, 0.14308262E-06_JPRB, 0.13956529E-06_JPRB, &
  & 0.13665692E-06_JPRB, 0.13438751E-06_JPRB, 0.13270312E-06_JPRB, 0.13149446E-06_JPRB, 0.13065461E-06_JPRB, 0.13008400E-06_JPRB, &
  & 0.12972352E-06_JPRB, 0.12943735E-06_JPRB, 0.12924903E-06_JPRB, 0.12884263E-06_JPRB /)

RGHG3(:,13,11) = (/ &
  & 0.12847789E-06_JPRB, 0.12878056E-06_JPRB, 0.12945084E-06_JPRB, 0.13035449E-06_JPRB, 0.13148298E-06_JPRB, 0.13284209E-06_JPRB, &
  & 0.13443223E-06_JPRB, 0.13624241E-06_JPRB, 0.13825681E-06_JPRB, 0.14041693E-06_JPRB, 0.14271080E-06_JPRB, 0.14516172E-06_JPRB, &
  & 0.14780206E-06_JPRB, 0.15067414E-06_JPRB, 0.15387440E-06_JPRB, 0.15741651E-06_JPRB, 0.16128747E-06_JPRB, 0.16537037E-06_JPRB, &
  & 0.16951151E-06_JPRB, 0.17356456E-06_JPRB, 0.17735317E-06_JPRB, 0.18066403E-06_JPRB, 0.18342571E-06_JPRB, 0.18558487E-06_JPRB, &
  & 0.18699347E-06_JPRB, 0.18770915E-06_JPRB, 0.18779404E-06_JPRB, 0.18742601E-06_JPRB, 0.18687359E-06_JPRB, 0.18638734E-06_JPRB, &
  & 0.18629652E-06_JPRB, 0.18676242E-06_JPRB, 0.18789612E-06_JPRB, 0.18927095E-06_JPRB, 0.19079549E-06_JPRB, 0.19231216E-06_JPRB, &
  & 0.19357172E-06_JPRB, 0.19450277E-06_JPRB, 0.19519348E-06_JPRB, 0.19569543E-06_JPRB, 0.19597046E-06_JPRB, 0.19591428E-06_JPRB, &
  & 0.19537079E-06_JPRB, 0.19417325E-06_JPRB, 0.19223585E-06_JPRB, 0.18959534E-06_JPRB, 0.18633719E-06_JPRB, 0.18254471E-06_JPRB, &
  & 0.17829484E-06_JPRB, 0.17369612E-06_JPRB, 0.16885933E-06_JPRB, 0.16399437E-06_JPRB, 0.15932036E-06_JPRB, 0.15509252E-06_JPRB, &
  & 0.15147583E-06_JPRB, 0.14854452E-06_JPRB, 0.14625957E-06_JPRB, 0.14453147E-06_JPRB, 0.14325694E-06_JPRB, 0.14234145E-06_JPRB, &
  & 0.14166805E-06_JPRB, 0.14120863E-06_JPRB, 0.14069252E-06_JPRB, 0.14008089E-06_JPRB /)

RGHG3(:,14,11) = (/ &
  & 0.13995432E-06_JPRB, 0.14074364E-06_JPRB, 0.14178661E-06_JPRB, 0.14307810E-06_JPRB, 0.14463814E-06_JPRB, 0.14648921E-06_JPRB, &
  & 0.14863885E-06_JPRB, 0.15107196E-06_JPRB, 0.15376045E-06_JPRB, 0.15662206E-06_JPRB, 0.15961021E-06_JPRB, 0.16270016E-06_JPRB, &
  & 0.16593556E-06_JPRB, 0.16938642E-06_JPRB, 0.17314187E-06_JPRB, 0.17725654E-06_JPRB, 0.18168210E-06_JPRB, 0.18629306E-06_JPRB, &
  & 0.19087875E-06_JPRB, 0.19524785E-06_JPRB, 0.19920259E-06_JPRB, 0.20248309E-06_JPRB, 0.20498166E-06_JPRB, 0.20665303E-06_JPRB, &
  & 0.20741564E-06_JPRB, 0.20730097E-06_JPRB, 0.20643830E-06_JPRB, 0.20501631E-06_JPRB, 0.20337332E-06_JPRB, 0.20190808E-06_JPRB, &
  & 0.20092095E-06_JPRB, 0.20069945E-06_JPRB, 0.20118053E-06_JPRB, 0.20262344E-06_JPRB, 0.20462046E-06_JPRB, 0.20661255E-06_JPRB, &
  & 0.20834688E-06_JPRB, 0.20976806E-06_JPRB, 0.21088729E-06_JPRB, 0.21172319E-06_JPRB, 0.21225918E-06_JPRB, 0.21243666E-06_JPRB, &
  & 0.21215686E-06_JPRB, 0.21127734E-06_JPRB, 0.20970749E-06_JPRB, 0.20745597E-06_JPRB, 0.20455788E-06_JPRB, 0.20106000E-06_JPRB, &
  & 0.19704031E-06_JPRB, 0.19259114E-06_JPRB, 0.18784878E-06_JPRB, 0.18297825E-06_JPRB, 0.17820885E-06_JPRB, 0.17375092E-06_JPRB, &
  & 0.16979091E-06_JPRB, 0.16642261E-06_JPRB, 0.16366153E-06_JPRB, 0.16145398E-06_JPRB, 0.15973157E-06_JPRB, 0.15841877E-06_JPRB, &
  & 0.15743377E-06_JPRB, 0.15663119E-06_JPRB, 0.15590335E-06_JPRB, 0.15460344E-06_JPRB /)

RGHG3(:,15,11) = (/ &
  & 0.15182367E-06_JPRB, 0.15324028E-06_JPRB, 0.15471159E-06_JPRB, 0.15642604E-06_JPRB, 0.15844417E-06_JPRB, 0.16080330E-06_JPRB, &
  & 0.16351427E-06_JPRB, 0.16655454E-06_JPRB, 0.16987433E-06_JPRB, 0.17337591E-06_JPRB, 0.17699779E-06_JPRB, 0.18069633E-06_JPRB, &
  & 0.18446586E-06_JPRB, 0.18835873E-06_JPRB, 0.19245473E-06_JPRB, 0.19683560E-06_JPRB, 0.20147934E-06_JPRB, 0.20624961E-06_JPRB, &
  & 0.21092004E-06_JPRB, 0.21527627E-06_JPRB, 0.21910689E-06_JPRB, 0.22217137E-06_JPRB, 0.22430459E-06_JPRB, 0.22547837E-06_JPRB, &
  & 0.22565533E-06_JPRB, 0.22486904E-06_JPRB, 0.22328540E-06_JPRB, 0.22114865E-06_JPRB, 0.21879143E-06_JPRB, 0.21660931E-06_JPRB, &
  & 0.21504763E-06_JPRB, 0.21439286E-06_JPRB, 0.21501434E-06_JPRB, 0.21656442E-06_JPRB, 0.21862076E-06_JPRB, 0.22085987E-06_JPRB, &
  & 0.22293725E-06_JPRB, 0.22467123E-06_JPRB, 0.22601319E-06_JPRB, 0.22697320E-06_JPRB, 0.22756416E-06_JPRB, 0.22775593E-06_JPRB, &
  & 0.22748016E-06_JPRB, 0.22666973E-06_JPRB, 0.22531296E-06_JPRB, 0.22341166E-06_JPRB, 0.22097439E-06_JPRB, 0.21801274E-06_JPRB, &
  & 0.21456599E-06_JPRB, 0.21070568E-06_JPRB, 0.20652681E-06_JPRB, 0.20216848E-06_JPRB, 0.19778842E-06_JPRB, 0.19356204E-06_JPRB, &
  & 0.18964322E-06_JPRB, 0.18614487E-06_JPRB, 0.18311589E-06_JPRB, 0.18056696E-06_JPRB, 0.17847650E-06_JPRB, 0.17680078E-06_JPRB, &
  & 0.17550711E-06_JPRB, 0.17442515E-06_JPRB, 0.17337793E-06_JPRB, 0.17160609E-06_JPRB /)

RGHG3(:,16,11) = (/ &
  & 0.16393656E-06_JPRB, 0.16595158E-06_JPRB, 0.16780562E-06_JPRB, 0.16989500E-06_JPRB, 0.17231875E-06_JPRB, 0.17512484E-06_JPRB, &
  & 0.17832329E-06_JPRB, 0.18188747E-06_JPRB, 0.18574870E-06_JPRB, 0.18977568E-06_JPRB, 0.19386408E-06_JPRB, 0.19795290E-06_JPRB, &
  & 0.20203566E-06_JPRB, 0.20614962E-06_JPRB, 0.21036058E-06_JPRB, 0.21473261E-06_JPRB, 0.21927849E-06_JPRB, 0.22388215E-06_JPRB, &
  & 0.22833213E-06_JPRB, 0.23241503E-06_JPRB, 0.23593817E-06_JPRB, 0.23867901E-06_JPRB, 0.24047029E-06_JPRB, 0.24126120E-06_JPRB, &
  & 0.24105063E-06_JPRB, 0.23988878E-06_JPRB, 0.23794070E-06_JPRB, 0.23549289E-06_JPRB, 0.23288030E-06_JPRB, 0.23058364E-06_JPRB, &
  & 0.22900080E-06_JPRB, 0.22844893E-06_JPRB, 0.22887690E-06_JPRB, 0.23023951E-06_JPRB, 0.23234220E-06_JPRB, 0.23472805E-06_JPRB, &
  & 0.23700201E-06_JPRB, 0.23889692E-06_JPRB, 0.24032701E-06_JPRB, 0.24129932E-06_JPRB, 0.24183228E-06_JPRB, 0.24190851E-06_JPRB, &
  & 0.24151919E-06_JPRB, 0.24068581E-06_JPRB, 0.23943147E-06_JPRB, 0.23776927E-06_JPRB, 0.23570199E-06_JPRB, 0.23323224E-06_JPRB, &
  & 0.23036498E-06_JPRB, 0.22711052E-06_JPRB, 0.22352543E-06_JPRB, 0.21971698E-06_JPRB, 0.21580308E-06_JPRB, 0.21192453E-06_JPRB, &
  & 0.20820907E-06_JPRB, 0.20477029E-06_JPRB, 0.20168399E-06_JPRB, 0.19898599E-06_JPRB, 0.19670242E-06_JPRB, 0.19483279E-06_JPRB, &
  & 0.19330510E-06_JPRB, 0.19211508E-06_JPRB, 0.19079737E-06_JPRB, 0.18894231E-06_JPRB /)

RGHG3(:,17,11) = (/ &
  & 0.17616250E-06_JPRB, 0.17861412E-06_JPRB, 0.18074020E-06_JPRB, 0.18308845E-06_JPRB, 0.18579520E-06_JPRB, 0.18890950E-06_JPRB, &
  & 0.19244183E-06_JPRB, 0.19634352E-06_JPRB, 0.20053129E-06_JPRB, 0.20486280E-06_JPRB, 0.20921075E-06_JPRB, 0.21348195E-06_JPRB, &
  & 0.21765851E-06_JPRB, 0.22177979E-06_JPRB, 0.22591310E-06_JPRB, 0.23011120E-06_JPRB, 0.23438542E-06_JPRB, 0.23865024E-06_JPRB, &
  & 0.24272259E-06_JPRB, 0.24641170E-06_JPRB, 0.24955079E-06_JPRB, 0.25196093E-06_JPRB, 0.25348697E-06_JPRB, 0.25406109E-06_JPRB, &
  & 0.25369167E-06_JPRB, 0.25245325E-06_JPRB, 0.25052222E-06_JPRB, 0.24818408E-06_JPRB, 0.24580791E-06_JPRB, 0.24377493E-06_JPRB, &
  & 0.24233177E-06_JPRB, 0.24176836E-06_JPRB, 0.24224795E-06_JPRB, 0.24365164E-06_JPRB, 0.24567120E-06_JPRB, 0.24796074E-06_JPRB, &
  & 0.25015115E-06_JPRB, 0.25199205E-06_JPRB, 0.25336436E-06_JPRB, 0.25425263E-06_JPRB, 0.25465408E-06_JPRB, 0.25458533E-06_JPRB, &
  & 0.25409440E-06_JPRB, 0.25323715E-06_JPRB, 0.25206006E-06_JPRB, 0.25059120E-06_JPRB, 0.24883991E-06_JPRB, 0.24679630E-06_JPRB, &
  & 0.24442411E-06_JPRB, 0.24170348E-06_JPRB, 0.23866403E-06_JPRB, 0.23536131E-06_JPRB, 0.23188009E-06_JPRB, 0.22833221E-06_JPRB, &
  & 0.22484656E-06_JPRB, 0.22153286E-06_JPRB, 0.21848109E-06_JPRB, 0.21575765E-06_JPRB, 0.21339869E-06_JPRB, 0.21143217E-06_JPRB, &
  & 0.20985995E-06_JPRB, 0.20851873E-06_JPRB, 0.20728089E-06_JPRB, 0.20511233E-06_JPRB /)

RGHG3(:,18,11) = (/ &
  & 0.18804789E-06_JPRB, 0.19082744E-06_JPRB, 0.19309499E-06_JPRB, 0.19557332E-06_JPRB, 0.19841058E-06_JPRB, 0.20167376E-06_JPRB, &
  & 0.20535241E-06_JPRB, 0.20940359E-06_JPRB, 0.21371473E-06_JPRB, 0.21813270E-06_JPRB, 0.22252644E-06_JPRB, 0.22679767E-06_JPRB, &
  & 0.23092011E-06_JPRB, 0.23492413E-06_JPRB, 0.23886784E-06_JPRB, 0.24280305E-06_JPRB, 0.24673955E-06_JPRB, 0.25061323E-06_JPRB, &
  & 0.25427775E-06_JPRB, 0.25756719E-06_JPRB, 0.26034311E-06_JPRB, 0.26246951E-06_JPRB, 0.26382321E-06_JPRB, 0.26433094E-06_JPRB, &
  & 0.26400684E-06_JPRB, 0.26294845E-06_JPRB, 0.26134154E-06_JPRB, 0.25945047E-06_JPRB, 0.25758240E-06_JPRB, 0.25600838E-06_JPRB, &
  & 0.25499267E-06_JPRB, 0.25476714E-06_JPRB, 0.25528487E-06_JPRB, 0.25648572E-06_JPRB, 0.25817187E-06_JPRB, 0.26007314E-06_JPRB, &
  & 0.26193737E-06_JPRB, 0.26352504E-06_JPRB, 0.26472190E-06_JPRB, 0.26543498E-06_JPRB, 0.26568705E-06_JPRB, 0.26550228E-06_JPRB, &
  & 0.26495525E-06_JPRB, 0.26411323E-06_JPRB, 0.26303482E-06_JPRB, 0.26175462E-06_JPRB, 0.26028135E-06_JPRB, 0.25859032E-06_JPRB, &
  & 0.25663374E-06_JPRB, 0.25438462E-06_JPRB, 0.25183903E-06_JPRB, 0.24901698E-06_JPRB, 0.24597483E-06_JPRB, 0.24280226E-06_JPRB, &
  & 0.23960669E-06_JPRB, 0.23650095E-06_JPRB, 0.23358706E-06_JPRB, 0.23093068E-06_JPRB, 0.22859598E-06_JPRB, 0.22661638E-06_JPRB, &
  & 0.22501001E-06_JPRB, 0.22366807E-06_JPRB, 0.22235798E-06_JPRB, 0.22020588E-06_JPRB /)

RGHG3(:,19,11) = (/ &
  & 0.19938409E-06_JPRB, 0.20233018E-06_JPRB, 0.20466015E-06_JPRB, 0.20714720E-06_JPRB, 0.20999717E-06_JPRB, 0.21325758E-06_JPRB, &
  & 0.21693290E-06_JPRB, 0.22094146E-06_JPRB, 0.22518013E-06_JPRB, 0.22949447E-06_JPRB, 0.23375648E-06_JPRB, 0.23787804E-06_JPRB, &
  & 0.24183049E-06_JPRB, 0.24564147E-06_JPRB, 0.24935869E-06_JPRB, 0.25301705E-06_JPRB, 0.25662328E-06_JPRB, 0.26012950E-06_JPRB, &
  & 0.26342707E-06_JPRB, 0.26638287E-06_JPRB, 0.26887614E-06_JPRB, 0.27080588E-06_JPRB, 0.27207909E-06_JPRB, 0.27264406E-06_JPRB, &
  & 0.27251119E-06_JPRB, 0.27178362E-06_JPRB, 0.27064962E-06_JPRB, 0.26933606E-06_JPRB, 0.26809957E-06_JPRB, 0.26713104E-06_JPRB, &
  & 0.26663832E-06_JPRB, 0.26663446E-06_JPRB, 0.26713798E-06_JPRB, 0.26806742E-06_JPRB, 0.26931519E-06_JPRB, 0.27071519E-06_JPRB, &
  & 0.27209128E-06_JPRB, 0.27329739E-06_JPRB, 0.27420489E-06_JPRB, 0.27472905E-06_JPRB, 0.27485149E-06_JPRB, 0.27461004E-06_JPRB, &
  & 0.27405571E-06_JPRB, 0.27326479E-06_JPRB, 0.27229217E-06_JPRB, 0.27117360E-06_JPRB, 0.26991393E-06_JPRB, 0.26848838E-06_JPRB, &
  & 0.26686155E-06_JPRB, 0.26500422E-06_JPRB, 0.26289391E-06_JPRB, 0.26053212E-06_JPRB, 0.25794947E-06_JPRB, 0.25520555E-06_JPRB, &
  & 0.25238825E-06_JPRB, 0.24960028E-06_JPRB, 0.24693171E-06_JPRB, 0.24446368E-06_JPRB, 0.24225156E-06_JPRB, 0.24035356E-06_JPRB, &
  & 0.23875472E-06_JPRB, 0.23746762E-06_JPRB, 0.23609653E-06_JPRB, 0.23406750E-06_JPRB /)

RGHG3(:,20,11) = (/ &
  & 0.20995412E-06_JPRB, 0.21303698E-06_JPRB, 0.21531716E-06_JPRB, 0.21775386E-06_JPRB, 0.22050801E-06_JPRB, 0.22366085E-06_JPRB, &
  & 0.22717973E-06_JPRB, 0.23100714E-06_JPRB, 0.23501939E-06_JPRB, 0.23908294E-06_JPRB, 0.24309153E-06_JPRB, 0.24696837E-06_JPRB, &
  & 0.25068746E-06_JPRB, 0.25426337E-06_JPRB, 0.25773781E-06_JPRB, 0.26113821E-06_JPRB, 0.26446023E-06_JPRB, 0.26766341E-06_JPRB, &
  & 0.27067188E-06_JPRB, 0.27338396E-06_JPRB, 0.27569854E-06_JPRB, 0.27753106E-06_JPRB, 0.27880770E-06_JPRB, 0.27949625E-06_JPRB, &
  & 0.27962656E-06_JPRB, 0.27930642E-06_JPRB, 0.27870166E-06_JPRB, 0.27799780E-06_JPRB, 0.27736891E-06_JPRB, 0.27694270E-06_JPRB, &
  & 0.27677373E-06_JPRB, 0.27690905E-06_JPRB, 0.27731517E-06_JPRB, 0.27793271E-06_JPRB, 0.27873037E-06_JPRB, 0.27962571E-06_JPRB, &
  & 0.28054032E-06_JPRB, 0.28135423E-06_JPRB, 0.28195689E-06_JPRB, 0.28231244E-06_JPRB, 0.28234317E-06_JPRB, 0.28207839E-06_JPRB, &
  & 0.28155108E-06_JPRB, 0.28082232E-06_JPRB, 0.27994247E-06_JPRB, 0.27894484E-06_JPRB, 0.27783759E-06_JPRB, 0.27660653E-06_JPRB, &
  & 0.27522651E-06_JPRB, 0.27367031E-06_JPRB, 0.27191521E-06_JPRB, 0.26995517E-06_JPRB, 0.26780282E-06_JPRB, 0.26549426E-06_JPRB, &
  & 0.26309479E-06_JPRB, 0.26068238E-06_JPRB, 0.25834663E-06_JPRB, 0.25614600E-06_JPRB, 0.25414332E-06_JPRB, 0.25237821E-06_JPRB, &
  & 0.25091404E-06_JPRB, 0.24957581E-06_JPRB, 0.24839923E-06_JPRB, 0.24610816E-06_JPRB /)

RGHG3(:,21,11) = (/ &
  & 0.21961344E-06_JPRB, 0.22268514E-06_JPRB, 0.22494933E-06_JPRB, 0.22727288E-06_JPRB, 0.22988894E-06_JPRB, 0.23284088E-06_JPRB, &
  & 0.23612708E-06_JPRB, 0.23966220E-06_JPRB, 0.24335498E-06_JPRB, 0.24709118E-06_JPRB, 0.25078202E-06_JPRB, 0.25436970E-06_JPRB, &
  & 0.25783086E-06_JPRB, 0.26117311E-06_JPRB, 0.26442356E-06_JPRB, 0.26760151E-06_JPRB, 0.27070115E-06_JPRB, 0.27367980E-06_JPRB, &
  & 0.27647644E-06_JPRB, 0.27902297E-06_JPRB, 0.28124191E-06_JPRB, 0.28305610E-06_JPRB, 0.28440579E-06_JPRB, 0.28526910E-06_JPRB, &
  & 0.28567752E-06_JPRB, 0.28573578E-06_JPRB, 0.28559003E-06_JPRB, 0.28537568E-06_JPRB, 0.28520432E-06_JPRB, 0.28514279E-06_JPRB, &
  & 0.28521330E-06_JPRB, 0.28539031E-06_JPRB, 0.28564918E-06_JPRB, 0.28598313E-06_JPRB, 0.28638885E-06_JPRB, 0.28685915E-06_JPRB, &
  & 0.28738572E-06_JPRB, 0.28787221E-06_JPRB, 0.28827409E-06_JPRB, 0.28847137E-06_JPRB, 0.28845602E-06_JPRB, 0.28818329E-06_JPRB, &
  & 0.28769693E-06_JPRB, 0.28703062E-06_JPRB, 0.28621773E-06_JPRB, 0.28530388E-06_JPRB, 0.28430173E-06_JPRB, 0.28320233E-06_JPRB, &
  & 0.28199344E-06_JPRB, 0.28065497E-06_JPRB, 0.27917014E-06_JPRB, 0.27753163E-06_JPRB, 0.27574313E-06_JPRB, 0.27382626E-06_JPRB, &
  & 0.27182168E-06_JPRB, 0.26979285E-06_JPRB, 0.26779514E-06_JPRB, 0.26588859E-06_JPRB, 0.26411897E-06_JPRB, 0.26253230E-06_JPRB, &
  & 0.26111979E-06_JPRB, 0.25995038E-06_JPRB, 0.25858003E-06_JPRB, 0.25662777E-06_JPRB /)

RGHG3(:,22,11) = (/ &
  & 0.22823588E-06_JPRB, 0.23129142E-06_JPRB, 0.23347128E-06_JPRB, 0.23568661E-06_JPRB, 0.23811796E-06_JPRB, 0.24084295E-06_JPRB, &
  & 0.24383064E-06_JPRB, 0.24703641E-06_JPRB, 0.25037463E-06_JPRB, 0.25375854E-06_JPRB, 0.25712552E-06_JPRB, 0.26042659E-06_JPRB, &
  & 0.26364231E-06_JPRB, 0.26676676E-06_JPRB, 0.26981763E-06_JPRB, 0.27280382E-06_JPRB, 0.27571963E-06_JPRB, 0.27853429E-06_JPRB, &
  & 0.28119314E-06_JPRB, 0.28364025E-06_JPRB, 0.28581843E-06_JPRB, 0.28766482E-06_JPRB, 0.28912106E-06_JPRB, 0.29016442E-06_JPRB, &
  & 0.29083165E-06_JPRB, 0.29121404E-06_JPRB, 0.29142021E-06_JPRB, 0.29155285E-06_JPRB, 0.29167595E-06_JPRB, 0.29182368E-06_JPRB, &
  & 0.29198253E-06_JPRB, 0.29212839E-06_JPRB, 0.29224651E-06_JPRB, 0.29235787E-06_JPRB, 0.29249449E-06_JPRB, 0.29267542E-06_JPRB, &
  & 0.29292718E-06_JPRB, 0.29319577E-06_JPRB, 0.29340111E-06_JPRB, 0.29351179E-06_JPRB, 0.29344886E-06_JPRB, 0.29318983E-06_JPRB, &
  & 0.29273713E-06_JPRB, 0.29211859E-06_JPRB, 0.29136262E-06_JPRB, 0.29050071E-06_JPRB, 0.28956279E-06_JPRB, 0.28855086E-06_JPRB, &
  & 0.28745541E-06_JPRB, 0.28627088E-06_JPRB, 0.28498511E-06_JPRB, 0.28359372E-06_JPRB, 0.28209627E-06_JPRB, 0.28050306E-06_JPRB, &
  & 0.27884153E-06_JPRB, 0.27714492E-06_JPRB, 0.27545738E-06_JPRB, 0.27381597E-06_JPRB, 0.27226028E-06_JPRB, 0.27082297E-06_JPRB, &
  & 0.26955300E-06_JPRB, 0.26832757E-06_JPRB, 0.26719545E-06_JPRB, 0.26501374E-06_JPRB /)

RGHG3(:,23,11) = (/ &
  & 0.23590685E-06_JPRB, 0.23880202E-06_JPRB, 0.24094157E-06_JPRB, 0.24300576E-06_JPRB, 0.24525625E-06_JPRB, 0.24773075E-06_JPRB, &
  & 0.25042985E-06_JPRB, 0.25330240E-06_JPRB, 0.25629674E-06_JPRB, 0.25935097E-06_JPRB, 0.26241509E-06_JPRB, 0.26545104E-06_JPRB, &
  & 0.26844381E-06_JPRB, 0.27138375E-06_JPRB, 0.27427089E-06_JPRB, 0.27709987E-06_JPRB, 0.27986496E-06_JPRB, 0.28254246E-06_JPRB, &
  & 0.28509541E-06_JPRB, 0.28747903E-06_JPRB, 0.28964396E-06_JPRB, 0.29153176E-06_JPRB, 0.29308910E-06_JPRB, 0.29429589E-06_JPRB, &
  & 0.29517500E-06_JPRB, 0.29579445E-06_JPRB, 0.29623769E-06_JPRB, 0.29658008E-06_JPRB, 0.29686072E-06_JPRB, 0.29709150E-06_JPRB, &
  & 0.29726459E-06_JPRB, 0.29736367E-06_JPRB, 0.29738746E-06_JPRB, 0.29736071E-06_JPRB, 0.29733545E-06_JPRB, 0.29733783E-06_JPRB, &
  & 0.29741156E-06_JPRB, 0.29751754E-06_JPRB, 0.29761554E-06_JPRB, 0.29765562E-06_JPRB, 0.29755029E-06_JPRB, 0.29729233E-06_JPRB, &
  & 0.29687021E-06_JPRB, 0.29628464E-06_JPRB, 0.29557049E-06_JPRB, 0.29475049E-06_JPRB, 0.29385345E-06_JPRB, 0.29289734E-06_JPRB, &
  & 0.29188027E-06_JPRB, 0.29080616E-06_JPRB, 0.28966483E-06_JPRB, 0.28845579E-06_JPRB, 0.28717929E-06_JPRB, 0.28584293E-06_JPRB, &
  & 0.28445680E-06_JPRB, 0.28303717E-06_JPRB, 0.28160756E-06_JPRB, 0.28019133E-06_JPRB, 0.27881961E-06_JPRB, 0.27752071E-06_JPRB, &
  & 0.27630293E-06_JPRB, 0.27520005E-06_JPRB, 0.27391130E-06_JPRB, 0.27190131E-06_JPRB /)

RGHG3(:,24,11) = (/ &
  & 0.24262394E-06_JPRB, 0.24541652E-06_JPRB, 0.24742630E-06_JPRB, 0.24936267E-06_JPRB, 0.25142782E-06_JPRB, 0.25367822E-06_JPRB, &
  & 0.25610336E-06_JPRB, 0.25868113E-06_JPRB, 0.26137101E-06_JPRB, 0.26413124E-06_JPRB, 0.26692871E-06_JPRB, 0.26972933E-06_JPRB, &
  & 0.27251869E-06_JPRB, 0.27528571E-06_JPRB, 0.27802733E-06_JPRB, 0.28072731E-06_JPRB, 0.28336680E-06_JPRB, 0.28592288E-06_JPRB, &
  & 0.28837798E-06_JPRB, 0.29070080E-06_JPRB, 0.29284800E-06_JPRB, 0.29476567E-06_JPRB, 0.29640134E-06_JPRB, 0.29772653E-06_JPRB, &
  & 0.29875221E-06_JPRB, 0.29953088E-06_JPRB, 0.30012168E-06_JPRB, 0.30057868E-06_JPRB, 0.30093099E-06_JPRB, 0.30119065E-06_JPRB, &
  & 0.30135442E-06_JPRB, 0.30141791E-06_JPRB, 0.30139284E-06_JPRB, 0.30129874E-06_JPRB, 0.30118852E-06_JPRB, 0.30110400E-06_JPRB, &
  & 0.30106938E-06_JPRB, 0.30107421E-06_JPRB, 0.30108865E-06_JPRB, 0.30105733E-06_JPRB, 0.30092863E-06_JPRB, 0.30066508E-06_JPRB, &
  & 0.30026095E-06_JPRB, 0.29970292E-06_JPRB, 0.29901406E-06_JPRB, 0.29822493E-06_JPRB, 0.29736034E-06_JPRB, 0.29644687E-06_JPRB, &
  & 0.29548528E-06_JPRB, 0.29448518E-06_JPRB, 0.29344702E-06_JPRB, 0.29237358E-06_JPRB, 0.29126545E-06_JPRB, 0.29012534E-06_JPRB, &
  & 0.28895425E-06_JPRB, 0.28775585E-06_JPRB, 0.28653599E-06_JPRB, 0.28530877E-06_JPRB, 0.28409269E-06_JPRB, 0.28290918E-06_JPRB, &
  & 0.28178172E-06_JPRB, 0.28065969E-06_JPRB, 0.27947516E-06_JPRB, 0.27738238E-06_JPRB /)

RGHG3(:,25,11) = (/ &
  & 0.24852218E-06_JPRB, 0.25124729E-06_JPRB, 0.25313309E-06_JPRB, 0.25493205E-06_JPRB, 0.25683229E-06_JPRB, 0.25887906E-06_JPRB, &
  & 0.26107435E-06_JPRB, 0.26339714E-06_JPRB, 0.26582617E-06_JPRB, 0.26833368E-06_JPRB, 0.27089649E-06_JPRB, 0.27348747E-06_JPRB, &
  & 0.27608854E-06_JPRB, 0.27868771E-06_JPRB, 0.28127707E-06_JPRB, 0.28383982E-06_JPRB, 0.28636069E-06_JPRB, 0.28881544E-06_JPRB, &
  & 0.29117854E-06_JPRB, 0.29343022E-06_JPRB, 0.29553971E-06_JPRB, 0.29745709E-06_JPRB, 0.29912891E-06_JPRB, 0.30052277E-06_JPRB, &
  & 0.30164136E-06_JPRB, 0.30251721E-06_JPRB, 0.30319575E-06_JPRB, 0.30371581E-06_JPRB, 0.30410271E-06_JPRB, 0.30437079E-06_JPRB, &
  & 0.30452460E-06_JPRB, 0.30457201E-06_JPRB, 0.30453214E-06_JPRB, 0.30442584E-06_JPRB, 0.30428947E-06_JPRB, 0.30416851E-06_JPRB, &
  & 0.30408282E-06_JPRB, 0.30402435E-06_JPRB, 0.30397948E-06_JPRB, 0.30389288E-06_JPRB, 0.30373204E-06_JPRB, 0.30345592E-06_JPRB, &
  & 0.30305375E-06_JPRB, 0.30251502E-06_JPRB, 0.30184808E-06_JPRB, 0.30108120E-06_JPRB, 0.30024077E-06_JPRB, 0.29935492E-06_JPRB, &
  & 0.29843679E-06_JPRB, 0.29749623E-06_JPRB, 0.29653438E-06_JPRB, 0.29555895E-06_JPRB, 0.29457433E-06_JPRB, 0.29358054E-06_JPRB, &
  & 0.29257291E-06_JPRB, 0.29154518E-06_JPRB, 0.29049670E-06_JPRB, 0.28942978E-06_JPRB, 0.28835703E-06_JPRB, 0.28729406E-06_JPRB, &
  & 0.28625132E-06_JPRB, 0.28520950E-06_JPRB, 0.28404583E-06_JPRB, 0.28196013E-06_JPRB /)

RGHG3(:,26,11) = (/ &
  & 0.25380513E-06_JPRB, 0.25647307E-06_JPRB, 0.25824156E-06_JPRB, 0.25992492E-06_JPRB, 0.26167569E-06_JPRB, 0.26354999E-06_JPRB, &
  & 0.26554713E-06_JPRB, 0.26765628E-06_JPRB, 0.26986214E-06_JPRB, 0.27215162E-06_JPRB, 0.27450568E-06_JPRB, 0.27690601E-06_JPRB, &
  & 0.27933373E-06_JPRB, 0.28177243E-06_JPRB, 0.28421255E-06_JPRB, 0.28663482E-06_JPRB, 0.28902096E-06_JPRB, 0.29135404E-06_JPRB, &
  & 0.29361613E-06_JPRB, 0.29578263E-06_JPRB, 0.29782692E-06_JPRB, 0.29970582E-06_JPRB, 0.30136957E-06_JPRB, 0.30278602E-06_JPRB, &
  & 0.30394844E-06_JPRB, 0.30487860E-06_JPRB, 0.30560912E-06_JPRB, 0.30616818E-06_JPRB, 0.30657733E-06_JPRB, 0.30685339E-06_JPRB, &
  & 0.30700792E-06_JPRB, 0.30705854E-06_JPRB, 0.30702731E-06_JPRB, 0.30693772E-06_JPRB, 0.30681153E-06_JPRB, 0.30668392E-06_JPRB, &
  & 0.30657580E-06_JPRB, 0.30648408E-06_JPRB, 0.30639006E-06_JPRB, 0.30626308E-06_JPRB, 0.30606941E-06_JPRB, 0.30577721E-06_JPRB, &
  & 0.30537197E-06_JPRB, 0.30484330E-06_JPRB, 0.30419443E-06_JPRB, 0.30344592E-06_JPRB, 0.30262569E-06_JPRB, 0.30176167E-06_JPRB, &
  & 0.30087278E-06_JPRB, 0.29997210E-06_JPRB, 0.29906892E-06_JPRB, 0.29817224E-06_JPRB, 0.29728332E-06_JPRB, 0.29640037E-06_JPRB, &
  & 0.29551518E-06_JPRB, 0.29462018E-06_JPRB, 0.29371012E-06_JPRB, 0.29278380E-06_JPRB, 0.29184901E-06_JPRB, 0.29091368E-06_JPRB, &
  & 0.28998511E-06_JPRB, 0.28905151E-06_JPRB, 0.28794085E-06_JPRB, 0.28605223E-06_JPRB /)

RGHG3(:,27,11) = (/ &
  & 0.25866183E-06_JPRB, 0.26128080E-06_JPRB, 0.26295893E-06_JPRB, 0.26452452E-06_JPRB, 0.26614737E-06_JPRB, 0.26786725E-06_JPRB, &
  & 0.26969258E-06_JPRB, 0.27161460E-06_JPRB, 0.27362660E-06_JPRB, 0.27571690E-06_JPRB, 0.27788028E-06_JPRB, 0.28009842E-06_JPRB, &
  & 0.28235269E-06_JPRB, 0.28463811E-06_JPRB, 0.28693114E-06_JPRB, 0.28922139E-06_JPRB, 0.29147472E-06_JPRB, 0.29368044E-06_JPRB, &
  & 0.29582051E-06_JPRB, 0.29787364E-06_JPRB, 0.29981760E-06_JPRB, 0.30162175E-06_JPRB, 0.30323747E-06_JPRB, 0.30463795E-06_JPRB, &
  & 0.30580878E-06_JPRB, 0.30676020E-06_JPRB, 0.30751846E-06_JPRB, 0.30810236E-06_JPRB, 0.30853005E-06_JPRB, 0.30881776E-06_JPRB, &
  & 0.30898244E-06_JPRB, 0.30904800E-06_JPRB, 0.30903780E-06_JPRB, 0.30897493E-06_JPRB, 0.30887654E-06_JPRB, 0.30876060E-06_JPRB, &
  & 0.30864740E-06_JPRB, 0.30853502E-06_JPRB, 0.30840658E-06_JPRB, 0.30824489E-06_JPRB, 0.30802263E-06_JPRB, 0.30771562E-06_JPRB, &
  & 0.30730729E-06_JPRB, 0.30678621E-06_JPRB, 0.30615280E-06_JPRB, 0.30542336E-06_JPRB, 0.30462527E-06_JPRB, 0.30378811E-06_JPRB, &
  & 0.30292819E-06_JPRB, 0.30206090E-06_JPRB, 0.30120012E-06_JPRB, 0.30035801E-06_JPRB, 0.29953912E-06_JPRB, 0.29873871E-06_JPRB, &
  & 0.29794805E-06_JPRB, 0.29715852E-06_JPRB, 0.29636274E-06_JPRB, 0.29555923E-06_JPRB, 0.29475160E-06_JPRB, 0.29394937E-06_JPRB, &
  & 0.29315552E-06_JPRB, 0.29233180E-06_JPRB, 0.29142021E-06_JPRB, 0.28968086E-06_JPRB /)

RGHG3(:,28,11) = (/ &
  & 0.26323906E-06_JPRB, 0.26580784E-06_JPRB, 0.26740011E-06_JPRB, 0.26887579E-06_JPRB, 0.27037231E-06_JPRB, 0.27195367E-06_JPRB, &
  & 0.27362341E-06_JPRB, 0.27537811E-06_JPRB, 0.27720981E-06_JPRB, 0.27912031E-06_JPRB, 0.28109918E-06_JPRB, 0.28313841E-06_JPRB, &
  & 0.28522302E-06_JPRB, 0.28734905E-06_JPRB, 0.28948566E-06_JPRB, 0.29163243E-06_JPRB, 0.29374888E-06_JPRB, 0.29582537E-06_JPRB, &
  & 0.29783754E-06_JPRB, 0.29976647E-06_JPRB, 0.30159563E-06_JPRB, 0.30330119E-06_JPRB, 0.30484443E-06_JPRB, 0.30619930E-06_JPRB, &
  & 0.30734873E-06_JPRB, 0.30829639E-06_JPRB, 0.30906267E-06_JPRB, 0.30965924E-06_JPRB, 0.31010114E-06_JPRB, 0.31040159E-06_JPRB, &
  & 0.31058093E-06_JPRB, 0.31066557E-06_JPRB, 0.31067987E-06_JPRB, 0.31064559E-06_JPRB, 0.31057604E-06_JPRB, 0.31047966E-06_JPRB, &
  & 0.31036942E-06_JPRB, 0.31024584E-06_JPRB, 0.31009549E-06_JPRB, 0.30990728E-06_JPRB, 0.30966194E-06_JPRB, 0.30934112E-06_JPRB, &
  & 0.30892983E-06_JPRB, 0.30841656E-06_JPRB, 0.30779722E-06_JPRB, 0.30708480E-06_JPRB, 0.30630315E-06_JPRB, 0.30547554E-06_JPRB, &
  & 0.30463161E-06_JPRB, 0.30379661E-06_JPRB, 0.30298708E-06_JPRB, 0.30220502E-06_JPRB, 0.30144946E-06_JPRB, 0.30071899E-06_JPRB, &
  & 0.30000575E-06_JPRB, 0.29930061E-06_JPRB, 0.29859822E-06_JPRB, 0.29789686E-06_JPRB, 0.29720087E-06_JPRB, 0.29651369E-06_JPRB, &
  & 0.29583811E-06_JPRB, 0.29516090E-06_JPRB, 0.29435017E-06_JPRB, 0.29294691E-06_JPRB /)

RGHG3(:,29,11) = (/ &
  & 0.26762621E-06_JPRB, 0.27012533E-06_JPRB, 0.27166294E-06_JPRB, 0.27303057E-06_JPRB, 0.27442198E-06_JPRB, 0.27587052E-06_JPRB, &
  & 0.27739782E-06_JPRB, 0.27899597E-06_JPRB, 0.28066549E-06_JPRB, 0.28240080E-06_JPRB, 0.28420763E-06_JPRB, 0.28607104E-06_JPRB, &
  & 0.28799388E-06_JPRB, 0.28995098E-06_JPRB, 0.29193723E-06_JPRB, 0.29393760E-06_JPRB, 0.29591655E-06_JPRB, 0.29785431E-06_JPRB, &
  & 0.29973060E-06_JPRB, 0.30152808E-06_JPRB, 0.30323309E-06_JPRB, 0.30482727E-06_JPRB, 0.30628019E-06_JPRB, 0.30756769E-06_JPRB, &
  & 0.30867429E-06_JPRB, 0.30959566E-06_JPRB, 0.31034989E-06_JPRB, 0.31094578E-06_JPRB, 0.31139365E-06_JPRB, 0.31170410E-06_JPRB, &
  & 0.31189708E-06_JPRB, 0.31199966E-06_JPRB, 0.31203612E-06_JPRB, 0.31202677E-06_JPRB, 0.31198127E-06_JPRB, 0.31190405E-06_JPRB, &
  & 0.31180051E-06_JPRB, 0.31167212E-06_JPRB, 0.31150864E-06_JPRB, 0.31130293E-06_JPRB, 0.31104105E-06_JPRB, 0.31071031E-06_JPRB, &
  & 0.31029748E-06_JPRB, 0.30979214E-06_JPRB, 0.30918901E-06_JPRB, 0.30849634E-06_JPRB, 0.30773310E-06_JPRB, 0.30693127E-06_JPRB, &
  & 0.30612469E-06_JPRB, 0.30533010E-06_JPRB, 0.30455354E-06_JPRB, 0.30380693E-06_JPRB, 0.30310034E-06_JPRB, 0.30242612E-06_JPRB, &
  & 0.30177438E-06_JPRB, 0.30113659E-06_JPRB, 0.30050714E-06_JPRB, 0.29988541E-06_JPRB, 0.29927415E-06_JPRB, 0.29868087E-06_JPRB, &
  & 0.29810377E-06_JPRB, 0.29752064E-06_JPRB, 0.29687092E-06_JPRB, 0.29568395E-06_JPRB /)

RGHG3(:,30,11) = (/ &
  & 0.27182924E-06_JPRB, 0.27429425E-06_JPRB, 0.27573637E-06_JPRB, 0.27703365E-06_JPRB, 0.27830879E-06_JPRB, 0.27963949E-06_JPRB, &
  & 0.28103079E-06_JPRB, 0.28248550E-06_JPRB, 0.28399671E-06_JPRB, 0.28557290E-06_JPRB, 0.28721126E-06_JPRB, 0.28890938E-06_JPRB, &
  & 0.29067061E-06_JPRB, 0.29246641E-06_JPRB, 0.29430365E-06_JPRB, 0.29616334E-06_JPRB, 0.29800688E-06_JPRB, 0.29980899E-06_JPRB, &
  & 0.30154834E-06_JPRB, 0.30321036E-06_JPRB, 0.30478313E-06_JPRB, 0.30625432E-06_JPRB, 0.30760464E-06_JPRB, 0.30881154E-06_JPRB, &
  & 0.30985339E-06_JPRB, 0.31073111E-06_JPRB, 0.31145521E-06_JPRB, 0.31203709E-06_JPRB, 0.31248112E-06_JPRB, 0.31279532E-06_JPRB, &
  & 0.31299766E-06_JPRB, 0.31311367E-06_JPRB, 0.31316722E-06_JPRB, 0.31317666E-06_JPRB, 0.31314875E-06_JPRB, 0.31308633E-06_JPRB, &
  & 0.31299015E-06_JPRB, 0.31286098E-06_JPRB, 0.31269090E-06_JPRB, 0.31247532E-06_JPRB, 0.31220392E-06_JPRB, 0.31186804E-06_JPRB, &
  & 0.31145620E-06_JPRB, 0.31096022E-06_JPRB, 0.31037314E-06_JPRB, 0.30969977E-06_JPRB, 0.30895981E-06_JPRB, 0.30818384E-06_JPRB, &
  & 0.30740313E-06_JPRB, 0.30663270E-06_JPRB, 0.30589550E-06_JPRB, 0.30520363E-06_JPRB, 0.30454979E-06_JPRB, 0.30392562E-06_JPRB, &
  & 0.30332259E-06_JPRB, 0.30273424E-06_JPRB, 0.30215728E-06_JPRB, 0.30159129E-06_JPRB, 0.30104223E-06_JPRB, 0.30051447E-06_JPRB, &
  & 0.30001220E-06_JPRB, 0.29951465E-06_JPRB, 0.29894733E-06_JPRB, 0.29796087E-06_JPRB /)

RGHG3(:,31,11) = (/ &
  & 0.27589698E-06_JPRB, 0.27825729E-06_JPRB, 0.27965669E-06_JPRB, 0.28084986E-06_JPRB, 0.28203345E-06_JPRB, 0.28324729E-06_JPRB, &
  & 0.28451569E-06_JPRB, 0.28583270E-06_JPRB, 0.28720066E-06_JPRB, 0.28862044E-06_JPRB, 0.29010084E-06_JPRB, 0.29164056E-06_JPRB, &
  & 0.29324181E-06_JPRB, 0.29488467E-06_JPRB, 0.29657738E-06_JPRB, 0.29829681E-06_JPRB, 0.30000913E-06_JPRB, 0.30168263E-06_JPRB, &
  & 0.30329252E-06_JPRB, 0.30481991E-06_JPRB, 0.30626097E-06_JPRB, 0.30760984E-06_JPRB, 0.30885161E-06_JPRB, 0.30996532E-06_JPRB, &
  & 0.31093211E-06_JPRB, 0.31174886E-06_JPRB, 0.31243107E-06_JPRB, 0.31298433E-06_JPRB, 0.31341369E-06_JPRB, 0.31372377E-06_JPRB, &
  & 0.31392938E-06_JPRB, 0.31405341E-06_JPRB, 0.31411787E-06_JPRB, 0.31413924E-06_JPRB, 0.31412259E-06_JPRB, 0.31406964E-06_JPRB, &
  & 0.31397994E-06_JPRB, 0.31385184E-06_JPRB, 0.31368026E-06_JPRB, 0.31346079E-06_JPRB, 0.31318609E-06_JPRB, 0.31284969E-06_JPRB, &
  & 0.31244170E-06_JPRB, 0.31195603E-06_JPRB, 0.31138515E-06_JPRB, 0.31073367E-06_JPRB, 0.31002028E-06_JPRB, 0.30927902E-06_JPRB, &
  & 0.30853158E-06_JPRB, 0.30780512E-06_JPRB, 0.30711402E-06_JPRB, 0.30646106E-06_JPRB, 0.30584494E-06_JPRB, 0.30525828E-06_JPRB, &
  & 0.30469357E-06_JPRB, 0.30414361E-06_JPRB, 0.30360363E-06_JPRB, 0.30307672E-06_JPRB, 0.30256965E-06_JPRB, 0.30209165E-06_JPRB, &
  & 0.30163744E-06_JPRB, 0.30119409E-06_JPRB, 0.30070015E-06_JPRB, 0.29984702E-06_JPRB /)

RGHG3(:,32,11) = (/ &
  & 0.27976995E-06_JPRB, 0.28206199E-06_JPRB, 0.28335646E-06_JPRB, 0.28448230E-06_JPRB, 0.28556644E-06_JPRB, 0.28667836E-06_JPRB, &
  & 0.28782972E-06_JPRB, 0.28902221E-06_JPRB, 0.29025153E-06_JPRB, 0.29152710E-06_JPRB, 0.29285363E-06_JPRB, 0.29424021E-06_JPRB, &
  & 0.29568469E-06_JPRB, 0.29718407E-06_JPRB, 0.29873618E-06_JPRB, 0.30032118E-06_JPRB, 0.30190603E-06_JPRB, 0.30345592E-06_JPRB, &
  & 0.30494220E-06_JPRB, 0.30634834E-06_JPRB, 0.30766836E-06_JPRB, 0.30889916E-06_JPRB, 0.31003199E-06_JPRB, 0.31104776E-06_JPRB, &
  & 0.31193059E-06_JPRB, 0.31268067E-06_JPRB, 0.31330759E-06_JPRB, 0.31382206E-06_JPRB, 0.31422624E-06_JPRB, 0.31452399E-06_JPRB, &
  & 0.31472658E-06_JPRB, 0.31485260E-06_JPRB, 0.31492226E-06_JPRB, 0.31494929E-06_JPRB, 0.31493832E-06_JPRB, 0.31489111E-06_JPRB, &
  & 0.31480621E-06_JPRB, 0.31468036E-06_JPRB, 0.31451080E-06_JPRB, 0.31429187E-06_JPRB, 0.31401888E-06_JPRB, 0.31368518E-06_JPRB, &
  & 0.31328366E-06_JPRB, 0.31280905E-06_JPRB, 0.31225528E-06_JPRB, 0.31162881E-06_JPRB, 0.31095158E-06_JPRB, 0.31024564E-06_JPRB, &
  & 0.30953771E-06_JPRB, 0.30884988E-06_JPRB, 0.30819714E-06_JPRB, 0.30758437E-06_JPRB, 0.30700664E-06_JPRB, 0.30645779E-06_JPRB, &
  & 0.30592656E-06_JPRB, 0.30540502E-06_JPRB, 0.30489292E-06_JPRB, 0.30439330E-06_JPRB, 0.30391752E-06_JPRB, 0.30346979E-06_JPRB, &
  & 0.30305512E-06_JPRB, 0.30265105E-06_JPRB, 0.30220900E-06_JPRB, 0.30144798E-06_JPRB /)

RGHG3(:,33,11) = (/ &
  & 0.28347358E-06_JPRB, 0.28562491E-06_JPRB, 0.28685190E-06_JPRB, 0.28788557E-06_JPRB, 0.28888451E-06_JPRB, 0.28990098E-06_JPRB, &
  & 0.29094832E-06_JPRB, 0.29202400E-06_JPRB, 0.29312827E-06_JPRB, 0.29426471E-06_JPRB, 0.29544512E-06_JPRB, 0.29668075E-06_JPRB, &
  & 0.29797513E-06_JPRB, 0.29933406E-06_JPRB, 0.30075381E-06_JPRB, 0.30221153E-06_JPRB, 0.30367954E-06_JPRB, 0.30511902E-06_JPRB, &
  & 0.30649437E-06_JPRB, 0.30778895E-06_JPRB, 0.30899722E-06_JPRB, 0.31011973E-06_JPRB, 0.31114590E-06_JPRB, 0.31206378E-06_JPRB, &
  & 0.31285970E-06_JPRB, 0.31353483E-06_JPRB, 0.31410201E-06_JPRB, 0.31456949E-06_JPRB, 0.31494153E-06_JPRB, 0.31522026E-06_JPRB, &
  & 0.31541327E-06_JPRB, 0.31553606E-06_JPRB, 0.31560558E-06_JPRB, 0.31563323E-06_JPRB, 0.31562411E-06_JPRB, 0.31558051E-06_JPRB, &
  & 0.31549888E-06_JPRB, 0.31537712E-06_JPRB, 0.31521171E-06_JPRB, 0.31499687E-06_JPRB, 0.31472899E-06_JPRB, 0.31440075E-06_JPRB, &
  & 0.31400779E-06_JPRB, 0.31354486E-06_JPRB, 0.31301045E-06_JPRB, 0.31241373E-06_JPRB, 0.31176916E-06_JPRB, 0.31110091E-06_JPRB, &
  & 0.31043265E-06_JPRB, 0.30978879E-06_JPRB, 0.30917897E-06_JPRB, 0.30860599E-06_JPRB, 0.30806714E-06_JPRB, 0.30755044E-06_JPRB, &
  & 0.30704632E-06_JPRB, 0.30654959E-06_JPRB, 0.30605921E-06_JPRB, 0.30558206E-06_JPRB, 0.30512700E-06_JPRB, 0.30470630E-06_JPRB, &
  & 0.30431636E-06_JPRB, 0.30394662E-06_JPRB, 0.30353667E-06_JPRB, 0.30285113E-06_JPRB /)

RGHG3(:,34,11) = (/ &
  & 0.28696428E-06_JPRB, 0.28896190E-06_JPRB, 0.29008675E-06_JPRB, 0.29103799E-06_JPRB, 0.29195749E-06_JPRB, 0.29288537E-06_JPRB, &
  & 0.29383841E-06_JPRB, 0.29481075E-06_JPRB, 0.29579797E-06_JPRB, 0.29680689E-06_JPRB, 0.29784761E-06_JPRB, 0.29893690E-06_JPRB, &
  & 0.30008741E-06_JPRB, 0.30130963E-06_JPRB, 0.30260185E-06_JPRB, 0.30394202E-06_JPRB, 0.30530106E-06_JPRB, 0.30663875E-06_JPRB, &
  & 0.30791929E-06_JPRB, 0.30912145E-06_JPRB, 0.31023745E-06_JPRB, 0.31126419E-06_JPRB, 0.31219443E-06_JPRB, 0.31301840E-06_JPRB, &
  & 0.31372866E-06_JPRB, 0.31432782E-06_JPRB, 0.31482972E-06_JPRB, 0.31524476E-06_JPRB, 0.31557758E-06_JPRB, 0.31582985E-06_JPRB, &
  & 0.31600769E-06_JPRB, 0.31612214E-06_JPRB, 0.31618674E-06_JPRB, 0.31621158E-06_JPRB, 0.31620306E-06_JPRB, 0.31616142E-06_JPRB, &
  & 0.31608357E-06_JPRB, 0.31596821E-06_JPRB, 0.31580888E-06_JPRB, 0.31560160E-06_JPRB, 0.31534097E-06_JPRB, 0.31502060E-06_JPRB, &
  & 0.31463665E-06_JPRB, 0.31418648E-06_JPRB, 0.31367222E-06_JPRB, 0.31310228E-06_JPRB, 0.31249397E-06_JPRB, 0.31186667E-06_JPRB, &
  & 0.31124711E-06_JPRB, 0.31064769E-06_JPRB, 0.31007968E-06_JPRB, 0.30954499E-06_JPRB, 0.30903647E-06_JPRB, 0.30854710E-06_JPRB, &
  & 0.30806765E-06_JPRB, 0.30759298E-06_JPRB, 0.30712397E-06_JPRB, 0.30666496E-06_JPRB, 0.30623059E-06_JPRB, 0.30582962E-06_JPRB, &
  & 0.30546619E-06_JPRB, 0.30511620E-06_JPRB, 0.30474285E-06_JPRB, 0.30410823E-06_JPRB /)

RGHG3(:,35,11) = (/ &
  & 0.29024028E-06_JPRB, 0.29205054E-06_JPRB, 0.29306057E-06_JPRB, 0.29392683E-06_JPRB, 0.29475899E-06_JPRB, 0.29561016E-06_JPRB, &
  & 0.29647731E-06_JPRB, 0.29735563E-06_JPRB, 0.29823926E-06_JPRB, 0.29912940E-06_JPRB, 0.30004048E-06_JPRB, 0.30099085E-06_JPRB, &
  & 0.30200385E-06_JPRB, 0.30309423E-06_JPRB, 0.30426557E-06_JPRB, 0.30549725E-06_JPRB, 0.30676026E-06_JPRB, 0.30801067E-06_JPRB, &
  & 0.30921305E-06_JPRB, 0.31033989E-06_JPRB, 0.31138069E-06_JPRB, 0.31232722E-06_JPRB, 0.31317316E-06_JPRB, 0.31391153E-06_JPRB, &
  & 0.31453882E-06_JPRB, 0.31506224E-06_JPRB, 0.31549635E-06_JPRB, 0.31585387E-06_JPRB, 0.31614115E-06_JPRB, 0.31636125E-06_JPRB, &
  & 0.31651797E-06_JPRB, 0.31661963E-06_JPRB, 0.31667628E-06_JPRB, 0.31669748E-06_JPRB, 0.31668895E-06_JPRB, 0.31664908E-06_JPRB, &
  & 0.31657783E-06_JPRB, 0.31647107E-06_JPRB, 0.31632169E-06_JPRB, 0.31612547E-06_JPRB, 0.31587510E-06_JPRB, 0.31556431E-06_JPRB, &
  & 0.31519087E-06_JPRB, 0.31475366E-06_JPRB, 0.31425878E-06_JPRB, 0.31371709E-06_JPRB, 0.31314340E-06_JPRB, 0.31255971E-06_JPRB, &
  & 0.31198061E-06_JPRB, 0.31142321E-06_JPRB, 0.31089454E-06_JPRB, 0.31039363E-06_JPRB, 0.30991694E-06_JPRB, 0.30945523E-06_JPRB, &
  & 0.30900068E-06_JPRB, 0.30854824E-06_JPRB, 0.30809795E-06_JPRB, 0.30765852E-06_JPRB, 0.30724175E-06_JPRB, 0.30686112E-06_JPRB, &
  & 0.30651324E-06_JPRB, 0.30618975E-06_JPRB, 0.30583573E-06_JPRB, 0.30525359E-06_JPRB /)

RGHG3(:,36,11) = (/ &
  & 0.29331855E-06_JPRB, 0.29488544E-06_JPRB, 0.29577993E-06_JPRB, 0.29654313E-06_JPRB, 0.29729878E-06_JPRB, 0.29806864E-06_JPRB, &
  & 0.29885848E-06_JPRB, 0.29965298E-06_JPRB, 0.30044146E-06_JPRB, 0.30122533E-06_JPRB, 0.30201610E-06_JPRB, 0.30283800E-06_JPRB, &
  & 0.30372064E-06_JPRB, 0.30468709E-06_JPRB, 0.30574427E-06_JPRB, 0.30687895E-06_JPRB, 0.30805720E-06_JPRB, 0.30923832E-06_JPRB, &
  & 0.31037681E-06_JPRB, 0.31144484E-06_JPRB, 0.31242365E-06_JPRB, 0.31330387E-06_JPRB, 0.31407521E-06_JPRB, 0.31473482E-06_JPRB, &
  & 0.31528279E-06_JPRB, 0.31573018E-06_JPRB, 0.31609454E-06_JPRB, 0.31639030E-06_JPRB, 0.31662688E-06_JPRB, 0.31680821E-06_JPRB, &
  & 0.31693892E-06_JPRB, 0.31702427E-06_JPRB, 0.31707145E-06_JPRB, 0.31708959E-06_JPRB, 0.31708106E-06_JPRB, 0.31704582E-06_JPRB, &
  & 0.31698434E-06_JPRB, 0.31688947E-06_JPRB, 0.31675623E-06_JPRB, 0.31657697E-06_JPRB, 0.31634247E-06_JPRB, 0.31604660E-06_JPRB, &
  & 0.31568518E-06_JPRB, 0.31526281E-06_JPRB, 0.31478692E-06_JPRB, 0.31427138E-06_JPRB, 0.31373301E-06_JPRB, 0.31318655E-06_JPRB, &
  & 0.31264884E-06_JPRB, 0.31212980E-06_JPRB, 0.31163600E-06_JPRB, 0.31116704E-06_JPRB, 0.31071642E-06_JPRB, 0.31028068E-06_JPRB, &
  & 0.30984901E-06_JPRB, 0.30941902E-06_JPRB, 0.30899025E-06_JPRB, 0.30857103E-06_JPRB, 0.30817239E-06_JPRB, 0.30780726E-06_JPRB, &
  & 0.30748001E-06_JPRB, 0.30717058E-06_JPRB, 0.30684447E-06_JPRB, 0.30629752E-06_JPRB /)

RGHG3(:,37,11) = (/ &
  & 0.29619198E-06_JPRB, 0.29751115E-06_JPRB, 0.29825958E-06_JPRB, 0.29892448E-06_JPRB, 0.29958966E-06_JPRB, 0.30028559E-06_JPRB, &
  & 0.30100028E-06_JPRB, 0.30171600E-06_JPRB, 0.30241853E-06_JPRB, 0.30310412E-06_JPRB, 0.30378607E-06_JPRB, 0.30449044E-06_JPRB, &
  & 0.30525160E-06_JPRB, 0.30610195E-06_JPRB, 0.30705280E-06_JPRB, 0.30809949E-06_JPRB, 0.30920313E-06_JPRB, 0.31032445E-06_JPRB, &
  & 0.31141593E-06_JPRB, 0.31243985E-06_JPRB, 0.31337009E-06_JPRB, 0.31419106E-06_JPRB, 0.31489259E-06_JPRB, 0.31547142E-06_JPRB, &
  & 0.31593547E-06_JPRB, 0.31630157E-06_JPRB, 0.31659127E-06_JPRB, 0.31682200E-06_JPRB, 0.31700449E-06_JPRB, 0.31714532E-06_JPRB, &
  & 0.31724784E-06_JPRB, 0.31731597E-06_JPRB, 0.31735456E-06_JPRB, 0.31737031E-06_JPRB, 0.31736312E-06_JPRB, 0.31733563E-06_JPRB, &
  & 0.31728547E-06_JPRB, 0.31720799E-06_JPRB, 0.31709703E-06_JPRB, 0.31694304E-06_JPRB, 0.31673616E-06_JPRB, 0.31646437E-06_JPRB, &
  & 0.31612547E-06_JPRB, 0.31572176E-06_JPRB, 0.31526670E-06_JPRB, 0.31477626E-06_JPRB, 0.31426794E-06_JPRB, 0.31375652E-06_JPRB, &
  & 0.31325303E-06_JPRB, 0.31276744E-06_JPRB, 0.31230425E-06_JPRB, 0.31186298E-06_JPRB, 0.31143858E-06_JPRB, 0.31102698E-06_JPRB, &
  & 0.31062103E-06_JPRB, 0.31021705E-06_JPRB, 0.30981283E-06_JPRB, 0.30941536E-06_JPRB, 0.30903561E-06_JPRB, 0.30868739E-06_JPRB, &
  & 0.30837273E-06_JPRB, 0.30808116E-06_JPRB, 0.30776738E-06_JPRB, 0.30725533E-06_JPRB /)

RGHG3(:,38,11) = (/ &
  & 0.29886095E-06_JPRB, 0.29990929E-06_JPRB, 0.30052763E-06_JPRB, 0.30108646E-06_JPRB, 0.30166666E-06_JPRB, 0.30228563E-06_JPRB, &
  & 0.30292722E-06_JPRB, 0.30356790E-06_JPRB, 0.30418860E-06_JPRB, 0.30478458E-06_JPRB, 0.30536816E-06_JPRB, 0.30596721E-06_JPRB, &
  & 0.30661820E-06_JPRB, 0.30736007E-06_JPRB, 0.30821442E-06_JPRB, 0.30917664E-06_JPRB, 0.31022074E-06_JPRB, 0.31128926E-06_JPRB, &
  & 0.31233685E-06_JPRB, 0.31331993E-06_JPRB, 0.31420171E-06_JPRB, 0.31495665E-06_JPRB, 0.31557431E-06_JPRB, 0.31606174E-06_JPRB, &
  & 0.31643560E-06_JPRB, 0.31672096E-06_JPRB, 0.31694151E-06_JPRB, 0.31711497E-06_JPRB, 0.31725244E-06_JPRB, 0.31735942E-06_JPRB, &
  & 0.31743932E-06_JPRB, 0.31749346E-06_JPRB, 0.31752586E-06_JPRB, 0.31753973E-06_JPRB, 0.31753495E-06_JPRB, 0.31751446E-06_JPRB, &
  & 0.31747533E-06_JPRB, 0.31741510E-06_JPRB, 0.31732765E-06_JPRB, 0.31720407E-06_JPRB, 0.31703203E-06_JPRB, 0.31679937E-06_JPRB, &
  & 0.31649657E-06_JPRB, 0.31612561E-06_JPRB, 0.31569664E-06_JPRB, 0.31523314E-06_JPRB, 0.31475392E-06_JPRB, 0.31427263E-06_JPRB, &
  & 0.31379955E-06_JPRB, 0.31334210E-06_JPRB, 0.31290395E-06_JPRB, 0.31248672E-06_JPRB, 0.31208651E-06_JPRB, 0.31170089E-06_JPRB, &
  & 0.31132419E-06_JPRB, 0.31094999E-06_JPRB, 0.31057510E-06_JPRB, 0.31020352E-06_JPRB, 0.30984484E-06_JPRB, 0.30951088E-06_JPRB, &
  & 0.30920904E-06_JPRB, 0.30892588E-06_JPRB, 0.30862850E-06_JPRB, 0.30813567E-06_JPRB /)

RGHG3(:,39,11) = (/ &
  & 0.30127495E-06_JPRB, 0.30209566E-06_JPRB, 0.30258650E-06_JPRB, 0.30304966E-06_JPRB, 0.30354977E-06_JPRB, 0.30409399E-06_JPRB, &
  & 0.30466470E-06_JPRB, 0.30523094E-06_JPRB, 0.30577343E-06_JPRB, 0.30628692E-06_JPRB, 0.30678410E-06_JPRB, 0.30728995E-06_JPRB, &
  & 0.30784577E-06_JPRB, 0.30848670E-06_JPRB, 0.30925173E-06_JPRB, 0.31013712E-06_JPRB, 0.31111637E-06_JPRB, 0.31213813E-06_JPRB, &
  & 0.31314042E-06_JPRB, 0.31406961E-06_JPRB, 0.31488275E-06_JPRB, 0.31555126E-06_JPRB, 0.31607402E-06_JPRB, 0.31646985E-06_JPRB, &
  & 0.31676541E-06_JPRB, 0.31698650E-06_JPRB, 0.31715641E-06_JPRB, 0.31729024E-06_JPRB, 0.31739734E-06_JPRB, 0.31748255E-06_JPRB, &
  & 0.31754763E-06_JPRB, 0.31759285E-06_JPRB, 0.31762144E-06_JPRB, 0.31763361E-06_JPRB, 0.31763108E-06_JPRB, 0.31761508E-06_JPRB, &
  & 0.31758421E-06_JPRB, 0.31753709E-06_JPRB, 0.31746814E-06_JPRB, 0.31737034E-06_JPRB, 0.31723243E-06_JPRB, 0.31704144E-06_JPRB, &
  & 0.31678641E-06_JPRB, 0.31645854E-06_JPRB, 0.31606911E-06_JPRB, 0.31563911E-06_JPRB, 0.31518931E-06_JPRB, 0.31473658E-06_JPRB, &
  & 0.31429011E-06_JPRB, 0.31385633E-06_JPRB, 0.31344018E-06_JPRB, 0.31304467E-06_JPRB, 0.31266848E-06_JPRB, 0.31231059E-06_JPRB, &
  & 0.31196433E-06_JPRB, 0.31162449E-06_JPRB, 0.31128320E-06_JPRB, 0.31094126E-06_JPRB, 0.31060520E-06_JPRB, 0.31028713E-06_JPRB, &
  & 0.30999496E-06_JPRB, 0.30972217E-06_JPRB, 0.30942928E-06_JPRB, 0.30895347E-06_JPRB /)

RGHG3(:,40,11) = (/ &
  & 0.30340865E-06_JPRB, 0.30404004E-06_JPRB, 0.30443380E-06_JPRB, 0.30481951E-06_JPRB, 0.30524734E-06_JPRB, 0.30572835E-06_JPRB, &
  & 0.30622996E-06_JPRB, 0.30672476E-06_JPRB, 0.30719397E-06_JPRB, 0.30763326E-06_JPRB, 0.30805367E-06_JPRB, 0.30848349E-06_JPRB, &
  & 0.30895276E-06_JPRB, 0.30951054E-06_JPRB, 0.31018629E-06_JPRB, 0.31100160E-06_JPRB, 0.31192084E-06_JPRB, 0.31288758E-06_JPRB, &
  & 0.31383192E-06_JPRB, 0.31469165E-06_JPRB, 0.31541515E-06_JPRB, 0.31598677E-06_JPRB, 0.31641741E-06_JPRB, 0.31673676E-06_JPRB, &
  & 0.31697229E-06_JPRB, 0.31714916E-06_JPRB, 0.31728558E-06_JPRB, 0.31739447E-06_JPRB, 0.31748331E-06_JPRB, 0.31755516E-06_JPRB, &
  & 0.31761118E-06_JPRB, 0.31765092E-06_JPRB, 0.31767701E-06_JPRB, 0.31768792E-06_JPRB, 0.31768684E-06_JPRB, 0.31767348E-06_JPRB, &
  & 0.31764839E-06_JPRB, 0.31760970E-06_JPRB, 0.31755388E-06_JPRB, 0.31747493E-06_JPRB, 0.31736383E-06_JPRB, 0.31720947E-06_JPRB, &
  & 0.31699787E-06_JPRB, 0.31671965E-06_JPRB, 0.31637839E-06_JPRB, 0.31598802E-06_JPRB, 0.31557343E-06_JPRB, 0.31514980E-06_JPRB, &
  & 0.31472871E-06_JPRB, 0.31431716E-06_JPRB, 0.31392059E-06_JPRB, 0.31354432E-06_JPRB, 0.31319269E-06_JPRB, 0.31286146E-06_JPRB, &
  & 0.31254953E-06_JPRB, 0.31224414E-06_JPRB, 0.31193940E-06_JPRB, 0.31162853E-06_JPRB, 0.31131867E-06_JPRB, 0.31101834E-06_JPRB, &
  & 0.31073859E-06_JPRB, 0.31047125E-06_JPRB, 0.31018814E-06_JPRB, 0.30971981E-06_JPRB /)

RGHG3(:,41,11) = (/ &
  & 0.30525410E-06_JPRB, 0.30575458E-06_JPRB, 0.30607447E-06_JPRB, 0.30639819E-06_JPRB, 0.30677538E-06_JPRB, 0.30719912E-06_JPRB, &
  & 0.30764261E-06_JPRB, 0.30807198E-06_JPRB, 0.30847414E-06_JPRB, 0.30884723E-06_JPRB, 0.30920447E-06_JPRB, 0.30956483E-06_JPRB, &
  & 0.30996767E-06_JPRB, 0.31044448E-06_JPRB, 0.31104616E-06_JPRB, 0.31178408E-06_JPRB, 0.31264099E-06_JPRB, 0.31354747E-06_JPRB, &
  & 0.31442670E-06_JPRB, 0.31519986E-06_JPRB, 0.31582843E-06_JPRB, 0.31630520E-06_JPRB, 0.31665726E-06_JPRB, 0.31691610E-06_JPRB, &
  & 0.31710877E-06_JPRB, 0.31725483E-06_JPRB, 0.31736937E-06_JPRB, 0.31746234E-06_JPRB, 0.31753910E-06_JPRB, 0.31760274E-06_JPRB, &
  & 0.31765268E-06_JPRB, 0.31768906E-06_JPRB, 0.31771305E-06_JPRB, 0.31772333E-06_JPRB, 0.31772277E-06_JPRB, 0.31771120E-06_JPRB, &
  & 0.31768980E-06_JPRB, 0.31765688E-06_JPRB, 0.31761016E-06_JPRB, 0.31754487E-06_JPRB, 0.31745390E-06_JPRB, 0.31732753E-06_JPRB, &
  & 0.31715336E-06_JPRB, 0.31692184E-06_JPRB, 0.31662879E-06_JPRB, 0.31628545E-06_JPRB, 0.31590693E-06_JPRB, 0.31551565E-06_JPRB, &
  & 0.31512138E-06_JPRB, 0.31473127E-06_JPRB, 0.31435346E-06_JPRB, 0.31399799E-06_JPRB, 0.31366716E-06_JPRB, 0.31336657E-06_JPRB, &
  & 0.31308454E-06_JPRB, 0.31281547E-06_JPRB, 0.31254459E-06_JPRB, 0.31226730E-06_JPRB, 0.31198499E-06_JPRB, 0.31170723E-06_JPRB, &
  & 0.31144188E-06_JPRB, 0.31118770E-06_JPRB, 0.31091017E-06_JPRB, 0.31045420E-06_JPRB /)

RGHG3(:,42,11) = (/ &
  & 0.30684691E-06_JPRB, 0.30725602E-06_JPRB, 0.30752466E-06_JPRB, 0.30780905E-06_JPRB, 0.30814437E-06_JPRB, 0.30853099E-06_JPRB, &
  & 0.30892352E-06_JPRB, 0.30929709E-06_JPRB, 0.30964100E-06_JPRB, 0.30995801E-06_JPRB, 0.31025820E-06_JPRB, 0.31056481E-06_JPRB, &
  & 0.31090218E-06_JPRB, 0.31131572E-06_JPRB, 0.31184044E-06_JPRB, 0.31251022E-06_JPRB, 0.31329830E-06_JPRB, 0.31413785E-06_JPRB, &
  & 0.31493505E-06_JPRB, 0.31561942E-06_JPRB, 0.31615053E-06_JPRB, 0.31654423E-06_JPRB, 0.31683149E-06_JPRB, 0.31704454E-06_JPRB, &
  & 0.31720509E-06_JPRB, 0.31732958E-06_JPRB, 0.31742897E-06_JPRB, 0.31751082E-06_JPRB, 0.31757995E-06_JPRB, 0.31763750E-06_JPRB, &
  & 0.31768303E-06_JPRB, 0.31771737E-06_JPRB, 0.31773939E-06_JPRB, 0.31774925E-06_JPRB, 0.31774871E-06_JPRB, 0.31773840E-06_JPRB, &
  & 0.31771941E-06_JPRB, 0.31769068E-06_JPRB, 0.31765057E-06_JPRB, 0.31759546E-06_JPRB, 0.31751986E-06_JPRB, 0.31741533E-06_JPRB, &
  & 0.31727240E-06_JPRB, 0.31708066E-06_JPRB, 0.31683433E-06_JPRB, 0.31653383E-06_JPRB, 0.31619780E-06_JPRB, 0.31583951E-06_JPRB, &
  & 0.31547356E-06_JPRB, 0.31510760E-06_JPRB, 0.31475076E-06_JPRB, 0.31441297E-06_JPRB, 0.31410767E-06_JPRB, 0.31383220E-06_JPRB, &
  & 0.31358303E-06_JPRB, 0.31334517E-06_JPRB, 0.31310822E-06_JPRB, 0.31286274E-06_JPRB, 0.31261004E-06_JPRB, 0.31235797E-06_JPRB, &
  & 0.31211511E-06_JPRB, 0.31187619E-06_JPRB, 0.31161554E-06_JPRB, 0.31117719E-06_JPRB /)

RGHG3(:,43,11) = (/ &
  & 0.30823304E-06_JPRB, 0.30858152E-06_JPRB, 0.30881674E-06_JPRB, 0.30907034E-06_JPRB, 0.30938412E-06_JPRB, 0.30973916E-06_JPRB, &
  & 0.31009552E-06_JPRB, 0.31042265E-06_JPRB, 0.31071892E-06_JPRB, 0.31098770E-06_JPRB, 0.31124171E-06_JPRB, 0.31149727E-06_JPRB, &
  & 0.31178362E-06_JPRB, 0.31213182E-06_JPRB, 0.31259052E-06_JPRB, 0.31318604E-06_JPRB, 0.31390562E-06_JPRB, 0.31466922E-06_JPRB, &
  & 0.31538235E-06_JPRB, 0.31596690E-06_JPRB, 0.31640886E-06_JPRB, 0.31672997E-06_JPRB, 0.31696493E-06_JPRB, 0.31714168E-06_JPRB, &
  & 0.31727814E-06_JPRB, 0.31738631E-06_JPRB, 0.31747464E-06_JPRB, 0.31754894E-06_JPRB, 0.31761212E-06_JPRB, 0.31766569E-06_JPRB, &
  & 0.31770765E-06_JPRB, 0.31774024E-06_JPRB, 0.31776040E-06_JPRB, 0.31776995E-06_JPRB, 0.31776918E-06_JPRB, 0.31775969E-06_JPRB, &
  & 0.31774240E-06_JPRB, 0.31771680E-06_JPRB, 0.31768175E-06_JPRB, 0.31763457E-06_JPRB, 0.31757094E-06_JPRB, 0.31748422E-06_JPRB, &
  & 0.31736676E-06_JPRB, 0.31720921E-06_JPRB, 0.31700264E-06_JPRB, 0.31674767E-06_JPRB, 0.31644905E-06_JPRB, 0.31612674E-06_JPRB, &
  & 0.31579188E-06_JPRB, 0.31545261E-06_JPRB, 0.31511843E-06_JPRB, 0.31480474E-06_JPRB, 0.31452200E-06_JPRB, 0.31427470E-06_JPRB, &
  & 0.31405361E-06_JPRB, 0.31384576E-06_JPRB, 0.31363859E-06_JPRB, 0.31342373E-06_JPRB, 0.31320150E-06_JPRB, 0.31297952E-06_JPRB, &
  & 0.31276369E-06_JPRB, 0.31255050E-06_JPRB, 0.31231252E-06_JPRB, 0.31190817E-06_JPRB /)

RGHG3(:,44,11) = (/ &
  & 0.30946001E-06_JPRB, 0.30976818E-06_JPRB, 0.30997791E-06_JPRB, 0.31021466E-06_JPRB, 0.31050894E-06_JPRB, 0.31084832E-06_JPRB, &
  & 0.31117443E-06_JPRB, 0.31146732E-06_JPRB, 0.31172436E-06_JPRB, 0.31195384E-06_JPRB, 0.31216683E-06_JPRB, 0.31238071E-06_JPRB, &
  & 0.31261675E-06_JPRB, 0.31291083E-06_JPRB, 0.31330211E-06_JPRB, 0.31382891E-06_JPRB, 0.31447493E-06_JPRB, 0.31515765E-06_JPRB, &
  & 0.31577238E-06_JPRB, 0.31626047E-06_JPRB, 0.31661878E-06_JPRB, 0.31687807E-06_JPRB, 0.31707080E-06_JPRB, 0.31721865E-06_JPRB, &
  & 0.31733600E-06_JPRB, 0.31743167E-06_JPRB, 0.31751171E-06_JPRB, 0.31758020E-06_JPRB, 0.31763938E-06_JPRB, 0.31768963E-06_JPRB, &
  & 0.31772885E-06_JPRB, 0.31775974E-06_JPRB, 0.31777847E-06_JPRB, 0.31778745E-06_JPRB, 0.31778649E-06_JPRB, 0.31777751E-06_JPRB, &
  & 0.31776136E-06_JPRB, 0.31773808E-06_JPRB, 0.31770702E-06_JPRB, 0.31766621E-06_JPRB, 0.31761212E-06_JPRB, 0.31753993E-06_JPRB, &
  & 0.31744344E-06_JPRB, 0.31731457E-06_JPRB, 0.31714566E-06_JPRB, 0.31692906E-06_JPRB, 0.31667150E-06_JPRB, 0.31638334E-06_JPRB, &
  & 0.31608067E-06_JPRB, 0.31577170E-06_JPRB, 0.31546529E-06_JPRB, 0.31517678E-06_JPRB, 0.31492047E-06_JPRB, 0.31470077E-06_JPRB, &
  & 0.31450588E-06_JPRB, 0.31432532E-06_JPRB, 0.31414527E-06_JPRB, 0.31395911E-06_JPRB, 0.31376740E-06_JPRB, 0.31357723E-06_JPRB, &
  & 0.31339357E-06_JPRB, 0.31321116E-06_JPRB, 0.31300570E-06_JPRB, 0.31265185E-06_JPRB /)

RGHG3(:,45,11) = (/ &
  & 0.31056626E-06_JPRB, 0.31084366E-06_JPRB, 0.31103784E-06_JPRB, 0.31125697E-06_JPRB, 0.31154400E-06_JPRB, 0.31186693E-06_JPRB, &
  & 0.31217490E-06_JPRB, 0.31243943E-06_JPRB, 0.31266561E-06_JPRB, 0.31286237E-06_JPRB, 0.31304069E-06_JPRB, 0.31321633E-06_JPRB, &
  & 0.31341119E-06_JPRB, 0.31365258E-06_JPRB, 0.31398255E-06_JPRB, 0.31444108E-06_JPRB, 0.31500940E-06_JPRB, 0.31560205E-06_JPRB, &
  & 0.31611350E-06_JPRB, 0.31650552E-06_JPRB, 0.31678974E-06_JPRB, 0.31699841E-06_JPRB, 0.31715621E-06_JPRB, 0.31728132E-06_JPRB, &
  & 0.31738327E-06_JPRB, 0.31746902E-06_JPRB, 0.31754274E-06_JPRB, 0.31760720E-06_JPRB, 0.31766322E-06_JPRB, 0.31771083E-06_JPRB, &
  & 0.31774786E-06_JPRB, 0.31777705E-06_JPRB, 0.31779456E-06_JPRB, 0.31780291E-06_JPRB, 0.31780166E-06_JPRB, 0.31779294E-06_JPRB, &
  & 0.31777765E-06_JPRB, 0.31775619E-06_JPRB, 0.31772817E-06_JPRB, 0.31769230E-06_JPRB, 0.31764608E-06_JPRB, 0.31758569E-06_JPRB, &
  & 0.31750639E-06_JPRB, 0.31740225E-06_JPRB, 0.31726498E-06_JPRB, 0.31708817E-06_JPRB, 0.31686773E-06_JPRB, 0.31661602E-06_JPRB, &
  & 0.31634630E-06_JPRB, 0.31606808E-06_JPRB, 0.31579162E-06_JPRB, 0.31553336E-06_JPRB, 0.31530632E-06_JPRB, 0.31511291E-06_JPRB, &
  & 0.31494503E-06_JPRB, 0.31478856E-06_JPRB, 0.31463418E-06_JPRB, 0.31447505E-06_JPRB, 0.31431318E-06_JPRB, 0.31415533E-06_JPRB, &
  & 0.31400498E-06_JPRB, 0.31385579E-06_JPRB, 0.31368728E-06_JPRB, 0.31339320E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART22',0,ZHOOK_HANDLE)



RGHG3(:,46,11) = (/ &
  & 0.31157845E-06_JPRB, 0.31183566E-06_JPRB, 0.31201236E-06_JPRB, 0.31222373E-06_JPRB, 0.31249405E-06_JPRB, 0.31281235E-06_JPRB, &
  & 0.31310091E-06_JPRB, 0.31334389E-06_JPRB, 0.31354443E-06_JPRB, 0.31371155E-06_JPRB, 0.31386031E-06_JPRB, 0.31400410E-06_JPRB, &
  & 0.31416116E-06_JPRB, 0.31435800E-06_JPRB, 0.31463449E-06_JPRB, 0.31502029E-06_JPRB, 0.31551099E-06_JPRB, 0.31599785E-06_JPRB, &
  & 0.31640505E-06_JPRB, 0.31670737E-06_JPRB, 0.31692957E-06_JPRB, 0.31709570E-06_JPRB, 0.31722644E-06_JPRB, 0.31733285E-06_JPRB, &
  & 0.31742286E-06_JPRB, 0.31750079E-06_JPRB, 0.31756963E-06_JPRB, 0.31763091E-06_JPRB, 0.31768468E-06_JPRB, 0.31773016E-06_JPRB, &
  & 0.31776528E-06_JPRB, 0.31779282E-06_JPRB, 0.31780922E-06_JPRB, 0.31781681E-06_JPRB, 0.31781528E-06_JPRB, 0.31780655E-06_JPRB, &
  & 0.31779189E-06_JPRB, 0.31777176E-06_JPRB, 0.31774618E-06_JPRB, 0.31771424E-06_JPRB, 0.31767425E-06_JPRB, 0.31762349E-06_JPRB, &
  & 0.31755826E-06_JPRB, 0.31747456E-06_JPRB, 0.31736610E-06_JPRB, 0.31722428E-06_JPRB, 0.31704414E-06_JPRB, 0.31682944E-06_JPRB, &
  & 0.31659187E-06_JPRB, 0.31634551E-06_JPRB, 0.31610168E-06_JPRB, 0.31587385E-06_JPRB, 0.31567879E-06_JPRB, 0.31551298E-06_JPRB, &
  & 0.31536985E-06_JPRB, 0.31523709E-06_JPRB, 0.31510618E-06_JPRB, 0.31497257E-06_JPRB, 0.31483893E-06_JPRB, 0.31471154E-06_JPRB, &
  & 0.31459172E-06_JPRB, 0.31447439E-06_JPRB, 0.31434053E-06_JPRB, 0.31410738E-06_JPRB /)

RGHG3(:,47,11) = (/ &
  & 0.31251832E-06_JPRB, 0.31275405E-06_JPRB, 0.31292257E-06_JPRB, 0.31311509E-06_JPRB, 0.31338294E-06_JPRB, 0.31368205E-06_JPRB, &
  & 0.31395939E-06_JPRB, 0.31418170E-06_JPRB, 0.31435653E-06_JPRB, 0.31449954E-06_JPRB, 0.31462113E-06_JPRB, 0.31473724E-06_JPRB, &
  & 0.31486331E-06_JPRB, 0.31502259E-06_JPRB, 0.31524468E-06_JPRB, 0.31556863E-06_JPRB, 0.31596008E-06_JPRB, 0.31634289E-06_JPRB, &
  & 0.31664524E-06_JPRB, 0.31687244E-06_JPRB, 0.31704215E-06_JPRB, 0.31717556E-06_JPRB, 0.31728405E-06_JPRB, 0.31737630E-06_JPRB, &
  & 0.31745662E-06_JPRB, 0.31752836E-06_JPRB, 0.31759345E-06_JPRB, 0.31765245E-06_JPRB, 0.31770441E-06_JPRB, 0.31774786E-06_JPRB, &
  & 0.31778137E-06_JPRB, 0.31780729E-06_JPRB, 0.31782264E-06_JPRB, 0.31782946E-06_JPRB, 0.31782753E-06_JPRB, 0.31781872E-06_JPRB, &
  & 0.31780442E-06_JPRB, 0.31778535E-06_JPRB, 0.31776165E-06_JPRB, 0.31773288E-06_JPRB, 0.31769792E-06_JPRB, 0.31765461E-06_JPRB, &
  & 0.31760078E-06_JPRB, 0.31753387E-06_JPRB, 0.31744921E-06_JPRB, 0.31734012E-06_JPRB, 0.31719932E-06_JPRB, 0.31702359E-06_JPRB, &
  & 0.31682291E-06_JPRB, 0.31660841E-06_JPRB, 0.31639482E-06_JPRB, 0.31620226E-06_JPRB, 0.31603463E-06_JPRB, 0.31589769E-06_JPRB, &
  & 0.31577713E-06_JPRB, 0.31566657E-06_JPRB, 0.31555729E-06_JPRB, 0.31544681E-06_JPRB, 0.31533858E-06_JPRB, 0.31523714E-06_JPRB, &
  & 0.31514418E-06_JPRB, 0.31505280E-06_JPRB, 0.31494974E-06_JPRB, 0.31476762E-06_JPRB /)

RGHG3(:,48,11) = (/ &
  & 0.31339314E-06_JPRB, 0.31361549E-06_JPRB, 0.31376840E-06_JPRB, 0.31395467E-06_JPRB, 0.31419918E-06_JPRB, 0.31449406E-06_JPRB, &
  & 0.31475187E-06_JPRB, 0.31495387E-06_JPRB, 0.31510726E-06_JPRB, 0.31522461E-06_JPRB, 0.31532346E-06_JPRB, 0.31541501E-06_JPRB, &
  & 0.31551403E-06_JPRB, 0.31563832E-06_JPRB, 0.31581351E-06_JPRB, 0.31605933E-06_JPRB, 0.31635358E-06_JPRB, 0.31662461E-06_JPRB, &
  & 0.31684002E-06_JPRB, 0.31700364E-06_JPRB, 0.31713344E-06_JPRB, 0.31724028E-06_JPRB, 0.31733211E-06_JPRB, 0.31741308E-06_JPRB, &
  & 0.31748607E-06_JPRB, 0.31755320E-06_JPRB, 0.31761536E-06_JPRB, 0.31767232E-06_JPRB, 0.31772274E-06_JPRB, 0.31776443E-06_JPRB, &
  & 0.31779638E-06_JPRB, 0.31782065E-06_JPRB, 0.31783512E-06_JPRB, 0.31784100E-06_JPRB, 0.31783864E-06_JPRB, 0.31782974E-06_JPRB, &
  & 0.31781565E-06_JPRB, 0.31779734E-06_JPRB, 0.31777515E-06_JPRB, 0.31774886E-06_JPRB, 0.31771773E-06_JPRB, 0.31768053E-06_JPRB, &
  & 0.31763568E-06_JPRB, 0.31758196E-06_JPRB, 0.31751665E-06_JPRB, 0.31743545E-06_JPRB, 0.31733083E-06_JPRB, 0.31719836E-06_JPRB, &
  & 0.31703703E-06_JPRB, 0.31685863E-06_JPRB, 0.31668026E-06_JPRB, 0.31651552E-06_JPRB, 0.31637998E-06_JPRB, 0.31626479E-06_JPRB, &
  & 0.31616665E-06_JPRB, 0.31607448E-06_JPRB, 0.31598412E-06_JPRB, 0.31589354E-06_JPRB, 0.31580601E-06_JPRB, 0.31572620E-06_JPRB, &
  & 0.31565335E-06_JPRB, 0.31558315E-06_JPRB, 0.31550283E-06_JPRB, 0.31536183E-06_JPRB /)

RGHG3(:,49,11) = (/ &
  & 0.31421067E-06_JPRB, 0.31441644E-06_JPRB, 0.31456074E-06_JPRB, 0.31472999E-06_JPRB, 0.31496603E-06_JPRB, 0.31523905E-06_JPRB, &
  & 0.31548379E-06_JPRB, 0.31566435E-06_JPRB, 0.31579259E-06_JPRB, 0.31588783E-06_JPRB, 0.31596329E-06_JPRB, 0.31603207E-06_JPRB, &
  & 0.31610506E-06_JPRB, 0.31619300E-06_JPRB, 0.31631680E-06_JPRB, 0.31647880E-06_JPRB, 0.31667184E-06_JPRB, 0.31684780E-06_JPRB, &
  & 0.31699145E-06_JPRB, 0.31710837E-06_JPRB, 0.31720674E-06_JPRB, 0.31729374E-06_JPRB, 0.31737235E-06_JPRB, 0.31744486E-06_JPRB, &
  & 0.31751244E-06_JPRB, 0.31757600E-06_JPRB, 0.31763594E-06_JPRB, 0.31769116E-06_JPRB, 0.31773990E-06_JPRB, 0.31777992E-06_JPRB, &
  & 0.31781025E-06_JPRB, 0.31783307E-06_JPRB, 0.31784654E-06_JPRB, 0.31785169E-06_JPRB, 0.31784884E-06_JPRB, 0.31783978E-06_JPRB, &
  & 0.31782579E-06_JPRB, 0.31780809E-06_JPRB, 0.31778700E-06_JPRB, 0.31776270E-06_JPRB, 0.31773467E-06_JPRB, 0.31770205E-06_JPRB, &
  & 0.31766416E-06_JPRB, 0.31762050E-06_JPRB, 0.31757028E-06_JPRB, 0.31751082E-06_JPRB, 0.31743804E-06_JPRB, 0.31734504E-06_JPRB, &
  & 0.31722911E-06_JPRB, 0.31709419E-06_JPRB, 0.31695231E-06_JPRB, 0.31682305E-06_JPRB, 0.31671124E-06_JPRB, 0.31661955E-06_JPRB, &
  & 0.31653838E-06_JPRB, 0.31646232E-06_JPRB, 0.31638723E-06_JPRB, 0.31631225E-06_JPRB, 0.31624126E-06_JPRB, 0.31617728E-06_JPRB, &
  & 0.31612021E-06_JPRB, 0.31606493E-06_JPRB, 0.31600175E-06_JPRB, 0.31588988E-06_JPRB /)

RGHG3(:,50,11) = (/ &
  & 0.31496350E-06_JPRB, 0.31515458E-06_JPRB, 0.31528657E-06_JPRB, 0.31544383E-06_JPRB, 0.31566123E-06_JPRB, 0.31591986E-06_JPRB, &
  & 0.31613729E-06_JPRB, 0.31629085E-06_JPRB, 0.31639186E-06_JPRB, 0.31646053E-06_JPRB, 0.31651251E-06_JPRB, 0.31655716E-06_JPRB, &
  & 0.31660113E-06_JPRB, 0.31665448E-06_JPRB, 0.31671800E-06_JPRB, 0.31680972E-06_JPRB, 0.31691241E-06_JPRB, 0.31701677E-06_JPRB, &
  & 0.31710880E-06_JPRB, 0.31719074E-06_JPRB, 0.31726657E-06_JPRB, 0.31733802E-06_JPRB, 0.31740663E-06_JPRB, 0.31747291E-06_JPRB, &
  & 0.31753660E-06_JPRB, 0.31759780E-06_JPRB, 0.31765575E-06_JPRB, 0.31770927E-06_JPRB, 0.31775622E-06_JPRB, 0.31779436E-06_JPRB, &
  & 0.31782332E-06_JPRB, 0.31784461E-06_JPRB, 0.31785720E-06_JPRB, 0.31786158E-06_JPRB, 0.31785831E-06_JPRB, 0.31784893E-06_JPRB, &
  & 0.31783512E-06_JPRB, 0.31781786E-06_JPRB, 0.31779777E-06_JPRB, 0.31777503E-06_JPRB, 0.31774931E-06_JPRB, 0.31772021E-06_JPRB, &
  & 0.31768749E-06_JPRB, 0.31765154E-06_JPRB, 0.31761238E-06_JPRB, 0.31756963E-06_JPRB, 0.31752054E-06_JPRB, 0.31746117E-06_JPRB, &
  & 0.31738756E-06_JPRB, 0.31729911E-06_JPRB, 0.31720353E-06_JPRB, 0.31711016E-06_JPRB, 0.31702928E-06_JPRB, 0.31695797E-06_JPRB, &
  & 0.31689356E-06_JPRB, 0.31683197E-06_JPRB, 0.31676959E-06_JPRB, 0.31670743E-06_JPRB, 0.31664905E-06_JPRB, 0.31659724E-06_JPRB, &
  & 0.31655142E-06_JPRB, 0.31650671E-06_JPRB, 0.31645558E-06_JPRB, 0.31636256E-06_JPRB /)

RGHG3(:,51,11) = (/ &
  & 0.31563968E-06_JPRB, 0.31581084E-06_JPRB, 0.31593095E-06_JPRB, 0.31607345E-06_JPRB, 0.31626843E-06_JPRB, 0.31649199E-06_JPRB, &
  & 0.31667275E-06_JPRB, 0.31678360E-06_JPRB, 0.31684959E-06_JPRB, 0.31689095E-06_JPRB, 0.31691917E-06_JPRB, 0.31694123E-06_JPRB, &
  & 0.31696160E-06_JPRB, 0.31698147E-06_JPRB, 0.31700856E-06_JPRB, 0.31704107E-06_JPRB, 0.31708902E-06_JPRB, 0.31714299E-06_JPRB, &
  & 0.31719969E-06_JPRB, 0.31725742E-06_JPRB, 0.31731585E-06_JPRB, 0.31737565E-06_JPRB, 0.31743684E-06_JPRB, 0.31749812E-06_JPRB, &
  & 0.31755928E-06_JPRB, 0.31761857E-06_JPRB, 0.31767502E-06_JPRB, 0.31772649E-06_JPRB, 0.31777145E-06_JPRB, 0.31780789E-06_JPRB, &
  & 0.31783543E-06_JPRB, 0.31785544E-06_JPRB, 0.31786709E-06_JPRB, 0.31787079E-06_JPRB, 0.31786709E-06_JPRB, 0.31785757E-06_JPRB, &
  & 0.31784376E-06_JPRB, 0.31782687E-06_JPRB, 0.31780755E-06_JPRB, 0.31778603E-06_JPRB, 0.31776216E-06_JPRB, 0.31773567E-06_JPRB, &
  & 0.31770685E-06_JPRB, 0.31767649E-06_JPRB, 0.31764594E-06_JPRB, 0.31761513E-06_JPRB, 0.31758344E-06_JPRB, 0.31754820E-06_JPRB, &
  & 0.31750690E-06_JPRB, 0.31745867E-06_JPRB, 0.31740575E-06_JPRB, 0.31735343E-06_JPRB, 0.31730346E-06_JPRB, 0.31725773E-06_JPRB, &
  & 0.31721351E-06_JPRB, 0.31716760E-06_JPRB, 0.31712011E-06_JPRB, 0.31707131E-06_JPRB, 0.31702490E-06_JPRB, 0.31698403E-06_JPRB, &
  & 0.31694734E-06_JPRB, 0.31691158E-06_JPRB, 0.31686832E-06_JPRB, 0.31679016E-06_JPRB /)

RGHG3(:,52,11) = (/ &
  & 0.31621062E-06_JPRB, 0.31636282E-06_JPRB, 0.31646437E-06_JPRB, 0.31658448E-06_JPRB, 0.31674580E-06_JPRB, 0.31692025E-06_JPRB, &
  & 0.31703934E-06_JPRB, 0.31710624E-06_JPRB, 0.31714120E-06_JPRB, 0.31716075E-06_JPRB, 0.31717286E-06_JPRB, 0.31718093E-06_JPRB, &
  & 0.31718653E-06_JPRB, 0.31719114E-06_JPRB, 0.31719463E-06_JPRB, 0.31720128E-06_JPRB, 0.31721453E-06_JPRB, 0.31723886E-06_JPRB, &
  & 0.31727194E-06_JPRB, 0.31731196E-06_JPRB, 0.31735800E-06_JPRB, 0.31740893E-06_JPRB, 0.31746376E-06_JPRB, 0.31752191E-06_JPRB, &
  & 0.31758057E-06_JPRB, 0.31763864E-06_JPRB, 0.31769306E-06_JPRB, 0.31774289E-06_JPRB, 0.31778566E-06_JPRB, 0.31782042E-06_JPRB, &
  & 0.31784674E-06_JPRB, 0.31786567E-06_JPRB, 0.31787638E-06_JPRB, 0.31787943E-06_JPRB, 0.31787528E-06_JPRB, 0.31786561E-06_JPRB, &
  & 0.31785186E-06_JPRB, 0.31783532E-06_JPRB, 0.31781667E-06_JPRB, 0.31779612E-06_JPRB, 0.31777358E-06_JPRB, 0.31774908E-06_JPRB, &
  & 0.31772311E-06_JPRB, 0.31769736E-06_JPRB, 0.31767303E-06_JPRB, 0.31765140E-06_JPRB, 0.31763145E-06_JPRB, 0.31761206E-06_JPRB, &
  & 0.31759146E-06_JPRB, 0.31756898E-06_JPRB, 0.31754513E-06_JPRB, 0.31752091E-06_JPRB, 0.31749767E-06_JPRB, 0.31747419E-06_JPRB, &
  & 0.31744935E-06_JPRB, 0.31742252E-06_JPRB, 0.31739171E-06_JPRB, 0.31735894E-06_JPRB, 0.31732731E-06_JPRB, 0.31729894E-06_JPRB, &
  & 0.31727345E-06_JPRB, 0.31724721E-06_JPRB, 0.31721538E-06_JPRB, 0.31715106E-06_JPRB /)

RGHG3(:,53,11) = (/ &
  & 0.31666272E-06_JPRB, 0.31678175E-06_JPRB, 0.31686554E-06_JPRB, 0.31695731E-06_JPRB, 0.31707467E-06_JPRB, 0.31718733E-06_JPRB, &
  & 0.31725870E-06_JPRB, 0.31729215E-06_JPRB, 0.31730838E-06_JPRB, 0.31731659E-06_JPRB, 0.31732074E-06_JPRB, 0.31732259E-06_JPRB, &
  & 0.31732253E-06_JPRB, 0.31732066E-06_JPRB, 0.31731602E-06_JPRB, 0.31731051E-06_JPRB, 0.31730741E-06_JPRB, 0.31731344E-06_JPRB, &
  & 0.31733072E-06_JPRB, 0.31735860E-06_JPRB, 0.31739492E-06_JPRB, 0.31743878E-06_JPRB, 0.31748951E-06_JPRB, 0.31754408E-06_JPRB, &
  & 0.31760149E-06_JPRB, 0.31765745E-06_JPRB, 0.31771054E-06_JPRB, 0.31775784E-06_JPRB, 0.31779905E-06_JPRB, 0.31783216E-06_JPRB, &
  & 0.31785748E-06_JPRB, 0.31787528E-06_JPRB, 0.31788511E-06_JPRB, 0.31788755E-06_JPRB, 0.31788298E-06_JPRB, 0.31787320E-06_JPRB, &
  & 0.31785953E-06_JPRB, 0.31784327E-06_JPRB, 0.31782520E-06_JPRB, 0.31780550E-06_JPRB, 0.31778416E-06_JPRB, 0.31776102E-06_JPRB, &
  & 0.31773749E-06_JPRB, 0.31771498E-06_JPRB, 0.31769599E-06_JPRB, 0.31768064E-06_JPRB, 0.31766893E-06_JPRB, 0.31765910E-06_JPRB, &
  & 0.31764989E-06_JPRB, 0.31764051E-06_JPRB, 0.31763088E-06_JPRB, 0.31762107E-06_JPRB, 0.31761095E-06_JPRB, 0.31760030E-06_JPRB, &
  & 0.31758842E-06_JPRB, 0.31757378E-06_JPRB, 0.31755690E-06_JPRB, 0.31753802E-06_JPRB, 0.31751961E-06_JPRB, 0.31750329E-06_JPRB, &
  & 0.31748866E-06_JPRB, 0.31747385E-06_JPRB, 0.31745489E-06_JPRB, 0.31741496E-06_JPRB /)

RGHG3(:,54,11) = (/ &
  & 0.31698400E-06_JPRB, 0.31707918E-06_JPRB, 0.31713688E-06_JPRB, 0.31720143E-06_JPRB, 0.31727805E-06_JPRB, 0.31734734E-06_JPRB, &
  & 0.31738392E-06_JPRB, 0.31740052E-06_JPRB, 0.31740748E-06_JPRB, 0.31741050E-06_JPRB, 0.31741146E-06_JPRB, 0.31741104E-06_JPRB, &
  & 0.31740933E-06_JPRB, 0.31740552E-06_JPRB, 0.31739947E-06_JPRB, 0.31738884E-06_JPRB, 0.31737846E-06_JPRB, 0.31737372E-06_JPRB, &
  & 0.31738060E-06_JPRB, 0.31739916E-06_JPRB, 0.31742860E-06_JPRB, 0.31746720E-06_JPRB, 0.31751347E-06_JPRB, 0.31756628E-06_JPRB, &
  & 0.31762093E-06_JPRB, 0.31767576E-06_JPRB, 0.31772629E-06_JPRB, 0.31777230E-06_JPRB, 0.31781144E-06_JPRB, 0.31784330E-06_JPRB, &
  & 0.31786743E-06_JPRB, 0.31788420E-06_JPRB, 0.31789327E-06_JPRB, 0.31789517E-06_JPRB, 0.31789028E-06_JPRB, 0.31788042E-06_JPRB, &
  & 0.31786686E-06_JPRB, 0.31785089E-06_JPRB, 0.31783338E-06_JPRB, 0.31781434E-06_JPRB, 0.31779376E-06_JPRB, 0.31777211E-06_JPRB, &
  & 0.31775028E-06_JPRB, 0.31773112E-06_JPRB, 0.31771572E-06_JPRB, 0.31770543E-06_JPRB, 0.31769886E-06_JPRB, 0.31769460E-06_JPRB, &
  & 0.31769122E-06_JPRB, 0.31768792E-06_JPRB, 0.31768428E-06_JPRB, 0.31768025E-06_JPRB, 0.31767587E-06_JPRB, 0.31767081E-06_JPRB, &
  & 0.31766461E-06_JPRB, 0.31765717E-06_JPRB, 0.31764768E-06_JPRB, 0.31763722E-06_JPRB, 0.31762701E-06_JPRB, 0.31761846E-06_JPRB, &
  & 0.31761112E-06_JPRB, 0.31760459E-06_JPRB, 0.31759816E-06_JPRB, 0.31758955E-06_JPRB /)

RGHG3(:,55,11) = (/ &
  & 0.31720589E-06_JPRB, 0.31727114E-06_JPRB, 0.31731383E-06_JPRB, 0.31735550E-06_JPRB, 0.31740387E-06_JPRB, 0.31744290E-06_JPRB, &
  & 0.31746248E-06_JPRB, 0.31746984E-06_JPRB, 0.31747260E-06_JPRB, 0.31747334E-06_JPRB, 0.31747308E-06_JPRB, 0.31747203E-06_JPRB, &
  & 0.31746993E-06_JPRB, 0.31746643E-06_JPRB, 0.31745964E-06_JPRB, 0.31744977E-06_JPRB, 0.31743517E-06_JPRB, 0.31742422E-06_JPRB, &
  & 0.31742383E-06_JPRB, 0.31743596E-06_JPRB, 0.31745986E-06_JPRB, 0.31749420E-06_JPRB, 0.31753765E-06_JPRB, 0.31758697E-06_JPRB, &
  & 0.31764014E-06_JPRB, 0.31769230E-06_JPRB, 0.31774169E-06_JPRB, 0.31778552E-06_JPRB, 0.31782338E-06_JPRB, 0.31785379E-06_JPRB, &
  & 0.31787675E-06_JPRB, 0.31789256E-06_JPRB, 0.31790091E-06_JPRB, 0.31790239E-06_JPRB, 0.31789727E-06_JPRB, 0.31788730E-06_JPRB, &
  & 0.31787391E-06_JPRB, 0.31785834E-06_JPRB, 0.31784111E-06_JPRB, 0.31782264E-06_JPRB, 0.31780311E-06_JPRB, 0.31778239E-06_JPRB, &
  & 0.31776273E-06_JPRB, 0.31774559E-06_JPRB, 0.31773376E-06_JPRB, 0.31772669E-06_JPRB, 0.31772356E-06_JPRB, 0.31772245E-06_JPRB, &
  & 0.31772200E-06_JPRB, 0.31772129E-06_JPRB, 0.31772018E-06_JPRB, 0.31771856E-06_JPRB, 0.31771643E-06_JPRB, 0.31771381E-06_JPRB, &
  & 0.31771054E-06_JPRB, 0.31770611E-06_JPRB, 0.31770065E-06_JPRB, 0.31769429E-06_JPRB, 0.31768823E-06_JPRB, 0.31768292E-06_JPRB, &
  & 0.31767854E-06_JPRB, 0.31767433E-06_JPRB, 0.31766947E-06_JPRB, 0.31766064E-06_JPRB /)

RGHG3(:,56,11) = (/ &
  & 0.31735385E-06_JPRB, 0.31740143E-06_JPRB, 0.31742826E-06_JPRB, 0.31745492E-06_JPRB, 0.31748451E-06_JPRB, 0.31750685E-06_JPRB, &
  & 0.31751620E-06_JPRB, 0.31751938E-06_JPRB, 0.31752012E-06_JPRB, 0.31751998E-06_JPRB, 0.31751932E-06_JPRB, 0.31751821E-06_JPRB, &
  & 0.31751637E-06_JPRB, 0.31751318E-06_JPRB, 0.31750798E-06_JPRB, 0.31749769E-06_JPRB, 0.31748334E-06_JPRB, 0.31746833E-06_JPRB, &
  & 0.31746268E-06_JPRB, 0.31747004E-06_JPRB, 0.31748991E-06_JPRB, 0.31752077E-06_JPRB, 0.31756090E-06_JPRB, 0.31760783E-06_JPRB, &
  & 0.31765816E-06_JPRB, 0.31770873E-06_JPRB, 0.31775591E-06_JPRB, 0.31779851E-06_JPRB, 0.31783466E-06_JPRB, 0.31786377E-06_JPRB, &
  & 0.31788556E-06_JPRB, 0.31790051E-06_JPRB, 0.31790816E-06_JPRB, 0.31790933E-06_JPRB, 0.31790401E-06_JPRB, 0.31789412E-06_JPRB, &
  & 0.31788085E-06_JPRB, 0.31786544E-06_JPRB, 0.31784873E-06_JPRB, 0.31783080E-06_JPRB, 0.31781190E-06_JPRB, 0.31779271E-06_JPRB, &
  & 0.31777435E-06_JPRB, 0.31775971E-06_JPRB, 0.31775005E-06_JPRB, 0.31774562E-06_JPRB, 0.31774468E-06_JPRB, 0.31774542E-06_JPRB, &
  & 0.31774636E-06_JPRB, 0.31774687E-06_JPRB, 0.31774672E-06_JPRB, 0.31774601E-06_JPRB, 0.31774493E-06_JPRB, 0.31774331E-06_JPRB, &
  & 0.31774124E-06_JPRB, 0.31773857E-06_JPRB, 0.31773499E-06_JPRB, 0.31773095E-06_JPRB, 0.31772700E-06_JPRB, 0.31772379E-06_JPRB, &
  & 0.31772089E-06_JPRB, 0.31771827E-06_JPRB, 0.31771540E-06_JPRB, 0.31771080E-06_JPRB /)

RGHG3(:,57,11) = (/ &
  & 0.31745267E-06_JPRB, 0.31748766E-06_JPRB, 0.31750622E-06_JPRB, 0.31752342E-06_JPRB, 0.31754072E-06_JPRB, 0.31755280E-06_JPRB, &
  & 0.31755735E-06_JPRB, 0.31755837E-06_JPRB, 0.31755832E-06_JPRB, 0.31755786E-06_JPRB, 0.31755715E-06_JPRB, 0.31755616E-06_JPRB, &
  & 0.31755462E-06_JPRB, 0.31755212E-06_JPRB, 0.31754735E-06_JPRB, 0.31753916E-06_JPRB, 0.31752427E-06_JPRB, 0.31750761E-06_JPRB, &
  & 0.31749855E-06_JPRB, 0.31750244E-06_JPRB, 0.31751895E-06_JPRB, 0.31754686E-06_JPRB, 0.31758415E-06_JPRB, 0.31762812E-06_JPRB, &
  & 0.31767610E-06_JPRB, 0.31772439E-06_JPRB, 0.31777009E-06_JPRB, 0.31781087E-06_JPRB, 0.31784552E-06_JPRB, 0.31787332E-06_JPRB, &
  & 0.31789381E-06_JPRB, 0.31790802E-06_JPRB, 0.31791504E-06_JPRB, 0.31791595E-06_JPRB, 0.31791063E-06_JPRB, 0.31790086E-06_JPRB, &
  & 0.31788773E-06_JPRB, 0.31787269E-06_JPRB, 0.31785626E-06_JPRB, 0.31783873E-06_JPRB, 0.31782071E-06_JPRB, 0.31780243E-06_JPRB, &
  & 0.31778598E-06_JPRB, 0.31777302E-06_JPRB, 0.31776551E-06_JPRB, 0.31776275E-06_JPRB, 0.31776332E-06_JPRB, 0.31776514E-06_JPRB, &
  & 0.31776679E-06_JPRB, 0.31776781E-06_JPRB, 0.31776801E-06_JPRB, 0.31776761E-06_JPRB, 0.31776688E-06_JPRB, 0.31776580E-06_JPRB, &
  & 0.31776437E-06_JPRB, 0.31776244E-06_JPRB, 0.31776000E-06_JPRB, 0.31775713E-06_JPRB, 0.31775440E-06_JPRB, 0.31775195E-06_JPRB, &
  & 0.31774991E-06_JPRB, 0.31774789E-06_JPRB, 0.31774553E-06_JPRB, 0.31774121E-06_JPRB /)

RGHG3(:,58,11) = (/ &
  & 0.31753646E-06_JPRB, 0.31755303E-06_JPRB, 0.31756326E-06_JPRB, 0.31757270E-06_JPRB, 0.31758304E-06_JPRB, 0.31758930E-06_JPRB, &
  & 0.31759112E-06_JPRB, 0.31759132E-06_JPRB, 0.31759103E-06_JPRB, 0.31759058E-06_JPRB, 0.31759001E-06_JPRB, 0.31758924E-06_JPRB, &
  & 0.31758802E-06_JPRB, 0.31758591E-06_JPRB, 0.31758213E-06_JPRB, 0.31757438E-06_JPRB, 0.31756105E-06_JPRB, 0.31754334E-06_JPRB, &
  & 0.31753214E-06_JPRB, 0.31753351E-06_JPRB, 0.31754746E-06_JPRB, 0.31757261E-06_JPRB, 0.31760709E-06_JPRB, 0.31764836E-06_JPRB, &
  & 0.31769386E-06_JPRB, 0.31773999E-06_JPRB, 0.31778376E-06_JPRB, 0.31782281E-06_JPRB, 0.31785586E-06_JPRB, 0.31788232E-06_JPRB, &
  & 0.31790174E-06_JPRB, 0.31791524E-06_JPRB, 0.31792175E-06_JPRB, 0.31792251E-06_JPRB, 0.31791726E-06_JPRB, 0.31790759E-06_JPRB, &
  & 0.31789477E-06_JPRB, 0.31788005E-06_JPRB, 0.31786391E-06_JPRB, 0.31784691E-06_JPRB, 0.31782955E-06_JPRB, 0.31781258E-06_JPRB, &
  & 0.31779732E-06_JPRB, 0.31778617E-06_JPRB, 0.31778012E-06_JPRB, 0.31777859E-06_JPRB, 0.31778018E-06_JPRB, 0.31778271E-06_JPRB, &
  & 0.31778475E-06_JPRB, 0.31778578E-06_JPRB, 0.31778603E-06_JPRB, 0.31778566E-06_JPRB, 0.31778501E-06_JPRB, 0.31778416E-06_JPRB, &
  & 0.31778302E-06_JPRB, 0.31778157E-06_JPRB, 0.31777961E-06_JPRB, 0.31777734E-06_JPRB, 0.31777509E-06_JPRB, 0.31777324E-06_JPRB, &
  & 0.31777154E-06_JPRB, 0.31776997E-06_JPRB, 0.31776810E-06_JPRB, 0.31776477E-06_JPRB /)

RGHG3(:,59,11) = (/ &
  & 0.31758532E-06_JPRB, 0.31759870E-06_JPRB, 0.31760527E-06_JPRB, 0.31761147E-06_JPRB, 0.31761687E-06_JPRB, 0.31762005E-06_JPRB, &
  & 0.31762073E-06_JPRB, 0.31762062E-06_JPRB, 0.31762028E-06_JPRB, 0.31761991E-06_JPRB, 0.31761945E-06_JPRB, 0.31761886E-06_JPRB, &
  & 0.31761789E-06_JPRB, 0.31761618E-06_JPRB, 0.31761294E-06_JPRB, 0.31760641E-06_JPRB, 0.31759350E-06_JPRB, 0.31757625E-06_JPRB, &
  & 0.31756409E-06_JPRB, 0.31756377E-06_JPRB, 0.31757546E-06_JPRB, 0.31759822E-06_JPRB, 0.31763000E-06_JPRB, 0.31766876E-06_JPRB, &
  & 0.31771165E-06_JPRB, 0.31775559E-06_JPRB, 0.31779726E-06_JPRB, 0.31783452E-06_JPRB, 0.31786593E-06_JPRB, 0.31789094E-06_JPRB, &
  & 0.31790952E-06_JPRB, 0.31792226E-06_JPRB, 0.31792825E-06_JPRB, 0.31792885E-06_JPRB, 0.31792374E-06_JPRB, 0.31791444E-06_JPRB, &
  & 0.31790196E-06_JPRB, 0.31788750E-06_JPRB, 0.31787172E-06_JPRB, 0.31785527E-06_JPRB, 0.31783856E-06_JPRB, 0.31782247E-06_JPRB, &
  & 0.31780871E-06_JPRB, 0.31779888E-06_JPRB, 0.31779408E-06_JPRB, 0.31779354E-06_JPRB, 0.31779581E-06_JPRB, 0.31779877E-06_JPRB, &
  & 0.31780090E-06_JPRB, 0.31780189E-06_JPRB, 0.31780192E-06_JPRB, 0.31780144E-06_JPRB, 0.31780073E-06_JPRB, 0.31779985E-06_JPRB, &
  & 0.31779882E-06_JPRB, 0.31779746E-06_JPRB, 0.31779575E-06_JPRB, 0.31779379E-06_JPRB, 0.31779194E-06_JPRB, 0.31779032E-06_JPRB, &
  & 0.31778893E-06_JPRB, 0.31778745E-06_JPRB, 0.31778575E-06_JPRB, 0.31778251E-06_JPRB /)

RGHG3(:,60,11) = (/ &
  & 0.31762741E-06_JPRB, 0.31763534E-06_JPRB, 0.31763955E-06_JPRB, 0.31764279E-06_JPRB, 0.31764591E-06_JPRB, 0.31764728E-06_JPRB, &
  & 0.31764736E-06_JPRB, 0.31764716E-06_JPRB, 0.31764702E-06_JPRB, 0.31764688E-06_JPRB, 0.31764674E-06_JPRB, 0.31764642E-06_JPRB, &
  & 0.31764586E-06_JPRB, 0.31764466E-06_JPRB, 0.31764193E-06_JPRB, 0.31763594E-06_JPRB, 0.31762360E-06_JPRB, 0.31760686E-06_JPRB, &
  & 0.31759473E-06_JPRB, 0.31759333E-06_JPRB, 0.31760325E-06_JPRB, 0.31762374E-06_JPRB, 0.31765319E-06_JPRB, 0.31768928E-06_JPRB, &
  & 0.31772967E-06_JPRB, 0.31777125E-06_JPRB, 0.31781079E-06_JPRB, 0.31784612E-06_JPRB, 0.31787579E-06_JPRB, 0.31789955E-06_JPRB, &
  & 0.31791691E-06_JPRB, 0.31792899E-06_JPRB, 0.31793465E-06_JPRB, 0.31793522E-06_JPRB, 0.31793024E-06_JPRB, 0.31792126E-06_JPRB, &
  & 0.31790921E-06_JPRB, 0.31789511E-06_JPRB, 0.31787977E-06_JPRB, 0.31786377E-06_JPRB, 0.31784768E-06_JPRB, 0.31783256E-06_JPRB, &
  & 0.31781983E-06_JPRB, 0.31781133E-06_JPRB, 0.31780752E-06_JPRB, 0.31780769E-06_JPRB, 0.31781047E-06_JPRB, 0.31781366E-06_JPRB, &
  & 0.31781593E-06_JPRB, 0.31781673E-06_JPRB, 0.31781656E-06_JPRB, 0.31781593E-06_JPRB, 0.31781514E-06_JPRB, 0.31781417E-06_JPRB, &
  & 0.31781303E-06_JPRB, 0.31781167E-06_JPRB, 0.31781002E-06_JPRB, 0.31780820E-06_JPRB, 0.31780644E-06_JPRB, 0.31780493E-06_JPRB, &
  & 0.31780348E-06_JPRB, 0.31780218E-06_JPRB, 0.31780053E-06_JPRB, 0.31779763E-06_JPRB /)

RGHG3(:,61,11) = (/ &
  & 0.31765825E-06_JPRB, 0.31766527E-06_JPRB, 0.31766811E-06_JPRB, 0.31767024E-06_JPRB, 0.31767166E-06_JPRB, 0.31767217E-06_JPRB, &
  & 0.31767200E-06_JPRB, 0.31767186E-06_JPRB, 0.31767189E-06_JPRB, 0.31767200E-06_JPRB, 0.31767220E-06_JPRB, 0.31767226E-06_JPRB, &
  & 0.31767206E-06_JPRB, 0.31767118E-06_JPRB, 0.31766893E-06_JPRB, 0.31766308E-06_JPRB, 0.31765140E-06_JPRB, 0.31763599E-06_JPRB, &
  & 0.31762434E-06_JPRB, 0.31762229E-06_JPRB, 0.31763074E-06_JPRB, 0.31764932E-06_JPRB, 0.31767658E-06_JPRB, 0.31771017E-06_JPRB, &
  & 0.31774798E-06_JPRB, 0.31778708E-06_JPRB, 0.31782437E-06_JPRB, 0.31785763E-06_JPRB, 0.31788559E-06_JPRB, 0.31790782E-06_JPRB, &
  & 0.31792436E-06_JPRB, 0.31793559E-06_JPRB, 0.31794099E-06_JPRB, 0.31794150E-06_JPRB, 0.31793672E-06_JPRB, 0.31792811E-06_JPRB, &
  & 0.31791649E-06_JPRB, 0.31790276E-06_JPRB, 0.31788787E-06_JPRB, 0.31787235E-06_JPRB, 0.31785694E-06_JPRB, 0.31784259E-06_JPRB, &
  & 0.31783100E-06_JPRB, 0.31782361E-06_JPRB, 0.31782071E-06_JPRB, 0.31782133E-06_JPRB, 0.31782440E-06_JPRB, 0.31782781E-06_JPRB, &
  & 0.31782997E-06_JPRB, 0.31783065E-06_JPRB, 0.31783026E-06_JPRB, 0.31782940E-06_JPRB, 0.31782838E-06_JPRB, 0.31782730E-06_JPRB, &
  & 0.31782602E-06_JPRB, 0.31782452E-06_JPRB, 0.31782278E-06_JPRB, 0.31782093E-06_JPRB, 0.31781920E-06_JPRB, 0.31781764E-06_JPRB, &
  & 0.31781633E-06_JPRB, 0.31781497E-06_JPRB, 0.31781335E-06_JPRB, 0.31781033E-06_JPRB /)

RGHG3(:,62,11) = (/ &
  & 0.31768676E-06_JPRB, 0.31769170E-06_JPRB, 0.31769372E-06_JPRB, 0.31769480E-06_JPRB, 0.31769548E-06_JPRB, 0.31769542E-06_JPRB, &
  & 0.31769514E-06_JPRB, 0.31769514E-06_JPRB, 0.31769542E-06_JPRB, 0.31769588E-06_JPRB, 0.31769648E-06_JPRB, 0.31769713E-06_JPRB, &
  & 0.31769756E-06_JPRB, 0.31769736E-06_JPRB, 0.31769548E-06_JPRB, 0.31768991E-06_JPRB, 0.31767860E-06_JPRB, 0.31766405E-06_JPRB, &
  & 0.31765333E-06_JPRB, 0.31765092E-06_JPRB, 0.31765816E-06_JPRB, 0.31767505E-06_JPRB, 0.31770017E-06_JPRB, 0.31773132E-06_JPRB, &
  & 0.31776653E-06_JPRB, 0.31780311E-06_JPRB, 0.31783807E-06_JPRB, 0.31786914E-06_JPRB, 0.31789529E-06_JPRB, 0.31791609E-06_JPRB, &
  & 0.31793152E-06_JPRB, 0.31794201E-06_JPRB, 0.31794718E-06_JPRB, 0.31794764E-06_JPRB, 0.31794318E-06_JPRB, 0.31793488E-06_JPRB, &
  & 0.31792379E-06_JPRB, 0.31791049E-06_JPRB, 0.31789608E-06_JPRB, 0.31788105E-06_JPRB, 0.31786627E-06_JPRB, 0.31785282E-06_JPRB, &
  & 0.31784222E-06_JPRB, 0.31783577E-06_JPRB, 0.31783352E-06_JPRB, 0.31783458E-06_JPRB, 0.31783784E-06_JPRB, 0.31784128E-06_JPRB, &
  & 0.31784356E-06_JPRB, 0.31784410E-06_JPRB, 0.31784342E-06_JPRB, 0.31784219E-06_JPRB, 0.31784089E-06_JPRB, 0.31783946E-06_JPRB, &
  & 0.31783799E-06_JPRB, 0.31783634E-06_JPRB, 0.31783446E-06_JPRB, 0.31783253E-06_JPRB, 0.31783065E-06_JPRB, 0.31782912E-06_JPRB, &
  & 0.31782770E-06_JPRB, 0.31782628E-06_JPRB, 0.31782457E-06_JPRB, 0.31782147E-06_JPRB /)

RGHG3(:,63,11) = (/ &
  & 0.31771111E-06_JPRB, 0.31771566E-06_JPRB, 0.31771714E-06_JPRB, 0.31771776E-06_JPRB, 0.31771793E-06_JPRB, 0.31771751E-06_JPRB, &
  & 0.31771717E-06_JPRB, 0.31771719E-06_JPRB, 0.31771771E-06_JPRB, 0.31771856E-06_JPRB, 0.31771981E-06_JPRB, 0.31772115E-06_JPRB, &
  & 0.31772231E-06_JPRB, 0.31772274E-06_JPRB, 0.31772106E-06_JPRB, 0.31771529E-06_JPRB, 0.31770438E-06_JPRB, 0.31769159E-06_JPRB, &
  & 0.31768181E-06_JPRB, 0.31767917E-06_JPRB, 0.31768559E-06_JPRB, 0.31770091E-06_JPRB, 0.31772393E-06_JPRB, 0.31775275E-06_JPRB, &
  & 0.31778549E-06_JPRB, 0.31781954E-06_JPRB, 0.31785197E-06_JPRB, 0.31788079E-06_JPRB, 0.31790501E-06_JPRB, 0.31792433E-06_JPRB, &
  & 0.31793869E-06_JPRB, 0.31794841E-06_JPRB, 0.31795329E-06_JPRB, 0.31795366E-06_JPRB, 0.31794946E-06_JPRB, 0.31794164E-06_JPRB, &
  & 0.31793104E-06_JPRB, 0.31791825E-06_JPRB, 0.31790435E-06_JPRB, 0.31788986E-06_JPRB, 0.31787584E-06_JPRB, 0.31786320E-06_JPRB, &
  & 0.31785351E-06_JPRB, 0.31784779E-06_JPRB, 0.31784617E-06_JPRB, 0.31784754E-06_JPRB, 0.31785083E-06_JPRB, 0.31785427E-06_JPRB, &
  & 0.31785663E-06_JPRB, 0.31785711E-06_JPRB, 0.31785623E-06_JPRB, 0.31785476E-06_JPRB, 0.31785305E-06_JPRB, 0.31785135E-06_JPRB, &
  & 0.31784953E-06_JPRB, 0.31784748E-06_JPRB, 0.31784535E-06_JPRB, 0.31784322E-06_JPRB, 0.31784134E-06_JPRB, 0.31783964E-06_JPRB, &
  & 0.31783807E-06_JPRB, 0.31783642E-06_JPRB, 0.31783452E-06_JPRB, 0.31783111E-06_JPRB /)

RGHG3(:,64,11) = (/ &
  & 0.31773359E-06_JPRB, 0.31773777E-06_JPRB, 0.31773905E-06_JPRB, 0.31773945E-06_JPRB, 0.31773939E-06_JPRB, 0.31773880E-06_JPRB, &
  & 0.31773834E-06_JPRB, 0.31773834E-06_JPRB, 0.31773894E-06_JPRB, 0.31774022E-06_JPRB, 0.31774209E-06_JPRB, 0.31774442E-06_JPRB, &
  & 0.31774650E-06_JPRB, 0.31774758E-06_JPRB, 0.31774616E-06_JPRB, 0.31774056E-06_JPRB, 0.31773055E-06_JPRB, 0.31771856E-06_JPRB, &
  & 0.31770958E-06_JPRB, 0.31770711E-06_JPRB, 0.31771282E-06_JPRB, 0.31772683E-06_JPRB, 0.31774786E-06_JPRB, 0.31777435E-06_JPRB, &
  & 0.31780453E-06_JPRB, 0.31783591E-06_JPRB, 0.31786590E-06_JPRB, 0.31789244E-06_JPRB, 0.31791473E-06_JPRB, 0.31793243E-06_JPRB, &
  & 0.31794571E-06_JPRB, 0.31795463E-06_JPRB, 0.31795912E-06_JPRB, 0.31795943E-06_JPRB, 0.31795560E-06_JPRB, 0.31794826E-06_JPRB, &
  & 0.31793820E-06_JPRB, 0.31792595E-06_JPRB, 0.31791259E-06_JPRB, 0.31789872E-06_JPRB, 0.31788537E-06_JPRB, 0.31787346E-06_JPRB, &
  & 0.31786459E-06_JPRB, 0.31785962E-06_JPRB, 0.31785851E-06_JPRB, 0.31786007E-06_JPRB, 0.31786345E-06_JPRB, 0.31786681E-06_JPRB, &
  & 0.31786917E-06_JPRB, 0.31786968E-06_JPRB, 0.31786871E-06_JPRB, 0.31786692E-06_JPRB, 0.31786493E-06_JPRB, 0.31786277E-06_JPRB, &
  & 0.31786058E-06_JPRB, 0.31785822E-06_JPRB, 0.31785578E-06_JPRB, 0.31785339E-06_JPRB, 0.31785117E-06_JPRB, 0.31784936E-06_JPRB, &
  & 0.31784762E-06_JPRB, 0.31784589E-06_JPRB, 0.31784364E-06_JPRB, 0.31783964E-06_JPRB /)

RGHG3(:,65,11) = (/ &
  & 0.31775437E-06_JPRB, 0.31775861E-06_JPRB, 0.31775983E-06_JPRB, 0.31776025E-06_JPRB, 0.31776011E-06_JPRB, 0.31775943E-06_JPRB, &
  & 0.31775889E-06_JPRB, 0.31775886E-06_JPRB, 0.31775963E-06_JPRB, 0.31776139E-06_JPRB, 0.31776395E-06_JPRB, 0.31776707E-06_JPRB, &
  & 0.31776997E-06_JPRB, 0.31777145E-06_JPRB, 0.31776995E-06_JPRB, 0.31776460E-06_JPRB, 0.31775548E-06_JPRB, 0.31774499E-06_JPRB, &
  & 0.31773689E-06_JPRB, 0.31773450E-06_JPRB, 0.31773976E-06_JPRB, 0.31775244E-06_JPRB, 0.31777159E-06_JPRB, 0.31779587E-06_JPRB, &
  & 0.31782349E-06_JPRB, 0.31785223E-06_JPRB, 0.31787960E-06_JPRB, 0.31790387E-06_JPRB, 0.31792416E-06_JPRB, 0.31794031E-06_JPRB, &
  & 0.31795236E-06_JPRB, 0.31796037E-06_JPRB, 0.31796452E-06_JPRB, 0.31796486E-06_JPRB, 0.31796131E-06_JPRB, 0.31795449E-06_JPRB, &
  & 0.31794505E-06_JPRB, 0.31793348E-06_JPRB, 0.31792078E-06_JPRB, 0.31790759E-06_JPRB, 0.31789497E-06_JPRB, 0.31788386E-06_JPRB, &
  & 0.31787579E-06_JPRB, 0.31787133E-06_JPRB, 0.31787053E-06_JPRB, 0.31787232E-06_JPRB, 0.31787565E-06_JPRB, 0.31787886E-06_JPRB, &
  & 0.31788122E-06_JPRB, 0.31788184E-06_JPRB, 0.31788090E-06_JPRB, 0.31787897E-06_JPRB, 0.31787664E-06_JPRB, 0.31787411E-06_JPRB, &
  & 0.31787141E-06_JPRB, 0.31786865E-06_JPRB, 0.31786584E-06_JPRB, 0.31786317E-06_JPRB, 0.31786081E-06_JPRB, 0.31785865E-06_JPRB, &
  & 0.31785669E-06_JPRB, 0.31785453E-06_JPRB, 0.31785183E-06_JPRB, 0.31784683E-06_JPRB /)

RGHG3(:,66,11) = (/ &
  & 0.31777302E-06_JPRB, 0.31777799E-06_JPRB, 0.31777955E-06_JPRB, 0.31778015E-06_JPRB, 0.31778006E-06_JPRB, 0.31777952E-06_JPRB, &
  & 0.31777898E-06_JPRB, 0.31777901E-06_JPRB, 0.31778001E-06_JPRB, 0.31778220E-06_JPRB, 0.31778546E-06_JPRB, 0.31778919E-06_JPRB, &
  & 0.31779257E-06_JPRB, 0.31779436E-06_JPRB, 0.31779297E-06_JPRB, 0.31778828E-06_JPRB, 0.31778015E-06_JPRB, 0.31777051E-06_JPRB, &
  & 0.31776329E-06_JPRB, 0.31776131E-06_JPRB, 0.31776614E-06_JPRB, 0.31777773E-06_JPRB, 0.31779507E-06_JPRB, 0.31781701E-06_JPRB, &
  & 0.31784205E-06_JPRB, 0.31786809E-06_JPRB, 0.31789290E-06_JPRB, 0.31791478E-06_JPRB, 0.31793306E-06_JPRB, 0.31794769E-06_JPRB, &
  & 0.31795855E-06_JPRB, 0.31796571E-06_JPRB, 0.31796941E-06_JPRB, 0.31796981E-06_JPRB, 0.31796657E-06_JPRB, 0.31796026E-06_JPRB, &
  & 0.31795145E-06_JPRB, 0.31794065E-06_JPRB, 0.31792877E-06_JPRB, 0.31791635E-06_JPRB, 0.31790458E-06_JPRB, 0.31789421E-06_JPRB, &
  & 0.31788679E-06_JPRB, 0.31788289E-06_JPRB, 0.31788235E-06_JPRB, 0.31788417E-06_JPRB, 0.31788744E-06_JPRB, 0.31789045E-06_JPRB, &
  & 0.31789278E-06_JPRB, 0.31789335E-06_JPRB, 0.31789253E-06_JPRB, 0.31789054E-06_JPRB, 0.31788804E-06_JPRB, 0.31788511E-06_JPRB, &
  & 0.31788207E-06_JPRB, 0.31787891E-06_JPRB, 0.31787584E-06_JPRB, 0.31787289E-06_JPRB, 0.31787016E-06_JPRB, 0.31786777E-06_JPRB, &
  & 0.31786539E-06_JPRB, 0.31786280E-06_JPRB, 0.31785936E-06_JPRB, 0.31785299E-06_JPRB /)

RGHG3(:,67,11) = (/ &
  & 0.31779120E-06_JPRB, 0.31779689E-06_JPRB, 0.31779871E-06_JPRB, 0.31779956E-06_JPRB, 0.31779959E-06_JPRB, 0.31779919E-06_JPRB, &
  & 0.31779877E-06_JPRB, 0.31779888E-06_JPRB, 0.31780013E-06_JPRB, 0.31780297E-06_JPRB, 0.31780655E-06_JPRB, 0.31781073E-06_JPRB, &
  & 0.31781431E-06_JPRB, 0.31781641E-06_JPRB, 0.31781514E-06_JPRB, 0.31781087E-06_JPRB, 0.31780357E-06_JPRB, 0.31779535E-06_JPRB, &
  & 0.31778896E-06_JPRB, 0.31778731E-06_JPRB, 0.31779172E-06_JPRB, 0.31780220E-06_JPRB, 0.31781772E-06_JPRB, 0.31783750E-06_JPRB, &
  & 0.31785996E-06_JPRB, 0.31788318E-06_JPRB, 0.31790537E-06_JPRB, 0.31792507E-06_JPRB, 0.31794139E-06_JPRB, 0.31795437E-06_JPRB, &
  & 0.31796418E-06_JPRB, 0.31797055E-06_JPRB, 0.31797384E-06_JPRB, 0.31797410E-06_JPRB, 0.31797114E-06_JPRB, 0.31796549E-06_JPRB, &
  & 0.31795744E-06_JPRB, 0.31794744E-06_JPRB, 0.31793644E-06_JPRB, 0.31792490E-06_JPRB, 0.31791393E-06_JPRB, 0.31790441E-06_JPRB, &
  & 0.31789764E-06_JPRB, 0.31789418E-06_JPRB, 0.31789384E-06_JPRB, 0.31789563E-06_JPRB, 0.31789870E-06_JPRB, 0.31790157E-06_JPRB, &
  & 0.31790378E-06_JPRB, 0.31790435E-06_JPRB, 0.31790353E-06_JPRB, 0.31790165E-06_JPRB, 0.31789898E-06_JPRB, 0.31789591E-06_JPRB, &
  & 0.31789261E-06_JPRB, 0.31788920E-06_JPRB, 0.31788579E-06_JPRB, 0.31788261E-06_JPRB, 0.31787965E-06_JPRB, 0.31787692E-06_JPRB, &
  & 0.31787425E-06_JPRB, 0.31787107E-06_JPRB, 0.31786681E-06_JPRB, 0.31785839E-06_JPRB /)

RGHG3(:,68,11) = (/ &
  & 0.31780786E-06_JPRB, 0.31781479E-06_JPRB, 0.31781730E-06_JPRB, 0.31781843E-06_JPRB, 0.31781869E-06_JPRB, 0.31781846E-06_JPRB, &
  & 0.31781823E-06_JPRB, 0.31781866E-06_JPRB, 0.31782031E-06_JPRB, 0.31782335E-06_JPRB, 0.31782739E-06_JPRB, 0.31783162E-06_JPRB, &
  & 0.31783526E-06_JPRB, 0.31783745E-06_JPRB, 0.31783622E-06_JPRB, 0.31783267E-06_JPRB, 0.31782628E-06_JPRB, 0.31781906E-06_JPRB, &
  & 0.31781343E-06_JPRB, 0.31781212E-06_JPRB, 0.31781613E-06_JPRB, 0.31782554E-06_JPRB, 0.31783929E-06_JPRB, 0.31785683E-06_JPRB, &
  & 0.31787675E-06_JPRB, 0.31789745E-06_JPRB, 0.31791717E-06_JPRB, 0.31793462E-06_JPRB, 0.31794897E-06_JPRB, 0.31796046E-06_JPRB, &
  & 0.31796921E-06_JPRB, 0.31797487E-06_JPRB, 0.31797777E-06_JPRB, 0.31797794E-06_JPRB, 0.31797532E-06_JPRB, 0.31797015E-06_JPRB, &
  & 0.31796293E-06_JPRB, 0.31795389E-06_JPRB, 0.31794374E-06_JPRB, 0.31793306E-06_JPRB, 0.31792305E-06_JPRB, 0.31791438E-06_JPRB, &
  & 0.31790836E-06_JPRB, 0.31790526E-06_JPRB, 0.31790498E-06_JPRB, 0.31790677E-06_JPRB, 0.31790961E-06_JPRB, 0.31791225E-06_JPRB, &
  & 0.31791436E-06_JPRB, 0.31791490E-06_JPRB, 0.31791404E-06_JPRB, 0.31791234E-06_JPRB, 0.31790967E-06_JPRB, 0.31790651E-06_JPRB, &
  & 0.31790313E-06_JPRB, 0.31789952E-06_JPRB, 0.31789591E-06_JPRB, 0.31789256E-06_JPRB, 0.31788943E-06_JPRB, 0.31788650E-06_JPRB, &
  & 0.31788332E-06_JPRB, 0.31787980E-06_JPRB, 0.31787442E-06_JPRB, 0.31786405E-06_JPRB /)

RGHG3(:,69,11) = (/ &
  & 0.31782400E-06_JPRB, 0.31783242E-06_JPRB, 0.31783543E-06_JPRB, 0.31783694E-06_JPRB, 0.31783753E-06_JPRB, 0.31783765E-06_JPRB, &
  & 0.31783773E-06_JPRB, 0.31783844E-06_JPRB, 0.31784037E-06_JPRB, 0.31784376E-06_JPRB, 0.31784771E-06_JPRB, 0.31785191E-06_JPRB, &
  & 0.31785544E-06_JPRB, 0.31785777E-06_JPRB, 0.31785646E-06_JPRB, 0.31785345E-06_JPRB, 0.31784779E-06_JPRB, 0.31784163E-06_JPRB, &
  & 0.31783688E-06_JPRB, 0.31783568E-06_JPRB, 0.31783924E-06_JPRB, 0.31784745E-06_JPRB, 0.31785956E-06_JPRB, 0.31787505E-06_JPRB, &
  & 0.31789259E-06_JPRB, 0.31791080E-06_JPRB, 0.31792806E-06_JPRB, 0.31794343E-06_JPRB, 0.31795599E-06_JPRB, 0.31796600E-06_JPRB, &
  & 0.31797376E-06_JPRB, 0.31797879E-06_JPRB, 0.31798135E-06_JPRB, 0.31798132E-06_JPRB, 0.31797902E-06_JPRB, 0.31797441E-06_JPRB, &
  & 0.31796802E-06_JPRB, 0.31795980E-06_JPRB, 0.31795065E-06_JPRB, 0.31794096E-06_JPRB, 0.31793198E-06_JPRB, 0.31792416E-06_JPRB, &
  & 0.31791876E-06_JPRB, 0.31791600E-06_JPRB, 0.31791589E-06_JPRB, 0.31791757E-06_JPRB, 0.31792018E-06_JPRB, 0.31792268E-06_JPRB, &
  & 0.31792456E-06_JPRB, 0.31792499E-06_JPRB, 0.31792422E-06_JPRB, 0.31792254E-06_JPRB, 0.31791987E-06_JPRB, 0.31791680E-06_JPRB, &
  & 0.31791339E-06_JPRB, 0.31790984E-06_JPRB, 0.31790617E-06_JPRB, 0.31790267E-06_JPRB, 0.31789955E-06_JPRB, 0.31789631E-06_JPRB, &
  & 0.31789307E-06_JPRB, 0.31788909E-06_JPRB, 0.31788298E-06_JPRB, 0.31787047E-06_JPRB /)

RGHG3(:,70,11) = (/ &
  & 0.31783972E-06_JPRB, 0.31784970E-06_JPRB, 0.31785342E-06_JPRB, 0.31785535E-06_JPRB, 0.31785623E-06_JPRB, 0.31785672E-06_JPRB, &
  & 0.31785714E-06_JPRB, 0.31785822E-06_JPRB, 0.31786035E-06_JPRB, 0.31786371E-06_JPRB, 0.31786746E-06_JPRB, 0.31787144E-06_JPRB, &
  & 0.31787471E-06_JPRB, 0.31787707E-06_JPRB, 0.31787570E-06_JPRB, 0.31787329E-06_JPRB, 0.31786817E-06_JPRB, 0.31786274E-06_JPRB, &
  & 0.31785865E-06_JPRB, 0.31785765E-06_JPRB, 0.31786087E-06_JPRB, 0.31786794E-06_JPRB, 0.31787846E-06_JPRB, 0.31789199E-06_JPRB, &
  & 0.31790728E-06_JPRB, 0.31792320E-06_JPRB, 0.31793817E-06_JPRB, 0.31795150E-06_JPRB, 0.31796247E-06_JPRB, 0.31797106E-06_JPRB, &
  & 0.31797796E-06_JPRB, 0.31798226E-06_JPRB, 0.31798444E-06_JPRB, 0.31798425E-06_JPRB, 0.31798228E-06_JPRB, 0.31797819E-06_JPRB, &
  & 0.31797259E-06_JPRB, 0.31796534E-06_JPRB, 0.31795722E-06_JPRB, 0.31794852E-06_JPRB, 0.31794050E-06_JPRB, 0.31793351E-06_JPRB, &
  & 0.31792882E-06_JPRB, 0.31792655E-06_JPRB, 0.31792644E-06_JPRB, 0.31792803E-06_JPRB, 0.31793033E-06_JPRB, 0.31793269E-06_JPRB, &
  & 0.31793445E-06_JPRB, 0.31793479E-06_JPRB, 0.31793388E-06_JPRB, 0.31793240E-06_JPRB, 0.31792982E-06_JPRB, 0.31792686E-06_JPRB, &
  & 0.31792362E-06_JPRB, 0.31792010E-06_JPRB, 0.31791649E-06_JPRB, 0.31791316E-06_JPRB, 0.31790998E-06_JPRB, 0.31790682E-06_JPRB, &
  & 0.31790350E-06_JPRB, 0.31789943E-06_JPRB, 0.31789270E-06_JPRB, 0.31787869E-06_JPRB /)

RGHG3(:,71,11) = (/ &
  & 0.31785561E-06_JPRB, 0.31786715E-06_JPRB, 0.31787138E-06_JPRB, 0.31787371E-06_JPRB, 0.31787488E-06_JPRB, 0.31787567E-06_JPRB, &
  & 0.31787641E-06_JPRB, 0.31787772E-06_JPRB, 0.31788008E-06_JPRB, 0.31788315E-06_JPRB, 0.31788662E-06_JPRB, 0.31789008E-06_JPRB, &
  & 0.31789301E-06_JPRB, 0.31789546E-06_JPRB, 0.31789358E-06_JPRB, 0.31789182E-06_JPRB, 0.31788733E-06_JPRB, 0.31788264E-06_JPRB, &
  & 0.31787900E-06_JPRB, 0.31787812E-06_JPRB, 0.31788105E-06_JPRB, 0.31788713E-06_JPRB, 0.31789602E-06_JPRB, 0.31790773E-06_JPRB, &
  & 0.31792092E-06_JPRB, 0.31793459E-06_JPRB, 0.31794747E-06_JPRB, 0.31795895E-06_JPRB, 0.31796836E-06_JPRB, 0.31797566E-06_JPRB, &
  & 0.31798169E-06_JPRB, 0.31798541E-06_JPRB, 0.31798729E-06_JPRB, 0.31798692E-06_JPRB, 0.31798527E-06_JPRB, 0.31798172E-06_JPRB, &
  & 0.31797688E-06_JPRB, 0.31797049E-06_JPRB, 0.31796333E-06_JPRB, 0.31795560E-06_JPRB, 0.31794860E-06_JPRB, 0.31794244E-06_JPRB, &
  & 0.31793846E-06_JPRB, 0.31793647E-06_JPRB, 0.31793653E-06_JPRB, 0.31793815E-06_JPRB, 0.31794008E-06_JPRB, 0.31794224E-06_JPRB, &
  & 0.31794377E-06_JPRB, 0.31794409E-06_JPRB, 0.31794318E-06_JPRB, 0.31794201E-06_JPRB, 0.31793951E-06_JPRB, 0.31793672E-06_JPRB, &
  & 0.31793374E-06_JPRB, 0.31793047E-06_JPRB, 0.31792703E-06_JPRB, 0.31792396E-06_JPRB, 0.31792086E-06_JPRB, 0.31791780E-06_JPRB, &
  & 0.31791464E-06_JPRB, 0.31791052E-06_JPRB, 0.31790375E-06_JPRB, 0.31788886E-06_JPRB /)

RGHG3(:,72,11) = (/ &
  & 0.31787204E-06_JPRB, 0.31788451E-06_JPRB, 0.31788923E-06_JPRB, 0.31789179E-06_JPRB, 0.31789310E-06_JPRB, 0.31789415E-06_JPRB, &
  & 0.31789517E-06_JPRB, 0.31789665E-06_JPRB, 0.31789887E-06_JPRB, 0.31790185E-06_JPRB, 0.31790464E-06_JPRB, 0.31790776E-06_JPRB, &
  & 0.31791009E-06_JPRB, 0.31791265E-06_JPRB, 0.31791080E-06_JPRB, 0.31790913E-06_JPRB, 0.31790523E-06_JPRB, 0.31790114E-06_JPRB, &
  & 0.31789790E-06_JPRB, 0.31789708E-06_JPRB, 0.31789980E-06_JPRB, 0.31790492E-06_JPRB, 0.31791237E-06_JPRB, 0.31792217E-06_JPRB, &
  & 0.31793346E-06_JPRB, 0.31794508E-06_JPRB, 0.31795608E-06_JPRB, 0.31796583E-06_JPRB, 0.31797370E-06_JPRB, 0.31797978E-06_JPRB, &
  & 0.31798504E-06_JPRB, 0.31798814E-06_JPRB, 0.31798987E-06_JPRB, 0.31798936E-06_JPRB, 0.31798797E-06_JPRB, 0.31798487E-06_JPRB, &
  & 0.31798072E-06_JPRB, 0.31797518E-06_JPRB, 0.31796904E-06_JPRB, 0.31796239E-06_JPRB, 0.31795628E-06_JPRB, 0.31795093E-06_JPRB, &
  & 0.31794755E-06_JPRB, 0.31794593E-06_JPRB, 0.31794610E-06_JPRB, 0.31794772E-06_JPRB, 0.31794940E-06_JPRB, 0.31795128E-06_JPRB, &
  & 0.31795267E-06_JPRB, 0.31795295E-06_JPRB, 0.31795204E-06_JPRB, 0.31795111E-06_JPRB, 0.31794883E-06_JPRB, 0.31794625E-06_JPRB, &
  & 0.31794357E-06_JPRB, 0.31794079E-06_JPRB, 0.31793761E-06_JPRB, 0.31793479E-06_JPRB, 0.31793201E-06_JPRB, 0.31792902E-06_JPRB, &
  & 0.31792601E-06_JPRB, 0.31792223E-06_JPRB, 0.31791546E-06_JPRB, 0.31790046E-06_JPRB /)

RGHG3(:,73,11) = (/ &
  & 0.31788923E-06_JPRB, 0.31790196E-06_JPRB, 0.31790677E-06_JPRB, 0.31790938E-06_JPRB, 0.31791063E-06_JPRB, 0.31791188E-06_JPRB, &
  & 0.31791302E-06_JPRB, 0.31791444E-06_JPRB, 0.31791669E-06_JPRB, 0.31791902E-06_JPRB, 0.31792155E-06_JPRB, 0.31792391E-06_JPRB, &
  & 0.31792587E-06_JPRB, 0.31792831E-06_JPRB, 0.31792683E-06_JPRB, 0.31792507E-06_JPRB, 0.31792172E-06_JPRB, 0.31791814E-06_JPRB, &
  & 0.31791529E-06_JPRB, 0.31791456E-06_JPRB, 0.31791714E-06_JPRB, 0.31792138E-06_JPRB, 0.31792732E-06_JPRB, 0.31793553E-06_JPRB, &
  & 0.31794488E-06_JPRB, 0.31795483E-06_JPRB, 0.31796395E-06_JPRB, 0.31797205E-06_JPRB, 0.31797839E-06_JPRB, 0.31798345E-06_JPRB, &
  & 0.31798814E-06_JPRB, 0.31799070E-06_JPRB, 0.31799217E-06_JPRB, 0.31799149E-06_JPRB, 0.31799041E-06_JPRB, 0.31798777E-06_JPRB, &
  & 0.31798427E-06_JPRB, 0.31797956E-06_JPRB, 0.31797450E-06_JPRB, 0.31796867E-06_JPRB, 0.31796350E-06_JPRB, 0.31795895E-06_JPRB, &
  & 0.31795614E-06_JPRB, 0.31795483E-06_JPRB, 0.31795500E-06_JPRB, 0.31795662E-06_JPRB, 0.31795801E-06_JPRB, 0.31795969E-06_JPRB, &
  & 0.31796094E-06_JPRB, 0.31796120E-06_JPRB, 0.31796037E-06_JPRB, 0.31795975E-06_JPRB, 0.31795770E-06_JPRB, 0.31795531E-06_JPRB, &
  & 0.31795315E-06_JPRB, 0.31795071E-06_JPRB, 0.31794801E-06_JPRB, 0.31794562E-06_JPRB, 0.31794303E-06_JPRB, 0.31794036E-06_JPRB, &
  & 0.31793746E-06_JPRB, 0.31793391E-06_JPRB, 0.31792774E-06_JPRB, 0.31791279E-06_JPRB /)

RGHG3(:,74,11) = (/ &
  & 0.31790623E-06_JPRB, 0.31791882E-06_JPRB, 0.31792362E-06_JPRB, 0.31792607E-06_JPRB, 0.31792717E-06_JPRB, 0.31792842E-06_JPRB, &
  & 0.31792956E-06_JPRB, 0.31793101E-06_JPRB, 0.31793283E-06_JPRB, 0.31793508E-06_JPRB, 0.31793672E-06_JPRB, 0.31793888E-06_JPRB, &
  & 0.31794025E-06_JPRB, 0.31794247E-06_JPRB, 0.31794153E-06_JPRB, 0.31793977E-06_JPRB, 0.31793695E-06_JPRB, 0.31793371E-06_JPRB, &
  & 0.31793115E-06_JPRB, 0.31793047E-06_JPRB, 0.31793320E-06_JPRB, 0.31793655E-06_JPRB, 0.31794096E-06_JPRB, 0.31794767E-06_JPRB, &
  & 0.31795545E-06_JPRB, 0.31796370E-06_JPRB, 0.31797106E-06_JPRB, 0.31797771E-06_JPRB, 0.31798263E-06_JPRB, 0.31798672E-06_JPRB, &
  & 0.31799092E-06_JPRB, 0.31799289E-06_JPRB, 0.31799425E-06_JPRB, 0.31799357E-06_JPRB, 0.31799271E-06_JPRB, 0.31799038E-06_JPRB, &
  & 0.31798740E-06_JPRB, 0.31798356E-06_JPRB, 0.31797956E-06_JPRB, 0.31797461E-06_JPRB, 0.31797020E-06_JPRB, 0.31796642E-06_JPRB, &
  & 0.31796424E-06_JPRB, 0.31796318E-06_JPRB, 0.31796341E-06_JPRB, 0.31796495E-06_JPRB, 0.31796594E-06_JPRB, 0.31796745E-06_JPRB, &
  & 0.31796856E-06_JPRB, 0.31796887E-06_JPRB, 0.31796810E-06_JPRB, 0.31796799E-06_JPRB, 0.31796614E-06_JPRB, 0.31796395E-06_JPRB, &
  & 0.31796199E-06_JPRB, 0.31796012E-06_JPRB, 0.31795787E-06_JPRB, 0.31795580E-06_JPRB, 0.31795375E-06_JPRB, 0.31795102E-06_JPRB, &
  & 0.31794860E-06_JPRB, 0.31794548E-06_JPRB, 0.31793962E-06_JPRB, 0.31792581E-06_JPRB /)

RGHG3(:,75,11) = (/ &
  & 0.31792266E-06_JPRB, 0.31793493E-06_JPRB, 0.31793962E-06_JPRB, 0.31794178E-06_JPRB, 0.31794261E-06_JPRB, 0.31794380E-06_JPRB, &
  & 0.31794491E-06_JPRB, 0.31794605E-06_JPRB, 0.31794775E-06_JPRB, 0.31794934E-06_JPRB, 0.31795074E-06_JPRB, 0.31795230E-06_JPRB, &
  & 0.31795346E-06_JPRB, 0.31795537E-06_JPRB, 0.31795514E-06_JPRB, 0.31795312E-06_JPRB, 0.31795076E-06_JPRB, 0.31794781E-06_JPRB, &
  & 0.31794565E-06_JPRB, 0.31794514E-06_JPRB, 0.31794801E-06_JPRB, 0.31795062E-06_JPRB, 0.31795361E-06_JPRB, 0.31795892E-06_JPRB, &
  & 0.31796515E-06_JPRB, 0.31797194E-06_JPRB, 0.31797759E-06_JPRB, 0.31798285E-06_JPRB, 0.31798623E-06_JPRB, 0.31798965E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799482E-06_JPRB, 0.31799613E-06_JPRB, 0.31799541E-06_JPRB, 0.31799470E-06_JPRB, 0.31799283E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31798731E-06_JPRB, 0.31798430E-06_JPRB, 0.31798010E-06_JPRB, 0.31797651E-06_JPRB, 0.31797336E-06_JPRB, &
  & 0.31797171E-06_JPRB, 0.31797089E-06_JPRB, 0.31797109E-06_JPRB, 0.31797254E-06_JPRB, 0.31797313E-06_JPRB, 0.31797455E-06_JPRB, &
  & 0.31797552E-06_JPRB, 0.31797589E-06_JPRB, 0.31797521E-06_JPRB, 0.31797572E-06_JPRB, 0.31797396E-06_JPRB, 0.31797174E-06_JPRB, &
  & 0.31797026E-06_JPRB, 0.31796878E-06_JPRB, 0.31796699E-06_JPRB, 0.31796557E-06_JPRB, 0.31796372E-06_JPRB, 0.31796142E-06_JPRB, &
  & 0.31795909E-06_JPRB, 0.31795642E-06_JPRB, 0.31795145E-06_JPRB, 0.31793857E-06_JPRB /)

RGHG3(:,76,11) = (/ &
  & 0.31793849E-06_JPRB, 0.31795022E-06_JPRB, 0.31795469E-06_JPRB, 0.31795653E-06_JPRB, 0.31795685E-06_JPRB, 0.31795801E-06_JPRB, &
  & 0.31795895E-06_JPRB, 0.31795983E-06_JPRB, 0.31796111E-06_JPRB, 0.31796242E-06_JPRB, 0.31796307E-06_JPRB, 0.31796444E-06_JPRB, &
  & 0.31796523E-06_JPRB, 0.31796674E-06_JPRB, 0.31796725E-06_JPRB, 0.31796526E-06_JPRB, 0.31796341E-06_JPRB, 0.31796066E-06_JPRB, &
  & 0.31795869E-06_JPRB, 0.31795827E-06_JPRB, 0.31796162E-06_JPRB, 0.31796367E-06_JPRB, 0.31796523E-06_JPRB, 0.31796918E-06_JPRB, &
  & 0.31797393E-06_JPRB, 0.31797941E-06_JPRB, 0.31798353E-06_JPRB, 0.31798743E-06_JPRB, 0.31798936E-06_JPRB, 0.31799217E-06_JPRB, &
  & 0.31799553E-06_JPRB, 0.31799652E-06_JPRB, 0.31799780E-06_JPRB, 0.31799698E-06_JPRB, 0.31799649E-06_JPRB, 0.31799502E-06_JPRB, &
  & 0.31799286E-06_JPRB, 0.31799070E-06_JPRB, 0.31798871E-06_JPRB, 0.31798521E-06_JPRB, 0.31798251E-06_JPRB, 0.31797990E-06_JPRB, &
  & 0.31797865E-06_JPRB, 0.31797802E-06_JPRB, 0.31797816E-06_JPRB, 0.31797964E-06_JPRB, 0.31797964E-06_JPRB, 0.31798101E-06_JPRB, &
  & 0.31798180E-06_JPRB, 0.31798231E-06_JPRB, 0.31798157E-06_JPRB, 0.31798282E-06_JPRB, 0.31798106E-06_JPRB, 0.31797879E-06_JPRB, &
  & 0.31797754E-06_JPRB, 0.31797683E-06_JPRB, 0.31797546E-06_JPRB, 0.31797455E-06_JPRB, 0.31797325E-06_JPRB, 0.31797080E-06_JPRB, &
  & 0.31796898E-06_JPRB, 0.31796688E-06_JPRB, 0.31796264E-06_JPRB, 0.31795139E-06_JPRB /)

RGHG3(:,77,11) = (/ &
  & 0.31795352E-06_JPRB, 0.31796446E-06_JPRB, 0.31796864E-06_JPRB, 0.31797012E-06_JPRB, 0.31796981E-06_JPRB, 0.31797092E-06_JPRB, &
  & 0.31797182E-06_JPRB, 0.31797219E-06_JPRB, 0.31797316E-06_JPRB, 0.31797396E-06_JPRB, 0.31797396E-06_JPRB, 0.31797492E-06_JPRB, &
  & 0.31797555E-06_JPRB, 0.31797677E-06_JPRB, 0.31797819E-06_JPRB, 0.31797600E-06_JPRB, 0.31797478E-06_JPRB, 0.31797202E-06_JPRB, &
  & 0.31797040E-06_JPRB, 0.31797003E-06_JPRB, 0.31797421E-06_JPRB, 0.31797552E-06_JPRB, 0.31797566E-06_JPRB, 0.31797850E-06_JPRB, &
  & 0.31798206E-06_JPRB, 0.31798621E-06_JPRB, 0.31798893E-06_JPRB, 0.31799155E-06_JPRB, 0.31799203E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799749E-06_JPRB, 0.31799789E-06_JPRB, 0.31799922E-06_JPRB, 0.31799848E-06_JPRB, 0.31799823E-06_JPRB, 0.31799709E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799382E-06_JPRB, 0.31799277E-06_JPRB, 0.31799001E-06_JPRB, 0.31798800E-06_JPRB, 0.31798578E-06_JPRB, &
  & 0.31798498E-06_JPRB, 0.31798450E-06_JPRB, 0.31798456E-06_JPRB, 0.31798606E-06_JPRB, 0.31798541E-06_JPRB, 0.31798675E-06_JPRB, &
  & 0.31798737E-06_JPRB, 0.31798805E-06_JPRB, 0.31798712E-06_JPRB, 0.31798947E-06_JPRB, 0.31798763E-06_JPRB, 0.31798498E-06_JPRB, &
  & 0.31798416E-06_JPRB, 0.31798413E-06_JPRB, 0.31798322E-06_JPRB, 0.31798299E-06_JPRB, 0.31798197E-06_JPRB, 0.31797978E-06_JPRB, &
  & 0.31797805E-06_JPRB, 0.31797660E-06_JPRB, 0.31797319E-06_JPRB, 0.31796390E-06_JPRB /)

RGHG3(:,78,11) = (/ &
  & 0.31796768E-06_JPRB, 0.31797708E-06_JPRB, 0.31798061E-06_JPRB, 0.31798169E-06_JPRB, 0.31798072E-06_JPRB, 0.31798174E-06_JPRB, &
  & 0.31798265E-06_JPRB, 0.31798254E-06_JPRB, 0.31798314E-06_JPRB, 0.31798348E-06_JPRB, 0.31798274E-06_JPRB, 0.31798351E-06_JPRB, &
  & 0.31798382E-06_JPRB, 0.31798479E-06_JPRB, 0.31798729E-06_JPRB, 0.31798484E-06_JPRB, 0.31798427E-06_JPRB, 0.31798146E-06_JPRB, &
  & 0.31798021E-06_JPRB, 0.31797998E-06_JPRB, 0.31798493E-06_JPRB, 0.31798569E-06_JPRB, 0.31798453E-06_JPRB, 0.31798641E-06_JPRB, &
  & 0.31798896E-06_JPRB, 0.31799195E-06_JPRB, 0.31799345E-06_JPRB, 0.31799505E-06_JPRB, 0.31799419E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799911E-06_JPRB, 0.31799908E-06_JPRB, 0.31800045E-06_JPRB, 0.31799971E-06_JPRB, 0.31799965E-06_JPRB, 0.31799888E-06_JPRB, &
  & 0.31799718E-06_JPRB, 0.31799649E-06_JPRB, 0.31799627E-06_JPRB, 0.31799408E-06_JPRB, 0.31799266E-06_JPRB, 0.31799095E-06_JPRB, &
  & 0.31799041E-06_JPRB, 0.31799010E-06_JPRB, 0.31799001E-06_JPRB, 0.31799158E-06_JPRB, 0.31799019E-06_JPRB, 0.31799158E-06_JPRB, &
  & 0.31799203E-06_JPRB, 0.31799283E-06_JPRB, 0.31799169E-06_JPRB, 0.31799519E-06_JPRB, 0.31799311E-06_JPRB, 0.31799007E-06_JPRB, &
  & 0.31798962E-06_JPRB, 0.31799024E-06_JPRB, 0.31798976E-06_JPRB, 0.31799021E-06_JPRB, 0.31798965E-06_JPRB, 0.31798726E-06_JPRB, &
  & 0.31798578E-06_JPRB, 0.31798490E-06_JPRB, 0.31798268E-06_JPRB, 0.31797632E-06_JPRB /)

RGHG3(:,79,11) = (/ &
  & 0.31797649E-06_JPRB, 0.31798410E-06_JPRB, 0.31798720E-06_JPRB, 0.31798794E-06_JPRB, 0.31798641E-06_JPRB, 0.31798749E-06_JPRB, &
  & 0.31798845E-06_JPRB, 0.31798797E-06_JPRB, 0.31798837E-06_JPRB, 0.31798848E-06_JPRB, 0.31798714E-06_JPRB, 0.31798783E-06_JPRB, &
  & 0.31798811E-06_JPRB, 0.31798893E-06_JPRB, 0.31799237E-06_JPRB, 0.31798947E-06_JPRB, 0.31798933E-06_JPRB, 0.31798629E-06_JPRB, &
  & 0.31798518E-06_JPRB, 0.31798504E-06_JPRB, 0.31799107E-06_JPRB, 0.31799152E-06_JPRB, 0.31798939E-06_JPRB, 0.31799070E-06_JPRB, &
  & 0.31799277E-06_JPRB, 0.31799527E-06_JPRB, 0.31799618E-06_JPRB, 0.31799709E-06_JPRB, 0.31799516E-06_JPRB, 0.31799686E-06_JPRB, &
  & 0.31800013E-06_JPRB, 0.31799982E-06_JPRB, 0.31800133E-06_JPRB, 0.31800059E-06_JPRB, 0.31800067E-06_JPRB, 0.31799999E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799809E-06_JPRB, 0.31799837E-06_JPRB, 0.31799641E-06_JPRB, 0.31799524E-06_JPRB, 0.31799360E-06_JPRB, &
  & 0.31799331E-06_JPRB, 0.31799300E-06_JPRB, 0.31799286E-06_JPRB, 0.31799462E-06_JPRB, 0.31799260E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799550E-06_JPRB, 0.31799405E-06_JPRB, 0.31799848E-06_JPRB, 0.31799618E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799237E-06_JPRB, 0.31799351E-06_JPRB, 0.31799328E-06_JPRB, 0.31799425E-06_JPRB, 0.31799388E-06_JPRB, 0.31799135E-06_JPRB, &
  & 0.31798970E-06_JPRB, 0.31798933E-06_JPRB, 0.31798800E-06_JPRB, 0.31798447E-06_JPRB /)

RGHG3(:,80,11) = (/ &
  & 0.31798203E-06_JPRB, 0.31798751E-06_JPRB, 0.31799016E-06_JPRB, 0.31799073E-06_JPRB, 0.31798888E-06_JPRB, 0.31799001E-06_JPRB, &
  & 0.31799104E-06_JPRB, 0.31799038E-06_JPRB, 0.31799067E-06_JPRB, 0.31799075E-06_JPRB, 0.31798896E-06_JPRB, 0.31798965E-06_JPRB, &
  & 0.31798993E-06_JPRB, 0.31799078E-06_JPRB, 0.31799487E-06_JPRB, 0.31799163E-06_JPRB, 0.31799169E-06_JPRB, 0.31798839E-06_JPRB, &
  & 0.31798726E-06_JPRB, 0.31798720E-06_JPRB, 0.31799399E-06_JPRB, 0.31799428E-06_JPRB, 0.31799161E-06_JPRB, 0.31799266E-06_JPRB, &
  & 0.31799456E-06_JPRB, 0.31799692E-06_JPRB, 0.31799743E-06_JPRB, 0.31799800E-06_JPRB, 0.31799550E-06_JPRB, 0.31799721E-06_JPRB, &
  & 0.31800076E-06_JPRB, 0.31800028E-06_JPRB, 0.31800192E-06_JPRB, 0.31800110E-06_JPRB, 0.31800124E-06_JPRB, 0.31800064E-06_JPRB, &
  & 0.31799885E-06_JPRB, 0.31799885E-06_JPRB, 0.31799951E-06_JPRB, 0.31799757E-06_JPRB, 0.31799644E-06_JPRB, 0.31799482E-06_JPRB, &
  & 0.31799462E-06_JPRB, 0.31799439E-06_JPRB, 0.31799414E-06_JPRB, 0.31799604E-06_JPRB, 0.31799362E-06_JPRB, 0.31799522E-06_JPRB, &
  & 0.31799564E-06_JPRB, 0.31799681E-06_JPRB, 0.31799510E-06_JPRB, 0.31800028E-06_JPRB, 0.31799772E-06_JPRB, 0.31799362E-06_JPRB, &
  & 0.31799351E-06_JPRB, 0.31799502E-06_JPRB, 0.31799487E-06_JPRB, 0.31799613E-06_JPRB, 0.31799587E-06_JPRB, 0.31799300E-06_JPRB, &
  & 0.31799144E-06_JPRB, 0.31799129E-06_JPRB, 0.31799061E-06_JPRB, 0.31799019E-06_JPRB /)

RGHG3(:,81,11) = (/ &
  & 0.31798541E-06_JPRB, 0.31798896E-06_JPRB, 0.31799152E-06_JPRB, 0.31799206E-06_JPRB, 0.31798999E-06_JPRB, 0.31799112E-06_JPRB, &
  & 0.31799217E-06_JPRB, 0.31799138E-06_JPRB, 0.31799163E-06_JPRB, 0.31799169E-06_JPRB, 0.31798973E-06_JPRB, 0.31799041E-06_JPRB, &
  & 0.31799073E-06_JPRB, 0.31799152E-06_JPRB, 0.31799604E-06_JPRB, 0.31799263E-06_JPRB, 0.31799283E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31798808E-06_JPRB, 0.31798803E-06_JPRB, 0.31799547E-06_JPRB, 0.31799561E-06_JPRB, 0.31799269E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799539E-06_JPRB, 0.31799760E-06_JPRB, 0.31799800E-06_JPRB, 0.31799851E-06_JPRB, 0.31799561E-06_JPRB, 0.31799729E-06_JPRB, &
  & 0.31800099E-06_JPRB, 0.31800045E-06_JPRB, 0.31800229E-06_JPRB, 0.31800147E-06_JPRB, 0.31800161E-06_JPRB, 0.31800093E-06_JPRB, &
  & 0.31799911E-06_JPRB, 0.31799925E-06_JPRB, 0.31800002E-06_JPRB, 0.31799811E-06_JPRB, 0.31799703E-06_JPRB, 0.31799544E-06_JPRB, &
  & 0.31799522E-06_JPRB, 0.31799490E-06_JPRB, 0.31799465E-06_JPRB, 0.31799672E-06_JPRB, 0.31799402E-06_JPRB, 0.31799570E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799732E-06_JPRB, 0.31799550E-06_JPRB, 0.31800121E-06_JPRB, 0.31799851E-06_JPRB, 0.31799397E-06_JPRB, &
  & 0.31799402E-06_JPRB, 0.31799576E-06_JPRB, 0.31799561E-06_JPRB, 0.31799703E-06_JPRB, 0.31799686E-06_JPRB, 0.31799379E-06_JPRB, &
  & 0.31799209E-06_JPRB, 0.31799206E-06_JPRB, 0.31799169E-06_JPRB, 0.31799439E-06_JPRB /)

RGHG3(:,82,11) = (/ &
  & 0.31798567E-06_JPRB, 0.31798945E-06_JPRB, 0.31799212E-06_JPRB, 0.31799266E-06_JPRB, 0.31799050E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799189E-06_JPRB, 0.31799217E-06_JPRB, 0.31799229E-06_JPRB, 0.31799010E-06_JPRB, 0.31799084E-06_JPRB, &
  & 0.31799107E-06_JPRB, 0.31799192E-06_JPRB, 0.31799667E-06_JPRB, 0.31799308E-06_JPRB, 0.31799343E-06_JPRB, 0.31798959E-06_JPRB, &
  & 0.31798845E-06_JPRB, 0.31798842E-06_JPRB, 0.31799610E-06_JPRB, 0.31799632E-06_JPRB, 0.31799317E-06_JPRB, 0.31799405E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799806E-06_JPRB, 0.31799840E-06_JPRB, 0.31799874E-06_JPRB, 0.31799564E-06_JPRB, 0.31799732E-06_JPRB, &
  & 0.31800116E-06_JPRB, 0.31800059E-06_JPRB, 0.31800255E-06_JPRB, 0.31800161E-06_JPRB, 0.31800181E-06_JPRB, 0.31800116E-06_JPRB, &
  & 0.31799928E-06_JPRB, 0.31799945E-06_JPRB, 0.31800033E-06_JPRB, 0.31799848E-06_JPRB, 0.31799732E-06_JPRB, 0.31799564E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799519E-06_JPRB, 0.31799493E-06_JPRB, 0.31799709E-06_JPRB, 0.31799414E-06_JPRB, 0.31799587E-06_JPRB, &
  & 0.31799627E-06_JPRB, 0.31799763E-06_JPRB, 0.31799570E-06_JPRB, 0.31800178E-06_JPRB, 0.31799894E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799425E-06_JPRB, 0.31799607E-06_JPRB, 0.31799598E-06_JPRB, 0.31799755E-06_JPRB, 0.31799732E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799240E-06_JPRB, 0.31799240E-06_JPRB, 0.31799203E-06_JPRB, 0.31799476E-06_JPRB /)

RGHG3(:,83,11) = (/ &
  & 0.31798578E-06_JPRB, 0.31798970E-06_JPRB, 0.31799252E-06_JPRB, 0.31799308E-06_JPRB, 0.31799084E-06_JPRB, 0.31799200E-06_JPRB, &
  & 0.31799311E-06_JPRB, 0.31799217E-06_JPRB, 0.31799243E-06_JPRB, 0.31799237E-06_JPRB, 0.31799038E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799127E-06_JPRB, 0.31799212E-06_JPRB, 0.31799706E-06_JPRB, 0.31799340E-06_JPRB, 0.31799368E-06_JPRB, 0.31798976E-06_JPRB, &
  & 0.31798857E-06_JPRB, 0.31798848E-06_JPRB, 0.31799667E-06_JPRB, 0.31799684E-06_JPRB, 0.31799345E-06_JPRB, 0.31799428E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799831E-06_JPRB, 0.31799854E-06_JPRB, 0.31799891E-06_JPRB, 0.31799561E-06_JPRB, 0.31799726E-06_JPRB, &
  & 0.31800130E-06_JPRB, 0.31800067E-06_JPRB, 0.31800269E-06_JPRB, 0.31800178E-06_JPRB, 0.31800187E-06_JPRB, 0.31800121E-06_JPRB, &
  & 0.31799948E-06_JPRB, 0.31799956E-06_JPRB, 0.31800045E-06_JPRB, 0.31799874E-06_JPRB, 0.31799749E-06_JPRB, 0.31799584E-06_JPRB, &
  & 0.31799564E-06_JPRB, 0.31799533E-06_JPRB, 0.31799499E-06_JPRB, 0.31799729E-06_JPRB, 0.31799414E-06_JPRB, 0.31799598E-06_JPRB, &
  & 0.31799638E-06_JPRB, 0.31799783E-06_JPRB, 0.31799578E-06_JPRB, 0.31800215E-06_JPRB, 0.31799922E-06_JPRB, 0.31799428E-06_JPRB, &
  & 0.31799436E-06_JPRB, 0.31799624E-06_JPRB, 0.31799630E-06_JPRB, 0.31799789E-06_JPRB, 0.31799766E-06_JPRB, 0.31799439E-06_JPRB, &
  & 0.31799260E-06_JPRB, 0.31799263E-06_JPRB, 0.31799223E-06_JPRB, 0.31799502E-06_JPRB /)

RGHG3(:,84,11) = (/ &
  & 0.31798584E-06_JPRB, 0.31798987E-06_JPRB, 0.31799277E-06_JPRB, 0.31799334E-06_JPRB, 0.31799107E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799331E-06_JPRB, 0.31799240E-06_JPRB, 0.31799257E-06_JPRB, 0.31799246E-06_JPRB, 0.31799055E-06_JPRB, 0.31799107E-06_JPRB, &
  & 0.31799144E-06_JPRB, 0.31799220E-06_JPRB, 0.31799718E-06_JPRB, 0.31799362E-06_JPRB, 0.31799397E-06_JPRB, 0.31798993E-06_JPRB, &
  & 0.31798868E-06_JPRB, 0.31798865E-06_JPRB, 0.31799698E-06_JPRB, 0.31799712E-06_JPRB, 0.31799362E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799621E-06_JPRB, 0.31799857E-06_JPRB, 0.31799871E-06_JPRB, 0.31799897E-06_JPRB, 0.31799556E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31800141E-06_JPRB, 0.31800070E-06_JPRB, 0.31800283E-06_JPRB, 0.31800187E-06_JPRB, 0.31800198E-06_JPRB, 0.31800127E-06_JPRB, &
  & 0.31799956E-06_JPRB, 0.31799971E-06_JPRB, 0.31800053E-06_JPRB, 0.31799894E-06_JPRB, 0.31799769E-06_JPRB, 0.31799590E-06_JPRB, &
  & 0.31799567E-06_JPRB, 0.31799539E-06_JPRB, 0.31799496E-06_JPRB, 0.31799738E-06_JPRB, 0.31799416E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799638E-06_JPRB, 0.31799792E-06_JPRB, 0.31799587E-06_JPRB, 0.31800244E-06_JPRB, 0.31799937E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799439E-06_JPRB, 0.31799627E-06_JPRB, 0.31799641E-06_JPRB, 0.31799809E-06_JPRB, 0.31799789E-06_JPRB, 0.31799456E-06_JPRB, &
  & 0.31799271E-06_JPRB, 0.31799271E-06_JPRB, 0.31799240E-06_JPRB, 0.31799522E-06_JPRB /)

RGHG3(:,85,11) = (/ &
  & 0.31798581E-06_JPRB, 0.31798999E-06_JPRB, 0.31799300E-06_JPRB, 0.31799362E-06_JPRB, 0.31799118E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799334E-06_JPRB, 0.31799254E-06_JPRB, 0.31799260E-06_JPRB, 0.31799232E-06_JPRB, 0.31799098E-06_JPRB, 0.31799124E-06_JPRB, &
  & 0.31799161E-06_JPRB, 0.31799260E-06_JPRB, 0.31799681E-06_JPRB, 0.31799394E-06_JPRB, 0.31799402E-06_JPRB, 0.31799001E-06_JPRB, &
  & 0.31798871E-06_JPRB, 0.31798862E-06_JPRB, 0.31799735E-06_JPRB, 0.31799746E-06_JPRB, 0.31799360E-06_JPRB, 0.31799451E-06_JPRB, &
  & 0.31799635E-06_JPRB, 0.31799874E-06_JPRB, 0.31799880E-06_JPRB, 0.31799908E-06_JPRB, 0.31799547E-06_JPRB, 0.31799723E-06_JPRB, &
  & 0.31800144E-06_JPRB, 0.31800079E-06_JPRB, 0.31800295E-06_JPRB, 0.31800198E-06_JPRB, 0.31800207E-06_JPRB, 0.31800133E-06_JPRB, &
  & 0.31799965E-06_JPRB, 0.31799982E-06_JPRB, 0.31800067E-06_JPRB, 0.31799914E-06_JPRB, 0.31799772E-06_JPRB, 0.31799590E-06_JPRB, &
  & 0.31799567E-06_JPRB, 0.31799536E-06_JPRB, 0.31799505E-06_JPRB, 0.31799757E-06_JPRB, 0.31799411E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799632E-06_JPRB, 0.31799794E-06_JPRB, 0.31799590E-06_JPRB, 0.31800269E-06_JPRB, 0.31799954E-06_JPRB, 0.31799439E-06_JPRB, &
  & 0.31799445E-06_JPRB, 0.31799630E-06_JPRB, 0.31799649E-06_JPRB, 0.31799823E-06_JPRB, 0.31799809E-06_JPRB, 0.31799468E-06_JPRB, &
  & 0.31799277E-06_JPRB, 0.31799280E-06_JPRB, 0.31799243E-06_JPRB, 0.31799541E-06_JPRB /)

RGHG3(:,86,11) = (/ &
  & 0.31798578E-06_JPRB, 0.31799004E-06_JPRB, 0.31799314E-06_JPRB, 0.31799379E-06_JPRB, 0.31799124E-06_JPRB, 0.31799237E-06_JPRB, &
  & 0.31799328E-06_JPRB, 0.31799269E-06_JPRB, 0.31799260E-06_JPRB, 0.31799223E-06_JPRB, 0.31799129E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799186E-06_JPRB, 0.31799286E-06_JPRB, 0.31799613E-06_JPRB, 0.31799408E-06_JPRB, 0.31799402E-06_JPRB, 0.31799027E-06_JPRB, &
  & 0.31798891E-06_JPRB, 0.31798868E-06_JPRB, 0.31799755E-06_JPRB, 0.31799775E-06_JPRB, 0.31799360E-06_JPRB, 0.31799453E-06_JPRB, &
  & 0.31799644E-06_JPRB, 0.31799894E-06_JPRB, 0.31799894E-06_JPRB, 0.31799922E-06_JPRB, 0.31799536E-06_JPRB, 0.31799715E-06_JPRB, &
  & 0.31800150E-06_JPRB, 0.31800084E-06_JPRB, 0.31800306E-06_JPRB, 0.31800198E-06_JPRB, 0.31800204E-06_JPRB, 0.31800133E-06_JPRB, &
  & 0.31799965E-06_JPRB, 0.31799982E-06_JPRB, 0.31800076E-06_JPRB, 0.31799919E-06_JPRB, 0.31799783E-06_JPRB, 0.31799584E-06_JPRB, &
  & 0.31799573E-06_JPRB, 0.31799541E-06_JPRB, 0.31799502E-06_JPRB, 0.31799766E-06_JPRB, 0.31799408E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799627E-06_JPRB, 0.31799800E-06_JPRB, 0.31799593E-06_JPRB, 0.31800298E-06_JPRB, 0.31799965E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799451E-06_JPRB, 0.31799632E-06_JPRB, 0.31799661E-06_JPRB, 0.31799834E-06_JPRB, 0.31799820E-06_JPRB, 0.31799476E-06_JPRB, &
  & 0.31799286E-06_JPRB, 0.31799286E-06_JPRB, 0.31799246E-06_JPRB, 0.31799556E-06_JPRB /)

RGHG3(:,87,11) = (/ &
  & 0.31798567E-06_JPRB, 0.31799004E-06_JPRB, 0.31799323E-06_JPRB, 0.31799379E-06_JPRB, 0.31799129E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799323E-06_JPRB, 0.31799266E-06_JPRB, 0.31799257E-06_JPRB, 0.31799223E-06_JPRB, 0.31799163E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799311E-06_JPRB, 0.31799559E-06_JPRB, 0.31799411E-06_JPRB, 0.31799391E-06_JPRB, 0.31799036E-06_JPRB, &
  & 0.31798899E-06_JPRB, 0.31798879E-06_JPRB, 0.31799763E-06_JPRB, 0.31799794E-06_JPRB, 0.31799351E-06_JPRB, 0.31799445E-06_JPRB, &
  & 0.31799649E-06_JPRB, 0.31799917E-06_JPRB, 0.31799902E-06_JPRB, 0.31799934E-06_JPRB, 0.31799519E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31800161E-06_JPRB, 0.31800087E-06_JPRB, 0.31800317E-06_JPRB, 0.31800212E-06_JPRB, 0.31800209E-06_JPRB, 0.31800130E-06_JPRB, &
  & 0.31799962E-06_JPRB, 0.31799982E-06_JPRB, 0.31800104E-06_JPRB, 0.31799942E-06_JPRB, 0.31799780E-06_JPRB, 0.31799584E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799541E-06_JPRB, 0.31799496E-06_JPRB, 0.31799772E-06_JPRB, 0.31799399E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799624E-06_JPRB, 0.31799809E-06_JPRB, 0.31799593E-06_JPRB, 0.31800315E-06_JPRB, 0.31799973E-06_JPRB, 0.31799433E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799630E-06_JPRB, 0.31799658E-06_JPRB, 0.31799837E-06_JPRB, 0.31799820E-06_JPRB, 0.31799485E-06_JPRB, &
  & 0.31799297E-06_JPRB, 0.31799289E-06_JPRB, 0.31799243E-06_JPRB, 0.31799567E-06_JPRB /)

RGHG3(:,88,11) = (/ &
  & 0.31798572E-06_JPRB, 0.31799010E-06_JPRB, 0.31799328E-06_JPRB, 0.31799394E-06_JPRB, 0.31799132E-06_JPRB, 0.31799243E-06_JPRB, &
  & 0.31799317E-06_JPRB, 0.31799277E-06_JPRB, 0.31799260E-06_JPRB, 0.31799226E-06_JPRB, 0.31799163E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799300E-06_JPRB, 0.31799539E-06_JPRB, 0.31799414E-06_JPRB, 0.31799385E-06_JPRB, 0.31799050E-06_JPRB, &
  & 0.31798902E-06_JPRB, 0.31798871E-06_JPRB, 0.31799780E-06_JPRB, 0.31799820E-06_JPRB, 0.31799343E-06_JPRB, 0.31799442E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799939E-06_JPRB, 0.31799900E-06_JPRB, 0.31799948E-06_JPRB, 0.31799502E-06_JPRB, 0.31799698E-06_JPRB, &
  & 0.31800172E-06_JPRB, 0.31800096E-06_JPRB, 0.31800326E-06_JPRB, 0.31800215E-06_JPRB, 0.31800209E-06_JPRB, 0.31800136E-06_JPRB, &
  & 0.31799959E-06_JPRB, 0.31799982E-06_JPRB, 0.31800113E-06_JPRB, 0.31799939E-06_JPRB, 0.31799783E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799581E-06_JPRB, 0.31799536E-06_JPRB, 0.31799487E-06_JPRB, 0.31799777E-06_JPRB, 0.31799394E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799615E-06_JPRB, 0.31799809E-06_JPRB, 0.31799593E-06_JPRB, 0.31800334E-06_JPRB, 0.31799982E-06_JPRB, 0.31799431E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799635E-06_JPRB, 0.31799664E-06_JPRB, 0.31799846E-06_JPRB, 0.31799826E-06_JPRB, 0.31799482E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799291E-06_JPRB, 0.31799246E-06_JPRB, 0.31799578E-06_JPRB /)

RGHG3(:,89,11) = (/ &
  & 0.31798584E-06_JPRB, 0.31799010E-06_JPRB, 0.31799337E-06_JPRB, 0.31799394E-06_JPRB, 0.31799127E-06_JPRB, 0.31799271E-06_JPRB, &
  & 0.31799331E-06_JPRB, 0.31799271E-06_JPRB, 0.31799260E-06_JPRB, 0.31799220E-06_JPRB, 0.31799152E-06_JPRB, 0.31799169E-06_JPRB, &
  & 0.31799212E-06_JPRB, 0.31799306E-06_JPRB, 0.31799570E-06_JPRB, 0.31799419E-06_JPRB, 0.31799402E-06_JPRB, 0.31799041E-06_JPRB, &
  & 0.31798896E-06_JPRB, 0.31798865E-06_JPRB, 0.31799789E-06_JPRB, 0.31799840E-06_JPRB, 0.31799337E-06_JPRB, 0.31799439E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799959E-06_JPRB, 0.31799908E-06_JPRB, 0.31799954E-06_JPRB, 0.31799487E-06_JPRB, 0.31799692E-06_JPRB, &
  & 0.31800181E-06_JPRB, 0.31800096E-06_JPRB, 0.31800343E-06_JPRB, 0.31800212E-06_JPRB, 0.31800209E-06_JPRB, 0.31800133E-06_JPRB, &
  & 0.31799956E-06_JPRB, 0.31799979E-06_JPRB, 0.31800127E-06_JPRB, 0.31799942E-06_JPRB, 0.31799783E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799584E-06_JPRB, 0.31799536E-06_JPRB, 0.31799487E-06_JPRB, 0.31799789E-06_JPRB, 0.31799388E-06_JPRB, 0.31799601E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799814E-06_JPRB, 0.31799584E-06_JPRB, 0.31800354E-06_JPRB, 0.31799988E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799453E-06_JPRB, 0.31799635E-06_JPRB, 0.31799667E-06_JPRB, 0.31799851E-06_JPRB, 0.31799829E-06_JPRB, 0.31799485E-06_JPRB, &
  & 0.31799303E-06_JPRB, 0.31799300E-06_JPRB, 0.31799237E-06_JPRB, 0.31799584E-06_JPRB /)

RGHG3(:,90,11) = (/ &
  & 0.31798601E-06_JPRB, 0.31799010E-06_JPRB, 0.31799348E-06_JPRB, 0.31799416E-06_JPRB, 0.31799112E-06_JPRB, 0.31799257E-06_JPRB, &
  & 0.31799351E-06_JPRB, 0.31799289E-06_JPRB, 0.31799277E-06_JPRB, 0.31799232E-06_JPRB, 0.31799129E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31799192E-06_JPRB, 0.31799289E-06_JPRB, 0.31799652E-06_JPRB, 0.31799419E-06_JPRB, 0.31799436E-06_JPRB, 0.31799016E-06_JPRB, &
  & 0.31798879E-06_JPRB, 0.31798820E-06_JPRB, 0.31799829E-06_JPRB, 0.31799865E-06_JPRB, 0.31799323E-06_JPRB, 0.31799436E-06_JPRB, &
  & 0.31799652E-06_JPRB, 0.31799973E-06_JPRB, 0.31799902E-06_JPRB, 0.31799965E-06_JPRB, 0.31799465E-06_JPRB, 0.31799684E-06_JPRB, &
  & 0.31800204E-06_JPRB, 0.31800090E-06_JPRB, 0.31800363E-06_JPRB, 0.31800212E-06_JPRB, 0.31800215E-06_JPRB, 0.31800141E-06_JPRB, &
  & 0.31799948E-06_JPRB, 0.31799971E-06_JPRB, 0.31800141E-06_JPRB, 0.31799945E-06_JPRB, 0.31799783E-06_JPRB, 0.31799561E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799536E-06_JPRB, 0.31799473E-06_JPRB, 0.31799809E-06_JPRB, 0.31799371E-06_JPRB, 0.31799607E-06_JPRB, &
  & 0.31799607E-06_JPRB, 0.31799826E-06_JPRB, 0.31799561E-06_JPRB, 0.31800391E-06_JPRB, 0.31799993E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799445E-06_JPRB, 0.31799638E-06_JPRB, 0.31799669E-06_JPRB, 0.31799860E-06_JPRB, 0.31799846E-06_JPRB, 0.31799479E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799306E-06_JPRB, 0.31799246E-06_JPRB, 0.31799601E-06_JPRB /)

RGHG3(:,91,11) = (/ &
  & 0.31798618E-06_JPRB, 0.31798979E-06_JPRB, 0.31799351E-06_JPRB, 0.31799448E-06_JPRB, 0.31799067E-06_JPRB, 0.31799260E-06_JPRB, &
  & 0.31799408E-06_JPRB, 0.31799274E-06_JPRB, 0.31799334E-06_JPRB, 0.31799306E-06_JPRB, 0.31799001E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799169E-06_JPRB, 0.31799919E-06_JPRB, 0.31799345E-06_JPRB, 0.31799522E-06_JPRB, 0.31798965E-06_JPRB, &
  & 0.31798859E-06_JPRB, 0.31798740E-06_JPRB, 0.31799902E-06_JPRB, 0.31799911E-06_JPRB, 0.31799283E-06_JPRB, 0.31799422E-06_JPRB, &
  & 0.31799647E-06_JPRB, 0.31800002E-06_JPRB, 0.31799905E-06_JPRB, 0.31800005E-06_JPRB, 0.31799414E-06_JPRB, 0.31799658E-06_JPRB, &
  & 0.31800249E-06_JPRB, 0.31800059E-06_JPRB, 0.31800400E-06_JPRB, 0.31800198E-06_JPRB, 0.31800218E-06_JPRB, 0.31800158E-06_JPRB, &
  & 0.31799925E-06_JPRB, 0.31799959E-06_JPRB, 0.31800170E-06_JPRB, 0.31799942E-06_JPRB, 0.31799786E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799593E-06_JPRB, 0.31799533E-06_JPRB, 0.31799453E-06_JPRB, 0.31799857E-06_JPRB, 0.31799331E-06_JPRB, 0.31799615E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799857E-06_JPRB, 0.31799493E-06_JPRB, 0.31800477E-06_JPRB, 0.31800008E-06_JPRB, 0.31799368E-06_JPRB, &
  & 0.31799439E-06_JPRB, 0.31799655E-06_JPRB, 0.31799661E-06_JPRB, 0.31799874E-06_JPRB, 0.31799863E-06_JPRB, 0.31799462E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799306E-06_JPRB, 0.31799237E-06_JPRB, 0.31799610E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG3(:, 1,12) = (/ &
  & 0.91040221E-07_JPRB, 0.91393801E-07_JPRB, 0.91233403E-07_JPRB, 0.91100041E-07_JPRB, 0.90998370E-07_JPRB, 0.90923848E-07_JPRB, &
  & 0.90870657E-07_JPRB, 0.90833858E-07_JPRB, 0.90811071E-07_JPRB, 0.90799773E-07_JPRB, 0.90797727E-07_JPRB, 0.90804619E-07_JPRB, &
  & 0.90822930E-07_JPRB, 0.90856886E-07_JPRB, 0.90911527E-07_JPRB, 0.90993439E-07_JPRB, 0.91103217E-07_JPRB, 0.91233936E-07_JPRB, &
  & 0.91376641E-07_JPRB, 0.91519986E-07_JPRB, 0.91652602E-07_JPRB, 0.91766864E-07_JPRB, 0.91861004E-07_JPRB, 0.91938034E-07_JPRB, &
  & 0.92002580E-07_JPRB, 0.92059651E-07_JPRB, 0.92114718E-07_JPRB, 0.92176371E-07_JPRB, 0.92239134E-07_JPRB, 0.92303367E-07_JPRB, &
  & 0.92368445E-07_JPRB, 0.92434057E-07_JPRB, 0.92499519E-07_JPRB, 0.92564662E-07_JPRB, 0.92630259E-07_JPRB, 0.92697753E-07_JPRB, &
  & 0.92768367E-07_JPRB, 0.92841752E-07_JPRB, 0.92919706E-07_JPRB, 0.92999713E-07_JPRB, 0.93077247E-07_JPRB, 0.93148806E-07_JPRB, &
  & 0.93209948E-07_JPRB, 0.93255757E-07_JPRB, 0.93284747E-07_JPRB, 0.93296158E-07_JPRB, 0.93290822E-07_JPRB, 0.93272469E-07_JPRB, &
  & 0.93249113E-07_JPRB, 0.93232423E-07_JPRB, 0.93234377E-07_JPRB, 0.93263353E-07_JPRB, 0.93321255E-07_JPRB, 0.93401894E-07_JPRB, &
  & 0.93492588E-07_JPRB, 0.93579843E-07_JPRB, 0.93654990E-07_JPRB, 0.93715286E-07_JPRB, 0.93762040E-07_JPRB, 0.93797283E-07_JPRB, &
  & 0.93824866E-07_JPRB, 0.93845046E-07_JPRB, 0.93859938E-07_JPRB, 0.93869225E-07_JPRB /)

RGHG3(:, 2,12) = (/ &
  & 0.91402107E-07_JPRB, 0.91142134E-07_JPRB, 0.90830980E-07_JPRB, 0.90735782E-07_JPRB, 0.90686143E-07_JPRB, 0.90685930E-07_JPRB, &
  & 0.90707239E-07_JPRB, 0.90743157E-07_JPRB, 0.90790593E-07_JPRB, 0.90850811E-07_JPRB, 0.90924587E-07_JPRB, 0.91023281E-07_JPRB, &
  & 0.91152721E-07_JPRB, 0.91327934E-07_JPRB, 0.91560196E-07_JPRB, 0.91856499E-07_JPRB, 0.92199031E-07_JPRB, 0.92556803E-07_JPRB, &
  & 0.92895036E-07_JPRB, 0.93186756E-07_JPRB, 0.93415665E-07_JPRB, 0.93579068E-07_JPRB, 0.93685692E-07_JPRB, 0.93749733E-07_JPRB, &
  & 0.93785104E-07_JPRB, 0.93802932E-07_JPRB, 0.93811977E-07_JPRB, 0.93819239E-07_JPRB, 0.93829115E-07_JPRB, 0.93842985E-07_JPRB, &
  & 0.93859668E-07_JPRB, 0.93877631E-07_JPRB, 0.93896077E-07_JPRB, 0.93915823E-07_JPRB, 0.93940393E-07_JPRB, 0.93974016E-07_JPRB, &
  & 0.94020024E-07_JPRB, 0.94079986E-07_JPRB, 0.94151865E-07_JPRB, 0.94223701E-07_JPRB, 0.94281198E-07_JPRB, 0.94312234E-07_JPRB, &
  & 0.94312227E-07_JPRB, 0.94280864E-07_JPRB, 0.94220930E-07_JPRB, 0.94141349E-07_JPRB, 0.94058748E-07_JPRB, 0.93993648E-07_JPRB, &
  & 0.93957766E-07_JPRB, 0.93943882E-07_JPRB, 0.93932286E-07_JPRB, 0.93911147E-07_JPRB, 0.93886342E-07_JPRB, 0.93870128E-07_JPRB, &
  & 0.93867797E-07_JPRB, 0.93877887E-07_JPRB, 0.93897064E-07_JPRB, 0.93921045E-07_JPRB, 0.93946397E-07_JPRB, 0.93970357E-07_JPRB, &
  & 0.93992170E-07_JPRB, 0.94010531E-07_JPRB, 0.94027072E-07_JPRB, 0.94042704E-07_JPRB /)

RGHG3(:, 3,12) = (/ &
  & 0.91632899E-07_JPRB, 0.91149516E-07_JPRB, 0.90946926E-07_JPRB, 0.90860979E-07_JPRB, 0.90840786E-07_JPRB, 0.90864539E-07_JPRB, &
  & 0.90919045E-07_JPRB, 0.90997531E-07_JPRB, 0.91098649E-07_JPRB, 0.91212264E-07_JPRB, 0.91356455E-07_JPRB, 0.91541722E-07_JPRB, &
  & 0.91800629E-07_JPRB, 0.92141697E-07_JPRB, 0.92569536E-07_JPRB, 0.93059811E-07_JPRB, 0.93577306E-07_JPRB, 0.94072988E-07_JPRB, &
  & 0.94514746E-07_JPRB, 0.94884726E-07_JPRB, 0.95171885E-07_JPRB, 0.95376919E-07_JPRB, 0.95510984E-07_JPRB, 0.95592490E-07_JPRB, &
  & 0.95639024E-07_JPRB, 0.95664845E-07_JPRB, 0.95680136E-07_JPRB, 0.95691455E-07_JPRB, 0.95703314E-07_JPRB, 0.95715514E-07_JPRB, &
  & 0.95725802E-07_JPRB, 0.95732240E-07_JPRB, 0.95734748E-07_JPRB, 0.95736056E-07_JPRB, 0.95743083E-07_JPRB, 0.95762005E-07_JPRB, &
  & 0.95796096E-07_JPRB, 0.95842822E-07_JPRB, 0.95890933E-07_JPRB, 0.95923689E-07_JPRB, 0.95927518E-07_JPRB, 0.95896269E-07_JPRB, &
  & 0.95831076E-07_JPRB, 0.95734208E-07_JPRB, 0.95608257E-07_JPRB, 0.95455590E-07_JPRB, 0.95278722E-07_JPRB, 0.95079926E-07_JPRB, &
  & 0.94862827E-07_JPRB, 0.94642019E-07_JPRB, 0.94448659E-07_JPRB, 0.94310778E-07_JPRB, 0.94227929E-07_JPRB, 0.94181729E-07_JPRB, &
  & 0.94161386E-07_JPRB, 0.94163312E-07_JPRB, 0.94181843E-07_JPRB, 0.94209817E-07_JPRB, 0.94244015E-07_JPRB, 0.94282328E-07_JPRB, &
  & 0.94323781E-07_JPRB, 0.94364765E-07_JPRB, 0.94413075E-07_JPRB, 0.94484747E-07_JPRB /)

RGHG3(:, 4,12) = (/ &
  & 0.91961070E-07_JPRB, 0.91521294E-07_JPRB, 0.91346152E-07_JPRB, 0.91257881E-07_JPRB, 0.91234313E-07_JPRB, 0.91257562E-07_JPRB, &
  & 0.91317631E-07_JPRB, 0.91412176E-07_JPRB, 0.91553844E-07_JPRB, 0.91740702E-07_JPRB, 0.91969454E-07_JPRB, 0.92278945E-07_JPRB, &
  & 0.92678810E-07_JPRB, 0.93180702E-07_JPRB, 0.93748682E-07_JPRB, 0.94347961E-07_JPRB, 0.94936681E-07_JPRB, 0.95488247E-07_JPRB, &
  & 0.95980376E-07_JPRB, 0.96398445E-07_JPRB, 0.96734674E-07_JPRB, 0.96985801E-07_JPRB, 0.97159187E-07_JPRB, 0.97270316E-07_JPRB, &
  & 0.97335509E-07_JPRB, 0.97370162E-07_JPRB, 0.97386248E-07_JPRB, 0.97392153E-07_JPRB, 0.97393709E-07_JPRB, 0.97390199E-07_JPRB, &
  & 0.97378717E-07_JPRB, 0.97357017E-07_JPRB, 0.97326463E-07_JPRB, 0.97294119E-07_JPRB, 0.97272434E-07_JPRB, 0.97271048E-07_JPRB, &
  & 0.97292777E-07_JPRB, 0.97328865E-07_JPRB, 0.97358765E-07_JPRB, 0.97354707E-07_JPRB, 0.97294603E-07_JPRB, 0.97173583E-07_JPRB, &
  & 0.97002257E-07_JPRB, 0.96793606E-07_JPRB, 0.96561408E-07_JPRB, 0.96321060E-07_JPRB, 0.96084221E-07_JPRB, 0.95854290E-07_JPRB, &
  & 0.95629346E-07_JPRB, 0.95412005E-07_JPRB, 0.95205351E-07_JPRB, 0.95006357E-07_JPRB, 0.94822923E-07_JPRB, 0.94677844E-07_JPRB, &
  & 0.94585218E-07_JPRB, 0.94545321E-07_JPRB, 0.94551311E-07_JPRB, 0.94592878E-07_JPRB, 0.94663164E-07_JPRB, 0.94751897E-07_JPRB, &
  & 0.94858279E-07_JPRB, 0.94970773E-07_JPRB, 0.95105371E-07_JPRB, 0.95301395E-07_JPRB /)

RGHG3(:, 5,12) = (/ &
  & 0.92530769E-07_JPRB, 0.92087724E-07_JPRB, 0.91900262E-07_JPRB, 0.91810563E-07_JPRB, 0.91777189E-07_JPRB, 0.91793801E-07_JPRB, &
  & 0.91863313E-07_JPRB, 0.91992391E-07_JPRB, 0.92197197E-07_JPRB, 0.92486033E-07_JPRB, 0.92878231E-07_JPRB, 0.93359787E-07_JPRB, &
  & 0.93930197E-07_JPRB, 0.94568883E-07_JPRB, 0.95244062E-07_JPRB, 0.95931931E-07_JPRB, 0.96605234E-07_JPRB, 0.97234086E-07_JPRB, &
  & 0.97803323E-07_JPRB, 0.98298862E-07_JPRB, 0.98705073E-07_JPRB, 0.99022472E-07_JPRB, 0.99257839E-07_JPRB, 0.99430125E-07_JPRB, &
  & 0.99557013E-07_JPRB, 0.99655345E-07_JPRB, 0.99736042E-07_JPRB, 0.99805298E-07_JPRB, 0.99865360E-07_JPRB, 0.99911176E-07_JPRB, &
  & 0.99940614E-07_JPRB, 0.99956544E-07_JPRB, 0.99969704E-07_JPRB, 0.10000014E-06_JPRB, 0.10007535E-06_JPRB, 0.10021550E-06_JPRB, &
  & 0.10041857E-06_JPRB, 0.10064560E-06_JPRB, 0.10081565E-06_JPRB, 0.10083215E-06_JPRB, 0.10063363E-06_JPRB, 0.10022801E-06_JPRB, &
  & 0.99683049E-07_JPRB, 0.99073311E-07_JPRB, 0.98467723E-07_JPRB, 0.97916455E-07_JPRB, 0.97438743E-07_JPRB, 0.97019161E-07_JPRB, &
  & 0.96635318E-07_JPRB, 0.96282889E-07_JPRB, 0.95964310E-07_JPRB, 0.95683291E-07_JPRB, 0.95445522E-07_JPRB, 0.95251764E-07_JPRB, &
  & 0.95107900E-07_JPRB, 0.95027119E-07_JPRB, 0.95014215E-07_JPRB, 0.95066966E-07_JPRB, 0.95178258E-07_JPRB, 0.95329618E-07_JPRB, &
  & 0.95500511E-07_JPRB, 0.95673400E-07_JPRB, 0.95869034E-07_JPRB, 0.96140091E-07_JPRB /)

RGHG3(:, 6,12) = (/ &
  & 0.93571039E-07_JPRB, 0.93091160E-07_JPRB, 0.92901807E-07_JPRB, 0.92787914E-07_JPRB, 0.92738958E-07_JPRB, 0.92757624E-07_JPRB, &
  & 0.92856439E-07_JPRB, 0.93052655E-07_JPRB, 0.93373302E-07_JPRB, 0.93797688E-07_JPRB, 0.94332691E-07_JPRB, 0.94978049E-07_JPRB, &
  & 0.95701246E-07_JPRB, 0.96465051E-07_JPRB, 0.97242477E-07_JPRB, 0.98022298E-07_JPRB, 0.98798907E-07_JPRB, 0.99545581E-07_JPRB, &
  & 0.10025073E-06_JPRB, 0.10090709E-06_JPRB, 0.10150212E-06_JPRB, 0.10202300E-06_JPRB, 0.10247074E-06_JPRB, 0.10284747E-06_JPRB, &
  & 0.10316204E-06_JPRB, 0.10342873E-06_JPRB, 0.10366440E-06_JPRB, 0.10388631E-06_JPRB, 0.10410757E-06_JPRB, 0.10433049E-06_JPRB, &
  & 0.10455578E-06_JPRB, 0.10478450E-06_JPRB, 0.10502642E-06_JPRB, 0.10530059E-06_JPRB, 0.10563366E-06_JPRB, 0.10603482E-06_JPRB, &
  & 0.10648041E-06_JPRB, 0.10688329E-06_JPRB, 0.10709403E-06_JPRB, 0.10695134E-06_JPRB, 0.10638877E-06_JPRB, 0.10549390E-06_JPRB, &
  & 0.10443025E-06_JPRB, 0.10333653E-06_JPRB, 0.10229231E-06_JPRB, 0.10132547E-06_JPRB, 0.10042245E-06_JPRB, 0.99563408E-07_JPRB, &
  & 0.98763863E-07_JPRB, 0.98048091E-07_JPRB, 0.97419154E-07_JPRB, 0.96877436E-07_JPRB, 0.96424401E-07_JPRB, 0.96064994E-07_JPRB, &
  & 0.95805305E-07_JPRB, 0.95649114E-07_JPRB, 0.95590245E-07_JPRB, 0.95626923E-07_JPRB, 0.95745278E-07_JPRB, 0.95917223E-07_JPRB, &
  & 0.96115016E-07_JPRB, 0.96323156E-07_JPRB, 0.96552881E-07_JPRB, 0.96915848E-07_JPRB /)

RGHG3(:, 7,12) = (/ &
  & 0.95368108E-07_JPRB, 0.94813899E-07_JPRB, 0.94572371E-07_JPRB, 0.94442825E-07_JPRB, 0.94399859E-07_JPRB, 0.94444680E-07_JPRB, &
  & 0.94595109E-07_JPRB, 0.94881820E-07_JPRB, 0.95342209E-07_JPRB, 0.95952586E-07_JPRB, 0.96669140E-07_JPRB, 0.97473830E-07_JPRB, &
  & 0.98358832E-07_JPRB, 0.99309148E-07_JPRB, 0.10029299E-06_JPRB, 0.10127386E-06_JPRB, 0.10223373E-06_JPRB, 0.10316552E-06_JPRB, &
  & 0.10405905E-06_JPRB, 0.10490861E-06_JPRB, 0.10571321E-06_JPRB, 0.10646414E-06_JPRB, 0.10715383E-06_JPRB, 0.10777786E-06_JPRB, &
  & 0.10833166E-06_JPRB, 0.10882554E-06_JPRB, 0.10928100E-06_JPRB, 0.10972916E-06_JPRB, 0.11019776E-06_JPRB, 0.11070237E-06_JPRB, &
  & 0.11124808E-06_JPRB, 0.11183082E-06_JPRB, 0.11244037E-06_JPRB, 0.11306648E-06_JPRB, 0.11369549E-06_JPRB, 0.11429515E-06_JPRB, &
  & 0.11480273E-06_JPRB, 0.11510175E-06_JPRB, 0.11501383E-06_JPRB, 0.11436335E-06_JPRB, 0.11313226E-06_JPRB, 0.11152513E-06_JPRB, &
  & 0.10983326E-06_JPRB, 0.10824216E-06_JPRB, 0.10681111E-06_JPRB, 0.10551202E-06_JPRB, 0.10428789E-06_JPRB, 0.10311979E-06_JPRB, &
  & 0.10200662E-06_JPRB, 0.10093029E-06_JPRB, 0.99902451E-07_JPRB, 0.98962651E-07_JPRB, 0.98147623E-07_JPRB, 0.97480893E-07_JPRB, &
  & 0.96977978E-07_JPRB, 0.96643106E-07_JPRB, 0.96469726E-07_JPRB, 0.96448566E-07_JPRB, 0.96557287E-07_JPRB, 0.96755279E-07_JPRB, &
  & 0.96995755E-07_JPRB, 0.97267360E-07_JPRB, 0.97579303E-07_JPRB, 0.98100799E-07_JPRB /)

RGHG3(:, 8,12) = (/ &
  & 0.98662277E-07_JPRB, 0.97891458E-07_JPRB, 0.97573547E-07_JPRB, 0.97421776E-07_JPRB, 0.97392416E-07_JPRB, 0.97483017E-07_JPRB, &
  & 0.97708885E-07_JPRB, 0.98097509E-07_JPRB, 0.98703666E-07_JPRB, 0.99499751E-07_JPRB, 0.10046497E-06_JPRB, 0.10156272E-06_JPRB, &
  & 0.10274051E-06_JPRB, 0.10397265E-06_JPRB, 0.10524724E-06_JPRB, 0.10655432E-06_JPRB, 0.10786811E-06_JPRB, 0.10916790E-06_JPRB, &
  & 0.11045094E-06_JPRB, 0.11169897E-06_JPRB, 0.11290778E-06_JPRB, 0.11405346E-06_JPRB, 0.11511908E-06_JPRB, 0.11607433E-06_JPRB, &
  & 0.11691267E-06_JPRB, 0.11762960E-06_JPRB, 0.11825887E-06_JPRB, 0.11885164E-06_JPRB, 0.11945963E-06_JPRB, 0.12011598E-06_JPRB, &
  & 0.12082889E-06_JPRB, 0.12157497E-06_JPRB, 0.12230649E-06_JPRB, 0.12296431E-06_JPRB, 0.12348907E-06_JPRB, 0.12382417E-06_JPRB, &
  & 0.12391554E-06_JPRB, 0.12367815E-06_JPRB, 0.12296225E-06_JPRB, 0.12160211E-06_JPRB, 0.11961524E-06_JPRB, 0.11732543E-06_JPRB, &
  & 0.11512066E-06_JPRB, 0.11317305E-06_JPRB, 0.11146721E-06_JPRB, 0.10991792E-06_JPRB, 0.10847585E-06_JPRB, 0.10710879E-06_JPRB, &
  & 0.10575495E-06_JPRB, 0.10439571E-06_JPRB, 0.10306020E-06_JPRB, 0.10178494E-06_JPRB, 0.10061569E-06_JPRB, 0.99611761E-07_JPRB, &
  & 0.98816919E-07_JPRB, 0.98262468E-07_JPRB, 0.97954953E-07_JPRB, 0.97886470E-07_JPRB, 0.98018759E-07_JPRB, 0.98286961E-07_JPRB, &
  & 0.98625570E-07_JPRB, 0.98990967E-07_JPRB, 0.99368499E-07_JPRB, 0.99949006E-07_JPRB /)

RGHG3(:, 9,12) = (/ &
  & 0.10438261E-06_JPRB, 0.10314593E-06_JPRB, 0.10257504E-06_JPRB, 0.10231223E-06_JPRB, 0.10224572E-06_JPRB, 0.10236184E-06_JPRB, &
  & 0.10266944E-06_JPRB, 0.10319111E-06_JPRB, 0.10396866E-06_JPRB, 0.10496989E-06_JPRB, 0.10617057E-06_JPRB, 0.10755832E-06_JPRB, &
  & 0.10911398E-06_JPRB, 0.11077831E-06_JPRB, 0.11250578E-06_JPRB, 0.11427858E-06_JPRB, 0.11610030E-06_JPRB, 0.11795693E-06_JPRB, &
  & 0.11985396E-06_JPRB, 0.12175337E-06_JPRB, 0.12362815E-06_JPRB, 0.12543367E-06_JPRB, 0.12710325E-06_JPRB, 0.12856768E-06_JPRB, &
  & 0.12978499E-06_JPRB, 0.13074779E-06_JPRB, 0.13149494E-06_JPRB, 0.13210976E-06_JPRB, 0.13266983E-06_JPRB, 0.13322507E-06_JPRB, &
  & 0.13377746E-06_JPRB, 0.13428203E-06_JPRB, 0.13466337E-06_JPRB, 0.13484059E-06_JPRB, 0.13475629E-06_JPRB, 0.13437555E-06_JPRB, &
  & 0.13366885E-06_JPRB, 0.13259769E-06_JPRB, 0.13105347E-06_JPRB, 0.12892470E-06_JPRB, 0.12622900E-06_JPRB, 0.12332011E-06_JPRB, &
  & 0.12062215E-06_JPRB, 0.11828711E-06_JPRB, 0.11626766E-06_JPRB, 0.11449889E-06_JPRB, 0.11290351E-06_JPRB, 0.11136323E-06_JPRB, &
  & 0.10981957E-06_JPRB, 0.10826628E-06_JPRB, 0.10670032E-06_JPRB, 0.10515859E-06_JPRB, 0.10371809E-06_JPRB, 0.10245558E-06_JPRB, &
  & 0.10144875E-06_JPRB, 0.10075244E-06_JPRB, 0.10039134E-06_JPRB, 0.10034605E-06_JPRB, 0.10055126E-06_JPRB, 0.10091145E-06_JPRB, &
  & 0.10133526E-06_JPRB, 0.10174138E-06_JPRB, 0.10219168E-06_JPRB, 0.10274911E-06_JPRB /)

RGHG3(:,10,12) = (/ &
  & 0.11385435E-06_JPRB, 0.11155485E-06_JPRB, 0.11041535E-06_JPRB, 0.10988290E-06_JPRB, 0.10966448E-06_JPRB, 0.10972027E-06_JPRB, &
  & 0.11005117E-06_JPRB, 0.11067903E-06_JPRB, 0.11164902E-06_JPRB, 0.11293051E-06_JPRB, 0.11449103E-06_JPRB, 0.11631399E-06_JPRB, &
  & 0.11835821E-06_JPRB, 0.12060673E-06_JPRB, 0.12302142E-06_JPRB, 0.12557147E-06_JPRB, 0.12822900E-06_JPRB, 0.13094970E-06_JPRB, &
  & 0.13372791E-06_JPRB, 0.13651747E-06_JPRB, 0.13924993E-06_JPRB, 0.14182741E-06_JPRB, 0.14418404E-06_JPRB, 0.14619394E-06_JPRB, &
  & 0.14778885E-06_JPRB, 0.14895434E-06_JPRB, 0.14971511E-06_JPRB, 0.15015982E-06_JPRB, 0.15036771E-06_JPRB, 0.15039443E-06_JPRB, &
  & 0.15024756E-06_JPRB, 0.14988586E-06_JPRB, 0.14924571E-06_JPRB, 0.14827312E-06_JPRB, 0.14696771E-06_JPRB, 0.14540478E-06_JPRB, &
  & 0.14364147E-06_JPRB, 0.14165857E-06_JPRB, 0.13942224E-06_JPRB, 0.13678168E-06_JPRB, 0.13366852E-06_JPRB, 0.13029822E-06_JPRB, &
  & 0.12712560E-06_JPRB, 0.12439662E-06_JPRB, 0.12213226E-06_JPRB, 0.12018563E-06_JPRB, 0.11837652E-06_JPRB, 0.11661554E-06_JPRB, &
  & 0.11486027E-06_JPRB, 0.11306324E-06_JPRB, 0.11123996E-06_JPRB, 0.10945723E-06_JPRB, 0.10779878E-06_JPRB, 0.10637108E-06_JPRB, &
  & 0.10527188E-06_JPRB, 0.10456473E-06_JPRB, 0.10425526E-06_JPRB, 0.10428936E-06_JPRB, 0.10456549E-06_JPRB, 0.10496513E-06_JPRB, &
  & 0.10537521E-06_JPRB, 0.10577880E-06_JPRB, 0.10608932E-06_JPRB, 0.10654232E-06_JPRB /)

RGHG3(:,11,12) = (/ &
  & 0.12695595E-06_JPRB, 0.12354418E-06_JPRB, 0.12181609E-06_JPRB, 0.12094760E-06_JPRB, 0.12052102E-06_JPRB, 0.12046758E-06_JPRB, &
  & 0.12077686E-06_JPRB, 0.12147287E-06_JPRB, 0.12260924E-06_JPRB, 0.12415191E-06_JPRB, 0.12606814E-06_JPRB, 0.12834064E-06_JPRB, &
  & 0.13093899E-06_JPRB, 0.13381886E-06_JPRB, 0.13693322E-06_JPRB, 0.14024576E-06_JPRB, 0.14374049E-06_JPRB, 0.14735201E-06_JPRB, &
  & 0.15101729E-06_JPRB, 0.15466426E-06_JPRB, 0.15821225E-06_JPRB, 0.16150649E-06_JPRB, 0.16441993E-06_JPRB, 0.16687700E-06_JPRB, &
  & 0.16874080E-06_JPRB, 0.16998420E-06_JPRB, 0.17061602E-06_JPRB, 0.17067119E-06_JPRB, 0.17022290E-06_JPRB, 0.16931864E-06_JPRB, &
  & 0.16800485E-06_JPRB, 0.16629781E-06_JPRB, 0.16421895E-06_JPRB, 0.16182629E-06_JPRB, 0.15924024E-06_JPRB, 0.15657804E-06_JPRB, &
  & 0.15397859E-06_JPRB, 0.15142567E-06_JPRB, 0.14872916E-06_JPRB, 0.14585216E-06_JPRB, 0.14277565E-06_JPRB, 0.13960138E-06_JPRB, &
  & 0.13652769E-06_JPRB, 0.13375131E-06_JPRB, 0.13123584E-06_JPRB, 0.12891178E-06_JPRB, 0.12671528E-06_JPRB, 0.12456813E-06_JPRB, &
  & 0.12238506E-06_JPRB, 0.12015985E-06_JPRB, 0.11794346E-06_JPRB, 0.11581139E-06_JPRB, 0.11387985E-06_JPRB, 0.11228177E-06_JPRB, &
  & 0.11110957E-06_JPRB, 0.11039830E-06_JPRB, 0.11010533E-06_JPRB, 0.11013428E-06_JPRB, 0.11036622E-06_JPRB, 0.11068508E-06_JPRB, &
  & 0.11101511E-06_JPRB, 0.11127147E-06_JPRB, 0.11154076E-06_JPRB, 0.11177987E-06_JPRB /)

RGHG3(:,12,12) = (/ &
  & 0.14148490E-06_JPRB, 0.13759292E-06_JPRB, 0.13578278E-06_JPRB, 0.13481727E-06_JPRB, 0.13434268E-06_JPRB, 0.13426994E-06_JPRB, &
  & 0.13458822E-06_JPRB, 0.13532703E-06_JPRB, 0.13655958E-06_JPRB, 0.13828497E-06_JPRB, 0.14048170E-06_JPRB, 0.14311384E-06_JPRB, &
  & 0.14613822E-06_JPRB, 0.14953393E-06_JPRB, 0.15327082E-06_JPRB, 0.15728251E-06_JPRB, 0.16150159E-06_JPRB, 0.16584889E-06_JPRB, &
  & 0.17020987E-06_JPRB, 0.17446206E-06_JPRB, 0.17851818E-06_JPRB, 0.18224227E-06_JPRB, 0.18544199E-06_JPRB, 0.18805788E-06_JPRB, &
  & 0.18997797E-06_JPRB, 0.19109028E-06_JPRB, 0.19140265E-06_JPRB, 0.19087946E-06_JPRB, 0.18958066E-06_JPRB, 0.18756545E-06_JPRB, &
  & 0.18492885E-06_JPRB, 0.18179500E-06_JPRB, 0.17830916E-06_JPRB, 0.17467462E-06_JPRB, 0.17112956E-06_JPRB, 0.16791152E-06_JPRB, &
  & 0.16500655E-06_JPRB, 0.16242564E-06_JPRB, 0.16017644E-06_JPRB, 0.15803425E-06_JPRB, 0.15587175E-06_JPRB, 0.15360781E-06_JPRB, &
  & 0.15122563E-06_JPRB, 0.14872572E-06_JPRB, 0.14616285E-06_JPRB, 0.14352941E-06_JPRB, 0.14078149E-06_JPRB, 0.13789806E-06_JPRB, &
  & 0.13489566E-06_JPRB, 0.13184172E-06_JPRB, 0.12882033E-06_JPRB, 0.12595849E-06_JPRB, 0.12342883E-06_JPRB, 0.12136213E-06_JPRB, &
  & 0.11984102E-06_JPRB, 0.11885321E-06_JPRB, 0.11831855E-06_JPRB, 0.11811844E-06_JPRB, 0.11813171E-06_JPRB, 0.11824817E-06_JPRB, &
  & 0.11837379E-06_JPRB, 0.11846875E-06_JPRB, 0.11847962E-06_JPRB, 0.11826534E-06_JPRB /)

RGHG3(:,13,12) = (/ &
  & 0.15592570E-06_JPRB, 0.15207766E-06_JPRB, 0.15052181E-06_JPRB, 0.14972261E-06_JPRB, 0.14942864E-06_JPRB, 0.14955241E-06_JPRB, &
  & 0.15006529E-06_JPRB, 0.15099030E-06_JPRB, 0.15239112E-06_JPRB, 0.15429077E-06_JPRB, 0.15670128E-06_JPRB, 0.15963121E-06_JPRB, &
  & 0.16303150E-06_JPRB, 0.16683671E-06_JPRB, 0.17098824E-06_JPRB, 0.17542672E-06_JPRB, 0.18006595E-06_JPRB, 0.18479787E-06_JPRB, &
  & 0.18948985E-06_JPRB, 0.19397766E-06_JPRB, 0.19815133E-06_JPRB, 0.20191983E-06_JPRB, 0.20508273E-06_JPRB, 0.20755968E-06_JPRB, &
  & 0.20927214E-06_JPRB, 0.21005688E-06_JPRB, 0.20989393E-06_JPRB, 0.20871990E-06_JPRB, 0.20656951E-06_JPRB, 0.20355253E-06_JPRB, &
  & 0.19984495E-06_JPRB, 0.19566700E-06_JPRB, 0.19132827E-06_JPRB, 0.18715691E-06_JPRB, 0.18349438E-06_JPRB, 0.18044435E-06_JPRB, &
  & 0.17817395E-06_JPRB, 0.17645733E-06_JPRB, 0.17504244E-06_JPRB, 0.17388889E-06_JPRB, 0.17289284E-06_JPRB, 0.17190271E-06_JPRB, &
  & 0.17073178E-06_JPRB, 0.16916950E-06_JPRB, 0.16708691E-06_JPRB, 0.16447078E-06_JPRB, 0.16136448E-06_JPRB, 0.15783486E-06_JPRB, &
  & 0.15394346E-06_JPRB, 0.14981332E-06_JPRB, 0.14561007E-06_JPRB, 0.14157528E-06_JPRB, 0.13792901E-06_JPRB, 0.13487652E-06_JPRB, &
  & 0.13250822E-06_JPRB, 0.13081728E-06_JPRB, 0.12969896E-06_JPRB, 0.12901944E-06_JPRB, 0.12864038E-06_JPRB, 0.12844066E-06_JPRB, &
  & 0.12831653E-06_JPRB, 0.12820431E-06_JPRB, 0.12801068E-06_JPRB, 0.12761622E-06_JPRB /)

RGHG3(:,14,12) = (/ &
  & 0.16932037E-06_JPRB, 0.16609967E-06_JPRB, 0.16494992E-06_JPRB, 0.16454970E-06_JPRB, 0.16464934E-06_JPRB, 0.16514997E-06_JPRB, &
  & 0.16602050E-06_JPRB, 0.16728103E-06_JPRB, 0.16899719E-06_JPRB, 0.17117711E-06_JPRB, 0.17382963E-06_JPRB, 0.17695452E-06_JPRB, &
  & 0.18054081E-06_JPRB, 0.18453653E-06_JPRB, 0.18886104E-06_JPRB, 0.19342205E-06_JPRB, 0.19812131E-06_JPRB, 0.20285559E-06_JPRB, &
  & 0.20748872E-06_JPRB, 0.21184511E-06_JPRB, 0.21580824E-06_JPRB, 0.21930482E-06_JPRB, 0.22215238E-06_JPRB, 0.22427419E-06_JPRB, &
  & 0.22558847E-06_JPRB, 0.22592715E-06_JPRB, 0.22524381E-06_JPRB, 0.22347641E-06_JPRB, 0.22066934E-06_JPRB, 0.21696692E-06_JPRB, &
  & 0.21261620E-06_JPRB, 0.20800412E-06_JPRB, 0.20352600E-06_JPRB, 0.19957754E-06_JPRB, 0.19648667E-06_JPRB, 0.19450862E-06_JPRB, &
  & 0.19320183E-06_JPRB, 0.19243015E-06_JPRB, 0.19207967E-06_JPRB, 0.19194539E-06_JPRB, 0.19187615E-06_JPRB, 0.19171941E-06_JPRB, &
  & 0.19128569E-06_JPRB, 0.19038369E-06_JPRB, 0.18886890E-06_JPRB, 0.18667764E-06_JPRB, 0.18380692E-06_JPRB, 0.18030232E-06_JPRB, &
  & 0.17622112E-06_JPRB, 0.17169765E-06_JPRB, 0.16690967E-06_JPRB, 0.16208341E-06_JPRB, 0.15749612E-06_JPRB, 0.15340316E-06_JPRB, &
  & 0.14997987E-06_JPRB, 0.14727378E-06_JPRB, 0.14523036E-06_JPRB, 0.14373124E-06_JPRB, 0.14265353E-06_JPRB, 0.14187809E-06_JPRB, &
  & 0.14129472E-06_JPRB, 0.14078810E-06_JPRB, 0.14023834E-06_JPRB, 0.13911669E-06_JPRB /)

RGHG3(:,15,12) = (/ &
  & 0.18142103E-06_JPRB, 0.17919348E-06_JPRB, 0.17869888E-06_JPRB, 0.17886194E-06_JPRB, 0.17946651E-06_JPRB, 0.18042823E-06_JPRB, &
  & 0.18171542E-06_JPRB, 0.18334616E-06_JPRB, 0.18537889E-06_JPRB, 0.18784357E-06_JPRB, 0.19073687E-06_JPRB, 0.19403318E-06_JPRB, &
  & 0.19769710E-06_JPRB, 0.20168621E-06_JPRB, 0.20594140E-06_JPRB, 0.21036738E-06_JPRB, 0.21485309E-06_JPRB, 0.21930013E-06_JPRB, &
  & 0.22358944E-06_JPRB, 0.22754881E-06_JPRB, 0.23108720E-06_JPRB, 0.23412628E-06_JPRB, 0.23649707E-06_JPRB, 0.23815124E-06_JPRB, &
  & 0.23898232E-06_JPRB, 0.23885065E-06_JPRB, 0.23770181E-06_JPRB, 0.23549428E-06_JPRB, 0.23228996E-06_JPRB, 0.22831212E-06_JPRB, &
  & 0.22388073E-06_JPRB, 0.21943546E-06_JPRB, 0.21540875E-06_JPRB, 0.21237891E-06_JPRB, 0.21045165E-06_JPRB, 0.20940607E-06_JPRB, &
  & 0.20923878E-06_JPRB, 0.20952163E-06_JPRB, 0.20995418E-06_JPRB, 0.21040528E-06_JPRB, 0.21076085E-06_JPRB, 0.21088601E-06_JPRB, &
  & 0.21065627E-06_JPRB, 0.20996430E-06_JPRB, 0.20872594E-06_JPRB, 0.20688790E-06_JPRB, 0.20441176E-06_JPRB, 0.20127261E-06_JPRB, &
  & 0.19749791E-06_JPRB, 0.19316457E-06_JPRB, 0.18842155E-06_JPRB, 0.18347703E-06_JPRB, 0.17856458E-06_JPRB, 0.17393543E-06_JPRB, &
  & 0.16978564E-06_JPRB, 0.16623549E-06_JPRB, 0.16330618E-06_JPRB, 0.16095184E-06_JPRB, 0.15909569E-06_JPRB, 0.15764280E-06_JPRB, &
  & 0.15653205E-06_JPRB, 0.15555335E-06_JPRB, 0.15461758E-06_JPRB, 0.15282859E-06_JPRB /)

RGHG3(:,16,12) = (/ &
  & 0.19239650E-06_JPRB, 0.19139107E-06_JPRB, 0.19156397E-06_JPRB, 0.19222591E-06_JPRB, 0.19326608E-06_JPRB, 0.19463344E-06_JPRB, &
  & 0.19630774E-06_JPRB, 0.19830870E-06_JPRB, 0.20067660E-06_JPRB, 0.20341476E-06_JPRB, 0.20651645E-06_JPRB, 0.20993950E-06_JPRB, &
  & 0.21363023E-06_JPRB, 0.21753095E-06_JPRB, 0.22158517E-06_JPRB, 0.22572011E-06_JPRB, 0.22983846E-06_JPRB, 0.23385526E-06_JPRB, &
  & 0.23766208E-06_JPRB, 0.24110341E-06_JPRB, 0.24412421E-06_JPRB, 0.24662492E-06_JPRB, 0.24846878E-06_JPRB, 0.24962046E-06_JPRB, &
  & 0.24996893E-06_JPRB, 0.24941340E-06_JPRB, 0.24791456E-06_JPRB, 0.24547248E-06_JPRB, 0.24221595E-06_JPRB, 0.23838825E-06_JPRB, &
  & 0.23439335E-06_JPRB, 0.23064801E-06_JPRB, 0.22769441E-06_JPRB, 0.22564335E-06_JPRB, 0.22478316E-06_JPRB, 0.22499120E-06_JPRB, &
  & 0.22570683E-06_JPRB, 0.22662780E-06_JPRB, 0.22752036E-06_JPRB, 0.22822007E-06_JPRB, 0.22863046E-06_JPRB, 0.22868980E-06_JPRB, &
  & 0.22835104E-06_JPRB, 0.22759194E-06_JPRB, 0.22639583E-06_JPRB, 0.22472855E-06_JPRB, 0.22254568E-06_JPRB, 0.21980081E-06_JPRB, &
  & 0.21646974E-06_JPRB, 0.21258970E-06_JPRB, 0.20826229E-06_JPRB, 0.20362847E-06_JPRB, 0.19886988E-06_JPRB, 0.19419059E-06_JPRB, &
  & 0.18978524E-06_JPRB, 0.18581653E-06_JPRB, 0.18236454E-06_JPRB, 0.17944274E-06_JPRB, 0.17702909E-06_JPRB, 0.17508057E-06_JPRB, &
  & 0.17347180E-06_JPRB, 0.17219959E-06_JPRB, 0.17072379E-06_JPRB, 0.16850925E-06_JPRB /)

RGHG3(:,17,12) = (/ &
  & 0.20232741E-06_JPRB, 0.20239109E-06_JPRB, 0.20307724E-06_JPRB, 0.20416896E-06_JPRB, 0.20560861E-06_JPRB, 0.20735122E-06_JPRB, &
  & 0.20938208E-06_JPRB, 0.21170789E-06_JPRB, 0.21437094E-06_JPRB, 0.21735755E-06_JPRB, 0.22062986E-06_JPRB, 0.22412878E-06_JPRB, &
  & 0.22779072E-06_JPRB, 0.23155803E-06_JPRB, 0.23537356E-06_JPRB, 0.23917656E-06_JPRB, 0.24289255E-06_JPRB, 0.24645436E-06_JPRB, &
  & 0.24976208E-06_JPRB, 0.25268542E-06_JPRB, 0.25518244E-06_JPRB, 0.25715235E-06_JPRB, 0.25848971E-06_JPRB, 0.25915909E-06_JPRB, &
  & 0.25907741E-06_JPRB, 0.25819338E-06_JPRB, 0.25651192E-06_JPRB, 0.25410071E-06_JPRB, 0.25111132E-06_JPRB, 0.24784680E-06_JPRB, &
  & 0.24468551E-06_JPRB, 0.24197337E-06_JPRB, 0.24005965E-06_JPRB, 0.23927265E-06_JPRB, 0.23942394E-06_JPRB, 0.24029137E-06_JPRB, &
  & 0.24157103E-06_JPRB, 0.24286237E-06_JPRB, 0.24389408E-06_JPRB, 0.24454812E-06_JPRB, 0.24478987E-06_JPRB, 0.24460849E-06_JPRB, &
  & 0.24403536E-06_JPRB, 0.24310563E-06_JPRB, 0.24183240E-06_JPRB, 0.24021188E-06_JPRB, 0.23820751E-06_JPRB, 0.23576527E-06_JPRB, &
  & 0.23284460E-06_JPRB, 0.22945277E-06_JPRB, 0.22564825E-06_JPRB, 0.22152450E-06_JPRB, 0.21719751E-06_JPRB, 0.21282109E-06_JPRB, &
  & 0.20857654E-06_JPRB, 0.20461620E-06_JPRB, 0.20105568E-06_JPRB, 0.19794200E-06_JPRB, 0.19528468E-06_JPRB, 0.19306974E-06_JPRB, &
  & 0.19128377E-06_JPRB, 0.18969484E-06_JPRB, 0.18820216E-06_JPRB, 0.18535346E-06_JPRB /)

RGHG3(:,18,12) = (/ &
  & 0.21152020E-06_JPRB, 0.21233043E-06_JPRB, 0.21346190E-06_JPRB, 0.21490281E-06_JPRB, 0.21664192E-06_JPRB, 0.21866265E-06_JPRB, &
  & 0.22094312E-06_JPRB, 0.22350308E-06_JPRB, 0.22634950E-06_JPRB, 0.22947391E-06_JPRB, 0.23282743E-06_JPRB, 0.23633385E-06_JPRB, &
  & 0.23992158E-06_JPRB, 0.24353076E-06_JPRB, 0.24710749E-06_JPRB, 0.25059924E-06_JPRB, 0.25395178E-06_JPRB, 0.25710844E-06_JPRB, &
  & 0.25998096E-06_JPRB, 0.26246201E-06_JPRB, 0.26449624E-06_JPRB, 0.26600597E-06_JPRB, 0.26690816E-06_JPRB, 0.26716970E-06_JPRB, &
  & 0.26675841E-06_JPRB, 0.26567378E-06_JPRB, 0.26397498E-06_JPRB, 0.26179546E-06_JPRB, 0.25936905E-06_JPRB, 0.25695994E-06_JPRB, &
  & 0.25479221E-06_JPRB, 0.25329601E-06_JPRB, 0.25254758E-06_JPRB, 0.25255619E-06_JPRB, 0.25333816E-06_JPRB, 0.25462921E-06_JPRB, &
  & 0.25607915E-06_JPRB, 0.25736051E-06_JPRB, 0.25825403E-06_JPRB, 0.25868960E-06_JPRB, 0.25865285E-06_JPRB, 0.25819938E-06_JPRB, &
  & 0.25739490E-06_JPRB, 0.25629370E-06_JPRB, 0.25493708E-06_JPRB, 0.25332707E-06_JPRB, 0.25143913E-06_JPRB, 0.24922264E-06_JPRB, &
  & 0.24663916E-06_JPRB, 0.24368717E-06_JPRB, 0.24038710E-06_JPRB, 0.23677944E-06_JPRB, 0.23294882E-06_JPRB, 0.22901482E-06_JPRB, &
  & 0.22512033E-06_JPRB, 0.22142156E-06_JPRB, 0.21802798E-06_JPRB, 0.21499990E-06_JPRB, 0.21237098E-06_JPRB, 0.21014621E-06_JPRB, &
  & 0.20831872E-06_JPRB, 0.20676261E-06_JPRB, 0.20517645E-06_JPRB, 0.20240178E-06_JPRB /)

RGHG3(:,19,12) = (/ &
  & 0.21976422E-06_JPRB, 0.22132043E-06_JPRB, 0.22276654E-06_JPRB, 0.22441927E-06_JPRB, 0.22633419E-06_JPRB, 0.22850332E-06_JPRB, &
  & 0.23092915E-06_JPRB, 0.23359867E-06_JPRB, 0.23653226E-06_JPRB, 0.23970020E-06_JPRB, 0.24304831E-06_JPRB, 0.24650041E-06_JPRB, &
  & 0.24997760E-06_JPRB, 0.25342592E-06_JPRB, 0.25679222E-06_JPRB, 0.26002434E-06_JPRB, 0.26308021E-06_JPRB, 0.26591422E-06_JPRB, &
  & 0.26844862E-06_JPRB, 0.27059215E-06_JPRB, 0.27227472E-06_JPRB, 0.27343353E-06_JPRB, 0.27401214E-06_JPRB, 0.27398704E-06_JPRB, &
  & 0.27337913E-06_JPRB, 0.27224931E-06_JPRB, 0.27072673E-06_JPRB, 0.26900210E-06_JPRB, 0.26726940E-06_JPRB, 0.26575376E-06_JPRB, &
  & 0.26472668E-06_JPRB, 0.26419909E-06_JPRB, 0.26429683E-06_JPRB, 0.26496059E-06_JPRB, 0.26602822E-06_JPRB, 0.26731593E-06_JPRB, &
  & 0.26858345E-06_JPRB, 0.26958617E-06_JPRB, 0.27018018E-06_JPRB, 0.27033036E-06_JPRB, 0.27004737E-06_JPRB, 0.26938119E-06_JPRB, &
  & 0.26841832E-06_JPRB, 0.26721926E-06_JPRB, 0.26582165E-06_JPRB, 0.26424186E-06_JPRB, 0.26246005E-06_JPRB, 0.26043995E-06_JPRB, &
  & 0.25815393E-06_JPRB, 0.25558140E-06_JPRB, 0.25271453E-06_JPRB, 0.24958996E-06_JPRB, 0.24626337E-06_JPRB, 0.24281709E-06_JPRB, &
  & 0.23937625E-06_JPRB, 0.23607051E-06_JPRB, 0.23300069E-06_JPRB, 0.23023097E-06_JPRB, 0.22779417E-06_JPRB, 0.22572259E-06_JPRB, &
  & 0.22397818E-06_JPRB, 0.22256106E-06_JPRB, 0.22099731E-06_JPRB, 0.21859256E-06_JPRB /)

RGHG3(:,20,12) = (/ &
  & 0.22740919E-06_JPRB, 0.22930726E-06_JPRB, 0.23091005E-06_JPRB, 0.23267066E-06_JPRB, 0.23466727E-06_JPRB, 0.23691749E-06_JPRB, &
  & 0.23939521E-06_JPRB, 0.24210993E-06_JPRB, 0.24504556E-06_JPRB, 0.24817902E-06_JPRB, 0.25146426E-06_JPRB, 0.25481773E-06_JPRB, &
  & 0.25816485E-06_JPRB, 0.26144676E-06_JPRB, 0.26462857E-06_JPRB, 0.26765900E-06_JPRB, 0.27049001E-06_JPRB, 0.27308164E-06_JPRB, &
  & 0.27537456E-06_JPRB, 0.27728680E-06_JPRB, 0.27874137E-06_JPRB, 0.27967860E-06_JPRB, 0.28006420E-06_JPRB, 0.27990208E-06_JPRB, &
  & 0.27925336E-06_JPRB, 0.27824021E-06_JPRB, 0.27703734E-06_JPRB, 0.27581930E-06_JPRB, 0.27481462E-06_JPRB, 0.27418432E-06_JPRB, &
  & 0.27397505E-06_JPRB, 0.27423826E-06_JPRB, 0.27485970E-06_JPRB, 0.27575405E-06_JPRB, 0.27680369E-06_JPRB, 0.27785859E-06_JPRB, &
  & 0.27880714E-06_JPRB, 0.27949264E-06_JPRB, 0.27980025E-06_JPRB, 0.27967110E-06_JPRB, 0.27919540E-06_JPRB, 0.27839991E-06_JPRB, &
  & 0.27736417E-06_JPRB, 0.27613527E-06_JPRB, 0.27474741E-06_JPRB, 0.27322378E-06_JPRB, 0.27155377E-06_JPRB, 0.26972069E-06_JPRB, &
  & 0.26769197E-06_JPRB, 0.26544265E-06_JPRB, 0.26297286E-06_JPRB, 0.26030474E-06_JPRB, 0.25746763E-06_JPRB, 0.25452658E-06_JPRB, &
  & 0.25157925E-06_JPRB, 0.24872770E-06_JPRB, 0.24606248E-06_JPRB, 0.24363524E-06_JPRB, 0.24148881E-06_JPRB, 0.23964040E-06_JPRB, &
  & 0.23813537E-06_JPRB, 0.23676401E-06_JPRB, 0.23554963E-06_JPRB, 0.23304757E-06_JPRB /)

RGHG3(:,21,12) = (/ &
  & 0.23432769E-06_JPRB, 0.23646108E-06_JPRB, 0.23812302E-06_JPRB, 0.23989980E-06_JPRB, 0.24190001E-06_JPRB, 0.24413544E-06_JPRB, &
  & 0.24660392E-06_JPRB, 0.24927166E-06_JPRB, 0.25214123E-06_JPRB, 0.25518648E-06_JPRB, 0.25835126E-06_JPRB, 0.26157420E-06_JPRB, &
  & 0.26478043E-06_JPRB, 0.26790727E-06_JPRB, 0.27092125E-06_JPRB, 0.27378962E-06_JPRB, 0.27646684E-06_JPRB, 0.27889931E-06_JPRB, &
  & 0.28103457E-06_JPRB, 0.28280698E-06_JPRB, 0.28414604E-06_JPRB, 0.28499454E-06_JPRB, 0.28532895E-06_JPRB, 0.28517911E-06_JPRB, &
  & 0.28463569E-06_JPRB, 0.28384807E-06_JPRB, 0.28299831E-06_JPRB, 0.28228789E-06_JPRB, 0.28189442E-06_JPRB, 0.28188418E-06_JPRB, &
  & 0.28225043E-06_JPRB, 0.28289134E-06_JPRB, 0.28371778E-06_JPRB, 0.28461173E-06_JPRB, 0.28547009E-06_JPRB, 0.28623964E-06_JPRB, &
  & 0.28683792E-06_JPRB, 0.28717906E-06_JPRB, 0.28724600E-06_JPRB, 0.28698329E-06_JPRB, 0.28641247E-06_JPRB, 0.28557864E-06_JPRB, &
  & 0.28454173E-06_JPRB, 0.28334139E-06_JPRB, 0.28201379E-06_JPRB, 0.28056689E-06_JPRB, 0.27901956E-06_JPRB, 0.27735572E-06_JPRB, &
  & 0.27555464E-06_JPRB, 0.27360301E-06_JPRB, 0.27150159E-06_JPRB, 0.26925375E-06_JPRB, 0.26687857E-06_JPRB, 0.26442433E-06_JPRB, &
  & 0.26195525E-06_JPRB, 0.25955561E-06_JPRB, 0.25729332E-06_JPRB, 0.25522075E-06_JPRB, 0.25337405E-06_JPRB, 0.25178323E-06_JPRB, &
  & 0.25041504E-06_JPRB, 0.24931376E-06_JPRB, 0.24799485E-06_JPRB, 0.24606325E-06_JPRB /)

RGHG3(:,22,12) = (/ &
  & 0.24068075E-06_JPRB, 0.24290017E-06_JPRB, 0.24455869E-06_JPRB, 0.24629583E-06_JPRB, 0.24823009E-06_JPRB, 0.25039336E-06_JPRB, &
  & 0.25276219E-06_JPRB, 0.25533220E-06_JPRB, 0.25808100E-06_JPRB, 0.26098618E-06_JPRB, 0.26401375E-06_JPRB, 0.26708452E-06_JPRB, &
  & 0.27014428E-06_JPRB, 0.27313004E-06_JPRB, 0.27600154E-06_JPRB, 0.27872815E-06_JPRB, 0.28128130E-06_JPRB, 0.28361907E-06_JPRB, &
  & 0.28568138E-06_JPRB, 0.28740317E-06_JPRB, 0.28872134E-06_JPRB, 0.28958928E-06_JPRB, 0.28999702E-06_JPRB, 0.28998690E-06_JPRB, &
  & 0.28966369E-06_JPRB, 0.28918257E-06_JPRB, 0.28871810E-06_JPRB, 0.28844525E-06_JPRB, 0.28845321E-06_JPRB, 0.28877241E-06_JPRB, &
  & 0.28933755E-06_JPRB, 0.29007634E-06_JPRB, 0.29086689E-06_JPRB, 0.29160239E-06_JPRB, 0.29224293E-06_JPRB, 0.29275418E-06_JPRB, &
  & 0.29310937E-06_JPRB, 0.29324048E-06_JPRB, 0.29312216E-06_JPRB, 0.29272451E-06_JPRB, 0.29210656E-06_JPRB, 0.29129754E-06_JPRB, &
  & 0.29029832E-06_JPRB, 0.28916745E-06_JPRB, 0.28791317E-06_JPRB, 0.28656837E-06_JPRB, 0.28514557E-06_JPRB, 0.28364693E-06_JPRB, &
  & 0.28205866E-06_JPRB, 0.28037834E-06_JPRB, 0.27859573E-06_JPRB, 0.27671123E-06_JPRB, 0.27474016E-06_JPRB, 0.27271014E-06_JPRB, &
  & 0.27066838E-06_JPRB, 0.26866601E-06_JPRB, 0.26676062E-06_JPRB, 0.26499427E-06_JPRB, 0.26340501E-06_JPRB, 0.26201550E-06_JPRB, &
  & 0.26085397E-06_JPRB, 0.25977184E-06_JPRB, 0.25879447E-06_JPRB, 0.25678168E-06_JPRB /)

RGHG3(:,23,12) = (/ &
  & 0.24653602E-06_JPRB, 0.24871028E-06_JPRB, 0.25031966E-06_JPRB, 0.25197431E-06_JPRB, 0.25380467E-06_JPRB, 0.25584166E-06_JPRB, &
  & 0.25808379E-06_JPRB, 0.26050500E-06_JPRB, 0.26310079E-06_JPRB, 0.26585141E-06_JPRB, 0.26871476E-06_JPRB, 0.27162980E-06_JPRB, &
  & 0.27453601E-06_JPRB, 0.27738690E-06_JPRB, 0.28014244E-06_JPRB, 0.28276824E-06_JPRB, 0.28522868E-06_JPRB, 0.28748923E-06_JPRB, &
  & 0.28950831E-06_JPRB, 0.29123453E-06_JPRB, 0.29261119E-06_JPRB, 0.29359370E-06_JPRB, 0.29417205E-06_JPRB, 0.29439528E-06_JPRB, &
  & 0.29436282E-06_JPRB, 0.29420565E-06_JPRB, 0.29406178E-06_JPRB, 0.29405339E-06_JPRB, 0.29424888E-06_JPRB, 0.29465500E-06_JPRB, &
  & 0.29522823E-06_JPRB, 0.29587210E-06_JPRB, 0.29648567E-06_JPRB, 0.29702107E-06_JPRB, 0.29744740E-06_JPRB, 0.29773665E-06_JPRB, &
  & 0.29787719E-06_JPRB, 0.29784724E-06_JPRB, 0.29764556E-06_JPRB, 0.29723321E-06_JPRB, 0.29663070E-06_JPRB, 0.29586116E-06_JPRB, &
  & 0.29492850E-06_JPRB, 0.29388073E-06_JPRB, 0.29271922E-06_JPRB, 0.29147793E-06_JPRB, 0.29018298E-06_JPRB, 0.28883727E-06_JPRB, &
  & 0.28744066E-06_JPRB, 0.28598410E-06_JPRB, 0.28446524E-06_JPRB, 0.28288363E-06_JPRB, 0.28124492E-06_JPRB, 0.27956725E-06_JPRB, &
  & 0.27787280E-06_JPRB, 0.27619890E-06_JPRB, 0.27458080E-06_JPRB, 0.27305924E-06_JPRB, 0.27167027E-06_JPRB, 0.27044169E-06_JPRB, &
  & 0.26936584E-06_JPRB, 0.26845004E-06_JPRB, 0.26738027E-06_JPRB, 0.26568162E-06_JPRB /)

RGHG3(:,24,12) = (/ &
  & 0.25189976E-06_JPRB, 0.25397804E-06_JPRB, 0.25550585E-06_JPRB, 0.25705228E-06_JPRB, 0.25875244E-06_JPRB, 0.26064697E-06_JPRB, &
  & 0.26272895E-06_JPRB, 0.26499194E-06_JPRB, 0.26742276E-06_JPRB, 0.27000189E-06_JPRB, 0.27269971E-06_JPRB, 0.27545087E-06_JPRB, &
  & 0.27819814E-06_JPRB, 0.28089619E-06_JPRB, 0.28351590E-06_JPRB, 0.28603176E-06_JPRB, 0.28841717E-06_JPRB, 0.29063969E-06_JPRB, &
  & 0.29266096E-06_JPRB, 0.29443237E-06_JPRB, 0.29590294E-06_JPRB, 0.29703475E-06_JPRB, 0.29782433E-06_JPRB, 0.29831352E-06_JPRB, &
  & 0.29857449E-06_JPRB, 0.29870779E-06_JPRB, 0.29880260E-06_JPRB, 0.29894952E-06_JPRB, 0.29920145E-06_JPRB, 0.29955936E-06_JPRB, &
  & 0.29999694E-06_JPRB, 0.30044936E-06_JPRB, 0.30086272E-06_JPRB, 0.30119966E-06_JPRB, 0.30144690E-06_JPRB, 0.30157921E-06_JPRB, &
  & 0.30159541E-06_JPRB, 0.30148377E-06_JPRB, 0.30121774E-06_JPRB, 0.30079585E-06_JPRB, 0.30023290E-06_JPRB, 0.29951633E-06_JPRB, &
  & 0.29867607E-06_JPRB, 0.29771300E-06_JPRB, 0.29665796E-06_JPRB, 0.29552095E-06_JPRB, 0.29434173E-06_JPRB, 0.29312594E-06_JPRB, &
  & 0.29188351E-06_JPRB, 0.29060843E-06_JPRB, 0.28929884E-06_JPRB, 0.28795600E-06_JPRB, 0.28657888E-06_JPRB, 0.28517559E-06_JPRB, &
  & 0.28375811E-06_JPRB, 0.28234174E-06_JPRB, 0.28095658E-06_JPRB, 0.27962778E-06_JPRB, 0.27839201E-06_JPRB, 0.27727566E-06_JPRB, &
  & 0.27629480E-06_JPRB, 0.27538391E-06_JPRB, 0.27446632E-06_JPRB, 0.27277400E-06_JPRB /)

RGHG3(:,25,12) = (/ &
  & 0.25684236E-06_JPRB, 0.25881428E-06_JPRB, 0.26023196E-06_JPRB, 0.26165287E-06_JPRB, 0.26321146E-06_JPRB, 0.26494683E-06_JPRB, &
  & 0.26686888E-06_JPRB, 0.26896473E-06_JPRB, 0.27122488E-06_JPRB, 0.27363345E-06_JPRB, 0.27615496E-06_JPRB, 0.27874009E-06_JPRB, &
  & 0.28133502E-06_JPRB, 0.28389871E-06_JPRB, 0.28640133E-06_JPRB, 0.28881209E-06_JPRB, 0.29111328E-06_JPRB, 0.29327933E-06_JPRB, &
  & 0.29527558E-06_JPRB, 0.29706828E-06_JPRB, 0.29862008E-06_JPRB, 0.29989729E-06_JPRB, 0.30088694E-06_JPRB, 0.30161064E-06_JPRB, &
  & 0.30211672E-06_JPRB, 0.30247085E-06_JPRB, 0.30274015E-06_JPRB, 0.30297849E-06_JPRB, 0.30321868E-06_JPRB, 0.30348227E-06_JPRB, &
  & 0.30376108E-06_JPRB, 0.30403308E-06_JPRB, 0.30426401E-06_JPRB, 0.30443900E-06_JPRB, 0.30454908E-06_JPRB, 0.30457656E-06_JPRB, &
  & 0.30450639E-06_JPRB, 0.30433517E-06_JPRB, 0.30405565E-06_JPRB, 0.30365157E-06_JPRB, 0.30312987E-06_JPRB, 0.30248302E-06_JPRB, &
  & 0.30172620E-06_JPRB, 0.30085610E-06_JPRB, 0.29989454E-06_JPRB, 0.29885689E-06_JPRB, 0.29777715E-06_JPRB, 0.29667225E-06_JPRB, &
  & 0.29554951E-06_JPRB, 0.29441526E-06_JPRB, 0.29326517E-06_JPRB, 0.29210295E-06_JPRB, 0.29092320E-06_JPRB, 0.28973074E-06_JPRB, &
  & 0.28852631E-06_JPRB, 0.28732126E-06_JPRB, 0.28612490E-06_JPRB, 0.28496356E-06_JPRB, 0.28386032E-06_JPRB, 0.28284416E-06_JPRB, &
  & 0.28192909E-06_JPRB, 0.28108181E-06_JPRB, 0.28017288E-06_JPRB, 0.27852451E-06_JPRB /)

RGHG3(:,26,12) = (/ &
  & 0.26144991E-06_JPRB, 0.26330383E-06_JPRB, 0.26460037E-06_JPRB, 0.26589456E-06_JPRB, 0.26730513E-06_JPRB, 0.26888779E-06_JPRB, &
  & 0.27064706E-06_JPRB, 0.27257730E-06_JPRB, 0.27466501E-06_JPRB, 0.27689302E-06_JPRB, 0.27923164E-06_JPRB, 0.28163370E-06_JPRB, &
  & 0.28405532E-06_JPRB, 0.28645965E-06_JPRB, 0.28882209E-06_JPRB, 0.29111996E-06_JPRB, 0.29332523E-06_JPRB, 0.29541863E-06_JPRB, &
  & 0.29738328E-06_JPRB, 0.29919133E-06_JPRB, 0.30080622E-06_JPRB, 0.30219229E-06_JPRB, 0.30333140E-06_JPRB, 0.30423143E-06_JPRB, &
  & 0.30492154E-06_JPRB, 0.30543961E-06_JPRB, 0.30582794E-06_JPRB, 0.30612168E-06_JPRB, 0.30634982E-06_JPRB, 0.30653905E-06_JPRB, &
  & 0.30670031E-06_JPRB, 0.30683191E-06_JPRB, 0.30692391E-06_JPRB, 0.30697947E-06_JPRB, 0.30699019E-06_JPRB, 0.30694409E-06_JPRB, &
  & 0.30682656E-06_JPRB, 0.30663256E-06_JPRB, 0.30635283E-06_JPRB, 0.30597795E-06_JPRB, 0.30550163E-06_JPRB, 0.30492140E-06_JPRB, &
  & 0.30423899E-06_JPRB, 0.30345191E-06_JPRB, 0.30257215E-06_JPRB, 0.30161931E-06_JPRB, 0.30062222E-06_JPRB, 0.29960444E-06_JPRB, &
  & 0.29857750E-06_JPRB, 0.29754881E-06_JPRB, 0.29651838E-06_JPRB, 0.29549000E-06_JPRB, 0.29445971E-06_JPRB, 0.29342820E-06_JPRB, &
  & 0.29239422E-06_JPRB, 0.29135930E-06_JPRB, 0.29033328E-06_JPRB, 0.28932203E-06_JPRB, 0.28835149E-06_JPRB, 0.28743881E-06_JPRB, &
  & 0.28659349E-06_JPRB, 0.28580891E-06_JPRB, 0.28491036E-06_JPRB, 0.28341520E-06_JPRB /)

RGHG3(:,27,12) = (/ &
  & 0.26579801E-06_JPRB, 0.26753088E-06_JPRB, 0.26870720E-06_JPRB, 0.26987112E-06_JPRB, 0.27114814E-06_JPRB, 0.27257900E-06_JPRB, &
  & 0.27418449E-06_JPRB, 0.27595181E-06_JPRB, 0.27786484E-06_JPRB, 0.27990768E-06_JPRB, 0.28205457E-06_JPRB, 0.28427061E-06_JPRB, &
  & 0.28651084E-06_JPRB, 0.28874862E-06_JPRB, 0.29095418E-06_JPRB, 0.29311340E-06_JPRB, 0.29521104E-06_JPRB, 0.29722852E-06_JPRB, &
  & 0.29914341E-06_JPRB, 0.30092920E-06_JPRB, 0.30255507E-06_JPRB, 0.30399099E-06_JPRB, 0.30521738E-06_JPRB, 0.30623102E-06_JPRB, &
  & 0.30704680E-06_JPRB, 0.30768129E-06_JPRB, 0.30816361E-06_JPRB, 0.30850919E-06_JPRB, 0.30874548E-06_JPRB, 0.30889530E-06_JPRB, &
  & 0.30898553E-06_JPRB, 0.30902623E-06_JPRB, 0.30902666E-06_JPRB, 0.30900190E-06_JPRB, 0.30894594E-06_JPRB, 0.30885246E-06_JPRB, &
  & 0.30870871E-06_JPRB, 0.30850370E-06_JPRB, 0.30823523E-06_JPRB, 0.30789303E-06_JPRB, 0.30746486E-06_JPRB, 0.30694630E-06_JPRB, &
  & 0.30633214E-06_JPRB, 0.30561816E-06_JPRB, 0.30481192E-06_JPRB, 0.30393133E-06_JPRB, 0.30300117E-06_JPRB, 0.30204890E-06_JPRB, &
  & 0.30108987E-06_JPRB, 0.30014013E-06_JPRB, 0.29920136E-06_JPRB, 0.29827558E-06_JPRB, 0.29736057E-06_JPRB, 0.29645540E-06_JPRB, &
  & 0.29555923E-06_JPRB, 0.29467074E-06_JPRB, 0.29378847E-06_JPRB, 0.29292173E-06_JPRB, 0.29207834E-06_JPRB, 0.29127898E-06_JPRB, &
  & 0.29053606E-06_JPRB, 0.28980591E-06_JPRB, 0.28904995E-06_JPRB, 0.28758038E-06_JPRB /)

RGHG3(:,28,12) = (/ &
  & 0.26993825E-06_JPRB, 0.27153848E-06_JPRB, 0.27260842E-06_JPRB, 0.27366298E-06_JPRB, 0.27480846E-06_JPRB, 0.27610750E-06_JPRB, &
  & 0.27756406E-06_JPRB, 0.27916903E-06_JPRB, 0.28090426E-06_JPRB, 0.28275844E-06_JPRB, 0.28470924E-06_JPRB, 0.28673583E-06_JPRB, &
  & 0.28879197E-06_JPRB, 0.29086152E-06_JPRB, 0.29291857E-06_JPRB, 0.29494024E-06_JPRB, 0.29691211E-06_JPRB, 0.29882040E-06_JPRB, &
  & 0.30064803E-06_JPRB, 0.30237220E-06_JPRB, 0.30396666E-06_JPRB, 0.30540522E-06_JPRB, 0.30666706E-06_JPRB, 0.30774527E-06_JPRB, &
  & 0.30863907E-06_JPRB, 0.30935411E-06_JPRB, 0.30990859E-06_JPRB, 0.31030567E-06_JPRB, 0.31056717E-06_JPRB, 0.31071144E-06_JPRB, &
  & 0.31077124E-06_JPRB, 0.31076524E-06_JPRB, 0.31071266E-06_JPRB, 0.31063820E-06_JPRB, 0.31054071E-06_JPRB, 0.31041841E-06_JPRB, &
  & 0.31026192E-06_JPRB, 0.31005968E-06_JPRB, 0.30980735E-06_JPRB, 0.30949627E-06_JPRB, 0.30911281E-06_JPRB, 0.30864857E-06_JPRB, &
  & 0.30809466E-06_JPRB, 0.30744485E-06_JPRB, 0.30670193E-06_JPRB, 0.30588029E-06_JPRB, 0.30500402E-06_JPRB, 0.30410118E-06_JPRB, &
  & 0.30319976E-06_JPRB, 0.30231107E-06_JPRB, 0.30144312E-06_JPRB, 0.30059812E-06_JPRB, 0.29977559E-06_JPRB, 0.29897433E-06_JPRB, &
  & 0.29818978E-06_JPRB, 0.29742003E-06_JPRB, 0.29666262E-06_JPRB, 0.29591610E-06_JPRB, 0.29519379E-06_JPRB, 0.29450396E-06_JPRB, &
  & 0.29385507E-06_JPRB, 0.29324073E-06_JPRB, 0.29251640E-06_JPRB, 0.29129868E-06_JPRB /)

RGHG3(:,29,12) = (/ &
  & 0.27388720E-06_JPRB, 0.27537044E-06_JPRB, 0.27634908E-06_JPRB, 0.27730016E-06_JPRB, 0.27834295E-06_JPRB, 0.27951307E-06_JPRB, &
  & 0.28083073E-06_JPRB, 0.28227694E-06_JPRB, 0.28383434E-06_JPRB, 0.28549331E-06_JPRB, 0.28725023E-06_JPRB, 0.28907658E-06_JPRB, &
  & 0.29094795E-06_JPRB, 0.29284294E-06_JPRB, 0.29473787E-06_JPRB, 0.29661427E-06_JPRB, 0.29845569E-06_JPRB, 0.30024876E-06_JPRB, &
  & 0.30197566E-06_JPRB, 0.30361696E-06_JPRB, 0.30515469E-06_JPRB, 0.30656366E-06_JPRB, 0.30782567E-06_JPRB, 0.30892809E-06_JPRB, &
  & 0.30986379E-06_JPRB, 0.31063163E-06_JPRB, 0.31123656E-06_JPRB, 0.31167934E-06_JPRB, 0.31197203E-06_JPRB, 0.31213051E-06_JPRB, &
  & 0.31218616E-06_JPRB, 0.31216356E-06_JPRB, 0.31208569E-06_JPRB, 0.31198360E-06_JPRB, 0.31186252E-06_JPRB, 0.31172470E-06_JPRB, &
  & 0.31156310E-06_JPRB, 0.31136946E-06_JPRB, 0.31113598E-06_JPRB, 0.31085420E-06_JPRB, 0.31050990E-06_JPRB, 0.31009179E-06_JPRB, &
  & 0.30958870E-06_JPRB, 0.30899250E-06_JPRB, 0.30830219E-06_JPRB, 0.30752923E-06_JPRB, 0.30669651E-06_JPRB, 0.30584161E-06_JPRB, &
  & 0.30498720E-06_JPRB, 0.30415313E-06_JPRB, 0.30334647E-06_JPRB, 0.30257047E-06_JPRB, 0.30182508E-06_JPRB, 0.30110573E-06_JPRB, &
  & 0.30041107E-06_JPRB, 0.29973404E-06_JPRB, 0.29907119E-06_JPRB, 0.29842349E-06_JPRB, 0.29779594E-06_JPRB, 0.29720380E-06_JPRB, &
  & 0.29665023E-06_JPRB, 0.29611019E-06_JPRB, 0.29553334E-06_JPRB, 0.29445337E-06_JPRB /)

RGHG3(:,30,12) = (/ &
  & 0.27766202E-06_JPRB, 0.27904022E-06_JPRB, 0.27993860E-06_JPRB, 0.28081121E-06_JPRB, 0.28175128E-06_JPRB, 0.28281346E-06_JPRB, &
  & 0.28399728E-06_JPRB, 0.28528834E-06_JPRB, 0.28667102E-06_JPRB, 0.28814171E-06_JPRB, 0.28970135E-06_JPRB, 0.29133002E-06_JPRB, &
  & 0.29301472E-06_JPRB, 0.29473671E-06_JPRB, 0.29647475E-06_JPRB, 0.29821030E-06_JPRB, 0.29992609E-06_JPRB, 0.30160359E-06_JPRB, &
  & 0.30322548E-06_JPRB, 0.30477329E-06_JPRB, 0.30623318E-06_JPRB, 0.30758991E-06_JPRB, 0.30882322E-06_JPRB, 0.30991939E-06_JPRB, &
  & 0.31086529E-06_JPRB, 0.31165570E-06_JPRB, 0.31228925E-06_JPRB, 0.31276352E-06_JPRB, 0.31308429E-06_JPRB, 0.31326363E-06_JPRB, &
  & 0.31332820E-06_JPRB, 0.31330651E-06_JPRB, 0.31322202E-06_JPRB, 0.31310728E-06_JPRB, 0.31297552E-06_JPRB, 0.31283037E-06_JPRB, &
  & 0.31266916E-06_JPRB, 0.31248547E-06_JPRB, 0.31227077E-06_JPRB, 0.31201517E-06_JPRB, 0.31170356E-06_JPRB, 0.31132305E-06_JPRB, &
  & 0.31086162E-06_JPRB, 0.31030922E-06_JPRB, 0.30966365E-06_JPRB, 0.30893418E-06_JPRB, 0.30814778E-06_JPRB, 0.30733497E-06_JPRB, &
  & 0.30652717E-06_JPRB, 0.30574108E-06_JPRB, 0.30498961E-06_JPRB, 0.30427336E-06_JPRB, 0.30358990E-06_JPRB, 0.30293634E-06_JPRB, &
  & 0.30230717E-06_JPRB, 0.30169915E-06_JPRB, 0.30110658E-06_JPRB, 0.30052936E-06_JPRB, 0.29997781E-06_JPRB, 0.29946037E-06_JPRB, &
  & 0.29898391E-06_JPRB, 0.29853018E-06_JPRB, 0.29801720E-06_JPRB, 0.29712177E-06_JPRB /)

RGHG3(:,31,12) = (/ &
  & 0.28127670E-06_JPRB, 0.28255747E-06_JPRB, 0.28338616E-06_JPRB, 0.28417875E-06_JPRB, 0.28503655E-06_JPRB, 0.28599200E-06_JPRB, &
  & 0.28705287E-06_JPRB, 0.28820011E-06_JPRB, 0.28941759E-06_JPRB, 0.29070671E-06_JPRB, 0.29207592E-06_JPRB, 0.29351128E-06_JPRB, &
  & 0.29501450E-06_JPRB, 0.29656712E-06_JPRB, 0.29815072E-06_JPRB, 0.29974967E-06_JPRB, 0.30134493E-06_JPRB, 0.30291454E-06_JPRB, &
  & 0.30443832E-06_JPRB, 0.30589715E-06_JPRB, 0.30727688E-06_JPRB, 0.30856782E-06_JPRB, 0.30975272E-06_JPRB, 0.31081771E-06_JPRB, &
  & 0.31174534E-06_JPRB, 0.31252790E-06_JPRB, 0.31316483E-06_JPRB, 0.31365283E-06_JPRB, 0.31399188E-06_JPRB, 0.31418924E-06_JPRB, &
  & 0.31426737E-06_JPRB, 0.31425506E-06_JPRB, 0.31417565E-06_JPRB, 0.31405949E-06_JPRB, 0.31392568E-06_JPRB, 0.31377968E-06_JPRB, &
  & 0.31362171E-06_JPRB, 0.31344857E-06_JPRB, 0.31325058E-06_JPRB, 0.31301624E-06_JPRB, 0.31273063E-06_JPRB, 0.31237983E-06_JPRB, &
  & 0.31195054E-06_JPRB, 0.31143398E-06_JPRB, 0.31082720E-06_JPRB, 0.31014034E-06_JPRB, 0.30939748E-06_JPRB, 0.30863123E-06_JPRB, &
  & 0.30786742E-06_JPRB, 0.30713079E-06_JPRB, 0.30642747E-06_JPRB, 0.30575958E-06_JPRB, 0.30512558E-06_JPRB, 0.30452165E-06_JPRB, &
  & 0.30394460E-06_JPRB, 0.30338583E-06_JPRB, 0.30284301E-06_JPRB, 0.30231860E-06_JPRB, 0.30182099E-06_JPRB, 0.30136349E-06_JPRB, &
  & 0.30094469E-06_JPRB, 0.30054869E-06_JPRB, 0.30011529E-06_JPRB, 0.29934645E-06_JPRB /)

RGHG3(:,32,12) = (/ &
  & 0.28473451E-06_JPRB, 0.28591515E-06_JPRB, 0.28667245E-06_JPRB, 0.28739566E-06_JPRB, 0.28816947E-06_JPRB, 0.28903111E-06_JPRB, &
  & 0.28997874E-06_JPRB, 0.29099289E-06_JPRB, 0.29206095E-06_JPRB, 0.29318363E-06_JPRB, 0.29437049E-06_JPRB, 0.29562466E-06_JPRB, &
  & 0.29695417E-06_JPRB, 0.29835064E-06_JPRB, 0.29979836E-06_JPRB, 0.30127632E-06_JPRB, 0.30276323E-06_JPRB, 0.30423246E-06_JPRB, &
  & 0.30566102E-06_JPRB, 0.30703043E-06_JPRB, 0.30832987E-06_JPRB, 0.30954763E-06_JPRB, 0.31066966E-06_JPRB, 0.31167829E-06_JPRB, &
  & 0.31256113E-06_JPRB, 0.31331155E-06_JPRB, 0.31392867E-06_JPRB, 0.31441030E-06_JPRB, 0.31475321E-06_JPRB, 0.31496194E-06_JPRB, &
  & 0.31505292E-06_JPRB, 0.31505328E-06_JPRB, 0.31498573E-06_JPRB, 0.31487642E-06_JPRB, 0.31474707E-06_JPRB, 0.31460468E-06_JPRB, &
  & 0.31445342E-06_JPRB, 0.31429065E-06_JPRB, 0.31410667E-06_JPRB, 0.31388862E-06_JPRB, 0.31362248E-06_JPRB, 0.31329310E-06_JPRB, &
  & 0.31288914E-06_JPRB, 0.31240134E-06_JPRB, 0.31182810E-06_JPRB, 0.31118151E-06_JPRB, 0.31048393E-06_JPRB, 0.30975866E-06_JPRB, &
  & 0.30904161E-06_JPRB, 0.30834784E-06_JPRB, 0.30769004E-06_JPRB, 0.30706752E-06_JPRB, 0.30647624E-06_JPRB, 0.30591440E-06_JPRB, &
  & 0.30537385E-06_JPRB, 0.30485208E-06_JPRB, 0.30434634E-06_JPRB, 0.30386025E-06_JPRB, 0.30340536E-06_JPRB, 0.30298997E-06_JPRB, &
  & 0.30261802E-06_JPRB, 0.30226565E-06_JPRB, 0.30188301E-06_JPRB, 0.30120688E-06_JPRB /)

RGHG3(:,33,12) = (/ &
  & 0.28802444E-06_JPRB, 0.28909858E-06_JPRB, 0.28978093E-06_JPRB, 0.29043281E-06_JPRB, 0.29112979E-06_JPRB, 0.29190372E-06_JPRB, &
  & 0.29274983E-06_JPRB, 0.29364844E-06_JPRB, 0.29458158E-06_JPRB, 0.29555326E-06_JPRB, 0.29657298E-06_JPRB, 0.29765769E-06_JPRB, &
  & 0.29882290E-06_JPRB, 0.30007180E-06_JPRB, 0.30139540E-06_JPRB, 0.30277013E-06_JPRB, 0.30416680E-06_JPRB, 0.30555191E-06_JPRB, &
  & 0.30689654E-06_JPRB, 0.30818546E-06_JPRB, 0.30940561E-06_JPRB, 0.31054529E-06_JPRB, 0.31159132E-06_JPRB, 0.31253063E-06_JPRB, &
  & 0.31334858E-06_JPRB, 0.31404295E-06_JPRB, 0.31461843E-06_JPRB, 0.31507398E-06_JPRB, 0.31540642E-06_JPRB, 0.31561660E-06_JPRB, &
  & 0.31571707E-06_JPRB, 0.31573094E-06_JPRB, 0.31567947E-06_JPRB, 0.31558275E-06_JPRB, 0.31546347E-06_JPRB, 0.31532983E-06_JPRB, &
  & 0.31518817E-06_JPRB, 0.31503572E-06_JPRB, 0.31486300E-06_JPRB, 0.31465794E-06_JPRB, 0.31440527E-06_JPRB, 0.31409132E-06_JPRB, &
  & 0.31370553E-06_JPRB, 0.31323944E-06_JPRB, 0.31269545E-06_JPRB, 0.31208609E-06_JPRB, 0.31142633E-06_JPRB, 0.31074870E-06_JPRB, &
  & 0.31007571E-06_JPRB, 0.30943048E-06_JPRB, 0.30881392E-06_JPRB, 0.30822821E-06_JPRB, 0.30767279E-06_JPRB, 0.30714264E-06_JPRB, &
  & 0.30663472E-06_JPRB, 0.30614279E-06_JPRB, 0.30566713E-06_JPRB, 0.30521210E-06_JPRB, 0.30478827E-06_JPRB, 0.30440734E-06_JPRB, &
  & 0.30406386E-06_JPRB, 0.30374616E-06_JPRB, 0.30339530E-06_JPRB, 0.30279537E-06_JPRB /)

RGHG3(:,34,12) = (/ &
  & 0.29112542E-06_JPRB, 0.29207843E-06_JPRB, 0.29268980E-06_JPRB, 0.29326907E-06_JPRB, 0.29389560E-06_JPRB, 0.29458957E-06_JPRB, &
  & 0.29534775E-06_JPRB, 0.29614313E-06_JPRB, 0.29695929E-06_JPRB, 0.29779520E-06_JPRB, 0.29866411E-06_JPRB, 0.29959284E-06_JPRB, &
  & 0.30060554E-06_JPRB, 0.30171694E-06_JPRB, 0.30292605E-06_JPRB, 0.30420856E-06_JPRB, 0.30552488E-06_JPRB, 0.30684046E-06_JPRB, &
  & 0.30812080E-06_JPRB, 0.30934325E-06_JPRB, 0.31048961E-06_JPRB, 0.31155048E-06_JPRB, 0.31251702E-06_JPRB, 0.31337552E-06_JPRB, &
  & 0.31411483E-06_JPRB, 0.31473783E-06_JPRB, 0.31525349E-06_JPRB, 0.31566552E-06_JPRB, 0.31597284E-06_JPRB, 0.31617458E-06_JPRB, &
  & 0.31627891E-06_JPRB, 0.31630563E-06_JPRB, 0.31627209E-06_JPRB, 0.31619271E-06_JPRB, 0.31608940E-06_JPRB, 0.31597040E-06_JPRB, &
  & 0.31584108E-06_JPRB, 0.31570013E-06_JPRB, 0.31553836E-06_JPRB, 0.31534330E-06_JPRB, 0.31510032E-06_JPRB, 0.31479684E-06_JPRB, &
  & 0.31442224E-06_JPRB, 0.31397303E-06_JPRB, 0.31345263E-06_JPRB, 0.31287286E-06_JPRB, 0.31225443E-06_JPRB, 0.31161861E-06_JPRB, &
  & 0.31099347E-06_JPRB, 0.31038616E-06_JPRB, 0.30980701E-06_JPRB, 0.30925781E-06_JPRB, 0.30873539E-06_JPRB, 0.30823691E-06_JPRB, &
  & 0.30775476E-06_JPRB, 0.30728856E-06_JPRB, 0.30683699E-06_JPRB, 0.30640692E-06_JPRB, 0.30600978E-06_JPRB, 0.30565130E-06_JPRB, &
  & 0.30533491E-06_JPRB, 0.30503580E-06_JPRB, 0.30471793E-06_JPRB, 0.30416081E-06_JPRB /)

RGHG3(:,35,12) = (/ &
  & 0.29401403E-06_JPRB, 0.29485187E-06_JPRB, 0.29538108E-06_JPRB, 0.29589629E-06_JPRB, 0.29645184E-06_JPRB, 0.29707701E-06_JPRB, &
  & 0.29775580E-06_JPRB, 0.29846268E-06_JPRB, 0.29917416E-06_JPRB, 0.29988982E-06_JPRB, 0.30062549E-06_JPRB, 0.30141166E-06_JPRB, &
  & 0.30228475E-06_JPRB, 0.30326950E-06_JPRB, 0.30437451E-06_JPRB, 0.30557612E-06_JPRB, 0.30683137E-06_JPRB, 0.30808980E-06_JPRB, &
  & 0.30931668E-06_JPRB, 0.31048052E-06_JPRB, 0.31156199E-06_JPRB, 0.31255030E-06_JPRB, 0.31343509E-06_JPRB, 0.31420390E-06_JPRB, &
  & 0.31485436E-06_JPRB, 0.31539315E-06_JPRB, 0.31583525E-06_JPRB, 0.31618944E-06_JPRB, 0.31645689E-06_JPRB, 0.31663876E-06_JPRB, &
  & 0.31673929E-06_JPRB, 0.31677587E-06_JPRB, 0.31675972E-06_JPRB, 0.31670149E-06_JPRB, 0.31662032E-06_JPRB, 0.31652064E-06_JPRB, &
  & 0.31640869E-06_JPRB, 0.31628306E-06_JPRB, 0.31613405E-06_JPRB, 0.31595019E-06_JPRB, 0.31571744E-06_JPRB, 0.31542169E-06_JPRB, &
  & 0.31505644E-06_JPRB, 0.31461934E-06_JPRB, 0.31411807E-06_JPRB, 0.31356743E-06_JPRB, 0.31298327E-06_JPRB, 0.31239151E-06_JPRB, &
  & 0.31180312E-06_JPRB, 0.31123665E-06_JPRB, 0.31069416E-06_JPRB, 0.31017601E-06_JPRB, 0.30968150E-06_JPRB, 0.30920538E-06_JPRB, &
  & 0.30874787E-06_JPRB, 0.30830338E-06_JPRB, 0.30787470E-06_JPRB, 0.30746631E-06_JPRB, 0.30708946E-06_JPRB, 0.30675307E-06_JPRB, &
  & 0.30645239E-06_JPRB, 0.30617645E-06_JPRB, 0.30587393E-06_JPRB, 0.30536194E-06_JPRB /)

RGHG3(:,36,12) = (/ &
  & 0.29668726E-06_JPRB, 0.29739877E-06_JPRB, 0.29786071E-06_JPRB, 0.29830642E-06_JPRB, 0.29880280E-06_JPRB, 0.29936143E-06_JPRB, &
  & 0.29997156E-06_JPRB, 0.30059803E-06_JPRB, 0.30121760E-06_JPRB, 0.30182673E-06_JPRB, 0.30244382E-06_JPRB, 0.30310315E-06_JPRB, &
  & 0.30384783E-06_JPRB, 0.30471477E-06_JPRB, 0.30572318E-06_JPRB, 0.30685078E-06_JPRB, 0.30805361E-06_JPRB, 0.30927143E-06_JPRB, &
  & 0.31045519E-06_JPRB, 0.31157379E-06_JPRB, 0.31260060E-06_JPRB, 0.31352164E-06_JPRB, 0.31432162E-06_JPRB, 0.31499573E-06_JPRB, &
  & 0.31554544E-06_JPRB, 0.31598907E-06_JPRB, 0.31634556E-06_JPRB, 0.31662807E-06_JPRB, 0.31684436E-06_JPRB, 0.31699443E-06_JPRB, &
  & 0.31708356E-06_JPRB, 0.31712457E-06_JPRB, 0.31712187E-06_JPRB, 0.31708598E-06_JPRB, 0.31702794E-06_JPRB, 0.31695100E-06_JPRB, &
  & 0.31686136E-06_JPRB, 0.31675506E-06_JPRB, 0.31662509E-06_JPRB, 0.31645999E-06_JPRB, 0.31624407E-06_JPRB, 0.31596466E-06_JPRB, &
  & 0.31561308E-06_JPRB, 0.31519028E-06_JPRB, 0.31470773E-06_JPRB, 0.31417972E-06_JPRB, 0.31362970E-06_JPRB, 0.31307096E-06_JPRB, &
  & 0.31252333E-06_JPRB, 0.31199141E-06_JPRB, 0.31147857E-06_JPRB, 0.31098671E-06_JPRB, 0.31051420E-06_JPRB, 0.31006235E-06_JPRB, &
  & 0.30962579E-06_JPRB, 0.30920393E-06_JPRB, 0.30879517E-06_JPRB, 0.30840710E-06_JPRB, 0.30804901E-06_JPRB, 0.30772841E-06_JPRB, &
  & 0.30744638E-06_JPRB, 0.30718354E-06_JPRB, 0.30690444E-06_JPRB, 0.30642394E-06_JPRB /)

RGHG3(:,37,12) = (/ &
  & 0.29913977E-06_JPRB, 0.29974041E-06_JPRB, 0.30012765E-06_JPRB, 0.30051592E-06_JPRB, 0.30095168E-06_JPRB, 0.30145316E-06_JPRB, &
  & 0.30199863E-06_JPRB, 0.30255336E-06_JPRB, 0.30308985E-06_JPRB, 0.30360468E-06_JPRB, 0.30411883E-06_JPRB, 0.30466563E-06_JPRB, &
  & 0.30529381E-06_JPRB, 0.30605011E-06_JPRB, 0.30696435E-06_JPRB, 0.30802542E-06_JPRB, 0.30917781E-06_JPRB, 0.31036387E-06_JPRB, &
  & 0.31151939E-06_JPRB, 0.31259981E-06_JPRB, 0.31357524E-06_JPRB, 0.31442130E-06_JPRB, 0.31512658E-06_JPRB, 0.31569147E-06_JPRB, &
  & 0.31613328E-06_JPRB, 0.31647517E-06_JPRB, 0.31674304E-06_JPRB, 0.31695379E-06_JPRB, 0.31711636E-06_JPRB, 0.31723371E-06_JPRB, &
  & 0.31730818E-06_JPRB, 0.31734834E-06_JPRB, 0.31735405E-06_JPRB, 0.31733560E-06_JPRB, 0.31729618E-06_JPRB, 0.31724110E-06_JPRB, &
  & 0.31717252E-06_JPRB, 0.31708808E-06_JPRB, 0.31698221E-06_JPRB, 0.31684343E-06_JPRB, 0.31665766E-06_JPRB, 0.31640832E-06_JPRB, &
  & 0.31608550E-06_JPRB, 0.31568757E-06_JPRB, 0.31522495E-06_JPRB, 0.31472220E-06_JPRB, 0.31419839E-06_JPRB, 0.31367472E-06_JPRB, &
  & 0.31315852E-06_JPRB, 0.31265614E-06_JPRB, 0.31216950E-06_JPRB, 0.31169949E-06_JPRB, 0.31124944E-06_JPRB, 0.31081717E-06_JPRB, &
  & 0.31040332E-06_JPRB, 0.31000386E-06_JPRB, 0.30961837E-06_JPRB, 0.30925011E-06_JPRB, 0.30890959E-06_JPRB, 0.30860531E-06_JPRB, &
  & 0.30833658E-06_JPRB, 0.30809068E-06_JPRB, 0.30782681E-06_JPRB, 0.30737797E-06_JPRB /)

RGHG3(:,38,12) = (/ &
  & 0.30136795E-06_JPRB, 0.30186311E-06_JPRB, 0.30219113E-06_JPRB, 0.30252437E-06_JPRB, 0.30290806E-06_JPRB, 0.30335559E-06_JPRB, &
  & 0.30384228E-06_JPRB, 0.30433048E-06_JPRB, 0.30479234E-06_JPRB, 0.30522682E-06_JPRB, 0.30565101E-06_JPRB, 0.30610454E-06_JPRB, &
  & 0.30662716E-06_JPRB, 0.30728239E-06_JPRB, 0.30810452E-06_JPRB, 0.30910195E-06_JPRB, 0.31021597E-06_JPRB, 0.31136790E-06_JPRB, &
  & 0.31248962E-06_JPRB, 0.31352795E-06_JPRB, 0.31443471E-06_JPRB, 0.31518610E-06_JPRB, 0.31577630E-06_JPRB, 0.31622531E-06_JPRB, &
  & 0.31656054E-06_JPRB, 0.31681384E-06_JPRB, 0.31700955E-06_JPRB, 0.31716417E-06_JPRB, 0.31728678E-06_JPRB, 0.31737835E-06_JPRB, &
  & 0.31744210E-06_JPRB, 0.31747871E-06_JPRB, 0.31749016E-06_JPRB, 0.31748129E-06_JPRB, 0.31745486E-06_JPRB, 0.31741516E-06_JPRB, &
  & 0.31736269E-06_JPRB, 0.31729664E-06_JPRB, 0.31721225E-06_JPRB, 0.31710067E-06_JPRB, 0.31694844E-06_JPRB, 0.31673918E-06_JPRB, &
  & 0.31645763E-06_JPRB, 0.31609704E-06_JPRB, 0.31566793E-06_JPRB, 0.31519198E-06_JPRB, 0.31469844E-06_JPRB, 0.31420299E-06_JPRB, &
  & 0.31371601E-06_JPRB, 0.31324078E-06_JPRB, 0.31277636E-06_JPRB, 0.31232696E-06_JPRB, 0.31189504E-06_JPRB, 0.31148423E-06_JPRB, &
  & 0.31109414E-06_JPRB, 0.31072156E-06_JPRB, 0.31036191E-06_JPRB, 0.31001707E-06_JPRB, 0.30969471E-06_JPRB, 0.30940510E-06_JPRB, &
  & 0.30915007E-06_JPRB, 0.30891687E-06_JPRB, 0.30866931E-06_JPRB, 0.30824711E-06_JPRB /)

RGHG3(:,39,12) = (/ &
  & 0.30336213E-06_JPRB, 0.30377007E-06_JPRB, 0.30404559E-06_JPRB, 0.30433176E-06_JPRB, 0.30467285E-06_JPRB, 0.30507090E-06_JPRB, &
  & 0.30550422E-06_JPRB, 0.30593100E-06_JPRB, 0.30632822E-06_JPRB, 0.30669207E-06_JPRB, 0.30704723E-06_JPRB, 0.30741805E-06_JPRB, &
  & 0.30785944E-06_JPRB, 0.30841471E-06_JPRB, 0.30915444E-06_JPRB, 0.31007727E-06_JPRB, 0.31114507E-06_JPRB, 0.31226472E-06_JPRB, &
  & 0.31334508E-06_JPRB, 0.31431321E-06_JPRB, 0.31512650E-06_JPRB, 0.31576121E-06_JPRB, 0.31623549E-06_JPRB, 0.31658163E-06_JPRB, &
  & 0.31683595E-06_JPRB, 0.31702632E-06_JPRB, 0.31717445E-06_JPRB, 0.31729346E-06_JPRB, 0.31739032E-06_JPRB, 0.31746609E-06_JPRB, &
  & 0.31752217E-06_JPRB, 0.31755593E-06_JPRB, 0.31757068E-06_JPRB, 0.31756690E-06_JPRB, 0.31754885E-06_JPRB, 0.31751844E-06_JPRB, &
  & 0.31747717E-06_JPRB, 0.31742414E-06_JPRB, 0.31735564E-06_JPRB, 0.31726503E-06_JPRB, 0.31714075E-06_JPRB, 0.31696720E-06_JPRB, &
  & 0.31672914E-06_JPRB, 0.31641531E-06_JPRB, 0.31602863E-06_JPRB, 0.31559156E-06_JPRB, 0.31512812E-06_JPRB, 0.31466243E-06_JPRB, &
  & 0.31420274E-06_JPRB, 0.31374972E-06_JPRB, 0.31330603E-06_JPRB, 0.31287402E-06_JPRB, 0.31246091E-06_JPRB, 0.31207429E-06_JPRB, &
  & 0.31171092E-06_JPRB, 0.31136994E-06_JPRB, 0.31104000E-06_JPRB, 0.31072230E-06_JPRB, 0.31042040E-06_JPRB, 0.31014724E-06_JPRB, &
  & 0.30990537E-06_JPRB, 0.30968530E-06_JPRB, 0.30945097E-06_JPRB, 0.30905252E-06_JPRB /)

RGHG3(:,40,12) = (/ &
  & 0.30511322E-06_JPRB, 0.30545431E-06_JPRB, 0.30568827E-06_JPRB, 0.30594131E-06_JPRB, 0.30624290E-06_JPRB, 0.30660365E-06_JPRB, &
  & 0.30698732E-06_JPRB, 0.30736041E-06_JPRB, 0.30770008E-06_JPRB, 0.30801067E-06_JPRB, 0.30830407E-06_JPRB, 0.30861958E-06_JPRB, &
  & 0.30898374E-06_JPRB, 0.30946731E-06_JPRB, 0.31011544E-06_JPRB, 0.31097647E-06_JPRB, 0.31198650E-06_JPRB, 0.31305257E-06_JPRB, &
  & 0.31406756E-06_JPRB, 0.31494636E-06_JPRB, 0.31564238E-06_JPRB, 0.31616366E-06_JPRB, 0.31653963E-06_JPRB, 0.31681131E-06_JPRB, &
  & 0.31700986E-06_JPRB, 0.31716047E-06_JPRB, 0.31727910E-06_JPRB, 0.31737642E-06_JPRB, 0.31745753E-06_JPRB, 0.31752353E-06_JPRB, &
  & 0.31757378E-06_JPRB, 0.31760618E-06_JPRB, 0.31762181E-06_JPRB, 0.31762141E-06_JPRB, 0.31760811E-06_JPRB, 0.31758375E-06_JPRB, &
  & 0.31755002E-06_JPRB, 0.31750577E-06_JPRB, 0.31744869E-06_JPRB, 0.31737309E-06_JPRB, 0.31726947E-06_JPRB, 0.31712472E-06_JPRB, &
  & 0.31692429E-06_JPRB, 0.31665559E-06_JPRB, 0.31631703E-06_JPRB, 0.31592018E-06_JPRB, 0.31549507E-06_JPRB, 0.31505991E-06_JPRB, &
  & 0.31462594E-06_JPRB, 0.31419646E-06_JPRB, 0.31377061E-06_JPRB, 0.31335466E-06_JPRB, 0.31296227E-06_JPRB, 0.31259714E-06_JPRB, &
  & 0.31226597E-06_JPRB, 0.31195538E-06_JPRB, 0.31166059E-06_JPRB, 0.31137233E-06_JPRB, 0.31109636E-06_JPRB, 0.31084224E-06_JPRB, &
  & 0.31061649E-06_JPRB, 0.31040949E-06_JPRB, 0.31019025E-06_JPRB, 0.30981278E-06_JPRB /)

RGHG3(:,41,12) = (/ &
  & 0.30663736E-06_JPRB, 0.30692837E-06_JPRB, 0.30713369E-06_JPRB, 0.30735725E-06_JPRB, 0.30763678E-06_JPRB, 0.30796249E-06_JPRB, &
  & 0.30830657E-06_JPRB, 0.30863168E-06_JPRB, 0.30892579E-06_JPRB, 0.30918864E-06_JPRB, 0.30944267E-06_JPRB, 0.30970406E-06_JPRB, &
  & 0.31002224E-06_JPRB, 0.31043004E-06_JPRB, 0.31101052E-06_JPRB, 0.31178854E-06_JPRB, 0.31273868E-06_JPRB, 0.31373494E-06_JPRB, &
  & 0.31466379E-06_JPRB, 0.31543530E-06_JPRB, 0.31602332E-06_JPRB, 0.31644620E-06_JPRB, 0.31674801E-06_JPRB, 0.31696558E-06_JPRB, &
  & 0.31712722E-06_JPRB, 0.31725153E-06_JPRB, 0.31735146E-06_JPRB, 0.31743500E-06_JPRB, 0.31750568E-06_JPRB, 0.31756542E-06_JPRB, &
  & 0.31761095E-06_JPRB, 0.31764250E-06_JPRB, 0.31765802E-06_JPRB, 0.31765970E-06_JPRB, 0.31764930E-06_JPRB, 0.31762909E-06_JPRB, &
  & 0.31760024E-06_JPRB, 0.31756247E-06_JPRB, 0.31751367E-06_JPRB, 0.31744912E-06_JPRB, 0.31736124E-06_JPRB, 0.31723900E-06_JPRB, &
  & 0.31706941E-06_JPRB, 0.31683970E-06_JPRB, 0.31654403E-06_JPRB, 0.31619351E-06_JPRB, 0.31580592E-06_JPRB, 0.31540441E-06_JPRB, &
  & 0.31499852E-06_JPRB, 0.31459021E-06_JPRB, 0.31418102E-06_JPRB, 0.31378300E-06_JPRB, 0.31340505E-06_JPRB, 0.31306874E-06_JPRB, &
  & 0.31276406E-06_JPRB, 0.31248979E-06_JPRB, 0.31222785E-06_JPRB, 0.31197385E-06_JPRB, 0.31172698E-06_JPRB, 0.31149801E-06_JPRB, &
  & 0.31129269E-06_JPRB, 0.31110338E-06_JPRB, 0.31089962E-06_JPRB, 0.31054790E-06_JPRB /)

RGHG3(:,42,12) = (/ &
  & 0.30796193E-06_JPRB, 0.30821951E-06_JPRB, 0.30840360E-06_JPRB, 0.30861264E-06_JPRB, 0.30887040E-06_JPRB, 0.30917559E-06_JPRB, &
  & 0.30948442E-06_JPRB, 0.30977125E-06_JPRB, 0.31002591E-06_JPRB, 0.31025564E-06_JPRB, 0.31047179E-06_JPRB, 0.31070232E-06_JPRB, &
  & 0.31096909E-06_JPRB, 0.31133155E-06_JPRB, 0.31183515E-06_JPRB, 0.31254734E-06_JPRB, 0.31342159E-06_JPRB, 0.31433697E-06_JPRB, &
  & 0.31516169E-06_JPRB, 0.31582346E-06_JPRB, 0.31630933E-06_JPRB, 0.31665405E-06_JPRB, 0.31689848E-06_JPRB, 0.31707742E-06_JPRB, &
  & 0.31721260E-06_JPRB, 0.31731909E-06_JPRB, 0.31740620E-06_JPRB, 0.31748039E-06_JPRB, 0.31754419E-06_JPRB, 0.31759890E-06_JPRB, &
  & 0.31764117E-06_JPRB, 0.31767118E-06_JPRB, 0.31768647E-06_JPRB, 0.31768928E-06_JPRB, 0.31768070E-06_JPRB, 0.31766319E-06_JPRB, &
  & 0.31763796E-06_JPRB, 0.31760490E-06_JPRB, 0.31756235E-06_JPRB, 0.31750648E-06_JPRB, 0.31743090E-06_JPRB, 0.31732640E-06_JPRB, &
  & 0.31718170E-06_JPRB, 0.31698505E-06_JPRB, 0.31673017E-06_JPRB, 0.31642028E-06_JPRB, 0.31607351E-06_JPRB, 0.31570593E-06_JPRB, &
  & 0.31532883E-06_JPRB, 0.31494358E-06_JPRB, 0.31455380E-06_JPRB, 0.31416738E-06_JPRB, 0.31381254E-06_JPRB, 0.31349597E-06_JPRB, &
  & 0.31322492E-06_JPRB, 0.31298120E-06_JPRB, 0.31275505E-06_JPRB, 0.31253455E-06_JPRB, 0.31232119E-06_JPRB, 0.31212193E-06_JPRB, &
  & 0.31194242E-06_JPRB, 0.31177495E-06_JPRB, 0.31159297E-06_JPRB, 0.31127280E-06_JPRB /)

RGHG3(:,43,12) = (/ &
  & 0.30912631E-06_JPRB, 0.30936337E-06_JPRB, 0.30953458E-06_JPRB, 0.30973069E-06_JPRB, 0.30998095E-06_JPRB, 0.31026653E-06_JPRB, &
  & 0.31054984E-06_JPRB, 0.31080481E-06_JPRB, 0.31103022E-06_JPRB, 0.31123079E-06_JPRB, 0.31142230E-06_JPRB, 0.31161991E-06_JPRB, &
  & 0.31185655E-06_JPRB, 0.31216317E-06_JPRB, 0.31261277E-06_JPRB, 0.31324160E-06_JPRB, 0.31404070E-06_JPRB, 0.31486869E-06_JPRB, &
  & 0.31558727E-06_JPRB, 0.31613868E-06_JPRB, 0.31653434E-06_JPRB, 0.31681350E-06_JPRB, 0.31701404E-06_JPRB, 0.31716354E-06_JPRB, &
  & 0.31727927E-06_JPRB, 0.31737284E-06_JPRB, 0.31745080E-06_JPRB, 0.31751827E-06_JPRB, 0.31757739E-06_JPRB, 0.31762767E-06_JPRB, &
  & 0.31766749E-06_JPRB, 0.31769537E-06_JPRB, 0.31771043E-06_JPRB, 0.31771361E-06_JPRB, 0.31770625E-06_JPRB, 0.31769059E-06_JPRB, &
  & 0.31766794E-06_JPRB, 0.31763864E-06_JPRB, 0.31760106E-06_JPRB, 0.31755212E-06_JPRB, 0.31748664E-06_JPRB, 0.31739688E-06_JPRB, &
  & 0.31727348E-06_JPRB, 0.31710553E-06_JPRB, 0.31688546E-06_JPRB, 0.31661466E-06_JPRB, 0.31630475E-06_JPRB, 0.31597267E-06_JPRB, &
  & 0.31562610E-06_JPRB, 0.31526656E-06_JPRB, 0.31489495E-06_JPRB, 0.31452990E-06_JPRB, 0.31419188E-06_JPRB, 0.31390368E-06_JPRB, &
  & 0.31366028E-06_JPRB, 0.31344908E-06_JPRB, 0.31325453E-06_JPRB, 0.31306789E-06_JPRB, 0.31288846E-06_JPRB, 0.31272197E-06_JPRB, &
  & 0.31257196E-06_JPRB, 0.31243098E-06_JPRB, 0.31227515E-06_JPRB, 0.31199704E-06_JPRB /)

RGHG3(:,44,12) = (/ &
  & 0.31017086E-06_JPRB, 0.31039338E-06_JPRB, 0.31055754E-06_JPRB, 0.31074771E-06_JPRB, 0.31098955E-06_JPRB, 0.31126405E-06_JPRB, &
  & 0.31152624E-06_JPRB, 0.31175858E-06_JPRB, 0.31196029E-06_JPRB, 0.31213972E-06_JPRB, 0.31230798E-06_JPRB, 0.31248291E-06_JPRB, &
  & 0.31268451E-06_JPRB, 0.31295400E-06_JPRB, 0.31333650E-06_JPRB, 0.31390039E-06_JPRB, 0.31460877E-06_JPRB, 0.31533486E-06_JPRB, &
  & 0.31594541E-06_JPRB, 0.31639624E-06_JPRB, 0.31671453E-06_JPRB, 0.31694026E-06_JPRB, 0.31710601E-06_JPRB, 0.31723266E-06_JPRB, &
  & 0.31733367E-06_JPRB, 0.31741746E-06_JPRB, 0.31748914E-06_JPRB, 0.31755150E-06_JPRB, 0.31760734E-06_JPRB, 0.31765381E-06_JPRB, &
  & 0.31769122E-06_JPRB, 0.31771722E-06_JPRB, 0.31773158E-06_JPRB, 0.31773479E-06_JPRB, 0.31772814E-06_JPRB, 0.31771373E-06_JPRB, &
  & 0.31769304E-06_JPRB, 0.31766649E-06_JPRB, 0.31763295E-06_JPRB, 0.31758987E-06_JPRB, 0.31753285E-06_JPRB, 0.31745574E-06_JPRB, &
  & 0.31735050E-06_JPRB, 0.31720759E-06_JPRB, 0.31701904E-06_JPRB, 0.31678329E-06_JPRB, 0.31650967E-06_JPRB, 0.31621121E-06_JPRB, &
  & 0.31589570E-06_JPRB, 0.31556340E-06_JPRB, 0.31521819E-06_JPRB, 0.31487403E-06_JPRB, 0.31456221E-06_JPRB, 0.31430184E-06_JPRB, &
  & 0.31408712E-06_JPRB, 0.31390559E-06_JPRB, 0.31374066E-06_JPRB, 0.31358516E-06_JPRB, 0.31343819E-06_JPRB, 0.31330384E-06_JPRB, &
  & 0.31318396E-06_JPRB, 0.31307073E-06_JPRB, 0.31294428E-06_JPRB, 0.31271534E-06_JPRB /)

RGHG3(:,45,12) = (/ &
  & 0.31112228E-06_JPRB, 0.31134113E-06_JPRB, 0.31149824E-06_JPRB, 0.31168486E-06_JPRB, 0.31192087E-06_JPRB, 0.31218559E-06_JPRB, &
  & 0.31243320E-06_JPRB, 0.31264892E-06_JPRB, 0.31283378E-06_JPRB, 0.31299555E-06_JPRB, 0.31314497E-06_JPRB, 0.31329685E-06_JPRB, &
  & 0.31347034E-06_JPRB, 0.31369689E-06_JPRB, 0.31402530E-06_JPRB, 0.31450833E-06_JPRB, 0.31512920E-06_JPRB, 0.31574956E-06_JPRB, &
  & 0.31624648E-06_JPRB, 0.31660682E-06_JPRB, 0.31686000E-06_JPRB, 0.31704306E-06_JPRB, 0.31718071E-06_JPRB, 0.31728996E-06_JPRB, &
  & 0.31737932E-06_JPRB, 0.31745594E-06_JPRB, 0.31752276E-06_JPRB, 0.31758188E-06_JPRB, 0.31763483E-06_JPRB, 0.31767829E-06_JPRB, &
  & 0.31771316E-06_JPRB, 0.31773720E-06_JPRB, 0.31775065E-06_JPRB, 0.31775366E-06_JPRB, 0.31774735E-06_JPRB, 0.31773368E-06_JPRB, &
  & 0.31771441E-06_JPRB, 0.31769008E-06_JPRB, 0.31765981E-06_JPRB, 0.31762153E-06_JPRB, 0.31757179E-06_JPRB, 0.31750540E-06_JPRB, &
  & 0.31741607E-06_JPRB, 0.31729559E-06_JPRB, 0.31713614E-06_JPRB, 0.31693401E-06_JPRB, 0.31669398E-06_JPRB, 0.31642807E-06_JPRB, &
  & 0.31614357E-06_JPRB, 0.31584142E-06_JPRB, 0.31552310E-06_JPRB, 0.31521031E-06_JPRB, 0.31492880E-06_JPRB, 0.31469844E-06_JPRB, &
  & 0.31451407E-06_JPRB, 0.31435866E-06_JPRB, 0.31422113E-06_JPRB, 0.31409286E-06_JPRB, 0.31397468E-06_JPRB, 0.31386929E-06_JPRB, &
  & 0.31377633E-06_JPRB, 0.31368899E-06_JPRB, 0.31359065E-06_JPRB, 0.31341119E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART24',0,ZHOOK_HANDLE)



RGHG3(:,46,12) = (/ &
  & 0.31200739E-06_JPRB, 0.31221964E-06_JPRB, 0.31237639E-06_JPRB, 0.31255678E-06_JPRB, 0.31278896E-06_JPRB, 0.31304370E-06_JPRB, &
  & 0.31328204E-06_JPRB, 0.31348534E-06_JPRB, 0.31365767E-06_JPRB, 0.31380344E-06_JPRB, 0.31393583E-06_JPRB, 0.31406492E-06_JPRB, &
  & 0.31421234E-06_JPRB, 0.31439748E-06_JPRB, 0.31467448E-06_JPRB, 0.31507676E-06_JPRB, 0.31560060E-06_JPRB, 0.31610358E-06_JPRB, &
  & 0.31649822E-06_JPRB, 0.31677783E-06_JPRB, 0.31697817E-06_JPRB, 0.31712679E-06_JPRB, 0.31724312E-06_JPRB, 0.31733791E-06_JPRB, &
  & 0.31741899E-06_JPRB, 0.31748971E-06_JPRB, 0.31755363E-06_JPRB, 0.31760970E-06_JPRB, 0.31766072E-06_JPRB, 0.31770139E-06_JPRB, &
  & 0.31773382E-06_JPRB, 0.31775591E-06_JPRB, 0.31776813E-06_JPRB, 0.31777074E-06_JPRB, 0.31776443E-06_JPRB, 0.31775124E-06_JPRB, &
  & 0.31773300E-06_JPRB, 0.31771029E-06_JPRB, 0.31768263E-06_JPRB, 0.31764839E-06_JPRB, 0.31760467E-06_JPRB, 0.31754766E-06_JPRB, &
  & 0.31747206E-06_JPRB, 0.31737167E-06_JPRB, 0.31723945E-06_JPRB, 0.31706949E-06_JPRB, 0.31686369E-06_JPRB, 0.31663041E-06_JPRB, &
  & 0.31637674E-06_JPRB, 0.31610426E-06_JPRB, 0.31582073E-06_JPRB, 0.31553776E-06_JPRB, 0.31529453E-06_JPRB, 0.31509569E-06_JPRB, &
  & 0.31493943E-06_JPRB, 0.31481017E-06_JPRB, 0.31469574E-06_JPRB, 0.31459186E-06_JPRB, 0.31449764E-06_JPRB, 0.31441581E-06_JPRB, &
  & 0.31434487E-06_JPRB, 0.31427868E-06_JPRB, 0.31420382E-06_JPRB, 0.31406751E-06_JPRB /)

RGHG3(:,47,12) = (/ &
  & 0.31283167E-06_JPRB, 0.31304489E-06_JPRB, 0.31319655E-06_JPRB, 0.31337504E-06_JPRB, 0.31359804E-06_JPRB, 0.31384698E-06_JPRB, &
  & 0.31407470E-06_JPRB, 0.31427118E-06_JPRB, 0.31442940E-06_JPRB, 0.31456162E-06_JPRB, 0.31467425E-06_JPRB, 0.31478464E-06_JPRB, &
  & 0.31490140E-06_JPRB, 0.31505692E-06_JPRB, 0.31527037E-06_JPRB, 0.31560259E-06_JPRB, 0.31601132E-06_JPRB, 0.31640448E-06_JPRB, &
  & 0.31670172E-06_JPRB, 0.31691644E-06_JPRB, 0.31707395E-06_JPRB, 0.31719608E-06_JPRB, 0.31729516E-06_JPRB, 0.31737952E-06_JPRB, &
  & 0.31745373E-06_JPRB, 0.31752060E-06_JPRB, 0.31758185E-06_JPRB, 0.31763648E-06_JPRB, 0.31768468E-06_JPRB, 0.31772345E-06_JPRB, &
  & 0.31775309E-06_JPRB, 0.31777338E-06_JPRB, 0.31778444E-06_JPRB, 0.31778637E-06_JPRB, 0.31777986E-06_JPRB, 0.31776693E-06_JPRB, &
  & 0.31774925E-06_JPRB, 0.31772785E-06_JPRB, 0.31770224E-06_JPRB, 0.31767124E-06_JPRB, 0.31763261E-06_JPRB, 0.31758327E-06_JPRB, &
  & 0.31751966E-06_JPRB, 0.31743710E-06_JPRB, 0.31732986E-06_JPRB, 0.31719253E-06_JPRB, 0.31702194E-06_JPRB, 0.31682274E-06_JPRB, &
  & 0.31660153E-06_JPRB, 0.31636256E-06_JPRB, 0.31610796E-06_JPRB, 0.31586816E-06_JPRB, 0.31565463E-06_JPRB, 0.31549158E-06_JPRB, &
  & 0.31536104E-06_JPRB, 0.31525428E-06_JPRB, 0.31516117E-06_JPRB, 0.31507651E-06_JPRB, 0.31500207E-06_JPRB, 0.31493835E-06_JPRB, &
  & 0.31488443E-06_JPRB, 0.31483415E-06_JPRB, 0.31477776E-06_JPRB, 0.31467374E-06_JPRB /)

RGHG3(:,48,12) = (/ &
  & 0.31360256E-06_JPRB, 0.31381384E-06_JPRB, 0.31396465E-06_JPRB, 0.31413765E-06_JPRB, 0.31435570E-06_JPRB, 0.31459453E-06_JPRB, &
  & 0.31481875E-06_JPRB, 0.31500269E-06_JPRB, 0.31515020E-06_JPRB, 0.31526372E-06_JPRB, 0.31535981E-06_JPRB, 0.31544670E-06_JPRB, &
  & 0.31554237E-06_JPRB, 0.31565696E-06_JPRB, 0.31582604E-06_JPRB, 0.31606365E-06_JPRB, 0.31636739E-06_JPRB, 0.31664877E-06_JPRB, &
  & 0.31686668E-06_JPRB, 0.31702763E-06_JPRB, 0.31715228E-06_JPRB, 0.31725332E-06_JPRB, 0.31733970E-06_JPRB, 0.31741564E-06_JPRB, &
  & 0.31748522E-06_JPRB, 0.31754908E-06_JPRB, 0.31760874E-06_JPRB, 0.31766137E-06_JPRB, 0.31770782E-06_JPRB, 0.31774400E-06_JPRB, &
  & 0.31777137E-06_JPRB, 0.31778978E-06_JPRB, 0.31779959E-06_JPRB, 0.31780073E-06_JPRB, 0.31779388E-06_JPRB, 0.31778092E-06_JPRB, &
  & 0.31776375E-06_JPRB, 0.31774323E-06_JPRB, 0.31771918E-06_JPRB, 0.31769079E-06_JPRB, 0.31765620E-06_JPRB, 0.31761340E-06_JPRB, &
  & 0.31755974E-06_JPRB, 0.31749244E-06_JPRB, 0.31740828E-06_JPRB, 0.31730156E-06_JPRB, 0.31716888E-06_JPRB, 0.31700813E-06_JPRB, &
  & 0.31682299E-06_JPRB, 0.31661710E-06_JPRB, 0.31640235E-06_JPRB, 0.31619146E-06_JPRB, 0.31601991E-06_JPRB, 0.31588223E-06_JPRB, &
  & 0.31577713E-06_JPRB, 0.31568982E-06_JPRB, 0.31561348E-06_JPRB, 0.31554512E-06_JPRB, 0.31548507E-06_JPRB, 0.31543516E-06_JPRB, &
  & 0.31539309E-06_JPRB, 0.31535444E-06_JPRB, 0.31531064E-06_JPRB, 0.31523101E-06_JPRB /)

RGHG3(:,49,12) = (/ &
  & 0.31431864E-06_JPRB, 0.31452623E-06_JPRB, 0.31467590E-06_JPRB, 0.31484467E-06_JPRB, 0.31505672E-06_JPRB, 0.31529092E-06_JPRB, &
  & 0.31550616E-06_JPRB, 0.31568186E-06_JPRB, 0.31581030E-06_JPRB, 0.31590650E-06_JPRB, 0.31598134E-06_JPRB, 0.31604827E-06_JPRB, &
  & 0.31611643E-06_JPRB, 0.31619760E-06_JPRB, 0.31630810E-06_JPRB, 0.31646192E-06_JPRB, 0.31665641E-06_JPRB, 0.31684513E-06_JPRB, &
  & 0.31699739E-06_JPRB, 0.31711775E-06_JPRB, 0.31721626E-06_JPRB, 0.31730150E-06_JPRB, 0.31737790E-06_JPRB, 0.31744810E-06_JPRB, &
  & 0.31751424E-06_JPRB, 0.31757622E-06_JPRB, 0.31763440E-06_JPRB, 0.31768556E-06_JPRB, 0.31772927E-06_JPRB, 0.31776344E-06_JPRB, &
  & 0.31778842E-06_JPRB, 0.31780516E-06_JPRB, 0.31781374E-06_JPRB, 0.31781394E-06_JPRB, 0.31780661E-06_JPRB, 0.31779354E-06_JPRB, &
  & 0.31777665E-06_JPRB, 0.31775679E-06_JPRB, 0.31773402E-06_JPRB, 0.31770767E-06_JPRB, 0.31767641E-06_JPRB, 0.31763867E-06_JPRB, &
  & 0.31759328E-06_JPRB, 0.31753888E-06_JPRB, 0.31747396E-06_JPRB, 0.31739609E-06_JPRB, 0.31730025E-06_JPRB, 0.31718199E-06_JPRB, &
  & 0.31703897E-06_JPRB, 0.31687367E-06_JPRB, 0.31669509E-06_JPRB, 0.31652684E-06_JPRB, 0.31638473E-06_JPRB, 0.31627621E-06_JPRB, &
  & 0.31619055E-06_JPRB, 0.31611975E-06_JPRB, 0.31605697E-06_JPRB, 0.31600044E-06_JPRB, 0.31595135E-06_JPRB, 0.31591065E-06_JPRB, &
  & 0.31587706E-06_JPRB, 0.31584608E-06_JPRB, 0.31581112E-06_JPRB, 0.31574683E-06_JPRB /)

RGHG3(:,50,12) = (/ &
  & 0.31496839E-06_JPRB, 0.31517916E-06_JPRB, 0.31532070E-06_JPRB, 0.31548922E-06_JPRB, 0.31569431E-06_JPRB, 0.31592486E-06_JPRB, &
  & 0.31613061E-06_JPRB, 0.31628616E-06_JPRB, 0.31639175E-06_JPRB, 0.31646240E-06_JPRB, 0.31651422E-06_JPRB, 0.31655736E-06_JPRB, &
  & 0.31659698E-06_JPRB, 0.31664365E-06_JPRB, 0.31669759E-06_JPRB, 0.31677905E-06_JPRB, 0.31688370E-06_JPRB, 0.31699889E-06_JPRB, &
  & 0.31710189E-06_JPRB, 0.31719054E-06_JPRB, 0.31726989E-06_JPRB, 0.31734268E-06_JPRB, 0.31741160E-06_JPRB, 0.31747780E-06_JPRB, &
  & 0.31754155E-06_JPRB, 0.31760234E-06_JPRB, 0.31765893E-06_JPRB, 0.31770836E-06_JPRB, 0.31774957E-06_JPRB, 0.31778151E-06_JPRB, &
  & 0.31780456E-06_JPRB, 0.31781960E-06_JPRB, 0.31782687E-06_JPRB, 0.31782614E-06_JPRB, 0.31781835E-06_JPRB, 0.31780507E-06_JPRB, &
  & 0.31778825E-06_JPRB, 0.31776892E-06_JPRB, 0.31774712E-06_JPRB, 0.31772242E-06_JPRB, 0.31769369E-06_JPRB, 0.31766007E-06_JPRB, &
  & 0.31762124E-06_JPRB, 0.31757722E-06_JPRB, 0.31752853E-06_JPRB, 0.31747430E-06_JPRB, 0.31741163E-06_JPRB, 0.31733464E-06_JPRB, &
  & 0.31723783E-06_JPRB, 0.31712025E-06_JPRB, 0.31698877E-06_JPRB, 0.31686344E-06_JPRB, 0.31675702E-06_JPRB, 0.31667415E-06_JPRB, &
  & 0.31660721E-06_JPRB, 0.31654989E-06_JPRB, 0.31649878E-06_JPRB, 0.31645129E-06_JPRB, 0.31641005E-06_JPRB, 0.31637578E-06_JPRB, &
  & 0.31634724E-06_JPRB, 0.31632081E-06_JPRB, 0.31629068E-06_JPRB, 0.31623500E-06_JPRB /)

RGHG3(:,51,12) = (/ &
  & 0.31555726E-06_JPRB, 0.31574785E-06_JPRB, 0.31589661E-06_JPRB, 0.31605151E-06_JPRB, 0.31625703E-06_JPRB, 0.31647062E-06_JPRB, &
  & 0.31665502E-06_JPRB, 0.31677359E-06_JPRB, 0.31684326E-06_JPRB, 0.31688467E-06_JPRB, 0.31691181E-06_JPRB, 0.31693111E-06_JPRB, &
  & 0.31694827E-06_JPRB, 0.31696291E-06_JPRB, 0.31698306E-06_JPRB, 0.31700887E-06_JPRB, 0.31705622E-06_JPRB, 0.31711866E-06_JPRB, &
  & 0.31718560E-06_JPRB, 0.31725145E-06_JPRB, 0.31731537E-06_JPRB, 0.31737875E-06_JPRB, 0.31744236E-06_JPRB, 0.31750531E-06_JPRB, &
  & 0.31756778E-06_JPRB, 0.31762721E-06_JPRB, 0.31768241E-06_JPRB, 0.31772956E-06_JPRB, 0.31776847E-06_JPRB, 0.31779837E-06_JPRB, &
  & 0.31781954E-06_JPRB, 0.31783304E-06_JPRB, 0.31783910E-06_JPRB, 0.31783739E-06_JPRB, 0.31782912E-06_JPRB, 0.31781559E-06_JPRB, &
  & 0.31779885E-06_JPRB, 0.31777989E-06_JPRB, 0.31775886E-06_JPRB, 0.31773536E-06_JPRB, 0.31770867E-06_JPRB, 0.31767826E-06_JPRB, &
  & 0.31764469E-06_JPRB, 0.31760911E-06_JPRB, 0.31757324E-06_JPRB, 0.31753768E-06_JPRB, 0.31750062E-06_JPRB, 0.31745736E-06_JPRB, &
  & 0.31740262E-06_JPRB, 0.31733390E-06_JPRB, 0.31725631E-06_JPRB, 0.31717809E-06_JPRB, 0.31711158E-06_JPRB, 0.31705522E-06_JPRB, &
  & 0.31700813E-06_JPRB, 0.31696635E-06_JPRB, 0.31692599E-06_JPRB, 0.31688882E-06_JPRB, 0.31685465E-06_JPRB, 0.31682595E-06_JPRB, &
  & 0.31680167E-06_JPRB, 0.31677860E-06_JPRB, 0.31675125E-06_JPRB, 0.31670066E-06_JPRB /)

RGHG3(:,52,12) = (/ &
  & 0.31604856E-06_JPRB, 0.31624899E-06_JPRB, 0.31637049E-06_JPRB, 0.31653073E-06_JPRB, 0.31670660E-06_JPRB, 0.31689660E-06_JPRB, &
  & 0.31702561E-06_JPRB, 0.31709845E-06_JPRB, 0.31713364E-06_JPRB, 0.31715160E-06_JPRB, 0.31716135E-06_JPRB, 0.31716706E-06_JPRB, &
  & 0.31716976E-06_JPRB, 0.31717082E-06_JPRB, 0.31717028E-06_JPRB, 0.31717175E-06_JPRB, 0.31718315E-06_JPRB, 0.31721243E-06_JPRB, &
  & 0.31725432E-06_JPRB, 0.31730275E-06_JPRB, 0.31735567E-06_JPRB, 0.31741178E-06_JPRB, 0.31747064E-06_JPRB, 0.31753194E-06_JPRB, &
  & 0.31759262E-06_JPRB, 0.31765109E-06_JPRB, 0.31770423E-06_JPRB, 0.31774942E-06_JPRB, 0.31778600E-06_JPRB, 0.31781411E-06_JPRB, &
  & 0.31783372E-06_JPRB, 0.31784563E-06_JPRB, 0.31785049E-06_JPRB, 0.31784776E-06_JPRB, 0.31783907E-06_JPRB, 0.31782531E-06_JPRB, &
  & 0.31780866E-06_JPRB, 0.31778995E-06_JPRB, 0.31776958E-06_JPRB, 0.31774701E-06_JPRB, 0.31772186E-06_JPRB, 0.31769412E-06_JPRB, &
  & 0.31766479E-06_JPRB, 0.31763614E-06_JPRB, 0.31761027E-06_JPRB, 0.31758856E-06_JPRB, 0.31756912E-06_JPRB, 0.31754854E-06_JPRB, &
  & 0.31752302E-06_JPRB, 0.31749113E-06_JPRB, 0.31745404E-06_JPRB, 0.31741729E-06_JPRB, 0.31738267E-06_JPRB, 0.31735289E-06_JPRB, &
  & 0.31732571E-06_JPRB, 0.31729945E-06_JPRB, 0.31727430E-06_JPRB, 0.31724807E-06_JPRB, 0.31722425E-06_JPRB, 0.31720347E-06_JPRB, &
  & 0.31718548E-06_JPRB, 0.31716792E-06_JPRB, 0.31714663E-06_JPRB, 0.31710414E-06_JPRB /)

RGHG3(:,53,12) = (/ &
  & 0.31647431E-06_JPRB, 0.31663137E-06_JPRB, 0.31676672E-06_JPRB, 0.31688654E-06_JPRB, 0.31704434E-06_JPRB, 0.31717036E-06_JPRB, &
  & 0.31725054E-06_JPRB, 0.31728490E-06_JPRB, 0.31729971E-06_JPRB, 0.31730576E-06_JPRB, 0.31730792E-06_JPRB, 0.31730775E-06_JPRB, &
  & 0.31730559E-06_JPRB, 0.31730173E-06_JPRB, 0.31729377E-06_JPRB, 0.31728507E-06_JPRB, 0.31727922E-06_JPRB, 0.31728746E-06_JPRB, &
  & 0.31731173E-06_JPRB, 0.31734780E-06_JPRB, 0.31739197E-06_JPRB, 0.31744250E-06_JPRB, 0.31749832E-06_JPRB, 0.31755698E-06_JPRB, &
  & 0.31761681E-06_JPRB, 0.31767325E-06_JPRB, 0.31772467E-06_JPRB, 0.31776773E-06_JPRB, 0.31780240E-06_JPRB, 0.31782875E-06_JPRB, &
  & 0.31784680E-06_JPRB, 0.31785731E-06_JPRB, 0.31786109E-06_JPRB, 0.31785748E-06_JPRB, 0.31784825E-06_JPRB, 0.31783424E-06_JPRB, &
  & 0.31781764E-06_JPRB, 0.31779928E-06_JPRB, 0.31777944E-06_JPRB, 0.31775772E-06_JPRB, 0.31773399E-06_JPRB, 0.31770833E-06_JPRB, &
  & 0.31768269E-06_JPRB, 0.31765953E-06_JPRB, 0.31764162E-06_JPRB, 0.31762937E-06_JPRB, 0.31762113E-06_JPRB, 0.31761365E-06_JPRB, &
  & 0.31760416E-06_JPRB, 0.31759146E-06_JPRB, 0.31757639E-06_JPRB, 0.31756014E-06_JPRB, 0.31754490E-06_JPRB, 0.31753029E-06_JPRB, &
  & 0.31751648E-06_JPRB, 0.31750290E-06_JPRB, 0.31748812E-06_JPRB, 0.31747356E-06_JPRB, 0.31745930E-06_JPRB, 0.31744705E-06_JPRB, &
  & 0.31743676E-06_JPRB, 0.31742695E-06_JPRB, 0.31741513E-06_JPRB, 0.31738975E-06_JPRB /)

RGHG3(:,54,12) = (/ &
  & 0.31679122E-06_JPRB, 0.31695569E-06_JPRB, 0.31704312E-06_JPRB, 0.31715709E-06_JPRB, 0.31725597E-06_JPRB, 0.31733899E-06_JPRB, &
  & 0.31737733E-06_JPRB, 0.31739251E-06_JPRB, 0.31739751E-06_JPRB, 0.31739870E-06_JPRB, 0.31739810E-06_JPRB, 0.31739626E-06_JPRB, &
  & 0.31739324E-06_JPRB, 0.31738767E-06_JPRB, 0.31738037E-06_JPRB, 0.31736676E-06_JPRB, 0.31735391E-06_JPRB, 0.31734942E-06_JPRB, &
  & 0.31736147E-06_JPRB, 0.31738799E-06_JPRB, 0.31742576E-06_JPRB, 0.31747203E-06_JPRB, 0.31752467E-06_JPRB, 0.31758182E-06_JPRB, &
  & 0.31763929E-06_JPRB, 0.31769437E-06_JPRB, 0.31774348E-06_JPRB, 0.31778478E-06_JPRB, 0.31781767E-06_JPRB, 0.31784234E-06_JPRB, &
  & 0.31785902E-06_JPRB, 0.31786840E-06_JPRB, 0.31787101E-06_JPRB, 0.31786661E-06_JPRB, 0.31785692E-06_JPRB, 0.31784265E-06_JPRB, &
  & 0.31782614E-06_JPRB, 0.31780803E-06_JPRB, 0.31778862E-06_JPRB, 0.31776773E-06_JPRB, 0.31774513E-06_JPRB, 0.31772151E-06_JPRB, &
  & 0.31769875E-06_JPRB, 0.31768050E-06_JPRB, 0.31766839E-06_JPRB, 0.31766282E-06_JPRB, 0.31766109E-06_JPRB, 0.31766052E-06_JPRB, &
  & 0.31765859E-06_JPRB, 0.31765461E-06_JPRB, 0.31764858E-06_JPRB, 0.31764165E-06_JPRB, 0.31763432E-06_JPRB, 0.31762721E-06_JPRB, &
  & 0.31762013E-06_JPRB, 0.31761260E-06_JPRB, 0.31760482E-06_JPRB, 0.31759623E-06_JPRB, 0.31758827E-06_JPRB, 0.31758179E-06_JPRB, &
  & 0.31757679E-06_JPRB, 0.31757304E-06_JPRB, 0.31757020E-06_JPRB, 0.31756875E-06_JPRB /)

RGHG3(:,55,12) = (/ &
  & 0.31705252E-06_JPRB, 0.31716971E-06_JPRB, 0.31725909E-06_JPRB, 0.31732554E-06_JPRB, 0.31739535E-06_JPRB, 0.31743730E-06_JPRB, &
  & 0.31745589E-06_JPRB, 0.31746100E-06_JPRB, 0.31746180E-06_JPRB, 0.31746109E-06_JPRB, 0.31745967E-06_JPRB, 0.31745762E-06_JPRB, &
  & 0.31745452E-06_JPRB, 0.31745037E-06_JPRB, 0.31744221E-06_JPRB, 0.31743124E-06_JPRB, 0.31741411E-06_JPRB, 0.31740220E-06_JPRB, &
  & 0.31740549E-06_JPRB, 0.31742519E-06_JPRB, 0.31745779E-06_JPRB, 0.31750048E-06_JPRB, 0.31755050E-06_JPRB, 0.31760510E-06_JPRB, &
  & 0.31766095E-06_JPRB, 0.31771384E-06_JPRB, 0.31776142E-06_JPRB, 0.31780087E-06_JPRB, 0.31783210E-06_JPRB, 0.31785521E-06_JPRB, &
  & 0.31787044E-06_JPRB, 0.31787872E-06_JPRB, 0.31788028E-06_JPRB, 0.31787516E-06_JPRB, 0.31786507E-06_JPRB, 0.31785063E-06_JPRB, &
  & 0.31783412E-06_JPRB, 0.31781639E-06_JPRB, 0.31779740E-06_JPRB, 0.31777716E-06_JPRB, 0.31775582E-06_JPRB, 0.31773388E-06_JPRB, &
  & 0.31771418E-06_JPRB, 0.31769949E-06_JPRB, 0.31769204E-06_JPRB, 0.31769071E-06_JPRB, 0.31769284E-06_JPRB, 0.31769574E-06_JPRB, &
  & 0.31769733E-06_JPRB, 0.31769696E-06_JPRB, 0.31769486E-06_JPRB, 0.31769162E-06_JPRB, 0.31768798E-06_JPRB, 0.31768417E-06_JPRB, &
  & 0.31768013E-06_JPRB, 0.31767587E-06_JPRB, 0.31767098E-06_JPRB, 0.31766592E-06_JPRB, 0.31766086E-06_JPRB, 0.31765654E-06_JPRB, &
  & 0.31765316E-06_JPRB, 0.31765009E-06_JPRB, 0.31764691E-06_JPRB, 0.31764174E-06_JPRB /)

RGHG3(:,56,12) = (/ &
  & 0.31723604E-06_JPRB, 0.31734126E-06_JPRB, 0.31739330E-06_JPRB, 0.31744344E-06_JPRB, 0.31748061E-06_JPRB, 0.31750301E-06_JPRB, &
  & 0.31750960E-06_JPRB, 0.31751034E-06_JPRB, 0.31750938E-06_JPRB, 0.31750807E-06_JPRB, 0.31750653E-06_JPRB, 0.31750463E-06_JPRB, &
  & 0.31750221E-06_JPRB, 0.31749818E-06_JPRB, 0.31749255E-06_JPRB, 0.31748107E-06_JPRB, 0.31746541E-06_JPRB, 0.31744889E-06_JPRB, &
  & 0.31744588E-06_JPRB, 0.31746004E-06_JPRB, 0.31748874E-06_JPRB, 0.31752808E-06_JPRB, 0.31757554E-06_JPRB, 0.31762787E-06_JPRB, &
  & 0.31768135E-06_JPRB, 0.31773268E-06_JPRB, 0.31777833E-06_JPRB, 0.31781616E-06_JPRB, 0.31784575E-06_JPRB, 0.31786726E-06_JPRB, &
  & 0.31788124E-06_JPRB, 0.31788841E-06_JPRB, 0.31788903E-06_JPRB, 0.31788343E-06_JPRB, 0.31787292E-06_JPRB, 0.31785831E-06_JPRB, &
  & 0.31784197E-06_JPRB, 0.31782434E-06_JPRB, 0.31780596E-06_JPRB, 0.31778649E-06_JPRB, 0.31776628E-06_JPRB, 0.31774633E-06_JPRB, &
  & 0.31772890E-06_JPRB, 0.31771737E-06_JPRB, 0.31771302E-06_JPRB, 0.31771455E-06_JPRB, 0.31771910E-06_JPRB, 0.31772373E-06_JPRB, &
  & 0.31772686E-06_JPRB, 0.31772800E-06_JPRB, 0.31772748E-06_JPRB, 0.31772595E-06_JPRB, 0.31772390E-06_JPRB, 0.31772163E-06_JPRB, &
  & 0.31771918E-06_JPRB, 0.31771646E-06_JPRB, 0.31771339E-06_JPRB, 0.31770992E-06_JPRB, 0.31770651E-06_JPRB, 0.31770361E-06_JPRB, &
  & 0.31770116E-06_JPRB, 0.31769906E-06_JPRB, 0.31769693E-06_JPRB, 0.31769386E-06_JPRB /)

RGHG3(:,57,12) = (/ &
  & 0.31737551E-06_JPRB, 0.31745120E-06_JPRB, 0.31749087E-06_JPRB, 0.31751924E-06_JPRB, 0.31754010E-06_JPRB, 0.31754948E-06_JPRB, &
  & 0.31755059E-06_JPRB, 0.31754928E-06_JPRB, 0.31754772E-06_JPRB, 0.31754627E-06_JPRB, 0.31754485E-06_JPRB, 0.31754325E-06_JPRB, &
  & 0.31754115E-06_JPRB, 0.31753831E-06_JPRB, 0.31753291E-06_JPRB, 0.31752467E-06_JPRB, 0.31750864E-06_JPRB, 0.31749073E-06_JPRB, &
  & 0.31748357E-06_JPRB, 0.31749374E-06_JPRB, 0.31751887E-06_JPRB, 0.31755545E-06_JPRB, 0.31760001E-06_JPRB, 0.31764992E-06_JPRB, &
  & 0.31770131E-06_JPRB, 0.31775059E-06_JPRB, 0.31779442E-06_JPRB, 0.31783065E-06_JPRB, 0.31785865E-06_JPRB, 0.31787869E-06_JPRB, &
  & 0.31789148E-06_JPRB, 0.31789762E-06_JPRB, 0.31789753E-06_JPRB, 0.31789145E-06_JPRB, 0.31788059E-06_JPRB, 0.31786604E-06_JPRB, &
  & 0.31784970E-06_JPRB, 0.31783236E-06_JPRB, 0.31781443E-06_JPRB, 0.31779578E-06_JPRB, 0.31777674E-06_JPRB, 0.31775841E-06_JPRB, &
  & 0.31774337E-06_JPRB, 0.31773405E-06_JPRB, 0.31773209E-06_JPRB, 0.31773573E-06_JPRB, 0.31774169E-06_JPRB, 0.31774729E-06_JPRB, &
  & 0.31775102E-06_JPRB, 0.31775261E-06_JPRB, 0.31775267E-06_JPRB, 0.31775181E-06_JPRB, 0.31775056E-06_JPRB, 0.31774908E-06_JPRB, &
  & 0.31774746E-06_JPRB, 0.31774562E-06_JPRB, 0.31774340E-06_JPRB, 0.31774101E-06_JPRB, 0.31773857E-06_JPRB, 0.31773627E-06_JPRB, &
  & 0.31773442E-06_JPRB, 0.31773266E-06_JPRB, 0.31773072E-06_JPRB, 0.31772743E-06_JPRB /)

RGHG3(:,58,12) = (/ &
  & 0.31747697E-06_JPRB, 0.31753171E-06_JPRB, 0.31755707E-06_JPRB, 0.31757332E-06_JPRB, 0.31758390E-06_JPRB, 0.31758657E-06_JPRB, &
  & 0.31758498E-06_JPRB, 0.31758282E-06_JPRB, 0.31758108E-06_JPRB, 0.31757972E-06_JPRB, 0.31757844E-06_JPRB, 0.31757710E-06_JPRB, &
  & 0.31757551E-06_JPRB, 0.31757298E-06_JPRB, 0.31756912E-06_JPRB, 0.31756096E-06_JPRB, 0.31754752E-06_JPRB, 0.31752873E-06_JPRB, &
  & 0.31751929E-06_JPRB, 0.31752649E-06_JPRB, 0.31754854E-06_JPRB, 0.31758222E-06_JPRB, 0.31762437E-06_JPRB, 0.31767163E-06_JPRB, &
  & 0.31772086E-06_JPRB, 0.31776796E-06_JPRB, 0.31781013E-06_JPRB, 0.31784447E-06_JPRB, 0.31787098E-06_JPRB, 0.31788960E-06_JPRB, &
  & 0.31790114E-06_JPRB, 0.31790645E-06_JPRB, 0.31790566E-06_JPRB, 0.31789935E-06_JPRB, 0.31788824E-06_JPRB, 0.31787377E-06_JPRB, &
  & 0.31785760E-06_JPRB, 0.31784057E-06_JPRB, 0.31782304E-06_JPRB, 0.31780510E-06_JPRB, 0.31778723E-06_JPRB, 0.31777063E-06_JPRB, &
  & 0.31775738E-06_JPRB, 0.31775011E-06_JPRB, 0.31774991E-06_JPRB, 0.31775471E-06_JPRB, 0.31776179E-06_JPRB, 0.31776779E-06_JPRB, &
  & 0.31777168E-06_JPRB, 0.31777330E-06_JPRB, 0.31777347E-06_JPRB, 0.31777290E-06_JPRB, 0.31777199E-06_JPRB, 0.31777085E-06_JPRB, &
  & 0.31776960E-06_JPRB, 0.31776818E-06_JPRB, 0.31776656E-06_JPRB, 0.31776460E-06_JPRB, 0.31776261E-06_JPRB, 0.31776079E-06_JPRB, &
  & 0.31775915E-06_JPRB, 0.31775767E-06_JPRB, 0.31775613E-06_JPRB, 0.31775346E-06_JPRB /)

RGHG3(:,59,12) = (/ &
  & 0.31755249E-06_JPRB, 0.31759220E-06_JPRB, 0.31760604E-06_JPRB, 0.31761516E-06_JPRB, 0.31761894E-06_JPRB, 0.31761817E-06_JPRB, &
  & 0.31761530E-06_JPRB, 0.31761289E-06_JPRB, 0.31761118E-06_JPRB, 0.31760999E-06_JPRB, 0.31760896E-06_JPRB, 0.31760794E-06_JPRB, &
  & 0.31760661E-06_JPRB, 0.31760467E-06_JPRB, 0.31760098E-06_JPRB, 0.31759453E-06_JPRB, 0.31758128E-06_JPRB, 0.31756360E-06_JPRB, &
  & 0.31755314E-06_JPRB, 0.31755832E-06_JPRB, 0.31757781E-06_JPRB, 0.31760902E-06_JPRB, 0.31764850E-06_JPRB, 0.31769346E-06_JPRB, &
  & 0.31774019E-06_JPRB, 0.31778524E-06_JPRB, 0.31782525E-06_JPRB, 0.31785788E-06_JPRB, 0.31788267E-06_JPRB, 0.31790003E-06_JPRB, &
  & 0.31791060E-06_JPRB, 0.31791507E-06_JPRB, 0.31791370E-06_JPRB, 0.31790714E-06_JPRB, 0.31789594E-06_JPRB, 0.31788164E-06_JPRB, &
  & 0.31786573E-06_JPRB, 0.31784901E-06_JPRB, 0.31783190E-06_JPRB, 0.31781468E-06_JPRB, 0.31779788E-06_JPRB, 0.31778259E-06_JPRB, &
  & 0.31777125E-06_JPRB, 0.31776543E-06_JPRB, 0.31776648E-06_JPRB, 0.31777233E-06_JPRB, 0.31777978E-06_JPRB, 0.31778617E-06_JPRB, &
  & 0.31778995E-06_JPRB, 0.31779149E-06_JPRB, 0.31779160E-06_JPRB, 0.31779103E-06_JPRB, 0.31779021E-06_JPRB, 0.31778924E-06_JPRB, &
  & 0.31778819E-06_JPRB, 0.31778700E-06_JPRB, 0.31778558E-06_JPRB, 0.31778399E-06_JPRB, 0.31778222E-06_JPRB, 0.31778058E-06_JPRB, &
  & 0.31777915E-06_JPRB, 0.31777785E-06_JPRB, 0.31777637E-06_JPRB, 0.31777370E-06_JPRB /)

RGHG3(:,60,12) = (/ &
  & 0.31762764E-06_JPRB, 0.31763926E-06_JPRB, 0.31764552E-06_JPRB, 0.31764853E-06_JPRB, 0.31764898E-06_JPRB, 0.31764648E-06_JPRB, &
  & 0.31764307E-06_JPRB, 0.31764048E-06_JPRB, 0.31763895E-06_JPRB, 0.31763796E-06_JPRB, 0.31763727E-06_JPRB, 0.31763651E-06_JPRB, &
  & 0.31763554E-06_JPRB, 0.31763389E-06_JPRB, 0.31763096E-06_JPRB, 0.31762454E-06_JPRB, 0.31761252E-06_JPRB, 0.31759564E-06_JPRB, &
  & 0.31758563E-06_JPRB, 0.31758955E-06_JPRB, 0.31760695E-06_JPRB, 0.31763574E-06_JPRB, 0.31767289E-06_JPRB, 0.31771529E-06_JPRB, &
  & 0.31775963E-06_JPRB, 0.31780218E-06_JPRB, 0.31784000E-06_JPRB, 0.31787062E-06_JPRB, 0.31789386E-06_JPRB, 0.31790989E-06_JPRB, &
  & 0.31791947E-06_JPRB, 0.31792331E-06_JPRB, 0.31792149E-06_JPRB, 0.31791478E-06_JPRB, 0.31790370E-06_JPRB, 0.31788963E-06_JPRB, &
  & 0.31787397E-06_JPRB, 0.31785768E-06_JPRB, 0.31784106E-06_JPRB, 0.31782457E-06_JPRB, 0.31780871E-06_JPRB, 0.31779484E-06_JPRB, &
  & 0.31778481E-06_JPRB, 0.31778040E-06_JPRB, 0.31778239E-06_JPRB, 0.31778870E-06_JPRB, 0.31779663E-06_JPRB, 0.31780303E-06_JPRB, &
  & 0.31780675E-06_JPRB, 0.31780797E-06_JPRB, 0.31780789E-06_JPRB, 0.31780718E-06_JPRB, 0.31780627E-06_JPRB, 0.31780530E-06_JPRB, &
  & 0.31780425E-06_JPRB, 0.31780311E-06_JPRB, 0.31780178E-06_JPRB, 0.31780024E-06_JPRB, 0.31779865E-06_JPRB, 0.31779717E-06_JPRB, &
  & 0.31779581E-06_JPRB, 0.31779459E-06_JPRB, 0.31779319E-06_JPRB, 0.31779084E-06_JPRB /)

RGHG3(:,61,12) = (/ &
  & 0.31766439E-06_JPRB, 0.31767331E-06_JPRB, 0.31767618E-06_JPRB, 0.31767721E-06_JPRB, 0.31767598E-06_JPRB, 0.31767257E-06_JPRB, &
  & 0.31766899E-06_JPRB, 0.31766660E-06_JPRB, 0.31766518E-06_JPRB, 0.31766444E-06_JPRB, 0.31766402E-06_JPRB, 0.31766362E-06_JPRB, &
  & 0.31766308E-06_JPRB, 0.31766194E-06_JPRB, 0.31765921E-06_JPRB, 0.31765330E-06_JPRB, 0.31764162E-06_JPRB, 0.31762650E-06_JPRB, &
  & 0.31761726E-06_JPRB, 0.31762013E-06_JPRB, 0.31763594E-06_JPRB, 0.31766251E-06_JPRB, 0.31769719E-06_JPRB, 0.31773718E-06_JPRB, &
  & 0.31777884E-06_JPRB, 0.31781900E-06_JPRB, 0.31785441E-06_JPRB, 0.31788298E-06_JPRB, 0.31790452E-06_JPRB, 0.31791939E-06_JPRB, &
  & 0.31792806E-06_JPRB, 0.31793121E-06_JPRB, 0.31792922E-06_JPRB, 0.31792248E-06_JPRB, 0.31791154E-06_JPRB, 0.31789779E-06_JPRB, &
  & 0.31788255E-06_JPRB, 0.31786652E-06_JPRB, 0.31785041E-06_JPRB, 0.31783455E-06_JPRB, 0.31781971E-06_JPRB, 0.31780695E-06_JPRB, &
  & 0.31779825E-06_JPRB, 0.31779504E-06_JPRB, 0.31779763E-06_JPRB, 0.31780439E-06_JPRB, 0.31781224E-06_JPRB, 0.31781880E-06_JPRB, &
  & 0.31782224E-06_JPRB, 0.31782332E-06_JPRB, 0.31782298E-06_JPRB, 0.31782207E-06_JPRB, 0.31782099E-06_JPRB, 0.31781985E-06_JPRB, &
  & 0.31781872E-06_JPRB, 0.31781755E-06_JPRB, 0.31781619E-06_JPRB, 0.31781474E-06_JPRB, 0.31781323E-06_JPRB, 0.31781178E-06_JPRB, &
  & 0.31781047E-06_JPRB, 0.31780922E-06_JPRB, 0.31780786E-06_JPRB, 0.31780536E-06_JPRB /)

RGHG3(:,62,12) = (/ &
  & 0.31769599E-06_JPRB, 0.31770156E-06_JPRB, 0.31770307E-06_JPRB, 0.31770276E-06_JPRB, 0.31770065E-06_JPRB, 0.31769721E-06_JPRB, &
  & 0.31769355E-06_JPRB, 0.31769105E-06_JPRB, 0.31768980E-06_JPRB, 0.31768940E-06_JPRB, 0.31768951E-06_JPRB, 0.31768974E-06_JPRB, &
  & 0.31768974E-06_JPRB, 0.31768906E-06_JPRB, 0.31768673E-06_JPRB, 0.31768081E-06_JPRB, 0.31766962E-06_JPRB, 0.31765595E-06_JPRB, &
  & 0.31764762E-06_JPRB, 0.31765046E-06_JPRB, 0.31766481E-06_JPRB, 0.31768934E-06_JPRB, 0.31772174E-06_JPRB, 0.31775909E-06_JPRB, &
  & 0.31779823E-06_JPRB, 0.31783563E-06_JPRB, 0.31786854E-06_JPRB, 0.31789497E-06_JPRB, 0.31791490E-06_JPRB, 0.31792845E-06_JPRB, &
  & 0.31793633E-06_JPRB, 0.31793897E-06_JPRB, 0.31793675E-06_JPRB, 0.31793004E-06_JPRB, 0.31791933E-06_JPRB, 0.31790611E-06_JPRB, &
  & 0.31789114E-06_JPRB, 0.31787556E-06_JPRB, 0.31785993E-06_JPRB, 0.31784475E-06_JPRB, 0.31783065E-06_JPRB, 0.31781917E-06_JPRB, &
  & 0.31781153E-06_JPRB, 0.31780931E-06_JPRB, 0.31781249E-06_JPRB, 0.31781931E-06_JPRB, 0.31782722E-06_JPRB, 0.31783355E-06_JPRB, &
  & 0.31783705E-06_JPRB, 0.31783782E-06_JPRB, 0.31783722E-06_JPRB, 0.31783600E-06_JPRB, 0.31783469E-06_JPRB, 0.31783335E-06_JPRB, &
  & 0.31783208E-06_JPRB, 0.31783077E-06_JPRB, 0.31782943E-06_JPRB, 0.31782787E-06_JPRB, 0.31782625E-06_JPRB, 0.31782474E-06_JPRB, &
  & 0.31782332E-06_JPRB, 0.31782201E-06_JPRB, 0.31782054E-06_JPRB, 0.31781795E-06_JPRB /)

RGHG3(:,63,12) = (/ &
  & 0.31772234E-06_JPRB, 0.31772663E-06_JPRB, 0.31772720E-06_JPRB, 0.31772635E-06_JPRB, 0.31772419E-06_JPRB, 0.31772061E-06_JPRB, &
  & 0.31771691E-06_JPRB, 0.31771441E-06_JPRB, 0.31771316E-06_JPRB, 0.31771307E-06_JPRB, 0.31771378E-06_JPRB, 0.31771478E-06_JPRB, &
  & 0.31771566E-06_JPRB, 0.31771557E-06_JPRB, 0.31771339E-06_JPRB, 0.31770756E-06_JPRB, 0.31769704E-06_JPRB, 0.31768522E-06_JPRB, &
  & 0.31767811E-06_JPRB, 0.31768042E-06_JPRB, 0.31769355E-06_JPRB, 0.31771623E-06_JPRB, 0.31774636E-06_JPRB, 0.31778112E-06_JPRB, &
  & 0.31781735E-06_JPRB, 0.31785214E-06_JPRB, 0.31788238E-06_JPRB, 0.31790668E-06_JPRB, 0.31792479E-06_JPRB, 0.31793726E-06_JPRB, &
  & 0.31794428E-06_JPRB, 0.31794653E-06_JPRB, 0.31794411E-06_JPRB, 0.31793758E-06_JPRB, 0.31792726E-06_JPRB, 0.31791444E-06_JPRB, &
  & 0.31789997E-06_JPRB, 0.31788480E-06_JPRB, 0.31786973E-06_JPRB, 0.31785515E-06_JPRB, 0.31784194E-06_JPRB, 0.31783139E-06_JPRB, &
  & 0.31782469E-06_JPRB, 0.31782341E-06_JPRB, 0.31782696E-06_JPRB, 0.31783375E-06_JPRB, 0.31784143E-06_JPRB, 0.31784776E-06_JPRB, &
  & 0.31785112E-06_JPRB, 0.31785183E-06_JPRB, 0.31785092E-06_JPRB, 0.31784941E-06_JPRB, 0.31784774E-06_JPRB, 0.31784623E-06_JPRB, &
  & 0.31784472E-06_JPRB, 0.31784322E-06_JPRB, 0.31784160E-06_JPRB, 0.31783992E-06_JPRB, 0.31783813E-06_JPRB, 0.31783642E-06_JPRB, &
  & 0.31783492E-06_JPRB, 0.31783347E-06_JPRB, 0.31783182E-06_JPRB, 0.31782901E-06_JPRB /)

RGHG3(:,64,12) = (/ &
  & 0.31774601E-06_JPRB, 0.31774925E-06_JPRB, 0.31774951E-06_JPRB, 0.31774852E-06_JPRB, 0.31774630E-06_JPRB, 0.31774300E-06_JPRB, &
  & 0.31773939E-06_JPRB, 0.31773669E-06_JPRB, 0.31773558E-06_JPRB, 0.31773581E-06_JPRB, 0.31773723E-06_JPRB, 0.31773925E-06_JPRB, &
  & 0.31774087E-06_JPRB, 0.31774135E-06_JPRB, 0.31773925E-06_JPRB, 0.31773374E-06_JPRB, 0.31772402E-06_JPRB, 0.31771353E-06_JPRB, &
  & 0.31770725E-06_JPRB, 0.31770975E-06_JPRB, 0.31772203E-06_JPRB, 0.31774297E-06_JPRB, 0.31777080E-06_JPRB, 0.31780291E-06_JPRB, &
  & 0.31783634E-06_JPRB, 0.31786823E-06_JPRB, 0.31789574E-06_JPRB, 0.31791782E-06_JPRB, 0.31793428E-06_JPRB, 0.31794548E-06_JPRB, &
  & 0.31795176E-06_JPRB, 0.31795361E-06_JPRB, 0.31795113E-06_JPRB, 0.31794494E-06_JPRB, 0.31793502E-06_JPRB, 0.31792277E-06_JPRB, &
  & 0.31790879E-06_JPRB, 0.31789415E-06_JPRB, 0.31787957E-06_JPRB, 0.31786564E-06_JPRB, 0.31785319E-06_JPRB, 0.31784353E-06_JPRB, &
  & 0.31783784E-06_JPRB, 0.31783711E-06_JPRB, 0.31784097E-06_JPRB, 0.31784771E-06_JPRB, 0.31785513E-06_JPRB, 0.31786124E-06_JPRB, &
  & 0.31786470E-06_JPRB, 0.31786533E-06_JPRB, 0.31786425E-06_JPRB, 0.31786237E-06_JPRB, 0.31786044E-06_JPRB, 0.31785856E-06_JPRB, &
  & 0.31785677E-06_JPRB, 0.31785487E-06_JPRB, 0.31785299E-06_JPRB, 0.31785095E-06_JPRB, 0.31784899E-06_JPRB, 0.31784714E-06_JPRB, &
  & 0.31784543E-06_JPRB, 0.31784379E-06_JPRB, 0.31784188E-06_JPRB, 0.31783856E-06_JPRB /)

RGHG3(:,65,12) = (/ &
  & 0.31776784E-06_JPRB, 0.31777046E-06_JPRB, 0.31777051E-06_JPRB, 0.31776952E-06_JPRB, 0.31776756E-06_JPRB, 0.31776455E-06_JPRB, &
  & 0.31776108E-06_JPRB, 0.31775846E-06_JPRB, 0.31775747E-06_JPRB, 0.31775807E-06_JPRB, 0.31776017E-06_JPRB, 0.31776295E-06_JPRB, &
  & 0.31776534E-06_JPRB, 0.31776622E-06_JPRB, 0.31776412E-06_JPRB, 0.31775909E-06_JPRB, 0.31775039E-06_JPRB, 0.31774132E-06_JPRB, &
  & 0.31773621E-06_JPRB, 0.31773857E-06_JPRB, 0.31774988E-06_JPRB, 0.31776918E-06_JPRB, 0.31779473E-06_JPRB, 0.31782417E-06_JPRB, &
  & 0.31785470E-06_JPRB, 0.31788358E-06_JPRB, 0.31790844E-06_JPRB, 0.31792828E-06_JPRB, 0.31794298E-06_JPRB, 0.31795307E-06_JPRB, &
  & 0.31795858E-06_JPRB, 0.31796009E-06_JPRB, 0.31795773E-06_JPRB, 0.31795179E-06_JPRB, 0.31794247E-06_JPRB, 0.31793084E-06_JPRB, &
  & 0.31791751E-06_JPRB, 0.31790344E-06_JPRB, 0.31788952E-06_JPRB, 0.31787619E-06_JPRB, 0.31786448E-06_JPRB, 0.31785567E-06_JPRB, &
  & 0.31785078E-06_JPRB, 0.31785055E-06_JPRB, 0.31785456E-06_JPRB, 0.31786112E-06_JPRB, 0.31786828E-06_JPRB, 0.31787411E-06_JPRB, &
  & 0.31787761E-06_JPRB, 0.31787829E-06_JPRB, 0.31787707E-06_JPRB, 0.31787494E-06_JPRB, 0.31787258E-06_JPRB, 0.31787030E-06_JPRB, &
  & 0.31786811E-06_JPRB, 0.31786598E-06_JPRB, 0.31786374E-06_JPRB, 0.31786152E-06_JPRB, 0.31785925E-06_JPRB, 0.31785709E-06_JPRB, &
  & 0.31785510E-06_JPRB, 0.31785316E-06_JPRB, 0.31785089E-06_JPRB, 0.31784685E-06_JPRB /)

RGHG3(:,66,12) = (/ &
  & 0.31778677E-06_JPRB, 0.31778995E-06_JPRB, 0.31779024E-06_JPRB, 0.31778947E-06_JPRB, 0.31778782E-06_JPRB, 0.31778512E-06_JPRB, &
  & 0.31778208E-06_JPRB, 0.31777969E-06_JPRB, 0.31777896E-06_JPRB, 0.31778001E-06_JPRB, 0.31778265E-06_JPRB, 0.31778603E-06_JPRB, &
  & 0.31778879E-06_JPRB, 0.31779001E-06_JPRB, 0.31778794E-06_JPRB, 0.31778373E-06_JPRB, 0.31777600E-06_JPRB, 0.31776804E-06_JPRB, &
  & 0.31776372E-06_JPRB, 0.31776639E-06_JPRB, 0.31777680E-06_JPRB, 0.31779459E-06_JPRB, 0.31781789E-06_JPRB, 0.31784450E-06_JPRB, &
  & 0.31787206E-06_JPRB, 0.31789801E-06_JPRB, 0.31792032E-06_JPRB, 0.31793786E-06_JPRB, 0.31795093E-06_JPRB, 0.31795975E-06_JPRB, &
  & 0.31796466E-06_JPRB, 0.31796588E-06_JPRB, 0.31796350E-06_JPRB, 0.31795793E-06_JPRB, 0.31794940E-06_JPRB, 0.31793860E-06_JPRB, &
  & 0.31792598E-06_JPRB, 0.31791268E-06_JPRB, 0.31789943E-06_JPRB, 0.31788684E-06_JPRB, 0.31787590E-06_JPRB, 0.31786772E-06_JPRB, &
  & 0.31786351E-06_JPRB, 0.31786371E-06_JPRB, 0.31786772E-06_JPRB, 0.31787405E-06_JPRB, 0.31788085E-06_JPRB, 0.31788639E-06_JPRB, &
  & 0.31788977E-06_JPRB, 0.31789051E-06_JPRB, 0.31788932E-06_JPRB, 0.31788710E-06_JPRB, 0.31788448E-06_JPRB, 0.31788181E-06_JPRB, &
  & 0.31787931E-06_JPRB, 0.31787675E-06_JPRB, 0.31787420E-06_JPRB, 0.31787158E-06_JPRB, 0.31786902E-06_JPRB, 0.31786664E-06_JPRB, &
  & 0.31786436E-06_JPRB, 0.31786203E-06_JPRB, 0.31785913E-06_JPRB, 0.31785385E-06_JPRB /)

RGHG3(:,67,12) = (/ &
  & 0.31780544E-06_JPRB, 0.31780868E-06_JPRB, 0.31780914E-06_JPRB, 0.31780868E-06_JPRB, 0.31780735E-06_JPRB, 0.31780507E-06_JPRB, &
  & 0.31780235E-06_JPRB, 0.31780033E-06_JPRB, 0.31780010E-06_JPRB, 0.31780164E-06_JPRB, 0.31780468E-06_JPRB, 0.31780843E-06_JPRB, &
  & 0.31781144E-06_JPRB, 0.31781283E-06_JPRB, 0.31781096E-06_JPRB, 0.31780760E-06_JPRB, 0.31780067E-06_JPRB, 0.31779402E-06_JPRB, &
  & 0.31779055E-06_JPRB, 0.31779311E-06_JPRB, 0.31780269E-06_JPRB, 0.31781875E-06_JPRB, 0.31783978E-06_JPRB, 0.31786365E-06_JPRB, &
  & 0.31788827E-06_JPRB, 0.31791137E-06_JPRB, 0.31793104E-06_JPRB, 0.31794647E-06_JPRB, 0.31795793E-06_JPRB, 0.31796566E-06_JPRB, &
  & 0.31796986E-06_JPRB, 0.31797089E-06_JPRB, 0.31796864E-06_JPRB, 0.31796350E-06_JPRB, 0.31795571E-06_JPRB, 0.31794571E-06_JPRB, &
  & 0.31793408E-06_JPRB, 0.31792152E-06_JPRB, 0.31790910E-06_JPRB, 0.31789739E-06_JPRB, 0.31788721E-06_JPRB, 0.31787980E-06_JPRB, &
  & 0.31787607E-06_JPRB, 0.31787653E-06_JPRB, 0.31788051E-06_JPRB, 0.31788659E-06_JPRB, 0.31789290E-06_JPRB, 0.31789816E-06_JPRB, &
  & 0.31790137E-06_JPRB, 0.31790211E-06_JPRB, 0.31790103E-06_JPRB, 0.31789881E-06_JPRB, 0.31789597E-06_JPRB, 0.31789310E-06_JPRB, &
  & 0.31789017E-06_JPRB, 0.31788727E-06_JPRB, 0.31788440E-06_JPRB, 0.31788159E-06_JPRB, 0.31787874E-06_JPRB, 0.31787593E-06_JPRB, &
  & 0.31787334E-06_JPRB, 0.31787053E-06_JPRB, 0.31786689E-06_JPRB, 0.31785979E-06_JPRB /)

RGHG3(:,68,12) = (/ &
  & 0.31782270E-06_JPRB, 0.31782645E-06_JPRB, 0.31782733E-06_JPRB, 0.31782713E-06_JPRB, 0.31782614E-06_JPRB, 0.31782434E-06_JPRB, &
  & 0.31782224E-06_JPRB, 0.31782068E-06_JPRB, 0.31782091E-06_JPRB, 0.31782287E-06_JPRB, 0.31782622E-06_JPRB, 0.31783011E-06_JPRB, &
  & 0.31783327E-06_JPRB, 0.31783475E-06_JPRB, 0.31783273E-06_JPRB, 0.31783043E-06_JPRB, 0.31782412E-06_JPRB, 0.31781843E-06_JPRB, &
  & 0.31781565E-06_JPRB, 0.31781826E-06_JPRB, 0.31782702E-06_JPRB, 0.31784151E-06_JPRB, 0.31786024E-06_JPRB, 0.31788139E-06_JPRB, &
  & 0.31790316E-06_JPRB, 0.31792345E-06_JPRB, 0.31794073E-06_JPRB, 0.31795420E-06_JPRB, 0.31796412E-06_JPRB, 0.31797083E-06_JPRB, &
  & 0.31797455E-06_JPRB, 0.31797532E-06_JPRB, 0.31797310E-06_JPRB, 0.31796841E-06_JPRB, 0.31796151E-06_JPRB, 0.31795236E-06_JPRB, &
  & 0.31794167E-06_JPRB, 0.31792996E-06_JPRB, 0.31791842E-06_JPRB, 0.31790768E-06_JPRB, 0.31789838E-06_JPRB, 0.31789165E-06_JPRB, &
  & 0.31788844E-06_JPRB, 0.31788912E-06_JPRB, 0.31789295E-06_JPRB, 0.31789861E-06_JPRB, 0.31790455E-06_JPRB, 0.31790933E-06_JPRB, &
  & 0.31791237E-06_JPRB, 0.31791308E-06_JPRB, 0.31791200E-06_JPRB, 0.31790984E-06_JPRB, 0.31790702E-06_JPRB, 0.31790393E-06_JPRB, &
  & 0.31790091E-06_JPRB, 0.31789770E-06_JPRB, 0.31789466E-06_JPRB, 0.31789156E-06_JPRB, 0.31788855E-06_JPRB, 0.31788554E-06_JPRB, &
  & 0.31788258E-06_JPRB, 0.31787937E-06_JPRB, 0.31787482E-06_JPRB, 0.31786570E-06_JPRB /)

RGHG3(:,69,12) = (/ &
  & 0.31783935E-06_JPRB, 0.31784379E-06_JPRB, 0.31784498E-06_JPRB, 0.31784512E-06_JPRB, 0.31784447E-06_JPRB, 0.31784316E-06_JPRB, &
  & 0.31784163E-06_JPRB, 0.31784069E-06_JPRB, 0.31784151E-06_JPRB, 0.31784379E-06_JPRB, 0.31784722E-06_JPRB, 0.31785106E-06_JPRB, &
  & 0.31785413E-06_JPRB, 0.31785572E-06_JPRB, 0.31785345E-06_JPRB, 0.31785217E-06_JPRB, 0.31784637E-06_JPRB, 0.31784168E-06_JPRB, &
  & 0.31783952E-06_JPRB, 0.31784180E-06_JPRB, 0.31784955E-06_JPRB, 0.31786240E-06_JPRB, 0.31787903E-06_JPRB, 0.31789773E-06_JPRB, &
  & 0.31791672E-06_JPRB, 0.31793437E-06_JPRB, 0.31794943E-06_JPRB, 0.31796114E-06_JPRB, 0.31796964E-06_JPRB, 0.31797552E-06_JPRB, &
  & 0.31797865E-06_JPRB, 0.31797913E-06_JPRB, 0.31797703E-06_JPRB, 0.31797282E-06_JPRB, 0.31796662E-06_JPRB, 0.31795841E-06_JPRB, &
  & 0.31794866E-06_JPRB, 0.31793803E-06_JPRB, 0.31792746E-06_JPRB, 0.31791768E-06_JPRB, 0.31790935E-06_JPRB, 0.31790330E-06_JPRB, &
  & 0.31790054E-06_JPRB, 0.31790137E-06_JPRB, 0.31790501E-06_JPRB, 0.31791029E-06_JPRB, 0.31791575E-06_JPRB, 0.31792015E-06_JPRB, &
  & 0.31792288E-06_JPRB, 0.31792356E-06_JPRB, 0.31792248E-06_JPRB, 0.31792050E-06_JPRB, 0.31791774E-06_JPRB, 0.31791456E-06_JPRB, &
  & 0.31791143E-06_JPRB, 0.31790819E-06_JPRB, 0.31790492E-06_JPRB, 0.31790179E-06_JPRB, 0.31789872E-06_JPRB, 0.31789548E-06_JPRB, &
  & 0.31789239E-06_JPRB, 0.31788878E-06_JPRB, 0.31788346E-06_JPRB, 0.31787195E-06_JPRB /)

RGHG3(:,70,12) = (/ &
  & 0.31785513E-06_JPRB, 0.31786044E-06_JPRB, 0.31786206E-06_JPRB, 0.31786260E-06_JPRB, 0.31786240E-06_JPRB, 0.31786152E-06_JPRB, &
  & 0.31786070E-06_JPRB, 0.31786041E-06_JPRB, 0.31786169E-06_JPRB, 0.31786436E-06_JPRB, 0.31786766E-06_JPRB, 0.31787130E-06_JPRB, &
  & 0.31787417E-06_JPRB, 0.31787579E-06_JPRB, 0.31787300E-06_JPRB, 0.31787255E-06_JPRB, 0.31786738E-06_JPRB, 0.31786323E-06_JPRB, &
  & 0.31786152E-06_JPRB, 0.31786357E-06_JPRB, 0.31787027E-06_JPRB, 0.31788164E-06_JPRB, 0.31789631E-06_JPRB, 0.31791268E-06_JPRB, &
  & 0.31792911E-06_JPRB, 0.31794431E-06_JPRB, 0.31795730E-06_JPRB, 0.31796728E-06_JPRB, 0.31797458E-06_JPRB, 0.31797956E-06_JPRB, &
  & 0.31798228E-06_JPRB, 0.31798254E-06_JPRB, 0.31798049E-06_JPRB, 0.31797686E-06_JPRB, 0.31797143E-06_JPRB, 0.31796401E-06_JPRB, &
  & 0.31795531E-06_JPRB, 0.31794571E-06_JPRB, 0.31793613E-06_JPRB, 0.31792737E-06_JPRB, 0.31791990E-06_JPRB, 0.31791458E-06_JPRB, &
  & 0.31791231E-06_JPRB, 0.31791342E-06_JPRB, 0.31791683E-06_JPRB, 0.31792155E-06_JPRB, 0.31792644E-06_JPRB, 0.31793047E-06_JPRB, &
  & 0.31793289E-06_JPRB, 0.31793348E-06_JPRB, 0.31793246E-06_JPRB, 0.31793067E-06_JPRB, 0.31792800E-06_JPRB, 0.31792496E-06_JPRB, &
  & 0.31792189E-06_JPRB, 0.31791865E-06_JPRB, 0.31791544E-06_JPRB, 0.31791228E-06_JPRB, 0.31790930E-06_JPRB, 0.31790603E-06_JPRB, &
  & 0.31790285E-06_JPRB, 0.31789915E-06_JPRB, 0.31789318E-06_JPRB, 0.31787962E-06_JPRB /)

RGHG3(:,71,12) = (/ &
  & 0.31787033E-06_JPRB, 0.31787684E-06_JPRB, 0.31787886E-06_JPRB, 0.31787982E-06_JPRB, 0.31788008E-06_JPRB, 0.31787960E-06_JPRB, &
  & 0.31787937E-06_JPRB, 0.31787977E-06_JPRB, 0.31788142E-06_JPRB, 0.31788412E-06_JPRB, 0.31788730E-06_JPRB, 0.31789045E-06_JPRB, &
  & 0.31789304E-06_JPRB, 0.31789475E-06_JPRB, 0.31789162E-06_JPRB, 0.31789131E-06_JPRB, 0.31788701E-06_JPRB, 0.31788338E-06_JPRB, &
  & 0.31788201E-06_JPRB, 0.31788363E-06_JPRB, 0.31788940E-06_JPRB, 0.31789932E-06_JPRB, 0.31791211E-06_JPRB, 0.31792629E-06_JPRB, &
  & 0.31794025E-06_JPRB, 0.31795329E-06_JPRB, 0.31796435E-06_JPRB, 0.31797279E-06_JPRB, 0.31797893E-06_JPRB, 0.31798311E-06_JPRB, &
  & 0.31798547E-06_JPRB, 0.31798555E-06_JPRB, 0.31798373E-06_JPRB, 0.31798044E-06_JPRB, 0.31797580E-06_JPRB, 0.31796924E-06_JPRB, &
  & 0.31796156E-06_JPRB, 0.31795298E-06_JPRB, 0.31794440E-06_JPRB, 0.31793672E-06_JPRB, 0.31793013E-06_JPRB, 0.31792561E-06_JPRB, &
  & 0.31792374E-06_JPRB, 0.31792499E-06_JPRB, 0.31792820E-06_JPRB, 0.31793243E-06_JPRB, 0.31793672E-06_JPRB, 0.31794031E-06_JPRB, &
  & 0.31794238E-06_JPRB, 0.31794295E-06_JPRB, 0.31794195E-06_JPRB, 0.31794031E-06_JPRB, 0.31793786E-06_JPRB, 0.31793510E-06_JPRB, &
  & 0.31793229E-06_JPRB, 0.31792925E-06_JPRB, 0.31792609E-06_JPRB, 0.31792302E-06_JPRB, 0.31792032E-06_JPRB, 0.31791711E-06_JPRB, &
  & 0.31791387E-06_JPRB, 0.31791026E-06_JPRB, 0.31790404E-06_JPRB, 0.31788929E-06_JPRB /)

RGHG3(:,72,12) = (/ &
  & 0.31788508E-06_JPRB, 0.31789293E-06_JPRB, 0.31789543E-06_JPRB, 0.31789671E-06_JPRB, 0.31789739E-06_JPRB, 0.31789722E-06_JPRB, &
  & 0.31789759E-06_JPRB, 0.31789838E-06_JPRB, 0.31790032E-06_JPRB, 0.31790304E-06_JPRB, 0.31790566E-06_JPRB, 0.31790853E-06_JPRB, &
  & 0.31791063E-06_JPRB, 0.31791211E-06_JPRB, 0.31790927E-06_JPRB, 0.31790847E-06_JPRB, 0.31790523E-06_JPRB, 0.31790188E-06_JPRB, &
  & 0.31790080E-06_JPRB, 0.31790211E-06_JPRB, 0.31790697E-06_JPRB, 0.31791544E-06_JPRB, 0.31792649E-06_JPRB, 0.31793860E-06_JPRB, &
  & 0.31795039E-06_JPRB, 0.31796139E-06_JPRB, 0.31797080E-06_JPRB, 0.31797777E-06_JPRB, 0.31798291E-06_JPRB, 0.31798635E-06_JPRB, &
  & 0.31798834E-06_JPRB, 0.31798822E-06_JPRB, 0.31798646E-06_JPRB, 0.31798368E-06_JPRB, 0.31797975E-06_JPRB, 0.31797401E-06_JPRB, &
  & 0.31796742E-06_JPRB, 0.31795980E-06_JPRB, 0.31795221E-06_JPRB, 0.31794568E-06_JPRB, 0.31793994E-06_JPRB, 0.31793618E-06_JPRB, &
  & 0.31793465E-06_JPRB, 0.31793618E-06_JPRB, 0.31793914E-06_JPRB, 0.31794281E-06_JPRB, 0.31794653E-06_JPRB, 0.31794957E-06_JPRB, &
  & 0.31795125E-06_JPRB, 0.31795187E-06_JPRB, 0.31795096E-06_JPRB, 0.31794963E-06_JPRB, 0.31794752E-06_JPRB, 0.31794497E-06_JPRB, &
  & 0.31794244E-06_JPRB, 0.31793962E-06_JPRB, 0.31793681E-06_JPRB, 0.31793377E-06_JPRB, 0.31793149E-06_JPRB, 0.31792834E-06_JPRB, &
  & 0.31792521E-06_JPRB, 0.31792206E-06_JPRB, 0.31791578E-06_JPRB, 0.31790037E-06_JPRB /)

RGHG3(:,73,12) = (/ &
  & 0.31790100E-06_JPRB, 0.31790927E-06_JPRB, 0.31791174E-06_JPRB, 0.31791322E-06_JPRB, 0.31791424E-06_JPRB, 0.31791430E-06_JPRB, &
  & 0.31791501E-06_JPRB, 0.31791612E-06_JPRB, 0.31791816E-06_JPRB, 0.31792050E-06_JPRB, 0.31792291E-06_JPRB, 0.31792501E-06_JPRB, &
  & 0.31792683E-06_JPRB, 0.31792794E-06_JPRB, 0.31792567E-06_JPRB, 0.31792447E-06_JPRB, 0.31792186E-06_JPRB, 0.31791888E-06_JPRB, &
  & 0.31791814E-06_JPRB, 0.31791907E-06_JPRB, 0.31792300E-06_JPRB, 0.31793024E-06_JPRB, 0.31793962E-06_JPRB, 0.31794977E-06_JPRB, &
  & 0.31795955E-06_JPRB, 0.31796867E-06_JPRB, 0.31797654E-06_JPRB, 0.31798217E-06_JPRB, 0.31798643E-06_JPRB, 0.31798908E-06_JPRB, &
  & 0.31799078E-06_JPRB, 0.31799053E-06_JPRB, 0.31798896E-06_JPRB, 0.31798646E-06_JPRB, 0.31798334E-06_JPRB, 0.31797839E-06_JPRB, &
  & 0.31797288E-06_JPRB, 0.31796628E-06_JPRB, 0.31795963E-06_JPRB, 0.31795432E-06_JPRB, 0.31794940E-06_JPRB, 0.31794627E-06_JPRB, &
  & 0.31794517E-06_JPRB, 0.31794687E-06_JPRB, 0.31794954E-06_JPRB, 0.31795258E-06_JPRB, 0.31795571E-06_JPRB, 0.31795821E-06_JPRB, &
  & 0.31795946E-06_JPRB, 0.31796017E-06_JPRB, 0.31795938E-06_JPRB, 0.31795838E-06_JPRB, 0.31795662E-06_JPRB, 0.31795449E-06_JPRB, &
  & 0.31795213E-06_JPRB, 0.31794974E-06_JPRB, 0.31794707E-06_JPRB, 0.31794437E-06_JPRB, 0.31794238E-06_JPRB, 0.31793951E-06_JPRB, &
  & 0.31793664E-06_JPRB, 0.31793400E-06_JPRB, 0.31792803E-06_JPRB, 0.31791240E-06_JPRB /)

RGHG3(:,74,12) = (/ &
  & 0.31791643E-06_JPRB, 0.31792513E-06_JPRB, 0.31792749E-06_JPRB, 0.31792894E-06_JPRB, 0.31793030E-06_JPRB, 0.31793036E-06_JPRB, &
  & 0.31793127E-06_JPRB, 0.31793243E-06_JPRB, 0.31793434E-06_JPRB, 0.31793664E-06_JPRB, 0.31793826E-06_JPRB, 0.31794016E-06_JPRB, &
  & 0.31794144E-06_JPRB, 0.31794229E-06_JPRB, 0.31794039E-06_JPRB, 0.31793903E-06_JPRB, 0.31793698E-06_JPRB, 0.31793431E-06_JPRB, &
  & 0.31793400E-06_JPRB, 0.31793468E-06_JPRB, 0.31793763E-06_JPRB, 0.31794360E-06_JPRB, 0.31795162E-06_JPRB, 0.31795989E-06_JPRB, &
  & 0.31796779E-06_JPRB, 0.31797506E-06_JPRB, 0.31798160E-06_JPRB, 0.31798612E-06_JPRB, 0.31798953E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799294E-06_JPRB, 0.31799252E-06_JPRB, 0.31799107E-06_JPRB, 0.31798891E-06_JPRB, 0.31798663E-06_JPRB, 0.31798234E-06_JPRB, &
  & 0.31797805E-06_JPRB, 0.31797242E-06_JPRB, 0.31796665E-06_JPRB, 0.31796256E-06_JPRB, 0.31795830E-06_JPRB, 0.31795582E-06_JPRB, &
  & 0.31795503E-06_JPRB, 0.31795685E-06_JPRB, 0.31795932E-06_JPRB, 0.31796171E-06_JPRB, 0.31796415E-06_JPRB, 0.31796617E-06_JPRB, &
  & 0.31796708E-06_JPRB, 0.31796779E-06_JPRB, 0.31796725E-06_JPRB, 0.31796654E-06_JPRB, 0.31796520E-06_JPRB, 0.31796318E-06_JPRB, &
  & 0.31796134E-06_JPRB, 0.31795912E-06_JPRB, 0.31795690E-06_JPRB, 0.31795429E-06_JPRB, 0.31795298E-06_JPRB, 0.31795020E-06_JPRB, &
  & 0.31794758E-06_JPRB, 0.31794573E-06_JPRB, 0.31794022E-06_JPRB, 0.31792490E-06_JPRB /)

RGHG3(:,75,12) = (/ &
  & 0.31793135E-06_JPRB, 0.31794033E-06_JPRB, 0.31794235E-06_JPRB, 0.31794372E-06_JPRB, 0.31794545E-06_JPRB, 0.31794528E-06_JPRB, &
  & 0.31794622E-06_JPRB, 0.31794718E-06_JPRB, 0.31794917E-06_JPRB, 0.31795093E-06_JPRB, 0.31795224E-06_JPRB, 0.31795358E-06_JPRB, &
  & 0.31795474E-06_JPRB, 0.31795543E-06_JPRB, 0.31795363E-06_JPRB, 0.31795227E-06_JPRB, 0.31795079E-06_JPRB, 0.31794849E-06_JPRB, &
  & 0.31794855E-06_JPRB, 0.31794889E-06_JPRB, 0.31795113E-06_JPRB, 0.31795588E-06_JPRB, 0.31796245E-06_JPRB, 0.31796904E-06_JPRB, &
  & 0.31797521E-06_JPRB, 0.31798083E-06_JPRB, 0.31798609E-06_JPRB, 0.31798962E-06_JPRB, 0.31799237E-06_JPRB, 0.31799360E-06_JPRB, &
  & 0.31799485E-06_JPRB, 0.31799428E-06_JPRB, 0.31799297E-06_JPRB, 0.31799092E-06_JPRB, 0.31798965E-06_JPRB, 0.31798592E-06_JPRB, &
  & 0.31798299E-06_JPRB, 0.31797816E-06_JPRB, 0.31797333E-06_JPRB, 0.31797049E-06_JPRB, 0.31796688E-06_JPRB, 0.31796489E-06_JPRB, &
  & 0.31796429E-06_JPRB, 0.31796634E-06_JPRB, 0.31796856E-06_JPRB, 0.31797012E-06_JPRB, 0.31797194E-06_JPRB, 0.31797339E-06_JPRB, &
  & 0.31797381E-06_JPRB, 0.31797464E-06_JPRB, 0.31797441E-06_JPRB, 0.31797418E-06_JPRB, 0.31797313E-06_JPRB, 0.31797140E-06_JPRB, &
  & 0.31796972E-06_JPRB, 0.31796799E-06_JPRB, 0.31796591E-06_JPRB, 0.31796350E-06_JPRB, 0.31796284E-06_JPRB, 0.31796026E-06_JPRB, &
  & 0.31795787E-06_JPRB, 0.31795696E-06_JPRB, 0.31795221E-06_JPRB, 0.31793752E-06_JPRB /)

RGHG3(:,76,12) = (/ &
  & 0.31794556E-06_JPRB, 0.31795480E-06_JPRB, 0.31795619E-06_JPRB, 0.31795739E-06_JPRB, 0.31795952E-06_JPRB, 0.31795889E-06_JPRB, &
  & 0.31795980E-06_JPRB, 0.31796046E-06_JPRB, 0.31796216E-06_JPRB, 0.31796390E-06_JPRB, 0.31796444E-06_JPRB, 0.31796563E-06_JPRB, &
  & 0.31796645E-06_JPRB, 0.31796719E-06_JPRB, 0.31796549E-06_JPRB, 0.31796432E-06_JPRB, 0.31796338E-06_JPRB, 0.31796120E-06_JPRB, &
  & 0.31796176E-06_JPRB, 0.31796188E-06_JPRB, 0.31796330E-06_JPRB, 0.31796699E-06_JPRB, 0.31797236E-06_JPRB, 0.31797740E-06_JPRB, &
  & 0.31798191E-06_JPRB, 0.31798584E-06_JPRB, 0.31799016E-06_JPRB, 0.31799280E-06_JPRB, 0.31799490E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799664E-06_JPRB, 0.31799581E-06_JPRB, 0.31799470E-06_JPRB, 0.31799277E-06_JPRB, 0.31799246E-06_JPRB, 0.31798922E-06_JPRB, &
  & 0.31798774E-06_JPRB, 0.31798362E-06_JPRB, 0.31797947E-06_JPRB, 0.31797802E-06_JPRB, 0.31797487E-06_JPRB, 0.31797327E-06_JPRB, &
  & 0.31797282E-06_JPRB, 0.31797518E-06_JPRB, 0.31797711E-06_JPRB, 0.31797796E-06_JPRB, 0.31797896E-06_JPRB, 0.31797998E-06_JPRB, &
  & 0.31797981E-06_JPRB, 0.31798083E-06_JPRB, 0.31798086E-06_JPRB, 0.31798118E-06_JPRB, 0.31798049E-06_JPRB, 0.31797882E-06_JPRB, &
  & 0.31797745E-06_JPRB, 0.31797592E-06_JPRB, 0.31797421E-06_JPRB, 0.31797185E-06_JPRB, 0.31797228E-06_JPRB, 0.31796969E-06_JPRB, &
  & 0.31796748E-06_JPRB, 0.31796785E-06_JPRB, 0.31796390E-06_JPRB, 0.31795008E-06_JPRB /)

RGHG3(:,77,12) = (/ &
  & 0.31795906E-06_JPRB, 0.31796836E-06_JPRB, 0.31796893E-06_JPRB, 0.31796981E-06_JPRB, 0.31797254E-06_JPRB, 0.31797117E-06_JPRB, &
  & 0.31797200E-06_JPRB, 0.31797214E-06_JPRB, 0.31797390E-06_JPRB, 0.31797526E-06_JPRB, 0.31797504E-06_JPRB, 0.31797589E-06_JPRB, &
  & 0.31797663E-06_JPRB, 0.31797751E-06_JPRB, 0.31797586E-06_JPRB, 0.31797487E-06_JPRB, 0.31797470E-06_JPRB, 0.31797271E-06_JPRB, &
  & 0.31797384E-06_JPRB, 0.31797364E-06_JPRB, 0.31797435E-06_JPRB, 0.31797700E-06_JPRB, 0.31798129E-06_JPRB, 0.31798481E-06_JPRB, &
  & 0.31798785E-06_JPRB, 0.31799036E-06_JPRB, 0.31799374E-06_JPRB, 0.31799567E-06_JPRB, 0.31799718E-06_JPRB, 0.31799686E-06_JPRB, &
  & 0.31799817E-06_JPRB, 0.31799706E-06_JPRB, 0.31799630E-06_JPRB, 0.31799431E-06_JPRB, 0.31799505E-06_JPRB, 0.31799203E-06_JPRB, &
  & 0.31799220E-06_JPRB, 0.31798874E-06_JPRB, 0.31798533E-06_JPRB, 0.31798507E-06_JPRB, 0.31798237E-06_JPRB, 0.31798106E-06_JPRB, &
  & 0.31798064E-06_JPRB, 0.31798345E-06_JPRB, 0.31798513E-06_JPRB, 0.31798510E-06_JPRB, 0.31798538E-06_JPRB, 0.31798592E-06_JPRB, &
  & 0.31798513E-06_JPRB, 0.31798632E-06_JPRB, 0.31798663E-06_JPRB, 0.31798743E-06_JPRB, 0.31798720E-06_JPRB, 0.31798550E-06_JPRB, &
  & 0.31798442E-06_JPRB, 0.31798317E-06_JPRB, 0.31798166E-06_JPRB, 0.31797933E-06_JPRB, 0.31798101E-06_JPRB, 0.31797825E-06_JPRB, &
  & 0.31797612E-06_JPRB, 0.31797811E-06_JPRB, 0.31797506E-06_JPRB, 0.31796245E-06_JPRB /)

RGHG3(:,78,12) = (/ &
  & 0.31797171E-06_JPRB, 0.31798035E-06_JPRB, 0.31797975E-06_JPRB, 0.31798027E-06_JPRB, 0.31798368E-06_JPRB, 0.31798137E-06_JPRB, &
  & 0.31798223E-06_JPRB, 0.31798180E-06_JPRB, 0.31798351E-06_JPRB, 0.31798461E-06_JPRB, 0.31798345E-06_JPRB, 0.31798419E-06_JPRB, &
  & 0.31798464E-06_JPRB, 0.31798598E-06_JPRB, 0.31798436E-06_JPRB, 0.31798371E-06_JPRB, 0.31798419E-06_JPRB, 0.31798228E-06_JPRB, &
  & 0.31798399E-06_JPRB, 0.31798365E-06_JPRB, 0.31798368E-06_JPRB, 0.31798552E-06_JPRB, 0.31798888E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799283E-06_JPRB, 0.31799408E-06_JPRB, 0.31799678E-06_JPRB, 0.31799809E-06_JPRB, 0.31799911E-06_JPRB, 0.31799800E-06_JPRB, &
  & 0.31799945E-06_JPRB, 0.31799817E-06_JPRB, 0.31799760E-06_JPRB, 0.31799547E-06_JPRB, 0.31799721E-06_JPRB, 0.31799445E-06_JPRB, &
  & 0.31799624E-06_JPRB, 0.31799323E-06_JPRB, 0.31799036E-06_JPRB, 0.31799129E-06_JPRB, 0.31798879E-06_JPRB, 0.31798774E-06_JPRB, &
  & 0.31798740E-06_JPRB, 0.31799053E-06_JPRB, 0.31799209E-06_JPRB, 0.31799121E-06_JPRB, 0.31799075E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31798942E-06_JPRB, 0.31799084E-06_JPRB, 0.31799135E-06_JPRB, 0.31799263E-06_JPRB, 0.31799286E-06_JPRB, 0.31799092E-06_JPRB, &
  & 0.31799027E-06_JPRB, 0.31798919E-06_JPRB, 0.31798791E-06_JPRB, 0.31798552E-06_JPRB, 0.31798851E-06_JPRB, 0.31798561E-06_JPRB, &
  & 0.31798359E-06_JPRB, 0.31798703E-06_JPRB, 0.31798515E-06_JPRB, 0.31797455E-06_JPRB /)

RGHG3(:,79,12) = (/ &
  & 0.31797964E-06_JPRB, 0.31798726E-06_JPRB, 0.31798541E-06_JPRB, 0.31798558E-06_JPRB, 0.31798976E-06_JPRB, 0.31798669E-06_JPRB, &
  & 0.31798754E-06_JPRB, 0.31798666E-06_JPRB, 0.31798851E-06_JPRB, 0.31798967E-06_JPRB, 0.31798777E-06_JPRB, 0.31798842E-06_JPRB, &
  & 0.31798882E-06_JPRB, 0.31799053E-06_JPRB, 0.31798879E-06_JPRB, 0.31798822E-06_JPRB, 0.31798919E-06_JPRB, 0.31798712E-06_JPRB, &
  & 0.31798962E-06_JPRB, 0.31798908E-06_JPRB, 0.31798862E-06_JPRB, 0.31799007E-06_JPRB, 0.31799317E-06_JPRB, 0.31799448E-06_JPRB, &
  & 0.31799561E-06_JPRB, 0.31799621E-06_JPRB, 0.31799865E-06_JPRB, 0.31799962E-06_JPRB, 0.31800039E-06_JPRB, 0.31799865E-06_JPRB, &
  & 0.31800033E-06_JPRB, 0.31799868E-06_JPRB, 0.31799834E-06_JPRB, 0.31799595E-06_JPRB, 0.31799843E-06_JPRB, 0.31799573E-06_JPRB, &
  & 0.31799863E-06_JPRB, 0.31799576E-06_JPRB, 0.31799294E-06_JPRB, 0.31799485E-06_JPRB, 0.31799229E-06_JPRB, 0.31799135E-06_JPRB, &
  & 0.31799095E-06_JPRB, 0.31799468E-06_JPRB, 0.31799621E-06_JPRB, 0.31799465E-06_JPRB, 0.31799357E-06_JPRB, 0.31799348E-06_JPRB, &
  & 0.31799141E-06_JPRB, 0.31799317E-06_JPRB, 0.31799379E-06_JPRB, 0.31799550E-06_JPRB, 0.31799601E-06_JPRB, 0.31799379E-06_JPRB, &
  & 0.31799340E-06_JPRB, 0.31799243E-06_JPRB, 0.31799118E-06_JPRB, 0.31798854E-06_JPRB, 0.31799252E-06_JPRB, 0.31798925E-06_JPRB, &
  & 0.31798712E-06_JPRB, 0.31799206E-06_JPRB, 0.31799107E-06_JPRB, 0.31798217E-06_JPRB /)

RGHG3(:,80,12) = (/ &
  & 0.31798456E-06_JPRB, 0.31799067E-06_JPRB, 0.31798777E-06_JPRB, 0.31798777E-06_JPRB, 0.31799249E-06_JPRB, 0.31798891E-06_JPRB, &
  & 0.31798990E-06_JPRB, 0.31798874E-06_JPRB, 0.31799081E-06_JPRB, 0.31799198E-06_JPRB, 0.31798956E-06_JPRB, 0.31799027E-06_JPRB, &
  & 0.31799061E-06_JPRB, 0.31799257E-06_JPRB, 0.31799073E-06_JPRB, 0.31799021E-06_JPRB, 0.31799149E-06_JPRB, 0.31798933E-06_JPRB, &
  & 0.31799223E-06_JPRB, 0.31799163E-06_JPRB, 0.31799087E-06_JPRB, 0.31799220E-06_JPRB, 0.31799522E-06_JPRB, 0.31799621E-06_JPRB, &
  & 0.31799689E-06_JPRB, 0.31799721E-06_JPRB, 0.31799965E-06_JPRB, 0.31800050E-06_JPRB, 0.31800116E-06_JPRB, 0.31799908E-06_JPRB, &
  & 0.31800082E-06_JPRB, 0.31799897E-06_JPRB, 0.31799857E-06_JPRB, 0.31799601E-06_JPRB, 0.31799897E-06_JPRB, 0.31799624E-06_JPRB, &
  & 0.31799988E-06_JPRB, 0.31799701E-06_JPRB, 0.31799411E-06_JPRB, 0.31799652E-06_JPRB, 0.31799385E-06_JPRB, 0.31799291E-06_JPRB, &
  & 0.31799254E-06_JPRB, 0.31799669E-06_JPRB, 0.31799834E-06_JPRB, 0.31799638E-06_JPRB, 0.31799496E-06_JPRB, 0.31799465E-06_JPRB, &
  & 0.31799217E-06_JPRB, 0.31799414E-06_JPRB, 0.31799482E-06_JPRB, 0.31799689E-06_JPRB, 0.31799755E-06_JPRB, 0.31799510E-06_JPRB, &
  & 0.31799482E-06_JPRB, 0.31799374E-06_JPRB, 0.31799252E-06_JPRB, 0.31798965E-06_JPRB, 0.31799431E-06_JPRB, 0.31799075E-06_JPRB, &
  & 0.31798851E-06_JPRB, 0.31799445E-06_JPRB, 0.31799416E-06_JPRB, 0.31798717E-06_JPRB /)

RGHG3(:,81,12) = (/ &
  & 0.31798763E-06_JPRB, 0.31799220E-06_JPRB, 0.31798891E-06_JPRB, 0.31798874E-06_JPRB, 0.31799374E-06_JPRB, 0.31798990E-06_JPRB, &
  & 0.31799087E-06_JPRB, 0.31798965E-06_JPRB, 0.31799166E-06_JPRB, 0.31799294E-06_JPRB, 0.31799044E-06_JPRB, 0.31799112E-06_JPRB, &
  & 0.31799144E-06_JPRB, 0.31799354E-06_JPRB, 0.31799161E-06_JPRB, 0.31799104E-06_JPRB, 0.31799254E-06_JPRB, 0.31799021E-06_JPRB, &
  & 0.31799348E-06_JPRB, 0.31799283E-06_JPRB, 0.31799183E-06_JPRB, 0.31799311E-06_JPRB, 0.31799624E-06_JPRB, 0.31799701E-06_JPRB, &
  & 0.31799757E-06_JPRB, 0.31799769E-06_JPRB, 0.31800010E-06_JPRB, 0.31800096E-06_JPRB, 0.31800158E-06_JPRB, 0.31799919E-06_JPRB, &
  & 0.31800113E-06_JPRB, 0.31799911E-06_JPRB, 0.31799871E-06_JPRB, 0.31799595E-06_JPRB, 0.31799925E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31800047E-06_JPRB, 0.31799755E-06_JPRB, 0.31799462E-06_JPRB, 0.31799729E-06_JPRB, 0.31799459E-06_JPRB, 0.31799357E-06_JPRB, &
  & 0.31799314E-06_JPRB, 0.31799766E-06_JPRB, 0.31799942E-06_JPRB, 0.31799718E-06_JPRB, 0.31799547E-06_JPRB, 0.31799513E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799453E-06_JPRB, 0.31799533E-06_JPRB, 0.31799757E-06_JPRB, 0.31799834E-06_JPRB, 0.31799567E-06_JPRB, &
  & 0.31799547E-06_JPRB, 0.31799439E-06_JPRB, 0.31799311E-06_JPRB, 0.31799007E-06_JPRB, 0.31799513E-06_JPRB, 0.31799141E-06_JPRB, &
  & 0.31798908E-06_JPRB, 0.31799564E-06_JPRB, 0.31799567E-06_JPRB, 0.31799044E-06_JPRB /)

RGHG3(:,82,12) = (/ &
  & 0.31798788E-06_JPRB, 0.31799271E-06_JPRB, 0.31798925E-06_JPRB, 0.31798916E-06_JPRB, 0.31799431E-06_JPRB, 0.31799033E-06_JPRB, &
  & 0.31799129E-06_JPRB, 0.31798999E-06_JPRB, 0.31799223E-06_JPRB, 0.31799360E-06_JPRB, 0.31799073E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799178E-06_JPRB, 0.31799402E-06_JPRB, 0.31799200E-06_JPRB, 0.31799146E-06_JPRB, 0.31799306E-06_JPRB, 0.31799067E-06_JPRB, &
  & 0.31799416E-06_JPRB, 0.31799337E-06_JPRB, 0.31799229E-06_JPRB, 0.31799362E-06_JPRB, 0.31799678E-06_JPRB, 0.31799740E-06_JPRB, &
  & 0.31799786E-06_JPRB, 0.31799794E-06_JPRB, 0.31800039E-06_JPRB, 0.31800127E-06_JPRB, 0.31800190E-06_JPRB, 0.31799937E-06_JPRB, &
  & 0.31800130E-06_JPRB, 0.31799911E-06_JPRB, 0.31799865E-06_JPRB, 0.31799590E-06_JPRB, 0.31799934E-06_JPRB, 0.31799664E-06_JPRB, &
  & 0.31800067E-06_JPRB, 0.31799780E-06_JPRB, 0.31799499E-06_JPRB, 0.31799760E-06_JPRB, 0.31799496E-06_JPRB, 0.31799388E-06_JPRB, &
  & 0.31799345E-06_JPRB, 0.31799823E-06_JPRB, 0.31800008E-06_JPRB, 0.31799760E-06_JPRB, 0.31799573E-06_JPRB, 0.31799530E-06_JPRB, &
  & 0.31799249E-06_JPRB, 0.31799473E-06_JPRB, 0.31799553E-06_JPRB, 0.31799797E-06_JPRB, 0.31799877E-06_JPRB, 0.31799595E-06_JPRB, &
  & 0.31799576E-06_JPRB, 0.31799468E-06_JPRB, 0.31799340E-06_JPRB, 0.31799019E-06_JPRB, 0.31799550E-06_JPRB, 0.31799163E-06_JPRB, &
  & 0.31798925E-06_JPRB, 0.31799618E-06_JPRB, 0.31799624E-06_JPRB, 0.31799070E-06_JPRB /)

RGHG3(:,83,12) = (/ &
  & 0.31798803E-06_JPRB, 0.31799308E-06_JPRB, 0.31798953E-06_JPRB, 0.31798942E-06_JPRB, 0.31799465E-06_JPRB, 0.31799055E-06_JPRB, &
  & 0.31799155E-06_JPRB, 0.31799024E-06_JPRB, 0.31799237E-06_JPRB, 0.31799379E-06_JPRB, 0.31799107E-06_JPRB, 0.31799175E-06_JPRB, &
  & 0.31799206E-06_JPRB, 0.31799428E-06_JPRB, 0.31799220E-06_JPRB, 0.31799163E-06_JPRB, 0.31799331E-06_JPRB, 0.31799087E-06_JPRB, &
  & 0.31799456E-06_JPRB, 0.31799379E-06_JPRB, 0.31799257E-06_JPRB, 0.31799385E-06_JPRB, 0.31799712E-06_JPRB, 0.31799772E-06_JPRB, &
  & 0.31799814E-06_JPRB, 0.31799811E-06_JPRB, 0.31800062E-06_JPRB, 0.31800144E-06_JPRB, 0.31800209E-06_JPRB, 0.31799934E-06_JPRB, &
  & 0.31800144E-06_JPRB, 0.31799914E-06_JPRB, 0.31799871E-06_JPRB, 0.31799593E-06_JPRB, 0.31799937E-06_JPRB, 0.31799684E-06_JPRB, &
  & 0.31800076E-06_JPRB, 0.31799803E-06_JPRB, 0.31799533E-06_JPRB, 0.31799777E-06_JPRB, 0.31799522E-06_JPRB, 0.31799411E-06_JPRB, &
  & 0.31799374E-06_JPRB, 0.31799848E-06_JPRB, 0.31800053E-06_JPRB, 0.31799792E-06_JPRB, 0.31799587E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799246E-06_JPRB, 0.31799479E-06_JPRB, 0.31799561E-06_JPRB, 0.31799820E-06_JPRB, 0.31799897E-06_JPRB, 0.31799613E-06_JPRB, &
  & 0.31799590E-06_JPRB, 0.31799476E-06_JPRB, 0.31799348E-06_JPRB, 0.31799019E-06_JPRB, 0.31799578E-06_JPRB, 0.31799181E-06_JPRB, &
  & 0.31798928E-06_JPRB, 0.31799652E-06_JPRB, 0.31799658E-06_JPRB, 0.31799084E-06_JPRB /)

RGHG3(:,84,12) = (/ &
  & 0.31798805E-06_JPRB, 0.31799325E-06_JPRB, 0.31798965E-06_JPRB, 0.31798950E-06_JPRB, 0.31799485E-06_JPRB, 0.31799073E-06_JPRB, &
  & 0.31799163E-06_JPRB, 0.31799038E-06_JPRB, 0.31799269E-06_JPRB, 0.31799385E-06_JPRB, 0.31799118E-06_JPRB, 0.31799183E-06_JPRB, &
  & 0.31799229E-06_JPRB, 0.31799436E-06_JPRB, 0.31799240E-06_JPRB, 0.31799178E-06_JPRB, 0.31799345E-06_JPRB, 0.31799101E-06_JPRB, &
  & 0.31799479E-06_JPRB, 0.31799399E-06_JPRB, 0.31799277E-06_JPRB, 0.31799416E-06_JPRB, 0.31799735E-06_JPRB, 0.31799783E-06_JPRB, &
  & 0.31799820E-06_JPRB, 0.31799823E-06_JPRB, 0.31800076E-06_JPRB, 0.31800161E-06_JPRB, 0.31800224E-06_JPRB, 0.31799934E-06_JPRB, &
  & 0.31800153E-06_JPRB, 0.31799914E-06_JPRB, 0.31799868E-06_JPRB, 0.31799587E-06_JPRB, 0.31799931E-06_JPRB, 0.31799698E-06_JPRB, &
  & 0.31800073E-06_JPRB, 0.31799814E-06_JPRB, 0.31799553E-06_JPRB, 0.31799786E-06_JPRB, 0.31799536E-06_JPRB, 0.31799419E-06_JPRB, &
  & 0.31799379E-06_JPRB, 0.31799880E-06_JPRB, 0.31800082E-06_JPRB, 0.31799811E-06_JPRB, 0.31799587E-06_JPRB, 0.31799539E-06_JPRB, &
  & 0.31799237E-06_JPRB, 0.31799476E-06_JPRB, 0.31799564E-06_JPRB, 0.31799831E-06_JPRB, 0.31799911E-06_JPRB, 0.31799624E-06_JPRB, &
  & 0.31799595E-06_JPRB, 0.31799487E-06_JPRB, 0.31799357E-06_JPRB, 0.31799019E-06_JPRB, 0.31799593E-06_JPRB, 0.31799183E-06_JPRB, &
  & 0.31798928E-06_JPRB, 0.31799675E-06_JPRB, 0.31799686E-06_JPRB, 0.31799098E-06_JPRB /)

RGHG3(:,85,12) = (/ &
  & 0.31798814E-06_JPRB, 0.31799345E-06_JPRB, 0.31798967E-06_JPRB, 0.31798953E-06_JPRB, 0.31799510E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799070E-06_JPRB, 0.31799254E-06_JPRB, 0.31799348E-06_JPRB, 0.31799169E-06_JPRB, 0.31799209E-06_JPRB, &
  & 0.31799252E-06_JPRB, 0.31799419E-06_JPRB, 0.31799249E-06_JPRB, 0.31799198E-06_JPRB, 0.31799360E-06_JPRB, 0.31799118E-06_JPRB, &
  & 0.31799505E-06_JPRB, 0.31799419E-06_JPRB, 0.31799283E-06_JPRB, 0.31799422E-06_JPRB, 0.31799757E-06_JPRB, 0.31799797E-06_JPRB, &
  & 0.31799829E-06_JPRB, 0.31799823E-06_JPRB, 0.31800096E-06_JPRB, 0.31800178E-06_JPRB, 0.31800238E-06_JPRB, 0.31799939E-06_JPRB, &
  & 0.31800164E-06_JPRB, 0.31799914E-06_JPRB, 0.31799863E-06_JPRB, 0.31799584E-06_JPRB, 0.31799925E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31800076E-06_JPRB, 0.31799831E-06_JPRB, 0.31799567E-06_JPRB, 0.31799797E-06_JPRB, 0.31799544E-06_JPRB, 0.31799428E-06_JPRB, &
  & 0.31799394E-06_JPRB, 0.31799891E-06_JPRB, 0.31800116E-06_JPRB, 0.31799831E-06_JPRB, 0.31799587E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799232E-06_JPRB, 0.31799476E-06_JPRB, 0.31799570E-06_JPRB, 0.31799843E-06_JPRB, 0.31799931E-06_JPRB, 0.31799632E-06_JPRB, &
  & 0.31799604E-06_JPRB, 0.31799490E-06_JPRB, 0.31799357E-06_JPRB, 0.31799010E-06_JPRB, 0.31799607E-06_JPRB, 0.31799186E-06_JPRB, &
  & 0.31798925E-06_JPRB, 0.31799692E-06_JPRB, 0.31799709E-06_JPRB, 0.31799109E-06_JPRB /)

RGHG3(:,86,12) = (/ &
  & 0.31798808E-06_JPRB, 0.31799357E-06_JPRB, 0.31798970E-06_JPRB, 0.31798942E-06_JPRB, 0.31799530E-06_JPRB, 0.31799092E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799107E-06_JPRB, 0.31799254E-06_JPRB, 0.31799317E-06_JPRB, 0.31799198E-06_JPRB, 0.31799220E-06_JPRB, &
  & 0.31799263E-06_JPRB, 0.31799391E-06_JPRB, 0.31799263E-06_JPRB, 0.31799217E-06_JPRB, 0.31799351E-06_JPRB, 0.31799135E-06_JPRB, &
  & 0.31799516E-06_JPRB, 0.31799433E-06_JPRB, 0.31799280E-06_JPRB, 0.31799425E-06_JPRB, 0.31799769E-06_JPRB, 0.31799806E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799820E-06_JPRB, 0.31800113E-06_JPRB, 0.31800195E-06_JPRB, 0.31800249E-06_JPRB, 0.31799931E-06_JPRB, &
  & 0.31800170E-06_JPRB, 0.31799914E-06_JPRB, 0.31799863E-06_JPRB, 0.31799578E-06_JPRB, 0.31799928E-06_JPRB, 0.31799703E-06_JPRB, &
  & 0.31800090E-06_JPRB, 0.31799837E-06_JPRB, 0.31799561E-06_JPRB, 0.31799820E-06_JPRB, 0.31799550E-06_JPRB, 0.31799425E-06_JPRB, &
  & 0.31799382E-06_JPRB, 0.31799922E-06_JPRB, 0.31800141E-06_JPRB, 0.31799837E-06_JPRB, 0.31799581E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799226E-06_JPRB, 0.31799473E-06_JPRB, 0.31799573E-06_JPRB, 0.31799860E-06_JPRB, 0.31799945E-06_JPRB, 0.31799635E-06_JPRB, &
  & 0.31799607E-06_JPRB, 0.31799487E-06_JPRB, 0.31799351E-06_JPRB, 0.31799010E-06_JPRB, 0.31799615E-06_JPRB, 0.31799189E-06_JPRB, &
  & 0.31798913E-06_JPRB, 0.31799706E-06_JPRB, 0.31799726E-06_JPRB, 0.31799118E-06_JPRB /)

RGHG3(:,87,12) = (/ &
  & 0.31798808E-06_JPRB, 0.31799368E-06_JPRB, 0.31798973E-06_JPRB, 0.31798936E-06_JPRB, 0.31799533E-06_JPRB, 0.31799090E-06_JPRB, &
  & 0.31799172E-06_JPRB, 0.31799127E-06_JPRB, 0.31799249E-06_JPRB, 0.31799297E-06_JPRB, 0.31799209E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799269E-06_JPRB, 0.31799360E-06_JPRB, 0.31799263E-06_JPRB, 0.31799226E-06_JPRB, 0.31799343E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799510E-06_JPRB, 0.31799436E-06_JPRB, 0.31799274E-06_JPRB, 0.31799419E-06_JPRB, 0.31799780E-06_JPRB, 0.31799811E-06_JPRB, &
  & 0.31799840E-06_JPRB, 0.31799814E-06_JPRB, 0.31800130E-06_JPRB, 0.31800209E-06_JPRB, 0.31800266E-06_JPRB, 0.31799931E-06_JPRB, &
  & 0.31800172E-06_JPRB, 0.31799908E-06_JPRB, 0.31799851E-06_JPRB, 0.31799567E-06_JPRB, 0.31799931E-06_JPRB, 0.31799695E-06_JPRB, &
  & 0.31800113E-06_JPRB, 0.31799848E-06_JPRB, 0.31799544E-06_JPRB, 0.31799848E-06_JPRB, 0.31799547E-06_JPRB, 0.31799422E-06_JPRB, &
  & 0.31799374E-06_JPRB, 0.31799942E-06_JPRB, 0.31800167E-06_JPRB, 0.31799854E-06_JPRB, 0.31799581E-06_JPRB, 0.31799536E-06_JPRB, &
  & 0.31799215E-06_JPRB, 0.31799465E-06_JPRB, 0.31799576E-06_JPRB, 0.31799868E-06_JPRB, 0.31799956E-06_JPRB, 0.31799638E-06_JPRB, &
  & 0.31799607E-06_JPRB, 0.31799479E-06_JPRB, 0.31799348E-06_JPRB, 0.31798999E-06_JPRB, 0.31799618E-06_JPRB, 0.31799195E-06_JPRB, &
  & 0.31798908E-06_JPRB, 0.31799715E-06_JPRB, 0.31799740E-06_JPRB, 0.31799127E-06_JPRB /)

RGHG3(:,88,12) = (/ &
  & 0.31798805E-06_JPRB, 0.31799365E-06_JPRB, 0.31798973E-06_JPRB, 0.31798922E-06_JPRB, 0.31799544E-06_JPRB, 0.31799095E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799135E-06_JPRB, 0.31799249E-06_JPRB, 0.31799300E-06_JPRB, 0.31799229E-06_JPRB, 0.31799246E-06_JPRB, &
  & 0.31799277E-06_JPRB, 0.31799360E-06_JPRB, 0.31799269E-06_JPRB, 0.31799235E-06_JPRB, 0.31799343E-06_JPRB, 0.31799149E-06_JPRB, &
  & 0.31799519E-06_JPRB, 0.31799436E-06_JPRB, 0.31799266E-06_JPRB, 0.31799416E-06_JPRB, 0.31799794E-06_JPRB, 0.31799814E-06_JPRB, &
  & 0.31799837E-06_JPRB, 0.31799806E-06_JPRB, 0.31800144E-06_JPRB, 0.31800221E-06_JPRB, 0.31800275E-06_JPRB, 0.31799928E-06_JPRB, &
  & 0.31800178E-06_JPRB, 0.31799905E-06_JPRB, 0.31799851E-06_JPRB, 0.31799553E-06_JPRB, 0.31799934E-06_JPRB, 0.31799686E-06_JPRB, &
  & 0.31800141E-06_JPRB, 0.31799854E-06_JPRB, 0.31799522E-06_JPRB, 0.31799883E-06_JPRB, 0.31799550E-06_JPRB, 0.31799416E-06_JPRB, &
  & 0.31799354E-06_JPRB, 0.31799959E-06_JPRB, 0.31800181E-06_JPRB, 0.31799863E-06_JPRB, 0.31799578E-06_JPRB, 0.31799533E-06_JPRB, &
  & 0.31799206E-06_JPRB, 0.31799456E-06_JPRB, 0.31799576E-06_JPRB, 0.31799880E-06_JPRB, 0.31799968E-06_JPRB, 0.31799641E-06_JPRB, &
  & 0.31799607E-06_JPRB, 0.31799476E-06_JPRB, 0.31799351E-06_JPRB, 0.31798993E-06_JPRB, 0.31799627E-06_JPRB, 0.31799189E-06_JPRB, &
  & 0.31798896E-06_JPRB, 0.31799723E-06_JPRB, 0.31799757E-06_JPRB, 0.31799132E-06_JPRB /)

RGHG3(:,89,12) = (/ &
  & 0.31798817E-06_JPRB, 0.31799360E-06_JPRB, 0.31798976E-06_JPRB, 0.31798919E-06_JPRB, 0.31799567E-06_JPRB, 0.31799078E-06_JPRB, &
  & 0.31799178E-06_JPRB, 0.31799124E-06_JPRB, 0.31799254E-06_JPRB, 0.31799306E-06_JPRB, 0.31799215E-06_JPRB, 0.31799232E-06_JPRB, &
  & 0.31799274E-06_JPRB, 0.31799365E-06_JPRB, 0.31799257E-06_JPRB, 0.31799226E-06_JPRB, 0.31799357E-06_JPRB, 0.31799146E-06_JPRB, &
  & 0.31799524E-06_JPRB, 0.31799442E-06_JPRB, 0.31799257E-06_JPRB, 0.31799414E-06_JPRB, 0.31799809E-06_JPRB, 0.31799820E-06_JPRB, &
  & 0.31799834E-06_JPRB, 0.31799794E-06_JPRB, 0.31800158E-06_JPRB, 0.31800238E-06_JPRB, 0.31800295E-06_JPRB, 0.31799922E-06_JPRB, &
  & 0.31800178E-06_JPRB, 0.31799902E-06_JPRB, 0.31799848E-06_JPRB, 0.31799536E-06_JPRB, 0.31799954E-06_JPRB, 0.31799675E-06_JPRB, &
  & 0.31800170E-06_JPRB, 0.31799865E-06_JPRB, 0.31799499E-06_JPRB, 0.31799908E-06_JPRB, 0.31799544E-06_JPRB, 0.31799405E-06_JPRB, &
  & 0.31799343E-06_JPRB, 0.31799976E-06_JPRB, 0.31800198E-06_JPRB, 0.31799865E-06_JPRB, 0.31799576E-06_JPRB, 0.31799533E-06_JPRB, &
  & 0.31799189E-06_JPRB, 0.31799453E-06_JPRB, 0.31799578E-06_JPRB, 0.31799888E-06_JPRB, 0.31799976E-06_JPRB, 0.31799644E-06_JPRB, &
  & 0.31799613E-06_JPRB, 0.31799482E-06_JPRB, 0.31799351E-06_JPRB, 0.31798987E-06_JPRB, 0.31799644E-06_JPRB, 0.31799195E-06_JPRB, &
  & 0.31798891E-06_JPRB, 0.31799740E-06_JPRB, 0.31799766E-06_JPRB, 0.31799129E-06_JPRB /)

RGHG3(:,90,12) = (/ &
  & 0.31798842E-06_JPRB, 0.31799360E-06_JPRB, 0.31798979E-06_JPRB, 0.31798891E-06_JPRB, 0.31799610E-06_JPRB, 0.31799053E-06_JPRB, &
  & 0.31799189E-06_JPRB, 0.31799087E-06_JPRB, 0.31799254E-06_JPRB, 0.31799345E-06_JPRB, 0.31799200E-06_JPRB, 0.31799226E-06_JPRB, &
  & 0.31799274E-06_JPRB, 0.31799408E-06_JPRB, 0.31799249E-06_JPRB, 0.31799200E-06_JPRB, 0.31799382E-06_JPRB, 0.31799112E-06_JPRB, &
  & 0.31799559E-06_JPRB, 0.31799451E-06_JPRB, 0.31799246E-06_JPRB, 0.31799405E-06_JPRB, 0.31799823E-06_JPRB, 0.31799823E-06_JPRB, &
  & 0.31799843E-06_JPRB, 0.31799780E-06_JPRB, 0.31800170E-06_JPRB, 0.31800244E-06_JPRB, 0.31800312E-06_JPRB, 0.31799902E-06_JPRB, &
  & 0.31800204E-06_JPRB, 0.31799897E-06_JPRB, 0.31799863E-06_JPRB, 0.31799496E-06_JPRB, 0.31799973E-06_JPRB, 0.31799632E-06_JPRB, &
  & 0.31800218E-06_JPRB, 0.31799874E-06_JPRB, 0.31799470E-06_JPRB, 0.31799931E-06_JPRB, 0.31799544E-06_JPRB, 0.31799399E-06_JPRB, &
  & 0.31799320E-06_JPRB, 0.31799988E-06_JPRB, 0.31800218E-06_JPRB, 0.31799871E-06_JPRB, 0.31799573E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31799175E-06_JPRB, 0.31799456E-06_JPRB, 0.31799576E-06_JPRB, 0.31799902E-06_JPRB, 0.31799993E-06_JPRB, 0.31799632E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799476E-06_JPRB, 0.31799354E-06_JPRB, 0.31798967E-06_JPRB, 0.31799678E-06_JPRB, 0.31799189E-06_JPRB, &
  & 0.31798865E-06_JPRB, 0.31799763E-06_JPRB, 0.31799780E-06_JPRB, 0.31799124E-06_JPRB /)

RGHG3(:,91,12) = (/ &
  & 0.31798893E-06_JPRB, 0.31799374E-06_JPRB, 0.31798959E-06_JPRB, 0.31798828E-06_JPRB, 0.31799712E-06_JPRB, 0.31798990E-06_JPRB, &
  & 0.31799237E-06_JPRB, 0.31798967E-06_JPRB, 0.31799289E-06_JPRB, 0.31799547E-06_JPRB, 0.31799041E-06_JPRB, 0.31799203E-06_JPRB, &
  & 0.31799243E-06_JPRB, 0.31799539E-06_JPRB, 0.31799206E-06_JPRB, 0.31799163E-06_JPRB, 0.31799448E-06_JPRB, 0.31799024E-06_JPRB, &
  & 0.31799610E-06_JPRB, 0.31799462E-06_JPRB, 0.31799217E-06_JPRB, 0.31799394E-06_JPRB, 0.31799854E-06_JPRB, 0.31799823E-06_JPRB, &
  & 0.31799846E-06_JPRB, 0.31799746E-06_JPRB, 0.31800192E-06_JPRB, 0.31800238E-06_JPRB, 0.31800340E-06_JPRB, 0.31799851E-06_JPRB, &
  & 0.31800246E-06_JPRB, 0.31799877E-06_JPRB, 0.31799891E-06_JPRB, 0.31799405E-06_JPRB, 0.31800050E-06_JPRB, 0.31799541E-06_JPRB, &
  & 0.31800323E-06_JPRB, 0.31799865E-06_JPRB, 0.31799408E-06_JPRB, 0.31799988E-06_JPRB, 0.31799527E-06_JPRB, 0.31799391E-06_JPRB, &
  & 0.31799274E-06_JPRB, 0.31800019E-06_JPRB, 0.31800261E-06_JPRB, 0.31799868E-06_JPRB, 0.31799559E-06_JPRB, 0.31799559E-06_JPRB, &
  & 0.31799127E-06_JPRB, 0.31799465E-06_JPRB, 0.31799561E-06_JPRB, 0.31799917E-06_JPRB, 0.31800019E-06_JPRB, 0.31799610E-06_JPRB, &
  & 0.31799621E-06_JPRB, 0.31799479E-06_JPRB, 0.31799368E-06_JPRB, 0.31798896E-06_JPRB, 0.31799757E-06_JPRB, 0.31799172E-06_JPRB, &
  & 0.31798794E-06_JPRB, 0.31799826E-06_JPRB, 0.31799794E-06_JPRB, 0.31799104E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_N2OCLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_N2OCLIM
