!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_NO2CLIM


!**   NITROGEN DIOXIDE CLIMATOLOGY FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_NO2CLIM* FROM *SUECRAD*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG4

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLNO2(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------
! REAL(KIND=JPRB),SAVE :: ZGHG4(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG4(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLNO2(:,:,:)=ZGHG4(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG4(:, 1, 1) = (/ &
  & 0.12411871E-12_JPRB, 0.11076041E-12_JPRB, 0.10160462E-12_JPRB, 0.11649449E-12_JPRB, 0.12173941E-12_JPRB, 0.13597427E-12_JPRB, &
  & 0.13866082E-12_JPRB, 0.14127982E-12_JPRB, 0.14188817E-12_JPRB, 0.14045756E-12_JPRB, 0.14114063E-12_JPRB, 0.13650427E-12_JPRB, &
  & 0.13611905E-12_JPRB, 0.13682175E-12_JPRB, 0.13059268E-12_JPRB, 0.13086017E-12_JPRB, 0.13111051E-12_JPRB, 0.13302587E-12_JPRB, &
  & 0.12728024E-12_JPRB, 0.12698330E-12_JPRB, 0.12719428E-12_JPRB, 0.12806248E-12_JPRB, 0.12990690E-12_JPRB, 0.13345686E-12_JPRB, &
  & 0.12988022E-12_JPRB, 0.13248593E-12_JPRB, 0.13510146E-12_JPRB, 0.13760420E-12_JPRB, 0.13964494E-12_JPRB, 0.14091679E-12_JPRB, &
  & 0.14107663E-12_JPRB, 0.14035908E-12_JPRB, 0.13012981E-12_JPRB, 0.12472969E-12_JPRB, 0.11903548E-12_JPRB, 0.11390509E-12_JPRB, &
  & 0.11014603E-12_JPRB, 0.10827003E-12_JPRB, 0.10847276E-12_JPRB, 0.11129053E-12_JPRB, 0.10702734E-12_JPRB, 0.10847883E-12_JPRB, &
  & 0.10949486E-12_JPRB, 0.10985969E-12_JPRB, 0.10946050E-12_JPRB, 0.10913877E-12_JPRB, 0.10102479E-12_JPRB, 0.98036488E-13_JPRB, &
  & 0.95145761E-13_JPRB, 0.92869221E-13_JPRB, 0.83692059E-13_JPRB, 0.77800844E-13_JPRB, 0.70758476E-13_JPRB, 0.54775974E-13_JPRB, &
  & 0.40088487E-13_JPRB, 0.33998493E-13_JPRB, 0.12808054E-13_JPRB, 0.16267744E-13_JPRB, 0.97364250E-09_JPRB, 0.97577946E-09_JPRB, &
  & 0.97416175E-09_JPRB, 0.97860031E-09_JPRB, 0.97863329E-09_JPRB, 0.99115904E-09_JPRB /)

RGHG4(:, 2, 1) = (/ &
  & 0.11031948E-11_JPRB, 0.73193648E-12_JPRB, 0.61486835E-12_JPRB, 0.60861288E-12_JPRB, 0.63195125E-12_JPRB, 0.68722236E-12_JPRB, &
  & 0.75574920E-12_JPRB, 0.83194096E-12_JPRB, 0.90524750E-12_JPRB, 0.95791452E-12_JPRB, 0.98125360E-12_JPRB, 0.10173187E-11_JPRB, &
  & 0.10718481E-11_JPRB, 0.11334758E-11_JPRB, 0.12285178E-11_JPRB, 0.13185101E-11_JPRB, 0.13733527E-11_JPRB, 0.14307304E-11_JPRB, &
  & 0.14490831E-11_JPRB, 0.14073699E-11_JPRB, 0.13617191E-11_JPRB, 0.12997458E-11_JPRB, 0.12269210E-11_JPRB, 0.11509021E-11_JPRB, &
  & 0.10783237E-11_JPRB, 0.10016923E-11_JPRB, 0.93831822E-12_JPRB, 0.87999383E-12_JPRB, 0.82568799E-12_JPRB, 0.77759115E-12_JPRB, &
  & 0.73606502E-12_JPRB, 0.69997784E-12_JPRB, 0.67178901E-12_JPRB, 0.62743463E-12_JPRB, 0.59838105E-12_JPRB, 0.57713952E-12_JPRB, &
  & 0.56071001E-12_JPRB, 0.54943897E-12_JPRB, 0.54471277E-12_JPRB, 0.54223233E-12_JPRB, 0.52592430E-12_JPRB, 0.51259382E-12_JPRB, &
  & 0.49437803E-12_JPRB, 0.46968717E-12_JPRB, 0.43656273E-12_JPRB, 0.39934771E-12_JPRB, 0.36015535E-12_JPRB, 0.33224663E-12_JPRB, &
  & 0.31360895E-12_JPRB, 0.30224911E-12_JPRB, 0.29174631E-12_JPRB, 0.27862958E-12_JPRB, 0.26232388E-12_JPRB, 0.24431244E-12_JPRB, &
  & 0.22792984E-12_JPRB, 0.21472395E-12_JPRB, 0.13210692E-12_JPRB, 0.13206600E-12_JPRB, 0.10048394E-19_JPRB, 0.10040637E-19_JPRB, &
  & 0.10032232E-19_JPRB, 0.10024247E-19_JPRB, 0.10017789E-19_JPRB, 0.10013801E-19_JPRB /)

RGHG4(:, 3, 1) = (/ &
  & 0.24165845E-11_JPRB, 0.17111903E-11_JPRB, 0.14966432E-11_JPRB, 0.14010308E-11_JPRB, 0.13606192E-11_JPRB, 0.13616971E-11_JPRB, &
  & 0.13945572E-11_JPRB, 0.14638383E-11_JPRB, 0.16262889E-11_JPRB, 0.17346659E-11_JPRB, 0.18302150E-11_JPRB, 0.19538245E-11_JPRB, &
  & 0.20913412E-11_JPRB, 0.22417530E-11_JPRB, 0.24094535E-11_JPRB, 0.25325254E-11_JPRB, 0.25984035E-11_JPRB, 0.26686268E-11_JPRB, &
  & 0.26383912E-11_JPRB, 0.25595719E-11_JPRB, 0.24955355E-11_JPRB, 0.23987934E-11_JPRB, 0.22895223E-11_JPRB, 0.21734873E-11_JPRB, &
  & 0.20582800E-11_JPRB, 0.19415218E-11_JPRB, 0.18521209E-11_JPRB, 0.17605195E-11_JPRB, 0.16743987E-11_JPRB, 0.15928607E-11_JPRB, &
  & 0.15150153E-11_JPRB, 0.14385588E-11_JPRB, 0.13752654E-11_JPRB, 0.12897779E-11_JPRB, 0.12314133E-11_JPRB, 0.11895686E-11_JPRB, &
  & 0.11662186E-11_JPRB, 0.11578475E-11_JPRB, 0.11685056E-11_JPRB, 0.11824727E-11_JPRB, 0.11743867E-11_JPRB, 0.11610516E-11_JPRB, &
  & 0.11239102E-11_JPRB, 0.10691931E-11_JPRB, 0.99400230E-12_JPRB, 0.90610706E-12_JPRB, 0.80826860E-12_JPRB, 0.72180391E-12_JPRB, &
  & 0.64138863E-12_JPRB, 0.56730234E-12_JPRB, 0.50337767E-12_JPRB, 0.45655618E-12_JPRB, 0.42696725E-12_JPRB, 0.40677406E-12_JPRB, &
  & 0.39124151E-12_JPRB, 0.38017232E-12_JPRB, 0.30147941E-12_JPRB, 0.36398415E-12_JPRB, 0.55905264E-20_JPRB, 0.55888268E-20_JPRB, &
  & 0.55864640E-20_JPRB, 0.55839449E-20_JPRB, 0.55817849E-20_JPRB, 0.55804229E-20_JPRB /)

RGHG4(:, 4, 1) = (/ &
  & 0.58334483E-11_JPRB, 0.47691304E-11_JPRB, 0.43218064E-11_JPRB, 0.40923254E-11_JPRB, 0.39776476E-11_JPRB, 0.39416955E-11_JPRB, &
  & 0.39654998E-11_JPRB, 0.40350770E-11_JPRB, 0.41972120E-11_JPRB, 0.43135898E-11_JPRB, 0.44495362E-11_JPRB, 0.46338337E-11_JPRB, &
  & 0.48200966E-11_JPRB, 0.50157053E-11_JPRB, 0.51815761E-11_JPRB, 0.52689550E-11_JPRB, 0.52890001E-11_JPRB, 0.53001479E-11_JPRB, &
  & 0.51873987E-11_JPRB, 0.50409598E-11_JPRB, 0.49274465E-11_JPRB, 0.47840247E-11_JPRB, 0.46186822E-11_JPRB, 0.44540070E-11_JPRB, &
  & 0.42837175E-11_JPRB, 0.41324973E-11_JPRB, 0.40263825E-11_JPRB, 0.38883575E-11_JPRB, 0.37594047E-11_JPRB, 0.36262115E-11_JPRB, &
  & 0.34938395E-11_JPRB, 0.33601099E-11_JPRB, 0.32518797E-11_JPRB, 0.31065569E-11_JPRB, 0.30073561E-11_JPRB, 0.29454163E-11_JPRB, &
  & 0.29235431E-11_JPRB, 0.29413822E-11_JPRB, 0.30097014E-11_JPRB, 0.30811302E-11_JPRB, 0.30978078E-11_JPRB, 0.30755873E-11_JPRB, &
  & 0.29801860E-11_JPRB, 0.28346834E-11_JPRB, 0.26394416E-11_JPRB, 0.24162087E-11_JPRB, 0.21759931E-11_JPRB, 0.19552673E-11_JPRB, &
  & 0.17496493E-11_JPRB, 0.15651703E-11_JPRB, 0.14053986E-11_JPRB, 0.12677329E-11_JPRB, 0.11447344E-11_JPRB, 0.10409402E-11_JPRB, &
  & 0.96551131E-12_JPRB, 0.91588510E-12_JPRB, 0.75467269E-12_JPRB, 0.12501299E-11_JPRB, 0.30866534E-09_JPRB, 0.29131098E-09_JPRB, &
  & 0.32235853E-09_JPRB, 0.36999143E-09_JPRB, 0.43244747E-09_JPRB, 0.56073357E-09_JPRB /)

RGHG4(:, 5, 1) = (/ &
  & 0.14582566E-10_JPRB, 0.12932965E-10_JPRB, 0.12022216E-10_JPRB, 0.11445059E-10_JPRB, 0.11098252E-10_JPRB, 0.10918819E-10_JPRB, &
  & 0.10958980E-10_JPRB, 0.11097175E-10_JPRB, 0.11309394E-10_JPRB, 0.11538884E-10_JPRB, 0.11781196E-10_JPRB, 0.12061482E-10_JPRB, &
  & 0.12294481E-10_JPRB, 0.12506590E-10_JPRB, 0.12635469E-10_JPRB, 0.12634104E-10_JPRB, 0.12571135E-10_JPRB, 0.12454648E-10_JPRB, &
  & 0.12231550E-10_JPRB, 0.11992215E-10_JPRB, 0.11805575E-10_JPRB, 0.11624881E-10_JPRB, 0.11426166E-10_JPRB, 0.11231435E-10_JPRB, &
  & 0.11050797E-10_JPRB, 0.10907015E-10_JPRB, 0.10824818E-10_JPRB, 0.10679033E-10_JPRB, 0.10499444E-10_JPRB, 0.10288428E-10_JPRB, &
  & 0.10026991E-10_JPRB, 0.97361997E-11_JPRB, 0.94973794E-11_JPRB, 0.92026256E-11_JPRB, 0.89966246E-11_JPRB, 0.88744827E-11_JPRB, &
  & 0.88657484E-11_JPRB, 0.89496891E-11_JPRB, 0.91070424E-11_JPRB, 0.92153941E-11_JPRB, 0.91401409E-11_JPRB, 0.88977497E-11_JPRB, &
  & 0.84678245E-11_JPRB, 0.79310889E-11_JPRB, 0.73218705E-11_JPRB, 0.66944757E-11_JPRB, 0.60732864E-11_JPRB, 0.55076044E-11_JPRB, &
  & 0.49812355E-11_JPRB, 0.44886811E-11_JPRB, 0.40361442E-11_JPRB, 0.36280169E-11_JPRB, 0.32725509E-11_JPRB, 0.29825374E-11_JPRB, &
  & 0.27595142E-11_JPRB, 0.25989265E-11_JPRB, 0.23452848E-11_JPRB, 0.43658493E-11_JPRB, 0.13641439E-08_JPRB, 0.13234422E-08_JPRB, &
  & 0.13244850E-08_JPRB, 0.13445624E-08_JPRB, 0.13887966E-08_JPRB, 0.14769026E-08_JPRB /)

RGHG4(:, 6, 1) = (/ &
  & 0.39037232E-10_JPRB, 0.35708356E-10_JPRB, 0.33166862E-10_JPRB, 0.31353222E-10_JPRB, 0.30107770E-10_JPRB, 0.29300666E-10_JPRB, &
  & 0.29324293E-10_JPRB, 0.29668910E-10_JPRB, 0.30024500E-10_JPRB, 0.30389576E-10_JPRB, 0.30736077E-10_JPRB, 0.31064554E-10_JPRB, &
  & 0.31280596E-10_JPRB, 0.31394380E-10_JPRB, 0.31361184E-10_JPRB, 0.31171715E-10_JPRB, 0.30893871E-10_JPRB, 0.30540796E-10_JPRB, &
  & 0.30155774E-10_JPRB, 0.29810269E-10_JPRB, 0.29553807E-10_JPRB, 0.29367748E-10_JPRB, 0.29221757E-10_JPRB, 0.29101820E-10_JPRB, &
  & 0.29031175E-10_JPRB, 0.29006342E-10_JPRB, 0.28992624E-10_JPRB, 0.28919049E-10_JPRB, 0.28790253E-10_JPRB, 0.28603522E-10_JPRB, &
  & 0.28337556E-10_JPRB, 0.28003370E-10_JPRB, 0.27743158E-10_JPRB, 0.27335923E-10_JPRB, 0.26983830E-10_JPRB, 0.26720232E-10_JPRB, &
  & 0.26539935E-10_JPRB, 0.26403478E-10_JPRB, 0.26249175E-10_JPRB, 0.25899158E-10_JPRB, 0.25139807E-10_JPRB, 0.23988657E-10_JPRB, &
  & 0.22579334E-10_JPRB, 0.21090732E-10_JPRB, 0.19606762E-10_JPRB, 0.18192555E-10_JPRB, 0.16846196E-10_JPRB, 0.15562281E-10_JPRB, &
  & 0.14307917E-10_JPRB, 0.13106477E-10_JPRB, 0.11979110E-10_JPRB, 0.10907751E-10_JPRB, 0.99524963E-11_JPRB, 0.91678835E-11_JPRB, &
  & 0.85954603E-11_JPRB, 0.82978563E-11_JPRB, 0.84428983E-11_JPRB, 0.13068156E-10_JPRB, 0.24722406E-08_JPRB, 0.23942324E-08_JPRB, &
  & 0.23637674E-08_JPRB, 0.23611748E-08_JPRB, 0.23704652E-08_JPRB, 0.24205116E-08_JPRB /)

RGHG4(:, 7, 1) = (/ &
  & 0.10641429E-09_JPRB, 0.99054799E-10_JPRB, 0.91817366E-10_JPRB, 0.86136973E-10_JPRB, 0.81857181E-10_JPRB, 0.78724478E-10_JPRB, &
  & 0.78171893E-10_JPRB, 0.78775104E-10_JPRB, 0.79211700E-10_JPRB, 0.79654831E-10_JPRB, 0.80037275E-10_JPRB, 0.80268035E-10_JPRB, &
  & 0.80376789E-10_JPRB, 0.80187183E-10_JPRB, 0.79769448E-10_JPRB, 0.79259141E-10_JPRB, 0.78543207E-10_JPRB, 0.77761041E-10_JPRB, &
  & 0.77156753E-10_JPRB, 0.76622021E-10_JPRB, 0.76219669E-10_JPRB, 0.75978772E-10_JPRB, 0.75875174E-10_JPRB, 0.75867777E-10_JPRB, &
  & 0.76020155E-10_JPRB, 0.76165192E-10_JPRB, 0.76223035E-10_JPRB, 0.76290113E-10_JPRB, 0.76413362E-10_JPRB, 0.76494623E-10_JPRB, &
  & 0.76567232E-10_JPRB, 0.76511235E-10_JPRB, 0.76617088E-10_JPRB, 0.76253677E-10_JPRB, 0.75570994E-10_JPRB, 0.74783450E-10_JPRB, &
  & 0.73771149E-10_JPRB, 0.72548717E-10_JPRB, 0.70984676E-10_JPRB, 0.68897339E-10_JPRB, 0.65941745E-10_JPRB, 0.62079952E-10_JPRB, &
  & 0.57944007E-10_JPRB, 0.53984251E-10_JPRB, 0.50446480E-10_JPRB, 0.47379753E-10_JPRB, 0.44663603E-10_JPRB, 0.42067492E-10_JPRB, &
  & 0.39563495E-10_JPRB, 0.37145193E-10_JPRB, 0.34771085E-10_JPRB, 0.32473225E-10_JPRB, 0.30441663E-10_JPRB, 0.28783049E-10_JPRB, &
  & 0.27800406E-10_JPRB, 0.28081489E-10_JPRB, 0.30616905E-10_JPRB, 0.36286370E-10_JPRB, 0.37268131E-08_JPRB, 0.35912489E-08_JPRB, &
  & 0.35121070E-08_JPRB, 0.34700549E-08_JPRB, 0.34451664E-08_JPRB, 0.34540377E-08_JPRB /)

RGHG4(:, 8, 1) = (/ &
  & 0.28123795E-09_JPRB, 0.26323738E-09_JPRB, 0.24435887E-09_JPRB, 0.22879809E-09_JPRB, 0.21637526E-09_JPRB, 0.20656613E-09_JPRB, &
  & 0.20317270E-09_JPRB, 0.20337620E-09_JPRB, 0.20320623E-09_JPRB, 0.20320172E-09_JPRB, 0.20322306E-09_JPRB, 0.20286745E-09_JPRB, &
  & 0.20263888E-09_JPRB, 0.20178245E-09_JPRB, 0.20071486E-09_JPRB, 0.19990405E-09_JPRB, 0.19853004E-09_JPRB, 0.19719579E-09_JPRB, &
  & 0.19651984E-09_JPRB, 0.19571771E-09_JPRB, 0.19492333E-09_JPRB, 0.19431237E-09_JPRB, 0.19392951E-09_JPRB, 0.19378960E-09_JPRB, &
  & 0.19414925E-09_JPRB, 0.19424309E-09_JPRB, 0.19402009E-09_JPRB, 0.19398523E-09_JPRB, 0.19442009E-09_JPRB, 0.19480756E-09_JPRB, &
  & 0.19542150E-09_JPRB, 0.19571961E-09_JPRB, 0.19652109E-09_JPRB, 0.19604543E-09_JPRB, 0.19424494E-09_JPRB, 0.19199201E-09_JPRB, &
  & 0.18882802E-09_JPRB, 0.18501055E-09_JPRB, 0.18021024E-09_JPRB, 0.17437475E-09_JPRB, 0.16676541E-09_JPRB, 0.15698289E-09_JPRB, &
  & 0.14708543E-09_JPRB, 0.13799605E-09_JPRB, 0.13031649E-09_JPRB, 0.12382519E-09_JPRB, 0.11810287E-09_JPRB, 0.11266873E-09_JPRB, &
  & 0.10773162E-09_JPRB, 0.10306221E-09_JPRB, 0.98627148E-10_JPRB, 0.94343422E-10_JPRB, 0.90580411E-10_JPRB, 0.87905114E-10_JPRB, &
  & 0.87104150E-10_JPRB, 0.89106285E-10_JPRB, 0.94241476E-10_JPRB, 0.92075139E-10_JPRB, 0.48811408E-08_JPRB, 0.46545860E-08_JPRB, &
  & 0.45032622E-08_JPRB, 0.43988773E-08_JPRB, 0.43245052E-08_JPRB, 0.42322190E-08_JPRB /)

RGHG4(:, 9, 1) = (/ &
  & 0.65643702E-09_JPRB, 0.61967903E-09_JPRB, 0.58038591E-09_JPRB, 0.54703797E-09_JPRB, 0.51977156E-09_JPRB, 0.49757509E-09_JPRB, &
  & 0.48702897E-09_JPRB, 0.48495324E-09_JPRB, 0.48252935E-09_JPRB, 0.48081239E-09_JPRB, 0.47948440E-09_JPRB, 0.47754128E-09_JPRB, &
  & 0.47659454E-09_JPRB, 0.47439219E-09_JPRB, 0.47240700E-09_JPRB, 0.47178245E-09_JPRB, 0.46974141E-09_JPRB, 0.46804433E-09_JPRB, &
  & 0.46787979E-09_JPRB, 0.46675702E-09_JPRB, 0.46514545E-09_JPRB, 0.46344453E-09_JPRB, 0.46197851E-09_JPRB, 0.46102885E-09_JPRB, &
  & 0.46138907E-09_JPRB, 0.46072146E-09_JPRB, 0.45922210E-09_JPRB, 0.45800136E-09_JPRB, 0.45813175E-09_JPRB, 0.45792123E-09_JPRB, &
  & 0.45833448E-09_JPRB, 0.45795992E-09_JPRB, 0.45901036E-09_JPRB, 0.45728135E-09_JPRB, 0.45223172E-09_JPRB, 0.44646659E-09_JPRB, &
  & 0.43875711E-09_JPRB, 0.43000728E-09_JPRB, 0.41944634E-09_JPRB, 0.40724993E-09_JPRB, 0.39153841E-09_JPRB, 0.37095826E-09_JPRB, &
  & 0.35016698E-09_JPRB, 0.33145947E-09_JPRB, 0.31632164E-09_JPRB, 0.30422267E-09_JPRB, 0.29443295E-09_JPRB, 0.28565922E-09_JPRB, &
  & 0.27769728E-09_JPRB, 0.26972111E-09_JPRB, 0.26193483E-09_JPRB, 0.25386390E-09_JPRB, 0.24647401E-09_JPRB, 0.23983479E-09_JPRB, &
  & 0.23353466E-09_JPRB, 0.22667684E-09_JPRB, 0.21827082E-09_JPRB, 0.19302820E-09_JPRB, 0.56754503E-08_JPRB, 0.53159392E-08_JPRB, &
  & 0.50705991E-08_JPRB, 0.48922417E-08_JPRB, 0.47406297E-08_JPRB, 0.45958970E-08_JPRB /)

RGHG4(:,10, 1) = (/ &
  & 0.13258213E-08_JPRB, 0.12604525E-08_JPRB, 0.11948682E-08_JPRB, 0.11419876E-08_JPRB, 0.10984567E-08_JPRB, 0.10632107E-08_JPRB, &
  & 0.10437236E-08_JPRB, 0.10381054E-08_JPRB, 0.10320771E-08_JPRB, 0.10278723E-08_JPRB, 0.10250827E-08_JPRB, 0.10215429E-08_JPRB, &
  & 0.10210452E-08_JPRB, 0.10184213E-08_JPRB, 0.10165121E-08_JPRB, 0.10179052E-08_JPRB, 0.10160327E-08_JPRB, 0.10148258E-08_JPRB, &
  & 0.10166623E-08_JPRB, 0.10154355E-08_JPRB, 0.10128703E-08_JPRB, 0.10093280E-08_JPRB, 0.10057917E-08_JPRB, 0.10032694E-08_JPRB, &
  & 0.10036331E-08_JPRB, 0.10011533E-08_JPRB, 0.99684749E-09_JPRB, 0.99194208E-09_JPRB, 0.98954711E-09_JPRB, 0.98566710E-09_JPRB, &
  & 0.98287001E-09_JPRB, 0.97850017E-09_JPRB, 0.97742336E-09_JPRB, 0.97131225E-09_JPRB, 0.95903874E-09_JPRB, 0.94638486E-09_JPRB, &
  & 0.93036778E-09_JPRB, 0.91322533E-09_JPRB, 0.89334945E-09_JPRB, 0.87117008E-09_JPRB, 0.84247659E-09_JPRB, 0.80434431E-09_JPRB, &
  & 0.76546042E-09_JPRB, 0.73043693E-09_JPRB, 0.70309486E-09_JPRB, 0.68203054E-09_JPRB, 0.66491385E-09_JPRB, 0.64857292E-09_JPRB, &
  & 0.63289352E-09_JPRB, 0.61710226E-09_JPRB, 0.59987920E-09_JPRB, 0.57903271E-09_JPRB, 0.55438509E-09_JPRB, 0.52412902E-09_JPRB, &
  & 0.48719989E-09_JPRB, 0.44346318E-09_JPRB, 0.39706483E-09_JPRB, 0.33372360E-09_JPRB, 0.58942997E-08_JPRB, 0.54094418E-08_JPRB, &
  & 0.50780180E-08_JPRB, 0.48369317E-08_JPRB, 0.46630095E-08_JPRB, 0.44702442E-08_JPRB /)

RGHG4(:,11, 1) = (/ &
  & 0.22943951E-08_JPRB, 0.22032296E-08_JPRB, 0.21202764E-08_JPRB, 0.20601525E-08_JPRB, 0.20126403E-08_JPRB, 0.19775610E-08_JPRB, &
  & 0.19600166E-08_JPRB, 0.19575102E-08_JPRB, 0.19529407E-08_JPRB, 0.19503310E-08_JPRB, 0.19492854E-08_JPRB, 0.19465667E-08_JPRB, &
  & 0.19488802E-08_JPRB, 0.19478434E-08_JPRB, 0.19482491E-08_JPRB, 0.19542978E-08_JPRB, 0.19542796E-08_JPRB, 0.19547992E-08_JPRB, &
  & 0.19606146E-08_JPRB, 0.19595976E-08_JPRB, 0.19562003E-08_JPRB, 0.19507456E-08_JPRB, 0.19446773E-08_JPRB, 0.19404818E-08_JPRB, &
  & 0.19415836E-08_JPRB, 0.19362563E-08_JPRB, 0.19276616E-08_JPRB, 0.19156952E-08_JPRB, 0.19072195E-08_JPRB, 0.18954702E-08_JPRB, &
  & 0.18857496E-08_JPRB, 0.18741335E-08_JPRB, 0.18686148E-08_JPRB, 0.18542856E-08_JPRB, 0.18282841E-08_JPRB, 0.18012479E-08_JPRB, &
  & 0.17698475E-08_JPRB, 0.17370695E-08_JPRB, 0.17010944E-08_JPRB, 0.16645071E-08_JPRB, 0.16168618E-08_JPRB, 0.15539099E-08_JPRB, &
  & 0.14878468E-08_JPRB, 0.14259366E-08_JPRB, 0.13735841E-08_JPRB, 0.13301730E-08_JPRB, 0.12911178E-08_JPRB, 0.12527221E-08_JPRB, &
  & 0.12134701E-08_JPRB, 0.11702629E-08_JPRB, 0.11194022E-08_JPRB, 0.10583382E-08_JPRB, 0.98637776E-09_JPRB, 0.90177321E-09_JPRB, &
  & 0.80556911E-09_JPRB, 0.70112882E-09_JPRB, 0.59875893E-09_JPRB, 0.48435722E-09_JPRB, 0.55942544E-08_JPRB, 0.50086482E-08_JPRB, &
  & 0.46383066E-08_JPRB, 0.43763797E-08_JPRB, 0.41809600E-08_JPRB, 0.40214725E-08_JPRB /)

RGHG4(:,12, 1) = (/ &
  & 0.34178003E-08_JPRB, 0.33354943E-08_JPRB, 0.32695129E-08_JPRB, 0.32315004E-08_JPRB, 0.32114793E-08_JPRB, 0.32044138E-08_JPRB, &
  & 0.32149485E-08_JPRB, 0.32330059E-08_JPRB, 0.32425955E-08_JPRB, 0.32510072E-08_JPRB, 0.32587801E-08_JPRB, 0.32623799E-08_JPRB, &
  & 0.32711065E-08_JPRB, 0.32736047E-08_JPRB, 0.32767644E-08_JPRB, 0.32863225E-08_JPRB, 0.32861396E-08_JPRB, 0.32849852E-08_JPRB, &
  & 0.32907688E-08_JPRB, 0.32854357E-08_JPRB, 0.32762730E-08_JPRB, 0.32647565E-08_JPRB, 0.32519363E-08_JPRB, 0.32414522E-08_JPRB, &
  & 0.32393739E-08_JPRB, 0.32272918E-08_JPRB, 0.32120053E-08_JPRB, 0.31910086E-08_JPRB, 0.31742382E-08_JPRB, 0.31532994E-08_JPRB, &
  & 0.31356435E-08_JPRB, 0.31162850E-08_JPRB, 0.31044296E-08_JPRB, 0.30809948E-08_JPRB, 0.30418028E-08_JPRB, 0.29982605E-08_JPRB, &
  & 0.29468008E-08_JPRB, 0.28976361E-08_JPRB, 0.28436640E-08_JPRB, 0.27877807E-08_JPRB, 0.27193148E-08_JPRB, 0.26324694E-08_JPRB, &
  & 0.25337696E-08_JPRB, 0.24318483E-08_JPRB, 0.23348081E-08_JPRB, 0.22444320E-08_JPRB, 0.21540512E-08_JPRB, 0.20602264E-08_JPRB, &
  & 0.19606303E-08_JPRB, 0.18534706E-08_JPRB, 0.17352495E-08_JPRB, 0.16025713E-08_JPRB, 0.14556661E-08_JPRB, 0.12951943E-08_JPRB, &
  & 0.11250225E-08_JPRB, 0.95058550E-09_JPRB, 0.78159640E-09_JPRB, 0.61509142E-09_JPRB, 0.49427573E-08_JPRB, 0.43294652E-08_JPRB, &
  & 0.39480788E-08_JPRB, 0.36804653E-08_JPRB, 0.35164014E-08_JPRB, 0.33696346E-08_JPRB /)

RGHG4(:,13, 1) = (/ &
  & 0.44367376E-08_JPRB, 0.43935486E-08_JPRB, 0.43765871E-08_JPRB, 0.43908899E-08_JPRB, 0.44276054E-08_JPRB, 0.44787343E-08_JPRB, &
  & 0.45450372E-08_JPRB, 0.46052646E-08_JPRB, 0.46481046E-08_JPRB, 0.46828976E-08_JPRB, 0.47106239E-08_JPRB, 0.47283981E-08_JPRB, &
  & 0.47475335E-08_JPRB, 0.47551421E-08_JPRB, 0.47598978E-08_JPRB, 0.47681459E-08_JPRB, 0.47628257E-08_JPRB, 0.47531659E-08_JPRB, &
  & 0.47490563E-08_JPRB, 0.47301039E-08_JPRB, 0.47060720E-08_JPRB, 0.46802637E-08_JPRB, 0.46540709E-08_JPRB, 0.46309401E-08_JPRB, &
  & 0.46190265E-08_JPRB, 0.45966133E-08_JPRB, 0.45740638E-08_JPRB, 0.45478861E-08_JPRB, 0.45290998E-08_JPRB, 0.45087662E-08_JPRB, &
  & 0.44941344E-08_JPRB, 0.44793915E-08_JPRB, 0.44707247E-08_JPRB, 0.44447974E-08_JPRB, 0.43990509E-08_JPRB, 0.43475570E-08_JPRB, &
  & 0.42875077E-08_JPRB, 0.42261794E-08_JPRB, 0.41649568E-08_JPRB, 0.40996024E-08_JPRB, 0.40157540E-08_JPRB, 0.39128487E-08_JPRB, &
  & 0.37931311E-08_JPRB, 0.36572156E-08_JPRB, 0.35085164E-08_JPRB, 0.33528269E-08_JPRB, 0.31866172E-08_JPRB, 0.30098148E-08_JPRB, &
  & 0.28238840E-08_JPRB, 0.26264753E-08_JPRB, 0.24140701E-08_JPRB, 0.21868047E-08_JPRB, 0.19490010E-08_JPRB, 0.17021784E-08_JPRB, &
  & 0.14513148E-08_JPRB, 0.11979759E-08_JPRB, 0.95144259E-09_JPRB, 0.71856587E-09_JPRB, 0.42039012E-08_JPRB, 0.35442902E-08_JPRB, &
  & 0.31760141E-08_JPRB, 0.29223506E-08_JPRB, 0.27638760E-08_JPRB, 0.26573794E-08_JPRB /)

RGHG4(:,14, 1) = (/ &
  & 0.51793045E-08_JPRB, 0.51945661E-08_JPRB, 0.52251985E-08_JPRB, 0.52898557E-08_JPRB, 0.53841043E-08_JPRB, 0.54975593E-08_JPRB, &
  & 0.56253424E-08_JPRB, 0.57318066E-08_JPRB, 0.58163017E-08_JPRB, 0.58863829E-08_JPRB, 0.59414469E-08_JPRB, 0.59776126E-08_JPRB, &
  & 0.60077303E-08_JPRB, 0.60188343E-08_JPRB, 0.60215872E-08_JPRB, 0.60214478E-08_JPRB, 0.60024505E-08_JPRB, 0.59746772E-08_JPRB, &
  & 0.59490519E-08_JPRB, 0.59054495E-08_JPRB, 0.58561764E-08_JPRB, 0.58067946E-08_JPRB, 0.57598699E-08_JPRB, 0.57194143E-08_JPRB, &
  & 0.56938640E-08_JPRB, 0.56623226E-08_JPRB, 0.56385150E-08_JPRB, 0.56188840E-08_JPRB, 0.56137273E-08_JPRB, 0.56135860E-08_JPRB, &
  & 0.56220384E-08_JPRB, 0.56293721E-08_JPRB, 0.56414398E-08_JPRB, 0.56332956E-08_JPRB, 0.56021894E-08_JPRB, 0.55584932E-08_JPRB, &
  & 0.55064344E-08_JPRB, 0.54459552E-08_JPRB, 0.53845715E-08_JPRB, 0.53200711E-08_JPRB, 0.52355689E-08_JPRB, 0.51235558E-08_JPRB, &
  & 0.49863313E-08_JPRB, 0.48247522E-08_JPRB, 0.46419966E-08_JPRB, 0.44411630E-08_JPRB, 0.42179522E-08_JPRB, 0.39712265E-08_JPRB, &
  & 0.37048855E-08_JPRB, 0.34189409E-08_JPRB, 0.31140022E-08_JPRB, 0.27923326E-08_JPRB, 0.24629840E-08_JPRB, 0.21300770E-08_JPRB, &
  & 0.17977327E-08_JPRB, 0.14618471E-08_JPRB, 0.11255709E-08_JPRB, 0.83434459E-09_JPRB, 0.36649299E-08_JPRB, 0.29837093E-08_JPRB, &
  & 0.25929598E-08_JPRB, 0.23370783E-08_JPRB, 0.21796978E-08_JPRB, 0.20725419E-08_JPRB /)

RGHG4(:,15, 1) = (/ &
  & 0.56149076E-08_JPRB, 0.56640483E-08_JPRB, 0.57207439E-08_JPRB, 0.58191589E-08_JPRB, 0.59544503E-08_JPRB, 0.61140013E-08_JPRB, &
  & 0.62836882E-08_JPRB, 0.64145289E-08_JPRB, 0.65241244E-08_JPRB, 0.66160628E-08_JPRB, 0.66864696E-08_JPRB, 0.67302297E-08_JPRB, &
  & 0.67604780E-08_JPRB, 0.67640422E-08_JPRB, 0.67531967E-08_JPRB, 0.67335235E-08_JPRB, 0.66896031E-08_JPRB, 0.66321952E-08_JPRB, &
  & 0.65741719E-08_JPRB, 0.64961196E-08_JPRB, 0.64138721E-08_JPRB, 0.63352754E-08_JPRB, 0.62658816E-08_JPRB, 0.62125389E-08_JPRB, &
  & 0.61819718E-08_JPRB, 0.61559708E-08_JPRB, 0.61491274E-08_JPRB, 0.61607923E-08_JPRB, 0.61982033E-08_JPRB, 0.62464593E-08_JPRB, &
  & 0.63054544E-08_JPRB, 0.63573897E-08_JPRB, 0.64011698E-08_JPRB, 0.64148336E-08_JPRB, 0.64079044E-08_JPRB, 0.63803580E-08_JPRB, &
  & 0.63336429E-08_JPRB, 0.62683929E-08_JPRB, 0.61880647E-08_JPRB, 0.60986074E-08_JPRB, 0.59916112E-08_JPRB, 0.58627347E-08_JPRB, &
  & 0.57119833E-08_JPRB, 0.55384084E-08_JPRB, 0.53437454E-08_JPRB, 0.51293396E-08_JPRB, 0.48899711E-08_JPRB, 0.46227884E-08_JPRB, &
  & 0.43312802E-08_JPRB, 0.40143573E-08_JPRB, 0.36703500E-08_JPRB, 0.33030878E-08_JPRB, 0.29239979E-08_JPRB, 0.25372460E-08_JPRB, &
  & 0.21423792E-08_JPRB, 0.17311645E-08_JPRB, 0.13060921E-08_JPRB, 0.94633967E-09_JPRB, 0.33944394E-08_JPRB, 0.26414646E-08_JPRB, &
  & 0.22235311E-08_JPRB, 0.19499238E-08_JPRB, 0.17792948E-08_JPRB, 0.16528198E-08_JPRB /)

RGHG4(:,16, 1) = (/ &
  & 0.58549627E-08_JPRB, 0.59059455E-08_JPRB, 0.59679297E-08_JPRB, 0.60726317E-08_JPRB, 0.62170074E-08_JPRB, 0.63881154E-08_JPRB, &
  & 0.65604495E-08_JPRB, 0.66765966E-08_JPRB, 0.67797639E-08_JPRB, 0.68677779E-08_JPRB, 0.69325243E-08_JPRB, 0.69666370E-08_JPRB, &
  & 0.69826038E-08_JPRB, 0.69663133E-08_JPRB, 0.69305539E-08_JPRB, 0.68818595E-08_JPRB, 0.68054473E-08_JPRB, 0.67146777E-08_JPRB, &
  & 0.66243739E-08_JPRB, 0.65160632E-08_JPRB, 0.64092256E-08_JPRB, 0.63121495E-08_JPRB, 0.62334546E-08_JPRB, 0.61823293E-08_JPRB, &
  & 0.61675136E-08_JPRB, 0.61728729E-08_JPRB, 0.62078294E-08_JPRB, 0.62694334E-08_JPRB, 0.63629058E-08_JPRB, 0.64717494E-08_JPRB, &
  & 0.65764314E-08_JPRB, 0.66676558E-08_JPRB, 0.67433454E-08_JPRB, 0.67762871E-08_JPRB, 0.67662635E-08_JPRB, 0.67239028E-08_JPRB, &
  & 0.66476171E-08_JPRB, 0.65478116E-08_JPRB, 0.64344219E-08_JPRB, 0.63119221E-08_JPRB, 0.61763923E-08_JPRB, 0.60250493E-08_JPRB, &
  & 0.58605347E-08_JPRB, 0.56832192E-08_JPRB, 0.54921356E-08_JPRB, 0.52880136E-08_JPRB, 0.50630269E-08_JPRB, 0.48109774E-08_JPRB, &
  & 0.45335264E-08_JPRB, 0.42292547E-08_JPRB, 0.38979229E-08_JPRB, 0.35402534E-08_JPRB, 0.31643093E-08_JPRB, 0.27662834E-08_JPRB, &
  & 0.23369697E-08_JPRB, 0.18662074E-08_JPRB, 0.14146074E-08_JPRB, 0.10005938E-08_JPRB, 0.30595459E-08_JPRB, 0.23051709E-08_JPRB, &
  & 0.18666859E-08_JPRB, 0.16062965E-08_JPRB, 0.14205763E-08_JPRB, 0.13114021E-08_JPRB /)

RGHG4(:,17, 1) = (/ &
  & 0.58661960E-08_JPRB, 0.58847083E-08_JPRB, 0.59245715E-08_JPRB, 0.60121574E-08_JPRB, 0.61423582E-08_JPRB, 0.62979297E-08_JPRB, &
  & 0.64436705E-08_JPRB, 0.65118857E-08_JPRB, 0.65794534E-08_JPRB, 0.66368075E-08_JPRB, 0.66719519E-08_JPRB, 0.66758785E-08_JPRB, &
  & 0.66605610E-08_JPRB, 0.66113812E-08_JPRB, 0.65418666E-08_JPRB, 0.64596390E-08_JPRB, 0.63506271E-08_JPRB, 0.62300516E-08_JPRB, &
  & 0.61120118E-08_JPRB, 0.59834799E-08_JPRB, 0.58658420E-08_JPRB, 0.57659690E-08_JPRB, 0.56976792E-08_JPRB, 0.56700178E-08_JPRB, &
  & 0.56918519E-08_JPRB, 0.57459628E-08_JPRB, 0.58335679E-08_JPRB, 0.59505876E-08_JPRB, 0.60917902E-08_JPRB, 0.62395729E-08_JPRB, &
  & 0.63729417E-08_JPRB, 0.64870544E-08_JPRB, 0.65647172E-08_JPRB, 0.65858305E-08_JPRB, 0.65556263E-08_JPRB, 0.64714594E-08_JPRB, &
  & 0.63522556E-08_JPRB, 0.62075278E-08_JPRB, 0.60518066E-08_JPRB, 0.59019767E-08_JPRB, 0.57460734E-08_JPRB, 0.55879390E-08_JPRB, &
  & 0.54321783E-08_JPRB, 0.52767768E-08_JPRB, 0.51154201E-08_JPRB, 0.49470592E-08_JPRB, 0.47612847E-08_JPRB, 0.45515511E-08_JPRB, &
  & 0.43178092E-08_JPRB, 0.40583275E-08_JPRB, 0.37710377E-08_JPRB, 0.34530478E-08_JPRB, 0.31067238E-08_JPRB, 0.27225819E-08_JPRB, &
  & 0.22919486E-08_JPRB, 0.18145352E-08_JPRB, 0.13797902E-08_JPRB, 0.10136412E-08_JPRB, 0.25810680E-08_JPRB, 0.18765312E-08_JPRB, &
  & 0.14872666E-08_JPRB, 0.12372258E-08_JPRB, 0.10792939E-08_JPRB, 0.98058794E-09_JPRB /)

RGHG4(:,18, 1) = (/ &
  & 0.57063305E-08_JPRB, 0.56817764E-08_JPRB, 0.56931850E-08_JPRB, 0.57533263E-08_JPRB, 0.58548206E-08_JPRB, 0.59772396E-08_JPRB, &
  & 0.60738303E-08_JPRB, 0.60722174E-08_JPRB, 0.60828929E-08_JPRB, 0.60895009E-08_JPRB, 0.60775824E-08_JPRB, 0.60372556E-08_JPRB, &
  & 0.59797585E-08_JPRB, 0.58907670E-08_JPRB, 0.57839458E-08_JPRB, 0.56680696E-08_JPRB, 0.55303948E-08_JPRB, 0.53886429E-08_JPRB, &
  & 0.52563203E-08_JPRB, 0.51245865E-08_JPRB, 0.50160405E-08_JPRB, 0.49362625E-08_JPRB, 0.48998485E-08_JPRB, 0.49138178E-08_JPRB, &
  & 0.49834976E-08_JPRB, 0.50884754E-08_JPRB, 0.52235718E-08_JPRB, 0.53752909E-08_JPRB, 0.55409992E-08_JPRB, 0.56881988E-08_JPRB, &
  & 0.58194058E-08_JPRB, 0.59056737E-08_JPRB, 0.59633325E-08_JPRB, 0.59511467E-08_JPRB, 0.58827103E-08_JPRB, 0.57631717E-08_JPRB, &
  & 0.56029421E-08_JPRB, 0.54240656E-08_JPRB, 0.52476445E-08_JPRB, 0.50853437E-08_JPRB, 0.49360391E-08_JPRB, 0.48019162E-08_JPRB, &
  & 0.46756146E-08_JPRB, 0.45570405E-08_JPRB, 0.44394244E-08_JPRB, 0.43187653E-08_JPRB, 0.41831680E-08_JPRB, 0.40284913E-08_JPRB, &
  & 0.38514285E-08_JPRB, 0.36489902E-08_JPRB, 0.34168506E-08_JPRB, 0.31470706E-08_JPRB, 0.28350475E-08_JPRB, 0.24708808E-08_JPRB, &
  & 0.20434257E-08_JPRB, 0.16165529E-08_JPRB, 0.12434140E-08_JPRB, 0.94036645E-09_JPRB, 0.19755395E-08_JPRB, 0.14022735E-08_JPRB, &
  & 0.10769926E-08_JPRB, 0.87423485E-09_JPRB, 0.74568984E-09_JPRB, 0.66504435E-09_JPRB /)

RGHG4(:,19, 1) = (/ &
  & 0.54285838E-08_JPRB, 0.53619833E-08_JPRB, 0.53418185E-08_JPRB, 0.53679794E-08_JPRB, 0.54322720E-08_JPRB, 0.55085692E-08_JPRB, &
  & 0.55424785E-08_JPRB, 0.54607274E-08_JPRB, 0.54060614E-08_JPRB, 0.53545706E-08_JPRB, 0.52895115E-08_JPRB, 0.52014975E-08_JPRB, &
  & 0.51008784E-08_JPRB, 0.49754378E-08_JPRB, 0.48378794E-08_JPRB, 0.46997473E-08_JPRB, 0.45491659E-08_JPRB, 0.44020512E-08_JPRB, &
  & 0.42732187E-08_JPRB, 0.41555439E-08_JPRB, 0.40688066E-08_JPRB, 0.40196784E-08_JPRB, 0.40198764E-08_JPRB, 0.40756607E-08_JPRB, &
  & 0.41857340E-08_JPRB, 0.43258708E-08_JPRB, 0.44847090E-08_JPRB, 0.46474264E-08_JPRB, 0.47890238E-08_JPRB, 0.49155067E-08_JPRB, &
  & 0.49905950E-08_JPRB, 0.50325073E-08_JPRB, 0.50343099E-08_JPRB, 0.49791105E-08_JPRB, 0.48722515E-08_JPRB, 0.47259205E-08_JPRB, &
  & 0.45577395E-08_JPRB, 0.43837618E-08_JPRB, 0.42263517E-08_JPRB, 0.40943693E-08_JPRB, 0.39766941E-08_JPRB, 0.38759995E-08_JPRB, &
  & 0.37924970E-08_JPRB, 0.37204528E-08_JPRB, 0.36493444E-08_JPRB, 0.35769834E-08_JPRB, 0.34923004E-08_JPRB, 0.33906764E-08_JPRB, &
  & 0.32675807E-08_JPRB, 0.31176639E-08_JPRB, 0.29336344E-08_JPRB, 0.27036517E-08_JPRB, 0.24234958E-08_JPRB, 0.20853546E-08_JPRB, &
  & 0.17031071E-08_JPRB, 0.13549294E-08_JPRB, 0.10405589E-08_JPRB, 0.79784296E-09_JPRB, 0.14253007E-08_JPRB, 0.10011154E-08_JPRB, &
  & 0.74817774E-09_JPRB, 0.58737004E-09_JPRB, 0.49370175E-09_JPRB, 0.41968418E-09_JPRB /)

RGHG4(:,20, 1) = (/ &
  & 0.50411941E-08_JPRB, 0.49234159E-08_JPRB, 0.48720867E-08_JPRB, 0.48658482E-08_JPRB, 0.48941962E-08_JPRB, 0.49262421E-08_JPRB, &
  & 0.49013544E-08_JPRB, 0.47510196E-08_JPRB, 0.46394319E-08_JPRB, 0.45385598E-08_JPRB, 0.44300834E-08_JPRB, 0.43063948E-08_JPRB, &
  & 0.41757402E-08_JPRB, 0.40297969E-08_JPRB, 0.38781547E-08_JPRB, 0.37301957E-08_JPRB, 0.35801062E-08_JPRB, 0.34419201E-08_JPRB, &
  & 0.33292686E-08_JPRB, 0.32370444E-08_JPRB, 0.31795162E-08_JPRB, 0.31636722E-08_JPRB, 0.31950742E-08_JPRB, 0.32774450E-08_JPRB, &
  & 0.34058332E-08_JPRB, 0.35546459E-08_JPRB, 0.37073506E-08_JPRB, 0.38424099E-08_JPRB, 0.39553290E-08_JPRB, 0.40126800E-08_JPRB, &
  & 0.40348938E-08_JPRB, 0.40114316E-08_JPRB, 0.39574770E-08_JPRB, 0.38613210E-08_JPRB, 0.37365222E-08_JPRB, 0.35913315E-08_JPRB, &
  & 0.34407388E-08_JPRB, 0.32974066E-08_JPRB, 0.31716809E-08_JPRB, 0.30789551E-08_JPRB, 0.30115861E-08_JPRB, 0.29635419E-08_JPRB, &
  & 0.29257030E-08_JPRB, 0.28965665E-08_JPRB, 0.28685618E-08_JPRB, 0.28378939E-08_JPRB, 0.27952440E-08_JPRB, 0.27364373E-08_JPRB, &
  & 0.26547040E-08_JPRB, 0.25433393E-08_JPRB, 0.23927909E-08_JPRB, 0.21932907E-08_JPRB, 0.19418624E-08_JPRB, 0.16375711E-08_JPRB, &
  & 0.13421603E-08_JPRB, 0.10671140E-08_JPRB, 0.82175811E-09_JPRB, 0.64899852E-09_JPRB, 0.97820185E-09_JPRB, 0.68687261E-09_JPRB, &
  & 0.50423832E-09_JPRB, 0.37657813E-09_JPRB, 0.32020414E-09_JPRB, 0.25713445E-09_JPRB /)

RGHG4(:,21, 1) = (/ &
  & 0.46460213E-08_JPRB, 0.44789110E-08_JPRB, 0.43935167E-08_JPRB, 0.43523896E-08_JPRB, 0.43411945E-08_JPRB, 0.43278132E-08_JPRB, &
  & 0.42504746E-08_JPRB, 0.40509573E-08_JPRB, 0.39004582E-08_JPRB, 0.37670405E-08_JPRB, 0.36322869E-08_JPRB, 0.34895458E-08_JPRB, &
  & 0.33448895E-08_JPRB, 0.31926013E-08_JPRB, 0.30419736E-08_JPRB, 0.29023108E-08_JPRB, 0.27682898E-08_JPRB, 0.26490328E-08_JPRB, &
  & 0.25544886E-08_JPRB, 0.24807987E-08_JPRB, 0.24403886E-08_JPRB, 0.24421432E-08_JPRB, 0.24869691E-08_JPRB, 0.25766880E-08_JPRB, &
  & 0.27014997E-08_JPRB, 0.28365146E-08_JPRB, 0.29630347E-08_JPRB, 0.30653631E-08_JPRB, 0.31138900E-08_JPRB, 0.31194989E-08_JPRB, &
  & 0.30804137E-08_JPRB, 0.30097005E-08_JPRB, 0.29199352E-08_JPRB, 0.28057008E-08_JPRB, 0.26830929E-08_JPRB, 0.25608082E-08_JPRB, &
  & 0.24446019E-08_JPRB, 0.23462035E-08_JPRB, 0.22716982E-08_JPRB, 0.22232842E-08_JPRB, 0.21917301E-08_JPRB, 0.21724589E-08_JPRB, &
  & 0.21640765E-08_JPRB, 0.21631195E-08_JPRB, 0.21600817E-08_JPRB, 0.21563937E-08_JPRB, 0.21385440E-08_JPRB, 0.21044593E-08_JPRB, &
  & 0.20475046E-08_JPRB, 0.19615556E-08_JPRB, 0.18396582E-08_JPRB, 0.16769487E-08_JPRB, 0.14745440E-08_JPRB, 0.12461565E-08_JPRB, &
  & 0.10311246E-08_JPRB, 0.82108081E-09_JPRB, 0.64106231E-09_JPRB, 0.50807553E-09_JPRB, 0.66284017E-09_JPRB, 0.46357176E-09_JPRB, &
  & 0.33202804E-09_JPRB, 0.24025218E-09_JPRB, 0.19898434E-09_JPRB, 0.15942996E-09_JPRB /)

RGHG4(:,22, 1) = (/ &
  & 0.40987929E-08_JPRB, 0.39552051E-08_JPRB, 0.38683838E-08_JPRB, 0.38124104E-08_JPRB, 0.37749630E-08_JPRB, 0.37280006E-08_JPRB, &
  & 0.36139407E-08_JPRB, 0.33904595E-08_JPRB, 0.32227352E-08_JPRB, 0.30772194E-08_JPRB, 0.29348015E-08_JPRB, 0.27904419E-08_JPRB, &
  & 0.26490190E-08_JPRB, 0.25059184E-08_JPRB, 0.23680691E-08_JPRB, 0.22401774E-08_JPRB, 0.21199380E-08_JPRB, 0.20170312E-08_JPRB, &
  & 0.19379620E-08_JPRB, 0.18777568E-08_JPRB, 0.18490103E-08_JPRB, 0.18556831E-08_JPRB, 0.18973287E-08_JPRB, 0.19713748E-08_JPRB, &
  & 0.20729019E-08_JPRB, 0.21746953E-08_JPRB, 0.22661297E-08_JPRB, 0.23256943E-08_JPRB, 0.23476656E-08_JPRB, 0.23191649E-08_JPRB, &
  & 0.22588102E-08_JPRB, 0.21742863E-08_JPRB, 0.20784137E-08_JPRB, 0.19743880E-08_JPRB, 0.18721733E-08_JPRB, 0.17790359E-08_JPRB, &
  & 0.17005558E-08_JPRB, 0.16413090E-08_JPRB, 0.16026654E-08_JPRB, 0.15858129E-08_JPRB, 0.15839723E-08_JPRB, 0.15911964E-08_JPRB, &
  & 0.16033518E-08_JPRB, 0.16181551E-08_JPRB, 0.16300671E-08_JPRB, 0.16352317E-08_JPRB, 0.16280741E-08_JPRB, 0.16047956E-08_JPRB, &
  & 0.15599945E-08_JPRB, 0.14891844E-08_JPRB, 0.13881325E-08_JPRB, 0.12555492E-08_JPRB, 0.10992347E-08_JPRB, 0.94458930E-09_JPRB, &
  & 0.78941065E-09_JPRB, 0.63494188E-09_JPRB, 0.49408722E-09_JPRB, 0.39505352E-09_JPRB, 0.45811355E-09_JPRB, 0.31273842E-09_JPRB, &
  & 0.22141541E-09_JPRB, 0.15162890E-09_JPRB, 0.12311234E-09_JPRB, 0.97629196E-10_JPRB /)

RGHG4(:,23, 1) = (/ &
  & 0.36469618E-08_JPRB, 0.34670227E-08_JPRB, 0.33715490E-08_JPRB, 0.33062824E-08_JPRB, 0.32540961E-08_JPRB, 0.31904357E-08_JPRB, &
  & 0.30620340E-08_JPRB, 0.28374187E-08_JPRB, 0.26696936E-08_JPRB, 0.25268638E-08_JPRB, 0.23900963E-08_JPRB, 0.22546847E-08_JPRB, &
  & 0.21223816E-08_JPRB, 0.19911315E-08_JPRB, 0.18667292E-08_JPRB, 0.17523465E-08_JPRB, 0.16456644E-08_JPRB, 0.15568431E-08_JPRB, &
  & 0.14906033E-08_JPRB, 0.14431659E-08_JPRB, 0.14193897E-08_JPRB, 0.14210102E-08_JPRB, 0.14483463E-08_JPRB, 0.14997429E-08_JPRB, &
  & 0.15667048E-08_JPRB, 0.16332906E-08_JPRB, 0.16882040E-08_JPRB, 0.17192552E-08_JPRB, 0.17171711E-08_JPRB, 0.16839599E-08_JPRB, &
  & 0.16224979E-08_JPRB, 0.15449969E-08_JPRB, 0.14623348E-08_JPRB, 0.13786451E-08_JPRB, 0.13022384E-08_JPRB, 0.12381706E-08_JPRB, &
  & 0.11890143E-08_JPRB, 0.11582874E-08_JPRB, 0.11446512E-08_JPRB, 0.11479375E-08_JPRB, 0.11612262E-08_JPRB, 0.11806758E-08_JPRB, &
  & 0.12044757E-08_JPRB, 0.12294454E-08_JPRB, 0.12514224E-08_JPRB, 0.12685931E-08_JPRB, 0.12731212E-08_JPRB, 0.12594378E-08_JPRB, &
  & 0.12258242E-08_JPRB, 0.11669542E-08_JPRB, 0.10828409E-08_JPRB, 0.97383668E-09_JPRB, 0.85763896E-09_JPRB, 0.73897749E-09_JPRB, &
  & 0.61494737E-09_JPRB, 0.49076232E-09_JPRB, 0.37573863E-09_JPRB, 0.29259817E-09_JPRB, 0.30999570E-09_JPRB, 0.20576596E-09_JPRB, &
  & 0.14172849E-09_JPRB, 0.93847791E-10_JPRB, 0.74391937E-10_JPRB, 0.55219284E-10_JPRB /)

RGHG4(:,24, 1) = (/ &
  & 0.31725031E-08_JPRB, 0.30160803E-08_JPRB, 0.29202889E-08_JPRB, 0.28497804E-08_JPRB, 0.27890918E-08_JPRB, 0.27178502E-08_JPRB, &
  & 0.25903815E-08_JPRB, 0.23824032E-08_JPRB, 0.22252027E-08_JPRB, 0.20930659E-08_JPRB, 0.19677782E-08_JPRB, 0.18436386E-08_JPRB, &
  & 0.17216116E-08_JPRB, 0.16010798E-08_JPRB, 0.14911545E-08_JPRB, 0.13934481E-08_JPRB, 0.13060005E-08_JPRB, 0.12318290E-08_JPRB, &
  & 0.11737910E-08_JPRB, 0.11293004E-08_JPRB, 0.11010938E-08_JPRB, 0.10915533E-08_JPRB, 0.11010516E-08_JPRB, 0.11250373E-08_JPRB, &
  & 0.11606269E-08_JPRB, 0.11958455E-08_JPRB, 0.12233322E-08_JPRB, 0.12359791E-08_JPRB, 0.12264550E-08_JPRB, 0.11952294E-08_JPRB, &
  & 0.11472927E-08_JPRB, 0.10875912E-08_JPRB, 0.10271592E-08_JPRB, 0.96802721E-09_JPRB, 0.91624630E-09_JPRB, 0.87540475E-09_JPRB, &
  & 0.84790591E-09_JPRB, 0.83538110E-09_JPRB, 0.83597179E-09_JPRB, 0.84823759E-09_JPRB, 0.86856289E-09_JPRB, 0.89304381E-09_JPRB, &
  & 0.92054547E-09_JPRB, 0.94846364E-09_JPRB, 0.97330899E-09_JPRB, 0.99103403E-09_JPRB, 0.99556641E-09_JPRB, 0.98623798E-09_JPRB, &
  & 0.95932207E-09_JPRB, 0.91103136E-09_JPRB, 0.84426505E-09_JPRB, 0.76202500E-09_JPRB, 0.67514522E-09_JPRB, 0.58231703E-09_JPRB, &
  & 0.48429594E-09_JPRB, 0.38653367E-09_JPRB, 0.29539030E-09_JPRB, 0.22618223E-09_JPRB, 0.21492812E-09_JPRB, 0.13556573E-09_JPRB, &
  & 0.88802965E-10_JPRB, 0.56608326E-10_JPRB, 0.41722081E-10_JPRB, 0.30690367E-10_JPRB /)

RGHG4(:,25, 1) = (/ &
  & 0.27809941E-08_JPRB, 0.26314659E-08_JPRB, 0.25431235E-08_JPRB, 0.24733648E-08_JPRB, 0.24105622E-08_JPRB, 0.23390803E-08_JPRB, &
  & 0.22172479E-08_JPRB, 0.20300086E-08_JPRB, 0.18881803E-08_JPRB, 0.17689932E-08_JPRB, 0.16562631E-08_JPRB, 0.15445198E-08_JPRB, &
  & 0.14358892E-08_JPRB, 0.13336583E-08_JPRB, 0.12402446E-08_JPRB, 0.11555813E-08_JPRB, 0.10778571E-08_JPRB, 0.10089857E-08_JPRB, &
  & 0.95132002E-09_JPRB, 0.90409980E-09_JPRB, 0.86930263E-09_JPRB, 0.84758833E-09_JPRB, 0.83815649E-09_JPRB, 0.83885060E-09_JPRB, &
  & 0.84857316E-09_JPRB, 0.85885515E-09_JPRB, 0.86677487E-09_JPRB, 0.86861190E-09_JPRB, 0.85856366E-09_JPRB, 0.83762552E-09_JPRB, &
  & 0.80544138E-09_JPRB, 0.76772955E-09_JPRB, 0.72863476E-09_JPRB, 0.69120321E-09_JPRB, 0.65953998E-09_JPRB, 0.63615069E-09_JPRB, &
  & 0.62353839E-09_JPRB, 0.62181310E-09_JPRB, 0.63012440E-09_JPRB, 0.64647943E-09_JPRB, 0.66844819E-09_JPRB, 0.69379702E-09_JPRB, &
  & 0.72110889E-09_JPRB, 0.74875173E-09_JPRB, 0.77320306E-09_JPRB, 0.79104373E-09_JPRB, 0.79847884E-09_JPRB, 0.79224427E-09_JPRB, &
  & 0.76959622E-09_JPRB, 0.72963929E-09_JPRB, 0.67471490E-09_JPRB, 0.61214162E-09_JPRB, 0.54267446E-09_JPRB, 0.46812432E-09_JPRB, &
  & 0.39075199E-09_JPRB, 0.30943859E-09_JPRB, 0.23311067E-09_JPRB, 0.17503551E-09_JPRB, 0.15018956E-09_JPRB, 0.89558673E-10_JPRB, &
  & 0.54931684E-10_JPRB, 0.33948754E-10_JPRB, 0.22986849E-10_JPRB, 0.15487091E-10_JPRB /)

RGHG4(:,26, 1) = (/ &
  & 0.24353555E-08_JPRB, 0.23132656E-08_JPRB, 0.22348154E-08_JPRB, 0.21687623E-08_JPRB, 0.21076023E-08_JPRB, 0.20385562E-08_JPRB, &
  & 0.19250530E-08_JPRB, 0.17567129E-08_JPRB, 0.16295177E-08_JPRB, 0.15207442E-08_JPRB, 0.14192658E-08_JPRB, 0.13197740E-08_JPRB, &
  & 0.12265907E-08_JPRB, 0.11379346E-08_JPRB, 0.10552674E-08_JPRB, 0.97886754E-09_JPRB, 0.90803165E-09_JPRB, 0.84448687E-09_JPRB, &
  & 0.78941254E-09_JPRB, 0.74121026E-09_JPRB, 0.70069939E-09_JPRB, 0.66837585E-09_JPRB, 0.64447564E-09_JPRB, 0.62789973E-09_JPRB, &
  & 0.61857480E-09_JPRB, 0.61259031E-09_JPRB, 0.60831551E-09_JPRB, 0.60312039E-09_JPRB, 0.59543814E-09_JPRB, 0.58287969E-09_JPRB, &
  & 0.56555610E-09_JPRB, 0.54490512E-09_JPRB, 0.52310389E-09_JPRB, 0.50279331E-09_JPRB, 0.48610477E-09_JPRB, 0.47553567E-09_JPRB, &
  & 0.47266574E-09_JPRB, 0.47744886E-09_JPRB, 0.48912502E-09_JPRB, 0.50638316E-09_JPRB, 0.52744292E-09_JPRB, 0.55142363E-09_JPRB, &
  & 0.57683408E-09_JPRB, 0.60231836E-09_JPRB, 0.62465089E-09_JPRB, 0.64047107E-09_JPRB, 0.64619871E-09_JPRB, 0.64028999E-09_JPRB, &
  & 0.62094613E-09_JPRB, 0.58864980E-09_JPRB, 0.54561516E-09_JPRB, 0.49642496E-09_JPRB, 0.44040524E-09_JPRB, 0.37835191E-09_JPRB, &
  & 0.31330416E-09_JPRB, 0.24882679E-09_JPRB, 0.18711169E-09_JPRB, 0.13723056E-09_JPRB, 0.10873216E-09_JPRB, 0.61433005E-10_JPRB, &
  & 0.34685737E-10_JPRB, 0.20475066E-10_JPRB, 0.11790149E-10_JPRB, 0.77349394E-11_JPRB /)

RGHG4(:,27, 1) = (/ &
  & 0.21668647E-08_JPRB, 0.20514259E-08_JPRB, 0.19787583E-08_JPRB, 0.19174218E-08_JPRB, 0.18602527E-08_JPRB, 0.17954879E-08_JPRB, &
  & 0.16903923E-08_JPRB, 0.15376963E-08_JPRB, 0.14211810E-08_JPRB, 0.13227115E-08_JPRB, 0.12333213E-08_JPRB, 0.11495239E-08_JPRB, &
  & 0.10695328E-08_JPRB, 0.99263819E-09_JPRB, 0.91968960E-09_JPRB, 0.85140178E-09_JPRB, 0.78704204E-09_JPRB, 0.72716572E-09_JPRB, &
  & 0.67246059E-09_JPRB, 0.62184352E-09_JPRB, 0.57660121E-09_JPRB, 0.53693072E-09_JPRB, 0.50362259E-09_JPRB, 0.47593435E-09_JPRB, &
  & 0.45477758E-09_JPRB, 0.43821174E-09_JPRB, 0.42648068E-09_JPRB, 0.41800433E-09_JPRB, 0.41151474E-09_JPRB, 0.40476272E-09_JPRB, &
  & 0.39674977E-09_JPRB, 0.38814191E-09_JPRB, 0.37839507E-09_JPRB, 0.37038961E-09_JPRB, 0.36410447E-09_JPRB, 0.36246847E-09_JPRB, &
  & 0.36562497E-09_JPRB, 0.37404041E-09_JPRB, 0.38673612E-09_JPRB, 0.40360867E-09_JPRB, 0.42310805E-09_JPRB, 0.44474491E-09_JPRB, &
  & 0.46779469E-09_JPRB, 0.49051713E-09_JPRB, 0.51055976E-09_JPRB, 0.52471205E-09_JPRB, 0.53061311E-09_JPRB, 0.52607080E-09_JPRB, &
  & 0.50964699E-09_JPRB, 0.48236543E-09_JPRB, 0.44736426E-09_JPRB, 0.40599293E-09_JPRB, 0.35953732E-09_JPRB, 0.30965272E-09_JPRB, &
  & 0.25723312E-09_JPRB, 0.20458846E-09_JPRB, 0.15286211E-09_JPRB, 0.11015154E-09_JPRB, 0.81557955E-10_JPRB, 0.43980611E-10_JPRB, &
  & 0.23706240E-10_JPRB, 0.12454797E-10_JPRB, 0.71942925E-11_JPRB, 0.39916881E-11_JPRB /)

RGHG4(:,28, 1) = (/ &
  & 0.19554820E-08_JPRB, 0.18365971E-08_JPRB, 0.17697849E-08_JPRB, 0.17118963E-08_JPRB, 0.16582650E-08_JPRB, 0.15969985E-08_JPRB, &
  & 0.14996486E-08_JPRB, 0.13619105E-08_JPRB, 0.12558184E-08_JPRB, 0.11695918E-08_JPRB, 0.10921968E-08_JPRB, 0.10188530E-08_JPRB, &
  & 0.94907326E-09_JPRB, 0.88109475E-09_JPRB, 0.81602336E-09_JPRB, 0.75402584E-09_JPRB, 0.69442330E-09_JPRB, 0.63746713E-09_JPRB, &
  & 0.58396027E-09_JPRB, 0.53286203E-09_JPRB, 0.48562315E-09_JPRB, 0.44205567E-09_JPRB, 0.40341711E-09_JPRB, 0.36938361E-09_JPRB, &
  & 0.34145631E-09_JPRB, 0.31890338E-09_JPRB, 0.30238134E-09_JPRB, 0.29124367E-09_JPRB, 0.28456132E-09_JPRB, 0.28080568E-09_JPRB, &
  & 0.27826086E-09_JPRB, 0.27702002E-09_JPRB, 0.27520786E-09_JPRB, 0.27526587E-09_JPRB, 0.27610098E-09_JPRB, 0.28024214E-09_JPRB, &
  & 0.28702513E-09_JPRB, 0.29731492E-09_JPRB, 0.31008002E-09_JPRB, 0.32583500E-09_JPRB, 0.34352959E-09_JPRB, 0.36287748E-09_JPRB, &
  & 0.38329215E-09_JPRB, 0.40351025E-09_JPRB, 0.42144557E-09_JPRB, 0.43425330E-09_JPRB, 0.43938125E-09_JPRB, 0.43503676E-09_JPRB, &
  & 0.42096635E-09_JPRB, 0.39887929E-09_JPRB, 0.37053483E-09_JPRB, 0.33660885E-09_JPRB, 0.29783018E-09_JPRB, 0.25626737E-09_JPRB, &
  & 0.21058154E-09_JPRB, 0.16583775E-09_JPRB, 0.12254821E-09_JPRB, 0.87692582E-10_JPRB, 0.61967570E-10_JPRB, 0.32803121E-10_JPRB, &
  & 0.16807883E-10_JPRB, 0.88735234E-11_JPRB, 0.44168497E-11_JPRB, 0.21146845E-11_JPRB /)

RGHG4(:,29, 1) = (/ &
  & 0.17809685E-08_JPRB, 0.16577002E-08_JPRB, 0.15889237E-08_JPRB, 0.15326012E-08_JPRB, 0.14815906E-08_JPRB, 0.14235255E-08_JPRB, &
  & 0.13341075E-08_JPRB, 0.12106721E-08_JPRB, 0.11172689E-08_JPRB, 0.10420116E-08_JPRB, 0.97476516E-09_JPRB, 0.91052299E-09_JPRB, &
  & 0.84841389E-09_JPRB, 0.78794538E-09_JPRB, 0.72928774E-09_JPRB, 0.67243378E-09_JPRB, 0.61700028E-09_JPRB, 0.56318389E-09_JPRB, &
  & 0.51180610E-09_JPRB, 0.46173793E-09_JPRB, 0.41452222E-09_JPRB, 0.36976375E-09_JPRB, 0.32868164E-09_JPRB, 0.29182881E-09_JPRB, &
  & 0.26050040E-09_JPRB, 0.23518734E-09_JPRB, 0.21613981E-09_JPRB, 0.20342288E-09_JPRB, 0.19620375E-09_JPRB, 0.19347715E-09_JPRB, &
  & 0.19357553E-09_JPRB, 0.19590199E-09_JPRB, 0.19891307E-09_JPRB, 0.20349887E-09_JPRB, 0.20900306E-09_JPRB, 0.21641521E-09_JPRB, &
  & 0.22536586E-09_JPRB, 0.23634905E-09_JPRB, 0.24842514E-09_JPRB, 0.26259001E-09_JPRB, 0.27828065E-09_JPRB, 0.29559771E-09_JPRB, &
  & 0.31382208E-09_JPRB, 0.33212796E-09_JPRB, 0.34844566E-09_JPRB, 0.36024658E-09_JPRB, 0.36528838E-09_JPRB, 0.36228723E-09_JPRB, &
  & 0.35103997E-09_JPRB, 0.33325562E-09_JPRB, 0.30950040E-09_JPRB, 0.28056263E-09_JPRB, 0.24822105E-09_JPRB, 0.21371439E-09_JPRB, &
  & 0.17623801E-09_JPRB, 0.13880797E-09_JPRB, 0.10225770E-09_JPRB, 0.71589366E-10_JPRB, 0.49286249E-10_JPRB, 0.25510438E-10_JPRB, &
  & 0.13065297E-10_JPRB, 0.66128747E-11_JPRB, 0.31264709E-11_JPRB, 0.13646320E-11_JPRB /)

RGHG4(:,30, 1) = (/ &
  & 0.16245580E-08_JPRB, 0.15046786E-08_JPRB, 0.14349537E-08_JPRB, 0.13800354E-08_JPRB, 0.13311715E-08_JPRB, 0.12764123E-08_JPRB, &
  & 0.11950837E-08_JPRB, 0.10862304E-08_JPRB, 0.10029986E-08_JPRB, 0.93603569E-09_JPRB, 0.87652002E-09_JPRB, 0.82017038E-09_JPRB, &
  & 0.76515544E-09_JPRB, 0.71065620E-09_JPRB, 0.65718930E-09_JPRB, 0.60491062E-09_JPRB, 0.55342586E-09_JPRB, 0.50274113E-09_JPRB, &
  & 0.45342355E-09_JPRB, 0.40476802E-09_JPRB, 0.35825892E-09_JPRB, 0.31358668E-09_JPRB, 0.27244282E-09_JPRB, 0.23516064E-09_JPRB, &
  & 0.20301170E-09_JPRB, 0.17684886E-09_JPRB, 0.15685120E-09_JPRB, 0.14312353E-09_JPRB, 0.13529315E-09_JPRB, 0.13237679E-09_JPRB, &
  & 0.13295456E-09_JPRB, 0.13656382E-09_JPRB, 0.14186141E-09_JPRB, 0.14877163E-09_JPRB, 0.15681165E-09_JPRB, 0.16581672E-09_JPRB, &
  & 0.17570505E-09_JPRB, 0.18663442E-09_JPRB, 0.19800794E-09_JPRB, 0.21088967E-09_JPRB, 0.22503585E-09_JPRB, 0.24072747E-09_JPRB, &
  & 0.25733202E-09_JPRB, 0.27416114E-09_JPRB, 0.28929695E-09_JPRB, 0.30057845E-09_JPRB, 0.30592182E-09_JPRB, 0.30411570E-09_JPRB, &
  & 0.29516678E-09_JPRB, 0.28007913E-09_JPRB, 0.25987695E-09_JPRB, 0.23540142E-09_JPRB, 0.20848998E-09_JPRB, 0.17893526E-09_JPRB, &
  & 0.14842100E-09_JPRB, 0.11715957E-09_JPRB, 0.86263122E-10_JPRB, 0.59481191E-10_JPRB, 0.39684818E-10_JPRB, 0.20568118E-10_JPRB, &
  & 0.10371571E-10_JPRB, 0.53786368E-11_JPRB, 0.24188555E-11_JPRB, 0.10042540E-11_JPRB /)

RGHG4(:,31, 1) = (/ &
  & 0.14769631E-08_JPRB, 0.13612889E-08_JPRB, 0.12923382E-08_JPRB, 0.12399464E-08_JPRB, 0.11938656E-08_JPRB, 0.11433307E-08_JPRB, &
  & 0.10704229E-08_JPRB, 0.97418063E-09_JPRB, 0.90032037E-09_JPRB, 0.84103463E-09_JPRB, 0.78825613E-09_JPRB, 0.73827805E-09_JPRB, &
  & 0.68935174E-09_JPRB, 0.64058731E-09_JPRB, 0.59198785E-09_JPRB, 0.54374610E-09_JPRB, 0.49556642E-09_JPRB, 0.44758397E-09_JPRB, &
  & 0.40016107E-09_JPRB, 0.35320624E-09_JPRB, 0.30818770E-09_JPRB, 0.26483371E-09_JPRB, 0.22487358E-09_JPRB, 0.18897298E-09_JPRB, &
  & 0.15805267E-09_JPRB, 0.13253874E-09_JPRB, 0.11307855E-09_JPRB, 0.99590350E-10_JPRB, 0.91550489E-10_JPRB, 0.88300367E-10_JPRB, &
  & 0.88671556E-10_JPRB, 0.92128118E-10_JPRB, 0.97982129E-10_JPRB, 0.10541247E-09_JPRB, 0.11412549E-09_JPRB, 0.12342746E-09_JPRB, &
  & 0.13317833E-09_JPRB, 0.14331619E-09_JPRB, 0.15375259E-09_JPRB, 0.16543458E-09_JPRB, 0.17837255E-09_JPRB, 0.19288818E-09_JPRB, &
  & 0.20846799E-09_JPRB, 0.22443056E-09_JPRB, 0.23895724E-09_JPRB, 0.25012317E-09_JPRB, 0.25586019E-09_JPRB, 0.25524532E-09_JPRB, &
  & 0.24853022E-09_JPRB, 0.23640886E-09_JPRB, 0.21977392E-09_JPRB, 0.19933347E-09_JPRB, 0.17680714E-09_JPRB, 0.15182980E-09_JPRB, &
  & 0.12602294E-09_JPRB, 0.98554574E-10_JPRB, 0.72567875E-10_JPRB, 0.49499470E-10_JPRB, 0.32447239E-10_JPRB, 0.16739036E-10_JPRB, &
  & 0.85427889E-11_JPRB, 0.42538208E-11_JPRB, 0.21046205E-11_JPRB, 0.80353524E-12_JPRB /)

RGHG4(:,32, 1) = (/ &
  & 0.13435525E-08_JPRB, 0.12334389E-08_JPRB, 0.11674960E-08_JPRB, 0.11173567E-08_JPRB, 0.10740495E-08_JPRB, 0.10271360E-08_JPRB, &
  & 0.96143338E-09_JPRB, 0.87615126E-09_JPRB, 0.81008972E-09_JPRB, 0.75719880E-09_JPRB, 0.71044787E-09_JPRB, 0.66613826E-09_JPRB, &
  & 0.62230199E-09_JPRB, 0.57787974E-09_JPRB, 0.53300714E-09_JPRB, 0.48795545E-09_JPRB, 0.44252593E-09_JPRB, 0.39685841E-09_JPRB, &
  & 0.35153877E-09_JPRB, 0.30669906E-09_JPRB, 0.26356556E-09_JPRB, 0.22248496E-09_JPRB, 0.18498511E-09_JPRB, 0.15132687E-09_JPRB, &
  & 0.12267128E-09_JPRB, 0.99274339E-10_JPRB, 0.81286027E-10_JPRB, 0.68872893E-10_JPRB, 0.61133161E-10_JPRB, 0.57641992E-10_JPRB, &
  & 0.57371288E-10_JPRB, 0.60003336E-10_JPRB, 0.65292376E-10_JPRB, 0.71889938E-10_JPRB, 0.80226985E-10_JPRB, 0.88882526E-10_JPRB, &
  & 0.97926285E-10_JPRB, 0.10729369E-09_JPRB, 0.11707163E-09_JPRB, 0.12784233E-09_JPRB, 0.13978989E-09_JPRB, 0.15326128E-09_JPRB, &
  & 0.16797427E-09_JPRB, 0.18322564E-09_JPRB, 0.19732262E-09_JPRB, 0.20845443E-09_JPRB, 0.21471762E-09_JPRB, 0.21531708E-09_JPRB, &
  & 0.21029836E-09_JPRB, 0.20039427E-09_JPRB, 0.18647250E-09_JPRB, 0.16968450E-09_JPRB, 0.15062995E-09_JPRB, 0.12901240E-09_JPRB, &
  & 0.10747959E-09_JPRB, 0.84369747E-10_JPRB, 0.62170616E-10_JPRB, 0.41893020E-10_JPRB, 0.26856262E-10_JPRB, 0.13737495E-10_JPRB, &
  & 0.72045417E-11_JPRB, 0.35063855E-11_JPRB, 0.16697245E-11_JPRB, 0.60857087E-12_JPRB /)

RGHG4(:,33, 1) = (/ &
  & 0.12156076E-08_JPRB, 0.11135655E-08_JPRB, 0.10515033E-08_JPRB, 0.10038892E-08_JPRB, 0.96389063E-09_JPRB, 0.92032393E-09_JPRB, &
  & 0.86108415E-09_JPRB, 0.78520296E-09_JPRB, 0.72622874E-09_JPRB, 0.67911660E-09_JPRB, 0.63775474E-09_JPRB, 0.59842836E-09_JPRB, &
  & 0.55922317E-09_JPRB, 0.51900845E-09_JPRB, 0.47745674E-09_JPRB, 0.43484832E-09_JPRB, 0.39130912E-09_JPRB, 0.34727349E-09_JPRB, &
  & 0.30346073E-09_JPRB, 0.26053620E-09_JPRB, 0.21977312E-09_JPRB, 0.18172767E-09_JPRB, 0.14729773E-09_JPRB, 0.11734129E-09_JPRB, &
  & 0.92162292E-10_JPRB, 0.71971595E-10_JPRB, 0.56669065E-10_JPRB, 0.46006747E-10_JPRB, 0.39189214E-10_JPRB, 0.35914622E-10_JPRB, &
  & 0.34939968E-10_JPRB, 0.36849017E-10_JPRB, 0.40495850E-10_JPRB, 0.45894632E-10_JPRB, 0.52716279E-10_JPRB, 0.59903298E-10_JPRB, &
  & 0.67727289E-10_JPRB, 0.75890481E-10_JPRB, 0.84603026E-10_JPRB, 0.94317859E-10_JPRB, 0.10536035E-09_JPRB, 0.11807716E-09_JPRB, &
  & 0.13230970E-09_JPRB, 0.14726292E-09_JPRB, 0.16128605E-09_JPRB, 0.17260472E-09_JPRB, 0.17947145E-09_JPRB, 0.18119828E-09_JPRB, &
  & 0.17776652E-09_JPRB, 0.17003747E-09_JPRB, 0.15858910E-09_JPRB, 0.14455687E-09_JPRB, 0.12866354E-09_JPRB, 0.11067148E-09_JPRB, &
  & 0.92556643E-10_JPRB, 0.72801279E-10_JPRB, 0.52988433E-10_JPRB, 0.35629513E-10_JPRB, 0.22822898E-10_JPRB, 0.11840458E-10_JPRB, &
  & 0.60514645E-11_JPRB, 0.30078071E-11_JPRB, 0.13573692E-11_JPRB, 0.58002464E-12_JPRB /)

RGHG4(:,34, 1) = (/ &
  & 0.11015584E-08_JPRB, 0.10068317E-08_JPRB, 0.94919472E-09_JPRB, 0.90442787E-09_JPRB, 0.86653579E-09_JPRB, 0.82581469E-09_JPRB, &
  & 0.77164702E-09_JPRB, 0.70375089E-09_JPRB, 0.65072181E-09_JPRB, 0.60852190E-09_JPRB, 0.57176991E-09_JPRB, 0.53688798E-09_JPRB, &
  & 0.50164445E-09_JPRB, 0.46478851E-09_JPRB, 0.42605322E-09_JPRB, 0.38546988E-09_JPRB, 0.34348735E-09_JPRB, 0.30078276E-09_JPRB, &
  & 0.25829225E-09_JPRB, 0.21762679E-09_JPRB, 0.17953143E-09_JPRB, 0.14455123E-09_JPRB, 0.11396008E-09_JPRB, 0.88066721E-10_JPRB, &
  & 0.67136748E-10_JPRB, 0.50765631E-10_JPRB, 0.38605296E-10_JPRB, 0.30072899E-10_JPRB, 0.24577358E-10_JPRB, 0.21699942E-10_JPRB, &
  & 0.20568649E-10_JPRB, 0.21582064E-10_JPRB, 0.23766390E-10_JPRB, 0.27687855E-10_JPRB, 0.32517152E-10_JPRB, 0.38155975E-10_JPRB, &
  & 0.44422563E-10_JPRB, 0.51084328E-10_JPRB, 0.58475884E-10_JPRB, 0.66985931E-10_JPRB, 0.76976252E-10_JPRB, 0.88847776E-10_JPRB, &
  & 0.10257505E-09_JPRB, 0.11721052E-09_JPRB, 0.13122724E-09_JPRB, 0.14269667E-09_JPRB, 0.15011416E-09_JPRB, 0.15274904E-09_JPRB, &
  & 0.15078033E-09_JPRB, 0.14484017E-09_JPRB, 0.13539850E-09_JPRB, 0.12373563E-09_JPRB, 0.10984972E-09_JPRB, 0.94778733E-10_JPRB, &
  & 0.78668683E-10_JPRB, 0.62318747E-10_JPRB, 0.45470985E-10_JPRB, 0.30576552E-10_JPRB, 0.19631213E-10_JPRB, 0.10114792E-10_JPRB, &
  & 0.50846922E-11_JPRB, 0.25627571E-11_JPRB, 0.11209898E-11_JPRB, 0.51787161E-12_JPRB /)

RGHG4(:,35, 1) = (/ &
  & 0.99143516E-09_JPRB, 0.90396413E-09_JPRB, 0.85097990E-09_JPRB, 0.80936197E-09_JPRB, 0.77386048E-09_JPRB, 0.73613610E-09_JPRB, &
  & 0.68665479E-09_JPRB, 0.62599487E-09_JPRB, 0.57864041E-09_JPRB, 0.54121924E-09_JPRB, 0.50880650E-09_JPRB, 0.47811333E-09_JPRB, &
  & 0.44667120E-09_JPRB, 0.41306658E-09_JPRB, 0.37682921E-09_JPRB, 0.33788283E-09_JPRB, 0.29710839E-09_JPRB, 0.25532668E-09_JPRB, &
  & 0.21422818E-09_JPRB, 0.17554325E-09_JPRB, 0.14012688E-09_JPRB, 0.10898729E-09_JPRB, 0.82869954E-10_JPRB, 0.61909956E-10_JPRB, &
  & 0.45708708E-10_JPRB, 0.33590179E-10_JPRB, 0.24908188E-10_JPRB, 0.18789111E-10_JPRB, 0.14889515E-10_JPRB, 0.12657421E-10_JPRB, &
  & 0.11728041E-10_JPRB, 0.12008319E-10_JPRB, 0.13210322E-10_JPRB, 0.15531609E-10_JPRB, 0.18527407E-10_JPRB, 0.22442076E-10_JPRB, &
  & 0.26759948E-10_JPRB, 0.31717906E-10_JPRB, 0.37448000E-10_JPRB, 0.44381616E-10_JPRB, 0.52971579E-10_JPRB, 0.63690116E-10_JPRB, &
  & 0.76647334E-10_JPRB, 0.91028213E-10_JPRB, 0.10501182E-09_JPRB, 0.11674063E-09_JPRB, 0.12469629E-09_JPRB, 0.12821015E-09_JPRB, &
  & 0.12745124E-09_JPRB, 0.12299474E-09_JPRB, 0.11541176E-09_JPRB, 0.10580662E-09_JPRB, 0.94199912E-10_JPRB, 0.81518153E-10_JPRB, &
  & 0.67751013E-10_JPRB, 0.53781431E-10_JPRB, 0.39347768E-10_JPRB, 0.26186791E-10_JPRB, 0.16645367E-10_JPRB, 0.85489133E-11_JPRB, &
  & 0.43125755E-11_JPRB, 0.21406516E-11_JPRB, 0.91224933E-12_JPRB, 0.43255834E-12_JPRB /)

RGHG4(:,36, 1) = (/ &
  & 0.88758090E-09_JPRB, 0.80855983E-09_JPRB, 0.76015988E-09_JPRB, 0.72204059E-09_JPRB, 0.68888284E-09_JPRB, 0.65410738E-09_JPRB, &
  & 0.60918365E-09_JPRB, 0.55505450E-09_JPRB, 0.51283378E-09_JPRB, 0.47973786E-09_JPRB, 0.45126930E-09_JPRB, 0.42450560E-09_JPRB, &
  & 0.39678588E-09_JPRB, 0.36643238E-09_JPRB, 0.33260653E-09_JPRB, 0.29549910E-09_JPRB, 0.25570016E-09_JPRB, 0.21476008E-09_JPRB, &
  & 0.17494983E-09_JPRB, 0.13812400E-09_JPRB, 0.10575749E-09_JPRB, 0.78752213E-10_JPRB, 0.57449656E-10_JPRB, 0.41490717E-10_JPRB, &
  & 0.30024684E-10_JPRB, 0.21777519E-10_JPRB, 0.16081825E-10_JPRB, 0.12095175E-10_JPRB, 0.95423123E-11_JPRB, 0.79393714E-11_JPRB, &
  & 0.72788294E-11_JPRB, 0.72032436E-11_JPRB, 0.78895944E-11_JPRB, 0.90988736E-11_JPRB, 0.10978776E-10_JPRB, 0.13397437E-10_JPRB, &
  & 0.16267585E-10_JPRB, 0.19764003E-10_JPRB, 0.23873823E-10_JPRB, 0.29137207E-10_JPRB, 0.35952432E-10_JPRB, 0.45017386E-10_JPRB, &
  & 0.56572615E-10_JPRB, 0.69964159E-10_JPRB, 0.83535422E-10_JPRB, 0.95277383E-10_JPRB, 0.10361792E-09_JPRB, 0.10782799E-09_JPRB, &
  & 0.10810741E-09_JPRB, 0.10494653E-09_JPRB, 0.99130912E-10_JPRB, 0.91284869E-10_JPRB, 0.81404349E-10_JPRB, 0.70502902E-10_JPRB, &
  & 0.58514568E-10_JPRB, 0.46400588E-10_JPRB, 0.33775021E-10_JPRB, 0.22277642E-10_JPRB, 0.14049806E-10_JPRB, 0.71837727E-11_JPRB, &
  & 0.35463015E-11_JPRB, 0.17000213E-11_JPRB, 0.71861110E-12_JPRB, 0.35465825E-12_JPRB /)

RGHG4(:,37, 1) = (/ &
  & 0.78869500E-09_JPRB, 0.71822054E-09_JPRB, 0.67500155E-09_JPRB, 0.64021100E-09_JPRB, 0.60965377E-09_JPRB, 0.57726046E-09_JPRB, &
  & 0.53646892E-09_JPRB, 0.48822285E-09_JPRB, 0.45079052E-09_JPRB, 0.42173345E-09_JPRB, 0.39701084E-09_JPRB, 0.37386227E-09_JPRB, &
  & 0.34946407E-09_JPRB, 0.32234734E-09_JPRB, 0.29091704E-09_JPRB, 0.25538044E-09_JPRB, 0.21684159E-09_JPRB, 0.17701889E-09_JPRB, &
  & 0.13858557E-09_JPRB, 0.10418250E-09_JPRB, 0.75577926E-10_JPRB, 0.53409891E-10_JPRB, 0.37630472E-10_JPRB, 0.26595250E-10_JPRB, &
  & 0.19276645E-10_JPRB, 0.14221259E-10_JPRB, 0.10763099E-10_JPRB, 0.82854461E-11_JPRB, 0.66556014E-11_JPRB, 0.55727632E-11_JPRB, &
  & 0.50363034E-11_JPRB, 0.49275549E-11_JPRB, 0.52417307E-11_JPRB, 0.59679202E-11_JPRB, 0.71253706E-11_JPRB, 0.86414764E-11_JPRB, &
  & 0.10583169E-10_JPRB, 0.12942292E-10_JPRB, 0.15865588E-10_JPRB, 0.19679463E-10_JPRB, 0.24756513E-10_JPRB, 0.31827329E-10_JPRB, &
  & 0.41298135E-10_JPRB, 0.53046612E-10_JPRB, 0.65639494E-10_JPRB, 0.77057603E-10_JPRB, 0.85516719E-10_JPRB, 0.90262534E-10_JPRB, &
  & 0.91395232E-10_JPRB, 0.89294426E-10_JPRB, 0.84679624E-10_JPRB, 0.78101650E-10_JPRB, 0.69638274E-10_JPRB, 0.60625997E-10_JPRB, &
  & 0.50446668E-10_JPRB, 0.40040898E-10_JPRB, 0.29216386E-10_JPRB, 0.19047661E-10_JPRB, 0.11818988E-10_JPRB, 0.59435074E-11_JPRB, &
  & 0.29039503E-11_JPRB, 0.13771850E-11_JPRB, 0.57997650E-12_JPRB, 0.30657893E-12_JPRB /)

RGHG4(:,38, 1) = (/ &
  & 0.69758010E-09_JPRB, 0.63517858E-09_JPRB, 0.59655281E-09_JPRB, 0.56534549E-09_JPRB, 0.53743693E-09_JPRB, 0.50751003E-09_JPRB, &
  & 0.47036269E-09_JPRB, 0.42752851E-09_JPRB, 0.39440273E-09_JPRB, 0.36896411E-09_JPRB, 0.34772651E-09_JPRB, 0.32781489E-09_JPRB, &
  & 0.30694455E-09_JPRB, 0.28278788E-09_JPRB, 0.25417726E-09_JPRB, 0.22028156E-09_JPRB, 0.18285679E-09_JPRB, 0.14442783E-09_JPRB, &
  & 0.10810067E-09_JPRB, 0.76872383E-10_JPRB, 0.53011390E-10_JPRB, 0.36128017E-10_JPRB, 0.25052120E-10_JPRB, 0.17939815E-10_JPRB, &
  & 0.13310826E-10_JPRB, 0.10157476E-10_JPRB, 0.79951488E-11_JPRB, 0.63770794E-11_JPRB, 0.52115976E-11_JPRB, 0.44612643E-11_JPRB, &
  & 0.39721967E-11_JPRB, 0.38670161E-11_JPRB, 0.40100701E-11_JPRB, 0.45040568E-11_JPRB, 0.52697985E-11_JPRB, 0.63659559E-11_JPRB, &
  & 0.77551628E-11_JPRB, 0.94800938E-11_JPRB, 0.11658375E-10_JPRB, 0.14478279E-10_JPRB, 0.18336544E-10_JPRB, 0.23776774E-10_JPRB, &
  & 0.31297250E-10_JPRB, 0.41085021E-10_JPRB, 0.52066941E-10_JPRB, 0.62563441E-10_JPRB, 0.70729173E-10_JPRB, 0.75765776E-10_JPRB, &
  & 0.77478482E-10_JPRB, 0.76237419E-10_JPRB, 0.72694156E-10_JPRB, 0.67362678E-10_JPRB, 0.60241756E-10_JPRB, 0.52387508E-10_JPRB, &
  & 0.43449234E-10_JPRB, 0.34440530E-10_JPRB, 0.25229327E-10_JPRB, 0.16374548E-10_JPRB, 0.10037921E-10_JPRB, 0.49596139E-11_JPRB, &
  & 0.23683369E-11_JPRB, 0.11209697E-11_JPRB, 0.47636575E-12_JPRB, 0.26393793E-12_JPRB /)

RGHG4(:,39, 1) = (/ &
  & 0.61179067E-09_JPRB, 0.55754934E-09_JPRB, 0.52364640E-09_JPRB, 0.49575499E-09_JPRB, 0.47033560E-09_JPRB, 0.44306359E-09_JPRB, &
  & 0.40936141E-09_JPRB, 0.37155756E-09_JPRB, 0.34236372E-09_JPRB, 0.32037151E-09_JPRB, 0.30211955E-09_JPRB, 0.28516825E-09_JPRB, &
  & 0.26724961E-09_JPRB, 0.24615507E-09_JPRB, 0.22033129E-09_JPRB, 0.18899543E-09_JPRB, 0.15330739E-09_JPRB, 0.11661071E-09_JPRB, &
  & 0.83430395E-10_JPRB, 0.56675595E-10_JPRB, 0.37820375E-10_JPRB, 0.25564334E-10_JPRB, 0.17955240E-10_JPRB, 0.13161927E-10_JPRB, &
  & 0.10147212E-10_JPRB, 0.79812068E-11_JPRB, 0.64942366E-11_JPRB, 0.53314952E-11_JPRB, 0.44593890E-11_JPRB, 0.38254001E-11_JPRB, &
  & 0.34388690E-11_JPRB, 0.32764859E-11_JPRB, 0.33751131E-11_JPRB, 0.37119197E-11_JPRB, 0.43018267E-11_JPRB, 0.51364217E-11_JPRB, &
  & 0.62046462E-11_JPRB, 0.75627924E-11_JPRB, 0.92642864E-11_JPRB, 0.11484948E-10_JPRB, 0.14513237E-10_JPRB, 0.18765628E-10_JPRB, &
  & 0.24770210E-10_JPRB, 0.32688508E-10_JPRB, 0.41986432E-10_JPRB, 0.51169718E-10_JPRB, 0.58786725E-10_JPRB, 0.63675426E-10_JPRB, &
  & 0.65690745E-10_JPRB, 0.65061123E-10_JPRB, 0.62284317E-10_JPRB, 0.57729429E-10_JPRB, 0.51525572E-10_JPRB, 0.44754058E-10_JPRB, &
  & 0.37223370E-10_JPRB, 0.29681112E-10_JPRB, 0.22027789E-10_JPRB, 0.14321584E-10_JPRB, 0.86880607E-11_JPRB, 0.42406786E-11_JPRB, &
  & 0.20340622E-11_JPRB, 0.94258748E-12_JPRB, 0.42010430E-12_JPRB, 0.23655576E-12_JPRB /)

RGHG4(:,40, 1) = (/ &
  & 0.53326077E-09_JPRB, 0.48633558E-09_JPRB, 0.45661755E-09_JPRB, 0.43211712E-09_JPRB, 0.40931336E-09_JPRB, 0.38448658E-09_JPRB, &
  & 0.35443370E-09_JPRB, 0.32139663E-09_JPRB, 0.29602884E-09_JPRB, 0.27681898E-09_JPRB, 0.26135638E-09_JPRB, 0.24674374E-09_JPRB, &
  & 0.23161474E-09_JPRB, 0.21333559E-09_JPRB, 0.19013910E-09_JPRB, 0.16098792E-09_JPRB, 0.12783832E-09_JPRB, 0.94183578E-10_JPRB, &
  & 0.64731664E-10_JPRB, 0.42826191E-10_JPRB, 0.28356444E-10_JPRB, 0.19397671E-10_JPRB, 0.14012448E-10_JPRB, 0.10549604E-10_JPRB, &
  & 0.83275904E-11_JPRB, 0.67715260E-11_JPRB, 0.56114375E-11_JPRB, 0.47003139E-11_JPRB, 0.39914951E-11_JPRB, 0.34512740E-11_JPRB, &
  & 0.30957314E-11_JPRB, 0.29322076E-11_JPRB, 0.29813333E-11_JPRB, 0.32399970E-11_JPRB, 0.37207455E-11_JPRB, 0.43984608E-11_JPRB, &
  & 0.52926166E-11_JPRB, 0.64031545E-11_JPRB, 0.78111788E-11_JPRB, 0.96546902E-11_JPRB, 0.12140892E-10_JPRB, 0.15620770E-10_JPRB, &
  & 0.20476901E-10_JPRB, 0.26954076E-10_JPRB, 0.34665614E-10_JPRB, 0.42651348E-10_JPRB, 0.49305438E-10_JPRB, 0.53882662E-10_JPRB, &
  & 0.55978774E-10_JPRB, 0.55680380E-10_JPRB, 0.53428630E-10_JPRB, 0.49534488E-10_JPRB, 0.44255027E-10_JPRB, 0.38415639E-10_JPRB, &
  & 0.31869327E-10_JPRB, 0.25472936E-10_JPRB, 0.19239964E-10_JPRB, 0.12612114E-10_JPRB, 0.77369691E-11_JPRB, 0.37845295E-11_JPRB, &
  & 0.18059585E-11_JPRB, 0.84081174E-12_JPRB, 0.40766224E-12_JPRB, 0.21998492E-12_JPRB /)

RGHG4(:,41, 1) = (/ &
  & 0.46377063E-09_JPRB, 0.42269058E-09_JPRB, 0.39669187E-09_JPRB, 0.37498685E-09_JPRB, 0.35453232E-09_JPRB, 0.33212910E-09_JPRB, &
  & 0.30517955E-09_JPRB, 0.27639172E-09_JPRB, 0.25436833E-09_JPRB, 0.23806063E-09_JPRB, 0.22462783E-09_JPRB, 0.21243356E-09_JPRB, &
  & 0.19914811E-09_JPRB, 0.18356450E-09_JPRB, 0.16339803E-09_JPRB, 0.13728310E-09_JPRB, 0.10663907E-09_JPRB, 0.76453156E-10_JPRB, &
  & 0.51728486E-10_JPRB, 0.33896098E-10_JPRB, 0.22722680E-10_JPRB, 0.15843188E-10_JPRB, 0.11686862E-10_JPRB, 0.91248693E-11_JPRB, &
  & 0.72620152E-11_JPRB, 0.60490684E-11_JPRB, 0.50705043E-11_JPRB, 0.43071388E-11_JPRB, 0.36771940E-11_JPRB, 0.32057510E-11_JPRB, &
  & 0.28678834E-11_JPRB, 0.27103339E-11_JPRB, 0.27277451E-11_JPRB, 0.29440712E-11_JPRB, 0.33519916E-11_JPRB, 0.39400666E-11_JPRB, &
  & 0.47055910E-11_JPRB, 0.56668698E-11_JPRB, 0.68858088E-11_JPRB, 0.84560562E-11_JPRB, 0.10564715E-10_JPRB, 0.13492604E-10_JPRB, &
  & 0.17574418E-10_JPRB, 0.22972953E-10_JPRB, 0.29457499E-10_JPRB, 0.36068731E-10_JPRB, 0.41862704E-10_JPRB, 0.45932563E-10_JPRB, &
  & 0.47894612E-10_JPRB, 0.47801266E-10_JPRB, 0.45958702E-10_JPRB, 0.42604604E-10_JPRB, 0.37913679E-10_JPRB, 0.32777822E-10_JPRB, &
  & 0.27162153E-10_JPRB, 0.21888120E-10_JPRB, 0.16868220E-10_JPRB, 0.11268152E-10_JPRB, 0.70398986E-11_JPRB, 0.34128403E-11_JPRB, &
  & 0.16715523E-11_JPRB, 0.79378485E-12_JPRB, 0.41759646E-12_JPRB, 0.21005890E-12_JPRB /)

RGHG4(:,42, 1) = (/ &
  & 0.40019851E-09_JPRB, 0.36461073E-09_JPRB, 0.34173736E-09_JPRB, 0.32282357E-09_JPRB, 0.30469277E-09_JPRB, 0.28459923E-09_JPRB, &
  & 0.26084793E-09_JPRB, 0.23592156E-09_JPRB, 0.21701851E-09_JPRB, 0.20319602E-09_JPRB, 0.19181919E-09_JPRB, 0.18140281E-09_JPRB, &
  & 0.17040840E-09_JPRB, 0.15676618E-09_JPRB, 0.13894813E-09_JPRB, 0.11575818E-09_JPRB, 0.88606976E-10_JPRB, 0.61935415E-10_JPRB, &
  & 0.41203565E-10_JPRB, 0.27402566E-10_JPRB, 0.18765938E-10_JPRB, 0.13535145E-10_JPRB, 0.10127769E-10_JPRB, 0.80983076E-11_JPRB, &
  & 0.65340992E-11_JPRB, 0.55116966E-11_JPRB, 0.46498591E-11_JPRB, 0.39818465E-11_JPRB, 0.34188477E-11_JPRB, 0.29924221E-11_JPRB, &
  & 0.26808963E-11_JPRB, 0.25294571E-11_JPRB, 0.25323092E-11_JPRB, 0.27185268E-11_JPRB, 0.30782026E-11_JPRB, 0.36044011E-11_JPRB, &
  & 0.42837964E-11_JPRB, 0.51298141E-11_JPRB, 0.61934212E-11_JPRB, 0.75669401E-11_JPRB, 0.94073933E-11_JPRB, 0.11914369E-10_JPRB, &
  & 0.15344210E-10_JPRB, 0.19835446E-10_JPRB, 0.25228885E-10_JPRB, 0.30882241E-10_JPRB, 0.35804373E-10_JPRB, 0.39350218E-10_JPRB, &
  & 0.41143321E-10_JPRB, 0.41167035E-10_JPRB, 0.39625723E-10_JPRB, 0.36621057E-10_JPRB, 0.32482298E-10_JPRB, 0.27980087E-10_JPRB, &
  & 0.23280215E-10_JPRB, 0.18817553E-10_JPRB, 0.14782054E-10_JPRB, 0.10098857E-10_JPRB, 0.64726874E-11_JPRB, 0.32491369E-11_JPRB, &
  & 0.16467304E-11_JPRB, 0.80268203E-12_JPRB, 0.44326112E-12_JPRB, 0.21491138E-12_JPRB /)

RGHG4(:,43, 1) = (/ &
  & 0.34308176E-09_JPRB, 0.31178340E-09_JPRB, 0.29192435E-09_JPRB, 0.27526811E-09_JPRB, 0.25919333E-09_JPRB, 0.24116739E-09_JPRB, &
  & 0.22017813E-09_JPRB, 0.19862149E-09_JPRB, 0.18242556E-09_JPRB, 0.17078984E-09_JPRB, 0.16126504E-09_JPRB, 0.15248705E-09_JPRB, &
  & 0.14316938E-09_JPRB, 0.13199546E-09_JPRB, 0.11686349E-09_JPRB, 0.96601560E-10_JPRB, 0.73109019E-10_JPRB, 0.51061322E-10_JPRB, &
  & 0.34128200E-10_JPRB, 0.22953641E-10_JPRB, 0.16061711E-10_JPRB, 0.11892084E-10_JPRB, 0.91206140E-11_JPRB, 0.73534026E-11_JPRB, &
  & 0.60183291E-11_JPRB, 0.50988007E-11_JPRB, 0.43170285E-11_JPRB, 0.37053706E-11_JPRB, 0.31934004E-11_JPRB, 0.28019800E-11_JPRB, &
  & 0.25192474E-11_JPRB, 0.23792142E-11_JPRB, 0.23781424E-11_JPRB, 0.25438466E-11_JPRB, 0.28723569E-11_JPRB, 0.33530657E-11_JPRB, &
  & 0.39684592E-11_JPRB, 0.47297153E-11_JPRB, 0.56813096E-11_JPRB, 0.68953237E-11_JPRB, 0.84949990E-11_JPRB, 0.10651086E-10_JPRB, &
  & 0.13580205E-10_JPRB, 0.17378234E-10_JPRB, 0.21900835E-10_JPRB, 0.26565448E-10_JPRB, 0.30703266E-10_JPRB, 0.33746558E-10_JPRB, &
  & 0.35345102E-10_JPRB, 0.35458355E-10_JPRB, 0.34165521E-10_JPRB, 0.31560098E-10_JPRB, 0.27892650E-10_JPRB, 0.23994641E-10_JPRB, &
  & 0.19976626E-10_JPRB, 0.16249691E-10_JPRB, 0.13071246E-10_JPRB, 0.91833043E-11_JPRB, 0.61405412E-11_JPRB, 0.32094269E-11_JPRB, &
  & 0.16539394E-11_JPRB, 0.87762230E-12_JPRB, 0.48926434E-12_JPRB, 0.24482806E-12_JPRB /)

RGHG4(:,44, 1) = (/ &
  & 0.29065486E-09_JPRB, 0.26325953E-09_JPRB, 0.24566382E-09_JPRB, 0.23118972E-09_JPRB, 0.21712157E-09_JPRB, 0.20132279E-09_JPRB, &
  & 0.18315881E-09_JPRB, 0.16468098E-09_JPRB, 0.15093593E-09_JPRB, 0.14123760E-09_JPRB, 0.13333509E-09_JPRB, 0.12614564E-09_JPRB, &
  & 0.11853901E-09_JPRB, 0.10912224E-09_JPRB, 0.96649973E-10_JPRB, 0.79447095E-10_JPRB, 0.59296339E-10_JPRB, 0.41044036E-10_JPRB, &
  & 0.28028534E-10_JPRB, 0.19505668E-10_JPRB, 0.14045010E-10_JPRB, 0.10611408E-10_JPRB, 0.83290813E-11_JPRB, 0.67597542E-11_JPRB, &
  & 0.55867346E-11_JPRB, 0.47314223E-11_JPRB, 0.40116474E-11_JPRB, 0.34413770E-11_JPRB, 0.29703878E-11_JPRB, 0.26159103E-11_JPRB, &
  & 0.23607056E-11_JPRB, 0.22383766E-11_JPRB, 0.22405914E-11_JPRB, 0.23938065E-11_JPRB, 0.27008751E-11_JPRB, 0.31475068E-11_JPRB, &
  & 0.37141588E-11_JPRB, 0.44038462E-11_JPRB, 0.52553031E-11_JPRB, 0.63317251E-11_JPRB, 0.77372440E-11_JPRB, 0.95976239E-11_JPRB, &
  & 0.12059415E-10_JPRB, 0.15185261E-10_JPRB, 0.18901032E-10_JPRB, 0.22788882E-10_JPRB, 0.26281182E-10_JPRB, 0.28881401E-10_JPRB, &
  & 0.30299790E-10_JPRB, 0.30470879E-10_JPRB, 0.29420390E-10_JPRB, 0.27162514E-10_JPRB, 0.24012627E-10_JPRB, 0.20664633E-10_JPRB, &
  & 0.17293535E-10_JPRB, 0.14244603E-10_JPRB, 0.11701897E-10_JPRB, 0.84636716E-11_JPRB, 0.59414756E-11_JPRB, 0.32777346E-11_JPRB, &
  & 0.17768368E-11_JPRB, 0.10124355E-11_JPRB, 0.56040188E-12_JPRB, 0.30164545E-12_JPRB /)

RGHG4(:,45, 1) = (/ &
  & 0.24208457E-09_JPRB, 0.21800733E-09_JPRB, 0.20282799E-09_JPRB, 0.19027310E-09_JPRB, 0.17799953E-09_JPRB, 0.16417129E-09_JPRB, &
  & 0.14867912E-09_JPRB, 0.13319035E-09_JPRB, 0.12171082E-09_JPRB, 0.11382580E-09_JPRB, 0.10747523E-09_JPRB, 0.10168269E-09_JPRB, &
  & 0.95699337E-10_JPRB, 0.88263341E-10_JPRB, 0.78145906E-10_JPRB, 0.64200444E-10_JPRB, 0.48113083E-10_JPRB, 0.33630120E-10_JPRB, &
  & 0.23321695E-10_JPRB, 0.16724785E-10_JPRB, 0.12467929E-10_JPRB, 0.95888280E-11_JPRB, 0.76910830E-11_JPRB, 0.62501926E-11_JPRB, &
  & 0.52129893E-11_JPRB, 0.43943304E-11_JPRB, 0.37252948E-11_JPRB, 0.31880700E-11_JPRB, 0.27497583E-11_JPRB, 0.24289201E-11_JPRB, &
  & 0.22098707E-11_JPRB, 0.21025057E-11_JPRB, 0.21160098E-11_JPRB, 0.22607014E-11_JPRB, 0.25524548E-11_JPRB, 0.29719705E-11_JPRB, &
  & 0.34993668E-11_JPRB, 0.41318151E-11_JPRB, 0.49019894E-11_JPRB, 0.58586174E-11_JPRB, 0.70819544E-11_JPRB, 0.86664616E-11_JPRB, &
  & 0.10724820E-10_JPRB, 0.13296653E-10_JPRB, 0.16309752E-10_JPRB, 0.19470835E-10_JPRB, 0.22347197E-10_JPRB, 0.24562101E-10_JPRB, &
  & 0.25812210E-10_JPRB, 0.26030256E-10_JPRB, 0.25177464E-10_JPRB, 0.23274943E-10_JPRB, 0.20581153E-10_JPRB, 0.17801845E-10_JPRB, &
  & 0.15063648E-10_JPRB, 0.12529946E-10_JPRB, 0.10587551E-10_JPRB, 0.78978117E-11_JPRB, 0.58746046E-11_JPRB, 0.34508763E-11_JPRB, &
  & 0.19859715E-11_JPRB, 0.11891251E-11_JPRB, 0.69679782E-12_JPRB, 0.39784015E-12_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART2',0,ZHOOK_HANDLE)



RGHG4(:,46, 1) = (/ &
  & 0.19693723E-09_JPRB, 0.17570903E-09_JPRB, 0.16254270E-09_JPRB, 0.15172706E-09_JPRB, 0.14121551E-09_JPRB, 0.12949698E-09_JPRB, &
  & 0.11670370E-09_JPRB, 0.10411789E-09_JPRB, 0.94841968E-10_JPRB, 0.88694205E-10_JPRB, 0.83801882E-10_JPRB, 0.79523998E-10_JPRB, &
  & 0.75031384E-10_JPRB, 0.69513902E-10_JPRB, 0.61710317E-10_JPRB, 0.50708413E-10_JPRB, 0.38073537E-10_JPRB, 0.27319060E-10_JPRB, &
  & 0.19692930E-10_JPRB, 0.14586728E-10_JPRB, 0.11233028E-10_JPRB, 0.87938927E-11_JPRB, 0.71643715E-11_JPRB, 0.58242144E-11_JPRB, &
  & 0.48864498E-11_JPRB, 0.40875736E-11_JPRB, 0.34498322E-11_JPRB, 0.29413648E-11_JPRB, 0.25401055E-11_JPRB, 0.22439624E-11_JPRB, &
  & 0.20658349E-11_JPRB, 0.19734637E-11_JPRB, 0.20025767E-11_JPRB, 0.21455030E-11_JPRB, 0.24281967E-11_JPRB, 0.28283580E-11_JPRB, &
  & 0.33258342E-11_JPRB, 0.39097488E-11_JPRB, 0.46074355E-11_JPRB, 0.54569461E-11_JPRB, 0.65225681E-11_JPRB, 0.78654175E-11_JPRB, &
  & 0.95523841E-11_JPRB, 0.11585525E-10_JPRB, 0.13944562E-10_JPRB, 0.16443210E-10_JPRB, 0.18791305E-10_JPRB, 0.20658466E-10_JPRB, &
  & 0.21750246E-10_JPRB, 0.21994878E-10_JPRB, 0.21331485E-10_JPRB, 0.19699279E-10_JPRB, 0.17621226E-10_JPRB, 0.15362447E-10_JPRB, &
  & 0.13159221E-10_JPRB, 0.11104155E-10_JPRB, 0.95854115E-11_JPRB, 0.74024424E-11_JPRB, 0.58710983E-11_JPRB, 0.36692680E-11_JPRB, &
  & 0.22407592E-11_JPRB, 0.14363865E-11_JPRB, 0.90257028E-12_JPRB, 0.54198182E-12_JPRB /)

RGHG4(:,47, 1) = (/ &
  & 0.15613857E-09_JPRB, 0.13812686E-09_JPRB, 0.12708221E-09_JPRB, 0.11821062E-09_JPRB, 0.10943327E-09_JPRB, 0.99691880E-10_JPRB, &
  & 0.89449184E-10_JPRB, 0.79461694E-10_JPRB, 0.72034330E-10_JPRB, 0.67325548E-10_JPRB, 0.63680679E-10_JPRB, 0.60445232E-10_JPRB, &
  & 0.57291651E-10_JPRB, 0.53138403E-10_JPRB, 0.47623166E-10_JPRB, 0.39424464E-10_JPRB, 0.30183838E-10_JPRB, 0.22256395E-10_JPRB, &
  & 0.16693438E-10_JPRB, 0.12822569E-10_JPRB, 0.10183261E-10_JPRB, 0.81143712E-11_JPRB, 0.66907035E-11_JPRB, 0.54451816E-11_JPRB, &
  & 0.45693922E-11_JPRB, 0.37936169E-11_JPRB, 0.31837484E-11_JPRB, 0.26977322E-11_JPRB, 0.23451375E-11_JPRB, 0.20634948E-11_JPRB, &
  & 0.19314051E-11_JPRB, 0.18547486E-11_JPRB, 0.18976908E-11_JPRB, 0.20426892E-11_JPRB, 0.23185050E-11_JPRB, 0.27032168E-11_JPRB, &
  & 0.31735834E-11_JPRB, 0.37168367E-11_JPRB, 0.43528991E-11_JPRB, 0.51096744E-11_JPRB, 0.60319575E-11_JPRB, 0.71554412E-11_JPRB, &
  & 0.85138788E-11_JPRB, 0.10086793E-10_JPRB, 0.11854846E-10_JPRB, 0.13711986E-10_JPRB, 0.15534034E-10_JPRB, 0.17026625E-10_JPRB, &
  & 0.17965391E-10_JPRB, 0.18232216E-10_JPRB, 0.17731419E-10_JPRB, 0.16479536E-10_JPRB, 0.14781523E-10_JPRB, 0.13083085E-10_JPRB, &
  & 0.11355464E-10_JPRB, 0.97266379E-11_JPRB, 0.87147520E-11_JPRB, 0.69490668E-11_JPRB, 0.58981804E-11_JPRB, 0.38767956E-11_JPRB, &
  & 0.25471637E-11_JPRB, 0.17274619E-11_JPRB, 0.11755212E-11_JPRB, 0.74745987E-12_JPRB /)

RGHG4(:,48, 1) = (/ &
  & 0.12050203E-09_JPRB, 0.10538916E-09_JPRB, 0.96534170E-10_JPRB, 0.89336955E-10_JPRB, 0.82351702E-10_JPRB, 0.74637768E-10_JPRB, &
  & 0.66690306E-10_JPRB, 0.59165166E-10_JPRB, 0.53310332E-10_JPRB, 0.49831281E-10_JPRB, 0.47128350E-10_JPRB, 0.44845468E-10_JPRB, &
  & 0.42552621E-10_JPRB, 0.39757204E-10_JPRB, 0.35739668E-10_JPRB, 0.30239498E-10_JPRB, 0.23807052E-10_JPRB, 0.18399214E-10_JPRB, &
  & 0.14442729E-10_JPRB, 0.11488034E-10_JPRB, 0.93448973E-11_JPRB, 0.75968919E-11_JPRB, 0.62715805E-11_JPRB, 0.51406730E-11_JPRB, &
  & 0.42795546E-11_JPRB, 0.35228868E-11_JPRB, 0.29377223E-11_JPRB, 0.24678217E-11_JPRB, 0.21656121E-11_JPRB, 0.19126237E-11_JPRB, &
  & 0.18044943E-11_JPRB, 0.17567332E-11_JPRB, 0.18084875E-11_JPRB, 0.19601098E-11_JPRB, 0.22323239E-11_JPRB, 0.26061685E-11_JPRB, &
  & 0.30564024E-11_JPRB, 0.35665709E-11_JPRB, 0.41513793E-11_JPRB, 0.48277697E-11_JPRB, 0.56285423E-11_JPRB, 0.65624810E-11_JPRB, &
  & 0.76322889E-11_JPRB, 0.87944053E-11_JPRB, 0.10021678E-10_JPRB, 0.11295356E-10_JPRB, 0.12545073E-10_JPRB, 0.13667794E-10_JPRB, &
  & 0.14392531E-10_JPRB, 0.14662485E-10_JPRB, 0.14353434E-10_JPRB, 0.13411812E-10_JPRB, 0.12207066E-10_JPRB, 0.10915781E-10_JPRB, &
  & 0.96757350E-11_JPRB, 0.84648608E-11_JPRB, 0.78892370E-11_JPRB, 0.65116480E-11_JPRB, 0.58495361E-11_JPRB, 0.40645564E-11_JPRB, &
  & 0.28265610E-11_JPRB, 0.20395176E-11_JPRB, 0.14830584E-11_JPRB, 0.10163014E-11_JPRB /)

RGHG4(:,49, 1) = (/ &
  & 0.90184644E-10_JPRB, 0.78279536E-10_JPRB, 0.71348420E-10_JPRB, 0.65886449E-10_JPRB, 0.60347789E-10_JPRB, 0.54232705E-10_JPRB, &
  & 0.48096915E-10_JPRB, 0.42385696E-10_JPRB, 0.37702685E-10_JPRB, 0.35131731E-10_JPRB, 0.33215351E-10_JPRB, 0.31605440E-10_JPRB, &
  & 0.30149834E-10_JPRB, 0.28393359E-10_JPRB, 0.26066599E-10_JPRB, 0.22770140E-10_JPRB, 0.18833022E-10_JPRB, 0.15277885E-10_JPRB, &
  & 0.12568114E-10_JPRB, 0.10390508E-10_JPRB, 0.86302614E-11_JPRB, 0.71529232E-11_JPRB, 0.58955414E-11_JPRB, 0.48577054E-11_JPRB, &
  & 0.39966650E-11_JPRB, 0.32708402E-11_JPRB, 0.27088425E-11_JPRB, 0.22660394E-11_JPRB, 0.19979530E-11_JPRB, 0.17940800E-11_JPRB, &
  & 0.16956131E-11_JPRB, 0.16753422E-11_JPRB, 0.17356329E-11_JPRB, 0.18940940E-11_JPRB, 0.21631124E-11_JPRB, 0.25281435E-11_JPRB, &
  & 0.29604416E-11_JPRB, 0.34423057E-11_JPRB, 0.39811405E-11_JPRB, 0.45892751E-11_JPRB, 0.52825964E-11_JPRB, 0.60510993E-11_JPRB, &
  & 0.68728621E-11_JPRB, 0.76813217E-11_JPRB, 0.84413318E-11_JPRB, 0.91392649E-11_JPRB, 0.98260063E-11_JPRB, 0.10461750E-10_JPRB, &
  & 0.10941811E-10_JPRB, 0.11162592E-10_JPRB, 0.10991982E-10_JPRB, 0.10381403E-10_JPRB, 0.95564476E-11_JPRB, 0.87235991E-11_JPRB, &
  & 0.79171071E-11_JPRB, 0.71236957E-11_JPRB, 0.69551517E-11_JPRB, 0.59249524E-11_JPRB, 0.56816067E-11_JPRB, 0.41430084E-11_JPRB, &
  & 0.30317619E-11_JPRB, 0.23338835E-11_JPRB, 0.17941765E-11_JPRB, 0.13258644E-11_JPRB /)

RGHG4(:,50, 1) = (/ &
  & 0.66576848E-10_JPRB, 0.57363198E-10_JPRB, 0.52192473E-10_JPRB, 0.47825473E-10_JPRB, 0.43379311E-10_JPRB, 0.38260704E-10_JPRB, &
  & 0.33343481E-10_JPRB, 0.29081910E-10_JPRB, 0.25292898E-10_JPRB, 0.23539264E-10_JPRB, 0.22309836E-10_JPRB, 0.21332542E-10_JPRB, &
  & 0.20574582E-10_JPRB, 0.19670647E-10_JPRB, 0.18653131E-10_JPRB, 0.17061300E-10_JPRB, 0.15051122E-10_JPRB, 0.12943149E-10_JPRB, &
  & 0.11112994E-10_JPRB, 0.95116259E-11_JPRB, 0.80393713E-11_JPRB, 0.67667308E-11_JPRB, 0.55725394E-11_JPRB, 0.45957261E-11_JPRB, &
  & 0.37436621E-11_JPRB, 0.30403742E-11_JPRB, 0.25135007E-11_JPRB, 0.21068787E-11_JPRB, 0.18604812E-11_JPRB, 0.17019837E-11_JPRB, &
  & 0.16202764E-11_JPRB, 0.16164147E-11_JPRB, 0.16846377E-11_JPRB, 0.18512490E-11_JPRB, 0.21148751E-11_JPRB, 0.24725868E-11_JPRB, &
  & 0.28885841E-11_JPRB, 0.33437183E-11_JPRB, 0.38433159E-11_JPRB, 0.43924599E-11_JPRB, 0.49943725E-11_JPRB, 0.56214690E-11_JPRB, &
  & 0.62295481E-11_JPRB, 0.67380077E-11_JPRB, 0.71028040E-11_JPRB, 0.73197151E-11_JPRB, 0.74905906E-11_JPRB, 0.76529390E-11_JPRB, &
  & 0.78065800E-11_JPRB, 0.78874528E-11_JPRB, 0.77930084E-11_JPRB, 0.74567149E-11_JPRB, 0.69794825E-11_JPRB, 0.65158933E-11_JPRB, &
  & 0.60531107E-11_JPRB, 0.56099010E-11_JPRB, 0.58181632E-11_JPRB, 0.51105799E-11_JPRB, 0.52544800E-11_JPRB, 0.40356277E-11_JPRB, &
  & 0.31075862E-11_JPRB, 0.25311131E-11_JPRB, 0.20358162E-11_JPRB, 0.16191889E-11_JPRB /)

RGHG4(:,51, 1) = (/ &
  & 0.48044398E-10_JPRB, 0.41099450E-10_JPRB, 0.37006887E-10_JPRB, 0.33646218E-10_JPRB, 0.29790278E-10_JPRB, 0.25541864E-10_JPRB, &
  & 0.21609624E-10_JPRB, 0.18763404E-10_JPRB, 0.15973807E-10_JPRB, 0.15007627E-10_JPRB, 0.14415281E-10_JPRB, 0.14009569E-10_JPRB, &
  & 0.13754099E-10_JPRB, 0.13588393E-10_JPRB, 0.13357045E-10_JPRB, 0.12990571E-10_JPRB, 0.12169530E-10_JPRB, 0.11098830E-10_JPRB, &
  & 0.99340822E-11_JPRB, 0.87817505E-11_JPRB, 0.75622460E-11_JPRB, 0.64110154E-11_JPRB, 0.53202893E-11_JPRB, 0.43602799E-11_JPRB, &
  & 0.35284039E-11_JPRB, 0.28517594E-11_JPRB, 0.23579834E-11_JPRB, 0.19976872E-11_JPRB, 0.17717324E-11_JPRB, 0.16410829E-11_JPRB, &
  & 0.15752450E-11_JPRB, 0.15906363E-11_JPRB, 0.16564653E-11_JPRB, 0.18352403E-11_JPRB, 0.20937536E-11_JPRB, 0.24460464E-11_JPRB, &
  & 0.28424062E-11_JPRB, 0.32748561E-11_JPRB, 0.37388361E-11_JPRB, 0.42380908E-11_JPRB, 0.47609789E-11_JPRB, 0.52662367E-11_JPRB, &
  & 0.56901814E-11_JPRB, 0.59527986E-11_JPRB, 0.59992371E-11_JPRB, 0.58694364E-11_JPRB, 0.56544253E-11_JPRB, 0.54735357E-11_JPRB, &
  & 0.53239431E-11_JPRB, 0.52134104E-11_JPRB, 0.50599447E-11_JPRB, 0.48336270E-11_JPRB, 0.45862580E-11_JPRB, 0.43566821E-11_JPRB, &
  & 0.41806255E-11_JPRB, 0.40036815E-11_JPRB, 0.44723942E-11_JPRB, 0.40765056E-11_JPRB, 0.45601791E-11_JPRB, 0.36990775E-11_JPRB, &
  & 0.29717437E-11_JPRB, 0.25565628E-11_JPRB, 0.21421244E-11_JPRB, 0.18290701E-11_JPRB /)

RGHG4(:,52, 1) = (/ &
  & 0.34286608E-10_JPRB, 0.28898751E-10_JPRB, 0.25955814E-10_JPRB, 0.23016873E-10_JPRB, 0.19924316E-10_JPRB, 0.16428340E-10_JPRB, &
  & 0.13839969E-10_JPRB, 0.12266506E-10_JPRB, 0.10344821E-10_JPRB, 0.99313977E-11_JPRB, 0.97418323E-11_JPRB, 0.96374011E-11_JPRB, &
  & 0.96600766E-11_JPRB, 0.97657004E-11_JPRB, 0.99450509E-11_JPRB, 0.10142891E-10_JPRB, 0.10088190E-10_JPRB, 0.96807232E-11_JPRB, &
  & 0.89876769E-11_JPRB, 0.81572769E-11_JPRB, 0.71598873E-11_JPRB, 0.61105530E-11_JPRB, 0.50934756E-11_JPRB, 0.41616792E-11_JPRB, &
  & 0.33636531E-11_JPRB, 0.27171494E-11_JPRB, 0.22581084E-11_JPRB, 0.19386370E-11_JPRB, 0.17373604E-11_JPRB, 0.16272447E-11_JPRB, &
  & 0.15693761E-11_JPRB, 0.16005061E-11_JPRB, 0.16706800E-11_JPRB, 0.18504668E-11_JPRB, 0.21045806E-11_JPRB, 0.24465564E-11_JPRB, &
  & 0.28277218E-11_JPRB, 0.32366397E-11_JPRB, 0.36664192E-11_JPRB, 0.41214172E-11_JPRB, 0.45742941E-11_JPRB, 0.49694589E-11_JPRB, &
  & 0.52333736E-11_JPRB, 0.52915025E-11_JPRB, 0.51130072E-11_JPRB, 0.47610227E-11_JPRB, 0.43660752E-11_JPRB, 0.40087746E-11_JPRB, &
  & 0.37191838E-11_JPRB, 0.34788312E-11_JPRB, 0.32714636E-11_JPRB, 0.30849136E-11_JPRB, 0.29224039E-11_JPRB, 0.28268360E-11_JPRB, &
  & 0.27464623E-11_JPRB, 0.26893013E-11_JPRB, 0.32950660E-11_JPRB, 0.30927908E-11_JPRB, 0.37942110E-11_JPRB, 0.31923355E-11_JPRB, &
  & 0.26876277E-11_JPRB, 0.24341321E-11_JPRB, 0.20995358E-11_JPRB, 0.19124457E-11_JPRB /)

RGHG4(:,53, 1) = (/ &
  & 0.24184708E-10_JPRB, 0.20160595E-10_JPRB, 0.17635291E-10_JPRB, 0.15543532E-10_JPRB, 0.13021555E-10_JPRB, 0.10854955E-10_JPRB, &
  & 0.94195103E-11_JPRB, 0.87459580E-11_JPRB, 0.73872904E-11_JPRB, 0.72455032E-11_JPRB, 0.72126866E-11_JPRB, 0.72332058E-11_JPRB, &
  & 0.73439085E-11_JPRB, 0.75214349E-11_JPRB, 0.78573398E-11_JPRB, 0.82140917E-11_JPRB, 0.85534262E-11_JPRB, 0.85784704E-11_JPRB, &
  & 0.82528125E-11_JPRB, 0.76639901E-11_JPRB, 0.68254833E-11_JPRB, 0.58832483E-11_JPRB, 0.49282852E-11_JPRB, 0.40381721E-11_JPRB, &
  & 0.32776741E-11_JPRB, 0.26451059E-11_JPRB, 0.22171277E-11_JPRB, 0.19337869E-11_JPRB, 0.17562363E-11_JPRB, 0.16622158E-11_JPRB, &
  & 0.16131353E-11_JPRB, 0.16400035E-11_JPRB, 0.17297992E-11_JPRB, 0.19018404E-11_JPRB, 0.21667436E-11_JPRB, 0.24933840E-11_JPRB, &
  & 0.28595435E-11_JPRB, 0.32416886E-11_JPRB, 0.36407531E-11_JPRB, 0.40579263E-11_JPRB, 0.44496169E-11_JPRB, 0.47443655E-11_JPRB, &
  & 0.48687976E-11_JPRB, 0.47686824E-11_JPRB, 0.44441347E-11_JPRB, 0.39913394E-11_JPRB, 0.35358242E-11_JPRB, 0.31467374E-11_JPRB, &
  & 0.28294192E-11_JPRB, 0.25711913E-11_JPRB, 0.23570648E-11_JPRB, 0.21846195E-11_JPRB, 0.20697801E-11_JPRB, 0.19980408E-11_JPRB, &
  & 0.19682838E-11_JPRB, 0.19659077E-11_JPRB, 0.25751797E-11_JPRB, 0.24845265E-11_JPRB, 0.32043036E-11_JPRB, 0.27887525E-11_JPRB, &
  & 0.24719398E-11_JPRB, 0.22700292E-11_JPRB, 0.20141621E-11_JPRB, 0.19176199E-11_JPRB /)

RGHG4(:,54, 1) = (/ &
  & 0.17032362E-10_JPRB, 0.13860474E-10_JPRB, 0.12207476E-10_JPRB, 0.10507641E-10_JPRB, 0.90230861E-11_JPRB, 0.77651609E-11_JPRB, &
  & 0.71648746E-11_JPRB, 0.69095701E-11_JPRB, 0.58315991E-11_JPRB, 0.57999820E-11_JPRB, 0.58119403E-11_JPRB, 0.58684980E-11_JPRB, &
  & 0.59619089E-11_JPRB, 0.61687795E-11_JPRB, 0.64482881E-11_JPRB, 0.69392751E-11_JPRB, 0.74094923E-11_JPRB, 0.77192393E-11_JPRB, &
  & 0.76633630E-11_JPRB, 0.72606539E-11_JPRB, 0.65577504E-11_JPRB, 0.57029646E-11_JPRB, 0.48098760E-11_JPRB, 0.39700274E-11_JPRB, &
  & 0.32449985E-11_JPRB, 0.26553709E-11_JPRB, 0.22591438E-11_JPRB, 0.20035343E-11_JPRB, 0.18467363E-11_JPRB, 0.17642754E-11_JPRB, &
  & 0.17264396E-11_JPRB, 0.17462972E-11_JPRB, 0.18461205E-11_JPRB, 0.20146599E-11_JPRB, 0.22770410E-11_JPRB, 0.25954260E-11_JPRB, &
  & 0.29517382E-11_JPRB, 0.33071154E-11_JPRB, 0.36779685E-11_JPRB, 0.40599577E-11_JPRB, 0.43942211E-11_JPRB, 0.45906356E-11_JPRB, &
  & 0.45875968E-11_JPRB, 0.43640894E-11_JPRB, 0.39484943E-11_JPRB, 0.34635220E-11_JPRB, 0.30117289E-11_JPRB, 0.26433111E-11_JPRB, &
  & 0.23476874E-11_JPRB, 0.21060842E-11_JPRB, 0.19149422E-11_JPRB, 0.17766243E-11_JPRB, 0.16829607E-11_JPRB, 0.16464923E-11_JPRB, &
  & 0.16340402E-11_JPRB, 0.16480068E-11_JPRB, 0.22272551E-11_JPRB, 0.21710173E-11_JPRB, 0.29108922E-11_JPRB, 0.25990009E-11_JPRB, &
  & 0.23500642E-11_JPRB, 0.21692485E-11_JPRB, 0.19978871E-11_JPRB, 0.19245042E-11_JPRB /)

RGHG4(:,55, 1) = (/ &
  & 0.12221521E-10_JPRB, 0.98441030E-11_JPRB, 0.85204959E-11_JPRB, 0.75531959E-11_JPRB, 0.66735905E-11_JPRB, 0.61069565E-11_JPRB, &
  & 0.59173833E-11_JPRB, 0.58603261E-11_JPRB, 0.49521797E-11_JPRB, 0.49679631E-11_JPRB, 0.49939441E-11_JPRB, 0.50532347E-11_JPRB, &
  & 0.51491953E-11_JPRB, 0.53024985E-11_JPRB, 0.55993847E-11_JPRB, 0.59883843E-11_JPRB, 0.65855264E-11_JPRB, 0.70593596E-11_JPRB, &
  & 0.72021230E-11_JPRB, 0.69657244E-11_JPRB, 0.63650912E-11_JPRB, 0.55777180E-11_JPRB, 0.47427674E-11_JPRB, 0.39481057E-11_JPRB, &
  & 0.32593936E-11_JPRB, 0.27007244E-11_JPRB, 0.23299745E-11_JPRB, 0.20993912E-11_JPRB, 0.19620798E-11_JPRB, 0.18922520E-11_JPRB, &
  & 0.18686172E-11_JPRB, 0.18957752E-11_JPRB, 0.20024141E-11_JPRB, 0.21863542E-11_JPRB, 0.24562882E-11_JPRB, 0.27700917E-11_JPRB, &
  & 0.31151078E-11_JPRB, 0.34450450E-11_JPRB, 0.37950801E-11_JPRB, 0.41456881E-11_JPRB, 0.44284108E-11_JPRB, 0.45298201E-11_JPRB, &
  & 0.44156501E-11_JPRB, 0.40970556E-11_JPRB, 0.36332528E-11_JPRB, 0.31430078E-11_JPRB, 0.27187172E-11_JPRB, 0.23780348E-11_JPRB, &
  & 0.21073093E-11_JPRB, 0.18923322E-11_JPRB, 0.17233937E-11_JPRB, 0.16020150E-11_JPRB, 0.15319264E-11_JPRB, 0.15011782E-11_JPRB, &
  & 0.14976949E-11_JPRB, 0.15200684E-11_JPRB, 0.20640592E-11_JPRB, 0.20537181E-11_JPRB, 0.27789682E-11_JPRB, 0.25242547E-11_JPRB, &
  & 0.23175919E-11_JPRB, 0.21580934E-11_JPRB, 0.20334292E-11_JPRB, 0.19346887E-11_JPRB /)

RGHG4(:,56, 1) = (/ &
  & 0.89317477E-11_JPRB, 0.72189125E-11_JPRB, 0.63881118E-11_JPRB, 0.58002357E-11_JPRB, 0.53794061E-11_JPRB, 0.51802282E-11_JPRB, &
  & 0.51823463E-11_JPRB, 0.52243318E-11_JPRB, 0.44211496E-11_JPRB, 0.44529948E-11_JPRB, 0.44801645E-11_JPRB, 0.45274756E-11_JPRB, &
  & 0.45929272E-11_JPRB, 0.47463851E-11_JPRB, 0.49612901E-11_JPRB, 0.53845327E-11_JPRB, 0.59392239E-11_JPRB, 0.65535737E-11_JPRB, &
  & 0.68481609E-11_JPRB, 0.67113298E-11_JPRB, 0.61924897E-11_JPRB, 0.54859277E-11_JPRB, 0.47077988E-11_JPRB, 0.39635469E-11_JPRB, &
  & 0.33125737E-11_JPRB, 0.27895542E-11_JPRB, 0.24464979E-11_JPRB, 0.22374904E-11_JPRB, 0.21189231E-11_JPRB, 0.20611728E-11_JPRB, &
  & 0.20485211E-11_JPRB, 0.20874715E-11_JPRB, 0.22020766E-11_JPRB, 0.24056239E-11_JPRB, 0.26817580E-11_JPRB, 0.30137470E-11_JPRB, &
  & 0.33623915E-11_JPRB, 0.36765244E-11_JPRB, 0.40069766E-11_JPRB, 0.43328991E-11_JPRB, 0.45682577E-11_JPRB, 0.45835488E-11_JPRB, &
  & 0.43644073E-11_JPRB, 0.39661026E-11_JPRB, 0.34622927E-11_JPRB, 0.29771470E-11_JPRB, 0.25702084E-11_JPRB, 0.22535287E-11_JPRB, &
  & 0.20051706E-11_JPRB, 0.18070959E-11_JPRB, 0.16540501E-11_JPRB, 0.15529156E-11_JPRB, 0.14914112E-11_JPRB, 0.14745496E-11_JPRB, &
  & 0.14805344E-11_JPRB, 0.15125813E-11_JPRB, 0.20354655E-11_JPRB, 0.20233067E-11_JPRB, 0.27485199E-11_JPRB, 0.25353062E-11_JPRB, &
  & 0.23490118E-11_JPRB, 0.22051475E-11_JPRB, 0.20991516E-11_JPRB, 0.19715262E-11_JPRB /)

RGHG4(:,57, 1) = (/ &
  & 0.69451857E-11_JPRB, 0.56084395E-11_JPRB, 0.51216201E-11_JPRB, 0.47887848E-11_JPRB, 0.46296990E-11_JPRB, 0.46043894E-11_JPRB, &
  & 0.47011809E-11_JPRB, 0.47703356E-11_JPRB, 0.40623811E-11_JPRB, 0.41000575E-11_JPRB, 0.41333196E-11_JPRB, 0.41765970E-11_JPRB, &
  & 0.42453185E-11_JPRB, 0.43545302E-11_JPRB, 0.45761424E-11_JPRB, 0.49124134E-11_JPRB, 0.55091322E-11_JPRB, 0.61620886E-11_JPRB, &
  & 0.65489333E-11_JPRB, 0.65028855E-11_JPRB, 0.60645889E-11_JPRB, 0.54169729E-11_JPRB, 0.46970045E-11_JPRB, 0.39998469E-11_JPRB, &
  & 0.33878111E-11_JPRB, 0.29051535E-11_JPRB, 0.25912363E-11_JPRB, 0.24054476E-11_JPRB, 0.23045424E-11_JPRB, 0.22596163E-11_JPRB, &
  & 0.22569121E-11_JPRB, 0.23079477E-11_JPRB, 0.24345367E-11_JPRB, 0.26563428E-11_JPRB, 0.29459794E-11_JPRB, 0.32898597E-11_JPRB, &
  & 0.36469946E-11_JPRB, 0.39821471E-11_JPRB, 0.43181981E-11_JPRB, 0.46302137E-11_JPRB, 0.48274774E-11_JPRB, 0.47591371E-11_JPRB, &
  & 0.44564179E-11_JPRB, 0.39879870E-11_JPRB, 0.34498285E-11_JPRB, 0.29592548E-11_JPRB, 0.25679790E-11_JPRB, 0.22571120E-11_JPRB, &
  & 0.20196778E-11_JPRB, 0.18307361E-11_JPRB, 0.16887707E-11_JPRB, 0.15937540E-11_JPRB, 0.15416665E-11_JPRB, 0.15282049E-11_JPRB, &
  & 0.15355276E-11_JPRB, 0.15700359E-11_JPRB, 0.20523251E-11_JPRB, 0.20589006E-11_JPRB, 0.28037663E-11_JPRB, 0.26136656E-11_JPRB, &
  & 0.24294707E-11_JPRB, 0.22958543E-11_JPRB, 0.21888600E-11_JPRB, 0.20419695E-11_JPRB /)

RGHG4(:,58, 1) = (/ &
  & 0.55297221E-11_JPRB, 0.47114920E-11_JPRB, 0.43782799E-11_JPRB, 0.42296461E-11_JPRB, 0.41890380E-11_JPRB, 0.42615833E-11_JPRB, &
  & 0.43809080E-11_JPRB, 0.44744690E-11_JPRB, 0.38471023E-11_JPRB, 0.38898880E-11_JPRB, 0.39154665E-11_JPRB, 0.39523432E-11_JPRB, &
  & 0.40029416E-11_JPRB, 0.41168358E-11_JPRB, 0.42900549E-11_JPRB, 0.46439597E-11_JPRB, 0.51727303E-11_JPRB, 0.58710259E-11_JPRB, &
  & 0.63168793E-11_JPRB, 0.63176396E-11_JPRB, 0.59389303E-11_JPRB, 0.53719099E-11_JPRB, 0.47044079E-11_JPRB, 0.40572142E-11_JPRB, &
  & 0.34909896E-11_JPRB, 0.30516015E-11_JPRB, 0.27713676E-11_JPRB, 0.26090484E-11_JPRB, 0.25268552E-11_JPRB, 0.24952373E-11_JPRB, &
  & 0.25021617E-11_JPRB, 0.25636633E-11_JPRB, 0.27028915E-11_JPRB, 0.29346239E-11_JPRB, 0.32464706E-11_JPRB, 0.36076504E-11_JPRB, &
  & 0.39804570E-11_JPRB, 0.43227952E-11_JPRB, 0.46620130E-11_JPRB, 0.49609943E-11_JPRB, 0.51341926E-11_JPRB, 0.50587009E-11_JPRB, &
  & 0.46939735E-11_JPRB, 0.41723534E-11_JPRB, 0.35959118E-11_JPRB, 0.30938700E-11_JPRB, 0.26902137E-11_JPRB, 0.23779691E-11_JPRB, &
  & 0.21373237E-11_JPRB, 0.19465334E-11_JPRB, 0.18049692E-11_JPRB, 0.17132864E-11_JPRB, 0.16611934E-11_JPRB, 0.16494747E-11_JPRB, &
  & 0.16598345E-11_JPRB, 0.16973805E-11_JPRB, 0.21622799E-11_JPRB, 0.21725148E-11_JPRB, 0.29314929E-11_JPRB, 0.27326288E-11_JPRB, &
  & 0.25611158E-11_JPRB, 0.24272652E-11_JPRB, 0.23125328E-11_JPRB, 0.21498417E-11_JPRB /)

RGHG4(:,59, 1) = (/ &
  & 0.47063920E-11_JPRB, 0.40955624E-11_JPRB, 0.39745217E-11_JPRB, 0.38958871E-11_JPRB, 0.39219808E-11_JPRB, 0.40228537E-11_JPRB, &
  & 0.41551779E-11_JPRB, 0.42480589E-11_JPRB, 0.36994969E-11_JPRB, 0.37456574E-11_JPRB, 0.37822332E-11_JPRB, 0.38213916E-11_JPRB, &
  & 0.38801917E-11_JPRB, 0.39728390E-11_JPRB, 0.41583386E-11_JPRB, 0.44546524E-11_JPRB, 0.50103480E-11_JPRB, 0.56691505E-11_JPRB, &
  & 0.61193537E-11_JPRB, 0.61562487E-11_JPRB, 0.58496636E-11_JPRB, 0.53374870E-11_JPRB, 0.47278318E-11_JPRB, 0.41308007E-11_JPRB, &
  & 0.36136133E-11_JPRB, 0.32221775E-11_JPRB, 0.29791924E-11_JPRB, 0.28435817E-11_JPRB, 0.27813589E-11_JPRB, 0.27648975E-11_JPRB, &
  & 0.27805846E-11_JPRB, 0.28495090E-11_JPRB, 0.29983524E-11_JPRB, 0.32430315E-11_JPRB, 0.35697190E-11_JPRB, 0.39450279E-11_JPRB, &
  & 0.43365988E-11_JPRB, 0.47046906E-11_JPRB, 0.50531081E-11_JPRB, 0.53475102E-11_JPRB, 0.55056797E-11_JPRB, 0.54150139E-11_JPRB, &
  & 0.50670982E-11_JPRB, 0.45234975E-11_JPRB, 0.39215723E-11_JPRB, 0.33983948E-11_JPRB, 0.29829735E-11_JPRB, 0.26420181E-11_JPRB, &
  & 0.23877371E-11_JPRB, 0.21814473E-11_JPRB, 0.20253003E-11_JPRB, 0.19249168E-11_JPRB, 0.18665254E-11_JPRB, 0.18534952E-11_JPRB, &
  & 0.18586955E-11_JPRB, 0.18962605E-11_JPRB, 0.23229914E-11_JPRB, 0.23315826E-11_JPRB, 0.31153968E-11_JPRB, 0.29318009E-11_JPRB, &
  & 0.27470081E-11_JPRB, 0.25992021E-11_JPRB, 0.24719525E-11_JPRB, 0.22931240E-11_JPRB /)

RGHG4(:,60, 1) = (/ &
  & 0.40274685E-11_JPRB, 0.38066976E-11_JPRB, 0.37569869E-11_JPRB, 0.37442332E-11_JPRB, 0.37957007E-11_JPRB, 0.39074473E-11_JPRB, &
  & 0.40373664E-11_JPRB, 0.41408157E-11_JPRB, 0.36683365E-11_JPRB, 0.37132337E-11_JPRB, 0.37455030E-11_JPRB, 0.37836852E-11_JPRB, &
  & 0.38386586E-11_JPRB, 0.39332691E-11_JPRB, 0.40987734E-11_JPRB, 0.44158119E-11_JPRB, 0.49200830E-11_JPRB, 0.55405949E-11_JPRB, &
  & 0.59657474E-11_JPRB, 0.60298537E-11_JPRB, 0.57759778E-11_JPRB, 0.53200964E-11_JPRB, 0.47699479E-11_JPRB, 0.42289228E-11_JPRB, &
  & 0.37684036E-11_JPRB, 0.34311106E-11_JPRB, 0.32303938E-11_JPRB, 0.31251514E-11_JPRB, 0.30855830E-11_JPRB, 0.30840361E-11_JPRB, &
  & 0.31067880E-11_JPRB, 0.31796276E-11_JPRB, 0.33313278E-11_JPRB, 0.35836019E-11_JPRB, 0.39193319E-11_JPRB, 0.43121071E-11_JPRB, &
  & 0.47245892E-11_JPRB, 0.51100326E-11_JPRB, 0.54714384E-11_JPRB, 0.57653066E-11_JPRB, 0.59194208E-11_JPRB, 0.58463529E-11_JPRB, &
  & 0.55129751E-11_JPRB, 0.50182094E-11_JPRB, 0.44303693E-11_JPRB, 0.39045087E-11_JPRB, 0.34569142E-11_JPRB, 0.30833591E-11_JPRB, &
  & 0.27798172E-11_JPRB, 0.25564188E-11_JPRB, 0.23642906E-11_JPRB, 0.22524138E-11_JPRB, 0.21776951E-11_JPRB, 0.21549342E-11_JPRB, &
  & 0.21509014E-11_JPRB, 0.21820805E-11_JPRB, 0.25841482E-11_JPRB, 0.25884499E-11_JPRB, 0.34144679E-11_JPRB, 0.31882251E-11_JPRB, &
  & 0.29817088E-11_JPRB, 0.28178618E-11_JPRB, 0.26725846E-11_JPRB, 0.24651837E-11_JPRB /)

RGHG4(:,61, 1) = (/ &
  & 0.37344164E-11_JPRB, 0.36938261E-11_JPRB, 0.37086913E-11_JPRB, 0.37076505E-11_JPRB, 0.37574640E-11_JPRB, 0.38628089E-11_JPRB, &
  & 0.39918849E-11_JPRB, 0.40932860E-11_JPRB, 0.36837378E-11_JPRB, 0.37381218E-11_JPRB, 0.37809504E-11_JPRB, 0.38268165E-11_JPRB, &
  & 0.38878987E-11_JPRB, 0.39818058E-11_JPRB, 0.41520563E-11_JPRB, 0.44409984E-11_JPRB, 0.49174380E-11_JPRB, 0.54670673E-11_JPRB, &
  & 0.58527410E-11_JPRB, 0.59320942E-11_JPRB, 0.57236824E-11_JPRB, 0.53245221E-11_JPRB, 0.48344644E-11_JPRB, 0.43565329E-11_JPRB, &
  & 0.39607081E-11_JPRB, 0.36828401E-11_JPRB, 0.35309427E-11_JPRB, 0.34613545E-11_JPRB, 0.34475595E-11_JPRB, 0.34604025E-11_JPRB, &
  & 0.34889867E-11_JPRB, 0.35613808E-11_JPRB, 0.37099000E-11_JPRB, 0.39589790E-11_JPRB, 0.42980537E-11_JPRB, 0.47023223E-11_JPRB, &
  & 0.51310301E-11_JPRB, 0.55412415E-11_JPRB, 0.59176635E-11_JPRB, 0.62192881E-11_JPRB, 0.63810771E-11_JPRB, 0.63313122E-11_JPRB, &
  & 0.60480969E-11_JPRB, 0.56133804E-11_JPRB, 0.51015542E-11_JPRB, 0.46177185E-11_JPRB, 0.41722311E-11_JPRB, 0.37580911E-11_JPRB, &
  & 0.33988042E-11_JPRB, 0.31123296E-11_JPRB, 0.28965758E-11_JPRB, 0.27179767E-11_JPRB, 0.26332790E-11_JPRB, 0.25759293E-11_JPRB, &
  & 0.25654184E-11_JPRB, 0.25841690E-11_JPRB, 0.29441707E-11_JPRB, 0.29286417E-11_JPRB, 0.37804070E-11_JPRB, 0.35244134E-11_JPRB, &
  & 0.32800082E-11_JPRB, 0.30833482E-11_JPRB, 0.29112550E-11_JPRB, 0.26664192E-11_JPRB /)

RGHG4(:,62, 1) = (/ &
  & 0.38323507E-11_JPRB, 0.37720109E-11_JPRB, 0.37757124E-11_JPRB, 0.37827809E-11_JPRB, 0.38316017E-11_JPRB, 0.39303109E-11_JPRB, &
  & 0.40614487E-11_JPRB, 0.41750722E-11_JPRB, 0.38103683E-11_JPRB, 0.38611540E-11_JPRB, 0.39013666E-11_JPRB, 0.39468793E-11_JPRB, &
  & 0.40042141E-11_JPRB, 0.41010294E-11_JPRB, 0.42589855E-11_JPRB, 0.45402410E-11_JPRB, 0.49688179E-11_JPRB, 0.54471228E-11_JPRB, &
  & 0.57905404E-11_JPRB, 0.58778780E-11_JPRB, 0.57074098E-11_JPRB, 0.53617748E-11_JPRB, 0.49350793E-11_JPRB, 0.45275485E-11_JPRB, &
  & 0.42048721E-11_JPRB, 0.39964833E-11_JPRB, 0.39002586E-11_JPRB, 0.38730217E-11_JPRB, 0.38879039E-11_JPRB, 0.39163490E-11_JPRB, &
  & 0.39494514E-11_JPRB, 0.40168663E-11_JPRB, 0.41518382E-11_JPRB, 0.43877419E-11_JPRB, 0.47247106E-11_JPRB, 0.51336413E-11_JPRB, &
  & 0.55767778E-11_JPRB, 0.60061127E-11_JPRB, 0.64003078E-11_JPRB, 0.67168649E-11_JPRB, 0.68983851E-11_JPRB, 0.68920594E-11_JPRB, &
  & 0.66706588E-11_JPRB, 0.63287257E-11_JPRB, 0.59156048E-11_JPRB, 0.55295980E-11_JPRB, 0.51208126E-11_JPRB, 0.46891922E-11_JPRB, &
  & 0.42843181E-11_JPRB, 0.39119285E-11_JPRB, 0.36265656E-11_JPRB, 0.34068592E-11_JPRB, 0.32681999E-11_JPRB, 0.31906808E-11_JPRB, &
  & 0.31472171E-11_JPRB, 0.31322627E-11_JPRB, 0.34487975E-11_JPRB, 0.33982402E-11_JPRB, 0.42841789E-11_JPRB, 0.39372052E-11_JPRB, &
  & 0.36243693E-11_JPRB, 0.33817341E-11_JPRB, 0.31759215E-11_JPRB, 0.28828413E-11_JPRB /)

RGHG4(:,63, 1) = (/ &
  & 0.39025289E-11_JPRB, 0.39090554E-11_JPRB, 0.39444134E-11_JPRB, 0.39456667E-11_JPRB, 0.39891562E-11_JPRB, 0.40814058E-11_JPRB, &
  & 0.42095862E-11_JPRB, 0.43251570E-11_JPRB, 0.39946223E-11_JPRB, 0.40422149E-11_JPRB, 0.40861273E-11_JPRB, 0.41326322E-11_JPRB, &
  & 0.41926679E-11_JPRB, 0.42824667E-11_JPRB, 0.44334445E-11_JPRB, 0.46853081E-11_JPRB, 0.50537170E-11_JPRB, 0.54592238E-11_JPRB, &
  & 0.57626772E-11_JPRB, 0.58577670E-11_JPRB, 0.57285465E-11_JPRB, 0.54410452E-11_JPRB, 0.50862561E-11_JPRB, 0.47595053E-11_JPRB, &
  & 0.45205493E-11_JPRB, 0.43877883E-11_JPRB, 0.43548359E-11_JPRB, 0.43764189E-11_JPRB, 0.44236355E-11_JPRB, 0.44697271E-11_JPRB, &
  & 0.45079825E-11_JPRB, 0.45666548E-11_JPRB, 0.46818916E-11_JPRB, 0.48949625E-11_JPRB, 0.52140015E-11_JPRB, 0.56179111E-11_JPRB, &
  & 0.60690996E-11_JPRB, 0.65157532E-11_JPRB, 0.69284574E-11_JPRB, 0.72648992E-11_JPRB, 0.74785031E-11_JPRB, 0.75286929E-11_JPRB, &
  & 0.73925683E-11_JPRB, 0.71611037E-11_JPRB, 0.68726661E-11_JPRB, 0.66172766E-11_JPRB, 0.63230636E-11_JPRB, 0.59207574E-11_JPRB, &
  & 0.54953156E-11_JPRB, 0.50688338E-11_JPRB, 0.46727435E-11_JPRB, 0.43594967E-11_JPRB, 0.41619945E-11_JPRB, 0.40149746E-11_JPRB, &
  & 0.39205687E-11_JPRB, 0.38761425E-11_JPRB, 0.41232859E-11_JPRB, 0.40075898E-11_JPRB, 0.48828077E-11_JPRB, 0.44163193E-11_JPRB, &
  & 0.40055116E-11_JPRB, 0.37026888E-11_JPRB, 0.34548716E-11_JPRB, 0.31220543E-11_JPRB /)

RGHG4(:,64, 1) = (/ &
  & 0.41373367E-11_JPRB, 0.41726058E-11_JPRB, 0.42046245E-11_JPRB, 0.42129169E-11_JPRB, 0.42519855E-11_JPRB, 0.43462022E-11_JPRB, &
  & 0.44783990E-11_JPRB, 0.46020362E-11_JPRB, 0.42768272E-11_JPRB, 0.43034287E-11_JPRB, 0.43356438E-11_JPRB, 0.43761227E-11_JPRB, &
  & 0.44285946E-11_JPRB, 0.45138697E-11_JPRB, 0.46504753E-11_JPRB, 0.48730312E-11_JPRB, 0.51898477E-11_JPRB, 0.55382240E-11_JPRB, &
  & 0.58101250E-11_JPRB, 0.59061844E-11_JPRB, 0.58124777E-11_JPRB, 0.55863248E-11_JPRB, 0.53101703E-11_JPRB, 0.50712949E-11_JPRB, &
  & 0.49236813E-11_JPRB, 0.48779951E-11_JPRB, 0.49148923E-11_JPRB, 0.49906932E-11_JPRB, 0.50744487E-11_JPRB, 0.51418631E-11_JPRB, &
  & 0.51869732E-11_JPRB, 0.52353261E-11_JPRB, 0.53238013E-11_JPRB, 0.55047642E-11_JPRB, 0.57980014E-11_JPRB, 0.61870114E-11_JPRB, &
  & 0.66358819E-11_JPRB, 0.70947202E-11_JPRB, 0.75234567E-11_JPRB, 0.78853469E-11_JPRB, 0.81404770E-11_JPRB, 0.82639399E-11_JPRB, &
  & 0.82290112E-11_JPRB, 0.81305145E-11_JPRB, 0.79875091E-11_JPRB, 0.78794887E-11_JPRB, 0.77176572E-11_JPRB, 0.74109174E-11_JPRB, &
  & 0.70199497E-11_JPRB, 0.65534236E-11_JPRB, 0.60951088E-11_JPRB, 0.56640751E-11_JPRB, 0.53752046E-11_JPRB, 0.51557304E-11_JPRB, &
  & 0.49980766E-11_JPRB, 0.48748085E-11_JPRB, 0.50123261E-11_JPRB, 0.47851692E-11_JPRB, 0.56066228E-11_JPRB, 0.49385179E-11_JPRB, &
  & 0.43839585E-11_JPRB, 0.40087382E-11_JPRB, 0.37193126E-11_JPRB, 0.33582987E-11_JPRB /)

RGHG4(:,65, 1) = (/ &
  & 0.44263785E-11_JPRB, 0.45035174E-11_JPRB, 0.45603005E-11_JPRB, 0.45637166E-11_JPRB, 0.46020136E-11_JPRB, 0.46918363E-11_JPRB, &
  & 0.48263971E-11_JPRB, 0.49502806E-11_JPRB, 0.46116591E-11_JPRB, 0.46199359E-11_JPRB, 0.46451272E-11_JPRB, 0.46866118E-11_JPRB, &
  & 0.47395230E-11_JPRB, 0.48179013E-11_JPRB, 0.49366860E-11_JPRB, 0.51239924E-11_JPRB, 0.53904962E-11_JPRB, 0.56858528E-11_JPRB, &
  & 0.59267279E-11_JPRB, 0.60304999E-11_JPRB, 0.59792232E-11_JPRB, 0.58213490E-11_JPRB, 0.56331923E-11_JPRB, 0.54938584E-11_JPRB, &
  & 0.54445220E-11_JPRB, 0.54860387E-11_JPRB, 0.55971304E-11_JPRB, 0.57295297E-11_JPRB, 0.58540152E-11_JPRB, 0.59473012E-11_JPRB, &
  & 0.60035791E-11_JPRB, 0.60443777E-11_JPRB, 0.61073126E-11_JPRB, 0.62490885E-11_JPRB, 0.65012626E-11_JPRB, 0.68671128E-11_JPRB, &
  & 0.73112141E-11_JPRB, 0.77723956E-11_JPRB, 0.82179376E-11_JPRB, 0.86044141E-11_JPRB, 0.89103334E-11_JPRB, 0.91173839E-11_JPRB, &
  & 0.91999819E-11_JPRB, 0.92460449E-11_JPRB, 0.92636177E-11_JPRB, 0.93213232E-11_JPRB, 0.93185468E-11_JPRB, 0.91382995E-11_JPRB, &
  & 0.88406140E-11_JPRB, 0.84008078E-11_JPRB, 0.78877547E-11_JPRB, 0.73813143E-11_JPRB, 0.69867406E-11_JPRB, 0.66653120E-11_JPRB, &
  & 0.63783501E-11_JPRB, 0.61647961E-11_JPRB, 0.61610660E-11_JPRB, 0.57565719E-11_JPRB, 0.64058077E-11_JPRB, 0.54448100E-11_JPRB, &
  & 0.47115146E-11_JPRB, 0.42674683E-11_JPRB, 0.39487012E-11_JPRB, 0.35608380E-11_JPRB /)

RGHG4(:,66, 1) = (/ &
  & 0.48072588E-11_JPRB, 0.49347258E-11_JPRB, 0.49995997E-11_JPRB, 0.50067064E-11_JPRB, 0.50388253E-11_JPRB, 0.51331396E-11_JPRB, &
  & 0.52669327E-11_JPRB, 0.53894922E-11_JPRB, 0.50218133E-11_JPRB, 0.50039517E-11_JPRB, 0.50197030E-11_JPRB, 0.50595244E-11_JPRB, &
  & 0.51078109E-11_JPRB, 0.51800396E-11_JPRB, 0.52882963E-11_JPRB, 0.54502288E-11_JPRB, 0.56811830E-11_JPRB, 0.59371978E-11_JPRB, &
  & 0.61569998E-11_JPRB, 0.62701055E-11_JPRB, 0.62614614E-11_JPRB, 0.61757587E-11_JPRB, 0.60804322E-11_JPRB, 0.60388240E-11_JPRB, &
  & 0.60902078E-11_JPRB, 0.62267340E-11_JPRB, 0.64132766E-11_JPRB, 0.66058279E-11_JPRB, 0.67725226E-11_JPRB, 0.68956477E-11_JPRB, &
  & 0.69681947E-11_JPRB, 0.70055754E-11_JPRB, 0.70423025E-11_JPRB, 0.71452232E-11_JPRB, 0.73657573E-11_JPRB, 0.77024212E-11_JPRB, &
  & 0.81321148E-11_JPRB, 0.85932468E-11_JPRB, 0.90475561E-11_JPRB, 0.94600361E-11_JPRB, 0.98212627E-11_JPRB, 0.10123169E-10_JPRB, &
  & 0.10332720E-10_JPRB, 0.10535738E-10_JPRB, 0.10722396E-10_JPRB, 0.10948621E-10_JPRB, 0.11107036E-10_JPRB, 0.11053436E-10_JPRB, &
  & 0.10882099E-10_JPRB, 0.10523013E-10_JPRB, 0.10051067E-10_JPRB, 0.95372469E-11_JPRB, 0.90473974E-11_JPRB, 0.86057168E-11_JPRB, &
  & 0.82122044E-11_JPRB, 0.78598317E-11_JPRB, 0.76598155E-11_JPRB, 0.69492355E-11_JPRB, 0.72743981E-11_JPRB, 0.59003011E-11_JPRB, &
  & 0.49458319E-11_JPRB, 0.44757605E-11_JPRB, 0.41544394E-11_JPRB, 0.37503264E-11_JPRB /)

RGHG4(:,67, 1) = (/ &
  & 0.52581745E-11_JPRB, 0.54382761E-11_JPRB, 0.55234779E-11_JPRB, 0.55266074E-11_JPRB, 0.55536266E-11_JPRB, 0.56414430E-11_JPRB, &
  & 0.57750575E-11_JPRB, 0.58901252E-11_JPRB, 0.54909840E-11_JPRB, 0.54557856E-11_JPRB, 0.54750427E-11_JPRB, 0.55220485E-11_JPRB, &
  & 0.55825353E-11_JPRB, 0.56497580E-11_JPRB, 0.57476706E-11_JPRB, 0.58831542E-11_JPRB, 0.60822766E-11_JPRB, 0.63077985E-11_JPRB, &
  & 0.65134768E-11_JPRB, 0.66452226E-11_JPRB, 0.66858225E-11_JPRB, 0.66770240E-11_JPRB, 0.66772659E-11_JPRB, 0.67441677E-11_JPRB, &
  & 0.68947586E-11_JPRB, 0.71176537E-11_JPRB, 0.73802318E-11_JPRB, 0.76329455E-11_JPRB, 0.78447951E-11_JPRB, 0.80016957E-11_JPRB, &
  & 0.80977395E-11_JPRB, 0.81386668E-11_JPRB, 0.81579769E-11_JPRB, 0.82286261E-11_JPRB, 0.84096653E-11_JPRB, 0.87211852E-11_JPRB, &
  & 0.91401400E-11_JPRB, 0.95960453E-11_JPRB, 0.10058294E-10_JPRB, 0.10496197E-10_JPRB, 0.10916565E-10_JPRB, 0.11318979E-10_JPRB, &
  & 0.11660349E-10_JPRB, 0.12021046E-10_JPRB, 0.12377284E-10_JPRB, 0.12777734E-10_JPRB, 0.13120333E-10_JPRB, 0.13201954E-10_JPRB, &
  & 0.13173596E-10_JPRB, 0.12900099E-10_JPRB, 0.12513733E-10_JPRB, 0.12043551E-10_JPRB, 0.11543425E-10_JPRB, 0.10993446E-10_JPRB, &
  & 0.10473108E-10_JPRB, 0.99924019E-11_JPRB, 0.95710974E-11_JPRB, 0.84468647E-11_JPRB, 0.82125539E-11_JPRB, 0.62725749E-11_JPRB, &
  & 0.51155191E-11_JPRB, 0.47054110E-11_JPRB, 0.44251490E-11_JPRB, 0.39832673E-11_JPRB /)

RGHG4(:,68, 1) = (/ &
  & 0.57871177E-11_JPRB, 0.60256630E-11_JPRB, 0.61211973E-11_JPRB, 0.61206110E-11_JPRB, 0.61381946E-11_JPRB, 0.62273086E-11_JPRB, &
  & 0.63603471E-11_JPRB, 0.64737842E-11_JPRB, 0.60422561E-11_JPRB, 0.59949645E-11_JPRB, 0.60232088E-11_JPRB, 0.60691291E-11_JPRB, &
  & 0.61386894E-11_JPRB, 0.62079686E-11_JPRB, 0.63087335E-11_JPRB, 0.64372951E-11_JPRB, 0.66204668E-11_JPRB, 0.68291492E-11_JPRB, &
  & 0.70320455E-11_JPRB, 0.71873054E-11_JPRB, 0.72804766E-11_JPRB, 0.73490519E-11_JPRB, 0.74438389E-11_JPRB, 0.76040372E-11_JPRB, &
  & 0.78541861E-11_JPRB, 0.81738184E-11_JPRB, 0.85148685E-11_JPRB, 0.88318944E-11_JPRB, 0.90941117E-11_JPRB, 0.92915562E-11_JPRB, &
  & 0.94160062E-11_JPRB, 0.94653096E-11_JPRB, 0.94697817E-11_JPRB, 0.95140180E-11_JPRB, 0.96776111E-11_JPRB, 0.99657791E-11_JPRB, &
  & 0.10368147E-10_JPRB, 0.10820083E-10_JPRB, 0.11287087E-10_JPRB, 0.11753844E-10_JPRB, 0.12237072E-10_JPRB, 0.12743303E-10_JPRB, &
  & 0.13218930E-10_JPRB, 0.13737221E-10_JPRB, 0.14264578E-10_JPRB, 0.14827077E-10_JPRB, 0.15345208E-10_JPRB, 0.15540142E-10_JPRB, &
  & 0.15687332E-10_JPRB, 0.15509012E-10_JPRB, 0.15240101E-10_JPRB, 0.14873495E-10_JPRB, 0.14388274E-10_JPRB, 0.13813195E-10_JPRB, &
  & 0.13217117E-10_JPRB, 0.12641488E-10_JPRB, 0.11991482E-10_JPRB, 0.10326771E-10_JPRB, 0.92736045E-11_JPRB, 0.66846576E-11_JPRB, &
  & 0.53304934E-11_JPRB, 0.51398725E-11_JPRB, 0.49257850E-11_JPRB, 0.43553368E-11_JPRB /)

RGHG4(:,69, 1) = (/ &
  & 0.63817792E-11_JPRB, 0.66855822E-11_JPRB, 0.67998376E-11_JPRB, 0.67914593E-11_JPRB, 0.68024861E-11_JPRB, 0.68887487E-11_JPRB, &
  & 0.70256114E-11_JPRB, 0.71396348E-11_JPRB, 0.66840227E-11_JPRB, 0.66428607E-11_JPRB, 0.66896801E-11_JPRB, 0.67574700E-11_JPRB, &
  & 0.68473187E-11_JPRB, 0.69233963E-11_JPRB, 0.70248560E-11_JPRB, 0.71467142E-11_JPRB, 0.73164244E-11_JPRB, 0.75190010E-11_JPRB, &
  & 0.77295809E-11_JPRB, 0.79162918E-11_JPRB, 0.80655291E-11_JPRB, 0.82139425E-11_JPRB, 0.84021566E-11_JPRB, 0.86740320E-11_JPRB, &
  & 0.90212681E-11_JPRB, 0.94251213E-11_JPRB, 0.98437499E-11_JPRB, 0.10226586E-10_JPRB, 0.10545026E-10_JPRB, 0.10789670E-10_JPRB, &
  & 0.10952825E-10_JPRB, 0.11022687E-10_JPRB, 0.11026348E-10_JPRB, 0.11055560E-10_JPRB, 0.11185801E-10_JPRB, 0.11465078E-10_JPRB, &
  & 0.11860106E-10_JPRB, 0.12309371E-10_JPRB, 0.12783616E-10_JPRB, 0.13281949E-10_JPRB, 0.13830785E-10_JPRB, 0.14443508E-10_JPRB, &
  & 0.15051894E-10_JPRB, 0.15723924E-10_JPRB, 0.16411792E-10_JPRB, 0.17136443E-10_JPRB, 0.17845815E-10_JPRB, 0.18165483E-10_JPRB, &
  & 0.18509128E-10_JPRB, 0.18374710E-10_JPRB, 0.18278377E-10_JPRB, 0.17995173E-10_JPRB, 0.17567156E-10_JPRB, 0.16991797E-10_JPRB, &
  & 0.16349476E-10_JPRB, 0.15764915E-10_JPRB, 0.14922726E-10_JPRB, 0.12653619E-10_JPRB, 0.10657868E-10_JPRB, 0.73752801E-11_JPRB, &
  & 0.58394236E-11_JPRB, 0.60032894E-11_JPRB, 0.58376910E-11_JPRB, 0.50055637E-11_JPRB /)

RGHG4(:,70, 1) = (/ &
  & 0.70444657E-11_JPRB, 0.74280521E-11_JPRB, 0.75589916E-11_JPRB, 0.75459717E-11_JPRB, 0.75502816E-11_JPRB, 0.76421352E-11_JPRB, &
  & 0.77898573E-11_JPRB, 0.79171392E-11_JPRB, 0.74502488E-11_JPRB, 0.74266045E-11_JPRB, 0.74912047E-11_JPRB, 0.75695526E-11_JPRB, &
  & 0.76797952E-11_JPRB, 0.77741416E-11_JPRB, 0.78888137E-11_JPRB, 0.80258716E-11_JPRB, 0.82002695E-11_JPRB, 0.84092941E-11_JPRB, &
  & 0.86361873E-11_JPRB, 0.88600551E-11_JPRB, 0.90682409E-11_JPRB, 0.92947863E-11_JPRB, 0.95752980E-11_JPRB, 0.99308157E-11_JPRB, &
  & 0.10379092E-10_JPRB, 0.10882416E-10_JPRB, 0.11385756E-10_JPRB, 0.11842259E-10_JPRB, 0.12221280E-10_JPRB, 0.12522177E-10_JPRB, &
  & 0.12731032E-10_JPRB, 0.12828370E-10_JPRB, 0.12836858E-10_JPRB, 0.12861418E-10_JPRB, 0.13002955E-10_JPRB, 0.13267847E-10_JPRB, &
  & 0.13657331E-10_JPRB, 0.14109271E-10_JPRB, 0.14593228E-10_JPRB, 0.15124943E-10_JPRB, 0.15743322E-10_JPRB, 0.16464025E-10_JPRB, &
  & 0.17207482E-10_JPRB, 0.18027595E-10_JPRB, 0.18874062E-10_JPRB, 0.19747532E-10_JPRB, 0.20621565E-10_JPRB, 0.21038452E-10_JPRB, &
  & 0.21582208E-10_JPRB, 0.21511255E-10_JPRB, 0.21675375E-10_JPRB, 0.21369913E-10_JPRB, 0.21124906E-10_JPRB, 0.20565586E-10_JPRB, &
  & 0.19913370E-10_JPRB, 0.19443079E-10_JPRB, 0.18326680E-10_JPRB, 0.15525187E-10_JPRB, 0.12596615E-10_JPRB, 0.86406039E-11_JPRB, &
  & 0.69509819E-11_JPRB, 0.75049663E-11_JPRB, 0.73300255E-11_JPRB, 0.60384297E-11_JPRB /)

RGHG4(:,71, 1) = (/ &
  & 0.77927335E-11_JPRB, 0.82621809E-11_JPRB, 0.84205342E-11_JPRB, 0.84018591E-11_JPRB, 0.84049078E-11_JPRB, 0.85053136E-11_JPRB, &
  & 0.86690568E-11_JPRB, 0.88188614E-11_JPRB, 0.83610584E-11_JPRB, 0.83747141E-11_JPRB, 0.84719601E-11_JPRB, 0.85922285E-11_JPRB, &
  & 0.87211358E-11_JPRB, 0.88402488E-11_JPRB, 0.89660501E-11_JPRB, 0.91077762E-11_JPRB, 0.92901598E-11_JPRB, 0.95144309E-11_JPRB, &
  & 0.97676849E-11_JPRB, 0.10037320E-10_JPRB, 0.10311522E-10_JPRB, 0.10621165E-10_JPRB, 0.10996764E-10_JPRB, 0.11473274E-10_JPRB, &
  & 0.12019378E-10_JPRB, 0.12606014E-10_JPRB, 0.13190875E-10_JPRB, 0.13722591E-10_JPRB, 0.14171221E-10_JPRB, 0.14538218E-10_JPRB, &
  & 0.14809208E-10_JPRB, 0.14952102E-10_JPRB, 0.14984219E-10_JPRB, 0.15018081E-10_JPRB, 0.15143890E-10_JPRB, 0.15417849E-10_JPRB, &
  & 0.15813474E-10_JPRB, 0.16271227E-10_JPRB, 0.16767220E-10_JPRB, 0.17336983E-10_JPRB, 0.18027517E-10_JPRB, 0.18858989E-10_JPRB, &
  & 0.19731144E-10_JPRB, 0.20696191E-10_JPRB, 0.21680982E-10_JPRB, 0.22704347E-10_JPRB, 0.23749142E-10_JPRB, 0.24272993E-10_JPRB, &
  & 0.25029524E-10_JPRB, 0.25000221E-10_JPRB, 0.25400819E-10_JPRB, 0.25080679E-10_JPRB, 0.25051542E-10_JPRB, 0.24573092E-10_JPRB, &
  & 0.23827041E-10_JPRB, 0.23631300E-10_JPRB, 0.22330790E-10_JPRB, 0.19004891E-10_JPRB, 0.15403383E-10_JPRB, 0.10822797E-10_JPRB, &
  & 0.89497671E-11_JPRB, 0.98251997E-11_JPRB, 0.96173148E-11_JPRB, 0.76820737E-11_JPRB /)

RGHG4(:,72, 1) = (/ &
  & 0.86248092E-11_JPRB, 0.92129446E-11_JPRB, 0.93964472E-11_JPRB, 0.93762602E-11_JPRB, 0.93824740E-11_JPRB, 0.95014647E-11_JPRB, &
  & 0.96967243E-11_JPRB, 0.98796743E-11_JPRB, 0.94536167E-11_JPRB, 0.95165594E-11_JPRB, 0.96395270E-11_JPRB, 0.97804230E-11_JPRB, &
  & 0.99405970E-11_JPRB, 0.10083273E-10_JPRB, 0.10238486E-10_JPRB, 0.10412638E-10_JPRB, 0.10617824E-10_JPRB, 0.10868589E-10_JPRB, &
  & 0.11160548E-10_JPRB, 0.11484490E-10_JPRB, 0.11830135E-10_JPRB, 0.12224774E-10_JPRB, 0.12694900E-10_JPRB, 0.13249985E-10_JPRB, &
  & 0.13896272E-10_JPRB, 0.14590332E-10_JPRB, 0.15275101E-10_JPRB, 0.15896092E-10_JPRB, 0.16422547E-10_JPRB, 0.16865138E-10_JPRB, &
  & 0.17200711E-10_JPRB, 0.17397134E-10_JPRB, 0.17469149E-10_JPRB, 0.17528447E-10_JPRB, 0.17702560E-10_JPRB, 0.17978254E-10_JPRB, &
  & 0.18384278E-10_JPRB, 0.18850860E-10_JPRB, 0.19364376E-10_JPRB, 0.19974486E-10_JPRB, 0.20741655E-10_JPRB, 0.21677670E-10_JPRB, &
  & 0.22677553E-10_JPRB, 0.23772881E-10_JPRB, 0.24898474E-10_JPRB, 0.26058256E-10_JPRB, 0.27225376E-10_JPRB, 0.27844537E-10_JPRB, &
  & 0.28750766E-10_JPRB, 0.28827178E-10_JPRB, 0.29462512E-10_JPRB, 0.29182361E-10_JPRB, 0.29320976E-10_JPRB, 0.29022526E-10_JPRB, &
  & 0.28241937E-10_JPRB, 0.28227982E-10_JPRB, 0.26932073E-10_JPRB, 0.23182397E-10_JPRB, 0.19402332E-10_JPRB, 0.14081494E-10_JPRB, &
  & 0.12137407E-10_JPRB, 0.13242451E-10_JPRB, 0.12969265E-10_JPRB, 0.10263387E-10_JPRB /)

RGHG4(:,73, 1) = (/ &
  & 0.96074607E-11_JPRB, 0.10299377E-10_JPRB, 0.10510651E-10_JPRB, 0.10485873E-10_JPRB, 0.10500048E-10_JPRB, 0.10645321E-10_JPRB, &
  & 0.10879099E-10_JPRB, 0.11113971E-10_JPRB, 0.10729994E-10_JPRB, 0.10850543E-10_JPRB, 0.11030838E-10_JPRB, 0.11218600E-10_JPRB, &
  & 0.11409979E-10_JPRB, 0.11591089E-10_JPRB, 0.11768989E-10_JPRB, 0.11960428E-10_JPRB, 0.12195406E-10_JPRB, 0.12482485E-10_JPRB, &
  & 0.12823085E-10_JPRB, 0.13214258E-10_JPRB, 0.13643779E-10_JPRB, 0.14135691E-10_JPRB, 0.14711612E-10_JPRB, 0.15403373E-10_JPRB, &
  & 0.16162094E-10_JPRB, 0.16945525E-10_JPRB, 0.17718467E-10_JPRB, 0.18427334E-10_JPRB, 0.19042497E-10_JPRB, 0.19574235E-10_JPRB, &
  & 0.20001729E-10_JPRB, 0.20273377E-10_JPRB, 0.20394854E-10_JPRB, 0.20496193E-10_JPRB, 0.20683644E-10_JPRB, 0.20994470E-10_JPRB, &
  & 0.21413366E-10_JPRB, 0.21891253E-10_JPRB, 0.22422810E-10_JPRB, 0.23076600E-10_JPRB, 0.23914894E-10_JPRB, 0.24948136E-10_JPRB, &
  & 0.26059052E-10_JPRB, 0.27267320E-10_JPRB, 0.28511520E-10_JPRB, 0.29788595E-10_JPRB, 0.31042197E-10_JPRB, 0.31814391E-10_JPRB, &
  & 0.32866376E-10_JPRB, 0.33036889E-10_JPRB, 0.33800643E-10_JPRB, 0.33614059E-10_JPRB, 0.33910805E-10_JPRB, 0.33805021E-10_JPRB, &
  & 0.33000585E-10_JPRB, 0.33264280E-10_JPRB, 0.31899768E-10_JPRB, 0.28240523E-10_JPRB, 0.24508281E-10_JPRB, 0.18804932E-10_JPRB, &
  & 0.16740876E-10_JPRB, 0.17966689E-10_JPRB, 0.17591727E-10_JPRB, 0.13984636E-10_JPRB /)

RGHG4(:,74, 1) = (/ &
  & 0.10780703E-10_JPRB, 0.11545187E-10_JPRB, 0.11765802E-10_JPRB, 0.11742073E-10_JPRB, 0.11770142E-10_JPRB, 0.11952255E-10_JPRB, &
  & 0.12245577E-10_JPRB, 0.12541628E-10_JPRB, 0.12203768E-10_JPRB, 0.12399250E-10_JPRB, 0.12605621E-10_JPRB, 0.12840701E-10_JPRB, &
  & 0.13070436E-10_JPRB, 0.13297147E-10_JPRB, 0.13524460E-10_JPRB, 0.13775390E-10_JPRB, 0.14061549E-10_JPRB, 0.14396932E-10_JPRB, &
  & 0.14800040E-10_JPRB, 0.15273369E-10_JPRB, 0.15794515E-10_JPRB, 0.16393409E-10_JPRB, 0.17073681E-10_JPRB, 0.17836552E-10_JPRB, &
  & 0.18689141E-10_JPRB, 0.19592782E-10_JPRB, 0.20481488E-10_JPRB, 0.21303098E-10_JPRB, 0.22017428E-10_JPRB, 0.22642069E-10_JPRB, &
  & 0.23151005E-10_JPRB, 0.23510215E-10_JPRB, 0.23736983E-10_JPRB, 0.23925351E-10_JPRB, 0.24172690E-10_JPRB, 0.24530359E-10_JPRB, &
  & 0.24963111E-10_JPRB, 0.25454664E-10_JPRB, 0.26009989E-10_JPRB, 0.26706710E-10_JPRB, 0.27610917E-10_JPRB, 0.28725123E-10_JPRB, &
  & 0.29926114E-10_JPRB, 0.31226924E-10_JPRB, 0.32557956E-10_JPRB, 0.33946953E-10_JPRB, 0.35230704E-10_JPRB, 0.36133502E-10_JPRB, &
  & 0.37217531E-10_JPRB, 0.37520011E-10_JPRB, 0.38463874E-10_JPRB, 0.38389843E-10_JPRB, 0.38846128E-10_JPRB, 0.38861022E-10_JPRB, &
  & 0.38195256E-10_JPRB, 0.38581340E-10_JPRB, 0.37481199E-10_JPRB, 0.33767288E-10_JPRB, 0.31063381E-10_JPRB, 0.25021428E-10_JPRB, &
  & 0.22964380E-10_JPRB, 0.24208786E-10_JPRB, 0.23660813E-10_JPRB, 0.19010743E-10_JPRB /)

RGHG4(:,75, 1) = (/ &
  & 0.12063237E-10_JPRB, 0.12915858E-10_JPRB, 0.13169858E-10_JPRB, 0.13150577E-10_JPRB, 0.13199426E-10_JPRB, 0.13425635E-10_JPRB, &
  & 0.13785399E-10_JPRB, 0.14166271E-10_JPRB, 0.13886154E-10_JPRB, 0.14146625E-10_JPRB, 0.14454494E-10_JPRB, 0.14740840E-10_JPRB, &
  & 0.15050239E-10_JPRB, 0.15325258E-10_JPRB, 0.15601576E-10_JPRB, 0.15888150E-10_JPRB, 0.16221122E-10_JPRB, 0.16631486E-10_JPRB, &
  & 0.17112376E-10_JPRB, 0.17681304E-10_JPRB, 0.18318668E-10_JPRB, 0.19037841E-10_JPRB, 0.19845270E-10_JPRB, 0.20778481E-10_JPRB, &
  & 0.21777559E-10_JPRB, 0.22787236E-10_JPRB, 0.23777967E-10_JPRB, 0.24696536E-10_JPRB, 0.25518256E-10_JPRB, 0.26261993E-10_JPRB, &
  & 0.26902713E-10_JPRB, 0.27373775E-10_JPRB, 0.27660188E-10_JPRB, 0.27907832E-10_JPRB, 0.28224553E-10_JPRB, 0.28628556E-10_JPRB, &
  & 0.29085144E-10_JPRB, 0.29587818E-10_JPRB, 0.30173228E-10_JPRB, 0.30917373E-10_JPRB, 0.31878312E-10_JPRB, 0.33050496E-10_JPRB, &
  & 0.34318437E-10_JPRB, 0.35679324E-10_JPRB, 0.37078816E-10_JPRB, 0.38506778E-10_JPRB, 0.39852757E-10_JPRB, 0.40892199E-10_JPRB, &
  & 0.42002547E-10_JPRB, 0.42435590E-10_JPRB, 0.43452301E-10_JPRB, 0.43490066E-10_JPRB, 0.44124416E-10_JPRB, 0.44269800E-10_JPRB, &
  & 0.43668617E-10_JPRB, 0.44373217E-10_JPRB, 0.43346365E-10_JPRB, 0.40110585E-10_JPRB, 0.38887699E-10_JPRB, 0.32868833E-10_JPRB, &
  & 0.30974941E-10_JPRB, 0.32158855E-10_JPRB, 0.31342710E-10_JPRB, 0.25553061E-10_JPRB /)

RGHG4(:,76, 1) = (/ &
  & 0.13485942E-10_JPRB, 0.14433500E-10_JPRB, 0.14714629E-10_JPRB, 0.14708651E-10_JPRB, 0.14782408E-10_JPRB, 0.15058330E-10_JPRB, &
  & 0.15499525E-10_JPRB, 0.15969609E-10_JPRB, 0.15743460E-10_JPRB, 0.16102852E-10_JPRB, 0.16438677E-10_JPRB, 0.16820564E-10_JPRB, &
  & 0.17164863E-10_JPRB, 0.17540903E-10_JPRB, 0.17903862E-10_JPRB, 0.18296437E-10_JPRB, 0.18715416E-10_JPRB, 0.19208239E-10_JPRB, &
  & 0.19782743E-10_JPRB, 0.20471475E-10_JPRB, 0.21234821E-10_JPRB, 0.22092994E-10_JPRB, 0.23020150E-10_JPRB, 0.24004491E-10_JPRB, &
  & 0.25063087E-10_JPRB, 0.26172011E-10_JPRB, 0.27273087E-10_JPRB, 0.28308774E-10_JPRB, 0.29245793E-10_JPRB, 0.30102785E-10_JPRB, &
  & 0.30845153E-10_JPRB, 0.31451463E-10_JPRB, 0.31969073E-10_JPRB, 0.32423422E-10_JPRB, 0.32850552E-10_JPRB, 0.33305841E-10_JPRB, &
  & 0.33804657E-10_JPRB, 0.34317268E-10_JPRB, 0.34938528E-10_JPRB, 0.35726554E-10_JPRB, 0.36730327E-10_JPRB, 0.37940658E-10_JPRB, &
  & 0.39228662E-10_JPRB, 0.40621541E-10_JPRB, 0.42034969E-10_JPRB, 0.43501286E-10_JPRB, 0.44832350E-10_JPRB, 0.45877829E-10_JPRB, &
  & 0.46966660E-10_JPRB, 0.47527128E-10_JPRB, 0.48694777E-10_JPRB, 0.48844827E-10_JPRB, 0.49593038E-10_JPRB, 0.49992534E-10_JPRB, &
  & 0.49453722E-10_JPRB, 0.50350741E-10_JPRB, 0.49753833E-10_JPRB, 0.47095661E-10_JPRB, 0.47678937E-10_JPRB, 0.42566558E-10_JPRB, &
  & 0.40826401E-10_JPRB, 0.41831309E-10_JPRB, 0.40698288E-10_JPRB, 0.33773664E-10_JPRB /)

RGHG4(:,77, 1) = (/ &
  & 0.15034652E-10_JPRB, 0.16068971E-10_JPRB, 0.16381542E-10_JPRB, 0.16392266E-10_JPRB, 0.16493560E-10_JPRB, 0.16825596E-10_JPRB, &
  & 0.17344222E-10_JPRB, 0.17911388E-10_JPRB, 0.17746875E-10_JPRB, 0.18171666E-10_JPRB, 0.18628810E-10_JPRB, 0.19060382E-10_JPRB, &
  & 0.19548816E-10_JPRB, 0.19998735E-10_JPRB, 0.20465709E-10_JPRB, 0.20941540E-10_JPRB, 0.21473025E-10_JPRB, 0.22074544E-10_JPRB, &
  & 0.22778602E-10_JPRB, 0.23598791E-10_JPRB, 0.24516516E-10_JPRB, 0.25517156E-10_JPRB, 0.26587343E-10_JPRB, 0.27771173E-10_JPRB, &
  & 0.29022154E-10_JPRB, 0.30276451E-10_JPRB, 0.31514905E-10_JPRB, 0.32682416E-10_JPRB, 0.33756220E-10_JPRB, 0.34739094E-10_JPRB, &
  & 0.35619559E-10_JPRB, 0.36382383E-10_JPRB, 0.36941079E-10_JPRB, 0.37401211E-10_JPRB, 0.37949355E-10_JPRB, 0.38492896E-10_JPRB, &
  & 0.39042825E-10_JPRB, 0.39593117E-10_JPRB, 0.40249280E-10_JPRB, 0.41083106E-10_JPRB, 0.42116036E-10_JPRB, 0.43322464E-10_JPRB, &
  & 0.44591584E-10_JPRB, 0.45953175E-10_JPRB, 0.47325074E-10_JPRB, 0.48740539E-10_JPRB, 0.50079416E-10_JPRB, 0.51138680E-10_JPRB, &
  & 0.52248119E-10_JPRB, 0.52880769E-10_JPRB, 0.54029742E-10_JPRB, 0.54352460E-10_JPRB, 0.55161122E-10_JPRB, 0.55811987E-10_JPRB, &
  & 0.55407231E-10_JPRB, 0.56544072E-10_JPRB, 0.56360177E-10_JPRB, 0.54317089E-10_JPRB, 0.58131857E-10_JPRB, 0.53579936E-10_JPRB, &
  & 0.52388548E-10_JPRB, 0.53130497E-10_JPRB, 0.51592407E-10_JPRB, 0.43724215E-10_JPRB /)

RGHG4(:,78, 1) = (/ &
  & 0.16703926E-10_JPRB, 0.17737515E-10_JPRB, 0.18043103E-10_JPRB, 0.18069130E-10_JPRB, 0.18197501E-10_JPRB, 0.18581556E-10_JPRB, &
  & 0.19175274E-10_JPRB, 0.19808431E-10_JPRB, 0.19702837E-10_JPRB, 0.20194514E-10_JPRB, 0.20671237E-10_JPRB, 0.21187541E-10_JPRB, &
  & 0.21721383E-10_JPRB, 0.22318937E-10_JPRB, 0.22934953E-10_JPRB, 0.23579031E-10_JPRB, 0.24248371E-10_JPRB, 0.25005760E-10_JPRB, &
  & 0.25850929E-10_JPRB, 0.26825858E-10_JPRB, 0.27880365E-10_JPRB, 0.29014008E-10_JPRB, 0.30179196E-10_JPRB, 0.31352903E-10_JPRB, &
  & 0.32561537E-10_JPRB, 0.33787223E-10_JPRB, 0.35020226E-10_JPRB, 0.36224433E-10_JPRB, 0.37377917E-10_JPRB, 0.38481975E-10_JPRB, &
  & 0.39531042E-10_JPRB, 0.40511337E-10_JPRB, 0.41427049E-10_JPRB, 0.42349766E-10_JPRB, 0.43090427E-10_JPRB, 0.43758695E-10_JPRB, &
  & 0.44407523E-10_JPRB, 0.45052292E-10_JPRB, 0.45763407E-10_JPRB, 0.46638166E-10_JPRB, 0.47667922E-10_JPRB, 0.48824913E-10_JPRB, &
  & 0.49985925E-10_JPRB, 0.51239676E-10_JPRB, 0.52506256E-10_JPRB, 0.53816951E-10_JPRB, 0.55052764E-10_JPRB, 0.56053173E-10_JPRB, &
  & 0.57078807E-10_JPRB, 0.57766906E-10_JPRB, 0.58955001E-10_JPRB, 0.59548824E-10_JPRB, 0.60209608E-10_JPRB, 0.61255480E-10_JPRB, &
  & 0.60987659E-10_JPRB, 0.62167715E-10_JPRB, 0.62611097E-10_JPRB, 0.61616559E-10_JPRB, 0.68217841E-10_JPRB, 0.65300515E-10_JPRB, &
  & 0.64518106E-10_JPRB, 0.64984948E-10_JPRB, 0.63330875E-10_JPRB, 0.55238224E-10_JPRB /)

RGHG4(:,79, 1) = (/ &
  & 0.18298378E-10_JPRB, 0.19016060E-10_JPRB, 0.19208411E-10_JPRB, 0.19201715E-10_JPRB, 0.19321473E-10_JPRB, 0.19720845E-10_JPRB, &
  & 0.20324315E-10_JPRB, 0.20984488E-10_JPRB, 0.20868635E-10_JPRB, 0.21379442E-10_JPRB, 0.21868434E-10_JPRB, 0.22417365E-10_JPRB, &
  & 0.23030501E-10_JPRB, 0.23691080E-10_JPRB, 0.24399892E-10_JPRB, 0.25163999E-10_JPRB, 0.26010288E-10_JPRB, 0.26917206E-10_JPRB, &
  & 0.27901273E-10_JPRB, 0.28956629E-10_JPRB, 0.30055163E-10_JPRB, 0.31159245E-10_JPRB, 0.32241664E-10_JPRB, 0.33397066E-10_JPRB, &
  & 0.34597825E-10_JPRB, 0.35807770E-10_JPRB, 0.37030736E-10_JPRB, 0.38251673E-10_JPRB, 0.39453708E-10_JPRB, 0.40628254E-10_JPRB, &
  & 0.41775871E-10_JPRB, 0.42894077E-10_JPRB, 0.43948321E-10_JPRB, 0.44926812E-10_JPRB, 0.45927605E-10_JPRB, 0.47016134E-10_JPRB, &
  & 0.48019543E-10_JPRB, 0.48964978E-10_JPRB, 0.49868512E-10_JPRB, 0.50828602E-10_JPRB, 0.51845098E-10_JPRB, 0.52870763E-10_JPRB, &
  & 0.53832966E-10_JPRB, 0.54856911E-10_JPRB, 0.55867321E-10_JPRB, 0.56961151E-10_JPRB, 0.58016727E-10_JPRB, 0.58899274E-10_JPRB, &
  & 0.59887782E-10_JPRB, 0.60569549E-10_JPRB, 0.61651087E-10_JPRB, 0.62445667E-10_JPRB, 0.63137294E-10_JPRB, 0.64242528E-10_JPRB, &
  & 0.64456177E-10_JPRB, 0.65558239E-10_JPRB, 0.66482209E-10_JPRB, 0.66134272E-10_JPRB, 0.75179397E-10_JPRB, 0.73237902E-10_JPRB, &
  & 0.72993882E-10_JPRB, 0.73653972E-10_JPRB, 0.72852745E-10_JPRB, 0.67332313E-10_JPRB /)

RGHG4(:,80, 1) = (/ &
  & 0.19234662E-10_JPRB, 0.19568121E-10_JPRB, 0.19695927E-10_JPRB, 0.19673315E-10_JPRB, 0.19789928E-10_JPRB, 0.20210097E-10_JPRB, &
  & 0.20846651E-10_JPRB, 0.21524680E-10_JPRB, 0.21529589E-10_JPRB, 0.22039886E-10_JPRB, 0.22584257E-10_JPRB, 0.23127257E-10_JPRB, &
  & 0.23754824E-10_JPRB, 0.24448287E-10_JPRB, 0.25201096E-10_JPRB, 0.25998417E-10_JPRB, 0.26839720E-10_JPRB, 0.27775102E-10_JPRB, &
  & 0.28784393E-10_JPRB, 0.29887873E-10_JPRB, 0.31024516E-10_JPRB, 0.32213114E-10_JPRB, 0.33374453E-10_JPRB, 0.34528137E-10_JPRB, &
  & 0.35684476E-10_JPRB, 0.36869768E-10_JPRB, 0.38087922E-10_JPRB, 0.39324318E-10_JPRB, 0.40553300E-10_JPRB, 0.41766472E-10_JPRB, &
  & 0.42961596E-10_JPRB, 0.44133624E-10_JPRB, 0.45284623E-10_JPRB, 0.46460970E-10_JPRB, 0.47577137E-10_JPRB, 0.48579689E-10_JPRB, &
  & 0.49547949E-10_JPRB, 0.50505409E-10_JPRB, 0.51476861E-10_JPRB, 0.52460373E-10_JPRB, 0.53474874E-10_JPRB, 0.54472472E-10_JPRB, &
  & 0.55372557E-10_JPRB, 0.56359063E-10_JPRB, 0.57364641E-10_JPRB, 0.58459321E-10_JPRB, 0.59539214E-10_JPRB, 0.60434123E-10_JPRB, &
  & 0.61391087E-10_JPRB, 0.62099520E-10_JPRB, 0.63146779E-10_JPRB, 0.64066391E-10_JPRB, 0.64729153E-10_JPRB, 0.65646183E-10_JPRB, &
  & 0.66036489E-10_JPRB, 0.66878079E-10_JPRB, 0.67985083E-10_JPRB, 0.67802548E-10_JPRB, 0.76994335E-10_JPRB, 0.75567462E-10_JPRB, &
  & 0.75310445E-10_JPRB, 0.76331177E-10_JPRB, 0.76230161E-10_JPRB, 0.74143865E-10_JPRB /)

RGHG4(:,81, 1) = (/ &
  & 0.19931031E-10_JPRB, 0.19974269E-10_JPRB, 0.20074406E-10_JPRB, 0.20047195E-10_JPRB, 0.20157150E-10_JPRB, 0.20590718E-10_JPRB, &
  & 0.21221970E-10_JPRB, 0.21931981E-10_JPRB, 0.21901885E-10_JPRB, 0.22456318E-10_JPRB, 0.22957291E-10_JPRB, 0.23553885E-10_JPRB, &
  & 0.24193066E-10_JPRB, 0.24903034E-10_JPRB, 0.25672631E-10_JPRB, 0.26509694E-10_JPRB, 0.27430214E-10_JPRB, 0.28411615E-10_JPRB, &
  & 0.29466613E-10_JPRB, 0.30575414E-10_JPRB, 0.31728040E-10_JPRB, 0.32857338E-10_JPRB, 0.33957115E-10_JPRB, 0.35085424E-10_JPRB, &
  & 0.36263589E-10_JPRB, 0.37462040E-10_JPRB, 0.38689375E-10_JPRB, 0.39935985E-10_JPRB, 0.41185673E-10_JPRB, 0.42420161E-10_JPRB, &
  & 0.43638513E-10_JPRB, 0.44838071E-10_JPRB, 0.46024504E-10_JPRB, 0.47185190E-10_JPRB, 0.48312673E-10_JPRB, 0.49458299E-10_JPRB, &
  & 0.50593727E-10_JPRB, 0.51623358E-10_JPRB, 0.52646134E-10_JPRB, 0.53649120E-10_JPRB, 0.54660436E-10_JPRB, 0.55654526E-10_JPRB, &
  & 0.56547371E-10_JPRB, 0.57514053E-10_JPRB, 0.58461840E-10_JPRB, 0.59499641E-10_JPRB, 0.60499689E-10_JPRB, 0.61322496E-10_JPRB, &
  & 0.62265353E-10_JPRB, 0.62955932E-10_JPRB, 0.63941422E-10_JPRB, 0.64882898E-10_JPRB, 0.65623833E-10_JPRB, 0.66505565E-10_JPRB, &
  & 0.67027078E-10_JPRB, 0.67857525E-10_JPRB, 0.69000972E-10_JPRB, 0.69057496E-10_JPRB, 0.78439463E-10_JPRB, 0.77385522E-10_JPRB, &
  & 0.77055209E-10_JPRB, 0.78144505E-10_JPRB, 0.78275698E-10_JPRB, 0.78207538E-10_JPRB /)

RGHG4(:,82, 1) = (/ &
  & 0.20360415E-10_JPRB, 0.20129292E-10_JPRB, 0.20245229E-10_JPRB, 0.20198903E-10_JPRB, 0.20305669E-10_JPRB, 0.20752455E-10_JPRB, &
  & 0.21399348E-10_JPRB, 0.22101243E-10_JPRB, 0.22219416E-10_JPRB, 0.22727193E-10_JPRB, 0.23313315E-10_JPRB, 0.23859180E-10_JPRB, &
  & 0.24510000E-10_JPRB, 0.25226677E-10_JPRB, 0.26003380E-10_JPRB, 0.26833921E-10_JPRB, 0.27712371E-10_JPRB, 0.28691036E-10_JPRB, &
  & 0.29737237E-10_JPRB, 0.30865640E-10_JPRB, 0.32006481E-10_JPRB, 0.33210438E-10_JPRB, 0.34371530E-10_JPRB, 0.35528126E-10_JPRB, &
  & 0.36681314E-10_JPRB, 0.37860784E-10_JPRB, 0.39091060E-10_JPRB, 0.40349359E-10_JPRB, 0.41609542E-10_JPRB, 0.42860146E-10_JPRB, &
  & 0.44093524E-10_JPRB, 0.45307584E-10_JPRB, 0.46520569E-10_JPRB, 0.47738799E-10_JPRB, 0.48934069E-10_JPRB, 0.50038414E-10_JPRB, &
  & 0.51104863E-10_JPRB, 0.52138051E-10_JPRB, 0.53156330E-10_JPRB, 0.54198666E-10_JPRB, 0.55203390E-10_JPRB, 0.56190618E-10_JPRB, &
  & 0.57062421E-10_JPRB, 0.58015266E-10_JPRB, 0.58970079E-10_JPRB, 0.60021300E-10_JPRB, 0.61054092E-10_JPRB, 0.61917325E-10_JPRB, &
  & 0.62855839E-10_JPRB, 0.63565916E-10_JPRB, 0.64507767E-10_JPRB, 0.65498801E-10_JPRB, 0.66188784E-10_JPRB, 0.67001925E-10_JPRB, &
  & 0.67411410E-10_JPRB, 0.68231615E-10_JPRB, 0.69239781E-10_JPRB, 0.69456114E-10_JPRB, 0.78498014E-10_JPRB, 0.77712017E-10_JPRB, &
  & 0.77275610E-10_JPRB, 0.78505154E-10_JPRB, 0.78913771E-10_JPRB, 0.80985052E-10_JPRB /)

RGHG4(:,83, 1) = (/ &
  & 0.20424492E-10_JPRB, 0.20262840E-10_JPRB, 0.20441373E-10_JPRB, 0.20378024E-10_JPRB, 0.20503392E-10_JPRB, 0.20962114E-10_JPRB, &
  & 0.21595281E-10_JPRB, 0.22359257E-10_JPRB, 0.22390624E-10_JPRB, 0.23001944E-10_JPRB, 0.23475701E-10_JPRB, 0.24121547E-10_JPRB, &
  & 0.24736378E-10_JPRB, 0.25471049E-10_JPRB, 0.26254878E-10_JPRB, 0.27111410E-10_JPRB, 0.28046935E-10_JPRB, 0.29038875E-10_JPRB, &
  & 0.30107847E-10_JPRB, 0.31216335E-10_JPRB, 0.32383572E-10_JPRB, 0.33522570E-10_JPRB, 0.34640388E-10_JPRB, 0.35759874E-10_JPRB, &
  & 0.36943882E-10_JPRB, 0.38142694E-10_JPRB, 0.39385484E-10_JPRB, 0.40651187E-10_JPRB, 0.41923694E-10_JPRB, 0.43184744E-10_JPRB, &
  & 0.44434168E-10_JPRB, 0.45667182E-10_JPRB, 0.46895089E-10_JPRB, 0.48124331E-10_JPRB, 0.49292192E-10_JPRB, 0.50437408E-10_JPRB, &
  & 0.51564142E-10_JPRB, 0.52645138E-10_JPRB, 0.53674846E-10_JPRB, 0.54718886E-10_JPRB, 0.55738705E-10_JPRB, 0.56723279E-10_JPRB, &
  & 0.57632368E-10_JPRB, 0.58596447E-10_JPRB, 0.59561890E-10_JPRB, 0.60613077E-10_JPRB, 0.61609752E-10_JPRB, 0.62393715E-10_JPRB, &
  & 0.63326303E-10_JPRB, 0.64052756E-10_JPRB, 0.64921887E-10_JPRB, 0.65951709E-10_JPRB, 0.66633490E-10_JPRB, 0.67526151E-10_JPRB, &
  & 0.67867267E-10_JPRB, 0.68735885E-10_JPRB, 0.69676452E-10_JPRB, 0.70065932E-10_JPRB, 0.78948265E-10_JPRB, 0.78299381E-10_JPRB, &
  & 0.77831179E-10_JPRB, 0.78820991E-10_JPRB, 0.79284773E-10_JPRB, 0.80968926E-10_JPRB /)

RGHG4(:,84, 1) = (/ &
  & 0.20557179E-10_JPRB, 0.20342667E-10_JPRB, 0.20565816E-10_JPRB, 0.20448964E-10_JPRB, 0.20603323E-10_JPRB, 0.21046850E-10_JPRB, &
  & 0.21709105E-10_JPRB, 0.22441176E-10_JPRB, 0.22647245E-10_JPRB, 0.23152280E-10_JPRB, 0.23750987E-10_JPRB, 0.24276364E-10_JPRB, &
  & 0.24949586E-10_JPRB, 0.25659386E-10_JPRB, 0.26454641E-10_JPRB, 0.27296759E-10_JPRB, 0.28193980E-10_JPRB, 0.29186636E-10_JPRB, &
  & 0.30242919E-10_JPRB, 0.31366396E-10_JPRB, 0.32500790E-10_JPRB, 0.33722448E-10_JPRB, 0.34852215E-10_JPRB, 0.36034446E-10_JPRB, &
  & 0.37188749E-10_JPRB, 0.38381215E-10_JPRB, 0.39619537E-10_JPRB, 0.40894281E-10_JPRB, 0.42174195E-10_JPRB, 0.43445962E-10_JPRB, &
  & 0.44706787E-10_JPRB, 0.45953196E-10_JPRB, 0.47202065E-10_JPRB, 0.48445123E-10_JPRB, 0.49650374E-10_JPRB, 0.50781969E-10_JPRB, &
  & 0.51895859E-10_JPRB, 0.52963130E-10_JPRB, 0.53995006E-10_JPRB, 0.55048875E-10_JPRB, 0.56069305E-10_JPRB, 0.57050045E-10_JPRB, &
  & 0.57944576E-10_JPRB, 0.58925302E-10_JPRB, 0.59852977E-10_JPRB, 0.60909389E-10_JPRB, 0.61954677E-10_JPRB, 0.62741930E-10_JPRB, &
  & 0.63664768E-10_JPRB, 0.64415508E-10_JPRB, 0.65222668E-10_JPRB, 0.66274437E-10_JPRB, 0.66917458E-10_JPRB, 0.67769616E-10_JPRB, &
  & 0.68040920E-10_JPRB, 0.68874344E-10_JPRB, 0.69768233E-10_JPRB, 0.70203413E-10_JPRB, 0.78929419E-10_JPRB, 0.78268572E-10_JPRB, &
  & 0.78040664E-10_JPRB, 0.78815079E-10_JPRB, 0.79578524E-10_JPRB, 0.80984011E-10_JPRB /)

RGHG4(:,85, 1) = (/ &
  & 0.20675085E-10_JPRB, 0.20403406E-10_JPRB, 0.20708487E-10_JPRB, 0.20538385E-10_JPRB, 0.20756542E-10_JPRB, 0.21180431E-10_JPRB, &
  & 0.21877156E-10_JPRB, 0.22673677E-10_JPRB, 0.22796919E-10_JPRB, 0.23377706E-10_JPRB, 0.23863649E-10_JPRB, 0.24445765E-10_JPRB, &
  & 0.25059264E-10_JPRB, 0.25796251E-10_JPRB, 0.26597256E-10_JPRB, 0.27477140E-10_JPRB, 0.28415707E-10_JPRB, 0.29414145E-10_JPRB, &
  & 0.30474664E-10_JPRB, 0.31576308E-10_JPRB, 0.32758719E-10_JPRB, 0.33883004E-10_JPRB, 0.35017021E-10_JPRB, 0.36147065E-10_JPRB, &
  & 0.37333692E-10_JPRB, 0.38547207E-10_JPRB, 0.39789800E-10_JPRB, 0.41082266E-10_JPRB, 0.42366787E-10_JPRB, 0.43646895E-10_JPRB, &
  & 0.44924856E-10_JPRB, 0.46191901E-10_JPRB, 0.47452629E-10_JPRB, 0.48706237E-10_JPRB, 0.49891119E-10_JPRB, 0.51042785E-10_JPRB, &
  & 0.52169689E-10_JPRB, 0.53268924E-10_JPRB, 0.54335501E-10_JPRB, 0.55363911E-10_JPRB, 0.56432598E-10_JPRB, 0.57399526E-10_JPRB, &
  & 0.58316581E-10_JPRB, 0.59319785E-10_JPRB, 0.60301562E-10_JPRB, 0.61298619E-10_JPRB, 0.62361373E-10_JPRB, 0.63101684E-10_JPRB, &
  & 0.63987780E-10_JPRB, 0.64815535E-10_JPRB, 0.65565532E-10_JPRB, 0.66601440E-10_JPRB, 0.67261238E-10_JPRB, 0.68105556E-10_JPRB, &
  & 0.68412657E-10_JPRB, 0.69144648E-10_JPRB, 0.70096699E-10_JPRB, 0.70466778E-10_JPRB, 0.79262055E-10_JPRB, 0.78339481E-10_JPRB, &
  & 0.78410507E-10_JPRB, 0.78874733E-10_JPRB, 0.79754904E-10_JPRB, 0.81207902E-10_JPRB /)

RGHG4(:,86, 1) = (/ &
  & 0.20775314E-10_JPRB, 0.20439567E-10_JPRB, 0.20818467E-10_JPRB, 0.20571942E-10_JPRB, 0.20863785E-10_JPRB, 0.21235950E-10_JPRB, &
  & 0.22051246E-10_JPRB, 0.22766219E-10_JPRB, 0.23037917E-10_JPRB, 0.23528427E-10_JPRB, 0.24060512E-10_JPRB, 0.24564670E-10_JPRB, &
  & 0.25168537E-10_JPRB, 0.25880987E-10_JPRB, 0.26692556E-10_JPRB, 0.27554995E-10_JPRB, 0.28483606E-10_JPRB, 0.29472327E-10_JPRB, &
  & 0.30538877E-10_JPRB, 0.31649273E-10_JPRB, 0.32795114E-10_JPRB, 0.33985554E-10_JPRB, 0.35133986E-10_JPRB, 0.36301854E-10_JPRB, &
  & 0.37489491E-10_JPRB, 0.38698444E-10_JPRB, 0.39953214E-10_JPRB, 0.41238180E-10_JPRB, 0.42535458E-10_JPRB, 0.43826436E-10_JPRB, &
  & 0.45110238E-10_JPRB, 0.46380406E-10_JPRB, 0.47652222E-10_JPRB, 0.48909810E-10_JPRB, 0.50121476E-10_JPRB, 0.51266685E-10_JPRB, &
  & 0.52418066E-10_JPRB, 0.53505710E-10_JPRB, 0.54575441E-10_JPRB, 0.55650092E-10_JPRB, 0.56665835E-10_JPRB, 0.57697631E-10_JPRB, &
  & 0.58576401E-10_JPRB, 0.59539700E-10_JPRB, 0.60549232E-10_JPRB, 0.61510144E-10_JPRB, 0.62564627E-10_JPRB, 0.63368734E-10_JPRB, &
  & 0.64139909E-10_JPRB, 0.65009526E-10_JPRB, 0.65764762E-10_JPRB, 0.66767085E-10_JPRB, 0.67453466E-10_JPRB, 0.68207599E-10_JPRB, &
  & 0.68592292E-10_JPRB, 0.69159928E-10_JPRB, 0.70239217E-10_JPRB, 0.70443255E-10_JPRB, 0.79349763E-10_JPRB, 0.78215677E-10_JPRB, &
  & 0.78535754E-10_JPRB, 0.78900754E-10_JPRB, 0.79865586E-10_JPRB, 0.81273821E-10_JPRB /)

RGHG4(:,87, 1) = (/ &
  & 0.20859240E-10_JPRB, 0.20476339E-10_JPRB, 0.20915936E-10_JPRB, 0.20624023E-10_JPRB, 0.20982622E-10_JPRB, 0.21363160E-10_JPRB, &
  & 0.22228190E-10_JPRB, 0.22961074E-10_JPRB, 0.23220608E-10_JPRB, 0.23674474E-10_JPRB, 0.24183105E-10_JPRB, 0.24649897E-10_JPRB, &
  & 0.25255263E-10_JPRB, 0.25930766E-10_JPRB, 0.26748419E-10_JPRB, 0.27654261E-10_JPRB, 0.28602813E-10_JPRB, 0.29612004E-10_JPRB, &
  & 0.30660290E-10_JPRB, 0.31779739E-10_JPRB, 0.32938235E-10_JPRB, 0.34076492E-10_JPRB, 0.35223637E-10_JPRB, 0.36368967E-10_JPRB, &
  & 0.37561922E-10_JPRB, 0.38784868E-10_JPRB, 0.40048753E-10_JPRB, 0.41343030E-10_JPRB, 0.42644586E-10_JPRB, 0.43930744E-10_JPRB, &
  & 0.45224040E-10_JPRB, 0.46516780E-10_JPRB, 0.47802099E-10_JPRB, 0.49066952E-10_JPRB, 0.50274843E-10_JPRB, 0.51443967E-10_JPRB, &
  & 0.52595171E-10_JPRB, 0.53733309E-10_JPRB, 0.54814837E-10_JPRB, 0.55888124E-10_JPRB, 0.56973485E-10_JPRB, 0.57931760E-10_JPRB, &
  & 0.58916892E-10_JPRB, 0.59829960E-10_JPRB, 0.60846647E-10_JPRB, 0.61846542E-10_JPRB, 0.62807037E-10_JPRB, 0.63686521E-10_JPRB, &
  & 0.64417416E-10_JPRB, 0.65288989E-10_JPRB, 0.66063301E-10_JPRB, 0.67019001E-10_JPRB, 0.67732583E-10_JPRB, 0.68414156E-10_JPRB, &
  & 0.68884183E-10_JPRB, 0.69324671E-10_JPRB, 0.70477395E-10_JPRB, 0.70589021E-10_JPRB, 0.79480353E-10_JPRB, 0.78284185E-10_JPRB, &
  & 0.78624822E-10_JPRB, 0.78973682E-10_JPRB, 0.79932401E-10_JPRB, 0.81311999E-10_JPRB /)

RGHG4(:,88, 1) = (/ &
  & 0.20914563E-10_JPRB, 0.20521158E-10_JPRB, 0.20975537E-10_JPRB, 0.20655868E-10_JPRB, 0.21057146E-10_JPRB, 0.21393555E-10_JPRB, &
  & 0.22345837E-10_JPRB, 0.23005535E-10_JPRB, 0.23328072E-10_JPRB, 0.23772562E-10_JPRB, 0.24281981E-10_JPRB, 0.24752722E-10_JPRB, &
  & 0.25315011E-10_JPRB, 0.26011006E-10_JPRB, 0.26812523E-10_JPRB, 0.27688109E-10_JPRB, 0.28631065E-10_JPRB, 0.29618405E-10_JPRB, &
  & 0.30705608E-10_JPRB, 0.31798116E-10_JPRB, 0.32948210E-10_JPRB, 0.34128977E-10_JPRB, 0.35277083E-10_JPRB, 0.36452705E-10_JPRB, &
  & 0.37656774E-10_JPRB, 0.38883428E-10_JPRB, 0.40157534E-10_JPRB, 0.41449177E-10_JPRB, 0.42760566E-10_JPRB, 0.44071493E-10_JPRB, &
  & 0.45376310E-10_JPRB, 0.46658163E-10_JPRB, 0.47935954E-10_JPRB, 0.49212398E-10_JPRB, 0.50446813E-10_JPRB, 0.51627726E-10_JPRB, &
  & 0.52803414E-10_JPRB, 0.53928216E-10_JPRB, 0.55029405E-10_JPRB, 0.56106845E-10_JPRB, 0.57178495E-10_JPRB, 0.58172956E-10_JPRB, &
  & 0.59083648E-10_JPRB, 0.60046829E-10_JPRB, 0.60966815E-10_JPRB, 0.62021450E-10_JPRB, 0.62918976E-10_JPRB, 0.63809825E-10_JPRB, &
  & 0.64521291E-10_JPRB, 0.65360009E-10_JPRB, 0.66166031E-10_JPRB, 0.67121766E-10_JPRB, 0.67865956E-10_JPRB, 0.68480631E-10_JPRB, &
  & 0.69004427E-10_JPRB, 0.69378045E-10_JPRB, 0.70531525E-10_JPRB, 0.70641902E-10_JPRB, 0.79435708E-10_JPRB, 0.78287217E-10_JPRB, &
  & 0.78634016E-10_JPRB, 0.79002908E-10_JPRB, 0.79986628E-10_JPRB, 0.81343758E-10_JPRB /)

RGHG4(:,89, 1) = (/ &
  & 0.20956115E-10_JPRB, 0.20577271E-10_JPRB, 0.21008592E-10_JPRB, 0.20707748E-10_JPRB, 0.21078804E-10_JPRB, 0.21442372E-10_JPRB, &
  & 0.22319407E-10_JPRB, 0.23038451E-10_JPRB, 0.23351862E-10_JPRB, 0.23793995E-10_JPRB, 0.24307514E-10_JPRB, 0.24786244E-10_JPRB, &
  & 0.25386155E-10_JPRB, 0.26071560E-10_JPRB, 0.26881084E-10_JPRB, 0.27782712E-10_JPRB, 0.28720254E-10_JPRB, 0.29736894E-10_JPRB, &
  & 0.30767822E-10_JPRB, 0.31867110E-10_JPRB, 0.33016794E-10_JPRB, 0.34166850E-10_JPRB, 0.35308069E-10_JPRB, 0.36462309E-10_JPRB, &
  & 0.37667890E-10_JPRB, 0.38898693E-10_JPRB, 0.40173146E-10_JPRB, 0.41490061E-10_JPRB, 0.42812615E-10_JPRB, 0.44108953E-10_JPRB, &
  & 0.45416740E-10_JPRB, 0.46727747E-10_JPRB, 0.48053752E-10_JPRB, 0.49365949E-10_JPRB, 0.50619699E-10_JPRB, 0.51830776E-10_JPRB, &
  & 0.53017556E-10_JPRB, 0.54158743E-10_JPRB, 0.55251380E-10_JPRB, 0.56338056E-10_JPRB, 0.57409202E-10_JPRB, 0.58403934E-10_JPRB, &
  & 0.59313013E-10_JPRB, 0.60287809E-10_JPRB, 0.61194494E-10_JPRB, 0.62254667E-10_JPRB, 0.63161740E-10_JPRB, 0.64049210E-10_JPRB, &
  & 0.64791575E-10_JPRB, 0.65592747E-10_JPRB, 0.66379603E-10_JPRB, 0.67306147E-10_JPRB, 0.68079993E-10_JPRB, 0.68607169E-10_JPRB, &
  & 0.69179530E-10_JPRB, 0.69537549E-10_JPRB, 0.70651048E-10_JPRB, 0.70739692E-10_JPRB, 0.79433543E-10_JPRB, 0.78296335E-10_JPRB, &
  & 0.78680062E-10_JPRB, 0.79012213E-10_JPRB, 0.80055289E-10_JPRB, 0.81359704E-10_JPRB /)

RGHG4(:,90, 1) = (/ &
  & 0.20971367E-10_JPRB, 0.20647584E-10_JPRB, 0.20993806E-10_JPRB, 0.20763809E-10_JPRB, 0.21039144E-10_JPRB, 0.21398047E-10_JPRB, &
  & 0.22213436E-10_JPRB, 0.22943404E-10_JPRB, 0.23236494E-10_JPRB, 0.23754285E-10_JPRB, 0.24273795E-10_JPRB, 0.24811443E-10_JPRB, &
  & 0.25430304E-10_JPRB, 0.26148507E-10_JPRB, 0.26970443E-10_JPRB, 0.27823310E-10_JPRB, 0.28752525E-10_JPRB, 0.29711591E-10_JPRB, &
  & 0.30758562E-10_JPRB, 0.31846498E-10_JPRB, 0.32986301E-10_JPRB, 0.34142491E-10_JPRB, 0.35287682E-10_JPRB, 0.36461164E-10_JPRB, &
  & 0.37679321E-10_JPRB, 0.38933131E-10_JPRB, 0.40230368E-10_JPRB, 0.41552355E-10_JPRB, 0.42881206E-10_JPRB, 0.44244976E-10_JPRB, &
  & 0.45592353E-10_JPRB, 0.46916537E-10_JPRB, 0.48254022E-10_JPRB, 0.49564720E-10_JPRB, 0.50848211E-10_JPRB, 0.52087671E-10_JPRB, &
  & 0.53290986E-10_JPRB, 0.54422598E-10_JPRB, 0.55503144E-10_JPRB, 0.56577118E-10_JPRB, 0.57632364E-10_JPRB, 0.58606252E-10_JPRB, &
  & 0.59486950E-10_JPRB, 0.60427267E-10_JPRB, 0.61321642E-10_JPRB, 0.62337725E-10_JPRB, 0.63232919E-10_JPRB, 0.64088186E-10_JPRB, &
  & 0.64853130E-10_JPRB, 0.65665674E-10_JPRB, 0.66478170E-10_JPRB, 0.67371921E-10_JPRB, 0.68232558E-10_JPRB, 0.68672672E-10_JPRB, &
  & 0.69232099E-10_JPRB, 0.69630121E-10_JPRB, 0.70729297E-10_JPRB, 0.70738977E-10_JPRB, 0.79354232E-10_JPRB, 0.78226807E-10_JPRB, &
  & 0.78712023E-10_JPRB, 0.79010576E-10_JPRB, 0.80150803E-10_JPRB, 0.81378723E-10_JPRB /)

RGHG4(:,91, 1) = (/ &
  & 0.20916373E-10_JPRB, 0.20759850E-10_JPRB, 0.20918992E-10_JPRB, 0.20840048E-10_JPRB, 0.20970180E-10_JPRB, 0.21378411E-10_JPRB, &
  & 0.20037930E-10_JPRB, 0.22196814E-10_JPRB, 0.23063619E-10_JPRB, 0.23608599E-10_JPRB, 0.24182260E-10_JPRB, 0.24789448E-10_JPRB, &
  & 0.25464478E-10_JPRB, 0.26213537E-10_JPRB, 0.27015721E-10_JPRB, 0.27867628E-10_JPRB, 0.28770871E-10_JPRB, 0.29737556E-10_JPRB, &
  & 0.30756658E-10_JPRB, 0.31819353E-10_JPRB, 0.32936421E-10_JPRB, 0.34076762E-10_JPRB, 0.35207528E-10_JPRB, 0.36379302E-10_JPRB, &
  & 0.37600905E-10_JPRB, 0.38827244E-10_JPRB, 0.40178656E-10_JPRB, 0.41547880E-10_JPRB, 0.42900683E-10_JPRB, 0.44274740E-10_JPRB, &
  & 0.45634226E-10_JPRB, 0.46984614E-10_JPRB, 0.48408087E-10_JPRB, 0.49781547E-10_JPRB, 0.51130031E-10_JPRB, 0.52448403E-10_JPRB, &
  & 0.53662005E-10_JPRB, 0.54781759E-10_JPRB, 0.55857426E-10_JPRB, 0.56916895E-10_JPRB, 0.55860830E-10_JPRB, 0.56887939E-10_JPRB, &
  & 0.59775282E-10_JPRB, 0.60701465E-10_JPRB, 0.61606865E-10_JPRB, 0.62613859E-10_JPRB, 0.63502627E-10_JPRB, 0.64320341E-10_JPRB, &
  & 0.65060304E-10_JPRB, 0.65837183E-10_JPRB, 0.66662571E-10_JPRB, 0.67508790E-10_JPRB, 0.68353795E-10_JPRB, 0.68832662E-10_JPRB, &
  & 0.69325538E-10_JPRB, 0.69748617E-10_JPRB, 0.70881759E-10_JPRB, 0.70697490E-10_JPRB, 0.79206988E-10_JPRB, 0.78115993E-10_JPRB, &
  & 0.78753275E-10_JPRB, 0.79042821E-10_JPRB, 0.80321833E-10_JPRB, 0.81419489E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG4(:, 1, 2) = (/ &
  & 0.82394202E-13_JPRB, 0.90051928E-13_JPRB, 0.10259184E-12_JPRB, 0.11240531E-12_JPRB, 0.11720038E-12_JPRB, 0.12363591E-12_JPRB, &
  & 0.12458745E-12_JPRB, 0.13011795E-12_JPRB, 0.12683222E-12_JPRB, 0.12864654E-12_JPRB, 0.12952782E-12_JPRB, 0.12446930E-12_JPRB, &
  & 0.12354492E-12_JPRB, 0.12346733E-12_JPRB, 0.12334487E-12_JPRB, 0.12382101E-12_JPRB, 0.12460050E-12_JPRB, 0.12615303E-12_JPRB, &
  & 0.11993199E-12_JPRB, 0.11952192E-12_JPRB, 0.11988036E-12_JPRB, 0.12058513E-12_JPRB, 0.12221211E-12_JPRB, 0.12466937E-12_JPRB, &
  & 0.12757947E-12_JPRB, 0.13069408E-12_JPRB, 0.13365716E-12_JPRB, 0.13610716E-12_JPRB, 0.13777864E-12_JPRB, 0.13845128E-12_JPRB, &
  & 0.13807481E-12_JPRB, 0.13704909E-12_JPRB, 0.12683622E-12_JPRB, 0.12284191E-12_JPRB, 0.11895948E-12_JPRB, 0.11553726E-12_JPRB, &
  & 0.11300359E-12_JPRB, 0.11149524E-12_JPRB, 0.11093275E-12_JPRB, 0.11107483E-12_JPRB, 0.11162538E-12_JPRB, 0.11232103E-12_JPRB, &
  & 0.11296366E-12_JPRB, 0.11348392E-12_JPRB, 0.11405034E-12_JPRB, 0.11442399E-12_JPRB, 0.10659312E-12_JPRB, 0.10469005E-12_JPRB, &
  & 0.10273892E-12_JPRB, 0.10074267E-12_JPRB, 0.98344069E-13_JPRB, 0.95648654E-13_JPRB, 0.92292330E-13_JPRB, 0.79909535E-13_JPRB, &
  & 0.69831842E-13_JPRB, 0.57733745E-13_JPRB, 0.32556060E-13_JPRB, 0.20967306E-13_JPRB, 0.13699541E-13_JPRB, 0.12440320E-13_JPRB, &
  & 0.15951907E-13_JPRB, 0.97774655E-09_JPRB, 0.97506525E-09_JPRB, 0.97830621E-09_JPRB /)

RGHG4(:, 2, 2) = (/ &
  & 0.80157414E-12_JPRB, 0.61626209E-12_JPRB, 0.57729949E-12_JPRB, 0.58988198E-12_JPRB, 0.61258675E-12_JPRB, 0.64522487E-12_JPRB, &
  & 0.67267210E-12_JPRB, 0.69853227E-12_JPRB, 0.71292706E-12_JPRB, 0.73513976E-12_JPRB, 0.75645149E-12_JPRB, 0.78627773E-12_JPRB, &
  & 0.82707571E-12_JPRB, 0.89268035E-12_JPRB, 0.95999478E-12_JPRB, 0.10349843E-11_JPRB, 0.10921351E-11_JPRB, 0.11267331E-11_JPRB, &
  & 0.11158321E-11_JPRB, 0.10668462E-11_JPRB, 0.10257317E-11_JPRB, 0.96876045E-12_JPRB, 0.91207445E-12_JPRB, 0.85763715E-12_JPRB, &
  & 0.80808770E-12_JPRB, 0.76211644E-12_JPRB, 0.71894536E-12_JPRB, 0.68052925E-12_JPRB, 0.64972436E-12_JPRB, 0.62641949E-12_JPRB, &
  & 0.60846044E-12_JPRB, 0.59266090E-12_JPRB, 0.57667347E-12_JPRB, 0.55099095E-12_JPRB, 0.54105884E-12_JPRB, 0.53432551E-12_JPRB, &
  & 0.53341717E-12_JPRB, 0.54016150E-12_JPRB, 0.55497962E-12_JPRB, 0.56983194E-12_JPRB, 0.57513548E-12_JPRB, 0.56774577E-12_JPRB, &
  & 0.54728569E-12_JPRB, 0.51589110E-12_JPRB, 0.47591309E-12_JPRB, 0.42882337E-12_JPRB, 0.38187707E-12_JPRB, 0.34119059E-12_JPRB, &
  & 0.31507005E-12_JPRB, 0.29856914E-12_JPRB, 0.28414800E-12_JPRB, 0.26619852E-12_JPRB, 0.24414395E-12_JPRB, 0.22179708E-12_JPRB, &
  & 0.20236948E-12_JPRB, 0.18806156E-12_JPRB, 0.15093699E-12_JPRB, 0.14976513E-12_JPRB, 0.14966705E-12_JPRB, 0.15103611E-12_JPRB, &
  & 0.19903331E-12_JPRB, 0.10032114E-19_JPRB, 0.10028673E-19_JPRB, 0.10026674E-19_JPRB /)

RGHG4(:, 3, 2) = (/ &
  & 0.18702589E-11_JPRB, 0.14486121E-11_JPRB, 0.13110229E-11_JPRB, 0.12414958E-11_JPRB, 0.12098512E-11_JPRB, 0.12039331E-11_JPRB, &
  & 0.12170745E-11_JPRB, 0.12600389E-11_JPRB, 0.13439745E-11_JPRB, 0.14105567E-11_JPRB, 0.14796346E-11_JPRB, 0.15526414E-11_JPRB, &
  & 0.16528598E-11_JPRB, 0.17698291E-11_JPRB, 0.18835736E-11_JPRB, 0.19814595E-11_JPRB, 0.20508855E-11_JPRB, 0.20708082E-11_JPRB, &
  & 0.20240706E-11_JPRB, 0.19541458E-11_JPRB, 0.18801514E-11_JPRB, 0.17971355E-11_JPRB, 0.17181912E-11_JPRB, 0.16374839E-11_JPRB, &
  & 0.15701557E-11_JPRB, 0.15085648E-11_JPRB, 0.14544697E-11_JPRB, 0.14061154E-11_JPRB, 0.13623030E-11_JPRB, 0.13218660E-11_JPRB, &
  & 0.12801746E-11_JPRB, 0.12363271E-11_JPRB, 0.12004765E-11_JPRB, 0.11547985E-11_JPRB, 0.11371805E-11_JPRB, 0.11282888E-11_JPRB, &
  & 0.11390418E-11_JPRB, 0.11694217E-11_JPRB, 0.12175750E-11_JPRB, 0.12612919E-11_JPRB, 0.12785828E-11_JPRB, 0.12619104E-11_JPRB, &
  & 0.12108340E-11_JPRB, 0.11349507E-11_JPRB, 0.10400038E-11_JPRB, 0.93352995E-12_JPRB, 0.82677924E-12_JPRB, 0.72931288E-12_JPRB, &
  & 0.64684504E-12_JPRB, 0.57327304E-12_JPRB, 0.51035250E-12_JPRB, 0.46349236E-12_JPRB, 0.43305523E-12_JPRB, 0.41384179E-12_JPRB, &
  & 0.40174496E-12_JPRB, 0.39622464E-12_JPRB, 0.36399434E-12_JPRB, 0.37051999E-12_JPRB, 0.37599893E-12_JPRB, 0.38885144E-12_JPRB, &
  & 0.81730732E-12_JPRB, 0.55978273E-20_JPRB, 0.55966354E-20_JPRB, 0.55958037E-20_JPRB /)

RGHG4(:, 4, 2) = (/ &
  & 0.44974766E-11_JPRB, 0.38116207E-11_JPRB, 0.35333904E-11_JPRB, 0.33943313E-11_JPRB, 0.33233002E-11_JPRB, 0.32910189E-11_JPRB, &
  & 0.32833083E-11_JPRB, 0.33191930E-11_JPRB, 0.33946030E-11_JPRB, 0.34893568E-11_JPRB, 0.35933446E-11_JPRB, 0.37016488E-11_JPRB, &
  & 0.38363583E-11_JPRB, 0.39776737E-11_JPRB, 0.41015919E-11_JPRB, 0.41829504E-11_JPRB, 0.42226014E-11_JPRB, 0.41999121E-11_JPRB, &
  & 0.40913458E-11_JPRB, 0.39763336E-11_JPRB, 0.38660303E-11_JPRB, 0.37543991E-11_JPRB, 0.36492875E-11_JPRB, 0.35616403E-11_JPRB, &
  & 0.34990424E-11_JPRB, 0.34543852E-11_JPRB, 0.34252844E-11_JPRB, 0.33899613E-11_JPRB, 0.33479693E-11_JPRB, 0.32901021E-11_JPRB, &
  & 0.32178693E-11_JPRB, 0.31326530E-11_JPRB, 0.30714300E-11_JPRB, 0.29894197E-11_JPRB, 0.29560610E-11_JPRB, 0.29581765E-11_JPRB, &
  & 0.30103470E-11_JPRB, 0.30984904E-11_JPRB, 0.32174096E-11_JPRB, 0.33247185E-11_JPRB, 0.33734586E-11_JPRB, 0.33333976E-11_JPRB, &
  & 0.31976750E-11_JPRB, 0.29945133E-11_JPRB, 0.27497490E-11_JPRB, 0.24872053E-11_JPRB, 0.22337794E-11_JPRB, 0.20049312E-11_JPRB, &
  & 0.18054119E-11_JPRB, 0.16299483E-11_JPRB, 0.14850884E-11_JPRB, 0.13680540E-11_JPRB, 0.12674138E-11_JPRB, 0.11851780E-11_JPRB, &
  & 0.11254070E-11_JPRB, 0.10875812E-11_JPRB, 0.94610094E-12_JPRB, 0.94655598E-12_JPRB, 0.95950916E-12_JPRB, 0.10973474E-11_JPRB, &
  & 0.28696661E-11_JPRB, 0.32583834E-20_JPRB, 0.34017394E-11_JPRB, 0.83215372E-10_JPRB /)

RGHG4(:, 5, 2) = (/ &
  & 0.11518405E-10_JPRB, 0.99491110E-11_JPRB, 0.92545520E-11_JPRB, 0.90004341E-11_JPRB, 0.89366058E-11_JPRB, 0.89310850E-11_JPRB, &
  & 0.89727071E-11_JPRB, 0.90771782E-11_JPRB, 0.92195626E-11_JPRB, 0.94325927E-11_JPRB, 0.96394203E-11_JPRB, 0.98259265E-11_JPRB, &
  & 0.10013168E-10_JPRB, 0.10185673E-10_JPRB, 0.10307937E-10_JPRB, 0.10353946E-10_JPRB, 0.10342159E-10_JPRB, 0.10252467E-10_JPRB, &
  & 0.10073333E-10_JPRB, 0.99304974E-11_JPRB, 0.98232594E-11_JPRB, 0.97560215E-11_JPRB, 0.97334571E-11_JPRB, 0.97752605E-11_JPRB, &
  & 0.98763515E-11_JPRB, 0.10006412E-10_JPRB, 0.10134792E-10_JPRB, 0.10225073E-10_JPRB, 0.10252072E-10_JPRB, 0.10206438E-10_JPRB, &
  & 0.10083660E-10_JPRB, 0.98992056E-11_JPRB, 0.97551784E-11_JPRB, 0.95748990E-11_JPRB, 0.95078789E-11_JPRB, 0.95314095E-11_JPRB, &
  & 0.96544118E-11_JPRB, 0.98220598E-11_JPRB, 0.99974326E-11_JPRB, 0.10084022E-10_JPRB, 0.99842556E-11_JPRB, 0.96494731E-11_JPRB, &
  & 0.91038618E-11_JPRB, 0.84407871E-11_JPRB, 0.77392797E-11_JPRB, 0.70490584E-11_JPRB, 0.64063832E-11_JPRB, 0.58225308E-11_JPRB, &
  & 0.52998842E-11_JPRB, 0.48269179E-11_JPRB, 0.44071769E-11_JPRB, 0.40380073E-11_JPRB, 0.37213670E-11_JPRB, 0.34720263E-11_JPRB, &
  & 0.32891745E-11_JPRB, 0.31631520E-11_JPRB, 0.29214433E-11_JPRB, 0.29351339E-11_JPRB, 0.30582208E-11_JPRB, 0.39795038E-11_JPRB, &
  & 0.85717284E-11_JPRB, 0.16572773E-08_JPRB, 0.16606729E-08_JPRB, 0.16703975E-08_JPRB /)

RGHG4(:, 6, 2) = (/ &
  & 0.32745400E-10_JPRB, 0.28126371E-10_JPRB, 0.25678753E-10_JPRB, 0.24816997E-10_JPRB, 0.24720203E-10_JPRB, 0.24715842E-10_JPRB, &
  & 0.24813195E-10_JPRB, 0.25015618E-10_JPRB, 0.25272385E-10_JPRB, 0.25623451E-10_JPRB, 0.25939487E-10_JPRB, 0.26198236E-10_JPRB, &
  & 0.26391637E-10_JPRB, 0.26541356E-10_JPRB, 0.26564716E-10_JPRB, 0.26470055E-10_JPRB, 0.26311456E-10_JPRB, 0.26092415E-10_JPRB, &
  & 0.25852383E-10_JPRB, 0.25725746E-10_JPRB, 0.25761232E-10_JPRB, 0.25907035E-10_JPRB, 0.26181614E-10_JPRB, 0.26584613E-10_JPRB, &
  & 0.27085818E-10_JPRB, 0.27621985E-10_JPRB, 0.28139879E-10_JPRB, 0.28605531E-10_JPRB, 0.28969624E-10_JPRB, 0.29210970E-10_JPRB, &
  & 0.29308764E-10_JPRB, 0.29268157E-10_JPRB, 0.29270489E-10_JPRB, 0.29111821E-10_JPRB, 0.29004710E-10_JPRB, 0.28951036E-10_JPRB, &
  & 0.28931319E-10_JPRB, 0.28879338E-10_JPRB, 0.28695098E-10_JPRB, 0.28217999E-10_JPRB, 0.27292326E-10_JPRB, 0.25908400E-10_JPRB, &
  & 0.24242471E-10_JPRB, 0.22531093E-10_JPRB, 0.20902960E-10_JPRB, 0.19381998E-10_JPRB, 0.17980130E-10_JPRB, 0.16667598E-10_JPRB, &
  & 0.15436477E-10_JPRB, 0.14292974E-10_JPRB, 0.13224297E-10_JPRB, 0.12229757E-10_JPRB, 0.11340744E-10_JPRB, 0.10612702E-10_JPRB, &
  & 0.10082260E-10_JPRB, 0.97611919E-11_JPRB, 0.95032177E-11_JPRB, 0.96822749E-11_JPRB, 0.10420803E-10_JPRB, 0.14064019E-10_JPRB, &
  & 0.22764632E-10_JPRB, 0.32071814E-08_JPRB, 0.31989733E-08_JPRB, 0.31615184E-08_JPRB /)

RGHG4(:, 7, 2) = (/ &
  & 0.98674298E-10_JPRB, 0.83407316E-10_JPRB, 0.74396843E-10_JPRB, 0.70499835E-10_JPRB, 0.69677722E-10_JPRB, 0.69244388E-10_JPRB, &
  & 0.69132727E-10_JPRB, 0.69294369E-10_JPRB, 0.69664031E-10_JPRB, 0.70265620E-10_JPRB, 0.70763985E-10_JPRB, 0.71140559E-10_JPRB, &
  & 0.71312817E-10_JPRB, 0.71401697E-10_JPRB, 0.71150433E-10_JPRB, 0.70657966E-10_JPRB, 0.70055267E-10_JPRB, 0.69427387E-10_JPRB, &
  & 0.68938098E-10_JPRB, 0.68715811E-10_JPRB, 0.68979392E-10_JPRB, 0.69466342E-10_JPRB, 0.70235852E-10_JPRB, 0.71267214E-10_JPRB, &
  & 0.72487433E-10_JPRB, 0.73787358E-10_JPRB, 0.75112090E-10_JPRB, 0.76408879E-10_JPRB, 0.77640602E-10_JPRB, 0.78757251E-10_JPRB, &
  & 0.79667252E-10_JPRB, 0.80348665E-10_JPRB, 0.81041333E-10_JPRB, 0.81159107E-10_JPRB, 0.80890510E-10_JPRB, 0.80440064E-10_JPRB, &
  & 0.79638435E-10_JPRB, 0.78515007E-10_JPRB, 0.76837349E-10_JPRB, 0.74401450E-10_JPRB, 0.70978175E-10_JPRB, 0.66737366E-10_JPRB, &
  & 0.62209855E-10_JPRB, 0.57944070E-10_JPRB, 0.54181281E-10_JPRB, 0.50890108E-10_JPRB, 0.47995684E-10_JPRB, 0.45342629E-10_JPRB, &
  & 0.42839829E-10_JPRB, 0.40453769E-10_JPRB, 0.38127768E-10_JPRB, 0.35966823E-10_JPRB, 0.34081748E-10_JPRB, 0.32539381E-10_JPRB, &
  & 0.31488780E-10_JPRB, 0.31156019E-10_JPRB, 0.31797565E-10_JPRB, 0.33702409E-10_JPRB, 0.37555598E-10_JPRB, 0.47369265E-10_JPRB, &
  & 0.59532060E-10_JPRB, 0.49312776E-08_JPRB, 0.48616373E-08_JPRB, 0.47824544E-08_JPRB /)

RGHG4(:, 8, 2) = (/ &
  & 0.27385899E-09_JPRB, 0.23944347E-09_JPRB, 0.21428501E-09_JPRB, 0.20086977E-09_JPRB, 0.19687028E-09_JPRB, 0.19425657E-09_JPRB, &
  & 0.19259803E-09_JPRB, 0.19172401E-09_JPRB, 0.19147421E-09_JPRB, 0.19182744E-09_JPRB, 0.19201433E-09_JPRB, 0.19216810E-09_JPRB, &
  & 0.19196546E-09_JPRB, 0.19179748E-09_JPRB, 0.19085329E-09_JPRB, 0.18951769E-09_JPRB, 0.18800794E-09_JPRB, 0.18652976E-09_JPRB, &
  & 0.18547268E-09_JPRB, 0.18481323E-09_JPRB, 0.18511229E-09_JPRB, 0.18551809E-09_JPRB, 0.18622752E-09_JPRB, 0.18738142E-09_JPRB, &
  & 0.18888757E-09_JPRB, 0.19066296E-09_JPRB, 0.19273905E-09_JPRB, 0.19497901E-09_JPRB, 0.19736181E-09_JPRB, 0.19976470E-09_JPRB, &
  & 0.20183542E-09_JPRB, 0.20359195E-09_JPRB, 0.20545853E-09_JPRB, 0.20580865E-09_JPRB, 0.20471765E-09_JPRB, 0.20307550E-09_JPRB, &
  & 0.20030215E-09_JPRB, 0.19672323E-09_JPRB, 0.19177188E-09_JPRB, 0.18521774E-09_JPRB, 0.17664634E-09_JPRB, 0.16659370E-09_JPRB, &
  & 0.15632959E-09_JPRB, 0.14709053E-09_JPRB, 0.13923419E-09_JPRB, 0.13252792E-09_JPRB, 0.12654870E-09_JPRB, 0.12102591E-09_JPRB, &
  & 0.11585580E-09_JPRB, 0.11098066E-09_JPRB, 0.10637041E-09_JPRB, 0.10212412E-09_JPRB, 0.98302512E-10_JPRB, 0.95279236E-10_JPRB, &
  & 0.93784723E-10_JPRB, 0.94488556E-10_JPRB, 0.98129685E-10_JPRB, 0.10485087E-09_JPRB, 0.11505442E-09_JPRB, 0.13101149E-09_JPRB, &
  & 0.14461980E-09_JPRB, 0.65744916E-08_JPRB, 0.64309638E-08_JPRB, 0.62020624E-08_JPRB /)

RGHG4(:, 9, 2) = (/ &
  & 0.66240657E-09_JPRB, 0.59847666E-09_JPRB, 0.55080740E-09_JPRB, 0.52053062E-09_JPRB, 0.50824916E-09_JPRB, 0.49905541E-09_JPRB, &
  & 0.49212334E-09_JPRB, 0.48685844E-09_JPRB, 0.48312432E-09_JPRB, 0.48096060E-09_JPRB, 0.47879312E-09_JPRB, 0.47724724E-09_JPRB, &
  & 0.47538723E-09_JPRB, 0.47433285E-09_JPRB, 0.47188886E-09_JPRB, 0.46884235E-09_JPRB, 0.46556031E-09_JPRB, 0.46244283E-09_JPRB, &
  & 0.46020124E-09_JPRB, 0.45832349E-09_JPRB, 0.45800413E-09_JPRB, 0.45725379E-09_JPRB, 0.45641027E-09_JPRB, 0.45612025E-09_JPRB, &
  & 0.45632959E-09_JPRB, 0.45716095E-09_JPRB, 0.45882728E-09_JPRB, 0.46096579E-09_JPRB, 0.46372250E-09_JPRB, 0.46666393E-09_JPRB, &
  & 0.46896864E-09_JPRB, 0.47090076E-09_JPRB, 0.47350257E-09_JPRB, 0.47283416E-09_JPRB, 0.46897303E-09_JPRB, 0.46432116E-09_JPRB, &
  & 0.45738410E-09_JPRB, 0.44913651E-09_JPRB, 0.43844758E-09_JPRB, 0.42491569E-09_JPRB, 0.40767403E-09_JPRB, 0.38769035E-09_JPRB, &
  & 0.36738360E-09_JPRB, 0.34935727E-09_JPRB, 0.33455902E-09_JPRB, 0.32239753E-09_JPRB, 0.31207911E-09_JPRB, 0.30294098E-09_JPRB, &
  & 0.29455449E-09_JPRB, 0.28641661E-09_JPRB, 0.27848507E-09_JPRB, 0.27101266E-09_JPRB, 0.26462696E-09_JPRB, 0.26014152E-09_JPRB, &
  & 0.25829092E-09_JPRB, 0.25970687E-09_JPRB, 0.26501604E-09_JPRB, 0.27274227E-09_JPRB, 0.28186356E-09_JPRB, 0.29324174E-09_JPRB, &
  & 0.30014818E-09_JPRB, 0.79254887E-08_JPRB, 0.76869835E-08_JPRB, 0.74065012E-08_JPRB /)

RGHG4(:,10, 2) = (/ &
  & 0.13236329E-08_JPRB, 0.12501553E-08_JPRB, 0.11923188E-08_JPRB, 0.11521606E-08_JPRB, 0.11328785E-08_JPRB, 0.11156939E-08_JPRB, &
  & 0.11006589E-08_JPRB, 0.10872842E-08_JPRB, 0.10766719E-08_JPRB, 0.10686220E-08_JPRB, 0.10612440E-08_JPRB, 0.10563266E-08_JPRB, &
  & 0.10514277E-08_JPRB, 0.10489218E-08_JPRB, 0.10445637E-08_JPRB, 0.10396328E-08_JPRB, 0.10344108E-08_JPRB, 0.10295340E-08_JPRB, &
  & 0.10262207E-08_JPRB, 0.10225759E-08_JPRB, 0.10209384E-08_JPRB, 0.10174471E-08_JPRB, 0.10130882E-08_JPRB, 0.10087284E-08_JPRB, &
  & 0.10051294E-08_JPRB, 0.10024436E-08_JPRB, 0.10010716E-08_JPRB, 0.10002825E-08_JPRB, 0.10003834E-08_JPRB, 0.10006544E-08_JPRB, &
  & 0.99950848E-09_JPRB, 0.99791464E-09_JPRB, 0.99841269E-09_JPRB, 0.99258601E-09_JPRB, 0.98096808E-09_JPRB, 0.96911945E-09_JPRB, &
  & 0.95444008E-09_JPRB, 0.93833119E-09_JPRB, 0.91851948E-09_JPRB, 0.89463992E-09_JPRB, 0.86445101E-09_JPRB, 0.82889773E-09_JPRB, &
  & 0.79202478E-09_JPRB, 0.75969808E-09_JPRB, 0.73421058E-09_JPRB, 0.71427536E-09_JPRB, 0.69805900E-09_JPRB, 0.68356820E-09_JPRB, &
  & 0.66989203E-09_JPRB, 0.65663247E-09_JPRB, 0.64357508E-09_JPRB, 0.63046734E-09_JPRB, 0.61722216E-09_JPRB, 0.60370914E-09_JPRB, &
  & 0.59032224E-09_JPRB, 0.57774069E-09_JPRB, 0.56546912E-09_JPRB, 0.55192634E-09_JPRB, 0.53828597E-09_JPRB, 0.53103022E-09_JPRB, &
  & 0.52596377E-09_JPRB, 0.87064018E-08_JPRB, 0.83612148E-08_JPRB, 0.79756388E-08_JPRB /)

RGHG4(:,11, 2) = (/ &
  & 0.21561526E-08_JPRB, 0.21176800E-08_JPRB, 0.20939079E-08_JPRB, 0.20870767E-08_JPRB, 0.20867552E-08_JPRB, 0.20800279E-08_JPRB, &
  & 0.20707180E-08_JPRB, 0.20595408E-08_JPRB, 0.20506283E-08_JPRB, 0.20431239E-08_JPRB, 0.20357673E-08_JPRB, 0.20322586E-08_JPRB, &
  & 0.20276172E-08_JPRB, 0.20259230E-08_JPRB, 0.20213460E-08_JPRB, 0.20154629E-08_JPRB, 0.20090158E-08_JPRB, 0.20028046E-08_JPRB, &
  & 0.19996047E-08_JPRB, 0.19939645E-08_JPRB, 0.19910549E-08_JPRB, 0.19842326E-08_JPRB, 0.19761142E-08_JPRB, 0.19669248E-08_JPRB, &
  & 0.19575646E-08_JPRB, 0.19489528E-08_JPRB, 0.19409148E-08_JPRB, 0.19324971E-08_JPRB, 0.19240418E-08_JPRB, 0.19155679E-08_JPRB, &
  & 0.19049460E-08_JPRB, 0.18946353E-08_JPRB, 0.18890949E-08_JPRB, 0.18734181E-08_JPRB, 0.18483258E-08_JPRB, 0.18217289E-08_JPRB, &
  & 0.17913032E-08_JPRB, 0.17611588E-08_JPRB, 0.17258941E-08_JPRB, 0.16851331E-08_JPRB, 0.16355247E-08_JPRB, 0.15779978E-08_JPRB, &
  & 0.15173202E-08_JPRB, 0.14626641E-08_JPRB, 0.14187185E-08_JPRB, 0.13834784E-08_JPRB, 0.13546564E-08_JPRB, 0.13278014E-08_JPRB, &
  & 0.13016699E-08_JPRB, 0.12745133E-08_JPRB, 0.12444046E-08_JPRB, 0.12099931E-08_JPRB, 0.11705562E-08_JPRB, 0.11255983E-08_JPRB, &
  & 0.10742121E-08_JPRB, 0.10169264E-08_JPRB, 0.95741337E-09_JPRB, 0.89815327E-09_JPRB, 0.84847873E-09_JPRB, 0.80854873E-09_JPRB, &
  & 0.78826828E-09_JPRB, 0.88197716E-08_JPRB, 0.83781293E-08_JPRB, 0.79264506E-08_JPRB /)

RGHG4(:,12, 2) = (/ &
  & 0.30332852E-08_JPRB, 0.30333063E-08_JPRB, 0.30857090E-08_JPRB, 0.31655256E-08_JPRB, 0.32343710E-08_JPRB, 0.32821288E-08_JPRB, &
  & 0.33154557E-08_JPRB, 0.33357201E-08_JPRB, 0.33518845E-08_JPRB, 0.33610066E-08_JPRB, 0.33662144E-08_JPRB, 0.33740077E-08_JPRB, &
  & 0.33759364E-08_JPRB, 0.33779617E-08_JPRB, 0.33756591E-08_JPRB, 0.33698020E-08_JPRB, 0.33619181E-08_JPRB, 0.33534806E-08_JPRB, &
  & 0.33490897E-08_JPRB, 0.33388796E-08_JPRB, 0.33297807E-08_JPRB, 0.33162453E-08_JPRB, 0.33004297E-08_JPRB, 0.32839496E-08_JPRB, &
  & 0.32665262E-08_JPRB, 0.32491272E-08_JPRB, 0.32323877E-08_JPRB, 0.32143417E-08_JPRB, 0.31955982E-08_JPRB, 0.31772163E-08_JPRB, &
  & 0.31567047E-08_JPRB, 0.31372225E-08_JPRB, 0.31243159E-08_JPRB, 0.30965672E-08_JPRB, 0.30565466E-08_JPRB, 0.30135026E-08_JPRB, &
  & 0.29640452E-08_JPRB, 0.29132976E-08_JPRB, 0.28604195E-08_JPRB, 0.28009197E-08_JPRB, 0.27296854E-08_JPRB, 0.26460389E-08_JPRB, &
  & 0.25544471E-08_JPRB, 0.24644531E-08_JPRB, 0.23841709E-08_JPRB, 0.23138733E-08_JPRB, 0.22516242E-08_JPRB, 0.21899971E-08_JPRB, &
  & 0.21265070E-08_JPRB, 0.20584434E-08_JPRB, 0.19838888E-08_JPRB, 0.19006601E-08_JPRB, 0.18064537E-08_JPRB, 0.17007845E-08_JPRB, &
  & 0.15832252E-08_JPRB, 0.14606639E-08_JPRB, 0.13410648E-08_JPRB, 0.12329384E-08_JPRB, 0.11380309E-08_JPRB, 0.10666509E-08_JPRB, &
  & 0.10301819E-08_JPRB, 0.83340579E-08_JPRB, 0.78297440E-08_JPRB, 0.73634197E-08_JPRB /)

RGHG4(:,13, 2) = (/ &
  & 0.37838412E-08_JPRB, 0.38248857E-08_JPRB, 0.39513561E-08_JPRB, 0.41188688E-08_JPRB, 0.42704262E-08_JPRB, 0.43952597E-08_JPRB, &
  & 0.44971427E-08_JPRB, 0.45760076E-08_JPRB, 0.46432485E-08_JPRB, 0.46924886E-08_JPRB, 0.47308562E-08_JPRB, 0.47666768E-08_JPRB, &
  & 0.47880691E-08_JPRB, 0.48017150E-08_JPRB, 0.48072750E-08_JPRB, 0.48051345E-08_JPRB, 0.47970738E-08_JPRB, 0.47867470E-08_JPRB, &
  & 0.47788595E-08_JPRB, 0.47616031E-08_JPRB, 0.47424193E-08_JPRB, 0.47198307E-08_JPRB, 0.46966617E-08_JPRB, 0.46732995E-08_JPRB, &
  & 0.46502304E-08_JPRB, 0.46274331E-08_JPRB, 0.46057953E-08_JPRB, 0.45851203E-08_JPRB, 0.45639021E-08_JPRB, 0.45454844E-08_JPRB, &
  & 0.45261528E-08_JPRB, 0.45078377E-08_JPRB, 0.44955919E-08_JPRB, 0.44641846E-08_JPRB, 0.44158899E-08_JPRB, 0.43598885E-08_JPRB, &
  & 0.43005879E-08_JPRB, 0.42392938E-08_JPRB, 0.41746016E-08_JPRB, 0.41019770E-08_JPRB, 0.40173549E-08_JPRB, 0.39168668E-08_JPRB, &
  & 0.38002348E-08_JPRB, 0.36713048E-08_JPRB, 0.35389671E-08_JPRB, 0.34086756E-08_JPRB, 0.32835799E-08_JPRB, 0.31556611E-08_JPRB, &
  & 0.30244240E-08_JPRB, 0.28877341E-08_JPRB, 0.27423233E-08_JPRB, 0.25852613E-08_JPRB, 0.24157478E-08_JPRB, 0.22361670E-08_JPRB, &
  & 0.20481099E-08_JPRB, 0.18604444E-08_JPRB, 0.16840205E-08_JPRB, 0.15223032E-08_JPRB, 0.13865298E-08_JPRB, 0.12722532E-08_JPRB, &
  & 0.12387864E-08_JPRB, 0.74181705E-08_JPRB, 0.68600903E-08_JPRB, 0.63767178E-08_JPRB /)

RGHG4(:,14, 2) = (/ &
  & 0.43202188E-08_JPRB, 0.43725161E-08_JPRB, 0.45414876E-08_JPRB, 0.47628439E-08_JPRB, 0.49740962E-08_JPRB, 0.51639488E-08_JPRB, &
  & 0.53308518E-08_JPRB, 0.54702252E-08_JPRB, 0.55940554E-08_JPRB, 0.56920273E-08_JPRB, 0.57729248E-08_JPRB, 0.58449894E-08_JPRB, &
  & 0.58933431E-08_JPRB, 0.59245124E-08_JPRB, 0.59412861E-08_JPRB, 0.59436438E-08_JPRB, 0.59340386E-08_JPRB, 0.59182970E-08_JPRB, &
  & 0.59017262E-08_JPRB, 0.58729590E-08_JPRB, 0.58395586E-08_JPRB, 0.58056946E-08_JPRB, 0.57752216E-08_JPRB, 0.57471592E-08_JPRB, &
  & 0.57221476E-08_JPRB, 0.57008638E-08_JPRB, 0.56843792E-08_JPRB, 0.56745488E-08_JPRB, 0.56680856E-08_JPRB, 0.56689253E-08_JPRB, &
  & 0.56717524E-08_JPRB, 0.56751270E-08_JPRB, 0.56831344E-08_JPRB, 0.56699081E-08_JPRB, 0.56391887E-08_JPRB, 0.55955462E-08_JPRB, &
  & 0.55448579E-08_JPRB, 0.54879616E-08_JPRB, 0.54275975E-08_JPRB, 0.53575020E-08_JPRB, 0.52735274E-08_JPRB, 0.51689706E-08_JPRB, &
  & 0.50397349E-08_JPRB, 0.48838644E-08_JPRB, 0.47070854E-08_JPRB, 0.45189896E-08_JPRB, 0.43276827E-08_JPRB, 0.41251047E-08_JPRB, &
  & 0.39135761E-08_JPRB, 0.36923695E-08_JPRB, 0.34606380E-08_JPRB, 0.32176852E-08_JPRB, 0.29650611E-08_JPRB, 0.27075759E-08_JPRB, &
  & 0.24491114E-08_JPRB, 0.22008602E-08_JPRB, 0.19714312E-08_JPRB, 0.17628317E-08_JPRB, 0.15747396E-08_JPRB, 0.14209581E-08_JPRB, &
  & 0.13625431E-08_JPRB, 0.64076913E-08_JPRB, 0.57888734E-08_JPRB, 0.52925033E-08_JPRB /)

RGHG4(:,15, 2) = (/ &
  & 0.46561435E-08_JPRB, 0.46983004E-08_JPRB, 0.48757323E-08_JPRB, 0.51028226E-08_JPRB, 0.53297065E-08_JPRB, 0.55477321E-08_JPRB, &
  & 0.57501870E-08_JPRB, 0.59266840E-08_JPRB, 0.60878924E-08_JPRB, 0.62196248E-08_JPRB, 0.63304513E-08_JPRB, 0.64273622E-08_JPRB, &
  & 0.64926109E-08_JPRB, 0.65322658E-08_JPRB, 0.65505739E-08_JPRB, 0.65476082E-08_JPRB, 0.65269505E-08_JPRB, 0.64942403E-08_JPRB, &
  & 0.64593726E-08_JPRB, 0.64101906E-08_JPRB, 0.63552315E-08_JPRB, 0.63062391E-08_JPRB, 0.62662004E-08_JPRB, 0.62364029E-08_JPRB, &
  & 0.62166881E-08_JPRB, 0.62082761E-08_JPRB, 0.62137939E-08_JPRB, 0.62358501E-08_JPRB, 0.62702838E-08_JPRB, 0.63177037E-08_JPRB, &
  & 0.63683303E-08_JPRB, 0.64159185E-08_JPRB, 0.64609980E-08_JPRB, 0.64777739E-08_JPRB, 0.64766241E-08_JPRB, 0.64584276E-08_JPRB, &
  & 0.64221704E-08_JPRB, 0.63709007E-08_JPRB, 0.63077912E-08_JPRB, 0.62317778E-08_JPRB, 0.61390066E-08_JPRB, 0.60238237E-08_JPRB, &
  & 0.58818381E-08_JPRB, 0.57128680E-08_JPRB, 0.55204734E-08_JPRB, 0.53117946E-08_JPRB, 0.50939390E-08_JPRB, 0.48570321E-08_JPRB, &
  & 0.46055812E-08_JPRB, 0.43385229E-08_JPRB, 0.40552268E-08_JPRB, 0.37551304E-08_JPRB, 0.34437930E-08_JPRB, 0.31304528E-08_JPRB, &
  & 0.28207696E-08_JPRB, 0.25264302E-08_JPRB, 0.22518285E-08_JPRB, 0.19941009E-08_JPRB, 0.17538460E-08_JPRB, 0.15363443E-08_JPRB, &
  & 0.14887579E-08_JPRB, 0.55912652E-08_JPRB, 0.49248809E-08_JPRB, 0.43628128E-08_JPRB /)

RGHG4(:,16, 2) = (/ &
  & 0.48464415E-08_JPRB, 0.48609707E-08_JPRB, 0.50137396E-08_JPRB, 0.52025189E-08_JPRB, 0.54036402E-08_JPRB, 0.56124838E-08_JPRB, &
  & 0.58153948E-08_JPRB, 0.59979515E-08_JPRB, 0.61680896E-08_JPRB, 0.63088055E-08_JPRB, 0.64272907E-08_JPRB, 0.65288814E-08_JPRB, &
  & 0.65942074E-08_JPRB, 0.66289072E-08_JPRB, 0.66373893E-08_JPRB, 0.66202328E-08_JPRB, 0.65819359E-08_JPRB, 0.65269217E-08_JPRB, &
  & 0.64714634E-08_JPRB, 0.63996120E-08_JPRB, 0.63276793E-08_JPRB, 0.62681917E-08_JPRB, 0.62248824E-08_JPRB, 0.62020158E-08_JPRB, &
  & 0.62013989E-08_JPRB, 0.62230230E-08_JPRB, 0.62676553E-08_JPRB, 0.63358687E-08_JPRB, 0.64233570E-08_JPRB, 0.65275261E-08_JPRB, &
  & 0.66298536E-08_JPRB, 0.67224386E-08_JPRB, 0.68084809E-08_JPRB, 0.68610988E-08_JPRB, 0.68794792E-08_JPRB, 0.68629125E-08_JPRB, &
  & 0.68161352E-08_JPRB, 0.67441217E-08_JPRB, 0.66540053E-08_JPRB, 0.65474315E-08_JPRB, 0.64249459E-08_JPRB, 0.62858247E-08_JPRB, &
  & 0.61293162E-08_JPRB, 0.59553846E-08_JPRB, 0.57669407E-08_JPRB, 0.55688285E-08_JPRB, 0.53640905E-08_JPRB, 0.51384523E-08_JPRB, &
  & 0.48951536E-08_JPRB, 0.46321520E-08_JPRB, 0.43494488E-08_JPRB, 0.40481596E-08_JPRB, 0.37348382E-08_JPRB, 0.34176988E-08_JPRB, &
  & 0.31023442E-08_JPRB, 0.27977065E-08_JPRB, 0.25064621E-08_JPRB, 0.22167392E-08_JPRB, 0.19297559E-08_JPRB, 0.16626541E-08_JPRB, &
  & 0.15783214E-08_JPRB, 0.50176405E-08_JPRB, 0.42682680E-08_JPRB, 0.36692076E-08_JPRB /)

RGHG4(:,17, 2) = (/ &
  & 0.48772812E-08_JPRB, 0.48499951E-08_JPRB, 0.49602313E-08_JPRB, 0.50792264E-08_JPRB, 0.52234084E-08_JPRB, 0.53883138E-08_JPRB, &
  & 0.55593343E-08_JPRB, 0.57145479E-08_JPRB, 0.58604201E-08_JPRB, 0.59788614E-08_JPRB, 0.60763923E-08_JPRB, 0.61572063E-08_JPRB, &
  & 0.62019248E-08_JPRB, 0.62155343E-08_JPRB, 0.62012031E-08_JPRB, 0.61615140E-08_JPRB, 0.61002878E-08_JPRB, 0.60233893E-08_JPRB, &
  & 0.59482246E-08_JPRB, 0.58610654E-08_JPRB, 0.57814180E-08_JPRB, 0.57214220E-08_JPRB, 0.56879301E-08_JPRB, 0.56856817E-08_JPRB, &
  & 0.57168759E-08_JPRB, 0.57798637E-08_JPRB, 0.58707896E-08_JPRB, 0.59882592E-08_JPRB, 0.61224767E-08_JPRB, 0.62603069E-08_JPRB, &
  & 0.64043055E-08_JPRB, 0.65269625E-08_JPRB, 0.66366188E-08_JPRB, 0.66950459E-08_JPRB, 0.67089934E-08_JPRB, 0.66741546E-08_JPRB, &
  & 0.65973822E-08_JPRB, 0.64854202E-08_JPRB, 0.63522076E-08_JPRB, 0.62110286E-08_JPRB, 0.60646377E-08_JPRB, 0.59104810E-08_JPRB, &
  & 0.57510383E-08_JPRB, 0.55915179E-08_JPRB, 0.54303513E-08_JPRB, 0.52668949E-08_JPRB, 0.51010098E-08_JPRB, 0.49179478E-08_JPRB, &
  & 0.47161755E-08_JPRB, 0.44953481E-08_JPRB, 0.42551305E-08_JPRB, 0.39968095E-08_JPRB, 0.37263921E-08_JPRB, 0.34513215E-08_JPRB, &
  & 0.31731215E-08_JPRB, 0.28956726E-08_JPRB, 0.26129048E-08_JPRB, 0.23111262E-08_JPRB, 0.19819060E-08_JPRB, 0.17200483E-08_JPRB, &
  & 0.16621943E-08_JPRB, 0.44099977E-08_JPRB, 0.36723347E-08_JPRB, 0.30692997E-08_JPRB /)

RGHG4(:,18, 2) = (/ &
  & 0.48224513E-08_JPRB, 0.47480628E-08_JPRB, 0.48071382E-08_JPRB, 0.48351412E-08_JPRB, 0.49018967E-08_JPRB, 0.50010232E-08_JPRB, &
  & 0.51134661E-08_JPRB, 0.52158229E-08_JPRB, 0.53115916E-08_JPRB, 0.53839431E-08_JPRB, 0.54384994E-08_JPRB, 0.54785554E-08_JPRB, &
  & 0.54865756E-08_JPRB, 0.54681397E-08_JPRB, 0.54243476E-08_JPRB, 0.53591669E-08_JPRB, 0.52766325E-08_JPRB, 0.51840607E-08_JPRB, &
  & 0.50983844E-08_JPRB, 0.50106292E-08_JPRB, 0.49380975E-08_JPRB, 0.48944568E-08_JPRB, 0.48864495E-08_JPRB, 0.49171982E-08_JPRB, &
  & 0.49861959E-08_JPRB, 0.50883435E-08_JPRB, 0.52167830E-08_JPRB, 0.53574669E-08_JPRB, 0.55116223E-08_JPRB, 0.56737162E-08_JPRB, &
  & 0.58120722E-08_JPRB, 0.59316911E-08_JPRB, 0.60317253E-08_JPRB, 0.60751644E-08_JPRB, 0.60613763E-08_JPRB, 0.59949650E-08_JPRB, &
  & 0.58824821E-08_JPRB, 0.57379927E-08_JPRB, 0.55781793E-08_JPRB, 0.54140927E-08_JPRB, 0.52579354E-08_JPRB, 0.51170344E-08_JPRB, &
  & 0.49880891E-08_JPRB, 0.48664122E-08_JPRB, 0.47474797E-08_JPRB, 0.46317052E-08_JPRB, 0.45163246E-08_JPRB, 0.43865476E-08_JPRB, &
  & 0.42395314E-08_JPRB, 0.40760049E-08_JPRB, 0.38943386E-08_JPRB, 0.36971646E-08_JPRB, 0.34884495E-08_JPRB, 0.32722782E-08_JPRB, &
  & 0.30473679E-08_JPRB, 0.28130125E-08_JPRB, 0.25608664E-08_JPRB, 0.22737372E-08_JPRB, 0.19679156E-08_JPRB, 0.17198690E-08_JPRB, &
  & 0.16278092E-08_JPRB, 0.37430725E-08_JPRB, 0.30266174E-08_JPRB, 0.24754157E-08_JPRB /)

RGHG4(:,19, 2) = (/ &
  & 0.46165871E-08_JPRB, 0.45304294E-08_JPRB, 0.45388759E-08_JPRB, 0.44785358E-08_JPRB, 0.44694488E-08_JPRB, 0.45026693E-08_JPRB, &
  & 0.45535966E-08_JPRB, 0.45960307E-08_JPRB, 0.46323643E-08_JPRB, 0.46496265E-08_JPRB, 0.46523958E-08_JPRB, 0.46441375E-08_JPRB, &
  & 0.46101971E-08_JPRB, 0.45574349E-08_JPRB, 0.44868451E-08_JPRB, 0.44021329E-08_JPRB, 0.43084158E-08_JPRB, 0.42129291E-08_JPRB, &
  & 0.41303903E-08_JPRB, 0.40540318E-08_JPRB, 0.39989057E-08_JPRB, 0.39785002E-08_JPRB, 0.39984931E-08_JPRB, 0.40600203E-08_JPRB, &
  & 0.41586024E-08_JPRB, 0.42855830E-08_JPRB, 0.44289976E-08_JPRB, 0.45829629E-08_JPRB, 0.47290367E-08_JPRB, 0.48518904E-08_JPRB, &
  & 0.49565769E-08_JPRB, 0.50365205E-08_JPRB, 0.50915254E-08_JPRB, 0.50907425E-08_JPRB, 0.50430131E-08_JPRB, 0.49482822E-08_JPRB, &
  & 0.48197748E-08_JPRB, 0.46720752E-08_JPRB, 0.45225614E-08_JPRB, 0.43827546E-08_JPRB, 0.42608477E-08_JPRB, 0.41559352E-08_JPRB, &
  & 0.40662020E-08_JPRB, 0.39884802E-08_JPRB, 0.39195016E-08_JPRB, 0.38547241E-08_JPRB, 0.37899808E-08_JPRB, 0.37129224E-08_JPRB, &
  & 0.36215535E-08_JPRB, 0.35152741E-08_JPRB, 0.33926353E-08_JPRB, 0.32554113E-08_JPRB, 0.31051055E-08_JPRB, 0.29433902E-08_JPRB, &
  & 0.27670297E-08_JPRB, 0.25699411E-08_JPRB, 0.23412339E-08_JPRB, 0.20679372E-08_JPRB, 0.18160299E-08_JPRB, 0.15925422E-08_JPRB, &
  & 0.15489087E-08_JPRB, 0.29758649E-08_JPRB, 0.23518596E-08_JPRB, 0.18964303E-08_JPRB /)

RGHG4(:,20, 2) = (/ &
  & 0.42332347E-08_JPRB, 0.42199293E-08_JPRB, 0.42051038E-08_JPRB, 0.40606198E-08_JPRB, 0.39786072E-08_JPRB, 0.39478585E-08_JPRB, &
  & 0.39414214E-08_JPRB, 0.39313903E-08_JPRB, 0.39148316E-08_JPRB, 0.38832546E-08_JPRB, 0.38406265E-08_JPRB, 0.37916430E-08_JPRB, &
  & 0.37243559E-08_JPRB, 0.36463046E-08_JPRB, 0.35589831E-08_JPRB, 0.34649168E-08_JPRB, 0.33695575E-08_JPRB, 0.32803920E-08_JPRB, &
  & 0.32097214E-08_JPRB, 0.31527885E-08_JPRB, 0.31206575E-08_JPRB, 0.31233616E-08_JPRB, 0.31643086E-08_JPRB, 0.32432053E-08_JPRB, &
  & 0.33528831E-08_JPRB, 0.34843128E-08_JPRB, 0.36235406E-08_JPRB, 0.37512349E-08_JPRB, 0.38516292E-08_JPRB, 0.39310688E-08_JPRB, &
  & 0.39790886E-08_JPRB, 0.39978358E-08_JPRB, 0.39891956E-08_JPRB, 0.39404404E-08_JPRB, 0.38596908E-08_JPRB, 0.37548813E-08_JPRB, &
  & 0.36326682E-08_JPRB, 0.35053651E-08_JPRB, 0.33877881E-08_JPRB, 0.32916763E-08_JPRB, 0.32181657E-08_JPRB, 0.31646463E-08_JPRB, &
  & 0.31273413E-08_JPRB, 0.31027934E-08_JPRB, 0.30837104E-08_JPRB, 0.30665861E-08_JPRB, 0.30470368E-08_JPRB, 0.30166230E-08_JPRB, &
  & 0.29727785E-08_JPRB, 0.29140161E-08_JPRB, 0.28383322E-08_JPRB, 0.27470448E-08_JPRB, 0.26399787E-08_JPRB, 0.25166831E-08_JPRB, &
  & 0.23731892E-08_JPRB, 0.22051796E-08_JPRB, 0.20036897E-08_JPRB, 0.17888320E-08_JPRB, 0.15807318E-08_JPRB, 0.13935221E-08_JPRB, &
  & 0.13660809E-08_JPRB, 0.22276960E-08_JPRB, 0.17550522E-08_JPRB, 0.13794278E-08_JPRB /)

RGHG4(:,21, 2) = (/ &
  & 0.39370911E-08_JPRB, 0.38484260E-08_JPRB, 0.38231920E-08_JPRB, 0.36297558E-08_JPRB, 0.34995575E-08_JPRB, 0.34192784E-08_JPRB, &
  & 0.33634056E-08_JPRB, 0.33107896E-08_JPRB, 0.32556937E-08_JPRB, 0.31898382E-08_JPRB, 0.31163141E-08_JPRB, 0.30402274E-08_JPRB, &
  & 0.29533513E-08_JPRB, 0.28615610E-08_JPRB, 0.27677869E-08_JPRB, 0.26749201E-08_JPRB, 0.25874289E-08_JPRB, 0.25105678E-08_JPRB, &
  & 0.24525726E-08_JPRB, 0.24092850E-08_JPRB, 0.23892677E-08_JPRB, 0.24015054E-08_JPRB, 0.24483644E-08_JPRB, 0.25285622E-08_JPRB, &
  & 0.26328799E-08_JPRB, 0.27508327E-08_JPRB, 0.28641520E-08_JPRB, 0.29567415E-08_JPRB, 0.30164873E-08_JPRB, 0.30347307E-08_JPRB, &
  & 0.30246874E-08_JPRB, 0.29863421E-08_JPRB, 0.29271479E-08_JPRB, 0.28481610E-08_JPRB, 0.27522722E-08_JPRB, 0.26478375E-08_JPRB, &
  & 0.25454763E-08_JPRB, 0.24571116E-08_JPRB, 0.23891136E-08_JPRB, 0.23439035E-08_JPRB, 0.23187303E-08_JPRB, 0.23097111E-08_JPRB, &
  & 0.23123310E-08_JPRB, 0.23224889E-08_JPRB, 0.23355928E-08_JPRB, 0.23482400E-08_JPRB, 0.23596964E-08_JPRB, 0.23628488E-08_JPRB, &
  & 0.23529600E-08_JPRB, 0.23302766E-08_JPRB, 0.22871811E-08_JPRB, 0.22217024E-08_JPRB, 0.21327697E-08_JPRB, 0.20209534E-08_JPRB, &
  & 0.18893900E-08_JPRB, 0.17346048E-08_JPRB, 0.15614604E-08_JPRB, 0.13967487E-08_JPRB, 0.12308555E-08_JPRB, 0.10803552E-08_JPRB, &
  & 0.10667479E-08_JPRB, 0.15241471E-08_JPRB, 0.11778970E-08_JPRB, 0.93082153E-09_JPRB /)

RGHG4(:,22, 2) = (/ &
  & 0.35486927E-08_JPRB, 0.33810352E-08_JPRB, 0.33580885E-08_JPRB, 0.31459371E-08_JPRB, 0.30008669E-08_JPRB, 0.29061045E-08_JPRB, &
  & 0.28304965E-08_JPRB, 0.27534444E-08_JPRB, 0.26766429E-08_JPRB, 0.25939020E-08_JPRB, 0.25066558E-08_JPRB, 0.24181221E-08_JPRB, &
  & 0.23251603E-08_JPRB, 0.22310300E-08_JPRB, 0.21390172E-08_JPRB, 0.20511397E-08_JPRB, 0.19708117E-08_JPRB, 0.19031432E-08_JPRB, &
  & 0.18538509E-08_JPRB, 0.18182919E-08_JPRB, 0.18007651E-08_JPRB, 0.18122300E-08_JPRB, 0.18531823E-08_JPRB, 0.19184567E-08_JPRB, &
  & 0.20037343E-08_JPRB, 0.20947570E-08_JPRB, 0.21795352E-08_JPRB, 0.22406594E-08_JPRB, 0.22709339E-08_JPRB, 0.22634312E-08_JPRB, &
  & 0.22240092E-08_JPRB, 0.21569742E-08_JPRB, 0.20794468E-08_JPRB, 0.19867572E-08_JPRB, 0.18939328E-08_JPRB, 0.18084058E-08_JPRB, &
  & 0.17364207E-08_JPRB, 0.16844737E-08_JPRB, 0.16551517E-08_JPRB, 0.16473090E-08_JPRB, 0.16562235E-08_JPRB, 0.16767963E-08_JPRB, &
  & 0.17049879E-08_JPRB, 0.17373684E-08_JPRB, 0.17692483E-08_JPRB, 0.17986889E-08_JPRB, 0.18230691E-08_JPRB, 0.18324570E-08_JPRB, &
  & 0.18301420E-08_JPRB, 0.18137447E-08_JPRB, 0.17801005E-08_JPRB, 0.17285013E-08_JPRB, 0.16577406E-08_JPRB, 0.15677387E-08_JPRB, &
  & 0.14579431E-08_JPRB, 0.13295783E-08_JPRB, 0.12090187E-08_JPRB, 0.10901945E-08_JPRB, 0.96451813E-09_JPRB, 0.84486468E-09_JPRB, &
  & 0.80252405E-09_JPRB, 0.10241922E-08_JPRB, 0.77373868E-09_JPRB, 0.59291394E-09_JPRB /)

RGHG4(:,23, 2) = (/ &
  & 0.32238767E-08_JPRB, 0.30273477E-08_JPRB, 0.29490295E-08_JPRB, 0.27174023E-08_JPRB, 0.25569942E-08_JPRB, 0.24520994E-08_JPRB, &
  & 0.23739832E-08_JPRB, 0.22936151E-08_JPRB, 0.22107132E-08_JPRB, 0.21248143E-08_JPRB, 0.20350626E-08_JPRB, 0.19451236E-08_JPRB, &
  & 0.18530076E-08_JPRB, 0.17612538E-08_JPRB, 0.16732074E-08_JPRB, 0.15902190E-08_JPRB, 0.15144113E-08_JPRB, 0.14541055E-08_JPRB, &
  & 0.14114885E-08_JPRB, 0.13829063E-08_JPRB, 0.13714895E-08_JPRB, 0.13798317E-08_JPRB, 0.14079505E-08_JPRB, 0.14553666E-08_JPRB, &
  & 0.15150532E-08_JPRB, 0.15779923E-08_JPRB, 0.16338402E-08_JPRB, 0.16711559E-08_JPRB, 0.16808649E-08_JPRB, 0.16605867E-08_JPRB, &
  & 0.16086326E-08_JPRB, 0.15382948E-08_JPRB, 0.14591672E-08_JPRB, 0.13764944E-08_JPRB, 0.12999687E-08_JPRB, 0.12361732E-08_JPRB, &
  & 0.11901378E-08_JPRB, 0.11646378E-08_JPRB, 0.11601629E-08_JPRB, 0.11735103E-08_JPRB, 0.12004091E-08_JPRB, 0.12360983E-08_JPRB, &
  & 0.12771160E-08_JPRB, 0.13204768E-08_JPRB, 0.13631898E-08_JPRB, 0.14026906E-08_JPRB, 0.14339550E-08_JPRB, 0.14548132E-08_JPRB, &
  & 0.14612457E-08_JPRB, 0.14516017E-08_JPRB, 0.14259404E-08_JPRB, 0.13846757E-08_JPRB, 0.13272543E-08_JPRB, 0.12538033E-08_JPRB, &
  & 0.11654370E-08_JPRB, 0.10686327E-08_JPRB, 0.97381658E-09_JPRB, 0.87870788E-09_JPRB, 0.77701345E-09_JPRB, 0.67375583E-09_JPRB, &
  & 0.62286132E-09_JPRB, 0.71193890E-09_JPRB, 0.51473353E-09_JPRB, 0.38121767E-09_JPRB /)

RGHG4(:,24, 2) = (/ &
  & 0.29161173E-08_JPRB, 0.26621625E-08_JPRB, 0.25506761E-08_JPRB, 0.23391129E-08_JPRB, 0.21841324E-08_JPRB, 0.20763451E-08_JPRB, &
  & 0.19956656E-08_JPRB, 0.19199879E-08_JPRB, 0.18398822E-08_JPRB, 0.17569369E-08_JPRB, 0.16710359E-08_JPRB, 0.15834468E-08_JPRB, &
  & 0.14936039E-08_JPRB, 0.14047196E-08_JPRB, 0.13242942E-08_JPRB, 0.12527505E-08_JPRB, 0.11903402E-08_JPRB, 0.11390230E-08_JPRB, &
  & 0.11007235E-08_JPRB, 0.10731596E-08_JPRB, 0.10581227E-08_JPRB, 0.10568422E-08_JPRB, 0.10704680E-08_JPRB, 0.10968587E-08_JPRB, &
  & 0.11322077E-08_JPRB, 0.11706495E-08_JPRB, 0.12036808E-08_JPRB, 0.12231539E-08_JPRB, 0.12223500E-08_JPRB, 0.11961239E-08_JPRB, &
  & 0.11503780E-08_JPRB, 0.10903035E-08_JPRB, 0.10248764E-08_JPRB, 0.95992680E-09_JPRB, 0.90326646E-09_JPRB, 0.86009883E-09_JPRB, &
  & 0.83405882E-09_JPRB, 0.82618429E-09_JPRB, 0.83555451E-09_JPRB, 0.85894131E-09_JPRB, 0.89277458E-09_JPRB, 0.93302965E-09_JPRB, &
  & 0.97735864E-09_JPRB, 0.10232580E-08_JPRB, 0.10680583E-08_JPRB, 0.11078747E-08_JPRB, 0.11394834E-08_JPRB, 0.11587068E-08_JPRB, &
  & 0.11652184E-08_JPRB, 0.11590714E-08_JPRB, 0.11381717E-08_JPRB, 0.11036855E-08_JPRB, 0.10561817E-08_JPRB, 0.99704167E-09_JPRB, &
  & 0.92703356E-09_JPRB, 0.85682039E-09_JPRB, 0.78398471E-09_JPRB, 0.70513834E-09_JPRB, 0.62255640E-09_JPRB, 0.53324445E-09_JPRB, &
  & 0.47562809E-09_JPRB, 0.48424192E-09_JPRB, 0.33461794E-09_JPRB, 0.24144234E-09_JPRB /)

RGHG4(:,25, 2) = (/ &
  & 0.26238185E-08_JPRB, 0.23862852E-08_JPRB, 0.22455493E-08_JPRB, 0.20233779E-08_JPRB, 0.18783228E-08_JPRB, 0.17808903E-08_JPRB, &
  & 0.17020997E-08_JPRB, 0.16300316E-08_JPRB, 0.15572267E-08_JPRB, 0.14790764E-08_JPRB, 0.13974942E-08_JPRB, 0.13133793E-08_JPRB, &
  & 0.12335102E-08_JPRB, 0.11581898E-08_JPRB, 0.10886626E-08_JPRB, 0.10257830E-08_JPRB, 0.96994812E-09_JPRB, 0.92210239E-09_JPRB, &
  & 0.88351676E-09_JPRB, 0.85259561E-09_JPRB, 0.83085272E-09_JPRB, 0.81934287E-09_JPRB, 0.81844526E-09_JPRB, 0.82665719E-09_JPRB, &
  & 0.84157781E-09_JPRB, 0.85999252E-09_JPRB, 0.87490098E-09_JPRB, 0.88287599E-09_JPRB, 0.87704327E-09_JPRB, 0.85598262E-09_JPRB, &
  & 0.82006069E-09_JPRB, 0.77466694E-09_JPRB, 0.72691697E-09_JPRB, 0.68123585E-09_JPRB, 0.64304151E-09_JPRB, 0.61722250E-09_JPRB, &
  & 0.60543104E-09_JPRB, 0.60888788E-09_JPRB, 0.62537781E-09_JPRB, 0.65260103E-09_JPRB, 0.68719258E-09_JPRB, 0.72711420E-09_JPRB, &
  & 0.77016055E-09_JPRB, 0.81438545E-09_JPRB, 0.85725910E-09_JPRB, 0.89461349E-09_JPRB, 0.92462810E-09_JPRB, 0.94479813E-09_JPRB, &
  & 0.95239350E-09_JPRB, 0.94633368E-09_JPRB, 0.92798225E-09_JPRB, 0.89781999E-09_JPRB, 0.85782287E-09_JPRB, 0.80877993E-09_JPRB, &
  & 0.75470324E-09_JPRB, 0.69778289E-09_JPRB, 0.63850536E-09_JPRB, 0.57087041E-09_JPRB, 0.49258914E-09_JPRB, 0.41187079E-09_JPRB, &
  & 0.35394743E-09_JPRB, 0.32261446E-09_JPRB, 0.21628845E-09_JPRB, 0.14342651E-09_JPRB /)

RGHG4(:,26, 2) = (/ &
  & 0.23981301E-08_JPRB, 0.21614803E-08_JPRB, 0.20100817E-08_JPRB, 0.17805111E-08_JPRB, 0.16376043E-08_JPRB, 0.15453271E-08_JPRB, &
  & 0.14735015E-08_JPRB, 0.14044484E-08_JPRB, 0.13360262E-08_JPRB, 0.12628142E-08_JPRB, 0.11891057E-08_JPRB, 0.11171720E-08_JPRB, &
  & 0.10480263E-08_JPRB, 0.98224751E-09_JPRB, 0.92051361E-09_JPRB, 0.86348600E-09_JPRB, 0.81151236E-09_JPRB, 0.76515028E-09_JPRB, &
  & 0.72563755E-09_JPRB, 0.69181222E-09_JPRB, 0.66461620E-09_JPRB, 0.64443934E-09_JPRB, 0.63166683E-09_JPRB, 0.62516542E-09_JPRB, &
  & 0.62449951E-09_JPRB, 0.62752359E-09_JPRB, 0.63073996E-09_JPRB, 0.63068234E-09_JPRB, 0.62363709E-09_JPRB, 0.60790428E-09_JPRB, &
  & 0.58349814E-09_JPRB, 0.55286647E-09_JPRB, 0.52118726E-09_JPRB, 0.49210619E-09_JPRB, 0.46909515E-09_JPRB, 0.45660828E-09_JPRB, &
  & 0.45483092E-09_JPRB, 0.46508042E-09_JPRB, 0.48451987E-09_JPRB, 0.51186055E-09_JPRB, 0.54478783E-09_JPRB, 0.58203625E-09_JPRB, &
  & 0.62149969E-09_JPRB, 0.66211286E-09_JPRB, 0.70111839E-09_JPRB, 0.73483830E-09_JPRB, 0.76129575E-09_JPRB, 0.77696832E-09_JPRB, &
  & 0.78162349E-09_JPRB, 0.77629669E-09_JPRB, 0.75996570E-09_JPRB, 0.73428474E-09_JPRB, 0.70045075E-09_JPRB, 0.66017297E-09_JPRB, &
  & 0.61758781E-09_JPRB, 0.57211613E-09_JPRB, 0.52130678E-09_JPRB, 0.46488932E-09_JPRB, 0.39817161E-09_JPRB, 0.32515418E-09_JPRB, &
  & 0.26345556E-09_JPRB, 0.21338516E-09_JPRB, 0.13479706E-09_JPRB, 0.82916139E-10_JPRB /)

RGHG4(:,27, 2) = (/ &
  & 0.21977780E-08_JPRB, 0.19660846E-08_JPRB, 0.18129327E-08_JPRB, 0.15883519E-08_JPRB, 0.14410204E-08_JPRB, 0.13533800E-08_JPRB, &
  & 0.12861234E-08_JPRB, 0.12210801E-08_JPRB, 0.11566692E-08_JPRB, 0.10941670E-08_JPRB, 0.10303514E-08_JPRB, 0.96921038E-09_JPRB, &
  & 0.90888091E-09_JPRB, 0.85013352E-09_JPRB, 0.79378609E-09_JPRB, 0.74062956E-09_JPRB, 0.69132544E-09_JPRB, 0.64643518E-09_JPRB, &
  & 0.60681532E-09_JPRB, 0.57118371E-09_JPRB, 0.54005811E-09_JPRB, 0.51371640E-09_JPRB, 0.49258919E-09_JPRB, 0.47621268E-09_JPRB, &
  & 0.46463675E-09_JPRB, 0.45678256E-09_JPRB, 0.45159529E-09_JPRB, 0.44620496E-09_JPRB, 0.43884082E-09_JPRB, 0.42774273E-09_JPRB, &
  & 0.41222681E-09_JPRB, 0.39388981E-09_JPRB, 0.37522313E-09_JPRB, 0.35914019E-09_JPRB, 0.34784567E-09_JPRB, 0.34470557E-09_JPRB, &
  & 0.34962994E-09_JPRB, 0.36318412E-09_JPRB, 0.38343748E-09_JPRB, 0.40965700E-09_JPRB, 0.43974133E-09_JPRB, 0.47324827E-09_JPRB, &
  & 0.50872317E-09_JPRB, 0.54506605E-09_JPRB, 0.57953142E-09_JPRB, 0.60930599E-09_JPRB, 0.63209099E-09_JPRB, 0.64585387E-09_JPRB, &
  & 0.64990202E-09_JPRB, 0.64376382E-09_JPRB, 0.62867511E-09_JPRB, 0.60627325E-09_JPRB, 0.57742039E-09_JPRB, 0.54609739E-09_JPRB, &
  & 0.51172538E-09_JPRB, 0.47429910E-09_JPRB, 0.43036036E-09_JPRB, 0.38100320E-09_JPRB, 0.32151817E-09_JPRB, 0.25481300E-09_JPRB, &
  & 0.19006985E-09_JPRB, 0.13802452E-09_JPRB, 0.83821561E-10_JPRB, 0.48000885E-10_JPRB /)

RGHG4(:,28, 2) = (/ &
  & 0.20238746E-08_JPRB, 0.18011731E-08_JPRB, 0.16478731E-08_JPRB, 0.14329878E-08_JPRB, 0.12891500E-08_JPRB, 0.11998517E-08_JPRB, &
  & 0.11332382E-08_JPRB, 0.10727278E-08_JPRB, 0.10153156E-08_JPRB, 0.96175601E-09_JPRB, 0.90872165E-09_JPRB, 0.85449470E-09_JPRB, &
  & 0.80158807E-09_JPRB, 0.74915907E-09_JPRB, 0.69806061E-09_JPRB, 0.64883976E-09_JPRB, 0.60231531E-09_JPRB, 0.55855415E-09_JPRB, &
  & 0.51833982E-09_JPRB, 0.48105836E-09_JPRB, 0.44718226E-09_JPRB, 0.41680034E-09_JPRB, 0.39012266E-09_JPRB, 0.36725645E-09_JPRB, &
  & 0.34850675E-09_JPRB, 0.33378322E-09_JPRB, 0.32248731E-09_JPRB, 0.31358743E-09_JPRB, 0.30575351E-09_JPRB, 0.29781189E-09_JPRB, &
  & 0.28896538E-09_JPRB, 0.27938915E-09_JPRB, 0.27033334E-09_JPRB, 0.26364702E-09_JPRB, 0.26079613E-09_JPRB, 0.26390382E-09_JPRB, &
  & 0.27283789E-09_JPRB, 0.28790936E-09_JPRB, 0.30787328E-09_JPRB, 0.33177858E-09_JPRB, 0.35877892E-09_JPRB, 0.38869569E-09_JPRB, &
  & 0.42034964E-09_JPRB, 0.45250195E-09_JPRB, 0.48308213E-09_JPRB, 0.50927823E-09_JPRB, 0.52876348E-09_JPRB, 0.53986499E-09_JPRB, &
  & 0.54216581E-09_JPRB, 0.53635535E-09_JPRB, 0.52306659E-09_JPRB, 0.50416138E-09_JPRB, 0.48035986E-09_JPRB, 0.45419929E-09_JPRB, &
  & 0.42521139E-09_JPRB, 0.39210182E-09_JPRB, 0.35519035E-09_JPRB, 0.31021866E-09_JPRB, 0.26036703E-09_JPRB, 0.20188891E-09_JPRB, &
  & 0.14303914E-09_JPRB, 0.94429457E-10_JPRB, 0.52920140E-10_JPRB, 0.27777874E-10_JPRB /)

RGHG4(:,29, 2) = (/ &
  & 0.18606047E-08_JPRB, 0.16491216E-08_JPRB, 0.14995138E-08_JPRB, 0.12947539E-08_JPRB, 0.11547908E-08_JPRB, 0.10642688E-08_JPRB, &
  & 0.10023852E-08_JPRB, 0.94896391E-09_JPRB, 0.90060931E-09_JPRB, 0.85365937E-09_JPRB, 0.80839141E-09_JPRB, 0.76165652E-09_JPRB, &
  & 0.71335160E-09_JPRB, 0.66551609E-09_JPRB, 0.61845190E-09_JPRB, 0.57235122E-09_JPRB, 0.52792054E-09_JPRB, 0.48542353E-09_JPRB, &
  & 0.44558573E-09_JPRB, 0.40799414E-09_JPRB, 0.37290879E-09_JPRB, 0.34056738E-09_JPRB, 0.31099223E-09_JPRB, 0.28444172E-09_JPRB, &
  & 0.26163377E-09_JPRB, 0.24287511E-09_JPRB, 0.22835744E-09_JPRB, 0.21732495E-09_JPRB, 0.20931368E-09_JPRB, 0.20347225E-09_JPRB, &
  & 0.19876376E-09_JPRB, 0.19497469E-09_JPRB, 0.19225077E-09_JPRB, 0.19186065E-09_JPRB, 0.19451872E-09_JPRB, 0.20141989E-09_JPRB, &
  & 0.21248717E-09_JPRB, 0.22747290E-09_JPRB, 0.24550253E-09_JPRB, 0.26667432E-09_JPRB, 0.29085431E-09_JPRB, 0.31742536E-09_JPRB, &
  & 0.34559663E-09_JPRB, 0.37428718E-09_JPRB, 0.40143508E-09_JPRB, 0.42458925E-09_JPRB, 0.44177112E-09_JPRB, 0.45166201E-09_JPRB, &
  & 0.45384649E-09_JPRB, 0.44865439E-09_JPRB, 0.43732726E-09_JPRB, 0.42113391E-09_JPRB, 0.40214038E-09_JPRB, 0.38069037E-09_JPRB, &
  & 0.35690315E-09_JPRB, 0.32889452E-09_JPRB, 0.29701921E-09_JPRB, 0.25739283E-09_JPRB, 0.21315327E-09_JPRB, 0.16182887E-09_JPRB, &
  & 0.11009380E-09_JPRB, 0.67821297E-10_JPRB, 0.35566529E-10_JPRB, 0.17171363E-10_JPRB /)

RGHG4(:,30, 2) = (/ &
  & 0.17275238E-08_JPRB, 0.15171308E-08_JPRB, 0.13678590E-08_JPRB, 0.11747823E-08_JPRB, 0.10415245E-08_JPRB, 0.95647656E-09_JPRB, &
  & 0.89820873E-09_JPRB, 0.85030721E-09_JPRB, 0.80766999E-09_JPRB, 0.76655959E-09_JPRB, 0.72549222E-09_JPRB, 0.68474326E-09_JPRB, &
  & 0.64223415E-09_JPRB, 0.59790156E-09_JPRB, 0.55347965E-09_JPRB, 0.50950827E-09_JPRB, 0.46682758E-09_JPRB, 0.42531087E-09_JPRB, &
  & 0.38595063E-09_JPRB, 0.34850420E-09_JPRB, 0.31319966E-09_JPRB, 0.28012551E-09_JPRB, 0.24948796E-09_JPRB, 0.22166981E-09_JPRB, &
  & 0.19715411E-09_JPRB, 0.17703131E-09_JPRB, 0.16082860E-09_JPRB, 0.14909382E-09_JPRB, 0.14103994E-09_JPRB, 0.13622738E-09_JPRB, &
  & 0.13364757E-09_JPRB, 0.13311766E-09_JPRB, 0.13419979E-09_JPRB, 0.13756066E-09_JPRB, 0.14333275E-09_JPRB, 0.15192674E-09_JPRB, &
  & 0.16327306E-09_JPRB, 0.17710471E-09_JPRB, 0.19361822E-09_JPRB, 0.21269497E-09_JPRB, 0.23431879E-09_JPRB, 0.25798250E-09_JPRB, &
  & 0.28323238E-09_JPRB, 0.30905264E-09_JPRB, 0.33351871E-09_JPRB, 0.35453199E-09_JPRB, 0.37013484E-09_JPRB, 0.37906725E-09_JPRB, &
  & 0.38117470E-09_JPRB, 0.37703465E-09_JPRB, 0.36786021E-09_JPRB, 0.35482395E-09_JPRB, 0.33918660E-09_JPRB, 0.32129932E-09_JPRB, &
  & 0.30041544E-09_JPRB, 0.27671260E-09_JPRB, 0.24881100E-09_JPRB, 0.21376692E-09_JPRB, 0.17236280E-09_JPRB, 0.12914066E-09_JPRB, &
  & 0.85574589E-10_JPRB, 0.50053933E-10_JPRB, 0.25423169E-10_JPRB, 0.11581076E-10_JPRB /)

RGHG4(:,31, 2) = (/ &
  & 0.15947714E-08_JPRB, 0.13905105E-08_JPRB, 0.12459436E-08_JPRB, 0.10673479E-08_JPRB, 0.94384967E-09_JPRB, 0.86396490E-09_JPRB, &
  & 0.80896612E-09_JPRB, 0.76485912E-09_JPRB, 0.72613354E-09_JPRB, 0.68990602E-09_JPRB, 0.65338335E-09_JPRB, 0.61564193E-09_JPRB, &
  & 0.57703481E-09_JPRB, 0.53693489E-09_JPRB, 0.49543852E-09_JPRB, 0.45343063E-09_JPRB, 0.41206838E-09_JPRB, 0.37152154E-09_JPRB, &
  & 0.33272593E-09_JPRB, 0.29572952E-09_JPRB, 0.26083313E-09_JPRB, 0.22814550E-09_JPRB, 0.19792196E-09_JPRB, 0.17055060E-09_JPRB, &
  & 0.14634632E-09_JPRB, 0.12664447E-09_JPRB, 0.11067210E-09_JPRB, 0.99337115E-10_JPRB, 0.91784066E-10_JPRB, 0.87728276E-10_JPRB, &
  & 0.86158441E-10_JPRB, 0.87385099E-10_JPRB, 0.89968144E-10_JPRB, 0.95292114E-10_JPRB, 0.10203266E-09_JPRB, 0.11105970E-09_JPRB, &
  & 0.12167939E-09_JPRB, 0.13407250E-09_JPRB, 0.14843819E-09_JPRB, 0.16497226E-09_JPRB, 0.18397982E-09_JPRB, 0.20514487E-09_JPRB, &
  & 0.22806299E-09_JPRB, 0.25175562E-09_JPRB, 0.27433431E-09_JPRB, 0.29386296E-09_JPRB, 0.30845249E-09_JPRB, 0.31712261E-09_JPRB, &
  & 0.31971861E-09_JPRB, 0.31685207E-09_JPRB, 0.30954081E-09_JPRB, 0.29908134E-09_JPRB, 0.28630381E-09_JPRB, 0.27150379E-09_JPRB, &
  & 0.25394473E-09_JPRB, 0.23363225E-09_JPRB, 0.20807293E-09_JPRB, 0.17872059E-09_JPRB, 0.14256749E-09_JPRB, 0.10524581E-09_JPRB, &
  & 0.67939099E-10_JPRB, 0.38711836E-10_JPRB, 0.19387237E-10_JPRB, 0.85754450E-11_JPRB /)

RGHG4(:,32, 2) = (/ &
  & 0.14777172E-08_JPRB, 0.12785332E-08_JPRB, 0.11399246E-08_JPRB, 0.97584052E-09_JPRB, 0.86058227E-09_JPRB, 0.78531326E-09_JPRB, &
  & 0.73321638E-09_JPRB, 0.69221129E-09_JPRB, 0.65640404E-09_JPRB, 0.62320143E-09_JPRB, 0.59062399E-09_JPRB, 0.55688681E-09_JPRB, &
  & 0.52101545E-09_JPRB, 0.48319387E-09_JPRB, 0.44392973E-09_JPRB, 0.40374004E-09_JPRB, 0.36354722E-09_JPRB, 0.32386702E-09_JPRB, &
  & 0.28586056E-09_JPRB, 0.24961269E-09_JPRB, 0.21575719E-09_JPRB, 0.18429334E-09_JPRB, 0.15553152E-09_JPRB, 0.12978366E-09_JPRB, &
  & 0.10759484E-09_JPRB, 0.89258080E-10_JPRB, 0.75199930E-10_JPRB, 0.65044567E-10_JPRB, 0.58471686E-10_JPRB, 0.54971003E-10_JPRB, &
  & 0.53909901E-10_JPRB, 0.55379760E-10_JPRB, 0.58342151E-10_JPRB, 0.63833695E-10_JPRB, 0.70331650E-10_JPRB, 0.78890207E-10_JPRB, &
  & 0.88366814E-10_JPRB, 0.99153470E-10_JPRB, 0.11151759E-09_JPRB, 0.12579952E-09_JPRB, 0.14236143E-09_JPRB, 0.16118915E-09_JPRB, &
  & 0.18198210E-09_JPRB, 0.20376580E-09_JPRB, 0.22481306E-09_JPRB, 0.24316854E-09_JPRB, 0.25709290E-09_JPRB, 0.26571426E-09_JPRB, &
  & 0.26885327E-09_JPRB, 0.26717675E-09_JPRB, 0.26176422E-09_JPRB, 0.25364497E-09_JPRB, 0.24346009E-09_JPRB, 0.23139311E-09_JPRB, &
  & 0.21659845E-09_JPRB, 0.19917050E-09_JPRB, 0.17713471E-09_JPRB, 0.15123926E-09_JPRB, 0.11910647E-09_JPRB, 0.84635972E-10_JPRB, &
  & 0.54373627E-10_JPRB, 0.30397716E-10_JPRB, 0.15206239E-10_JPRB, 0.66784334E-11_JPRB /)

RGHG4(:,33, 2) = (/ &
  & 0.13631829E-08_JPRB, 0.11722598E-08_JPRB, 0.10407128E-08_JPRB, 0.89001612E-09_JPRB, 0.78386631E-09_JPRB, 0.71312628E-09_JPRB, &
  & 0.66379652E-09_JPRB, 0.62514571E-09_JPRB, 0.59221905E-09_JPRB, 0.56193872E-09_JPRB, 0.53214011E-09_JPRB, 0.50143678E-09_JPRB, &
  & 0.46883170E-09_JPRB, 0.43378690E-09_JPRB, 0.39645964E-09_JPRB, 0.35749306E-09_JPRB, 0.31811911E-09_JPRB, 0.27908692E-09_JPRB, &
  & 0.24159819E-09_JPRB, 0.20641924E-09_JPRB, 0.17395696E-09_JPRB, 0.14448773E-09_JPRB, 0.11813391E-09_JPRB, 0.95213858E-10_JPRB, &
  & 0.76173540E-10_JPRB, 0.60471794E-10_JPRB, 0.49095471E-10_JPRB, 0.40904009E-10_JPRB, 0.35662022E-10_JPRB, 0.32701401E-10_JPRB, &
  & 0.32051733E-10_JPRB, 0.32952009E-10_JPRB, 0.35787730E-10_JPRB, 0.40091739E-10_JPRB, 0.45792002E-10_JPRB, 0.52841502E-10_JPRB, &
  & 0.60507967E-10_JPRB, 0.69493217E-10_JPRB, 0.79686278E-10_JPRB, 0.91578120E-10_JPRB, 0.10578678E-09_JPRB, 0.12255802E-09_JPRB, &
  & 0.14156472E-09_JPRB, 0.16195009E-09_JPRB, 0.18189358E-09_JPRB, 0.19950060E-09_JPRB, 0.21304736E-09_JPRB, 0.22171355E-09_JPRB, &
  & 0.22546429E-09_JPRB, 0.22510911E-09_JPRB, 0.22140573E-09_JPRB, 0.21518702E-09_JPRB, 0.20701077E-09_JPRB, 0.19671977E-09_JPRB, &
  & 0.18460791E-09_JPRB, 0.16992568E-09_JPRB, 0.15098457E-09_JPRB, 0.12826649E-09_JPRB, 0.10033335E-09_JPRB, 0.70631695E-10_JPRB, &
  & 0.44978583E-10_JPRB, 0.24954625E-10_JPRB, 0.12301365E-10_JPRB, 0.54131621E-11_JPRB /)

RGHG4(:,34, 2) = (/ &
  & 0.12568990E-08_JPRB, 0.10750829E-08_JPRB, 0.95154717E-09_JPRB, 0.81209556E-09_JPRB, 0.71349054E-09_JPRB, 0.64709127E-09_JPRB, &
  & 0.60074157E-09_JPRB, 0.56447164E-09_JPRB, 0.53412108E-09_JPRB, 0.50654031E-09_JPRB, 0.47965842E-09_JPRB, 0.45175771E-09_JPRB, &
  & 0.42154769E-09_JPRB, 0.38857612E-09_JPRB, 0.35293918E-09_JPRB, 0.31534997E-09_JPRB, 0.27676844E-09_JPRB, 0.23824115E-09_JPRB, &
  & 0.20174051E-09_JPRB, 0.16788765E-09_JPRB, 0.13732609E-09_JPRB, 0.11033682E-09_JPRB, 0.87214062E-10_JPRB, 0.67653806E-10_JPRB, &
  & 0.52208855E-10_JPRB, 0.39930229E-10_JPRB, 0.31243945E-10_JPRB, 0.25080040E-10_JPRB, 0.21164031E-10_JPRB, 0.18953590E-10_JPRB, &
  & 0.18295008E-10_JPRB, 0.18900598E-10_JPRB, 0.20798207E-10_JPRB, 0.23934446E-10_JPRB, 0.28230713E-10_JPRB, 0.33475840E-10_JPRB, &
  & 0.39578490E-10_JPRB, 0.46620083E-10_JPRB, 0.54585062E-10_JPRB, 0.64243208E-10_JPRB, 0.76177023E-10_JPRB, 0.90865183E-10_JPRB, &
  & 0.10829812E-09_JPRB, 0.12733291E-09_JPRB, 0.14632928E-09_JPRB, 0.16324245E-09_JPRB, 0.17645643E-09_JPRB, 0.18519235E-09_JPRB, &
  & 0.18952970E-09_JPRB, 0.19011202E-09_JPRB, 0.18770699E-09_JPRB, 0.18319032E-09_JPRB, 0.17681533E-09_JPRB, 0.16857961E-09_JPRB, &
  & 0.15863498E-09_JPRB, 0.14623926E-09_JPRB, 0.12996745E-09_JPRB, 0.11050678E-09_JPRB, 0.86408103E-10_JPRB, 0.60686088E-10_JPRB, &
  & 0.38508790E-10_JPRB, 0.21056525E-10_JPRB, 0.10360100E-10_JPRB, 0.46060300E-11_JPRB /)

RGHG4(:,35, 2) = (/ &
  & 0.11528676E-08_JPRB, 0.98005559E-09_JPRB, 0.86384466E-09_JPRB, 0.73590734E-09_JPRB, 0.64539540E-09_JPRB, 0.58376065E-09_JPRB, &
  & 0.54046212E-09_JPRB, 0.50674093E-09_JPRB, 0.47893328E-09_JPRB, 0.45390766E-09_JPRB, 0.42964976E-09_JPRB, 0.40447456E-09_JPRB, &
  & 0.37707046E-09_JPRB, 0.34639280E-09_JPRB, 0.31234443E-09_JPRB, 0.27576730E-09_JPRB, 0.23773145E-09_JPRB, 0.19989135E-09_JPRB, &
  & 0.16429907E-09_JPRB, 0.13197407E-09_JPRB, 0.10382546E-09_JPRB, 0.79887805E-10_JPRB, 0.60538692E-10_JPRB, 0.45097814E-10_JPRB, &
  & 0.33574862E-10_JPRB, 0.24865238E-10_JPRB, 0.18990578E-10_JPRB, 0.14821181E-10_JPRB, 0.12211905E-10_JPRB, 0.10712066E-10_JPRB, &
  & 0.10175393E-10_JPRB, 0.10433684E-10_JPRB, 0.11535049E-10_JPRB, 0.13465353E-10_JPRB, 0.16230224E-10_JPRB, 0.19779293E-10_JPRB, &
  & 0.24049951E-10_JPRB, 0.29022109E-10_JPRB, 0.34949366E-10_JPRB, 0.42382365E-10_JPRB, 0.51929787E-10_JPRB, 0.64392630E-10_JPRB, &
  & 0.79843653E-10_JPRB, 0.97666104E-10_JPRB, 0.11581922E-09_JPRB, 0.13228416E-09_JPRB, 0.14532490E-09_JPRB, 0.15417713E-09_JPRB, &
  & 0.15903866E-09_JPRB, 0.16047612E-09_JPRB, 0.15924599E-09_JPRB, 0.15606137E-09_JPRB, 0.15109877E-09_JPRB, 0.14437680E-09_JPRB, &
  & 0.13595290E-09_JPRB, 0.12480593E-09_JPRB, 0.11165342E-09_JPRB, 0.95114090E-10_JPRB, 0.74446845E-10_JPRB, 0.52247335E-10_JPRB, &
  & 0.33273585E-10_JPRB, 0.18217637E-10_JPRB, 0.90658722E-11_JPRB, 0.39008458E-11_JPRB /)

RGHG4(:,36, 2) = (/ &
  & 0.10510035E-08_JPRB, 0.88849289E-09_JPRB, 0.78109763E-09_JPRB, 0.66389166E-09_JPRB, 0.58040706E-09_JPRB, 0.52396210E-09_JPRB, &
  & 0.48402748E-09_JPRB, 0.45329226E-09_JPRB, 0.42800136E-09_JPRB, 0.40557982E-09_JPRB, 0.38401762E-09_JPRB, 0.36155606E-09_JPRB, &
  & 0.33671735E-09_JPRB, 0.30828981E-09_JPRB, 0.27603023E-09_JPRB, 0.24054081E-09_JPRB, 0.20318681E-09_JPRB, 0.16614803E-09_JPRB, &
  & 0.13183564E-09_JPRB, 0.10136466E-09_JPRB, 0.76049320E-10_JPRB, 0.55704726E-10_JPRB, 0.40335756E-10_JPRB, 0.29009534E-10_JPRB, &
  & 0.21153603E-10_JPRB, 0.15545596E-10_JPRB, 0.11854940E-10_JPRB, 0.92638666E-11_JPRB, 0.76120568E-11_JPRB, 0.66435763E-11_JPRB, &
  & 0.62308479E-11_JPRB, 0.63260612E-11_JPRB, 0.69247932E-11_JPRB, 0.80789880E-11_JPRB, 0.98048028E-11_JPRB, 0.12103090E-10_JPRB, &
  & 0.14970232E-10_JPRB, 0.18425303E-10_JPRB, 0.22694608E-10_JPRB, 0.28185655E-10_JPRB, 0.35558150E-10_JPRB, 0.45565104E-10_JPRB, &
  & 0.58759143E-10_JPRB, 0.74599556E-10_JPRB, 0.91571403E-10_JPRB, 0.10727455E-09_JPRB, 0.11993466E-09_JPRB, 0.12878966E-09_JPRB, &
  & 0.13396831E-09_JPRB, 0.13604111E-09_JPRB, 0.13572914E-09_JPRB, 0.13359761E-09_JPRB, 0.12979821E-09_JPRB, 0.12437387E-09_JPRB, &
  & 0.11729888E-09_JPRB, 0.10778643E-09_JPRB, 0.96371133E-10_JPRB, 0.82185619E-10_JPRB, 0.64561391E-10_JPRB, 0.45855559E-10_JPRB, &
  & 0.29462051E-10_JPRB, 0.16284078E-10_JPRB, 0.81238237E-11_JPRB, 0.33794788E-11_JPRB /)

RGHG4(:,37, 2) = (/ &
  & 0.94967556E-09_JPRB, 0.79995643E-09_JPRB, 0.70101869E-09_JPRB, 0.59497623E-09_JPRB, 0.51877591E-09_JPRB, 0.46695364E-09_JPRB, &
  & 0.43033277E-09_JPRB, 0.40235712E-09_JPRB, 0.37956399E-09_JPRB, 0.35968348E-09_JPRB, 0.34066161E-09_JPRB, 0.32086672E-09_JPRB, &
  & 0.29862923E-09_JPRB, 0.27256217E-09_JPRB, 0.24206021E-09_JPRB, 0.20773842E-09_JPRB, 0.17139577E-09_JPRB, 0.13536133E-09_JPRB, &
  & 0.10249643E-09_JPRB, 0.74765187E-10_JPRB, 0.52950946E-10_JPRB, 0.36799438E-10_JPRB, 0.25754059E-10_JPRB, 0.18250365E-10_JPRB, &
  & 0.13412992E-10_JPRB, 0.10073014E-10_JPRB, 0.79070058E-11_JPRB, 0.63295788E-11_JPRB, 0.52885231E-11_JPRB, 0.46478693E-11_JPRB, &
  & 0.43304310E-11_JPRB, 0.43533289E-11_JPRB, 0.46934427E-11_JPRB, 0.54210859E-11_JPRB, 0.65359801E-11_JPRB, 0.80836067E-11_JPRB, &
  & 0.10047930E-10_JPRB, 0.12484515E-10_JPRB, 0.15566683E-10_JPRB, 0.19598956E-10_JPRB, 0.25123086E-10_JPRB, 0.32889309E-10_JPRB, &
  & 0.43459129E-10_JPRB, 0.57016239E-10_JPRB, 0.72082069E-10_JPRB, 0.86744376E-10_JPRB, 0.98813617E-10_JPRB, 0.10751674E-09_JPRB, &
  & 0.11287820E-09_JPRB, 0.11539763E-09_JPRB, 0.11570821E-09_JPRB, 0.11428381E-09_JPRB, 0.11128511E-09_JPRB, 0.10698148E-09_JPRB, &
  & 0.10109145E-09_JPRB, 0.92968008E-10_JPRB, 0.83033642E-10_JPRB, 0.70124212E-10_JPRB, 0.55579676E-10_JPRB, 0.39775950E-10_JPRB, &
  & 0.25820349E-10_JPRB, 0.14531785E-10_JPRB, 0.73240485E-11_JPRB, 0.30419432E-11_JPRB /)

RGHG4(:,38, 2) = (/ &
  & 0.85400848E-09_JPRB, 0.71758705E-09_JPRB, 0.62814848E-09_JPRB, 0.53155713E-09_JPRB, 0.46202481E-09_JPRB, 0.41441417E-09_JPRB, &
  & 0.38098516E-09_JPRB, 0.35557249E-09_JPRB, 0.33505571E-09_JPRB, 0.31750719E-09_JPRB, 0.30093547E-09_JPRB, 0.28375688E-09_JPRB, &
  & 0.26416935E-09_JPRB, 0.24057856E-09_JPRB, 0.21218800E-09_JPRB, 0.17921521E-09_JPRB, 0.14393522E-09_JPRB, 0.10944737E-09_JPRB, &
  & 0.78721966E-10_JPRB, 0.54140727E-10_JPRB, 0.36465036E-10_JPRB, 0.24597621E-10_JPRB, 0.17055793E-10_JPRB, 0.12299111E-10_JPRB, &
  & 0.93231941E-11_JPRB, 0.72802944E-11_JPRB, 0.59215818E-11_JPRB, 0.48917420E-11_JPRB, 0.41675673E-11_JPRB, 0.36978116E-11_JPRB, &
  & 0.34335557E-11_JPRB, 0.34222299E-11_JPRB, 0.36370308E-11_JPRB, 0.41523898E-11_JPRB, 0.49574351E-11_JPRB, 0.61023699E-11_JPRB, &
  & 0.75640683E-11_JPRB, 0.94240744E-11_JPRB, 0.11770035E-10_JPRB, 0.14882165E-10_JPRB, 0.19162999E-10_JPRB, 0.25194442E-10_JPRB, &
  & 0.33668440E-10_JPRB, 0.44773359E-10_JPRB, 0.57812019E-10_JPRB, 0.70811738E-10_JPRB, 0.81975857E-10_JPRB, 0.90301780E-10_JPRB, &
  & 0.95615786E-10_JPRB, 0.98394008E-10_JPRB, 0.99174800E-10_JPRB, 0.98347858E-10_JPRB, 0.96017090E-10_JPRB, 0.92421515E-10_JPRB, &
  & 0.87399823E-10_JPRB, 0.80431099E-10_JPRB, 0.71947115E-10_JPRB, 0.60939045E-10_JPRB, 0.48637584E-10_JPRB, 0.35182871E-10_JPRB, &
  & 0.23039858E-10_JPRB, 0.13275599E-10_JPRB, 0.66840058E-11_JPRB, 0.29152494E-11_JPRB /)

RGHG4(:,39, 2) = (/ &
  & 0.76330048E-09_JPRB, 0.64057826E-09_JPRB, 0.55983973E-09_JPRB, 0.47374421E-09_JPRB, 0.41039516E-09_JPRB, 0.36668640E-09_JPRB, &
  & 0.33567130E-09_JPRB, 0.31236230E-09_JPRB, 0.29390773E-09_JPRB, 0.27848285E-09_JPRB, 0.26402402E-09_JPRB, 0.24915522E-09_JPRB, &
  & 0.23200566E-09_JPRB, 0.21089272E-09_JPRB, 0.18459285E-09_JPRB, 0.15354136E-09_JPRB, 0.11994136E-09_JPRB, 0.87579007E-10_JPRB, &
  & 0.60171659E-10_JPRB, 0.39528297E-10_JPRB, 0.25880454E-10_JPRB, 0.17373240E-10_JPRB, 0.12272770E-10_JPRB, 0.91349168E-11_JPRB, &
  & 0.71580649E-11_JPRB, 0.57954167E-11_JPRB, 0.48537212E-11_JPRB, 0.41137033E-11_JPRB, 0.35572775E-11_JPRB, 0.31807716E-11_JPRB, &
  & 0.29468849E-11_JPRB, 0.29155172E-11_JPRB, 0.30645126E-11_JPRB, 0.34615928E-11_JPRB, 0.40970929E-11_JPRB, 0.50110610E-11_JPRB, &
  & 0.61849414E-11_JPRB, 0.76759623E-11_JPRB, 0.95776234E-11_JPRB, 0.12100521E-10_JPRB, 0.15549719E-10_JPRB, 0.20422499E-10_JPRB, &
  & 0.27248977E-10_JPRB, 0.36341631E-10_JPRB, 0.47241513E-10_JPRB, 0.58572668E-10_JPRB, 0.68614343E-10_JPRB, 0.76281197E-10_JPRB, &
  & 0.81350489E-10_JPRB, 0.84187941E-10_JPRB, 0.85154182E-10_JPRB, 0.84591001E-10_JPRB, 0.82675707E-10_JPRB, 0.79679457E-10_JPRB, &
  & 0.75416354E-10_JPRB, 0.69528057E-10_JPRB, 0.62383231E-10_JPRB, 0.53097384E-10_JPRB, 0.42677972E-10_JPRB, 0.31230640E-10_JPRB, &
  & 0.20844373E-10_JPRB, 0.12210398E-10_JPRB, 0.63419487E-11_JPRB, 0.28158263E-11_JPRB /)

RGHG4(:,40, 2) = (/ &
  & 0.67581279E-09_JPRB, 0.56688637E-09_JPRB, 0.49551957E-09_JPRB, 0.41787074E-09_JPRB, 0.36119563E-09_JPRB, 0.32213485E-09_JPRB, &
  & 0.29461636E-09_JPRB, 0.27367955E-09_JPRB, 0.25701677E-09_JPRB, 0.24323973E-09_JPRB, 0.23073254E-09_JPRB, 0.21775096E-09_JPRB, &
  & 0.20296652E-09_JPRB, 0.18429168E-09_JPRB, 0.16039046E-09_JPRB, 0.13126286E-09_JPRB, 0.99852203E-10_JPRB, 0.70234263E-10_JPRB, &
  & 0.46452175E-10_JPRB, 0.29911539E-10_JPRB, 0.19461275E-10_JPRB, 0.13308079E-10_JPRB, 0.96201432E-11_JPRB, 0.73970049E-11_JPRB, &
  & 0.59395006E-11_JPRB, 0.49456936E-11_JPRB, 0.42184164E-11_JPRB, 0.36391107E-11_JPRB, 0.31804925E-11_JPRB, 0.28566810E-11_JPRB, &
  & 0.26441165E-11_JPRB, 0.25991516E-11_JPRB, 0.27102305E-11_JPRB, 0.30355475E-11_JPRB, 0.35693254E-11_JPRB, 0.43407083E-11_JPRB, &
  & 0.53289274E-11_JPRB, 0.65883197E-11_JPRB, 0.81933427E-11_JPRB, 0.10309446E-10_JPRB, 0.13207078E-10_JPRB, 0.17256419E-10_JPRB, &
  & 0.22911378E-10_JPRB, 0.30491266E-10_JPRB, 0.39675995E-10_JPRB, 0.49365758E-10_JPRB, 0.58083743E-10_JPRB, 0.64963028E-10_JPRB, &
  & 0.69696339E-10_JPRB, 0.72438035E-10_JPRB, 0.73510496E-10_JPRB, 0.73191384E-10_JPRB, 0.71615609E-10_JPRB, 0.68930354E-10_JPRB, &
  & 0.65180063E-10_JPRB, 0.60101833E-10_JPRB, 0.54204748E-10_JPRB, 0.46406490E-10_JPRB, 0.37634951E-10_JPRB, 0.27921328E-10_JPRB, &
  & 0.18956585E-10_JPRB, 0.11486894E-10_JPRB, 0.60516054E-11_JPRB, 0.27754871E-11_JPRB /)

RGHG4(:,41, 2) = (/ &
  & 0.59586447E-09_JPRB, 0.49919063E-09_JPRB, 0.43566192E-09_JPRB, 0.36657213E-09_JPRB, 0.31525285E-09_JPRB, 0.28051167E-09_JPRB, &
  & 0.25630770E-09_JPRB, 0.23802776E-09_JPRB, 0.22368009E-09_JPRB, 0.21170429E-09_JPRB, 0.20081108E-09_JPRB, 0.18951886E-09_JPRB, &
  & 0.17654095E-09_JPRB, 0.16009362E-09_JPRB, 0.13869787E-09_JPRB, 0.11201144E-09_JPRB, 0.83198552E-10_JPRB, 0.56817662E-10_JPRB, &
  & 0.36848753E-10_JPRB, 0.23676415E-10_JPRB, 0.15662232E-10_JPRB, 0.10957366E-10_JPRB, 0.81211860E-11_JPRB, 0.64056217E-11_JPRB, &
  & 0.52214986E-11_JPRB, 0.44329605E-11_JPRB, 0.38171783E-11_JPRB, 0.33297210E-11_JPRB, 0.29255712E-11_JPRB, 0.26373528E-11_JPRB, &
  & 0.24389388E-11_JPRB, 0.23895029E-11_JPRB, 0.24772430E-11_JPRB, 0.27584035E-11_JPRB, 0.32303325E-11_JPRB, 0.39108265E-11_JPRB, &
  & 0.47816534E-11_JPRB, 0.58816485E-11_JPRB, 0.72764060E-11_JPRB, 0.91205906E-11_JPRB, 0.11617271E-10_JPRB, 0.15077840E-10_JPRB, &
  & 0.19875993E-10_JPRB, 0.26228219E-10_JPRB, 0.33968238E-10_JPRB, 0.42157992E-10_JPRB, 0.49722126E-10_JPRB, 0.55773344E-10_JPRB, &
  & 0.60014042E-10_JPRB, 0.62604547E-10_JPRB, 0.63691163E-10_JPRB, 0.63428034E-10_JPRB, 0.61907986E-10_JPRB, 0.59486090E-10_JPRB, &
  & 0.56242278E-10_JPRB, 0.51918348E-10_JPRB, 0.47076797E-10_JPRB, 0.40565395E-10_JPRB, 0.33237704E-10_JPRB, 0.25061305E-10_JPRB, &
  & 0.17424812E-10_JPRB, 0.10863325E-10_JPRB, 0.59258249E-11_JPRB, 0.27660502E-11_JPRB /)

RGHG4(:,42, 2) = (/ &
  & 0.52065974E-09_JPRB, 0.43582696E-09_JPRB, 0.37959971E-09_JPRB, 0.31811592E-09_JPRB, 0.27229419E-09_JPRB, 0.24176158E-09_JPRB, &
  & 0.22084030E-09_JPRB, 0.20514190E-09_JPRB, 0.19288882E-09_JPRB, 0.18286690E-09_JPRB, 0.17356974E-09_JPRB, 0.16396731E-09_JPRB, &
  & 0.15277357E-09_JPRB, 0.13832799E-09_JPRB, 0.11918885E-09_JPRB, 0.95176762E-10_JPRB, 0.69147368E-10_JPRB, 0.46413685E-10_JPRB, &
  & 0.29741092E-10_JPRB, 0.19345811E-10_JPRB, 0.13097144E-10_JPRB, 0.93915093E-11_JPRB, 0.71173089E-11_JPRB, 0.57149411E-11_JPRB, &
  & 0.47124288E-11_JPRB, 0.40499735E-11_JPRB, 0.35022092E-11_JPRB, 0.30777488E-11_JPRB, 0.27112971E-11_JPRB, 0.24542820E-11_JPRB, &
  & 0.22682420E-11_JPRB, 0.22211480E-11_JPRB, 0.22950932E-11_JPRB, 0.25462664E-11_JPRB, 0.29736281E-11_JPRB, 0.35892942E-11_JPRB, &
  & 0.43715183E-11_JPRB, 0.53494297E-11_JPRB, 0.65866171E-11_JPRB, 0.82031500E-11_JPRB, 0.10380542E-10_JPRB, 0.13373547E-10_JPRB, &
  & 0.17472775E-10_JPRB, 0.22896882E-10_JPRB, 0.29468868E-10_JPRB, 0.36449361E-10_JPRB, 0.42850973E-10_JPRB, 0.48084703E-10_JPRB, &
  & 0.51874262E-10_JPRB, 0.54299603E-10_JPRB, 0.55362291E-10_JPRB, 0.55139990E-10_JPRB, 0.53792124E-10_JPRB, 0.51565949E-10_JPRB, &
  & 0.48598809E-10_JPRB, 0.44797884E-10_JPRB, 0.40894187E-10_JPRB, 0.35450778E-10_JPRB, 0.29386590E-10_JPRB, 0.22549233E-10_JPRB, &
  & 0.16070473E-10_JPRB, 0.10447696E-10_JPRB, 0.58505852E-11_JPRB, 0.28216385E-11_JPRB /)

RGHG4(:,43, 2) = (/ &
  & 0.45212351E-09_JPRB, 0.37732559E-09_JPRB, 0.32804953E-09_JPRB, 0.27358291E-09_JPRB, 0.23310009E-09_JPRB, 0.20626358E-09_JPRB, &
  & 0.18803176E-09_JPRB, 0.17443895E-09_JPRB, 0.16385392E-09_JPRB, 0.15554014E-09_JPRB, 0.14774414E-09_JPRB, 0.13965483E-09_JPRB, &
  & 0.13013685E-09_JPRB, 0.11784156E-09_JPRB, 0.10122255E-09_JPRB, 0.80020122E-10_JPRB, 0.57371035E-10_JPRB, 0.38086759E-10_JPRB, &
  & 0.24717504E-10_JPRB, 0.16318802E-10_JPRB, 0.11355767E-10_JPRB, 0.83255052E-11_JPRB, 0.64407334E-11_JPRB, 0.52224483E-11_JPRB, &
  & 0.43481347E-11_JPRB, 0.37505598E-11_JPRB, 0.32493899E-11_JPRB, 0.28621762E-11_JPRB, 0.25269925E-11_JPRB, 0.22909307E-11_JPRB, &
  & 0.21261337E-11_JPRB, 0.20817924E-11_JPRB, 0.21523720E-11_JPRB, 0.23815370E-11_JPRB, 0.27790402E-11_JPRB, 0.33471466E-11_JPRB, &
  & 0.40645391E-11_JPRB, 0.49491305E-11_JPRB, 0.60554821E-11_JPRB, 0.74883858E-11_JPRB, 0.94035170E-11_JPRB, 0.11995999E-10_JPRB, &
  & 0.15512130E-10_JPRB, 0.20095758E-10_JPRB, 0.25630999E-10_JPRB, 0.31500552E-10_JPRB, 0.36959689E-10_JPRB, 0.41465765E-10_JPRB, &
  & 0.44830004E-10_JPRB, 0.47070868E-10_JPRB, 0.48130055E-10_JPRB, 0.47986549E-10_JPRB, 0.46697896E-10_JPRB, 0.44595834E-10_JPRB, &
  & 0.41978830E-10_JPRB, 0.38709515E-10_JPRB, 0.35606032E-10_JPRB, 0.31046710E-10_JPRB, 0.26053808E-10_JPRB, 0.20392358E-10_JPRB, &
  & 0.14969683E-10_JPRB, 0.10159529E-10_JPRB, 0.59046236E-11_JPRB, 0.29373322E-11_JPRB /)

RGHG4(:,44, 2) = (/ &
  & 0.38851844E-09_JPRB, 0.32257405E-09_JPRB, 0.27984029E-09_JPRB, 0.23247773E-09_JPRB, 0.19727608E-09_JPRB, 0.17389848E-09_JPRB, &
  & 0.15815260E-09_JPRB, 0.14632502E-09_JPRB, 0.13724426E-09_JPRB, 0.13025088E-09_JPRB, 0.12382584E-09_JPRB, 0.11713382E-09_JPRB, &
  & 0.10920470E-09_JPRB, 0.98774981E-10_JPRB, 0.84636735E-10_JPRB, 0.66363852E-10_JPRB, 0.47123257E-10_JPRB, 0.31312668E-10_JPRB, &
  & 0.20669367E-10_JPRB, 0.14048224E-10_JPRB, 0.10046273E-10_JPRB, 0.75132366E-11_JPRB, 0.59177689E-11_JPRB, 0.48198806E-11_JPRB, &
  & 0.40461731E-11_JPRB, 0.34872602E-11_JPRB, 0.30167828E-11_JPRB, 0.26579906E-11_JPRB, 0.23513080E-11_JPRB, 0.21338014E-11_JPRB, &
  & 0.19927027E-11_JPRB, 0.19537705E-11_JPRB, 0.20284612E-11_JPRB, 0.22413907E-11_JPRB, 0.26177207E-11_JPRB, 0.31481471E-11_JPRB, &
  & 0.38135727E-11_JPRB, 0.46195491E-11_JPRB, 0.56168117E-11_JPRB, 0.68902709E-11_JPRB, 0.85694117E-11_JPRB, 0.10809167E-10_JPRB, &
  & 0.13803619E-10_JPRB, 0.17658116E-10_JPRB, 0.22308677E-10_JPRB, 0.27227836E-10_JPRB, 0.31813316E-10_JPRB, 0.35679210E-10_JPRB, &
  & 0.38637159E-10_JPRB, 0.40712014E-10_JPRB, 0.41763988E-10_JPRB, 0.41687761E-10_JPRB, 0.40566231E-10_JPRB, 0.38731119E-10_JPRB, &
  & 0.36449212E-10_JPRB, 0.33633180E-10_JPRB, 0.31221619E-10_JPRB, 0.27413604E-10_JPRB, 0.23300181E-10_JPRB, 0.18617920E-10_JPRB, &
  & 0.14091691E-10_JPRB, 0.10075005E-10_JPRB, 0.60878893E-11_JPRB, 0.31466071E-11_JPRB /)

RGHG4(:,45, 2) = (/ &
  & 0.32829869E-09_JPRB, 0.27113520E-09_JPRB, 0.23367167E-09_JPRB, 0.19407215E-09_JPRB, 0.16389340E-09_JPRB, 0.14396785E-09_JPRB, &
  & 0.13030714E-09_JPRB, 0.12014119E-09_JPRB, 0.11229379E-09_JPRB, 0.10650818E-09_JPRB, 0.10125657E-09_JPRB, 0.95822010E-10_JPRB, &
  & 0.89499012E-10_JPRB, 0.81011288E-10_JPRB, 0.69286195E-10_JPRB, 0.54078776E-10_JPRB, 0.38332688E-10_JPRB, 0.25811783E-10_JPRB, &
  & 0.17515569E-10_JPRB, 0.12257683E-10_JPRB, 0.90186530E-11_JPRB, 0.68639265E-11_JPRB, 0.54974688E-11_JPRB, 0.44820488E-11_JPRB, &
  & 0.37848756E-11_JPRB, 0.32446166E-11_JPRB, 0.28066330E-11_JPRB, 0.24621557E-11_JPRB, 0.21849204E-11_JPRB, 0.19790749E-11_JPRB, &
  & 0.18710010E-11_JPRB, 0.18349690E-11_JPRB, 0.19191350E-11_JPRB, 0.21198939E-11_JPRB, 0.24798841E-11_JPRB, 0.29797814E-11_JPRB, &
  & 0.36014572E-11_JPRB, 0.43414517E-11_JPRB, 0.52423643E-11_JPRB, 0.63744704E-11_JPRB, 0.78428366E-11_JPRB, 0.97624114E-11_JPRB, &
  & 0.12271827E-10_JPRB, 0.15451912E-10_JPRB, 0.19251446E-10_JPRB, 0.23330561E-10_JPRB, 0.27182369E-10_JPRB, 0.30485586E-10_JPRB, &
  & 0.33085683E-10_JPRB, 0.34985917E-10_JPRB, 0.36023174E-10_JPRB, 0.36056741E-10_JPRB, 0.35123491E-10_JPRB, 0.33548768E-10_JPRB, &
  & 0.31607526E-10_JPRB, 0.29282743E-10_JPRB, 0.27514662E-10_JPRB, 0.24351989E-10_JPRB, 0.20968921E-10_JPRB, 0.17139561E-10_JPRB, &
  & 0.13406170E-10_JPRB, 0.10152890E-10_JPRB, 0.64299204E-11_JPRB, 0.34736122E-11_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART4',0,ZHOOK_HANDLE)



RGHG4(:,46, 2) = (/ &
  & 0.27145905E-09_JPRB, 0.22103704E-09_JPRB, 0.19022293E-09_JPRB, 0.15713841E-09_JPRB, 0.13273137E-09_JPRB, 0.11592251E-09_JPRB, &
  & 0.10439261E-09_JPRB, 0.95576200E-10_JPRB, 0.88901386E-10_JPRB, 0.84189468E-10_JPRB, 0.80057606E-10_JPRB, 0.75942322E-10_JPRB, &
  & 0.71077901E-10_JPRB, 0.64649723E-10_JPRB, 0.55338081E-10_JPRB, 0.43228643E-10_JPRB, 0.30943390E-10_JPRB, 0.21342046E-10_JPRB, &
  & 0.15018395E-10_JPRB, 0.10890957E-10_JPRB, 0.82237680E-11_JPRB, 0.63750997E-11_JPRB, 0.51471336E-11_JPRB, 0.42063302E-11_JPRB, &
  & 0.35570325E-11_JPRB, 0.30279856E-11_JPRB, 0.26076029E-11_JPRB, 0.22759637E-11_JPRB, 0.20308043E-11_JPRB, 0.18326358E-11_JPRB, &
  & 0.17565381E-11_JPRB, 0.17287551E-11_JPRB, 0.18224413E-11_JPRB, 0.20195367E-11_JPRB, 0.23683210E-11_JPRB, 0.28450304E-11_JPRB, &
  & 0.34309756E-11_JPRB, 0.41141569E-11_JPRB, 0.49339213E-11_JPRB, 0.59418603E-11_JPRB, 0.72235022E-11_JPRB, 0.88543391E-11_JPRB, &
  & 0.10931260E-10_JPRB, 0.13487746E-10_JPRB, 0.16526471E-10_JPRB, 0.19791717E-10_JPRB, 0.22956732E-10_JPRB, 0.25745643E-10_JPRB, &
  & 0.27998638E-10_JPRB, 0.29729913E-10_JPRB, 0.30741847E-10_JPRB, 0.30877245E-10_JPRB, 0.30189212E-10_JPRB, 0.28900094E-10_JPRB, &
  & 0.27326839E-10_JPRB, 0.25500333E-10_JPRB, 0.24294405E-10_JPRB, 0.21740842E-10_JPRB, 0.18984290E-10_JPRB, 0.15892988E-10_JPRB, &
  & 0.12829236E-10_JPRB, 0.10375527E-10_JPRB, 0.68835918E-11_JPRB, 0.39330219E-11_JPRB /)

RGHG4(:,47, 2) = (/ &
  & 0.21832867E-09_JPRB, 0.17605406E-09_JPRB, 0.14982852E-09_JPRB, 0.12439032E-09_JPRB, 0.10478549E-09_JPRB, 0.91149789E-10_JPRB, &
  & 0.81510472E-10_JPRB, 0.74138189E-10_JPRB, 0.68536600E-10_JPRB, 0.64794704E-10_JPRB, 0.61638965E-10_JPRB, 0.58451403E-10_JPRB, &
  & 0.54934904E-10_JPRB, 0.49945523E-10_JPRB, 0.43144800E-10_JPRB, 0.33876540E-10_JPRB, 0.24801937E-10_JPRB, 0.17745312E-10_JPRB, &
  & 0.12989017E-10_JPRB, 0.97635702E-11_JPRB, 0.75547294E-11_JPRB, 0.59629094E-11_JPRB, 0.48390870E-11_JPRB, 0.39659777E-11_JPRB, &
  & 0.33410379E-11_JPRB, 0.28231135E-11_JPRB, 0.24217473E-11_JPRB, 0.20986333E-11_JPRB, 0.18855614E-11_JPRB, 0.17022578E-11_JPRB, &
  & 0.16477023E-11_JPRB, 0.16386685E-11_JPRB, 0.17347964E-11_JPRB, 0.19346952E-11_JPRB, 0.22726489E-11_JPRB, 0.27306410E-11_JPRB, &
  & 0.32822666E-11_JPRB, 0.39183665E-11_JPRB, 0.46645474E-11_JPRB, 0.55645037E-11_JPRB, 0.66773765E-11_JPRB, 0.80490632E-11_JPRB, &
  & 0.97248225E-11_JPRB, 0.11706532E-10_JPRB, 0.14000304E-10_JPRB, 0.16489208E-10_JPRB, 0.18978737E-10_JPRB, 0.21244640E-10_JPRB, &
  & 0.23169938E-10_JPRB, 0.24717201E-10_JPRB, 0.25714366E-10_JPRB, 0.25961082E-10_JPRB, 0.25509409E-10_JPRB, 0.24613749E-10_JPRB, &
  & 0.23395728E-10_JPRB, 0.22026544E-10_JPRB, 0.21359612E-10_JPRB, 0.19332784E-10_JPRB, 0.17154634E-10_JPRB, 0.14712747E-10_JPRB, &
  & 0.12253519E-10_JPRB, 0.10617044E-10_JPRB, 0.73801113E-11_JPRB, 0.45012219E-11_JPRB /)

RGHG4(:,48, 2) = (/ &
  & 0.16950850E-09_JPRB, 0.13482063E-09_JPRB, 0.11441108E-09_JPRB, 0.95147855E-10_JPRB, 0.80459847E-10_JPRB, 0.69796856E-10_JPRB, &
  & 0.62058726E-10_JPRB, 0.56117597E-10_JPRB, 0.51486704E-10_JPRB, 0.48628573E-10_JPRB, 0.46206514E-10_JPRB, 0.43886429E-10_JPRB, &
  & 0.41246572E-10_JPRB, 0.37806591E-10_JPRB, 0.32779966E-10_JPRB, 0.26407210E-10_JPRB, 0.19947021E-10_JPRB, 0.14958595E-10_JPRB, &
  & 0.11433542E-10_JPRB, 0.89164743E-11_JPRB, 0.70357335E-11_JPRB, 0.56594811E-11_JPRB, 0.45770631E-11_JPRB, 0.37738983E-11_JPRB, &
  & 0.31505347E-11_JPRB, 0.26395561E-11_JPRB, 0.22527219E-11_JPRB, 0.19405699E-11_JPRB, 0.17496692E-11_JPRB, 0.16029581E-11_JPRB, &
  & 0.15469311E-11_JPRB, 0.15696034E-11_JPRB, 0.16637755E-11_JPRB, 0.18713794E-11_JPRB, 0.22015653E-11_JPRB, 0.26456047E-11_JPRB, &
  & 0.31719109E-11_JPRB, 0.37685011E-11_JPRB, 0.44560080E-11_JPRB, 0.52631285E-11_JPRB, 0.62336872E-11_JPRB, 0.73776306E-11_JPRB, &
  & 0.87026992E-11_JPRB, 0.10173582E-10_JPRB, 0.11787197E-10_JPRB, 0.13500465E-10_JPRB, 0.15252678E-10_JPRB, 0.16969011E-10_JPRB, &
  & 0.18497552E-10_JPRB, 0.19861390E-10_JPRB, 0.20828308E-10_JPRB, 0.21210964E-10_JPRB, 0.21033526E-10_JPRB, 0.20438193E-10_JPRB, &
  & 0.19638301E-10_JPRB, 0.18666714E-10_JPRB, 0.18490905E-10_JPRB, 0.16960518E-10_JPRB, 0.15317029E-10_JPRB, 0.13453937E-10_JPRB, &
  & 0.11559043E-10_JPRB, 0.10708499E-10_JPRB, 0.77886395E-11_JPRB, 0.51014037E-11_JPRB /)

RGHG4(:,49, 2) = (/ &
  & 0.12718442E-09_JPRB, 0.99663985E-10_JPRB, 0.84520432E-10_JPRB, 0.70824735E-10_JPRB, 0.60085215E-10_JPRB, 0.51851839E-10_JPRB, &
  & 0.45700402E-10_JPRB, 0.40993604E-10_JPRB, 0.37177355E-10_JPRB, 0.34948967E-10_JPRB, 0.33165082E-10_JPRB, 0.31448167E-10_JPRB, &
  & 0.29683568E-10_JPRB, 0.27365877E-10_JPRB, 0.24307131E-10_JPRB, 0.20274870E-10_JPRB, 0.16154912E-10_JPRB, 0.12749413E-10_JPRB, &
  & 0.10172563E-10_JPRB, 0.82176869E-11_JPRB, 0.66139711E-11_JPRB, 0.53973445E-11_JPRB, 0.43560312E-11_JPRB, 0.35969875E-11_JPRB, &
  & 0.29660345E-11_JPRB, 0.24721681E-11_JPRB, 0.20977259E-11_JPRB, 0.18094220E-11_JPRB, 0.16266760E-11_JPRB, 0.15264840E-11_JPRB, &
  & 0.14684514E-11_JPRB, 0.15118616E-11_JPRB, 0.16116133E-11_JPRB, 0.18228036E-11_JPRB, 0.21473368E-11_JPRB, 0.25796359E-11_JPRB, &
  & 0.30835339E-11_JPRB, 0.36462677E-11_JPRB, 0.42811536E-11_JPRB, 0.50090704E-11_JPRB, 0.58513762E-11_JPRB, 0.67938016E-11_JPRB, &
  & 0.78064361E-11_JPRB, 0.88190132E-11_JPRB, 0.98094848E-11_JPRB, 0.10771700E-10_JPRB, 0.11759454E-10_JPRB, 0.12802728E-10_JPRB, &
  & 0.13889062E-10_JPRB, 0.14982637E-10_JPRB, 0.15893179E-10_JPRB, 0.16389591E-10_JPRB, 0.16438404E-10_JPRB, 0.16169085E-10_JPRB, &
  & 0.15742062E-10_JPRB, 0.15164529E-10_JPRB, 0.15448892E-10_JPRB, 0.14396035E-10_JPRB, 0.13257142E-10_JPRB, 0.11941126E-10_JPRB, &
  & 0.10587415E-10_JPRB, 0.10474245E-10_JPRB, 0.79683985E-11_JPRB, 0.56009381E-11_JPRB /)

RGHG4(:,50, 2) = (/ &
  & 0.92785439E-10_JPRB, 0.72529496E-10_JPRB, 0.61517680E-10_JPRB, 0.51855763E-10_JPRB, 0.43925686E-10_JPRB, 0.37389782E-10_JPRB, &
  & 0.32414620E-10_JPRB, 0.28715946E-10_JPRB, 0.25530385E-10_JPRB, 0.23904951E-10_JPRB, 0.22686285E-10_JPRB, 0.21593102E-10_JPRB, &
  & 0.20581443E-10_JPRB, 0.19322093E-10_JPRB, 0.17826724E-10_JPRB, 0.15622344E-10_JPRB, 0.13237519E-10_JPRB, 0.11043918E-10_JPRB, &
  & 0.91880800E-11_JPRB, 0.76576141E-11_JPRB, 0.62791708E-11_JPRB, 0.51709162E-11_JPRB, 0.41770892E-11_JPRB, 0.34318874E-11_JPRB, &
  & 0.28065512E-11_JPRB, 0.23230278E-11_JPRB, 0.19704243E-11_JPRB, 0.17104373E-11_JPRB, 0.15374200E-11_JPRB, 0.14645649E-11_JPRB, &
  & 0.14267360E-11_JPRB, 0.14691375E-11_JPRB, 0.15819464E-11_JPRB, 0.17928258E-11_JPRB, 0.21132553E-11_JPRB, 0.25346327E-11_JPRB, &
  & 0.30179385E-11_JPRB, 0.35506648E-11_JPRB, 0.41421046E-11_JPRB, 0.47998051E-11_JPRB, 0.55308991E-11_JPRB, 0.62976985E-11_JPRB, &
  & 0.70393955E-11_JPRB, 0.76678603E-11_JPRB, 0.81383138E-11_JPRB, 0.84646890E-11_JPRB, 0.87744716E-11_JPRB, 0.91739134E-11_JPRB, &
  & 0.97180996E-11_JPRB, 0.10415368E-10_JPRB, 0.11119290E-10_JPRB, 0.11610338E-10_JPRB, 0.11825433E-10_JPRB, 0.11832721E-10_JPRB, &
  & 0.11697831E-10_JPRB, 0.11471146E-10_JPRB, 0.12170055E-10_JPRB, 0.11556527E-10_JPRB, 0.10880845E-10_JPRB, 0.10085827E-10_JPRB, &
  & 0.92087275E-11_JPRB, 0.97456444E-11_JPRB, 0.77530629E-11_JPRB, 0.58094540E-11_JPRB /)

RGHG4(:,51, 2) = (/ &
  & 0.66337956E-10_JPRB, 0.51512655E-10_JPRB, 0.43601591E-10_JPRB, 0.36832901E-10_JPRB, 0.30668596E-10_JPRB, 0.25445734E-10_JPRB, &
  & 0.21443767E-10_JPRB, 0.18843547E-10_JPRB, 0.16418072E-10_JPRB, 0.15456520E-10_JPRB, 0.14826961E-10_JPRB, 0.14349034E-10_JPRB, &
  & 0.13969655E-10_JPRB, 0.13609905E-10_JPRB, 0.13087421E-10_JPRB, 0.12309923E-10_JPRB, 0.11049783E-10_JPRB, 0.97278392E-11_JPRB, &
  & 0.84070875E-11_JPRB, 0.71978729E-11_JPRB, 0.60233758E-11_JPRB, 0.49682216E-11_JPRB, 0.40430107E-11_JPRB, 0.32822237E-11_JPRB, &
  & 0.26689957E-11_JPRB, 0.22084630E-11_JPRB, 0.18766002E-11_JPRB, 0.16499894E-11_JPRB, 0.14933577E-11_JPRB, 0.14279970E-11_JPRB, &
  & 0.14096497E-11_JPRB, 0.14585463E-11_JPRB, 0.15679875E-11_JPRB, 0.17902786E-11_JPRB, 0.21025681E-11_JPRB, 0.25150632E-11_JPRB, &
  & 0.29768991E-11_JPRB, 0.34869028E-11_JPRB, 0.40390703E-11_JPRB, 0.46352154E-11_JPRB, 0.52668070E-11_JPRB, 0.58777328E-11_JPRB, &
  & 0.63849906E-11_JPRB, 0.66953903E-11_JPRB, 0.67675696E-11_JPRB, 0.66600961E-11_JPRB, 0.65132314E-11_JPRB, 0.64614074E-11_JPRB, &
  & 0.65517283E-11_JPRB, 0.68029896E-11_JPRB, 0.71220009E-11_JPRB, 0.74102243E-11_JPRB, 0.75907761E-11_JPRB, 0.76909087E-11_JPRB, &
  & 0.77523751E-11_JPRB, 0.77520412E-11_JPRB, 0.87486659E-11_JPRB, 0.85097459E-11_JPRB, 0.82270987E-11_JPRB, 0.78538018E-11_JPRB, &
  & 0.73896618E-11_JPRB, 0.84509422E-11_JPRB, 0.70150882E-11_JPRB, 0.56123821E-11_JPRB /)

RGHG4(:,52, 2) = (/ &
  & 0.46685048E-10_JPRB, 0.35932167E-10_JPRB, 0.30503385E-10_JPRB, 0.25312911E-10_JPRB, 0.20697761E-10_JPRB, 0.16550046E-10_JPRB, &
  & 0.13884116E-10_JPRB, 0.12334863E-10_JPRB, 0.10652641E-10_JPRB, 0.10218637E-10_JPRB, 0.99919656E-11_JPRB, 0.98694906E-11_JPRB, &
  & 0.98602532E-11_JPRB, 0.98982645E-11_JPRB, 0.99662388E-11_JPRB, 0.98560700E-11_JPRB, 0.94103154E-11_JPRB, 0.86731776E-11_JPRB, &
  & 0.77742300E-11_JPRB, 0.67996941E-11_JPRB, 0.57993944E-11_JPRB, 0.48059334E-11_JPRB, 0.39223316E-11_JPRB, 0.31734311E-11_JPRB, &
  & 0.25796383E-11_JPRB, 0.21381469E-11_JPRB, 0.18307591E-11_JPRB, 0.16304782E-11_JPRB, 0.14955156E-11_JPRB, 0.14371179E-11_JPRB, &
  & 0.14181441E-11_JPRB, 0.14907511E-11_JPRB, 0.15830750E-11_JPRB, 0.18201740E-11_JPRB, 0.21152221E-11_JPRB, 0.25230720E-11_JPRB, &
  & 0.29663782E-11_JPRB, 0.34547430E-11_JPRB, 0.39702950E-11_JPRB, 0.45079660E-11_JPRB, 0.50481368E-11_JPRB, 0.55173600E-11_JPRB, &
  & 0.58230235E-11_JPRB, 0.58860677E-11_JPRB, 0.56892451E-11_JPRB, 0.53443834E-11_JPRB, 0.49903493E-11_JPRB, 0.47294525E-11_JPRB, &
  & 0.45863218E-11_JPRB, 0.45478378E-11_JPRB, 0.45785654E-11_JPRB, 0.46296339E-11_JPRB, 0.46835886E-11_JPRB, 0.47463704E-11_JPRB, &
  & 0.47960065E-11_JPRB, 0.48587367E-11_JPRB, 0.59203259E-11_JPRB, 0.58653872E-11_JPRB, 0.58024644E-11_JPRB, 0.56686314E-11_JPRB, &
  & 0.54990786E-11_JPRB, 0.68285833E-11_JPRB, 0.59007985E-11_JPRB, 0.50460231E-11_JPRB /)

RGHG4(:,53, 2) = (/ &
  & 0.32649997E-10_JPRB, 0.24910364E-10_JPRB, 0.20676126E-10_JPRB, 0.17158878E-10_JPRB, 0.13581548E-10_JPRB, 0.10971596E-10_JPRB, &
  & 0.94742096E-11_JPRB, 0.87540235E-11_JPRB, 0.75642912E-11_JPRB, 0.74132488E-11_JPRB, 0.73618923E-11_JPRB, 0.73793888E-11_JPRB, &
  & 0.75002929E-11_JPRB, 0.76733455E-11_JPRB, 0.79711602E-11_JPRB, 0.82021872E-11_JPRB, 0.82069898E-11_JPRB, 0.78812226E-11_JPRB, &
  & 0.72857501E-11_JPRB, 0.64986805E-11_JPRB, 0.56063917E-11_JPRB, 0.46962256E-11_JPRB, 0.38401413E-11_JPRB, 0.31011860E-11_JPRB, &
  & 0.25337764E-11_JPRB, 0.21181210E-11_JPRB, 0.18361283E-11_JPRB, 0.16589290E-11_JPRB, 0.15418744E-11_JPRB, 0.14924312E-11_JPRB, &
  & 0.14678192E-11_JPRB, 0.15457239E-11_JPRB, 0.16460387E-11_JPRB, 0.18808477E-11_JPRB, 0.21775938E-11_JPRB, 0.25735737E-11_JPRB, &
  & 0.29998530E-11_JPRB, 0.34688884E-11_JPRB, 0.39514464E-11_JPRB, 0.44328204E-11_JPRB, 0.48890991E-11_JPRB, 0.52301206E-11_JPRB, &
  & 0.53662057E-11_JPRB, 0.52440829E-11_JPRB, 0.48996267E-11_JPRB, 0.44528686E-11_JPRB, 0.40457624E-11_JPRB, 0.37304231E-11_JPRB, &
  & 0.35128300E-11_JPRB, 0.33708477E-11_JPRB, 0.32841486E-11_JPRB, 0.32278225E-11_JPRB, 0.32077828E-11_JPRB, 0.32052000E-11_JPRB, &
  & 0.32346617E-11_JPRB, 0.32828794E-11_JPRB, 0.42444936E-11_JPRB, 0.42409045E-11_JPRB, 0.42273190E-11_JPRB, 0.41792789E-11_JPRB, &
  & 0.41343049E-11_JPRB, 0.54314339E-11_JPRB, 0.48242495E-11_JPRB, 0.43498360E-11_JPRB /)

RGHG4(:,54, 2) = (/ &
  & 0.22662382E-10_JPRB, 0.16912690E-10_JPRB, 0.14147967E-10_JPRB, 0.11529375E-10_JPRB, 0.93578660E-11_JPRB, 0.78456096E-11_JPRB, &
  & 0.71727784E-11_JPRB, 0.68724319E-11_JPRB, 0.59357757E-11_JPRB, 0.58952248E-11_JPRB, 0.59003202E-11_JPRB, 0.59563634E-11_JPRB, &
  & 0.60752427E-11_JPRB, 0.63016536E-11_JPRB, 0.65917194E-11_JPRB, 0.70222704E-11_JPRB, 0.72663316E-11_JPRB, 0.72522223E-11_JPRB, &
  & 0.69022604E-11_JPRB, 0.62745625E-11_JPRB, 0.54793262E-11_JPRB, 0.46308265E-11_JPRB, 0.38180045E-11_JPRB, 0.31151689E-11_JPRB, &
  & 0.25676850E-11_JPRB, 0.21751758E-11_JPRB, 0.19146932E-11_JPRB, 0.17541203E-11_JPRB, 0.16503373E-11_JPRB, 0.16078123E-11_JPRB, &
  & 0.15874556E-11_JPRB, 0.16493642E-11_JPRB, 0.17733586E-11_JPRB, 0.19833328E-11_JPRB, 0.22924210E-11_JPRB, 0.26756542E-11_JPRB, &
  & 0.30953042E-11_JPRB, 0.35467120E-11_JPRB, 0.39992042E-11_JPRB, 0.44216423E-11_JPRB, 0.47974645E-11_JPRB, 0.50151033E-11_JPRB, &
  & 0.50024316E-11_JPRB, 0.47514137E-11_JPRB, 0.43182025E-11_JPRB, 0.38549606E-11_JPRB, 0.34452027E-11_JPRB, 0.31424835E-11_JPRB, &
  & 0.29158000E-11_JPRB, 0.27529997E-11_JPRB, 0.26353195E-11_JPRB, 0.25579688E-11_JPRB, 0.25141627E-11_JPRB, 0.25078162E-11_JPRB, &
  & 0.25210680E-11_JPRB, 0.25482756E-11_JPRB, 0.34006441E-11_JPRB, 0.34049668E-11_JPRB, 0.34084042E-11_JPRB, 0.33848666E-11_JPRB, &
  & 0.33644682E-11_JPRB, 0.45465090E-11_JPRB, 0.41166636E-11_JPRB, 0.37857634E-11_JPRB /)

RGHG4(:,55, 2) = (/ &
  & 0.15978023E-10_JPRB, 0.11746660E-10_JPRB, 0.96942402E-11_JPRB, 0.81551987E-11_JPRB, 0.68944642E-11_JPRB, 0.61714952E-11_JPRB, &
  & 0.59096825E-11_JPRB, 0.58135259E-11_JPRB, 0.50340001E-11_JPRB, 0.50358663E-11_JPRB, 0.50605705E-11_JPRB, 0.51189344E-11_JPRB, &
  & 0.52404166E-11_JPRB, 0.54228406E-11_JPRB, 0.57532850E-11_JPRB, 0.61500991E-11_JPRB, 0.66069259E-11_JPRB, 0.67927981E-11_JPRB, &
  & 0.66281850E-11_JPRB, 0.61244100E-11_JPRB, 0.54160951E-11_JPRB, 0.46220089E-11_JPRB, 0.38446980E-11_JPRB, 0.31662487E-11_JPRB, &
  & 0.26390491E-11_JPRB, 0.22630055E-11_JPRB, 0.20191179E-11_JPRB, 0.18728417E-11_JPRB, 0.17815285E-11_JPRB, 0.17461344E-11_JPRB, &
  & 0.17400360E-11_JPRB, 0.17957526E-11_JPRB, 0.19357003E-11_JPRB, 0.21505042E-11_JPRB, 0.24716969E-11_JPRB, 0.28434286E-11_JPRB, &
  & 0.32612578E-11_JPRB, 0.36962226E-11_JPRB, 0.41225985E-11_JPRB, 0.44905412E-11_JPRB, 0.47939660E-11_JPRB, 0.48968000E-11_JPRB, &
  & 0.47627761E-11_JPRB, 0.44154532E-11_JPRB, 0.39494566E-11_JPRB, 0.34822670E-11_JPRB, 0.31051286E-11_JPRB, 0.28193760E-11_JPRB, &
  & 0.26026264E-11_JPRB, 0.24454150E-11_JPRB, 0.23258106E-11_JPRB, 0.22437354E-11_JPRB, 0.21994583E-11_JPRB, 0.21816982E-11_JPRB, &
  & 0.21837647E-11_JPRB, 0.22088160E-11_JPRB, 0.29769232E-11_JPRB, 0.29945100E-11_JPRB, 0.29987798E-11_JPRB, 0.29874907E-11_JPRB, &
  & 0.29805685E-11_JPRB, 0.40735332E-11_JPRB, 0.37542812E-11_JPRB, 0.34494978E-11_JPRB /)

RGHG4(:,56, 2) = (/ &
  & 0.11293702E-10_JPRB, 0.83550953E-11_JPRB, 0.70642802E-11_JPRB, 0.61706959E-11_JPRB, 0.55277549E-11_JPRB, 0.52478672E-11_JPRB, &
  & 0.51777458E-11_JPRB, 0.51780017E-11_JPRB, 0.44910980E-11_JPRB, 0.45092012E-11_JPRB, 0.45288747E-11_JPRB, 0.45830414E-11_JPRB, &
  & 0.46658593E-11_JPRB, 0.48549680E-11_JPRB, 0.51130098E-11_JPRB, 0.55689203E-11_JPRB, 0.60627553E-11_JPRB, 0.64470560E-11_JPRB, &
  & 0.64596722E-11_JPRB, 0.60526332E-11_JPRB, 0.53986269E-11_JPRB, 0.46603736E-11_JPRB, 0.39198818E-11_JPRB, 0.32630181E-11_JPRB, &
  & 0.27506482E-11_JPRB, 0.23911853E-11_JPRB, 0.21645296E-11_JPRB, 0.20309726E-11_JPRB, 0.19518998E-11_JPRB, 0.19219223E-11_JPRB, &
  & 0.19265451E-11_JPRB, 0.19886748E-11_JPRB, 0.21313431E-11_JPRB, 0.23680162E-11_JPRB, 0.26952318E-11_JPRB, 0.30820283E-11_JPRB, &
  & 0.35085125E-11_JPRB, 0.39386528E-11_JPRB, 0.43472001E-11_JPRB, 0.46567242E-11_JPRB, 0.48931297E-11_JPRB, 0.48979826E-11_JPRB, &
  & 0.46517044E-11_JPRB, 0.42323423E-11_JPRB, 0.37313004E-11_JPRB, 0.32761998E-11_JPRB, 0.29142181E-11_JPRB, 0.26441284E-11_JPRB, &
  & 0.24444906E-11_JPRB, 0.22917432E-11_JPRB, 0.21759601E-11_JPRB, 0.21003683E-11_JPRB, 0.20553214E-11_JPRB, 0.20440268E-11_JPRB, &
  & 0.20509783E-11_JPRB, 0.20822640E-11_JPRB, 0.27761367E-11_JPRB, 0.27869508E-11_JPRB, 0.28038316E-11_JPRB, 0.28047974E-11_JPRB, &
  & 0.28050541E-11_JPRB, 0.38532354E-11_JPRB, 0.35927138E-11_JPRB, 0.33140589E-11_JPRB /)

RGHG4(:,57, 2) = (/ &
  & 0.84240202E-11_JPRB, 0.62534617E-11_JPRB, 0.55404206E-11_JPRB, 0.50228021E-11_JPRB, 0.47419998E-11_JPRB, 0.46726646E-11_JPRB, &
  & 0.47121998E-11_JPRB, 0.47426394E-11_JPRB, 0.41423488E-11_JPRB, 0.41671883E-11_JPRB, 0.41942279E-11_JPRB, 0.42408199E-11_JPRB, &
  & 0.43264433E-11_JPRB, 0.44659406E-11_JPRB, 0.47369344E-11_JPRB, 0.51271452E-11_JPRB, 0.57222790E-11_JPRB, 0.61983066E-11_JPRB, &
  & 0.63123179E-11_JPRB, 0.59902569E-11_JPRB, 0.54159676E-11_JPRB, 0.47186617E-11_JPRB, 0.40057484E-11_JPRB, 0.33779375E-11_JPRB, &
  & 0.28840257E-11_JPRB, 0.25449365E-11_JPRB, 0.23373202E-11_JPRB, 0.22182070E-11_JPRB, 0.21514730E-11_JPRB, 0.21270850E-11_JPRB, &
  & 0.21384752E-11_JPRB, 0.22098534E-11_JPRB, 0.23612481E-11_JPRB, 0.26140529E-11_JPRB, 0.29497980E-11_JPRB, 0.33466522E-11_JPRB, &
  & 0.37769393E-11_JPRB, 0.42048387E-11_JPRB, 0.46058760E-11_JPRB, 0.49129169E-11_JPRB, 0.51074136E-11_JPRB, 0.50222526E-11_JPRB, &
  & 0.46942524E-11_JPRB, 0.42088199E-11_JPRB, 0.36823734E-11_JPRB, 0.32195344E-11_JPRB, 0.28741085E-11_JPRB, 0.26058541E-11_JPRB, &
  & 0.24151289E-11_JPRB, 0.22625044E-11_JPRB, 0.21524928E-11_JPRB, 0.20744036E-11_JPRB, 0.20365565E-11_JPRB, 0.20223768E-11_JPRB, &
  & 0.20269077E-11_JPRB, 0.20505611E-11_JPRB, 0.26780850E-11_JPRB, 0.27133467E-11_JPRB, 0.27391253E-11_JPRB, 0.27447903E-11_JPRB, &
  & 0.27549991E-11_JPRB, 0.37746421E-11_JPRB, 0.35541721E-11_JPRB, 0.32615462E-11_JPRB /)

RGHG4(:,58, 2) = (/ &
  & 0.64075568E-11_JPRB, 0.51046571E-11_JPRB, 0.46264585E-11_JPRB, 0.43998455E-11_JPRB, 0.42903528E-11_JPRB, 0.43417279E-11_JPRB, &
  & 0.44150712E-11_JPRB, 0.44778213E-11_JPRB, 0.39405553E-11_JPRB, 0.39685932E-11_JPRB, 0.39860146E-11_JPRB, 0.40304309E-11_JPRB, &
  & 0.40954865E-11_JPRB, 0.42439537E-11_JPRB, 0.44666467E-11_JPRB, 0.48792992E-11_JPRB, 0.54503533E-11_JPRB, 0.60165852E-11_JPRB, &
  & 0.62062287E-11_JPRB, 0.59573956E-11_JPRB, 0.54328876E-11_JPRB, 0.47867921E-11_JPRB, 0.41142593E-11_JPRB, 0.35104749E-11_JPRB, &
  & 0.30435446E-11_JPRB, 0.27297132E-11_JPRB, 0.25448500E-11_JPRB, 0.24416090E-11_JPRB, 0.23880791E-11_JPRB, 0.23697550E-11_JPRB, &
  & 0.23854766E-11_JPRB, 0.24632390E-11_JPRB, 0.26253713E-11_JPRB, 0.28861776E-11_JPRB, 0.32410899E-11_JPRB, 0.36526680E-11_JPRB, &
  & 0.40915830E-11_JPRB, 0.45210602E-11_JPRB, 0.49140982E-11_JPRB, 0.52002998E-11_JPRB, 0.53622055E-11_JPRB, 0.52690461E-11_JPRB, &
  & 0.48834873E-11_JPRB, 0.43506952E-11_JPRB, 0.37877709E-11_JPRB, 0.33181361E-11_JPRB, 0.29562579E-11_JPRB, 0.26863995E-11_JPRB, &
  & 0.24878253E-11_JPRB, 0.23330587E-11_JPRB, 0.22167719E-11_JPRB, 0.21416170E-11_JPRB, 0.21003622E-11_JPRB, 0.20854583E-11_JPRB, &
  & 0.20908295E-11_JPRB, 0.21205093E-11_JPRB, 0.27104521E-11_JPRB, 0.27386138E-11_JPRB, 0.27593429E-11_JPRB, 0.27740189E-11_JPRB, &
  & 0.27948119E-11_JPRB, 0.38119889E-11_JPRB, 0.36115991E-11_JPRB, 0.33335151E-11_JPRB /)

RGHG4(:,59, 2) = (/ &
  & 0.52532891E-11_JPRB, 0.43315273E-11_JPRB, 0.41380887E-11_JPRB, 0.40237813E-11_JPRB, 0.40143782E-11_JPRB, 0.41157819E-11_JPRB, &
  & 0.42179524E-11_JPRB, 0.42864245E-11_JPRB, 0.38252869E-11_JPRB, 0.38591036E-11_JPRB, 0.38876281E-11_JPRB, 0.39280363E-11_JPRB, &
  & 0.40032738E-11_JPRB, 0.41292195E-11_JPRB, 0.43665540E-11_JPRB, 0.47412308E-11_JPRB, 0.53340591E-11_JPRB, 0.58936484E-11_JPRB, &
  & 0.61198989E-11_JPRB, 0.59290550E-11_JPRB, 0.54554772E-11_JPRB, 0.48641408E-11_JPRB, 0.42227198E-11_JPRB, 0.36562472E-11_JPRB, &
  & 0.32210094E-11_JPRB, 0.29392419E-11_JPRB, 0.27806082E-11_JPRB, 0.26968631E-11_JPRB, 0.26576363E-11_JPRB, 0.26459494E-11_JPRB, &
  & 0.26641170E-11_JPRB, 0.27447899E-11_JPRB, 0.29137667E-11_JPRB, 0.31853457E-11_JPRB, 0.35501187E-11_JPRB, 0.39710271E-11_JPRB, &
  & 0.44190433E-11_JPRB, 0.48545308E-11_JPRB, 0.52459213E-11_JPRB, 0.55326937E-11_JPRB, 0.56793441E-11_JPRB, 0.55696715E-11_JPRB, &
  & 0.52033959E-11_JPRB, 0.46562567E-11_JPRB, 0.40738389E-11_JPRB, 0.35786560E-11_JPRB, 0.31994886E-11_JPRB, 0.29100155E-11_JPRB, &
  & 0.26973616E-11_JPRB, 0.25199278E-11_JPRB, 0.23929207E-11_JPRB, 0.23039402E-11_JPRB, 0.22609872E-11_JPRB, 0.22402438E-11_JPRB, &
  & 0.22450011E-11_JPRB, 0.22701710E-11_JPRB, 0.28020125E-11_JPRB, 0.28337970E-11_JPRB, 0.28699120E-11_JPRB, 0.28913755E-11_JPRB, &
  & 0.29129004E-11_JPRB, 0.39341369E-11_JPRB, 0.37484395E-11_JPRB, 0.34621581E-11_JPRB /)

RGHG4(:,60, 2) = (/ &
  & 0.43821253E-11_JPRB, 0.39674518E-11_JPRB, 0.38628814E-11_JPRB, 0.38437235E-11_JPRB, 0.38914648E-11_JPRB, 0.40142238E-11_JPRB, &
  & 0.41337159E-11_JPRB, 0.42239237E-11_JPRB, 0.38258663E-11_JPRB, 0.38593009E-11_JPRB, 0.38885830E-11_JPRB, 0.39316614E-11_JPRB, &
  & 0.40035874E-11_JPRB, 0.41326942E-11_JPRB, 0.43512294E-11_JPRB, 0.47396423E-11_JPRB, 0.52943531E-11_JPRB, 0.58414046E-11_JPRB, &
  & 0.60590001E-11_JPRB, 0.59037900E-11_JPRB, 0.54901153E-11_JPRB, 0.49391606E-11_JPRB, 0.43484604E-11_JPRB, 0.38207471E-11_JPRB, &
  & 0.34301618E-11_JPRB, 0.31877439E-11_JPRB, 0.30606457E-11_JPRB, 0.30002214E-11_JPRB, 0.29768800E-11_JPRB, 0.29713673E-11_JPRB, &
  & 0.29889509E-11_JPRB, 0.30673307E-11_JPRB, 0.32349301E-11_JPRB, 0.35120314E-11_JPRB, 0.38845355E-11_JPRB, 0.43148462E-11_JPRB, &
  & 0.47738740E-11_JPRB, 0.52145189E-11_JPRB, 0.56083528E-11_JPRB, 0.58932854E-11_JPRB, 0.60334094E-11_JPRB, 0.59433959E-11_JPRB, &
  & 0.55950084E-11_JPRB, 0.50967550E-11_JPRB, 0.45295109E-11_JPRB, 0.40355349E-11_JPRB, 0.36197098E-11_JPRB, 0.32918501E-11_JPRB, &
  & 0.30544569E-11_JPRB, 0.28495982E-11_JPRB, 0.26865853E-11_JPRB, 0.25904081E-11_JPRB, 0.25321553E-11_JPRB, 0.25050355E-11_JPRB, &
  & 0.24984342E-11_JPRB, 0.25201139E-11_JPRB, 0.30203015E-11_JPRB, 0.30552342E-11_JPRB, 0.30800458E-11_JPRB, 0.30906653E-11_JPRB, &
  & 0.31146836E-11_JPRB, 0.41610370E-11_JPRB, 0.39706871E-11_JPRB, 0.36580990E-11_JPRB /)

RGHG4(:,61, 2) = (/ &
  & 0.39676561E-11_JPRB, 0.37967160E-11_JPRB, 0.37852408E-11_JPRB, 0.37918388E-11_JPRB, 0.38519530E-11_JPRB, 0.39879762E-11_JPRB, &
  & 0.41225023E-11_JPRB, 0.42247876E-11_JPRB, 0.38926340E-11_JPRB, 0.39373140E-11_JPRB, 0.39804922E-11_JPRB, 0.40288419E-11_JPRB, &
  & 0.41098531E-11_JPRB, 0.42392669E-11_JPRB, 0.44655308E-11_JPRB, 0.48214909E-11_JPRB, 0.53385113E-11_JPRB, 0.58106592E-11_JPRB, &
  & 0.60209741E-11_JPRB, 0.59040602E-11_JPRB, 0.55376016E-11_JPRB, 0.50250164E-11_JPRB, 0.44866342E-11_JPRB, 0.40138834E-11_JPRB, &
  & 0.36751921E-11_JPRB, 0.34803224E-11_JPRB, 0.33920690E-11_JPRB, 0.33599653E-11_JPRB, 0.33541605E-11_JPRB, 0.33544153E-11_JPRB, &
  & 0.33685186E-11_JPRB, 0.34383672E-11_JPRB, 0.35971120E-11_JPRB, 0.38685123E-11_JPRB, 0.42403195E-11_JPRB, 0.46765248E-11_JPRB, &
  & 0.51423137E-11_JPRB, 0.55940330E-11_JPRB, 0.59941709E-11_JPRB, 0.62879368E-11_JPRB, 0.64366156E-11_JPRB, 0.63699293E-11_JPRB, &
  & 0.60746902E-11_JPRB, 0.56370746E-11_JPRB, 0.51404545E-11_JPRB, 0.46818335E-11_JPRB, 0.42716967E-11_JPRB, 0.39008120E-11_JPRB, &
  & 0.36056260E-11_JPRB, 0.33672342E-11_JPRB, 0.31542778E-11_JPRB, 0.30269116E-11_JPRB, 0.29435423E-11_JPRB, 0.29015594E-11_JPRB, &
  & 0.28798281E-11_JPRB, 0.29004128E-11_JPRB, 0.33535726E-11_JPRB, 0.33767060E-11_JPRB, 0.33946533E-11_JPRB, 0.34037783E-11_JPRB, &
  & 0.34195004E-11_JPRB, 0.44900680E-11_JPRB, 0.42801197E-11_JPRB, 0.39312663E-11_JPRB /)

RGHG4(:,62, 2) = (/ &
  & 0.40157604E-11_JPRB, 0.38562075E-11_JPRB, 0.38418426E-11_JPRB, 0.38643160E-11_JPRB, 0.39369875E-11_JPRB, 0.40751430E-11_JPRB, &
  & 0.42322656E-11_JPRB, 0.43619613E-11_JPRB, 0.40738701E-11_JPRB, 0.41276531E-11_JPRB, 0.41663734E-11_JPRB, 0.42217163E-11_JPRB, &
  & 0.42976785E-11_JPRB, 0.44294841E-11_JPRB, 0.46356296E-11_JPRB, 0.49724322E-11_JPRB, 0.54231146E-11_JPRB, 0.58340030E-11_JPRB, &
  & 0.60171564E-11_JPRB, 0.59182780E-11_JPRB, 0.55934515E-11_JPRB, 0.51357772E-11_JPRB, 0.46543732E-11_JPRB, 0.42456524E-11_JPRB, &
  & 0.39728667E-11_JPRB, 0.38357594E-11_JPRB, 0.37942024E-11_JPRB, 0.37964284E-11_JPRB, 0.38104194E-11_JPRB, 0.38167616E-11_JPRB, &
  & 0.38247495E-11_JPRB, 0.38790607E-11_JPRB, 0.40174222E-11_JPRB, 0.42731426E-11_JPRB, 0.46377971E-11_JPRB, 0.50715833E-11_JPRB, &
  & 0.55467185E-11_JPRB, 0.60072711E-11_JPRB, 0.64188880E-11_JPRB, 0.67264553E-11_JPRB, 0.68949677E-11_JPRB, 0.68734966E-11_JPRB, &
  & 0.66391302E-11_JPRB, 0.62918100E-11_JPRB, 0.58861089E-11_JPRB, 0.55136321E-11_JPRB, 0.51355665E-11_JPRB, 0.47594567E-11_JPRB, &
  & 0.44359486E-11_JPRB, 0.40950008E-11_JPRB, 0.38509903E-11_JPRB, 0.36567299E-11_JPRB, 0.35697083E-11_JPRB, 0.34818199E-11_JPRB, &
  & 0.34471252E-11_JPRB, 0.34407824E-11_JPRB, 0.38591543E-11_JPRB, 0.38718039E-11_JPRB, 0.38661088E-11_JPRB, 0.38444846E-11_JPRB, &
  & 0.38354714E-11_JPRB, 0.49308123E-11_JPRB, 0.46829008E-11_JPRB, 0.42601374E-11_JPRB /)

RGHG4(:,63, 2) = (/ &
  & 0.40688126E-11_JPRB, 0.39818227E-11_JPRB, 0.40044595E-11_JPRB, 0.40328318E-11_JPRB, 0.41096640E-11_JPRB, 0.42552606E-11_JPRB, &
  & 0.44270672E-11_JPRB, 0.45784179E-11_JPRB, 0.43372480E-11_JPRB, 0.43916294E-11_JPRB, 0.44398942E-11_JPRB, 0.44929919E-11_JPRB, &
  & 0.45700076E-11_JPRB, 0.46851637E-11_JPRB, 0.48728356E-11_JPRB, 0.51583759E-11_JPRB, 0.55338065E-11_JPRB, 0.58753627E-11_JPRB, &
  & 0.60404104E-11_JPRB, 0.59663763E-11_JPRB, 0.56835803E-11_JPRB, 0.52798924E-11_JPRB, 0.48684550E-11_JPRB, 0.45381138E-11_JPRB, &
  & 0.43400882E-11_JPRB, 0.42692998E-11_JPRB, 0.42826450E-11_JPRB, 0.43252962E-11_JPRB, 0.43618911E-11_JPRB, 0.43757263E-11_JPRB, &
  & 0.43771120E-11_JPRB, 0.44114790E-11_JPRB, 0.45215316E-11_JPRB, 0.47452099E-11_JPRB, 0.50854026E-11_JPRB, 0.55137232E-11_JPRB, &
  & 0.59915341E-11_JPRB, 0.64641127E-11_JPRB, 0.68901469E-11_JPRB, 0.72175035E-11_JPRB, 0.74178797E-11_JPRB, 0.74522541E-11_JPRB, &
  & 0.73030063E-11_JPRB, 0.70588305E-11_JPRB, 0.67692787E-11_JPRB, 0.65123944E-11_JPRB, 0.62245109E-11_JPRB, 0.58725811E-11_JPRB, &
  & 0.55478677E-11_JPRB, 0.51361020E-11_JPRB, 0.48204257E-11_JPRB, 0.45640536E-11_JPRB, 0.44359048E-11_JPRB, 0.42844695E-11_JPRB, &
  & 0.42297676E-11_JPRB, 0.41908404E-11_JPRB, 0.45756923E-11_JPRB, 0.45510930E-11_JPRB, 0.45061762E-11_JPRB, 0.44420964E-11_JPRB, &
  & 0.43885095E-11_JPRB, 0.55016920E-11_JPRB, 0.51789376E-11_JPRB, 0.46665670E-11_JPRB /)

RGHG4(:,64, 2) = (/ &
  & 0.42854652E-11_JPRB, 0.42445765E-11_JPRB, 0.42737892E-11_JPRB, 0.43167830E-11_JPRB, 0.44028587E-11_JPRB, 0.45623579E-11_JPRB, &
  & 0.47539681E-11_JPRB, 0.49323063E-11_JPRB, 0.47133447E-11_JPRB, 0.47574141E-11_JPRB, 0.47859793E-11_JPRB, 0.48308163E-11_JPRB, &
  & 0.48851578E-11_JPRB, 0.49838679E-11_JPRB, 0.51378454E-11_JPRB, 0.53797414E-11_JPRB, 0.56894775E-11_JPRB, 0.59772929E-11_JPRB, &
  & 0.61194864E-11_JPRB, 0.60584775E-11_JPRB, 0.58183432E-11_JPRB, 0.54818619E-11_JPRB, 0.51490674E-11_JPRB, 0.49056245E-11_JPRB, &
  & 0.47952822E-11_JPRB, 0.48010688E-11_JPRB, 0.48761559E-11_JPRB, 0.49640669E-11_JPRB, 0.50278011E-11_JPRB, 0.50525812E-11_JPRB, &
  & 0.50491824E-11_JPRB, 0.50601971E-11_JPRB, 0.51321837E-11_JPRB, 0.53151125E-11_JPRB, 0.56212617E-11_JPRB, 0.60297115E-11_JPRB, &
  & 0.65076334E-11_JPRB, 0.69878825E-11_JPRB, 0.74285508E-11_JPRB, 0.77809842E-11_JPRB, 0.80234144E-11_JPRB, 0.81306186E-11_JPRB, &
  & 0.80783245E-11_JPRB, 0.79596347E-11_JPRB, 0.77988293E-11_JPRB, 0.76646640E-11_JPRB, 0.74889522E-11_JPRB, 0.72088607E-11_JPRB, &
  & 0.69100142E-11_JPRB, 0.64828598E-11_JPRB, 0.61134591E-11_JPRB, 0.58137479E-11_JPRB, 0.56232744E-11_JPRB, 0.54230492E-11_JPRB, &
  & 0.53154920E-11_JPRB, 0.52211438E-11_JPRB, 0.55604037E-11_JPRB, 0.54843296E-11_JPRB, 0.53758040E-11_JPRB, 0.52268697E-11_JPRB, &
  & 0.50915903E-11_JPRB, 0.61856119E-11_JPRB, 0.57596831E-11_JPRB, 0.51278344E-11_JPRB /)

RGHG4(:,65, 2) = (/ &
  & 0.45786239E-11_JPRB, 0.45829534E-11_JPRB, 0.46396957E-11_JPRB, 0.46941171E-11_JPRB, 0.47968365E-11_JPRB, 0.49684696E-11_JPRB, &
  & 0.51813684E-11_JPRB, 0.53801039E-11_JPRB, 0.51565631E-11_JPRB, 0.51822691E-11_JPRB, 0.51975347E-11_JPRB, 0.52292454E-11_JPRB, &
  & 0.52713129E-11_JPRB, 0.53478957E-11_JPRB, 0.54680032E-11_JPRB, 0.56562819E-11_JPRB, 0.59028793E-11_JPRB, 0.61366801E-11_JPRB, &
  & 0.62605698E-11_JPRB, 0.62209448E-11_JPRB, 0.60310450E-11_JPRB, 0.57670704E-11_JPRB, 0.55258610E-11_JPRB, 0.53823968E-11_JPRB, &
  & 0.53622397E-11_JPRB, 0.54479307E-11_JPRB, 0.55893458E-11_JPRB, 0.57250016E-11_JPRB, 0.58202128E-11_JPRB, 0.58609853E-11_JPRB, &
  & 0.58574586E-11_JPRB, 0.58475742E-11_JPRB, 0.58796770E-11_JPRB, 0.60105987E-11_JPRB, 0.62727497E-11_JPRB, 0.66539391E-11_JPRB, &
  & 0.71243818E-11_JPRB, 0.76078284E-11_JPRB, 0.80626998E-11_JPRB, 0.84424915E-11_JPRB, 0.87363285E-11_JPRB, 0.89255894E-11_JPRB, &
  & 0.89866586E-11_JPRB, 0.90013136E-11_JPRB, 0.89843835E-11_JPRB, 0.89926747E-11_JPRB, 0.89409391E-11_JPRB, 0.87594897E-11_JPRB, &
  & 0.85141876E-11_JPRB, 0.81197904E-11_JPRB, 0.77301603E-11_JPRB, 0.74318373E-11_JPRB, 0.71813792E-11_JPRB, 0.69061176E-11_JPRB, &
  & 0.67175376E-11_JPRB, 0.65776403E-11_JPRB, 0.68714682E-11_JPRB, 0.67239899E-11_JPRB, 0.65094119E-11_JPRB, 0.62282323E-11_JPRB, &
  & 0.59565135E-11_JPRB, 0.69802241E-11_JPRB, 0.63816209E-11_JPRB, 0.56072816E-11_JPRB /)

RGHG4(:,66, 2) = (/ &
  & 0.49601933E-11_JPRB, 0.50218297E-11_JPRB, 0.51008997E-11_JPRB, 0.51754196E-11_JPRB, 0.52921417E-11_JPRB, 0.54923301E-11_JPRB, &
  & 0.57221038E-11_JPRB, 0.59295780E-11_JPRB, 0.56878048E-11_JPRB, 0.56756644E-11_JPRB, 0.56649910E-11_JPRB, 0.56802067E-11_JPRB, &
  & 0.57055615E-11_JPRB, 0.57576765E-11_JPRB, 0.58542242E-11_JPRB, 0.60028462E-11_JPRB, 0.62039883E-11_JPRB, 0.63935328E-11_JPRB, &
  & 0.65040859E-11_JPRB, 0.64840334E-11_JPRB, 0.63477604E-11_JPRB, 0.61653677E-11_JPRB, 0.60198465E-11_JPRB, 0.59740858E-11_JPRB, &
  & 0.60529641E-11_JPRB, 0.62238049E-11_JPRB, 0.64328091E-11_JPRB, 0.66193097E-11_JPRB, 0.67478796E-11_JPRB, 0.68094337E-11_JPRB, &
  & 0.68117885E-11_JPRB, 0.67850812E-11_JPRB, 0.67780261E-11_JPRB, 0.68615278E-11_JPRB, 0.70784949E-11_JPRB, 0.74280295E-11_JPRB, &
  & 0.78814065E-11_JPRB, 0.83644211E-11_JPRB, 0.88285265E-11_JPRB, 0.92385804E-11_JPRB, 0.95889581E-11_JPRB, 0.98710450E-11_JPRB, &
  & 0.10052886E-10_JPRB, 0.10212859E-10_JPRB, 0.10347228E-10_JPRB, 0.10488855E-10_JPRB, 0.10568026E-10_JPRB, 0.10484232E-10_JPRB, &
  & 0.10317195E-10_JPRB, 0.99927098E-11_JPRB, 0.96394429E-11_JPRB, 0.93620736E-11_JPRB, 0.90840478E-11_JPRB, 0.87766582E-11_JPRB, &
  & 0.85187682E-11_JPRB, 0.83409096E-11_JPRB, 0.85886645E-11_JPRB, 0.83486048E-11_JPRB, 0.79820543E-11_JPRB, 0.74970195E-11_JPRB, &
  & 0.70054153E-11_JPRB, 0.78493583E-11_JPRB, 0.70045354E-11_JPRB, 0.60496634E-11_JPRB /)

RGHG4(:,67, 2) = (/ &
  & 0.54191885E-11_JPRB, 0.55388914E-11_JPRB, 0.56471815E-11_JPRB, 0.57368433E-11_JPRB, 0.58779873E-11_JPRB, 0.60936165E-11_JPRB, &
  & 0.63438144E-11_JPRB, 0.65500778E-11_JPRB, 0.62713949E-11_JPRB, 0.62259234E-11_JPRB, 0.62069963E-11_JPRB, 0.62127287E-11_JPRB, &
  & 0.62395371E-11_JPRB, 0.62727193E-11_JPRB, 0.63435555E-11_JPRB, 0.64502089E-11_JPRB, 0.66095115E-11_JPRB, 0.67647255E-11_JPRB, &
  & 0.68709808E-11_JPRB, 0.68797823E-11_JPRB, 0.68026895E-11_JPRB, 0.67048294E-11_JPRB, 0.66612800E-11_JPRB, 0.67224802E-11_JPRB, &
  & 0.68926089E-11_JPRB, 0.71447457E-11_JPRB, 0.74213665E-11_JPRB, 0.76594954E-11_JPRB, 0.78248926E-11_JPRB, 0.79121345E-11_JPRB, &
  & 0.79283143E-11_JPRB, 0.78931705E-11_JPRB, 0.78568905E-11_JPRB, 0.78928079E-11_JPRB, 0.80665865E-11_JPRB, 0.83846610E-11_JPRB, &
  & 0.88233032E-11_JPRB, 0.92984847E-11_JPRB, 0.97728076E-11_JPRB, 0.10212418E-10_JPRB, 0.10624762E-10_JPRB, 0.11004062E-10_JPRB, &
  & 0.11312058E-10_JPRB, 0.11616578E-10_JPRB, 0.11906350E-10_JPRB, 0.12189042E-10_JPRB, 0.12417989E-10_JPRB, 0.12440757E-10_JPRB, &
  & 0.12357068E-10_JPRB, 0.12101263E-10_JPRB, 0.11812685E-10_JPRB, 0.11573497E-10_JPRB, 0.11316625E-10_JPRB, 0.10993978E-10_JPRB, &
  & 0.10696093E-10_JPRB, 0.10504274E-10_JPRB, 0.10753825E-10_JPRB, 0.10427027E-10_JPRB, 0.98666309E-11_JPRB, 0.91010003E-11_JPRB, &
  & 0.82831606E-11_JPRB, 0.87875887E-11_JPRB, 0.75862702E-11_JPRB, 0.64332242E-11_JPRB /)

RGHG4(:,68, 2) = (/ &
  & 0.59521676E-11_JPRB, 0.61395875E-11_JPRB, 0.62722982E-11_JPRB, 0.63864643E-11_JPRB, 0.65434784E-11_JPRB, 0.67885211E-11_JPRB, &
  & 0.70464615E-11_JPRB, 0.72527310E-11_JPRB, 0.69293872E-11_JPRB, 0.68511078E-11_JPRB, 0.68277350E-11_JPRB, 0.68206222E-11_JPRB, &
  & 0.68442261E-11_JPRB, 0.68667038E-11_JPRB, 0.69282583E-11_JPRB, 0.70160505E-11_JPRB, 0.71516222E-11_JPRB, 0.72853754E-11_JPRB, &
  & 0.73929612E-11_JPRB, 0.74344107E-11_JPRB, 0.74220439E-11_JPRB, 0.74105366E-11_JPRB, 0.74629435E-11_JPRB, 0.76188231E-11_JPRB, &
  & 0.78890627E-11_JPRB, 0.82281976E-11_JPRB, 0.85749862E-11_JPRB, 0.88692413E-11_JPRB, 0.90764948E-11_JPRB, 0.91951282E-11_JPRB, &
  & 0.92299631E-11_JPRB, 0.91938948E-11_JPRB, 0.91341899E-11_JPRB, 0.91373549E-11_JPRB, 0.92750928E-11_JPRB, 0.95650207E-11_JPRB, &
  & 0.99844065E-11_JPRB, 0.10453429E-10_JPRB, 0.10933381E-10_JPRB, 0.11406384E-10_JPRB, 0.11884237E-10_JPRB, 0.12367043E-10_JPRB, &
  & 0.12801847E-10_JPRB, 0.13251962E-10_JPRB, 0.13693576E-10_JPRB, 0.14104507E-10_JPRB, 0.14470692E-10_JPRB, 0.14587959E-10_JPRB, &
  & 0.14618617E-10_JPRB, 0.14444818E-10_JPRB, 0.14243337E-10_JPRB, 0.14046812E-10_JPRB, 0.13842380E-10_JPRB, 0.13531357E-10_JPRB, &
  & 0.13250193E-10_JPRB, 0.13094767E-10_JPRB, 0.13395431E-10_JPRB, 0.12987677E-10_JPRB, 0.12235786E-10_JPRB, 0.11129770E-10_JPRB, &
  & 0.98823094E-11_JPRB, 0.98268537E-11_JPRB, 0.81788716E-11_JPRB, 0.67881876E-11_JPRB /)

RGHG4(:,69, 2) = (/ &
  & 0.65493869E-11_JPRB, 0.68108787E-11_JPRB, 0.69788958E-11_JPRB, 0.71094359E-11_JPRB, 0.72903098E-11_JPRB, 0.75553955E-11_JPRB, &
  & 0.78331491E-11_JPRB, 0.80284538E-11_JPRB, 0.76648687E-11_JPRB, 0.75723837E-11_JPRB, 0.75572291E-11_JPRB, 0.75587791E-11_JPRB, &
  & 0.75921717E-11_JPRB, 0.76142400E-11_JPRB, 0.76638574E-11_JPRB, 0.77319982E-11_JPRB, 0.78470988E-11_JPRB, 0.79737085E-11_JPRB, &
  & 0.80952753E-11_JPRB, 0.81774951E-11_JPRB, 0.82288959E-11_JPRB, 0.83047709E-11_JPRB, 0.84571664E-11_JPRB, 0.87223154E-11_JPRB, &
  & 0.90821985E-11_JPRB, 0.95016807E-11_JPRB, 0.99179154E-11_JPRB, 0.10270479E-10_JPRB, 0.10525608E-10_JPRB, 0.10683454E-10_JPRB, &
  & 0.10748968E-10_JPRB, 0.10725056E-10_JPRB, 0.10655196E-10_JPRB, 0.10630672E-10_JPRB, 0.10737628E-10_JPRB, 0.11005654E-10_JPRB, &
  & 0.11414006E-10_JPRB, 0.11874215E-10_JPRB, 0.12364074E-10_JPRB, 0.12871223E-10_JPRB, 0.13420056E-10_JPRB, 0.14007891E-10_JPRB, &
  & 0.14570182E-10_JPRB, 0.15157972E-10_JPRB, 0.15751350E-10_JPRB, 0.16287168E-10_JPRB, 0.16813124E-10_JPRB, 0.17044604E-10_JPRB, &
  & 0.17167885E-10_JPRB, 0.17084376E-10_JPRB, 0.16977579E-10_JPRB, 0.16838588E-10_JPRB, 0.16687958E-10_JPRB, 0.16414366E-10_JPRB, &
  & 0.16138906E-10_JPRB, 0.16059017E-10_JPRB, 0.16448141E-10_JPRB, 0.16044681E-10_JPRB, 0.15133932E-10_JPRB, 0.13678429E-10_JPRB, &
  & 0.11939861E-10_JPRB, 0.11138015E-10_JPRB, 0.89755564E-11_JPRB, 0.72878543E-11_JPRB /)

RGHG4(:,70, 2) = (/ &
  & 0.72211195E-11_JPRB, 0.75711442E-11_JPRB, 0.77664758E-11_JPRB, 0.79230554E-11_JPRB, 0.81257492E-11_JPRB, 0.84194093E-11_JPRB, &
  & 0.87075043E-11_JPRB, 0.89046435E-11_JPRB, 0.85065644E-11_JPRB, 0.84112535E-11_JPRB, 0.84061482E-11_JPRB, 0.84142372E-11_JPRB, &
  & 0.84550917E-11_JPRB, 0.84875960E-11_JPRB, 0.85452357E-11_JPRB, 0.86217665E-11_JPRB, 0.87348765E-11_JPRB, 0.88659271E-11_JPRB, &
  & 0.90047301E-11_JPRB, 0.91313988E-11_JPRB, 0.92514650E-11_JPRB, 0.94121091E-11_JPRB, 0.96572863E-11_JPRB, 0.10008390E-10_JPRB, &
  & 0.10470260E-10_JPRB, 0.10980755E-10_JPRB, 0.11472394E-10_JPRB, 0.11887406E-10_JPRB, 0.12195722E-10_JPRB, 0.12402934E-10_JPRB, &
  & 0.12507485E-10_JPRB, 0.12506842E-10_JPRB, 0.12437379E-10_JPRB, 0.12404116E-10_JPRB, 0.12499872E-10_JPRB, 0.12756134E-10_JPRB, &
  & 0.13153212E-10_JPRB, 0.13611269E-10_JPRB, 0.14110889E-10_JPRB, 0.14655695E-10_JPRB, 0.15279692E-10_JPRB, 0.15975180E-10_JPRB, &
  & 0.16665820E-10_JPRB, 0.17388785E-10_JPRB, 0.18125617E-10_JPRB, 0.18773821E-10_JPRB, 0.19436470E-10_JPRB, 0.19762780E-10_JPRB, &
  & 0.19984412E-10_JPRB, 0.20041748E-10_JPRB, 0.20005159E-10_JPRB, 0.19970702E-10_JPRB, 0.19874642E-10_JPRB, 0.19696694E-10_JPRB, &
  & 0.19443414E-10_JPRB, 0.19481302E-10_JPRB, 0.19956837E-10_JPRB, 0.19575556E-10_JPRB, 0.18555543E-10_JPRB, 0.16759146E-10_JPRB, &
  & 0.14651226E-10_JPRB, 0.12929271E-10_JPRB, 0.10335630E-10_JPRB, 0.81775593E-11_JPRB /)

RGHG4(:,71, 2) = (/ &
  & 0.79794660E-11_JPRB, 0.84170830E-11_JPRB, 0.86514806E-11_JPRB, 0.88319465E-11_JPRB, 0.90645633E-11_JPRB, 0.93817679E-11_JPRB, &
  & 0.96884957E-11_JPRB, 0.98887912E-11_JPRB, 0.94754074E-11_JPRB, 0.94062978E-11_JPRB, 0.94191061E-11_JPRB, 0.94618844E-11_JPRB, &
  & 0.95224236E-11_JPRB, 0.95726743E-11_JPRB, 0.96330617E-11_JPRB, 0.97074701E-11_JPRB, 0.98238379E-11_JPRB, 0.99713571E-11_JPRB, &
  & 0.10140372E-10_JPRB, 0.10319659E-10_JPRB, 0.10512495E-10_JPRB, 0.10762550E-10_JPRB, 0.11109675E-10_JPRB, 0.11577996E-10_JPRB, &
  & 0.12129777E-10_JPRB, 0.12719733E-10_JPRB, 0.13284829E-10_JPRB, 0.13766385E-10_JPRB, 0.14136561E-10_JPRB, 0.14404439E-10_JPRB, &
  & 0.14565989E-10_JPRB, 0.14605475E-10_JPRB, 0.14548161E-10_JPRB, 0.14519355E-10_JPRB, 0.14607685E-10_JPRB, 0.14863449E-10_JPRB, &
  & 0.15260503E-10_JPRB, 0.15716222E-10_JPRB, 0.16231745E-10_JPRB, 0.16815637E-10_JPRB, 0.17518056E-10_JPRB, 0.18323903E-10_JPRB, &
  & 0.19137374E-10_JPRB, 0.19991304E-10_JPRB, 0.20863622E-10_JPRB, 0.21613489E-10_JPRB, 0.22450064E-10_JPRB, 0.22865671E-10_JPRB, &
  & 0.23187884E-10_JPRB, 0.23381418E-10_JPRB, 0.23417686E-10_JPRB, 0.23488652E-10_JPRB, 0.23452563E-10_JPRB, 0.23380886E-10_JPRB, &
  & 0.23183185E-10_JPRB, 0.23314869E-10_JPRB, 0.23899308E-10_JPRB, 0.23597364E-10_JPRB, 0.22610101E-10_JPRB, 0.20409617E-10_JPRB, &
  & 0.18001930E-10_JPRB, 0.15634665E-10_JPRB, 0.12544191E-10_JPRB, 0.97559660E-11_JPRB /)

RGHG4(:,72, 2) = (/ &
  & 0.88201365E-11_JPRB, 0.93875047E-11_JPRB, 0.96532600E-11_JPRB, 0.98647384E-11_JPRB, 0.10121329E-10_JPRB, 0.10468009E-10_JPRB, &
  & 0.10792542E-10_JPRB, 0.11006078E-10_JPRB, 0.10603475E-10_JPRB, 0.10572814E-10_JPRB, 0.10612020E-10_JPRB, 0.10673083E-10_JPRB, &
  & 0.10758301E-10_JPRB, 0.10831674E-10_JPRB, 0.10918788E-10_JPRB, 0.11024837E-10_JPRB, 0.11157519E-10_JPRB, 0.11329708E-10_JPRB, &
  & 0.11539165E-10_JPRB, 0.11778101E-10_JPRB, 0.12049280E-10_JPRB, 0.12389625E-10_JPRB, 0.12828794E-10_JPRB, 0.13379822E-10_JPRB, &
  & 0.14033502E-10_JPRB, 0.14723266E-10_JPRB, 0.15377886E-10_JPRB, 0.15937892E-10_JPRB, 0.16376600E-10_JPRB, 0.16712066E-10_JPRB, &
  & 0.16933777E-10_JPRB, 0.17030042E-10_JPRB, 0.17019122E-10_JPRB, 0.17018250E-10_JPRB, 0.17121035E-10_JPRB, 0.17385557E-10_JPRB, &
  & 0.17790781E-10_JPRB, 0.18250844E-10_JPRB, 0.18786151E-10_JPRB, 0.19411217E-10_JPRB, 0.20195496E-10_JPRB, 0.21104748E-10_JPRB, &
  & 0.22042274E-10_JPRB, 0.23017060E-10_JPRB, 0.24002409E-10_JPRB, 0.24888530E-10_JPRB, 0.25815102E-10_JPRB, 0.26287982E-10_JPRB, &
  & 0.26754534E-10_JPRB, 0.27081360E-10_JPRB, 0.27207630E-10_JPRB, 0.27372618E-10_JPRB, 0.27472762E-10_JPRB, 0.27478471E-10_JPRB, &
  & 0.27391167E-10_JPRB, 0.27641502E-10_JPRB, 0.28267817E-10_JPRB, 0.28051490E-10_JPRB, 0.27254825E-10_JPRB, 0.24707686E-10_JPRB, &
  & 0.22147327E-10_JPRB, 0.19381906E-10_JPRB, 0.15856868E-10_JPRB, 0.12279794E-10_JPRB /)

RGHG4(:,73, 2) = (/ &
  & 0.97973071E-11_JPRB, 0.10490425E-10_JPRB, 0.10792172E-10_JPRB, 0.11019965E-10_JPRB, 0.11305394E-10_JPRB, 0.11674484E-10_JPRB, &
  & 0.12022147E-10_JPRB, 0.12265289E-10_JPRB, 0.11893586E-10_JPRB, 0.11929020E-10_JPRB, 0.12010492E-10_JPRB, 0.12120181E-10_JPRB, &
  & 0.12242528E-10_JPRB, 0.12350469E-10_JPRB, 0.12454206E-10_JPRB, 0.12570097E-10_JPRB, 0.12732979E-10_JPRB, 0.12943814E-10_JPRB, &
  & 0.13206137E-10_JPRB, 0.13518614E-10_JPRB, 0.13879310E-10_JPRB, 0.14322152E-10_JPRB, 0.14875743E-10_JPRB, 0.15562286E-10_JPRB, &
  & 0.16318872E-10_JPRB, 0.17091309E-10_JPRB, 0.17826825E-10_JPRB, 0.18467035E-10_JPRB, 0.18986302E-10_JPRB, 0.19406091E-10_JPRB, &
  & 0.19716147E-10_JPRB, 0.19883047E-10_JPRB, 0.19915120E-10_JPRB, 0.19950919E-10_JPRB, 0.20092162E-10_JPRB, 0.20372632E-10_JPRB, &
  & 0.20796798E-10_JPRB, 0.21260806E-10_JPRB, 0.21816887E-10_JPRB, 0.22485305E-10_JPRB, 0.23343879E-10_JPRB, 0.24353689E-10_JPRB, &
  & 0.25392631E-10_JPRB, 0.26483668E-10_JPRB, 0.27554141E-10_JPRB, 0.28580711E-10_JPRB, 0.29587360E-10_JPRB, 0.30162227E-10_JPRB, &
  & 0.30759274E-10_JPRB, 0.31174521E-10_JPRB, 0.31407318E-10_JPRB, 0.31631139E-10_JPRB, 0.31870645E-10_JPRB, 0.31952271E-10_JPRB, &
  & 0.31932661E-10_JPRB, 0.32359504E-10_JPRB, 0.33000346E-10_JPRB, 0.32850327E-10_JPRB, 0.32363268E-10_JPRB, 0.29618287E-10_JPRB, &
  & 0.27026877E-10_JPRB, 0.24374570E-10_JPRB, 0.20432015E-10_JPRB, 0.15917071E-10_JPRB /)

RGHG4(:,74, 2) = (/ &
  & 0.10970558E-10_JPRB, 0.11755570E-10_JPRB, 0.12068662E-10_JPRB, 0.12316226E-10_JPRB, 0.12615434E-10_JPRB, 0.13015139E-10_JPRB, &
  & 0.13398002E-10_JPRB, 0.13689128E-10_JPRB, 0.13360902E-10_JPRB, 0.13463384E-10_JPRB, 0.13590334E-10_JPRB, 0.13742900E-10_JPRB, &
  & 0.13905487E-10_JPRB, 0.14061497E-10_JPRB, 0.14217919E-10_JPRB, 0.14392226E-10_JPRB, 0.14595701E-10_JPRB, 0.14857969E-10_JPRB, &
  & 0.15187632E-10_JPRB, 0.15586915E-10_JPRB, 0.16045909E-10_JPRB, 0.16600003E-10_JPRB, 0.17255962E-10_JPRB, 0.18013951E-10_JPRB, &
  & 0.18872874E-10_JPRB, 0.19763186E-10_JPRB, 0.20603816E-10_JPRB, 0.21345049E-10_JPRB, 0.21950476E-10_JPRB, 0.22451851E-10_JPRB, &
  & 0.22844409E-10_JPRB, 0.23114489E-10_JPRB, 0.23259651E-10_JPRB, 0.23376457E-10_JPRB, 0.23577695E-10_JPRB, 0.23893287E-10_JPRB, &
  & 0.24334510E-10_JPRB, 0.24813870E-10_JPRB, 0.25393448E-10_JPRB, 0.26104252E-10_JPRB, 0.27033297E-10_JPRB, 0.28125016E-10_JPRB, &
  & 0.29253447E-10_JPRB, 0.30427456E-10_JPRB, 0.31577439E-10_JPRB, 0.32722922E-10_JPRB, 0.33739168E-10_JPRB, 0.34421743E-10_JPRB, &
  & 0.35102667E-10_JPRB, 0.35631439E-10_JPRB, 0.35923878E-10_JPRB, 0.36271805E-10_JPRB, 0.36649791E-10_JPRB, 0.36829102E-10_JPRB, &
  & 0.36846755E-10_JPRB, 0.37449127E-10_JPRB, 0.38103565E-10_JPRB, 0.38008718E-10_JPRB, 0.37853699E-10_JPRB, 0.35115327E-10_JPRB, &
  & 0.32659816E-10_JPRB, 0.30647953E-10_JPRB, 0.26395757E-10_JPRB, 0.20854278E-10_JPRB /)

RGHG4(:,75, 2) = (/ &
  & 0.12264613E-10_JPRB, 0.13139608E-10_JPRB, 0.13480438E-10_JPRB, 0.13734967E-10_JPRB, 0.14052755E-10_JPRB, 0.14479929E-10_JPRB, &
  & 0.14911735E-10_JPRB, 0.15273857E-10_JPRB, 0.15009705E-10_JPRB, 0.15190097E-10_JPRB, 0.15411464E-10_JPRB, 0.15632376E-10_JPRB, &
  & 0.15867795E-10_JPRB, 0.16077268E-10_JPRB, 0.16274128E-10_JPRB, 0.16486045E-10_JPRB, 0.16753564E-10_JPRB, 0.17086789E-10_JPRB, &
  & 0.17498865E-10_JPRB, 0.18001755E-10_JPRB, 0.18580918E-10_JPRB, 0.19261153E-10_JPRB, 0.20058450E-10_JPRB, 0.20987786E-10_JPRB, &
  & 0.21982067E-10_JPRB, 0.22968332E-10_JPRB, 0.23904627E-10_JPRB, 0.24738040E-10_JPRB, 0.25449877E-10_JPRB, 0.26070665E-10_JPRB, &
  & 0.26588383E-10_JPRB, 0.26945734E-10_JPRB, 0.27144493E-10_JPRB, 0.27356459E-10_JPRB, 0.27627746E-10_JPRB, 0.28008504E-10_JPRB, &
  & 0.28468035E-10_JPRB, 0.28961824E-10_JPRB, 0.29575863E-10_JPRB, 0.30332785E-10_JPRB, 0.31318930E-10_JPRB, 0.32470818E-10_JPRB, &
  & 0.33657487E-10_JPRB, 0.34896148E-10_JPRB, 0.36112367E-10_JPRB, 0.37310446E-10_JPRB, 0.38380514E-10_JPRB, 0.39183583E-10_JPRB, &
  & 0.39915689E-10_JPRB, 0.40504669E-10_JPRB, 0.40913599E-10_JPRB, 0.41338825E-10_JPRB, 0.41824107E-10_JPRB, 0.42090453E-10_JPRB, &
  & 0.42140520E-10_JPRB, 0.42890528E-10_JPRB, 0.43577527E-10_JPRB, 0.43544151E-10_JPRB, 0.43760849E-10_JPRB, 0.41141153E-10_JPRB, &
  & 0.39055457E-10_JPRB, 0.38197834E-10_JPRB, 0.33860477E-10_JPRB, 0.27280043E-10_JPRB /)

RGHG4(:,76, 2) = (/ &
  & 0.13692429E-10_JPRB, 0.14658623E-10_JPRB, 0.15021588E-10_JPRB, 0.15276034E-10_JPRB, 0.15599825E-10_JPRB, 0.16063850E-10_JPRB, &
  & 0.16554176E-10_JPRB, 0.17003794E-10_JPRB, 0.16802939E-10_JPRB, 0.17084535E-10_JPRB, 0.17350621E-10_JPRB, 0.17657924E-10_JPRB, &
  & 0.17952447E-10_JPRB, 0.18257109E-10_JPRB, 0.18556854E-10_JPRB, 0.18870719E-10_JPRB, 0.19220420E-10_JPRB, 0.19648654E-10_JPRB, &
  & 0.20161952E-10_JPRB, 0.20791285E-10_JPRB, 0.21503870E-10_JPRB, 0.22329250E-10_JPRB, 0.23239135E-10_JPRB, 0.24218611E-10_JPRB, &
  & 0.25279683E-10_JPRB, 0.26370739E-10_JPRB, 0.27413538E-10_JPRB, 0.28358061E-10_JPRB, 0.29178170E-10_JPRB, 0.29902282E-10_JPRB, &
  & 0.30523452E-10_JPRB, 0.31058399E-10_JPRB, 0.31517261E-10_JPRB, 0.31892527E-10_JPRB, 0.32280064E-10_JPRB, 0.32725083E-10_JPRB, &
  & 0.33223951E-10_JPRB, 0.33735004E-10_JPRB, 0.34388981E-10_JPRB, 0.35189567E-10_JPRB, 0.36217765E-10_JPRB, 0.37405936E-10_JPRB, &
  & 0.38613911E-10_JPRB, 0.39874926E-10_JPRB, 0.41125072E-10_JPRB, 0.42366128E-10_JPRB, 0.43457196E-10_JPRB, 0.44270986E-10_JPRB, &
  & 0.45005399E-10_JPRB, 0.45700835E-10_JPRB, 0.46208683E-10_JPRB, 0.46708828E-10_JPRB, 0.47339001E-10_JPRB, 0.47702130E-10_JPRB, &
  & 0.47774017E-10_JPRB, 0.48668593E-10_JPRB, 0.49374164E-10_JPRB, 0.49411333E-10_JPRB, 0.50027604E-10_JPRB, 0.47697426E-10_JPRB, &
  & 0.46111344E-10_JPRB, 0.47109833E-10_JPRB, 0.42866689E-10_JPRB, 0.35324094E-10_JPRB /)

RGHG4(:,77, 2) = (/ &
  & 0.15262453E-10_JPRB, 0.16293028E-10_JPRB, 0.16670837E-10_JPRB, 0.16913564E-10_JPRB, 0.17232693E-10_JPRB, 0.17719158E-10_JPRB, &
  & 0.18276833E-10_JPRB, 0.18818540E-10_JPRB, 0.18699134E-10_JPRB, 0.19063298E-10_JPRB, 0.19457130E-10_JPRB, 0.19841885E-10_JPRB, &
  & 0.20255944E-10_JPRB, 0.20652240E-10_JPRB, 0.21045795E-10_JPRB, 0.21461981E-10_JPRB, 0.21934498E-10_JPRB, 0.22489384E-10_JPRB, &
  & 0.23140493E-10_JPRB, 0.23910932E-10_JPRB, 0.24783743E-10_JPRB, 0.25753934E-10_JPRB, 0.26818308E-10_JPRB, 0.28014233E-10_JPRB, &
  & 0.29262107E-10_JPRB, 0.30490031E-10_JPRB, 0.31669410E-10_JPRB, 0.32744606E-10_JPRB, 0.33699998E-10_JPRB, 0.34553659E-10_JPRB, &
  & 0.35317204E-10_JPRB, 0.35964832E-10_JPRB, 0.36424416E-10_JPRB, 0.36894095E-10_JPRB, 0.37437810E-10_JPRB, 0.37973135E-10_JPRB, &
  & 0.38532913E-10_JPRB, 0.39084430E-10_JPRB, 0.39779277E-10_JPRB, 0.40624979E-10_JPRB, 0.41673089E-10_JPRB, 0.42854203E-10_JPRB, &
  & 0.44034047E-10_JPRB, 0.45270232E-10_JPRB, 0.46487744E-10_JPRB, 0.47705305E-10_JPRB, 0.48812728E-10_JPRB, 0.49679424E-10_JPRB, &
  & 0.50458443E-10_JPRB, 0.51135561E-10_JPRB, 0.51809945E-10_JPRB, 0.52320460E-10_JPRB, 0.53044343E-10_JPRB, 0.53551590E-10_JPRB, &
  & 0.53608656E-10_JPRB, 0.54650177E-10_JPRB, 0.55389995E-10_JPRB, 0.55443344E-10_JPRB, 0.56549765E-10_JPRB, 0.54571805E-10_JPRB, &
  & 0.53740103E-10_JPRB, 0.57222980E-10_JPRB, 0.53307102E-10_JPRB, 0.45043042E-10_JPRB /)

RGHG4(:,78, 2) = (/ &
  & 0.16964664E-10_JPRB, 0.17965376E-10_JPRB, 0.18322465E-10_JPRB, 0.18526437E-10_JPRB, 0.18818365E-10_JPRB, 0.19318746E-10_JPRB, &
  & 0.19925428E-10_JPRB, 0.20541190E-10_JPRB, 0.20506511E-10_JPRB, 0.20949551E-10_JPRB, 0.21373152E-10_JPRB, 0.21846514E-10_JPRB, &
  & 0.22339502E-10_JPRB, 0.22884418E-10_JPRB, 0.23449905E-10_JPRB, 0.24040022E-10_JPRB, 0.24666224E-10_JPRB, 0.25382233E-10_JPRB, &
  & 0.26186936E-10_JPRB, 0.27120702E-10_JPRB, 0.28136594E-10_JPRB, 0.29241897E-10_JPRB, 0.30396925E-10_JPRB, 0.31567072E-10_JPRB, &
  & 0.32764905E-10_JPRB, 0.33972585E-10_JPRB, 0.35155486E-10_JPRB, 0.36286436E-10_JPRB, 0.37347649E-10_JPRB, 0.38354358E-10_JPRB, &
  & 0.39309282E-10_JPRB, 0.40219161E-10_JPRB, 0.41109671E-10_JPRB, 0.41960855E-10_JPRB, 0.42651657E-10_JPRB, 0.43330596E-10_JPRB, &
  & 0.43993774E-10_JPRB, 0.44640309E-10_JPRB, 0.45381580E-10_JPRB, 0.46264860E-10_JPRB, 0.47282331E-10_JPRB, 0.48397189E-10_JPRB, &
  & 0.49461900E-10_JPRB, 0.50589029E-10_JPRB, 0.51718043E-10_JPRB, 0.52869858E-10_JPRB, 0.53926211E-10_JPRB, 0.54765338E-10_JPRB, &
  & 0.55545714E-10_JPRB, 0.56249005E-10_JPRB, 0.57046534E-10_JPRB, 0.57625404E-10_JPRB, 0.58382625E-10_JPRB, 0.59104735E-10_JPRB, &
  & 0.59137847E-10_JPRB, 0.60259693E-10_JPRB, 0.61154755E-10_JPRB, 0.61124224E-10_JPRB, 0.62729232E-10_JPRB, 0.61295136E-10_JPRB, &
  & 0.61224789E-10_JPRB, 0.67724486E-10_JPRB, 0.64554577E-10_JPRB, 0.56296395E-10_JPRB /)

RGHG4(:,79, 2) = (/ &
  & 0.18672855E-10_JPRB, 0.19309096E-10_JPRB, 0.19518982E-10_JPRB, 0.19637951E-10_JPRB, 0.19869398E-10_JPRB, 0.20342290E-10_JPRB, &
  & 0.20941743E-10_JPRB, 0.21584170E-10_JPRB, 0.21546244E-10_JPRB, 0.22019128E-10_JPRB, 0.22496439E-10_JPRB, 0.23005802E-10_JPRB, &
  & 0.23581755E-10_JPRB, 0.24205235E-10_JPRB, 0.24875211E-10_JPRB, 0.25613943E-10_JPRB, 0.26424375E-10_JPRB, 0.27295883E-10_JPRB, &
  & 0.28240958E-10_JPRB, 0.29253933E-10_JPRB, 0.30306348E-10_JPRB, 0.31367516E-10_JPRB, 0.32440627E-10_JPRB, 0.33596528E-10_JPRB, &
  & 0.34783048E-10_JPRB, 0.35966549E-10_JPRB, 0.37149141E-10_JPRB, 0.38308464E-10_JPRB, 0.39438463E-10_JPRB, 0.40538212E-10_JPRB, &
  & 0.41617789E-10_JPRB, 0.42679048E-10_JPRB, 0.43658674E-10_JPRB, 0.44617872E-10_JPRB, 0.45628411E-10_JPRB, 0.46698676E-10_JPRB, &
  & 0.47668102E-10_JPRB, 0.48600103E-10_JPRB, 0.49488802E-10_JPRB, 0.50438719E-10_JPRB, 0.51407684E-10_JPRB, 0.52365536E-10_JPRB, &
  & 0.53230174E-10_JPRB, 0.54138558E-10_JPRB, 0.55035101E-10_JPRB, 0.56000968E-10_JPRB, 0.56944605E-10_JPRB, 0.57723531E-10_JPRB, &
  & 0.58520556E-10_JPRB, 0.59161641E-10_JPRB, 0.60040806E-10_JPRB, 0.60743049E-10_JPRB, 0.61441324E-10_JPRB, 0.62417536E-10_JPRB, &
  & 0.62513328E-10_JPRB, 0.63600791E-10_JPRB, 0.64898059E-10_JPRB, 0.64705352E-10_JPRB, 0.66670169E-10_JPRB, 0.65810662E-10_JPRB, &
  & 0.66288960E-10_JPRB, 0.75382978E-10_JPRB, 0.73560574E-10_JPRB, 0.68186498E-10_JPRB /)

RGHG4(:,80, 2) = (/ &
  & 0.19699367E-10_JPRB, 0.19885298E-10_JPRB, 0.20002621E-10_JPRB, 0.20084075E-10_JPRB, 0.20302831E-10_JPRB, 0.20786282E-10_JPRB, &
  & 0.21425068E-10_JPRB, 0.22081234E-10_JPRB, 0.22174120E-10_JPRB, 0.22640632E-10_JPRB, 0.23150070E-10_JPRB, 0.23679426E-10_JPRB, &
  & 0.24267510E-10_JPRB, 0.24935916E-10_JPRB, 0.25652069E-10_JPRB, 0.26410417E-10_JPRB, 0.27223786E-10_JPRB, 0.28129608E-10_JPRB, &
  & 0.29107057E-10_JPRB, 0.30166210E-10_JPRB, 0.31258954E-10_JPRB, 0.32414332E-10_JPRB, 0.33571344E-10_JPRB, 0.34694681E-10_JPRB, &
  & 0.35842260E-10_JPRB, 0.37014666E-10_JPRB, 0.38194160E-10_JPRB, 0.39379028E-10_JPRB, 0.40545633E-10_JPRB, 0.41695754E-10_JPRB, &
  & 0.42833858E-10_JPRB, 0.43957293E-10_JPRB, 0.45074524E-10_JPRB, 0.46223563E-10_JPRB, 0.47280894E-10_JPRB, 0.48274766E-10_JPRB, &
  & 0.49205542E-10_JPRB, 0.50165202E-10_JPRB, 0.51083436E-10_JPRB, 0.52052584E-10_JPRB, 0.53017687E-10_JPRB, 0.53941802E-10_JPRB, &
  & 0.54764186E-10_JPRB, 0.55656178E-10_JPRB, 0.56569364E-10_JPRB, 0.57564741E-10_JPRB, 0.58529522E-10_JPRB, 0.59330652E-10_JPRB, &
  & 0.60119618E-10_JPRB, 0.60776037E-10_JPRB, 0.61612181E-10_JPRB, 0.62425135E-10_JPRB, 0.63003380E-10_JPRB, 0.63964743E-10_JPRB, &
  & 0.64163418E-10_JPRB, 0.64872753E-10_JPRB, 0.66485803E-10_JPRB, 0.66163845E-10_JPRB, 0.67944712E-10_JPRB, 0.67527525E-10_JPRB, &
  & 0.68011589E-10_JPRB, 0.77703517E-10_JPRB, 0.76719429E-10_JPRB, 0.74797751E-10_JPRB /)

RGHG4(:,81, 2) = (/ &
  & 0.20333771E-10_JPRB, 0.20273890E-10_JPRB, 0.20362698E-10_JPRB, 0.20441353E-10_JPRB, 0.20644439E-10_JPRB, 0.21133493E-10_JPRB, &
  & 0.21757512E-10_JPRB, 0.22455938E-10_JPRB, 0.22493878E-10_JPRB, 0.23039530E-10_JPRB, 0.23516368E-10_JPRB, 0.24080833E-10_JPRB, &
  & 0.24694803E-10_JPRB, 0.25374943E-10_JPRB, 0.26113519E-10_JPRB, 0.26929731E-10_JPRB, 0.27818565E-10_JPRB, 0.28766349E-10_JPRB, &
  & 0.29784831E-10_JPRB, 0.30850222E-10_JPRB, 0.31955803E-10_JPRB, 0.33052255E-10_JPRB, 0.34120630E-10_JPRB, 0.35260538E-10_JPRB, &
  & 0.36426223E-10_JPRB, 0.37596568E-10_JPRB, 0.38793392E-10_JPRB, 0.39990032E-10_JPRB, 0.41183459E-10_JPRB, 0.42358953E-10_JPRB, &
  & 0.43525447E-10_JPRB, 0.44680620E-10_JPRB, 0.45816368E-10_JPRB, 0.46937024E-10_JPRB, 0.48049145E-10_JPRB, 0.49186124E-10_JPRB, &
  & 0.50271280E-10_JPRB, 0.51295943E-10_JPRB, 0.52283643E-10_JPRB, 0.53247479E-10_JPRB, 0.54234658E-10_JPRB, 0.55145520E-10_JPRB, &
  & 0.55958831E-10_JPRB, 0.56829045E-10_JPRB, 0.57676842E-10_JPRB, 0.58606064E-10_JPRB, 0.59517516E-10_JPRB, 0.60250575E-10_JPRB, &
  & 0.61058915E-10_JPRB, 0.61714321E-10_JPRB, 0.62503051E-10_JPRB, 0.63383417E-10_JPRB, 0.64002838E-10_JPRB, 0.64846309E-10_JPRB, &
  & 0.65331698E-10_JPRB, 0.65749808E-10_JPRB, 0.67460162E-10_JPRB, 0.67388942E-10_JPRB, 0.68833557E-10_JPRB, 0.68826125E-10_JPRB, &
  & 0.69228089E-10_JPRB, 0.79357042E-10_JPRB, 0.78715270E-10_JPRB, 0.78645403E-10_JPRB /)

RGHG4(:,82, 2) = (/ &
  & 0.20789356E-10_JPRB, 0.20437705E-10_JPRB, 0.20523678E-10_JPRB, 0.20582395E-10_JPRB, 0.20782372E-10_JPRB, 0.21284053E-10_JPRB, &
  & 0.21934839E-10_JPRB, 0.22608441E-10_JPRB, 0.22829997E-10_JPRB, 0.23280584E-10_JPRB, 0.23851223E-10_JPRB, 0.24375446E-10_JPRB, &
  & 0.24998420E-10_JPRB, 0.25688073E-10_JPRB, 0.26434950E-10_JPRB, 0.27233660E-10_JPRB, 0.28086792E-10_JPRB, 0.29036575E-10_JPRB, &
  & 0.30048831E-10_JPRB, 0.31128274E-10_JPRB, 0.32234989E-10_JPRB, 0.33406982E-10_JPRB, 0.34540312E-10_JPRB, 0.35679227E-10_JPRB, &
  & 0.36823392E-10_JPRB, 0.37993168E-10_JPRB, 0.39191202E-10_JPRB, 0.40406147E-10_JPRB, 0.41612509E-10_JPRB, 0.42805984E-10_JPRB, &
  & 0.43989631E-10_JPRB, 0.45158821E-10_JPRB, 0.46328785E-10_JPRB, 0.47514399E-10_JPRB, 0.48680896E-10_JPRB, 0.49747012E-10_JPRB, &
  & 0.50791513E-10_JPRB, 0.51780892E-10_JPRB, 0.52801787E-10_JPRB, 0.53765874E-10_JPRB, 0.54768676E-10_JPRB, 0.55672040E-10_JPRB, &
  & 0.56467258E-10_JPRB, 0.57336958E-10_JPRB, 0.58206981E-10_JPRB, 0.59167247E-10_JPRB, 0.60119083E-10_JPRB, 0.60887316E-10_JPRB, &
  & 0.61681368E-10_JPRB, 0.62354365E-10_JPRB, 0.63103162E-10_JPRB, 0.63973937E-10_JPRB, 0.64641445E-10_JPRB, 0.65298558E-10_JPRB, &
  & 0.65889995E-10_JPRB, 0.66208178E-10_JPRB, 0.67711454E-10_JPRB, 0.67954885E-10_JPRB, 0.69063963E-10_JPRB, 0.69235361E-10_JPRB, &
  & 0.69423196E-10_JPRB, 0.79631170E-10_JPRB, 0.79287375E-10_JPRB, 0.81109786E-10_JPRB /)

RGHG4(:,83, 2) = (/ &
  & 0.20907881E-10_JPRB, 0.20546186E-10_JPRB, 0.20686453E-10_JPRB, 0.20746757E-10_JPRB, 0.20953871E-10_JPRB, 0.21478283E-10_JPRB, &
  & 0.22103276E-10_JPRB, 0.22871007E-10_JPRB, 0.22961816E-10_JPRB, 0.23571875E-10_JPRB, 0.24003343E-10_JPRB, 0.24627586E-10_JPRB, &
  & 0.25222309E-10_JPRB, 0.25927347E-10_JPRB, 0.26681796E-10_JPRB, 0.27509744E-10_JPRB, 0.28414470E-10_JPRB, 0.29377355E-10_JPRB, &
  & 0.30407125E-10_JPRB, 0.31477144E-10_JPRB, 0.32612794E-10_JPRB, 0.33692851E-10_JPRB, 0.34791912E-10_JPRB, 0.35920222E-10_JPRB, &
  & 0.37094411E-10_JPRB, 0.38275379E-10_JPRB, 0.39489315E-10_JPRB, 0.40710588E-10_JPRB, 0.41931653E-10_JPRB, 0.43137844E-10_JPRB, &
  & 0.44338696E-10_JPRB, 0.45524924E-10_JPRB, 0.46707957E-10_JPRB, 0.47896059E-10_JPRB, 0.49036209E-10_JPRB, 0.50148306E-10_JPRB, &
  & 0.51255555E-10_JPRB, 0.52296275E-10_JPRB, 0.53328449E-10_JPRB, 0.54313349E-10_JPRB, 0.55315388E-10_JPRB, 0.56254095E-10_JPRB, &
  & 0.57061366E-10_JPRB, 0.57960425E-10_JPRB, 0.58827693E-10_JPRB, 0.59765526E-10_JPRB, 0.60677782E-10_JPRB, 0.61389303E-10_JPRB, &
  & 0.62200342E-10_JPRB, 0.62910684E-10_JPRB, 0.63606620E-10_JPRB, 0.64490240E-10_JPRB, 0.65188979E-10_JPRB, 0.65805646E-10_JPRB, &
  & 0.66371637E-10_JPRB, 0.66764261E-10_JPRB, 0.68062576E-10_JPRB, 0.68541554E-10_JPRB, 0.69482732E-10_JPRB, 0.69820580E-10_JPRB, &
  & 0.69909072E-10_JPRB, 0.79940915E-10_JPRB, 0.79651681E-10_JPRB, 0.80951128E-10_JPRB /)

RGHG4(:,84, 2) = (/ &
  & 0.21004920E-10_JPRB, 0.20620209E-10_JPRB, 0.20796439E-10_JPRB, 0.20818569E-10_JPRB, 0.21038159E-10_JPRB, 0.21563138E-10_JPRB, &
  & 0.22225867E-10_JPRB, 0.22932930E-10_JPRB, 0.23243078E-10_JPRB, 0.23685279E-10_JPRB, 0.24281138E-10_JPRB, 0.24769468E-10_JPRB, &
  & 0.25425882E-10_JPRB, 0.26111030E-10_JPRB, 0.26876255E-10_JPRB, 0.27688950E-10_JPRB, 0.28562064E-10_JPRB, 0.29523602E-10_JPRB, &
  & 0.30539783E-10_JPRB, 0.31631392E-10_JPRB, 0.32726922E-10_JPRB, 0.33886033E-10_JPRB, 0.35029618E-10_JPRB, 0.36162549E-10_JPRB, &
  & 0.37330781E-10_JPRB, 0.38510209E-10_JPRB, 0.39722458E-10_JPRB, 0.40957095E-10_JPRB, 0.42190369E-10_JPRB, 0.43407011E-10_JPRB, &
  & 0.44618819E-10_JPRB, 0.45821277E-10_JPRB, 0.47024513E-10_JPRB, 0.48230493E-10_JPRB, 0.49401400E-10_JPRB, 0.50505124E-10_JPRB, &
  & 0.51575640E-10_JPRB, 0.52615662E-10_JPRB, 0.53625073E-10_JPRB, 0.54652068E-10_JPRB, 0.55615838E-10_JPRB, 0.56582530E-10_JPRB, &
  & 0.57381183E-10_JPRB, 0.58266274E-10_JPRB, 0.59142177E-10_JPRB, 0.60088448E-10_JPRB, 0.61045821E-10_JPRB, 0.61786548E-10_JPRB, &
  & 0.62514993E-10_JPRB, 0.63265601E-10_JPRB, 0.63948014E-10_JPRB, 0.64839627E-10_JPRB, 0.65535591E-10_JPRB, 0.66126098E-10_JPRB, &
  & 0.66620764E-10_JPRB, 0.67036612E-10_JPRB, 0.68190988E-10_JPRB, 0.68790598E-10_JPRB, 0.69635943E-10_JPRB, 0.69996203E-10_JPRB, &
  & 0.70106053E-10_JPRB, 0.79906137E-10_JPRB, 0.79923748E-10_JPRB, 0.81073134E-10_JPRB /)

RGHG4(:,85, 2) = (/ &
  & 0.21102193E-10_JPRB, 0.20667273E-10_JPRB, 0.20911313E-10_JPRB, 0.20897624E-10_JPRB, 0.21161742E-10_JPRB, 0.21706298E-10_JPRB, &
  & 0.22360039E-10_JPRB, 0.23201305E-10_JPRB, 0.23358404E-10_JPRB, 0.23927907E-10_JPRB, 0.24365917E-10_JPRB, 0.24942529E-10_JPRB, &
  & 0.25528224E-10_JPRB, 0.26243825E-10_JPRB, 0.27015262E-10_JPRB, 0.27867654E-10_JPRB, 0.28770623E-10_JPRB, 0.29737303E-10_JPRB, &
  & 0.30760432E-10_JPRB, 0.31841529E-10_JPRB, 0.32962189E-10_JPRB, 0.34052986E-10_JPRB, 0.35164746E-10_JPRB, 0.36295317E-10_JPRB, &
  & 0.37472289E-10_JPRB, 0.38679542E-10_JPRB, 0.39899490E-10_JPRB, 0.41149043E-10_JPRB, 0.42386494E-10_JPRB, 0.43615601E-10_JPRB, &
  & 0.44847907E-10_JPRB, 0.46067379E-10_JPRB, 0.47281477E-10_JPRB, 0.48495142E-10_JPRB, 0.49648209E-10_JPRB, 0.50768501E-10_JPRB, &
  & 0.51851818E-10_JPRB, 0.52943254E-10_JPRB, 0.53964111E-10_JPRB, 0.54992323E-10_JPRB, 0.56005242E-10_JPRB, 0.56930832E-10_JPRB, &
  & 0.57800306E-10_JPRB, 0.58693744E-10_JPRB, 0.59590097E-10_JPRB, 0.60531323E-10_JPRB, 0.61424921E-10_JPRB, 0.62185646E-10_JPRB, &
  & 0.62917754E-10_JPRB, 0.63683371E-10_JPRB, 0.64334635E-10_JPRB, 0.65191262E-10_JPRB, 0.65921012E-10_JPRB, 0.66459123E-10_JPRB, &
  & 0.66957273E-10_JPRB, 0.67368638E-10_JPRB, 0.68467447E-10_JPRB, 0.69075350E-10_JPRB, 0.69981410E-10_JPRB, 0.70228226E-10_JPRB, &
  & 0.70448716E-10_JPRB, 0.79943475E-10_JPRB, 0.80097512E-10_JPRB, 0.81349434E-10_JPRB /)

RGHG4(:,86, 2) = (/ &
  & 0.21173972E-10_JPRB, 0.20698660E-10_JPRB, 0.21010175E-10_JPRB, 0.20930879E-10_JPRB, 0.21269117E-10_JPRB, 0.21769747E-10_JPRB, &
  & 0.22562526E-10_JPRB, 0.23268498E-10_JPRB, 0.23611006E-10_JPRB, 0.24066077E-10_JPRB, 0.24569683E-10_JPRB, 0.25039514E-10_JPRB, &
  & 0.25635697E-10_JPRB, 0.26317216E-10_JPRB, 0.27100594E-10_JPRB, 0.27935319E-10_JPRB, 0.28837393E-10_JPRB, 0.29797002E-10_JPRB, &
  & 0.30830512E-10_JPRB, 0.31918801E-10_JPRB, 0.32989802E-10_JPRB, 0.34170167E-10_JPRB, 0.35290063E-10_JPRB, 0.36453503E-10_JPRB, &
  & 0.37630399E-10_JPRB, 0.38826872E-10_JPRB, 0.40057822E-10_JPRB, 0.41311683E-10_JPRB, 0.42568296E-10_JPRB, 0.43805678E-10_JPRB, &
  & 0.45040735E-10_JPRB, 0.46265405E-10_JPRB, 0.47491171E-10_JPRB, 0.48715497E-10_JPRB, 0.49890932E-10_JPRB, 0.51009450E-10_JPRB, &
  & 0.52122407E-10_JPRB, 0.53177455E-10_JPRB, 0.54231196E-10_JPRB, 0.55254142E-10_JPRB, 0.56266467E-10_JPRB, 0.57208890E-10_JPRB, &
  & 0.58037158E-10_JPRB, 0.58942032E-10_JPRB, 0.59795766E-10_JPRB, 0.60764407E-10_JPRB, 0.61664326E-10_JPRB, 0.62422581E-10_JPRB, &
  & 0.63091338E-10_JPRB, 0.63855130E-10_JPRB, 0.64578877E-10_JPRB, 0.65379376E-10_JPRB, 0.66195410E-10_JPRB, 0.66657693E-10_JPRB, &
  & 0.67152062E-10_JPRB, 0.67513897E-10_JPRB, 0.68662104E-10_JPRB, 0.69138896E-10_JPRB, 0.70191838E-10_JPRB, 0.70308648E-10_JPRB, &
  & 0.70602330E-10_JPRB, 0.79929001E-10_JPRB, 0.80204308E-10_JPRB, 0.81423472E-10_JPRB /)

RGHG4(:,87, 2) = (/ &
  & 0.21238537E-10_JPRB, 0.20724466E-10_JPRB, 0.21092968E-10_JPRB, 0.20971886E-10_JPRB, 0.21374602E-10_JPRB, 0.21927066E-10_JPRB, &
  & 0.22692742E-10_JPRB, 0.23514503E-10_JPRB, 0.23766031E-10_JPRB, 0.24213517E-10_JPRB, 0.24665082E-10_JPRB, 0.25134009E-10_JPRB, &
  & 0.25699444E-10_JPRB, 0.26367264E-10_JPRB, 0.27148915E-10_JPRB, 0.28026250E-10_JPRB, 0.28942857E-10_JPRB, 0.29923650E-10_JPRB, &
  & 0.30952581E-10_JPRB, 0.32013597E-10_JPRB, 0.33150510E-10_JPRB, 0.34255508E-10_JPRB, 0.35368822E-10_JPRB, 0.36512619E-10_JPRB, &
  & 0.37704326E-10_JPRB, 0.38920381E-10_JPRB, 0.40160313E-10_JPRB, 0.41424534E-10_JPRB, 0.42671776E-10_JPRB, 0.43912821E-10_JPRB, &
  & 0.45165333E-10_JPRB, 0.46408027E-10_JPRB, 0.47650064E-10_JPRB, 0.48870907E-10_JPRB, 0.50060036E-10_JPRB, 0.51199867E-10_JPRB, &
  & 0.52316578E-10_JPRB, 0.53441002E-10_JPRB, 0.54489278E-10_JPRB, 0.55524675E-10_JPRB, 0.56573485E-10_JPRB, 0.57506395E-10_JPRB, &
  & 0.58356264E-10_JPRB, 0.59274349E-10_JPRB, 0.60132621E-10_JPRB, 0.61075110E-10_JPRB, 0.61941285E-10_JPRB, 0.62743158E-10_JPRB, &
  & 0.63461680E-10_JPRB, 0.64140158E-10_JPRB, 0.64889240E-10_JPRB, 0.65609511E-10_JPRB, 0.66463071E-10_JPRB, 0.66908028E-10_JPRB, &
  & 0.67403964E-10_JPRB, 0.67700186E-10_JPRB, 0.68915575E-10_JPRB, 0.69292877E-10_JPRB, 0.70390617E-10_JPRB, 0.70511097E-10_JPRB, &
  & 0.70723344E-10_JPRB, 0.79979239E-10_JPRB, 0.80267744E-10_JPRB, 0.81449375E-10_JPRB /)

RGHG4(:,88, 2) = (/ &
  & 0.21288088E-10_JPRB, 0.20761564E-10_JPRB, 0.21146040E-10_JPRB, 0.20996000E-10_JPRB, 0.21464096E-10_JPRB, 0.21932152E-10_JPRB, &
  & 0.22866129E-10_JPRB, 0.23507932E-10_JPRB, 0.23875376E-10_JPRB, 0.24315161E-10_JPRB, 0.24768132E-10_JPRB, 0.25222562E-10_JPRB, &
  & 0.25763546E-10_JPRB, 0.26428989E-10_JPRB, 0.27205394E-10_JPRB, 0.28049958E-10_JPRB, 0.28968248E-10_JPRB, 0.29940984E-10_JPRB, &
  & 0.30980291E-10_JPRB, 0.32058054E-10_JPRB, 0.33162903E-10_JPRB, 0.34303144E-10_JPRB, 0.35447520E-10_JPRB, 0.36607956E-10_JPRB, &
  & 0.37801779E-10_JPRB, 0.39019663E-10_JPRB, 0.40270582E-10_JPRB, 0.41530050E-10_JPRB, 0.42813166E-10_JPRB, 0.44074900E-10_JPRB, &
  & 0.45325584E-10_JPRB, 0.46559544E-10_JPRB, 0.47787024E-10_JPRB, 0.49042236E-10_JPRB, 0.50243702E-10_JPRB, 0.51417939E-10_JPRB, &
  & 0.52556109E-10_JPRB, 0.53649852E-10_JPRB, 0.54730800E-10_JPRB, 0.55765878E-10_JPRB, 0.56788831E-10_JPRB, 0.57745132E-10_JPRB, &
  & 0.58559560E-10_JPRB, 0.59447773E-10_JPRB, 0.60288927E-10_JPRB, 0.61242726E-10_JPRB, 0.62075185E-10_JPRB, 0.62793472E-10_JPRB, &
  & 0.63558055E-10_JPRB, 0.64243499E-10_JPRB, 0.65044622E-10_JPRB, 0.65767718E-10_JPRB, 0.66610190E-10_JPRB, 0.67062383E-10_JPRB, &
  & 0.67542305E-10_JPRB, 0.67795346E-10_JPRB, 0.69022794E-10_JPRB, 0.69412531E-10_JPRB, 0.70429280E-10_JPRB, 0.70665529E-10_JPRB, &
  & 0.70758323E-10_JPRB, 0.79989966E-10_JPRB, 0.80313561E-10_JPRB, 0.81469123E-10_JPRB /)

RGHG4(:,89, 2) = (/ &
  & 0.21322919E-10_JPRB, 0.20808497E-10_JPRB, 0.21172042E-10_JPRB, 0.21030728E-10_JPRB, 0.21461156E-10_JPRB, 0.21991357E-10_JPRB, &
  & 0.22762920E-10_JPRB, 0.23561656E-10_JPRB, 0.23900031E-10_JPRB, 0.24306075E-10_JPRB, 0.24789686E-10_JPRB, 0.25251155E-10_JPRB, &
  & 0.25829248E-10_JPRB, 0.26489883E-10_JPRB, 0.27274656E-10_JPRB, 0.28138252E-10_JPRB, 0.29061736E-10_JPRB, 0.30033857E-10_JPRB, &
  & 0.31047345E-10_JPRB, 0.32104999E-10_JPRB, 0.33218959E-10_JPRB, 0.34341720E-10_JPRB, 0.35465197E-10_JPRB, 0.36619388E-10_JPRB, &
  & 0.37818623E-10_JPRB, 0.39039088E-10_JPRB, 0.40305655E-10_JPRB, 0.41585693E-10_JPRB, 0.42848641E-10_JPRB, 0.44106281E-10_JPRB, &
  & 0.45375540E-10_JPRB, 0.46642759E-10_JPRB, 0.47929851E-10_JPRB, 0.49198624E-10_JPRB, 0.50449991E-10_JPRB, 0.51638072E-10_JPRB, &
  & 0.52797440E-10_JPRB, 0.53916392E-10_JPRB, 0.54972742E-10_JPRB, 0.56023363E-10_JPRB, 0.57057976E-10_JPRB, 0.57992344E-10_JPRB, &
  & 0.58826763E-10_JPRB, 0.59706913E-10_JPRB, 0.60529672E-10_JPRB, 0.61483825E-10_JPRB, 0.62382807E-10_JPRB, 0.63086307E-10_JPRB, &
  & 0.63811879E-10_JPRB, 0.64460319E-10_JPRB, 0.65224950E-10_JPRB, 0.65971853E-10_JPRB, 0.66782364E-10_JPRB, 0.67251489E-10_JPRB, &
  & 0.67700956E-10_JPRB, 0.67971358E-10_JPRB, 0.69142629E-10_JPRB, 0.69623134E-10_JPRB, 0.70448244E-10_JPRB, 0.70847446E-10_JPRB, &
  & 0.70802829E-10_JPRB, 0.79967769E-10_JPRB, 0.80367372E-10_JPRB, 0.81484486E-10_JPRB /)

RGHG4(:,90, 2) = (/ &
  & 0.21338160E-10_JPRB, 0.20869589E-10_JPRB, 0.21154285E-10_JPRB, 0.21065196E-10_JPRB, 0.21408129E-10_JPRB, 0.21871475E-10_JPRB, &
  & 0.22687244E-10_JPRB, 0.23437466E-10_JPRB, 0.23753607E-10_JPRB, 0.24276407E-10_JPRB, 0.24737960E-10_JPRB, 0.25276335E-10_JPRB, &
  & 0.25862937E-10_JPRB, 0.26570914E-10_JPRB, 0.27348573E-10_JPRB, 0.28187737E-10_JPRB, 0.29078380E-10_JPRB, 0.30017485E-10_JPRB, &
  & 0.31030754E-10_JPRB, 0.32090029E-10_JPRB, 0.33192400E-10_JPRB, 0.34319669E-10_JPRB, 0.35454226E-10_JPRB, 0.36622955E-10_JPRB, &
  & 0.37839797E-10_JPRB, 0.39085301E-10_JPRB, 0.40359091E-10_JPRB, 0.41647834E-10_JPRB, 0.42971834E-10_JPRB, 0.44291213E-10_JPRB, &
  & 0.45586358E-10_JPRB, 0.46868585E-10_JPRB, 0.48153932E-10_JPRB, 0.49436916E-10_JPRB, 0.50709343E-10_JPRB, 0.51935879E-10_JPRB, &
  & 0.53099546E-10_JPRB, 0.54205949E-10_JPRB, 0.55256501E-10_JPRB, 0.56288536E-10_JPRB, 0.57304030E-10_JPRB, 0.58213663E-10_JPRB, &
  & 0.59013794E-10_JPRB, 0.59861956E-10_JPRB, 0.60655071E-10_JPRB, 0.61536963E-10_JPRB, 0.62400939E-10_JPRB, 0.63142255E-10_JPRB, &
  & 0.63897956E-10_JPRB, 0.64580681E-10_JPRB, 0.65333412E-10_JPRB, 0.66105177E-10_JPRB, 0.66889771E-10_JPRB, 0.67384723E-10_JPRB, &
  & 0.67778047E-10_JPRB, 0.68096702E-10_JPRB, 0.69152371E-10_JPRB, 0.69856808E-10_JPRB, 0.70368218E-10_JPRB, 0.70989194E-10_JPRB, &
  & 0.70804175E-10_JPRB, 0.79891635E-10_JPRB, 0.80431127E-10_JPRB, 0.81506232E-10_JPRB /)

RGHG4(:,91, 2) = (/ &
  & 0.21287258E-10_JPRB, 0.20971232E-10_JPRB, 0.21083359E-10_JPRB, 0.21094845E-10_JPRB, 0.21320041E-10_JPRB, 0.21809140E-10_JPRB, &
  & 0.20663006E-10_JPRB, 0.22711617E-10_JPRB, 0.23569020E-10_JPRB, 0.24095691E-10_JPRB, 0.24651241E-10_JPRB, 0.25245297E-10_JPRB, &
  & 0.25899243E-10_JPRB, 0.26624869E-10_JPRB, 0.27400006E-10_JPRB, 0.28225207E-10_JPRB, 0.29096980E-10_JPRB, 0.30033184E-10_JPRB, &
  & 0.31017054E-10_JPRB, 0.32046827E-10_JPRB, 0.33130765E-10_JPRB, 0.34246918E-10_JPRB, 0.35370058E-10_JPRB, 0.36543647E-10_JPRB, &
  & 0.37766616E-10_JPRB, 0.38994055E-10_JPRB, 0.40337414E-10_JPRB, 0.41669987E-10_JPRB, 0.42984498E-10_JPRB, 0.44327108E-10_JPRB, &
  & 0.45639999E-10_JPRB, 0.46966583E-10_JPRB, 0.48342986E-10_JPRB, 0.49689780E-10_JPRB, 0.51053550E-10_JPRB, 0.52318868E-10_JPRB, &
  & 0.53497092E-10_JPRB, 0.54601663E-10_JPRB, 0.55649690E-10_JPRB, 0.56671608E-10_JPRB, 0.55477900E-10_JPRB, 0.56432525E-10_JPRB, &
  & 0.59329000E-10_JPRB, 0.60169238E-10_JPRB, 0.60980873E-10_JPRB, 0.61866158E-10_JPRB, 0.62679778E-10_JPRB, 0.63369372E-10_JPRB, &
  & 0.64084106E-10_JPRB, 0.64754938E-10_JPRB, 0.65492195E-10_JPRB, 0.66273036E-10_JPRB, 0.67029958E-10_JPRB, 0.67544664E-10_JPRB, &
  & 0.67871993E-10_JPRB, 0.68321113E-10_JPRB, 0.69092905E-10_JPRB, 0.70160232E-10_JPRB, 0.70354826E-10_JPRB, 0.71118132E-10_JPRB, &
  & 0.70698676E-10_JPRB, 0.79770704E-10_JPRB, 0.80543870E-10_JPRB, 0.81542662E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG4(:, 1, 3) = (/ &
  & 0.94725727E-09_JPRB, 0.85142281E-13_JPRB, 0.83163897E-13_JPRB, 0.85117514E-13_JPRB, 0.94493105E-13_JPRB, 0.99217760E-13_JPRB, &
  & 0.10343986E-12_JPRB, 0.11264888E-12_JPRB, 0.11361187E-12_JPRB, 0.11413114E-12_JPRB, 0.11423660E-12_JPRB, 0.11390480E-12_JPRB, &
  & 0.11356277E-12_JPRB, 0.11297192E-12_JPRB, 0.11270988E-12_JPRB, 0.11239324E-12_JPRB, 0.11224687E-12_JPRB, 0.11217747E-12_JPRB, &
  & 0.11192689E-12_JPRB, 0.11162088E-12_JPRB, 0.11172800E-12_JPRB, 0.11225561E-12_JPRB, 0.11325807E-12_JPRB, 0.11511580E-12_JPRB, &
  & 0.11736676E-12_JPRB, 0.11983856E-12_JPRB, 0.12244013E-12_JPRB, 0.12486248E-12_JPRB, 0.12647365E-12_JPRB, 0.12689821E-12_JPRB, &
  & 0.12614317E-12_JPRB, 0.12423028E-12_JPRB, 0.12199944E-12_JPRB, 0.12616499E-12_JPRB, 0.12278926E-12_JPRB, 0.12037498E-12_JPRB, &
  & 0.11904590E-12_JPRB, 0.11796366E-12_JPRB, 0.11708246E-12_JPRB, 0.11609644E-12_JPRB, 0.11528590E-12_JPRB, 0.11409738E-12_JPRB, &
  & 0.11302346E-12_JPRB, 0.11185828E-12_JPRB, 0.11097017E-12_JPRB, 0.11026826E-12_JPRB, 0.10970642E-12_JPRB, 0.10891264E-12_JPRB, &
  & 0.10782471E-12_JPRB, 0.10637117E-12_JPRB, 0.10459931E-12_JPRB, 0.10246913E-12_JPRB, 0.99725837E-13_JPRB, 0.96167933E-13_JPRB, &
  & 0.91438508E-13_JPRB, 0.85150359E-13_JPRB, 0.75426617E-13_JPRB, 0.67643231E-13_JPRB, 0.54283045E-13_JPRB, 0.40828221E-13_JPRB, &
  & 0.28896448E-13_JPRB, 0.20207765E-13_JPRB, 0.14954482E-13_JPRB, 0.13024589E-13_JPRB /)

RGHG4(:, 2, 3) = (/ &
  & 0.10067326E-19_JPRB, 0.29194008E-12_JPRB, 0.31815178E-12_JPRB, 0.34155770E-12_JPRB, 0.35447586E-12_JPRB, 0.35784635E-12_JPRB, &
  & 0.36707754E-12_JPRB, 0.38714279E-12_JPRB, 0.41942169E-12_JPRB, 0.45855491E-12_JPRB, 0.49976196E-12_JPRB, 0.54173604E-12_JPRB, &
  & 0.58235312E-12_JPRB, 0.62073914E-12_JPRB, 0.65463054E-12_JPRB, 0.68213761E-12_JPRB, 0.69785410E-12_JPRB, 0.70231180E-12_JPRB, &
  & 0.69706534E-12_JPRB, 0.68665120E-12_JPRB, 0.66486915E-12_JPRB, 0.63043673E-12_JPRB, 0.60183515E-12_JPRB, 0.57244926E-12_JPRB, &
  & 0.55261492E-12_JPRB, 0.54690914E-12_JPRB, 0.54793203E-12_JPRB, 0.54884949E-12_JPRB, 0.54831546E-12_JPRB, 0.54864772E-12_JPRB, &
  & 0.55283192E-12_JPRB, 0.55967167E-12_JPRB, 0.58949270E-12_JPRB, 0.64048978E-12_JPRB, 0.68999900E-12_JPRB, 0.73472950E-12_JPRB, &
  & 0.78040992E-12_JPRB, 0.82932245E-12_JPRB, 0.86565304E-12_JPRB, 0.87480760E-12_JPRB, 0.86008121E-12_JPRB, 0.82562212E-12_JPRB, &
  & 0.77627797E-12_JPRB, 0.71501686E-12_JPRB, 0.64614969E-12_JPRB, 0.57332296E-12_JPRB, 0.50008229E-12_JPRB, 0.42982938E-12_JPRB, &
  & 0.36959818E-12_JPRB, 0.32505579E-12_JPRB, 0.29646571E-12_JPRB, 0.27712535E-12_JPRB, 0.25863036E-12_JPRB, 0.23873397E-12_JPRB, &
  & 0.21915503E-12_JPRB, 0.20452575E-12_JPRB, 0.18029240E-12_JPRB, 0.18391083E-12_JPRB, 0.18877930E-12_JPRB, 0.19411728E-12_JPRB, &
  & 0.19942807E-12_JPRB, 0.20496015E-12_JPRB, 0.20933849E-12_JPRB, 0.21560156E-12_JPRB /)

RGHG4(:, 3, 3) = (/ &
  & 0.24212773E-09_JPRB, 0.45487128E-12_JPRB, 0.45669458E-12_JPRB, 0.47579746E-12_JPRB, 0.51956199E-12_JPRB, 0.58408519E-12_JPRB, &
  & 0.66215403E-12_JPRB, 0.74397818E-12_JPRB, 0.83223532E-12_JPRB, 0.90928339E-12_JPRB, 0.98364372E-12_JPRB, 0.10588756E-11_JPRB, &
  & 0.11299065E-11_JPRB, 0.11945470E-11_JPRB, 0.12496198E-11_JPRB, 0.12922179E-11_JPRB, 0.13162212E-11_JPRB, 0.13216042E-11_JPRB, &
  & 0.13060403E-11_JPRB, 0.12676326E-11_JPRB, 0.12240809E-11_JPRB, 0.11874605E-11_JPRB, 0.11485550E-11_JPRB, 0.11110135E-11_JPRB, &
  & 0.10796523E-11_JPRB, 0.10633419E-11_JPRB, 0.10680850E-11_JPRB, 0.10882948E-11_JPRB, 0.11135803E-11_JPRB, 0.11466650E-11_JPRB, &
  & 0.11851746E-11_JPRB, 0.12289019E-11_JPRB, 0.13017473E-11_JPRB, 0.13920709E-11_JPRB, 0.14807651E-11_JPRB, 0.15614034E-11_JPRB, &
  & 0.16395768E-11_JPRB, 0.17041012E-11_JPRB, 0.17590949E-11_JPRB, 0.17827264E-11_JPRB, 0.17625728E-11_JPRB, 0.16978321E-11_JPRB, &
  & 0.15975091E-11_JPRB, 0.14719750E-11_JPRB, 0.13317113E-11_JPRB, 0.11861752E-11_JPRB, 0.10461406E-11_JPRB, 0.91902462E-12_JPRB, &
  & 0.81062880E-12_JPRB, 0.71825163E-12_JPRB, 0.63850623E-12_JPRB, 0.57303993E-12_JPRB, 0.52561303E-12_JPRB, 0.49855508E-12_JPRB, &
  & 0.48893035E-12_JPRB, 0.49377749E-12_JPRB, 0.47846536E-12_JPRB, 0.50944475E-12_JPRB, 0.53900938E-12_JPRB, 0.56602303E-12_JPRB, &
  & 0.58895548E-12_JPRB, 0.60910500E-12_JPRB, 0.62924427E-12_JPRB, 0.73576486E-12_JPRB /)

RGHG4(:, 4, 3) = (/ &
  & 0.81627421E-09_JPRB, 0.96735011E-12_JPRB, 0.11002306E-11_JPRB, 0.12491336E-11_JPRB, 0.14009309E-11_JPRB, 0.15580408E-11_JPRB, &
  & 0.17283667E-11_JPRB, 0.19070294E-11_JPRB, 0.20835840E-11_JPRB, 0.22423372E-11_JPRB, 0.23820995E-11_JPRB, 0.25108342E-11_JPRB, &
  & 0.26203204E-11_JPRB, 0.27107695E-11_JPRB, 0.27812449E-11_JPRB, 0.28312647E-11_JPRB, 0.28570933E-11_JPRB, 0.28614697E-11_JPRB, &
  & 0.28487629E-11_JPRB, 0.28282756E-11_JPRB, 0.28104539E-11_JPRB, 0.27891242E-11_JPRB, 0.27793625E-11_JPRB, 0.28008938E-11_JPRB, &
  & 0.28543392E-11_JPRB, 0.29315383E-11_JPRB, 0.30180756E-11_JPRB, 0.31035114E-11_JPRB, 0.31904069E-11_JPRB, 0.32593362E-11_JPRB, &
  & 0.33098442E-11_JPRB, 0.33450595E-11_JPRB, 0.34193002E-11_JPRB, 0.35142414E-11_JPRB, 0.36112300E-11_JPRB, 0.37228649E-11_JPRB, &
  & 0.38621675E-11_JPRB, 0.39906841E-11_JPRB, 0.40955048E-11_JPRB, 0.41426502E-11_JPRB, 0.41093079E-11_JPRB, 0.39813257E-11_JPRB, &
  & 0.37705698E-11_JPRB, 0.35029165E-11_JPRB, 0.32092916E-11_JPRB, 0.29139002E-11_JPRB, 0.26344840E-11_JPRB, 0.23762270E-11_JPRB, &
  & 0.21489368E-11_JPRB, 0.19522990E-11_JPRB, 0.17896621E-11_JPRB, 0.16664977E-11_JPRB, 0.15765810E-11_JPRB, 0.15144923E-11_JPRB, &
  & 0.14745812E-11_JPRB, 0.14545138E-11_JPRB, 0.13194387E-11_JPRB, 0.13289895E-11_JPRB, 0.13515712E-11_JPRB, 0.13902926E-11_JPRB, &
  & 0.14250182E-11_JPRB, 0.14764550E-11_JPRB, 0.15518318E-11_JPRB, 0.21962336E-11_JPRB /)

RGHG4(:, 5, 3) = (/ &
  & 0.15150665E-08_JPRB, 0.31190736E-11_JPRB, 0.35019463E-11_JPRB, 0.38922238E-11_JPRB, 0.42708805E-11_JPRB, 0.46448977E-11_JPRB, &
  & 0.50227236E-11_JPRB, 0.53929565E-11_JPRB, 0.57473566E-11_JPRB, 0.60731021E-11_JPRB, 0.63597890E-11_JPRB, 0.66135322E-11_JPRB, &
  & 0.68236311E-11_JPRB, 0.69938651E-11_JPRB, 0.71254413E-11_JPRB, 0.72256710E-11_JPRB, 0.73027929E-11_JPRB, 0.73653783E-11_JPRB, &
  & 0.74323360E-11_JPRB, 0.75144986E-11_JPRB, 0.76463913E-11_JPRB, 0.78503480E-11_JPRB, 0.81343708E-11_JPRB, 0.84872968E-11_JPRB, &
  & 0.88749676E-11_JPRB, 0.92714074E-11_JPRB, 0.96366743E-11_JPRB, 0.99543282E-11_JPRB, 0.10202335E-10_JPRB, 0.10350364E-10_JPRB, &
  & 0.10428415E-10_JPRB, 0.10425657E-10_JPRB, 0.10445969E-10_JPRB, 0.10489556E-10_JPRB, 0.10536334E-10_JPRB, 0.10599618E-10_JPRB, &
  & 0.10726624E-10_JPRB, 0.10850772E-10_JPRB, 0.10932806E-10_JPRB, 0.10899447E-10_JPRB, 0.10698155E-10_JPRB, 0.10305081E-10_JPRB, &
  & 0.97488302E-11_JPRB, 0.91013820E-11_JPRB, 0.84262701E-11_JPRB, 0.77636595E-11_JPRB, 0.71485907E-11_JPRB, 0.65920138E-11_JPRB, &
  & 0.60989742E-11_JPRB, 0.56524039E-11_JPRB, 0.52570361E-11_JPRB, 0.49191744E-11_JPRB, 0.46258596E-11_JPRB, 0.43834073E-11_JPRB, &
  & 0.42005657E-11_JPRB, 0.40776709E-11_JPRB, 0.38685253E-11_JPRB, 0.38329656E-11_JPRB, 0.38274917E-11_JPRB, 0.38923587E-11_JPRB, &
  & 0.39795437E-11_JPRB, 0.41865266E-11_JPRB, 0.45967999E-11_JPRB, 0.76006189E-11_JPRB /)

RGHG4(:, 6, 3) = (/ &
  & 0.28720881E-08_JPRB, 0.12996574E-10_JPRB, 0.13005521E-10_JPRB, 0.13657594E-10_JPRB, 0.14374328E-10_JPRB, 0.15111632E-10_JPRB, &
  & 0.15851615E-10_JPRB, 0.16567983E-10_JPRB, 0.17244022E-10_JPRB, 0.17850756E-10_JPRB, 0.18366860E-10_JPRB, 0.18796589E-10_JPRB, &
  & 0.19139683E-10_JPRB, 0.19401999E-10_JPRB, 0.19597757E-10_JPRB, 0.19758292E-10_JPRB, 0.19916043E-10_JPRB, 0.20105372E-10_JPRB, &
  & 0.20387534E-10_JPRB, 0.20802009E-10_JPRB, 0.21398924E-10_JPRB, 0.22188225E-10_JPRB, 0.23151731E-10_JPRB, 0.24227750E-10_JPRB, &
  & 0.25333088E-10_JPRB, 0.26384103E-10_JPRB, 0.27343534E-10_JPRB, 0.28189132E-10_JPRB, 0.28871280E-10_JPRB, 0.29345922E-10_JPRB, &
  & 0.29646639E-10_JPRB, 0.29742906E-10_JPRB, 0.29722332E-10_JPRB, 0.29655490E-10_JPRB, 0.29518762E-10_JPRB, 0.29309798E-10_JPRB, &
  & 0.29151292E-10_JPRB, 0.28957316E-10_JPRB, 0.28637256E-10_JPRB, 0.28089661E-10_JPRB, 0.27222107E-10_JPRB, 0.26033127E-10_JPRB, &
  & 0.24650783E-10_JPRB, 0.23226653E-10_JPRB, 0.21861778E-10_JPRB, 0.20589126E-10_JPRB, 0.19402962E-10_JPRB, 0.18280979E-10_JPRB, &
  & 0.17210046E-10_JPRB, 0.16204742E-10_JPRB, 0.15281406E-10_JPRB, 0.14422014E-10_JPRB, 0.13620677E-10_JPRB, 0.12911081E-10_JPRB, &
  & 0.12309598E-10_JPRB, 0.11835232E-10_JPRB, 0.11462572E-10_JPRB, 0.11265851E-10_JPRB, 0.11187816E-10_JPRB, 0.11299689E-10_JPRB, &
  & 0.11526153E-10_JPRB, 0.12195315E-10_JPRB, 0.13707840E-10_JPRB, 0.20481897E-10_JPRB /)

RGHG4(:, 7, 3) = (/ &
  & 0.51871289E-08_JPRB, 0.57277148E-10_JPRB, 0.51768586E-10_JPRB, 0.50339576E-10_JPRB, 0.50001416E-10_JPRB, 0.50137273E-10_JPRB, &
  & 0.50526291E-10_JPRB, 0.51019303E-10_JPRB, 0.51582967E-10_JPRB, 0.52174813E-10_JPRB, 0.52718194E-10_JPRB, 0.53166541E-10_JPRB, &
  & 0.53498414E-10_JPRB, 0.53685174E-10_JPRB, 0.53770734E-10_JPRB, 0.53785677E-10_JPRB, 0.53857110E-10_JPRB, 0.54097508E-10_JPRB, &
  & 0.54652900E-10_JPRB, 0.55608990E-10_JPRB, 0.57055312E-10_JPRB, 0.59024563E-10_JPRB, 0.61483457E-10_JPRB, 0.64298573E-10_JPRB, &
  & 0.67203326E-10_JPRB, 0.70004010E-10_JPRB, 0.72528823E-10_JPRB, 0.74765805E-10_JPRB, 0.76655501E-10_JPRB, 0.78146163E-10_JPRB, &
  & 0.79209153E-10_JPRB, 0.79781251E-10_JPRB, 0.79845526E-10_JPRB, 0.79581293E-10_JPRB, 0.78986484E-10_JPRB, 0.77966494E-10_JPRB, &
  & 0.76893353E-10_JPRB, 0.75638530E-10_JPRB, 0.74017556E-10_JPRB, 0.71928130E-10_JPRB, 0.69256108E-10_JPRB, 0.66170763E-10_JPRB, &
  & 0.62944892E-10_JPRB, 0.59859895E-10_JPRB, 0.56999912E-10_JPRB, 0.54331661E-10_JPRB, 0.51834839E-10_JPRB, 0.49492466E-10_JPRB, &
  & 0.47278455E-10_JPRB, 0.45172945E-10_JPRB, 0.43128726E-10_JPRB, 0.41176472E-10_JPRB, 0.39403210E-10_JPRB, 0.37843367E-10_JPRB, &
  & 0.36522136E-10_JPRB, 0.35552252E-10_JPRB, 0.35052662E-10_JPRB, 0.34981493E-10_JPRB, 0.35226586E-10_JPRB, 0.36198419E-10_JPRB, &
  & 0.37860954E-10_JPRB, 0.41136476E-10_JPRB, 0.46772652E-10_JPRB, 0.64167033E-10_JPRB /)

RGHG4(:, 8, 3) = (/ &
  & 0.83853617E-08_JPRB, 0.19795880E-09_JPRB, 0.18618795E-09_JPRB, 0.17481541E-09_JPRB, 0.16713156E-09_JPRB, 0.16254677E-09_JPRB, &
  & 0.16010476E-09_JPRB, 0.15894377E-09_JPRB, 0.15873269E-09_JPRB, 0.15902804E-09_JPRB, 0.15934659E-09_JPRB, 0.15952596E-09_JPRB, &
  & 0.15950334E-09_JPRB, 0.15915784E-09_JPRB, 0.15857256E-09_JPRB, 0.15776321E-09_JPRB, 0.15704865E-09_JPRB, 0.15656978E-09_JPRB, &
  & 0.15675347E-09_JPRB, 0.15776347E-09_JPRB, 0.15979697E-09_JPRB, 0.16285968E-09_JPRB, 0.16689493E-09_JPRB, 0.17158987E-09_JPRB, &
  & 0.17666350E-09_JPRB, 0.18169879E-09_JPRB, 0.18645957E-09_JPRB, 0.19079172E-09_JPRB, 0.19454989E-09_JPRB, 0.19761992E-09_JPRB, &
  & 0.19988187E-09_JPRB, 0.20115412E-09_JPRB, 0.20123403E-09_JPRB, 0.20038546E-09_JPRB, 0.19878016E-09_JPRB, 0.19586881E-09_JPRB, &
  & 0.19273362E-09_JPRB, 0.18909917E-09_JPRB, 0.18459885E-09_JPRB, 0.17920669E-09_JPRB, 0.17288344E-09_JPRB, 0.16606082E-09_JPRB, &
  & 0.15924882E-09_JPRB, 0.15287546E-09_JPRB, 0.14698728E-09_JPRB, 0.14161383E-09_JPRB, 0.13663409E-09_JPRB, 0.13188929E-09_JPRB, &
  & 0.12725894E-09_JPRB, 0.12270929E-09_JPRB, 0.11829929E-09_JPRB, 0.11412453E-09_JPRB, 0.11016132E-09_JPRB, 0.10645929E-09_JPRB, &
  & 0.10331225E-09_JPRB, 0.10110576E-09_JPRB, 0.10019965E-09_JPRB, 0.10055325E-09_JPRB, 0.10208900E-09_JPRB, 0.10573087E-09_JPRB, &
  & 0.11138301E-09_JPRB, 0.12078495E-09_JPRB, 0.13492114E-09_JPRB, 0.15596152E-09_JPRB /)

RGHG4(:, 9, 3) = (/ &
  & 0.11705414E-07_JPRB, 0.47982257E-09_JPRB, 0.50475069E-09_JPRB, 0.50341703E-09_JPRB, 0.49001680E-09_JPRB, 0.47580184E-09_JPRB, &
  & 0.46377913E-09_JPRB, 0.45419807E-09_JPRB, 0.44760526E-09_JPRB, 0.44317208E-09_JPRB, 0.43979015E-09_JPRB, 0.43696599E-09_JPRB, &
  & 0.43433210E-09_JPRB, 0.43155116E-09_JPRB, 0.42873066E-09_JPRB, 0.42559756E-09_JPRB, 0.42269593E-09_JPRB, 0.42002310E-09_JPRB, &
  & 0.41829989E-09_JPRB, 0.41770673E-09_JPRB, 0.41862572E-09_JPRB, 0.42102830E-09_JPRB, 0.42483886E-09_JPRB, 0.42981529E-09_JPRB, &
  & 0.43542567E-09_JPRB, 0.44146115E-09_JPRB, 0.44747103E-09_JPRB, 0.45333950E-09_JPRB, 0.45858140E-09_JPRB, 0.46287760E-09_JPRB, &
  & 0.46575716E-09_JPRB, 0.46684501E-09_JPRB, 0.46566784E-09_JPRB, 0.46254317E-09_JPRB, 0.45827528E-09_JPRB, 0.45110782E-09_JPRB, &
  & 0.44385845E-09_JPRB, 0.43574447E-09_JPRB, 0.42613257E-09_JPRB, 0.41498144E-09_JPRB, 0.40222087E-09_JPRB, 0.38863757E-09_JPRB, &
  & 0.37529654E-09_JPRB, 0.36306735E-09_JPRB, 0.35232797E-09_JPRB, 0.34276973E-09_JPRB, 0.33395237E-09_JPRB, 0.32554417E-09_JPRB, &
  & 0.31739197E-09_JPRB, 0.30942138E-09_JPRB, 0.30161773E-09_JPRB, 0.29401995E-09_JPRB, 0.28694999E-09_JPRB, 0.28105335E-09_JPRB, &
  & 0.27672392E-09_JPRB, 0.27445304E-09_JPRB, 0.27507707E-09_JPRB, 0.27859209E-09_JPRB, 0.28479163E-09_JPRB, 0.29477329E-09_JPRB, &
  & 0.30682967E-09_JPRB, 0.31934902E-09_JPRB, 0.32784975E-09_JPRB, 0.33534794E-09_JPRB /)

RGHG4(:,10, 3) = (/ &
  & 0.14383624E-07_JPRB, 0.90916535E-09_JPRB, 0.10036817E-08_JPRB, 0.10622808E-08_JPRB, 0.10874781E-08_JPRB, 0.10922674E-08_JPRB, &
  & 0.10857927E-08_JPRB, 0.10738156E-08_JPRB, 0.10622999E-08_JPRB, 0.10521127E-08_JPRB, 0.10428578E-08_JPRB, 0.10345892E-08_JPRB, &
  & 0.10270315E-08_JPRB, 0.10196911E-08_JPRB, 0.10130445E-08_JPRB, 0.10061173E-08_JPRB, 0.99987552E-09_JPRB, 0.99365960E-09_JPRB, &
  & 0.98852182E-09_JPRB, 0.98431074E-09_JPRB, 0.98152286E-09_JPRB, 0.98010910E-09_JPRB, 0.98007014E-09_JPRB, 0.98132624E-09_JPRB, &
  & 0.98348352E-09_JPRB, 0.98639785E-09_JPRB, 0.98982300E-09_JPRB, 0.99352016E-09_JPRB, 0.99676156E-09_JPRB, 0.99899045E-09_JPRB, &
  & 0.99913178E-09_JPRB, 0.99628372E-09_JPRB, 0.98949704E-09_JPRB, 0.97873998E-09_JPRB, 0.96701058E-09_JPRB, 0.95045327E-09_JPRB, &
  & 0.93455621E-09_JPRB, 0.91802649E-09_JPRB, 0.90012925E-09_JPRB, 0.88035729E-09_JPRB, 0.85822904E-09_JPRB, 0.83468327E-09_JPRB, &
  & 0.81099355E-09_JPRB, 0.78894735E-09_JPRB, 0.76901058E-09_JPRB, 0.75150397E-09_JPRB, 0.73585971E-09_JPRB, 0.72166556E-09_JPRB, &
  & 0.70836614E-09_JPRB, 0.69558109E-09_JPRB, 0.68321798E-09_JPRB, 0.67146583E-09_JPRB, 0.66045214E-09_JPRB, 0.65036043E-09_JPRB, &
  & 0.64179689E-09_JPRB, 0.63617589E-09_JPRB, 0.63418976E-09_JPRB, 0.63444305E-09_JPRB, 0.63611838E-09_JPRB, 0.63932659E-09_JPRB, &
  & 0.64219746E-09_JPRB, 0.64507982E-09_JPRB, 0.64148170E-09_JPRB, 0.62408384E-09_JPRB /)

RGHG4(:,11, 3) = (/ &
  & 0.15896655E-07_JPRB, 0.14356327E-08_JPRB, 0.16132466E-08_JPRB, 0.17507755E-08_JPRB, 0.18514298E-08_JPRB, 0.19224538E-08_JPRB, &
  & 0.19668462E-08_JPRB, 0.19896906E-08_JPRB, 0.20025224E-08_JPRB, 0.20086921E-08_JPRB, 0.20104804E-08_JPRB, 0.20100581E-08_JPRB, &
  & 0.20085005E-08_JPRB, 0.20055257E-08_JPRB, 0.20027466E-08_JPRB, 0.19987250E-08_JPRB, 0.19945610E-08_JPRB, 0.19893893E-08_JPRB, &
  & 0.19838131E-08_JPRB, 0.19782214E-08_JPRB, 0.19728785E-08_JPRB, 0.19680964E-08_JPRB, 0.19637896E-08_JPRB, 0.19597877E-08_JPRB, &
  & 0.19559916E-08_JPRB, 0.19523336E-08_JPRB, 0.19484196E-08_JPRB, 0.19441548E-08_JPRB, 0.19383322E-08_JPRB, 0.19301749E-08_JPRB, &
  & 0.19190614E-08_JPRB, 0.19039903E-08_JPRB, 0.18835704E-08_JPRB, 0.18566707E-08_JPRB, 0.18291071E-08_JPRB, 0.17957746E-08_JPRB, &
  & 0.17666756E-08_JPRB, 0.17375735E-08_JPRB, 0.17061794E-08_JPRB, 0.16728662E-08_JPRB, 0.16365412E-08_JPRB, 0.15969362E-08_JPRB, &
  & 0.15555934E-08_JPRB, 0.15150480E-08_JPRB, 0.14783103E-08_JPRB, 0.14459659E-08_JPRB, 0.14178980E-08_JPRB, 0.13927625E-08_JPRB, &
  & 0.13696095E-08_JPRB, 0.13477207E-08_JPRB, 0.13263812E-08_JPRB, 0.13051225E-08_JPRB, 0.12839315E-08_JPRB, 0.12632526E-08_JPRB, &
  & 0.12434220E-08_JPRB, 0.12241566E-08_JPRB, 0.12050689E-08_JPRB, 0.11843941E-08_JPRB, 0.11628364E-08_JPRB, 0.11392989E-08_JPRB, &
  & 0.11126211E-08_JPRB, 0.10786414E-08_JPRB, 0.10401644E-08_JPRB, 0.98435915E-09_JPRB /)

RGHG4(:,12, 3) = (/ &
  & 0.15953871E-07_JPRB, 0.19392572E-08_JPRB, 0.22084410E-08_JPRB, 0.24213054E-08_JPRB, 0.26047116E-08_JPRB, 0.27626521E-08_JPRB, &
  & 0.28934715E-08_JPRB, 0.29957337E-08_JPRB, 0.30803307E-08_JPRB, 0.31485003E-08_JPRB, 0.32023970E-08_JPRB, 0.32451137E-08_JPRB, &
  & 0.32789376E-08_JPRB, 0.33039234E-08_JPRB, 0.33225689E-08_JPRB, 0.33353371E-08_JPRB, 0.33418501E-08_JPRB, 0.33447844E-08_JPRB, &
  & 0.33436540E-08_JPRB, 0.33398722E-08_JPRB, 0.33346037E-08_JPRB, 0.33278806E-08_JPRB, 0.33203260E-08_JPRB, 0.33110479E-08_JPRB, &
  & 0.33001419E-08_JPRB, 0.32877125E-08_JPRB, 0.32738230E-08_JPRB, 0.32584513E-08_JPRB, 0.32410243E-08_JPRB, 0.32210654E-08_JPRB, &
  & 0.31979179E-08_JPRB, 0.31703420E-08_JPRB, 0.31359357E-08_JPRB, 0.30908776E-08_JPRB, 0.30489085E-08_JPRB, 0.29995380E-08_JPRB, &
  & 0.29496257E-08_JPRB, 0.29026213E-08_JPRB, 0.28576246E-08_JPRB, 0.28113323E-08_JPRB, 0.27613412E-08_JPRB, 0.27053908E-08_JPRB, &
  & 0.26435636E-08_JPRB, 0.25784193E-08_JPRB, 0.25135374E-08_JPRB, 0.24524529E-08_JPRB, 0.23957667E-08_JPRB, 0.23427937E-08_JPRB, &
  & 0.22919302E-08_JPRB, 0.22417639E-08_JPRB, 0.21913407E-08_JPRB, 0.21396784E-08_JPRB, 0.20858038E-08_JPRB, 0.20290460E-08_JPRB, &
  & 0.19690669E-08_JPRB, 0.19064257E-08_JPRB, 0.18411750E-08_JPRB, 0.17728401E-08_JPRB, 0.17049867E-08_JPRB, 0.16398437E-08_JPRB, &
  & 0.15762958E-08_JPRB, 0.15190509E-08_JPRB, 0.14584014E-08_JPRB, 0.13909832E-08_JPRB /)

RGHG4(:,13, 3) = (/ &
  & 0.14901287E-07_JPRB, 0.23422342E-08_JPRB, 0.27382454E-08_JPRB, 0.30141662E-08_JPRB, 0.32587721E-08_JPRB, 0.34889314E-08_JPRB, &
  & 0.36976890E-08_JPRB, 0.38778825E-08_JPRB, 0.40383550E-08_JPRB, 0.41775130E-08_JPRB, 0.42967274E-08_JPRB, 0.43982644E-08_JPRB, &
  & 0.44848640E-08_JPRB, 0.45561643E-08_JPRB, 0.46127995E-08_JPRB, 0.46578581E-08_JPRB, 0.46887658E-08_JPRB, 0.47094755E-08_JPRB, &
  & 0.47234283E-08_JPRB, 0.47308886E-08_JPRB, 0.47366773E-08_JPRB, 0.47402877E-08_JPRB, 0.47424429E-08_JPRB, 0.47423239E-08_JPRB, &
  & 0.47378630E-08_JPRB, 0.47292787E-08_JPRB, 0.47162159E-08_JPRB, 0.46993294E-08_JPRB, 0.46792441E-08_JPRB, 0.46565609E-08_JPRB, &
  & 0.46312745E-08_JPRB, 0.46012989E-08_JPRB, 0.45629993E-08_JPRB, 0.45106066E-08_JPRB, 0.44599884E-08_JPRB, 0.44033484E-08_JPRB, &
  & 0.43522976E-08_JPRB, 0.43001607E-08_JPRB, 0.42488728E-08_JPRB, 0.41948494E-08_JPRB, 0.41363686E-08_JPRB, 0.40682191E-08_JPRB, &
  & 0.39872612E-08_JPRB, 0.38936232E-08_JPRB, 0.37906784E-08_JPRB, 0.36814132E-08_JPRB, 0.35714496E-08_JPRB, 0.34618877E-08_JPRB, &
  & 0.33531860E-08_JPRB, 0.32444123E-08_JPRB, 0.31346274E-08_JPRB, 0.30228977E-08_JPRB, 0.29081566E-08_JPRB, 0.27903448E-08_JPRB, &
  & 0.26699696E-08_JPRB, 0.25480109E-08_JPRB, 0.24256648E-08_JPRB, 0.23044218E-08_JPRB, 0.21909770E-08_JPRB, 0.20858881E-08_JPRB, &
  & 0.19934232E-08_JPRB, 0.19071129E-08_JPRB, 0.18331558E-08_JPRB, 0.17602072E-08_JPRB /)

RGHG4(:,14, 3) = (/ &
  & 0.13598022E-07_JPRB, 0.26594504E-08_JPRB, 0.30835603E-08_JPRB, 0.34048551E-08_JPRB, 0.36845429E-08_JPRB, 0.39544732E-08_JPRB, &
  & 0.42115613E-08_JPRB, 0.44458610E-08_JPRB, 0.46641868E-08_JPRB, 0.48613513E-08_JPRB, 0.50367084E-08_JPRB, 0.51911595E-08_JPRB, &
  & 0.53268501E-08_JPRB, 0.54435279E-08_JPRB, 0.55392348E-08_JPRB, 0.56176175E-08_JPRB, 0.56756448E-08_JPRB, 0.57167959E-08_JPRB, &
  & 0.57469078E-08_JPRB, 0.57688552E-08_JPRB, 0.57887721E-08_JPRB, 0.58102345E-08_JPRB, 0.58314891E-08_JPRB, 0.58519665E-08_JPRB, &
  & 0.58677050E-08_JPRB, 0.58779221E-08_JPRB, 0.58833276E-08_JPRB, 0.58831691E-08_JPRB, 0.58798166E-08_JPRB, 0.58745324E-08_JPRB, &
  & 0.58677436E-08_JPRB, 0.58563092E-08_JPRB, 0.58346399E-08_JPRB, 0.57941891E-08_JPRB, 0.57591514E-08_JPRB, 0.57193281E-08_JPRB, &
  & 0.56790328E-08_JPRB, 0.56362972E-08_JPRB, 0.55909806E-08_JPRB, 0.55403961E-08_JPRB, 0.54827587E-08_JPRB, 0.54117684E-08_JPRB, &
  & 0.53187588E-08_JPRB, 0.52025713E-08_JPRB, 0.50629136E-08_JPRB, 0.49036335E-08_JPRB, 0.47315929E-08_JPRB, 0.45536126E-08_JPRB, &
  & 0.43733581E-08_JPRB, 0.41925730E-08_JPRB, 0.40110337E-08_JPRB, 0.38280090E-08_JPRB, 0.36423680E-08_JPRB, 0.34545682E-08_JPRB, &
  & 0.32662675E-08_JPRB, 0.30804690E-08_JPRB, 0.29003622E-08_JPRB, 0.27282869E-08_JPRB, 0.25724498E-08_JPRB, 0.24356637E-08_JPRB, &
  & 0.23159026E-08_JPRB, 0.22169873E-08_JPRB, 0.21300117E-08_JPRB, 0.20516853E-08_JPRB /)

RGHG4(:,15, 3) = (/ &
  & 0.11764607E-07_JPRB, 0.28031171E-08_JPRB, 0.32085195E-08_JPRB, 0.35783196E-08_JPRB, 0.38736698E-08_JPRB, 0.41521817E-08_JPRB, &
  & 0.44228892E-08_JPRB, 0.46809330E-08_JPRB, 0.49313003E-08_JPRB, 0.51656790E-08_JPRB, 0.53800524E-08_JPRB, 0.55711848E-08_JPRB, &
  & 0.57390932E-08_JPRB, 0.58820988E-08_JPRB, 0.59982908E-08_JPRB, 0.60920344E-08_JPRB, 0.61596075E-08_JPRB, 0.62079022E-08_JPRB, &
  & 0.62412759E-08_JPRB, 0.62665793E-08_JPRB, 0.62914260E-08_JPRB, 0.63225221E-08_JPRB, 0.63586740E-08_JPRB, 0.64001342E-08_JPRB, &
  & 0.64400747E-08_JPRB, 0.64759518E-08_JPRB, 0.65119723E-08_JPRB, 0.65434422E-08_JPRB, 0.65741483E-08_JPRB, 0.66037118E-08_JPRB, &
  & 0.66338015E-08_JPRB, 0.66584498E-08_JPRB, 0.66704162E-08_JPRB, 0.66587407E-08_JPRB, 0.66521970E-08_JPRB, 0.66369243E-08_JPRB, &
  & 0.66106463E-08_JPRB, 0.65753314E-08_JPRB, 0.65314958E-08_JPRB, 0.64792944E-08_JPRB, 0.64138255E-08_JPRB, 0.63295231E-08_JPRB, &
  & 0.62246928E-08_JPRB, 0.60965055E-08_JPRB, 0.59417307E-08_JPRB, 0.57599303E-08_JPRB, 0.55578742E-08_JPRB, 0.53429492E-08_JPRB, &
  & 0.51208557E-08_JPRB, 0.48968429E-08_JPRB, 0.46717279E-08_JPRB, 0.44441610E-08_JPRB, 0.42122066E-08_JPRB, 0.39765142E-08_JPRB, &
  & 0.37400629E-08_JPRB, 0.35078931E-08_JPRB, 0.32844683E-08_JPRB, 0.30742100E-08_JPRB, 0.28871083E-08_JPRB, 0.27243479E-08_JPRB, &
  & 0.25889058E-08_JPRB, 0.24741147E-08_JPRB, 0.23773385E-08_JPRB, 0.22613706E-08_JPRB /)

RGHG4(:,16, 3) = (/ &
  & 0.95772759E-08_JPRB, 0.28006877E-08_JPRB, 0.31052112E-08_JPRB, 0.35494991E-08_JPRB, 0.38641286E-08_JPRB, 0.41424975E-08_JPRB, &
  & 0.44076360E-08_JPRB, 0.46614663E-08_JPRB, 0.49136166E-08_JPRB, 0.51539963E-08_JPRB, 0.53774318E-08_JPRB, 0.55783556E-08_JPRB, &
  & 0.57550582E-08_JPRB, 0.59031646E-08_JPRB, 0.60224767E-08_JPRB, 0.61134706E-08_JPRB, 0.61766334E-08_JPRB, 0.62199077E-08_JPRB, &
  & 0.62461663E-08_JPRB, 0.62671566E-08_JPRB, 0.62900578E-08_JPRB, 0.63226593E-08_JPRB, 0.63656183E-08_JPRB, 0.64204571E-08_JPRB, &
  & 0.64805361E-08_JPRB, 0.65442012E-08_JPRB, 0.66055832E-08_JPRB, 0.66725332E-08_JPRB, 0.67459860E-08_JPRB, 0.68210095E-08_JPRB, &
  & 0.68885280E-08_JPRB, 0.69545218E-08_JPRB, 0.70067534E-08_JPRB, 0.70302582E-08_JPRB, 0.70488615E-08_JPRB, 0.70486057E-08_JPRB, &
  & 0.70234338E-08_JPRB, 0.69773054E-08_JPRB, 0.69151480E-08_JPRB, 0.68411263E-08_JPRB, 0.67531816E-08_JPRB, 0.66541874E-08_JPRB, &
  & 0.65422068E-08_JPRB, 0.64112453E-08_JPRB, 0.62568106E-08_JPRB, 0.60782570E-08_JPRB, 0.58800835E-08_JPRB, 0.56676472E-08_JPRB, &
  & 0.54468057E-08_JPRB, 0.52213300E-08_JPRB, 0.49921542E-08_JPRB, 0.47579474E-08_JPRB, 0.45171302E-08_JPRB, 0.42704338E-08_JPRB, &
  & 0.40211243E-08_JPRB, 0.37748826E-08_JPRB, 0.35380063E-08_JPRB, 0.33149039E-08_JPRB, 0.31177612E-08_JPRB, 0.29499381E-08_JPRB, &
  & 0.28099711E-08_JPRB, 0.26962228E-08_JPRB, 0.26058540E-08_JPRB, 0.25136770E-08_JPRB /)

RGHG4(:,17, 3) = (/ &
  & 0.75212041E-08_JPRB, 0.27764864E-08_JPRB, 0.30199310E-08_JPRB, 0.33776208E-08_JPRB, 0.37128678E-08_JPRB, 0.39684442E-08_JPRB, &
  & 0.42045234E-08_JPRB, 0.44241535E-08_JPRB, 0.46413722E-08_JPRB, 0.48514139E-08_JPRB, 0.50497957E-08_JPRB, 0.52301843E-08_JPRB, &
  & 0.53883675E-08_JPRB, 0.55187495E-08_JPRB, 0.56230007E-08_JPRB, 0.56970033E-08_JPRB, 0.57453278E-08_JPRB, 0.57701617E-08_JPRB, &
  & 0.57819567E-08_JPRB, 0.57908842E-08_JPRB, 0.58045528E-08_JPRB, 0.58322938E-08_JPRB, 0.58768435E-08_JPRB, 0.59386345E-08_JPRB, &
  & 0.60133636E-08_JPRB, 0.60897309E-08_JPRB, 0.61833036E-08_JPRB, 0.62774648E-08_JPRB, 0.63648873E-08_JPRB, 0.64672925E-08_JPRB, &
  & 0.65709784E-08_JPRB, 0.66677974E-08_JPRB, 0.67494343E-08_JPRB, 0.67947585E-08_JPRB, 0.68272357E-08_JPRB, 0.68302293E-08_JPRB, &
  & 0.67973378E-08_JPRB, 0.67318364E-08_JPRB, 0.66465891E-08_JPRB, 0.65502910E-08_JPRB, 0.64475127E-08_JPRB, 0.63359487E-08_JPRB, &
  & 0.62180581E-08_JPRB, 0.60932139E-08_JPRB, 0.59570553E-08_JPRB, 0.58068168E-08_JPRB, 0.56414411E-08_JPRB, 0.54635567E-08_JPRB, &
  & 0.52772640E-08_JPRB, 0.50847939E-08_JPRB, 0.48856705E-08_JPRB, 0.46792148E-08_JPRB, 0.44647823E-08_JPRB, 0.42428043E-08_JPRB, &
  & 0.40168628E-08_JPRB, 0.37926964E-08_JPRB, 0.35763184E-08_JPRB, 0.33725789E-08_JPRB, 0.31937257E-08_JPRB, 0.30408429E-08_JPRB, &
  & 0.29141387E-08_JPRB, 0.28089360E-08_JPRB, 0.27261160E-08_JPRB, 0.27179412E-08_JPRB /)

RGHG4(:,18, 3) = (/ &
  & 0.57114873E-08_JPRB, 0.26368459E-08_JPRB, 0.28005713E-08_JPRB, 0.30489997E-08_JPRB, 0.34035323E-08_JPRB, 0.36617163E-08_JPRB, &
  & 0.38647259E-08_JPRB, 0.40419699E-08_JPRB, 0.42085628E-08_JPRB, 0.43672146E-08_JPRB, 0.45160098E-08_JPRB, 0.46516715E-08_JPRB, &
  & 0.47690820E-08_JPRB, 0.48633879E-08_JPRB, 0.49371041E-08_JPRB, 0.49866418E-08_JPRB, 0.50145661E-08_JPRB, 0.50215814E-08_JPRB, &
  & 0.50200830E-08_JPRB, 0.50166564E-08_JPRB, 0.50234088E-08_JPRB, 0.50479554E-08_JPRB, 0.50932969E-08_JPRB, 0.51589257E-08_JPRB, &
  & 0.52379185E-08_JPRB, 0.53292459E-08_JPRB, 0.54261733E-08_JPRB, 0.55027320E-08_JPRB, 0.56133174E-08_JPRB, 0.57193876E-08_JPRB, &
  & 0.58308798E-08_JPRB, 0.59309579E-08_JPRB, 0.60160112E-08_JPRB, 0.60621508E-08_JPRB, 0.60880869E-08_JPRB, 0.60798953E-08_JPRB, &
  & 0.60328262E-08_JPRB, 0.59529719E-08_JPRB, 0.58534777E-08_JPRB, 0.57442464E-08_JPRB, 0.56378000E-08_JPRB, 0.55366969E-08_JPRB, &
  & 0.54403966E-08_JPRB, 0.53464917E-08_JPRB, 0.52511435E-08_JPRB, 0.51483160E-08_JPRB, 0.50345879E-08_JPRB, 0.49106856E-08_JPRB, &
  & 0.47768891E-08_JPRB, 0.46346296E-08_JPRB, 0.44827577E-08_JPRB, 0.43221871E-08_JPRB, 0.41524868E-08_JPRB, 0.39751864E-08_JPRB, &
  & 0.37933541E-08_JPRB, 0.36119863E-08_JPRB, 0.34369638E-08_JPRB, 0.32719008E-08_JPRB, 0.31272027E-08_JPRB, 0.30030187E-08_JPRB, &
  & 0.28995395E-08_JPRB, 0.28121299E-08_JPRB, 0.27352673E-08_JPRB, 0.28983465E-08_JPRB /)

RGHG4(:,19, 3) = (/ &
  & 0.43099426E-08_JPRB, 0.23902187E-08_JPRB, 0.25739377E-08_JPRB, 0.27715856E-08_JPRB, 0.30247798E-08_JPRB, 0.32649732E-08_JPRB, &
  & 0.34335335E-08_JPRB, 0.35654757E-08_JPRB, 0.36802823E-08_JPRB, 0.37823829E-08_JPRB, 0.38729899E-08_JPRB, 0.39541086E-08_JPRB, &
  & 0.40217487E-08_JPRB, 0.40730028E-08_JPRB, 0.41101513E-08_JPRB, 0.41309898E-08_JPRB, 0.41380401E-08_JPRB, 0.41332577E-08_JPRB, &
  & 0.41235753E-08_JPRB, 0.41149995E-08_JPRB, 0.41189505E-08_JPRB, 0.41408121E-08_JPRB, 0.41848840E-08_JPRB, 0.42479651E-08_JPRB, &
  & 0.43259436E-08_JPRB, 0.44129829E-08_JPRB, 0.44814521E-08_JPRB, 0.45797339E-08_JPRB, 0.46606647E-08_JPRB, 0.47483444E-08_JPRB, &
  & 0.48292792E-08_JPRB, 0.49005831E-08_JPRB, 0.49557580E-08_JPRB, 0.49744813E-08_JPRB, 0.49760991E-08_JPRB, 0.49519162E-08_JPRB, &
  & 0.48990141E-08_JPRB, 0.48225242E-08_JPRB, 0.47340869E-08_JPRB, 0.46489634E-08_JPRB, 0.45722892E-08_JPRB, 0.45054316E-08_JPRB, &
  & 0.44485629E-08_JPRB, 0.43996575E-08_JPRB, 0.43537547E-08_JPRB, 0.43040655E-08_JPRB, 0.42470041E-08_JPRB, 0.41799968E-08_JPRB, &
  & 0.41015622E-08_JPRB, 0.40127905E-08_JPRB, 0.39132488E-08_JPRB, 0.38041428E-08_JPRB, 0.36857297E-08_JPRB, 0.35601495E-08_JPRB, &
  & 0.34300323E-08_JPRB, 0.32996117E-08_JPRB, 0.31735234E-08_JPRB, 0.30544343E-08_JPRB, 0.29496747E-08_JPRB, 0.28610458E-08_JPRB, &
  & 0.27883147E-08_JPRB, 0.27263083E-08_JPRB, 0.27180951E-08_JPRB, 0.30186176E-08_JPRB /)

RGHG4(:,20, 3) = (/ &
  & 0.31515521E-08_JPRB, 0.20975750E-08_JPRB, 0.22537034E-08_JPRB, 0.24258495E-08_JPRB, 0.25975009E-08_JPRB, 0.28013849E-08_JPRB, &
  & 0.29538840E-08_JPRB, 0.30511671E-08_JPRB, 0.31196836E-08_JPRB, 0.31719534E-08_JPRB, 0.32105940E-08_JPRB, 0.32410004E-08_JPRB, &
  & 0.32633407E-08_JPRB, 0.32757028E-08_JPRB, 0.32821916E-08_JPRB, 0.32810601E-08_JPRB, 0.32731322E-08_JPRB, 0.32603680E-08_JPRB, &
  & 0.32467833E-08_JPRB, 0.32373018E-08_JPRB, 0.32400593E-08_JPRB, 0.32598739E-08_JPRB, 0.32990917E-08_JPRB, 0.33558882E-08_JPRB, &
  & 0.34259837E-08_JPRB, 0.34918337E-08_JPRB, 0.35712933E-08_JPRB, 0.36321406E-08_JPRB, 0.36851568E-08_JPRB, 0.37290779E-08_JPRB, &
  & 0.37626875E-08_JPRB, 0.37860000E-08_JPRB, 0.37932963E-08_JPRB, 0.37734442E-08_JPRB, 0.37459693E-08_JPRB, 0.37042331E-08_JPRB, &
  & 0.36472187E-08_JPRB, 0.35855716E-08_JPRB, 0.35292012E-08_JPRB, 0.34843570E-08_JPRB, 0.34530914E-08_JPRB, 0.34347813E-08_JPRB, &
  & 0.34274243E-08_JPRB, 0.34283865E-08_JPRB, 0.34328960E-08_JPRB, 0.34348082E-08_JPRB, 0.34284111E-08_JPRB, 0.34110912E-08_JPRB, &
  & 0.33819443E-08_JPRB, 0.33419727E-08_JPRB, 0.32899794E-08_JPRB, 0.32278686E-08_JPRB, 0.31566434E-08_JPRB, 0.30788270E-08_JPRB, &
  & 0.29963818E-08_JPRB, 0.29125051E-08_JPRB, 0.28302096E-08_JPRB, 0.27504385E-08_JPRB, 0.26784721E-08_JPRB, 0.26139177E-08_JPRB, &
  & 0.25556668E-08_JPRB, 0.25208544E-08_JPRB, 0.25983906E-08_JPRB, 0.30469718E-08_JPRB /)

RGHG4(:,21, 3) = (/ &
  & 0.23490345E-08_JPRB, 0.18207893E-08_JPRB, 0.19598296E-08_JPRB, 0.20935049E-08_JPRB, 0.22126057E-08_JPRB, 0.23352864E-08_JPRB, &
  & 0.24809552E-08_JPRB, 0.25576405E-08_JPRB, 0.25965272E-08_JPRB, 0.26137204E-08_JPRB, 0.26159028E-08_JPRB, 0.26100344E-08_JPRB, &
  & 0.26000584E-08_JPRB, 0.25850555E-08_JPRB, 0.25678570E-08_JPRB, 0.25492792E-08_JPRB, 0.25308040E-08_JPRB, 0.25129459E-08_JPRB, &
  & 0.24976767E-08_JPRB, 0.24877509E-08_JPRB, 0.24870650E-08_JPRB, 0.24995928E-08_JPRB, 0.25276761E-08_JPRB, 0.25714733E-08_JPRB, &
  & 0.26223668E-08_JPRB, 0.26838176E-08_JPRB, 0.27378499E-08_JPRB, 0.27757827E-08_JPRB, 0.27993929E-08_JPRB, 0.28082965E-08_JPRB, &
  & 0.27988769E-08_JPRB, 0.27773313E-08_JPRB, 0.27396452E-08_JPRB, 0.26885021E-08_JPRB, 0.26372411E-08_JPRB, 0.25882345E-08_JPRB, &
  & 0.25428213E-08_JPRB, 0.25088709E-08_JPRB, 0.24889004E-08_JPRB, 0.24853923E-08_JPRB, 0.24971187E-08_JPRB, 0.25212203E-08_JPRB, &
  & 0.25545626E-08_JPRB, 0.25936082E-08_JPRB, 0.26335711E-08_JPRB, 0.26698657E-08_JPRB, 0.26986944E-08_JPRB, 0.27177649E-08_JPRB, &
  & 0.27261209E-08_JPRB, 0.27209253E-08_JPRB, 0.27035629E-08_JPRB, 0.26763900E-08_JPRB, 0.26401741E-08_JPRB, 0.25967903E-08_JPRB, &
  & 0.25482119E-08_JPRB, 0.24965334E-08_JPRB, 0.24431164E-08_JPRB, 0.23880811E-08_JPRB, 0.23339690E-08_JPRB, 0.22818705E-08_JPRB, &
  & 0.22246436E-08_JPRB, 0.22398523E-08_JPRB, 0.23698212E-08_JPRB, 0.28884637E-08_JPRB /)

RGHG4(:,22, 3) = (/ &
  & 0.17258756E-08_JPRB, 0.14957221E-08_JPRB, 0.16564913E-08_JPRB, 0.17556724E-08_JPRB, 0.18548991E-08_JPRB, 0.19457687E-08_JPRB, &
  & 0.20428796E-08_JPRB, 0.21066069E-08_JPRB, 0.21305360E-08_JPRB, 0.21291220E-08_JPRB, 0.21109858E-08_JPRB, 0.20836568E-08_JPRB, &
  & 0.20529192E-08_JPRB, 0.20205819E-08_JPRB, 0.19895612E-08_JPRB, 0.19608239E-08_JPRB, 0.19349113E-08_JPRB, 0.19123154E-08_JPRB, &
  & 0.18934685E-08_JPRB, 0.18797692E-08_JPRB, 0.18724489E-08_JPRB, 0.18729809E-08_JPRB, 0.18819499E-08_JPRB, 0.19061150E-08_JPRB, &
  & 0.19434303E-08_JPRB, 0.19837056E-08_JPRB, 0.20185043E-08_JPRB, 0.20424025E-08_JPRB, 0.20499729E-08_JPRB, 0.20379400E-08_JPRB, &
  & 0.20077915E-08_JPRB, 0.19618711E-08_JPRB, 0.19065811E-08_JPRB, 0.18464171E-08_JPRB, 0.17926823E-08_JPRB, 0.17486194E-08_JPRB, &
  & 0.17167959E-08_JPRB, 0.17019294E-08_JPRB, 0.17053200E-08_JPRB, 0.17260526E-08_JPRB, 0.17614947E-08_JPRB, 0.18075710E-08_JPRB, &
  & 0.18606919E-08_JPRB, 0.19171822E-08_JPRB, 0.19732542E-08_JPRB, 0.20255504E-08_JPRB, 0.20712494E-08_JPRB, 0.21074380E-08_JPRB, &
  & 0.21303037E-08_JPRB, 0.21425608E-08_JPRB, 0.21452466E-08_JPRB, 0.21375262E-08_JPRB, 0.21206359E-08_JPRB, 0.20960240E-08_JPRB, &
  & 0.20651409E-08_JPRB, 0.20293351E-08_JPRB, 0.19893773E-08_JPRB, 0.19455408E-08_JPRB, 0.18998692E-08_JPRB, 0.18550979E-08_JPRB, &
  & 0.18270218E-08_JPRB, 0.18553179E-08_JPRB, 0.19759783E-08_JPRB, 0.25095566E-08_JPRB /)

RGHG4(:,23, 3) = (/ &
  & 0.12803542E-08_JPRB, 0.12359629E-08_JPRB, 0.13697119E-08_JPRB, 0.14745657E-08_JPRB, 0.15509901E-08_JPRB, 0.16045621E-08_JPRB, &
  & 0.16538785E-08_JPRB, 0.17031581E-08_JPRB, 0.17190445E-08_JPRB, 0.17109112E-08_JPRB, 0.16853333E-08_JPRB, 0.16484292E-08_JPRB, &
  & 0.16067307E-08_JPRB, 0.15646995E-08_JPRB, 0.15255425E-08_JPRB, 0.14911206E-08_JPRB, 0.14618859E-08_JPRB, 0.14378414E-08_JPRB, &
  & 0.14186659E-08_JPRB, 0.14042079E-08_JPRB, 0.13958844E-08_JPRB, 0.13948959E-08_JPRB, 0.14018486E-08_JPRB, 0.14179632E-08_JPRB, &
  & 0.14409097E-08_JPRB, 0.14661939E-08_JPRB, 0.14883287E-08_JPRB, 0.14992464E-08_JPRB, 0.14949385E-08_JPRB, 0.14746526E-08_JPRB, &
  & 0.14367297E-08_JPRB, 0.13855499E-08_JPRB, 0.13296571E-08_JPRB, 0.12728266E-08_JPRB, 0.12265107E-08_JPRB, 0.11934520E-08_JPRB, &
  & 0.11757593E-08_JPRB, 0.11758943E-08_JPRB, 0.11934015E-08_JPRB, 0.12269132E-08_JPRB, 0.12730171E-08_JPRB, 0.13281021E-08_JPRB, &
  & 0.13882815E-08_JPRB, 0.14507082E-08_JPRB, 0.15125786E-08_JPRB, 0.15713583E-08_JPRB, 0.16232304E-08_JPRB, 0.16641160E-08_JPRB, &
  & 0.16958617E-08_JPRB, 0.17183699E-08_JPRB, 0.17288028E-08_JPRB, 0.17305586E-08_JPRB, 0.17251478E-08_JPRB, 0.17136551E-08_JPRB, &
  & 0.16967584E-08_JPRB, 0.16750077E-08_JPRB, 0.16482368E-08_JPRB, 0.16155899E-08_JPRB, 0.15800977E-08_JPRB, 0.15435210E-08_JPRB, &
  & 0.15385009E-08_JPRB, 0.15792095E-08_JPRB, 0.17009985E-08_JPRB, 0.21751263E-08_JPRB /)

RGHG4(:,24, 3) = (/ &
  & 0.97556452E-09_JPRB, 0.10356771E-08_JPRB, 0.11606769E-08_JPRB, 0.12492721E-08_JPRB, 0.13078294E-08_JPRB, 0.13413646E-08_JPRB, &
  & 0.13650304E-08_JPRB, 0.13790389E-08_JPRB, 0.13927463E-08_JPRB, 0.13834723E-08_JPRB, 0.13583261E-08_JPRB, 0.13228759E-08_JPRB, &
  & 0.12825357E-08_JPRB, 0.12420871E-08_JPRB, 0.12044030E-08_JPRB, 0.11706602E-08_JPRB, 0.11407377E-08_JPRB, 0.11148581E-08_JPRB, &
  & 0.10931459E-08_JPRB, 0.10754457E-08_JPRB, 0.10626793E-08_JPRB, 0.10551976E-08_JPRB, 0.10539519E-08_JPRB, 0.10594882E-08_JPRB, &
  & 0.10696127E-08_JPRB, 0.10829535E-08_JPRB, 0.10941887E-08_JPRB, 0.10975472E-08_JPRB, 0.10893771E-08_JPRB, 0.10662796E-08_JPRB, &
  & 0.10292360E-08_JPRB, 0.98334363E-09_JPRB, 0.93504426E-09_JPRB, 0.88897778E-09_JPRB, 0.85434587E-09_JPRB, 0.83358431E-09_JPRB, &
  & 0.82769624E-09_JPRB, 0.83802992E-09_JPRB, 0.86289459E-09_JPRB, 0.90121366E-09_JPRB, 0.94887664E-09_JPRB, 0.10037672E-08_JPRB, &
  & 0.10623290E-08_JPRB, 0.11226189E-08_JPRB, 0.11825412E-08_JPRB, 0.12387823E-08_JPRB, 0.12878395E-08_JPRB, 0.13300232E-08_JPRB, &
  & 0.13639218E-08_JPRB, 0.13874594E-08_JPRB, 0.14038151E-08_JPRB, 0.14122563E-08_JPRB, 0.14130114E-08_JPRB, 0.14074374E-08_JPRB, &
  & 0.13963347E-08_JPRB, 0.13801719E-08_JPRB, 0.13586152E-08_JPRB, 0.13318925E-08_JPRB, 0.13008037E-08_JPRB, 0.12875647E-08_JPRB, &
  & 0.12938669E-08_JPRB, 0.13323967E-08_JPRB, 0.14483452E-08_JPRB, 0.19172905E-08_JPRB /)

RGHG4(:,25, 3) = (/ &
  & 0.75579976E-09_JPRB, 0.87026181E-09_JPRB, 0.98291508E-09_JPRB, 0.10632640E-08_JPRB, 0.11098670E-08_JPRB, 0.11362316E-08_JPRB, &
  & 0.11476259E-08_JPRB, 0.11542225E-08_JPRB, 0.11561876E-08_JPRB, 0.11449478E-08_JPRB, 0.11214050E-08_JPRB, 0.10898081E-08_JPRB, &
  & 0.10542349E-08_JPRB, 0.10176782E-08_JPRB, 0.98193298E-09_JPRB, 0.94837316E-09_JPRB, 0.91765567E-09_JPRB, 0.89000379E-09_JPRB, &
  & 0.86565854E-09_JPRB, 0.84452845E-09_JPRB, 0.82705431E-09_JPRB, 0.81374757E-09_JPRB, 0.80535006E-09_JPRB, 0.80221807E-09_JPRB, &
  & 0.80280332E-09_JPRB, 0.80671259E-09_JPRB, 0.80953816E-09_JPRB, 0.80723994E-09_JPRB, 0.79680401E-09_JPRB, 0.77505541E-09_JPRB, &
  & 0.74397294E-09_JPRB, 0.70661960E-09_JPRB, 0.66894790E-09_JPRB, 0.63524486E-09_JPRB, 0.61231670E-09_JPRB, 0.60227695E-09_JPRB, &
  & 0.60555350E-09_JPRB, 0.62242561E-09_JPRB, 0.65055994E-09_JPRB, 0.68890038E-09_JPRB, 0.73442469E-09_JPRB, 0.78521900E-09_JPRB, &
  & 0.83853408E-09_JPRB, 0.89330193E-09_JPRB, 0.94752695E-09_JPRB, 0.99851749E-09_JPRB, 0.10448978E-08_JPRB, 0.10851557E-08_JPRB, &
  & 0.11171204E-08_JPRB, 0.11418168E-08_JPRB, 0.11578286E-08_JPRB, 0.11666721E-08_JPRB, 0.11699016E-08_JPRB, 0.11684139E-08_JPRB, &
  & 0.11623628E-08_JPRB, 0.11518263E-08_JPRB, 0.11371852E-08_JPRB, 0.11181568E-08_JPRB, 0.10984597E-08_JPRB, 0.10906529E-08_JPRB, &
  & 0.10999557E-08_JPRB, 0.11329422E-08_JPRB, 0.12386180E-08_JPRB, 0.16492644E-08_JPRB /)

RGHG4(:,26, 3) = (/ &
  & 0.58574340E-09_JPRB, 0.73801859E-09_JPRB, 0.83975438E-09_JPRB, 0.90481650E-09_JPRB, 0.94955321E-09_JPRB, 0.97578512E-09_JPRB, &
  & 0.98225250E-09_JPRB, 0.98154262E-09_JPRB, 0.97717368E-09_JPRB, 0.96903607E-09_JPRB, 0.95020636E-09_JPRB, 0.92344876E-09_JPRB, &
  & 0.89118113E-09_JPRB, 0.85642921E-09_JPRB, 0.82165597E-09_JPRB, 0.78817397E-09_JPRB, 0.75683093E-09_JPRB, 0.72781803E-09_JPRB, &
  & 0.70143147E-09_JPRB, 0.67760941E-09_JPRB, 0.65682532E-09_JPRB, 0.63928368E-09_JPRB, 0.62575989E-09_JPRB, 0.61597649E-09_JPRB, &
  & 0.60963090E-09_JPRB, 0.60583261E-09_JPRB, 0.60232030E-09_JPRB, 0.59636662E-09_JPRB, 0.58422139E-09_JPRB, 0.56595179E-09_JPRB, &
  & 0.54104571E-09_JPRB, 0.51317173E-09_JPRB, 0.48613896E-09_JPRB, 0.46367737E-09_JPRB, 0.45068668E-09_JPRB, 0.44887338E-09_JPRB, &
  & 0.45831178E-09_JPRB, 0.47843829E-09_JPRB, 0.50761084E-09_JPRB, 0.54404625E-09_JPRB, 0.58524147E-09_JPRB, 0.63021444E-09_JPRB, &
  & 0.67715789E-09_JPRB, 0.72533213E-09_JPRB, 0.77303725E-09_JPRB, 0.81830642E-09_JPRB, 0.85964297E-09_JPRB, 0.89493163E-09_JPRB, &
  & 0.92337005E-09_JPRB, 0.94470431E-09_JPRB, 0.95993602E-09_JPRB, 0.96949504E-09_JPRB, 0.97365771E-09_JPRB, 0.97359920E-09_JPRB, &
  & 0.96980057E-09_JPRB, 0.96237751E-09_JPRB, 0.95157904E-09_JPRB, 0.93611019E-09_JPRB, 0.92554064E-09_JPRB, 0.92269903E-09_JPRB, &
  & 0.92790764E-09_JPRB, 0.95954944E-09_JPRB, 0.10408758E-08_JPRB, 0.14108070E-08_JPRB /)

RGHG4(:,27, 3) = (/ &
  & 0.46615728E-09_JPRB, 0.61962779E-09_JPRB, 0.72387973E-09_JPRB, 0.77827300E-09_JPRB, 0.82386847E-09_JPRB, 0.84747787E-09_JPRB, &
  & 0.85994178E-09_JPRB, 0.85888346E-09_JPRB, 0.85296359E-09_JPRB, 0.84223134E-09_JPRB, 0.82340185E-09_JPRB, 0.79869283E-09_JPRB, &
  & 0.76880363E-09_JPRB, 0.73604611E-09_JPRB, 0.70240469E-09_JPRB, 0.66903677E-09_JPRB, 0.63689382E-09_JPRB, 0.60649258E-09_JPRB, &
  & 0.57843069E-09_JPRB, 0.55279703E-09_JPRB, 0.52980409E-09_JPRB, 0.50954596E-09_JPRB, 0.49242804E-09_JPRB, 0.47816945E-09_JPRB, &
  & 0.46672899E-09_JPRB, 0.45730950E-09_JPRB, 0.44903728E-09_JPRB, 0.43967538E-09_JPRB, 0.42772494E-09_JPRB, 0.41225540E-09_JPRB, &
  & 0.39361348E-09_JPRB, 0.37393991E-09_JPRB, 0.35597250E-09_JPRB, 0.34254052E-09_JPRB, 0.33715200E-09_JPRB, 0.34116229E-09_JPRB, &
  & 0.35444858E-09_JPRB, 0.37622055E-09_JPRB, 0.40405052E-09_JPRB, 0.43664539E-09_JPRB, 0.47321325E-09_JPRB, 0.51237309E-09_JPRB, &
  & 0.55318400E-09_JPRB, 0.59506705E-09_JPRB, 0.63666861E-09_JPRB, 0.67648992E-09_JPRB, 0.71279743E-09_JPRB, 0.74417600E-09_JPRB, &
  & 0.77020051E-09_JPRB, 0.79009177E-09_JPRB, 0.80383644E-09_JPRB, 0.81251628E-09_JPRB, 0.81699764E-09_JPRB, 0.81797763E-09_JPRB, &
  & 0.81570750E-09_JPRB, 0.81031287E-09_JPRB, 0.80285351E-09_JPRB, 0.79325513E-09_JPRB, 0.78672596E-09_JPRB, 0.78410101E-09_JPRB, &
  & 0.78878504E-09_JPRB, 0.81315310E-09_JPRB, 0.88066537E-09_JPRB, 0.11901797E-08_JPRB /)

RGHG4(:,28, 3) = (/ &
  & 0.38443296E-09_JPRB, 0.52723959E-09_JPRB, 0.61411115E-09_JPRB, 0.68261991E-09_JPRB, 0.72853945E-09_JPRB, 0.74767686E-09_JPRB, &
  & 0.75900519E-09_JPRB, 0.75876722E-09_JPRB, 0.75117895E-09_JPRB, 0.73969064E-09_JPRB, 0.72342149E-09_JPRB, 0.70029599E-09_JPRB, &
  & 0.67214501E-09_JPRB, 0.64064315E-09_JPRB, 0.60791699E-09_JPRB, 0.57520316E-09_JPRB, 0.54343863E-09_JPRB, 0.51297094E-09_JPRB, &
  & 0.48427290E-09_JPRB, 0.45768828E-09_JPRB, 0.43337423E-09_JPRB, 0.41135570E-09_JPRB, 0.39186512E-09_JPRB, 0.37467263E-09_JPRB, &
  & 0.35980746E-09_JPRB, 0.34676501E-09_JPRB, 0.33512751E-09_JPRB, 0.32369890E-09_JPRB, 0.31193298E-09_JPRB, 0.29914554E-09_JPRB, &
  & 0.28555680E-09_JPRB, 0.27242528E-09_JPRB, 0.26160654E-09_JPRB, 0.25501931E-09_JPRB, 0.25502467E-09_JPRB, 0.26255270E-09_JPRB, &
  & 0.27740968E-09_JPRB, 0.29830713E-09_JPRB, 0.32415140E-09_JPRB, 0.35345160E-09_JPRB, 0.38536721E-09_JPRB, 0.41924311E-09_JPRB, &
  & 0.45461496E-09_JPRB, 0.49095716E-09_JPRB, 0.52745369E-09_JPRB, 0.56240806E-09_JPRB, 0.59433325E-09_JPRB, 0.62206751E-09_JPRB, &
  & 0.64460631E-09_JPRB, 0.66179368E-09_JPRB, 0.67450667E-09_JPRB, 0.68294148E-09_JPRB, 0.68761774E-09_JPRB, 0.68951472E-09_JPRB, &
  & 0.68857631E-09_JPRB, 0.68514661E-09_JPRB, 0.67930161E-09_JPRB, 0.67339750E-09_JPRB, 0.66807249E-09_JPRB, 0.66363487E-09_JPRB, &
  & 0.66714806E-09_JPRB, 0.68576927E-09_JPRB, 0.73815998E-09_JPRB, 0.99510211E-09_JPRB /)

RGHG4(:,29, 3) = (/ &
  & 0.32849609E-09_JPRB, 0.46074874E-09_JPRB, 0.54285404E-09_JPRB, 0.60266026E-09_JPRB, 0.64573319E-09_JPRB, 0.66503075E-09_JPRB, &
  & 0.67335992E-09_JPRB, 0.67542960E-09_JPRB, 0.66862244E-09_JPRB, 0.65697581E-09_JPRB, 0.64143874E-09_JPRB, 0.62016425E-09_JPRB, &
  & 0.59421545E-09_JPRB, 0.56408084E-09_JPRB, 0.53196941E-09_JPRB, 0.49937032E-09_JPRB, 0.46732268E-09_JPRB, 0.43652509E-09_JPRB, &
  & 0.40736289E-09_JPRB, 0.38021095E-09_JPRB, 0.35521727E-09_JPRB, 0.33235817E-09_JPRB, 0.31154235E-09_JPRB, 0.29274796E-09_JPRB, &
  & 0.27575897E-09_JPRB, 0.26070787E-09_JPRB, 0.24718483E-09_JPRB, 0.23495764E-09_JPRB, 0.22381408E-09_JPRB, 0.21341133E-09_JPRB, &
  & 0.20379534E-09_JPRB, 0.19563476E-09_JPRB, 0.18997155E-09_JPRB, 0.18810731E-09_JPRB, 0.19145965E-09_JPRB, 0.20078059E-09_JPRB, &
  & 0.21568985E-09_JPRB, 0.23558847E-09_JPRB, 0.25856434E-09_JPRB, 0.28337263E-09_JPRB, 0.31074548E-09_JPRB, 0.33985792E-09_JPRB, &
  & 0.37051490E-09_JPRB, 0.40231082E-09_JPRB, 0.43439891E-09_JPRB, 0.46539519E-09_JPRB, 0.49377041E-09_JPRB, 0.51860627E-09_JPRB, &
  & 0.53916149E-09_JPRB, 0.55524157E-09_JPRB, 0.56696614E-09_JPRB, 0.57495109E-09_JPRB, 0.58005967E-09_JPRB, 0.58268723E-09_JPRB, &
  & 0.58295002E-09_JPRB, 0.58124178E-09_JPRB, 0.57746685E-09_JPRB, 0.57334659E-09_JPRB, 0.56854160E-09_JPRB, 0.56364918E-09_JPRB, &
  & 0.56381005E-09_JPRB, 0.57255650E-09_JPRB, 0.61712535E-09_JPRB, 0.81881146E-09_JPRB /)

RGHG4(:,30, 3) = (/ &
  & 0.28875502E-09_JPRB, 0.41245093E-09_JPRB, 0.48473303E-09_JPRB, 0.53901544E-09_JPRB, 0.57297139E-09_JPRB, 0.59496469E-09_JPRB, &
  & 0.60397271E-09_JPRB, 0.60559457E-09_JPRB, 0.60005706E-09_JPRB, 0.58882416E-09_JPRB, 0.57325883E-09_JPRB, 0.55333671E-09_JPRB, &
  & 0.52914534E-09_JPRB, 0.50095506E-09_JPRB, 0.46984427E-09_JPRB, 0.43738932E-09_JPRB, 0.40531367E-09_JPRB, 0.37426109E-09_JPRB, &
  & 0.34479078E-09_JPRB, 0.31728117E-09_JPRB, 0.29186281E-09_JPRB, 0.26851366E-09_JPRB, 0.24701022E-09_JPRB, 0.22765272E-09_JPRB, &
  & 0.20968746E-09_JPRB, 0.19411825E-09_JPRB, 0.17992247E-09_JPRB, 0.16801668E-09_JPRB, 0.15788520E-09_JPRB, 0.14949773E-09_JPRB, &
  & 0.14285620E-09_JPRB, 0.13822282E-09_JPRB, 0.13598032E-09_JPRB, 0.13715008E-09_JPRB, 0.14229309E-09_JPRB, 0.15210852E-09_JPRB, &
  & 0.16608044E-09_JPRB, 0.18309612E-09_JPRB, 0.20273035E-09_JPRB, 0.22429943E-09_JPRB, 0.24810395E-09_JPRB, 0.27345712E-09_JPRB, &
  & 0.30032696E-09_JPRB, 0.32824785E-09_JPRB, 0.35675865E-09_JPRB, 0.38447720E-09_JPRB, 0.41008225E-09_JPRB, 0.43263554E-09_JPRB, &
  & 0.45140314E-09_JPRB, 0.46625059E-09_JPRB, 0.47751247E-09_JPRB, 0.48559368E-09_JPRB, 0.49106780E-09_JPRB, 0.49435339E-09_JPRB, &
  & 0.49558752E-09_JPRB, 0.49490040E-09_JPRB, 0.49308918E-09_JPRB, 0.48995380E-09_JPRB, 0.48528587E-09_JPRB, 0.47951454E-09_JPRB, &
  & 0.47674226E-09_JPRB, 0.48186033E-09_JPRB, 0.51499854E-09_JPRB, 0.67174211E-09_JPRB /)

RGHG4(:,31, 3) = (/ &
  & 0.25467603E-09_JPRB, 0.36845693E-09_JPRB, 0.43570389E-09_JPRB, 0.48370952E-09_JPRB, 0.51397608E-09_JPRB, 0.53465243E-09_JPRB, &
  & 0.54371596E-09_JPRB, 0.54556337E-09_JPRB, 0.54030103E-09_JPRB, 0.52984733E-09_JPRB, 0.51514487E-09_JPRB, 0.49583659E-09_JPRB, &
  & 0.47161985E-09_JPRB, 0.44431034E-09_JPRB, 0.41473300E-09_JPRB, 0.38305048E-09_JPRB, 0.35102174E-09_JPRB, 0.31984618E-09_JPRB, &
  & 0.29020086E-09_JPRB, 0.26249669E-09_JPRB, 0.23697358E-09_JPRB, 0.21362287E-09_JPRB, 0.19216710E-09_JPRB, 0.17292009E-09_JPRB, &
  & 0.15540094E-09_JPRB, 0.14021155E-09_JPRB, 0.12673888E-09_JPRB, 0.11593308E-09_JPRB, 0.10721215E-09_JPRB, 0.10074624E-09_JPRB, &
  & 0.96395149E-10_JPRB, 0.94068968E-10_JPRB, 0.94037847E-10_JPRB, 0.96631661E-10_JPRB, 0.10228542E-09_JPRB, 0.11131488E-09_JPRB, &
  & 0.12309173E-09_JPRB, 0.13754041E-09_JPRB, 0.15419017E-09_JPRB, 0.17237042E-09_JPRB, 0.19275792E-09_JPRB, 0.21491506E-09_JPRB, &
  & 0.23870983E-09_JPRB, 0.26377406E-09_JPRB, 0.28952488E-09_JPRB, 0.31483258E-09_JPRB, 0.33837833E-09_JPRB, 0.35924025E-09_JPRB, &
  & 0.37682574E-09_JPRB, 0.39100367E-09_JPRB, 0.40193870E-09_JPRB, 0.41007367E-09_JPRB, 0.41603351E-09_JPRB, 0.42005441E-09_JPRB, &
  & 0.42240222E-09_JPRB, 0.42297554E-09_JPRB, 0.42197926E-09_JPRB, 0.41879000E-09_JPRB, 0.41351039E-09_JPRB, 0.40768011E-09_JPRB, &
  & 0.40354736E-09_JPRB, 0.40437761E-09_JPRB, 0.42578310E-09_JPRB, 0.54952093E-09_JPRB /)

RGHG4(:,32, 3) = (/ &
  & 0.23030808E-09_JPRB, 0.33502376E-09_JPRB, 0.39530673E-09_JPRB, 0.43902287E-09_JPRB, 0.46617327E-09_JPRB, 0.48437532E-09_JPRB, &
  & 0.49199822E-09_JPRB, 0.49250665E-09_JPRB, 0.48805732E-09_JPRB, 0.47831522E-09_JPRB, 0.46416437E-09_JPRB, 0.44629905E-09_JPRB, &
  & 0.42373113E-09_JPRB, 0.39651571E-09_JPRB, 0.36704051E-09_JPRB, 0.33601730E-09_JPRB, 0.30439531E-09_JPRB, 0.27330890E-09_JPRB, &
  & 0.24374058E-09_JPRB, 0.21624248E-09_JPRB, 0.19107473E-09_JPRB, 0.16803287E-09_JPRB, 0.14757023E-09_JPRB, 0.12881020E-09_JPRB, &
  & 0.11280438E-09_JPRB, 0.98787450E-10_JPRB, 0.86845024E-10_JPRB, 0.77722544E-10_JPRB, 0.70612280E-10_JPRB, 0.65753201E-10_JPRB, &
  & 0.62996164E-10_JPRB, 0.62101706E-10_JPRB, 0.63189246E-10_JPRB, 0.66249138E-10_JPRB, 0.71676595E-10_JPRB, 0.79506707E-10_JPRB, &
  & 0.89589100E-10_JPRB, 0.10158864E-09_JPRB, 0.11515698E-09_JPRB, 0.13042897E-09_JPRB, 0.14767607E-09_JPRB, 0.16698198E-09_JPRB, &
  & 0.18822721E-09_JPRB, 0.21085959E-09_JPRB, 0.23418703E-09_JPRB, 0.25725247E-09_JPRB, 0.27888925E-09_JPRB, 0.29832650E-09_JPRB, &
  & 0.31483943E-09_JPRB, 0.32842887E-09_JPRB, 0.33914652E-09_JPRB, 0.34744721E-09_JPRB, 0.35372208E-09_JPRB, 0.35820405E-09_JPRB, &
  & 0.36090964E-09_JPRB, 0.36224376E-09_JPRB, 0.36193537E-09_JPRB, 0.35957501E-09_JPRB, 0.35459596E-09_JPRB, 0.34826014E-09_JPRB, &
  & 0.34109832E-09_JPRB, 0.34078093E-09_JPRB, 0.35530751E-09_JPRB, 0.45140461E-09_JPRB /)

RGHG4(:,33, 3) = (/ &
  & 0.20855406E-09_JPRB, 0.30166994E-09_JPRB, 0.35913511E-09_JPRB, 0.39757403E-09_JPRB, 0.42211612E-09_JPRB, 0.43848325E-09_JPRB, &
  & 0.44490603E-09_JPRB, 0.44503579E-09_JPRB, 0.44068543E-09_JPRB, 0.43147999E-09_JPRB, 0.41802325E-09_JPRB, 0.40016429E-09_JPRB, &
  & 0.37886516E-09_JPRB, 0.35348530E-09_JPRB, 0.32471559E-09_JPRB, 0.29398078E-09_JPRB, 0.26260391E-09_JPRB, 0.23172503E-09_JPRB, &
  & 0.20242615E-09_JPRB, 0.17520919E-09_JPRB, 0.15087542E-09_JPRB, 0.12851976E-09_JPRB, 0.10952810E-09_JPRB, 0.92235102E-10_JPRB, &
  & 0.78165141E-10_JPRB, 0.66159619E-10_JPRB, 0.56371446E-10_JPRB, 0.49124628E-10_JPRB, 0.43761005E-10_JPRB, 0.40335603E-10_JPRB, &
  & 0.38676354E-10_JPRB, 0.38609550E-10_JPRB, 0.40044065E-10_JPRB, 0.43021232E-10_JPRB, 0.47675044E-10_JPRB, 0.54087956E-10_JPRB, &
  & 0.62000183E-10_JPRB, 0.71200719E-10_JPRB, 0.81880634E-10_JPRB, 0.94428416E-10_JPRB, 0.10913558E-09_JPRB, 0.12594843E-09_JPRB, &
  & 0.14488222E-09_JPRB, 0.16555927E-09_JPRB, 0.18715880E-09_JPRB, 0.20865464E-09_JPRB, 0.22893000E-09_JPRB, 0.24711269E-09_JPRB, &
  & 0.26278740E-09_JPRB, 0.27580843E-09_JPRB, 0.28624569E-09_JPRB, 0.29455074E-09_JPRB, 0.30097161E-09_JPRB, 0.30573691E-09_JPRB, &
  & 0.30904626E-09_JPRB, 0.31105940E-09_JPRB, 0.31121064E-09_JPRB, 0.30882702E-09_JPRB, 0.30438865E-09_JPRB, 0.29796707E-09_JPRB, &
  & 0.29048763E-09_JPRB, 0.28887559E-09_JPRB, 0.29920294E-09_JPRB, 0.37582060E-09_JPRB /)

RGHG4(:,34, 3) = (/ &
  & 0.19259587E-09_JPRB, 0.27757624E-09_JPRB, 0.32651895E-09_JPRB, 0.36121728E-09_JPRB, 0.38293219E-09_JPRB, 0.39712755E-09_JPRB, &
  & 0.40281992E-09_JPRB, 0.40262185E-09_JPRB, 0.39829473E-09_JPRB, 0.38943471E-09_JPRB, 0.37692729E-09_JPRB, 0.36055134E-09_JPRB, &
  & 0.33966796E-09_JPRB, 0.31488456E-09_JPRB, 0.28712058E-09_JPRB, 0.25717370E-09_JPRB, 0.22625740E-09_JPRB, 0.19586203E-09_JPRB, &
  & 0.16721648E-09_JPRB, 0.14073129E-09_JPRB, 0.11749257E-09_JPRB, 0.96631231E-10_JPRB, 0.79320231E-10_JPRB, 0.64190382E-10_JPRB, &
  & 0.52315402E-10_JPRB, 0.42668275E-10_JPRB, 0.35087259E-10_JPRB, 0.29748367E-10_JPRB, 0.25936735E-10_JPRB, 0.23645072E-10_JPRB, &
  & 0.22683907E-10_JPRB, 0.22913631E-10_JPRB, 0.24248431E-10_JPRB, 0.26685947E-10_JPRB, 0.30332785E-10_JPRB, 0.35172271E-10_JPRB, &
  & 0.41093004E-10_JPRB, 0.48082909E-10_JPRB, 0.56405658E-10_JPRB, 0.66519214E-10_JPRB, 0.78848060E-10_JPRB, 0.93573711E-10_JPRB, &
  & 0.11065188E-09_JPRB, 0.12956998E-09_JPRB, 0.14954983E-09_JPRB, 0.16948742E-09_JPRB, 0.18830473E-09_JPRB, 0.20530301E-09_JPRB, &
  & 0.22005342E-09_JPRB, 0.23244488E-09_JPRB, 0.24257799E-09_JPRB, 0.25078534E-09_JPRB, 0.25726968E-09_JPRB, 0.26231303E-09_JPRB, &
  & 0.26593033E-09_JPRB, 0.26807470E-09_JPRB, 0.26843336E-09_JPRB, 0.26656011E-09_JPRB, 0.26257693E-09_JPRB, 0.25635688E-09_JPRB, &
  & 0.24917587E-09_JPRB, 0.24654565E-09_JPRB, 0.25365848E-09_JPRB, 0.31584380E-09_JPRB /)

RGHG4(:,35, 3) = (/ &
  & 0.17743984E-09_JPRB, 0.24918495E-09_JPRB, 0.29513961E-09_JPRB, 0.32579220E-09_JPRB, 0.34551753E-09_JPRB, 0.35830036E-09_JPRB, &
  & 0.36331468E-09_JPRB, 0.36278361E-09_JPRB, 0.35853348E-09_JPRB, 0.35034381E-09_JPRB, 0.33838038E-09_JPRB, 0.32289615E-09_JPRB, &
  & 0.30358857E-09_JPRB, 0.28011896E-09_JPRB, 0.25319305E-09_JPRB, 0.22384714E-09_JPRB, 0.19357824E-09_JPRB, 0.16372918E-09_JPRB, &
  & 0.13592141E-09_JPRB, 0.11061484E-09_JPRB, 0.88787547E-10_JPRB, 0.69866619E-10_JPRB, 0.54705320E-10_JPRB, 0.42190161E-10_JPRB, &
  & 0.32865426E-10_JPRB, 0.25703672E-10_JPRB, 0.20435102E-10_JPRB, 0.16870743E-10_JPRB, 0.14428705E-10_JPRB, 0.13021985E-10_JPRB, &
  & 0.12501379E-10_JPRB, 0.12763015E-10_JPRB, 0.13739601E-10_JPRB, 0.15470692E-10_JPRB, 0.17973968E-10_JPRB, 0.21293448E-10_JPRB, &
  & 0.25402283E-10_JPRB, 0.30405400E-10_JPRB, 0.36600369E-10_JPRB, 0.44461206E-10_JPRB, 0.54521176E-10_JPRB, 0.67141785E-10_JPRB, &
  & 0.82334840E-10_JPRB, 0.99796817E-10_JPRB, 0.11837953E-09_JPRB, 0.13705033E-09_JPRB, 0.15470092E-09_JPRB, 0.17066572E-09_JPRB, &
  & 0.18462121E-09_JPRB, 0.19638392E-09_JPRB, 0.20613027E-09_JPRB, 0.21408247E-09_JPRB, 0.22040209E-09_JPRB, 0.22533769E-09_JPRB, &
  & 0.22890588E-09_JPRB, 0.23123818E-09_JPRB, 0.23195360E-09_JPRB, 0.23044712E-09_JPRB, 0.22687474E-09_JPRB, 0.22134751E-09_JPRB, &
  & 0.21498138E-09_JPRB, 0.21207447E-09_JPRB, 0.21712480E-09_JPRB, 0.26693525E-09_JPRB /)

RGHG4(:,36, 3) = (/ &
  & 0.16424616E-09_JPRB, 0.22799511E-09_JPRB, 0.26632740E-09_JPRB, 0.29116856E-09_JPRB, 0.31057204E-09_JPRB, 0.32087213E-09_JPRB, &
  & 0.32660982E-09_JPRB, 0.32620123E-09_JPRB, 0.32208664E-09_JPRB, 0.31452738E-09_JPRB, 0.30385425E-09_JPRB, 0.28958036E-09_JPRB, &
  & 0.27125618E-09_JPRB, 0.24903699E-09_JPRB, 0.22335420E-09_JPRB, 0.19500092E-09_JPRB, 0.16557497E-09_JPRB, 0.13664926E-09_JPRB, &
  & 0.11001214E-09_JPRB, 0.86103277E-10_JPRB, 0.66040617E-10_JPRB, 0.49392157E-10_JPRB, 0.36682834E-10_JPRB, 0.26909315E-10_JPRB, &
  & 0.20106484E-10_JPRB, 0.15239688E-10_JPRB, 0.11859187E-10_JPRB, 0.96661255E-11_JPRB, 0.82028212E-11_JPRB, 0.73859200E-11_JPRB, &
  & 0.71083469E-11_JPRB, 0.73085956E-11_JPRB, 0.79548937E-11_JPRB, 0.90858926E-11_JPRB, 0.10715341E-10_JPRB, 0.12902178E-10_JPRB, &
  & 0.15674489E-10_JPRB, 0.19183512E-10_JPRB, 0.23695693E-10_JPRB, 0.29683214E-10_JPRB, 0.37716531E-10_JPRB, 0.48228199E-10_JPRB, &
  & 0.61561554E-10_JPRB, 0.77197429E-10_JPRB, 0.94296980E-10_JPRB, 0.11155790E-09_JPRB, 0.12795513E-09_JPRB, 0.14287826E-09_JPRB, &
  & 0.15593669E-09_JPRB, 0.16705959E-09_JPRB, 0.17633445E-09_JPRB, 0.18389816E-09_JPRB, 0.18997921E-09_JPRB, 0.19478681E-09_JPRB, &
  & 0.19834134E-09_JPRB, 0.20063678E-09_JPRB, 0.20133752E-09_JPRB, 0.20016683E-09_JPRB, 0.19715228E-09_JPRB, 0.19171012E-09_JPRB, &
  & 0.18650979E-09_JPRB, 0.18368700E-09_JPRB, 0.18692142E-09_JPRB, 0.22562346E-09_JPRB /)

RGHG4(:,37, 3) = (/ &
  & 0.15102525E-09_JPRB, 0.20459243E-09_JPRB, 0.23977340E-09_JPRB, 0.26119459E-09_JPRB, 0.27849176E-09_JPRB, 0.28748368E-09_JPRB, &
  & 0.29226116E-09_JPRB, 0.29149877E-09_JPRB, 0.28743971E-09_JPRB, 0.28070465E-09_JPRB, 0.27092636E-09_JPRB, 0.25796573E-09_JPRB, &
  & 0.24130109E-09_JPRB, 0.22055903E-09_JPRB, 0.19602725E-09_JPRB, 0.16879753E-09_JPRB, 0.14059290E-09_JPRB, 0.11278852E-09_JPRB, &
  & 0.87411349E-10_JPRB, 0.65297857E-10_JPRB, 0.47394703E-10_JPRB, 0.33482671E-10_JPRB, 0.23627376E-10_JPRB, 0.16664746E-10_JPRB, &
  & 0.12210108E-10_JPRB, 0.91798262E-11_JPRB, 0.71978474E-11_JPRB, 0.59128557E-11_JPRB, 0.50628499E-11_JPRB, 0.45876389E-11_JPRB, &
  & 0.44303628E-11_JPRB, 0.45666960E-11_JPRB, 0.49826796E-11_JPRB, 0.57186465E-11_JPRB, 0.67766760E-11_JPRB, 0.82298803E-11_JPRB, &
  & 0.10107006E-10_JPRB, 0.12565401E-10_JPRB, 0.15816693E-10_JPRB, 0.20299484E-10_JPRB, 0.26520740E-10_JPRB, 0.35085070E-10_JPRB, &
  & 0.46279480E-10_JPRB, 0.60040833E-10_JPRB, 0.75321999E-10_JPRB, 0.91076029E-10_JPRB, 0.10618999E-09_JPRB, 0.12006217E-09_JPRB, &
  & 0.13231732E-09_JPRB, 0.14279752E-09_JPRB, 0.15151909E-09_JPRB, 0.15861780E-09_JPRB, 0.16431151E-09_JPRB, 0.16875817E-09_JPRB, &
  & 0.17199955E-09_JPRB, 0.17410230E-09_JPRB, 0.17476716E-09_JPRB, 0.17398447E-09_JPRB, 0.17129310E-09_JPRB, 0.16642014E-09_JPRB, &
  & 0.16174674E-09_JPRB, 0.15823685E-09_JPRB, 0.16146237E-09_JPRB, 0.19304416E-09_JPRB /)

RGHG4(:,38, 3) = (/ &
  & 0.13980789E-09_JPRB, 0.18487002E-09_JPRB, 0.21502942E-09_JPRB, 0.23429680E-09_JPRB, 0.24935418E-09_JPRB, 0.25692740E-09_JPRB, &
  & 0.26066505E-09_JPRB, 0.25963490E-09_JPRB, 0.25572289E-09_JPRB, 0.24973301E-09_JPRB, 0.24114047E-09_JPRB, 0.22950339E-09_JPRB, &
  & 0.21430087E-09_JPRB, 0.19510980E-09_JPRB, 0.17209995E-09_JPRB, 0.14605840E-09_JPRB, 0.11914887E-09_JPRB, 0.92924612E-10_JPRB, &
  & 0.69236339E-10_JPRB, 0.49220177E-10_JPRB, 0.33871229E-10_JPRB, 0.22801731E-10_JPRB, 0.15622739E-10_JPRB, 0.10908213E-10_JPRB, &
  & 0.80702476E-11_JPRB, 0.61851579E-11_JPRB, 0.49655414E-11_JPRB, 0.41641825E-11_JPRB, 0.36174848E-11_JPRB, 0.33056054E-11_JPRB, &
  & 0.31978879E-11_JPRB, 0.32913386E-11_JPRB, 0.35826381E-11_JPRB, 0.41042373E-11_JPRB, 0.48584426E-11_JPRB, 0.59060300E-11_JPRB, &
  & 0.72686627E-11_JPRB, 0.90941117E-11_JPRB, 0.11542557E-10_JPRB, 0.14988420E-10_JPRB, 0.19878873E-10_JPRB, 0.26761477E-10_JPRB, &
  & 0.36093011E-10_JPRB, 0.47735670E-10_JPRB, 0.61130302E-10_JPRB, 0.75137993E-10_JPRB, 0.88865533E-10_JPRB, 0.10162848E-09_JPRB, &
  & 0.11301195E-09_JPRB, 0.12284306E-09_JPRB, 0.13102856E-09_JPRB, 0.13766965E-09_JPRB, 0.14292917E-09_JPRB, 0.14695285E-09_JPRB, &
  & 0.14992263E-09_JPRB, 0.15181378E-09_JPRB, 0.15240462E-09_JPRB, 0.15167749E-09_JPRB, 0.14933886E-09_JPRB, 0.14529507E-09_JPRB, &
  & 0.14117452E-09_JPRB, 0.13789037E-09_JPRB, 0.14027093E-09_JPRB, 0.16620093E-09_JPRB /)

RGHG4(:,39, 3) = (/ &
  & 0.12730485E-09_JPRB, 0.16510877E-09_JPRB, 0.19163977E-09_JPRB, 0.20886548E-09_JPRB, 0.22188067E-09_JPRB, 0.22838460E-09_JPRB, &
  & 0.23108163E-09_JPRB, 0.22978584E-09_JPRB, 0.22608813E-09_JPRB, 0.22070354E-09_JPRB, 0.21307356E-09_JPRB, 0.20280272E-09_JPRB, &
  & 0.18923609E-09_JPRB, 0.17165654E-09_JPRB, 0.15025649E-09_JPRB, 0.12584901E-09_JPRB, 0.10020610E-09_JPRB, 0.75752675E-10_JPRB, &
  & 0.54399100E-10_JPRB, 0.37156698E-10_JPRB, 0.24680256E-10_JPRB, 0.16230621E-10_JPRB, 0.11085949E-10_JPRB, 0.78551141E-11_JPRB, &
  & 0.59615863E-11_JPRB, 0.46849976E-11_JPRB, 0.38627413E-11_JPRB, 0.32981029E-11_JPRB, 0.28996215E-11_JPRB, 0.26654907E-11_JPRB, &
  & 0.25767639E-11_JPRB, 0.26430568E-11_JPRB, 0.28637294E-11_JPRB, 0.32689411E-11_JPRB, 0.38563974E-11_JPRB, 0.46745728E-11_JPRB, &
  & 0.57422110E-11_JPRB, 0.71826989E-11_JPRB, 0.91341691E-11_JPRB, 0.11900404E-10_JPRB, 0.15851730E-10_JPRB, 0.21508018E-10_JPRB, &
  & 0.29219738E-10_JPRB, 0.39098214E-10_JPRB, 0.50557090E-10_JPRB, 0.62839532E-10_JPRB, 0.75045109E-10_JPRB, 0.86604737E-10_JPRB, &
  & 0.97069859E-10_JPRB, 0.10622059E-09_JPRB, 0.11380796E-09_JPRB, 0.11989205E-09_JPRB, 0.12460660E-09_JPRB, 0.12817955E-09_JPRB, &
  & 0.13076813E-09_JPRB, 0.13233847E-09_JPRB, 0.13280023E-09_JPRB, 0.13215057E-09_JPRB, 0.13015598E-09_JPRB, 0.12680973E-09_JPRB, &
  & 0.12349703E-09_JPRB, 0.12087584E-09_JPRB, 0.12319033E-09_JPRB, 0.14412056E-09_JPRB /)

RGHG4(:,40, 3) = (/ &
  & 0.11679734E-09_JPRB, 0.14752541E-09_JPRB, 0.17033629E-09_JPRB, 0.18529450E-09_JPRB, 0.19685824E-09_JPRB, 0.20209001E-09_JPRB, &
  & 0.20397681E-09_JPRB, 0.20243507E-09_JPRB, 0.19891840E-09_JPRB, 0.19417125E-09_JPRB, 0.18756131E-09_JPRB, 0.17861605E-09_JPRB, &
  & 0.16658101E-09_JPRB, 0.15071837E-09_JPRB, 0.13089080E-09_JPRB, 0.10827580E-09_JPRB, 0.84672110E-10_JPRB, 0.62162185E-10_JPRB, &
  & 0.43102674E-10_JPRB, 0.28588224E-10_JPRB, 0.18758821E-10_JPRB, 0.12356344E-10_JPRB, 0.85645605E-11_JPRB, 0.62068627E-11_JPRB, &
  & 0.48324339E-11_JPRB, 0.38840281E-11_JPRB, 0.32652533E-11_JPRB, 0.28262488E-11_JPRB, 0.25034040E-11_JPRB, 0.23069454E-11_JPRB, &
  & 0.22281558E-11_JPRB, 0.22728395E-11_JPRB, 0.24558415E-11_JPRB, 0.27890407E-11_JPRB, 0.32833879E-11_JPRB, 0.39613447E-11_JPRB, &
  & 0.48516720E-11_JPRB, 0.60470995E-11_JPRB, 0.76756318E-11_JPRB, 0.99855653E-11_JPRB, 0.13302181E-10_JPRB, 0.18041259E-10_JPRB, &
  & 0.24557066E-10_JPRB, 0.32885753E-10_JPRB, 0.42687034E-10_JPRB, 0.53264580E-10_JPRB, 0.63943503E-10_JPRB, 0.74235722E-10_JPRB, &
  & 0.83759173E-10_JPRB, 0.92168710E-10_JPRB, 0.99234551E-10_JPRB, 0.10485120E-09_JPRB, 0.10913107E-09_JPRB, 0.11223139E-09_JPRB, &
  & 0.11438466E-09_JPRB, 0.11563903E-09_JPRB, 0.11597896E-09_JPRB, 0.11537783E-09_JPRB, 0.11368962E-09_JPRB, 0.11098893E-09_JPRB, &
  & 0.10828639E-09_JPRB, 0.10631489E-09_JPRB, 0.10833644E-09_JPRB, 0.12607594E-09_JPRB /)

RGHG4(:,41, 3) = (/ &
  & 0.10520461E-09_JPRB, 0.12932201E-09_JPRB, 0.15092691E-09_JPRB, 0.16436028E-09_JPRB, 0.17444540E-09_JPRB, 0.17864840E-09_JPRB, &
  & 0.17962608E-09_JPRB, 0.17769469E-09_JPRB, 0.17426931E-09_JPRB, 0.17000958E-09_JPRB, 0.16427271E-09_JPRB, 0.15651773E-09_JPRB, &
  & 0.14594821E-09_JPRB, 0.13174392E-09_JPRB, 0.11376059E-09_JPRB, 0.92801079E-10_JPRB, 0.71252407E-10_JPRB, 0.51296183E-10_JPRB, &
  & 0.34974666E-10_JPRB, 0.22902232E-10_JPRB, 0.15043109E-10_JPRB, 0.10075920E-10_JPRB, 0.71224892E-11_JPRB, 0.52894147E-11_JPRB, &
  & 0.41955428E-11_JPRB, 0.34333552E-11_JPRB, 0.29237717E-11_JPRB, 0.25525348E-11_JPRB, 0.22704987E-11_JPRB, 0.20915886E-11_JPRB, &
  & 0.20197463E-11_JPRB, 0.20470056E-11_JPRB, 0.22114170E-11_JPRB, 0.24977834E-11_JPRB, 0.29396615E-11_JPRB, 0.35311608E-11_JPRB, &
  & 0.43121461E-11_JPRB, 0.53479539E-11_JPRB, 0.67596007E-11_JPRB, 0.87520191E-11_JPRB, 0.11605023E-10_JPRB, 0.15668768E-10_JPRB, &
  & 0.21221854E-10_JPRB, 0.28332468E-10_JPRB, 0.36672818E-10_JPRB, 0.45689341E-10_JPRB, 0.54927958E-10_JPRB, 0.63971342E-10_JPRB, &
  & 0.72480459E-10_JPRB, 0.80206147E-10_JPRB, 0.86709619E-10_JPRB, 0.91818067E-10_JPRB, 0.95588086E-10_JPRB, 0.98249776E-10_JPRB, &
  & 0.10008075E-09_JPRB, 0.10106274E-09_JPRB, 0.10130055E-09_JPRB, 0.10067187E-09_JPRB, 0.99188747E-10_JPRB, 0.97003919E-10_JPRB, &
  & 0.94928239E-10_JPRB, 0.93565086E-10_JPRB, 0.95687375E-10_JPRB, 0.11086466E-09_JPRB /)

RGHG4(:,42, 3) = (/ &
  & 0.96034194E-10_JPRB, 0.11595894E-09_JPRB, 0.13447696E-09_JPRB, 0.14626646E-09_JPRB, 0.15475260E-09_JPRB, 0.15774922E-09_JPRB, &
  & 0.15786508E-09_JPRB, 0.15548353E-09_JPRB, 0.15210076E-09_JPRB, 0.14819046E-09_JPRB, 0.14323769E-09_JPRB, 0.13657125E-09_JPRB, &
  & 0.12739157E-09_JPRB, 0.11470120E-09_JPRB, 0.98443094E-10_JPRB, 0.79461514E-10_JPRB, 0.59836996E-10_JPRB, 0.42248014E-10_JPRB, &
  & 0.28461834E-10_JPRB, 0.18750855E-10_JPRB, 0.12472086E-10_JPRB, 0.85436025E-11_JPRB, 0.61599293E-11_JPRB, 0.46813482E-11_JPRB, &
  & 0.37615076E-11_JPRB, 0.31237300E-11_JPRB, 0.26830842E-11_JPRB, 0.23548550E-11_JPRB, 0.21022546E-11_JPRB, 0.19327062E-11_JPRB, &
  & 0.18686025E-11_JPRB, 0.18815145E-11_JPRB, 0.20355618E-11_JPRB, 0.22862758E-11_JPRB, 0.26951592E-11_JPRB, 0.32223289E-11_JPRB, &
  & 0.39288139E-11_JPRB, 0.48442110E-11_JPRB, 0.60941109E-11_JPRB, 0.78339184E-11_JPRB, 0.10317716E-10_JPRB, 0.13813073E-10_JPRB, &
  & 0.18567828E-10_JPRB, 0.24606697E-10_JPRB, 0.31703275E-10_JPRB, 0.39414610E-10_JPRB, 0.47312758E-10_JPRB, 0.55197080E-10_JPRB, &
  & 0.62778303E-10_JPRB, 0.69781798E-10_JPRB, 0.75771077E-10_JPRB, 0.80478089E-10_JPRB, 0.83889229E-10_JPRB, 0.86190423E-10_JPRB, &
  & 0.87647480E-10_JPRB, 0.88346976E-10_JPRB, 0.88508714E-10_JPRB, 0.87906064E-10_JPRB, 0.86674681E-10_JPRB, 0.84986324E-10_JPRB, &
  & 0.83517825E-10_JPRB, 0.82660434E-10_JPRB, 0.84747605E-10_JPRB, 0.97870496E-10_JPRB /)

RGHG4(:,43, 3) = (/ &
  & 0.88546462E-10_JPRB, 0.10432001E-09_JPRB, 0.12108453E-09_JPRB, 0.13093876E-09_JPRB, 0.13765385E-09_JPRB, 0.13916561E-09_JPRB, &
  & 0.13820325E-09_JPRB, 0.13518592E-09_JPRB, 0.13169876E-09_JPRB, 0.12809395E-09_JPRB, 0.12372443E-09_JPRB, 0.11795882E-09_JPRB, &
  & 0.11000010E-09_JPRB, 0.98869531E-10_JPRB, 0.84285350E-10_JPRB, 0.67316513E-10_JPRB, 0.50162104E-10_JPRB, 0.35031374E-10_JPRB, &
  & 0.23581226E-10_JPRB, 0.15722160E-10_JPRB, 0.10663911E-10_JPRB, 0.75006190E-11_JPRB, 0.55012947E-11_JPRB, 0.42719669E-11_JPRB, &
  & 0.34588439E-11_JPRB, 0.29061874E-11_JPRB, 0.25087037E-11_JPRB, 0.22054329E-11_JPRB, 0.19755191E-11_JPRB, 0.18113723E-11_JPRB, &
  & 0.17560252E-11_JPRB, 0.17580886E-11_JPRB, 0.19066016E-11_JPRB, 0.21320862E-11_JPRB, 0.25171423E-11_JPRB, 0.30010614E-11_JPRB, &
  & 0.36539027E-11_JPRB, 0.44831487E-11_JPRB, 0.56074563E-11_JPRB, 0.71476700E-11_JPRB, 0.93169630E-11_JPRB, 0.12322252E-10_JPRB, &
  & 0.16351235E-10_JPRB, 0.21432002E-10_JPRB, 0.27394300E-10_JPRB, 0.33883254E-10_JPRB, 0.40643069E-10_JPRB, 0.47476301E-10_JPRB, &
  & 0.54166116E-10_JPRB, 0.60500244E-10_JPRB, 0.66000087E-10_JPRB, 0.70296102E-10_JPRB, 0.73339709E-10_JPRB, 0.75310647E-10_JPRB, &
  & 0.76567440E-10_JPRB, 0.77121316E-10_JPRB, 0.77309430E-10_JPRB, 0.76749912E-10_JPRB, 0.75747859E-10_JPRB, 0.74496048E-10_JPRB, &
  & 0.73511572E-10_JPRB, 0.73088771E-10_JPRB, 0.75168011E-10_JPRB, 0.86546478E-10_JPRB /)

RGHG4(:,44, 3) = (/ &
  & 0.81973539E-10_JPRB, 0.95463283E-10_JPRB, 0.10854574E-09_JPRB, 0.11716203E-09_JPRB, 0.12187851E-09_JPRB, 0.12192219E-09_JPRB, &
  & 0.11979950E-09_JPRB, 0.11629679E-09_JPRB, 0.11261660E-09_JPRB, 0.10932943E-09_JPRB, 0.10552031E-09_JPRB, 0.10061804E-09_JPRB, &
  & 0.93839943E-10_JPRB, 0.84112481E-10_JPRB, 0.71257708E-10_JPRB, 0.56211133E-10_JPRB, 0.41313876E-10_JPRB, 0.28787132E-10_JPRB, &
  & 0.19554533E-10_JPRB, 0.13353148E-10_JPRB, 0.92780870E-11_JPRB, 0.67075030E-11_JPRB, 0.49997866E-11_JPRB, 0.39598368E-11_JPRB, &
  & 0.32155225E-11_JPRB, 0.27309092E-11_JPRB, 0.23596784E-11_JPRB, 0.20752579E-11_JPRB, 0.18659208E-11_JPRB, 0.17051284E-11_JPRB, &
  & 0.16593752E-11_JPRB, 0.16560263E-11_JPRB, 0.17986677E-11_JPRB, 0.20072548E-11_JPRB, 0.23724785E-11_JPRB, 0.28255909E-11_JPRB, &
  & 0.34369365E-11_JPRB, 0.41980998E-11_JPRB, 0.52190400E-11_JPRB, 0.65864597E-11_JPRB, 0.84789138E-11_JPRB, 0.11033896E-10_JPRB, &
  & 0.14392682E-10_JPRB, 0.18557269E-10_JPRB, 0.23468932E-10_JPRB, 0.28880157E-10_JPRB, 0.34595285E-10_JPRB, 0.40490739E-10_JPRB, &
  & 0.46386121E-10_JPRB, 0.52097222E-10_JPRB, 0.57126720E-10_JPRB, 0.61089411E-10_JPRB, 0.63876092E-10_JPRB, 0.65671260E-10_JPRB, &
  & 0.66752964E-10_JPRB, 0.67154171E-10_JPRB, 0.67456561E-10_JPRB, 0.66969201E-10_JPRB, 0.66115217E-10_JPRB, 0.65360842E-10_JPRB, &
  & 0.64817179E-10_JPRB, 0.64759705E-10_JPRB, 0.66780297E-10_JPRB, 0.76532509E-10_JPRB /)

RGHG4(:,45, 3) = (/ &
  & 0.75267813E-10_JPRB, 0.84345586E-10_JPRB, 0.96585268E-10_JPRB, 0.10261470E-09_JPRB, 0.10593979E-09_JPRB, 0.10460600E-09_JPRB, &
  & 0.10175480E-09_JPRB, 0.98019454E-10_JPRB, 0.94405719E-10_JPRB, 0.91478110E-10_JPRB, 0.88195971E-10_JPRB, 0.84081672E-10_JPRB, &
  & 0.78358042E-10_JPRB, 0.70103402E-10_JPRB, 0.58867494E-10_JPRB, 0.45929774E-10_JPRB, 0.33503381E-10_JPRB, 0.23423683E-10_JPRB, &
  & 0.16251021E-10_JPRB, 0.11429557E-10_JPRB, 0.81798275E-11_JPRB, 0.60756248E-11_JPRB, 0.46031334E-11_JPRB, 0.37074298E-11_JPRB, &
  & 0.30139034E-11_JPRB, 0.25837887E-11_JPRB, 0.22297750E-11_JPRB, 0.19580262E-11_JPRB, 0.17660523E-11_JPRB, 0.16122732E-11_JPRB, &
  & 0.15718874E-11_JPRB, 0.15728106E-11_JPRB, 0.17041246E-11_JPRB, 0.19065355E-11_JPRB, 0.22492709E-11_JPRB, 0.26830747E-11_JPRB, &
  & 0.32576066E-11_JPRB, 0.39674744E-11_JPRB, 0.48987763E-11_JPRB, 0.61191460E-11_JPRB, 0.77588413E-11_JPRB, 0.99018814E-11_JPRB, &
  & 0.12624406E-10_JPRB, 0.15927206E-10_JPRB, 0.19799520E-10_JPRB, 0.24172034E-10_JPRB, 0.28926445E-10_JPRB, 0.33984149E-10_JPRB, &
  & 0.39181838E-10_JPRB, 0.44319604E-10_JPRB, 0.48934422E-10_JPRB, 0.52557105E-10_JPRB, 0.55135820E-10_JPRB, 0.56775147E-10_JPRB, &
  & 0.57821626E-10_JPRB, 0.58243875E-10_JPRB, 0.58741338E-10_JPRB, 0.58387316E-10_JPRB, 0.57793624E-10_JPRB, 0.57364904E-10_JPRB, &
  & 0.57190377E-10_JPRB, 0.57381769E-10_JPRB, 0.59357998E-10_JPRB, 0.67663763E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART6',0,ZHOOK_HANDLE)



RGHG4(:,46, 3) = (/ &
  & 0.67293761E-10_JPRB, 0.73898249E-10_JPRB, 0.82183205E-10_JPRB, 0.87135368E-10_JPRB, 0.88837084E-10_JPRB, 0.86976849E-10_JPRB, &
  & 0.83888750E-10_JPRB, 0.80253332E-10_JPRB, 0.76881286E-10_JPRB, 0.74351886E-10_JPRB, 0.71660150E-10_JPRB, 0.68317914E-10_JPRB, &
  & 0.63678160E-10_JPRB, 0.56746021E-10_JPRB, 0.47300337E-10_JPRB, 0.36478584E-10_JPRB, 0.26597651E-10_JPRB, 0.18969794E-10_JPRB, &
  & 0.13582714E-10_JPRB, 0.99159951E-11_JPRB, 0.73295866E-11_JPRB, 0.55831286E-11_JPRB, 0.43035697E-11_JPRB, 0.35061043E-11_JPRB, &
  & 0.28523217E-11_JPRB, 0.24590883E-11_JPRB, 0.21130563E-11_JPRB, 0.18527695E-11_JPRB, 0.16722598E-11_JPRB, 0.15327931E-11_JPRB, &
  & 0.14911163E-11_JPRB, 0.15068628E-11_JPRB, 0.16222419E-11_JPRB, 0.18282127E-11_JPRB, 0.21490698E-11_JPRB, 0.25738994E-11_JPRB, &
  & 0.31192379E-11_JPRB, 0.37901396E-11_JPRB, 0.46483724E-11_JPRB, 0.57408314E-11_JPRB, 0.71587987E-11_JPRB, 0.89268983E-11_JPRB, &
  & 0.11071235E-10_JPRB, 0.13544374E-10_JPRB, 0.16428178E-10_JPRB, 0.19728448E-10_JPRB, 0.23519164E-10_JPRB, 0.27759312E-10_JPRB, &
  & 0.32289449E-10_JPRB, 0.36955019E-10_JPRB, 0.41148761E-10_JPRB, 0.44539331E-10_JPRB, 0.46940809E-10_JPRB, 0.48560697E-10_JPRB, &
  & 0.49627646E-10_JPRB, 0.50102835E-10_JPRB, 0.50864001E-10_JPRB, 0.50698296E-10_JPRB, 0.50406079E-10_JPRB, 0.50272758E-10_JPRB, &
  & 0.50401051E-10_JPRB, 0.50824307E-10_JPRB, 0.52737214E-10_JPRB, 0.59705900E-10_JPRB /)

RGHG4(:,47, 3) = (/ &
  & 0.58621753E-10_JPRB, 0.61927276E-10_JPRB, 0.69131319E-10_JPRB, 0.72019300E-10_JPRB, 0.72797532E-10_JPRB, 0.70514317E-10_JPRB, &
  & 0.67509442E-10_JPRB, 0.64124366E-10_JPRB, 0.61092680E-10_JPRB, 0.58952357E-10_JPRB, 0.56717596E-10_JPRB, 0.53942198E-10_JPRB, &
  & 0.50122691E-10_JPRB, 0.44342009E-10_JPRB, 0.36608605E-10_JPRB, 0.28028529E-10_JPRB, 0.20715938E-10_JPRB, 0.15232983E-10_JPRB, &
  & 0.11397402E-10_JPRB, 0.86557064E-11_JPRB, 0.66287765E-11_JPRB, 0.51647376E-11_JPRB, 0.40587728E-11_JPRB, 0.33228732E-11_JPRB, &
  & 0.27156255E-11_JPRB, 0.23420937E-11_JPRB, 0.20060303E-11_JPRB, 0.17563683E-11_JPRB, 0.15837555E-11_JPRB, 0.14645878E-11_JPRB, &
  & 0.14176349E-11_JPRB, 0.14522771E-11_JPRB, 0.15515596E-11_JPRB, 0.17628985E-11_JPRB, 0.20641804E-11_JPRB, 0.24829704E-11_JPRB, &
  & 0.30005102E-11_JPRB, 0.36403276E-11_JPRB, 0.44306052E-11_JPRB, 0.54131365E-11_JPRB, 0.66255816E-11_JPRB, 0.80619209E-11_JPRB, &
  & 0.96768019E-11_JPRB, 0.11412550E-10_JPRB, 0.13317566E-10_JPRB, 0.15556258E-10_JPRB, 0.18281859E-10_JPRB, 0.21628845E-10_JPRB, &
  & 0.25545465E-10_JPRB, 0.29701547E-10_JPRB, 0.33633943E-10_JPRB, 0.36734886E-10_JPRB, 0.39062562E-10_JPRB, 0.40654514E-10_JPRB, &
  & 0.41799043E-10_JPRB, 0.42424148E-10_JPRB, 0.43507645E-10_JPRB, 0.43561276E-10_JPRB, 0.43558504E-10_JPRB, 0.43732858E-10_JPRB, &
  & 0.44130245E-10_JPRB, 0.44722000E-10_JPRB, 0.46559562E-10_JPRB, 0.52472405E-10_JPRB /)

RGHG4(:,48, 3) = (/ &
  & 0.50793314E-10_JPRB, 0.51665363E-10_JPRB, 0.56312410E-10_JPRB, 0.58122847E-10_JPRB, 0.58061538E-10_JPRB, 0.55780065E-10_JPRB, &
  & 0.53010180E-10_JPRB, 0.50006048E-10_JPRB, 0.47268359E-10_JPRB, 0.45430042E-10_JPRB, 0.43537070E-10_JPRB, 0.41239713E-10_JPRB, &
  & 0.38062241E-10_JPRB, 0.33468988E-10_JPRB, 0.27337278E-10_JPRB, 0.21185002E-10_JPRB, 0.16109168E-10_JPRB, 0.12418688E-10_JPRB, &
  & 0.97305445E-11_JPRB, 0.76975882E-11_JPRB, 0.60988120E-11_JPRB, 0.48472255E-11_JPRB, 0.38814624E-11_JPRB, 0.31757520E-11_JPRB, &
  & 0.26144119E-11_JPRB, 0.22410333E-11_JPRB, 0.19137697E-11_JPRB, 0.16742594E-11_JPRB, 0.15073108E-11_JPRB, 0.14098560E-11_JPRB, &
  & 0.13599998E-11_JPRB, 0.14082684E-11_JPRB, 0.15018123E-11_JPRB, 0.17126178E-11_JPRB, 0.20046094E-11_JPRB, 0.24161602E-11_JPRB, &
  & 0.29163714E-11_JPRB, 0.35289942E-11_JPRB, 0.42669462E-11_JPRB, 0.51514496E-11_JPRB, 0.61928735E-11_JPRB, 0.73376496E-11_JPRB, &
  & 0.85099991E-11_JPRB, 0.96178092E-11_JPRB, 0.10726668E-10_JPRB, 0.11972171E-10_JPRB, 0.13656676E-10_JPRB, 0.15996635E-10_JPRB, &
  & 0.19055006E-10_JPRB, 0.22723882E-10_JPRB, 0.26184045E-10_JPRB, 0.29133109E-10_JPRB, 0.31322459E-10_JPRB, 0.32954965E-10_JPRB, &
  & 0.34202884E-10_JPRB, 0.34984581E-10_JPRB, 0.36406645E-10_JPRB, 0.36702790E-10_JPRB, 0.36965878E-10_JPRB, 0.37396388E-10_JPRB, &
  & 0.38008728E-10_JPRB, 0.38749712E-10_JPRB, 0.40573263E-10_JPRB, 0.45682961E-10_JPRB /)

RGHG4(:,49, 3) = (/ &
  & 0.42648222E-10_JPRB, 0.41805760E-10_JPRB, 0.45200520E-10_JPRB, 0.45756170E-10_JPRB, 0.45103324E-10_JPRB, 0.42717302E-10_JPRB, &
  & 0.40073635E-10_JPRB, 0.37351091E-10_JPRB, 0.34840346E-10_JPRB, 0.33239096E-10_JPRB, 0.31652583E-10_JPRB, 0.29777021E-10_JPRB, &
  & 0.27338388E-10_JPRB, 0.23862275E-10_JPRB, 0.19821650E-10_JPRB, 0.15757362E-10_JPRB, 0.12620554E-10_JPRB, 0.10238900E-10_JPRB, &
  & 0.84209558E-11_JPRB, 0.69267942E-11_JPRB, 0.56656151E-11_JPRB, 0.45888076E-11_JPRB, 0.37350344E-11_JPRB, 0.30448955E-11_JPRB, &
  & 0.25244195E-11_JPRB, 0.21473717E-11_JPRB, 0.18316798E-11_JPRB, 0.16049769E-11_JPRB, 0.14448772E-11_JPRB, 0.13653162E-11_JPRB, &
  & 0.13205408E-11_JPRB, 0.13706525E-11_JPRB, 0.14687353E-11_JPRB, 0.16710340E-11_JPRB, 0.19617439E-11_JPRB, 0.23630631E-11_JPRB, &
  & 0.28485517E-11_JPRB, 0.34365520E-11_JPRB, 0.41253290E-11_JPRB, 0.49251931E-11_JPRB, 0.58123523E-11_JPRB, 0.67085205E-11_JPRB, &
  & 0.75107837E-11_JPRB, 0.81312379E-11_JPRB, 0.86172207E-11_JPRB, 0.91395884E-11_JPRB, 0.99346252E-11_JPRB, 0.11277586E-10_JPRB, &
  & 0.13378081E-10_JPRB, 0.16071405E-10_JPRB, 0.19002864E-10_JPRB, 0.21486233E-10_JPRB, 0.23526197E-10_JPRB, 0.25138178E-10_JPRB, &
  & 0.26463706E-10_JPRB, 0.27424805E-10_JPRB, 0.29200760E-10_JPRB, 0.29747482E-10_JPRB, 0.30272260E-10_JPRB, 0.30941059E-10_JPRB, &
  & 0.31715838E-10_JPRB, 0.32604943E-10_JPRB, 0.34403456E-10_JPRB, 0.38892441E-10_JPRB /)

RGHG4(:,50, 3) = (/ &
  & 0.35952841E-10_JPRB, 0.33612391E-10_JPRB, 0.35357026E-10_JPRB, 0.35245681E-10_JPRB, 0.33924984E-10_JPRB, 0.31355540E-10_JPRB, &
  & 0.28778025E-10_JPRB, 0.26378049E-10_JPRB, 0.24145059E-10_JPRB, 0.22829792E-10_JPRB, 0.21649314E-10_JPRB, 0.20290714E-10_JPRB, &
  & 0.18690220E-10_JPRB, 0.16646323E-10_JPRB, 0.14248948E-10_JPRB, 0.12003789E-10_JPRB, 0.10143204E-10_JPRB, 0.86700751E-11_JPRB, &
  & 0.74394692E-11_JPRB, 0.63370867E-11_JPRB, 0.53234743E-11_JPRB, 0.43924365E-11_JPRB, 0.36111821E-11_JPRB, 0.29443596E-11_JPRB, &
  & 0.24506989E-11_JPRB, 0.20692417E-11_JPRB, 0.17679609E-11_JPRB, 0.15550810E-11_JPRB, 0.14046076E-11_JPRB, 0.13364023E-11_JPRB, &
  & 0.13027662E-11_JPRB, 0.13495958E-11_JPRB, 0.14526650E-11_JPRB, 0.16499202E-11_JPRB, 0.19342791E-11_JPRB, 0.23253808E-11_JPRB, &
  & 0.27972047E-11_JPRB, 0.33614797E-11_JPRB, 0.40079038E-11_JPRB, 0.47306937E-11_JPRB, 0.54848383E-11_JPRB, 0.61743345E-11_JPRB, &
  & 0.66840851E-11_JPRB, 0.69562160E-11_JPRB, 0.70550852E-11_JPRB, 0.71332957E-11_JPRB, 0.73972928E-11_JPRB, 0.80205174E-11_JPRB, &
  & 0.91512778E-11_JPRB, 0.10856305E-10_JPRB, 0.12708016E-10_JPRB, 0.14521155E-10_JPRB, 0.16131424E-10_JPRB, 0.17531209E-10_JPRB, &
  & 0.18811903E-10_JPRB, 0.19869262E-10_JPRB, 0.21921638E-10_JPRB, 0.22682536E-10_JPRB, 0.23426986E-10_JPRB, 0.24249252E-10_JPRB, &
  & 0.25150923E-10_JPRB, 0.26137715E-10_JPRB, 0.27857897E-10_JPRB, 0.31911414E-10_JPRB /)

RGHG4(:,51, 3) = (/ &
  & 0.29898455E-10_JPRB, 0.26027767E-10_JPRB, 0.27169711E-10_JPRB, 0.26016571E-10_JPRB, 0.24124536E-10_JPRB, 0.21453424E-10_JPRB, &
  & 0.19135932E-10_JPRB, 0.17298952E-10_JPRB, 0.15519393E-10_JPRB, 0.14676585E-10_JPRB, 0.13981959E-10_JPRB, 0.13313553E-10_JPRB, &
  & 0.12561421E-10_JPRB, 0.11650637E-10_JPRB, 0.10570028E-10_JPRB, 0.94513902E-11_JPRB, 0.84284532E-11_JPRB, 0.75392670E-11_JPRB, &
  & 0.66966350E-11_JPRB, 0.58872252E-11_JPRB, 0.50502640E-11_JPRB, 0.42510127E-11_JPRB, 0.35070217E-11_JPRB, 0.28703539E-11_JPRB, &
  & 0.23856945E-11_JPRB, 0.20098521E-11_JPRB, 0.17258781E-11_JPRB, 0.15289971E-11_JPRB, 0.13902151E-11_JPRB, 0.13281011E-11_JPRB, &
  & 0.13038275E-11_JPRB, 0.13510892E-11_JPRB, 0.14484238E-11_JPRB, 0.16514483E-11_JPRB, 0.19222954E-11_JPRB, 0.23127229E-11_JPRB, &
  & 0.27654873E-11_JPRB, 0.33087322E-11_JPRB, 0.39157371E-11_JPRB, 0.45686306E-11_JPRB, 0.52073974E-11_JPRB, 0.57185025E-11_JPRB, &
  & 0.60019355E-11_JPRB, 0.60370671E-11_JPRB, 0.59174861E-11_JPRB, 0.57822497E-11_JPRB, 0.57678857E-11_JPRB, 0.59939788E-11_JPRB, &
  & 0.65293426E-11_JPRB, 0.73204134E-11_JPRB, 0.82839213E-11_JPRB, 0.92358950E-11_JPRB, 0.10151069E-10_JPRB, 0.11089281E-10_JPRB, &
  & 0.12024939E-10_JPRB, 0.12920813E-10_JPRB, 0.15025311E-10_JPRB, 0.15842456E-10_JPRB, 0.16664548E-10_JPRB, 0.17531560E-10_JPRB, &
  & 0.18466065E-10_JPRB, 0.19463771E-10_JPRB, 0.21061835E-10_JPRB, 0.24677009E-10_JPRB /)

RGHG4(:,52, 3) = (/ &
  & 0.24533462E-10_JPRB, 0.20196449E-10_JPRB, 0.19947526E-10_JPRB, 0.18459951E-10_JPRB, 0.16262172E-10_JPRB, 0.13909983E-10_JPRB, &
  & 0.12318883E-10_JPRB, 0.11180471E-10_JPRB, 0.99348984E-11_JPRB, 0.95160147E-11_JPRB, 0.92527982E-11_JPRB, 0.90102821E-11_JPRB, &
  & 0.88027328E-11_JPRB, 0.85580727E-11_JPRB, 0.82032619E-11_JPRB, 0.77439704E-11_JPRB, 0.72258783E-11_JPRB, 0.67067311E-11_JPRB, &
  & 0.61313610E-11_JPRB, 0.55296054E-11_JPRB, 0.48282814E-11_JPRB, 0.41321712E-11_JPRB, 0.34288518E-11_JPRB, 0.28305268E-11_JPRB, &
  & 0.23505403E-11_JPRB, 0.19854697E-11_JPRB, 0.17185804E-11_JPRB, 0.15361522E-11_JPRB, 0.14100123E-11_JPRB, 0.13525529E-11_JPRB, &
  & 0.13323443E-11_JPRB, 0.13864706E-11_JPRB, 0.14727812E-11_JPRB, 0.16830481E-11_JPRB, 0.19359395E-11_JPRB, 0.23238776E-11_JPRB, &
  & 0.27565318E-11_JPRB, 0.32822709E-11_JPRB, 0.38503146E-11_JPRB, 0.44350561E-11_JPRB, 0.49674527E-11_JPRB, 0.53269958E-11_JPRB, &
  & 0.54334332E-11_JPRB, 0.53222314E-11_JPRB, 0.50869552E-11_JPRB, 0.48653438E-11_JPRB, 0.47351658E-11_JPRB, 0.47636170E-11_JPRB, &
  & 0.49481660E-11_JPRB, 0.52837149E-11_JPRB, 0.56616903E-11_JPRB, 0.60425632E-11_JPRB, 0.64534636E-11_JPRB, 0.68803474E-11_JPRB, &
  & 0.73811434E-11_JPRB, 0.79174271E-11_JPRB, 0.97372778E-11_JPRB, 0.10364519E-10_JPRB, 0.11026587E-10_JPRB, 0.11739516E-10_JPRB, &
  & 0.12523596E-10_JPRB, 0.13366491E-10_JPRB, 0.14691063E-10_JPRB, 0.17702857E-10_JPRB /)

RGHG4(:,53, 3) = (/ &
  & 0.19964683E-10_JPRB, 0.14888025E-10_JPRB, 0.14310502E-10_JPRB, 0.12618612E-10_JPRB, 0.10740954E-10_JPRB, 0.92158078E-11_JPRB, &
  & 0.83735180E-11_JPRB, 0.78211925E-11_JPRB, 0.69456025E-11_JPRB, 0.67744165E-11_JPRB, 0.66809227E-11_JPRB, 0.66547531E-11_JPRB, &
  & 0.66709203E-11_JPRB, 0.67167422E-11_JPRB, 0.67076102E-11_JPRB, 0.66258704E-11_JPRB, 0.64022793E-11_JPRB, 0.61253485E-11_JPRB, &
  & 0.57257155E-11_JPRB, 0.52649820E-11_JPRB, 0.46804231E-11_JPRB, 0.40476919E-11_JPRB, 0.33983478E-11_JPRB, 0.28139169E-11_JPRB, &
  & 0.23451970E-11_JPRB, 0.19961281E-11_JPRB, 0.17455355E-11_JPRB, 0.15774804E-11_JPRB, 0.14629450E-11_JPRB, 0.14103075E-11_JPRB, &
  & 0.13893023E-11_JPRB, 0.14478179E-11_JPRB, 0.15306906E-11_JPRB, 0.17386167E-11_JPRB, 0.19933441E-11_JPRB, 0.23732414E-11_JPRB, &
  & 0.27892682E-11_JPRB, 0.32974782E-11_JPRB, 0.38267028E-11_JPRB, 0.43436517E-11_JPRB, 0.47794563E-11_JPRB, 0.50094586E-11_JPRB, &
  & 0.49892434E-11_JPRB, 0.47859967E-11_JPRB, 0.45123315E-11_JPRB, 0.42550117E-11_JPRB, 0.40883655E-11_JPRB, 0.40196887E-11_JPRB, &
  & 0.40465665E-11_JPRB, 0.41514023E-11_JPRB, 0.42753487E-11_JPRB, 0.44163887E-11_JPRB, 0.45617837E-11_JPRB, 0.47390416E-11_JPRB, &
  & 0.49531885E-11_JPRB, 0.52044519E-11_JPRB, 0.66548234E-11_JPRB, 0.70054548E-11_JPRB, 0.74035569E-11_JPRB, 0.78482247E-11_JPRB, &
  & 0.83626569E-11_JPRB, 0.89236942E-11_JPRB, 0.98362820E-11_JPRB, 0.11992830E-10_JPRB /)

RGHG4(:,54, 3) = (/ &
  & 0.16148791E-10_JPRB, 0.10944108E-10_JPRB, 0.99702876E-11_JPRB, 0.86294244E-11_JPRB, 0.74794415E-11_JPRB, 0.66954242E-11_JPRB, &
  & 0.63201913E-11_JPRB, 0.60575087E-11_JPRB, 0.53725527E-11_JPRB, 0.53008630E-11_JPRB, 0.52734627E-11_JPRB, 0.53093393E-11_JPRB, &
  & 0.53839077E-11_JPRB, 0.55553422E-11_JPRB, 0.57100232E-11_JPRB, 0.58217953E-11_JPRB, 0.58067370E-11_JPRB, 0.56910175E-11_JPRB, &
  & 0.54370887E-11_JPRB, 0.50710673E-11_JPRB, 0.45848559E-11_JPRB, 0.39989223E-11_JPRB, 0.34172400E-11_JPRB, 0.28602396E-11_JPRB, &
  & 0.24068070E-11_JPRB, 0.20723321E-11_JPRB, 0.18339505E-11_JPRB, 0.16764844E-11_JPRB, 0.15716120E-11_JPRB, 0.15236332E-11_JPRB, &
  & 0.15016444E-11_JPRB, 0.15567152E-11_JPRB, 0.16486094E-11_JPRB, 0.18380720E-11_JPRB, 0.21045938E-11_JPRB, 0.24639611E-11_JPRB, &
  & 0.28805573E-11_JPRB, 0.33694783E-11_JPRB, 0.38641039E-11_JPRB, 0.43093597E-11_JPRB, 0.46547141E-11_JPRB, 0.47673280E-11_JPRB, &
  & 0.46456892E-11_JPRB, 0.43908028E-11_JPRB, 0.40907924E-11_JPRB, 0.38368475E-11_JPRB, 0.36553816E-11_JPRB, 0.35353988E-11_JPRB, &
  & 0.34945170E-11_JPRB, 0.34915202E-11_JPRB, 0.35147941E-11_JPRB, 0.35522384E-11_JPRB, 0.35999487E-11_JPRB, 0.36708258E-11_JPRB, &
  & 0.37674135E-11_JPRB, 0.38844804E-11_JPRB, 0.50608302E-11_JPRB, 0.52450167E-11_JPRB, 0.54503611E-11_JPRB, 0.56927692E-11_JPRB, &
  & 0.59865884E-11_JPRB, 0.62882425E-11_JPRB, 0.68139821E-11_JPRB, 0.80718019E-11_JPRB /)

RGHG4(:,55, 3) = (/ &
  & 0.12702912E-10_JPRB, 0.79091074E-11_JPRB, 0.71152689E-11_JPRB, 0.62285233E-11_JPRB, 0.56673095E-11_JPRB, 0.53328457E-11_JPRB, &
  & 0.52004204E-11_JPRB, 0.50813399E-11_JPRB, 0.45122517E-11_JPRB, 0.44823437E-11_JPRB, 0.44812713E-11_JPRB, 0.45277866E-11_JPRB, &
  & 0.46332473E-11_JPRB, 0.48116827E-11_JPRB, 0.50454072E-11_JPRB, 0.52787514E-11_JPRB, 0.54008460E-11_JPRB, 0.54086202E-11_JPRB, &
  & 0.52603412E-11_JPRB, 0.49850926E-11_JPRB, 0.45596196E-11_JPRB, 0.40300662E-11_JPRB, 0.34860277E-11_JPRB, 0.29492251E-11_JPRB, &
  & 0.25090151E-11_JPRB, 0.21824148E-11_JPRB, 0.19529619E-11_JPRB, 0.18042041E-11_JPRB, 0.17078838E-11_JPRB, 0.16654651E-11_JPRB, &
  & 0.16482652E-11_JPRB, 0.16962509E-11_JPRB, 0.18047822E-11_JPRB, 0.19826835E-11_JPRB, 0.22693028E-11_JPRB, 0.26174334E-11_JPRB, &
  & 0.30372428E-11_JPRB, 0.35060516E-11_JPRB, 0.39695656E-11_JPRB, 0.43481629E-11_JPRB, 0.46126189E-11_JPRB, 0.46282639E-11_JPRB, &
  & 0.44321864E-11_JPRB, 0.41348405E-11_JPRB, 0.38318888E-11_JPRB, 0.35777973E-11_JPRB, 0.33951277E-11_JPRB, 0.32510479E-11_JPRB, &
  & 0.31779913E-11_JPRB, 0.31263863E-11_JPRB, 0.31119441E-11_JPRB, 0.31035276E-11_JPRB, 0.31181167E-11_JPRB, 0.31428649E-11_JPRB, &
  & 0.31839596E-11_JPRB, 0.32432845E-11_JPRB, 0.42376671E-11_JPRB, 0.43432536E-11_JPRB, 0.44602113E-11_JPRB, 0.46047137E-11_JPRB, &
  & 0.47817397E-11_JPRB, 0.49546738E-11_JPRB, 0.52691276E-11_JPRB, 0.59989709E-11_JPRB /)

RGHG4(:,56, 3) = (/ &
  & 0.10133317E-10_JPRB, 0.59061085E-11_JPRB, 0.52794149E-11_JPRB, 0.49056063E-11_JPRB, 0.46864600E-11_JPRB, 0.45849908E-11_JPRB, &
  & 0.45614797E-11_JPRB, 0.45147024E-11_JPRB, 0.40006353E-11_JPRB, 0.39949836E-11_JPRB, 0.39814822E-11_JPRB, 0.40396224E-11_JPRB, &
  & 0.41203529E-11_JPRB, 0.43221663E-11_JPRB, 0.45731782E-11_JPRB, 0.48762929E-11_JPRB, 0.51220616E-11_JPRB, 0.52433995E-11_JPRB, &
  & 0.51843677E-11_JPRB, 0.49875169E-11_JPRB, 0.46085757E-11_JPRB, 0.41145234E-11_JPRB, 0.36078117E-11_JPRB, 0.30855615E-11_JPRB, &
  & 0.26512449E-11_JPRB, 0.23312467E-11_JPRB, 0.21094734E-11_JPRB, 0.19682151E-11_JPRB, 0.18802301E-11_JPRB, 0.18422900E-11_JPRB, &
  & 0.18326222E-11_JPRB, 0.18749470E-11_JPRB, 0.19930166E-11_JPRB, 0.21771987E-11_JPRB, 0.24672436E-11_JPRB, 0.28263522E-11_JPRB, &
  & 0.32576160E-11_JPRB, 0.37196292E-11_JPRB, 0.41606848E-11_JPRB, 0.44744499E-11_JPRB, 0.46701393E-11_JPRB, 0.46068011E-11_JPRB, &
  & 0.43416152E-11_JPRB, 0.40072169E-11_JPRB, 0.36861625E-11_JPRB, 0.34430696E-11_JPRB, 0.32450303E-11_JPRB, 0.30908932E-11_JPRB, &
  & 0.29965288E-11_JPRB, 0.29195524E-11_JPRB, 0.28840313E-11_JPRB, 0.28580228E-11_JPRB, 0.28568953E-11_JPRB, 0.28604371E-11_JPRB, &
  & 0.28837588E-11_JPRB, 0.29200884E-11_JPRB, 0.37906219E-11_JPRB, 0.38642869E-11_JPRB, 0.39438752E-11_JPRB, 0.40420549E-11_JPRB, &
  & 0.41634513E-11_JPRB, 0.42700058E-11_JPRB, 0.44615826E-11_JPRB, 0.48642301E-11_JPRB /)

RGHG4(:,57, 3) = (/ &
  & 0.80651857E-11_JPRB, 0.46424201E-11_JPRB, 0.43499375E-11_JPRB, 0.41537776E-11_JPRB, 0.41204956E-11_JPRB, 0.41333421E-11_JPRB, &
  & 0.41526322E-11_JPRB, 0.41505389E-11_JPRB, 0.36939692E-11_JPRB, 0.36983459E-11_JPRB, 0.36936114E-11_JPRB, 0.37380316E-11_JPRB, &
  & 0.38274527E-11_JPRB, 0.39980844E-11_JPRB, 0.42725736E-11_JPRB, 0.46225189E-11_JPRB, 0.49612068E-11_JPRB, 0.51885453E-11_JPRB, &
  & 0.51963533E-11_JPRB, 0.50703716E-11_JPRB, 0.47232222E-11_JPRB, 0.42536742E-11_JPRB, 0.37515139E-11_JPRB, 0.32449256E-11_JPRB, &
  & 0.28167366E-11_JPRB, 0.25030661E-11_JPRB, 0.22910456E-11_JPRB, 0.21585255E-11_JPRB, 0.20796661E-11_JPRB, 0.20455777E-11_JPRB, &
  & 0.20430196E-11_JPRB, 0.20856448E-11_JPRB, 0.22023939E-11_JPRB, 0.24063462E-11_JPRB, 0.26919259E-11_JPRB, 0.30638259E-11_JPRB, &
  & 0.34936223E-11_JPRB, 0.39494302E-11_JPRB, 0.43770417E-11_JPRB, 0.46793008E-11_JPRB, 0.48330684E-11_JPRB, 0.47072186E-11_JPRB, &
  & 0.43950065E-11_JPRB, 0.40183612E-11_JPRB, 0.36809527E-11_JPRB, 0.34331455E-11_JPRB, 0.32246378E-11_JPRB, 0.30554042E-11_JPRB, &
  & 0.29389496E-11_JPRB, 0.28511093E-11_JPRB, 0.27972381E-11_JPRB, 0.27606511E-11_JPRB, 0.27510817E-11_JPRB, 0.27423914E-11_JPRB, &
  & 0.27552483E-11_JPRB, 0.27774363E-11_JPRB, 0.35563739E-11_JPRB, 0.36284678E-11_JPRB, 0.36953561E-11_JPRB, 0.37788297E-11_JPRB, &
  & 0.38838021E-11_JPRB, 0.39691935E-11_JPRB, 0.41116398E-11_JPRB, 0.42601179E-11_JPRB /)

RGHG4(:,58, 3) = (/ &
  & 0.67007701E-11_JPRB, 0.39581775E-11_JPRB, 0.37927166E-11_JPRB, 0.37561699E-11_JPRB, 0.38114759E-11_JPRB, 0.38737108E-11_JPRB, &
  & 0.39247802E-11_JPRB, 0.39384784E-11_JPRB, 0.35293864E-11_JPRB, 0.35363149E-11_JPRB, 0.35249687E-11_JPRB, 0.35775109E-11_JPRB, &
  & 0.36455856E-11_JPRB, 0.38357824E-11_JPRB, 0.40995016E-11_JPRB, 0.44914125E-11_JPRB, 0.49062377E-11_JPRB, 0.52030689E-11_JPRB, &
  & 0.52827868E-11_JPRB, 0.51791176E-11_JPRB, 0.48543444E-11_JPRB, 0.44138807E-11_JPRB, 0.39226469E-11_JPRB, 0.34223117E-11_JPRB, &
  & 0.30067292E-11_JPRB, 0.27040434E-11_JPRB, 0.25055032E-11_JPRB, 0.23842154E-11_JPRB, 0.23157305E-11_JPRB, 0.22855188E-11_JPRB, &
  & 0.22874320E-11_JPRB, 0.23333831E-11_JPRB, 0.24449845E-11_JPRB, 0.26592769E-11_JPRB, 0.29487797E-11_JPRB, 0.33331846E-11_JPRB, &
  & 0.37690762E-11_JPRB, 0.42239680E-11_JPRB, 0.46376861E-11_JPRB, 0.49118986E-11_JPRB, 0.50402829E-11_JPRB, 0.49167523E-11_JPRB, &
  & 0.45763181E-11_JPRB, 0.41727563E-11_JPRB, 0.38059516E-11_JPRB, 0.35592944E-11_JPRB, 0.33234244E-11_JPRB, 0.31315892E-11_JPRB, &
  & 0.29912028E-11_JPRB, 0.28825564E-11_JPRB, 0.28137531E-11_JPRB, 0.27685861E-11_JPRB, 0.27476960E-11_JPRB, 0.27331418E-11_JPRB, &
  & 0.27402661E-11_JPRB, 0.27632293E-11_JPRB, 0.34730476E-11_JPRB, 0.35402391E-11_JPRB, 0.36052188E-11_JPRB, 0.36897898E-11_JPRB, &
  & 0.37877397E-11_JPRB, 0.38754022E-11_JPRB, 0.40299860E-11_JPRB, 0.42827530E-11_JPRB /)

RGHG4(:,59, 3) = (/ &
  & 0.57806615E-11_JPRB, 0.35664338E-11_JPRB, 0.35381578E-11_JPRB, 0.35498692E-11_JPRB, 0.36209855E-11_JPRB, 0.37221259E-11_JPRB, &
  & 0.37895928E-11_JPRB, 0.38235257E-11_JPRB, 0.34694925E-11_JPRB, 0.34833156E-11_JPRB, 0.34856976E-11_JPRB, 0.35265374E-11_JPRB, &
  & 0.36164984E-11_JPRB, 0.37857378E-11_JPRB, 0.40802760E-11_JPRB, 0.44874009E-11_JPRB, 0.49423300E-11_JPRB, 0.52733538E-11_JPRB, &
  & 0.53954055E-11_JPRB, 0.53035020E-11_JPRB, 0.50124349E-11_JPRB, 0.45797021E-11_JPRB, 0.41049737E-11_JPRB, 0.36163063E-11_JPRB, &
  & 0.32127506E-11_JPRB, 0.29271988E-11_JPRB, 0.27456670E-11_JPRB, 0.26387896E-11_JPRB, 0.25823213E-11_JPRB, 0.25569768E-11_JPRB, &
  & 0.25612518E-11_JPRB, 0.26095911E-11_JPRB, 0.27200594E-11_JPRB, 0.29305085E-11_JPRB, 0.32327205E-11_JPRB, 0.36162132E-11_JPRB, &
  & 0.40547218E-11_JPRB, 0.45087658E-11_JPRB, 0.49173291E-11_JPRB, 0.51933141E-11_JPRB, 0.53117085E-11_JPRB, 0.51853990E-11_JPRB, &
  & 0.48726613E-11_JPRB, 0.44676728E-11_JPRB, 0.40900473E-11_JPRB, 0.38390671E-11_JPRB, 0.35737648E-11_JPRB, 0.33514884E-11_JPRB, &
  & 0.31795953E-11_JPRB, 0.30443963E-11_JPRB, 0.29519434E-11_JPRB, 0.28888970E-11_JPRB, 0.28580777E-11_JPRB, 0.28329043E-11_JPRB, &
  & 0.28354938E-11_JPRB, 0.28531014E-11_JPRB, 0.34978769E-11_JPRB, 0.35765865E-11_JPRB, 0.36494865E-11_JPRB, 0.37322593E-11_JPRB, &
  & 0.38265684E-11_JPRB, 0.39119558E-11_JPRB, 0.40435264E-11_JPRB, 0.42124477E-11_JPRB /)

RGHG4(:,60, 3) = (/ &
  & 0.53400903E-11_JPRB, 0.34175308E-11_JPRB, 0.34171496E-11_JPRB, 0.34671328E-11_JPRB, 0.35757543E-11_JPRB, 0.36806109E-11_JPRB, &
  & 0.37810818E-11_JPRB, 0.38264435E-11_JPRB, 0.35219976E-11_JPRB, 0.35334160E-11_JPRB, 0.35502289E-11_JPRB, 0.35938060E-11_JPRB, &
  & 0.36899559E-11_JPRB, 0.38790425E-11_JPRB, 0.41757765E-11_JPRB, 0.46012087E-11_JPRB, 0.50589689E-11_JPRB, 0.53968986E-11_JPRB, &
  & 0.55172633E-11_JPRB, 0.54422894E-11_JPRB, 0.51798140E-11_JPRB, 0.47619118E-11_JPRB, 0.42990078E-11_JPRB, 0.38270667E-11_JPRB, &
  & 0.34459133E-11_JPRB, 0.31850163E-11_JPRB, 0.30257285E-11_JPRB, 0.29374699E-11_JPRB, 0.28949714E-11_JPRB, 0.28758541E-11_JPRB, &
  & 0.28806144E-11_JPRB, 0.29269892E-11_JPRB, 0.30340285E-11_JPRB, 0.32352961E-11_JPRB, 0.35431558E-11_JPRB, 0.39249381E-11_JPRB, &
  & 0.43681174E-11_JPRB, 0.48231787E-11_JPRB, 0.52283828E-11_JPRB, 0.55028412E-11_JPRB, 0.56229999E-11_JPRB, 0.55250340E-11_JPRB, &
  & 0.52393038E-11_JPRB, 0.48783668E-11_JPRB, 0.45160325E-11_JPRB, 0.42818908E-11_JPRB, 0.39996726E-11_JPRB, 0.37306308E-11_JPRB, &
  & 0.35378271E-11_JPRB, 0.33407552E-11_JPRB, 0.32305864E-11_JPRB, 0.31285992E-11_JPRB, 0.30858458E-11_JPRB, 0.30498377E-11_JPRB, &
  & 0.30420586E-11_JPRB, 0.30625235E-11_JPRB, 0.36639229E-11_JPRB, 0.37488385E-11_JPRB, 0.38182998E-11_JPRB, 0.39025493E-11_JPRB, &
  & 0.39987670E-11_JPRB, 0.40884926E-11_JPRB, 0.42216634E-11_JPRB, 0.43929873E-11_JPRB /)

RGHG4(:,61, 3) = (/ &
  & 0.51250978E-11_JPRB, 0.33868034E-11_JPRB, 0.34285879E-11_JPRB, 0.34890849E-11_JPRB, 0.35951201E-11_JPRB, 0.37257766E-11_JPRB, &
  & 0.38477841E-11_JPRB, 0.39217280E-11_JPRB, 0.36706718E-11_JPRB, 0.36992102E-11_JPRB, 0.37248100E-11_JPRB, 0.37845777E-11_JPRB, &
  & 0.38976266E-11_JPRB, 0.40889128E-11_JPRB, 0.44084302E-11_JPRB, 0.48167659E-11_JPRB, 0.52383310E-11_JPRB, 0.55441073E-11_JPRB, &
  & 0.56655475E-11_JPRB, 0.56094435E-11_JPRB, 0.53473294E-11_JPRB, 0.49486192E-11_JPRB, 0.45072774E-11_JPRB, 0.40625394E-11_JPRB, &
  & 0.37123416E-11_JPRB, 0.34832118E-11_JPRB, 0.33530242E-11_JPRB, 0.32892079E-11_JPRB, 0.32637417E-11_JPRB, 0.32524350E-11_JPRB, &
  & 0.32558658E-11_JPRB, 0.32952907E-11_JPRB, 0.33936380E-11_JPRB, 0.35821274E-11_JPRB, 0.38808718E-11_JPRB, 0.42567460E-11_JPRB, &
  & 0.47009822E-11_JPRB, 0.51565171E-11_JPRB, 0.55670052E-11_JPRB, 0.58547646E-11_JPRB, 0.59886809E-11_JPRB, 0.59209642E-11_JPRB, &
  & 0.56873161E-11_JPRB, 0.53804006E-11_JPRB, 0.50693152E-11_JPRB, 0.48695349E-11_JPRB, 0.46066345E-11_JPRB, 0.43258643E-11_JPRB, &
  & 0.40970092E-11_JPRB, 0.38340212E-11_JPRB, 0.36777981E-11_JPRB, 0.35332423E-11_JPRB, 0.34748430E-11_JPRB, 0.34062373E-11_JPRB, &
  & 0.33913573E-11_JPRB, 0.34109412E-11_JPRB, 0.39677068E-11_JPRB, 0.40614556E-11_JPRB, 0.41360439E-11_JPRB, 0.42228378E-11_JPRB, &
  & 0.43156347E-11_JPRB, 0.44027147E-11_JPRB, 0.45233700E-11_JPRB, 0.46620377E-11_JPRB /)

RGHG4(:,62, 3) = (/ &
  & 0.51096575E-11_JPRB, 0.34831246E-11_JPRB, 0.35557659E-11_JPRB, 0.36043922E-11_JPRB, 0.37286888E-11_JPRB, 0.38755145E-11_JPRB, &
  & 0.40427219E-11_JPRB, 0.41492222E-11_JPRB, 0.39411196E-11_JPRB, 0.39903736E-11_JPRB, 0.40304947E-11_JPRB, 0.40985440E-11_JPRB, &
  & 0.42190036E-11_JPRB, 0.44309565E-11_JPRB, 0.47296733E-11_JPRB, 0.50952935E-11_JPRB, 0.54556503E-11_JPRB, 0.57215907E-11_JPRB, &
  & 0.58415386E-11_JPRB, 0.57848604E-11_JPRB, 0.55371497E-11_JPRB, 0.51673158E-11_JPRB, 0.47402425E-11_JPRB, 0.43325729E-11_JPRB, &
  & 0.40246547E-11_JPRB, 0.38379759E-11_JPRB, 0.37457580E-11_JPRB, 0.37130381E-11_JPRB, 0.37082655E-11_JPRB, 0.37067966E-11_JPRB, &
  & 0.37076904E-11_JPRB, 0.37352448E-11_JPRB, 0.38160547E-11_JPRB, 0.39839525E-11_JPRB, 0.42651893E-11_JPRB, 0.46329611E-11_JPRB, &
  & 0.50737283E-11_JPRB, 0.55321867E-11_JPRB, 0.59493855E-11_JPRB, 0.62547103E-11_JPRB, 0.64121972E-11_JPRB, 0.63938499E-11_JPRB, &
  & 0.62154305E-11_JPRB, 0.59792171E-11_JPRB, 0.57310233E-11_JPRB, 0.55836668E-11_JPRB, 0.53699415E-11_JPRB, 0.51199921E-11_JPRB, &
  & 0.48759733E-11_JPRB, 0.45691658E-11_JPRB, 0.43317537E-11_JPRB, 0.41529015E-11_JPRB, 0.40440663E-11_JPRB, 0.39500334E-11_JPRB, &
  & 0.39166404E-11_JPRB, 0.39324472E-11_JPRB, 0.44676775E-11_JPRB, 0.45698419E-11_JPRB, 0.46350202E-11_JPRB, 0.47140057E-11_JPRB, &
  & 0.48008125E-11_JPRB, 0.48869801E-11_JPRB, 0.49992285E-11_JPRB, 0.50973158E-11_JPRB /)

RGHG4(:,63, 3) = (/ &
  & 0.51890532E-11_JPRB, 0.36418191E-11_JPRB, 0.37496438E-11_JPRB, 0.37995440E-11_JPRB, 0.39367997E-11_JPRB, 0.41132020E-11_JPRB, &
  & 0.43230311E-11_JPRB, 0.44876112E-11_JPRB, 0.43300689E-11_JPRB, 0.43991568E-11_JPRB, 0.44618007E-11_JPRB, 0.45456156E-11_JPRB, &
  & 0.46725844E-11_JPRB, 0.48650827E-11_JPRB, 0.51233497E-11_JPRB, 0.54194509E-11_JPRB, 0.57095669E-11_JPRB, 0.59440408E-11_JPRB, &
  & 0.60413215E-11_JPRB, 0.59802818E-11_JPRB, 0.57472638E-11_JPRB, 0.53997327E-11_JPRB, 0.50116404E-11_JPRB, 0.46551265E-11_JPRB, &
  & 0.44022876E-11_JPRB, 0.42658021E-11_JPRB, 0.42193571E-11_JPRB, 0.42248193E-11_JPRB, 0.42459283E-11_JPRB, 0.42567187E-11_JPRB, &
  & 0.42565990E-11_JPRB, 0.42685031E-11_JPRB, 0.43235385E-11_JPRB, 0.44624252E-11_JPRB, 0.47121369E-11_JPRB, 0.50629826E-11_JPRB, &
  & 0.54956612E-11_JPRB, 0.59553950E-11_JPRB, 0.63841606E-11_JPRB, 0.67135420E-11_JPRB, 0.69053613E-11_JPRB, 0.69416270E-11_JPRB, &
  & 0.68350260E-11_JPRB, 0.66776220E-11_JPRB, 0.65116137E-11_JPRB, 0.64313515E-11_JPRB, 0.62941948E-11_JPRB, 0.60999730E-11_JPRB, &
  & 0.58842865E-11_JPRB, 0.55585475E-11_JPRB, 0.52615269E-11_JPRB, 0.50296516E-11_JPRB, 0.48589782E-11_JPRB, 0.47275192E-11_JPRB, &
  & 0.46634007E-11_JPRB, 0.46764029E-11_JPRB, 0.51961612E-11_JPRB, 0.52982978E-11_JPRB, 0.53550957E-11_JPRB, 0.54241060E-11_JPRB, &
  & 0.55002461E-11_JPRB, 0.55784847E-11_JPRB, 0.56726065E-11_JPRB, 0.57186673E-11_JPRB /)

RGHG4(:,64, 3) = (/ &
  & 0.53625732E-11_JPRB, 0.38950124E-11_JPRB, 0.40192875E-11_JPRB, 0.40947818E-11_JPRB, 0.42480850E-11_JPRB, 0.44629994E-11_JPRB, &
  & 0.47387667E-11_JPRB, 0.49547545E-11_JPRB, 0.48599362E-11_JPRB, 0.49464504E-11_JPRB, 0.50098818E-11_JPRB, 0.50916029E-11_JPRB, &
  & 0.51991710E-11_JPRB, 0.53529121E-11_JPRB, 0.55474592E-11_JPRB, 0.57745649E-11_JPRB, 0.60069961E-11_JPRB, 0.61919792E-11_JPRB, &
  & 0.62687633E-11_JPRB, 0.62129247E-11_JPRB, 0.60003213E-11_JPRB, 0.56846082E-11_JPRB, 0.53408549E-11_JPRB, 0.50448400E-11_JPRB, &
  & 0.48592515E-11_JPRB, 0.47857200E-11_JPRB, 0.47951825E-11_JPRB, 0.48450584E-11_JPRB, 0.48963411E-11_JPRB, 0.49239193E-11_JPRB, &
  & 0.49244515E-11_JPRB, 0.49191276E-11_JPRB, 0.49425121E-11_JPRB, 0.50406298E-11_JPRB, 0.52544379E-11_JPRB, 0.55789297E-11_JPRB, &
  & 0.59961801E-11_JPRB, 0.64542273E-11_JPRB, 0.68934858E-11_JPRB, 0.72489710E-11_JPRB, 0.74825779E-11_JPRB, 0.75858434E-11_JPRB, &
  & 0.75568432E-11_JPRB, 0.74906470E-11_JPRB, 0.74148023E-11_JPRB, 0.74087351E-11_JPRB, 0.73583535E-11_JPRB, 0.72302711E-11_JPRB, &
  & 0.70719953E-11_JPRB, 0.67707884E-11_JPRB, 0.64584614E-11_JPRB, 0.62106869E-11_JPRB, 0.59760382E-11_JPRB, 0.58012020E-11_JPRB, &
  & 0.56914798E-11_JPRB, 0.56979859E-11_JPRB, 0.62201212E-11_JPRB, 0.63178018E-11_JPRB, 0.63513114E-11_JPRB, 0.63934318E-11_JPRB, &
  & 0.64489785E-11_JPRB, 0.65152601E-11_JPRB, 0.65840952E-11_JPRB, 0.65502911E-11_JPRB /)

RGHG4(:,65, 3) = (/ &
  & 0.56115451E-11_JPRB, 0.42168742E-11_JPRB, 0.43870081E-11_JPRB, 0.44768455E-11_JPRB, 0.46608594E-11_JPRB, 0.49143623E-11_JPRB, &
  & 0.52474119E-11_JPRB, 0.55530597E-11_JPRB, 0.54942995E-11_JPRB, 0.55983326E-11_JPRB, 0.56565382E-11_JPRB, 0.57176802E-11_JPRB, &
  & 0.57877089E-11_JPRB, 0.58914579E-11_JPRB, 0.60271037E-11_JPRB, 0.61849354E-11_JPRB, 0.63551204E-11_JPRB, 0.64987694E-11_JPRB, &
  & 0.65589734E-11_JPRB, 0.65007691E-11_JPRB, 0.63074893E-11_JPRB, 0.60358298E-11_JPRB, 0.57525382E-11_JPRB, 0.55349948E-11_JPRB, &
  & 0.54257774E-11_JPRB, 0.54203699E-11_JPRB, 0.54911440E-11_JPRB, 0.55889373E-11_JPRB, 0.56741031E-11_JPRB, 0.57221966E-11_JPRB, &
  & 0.57281467E-11_JPRB, 0.57090504E-11_JPRB, 0.56983316E-11_JPRB, 0.57540574E-11_JPRB, 0.59183717E-11_JPRB, 0.62091651E-11_JPRB, &
  & 0.66037401E-11_JPRB, 0.70557527E-11_JPRB, 0.75037147E-11_JPRB, 0.78859775E-11_JPRB, 0.81674017E-11_JPRB, 0.83412530E-11_JPRB, &
  & 0.83993645E-11_JPRB, 0.84307327E-11_JPRB, 0.84601683E-11_JPRB, 0.85440934E-11_JPRB, 0.85853763E-11_JPRB, 0.85422181E-11_JPRB, &
  & 0.84487608E-11_JPRB, 0.81995686E-11_JPRB, 0.79140782E-11_JPRB, 0.76757012E-11_JPRB, 0.74064669E-11_JPRB, 0.71912402E-11_JPRB, &
  & 0.70346099E-11_JPRB, 0.70463440E-11_JPRB, 0.75853334E-11_JPRB, 0.76672089E-11_JPRB, 0.76673442E-11_JPRB, 0.76684076E-11_JPRB, &
  & 0.76954111E-11_JPRB, 0.77395026E-11_JPRB, 0.77711110E-11_JPRB, 0.76318474E-11_JPRB /)

RGHG4(:,66, 3) = (/ &
  & 0.59108204E-11_JPRB, 0.46304540E-11_JPRB, 0.48499026E-11_JPRB, 0.49801062E-11_JPRB, 0.51969115E-11_JPRB, 0.55087180E-11_JPRB, &
  & 0.59141767E-11_JPRB, 0.62783043E-11_JPRB, 0.62551973E-11_JPRB, 0.63305563E-11_JPRB, 0.63541681E-11_JPRB, 0.63782712E-11_JPRB, &
  & 0.64117661E-11_JPRB, 0.64640593E-11_JPRB, 0.65492629E-11_JPRB, 0.66518392E-11_JPRB, 0.67775594E-11_JPRB, 0.68786517E-11_JPRB, &
  & 0.69189181E-11_JPRB, 0.68677702E-11_JPRB, 0.67056755E-11_JPRB, 0.64842580E-11_JPRB, 0.62743855E-11_JPRB, 0.61370358E-11_JPRB, &
  & 0.61097984E-11_JPRB, 0.61823741E-11_JPRB, 0.63180038E-11_JPRB, 0.64677716E-11_JPRB, 0.65902930E-11_JPRB, 0.66633283E-11_JPRB, &
  & 0.66790024E-11_JPRB, 0.66494666E-11_JPRB, 0.66082686E-11_JPRB, 0.66172710E-11_JPRB, 0.67379544E-11_JPRB, 0.69908059E-11_JPRB, &
  & 0.73580022E-11_JPRB, 0.77990583E-11_JPRB, 0.82515383E-11_JPRB, 0.86582833E-11_JPRB, 0.89906554E-11_JPRB, 0.92425703E-11_JPRB, &
  & 0.93914590E-11_JPRB, 0.95277345E-11_JPRB, 0.96626830E-11_JPRB, 0.98439677E-11_JPRB, 0.99799084E-11_JPRB, 0.10018702E-10_JPRB, &
  & 0.99940455E-11_JPRB, 0.98093287E-11_JPRB, 0.95778697E-11_JPRB, 0.93866729E-11_JPRB, 0.91246810E-11_JPRB, 0.89158403E-11_JPRB, &
  & 0.87144059E-11_JPRB, 0.87492400E-11_JPRB, 0.93304574E-11_JPRB, 0.94019324E-11_JPRB, 0.93548832E-11_JPRB, 0.92930871E-11_JPRB, &
  & 0.92781520E-11_JPRB, 0.92941791E-11_JPRB, 0.92713320E-11_JPRB, 0.89851919E-11_JPRB /)

RGHG4(:,67, 3) = (/ &
  & 0.62815512E-11_JPRB, 0.51284055E-11_JPRB, 0.54248216E-11_JPRB, 0.55960436E-11_JPRB, 0.58624334E-11_JPRB, 0.62197842E-11_JPRB, &
  & 0.66959680E-11_JPRB, 0.71174555E-11_JPRB, 0.70756764E-11_JPRB, 0.71256365E-11_JPRB, 0.71096046E-11_JPRB, 0.71005883E-11_JPRB, &
  & 0.71086327E-11_JPRB, 0.71204743E-11_JPRB, 0.71638398E-11_JPRB, 0.72119602E-11_JPRB, 0.72875100E-11_JPRB, 0.73547782E-11_JPRB, &
  & 0.73867258E-11_JPRB, 0.73454819E-11_JPRB, 0.72200466E-11_JPRB, 0.70639965E-11_JPRB, 0.69323236E-11_JPRB, 0.68900567E-11_JPRB, &
  & 0.69487480E-11_JPRB, 0.70954284E-11_JPRB, 0.72931687E-11_JPRB, 0.74959240E-11_JPRB, 0.76586584E-11_JPRB, 0.77605760E-11_JPRB, &
  & 0.77929165E-11_JPRB, 0.77615423E-11_JPRB, 0.76938681E-11_JPRB, 0.76658541E-11_JPRB, 0.77389796E-11_JPRB, 0.79568435E-11_JPRB, &
  & 0.82987176E-11_JPRB, 0.87257562E-11_JPRB, 0.91807239E-11_JPRB, 0.96105493E-11_JPRB, 0.99951601E-11_JPRB, 0.10327885E-10_JPRB, &
  & 0.10570361E-10_JPRB, 0.10814041E-10_JPRB, 0.11061109E-10_JPRB, 0.11347794E-10_JPRB, 0.11575963E-10_JPRB, 0.11725204E-10_JPRB, &
  & 0.11773086E-10_JPRB, 0.11661035E-10_JPRB, 0.11479280E-10_JPRB, 0.11331242E-10_JPRB, 0.11098829E-10_JPRB, 0.10905834E-10_JPRB, &
  & 0.10708526E-10_JPRB, 0.10798540E-10_JPRB, 0.11463340E-10_JPRB, 0.11523806E-10_JPRB, 0.11431840E-10_JPRB, 0.11303887E-10_JPRB, &
  & 0.11244347E-10_JPRB, 0.11231301E-10_JPRB, 0.11131631E-10_JPRB, 0.10662879E-10_JPRB /)

RGHG4(:,68, 3) = (/ &
  & 0.66985657E-11_JPRB, 0.57259982E-11_JPRB, 0.61126802E-11_JPRB, 0.63436058E-11_JPRB, 0.66526602E-11_JPRB, 0.70830746E-11_JPRB, &
  & 0.75966889E-11_JPRB, 0.80406558E-11_JPRB, 0.79717240E-11_JPRB, 0.79551799E-11_JPRB, 0.79124190E-11_JPRB, 0.78728222E-11_JPRB, &
  & 0.78617599E-11_JPRB, 0.78413057E-11_JPRB, 0.78531018E-11_JPRB, 0.78714830E-11_JPRB, 0.79214196E-11_JPRB, 0.79646871E-11_JPRB, &
  & 0.79899828E-11_JPRB, 0.79673230E-11_JPRB, 0.78864580E-11_JPRB, 0.77967320E-11_JPRB, 0.77534637E-11_JPRB, 0.77947327E-11_JPRB, &
  & 0.79408043E-11_JPRB, 0.81692058E-11_JPRB, 0.84369525E-11_JPRB, 0.86960439E-11_JPRB, 0.89027492E-11_JPRB, 0.90372588E-11_JPRB, &
  & 0.90907438E-11_JPRB, 0.90633785E-11_JPRB, 0.89813799E-11_JPRB, 0.89239232E-11_JPRB, 0.89615138E-11_JPRB, 0.91465177E-11_JPRB, &
  & 0.94633433E-11_JPRB, 0.98778138E-11_JPRB, 0.10333436E-10_JPRB, 0.10787701E-10_JPRB, 0.11226885E-10_JPRB, 0.11643025E-10_JPRB, &
  & 0.11980932E-10_JPRB, 0.12334541E-10_JPRB, 0.12687535E-10_JPRB, 0.13081889E-10_JPRB, 0.13412312E-10_JPRB, 0.13638159E-10_JPRB, &
  & 0.13761784E-10_JPRB, 0.13727230E-10_JPRB, 0.13617185E-10_JPRB, 0.13529228E-10_JPRB, 0.13342766E-10_JPRB, 0.13181008E-10_JPRB, &
  & 0.12990956E-10_JPRB, 0.13127305E-10_JPRB, 0.13912785E-10_JPRB, 0.14027886E-10_JPRB, 0.13923519E-10_JPRB, 0.13716594E-10_JPRB, &
  & 0.13621396E-10_JPRB, 0.13600687E-10_JPRB, 0.13412460E-10_JPRB, 0.12718007E-10_JPRB /)

RGHG4(:,69, 3) = (/ &
  & 0.71596271E-11_JPRB, 0.64143916E-11_JPRB, 0.69139737E-11_JPRB, 0.72035585E-11_JPRB, 0.75680850E-11_JPRB, 0.80368785E-11_JPRB, &
  & 0.85863339E-11_JPRB, 0.90334693E-11_JPRB, 0.89178612E-11_JPRB, 0.88549888E-11_JPRB, 0.87994447E-11_JPRB, 0.87471141E-11_JPRB, &
  & 0.87298250E-11_JPRB, 0.86959606E-11_JPRB, 0.86807254E-11_JPRB, 0.86697064E-11_JPRB, 0.86906567E-11_JPRB, 0.87229841E-11_JPRB, &
  & 0.87558684E-11_JPRB, 0.87602208E-11_JPRB, 0.87319024E-11_JPRB, 0.87160869E-11_JPRB, 0.87565710E-11_JPRB, 0.89006233E-11_JPRB, &
  & 0.91393681E-11_JPRB, 0.94429655E-11_JPRB, 0.97760255E-11_JPRB, 0.10092772E-10_JPRB, 0.10347252E-10_JPRB, 0.10521404E-10_JPRB, &
  & 0.10607515E-10_JPRB, 0.10596713E-10_JPRB, 0.10506106E-10_JPRB, 0.10426131E-10_JPRB, 0.10436712E-10_JPRB, 0.10596944E-10_JPRB, &
  & 0.10898741E-10_JPRB, 0.11302558E-10_JPRB, 0.11762906E-10_JPRB, 0.12243755E-10_JPRB, 0.12741141E-10_JPRB, 0.13241751E-10_JPRB, &
  & 0.13676927E-10_JPRB, 0.14139637E-10_JPRB, 0.14601254E-10_JPRB, 0.15094604E-10_JPRB, 0.15525491E-10_JPRB, 0.15865023E-10_JPRB, &
  & 0.16073245E-10_JPRB, 0.16112237E-10_JPRB, 0.16061607E-10_JPRB, 0.16020857E-10_JPRB, 0.15887645E-10_JPRB, 0.15761845E-10_JPRB, &
  & 0.15603970E-10_JPRB, 0.15805858E-10_JPRB, 0.16701210E-10_JPRB, 0.16869188E-10_JPRB, 0.16778769E-10_JPRB, 0.16568295E-10_JPRB, &
  & 0.16467328E-10_JPRB, 0.16469935E-10_JPRB, 0.16175838E-10_JPRB, 0.15256399E-10_JPRB /)

RGHG4(:,70, 3) = (/ &
  & 0.76271559E-11_JPRB, 0.72153676E-11_JPRB, 0.78450779E-11_JPRB, 0.81928414E-11_JPRB, 0.85851725E-11_JPRB, 0.90881582E-11_JPRB, &
  & 0.96569714E-11_JPRB, 0.10106426E-10_JPRB, 0.99260470E-11_JPRB, 0.98336166E-11_JPRB, 0.97680085E-11_JPRB, 0.97099924E-11_JPRB, &
  & 0.96857392E-11_JPRB, 0.96524646E-11_JPRB, 0.96327816E-11_JPRB, 0.96215258E-11_JPRB, 0.96421413E-11_JPRB, 0.96730575E-11_JPRB, &
  & 0.97188204E-11_JPRB, 0.97566894E-11_JPRB, 0.97830216E-11_JPRB, 0.98437682E-11_JPRB, 0.99768960E-11_JPRB, 0.10201002E-10_JPRB, &
  & 0.10523288E-10_JPRB, 0.10915061E-10_JPRB, 0.11323906E-10_JPRB, 0.11704443E-10_JPRB, 0.12013046E-10_JPRB, 0.12233770E-10_JPRB, &
  & 0.12359127E-10_JPRB, 0.12371634E-10_JPRB, 0.12292795E-10_JPRB, 0.12208966E-10_JPRB, 0.12207192E-10_JPRB, 0.12356979E-10_JPRB, &
  & 0.12649191E-10_JPRB, 0.13049531E-10_JPRB, 0.13518061E-10_JPRB, 0.14030473E-10_JPRB, 0.14589798E-10_JPRB, 0.15177014E-10_JPRB, &
  & 0.15713764E-10_JPRB, 0.16282335E-10_JPRB, 0.16847813E-10_JPRB, 0.17453834E-10_JPRB, 0.17985365E-10_JPRB, 0.18379069E-10_JPRB, &
  & 0.18672517E-10_JPRB, 0.18787688E-10_JPRB, 0.18813374E-10_JPRB, 0.18848407E-10_JPRB, 0.18766174E-10_JPRB, 0.18703010E-10_JPRB, &
  & 0.18562285E-10_JPRB, 0.18848508E-10_JPRB, 0.19868230E-10_JPRB, 0.20106137E-10_JPRB, 0.20038882E-10_JPRB, 0.19817233E-10_JPRB, &
  & 0.19723423E-10_JPRB, 0.19773898E-10_JPRB, 0.19462064E-10_JPRB, 0.18260707E-10_JPRB /)

RGHG4(:,71, 3) = (/ &
  & 0.81370813E-11_JPRB, 0.80999365E-11_JPRB, 0.88813115E-11_JPRB, 0.92844161E-11_JPRB, 0.97118693E-11_JPRB, 0.10239162E-10_JPRB, &
  & 0.10812058E-10_JPRB, 0.11255403E-10_JPRB, 0.11020945E-10_JPRB, 0.10927282E-10_JPRB, 0.10873486E-10_JPRB, 0.10836016E-10_JPRB, &
  & 0.10821845E-10_JPRB, 0.10797857E-10_JPRB, 0.10780276E-10_JPRB, 0.10759832E-10_JPRB, 0.10777435E-10_JPRB, 0.10823750E-10_JPRB, &
  & 0.10895781E-10_JPRB, 0.10978948E-10_JPRB, 0.11070727E-10_JPRB, 0.11210769E-10_JPRB, 0.11430327E-10_JPRB, 0.11767714E-10_JPRB, &
  & 0.12193909E-10_JPRB, 0.12664159E-10_JPRB, 0.13143118E-10_JPRB, 0.13587926E-10_JPRB, 0.13956094E-10_JPRB, 0.14233946E-10_JPRB, &
  & 0.14416273E-10_JPRB, 0.14470011E-10_JPRB, 0.14407382E-10_JPRB, 0.14327823E-10_JPRB, 0.14322706E-10_JPRB, 0.14477834E-10_JPRB, &
  & 0.14771828E-10_JPRB, 0.15175281E-10_JPRB, 0.15658412E-10_JPRB, 0.16205690E-10_JPRB, 0.16830350E-10_JPRB, 0.17504852E-10_JPRB, &
  & 0.18139044E-10_JPRB, 0.18817441E-10_JPRB, 0.19476882E-10_JPRB, 0.20195111E-10_JPRB, 0.20809368E-10_JPRB, 0.21321056E-10_JPRB, &
  & 0.21696922E-10_JPRB, 0.21881691E-10_JPRB, 0.21970672E-10_JPRB, 0.22070066E-10_JPRB, 0.22036248E-10_JPRB, 0.22048046E-10_JPRB, &
  & 0.21948221E-10_JPRB, 0.22309102E-10_JPRB, 0.23425704E-10_JPRB, 0.23736775E-10_JPRB, 0.23720125E-10_JPRB, 0.23540940E-10_JPRB, &
  & 0.23477942E-10_JPRB, 0.23578960E-10_JPRB, 0.23270174E-10_JPRB, 0.21896930E-10_JPRB /)

RGHG4(:,72, 3) = (/ &
  & 0.86414426E-11_JPRB, 0.91551107E-11_JPRB, 0.10065118E-10_JPRB, 0.10513888E-10_JPRB, 0.10946848E-10_JPRB, 0.11486997E-10_JPRB, &
  & 0.12064804E-10_JPRB, 0.12492398E-10_JPRB, 0.12226393E-10_JPRB, 0.12154019E-10_JPRB, 0.12105812E-10_JPRB, 0.12096556E-10_JPRB, &
  & 0.12097850E-10_JPRB, 0.12094905E-10_JPRB, 0.12101369E-10_JPRB, 0.12116820E-10_JPRB, 0.12153203E-10_JPRB, 0.12221731E-10_JPRB, &
  & 0.12325143E-10_JPRB, 0.12460958E-10_JPRB, 0.12622067E-10_JPRB, 0.12852606E-10_JPRB, 0.13173078E-10_JPRB, 0.13589295E-10_JPRB, &
  & 0.14098298E-10_JPRB, 0.14665132E-10_JPRB, 0.15233320E-10_JPRB, 0.15758289E-10_JPRB, 0.16194757E-10_JPRB, 0.16534283E-10_JPRB, &
  & 0.16774533E-10_JPRB, 0.16878526E-10_JPRB, 0.16874724E-10_JPRB, 0.16828849E-10_JPRB, 0.16842720E-10_JPRB, 0.17017618E-10_JPRB, &
  & 0.17324571E-10_JPRB, 0.17740661E-10_JPRB, 0.18243865E-10_JPRB, 0.18830626E-10_JPRB, 0.19521914E-10_JPRB, 0.20278803E-10_JPRB, &
  & 0.21013106E-10_JPRB, 0.21785879E-10_JPRB, 0.22543365E-10_JPRB, 0.23376337E-10_JPRB, 0.24071670E-10_JPRB, 0.24626159E-10_JPRB, &
  & 0.25077839E-10_JPRB, 0.25353067E-10_JPRB, 0.25526909E-10_JPRB, 0.25709797E-10_JPRB, 0.25755008E-10_JPRB, 0.25829209E-10_JPRB, &
  & 0.25802823E-10_JPRB, 0.26215237E-10_JPRB, 0.27430114E-10_JPRB, 0.27807909E-10_JPRB, 0.27838494E-10_JPRB, 0.27699910E-10_JPRB, &
  & 0.27680145E-10_JPRB, 0.27830835E-10_JPRB, 0.27569473E-10_JPRB, 0.26147510E-10_JPRB /)

RGHG4(:,73, 3) = (/ &
  & 0.93347673E-11_JPRB, 0.10336587E-10_JPRB, 0.11399721E-10_JPRB, 0.11854577E-10_JPRB, 0.12292725E-10_JPRB, 0.12824383E-10_JPRB, &
  & 0.13396349E-10_JPRB, 0.13814553E-10_JPRB, 0.13546521E-10_JPRB, 0.13523278E-10_JPRB, 0.13532328E-10_JPRB, 0.13561331E-10_JPRB, &
  & 0.13600354E-10_JPRB, 0.13631088E-10_JPRB, 0.13652128E-10_JPRB, 0.13679303E-10_JPRB, 0.13745045E-10_JPRB, 0.13854754E-10_JPRB, &
  & 0.14008778E-10_JPRB, 0.14212059E-10_JPRB, 0.14457940E-10_JPRB, 0.14783685E-10_JPRB, 0.15203035E-10_JPRB, 0.15754497E-10_JPRB, &
  & 0.16392439E-10_JPRB, 0.17052247E-10_JPRB, 0.17702060E-10_JPRB, 0.18302646E-10_JPRB, 0.18815179E-10_JPRB, 0.19233443E-10_JPRB, &
  & 0.19559156E-10_JPRB, 0.19738679E-10_JPRB, 0.19779785E-10_JPRB, 0.19761304E-10_JPRB, 0.19826526E-10_JPRB, 0.20028295E-10_JPRB, &
  & 0.20363796E-10_JPRB, 0.20795875E-10_JPRB, 0.21319915E-10_JPRB, 0.21946932E-10_JPRB, 0.22701542E-10_JPRB, 0.23537583E-10_JPRB, &
  & 0.24353285E-10_JPRB, 0.25223011E-10_JPRB, 0.26065828E-10_JPRB, 0.27001054E-10_JPRB, 0.27752871E-10_JPRB, 0.28427403E-10_JPRB, &
  & 0.28959370E-10_JPRB, 0.29293998E-10_JPRB, 0.29527339E-10_JPRB, 0.29791974E-10_JPRB, 0.29906296E-10_JPRB, 0.30051520E-10_JPRB, &
  & 0.30093646E-10_JPRB, 0.30567372E-10_JPRB, 0.31810544E-10_JPRB, 0.32248707E-10_JPRB, 0.32328529E-10_JPRB, 0.32244978E-10_JPRB, &
  & 0.32282399E-10_JPRB, 0.32462977E-10_JPRB, 0.32233816E-10_JPRB, 0.30773908E-10_JPRB /)

RGHG4(:,74, 3) = (/ &
  & 0.10298382E-10_JPRB, 0.11772392E-10_JPRB, 0.12868328E-10_JPRB, 0.13310463E-10_JPRB, 0.13723411E-10_JPRB, 0.14246134E-10_JPRB, &
  & 0.14818230E-10_JPRB, 0.15237075E-10_JPRB, 0.14989466E-10_JPRB, 0.15035469E-10_JPRB, 0.15073016E-10_JPRB, 0.15170542E-10_JPRB, &
  & 0.15251210E-10_JPRB, 0.15331070E-10_JPRB, 0.15409033E-10_JPRB, 0.15501829E-10_JPRB, 0.15612145E-10_JPRB, 0.15773749E-10_JPRB, &
  & 0.15986618E-10_JPRB, 0.16270272E-10_JPRB, 0.16610513E-10_JPRB, 0.17051487E-10_JPRB, 0.17595479E-10_JPRB, 0.18228334E-10_JPRB, &
  & 0.18948239E-10_JPRB, 0.19716848E-10_JPRB, 0.20473349E-10_JPRB, 0.21174397E-10_JPRB, 0.21774887E-10_JPRB, 0.22272781E-10_JPRB, &
  & 0.22673833E-10_JPRB, 0.22938842E-10_JPRB, 0.23098150E-10_JPRB, 0.23188968E-10_JPRB, 0.23327812E-10_JPRB, 0.23577317E-10_JPRB, &
  & 0.23949063E-10_JPRB, 0.24406754E-10_JPRB, 0.24955475E-10_JPRB, 0.25622797E-10_JPRB, 0.26440275E-10_JPRB, 0.27341488E-10_JPRB, &
  & 0.28234547E-10_JPRB, 0.29172175E-10_JPRB, 0.30108149E-10_JPRB, 0.31091539E-10_JPRB, 0.31928005E-10_JPRB, 0.32633313E-10_JPRB, &
  & 0.33215732E-10_JPRB, 0.33642693E-10_JPRB, 0.33963620E-10_JPRB, 0.34332325E-10_JPRB, 0.34529213E-10_JPRB, 0.34740329E-10_JPRB, &
  & 0.34861825E-10_JPRB, 0.35357058E-10_JPRB, 0.36626171E-10_JPRB, 0.37086448E-10_JPRB, 0.37199122E-10_JPRB, 0.37168234E-10_JPRB, &
  & 0.37266655E-10_JPRB, 0.37482305E-10_JPRB, 0.37264507E-10_JPRB, 0.35738284E-10_JPRB /)

RGHG4(:,75, 3) = (/ &
  & 0.11700043E-10_JPRB, 0.13318619E-10_JPRB, 0.14443492E-10_JPRB, 0.14834486E-10_JPRB, 0.15228169E-10_JPRB, 0.15732422E-10_JPRB, &
  & 0.16307920E-10_JPRB, 0.16759226E-10_JPRB, 0.16564231E-10_JPRB, 0.16700630E-10_JPRB, 0.16863389E-10_JPRB, 0.17004292E-10_JPRB, &
  & 0.17166855E-10_JPRB, 0.17304930E-10_JPRB, 0.17425547E-10_JPRB, 0.17559980E-10_JPRB, 0.17738906E-10_JPRB, 0.17976034E-10_JPRB, &
  & 0.18276110E-10_JPRB, 0.18660105E-10_JPRB, 0.19118478E-10_JPRB, 0.19676613E-10_JPRB, 0.20345274E-10_JPRB, 0.21148923E-10_JPRB, &
  & 0.22038512E-10_JPRB, 0.22933107E-10_JPRB, 0.23799849E-10_JPRB, 0.24598852E-10_JPRB, 0.25300375E-10_JPRB, 0.25904045E-10_JPRB, &
  & 0.26425485E-10_JPRB, 0.26797861E-10_JPRB, 0.27017697E-10_JPRB, 0.27172853E-10_JPRB, 0.27398779E-10_JPRB, 0.27725613E-10_JPRB, &
  & 0.28144521E-10_JPRB, 0.28635158E-10_JPRB, 0.29213583E-10_JPRB, 0.29926232E-10_JPRB, 0.30797299E-10_JPRB, 0.31745984E-10_JPRB, &
  & 0.32692234E-10_JPRB, 0.33698058E-10_JPRB, 0.34698591E-10_JPRB, 0.35717006E-10_JPRB, 0.36624884E-10_JPRB, 0.37422475E-10_JPRB, &
  & 0.38079668E-10_JPRB, 0.38537326E-10_JPRB, 0.38918688E-10_JPRB, 0.39365559E-10_JPRB, 0.39642446E-10_JPRB, 0.39909635E-10_JPRB, &
  & 0.40084380E-10_JPRB, 0.40615723E-10_JPRB, 0.41857358E-10_JPRB, 0.42341432E-10_JPRB, 0.42479974E-10_JPRB, 0.42497481E-10_JPRB, &
  & 0.42662342E-10_JPRB, 0.42917791E-10_JPRB, 0.42701759E-10_JPRB, 0.41062678E-10_JPRB /)

RGHG4(:,76, 3) = (/ &
  & 0.13596425E-10_JPRB, 0.15011976E-10_JPRB, 0.16090136E-10_JPRB, 0.16419269E-10_JPRB, 0.16774172E-10_JPRB, 0.17272579E-10_JPRB, &
  & 0.17865690E-10_JPRB, 0.18360632E-10_JPRB, 0.18230700E-10_JPRB, 0.18458872E-10_JPRB, 0.18664731E-10_JPRB, 0.18925283E-10_JPRB, &
  & 0.19155483E-10_JPRB, 0.19395137E-10_JPRB, 0.19637248E-10_JPRB, 0.19877558E-10_JPRB, 0.20147741E-10_JPRB, 0.20479609E-10_JPRB, &
  & 0.20884116E-10_JPRB, 0.21393588E-10_JPRB, 0.21984302E-10_JPRB, 0.22692700E-10_JPRB, 0.23514839E-10_JPRB, 0.24402178E-10_JPRB, &
  & 0.25353507E-10_JPRB, 0.26343006E-10_JPRB, 0.27317424E-10_JPRB, 0.28230446E-10_JPRB, 0.29039073E-10_JPRB, 0.29746039E-10_JPRB, &
  & 0.30369710E-10_JPRB, 0.30875212E-10_JPRB, 0.31326455E-10_JPRB, 0.31715238E-10_JPRB, 0.32072293E-10_JPRB, 0.32500991E-10_JPRB, &
  & 0.32975393E-10_JPRB, 0.33508602E-10_JPRB, 0.34122864E-10_JPRB, 0.34880362E-10_JPRB, 0.35796439E-10_JPRB, 0.36776145E-10_JPRB, &
  & 0.37757828E-10_JPRB, 0.38795200E-10_JPRB, 0.39832755E-10_JPRB, 0.40892987E-10_JPRB, 0.41841180E-10_JPRB, 0.42622739E-10_JPRB, &
  & 0.43280719E-10_JPRB, 0.43833617E-10_JPRB, 0.44294707E-10_JPRB, 0.44847556E-10_JPRB, 0.45222635E-10_JPRB, 0.45511581E-10_JPRB, &
  & 0.45776771E-10_JPRB, 0.46297403E-10_JPRB, 0.47489523E-10_JPRB, 0.47991666E-10_JPRB, 0.48146209E-10_JPRB, 0.48216230E-10_JPRB, &
  & 0.48462682E-10_JPRB, 0.48778311E-10_JPRB, 0.48551173E-10_JPRB, 0.46741094E-10_JPRB /)

RGHG4(:,77, 3) = (/ &
  & 0.16033071E-10_JPRB, 0.16807175E-10_JPRB, 0.17769031E-10_JPRB, 0.18025659E-10_JPRB, 0.18339160E-10_JPRB, 0.18818624E-10_JPRB, &
  & 0.19436746E-10_JPRB, 0.19999299E-10_JPRB, 0.19949318E-10_JPRB, 0.20280605E-10_JPRB, 0.20631157E-10_JPRB, 0.20938223E-10_JPRB, &
  & 0.21297936E-10_JPRB, 0.21642596E-10_JPRB, 0.21982896E-10_JPRB, 0.22340336E-10_JPRB, 0.22747451E-10_JPRB, 0.23218753E-10_JPRB, &
  & 0.23769786E-10_JPRB, 0.24425514E-10_JPRB, 0.25176533E-10_JPRB, 0.26031824E-10_JPRB, 0.26990393E-10_JPRB, 0.28077209E-10_JPRB, &
  & 0.29251171E-10_JPRB, 0.30428882E-10_JPRB, 0.31566728E-10_JPRB, 0.32622190E-10_JPRB, 0.33568807E-10_JPRB, 0.34408254E-10_JPRB, &
  & 0.35169291E-10_JPRB, 0.35821658E-10_JPRB, 0.36342769E-10_JPRB, 0.36753878E-10_JPRB, 0.37264917E-10_JPRB, 0.37824271E-10_JPRB, &
  & 0.38377853E-10_JPRB, 0.38966455E-10_JPRB, 0.39631996E-10_JPRB, 0.40430440E-10_JPRB, 0.41380475E-10_JPRB, 0.42363370E-10_JPRB, &
  & 0.43342746E-10_JPRB, 0.44369459E-10_JPRB, 0.45394664E-10_JPRB, 0.46451842E-10_JPRB, 0.47447487E-10_JPRB, 0.48279457E-10_JPRB, &
  & 0.48991092E-10_JPRB, 0.49556144E-10_JPRB, 0.50055980E-10_JPRB, 0.50637789E-10_JPRB, 0.51142781E-10_JPRB, 0.51428615E-10_JPRB, &
  & 0.51785545E-10_JPRB, 0.52294561E-10_JPRB, 0.53403979E-10_JPRB, 0.53911212E-10_JPRB, 0.54110660E-10_JPRB, 0.54232618E-10_JPRB, &
  & 0.54592855E-10_JPRB, 0.54981682E-10_JPRB, 0.54749021E-10_JPRB, 0.52761934E-10_JPRB /)

RGHG4(:,78, 3) = (/ &
  & 0.19098344E-10_JPRB, 0.18578661E-10_JPRB, 0.19389431E-10_JPRB, 0.19543481E-10_JPRB, 0.19804455E-10_JPRB, 0.20261889E-10_JPRB, &
  & 0.20897662E-10_JPRB, 0.21497554E-10_JPRB, 0.21529452E-10_JPRB, 0.21925026E-10_JPRB, 0.22284698E-10_JPRB, 0.22730866E-10_JPRB, &
  & 0.23171791E-10_JPRB, 0.23678325E-10_JPRB, 0.24207804E-10_JPRB, 0.24745150E-10_JPRB, 0.25321601E-10_JPRB, 0.25961976E-10_JPRB, &
  & 0.26679657E-10_JPRB, 0.27510038E-10_JPRB, 0.28419192E-10_JPRB, 0.29437366E-10_JPRB, 0.30520916E-10_JPRB, 0.31667523E-10_JPRB, &
  & 0.32833632E-10_JPRB, 0.34004282E-10_JPRB, 0.35154404E-10_JPRB, 0.36261959E-10_JPRB, 0.37300281E-10_JPRB, 0.38281208E-10_JPRB, &
  & 0.39218052E-10_JPRB, 0.40090074E-10_JPRB, 0.40944068E-10_JPRB, 0.41789832E-10_JPRB, 0.42552965E-10_JPRB, 0.43243242E-10_JPRB, &
  & 0.43926814E-10_JPRB, 0.44598970E-10_JPRB, 0.45341075E-10_JPRB, 0.46167643E-10_JPRB, 0.47115024E-10_JPRB, 0.48057679E-10_JPRB, &
  & 0.48964357E-10_JPRB, 0.49909951E-10_JPRB, 0.50865048E-10_JPRB, 0.51887095E-10_JPRB, 0.52854467E-10_JPRB, 0.53625940E-10_JPRB, &
  & 0.54335200E-10_JPRB, 0.54963450E-10_JPRB, 0.55575062E-10_JPRB, 0.56149765E-10_JPRB, 0.56845573E-10_JPRB, 0.57107166E-10_JPRB, &
  & 0.57570920E-10_JPRB, 0.58079708E-10_JPRB, 0.59062782E-10_JPRB, 0.59596758E-10_JPRB, 0.59887220E-10_JPRB, 0.60053400E-10_JPRB, &
  & 0.60550995E-10_JPRB, 0.61064889E-10_JPRB, 0.60955824E-10_JPRB, 0.59026367E-10_JPRB /)

RGHG4(:,79, 3) = (/ &
  & 0.22432178E-10_JPRB, 0.20035031E-10_JPRB, 0.20553764E-10_JPRB, 0.20588781E-10_JPRB, 0.20774979E-10_JPRB, 0.21181895E-10_JPRB, &
  & 0.21789364E-10_JPRB, 0.22407786E-10_JPRB, 0.22432488E-10_JPRB, 0.22869408E-10_JPRB, 0.23307734E-10_JPRB, 0.23740660E-10_JPRB, &
  & 0.24289867E-10_JPRB, 0.24881054E-10_JPRB, 0.25518447E-10_JPRB, 0.26221671E-10_JPRB, 0.26980583E-10_JPRB, 0.27792693E-10_JPRB, &
  & 0.28666333E-10_JPRB, 0.29607074E-10_JPRB, 0.30594090E-10_JPRB, 0.31608702E-10_JPRB, 0.32635693E-10_JPRB, 0.33718216E-10_JPRB, &
  & 0.34881650E-10_JPRB, 0.36049143E-10_JPRB, 0.37205242E-10_JPRB, 0.38337087E-10_JPRB, 0.39434376E-10_JPRB, 0.40501463E-10_JPRB, &
  & 0.41549087E-10_JPRB, 0.42575009E-10_JPRB, 0.43574880E-10_JPRB, 0.44482473E-10_JPRB, 0.45458057E-10_JPRB, 0.46484414E-10_JPRB, &
  & 0.47508140E-10_JPRB, 0.48413443E-10_JPRB, 0.49346700E-10_JPRB, 0.50232804E-10_JPRB, 0.51170401E-10_JPRB, 0.52017238E-10_JPRB, &
  & 0.52777793E-10_JPRB, 0.53549751E-10_JPRB, 0.54323095E-10_JPRB, 0.55178057E-10_JPRB, 0.56037005E-10_JPRB, 0.56752856E-10_JPRB, &
  & 0.57443876E-10_JPRB, 0.58055876E-10_JPRB, 0.58786864E-10_JPRB, 0.59272705E-10_JPRB, 0.60161640E-10_JPRB, 0.60489863E-10_JPRB, &
  & 0.61027496E-10_JPRB, 0.61673881E-10_JPRB, 0.62634252E-10_JPRB, 0.63191390E-10_JPRB, 0.63696923E-10_JPRB, 0.63893515E-10_JPRB, &
  & 0.64522110E-10_JPRB, 0.65311728E-10_JPRB, 0.65628912E-10_JPRB, 0.64917224E-10_JPRB /)

RGHG4(:,80, 3) = (/ &
  & 0.24683344E-10_JPRB, 0.20662121E-10_JPRB, 0.21043094E-10_JPRB, 0.21013961E-10_JPRB, 0.21177244E-10_JPRB, 0.21588370E-10_JPRB, &
  & 0.22234797E-10_JPRB, 0.22849757E-10_JPRB, 0.23008612E-10_JPRB, 0.23417384E-10_JPRB, 0.23854472E-10_JPRB, 0.24363461E-10_JPRB, &
  & 0.24909375E-10_JPRB, 0.25555438E-10_JPRB, 0.26242251E-10_JPRB, 0.26964797E-10_JPRB, 0.27735581E-10_JPRB, 0.28583658E-10_JPRB, &
  & 0.29496516E-10_JPRB, 0.30481992E-10_JPRB, 0.31511106E-10_JPRB, 0.32570259E-10_JPRB, 0.33710090E-10_JPRB, 0.34839329E-10_JPRB, &
  & 0.35971844E-10_JPRB, 0.37116001E-10_JPRB, 0.38270508E-10_JPRB, 0.39424571E-10_JPRB, 0.40554220E-10_JPRB, 0.41669269E-10_JPRB, &
  & 0.42774433E-10_JPRB, 0.43862070E-10_JPRB, 0.44935965E-10_JPRB, 0.46030089E-10_JPRB, 0.47158142E-10_JPRB, 0.48119793E-10_JPRB, &
  & 0.49098732E-10_JPRB, 0.49968071E-10_JPRB, 0.50928747E-10_JPRB, 0.51824860E-10_JPRB, 0.52760987E-10_JPRB, 0.53602203E-10_JPRB, &
  & 0.54345986E-10_JPRB, 0.55121428E-10_JPRB, 0.55919672E-10_JPRB, 0.56821502E-10_JPRB, 0.57711093E-10_JPRB, 0.58440267E-10_JPRB, &
  & 0.59145695E-10_JPRB, 0.59708814E-10_JPRB, 0.60571693E-10_JPRB, 0.60994709E-10_JPRB, 0.61843093E-10_JPRB, 0.62269419E-10_JPRB, &
  & 0.62612270E-10_JPRB, 0.63288284E-10_JPRB, 0.64177885E-10_JPRB, 0.64575512E-10_JPRB, 0.65235803E-10_JPRB, 0.65370306E-10_JPRB, &
  & 0.65946873E-10_JPRB, 0.66963719E-10_JPRB, 0.67512870E-10_JPRB, 0.68355537E-10_JPRB /)

RGHG4(:,81, 3) = (/ &
  & 0.26242619E-10_JPRB, 0.21028622E-10_JPRB, 0.21370669E-10_JPRB, 0.21320473E-10_JPRB, 0.21471269E-10_JPRB, 0.21901623E-10_JPRB, &
  & 0.22518598E-10_JPRB, 0.23215332E-10_JPRB, 0.23280197E-10_JPRB, 0.23801506E-10_JPRB, 0.24221359E-10_JPRB, 0.24723517E-10_JPRB, &
  & 0.25308837E-10_JPRB, 0.25974277E-10_JPRB, 0.26682682E-10_JPRB, 0.27468486E-10_JPRB, 0.28305181E-10_JPRB, 0.29198793E-10_JPRB, &
  & 0.30153484E-10_JPRB, 0.31168942E-10_JPRB, 0.32198813E-10_JPRB, 0.33259138E-10_JPRB, 0.34319179E-10_JPRB, 0.35387495E-10_JPRB, &
  & 0.36534567E-10_JPRB, 0.37700745E-10_JPRB, 0.38870584E-10_JPRB, 0.40037001E-10_JPRB, 0.41192681E-10_JPRB, 0.42331808E-10_JPRB, &
  & 0.43464628E-10_JPRB, 0.44583018E-10_JPRB, 0.45692568E-10_JPRB, 0.46805056E-10_JPRB, 0.47876838E-10_JPRB, 0.48970411E-10_JPRB, &
  & 0.50095945E-10_JPRB, 0.51096849E-10_JPRB, 0.52106857E-10_JPRB, 0.53050984E-10_JPRB, 0.53986426E-10_JPRB, 0.54839359E-10_JPRB, &
  & 0.55564726E-10_JPRB, 0.56326291E-10_JPRB, 0.57073870E-10_JPRB, 0.57908366E-10_JPRB, 0.58743302E-10_JPRB, 0.59423896E-10_JPRB, &
  & 0.60142731E-10_JPRB, 0.60621154E-10_JPRB, 0.61518145E-10_JPRB, 0.62055909E-10_JPRB, 0.62730605E-10_JPRB, 0.63429553E-10_JPRB, &
  & 0.63668223E-10_JPRB, 0.64335440E-10_JPRB, 0.65370445E-10_JPRB, 0.65558045E-10_JPRB, 0.66344027E-10_JPRB, 0.66558349E-10_JPRB, &
  & 0.66943499E-10_JPRB, 0.68122098E-10_JPRB, 0.68765924E-10_JPRB, 0.70697163E-10_JPRB /)

RGHG4(:,82, 3) = (/ &
  & 0.27131080E-10_JPRB, 0.21179029E-10_JPRB, 0.21539968E-10_JPRB, 0.21445240E-10_JPRB, 0.21602354E-10_JPRB, 0.22039726E-10_JPRB, &
  & 0.22708287E-10_JPRB, 0.23323662E-10_JPRB, 0.23639748E-10_JPRB, 0.24007341E-10_JPRB, 0.24528187E-10_JPRB, 0.25003336E-10_JPRB, &
  & 0.25599942E-10_JPRB, 0.26268210E-10_JPRB, 0.26990327E-10_JPRB, 0.27749161E-10_JPRB, 0.28563388E-10_JPRB, 0.29462793E-10_JPRB, &
  & 0.30424312E-10_JPRB, 0.31431691E-10_JPRB, 0.32457356E-10_JPRB, 0.33574182E-10_JPRB, 0.34661860E-10_JPRB, 0.35830321E-10_JPRB, &
  & 0.36952434E-10_JPRB, 0.38094403E-10_JPRB, 0.39268581E-10_JPRB, 0.40449623E-10_JPRB, 0.41618733E-10_JPRB, 0.42776178E-10_JPRB, &
  & 0.43927622E-10_JPRB, 0.45056979E-10_JPRB, 0.46190371E-10_JPRB, 0.47346432E-10_JPRB, 0.48492117E-10_JPRB, 0.49616516E-10_JPRB, &
  & 0.50606328E-10_JPRB, 0.51613283E-10_JPRB, 0.52556390E-10_JPRB, 0.53553231E-10_JPRB, 0.54468333E-10_JPRB, 0.55341613E-10_JPRB, &
  & 0.56057197E-10_JPRB, 0.56832716E-10_JPRB, 0.57604130E-10_JPRB, 0.58484072E-10_JPRB, 0.59368920E-10_JPRB, 0.60066375E-10_JPRB, &
  & 0.60858478E-10_JPRB, 0.61348711E-10_JPRB, 0.62099069E-10_JPRB, 0.62872853E-10_JPRB, 0.63332006E-10_JPRB, 0.64078909E-10_JPRB, &
  & 0.64351365E-10_JPRB, 0.64719632E-10_JPRB, 0.65945527E-10_JPRB, 0.65992954E-10_JPRB, 0.66661704E-10_JPRB, 0.67141619E-10_JPRB, &
  & 0.67247256E-10_JPRB, 0.68543220E-10_JPRB, 0.69235506E-10_JPRB, 0.72073257E-10_JPRB /)

RGHG4(:,83, 3) = (/ &
  & 0.27275524E-10_JPRB, 0.21231907E-10_JPRB, 0.21678185E-10_JPRB, 0.21557915E-10_JPRB, 0.21750664E-10_JPRB, 0.22213328E-10_JPRB, &
  & 0.22825542E-10_JPRB, 0.23630467E-10_JPRB, 0.23718125E-10_JPRB, 0.24325918E-10_JPRB, 0.24679217E-10_JPRB, 0.25248977E-10_JPRB, &
  & 0.25805535E-10_JPRB, 0.26500115E-10_JPRB, 0.27231075E-10_JPRB, 0.28032517E-10_JPRB, 0.28882582E-10_JPRB, 0.29789161E-10_JPRB, &
  & 0.30760797E-10_JPRB, 0.31758294E-10_JPRB, 0.32822887E-10_JPRB, 0.33907852E-10_JPRB, 0.34952746E-10_JPRB, 0.36043037E-10_JPRB, &
  & 0.37203386E-10_JPRB, 0.38372878E-10_JPRB, 0.39561642E-10_JPRB, 0.40752027E-10_JPRB, 0.41937325E-10_JPRB, 0.43106099E-10_JPRB, &
  & 0.44272433E-10_JPRB, 0.45415536E-10_JPRB, 0.46571007E-10_JPRB, 0.47746102E-10_JPRB, 0.48862206E-10_JPRB, 0.49978233E-10_JPRB, &
  & 0.51025982E-10_JPRB, 0.52140334E-10_JPRB, 0.53098800E-10_JPRB, 0.54127092E-10_JPRB, 0.55052636E-10_JPRB, 0.55933778E-10_JPRB, &
  & 0.56669423E-10_JPRB, 0.57471021E-10_JPRB, 0.58245887E-10_JPRB, 0.59100273E-10_JPRB, 0.59952036E-10_JPRB, 0.60591698E-10_JPRB, &
  & 0.61337081E-10_JPRB, 0.61958792E-10_JPRB, 0.62530474E-10_JPRB, 0.63404684E-10_JPRB, 0.63928772E-10_JPRB, 0.64527932E-10_JPRB, &
  & 0.65091016E-10_JPRB, 0.65201740E-10_JPRB, 0.66474160E-10_JPRB, 0.66687059E-10_JPRB, 0.66962658E-10_JPRB, 0.67813366E-10_JPRB, &
  & 0.67682672E-10_JPRB, 0.68915665E-10_JPRB, 0.69615036E-10_JPRB, 0.72089286E-10_JPRB /)

RGHG4(:,84, 3) = (/ &
  & 0.27342621E-10_JPRB, 0.21263968E-10_JPRB, 0.21784931E-10_JPRB, 0.21608016E-10_JPRB, 0.21849399E-10_JPRB, 0.22273003E-10_JPRB, &
  & 0.22979616E-10_JPRB, 0.23626578E-10_JPRB, 0.24061914E-10_JPRB, 0.24404791E-10_JPRB, 0.24967301E-10_JPRB, 0.25388056E-10_JPRB, &
  & 0.26002889E-10_JPRB, 0.26668730E-10_JPRB, 0.27411124E-10_JPRB, 0.28182781E-10_JPRB, 0.29025357E-10_JPRB, 0.29930176E-10_JPRB, &
  & 0.30898072E-10_JPRB, 0.31890279E-10_JPRB, 0.32977069E-10_JPRB, 0.34018600E-10_JPRB, 0.35174304E-10_JPRB, 0.36290054E-10_JPRB, &
  & 0.37453908E-10_JPRB, 0.38602802E-10_JPRB, 0.39793484E-10_JPRB, 0.40995585E-10_JPRB, 0.42190786E-10_JPRB, 0.43372354E-10_JPRB, &
  & 0.44550145E-10_JPRB, 0.45706272E-10_JPRB, 0.46888535E-10_JPRB, 0.48060656E-10_JPRB, 0.49241031E-10_JPRB, 0.50349745E-10_JPRB, &
  & 0.51414650E-10_JPRB, 0.52442356E-10_JPRB, 0.53400093E-10_JPRB, 0.54413505E-10_JPRB, 0.55340114E-10_JPRB, 0.56218859E-10_JPRB, &
  & 0.56952956E-10_JPRB, 0.57748886E-10_JPRB, 0.58541387E-10_JPRB, 0.59411039E-10_JPRB, 0.60331122E-10_JPRB, 0.61002474E-10_JPRB, &
  & 0.61681750E-10_JPRB, 0.62393576E-10_JPRB, 0.63006787E-10_JPRB, 0.63748375E-10_JPRB, 0.64440848E-10_JPRB, 0.64830599E-10_JPRB, &
  & 0.65464578E-10_JPRB, 0.65601725E-10_JPRB, 0.66524092E-10_JPRB, 0.67205373E-10_JPRB, 0.67006220E-10_JPRB, 0.68102246E-10_JPRB, &
  & 0.67978817E-10_JPRB, 0.69061118E-10_JPRB, 0.69903638E-10_JPRB, 0.72301047E-10_JPRB /)

RGHG4(:,85, 3) = (/ &
  & 0.27374993E-10_JPRB, 0.21262382E-10_JPRB, 0.21885096E-10_JPRB, 0.21658248E-10_JPRB, 0.21954494E-10_JPRB, 0.22381853E-10_JPRB, &
  & 0.23090703E-10_JPRB, 0.23943722E-10_JPRB, 0.24111796E-10_JPRB, 0.24696530E-10_JPRB, 0.25044274E-10_JPRB, 0.25580761E-10_JPRB, &
  & 0.26113139E-10_JPRB, 0.26794594E-10_JPRB, 0.27536492E-10_JPRB, 0.28356172E-10_JPRB, 0.29223290E-10_JPRB, 0.30118821E-10_JPRB, &
  & 0.31094963E-10_JPRB, 0.32101537E-10_JPRB, 0.33170668E-10_JPRB, 0.34224415E-10_JPRB, 0.35322922E-10_JPRB, 0.36409049E-10_JPRB, &
  & 0.37577625E-10_JPRB, 0.38762688E-10_JPRB, 0.39966523E-10_JPRB, 0.41184459E-10_JPRB, 0.42388686E-10_JPRB, 0.43580643E-10_JPRB, &
  & 0.44773782E-10_JPRB, 0.45951791E-10_JPRB, 0.47134768E-10_JPRB, 0.48351316E-10_JPRB, 0.49495935E-10_JPRB, 0.50613385E-10_JPRB, &
  & 0.51685958E-10_JPRB, 0.52754114E-10_JPRB, 0.53814904E-10_JPRB, 0.54737249E-10_JPRB, 0.55748385E-10_JPRB, 0.56584445E-10_JPRB, &
  & 0.57351290E-10_JPRB, 0.58170486E-10_JPRB, 0.58982617E-10_JPRB, 0.59839918E-10_JPRB, 0.60708182E-10_JPRB, 0.61427419E-10_JPRB, &
  & 0.62076344E-10_JPRB, 0.62699249E-10_JPRB, 0.63396524E-10_JPRB, 0.64070929E-10_JPRB, 0.64797945E-10_JPRB, 0.65286554E-10_JPRB, &
  & 0.65712651E-10_JPRB, 0.66211862E-10_JPRB, 0.66647576E-10_JPRB, 0.67706535E-10_JPRB, 0.67323140E-10_JPRB, 0.68289221E-10_JPRB, &
  & 0.68396538E-10_JPRB, 0.69219727E-10_JPRB, 0.70132039E-10_JPRB, 0.72507708E-10_JPRB /)

RGHG4(:,86, 3) = (/ &
  & 0.27440720E-10_JPRB, 0.21251122E-10_JPRB, 0.21983564E-10_JPRB, 0.21686423E-10_JPRB, 0.22048538E-10_JPRB, 0.22445415E-10_JPRB, &
  & 0.23282175E-10_JPRB, 0.23947481E-10_JPRB, 0.24428281E-10_JPRB, 0.24797820E-10_JPRB, 0.25277291E-10_JPRB, 0.25692800E-10_JPRB, &
  & 0.26233390E-10_JPRB, 0.26863975E-10_JPRB, 0.27601685E-10_JPRB, 0.28399567E-10_JPRB, 0.29269288E-10_JPRB, 0.30169332E-10_JPRB, &
  & 0.31174646E-10_JPRB, 0.32168865E-10_JPRB, 0.33220732E-10_JPRB, 0.34310124E-10_JPRB, 0.35423258E-10_JPRB, 0.36564165E-10_JPRB, &
  & 0.37732050E-10_JPRB, 0.38906892E-10_JPRB, 0.40117930E-10_JPRB, 0.41341180E-10_JPRB, 0.42557933E-10_JPRB, 0.43762806E-10_JPRB, &
  & 0.44966877E-10_JPRB, 0.46141018E-10_JPRB, 0.47354863E-10_JPRB, 0.48550722E-10_JPRB, 0.49750790E-10_JPRB, 0.50861974E-10_JPRB, &
  & 0.52000657E-10_JPRB, 0.53018930E-10_JPRB, 0.54049952E-10_JPRB, 0.55043158E-10_JPRB, 0.55967758E-10_JPRB, 0.56828812E-10_JPRB, &
  & 0.57586269E-10_JPRB, 0.58375783E-10_JPRB, 0.59194316E-10_JPRB, 0.60072974E-10_JPRB, 0.60910665E-10_JPRB, 0.61624990E-10_JPRB, &
  & 0.62344838E-10_JPRB, 0.62970747E-10_JPRB, 0.63675509E-10_JPRB, 0.64395891E-10_JPRB, 0.65023618E-10_JPRB, 0.65650763E-10_JPRB, &
  & 0.65842796E-10_JPRB, 0.66528283E-10_JPRB, 0.66821000E-10_JPRB, 0.67807017E-10_JPRB, 0.67692470E-10_JPRB, 0.68278889E-10_JPRB, &
  & 0.68693704E-10_JPRB, 0.69356354E-10_JPRB, 0.70318799E-10_JPRB, 0.72665207E-10_JPRB /)

RGHG4(:,87, 3) = (/ &
  & 0.27477593E-10_JPRB, 0.21235701E-10_JPRB, 0.22067246E-10_JPRB, 0.21703684E-10_JPRB, 0.22129030E-10_JPRB, 0.22556802E-10_JPRB, &
  & 0.23420975E-10_JPRB, 0.24212254E-10_JPRB, 0.24512056E-10_JPRB, 0.24982346E-10_JPRB, 0.25366457E-10_JPRB, 0.25804935E-10_JPRB, &
  & 0.26301636E-10_JPRB, 0.26922206E-10_JPRB, 0.27633725E-10_JPRB, 0.28465058E-10_JPRB, 0.29339933E-10_JPRB, 0.30283043E-10_JPRB, &
  & 0.31273865E-10_JPRB, 0.32255736E-10_JPRB, 0.33349563E-10_JPRB, 0.34412306E-10_JPRB, 0.35510657E-10_JPRB, 0.36625487E-10_JPRB, &
  & 0.37802168E-10_JPRB, 0.38999620E-10_JPRB, 0.40218114E-10_JPRB, 0.41460207E-10_JPRB, 0.42676983E-10_JPRB, 0.43888088E-10_JPRB, &
  & 0.45094695E-10_JPRB, 0.46291287E-10_JPRB, 0.47501846E-10_JPRB, 0.48727817E-10_JPRB, 0.49909115E-10_JPRB, 0.51078589E-10_JPRB, &
  & 0.52170643E-10_JPRB, 0.53300787E-10_JPRB, 0.54329857E-10_JPRB, 0.55306822E-10_JPRB, 0.56315501E-10_JPRB, 0.57143575E-10_JPRB, &
  & 0.57899244E-10_JPRB, 0.58720744E-10_JPRB, 0.59494097E-10_JPRB, 0.60396382E-10_JPRB, 0.61246008E-10_JPRB, 0.61918651E-10_JPRB, &
  & 0.62608786E-10_JPRB, 0.63218118E-10_JPRB, 0.63900413E-10_JPRB, 0.64645324E-10_JPRB, 0.65260831E-10_JPRB, 0.65918680E-10_JPRB, &
  & 0.66140898E-10_JPRB, 0.66707959E-10_JPRB, 0.67199198E-10_JPRB, 0.67855888E-10_JPRB, 0.68078099E-10_JPRB, 0.68370649E-10_JPRB, &
  & 0.68900233E-10_JPRB, 0.69516795E-10_JPRB, 0.70460200E-10_JPRB, 0.72801438E-10_JPRB /)

RGHG4(:,88, 3) = (/ &
  & 0.27511778E-10_JPRB, 0.21238764E-10_JPRB, 0.22131300E-10_JPRB, 0.21696695E-10_JPRB, 0.22192036E-10_JPRB, 0.22601438E-10_JPRB, &
  & 0.23530127E-10_JPRB, 0.24133825E-10_JPRB, 0.24666991E-10_JPRB, 0.25035163E-10_JPRB, 0.25456639E-10_JPRB, 0.25884572E-10_JPRB, &
  & 0.26369682E-10_JPRB, 0.26966238E-10_JPRB, 0.27681992E-10_JPRB, 0.28476440E-10_JPRB, 0.29356399E-10_JPRB, 0.30304391E-10_JPRB, &
  & 0.31277002E-10_JPRB, 0.32316504E-10_JPRB, 0.33369089E-10_JPRB, 0.34453627E-10_JPRB, 0.35568735E-10_JPRB, 0.36710732E-10_JPRB, &
  & 0.37890219E-10_JPRB, 0.39091910E-10_JPRB, 0.40321569E-10_JPRB, 0.41563291E-10_JPRB, 0.42793370E-10_JPRB, 0.44022258E-10_JPRB, &
  & 0.45242025E-10_JPRB, 0.46438506E-10_JPRB, 0.47644336E-10_JPRB, 0.48882884E-10_JPRB, 0.50098051E-10_JPRB, 0.51276532E-10_JPRB, &
  & 0.52435917E-10_JPRB, 0.53509069E-10_JPRB, 0.54594090E-10_JPRB, 0.55581401E-10_JPRB, 0.56531654E-10_JPRB, 0.57404335E-10_JPRB, &
  & 0.58140780E-10_JPRB, 0.58933310E-10_JPRB, 0.59682197E-10_JPRB, 0.60523107E-10_JPRB, 0.61354810E-10_JPRB, 0.62041559E-10_JPRB, &
  & 0.62769089E-10_JPRB, 0.63405108E-10_JPRB, 0.64097297E-10_JPRB, 0.64835706E-10_JPRB, 0.65469699E-10_JPRB, 0.66072960E-10_JPRB, &
  & 0.66368328E-10_JPRB, 0.66791586E-10_JPRB, 0.67417315E-10_JPRB, 0.67920516E-10_JPRB, 0.68247338E-10_JPRB, 0.68493620E-10_JPRB, &
  & 0.68999910E-10_JPRB, 0.69634222E-10_JPRB, 0.70586162E-10_JPRB, 0.72897792E-10_JPRB /)

RGHG4(:,89, 3) = (/ &
  & 0.27532998E-10_JPRB, 0.21247176E-10_JPRB, 0.22163285E-10_JPRB, 0.21679027E-10_JPRB, 0.22209129E-10_JPRB, 0.22580004E-10_JPRB, &
  & 0.23404608E-10_JPRB, 0.24234101E-10_JPRB, 0.24609396E-10_JPRB, 0.24995448E-10_JPRB, 0.25437546E-10_JPRB, 0.25857035E-10_JPRB, &
  & 0.26396500E-10_JPRB, 0.27008520E-10_JPRB, 0.27731307E-10_JPRB, 0.28546185E-10_JPRB, 0.29438067E-10_JPRB, 0.30373454E-10_JPRB, &
  & 0.31348146E-10_JPRB, 0.32357689E-10_JPRB, 0.33406281E-10_JPRB, 0.34493585E-10_JPRB, 0.35587491E-10_JPRB, 0.36727201E-10_JPRB, &
  & 0.37906785E-10_JPRB, 0.39113573E-10_JPRB, 0.40351299E-10_JPRB, 0.41618872E-10_JPRB, 0.42859799E-10_JPRB, 0.44090506E-10_JPRB, &
  & 0.45323890E-10_JPRB, 0.46531508E-10_JPRB, 0.47785543E-10_JPRB, 0.49036535E-10_JPRB, 0.50298023E-10_JPRB, 0.51500578E-10_JPRB, &
  & 0.52666371E-10_JPRB, 0.53793064E-10_JPRB, 0.54840656E-10_JPRB, 0.55860944E-10_JPRB, 0.56841802E-10_JPRB, 0.57681276E-10_JPRB, &
  & 0.58408327E-10_JPRB, 0.59200415E-10_JPRB, 0.59939109E-10_JPRB, 0.60789207E-10_JPRB, 0.61617780E-10_JPRB, 0.62260183E-10_JPRB, &
  & 0.62948625E-10_JPRB, 0.63569920E-10_JPRB, 0.64265024E-10_JPRB, 0.64994336E-10_JPRB, 0.65654017E-10_JPRB, 0.66233109E-10_JPRB, &
  & 0.66567266E-10_JPRB, 0.66951764E-10_JPRB, 0.67587026E-10_JPRB, 0.68072367E-10_JPRB, 0.68385991E-10_JPRB, 0.68626951E-10_JPRB, &
  & 0.69119079E-10_JPRB, 0.69711396E-10_JPRB, 0.70720312E-10_JPRB, 0.72966355E-10_JPRB /)

RGHG4(:,90, 3) = (/ &
  & 0.27550269E-10_JPRB, 0.21279430E-10_JPRB, 0.22107248E-10_JPRB, 0.21707663E-10_JPRB, 0.22106445E-10_JPRB, 0.22461137E-10_JPRB, &
  & 0.23262800E-10_JPRB, 0.23982283E-10_JPRB, 0.24378489E-10_JPRB, 0.24883163E-10_JPRB, 0.25313522E-10_JPRB, 0.25817282E-10_JPRB, &
  & 0.26375778E-10_JPRB, 0.27045225E-10_JPRB, 0.27787455E-10_JPRB, 0.28599080E-10_JPRB, 0.29461503E-10_JPRB, 0.30372548E-10_JPRB, &
  & 0.31330823E-10_JPRB, 0.32335263E-10_JPRB, 0.33379712E-10_JPRB, 0.34460351E-10_JPRB, 0.35565700E-10_JPRB, 0.36713660E-10_JPRB, &
  & 0.37911528E-10_JPRB, 0.39140094E-10_JPRB, 0.40393931E-10_JPRB, 0.41663551E-10_JPRB, 0.42931624E-10_JPRB, 0.44212627E-10_JPRB, &
  & 0.45471786E-10_JPRB, 0.46716860E-10_JPRB, 0.47984457E-10_JPRB, 0.49269689E-10_JPRB, 0.50552319E-10_JPRB, 0.51796477E-10_JPRB, &
  & 0.52980037E-10_JPRB, 0.54096585E-10_JPRB, 0.55156612E-10_JPRB, 0.56157204E-10_JPRB, 0.57121332E-10_JPRB, 0.57948809E-10_JPRB, &
  & 0.58649030E-10_JPRB, 0.59378738E-10_JPRB, 0.60070983E-10_JPRB, 0.60863717E-10_JPRB, 0.61685157E-10_JPRB, 0.62363635E-10_JPRB, &
  & 0.63075163E-10_JPRB, 0.63703126E-10_JPRB, 0.64410519E-10_JPRB, 0.65134252E-10_JPRB, 0.65799532E-10_JPRB, 0.66365281E-10_JPRB, &
  & 0.66694095E-10_JPRB, 0.67078565E-10_JPRB, 0.67698604E-10_JPRB, 0.68173002E-10_JPRB, 0.68494398E-10_JPRB, 0.68692614E-10_JPRB, &
  & 0.69236956E-10_JPRB, 0.69742837E-10_JPRB, 0.70865418E-10_JPRB, 0.73014400E-10_JPRB /)

RGHG4(:,91, 3) = (/ &
  & 0.27480006E-10_JPRB, 0.21336346E-10_JPRB, 0.21932609E-10_JPRB, 0.21768483E-10_JPRB, 0.21960990E-10_JPRB, 0.22329378E-10_JPRB, &
  & 0.21529677E-10_JPRB, 0.23248712E-10_JPRB, 0.24066466E-10_JPRB, 0.24568713E-10_JPRB, 0.25093259E-10_JPRB, 0.25669926E-10_JPRB, &
  & 0.26317826E-10_JPRB, 0.27039667E-10_JPRB, 0.27812216E-10_JPRB, 0.28623690E-10_JPRB, 0.29472664E-10_JPRB, 0.30369485E-10_JPRB, &
  & 0.31304636E-10_JPRB, 0.32280314E-10_JPRB, 0.33305483E-10_JPRB, 0.34373868E-10_JPRB, 0.35466418E-10_JPRB, 0.36619291E-10_JPRB, &
  & 0.37823026E-10_JPRB, 0.39035657E-10_JPRB, 0.40351816E-10_JPRB, 0.41663079E-10_JPRB, 0.42959962E-10_JPRB, 0.44271403E-10_JPRB, &
  & 0.45562110E-10_JPRB, 0.46842221E-10_JPRB, 0.48182829E-10_JPRB, 0.49520849E-10_JPRB, 0.50870735E-10_JPRB, 0.52158184E-10_JPRB, &
  & 0.53375714E-10_JPRB, 0.54500425E-10_JPRB, 0.55565400E-10_JPRB, 0.56573156E-10_JPRB, 0.55187771E-10_JPRB, 0.56034833E-10_JPRB, &
  & 0.58973722E-10_JPRB, 0.59676590E-10_JPRB, 0.60347970E-10_JPRB, 0.61123585E-10_JPRB, 0.61893650E-10_JPRB, 0.62528857E-10_JPRB, &
  & 0.63221393E-10_JPRB, 0.63839933E-10_JPRB, 0.64550879E-10_JPRB, 0.65274237E-10_JPRB, 0.65944618E-10_JPRB, 0.66497551E-10_JPRB, &
  & 0.66822881E-10_JPRB, 0.67229243E-10_JPRB, 0.67830241E-10_JPRB, 0.68285717E-10_JPRB, 0.68604039E-10_JPRB, 0.68759339E-10_JPRB, &
  & 0.69353114E-10_JPRB, 0.69760683E-10_JPRB, 0.71061219E-10_JPRB, 0.73052328E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG4(:, 1, 4) = (/ &
  & 0.96346975E-09_JPRB, 0.96181751E-09_JPRB, 0.96176189E-09_JPRB, 0.96168851E-09_JPRB, 0.96244912E-09_JPRB, 0.90710947E-13_JPRB, &
  & 0.76400630E-13_JPRB, 0.80221630E-13_JPRB, 0.87109065E-13_JPRB, 0.95954711E-13_JPRB, 0.96966977E-13_JPRB, 0.99048895E-13_JPRB, &
  & 0.10478923E-12_JPRB, 0.10444023E-12_JPRB, 0.10421156E-12_JPRB, 0.10424060E-12_JPRB, 0.10866943E-12_JPRB, 0.10754607E-12_JPRB, &
  & 0.10685310E-12_JPRB, 0.10644339E-12_JPRB, 0.10605378E-12_JPRB, 0.10577573E-12_JPRB, 0.11168570E-12_JPRB, 0.11036391E-12_JPRB, &
  & 0.11019540E-12_JPRB, 0.11108938E-12_JPRB, 0.11285578E-12_JPRB, 0.11519452E-12_JPRB, 0.11783292E-12_JPRB, 0.12024051E-12_JPRB, &
  & 0.12198042E-12_JPRB, 0.12292413E-12_JPRB, 0.12863225E-12_JPRB, 0.12591543E-12_JPRB, 0.12320032E-12_JPRB, 0.12052395E-12_JPRB, &
  & 0.11791065E-12_JPRB, 0.11563935E-12_JPRB, 0.11357722E-12_JPRB, 0.11183900E-12_JPRB, 0.11037837E-12_JPRB, 0.10909126E-12_JPRB, &
  & 0.11302200E-12_JPRB, 0.11039780E-12_JPRB, 0.10867337E-12_JPRB, 0.10711680E-12_JPRB, 0.10616054E-12_JPRB, 0.10511051E-12_JPRB, &
  & 0.10406615E-12_JPRB, 0.10637957E-12_JPRB, 0.10403787E-12_JPRB, 0.10211611E-12_JPRB, 0.10021716E-12_JPRB, 0.10124969E-12_JPRB, &
  & 0.98895454E-13_JPRB, 0.10003143E-12_JPRB, 0.10083813E-12_JPRB, 0.10145725E-12_JPRB, 0.10140361E-12_JPRB, 0.10200211E-12_JPRB, &
  & 0.90090905E-13_JPRB, 0.78364879E-13_JPRB, 0.65423544E-13_JPRB, 0.52256363E-13_JPRB /)

RGHG4(:, 2, 4) = (/ &
  & 0.10083931E-19_JPRB, 0.10083576E-19_JPRB, 0.10083267E-19_JPRB, 0.10082600E-19_JPRB, 0.10081394E-19_JPRB, 0.26136282E-12_JPRB, &
  & 0.26933840E-12_JPRB, 0.27895806E-12_JPRB, 0.29232262E-12_JPRB, 0.30486716E-12_JPRB, 0.31990778E-12_JPRB, 0.34609040E-12_JPRB, &
  & 0.37503692E-12_JPRB, 0.40276848E-12_JPRB, 0.42602887E-12_JPRB, 0.45097544E-12_JPRB, 0.46630717E-12_JPRB, 0.47703860E-12_JPRB, &
  & 0.48485559E-12_JPRB, 0.49178288E-12_JPRB, 0.49698077E-12_JPRB, 0.50913028E-12_JPRB, 0.51934515E-12_JPRB, 0.52545094E-12_JPRB, &
  & 0.52525849E-12_JPRB, 0.52466543E-12_JPRB, 0.53296273E-12_JPRB, 0.55327119E-12_JPRB, 0.58667253E-12_JPRB, 0.63331848E-12_JPRB, &
  & 0.68661092E-12_JPRB, 0.76304501E-12_JPRB, 0.82675132E-12_JPRB, 0.88119724E-12_JPRB, 0.92613243E-12_JPRB, 0.96199600E-12_JPRB, &
  & 0.98661216E-12_JPRB, 0.99929266E-12_JPRB, 0.99461032E-12_JPRB, 0.97386704E-12_JPRB, 0.94111058E-12_JPRB, 0.90017533E-12_JPRB, &
  & 0.85435191E-12_JPRB, 0.78977395E-12_JPRB, 0.71824887E-12_JPRB, 0.63769286E-12_JPRB, 0.56248360E-12_JPRB, 0.48837068E-12_JPRB, &
  & 0.42438950E-12_JPRB, 0.37565510E-12_JPRB, 0.34014054E-12_JPRB, 0.31072689E-12_JPRB, 0.28630383E-12_JPRB, 0.26656252E-12_JPRB, &
  & 0.24671752E-12_JPRB, 0.22979969E-12_JPRB, 0.20010954E-12_JPRB, 0.20664008E-12_JPRB, 0.21549643E-12_JPRB, 0.22389527E-12_JPRB, &
  & 0.23166647E-12_JPRB, 0.23999208E-12_JPRB, 0.24870023E-12_JPRB, 0.25580395E-12_JPRB /)

RGHG4(:, 3, 4) = (/ &
  & 0.56030177E-20_JPRB, 0.56020674E-20_JPRB, 0.56005495E-20_JPRB, 0.20206969E-09_JPRB, 0.48138732E-09_JPRB, 0.41800217E-12_JPRB, &
  & 0.44524033E-12_JPRB, 0.48364194E-12_JPRB, 0.53430714E-12_JPRB, 0.58502205E-12_JPRB, 0.63595445E-12_JPRB, 0.69293340E-12_JPRB, &
  & 0.74369374E-12_JPRB, 0.79113457E-12_JPRB, 0.83399032E-12_JPRB, 0.88495829E-12_JPRB, 0.93225904E-12_JPRB, 0.97725333E-12_JPRB, &
  & 0.10149586E-11_JPRB, 0.10490648E-11_JPRB, 0.10705497E-11_JPRB, 0.10949236E-11_JPRB, 0.11098156E-11_JPRB, 0.11242091E-11_JPRB, &
  & 0.11455536E-11_JPRB, 0.11790928E-11_JPRB, 0.12244208E-11_JPRB, 0.12831635E-11_JPRB, 0.13508996E-11_JPRB, 0.14372365E-11_JPRB, &
  & 0.15290244E-11_JPRB, 0.16528342E-11_JPRB, 0.17510903E-11_JPRB, 0.18313755E-11_JPRB, 0.18910934E-11_JPRB, 0.19368962E-11_JPRB, &
  & 0.19693914E-11_JPRB, 0.19878888E-11_JPRB, 0.19850712E-11_JPRB, 0.19578360E-11_JPRB, 0.19003215E-11_JPRB, 0.18233091E-11_JPRB, &
  & 0.17349941E-11_JPRB, 0.16111643E-11_JPRB, 0.14716377E-11_JPRB, 0.13180939E-11_JPRB, 0.11683448E-11_JPRB, 0.10294084E-11_JPRB, &
  & 0.91209896E-12_JPRB, 0.81635187E-12_JPRB, 0.73774233E-12_JPRB, 0.67420380E-12_JPRB, 0.62933160E-12_JPRB, 0.60816808E-12_JPRB, &
  & 0.60450923E-12_JPRB, 0.61649844E-12_JPRB, 0.59486769E-12_JPRB, 0.63952977E-12_JPRB, 0.68326182E-12_JPRB, 0.72243546E-12_JPRB, &
  & 0.76059379E-12_JPRB, 0.80159962E-12_JPRB, 0.84648499E-12_JPRB, 0.90225771E-12_JPRB /)

RGHG4(:, 4, 4) = (/ &
  & 0.32484120E-20_JPRB, 0.15101992E-09_JPRB, 0.38264331E-09_JPRB, 0.54965477E-09_JPRB, 0.71348261E-09_JPRB, 0.86883360E-12_JPRB, &
  & 0.94951954E-12_JPRB, 0.10531803E-11_JPRB, 0.11710156E-11_JPRB, 0.12942871E-11_JPRB, 0.14135890E-11_JPRB, 0.15399970E-11_JPRB, &
  & 0.16561736E-11_JPRB, 0.17617247E-11_JPRB, 0.18624607E-11_JPRB, 0.19833954E-11_JPRB, 0.21086670E-11_JPRB, 0.22277260E-11_JPRB, &
  & 0.23386766E-11_JPRB, 0.24513549E-11_JPRB, 0.25528347E-11_JPRB, 0.26747693E-11_JPRB, 0.27937533E-11_JPRB, 0.29141863E-11_JPRB, &
  & 0.30390846E-11_JPRB, 0.31705196E-11_JPRB, 0.33055796E-11_JPRB, 0.34557192E-11_JPRB, 0.36045719E-11_JPRB, 0.37632822E-11_JPRB, &
  & 0.38833706E-11_JPRB, 0.40198526E-11_JPRB, 0.40932665E-11_JPRB, 0.41518993E-11_JPRB, 0.41863396E-11_JPRB, 0.42170221E-11_JPRB, &
  & 0.42413885E-11_JPRB, 0.42591577E-11_JPRB, 0.42577669E-11_JPRB, 0.42274873E-11_JPRB, 0.41522541E-11_JPRB, 0.40345075E-11_JPRB, &
  & 0.38785021E-11_JPRB, 0.36474795E-11_JPRB, 0.33812055E-11_JPRB, 0.31041818E-11_JPRB, 0.28434659E-11_JPRB, 0.26051555E-11_JPRB, &
  & 0.24049168E-11_JPRB, 0.22375981E-11_JPRB, 0.20964693E-11_JPRB, 0.19894425E-11_JPRB, 0.19131107E-11_JPRB, 0.18715674E-11_JPRB, &
  & 0.18561016E-11_JPRB, 0.18684377E-11_JPRB, 0.17808267E-11_JPRB, 0.18138453E-11_JPRB, 0.18595483E-11_JPRB, 0.19161374E-11_JPRB, &
  & 0.20068064E-11_JPRB, 0.21422985E-11_JPRB, 0.23040383E-11_JPRB, 0.25178412E-11_JPRB /)

RGHG4(:, 5, 4) = (/ &
  & 0.22626725E-09_JPRB, 0.67144335E-09_JPRB, 0.92361396E-09_JPRB, 0.12245542E-08_JPRB, 0.15209872E-08_JPRB, 0.24056781E-11_JPRB, &
  & 0.25865783E-11_JPRB, 0.28672026E-11_JPRB, 0.31692912E-11_JPRB, 0.34766118E-11_JPRB, 0.37756573E-11_JPRB, 0.40769081E-11_JPRB, &
  & 0.43637234E-11_JPRB, 0.46455795E-11_JPRB, 0.49320487E-11_JPRB, 0.52433466E-11_JPRB, 0.55655194E-11_JPRB, 0.58849275E-11_JPRB, &
  & 0.62201503E-11_JPRB, 0.65929068E-11_JPRB, 0.69901780E-11_JPRB, 0.74749937E-11_JPRB, 0.79982522E-11_JPRB, 0.85420672E-11_JPRB, &
  & 0.90650473E-11_JPRB, 0.95630873E-11_JPRB, 0.10022056E-10_JPRB, 0.10441955E-10_JPRB, 0.10776034E-10_JPRB, 0.11037346E-10_JPRB, &
  & 0.11161225E-10_JPRB, 0.11229203E-10_JPRB, 0.11148725E-10_JPRB, 0.11056835E-10_JPRB, 0.10942767E-10_JPRB, 0.10853614E-10_JPRB, &
  & 0.10789892E-10_JPRB, 0.10743137E-10_JPRB, 0.10682593E-10_JPRB, 0.10587102E-10_JPRB, 0.10415668E-10_JPRB, 0.10171877E-10_JPRB, &
  & 0.98600772E-11_JPRB, 0.94166671E-11_JPRB, 0.89141212E-11_JPRB, 0.83585326E-11_JPRB, 0.78148000E-11_JPRB, 0.73105766E-11_JPRB, &
  & 0.68844431E-11_JPRB, 0.65200610E-11_JPRB, 0.61993583E-11_JPRB, 0.59301860E-11_JPRB, 0.56980228E-11_JPRB, 0.55076087E-11_JPRB, &
  & 0.53588280E-11_JPRB, 0.52655866E-11_JPRB, 0.51250362E-11_JPRB, 0.51023417E-11_JPRB, 0.51045461E-11_JPRB, 0.51497409E-11_JPRB, &
  & 0.53531910E-11_JPRB, 0.57331123E-11_JPRB, 0.62581095E-11_JPRB, 0.72177169E-11_JPRB /)

RGHG4(:, 6, 4) = (/ &
  & 0.80334500E-09_JPRB, 0.12971280E-08_JPRB, 0.16880725E-08_JPRB, 0.20910265E-08_JPRB, 0.25273579E-08_JPRB, 0.89797388E-11_JPRB, &
  & 0.88046306E-11_JPRB, 0.93899428E-11_JPRB, 0.10087520E-10_JPRB, 0.10798306E-10_JPRB, 0.11479138E-10_JPRB, 0.12135283E-10_JPRB, &
  & 0.12746118E-10_JPRB, 0.13324554E-10_JPRB, 0.13898309E-10_JPRB, 0.14535153E-10_JPRB, 0.15263029E-10_JPRB, 0.16117496E-10_JPRB, &
  & 0.17113696E-10_JPRB, 0.18232178E-10_JPRB, 0.19404313E-10_JPRB, 0.20682381E-10_JPRB, 0.22041945E-10_JPRB, 0.23461288E-10_JPRB, &
  & 0.24831023E-10_JPRB, 0.26103708E-10_JPRB, 0.27240335E-10_JPRB, 0.28223998E-10_JPRB, 0.29003704E-10_JPRB, 0.29533445E-10_JPRB, &
  & 0.29760874E-10_JPRB, 0.29720601E-10_JPRB, 0.29309923E-10_JPRB, 0.28872588E-10_JPRB, 0.28413952E-10_JPRB, 0.27995819E-10_JPRB, &
  & 0.27644257E-10_JPRB, 0.27342422E-10_JPRB, 0.27047718E-10_JPRB, 0.26717321E-10_JPRB, 0.26310624E-10_JPRB, 0.25795397E-10_JPRB, &
  & 0.25119849E-10_JPRB, 0.24191356E-10_JPRB, 0.23190365E-10_JPRB, 0.22185453E-10_JPRB, 0.21250512E-10_JPRB, 0.20377599E-10_JPRB, &
  & 0.19578617E-10_JPRB, 0.18816034E-10_JPRB, 0.18070366E-10_JPRB, 0.17363442E-10_JPRB, 0.16682907E-10_JPRB, 0.16044008E-10_JPRB, &
  & 0.15467950E-10_JPRB, 0.14991905E-10_JPRB, 0.14655650E-10_JPRB, 0.14475445E-10_JPRB, 0.14342690E-10_JPRB, 0.14330151E-10_JPRB, &
  & 0.14908300E-10_JPRB, 0.16030816E-10_JPRB, 0.17476966E-10_JPRB, 0.19541074E-10_JPRB /)

RGHG4(:, 7, 4) = (/ &
  & 0.14381197E-08_JPRB, 0.22824318E-08_JPRB, 0.29526062E-08_JPRB, 0.36427856E-08_JPRB, 0.43957820E-08_JPRB, 0.39419482E-10_JPRB, &
  & 0.35514848E-10_JPRB, 0.35391773E-10_JPRB, 0.36141191E-10_JPRB, 0.37152673E-10_JPRB, 0.38118137E-10_JPRB, 0.39047626E-10_JPRB, &
  & 0.39811824E-10_JPRB, 0.40472906E-10_JPRB, 0.41114286E-10_JPRB, 0.41872068E-10_JPRB, 0.42819331E-10_JPRB, 0.44093156E-10_JPRB, &
  & 0.45766755E-10_JPRB, 0.47885591E-10_JPRB, 0.50359276E-10_JPRB, 0.53155168E-10_JPRB, 0.56301099E-10_JPRB, 0.59797861E-10_JPRB, &
  & 0.63417036E-10_JPRB, 0.66843087E-10_JPRB, 0.69949685E-10_JPRB, 0.72543568E-10_JPRB, 0.74651368E-10_JPRB, 0.76045885E-10_JPRB, &
  & 0.76843795E-10_JPRB, 0.76852504E-10_JPRB, 0.75983241E-10_JPRB, 0.74961884E-10_JPRB, 0.73802423E-10_JPRB, 0.72601938E-10_JPRB, &
  & 0.71512241E-10_JPRB, 0.70505331E-10_JPRB, 0.69547104E-10_JPRB, 0.68536080E-10_JPRB, 0.67411673E-10_JPRB, 0.66177237E-10_JPRB, &
  & 0.64764763E-10_JPRB, 0.63104598E-10_JPRB, 0.61485567E-10_JPRB, 0.59808936E-10_JPRB, 0.58093294E-10_JPRB, 0.56330416E-10_JPRB, &
  & 0.54538533E-10_JPRB, 0.52683160E-10_JPRB, 0.50831155E-10_JPRB, 0.49090947E-10_JPRB, 0.47414933E-10_JPRB, 0.45826176E-10_JPRB, &
  & 0.44433558E-10_JPRB, 0.43344609E-10_JPRB, 0.42688492E-10_JPRB, 0.42262097E-10_JPRB, 0.41932305E-10_JPRB, 0.42270177E-10_JPRB, &
  & 0.44643414E-10_JPRB, 0.48625624E-10_JPRB, 0.54046115E-10_JPRB, 0.62465005E-10_JPRB /)

RGHG4(:, 8, 4) = (/ &
  & 0.23905122E-08_JPRB, 0.38394288E-08_JPRB, 0.48724407E-08_JPRB, 0.58805050E-08_JPRB, 0.69888419E-08_JPRB, 0.14737282E-09_JPRB, &
  & 0.13960792E-09_JPRB, 0.13342931E-09_JPRB, 0.12941433E-09_JPRB, 0.12725308E-09_JPRB, 0.12603653E-09_JPRB, 0.12556457E-09_JPRB, &
  & 0.12503337E-09_JPRB, 0.12442719E-09_JPRB, 0.12382537E-09_JPRB, 0.12370156E-09_JPRB, 0.12415187E-09_JPRB, 0.12543380E-09_JPRB, &
  & 0.12774301E-09_JPRB, 0.13112438E-09_JPRB, 0.13556192E-09_JPRB, 0.14120033E-09_JPRB, 0.14788776E-09_JPRB, 0.15524196E-09_JPRB, &
  & 0.16270704E-09_JPRB, 0.16981853E-09_JPRB, 0.17636315E-09_JPRB, 0.18168358E-09_JPRB, 0.18626432E-09_JPRB, 0.18928806E-09_JPRB, &
  & 0.19144866E-09_JPRB, 0.19177045E-09_JPRB, 0.19023522E-09_JPRB, 0.18857611E-09_JPRB, 0.18649315E-09_JPRB, 0.18402822E-09_JPRB, &
  & 0.18149746E-09_JPRB, 0.17885017E-09_JPRB, 0.17619815E-09_JPRB, 0.17350980E-09_JPRB, 0.17092772E-09_JPRB, 0.16834557E-09_JPRB, &
  & 0.16537491E-09_JPRB, 0.16200749E-09_JPRB, 0.15890222E-09_JPRB, 0.15574350E-09_JPRB, 0.15250860E-09_JPRB, 0.14920684E-09_JPRB, &
  & 0.14573720E-09_JPRB, 0.14183790E-09_JPRB, 0.13771982E-09_JPRB, 0.13377251E-09_JPRB, 0.12996365E-09_JPRB, 0.12620900E-09_JPRB, &
  & 0.12274727E-09_JPRB, 0.11987779E-09_JPRB, 0.11807218E-09_JPRB, 0.11735711E-09_JPRB, 0.11747590E-09_JPRB, 0.11946429E-09_JPRB, &
  & 0.12661518E-09_JPRB, 0.13780627E-09_JPRB, 0.15237885E-09_JPRB, 0.17077388E-09_JPRB /)

RGHG4(:, 9, 4) = (/ &
  & 0.38088968E-08_JPRB, 0.56701142E-08_JPRB, 0.69092407E-08_JPRB, 0.82228384E-08_JPRB, 0.97727062E-08_JPRB, 0.38099407E-09_JPRB, &
  & 0.40382486E-09_JPRB, 0.41289139E-09_JPRB, 0.40978387E-09_JPRB, 0.40281140E-09_JPRB, 0.39519302E-09_JPRB, 0.38887021E-09_JPRB, &
  & 0.38268747E-09_JPRB, 0.37693049E-09_JPRB, 0.37131084E-09_JPRB, 0.36684822E-09_JPRB, 0.36334408E-09_JPRB, 0.36142050E-09_JPRB, &
  & 0.36156536E-09_JPRB, 0.36359851E-09_JPRB, 0.36734529E-09_JPRB, 0.37277711E-09_JPRB, 0.38060166E-09_JPRB, 0.39082557E-09_JPRB, &
  & 0.40149714E-09_JPRB, 0.41170331E-09_JPRB, 0.42117251E-09_JPRB, 0.42935500E-09_JPRB, 0.43690862E-09_JPRB, 0.44176152E-09_JPRB, &
  & 0.44581352E-09_JPRB, 0.44626827E-09_JPRB, 0.44304133E-09_JPRB, 0.44025275E-09_JPRB, 0.43686907E-09_JPRB, 0.43229031E-09_JPRB, &
  & 0.42726531E-09_JPRB, 0.42163997E-09_JPRB, 0.41594711E-09_JPRB, 0.41007628E-09_JPRB, 0.40416959E-09_JPRB, 0.39807332E-09_JPRB, &
  & 0.39111694E-09_JPRB, 0.38384901E-09_JPRB, 0.37778922E-09_JPRB, 0.37212081E-09_JPRB, 0.36641667E-09_JPRB, 0.36042702E-09_JPRB, &
  & 0.35390485E-09_JPRB, 0.34655323E-09_JPRB, 0.33904893E-09_JPRB, 0.33220030E-09_JPRB, 0.32572570E-09_JPRB, 0.31947617E-09_JPRB, &
  & 0.31438571E-09_JPRB, 0.31109249E-09_JPRB, 0.31030442E-09_JPRB, 0.31150094E-09_JPRB, 0.31402378E-09_JPRB, 0.32164699E-09_JPRB, &
  & 0.34020439E-09_JPRB, 0.36781519E-09_JPRB, 0.40362602E-09_JPRB, 0.45324583E-09_JPRB /)

RGHG4(:,10, 4) = (/ &
  & 0.51644085E-08_JPRB, 0.68883965E-08_JPRB, 0.82075928E-08_JPRB, 0.98324398E-08_JPRB, 0.11920711E-07_JPRB, 0.74704848E-09_JPRB, &
  & 0.84192736E-09_JPRB, 0.91257168E-09_JPRB, 0.95427843E-09_JPRB, 0.97370922E-09_JPRB, 0.97929542E-09_JPRB, 0.97752473E-09_JPRB, &
  & 0.97018538E-09_JPRB, 0.96096375E-09_JPRB, 0.94995589E-09_JPRB, 0.93959096E-09_JPRB, 0.92942337E-09_JPRB, 0.92138158E-09_JPRB, &
  & 0.91592062E-09_JPRB, 0.91238722E-09_JPRB, 0.91056596E-09_JPRB, 0.90998137E-09_JPRB, 0.91208097E-09_JPRB, 0.91809033E-09_JPRB, &
  & 0.92581320E-09_JPRB, 0.93412622E-09_JPRB, 0.94249974E-09_JPRB, 0.94923036E-09_JPRB, 0.95555885E-09_JPRB, 0.95865227E-09_JPRB, &
  & 0.96236619E-09_JPRB, 0.95986896E-09_JPRB, 0.95112107E-09_JPRB, 0.94421837E-09_JPRB, 0.93566510E-09_JPRB, 0.92517360E-09_JPRB, &
  & 0.91420960E-09_JPRB, 0.90238855E-09_JPRB, 0.89057317E-09_JPRB, 0.87833962E-09_JPRB, 0.86612661E-09_JPRB, 0.85352814E-09_JPRB, &
  & 0.83870760E-09_JPRB, 0.82328649E-09_JPRB, 0.81021706E-09_JPRB, 0.79823703E-09_JPRB, 0.78679091E-09_JPRB, 0.77585410E-09_JPRB, &
  & 0.76513185E-09_JPRB, 0.75325240E-09_JPRB, 0.74154677E-09_JPRB, 0.73143097E-09_JPRB, 0.72241901E-09_JPRB, 0.71353029E-09_JPRB, &
  & 0.70611272E-09_JPRB, 0.70107997E-09_JPRB, 0.69985867E-09_JPRB, 0.70249662E-09_JPRB, 0.70851319E-09_JPRB, 0.72280021E-09_JPRB, &
  & 0.75117529E-09_JPRB, 0.79140400E-09_JPRB, 0.84187135E-09_JPRB, 0.90358815E-09_JPRB /)

RGHG4(:,11, 4) = (/ &
  & 0.56113318E-08_JPRB, 0.69503034E-08_JPRB, 0.82404483E-08_JPRB, 0.10165559E-07_JPRB, 0.12707075E-07_JPRB, 0.11660996E-08_JPRB, &
  & 0.13690171E-08_JPRB, 0.15331916E-08_JPRB, 0.16580822E-08_JPRB, 0.17508947E-08_JPRB, 0.18187178E-08_JPRB, 0.18651398E-08_JPRB, &
  & 0.18932498E-08_JPRB, 0.19115409E-08_JPRB, 0.19202608E-08_JPRB, 0.19234465E-08_JPRB, 0.19204613E-08_JPRB, 0.19174291E-08_JPRB, &
  & 0.19140263E-08_JPRB, 0.19095383E-08_JPRB, 0.19033914E-08_JPRB, 0.18948145E-08_JPRB, 0.18866115E-08_JPRB, 0.18831814E-08_JPRB, &
  & 0.18812270E-08_JPRB, 0.18796507E-08_JPRB, 0.18790969E-08_JPRB, 0.18789152E-08_JPRB, 0.18800339E-08_JPRB, 0.18760336E-08_JPRB, &
  & 0.18714947E-08_JPRB, 0.18572787E-08_JPRB, 0.18346721E-08_JPRB, 0.18166716E-08_JPRB, 0.17991341E-08_JPRB, 0.17790759E-08_JPRB, &
  & 0.17577279E-08_JPRB, 0.17348137E-08_JPRB, 0.17116378E-08_JPRB, 0.16879159E-08_JPRB, 0.16642211E-08_JPRB, 0.16392783E-08_JPRB, &
  & 0.16101019E-08_JPRB, 0.15800488E-08_JPRB, 0.15533790E-08_JPRB, 0.15282395E-08_JPRB, 0.15041387E-08_JPRB, 0.14813852E-08_JPRB, &
  & 0.14593892E-08_JPRB, 0.14365247E-08_JPRB, 0.14156875E-08_JPRB, 0.13983382E-08_JPRB, 0.13829609E-08_JPRB, 0.13684900E-08_JPRB, &
  & 0.13575409E-08_JPRB, 0.13500264E-08_JPRB, 0.13469306E-08_JPRB, 0.13478215E-08_JPRB, 0.13510484E-08_JPRB, 0.13605066E-08_JPRB, &
  & 0.13844197E-08_JPRB, 0.14199626E-08_JPRB, 0.14681828E-08_JPRB, 0.15391732E-08_JPRB /)

RGHG4(:,12, 4) = (/ &
  & 0.50056013E-08_JPRB, 0.61668413E-08_JPRB, 0.74656157E-08_JPRB, 0.95441735E-08_JPRB, 0.12346085E-07_JPRB, 0.15288846E-08_JPRB, &
  & 0.18580609E-08_JPRB, 0.21244484E-08_JPRB, 0.23419169E-08_JPRB, 0.25253928E-08_JPRB, 0.26843159E-08_JPRB, 0.28179570E-08_JPRB, &
  & 0.29255673E-08_JPRB, 0.30188456E-08_JPRB, 0.30943457E-08_JPRB, 0.31520746E-08_JPRB, 0.31910705E-08_JPRB, 0.32215350E-08_JPRB, &
  & 0.32434206E-08_JPRB, 0.32559582E-08_JPRB, 0.32599807E-08_JPRB, 0.32543319E-08_JPRB, 0.32418270E-08_JPRB, 0.32326477E-08_JPRB, &
  & 0.32225971E-08_JPRB, 0.32110079E-08_JPRB, 0.31991896E-08_JPRB, 0.31870233E-08_JPRB, 0.31762675E-08_JPRB, 0.31636906E-08_JPRB, &
  & 0.31525031E-08_JPRB, 0.31283849E-08_JPRB, 0.30947869E-08_JPRB, 0.30700433E-08_JPRB, 0.30458454E-08_JPRB, 0.30180005E-08_JPRB, &
  & 0.29872855E-08_JPRB, 0.29530569E-08_JPRB, 0.29183918E-08_JPRB, 0.28838418E-08_JPRB, 0.28484932E-08_JPRB, 0.28098421E-08_JPRB, &
  & 0.27629852E-08_JPRB, 0.27140463E-08_JPRB, 0.26665694E-08_JPRB, 0.26184575E-08_JPRB, 0.25704734E-08_JPRB, 0.25234483E-08_JPRB, &
  & 0.24769091E-08_JPRB, 0.24282398E-08_JPRB, 0.23834270E-08_JPRB, 0.23435600E-08_JPRB, 0.23063798E-08_JPRB, 0.22690854E-08_JPRB, &
  & 0.22348554E-08_JPRB, 0.22023188E-08_JPRB, 0.21723496E-08_JPRB, 0.21447657E-08_JPRB, 0.21175963E-08_JPRB, 0.20921549E-08_JPRB, &
  & 0.20821349E-08_JPRB, 0.20871609E-08_JPRB, 0.21098350E-08_JPRB, 0.21503281E-08_JPRB /)

RGHG4(:,13, 4) = (/ &
  & 0.40098791E-08_JPRB, 0.51413136E-08_JPRB, 0.63297367E-08_JPRB, 0.84159391E-08_JPRB, 0.11212060E-07_JPRB, 0.17863486E-08_JPRB, &
  & 0.22633655E-08_JPRB, 0.26235552E-08_JPRB, 0.29195624E-08_JPRB, 0.31807927E-08_JPRB, 0.34209475E-08_JPRB, 0.36359262E-08_JPRB, &
  & 0.38203329E-08_JPRB, 0.39882284E-08_JPRB, 0.41373669E-08_JPRB, 0.42617807E-08_JPRB, 0.43596087E-08_JPRB, 0.44430952E-08_JPRB, &
  & 0.45111372E-08_JPRB, 0.45649529E-08_JPRB, 0.46053192E-08_JPRB, 0.46329482E-08_JPRB, 0.46457158E-08_JPRB, 0.46587632E-08_JPRB, &
  & 0.46666866E-08_JPRB, 0.46688413E-08_JPRB, 0.46656150E-08_JPRB, 0.46576600E-08_JPRB, 0.46470672E-08_JPRB, 0.46333901E-08_JPRB, &
  & 0.46223780E-08_JPRB, 0.46009907E-08_JPRB, 0.45673834E-08_JPRB, 0.45421351E-08_JPRB, 0.45170436E-08_JPRB, 0.44886810E-08_JPRB, &
  & 0.44586730E-08_JPRB, 0.44258619E-08_JPRB, 0.43893165E-08_JPRB, 0.43499231E-08_JPRB, 0.43071160E-08_JPRB, 0.42569370E-08_JPRB, &
  & 0.41925539E-08_JPRB, 0.41238102E-08_JPRB, 0.40494905E-08_JPRB, 0.39694861E-08_JPRB, 0.38843693E-08_JPRB, 0.37965742E-08_JPRB, &
  & 0.37059671E-08_JPRB, 0.36118519E-08_JPRB, 0.35243914E-08_JPRB, 0.34418710E-08_JPRB, 0.33606709E-08_JPRB, 0.32770617E-08_JPRB, &
  & 0.31961676E-08_JPRB, 0.31145655E-08_JPRB, 0.30346046E-08_JPRB, 0.29577545E-08_JPRB, 0.28829814E-08_JPRB, 0.28089304E-08_JPRB, &
  & 0.27532054E-08_JPRB, 0.27160936E-08_JPRB, 0.27061893E-08_JPRB, 0.27180955E-08_JPRB /)

RGHG4(:,14, 4) = (/ &
  & 0.31386753E-08_JPRB, 0.41765031E-08_JPRB, 0.52985629E-08_JPRB, 0.72515096E-08_JPRB, 0.99416377E-08_JPRB, 0.19300079E-08_JPRB, &
  & 0.25157247E-08_JPRB, 0.29582214E-08_JPRB, 0.33087848E-08_JPRB, 0.36139483E-08_JPRB, 0.38994066E-08_JPRB, 0.41650448E-08_JPRB, &
  & 0.44021036E-08_JPRB, 0.46216075E-08_JPRB, 0.48213140E-08_JPRB, 0.49957309E-08_JPRB, 0.51415121E-08_JPRB, 0.52722777E-08_JPRB, &
  & 0.53852349E-08_JPRB, 0.54831051E-08_JPRB, 0.55681197E-08_JPRB, 0.56413416E-08_JPRB, 0.57003509E-08_JPRB, 0.57572995E-08_JPRB, &
  & 0.58077307E-08_JPRB, 0.58474416E-08_JPRB, 0.58774710E-08_JPRB, 0.58957839E-08_JPRB, 0.59076584E-08_JPRB, 0.59142335E-08_JPRB, &
  & 0.59194516E-08_JPRB, 0.59174150E-08_JPRB, 0.59005894E-08_JPRB, 0.58856471E-08_JPRB, 0.58705005E-08_JPRB, 0.58513261E-08_JPRB, &
  & 0.58274328E-08_JPRB, 0.58005170E-08_JPRB, 0.57695742E-08_JPRB, 0.57353766E-08_JPRB, 0.56958882E-08_JPRB, 0.56436988E-08_JPRB, &
  & 0.55699236E-08_JPRB, 0.54888023E-08_JPRB, 0.53939049E-08_JPRB, 0.52854761E-08_JPRB, 0.51645546E-08_JPRB, 0.50353282E-08_JPRB, &
  & 0.48988835E-08_JPRB, 0.47548299E-08_JPRB, 0.46177027E-08_JPRB, 0.44842179E-08_JPRB, 0.43507078E-08_JPRB, 0.42128243E-08_JPRB, &
  & 0.40782080E-08_JPRB, 0.39415204E-08_JPRB, 0.38073278E-08_JPRB, 0.36784897E-08_JPRB, 0.35562531E-08_JPRB, 0.34375072E-08_JPRB, &
  & 0.33367866E-08_JPRB, 0.32620922E-08_JPRB, 0.32189482E-08_JPRB, 0.32055891E-08_JPRB /)

RGHG4(:,15, 4) = (/ &
  & 0.24869058E-08_JPRB, 0.34023728E-08_JPRB, 0.43866657E-08_JPRB, 0.60879848E-08_JPRB, 0.85260448E-08_JPRB, 0.19880915E-08_JPRB, &
  & 0.25426956E-08_JPRB, 0.30711129E-08_JPRB, 0.34710006E-08_JPRB, 0.38039185E-08_JPRB, 0.41073385E-08_JPRB, 0.43918780E-08_JPRB, &
  & 0.46519646E-08_JPRB, 0.48978728E-08_JPRB, 0.51221303E-08_JPRB, 0.53183666E-08_JPRB, 0.54854223E-08_JPRB, 0.56395710E-08_JPRB, &
  & 0.57786989E-08_JPRB, 0.59034102E-08_JPRB, 0.60184839E-08_JPRB, 0.61255498E-08_JPRB, 0.62241208E-08_JPRB, 0.63235217E-08_JPRB, &
  & 0.64176171E-08_JPRB, 0.64968124E-08_JPRB, 0.65636292E-08_JPRB, 0.66161427E-08_JPRB, 0.66582557E-08_JPRB, 0.66932913E-08_JPRB, &
  & 0.67267942E-08_JPRB, 0.67548309E-08_JPRB, 0.67655761E-08_JPRB, 0.67779156E-08_JPRB, 0.67841750E-08_JPRB, 0.67792891E-08_JPRB, &
  & 0.67635755E-08_JPRB, 0.67386594E-08_JPRB, 0.67088548E-08_JPRB, 0.66717067E-08_JPRB, 0.66247039E-08_JPRB, 0.65653483E-08_JPRB, &
  & 0.64864638E-08_JPRB, 0.64059464E-08_JPRB, 0.63113834E-08_JPRB, 0.61976455E-08_JPRB, 0.60646217E-08_JPRB, 0.59157581E-08_JPRB, &
  & 0.57530776E-08_JPRB, 0.55790430E-08_JPRB, 0.54131335E-08_JPRB, 0.52504250E-08_JPRB, 0.50852562E-08_JPRB, 0.49133293E-08_JPRB, &
  & 0.47444533E-08_JPRB, 0.45721338E-08_JPRB, 0.44024748E-08_JPRB, 0.42406634E-08_JPRB, 0.40893449E-08_JPRB, 0.39439514E-08_JPRB, &
  & 0.38116208E-08_JPRB, 0.37055861E-08_JPRB, 0.36402437E-08_JPRB, 0.36031711E-08_JPRB /)

RGHG4(:,16, 4) = (/ &
  & 0.18808994E-08_JPRB, 0.25791651E-08_JPRB, 0.33719794E-08_JPRB, 0.47488058E-08_JPRB, 0.67799184E-08_JPRB, 0.19108943E-08_JPRB, &
  & 0.24373819E-08_JPRB, 0.30369303E-08_JPRB, 0.34586198E-08_JPRB, 0.38015466E-08_JPRB, 0.41011949E-08_JPRB, 0.43772221E-08_JPRB, &
  & 0.46292312E-08_JPRB, 0.48705848E-08_JPRB, 0.50945088E-08_JPRB, 0.52908495E-08_JPRB, 0.54570357E-08_JPRB, 0.56117839E-08_JPRB, &
  & 0.57548419E-08_JPRB, 0.58873719E-08_JPRB, 0.60100338E-08_JPRB, 0.61297709E-08_JPRB, 0.62405867E-08_JPRB, 0.63581629E-08_JPRB, &
  & 0.64704104E-08_JPRB, 0.65725883E-08_JPRB, 0.66587513E-08_JPRB, 0.67386825E-08_JPRB, 0.68100374E-08_JPRB, 0.68814403E-08_JPRB, &
  & 0.69498109E-08_JPRB, 0.70152404E-08_JPRB, 0.70635848E-08_JPRB, 0.71110948E-08_JPRB, 0.71422606E-08_JPRB, 0.71518786E-08_JPRB, &
  & 0.71399207E-08_JPRB, 0.71087478E-08_JPRB, 0.70618458E-08_JPRB, 0.70083046E-08_JPRB, 0.69540746E-08_JPRB, 0.68912009E-08_JPRB, &
  & 0.68133645E-08_JPRB, 0.67429857E-08_JPRB, 0.66631389E-08_JPRB, 0.65632015E-08_JPRB, 0.64417218E-08_JPRB, 0.62997438E-08_JPRB, &
  & 0.61405143E-08_JPRB, 0.59651426E-08_JPRB, 0.57976619E-08_JPRB, 0.56309393E-08_JPRB, 0.54597806E-08_JPRB, 0.52797842E-08_JPRB, &
  & 0.51024514E-08_JPRB, 0.49198992E-08_JPRB, 0.47401745E-08_JPRB, 0.45692512E-08_JPRB, 0.44131911E-08_JPRB, 0.42650936E-08_JPRB, &
  & 0.41187138E-08_JPRB, 0.39989785E-08_JPRB, 0.39202757E-08_JPRB, 0.38843790E-08_JPRB /)

RGHG4(:,17, 4) = (/ &
  & 0.13165383E-08_JPRB, 0.18164867E-08_JPRB, 0.24369533E-08_JPRB, 0.35218477E-08_JPRB, 0.51541895E-08_JPRB, 0.17959566E-08_JPRB, &
  & 0.22469273E-08_JPRB, 0.27868972E-08_JPRB, 0.32476195E-08_JPRB, 0.35988312E-08_JPRB, 0.38909449E-08_JPRB, 0.41435992E-08_JPRB, &
  & 0.43649129E-08_JPRB, 0.45732120E-08_JPRB, 0.47671245E-08_JPRB, 0.49404267E-08_JPRB, 0.50872009E-08_JPRB, 0.52203402E-08_JPRB, &
  & 0.53439049E-08_JPRB, 0.54572200E-08_JPRB, 0.55682929E-08_JPRB, 0.56689564E-08_JPRB, 0.57687237E-08_JPRB, 0.58757474E-08_JPRB, &
  & 0.59721383E-08_JPRB, 0.60713603E-08_JPRB, 0.61541545E-08_JPRB, 0.62339507E-08_JPRB, 0.63201062E-08_JPRB, 0.64139845E-08_JPRB, &
  & 0.65139045E-08_JPRB, 0.66151302E-08_JPRB, 0.67041723E-08_JPRB, 0.67917734E-08_JPRB, 0.68567005E-08_JPRB, 0.68873387E-08_JPRB, &
  & 0.68808661E-08_JPRB, 0.68440613E-08_JPRB, 0.67857417E-08_JPRB, 0.67161809E-08_JPRB, 0.66454344E-08_JPRB, 0.65747474E-08_JPRB, &
  & 0.65009207E-08_JPRB, 0.64458789E-08_JPRB, 0.63880576E-08_JPRB, 0.63151306E-08_JPRB, 0.62226815E-08_JPRB, 0.61090581E-08_JPRB, &
  & 0.59775744E-08_JPRB, 0.58273533E-08_JPRB, 0.56829608E-08_JPRB, 0.55366103E-08_JPRB, 0.53845626E-08_JPRB, 0.52212634E-08_JPRB, &
  & 0.50595412E-08_JPRB, 0.48911555E-08_JPRB, 0.47250417E-08_JPRB, 0.45693018E-08_JPRB, 0.44314152E-08_JPRB, 0.43055017E-08_JPRB, &
  & 0.41666022E-08_JPRB, 0.40499617E-08_JPRB, 0.39755208E-08_JPRB, 0.39362846E-08_JPRB /)

RGHG4(:,18, 4) = (/ &
  & 0.87371094E-09_JPRB, 0.12426411E-08_JPRB, 0.17125673E-08_JPRB, 0.25195084E-08_JPRB, 0.38162398E-08_JPRB, 0.15929069E-08_JPRB, &
  & 0.20319981E-08_JPRB, 0.24657953E-08_JPRB, 0.29380223E-08_JPRB, 0.32813128E-08_JPRB, 0.35509775E-08_JPRB, 0.37669223E-08_JPRB, &
  & 0.39472581E-08_JPRB, 0.41088399E-08_JPRB, 0.42552077E-08_JPRB, 0.43857940E-08_JPRB, 0.44986974E-08_JPRB, 0.46005839E-08_JPRB, &
  & 0.46907851E-08_JPRB, 0.47749817E-08_JPRB, 0.48526663E-08_JPRB, 0.49262767E-08_JPRB, 0.49986144E-08_JPRB, 0.50698321E-08_JPRB, &
  & 0.51480051E-08_JPRB, 0.52153055E-08_JPRB, 0.52774238E-08_JPRB, 0.53371934E-08_JPRB, 0.54114682E-08_JPRB, 0.55027414E-08_JPRB, &
  & 0.56132223E-08_JPRB, 0.57313678E-08_JPRB, 0.58437841E-08_JPRB, 0.59557563E-08_JPRB, 0.60439396E-08_JPRB, 0.60926957E-08_JPRB, &
  & 0.60971743E-08_JPRB, 0.60602559E-08_JPRB, 0.59968195E-08_JPRB, 0.59215139E-08_JPRB, 0.58485954E-08_JPRB, 0.57859810E-08_JPRB, &
  & 0.57291913E-08_JPRB, 0.56977520E-08_JPRB, 0.56710983E-08_JPRB, 0.56364713E-08_JPRB, 0.55872396E-08_JPRB, 0.55195537E-08_JPRB, &
  & 0.54334861E-08_JPRB, 0.53269060E-08_JPRB, 0.52214983E-08_JPRB, 0.51105986E-08_JPRB, 0.49915680E-08_JPRB, 0.48594750E-08_JPRB, &
  & 0.47280033E-08_JPRB, 0.45891233E-08_JPRB, 0.44524087E-08_JPRB, 0.43265107E-08_JPRB, 0.42223802E-08_JPRB, 0.41350781E-08_JPRB, &
  & 0.40186552E-08_JPRB, 0.39170542E-08_JPRB, 0.38530299E-08_JPRB, 0.38143222E-08_JPRB /)

RGHG4(:,19, 4) = (/ &
  & 0.55526944E-09_JPRB, 0.81158680E-09_JPRB, 0.11423595E-08_JPRB, 0.17217534E-08_JPRB, 0.26678058E-08_JPRB, 0.13792285E-08_JPRB, &
  & 0.17355808E-08_JPRB, 0.21124740E-08_JPRB, 0.24735545E-08_JPRB, 0.28214653E-08_JPRB, 0.30774026E-08_JPRB, 0.32689649E-08_JPRB, &
  & 0.34126821E-08_JPRB, 0.35308443E-08_JPRB, 0.36330625E-08_JPRB, 0.37190127E-08_JPRB, 0.37921852E-08_JPRB, 0.38603218E-08_JPRB, &
  & 0.39197237E-08_JPRB, 0.39702792E-08_JPRB, 0.40138755E-08_JPRB, 0.40603823E-08_JPRB, 0.40894408E-08_JPRB, 0.41360182E-08_JPRB, &
  & 0.41754653E-08_JPRB, 0.42097952E-08_JPRB, 0.42453165E-08_JPRB, 0.42808157E-08_JPRB, 0.43274868E-08_JPRB, 0.43938031E-08_JPRB, &
  & 0.44819575E-08_JPRB, 0.45823967E-08_JPRB, 0.46846553E-08_JPRB, 0.47891171E-08_JPRB, 0.48746056E-08_JPRB, 0.49298921E-08_JPRB, &
  & 0.49426321E-08_JPRB, 0.49197530E-08_JPRB, 0.48757074E-08_JPRB, 0.48230242E-08_JPRB, 0.47744870E-08_JPRB, 0.47387063E-08_JPRB, &
  & 0.47143738E-08_JPRB, 0.47175832E-08_JPRB, 0.47292730E-08_JPRB, 0.47368536E-08_JPRB, 0.47334172E-08_JPRB, 0.47146527E-08_JPRB, &
  & 0.46780984E-08_JPRB, 0.46202171E-08_JPRB, 0.45587574E-08_JPRB, 0.44891091E-08_JPRB, 0.44094111E-08_JPRB, 0.43163362E-08_JPRB, &
  & 0.42222719E-08_JPRB, 0.41208277E-08_JPRB, 0.40214809E-08_JPRB, 0.39339900E-08_JPRB, 0.38715968E-08_JPRB, 0.38319401E-08_JPRB, &
  & 0.37451757E-08_JPRB, 0.36670940E-08_JPRB, 0.36177592E-08_JPRB, 0.35898120E-08_JPRB /)

RGHG4(:,20, 4) = (/ &
  & 0.34812789E-09_JPRB, 0.51696675E-09_JPRB, 0.75742679E-09_JPRB, 0.11658116E-08_JPRB, 0.18626956E-08_JPRB, 0.11660599E-08_JPRB, &
  & 0.14651612E-08_JPRB, 0.17767883E-08_JPRB, 0.20545408E-08_JPRB, 0.23260585E-08_JPRB, 0.25460554E-08_JPRB, 0.27099762E-08_JPRB, &
  & 0.28277245E-08_JPRB, 0.29126324E-08_JPRB, 0.29793501E-08_JPRB, 0.30309717E-08_JPRB, 0.30711245E-08_JPRB, 0.31068004E-08_JPRB, &
  & 0.31374907E-08_JPRB, 0.31614382E-08_JPRB, 0.31816034E-08_JPRB, 0.31957257E-08_JPRB, 0.32117311E-08_JPRB, 0.32238159E-08_JPRB, &
  & 0.32397289E-08_JPRB, 0.32544236E-08_JPRB, 0.32656908E-08_JPRB, 0.32822809E-08_JPRB, 0.33013694E-08_JPRB, 0.33314558E-08_JPRB, &
  & 0.33753988E-08_JPRB, 0.34312662E-08_JPRB, 0.34902461E-08_JPRB, 0.35566987E-08_JPRB, 0.36156291E-08_JPRB, 0.36568977E-08_JPRB, &
  & 0.36762897E-08_JPRB, 0.36768328E-08_JPRB, 0.36614960E-08_JPRB, 0.36465058E-08_JPRB, 0.36401113E-08_JPRB, 0.36465839E-08_JPRB, &
  & 0.36632937E-08_JPRB, 0.37022474E-08_JPRB, 0.37487080E-08_JPRB, 0.37937209E-08_JPRB, 0.38306358E-08_JPRB, 0.38536601E-08_JPRB, &
  & 0.38587387E-08_JPRB, 0.38430543E-08_JPRB, 0.38206949E-08_JPRB, 0.37894314E-08_JPRB, 0.37473047E-08_JPRB, 0.36924301E-08_JPRB, &
  & 0.36354393E-08_JPRB, 0.35722354E-08_JPRB, 0.35115766E-08_JPRB, 0.34635779E-08_JPRB, 0.34428158E-08_JPRB, 0.34485510E-08_JPRB, &
  & 0.33932892E-08_JPRB, 0.33340777E-08_JPRB, 0.32977920E-08_JPRB, 0.32573861E-08_JPRB /)

RGHG4(:,21, 4) = (/ &
  & 0.21791362E-09_JPRB, 0.33691491E-09_JPRB, 0.49871007E-09_JPRB, 0.79969481E-09_JPRB, 0.13109897E-08_JPRB, 0.93478159E-09_JPRB, &
  & 0.12076217E-08_JPRB, 0.14559158E-08_JPRB, 0.16603409E-08_JPRB, 0.18477011E-08_JPRB, 0.20347635E-08_JPRB, 0.21696518E-08_JPRB, &
  & 0.22582682E-08_JPRB, 0.23224898E-08_JPRB, 0.23647471E-08_JPRB, 0.23927851E-08_JPRB, 0.24112874E-08_JPRB, 0.24258324E-08_JPRB, &
  & 0.24372071E-08_JPRB, 0.24444664E-08_JPRB, 0.24473841E-08_JPRB, 0.24491915E-08_JPRB, 0.24443392E-08_JPRB, 0.24446691E-08_JPRB, &
  & 0.24481541E-08_JPRB, 0.24483002E-08_JPRB, 0.24454434E-08_JPRB, 0.24398403E-08_JPRB, 0.24348552E-08_JPRB, 0.24358806E-08_JPRB, &
  & 0.24419062E-08_JPRB, 0.24544848E-08_JPRB, 0.24696660E-08_JPRB, 0.24952087E-08_JPRB, 0.25226921E-08_JPRB, 0.25478442E-08_JPRB, &
  & 0.25649396E-08_JPRB, 0.25787124E-08_JPRB, 0.25920179E-08_JPRB, 0.26130600E-08_JPRB, 0.26457134E-08_JPRB, 0.26910443E-08_JPRB, &
  & 0.27445690E-08_JPRB, 0.28143490E-08_JPRB, 0.28892868E-08_JPRB, 0.29608078E-08_JPRB, 0.30228156E-08_JPRB, 0.30714866E-08_JPRB, &
  & 0.31040146E-08_JPRB, 0.31198808E-08_JPRB, 0.31285141E-08_JPRB, 0.31270881E-08_JPRB, 0.31149645E-08_JPRB, 0.30916603E-08_JPRB, &
  & 0.30655309E-08_JPRB, 0.30347005E-08_JPRB, 0.30070375E-08_JPRB, 0.29926328E-08_JPRB, 0.30068648E-08_JPRB, 0.30499476E-08_JPRB, &
  & 0.30206271E-08_JPRB, 0.29804927E-08_JPRB, 0.29500475E-08_JPRB, 0.29067577E-08_JPRB /)

RGHG4(:,22, 4) = (/ &
  & 0.13900021E-09_JPRB, 0.22099260E-09_JPRB, 0.33688555E-09_JPRB, 0.54057109E-09_JPRB, 0.90548069E-09_JPRB, 0.74042183E-09_JPRB, &
  & 0.94893982E-09_JPRB, 0.11638098E-08_JPRB, 0.13327104E-08_JPRB, 0.14600474E-08_JPRB, 0.15728263E-08_JPRB, 0.16810642E-08_JPRB, &
  & 0.17490844E-08_JPRB, 0.17859825E-08_JPRB, 0.18048185E-08_JPRB, 0.18139962E-08_JPRB, 0.18172038E-08_JPRB, 0.18181886E-08_JPRB, &
  & 0.18174697E-08_JPRB, 0.18147381E-08_JPRB, 0.18107443E-08_JPRB, 0.18048427E-08_JPRB, 0.17973916E-08_JPRB, 0.17943647E-08_JPRB, &
  & 0.17928942E-08_JPRB, 0.17904161E-08_JPRB, 0.17852959E-08_JPRB, 0.17759051E-08_JPRB, 0.17605790E-08_JPRB, 0.17414752E-08_JPRB, &
  & 0.17225350E-08_JPRB, 0.17047210E-08_JPRB, 0.16892147E-08_JPRB, 0.16845679E-08_JPRB, 0.16872937E-08_JPRB, 0.16968765E-08_JPRB, &
  & 0.17114716E-08_JPRB, 0.17341549E-08_JPRB, 0.17657733E-08_JPRB, 0.18095576E-08_JPRB, 0.18658821E-08_JPRB, 0.19327713E-08_JPRB, &
  & 0.20046895E-08_JPRB, 0.20861386E-08_JPRB, 0.21688693E-08_JPRB, 0.22497402E-08_JPRB, 0.23251314E-08_JPRB, 0.23945776E-08_JPRB, &
  & 0.24489053E-08_JPRB, 0.24865263E-08_JPRB, 0.25153453E-08_JPRB, 0.25341458E-08_JPRB, 0.25427751E-08_JPRB, 0.25417779E-08_JPRB, &
  & 0.25378761E-08_JPRB, 0.25311546E-08_JPRB, 0.25287259E-08_JPRB, 0.25403351E-08_JPRB, 0.25803981E-08_JPRB, 0.26491975E-08_JPRB, &
  & 0.26428417E-08_JPRB, 0.26143854E-08_JPRB, 0.25912488E-08_JPRB, 0.25398847E-08_JPRB /)

RGHG4(:,23, 4) = (/ &
  & 0.92891507E-10_JPRB, 0.15000889E-09_JPRB, 0.23699595E-09_JPRB, 0.38566689E-09_JPRB, 0.65071321E-09_JPRB, 0.59812838E-09_JPRB, &
  & 0.77140216E-09_JPRB, 0.94525421E-09_JPRB, 0.10756791E-08_JPRB, 0.11666865E-08_JPRB, 0.12416351E-08_JPRB, 0.13105275E-08_JPRB, &
  & 0.13560401E-08_JPRB, 0.13796818E-08_JPRB, 0.13891198E-08_JPRB, 0.13898697E-08_JPRB, 0.13857016E-08_JPRB, 0.13797022E-08_JPRB, &
  & 0.13725726E-08_JPRB, 0.13649776E-08_JPRB, 0.13569524E-08_JPRB, 0.13483791E-08_JPRB, 0.13392405E-08_JPRB, 0.13332649E-08_JPRB, &
  & 0.13293788E-08_JPRB, 0.13244360E-08_JPRB, 0.13169916E-08_JPRB, 0.13040415E-08_JPRB, 0.12845953E-08_JPRB, 0.12586450E-08_JPRB, &
  & 0.12288179E-08_JPRB, 0.11969379E-08_JPRB, 0.11682361E-08_JPRB, 0.11493750E-08_JPRB, 0.11410092E-08_JPRB, 0.11436793E-08_JPRB, &
  & 0.11574970E-08_JPRB, 0.11842896E-08_JPRB, 0.12236794E-08_JPRB, 0.12766879E-08_JPRB, 0.13413541E-08_JPRB, 0.14155471E-08_JPRB, &
  & 0.14926408E-08_JPRB, 0.15748653E-08_JPRB, 0.16569197E-08_JPRB, 0.17362363E-08_JPRB, 0.18084920E-08_JPRB, 0.18712547E-08_JPRB, &
  & 0.19229933E-08_JPRB, 0.19647306E-08_JPRB, 0.19996611E-08_JPRB, 0.20264010E-08_JPRB, 0.20471835E-08_JPRB, 0.20636508E-08_JPRB, &
  & 0.20772726E-08_JPRB, 0.20889408E-08_JPRB, 0.21051156E-08_JPRB, 0.21349216E-08_JPRB, 0.21921951E-08_JPRB, 0.22770317E-08_JPRB, &
  & 0.22884756E-08_JPRB, 0.22744320E-08_JPRB, 0.22598123E-08_JPRB, 0.22170341E-08_JPRB /)

RGHG4(:,24, 4) = (/ &
  & 0.61762949E-10_JPRB, 0.10126225E-09_JPRB, 0.16126971E-09_JPRB, 0.27373814E-09_JPRB, 0.48190674E-09_JPRB, 0.48520621E-09_JPRB, &
  & 0.62913930E-09_JPRB, 0.77104684E-09_JPRB, 0.87354690E-09_JPRB, 0.94961139E-09_JPRB, 0.99932063E-09_JPRB, 0.10369632E-08_JPRB, &
  & 0.10686754E-08_JPRB, 0.10825046E-08_JPRB, 0.10857786E-08_JPRB, 0.10821030E-08_JPRB, 0.10741873E-08_JPRB, 0.10641537E-08_JPRB, &
  & 0.10534448E-08_JPRB, 0.10424608E-08_JPRB, 0.10312341E-08_JPRB, 0.10205335E-08_JPRB, 0.10096690E-08_JPRB, 0.10015347E-08_JPRB, &
  & 0.99479913E-09_JPRB, 0.98823172E-09_JPRB, 0.97965702E-09_JPRB, 0.96606922E-09_JPRB, 0.94611152E-09_JPRB, 0.91940344E-09_JPRB, &
  & 0.88806429E-09_JPRB, 0.85378526E-09_JPRB, 0.82292706E-09_JPRB, 0.80118512E-09_JPRB, 0.79061035E-09_JPRB, 0.79220186E-09_JPRB, &
  & 0.80680113E-09_JPRB, 0.83453894E-09_JPRB, 0.87521190E-09_JPRB, 0.92898550E-09_JPRB, 0.99298458E-09_JPRB, 0.10645129E-08_JPRB, &
  & 0.11376946E-08_JPRB, 0.12143212E-08_JPRB, 0.12900198E-08_JPRB, 0.13619983E-08_JPRB, 0.14266882E-08_JPRB, 0.14844140E-08_JPRB, &
  & 0.15356502E-08_JPRB, 0.15778721E-08_JPRB, 0.16134830E-08_JPRB, 0.16440358E-08_JPRB, 0.16681561E-08_JPRB, 0.16867563E-08_JPRB, &
  & 0.17040117E-08_JPRB, 0.17220845E-08_JPRB, 0.17469343E-08_JPRB, 0.17872014E-08_JPRB, 0.18550599E-08_JPRB, 0.19498814E-08_JPRB, &
  & 0.19768553E-08_JPRB, 0.19752968E-08_JPRB, 0.19728963E-08_JPRB, 0.19700079E-08_JPRB /)

RGHG4(:,25, 4) = (/ &
  & 0.44572967E-10_JPRB, 0.72686315E-10_JPRB, 0.12250793E-09_JPRB, 0.20596830E-09_JPRB, 0.36615025E-09_JPRB, 0.39815937E-09_JPRB, &
  & 0.51774701E-09_JPRB, 0.62660849E-09_JPRB, 0.72137574E-09_JPRB, 0.78741236E-09_JPRB, 0.82906287E-09_JPRB, 0.85649865E-09_JPRB, &
  & 0.87420859E-09_JPRB, 0.88073498E-09_JPRB, 0.87769170E-09_JPRB, 0.86890284E-09_JPRB, 0.85675333E-09_JPRB, 0.84298757E-09_JPRB, &
  & 0.82875179E-09_JPRB, 0.81444640E-09_JPRB, 0.80042956E-09_JPRB, 0.78737600E-09_JPRB, 0.77492851E-09_JPRB, 0.76489298E-09_JPRB, &
  & 0.75639262E-09_JPRB, 0.74850875E-09_JPRB, 0.73943235E-09_JPRB, 0.72595757E-09_JPRB, 0.70738787E-09_JPRB, 0.68294792E-09_JPRB, &
  & 0.65403871E-09_JPRB, 0.62318856E-09_JPRB, 0.59559491E-09_JPRB, 0.57625160E-09_JPRB, 0.56754107E-09_JPRB, 0.57068622E-09_JPRB, &
  & 0.58635158E-09_JPRB, 0.61492217E-09_JPRB, 0.65475397E-09_JPRB, 0.70501821E-09_JPRB, 0.76367324E-09_JPRB, 0.82858737E-09_JPRB, &
  & 0.89426699E-09_JPRB, 0.96227248E-09_JPRB, 0.10284944E-08_JPRB, 0.10912631E-08_JPRB, 0.11494791E-08_JPRB, 0.12032473E-08_JPRB, &
  & 0.12499370E-08_JPRB, 0.12894171E-08_JPRB, 0.13249208E-08_JPRB, 0.13539876E-08_JPRB, 0.13782954E-08_JPRB, 0.13997550E-08_JPRB, &
  & 0.14213541E-08_JPRB, 0.14451338E-08_JPRB, 0.14759941E-08_JPRB, 0.15219526E-08_JPRB, 0.15944817E-08_JPRB, 0.16935549E-08_JPRB, &
  & 0.17306031E-08_JPRB, 0.17412346E-08_JPRB, 0.17503916E-08_JPRB, 0.17823211E-08_JPRB /)

RGHG4(:,26, 4) = (/ &
  & 0.33988097E-10_JPRB, 0.53762904E-10_JPRB, 0.89375791E-10_JPRB, 0.15552595E-09_JPRB, 0.28102171E-09_JPRB, 0.32024733E-09_JPRB, &
  & 0.43260570E-09_JPRB, 0.52662336E-09_JPRB, 0.60697142E-09_JPRB, 0.65937672E-09_JPRB, 0.69514927E-09_JPRB, 0.71491990E-09_JPRB, &
  & 0.72537071E-09_JPRB, 0.72960438E-09_JPRB, 0.72534778E-09_JPRB, 0.71433198E-09_JPRB, 0.69951772E-09_JPRB, 0.68295086E-09_JPRB, &
  & 0.66600608E-09_JPRB, 0.64915773E-09_JPRB, 0.63313843E-09_JPRB, 0.61814087E-09_JPRB, 0.60441491E-09_JPRB, 0.59270289E-09_JPRB, &
  & 0.58273808E-09_JPRB, 0.57375060E-09_JPRB, 0.56372690E-09_JPRB, 0.55164112E-09_JPRB, 0.53474536E-09_JPRB, 0.51368870E-09_JPRB, &
  & 0.48931398E-09_JPRB, 0.46406129E-09_JPRB, 0.44163045E-09_JPRB, 0.42643042E-09_JPRB, 0.42092718E-09_JPRB, 0.42633111E-09_JPRB, &
  & 0.44337567E-09_JPRB, 0.47060061E-09_JPRB, 0.50768673E-09_JPRB, 0.55370192E-09_JPRB, 0.60582139E-09_JPRB, 0.66219197E-09_JPRB, &
  & 0.71939144E-09_JPRB, 0.77770823E-09_JPRB, 0.83456103E-09_JPRB, 0.88910879E-09_JPRB, 0.94024066E-09_JPRB, 0.98648223E-09_JPRB, &
  & 0.10278169E-08_JPRB, 0.10644567E-08_JPRB, 0.10964892E-08_JPRB, 0.11254102E-08_JPRB, 0.11513340E-08_JPRB, 0.11745873E-08_JPRB, &
  & 0.11982237E-08_JPRB, 0.12248170E-08_JPRB, 0.12589948E-08_JPRB, 0.13081898E-08_JPRB, 0.13835652E-08_JPRB, 0.14854626E-08_JPRB, &
  & 0.15306834E-08_JPRB, 0.15503079E-08_JPRB, 0.15796889E-08_JPRB, 0.16324311E-08_JPRB /)

RGHG4(:,27, 4) = (/ &
  & 0.26630842E-10_JPRB, 0.44038745E-10_JPRB, 0.76020523E-10_JPRB, 0.12933644E-09_JPRB, 0.23088187E-09_JPRB, 0.27209843E-09_JPRB, &
  & 0.36114828E-09_JPRB, 0.45090584E-09_JPRB, 0.52176818E-09_JPRB, 0.56739058E-09_JPRB, 0.59766486E-09_JPRB, 0.61291427E-09_JPRB, &
  & 0.61854410E-09_JPRB, 0.61799910E-09_JPRB, 0.61078681E-09_JPRB, 0.59800376E-09_JPRB, 0.58163896E-09_JPRB, 0.56327587E-09_JPRB, &
  & 0.54437099E-09_JPRB, 0.52564458E-09_JPRB, 0.50790738E-09_JPRB, 0.49136833E-09_JPRB, 0.47643456E-09_JPRB, 0.46332238E-09_JPRB, &
  & 0.45218770E-09_JPRB, 0.44198084E-09_JPRB, 0.43180534E-09_JPRB, 0.42003834E-09_JPRB, 0.40547202E-09_JPRB, 0.38826539E-09_JPRB, &
  & 0.36873490E-09_JPRB, 0.34902106E-09_JPRB, 0.33191350E-09_JPRB, 0.32098793E-09_JPRB, 0.31856928E-09_JPRB, 0.32565975E-09_JPRB, &
  & 0.34227346E-09_JPRB, 0.36885542E-09_JPRB, 0.40324763E-09_JPRB, 0.44343940E-09_JPRB, 0.48844961E-09_JPRB, 0.53674065E-09_JPRB, &
  & 0.58548505E-09_JPRB, 0.63494032E-09_JPRB, 0.68345046E-09_JPRB, 0.73048401E-09_JPRB, 0.77453960E-09_JPRB, 0.81560503E-09_JPRB, &
  & 0.85344171E-09_JPRB, 0.88691859E-09_JPRB, 0.91763996E-09_JPRB, 0.94491404E-09_JPRB, 0.96948516E-09_JPRB, 0.99322450E-09_JPRB, &
  & 0.10180153E-08_JPRB, 0.10462281E-08_JPRB, 0.10820044E-08_JPRB, 0.11328340E-08_JPRB, 0.12097083E-08_JPRB, 0.13130843E-08_JPRB, &
  & 0.13660189E-08_JPRB, 0.13977973E-08_JPRB, 0.14360695E-08_JPRB, 0.14982328E-08_JPRB /)

RGHG4(:,28, 4) = (/ &
  & 0.20602796E-10_JPRB, 0.36037302E-10_JPRB, 0.60544257E-10_JPRB, 0.10571654E-09_JPRB, 0.18907237E-09_JPRB, 0.23154469E-09_JPRB, &
  & 0.30991398E-09_JPRB, 0.38847803E-09_JPRB, 0.45115273E-09_JPRB, 0.49220167E-09_JPRB, 0.51849802E-09_JPRB, 0.53326532E-09_JPRB, &
  & 0.53655230E-09_JPRB, 0.53246707E-09_JPRB, 0.52300514E-09_JPRB, 0.50856735E-09_JPRB, 0.49099186E-09_JPRB, 0.47160226E-09_JPRB, &
  & 0.45142981E-09_JPRB, 0.43136583E-09_JPRB, 0.41225154E-09_JPRB, 0.39439754E-09_JPRB, 0.37828568E-09_JPRB, 0.36414671E-09_JPRB, &
  & 0.35196682E-09_JPRB, 0.34102038E-09_JPRB, 0.33078498E-09_JPRB, 0.31971423E-09_JPRB, 0.30737485E-09_JPRB, 0.29358116E-09_JPRB, &
  & 0.27861910E-09_JPRB, 0.26392546E-09_JPRB, 0.25177599E-09_JPRB, 0.24461635E-09_JPRB, 0.24479105E-09_JPRB, 0.25292085E-09_JPRB, &
  & 0.26995736E-09_JPRB, 0.29398334E-09_JPRB, 0.32361969E-09_JPRB, 0.35849651E-09_JPRB, 0.39703016E-09_JPRB, 0.43767884E-09_JPRB, &
  & 0.47890836E-09_JPRB, 0.52071125E-09_JPRB, 0.56249139E-09_JPRB, 0.60302063E-09_JPRB, 0.64166100E-09_JPRB, 0.67826322E-09_JPRB, &
  & 0.71189427E-09_JPRB, 0.74208573E-09_JPRB, 0.76997303E-09_JPRB, 0.79575396E-09_JPRB, 0.82025786E-09_JPRB, 0.84394575E-09_JPRB, &
  & 0.86899976E-09_JPRB, 0.89791352E-09_JPRB, 0.93462593E-09_JPRB, 0.98598529E-09_JPRB, 0.10623995E-08_JPRB, 0.11654575E-08_JPRB, &
  & 0.12228170E-08_JPRB, 0.12634532E-08_JPRB, 0.13083138E-08_JPRB, 0.13766931E-08_JPRB /)

RGHG4(:,29, 4) = (/ &
  & 0.15922146E-10_JPRB, 0.31252046E-10_JPRB, 0.52681044E-10_JPRB, 0.89234647E-10_JPRB, 0.16237500E-09_JPRB, 0.20131757E-09_JPRB, &
  & 0.26926586E-09_JPRB, 0.33752623E-09_JPRB, 0.38949491E-09_JPRB, 0.43008497E-09_JPRB, 0.45417362E-09_JPRB, 0.46741372E-09_JPRB, &
  & 0.46999982E-09_JPRB, 0.46514312E-09_JPRB, 0.45456786E-09_JPRB, 0.43872672E-09_JPRB, 0.41916684E-09_JPRB, 0.39816822E-09_JPRB, &
  & 0.37666756E-09_JPRB, 0.35544115E-09_JPRB, 0.33508951E-09_JPRB, 0.31638836E-09_JPRB, 0.29924446E-09_JPRB, 0.28460834E-09_JPRB, &
  & 0.27158406E-09_JPRB, 0.26037755E-09_JPRB, 0.25010707E-09_JPRB, 0.23995633E-09_JPRB, 0.22973093E-09_JPRB, 0.21902127E-09_JPRB, &
  & 0.20798684E-09_JPRB, 0.19759325E-09_JPRB, 0.18953840E-09_JPRB, 0.18551699E-09_JPRB, 0.18746059E-09_JPRB, 0.19590891E-09_JPRB, &
  & 0.21090371E-09_JPRB, 0.23172059E-09_JPRB, 0.25831523E-09_JPRB, 0.28793554E-09_JPRB, 0.32008293E-09_JPRB, 0.35401068E-09_JPRB, &
  & 0.38860146E-09_JPRB, 0.42393913E-09_JPRB, 0.45981349E-09_JPRB, 0.49518473E-09_JPRB, 0.52927068E-09_JPRB, 0.56220212E-09_JPRB, &
  & 0.59297406E-09_JPRB, 0.62144762E-09_JPRB, 0.64794931E-09_JPRB, 0.67242029E-09_JPRB, 0.69586981E-09_JPRB, 0.71931344E-09_JPRB, &
  & 0.74434142E-09_JPRB, 0.77319906E-09_JPRB, 0.80942553E-09_JPRB, 0.86002544E-09_JPRB, 0.93479491E-09_JPRB, 0.10361754E-08_JPRB, &
  & 0.10969607E-08_JPRB, 0.11408632E-08_JPRB, 0.11871990E-08_JPRB, 0.12572323E-08_JPRB /)

RGHG4(:,30, 4) = (/ &
  & 0.14370601E-10_JPRB, 0.27289598E-10_JPRB, 0.46533725E-10_JPRB, 0.76758537E-10_JPRB, 0.13935619E-09_JPRB, 0.17887622E-09_JPRB, &
  & 0.23913446E-09_JPRB, 0.29893860E-09_JPRB, 0.34476172E-09_JPRB, 0.38129438E-09_JPRB, 0.40318812E-09_JPRB, 0.41467793E-09_JPRB, &
  & 0.41566814E-09_JPRB, 0.40886017E-09_JPRB, 0.39683187E-09_JPRB, 0.38102840E-09_JPRB, 0.36121800E-09_JPRB, 0.33922831E-09_JPRB, &
  & 0.31664596E-09_JPRB, 0.29465844E-09_JPRB, 0.27328204E-09_JPRB, 0.25397637E-09_JPRB, 0.23608063E-09_JPRB, 0.22104053E-09_JPRB, &
  & 0.20749698E-09_JPRB, 0.19642094E-09_JPRB, 0.18636806E-09_JPRB, 0.17726931E-09_JPRB, 0.16887171E-09_JPRB, 0.16080159E-09_JPRB, &
  & 0.15300629E-09_JPRB, 0.14615280E-09_JPRB, 0.14121181E-09_JPRB, 0.13967053E-09_JPRB, 0.14272153E-09_JPRB, 0.15091429E-09_JPRB, &
  & 0.16476101E-09_JPRB, 0.18365658E-09_JPRB, 0.20576427E-09_JPRB, 0.22994301E-09_JPRB, 0.25644264E-09_JPRB, 0.28466776E-09_JPRB, &
  & 0.31404052E-09_JPRB, 0.34414355E-09_JPRB, 0.37522843E-09_JPRB, 0.40636469E-09_JPRB, 0.43680581E-09_JPRB, 0.46656634E-09_JPRB, &
  & 0.49483873E-09_JPRB, 0.52109461E-09_JPRB, 0.54574295E-09_JPRB, 0.56934357E-09_JPRB, 0.59231797E-09_JPRB, 0.61525568E-09_JPRB, &
  & 0.63995736E-09_JPRB, 0.66841171E-09_JPRB, 0.70412570E-09_JPRB, 0.75347806E-09_JPRB, 0.82560997E-09_JPRB, 0.92335195E-09_JPRB, &
  & 0.98526431E-09_JPRB, 0.10309296E-08_JPRB, 0.10776159E-08_JPRB, 0.11467772E-08_JPRB /)

RGHG4(:,31, 4) = (/ &
  & 0.12132864E-10_JPRB, 0.23490520E-10_JPRB, 0.39678143E-10_JPRB, 0.68962058E-10_JPRB, 0.12283255E-09_JPRB, 0.15768087E-09_JPRB, &
  & 0.21189701E-09_JPRB, 0.26501434E-09_JPRB, 0.30620512E-09_JPRB, 0.33879743E-09_JPRB, 0.35829212E-09_JPRB, 0.36792686E-09_JPRB, &
  & 0.36960038E-09_JPRB, 0.36279199E-09_JPRB, 0.34972680E-09_JPRB, 0.33238773E-09_JPRB, 0.31184297E-09_JPRB, 0.28921168E-09_JPRB, &
  & 0.26581454E-09_JPRB, 0.24302407E-09_JPRB, 0.22117842E-09_JPRB, 0.20128833E-09_JPRB, 0.18322735E-09_JPRB, 0.16810831E-09_JPRB, &
  & 0.15462556E-09_JPRB, 0.14406096E-09_JPRB, 0.13460839E-09_JPRB, 0.12675841E-09_JPRB, 0.11996971E-09_JPRB, 0.11414633E-09_JPRB, &
  & 0.10897331E-09_JPRB, 0.10484794E-09_JPRB, 0.10236239E-09_JPRB, 0.10246251E-09_JPRB, 0.10601340E-09_JPRB, 0.11366062E-09_JPRB, &
  & 0.12552832E-09_JPRB, 0.14046840E-09_JPRB, 0.15849705E-09_JPRB, 0.17879795E-09_JPRB, 0.20087260E-09_JPRB, 0.22441782E-09_JPRB, &
  & 0.24926938E-09_JPRB, 0.27535027E-09_JPRB, 0.30265060E-09_JPRB, 0.33061981E-09_JPRB, 0.35825726E-09_JPRB, 0.38535472E-09_JPRB, &
  & 0.41146195E-09_JPRB, 0.43621576E-09_JPRB, 0.45970133E-09_JPRB, 0.48222804E-09_JPRB, 0.50424315E-09_JPRB, 0.52663096E-09_JPRB, &
  & 0.55070493E-09_JPRB, 0.57827976E-09_JPRB, 0.61265942E-09_JPRB, 0.65973060E-09_JPRB, 0.72876549E-09_JPRB, 0.82195289E-09_JPRB, &
  & 0.88295998E-09_JPRB, 0.92800256E-09_JPRB, 0.97298614E-09_JPRB, 0.10391284E-08_JPRB /)

RGHG4(:,32, 4) = (/ &
  & 0.10760958E-10_JPRB, 0.20200626E-10_JPRB, 0.34218614E-10_JPRB, 0.58945709E-10_JPRB, 0.10799638E-09_JPRB, 0.14021291E-09_JPRB, &
  & 0.18858409E-09_JPRB, 0.23617322E-09_JPRB, 0.27322361E-09_JPRB, 0.30260905E-09_JPRB, 0.32046468E-09_JPRB, 0.32879738E-09_JPRB, &
  & 0.32957206E-09_JPRB, 0.32257144E-09_JPRB, 0.30939662E-09_JPRB, 0.29162767E-09_JPRB, 0.27053226E-09_JPRB, 0.24732544E-09_JPRB, &
  & 0.22374352E-09_JPRB, 0.20043867E-09_JPRB, 0.17878445E-09_JPRB, 0.15887058E-09_JPRB, 0.14101777E-09_JPRB, 0.12627230E-09_JPRB, &
  & 0.11331999E-09_JPRB, 0.10333738E-09_JPRB, 0.94912592E-10_JPRB, 0.88136533E-10_JPRB, 0.82810918E-10_JPRB, 0.78597004E-10_JPRB, &
  & 0.75326204E-10_JPRB, 0.73128933E-10_JPRB, 0.72285913E-10_JPRB, 0.73443349E-10_JPRB, 0.77201037E-10_JPRB, 0.84006808E-10_JPRB, &
  & 0.93708388E-10_JPRB, 0.10601531E-09_JPRB, 0.12083481E-09_JPRB, 0.13760185E-09_JPRB, 0.15614218E-09_JPRB, 0.17609300E-09_JPRB, &
  & 0.19737353E-09_JPRB, 0.22003037E-09_JPRB, 0.24400523E-09_JPRB, 0.26887914E-09_JPRB, 0.29394062E-09_JPRB, 0.31874373E-09_JPRB, &
  & 0.34280526E-09_JPRB, 0.36596892E-09_JPRB, 0.38813611E-09_JPRB, 0.40970091E-09_JPRB, 0.43091694E-09_JPRB, 0.45246254E-09_JPRB, &
  & 0.47558291E-09_JPRB, 0.50199161E-09_JPRB, 0.53483468E-09_JPRB, 0.57951210E-09_JPRB, 0.64436051E-09_JPRB, 0.73190232E-09_JPRB, &
  & 0.79026968E-09_JPRB, 0.83367813E-09_JPRB, 0.87675278E-09_JPRB, 0.93977714E-09_JPRB /)

RGHG4(:,33, 4) = (/ &
  & 0.89859205E-11_JPRB, 0.17521823E-10_JPRB, 0.30153786E-10_JPRB, 0.51974210E-10_JPRB, 0.95044389E-10_JPRB, 0.12458237E-09_JPRB, &
  & 0.16747377E-09_JPRB, 0.20728891E-09_JPRB, 0.24256516E-09_JPRB, 0.26789035E-09_JPRB, 0.28606867E-09_JPRB, 0.29416192E-09_JPRB, &
  & 0.29448363E-09_JPRB, 0.28705710E-09_JPRB, 0.27378097E-09_JPRB, 0.25570460E-09_JPRB, 0.23446339E-09_JPRB, 0.21102402E-09_JPRB, &
  & 0.18742656E-09_JPRB, 0.16400702E-09_JPRB, 0.14250857E-09_JPRB, 0.12311696E-09_JPRB, 0.10587952E-09_JPRB, 0.91819732E-10_JPRB, &
  & 0.79987607E-10_JPRB, 0.70871434E-10_JPRB, 0.63712126E-10_JPRB, 0.58083149E-10_JPRB, 0.54038996E-10_JPRB, 0.51129306E-10_JPRB, &
  & 0.49241358E-10_JPRB, 0.48358314E-10_JPRB, 0.48575723E-10_JPRB, 0.50289457E-10_JPRB, 0.53856600E-10_JPRB, 0.59521589E-10_JPRB, &
  & 0.67360860E-10_JPRB, 0.77206290E-10_JPRB, 0.89144046E-10_JPRB, 0.10282166E-09_JPRB, 0.11827657E-09_JPRB, 0.13521492E-09_JPRB, &
  & 0.15374614E-09_JPRB, 0.17377991E-09_JPRB, 0.19517682E-09_JPRB, 0.21763853E-09_JPRB, 0.24050881E-09_JPRB, 0.26324273E-09_JPRB, &
  & 0.28553607E-09_JPRB, 0.30710617E-09_JPRB, 0.32801784E-09_JPRB, 0.34843822E-09_JPRB, 0.36850756E-09_JPRB, 0.38908074E-09_JPRB, &
  & 0.41111112E-09_JPRB, 0.43620110E-09_JPRB, 0.46707643E-09_JPRB, 0.50874399E-09_JPRB, 0.56897720E-09_JPRB, 0.64988165E-09_JPRB, &
  & 0.70501577E-09_JPRB, 0.74606982E-09_JPRB, 0.78667722E-09_JPRB, 0.84514246E-09_JPRB /)

RGHG4(:,34, 4) = (/ &
  & 0.81433575E-11_JPRB, 0.15602079E-10_JPRB, 0.27469685E-10_JPRB, 0.47695143E-10_JPRB, 0.85424209E-10_JPRB, 0.11133571E-09_JPRB, &
  & 0.15038182E-09_JPRB, 0.18590648E-09_JPRB, 0.21747283E-09_JPRB, 0.24008009E-09_JPRB, 0.25635821E-09_JPRB, 0.26353783E-09_JPRB, &
  & 0.26367344E-09_JPRB, 0.25631763E-09_JPRB, 0.24291483E-09_JPRB, 0.22486094E-09_JPRB, 0.20356347E-09_JPRB, 0.18020710E-09_JPRB, &
  & 0.15700748E-09_JPRB, 0.13416521E-09_JPRB, 0.11319272E-09_JPRB, 0.94690839E-10_JPRB, 0.78574799E-10_JPRB, 0.65558795E-10_JPRB, &
  & 0.55128725E-10_JPRB, 0.47084787E-10_JPRB, 0.41149941E-10_JPRB, 0.36626067E-10_JPRB, 0.33584309E-10_JPRB, 0.31640624E-10_JPRB, &
  & 0.30642166E-10_JPRB, 0.30535137E-10_JPRB, 0.31308910E-10_JPRB, 0.33194732E-10_JPRB, 0.36374553E-10_JPRB, 0.41014796E-10_JPRB, &
  & 0.47260133E-10_JPRB, 0.55044365E-10_JPRB, 0.64535072E-10_JPRB, 0.75834790E-10_JPRB, 0.88877843E-10_JPRB, 0.10348582E-09_JPRB, &
  & 0.11973462E-09_JPRB, 0.13756002E-09_JPRB, 0.15677054E-09_JPRB, 0.17703440E-09_JPRB, 0.19781232E-09_JPRB, 0.21860048E-09_JPRB, &
  & 0.23909216E-09_JPRB, 0.25911776E-09_JPRB, 0.27870259E-09_JPRB, 0.29783059E-09_JPRB, 0.31678718E-09_JPRB, 0.33614972E-09_JPRB, &
  & 0.35672995E-09_JPRB, 0.38007247E-09_JPRB, 0.40879355E-09_JPRB, 0.44754792E-09_JPRB, 0.50306670E-09_JPRB, 0.57719624E-09_JPRB, &
  & 0.62827776E-09_JPRB, 0.66685529E-09_JPRB, 0.70465811E-09_JPRB, 0.76082385E-09_JPRB /)

RGHG4(:,35, 4) = (/ &
  & 0.74618410E-11_JPRB, 0.14855804E-10_JPRB, 0.24296270E-10_JPRB, 0.42853745E-10_JPRB, 0.77684519E-10_JPRB, 0.10046590E-09_JPRB, &
  & 0.13506173E-09_JPRB, 0.16686889E-09_JPRB, 0.19480552E-09_JPRB, 0.21497164E-09_JPRB, 0.22947712E-09_JPRB, 0.23569435E-09_JPRB, &
  & 0.23491306E-09_JPRB, 0.22811468E-09_JPRB, 0.21509786E-09_JPRB, 0.19719196E-09_JPRB, 0.17622039E-09_JPRB, 0.15314347E-09_JPRB, &
  & 0.13032991E-09_JPRB, 0.10837413E-09_JPRB, 0.88355913E-10_JPRB, 0.70986668E-10_JPRB, 0.56396519E-10_JPRB, 0.44808563E-10_JPRB, &
  & 0.36033652E-10_JPRB, 0.29429868E-10_JPRB, 0.24786855E-10_JPRB, 0.21432897E-10_JPRB, 0.19281949E-10_JPRB, 0.18058530E-10_JPRB, &
  & 0.17609527E-10_JPRB, 0.17865693E-10_JPRB, 0.18793928E-10_JPRB, 0.20500579E-10_JPRB, 0.23080890E-10_JPRB, 0.26678756E-10_JPRB, &
  & 0.31376970E-10_JPRB, 0.37251716E-10_JPRB, 0.44578681E-10_JPRB, 0.53665312E-10_JPRB, 0.64648661E-10_JPRB, 0.77426905E-10_JPRB, &
  & 0.91978342E-10_JPRB, 0.10813923E-09_JPRB, 0.12559968E-09_JPRB, 0.14407883E-09_JPRB, 0.16298372E-09_JPRB, 0.18200037E-09_JPRB, &
  & 0.20091170E-09_JPRB, 0.21946178E-09_JPRB, 0.23763144E-09_JPRB, 0.25541610E-09_JPRB, 0.27300989E-09_JPRB, 0.29087979E-09_JPRB, &
  & 0.30991396E-09_JPRB, 0.33157027E-09_JPRB, 0.35804568E-09_JPRB, 0.39332981E-09_JPRB, 0.44351137E-09_JPRB, 0.51010496E-09_JPRB, &
  & 0.55714172E-09_JPRB, 0.59298044E-09_JPRB, 0.62831795E-09_JPRB, 0.68016842E-09_JPRB /)

RGHG4(:,36, 4) = (/ &
  & 0.70443946E-11_JPRB, 0.13284415E-10_JPRB, 0.23461927E-10_JPRB, 0.39732752E-10_JPRB, 0.71001968E-10_JPRB, 0.90406425E-10_JPRB, &
  & 0.12212088E-09_JPRB, 0.15032672E-09_JPRB, 0.17489647E-09_JPRB, 0.19275899E-09_JPRB, 0.20547750E-09_JPRB, 0.21110846E-09_JPRB, &
  & 0.21028485E-09_JPRB, 0.20337618E-09_JPRB, 0.19078411E-09_JPRB, 0.17339259E-09_JPRB, 0.15294833E-09_JPRB, 0.13064146E-09_JPRB, &
  & 0.10849018E-09_JPRB, 0.87487240E-10_JPRB, 0.68667606E-10_JPRB, 0.52686890E-10_JPRB, 0.39819148E-10_JPRB, 0.29940890E-10_JPRB, &
  & 0.22871956E-10_JPRB, 0.17830262E-10_JPRB, 0.14441341E-10_JPRB, 0.12136293E-10_JPRB, 0.10713127E-10_JPRB, 0.99705539E-11_JPRB, &
  & 0.97921836E-11_JPRB, 0.10116840E-10_JPRB, 0.10920425E-10_JPRB, 0.12252214E-10_JPRB, 0.14173744E-10_JPRB, 0.16794505E-10_JPRB, &
  & 0.20195153E-10_JPRB, 0.24544955E-10_JPRB, 0.30118644E-10_JPRB, 0.37293363E-10_JPRB, 0.46417287E-10_JPRB, 0.57633297E-10_JPRB, &
  & 0.70791831E-10_JPRB, 0.85547368E-10_JPRB, 0.10146011E-09_JPRB, 0.11816088E-09_JPRB, 0.13542438E-09_JPRB, 0.15289113E-09_JPRB, &
  & 0.17028511E-09_JPRB, 0.18746790E-09_JPRB, 0.20432349E-09_JPRB, 0.22078604E-09_JPRB, 0.23702748E-09_JPRB, 0.25348001E-09_JPRB, &
  & 0.27094382E-09_JPRB, 0.29059163E-09_JPRB, 0.31445199E-09_JPRB, 0.34630490E-09_JPRB, 0.39141906E-09_JPRB, 0.45078513E-09_JPRB, &
  & 0.49329907E-09_JPRB, 0.52604587E-09_JPRB, 0.55860766E-09_JPRB, 0.60834754E-09_JPRB /)

RGHG4(:,37, 4) = (/ &
  & 0.67073530E-11_JPRB, 0.12759549E-10_JPRB, 0.20564507E-10_JPRB, 0.35997261E-10_JPRB, 0.64127426E-10_JPRB, 0.81096505E-10_JPRB, &
  & 0.10978736E-09_JPRB, 0.13487594E-09_JPRB, 0.15651877E-09_JPRB, 0.17222108E-09_JPRB, 0.18337183E-09_JPRB, 0.18809862E-09_JPRB, &
  & 0.18719068E-09_JPRB, 0.18069123E-09_JPRB, 0.16853555E-09_JPRB, 0.15172708E-09_JPRB, 0.13197272E-09_JPRB, 0.11067364E-09_JPRB, &
  & 0.89568492E-10_JPRB, 0.69717697E-10_JPRB, 0.52216807E-10_JPRB, 0.37876882E-10_JPRB, 0.27012330E-10_JPRB, 0.19236781E-10_JPRB, &
  & 0.13987412E-10_JPRB, 0.10553391E-10_JPRB, 0.83037587E-11_JPRB, 0.68863569E-11_JPRB, 0.60110731E-11_JPRB, 0.55893948E-11_JPRB, &
  & 0.55112551E-11_JPRB, 0.57678727E-11_JPRB, 0.63378265E-11_JPRB, 0.72498726E-11_JPRB, 0.85418556E-11_JPRB, 0.10305637E-10_JPRB, &
  & 0.12625982E-10_JPRB, 0.15698942E-10_JPRB, 0.19793129E-10_JPRB, 0.25286996E-10_JPRB, 0.32638395E-10_JPRB, 0.42175492E-10_JPRB, &
  & 0.53851860E-10_JPRB, 0.67249782E-10_JPRB, 0.81772457E-10_JPRB, 0.97146180E-10_JPRB, 0.11296399E-09_JPRB, 0.12900153E-09_JPRB, &
  & 0.14510962E-09_JPRB, 0.16105398E-09_JPRB, 0.17666524E-09_JPRB, 0.19185062E-09_JPRB, 0.20670980E-09_JPRB, 0.22161398E-09_JPRB, &
  & 0.23729788E-09_JPRB, 0.25496250E-09_JPRB, 0.27649494E-09_JPRB, 0.30505470E-09_JPRB, 0.34497902E-09_JPRB, 0.39710032E-09_JPRB, &
  & 0.43532070E-09_JPRB, 0.46523799E-09_JPRB, 0.49499865E-09_JPRB, 0.54140298E-09_JPRB /)

RGHG4(:,38, 4) = (/ &
  & 0.64481875E-11_JPRB, 0.11687632E-10_JPRB, 0.19977705E-10_JPRB, 0.33083869E-10_JPRB, 0.59030565E-10_JPRB, 0.73717275E-10_JPRB, &
  & 0.99138114E-10_JPRB, 0.12112573E-09_JPRB, 0.13979856E-09_JPRB, 0.15346259E-09_JPRB, 0.16317127E-09_JPRB, 0.16750579E-09_JPRB, &
  & 0.16645241E-09_JPRB, 0.16021555E-09_JPRB, 0.14880085E-09_JPRB, 0.13291182E-09_JPRB, 0.11415752E-09_JPRB, 0.93815011E-10_JPRB, &
  & 0.73791827E-10_JPRB, 0.55367197E-10_JPRB, 0.39585245E-10_JPRB, 0.27166526E-10_JPRB, 0.18366563E-10_JPRB, 0.12632700E-10_JPRB, &
  & 0.89601070E-11_JPRB, 0.67235367E-11_JPRB, 0.52688583E-11_JPRB, 0.43941951E-11_JPRB, 0.38346236E-11_JPRB, 0.35827044E-11_JPRB, &
  & 0.35362034E-11_JPRB, 0.37156740E-11_JPRB, 0.41116160E-11_JPRB, 0.47327918E-11_JPRB, 0.56174297E-11_JPRB, 0.68125657E-11_JPRB, &
  & 0.84139041E-11_JPRB, 0.10590535E-10_JPRB, 0.13580301E-10_JPRB, 0.17764264E-10_JPRB, 0.23596099E-10_JPRB, 0.31478559E-10_JPRB, &
  & 0.41547429E-10_JPRB, 0.53423672E-10_JPRB, 0.66561069E-10_JPRB, 0.80411566E-10_JPRB, 0.94797177E-10_JPRB, 0.10955552E-09_JPRB, &
  & 0.12445868E-09_JPRB, 0.13930944E-09_JPRB, 0.15385418E-09_JPRB, 0.16791787E-09_JPRB, 0.18149220E-09_JPRB, 0.19496189E-09_JPRB, &
  & 0.20909517E-09_JPRB, 0.22489276E-09_JPRB, 0.24396407E-09_JPRB, 0.26920285E-09_JPRB, 0.30435507E-09_JPRB, 0.34987357E-09_JPRB, &
  & 0.38390693E-09_JPRB, 0.41073986E-09_JPRB, 0.43777951E-09_JPRB, 0.48027482E-09_JPRB /)

RGHG4(:,39, 4) = (/ &
  & 0.62080267E-11_JPRB, 0.11108897E-10_JPRB, 0.17451582E-10_JPRB, 0.30241195E-10_JPRB, 0.53559761E-10_JPRB, 0.66670863E-10_JPRB, &
  & 0.89368214E-10_JPRB, 0.10831001E-09_JPRB, 0.12425436E-09_JPRB, 0.13605346E-09_JPRB, 0.14435934E-09_JPRB, 0.14806605E-09_JPRB, &
  & 0.14717640E-09_JPRB, 0.14138134E-09_JPRB, 0.13070289E-09_JPRB, 0.11579022E-09_JPRB, 0.98186986E-10_JPRB, 0.79294987E-10_JPRB, &
  & 0.60657090E-10_JPRB, 0.43792043E-10_JPRB, 0.30044037E-10_JPRB, 0.19910490E-10_JPRB, 0.13040062E-10_JPRB, 0.88907172E-11_JPRB, &
  & 0.63309726E-11_JPRB, 0.48202488E-11_JPRB, 0.38255011E-11_JPRB, 0.32311658E-11_JPRB, 0.28399407E-11_JPRB, 0.26615884E-11_JPRB, &
  & 0.26260957E-11_JPRB, 0.27562572E-11_JPRB, 0.30491202E-11_JPRB, 0.35046597E-11_JPRB, 0.41582579E-11_JPRB, 0.50284273E-11_JPRB, &
  & 0.62095732E-11_JPRB, 0.78144696E-11_JPRB, 0.10068924E-10_JPRB, 0.13295007E-10_JPRB, 0.17925706E-10_JPRB, 0.24407448E-10_JPRB, &
  & 0.32902476E-10_JPRB, 0.43231804E-10_JPRB, 0.54745802E-10_JPRB, 0.67119373E-10_JPRB, 0.80049370E-10_JPRB, 0.93461190E-10_JPRB, &
  & 0.10723087E-09_JPRB, 0.12109570E-09_JPRB, 0.13465828E-09_JPRB, 0.14761488E-09_JPRB, 0.15993887E-09_JPRB, 0.17204714E-09_JPRB, &
  & 0.18458587E-09_JPRB, 0.19848913E-09_JPRB, 0.21538825E-09_JPRB, 0.23766022E-09_JPRB, 0.26838518E-09_JPRB, 0.30763742E-09_JPRB, &
  & 0.33754624E-09_JPRB, 0.36169590E-09_JPRB, 0.38634923E-09_JPRB, 0.42484649E-09_JPRB /)

RGHG4(:,40, 4) = (/ &
  & 0.59277804E-11_JPRB, 0.99530609E-11_JPRB, 0.16311707E-10_JPRB, 0.27002739E-10_JPRB, 0.48677371E-10_JPRB, 0.60216630E-10_JPRB, &
  & 0.80211483E-10_JPRB, 0.96582457E-10_JPRB, 0.11003476E-09_JPRB, 0.11994278E-09_JPRB, 0.12718104E-09_JPRB, 0.13044837E-09_JPRB, &
  & 0.12957543E-09_JPRB, 0.12427587E-09_JPRB, 0.11442949E-09_JPRB, 0.10065224E-09_JPRB, 0.84322375E-10_JPRB, 0.66877136E-10_JPRB, &
  & 0.50054190E-10_JPRB, 0.35090826E-10_JPRB, 0.23290932E-10_JPRB, 0.15201840E-10_JPRB, 0.99312121E-11_JPRB, 0.68310049E-11_JPRB, &
  & 0.49501831E-11_JPRB, 0.38462115E-11_JPRB, 0.31025783E-11_JPRB, 0.26539753E-11_JPRB, 0.23452028E-11_JPRB, 0.22056198E-11_JPRB, &
  & 0.21716511E-11_JPRB, 0.22728106E-11_JPRB, 0.25077121E-11_JPRB, 0.28704821E-11_JPRB, 0.34010954E-11_JPRB, 0.40828911E-11_JPRB, &
  & 0.50308000E-11_JPRB, 0.62817754E-11_JPRB, 0.80749565E-11_JPRB, 0.10626543E-10_JPRB, 0.14362186E-10_JPRB, 0.19652590E-10_JPRB, &
  & 0.26762533E-10_JPRB, 0.35495142E-10_JPRB, 0.45472893E-10_JPRB, 0.56209308E-10_JPRB, 0.67683185E-10_JPRB, 0.79853325E-10_JPRB, &
  & 0.92563936E-10_JPRB, 0.10551528E-09_JPRB, 0.11822719E-09_JPRB, 0.13025270E-09_JPRB, 0.14152576E-09_JPRB, 0.15234812E-09_JPRB, &
  & 0.16343749E-09_JPRB, 0.17570798E-09_JPRB, 0.19052120E-09_JPRB, 0.20995833E-09_JPRB, 0.23653010E-09_JPRB, 0.27006716E-09_JPRB, &
  & 0.29613062E-09_JPRB, 0.31754932E-09_JPRB, 0.33945041E-09_JPRB, 0.37441802E-09_JPRB /)

RGHG4(:,41, 4) = (/ &
  & 0.56416551E-11_JPRB, 0.92644486E-11_JPRB, 0.14024391E-10_JPRB, 0.24003934E-10_JPRB, 0.43371830E-10_JPRB, 0.54007743E-10_JPRB, &
  & 0.71806588E-10_JPRB, 0.85801942E-10_JPRB, 0.96978293E-10_JPRB, 0.10530976E-09_JPRB, 0.11130182E-09_JPRB, 0.11412851E-09_JPRB, &
  & 0.11342721E-09_JPRB, 0.10870255E-09_JPRB, 0.99755891E-10_JPRB, 0.87231652E-10_JPRB, 0.72376952E-10_JPRB, 0.56554476E-10_JPRB, &
  & 0.41469925E-10_JPRB, 0.28697288E-10_JPRB, 0.18791755E-10_JPRB, 0.12228341E-10_JPRB, 0.80971861E-11_JPRB, 0.56731629E-11_JPRB, &
  & 0.42058865E-11_JPRB, 0.33122823E-11_JPRB, 0.27351420E-11_JPRB, 0.23393483E-11_JPRB, 0.20988879E-11_JPRB, 0.19569320E-11_JPRB, &
  & 0.19329761E-11_JPRB, 0.20110719E-11_JPRB, 0.22123323E-11_JPRB, 0.25296208E-11_JPRB, 0.29823019E-11_JPRB, 0.35668950E-11_JPRB, &
  & 0.43715461E-11_JPRB, 0.54105791E-11_JPRB, 0.69107914E-11_JPRB, 0.89925671E-11_JPRB, 0.12067253E-10_JPRB, 0.16390403E-10_JPRB, &
  & 0.22234620E-10_JPRB, 0.29553998E-10_JPRB, 0.37955524E-10_JPRB, 0.47237114E-10_JPRB, 0.57286852E-10_JPRB, 0.68184312E-10_JPRB, &
  & 0.79847802E-10_JPRB, 0.91966726E-10_JPRB, 0.10385933E-09_JPRB, 0.11498121E-09_JPRB, 0.12515963E-09_JPRB, 0.13480840E-09_JPRB, &
  & 0.14463025E-09_JPRB, 0.15535716E-09_JPRB, 0.16832884E-09_JPRB, 0.18522452E-09_JPRB, 0.20810198E-09_JPRB, 0.23656269E-09_JPRB, &
  & 0.25911781E-09_JPRB, 0.27791536E-09_JPRB, 0.29745656E-09_JPRB, 0.32870820E-09_JPRB /)

RGHG4(:,42, 4) = (/ &
  & 0.52508679E-11_JPRB, 0.82504489E-11_JPRB, 0.12956118E-10_JPRB, 0.21466075E-10_JPRB, 0.39043043E-10_JPRB, 0.48558775E-10_JPRB, &
  & 0.64188856E-10_JPRB, 0.76004814E-10_JPRB, 0.85115519E-10_JPRB, 0.91924884E-10_JPRB, 0.96968066E-10_JPRB, 0.99399516E-10_JPRB, &
  & 0.98775932E-10_JPRB, 0.94609966E-10_JPRB, 0.86552418E-10_JPRB, 0.75168469E-10_JPRB, 0.61782378E-10_JPRB, 0.47726073E-10_JPRB, &
  & 0.34528828E-10_JPRB, 0.23611330E-10_JPRB, 0.15512478E-10_JPRB, 0.10180383E-10_JPRB, 0.68760622E-11_JPRB, 0.48980295E-11_JPRB, &
  & 0.37322164E-11_JPRB, 0.29687433E-11_JPRB, 0.24955682E-11_JPRB, 0.21415901E-11_JPRB, 0.19318264E-11_JPRB, 0.17973209E-11_JPRB, &
  & 0.17760182E-11_JPRB, 0.18386117E-11_JPRB, 0.20152382E-11_JPRB, 0.23066167E-11_JPRB, 0.26967805E-11_JPRB, 0.32332416E-11_JPRB, &
  & 0.39206459E-11_JPRB, 0.48338365E-11_JPRB, 0.61070368E-11_JPRB, 0.78577049E-11_JPRB, 0.10404534E-10_JPRB, 0.13905963E-10_JPRB, &
  & 0.18644492E-10_JPRB, 0.24559544E-10_JPRB, 0.31570704E-10_JPRB, 0.39370129E-10_JPRB, 0.48089900E-10_JPRB, 0.57845465E-10_JPRB, &
  & 0.68527461E-10_JPRB, 0.79817361E-10_JPRB, 0.90970023E-10_JPRB, 0.10125034E-09_JPRB, 0.11052288E-09_JPRB, 0.11911677E-09_JPRB, &
  & 0.12772655E-09_JPRB, 0.13708226E-09_JPRB, 0.14838075E-09_JPRB, 0.16295647E-09_JPRB, 0.18247337E-09_JPRB, 0.20637929E-09_JPRB, &
  & 0.22560932E-09_JPRB, 0.24196903E-09_JPRB, 0.25924365E-09_JPRB, 0.28707667E-09_JPRB /)

RGHG4(:,43, 4) = (/ &
  & 0.50210209E-11_JPRB, 0.76656155E-11_JPRB, 0.11415827E-10_JPRB, 0.18999394E-10_JPRB, 0.35251684E-10_JPRB, 0.43413551E-10_JPRB, &
  & 0.57150739E-10_JPRB, 0.66920393E-10_JPRB, 0.74239413E-10_JPRB, 0.79608806E-10_JPRB, 0.83620708E-10_JPRB, 0.85649945E-10_JPRB, &
  & 0.85181889E-10_JPRB, 0.81534321E-10_JPRB, 0.74417729E-10_JPRB, 0.64295368E-10_JPRB, 0.52376742E-10_JPRB, 0.40053433E-10_JPRB, &
  & 0.28758730E-10_JPRB, 0.19696978E-10_JPRB, 0.13066646E-10_JPRB, 0.87306126E-11_JPRB, 0.60454658E-11_JPRB, 0.43825455E-11_JPRB, &
  & 0.34104716E-11_JPRB, 0.27433797E-11_JPRB, 0.23325198E-11_JPRB, 0.20108639E-11_JPRB, 0.18233748E-11_JPRB, 0.16907916E-11_JPRB, &
  & 0.16695871E-11_JPRB, 0.17205123E-11_JPRB, 0.18818168E-11_JPRB, 0.21522833E-11_JPRB, 0.25012557E-11_JPRB, 0.30095241E-11_JPRB, &
  & 0.36078506E-11_JPRB, 0.44498251E-11_JPRB, 0.55395419E-11_JPRB, 0.70601060E-11_JPRB, 0.91738440E-11_JPRB, 0.12008609E-10_JPRB, &
  & 0.15730292E-10_JPRB, 0.20373064E-10_JPRB, 0.25922238E-10_JPRB, 0.32408787E-10_JPRB, 0.39832599E-10_JPRB, 0.48425028E-10_JPRB, &
  & 0.58110138E-10_JPRB, 0.68559540E-10_JPRB, 0.78884260E-10_JPRB, 0.88299215E-10_JPRB, 0.96594649E-10_JPRB, 0.10417779E-09_JPRB, &
  & 0.11177585E-09_JPRB, 0.11994805E-09_JPRB, 0.12978046E-09_JPRB, 0.14227848E-09_JPRB, 0.15871736E-09_JPRB, 0.17843746E-09_JPRB, &
  & 0.19467522E-09_JPRB, 0.20880440E-09_JPRB, 0.22409537E-09_JPRB, 0.24875266E-09_JPRB /)

RGHG4(:,44, 4) = (/ &
  & 0.47897237E-11_JPRB, 0.71460234E-11_JPRB, 0.10587102E-10_JPRB, 0.17566540E-10_JPRB, 0.31947108E-10_JPRB, 0.38762521E-10_JPRB, &
  & 0.50302987E-10_JPRB, 0.58534164E-10_JPRB, 0.64232453E-10_JPRB, 0.68399765E-10_JPRB, 0.71526653E-10_JPRB, 0.73119663E-10_JPRB, &
  & 0.72713356E-10_JPRB, 0.69510370E-10_JPRB, 0.63165251E-10_JPRB, 0.54174616E-10_JPRB, 0.43718626E-10_JPRB, 0.33178040E-10_JPRB, &
  & 0.23746951E-10_JPRB, 0.16417846E-10_JPRB, 0.11121635E-10_JPRB, 0.75978963E-11_JPRB, 0.54115579E-11_JPRB, 0.39944285E-11_JPRB, &
  & 0.31672998E-11_JPRB, 0.25707865E-11_JPRB, 0.22119268E-11_JPRB, 0.19081368E-11_JPRB, 0.17367495E-11_JPRB, 0.16051977E-11_JPRB, &
  & 0.15858837E-11_JPRB, 0.16289024E-11_JPRB, 0.17759743E-11_JPRB, 0.20273481E-11_JPRB, 0.23509391E-11_JPRB, 0.28278825E-11_JPRB, &
  & 0.33727118E-11_JPRB, 0.41518585E-11_JPRB, 0.51014258E-11_JPRB, 0.64368250E-11_JPRB, 0.81794892E-11_JPRB, 0.10441530E-10_JPRB, &
  & 0.13279221E-10_JPRB, 0.16689500E-10_JPRB, 0.20897336E-10_JPRB, 0.25932565E-10_JPRB, 0.32108784E-10_JPRB, 0.39584509E-10_JPRB, &
  & 0.48293185E-10_JPRB, 0.57883472E-10_JPRB, 0.67405234E-10_JPRB, 0.75961688E-10_JPRB, 0.83407579E-10_JPRB, 0.90119981E-10_JPRB, &
  & 0.96777301E-10_JPRB, 0.10385819E-09_JPRB, 0.11239895E-09_JPRB, 0.12297113E-09_JPRB, 0.13659712E-09_JPRB, 0.15260300E-09_JPRB, &
  & 0.16608202E-09_JPRB, 0.17808238E-09_JPRB, 0.19138169E-09_JPRB, 0.21306922E-09_JPRB /)

RGHG4(:,45, 4) = (/ &
  & 0.46757893E-11_JPRB, 0.68005740E-11_JPRB, 0.99285745E-11_JPRB, 0.16067519E-10_JPRB, 0.29596204E-10_JPRB, 0.34762016E-10_JPRB, &
  & 0.44556466E-10_JPRB, 0.50945085E-10_JPRB, 0.55157313E-10_JPRB, 0.58105892E-10_JPRB, 0.60359509E-10_JPRB, 0.61451691E-10_JPRB, &
  & 0.61010710E-10_JPRB, 0.58194741E-10_JPRB, 0.52551487E-10_JPRB, 0.44584600E-10_JPRB, 0.35586398E-10_JPRB, 0.26827450E-10_JPRB, &
  & 0.19362860E-10_JPRB, 0.13642140E-10_JPRB, 0.95374429E-11_JPRB, 0.66874869E-11_JPRB, 0.48991462E-11_JPRB, 0.36834611E-11_JPRB, &
  & 0.29746438E-11_JPRB, 0.24308661E-11_JPRB, 0.21109956E-11_JPRB, 0.18218563E-11_JPRB, 0.16633007E-11_JPRB, 0.15377038E-11_JPRB, &
  & 0.15141921E-11_JPRB, 0.15533059E-11_JPRB, 0.16884768E-11_JPRB, 0.19193399E-11_JPRB, 0.22284037E-11_JPRB, 0.26724168E-11_JPRB, &
  & 0.31887787E-11_JPRB, 0.39058114E-11_JPRB, 0.47593951E-11_JPRB, 0.59297697E-11_JPRB, 0.73662526E-11_JPRB, 0.91452896E-11_JPRB, &
  & 0.11199408E-10_JPRB, 0.13580978E-10_JPRB, 0.16430260E-10_JPRB, 0.20145817E-10_JPRB, 0.24951678E-10_JPRB, 0.31233897E-10_JPRB, &
  & 0.38928648E-10_JPRB, 0.47648253E-10_JPRB, 0.56326499E-10_JPRB, 0.64023196E-10_JPRB, 0.70598999E-10_JPRB, 0.76476339E-10_JPRB, &
  & 0.82304538E-10_JPRB, 0.88465367E-10_JPRB, 0.95864941E-10_JPRB, 0.10470616E-09_JPRB, 0.11579464E-09_JPRB, 0.12847709E-09_JPRB, &
  & 0.13946311E-09_JPRB, 0.14949772E-09_JPRB, 0.16088729E-09_JPRB, 0.17974620E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART8',0,ZHOOK_HANDLE)



RGHG4(:,46, 4) = (/ &
  & 0.45495521E-11_JPRB, 0.64855491E-11_JPRB, 0.93613485E-11_JPRB, 0.15124652E-10_JPRB, 0.27443499E-10_JPRB, 0.31146696E-10_JPRB, &
  & 0.39020794E-10_JPRB, 0.43838020E-10_JPRB, 0.46570775E-10_JPRB, 0.48585101E-10_JPRB, 0.50006020E-10_JPRB, 0.50664820E-10_JPRB, &
  & 0.50066062E-10_JPRB, 0.47481900E-10_JPRB, 0.42421799E-10_JPRB, 0.35551260E-10_JPRB, 0.28028111E-10_JPRB, 0.21223122E-10_JPRB, &
  & 0.15583196E-10_JPRB, 0.11354625E-10_JPRB, 0.82499979E-11_JPRB, 0.59753214E-11_JPRB, 0.45011833E-11_JPRB, 0.34443858E-11_JPRB, &
  & 0.28236647E-11_JPRB, 0.23222130E-11_JPRB, 0.20267882E-11_JPRB, 0.17550322E-11_JPRB, 0.15984863E-11_JPRB, 0.14827109E-11_JPRB, &
  & 0.14544738E-11_JPRB, 0.14908621E-11_JPRB, 0.16161649E-11_JPRB, 0.18293750E-11_JPRB, 0.21295491E-11_JPRB, 0.25459517E-11_JPRB, &
  & 0.30485595E-11_JPRB, 0.37133859E-11_JPRB, 0.45038851E-11_JPRB, 0.55319438E-11_JPRB, 0.67229946E-11_JPRB, 0.80922343E-11_JPRB, &
  & 0.95301727E-11_JPRB, 0.11029278E-10_JPRB, 0.12826535E-10_JPRB, 0.15179928E-10_JPRB, 0.18645344E-10_JPRB, 0.23534874E-10_JPRB, &
  & 0.30055954E-10_JPRB, 0.37793234E-10_JPRB, 0.45599607E-10_JPRB, 0.52430914E-10_JPRB, 0.58216924E-10_JPRB, 0.63312702E-10_JPRB, &
  & 0.68379309E-10_JPRB, 0.73617806E-10_JPRB, 0.80008257E-10_JPRB, 0.87241013E-10_JPRB, 0.96029310E-10_JPRB, 0.10575470E-09_JPRB, &
  & 0.11446594E-09_JPRB, 0.12262237E-09_JPRB, 0.13219421E-09_JPRB, 0.14842411E-09_JPRB /)

RGHG4(:,47, 4) = (/ &
  & 0.43790865E-11_JPRB, 0.62248223E-11_JPRB, 0.88417450E-11_JPRB, 0.14257524E-10_JPRB, 0.25445814E-10_JPRB, 0.27593644E-10_JPRB, &
  & 0.33605504E-10_JPRB, 0.36875763E-10_JPRB, 0.38507034E-10_JPRB, 0.39591778E-10_JPRB, 0.40303153E-10_JPRB, 0.40529267E-10_JPRB, &
  & 0.39742640E-10_JPRB, 0.37254286E-10_JPRB, 0.32767879E-10_JPRB, 0.26957124E-10_JPRB, 0.21200541E-10_JPRB, 0.16299713E-10_JPRB, &
  & 0.12446330E-10_JPRB, 0.94441113E-11_JPRB, 0.71792325E-11_JPRB, 0.53794820E-11_JPRB, 0.41661154E-11_JPRB, 0.32417033E-11_JPRB, &
  & 0.26928737E-11_JPRB, 0.22279448E-11_JPRB, 0.19524517E-11_JPRB, 0.16941318E-11_JPRB, 0.15415463E-11_JPRB, 0.14338971E-11_JPRB, &
  & 0.14022882E-11_JPRB, 0.14364648E-11_JPRB, 0.15520407E-11_JPRB, 0.17505761E-11_JPRB, 0.20398503E-11_JPRB, 0.24342169E-11_JPRB, &
  & 0.29251710E-11_JPRB, 0.35481383E-11_JPRB, 0.42851781E-11_JPRB, 0.51868102E-11_JPRB, 0.61738882E-11_JPRB, 0.72112893E-11_JPRB, &
  & 0.81557833E-11_JPRB, 0.90338076E-11_JPRB, 0.99826857E-11_JPRB, 0.11338472E-10_JPRB, 0.13481130E-10_JPRB, 0.16912458E-10_JPRB, &
  & 0.21946256E-10_JPRB, 0.28490323E-10_JPRB, 0.35303184E-10_JPRB, 0.41279678E-10_JPRB, 0.46253813E-10_JPRB, 0.50653710E-10_JPRB, &
  & 0.54988774E-10_JPRB, 0.59490295E-10_JPRB, 0.65010233E-10_JPRB, 0.70865570E-10_JPRB, 0.77708485E-10_JPRB, 0.85031510E-10_JPRB, &
  & 0.91801566E-10_JPRB, 0.98297655E-10_JPRB, 0.10610848E-09_JPRB, 0.11967592E-09_JPRB /)

RGHG4(:,48, 4) = (/ &
  & 0.41794298E-11_JPRB, 0.58186789E-11_JPRB, 0.83538445E-11_JPRB, 0.13063563E-10_JPRB, 0.23264661E-10_JPRB, 0.23613956E-10_JPRB, &
  & 0.28022480E-10_JPRB, 0.29991898E-10_JPRB, 0.30715121E-10_JPRB, 0.31180395E-10_JPRB, 0.31352972E-10_JPRB, 0.31215527E-10_JPRB, &
  & 0.30212541E-10_JPRB, 0.27893236E-10_JPRB, 0.24056456E-10_JPRB, 0.19712247E-10_JPRB, 0.15681878E-10_JPRB, 0.12513247E-10_JPRB, &
  & 0.10028115E-10_JPRB, 0.79915536E-11_JPRB, 0.63484357E-11_JPRB, 0.49259507E-11_JPRB, 0.39102575E-11_JPRB, 0.30925878E-11_JPRB, &
  & 0.25939637E-11_JPRB, 0.21571492E-11_JPRB, 0.18976077E-11_JPRB, 0.16453907E-11_JPRB, 0.14983778E-11_JPRB, 0.13960768E-11_JPRB, &
  & 0.13627147E-11_JPRB, 0.13947079E-11_JPRB, 0.15025777E-11_JPRB, 0.16899416E-11_JPRB, 0.19690824E-11_JPRB, 0.23510824E-11_JPRB, &
  & 0.28292136E-11_JPRB, 0.34225884E-11_JPRB, 0.41167673E-11_JPRB, 0.49174770E-11_JPRB, 0.57430467E-11_JPRB, 0.65139595E-11_JPRB, &
  & 0.71198650E-11_JPRB, 0.75691606E-11_JPRB, 0.80203708E-11_JPRB, 0.86809709E-11_JPRB, 0.98854995E-11_JPRB, 0.11988944E-10_JPRB, &
  & 0.15465245E-10_JPRB, 0.20366897E-10_JPRB, 0.25832928E-10_JPRB, 0.30763950E-10_JPRB, 0.34940235E-10_JPRB, 0.38633319E-10_JPRB, &
  & 0.42320883E-10_JPRB, 0.46072667E-10_JPRB, 0.50894986E-10_JPRB, 0.55571447E-10_JPRB, 0.60849770E-10_JPRB, 0.66263703E-10_JPRB, &
  & 0.71461802E-10_JPRB, 0.76541322E-10_JPRB, 0.82874908E-10_JPRB, 0.94105564E-10_JPRB /)

RGHG4(:,49, 4) = (/ &
  & 0.39072777E-11_JPRB, 0.54475344E-11_JPRB, 0.76480471E-11_JPRB, 0.12062215E-10_JPRB, 0.20532714E-10_JPRB, 0.19401718E-10_JPRB, &
  & 0.22139322E-10_JPRB, 0.23040415E-10_JPRB, 0.23072164E-10_JPRB, 0.23035466E-10_JPRB, 0.22847070E-10_JPRB, 0.22418388E-10_JPRB, &
  & 0.21398930E-10_JPRB, 0.19481425E-10_JPRB, 0.16754187E-10_JPRB, 0.13946757E-10_JPRB, 0.11546051E-10_JPRB, 0.96936669E-11_JPRB, &
  & 0.82017500E-11_JPRB, 0.68574148E-11_JPRB, 0.56854087E-11_JPRB, 0.45594817E-11_JPRB, 0.37027803E-11_JPRB, 0.29727230E-11_JPRB, &
  & 0.25105089E-11_JPRB, 0.20988697E-11_JPRB, 0.18494505E-11_JPRB, 0.16041331E-11_JPRB, 0.14653882E-11_JPRB, 0.13664440E-11_JPRB, &
  & 0.13328231E-11_JPRB, 0.13623718E-11_JPRB, 0.14624890E-11_JPRB, 0.16402668E-11_JPRB, 0.19072823E-11_JPRB, 0.22794314E-11_JPRB, &
  & 0.27425868E-11_JPRB, 0.33176328E-11_JPRB, 0.39684736E-11_JPRB, 0.46856664E-11_JPRB, 0.53727786E-11_JPRB, 0.59376844E-11_JPRB, &
  & 0.62945890E-11_JPRB, 0.64795907E-11_JPRB, 0.66241986E-11_JPRB, 0.69116267E-11_JPRB, 0.75191025E-11_JPRB, 0.87164980E-11_JPRB, &
  & 0.10789135E-10_JPRB, 0.13939713E-10_JPRB, 0.17674761E-10_JPRB, 0.21229967E-10_JPRB, 0.24394913E-10_JPRB, 0.27287551E-10_JPRB, &
  & 0.30261019E-10_JPRB, 0.33351391E-10_JPRB, 0.37561908E-10_JPRB, 0.41266799E-10_JPRB, 0.45274461E-10_JPRB, 0.49250957E-10_JPRB, &
  & 0.53138480E-10_JPRB, 0.57022633E-10_JPRB, 0.62061689E-10_JPRB, 0.71243317E-10_JPRB /)

RGHG4(:,50, 4) = (/ &
  & 0.36207057E-11_JPRB, 0.49951310E-11_JPRB, 0.70199363E-11_JPRB, 0.10594641E-10_JPRB, 0.17452564E-10_JPRB, 0.14897727E-10_JPRB, &
  & 0.16273316E-10_JPRB, 0.16398124E-10_JPRB, 0.16006640E-10_JPRB, 0.15732485E-10_JPRB, 0.15431458E-10_JPRB, 0.15017522E-10_JPRB, &
  & 0.14279447E-10_JPRB, 0.13113696E-10_JPRB, 0.11572798E-10_JPRB, 0.10075273E-10_JPRB, 0.87967073E-11_JPRB, 0.77633568E-11_JPRB, &
  & 0.68982281E-11_JPRB, 0.60167357E-11_JPRB, 0.51763233E-11_JPRB, 0.42805971E-11_JPRB, 0.35432319E-11_JPRB, 0.28790041E-11_JPRB, &
  & 0.24460054E-11_JPRB, 0.20589535E-11_JPRB, 0.18152947E-11_JPRB, 0.15818470E-11_JPRB, 0.14488589E-11_JPRB, 0.13530669E-11_JPRB, &
  & 0.13193013E-11_JPRB, 0.13460061E-11_JPRB, 0.14392409E-11_JPRB, 0.16101441E-11_JPRB, 0.18638827E-11_JPRB, 0.22291123E-11_JPRB, &
  & 0.26718144E-11_JPRB, 0.32283770E-11_JPRB, 0.38392293E-11_JPRB, 0.44898234E-11_JPRB, 0.50618160E-11_JPRB, 0.54683038E-11_JPRB, &
  & 0.56551764E-11_JPRB, 0.56820234E-11_JPRB, 0.56748655E-11_JPRB, 0.57568238E-11_JPRB, 0.60610432E-11_JPRB, 0.66944636E-11_JPRB, &
  & 0.78506073E-11_JPRB, 0.96270171E-11_JPRB, 0.11699326E-10_JPRB, 0.13791189E-10_JPRB, 0.15734351E-10_JPRB, 0.17698650E-10_JPRB, &
  & 0.19795665E-10_JPRB, 0.22104660E-10_JPRB, 0.25658645E-10_JPRB, 0.28491586E-10_JPRB, 0.31486914E-10_JPRB, 0.34362749E-10_JPRB, &
  & 0.37224907E-10_JPRB, 0.40189845E-10_JPRB, 0.44107770E-10_JPRB, 0.51554920E-10_JPRB /)

RGHG4(:,51, 4) = (/ &
  & 0.34946226E-11_JPRB, 0.44130212E-11_JPRB, 0.62061714E-11_JPRB, 0.90233316E-11_JPRB, 0.14148548E-10_JPRB, 0.10612938E-10_JPRB, &
  & 0.11105857E-10_JPRB, 0.10934541E-10_JPRB, 0.10435521E-10_JPRB, 0.10183653E-10_JPRB, 0.99668832E-11_JPRB, 0.97717051E-11_JPRB, &
  & 0.94423401E-11_JPRB, 0.89855016E-11_JPRB, 0.83148011E-11_JPRB, 0.76527838E-11_JPRB, 0.70207451E-11_JPRB, 0.64813502E-11_JPRB, &
  & 0.59702451E-11_JPRB, 0.53994092E-11_JPRB, 0.47879040E-11_JPRB, 0.40737110E-11_JPRB, 0.34269471E-11_JPRB, 0.28195469E-11_JPRB, &
  & 0.24028631E-11_JPRB, 0.20330025E-11_JPRB, 0.17952361E-11_JPRB, 0.15766920E-11_JPRB, 0.14474989E-11_JPRB, 0.13562142E-11_JPRB, &
  & 0.13232926E-11_JPRB, 0.13466056E-11_JPRB, 0.14326857E-11_JPRB, 0.15966058E-11_JPRB, 0.18357505E-11_JPRB, 0.21932081E-11_JPRB, &
  & 0.26200296E-11_JPRB, 0.31635107E-11_JPRB, 0.37375949E-11_JPRB, 0.43288758E-11_JPRB, 0.48024609E-11_JPRB, 0.50818720E-11_JPRB, &
  & 0.51510697E-11_JPRB, 0.50876035E-11_JPRB, 0.50027439E-11_JPRB, 0.49986781E-11_JPRB, 0.51291389E-11_JPRB, 0.54619460E-11_JPRB, &
  & 0.60893760E-11_JPRB, 0.69758804E-11_JPRB, 0.79900583E-11_JPRB, 0.89464356E-11_JPRB, 0.99037003E-11_JPRB, 0.10889222E-10_JPRB, &
  & 0.12055312E-10_JPRB, 0.13419234E-10_JPRB, 0.16151264E-10_JPRB, 0.18042189E-10_JPRB, 0.20067066E-10_JPRB, 0.22015289E-10_JPRB, &
  & 0.24001232E-10_JPRB, 0.26130110E-10_JPRB, 0.29065908E-10_JPRB, 0.34892221E-10_JPRB /)

RGHG4(:,52, 4) = (/ &
  & 0.33927167E-11_JPRB, 0.39989401E-11_JPRB, 0.51890892E-11_JPRB, 0.75634490E-11_JPRB, 0.11020847E-10_JPRB, 0.73893548E-11_JPRB, &
  & 0.75426358E-11_JPRB, 0.73753052E-11_JPRB, 0.69421179E-11_JPRB, 0.68041848E-11_JPRB, 0.67152815E-11_JPRB, 0.66873985E-11_JPRB, &
  & 0.66383236E-11_JPRB, 0.65706412E-11_JPRB, 0.63795358E-11_JPRB, 0.61443051E-11_JPRB, 0.58674506E-11_JPRB, 0.56000491E-11_JPRB, &
  & 0.53032045E-11_JPRB, 0.49397591E-11_JPRB, 0.44777918E-11_JPRB, 0.39245417E-11_JPRB, 0.33304891E-11_JPRB, 0.27898504E-11_JPRB, &
  & 0.23685689E-11_JPRB, 0.20382899E-11_JPRB, 0.18035805E-11_JPRB, 0.16016899E-11_JPRB, 0.14744469E-11_JPRB, 0.13895731E-11_JPRB, &
  & 0.13574328E-11_JPRB, 0.13773495E-11_JPRB, 0.14570436E-11_JPRB, 0.16153569E-11_JPRB, 0.18437044E-11_JPRB, 0.21879191E-11_JPRB, &
  & 0.25983228E-11_JPRB, 0.31193709E-11_JPRB, 0.36628877E-11_JPRB, 0.42000539E-11_JPRB, 0.45828692E-11_JPRB, 0.47602521E-11_JPRB, &
  & 0.47453508E-11_JPRB, 0.46328471E-11_JPRB, 0.45105161E-11_JPRB, 0.44605652E-11_JPRB, 0.45016577E-11_JPRB, 0.46630382E-11_JPRB, &
  & 0.49907587E-11_JPRB, 0.54205303E-11_JPRB, 0.58570909E-11_JPRB, 0.62545624E-11_JPRB, 0.66287817E-11_JPRB, 0.70395582E-11_JPRB, &
  & 0.75434936E-11_JPRB, 0.81687808E-11_JPRB, 0.10091793E-10_JPRB, 0.11111513E-10_JPRB, 0.12249719E-10_JPRB, 0.13370226E-10_JPRB, &
  & 0.14571826E-10_JPRB, 0.15914556E-10_JPRB, 0.17821453E-10_JPRB, 0.22021284E-10_JPRB /)

RGHG4(:,53, 4) = (/ &
  & 0.32342939E-11_JPRB, 0.35715352E-11_JPRB, 0.45727502E-11_JPRB, 0.62147054E-11_JPRB, 0.88707037E-11_JPRB, 0.54337767E-11_JPRB, &
  & 0.55165698E-11_JPRB, 0.54328000E-11_JPRB, 0.50735505E-11_JPRB, 0.49894264E-11_JPRB, 0.49780926E-11_JPRB, 0.50104508E-11_JPRB, &
  & 0.50874136E-11_JPRB, 0.51738362E-11_JPRB, 0.52261940E-11_JPRB, 0.52176354E-11_JPRB, 0.51304681E-11_JPRB, 0.50267919E-11_JPRB, &
  & 0.48486579E-11_JPRB, 0.46204785E-11_JPRB, 0.42606027E-11_JPRB, 0.38244382E-11_JPRB, 0.32845616E-11_JPRB, 0.27970720E-11_JPRB, &
  & 0.23683275E-11_JPRB, 0.20780116E-11_JPRB, 0.18389409E-11_JPRB, 0.16527343E-11_JPRB, 0.15289730E-11_JPRB, 0.14510498E-11_JPRB, &
  & 0.14193478E-11_JPRB, 0.14362745E-11_JPRB, 0.15085678E-11_JPRB, 0.16613813E-11_JPRB, 0.18805393E-11_JPRB, 0.22118965E-11_JPRB, &
  & 0.26182982E-11_JPRB, 0.31186514E-11_JPRB, 0.36344324E-11_JPRB, 0.41158990E-11_JPRB, 0.44170822E-11_JPRB, 0.45108041E-11_JPRB, &
  & 0.44451413E-11_JPRB, 0.43028142E-11_JPRB, 0.41652172E-11_JPRB, 0.40941187E-11_JPRB, 0.40821574E-11_JPRB, 0.41570133E-11_JPRB, &
  & 0.43191817E-11_JPRB, 0.45046232E-11_JPRB, 0.46882949E-11_JPRB, 0.48244876E-11_JPRB, 0.49652153E-11_JPRB, 0.51226354E-11_JPRB, &
  & 0.53226026E-11_JPRB, 0.55852397E-11_JPRB, 0.69964715E-11_JPRB, 0.74686212E-11_JPRB, 0.80223632E-11_JPRB, 0.85798495E-11_JPRB, &
  & 0.92018624E-11_JPRB, 0.99059450E-11_JPRB, 0.11002464E-10_JPRB, 0.13585738E-10_JPRB /)

RGHG4(:,54, 4) = (/ &
  & 0.30451154E-11_JPRB, 0.33287529E-11_JPRB, 0.40427414E-11_JPRB, 0.54713465E-11_JPRB, 0.73798519E-11_JPRB, 0.43790080E-11_JPRB, &
  & 0.44297023E-11_JPRB, 0.43719941E-11_JPRB, 0.40593770E-11_JPRB, 0.40079780E-11_JPRB, 0.39891528E-11_JPRB, 0.40660960E-11_JPRB, &
  & 0.41542143E-11_JPRB, 0.43258240E-11_JPRB, 0.44752860E-11_JPRB, 0.45874888E-11_JPRB, 0.46228130E-11_JPRB, 0.46178877E-11_JPRB, &
  & 0.45340693E-11_JPRB, 0.43896354E-11_JPRB, 0.41193659E-11_JPRB, 0.37583517E-11_JPRB, 0.32910536E-11_JPRB, 0.28233596E-11_JPRB, &
  & 0.24299568E-11_JPRB, 0.21597453E-11_JPRB, 0.19297463E-11_JPRB, 0.17577701E-11_JPRB, 0.16373211E-11_JPRB, 0.15653404E-11_JPRB, &
  & 0.15338604E-11_JPRB, 0.15495026E-11_JPRB, 0.16149046E-11_JPRB, 0.17626612E-11_JPRB, 0.19780690E-11_JPRB, 0.22937305E-11_JPRB, &
  & 0.26932766E-11_JPRB, 0.31704066E-11_JPRB, 0.36651550E-11_JPRB, 0.40919833E-11_JPRB, 0.43128027E-11_JPRB, 0.43344655E-11_JPRB, &
  & 0.42276842E-11_JPRB, 0.40647910E-11_JPRB, 0.39125595E-11_JPRB, 0.38256460E-11_JPRB, 0.37861394E-11_JPRB, 0.38059972E-11_JPRB, &
  & 0.38692257E-11_JPRB, 0.39353447E-11_JPRB, 0.39923256E-11_JPRB, 0.40257910E-11_JPRB, 0.40756517E-11_JPRB, 0.41261768E-11_JPRB, &
  & 0.42119680E-11_JPRB, 0.43242437E-11_JPRB, 0.54633407E-11_JPRB, 0.56920605E-11_JPRB, 0.59616266E-11_JPRB, 0.62229991E-11_JPRB, &
  & 0.65346248E-11_JPRB, 0.68682386E-11_JPRB, 0.74104273E-11_JPRB, 0.86554054E-11_JPRB /)

RGHG4(:,55, 4) = (/ &
  & 0.28237803E-11_JPRB, 0.31229429E-11_JPRB, 0.38468881E-11_JPRB, 0.49525171E-11_JPRB, 0.65037060E-11_JPRB, 0.37853401E-11_JPRB, &
  & 0.38226306E-11_JPRB, 0.37937943E-11_JPRB, 0.34932513E-11_JPRB, 0.34538652E-11_JPRB, 0.34531061E-11_JPRB, 0.34931450E-11_JPRB, &
  & 0.36211446E-11_JPRB, 0.37802751E-11_JPRB, 0.40051404E-11_JPRB, 0.41800248E-11_JPRB, 0.43028844E-11_JPRB, 0.43629649E-11_JPRB, &
  & 0.43560437E-11_JPRB, 0.42603841E-11_JPRB, 0.40702550E-11_JPRB, 0.37547782E-11_JPRB, 0.33609643E-11_JPRB, 0.29177615E-11_JPRB, &
  & 0.25450883E-11_JPRB, 0.22840889E-11_JPRB, 0.20637318E-11_JPRB, 0.18979972E-11_JPRB, 0.17802462E-11_JPRB, 0.17113548E-11_JPRB, &
  & 0.16793796E-11_JPRB, 0.16952198E-11_JPRB, 0.17554246E-11_JPRB, 0.18979781E-11_JPRB, 0.21170511E-11_JPRB, 0.24218776E-11_JPRB, &
  & 0.28265430E-11_JPRB, 0.32886324E-11_JPRB, 0.37596141E-11_JPRB, 0.41341860E-11_JPRB, 0.42876857E-11_JPRB, 0.42534001E-11_JPRB, &
  & 0.41211353E-11_JPRB, 0.39304020E-11_JPRB, 0.37664867E-11_JPRB, 0.36698747E-11_JPRB, 0.36094478E-11_JPRB, 0.35923068E-11_JPRB, &
  & 0.36012272E-11_JPRB, 0.36021802E-11_JPRB, 0.36031631E-11_JPRB, 0.35975227E-11_JPRB, 0.36091564E-11_JPRB, 0.36223832E-11_JPRB, &
  & 0.36617545E-11_JPRB, 0.37109907E-11_JPRB, 0.46834797E-11_JPRB, 0.48057270E-11_JPRB, 0.49500048E-11_JPRB, 0.50937288E-11_JPRB, &
  & 0.52686367E-11_JPRB, 0.54574817E-11_JPRB, 0.57701014E-11_JPRB, 0.64421359E-11_JPRB /)

RGHG4(:,56, 4) = (/ &
  & 0.26565165E-11_JPRB, 0.30302416E-11_JPRB, 0.36800884E-11_JPRB, 0.46786628E-11_JPRB, 0.59157475E-11_JPRB, 0.34507161E-11_JPRB, &
  & 0.34667750E-11_JPRB, 0.34431505E-11_JPRB, 0.31724387E-11_JPRB, 0.31205060E-11_JPRB, 0.31083265E-11_JPRB, 0.31683302E-11_JPRB, &
  & 0.32488461E-11_JPRB, 0.34444142E-11_JPRB, 0.36693942E-11_JPRB, 0.38995864E-11_JPRB, 0.40929994E-11_JPRB, 0.42184589E-11_JPRB, &
  & 0.42809415E-11_JPRB, 0.42359562E-11_JPRB, 0.41034749E-11_JPRB, 0.38349571E-11_JPRB, 0.34843016E-11_JPRB, 0.30762300E-11_JPRB, &
  & 0.27126602E-11_JPRB, 0.24560980E-11_JPRB, 0.22394614E-11_JPRB, 0.20759490E-11_JPRB, 0.19615145E-11_JPRB, 0.18945778E-11_JPRB, &
  & 0.18612082E-11_JPRB, 0.18772687E-11_JPRB, 0.19353512E-11_JPRB, 0.20710087E-11_JPRB, 0.22936715E-11_JPRB, 0.25959159E-11_JPRB, &
  & 0.30040289E-11_JPRB, 0.34649980E-11_JPRB, 0.39201745E-11_JPRB, 0.42577344E-11_JPRB, 0.43534698E-11_JPRB, 0.42727059E-11_JPRB, &
  & 0.41204735E-11_JPRB, 0.39023242E-11_JPRB, 0.37103732E-11_JPRB, 0.36040856E-11_JPRB, 0.35214433E-11_JPRB, 0.34789055E-11_JPRB, &
  & 0.34440671E-11_JPRB, 0.34048114E-11_JPRB, 0.33746009E-11_JPRB, 0.33505555E-11_JPRB, 0.33431237E-11_JPRB, 0.33394620E-11_JPRB, &
  & 0.33539729E-11_JPRB, 0.33812486E-11_JPRB, 0.42465007E-11_JPRB, 0.43274251E-11_JPRB, 0.44230622E-11_JPRB, 0.45104896E-11_JPRB, &
  & 0.46264659E-11_JPRB, 0.47452767E-11_JPRB, 0.49573930E-11_JPRB, 0.53921308E-11_JPRB /)

RGHG4(:,57, 4) = (/ &
  & 0.25555914E-11_JPRB, 0.29884220E-11_JPRB, 0.36005129E-11_JPRB, 0.44999191E-11_JPRB, 0.54911197E-11_JPRB, 0.32494419E-11_JPRB, &
  & 0.32563093E-11_JPRB, 0.32392145E-11_JPRB, 0.29865685E-11_JPRB, 0.29508106E-11_JPRB, 0.29262307E-11_JPRB, 0.29640197E-11_JPRB, &
  & 0.30653240E-11_JPRB, 0.32247557E-11_JPRB, 0.34775509E-11_JPRB, 0.37440628E-11_JPRB, 0.39919166E-11_JPRB, 0.41906470E-11_JPRB, &
  & 0.43143748E-11_JPRB, 0.43199650E-11_JPRB, 0.42290438E-11_JPRB, 0.39955179E-11_JPRB, 0.36849447E-11_JPRB, 0.32821129E-11_JPRB, &
  & 0.29203174E-11_JPRB, 0.26577015E-11_JPRB, 0.24405120E-11_JPRB, 0.22795114E-11_JPRB, 0.21698481E-11_JPRB, 0.21061705E-11_JPRB, &
  & 0.20710922E-11_JPRB, 0.20854039E-11_JPRB, 0.21436969E-11_JPRB, 0.22730307E-11_JPRB, 0.24974222E-11_JPRB, 0.28006636E-11_JPRB, &
  & 0.32077396E-11_JPRB, 0.36618434E-11_JPRB, 0.40992322E-11_JPRB, 0.44171372E-11_JPRB, 0.45023893E-11_JPRB, 0.43958019E-11_JPRB, &
  & 0.42288508E-11_JPRB, 0.39900821E-11_JPRB, 0.37703391E-11_JPRB, 0.36517326E-11_JPRB, 0.35462505E-11_JPRB, 0.34734336E-11_JPRB, &
  & 0.34068826E-11_JPRB, 0.33385061E-11_JPRB, 0.32878335E-11_JPRB, 0.32536380E-11_JPRB, 0.32371931E-11_JPRB, 0.32275749E-11_JPRB, &
  & 0.32325737E-11_JPRB, 0.32514792E-11_JPRB, 0.40233108E-11_JPRB, 0.40898470E-11_JPRB, 0.41648933E-11_JPRB, 0.42325813E-11_JPRB, &
  & 0.43268475E-11_JPRB, 0.44245675E-11_JPRB, 0.45718520E-11_JPRB, 0.47386348E-11_JPRB /)

RGHG4(:,58, 4) = (/ &
  & 0.25288838E-11_JPRB, 0.29701794E-11_JPRB, 0.35961089E-11_JPRB, 0.43455972E-11_JPRB, 0.52398441E-11_JPRB, 0.31335861E-11_JPRB, &
  & 0.31535091E-11_JPRB, 0.31499076E-11_JPRB, 0.29098288E-11_JPRB, 0.28735970E-11_JPRB, 0.28507262E-11_JPRB, 0.28948491E-11_JPRB, &
  & 0.29569539E-11_JPRB, 0.31474641E-11_JPRB, 0.33867683E-11_JPRB, 0.36945464E-11_JPRB, 0.40022083E-11_JPRB, 0.42717501E-11_JPRB, &
  & 0.44588547E-11_JPRB, 0.44955558E-11_JPRB, 0.44479368E-11_JPRB, 0.42188640E-11_JPRB, 0.39030077E-11_JPRB, 0.35145077E-11_JPRB, &
  & 0.31566754E-11_JPRB, 0.28868639E-11_JPRB, 0.26716108E-11_JPRB, 0.25160631E-11_JPRB, 0.24140869E-11_JPRB, 0.23554422E-11_JPRB, &
  & 0.23201165E-11_JPRB, 0.23293451E-11_JPRB, 0.23852452E-11_JPRB, 0.25089594E-11_JPRB, 0.27277269E-11_JPRB, 0.30340990E-11_JPRB, &
  & 0.34393974E-11_JPRB, 0.38944408E-11_JPRB, 0.43229986E-11_JPRB, 0.46209443E-11_JPRB, 0.46999444E-11_JPRB, 0.46071979E-11_JPRB, &
  & 0.44316148E-11_JPRB, 0.41898911E-11_JPRB, 0.39550893E-11_JPRB, 0.38300144E-11_JPRB, 0.36836944E-11_JPRB, 0.35896848E-11_JPRB, &
  & 0.34800179E-11_JPRB, 0.33746320E-11_JPRB, 0.33172033E-11_JPRB, 0.32608269E-11_JPRB, 0.32431744E-11_JPRB, 0.32208149E-11_JPRB, &
  & 0.32178327E-11_JPRB, 0.32307878E-11_JPRB, 0.39335297E-11_JPRB, 0.40041390E-11_JPRB, 0.40741165E-11_JPRB, 0.41376750E-11_JPRB, &
  & 0.42270098E-11_JPRB, 0.43266870E-11_JPRB, 0.44972246E-11_JPRB, 0.47862677E-11_JPRB /)

RGHG4(:,59, 4) = (/ &
  & 0.25007359E-11_JPRB, 0.29980352E-11_JPRB, 0.35606557E-11_JPRB, 0.42853772E-11_JPRB, 0.50220821E-11_JPRB, 0.31103950E-11_JPRB, &
  & 0.31229045E-11_JPRB, 0.31439671E-11_JPRB, 0.29332697E-11_JPRB, 0.29037111E-11_JPRB, 0.28745311E-11_JPRB, 0.29237797E-11_JPRB, &
  & 0.30022859E-11_JPRB, 0.31675444E-11_JPRB, 0.34424508E-11_JPRB, 0.37731376E-11_JPRB, 0.41358158E-11_JPRB, 0.44580056E-11_JPRB, &
  & 0.46934418E-11_JPRB, 0.47506977E-11_JPRB, 0.46978853E-11_JPRB, 0.44754057E-11_JPRB, 0.41654007E-11_JPRB, 0.37727716E-11_JPRB, &
  & 0.34109081E-11_JPRB, 0.31368888E-11_JPRB, 0.29249771E-11_JPRB, 0.27771362E-11_JPRB, 0.26845544E-11_JPRB, 0.26330932E-11_JPRB, &
  & 0.26011090E-11_JPRB, 0.26056045E-11_JPRB, 0.26546755E-11_JPRB, 0.27758895E-11_JPRB, 0.29849207E-11_JPRB, 0.32906176E-11_JPRB, &
  & 0.36896488E-11_JPRB, 0.41392397E-11_JPRB, 0.45577270E-11_JPRB, 0.48502417E-11_JPRB, 0.49448006E-11_JPRB, 0.48622742E-11_JPRB, &
  & 0.47026215E-11_JPRB, 0.44812166E-11_JPRB, 0.42572703E-11_JPRB, 0.41250467E-11_JPRB, 0.39705179E-11_JPRB, 0.38448546E-11_JPRB, &
  & 0.36896402E-11_JPRB, 0.35568313E-11_JPRB, 0.34654861E-11_JPRB, 0.33980598E-11_JPRB, 0.33697543E-11_JPRB, 0.33340253E-11_JPRB, &
  & 0.33315410E-11_JPRB, 0.33421759E-11_JPRB, 0.39848754E-11_JPRB, 0.40568542E-11_JPRB, 0.41241615E-11_JPRB, 0.41866532E-11_JPRB, &
  & 0.42711364E-11_JPRB, 0.43677163E-11_JPRB, 0.45100833E-11_JPRB, 0.47035956E-11_JPRB /)

RGHG4(:,60, 4) = (/ &
  & 0.25436133E-11_JPRB, 0.30246571E-11_JPRB, 0.35972453E-11_JPRB, 0.42338359E-11_JPRB, 0.49466989E-11_JPRB, 0.31496819E-11_JPRB, &
  & 0.32046917E-11_JPRB, 0.32319204E-11_JPRB, 0.30546783E-11_JPRB, 0.30289649E-11_JPRB, 0.30351715E-11_JPRB, 0.30593371E-11_JPRB, &
  & 0.31463280E-11_JPRB, 0.33470668E-11_JPRB, 0.36243144E-11_JPRB, 0.39935381E-11_JPRB, 0.43908232E-11_JPRB, 0.47498463E-11_JPRB, &
  & 0.49822507E-11_JPRB, 0.50415843E-11_JPRB, 0.49854123E-11_JPRB, 0.47532130E-11_JPRB, 0.44279012E-11_JPRB, 0.40463587E-11_JPRB, &
  & 0.36876400E-11_JPRB, 0.34143003E-11_JPRB, 0.32127005E-11_JPRB, 0.30774198E-11_JPRB, 0.29970191E-11_JPRB, 0.29547478E-11_JPRB, &
  & 0.29278528E-11_JPRB, 0.29293029E-11_JPRB, 0.29669336E-11_JPRB, 0.30789653E-11_JPRB, 0.32758527E-11_JPRB, 0.35745645E-11_JPRB, &
  & 0.39683239E-11_JPRB, 0.44155122E-11_JPRB, 0.48287559E-11_JPRB, 0.51188637E-11_JPRB, 0.52326923E-11_JPRB, 0.51806576E-11_JPRB, &
  & 0.50384657E-11_JPRB, 0.48440856E-11_JPRB, 0.46543581E-11_JPRB, 0.45345494E-11_JPRB, 0.43872922E-11_JPRB, 0.42488179E-11_JPRB, &
  & 0.40633850E-11_JPRB, 0.38833368E-11_JPRB, 0.37594238E-11_JPRB, 0.36751960E-11_JPRB, 0.36203720E-11_JPRB, 0.35786536E-11_JPRB, &
  & 0.35640531E-11_JPRB, 0.35698688E-11_JPRB, 0.41686251E-11_JPRB, 0.42489870E-11_JPRB, 0.43184891E-11_JPRB, 0.43801330E-11_JPRB, &
  & 0.44647103E-11_JPRB, 0.45692092E-11_JPRB, 0.47243247E-11_JPRB, 0.49215163E-11_JPRB /)

RGHG4(:,61, 4) = (/ &
  & 0.25595539E-11_JPRB, 0.30598514E-11_JPRB, 0.36059159E-11_JPRB, 0.42375860E-11_JPRB, 0.49212756E-11_JPRB, 0.32656358E-11_JPRB, &
  & 0.33522742E-11_JPRB, 0.34217733E-11_JPRB, 0.32796075E-11_JPRB, 0.32664171E-11_JPRB, 0.32866947E-11_JPRB, 0.33301304E-11_JPRB, &
  & 0.34468778E-11_JPRB, 0.36476126E-11_JPRB, 0.39776854E-11_JPRB, 0.43555597E-11_JPRB, 0.47572081E-11_JPRB, 0.50938451E-11_JPRB, &
  & 0.53072499E-11_JPRB, 0.53601065E-11_JPRB, 0.52899946E-11_JPRB, 0.50531862E-11_JPRB, 0.47250528E-11_JPRB, 0.43427683E-11_JPRB, &
  & 0.39906620E-11_JPRB, 0.37276913E-11_JPRB, 0.35429348E-11_JPRB, 0.34273398E-11_JPRB, 0.33640924E-11_JPRB, 0.33318814E-11_JPRB, &
  & 0.33096045E-11_JPRB, 0.33073724E-11_JPRB, 0.33315928E-11_JPRB, 0.34275085E-11_JPRB, 0.36094337E-11_JPRB, 0.38902007E-11_JPRB, &
  & 0.42744883E-11_JPRB, 0.47129197E-11_JPRB, 0.51253563E-11_JPRB, 0.54250359E-11_JPRB, 0.55641563E-11_JPRB, 0.55490460E-11_JPRB, &
  & 0.54399436E-11_JPRB, 0.52829139E-11_JPRB, 0.51290391E-11_JPRB, 0.50383968E-11_JPRB, 0.49214743E-11_JPRB, 0.48039346E-11_JPRB, &
  & 0.46075279E-11_JPRB, 0.43982136E-11_JPRB, 0.42362654E-11_JPRB, 0.41171897E-11_JPRB, 0.40391514E-11_JPRB, 0.39767083E-11_JPRB, &
  & 0.39500079E-11_JPRB, 0.39609535E-11_JPRB, 0.45264873E-11_JPRB, 0.46104396E-11_JPRB, 0.46778072E-11_JPRB, 0.47356654E-11_JPRB, &
  & 0.48175942E-11_JPRB, 0.49239267E-11_JPRB, 0.50662001E-11_JPRB, 0.52267535E-11_JPRB /)

RGHG4(:,62, 4) = (/ &
  & 0.25884277E-11_JPRB, 0.30859202E-11_JPRB, 0.36156861E-11_JPRB, 0.42585449E-11_JPRB, 0.49757368E-11_JPRB, 0.34526494E-11_JPRB, &
  & 0.36068980E-11_JPRB, 0.37142871E-11_JPRB, 0.36223650E-11_JPRB, 0.36366064E-11_JPRB, 0.36751821E-11_JPRB, 0.37464771E-11_JPRB, &
  & 0.38764452E-11_JPRB, 0.41245111E-11_JPRB, 0.44625679E-11_JPRB, 0.48325528E-11_JPRB, 0.51978712E-11_JPRB, 0.54946421E-11_JPRB, &
  & 0.56765022E-11_JPRB, 0.57136492E-11_JPRB, 0.56255066E-11_JPRB, 0.53741959E-11_JPRB, 0.50400105E-11_JPRB, 0.46667037E-11_JPRB, &
  & 0.43315729E-11_JPRB, 0.40872271E-11_JPRB, 0.39291127E-11_JPRB, 0.38425127E-11_JPRB, 0.38029645E-11_JPRB, 0.37856103E-11_JPRB, &
  & 0.37685501E-11_JPRB, 0.37604295E-11_JPRB, 0.37675457E-11_JPRB, 0.38393828E-11_JPRB, 0.39973398E-11_JPRB, 0.42568323E-11_JPRB, &
  & 0.46277795E-11_JPRB, 0.50584801E-11_JPRB, 0.54734888E-11_JPRB, 0.57864850E-11_JPRB, 0.59538212E-11_JPRB, 0.59823630E-11_JPRB, &
  & 0.59137304E-11_JPRB, 0.58048696E-11_JPRB, 0.56937970E-11_JPRB, 0.56465366E-11_JPRB, 0.55653711E-11_JPRB, 0.54811789E-11_JPRB, &
  & 0.53146081E-11_JPRB, 0.51010680E-11_JPRB, 0.49216729E-11_JPRB, 0.47692922E-11_JPRB, 0.46551448E-11_JPRB, 0.45650892E-11_JPRB, &
  & 0.45255232E-11_JPRB, 0.45383259E-11_JPRB, 0.50824397E-11_JPRB, 0.51721440E-11_JPRB, 0.52333372E-11_JPRB, 0.52798790E-11_JPRB, &
  & 0.53576965E-11_JPRB, 0.54698620E-11_JPRB, 0.56160966E-11_JPRB, 0.57276449E-11_JPRB /)

RGHG4(:,63, 4) = (/ &
  & 0.25697699E-11_JPRB, 0.30579278E-11_JPRB, 0.36155896E-11_JPRB, 0.42671405E-11_JPRB, 0.50550354E-11_JPRB, 0.36905158E-11_JPRB, &
  & 0.39301609E-11_JPRB, 0.41204379E-11_JPRB, 0.40795358E-11_JPRB, 0.41308411E-11_JPRB, 0.42132040E-11_JPRB, 0.43122294E-11_JPRB, &
  & 0.44840416E-11_JPRB, 0.47499509E-11_JPRB, 0.50790548E-11_JPRB, 0.53968401E-11_JPRB, 0.56917834E-11_JPRB, 0.59331294E-11_JPRB, &
  & 0.60742331E-11_JPRB, 0.60891188E-11_JPRB, 0.59774121E-11_JPRB, 0.57231368E-11_JPRB, 0.53932041E-11_JPRB, 0.50302891E-11_JPRB, &
  & 0.47218327E-11_JPRB, 0.45110387E-11_JPRB, 0.43875667E-11_JPRB, 0.43369232E-11_JPRB, 0.43298659E-11_JPRB, 0.43333605E-11_JPRB, &
  & 0.43255369E-11_JPRB, 0.43097570E-11_JPRB, 0.42975025E-11_JPRB, 0.43374900E-11_JPRB, 0.44621919E-11_JPRB, 0.46896545E-11_JPRB, &
  & 0.50411511E-11_JPRB, 0.54570055E-11_JPRB, 0.58777601E-11_JPRB, 0.62089739E-11_JPRB, 0.64111342E-11_JPRB, 0.64893928E-11_JPRB, &
  & 0.64674681E-11_JPRB, 0.64175189E-11_JPRB, 0.63539200E-11_JPRB, 0.63582186E-11_JPRB, 0.63262898E-11_JPRB, 0.62910662E-11_JPRB, &
  & 0.61682265E-11_JPRB, 0.59855454E-11_JPRB, 0.58103049E-11_JPRB, 0.56421139E-11_JPRB, 0.55026387E-11_JPRB, 0.53833925E-11_JPRB, &
  & 0.53289530E-11_JPRB, 0.53505325E-11_JPRB, 0.58902167E-11_JPRB, 0.59790783E-11_JPRB, 0.60242679E-11_JPRB, 0.60507081E-11_JPRB, &
  & 0.61221314E-11_JPRB, 0.62371115E-11_JPRB, 0.63785292E-11_JPRB, 0.64342654E-11_JPRB /)

RGHG4(:,64, 4) = (/ &
  & 0.25019583E-11_JPRB, 0.29909090E-11_JPRB, 0.35437204E-11_JPRB, 0.42671474E-11_JPRB, 0.51350742E-11_JPRB, 0.39698678E-11_JPRB, &
  & 0.43436760E-11_JPRB, 0.46312589E-11_JPRB, 0.46853281E-11_JPRB, 0.47882705E-11_JPRB, 0.49058427E-11_JPRB, 0.50436816E-11_JPRB, &
  & 0.52335996E-11_JPRB, 0.54944469E-11_JPRB, 0.57636148E-11_JPRB, 0.60066930E-11_JPRB, 0.62294024E-11_JPRB, 0.64115883E-11_JPRB, &
  & 0.65070904E-11_JPRB, 0.64969380E-11_JPRB, 0.63668211E-11_JPRB, 0.61072154E-11_JPRB, 0.57832688E-11_JPRB, 0.54518200E-11_JPRB, &
  & 0.51823064E-11_JPRB, 0.50131878E-11_JPRB, 0.49388289E-11_JPRB, 0.49359497E-11_JPRB, 0.49676066E-11_JPRB, 0.49980172E-11_JPRB, &
  & 0.50021272E-11_JPRB, 0.49790198E-11_JPRB, 0.49424406E-11_JPRB, 0.49462218E-11_JPRB, 0.50287014E-11_JPRB, 0.52205380E-11_JPRB, &
  & 0.55444629E-11_JPRB, 0.59447234E-11_JPRB, 0.63661485E-11_JPRB, 0.67187944E-11_JPRB, 0.69559319E-11_JPRB, 0.70878373E-11_JPRB, &
  & 0.71210234E-11_JPRB, 0.71319036E-11_JPRB, 0.71257176E-11_JPRB, 0.71875284E-11_JPRB, 0.72127278E-11_JPRB, 0.72218048E-11_JPRB, &
  & 0.71543223E-11_JPRB, 0.70195069E-11_JPRB, 0.68708190E-11_JPRB, 0.67254019E-11_JPRB, 0.65860477E-11_JPRB, 0.64483228E-11_JPRB, &
  & 0.63846068E-11_JPRB, 0.64295921E-11_JPRB, 0.69809961E-11_JPRB, 0.70678966E-11_JPRB, 0.70848522E-11_JPRB, 0.70807726E-11_JPRB, &
  & 0.71417204E-11_JPRB, 0.72644872E-11_JPRB, 0.74102981E-11_JPRB, 0.73767711E-11_JPRB /)

RGHG4(:,65, 4) = (/ &
  & 0.23923331E-11_JPRB, 0.28499687E-11_JPRB, 0.34369120E-11_JPRB, 0.41958021E-11_JPRB, 0.51898629E-11_JPRB, 0.42742676E-11_JPRB, &
  & 0.48133737E-11_JPRB, 0.52621596E-11_JPRB, 0.54093106E-11_JPRB, 0.55926184E-11_JPRB, 0.57612218E-11_JPRB, 0.59254030E-11_JPRB, &
  & 0.61047053E-11_JPRB, 0.63156047E-11_JPRB, 0.65058796E-11_JPRB, 0.66651099E-11_JPRB, 0.68105721E-11_JPRB, 0.69253743E-11_JPRB, &
  & 0.69808920E-11_JPRB, 0.69459456E-11_JPRB, 0.67998931E-11_JPRB, 0.65489931E-11_JPRB, 0.62426032E-11_JPRB, 0.59497208E-11_JPRB, &
  & 0.57341137E-11_JPRB, 0.56248925E-11_JPRB, 0.56089274E-11_JPRB, 0.56597765E-11_JPRB, 0.57348393E-11_JPRB, 0.57956036E-11_JPRB, &
  & 0.58158131E-11_JPRB, 0.57899094E-11_JPRB, 0.57311382E-11_JPRB, 0.56928251E-11_JPRB, 0.57273721E-11_JPRB, 0.58756324E-11_JPRB, &
  & 0.61673466E-11_JPRB, 0.65470004E-11_JPRB, 0.69661828E-11_JPRB, 0.73396419E-11_JPRB, 0.76140396E-11_JPRB, 0.78015927E-11_JPRB, &
  & 0.78941029E-11_JPRB, 0.79709043E-11_JPRB, 0.80339485E-11_JPRB, 0.81565206E-11_JPRB, 0.82429653E-11_JPRB, 0.83148549E-11_JPRB, &
  & 0.83092751E-11_JPRB, 0.82211252E-11_JPRB, 0.81056065E-11_JPRB, 0.79994405E-11_JPRB, 0.78744155E-11_JPRB, 0.77482170E-11_JPRB, &
  & 0.76886024E-11_JPRB, 0.77731840E-11_JPRB, 0.83601077E-11_JPRB, 0.84486359E-11_JPRB, 0.84310406E-11_JPRB, 0.83904723E-11_JPRB, &
  & 0.84430431E-11_JPRB, 0.85800742E-11_JPRB, 0.87356988E-11_JPRB, 0.85923968E-11_JPRB /)

RGHG4(:,66, 4) = (/ &
  & 0.22502939E-11_JPRB, 0.26682682E-11_JPRB, 0.32657796E-11_JPRB, 0.41062783E-11_JPRB, 0.52163794E-11_JPRB, 0.46174930E-11_JPRB, &
  & 0.53910067E-11_JPRB, 0.60190039E-11_JPRB, 0.63225488E-11_JPRB, 0.65546839E-11_JPRB, 0.67507840E-11_JPRB, 0.68918768E-11_JPRB, &
  & 0.70203916E-11_JPRB, 0.71569699E-11_JPRB, 0.72702664E-11_JPRB, 0.73565598E-11_JPRB, 0.74410218E-11_JPRB, 0.75014144E-11_JPRB, &
  & 0.75152089E-11_JPRB, 0.74560809E-11_JPRB, 0.73013227E-11_JPRB, 0.70624856E-11_JPRB, 0.67909658E-11_JPRB, 0.65554788E-11_JPRB, &
  & 0.64028778E-11_JPRB, 0.63569787E-11_JPRB, 0.64080620E-11_JPRB, 0.65189156E-11_JPRB, 0.66419596E-11_JPRB, 0.67373013E-11_JPRB, &
  & 0.67782386E-11_JPRB, 0.67523322E-11_JPRB, 0.66712950E-11_JPRB, 0.65961733E-11_JPRB, 0.65846651E-11_JPRB, 0.66913966E-11_JPRB, &
  & 0.69467856E-11_JPRB, 0.73047254E-11_JPRB, 0.77177830E-11_JPRB, 0.81091080E-11_JPRB, 0.84202888E-11_JPRB, 0.86652257E-11_JPRB, &
  & 0.88202362E-11_JPRB, 0.89660146E-11_JPRB, 0.91017879E-11_JPRB, 0.92773567E-11_JPRB, 0.94418102E-11_JPRB, 0.95626588E-11_JPRB, &
  & 0.96209195E-11_JPRB, 0.95922098E-11_JPRB, 0.95246979E-11_JPRB, 0.94602373E-11_JPRB, 0.93649307E-11_JPRB, 0.92631094E-11_JPRB, &
  & 0.92121588E-11_JPRB, 0.93453873E-11_JPRB, 0.10015237E-10_JPRB, 0.10126155E-10_JPRB, 0.10076703E-10_JPRB, 0.99834247E-11_JPRB, &
  & 0.10034123E-10_JPRB, 0.10205900E-10_JPRB, 0.10391149E-10_JPRB, 0.10095179E-10_JPRB /)

RGHG4(:,67, 4) = (/ &
  & 0.20838776E-11_JPRB, 0.24736595E-11_JPRB, 0.31019996E-11_JPRB, 0.39888388E-11_JPRB, 0.52681262E-11_JPRB, 0.50227105E-11_JPRB, &
  & 0.60861806E-11_JPRB, 0.69504116E-11_JPRB, 0.73503131E-11_JPRB, 0.76601555E-11_JPRB, 0.78185783E-11_JPRB, 0.79078185E-11_JPRB, &
  & 0.79826588E-11_JPRB, 0.80487908E-11_JPRB, 0.80999972E-11_JPRB, 0.81222459E-11_JPRB, 0.81422612E-11_JPRB, 0.81452614E-11_JPRB, &
  & 0.81282724E-11_JPRB, 0.80524311E-11_JPRB, 0.78995499E-11_JPRB, 0.76883716E-11_JPRB, 0.74613241E-11_JPRB, 0.72864778E-11_JPRB, &
  & 0.72110499E-11_JPRB, 0.72468238E-11_JPRB, 0.73657313E-11_JPRB, 0.75347506E-11_JPRB, 0.77062141E-11_JPRB, 0.78387756E-11_JPRB, &
  & 0.79057230E-11_JPRB, 0.78886463E-11_JPRB, 0.77942479E-11_JPRB, 0.76818864E-11_JPRB, 0.76278419E-11_JPRB, 0.76950035E-11_JPRB, &
  & 0.79188444E-11_JPRB, 0.82559237E-11_JPRB, 0.86632090E-11_JPRB, 0.90701622E-11_JPRB, 0.94184651E-11_JPRB, 0.97205880E-11_JPRB, &
  & 0.99380096E-11_JPRB, 0.10157935E-10_JPRB, 0.10365131E-10_JPRB, 0.10615583E-10_JPRB, 0.10841722E-10_JPRB, 0.11038712E-10_JPRB, &
  & 0.11164680E-10_JPRB, 0.11188279E-10_JPRB, 0.11167380E-10_JPRB, 0.11144977E-10_JPRB, 0.11085556E-10_JPRB, 0.11008003E-10_JPRB, &
  & 0.10976041E-10_JPRB, 0.11150282E-10_JPRB, 0.11917182E-10_JPRB, 0.12057787E-10_JPRB, 0.11986727E-10_JPRB, 0.11859303E-10_JPRB, &
  & 0.11928921E-10_JPRB, 0.12157737E-10_JPRB, 0.12390486E-10_JPRB, 0.11912627E-10_JPRB /)

RGHG4(:,68, 4) = (/ &
  & 0.19446961E-11_JPRB, 0.23261386E-11_JPRB, 0.29728093E-11_JPRB, 0.39237012E-11_JPRB, 0.53538415E-11_JPRB, 0.55889165E-11_JPRB, &
  & 0.69301453E-11_JPRB, 0.80212573E-11_JPRB, 0.85421739E-11_JPRB, 0.87985183E-11_JPRB, 0.89198969E-11_JPRB, 0.89334373E-11_JPRB, &
  & 0.89637213E-11_JPRB, 0.89779226E-11_JPRB, 0.89759086E-11_JPRB, 0.89524655E-11_JPRB, 0.89338146E-11_JPRB, 0.88999684E-11_JPRB, &
  & 0.88530485E-11_JPRB, 0.87665483E-11_JPRB, 0.86250573E-11_JPRB, 0.84481406E-11_JPRB, 0.82810096E-11_JPRB, 0.81865955E-11_JPRB, &
  & 0.81898438E-11_JPRB, 0.82951354E-11_JPRB, 0.84889899E-11_JPRB, 0.87245966E-11_JPRB, 0.89499337E-11_JPRB, 0.91231432E-11_JPRB, &
  & 0.92191966E-11_JPRB, 0.92133723E-11_JPRB, 0.91091848E-11_JPRB, 0.89759788E-11_JPRB, 0.88893684E-11_JPRB, 0.89261090E-11_JPRB, &
  & 0.91222186E-11_JPRB, 0.94430670E-11_JPRB, 0.98470529E-11_JPRB, 0.10268643E-10_JPRB, 0.10653339E-10_JPRB, 0.11012410E-10_JPRB, &
  & 0.11294847E-10_JPRB, 0.11588975E-10_JPRB, 0.11864211E-10_JPRB, 0.12184304E-10_JPRB, 0.12487147E-10_JPRB, 0.12732573E-10_JPRB, &
  & 0.12917157E-10_JPRB, 0.13011007E-10_JPRB, 0.13045876E-10_JPRB, 0.13067469E-10_JPRB, 0.13045761E-10_JPRB, 0.13005452E-10_JPRB, &
  & 0.12991634E-10_JPRB, 0.13224468E-10_JPRB, 0.14092027E-10_JPRB, 0.14269524E-10_JPRB, 0.14179438E-10_JPRB, 0.14004346E-10_JPRB, &
  & 0.14101526E-10_JPRB, 0.14406498E-10_JPRB, 0.14702723E-10_JPRB, 0.14011470E-10_JPRB /)

RGHG4(:,69, 4) = (/ &
  & 0.18913360E-11_JPRB, 0.22672231E-11_JPRB, 0.29594938E-11_JPRB, 0.39525583E-11_JPRB, 0.55708081E-11_JPRB, 0.62741748E-11_JPRB, &
  & 0.79578037E-11_JPRB, 0.92124329E-11_JPRB, 0.97709445E-11_JPRB, 0.99843467E-11_JPRB, 0.10051394E-10_JPRB, 0.10027702E-10_JPRB, &
  & 0.10023082E-10_JPRB, 0.10002752E-10_JPRB, 0.99617189E-11_JPRB, 0.99036387E-11_JPRB, 0.98383012E-11_JPRB, 0.97751833E-11_JPRB, &
  & 0.97161636E-11_JPRB, 0.96310295E-11_JPRB, 0.95128445E-11_JPRB, 0.93819926E-11_JPRB, 0.92800602E-11_JPRB, 0.92602670E-11_JPRB, &
  & 0.93540592E-11_JPRB, 0.95545759E-11_JPRB, 0.98233305E-11_JPRB, 0.10121700E-10_JPRB, 0.10400525E-10_JPRB, 0.10618780E-10_JPRB, &
  & 0.10751461E-10_JPRB, 0.10771208E-10_JPRB, 0.10672681E-10_JPRB, 0.10517182E-10_JPRB, 0.10404524E-10_JPRB, 0.10416475E-10_JPRB, &
  & 0.10597564E-10_JPRB, 0.10909461E-10_JPRB, 0.11316785E-10_JPRB, 0.11755568E-10_JPRB, 0.12178256E-10_JPRB, 0.12596275E-10_JPRB, &
  & 0.12945640E-10_JPRB, 0.13317364E-10_JPRB, 0.13667806E-10_JPRB, 0.14069397E-10_JPRB, 0.14424959E-10_JPRB, 0.14755655E-10_JPRB, &
  & 0.15010973E-10_JPRB, 0.15157880E-10_JPRB, 0.15225717E-10_JPRB, 0.15295118E-10_JPRB, 0.15302148E-10_JPRB, 0.15305852E-10_JPRB, &
  & 0.15295589E-10_JPRB, 0.15586846E-10_JPRB, 0.16549635E-10_JPRB, 0.16769560E-10_JPRB, 0.16680941E-10_JPRB, 0.16482784E-10_JPRB, &
  & 0.16626410E-10_JPRB, 0.17011633E-10_JPRB, 0.17368927E-10_JPRB, 0.16482940E-10_JPRB /)

RGHG4(:,70, 4) = (/ &
  & 0.19528441E-11_JPRB, 0.23728981E-11_JPRB, 0.31074596E-11_JPRB, 0.41869455E-11_JPRB, 0.59605229E-11_JPRB, 0.71425101E-11_JPRB, &
  & 0.91002058E-11_JPRB, 0.10520904E-10_JPRB, 0.11027784E-10_JPRB, 0.11200403E-10_JPRB, 0.11214760E-10_JPRB, 0.11160608E-10_JPRB, &
  & 0.11134890E-10_JPRB, 0.11095546E-10_JPRB, 0.11027247E-10_JPRB, 0.10961627E-10_JPRB, 0.10889224E-10_JPRB, 0.10817892E-10_JPRB, &
  & 0.10752460E-10_JPRB, 0.10679823E-10_JPRB, 0.10592438E-10_JPRB, 0.10517632E-10_JPRB, 0.10490835E-10_JPRB, 0.10564686E-10_JPRB, &
  & 0.10740196E-10_JPRB, 0.11009984E-10_JPRB, 0.11356325E-10_JPRB, 0.11730241E-10_JPRB, 0.12071835E-10_JPRB, 0.12341591E-10_JPRB, &
  & 0.12517174E-10_JPRB, 0.12564155E-10_JPRB, 0.12475590E-10_JPRB, 0.12327557E-10_JPRB, 0.12212527E-10_JPRB, 0.12213535E-10_JPRB, &
  & 0.12389542E-10_JPRB, 0.12704194E-10_JPRB, 0.13121181E-10_JPRB, 0.13581712E-10_JPRB, 0.14047178E-10_JPRB, 0.14526458E-10_JPRB, &
  & 0.14949033E-10_JPRB, 0.15391612E-10_JPRB, 0.15821757E-10_JPRB, 0.16294343E-10_JPRB, 0.16725605E-10_JPRB, 0.17096777E-10_JPRB, &
  & 0.17404937E-10_JPRB, 0.17618119E-10_JPRB, 0.17742675E-10_JPRB, 0.17867641E-10_JPRB, 0.17900693E-10_JPRB, 0.17953691E-10_JPRB, &
  & 0.17954570E-10_JPRB, 0.18299961E-10_JPRB, 0.19355925E-10_JPRB, 0.19617087E-10_JPRB, 0.19533005E-10_JPRB, 0.19324249E-10_JPRB, &
  & 0.19532539E-10_JPRB, 0.19999634E-10_JPRB, 0.20402931E-10_JPRB, 0.19330574E-10_JPRB /)

RGHG4(:,71, 4) = (/ &
  & 0.21899960E-11_JPRB, 0.26902330E-11_JPRB, 0.35701821E-11_JPRB, 0.46979881E-11_JPRB, 0.66304280E-11_JPRB, 0.82010284E-11_JPRB, &
  & 0.10401023E-10_JPRB, 0.11847235E-10_JPRB, 0.12334506E-10_JPRB, 0.12466535E-10_JPRB, 0.12473285E-10_JPRB, 0.12409378E-10_JPRB, &
  & 0.12379489E-10_JPRB, 0.12337614E-10_JPRB, 0.12263857E-10_JPRB, 0.12188354E-10_JPRB, 0.12102924E-10_JPRB, 0.12037186E-10_JPRB, &
  & 0.11988435E-10_JPRB, 0.11940797E-10_JPRB, 0.11898211E-10_JPRB, 0.11886652E-10_JPRB, 0.11938425E-10_JPRB, 0.12090318E-10_JPRB, &
  & 0.12367482E-10_JPRB, 0.12751652E-10_JPRB, 0.13183778E-10_JPRB, 0.13625619E-10_JPRB, 0.14029377E-10_JPRB, 0.14356524E-10_JPRB, &
  & 0.14586799E-10_JPRB, 0.14684637E-10_JPRB, 0.14629980E-10_JPRB, 0.14482660E-10_JPRB, 0.14361698E-10_JPRB, 0.14368041E-10_JPRB, &
  & 0.14555234E-10_JPRB, 0.14879776E-10_JPRB, 0.15315962E-10_JPRB, 0.15803433E-10_JPRB, 0.16316407E-10_JPRB, 0.16861295E-10_JPRB, &
  & 0.17353265E-10_JPRB, 0.17876069E-10_JPRB, 0.18379064E-10_JPRB, 0.18929682E-10_JPRB, 0.19429966E-10_JPRB, 0.19888716E-10_JPRB, &
  & 0.20268490E-10_JPRB, 0.20528019E-10_JPRB, 0.20685436E-10_JPRB, 0.20850315E-10_JPRB, 0.20915228E-10_JPRB, 0.21009907E-10_JPRB, &
  & 0.21034667E-10_JPRB, 0.21422896E-10_JPRB, 0.22552550E-10_JPRB, 0.22865239E-10_JPRB, 0.22801502E-10_JPRB, 0.22605090E-10_JPRB, &
  & 0.22880399E-10_JPRB, 0.23436376E-10_JPRB, 0.23922352E-10_JPRB, 0.22771202E-10_JPRB /)

RGHG4(:,72, 4) = (/ &
  & 0.26910711E-11_JPRB, 0.33974349E-11_JPRB, 0.43932388E-11_JPRB, 0.56709073E-11_JPRB, 0.77064978E-11_JPRB, 0.94593647E-11_JPRB, &
  & 0.11775075E-10_JPRB, 0.13241770E-10_JPRB, 0.13692103E-10_JPRB, 0.13801892E-10_JPRB, 0.13803072E-10_JPRB, 0.13745159E-10_JPRB, &
  & 0.13725023E-10_JPRB, 0.13690443E-10_JPRB, 0.13636036E-10_JPRB, 0.13582999E-10_JPRB, 0.13532404E-10_JPRB, 0.13484529E-10_JPRB, &
  & 0.13454763E-10_JPRB, 0.13446647E-10_JPRB, 0.13458328E-10_JPRB, 0.13520389E-10_JPRB, 0.13660289E-10_JPRB, 0.13924789E-10_JPRB, &
  & 0.14292378E-10_JPRB, 0.14742069E-10_JPRB, 0.15261648E-10_JPRB, 0.15793833E-10_JPRB, 0.16275814E-10_JPRB, 0.16669034E-10_JPRB, &
  & 0.16958299E-10_JPRB, 0.17104830E-10_JPRB, 0.17087946E-10_JPRB, 0.16988405E-10_JPRB, 0.16908724E-10_JPRB, 0.16942871E-10_JPRB, &
  & 0.17152165E-10_JPRB, 0.17496896E-10_JPRB, 0.17958782E-10_JPRB, 0.18481463E-10_JPRB, 0.19047071E-10_JPRB, 0.19655408E-10_JPRB, &
  & 0.20224971E-10_JPRB, 0.20810503E-10_JPRB, 0.21400548E-10_JPRB, 0.22014121E-10_JPRB, 0.22600680E-10_JPRB, 0.23093505E-10_JPRB, &
  & 0.23516069E-10_JPRB, 0.23838336E-10_JPRB, 0.24069241E-10_JPRB, 0.24294693E-10_JPRB, 0.24414606E-10_JPRB, 0.24543081E-10_JPRB, &
  & 0.24607871E-10_JPRB, 0.25021952E-10_JPRB, 0.26217910E-10_JPRB, 0.26567255E-10_JPRB, 0.26534509E-10_JPRB, 0.26359200E-10_JPRB, &
  & 0.26709994E-10_JPRB, 0.27354690E-10_JPRB, 0.27922846E-10_JPRB, 0.26850197E-10_JPRB /)

RGHG4(:,73, 4) = (/ &
  & 0.35700310E-11_JPRB, 0.45796067E-11_JPRB, 0.58120470E-11_JPRB, 0.71239963E-11_JPRB, 0.93846216E-11_JPRB, 0.10906157E-10_JPRB, &
  & 0.13236856E-10_JPRB, 0.14672171E-10_JPRB, 0.15100182E-10_JPRB, 0.15217272E-10_JPRB, 0.15273699E-10_JPRB, 0.15234777E-10_JPRB, &
  & 0.15245298E-10_JPRB, 0.15240250E-10_JPRB, 0.15206548E-10_JPRB, 0.15170445E-10_JPRB, 0.15142143E-10_JPRB, 0.15136019E-10_JPRB, &
  & 0.15153975E-10_JPRB, 0.15201134E-10_JPRB, 0.15282827E-10_JPRB, 0.15431493E-10_JPRB, 0.15672673E-10_JPRB, 0.16023688E-10_JPRB, &
  & 0.16513823E-10_JPRB, 0.17112095E-10_JPRB, 0.17742171E-10_JPRB, 0.18359420E-10_JPRB, 0.18915636E-10_JPRB, 0.19383422E-10_JPRB, &
  & 0.19750472E-10_JPRB, 0.19980174E-10_JPRB, 0.20035223E-10_JPRB, 0.19966218E-10_JPRB, 0.19907343E-10_JPRB, 0.19987591E-10_JPRB, &
  & 0.20236765E-10_JPRB, 0.20609424E-10_JPRB, 0.21101849E-10_JPRB, 0.21657717E-10_JPRB, 0.22275176E-10_JPRB, 0.22952740E-10_JPRB, &
  & 0.23582912E-10_JPRB, 0.24245977E-10_JPRB, 0.24902523E-10_JPRB, 0.25590949E-10_JPRB, 0.26251218E-10_JPRB, 0.26827237E-10_JPRB, &
  & 0.27333875E-10_JPRB, 0.27698479E-10_JPRB, 0.27975920E-10_JPRB, 0.28243423E-10_JPRB, 0.28416143E-10_JPRB, 0.28589962E-10_JPRB, &
  & 0.28691358E-10_JPRB, 0.29147781E-10_JPRB, 0.30345181E-10_JPRB, 0.30731629E-10_JPRB, 0.30723007E-10_JPRB, 0.30578526E-10_JPRB, &
  & 0.30981110E-10_JPRB, 0.31684839E-10_JPRB, 0.32301051E-10_JPRB, 0.31257743E-10_JPRB /)

RGHG4(:,74, 4) = (/ &
  & 0.50143518E-11_JPRB, 0.64090018E-11_JPRB, 0.78097320E-11_JPRB, 0.92153429E-11_JPRB, 0.11566381E-10_JPRB, 0.12549546E-10_JPRB, &
  & 0.14778605E-10_JPRB, 0.16184630E-10_JPRB, 0.16550638E-10_JPRB, 0.16727309E-10_JPRB, 0.16789374E-10_JPRB, 0.16830331E-10_JPRB, &
  & 0.16867891E-10_JPRB, 0.16915237E-10_JPRB, 0.16936086E-10_JPRB, 0.16966524E-10_JPRB, 0.16999515E-10_JPRB, 0.17048390E-10_JPRB, &
  & 0.17118801E-10_JPRB, 0.17239356E-10_JPRB, 0.17403386E-10_JPRB, 0.17658533E-10_JPRB, 0.18014047E-10_JPRB, 0.18509499E-10_JPRB, &
  & 0.19100927E-10_JPRB, 0.19770702E-10_JPRB, 0.20493607E-10_JPRB, 0.21219058E-10_JPRB, 0.21875779E-10_JPRB, 0.22430431E-10_JPRB, &
  & 0.22876260E-10_JPRB, 0.23179432E-10_JPRB, 0.23309086E-10_JPRB, 0.23356357E-10_JPRB, 0.23419077E-10_JPRB, 0.23570345E-10_JPRB, &
  & 0.23871901E-10_JPRB, 0.24283136E-10_JPRB, 0.24811037E-10_JPRB, 0.25401488E-10_JPRB, 0.26076478E-10_JPRB, 0.26814533E-10_JPRB, &
  & 0.27512707E-10_JPRB, 0.28223699E-10_JPRB, 0.28962605E-10_JPRB, 0.29707313E-10_JPRB, 0.30436667E-10_JPRB, 0.31047741E-10_JPRB, &
  & 0.31582150E-10_JPRB, 0.32019640E-10_JPRB, 0.32383141E-10_JPRB, 0.32730183E-10_JPRB, 0.32973645E-10_JPRB, 0.33192324E-10_JPRB, &
  & 0.33350232E-10_JPRB, 0.33800813E-10_JPRB, 0.35011515E-10_JPRB, 0.35393657E-10_JPRB, 0.35400908E-10_JPRB, 0.35282215E-10_JPRB, &
  & 0.35725412E-10_JPRB, 0.36472020E-10_JPRB, 0.37112348E-10_JPRB, 0.36047287E-10_JPRB /)

RGHG4(:,75, 4) = (/ &
  & 0.70373759E-11_JPRB, 0.88810504E-11_JPRB, 0.10471552E-10_JPRB, 0.11840477E-10_JPRB, 0.14261500E-10_JPRB, 0.14364047E-10_JPRB, &
  & 0.16433658E-10_JPRB, 0.17729320E-10_JPRB, 0.18109245E-10_JPRB, 0.18297306E-10_JPRB, 0.18505536E-10_JPRB, 0.18570364E-10_JPRB, &
  & 0.18703076E-10_JPRB, 0.18806781E-10_JPRB, 0.18887919E-10_JPRB, 0.18971576E-10_JPRB, 0.19070519E-10_JPRB, 0.19205382E-10_JPRB, &
  & 0.19366432E-10_JPRB, 0.19584258E-10_JPRB, 0.19858802E-10_JPRB, 0.20231879E-10_JPRB, 0.20716266E-10_JPRB, 0.21312483E-10_JPRB, &
  & 0.22064699E-10_JPRB, 0.22922522E-10_JPRB, 0.23806554E-10_JPRB, 0.24649316E-10_JPRB, 0.25414035E-10_JPRB, 0.26065625E-10_JPRB, &
  & 0.26622322E-10_JPRB, 0.27044237E-10_JPRB, 0.27293669E-10_JPRB, 0.27412806E-10_JPRB, 0.27508664E-10_JPRB, 0.27749853E-10_JPRB, &
  & 0.28124655E-10_JPRB, 0.28580265E-10_JPRB, 0.29151809E-10_JPRB, 0.29786559E-10_JPRB, 0.30515587E-10_JPRB, 0.31308060E-10_JPRB, &
  & 0.32041408E-10_JPRB, 0.32823886E-10_JPRB, 0.33613858E-10_JPRB, 0.34421663E-10_JPRB, 0.35234017E-10_JPRB, 0.35927806E-10_JPRB, &
  & 0.36550714E-10_JPRB, 0.37023228E-10_JPRB, 0.37445651E-10_JPRB, 0.37824285E-10_JPRB, 0.38126998E-10_JPRB, 0.38396234E-10_JPRB, &
  & 0.38585191E-10_JPRB, 0.39050964E-10_JPRB, 0.40218107E-10_JPRB, 0.40592519E-10_JPRB, 0.40603017E-10_JPRB, 0.40500717E-10_JPRB, &
  & 0.40980618E-10_JPRB, 0.41764821E-10_JPRB, 0.42405537E-10_JPRB, 0.41249372E-10_JPRB /)

RGHG4(:,76, 4) = (/ &
  & 0.96650517E-11_JPRB, 0.12004104E-10_JPRB, 0.13734529E-10_JPRB, 0.15006135E-10_JPRB, 0.17287564E-10_JPRB, 0.16313353E-10_JPRB, &
  & 0.18176021E-10_JPRB, 0.19353113E-10_JPRB, 0.19669363E-10_JPRB, 0.19960726E-10_JPRB, 0.20136080E-10_JPRB, 0.20364110E-10_JPRB, &
  & 0.20540987E-10_JPRB, 0.20764217E-10_JPRB, 0.20965178E-10_JPRB, 0.21168178E-10_JPRB, 0.21376161E-10_JPRB, 0.21618042E-10_JPRB, &
  & 0.21887069E-10_JPRB, 0.22232825E-10_JPRB, 0.22636131E-10_JPRB, 0.23155854E-10_JPRB, 0.23787177E-10_JPRB, 0.24570290E-10_JPRB, &
  & 0.25431780E-10_JPRB, 0.26353896E-10_JPRB, 0.27315095E-10_JPRB, 0.28266387E-10_JPRB, 0.29145211E-10_JPRB, 0.29906293E-10_JPRB, &
  & 0.30572076E-10_JPRB, 0.31111010E-10_JPRB, 0.31503258E-10_JPRB, 0.31835080E-10_JPRB, 0.32183218E-10_JPRB, 0.32554931E-10_JPRB, &
  & 0.33023584E-10_JPRB, 0.33532403E-10_JPRB, 0.34153482E-10_JPRB, 0.34837373E-10_JPRB, 0.35626023E-10_JPRB, 0.36457937E-10_JPRB, &
  & 0.37228835E-10_JPRB, 0.38054320E-10_JPRB, 0.38894298E-10_JPRB, 0.39764792E-10_JPRB, 0.40620049E-10_JPRB, 0.41351530E-10_JPRB, &
  & 0.41976891E-10_JPRB, 0.42510398E-10_JPRB, 0.43012788E-10_JPRB, 0.43479713E-10_JPRB, 0.43857421E-10_JPRB, 0.44185440E-10_JPRB, &
  & 0.44404005E-10_JPRB, 0.44855862E-10_JPRB, 0.45963983E-10_JPRB, 0.46315247E-10_JPRB, 0.46327015E-10_JPRB, 0.46243464E-10_JPRB, &
  & 0.46762403E-10_JPRB, 0.47572595E-10_JPRB, 0.48193359E-10_JPRB, 0.46867121E-10_JPRB /)

RGHG4(:,77, 4) = (/ &
  & 0.12935930E-10_JPRB, 0.15738600E-10_JPRB, 0.17511707E-10_JPRB, 0.18605298E-10_JPRB, 0.20577606E-10_JPRB, 0.18373143E-10_JPRB, &
  & 0.19904044E-10_JPRB, 0.20962137E-10_JPRB, 0.21272204E-10_JPRB, 0.21553405E-10_JPRB, 0.21935412E-10_JPRB, 0.22149062E-10_JPRB, &
  & 0.22487463E-10_JPRB, 0.22807022E-10_JPRB, 0.23125869E-10_JPRB, 0.23453340E-10_JPRB, 0.23801442E-10_JPRB, 0.24198782E-10_JPRB, &
  & 0.24626799E-10_JPRB, 0.25126448E-10_JPRB, 0.25693378E-10_JPRB, 0.26370909E-10_JPRB, 0.27167647E-10_JPRB, 0.28052862E-10_JPRB, &
  & 0.29121167E-10_JPRB, 0.30278207E-10_JPRB, 0.31465427E-10_JPRB, 0.32598538E-10_JPRB, 0.33634037E-10_JPRB, 0.34541148E-10_JPRB, &
  & 0.35343679E-10_JPRB, 0.36035040E-10_JPRB, 0.36595883E-10_JPRB, 0.37040711E-10_JPRB, 0.37420417E-10_JPRB, 0.37906383E-10_JPRB, &
  & 0.38496758E-10_JPRB, 0.39066684E-10_JPRB, 0.39754394E-10_JPRB, 0.40496450E-10_JPRB, 0.41345753E-10_JPRB, 0.42213802E-10_JPRB, &
  & 0.42994937E-10_JPRB, 0.43847852E-10_JPRB, 0.44706922E-10_JPRB, 0.45609360E-10_JPRB, 0.46530797E-10_JPRB, 0.47335798E-10_JPRB, &
  & 0.48036554E-10_JPRB, 0.48586198E-10_JPRB, 0.49141292E-10_JPRB, 0.49632454E-10_JPRB, 0.50061885E-10_JPRB, 0.50431652E-10_JPRB, &
  & 0.50685612E-10_JPRB, 0.51115570E-10_JPRB, 0.52139210E-10_JPRB, 0.52451227E-10_JPRB, 0.52483729E-10_JPRB, 0.52440878E-10_JPRB, &
  & 0.52994380E-10_JPRB, 0.53816705E-10_JPRB, 0.54384969E-10_JPRB, 0.52873917E-10_JPRB /)

RGHG4(:,78, 4) = (/ &
  & 0.16784470E-10_JPRB, 0.19831806E-10_JPRB, 0.21519812E-10_JPRB, 0.22354165E-10_JPRB, 0.23884681E-10_JPRB, 0.20305922E-10_JPRB, &
  & 0.21511050E-10_JPRB, 0.22391996E-10_JPRB, 0.22682510E-10_JPRB, 0.23034571E-10_JPRB, 0.23336546E-10_JPRB, 0.23743623E-10_JPRB, &
  & 0.24122232E-10_JPRB, 0.24619206E-10_JPRB, 0.25112256E-10_JPRB, 0.25616806E-10_JPRB, 0.26141903E-10_JPRB, 0.26719196E-10_JPRB, &
  & 0.27328166E-10_JPRB, 0.28016865E-10_JPRB, 0.28763698E-10_JPRB, 0.29624136E-10_JPRB, 0.30582727E-10_JPRB, 0.31654752E-10_JPRB, &
  & 0.32792141E-10_JPRB, 0.33994908E-10_JPRB, 0.35150514E-10_JPRB, 0.36300647E-10_JPRB, 0.37391212E-10_JPRB, 0.38406021E-10_JPRB, &
  & 0.39355033E-10_JPRB, 0.40245689E-10_JPRB, 0.41059232E-10_JPRB, 0.41834900E-10_JPRB, 0.42630340E-10_JPRB, 0.43374835E-10_JPRB, &
  & 0.44079535E-10_JPRB, 0.44757090E-10_JPRB, 0.45518443E-10_JPRB, 0.46326241E-10_JPRB, 0.47215527E-10_JPRB, 0.48090882E-10_JPRB, &
  & 0.48848134E-10_JPRB, 0.49681714E-10_JPRB, 0.50507459E-10_JPRB, 0.51415403E-10_JPRB, 0.52348081E-10_JPRB, 0.53103126E-10_JPRB, &
  & 0.53811414E-10_JPRB, 0.54381177E-10_JPRB, 0.55008616E-10_JPRB, 0.55604348E-10_JPRB, 0.56090157E-10_JPRB, 0.56534943E-10_JPRB, &
  & 0.56823463E-10_JPRB, 0.57247079E-10_JPRB, 0.58168439E-10_JPRB, 0.58467564E-10_JPRB, 0.58549797E-10_JPRB, 0.58581112E-10_JPRB, &
  & 0.59174131E-10_JPRB, 0.59987917E-10_JPRB, 0.60608497E-10_JPRB, 0.59148748E-10_JPRB /)

RGHG4(:,79, 4) = (/ &
  & 0.20877959E-10_JPRB, 0.23468278E-10_JPRB, 0.24547945E-10_JPRB, 0.25051539E-10_JPRB, 0.26118855E-10_JPRB, 0.21518219E-10_JPRB, &
  & 0.22464660E-10_JPRB, 0.23265318E-10_JPRB, 0.23505723E-10_JPRB, 0.23829246E-10_JPRB, 0.24276251E-10_JPRB, 0.24602632E-10_JPRB, &
  & 0.25118779E-10_JPRB, 0.25677294E-10_JPRB, 0.26275204E-10_JPRB, 0.26926664E-10_JPRB, 0.27627499E-10_JPRB, 0.28384963E-10_JPRB, &
  & 0.29173518E-10_JPRB, 0.30017131E-10_JPRB, 0.30899294E-10_JPRB, 0.31851369E-10_JPRB, 0.32824431E-10_JPRB, 0.33850703E-10_JPRB, &
  & 0.34903962E-10_JPRB, 0.36083216E-10_JPRB, 0.37250675E-10_JPRB, 0.38412298E-10_JPRB, 0.39531739E-10_JPRB, 0.40612198E-10_JPRB, &
  & 0.41650752E-10_JPRB, 0.42664303E-10_JPRB, 0.43648050E-10_JPRB, 0.44596198E-10_JPRB, 0.45491656E-10_JPRB, 0.46438266E-10_JPRB, &
  & 0.47455113E-10_JPRB, 0.48415230E-10_JPRB, 0.49344941E-10_JPRB, 0.50250578E-10_JPRB, 0.51173357E-10_JPRB, 0.52012668E-10_JPRB, &
  & 0.52695567E-10_JPRB, 0.53435523E-10_JPRB, 0.54144814E-10_JPRB, 0.54930675E-10_JPRB, 0.55768581E-10_JPRB, 0.56466574E-10_JPRB, &
  & 0.57142784E-10_JPRB, 0.57717810E-10_JPRB, 0.58311571E-10_JPRB, 0.58965839E-10_JPRB, 0.59503444E-10_JPRB, 0.60044442E-10_JPRB, &
  & 0.60451241E-10_JPRB, 0.60974101E-10_JPRB, 0.61917020E-10_JPRB, 0.62288862E-10_JPRB, 0.62486342E-10_JPRB, 0.62623698E-10_JPRB, &
  & 0.63282608E-10_JPRB, 0.64200527E-10_JPRB, 0.65124003E-10_JPRB, 0.64700863E-10_JPRB /)

RGHG4(:,80, 4) = (/ &
  & 0.23584641E-10_JPRB, 0.24842071E-10_JPRB, 0.25517017E-10_JPRB, 0.25864385E-10_JPRB, 0.26702860E-10_JPRB, 0.21995057E-10_JPRB, &
  & 0.22925828E-10_JPRB, 0.23678295E-10_JPRB, 0.24015798E-10_JPRB, 0.24356971E-10_JPRB, 0.24720894E-10_JPRB, 0.25199721E-10_JPRB, &
  & 0.25686094E-10_JPRB, 0.26297999E-10_JPRB, 0.26938634E-10_JPRB, 0.27614780E-10_JPRB, 0.28336425E-10_JPRB, 0.29128904E-10_JPRB, &
  & 0.29960760E-10_JPRB, 0.30848220E-10_JPRB, 0.31785598E-10_JPRB, 0.32764090E-10_JPRB, 0.33776412E-10_JPRB, 0.34918780E-10_JPRB, &
  & 0.36030585E-10_JPRB, 0.37220334E-10_JPRB, 0.38352602E-10_JPRB, 0.39505673E-10_JPRB, 0.40645990E-10_JPRB, 0.41763034E-10_JPRB, &
  & 0.42849915E-10_JPRB, 0.43923611E-10_JPRB, 0.44974781E-10_JPRB, 0.46003732E-10_JPRB, 0.47076058E-10_JPRB, 0.48167383E-10_JPRB, &
  & 0.49107697E-10_JPRB, 0.50027718E-10_JPRB, 0.50934670E-10_JPRB, 0.51849591E-10_JPRB, 0.52776148E-10_JPRB, 0.53625493E-10_JPRB, &
  & 0.54317235E-10_JPRB, 0.55079063E-10_JPRB, 0.55815869E-10_JPRB, 0.56661221E-10_JPRB, 0.57540160E-10_JPRB, 0.58250710E-10_JPRB, &
  & 0.58928626E-10_JPRB, 0.59521998E-10_JPRB, 0.60132156E-10_JPRB, 0.60802537E-10_JPRB, 0.61370992E-10_JPRB, 0.61879106E-10_JPRB, &
  & 0.62251253E-10_JPRB, 0.62689527E-10_JPRB, 0.63535073E-10_JPRB, 0.63856004E-10_JPRB, 0.64044305E-10_JPRB, 0.64176879E-10_JPRB, &
  & 0.64857293E-10_JPRB, 0.65836316E-10_JPRB, 0.66977986E-10_JPRB, 0.67740237E-10_JPRB /)

RGHG4(:,81, 4) = (/ &
  & 0.25407005E-10_JPRB, 0.25573339E-10_JPRB, 0.26131170E-10_JPRB, 0.26484703E-10_JPRB, 0.27171897E-10_JPRB, 0.22336568E-10_JPRB, &
  & 0.23214028E-10_JPRB, 0.24022352E-10_JPRB, 0.24271319E-10_JPRB, 0.24674238E-10_JPRB, 0.25100562E-10_JPRB, 0.25487267E-10_JPRB, &
  & 0.26014087E-10_JPRB, 0.26675632E-10_JPRB, 0.27345732E-10_JPRB, 0.28074165E-10_JPRB, 0.28859904E-10_JPRB, 0.29700978E-10_JPRB, &
  & 0.30575396E-10_JPRB, 0.31504382E-10_JPRB, 0.32465600E-10_JPRB, 0.33458066E-10_JPRB, 0.34491385E-10_JPRB, 0.35554948E-10_JPRB, &
  & 0.36619270E-10_JPRB, 0.37756905E-10_JPRB, 0.38948521E-10_JPRB, 0.40119318E-10_JPRB, 0.41272742E-10_JPRB, 0.42412927E-10_JPRB, &
  & 0.43523914E-10_JPRB, 0.44622528E-10_JPRB, 0.45705061E-10_JPRB, 0.46797444E-10_JPRB, 0.47901273E-10_JPRB, 0.48918185E-10_JPRB, &
  & 0.49999668E-10_JPRB, 0.51077496E-10_JPRB, 0.52079271E-10_JPRB, 0.53048742E-10_JPRB, 0.53993882E-10_JPRB, 0.54855263E-10_JPRB, &
  & 0.55541741E-10_JPRB, 0.56294257E-10_JPRB, 0.56994683E-10_JPRB, 0.57784080E-10_JPRB, 0.58610901E-10_JPRB, 0.59273302E-10_JPRB, &
  & 0.59934245E-10_JPRB, 0.60482418E-10_JPRB, 0.61151605E-10_JPRB, 0.61748329E-10_JPRB, 0.62379046E-10_JPRB, 0.62911940E-10_JPRB, &
  & 0.63362510E-10_JPRB, 0.63839101E-10_JPRB, 0.64685840E-10_JPRB, 0.65018727E-10_JPRB, 0.65225152E-10_JPRB, 0.65367795E-10_JPRB, &
  & 0.66044600E-10_JPRB, 0.67036800E-10_JPRB, 0.68271264E-10_JPRB, 0.70068916E-10_JPRB /)

RGHG4(:,82, 4) = (/ &
  & 0.26485697E-10_JPRB, 0.25844035E-10_JPRB, 0.26315500E-10_JPRB, 0.26581229E-10_JPRB, 0.27194044E-10_JPRB, 0.22508325E-10_JPRB, &
  & 0.23391301E-10_JPRB, 0.24109308E-10_JPRB, 0.24606737E-10_JPRB, 0.24895733E-10_JPRB, 0.25353258E-10_JPRB, 0.25790810E-10_JPRB, &
  & 0.26366336E-10_JPRB, 0.26964871E-10_JPRB, 0.27636213E-10_JPRB, 0.28352889E-10_JPRB, 0.29121705E-10_JPRB, 0.29964763E-10_JPRB, &
  & 0.30845861E-10_JPRB, 0.31780068E-10_JPRB, 0.32736897E-10_JPRB, 0.33726529E-10_JPRB, 0.34813662E-10_JPRB, 0.35865737E-10_JPRB, &
  & 0.37063796E-10_JPRB, 0.38194829E-10_JPRB, 0.39350252E-10_JPRB, 0.40525871E-10_JPRB, 0.41691584E-10_JPRB, 0.42844648E-10_JPRB, &
  & 0.43973294E-10_JPRB, 0.45084447E-10_JPRB, 0.46184952E-10_JPRB, 0.47316009E-10_JPRB, 0.48434642E-10_JPRB, 0.49535678E-10_JPRB, &
  & 0.50643684E-10_JPRB, 0.51590926E-10_JPRB, 0.52550644E-10_JPRB, 0.53512660E-10_JPRB, 0.54437128E-10_JPRB, 0.55316328E-10_JPRB, &
  & 0.56001905E-10_JPRB, 0.56773464E-10_JPRB, 0.57503662E-10_JPRB, 0.58355591E-10_JPRB, 0.59242583E-10_JPRB, 0.59950010E-10_JPRB, &
  & 0.60651789E-10_JPRB, 0.61192801E-10_JPRB, 0.61896738E-10_JPRB, 0.62492254E-10_JPRB, 0.63134518E-10_JPRB, 0.63632322E-10_JPRB, &
  & 0.64033862E-10_JPRB, 0.64432730E-10_JPRB, 0.65195842E-10_JPRB, 0.65493784E-10_JPRB, 0.65676402E-10_JPRB, 0.65809698E-10_JPRB, &
  & 0.66448569E-10_JPRB, 0.67483283E-10_JPRB, 0.68704001E-10_JPRB, 0.71255911E-10_JPRB /)

RGHG4(:,83, 4) = (/ &
  & 0.26593273E-10_JPRB, 0.25966208E-10_JPRB, 0.26440166E-10_JPRB, 0.26706316E-10_JPRB, 0.27302750E-10_JPRB, 0.22720168E-10_JPRB, &
  & 0.23456863E-10_JPRB, 0.24428974E-10_JPRB, 0.24659700E-10_JPRB, 0.25179586E-10_JPRB, 0.25526265E-10_JPRB, 0.25989537E-10_JPRB, &
  & 0.26449081E-10_JPRB, 0.27139933E-10_JPRB, 0.27858209E-10_JPRB, 0.28609278E-10_JPRB, 0.29413662E-10_JPRB, 0.30263816E-10_JPRB, &
  & 0.31160418E-10_JPRB, 0.32092256E-10_JPRB, 0.33045219E-10_JPRB, 0.34092930E-10_JPRB, 0.35117440E-10_JPRB, 0.36193215E-10_JPRB, &
  & 0.37289997E-10_JPRB, 0.38442236E-10_JPRB, 0.39629057E-10_JPRB, 0.40823338E-10_JPRB, 0.42000198E-10_JPRB, 0.43166588E-10_JPRB, &
  & 0.44305875E-10_JPRB, 0.45427415E-10_JPRB, 0.46549677E-10_JPRB, 0.47709402E-10_JPRB, 0.48843030E-10_JPRB, 0.49928645E-10_JPRB, &
  & 0.51015261E-10_JPRB, 0.52044393E-10_JPRB, 0.53132890E-10_JPRB, 0.54091558E-10_JPRB, 0.55053701E-10_JPRB, 0.55923297E-10_JPRB, &
  & 0.56623876E-10_JPRB, 0.57405355E-10_JPRB, 0.58140524E-10_JPRB, 0.58968080E-10_JPRB, 0.59814445E-10_JPRB, 0.60469241E-10_JPRB, &
  & 0.61167342E-10_JPRB, 0.61717610E-10_JPRB, 0.62358632E-10_JPRB, 0.63003922E-10_JPRB, 0.63602741E-10_JPRB, 0.64185920E-10_JPRB, &
  & 0.64605488E-10_JPRB, 0.65065446E-10_JPRB, 0.65794356E-10_JPRB, 0.66093103E-10_JPRB, 0.66252219E-10_JPRB, 0.66398893E-10_JPRB, &
  & 0.66967210E-10_JPRB, 0.68003797E-10_JPRB, 0.69129064E-10_JPRB, 0.71262954E-10_JPRB /)

RGHG4(:,84, 4) = (/ &
  & 0.26604186E-10_JPRB, 0.26101512E-10_JPRB, 0.26469126E-10_JPRB, 0.26714426E-10_JPRB, 0.27357101E-10_JPRB, 0.22808885E-10_JPRB, &
  & 0.23570701E-10_JPRB, 0.24420375E-10_JPRB, 0.25017648E-10_JPRB, 0.25269014E-10_JPRB, 0.25770625E-10_JPRB, 0.26150804E-10_JPRB, &
  & 0.26762845E-10_JPRB, 0.27393645E-10_JPRB, 0.28014166E-10_JPRB, 0.28759469E-10_JPRB, 0.29554095E-10_JPRB, 0.30412010E-10_JPRB, &
  & 0.31309379E-10_JPRB, 0.32225275E-10_JPRB, 0.33204755E-10_JPRB, 0.34228582E-10_JPRB, 0.35266380E-10_JPRB, 0.36381145E-10_JPRB, &
  & 0.37531620E-10_JPRB, 0.38696751E-10_JPRB, 0.39863082E-10_JPRB, 0.41058365E-10_JPRB, 0.42245891E-10_JPRB, 0.43420576E-10_JPRB, &
  & 0.44573366E-10_JPRB, 0.45706213E-10_JPRB, 0.46847821E-10_JPRB, 0.48027294E-10_JPRB, 0.49174081E-10_JPRB, 0.50314766E-10_JPRB, &
  & 0.51431515E-10_JPRB, 0.52444018E-10_JPRB, 0.53431641E-10_JPRB, 0.54348331E-10_JPRB, 0.55297624E-10_JPRB, 0.56132633E-10_JPRB, &
  & 0.56855829E-10_JPRB, 0.57614951E-10_JPRB, 0.58378628E-10_JPRB, 0.59245713E-10_JPRB, 0.60172416E-10_JPRB, 0.60857416E-10_JPRB, &
  & 0.61557676E-10_JPRB, 0.62176778E-10_JPRB, 0.62783737E-10_JPRB, 0.63494023E-10_JPRB, 0.64052610E-10_JPRB, 0.64660784E-10_JPRB, &
  & 0.64992303E-10_JPRB, 0.65432347E-10_JPRB, 0.66081272E-10_JPRB, 0.66373303E-10_JPRB, 0.66475964E-10_JPRB, 0.66675464E-10_JPRB, &
  & 0.67173836E-10_JPRB, 0.68252286E-10_JPRB, 0.69399160E-10_JPRB, 0.71631027E-10_JPRB /)

RGHG4(:,85, 4) = (/ &
  & 0.26636145E-10_JPRB, 0.26208246E-10_JPRB, 0.26461083E-10_JPRB, 0.26771202E-10_JPRB, 0.27482320E-10_JPRB, 0.22882380E-10_JPRB, &
  & 0.23656764E-10_JPRB, 0.24741436E-10_JPRB, 0.25001196E-10_JPRB, 0.25550251E-10_JPRB, 0.25881354E-10_JPRB, 0.26336095E-10_JPRB, &
  & 0.26726231E-10_JPRB, 0.27354872E-10_JPRB, 0.28121727E-10_JPRB, 0.28896363E-10_JPRB, 0.29715064E-10_JPRB, 0.30588105E-10_JPRB, &
  & 0.31471100E-10_JPRB, 0.32401675E-10_JPRB, 0.33402538E-10_JPRB, 0.34395164E-10_JPRB, 0.35460718E-10_JPRB, 0.36535459E-10_JPRB, &
  & 0.37663629E-10_JPRB, 0.38821679E-10_JPRB, 0.40023297E-10_JPRB, 0.41233295E-10_JPRB, 0.42434119E-10_JPRB, 0.43622640E-10_JPRB, &
  & 0.44785915E-10_JPRB, 0.45931491E-10_JPRB, 0.47088732E-10_JPRB, 0.48292113E-10_JPRB, 0.49459787E-10_JPRB, 0.50614474E-10_JPRB, &
  & 0.51687491E-10_JPRB, 0.52750939E-10_JPRB, 0.53816666E-10_JPRB, 0.54761740E-10_JPRB, 0.55711918E-10_JPRB, 0.56528251E-10_JPRB, &
  & 0.57236500E-10_JPRB, 0.58031989E-10_JPRB, 0.58783416E-10_JPRB, 0.59660464E-10_JPRB, 0.60543758E-10_JPRB, 0.61237175E-10_JPRB, &
  & 0.61884622E-10_JPRB, 0.62507097E-10_JPRB, 0.63107276E-10_JPRB, 0.63809145E-10_JPRB, 0.64371487E-10_JPRB, 0.65013876E-10_JPRB, &
  & 0.65373595E-10_JPRB, 0.65862919E-10_JPRB, 0.66463515E-10_JPRB, 0.66798192E-10_JPRB, 0.66801682E-10_JPRB, 0.67054473E-10_JPRB, &
  & 0.67491540E-10_JPRB, 0.68545149E-10_JPRB, 0.69657252E-10_JPRB, 0.71834858E-10_JPRB /)

RGHG4(:,86, 4) = (/ &
  & 0.26631246E-10_JPRB, 0.26293476E-10_JPRB, 0.26422383E-10_JPRB, 0.26817559E-10_JPRB, 0.27504159E-10_JPRB, 0.22977457E-10_JPRB, &
  & 0.23745521E-10_JPRB, 0.24786629E-10_JPRB, 0.25346621E-10_JPRB, 0.25605155E-10_JPRB, 0.26114716E-10_JPRB, 0.26439030E-10_JPRB, &
  & 0.27062585E-10_JPRB, 0.27600536E-10_JPRB, 0.28203698E-10_JPRB, 0.28923402E-10_JPRB, 0.29752579E-10_JPRB, 0.30618758E-10_JPRB, &
  & 0.31532423E-10_JPRB, 0.32496453E-10_JPRB, 0.33451159E-10_JPRB, 0.34475162E-10_JPRB, 0.35541372E-10_JPRB, 0.36635053E-10_JPRB, &
  & 0.37792776E-10_JPRB, 0.38969550E-10_JPRB, 0.40161898E-10_JPRB, 0.41384601E-10_JPRB, 0.42594008E-10_JPRB, 0.43790423E-10_JPRB, &
  & 0.44964133E-10_JPRB, 0.46119126E-10_JPRB, 0.47292153E-10_JPRB, 0.48494413E-10_JPRB, 0.49694950E-10_JPRB, 0.50856798E-10_JPRB, &
  & 0.51997802E-10_JPRB, 0.53093436E-10_JPRB, 0.54060281E-10_JPRB, 0.55018864E-10_JPRB, 0.55915963E-10_JPRB, 0.56725662E-10_JPRB, &
  & 0.57415454E-10_JPRB, 0.58198807E-10_JPRB, 0.58967040E-10_JPRB, 0.59834783E-10_JPRB, 0.60735771E-10_JPRB, 0.61468886E-10_JPRB, &
  & 0.62158584E-10_JPRB, 0.62780579E-10_JPRB, 0.63417799E-10_JPRB, 0.64112264E-10_JPRB, 0.64699753E-10_JPRB, 0.65318050E-10_JPRB, &
  & 0.65648292E-10_JPRB, 0.66120075E-10_JPRB, 0.66655056E-10_JPRB, 0.67015532E-10_JPRB, 0.66976188E-10_JPRB, 0.67227612E-10_JPRB, &
  & 0.67685559E-10_JPRB, 0.68728953E-10_JPRB, 0.69855843E-10_JPRB, 0.72039340E-10_JPRB /)

RGHG4(:,87, 4) = (/ &
  & 0.26647573E-10_JPRB, 0.26368978E-10_JPRB, 0.26383173E-10_JPRB, 0.26890691E-10_JPRB, 0.27595775E-10_JPRB, 0.22893791E-10_JPRB, &
  & 0.23956092E-10_JPRB, 0.25025055E-10_JPRB, 0.25320286E-10_JPRB, 0.25896205E-10_JPRB, 0.26211639E-10_JPRB, 0.26612974E-10_JPRB, &
  & 0.26883662E-10_JPRB, 0.27495273E-10_JPRB, 0.28161549E-10_JPRB, 0.28974734E-10_JPRB, 0.29771085E-10_JPRB, 0.30688493E-10_JPRB, &
  & 0.31616518E-10_JPRB, 0.32559951E-10_JPRB, 0.33549732E-10_JPRB, 0.34582819E-10_JPRB, 0.35630953E-10_JPRB, 0.36725858E-10_JPRB, &
  & 0.37867563E-10_JPRB, 0.39047765E-10_JPRB, 0.40259938E-10_JPRB, 0.41485201E-10_JPRB, 0.42711317E-10_JPRB, 0.43923611E-10_JPRB, &
  & 0.45100267E-10_JPRB, 0.46263611E-10_JPRB, 0.47439608E-10_JPRB, 0.48660728E-10_JPRB, 0.49858333E-10_JPRB, 0.51045824E-10_JPRB, &
  & 0.52185232E-10_JPRB, 0.53298775E-10_JPRB, 0.54344543E-10_JPRB, 0.55330171E-10_JPRB, 0.56238257E-10_JPRB, 0.57104346E-10_JPRB, &
  & 0.57751387E-10_JPRB, 0.58525934E-10_JPRB, 0.59288734E-10_JPRB, 0.60173720E-10_JPRB, 0.61023242E-10_JPRB, 0.61716819E-10_JPRB, &
  & 0.62392445E-10_JPRB, 0.62990897E-10_JPRB, 0.63640850E-10_JPRB, 0.64316497E-10_JPRB, 0.64921887E-10_JPRB, 0.65537999E-10_JPRB, &
  & 0.65913677E-10_JPRB, 0.66390678E-10_JPRB, 0.66934701E-10_JPRB, 0.67253321E-10_JPRB, 0.67246653E-10_JPRB, 0.67430193E-10_JPRB, &
  & 0.67911538E-10_JPRB, 0.68921036E-10_JPRB, 0.70030176E-10_JPRB, 0.72194778E-10_JPRB /)

RGHG4(:,88, 4) = (/ &
  & 0.26622662E-10_JPRB, 0.26438353E-10_JPRB, 0.26337739E-10_JPRB, 0.26945082E-10_JPRB, 0.27487347E-10_JPRB, 0.22939086E-10_JPRB, &
  & 0.24073514E-10_JPRB, 0.24879146E-10_JPRB, 0.25554864E-10_JPRB, 0.25890123E-10_JPRB, 0.26300203E-10_JPRB, 0.26740587E-10_JPRB, &
  & 0.27249222E-10_JPRB, 0.27733036E-10_JPRB, 0.28272480E-10_JPRB, 0.28969563E-10_JPRB, 0.29745335E-10_JPRB, 0.30724416E-10_JPRB, &
  & 0.31604212E-10_JPRB, 0.32614366E-10_JPRB, 0.33580611E-10_JPRB, 0.34623842E-10_JPRB, 0.35673672E-10_JPRB, 0.36783125E-10_JPRB, &
  & 0.37938125E-10_JPRB, 0.39126823E-10_JPRB, 0.40343884E-10_JPRB, 0.41593798E-10_JPRB, 0.42819005E-10_JPRB, 0.44034432E-10_JPRB, &
  & 0.45225185E-10_JPRB, 0.46401914E-10_JPRB, 0.47586154E-10_JPRB, 0.48808211E-10_JPRB, 0.50019579E-10_JPRB, 0.51228469E-10_JPRB, &
  & 0.52408293E-10_JPRB, 0.53523297E-10_JPRB, 0.54593104E-10_JPRB, 0.55580280E-10_JPRB, 0.56503965E-10_JPRB, 0.57313539E-10_JPRB, &
  & 0.58041766E-10_JPRB, 0.58777178E-10_JPRB, 0.59466716E-10_JPRB, 0.60332642E-10_JPRB, 0.61171075E-10_JPRB, 0.61855479E-10_JPRB, &
  & 0.62569436E-10_JPRB, 0.63174958E-10_JPRB, 0.63841106E-10_JPRB, 0.64515789E-10_JPRB, 0.65139498E-10_JPRB, 0.65735091E-10_JPRB, &
  & 0.66113753E-10_JPRB, 0.66546345E-10_JPRB, 0.67110338E-10_JPRB, 0.67368090E-10_JPRB, 0.67395249E-10_JPRB, 0.67545178E-10_JPRB, &
  & 0.68036618E-10_JPRB, 0.69046394E-10_JPRB, 0.70171084E-10_JPRB, 0.72308257E-10_JPRB /)

RGHG4(:,89, 4) = (/ &
  & 0.26606665E-10_JPRB, 0.26524501E-10_JPRB, 0.26285144E-10_JPRB, 0.26952584E-10_JPRB, 0.27417605E-10_JPRB, 0.22687286E-10_JPRB, &
  & 0.24024102E-10_JPRB, 0.24866730E-10_JPRB, 0.25497040E-10_JPRB, 0.25916606E-10_JPRB, 0.26234494E-10_JPRB, 0.26474116E-10_JPRB, &
  & 0.27008418E-10_JPRB, 0.27391081E-10_JPRB, 0.28169526E-10_JPRB, 0.29131569E-10_JPRB, 0.29962484E-10_JPRB, 0.30781246E-10_JPRB, &
  & 0.31661614E-10_JPRB, 0.32653220E-10_JPRB, 0.33612519E-10_JPRB, 0.34654477E-10_JPRB, 0.35697674E-10_JPRB, 0.36803845E-10_JPRB, &
  & 0.37953578E-10_JPRB, 0.39154166E-10_JPRB, 0.40384470E-10_JPRB, 0.41627340E-10_JPRB, 0.42872369E-10_JPRB, 0.44111485E-10_JPRB, &
  & 0.45313062E-10_JPRB, 0.46498704E-10_JPRB, 0.47706658E-10_JPRB, 0.48947731E-10_JPRB, 0.50190862E-10_JPRB, 0.51423959E-10_JPRB, &
  & 0.52615596E-10_JPRB, 0.53765572E-10_JPRB, 0.54843616E-10_JPRB, 0.55858988E-10_JPRB, 0.56828688E-10_JPRB, 0.57656758E-10_JPRB, &
  & 0.58317330E-10_JPRB, 0.59083932E-10_JPRB, 0.59750420E-10_JPRB, 0.60560487E-10_JPRB, 0.61401016E-10_JPRB, 0.62038541E-10_JPRB, &
  & 0.62719691E-10_JPRB, 0.63319294E-10_JPRB, 0.63987766E-10_JPRB, 0.64659236E-10_JPRB, 0.65291376E-10_JPRB, 0.65890231E-10_JPRB, &
  & 0.66289113E-10_JPRB, 0.66720372E-10_JPRB, 0.67291839E-10_JPRB, 0.67539092E-10_JPRB, 0.67551111E-10_JPRB, 0.67686891E-10_JPRB, &
  & 0.68178990E-10_JPRB, 0.69150560E-10_JPRB, 0.70310494E-10_JPRB, 0.72392758E-10_JPRB /)

RGHG4(:,90, 4) = (/ &
  & 0.26545566E-10_JPRB, 0.26607513E-10_JPRB, 0.26262163E-10_JPRB, 0.26853249E-10_JPRB, 0.27156295E-10_JPRB, 0.22354878E-10_JPRB, &
  & 0.23729553E-10_JPRB, 0.24638168E-10_JPRB, 0.25595481E-10_JPRB, 0.25953052E-10_JPRB, 0.26216248E-10_JPRB, 0.26625636E-10_JPRB, &
  & 0.27577643E-10_JPRB, 0.27901761E-10_JPRB, 0.28487997E-10_JPRB, 0.28890407E-10_JPRB, 0.29498817E-10_JPRB, 0.30601219E-10_JPRB, &
  & 0.31577203E-10_JPRB, 0.32621281E-10_JPRB, 0.33586561E-10_JPRB, 0.34617986E-10_JPRB, 0.35664850E-10_JPRB, 0.36762666E-10_JPRB, &
  & 0.37910272E-10_JPRB, 0.39112359E-10_JPRB, 0.40347562E-10_JPRB, 0.41624315E-10_JPRB, 0.42907924E-10_JPRB, 0.44168218E-10_JPRB, &
  & 0.45405658E-10_JPRB, 0.46626789E-10_JPRB, 0.47873854E-10_JPRB, 0.49136195E-10_JPRB, 0.50417105E-10_JPRB, 0.51691020E-10_JPRB, &
  & 0.52909992E-10_JPRB, 0.54069558E-10_JPRB, 0.55163558E-10_JPRB, 0.56177455E-10_JPRB, 0.57128097E-10_JPRB, 0.57933530E-10_JPRB, &
  & 0.58603310E-10_JPRB, 0.59281698E-10_JPRB, 0.59918258E-10_JPRB, 0.60669435E-10_JPRB, 0.61481320E-10_JPRB, 0.62141473E-10_JPRB, &
  & 0.62835473E-10_JPRB, 0.63440822E-10_JPRB, 0.64118912E-10_JPRB, 0.64795266E-10_JPRB, 0.65435213E-10_JPRB, 0.66027905E-10_JPRB, &
  & 0.66421577E-10_JPRB, 0.66852079E-10_JPRB, 0.67401890E-10_JPRB, 0.67646076E-10_JPRB, 0.67653230E-10_JPRB, 0.67752338E-10_JPRB, &
  & 0.68299720E-10_JPRB, 0.69203906E-10_JPRB, 0.70455509E-10_JPRB, 0.72456409E-10_JPRB /)

RGHG4(:,91, 4) = (/ &
  & 0.26555310E-10_JPRB, 0.26622473E-10_JPRB, 0.26287994E-10_JPRB, 0.26554897E-10_JPRB, 0.26918363E-10_JPRB, 0.19139293E-10_JPRB, &
  & 0.19245439E-10_JPRB, 0.14092546E-10_JPRB, 0.35033615E-10_JPRB, 0.33048213E-10_JPRB, 0.23854569E-10_JPRB, 0.20976006E-10_JPRB, &
  & 0.29563706E-10_JPRB, 0.26525906E-10_JPRB, 0.28725043E-10_JPRB, 0.29008034E-10_JPRB, 0.30346638E-10_JPRB, 0.30993284E-10_JPRB, &
  & 0.31802252E-10_JPRB, 0.32596224E-10_JPRB, 0.33515316E-10_JPRB, 0.34510794E-10_JPRB, 0.35551066E-10_JPRB, 0.36663811E-10_JPRB, &
  & 0.37847610E-10_JPRB, 0.39019180E-10_JPRB, 0.40304111E-10_JPRB, 0.41611867E-10_JPRB, 0.42895590E-10_JPRB, 0.44197684E-10_JPRB, &
  & 0.45468296E-10_JPRB, 0.46716818E-10_JPRB, 0.48025497E-10_JPRB, 0.49325044E-10_JPRB, 0.50678423E-10_JPRB, 0.52024697E-10_JPRB, &
  & 0.53259789E-10_JPRB, 0.54455839E-10_JPRB, 0.55570964E-10_JPRB, 0.56603992E-10_JPRB, 0.55115038E-10_JPRB, 0.55923013E-10_JPRB, &
  & 0.58933074E-10_JPRB, 0.59564721E-10_JPRB, 0.60146679E-10_JPRB, 0.60869185E-10_JPRB, 0.61661912E-10_JPRB, 0.62273180E-10_JPRB, &
  & 0.62938897E-10_JPRB, 0.63550547E-10_JPRB, 0.64233036E-10_JPRB, 0.64909959E-10_JPRB, 0.65558725E-10_JPRB, 0.66151751E-10_JPRB, &
  & 0.66538504E-10_JPRB, 0.67001189E-10_JPRB, 0.67536352E-10_JPRB, 0.67758014E-10_JPRB, 0.67762268E-10_JPRB, 0.67819896E-10_JPRB, &
  & 0.68435743E-10_JPRB, 0.69240169E-10_JPRB, 0.70658084E-10_JPRB, 0.72500020E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG4(:, 1, 5) = (/ &
  & 0.96736452E-09_JPRB, 0.96559838E-09_JPRB, 0.96360064E-09_JPRB, 0.96296870E-09_JPRB, 0.96213448E-09_JPRB, 0.96050556E-09_JPRB, &
  & 0.95793284E-09_JPRB, 0.98722908E-09_JPRB, 0.73972973E-13_JPRB, 0.68312177E-13_JPRB, 0.74252392E-13_JPRB, 0.82240170E-13_JPRB, &
  & 0.90503661E-13_JPRB, 0.92384664E-13_JPRB, 0.99307688E-13_JPRB, 0.99565118E-13_JPRB, 0.99622547E-13_JPRB, 0.10432353E-12_JPRB, &
  & 0.10328807E-12_JPRB, 0.10274294E-12_JPRB, 0.10913081E-12_JPRB, 0.10554989E-12_JPRB, 0.10421172E-12_JPRB, 0.10357023E-12_JPRB, &
  & 0.10331459E-12_JPRB, 0.10369095E-12_JPRB, 0.10943220E-12_JPRB, 0.11049974E-12_JPRB, 0.11288720E-12_JPRB, 0.11597975E-12_JPRB, &
  & 0.11915859E-12_JPRB, 0.12191436E-12_JPRB, 0.12908489E-12_JPRB, 0.12782361E-12_JPRB, 0.12590830E-12_JPRB, 0.12298223E-12_JPRB, &
  & 0.11951070E-12_JPRB, 0.11585345E-12_JPRB, 0.11921977E-12_JPRB, 0.11376596E-12_JPRB, 0.11060921E-12_JPRB, 0.10882456E-12_JPRB, &
  & 0.10688806E-12_JPRB, 0.10590326E-12_JPRB, 0.10799268E-12_JPRB, 0.10580366E-12_JPRB, 0.10402972E-12_JPRB, 0.10241444E-12_JPRB, &
  & 0.10350414E-12_JPRB, 0.10105502E-12_JPRB, 0.10282783E-12_JPRB, 0.99705251E-13_JPRB, 0.10155887E-12_JPRB, 0.10112875E-12_JPRB, &
  & 0.10903874E-12_JPRB, 0.13227586E-12_JPRB, 0.14253172E-12_JPRB, 0.13513363E-12_JPRB, 0.12890306E-12_JPRB, 0.12201201E-12_JPRB, &
  & 0.11523162E-12_JPRB, 0.10825543E-12_JPRB, 0.10174554E-12_JPRB, 0.95422002E-13_JPRB /)

RGHG4(:, 2, 5) = (/ &
  & 0.10069825E-19_JPRB, 0.10071987E-19_JPRB, 0.10075805E-19_JPRB, 0.10080781E-19_JPRB, 0.10086320E-19_JPRB, 0.10091746E-19_JPRB, &
  & 0.10096530E-19_JPRB, 0.11560864E-08_JPRB, 0.27403812E-12_JPRB, 0.28613030E-12_JPRB, 0.29554714E-12_JPRB, 0.30574604E-12_JPRB, &
  & 0.31723045E-12_JPRB, 0.32979717E-12_JPRB, 0.34992338E-12_JPRB, 0.38041421E-12_JPRB, 0.41186949E-12_JPRB, 0.44692901E-12_JPRB, &
  & 0.48202680E-12_JPRB, 0.51903181E-12_JPRB, 0.54477565E-12_JPRB, 0.56491536E-12_JPRB, 0.58087319E-12_JPRB, 0.59582921E-12_JPRB, &
  & 0.61661527E-12_JPRB, 0.65340501E-12_JPRB, 0.68985432E-12_JPRB, 0.73748337E-12_JPRB, 0.79600362E-12_JPRB, 0.86381022E-12_JPRB, &
  & 0.94192894E-12_JPRB, 0.10385516E-11_JPRB, 0.10940718E-11_JPRB, 0.11356823E-11_JPRB, 0.11557472E-11_JPRB, 0.11544910E-11_JPRB, &
  & 0.11353115E-11_JPRB, 0.10989774E-11_JPRB, 0.10732384E-11_JPRB, 0.10266509E-11_JPRB, 0.97227651E-12_JPRB, 0.91991421E-12_JPRB, &
  & 0.85925895E-12_JPRB, 0.80374005E-12_JPRB, 0.73836418E-12_JPRB, 0.66656251E-12_JPRB, 0.59556434E-12_JPRB, 0.52931075E-12_JPRB, &
  & 0.47578814E-12_JPRB, 0.42639194E-12_JPRB, 0.38970376E-12_JPRB, 0.36707231E-12_JPRB, 0.34619383E-12_JPRB, 0.33519528E-12_JPRB, &
  & 0.33020326E-12_JPRB, 0.32162635E-12_JPRB, 0.26442878E-12_JPRB, 0.24227766E-12_JPRB, 0.23062655E-12_JPRB, 0.22157883E-12_JPRB, &
  & 0.21672582E-12_JPRB, 0.21187780E-12_JPRB, 0.20582813E-12_JPRB, 0.19246462E-12_JPRB /)

RGHG4(:, 3, 5) = (/ &
  & 0.55891964E-20_JPRB, 0.55908661E-20_JPRB, 0.55934894E-20_JPRB, 0.55966822E-20_JPRB, 0.55998399E-20_JPRB, 0.69477597E-10_JPRB, &
  & 0.38783163E-09_JPRB, 0.10909874E-08_JPRB, 0.42988486E-12_JPRB, 0.44994149E-12_JPRB, 0.48074598E-12_JPRB, 0.52850102E-12_JPRB, &
  & 0.59027555E-12_JPRB, 0.65608364E-12_JPRB, 0.72405797E-12_JPRB, 0.80068130E-12_JPRB, 0.87557701E-12_JPRB, 0.95461594E-12_JPRB, &
  & 0.10332492E-11_JPRB, 0.11172723E-11_JPRB, 0.11835833E-11_JPRB, 0.12425023E-11_JPRB, 0.12914750E-11_JPRB, 0.13365028E-11_JPRB, &
  & 0.13837910E-11_JPRB, 0.14540376E-11_JPRB, 0.15268532E-11_JPRB, 0.16124869E-11_JPRB, 0.17108361E-11_JPRB, 0.18246470E-11_JPRB, &
  & 0.19456444E-11_JPRB, 0.20858953E-11_JPRB, 0.21657693E-11_JPRB, 0.22247419E-11_JPRB, 0.22510500E-11_JPRB, 0.22457405E-11_JPRB, &
  & 0.22272332E-11_JPRB, 0.21834121E-11_JPRB, 0.21528155E-11_JPRB, 0.20883119E-11_JPRB, 0.19981369E-11_JPRB, 0.18993388E-11_JPRB, &
  & 0.17848695E-11_JPRB, 0.16798754E-11_JPRB, 0.15652694E-11_JPRB, 0.14390521E-11_JPRB, 0.13055544E-11_JPRB, 0.11755767E-11_JPRB, &
  & 0.10674936E-11_JPRB, 0.97377369E-12_JPRB, 0.90491704E-12_JPRB, 0.86215795E-12_JPRB, 0.83142185E-12_JPRB, 0.81962323E-12_JPRB, &
  & 0.81584191E-12_JPRB, 0.80976171E-12_JPRB, 0.72762488E-12_JPRB, 0.72771037E-12_JPRB, 0.73694295E-12_JPRB, 0.74556306E-12_JPRB, &
  & 0.75502197E-12_JPRB, 0.76312882E-12_JPRB, 0.76490105E-12_JPRB, 0.73303321E-12_JPRB /)

RGHG4(:, 4, 5) = (/ &
  & 0.32364047E-20_JPRB, 0.32375181E-20_JPRB, 0.32392867E-20_JPRB, 0.77326021E-10_JPRB, 0.25465308E-09_JPRB, 0.42017112E-09_JPRB, &
  & 0.63008282E-09_JPRB, 0.10665286E-08_JPRB, 0.84402141E-12_JPRB, 0.91722593E-12_JPRB, 0.10236454E-11_JPRB, 0.11541694E-11_JPRB, &
  & 0.13115349E-11_JPRB, 0.14913555E-11_JPRB, 0.16824324E-11_JPRB, 0.18783657E-11_JPRB, 0.20591395E-11_JPRB, 0.22468852E-11_JPRB, &
  & 0.24488872E-11_JPRB, 0.26743317E-11_JPRB, 0.28751355E-11_JPRB, 0.30549395E-11_JPRB, 0.32070336E-11_JPRB, 0.33419168E-11_JPRB, &
  & 0.34615097E-11_JPRB, 0.36016784E-11_JPRB, 0.37402139E-11_JPRB, 0.38890432E-11_JPRB, 0.40430190E-11_JPRB, 0.42043946E-11_JPRB, &
  & 0.43475254E-11_JPRB, 0.44934503E-11_JPRB, 0.45420512E-11_JPRB, 0.45705661E-11_JPRB, 0.45752881E-11_JPRB, 0.45561293E-11_JPRB, &
  & 0.45362069E-11_JPRB, 0.44897671E-11_JPRB, 0.44614304E-11_JPRB, 0.43931000E-11_JPRB, 0.42877524E-11_JPRB, 0.41620262E-11_JPRB, &
  & 0.39942403E-11_JPRB, 0.38248567E-11_JPRB, 0.36233822E-11_JPRB, 0.33963206E-11_JPRB, 0.31698132E-11_JPRB, 0.29771461E-11_JPRB, &
  & 0.28217459E-11_JPRB, 0.26840878E-11_JPRB, 0.25748420E-11_JPRB, 0.24976525E-11_JPRB, 0.24329057E-11_JPRB, 0.23896848E-11_JPRB, &
  & 0.23637221E-11_JPRB, 0.23440670E-11_JPRB, 0.22266115E-11_JPRB, 0.22037025E-11_JPRB, 0.22012234E-11_JPRB, 0.22114264E-11_JPRB, &
  & 0.22369780E-11_JPRB, 0.22771101E-11_JPRB, 0.23143278E-11_JPRB, 0.23073739E-11_JPRB /)

RGHG4(:, 5, 5) = (/ &
  & 0.14987116E-10_JPRB, 0.23710206E-09_JPRB, 0.38016146E-09_JPRB, 0.51068844E-09_JPRB, 0.67144795E-09_JPRB, 0.85419005E-09_JPRB, &
  & 0.11170810E-08_JPRB, 0.13963709E-08_JPRB, 0.21334189E-11_JPRB, 0.22635296E-11_JPRB, 0.25244477E-11_JPRB, 0.28560795E-11_JPRB, &
  & 0.32439999E-11_JPRB, 0.36781177E-11_JPRB, 0.41757912E-11_JPRB, 0.47743294E-11_JPRB, 0.54157928E-11_JPRB, 0.60185047E-11_JPRB, &
  & 0.65523103E-11_JPRB, 0.70904476E-11_JPRB, 0.76286616E-11_JPRB, 0.81849388E-11_JPRB, 0.87116659E-11_JPRB, 0.92025493E-11_JPRB, &
  & 0.96342257E-11_JPRB, 0.10055854E-10_JPRB, 0.10428487E-10_JPRB, 0.10753340E-10_JPRB, 0.10999692E-10_JPRB, 0.11168404E-10_JPRB, &
  & 0.11229028E-10_JPRB, 0.11252207E-10_JPRB, 0.11142334E-10_JPRB, 0.11059013E-10_JPRB, 0.10977780E-10_JPRB, 0.10887185E-10_JPRB, &
  & 0.10829102E-10_JPRB, 0.10777346E-10_JPRB, 0.10776098E-10_JPRB, 0.10731193E-10_JPRB, 0.10634583E-10_JPRB, 0.10494483E-10_JPRB, &
  & 0.10271791E-10_JPRB, 0.10034567E-10_JPRB, 0.97343305E-11_JPRB, 0.93848609E-11_JPRB, 0.90200764E-11_JPRB, 0.86849347E-11_JPRB, &
  & 0.83679765E-11_JPRB, 0.80660201E-11_JPRB, 0.77912520E-11_JPRB, 0.75445206E-11_JPRB, 0.73097474E-11_JPRB, 0.70958725E-11_JPRB, &
  & 0.69029556E-11_JPRB, 0.67284333E-11_JPRB, 0.65096266E-11_JPRB, 0.64420544E-11_JPRB, 0.64199483E-11_JPRB, 0.64718370E-11_JPRB, &
  & 0.65765128E-11_JPRB, 0.67836479E-11_JPRB, 0.69624445E-11_JPRB, 0.70518829E-11_JPRB /)

RGHG4(:, 6, 5) = (/ &
  & 0.52206889E-09_JPRB, 0.69889633E-09_JPRB, 0.81988594E-09_JPRB, 0.95370711E-09_JPRB, 0.11240593E-08_JPRB, 0.13285388E-08_JPRB, &
  & 0.15905816E-08_JPRB, 0.19011670E-08_JPRB, 0.67194956E-11_JPRB, 0.66161790E-11_JPRB, 0.72156552E-11_JPRB, 0.80490068E-11_JPRB, &
  & 0.90453678E-11_JPRB, 0.10207548E-10_JPRB, 0.11460669E-10_JPRB, 0.12705078E-10_JPRB, 0.14027764E-10_JPRB, 0.15541823E-10_JPRB, &
  & 0.17134658E-10_JPRB, 0.18625752E-10_JPRB, 0.19980257E-10_JPRB, 0.21333161E-10_JPRB, 0.22675627E-10_JPRB, 0.23991292E-10_JPRB, &
  & 0.25211127E-10_JPRB, 0.26313745E-10_JPRB, 0.27264444E-10_JPRB, 0.28020981E-10_JPRB, 0.28508949E-10_JPRB, 0.28707614E-10_JPRB, &
  & 0.28649482E-10_JPRB, 0.28401188E-10_JPRB, 0.27852087E-10_JPRB, 0.27373754E-10_JPRB, 0.26986628E-10_JPRB, 0.26749995E-10_JPRB, &
  & 0.26680960E-10_JPRB, 0.26711017E-10_JPRB, 0.26811147E-10_JPRB, 0.26853731E-10_JPRB, 0.26863378E-10_JPRB, 0.26809841E-10_JPRB, &
  & 0.26636420E-10_JPRB, 0.26385409E-10_JPRB, 0.25982650E-10_JPRB, 0.25513173E-10_JPRB, 0.25000705E-10_JPRB, 0.24484952E-10_JPRB, &
  & 0.23912134E-10_JPRB, 0.23332799E-10_JPRB, 0.22727766E-10_JPRB, 0.22074531E-10_JPRB, 0.21398777E-10_JPRB, 0.20691268E-10_JPRB, &
  & 0.19981964E-10_JPRB, 0.19294292E-10_JPRB, 0.18624560E-10_JPRB, 0.18462001E-10_JPRB, 0.18479945E-10_JPRB, 0.18670926E-10_JPRB, &
  & 0.18976416E-10_JPRB, 0.19540567E-10_JPRB, 0.19963840E-10_JPRB, 0.19646122E-10_JPRB /)

RGHG4(:, 7, 5) = (/ &
  & 0.87557145E-09_JPRB, 0.10688319E-08_JPRB, 0.12518623E-08_JPRB, 0.14649670E-08_JPRB, 0.17233053E-08_JPRB, 0.20319930E-08_JPRB, &
  & 0.24207345E-08_JPRB, 0.28847409E-08_JPRB, 0.26132417E-10_JPRB, 0.23634492E-10_JPRB, 0.24183619E-10_JPRB, 0.25748216E-10_JPRB, &
  & 0.27640027E-10_JPRB, 0.29831609E-10_JPRB, 0.32373236E-10_JPRB, 0.35104985E-10_JPRB, 0.37854889E-10_JPRB, 0.40541532E-10_JPRB, &
  & 0.43362265E-10_JPRB, 0.46364541E-10_JPRB, 0.49416731E-10_JPRB, 0.52544677E-10_JPRB, 0.55798959E-10_JPRB, 0.59246191E-10_JPRB, &
  & 0.62764842E-10_JPRB, 0.65923191E-10_JPRB, 0.68635236E-10_JPRB, 0.70742655E-10_JPRB, 0.72156607E-10_JPRB, 0.72734943E-10_JPRB, &
  & 0.72667455E-10_JPRB, 0.71935354E-10_JPRB, 0.70638564E-10_JPRB, 0.69592339E-10_JPRB, 0.68752587E-10_JPRB, 0.68267170E-10_JPRB, &
  & 0.68086398E-10_JPRB, 0.68234876E-10_JPRB, 0.68485766E-10_JPRB, 0.68714909E-10_JPRB, 0.69016001E-10_JPRB, 0.69203664E-10_JPRB, &
  & 0.69263782E-10_JPRB, 0.69105728E-10_JPRB, 0.68648053E-10_JPRB, 0.68144324E-10_JPRB, 0.67485961E-10_JPRB, 0.66630028E-10_JPRB, &
  & 0.65448279E-10_JPRB, 0.64184623E-10_JPRB, 0.62740049E-10_JPRB, 0.61040541E-10_JPRB, 0.59298413E-10_JPRB, 0.57428919E-10_JPRB, &
  & 0.55646533E-10_JPRB, 0.54031127E-10_JPRB, 0.52582969E-10_JPRB, 0.52865917E-10_JPRB, 0.53415095E-10_JPRB, 0.54582949E-10_JPRB, &
  & 0.56137220E-10_JPRB, 0.58227541E-10_JPRB, 0.60309521E-10_JPRB, 0.60505330E-10_JPRB /)

RGHG4(:, 8, 5) = (/ &
  & 0.11473874E-08_JPRB, 0.15546315E-08_JPRB, 0.18861714E-08_JPRB, 0.22311830E-08_JPRB, 0.26233666E-08_JPRB, 0.30979168E-08_JPRB, &
  & 0.36815679E-08_JPRB, 0.44109862E-08_JPRB, 0.93695308E-10_JPRB, 0.89533478E-10_JPRB, 0.87919255E-10_JPRB, 0.88510796E-10_JPRB, &
  & 0.90045194E-10_JPRB, 0.92555422E-10_JPRB, 0.95885667E-10_JPRB, 0.99370463E-10_JPRB, 0.10330928E-09_JPRB, 0.10802800E-09_JPRB, &
  & 0.11329876E-09_JPRB, 0.11862213E-09_JPRB, 0.12457292E-09_JPRB, 0.13187162E-09_JPRB, 0.13973762E-09_JPRB, 0.14786644E-09_JPRB, &
  & 0.15622546E-09_JPRB, 0.16354204E-09_JPRB, 0.16964079E-09_JPRB, 0.17446053E-09_JPRB, 0.17802938E-09_JPRB, 0.17979343E-09_JPRB, &
  & 0.18044945E-09_JPRB, 0.17952810E-09_JPRB, 0.17732868E-09_JPRB, 0.17565766E-09_JPRB, 0.17422055E-09_JPRB, 0.17341893E-09_JPRB, &
  & 0.17298288E-09_JPRB, 0.17329962E-09_JPRB, 0.17341999E-09_JPRB, 0.17345554E-09_JPRB, 0.17389723E-09_JPRB, 0.17422368E-09_JPRB, &
  & 0.17454273E-09_JPRB, 0.17426484E-09_JPRB, 0.17341246E-09_JPRB, 0.17280666E-09_JPRB, 0.17200967E-09_JPRB, 0.17064195E-09_JPRB, &
  & 0.16840165E-09_JPRB, 0.16624190E-09_JPRB, 0.16368157E-09_JPRB, 0.16042220E-09_JPRB, 0.15726105E-09_JPRB, 0.15379746E-09_JPRB, &
  & 0.15032915E-09_JPRB, 0.14697567E-09_JPRB, 0.14400298E-09_JPRB, 0.14592728E-09_JPRB, 0.14917596E-09_JPRB, 0.15355225E-09_JPRB, &
  & 0.15907101E-09_JPRB, 0.16654604E-09_JPRB, 0.17386501E-09_JPRB, 0.17200481E-09_JPRB /)

RGHG4(:, 9, 5) = (/ &
  & 0.16188724E-08_JPRB, 0.22697770E-08_JPRB, 0.27267872E-08_JPRB, 0.32018297E-08_JPRB, 0.37432186E-08_JPRB, 0.44230859E-08_JPRB, &
  & 0.53408491E-08_JPRB, 0.65375652E-08_JPRB, 0.26015445E-09_JPRB, 0.27605943E-09_JPRB, 0.28555033E-09_JPRB, 0.28872785E-09_JPRB, &
  & 0.28803690E-09_JPRB, 0.28717406E-09_JPRB, 0.28782318E-09_JPRB, 0.28912014E-09_JPRB, 0.29094807E-09_JPRB, 0.29469727E-09_JPRB, &
  & 0.30075667E-09_JPRB, 0.30839739E-09_JPRB, 0.31710423E-09_JPRB, 0.32839551E-09_JPRB, 0.34231779E-09_JPRB, 0.35855519E-09_JPRB, &
  & 0.37514147E-09_JPRB, 0.38853429E-09_JPRB, 0.39895870E-09_JPRB, 0.40794709E-09_JPRB, 0.41506823E-09_JPRB, 0.41906054E-09_JPRB, &
  & 0.42187051E-09_JPRB, 0.42142750E-09_JPRB, 0.41843531E-09_JPRB, 0.41666304E-09_JPRB, 0.41490292E-09_JPRB, 0.41360210E-09_JPRB, &
  & 0.41213011E-09_JPRB, 0.41185175E-09_JPRB, 0.41034295E-09_JPRB, 0.40851417E-09_JPRB, 0.40791920E-09_JPRB, 0.40731429E-09_JPRB, &
  & 0.40686585E-09_JPRB, 0.40521483E-09_JPRB, 0.40254680E-09_JPRB, 0.40104239E-09_JPRB, 0.39947681E-09_JPRB, 0.39701059E-09_JPRB, &
  & 0.39315751E-09_JPRB, 0.39040793E-09_JPRB, 0.38715633E-09_JPRB, 0.38235362E-09_JPRB, 0.37803435E-09_JPRB, 0.37309147E-09_JPRB, &
  & 0.36873374E-09_JPRB, 0.36557013E-09_JPRB, 0.36454800E-09_JPRB, 0.37334516E-09_JPRB, 0.38471748E-09_JPRB, 0.39962525E-09_JPRB, &
  & 0.41733489E-09_JPRB, 0.43994713E-09_JPRB, 0.46482157E-09_JPRB, 0.48418219E-09_JPRB /)

RGHG4(:,10, 5) = (/ &
  & 0.21925446E-08_JPRB, 0.28553562E-08_JPRB, 0.33283243E-08_JPRB, 0.38688297E-08_JPRB, 0.45245105E-08_JPRB, 0.54579483E-08_JPRB, &
  & 0.68047177E-08_JPRB, 0.87669338E-08_JPRB, 0.55834565E-09_JPRB, 0.63502553E-09_JPRB, 0.69973577E-09_JPRB, 0.74583062E-09_JPRB, &
  & 0.77172951E-09_JPRB, 0.78384299E-09_JPRB, 0.78901496E-09_JPRB, 0.78873436E-09_JPRB, 0.78462409E-09_JPRB, 0.78206480E-09_JPRB, &
  & 0.78197798E-09_JPRB, 0.78323170E-09_JPRB, 0.78660600E-09_JPRB, 0.79729506E-09_JPRB, 0.81291546E-09_JPRB, 0.83100210E-09_JPRB, &
  & 0.85060781E-09_JPRB, 0.86899993E-09_JPRB, 0.88369800E-09_JPRB, 0.89483648E-09_JPRB, 0.90414148E-09_JPRB, 0.90982105E-09_JPRB, &
  & 0.91542979E-09_JPRB, 0.91544455E-09_JPRB, 0.91079594E-09_JPRB, 0.90863461E-09_JPRB, 0.90614199E-09_JPRB, 0.90344038E-09_JPRB, &
  & 0.89970076E-09_JPRB, 0.89719676E-09_JPRB, 0.89132224E-09_JPRB, 0.88408847E-09_JPRB, 0.87953456E-09_JPRB, 0.87519691E-09_JPRB, &
  & 0.87107943E-09_JPRB, 0.86483859E-09_JPRB, 0.85612767E-09_JPRB, 0.85048557E-09_JPRB, 0.84553170E-09_JPRB, 0.83959317E-09_JPRB, &
  & 0.83112817E-09_JPRB, 0.82567680E-09_JPRB, 0.82022150E-09_JPRB, 0.81354157E-09_JPRB, 0.81002482E-09_JPRB, 0.80642937E-09_JPRB, &
  & 0.80371942E-09_JPRB, 0.80254203E-09_JPRB, 0.80541585E-09_JPRB, 0.82285950E-09_JPRB, 0.84546564E-09_JPRB, 0.87398411E-09_JPRB, &
  & 0.90809643E-09_JPRB, 0.95064245E-09_JPRB, 0.99893160E-09_JPRB, 0.10402668E-08_JPRB /)

RGHG4(:,11, 5) = (/ &
  & 0.23877917E-08_JPRB, 0.28333575E-08_JPRB, 0.32279239E-08_JPRB, 0.38034926E-08_JPRB, 0.45175681E-08_JPRB, 0.56680847E-08_JPRB, &
  & 0.74840205E-08_JPRB, 0.10315500E-07_JPRB, 0.96392461E-09_JPRB, 0.11400005E-08_JPRB, 0.13018765E-08_JPRB, 0.14386765E-08_JPRB, &
  & 0.15448812E-08_JPRB, 0.16233047E-08_JPRB, 0.16803515E-08_JPRB, 0.17173097E-08_JPRB, 0.17350541E-08_JPRB, 0.17439138E-08_JPRB, &
  & 0.17468180E-08_JPRB, 0.17439681E-08_JPRB, 0.17349988E-08_JPRB, 0.17314334E-08_JPRB, 0.17322873E-08_JPRB, 0.17382521E-08_JPRB, &
  & 0.17466079E-08_JPRB, 0.17499542E-08_JPRB, 0.17490996E-08_JPRB, 0.17587291E-08_JPRB, 0.17734136E-08_JPRB, 0.17819438E-08_JPRB, &
  & 0.17888134E-08_JPRB, 0.17875424E-08_JPRB, 0.17805087E-08_JPRB, 0.17793398E-08_JPRB, 0.17776967E-08_JPRB, 0.17742450E-08_JPRB, &
  & 0.17681193E-08_JPRB, 0.17609504E-08_JPRB, 0.17463757E-08_JPRB, 0.17274673E-08_JPRB, 0.17131476E-08_JPRB, 0.16997851E-08_JPRB, &
  & 0.16865530E-08_JPRB, 0.16700357E-08_JPRB, 0.16488335E-08_JPRB, 0.16332721E-08_JPRB, 0.16185084E-08_JPRB, 0.16016699E-08_JPRB, &
  & 0.15806232E-08_JPRB, 0.15658026E-08_JPRB, 0.15522856E-08_JPRB, 0.15376356E-08_JPRB, 0.15279769E-08_JPRB, 0.15185790E-08_JPRB, &
  & 0.15117820E-08_JPRB, 0.15089761E-08_JPRB, 0.15129599E-08_JPRB, 0.15326977E-08_JPRB, 0.15591329E-08_JPRB, 0.15936192E-08_JPRB, &
  & 0.16364802E-08_JPRB, 0.16912290E-08_JPRB, 0.17542359E-08_JPRB, 0.18085976E-08_JPRB /)

RGHG4(:,12, 5) = (/ &
  & 0.19628319E-08_JPRB, 0.22838980E-08_JPRB, 0.26227673E-08_JPRB, 0.31689200E-08_JPRB, 0.39052925E-08_JPRB, 0.51437570E-08_JPRB, &
  & 0.72083313E-08_JPRB, 0.10653007E-07_JPRB, 0.13276449E-08_JPRB, 0.16165876E-08_JPRB, 0.18850557E-08_JPRB, 0.21268809E-08_JPRB, &
  & 0.23361844E-08_JPRB, 0.25148541E-08_JPRB, 0.26672125E-08_JPRB, 0.27927087E-08_JPRB, 0.28878033E-08_JPRB, 0.29612652E-08_JPRB, &
  & 0.30155749E-08_JPRB, 0.30490173E-08_JPRB, 0.30596552E-08_JPRB, 0.30651075E-08_JPRB, 0.30648832E-08_JPRB, 0.30610032E-08_JPRB, &
  & 0.30557190E-08_JPRB, 0.30506988E-08_JPRB, 0.30413834E-08_JPRB, 0.30327054E-08_JPRB, 0.30312137E-08_JPRB, 0.30392093E-08_JPRB, &
  & 0.30525358E-08_JPRB, 0.30543656E-08_JPRB, 0.30487781E-08_JPRB, 0.30515694E-08_JPRB, 0.30550005E-08_JPRB, 0.30566438E-08_JPRB, &
  & 0.30525018E-08_JPRB, 0.30435796E-08_JPRB, 0.30236851E-08_JPRB, 0.29948444E-08_JPRB, 0.29703648E-08_JPRB, 0.29459597E-08_JPRB, &
  & 0.29192093E-08_JPRB, 0.28874931E-08_JPRB, 0.28467984E-08_JPRB, 0.28133671E-08_JPRB, 0.27810494E-08_JPRB, 0.27463190E-08_JPRB, &
  & 0.27047991E-08_JPRB, 0.26709646E-08_JPRB, 0.26384839E-08_JPRB, 0.26049483E-08_JPRB, 0.25785556E-08_JPRB, 0.25530320E-08_JPRB, &
  & 0.25305331E-08_JPRB, 0.25118911E-08_JPRB, 0.24981894E-08_JPRB, 0.24986337E-08_JPRB, 0.25071212E-08_JPRB, 0.25245379E-08_JPRB, &
  & 0.25519657E-08_JPRB, 0.25918634E-08_JPRB, 0.26453610E-08_JPRB, 0.26947931E-08_JPRB /)

RGHG4(:,13, 5) = (/ &
  & 0.13459831E-08_JPRB, 0.16489460E-08_JPRB, 0.19284954E-08_JPRB, 0.24430049E-08_JPRB, 0.31197360E-08_JPRB, 0.43329274E-08_JPRB, &
  & 0.63594290E-08_JPRB, 0.98958397E-08_JPRB, 0.15719248E-08_JPRB, 0.19898541E-08_JPRB, 0.23579068E-08_JPRB, 0.26861344E-08_JPRB, &
  & 0.29822522E-08_JPRB, 0.32502170E-08_JPRB, 0.34920344E-08_JPRB, 0.37064005E-08_JPRB, 0.38897308E-08_JPRB, 0.40481267E-08_JPRB, &
  & 0.41812611E-08_JPRB, 0.42850434E-08_JPRB, 0.43556501E-08_JPRB, 0.44093680E-08_JPRB, 0.44460080E-08_JPRB, 0.44687014E-08_JPRB, &
  & 0.44799084E-08_JPRB, 0.44798942E-08_JPRB, 0.44749147E-08_JPRB, 0.44835571E-08_JPRB, 0.44964046E-08_JPRB, 0.45007122E-08_JPRB, &
  & 0.45178359E-08_JPRB, 0.45291566E-08_JPRB, 0.45304400E-08_JPRB, 0.45416368E-08_JPRB, 0.45507642E-08_JPRB, 0.45551167E-08_JPRB, &
  & 0.45570774E-08_JPRB, 0.45528208E-08_JPRB, 0.45338444E-08_JPRB, 0.45025748E-08_JPRB, 0.44748165E-08_JPRB, 0.44449364E-08_JPRB, &
  & 0.44098134E-08_JPRB, 0.43670836E-08_JPRB, 0.43104897E-08_JPRB, 0.42603143E-08_JPRB, 0.42083932E-08_JPRB, 0.41506958E-08_JPRB, &
  & 0.40822217E-08_JPRB, 0.40218620E-08_JPRB, 0.39626795E-08_JPRB, 0.39013135E-08_JPRB, 0.38463059E-08_JPRB, 0.37902357E-08_JPRB, &
  & 0.37356234E-08_JPRB, 0.36826866E-08_JPRB, 0.36296639E-08_JPRB, 0.35874272E-08_JPRB, 0.35528505E-08_JPRB, 0.35307641E-08_JPRB, &
  & 0.35239032E-08_JPRB, 0.35353680E-08_JPRB, 0.35644641E-08_JPRB, 0.35945131E-08_JPRB /)

RGHG4(:,14, 5) = (/ &
  & 0.91337854E-09_JPRB, 0.11761881E-08_JPRB, 0.14320231E-08_JPRB, 0.18886670E-08_JPRB, 0.25059097E-08_JPRB, 0.36294405E-08_JPRB, &
  & 0.55257630E-08_JPRB, 0.88840508E-08_JPRB, 0.16888538E-08_JPRB, 0.22068147E-08_JPRB, 0.26523372E-08_JPRB, 0.30403622E-08_JPRB, &
  & 0.33871344E-08_JPRB, 0.37069410E-08_JPRB, 0.40032417E-08_JPRB, 0.42757251E-08_JPRB, 0.45251429E-08_JPRB, 0.47536646E-08_JPRB, &
  & 0.49600137E-08_JPRB, 0.51333391E-08_JPRB, 0.52765579E-08_JPRB, 0.53988680E-08_JPRB, 0.55001301E-08_JPRB, 0.55805094E-08_JPRB, &
  & 0.56431002E-08_JPRB, 0.56908869E-08_JPRB, 0.57214615E-08_JPRB, 0.57448415E-08_JPRB, 0.57771490E-08_JPRB, 0.58038796E-08_JPRB, &
  & 0.58270375E-08_JPRB, 0.58433636E-08_JPRB, 0.58435314E-08_JPRB, 0.58484844E-08_JPRB, 0.58607577E-08_JPRB, 0.58723559E-08_JPRB, &
  & 0.58780927E-08_JPRB, 0.58802829E-08_JPRB, 0.58732188E-08_JPRB, 0.58535292E-08_JPRB, 0.58362088E-08_JPRB, 0.58145853E-08_JPRB, &
  & 0.57856040E-08_JPRB, 0.57458838E-08_JPRB, 0.56872045E-08_JPRB, 0.56304970E-08_JPRB, 0.55668985E-08_JPRB, 0.54936127E-08_JPRB, &
  & 0.54059566E-08_JPRB, 0.53250253E-08_JPRB, 0.52426605E-08_JPRB, 0.51555773E-08_JPRB, 0.50722493E-08_JPRB, 0.49846078E-08_JPRB, &
  & 0.48947459E-08_JPRB, 0.48028479E-08_JPRB, 0.47063389E-08_JPRB, 0.46142672E-08_JPRB, 0.45301611E-08_JPRB, 0.44625121E-08_JPRB, &
  & 0.44167692E-08_JPRB, 0.43954138E-08_JPRB, 0.43987574E-08_JPRB, 0.44128301E-08_JPRB /)

RGHG4(:,15, 5) = (/ &
  & 0.66431305E-09_JPRB, 0.91655150E-09_JPRB, 0.11648051E-08_JPRB, 0.15732980E-08_JPRB, 0.21256399E-08_JPRB, 0.31173093E-08_JPRB, &
  & 0.47997335E-08_JPRB, 0.77767979E-08_JPRB, 0.17451380E-08_JPRB, 0.22717983E-08_JPRB, 0.27736631E-08_JPRB, 0.31933234E-08_JPRB, &
  & 0.35635690E-08_JPRB, 0.39045318E-08_JPRB, 0.42241535E-08_JPRB, 0.45235584E-08_JPRB, 0.48037800E-08_JPRB, 0.50699844E-08_JPRB, &
  & 0.53202585E-08_JPRB, 0.55408274E-08_JPRB, 0.57335434E-08_JPRB, 0.59083285E-08_JPRB, 0.60583303E-08_JPRB, 0.61887824E-08_JPRB, &
  & 0.62984356E-08_JPRB, 0.63857017E-08_JPRB, 0.64538082E-08_JPRB, 0.65129013E-08_JPRB, 0.65624772E-08_JPRB, 0.66027384E-08_JPRB, &
  & 0.66424182E-08_JPRB, 0.66689338E-08_JPRB, 0.66840875E-08_JPRB, 0.66993935E-08_JPRB, 0.66998012E-08_JPRB, 0.66980164E-08_JPRB, &
  & 0.67039698E-08_JPRB, 0.67068440E-08_JPRB, 0.66988104E-08_JPRB, 0.66828454E-08_JPRB, 0.66742172E-08_JPRB, 0.66660188E-08_JPRB, &
  & 0.66548398E-08_JPRB, 0.66336669E-08_JPRB, 0.65923187E-08_JPRB, 0.65486572E-08_JPRB, 0.64925105E-08_JPRB, 0.64221739E-08_JPRB, &
  & 0.63334125E-08_JPRB, 0.62488010E-08_JPRB, 0.61596990E-08_JPRB, 0.60631917E-08_JPRB, 0.59672312E-08_JPRB, 0.58627609E-08_JPRB, &
  & 0.57517724E-08_JPRB, 0.56367364E-08_JPRB, 0.55161000E-08_JPRB, 0.53900431E-08_JPRB, 0.52676530E-08_JPRB, 0.51654698E-08_JPRB, &
  & 0.50894902E-08_JPRB, 0.50409104E-08_JPRB, 0.50155879E-08_JPRB, 0.49899027E-08_JPRB /)

RGHG4(:,16, 5) = (/ &
  & 0.45086754E-09_JPRB, 0.66690142E-09_JPRB, 0.87463242E-09_JPRB, 0.12205967E-08_JPRB, 0.16928126E-08_JPRB, 0.25429976E-08_JPRB, &
  & 0.39451411E-08_JPRB, 0.64130141E-08_JPRB, 0.17099224E-08_JPRB, 0.21637081E-08_JPRB, 0.27381992E-08_JPRB, 0.31885707E-08_JPRB, &
  & 0.35648735E-08_JPRB, 0.39058654E-08_JPRB, 0.42244643E-08_JPRB, 0.45239563E-08_JPRB, 0.48032471E-08_JPRB, 0.50680979E-08_JPRB, &
  & 0.53201314E-08_JPRB, 0.55456222E-08_JPRB, 0.57448450E-08_JPRB, 0.59294876E-08_JPRB, 0.60912577E-08_JPRB, 0.62332441E-08_JPRB, &
  & 0.63528076E-08_JPRB, 0.64481642E-08_JPRB, 0.65227472E-08_JPRB, 0.65973902E-08_JPRB, 0.66727268E-08_JPRB, 0.67447905E-08_JPRB, &
  & 0.68182309E-08_JPRB, 0.68812276E-08_JPRB, 0.69269364E-08_JPRB, 0.69711610E-08_JPRB, 0.70025750E-08_JPRB, 0.70120980E-08_JPRB, &
  & 0.70037962E-08_JPRB, 0.69923192E-08_JPRB, 0.69730683E-08_JPRB, 0.69479871E-08_JPRB, 0.69364119E-08_JPRB, 0.69318560E-08_JPRB, &
  & 0.69320674E-08_JPRB, 0.69297417E-08_JPRB, 0.69123161E-08_JPRB, 0.68937420E-08_JPRB, 0.68637176E-08_JPRB, 0.68162951E-08_JPRB, &
  & 0.67467982E-08_JPRB, 0.66774573E-08_JPRB, 0.65997647E-08_JPRB, 0.65094614E-08_JPRB, 0.64157568E-08_JPRB, 0.63095111E-08_JPRB, &
  & 0.61950756E-08_JPRB, 0.60788206E-08_JPRB, 0.59613519E-08_JPRB, 0.58237144E-08_JPRB, 0.56810170E-08_JPRB, 0.55593339E-08_JPRB, &
  & 0.54646541E-08_JPRB, 0.53976019E-08_JPRB, 0.53469855E-08_JPRB, 0.52741722E-08_JPRB /)

RGHG4(:,17, 5) = (/ &
  & 0.29083819E-09_JPRB, 0.44668472E-09_JPRB, 0.60932365E-09_JPRB, 0.86900270E-09_JPRB, 0.12545136E-08_JPRB, 0.19250108E-08_JPRB, &
  & 0.30378868E-08_JPRB, 0.50164197E-08_JPRB, 0.16218880E-08_JPRB, 0.20387849E-08_JPRB, 0.25679363E-08_JPRB, 0.30370444E-08_JPRB, &
  & 0.34084529E-08_JPRB, 0.37301651E-08_JPRB, 0.40217669E-08_JPRB, 0.42938497E-08_JPRB, 0.45459361E-08_JPRB, 0.47775717E-08_JPRB, &
  & 0.49916040E-08_JPRB, 0.51767013E-08_JPRB, 0.53309477E-08_JPRB, 0.54692717E-08_JPRB, 0.55874536E-08_JPRB, 0.56877800E-08_JPRB, &
  & 0.57681162E-08_JPRB, 0.58275473E-08_JPRB, 0.58756404E-08_JPRB, 0.59369221E-08_JPRB, 0.60196070E-08_JPRB, 0.61230585E-08_JPRB, &
  & 0.62439760E-08_JPRB, 0.63680750E-08_JPRB, 0.64785777E-08_JPRB, 0.65831682E-08_JPRB, 0.66641697E-08_JPRB, 0.67128192E-08_JPRB, &
  & 0.67268879E-08_JPRB, 0.67058972E-08_JPRB, 0.66675829E-08_JPRB, 0.66158914E-08_JPRB, 0.65813222E-08_JPRB, 0.65653976E-08_JPRB, &
  & 0.65679835E-08_JPRB, 0.65804162E-08_JPRB, 0.65867773E-08_JPRB, 0.65991732E-08_JPRB, 0.66055277E-08_JPRB, 0.65960406E-08_JPRB, &
  & 0.65626038E-08_JPRB, 0.65251227E-08_JPRB, 0.64757320E-08_JPRB, 0.64080075E-08_JPRB, 0.63338734E-08_JPRB, 0.62437207E-08_JPRB, &
  & 0.61448850E-08_JPRB, 0.60475727E-08_JPRB, 0.59556591E-08_JPRB, 0.58270615E-08_JPRB, 0.56812799E-08_JPRB, 0.55534830E-08_JPRB, &
  & 0.54509179E-08_JPRB, 0.53727263E-08_JPRB, 0.53002300E-08_JPRB, 0.51766702E-08_JPRB /)

RGHG4(:,18, 5) = (/ &
  & 0.18454814E-09_JPRB, 0.29171698E-09_JPRB, 0.41569906E-09_JPRB, 0.60609867E-09_JPRB, 0.89376512E-09_JPRB, 0.13943517E-08_JPRB, &
  & 0.22227624E-08_JPRB, 0.37435526E-08_JPRB, 0.14725426E-08_JPRB, 0.18472270E-08_JPRB, 0.22745017E-08_JPRB, 0.27534202E-08_JPRB, &
  & 0.31225524E-08_JPRB, 0.34248413E-08_JPRB, 0.36850678E-08_JPRB, 0.39080308E-08_JPRB, 0.41060426E-08_JPRB, 0.42836645E-08_JPRB, &
  & 0.44399693E-08_JPRB, 0.45622421E-08_JPRB, 0.46557127E-08_JPRB, 0.47313198E-08_JPRB, 0.47834221E-08_JPRB, 0.48145581E-08_JPRB, &
  & 0.48312008E-08_JPRB, 0.48331978E-08_JPRB, 0.48346767E-08_JPRB, 0.48617945E-08_JPRB, 0.49303122E-08_JPRB, 0.50417341E-08_JPRB, &
  & 0.51940323E-08_JPRB, 0.53671609E-08_JPRB, 0.55386047E-08_JPRB, 0.57091687E-08_JPRB, 0.58501683E-08_JPRB, 0.59450653E-08_JPRB, &
  & 0.59860503E-08_JPRB, 0.59801089E-08_JPRB, 0.59308305E-08_JPRB, 0.58615042E-08_JPRB, 0.58098157E-08_JPRB, 0.57793570E-08_JPRB, &
  & 0.57759535E-08_JPRB, 0.57944587E-08_JPRB, 0.58196665E-08_JPRB, 0.58624257E-08_JPRB, 0.59077179E-08_JPRB, 0.59411573E-08_JPRB, &
  & 0.59487868E-08_JPRB, 0.59496537E-08_JPRB, 0.59369567E-08_JPRB, 0.59038756E-08_JPRB, 0.58626100E-08_JPRB, 0.58032734E-08_JPRB, &
  & 0.57355996E-08_JPRB, 0.56722902E-08_JPRB, 0.56214384E-08_JPRB, 0.55169527E-08_JPRB, 0.53821516E-08_JPRB, 0.52611311E-08_JPRB, &
  & 0.51623057E-08_JPRB, 0.50821005E-08_JPRB, 0.50006683E-08_JPRB, 0.48537263E-08_JPRB /)

RGHG4(:,19, 5) = (/ &
  & 0.11655453E-09_JPRB, 0.18947806E-09_JPRB, 0.27074085E-09_JPRB, 0.40026005E-09_JPRB, 0.60012406E-09_JPRB, 0.94186847E-09_JPRB, &
  & 0.15435334E-08_JPRB, 0.26572937E-08_JPRB, 0.12763538E-08_JPRB, 0.16161165E-08_JPRB, 0.19926216E-08_JPRB, 0.23830842E-08_JPRB, &
  & 0.27449296E-08_JPRB, 0.30114571E-08_JPRB, 0.32329688E-08_JPRB, 0.34204570E-08_JPRB, 0.35682739E-08_JPRB, 0.36875625E-08_JPRB, &
  & 0.37860044E-08_JPRB, 0.38575450E-08_JPRB, 0.38982204E-08_JPRB, 0.39129961E-08_JPRB, 0.39013952E-08_JPRB, 0.38748649E-08_JPRB, &
  & 0.38344172E-08_JPRB, 0.37860426E-08_JPRB, 0.37455150E-08_JPRB, 0.37369547E-08_JPRB, 0.37725223E-08_JPRB, 0.38580343E-08_JPRB, &
  & 0.39939705E-08_JPRB, 0.41672448E-08_JPRB, 0.43580437E-08_JPRB, 0.45582467E-08_JPRB, 0.47338848E-08_JPRB, 0.48626343E-08_JPRB, &
  & 0.49320863E-08_JPRB, 0.49423985E-08_JPRB, 0.49064162E-08_JPRB, 0.48412314E-08_JPRB, 0.47868900E-08_JPRB, 0.47576001E-08_JPRB, &
  & 0.47590749E-08_JPRB, 0.47894586E-08_JPRB, 0.48354694E-08_JPRB, 0.49048250E-08_JPRB, 0.49793529E-08_JPRB, 0.50432498E-08_JPRB, &
  & 0.50852278E-08_JPRB, 0.51253339E-08_JPRB, 0.51539297E-08_JPRB, 0.51603095E-08_JPRB, 0.51566529E-08_JPRB, 0.51339435E-08_JPRB, &
  & 0.51025948E-08_JPRB, 0.50772342E-08_JPRB, 0.50707611E-08_JPRB, 0.49973887E-08_JPRB, 0.48816848E-08_JPRB, 0.47745812E-08_JPRB, &
  & 0.46869180E-08_JPRB, 0.46136019E-08_JPRB, 0.45398525E-08_JPRB, 0.43787152E-08_JPRB /)

RGHG4(:,20, 5) = (/ &
  & 0.75468055E-10_JPRB, 0.12429027E-09_JPRB, 0.17642053E-09_JPRB, 0.26319594E-09_JPRB, 0.39917294E-09_JPRB, 0.63840261E-09_JPRB, &
  & 0.10702447E-08_JPRB, 0.18777986E-08_JPRB, 0.10917471E-08_JPRB, 0.13688412E-08_JPRB, 0.16778791E-08_JPRB, 0.19775743E-08_JPRB, &
  & 0.22843802E-08_JPRB, 0.25276408E-08_JPRB, 0.27109466E-08_JPRB, 0.28578706E-08_JPRB, 0.29745710E-08_JPRB, 0.30555720E-08_JPRB, &
  & 0.31082361E-08_JPRB, 0.31333034E-08_JPRB, 0.31346508E-08_JPRB, 0.31188445E-08_JPRB, 0.30805114E-08_JPRB, 0.30254430E-08_JPRB, &
  & 0.29596425E-08_JPRB, 0.28906117E-08_JPRB, 0.28263223E-08_JPRB, 0.27877949E-08_JPRB, 0.27865281E-08_JPRB, 0.28278797E-08_JPRB, &
  & 0.29151526E-08_JPRB, 0.30427210E-08_JPRB, 0.31947909E-08_JPRB, 0.33661240E-08_JPRB, 0.35301757E-08_JPRB, 0.36634380E-08_JPRB, &
  & 0.37478372E-08_JPRB, 0.37812384E-08_JPRB, 0.37699768E-08_JPRB, 0.37350820E-08_JPRB, 0.37062096E-08_JPRB, 0.36965837E-08_JPRB, &
  & 0.37157091E-08_JPRB, 0.37626213E-08_JPRB, 0.38243386E-08_JPRB, 0.39061336E-08_JPRB, 0.39950518E-08_JPRB, 0.40832853E-08_JPRB, &
  & 0.41602894E-08_JPRB, 0.42352948E-08_JPRB, 0.42946797E-08_JPRB, 0.43318513E-08_JPRB, 0.43579518E-08_JPRB, 0.43652926E-08_JPRB, &
  & 0.43646819E-08_JPRB, 0.43725481E-08_JPRB, 0.44053441E-08_JPRB, 0.43651456E-08_JPRB, 0.42751922E-08_JPRB, 0.41884420E-08_JPRB, &
  & 0.41149502E-08_JPRB, 0.40499324E-08_JPRB, 0.39810546E-08_JPRB, 0.38261847E-08_JPRB /)

RGHG4(:,21, 5) = (/ &
  & 0.45512951E-10_JPRB, 0.76570153E-10_JPRB, 0.11142126E-09_JPRB, 0.16758767E-09_JPRB, 0.25869379E-09_JPRB, 0.42295525E-09_JPRB, &
  & 0.73135509E-09_JPRB, 0.13053273E-08_JPRB, 0.88565816E-09_JPRB, 0.11280864E-08_JPRB, 0.13782580E-08_JPRB, 0.15981000E-08_JPRB, &
  & 0.18109940E-08_JPRB, 0.20225059E-08_JPRB, 0.21790214E-08_JPRB, 0.22883901E-08_JPRB, 0.23680049E-08_JPRB, 0.24228066E-08_JPRB, &
  & 0.24550835E-08_JPRB, 0.24670495E-08_JPRB, 0.24552085E-08_JPRB, 0.24235460E-08_JPRB, 0.23778566E-08_JPRB, 0.23187270E-08_JPRB, &
  & 0.22492264E-08_JPRB, 0.21770188E-08_JPRB, 0.21068627E-08_JPRB, 0.20545188E-08_JPRB, 0.20258883E-08_JPRB, 0.20271413E-08_JPRB, &
  & 0.20629625E-08_JPRB, 0.21309534E-08_JPRB, 0.22237649E-08_JPRB, 0.23407924E-08_JPRB, 0.24607469E-08_JPRB, 0.25652356E-08_JPRB, &
  & 0.26434328E-08_JPRB, 0.26920193E-08_JPRB, 0.27113392E-08_JPRB, 0.27124258E-08_JPRB, 0.27192237E-08_JPRB, 0.27414351E-08_JPRB, &
  & 0.27847782E-08_JPRB, 0.28503551E-08_JPRB, 0.29282505E-08_JPRB, 0.30241341E-08_JPRB, 0.31314720E-08_JPRB, 0.32402228E-08_JPRB, &
  & 0.33347314E-08_JPRB, 0.34208405E-08_JPRB, 0.34937646E-08_JPRB, 0.35495031E-08_JPRB, 0.35941827E-08_JPRB, 0.36229861E-08_JPRB, &
  & 0.36455721E-08_JPRB, 0.36779515E-08_JPRB, 0.37377541E-08_JPRB, 0.37236474E-08_JPRB, 0.36561130E-08_JPRB, 0.35888823E-08_JPRB, &
  & 0.35328771E-08_JPRB, 0.34854701E-08_JPRB, 0.34332472E-08_JPRB, 0.33103889E-08_JPRB /)

RGHG4(:,22, 5) = (/ &
  & 0.28882103E-10_JPRB, 0.48011598E-10_JPRB, 0.72037154E-10_JPRB, 0.10967093E-09_JPRB, 0.17293479E-09_JPRB, 0.28753164E-09_JPRB, &
  & 0.49695681E-09_JPRB, 0.90594476E-09_JPRB, 0.71373724E-09_JPRB, 0.90324909E-09_JPRB, 0.11032579E-08_JPRB, 0.12836718E-08_JPRB, &
  & 0.14365091E-08_JPRB, 0.15812904E-08_JPRB, 0.16963486E-08_JPRB, 0.17721319E-08_JPRB, 0.18223321E-08_JPRB, 0.18535178E-08_JPRB, &
  & 0.18670183E-08_JPRB, 0.18625219E-08_JPRB, 0.18420281E-08_JPRB, 0.18109292E-08_JPRB, 0.17717305E-08_JPRB, 0.17259657E-08_JPRB, &
  & 0.16743248E-08_JPRB, 0.16175751E-08_JPRB, 0.15579916E-08_JPRB, 0.15066834E-08_JPRB, 0.14681968E-08_JPRB, 0.14449125E-08_JPRB, &
  & 0.14419080E-08_JPRB, 0.14594992E-08_JPRB, 0.14964601E-08_JPRB, 0.15545762E-08_JPRB, 0.16215136E-08_JPRB, 0.16905926E-08_JPRB, &
  & 0.17498344E-08_JPRB, 0.18000506E-08_JPRB, 0.18380665E-08_JPRB, 0.18698236E-08_JPRB, 0.19086182E-08_JPRB, 0.19616766E-08_JPRB, &
  & 0.20309066E-08_JPRB, 0.21179309E-08_JPRB, 0.22107169E-08_JPRB, 0.23151536E-08_JPRB, 0.24243827E-08_JPRB, 0.25286302E-08_JPRB, &
  & 0.26200291E-08_JPRB, 0.27076701E-08_JPRB, 0.27861655E-08_JPRB, 0.28487497E-08_JPRB, 0.29015950E-08_JPRB, 0.29425824E-08_JPRB, &
  & 0.29801352E-08_JPRB, 0.30295351E-08_JPRB, 0.31070349E-08_JPRB, 0.31169214E-08_JPRB, 0.30733001E-08_JPRB, 0.30254952E-08_JPRB, &
  & 0.29852452E-08_JPRB, 0.29511622E-08_JPRB, 0.29119183E-08_JPRB, 0.28084877E-08_JPRB /)

RGHG4(:,23, 5) = (/ &
  & 0.17698029E-10_JPRB, 0.29360084E-10_JPRB, 0.44623562E-10_JPRB, 0.68904722E-10_JPRB, 0.10986604E-09_JPRB, 0.18320813E-09_JPRB, &
  & 0.33304298E-09_JPRB, 0.62691458E-09_JPRB, 0.55412192E-09_JPRB, 0.71137007E-09_JPRB, 0.87835744E-09_JPRB, 0.10169908E-08_JPRB, &
  & 0.11274361E-08_JPRB, 0.12219129E-08_JPRB, 0.13037835E-08_JPRB, 0.13591630E-08_JPRB, 0.13894026E-08_JPRB, 0.14021637E-08_JPRB, &
  & 0.14030396E-08_JPRB, 0.13956333E-08_JPRB, 0.13801428E-08_JPRB, 0.13593534E-08_JPRB, 0.13339007E-08_JPRB, 0.13038080E-08_JPRB, &
  & 0.12694814E-08_JPRB, 0.12300632E-08_JPRB, 0.11842674E-08_JPRB, 0.11364258E-08_JPRB, 0.10931965E-08_JPRB, 0.10570692E-08_JPRB, &
  & 0.10317284E-08_JPRB, 0.10185774E-08_JPRB, 0.10196752E-08_JPRB, 0.10371251E-08_JPRB, 0.10665190E-08_JPRB, 0.11042234E-08_JPRB, &
  & 0.11463684E-08_JPRB, 0.11907568E-08_JPRB, 0.12364765E-08_JPRB, 0.12850500E-08_JPRB, 0.13424577E-08_JPRB, 0.14110570E-08_JPRB, &
  & 0.14893577E-08_JPRB, 0.15769372E-08_JPRB, 0.16696083E-08_JPRB, 0.17678834E-08_JPRB, 0.18666857E-08_JPRB, 0.19640534E-08_JPRB, &
  & 0.20573490E-08_JPRB, 0.21444226E-08_JPRB, 0.22206164E-08_JPRB, 0.22842119E-08_JPRB, 0.23395570E-08_JPRB, 0.23859799E-08_JPRB, &
  & 0.24310522E-08_JPRB, 0.24881677E-08_JPRB, 0.25708773E-08_JPRB, 0.25943372E-08_JPRB, 0.25679998E-08_JPRB, 0.25360356E-08_JPRB, &
  & 0.25087261E-08_JPRB, 0.24858857E-08_JPRB, 0.24617317E-08_JPRB, 0.23936197E-08_JPRB /)

RGHG4(:,24, 5) = (/ &
  & 0.10597255E-10_JPRB, 0.17641765E-10_JPRB, 0.27311521E-10_JPRB, 0.43029649E-10_JPRB, 0.70814396E-10_JPRB, 0.12644076E-09_JPRB, &
  & 0.23224082E-09_JPRB, 0.44308240E-09_JPRB, 0.43631151E-09_JPRB, 0.56814947E-09_JPRB, 0.70170803E-09_JPRB, 0.80505480E-09_JPRB, &
  & 0.88880409E-09_JPRB, 0.95062103E-09_JPRB, 0.10021913E-08_JPRB, 0.10462147E-08_JPRB, 0.10688033E-08_JPRB, 0.10759137E-08_JPRB, &
  & 0.10724103E-08_JPRB, 0.10622349E-08_JPRB, 0.10475989E-08_JPRB, 0.10313406E-08_JPRB, 0.10138488E-08_JPRB, 0.99458619E-09_JPRB, &
  & 0.97232322E-09_JPRB, 0.94528829E-09_JPRB, 0.91153990E-09_JPRB, 0.87362312E-09_JPRB, 0.83231882E-09_JPRB, 0.79217821E-09_JPRB, &
  & 0.75701712E-09_JPRB, 0.72914247E-09_JPRB, 0.71178791E-09_JPRB, 0.70759071E-09_JPRB, 0.71577788E-09_JPRB, 0.73481882E-09_JPRB, &
  & 0.76390078E-09_JPRB, 0.80136686E-09_JPRB, 0.84744445E-09_JPRB, 0.90043151E-09_JPRB, 0.96352037E-09_JPRB, 0.10363043E-08_JPRB, &
  & 0.11160534E-08_JPRB, 0.12011654E-08_JPRB, 0.12874681E-08_JPRB, 0.13759551E-08_JPRB, 0.14641299E-08_JPRB, 0.15480235E-08_JPRB, &
  & 0.16250463E-08_JPRB, 0.16988562E-08_JPRB, 0.17673244E-08_JPRB, 0.18303125E-08_JPRB, 0.18855415E-08_JPRB, 0.19335737E-08_JPRB, &
  & 0.19816551E-08_JPRB, 0.20421957E-08_JPRB, 0.21264075E-08_JPRB, 0.21611875E-08_JPRB, 0.21504616E-08_JPRB, 0.21315067E-08_JPRB, &
  & 0.21155919E-08_JPRB, 0.21028252E-08_JPRB, 0.20876700E-08_JPRB, 0.20423678E-08_JPRB /)

RGHG4(:,25, 5) = (/ &
  & 0.79735914E-11_JPRB, 0.12401549E-10_JPRB, 0.20195541E-10_JPRB, 0.32354432E-10_JPRB, 0.54035845E-10_JPRB, 0.92738393E-10_JPRB, &
  & 0.16829138E-09_JPRB, 0.32591113E-09_JPRB, 0.34523018E-09_JPRB, 0.45818455E-09_JPRB, 0.56517807E-09_JPRB, 0.65198619E-09_JPRB, &
  & 0.71748141E-09_JPRB, 0.76155360E-09_JPRB, 0.79305967E-09_JPRB, 0.81865503E-09_JPRB, 0.83194485E-09_JPRB, 0.83429330E-09_JPRB, &
  & 0.82889995E-09_JPRB, 0.81892287E-09_JPRB, 0.80634521E-09_JPRB, 0.79351220E-09_JPRB, 0.78139578E-09_JPRB, 0.76903395E-09_JPRB, &
  & 0.75517709E-09_JPRB, 0.73742679E-09_JPRB, 0.71294426E-09_JPRB, 0.68243872E-09_JPRB, 0.64714845E-09_JPRB, 0.60898292E-09_JPRB, &
  & 0.57210270E-09_JPRB, 0.53964250E-09_JPRB, 0.51549631E-09_JPRB, 0.50212173E-09_JPRB, 0.50072252E-09_JPRB, 0.51086729E-09_JPRB, &
  & 0.53267080E-09_JPRB, 0.56489147E-09_JPRB, 0.60752448E-09_JPRB, 0.65961486E-09_JPRB, 0.72133888E-09_JPRB, 0.79170692E-09_JPRB, &
  & 0.86712804E-09_JPRB, 0.94605179E-09_JPRB, 0.10253575E-08_JPRB, 0.11045911E-08_JPRB, 0.11806821E-08_JPRB, 0.12529670E-08_JPRB, &
  & 0.13185044E-08_JPRB, 0.13796172E-08_JPRB, 0.14355137E-08_JPRB, 0.14864530E-08_JPRB, 0.15343818E-08_JPRB, 0.15821300E-08_JPRB, &
  & 0.16316442E-08_JPRB, 0.16930524E-08_JPRB, 0.17756707E-08_JPRB, 0.18170891E-08_JPRB, 0.18181592E-08_JPRB, 0.18103820E-08_JPRB, &
  & 0.18039040E-08_JPRB, 0.17995734E-08_JPRB, 0.17933875E-08_JPRB, 0.17618349E-08_JPRB /)

RGHG4(:,26, 5) = (/ &
  & 0.55179711E-11_JPRB, 0.86250495E-11_JPRB, 0.13531864E-10_JPRB, 0.22174221E-10_JPRB, 0.37340762E-10_JPRB, 0.65372922E-10_JPRB, &
  & 0.12415752E-09_JPRB, 0.24506364E-09_JPRB, 0.27963054E-09_JPRB, 0.36986159E-09_JPRB, 0.45614426E-09_JPRB, 0.53046473E-09_JPRB, &
  & 0.58229516E-09_JPRB, 0.61976113E-09_JPRB, 0.64198508E-09_JPRB, 0.65523159E-09_JPRB, 0.66247713E-09_JPRB, 0.66078232E-09_JPRB, &
  & 0.65343869E-09_JPRB, 0.64274569E-09_JPRB, 0.63086958E-09_JPRB, 0.61980826E-09_JPRB, 0.61021094E-09_JPRB, 0.60153077E-09_JPRB, &
  & 0.59244837E-09_JPRB, 0.58072613E-09_JPRB, 0.56347160E-09_JPRB, 0.54007043E-09_JPRB, 0.51043020E-09_JPRB, 0.47698351E-09_JPRB, &
  & 0.44300194E-09_JPRB, 0.41126147E-09_JPRB, 0.38659095E-09_JPRB, 0.37053821E-09_JPRB, 0.36600406E-09_JPRB, 0.37245693E-09_JPRB, &
  & 0.39030013E-09_JPRB, 0.41921114E-09_JPRB, 0.45811288E-09_JPRB, 0.50718796E-09_JPRB, 0.56413518E-09_JPRB, 0.62902872E-09_JPRB, &
  & 0.69758826E-09_JPRB, 0.76897400E-09_JPRB, 0.83891083E-09_JPRB, 0.90756358E-09_JPRB, 0.97300112E-09_JPRB, 0.10335331E-08_JPRB, &
  & 0.10876252E-08_JPRB, 0.11384926E-08_JPRB, 0.11852391E-08_JPRB, 0.12275430E-08_JPRB, 0.12691217E-08_JPRB, 0.13112126E-08_JPRB, &
  & 0.13592896E-08_JPRB, 0.14199643E-08_JPRB, 0.15004388E-08_JPRB, 0.15464978E-08_JPRB, 0.15565015E-08_JPRB, 0.15567094E-08_JPRB, &
  & 0.15569465E-08_JPRB, 0.15592340E-08_JPRB, 0.15609479E-08_JPRB, 0.15482949E-08_JPRB /)

RGHG4(:,27, 5) = (/ &
  & 0.47439873E-11_JPRB, 0.68392488E-11_JPRB, 0.11132239E-10_JPRB, 0.17284181E-10_JPRB, 0.28692096E-10_JPRB, 0.51054248E-10_JPRB, &
  & 0.96309204E-10_JPRB, 0.19133468E-09_JPRB, 0.23083202E-09_JPRB, 0.30686528E-09_JPRB, 0.37919928E-09_JPRB, 0.44177920E-09_JPRB, &
  & 0.48431348E-09_JPRB, 0.51422661E-09_JPRB, 0.53070554E-09_JPRB, 0.53800892E-09_JPRB, 0.53963156E-09_JPRB, 0.53460031E-09_JPRB, &
  & 0.52534777E-09_JPRB, 0.51342708E-09_JPRB, 0.50123117E-09_JPRB, 0.49018228E-09_JPRB, 0.48109200E-09_JPRB, 0.47363458E-09_JPRB, &
  & 0.46673576E-09_JPRB, 0.45834428E-09_JPRB, 0.44578824E-09_JPRB, 0.42840859E-09_JPRB, 0.40524711E-09_JPRB, 0.37703290E-09_JPRB, &
  & 0.34768741E-09_JPRB, 0.31932143E-09_JPRB, 0.29671049E-09_JPRB, 0.28143274E-09_JPRB, 0.27650859E-09_JPRB, 0.28164593E-09_JPRB, &
  & 0.29742375E-09_JPRB, 0.32386654E-09_JPRB, 0.35949918E-09_JPRB, 0.40372464E-09_JPRB, 0.45566961E-09_JPRB, 0.51384014E-09_JPRB, &
  & 0.57479810E-09_JPRB, 0.63694711E-09_JPRB, 0.69713957E-09_JPRB, 0.75623657E-09_JPRB, 0.81082546E-09_JPRB, 0.86123925E-09_JPRB, &
  & 0.90763458E-09_JPRB, 0.95071306E-09_JPRB, 0.98995101E-09_JPRB, 0.10270970E-08_JPRB, 0.10630105E-08_JPRB, 0.11003412E-08_JPRB, &
  & 0.11442730E-08_JPRB, 0.12024299E-08_JPRB, 0.12791023E-08_JPRB, 0.13275065E-08_JPRB, 0.13439884E-08_JPRB, 0.13503894E-08_JPRB, &
  & 0.13560204E-08_JPRB, 0.13628169E-08_JPRB, 0.13690541E-08_JPRB, 0.13647106E-08_JPRB /)

RGHG4(:,28, 5) = (/ &
  & 0.39398307E-11_JPRB, 0.57249028E-11_JPRB, 0.88890657E-11_JPRB, 0.14580932E-10_JPRB, 0.23334761E-10_JPRB, 0.40130590E-10_JPRB, &
  & 0.75274287E-10_JPRB, 0.14841772E-09_JPRB, 0.18463306E-09_JPRB, 0.25047797E-09_JPRB, 0.31705025E-09_JPRB, 0.37086459E-09_JPRB, &
  & 0.40943576E-09_JPRB, 0.43387577E-09_JPRB, 0.44711104E-09_JPRB, 0.45059936E-09_JPRB, 0.44778234E-09_JPRB, 0.44079126E-09_JPRB, &
  & 0.42987475E-09_JPRB, 0.41690093E-09_JPRB, 0.40374581E-09_JPRB, 0.39185366E-09_JPRB, 0.38212727E-09_JPRB, 0.37445236E-09_JPRB, &
  & 0.36809183E-09_JPRB, 0.36128689E-09_JPRB, 0.35218337E-09_JPRB, 0.33912487E-09_JPRB, 0.32124692E-09_JPRB, 0.29897429E-09_JPRB, &
  & 0.27479288E-09_JPRB, 0.25117403E-09_JPRB, 0.23178084E-09_JPRB, 0.21891571E-09_JPRB, 0.21474730E-09_JPRB, 0.21969430E-09_JPRB, &
  & 0.23436084E-09_JPRB, 0.25820210E-09_JPRB, 0.29059957E-09_JPRB, 0.33047956E-09_JPRB, 0.37675024E-09_JPRB, 0.42744616E-09_JPRB, &
  & 0.48018861E-09_JPRB, 0.53328053E-09_JPRB, 0.58503763E-09_JPRB, 0.63464123E-09_JPRB, 0.68045830E-09_JPRB, 0.72340178E-09_JPRB, &
  & 0.76241424E-09_JPRB, 0.79865764E-09_JPRB, 0.83299889E-09_JPRB, 0.86522867E-09_JPRB, 0.89786650E-09_JPRB, 0.93275077E-09_JPRB, &
  & 0.97377761E-09_JPRB, 0.10283542E-08_JPRB, 0.11009000E-08_JPRB, 0.11503870E-08_JPRB, 0.11715861E-08_JPRB, 0.11827496E-08_JPRB, &
  & 0.11923642E-08_JPRB, 0.12028363E-08_JPRB, 0.12147319E-08_JPRB, 0.12209037E-08_JPRB /)

RGHG4(:,29, 5) = (/ &
  & 0.33441780E-11_JPRB, 0.48683778E-11_JPRB, 0.78325124E-11_JPRB, 0.12402782E-10_JPRB, 0.19559859E-10_JPRB, 0.33149875E-10_JPRB, &
  & 0.62167667E-10_JPRB, 0.12205353E-09_JPRB, 0.15505867E-09_JPRB, 0.21143290E-09_JPRB, 0.26887087E-09_JPRB, 0.31351935E-09_JPRB, &
  & 0.34929917E-09_JPRB, 0.37004633E-09_JPRB, 0.38106399E-09_JPRB, 0.38277720E-09_JPRB, 0.37786238E-09_JPRB, 0.36849546E-09_JPRB, &
  & 0.35571995E-09_JPRB, 0.34140479E-09_JPRB, 0.32688879E-09_JPRB, 0.31389064E-09_JPRB, 0.30301620E-09_JPRB, 0.29456779E-09_JPRB, &
  & 0.28791150E-09_JPRB, 0.28166430E-09_JPRB, 0.27448835E-09_JPRB, 0.26482153E-09_JPRB, 0.25140831E-09_JPRB, 0.23455468E-09_JPRB, &
  & 0.21558665E-09_JPRB, 0.19697534E-09_JPRB, 0.18136979E-09_JPRB, 0.17123200E-09_JPRB, 0.16834176E-09_JPRB, 0.17338875E-09_JPRB, &
  & 0.18677337E-09_JPRB, 0.20820766E-09_JPRB, 0.23697122E-09_JPRB, 0.27187516E-09_JPRB, 0.31203215E-09_JPRB, 0.35554087E-09_JPRB, &
  & 0.40027390E-09_JPRB, 0.44500537E-09_JPRB, 0.48846560E-09_JPRB, 0.53005433E-09_JPRB, 0.56920590E-09_JPRB, 0.60573141E-09_JPRB, &
  & 0.63954542E-09_JPRB, 0.67179595E-09_JPRB, 0.70223982E-09_JPRB, 0.73183004E-09_JPRB, 0.76191231E-09_JPRB, 0.79404183E-09_JPRB, &
  & 0.83270368E-09_JPRB, 0.88371577E-09_JPRB, 0.95136099E-09_JPRB, 0.10003590E-08_JPRB, 0.10249038E-08_JPRB, 0.10399026E-08_JPRB, &
  & 0.10526070E-08_JPRB, 0.10661924E-08_JPRB, 0.10817749E-08_JPRB, 0.11006069E-08_JPRB /)

RGHG4(:,30, 5) = (/ &
  & 0.25951669E-11_JPRB, 0.41341743E-11_JPRB, 0.63502658E-11_JPRB, 0.96703765E-11_JPRB, 0.16115101E-10_JPRB, 0.27457340E-10_JPRB, &
  & 0.52508983E-10_JPRB, 0.10271701E-09_JPRB, 0.13350225E-09_JPRB, 0.18291793E-09_JPRB, 0.23268321E-09_JPRB, 0.27158764E-09_JPRB, &
  & 0.30325212E-09_JPRB, 0.32153752E-09_JPRB, 0.33004927E-09_JPRB, 0.32962974E-09_JPRB, 0.32291919E-09_JPRB, 0.31194503E-09_JPRB, &
  & 0.29776911E-09_JPRB, 0.28241087E-09_JPRB, 0.26668442E-09_JPRB, 0.25258681E-09_JPRB, 0.24036168E-09_JPRB, 0.23071432E-09_JPRB, &
  & 0.22318897E-09_JPRB, 0.21682975E-09_JPRB, 0.21075841E-09_JPRB, 0.20339629E-09_JPRB, 0.19359730E-09_JPRB, 0.18130385E-09_JPRB, &
  & 0.16726544E-09_JPRB, 0.15334230E-09_JPRB, 0.14162602E-09_JPRB, 0.13432556E-09_JPRB, 0.13295758E-09_JPRB, 0.13812053E-09_JPRB, &
  & 0.15036743E-09_JPRB, 0.16919820E-09_JPRB, 0.19401483E-09_JPRB, 0.22375930E-09_JPRB, 0.25768210E-09_JPRB, 0.29404032E-09_JPRB, &
  & 0.33141670E-09_JPRB, 0.36880796E-09_JPRB, 0.40574005E-09_JPRB, 0.44105472E-09_JPRB, 0.47497423E-09_JPRB, 0.50724036E-09_JPRB, &
  & 0.53716409E-09_JPRB, 0.56588167E-09_JPRB, 0.59337529E-09_JPRB, 0.62056504E-09_JPRB, 0.64875511E-09_JPRB, 0.67960987E-09_JPRB, &
  & 0.71630790E-09_JPRB, 0.76433154E-09_JPRB, 0.82754525E-09_JPRB, 0.87581786E-09_JPRB, 0.90278590E-09_JPRB, 0.92068070E-09_JPRB, &
  & 0.93602326E-09_JPRB, 0.95227704E-09_JPRB, 0.97028952E-09_JPRB, 0.99635000E-09_JPRB /)

RGHG4(:,31, 5) = (/ &
  & 0.21373057E-11_JPRB, 0.38842423E-11_JPRB, 0.60602226E-11_JPRB, 0.83544751E-11_JPRB, 0.14153153E-10_JPRB, 0.23576946E-10_JPRB, &
  & 0.44134717E-10_JPRB, 0.86811017E-10_JPRB, 0.11475581E-09_JPRB, 0.15805450E-09_JPRB, 0.20208991E-09_JPRB, 0.23656380E-09_JPRB, &
  & 0.26424968E-09_JPRB, 0.28043914E-09_JPRB, 0.28758845E-09_JPRB, 0.28614611E-09_JPRB, 0.27800201E-09_JPRB, 0.26571462E-09_JPRB, &
  & 0.25022054E-09_JPRB, 0.23377719E-09_JPRB, 0.21694907E-09_JPRB, 0.20177962E-09_JPRB, 0.18847042E-09_JPRB, 0.17781203E-09_JPRB, &
  & 0.16952413E-09_JPRB, 0.16298315E-09_JPRB, 0.15748029E-09_JPRB, 0.15185286E-09_JPRB, 0.14481009E-09_JPRB, 0.13638464E-09_JPRB, &
  & 0.12656182E-09_JPRB, 0.11673842E-09_JPRB, 0.10855391E-09_JPRB, 0.10377992E-09_JPRB, 0.10368487E-09_JPRB, 0.10879703E-09_JPRB, &
  & 0.11965209E-09_JPRB, 0.13568736E-09_JPRB, 0.15640585E-09_JPRB, 0.18096116E-09_JPRB, 0.20861933E-09_JPRB, 0.23846025E-09_JPRB, &
  & 0.26936259E-09_JPRB, 0.30045583E-09_JPRB, 0.33148306E-09_JPRB, 0.36219142E-09_JPRB, 0.39172010E-09_JPRB, 0.42066264E-09_JPRB, &
  & 0.44804296E-09_JPRB, 0.47454907E-09_JPRB, 0.50069870E-09_JPRB, 0.52668980E-09_JPRB, 0.55342153E-09_JPRB, 0.58266514E-09_JPRB, &
  & 0.61750532E-09_JPRB, 0.66260814E-09_JPRB, 0.72110434E-09_JPRB, 0.76771794E-09_JPRB, 0.79612050E-09_JPRB, 0.81622281E-09_JPRB, &
  & 0.83360813E-09_JPRB, 0.85170410E-09_JPRB, 0.87178054E-09_JPRB, 0.90098967E-09_JPRB /)

RGHG4(:,32, 5) = (/ &
  & 0.16773103E-11_JPRB, 0.29642812E-11_JPRB, 0.47095708E-11_JPRB, 0.64819500E-11_JPRB, 0.11339149E-10_JPRB, 0.19944026E-10_JPRB, &
  & 0.37964555E-10_JPRB, 0.75395613E-10_JPRB, 0.10062010E-09_JPRB, 0.13925308E-09_JPRB, 0.17709502E-09_JPRB, 0.20859747E-09_JPRB, &
  & 0.23309962E-09_JPRB, 0.24686811E-09_JPRB, 0.25204835E-09_JPRB, 0.25012667E-09_JPRB, 0.24115893E-09_JPRB, 0.22802697E-09_JPRB, &
  & 0.21174940E-09_JPRB, 0.19455092E-09_JPRB, 0.17720171E-09_JPRB, 0.16127537E-09_JPRB, 0.14744135E-09_JPRB, 0.13598084E-09_JPRB, &
  & 0.12717859E-09_JPRB, 0.12037440E-09_JPRB, 0.11508183E-09_JPRB, 0.11043933E-09_JPRB, 0.10539546E-09_JPRB, 0.99748577E-10_JPRB, &
  & 0.93373823E-10_JPRB, 0.86974684E-10_JPRB, 0.81796514E-10_JPRB, 0.79248448E-10_JPRB, 0.80411053E-10_JPRB, 0.85610588E-10_JPRB, &
  & 0.95024884E-10_JPRB, 0.10826632E-09_JPRB, 0.12512742E-09_JPRB, 0.14494118E-09_JPRB, 0.16735234E-09_JPRB, 0.19152246E-09_JPRB, &
  & 0.21688272E-09_JPRB, 0.24279836E-09_JPRB, 0.26916530E-09_JPRB, 0.29578548E-09_JPRB, 0.32221611E-09_JPRB, 0.34840814E-09_JPRB, &
  & 0.37385059E-09_JPRB, 0.39865453E-09_JPRB, 0.42316187E-09_JPRB, 0.44780704E-09_JPRB, 0.47348581E-09_JPRB, 0.50165805E-09_JPRB, &
  & 0.53472865E-09_JPRB, 0.57711042E-09_JPRB, 0.63151240E-09_JPRB, 0.67631045E-09_JPRB, 0.70534473E-09_JPRB, 0.72650269E-09_JPRB, &
  & 0.74504841E-09_JPRB, 0.76397116E-09_JPRB, 0.78597467E-09_JPRB, 0.81800827E-09_JPRB /)

RGHG4(:,33, 5) = (/ &
  & 0.14191980E-11_JPRB, 0.26499666E-11_JPRB, 0.40692085E-11_JPRB, 0.57712867E-11_JPRB, 0.10083255E-10_JPRB, 0.18080214E-10_JPRB, &
  & 0.33902617E-10_JPRB, 0.65820273E-10_JPRB, 0.87694393E-10_JPRB, 0.12168541E-09_JPRB, 0.15547352E-09_JPRB, 0.18352506E-09_JPRB, &
  & 0.20501550E-09_JPRB, 0.21806737E-09_JPRB, 0.22228858E-09_JPRB, 0.21933691E-09_JPRB, 0.20987871E-09_JPRB, 0.19596638E-09_JPRB, &
  & 0.17912460E-09_JPRB, 0.16127323E-09_JPRB, 0.14363080E-09_JPRB, 0.12725528E-09_JPRB, 0.11319030E-09_JPRB, 0.10146243E-09_JPRB, &
  & 0.92503567E-10_JPRB, 0.85756256E-10_JPRB, 0.80799326E-10_JPRB, 0.76885123E-10_JPRB, 0.73285059E-10_JPRB, 0.69680137E-10_JPRB, &
  & 0.65901312E-10_JPRB, 0.62187075E-10_JPRB, 0.59404690E-10_JPRB, 0.58527010E-10_JPRB, 0.60349455E-10_JPRB, 0.65117814E-10_JPRB, &
  & 0.73128843E-10_JPRB, 0.83958007E-10_JPRB, 0.97347672E-10_JPRB, 0.11297322E-09_JPRB, 0.13080614E-09_JPRB, 0.15029507E-09_JPRB, &
  & 0.17108748E-09_JPRB, 0.19291944E-09_JPRB, 0.21564237E-09_JPRB, 0.23928109E-09_JPRB, 0.26308053E-09_JPRB, 0.28691260E-09_JPRB, &
  & 0.31058711E-09_JPRB, 0.33397754E-09_JPRB, 0.35738693E-09_JPRB, 0.38105391E-09_JPRB, 0.40555545E-09_JPRB, 0.43226692E-09_JPRB, &
  & 0.46358534E-09_JPRB, 0.50330617E-09_JPRB, 0.55355392E-09_JPRB, 0.59608374E-09_JPRB, 0.62509475E-09_JPRB, 0.64703004E-09_JPRB, &
  & 0.66651795E-09_JPRB, 0.68609124E-09_JPRB, 0.70845085E-09_JPRB, 0.74089457E-09_JPRB /)

RGHG4(:,34, 5) = (/ &
  & 0.11950837E-11_JPRB, 0.23953942E-11_JPRB, 0.38471427E-11_JPRB, 0.51423366E-11_JPRB, 0.94577679E-11_JPRB, 0.16856981E-10_JPRB, &
  & 0.31008023E-10_JPRB, 0.59255253E-10_JPRB, 0.78059594E-10_JPRB, 0.10804264E-09_JPRB, 0.13753522E-09_JPRB, 0.16226501E-09_JPRB, &
  & 0.18054636E-09_JPRB, 0.19275749E-09_JPRB, 0.19667480E-09_JPRB, 0.19338928E-09_JPRB, 0.18353961E-09_JPRB, 0.16922352E-09_JPRB, &
  & 0.15218526E-09_JPRB, 0.13410927E-09_JPRB, 0.11646593E-09_JPRB, 0.10017248E-09_JPRB, 0.86232514E-10_JPRB, 0.74787385E-10_JPRB, &
  & 0.66032096E-10_JPRB, 0.59554195E-10_JPRB, 0.54941957E-10_JPRB, 0.51588768E-10_JPRB, 0.48922578E-10_JPRB, 0.46641836E-10_JPRB, &
  & 0.44570559E-10_JPRB, 0.42755771E-10_JPRB, 0.41693187E-10_JPRB, 0.41988975E-10_JPRB, 0.44257001E-10_JPRB, 0.48674929E-10_JPRB, &
  & 0.55165775E-10_JPRB, 0.63777768E-10_JPRB, 0.74399896E-10_JPRB, 0.86873585E-10_JPRB, 0.10116957E-09_JPRB, 0.11703886E-09_JPRB, &
  & 0.13437544E-09_JPRB, 0.15289119E-09_JPRB, 0.17261798E-09_JPRB, 0.19345366E-09_JPRB, 0.21498692E-09_JPRB, 0.23683744E-09_JPRB, &
  & 0.25879313E-09_JPRB, 0.28089039E-09_JPRB, 0.30311476E-09_JPRB, 0.32560801E-09_JPRB, 0.34899461E-09_JPRB, 0.37440229E-09_JPRB, &
  & 0.40390691E-09_JPRB, 0.44093007E-09_JPRB, 0.48734189E-09_JPRB, 0.52754418E-09_JPRB, 0.55602933E-09_JPRB, 0.57799887E-09_JPRB, &
  & 0.59750305E-09_JPRB, 0.61731975E-09_JPRB, 0.63979971E-09_JPRB, 0.67264938E-09_JPRB /)

RGHG4(:,35, 5) = (/ &
  & 0.10401844E-11_JPRB, 0.19418093E-11_JPRB, 0.35480516E-11_JPRB, 0.54176980E-11_JPRB, 0.87815675E-11_JPRB, 0.15084257E-10_JPRB, &
  & 0.28045203E-10_JPRB, 0.53089363E-10_JPRB, 0.68701350E-10_JPRB, 0.94566806E-10_JPRB, 0.11987029E-09_JPRB, 0.14305535E-09_JPRB, &
  & 0.15992140E-09_JPRB, 0.17104379E-09_JPRB, 0.17415068E-09_JPRB, 0.17036807E-09_JPRB, 0.16059434E-09_JPRB, 0.14614032E-09_JPRB, &
  & 0.12895347E-09_JPRB, 0.11077950E-09_JPRB, 0.93233352E-10_JPRB, 0.77306564E-10_JPRB, 0.63844020E-10_JPRB, 0.53085158E-10_JPRB, &
  & 0.44944968E-10_JPRB, 0.39103804E-10_JPRB, 0.35004322E-10_JPRB, 0.32231173E-10_JPRB, 0.30299444E-10_JPRB, 0.28933618E-10_JPRB, &
  & 0.27975828E-10_JPRB, 0.27391169E-10_JPRB, 0.27422901E-10_JPRB, 0.28366044E-10_JPRB, 0.30620454E-10_JPRB, 0.34360334E-10_JPRB, &
  & 0.39655192E-10_JPRB, 0.46245369E-10_JPRB, 0.54390915E-10_JPRB, 0.64227290E-10_JPRB, 0.75780014E-10_JPRB, 0.88898916E-10_JPRB, &
  & 0.10357874E-09_JPRB, 0.11967238E-09_JPRB, 0.13699231E-09_JPRB, 0.15566946E-09_JPRB, 0.17524671E-09_JPRB, 0.19532402E-09_JPRB, &
  & 0.21579710E-09_JPRB, 0.23649699E-09_JPRB, 0.25742977E-09_JPRB, 0.27870767E-09_JPRB, 0.30073813E-09_JPRB, 0.32452263E-09_JPRB, &
  & 0.35208286E-09_JPRB, 0.38636647E-09_JPRB, 0.42881432E-09_JPRB, 0.46622584E-09_JPRB, 0.49352322E-09_JPRB, 0.51502858E-09_JPRB, &
  & 0.53426752E-09_JPRB, 0.55379668E-09_JPRB, 0.57560628E-09_JPRB, 0.60787558E-09_JPRB /)

RGHG4(:,36, 5) = (/ &
  & 0.97553812E-12_JPRB, 0.19587853E-11_JPRB, 0.29939434E-11_JPRB, 0.45911057E-11_JPRB, 0.84529207E-11_JPRB, 0.14650116E-10_JPRB, &
  & 0.26093430E-10_JPRB, 0.48701227E-10_JPRB, 0.61697362E-10_JPRB, 0.84323618E-10_JPRB, 0.10644461E-09_JPRB, 0.12707073E-09_JPRB, &
  & 0.14215087E-09_JPRB, 0.15207405E-09_JPRB, 0.15485398E-09_JPRB, 0.15083738E-09_JPRB, 0.14101946E-09_JPRB, 0.12674693E-09_JPRB, &
  & 0.10979537E-09_JPRB, 0.91820898E-10_JPRB, 0.74546841E-10_JPRB, 0.59251062E-10_JPRB, 0.46543561E-10_JPRB, 0.36814957E-10_JPRB, &
  & 0.29559289E-10_JPRB, 0.24633512E-10_JPRB, 0.21150009E-10_JPRB, 0.19015317E-10_JPRB, 0.17578725E-10_JPRB, 0.16807784E-10_JPRB, &
  & 0.16472495E-10_JPRB, 0.16518373E-10_JPRB, 0.17051574E-10_JPRB, 0.18190918E-10_JPRB, 0.20144070E-10_JPRB, 0.22992573E-10_JPRB, &
  & 0.27020599E-10_JPRB, 0.32176678E-10_JPRB, 0.38473884E-10_JPRB, 0.46226040E-10_JPRB, 0.55758061E-10_JPRB, 0.66893567E-10_JPRB, &
  & 0.79687541E-10_JPRB, 0.93824622E-10_JPRB, 0.10927245E-09_JPRB, 0.12598317E-09_JPRB, 0.14373952E-09_JPRB, 0.16221924E-09_JPRB, &
  & 0.18123077E-09_JPRB, 0.20060606E-09_JPRB, 0.22031155E-09_JPRB, 0.24034305E-09_JPRB, 0.26101199E-09_JPRB, 0.28323741E-09_JPRB, &
  & 0.30881514E-09_JPRB, 0.34028808E-09_JPRB, 0.37887657E-09_JPRB, 0.41340104E-09_JPRB, 0.43922591E-09_JPRB, 0.45977278E-09_JPRB, &
  & 0.47812387E-09_JPRB, 0.49668808E-09_JPRB, 0.51753157E-09_JPRB, 0.54882060E-09_JPRB /)

RGHG4(:,37, 5) = (/ &
  & 0.85138255E-12_JPRB, 0.16932946E-11_JPRB, 0.29113450E-11_JPRB, 0.48534904E-11_JPRB, 0.78412303E-11_JPRB, 0.13906428E-10_JPRB, &
  & 0.24696958E-10_JPRB, 0.44582105E-10_JPRB, 0.55306686E-10_JPRB, 0.75066543E-10_JPRB, 0.94504557E-10_JPRB, 0.11283643E-09_JPRB, &
  & 0.12632423E-09_JPRB, 0.13491827E-09_JPRB, 0.13712377E-09_JPRB, 0.13316395E-09_JPRB, 0.12361072E-09_JPRB, 0.10957019E-09_JPRB, &
  & 0.92885644E-10_JPRB, 0.75354382E-10_JPRB, 0.58575478E-10_JPRB, 0.44103821E-10_JPRB, 0.32555878E-10_JPRB, 0.24214134E-10_JPRB, &
  & 0.18338074E-10_JPRB, 0.14506588E-10_JPRB, 0.11971508E-10_JPRB, 0.10440692E-10_JPRB, 0.95080775E-11_JPRB, 0.90879396E-11_JPRB, &
  & 0.90192801E-11_JPRB, 0.92789856E-11_JPRB, 0.98644252E-11_JPRB, 0.10874919E-10_JPRB, 0.12376967E-10_JPRB, 0.14482583E-10_JPRB, &
  & 0.17209317E-10_JPRB, 0.20793358E-10_JPRB, 0.25495382E-10_JPRB, 0.31419027E-10_JPRB, 0.39099033E-10_JPRB, 0.48658032E-10_JPRB, &
  & 0.59937041E-10_JPRB, 0.72634405E-10_JPRB, 0.86559482E-10_JPRB, 0.10173933E-09_JPRB, 0.11797523E-09_JPRB, 0.13500874E-09_JPRB, &
  & 0.15269672E-09_JPRB, 0.17085515E-09_JPRB, 0.18930540E-09_JPRB, 0.20804018E-09_JPRB, 0.22727385E-09_JPRB, 0.24785848E-09_JPRB, &
  & 0.27143726E-09_JPRB, 0.30033792E-09_JPRB, 0.33540179E-09_JPRB, 0.36700382E-09_JPRB, 0.39093284E-09_JPRB, 0.41012169E-09_JPRB, &
  & 0.42740608E-09_JPRB, 0.44484796E-09_JPRB, 0.46435017E-09_JPRB, 0.49390364E-09_JPRB /)

RGHG4(:,38, 5) = (/ &
  & 0.84702449E-12_JPRB, 0.16279359E-11_JPRB, 0.26814410E-11_JPRB, 0.44466765E-11_JPRB, 0.76973228E-11_JPRB, 0.13097262E-10_JPRB, &
  & 0.23017461E-10_JPRB, 0.41262549E-10_JPRB, 0.49920242E-10_JPRB, 0.67159223E-10_JPRB, 0.84187074E-10_JPRB, 0.10008764E-09_JPRB, &
  & 0.11197369E-09_JPRB, 0.11960635E-09_JPRB, 0.12136241E-09_JPRB, 0.11737135E-09_JPRB, 0.10833345E-09_JPRB, 0.94943213E-10_JPRB, &
  & 0.78726199E-10_JPRB, 0.61751985E-10_JPRB, 0.45856444E-10_JPRB, 0.32605103E-10_JPRB, 0.22590383E-10_JPRB, 0.15822147E-10_JPRB, &
  & 0.11484818E-10_JPRB, 0.87384353E-11_JPRB, 0.70737079E-11_JPRB, 0.60385043E-11_JPRB, 0.54833256E-11_JPRB, 0.52296154E-11_JPRB, &
  & 0.52326776E-11_JPRB, 0.54943901E-11_JPRB, 0.59434393E-11_JPRB, 0.66961289E-11_JPRB, 0.77468813E-11_JPRB, 0.91779752E-11_JPRB, &
  & 0.11049354E-10_JPRB, 0.13432367E-10_JPRB, 0.16697397E-10_JPRB, 0.21137564E-10_JPRB, 0.27077852E-10_JPRB, 0.34864878E-10_JPRB, &
  & 0.44585492E-10_JPRB, 0.55925879E-10_JPRB, 0.68520870E-10_JPRB, 0.82289744E-10_JPRB, 0.97116773E-10_JPRB, 0.11285531E-09_JPRB, &
  & 0.12935372E-09_JPRB, 0.14639012E-09_JPRB, 0.16374080E-09_JPRB, 0.18128825E-09_JPRB, 0.19919924E-09_JPRB, 0.21824589E-09_JPRB, &
  & 0.23995203E-09_JPRB, 0.26628222E-09_JPRB, 0.29786523E-09_JPRB, 0.32657918E-09_JPRB, 0.34867495E-09_JPRB, 0.36651501E-09_JPRB, &
  & 0.38249248E-09_JPRB, 0.39849649E-09_JPRB, 0.41647141E-09_JPRB, 0.44416015E-09_JPRB /)

RGHG4(:,39, 5) = (/ &
  & 0.79761707E-12_JPRB, 0.15562397E-11_JPRB, 0.25197659E-11_JPRB, 0.43001579E-11_JPRB, 0.74707801E-11_JPRB, 0.12741743E-10_JPRB, &
  & 0.22076188E-10_JPRB, 0.38466341E-10_JPRB, 0.45168529E-10_JPRB, 0.59967635E-10_JPRB, 0.74694348E-10_JPRB, 0.88486649E-10_JPRB, &
  & 0.98879460E-10_JPRB, 0.10546006E-09_JPRB, 0.10691013E-09_JPRB, 0.10313290E-09_JPRB, 0.94598197E-10_JPRB, 0.81949503E-10_JPRB, &
  & 0.66676525E-10_JPRB, 0.50563671E-10_JPRB, 0.35914955E-10_JPRB, 0.24334968E-10_JPRB, 0.16173885E-10_JPRB, 0.10891591E-10_JPRB, &
  & 0.77813337E-11_JPRB, 0.58593404E-11_JPRB, 0.47447285E-11_JPRB, 0.40396783E-11_JPRB, 0.36801699E-11_JPRB, 0.35151799E-11_JPRB, &
  & 0.35334459E-11_JPRB, 0.37355635E-11_JPRB, 0.40833396E-11_JPRB, 0.46350202E-11_JPRB, 0.53688217E-11_JPRB, 0.63709554E-11_JPRB, &
  & 0.76502658E-11_JPRB, 0.93388604E-11_JPRB, 0.11564126E-10_JPRB, 0.14745788E-10_JPRB, 0.19214873E-10_JPRB, 0.25318695E-10_JPRB, &
  & 0.33244088E-10_JPRB, 0.42901158E-10_JPRB, 0.54103021E-10_JPRB, 0.66493817E-10_JPRB, 0.80023606E-10_JPRB, 0.94525325E-10_JPRB, &
  & 0.10989303E-09_JPRB, 0.12589867E-09_JPRB, 0.14218855E-09_JPRB, 0.15855893E-09_JPRB, 0.17515883E-09_JPRB, 0.19270763E-09_JPRB, &
  & 0.21256774E-09_JPRB, 0.23640498E-09_JPRB, 0.26490052E-09_JPRB, 0.29094305E-09_JPRB, 0.31109504E-09_JPRB, 0.32737624E-09_JPRB, &
  & 0.34199749E-09_JPRB, 0.35660894E-09_JPRB, 0.37303768E-09_JPRB, 0.39822279E-09_JPRB /)

RGHG4(:,40, 5) = (/ &
  & 0.78445865E-12_JPRB, 0.14646928E-11_JPRB, 0.25358860E-11_JPRB, 0.39192855E-11_JPRB, 0.71718048E-11_JPRB, 0.12173825E-10_JPRB, &
  & 0.21153666E-10_JPRB, 0.36097635E-10_JPRB, 0.40881184E-10_JPRB, 0.53461777E-10_JPRB, 0.66130802E-10_JPRB, 0.77978027E-10_JPRB, &
  & 0.87035282E-10_JPRB, 0.92701069E-10_JPRB, 0.93828556E-10_JPRB, 0.90315866E-10_JPRB, 0.82470225E-10_JPRB, 0.70710306E-10_JPRB, &
  & 0.56449470E-10_JPRB, 0.41816769E-10_JPRB, 0.28632516E-10_JPRB, 0.18766266E-10_JPRB, 0.12274393E-10_JPRB, 0.82013346E-11_JPRB, &
  & 0.58591279E-11_JPRB, 0.44545843E-11_JPRB, 0.36350779E-11_JPRB, 0.31221594E-11_JPRB, 0.28541887E-11_JPRB, 0.27285637E-11_JPRB, &
  & 0.27674751E-11_JPRB, 0.28990742E-11_JPRB, 0.32104517E-11_JPRB, 0.36280581E-11_JPRB, 0.42045972E-11_JPRB, 0.49582630E-11_JPRB, &
  & 0.59170260E-11_JPRB, 0.71581239E-11_JPRB, 0.88039402E-11_JPRB, 0.11069016E-10_JPRB, 0.14351841E-10_JPRB, 0.18965494E-10_JPRB, &
  & 0.25215972E-10_JPRB, 0.33129628E-10_JPRB, 0.42604503E-10_JPRB, 0.53545137E-10_JPRB, 0.65707814E-10_JPRB, 0.79024808E-10_JPRB, &
  & 0.93311206E-10_JPRB, 0.10835570E-09_JPRB, 0.12371214E-09_JPRB, 0.13906121E-09_JPRB, 0.15450162E-09_JPRB, 0.17064010E-09_JPRB, &
  & 0.18877420E-09_JPRB, 0.21038160E-09_JPRB, 0.23588098E-09_JPRB, 0.25923336E-09_JPRB, 0.27747038E-09_JPRB, 0.29228561E-09_JPRB, &
  & 0.30550906E-09_JPRB, 0.31866249E-09_JPRB, 0.33346281E-09_JPRB, 0.35643127E-09_JPRB /)

RGHG4(:,41, 5) = (/ &
  & 0.78470368E-12_JPRB, 0.13990010E-11_JPRB, 0.23315388E-11_JPRB, 0.36946427E-11_JPRB, 0.67546511E-11_JPRB, 0.11633075E-10_JPRB, &
  & 0.20171753E-10_JPRB, 0.33761067E-10_JPRB, 0.36855522E-10_JPRB, 0.47474899E-10_JPRB, 0.58140392E-10_JPRB, 0.68263152E-10_JPRB, &
  & 0.76081842E-10_JPRB, 0.81013231E-10_JPRB, 0.81946706E-10_JPRB, 0.78739952E-10_JPRB, 0.71644420E-10_JPRB, 0.61055501E-10_JPRB, &
  & 0.48120702E-10_JPRB, 0.34924841E-10_JPRB, 0.23622356E-10_JPRB, 0.15183322E-10_JPRB, 0.99140461E-11_JPRB, 0.67066882E-11_JPRB, &
  & 0.48438558E-11_JPRB, 0.37395208E-11_JPRB, 0.30839381E-11_JPRB, 0.26733091E-11_JPRB, 0.24560300E-11_JPRB, 0.23469829E-11_JPRB, &
  & 0.23886052E-11_JPRB, 0.24935921E-11_JPRB, 0.27637183E-11_JPRB, 0.31203371E-11_JPRB, 0.36123869E-11_JPRB, 0.42266923E-11_JPRB, &
  & 0.50169751E-11_JPRB, 0.60032990E-11_JPRB, 0.72805607E-11_JPRB, 0.90192341E-11_JPRB, 0.11439151E-10_JPRB, 0.14831700E-10_JPRB, &
  & 0.19553109E-10_JPRB, 0.25793314E-10_JPRB, 0.33590918E-10_JPRB, 0.42895004E-10_JPRB, 0.53669923E-10_JPRB, 0.65726327E-10_JPRB, &
  & 0.78903876E-10_JPRB, 0.92992773E-10_JPRB, 0.10744157E-09_JPRB, 0.12177019E-09_JPRB, 0.13601059E-09_JPRB, 0.15078964E-09_JPRB, &
  & 0.16730006E-09_JPRB, 0.18674423E-09_JPRB, 0.20957158E-09_JPRB, 0.23050431E-09_JPRB, 0.24690847E-09_JPRB, 0.26020563E-09_JPRB, &
  & 0.27211403E-09_JPRB, 0.28394667E-09_JPRB, 0.29733799E-09_JPRB, 0.31806202E-09_JPRB /)

RGHG4(:,42, 5) = (/ &
  & 0.78724939E-12_JPRB, 0.13555958E-11_JPRB, 0.22500743E-11_JPRB, 0.35700392E-11_JPRB, 0.67033041E-11_JPRB, 0.11688037E-10_JPRB, &
  & 0.19794298E-10_JPRB, 0.32207442E-10_JPRB, 0.33501230E-10_JPRB, 0.42185141E-10_JPRB, 0.51066543E-10_JPRB, 0.59588480E-10_JPRB, &
  & 0.66264980E-10_JPRB, 0.70471316E-10_JPRB, 0.71225574E-10_JPRB, 0.68340791E-10_JPRB, 0.61981177E-10_JPRB, 0.52528600E-10_JPRB, &
  & 0.41080781E-10_JPRB, 0.29448357E-10_JPRB, 0.19716234E-10_JPRB, 0.12720069E-10_JPRB, 0.83241461E-11_JPRB, 0.57384960E-11_JPRB, &
  & 0.42116996E-11_JPRB, 0.32987374E-11_JPRB, 0.27509707E-11_JPRB, 0.24037489E-11_JPRB, 0.22156276E-11_JPRB, 0.21238187E-11_JPRB, &
  & 0.21466388E-11_JPRB, 0.22596593E-11_JPRB, 0.24715362E-11_JPRB, 0.28101189E-11_JPRB, 0.32339604E-11_JPRB, 0.37650031E-11_JPRB, &
  & 0.44396709E-11_JPRB, 0.52666595E-11_JPRB, 0.62957686E-11_JPRB, 0.76824918E-11_JPRB, 0.95185500E-11_JPRB, 0.12062719E-10_JPRB, &
  & 0.15489606E-10_JPRB, 0.20109567E-10_JPRB, 0.26242952E-10_JPRB, 0.33868488E-10_JPRB, 0.43116000E-10_JPRB, 0.53892227E-10_JPRB, &
  & 0.65937679E-10_JPRB, 0.79045777E-10_JPRB, 0.92623728E-10_JPRB, 0.10599750E-09_JPRB, 0.11915913E-09_JPRB, 0.13264947E-09_JPRB, &
  & 0.14754194E-09_JPRB, 0.16495075E-09_JPRB, 0.18521820E-09_JPRB, 0.20375122E-09_JPRB, 0.21837665E-09_JPRB, 0.23030490E-09_JPRB, &
  & 0.24097618E-09_JPRB, 0.25151661E-09_JPRB, 0.26348326E-09_JPRB, 0.28231073E-09_JPRB /)

RGHG4(:,43, 5) = (/ &
  & 0.82027733E-12_JPRB, 0.13550813E-11_JPRB, 0.20524455E-11_JPRB, 0.35087382E-11_JPRB, 0.64283366E-11_JPRB, 0.11492396E-10_JPRB, &
  & 0.19306313E-10_JPRB, 0.30602472E-10_JPRB, 0.30267722E-10_JPRB, 0.37308448E-10_JPRB, 0.44541478E-10_JPRB, 0.51584941E-10_JPRB, &
  & 0.57240403E-10_JPRB, 0.60854669E-10_JPRB, 0.61433809E-10_JPRB, 0.58837976E-10_JPRB, 0.53227700E-10_JPRB, 0.44929459E-10_JPRB, &
  & 0.35005061E-10_JPRB, 0.24985418E-10_JPRB, 0.16740973E-10_JPRB, 0.10901559E-10_JPRB, 0.72434580E-11_JPRB, 0.50753737E-11_JPRB, &
  & 0.38025139E-11_JPRB, 0.30195028E-11_JPRB, 0.25436884E-11_JPRB, 0.22383883E-11_JPRB, 0.20653906E-11_JPRB, 0.19857217E-11_JPRB, &
  & 0.19945636E-11_JPRB, 0.21057669E-11_JPRB, 0.22858991E-11_JPRB, 0.26017556E-11_JPRB, 0.29820922E-11_JPRB, 0.34579442E-11_JPRB, &
  & 0.40562783E-11_JPRB, 0.47741811E-11_JPRB, 0.56565451E-11_JPRB, 0.67872786E-11_JPRB, 0.82292471E-11_JPRB, 0.10143862E-10_JPRB, &
  & 0.12611735E-10_JPRB, 0.15917481E-10_JPRB, 0.20358909E-10_JPRB, 0.26279999E-10_JPRB, 0.33867225E-10_JPRB, 0.43145341E-10_JPRB, &
  & 0.53912010E-10_JPRB, 0.65907807E-10_JPRB, 0.78440421E-10_JPRB, 0.90770544E-10_JPRB, 0.10273082E-09_JPRB, 0.11485375E-09_JPRB, &
  & 0.12815254E-09_JPRB, 0.14351235E-09_JPRB, 0.16121318E-09_JPRB, 0.17745101E-09_JPRB, 0.19042158E-09_JPRB, 0.20104585E-09_JPRB, &
  & 0.21059696E-09_JPRB, 0.22006348E-09_JPRB, 0.23091634E-09_JPRB, 0.24807109E-09_JPRB /)

RGHG4(:,44, 5) = (/ &
  & 0.89489250E-12_JPRB, 0.14160095E-11_JPRB, 0.22247852E-11_JPRB, 0.34889121E-11_JPRB, 0.64311560E-11_JPRB, 0.11558245E-10_JPRB, &
  & 0.19015244E-10_JPRB, 0.29340485E-10_JPRB, 0.27385110E-10_JPRB, 0.32921485E-10_JPRB, 0.38644671E-10_JPRB, 0.44395550E-10_JPRB, &
  & 0.49056672E-10_JPRB, 0.52069054E-10_JPRB, 0.52480329E-10_JPRB, 0.50111422E-10_JPRB, 0.45137557E-10_JPRB, 0.37935818E-10_JPRB, &
  & 0.29470218E-10_JPRB, 0.21121440E-10_JPRB, 0.14249083E-10_JPRB, 0.94459640E-11_JPRB, 0.64097954E-11_JPRB, 0.45814351E-11_JPRB, &
  & 0.34995654E-11_JPRB, 0.28184514E-11_JPRB, 0.23948738E-11_JPRB, 0.21187464E-11_JPRB, 0.19581997E-11_JPRB, 0.18796982E-11_JPRB, &
  & 0.18870977E-11_JPRB, 0.19782279E-11_JPRB, 0.21522983E-11_JPRB, 0.24274916E-11_JPRB, 0.27903302E-11_JPRB, 0.32156784E-11_JPRB, &
  & 0.37640867E-11_JPRB, 0.44080937E-11_JPRB, 0.51778438E-11_JPRB, 0.61188138E-11_JPRB, 0.72676240E-11_JPRB, 0.86893010E-11_JPRB, &
  & 0.10425640E-10_JPRB, 0.12676470E-10_JPRB, 0.15699832E-10_JPRB, 0.19909812E-10_JPRB, 0.25701741E-10_JPRB, 0.33328614E-10_JPRB, &
  & 0.42687357E-10_JPRB, 0.53480907E-10_JPRB, 0.64904533E-10_JPRB, 0.76093847E-10_JPRB, 0.86875528E-10_JPRB, 0.97610448E-10_JPRB, &
  & 0.10923875E-09_JPRB, 0.12245356E-09_JPRB, 0.13754792E-09_JPRB, 0.15144697E-09_JPRB, 0.16276086E-09_JPRB, 0.17218169E-09_JPRB, &
  & 0.18067801E-09_JPRB, 0.18907656E-09_JPRB, 0.19875612E-09_JPRB, 0.21448719E-09_JPRB /)

RGHG4(:,45, 5) = (/ &
  & 0.10012048E-11_JPRB, 0.15372001E-11_JPRB, 0.23121878E-11_JPRB, 0.35697634E-11_JPRB, 0.65436567E-11_JPRB, 0.11553355E-10_JPRB, &
  & 0.18843736E-10_JPRB, 0.28107447E-10_JPRB, 0.24696687E-10_JPRB, 0.28871947E-10_JPRB, 0.33264305E-10_JPRB, 0.37712892E-10_JPRB, &
  & 0.41506115E-10_JPRB, 0.43880014E-10_JPRB, 0.44085201E-10_JPRB, 0.41853142E-10_JPRB, 0.37477053E-10_JPRB, 0.31332943E-10_JPRB, &
  & 0.24386198E-10_JPRB, 0.17622719E-10_JPRB, 0.12149953E-10_JPRB, 0.82306488E-11_JPRB, 0.57368966E-11_JPRB, 0.41890762E-11_JPRB, &
  & 0.32573970E-11_JPRB, 0.26607761E-11_JPRB, 0.22791981E-11_JPRB, 0.20231065E-11_JPRB, 0.18745639E-11_JPRB, 0.17924236E-11_JPRB, &
  & 0.18010838E-11_JPRB, 0.18703452E-11_JPRB, 0.20414113E-11_JPRB, 0.22757408E-11_JPRB, 0.26278407E-11_JPRB, 0.30057673E-11_JPRB, &
  & 0.35169938E-11_JPRB, 0.41050700E-11_JPRB, 0.47882575E-11_JPRB, 0.55961629E-11_JPRB, 0.65230065E-11_JPRB, 0.75754680E-11_JPRB, &
  & 0.87679265E-11_JPRB, 0.10231465E-10_JPRB, 0.12141814E-10_JPRB, 0.14881854E-10_JPRB, 0.18933194E-10_JPRB, 0.24729293E-10_JPRB, &
  & 0.32477160E-10_JPRB, 0.41857431E-10_JPRB, 0.51982547E-10_JPRB, 0.61953234E-10_JPRB, 0.71344070E-10_JPRB, 0.80598389E-10_JPRB, &
  & 0.90442182E-10_JPRB, 0.10148354E-09_JPRB, 0.11392980E-09_JPRB, 0.12547381E-09_JPRB, 0.13514133E-09_JPRB, 0.14328821E-09_JPRB, &
  & 0.15068709E-09_JPRB, 0.15801767E-09_JPRB, 0.16659694E-09_JPRB, 0.18089190E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART10',0,ZHOOK_HANDLE)



RGHG4(:,46, 5) = (/ &
  & 0.11182005E-11_JPRB, 0.16586367E-11_JPRB, 0.25053308E-11_JPRB, 0.36341965E-11_JPRB, 0.66943265E-11_JPRB, 0.11574507E-10_JPRB, &
  & 0.18494432E-10_JPRB, 0.26762459E-10_JPRB, 0.21986876E-10_JPRB, 0.25038312E-10_JPRB, 0.28242084E-10_JPRB, 0.31603734E-10_JPRB, &
  & 0.34448069E-10_JPRB, 0.36215718E-10_JPRB, 0.36127830E-10_JPRB, 0.33962100E-10_JPRB, 0.30119716E-10_JPRB, 0.25080582E-10_JPRB, &
  & 0.19645518E-10_JPRB, 0.14549721E-10_JPRB, 0.10318801E-10_JPRB, 0.72329005E-11_JPRB, 0.51831994E-11_JPRB, 0.38801163E-11_JPRB, &
  & 0.30692998E-11_JPRB, 0.25390386E-11_JPRB, 0.21912463E-11_JPRB, 0.19483826E-11_JPRB, 0.18081481E-11_JPRB, 0.17216652E-11_JPRB, &
  & 0.17286332E-11_JPRB, 0.17814503E-11_JPRB, 0.19414104E-11_JPRB, 0.21485990E-11_JPRB, 0.24831426E-11_JPRB, 0.28297215E-11_JPRB, &
  & 0.33160044E-11_JPRB, 0.38718685E-11_JPRB, 0.44867274E-11_JPRB, 0.52019435E-11_JPRB, 0.59497810E-11_JPRB, 0.67370788E-11_JPRB, &
  & 0.75493561E-11_JPRB, 0.84489369E-11_JPRB, 0.95875547E-11_JPRB, 0.11242696E-10_JPRB, 0.13814977E-10_JPRB, 0.17838984E-10_JPRB, &
  & 0.23682518E-10_JPRB, 0.31353153E-10_JPRB, 0.40010568E-10_JPRB, 0.48508485E-10_JPRB, 0.56552416E-10_JPRB, 0.64159351E-10_JPRB, &
  & 0.72201210E-10_JPRB, 0.80914934E-10_JPRB, 0.90689345E-10_JPRB, 0.99798114E-10_JPRB, 0.10766417E-09_JPRB, 0.11445746E-09_JPRB, &
  & 0.12065671E-09_JPRB, 0.12684390E-09_JPRB, 0.13419126E-09_JPRB, 0.14693509E-09_JPRB /)

RGHG4(:,47, 5) = (/ &
  & 0.12290054E-11_JPRB, 0.17789483E-11_JPRB, 0.25556822E-11_JPRB, 0.37435905E-11_JPRB, 0.66143358E-11_JPRB, 0.11346332E-10_JPRB, &
  & 0.17654121E-10_JPRB, 0.24987307E-10_JPRB, 0.19099892E-10_JPRB, 0.21152137E-10_JPRB, 0.23383368E-10_JPRB, 0.25690335E-10_JPRB, &
  & 0.27698890E-10_JPRB, 0.28779311E-10_JPRB, 0.28324938E-10_JPRB, 0.26237955E-10_JPRB, 0.23011794E-10_JPRB, 0.19200848E-10_JPRB, &
  & 0.15366779E-10_JPRB, 0.11793776E-10_JPRB, 0.87546845E-11_JPRB, 0.63693603E-11_JPRB, 0.47146683E-11_JPRB, 0.36157115E-11_JPRB, &
  & 0.29100914E-11_JPRB, 0.24339411E-11_JPRB, 0.21155766E-11_JPRB, 0.18829764E-11_JPRB, 0.17493834E-11_JPRB, 0.16580948E-11_JPRB, &
  & 0.16627323E-11_JPRB, 0.17016965E-11_JPRB, 0.18454513E-11_JPRB, 0.20367724E-11_JPRB, 0.23429459E-11_JPRB, 0.26694924E-11_JPRB, &
  & 0.31322380E-11_JPRB, 0.36538836E-11_JPRB, 0.42167780E-11_JPRB, 0.48565535E-11_JPRB, 0.54668436E-11_JPRB, 0.60624747E-11_JPRB, &
  & 0.65929120E-11_JPRB, 0.71251503E-11_JPRB, 0.77483905E-11_JPRB, 0.86796950E-11_JPRB, 0.10193167E-10_JPRB, 0.12689133E-10_JPRB, &
  & 0.16655816E-10_JPRB, 0.22372057E-10_JPRB, 0.29265888E-10_JPRB, 0.36336555E-10_JPRB, 0.42860590E-10_JPRB, 0.49041320E-10_JPRB, &
  & 0.55331340E-10_JPRB, 0.62104981E-10_JPRB, 0.69606113E-10_JPRB, 0.76570729E-10_JPRB, 0.82763567E-10_JPRB, 0.88209266E-10_JPRB, &
  & 0.93189248E-10_JPRB, 0.98168584E-10_JPRB, 0.10416821E-09_JPRB, 0.11489389E-09_JPRB /)

RGHG4(:,48, 5) = (/ &
  & 0.13241128E-11_JPRB, 0.18301990E-11_JPRB, 0.26318973E-11_JPRB, 0.37126248E-11_JPRB, 0.62806865E-11_JPRB, 0.10739522E-10_JPRB, &
  & 0.16187808E-10_JPRB, 0.22364411E-10_JPRB, 0.15821741E-10_JPRB, 0.17116322E-10_JPRB, 0.18491651E-10_JPRB, 0.19969233E-10_JPRB, &
  & 0.21146144E-10_JPRB, 0.21620691E-10_JPRB, 0.20916529E-10_JPRB, 0.19066889E-10_JPRB, 0.16714850E-10_JPRB, 0.14192606E-10_JPRB, &
  & 0.11821330E-10_JPRB, 0.95551076E-11_JPRB, 0.74666081E-11_JPRB, 0.56786199E-11_JPRB, 0.43399078E-11_JPRB, 0.34075293E-11_JPRB, &
  & 0.27881562E-11_JPRB, 0.23536657E-11_JPRB, 0.20573647E-11_JPRB, 0.18319278E-11_JPRB, 0.17032143E-11_JPRB, 0.16069328E-11_JPRB, &
  & 0.16103278E-11_JPRB, 0.16332036E-11_JPRB, 0.17649672E-11_JPRB, 0.19436087E-11_JPRB, 0.22182135E-11_JPRB, 0.25378534E-11_JPRB, &
  & 0.29796964E-11_JPRB, 0.34821638E-11_JPRB, 0.40073383E-11_JPRB, 0.45851322E-11_JPRB, 0.50912104E-11_JPRB, 0.55445843E-11_JPRB, &
  & 0.58929502E-11_JPRB, 0.61862408E-11_JPRB, 0.65130475E-11_JPRB, 0.70162686E-11_JPRB, 0.78550118E-11_JPRB, 0.93035180E-11_JPRB, &
  & 0.11720381E-10_JPRB, 0.15447924E-10_JPRB, 0.20387985E-10_JPRB, 0.25708317E-10_JPRB, 0.30799557E-10_JPRB, 0.35538329E-10_JPRB, &
  & 0.40409953E-10_JPRB, 0.45438080E-10_JPRB, 0.51155351E-10_JPRB, 0.56317277E-10_JPRB, 0.61016213E-10_JPRB, 0.65179681E-10_JPRB, &
  & 0.69005628E-10_JPRB, 0.72869606E-10_JPRB, 0.77646216E-10_JPRB, 0.86454621E-10_JPRB /)

RGHG4(:,49, 5) = (/ &
  & 0.13994439E-11_JPRB, 0.18086430E-11_JPRB, 0.25215648E-11_JPRB, 0.35356913E-11_JPRB, 0.57205720E-11_JPRB, 0.95225321E-11_JPRB, &
  & 0.14003827E-10_JPRB, 0.18840105E-10_JPRB, 0.12119020E-10_JPRB, 0.12751562E-10_JPRB, 0.13446506E-10_JPRB, 0.14220321E-10_JPRB, &
  & 0.14777153E-10_JPRB, 0.14861570E-10_JPRB, 0.14190080E-10_JPRB, 0.12978170E-10_JPRB, 0.11605433E-10_JPRB, 0.10293441E-10_JPRB, &
  & 0.90432141E-11_JPRB, 0.77718309E-11_JPRB, 0.64171997E-11_JPRB, 0.51105374E-11_JPRB, 0.40331770E-11_JPRB, 0.32362784E-11_JPRB, &
  & 0.26867683E-11_JPRB, 0.22877631E-11_JPRB, 0.20089178E-11_JPRB, 0.17900323E-11_JPRB, 0.16635713E-11_JPRB, 0.15649049E-11_JPRB, &
  & 0.15640436E-11_JPRB, 0.15739561E-11_JPRB, 0.16975835E-11_JPRB, 0.18588826E-11_JPRB, 0.21064602E-11_JPRB, 0.24198315E-11_JPRB, &
  & 0.28382791E-11_JPRB, 0.33176118E-11_JPRB, 0.38155633E-11_JPRB, 0.43405943E-11_JPRB, 0.47706435E-11_JPRB, 0.51165487E-11_JPRB, &
  & 0.53312021E-11_JPRB, 0.54792013E-11_JPRB, 0.56238538E-11_JPRB, 0.58790737E-11_JPRB, 0.63220310E-11_JPRB, 0.71256824E-11_JPRB, &
  & 0.84684430E-11_JPRB, 0.10638383E-10_JPRB, 0.13607834E-10_JPRB, 0.17026011E-10_JPRB, 0.20503866E-10_JPRB, 0.23815692E-10_JPRB, &
  & 0.27307986E-10_JPRB, 0.30977741E-10_JPRB, 0.35339842E-10_JPRB, 0.39096216E-10_JPRB, 0.42561323E-10_JPRB, 0.45627096E-10_JPRB, &
  & 0.48477156E-10_JPRB, 0.51361589E-10_JPRB, 0.55014982E-10_JPRB, 0.62008919E-10_JPRB /)

RGHG4(:,50, 5) = (/ &
  & 0.14046683E-11_JPRB, 0.17376329E-11_JPRB, 0.23697901E-11_JPRB, 0.32572929E-11_JPRB, 0.49697017E-11_JPRB, 0.79144503E-11_JPRB, &
  & 0.11282055E-10_JPRB, 0.14618591E-10_JPRB, 0.84436165E-11_JPRB, 0.86116383E-11_JPRB, 0.89355459E-11_JPRB, 0.92651806E-11_JPRB, &
  & 0.95405272E-11_JPRB, 0.95652297E-11_JPRB, 0.92996565E-11_JPRB, 0.87459753E-11_JPRB, 0.81981956E-11_JPRB, 0.76418602E-11_JPRB, &
  & 0.70956752E-11_JPRB, 0.64291216E-11_JPRB, 0.56105806E-11_JPRB, 0.46638136E-11_JPRB, 0.37964115E-11_JPRB, 0.31059489E-11_JPRB, &
  & 0.26096191E-11_JPRB, 0.22380015E-11_JPRB, 0.19720729E-11_JPRB, 0.17603257E-11_JPRB, 0.16352370E-11_JPRB, 0.15397810E-11_JPRB, &
  & 0.15296652E-11_JPRB, 0.15359468E-11_JPRB, 0.16464319E-11_JPRB, 0.17911687E-11_JPRB, 0.20196568E-11_JPRB, 0.23253096E-11_JPRB, &
  & 0.27252851E-11_JPRB, 0.31804986E-11_JPRB, 0.36561683E-11_JPRB, 0.41317384E-11_JPRB, 0.45039580E-11_JPRB, 0.47658310E-11_JPRB, &
  & 0.48942256E-11_JPRB, 0.49470198E-11_JPRB, 0.49943374E-11_JPRB, 0.51092147E-11_JPRB, 0.53442988E-11_JPRB, 0.57743532E-11_JPRB, &
  & 0.65139591E-11_JPRB, 0.76666703E-11_JPRB, 0.92320812E-11_JPRB, 0.11107977E-10_JPRB, 0.12974331E-10_JPRB, 0.15004139E-10_JPRB, &
  & 0.17164785E-10_JPRB, 0.19573275E-10_JPRB, 0.22808569E-10_JPRB, 0.25445297E-10_JPRB, 0.27899768E-10_JPRB, 0.30095679E-10_JPRB, &
  & 0.32159858E-10_JPRB, 0.34281515E-10_JPRB, 0.37032766E-10_JPRB, 0.42534636E-10_JPRB /)

RGHG4(:,51, 5) = (/ &
  & 0.13937073E-11_JPRB, 0.15737520E-11_JPRB, 0.21496654E-11_JPRB, 0.28200719E-11_JPRB, 0.42719955E-11_JPRB, 0.63533636E-11_JPRB, &
  & 0.86576493E-11_JPRB, 0.10887118E-10_JPRB, 0.55969296E-11_JPRB, 0.56303764E-11_JPRB, 0.57193386E-11_JPRB, 0.59415975E-11_JPRB, &
  & 0.61421844E-11_JPRB, 0.63099222E-11_JPRB, 0.63536737E-11_JPRB, 0.62587852E-11_JPRB, 0.61238241E-11_JPRB, 0.59651186E-11_JPRB, &
  & 0.57622527E-11_JPRB, 0.54638911E-11_JPRB, 0.49811032E-11_JPRB, 0.43224573E-11_JPRB, 0.36208209E-11_JPRB, 0.30142585E-11_JPRB, &
  & 0.25579541E-11_JPRB, 0.22080222E-11_JPRB, 0.19513182E-11_JPRB, 0.17469512E-11_JPRB, 0.16208883E-11_JPRB, 0.15307219E-11_JPRB, &
  & 0.15120135E-11_JPRB, 0.15186337E-11_JPRB, 0.16115537E-11_JPRB, 0.17457273E-11_JPRB, 0.19585032E-11_JPRB, 0.22511693E-11_JPRB, &
  & 0.26288088E-11_JPRB, 0.30646605E-11_JPRB, 0.35203158E-11_JPRB, 0.39571003E-11_JPRB, 0.42827716E-11_JPRB, 0.44806403E-11_JPRB, &
  & 0.45443805E-11_JPRB, 0.45431194E-11_JPRB, 0.45326776E-11_JPRB, 0.45778641E-11_JPRB, 0.46933343E-11_JPRB, 0.49304896E-11_JPRB, &
  & 0.53267083E-11_JPRB, 0.59340883E-11_JPRB, 0.67189158E-11_JPRB, 0.75632009E-11_JPRB, 0.84614633E-11_JPRB, 0.93788519E-11_JPRB, &
  & 0.10443430E-10_JPRB, 0.11659558E-10_JPRB, 0.13846897E-10_JPRB, 0.15372802E-10_JPRB, 0.16886820E-10_JPRB, 0.18250635E-10_JPRB, &
  & 0.19635195E-10_JPRB, 0.21059883E-10_JPRB, 0.23090866E-10_JPRB, 0.27282664E-10_JPRB /)

RGHG4(:,52, 5) = (/ &
  & 0.13385411E-11_JPRB, 0.14757661E-11_JPRB, 0.19328844E-11_JPRB, 0.25707149E-11_JPRB, 0.36546890E-11_JPRB, 0.51934806E-11_JPRB, &
  & 0.68023018E-11_JPRB, 0.82080983E-11_JPRB, 0.39487363E-11_JPRB, 0.38922784E-11_JPRB, 0.39749710E-11_JPRB, 0.40999378E-11_JPRB, &
  & 0.43241699E-11_JPRB, 0.45401395E-11_JPRB, 0.47405296E-11_JPRB, 0.48378888E-11_JPRB, 0.48896395E-11_JPRB, 0.48985707E-11_JPRB, &
  & 0.48652614E-11_JPRB, 0.47520755E-11_JPRB, 0.44974519E-11_JPRB, 0.40511500E-11_JPRB, 0.34905082E-11_JPRB, 0.29546461E-11_JPRB, &
  & 0.25287827E-11_JPRB, 0.21954535E-11_JPRB, 0.19465410E-11_JPRB, 0.17518474E-11_JPRB, 0.16275918E-11_JPRB, 0.15513154E-11_JPRB, &
  & 0.15253697E-11_JPRB, 0.15323776E-11_JPRB, 0.16103087E-11_JPRB, 0.17380527E-11_JPRB, 0.19373194E-11_JPRB, 0.22162875E-11_JPRB, &
  & 0.25769100E-11_JPRB, 0.29912147E-11_JPRB, 0.34239844E-11_JPRB, 0.38206656E-11_JPRB, 0.41015455E-11_JPRB, 0.42446689E-11_JPRB, &
  & 0.42614007E-11_JPRB, 0.42242043E-11_JPRB, 0.41825220E-11_JPRB, 0.41907727E-11_JPRB, 0.42460306E-11_JPRB, 0.43668840E-11_JPRB, &
  & 0.45874784E-11_JPRB, 0.49014647E-11_JPRB, 0.52720853E-11_JPRB, 0.56607163E-11_JPRB, 0.60165662E-11_JPRB, 0.64191924E-11_JPRB, &
  & 0.68259686E-11_JPRB, 0.73514675E-11_JPRB, 0.87559647E-11_JPRB, 0.94600473E-11_JPRB, 0.10181528E-10_JPRB, 0.10906951E-10_JPRB, &
  & 0.11652333E-10_JPRB, 0.12489992E-10_JPRB, 0.13712114E-10_JPRB, 0.16579290E-10_JPRB /)

RGHG4(:,53, 5) = (/ &
  & 0.12833788E-11_JPRB, 0.13852769E-11_JPRB, 0.18583351E-11_JPRB, 0.23283942E-11_JPRB, 0.33226375E-11_JPRB, 0.44471540E-11_JPRB, &
  & 0.56163546E-11_JPRB, 0.66380629E-11_JPRB, 0.30478484E-11_JPRB, 0.30164844E-11_JPRB, 0.30317773E-11_JPRB, 0.31573899E-11_JPRB, &
  & 0.33418752E-11_JPRB, 0.35894393E-11_JPRB, 0.38420278E-11_JPRB, 0.40208809E-11_JPRB, 0.41556485E-11_JPRB, 0.42396277E-11_JPRB, &
  & 0.42826858E-11_JPRB, 0.42662813E-11_JPRB, 0.41450988E-11_JPRB, 0.38511351E-11_JPRB, 0.34116386E-11_JPRB, 0.29337277E-11_JPRB, &
  & 0.25362997E-11_JPRB, 0.22144632E-11_JPRB, 0.19738087E-11_JPRB, 0.17859882E-11_JPRB, 0.16661129E-11_JPRB, 0.16001463E-11_JPRB, &
  & 0.15684454E-11_JPRB, 0.15760509E-11_JPRB, 0.16423702E-11_JPRB, 0.17647693E-11_JPRB, 0.19507054E-11_JPRB, 0.22141757E-11_JPRB, &
  & 0.25588308E-11_JPRB, 0.29575077E-11_JPRB, 0.33734031E-11_JPRB, 0.37359187E-11_JPRB, 0.39712508E-11_JPRB, 0.40739716E-11_JPRB, &
  & 0.40528371E-11_JPRB, 0.39931804E-11_JPRB, 0.39338251E-11_JPRB, 0.39221599E-11_JPRB, 0.39421929E-11_JPRB, 0.40110124E-11_JPRB, &
  & 0.41308437E-11_JPRB, 0.42973910E-11_JPRB, 0.44777281E-11_JPRB, 0.46338094E-11_JPRB, 0.47952488E-11_JPRB, 0.49318180E-11_JPRB, &
  & 0.50997392E-11_JPRB, 0.52928339E-11_JPRB, 0.63301820E-11_JPRB, 0.66275570E-11_JPRB, 0.69474548E-11_JPRB, 0.72665658E-11_JPRB, &
  & 0.76340592E-11_JPRB, 0.80322294E-11_JPRB, 0.86899108E-11_JPRB, 0.10342872E-10_JPRB /)

RGHG4(:,54, 5) = (/ &
  & 0.12423401E-11_JPRB, 0.13815503E-11_JPRB, 0.17767982E-11_JPRB, 0.22793828E-11_JPRB, 0.30574098E-11_JPRB, 0.40071258E-11_JPRB, &
  & 0.48555088E-11_JPRB, 0.55842310E-11_JPRB, 0.25834044E-11_JPRB, 0.25076486E-11_JPRB, 0.25454393E-11_JPRB, 0.26125684E-11_JPRB, &
  & 0.27903728E-11_JPRB, 0.30230183E-11_JPRB, 0.32909140E-11_JPRB, 0.35068441E-11_JPRB, 0.36772577E-11_JPRB, 0.38036896E-11_JPRB, &
  & 0.38887088E-11_JPRB, 0.39293256E-11_JPRB, 0.38890926E-11_JPRB, 0.37106160E-11_JPRB, 0.33737592E-11_JPRB, 0.29549184E-11_JPRB, &
  & 0.25870126E-11_JPRB, 0.22746906E-11_JPRB, 0.20441249E-11_JPRB, 0.18598565E-11_JPRB, 0.17479077E-11_JPRB, 0.16975946E-11_JPRB, &
  & 0.16690991E-11_JPRB, 0.16772827E-11_JPRB, 0.17360572E-11_JPRB, 0.18546512E-11_JPRB, 0.20309472E-11_JPRB, 0.22823150E-11_JPRB, &
  & 0.26125419E-11_JPRB, 0.29936730E-11_JPRB, 0.33877235E-11_JPRB, 0.37169803E-11_JPRB, 0.39036786E-11_JPRB, 0.39682589E-11_JPRB, &
  & 0.39146425E-11_JPRB, 0.38369433E-11_JPRB, 0.37596610E-11_JPRB, 0.37365670E-11_JPRB, 0.37412859E-11_JPRB, 0.37656271E-11_JPRB, &
  & 0.38359797E-11_JPRB, 0.39130357E-11_JPRB, 0.39922154E-11_JPRB, 0.40597178E-11_JPRB, 0.41162121E-11_JPRB, 0.41666358E-11_JPRB, &
  & 0.42292038E-11_JPRB, 0.43001245E-11_JPRB, 0.51913643E-11_JPRB, 0.53161191E-11_JPRB, 0.54597893E-11_JPRB, 0.56217101E-11_JPRB, &
  & 0.58022129E-11_JPRB, 0.59872073E-11_JPRB, 0.62854227E-11_JPRB, 0.68930322E-11_JPRB /)

RGHG4(:,55, 5) = (/ &
  & 0.12421553E-11_JPRB, 0.13794101E-11_JPRB, 0.17864574E-11_JPRB, 0.22469611E-11_JPRB, 0.29343767E-11_JPRB, 0.36910960E-11_JPRB, &
  & 0.44063937E-11_JPRB, 0.49263909E-11_JPRB, 0.23155501E-11_JPRB, 0.22545106E-11_JPRB, 0.22488736E-11_JPRB, 0.23256436E-11_JPRB, &
  & 0.24602054E-11_JPRB, 0.26835563E-11_JPRB, 0.29572011E-11_JPRB, 0.31897540E-11_JPRB, 0.33940596E-11_JPRB, 0.35434058E-11_JPRB, &
  & 0.36622190E-11_JPRB, 0.37365258E-11_JPRB, 0.37536532E-11_JPRB, 0.36451835E-11_JPRB, 0.33940478E-11_JPRB, 0.30287047E-11_JPRB, &
  & 0.26944282E-11_JPRB, 0.23944566E-11_JPRB, 0.21627294E-11_JPRB, 0.19915348E-11_JPRB, 0.18806261E-11_JPRB, 0.18385961E-11_JPRB, &
  & 0.18099734E-11_JPRB, 0.18148744E-11_JPRB, 0.18655997E-11_JPRB, 0.19785013E-11_JPRB, 0.21458605E-11_JPRB, 0.23876704E-11_JPRB, &
  & 0.27109070E-11_JPRB, 0.30853198E-11_JPRB, 0.34675038E-11_JPRB, 0.37658227E-11_JPRB, 0.39142760E-11_JPRB, 0.39472475E-11_JPRB, &
  & 0.38630175E-11_JPRB, 0.37697389E-11_JPRB, 0.36795506E-11_JPRB, 0.36462847E-11_JPRB, 0.36334612E-11_JPRB, 0.36413546E-11_JPRB, &
  & 0.36748829E-11_JPRB, 0.37069987E-11_JPRB, 0.37394788E-11_JPRB, 0.37540188E-11_JPRB, 0.37688607E-11_JPRB, 0.37773925E-11_JPRB, &
  & 0.37945749E-11_JPRB, 0.38315449E-11_JPRB, 0.46125295E-11_JPRB, 0.46797787E-11_JPRB, 0.47735756E-11_JPRB, 0.48630496E-11_JPRB, &
  & 0.49797640E-11_JPRB, 0.51055228E-11_JPRB, 0.52837899E-11_JPRB, 0.55494801E-11_JPRB /)

RGHG4(:,56, 5) = (/ &
  & 0.12829098E-11_JPRB, 0.14439674E-11_JPRB, 0.17851108E-11_JPRB, 0.22437859E-11_JPRB, 0.28630711E-11_JPRB, 0.35009701E-11_JPRB, &
  & 0.40551382E-11_JPRB, 0.44837068E-11_JPRB, 0.21750288E-11_JPRB, 0.21057617E-11_JPRB, 0.21065029E-11_JPRB, 0.21460889E-11_JPRB, &
  & 0.22714736E-11_JPRB, 0.24692063E-11_JPRB, 0.27393263E-11_JPRB, 0.29887308E-11_JPRB, 0.32172379E-11_JPRB, 0.34001400E-11_JPRB, &
  & 0.35489224E-11_JPRB, 0.36605827E-11_JPRB, 0.37203881E-11_JPRB, 0.36692177E-11_JPRB, 0.34896552E-11_JPRB, 0.31728398E-11_JPRB, &
  & 0.28662426E-11_JPRB, 0.25821901E-11_JPRB, 0.23496214E-11_JPRB, 0.21777578E-11_JPRB, 0.20657831E-11_JPRB, 0.20217120E-11_JPRB, &
  & 0.19929403E-11_JPRB, 0.19936505E-11_JPRB, 0.20364695E-11_JPRB, 0.21431463E-11_JPRB, 0.23030122E-11_JPRB, 0.25373896E-11_JPRB, &
  & 0.28531494E-11_JPRB, 0.32215214E-11_JPRB, 0.35957335E-11_JPRB, 0.38765649E-11_JPRB, 0.40055533E-11_JPRB, 0.40103840E-11_JPRB, &
  & 0.39121176E-11_JPRB, 0.37960607E-11_JPRB, 0.36867011E-11_JPRB, 0.36434822E-11_JPRB, 0.36249970E-11_JPRB, 0.36054835E-11_JPRB, &
  & 0.36103802E-11_JPRB, 0.36102319E-11_JPRB, 0.36053944E-11_JPRB, 0.35960174E-11_JPRB, 0.35899981E-11_JPRB, 0.35842045E-11_JPRB, &
  & 0.35897286E-11_JPRB, 0.36046086E-11_JPRB, 0.43141077E-11_JPRB, 0.43696401E-11_JPRB, 0.44290491E-11_JPRB, 0.44971206E-11_JPRB, &
  & 0.45999797E-11_JPRB, 0.46983832E-11_JPRB, 0.48833511E-11_JPRB, 0.52242199E-11_JPRB /)

RGHG4(:,57, 5) = (/ &
  & 0.13299583E-11_JPRB, 0.15216390E-11_JPRB, 0.18350401E-11_JPRB, 0.22791216E-11_JPRB, 0.28026264E-11_JPRB, 0.33848655E-11_JPRB, &
  & 0.38473712E-11_JPRB, 0.41767844E-11_JPRB, 0.21156753E-11_JPRB, 0.20481984E-11_JPRB, 0.20338258E-11_JPRB, 0.20769363E-11_JPRB, &
  & 0.21737421E-11_JPRB, 0.23576722E-11_JPRB, 0.26260242E-11_JPRB, 0.28900547E-11_JPRB, 0.31532405E-11_JPRB, 0.33700527E-11_JPRB, &
  & 0.35554613E-11_JPRB, 0.37056560E-11_JPRB, 0.38109815E-11_JPRB, 0.38003511E-11_JPRB, 0.36652422E-11_JPRB, 0.33895033E-11_JPRB, &
  & 0.31076895E-11_JPRB, 0.28230805E-11_JPRB, 0.25836249E-11_JPRB, 0.24054968E-11_JPRB, 0.22898970E-11_JPRB, 0.22386849E-11_JPRB, &
  & 0.22061998E-11_JPRB, 0.22038170E-11_JPRB, 0.22385852E-11_JPRB, 0.23368154E-11_JPRB, 0.24874367E-11_JPRB, 0.27136843E-11_JPRB, &
  & 0.30231312E-11_JPRB, 0.33907968E-11_JPRB, 0.37559730E-11_JPRB, 0.40266180E-11_JPRB, 0.41569456E-11_JPRB, 0.41499421E-11_JPRB, &
  & 0.40470943E-11_JPRB, 0.39246640E-11_JPRB, 0.38025256E-11_JPRB, 0.37557466E-11_JPRB, 0.37209901E-11_JPRB, 0.36719794E-11_JPRB, &
  & 0.36567954E-11_JPRB, 0.36240969E-11_JPRB, 0.35955895E-11_JPRB, 0.35707782E-11_JPRB, 0.35526445E-11_JPRB, 0.35359064E-11_JPRB, &
  & 0.35257886E-11_JPRB, 0.35323417E-11_JPRB, 0.41860348E-11_JPRB, 0.42357112E-11_JPRB, 0.42900371E-11_JPRB, 0.43561665E-11_JPRB, &
  & 0.44376816E-11_JPRB, 0.45267722E-11_JPRB, 0.46572039E-11_JPRB, 0.48299064E-11_JPRB /)

RGHG4(:,58, 5) = (/ &
  & 0.13912931E-11_JPRB, 0.16023239E-11_JPRB, 0.19091066E-11_JPRB, 0.22965143E-11_JPRB, 0.28046920E-11_JPRB, 0.32976425E-11_JPRB, &
  & 0.37197532E-11_JPRB, 0.39949814E-11_JPRB, 0.21185389E-11_JPRB, 0.20571661E-11_JPRB, 0.20424331E-11_JPRB, 0.20729993E-11_JPRB, &
  & 0.21621218E-11_JPRB, 0.23350438E-11_JPRB, 0.25971491E-11_JPRB, 0.28866809E-11_JPRB, 0.31843291E-11_JPRB, 0.34534944E-11_JPRB, &
  & 0.36751778E-11_JPRB, 0.38754182E-11_JPRB, 0.40151311E-11_JPRB, 0.40322411E-11_JPRB, 0.39378492E-11_JPRB, 0.36701094E-11_JPRB, &
  & 0.33785388E-11_JPRB, 0.30904444E-11_JPRB, 0.28520608E-11_JPRB, 0.26704368E-11_JPRB, 0.25519094E-11_JPRB, 0.24949415E-11_JPRB, &
  & 0.24578195E-11_JPRB, 0.24526752E-11_JPRB, 0.24793119E-11_JPRB, 0.25673207E-11_JPRB, 0.27061972E-11_JPRB, 0.29230242E-11_JPRB, &
  & 0.32230158E-11_JPRB, 0.35850535E-11_JPRB, 0.39447031E-11_JPRB, 0.42104701E-11_JPRB, 0.43414061E-11_JPRB, 0.43449914E-11_JPRB, &
  & 0.42471569E-11_JPRB, 0.41331816E-11_JPRB, 0.40134666E-11_JPRB, 0.39634810E-11_JPRB, 0.39222033E-11_JPRB, 0.38492408E-11_JPRB, &
  & 0.38078447E-11_JPRB, 0.37444717E-11_JPRB, 0.36901879E-11_JPRB, 0.36515513E-11_JPRB, 0.36207205E-11_JPRB, 0.35967123E-11_JPRB, &
  & 0.35852764E-11_JPRB, 0.35951010E-11_JPRB, 0.41926870E-11_JPRB, 0.42431015E-11_JPRB, 0.42993226E-11_JPRB, 0.43613147E-11_JPRB, &
  & 0.44461310E-11_JPRB, 0.45446741E-11_JPRB, 0.47010833E-11_JPRB, 0.49151525E-11_JPRB /)

RGHG4(:,59, 5) = (/ &
  & 0.14467735E-11_JPRB, 0.16965487E-11_JPRB, 0.19640439E-11_JPRB, 0.23525138E-11_JPRB, 0.28017185E-11_JPRB, 0.32799384E-11_JPRB, &
  & 0.36511788E-11_JPRB, 0.39167168E-11_JPRB, 0.21768915E-11_JPRB, 0.21249463E-11_JPRB, 0.21146800E-11_JPRB, 0.21508403E-11_JPRB, &
  & 0.22360017E-11_JPRB, 0.24064904E-11_JPRB, 0.26797167E-11_JPRB, 0.29950549E-11_JPRB, 0.33406028E-11_JPRB, 0.36622172E-11_JPRB, &
  & 0.39229028E-11_JPRB, 0.41597728E-11_JPRB, 0.43319870E-11_JPRB, 0.43571305E-11_JPRB, 0.42363678E-11_JPRB, 0.39761488E-11_JPRB, &
  & 0.36868438E-11_JPRB, 0.33928611E-11_JPRB, 0.31467225E-11_JPRB, 0.29626902E-11_JPRB, 0.28412437E-11_JPRB, 0.27806678E-11_JPRB, &
  & 0.27403281E-11_JPRB, 0.27321157E-11_JPRB, 0.27516383E-11_JPRB, 0.28295790E-11_JPRB, 0.29541784E-11_JPRB, 0.31581777E-11_JPRB, &
  & 0.34488497E-11_JPRB, 0.38045435E-11_JPRB, 0.41565688E-11_JPRB, 0.44289902E-11_JPRB, 0.45653537E-11_JPRB, 0.45829425E-11_JPRB, &
  & 0.44984476E-11_JPRB, 0.44006986E-11_JPRB, 0.42921977E-11_JPRB, 0.42502052E-11_JPRB, 0.42117165E-11_JPRB, 0.41362846E-11_JPRB, &
  & 0.40869357E-11_JPRB, 0.39917861E-11_JPRB, 0.39076537E-11_JPRB, 0.38547806E-11_JPRB, 0.38115613E-11_JPRB, 0.37798150E-11_JPRB, &
  & 0.37592234E-11_JPRB, 0.37622817E-11_JPRB, 0.43131635E-11_JPRB, 0.43754471E-11_JPRB, 0.44368814E-11_JPRB, 0.45021387E-11_JPRB, &
  & 0.45859549E-11_JPRB, 0.46834221E-11_JPRB, 0.48121476E-11_JPRB, 0.49807658E-11_JPRB /)

RGHG4(:,60, 5) = (/ &
  & 0.15280637E-11_JPRB, 0.17762096E-11_JPRB, 0.20538298E-11_JPRB, 0.23882094E-11_JPRB, 0.28467812E-11_JPRB, 0.33019145E-11_JPRB, &
  & 0.36791364E-11_JPRB, 0.39324572E-11_JPRB, 0.23086112E-11_JPRB, 0.22662972E-11_JPRB, 0.22655237E-11_JPRB, 0.23083900E-11_JPRB, &
  & 0.24078330E-11_JPRB, 0.25893222E-11_JPRB, 0.28888719E-11_JPRB, 0.32369647E-11_JPRB, 0.36346501E-11_JPRB, 0.40073652E-11_JPRB, &
  & 0.42901672E-11_JPRB, 0.45487156E-11_JPRB, 0.47020131E-11_JPRB, 0.47086267E-11_JPRB, 0.45887391E-11_JPRB, 0.43178391E-11_JPRB, &
  & 0.40131093E-11_JPRB, 0.37169278E-11_JPRB, 0.34698524E-11_JPRB, 0.32861723E-11_JPRB, 0.31669723E-11_JPRB, 0.31087901E-11_JPRB, &
  & 0.30704540E-11_JPRB, 0.30595097E-11_JPRB, 0.30706028E-11_JPRB, 0.31352239E-11_JPRB, 0.32442699E-11_JPRB, 0.34295841E-11_JPRB, &
  & 0.37084350E-11_JPRB, 0.40533041E-11_JPRB, 0.44003286E-11_JPRB, 0.46729239E-11_JPRB, 0.48257709E-11_JPRB, 0.48661353E-11_JPRB, &
  & 0.48010706E-11_JPRB, 0.47252666E-11_JPRB, 0.46338185E-11_JPRB, 0.46059007E-11_JPRB, 0.45734072E-11_JPRB, 0.45144075E-11_JPRB, &
  & 0.44679161E-11_JPRB, 0.43656558E-11_JPRB, 0.42610715E-11_JPRB, 0.41942149E-11_JPRB, 0.41367244E-11_JPRB, 0.40914759E-11_JPRB, &
  & 0.40610796E-11_JPRB, 0.40684201E-11_JPRB, 0.45846781E-11_JPRB, 0.46554878E-11_JPRB, 0.47215972E-11_JPRB, 0.47898608E-11_JPRB, &
  & 0.48788703E-11_JPRB, 0.49868573E-11_JPRB, 0.51288284E-11_JPRB, 0.52594205E-11_JPRB /)

RGHG4(:,61, 5) = (/ &
  & 0.15937193E-11_JPRB, 0.18450287E-11_JPRB, 0.21077838E-11_JPRB, 0.24541567E-11_JPRB, 0.28914798E-11_JPRB, 0.33722701E-11_JPRB, &
  & 0.37603250E-11_JPRB, 0.40442875E-11_JPRB, 0.24955669E-11_JPRB, 0.24842795E-11_JPRB, 0.24986224E-11_JPRB, 0.25733343E-11_JPRB, &
  & 0.26862085E-11_JPRB, 0.29292165E-11_JPRB, 0.32454157E-11_JPRB, 0.36400744E-11_JPRB, 0.40764167E-11_JPRB, 0.44717619E-11_JPRB, &
  & 0.47611637E-11_JPRB, 0.49943929E-11_JPRB, 0.51234902E-11_JPRB, 0.51097065E-11_JPRB, 0.49597717E-11_JPRB, 0.46843597E-11_JPRB, &
  & 0.43714277E-11_JPRB, 0.40718392E-11_JPRB, 0.38259396E-11_JPRB, 0.36507347E-11_JPRB, 0.35398733E-11_JPRB, 0.34877275E-11_JPRB, &
  & 0.34553506E-11_JPRB, 0.34444743E-11_JPRB, 0.34467158E-11_JPRB, 0.34944038E-11_JPRB, 0.35836800E-11_JPRB, 0.37476433E-11_JPRB, &
  & 0.40079329E-11_JPRB, 0.43389719E-11_JPRB, 0.46808547E-11_JPRB, 0.49614414E-11_JPRB, 0.51311347E-11_JPRB, 0.51968247E-11_JPRB, &
  & 0.51573325E-11_JPRB, 0.51087949E-11_JPRB, 0.50415817E-11_JPRB, 0.50313768E-11_JPRB, 0.50149255E-11_JPRB, 0.49832157E-11_JPRB, &
  & 0.49492745E-11_JPRB, 0.48649964E-11_JPRB, 0.47619343E-11_JPRB, 0.46900023E-11_JPRB, 0.46166361E-11_JPRB, 0.45512530E-11_JPRB, &
  & 0.45122443E-11_JPRB, 0.45161834E-11_JPRB, 0.50056513E-11_JPRB, 0.50949822E-11_JPRB, 0.51716890E-11_JPRB, 0.52455661E-11_JPRB, &
  & 0.53389723E-11_JPRB, 0.54540816E-11_JPRB, 0.55829300E-11_JPRB, 0.56761583E-11_JPRB /)

RGHG4(:,62, 5) = (/ &
  & 0.16604811E-11_JPRB, 0.18958982E-11_JPRB, 0.21551725E-11_JPRB, 0.24922911E-11_JPRB, 0.29532151E-11_JPRB, 0.34630901E-11_JPRB, &
  & 0.39097766E-11_JPRB, 0.42429324E-11_JPRB, 0.27715534E-11_JPRB, 0.27829093E-11_JPRB, 0.28452934E-11_JPRB, 0.29442215E-11_JPRB, &
  & 0.31196963E-11_JPRB, 0.34029702E-11_JPRB, 0.37824093E-11_JPRB, 0.42101609E-11_JPRB, 0.46557116E-11_JPRB, 0.50339568E-11_JPRB, &
  & 0.52947742E-11_JPRB, 0.54997664E-11_JPRB, 0.55862559E-11_JPRB, 0.55441107E-11_JPRB, 0.53721320E-11_JPRB, 0.50782022E-11_JPRB, &
  & 0.47595612E-11_JPRB, 0.44636421E-11_JPRB, 0.42278217E-11_JPRB, 0.40675241E-11_JPRB, 0.39735034E-11_JPRB, 0.39350966E-11_JPRB, &
  & 0.39141828E-11_JPRB, 0.39060808E-11_JPRB, 0.39008952E-11_JPRB, 0.39254554E-11_JPRB, 0.39910631E-11_JPRB, 0.41287659E-11_JPRB, &
  & 0.43657725E-11_JPRB, 0.46800649E-11_JPRB, 0.50183035E-11_JPRB, 0.53022647E-11_JPRB, 0.54930704E-11_JPRB, 0.55891038E-11_JPRB, &
  & 0.55796383E-11_JPRB, 0.55636142E-11_JPRB, 0.55231501E-11_JPRB, 0.55356154E-11_JPRB, 0.55414731E-11_JPRB, 0.55366961E-11_JPRB, &
  & 0.55258654E-11_JPRB, 0.54720555E-11_JPRB, 0.53893118E-11_JPRB, 0.53299205E-11_JPRB, 0.52498283E-11_JPRB, 0.51742738E-11_JPRB, &
  & 0.51229268E-11_JPRB, 0.51303302E-11_JPRB, 0.56178872E-11_JPRB, 0.57334437E-11_JPRB, 0.58195029E-11_JPRB, 0.58966152E-11_JPRB, &
  & 0.59980753E-11_JPRB, 0.61254452E-11_JPRB, 0.62567130E-11_JPRB, 0.62711555E-11_JPRB /)

RGHG4(:,63, 5) = (/ &
  & 0.16865337E-11_JPRB, 0.19115029E-11_JPRB, 0.21662379E-11_JPRB, 0.25094421E-11_JPRB, 0.29889272E-11_JPRB, 0.35594431E-11_JPRB, &
  & 0.40818278E-11_JPRB, 0.45012713E-11_JPRB, 0.31104193E-11_JPRB, 0.31805058E-11_JPRB, 0.32911803E-11_JPRB, 0.34681257E-11_JPRB, &
  & 0.37073760E-11_JPRB, 0.40704788E-11_JPRB, 0.45000501E-11_JPRB, 0.49342518E-11_JPRB, 0.53411004E-11_JPRB, 0.56652309E-11_JPRB, &
  & 0.58870239E-11_JPRB, 0.60416789E-11_JPRB, 0.60850526E-11_JPRB, 0.60091389E-11_JPRB, 0.58078607E-11_JPRB, 0.55094627E-11_JPRB, &
  & 0.51905971E-11_JPRB, 0.49014729E-11_JPRB, 0.46856273E-11_JPRB, 0.45516516E-11_JPRB, 0.44842350E-11_JPRB, 0.44687591E-11_JPRB, &
  & 0.44670201E-11_JPRB, 0.44635589E-11_JPRB, 0.44521123E-11_JPRB, 0.44550019E-11_JPRB, 0.44875115E-11_JPRB, 0.45949021E-11_JPRB, &
  & 0.48034454E-11_JPRB, 0.50961947E-11_JPRB, 0.54249430E-11_JPRB, 0.57166585E-11_JPRB, 0.59271780E-11_JPRB, 0.60543437E-11_JPRB, &
  & 0.60829766E-11_JPRB, 0.61014071E-11_JPRB, 0.60957480E-11_JPRB, 0.61328304E-11_JPRB, 0.61694300E-11_JPRB, 0.61997811E-11_JPRB, &
  & 0.62199495E-11_JPRB, 0.61977021E-11_JPRB, 0.61410048E-11_JPRB, 0.61053250E-11_JPRB, 0.60303936E-11_JPRB, 0.59550225E-11_JPRB, &
  & 0.58976647E-11_JPRB, 0.59202721E-11_JPRB, 0.64349658E-11_JPRB, 0.65795264E-11_JPRB, 0.66820082E-11_JPRB, 0.67653921E-11_JPRB, &
  & 0.68776139E-11_JPRB, 0.70210283E-11_JPRB, 0.71446078E-11_JPRB, 0.70720031E-11_JPRB /)

RGHG4(:,64, 5) = (/ &
  & 0.16749374E-11_JPRB, 0.18860677E-11_JPRB, 0.21353763E-11_JPRB, 0.24805143E-11_JPRB, 0.29795801E-11_JPRB, 0.36098997E-11_JPRB, &
  & 0.42690287E-11_JPRB, 0.48070961E-11_JPRB, 0.35303793E-11_JPRB, 0.36817945E-11_JPRB, 0.38889781E-11_JPRB, 0.41483778E-11_JPRB, &
  & 0.44853782E-11_JPRB, 0.49243734E-11_JPRB, 0.53638695E-11_JPRB, 0.57617123E-11_JPRB, 0.60984412E-11_JPRB, 0.63561153E-11_JPRB, &
  & 0.65235608E-11_JPRB, 0.66272990E-11_JPRB, 0.66255989E-11_JPRB, 0.65130124E-11_JPRB, 0.62906572E-11_JPRB, 0.59831419E-11_JPRB, &
  & 0.56699428E-11_JPRB, 0.54065376E-11_JPRB, 0.52205445E-11_JPRB, 0.51230994E-11_JPRB, 0.50955728E-11_JPRB, 0.51135016E-11_JPRB, &
  & 0.51378814E-11_JPRB, 0.51439157E-11_JPRB, 0.51253225E-11_JPRB, 0.51011205E-11_JPRB, 0.51003785E-11_JPRB, 0.51724610E-11_JPRB, &
  & 0.53490168E-11_JPRB, 0.56171478E-11_JPRB, 0.59327651E-11_JPRB, 0.62289627E-11_JPRB, 0.64599320E-11_JPRB, 0.66203549E-11_JPRB, &
  & 0.66884827E-11_JPRB, 0.67399020E-11_JPRB, 0.67726380E-11_JPRB, 0.68396564E-11_JPRB, 0.69065261E-11_JPRB, 0.69682428E-11_JPRB, &
  & 0.70251222E-11_JPRB, 0.70380407E-11_JPRB, 0.70210266E-11_JPRB, 0.70120845E-11_JPRB, 0.69556652E-11_JPRB, 0.68890831E-11_JPRB, &
  & 0.68343825E-11_JPRB, 0.68865278E-11_JPRB, 0.74485695E-11_JPRB, 0.76411620E-11_JPRB, 0.77677743E-11_JPRB, 0.78616731E-11_JPRB, &
  & 0.79912665E-11_JPRB, 0.81603422E-11_JPRB, 0.82860203E-11_JPRB, 0.80813993E-11_JPRB /)

RGHG4(:,65, 5) = (/ &
  & 0.16198615E-11_JPRB, 0.18174328E-11_JPRB, 0.20541357E-11_JPRB, 0.23924103E-11_JPRB, 0.29012704E-11_JPRB, 0.35966588E-11_JPRB, &
  & 0.43922622E-11_JPRB, 0.51571074E-11_JPRB, 0.40128903E-11_JPRB, 0.43112128E-11_JPRB, 0.46338597E-11_JPRB, 0.50404845E-11_JPRB, &
  & 0.54707862E-11_JPRB, 0.59359032E-11_JPRB, 0.63426638E-11_JPRB, 0.66592764E-11_JPRB, 0.69165481E-11_JPRB, 0.70938090E-11_JPRB, &
  & 0.72005756E-11_JPRB, 0.72528329E-11_JPRB, 0.72045325E-11_JPRB, 0.70602049E-11_JPRB, 0.68203134E-11_JPRB, 0.65192344E-11_JPRB, &
  & 0.62274231E-11_JPRB, 0.59951662E-11_JPRB, 0.58553188E-11_JPRB, 0.58100443E-11_JPRB, 0.58309624E-11_JPRB, 0.58905363E-11_JPRB, &
  & 0.59463432E-11_JPRB, 0.59680321E-11_JPRB, 0.59446298E-11_JPRB, 0.58978235E-11_JPRB, 0.58596496E-11_JPRB, 0.58928136E-11_JPRB, &
  & 0.60339862E-11_JPRB, 0.62729201E-11_JPRB, 0.65717679E-11_JPRB, 0.68708325E-11_JPRB, 0.71192869E-11_JPRB, 0.73133643E-11_JPRB, &
  & 0.74218288E-11_JPRB, 0.75141490E-11_JPRB, 0.75845302E-11_JPRB, 0.76790779E-11_JPRB, 0.77835880E-11_JPRB, 0.78900471E-11_JPRB, &
  & 0.79849590E-11_JPRB, 0.80339364E-11_JPRB, 0.80538362E-11_JPRB, 0.80669638E-11_JPRB, 0.80376591E-11_JPRB, 0.79870789E-11_JPRB, &
  & 0.79383574E-11_JPRB, 0.80195616E-11_JPRB, 0.86413845E-11_JPRB, 0.88789254E-11_JPRB, 0.90454397E-11_JPRB, 0.91727216E-11_JPRB, &
  & 0.93357553E-11_JPRB, 0.95411387E-11_JPRB, 0.96604252E-11_JPRB, 0.92874736E-11_JPRB /)

RGHG4(:,66, 5) = (/ &
  & 0.15500121E-11_JPRB, 0.17217500E-11_JPRB, 0.19458504E-11_JPRB, 0.22658895E-11_JPRB, 0.27589936E-11_JPRB, 0.35014175E-11_JPRB, &
  & 0.44728305E-11_JPRB, 0.55159202E-11_JPRB, 0.46206754E-11_JPRB, 0.50913961E-11_JPRB, 0.56078024E-11_JPRB, 0.61185436E-11_JPRB, &
  & 0.66026173E-11_JPRB, 0.70373282E-11_JPRB, 0.73545909E-11_JPRB, 0.75989527E-11_JPRB, 0.77740895E-11_JPRB, 0.78843347E-11_JPRB, &
  & 0.79358612E-11_JPRB, 0.79298859E-11_JPRB, 0.78412337E-11_JPRB, 0.76708744E-11_JPRB, 0.74243294E-11_JPRB, 0.71364616E-11_JPRB, &
  & 0.68789432E-11_JPRB, 0.66994643E-11_JPRB, 0.66146255E-11_JPRB, 0.66252962E-11_JPRB, 0.67024775E-11_JPRB, 0.68100096E-11_JPRB, &
  & 0.69037575E-11_JPRB, 0.69459538E-11_JPRB, 0.69205939E-11_JPRB, 0.68481089E-11_JPRB, 0.67765685E-11_JPRB, 0.67804659E-11_JPRB, &
  & 0.68895588E-11_JPRB, 0.71009782E-11_JPRB, 0.73822840E-11_JPRB, 0.76812992E-11_JPRB, 0.79460596E-11_JPRB, 0.81740561E-11_JPRB, &
  & 0.83189740E-11_JPRB, 0.84490999E-11_JPRB, 0.85545989E-11_JPRB, 0.86860215E-11_JPRB, 0.88245522E-11_JPRB, 0.89623890E-11_JPRB, &
  & 0.90890169E-11_JPRB, 0.91872039E-11_JPRB, 0.92454898E-11_JPRB, 0.92968541E-11_JPRB, 0.92927393E-11_JPRB, 0.92718559E-11_JPRB, &
  & 0.92245716E-11_JPRB, 0.93530505E-11_JPRB, 0.10025760E-10_JPRB, 0.10315747E-10_JPRB, 0.10524926E-10_JPRB, 0.10689593E-10_JPRB, &
  & 0.10890556E-10_JPRB, 0.11133323E-10_JPRB, 0.11261425E-10_JPRB, 0.10677859E-10_JPRB /)

RGHG4(:,67, 5) = (/ &
  & 0.14802917E-11_JPRB, 0.16362368E-11_JPRB, 0.18457738E-11_JPRB, 0.21421957E-11_JPRB, 0.26014377E-11_JPRB, 0.33336114E-11_JPRB, &
  & 0.45202067E-11_JPRB, 0.59578280E-11_JPRB, 0.53555060E-11_JPRB, 0.60916936E-11_JPRB, 0.67700784E-11_JPRB, 0.73753833E-11_JPRB, &
  & 0.78230053E-11_JPRB, 0.81833732E-11_JPRB, 0.84233636E-11_JPRB, 0.85933049E-11_JPRB, 0.86968514E-11_JPRB, 0.87350864E-11_JPRB, &
  & 0.87239521E-11_JPRB, 0.86767555E-11_JPRB, 0.85540281E-11_JPRB, 0.83670995E-11_JPRB, 0.81248749E-11_JPRB, 0.78660108E-11_JPRB, &
  & 0.76580547E-11_JPRB, 0.75346300E-11_JPRB, 0.75216586E-11_JPRB, 0.76019989E-11_JPRB, 0.77376812E-11_JPRB, 0.78941549E-11_JPRB, &
  & 0.80296421E-11_JPRB, 0.80981220E-11_JPRB, 0.80771232E-11_JPRB, 0.79930125E-11_JPRB, 0.79002568E-11_JPRB, 0.78661530E-11_JPRB, &
  & 0.79473268E-11_JPRB, 0.81339735E-11_JPRB, 0.84008937E-11_JPRB, 0.86991169E-11_JPRB, 0.89793650E-11_JPRB, 0.92396906E-11_JPRB, &
  & 0.94194088E-11_JPRB, 0.95902149E-11_JPRB, 0.97307717E-11_JPRB, 0.98987190E-11_JPRB, 0.10071501E-10_JPRB, 0.10254485E-10_JPRB, &
  & 0.10428020E-10_JPRB, 0.10570500E-10_JPRB, 0.10654827E-10_JPRB, 0.10744391E-10_JPRB, 0.10758634E-10_JPRB, 0.10769071E-10_JPRB, &
  & 0.10725529E-10_JPRB, 0.10889754E-10_JPRB, 0.11613745E-10_JPRB, 0.11954683E-10_JPRB, 0.12220099E-10_JPRB, 0.12434316E-10_JPRB, &
  & 0.12684717E-10_JPRB, 0.12969995E-10_JPRB, 0.13095326E-10_JPRB, 0.12308687E-10_JPRB /)

RGHG4(:,68, 5) = (/ &
  & 0.14302203E-11_JPRB, 0.16076021E-11_JPRB, 0.18144568E-11_JPRB, 0.20938253E-11_JPRB, 0.24884298E-11_JPRB, 0.32071262E-11_JPRB, &
  & 0.44891378E-11_JPRB, 0.66166222E-11_JPRB, 0.62772708E-11_JPRB, 0.72967483E-11_JPRB, 0.80937652E-11_JPRB, 0.86933195E-11_JPRB, &
  & 0.90624556E-11_JPRB, 0.93554574E-11_JPRB, 0.95278863E-11_JPRB, 0.96380473E-11_JPRB, 0.96801499E-11_JPRB, 0.96678880E-11_JPRB, &
  & 0.96128548E-11_JPRB, 0.95189915E-11_JPRB, 0.93696804E-11_JPRB, 0.91777827E-11_JPRB, 0.89519078E-11_JPRB, 0.87360778E-11_JPRB, &
  & 0.85885821E-11_JPRB, 0.85444611E-11_JPRB, 0.86035614E-11_JPRB, 0.87478809E-11_JPRB, 0.89467444E-11_JPRB, 0.91594180E-11_JPRB, &
  & 0.93408675E-11_JPRB, 0.94412395E-11_JPRB, 0.94297825E-11_JPRB, 0.93324749E-11_JPRB, 0.92173127E-11_JPRB, 0.91758233E-11_JPRB, &
  & 0.92417306E-11_JPRB, 0.94109399E-11_JPRB, 0.96673962E-11_JPRB, 0.99661043E-11_JPRB, 0.10264356E-10_JPRB, 0.10555267E-10_JPRB, &
  & 0.10767792E-10_JPRB, 0.10977256E-10_JPRB, 0.11151926E-10_JPRB, 0.11357447E-10_JPRB, 0.11564858E-10_JPRB, 0.11777291E-10_JPRB, &
  & 0.11985987E-10_JPRB, 0.12173353E-10_JPRB, 0.12299359E-10_JPRB, 0.12435574E-10_JPRB, 0.12473804E-10_JPRB, 0.12513070E-10_JPRB, &
  & 0.12475169E-10_JPRB, 0.12670079E-10_JPRB, 0.13437821E-10_JPRB, 0.13829955E-10_JPRB, 0.14149851E-10_JPRB, 0.14421696E-10_JPRB, &
  & 0.14727625E-10_JPRB, 0.15052813E-10_JPRB, 0.15187665E-10_JPRB, 0.14221002E-10_JPRB /)

RGHG4(:,69, 5) = (/ &
  & 0.14595816E-11_JPRB, 0.16819327E-11_JPRB, 0.19173296E-11_JPRB, 0.21913164E-11_JPRB, 0.25317107E-11_JPRB, 0.31393219E-11_JPRB, &
  & 0.47055580E-11_JPRB, 0.72599509E-11_JPRB, 0.74883771E-11_JPRB, 0.86609695E-11_JPRB, 0.94862330E-11_JPRB, 0.10041737E-10_JPRB, &
  & 0.10357798E-10_JPRB, 0.10592279E-10_JPRB, 0.10707929E-10_JPRB, 0.10769138E-10_JPRB, 0.10765252E-10_JPRB, 0.10697250E-10_JPRB, &
  & 0.10601382E-10_JPRB, 0.10483631E-10_JPRB, 0.10323773E-10_JPRB, 0.10137537E-10_JPRB, 0.99426023E-11_JPRB, 0.97796623E-11_JPRB, &
  & 0.97050449E-11_JPRB, 0.97340426E-11_JPRB, 0.98781426E-11_JPRB, 0.10109284E-10_JPRB, 0.10375749E-10_JPRB, 0.10643781E-10_JPRB, &
  & 0.10873715E-10_JPRB, 0.11013676E-10_JPRB, 0.11022809E-10_JPRB, 0.10934020E-10_JPRB, 0.10821200E-10_JPRB, 0.10752077E-10_JPRB, &
  & 0.10807192E-10_JPRB, 0.10968131E-10_JPRB, 0.11222226E-10_JPRB, 0.11526354E-10_JPRB, 0.11846725E-10_JPRB, 0.12167535E-10_JPRB, &
  & 0.12417104E-10_JPRB, 0.12663246E-10_JPRB, 0.12876069E-10_JPRB, 0.13120028E-10_JPRB, 0.13369377E-10_JPRB, 0.13628473E-10_JPRB, &
  & 0.13897007E-10_JPRB, 0.14126660E-10_JPRB, 0.14285210E-10_JPRB, 0.14446765E-10_JPRB, 0.14504864E-10_JPRB, 0.14563630E-10_JPRB, &
  & 0.14532905E-10_JPRB, 0.14743764E-10_JPRB, 0.15550925E-10_JPRB, 0.15991613E-10_JPRB, 0.16373670E-10_JPRB, 0.16709351E-10_JPRB, &
  & 0.17079749E-10_JPRB, 0.17453096E-10_JPRB, 0.17594617E-10_JPRB, 0.16474159E-10_JPRB /)

RGHG4(:,70, 5) = (/ &
  & 0.15998101E-11_JPRB, 0.19120571E-11_JPRB, 0.22131949E-11_JPRB, 0.25110164E-11_JPRB, 0.28137174E-11_JPRB, 0.33237000E-11_JPRB, &
  & 0.49633526E-11_JPRB, 0.84310501E-11_JPRB, 0.88309395E-11_JPRB, 0.10040298E-10_JPRB, 0.10939553E-10_JPRB, 0.11416664E-10_JPRB, &
  & 0.11673379E-10_JPRB, 0.11878213E-10_JPRB, 0.11957793E-10_JPRB, 0.11978322E-10_JPRB, 0.11950524E-10_JPRB, 0.11865002E-10_JPRB, &
  & 0.11749367E-10_JPRB, 0.11611695E-10_JPRB, 0.11447074E-10_JPRB, 0.11282700E-10_JPRB, 0.11128575E-10_JPRB, 0.11029411E-10_JPRB, &
  & 0.11035338E-10_JPRB, 0.11159362E-10_JPRB, 0.11379798E-10_JPRB, 0.11674751E-10_JPRB, 0.12013416E-10_JPRB, 0.12350922E-10_JPRB, &
  & 0.12639214E-10_JPRB, 0.12823605E-10_JPRB, 0.12861935E-10_JPRB, 0.12778323E-10_JPRB, 0.12660610E-10_JPRB, 0.12622558E-10_JPRB, &
  & 0.12684824E-10_JPRB, 0.12851301E-10_JPRB, 0.13112758E-10_JPRB, 0.13431280E-10_JPRB, 0.13778511E-10_JPRB, 0.14133804E-10_JPRB, &
  & 0.14422561E-10_JPRB, 0.14707346E-10_JPRB, 0.14962916E-10_JPRB, 0.15248190E-10_JPRB, 0.15539665E-10_JPRB, 0.15838903E-10_JPRB, &
  & 0.16139937E-10_JPRB, 0.16409891E-10_JPRB, 0.16616156E-10_JPRB, 0.16821548E-10_JPRB, 0.16915160E-10_JPRB, 0.16987585E-10_JPRB, &
  & 0.16961519E-10_JPRB, 0.17180526E-10_JPRB, 0.18018797E-10_JPRB, 0.18501140E-10_JPRB, 0.18949299E-10_JPRB, 0.19357245E-10_JPRB, &
  & 0.19801336E-10_JPRB, 0.20227016E-10_JPRB, 0.20375802E-10_JPRB, 0.19084232E-10_JPRB /)

RGHG4(:,71, 5) = (/ &
  & 0.18921737E-11_JPRB, 0.23553228E-11_JPRB, 0.27818019E-11_JPRB, 0.31275891E-11_JPRB, 0.34208281E-11_JPRB, 0.38784739E-11_JPRB, &
  & 0.56766232E-11_JPRB, 0.96177979E-11_JPRB, 0.10394912E-10_JPRB, 0.11509141E-10_JPRB, 0.12394163E-10_JPRB, 0.12885933E-10_JPRB, &
  & 0.13098381E-10_JPRB, 0.13261353E-10_JPRB, 0.13325360E-10_JPRB, 0.13325024E-10_JPRB, 0.13281399E-10_JPRB, 0.13179745E-10_JPRB, &
  & 0.13057569E-10_JPRB, 0.12925358E-10_JPRB, 0.12777215E-10_JPRB, 0.12643457E-10_JPRB, 0.12543217E-10_JPRB, 0.12516804E-10_JPRB, &
  & 0.12610678E-10_JPRB, 0.12814075E-10_JPRB, 0.13136459E-10_JPRB, 0.13539325E-10_JPRB, 0.13958575E-10_JPRB, 0.14363662E-10_JPRB, &
  & 0.14712920E-10_JPRB, 0.14952340E-10_JPRB, 0.15033719E-10_JPRB, 0.14987289E-10_JPRB, 0.14902860E-10_JPRB, 0.14850008E-10_JPRB, &
  & 0.14927415E-10_JPRB, 0.15110914E-10_JPRB, 0.15391374E-10_JPRB, 0.15733762E-10_JPRB, 0.16116627E-10_JPRB, 0.16509421E-10_JPRB, &
  & 0.16841721E-10_JPRB, 0.17171606E-10_JPRB, 0.17474005E-10_JPRB, 0.17809986E-10_JPRB, 0.18150606E-10_JPRB, 0.18504935E-10_JPRB, &
  & 0.18879729E-10_JPRB, 0.19194682E-10_JPRB, 0.19441218E-10_JPRB, 0.19667110E-10_JPRB, 0.19776568E-10_JPRB, 0.19864856E-10_JPRB, &
  & 0.19847910E-10_JPRB, 0.20067862E-10_JPRB, 0.20919893E-10_JPRB, 0.21451655E-10_JPRB, 0.21961285E-10_JPRB, 0.22450890E-10_JPRB, &
  & 0.22982420E-10_JPRB, 0.23489535E-10_JPRB, 0.23688676E-10_JPRB, 0.22331985E-10_JPRB /)

RGHG4(:,72, 5) = (/ &
  & 0.24182587E-11_JPRB, 0.31178716E-11_JPRB, 0.37160852E-11_JPRB, 0.41316117E-11_JPRB, 0.44636113E-11_JPRB, 0.49163941E-11_JPRB, &
  & 0.69232020E-11_JPRB, 0.11405255E-10_JPRB, 0.11829769E-10_JPRB, 0.13125195E-10_JPRB, 0.13909040E-10_JPRB, 0.14379697E-10_JPRB, &
  & 0.14608622E-10_JPRB, 0.14745229E-10_JPRB, 0.14802730E-10_JPRB, 0.14804307E-10_JPRB, 0.14767586E-10_JPRB, 0.14697072E-10_JPRB, &
  & 0.14587644E-10_JPRB, 0.14467648E-10_JPRB, 0.14344183E-10_JPRB, 0.14256117E-10_JPRB, 0.14218814E-10_JPRB, 0.14277306E-10_JPRB, &
  & 0.14467290E-10_JPRB, 0.14786103E-10_JPRB, 0.15204438E-10_JPRB, 0.15673133E-10_JPRB, 0.16170827E-10_JPRB, 0.16657424E-10_JPRB, &
  & 0.17080065E-10_JPRB, 0.17386632E-10_JPRB, 0.17519449E-10_JPRB, 0.17505631E-10_JPRB, 0.17445810E-10_JPRB, 0.17465650E-10_JPRB, &
  & 0.17592091E-10_JPRB, 0.17806284E-10_JPRB, 0.18115662E-10_JPRB, 0.18495854E-10_JPRB, 0.18921392E-10_JPRB, 0.19357035E-10_JPRB, &
  & 0.19739205E-10_JPRB, 0.20117604E-10_JPRB, 0.20472993E-10_JPRB, 0.20858950E-10_JPRB, 0.21261229E-10_JPRB, 0.21658923E-10_JPRB, &
  & 0.22067959E-10_JPRB, 0.22419172E-10_JPRB, 0.22719078E-10_JPRB, 0.22996410E-10_JPRB, 0.23159925E-10_JPRB, 0.23271459E-10_JPRB, &
  & 0.23273380E-10_JPRB, 0.23492036E-10_JPRB, 0.24352492E-10_JPRB, 0.24913007E-10_JPRB, 0.25496777E-10_JPRB, 0.26060303E-10_JPRB, &
  & 0.26685881E-10_JPRB, 0.27279392E-10_JPRB, 0.27551008E-10_JPRB, 0.26267898E-10_JPRB /)

RGHG4(:,73, 5) = (/ &
  & 0.33006768E-11_JPRB, 0.43293320E-11_JPRB, 0.51470841E-11_JPRB, 0.56483030E-11_JPRB, 0.60460426E-11_JPRB, 0.66677558E-11_JPRB, &
  & 0.86946145E-11_JPRB, 0.13400090E-10_JPRB, 0.13484379E-10_JPRB, 0.14691243E-10_JPRB, 0.15572696E-10_JPRB, 0.15986519E-10_JPRB, &
  & 0.16222445E-10_JPRB, 0.16361664E-10_JPRB, 0.16425205E-10_JPRB, 0.16443067E-10_JPRB, 0.16427495E-10_JPRB, 0.16376520E-10_JPRB, &
  & 0.16305167E-10_JPRB, 0.16229164E-10_JPRB, 0.16153703E-10_JPRB, 0.16126163E-10_JPRB, 0.16170410E-10_JPRB, 0.16326093E-10_JPRB, &
  & 0.16624120E-10_JPRB, 0.17038435E-10_JPRB, 0.17583487E-10_JPRB, 0.18201459E-10_JPRB, 0.18803722E-10_JPRB, 0.19373170E-10_JPRB, &
  & 0.19873669E-10_JPRB, 0.20258021E-10_JPRB, 0.20466904E-10_JPRB, 0.20529498E-10_JPRB, 0.20543497E-10_JPRB, 0.20597940E-10_JPRB, &
  & 0.20734399E-10_JPRB, 0.20989850E-10_JPRB, 0.21338167E-10_JPRB, 0.21760064E-10_JPRB, 0.22233831E-10_JPRB, 0.22720440E-10_JPRB, &
  & 0.23155573E-10_JPRB, 0.23590902E-10_JPRB, 0.24001948E-10_JPRB, 0.24447742E-10_JPRB, 0.24915838E-10_JPRB, 0.25374933E-10_JPRB, &
  & 0.25865379E-10_JPRB, 0.26271192E-10_JPRB, 0.26623792E-10_JPRB, 0.26924858E-10_JPRB, 0.27118906E-10_JPRB, 0.27257148E-10_JPRB, &
  & 0.27288685E-10_JPRB, 0.27514789E-10_JPRB, 0.28347075E-10_JPRB, 0.28957772E-10_JPRB, 0.29570832E-10_JPRB, 0.30214199E-10_JPRB, &
  & 0.30911294E-10_JPRB, 0.31583406E-10_JPRB, 0.31887635E-10_JPRB, 0.30569339E-10_JPRB /)

RGHG4(:,74, 5) = (/ &
  & 0.47093904E-11_JPRB, 0.61419754E-11_JPRB, 0.71602164E-11_JPRB, 0.77713036E-11_JPRB, 0.82745625E-11_JPRB, 0.90582906E-11_JPRB, &
  & 0.11330176E-10_JPRB, 0.15873424E-10_JPRB, 0.15082246E-10_JPRB, 0.16436071E-10_JPRB, 0.17182745E-10_JPRB, 0.17671661E-10_JPRB, &
  & 0.17912156E-10_JPRB, 0.18088361E-10_JPRB, 0.18177562E-10_JPRB, 0.18237878E-10_JPRB, 0.18277768E-10_JPRB, 0.18286759E-10_JPRB, &
  & 0.18270760E-10_JPRB, 0.18251031E-10_JPRB, 0.18240316E-10_JPRB, 0.18292206E-10_JPRB, 0.18434181E-10_JPRB, 0.18703067E-10_JPRB, &
  & 0.19122277E-10_JPRB, 0.19690999E-10_JPRB, 0.20343820E-10_JPRB, 0.21035451E-10_JPRB, 0.21728119E-10_JPRB, 0.22391436E-10_JPRB, &
  & 0.22990823E-10_JPRB, 0.23463334E-10_JPRB, 0.23755596E-10_JPRB, 0.23895507E-10_JPRB, 0.23980875E-10_JPRB, 0.24120719E-10_JPRB, &
  & 0.24416320E-10_JPRB, 0.24730638E-10_JPRB, 0.25124866E-10_JPRB, 0.25597559E-10_JPRB, 0.26125865E-10_JPRB, 0.26667375E-10_JPRB, &
  & 0.27166356E-10_JPRB, 0.27652970E-10_JPRB, 0.28129605E-10_JPRB, 0.28643705E-10_JPRB, 0.29177265E-10_JPRB, 0.29692644E-10_JPRB, &
  & 0.30202073E-10_JPRB, 0.30649011E-10_JPRB, 0.31041648E-10_JPRB, 0.31419502E-10_JPRB, 0.31688187E-10_JPRB, 0.31887309E-10_JPRB, &
  & 0.31958842E-10_JPRB, 0.32180116E-10_JPRB, 0.33015157E-10_JPRB, 0.33605427E-10_JPRB, 0.34279617E-10_JPRB, 0.34950168E-10_JPRB, &
  & 0.35713064E-10_JPRB, 0.36441405E-10_JPRB, 0.36768377E-10_JPRB, 0.35374932E-10_JPRB /)

RGHG4(:,75, 5) = (/ &
  & 0.66846936E-11_JPRB, 0.85692486E-11_JPRB, 0.98309911E-11_JPRB, 0.10543953E-10_JPRB, 0.11139678E-10_JPRB, 0.12102524E-10_JPRB, &
  & 0.14349807E-10_JPRB, 0.18423318E-10_JPRB, 0.17064006E-10_JPRB, 0.18134773E-10_JPRB, 0.19001994E-10_JPRB, 0.19434150E-10_JPRB, &
  & 0.19720954E-10_JPRB, 0.19933617E-10_JPRB, 0.20087218E-10_JPRB, 0.20208189E-10_JPRB, 0.20316644E-10_JPRB, 0.20401528E-10_JPRB, &
  & 0.20470688E-10_JPRB, 0.20546266E-10_JPRB, 0.20627916E-10_JPRB, 0.20785224E-10_JPRB, 0.21047306E-10_JPRB, 0.21444393E-10_JPRB, &
  & 0.21995249E-10_JPRB, 0.22683836E-10_JPRB, 0.23493429E-10_JPRB, 0.24391260E-10_JPRB, 0.25237331E-10_JPRB, 0.26015017E-10_JPRB, &
  & 0.26725983E-10_JPRB, 0.27307896E-10_JPRB, 0.27721494E-10_JPRB, 0.27990811E-10_JPRB, 0.28202489E-10_JPRB, 0.28447156E-10_JPRB, &
  & 0.28699635E-10_JPRB, 0.29085977E-10_JPRB, 0.29538545E-10_JPRB, 0.30073850E-10_JPRB, 0.30661348E-10_JPRB, 0.31266517E-10_JPRB, &
  & 0.31817850E-10_JPRB, 0.32371258E-10_JPRB, 0.32913172E-10_JPRB, 0.33507242E-10_JPRB, 0.34121476E-10_JPRB, 0.34716726E-10_JPRB, &
  & 0.35318509E-10_JPRB, 0.35831092E-10_JPRB, 0.36283764E-10_JPRB, 0.36708209E-10_JPRB, 0.37018194E-10_JPRB, 0.37246574E-10_JPRB, &
  & 0.37354606E-10_JPRB, 0.37584800E-10_JPRB, 0.38367799E-10_JPRB, 0.38974459E-10_JPRB, 0.39630691E-10_JPRB, 0.40342625E-10_JPRB, &
  & 0.41138013E-10_JPRB, 0.41913115E-10_JPRB, 0.42228776E-10_JPRB, 0.40679366E-10_JPRB /)

RGHG4(:,76, 5) = (/ &
  & 0.92433561E-11_JPRB, 0.11707451E-10_JPRB, 0.13106430E-10_JPRB, 0.13931202E-10_JPRB, 0.14585973E-10_JPRB, 0.15562985E-10_JPRB, &
  & 0.17778142E-10_JPRB, 0.21432633E-10_JPRB, 0.18926423E-10_JPRB, 0.20052052E-10_JPRB, 0.20676837E-10_JPRB, 0.21213710E-10_JPRB, &
  & 0.21520173E-10_JPRB, 0.21839641E-10_JPRB, 0.22066186E-10_JPRB, 0.22294576E-10_JPRB, 0.22518636E-10_JPRB, 0.22727405E-10_JPRB, &
  & 0.22908187E-10_JPRB, 0.23102534E-10_JPRB, 0.23306308E-10_JPRB, 0.23597371E-10_JPRB, 0.24002815E-10_JPRB, 0.24549324E-10_JPRB, &
  & 0.25247877E-10_JPRB, 0.26134171E-10_JPRB, 0.27061478E-10_JPRB, 0.28041097E-10_JPRB, 0.28960511E-10_JPRB, 0.29836217E-10_JPRB, &
  & 0.30660464E-10_JPRB, 0.31363377E-10_JPRB, 0.31908969E-10_JPRB, 0.32322176E-10_JPRB, 0.32684824E-10_JPRB, 0.33078356E-10_JPRB, &
  & 0.33615392E-10_JPRB, 0.34095008E-10_JPRB, 0.34614395E-10_JPRB, 0.35224469E-10_JPRB, 0.35882231E-10_JPRB, 0.36551727E-10_JPRB, &
  & 0.37166482E-10_JPRB, 0.37782909E-10_JPRB, 0.38398614E-10_JPRB, 0.39083185E-10_JPRB, 0.39782910E-10_JPRB, 0.40452666E-10_JPRB, &
  & 0.41063923E-10_JPRB, 0.41613664E-10_JPRB, 0.42113407E-10_JPRB, 0.42616077E-10_JPRB, 0.43017132E-10_JPRB, 0.43344429E-10_JPRB, &
  & 0.43499680E-10_JPRB, 0.43728320E-10_JPRB, 0.44479320E-10_JPRB, 0.45026673E-10_JPRB, 0.45679294E-10_JPRB, 0.46377516E-10_JPRB, &
  & 0.47193891E-10_JPRB, 0.47982736E-10_JPRB, 0.48268153E-10_JPRB, 0.46519205E-10_JPRB /)

RGHG4(:,77, 5) = (/ &
  & 0.12450875E-10_JPRB, 0.15415356E-10_JPRB, 0.16971593E-10_JPRB, 0.17812363E-10_JPRB, 0.18467745E-10_JPRB, 0.19371381E-10_JPRB, &
  & 0.21280266E-10_JPRB, 0.24306527E-10_JPRB, 0.21054139E-10_JPRB, 0.21811952E-10_JPRB, 0.22511912E-10_JPRB, 0.22947149E-10_JPRB, &
  & 0.23335401E-10_JPRB, 0.23724720E-10_JPRB, 0.24078997E-10_JPRB, 0.24428693E-10_JPRB, 0.24789471E-10_JPRB, 0.25149204E-10_JPRB, &
  & 0.25490020E-10_JPRB, 0.25852091E-10_JPRB, 0.26219443E-10_JPRB, 0.26674307E-10_JPRB, 0.27254147E-10_JPRB, 0.27966541E-10_JPRB, &
  & 0.28823161E-10_JPRB, 0.29864781E-10_JPRB, 0.30960855E-10_JPRB, 0.32195378E-10_JPRB, 0.33345604E-10_JPRB, 0.34404972E-10_JPRB, &
  & 0.35379876E-10_JPRB, 0.36242963E-10_JPRB, 0.36970704E-10_JPRB, 0.37574076E-10_JPRB, 0.38111153E-10_JPRB, 0.38635338E-10_JPRB, &
  & 0.39110853E-10_JPRB, 0.39668213E-10_JPRB, 0.40278642E-10_JPRB, 0.40978460E-10_JPRB, 0.41717615E-10_JPRB, 0.42468563E-10_JPRB, &
  & 0.43138035E-10_JPRB, 0.43825582E-10_JPRB, 0.44516002E-10_JPRB, 0.45283322E-10_JPRB, 0.46101935E-10_JPRB, 0.46840212E-10_JPRB, &
  & 0.47568414E-10_JPRB, 0.48178073E-10_JPRB, 0.48756454E-10_JPRB, 0.49299540E-10_JPRB, 0.49739039E-10_JPRB, 0.50097482E-10_JPRB, &
  & 0.50294852E-10_JPRB, 0.50540759E-10_JPRB, 0.51226235E-10_JPRB, 0.51727497E-10_JPRB, 0.52323021E-10_JPRB, 0.52971069E-10_JPRB, &
  & 0.53774103E-10_JPRB, 0.54560086E-10_JPRB, 0.54779393E-10_JPRB, 0.52840354E-10_JPRB /)

RGHG4(:,78, 5) = (/ &
  & 0.16253623E-10_JPRB, 0.19558338E-10_JPRB, 0.21040161E-10_JPRB, 0.21861162E-10_JPRB, 0.22432499E-10_JPRB, 0.23224495E-10_JPRB, &
  & 0.24745943E-10_JPRB, 0.27045120E-10_JPRB, 0.22783749E-10_JPRB, 0.23436511E-10_JPRB, 0.23929275E-10_JPRB, 0.24461393E-10_JPRB, &
  & 0.24880195E-10_JPRB, 0.25403993E-10_JPRB, 0.25877996E-10_JPRB, 0.26382669E-10_JPRB, 0.26917872E-10_JPRB, 0.27454147E-10_JPRB, &
  & 0.27984188E-10_JPRB, 0.28542693E-10_JPRB, 0.29108015E-10_JPRB, 0.29764885E-10_JPRB, 0.30538613E-10_JPRB, 0.31421116E-10_JPRB, &
  & 0.32445956E-10_JPRB, 0.33654624E-10_JPRB, 0.34851809E-10_JPRB, 0.36108099E-10_JPRB, 0.37257648E-10_JPRB, 0.38343238E-10_JPRB, &
  & 0.39398092E-10_JPRB, 0.40392991E-10_JPRB, 0.41303277E-10_JPRB, 0.42140024E-10_JPRB, 0.42946310E-10_JPRB, 0.43749566E-10_JPRB, &
  & 0.44559325E-10_JPRB, 0.45335267E-10_JPRB, 0.46043183E-10_JPRB, 0.46848046E-10_JPRB, 0.47672713E-10_JPRB, 0.48495517E-10_JPRB, &
  & 0.49217488E-10_JPRB, 0.49960387E-10_JPRB, 0.50708767E-10_JPRB, 0.51553983E-10_JPRB, 0.52448847E-10_JPRB, 0.53221493E-10_JPRB, &
  & 0.53943277E-10_JPRB, 0.54549778E-10_JPRB, 0.55155130E-10_JPRB, 0.55760722E-10_JPRB, 0.56296707E-10_JPRB, 0.56762411E-10_JPRB, &
  & 0.57053667E-10_JPRB, 0.57333114E-10_JPRB, 0.58002794E-10_JPRB, 0.58442987E-10_JPRB, 0.58946729E-10_JPRB, 0.59556561E-10_JPRB, &
  & 0.60296268E-10_JPRB, 0.61075207E-10_JPRB, 0.61352291E-10_JPRB, 0.59539776E-10_JPRB /)

RGHG4(:,79, 5) = (/ &
  & 0.20453637E-10_JPRB, 0.23319530E-10_JPRB, 0.24218917E-10_JPRB, 0.24765370E-10_JPRB, 0.25130089E-10_JPRB, 0.25695331E-10_JPRB, &
  & 0.26750472E-10_JPRB, 0.28487010E-10_JPRB, 0.23814608E-10_JPRB, 0.24307315E-10_JPRB, 0.24844026E-10_JPRB, 0.25304005E-10_JPRB, &
  & 0.25774787E-10_JPRB, 0.26350483E-10_JPRB, 0.26920965E-10_JPRB, 0.27534494E-10_JPRB, 0.28222851E-10_JPRB, 0.28932946E-10_JPRB, &
  & 0.29651299E-10_JPRB, 0.30402233E-10_JPRB, 0.31154135E-10_JPRB, 0.31989772E-10_JPRB, 0.32890218E-10_JPRB, 0.33828825E-10_JPRB, &
  & 0.34899538E-10_JPRB, 0.35984670E-10_JPRB, 0.37087288E-10_JPRB, 0.38267983E-10_JPRB, 0.39478625E-10_JPRB, 0.40598681E-10_JPRB, &
  & 0.41687574E-10_JPRB, 0.42756892E-10_JPRB, 0.43778207E-10_JPRB, 0.44759595E-10_JPRB, 0.45731231E-10_JPRB, 0.46711027E-10_JPRB, &
  & 0.47670919E-10_JPRB, 0.48545813E-10_JPRB, 0.49499189E-10_JPRB, 0.50470943E-10_JPRB, 0.51402070E-10_JPRB, 0.52280943E-10_JPRB, &
  & 0.53025171E-10_JPRB, 0.53784404E-10_JPRB, 0.54519271E-10_JPRB, 0.55343195E-10_JPRB, 0.56192891E-10_JPRB, 0.56913394E-10_JPRB, &
  & 0.57610576E-10_JPRB, 0.58197537E-10_JPRB, 0.58802477E-10_JPRB, 0.59404801E-10_JPRB, 0.59949351E-10_JPRB, 0.60464016E-10_JPRB, &
  & 0.60861607E-10_JPRB, 0.61299348E-10_JPRB, 0.62073562E-10_JPRB, 0.62598975E-10_JPRB, 0.63155002E-10_JPRB, 0.63750859E-10_JPRB, &
  & 0.64523463E-10_JPRB, 0.65403613E-10_JPRB, 0.65986723E-10_JPRB, 0.65261789E-10_JPRB /)

RGHG4(:,80, 5) = (/ &
  & 0.23224521E-10_JPRB, 0.24834749E-10_JPRB, 0.25245851E-10_JPRB, 0.25620939E-10_JPRB, 0.25892765E-10_JPRB, 0.26458462E-10_JPRB, &
  & 0.27427121E-10_JPRB, 0.29004958E-10_JPRB, 0.24385589E-10_JPRB, 0.24816050E-10_JPRB, 0.25321389E-10_JPRB, 0.25836999E-10_JPRB, &
  & 0.26321754E-10_JPRB, 0.26941747E-10_JPRB, 0.27540624E-10_JPRB, 0.28185097E-10_JPRB, 0.28898745E-10_JPRB, 0.29637581E-10_JPRB, &
  & 0.30396661E-10_JPRB, 0.31196809E-10_JPRB, 0.32006491E-10_JPRB, 0.32901223E-10_JPRB, 0.33825668E-10_JPRB, 0.34797804E-10_JPRB, &
  & 0.35950753E-10_JPRB, 0.37041967E-10_JPRB, 0.38311507E-10_JPRB, 0.39464206E-10_JPRB, 0.40626596E-10_JPRB, 0.41764543E-10_JPRB, &
  & 0.42880820E-10_JPRB, 0.43984691E-10_JPRB, 0.45059317E-10_JPRB, 0.46113557E-10_JPRB, 0.47170278E-10_JPRB, 0.48229417E-10_JPRB, &
  & 0.49267774E-10_JPRB, 0.50295129E-10_JPRB, 0.51216486E-10_JPRB, 0.52142773E-10_JPRB, 0.53074573E-10_JPRB, 0.53959490E-10_JPRB, &
  & 0.54725877E-10_JPRB, 0.55508886E-10_JPRB, 0.56283984E-10_JPRB, 0.57154545E-10_JPRB, 0.58073581E-10_JPRB, 0.58819914E-10_JPRB, &
  & 0.59514733E-10_JPRB, 0.60089919E-10_JPRB, 0.60699078E-10_JPRB, 0.61320261E-10_JPRB, 0.61907646E-10_JPRB, 0.62453348E-10_JPRB, &
  & 0.62851349E-10_JPRB, 0.63224037E-10_JPRB, 0.63895993E-10_JPRB, 0.64334066E-10_JPRB, 0.64802740E-10_JPRB, 0.65399908E-10_JPRB, &
  & 0.66132606E-10_JPRB, 0.67104981E-10_JPRB, 0.67882103E-10_JPRB, 0.68294384E-10_JPRB /)

RGHG4(:,81, 5) = (/ &
  & 0.25057839E-10_JPRB, 0.25584654E-10_JPRB, 0.25874245E-10_JPRB, 0.26205814E-10_JPRB, 0.26484483E-10_JPRB, 0.27034156E-10_JPRB, &
  & 0.27849428E-10_JPRB, 0.29382830E-10_JPRB, 0.24658805E-10_JPRB, 0.25171341E-10_JPRB, 0.25656919E-10_JPRB, 0.26157212E-10_JPRB, &
  & 0.26658063E-10_JPRB, 0.27277491E-10_JPRB, 0.27908439E-10_JPRB, 0.28598532E-10_JPRB, 0.29367571E-10_JPRB, 0.30160614E-10_JPRB, &
  & 0.30972006E-10_JPRB, 0.31810197E-10_JPRB, 0.32660055E-10_JPRB, 0.33597576E-10_JPRB, 0.34512004E-10_JPRB, 0.35576552E-10_JPRB, &
  & 0.36668932E-10_JPRB, 0.37733854E-10_JPRB, 0.38875049E-10_JPRB, 0.40052600E-10_JPRB, 0.41247887E-10_JPRB, 0.42411852E-10_JPRB, &
  & 0.43539856E-10_JPRB, 0.44658499E-10_JPRB, 0.45762907E-10_JPRB, 0.46861629E-10_JPRB, 0.47959223E-10_JPRB, 0.49054483E-10_JPRB, &
  & 0.50122399E-10_JPRB, 0.51133896E-10_JPRB, 0.52169723E-10_JPRB, 0.53200250E-10_JPRB, 0.54216610E-10_JPRB, 0.55110434E-10_JPRB, &
  & 0.55906842E-10_JPRB, 0.56694746E-10_JPRB, 0.57455433E-10_JPRB, 0.58311522E-10_JPRB, 0.59174825E-10_JPRB, 0.59867229E-10_JPRB, &
  & 0.60560487E-10_JPRB, 0.61140412E-10_JPRB, 0.61746074E-10_JPRB, 0.62352547E-10_JPRB, 0.62920474E-10_JPRB, 0.63469618E-10_JPRB, &
  & 0.63917871E-10_JPRB, 0.64375380E-10_JPRB, 0.65089989E-10_JPRB, 0.65563069E-10_JPRB, 0.66042859E-10_JPRB, 0.66620695E-10_JPRB, &
  & 0.67348176E-10_JPRB, 0.68353163E-10_JPRB, 0.69239316E-10_JPRB, 0.70786335E-10_JPRB /)

RGHG4(:,82, 5) = (/ &
  & 0.26292713E-10_JPRB, 0.25902544E-10_JPRB, 0.26071744E-10_JPRB, 0.26300856E-10_JPRB, 0.26592506E-10_JPRB, 0.27100960E-10_JPRB, &
  & 0.27948520E-10_JPRB, 0.29317201E-10_JPRB, 0.25003562E-10_JPRB, 0.25351252E-10_JPRB, 0.25926747E-10_JPRB, 0.26406320E-10_JPRB, &
  & 0.26909973E-10_JPRB, 0.27565254E-10_JPRB, 0.28190625E-10_JPRB, 0.28879668E-10_JPRB, 0.29633823E-10_JPRB, 0.30427775E-10_JPRB, &
  & 0.31234692E-10_JPRB, 0.32088898E-10_JPRB, 0.32961640E-10_JPRB, 0.33887042E-10_JPRB, 0.34808805E-10_JPRB, 0.35924652E-10_JPRB, &
  & 0.36930830E-10_JPRB, 0.38154514E-10_JPRB, 0.39305996E-10_JPRB, 0.40515275E-10_JPRB, 0.41666715E-10_JPRB, 0.42839010E-10_JPRB, &
  & 0.43989222E-10_JPRB, 0.45116418E-10_JPRB, 0.46231990E-10_JPRB, 0.47355588E-10_JPRB, 0.48478957E-10_JPRB, 0.49596768E-10_JPRB, &
  & 0.50681230E-10_JPRB, 0.51761154E-10_JPRB, 0.52757732E-10_JPRB, 0.53706078E-10_JPRB, 0.54688188E-10_JPRB, 0.55556618E-10_JPRB, &
  & 0.56369031E-10_JPRB, 0.57158830E-10_JPRB, 0.57954294E-10_JPRB, 0.58848725E-10_JPRB, 0.59789389E-10_JPRB, 0.60543626E-10_JPRB, &
  & 0.61248860E-10_JPRB, 0.61838874E-10_JPRB, 0.62455617E-10_JPRB, 0.63076842E-10_JPRB, 0.63679617E-10_JPRB, 0.64247441E-10_JPRB, &
  & 0.64675716E-10_JPRB, 0.65055905E-10_JPRB, 0.65664064E-10_JPRB, 0.66058173E-10_JPRB, 0.66481196E-10_JPRB, 0.67069364E-10_JPRB, &
  & 0.67742631E-10_JPRB, 0.68802818E-10_JPRB, 0.69645199E-10_JPRB, 0.71848465E-10_JPRB /)

RGHG4(:,83, 5) = (/ &
  & 0.26358762E-10_JPRB, 0.26050733E-10_JPRB, 0.26167110E-10_JPRB, 0.26425405E-10_JPRB, 0.26806356E-10_JPRB, 0.27295777E-10_JPRB, &
  & 0.28099321E-10_JPRB, 0.29640131E-10_JPRB, 0.25039618E-10_JPRB, 0.25665296E-10_JPRB, 0.26054952E-10_JPRB, 0.26616372E-10_JPRB, &
  & 0.27103007E-10_JPRB, 0.27728403E-10_JPRB, 0.28390502E-10_JPRB, 0.29108299E-10_JPRB, 0.29899330E-10_JPRB, 0.30705161E-10_JPRB, &
  & 0.31532651E-10_JPRB, 0.32386659E-10_JPRB, 0.33270945E-10_JPRB, 0.34167499E-10_JPRB, 0.35171647E-10_JPRB, 0.36232312E-10_JPRB, &
  & 0.37285914E-10_JPRB, 0.38441816E-10_JPRB, 0.39566309E-10_JPRB, 0.40769176E-10_JPRB, 0.41975645E-10_JPRB, 0.43146382E-10_JPRB, &
  & 0.44297989E-10_JPRB, 0.45433921E-10_JPRB, 0.46572590E-10_JPRB, 0.47723842E-10_JPRB, 0.48873822E-10_JPRB, 0.50002162E-10_JPRB, &
  & 0.51110120E-10_JPRB, 0.52174084E-10_JPRB, 0.53192249E-10_JPRB, 0.54273780E-10_JPRB, 0.55278941E-10_JPRB, 0.56155119E-10_JPRB, &
  & 0.56984910E-10_JPRB, 0.57770639E-10_JPRB, 0.58568136E-10_JPRB, 0.59457446E-10_JPRB, 0.60356359E-10_JPRB, 0.61055293E-10_JPRB, &
  & 0.61752485E-10_JPRB, 0.62348883E-10_JPRB, 0.62968825E-10_JPRB, 0.63582660E-10_JPRB, 0.64164479E-10_JPRB, 0.64722998E-10_JPRB, &
  & 0.65190256E-10_JPRB, 0.65637079E-10_JPRB, 0.66278379E-10_JPRB, 0.66683555E-10_JPRB, 0.67080064E-10_JPRB, 0.67682575E-10_JPRB, &
  & 0.68296646E-10_JPRB, 0.69364500E-10_JPRB, 0.70119292E-10_JPRB, 0.71860684E-10_JPRB /)

RGHG4(:,84, 5) = (/ &
  & 0.26392021E-10_JPRB, 0.26215514E-10_JPRB, 0.26159646E-10_JPRB, 0.26488959E-10_JPRB, 0.26866998E-10_JPRB, 0.27280390E-10_JPRB, &
  & 0.28204123E-10_JPRB, 0.29398196E-10_JPRB, 0.25413524E-10_JPRB, 0.25679648E-10_JPRB, 0.26329732E-10_JPRB, 0.26726742E-10_JPRB, &
  & 0.27267952E-10_JPRB, 0.27905990E-10_JPRB, 0.28537115E-10_JPRB, 0.29261097E-10_JPRB, 0.30037760E-10_JPRB, 0.30849514E-10_JPRB, &
  & 0.31674947E-10_JPRB, 0.32545099E-10_JPRB, 0.33412117E-10_JPRB, 0.34329067E-10_JPRB, 0.35364045E-10_JPRB, 0.36345003E-10_JPRB, &
  & 0.37495517E-10_JPRB, 0.38631143E-10_JPRB, 0.39828297E-10_JPRB, 0.41023400E-10_JPRB, 0.42211023E-10_JPRB, 0.43405054E-10_JPRB, &
  & 0.44579312E-10_JPRB, 0.45724563E-10_JPRB, 0.46859017E-10_JPRB, 0.48027398E-10_JPRB, 0.49194988E-10_JPRB, 0.50357982E-10_JPRB, &
  & 0.51484341E-10_JPRB, 0.52585498E-10_JPRB, 0.53619519E-10_JPRB, 0.54528951E-10_JPRB, 0.55479864E-10_JPRB, 0.56340856E-10_JPRB, &
  & 0.57151939E-10_JPRB, 0.57947605E-10_JPRB, 0.58751670E-10_JPRB, 0.59687220E-10_JPRB, 0.60645114E-10_JPRB, 0.61423679E-10_JPRB, &
  & 0.62148495E-10_JPRB, 0.62753878E-10_JPRB, 0.63381286E-10_JPRB, 0.64018388E-10_JPRB, 0.64615147E-10_JPRB, 0.65209019E-10_JPRB, &
  & 0.65648688E-10_JPRB, 0.66041159E-10_JPRB, 0.66595292E-10_JPRB, 0.66956621E-10_JPRB, 0.67282978E-10_JPRB, 0.67943755E-10_JPRB, &
  & 0.68491914E-10_JPRB, 0.69609790E-10_JPRB, 0.70366685E-10_JPRB, 0.72306945E-10_JPRB /)

RGHG4(:,85, 5) = (/ &
  & 0.26410341E-10_JPRB, 0.26345728E-10_JPRB, 0.26111550E-10_JPRB, 0.26607383E-10_JPRB, 0.26929244E-10_JPRB, 0.27394070E-10_JPRB, &
  & 0.28421153E-10_JPRB, 0.29738836E-10_JPRB, 0.25356143E-10_JPRB, 0.26001470E-10_JPRB, 0.26335966E-10_JPRB, 0.26962174E-10_JPRB, &
  & 0.27352653E-10_JPRB, 0.28019158E-10_JPRB, 0.28647548E-10_JPRB, 0.29363970E-10_JPRB, 0.30172729E-10_JPRB, 0.31005018E-10_JPRB, &
  & 0.31833969E-10_JPRB, 0.32698524E-10_JPRB, 0.33570532E-10_JPRB, 0.34523738E-10_JPRB, 0.35501758E-10_JPRB, 0.36543542E-10_JPRB, &
  & 0.37663185E-10_JPRB, 0.38782619E-10_JPRB, 0.39960715E-10_JPRB, 0.41170626E-10_JPRB, 0.42391785E-10_JPRB, 0.43581382E-10_JPRB, &
  & 0.44741336E-10_JPRB, 0.45896946E-10_JPRB, 0.47073762E-10_JPRB, 0.48270839E-10_JPRB, 0.49464141E-10_JPRB, 0.50645883E-10_JPRB, &
  & 0.51792941E-10_JPRB, 0.52874084E-10_JPRB, 0.53914595E-10_JPRB, 0.54964248E-10_JPRB, 0.55916140E-10_JPRB, 0.56783411E-10_JPRB, &
  & 0.57545045E-10_JPRB, 0.58348423E-10_JPRB, 0.59153279E-10_JPRB, 0.60084319E-10_JPRB, 0.61035600E-10_JPRB, 0.61749071E-10_JPRB, &
  & 0.62460460E-10_JPRB, 0.63069397E-10_JPRB, 0.63697339E-10_JPRB, 0.64343815E-10_JPRB, 0.64909578E-10_JPRB, 0.65518931E-10_JPRB, &
  & 0.65956442E-10_JPRB, 0.66435565E-10_JPRB, 0.66966051E-10_JPRB, 0.67400328E-10_JPRB, 0.67625155E-10_JPRB, 0.68353732E-10_JPRB, &
  & 0.68835507E-10_JPRB, 0.69942753E-10_JPRB, 0.70644809E-10_JPRB, 0.72476580E-10_JPRB /)

RGHG4(:,86, 5) = (/ &
  & 0.26391757E-10_JPRB, 0.26438825E-10_JPRB, 0.26049005E-10_JPRB, 0.26727960E-10_JPRB, 0.26899542E-10_JPRB, 0.27495676E-10_JPRB, &
  & 0.28458231E-10_JPRB, 0.29551667E-10_JPRB, 0.25753023E-10_JPRB, 0.25944982E-10_JPRB, 0.26670327E-10_JPRB, 0.26956878E-10_JPRB, &
  & 0.27572691E-10_JPRB, 0.28066782E-10_JPRB, 0.28701090E-10_JPRB, 0.29409253E-10_JPRB, 0.30189570E-10_JPRB, 0.31016852E-10_JPRB, &
  & 0.31882441E-10_JPRB, 0.32760347E-10_JPRB, 0.33659790E-10_JPRB, 0.34600007E-10_JPRB, 0.35580667E-10_JPRB, 0.36636118E-10_JPRB, &
  & 0.37737782E-10_JPRB, 0.38901552E-10_JPRB, 0.40090299E-10_JPRB, 0.41314282E-10_JPRB, 0.42535076E-10_JPRB, 0.43758788E-10_JPRB, &
  & 0.44984537E-10_JPRB, 0.46140803E-10_JPRB, 0.47279399E-10_JPRB, 0.48466682E-10_JPRB, 0.49677217E-10_JPRB, 0.50873035E-10_JPRB, &
  & 0.52080073E-10_JPRB, 0.53197738E-10_JPRB, 0.54261616E-10_JPRB, 0.55165591E-10_JPRB, 0.56051837E-10_JPRB, 0.56939720E-10_JPRB, &
  & 0.57666271E-10_JPRB, 0.58492974E-10_JPRB, 0.59271817E-10_JPRB, 0.60213896E-10_JPRB, 0.61184717E-10_JPRB, 0.61969242E-10_JPRB, &
  & 0.62704932E-10_JPRB, 0.63323458E-10_JPRB, 0.63957312E-10_JPRB, 0.64623487E-10_JPRB, 0.65200449E-10_JPRB, 0.65847529E-10_JPRB, &
  & 0.66247667E-10_JPRB, 0.66728623E-10_JPRB, 0.67152638E-10_JPRB, 0.67612992E-10_JPRB, 0.67770609E-10_JPRB, 0.68524381E-10_JPRB, &
  & 0.69005239E-10_JPRB, 0.70119112E-10_JPRB, 0.70827275E-10_JPRB, 0.72716118E-10_JPRB /)

RGHG4(:,87, 5) = (/ &
  & 0.26302523E-10_JPRB, 0.26513099E-10_JPRB, 0.26005625E-10_JPRB, 0.26838752E-10_JPRB, 0.26855157E-10_JPRB, 0.27670043E-10_JPRB, &
  & 0.28692224E-10_JPRB, 0.29925080E-10_JPRB, 0.25700594E-10_JPRB, 0.26279316E-10_JPRB, 0.26613342E-10_JPRB, 0.27219822E-10_JPRB, &
  & 0.27565682E-10_JPRB, 0.28144117E-10_JPRB, 0.28755812E-10_JPRB, 0.29383315E-10_JPRB, 0.30220756E-10_JPRB, 0.31054194E-10_JPRB, &
  & 0.31928425E-10_JPRB, 0.32825600E-10_JPRB, 0.33741551E-10_JPRB, 0.34676598E-10_JPRB, 0.35682818E-10_JPRB, 0.36724231E-10_JPRB, &
  & 0.37835360E-10_JPRB, 0.38985471E-10_JPRB, 0.40177733E-10_JPRB, 0.41411409E-10_JPRB, 0.42654661E-10_JPRB, 0.43857890E-10_JPRB, &
  & 0.44994029E-10_JPRB, 0.46181083E-10_JPRB, 0.47427166E-10_JPRB, 0.48626981E-10_JPRB, 0.49831726E-10_JPRB, 0.51070061E-10_JPRB, &
  & 0.52242696E-10_JPRB, 0.53382097E-10_JPRB, 0.54440116E-10_JPRB, 0.55509708E-10_JPRB, 0.56413107E-10_JPRB, 0.57325211E-10_JPRB, &
  & 0.58030060E-10_JPRB, 0.58841688E-10_JPRB, 0.59621683E-10_JPRB, 0.60548580E-10_JPRB, 0.61485129E-10_JPRB, 0.62198115E-10_JPRB, &
  & 0.62911169E-10_JPRB, 0.63514367E-10_JPRB, 0.64158498E-10_JPRB, 0.64817950E-10_JPRB, 0.65397840E-10_JPRB, 0.66038001E-10_JPRB, &
  & 0.66453364E-10_JPRB, 0.66973337E-10_JPRB, 0.67409717E-10_JPRB, 0.67875768E-10_JPRB, 0.68039220E-10_JPRB, 0.68752060E-10_JPRB, &
  & 0.69258842E-10_JPRB, 0.70329756E-10_JPRB, 0.71018559E-10_JPRB, 0.72861744E-10_JPRB /)

RGHG4(:,88, 5) = (/ &
  & 0.26322168E-10_JPRB, 0.26581902E-10_JPRB, 0.25991371E-10_JPRB, 0.26910299E-10_JPRB, 0.26781631E-10_JPRB, 0.27841660E-10_JPRB, &
  & 0.28488122E-10_JPRB, 0.29733264E-10_JPRB, 0.25967109E-10_JPRB, 0.26280511E-10_JPRB, 0.26854730E-10_JPRB, 0.27211997E-10_JPRB, &
  & 0.27635484E-10_JPRB, 0.28194688E-10_JPRB, 0.28683413E-10_JPRB, 0.29448277E-10_JPRB, 0.30162983E-10_JPRB, 0.31061976E-10_JPRB, &
  & 0.31917267E-10_JPRB, 0.32861117E-10_JPRB, 0.33762718E-10_JPRB, 0.34734819E-10_JPRB, 0.35724250E-10_JPRB, 0.36775121E-10_JPRB, &
  & 0.37885028E-10_JPRB, 0.39047529E-10_JPRB, 0.40247892E-10_JPRB, 0.41490467E-10_JPRB, 0.42734975E-10_JPRB, 0.44017727E-10_JPRB, &
  & 0.45318062E-10_JPRB, 0.46446132E-10_JPRB, 0.47567915E-10_JPRB, 0.48770748E-10_JPRB, 0.49994332E-10_JPRB, 0.51221295E-10_JPRB, &
  & 0.52435674E-10_JPRB, 0.53597269E-10_JPRB, 0.54702517E-10_JPRB, 0.55692822E-10_JPRB, 0.56643912E-10_JPRB, 0.57520558E-10_JPRB, &
  & 0.58283198E-10_JPRB, 0.59069326E-10_JPRB, 0.59814459E-10_JPRB, 0.60699987E-10_JPRB, 0.61611938E-10_JPRB, 0.62346885E-10_JPRB, &
  & 0.63069459E-10_JPRB, 0.63678805E-10_JPRB, 0.64321160E-10_JPRB, 0.64990999E-10_JPRB, 0.65592969E-10_JPRB, 0.66232547E-10_JPRB, &
  & 0.66665728E-10_JPRB, 0.67139572E-10_JPRB, 0.67582093E-10_JPRB, 0.67977991E-10_JPRB, 0.68185138E-10_JPRB, 0.68848045E-10_JPRB, &
  & 0.69391576E-10_JPRB, 0.70444144E-10_JPRB, 0.71162756E-10_JPRB, 0.72982578E-10_JPRB /)

RGHG4(:,89, 5) = (/ &
  & 0.26266524E-10_JPRB, 0.26663075E-10_JPRB, 0.25954685E-10_JPRB, 0.26844919E-10_JPRB, 0.26734844E-10_JPRB, 0.27631970E-10_JPRB, &
  & 0.28354289E-10_JPRB, 0.29675529E-10_JPRB, 0.25875233E-10_JPRB, 0.26375077E-10_JPRB, 0.26803707E-10_JPRB, 0.27216963E-10_JPRB, &
  & 0.27630113E-10_JPRB, 0.28092723E-10_JPRB, 0.28772890E-10_JPRB, 0.29368698E-10_JPRB, 0.30281461E-10_JPRB, 0.31064651E-10_JPRB, &
  & 0.32015206E-10_JPRB, 0.32876681E-10_JPRB, 0.33822851E-10_JPRB, 0.34753034E-10_JPRB, 0.35754701E-10_JPRB, 0.36794196E-10_JPRB, &
  & 0.37906019E-10_JPRB, 0.39063124E-10_JPRB, 0.40265982E-10_JPRB, 0.41520846E-10_JPRB, 0.42779679E-10_JPRB, 0.43949042E-10_JPRB, &
  & 0.45082462E-10_JPRB, 0.46376285E-10_JPRB, 0.47669382E-10_JPRB, 0.48902427E-10_JPRB, 0.50142859E-10_JPRB, 0.51387779E-10_JPRB, &
  & 0.52609282E-10_JPRB, 0.53784779E-10_JPRB, 0.54902752E-10_JPRB, 0.55964903E-10_JPRB, 0.56962386E-10_JPRB, 0.57851952E-10_JPRB, &
  & 0.58616362E-10_JPRB, 0.59381160E-10_JPRB, 0.60087747E-10_JPRB, 0.60963443E-10_JPRB, 0.61831373E-10_JPRB, 0.62514952E-10_JPRB, &
  & 0.63206371E-10_JPRB, 0.63799147E-10_JPRB, 0.64450285E-10_JPRB, 0.65109598E-10_JPRB, 0.65724592E-10_JPRB, 0.66352798E-10_JPRB, &
  & 0.66813485E-10_JPRB, 0.67282117E-10_JPRB, 0.67764773E-10_JPRB, 0.68134005E-10_JPRB, 0.68365882E-10_JPRB, 0.68987170E-10_JPRB, &
  & 0.69560850E-10_JPRB, 0.70551454E-10_JPRB, 0.71312768E-10_JPRB, 0.73062903E-10_JPRB /)

RGHG4(:,90, 5) = (/ &
  & 0.26246618E-10_JPRB, 0.26759215E-10_JPRB, 0.26023312E-10_JPRB, 0.26703794E-10_JPRB, 0.26785065E-10_JPRB, 0.27297132E-10_JPRB, &
  & 0.27973054E-10_JPRB, 0.28940251E-10_JPRB, 0.25547673E-10_JPRB, 0.26303557E-10_JPRB, 0.26777263E-10_JPRB, 0.27231667E-10_JPRB, &
  & 0.27473603E-10_JPRB, 0.28164361E-10_JPRB, 0.28655514E-10_JPRB, 0.29504493E-10_JPRB, 0.30241067E-10_JPRB, 0.31171638E-10_JPRB, &
  & 0.31976196E-10_JPRB, 0.32904818E-10_JPRB, 0.33781380E-10_JPRB, 0.34730555E-10_JPRB, 0.35712062E-10_JPRB, 0.36754971E-10_JPRB, &
  & 0.37860735E-10_JPRB, 0.39020627E-10_JPRB, 0.40228564E-10_JPRB, 0.41492140E-10_JPRB, 0.42802265E-10_JPRB, 0.44173880E-10_JPRB, &
  & 0.45514287E-10_JPRB, 0.46634079E-10_JPRB, 0.47779208E-10_JPRB, 0.49054039E-10_JPRB, 0.50324200E-10_JPRB, 0.51614952E-10_JPRB, &
  & 0.52863370E-10_JPRB, 0.54057328E-10_JPRB, 0.55203134E-10_JPRB, 0.56252177E-10_JPRB, 0.57245791E-10_JPRB, 0.58114784E-10_JPRB, &
  & 0.58854539E-10_JPRB, 0.59604634E-10_JPRB, 0.60238897E-10_JPRB, 0.61047264E-10_JPRB, 0.61915896E-10_JPRB, 0.62611027E-10_JPRB, &
  & 0.63301517E-10_JPRB, 0.63905319E-10_JPRB, 0.64554070E-10_JPRB, 0.65225686E-10_JPRB, 0.65854378E-10_JPRB, 0.66478087E-10_JPRB, &
  & 0.66950494E-10_JPRB, 0.67392335E-10_JPRB, 0.67885565E-10_JPRB, 0.68211860E-10_JPRB, 0.68484517E-10_JPRB, 0.69034368E-10_JPRB, &
  & 0.69691412E-10_JPRB, 0.70591061E-10_JPRB, 0.71459040E-10_JPRB, 0.73122446E-10_JPRB /)

RGHG4(:,91, 5) = (/ &
  & 0.26449757E-10_JPRB, 0.26626919E-10_JPRB, 0.26171846E-10_JPRB, 0.26377272E-10_JPRB, 0.26659461E-10_JPRB, 0.26648742E-10_JPRB, &
  & 0.27626970E-10_JPRB, 0.26984011E-10_JPRB, 0.25012712E-10_JPRB, 0.26345181E-10_JPRB, 0.26626300E-10_JPRB, 0.26877578E-10_JPRB, &
  & 0.27254088E-10_JPRB, 0.28161602E-10_JPRB, 0.28862909E-10_JPRB, 0.29537026E-10_JPRB, 0.30370352E-10_JPRB, 0.31156529E-10_JPRB, &
  & 0.32009694E-10_JPRB, 0.32860398E-10_JPRB, 0.33729481E-10_JPRB, 0.34639704E-10_JPRB, 0.35597841E-10_JPRB, 0.36623517E-10_JPRB, &
  & 0.37717895E-10_JPRB, 0.38853577E-10_JPRB, 0.40109742E-10_JPRB, 0.41383272E-10_JPRB, 0.42648978E-10_JPRB, 0.43910143E-10_JPRB, &
  & 0.45193741E-10_JPRB, 0.46521665E-10_JPRB, 0.47875547E-10_JPRB, 0.49185829E-10_JPRB, 0.50511206E-10_JPRB, 0.51861723E-10_JPRB, &
  & 0.53153603E-10_JPRB, 0.54393098E-10_JPRB, 0.55560872E-10_JPRB, 0.56640928E-10_JPRB, 0.55104827E-10_JPRB, 0.55999143E-10_JPRB, &
  & 0.59155868E-10_JPRB, 0.59849244E-10_JPRB, 0.60454794E-10_JPRB, 0.61171609E-10_JPRB, 0.62054611E-10_JPRB, 0.62751249E-10_JPRB, &
  & 0.63360032E-10_JPRB, 0.64010255E-10_JPRB, 0.64637642E-10_JPRB, 0.65331067E-10_JPRB, 0.65962485E-10_JPRB, 0.66578208E-10_JPRB, &
  & 0.67057027E-10_JPRB, 0.67492394E-10_JPRB, 0.68012436E-10_JPRB, 0.68306943E-10_JPRB, 0.68633682E-10_JPRB, 0.69094550E-10_JPRB, &
  & 0.69859084E-10_JPRB, 0.70605022E-10_JPRB, 0.71663946E-10_JPRB, 0.73151055E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG4(:, 1, 6) = (/ &
  & 0.96698693E-09_JPRB, 0.96592156E-09_JPRB, 0.96476138E-09_JPRB, 0.96292074E-09_JPRB, 0.96066699E-09_JPRB, 0.95818220E-09_JPRB, &
  & 0.95547392E-09_JPRB, 0.95277330E-09_JPRB, 0.60383481E-13_JPRB, 0.51736142E-13_JPRB, 0.57233813E-13_JPRB, 0.68282314E-13_JPRB, &
  & 0.81256670E-13_JPRB, 0.85019834E-13_JPRB, 0.95081237E-13_JPRB, 0.95729651E-13_JPRB, 0.97556559E-13_JPRB, 0.10366371E-12_JPRB, &
  & 0.10292070E-12_JPRB, 0.10277020E-12_JPRB, 0.10243899E-12_JPRB, 0.10597581E-12_JPRB, 0.10344160E-12_JPRB, 0.10161711E-12_JPRB, &
  & 0.10041653E-12_JPRB, 0.10012974E-12_JPRB, 0.10525461E-12_JPRB, 0.10579130E-12_JPRB, 0.10830457E-12_JPRB, 0.11198600E-12_JPRB, &
  & 0.11584710E-12_JPRB, 0.11965191E-12_JPRB, 0.12768059E-12_JPRB, 0.12725976E-12_JPRB, 0.12585778E-12_JPRB, 0.12304314E-12_JPRB, &
  & 0.11923421E-12_JPRB, 0.11532034E-12_JPRB, 0.11610333E-12_JPRB, 0.11117566E-12_JPRB, 0.10798992E-12_JPRB, 0.10556134E-12_JPRB, &
  & 0.10386878E-12_JPRB, 0.10654617E-12_JPRB, 0.10355315E-12_JPRB, 0.10150694E-12_JPRB, 0.99626735E-13_JPRB, 0.10139106E-12_JPRB, &
  & 0.99039910E-13_JPRB, 0.99486811E-13_JPRB, 0.10409360E-12_JPRB, 0.10935731E-12_JPRB, 0.12014773E-12_JPRB, 0.13680135E-12_JPRB, &
  & 0.14387554E-12_JPRB, 0.14927537E-12_JPRB, 0.14346202E-12_JPRB, 0.13626680E-12_JPRB, 0.12799069E-12_JPRB, 0.12197424E-12_JPRB, &
  & 0.11610091E-12_JPRB, 0.11016380E-12_JPRB, 0.10518274E-12_JPRB, 0.10143163E-12_JPRB /)

RGHG4(:, 2, 6) = (/ &
  & 0.10068246E-19_JPRB, 0.10071775E-19_JPRB, 0.10077888E-19_JPRB, 0.10085911E-19_JPRB, 0.10094974E-19_JPRB, 0.10104139E-19_JPRB, &
  & 0.10112601E-19_JPRB, 0.10119751E-19_JPRB, 0.25026490E-12_JPRB, 0.26271989E-12_JPRB, 0.27820828E-12_JPRB, 0.29332404E-12_JPRB, &
  & 0.30540574E-12_JPRB, 0.31894455E-12_JPRB, 0.33306685E-12_JPRB, 0.35449830E-12_JPRB, 0.38423217E-12_JPRB, 0.41427782E-12_JPRB, &
  & 0.45099617E-12_JPRB, 0.48715339E-12_JPRB, 0.52237630E-12_JPRB, 0.54658280E-12_JPRB, 0.57482860E-12_JPRB, 0.60604467E-12_JPRB, &
  & 0.64468781E-12_JPRB, 0.70166757E-12_JPRB, 0.75239251E-12_JPRB, 0.81628167E-12_JPRB, 0.89353264E-12_JPRB, 0.98133546E-12_JPRB, &
  & 0.10704435E-11_JPRB, 0.11684750E-11_JPRB, 0.12137649E-11_JPRB, 0.12394015E-11_JPRB, 0.12350900E-11_JPRB, 0.12028603E-11_JPRB, &
  & 0.11503212E-11_JPRB, 0.11016503E-11_JPRB, 0.10243059E-11_JPRB, 0.95294508E-12_JPRB, 0.89315035E-12_JPRB, 0.83888604E-12_JPRB, &
  & 0.79928734E-12_JPRB, 0.75234898E-12_JPRB, 0.70557584E-12_JPRB, 0.65240467E-12_JPRB, 0.60667736E-12_JPRB, 0.56589927E-12_JPRB, &
  & 0.52521431E-12_JPRB, 0.50593183E-12_JPRB, 0.49655451E-12_JPRB, 0.49944196E-12_JPRB, 0.51837625E-12_JPRB, 0.55789433E-12_JPRB, &
  & 0.59871270E-12_JPRB, 0.59257449E-12_JPRB, 0.48977359E-12_JPRB, 0.41489493E-12_JPRB, 0.35734949E-12_JPRB, 0.30919017E-12_JPRB, &
  & 0.27276618E-12_JPRB, 0.24139740E-12_JPRB, 0.22049739E-12_JPRB, 0.19407419E-12_JPRB /)

RGHG4(:, 3, 6) = (/ &
  & 0.55865767E-20_JPRB, 0.55891592E-20_JPRB, 0.55935076E-20_JPRB, 0.55990915E-20_JPRB, 0.56051523E-20_JPRB, 0.56107831E-20_JPRB, &
  & 0.56150955E-20_JPRB, 0.28999980E-09_JPRB, 0.42444249E-12_JPRB, 0.43530774E-12_JPRB, 0.45370635E-12_JPRB, 0.48540398E-12_JPRB, &
  & 0.53685311E-12_JPRB, 0.61211436E-12_JPRB, 0.69463483E-12_JPRB, 0.77900674E-12_JPRB, 0.86427848E-12_JPRB, 0.93797214E-12_JPRB, &
  & 0.10152160E-11_JPRB, 0.10913394E-11_JPRB, 0.11682458E-11_JPRB, 0.12257133E-11_JPRB, 0.12871816E-11_JPRB, 0.13496101E-11_JPRB, &
  & 0.14214162E-11_JPRB, 0.15191560E-11_JPRB, 0.16056700E-11_JPRB, 0.17194169E-11_JPRB, 0.18469768E-11_JPRB, 0.19854396E-11_JPRB, &
  & 0.21286002E-11_JPRB, 0.22832311E-11_JPRB, 0.23575272E-11_JPRB, 0.24115822E-11_JPRB, 0.24217854E-11_JPRB, 0.23955809E-11_JPRB, &
  & 0.23342355E-11_JPRB, 0.22741524E-11_JPRB, 0.21654174E-11_JPRB, 0.20517858E-11_JPRB, 0.19477935E-11_JPRB, 0.18447741E-11_JPRB, &
  & 0.17655347E-11_JPRB, 0.16704513E-11_JPRB, 0.15766627E-11_JPRB, 0.14780994E-11_JPRB, 0.13925019E-11_JPRB, 0.13148772E-11_JPRB, &
  & 0.12415442E-11_JPRB, 0.11906036E-11_JPRB, 0.11518974E-11_JPRB, 0.11224653E-11_JPRB, 0.11006325E-11_JPRB, 0.10853050E-11_JPRB, &
  & 0.10671323E-11_JPRB, 0.10303573E-11_JPRB, 0.89034363E-12_JPRB, 0.84441959E-12_JPRB, 0.81895585E-12_JPRB, 0.79372327E-12_JPRB, &
  & 0.76875913E-12_JPRB, 0.74623863E-12_JPRB, 0.70755229E-12_JPRB, 0.61784090E-12_JPRB /)

RGHG4(:, 4, 6) = (/ &
  & 0.32335088E-20_JPRB, 0.32353718E-20_JPRB, 0.32385452E-20_JPRB, 0.32425775E-20_JPRB, 0.10325043E-10_JPRB, 0.20455278E-09_JPRB, &
  & 0.40551698E-09_JPRB, 0.66653166E-09_JPRB, 0.89396941E-12_JPRB, 0.91927171E-12_JPRB, 0.10203265E-11_JPRB, 0.11587885E-11_JPRB, &
  & 0.13140356E-11_JPRB, 0.14846722E-11_JPRB, 0.16717619E-11_JPRB, 0.18791132E-11_JPRB, 0.20932863E-11_JPRB, 0.22837088E-11_JPRB, &
  & 0.24756479E-11_JPRB, 0.26635649E-11_JPRB, 0.28502185E-11_JPRB, 0.30028343E-11_JPRB, 0.31544444E-11_JPRB, 0.32942338E-11_JPRB, &
  & 0.34292564E-11_JPRB, 0.35855288E-11_JPRB, 0.37144007E-11_JPRB, 0.38807087E-11_JPRB, 0.40601186E-11_JPRB, 0.42529118E-11_JPRB, &
  & 0.44394896E-11_JPRB, 0.46329737E-11_JPRB, 0.47182726E-11_JPRB, 0.47953364E-11_JPRB, 0.48226661E-11_JPRB, 0.48148378E-11_JPRB, &
  & 0.47674469E-11_JPRB, 0.47219824E-11_JPRB, 0.46082352E-11_JPRB, 0.44806841E-11_JPRB, 0.43533133E-11_JPRB, 0.42133380E-11_JPRB, &
  & 0.41018673E-11_JPRB, 0.39564628E-11_JPRB, 0.38146478E-11_JPRB, 0.36704676E-11_JPRB, 0.35519439E-11_JPRB, 0.34403879E-11_JPRB, &
  & 0.33324461E-11_JPRB, 0.32536038E-11_JPRB, 0.31754885E-11_JPRB, 0.31082862E-11_JPRB, 0.30411799E-11_JPRB, 0.29774941E-11_JPRB, &
  & 0.29044651E-11_JPRB, 0.28210581E-11_JPRB, 0.26488564E-11_JPRB, 0.25538805E-11_JPRB, 0.24705114E-11_JPRB, 0.24064591E-11_JPRB, &
  & 0.23680133E-11_JPRB, 0.23295003E-11_JPRB, 0.22891019E-11_JPRB, 0.21733110E-11_JPRB /)

RGHG4(:, 5, 6) = (/ &
  & 0.19399033E-20_JPRB, 0.16811710E-09_JPRB, 0.29229025E-09_JPRB, 0.40737377E-09_JPRB, 0.53719651E-09_JPRB, 0.71852385E-09_JPRB, &
  & 0.93640906E-09_JPRB, 0.12433331E-08_JPRB, 0.24233835E-11_JPRB, 0.23225840E-11_JPRB, 0.25710491E-11_JPRB, 0.28931590E-11_JPRB, &
  & 0.32846646E-11_JPRB, 0.37344290E-11_JPRB, 0.42178227E-11_JPRB, 0.47534077E-11_JPRB, 0.53501240E-11_JPRB, 0.59420147E-11_JPRB, &
  & 0.65134291E-11_JPRB, 0.70452312E-11_JPRB, 0.75607368E-11_JPRB, 0.80262758E-11_JPRB, 0.84878242E-11_JPRB, 0.89067920E-11_JPRB, &
  & 0.92749489E-11_JPRB, 0.96172610E-11_JPRB, 0.98649066E-11_JPRB, 0.10132099E-10_JPRB, 0.10369657E-10_JPRB, 0.10586681E-10_JPRB, &
  & 0.10775258E-10_JPRB, 0.10979698E-10_JPRB, 0.11054694E-10_JPRB, 0.11160014E-10_JPRB, 0.11227992E-10_JPRB, 0.11278508E-10_JPRB, &
  & 0.11303129E-10_JPRB, 0.11342719E-10_JPRB, 0.11287149E-10_JPRB, 0.11226694E-10_JPRB, 0.11153000E-10_JPRB, 0.11047629E-10_JPRB, &
  & 0.10966653E-10_JPRB, 0.10800819E-10_JPRB, 0.10635872E-10_JPRB, 0.10459227E-10_JPRB, 0.10310497E-10_JPRB, 0.10134658E-10_JPRB, &
  & 0.99468983E-11_JPRB, 0.97739507E-11_JPRB, 0.95648758E-11_JPRB, 0.93530053E-11_JPRB, 0.91007462E-11_JPRB, 0.88085381E-11_JPRB, &
  & 0.84820883E-11_JPRB, 0.81423453E-11_JPRB, 0.77788860E-11_JPRB, 0.75270875E-11_JPRB, 0.73405431E-11_JPRB, 0.72324972E-11_JPRB, &
  & 0.71637167E-11_JPRB, 0.71577501E-11_JPRB, 0.71209735E-11_JPRB, 0.67431416E-11_JPRB /)

RGHG4(:, 6, 6) = (/ &
  & 0.50759019E-09_JPRB, 0.65532196E-09_JPRB, 0.75137652E-09_JPRB, 0.86114355E-09_JPRB, 0.10015924E-08_JPRB, 0.11987710E-08_JPRB, &
  & 0.14410731E-08_JPRB, 0.17538903E-08_JPRB, 0.78900133E-11_JPRB, 0.66818868E-11_JPRB, 0.71843542E-11_JPRB, 0.80041191E-11_JPRB, &
  & 0.90142043E-11_JPRB, 0.10178401E-10_JPRB, 0.11474258E-10_JPRB, 0.12858626E-10_JPRB, 0.14252848E-10_JPRB, 0.15716076E-10_JPRB, &
  & 0.17283860E-10_JPRB, 0.18794003E-10_JPRB, 0.20158110E-10_JPRB, 0.21374281E-10_JPRB, 0.22564707E-10_JPRB, 0.23649591E-10_JPRB, &
  & 0.24610480E-10_JPRB, 0.25414412E-10_JPRB, 0.25958499E-10_JPRB, 0.26392430E-10_JPRB, 0.26644437E-10_JPRB, 0.26748950E-10_JPRB, &
  & 0.26776697E-10_JPRB, 0.26795318E-10_JPRB, 0.26698168E-10_JPRB, 0.26782805E-10_JPRB, 0.26955506E-10_JPRB, 0.27207646E-10_JPRB, &
  & 0.27512582E-10_JPRB, 0.27857555E-10_JPRB, 0.28083357E-10_JPRB, 0.28344768E-10_JPRB, 0.28565103E-10_JPRB, 0.28731623E-10_JPRB, &
  & 0.28861111E-10_JPRB, 0.28811648E-10_JPRB, 0.28745870E-10_JPRB, 0.28628532E-10_JPRB, 0.28483086E-10_JPRB, 0.28194756E-10_JPRB, &
  & 0.27859628E-10_JPRB, 0.27457214E-10_JPRB, 0.26888037E-10_JPRB, 0.26265065E-10_JPRB, 0.25505905E-10_JPRB, 0.24689051E-10_JPRB, &
  & 0.23846923E-10_JPRB, 0.22910276E-10_JPRB, 0.22095274E-10_JPRB, 0.21718998E-10_JPRB, 0.21464596E-10_JPRB, 0.21341897E-10_JPRB, &
  & 0.21371661E-10_JPRB, 0.21539506E-10_JPRB, 0.21517956E-10_JPRB, 0.20003823E-10_JPRB /)

RGHG4(:, 7, 6) = (/ &
  & 0.85319540E-09_JPRB, 0.93964014E-09_JPRB, 0.10406327E-08_JPRB, 0.11809064E-08_JPRB, 0.13699968E-08_JPRB, 0.16201082E-08_JPRB, &
  & 0.19408757E-08_JPRB, 0.23579958E-08_JPRB, 0.25020382E-10_JPRB, 0.22011469E-10_JPRB, 0.22553046E-10_JPRB, 0.24287863E-10_JPRB, &
  & 0.26592289E-10_JPRB, 0.29249814E-10_JPRB, 0.32068209E-10_JPRB, 0.35227682E-10_JPRB, 0.38438558E-10_JPRB, 0.41542207E-10_JPRB, &
  & 0.44680277E-10_JPRB, 0.47899948E-10_JPRB, 0.50950969E-10_JPRB, 0.53783936E-10_JPRB, 0.56731939E-10_JPRB, 0.59618616E-10_JPRB, &
  & 0.62357765E-10_JPRB, 0.64599770E-10_JPRB, 0.66191795E-10_JPRB, 0.67313245E-10_JPRB, 0.67876184E-10_JPRB, 0.67859982E-10_JPRB, &
  & 0.67577943E-10_JPRB, 0.67086489E-10_JPRB, 0.66517861E-10_JPRB, 0.66533418E-10_JPRB, 0.66995846E-10_JPRB, 0.67807079E-10_JPRB, &
  & 0.68916581E-10_JPRB, 0.70078200E-10_JPRB, 0.71075638E-10_JPRB, 0.72200905E-10_JPRB, 0.73183841E-10_JPRB, 0.74085633E-10_JPRB, &
  & 0.74728716E-10_JPRB, 0.75034756E-10_JPRB, 0.75301522E-10_JPRB, 0.75441056E-10_JPRB, 0.75380091E-10_JPRB, 0.74930291E-10_JPRB, &
  & 0.74426278E-10_JPRB, 0.73639476E-10_JPRB, 0.72413318E-10_JPRB, 0.71020641E-10_JPRB, 0.69154092E-10_JPRB, 0.67067046E-10_JPRB, &
  & 0.64847357E-10_JPRB, 0.62473436E-10_JPRB, 0.60953791E-10_JPRB, 0.60925438E-10_JPRB, 0.61211217E-10_JPRB, 0.61962095E-10_JPRB, &
  & 0.63186505E-10_JPRB, 0.64772764E-10_JPRB, 0.66442830E-10_JPRB, 0.64441126E-10_JPRB /)

RGHG4(:, 8, 6) = (/ &
  & 0.94194708E-09_JPRB, 0.10659024E-08_JPRB, 0.12233942E-08_JPRB, 0.14243077E-08_JPRB, 0.16773373E-08_JPRB, 0.20136655E-08_JPRB, &
  & 0.24348124E-08_JPRB, 0.30117315E-08_JPRB, 0.68190710E-10_JPRB, 0.70507232E-10_JPRB, 0.73034995E-10_JPRB, 0.76278331E-10_JPRB, &
  & 0.80431432E-10_JPRB, 0.85529459E-10_JPRB, 0.90766408E-10_JPRB, 0.96467390E-10_JPRB, 0.10212305E-09_JPRB, 0.10804561E-09_JPRB, &
  & 0.11438594E-09_JPRB, 0.12112107E-09_JPRB, 0.12824701E-09_JPRB, 0.13540280E-09_JPRB, 0.14266195E-09_JPRB, 0.14947056E-09_JPRB, &
  & 0.15594753E-09_JPRB, 0.16103334E-09_JPRB, 0.16478278E-09_JPRB, 0.16747821E-09_JPRB, 0.16902918E-09_JPRB, 0.16917504E-09_JPRB, &
  & 0.16882851E-09_JPRB, 0.16766931E-09_JPRB, 0.16636176E-09_JPRB, 0.16639294E-09_JPRB, 0.16748526E-09_JPRB, 0.16931387E-09_JPRB, &
  & 0.17197985E-09_JPRB, 0.17457956E-09_JPRB, 0.17692826E-09_JPRB, 0.17974303E-09_JPRB, 0.18216346E-09_JPRB, 0.18452155E-09_JPRB, &
  & 0.18595048E-09_JPRB, 0.18676466E-09_JPRB, 0.18756302E-09_JPRB, 0.18821120E-09_JPRB, 0.18829587E-09_JPRB, 0.18752508E-09_JPRB, &
  & 0.18699355E-09_JPRB, 0.18584508E-09_JPRB, 0.18384590E-09_JPRB, 0.18172516E-09_JPRB, 0.17883896E-09_JPRB, 0.17573043E-09_JPRB, &
  & 0.17238226E-09_JPRB, 0.16842144E-09_JPRB, 0.16646373E-09_JPRB, 0.16808231E-09_JPRB, 0.17075857E-09_JPRB, 0.17456163E-09_JPRB, &
  & 0.17999022E-09_JPRB, 0.18579130E-09_JPRB, 0.19430105E-09_JPRB, 0.18927149E-09_JPRB /)

RGHG4(:, 9, 6) = (/ &
  & 0.98374353E-09_JPRB, 0.11881846E-08_JPRB, 0.13881579E-08_JPRB, 0.16270367E-08_JPRB, 0.19301596E-08_JPRB, 0.23153526E-08_JPRB, &
  & 0.28526244E-08_JPRB, 0.35952641E-08_JPRB, 0.14709987E-09_JPRB, 0.17286514E-09_JPRB, 0.19630395E-09_JPRB, 0.21282466E-09_JPRB, &
  & 0.22470752E-09_JPRB, 0.23512489E-09_JPRB, 0.24402505E-09_JPRB, 0.25405261E-09_JPRB, 0.26363367E-09_JPRB, 0.27334832E-09_JPRB, &
  & 0.28479560E-09_JPRB, 0.29748817E-09_JPRB, 0.31018524E-09_JPRB, 0.32343606E-09_JPRB, 0.33897346E-09_JPRB, 0.35397316E-09_JPRB, &
  & 0.36759013E-09_JPRB, 0.37796777E-09_JPRB, 0.38599501E-09_JPRB, 0.39220724E-09_JPRB, 0.39665582E-09_JPRB, 0.39844703E-09_JPRB, &
  & 0.39962758E-09_JPRB, 0.39845496E-09_JPRB, 0.39654854E-09_JPRB, 0.39712586E-09_JPRB, 0.39953774E-09_JPRB, 0.40291481E-09_JPRB, &
  & 0.40795831E-09_JPRB, 0.41226933E-09_JPRB, 0.41599543E-09_JPRB, 0.42106135E-09_JPRB, 0.42525641E-09_JPRB, 0.42954654E-09_JPRB, &
  & 0.43144507E-09_JPRB, 0.43219031E-09_JPRB, 0.43312132E-09_JPRB, 0.43406725E-09_JPRB, 0.43357781E-09_JPRB, 0.43148898E-09_JPRB, &
  & 0.43075590E-09_JPRB, 0.42918177E-09_JPRB, 0.42644460E-09_JPRB, 0.42425891E-09_JPRB, 0.42068687E-09_JPRB, 0.41665607E-09_JPRB, &
  & 0.41247203E-09_JPRB, 0.40806630E-09_JPRB, 0.41003201E-09_JPRB, 0.41960369E-09_JPRB, 0.43087303E-09_JPRB, 0.44511494E-09_JPRB, &
  & 0.46299972E-09_JPRB, 0.48281112E-09_JPRB, 0.51087823E-09_JPRB, 0.52157073E-09_JPRB /)

RGHG4(:,10, 6) = (/ &
  & 0.10395182E-08_JPRB, 0.13018970E-08_JPRB, 0.15228696E-08_JPRB, 0.17878450E-08_JPRB, 0.20934170E-08_JPRB, 0.25383331E-08_JPRB, &
  & 0.31423577E-08_JPRB, 0.41093968E-08_JPRB, 0.27441266E-09_JPRB, 0.34395520E-09_JPRB, 0.41392267E-09_JPRB, 0.47408466E-09_JPRB, &
  & 0.52171606E-09_JPRB, 0.55849042E-09_JPRB, 0.58460636E-09_JPRB, 0.60637356E-09_JPRB, 0.62412064E-09_JPRB, 0.63933348E-09_JPRB, &
  & 0.65678590E-09_JPRB, 0.67706285E-09_JPRB, 0.69979122E-09_JPRB, 0.72337469E-09_JPRB, 0.75049028E-09_JPRB, 0.77756851E-09_JPRB, &
  & 0.80591334E-09_JPRB, 0.82810919E-09_JPRB, 0.84261581E-09_JPRB, 0.85463947E-09_JPRB, 0.86512819E-09_JPRB, 0.87189206E-09_JPRB, &
  & 0.87858709E-09_JPRB, 0.88018687E-09_JPRB, 0.87967977E-09_JPRB, 0.88297863E-09_JPRB, 0.88868712E-09_JPRB, 0.89460817E-09_JPRB, &
  & 0.90288066E-09_JPRB, 0.90829710E-09_JPRB, 0.91198188E-09_JPRB, 0.91864660E-09_JPRB, 0.92381525E-09_JPRB, 0.92928465E-09_JPRB, &
  & 0.92999153E-09_JPRB, 0.92810537E-09_JPRB, 0.92719554E-09_JPRB, 0.92625457E-09_JPRB, 0.92228869E-09_JPRB, 0.91525015E-09_JPRB, &
  & 0.91125107E-09_JPRB, 0.90612157E-09_JPRB, 0.89945978E-09_JPRB, 0.89580421E-09_JPRB, 0.89139529E-09_JPRB, 0.88867291E-09_JPRB, &
  & 0.88782109E-09_JPRB, 0.88710789E-09_JPRB, 0.89616436E-09_JPRB, 0.91539465E-09_JPRB, 0.93791952E-09_JPRB, 0.96571473E-09_JPRB, &
  & 0.10000091E-08_JPRB, 0.10387786E-08_JPRB, 0.10935286E-08_JPRB, 0.11269244E-08_JPRB /)

RGHG4(:,11, 6) = (/ &
  & 0.11004898E-08_JPRB, 0.13583906E-08_JPRB, 0.15675858E-08_JPRB, 0.18395397E-08_JPRB, 0.21684672E-08_JPRB, 0.26509432E-08_JPRB, &
  & 0.34383061E-08_JPRB, 0.46792756E-08_JPRB, 0.48257909E-09_JPRB, 0.62689742E-09_JPRB, 0.77765455E-09_JPRB, 0.91847563E-09_JPRB, &
  & 0.10443340E-08_JPRB, 0.11516532E-08_JPRB, 0.12357412E-08_JPRB, 0.13012367E-08_JPRB, 0.13482747E-08_JPRB, 0.13793754E-08_JPRB, &
  & 0.14067251E-08_JPRB, 0.14335142E-08_JPRB, 0.14609552E-08_JPRB, 0.14890706E-08_JPRB, 0.15260569E-08_JPRB, 0.15659175E-08_JPRB, &
  & 0.16006835E-08_JPRB, 0.16251783E-08_JPRB, 0.16507350E-08_JPRB, 0.16764865E-08_JPRB, 0.17001092E-08_JPRB, 0.17183529E-08_JPRB, &
  & 0.17375380E-08_JPRB, 0.17481533E-08_JPRB, 0.17545800E-08_JPRB, 0.17658813E-08_JPRB, 0.17794275E-08_JPRB, 0.17905749E-08_JPRB, &
  & 0.18029885E-08_JPRB, 0.18081969E-08_JPRB, 0.18082588E-08_JPRB, 0.18131096E-08_JPRB, 0.18159841E-08_JPRB, 0.18186354E-08_JPRB, &
  & 0.18139876E-08_JPRB, 0.18035210E-08_JPRB, 0.17956159E-08_JPRB, 0.17873450E-08_JPRB, 0.17745611E-08_JPRB, 0.17558276E-08_JPRB, &
  & 0.17422661E-08_JPRB, 0.17275349E-08_JPRB, 0.17103374E-08_JPRB, 0.16981890E-08_JPRB, 0.16839307E-08_JPRB, 0.16722663E-08_JPRB, &
  & 0.16636906E-08_JPRB, 0.16562426E-08_JPRB, 0.16625308E-08_JPRB, 0.16807318E-08_JPRB, 0.17047987E-08_JPRB, 0.17374601E-08_JPRB, &
  & 0.17815858E-08_JPRB, 0.18338081E-08_JPRB, 0.19057145E-08_JPRB, 0.19573179E-08_JPRB /)

RGHG4(:,12, 6) = (/ &
  & 0.10205766E-08_JPRB, 0.12040769E-08_JPRB, 0.13921252E-08_JPRB, 0.16792853E-08_JPRB, 0.20278197E-08_JPRB, 0.26252196E-08_JPRB, &
  & 0.35631595E-08_JPRB, 0.52325326E-08_JPRB, 0.75450146E-09_JPRB, 0.10134832E-08_JPRB, 0.12838515E-08_JPRB, 0.15447918E-08_JPRB, &
  & 0.17913254E-08_JPRB, 0.20168089E-08_JPRB, 0.22107607E-08_JPRB, 0.23736650E-08_JPRB, 0.25003095E-08_JPRB, 0.25886748E-08_JPRB, &
  & 0.26531681E-08_JPRB, 0.26969056E-08_JPRB, 0.27252121E-08_JPRB, 0.27418772E-08_JPRB, 0.27634826E-08_JPRB, 0.27861933E-08_JPRB, &
  & 0.28141545E-08_JPRB, 0.28437275E-08_JPRB, 0.28593377E-08_JPRB, 0.28812168E-08_JPRB, 0.29160774E-08_JPRB, 0.29531386E-08_JPRB, &
  & 0.29920582E-08_JPRB, 0.30195042E-08_JPRB, 0.30403744E-08_JPRB, 0.30652429E-08_JPRB, 0.30895539E-08_JPRB, 0.31086731E-08_JPRB, &
  & 0.31278184E-08_JPRB, 0.31350107E-08_JPRB, 0.31319418E-08_JPRB, 0.31342353E-08_JPRB, 0.31338707E-08_JPRB, 0.31313330E-08_JPRB, &
  & 0.31197542E-08_JPRB, 0.30974552E-08_JPRB, 0.30798657E-08_JPRB, 0.30619258E-08_JPRB, 0.30378391E-08_JPRB, 0.30030896E-08_JPRB, &
  & 0.29747844E-08_JPRB, 0.29453111E-08_JPRB, 0.29106131E-08_JPRB, 0.28826641E-08_JPRB, 0.28518217E-08_JPRB, 0.28246296E-08_JPRB, &
  & 0.28010121E-08_JPRB, 0.27770077E-08_JPRB, 0.27649367E-08_JPRB, 0.27644733E-08_JPRB, 0.27706446E-08_JPRB, 0.27870177E-08_JPRB, &
  & 0.28174316E-08_JPRB, 0.28606564E-08_JPRB, 0.29275558E-08_JPRB, 0.29915208E-08_JPRB /)

RGHG4(:,13, 6) = (/ &
  & 0.73849538E-09_JPRB, 0.89341223E-09_JPRB, 0.10619033E-08_JPRB, 0.13346722E-08_JPRB, 0.16992341E-08_JPRB, 0.23078672E-08_JPRB, &
  & 0.33709655E-08_JPRB, 0.52092055E-08_JPRB, 0.97947983E-09_JPRB, 0.13520084E-08_JPRB, 0.17438908E-08_JPRB, 0.21102524E-08_JPRB, &
  & 0.24549998E-08_JPRB, 0.27792604E-08_JPRB, 0.30736917E-08_JPRB, 0.33399430E-08_JPRB, 0.35666925E-08_JPRB, 0.37472931E-08_JPRB, &
  & 0.38932835E-08_JPRB, 0.40037178E-08_JPRB, 0.40803401E-08_JPRB, 0.41256363E-08_JPRB, 0.41627350E-08_JPRB, 0.41955808E-08_JPRB, &
  & 0.42214006E-08_JPRB, 0.42380144E-08_JPRB, 0.42667656E-08_JPRB, 0.43035411E-08_JPRB, 0.43427377E-08_JPRB, 0.43874420E-08_JPRB, &
  & 0.44405679E-08_JPRB, 0.44834714E-08_JPRB, 0.45122293E-08_JPRB, 0.45431374E-08_JPRB, 0.45779838E-08_JPRB, 0.46026964E-08_JPRB, &
  & 0.46239261E-08_JPRB, 0.46335455E-08_JPRB, 0.46321276E-08_JPRB, 0.46369641E-08_JPRB, 0.46394821E-08_JPRB, 0.46378448E-08_JPRB, &
  & 0.46265471E-08_JPRB, 0.46000808E-08_JPRB, 0.45778568E-08_JPRB, 0.45526858E-08_JPRB, 0.45194808E-08_JPRB, 0.44724944E-08_JPRB, &
  & 0.44322079E-08_JPRB, 0.43899475E-08_JPRB, 0.43404307E-08_JPRB, 0.42984585E-08_JPRB, 0.42509525E-08_JPRB, 0.42043875E-08_JPRB, &
  & 0.41581707E-08_JPRB, 0.41067434E-08_JPRB, 0.40598440E-08_JPRB, 0.40215538E-08_JPRB, 0.39912429E-08_JPRB, 0.39738013E-08_JPRB, &
  & 0.39740482E-08_JPRB, 0.39931369E-08_JPRB, 0.40376364E-08_JPRB, 0.40989421E-08_JPRB /)

RGHG4(:,14, 6) = (/ &
  & 0.48986010E-09_JPRB, 0.66862832E-09_JPRB, 0.81619167E-09_JPRB, 0.10655585E-08_JPRB, 0.13771010E-08_JPRB, 0.19460309E-08_JPRB, &
  & 0.29402956E-08_JPRB, 0.47715525E-08_JPRB, 0.10926228E-08_JPRB, 0.15195458E-08_JPRB, 0.20056452E-08_JPRB, 0.24526292E-08_JPRB, &
  & 0.28720701E-08_JPRB, 0.32638596E-08_JPRB, 0.36226315E-08_JPRB, 0.39567132E-08_JPRB, 0.42571564E-08_JPRB, 0.45185455E-08_JPRB, &
  & 0.47484394E-08_JPRB, 0.49451701E-08_JPRB, 0.51015383E-08_JPRB, 0.52166236E-08_JPRB, 0.53122076E-08_JPRB, 0.53816165E-08_JPRB, &
  & 0.54464762E-08_JPRB, 0.54953890E-08_JPRB, 0.55287277E-08_JPRB, 0.55742997E-08_JPRB, 0.56313216E-08_JPRB, 0.56832841E-08_JPRB, &
  & 0.57354450E-08_JPRB, 0.57679252E-08_JPRB, 0.57864176E-08_JPRB, 0.58097833E-08_JPRB, 0.58182699E-08_JPRB, 0.58350866E-08_JPRB, &
  & 0.58620966E-08_JPRB, 0.58836456E-08_JPRB, 0.58938538E-08_JPRB, 0.59136060E-08_JPRB, 0.59320135E-08_JPRB, 0.59450977E-08_JPRB, &
  & 0.59480816E-08_JPRB, 0.59331300E-08_JPRB, 0.59208851E-08_JPRB, 0.59032965E-08_JPRB, 0.58761134E-08_JPRB, 0.58316094E-08_JPRB, &
  & 0.57902572E-08_JPRB, 0.57443499E-08_JPRB, 0.56874789E-08_JPRB, 0.56358984E-08_JPRB, 0.55744254E-08_JPRB, 0.55094374E-08_JPRB, &
  & 0.54400253E-08_JPRB, 0.53606120E-08_JPRB, 0.52753544E-08_JPRB, 0.51920930E-08_JPRB, 0.51177875E-08_JPRB, 0.50596465E-08_JPRB, &
  & 0.50223732E-08_JPRB, 0.50109175E-08_JPRB, 0.50222764E-08_JPRB, 0.50473128E-08_JPRB /)

RGHG4(:,15, 6) = (/ &
  & 0.40090037E-09_JPRB, 0.58187227E-09_JPRB, 0.71848144E-09_JPRB, 0.93040892E-09_JPRB, 0.12116460E-08_JPRB, 0.17262035E-08_JPRB, &
  & 0.26255500E-08_JPRB, 0.42761323E-08_JPRB, 0.11379585E-08_JPRB, 0.15541717E-08_JPRB, 0.21173552E-08_JPRB, 0.26144480E-08_JPRB, &
  & 0.30646001E-08_JPRB, 0.34900394E-08_JPRB, 0.38823069E-08_JPRB, 0.42532515E-08_JPRB, 0.45966404E-08_JPRB, 0.49094049E-08_JPRB, &
  & 0.51977733E-08_JPRB, 0.54519811E-08_JPRB, 0.56699134E-08_JPRB, 0.58444392E-08_JPRB, 0.59957173E-08_JPRB, 0.61149996E-08_JPRB, &
  & 0.62115038E-08_JPRB, 0.62889205E-08_JPRB, 0.63534711E-08_JPRB, 0.64058825E-08_JPRB, 0.64544472E-08_JPRB, 0.64914922E-08_JPRB, &
  & 0.65168955E-08_JPRB, 0.65314016E-08_JPRB, 0.65244228E-08_JPRB, 0.65235395E-08_JPRB, 0.65370136E-08_JPRB, 0.65432135E-08_JPRB, &
  & 0.65486243E-08_JPRB, 0.65682473E-08_JPRB, 0.65889152E-08_JPRB, 0.66225034E-08_JPRB, 0.66591705E-08_JPRB, 0.66933947E-08_JPRB, &
  & 0.67230639E-08_JPRB, 0.67367898E-08_JPRB, 0.67534445E-08_JPRB, 0.67621073E-08_JPRB, 0.67572721E-08_JPRB, 0.67298602E-08_JPRB, &
  & 0.67017303E-08_JPRB, 0.66662227E-08_JPRB, 0.66152808E-08_JPRB, 0.65656622E-08_JPRB, 0.65000454E-08_JPRB, 0.64253780E-08_JPRB, &
  & 0.63419310E-08_JPRB, 0.62468732E-08_JPRB, 0.61378143E-08_JPRB, 0.60175092E-08_JPRB, 0.59058887E-08_JPRB, 0.58135856E-08_JPRB, &
  & 0.57425980E-08_JPRB, 0.56992784E-08_JPRB, 0.56661063E-08_JPRB, 0.56187082E-08_JPRB /)

RGHG4(:,16, 6) = (/ &
  & 0.30192573E-09_JPRB, 0.44867349E-09_JPRB, 0.55967680E-09_JPRB, 0.74514450E-09_JPRB, 0.99735842E-09_JPRB, 0.14565570E-08_JPRB, &
  & 0.22369968E-08_JPRB, 0.36580301E-08_JPRB, 0.11361623E-08_JPRB, 0.15357867E-08_JPRB, 0.21096644E-08_JPRB, 0.26409781E-08_JPRB, &
  & 0.31102343E-08_JPRB, 0.35389347E-08_JPRB, 0.39379371E-08_JPRB, 0.43166559E-08_JPRB, 0.46663913E-08_JPRB, 0.49867022E-08_JPRB, &
  & 0.52864242E-08_JPRB, 0.55578537E-08_JPRB, 0.57918856E-08_JPRB, 0.59864673E-08_JPRB, 0.61562075E-08_JPRB, 0.62921752E-08_JPRB, &
  & 0.64039347E-08_JPRB, 0.64776922E-08_JPRB, 0.65311787E-08_JPRB, 0.65721415E-08_JPRB, 0.66078099E-08_JPRB, 0.66305117E-08_JPRB, &
  & 0.66526500E-08_JPRB, 0.66575003E-08_JPRB, 0.66480639E-08_JPRB, 0.66463923E-08_JPRB, 0.66531065E-08_JPRB, 0.66751022E-08_JPRB, &
  & 0.67147816E-08_JPRB, 0.67356045E-08_JPRB, 0.67496848E-08_JPRB, 0.67823742E-08_JPRB, 0.68249228E-08_JPRB, 0.68735617E-08_JPRB, &
  & 0.69222166E-08_JPRB, 0.69605410E-08_JPRB, 0.70077002E-08_JPRB, 0.70495654E-08_JPRB, 0.70768986E-08_JPRB, 0.70784085E-08_JPRB, &
  & 0.70772201E-08_JPRB, 0.70643731E-08_JPRB, 0.70308190E-08_JPRB, 0.69932353E-08_JPRB, 0.69329675E-08_JPRB, 0.68592132E-08_JPRB, &
  & 0.67752937E-08_JPRB, 0.66827543E-08_JPRB, 0.65710846E-08_JPRB, 0.64290435E-08_JPRB, 0.62934675E-08_JPRB, 0.61784853E-08_JPRB, &
  & 0.60831207E-08_JPRB, 0.60141501E-08_JPRB, 0.59407199E-08_JPRB, 0.58220779E-08_JPRB /)

RGHG4(:,17, 6) = (/ &
  & 0.19584087E-09_JPRB, 0.30233976E-09_JPRB, 0.40424056E-09_JPRB, 0.55431121E-09_JPRB, 0.77077716E-09_JPRB, 0.11521404E-08_JPRB, &
  & 0.18061403E-08_JPRB, 0.29823899E-08_JPRB, 0.10868174E-08_JPRB, 0.14681408E-08_JPRB, 0.19453481E-08_JPRB, 0.25240232E-08_JPRB, &
  & 0.29987177E-08_JPRB, 0.34194072E-08_JPRB, 0.37935153E-08_JPRB, 0.41448098E-08_JPRB, 0.44637050E-08_JPRB, 0.47492978E-08_JPRB, &
  & 0.50049955E-08_JPRB, 0.52270641E-08_JPRB, 0.54111733E-08_JPRB, 0.55559792E-08_JPRB, 0.56737934E-08_JPRB, 0.57570002E-08_JPRB, &
  & 0.58127090E-08_JPRB, 0.58307497E-08_JPRB, 0.58304455E-08_JPRB, 0.58338818E-08_JPRB, 0.58563221E-08_JPRB, 0.58886949E-08_JPRB, &
  & 0.59425291E-08_JPRB, 0.60039729E-08_JPRB, 0.60666272E-08_JPRB, 0.61422556E-08_JPRB, 0.62144641E-08_JPRB, 0.62711774E-08_JPRB, &
  & 0.63086363E-08_JPRB, 0.63484680E-08_JPRB, 0.63618080E-08_JPRB, 0.63822228E-08_JPRB, 0.64117831E-08_JPRB, 0.64540822E-08_JPRB, &
  & 0.65044410E-08_JPRB, 0.65579493E-08_JPRB, 0.66303629E-08_JPRB, 0.67031198E-08_JPRB, 0.67628059E-08_JPRB, 0.67997896E-08_JPRB, &
  & 0.68362120E-08_JPRB, 0.68598687E-08_JPRB, 0.68592128E-08_JPRB, 0.68489681E-08_JPRB, 0.68106676E-08_JPRB, 0.67550348E-08_JPRB, &
  & 0.66889427E-08_JPRB, 0.66186874E-08_JPRB, 0.65264114E-08_JPRB, 0.63795742E-08_JPRB, 0.62351466E-08_JPRB, 0.61096666E-08_JPRB, &
  & 0.60047745E-08_JPRB, 0.59212777E-08_JPRB, 0.58278702E-08_JPRB, 0.56580212E-08_JPRB /)

RGHG4(:,18, 6) = (/ &
  & 0.11847812E-09_JPRB, 0.19188831E-09_JPRB, 0.27179045E-09_JPRB, 0.38662926E-09_JPRB, 0.55988125E-09_JPRB, 0.85642304E-09_JPRB, &
  & 0.13711804E-08_JPRB, 0.22971001E-08_JPRB, 0.99119457E-09_JPRB, 0.13316703E-08_JPRB, 0.17917000E-08_JPRB, 0.23162932E-08_JPRB, &
  & 0.27957863E-08_JPRB, 0.31924272E-08_JPRB, 0.35376677E-08_JPRB, 0.38411665E-08_JPRB, 0.40933852E-08_JPRB, 0.43029664E-08_JPRB, &
  & 0.44786348E-08_JPRB, 0.46164002E-08_JPRB, 0.47131641E-08_JPRB, 0.47695305E-08_JPRB, 0.47965036E-08_JPRB, 0.47861879E-08_JPRB, &
  & 0.47503592E-08_JPRB, 0.46941500E-08_JPRB, 0.46346251E-08_JPRB, 0.45934772E-08_JPRB, 0.45914157E-08_JPRB, 0.46384505E-08_JPRB, &
  & 0.47381161E-08_JPRB, 0.48765845E-08_JPRB, 0.50341682E-08_JPRB, 0.52069673E-08_JPRB, 0.53737148E-08_JPRB, 0.55116871E-08_JPRB, &
  & 0.56065943E-08_JPRB, 0.56403304E-08_JPRB, 0.56429155E-08_JPRB, 0.56399565E-08_JPRB, 0.56420952E-08_JPRB, 0.56617786E-08_JPRB, &
  & 0.56961844E-08_JPRB, 0.57466054E-08_JPRB, 0.58247234E-08_JPRB, 0.59130496E-08_JPRB, 0.59985292E-08_JPRB, 0.60739493E-08_JPRB, &
  & 0.61525087E-08_JPRB, 0.62167782E-08_JPRB, 0.62550414E-08_JPRB, 0.62812453E-08_JPRB, 0.62781020E-08_JPRB, 0.62564340E-08_JPRB, &
  & 0.62263266E-08_JPRB, 0.61980332E-08_JPRB, 0.61461960E-08_JPRB, 0.60141780E-08_JPRB, 0.58789973E-08_JPRB, 0.57597513E-08_JPRB, &
  & 0.56599290E-08_JPRB, 0.55739235E-08_JPRB, 0.54835430E-08_JPRB, 0.52938263E-08_JPRB /)

RGHG4(:,19, 6) = (/ &
  & 0.75121485E-10_JPRB, 0.12232908E-09_JPRB, 0.17579997E-09_JPRB, 0.25895386E-09_JPRB, 0.38641432E-09_JPRB, 0.60857258E-09_JPRB, &
  & 0.99713160E-09_JPRB, 0.16965207E-08_JPRB, 0.90242608E-09_JPRB, 0.12055391E-08_JPRB, 0.16044475E-08_JPRB, 0.20245083E-08_JPRB, &
  & 0.24845290E-08_JPRB, 0.28567544E-08_JPRB, 0.31559853E-08_JPRB, 0.34034693E-08_JPRB, 0.35995085E-08_JPRB, 0.37403654E-08_JPRB, &
  & 0.38396579E-08_JPRB, 0.39019046E-08_JPRB, 0.39244203E-08_JPRB, 0.39054515E-08_JPRB, 0.38554160E-08_JPRB, 0.37708743E-08_JPRB, &
  & 0.36666929E-08_JPRB, 0.35479319E-08_JPRB, 0.34376904E-08_JPRB, 0.33665288E-08_JPRB, 0.33492582E-08_JPRB, 0.33964771E-08_JPRB, &
  & 0.35080994E-08_JPRB, 0.36762444E-08_JPRB, 0.38798125E-08_JPRB, 0.41088608E-08_JPRB, 0.43301793E-08_JPRB, 0.45156612E-08_JPRB, &
  & 0.46430499E-08_JPRB, 0.47085540E-08_JPRB, 0.47082551E-08_JPRB, 0.46911355E-08_JPRB, 0.46713073E-08_JPRB, 0.46674957E-08_JPRB, &
  & 0.46852673E-08_JPRB, 0.47269455E-08_JPRB, 0.48009712E-08_JPRB, 0.48954925E-08_JPRB, 0.50010005E-08_JPRB, 0.51049609E-08_JPRB, &
  & 0.52123390E-08_JPRB, 0.53070925E-08_JPRB, 0.53799645E-08_JPRB, 0.54431726E-08_JPRB, 0.54797544E-08_JPRB, 0.55000178E-08_JPRB, &
  & 0.55148828E-08_JPRB, 0.55364944E-08_JPRB, 0.55342255E-08_JPRB, 0.54288658E-08_JPRB, 0.53142659E-08_JPRB, 0.52131512E-08_JPRB, &
  & 0.51290541E-08_JPRB, 0.50555578E-08_JPRB, 0.49783795E-08_JPRB, 0.47984696E-08_JPRB /)

RGHG4(:,20, 6) = (/ &
  & 0.51292168E-10_JPRB, 0.84709281E-10_JPRB, 0.11949465E-09_JPRB, 0.17896463E-09_JPRB, 0.27079744E-09_JPRB, 0.43144502E-09_JPRB, &
  & 0.71761919E-09_JPRB, 0.12315267E-08_JPRB, 0.79215540E-09_JPRB, 0.10495478E-08_JPRB, 0.13849901E-08_JPRB, 0.17242933E-08_JPRB, &
  & 0.20895679E-08_JPRB, 0.24499496E-08_JPRB, 0.27116829E-08_JPRB, 0.29096230E-08_JPRB, 0.30539589E-08_JPRB, 0.31505316E-08_JPRB, &
  & 0.31987188E-08_JPRB, 0.32066305E-08_JPRB, 0.31817466E-08_JPRB, 0.31212530E-08_JPRB, 0.30341236E-08_JPRB, 0.29172431E-08_JPRB, &
  & 0.27835338E-08_JPRB, 0.26398499E-08_JPRB, 0.25070783E-08_JPRB, 0.24135469E-08_JPRB, 0.23755737E-08_JPRB, 0.24009581E-08_JPRB, &
  & 0.24905435E-08_JPRB, 0.26415496E-08_JPRB, 0.28377729E-08_JPRB, 0.30643401E-08_JPRB, 0.32896632E-08_JPRB, 0.34841992E-08_JPRB, &
  & 0.36242240E-08_JPRB, 0.36986190E-08_JPRB, 0.37079810E-08_JPRB, 0.36930983E-08_JPRB, 0.36700278E-08_JPRB, 0.36587351E-08_JPRB, &
  & 0.36649366E-08_JPRB, 0.36954919E-08_JPRB, 0.37627346E-08_JPRB, 0.38579535E-08_JPRB, 0.39699177E-08_JPRB, 0.40830321E-08_JPRB, &
  & 0.42009387E-08_JPRB, 0.43138377E-08_JPRB, 0.44117328E-08_JPRB, 0.45012758E-08_JPRB, 0.45702691E-08_JPRB, 0.46265893E-08_JPRB, &
  & 0.46808570E-08_JPRB, 0.47475277E-08_JPRB, 0.47936624E-08_JPRB, 0.47232951E-08_JPRB, 0.46366693E-08_JPRB, 0.45583830E-08_JPRB, &
  & 0.44927795E-08_JPRB, 0.44362958E-08_JPRB, 0.43720578E-08_JPRB, 0.42248249E-08_JPRB /)

RGHG4(:,21, 6) = (/ &
  & 0.34676675E-10_JPRB, 0.58538896E-10_JPRB, 0.82719255E-10_JPRB, 0.12347492E-09_JPRB, 0.18811579E-09_JPRB, 0.30058298E-09_JPRB, &
  & 0.49776822E-09_JPRB, 0.86697804E-09_JPRB, 0.64896855E-09_JPRB, 0.85799723E-09_JPRB, 0.11624814E-08_JPRB, 0.14584016E-08_JPRB, &
  & 0.17435167E-08_JPRB, 0.20313984E-08_JPRB, 0.22574946E-08_JPRB, 0.24163760E-08_JPRB, 0.25201563E-08_JPRB, 0.25753510E-08_JPRB, &
  & 0.25949636E-08_JPRB, 0.25851101E-08_JPRB, 0.25482110E-08_JPRB, 0.24792071E-08_JPRB, 0.23833924E-08_JPRB, 0.22604982E-08_JPRB, &
  & 0.21232804E-08_JPRB, 0.19755959E-08_JPRB, 0.18399935E-08_JPRB, 0.17450149E-08_JPRB, 0.16960624E-08_JPRB, 0.16964017E-08_JPRB, &
  & 0.17490578E-08_JPRB, 0.18536709E-08_JPRB, 0.20028126E-08_JPRB, 0.21852715E-08_JPRB, 0.23737878E-08_JPRB, 0.25444467E-08_JPRB, &
  & 0.26726190E-08_JPRB, 0.27454063E-08_JPRB, 0.27699865E-08_JPRB, 0.27644749E-08_JPRB, 0.27542784E-08_JPRB, 0.27528011E-08_JPRB, &
  & 0.27720559E-08_JPRB, 0.28109233E-08_JPRB, 0.28791964E-08_JPRB, 0.29704250E-08_JPRB, 0.30749276E-08_JPRB, 0.31814069E-08_JPRB, &
  & 0.32992098E-08_JPRB, 0.34184946E-08_JPRB, 0.35252166E-08_JPRB, 0.36297276E-08_JPRB, 0.37188319E-08_JPRB, 0.37968451E-08_JPRB, &
  & 0.38750478E-08_JPRB, 0.39695749E-08_JPRB, 0.40477857E-08_JPRB, 0.40077075E-08_JPRB, 0.39482466E-08_JPRB, 0.38937893E-08_JPRB, &
  & 0.38482346E-08_JPRB, 0.38094594E-08_JPRB, 0.37684216E-08_JPRB, 0.36586865E-08_JPRB /)

RGHG4(:,22, 6) = (/ &
  & 0.22874426E-10_JPRB, 0.39275617E-10_JPRB, 0.56302008E-10_JPRB, 0.84418694E-10_JPRB, 0.12947420E-09_JPRB, 0.20610187E-09_JPRB, &
  & 0.34538036E-09_JPRB, 0.61324001E-09_JPRB, 0.51668636E-09_JPRB, 0.70786621E-09_JPRB, 0.96139785E-09_JPRB, 0.12092840E-08_JPRB, &
  & 0.14314917E-08_JPRB, 0.16336503E-08_JPRB, 0.18213502E-08_JPRB, 0.19453581E-08_JPRB, 0.20201025E-08_JPRB, 0.20547775E-08_JPRB, &
  & 0.20559701E-08_JPRB, 0.20345872E-08_JPRB, 0.19901150E-08_JPRB, 0.19203010E-08_JPRB, 0.18315554E-08_JPRB, 0.17269606E-08_JPRB, &
  & 0.16118352E-08_JPRB, 0.14943763E-08_JPRB, 0.13851206E-08_JPRB, 0.12977620E-08_JPRB, 0.12435865E-08_JPRB, 0.12248285E-08_JPRB, &
  & 0.12423886E-08_JPRB, 0.12963696E-08_JPRB, 0.13826624E-08_JPRB, 0.14972182E-08_JPRB, 0.16245227E-08_JPRB, 0.17437507E-08_JPRB, &
  & 0.18447618E-08_JPRB, 0.19108135E-08_JPRB, 0.19411739E-08_JPRB, 0.19573365E-08_JPRB, 0.19718021E-08_JPRB, 0.19947617E-08_JPRB, &
  & 0.20264546E-08_JPRB, 0.20721673E-08_JPRB, 0.21417470E-08_JPRB, 0.22288340E-08_JPRB, 0.23281828E-08_JPRB, 0.24333668E-08_JPRB, &
  & 0.25473859E-08_JPRB, 0.26596267E-08_JPRB, 0.27658336E-08_JPRB, 0.28702241E-08_JPRB, 0.29605158E-08_JPRB, 0.30438221E-08_JPRB, &
  & 0.31307070E-08_JPRB, 0.32371656E-08_JPRB, 0.33330860E-08_JPRB, 0.33205771E-08_JPRB, 0.32864329E-08_JPRB, 0.32535636E-08_JPRB, &
  & 0.32263332E-08_JPRB, 0.32034995E-08_JPRB, 0.31768594E-08_JPRB, 0.31042520E-08_JPRB /)

RGHG4(:,23, 6) = (/ &
  & 0.15387757E-10_JPRB, 0.25758437E-10_JPRB, 0.37810002E-10_JPRB, 0.57302947E-10_JPRB, 0.88117777E-10_JPRB, 0.14297541E-09_JPRB, &
  & 0.24481078E-09_JPRB, 0.44126416E-09_JPRB, 0.42133042E-09_JPRB, 0.58056449E-09_JPRB, 0.78643109E-09_JPRB, 0.97437902E-09_JPRB, &
  & 0.11492919E-08_JPRB, 0.13010780E-08_JPRB, 0.14336738E-08_JPRB, 0.15418199E-08_JPRB, 0.16033238E-08_JPRB, 0.16278293E-08_JPRB, &
  & 0.16233274E-08_JPRB, 0.15946157E-08_JPRB, 0.15486078E-08_JPRB, 0.14910879E-08_JPRB, 0.14227242E-08_JPRB, 0.13416604E-08_JPRB, &
  & 0.12533683E-08_JPRB, 0.11598792E-08_JPRB, 0.10710864E-08_JPRB, 0.99922048E-09_JPRB, 0.94469199E-09_JPRB, 0.91271934E-09_JPRB, &
  & 0.90553715E-09_JPRB, 0.92259295E-09_JPRB, 0.96201624E-09_JPRB, 0.10218274E-08_JPRB, 0.10953900E-08_JPRB, 0.11670297E-08_JPRB, &
  & 0.12338555E-08_JPRB, 0.12869614E-08_JPRB, 0.13242930E-08_JPRB, 0.13563242E-08_JPRB, 0.13875991E-08_JPRB, 0.14240843E-08_JPRB, &
  & 0.14680452E-08_JPRB, 0.15200438E-08_JPRB, 0.15874491E-08_JPRB, 0.16710601E-08_JPRB, 0.17696082E-08_JPRB, 0.18701756E-08_JPRB, &
  & 0.19738227E-08_JPRB, 0.20789128E-08_JPRB, 0.21781019E-08_JPRB, 0.22720354E-08_JPRB, 0.23572759E-08_JPRB, 0.24379390E-08_JPRB, &
  & 0.25232147E-08_JPRB, 0.26277100E-08_JPRB, 0.27251446E-08_JPRB, 0.27286846E-08_JPRB, 0.27118838E-08_JPRB, 0.26960987E-08_JPRB, &
  & 0.26842180E-08_JPRB, 0.26750300E-08_JPRB, 0.26639606E-08_JPRB, 0.26207692E-08_JPRB /)

RGHG4(:,24, 6) = (/ &
  & 0.10546637E-10_JPRB, 0.18401525E-10_JPRB, 0.26734771E-10_JPRB, 0.39487580E-10_JPRB, 0.60765483E-10_JPRB, 0.98493935E-10_JPRB, &
  & 0.16727922E-09_JPRB, 0.30621936E-09_JPRB, 0.32402203E-09_JPRB, 0.44834556E-09_JPRB, 0.61020156E-09_JPRB, 0.77924311E-09_JPRB, &
  & 0.92149965E-09_JPRB, 0.10311518E-08_JPRB, 0.11229095E-08_JPRB, 0.12015470E-08_JPRB, 0.12482030E-08_JPRB, 0.12665411E-08_JPRB, &
  & 0.12619507E-08_JPRB, 0.12416921E-08_JPRB, 0.12080557E-08_JPRB, 0.11619815E-08_JPRB, 0.11083358E-08_JPRB, 0.10490978E-08_JPRB, &
  & 0.98454689E-09_JPRB, 0.91730751E-09_JPRB, 0.84841512E-09_JPRB, 0.78573176E-09_JPRB, 0.73651346E-09_JPRB, 0.69994682E-09_JPRB, &
  & 0.67829958E-09_JPRB, 0.67172345E-09_JPRB, 0.68020156E-09_JPRB, 0.70330081E-09_JPRB, 0.73807954E-09_JPRB, 0.77770573E-09_JPRB, &
  & 0.81926016E-09_JPRB, 0.85892310E-09_JPRB, 0.89691282E-09_JPRB, 0.93551134E-09_JPRB, 0.97859398E-09_JPRB, 0.10266265E-08_JPRB, &
  & 0.10815541E-08_JPRB, 0.11421032E-08_JPRB, 0.12121757E-08_JPRB, 0.12914046E-08_JPRB, 0.13755023E-08_JPRB, 0.14600718E-08_JPRB, &
  & 0.15500355E-08_JPRB, 0.16424941E-08_JPRB, 0.17264052E-08_JPRB, 0.18070050E-08_JPRB, 0.18800936E-08_JPRB, 0.19509594E-08_JPRB, &
  & 0.20293536E-08_JPRB, 0.21274527E-08_JPRB, 0.22219431E-08_JPRB, 0.22374702E-08_JPRB, 0.22325306E-08_JPRB, 0.22267930E-08_JPRB, &
  & 0.22241569E-08_JPRB, 0.22246176E-08_JPRB, 0.22258884E-08_JPRB, 0.22094973E-08_JPRB /)

RGHG4(:,25, 6) = (/ &
  & 0.74396930E-11_JPRB, 0.11997547E-10_JPRB, 0.18006029E-10_JPRB, 0.27237568E-10_JPRB, 0.42138550E-10_JPRB, 0.67848997E-10_JPRB, &
  & 0.11928368E-09_JPRB, 0.21761268E-09_JPRB, 0.25113667E-09_JPRB, 0.34879669E-09_JPRB, 0.48730869E-09_JPRB, 0.62241984E-09_JPRB, &
  & 0.73086220E-09_JPRB, 0.82135976E-09_JPRB, 0.88864860E-09_JPRB, 0.93731045E-09_JPRB, 0.97266106E-09_JPRB, 0.98581332E-09_JPRB, &
  & 0.98091901E-09_JPRB, 0.96183161E-09_JPRB, 0.93419517E-09_JPRB, 0.90105512E-09_JPRB, 0.86422997E-09_JPRB, 0.82342649E-09_JPRB, &
  & 0.77962620E-09_JPRB, 0.73271261E-09_JPRB, 0.68387235E-09_JPRB, 0.63583855E-09_JPRB, 0.59085142E-09_JPRB, 0.55343108E-09_JPRB, &
  & 0.52475968E-09_JPRB, 0.50527471E-09_JPRB, 0.49619492E-09_JPRB, 0.49805099E-09_JPRB, 0.50981741E-09_JPRB, 0.52894006E-09_JPRB, &
  & 0.55429950E-09_JPRB, 0.58472610E-09_JPRB, 0.61951161E-09_JPRB, 0.66063288E-09_JPRB, 0.70767320E-09_JPRB, 0.76108059E-09_JPRB, &
  & 0.81993423E-09_JPRB, 0.88368579E-09_JPRB, 0.95282293E-09_JPRB, 0.10264727E-08_JPRB, 0.11008139E-08_JPRB, 0.11741242E-08_JPRB, &
  & 0.12471769E-08_JPRB, 0.13193276E-08_JPRB, 0.13906259E-08_JPRB, 0.14593622E-08_JPRB, 0.15236749E-08_JPRB, 0.15878209E-08_JPRB, &
  & 0.16583531E-08_JPRB, 0.17466608E-08_JPRB, 0.18336731E-08_JPRB, 0.18553602E-08_JPRB, 0.18582753E-08_JPRB, 0.18602727E-08_JPRB, &
  & 0.18651316E-08_JPRB, 0.18726127E-08_JPRB, 0.18813469E-08_JPRB, 0.18802062E-08_JPRB /)

RGHG4(:,26, 6) = (/ &
  & 0.56718874E-11_JPRB, 0.95030962E-11_JPRB, 0.13643484E-10_JPRB, 0.20021146E-10_JPRB, 0.30715673E-10_JPRB, 0.51069732E-10_JPRB, &
  & 0.86269686E-10_JPRB, 0.15833752E-09_JPRB, 0.19766215E-09_JPRB, 0.28178657E-09_JPRB, 0.39078624E-09_JPRB, 0.49652660E-09_JPRB, &
  & 0.58145455E-09_JPRB, 0.64985306E-09_JPRB, 0.69809547E-09_JPRB, 0.73295059E-09_JPRB, 0.75627349E-09_JPRB, 0.76517243E-09_JPRB, &
  & 0.76143813E-09_JPRB, 0.74766654E-09_JPRB, 0.72674922E-09_JPRB, 0.70215539E-09_JPRB, 0.67629824E-09_JPRB, 0.64919514E-09_JPRB, &
  & 0.62084438E-09_JPRB, 0.59033550E-09_JPRB, 0.55691268E-09_JPRB, 0.52118515E-09_JPRB, 0.48464899E-09_JPRB, 0.44884471E-09_JPRB, &
  & 0.41767284E-09_JPRB, 0.39228096E-09_JPRB, 0.37454298E-09_JPRB, 0.36566100E-09_JPRB, 0.36568634E-09_JPRB, 0.37384887E-09_JPRB, &
  & 0.39010528E-09_JPRB, 0.41440518E-09_JPRB, 0.44548110E-09_JPRB, 0.48549509E-09_JPRB, 0.53214444E-09_JPRB, 0.58570016E-09_JPRB, &
  & 0.64370997E-09_JPRB, 0.70577216E-09_JPRB, 0.77037088E-09_JPRB, 0.83744939E-09_JPRB, 0.90311641E-09_JPRB, 0.96658981E-09_JPRB, &
  & 0.10272245E-08_JPRB, 0.10864331E-08_JPRB, 0.11423836E-08_JPRB, 0.11986847E-08_JPRB, 0.12546276E-08_JPRB, 0.13104781E-08_JPRB, &
  & 0.13737291E-08_JPRB, 0.14539276E-08_JPRB, 0.15344378E-08_JPRB, 0.15596077E-08_JPRB, 0.15673596E-08_JPRB, 0.15740749E-08_JPRB, &
  & 0.15833514E-08_JPRB, 0.15952901E-08_JPRB, 0.16094404E-08_JPRB, 0.16221613E-08_JPRB /)

RGHG4(:,27, 6) = (/ &
  & 0.48656795E-11_JPRB, 0.73369262E-11_JPRB, 0.10796430E-10_JPRB, 0.15909534E-10_JPRB, 0.24488279E-10_JPRB, 0.38680451E-10_JPRB, &
  & 0.65478817E-10_JPRB, 0.12121609E-09_JPRB, 0.15669925E-09_JPRB, 0.22547511E-09_JPRB, 0.31365316E-09_JPRB, 0.39316289E-09_JPRB, &
  & 0.46606619E-09_JPRB, 0.51931226E-09_JPRB, 0.55920407E-09_JPRB, 0.58397037E-09_JPRB, 0.59737448E-09_JPRB, 0.60180738E-09_JPRB, &
  & 0.59677840E-09_JPRB, 0.58471350E-09_JPRB, 0.56816862E-09_JPRB, 0.54977217E-09_JPRB, 0.53143068E-09_JPRB, 0.51386040E-09_JPRB, &
  & 0.49605497E-09_JPRB, 0.47722165E-09_JPRB, 0.45494281E-09_JPRB, 0.42892664E-09_JPRB, 0.39955589E-09_JPRB, 0.36848855E-09_JPRB, &
  & 0.33846828E-09_JPRB, 0.31160374E-09_JPRB, 0.29058461E-09_JPRB, 0.27714814E-09_JPRB, 0.27189931E-09_JPRB, 0.27496433E-09_JPRB, &
  & 0.28653444E-09_JPRB, 0.30682210E-09_JPRB, 0.33512093E-09_JPRB, 0.37189912E-09_JPRB, 0.41667730E-09_JPRB, 0.46734622E-09_JPRB, &
  & 0.52255350E-09_JPRB, 0.58049837E-09_JPRB, 0.63986511E-09_JPRB, 0.69966277E-09_JPRB, 0.75670004E-09_JPRB, 0.81015478E-09_JPRB, &
  & 0.86079133E-09_JPRB, 0.90878149E-09_JPRB, 0.95412467E-09_JPRB, 0.99994502E-09_JPRB, 0.10469556E-08_JPRB, 0.10960899E-08_JPRB, &
  & 0.11524476E-08_JPRB, 0.12242497E-08_JPRB, 0.12972972E-08_JPRB, 0.13236656E-08_JPRB, 0.13340929E-08_JPRB, 0.13433833E-08_JPRB, &
  & 0.13551072E-08_JPRB, 0.13692760E-08_JPRB, 0.13858572E-08_JPRB, 0.14049555E-08_JPRB /)

RGHG4(:,28, 6) = (/ &
  & 0.38451772E-11_JPRB, 0.59602262E-11_JPRB, 0.83882849E-11_JPRB, 0.12230187E-10_JPRB, 0.18103286E-10_JPRB, 0.29405391E-10_JPRB, &
  & 0.50293186E-10_JPRB, 0.91198167E-10_JPRB, 0.12310176E-09_JPRB, 0.18304332E-09_JPRB, 0.25368271E-09_JPRB, 0.31774347E-09_JPRB, &
  & 0.37768896E-09_JPRB, 0.42098014E-09_JPRB, 0.45229068E-09_JPRB, 0.47083781E-09_JPRB, 0.47992255E-09_JPRB, 0.48121401E-09_JPRB, &
  & 0.47512422E-09_JPRB, 0.46373910E-09_JPRB, 0.44947104E-09_JPRB, 0.43463316E-09_JPRB, 0.42093157E-09_JPRB, 0.40898981E-09_JPRB, &
  & 0.39799125E-09_JPRB, 0.38670378E-09_JPRB, 0.37269354E-09_JPRB, 0.35454620E-09_JPRB, 0.33186212E-09_JPRB, 0.30520836E-09_JPRB, &
  & 0.27794769E-09_JPRB, 0.25223865E-09_JPRB, 0.23112147E-09_JPRB, 0.21643673E-09_JPRB, 0.20936623E-09_JPRB, 0.21034158E-09_JPRB, &
  & 0.21966694E-09_JPRB, 0.23745522E-09_JPRB, 0.26341435E-09_JPRB, 0.29733829E-09_JPRB, 0.33868836E-09_JPRB, 0.38605388E-09_JPRB, &
  & 0.43679144E-09_JPRB, 0.48979282E-09_JPRB, 0.54312976E-09_JPRB, 0.59529226E-09_JPRB, 0.64410127E-09_JPRB, 0.68893902E-09_JPRB, &
  & 0.73076767E-09_JPRB, 0.77012091E-09_JPRB, 0.80719631E-09_JPRB, 0.84416424E-09_JPRB, 0.88291824E-09_JPRB, 0.92613467E-09_JPRB, &
  & 0.97673158E-09_JPRB, 0.10416350E-08_JPRB, 0.11080854E-08_JPRB, 0.11348731E-08_JPRB, 0.11474925E-08_JPRB, 0.11591830E-08_JPRB, &
  & 0.11733441E-08_JPRB, 0.11903761E-08_JPRB, 0.12112281E-08_JPRB, 0.12413214E-08_JPRB /)

RGHG4(:,29, 6) = (/ &
  & 0.34500681E-11_JPRB, 0.49482462E-11_JPRB, 0.69080679E-11_JPRB, 0.99073675E-11_JPRB, 0.14815866E-10_JPRB, 0.24264400E-10_JPRB, &
  & 0.40410068E-10_JPRB, 0.73870590E-10_JPRB, 0.10186874E-09_JPRB, 0.15052648E-09_JPRB, 0.20631735E-09_JPRB, 0.26209651E-09_JPRB, &
  & 0.31177358E-09_JPRB, 0.34716621E-09_JPRB, 0.37178466E-09_JPRB, 0.38630921E-09_JPRB, 0.39163378E-09_JPRB, 0.38995290E-09_JPRB, &
  & 0.38300235E-09_JPRB, 0.37167358E-09_JPRB, 0.35846037E-09_JPRB, 0.34537662E-09_JPRB, 0.33423619E-09_JPRB, 0.32549033E-09_JPRB, &
  & 0.31854083E-09_JPRB, 0.31186378E-09_JPRB, 0.30305067E-09_JPRB, 0.29076005E-09_JPRB, 0.27376088E-09_JPRB, 0.25224409E-09_JPRB, &
  & 0.22828785E-09_JPRB, 0.20502006E-09_JPRB, 0.18542705E-09_JPRB, 0.17125718E-09_JPRB, 0.16408232E-09_JPRB, 0.16429522E-09_JPRB, &
  & 0.17224849E-09_JPRB, 0.18802623E-09_JPRB, 0.21149696E-09_JPRB, 0.24258978E-09_JPRB, 0.28027441E-09_JPRB, 0.32326652E-09_JPRB, &
  & 0.36943126E-09_JPRB, 0.41696904E-09_JPRB, 0.46349746E-09_JPRB, 0.50832699E-09_JPRB, 0.54967320E-09_JPRB, 0.58738930E-09_JPRB, &
  & 0.62203726E-09_JPRB, 0.65478967E-09_JPRB, 0.68562744E-09_JPRB, 0.71678319E-09_JPRB, 0.74982864E-09_JPRB, 0.78753931E-09_JPRB, &
  & 0.83276219E-09_JPRB, 0.89081736E-09_JPRB, 0.95096131E-09_JPRB, 0.97788777E-09_JPRB, 0.99212283E-09_JPRB, 0.10052320E-08_JPRB, &
  & 0.10202962E-08_JPRB, 0.10377451E-08_JPRB, 0.10579783E-08_JPRB, 0.10787393E-08_JPRB /)

RGHG4(:,30, 6) = (/ &
  & 0.27217853E-11_JPRB, 0.40164343E-11_JPRB, 0.56036694E-11_JPRB, 0.81117509E-11_JPRB, 0.12091486E-10_JPRB, 0.19316087E-10_JPRB, &
  & 0.32538638E-10_JPRB, 0.58997862E-10_JPRB, 0.83342992E-10_JPRB, 0.12419031E-09_JPRB, 0.16910671E-09_JPRB, 0.21844659E-09_JPRB, &
  & 0.26049024E-09_JPRB, 0.29050409E-09_JPRB, 0.31065034E-09_JPRB, 0.32240011E-09_JPRB, 0.32523942E-09_JPRB, 0.32173089E-09_JPRB, &
  & 0.31349734E-09_JPRB, 0.30200961E-09_JPRB, 0.28927527E-09_JPRB, 0.27710248E-09_JPRB, 0.26707819E-09_JPRB, 0.25968774E-09_JPRB, &
  & 0.25443997E-09_JPRB, 0.25010083E-09_JPRB, 0.24462088E-09_JPRB, 0.23617777E-09_JPRB, 0.22338104E-09_JPRB, 0.20636436E-09_JPRB, &
  & 0.18648752E-09_JPRB, 0.16636399E-09_JPRB, 0.14910907E-09_JPRB, 0.13650468E-09_JPRB, 0.13013304E-09_JPRB, 0.13047249E-09_JPRB, &
  & 0.13771549E-09_JPRB, 0.15178758E-09_JPRB, 0.17276577E-09_JPRB, 0.20053786E-09_JPRB, 0.23443408E-09_JPRB, 0.27281566E-09_JPRB, &
  & 0.31344252E-09_JPRB, 0.35488482E-09_JPRB, 0.39563255E-09_JPRB, 0.43408777E-09_JPRB, 0.46942994E-09_JPRB, 0.50109378E-09_JPRB, &
  & 0.53079646E-09_JPRB, 0.55851590E-09_JPRB, 0.58478600E-09_JPRB, 0.61179378E-09_JPRB, 0.64056388E-09_JPRB, 0.67407735E-09_JPRB, &
  & 0.71491391E-09_JPRB, 0.76756385E-09_JPRB, 0.82239837E-09_JPRB, 0.84923979E-09_JPRB, 0.86463975E-09_JPRB, 0.87857527E-09_JPRB, &
  & 0.89406899E-09_JPRB, 0.91182506E-09_JPRB, 0.93170471E-09_JPRB, 0.95841968E-09_JPRB /)

RGHG4(:,31, 6) = (/ &
  & 0.21478444E-11_JPRB, 0.32132623E-11_JPRB, 0.46392330E-11_JPRB, 0.63523345E-11_JPRB, 0.95817573E-11_JPRB, 0.15672623E-10_JPRB, &
  & 0.26392706E-10_JPRB, 0.48248329E-10_JPRB, 0.69460514E-10_JPRB, 0.10469559E-09_JPRB, 0.14335000E-09_JPRB, 0.18416695E-09_JPRB, &
  & 0.21754698E-09_JPRB, 0.24523406E-09_JPRB, 0.26244867E-09_JPRB, 0.27179922E-09_JPRB, 0.27294139E-09_JPRB, 0.26801450E-09_JPRB, &
  & 0.25860369E-09_JPRB, 0.24675073E-09_JPRB, 0.23393631E-09_JPRB, 0.22200938E-09_JPRB, 0.21235712E-09_JPRB, 0.20541457E-09_JPRB, &
  & 0.20083406E-09_JPRB, 0.19753227E-09_JPRB, 0.19387572E-09_JPRB, 0.18817274E-09_JPRB, 0.17878292E-09_JPRB, 0.16559039E-09_JPRB, &
  & 0.14960554E-09_JPRB, 0.13290390E-09_JPRB, 0.11841715E-09_JPRB, 0.10796446E-09_JPRB, 0.10275178E-09_JPRB, 0.10324543E-09_JPRB, &
  & 0.10973606E-09_JPRB, 0.12207138E-09_JPRB, 0.14024114E-09_JPRB, 0.16430846E-09_JPRB, 0.19364556E-09_JPRB, 0.22712655E-09_JPRB, &
  & 0.26259894E-09_JPRB, 0.29828137E-09_JPRB, 0.33338762E-09_JPRB, 0.36599493E-09_JPRB, 0.39658221E-09_JPRB, 0.42419204E-09_JPRB, &
  & 0.44993873E-09_JPRB, 0.47449705E-09_JPRB, 0.49798288E-09_JPRB, 0.52215199E-09_JPRB, 0.54801430E-09_JPRB, 0.57788535E-09_JPRB, &
  & 0.61533623E-09_JPRB, 0.66337086E-09_JPRB, 0.71333350E-09_JPRB, 0.73961004E-09_JPRB, 0.75552614E-09_JPRB, 0.76990686E-09_JPRB, &
  & 0.78548812E-09_JPRB, 0.80288604E-09_JPRB, 0.82234264E-09_JPRB, 0.85296131E-09_JPRB /)

RGHG4(:,32, 6) = (/ &
  & 0.16232280E-11_JPRB, 0.25849214E-11_JPRB, 0.36709195E-11_JPRB, 0.50493641E-11_JPRB, 0.78343712E-11_JPRB, 0.12842716E-10_JPRB, &
  & 0.21979227E-10_JPRB, 0.39808368E-10_JPRB, 0.57595800E-10_JPRB, 0.86970757E-10_JPRB, 0.12202706E-09_JPRB, 0.15791909E-09_JPRB, &
  & 0.18681315E-09_JPRB, 0.21066214E-09_JPRB, 0.22510491E-09_JPRB, 0.23223387E-09_JPRB, 0.23175060E-09_JPRB, 0.22587014E-09_JPRB, &
  & 0.21590051E-09_JPRB, 0.20373070E-09_JPRB, 0.19092233E-09_JPRB, 0.17906324E-09_JPRB, 0.16942674E-09_JPRB, 0.16235076E-09_JPRB, &
  & 0.15762029E-09_JPRB, 0.15447139E-09_JPRB, 0.15140547E-09_JPRB, 0.14720872E-09_JPRB, 0.14012867E-09_JPRB, 0.12995600E-09_JPRB, &
  & 0.11735322E-09_JPRB, 0.10403838E-09_JPRB, 0.92441867E-10_JPRB, 0.84096653E-10_JPRB, 0.80332581E-10_JPRB, 0.81236663E-10_JPRB, &
  & 0.86968127E-10_JPRB, 0.97508765E-10_JPRB, 0.11295848E-09_JPRB, 0.13324890E-09_JPRB, 0.15812218E-09_JPRB, 0.18635826E-09_JPRB, &
  & 0.21657234E-09_JPRB, 0.24701066E-09_JPRB, 0.27730107E-09_JPRB, 0.30593056E-09_JPRB, 0.33264960E-09_JPRB, 0.35776634E-09_JPRB, &
  & 0.38074632E-09_JPRB, 0.40299231E-09_JPRB, 0.42446888E-09_JPRB, 0.44644269E-09_JPRB, 0.47023563E-09_JPRB, 0.49780674E-09_JPRB, &
  & 0.53224020E-09_JPRB, 0.57595606E-09_JPRB, 0.62152467E-09_JPRB, 0.64715688E-09_JPRB, 0.66352129E-09_JPRB, 0.67809491E-09_JPRB, &
  & 0.69350903E-09_JPRB, 0.71063921E-09_JPRB, 0.73048795E-09_JPRB, 0.76011919E-09_JPRB /)

RGHG4(:,33, 6) = (/ &
  & 0.13641807E-11_JPRB, 0.22154876E-11_JPRB, 0.32795585E-11_JPRB, 0.43785201E-11_JPRB, 0.66997753E-11_JPRB, 0.11056453E-10_JPRB, &
  & 0.18762563E-10_JPRB, 0.33830709E-10_JPRB, 0.49100703E-10_JPRB, 0.73637936E-10_JPRB, 0.10486424E-09_JPRB, 0.13599143E-09_JPRB, &
  & 0.16118892E-09_JPRB, 0.18161081E-09_JPRB, 0.19372909E-09_JPRB, 0.19907946E-09_JPRB, 0.19799322E-09_JPRB, 0.19127801E-09_JPRB, &
  & 0.18082770E-09_JPRB, 0.16823572E-09_JPRB, 0.15525212E-09_JPRB, 0.14324303E-09_JPRB, 0.13334313E-09_JPRB, 0.12588912E-09_JPRB, &
  & 0.12073294E-09_JPRB, 0.11733610E-09_JPRB, 0.11434491E-09_JPRB, 0.11095247E-09_JPRB, 0.10566360E-09_JPRB, 0.98037814E-10_JPRB, &
  & 0.88544921E-10_JPRB, 0.78427667E-10_JPRB, 0.69678950E-10_JPRB, 0.63503230E-10_JPRB, 0.60908126E-10_JPRB, 0.62110046E-10_JPRB, &
  & 0.67104301E-10_JPRB, 0.75751398E-10_JPRB, 0.88323709E-10_JPRB, 0.10490707E-09_JPRB, 0.12515555E-09_JPRB, 0.14859368E-09_JPRB, &
  & 0.17380018E-09_JPRB, 0.19975428E-09_JPRB, 0.22569047E-09_JPRB, 0.25105490E-09_JPRB, 0.27496805E-09_JPRB, 0.29779312E-09_JPRB, &
  & 0.31930350E-09_JPRB, 0.33989200E-09_JPRB, 0.36029718E-09_JPRB, 0.38116119E-09_JPRB, 0.40357420E-09_JPRB, 0.42917092E-09_JPRB, &
  & 0.46079437E-09_JPRB, 0.50065824E-09_JPRB, 0.54218291E-09_JPRB, 0.56687977E-09_JPRB, 0.58322791E-09_JPRB, 0.59779509E-09_JPRB, &
  & 0.61307870E-09_JPRB, 0.62988642E-09_JPRB, 0.64921979E-09_JPRB, 0.67856704E-09_JPRB /)

RGHG4(:,34, 6) = (/ &
  & 0.10367096E-11_JPRB, 0.17448976E-11_JPRB, 0.25901464E-11_JPRB, 0.36543819E-11_JPRB, 0.57509726E-11_JPRB, 0.96772763E-11_JPRB, &
  & 0.16578631E-10_JPRB, 0.29786139E-10_JPRB, 0.42635780E-10_JPRB, 0.64110918E-10_JPRB, 0.91274197E-10_JPRB, 0.11830976E-09_JPRB, &
  & 0.14041410E-09_JPRB, 0.15820120E-09_JPRB, 0.16836348E-09_JPRB, 0.17225650E-09_JPRB, 0.17043569E-09_JPRB, 0.16323769E-09_JPRB, &
  & 0.15249789E-09_JPRB, 0.13974916E-09_JPRB, 0.12665452E-09_JPRB, 0.11453905E-09_JPRB, 0.10438975E-09_JPRB, 0.96592546E-10_JPRB, &
  & 0.91004947E-10_JPRB, 0.87166607E-10_JPRB, 0.84098228E-10_JPRB, 0.80919507E-10_JPRB, 0.76836384E-10_JPRB, 0.71046100E-10_JPRB, &
  & 0.64080359E-10_JPRB, 0.56760766E-10_JPRB, 0.50508656E-10_JPRB, 0.46231647E-10_JPRB, 0.44751685E-10_JPRB, 0.46012624E-10_JPRB, &
  & 0.50222139E-10_JPRB, 0.57208550E-10_JPRB, 0.67263382E-10_JPRB, 0.80490524E-10_JPRB, 0.96894104E-10_JPRB, 0.11593030E-09_JPRB, &
  & 0.13689155E-09_JPRB, 0.15880147E-09_JPRB, 0.18131356E-09_JPRB, 0.20375705E-09_JPRB, 0.22554897E-09_JPRB, 0.24671815E-09_JPRB, &
  & 0.26710437E-09_JPRB, 0.28674252E-09_JPRB, 0.30613601E-09_JPRB, 0.32591721E-09_JPRB, 0.34705400E-09_JPRB, 0.37116876E-09_JPRB, &
  & 0.40037126E-09_JPRB, 0.43666784E-09_JPRB, 0.47455645E-09_JPRB, 0.49824384E-09_JPRB, 0.51437837E-09_JPRB, 0.52863752E-09_JPRB, &
  & 0.54330962E-09_JPRB, 0.55927907E-09_JPRB, 0.57815464E-09_JPRB, 0.60619593E-09_JPRB /)

RGHG4(:,35, 6) = (/ &
  & 0.93837579E-12_JPRB, 0.15533916E-11_JPRB, 0.23804183E-11_JPRB, 0.33426812E-11_JPRB, 0.51966205E-11_JPRB, 0.86261935E-11_JPRB, &
  & 0.14800718E-10_JPRB, 0.26367247E-10_JPRB, 0.37333386E-10_JPRB, 0.56127214E-10_JPRB, 0.79748805E-10_JPRB, 0.10309235E-09_JPRB, &
  & 0.12232249E-09_JPRB, 0.13767912E-09_JPRB, 0.14659302E-09_JPRB, 0.14952951E-09_JPRB, 0.14706383E-09_JPRB, 0.13950094E-09_JPRB, &
  & 0.12841246E-09_JPRB, 0.11546396E-09_JPRB, 0.10216980E-09_JPRB, 0.89851765E-10_JPRB, 0.79403803E-10_JPRB, 0.71284451E-10_JPRB, &
  & 0.65373221E-10_JPRB, 0.61156684E-10_JPRB, 0.58012671E-10_JPRB, 0.55044604E-10_JPRB, 0.51843252E-10_JPRB, 0.47711651E-10_JPRB, &
  & 0.42960968E-10_JPRB, 0.38085844E-10_JPRB, 0.34037644E-10_JPRB, 0.31363252E-10_JPRB, 0.30711381E-10_JPRB, 0.31988440E-10_JPRB, &
  & 0.35317360E-10_JPRB, 0.40698705E-10_JPRB, 0.48448162E-10_JPRB, 0.58668424E-10_JPRB, 0.71521199E-10_JPRB, 0.86837385E-10_JPRB, &
  & 0.10405538E-09_JPRB, 0.12267588E-09_JPRB, 0.14228627E-09_JPRB, 0.16249908E-09_JPRB, 0.18258964E-09_JPRB, 0.20239621E-09_JPRB, &
  & 0.22183004E-09_JPRB, 0.24061497E-09_JPRB, 0.25921451E-09_JPRB, 0.27819402E-09_JPRB, 0.29831859E-09_JPRB, 0.32088326E-09_JPRB, &
  & 0.34764888E-09_JPRB, 0.38060119E-09_JPRB, 0.41495873E-09_JPRB, 0.43728371E-09_JPRB, 0.45280743E-09_JPRB, 0.46652948E-09_JPRB, &
  & 0.48055537E-09_JPRB, 0.49572763E-09_JPRB, 0.51334115E-09_JPRB, 0.53944432E-09_JPRB /)

RGHG4(:,36, 6) = (/ &
  & 0.78853666E-12_JPRB, 0.13479212E-11_JPRB, 0.21038616E-11_JPRB, 0.28360226E-11_JPRB, 0.46265448E-11_JPRB, 0.78305400E-11_JPRB, &
  & 0.13542943E-10_JPRB, 0.23869235E-10_JPRB, 0.33214036E-10_JPRB, 0.49639313E-10_JPRB, 0.70129111E-10_JPRB, 0.90416327E-10_JPRB, &
  & 0.10717423E-09_JPRB, 0.11998515E-09_JPRB, 0.12811338E-09_JPRB, 0.13045495E-09_JPRB, 0.12758404E-09_JPRB, 0.11991033E-09_JPRB, &
  & 0.10875735E-09_JPRB, 0.95726788E-10_JPRB, 0.82220702E-10_JPRB, 0.69802691E-10_JPRB, 0.59250584E-10_JPRB, 0.51105228E-10_JPRB, &
  & 0.45146695E-10_JPRB, 0.40899301E-10_JPRB, 0.37805242E-10_JPRB, 0.35186510E-10_JPRB, 0.32658359E-10_JPRB, 0.29835412E-10_JPRB, &
  & 0.26837959E-10_JPRB, 0.23871786E-10_JPRB, 0.21510302E-10_JPRB, 0.20055246E-10_JPRB, 0.19886865E-10_JPRB, 0.21070519E-10_JPRB, &
  & 0.23586435E-10_JPRB, 0.27635040E-10_JPRB, 0.33337097E-10_JPRB, 0.41049598E-10_JPRB, 0.51044658E-10_JPRB, 0.63224002E-10_JPRB, &
  & 0.77456985E-10_JPRB, 0.93277989E-10_JPRB, 0.11042533E-09_JPRB, 0.12854674E-09_JPRB, 0.14709650E-09_JPRB, 0.16572986E-09_JPRB, &
  & 0.18421366E-09_JPRB, 0.20229841E-09_JPRB, 0.22026814E-09_JPRB, 0.23846919E-09_JPRB, 0.25756031E-09_JPRB, 0.27868324E-09_JPRB, &
  & 0.30334971E-09_JPRB, 0.33318664E-09_JPRB, 0.36425360E-09_JPRB, 0.38508663E-09_JPRB, 0.39981243E-09_JPRB, 0.41277551E-09_JPRB, &
  & 0.42580225E-09_JPRB, 0.43978562E-09_JPRB, 0.45596033E-09_JPRB, 0.47995613E-09_JPRB /)

RGHG4(:,37, 6) = (/ &
  & 0.74700906E-12_JPRB, 0.11455653E-11_JPRB, 0.18921787E-11_JPRB, 0.26844874E-11_JPRB, 0.43743282E-11_JPRB, 0.73189788E-11_JPRB, &
  & 0.12344925E-10_JPRB, 0.21455719E-10_JPRB, 0.29412021E-10_JPRB, 0.43654417E-10_JPRB, 0.61403292E-10_JPRB, 0.78953760E-10_JPRB, &
  & 0.93608704E-10_JPRB, 0.10465558E-09_JPRB, 0.11200678E-09_JPRB, 0.11382474E-09_JPRB, 0.11071491E-09_JPRB, 0.10297026E-09_JPRB, &
  & 0.91781492E-10_JPRB, 0.78680729E-10_JPRB, 0.65081947E-10_JPRB, 0.52638168E-10_JPRB, 0.42301145E-10_JPRB, 0.34560316E-10_JPRB, &
  & 0.29036147E-10_JPRB, 0.25279022E-10_JPRB, 0.22561513E-10_JPRB, 0.20522320E-10_JPRB, 0.18718671E-10_JPRB, 0.16982627E-10_JPRB, &
  & 0.15272674E-10_JPRB, 0.13753759E-10_JPRB, 0.12521643E-10_JPRB, 0.11951749E-10_JPRB, 0.11965653E-10_JPRB, 0.12934641E-10_JPRB, &
  & 0.14556242E-10_JPRB, 0.17348494E-10_JPRB, 0.21156285E-10_JPRB, 0.26734387E-10_JPRB, 0.34050072E-10_JPRB, 0.43530842E-10_JPRB, &
  & 0.55078296E-10_JPRB, 0.68543032E-10_JPRB, 0.83552790E-10_JPRB, 0.99859399E-10_JPRB, 0.11703229E-09_JPRB, 0.13463605E-09_JPRB, &
  & 0.15225567E-09_JPRB, 0.16962262E-09_JPRB, 0.18683502E-09_JPRB, 0.20415132E-09_JPRB, 0.22212868E-09_JPRB, 0.24178087E-09_JPRB, &
  & 0.26440766E-09_JPRB, 0.29152655E-09_JPRB, 0.31970690E-09_JPRB, 0.33908734E-09_JPRB, 0.35290051E-09_JPRB, 0.36496650E-09_JPRB, &
  & 0.37700029E-09_JPRB, 0.38985215E-09_JPRB, 0.40443626E-09_JPRB, 0.42587991E-09_JPRB /)

RGHG4(:,38, 6) = (/ &
  & 0.68993465E-12_JPRB, 0.10847073E-11_JPRB, 0.17348232E-11_JPRB, 0.25181740E-11_JPRB, 0.39923937E-11_JPRB, 0.67914949E-11_JPRB, &
  & 0.11480535E-10_JPRB, 0.19833222E-10_JPRB, 0.26468798E-10_JPRB, 0.38756800E-10_JPRB, 0.53813974E-10_JPRB, 0.68500115E-10_JPRB, &
  & 0.81928193E-10_JPRB, 0.91794537E-10_JPRB, 0.98186834E-10_JPRB, 0.99526144E-10_JPRB, 0.96262442E-10_JPRB, 0.88668399E-10_JPRB, &
  & 0.77634697E-10_JPRB, 0.64664128E-10_JPRB, 0.51356162E-10_JPRB, 0.39453402E-10_JPRB, 0.29937657E-10_JPRB, 0.23210768E-10_JPRB, &
  & 0.18646187E-10_JPRB, 0.15711385E-10_JPRB, 0.13662092E-10_JPRB, 0.12212883E-10_JPRB, 0.10987179E-10_JPRB, 0.99563725E-11_JPRB, &
  & 0.89990541E-11_JPRB, 0.82152046E-11_JPRB, 0.76508105E-11_JPRB, 0.74067150E-11_JPRB, 0.75991210E-11_JPRB, 0.82101227E-11_JPRB, &
  & 0.93356763E-11_JPRB, 0.11071125E-10_JPRB, 0.13641550E-10_JPRB, 0.17283860E-10_JPRB, 0.22338489E-10_JPRB, 0.29252045E-10_JPRB, &
  & 0.38203982E-10_JPRB, 0.49218737E-10_JPRB, 0.62129614E-10_JPRB, 0.76678504E-10_JPRB, 0.92448715E-10_JPRB, 0.10896573E-09_JPRB, &
  & 0.12570088E-09_JPRB, 0.14228241E-09_JPRB, 0.15878281E-09_JPRB, 0.17529980E-09_JPRB, 0.19225427E-09_JPRB, 0.21052481E-09_JPRB, &
  & 0.23133587E-09_JPRB, 0.25592811E-09_JPRB, 0.28134520E-09_JPRB, 0.29924471E-09_JPRB, 0.31214620E-09_JPRB, 0.32334060E-09_JPRB, &
  & 0.33431613E-09_JPRB, 0.34585931E-09_JPRB, 0.35893785E-09_JPRB, 0.37814057E-09_JPRB /)

RGHG4(:,39, 6) = (/ &
  & 0.58532275E-12_JPRB, 0.10148991E-11_JPRB, 0.16587231E-11_JPRB, 0.24693589E-11_JPRB, 0.38380575E-11_JPRB, 0.65471443E-11_JPRB, &
  & 0.10882266E-10_JPRB, 0.18371991E-10_JPRB, 0.23758575E-10_JPRB, 0.34337429E-10_JPRB, 0.47229453E-10_JPRB, 0.59904880E-10_JPRB, &
  & 0.71709985E-10_JPRB, 0.80411018E-10_JPRB, 0.85923130E-10_JPRB, 0.86976516E-10_JPRB, 0.83717790E-10_JPRB, 0.76381027E-10_JPRB, &
  & 0.65820321E-10_JPRB, 0.53221587E-10_JPRB, 0.40658466E-10_JPRB, 0.29833660E-10_JPRB, 0.21751748E-10_JPRB, 0.16301512E-10_JPRB, &
  & 0.12823866E-10_JPRB, 0.10632883E-10_JPRB, 0.91579825E-11_JPRB, 0.81038648E-11_JPRB, 0.72816969E-11_JPRB, 0.65871054E-11_JPRB, &
  & 0.60120142E-11_JPRB, 0.55478586E-11_JPRB, 0.52807112E-11_JPRB, 0.51939859E-11_JPRB, 0.53937705E-11_JPRB, 0.58442231E-11_JPRB, &
  & 0.66062052E-11_JPRB, 0.77720703E-11_JPRB, 0.94660391E-11_JPRB, 0.11780838E-10_JPRB, 0.15206237E-10_JPRB, 0.19999183E-10_JPRB, &
  & 0.26524703E-10_JPRB, 0.35011685E-10_JPRB, 0.45648700E-10_JPRB, 0.58173508E-10_JPRB, 0.72389254E-10_JPRB, 0.87697058E-10_JPRB, &
  & 0.10344078E-09_JPRB, 0.11918760E-09_JPRB, 0.13487467E-09_JPRB, 0.15046892E-09_JPRB, 0.16633300E-09_JPRB, 0.18320412E-09_JPRB, &
  & 0.20226272E-09_JPRB, 0.22456947E-09_JPRB, 0.24762561E-09_JPRB, 0.26416946E-09_JPRB, 0.27610858E-09_JPRB, 0.28634206E-09_JPRB, &
  & 0.29628852E-09_JPRB, 0.30666308E-09_JPRB, 0.31832176E-09_JPRB, 0.33526859E-09_JPRB /)

RGHG4(:,40, 6) = (/ &
  & 0.54785755E-12_JPRB, 0.97408962E-12_JPRB, 0.15223925E-11_JPRB, 0.22581897E-11_JPRB, 0.38851223E-11_JPRB, 0.64985703E-11_JPRB, &
  & 0.10490919E-10_JPRB, 0.17381142E-10_JPRB, 0.21660449E-10_JPRB, 0.30717203E-10_JPRB, 0.41773137E-10_JPRB, 0.52671062E-10_JPRB, &
  & 0.62824190E-10_JPRB, 0.70384046E-10_JPRB, 0.75154653E-10_JPRB, 0.75928146E-10_JPRB, 0.72824025E-10_JPRB, 0.65979583E-10_JPRB, &
  & 0.56084280E-10_JPRB, 0.44492337E-10_JPRB, 0.32946028E-10_JPRB, 0.23431344E-10_JPRB, 0.16670883E-10_JPRB, 0.12353561E-10_JPRB, &
  & 0.96963054E-11_JPRB, 0.80307211E-11_JPRB, 0.69261532E-11_JPRB, 0.61150542E-11_JPRB, 0.54892679E-11_JPRB, 0.49751050E-11_JPRB, &
  & 0.45744311E-11_JPRB, 0.42614549E-11_JPRB, 0.41182808E-11_JPRB, 0.40996954E-11_JPRB, 0.42885734E-11_JPRB, 0.46580084E-11_JPRB, &
  & 0.52083888E-11_JPRB, 0.60922890E-11_JPRB, 0.72445587E-11_JPRB, 0.88688024E-11_JPRB, 0.11226597E-10_JPRB, 0.14522431E-10_JPRB, &
  & 0.19070200E-10_JPRB, 0.25342173E-10_JPRB, 0.33549840E-10_JPRB, 0.43917162E-10_JPRB, 0.56302459E-10_JPRB, 0.70135737E-10_JPRB, &
  & 0.84788870E-10_JPRB, 0.99596310E-10_JPRB, 0.11442933E-09_JPRB, 0.12920050E-09_JPRB, 0.14409268E-09_JPRB, 0.15969912E-09_JPRB, &
  & 0.17715802E-09_JPRB, 0.19737728E-09_JPRB, 0.21809914E-09_JPRB, 0.23317043E-09_JPRB, 0.24412200E-09_JPRB, 0.25348368E-09_JPRB, &
  & 0.26245184E-09_JPRB, 0.27168129E-09_JPRB, 0.28203892E-09_JPRB, 0.29709421E-09_JPRB /)

RGHG4(:,41, 6) = (/ &
  & 0.53268707E-12_JPRB, 0.92500150E-12_JPRB, 0.15623196E-11_JPRB, 0.22649964E-11_JPRB, 0.37377566E-11_JPRB, 0.63373083E-11_JPRB, &
  & 0.10166840E-10_JPRB, 0.16512505E-10_JPRB, 0.19737888E-10_JPRB, 0.27444189E-10_JPRB, 0.36825695E-10_JPRB, 0.46113648E-10_JPRB, &
  & 0.54940445E-10_JPRB, 0.61485241E-10_JPRB, 0.65604258E-10_JPRB, 0.66232464E-10_JPRB, 0.63374403E-10_JPRB, 0.57243339E-10_JPRB, &
  & 0.48266346E-10_JPRB, 0.37742906E-10_JPRB, 0.27701546E-10_JPRB, 0.19489290E-10_JPRB, 0.13796465E-10_JPRB, 0.10197428E-10_JPRB, &
  & 0.80294426E-11_JPRB, 0.66777963E-11_JPRB, 0.57721718E-11_JPRB, 0.51012679E-11_JPRB, 0.45887005E-11_JPRB, 0.41593114E-11_JPRB, &
  & 0.38418951E-11_JPRB, 0.35999112E-11_JPRB, 0.35160642E-11_JPRB, 0.35213694E-11_JPRB, 0.37185550E-11_JPRB, 0.40171907E-11_JPRB, &
  & 0.44909072E-11_JPRB, 0.51741797E-11_JPRB, 0.60677028E-11_JPRB, 0.72690881E-11_JPRB, 0.89796573E-11_JPRB, 0.11313305E-10_JPRB, &
  & 0.14532751E-10_JPRB, 0.19031677E-10_JPRB, 0.25130904E-10_JPRB, 0.33356547E-10_JPRB, 0.43702101E-10_JPRB, 0.55861555E-10_JPRB, &
  & 0.69170260E-10_JPRB, 0.82903150E-10_JPRB, 0.96720583E-10_JPRB, 0.11051608E-09_JPRB, 0.12430722E-09_JPRB, 0.13867604E-09_JPRB, &
  & 0.15467758E-09_JPRB, 0.17299376E-09_JPRB, 0.19174407E-09_JPRB, 0.20551587E-09_JPRB, 0.21553741E-09_JPRB, 0.22398829E-09_JPRB, &
  & 0.23202623E-09_JPRB, 0.24023850E-09_JPRB, 0.24945926E-09_JPRB, 0.26282546E-09_JPRB /)

RGHG4(:,42, 6) = (/ &
  & 0.55804103E-12_JPRB, 0.88147073E-12_JPRB, 0.14363906E-11_JPRB, 0.21452965E-11_JPRB, 0.38104212E-11_JPRB, 0.62844066E-11_JPRB, &
  & 0.99501197E-11_JPRB, 0.15887486E-10_JPRB, 0.18144743E-10_JPRB, 0.24603567E-10_JPRB, 0.32513946E-10_JPRB, 0.40401165E-10_JPRB, &
  & 0.47949950E-10_JPRB, 0.53616736E-10_JPRB, 0.57175282E-10_JPRB, 0.57700705E-10_JPRB, 0.55158045E-10_JPRB, 0.49731160E-10_JPRB, &
  & 0.41825626E-10_JPRB, 0.32500051E-10_JPRB, 0.23549395E-10_JPRB, 0.16542014E-10_JPRB, 0.11785863E-10_JPRB, 0.88096509E-11_JPRB, &
  & 0.69861656E-11_JPRB, 0.58338941E-11_JPRB, 0.50621100E-11_JPRB, 0.44786995E-11_JPRB, 0.40292743E-11_JPRB, 0.36557931E-11_JPRB, &
  & 0.33834164E-11_JPRB, 0.31835383E-11_JPRB, 0.31263423E-11_JPRB, 0.31537151E-11_JPRB, 0.33355534E-11_JPRB, 0.35971367E-11_JPRB, &
  & 0.40156203E-11_JPRB, 0.45653442E-11_JPRB, 0.53037167E-11_JPRB, 0.62279318E-11_JPRB, 0.75288838E-11_JPRB, 0.92503782E-11_JPRB, &
  & 0.11550594E-10_JPRB, 0.14756795E-10_JPRB, 0.19205186E-10_JPRB, 0.25449228E-10_JPRB, 0.33737731E-10_JPRB, 0.44083053E-10_JPRB, &
  & 0.55904208E-10_JPRB, 0.68424925E-10_JPRB, 0.81142378E-10_JPRB, 0.93903378E-10_JPRB, 0.10666296E-09_JPRB, 0.11985425E-09_JPRB, &
  & 0.13444379E-09_JPRB, 0.15101057E-09_JPRB, 0.16782317E-09_JPRB, 0.18022997E-09_JPRB, 0.18928903E-09_JPRB, 0.19694361E-09_JPRB, &
  & 0.20416480E-09_JPRB, 0.21145918E-09_JPRB, 0.21967317E-09_JPRB, 0.23175817E-09_JPRB /)

RGHG4(:,43, 6) = (/ &
  & 0.55587566E-12_JPRB, 0.86158289E-12_JPRB, 0.14172047E-11_JPRB, 0.21125165E-11_JPRB, 0.37437276E-11_JPRB, 0.62656230E-11_JPRB, &
  & 0.98338750E-11_JPRB, 0.15320427E-10_JPRB, 0.16679432E-10_JPRB, 0.22052388E-10_JPRB, 0.28628794E-10_JPRB, 0.35270609E-10_JPRB, &
  & 0.41681894E-10_JPRB, 0.46521901E-10_JPRB, 0.49581138E-10_JPRB, 0.50030226E-10_JPRB, 0.47833969E-10_JPRB, 0.43105054E-10_JPRB, &
  & 0.36265178E-10_JPRB, 0.28231606E-10_JPRB, 0.20538205E-10_JPRB, 0.14418370E-10_JPRB, 0.10331899E-10_JPRB, 0.78168800E-11_JPRB, &
  & 0.62866296E-11_JPRB, 0.52878500E-11_JPRB, 0.45986760E-11_JPRB, 0.40763781E-11_JPRB, 0.36680966E-11_JPRB, 0.33302280E-11_JPRB, &
  & 0.30813407E-11_JPRB, 0.29072020E-11_JPRB, 0.28655377E-11_JPRB, 0.28953183E-11_JPRB, 0.30740729E-11_JPRB, 0.33027160E-11_JPRB, &
  & 0.36854985E-11_JPRB, 0.41476566E-11_JPRB, 0.47905278E-11_JPRB, 0.55350845E-11_JPRB, 0.65703619E-11_JPRB, 0.78865456E-11_JPRB, &
  & 0.95630084E-11_JPRB, 0.11889613E-10_JPRB, 0.15069515E-10_JPRB, 0.19646562E-10_JPRB, 0.25968162E-10_JPRB, 0.34414482E-10_JPRB, &
  & 0.44493246E-10_JPRB, 0.55576529E-10_JPRB, 0.67028563E-10_JPRB, 0.78554996E-10_JPRB, 0.90108601E-10_JPRB, 0.10202295E-09_JPRB, &
  & 0.11519001E-09_JPRB, 0.12999668E-09_JPRB, 0.14497308E-09_JPRB, 0.15612123E-09_JPRB, 0.16434092E-09_JPRB, 0.17123024E-09_JPRB, &
  & 0.17770160E-09_JPRB, 0.18418517E-09_JPRB, 0.19155168E-09_JPRB, 0.20257317E-09_JPRB /)

RGHG4(:,44, 6) = (/ &
  & 0.56046438E-12_JPRB, 0.81988989E-12_JPRB, 0.13776792E-11_JPRB, 0.20556128E-11_JPRB, 0.37256322E-11_JPRB, 0.61538314E-11_JPRB, &
  & 0.96774134E-11_JPRB, 0.14830715E-10_JPRB, 0.15357214E-10_JPRB, 0.19763829E-10_JPRB, 0.25180472E-10_JPRB, 0.30681888E-10_JPRB, &
  & 0.36059673E-10_JPRB, 0.40141498E-10_JPRB, 0.42704316E-10_JPRB, 0.43036005E-10_JPRB, 0.41146281E-10_JPRB, 0.37140343E-10_JPRB, &
  & 0.31281193E-10_JPRB, 0.24431913E-10_JPRB, 0.17865109E-10_JPRB, 0.12734929E-10_JPRB, 0.92570942E-11_JPRB, 0.70861121E-11_JPRB, &
  & 0.57549308E-11_JPRB, 0.48821242E-11_JPRB, 0.42621952E-11_JPRB, 0.37840920E-11_JPRB, 0.34033716E-11_JPRB, 0.30869096E-11_JPRB, &
  & 0.28528824E-11_JPRB, 0.26926649E-11_JPRB, 0.26580294E-11_JPRB, 0.26848742E-11_JPRB, 0.28641508E-11_JPRB, 0.30461931E-11_JPRB, &
  & 0.34270768E-11_JPRB, 0.38047412E-11_JPRB, 0.43876586E-11_JPRB, 0.50064766E-11_JPRB, 0.58517540E-11_JPRB, 0.68835328E-11_JPRB, &
  & 0.81305865E-11_JPRB, 0.98132153E-11_JPRB, 0.12028302E-10_JPRB, 0.15267164E-10_JPRB, 0.19871058E-10_JPRB, 0.26396881E-10_JPRB, &
  & 0.34666811E-10_JPRB, 0.44214524E-10_JPRB, 0.54308329E-10_JPRB, 0.64507684E-10_JPRB, 0.74795982E-10_JPRB, 0.85393567E-10_JPRB, &
  & 0.97043422E-10_JPRB, 0.11000677E-09_JPRB, 0.12302959E-09_JPRB, 0.13284619E-09_JPRB, 0.14016480E-09_JPRB, 0.14635730E-09_JPRB, &
  & 0.15213936E-09_JPRB, 0.15787892E-09_JPRB, 0.16442922E-09_JPRB, 0.17446129E-09_JPRB /)

RGHG4(:,45, 6) = (/ &
  & 0.56502925E-12_JPRB, 0.82354344E-12_JPRB, 0.13042860E-11_JPRB, 0.20964656E-11_JPRB, 0.36704394E-11_JPRB, 0.61638216E-11_JPRB, &
  & 0.95525341E-11_JPRB, 0.14431368E-10_JPRB, 0.14113562E-10_JPRB, 0.17687560E-10_JPRB, 0.21977663E-10_JPRB, 0.26448139E-10_JPRB, &
  & 0.30829568E-10_JPRB, 0.34199817E-10_JPRB, 0.36276072E-10_JPRB, 0.36478310E-10_JPRB, 0.34845078E-10_JPRB, 0.31475187E-10_JPRB, &
  & 0.26682196E-10_JPRB, 0.20981217E-10_JPRB, 0.15543339E-10_JPRB, 0.11208906E-10_JPRB, 0.83145001E-11_JPRB, 0.64849723E-11_JPRB, &
  & 0.53318140E-11_JPRB, 0.45555192E-11_JPRB, 0.39914838E-11_JPRB, 0.35471613E-11_JPRB, 0.31883779E-11_JPRB, 0.28889792E-11_JPRB, &
  & 0.26650635E-11_JPRB, 0.25151346E-11_JPRB, 0.24792627E-11_JPRB, 0.25105486E-11_JPRB, 0.26649963E-11_JPRB, 0.28390454E-11_JPRB, &
  & 0.31902950E-11_JPRB, 0.35159818E-11_JPRB, 0.40584112E-11_JPRB, 0.45774578E-11_JPRB, 0.52903151E-11_JPRB, 0.61153764E-11_JPRB, &
  & 0.70521037E-11_JPRB, 0.82716039E-11_JPRB, 0.97976098E-11_JPRB, 0.12004346E-10_JPRB, 0.15210617E-10_JPRB, 0.19930011E-10_JPRB, &
  & 0.26373882E-10_JPRB, 0.34245530E-10_JPRB, 0.42867536E-10_JPRB, 0.51626470E-10_JPRB, 0.60446113E-10_JPRB, 0.69542865E-10_JPRB, &
  & 0.79466343E-10_JPRB, 0.90363356E-10_JPRB, 0.10128995E-09_JPRB, 0.10966315E-09_JPRB, 0.11605134E-09_JPRB, 0.12146217E-09_JPRB, &
  & 0.12653129E-09_JPRB, 0.13153206E-09_JPRB, 0.13734330E-09_JPRB, 0.14652748E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART12',0,ZHOOK_HANDLE)



RGHG4(:,46, 6) = (/ &
  & 0.57261048E-12_JPRB, 0.81414102E-12_JPRB, 0.12792986E-11_JPRB, 0.20295202E-11_JPRB, 0.36469243E-11_JPRB, 0.60401063E-11_JPRB, &
  & 0.94665586E-11_JPRB, 0.13981289E-10_JPRB, 0.12909353E-10_JPRB, 0.15649867E-10_JPRB, 0.19008170E-10_JPRB, 0.22453173E-10_JPRB, &
  & 0.25927918E-10_JPRB, 0.28561377E-10_JPRB, 0.30157151E-10_JPRB, 0.30194451E-10_JPRB, 0.28771220E-10_JPRB, 0.26047775E-10_JPRB, &
  & 0.22191197E-10_JPRB, 0.17770488E-10_JPRB, 0.13439420E-10_JPRB, 0.99602410E-11_JPRB, 0.75352832E-11_JPRB, 0.59852635E-11_JPRB, &
  & 0.49861842E-11_JPRB, 0.42932493E-11_JPRB, 0.37754960E-11_JPRB, 0.33599983E-11_JPRB, 0.30170050E-11_JPRB, 0.27292936E-11_JPRB, &
  & 0.25101835E-11_JPRB, 0.23664406E-11_JPRB, 0.23257258E-11_JPRB, 0.23552937E-11_JPRB, 0.24826612E-11_JPRB, 0.26656654E-11_JPRB, &
  & 0.29612369E-11_JPRB, 0.32913763E-11_JPRB, 0.37682665E-11_JPRB, 0.42381858E-11_JPRB, 0.48489073E-11_JPRB, 0.55228209E-11_JPRB, &
  & 0.62483347E-11_JPRB, 0.71400446E-11_JPRB, 0.81845216E-11_JPRB, 0.96692931E-11_JPRB, 0.11773860E-10_JPRB, 0.15000074E-10_JPRB, &
  & 0.19590192E-10_JPRB, 0.25699207E-10_JPRB, 0.32629625E-10_JPRB, 0.39873896E-10_JPRB, 0.47182983E-10_JPRB, 0.54627098E-10_JPRB, &
  & 0.62663347E-10_JPRB, 0.71292368E-10_JPRB, 0.79868716E-10_JPRB, 0.86603995E-10_JPRB, 0.91866410E-10_JPRB, 0.96425506E-10_JPRB, &
  & 0.10070008E-09_JPRB, 0.10490120E-09_JPRB, 0.10984833E-09_JPRB, 0.11810439E-09_JPRB /)

RGHG4(:,47, 6) = (/ &
  & 0.59888645E-12_JPRB, 0.82762676E-12_JPRB, 0.12459042E-11_JPRB, 0.19789305E-11_JPRB, 0.35172119E-11_JPRB, 0.58378940E-11_JPRB, &
  & 0.91044299E-11_JPRB, 0.13306647E-10_JPRB, 0.11434547E-10_JPRB, 0.13485124E-10_JPRB, 0.15891503E-10_JPRB, 0.18434332E-10_JPRB, &
  & 0.20996047E-10_JPRB, 0.22947512E-10_JPRB, 0.24036537E-10_JPRB, 0.23917649E-10_JPRB, 0.22728590E-10_JPRB, 0.20637323E-10_JPRB, &
  & 0.17878065E-10_JPRB, 0.14670253E-10_JPRB, 0.11495818E-10_JPRB, 0.87892341E-11_JPRB, 0.68480009E-11_JPRB, 0.55475334E-11_JPRB, &
  & 0.46829541E-11_JPRB, 0.40632458E-11_JPRB, 0.35858406E-11_JPRB, 0.31948448E-11_JPRB, 0.28660566E-11_JPRB, 0.25881083E-11_JPRB, &
  & 0.23733205E-11_JPRB, 0.22343622E-11_JPRB, 0.21865591E-11_JPRB, 0.22084613E-11_JPRB, 0.23250054E-11_JPRB, 0.24933172E-11_JPRB, &
  & 0.27587774E-11_JPRB, 0.30886626E-11_JPRB, 0.35016254E-11_JPRB, 0.39426075E-11_JPRB, 0.44684425E-11_JPRB, 0.50271272E-11_JPRB, &
  & 0.56010895E-11_JPRB, 0.62493513E-11_JPRB, 0.69684597E-11_JPRB, 0.79257798E-11_JPRB, 0.92618482E-11_JPRB, 0.11283467E-10_JPRB, &
  & 0.14321844E-10_JPRB, 0.18557029E-10_JPRB, 0.23835761E-10_JPRB, 0.29495011E-10_JPRB, 0.35314064E-10_JPRB, 0.41227011E-10_JPRB, &
  & 0.47540246E-10_JPRB, 0.54153751E-10_JPRB, 0.60767731E-10_JPRB, 0.65995612E-10_JPRB, 0.70191339E-10_JPRB, 0.73853888E-10_JPRB, &
  & 0.77291444E-10_JPRB, 0.80653262E-10_JPRB, 0.84668564E-10_JPRB, 0.91620385E-10_JPRB /)

RGHG4(:,48, 6) = (/ &
  & 0.62928482E-12_JPRB, 0.82740271E-12_JPRB, 0.12416714E-11_JPRB, 0.18558529E-11_JPRB, 0.34180952E-11_JPRB, 0.55058614E-11_JPRB, &
  & 0.85810647E-11_JPRB, 0.12195280E-10_JPRB, 0.96709403E-11_JPRB, 0.10974424E-10_JPRB, 0.12589188E-10_JPRB, 0.14248113E-10_JPRB, &
  & 0.15986589E-10_JPRB, 0.17270390E-10_JPRB, 0.17942894E-10_JPRB, 0.17746245E-10_JPRB, 0.16888631E-10_JPRB, 0.15549506E-10_JPRB, &
  & 0.13872335E-10_JPRB, 0.11893637E-10_JPRB, 0.97873133E-11_JPRB, 0.78066329E-11_JPRB, 0.62683929E-11_JPRB, 0.51844956E-11_JPRB, &
  & 0.44329635E-11_JPRB, 0.38745851E-11_JPRB, 0.34305026E-11_JPRB, 0.30597250E-11_JPRB, 0.27432579E-11_JPRB, 0.24726217E-11_JPRB, &
  & 0.22618131E-11_JPRB, 0.21237040E-11_JPRB, 0.20663681E-11_JPRB, 0.20868370E-11_JPRB, 0.21852715E-11_JPRB, 0.23358498E-11_JPRB, &
  & 0.25966579E-11_JPRB, 0.29064123E-11_JPRB, 0.32829739E-11_JPRB, 0.37010282E-11_JPRB, 0.41681502E-11_JPRB, 0.46406507E-11_JPRB, &
  & 0.51137289E-11_JPRB, 0.55917896E-11_JPRB, 0.60922062E-11_JPRB, 0.67121339E-11_JPRB, 0.75248479E-11_JPRB, 0.87279602E-11_JPRB, &
  & 0.10511324E-10_JPRB, 0.13176425E-10_JPRB, 0.16575481E-10_JPRB, 0.20657613E-10_JPRB, 0.24948458E-10_JPRB, 0.29439812E-10_JPRB, &
  & 0.34195591E-10_JPRB, 0.39120155E-10_JPRB, 0.44083164E-10_JPRB, 0.47992589E-10_JPRB, 0.51156974E-10_JPRB, 0.53938038E-10_JPRB, &
  & 0.56560208E-10_JPRB, 0.59118335E-10_JPRB, 0.62262147E-10_JPRB, 0.68037277E-10_JPRB /)

RGHG4(:,49, 6) = (/ &
  & 0.65138883E-12_JPRB, 0.82651778E-12_JPRB, 0.11905360E-11_JPRB, 0.17866004E-11_JPRB, 0.30834950E-11_JPRB, 0.50822007E-11_JPRB, &
  & 0.75845198E-11_JPRB, 0.10538535E-10_JPRB, 0.74011890E-11_JPRB, 0.80989052E-11_JPRB, 0.89377741E-11_JPRB, 0.98967032E-11_JPRB, &
  & 0.10901596E-10_JPRB, 0.11672885E-10_JPRB, 0.12057280E-10_JPRB, 0.11970610E-10_JPRB, 0.11593086E-10_JPRB, 0.11063345E-10_JPRB, &
  & 0.10366742E-10_JPRB, 0.94757284E-11_JPRB, 0.82600142E-11_JPRB, 0.69391901E-11_JPRB, 0.57624335E-11_JPRB, 0.48669645E-11_JPRB, &
  & 0.42131875E-11_JPRB, 0.37081020E-11_JPRB, 0.32951454E-11_JPRB, 0.29404272E-11_JPRB, 0.26375540E-11_JPRB, 0.23722998E-11_JPRB, &
  & 0.21695863E-11_JPRB, 0.20229951E-11_JPRB, 0.19702820E-11_JPRB, 0.19788572E-11_JPRB, 0.20576626E-11_JPRB, 0.22076789E-11_JPRB, &
  & 0.24547074E-11_JPRB, 0.27394387E-11_JPRB, 0.30919069E-11_JPRB, 0.34849122E-11_JPRB, 0.38995049E-11_JPRB, 0.43112653E-11_JPRB, &
  & 0.47035344E-11_JPRB, 0.50638179E-11_JPRB, 0.54134613E-11_JPRB, 0.58029315E-11_JPRB, 0.62778875E-11_JPRB, 0.69355017E-11_JPRB, &
  & 0.78982775E-11_JPRB, 0.92845020E-11_JPRB, 0.11198670E-10_JPRB, 0.13496229E-10_JPRB, 0.16224397E-10_JPRB, 0.19160855E-10_JPRB, &
  & 0.22466334E-10_JPRB, 0.25984090E-10_JPRB, 0.29791294E-10_JPRB, 0.32708124E-10_JPRB, 0.35116503E-10_JPRB, 0.37199320E-10_JPRB, &
  & 0.39143494E-10_JPRB, 0.41032257E-10_JPRB, 0.43408520E-10_JPRB, 0.47998869E-10_JPRB /)

RGHG4(:,50, 6) = (/ &
  & 0.68181170E-12_JPRB, 0.84399268E-12_JPRB, 0.11471311E-11_JPRB, 0.17554141E-11_JPRB, 0.27661341E-11_JPRB, 0.44615787E-11_JPRB, &
  & 0.63625524E-11_JPRB, 0.84282034E-11_JPRB, 0.51481089E-11_JPRB, 0.53825282E-11_JPRB, 0.57690246E-11_JPRB, 0.62224449E-11_JPRB, &
  & 0.68002084E-11_JPRB, 0.72846087E-11_JPRB, 0.76301500E-11_JPRB, 0.77575984E-11_JPRB, 0.77979810E-11_JPRB, 0.77968890E-11_JPRB, &
  & 0.77450693E-11_JPRB, 0.75134699E-11_JPRB, 0.70130334E-11_JPRB, 0.61916761E-11_JPRB, 0.53336012E-11_JPRB, 0.45970636E-11_JPRB, &
  & 0.40267238E-11_JPRB, 0.35664262E-11_JPRB, 0.31810156E-11_JPRB, 0.28410369E-11_JPRB, 0.25500997E-11_JPRB, 0.22902448E-11_JPRB, &
  & 0.20991824E-11_JPRB, 0.19432711E-11_JPRB, 0.19049293E-11_JPRB, 0.18811901E-11_JPRB, 0.19694103E-11_JPRB, 0.21078393E-11_JPRB, &
  & 0.23351160E-11_JPRB, 0.26013896E-11_JPRB, 0.29376861E-11_JPRB, 0.33046300E-11_JPRB, 0.36836454E-11_JPRB, 0.40501053E-11_JPRB, &
  & 0.43793437E-11_JPRB, 0.46534825E-11_JPRB, 0.48968525E-11_JPRB, 0.51384643E-11_JPRB, 0.54072250E-11_JPRB, 0.57414780E-11_JPRB, &
  & 0.62137136E-11_JPRB, 0.68826386E-11_JPRB, 0.77560658E-11_JPRB, 0.88991670E-11_JPRB, 0.10219356E-10_JPRB, 0.11835503E-10_JPRB, &
  & 0.13735824E-10_JPRB, 0.15912419E-10_JPRB, 0.18658986E-10_JPRB, 0.20732985E-10_JPRB, 0.22476940E-10_JPRB, 0.24007459E-10_JPRB, &
  & 0.25425856E-10_JPRB, 0.26851016E-10_JPRB, 0.28706986E-10_JPRB, 0.32503805E-10_JPRB /)

RGHG4(:,51, 6) = (/ &
  & 0.74542754E-12_JPRB, 0.87517266E-12_JPRB, 0.11638079E-11_JPRB, 0.16717267E-11_JPRB, 0.25795490E-11_JPRB, 0.38334171E-11_JPRB, &
  & 0.52684085E-11_JPRB, 0.66112857E-11_JPRB, 0.35639183E-11_JPRB, 0.36080323E-11_JPRB, 0.37471558E-11_JPRB, 0.40071531E-11_JPRB, &
  & 0.43595010E-11_JPRB, 0.47478332E-11_JPRB, 0.50987942E-11_JPRB, 0.53508612E-11_JPRB, 0.55638311E-11_JPRB, 0.57652351E-11_JPRB, &
  & 0.59542449E-11_JPRB, 0.60651991E-11_JPRB, 0.59682762E-11_JPRB, 0.55714895E-11_JPRB, 0.49705929E-11_JPRB, 0.43743182E-11_JPRB, &
  & 0.38732485E-11_JPRB, 0.34510042E-11_JPRB, 0.30885871E-11_JPRB, 0.27650506E-11_JPRB, 0.24827221E-11_JPRB, 0.22374552E-11_JPRB, &
  & 0.20437593E-11_JPRB, 0.19018910E-11_JPRB, 0.18462022E-11_JPRB, 0.18254133E-11_JPRB, 0.19124357E-11_JPRB, 0.20330174E-11_JPRB, &
  & 0.22441747E-11_JPRB, 0.24989928E-11_JPRB, 0.28118538E-11_JPRB, 0.31554154E-11_JPRB, 0.35047000E-11_JPRB, 0.38305678E-11_JPRB, &
  & 0.41076799E-11_JPRB, 0.43269758E-11_JPRB, 0.44905316E-11_JPRB, 0.46476087E-11_JPRB, 0.47890017E-11_JPRB, 0.49482788E-11_JPRB, &
  & 0.51609984E-11_JPRB, 0.54561772E-11_JPRB, 0.58475690E-11_JPRB, 0.63217808E-11_JPRB, 0.69133241E-11_JPRB, 0.75817807E-11_JPRB, &
  & 0.84028218E-11_JPRB, 0.94341375E-11_JPRB, 0.11078456E-10_JPRB, 0.12184427E-10_JPRB, 0.13200082E-10_JPRB, 0.14090169E-10_JPRB, &
  & 0.15001334E-10_JPRB, 0.15949044E-10_JPRB, 0.17349535E-10_JPRB, 0.20382073E-10_JPRB /)

RGHG4(:,52, 6) = (/ &
  & 0.83932920E-12_JPRB, 0.97262454E-12_JPRB, 0.11854518E-11_JPRB, 0.16767877E-11_JPRB, 0.24503639E-11_JPRB, 0.34628561E-11_JPRB, &
  & 0.44635836E-11_JPRB, 0.54115202E-11_JPRB, 0.27047713E-11_JPRB, 0.26659267E-11_JPRB, 0.27422472E-11_JPRB, 0.28718690E-11_JPRB, &
  & 0.31513071E-11_JPRB, 0.34694695E-11_JPRB, 0.38090460E-11_JPRB, 0.40852538E-11_JPRB, 0.43240281E-11_JPRB, 0.45706126E-11_JPRB, &
  & 0.47946295E-11_JPRB, 0.50251157E-11_JPRB, 0.51420764E-11_JPRB, 0.50281320E-11_JPRB, 0.46613668E-11_JPRB, 0.41887613E-11_JPRB, &
  & 0.37495319E-11_JPRB, 0.33608875E-11_JPRB, 0.30184100E-11_JPRB, 0.27116467E-11_JPRB, 0.24373077E-11_JPRB, 0.22079651E-11_JPRB, &
  & 0.20226167E-11_JPRB, 0.18949872E-11_JPRB, 0.18242643E-11_JPRB, 0.18212298E-11_JPRB, 0.18864515E-11_JPRB, 0.20001676E-11_JPRB, &
  & 0.22008829E-11_JPRB, 0.24440337E-11_JPRB, 0.27364723E-11_JPRB, 0.30616373E-11_JPRB, 0.33768776E-11_JPRB, 0.36623634E-11_JPRB, &
  & 0.39040238E-11_JPRB, 0.40696951E-11_JPRB, 0.41810904E-11_JPRB, 0.42727939E-11_JPRB, 0.43450642E-11_JPRB, 0.44025235E-11_JPRB, &
  & 0.44861606E-11_JPRB, 0.46065205E-11_JPRB, 0.47699713E-11_JPRB, 0.49802831E-11_JPRB, 0.52114810E-11_JPRB, 0.54819491E-11_JPRB, &
  & 0.58198403E-11_JPRB, 0.61980967E-11_JPRB, 0.72254121E-11_JPRB, 0.76617783E-11_JPRB, 0.80628776E-11_JPRB, 0.84878641E-11_JPRB, &
  & 0.89217227E-11_JPRB, 0.94510701E-11_JPRB, 0.10271177E-10_JPRB, 0.12297601E-10_JPRB /)

RGHG4(:,53, 6) = (/ &
  & 0.94202315E-12_JPRB, 0.10877584E-11_JPRB, 0.13013430E-11_JPRB, 0.16839894E-11_JPRB, 0.23582447E-11_JPRB, 0.31678208E-11_JPRB, &
  & 0.39621314E-11_JPRB, 0.46246162E-11_JPRB, 0.22410708E-11_JPRB, 0.21889407E-11_JPRB, 0.22074432E-11_JPRB, 0.23190716E-11_JPRB, &
  & 0.25170146E-11_JPRB, 0.28144659E-11_JPRB, 0.31271635E-11_JPRB, 0.33994010E-11_JPRB, 0.36390101E-11_JPRB, 0.38567912E-11_JPRB, &
  & 0.40941391E-11_JPRB, 0.43151793E-11_JPRB, 0.45333425E-11_JPRB, 0.45845450E-11_JPRB, 0.44082676E-11_JPRB, 0.40536684E-11_JPRB, &
  & 0.36711849E-11_JPRB, 0.33107031E-11_JPRB, 0.29851785E-11_JPRB, 0.26940253E-11_JPRB, 0.24353967E-11_JPRB, 0.22162344E-11_JPRB, &
  & 0.20472539E-11_JPRB, 0.19138786E-11_JPRB, 0.18509309E-11_JPRB, 0.18480564E-11_JPRB, 0.19001870E-11_JPRB, 0.20121470E-11_JPRB, &
  & 0.21993718E-11_JPRB, 0.24286985E-11_JPRB, 0.27031021E-11_JPRB, 0.30094896E-11_JPRB, 0.32996793E-11_JPRB, 0.35550436E-11_JPRB, &
  & 0.37555163E-11_JPRB, 0.38838997E-11_JPRB, 0.39535207E-11_JPRB, 0.40129844E-11_JPRB, 0.40434153E-11_JPRB, 0.40537994E-11_JPRB, &
  & 0.40764063E-11_JPRB, 0.41191850E-11_JPRB, 0.41873961E-11_JPRB, 0.42673603E-11_JPRB, 0.43596728E-11_JPRB, 0.44636369E-11_JPRB, &
  & 0.45841772E-11_JPRB, 0.47292456E-11_JPRB, 0.55017579E-11_JPRB, 0.56591832E-11_JPRB, 0.58276864E-11_JPRB, 0.59944940E-11_JPRB, &
  & 0.61993405E-11_JPRB, 0.64461305E-11_JPRB, 0.68551471E-11_JPRB, 0.79555416E-11_JPRB /)

RGHG4(:,54, 6) = (/ &
  & 0.10353550E-11_JPRB, 0.11864406E-11_JPRB, 0.14027180E-11_JPRB, 0.17456871E-11_JPRB, 0.23051071E-11_JPRB, 0.29803261E-11_JPRB, &
  & 0.35867513E-11_JPRB, 0.41151574E-11_JPRB, 0.19913168E-11_JPRB, 0.19293345E-11_JPRB, 0.19408789E-11_JPRB, 0.20002030E-11_JPRB, &
  & 0.21836265E-11_JPRB, 0.24301487E-11_JPRB, 0.27293545E-11_JPRB, 0.29856991E-11_JPRB, 0.32007251E-11_JPRB, 0.34197966E-11_JPRB, &
  & 0.36156609E-11_JPRB, 0.38473612E-11_JPRB, 0.40713106E-11_JPRB, 0.42446255E-11_JPRB, 0.42099106E-11_JPRB, 0.39703726E-11_JPRB, &
  & 0.36484236E-11_JPRB, 0.33147775E-11_JPRB, 0.30045051E-11_JPRB, 0.27258601E-11_JPRB, 0.24771819E-11_JPRB, 0.22749047E-11_JPRB, &
  & 0.21211784E-11_JPRB, 0.20034955E-11_JPRB, 0.19430169E-11_JPRB, 0.19394484E-11_JPRB, 0.19879532E-11_JPRB, 0.20970925E-11_JPRB, &
  & 0.22719344E-11_JPRB, 0.24920660E-11_JPRB, 0.27504078E-11_JPRB, 0.30425462E-11_JPRB, 0.32989408E-11_JPRB, 0.35068459E-11_JPRB, &
  & 0.36824497E-11_JPRB, 0.37767307E-11_JPRB, 0.38131234E-11_JPRB, 0.38440982E-11_JPRB, 0.38475902E-11_JPRB, 0.38257101E-11_JPRB, &
  & 0.38178878E-11_JPRB, 0.38219033E-11_JPRB, 0.38397137E-11_JPRB, 0.38716920E-11_JPRB, 0.39037502E-11_JPRB, 0.39424284E-11_JPRB, &
  & 0.39873426E-11_JPRB, 0.40451947E-11_JPRB, 0.47296000E-11_JPRB, 0.47923614E-11_JPRB, 0.48648845E-11_JPRB, 0.49511836E-11_JPRB, &
  & 0.50614925E-11_JPRB, 0.51786054E-11_JPRB, 0.53598571E-11_JPRB, 0.56871218E-11_JPRB /)

RGHG4(:,55, 6) = (/ &
  & 0.11168416E-11_JPRB, 0.12666950E-11_JPRB, 0.14939483E-11_JPRB, 0.17988618E-11_JPRB, 0.22591477E-11_JPRB, 0.28257444E-11_JPRB, &
  & 0.33390328E-11_JPRB, 0.37431924E-11_JPRB, 0.18505102E-11_JPRB, 0.17880798E-11_JPRB, 0.17847081E-11_JPRB, 0.18443732E-11_JPRB, &
  & 0.19829147E-11_JPRB, 0.22176252E-11_JPRB, 0.24914907E-11_JPRB, 0.27388048E-11_JPRB, 0.29583972E-11_JPRB, 0.31427066E-11_JPRB, &
  & 0.33543396E-11_JPRB, 0.35546674E-11_JPRB, 0.38002388E-11_JPRB, 0.40113707E-11_JPRB, 0.40939101E-11_JPRB, 0.39557658E-11_JPRB, &
  & 0.36975063E-11_JPRB, 0.33900732E-11_JPRB, 0.30931603E-11_JPRB, 0.28254903E-11_JPRB, 0.25868962E-11_JPRB, 0.23952056E-11_JPRB, &
  & 0.22531716E-11_JPRB, 0.21379946E-11_JPRB, 0.20736243E-11_JPRB, 0.20677255E-11_JPRB, 0.21111069E-11_JPRB, 0.22128720E-11_JPRB, &
  & 0.23780899E-11_JPRB, 0.25899202E-11_JPRB, 0.28426534E-11_JPRB, 0.31211624E-11_JPRB, 0.33637702E-11_JPRB, 0.35443738E-11_JPRB, &
  & 0.37003898E-11_JPRB, 0.37537157E-11_JPRB, 0.37601328E-11_JPRB, 0.37730318E-11_JPRB, 0.37631699E-11_JPRB, 0.37229837E-11_JPRB, &
  & 0.36983069E-11_JPRB, 0.36832863E-11_JPRB, 0.36863724E-11_JPRB, 0.36920523E-11_JPRB, 0.36993048E-11_JPRB, 0.37094052E-11_JPRB, &
  & 0.37192467E-11_JPRB, 0.37415617E-11_JPRB, 0.43608233E-11_JPRB, 0.44011413E-11_JPRB, 0.44530248E-11_JPRB, 0.45139682E-11_JPRB, &
  & 0.45903476E-11_JPRB, 0.46885083E-11_JPRB, 0.48128836E-11_JPRB, 0.49170559E-11_JPRB /)

RGHG4(:,56, 6) = (/ &
  & 0.11918901E-11_JPRB, 0.13524698E-11_JPRB, 0.15586155E-11_JPRB, 0.18412884E-11_JPRB, 0.22377883E-11_JPRB, 0.27056842E-11_JPRB, &
  & 0.31377435E-11_JPRB, 0.34860006E-11_JPRB, 0.17847708E-11_JPRB, 0.17230349E-11_JPRB, 0.17164861E-11_JPRB, 0.17506803E-11_JPRB, &
  & 0.18848280E-11_JPRB, 0.20818870E-11_JPRB, 0.23467946E-11_JPRB, 0.25859506E-11_JPRB, 0.27965291E-11_JPRB, 0.30035028E-11_JPRB, &
  & 0.31846680E-11_JPRB, 0.34103805E-11_JPRB, 0.36485598E-11_JPRB, 0.39175633E-11_JPRB, 0.40771496E-11_JPRB, 0.40291711E-11_JPRB, &
  & 0.38336999E-11_JPRB, 0.35492056E-11_JPRB, 0.32620816E-11_JPRB, 0.29980699E-11_JPRB, 0.27663384E-11_JPRB, 0.25773455E-11_JPRB, &
  & 0.24365254E-11_JPRB, 0.23166993E-11_JPRB, 0.22489278E-11_JPRB, 0.22392804E-11_JPRB, 0.22772385E-11_JPRB, 0.23711493E-11_JPRB, &
  & 0.25273774E-11_JPRB, 0.27345591E-11_JPRB, 0.29799887E-11_JPRB, 0.32520048E-11_JPRB, 0.34881059E-11_JPRB, 0.36547072E-11_JPRB, &
  & 0.37874070E-11_JPRB, 0.38247014E-11_JPRB, 0.38088833E-11_JPRB, 0.38106939E-11_JPRB, 0.37819027E-11_JPRB, 0.37158137E-11_JPRB, &
  & 0.36814263E-11_JPRB, 0.36517733E-11_JPRB, 0.36406230E-11_JPRB, 0.36358256E-11_JPRB, 0.36273994E-11_JPRB, 0.36236485E-11_JPRB, &
  & 0.36203610E-11_JPRB, 0.36372604E-11_JPRB, 0.42237099E-11_JPRB, 0.42602519E-11_JPRB, 0.43030883E-11_JPRB, 0.43526203E-11_JPRB, &
  & 0.44329583E-11_JPRB, 0.45291574E-11_JPRB, 0.46745385E-11_JPRB, 0.49443939E-11_JPRB /)

RGHG4(:,57, 6) = (/ &
  & 0.12538771E-11_JPRB, 0.14314644E-11_JPRB, 0.16098427E-11_JPRB, 0.18765766E-11_JPRB, 0.22142268E-11_JPRB, 0.26286720E-11_JPRB, &
  & 0.30045578E-11_JPRB, 0.32951237E-11_JPRB, 0.17552625E-11_JPRB, 0.17024701E-11_JPRB, 0.16953987E-11_JPRB, 0.17309815E-11_JPRB, &
  & 0.18396602E-11_JPRB, 0.20281194E-11_JPRB, 0.22761641E-11_JPRB, 0.25210478E-11_JPRB, 0.27446645E-11_JPRB, 0.29478744E-11_JPRB, &
  & 0.31626622E-11_JPRB, 0.33828964E-11_JPRB, 0.36529816E-11_JPRB, 0.39536911E-11_JPRB, 0.41811927E-11_JPRB, 0.41983235E-11_JPRB, &
  & 0.40603111E-11_JPRB, 0.37931065E-11_JPRB, 0.35070339E-11_JPRB, 0.32408715E-11_JPRB, 0.30036629E-11_JPRB, 0.28027303E-11_JPRB, &
  & 0.26536984E-11_JPRB, 0.25285392E-11_JPRB, 0.24555009E-11_JPRB, 0.24410270E-11_JPRB, 0.24721974E-11_JPRB, 0.25570390E-11_JPRB, &
  & 0.27046507E-11_JPRB, 0.29058765E-11_JPRB, 0.31475992E-11_JPRB, 0.34133211E-11_JPRB, 0.36473272E-11_JPRB, 0.38124408E-11_JPRB, &
  & 0.39295294E-11_JPRB, 0.39631055E-11_JPRB, 0.39409513E-11_JPRB, 0.39366479E-11_JPRB, 0.39008072E-11_JPRB, 0.38245132E-11_JPRB, &
  & 0.37749959E-11_JPRB, 0.37253828E-11_JPRB, 0.37083427E-11_JPRB, 0.36957373E-11_JPRB, 0.36775830E-11_JPRB, 0.36671777E-11_JPRB, &
  & 0.36600402E-11_JPRB, 0.36704207E-11_JPRB, 0.42066749E-11_JPRB, 0.42477211E-11_JPRB, 0.42908693E-11_JPRB, 0.43437255E-11_JPRB, &
  & 0.44188667E-11_JPRB, 0.45048943E-11_JPRB, 0.46260860E-11_JPRB, 0.47956994E-11_JPRB /)

RGHG4(:,58, 6) = (/ &
  & 0.13076455E-11_JPRB, 0.14837688E-11_JPRB, 0.16764653E-11_JPRB, 0.18967891E-11_JPRB, 0.22078628E-11_JPRB, 0.25723425E-11_JPRB, &
  & 0.29143029E-11_JPRB, 0.31862213E-11_JPRB, 0.17799009E-11_JPRB, 0.17265972E-11_JPRB, 0.17230163E-11_JPRB, 0.17500129E-11_JPRB, &
  & 0.18605889E-11_JPRB, 0.20294461E-11_JPRB, 0.22755825E-11_JPRB, 0.25298780E-11_JPRB, 0.27688101E-11_JPRB, 0.30104467E-11_JPRB, &
  & 0.32262233E-11_JPRB, 0.34909736E-11_JPRB, 0.37869048E-11_JPRB, 0.41290634E-11_JPRB, 0.44103996E-11_JPRB, 0.44583829E-11_JPRB, &
  & 0.43221811E-11_JPRB, 0.40629644E-11_JPRB, 0.37763750E-11_JPRB, 0.35068877E-11_JPRB, 0.32659515E-11_JPRB, 0.30657261E-11_JPRB, &
  & 0.29065268E-11_JPRB, 0.27769718E-11_JPRB, 0.26991417E-11_JPRB, 0.26797924E-11_JPRB, 0.27040301E-11_JPRB, 0.27791307E-11_JPRB, &
  & 0.29170169E-11_JPRB, 0.31114835E-11_JPRB, 0.33487267E-11_JPRB, 0.36100712E-11_JPRB, 0.38424403E-11_JPRB, 0.40077711E-11_JPRB, &
  & 0.41141639E-11_JPRB, 0.41517007E-11_JPRB, 0.41322210E-11_JPRB, 0.41295990E-11_JPRB, 0.40935445E-11_JPRB, 0.40194085E-11_JPRB, &
  & 0.39671317E-11_JPRB, 0.39051405E-11_JPRB, 0.38815678E-11_JPRB, 0.38586985E-11_JPRB, 0.38285646E-11_JPRB, 0.38105712E-11_JPRB, &
  & 0.37987291E-11_JPRB, 0.38126737E-11_JPRB, 0.43251019E-11_JPRB, 0.43772078E-11_JPRB, 0.44190081E-11_JPRB, 0.44730318E-11_JPRB, &
  & 0.45506684E-11_JPRB, 0.46458128E-11_JPRB, 0.47871884E-11_JPRB, 0.49704854E-11_JPRB /)

RGHG4(:,59, 6) = (/ &
  & 0.13582330E-11_JPRB, 0.15302617E-11_JPRB, 0.17085462E-11_JPRB, 0.19423519E-11_JPRB, 0.22135282E-11_JPRB, 0.25610243E-11_JPRB, &
  & 0.28740324E-11_JPRB, 0.31230539E-11_JPRB, 0.18308265E-11_JPRB, 0.17952284E-11_JPRB, 0.17960536E-11_JPRB, 0.18309633E-11_JPRB, &
  & 0.19368847E-11_JPRB, 0.21099270E-11_JPRB, 0.23611781E-11_JPRB, 0.26355725E-11_JPRB, 0.29072330E-11_JPRB, 0.31754187E-11_JPRB, &
  & 0.34355793E-11_JPRB, 0.37220674E-11_JPRB, 0.40528722E-11_JPRB, 0.44266366E-11_JPRB, 0.46994309E-11_JPRB, 0.47500185E-11_JPRB, &
  & 0.46256866E-11_JPRB, 0.43718744E-11_JPRB, 0.40838249E-11_JPRB, 0.38098214E-11_JPRB, 0.35628813E-11_JPRB, 0.33506535E-11_JPRB, &
  & 0.31860163E-11_JPRB, 0.30535292E-11_JPRB, 0.29717916E-11_JPRB, 0.29482664E-11_JPRB, 0.29654462E-11_JPRB, 0.30308781E-11_JPRB, &
  & 0.31589661E-11_JPRB, 0.33452113E-11_JPRB, 0.35749858E-11_JPRB, 0.38317492E-11_JPRB, 0.40646362E-11_JPRB, 0.42343412E-11_JPRB, &
  & 0.43382208E-11_JPRB, 0.43816040E-11_JPRB, 0.43704966E-11_JPRB, 0.43740636E-11_JPRB, 0.43461211E-11_JPRB, 0.42898948E-11_JPRB, &
  & 0.42440500E-11_JPRB, 0.41847983E-11_JPRB, 0.41576339E-11_JPRB, 0.41314682E-11_JPRB, 0.40881907E-11_JPRB, 0.40624041E-11_JPRB, &
  & 0.40479200E-11_JPRB, 0.40712217E-11_JPRB, 0.45515171E-11_JPRB, 0.46074945E-11_JPRB, 0.46568513E-11_JPRB, 0.47159750E-11_JPRB, &
  & 0.47934564E-11_JPRB, 0.48905120E-11_JPRB, 0.50193035E-11_JPRB, 0.51696932E-11_JPRB /)

RGHG4(:,60, 6) = (/ &
  & 0.14119973E-11_JPRB, 0.15791822E-11_JPRB, 0.17542853E-11_JPRB, 0.19688346E-11_JPRB, 0.22433364E-11_JPRB, 0.25659177E-11_JPRB, &
  & 0.28917498E-11_JPRB, 0.31426478E-11_JPRB, 0.19375779E-11_JPRB, 0.19107450E-11_JPRB, 0.19270716E-11_JPRB, 0.19721867E-11_JPRB, &
  & 0.20935471E-11_JPRB, 0.22785044E-11_JPRB, 0.25516477E-11_JPRB, 0.28617961E-11_JPRB, 0.31742777E-11_JPRB, 0.34877730E-11_JPRB, &
  & 0.37685011E-11_JPRB, 0.40863151E-11_JPRB, 0.44423840E-11_JPRB, 0.47911588E-11_JPRB, 0.50464168E-11_JPRB, 0.50860531E-11_JPRB, &
  & 0.49509589E-11_JPRB, 0.46963670E-11_JPRB, 0.44061144E-11_JPRB, 0.41252821E-11_JPRB, 0.38767509E-11_JPRB, 0.36646125E-11_JPRB, &
  & 0.34978763E-11_JPRB, 0.33704463E-11_JPRB, 0.32888844E-11_JPRB, 0.32620328E-11_JPRB, 0.32725274E-11_JPRB, 0.33287520E-11_JPRB, &
  & 0.34449271E-11_JPRB, 0.36206040E-11_JPRB, 0.38421319E-11_JPRB, 0.40923770E-11_JPRB, 0.43255326E-11_JPRB, 0.44989719E-11_JPRB, &
  & 0.46036439E-11_JPRB, 0.46568751E-11_JPRB, 0.46589594E-11_JPRB, 0.46695620E-11_JPRB, 0.46529980E-11_JPRB, 0.46158160E-11_JPRB, &
  & 0.45854574E-11_JPRB, 0.45412805E-11_JPRB, 0.45214869E-11_JPRB, 0.45028582E-11_JPRB, 0.44517354E-11_JPRB, 0.44226805E-11_JPRB, &
  & 0.44059166E-11_JPRB, 0.44483189E-11_JPRB, 0.49193193E-11_JPRB, 0.49956194E-11_JPRB, 0.50501907E-11_JPRB, 0.51105010E-11_JPRB, &
  & 0.51931957E-11_JPRB, 0.53003513E-11_JPRB, 0.54307769E-11_JPRB, 0.55292420E-11_JPRB /)

RGHG4(:,61, 6) = (/ &
  & 0.14457104E-11_JPRB, 0.16126665E-11_JPRB, 0.17887224E-11_JPRB, 0.20075814E-11_JPRB, 0.22784517E-11_JPRB, 0.26145275E-11_JPRB, &
  & 0.29339083E-11_JPRB, 0.32135878E-11_JPRB, 0.20853939E-11_JPRB, 0.20893907E-11_JPRB, 0.21232519E-11_JPRB, 0.21971927E-11_JPRB, &
  & 0.23464772E-11_JPRB, 0.25670553E-11_JPRB, 0.28872347E-11_JPRB, 0.32415121E-11_JPRB, 0.35996210E-11_JPRB, 0.39491041E-11_JPRB, &
  & 0.42448319E-11_JPRB, 0.45701012E-11_JPRB, 0.48911118E-11_JPRB, 0.52096899E-11_JPRB, 0.54207459E-11_JPRB, 0.54410413E-11_JPRB, &
  & 0.52999796E-11_JPRB, 0.50445338E-11_JPRB, 0.47517901E-11_JPRB, 0.44719272E-11_JPRB, 0.42219197E-11_JPRB, 0.40144528E-11_JPRB, &
  & 0.38526608E-11_JPRB, 0.37343787E-11_JPRB, 0.36591849E-11_JPRB, 0.36319940E-11_JPRB, 0.36356239E-11_JPRB, 0.36817554E-11_JPRB, &
  & 0.37850166E-11_JPRB, 0.39467817E-11_JPRB, 0.41570436E-11_JPRB, 0.43994942E-11_JPRB, 0.46291577E-11_JPRB, 0.48105981E-11_JPRB, &
  & 0.49210020E-11_JPRB, 0.49857349E-11_JPRB, 0.50019112E-11_JPRB, 0.50226013E-11_JPRB, 0.50260126E-11_JPRB, 0.50113312E-11_JPRB, &
  & 0.50038242E-11_JPRB, 0.49735186E-11_JPRB, 0.49640721E-11_JPRB, 0.49571263E-11_JPRB, 0.49151152E-11_JPRB, 0.48917936E-11_JPRB, &
  & 0.48762071E-11_JPRB, 0.49416053E-11_JPRB, 0.54239464E-11_JPRB, 0.55203273E-11_JPRB, 0.55859718E-11_JPRB, 0.56562324E-11_JPRB, &
  & 0.57463661E-11_JPRB, 0.58609597E-11_JPRB, 0.59847951E-11_JPRB, 0.60385312E-11_JPRB /)

RGHG4(:,62, 6) = (/ &
  & 0.14708160E-11_JPRB, 0.16371211E-11_JPRB, 0.18104807E-11_JPRB, 0.20347190E-11_JPRB, 0.23148629E-11_JPRB, 0.26644689E-11_JPRB, &
  & 0.30313876E-11_JPRB, 0.33410119E-11_JPRB, 0.22966830E-11_JPRB, 0.23284649E-11_JPRB, 0.24120181E-11_JPRB, 0.25211181E-11_JPRB, &
  & 0.27300549E-11_JPRB, 0.30091324E-11_JPRB, 0.33874208E-11_JPRB, 0.38023547E-11_JPRB, 0.41895129E-11_JPRB, 0.45483109E-11_JPRB, &
  & 0.48313194E-11_JPRB, 0.51243411E-11_JPRB, 0.54089329E-11_JPRB, 0.56690104E-11_JPRB, 0.58347454E-11_JPRB, 0.58301172E-11_JPRB, &
  & 0.56751786E-11_JPRB, 0.54154966E-11_JPRB, 0.51231085E-11_JPRB, 0.48437634E-11_JPRB, 0.46032093E-11_JPRB, 0.44100860E-11_JPRB, &
  & 0.42657423E-11_JPRB, 0.41659714E-11_JPRB, 0.41037976E-11_JPRB, 0.40797994E-11_JPRB, 0.40778778E-11_JPRB, 0.41098882E-11_JPRB, &
  & 0.41975876E-11_JPRB, 0.43435320E-11_JPRB, 0.45414983E-11_JPRB, 0.47730886E-11_JPRB, 0.49993729E-11_JPRB, 0.51859615E-11_JPRB, &
  & 0.53024043E-11_JPRB, 0.53815199E-11_JPRB, 0.54137445E-11_JPRB, 0.54492543E-11_JPRB, 0.54679859E-11_JPRB, 0.54748983E-11_JPRB, &
  & 0.54902020E-11_JPRB, 0.54810787E-11_JPRB, 0.54924958E-11_JPRB, 0.54994880E-11_JPRB, 0.54778950E-11_JPRB, 0.54602837E-11_JPRB, &
  & 0.54547820E-11_JPRB, 0.55536960E-11_JPRB, 0.60743550E-11_JPRB, 0.62148359E-11_JPRB, 0.62980419E-11_JPRB, 0.63778514E-11_JPRB, &
  & 0.64812418E-11_JPRB, 0.66117979E-11_JPRB, 0.67343540E-11_JPRB, 0.67116560E-11_JPRB /)

RGHG4(:,63, 6) = (/ &
  & 0.14715706E-11_JPRB, 0.16339005E-11_JPRB, 0.18121900E-11_JPRB, 0.20401810E-11_JPRB, 0.23365667E-11_JPRB, 0.27128146E-11_JPRB, &
  & 0.31218454E-11_JPRB, 0.35114977E-11_JPRB, 0.25500301E-11_JPRB, 0.26525652E-11_JPRB, 0.27883351E-11_JPRB, 0.29840160E-11_JPRB, &
  & 0.32699785E-11_JPRB, 0.36388184E-11_JPRB, 0.40852751E-11_JPRB, 0.45321234E-11_JPRB, 0.49214994E-11_JPRB, 0.52465718E-11_JPRB, &
  & 0.54988631E-11_JPRB, 0.57473960E-11_JPRB, 0.59661893E-11_JPRB, 0.61696208E-11_JPRB, 0.62804865E-11_JPRB, 0.62452881E-11_JPRB, &
  & 0.60777286E-11_JPRB, 0.58162832E-11_JPRB, 0.55280234E-11_JPRB, 0.52625617E-11_JPRB, 0.50359170E-11_JPRB, 0.48704487E-11_JPRB, &
  & 0.47569162E-11_JPRB, 0.46859591E-11_JPRB, 0.46431353E-11_JPRB, 0.46247181E-11_JPRB, 0.46220931E-11_JPRB, 0.46406707E-11_JPRB, &
  & 0.47152924E-11_JPRB, 0.48399874E-11_JPRB, 0.50174552E-11_JPRB, 0.52356054E-11_JPRB, 0.54547014E-11_JPRB, 0.56450383E-11_JPRB, &
  & 0.57728913E-11_JPRB, 0.58626658E-11_JPRB, 0.59137617E-11_JPRB, 0.59639008E-11_JPRB, 0.60000698E-11_JPRB, 0.60392750E-11_JPRB, &
  & 0.60779888E-11_JPRB, 0.60956982E-11_JPRB, 0.61176190E-11_JPRB, 0.61431429E-11_JPRB, 0.61396743E-11_JPRB, 0.61420665E-11_JPRB, &
  & 0.61409636E-11_JPRB, 0.62695799E-11_JPRB, 0.68430400E-11_JPRB, 0.70356576E-11_JPRB, 0.71556836E-11_JPRB, 0.72625959E-11_JPRB, &
  & 0.73900599E-11_JPRB, 0.75449855E-11_JPRB, 0.76674014E-11_JPRB, 0.75522800E-11_JPRB /)

RGHG4(:,64, 6) = (/ &
  & 0.14500625E-11_JPRB, 0.16094099E-11_JPRB, 0.17832510E-11_JPRB, 0.20179182E-11_JPRB, 0.23211862E-11_JPRB, 0.27298240E-11_JPRB, &
  & 0.32079738E-11_JPRB, 0.36913987E-11_JPRB, 0.28612143E-11_JPRB, 0.30483897E-11_JPRB, 0.33071165E-11_JPRB, 0.35970734E-11_JPRB, &
  & 0.40130733E-11_JPRB, 0.44669667E-11_JPRB, 0.49584295E-11_JPRB, 0.53994838E-11_JPRB, 0.57504682E-11_JPRB, 0.60252146E-11_JPRB, &
  & 0.62333962E-11_JPRB, 0.64175006E-11_JPRB, 0.65759134E-11_JPRB, 0.67154832E-11_JPRB, 0.67696855E-11_JPRB, 0.67006505E-11_JPRB, &
  & 0.65205341E-11_JPRB, 0.62613400E-11_JPRB, 0.59851585E-11_JPRB, 0.57423025E-11_JPRB, 0.55525506E-11_JPRB, 0.54232912E-11_JPRB, &
  & 0.53521068E-11_JPRB, 0.53208085E-11_JPRB, 0.53050624E-11_JPRB, 0.52943054E-11_JPRB, 0.52884754E-11_JPRB, 0.52995355E-11_JPRB, &
  & 0.53505464E-11_JPRB, 0.54564773E-11_JPRB, 0.56157674E-11_JPRB, 0.58154011E-11_JPRB, 0.60258005E-11_JPRB, 0.62177620E-11_JPRB, &
  & 0.63536901E-11_JPRB, 0.64588053E-11_JPRB, 0.65238370E-11_JPRB, 0.65868027E-11_JPRB, 0.66397842E-11_JPRB, 0.67031146E-11_JPRB, &
  & 0.67583647E-11_JPRB, 0.68066568E-11_JPRB, 0.68452947E-11_JPRB, 0.69056648E-11_JPRB, 0.69185690E-11_JPRB, 0.69502490E-11_JPRB, &
  & 0.69527569E-11_JPRB, 0.71195263E-11_JPRB, 0.77449557E-11_JPRB, 0.79997458E-11_JPRB, 0.81623389E-11_JPRB, 0.83019485E-11_JPRB, &
  & 0.84592359E-11_JPRB, 0.86435564E-11_JPRB, 0.87688372E-11_JPRB, 0.85231986E-11_JPRB /)

RGHG4(:,65, 6) = (/ &
  & 0.14075156E-11_JPRB, 0.15584865E-11_JPRB, 0.17271903E-11_JPRB, 0.19562884E-11_JPRB, 0.22640650E-11_JPRB, 0.26924487E-11_JPRB, &
  & 0.32429855E-11_JPRB, 0.38662853E-11_JPRB, 0.32017913E-11_JPRB, 0.35523479E-11_JPRB, 0.39454785E-11_JPRB, 0.44185992E-11_JPRB, &
  & 0.49624822E-11_JPRB, 0.54816321E-11_JPRB, 0.59744783E-11_JPRB, 0.63591168E-11_JPRB, 0.66529590E-11_JPRB, 0.68713082E-11_JPRB, &
  & 0.70176733E-11_JPRB, 0.71417642E-11_JPRB, 0.72359766E-11_JPRB, 0.73082217E-11_JPRB, 0.73073171E-11_JPRB, 0.72071038E-11_JPRB, &
  & 0.70197958E-11_JPRB, 0.67745518E-11_JPRB, 0.65225564E-11_JPRB, 0.63144117E-11_JPRB, 0.61716361E-11_JPRB, 0.61011257E-11_JPRB, &
  & 0.60853792E-11_JPRB, 0.60996928E-11_JPRB, 0.61140771E-11_JPRB, 0.61144874E-11_JPRB, 0.61042100E-11_JPRB, 0.61089853E-11_JPRB, &
  & 0.61503090E-11_JPRB, 0.62324395E-11_JPRB, 0.63660527E-11_JPRB, 0.65459474E-11_JPRB, 0.67440307E-11_JPRB, 0.69367238E-11_JPRB, &
  & 0.70801338E-11_JPRB, 0.71955801E-11_JPRB, 0.72733286E-11_JPRB, 0.73484248E-11_JPRB, 0.74228358E-11_JPRB, 0.75122998E-11_JPRB, &
  & 0.75950418E-11_JPRB, 0.76708830E-11_JPRB, 0.77258469E-11_JPRB, 0.78093634E-11_JPRB, 0.78397089E-11_JPRB, 0.78952643E-11_JPRB, &
  & 0.79138987E-11_JPRB, 0.81061911E-11_JPRB, 0.87880892E-11_JPRB, 0.91046736E-11_JPRB, 0.93209355E-11_JPRB, 0.95034987E-11_JPRB, &
  & 0.96986724E-11_JPRB, 0.99127954E-11_JPRB, 0.10036985E-10_JPRB, 0.96621374E-11_JPRB /)

RGHG4(:,66, 6) = (/ &
  & 0.13642426E-11_JPRB, 0.14976664E-11_JPRB, 0.16576431E-11_JPRB, 0.18788363E-11_JPRB, 0.21704984E-11_JPRB, 0.26109882E-11_JPRB, &
  & 0.32274363E-11_JPRB, 0.40237935E-11_JPRB, 0.36074542E-11_JPRB, 0.41698706E-11_JPRB, 0.48016981E-11_JPRB, 0.54265837E-11_JPRB, &
  & 0.60862019E-11_JPRB, 0.66160176E-11_JPRB, 0.70555133E-11_JPRB, 0.73835729E-11_JPRB, 0.76129363E-11_JPRB, 0.77717398E-11_JPRB, &
  & 0.78602983E-11_JPRB, 0.79230832E-11_JPRB, 0.79494900E-11_JPRB, 0.79606269E-11_JPRB, 0.79120920E-11_JPRB, 0.77874339E-11_JPRB, &
  & 0.76001878E-11_JPRB, 0.73783228E-11_JPRB, 0.71677516E-11_JPRB, 0.70087347E-11_JPRB, 0.69258171E-11_JPRB, 0.69144720E-11_JPRB, &
  & 0.69628487E-11_JPRB, 0.70334732E-11_JPRB, 0.70829215E-11_JPRB, 0.70970270E-11_JPRB, 0.70884800E-11_JPRB, 0.70848032E-11_JPRB, &
  & 0.71157112E-11_JPRB, 0.71798283E-11_JPRB, 0.72989514E-11_JPRB, 0.74593630E-11_JPRB, 0.76463931E-11_JPRB, 0.78382830E-11_JPRB, &
  & 0.79852487E-11_JPRB, 0.81104819E-11_JPRB, 0.81976986E-11_JPRB, 0.82855736E-11_JPRB, 0.83738034E-11_JPRB, 0.84788305E-11_JPRB, &
  & 0.85774313E-11_JPRB, 0.86776983E-11_JPRB, 0.87568989E-11_JPRB, 0.88738305E-11_JPRB, 0.89338597E-11_JPRB, 0.90114236E-11_JPRB, &
  & 0.90435099E-11_JPRB, 0.92646940E-11_JPRB, 0.99973640E-11_JPRB, 0.10374365E-10_JPRB, 0.10645965E-10_JPRB, 0.10874722E-10_JPRB, &
  & 0.11110095E-10_JPRB, 0.11353158E-10_JPRB, 0.11480141E-10_JPRB, 0.10996410E-10_JPRB /)

RGHG4(:,67, 6) = (/ &
  & 0.13235372E-11_JPRB, 0.14524574E-11_JPRB, 0.16082228E-11_JPRB, 0.18125284E-11_JPRB, 0.20822187E-11_JPRB, 0.24964115E-11_JPRB, &
  & 0.31914530E-11_JPRB, 0.41688142E-11_JPRB, 0.41053931E-11_JPRB, 0.49745147E-11_JPRB, 0.58268043E-11_JPRB, 0.66457426E-11_JPRB, &
  & 0.73349547E-11_JPRB, 0.78150203E-11_JPRB, 0.82047841E-11_JPRB, 0.84637453E-11_JPRB, 0.86372567E-11_JPRB, 0.87316473E-11_JPRB, &
  & 0.87642680E-11_JPRB, 0.87659333E-11_JPRB, 0.87363181E-11_JPRB, 0.86925181E-11_JPRB, 0.86060404E-11_JPRB, 0.84691629E-11_JPRB, &
  & 0.82922410E-11_JPRB, 0.81080411E-11_JPRB, 0.79491552E-11_JPRB, 0.78496957E-11_JPRB, 0.78382145E-11_JPRB, 0.79032145E-11_JPRB, &
  & 0.80201895E-11_JPRB, 0.81476362E-11_JPRB, 0.82324703E-11_JPRB, 0.82643371E-11_JPRB, 0.82611210E-11_JPRB, 0.82604618E-11_JPRB, &
  & 0.82920780E-11_JPRB, 0.83497809E-11_JPRB, 0.84429443E-11_JPRB, 0.85877468E-11_JPRB, 0.87663800E-11_JPRB, 0.89583575E-11_JPRB, &
  & 0.91084336E-11_JPRB, 0.92433786E-11_JPRB, 0.93374189E-11_JPRB, 0.94370423E-11_JPRB, 0.95408282E-11_JPRB, 0.96650014E-11_JPRB, &
  & 0.98007704E-11_JPRB, 0.99278571E-11_JPRB, 0.10031493E-10_JPRB, 0.10169223E-10_JPRB, 0.10247855E-10_JPRB, 0.10344777E-10_JPRB, &
  & 0.10388960E-10_JPRB, 0.10628648E-10_JPRB, 0.11412085E-10_JPRB, 0.11845913E-10_JPRB, 0.12172858E-10_JPRB, 0.12452004E-10_JPRB, &
  & 0.12732779E-10_JPRB, 0.13003307E-10_JPRB, 0.13123106E-10_JPRB, 0.12525730E-10_JPRB /)

RGHG4(:,68, 6) = (/ &
  & 0.13079207E-11_JPRB, 0.14623369E-11_JPRB, 0.16256403E-11_JPRB, 0.18216858E-11_JPRB, 0.20490836E-11_JPRB, 0.24277576E-11_JPRB, &
  & 0.31355485E-11_JPRB, 0.44265685E-11_JPRB, 0.47075547E-11_JPRB, 0.59815763E-11_JPRB, 0.70924733E-11_JPRB, 0.79468151E-11_JPRB, &
  & 0.86169700E-11_JPRB, 0.90588882E-11_JPRB, 0.93853371E-11_JPRB, 0.95988764E-11_JPRB, 0.97207528E-11_JPRB, 0.97612352E-11_JPRB, &
  & 0.97508069E-11_JPRB, 0.96987713E-11_JPRB, 0.96153563E-11_JPRB, 0.95280407E-11_JPRB, 0.94154519E-11_JPRB, 0.92799553E-11_JPRB, &
  & 0.91247079E-11_JPRB, 0.89925194E-11_JPRB, 0.88979041E-11_JPRB, 0.88766269E-11_JPRB, 0.89386502E-11_JPRB, 0.90691482E-11_JPRB, &
  & 0.92599270E-11_JPRB, 0.94496841E-11_JPRB, 0.95804857E-11_JPRB, 0.96361539E-11_JPRB, 0.96466212E-11_JPRB, 0.96512243E-11_JPRB, &
  & 0.96817615E-11_JPRB, 0.97273691E-11_JPRB, 0.98283673E-11_JPRB, 0.99652005E-11_JPRB, 0.10138801E-10_JPRB, 0.10332990E-10_JPRB, &
  & 0.10488394E-10_JPRB, 0.10632923E-10_JPRB, 0.10736939E-10_JPRB, 0.10846315E-10_JPRB, 0.10962344E-10_JPRB, 0.11105466E-10_JPRB, &
  & 0.11256988E-10_JPRB, 0.11405901E-10_JPRB, 0.11534456E-10_JPRB, 0.11707705E-10_JPRB, 0.11820681E-10_JPRB, 0.11940799E-10_JPRB, &
  & 0.11992313E-10_JPRB, 0.12245009E-10_JPRB, 0.13072953E-10_JPRB, 0.13559395E-10_JPRB, 0.13939422E-10_JPRB, 0.14269853E-10_JPRB, &
  & 0.14601738E-10_JPRB, 0.14904791E-10_JPRB, 0.15024211E-10_JPRB, 0.14316646E-10_JPRB /)

RGHG4(:,69, 6) = (/ &
  & 0.13643514E-11_JPRB, 0.15711804E-11_JPRB, 0.17694941E-11_JPRB, 0.19679813E-11_JPRB, 0.21591385E-11_JPRB, 0.24530879E-11_JPRB, &
  & 0.32274014E-11_JPRB, 0.46581597E-11_JPRB, 0.55684797E-11_JPRB, 0.72105507E-11_JPRB, 0.84172972E-11_JPRB, 0.93514016E-11_JPRB, &
  & 0.99449633E-11_JPRB, 0.10373761E-10_JPRB, 0.10635977E-10_JPRB, 0.10811275E-10_JPRB, 0.10888276E-10_JPRB, 0.10882481E-10_JPRB, &
  & 0.10831069E-10_JPRB, 0.10735733E-10_JPRB, 0.10618785E-10_JPRB, 0.10501979E-10_JPRB, 0.10377270E-10_JPRB, 0.10254951E-10_JPRB, &
  & 0.10136681E-10_JPRB, 0.10064206E-10_JPRB, 0.10044549E-10_JPRB, 0.10100658E-10_JPRB, 0.10246155E-10_JPRB, 0.10469683E-10_JPRB, &
  & 0.10738996E-10_JPRB, 0.10991069E-10_JPRB, 0.11166964E-10_JPRB, 0.11252031E-10_JPRB, 0.11282376E-10_JPRB, 0.11307066E-10_JPRB, &
  & 0.11356490E-10_JPRB, 0.11422028E-10_JPRB, 0.11499830E-10_JPRB, 0.11629703E-10_JPRB, 0.11805245E-10_JPRB, 0.12006722E-10_JPRB, &
  & 0.12173810E-10_JPRB, 0.12329048E-10_JPRB, 0.12447019E-10_JPRB, 0.12570564E-10_JPRB, 0.12707783E-10_JPRB, 0.12874495E-10_JPRB, &
  & 0.13073231E-10_JPRB, 0.13252163E-10_JPRB, 0.13417442E-10_JPRB, 0.13613267E-10_JPRB, 0.13745892E-10_JPRB, 0.13876038E-10_JPRB, &
  & 0.13933947E-10_JPRB, 0.14186572E-10_JPRB, 0.15051736E-10_JPRB, 0.15586260E-10_JPRB, 0.16016424E-10_JPRB, 0.16401786E-10_JPRB, &
  & 0.16791136E-10_JPRB, 0.17141477E-10_JPRB, 0.17262343E-10_JPRB, 0.16446048E-10_JPRB /)

RGHG4(:,70, 6) = (/ &
  & 0.15214017E-11_JPRB, 0.18260890E-11_JPRB, 0.20982248E-11_JPRB, 0.23261289E-11_JPRB, 0.24909538E-11_JPRB, 0.27072994E-11_JPRB, &
  & 0.34995236E-11_JPRB, 0.52769724E-11_JPRB, 0.64685661E-11_JPRB, 0.86518501E-11_JPRB, 0.97860929E-11_JPRB, 0.10771382E-10_JPRB, &
  & 0.11311499E-10_JPRB, 0.11724646E-10_JPRB, 0.11939682E-10_JPRB, 0.12088289E-10_JPRB, 0.12146643E-10_JPRB, 0.12114376E-10_JPRB, &
  & 0.12041658E-10_JPRB, 0.11925249E-10_JPRB, 0.11779870E-10_JPRB, 0.11648726E-10_JPRB, 0.11525155E-10_JPRB, 0.11428922E-10_JPRB, &
  & 0.11361485E-10_JPRB, 0.11355400E-10_JPRB, 0.11417691E-10_JPRB, 0.11567039E-10_JPRB, 0.11796551E-10_JPRB, 0.12088331E-10_JPRB, &
  & 0.12439431E-10_JPRB, 0.12766847E-10_JPRB, 0.13001169E-10_JPRB, 0.13124726E-10_JPRB, 0.13184861E-10_JPRB, 0.13232777E-10_JPRB, &
  & 0.13299525E-10_JPRB, 0.13363849E-10_JPRB, 0.13477882E-10_JPRB, 0.13627406E-10_JPRB, 0.13813208E-10_JPRB, 0.14032524E-10_JPRB, &
  & 0.14216283E-10_JPRB, 0.14390599E-10_JPRB, 0.14526619E-10_JPRB, 0.14671403E-10_JPRB, 0.14831998E-10_JPRB, 0.15030165E-10_JPRB, &
  & 0.15252240E-10_JPRB, 0.15453097E-10_JPRB, 0.15649090E-10_JPRB, 0.15885231E-10_JPRB, 0.16062937E-10_JPRB, 0.16220945E-10_JPRB, &
  & 0.16287130E-10_JPRB, 0.16534702E-10_JPRB, 0.17425708E-10_JPRB, 0.18001368E-10_JPRB, 0.18483154E-10_JPRB, 0.18922969E-10_JPRB, &
  & 0.19382858E-10_JPRB, 0.19787064E-10_JPRB, 0.19919177E-10_JPRB, 0.18962042E-10_JPRB /)

RGHG4(:,71, 6) = (/ &
  & 0.18240828E-11_JPRB, 0.22899566E-11_JPRB, 0.26733609E-11_JPRB, 0.29659146E-11_JPRB, 0.31310943E-11_JPRB, 0.33264511E-11_JPRB, &
  & 0.41565883E-11_JPRB, 0.61421437E-11_JPRB, 0.78177881E-11_JPRB, 0.10019739E-10_JPRB, 0.11268247E-10_JPRB, 0.12260952E-10_JPRB, &
  & 0.12769694E-10_JPRB, 0.13186695E-10_JPRB, 0.13361969E-10_JPRB, 0.13476338E-10_JPRB, 0.13529526E-10_JPRB, 0.13487548E-10_JPRB, &
  & 0.13402141E-10_JPRB, 0.13278928E-10_JPRB, 0.13131351E-10_JPRB, 0.13001949E-10_JPRB, 0.12894688E-10_JPRB, 0.12835859E-10_JPRB, &
  & 0.12832315E-10_JPRB, 0.12903905E-10_JPRB, 0.13057936E-10_JPRB, 0.13292860E-10_JPRB, 0.13620863E-10_JPRB, 0.14027291E-10_JPRB, &
  & 0.14468586E-10_JPRB, 0.14875209E-10_JPRB, 0.15164876E-10_JPRB, 0.15335044E-10_JPRB, 0.15434255E-10_JPRB, 0.15526559E-10_JPRB, &
  & 0.15638459E-10_JPRB, 0.15750791E-10_JPRB, 0.15864426E-10_JPRB, 0.16014159E-10_JPRB, 0.16220695E-10_JPRB, 0.16465402E-10_JPRB, &
  & 0.16680251E-10_JPRB, 0.16877435E-10_JPRB, 0.17043549E-10_JPRB, 0.17221330E-10_JPRB, 0.17414402E-10_JPRB, 0.17649457E-10_JPRB, &
  & 0.17930313E-10_JPRB, 0.18178063E-10_JPRB, 0.18424358E-10_JPRB, 0.18691097E-10_JPRB, 0.18899493E-10_JPRB, 0.19068276E-10_JPRB, &
  & 0.19147593E-10_JPRB, 0.19387545E-10_JPRB, 0.20287714E-10_JPRB, 0.20899322E-10_JPRB, 0.21424643E-10_JPRB, 0.21926452E-10_JPRB, &
  & 0.22458370E-10_JPRB, 0.22953023E-10_JPRB, 0.23147791E-10_JPRB, 0.22157047E-10_JPRB /)

RGHG4(:,72, 6) = (/ &
  & 0.23256507E-11_JPRB, 0.30404687E-11_JPRB, 0.35993675E-11_JPRB, 0.39646827E-11_JPRB, 0.41844739E-11_JPRB, 0.44058333E-11_JPRB, &
  & 0.54527450E-11_JPRB, 0.76993993E-11_JPRB, 0.90295939E-11_JPRB, 0.11639453E-10_JPRB, 0.12745285E-10_JPRB, 0.13851227E-10_JPRB, &
  & 0.14288001E-10_JPRB, 0.14704763E-10_JPRB, 0.14892277E-10_JPRB, 0.14991213E-10_JPRB, 0.15051752E-10_JPRB, 0.15030057E-10_JPRB, &
  & 0.14959952E-10_JPRB, 0.14848822E-10_JPRB, 0.14709012E-10_JPRB, 0.14596505E-10_JPRB, 0.14520217E-10_JPRB, 0.14514444E-10_JPRB, &
  & 0.14585699E-10_JPRB, 0.14747571E-10_JPRB, 0.15002798E-10_JPRB, 0.15356001E-10_JPRB, 0.15778524E-10_JPRB, 0.16249687E-10_JPRB, &
  & 0.16782393E-10_JPRB, 0.17271806E-10_JPRB, 0.17642252E-10_JPRB, 0.17874478E-10_JPRB, 0.18030685E-10_JPRB, 0.18168441E-10_JPRB, &
  & 0.18320118E-10_JPRB, 0.18456313E-10_JPRB, 0.18623486E-10_JPRB, 0.18841472E-10_JPRB, 0.19086156E-10_JPRB, 0.19373662E-10_JPRB, &
  & 0.19621853E-10_JPRB, 0.19859248E-10_JPRB, 0.20061364E-10_JPRB, 0.20280477E-10_JPRB, 0.20521003E-10_JPRB, 0.20795922E-10_JPRB, &
  & 0.21109857E-10_JPRB, 0.21388098E-10_JPRB, 0.21667741E-10_JPRB, 0.21983625E-10_JPRB, 0.22256029E-10_JPRB, 0.22480287E-10_JPRB, &
  & 0.22594104E-10_JPRB, 0.22841366E-10_JPRB, 0.23733720E-10_JPRB, 0.24362084E-10_JPRB, 0.24934619E-10_JPRB, 0.25483731E-10_JPRB, &
  & 0.26094071E-10_JPRB, 0.26676590E-10_JPRB, 0.26954697E-10_JPRB, 0.26007413E-10_JPRB /)

RGHG4(:,73, 6) = (/ &
  & 0.31361675E-11_JPRB, 0.42315539E-11_JPRB, 0.49963636E-11_JPRB, 0.54679321E-11_JPRB, 0.57740366E-11_JPRB, 0.61787216E-11_JPRB, &
  & 0.73493243E-11_JPRB, 0.97570840E-11_JPRB, 0.10943494E-10_JPRB, 0.13027594E-10_JPRB, 0.14490063E-10_JPRB, 0.15452556E-10_JPRB, &
  & 0.15994170E-10_JPRB, 0.16336967E-10_JPRB, 0.16550046E-10_JPRB, 0.16650690E-10_JPRB, 0.16730515E-10_JPRB, 0.16732693E-10_JPRB, &
  & 0.16690961E-10_JPRB, 0.16614547E-10_JPRB, 0.16512952E-10_JPRB, 0.16438996E-10_JPRB, 0.16413921E-10_JPRB, 0.16474514E-10_JPRB, &
  & 0.16636368E-10_JPRB, 0.16906197E-10_JPRB, 0.17271603E-10_JPRB, 0.17752948E-10_JPRB, 0.18279763E-10_JPRB, 0.18887345E-10_JPRB, &
  & 0.19539315E-10_JPRB, 0.20124289E-10_JPRB, 0.20578679E-10_JPRB, 0.20882242E-10_JPRB, 0.21109132E-10_JPRB, 0.21325459E-10_JPRB, &
  & 0.21555592E-10_JPRB, 0.21764127E-10_JPRB, 0.21968727E-10_JPRB, 0.22183495E-10_JPRB, 0.22459602E-10_JPRB, 0.22797471E-10_JPRB, &
  & 0.23098060E-10_JPRB, 0.23380695E-10_JPRB, 0.23636390E-10_JPRB, 0.23905116E-10_JPRB, 0.24206625E-10_JPRB, 0.24535190E-10_JPRB, &
  & 0.24913474E-10_JPRB, 0.25253090E-10_JPRB, 0.25590870E-10_JPRB, 0.25960291E-10_JPRB, 0.26286038E-10_JPRB, 0.26540676E-10_JPRB, &
  & 0.26690360E-10_JPRB, 0.26943326E-10_JPRB, 0.27812565E-10_JPRB, 0.28455596E-10_JPRB, 0.29037116E-10_JPRB, 0.29632168E-10_JPRB, &
  & 0.30297150E-10_JPRB, 0.30961084E-10_JPRB, 0.31293614E-10_JPRB, 0.30282742E-10_JPRB /)

RGHG4(:,74, 6) = (/ &
  & 0.45043674E-11_JPRB, 0.60278562E-11_JPRB, 0.69923741E-11_JPRB, 0.75724305E-11_JPRB, 0.80226711E-11_JPRB, 0.85988916E-11_JPRB, &
  & 0.10008450E-10_JPRB, 0.12586138E-10_JPRB, 0.12573771E-10_JPRB, 0.15025842E-10_JPRB, 0.16067687E-10_JPRB, 0.17216926E-10_JPRB, &
  & 0.17724926E-10_JPRB, 0.18073189E-10_JPRB, 0.18306565E-10_JPRB, 0.18452188E-10_JPRB, 0.18572092E-10_JPRB, 0.18635636E-10_JPRB, &
  & 0.18647967E-10_JPRB, 0.18626085E-10_JPRB, 0.18579282E-10_JPRB, 0.18567172E-10_JPRB, 0.18613113E-10_JPRB, 0.18760214E-10_JPRB, &
  & 0.19026529E-10_JPRB, 0.19421699E-10_JPRB, 0.19920163E-10_JPRB, 0.20557854E-10_JPRB, 0.21199466E-10_JPRB, 0.21881132E-10_JPRB, &
  & 0.22628200E-10_JPRB, 0.23296169E-10_JPRB, 0.23853017E-10_JPRB, 0.24256664E-10_JPRB, 0.24578187E-10_JPRB, 0.24874526E-10_JPRB, &
  & 0.25176644E-10_JPRB, 0.25440967E-10_JPRB, 0.25718826E-10_JPRB, 0.26054317E-10_JPRB, 0.26417745E-10_JPRB, 0.26818272E-10_JPRB, &
  & 0.27173132E-10_JPRB, 0.27523234E-10_JPRB, 0.27839496E-10_JPRB, 0.28177748E-10_JPRB, 0.28547498E-10_JPRB, 0.28938182E-10_JPRB, &
  & 0.29338813E-10_JPRB, 0.29714477E-10_JPRB, 0.30085295E-10_JPRB, 0.30525343E-10_JPRB, 0.30929970E-10_JPRB, 0.31279940E-10_JPRB, &
  & 0.31492139E-10_JPRB, 0.31759925E-10_JPRB, 0.32610050E-10_JPRB, 0.33229627E-10_JPRB, 0.33828731E-10_JPRB, 0.34434851E-10_JPRB, &
  & 0.35145626E-10_JPRB, 0.35866452E-10_JPRB, 0.36234411E-10_JPRB, 0.35125881E-10_JPRB /)

RGHG4(:,75, 6) = (/ &
  & 0.64440064E-11_JPRB, 0.84295938E-11_JPRB, 0.96629198E-11_JPRB, 0.10332137E-10_JPRB, 0.10903444E-10_JPRB, 0.11651527E-10_JPRB, &
  & 0.13123778E-10_JPRB, 0.15527529E-10_JPRB, 0.15080508E-10_JPRB, 0.16755285E-10_JPRB, 0.18178696E-10_JPRB, 0.18952102E-10_JPRB, &
  & 0.19618480E-10_JPRB, 0.19937109E-10_JPRB, 0.20213980E-10_JPRB, 0.20408437E-10_JPRB, 0.20583944E-10_JPRB, 0.20727139E-10_JPRB, &
  & 0.20818069E-10_JPRB, 0.20884272E-10_JPRB, 0.20924408E-10_JPRB, 0.21003642E-10_JPRB, 0.21151013E-10_JPRB, 0.21410025E-10_JPRB, &
  & 0.21799531E-10_JPRB, 0.22330681E-10_JPRB, 0.22989947E-10_JPRB, 0.23756289E-10_JPRB, 0.24553595E-10_JPRB, 0.25394001E-10_JPRB, &
  & 0.26291722E-10_JPRB, 0.27123640E-10_JPRB, 0.27802590E-10_JPRB, 0.28326326E-10_JPRB, 0.28767422E-10_JPRB, 0.29189609E-10_JPRB, &
  & 0.29602196E-10_JPRB, 0.29960787E-10_JPRB, 0.30301723E-10_JPRB, 0.30637808E-10_JPRB, 0.31019669E-10_JPRB, 0.31498332E-10_JPRB, &
  & 0.31920376E-10_JPRB, 0.32349300E-10_JPRB, 0.32748311E-10_JPRB, 0.33170872E-10_JPRB, 0.33632121E-10_JPRB, 0.34103192E-10_JPRB, &
  & 0.34598633E-10_JPRB, 0.35046167E-10_JPRB, 0.35499395E-10_JPRB, 0.35992154E-10_JPRB, 0.36470861E-10_JPRB, 0.36862374E-10_JPRB, &
  & 0.37101697E-10_JPRB, 0.37366867E-10_JPRB, 0.38172195E-10_JPRB, 0.38785617E-10_JPRB, 0.39360820E-10_JPRB, 0.39981549E-10_JPRB, &
  & 0.40722033E-10_JPRB, 0.41482193E-10_JPRB, 0.41844580E-10_JPRB, 0.40534024E-10_JPRB /)

RGHG4(:,76, 6) = (/ &
  & 0.89410857E-11_JPRB, 0.11548730E-10_JPRB, 0.12934201E-10_JPRB, 0.13719102E-10_JPRB, 0.14357439E-10_JPRB, 0.15146256E-10_JPRB, &
  & 0.16618073E-10_JPRB, 0.18967815E-10_JPRB, 0.17243190E-10_JPRB, 0.19103998E-10_JPRB, 0.19975209E-10_JPRB, 0.20859307E-10_JPRB, &
  & 0.21420555E-10_JPRB, 0.21813454E-10_JPRB, 0.22161021E-10_JPRB, 0.22455185E-10_JPRB, 0.22735619E-10_JPRB, 0.22994153E-10_JPRB, &
  & 0.23201961E-10_JPRB, 0.23380296E-10_JPRB, 0.23536489E-10_JPRB, 0.23740563E-10_JPRB, 0.24019077E-10_JPRB, 0.24419293E-10_JPRB, &
  & 0.24952818E-10_JPRB, 0.25642551E-10_JPRB, 0.26484145E-10_JPRB, 0.27402042E-10_JPRB, 0.28370695E-10_JPRB, 0.29309392E-10_JPRB, &
  & 0.30259534E-10_JPRB, 0.31157913E-10_JPRB, 0.31959740E-10_JPRB, 0.32630901E-10_JPRB, 0.33215958E-10_JPRB, 0.33770434E-10_JPRB, &
  & 0.34305312E-10_JPRB, 0.34785820E-10_JPRB, 0.35259805E-10_JPRB, 0.35765835E-10_JPRB, 0.36323999E-10_JPRB, 0.36885883E-10_JPRB, &
  & 0.37386434E-10_JPRB, 0.37917731E-10_JPRB, 0.38409744E-10_JPRB, 0.38947501E-10_JPRB, 0.39514447E-10_JPRB, 0.40072293E-10_JPRB, &
  & 0.40606272E-10_JPRB, 0.41095086E-10_JPRB, 0.41601764E-10_JPRB, 0.42162621E-10_JPRB, 0.42711893E-10_JPRB, 0.43195801E-10_JPRB, &
  & 0.43508700E-10_JPRB, 0.43781999E-10_JPRB, 0.44560813E-10_JPRB, 0.45124161E-10_JPRB, 0.45681715E-10_JPRB, 0.46299960E-10_JPRB, &
  & 0.47051203E-10_JPRB, 0.47822881E-10_JPRB, 0.48139371E-10_JPRB, 0.46552755E-10_JPRB /)

RGHG4(:,77, 6) = (/ &
  & 0.12104251E-10_JPRB, 0.15229720E-10_JPRB, 0.16808730E-10_JPRB, 0.17602966E-10_JPRB, 0.18260593E-10_JPRB, 0.19013338E-10_JPRB, &
  & 0.20337817E-10_JPRB, 0.22336254E-10_JPRB, 0.19876422E-10_JPRB, 0.21061177E-10_JPRB, 0.22099511E-10_JPRB, 0.22646720E-10_JPRB, &
  & 0.23279264E-10_JPRB, 0.23698437E-10_JPRB, 0.24134097E-10_JPRB, 0.24531925E-10_JPRB, 0.24930929E-10_JPRB, 0.25330829E-10_JPRB, &
  & 0.25689785E-10_JPRB, 0.26033495E-10_JPRB, 0.26352464E-10_JPRB, 0.26720652E-10_JPRB, 0.27172415E-10_JPRB, 0.27740504E-10_JPRB, &
  & 0.28444982E-10_JPRB, 0.29316195E-10_JPRB, 0.30331113E-10_JPRB, 0.31412078E-10_JPRB, 0.32547361E-10_JPRB, 0.33669505E-10_JPRB, &
  & 0.34860330E-10_JPRB, 0.35999304E-10_JPRB, 0.36984950E-10_JPRB, 0.37857984E-10_JPRB, 0.38644969E-10_JPRB, 0.39375472E-10_JPRB, &
  & 0.40043885E-10_JPRB, 0.40614852E-10_JPRB, 0.41146905E-10_JPRB, 0.41679344E-10_JPRB, 0.42243042E-10_JPRB, 0.42903417E-10_JPRB, &
  & 0.43508301E-10_JPRB, 0.44155395E-10_JPRB, 0.44764834E-10_JPRB, 0.45431110E-10_JPRB, 0.46137580E-10_JPRB, 0.46807672E-10_JPRB, &
  & 0.47469802E-10_JPRB, 0.48042098E-10_JPRB, 0.48622398E-10_JPRB, 0.49242058E-10_JPRB, 0.49825470E-10_JPRB, 0.50330021E-10_JPRB, &
  & 0.50641817E-10_JPRB, 0.50914849E-10_JPRB, 0.51641805E-10_JPRB, 0.52186599E-10_JPRB, 0.52713826E-10_JPRB, 0.53291999E-10_JPRB, &
  & 0.54040137E-10_JPRB, 0.54799186E-10_JPRB, 0.55010749E-10_JPRB, 0.53128654E-10_JPRB /)

RGHG4(:,78, 6) = (/ &
  & 0.15866338E-10_JPRB, 0.19355913E-10_JPRB, 0.20889464E-10_JPRB, 0.21675176E-10_JPRB, 0.22263040E-10_JPRB, 0.22930257E-10_JPRB, &
  & 0.24006182E-10_JPRB, 0.25605811E-10_JPRB, 0.21997583E-10_JPRB, 0.23035436E-10_JPRB, 0.23601347E-10_JPRB, 0.24250397E-10_JPRB, &
  & 0.24810232E-10_JPRB, 0.25319656E-10_JPRB, 0.25880891E-10_JPRB, 0.26412299E-10_JPRB, 0.26966132E-10_JPRB, 0.27527234E-10_JPRB, &
  & 0.28067985E-10_JPRB, 0.28601911E-10_JPRB, 0.29121278E-10_JPRB, 0.29694906E-10_JPRB, 0.30358993E-10_JPRB, 0.31120634E-10_JPRB, &
  & 0.32011362E-10_JPRB, 0.33070571E-10_JPRB, 0.34225664E-10_JPRB, 0.35471313E-10_JPRB, 0.36727371E-10_JPRB, 0.37940429E-10_JPRB, &
  & 0.39056505E-10_JPRB, 0.40197415E-10_JPRB, 0.41272225E-10_JPRB, 0.42270801E-10_JPRB, 0.43232602E-10_JPRB, 0.44167704E-10_JPRB, &
  & 0.45068383E-10_JPRB, 0.45884792E-10_JPRB, 0.46662459E-10_JPRB, 0.47425782E-10_JPRB, 0.48227949E-10_JPRB, 0.49010337E-10_JPRB, &
  & 0.49723125E-10_JPRB, 0.50487975E-10_JPRB, 0.51214814E-10_JPRB, 0.52024596E-10_JPRB, 0.52872349E-10_JPRB, 0.53601207E-10_JPRB, &
  & 0.54298389E-10_JPRB, 0.54906881E-10_JPRB, 0.55521861E-10_JPRB, 0.56158193E-10_JPRB, 0.56768253E-10_JPRB, 0.57316225E-10_JPRB, &
  & 0.57715801E-10_JPRB, 0.58047386E-10_JPRB, 0.58774999E-10_JPRB, 0.59285424E-10_JPRB, 0.59763743E-10_JPRB, 0.60332295E-10_JPRB, &
  & 0.61033019E-10_JPRB, 0.61772983E-10_JPRB, 0.62009897E-10_JPRB, 0.60157511E-10_JPRB /)

RGHG4(:,79, 6) = (/ &
  & 0.20186124E-10_JPRB, 0.23185114E-10_JPRB, 0.24120560E-10_JPRB, 0.24631613E-10_JPRB, 0.25021698E-10_JPRB, 0.25486578E-10_JPRB, &
  & 0.26237738E-10_JPRB, 0.27431149E-10_JPRB, 0.23216259E-10_JPRB, 0.24009484E-10_JPRB, 0.24640009E-10_JPRB, 0.25111814E-10_JPRB, &
  & 0.25739308E-10_JPRB, 0.26276160E-10_JPRB, 0.26898124E-10_JPRB, 0.27523315E-10_JPRB, 0.28194044E-10_JPRB, 0.28921324E-10_JPRB, &
  & 0.29626100E-10_JPRB, 0.30363555E-10_JPRB, 0.31088403E-10_JPRB, 0.31865764E-10_JPRB, 0.32722686E-10_JPRB, 0.33613990E-10_JPRB, &
  & 0.34610963E-10_JPRB, 0.35706160E-10_JPRB, 0.36803064E-10_JPRB, 0.37955524E-10_JPRB, 0.39056397E-10_JPRB, 0.40240238E-10_JPRB, &
  & 0.41435810E-10_JPRB, 0.42600465E-10_JPRB, 0.43713880E-10_JPRB, 0.44786237E-10_JPRB, 0.45849092E-10_JPRB, 0.46908352E-10_JPRB, &
  & 0.47947497E-10_JPRB, 0.48916645E-10_JPRB, 0.49849878E-10_JPRB, 0.50754373E-10_JPRB, 0.51651652E-10_JPRB, 0.52564290E-10_JPRB, &
  & 0.53380095E-10_JPRB, 0.54229701E-10_JPRB, 0.55009889E-10_JPRB, 0.55869920E-10_JPRB, 0.56749976E-10_JPRB, 0.57500775E-10_JPRB, &
  & 0.58217917E-10_JPRB, 0.58832314E-10_JPRB, 0.59450847E-10_JPRB, 0.60079476E-10_JPRB, 0.60672432E-10_JPRB, 0.61210384E-10_JPRB, &
  & 0.61628695E-10_JPRB, 0.62050129E-10_JPRB, 0.62871423E-10_JPRB, 0.63492753E-10_JPRB, 0.64094403E-10_JPRB, 0.64693161E-10_JPRB, &
  & 0.65461317E-10_JPRB, 0.66334084E-10_JPRB, 0.66862807E-10_JPRB, 0.66058409E-10_JPRB /)

RGHG4(:,80, 6) = (/ &
  & 0.23015104E-10_JPRB, 0.24776268E-10_JPRB, 0.25173676E-10_JPRB, 0.25516362E-10_JPRB, 0.25802048E-10_JPRB, 0.26252708E-10_JPRB, &
  & 0.26987515E-10_JPRB, 0.27993413E-10_JPRB, 0.23967545E-10_JPRB, 0.24556156E-10_JPRB, 0.25127265E-10_JPRB, 0.25660687E-10_JPRB, &
  & 0.26269726E-10_JPRB, 0.26843304E-10_JPRB, 0.27504251E-10_JPRB, 0.28163354E-10_JPRB, 0.28858204E-10_JPRB, 0.29618908E-10_JPRB, &
  & 0.30349313E-10_JPRB, 0.31138370E-10_JPRB, 0.31921146E-10_JPRB, 0.32773773E-10_JPRB, 0.33683816E-10_JPRB, 0.34596166E-10_JPRB, &
  & 0.35668416E-10_JPRB, 0.36763186E-10_JPRB, 0.37908642E-10_JPRB, 0.39140347E-10_JPRB, 0.40367848E-10_JPRB, 0.41529325E-10_JPRB, &
  & 0.42674114E-10_JPRB, 0.43828691E-10_JPRB, 0.44971832E-10_JPRB, 0.46086062E-10_JPRB, 0.47202128E-10_JPRB, 0.48318290E-10_JPRB, &
  & 0.49424759E-10_JPRB, 0.50474177E-10_JPRB, 0.51491252E-10_JPRB, 0.52470361E-10_JPRB, 0.53440589E-10_JPRB, 0.54357591E-10_JPRB, &
  & 0.55193509E-10_JPRB, 0.56062363E-10_JPRB, 0.56884032E-10_JPRB, 0.57792302E-10_JPRB, 0.58725677E-10_JPRB, 0.59487408E-10_JPRB, &
  & 0.60205951E-10_JPRB, 0.60819662E-10_JPRB, 0.61442545E-10_JPRB, 0.62071556E-10_JPRB, 0.62682561E-10_JPRB, 0.63262402E-10_JPRB, &
  & 0.63732297E-10_JPRB, 0.64156513E-10_JPRB, 0.64883862E-10_JPRB, 0.65373568E-10_JPRB, 0.65852240E-10_JPRB, 0.66434427E-10_JPRB, &
  & 0.67142979E-10_JPRB, 0.68110219E-10_JPRB, 0.68813705E-10_JPRB, 0.69152871E-10_JPRB /)

RGHG4(:,81, 6) = (/ &
  & 0.24896448E-10_JPRB, 0.25520537E-10_JPRB, 0.25795293E-10_JPRB, 0.26120623E-10_JPRB, 0.26390466E-10_JPRB, 0.26872964E-10_JPRB, &
  & 0.27479042E-10_JPRB, 0.28618042E-10_JPRB, 0.24139277E-10_JPRB, 0.25010487E-10_JPRB, 0.25451948E-10_JPRB, 0.26001111E-10_JPRB, &
  & 0.26605877E-10_JPRB, 0.27192051E-10_JPRB, 0.27874690E-10_JPRB, 0.28562800E-10_JPRB, 0.29311435E-10_JPRB, 0.30117880E-10_JPRB, &
  & 0.30905993E-10_JPRB, 0.31730028E-10_JPRB, 0.32554265E-10_JPRB, 0.33457351E-10_JPRB, 0.34374701E-10_JPRB, 0.35320861E-10_JPRB, &
  & 0.36479444E-10_JPRB, 0.37494029E-10_JPRB, 0.38692646E-10_JPRB, 0.39788572E-10_JPRB, 0.40972080E-10_JPRB, 0.42147265E-10_JPRB, &
  & 0.43348276E-10_JPRB, 0.44507939E-10_JPRB, 0.45661922E-10_JPRB, 0.46807967E-10_JPRB, 0.47949349E-10_JPRB, 0.49094159E-10_JPRB, &
  & 0.50230708E-10_JPRB, 0.51313460E-10_JPRB, 0.52370618E-10_JPRB, 0.53379814E-10_JPRB, 0.54384112E-10_JPRB, 0.55375909E-10_JPRB, &
  & 0.56250581E-10_JPRB, 0.57150642E-10_JPRB, 0.57971284E-10_JPRB, 0.58887333E-10_JPRB, 0.59796681E-10_JPRB, 0.60553618E-10_JPRB, &
  & 0.61278378E-10_JPRB, 0.61898306E-10_JPRB, 0.62525700E-10_JPRB, 0.63153517E-10_JPRB, 0.63759657E-10_JPRB, 0.64327377E-10_JPRB, &
  & 0.64779647E-10_JPRB, 0.65237656E-10_JPRB, 0.66015984E-10_JPRB, 0.66565933E-10_JPRB, 0.67104100E-10_JPRB, 0.67688417E-10_JPRB, &
  & 0.68385603E-10_JPRB, 0.69427478E-10_JPRB, 0.70219469E-10_JPRB, 0.71793724E-10_JPRB /)

RGHG4(:,82, 6) = (/ &
  & 0.26211776E-10_JPRB, 0.25829380E-10_JPRB, 0.26011639E-10_JPRB, 0.26240211E-10_JPRB, 0.26488482E-10_JPRB, 0.26967394E-10_JPRB, &
  & 0.27616628E-10_JPRB, 0.28455587E-10_JPRB, 0.24694264E-10_JPRB, 0.25090929E-10_JPRB, 0.25763499E-10_JPRB, 0.26201444E-10_JPRB, &
  & 0.26858703E-10_JPRB, 0.27465230E-10_JPRB, 0.28150232E-10_JPRB, 0.28852998E-10_JPRB, 0.29577778E-10_JPRB, 0.30395964E-10_JPRB, &
  & 0.31171239E-10_JPRB, 0.32013253E-10_JPRB, 0.32850330E-10_JPRB, 0.33787351E-10_JPRB, 0.34668633E-10_JPRB, 0.35702115E-10_JPRB, &
  & 0.36801943E-10_JPRB, 0.37834048E-10_JPRB, 0.39065595E-10_JPRB, 0.40215858E-10_JPRB, 0.41454978E-10_JPRB, 0.42604847E-10_JPRB, &
  & 0.43785611E-10_JPRB, 0.44953034E-10_JPRB, 0.46116763E-10_JPRB, 0.47283344E-10_JPRB, 0.48444738E-10_JPRB, 0.49607304E-10_JPRB, &
  & 0.50758283E-10_JPRB, 0.51875153E-10_JPRB, 0.52956535E-10_JPRB, 0.53985268E-10_JPRB, 0.54981446E-10_JPRB, 0.55915401E-10_JPRB, &
  & 0.56781115E-10_JPRB, 0.57680822E-10_JPRB, 0.58528023E-10_JPRB, 0.59475307E-10_JPRB, 0.60446897E-10_JPRB, 0.61228932E-10_JPRB, &
  & 0.61963976E-10_JPRB, 0.62594083E-10_JPRB, 0.63224086E-10_JPRB, 0.63860472E-10_JPRB, 0.64474925E-10_JPRB, 0.65081177E-10_JPRB, &
  & 0.65572499E-10_JPRB, 0.66029286E-10_JPRB, 0.66701297E-10_JPRB, 0.67125853E-10_JPRB, 0.67540806E-10_JPRB, 0.68158458E-10_JPRB, &
  & 0.68742463E-10_JPRB, 0.69868535E-10_JPRB, 0.70574532E-10_JPRB, 0.72816489E-10_JPRB /)

RGHG4(:,83, 6) = (/ &
  & 0.26299973E-10_JPRB, 0.25948448E-10_JPRB, 0.26124748E-10_JPRB, 0.26359635E-10_JPRB, 0.26685659E-10_JPRB, 0.27194785E-10_JPRB, &
  & 0.27751324E-10_JPRB, 0.28988674E-10_JPRB, 0.24550100E-10_JPRB, 0.25504522E-10_JPRB, 0.25864236E-10_JPRB, 0.26459957E-10_JPRB, &
  & 0.27049170E-10_JPRB, 0.27644087E-10_JPRB, 0.28362368E-10_JPRB, 0.29073429E-10_JPRB, 0.29844686E-10_JPRB, 0.30660818E-10_JPRB, &
  & 0.31468415E-10_JPRB, 0.32299965E-10_JPRB, 0.33155763E-10_JPRB, 0.34077456E-10_JPRB, 0.34949835E-10_JPRB, 0.36080368E-10_JPRB, &
  & 0.37063370E-10_JPRB, 0.38223272E-10_JPRB, 0.39359408E-10_JPRB, 0.40533642E-10_JPRB, 0.41707523E-10_JPRB, 0.42920941E-10_JPRB, &
  & 0.44102264E-10_JPRB, 0.45280540E-10_JPRB, 0.46451419E-10_JPRB, 0.47634868E-10_JPRB, 0.48813915E-10_JPRB, 0.49989870E-10_JPRB, &
  & 0.51168451E-10_JPRB, 0.52283976E-10_JPRB, 0.53372948E-10_JPRB, 0.54408259E-10_JPRB, 0.55433495E-10_JPRB, 0.56439034E-10_JPRB, &
  & 0.57347380E-10_JPRB, 0.58230983E-10_JPRB, 0.59082191E-10_JPRB, 0.60015187E-10_JPRB, 0.60950023E-10_JPRB, 0.61712135E-10_JPRB, &
  & 0.62453556E-10_JPRB, 0.63097041E-10_JPRB, 0.63724734E-10_JPRB, 0.64376011E-10_JPRB, 0.64975268E-10_JPRB, 0.65586522E-10_JPRB, &
  & 0.66038126E-10_JPRB, 0.66525126E-10_JPRB, 0.67220500E-10_JPRB, 0.67734873E-10_JPRB, 0.68116138E-10_JPRB, 0.68808861E-10_JPRB, &
  & 0.69300427E-10_JPRB, 0.70471053E-10_JPRB, 0.71062697E-10_JPRB, 0.72836140E-10_JPRB /)

RGHG4(:,84, 6) = (/ &
  & 0.26318626E-10_JPRB, 0.26084955E-10_JPRB, 0.26143752E-10_JPRB, 0.26410794E-10_JPRB, 0.26752210E-10_JPRB, 0.27193555E-10_JPRB, &
  & 0.27853986E-10_JPRB, 0.28726138E-10_JPRB, 0.25148595E-10_JPRB, 0.25449918E-10_JPRB, 0.26158669E-10_JPRB, 0.26530994E-10_JPRB, &
  & 0.27201999E-10_JPRB, 0.27819231E-10_JPRB, 0.28514363E-10_JPRB, 0.29235548E-10_JPRB, 0.29986527E-10_JPRB, 0.30804023E-10_JPRB, &
  & 0.31615082E-10_JPRB, 0.32455639E-10_JPRB, 0.33324895E-10_JPRB, 0.34216470E-10_JPRB, 0.35163067E-10_JPRB, 0.36247158E-10_JPRB, &
  & 0.37218482E-10_JPRB, 0.38445701E-10_JPRB, 0.39547476E-10_JPRB, 0.40772326E-10_JPRB, 0.41969744E-10_JPRB, 0.43165308E-10_JPRB, &
  & 0.44360335E-10_JPRB, 0.45540217E-10_JPRB, 0.46722792E-10_JPRB, 0.47918836E-10_JPRB, 0.49110976E-10_JPRB, 0.50315412E-10_JPRB, &
  & 0.51501976E-10_JPRB, 0.52654478E-10_JPRB, 0.53768878E-10_JPRB, 0.54773082E-10_JPRB, 0.55757569E-10_JPRB, 0.56675449E-10_JPRB, &
  & 0.57527115E-10_JPRB, 0.58463803E-10_JPRB, 0.59292675E-10_JPRB, 0.60278400E-10_JPRB, 0.61267692E-10_JPRB, 0.62075844E-10_JPRB, &
  & 0.62833252E-10_JPRB, 0.63478729E-10_JPRB, 0.64116497E-10_JPRB, 0.64776996E-10_JPRB, 0.65374095E-10_JPRB, 0.66032707E-10_JPRB, &
  & 0.66486955E-10_JPRB, 0.67029902E-10_JPRB, 0.67577159E-10_JPRB, 0.68066490E-10_JPRB, 0.68264512E-10_JPRB, 0.69074815E-10_JPRB, &
  & 0.69443534E-10_JPRB, 0.70696456E-10_JPRB, 0.71271905E-10_JPRB, 0.73310448E-10_JPRB /)

RGHG4(:,85, 6) = (/ &
  & 0.26456302E-10_JPRB, 0.26209132E-10_JPRB, 0.26112921E-10_JPRB, 0.26507192E-10_JPRB, 0.26823259E-10_JPRB, 0.27285930E-10_JPRB, &
  & 0.27976938E-10_JPRB, 0.29197169E-10_JPRB, 0.24862236E-10_JPRB, 0.25874337E-10_JPRB, 0.26159677E-10_JPRB, 0.26826449E-10_JPRB, &
  & 0.27328339E-10_JPRB, 0.27935888E-10_JPRB, 0.28635695E-10_JPRB, 0.29332776E-10_JPRB, 0.30115629E-10_JPRB, 0.30948934E-10_JPRB, &
  & 0.31767859E-10_JPRB, 0.32603902E-10_JPRB, 0.33480420E-10_JPRB, 0.34362835E-10_JPRB, 0.35366710E-10_JPRB, 0.36339317E-10_JPRB, &
  & 0.37447250E-10_JPRB, 0.38563455E-10_JPRB, 0.39720578E-10_JPRB, 0.40927123E-10_JPRB, 0.42123263E-10_JPRB, 0.43352037E-10_JPRB, &
  & 0.44549812E-10_JPRB, 0.45743884E-10_JPRB, 0.46931129E-10_JPRB, 0.48138261E-10_JPRB, 0.49350937E-10_JPRB, 0.50564598E-10_JPRB, &
  & 0.51786370E-10_JPRB, 0.52930375E-10_JPRB, 0.54027074E-10_JPRB, 0.55071749E-10_JPRB, 0.56097852E-10_JPRB, 0.57067025E-10_JPRB, &
  & 0.57968713E-10_JPRB, 0.58838948E-10_JPRB, 0.59697962E-10_JPRB, 0.60632693E-10_JPRB, 0.61599954E-10_JPRB, 0.62364461E-10_JPRB, &
  & 0.63123395E-10_JPRB, 0.63773375E-10_JPRB, 0.64414474E-10_JPRB, 0.65084070E-10_JPRB, 0.65680308E-10_JPRB, 0.66348906E-10_JPRB, &
  & 0.66752180E-10_JPRB, 0.67352020E-10_JPRB, 0.67856783E-10_JPRB, 0.68498492E-10_JPRB, 0.68588746E-10_JPRB, 0.69503334E-10_JPRB, &
  & 0.69802782E-10_JPRB, 0.71055085E-10_JPRB, 0.71554478E-10_JPRB, 0.73470778E-10_JPRB /)

RGHG4(:,86, 6) = (/ &
  & 0.26337221E-10_JPRB, 0.26281121E-10_JPRB, 0.26061890E-10_JPRB, 0.26611323E-10_JPRB, 0.26813728E-10_JPRB, 0.27348322E-10_JPRB, &
  & 0.28124987E-10_JPRB, 0.29017443E-10_JPRB, 0.25566967E-10_JPRB, 0.25776568E-10_JPRB, 0.26517169E-10_JPRB, 0.26793734E-10_JPRB, &
  & 0.27514779E-10_JPRB, 0.27996388E-10_JPRB, 0.28683805E-10_JPRB, 0.29382604E-10_JPRB, 0.30129472E-10_JPRB, 0.30947224E-10_JPRB, &
  & 0.31797294E-10_JPRB, 0.32653064E-10_JPRB, 0.33558767E-10_JPRB, 0.34463266E-10_JPRB, 0.35436959E-10_JPRB, 0.36435396E-10_JPRB, &
  & 0.37528862E-10_JPRB, 0.38650944E-10_JPRB, 0.39831107E-10_JPRB, 0.41031293E-10_JPRB, 0.42272349E-10_JPRB, 0.43492120E-10_JPRB, &
  & 0.44717608E-10_JPRB, 0.45915622E-10_JPRB, 0.47117130E-10_JPRB, 0.48329927E-10_JPRB, 0.49543869E-10_JPRB, 0.50785674E-10_JPRB, &
  & 0.52023233E-10_JPRB, 0.53212063E-10_JPRB, 0.54349109E-10_JPRB, 0.55331153E-10_JPRB, 0.56280848E-10_JPRB, 0.57199755E-10_JPRB, &
  & 0.58062329E-10_JPRB, 0.58977323E-10_JPRB, 0.59806465E-10_JPRB, 0.60780075E-10_JPRB, 0.61762991E-10_JPRB, 0.62582321E-10_JPRB, &
  & 0.63349041E-10_JPRB, 0.63997196E-10_JPRB, 0.64650209E-10_JPRB, 0.65315989E-10_JPRB, 0.65936923E-10_JPRB, 0.66618988E-10_JPRB, &
  & 0.67047957E-10_JPRB, 0.67681895E-10_JPRB, 0.68093892E-10_JPRB, 0.68707671E-10_JPRB, 0.68711960E-10_JPRB, 0.69638260E-10_JPRB, &
  & 0.69940005E-10_JPRB, 0.71207706E-10_JPRB, 0.71710374E-10_JPRB, 0.73730938E-10_JPRB /)

RGHG4(:,87, 6) = (/ &
  & 0.26983461E-10_JPRB, 0.26333003E-10_JPRB, 0.26043914E-10_JPRB, 0.26687997E-10_JPRB, 0.26786462E-10_JPRB, 0.27497575E-10_JPRB, &
  & 0.28245272E-10_JPRB, 0.29462644E-10_JPRB, 0.25218437E-10_JPRB, 0.26172457E-10_JPRB, 0.26511191E-10_JPRB, 0.27043444E-10_JPRB, &
  & 0.27528341E-10_JPRB, 0.28095325E-10_JPRB, 0.28715998E-10_JPRB, 0.29356777E-10_JPRB, 0.30138936E-10_JPRB, 0.30965262E-10_JPRB, &
  & 0.31816442E-10_JPRB, 0.32716163E-10_JPRB, 0.33618348E-10_JPRB, 0.34537675E-10_JPRB, 0.35516014E-10_JPRB, 0.36523409E-10_JPRB, &
  & 0.37613454E-10_JPRB, 0.38734630E-10_JPRB, 0.39912518E-10_JPRB, 0.41135970E-10_JPRB, 0.42369594E-10_JPRB, 0.43622453E-10_JPRB, &
  & 0.44850523E-10_JPRB, 0.46056672E-10_JPRB, 0.47257909E-10_JPRB, 0.48481906E-10_JPRB, 0.49706204E-10_JPRB, 0.50952582E-10_JPRB, &
  & 0.52190620E-10_JPRB, 0.53358405E-10_JPRB, 0.54489368E-10_JPRB, 0.55556434E-10_JPRB, 0.56621152E-10_JPRB, 0.57562975E-10_JPRB, &
  & 0.58453513E-10_JPRB, 0.59328820E-10_JPRB, 0.60146194E-10_JPRB, 0.61084804E-10_JPRB, 0.62029472E-10_JPRB, 0.62774716E-10_JPRB, &
  & 0.63536100E-10_JPRB, 0.64163758E-10_JPRB, 0.64826200E-10_JPRB, 0.65487366E-10_JPRB, 0.66125237E-10_JPRB, 0.66796242E-10_JPRB, &
  & 0.67235918E-10_JPRB, 0.67846492E-10_JPRB, 0.68319614E-10_JPRB, 0.68921438E-10_JPRB, 0.68997419E-10_JPRB, 0.69863060E-10_JPRB, &
  & 0.70212031E-10_JPRB, 0.71425948E-10_JPRB, 0.71906210E-10_JPRB, 0.73867579E-10_JPRB /)

RGHG4(:,88, 6) = (/ &
  & 0.26693946E-10_JPRB, 0.26304152E-10_JPRB, 0.26091185E-10_JPRB, 0.26710203E-10_JPRB, 0.26793831E-10_JPRB, 0.27611651E-10_JPRB, &
  & 0.28314417E-10_JPRB, 0.29264594E-10_JPRB, 0.25817438E-10_JPRB, 0.26117582E-10_JPRB, 0.26594974E-10_JPRB, 0.27063437E-10_JPRB, &
  & 0.27482438E-10_JPRB, 0.28149202E-10_JPRB, 0.28627985E-10_JPRB, 0.29477837E-10_JPRB, 0.30052797E-10_JPRB, 0.30995345E-10_JPRB, &
  & 0.31775225E-10_JPRB, 0.32742982E-10_JPRB, 0.33623885E-10_JPRB, 0.34598855E-10_JPRB, 0.35554660E-10_JPRB, 0.36582248E-10_JPRB, &
  & 0.37653141E-10_JPRB, 0.38786713E-10_JPRB, 0.39967248E-10_JPRB, 0.41191429E-10_JPRB, 0.42447136E-10_JPRB, 0.43701390E-10_JPRB, &
  & 0.44954158E-10_JPRB, 0.46183665E-10_JPRB, 0.47399990E-10_JPRB, 0.48623564E-10_JPRB, 0.49862985E-10_JPRB, 0.51109280E-10_JPRB, &
  & 0.52357427E-10_JPRB, 0.53579852E-10_JPRB, 0.54732024E-10_JPRB, 0.55750259E-10_JPRB, 0.56737719E-10_JPRB, 0.57712970E-10_JPRB, &
  & 0.58592776E-10_JPRB, 0.59491995E-10_JPRB, 0.60296441E-10_JPRB, 0.61197970E-10_JPRB, 0.62153636E-10_JPRB, 0.62928780E-10_JPRB, &
  & 0.63673088E-10_JPRB, 0.64309655E-10_JPRB, 0.64955402E-10_JPRB, 0.65623375E-10_JPRB, 0.66277192E-10_JPRB, 0.66952763E-10_JPRB, &
  & 0.67438971E-10_JPRB, 0.68028895E-10_JPRB, 0.68518656E-10_JPRB, 0.69017417E-10_JPRB, 0.69127287E-10_JPRB, 0.69925642E-10_JPRB, &
  & 0.70329673E-10_JPRB, 0.71515391E-10_JPRB, 0.72041970E-10_JPRB, 0.73996156E-10_JPRB /)

RGHG4(:,89, 6) = (/ &
  & 0.26424654E-10_JPRB, 0.26282865E-10_JPRB, 0.26122014E-10_JPRB, 0.26622371E-10_JPRB, 0.26796855E-10_JPRB, 0.27485384E-10_JPRB, &
  & 0.28181126E-10_JPRB, 0.29437681E-10_JPRB, 0.25437812E-10_JPRB, 0.26017697E-10_JPRB, 0.26589798E-10_JPRB, 0.26897590E-10_JPRB, &
  & 0.27481555E-10_JPRB, 0.27943207E-10_JPRB, 0.28686092E-10_JPRB, 0.29289831E-10_JPRB, 0.30177617E-10_JPRB, 0.30995456E-10_JPRB, &
  & 0.31901714E-10_JPRB, 0.32772979E-10_JPRB, 0.33691199E-10_JPRB, 0.34610981E-10_JPRB, 0.35586024E-10_JPRB, 0.36589773E-10_JPRB, &
  & 0.37667789E-10_JPRB, 0.38794450E-10_JPRB, 0.39973698E-10_JPRB, 0.41205060E-10_JPRB, 0.42467082E-10_JPRB, 0.43736379E-10_JPRB, &
  & 0.44988503E-10_JPRB, 0.46217228E-10_JPRB, 0.47459897E-10_JPRB, 0.48728636E-10_JPRB, 0.49979312E-10_JPRB, 0.51240172E-10_JPRB, &
  & 0.52497000E-10_JPRB, 0.53698296E-10_JPRB, 0.54844487E-10_JPRB, 0.55967089E-10_JPRB, 0.57024847E-10_JPRB, 0.58017997E-10_JPRB, &
  & 0.58886972E-10_JPRB, 0.59789639E-10_JPRB, 0.60530171E-10_JPRB, 0.61446556E-10_JPRB, 0.62346170E-10_JPRB, 0.63069903E-10_JPRB, &
  & 0.63796898E-10_JPRB, 0.64415195E-10_JPRB, 0.65062844E-10_JPRB, 0.65721685E-10_JPRB, 0.66387527E-10_JPRB, 0.67058227E-10_JPRB, &
  & 0.67559784E-10_JPRB, 0.68126560E-10_JPRB, 0.68672290E-10_JPRB, 0.69145280E-10_JPRB, 0.69319342E-10_JPRB, 0.70058140E-10_JPRB, &
  & 0.70518764E-10_JPRB, 0.71619800E-10_JPRB, 0.72201460E-10_JPRB, 0.74070763E-10_JPRB /)

RGHG4(:,90, 6) = (/ &
  & 0.26047218E-10_JPRB, 0.26338470E-10_JPRB, 0.26177990E-10_JPRB, 0.26558086E-10_JPRB, 0.26761171E-10_JPRB, 0.27281788E-10_JPRB, &
  & 0.27992162E-10_JPRB, 0.28768788E-10_JPRB, 0.25253294E-10_JPRB, 0.25947581E-10_JPRB, 0.26288145E-10_JPRB, 0.26928489E-10_JPRB, &
  & 0.27094436E-10_JPRB, 0.27772524E-10_JPRB, 0.28772177E-10_JPRB, 0.29440290E-10_JPRB, 0.30201727E-10_JPRB, 0.31037187E-10_JPRB, &
  & 0.31812549E-10_JPRB, 0.32705699E-10_JPRB, 0.33605393E-10_JPRB, 0.34570295E-10_JPRB, 0.35534572E-10_JPRB, 0.36545877E-10_JPRB, &
  & 0.37611171E-10_JPRB, 0.38729658E-10_JPRB, 0.39904330E-10_JPRB, 0.41136611E-10_JPRB, 0.42416664E-10_JPRB, 0.43714449E-10_JPRB, &
  & 0.45022715E-10_JPRB, 0.46302521E-10_JPRB, 0.47548097E-10_JPRB, 0.48842503E-10_JPRB, 0.50111547E-10_JPRB, 0.51419695E-10_JPRB, &
  & 0.52699206E-10_JPRB, 0.53915282E-10_JPRB, 0.55089103E-10_JPRB, 0.56157894E-10_JPRB, 0.57188247E-10_JPRB, 0.58178323E-10_JPRB, &
  & 0.59023481E-10_JPRB, 0.59891890E-10_JPRB, 0.60647085E-10_JPRB, 0.61475471E-10_JPRB, 0.62418300E-10_JPRB, 0.63158895E-10_JPRB, &
  & 0.63872900E-10_JPRB, 0.64525073E-10_JPRB, 0.65146291E-10_JPRB, 0.65813931E-10_JPRB, 0.66492041E-10_JPRB, 0.67162838E-10_JPRB, &
  & 0.67691172E-10_JPRB, 0.68229596E-10_JPRB, 0.68812789E-10_JPRB, 0.69203636E-10_JPRB, 0.69441120E-10_JPRB, 0.70072247E-10_JPRB, &
  & 0.70655252E-10_JPRB, 0.71631687E-10_JPRB, 0.72355372E-10_JPRB, 0.74128148E-10_JPRB /)

RGHG4(:,91, 6) = (/ &
  & 0.26615439E-10_JPRB, 0.26524451E-10_JPRB, 0.26107887E-10_JPRB, 0.26387902E-10_JPRB, 0.26630427E-10_JPRB, 0.26964743E-10_JPRB, &
  & 0.27232844E-10_JPRB, 0.28484451E-10_JPRB, 0.21454402E-10_JPRB, 0.27758216E-10_JPRB, 0.23364220E-10_JPRB, 0.32193324E-10_JPRB, &
  & 0.25241642E-10_JPRB, 0.25773626E-10_JPRB, 0.29213337E-10_JPRB, 0.29497741E-10_JPRB, 0.30149057E-10_JPRB, 0.31089867E-10_JPRB, &
  & 0.31946102E-10_JPRB, 0.32855357E-10_JPRB, 0.33685200E-10_JPRB, 0.34522055E-10_JPRB, 0.35421884E-10_JPRB, 0.36398360E-10_JPRB, &
  & 0.37439950E-10_JPRB, 0.38524968E-10_JPRB, 0.39726260E-10_JPRB, 0.40978068E-10_JPRB, 0.42266760E-10_JPRB, 0.43564999E-10_JPRB, &
  & 0.44885127E-10_JPRB, 0.46191884E-10_JPRB, 0.47507848E-10_JPRB, 0.48910657E-10_JPRB, 0.50196302E-10_JPRB, 0.51554323E-10_JPRB, &
  & 0.52871905E-10_JPRB, 0.54126103E-10_JPRB, 0.55318611E-10_JPRB, 0.56422332E-10_JPRB, 0.54795998E-10_JPRB, 0.55789377E-10_JPRB, &
  & 0.59224271E-10_JPRB, 0.60089198E-10_JPRB, 0.60766121E-10_JPRB, 0.61562276E-10_JPRB, 0.62488625E-10_JPRB, 0.63283101E-10_JPRB, &
  & 0.63923519E-10_JPRB, 0.64625139E-10_JPRB, 0.65223993E-10_JPRB, 0.65911707E-10_JPRB, 0.66604791E-10_JPRB, 0.67257838E-10_JPRB, &
  & 0.67787741E-10_JPRB, 0.68293642E-10_JPRB, 0.68937064E-10_JPRB, 0.69271304E-10_JPRB, 0.69609034E-10_JPRB, 0.70103590E-10_JPRB, &
  & 0.70855315E-10_JPRB, 0.71611647E-10_JPRB, 0.72588921E-10_JPRB, 0.74130653E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG4(:, 1, 7) = (/ &
  & 0.96664654E-09_JPRB, 0.96577402E-09_JPRB, 0.96492703E-09_JPRB, 0.96376673E-09_JPRB, 0.96236452E-09_JPRB, 0.96083852E-09_JPRB, &
  & 0.25409408E-13_JPRB, 0.13033692E-13_JPRB, 0.35082323E-13_JPRB, 0.43035528E-13_JPRB, 0.57941045E-13_JPRB, 0.69485162E-13_JPRB, &
  & 0.81505813E-13_JPRB, 0.86921193E-13_JPRB, 0.96644474E-13_JPRB, 0.97204254E-13_JPRB, 0.98425574E-13_JPRB, 0.99733610E-13_JPRB, &
  & 0.10707518E-12_JPRB, 0.10531198E-12_JPRB, 0.10428315E-12_JPRB, 0.10329623E-12_JPRB, 0.10200872E-12_JPRB, 0.10065681E-12_JPRB, &
  & 0.10529453E-12_JPRB, 0.10234776E-12_JPRB, 0.10190899E-12_JPRB, 0.10314924E-12_JPRB, 0.10592436E-12_JPRB, 0.10993773E-12_JPRB, &
  & 0.11462939E-12_JPRB, 0.11884928E-12_JPRB, 0.12785067E-12_JPRB, 0.12825465E-12_JPRB, 0.12747279E-12_JPRB, 0.12494731E-12_JPRB, &
  & 0.12109671E-12_JPRB, 0.11655585E-12_JPRB, 0.11221923E-12_JPRB, 0.10831089E-12_JPRB, 0.11013450E-12_JPRB, 0.10665926E-12_JPRB, &
  & 0.10447393E-12_JPRB, 0.10272119E-12_JPRB, 0.10165259E-12_JPRB, 0.10075146E-12_JPRB, 0.10524997E-12_JPRB, 0.10580576E-12_JPRB, &
  & 0.10783732E-12_JPRB, 0.11077889E-12_JPRB, 0.11810285E-12_JPRB, 0.12142281E-12_JPRB, 0.12990684E-12_JPRB, 0.13059273E-12_JPRB, &
  & 0.13690981E-12_JPRB, 0.14097027E-12_JPRB, 0.13885604E-12_JPRB, 0.13669304E-12_JPRB, 0.12972125E-12_JPRB, 0.12016139E-12_JPRB, &
  & 0.11224027E-12_JPRB, 0.10484907E-12_JPRB, 0.98576244E-13_JPRB, 0.94277505E-13_JPRB /)

RGHG4(:, 2, 7) = (/ &
  & 0.10096633E-19_JPRB, 0.10099500E-19_JPRB, 0.10104324E-19_JPRB, 0.10110413E-19_JPRB, 0.10116914E-19_JPRB, 0.10122989E-19_JPRB, &
  & 0.18232998E-12_JPRB, 0.12821799E-12_JPRB, 0.20568879E-12_JPRB, 0.21944313E-12_JPRB, 0.23507918E-12_JPRB, 0.25247523E-12_JPRB, &
  & 0.26856807E-12_JPRB, 0.28680931E-12_JPRB, 0.30529829E-12_JPRB, 0.32884475E-12_JPRB, 0.35693134E-12_JPRB, 0.38889508E-12_JPRB, &
  & 0.42085462E-12_JPRB, 0.44905228E-12_JPRB, 0.47364668E-12_JPRB, 0.49729101E-12_JPRB, 0.52342229E-12_JPRB, 0.56032728E-12_JPRB, &
  & 0.59567271E-12_JPRB, 0.63697577E-12_JPRB, 0.69303721E-12_JPRB, 0.76703449E-12_JPRB, 0.85871002E-12_JPRB, 0.96373766E-12_JPRB, &
  & 0.10706632E-11_JPRB, 0.11899610E-11_JPRB, 0.12543845E-11_JPRB, 0.12957612E-11_JPRB, 0.13013135E-11_JPRB, 0.12709346E-11_JPRB, &
  & 0.12103274E-11_JPRB, 0.11294199E-11_JPRB, 0.10470487E-11_JPRB, 0.97683775E-12_JPRB, 0.91596771E-12_JPRB, 0.85711370E-12_JPRB, &
  & 0.80743593E-12_JPRB, 0.75427907E-12_JPRB, 0.71624304E-12_JPRB, 0.67571101E-12_JPRB, 0.65185796E-12_JPRB, 0.61840951E-12_JPRB, &
  & 0.60370795E-12_JPRB, 0.59036505E-12_JPRB, 0.59184228E-12_JPRB, 0.59518590E-12_JPRB, 0.60572619E-12_JPRB, 0.62257328E-12_JPRB, &
  & 0.64510582E-12_JPRB, 0.64782815E-12_JPRB, 0.59768786E-12_JPRB, 0.54006691E-12_JPRB, 0.48509395E-12_JPRB, 0.41860279E-12_JPRB, &
  & 0.35941828E-12_JPRB, 0.30994632E-12_JPRB, 0.27035771E-12_JPRB, 0.24367346E-12_JPRB /)

RGHG4(:, 3, 7) = (/ &
  & 0.56085851E-20_JPRB, 0.56109935E-20_JPRB, 0.56150664E-20_JPRB, 0.56200634E-20_JPRB, 0.56250867E-20_JPRB, 0.56291939E-20_JPRB, &
  & 0.66193508E-12_JPRB, 0.28996808E-12_JPRB, 0.37262164E-12_JPRB, 0.39197465E-12_JPRB, 0.41427552E-12_JPRB, 0.44807311E-12_JPRB, &
  & 0.49752395E-12_JPRB, 0.56513203E-12_JPRB, 0.63934166E-12_JPRB, 0.71661383E-12_JPRB, 0.79131878E-12_JPRB, 0.86758129E-12_JPRB, &
  & 0.93952905E-12_JPRB, 0.10036831E-11_JPRB, 0.10568981E-11_JPRB, 0.11062162E-11_JPRB, 0.11610457E-11_JPRB, 0.12359816E-11_JPRB, &
  & 0.13068308E-11_JPRB, 0.13862499E-11_JPRB, 0.14860254E-11_JPRB, 0.16173548E-11_JPRB, 0.17688340E-11_JPRB, 0.19348295E-11_JPRB, &
  & 0.21092824E-11_JPRB, 0.22992270E-11_JPRB, 0.24070340E-11_JPRB, 0.24927976E-11_JPRB, 0.25285789E-11_JPRB, 0.25142813E-11_JPRB, &
  & 0.24586628E-11_JPRB, 0.23581785E-11_JPRB, 0.22434964E-11_JPRB, 0.21262996E-11_JPRB, 0.20263077E-11_JPRB, 0.19212195E-11_JPRB, &
  & 0.18268032E-11_JPRB, 0.17220728E-11_JPRB, 0.16474702E-11_JPRB, 0.15697017E-11_JPRB, 0.15223157E-11_JPRB, 0.14529099E-11_JPRB, &
  & 0.14059315E-11_JPRB, 0.13585331E-11_JPRB, 0.13283816E-11_JPRB, 0.12940126E-11_JPRB, 0.12606379E-11_JPRB, 0.12136372E-11_JPRB, &
  & 0.11637267E-11_JPRB, 0.10932406E-11_JPRB, 0.94443127E-12_JPRB, 0.86882303E-12_JPRB, 0.80836265E-12_JPRB, 0.75626164E-12_JPRB, &
  & 0.71020040E-12_JPRB, 0.66875601E-12_JPRB, 0.62964326E-12_JPRB, 0.51984084E-12_JPRB /)

RGHG4(:, 4, 7) = (/ &
  & 0.32503763E-20_JPRB, 0.32523027E-20_JPRB, 0.32556088E-20_JPRB, 0.32596179E-20_JPRB, 0.32635389E-20_JPRB, 0.32665506E-20_JPRB, &
  & 0.24398467E-11_JPRB, 0.71503952E-12_JPRB, 0.85382092E-12_JPRB, 0.93234611E-12_JPRB, 0.10376547E-11_JPRB, 0.11676108E-11_JPRB, &
  & 0.13117801E-11_JPRB, 0.14689571E-11_JPRB, 0.16390361E-11_JPRB, 0.18198500E-11_JPRB, 0.20010662E-11_JPRB, 0.21801953E-11_JPRB, &
  & 0.23540642E-11_JPRB, 0.25110860E-11_JPRB, 0.26480016E-11_JPRB, 0.27757601E-11_JPRB, 0.29082344E-11_JPRB, 0.30553737E-11_JPRB, &
  & 0.31898143E-11_JPRB, 0.33152556E-11_JPRB, 0.34577040E-11_JPRB, 0.36449320E-11_JPRB, 0.38574690E-11_JPRB, 0.40938008E-11_JPRB, &
  & 0.43387928E-11_JPRB, 0.46025111E-11_JPRB, 0.47612478E-11_JPRB, 0.49074911E-11_JPRB, 0.49952807E-11_JPRB, 0.50241170E-11_JPRB, &
  & 0.50085257E-11_JPRB, 0.49329993E-11_JPRB, 0.48241992E-11_JPRB, 0.47021089E-11_JPRB, 0.45998001E-11_JPRB, 0.44771040E-11_JPRB, &
  & 0.43593857E-11_JPRB, 0.42170390E-11_JPRB, 0.41233367E-11_JPRB, 0.40243572E-11_JPRB, 0.39715137E-11_JPRB, 0.38693814E-11_JPRB, &
  & 0.37932509E-11_JPRB, 0.37027582E-11_JPRB, 0.36226022E-11_JPRB, 0.35179537E-11_JPRB, 0.33973048E-11_JPRB, 0.32496358E-11_JPRB, &
  & 0.31013753E-11_JPRB, 0.29500419E-11_JPRB, 0.27287547E-11_JPRB, 0.25609987E-11_JPRB, 0.24256218E-11_JPRB, 0.22919724E-11_JPRB, &
  & 0.22019910E-11_JPRB, 0.21228295E-11_JPRB, 0.20115036E-11_JPRB, 0.18344688E-11_JPRB /)

RGHG4(:, 5, 7) = (/ &
  & 0.19538638E-20_JPRB, 0.19551329E-20_JPRB, 0.19577172E-20_JPRB, 0.19610576E-20_JPRB, 0.19646390E-20_JPRB, 0.22457772E-09_JPRB, &
  & 0.74381725E-11_JPRB, 0.21337383E-11_JPRB, 0.22217137E-11_JPRB, 0.24388770E-11_JPRB, 0.27178604E-11_JPRB, 0.30426731E-11_JPRB, &
  & 0.34140334E-11_JPRB, 0.38261208E-11_JPRB, 0.42667493E-11_JPRB, 0.47360679E-11_JPRB, 0.52296049E-11_JPRB, 0.57281484E-11_JPRB, &
  & 0.62146863E-11_JPRB, 0.66669964E-11_JPRB, 0.70934378E-11_JPRB, 0.75130492E-11_JPRB, 0.79347596E-11_JPRB, 0.83464529E-11_JPRB, &
  & 0.87038154E-11_JPRB, 0.89834425E-11_JPRB, 0.92402336E-11_JPRB, 0.95243188E-11_JPRB, 0.98188697E-11_JPRB, 0.10138051E-10_JPRB, &
  & 0.10471762E-10_JPRB, 0.10845765E-10_JPRB, 0.11097836E-10_JPRB, 0.11369391E-10_JPRB, 0.11586785E-10_JPRB, 0.11745620E-10_JPRB, &
  & 0.11866944E-10_JPRB, 0.11926111E-10_JPRB, 0.11941334E-10_JPRB, 0.11933698E-10_JPRB, 0.11948976E-10_JPRB, 0.11915816E-10_JPRB, &
  & 0.11858970E-10_JPRB, 0.11736646E-10_JPRB, 0.11663324E-10_JPRB, 0.11550960E-10_JPRB, 0.11490266E-10_JPRB, 0.11316384E-10_JPRB, &
  & 0.11150399E-10_JPRB, 0.10920887E-10_JPRB, 0.10683205E-10_JPRB, 0.10386869E-10_JPRB, 0.10052648E-10_JPRB, 0.96403927E-11_JPRB, &
  & 0.91824465E-11_JPRB, 0.86599330E-11_JPRB, 0.81011578E-11_JPRB, 0.75991670E-11_JPRB, 0.71922225E-11_JPRB, 0.69152522E-11_JPRB, &
  & 0.66592881E-11_JPRB, 0.64493810E-11_JPRB, 0.63108451E-11_JPRB, 0.57474793E-11_JPRB /)

RGHG4(:, 6, 7) = (/ &
  & 0.22231289E-09_JPRB, 0.43203299E-09_JPRB, 0.55360788E-09_JPRB, 0.68652151E-09_JPRB, 0.84839669E-09_JPRB, 0.10978232E-08_JPRB, &
  & 0.17754340E-10_JPRB, 0.71310301E-11_JPRB, 0.63919777E-11_JPRB, 0.68016491E-11_JPRB, 0.75070106E-11_JPRB, 0.83668723E-11_JPRB, &
  & 0.93429205E-11_JPRB, 0.10443180E-10_JPRB, 0.11618080E-10_JPRB, 0.12862242E-10_JPRB, 0.14160476E-10_JPRB, 0.15528925E-10_JPRB, &
  & 0.16916741E-10_JPRB, 0.18236978E-10_JPRB, 0.19449196E-10_JPRB, 0.20591421E-10_JPRB, 0.21677759E-10_JPRB, 0.22679386E-10_JPRB, &
  & 0.23528700E-10_JPRB, 0.24200079E-10_JPRB, 0.24736286E-10_JPRB, 0.25164232E-10_JPRB, 0.25493238E-10_JPRB, 0.25780803E-10_JPRB, &
  & 0.26087453E-10_JPRB, 0.26452358E-10_JPRB, 0.26744728E-10_JPRB, 0.27219452E-10_JPRB, 0.27751367E-10_JPRB, 0.28305056E-10_JPRB, &
  & 0.28863315E-10_JPRB, 0.29398383E-10_JPRB, 0.29869385E-10_JPRB, 0.30288515E-10_JPRB, 0.30722806E-10_JPRB, 0.31061157E-10_JPRB, &
  & 0.31300764E-10_JPRB, 0.31406475E-10_JPRB, 0.31459571E-10_JPRB, 0.31373917E-10_JPRB, 0.31286980E-10_JPRB, 0.31011051E-10_JPRB, &
  & 0.30642593E-10_JPRB, 0.30091311E-10_JPRB, 0.29451899E-10_JPRB, 0.28646658E-10_JPRB, 0.27687816E-10_JPRB, 0.26628288E-10_JPRB, &
  & 0.25499736E-10_JPRB, 0.24351523E-10_JPRB, 0.23156182E-10_JPRB, 0.21919237E-10_JPRB, 0.21067753E-10_JPRB, 0.20542299E-10_JPRB, &
  & 0.20241527E-10_JPRB, 0.20154460E-10_JPRB, 0.19890397E-10_JPRB, 0.18125942E-10_JPRB /)

RGHG4(:, 7, 7) = (/ &
  & 0.74866968E-09_JPRB, 0.88026986E-09_JPRB, 0.10038543E-08_JPRB, 0.11698814E-08_JPRB, 0.13972392E-08_JPRB, 0.17214989E-08_JPRB, &
  & 0.37953432E-10_JPRB, 0.23186180E-10_JPRB, 0.20493112E-10_JPRB, 0.20879073E-10_JPRB, 0.22451338E-10_JPRB, 0.24514210E-10_JPRB, &
  & 0.26857192E-10_JPRB, 0.29494070E-10_JPRB, 0.32279526E-10_JPRB, 0.35310997E-10_JPRB, 0.38448519E-10_JPRB, 0.41536240E-10_JPRB, &
  & 0.44467124E-10_JPRB, 0.47389447E-10_JPRB, 0.50195771E-10_JPRB, 0.52929782E-10_JPRB, 0.55650803E-10_JPRB, 0.58327579E-10_JPRB, &
  & 0.60675971E-10_JPRB, 0.62639997E-10_JPRB, 0.64183492E-10_JPRB, 0.65188736E-10_JPRB, 0.65718701E-10_JPRB, 0.65835705E-10_JPRB, &
  & 0.65864300E-10_JPRB, 0.65902027E-10_JPRB, 0.66062426E-10_JPRB, 0.66963782E-10_JPRB, 0.68311391E-10_JPRB, 0.69991762E-10_JPRB, &
  & 0.71833442E-10_JPRB, 0.73802173E-10_JPRB, 0.75608582E-10_JPRB, 0.77246293E-10_JPRB, 0.78811652E-10_JPRB, 0.80142122E-10_JPRB, &
  & 0.81150114E-10_JPRB, 0.81890640E-10_JPRB, 0.82236405E-10_JPRB, 0.82245925E-10_JPRB, 0.82102450E-10_JPRB, 0.81741558E-10_JPRB, &
  & 0.80991741E-10_JPRB, 0.79850411E-10_JPRB, 0.78440671E-10_JPRB, 0.76730060E-10_JPRB, 0.74583333E-10_JPRB, 0.72273867E-10_JPRB, &
  & 0.69671248E-10_JPRB, 0.67161117E-10_JPRB, 0.64750288E-10_JPRB, 0.62322911E-10_JPRB, 0.61427502E-10_JPRB, 0.61993188E-10_JPRB, &
  & 0.63328363E-10_JPRB, 0.65108224E-10_JPRB, 0.67464617E-10_JPRB, 0.65985661E-10_JPRB /)

RGHG4(:, 8, 7) = (/ &
  & 0.91557290E-09_JPRB, 0.10517384E-08_JPRB, 0.12199094E-08_JPRB, 0.14506875E-08_JPRB, 0.17614620E-08_JPRB, 0.22050759E-08_JPRB, &
  & 0.80359157E-10_JPRB, 0.63938410E-10_JPRB, 0.64655975E-10_JPRB, 0.65919242E-10_JPRB, 0.69030358E-10_JPRB, 0.73430227E-10_JPRB, &
  & 0.78473651E-10_JPRB, 0.84166001E-10_JPRB, 0.89915048E-10_JPRB, 0.95908094E-10_JPRB, 0.10223631E-09_JPRB, 0.10874607E-09_JPRB, &
  & 0.11494945E-09_JPRB, 0.12146295E-09_JPRB, 0.12833891E-09_JPRB, 0.13516482E-09_JPRB, 0.14150998E-09_JPRB, 0.14754198E-09_JPRB, &
  & 0.15263375E-09_JPRB, 0.15706238E-09_JPRB, 0.16073547E-09_JPRB, 0.16318454E-09_JPRB, 0.16454113E-09_JPRB, 0.16473752E-09_JPRB, &
  & 0.16476659E-09_JPRB, 0.16454701E-09_JPRB, 0.16466077E-09_JPRB, 0.16659521E-09_JPRB, 0.16964707E-09_JPRB, 0.17368774E-09_JPRB, &
  & 0.17822747E-09_JPRB, 0.18335336E-09_JPRB, 0.18793411E-09_JPRB, 0.19212047E-09_JPRB, 0.19595285E-09_JPRB, 0.19937478E-09_JPRB, &
  & 0.20199024E-09_JPRB, 0.20410888E-09_JPRB, 0.20499949E-09_JPRB, 0.20510572E-09_JPRB, 0.20474637E-09_JPRB, 0.20434715E-09_JPRB, &
  & 0.20296152E-09_JPRB, 0.20102595E-09_JPRB, 0.19866722E-09_JPRB, 0.19607810E-09_JPRB, 0.19262725E-09_JPRB, 0.18952745E-09_JPRB, &
  & 0.18612938E-09_JPRB, 0.18263793E-09_JPRB, 0.17890092E-09_JPRB, 0.17489213E-09_JPRB, 0.17619098E-09_JPRB, 0.18033204E-09_JPRB, &
  & 0.18886256E-09_JPRB, 0.19604655E-09_JPRB, 0.20890427E-09_JPRB, 0.21025544E-09_JPRB /)

RGHG4(:, 9, 7) = (/ &
  & 0.96234642E-09_JPRB, 0.11372777E-08_JPRB, 0.13440117E-08_JPRB, 0.16134960E-08_JPRB, 0.20002866E-08_JPRB, 0.25433946E-08_JPRB, &
  & 0.15689261E-09_JPRB, 0.13906670E-09_JPRB, 0.16316483E-09_JPRB, 0.18096560E-09_JPRB, 0.19448582E-09_JPRB, 0.20641663E-09_JPRB, &
  & 0.21703611E-09_JPRB, 0.22803892E-09_JPRB, 0.23879629E-09_JPRB, 0.24984365E-09_JPRB, 0.26176272E-09_JPRB, 0.27390917E-09_JPRB, &
  & 0.28565830E-09_JPRB, 0.29775502E-09_JPRB, 0.31017697E-09_JPRB, 0.32330871E-09_JPRB, 0.33644135E-09_JPRB, 0.34905984E-09_JPRB, &
  & 0.35945261E-09_JPRB, 0.36898909E-09_JPRB, 0.37748543E-09_JPRB, 0.38364301E-09_JPRB, 0.38800799E-09_JPRB, 0.39017023E-09_JPRB, &
  & 0.39207926E-09_JPRB, 0.39246917E-09_JPRB, 0.39276640E-09_JPRB, 0.39663137E-09_JPRB, 0.40263462E-09_JPRB, 0.41084303E-09_JPRB, &
  & 0.42004469E-09_JPRB, 0.43079743E-09_JPRB, 0.44009685E-09_JPRB, 0.44865098E-09_JPRB, 0.45628651E-09_JPRB, 0.46343709E-09_JPRB, &
  & 0.46884824E-09_JPRB, 0.47340343E-09_JPRB, 0.47499954E-09_JPRB, 0.47467852E-09_JPRB, 0.47351795E-09_JPRB, 0.47248505E-09_JPRB, &
  & 0.46973048E-09_JPRB, 0.46628651E-09_JPRB, 0.46252169E-09_JPRB, 0.45944409E-09_JPRB, 0.45528920E-09_JPRB, 0.45271911E-09_JPRB, &
  & 0.44926809E-09_JPRB, 0.44639956E-09_JPRB, 0.44441620E-09_JPRB, 0.44321871E-09_JPRB, 0.45474008E-09_JPRB, 0.47126797E-09_JPRB, &
  & 0.49886539E-09_JPRB, 0.52515509E-09_JPRB, 0.56784349E-09_JPRB, 0.60689087E-09_JPRB /)

RGHG4(:,10, 7) = (/ &
  & 0.93456698E-09_JPRB, 0.11254557E-08_JPRB, 0.13324220E-08_JPRB, 0.16315910E-08_JPRB, 0.20182596E-08_JPRB, 0.26741704E-08_JPRB, &
  & 0.25730182E-09_JPRB, 0.24453450E-09_JPRB, 0.31089722E-09_JPRB, 0.37338749E-09_JPRB, 0.42673529E-09_JPRB, 0.47124499E-09_JPRB, &
  & 0.50616439E-09_JPRB, 0.53601346E-09_JPRB, 0.56074978E-09_JPRB, 0.58272159E-09_JPRB, 0.60462108E-09_JPRB, 0.62555972E-09_JPRB, &
  & 0.64489863E-09_JPRB, 0.66542216E-09_JPRB, 0.68837841E-09_JPRB, 0.71254025E-09_JPRB, 0.73694878E-09_JPRB, 0.76241086E-09_JPRB, &
  & 0.78461704E-09_JPRB, 0.80395435E-09_JPRB, 0.82184315E-09_JPRB, 0.83725121E-09_JPRB, 0.85109025E-09_JPRB, 0.86144741E-09_JPRB, &
  & 0.87129048E-09_JPRB, 0.87636892E-09_JPRB, 0.87942248E-09_JPRB, 0.88820007E-09_JPRB, 0.89934205E-09_JPRB, 0.91373137E-09_JPRB, &
  & 0.92888608E-09_JPRB, 0.94684816E-09_JPRB, 0.96126962E-09_JPRB, 0.97438813E-09_JPRB, 0.98590069E-09_JPRB, 0.99715403E-09_JPRB, &
  & 0.10058080E-08_JPRB, 0.10129255E-08_JPRB, 0.10145489E-08_JPRB, 0.10127029E-08_JPRB, 0.10091293E-08_JPRB, 0.10060446E-08_JPRB, &
  & 0.10003566E-08_JPRB, 0.99261632E-09_JPRB, 0.98452657E-09_JPRB, 0.97850439E-09_JPRB, 0.97087394E-09_JPRB, 0.96762443E-09_JPRB, &
  & 0.96445130E-09_JPRB, 0.96383923E-09_JPRB, 0.96513786E-09_JPRB, 0.96793251E-09_JPRB, 0.99041597E-09_JPRB, 0.10183340E-08_JPRB, &
  & 0.10636224E-08_JPRB, 0.11069817E-08_JPRB, 0.11752130E-08_JPRB, 0.12411695E-08_JPRB /)

RGHG4(:,11, 7) = (/ &
  & 0.83461543E-09_JPRB, 0.99719899E-09_JPRB, 0.11872997E-08_JPRB, 0.14599733E-08_JPRB, 0.18592573E-08_JPRB, 0.24914122E-08_JPRB, &
  & 0.35910017E-09_JPRB, 0.35966793E-09_JPRB, 0.48210658E-09_JPRB, 0.60605565E-09_JPRB, 0.72566414E-09_JPRB, 0.83526247E-09_JPRB, &
  & 0.92909119E-09_JPRB, 0.10105737E-08_JPRB, 0.10780828E-08_JPRB, 0.11354354E-08_JPRB, 0.11862449E-08_JPRB, 0.12314663E-08_JPRB, &
  & 0.12708328E-08_JPRB, 0.13091007E-08_JPRB, 0.13494504E-08_JPRB, 0.13929019E-08_JPRB, 0.14379501E-08_JPRB, 0.14811269E-08_JPRB, &
  & 0.15177237E-08_JPRB, 0.15575167E-08_JPRB, 0.15994408E-08_JPRB, 0.16376920E-08_JPRB, 0.16739461E-08_JPRB, 0.17060879E-08_JPRB, &
  & 0.17382396E-08_JPRB, 0.17599480E-08_JPRB, 0.17750054E-08_JPRB, 0.17952597E-08_JPRB, 0.18156497E-08_JPRB, 0.18376356E-08_JPRB, &
  & 0.18576917E-08_JPRB, 0.18801105E-08_JPRB, 0.18954041E-08_JPRB, 0.19082989E-08_JPRB, 0.19184849E-08_JPRB, 0.19302957E-08_JPRB, &
  & 0.19395812E-08_JPRB, 0.19464805E-08_JPRB, 0.19463122E-08_JPRB, 0.19399229E-08_JPRB, 0.19306310E-08_JPRB, 0.19226134E-08_JPRB, &
  & 0.19106809E-08_JPRB, 0.18952238E-08_JPRB, 0.18792210E-08_JPRB, 0.18665487E-08_JPRB, 0.18508562E-08_JPRB, 0.18416029E-08_JPRB, &
  & 0.18315918E-08_JPRB, 0.18243840E-08_JPRB, 0.18192454E-08_JPRB, 0.18166796E-08_JPRB, 0.18368721E-08_JPRB, 0.18640496E-08_JPRB, &
  & 0.19123219E-08_JPRB, 0.19643138E-08_JPRB, 0.20468738E-08_JPRB, 0.21461302E-08_JPRB /)

RGHG4(:,12, 7) = (/ &
  & 0.65870409E-09_JPRB, 0.79239759E-09_JPRB, 0.95061337E-09_JPRB, 0.12176140E-08_JPRB, 0.15727843E-08_JPRB, 0.22559012E-08_JPRB, &
  & 0.45501042E-09_JPRB, 0.48429671E-09_JPRB, 0.67117017E-09_JPRB, 0.87182028E-09_JPRB, 0.10774750E-08_JPRB, 0.12817092E-08_JPRB, &
  & 0.14750022E-08_JPRB, 0.16547771E-08_JPRB, 0.18139815E-08_JPRB, 0.19533652E-08_JPRB, 0.20718045E-08_JPRB, 0.21686497E-08_JPRB, &
  & 0.22443660E-08_JPRB, 0.23092370E-08_JPRB, 0.23717326E-08_JPRB, 0.24343152E-08_JPRB, 0.24971847E-08_JPRB, 0.25631430E-08_JPRB, &
  & 0.26249043E-08_JPRB, 0.26822431E-08_JPRB, 0.27414009E-08_JPRB, 0.28065392E-08_JPRB, 0.28756395E-08_JPRB, 0.29402569E-08_JPRB, &
  & 0.30026222E-08_JPRB, 0.30466325E-08_JPRB, 0.30782741E-08_JPRB, 0.31114036E-08_JPRB, 0.31413010E-08_JPRB, 0.31676974E-08_JPRB, &
  & 0.31912424E-08_JPRB, 0.32141312E-08_JPRB, 0.32295440E-08_JPRB, 0.32399852E-08_JPRB, 0.32467808E-08_JPRB, 0.32577168E-08_JPRB, &
  & 0.32663336E-08_JPRB, 0.32719125E-08_JPRB, 0.32696881E-08_JPRB, 0.32596497E-08_JPRB, 0.32439096E-08_JPRB, 0.32305736E-08_JPRB, &
  & 0.32136598E-08_JPRB, 0.31907339E-08_JPRB, 0.31652307E-08_JPRB, 0.31439122E-08_JPRB, 0.31177625E-08_JPRB, 0.30987102E-08_JPRB, &
  & 0.30762421E-08_JPRB, 0.30538934E-08_JPRB, 0.30306724E-08_JPRB, 0.30061178E-08_JPRB, 0.29992544E-08_JPRB, 0.30014362E-08_JPRB, &
  & 0.30232148E-08_JPRB, 0.30589864E-08_JPRB, 0.31251848E-08_JPRB, 0.32240131E-08_JPRB /)

RGHG4(:,13, 7) = (/ &
  & 0.49387394E-09_JPRB, 0.63670824E-09_JPRB, 0.79336976E-09_JPRB, 0.10529889E-08_JPRB, 0.14280225E-08_JPRB, 0.21430593E-08_JPRB, &
  & 0.59153360E-09_JPRB, 0.67145617E-09_JPRB, 0.95678243E-09_JPRB, 0.12665671E-08_JPRB, 0.15924212E-08_JPRB, 0.19265940E-08_JPRB, &
  & 0.22546096E-08_JPRB, 0.25683184E-08_JPRB, 0.28520539E-08_JPRB, 0.31029286E-08_JPRB, 0.33159395E-08_JPRB, 0.34844290E-08_JPRB, &
  & 0.36069092E-08_JPRB, 0.36967160E-08_JPRB, 0.37633354E-08_JPRB, 0.38179033E-08_JPRB, 0.38702304E-08_JPRB, 0.39201051E-08_JPRB, &
  & 0.39665538E-08_JPRB, 0.40301193E-08_JPRB, 0.41067820E-08_JPRB, 0.41866537E-08_JPRB, 0.42748920E-08_JPRB, 0.43586161E-08_JPRB, &
  & 0.44350554E-08_JPRB, 0.44881965E-08_JPRB, 0.45212554E-08_JPRB, 0.45488209E-08_JPRB, 0.45754516E-08_JPRB, 0.45980921E-08_JPRB, &
  & 0.46228363E-08_JPRB, 0.46476214E-08_JPRB, 0.46696198E-08_JPRB, 0.46862860E-08_JPRB, 0.46968389E-08_JPRB, 0.47125308E-08_JPRB, &
  & 0.47255528E-08_JPRB, 0.47354489E-08_JPRB, 0.47374917E-08_JPRB, 0.47290065E-08_JPRB, 0.47117616E-08_JPRB, 0.46978585E-08_JPRB, &
  & 0.46786068E-08_JPRB, 0.46519393E-08_JPRB, 0.46194333E-08_JPRB, 0.45908313E-08_JPRB, 0.45539745E-08_JPRB, 0.45212731E-08_JPRB, &
  & 0.44791233E-08_JPRB, 0.44310640E-08_JPRB, 0.43751647E-08_JPRB, 0.43099257E-08_JPRB, 0.42537485E-08_JPRB, 0.42067869E-08_JPRB, &
  & 0.41768726E-08_JPRB, 0.41711949E-08_JPRB, 0.41941628E-08_JPRB, 0.42533896E-08_JPRB /)

RGHG4(:,14, 7) = (/ &
  & 0.40409806E-09_JPRB, 0.54141597E-09_JPRB, 0.69643696E-09_JPRB, 0.95504216E-09_JPRB, 0.13440981E-08_JPRB, 0.21169870E-08_JPRB, &
  & 0.69064165E-09_JPRB, 0.85208457E-09_JPRB, 0.12490657E-08_JPRB, 0.16535951E-08_JPRB, 0.20700932E-08_JPRB, 0.24929037E-08_JPRB, &
  & 0.29061329E-08_JPRB, 0.33039189E-08_JPRB, 0.36687975E-08_JPRB, 0.40007553E-08_JPRB, 0.42927724E-08_JPRB, 0.45378878E-08_JPRB, &
  & 0.47309823E-08_JPRB, 0.48839546E-08_JPRB, 0.50046354E-08_JPRB, 0.50974096E-08_JPRB, 0.51701545E-08_JPRB, 0.52313331E-08_JPRB, &
  & 0.52811444E-08_JPRB, 0.53297797E-08_JPRB, 0.53918692E-08_JPRB, 0.54641278E-08_JPRB, 0.55384035E-08_JPRB, 0.56071259E-08_JPRB, &
  & 0.56692122E-08_JPRB, 0.56975780E-08_JPRB, 0.57042042E-08_JPRB, 0.57077432E-08_JPRB, 0.57136380E-08_JPRB, 0.57184950E-08_JPRB, &
  & 0.57390319E-08_JPRB, 0.57702181E-08_JPRB, 0.58084866E-08_JPRB, 0.58461742E-08_JPRB, 0.58772400E-08_JPRB, 0.59140528E-08_JPRB, &
  & 0.59481744E-08_JPRB, 0.59747371E-08_JPRB, 0.59923506E-08_JPRB, 0.59986593E-08_JPRB, 0.59910752E-08_JPRB, 0.59824750E-08_JPRB, &
  & 0.59668608E-08_JPRB, 0.59411778E-08_JPRB, 0.59039125E-08_JPRB, 0.58673777E-08_JPRB, 0.58172271E-08_JPRB, 0.57664620E-08_JPRB, &
  & 0.56983933E-08_JPRB, 0.56168319E-08_JPRB, 0.55197322E-08_JPRB, 0.54080997E-08_JPRB, 0.52994515E-08_JPRB, 0.51953650E-08_JPRB, &
  & 0.51071800E-08_JPRB, 0.50514437E-08_JPRB, 0.50212852E-08_JPRB, 0.50129607E-08_JPRB /)

RGHG4(:,15, 7) = (/ &
  & 0.34976649E-09_JPRB, 0.49367138E-09_JPRB, 0.62943428E-09_JPRB, 0.88559937E-09_JPRB, 0.12602088E-08_JPRB, 0.20357223E-08_JPRB, &
  & 0.70819239E-09_JPRB, 0.97055086E-09_JPRB, 0.14145364E-08_JPRB, 0.18769422E-08_JPRB, 0.23386577E-08_JPRB, 0.28058516E-08_JPRB, &
  & 0.32650083E-08_JPRB, 0.37093657E-08_JPRB, 0.41227932E-08_JPRB, 0.45046078E-08_JPRB, 0.48467066E-08_JPRB, 0.51422822E-08_JPRB, &
  & 0.53909455E-08_JPRB, 0.56033032E-08_JPRB, 0.57805885E-08_JPRB, 0.59231935E-08_JPRB, 0.60361365E-08_JPRB, 0.61210330E-08_JPRB, &
  & 0.61847212E-08_JPRB, 0.62447962E-08_JPRB, 0.62991141E-08_JPRB, 0.63484027E-08_JPRB, 0.63965682E-08_JPRB, 0.64237957E-08_JPRB, &
  & 0.64259842E-08_JPRB, 0.63971606E-08_JPRB, 0.63434213E-08_JPRB, 0.62986789E-08_JPRB, 0.62661014E-08_JPRB, 0.62598509E-08_JPRB, &
  & 0.62748486E-08_JPRB, 0.63124750E-08_JPRB, 0.63673768E-08_JPRB, 0.64321060E-08_JPRB, 0.64905099E-08_JPRB, 0.65567525E-08_JPRB, &
  & 0.66200689E-08_JPRB, 0.66779613E-08_JPRB, 0.67272348E-08_JPRB, 0.67603954E-08_JPRB, 0.67717090E-08_JPRB, 0.67805295E-08_JPRB, &
  & 0.67784174E-08_JPRB, 0.67605428E-08_JPRB, 0.67233530E-08_JPRB, 0.66810779E-08_JPRB, 0.66178636E-08_JPRB, 0.65472707E-08_JPRB, &
  & 0.64526615E-08_JPRB, 0.63405126E-08_JPRB, 0.62104406E-08_JPRB, 0.60683827E-08_JPRB, 0.59284839E-08_JPRB, 0.57838347E-08_JPRB, &
  & 0.56552096E-08_JPRB, 0.55638987E-08_JPRB, 0.54945168E-08_JPRB, 0.54239302E-08_JPRB /)

RGHG4(:,16, 7) = (/ &
  & 0.29881439E-09_JPRB, 0.43900891E-09_JPRB, 0.55181926E-09_JPRB, 0.79163076E-09_JPRB, 0.11526671E-08_JPRB, 0.18632083E-08_JPRB, &
  & 0.67812522E-09_JPRB, 0.99317821E-09_JPRB, 0.14505199E-08_JPRB, 0.19521500E-08_JPRB, 0.24419899E-08_JPRB, 0.29233600E-08_JPRB, &
  & 0.33960881E-08_JPRB, 0.38578136E-08_JPRB, 0.42847290E-08_JPRB, 0.46818989E-08_JPRB, 0.50459739E-08_JPRB, 0.53659996E-08_JPRB, &
  & 0.56376153E-08_JPRB, 0.58745573E-08_JPRB, 0.60746257E-08_JPRB, 0.62399232E-08_JPRB, 0.63726371E-08_JPRB, 0.64756982E-08_JPRB, &
  & 0.65427770E-08_JPRB, 0.65917103E-08_JPRB, 0.66237664E-08_JPRB, 0.66319261E-08_JPRB, 0.66235213E-08_JPRB, 0.65892984E-08_JPRB, &
  & 0.65404895E-08_JPRB, 0.64707990E-08_JPRB, 0.63841767E-08_JPRB, 0.63209544E-08_JPRB, 0.62864602E-08_JPRB, 0.62754131E-08_JPRB, &
  & 0.63009034E-08_JPRB, 0.63552146E-08_JPRB, 0.64188028E-08_JPRB, 0.64906276E-08_JPRB, 0.65593087E-08_JPRB, 0.66423973E-08_JPRB, &
  & 0.67300716E-08_JPRB, 0.68158532E-08_JPRB, 0.68918529E-08_JPRB, 0.69538086E-08_JPRB, 0.69930572E-08_JPRB, 0.70262551E-08_JPRB, &
  & 0.70444481E-08_JPRB, 0.70409460E-08_JPRB, 0.70117707E-08_JPRB, 0.69717943E-08_JPRB, 0.69042265E-08_JPRB, 0.68252142E-08_JPRB, &
  & 0.67193677E-08_JPRB, 0.65956680E-08_JPRB, 0.64565198E-08_JPRB, 0.63131007E-08_JPRB, 0.61740386E-08_JPRB, 0.60123093E-08_JPRB, &
  & 0.58654708E-08_JPRB, 0.57556702E-08_JPRB, 0.56694920E-08_JPRB, 0.55617200E-08_JPRB /)

RGHG4(:,17, 7) = (/ &
  & 0.24073682E-09_JPRB, 0.35184256E-09_JPRB, 0.46711141E-09_JPRB, 0.67916112E-09_JPRB, 0.10013059E-08_JPRB, 0.16494607E-08_JPRB, &
  & 0.62224570E-09_JPRB, 0.98964403E-09_JPRB, 0.13918799E-08_JPRB, 0.19161883E-08_JPRB, 0.24153497E-08_JPRB, 0.28931293E-08_JPRB, &
  & 0.33483365E-08_JPRB, 0.37913601E-08_JPRB, 0.42051833E-08_JPRB, 0.45780459E-08_JPRB, 0.49064961E-08_JPRB, 0.51883617E-08_JPRB, &
  & 0.54213736E-08_JPRB, 0.56205218E-08_JPRB, 0.57810561E-08_JPRB, 0.59059957E-08_JPRB, 0.59957714E-08_JPRB, 0.60541714E-08_JPRB, &
  & 0.60724843E-08_JPRB, 0.60619572E-08_JPRB, 0.60230159E-08_JPRB, 0.59637233E-08_JPRB, 0.59052856E-08_JPRB, 0.58552172E-08_JPRB, &
  & 0.58120335E-08_JPRB, 0.57763594E-08_JPRB, 0.57448006E-08_JPRB, 0.57456040E-08_JPRB, 0.57752674E-08_JPRB, 0.58279928E-08_JPRB, &
  & 0.58878395E-08_JPRB, 0.59364500E-08_JPRB, 0.59854179E-08_JPRB, 0.60391190E-08_JPRB, 0.60924101E-08_JPRB, 0.61615726E-08_JPRB, &
  & 0.62412777E-08_JPRB, 0.63302936E-08_JPRB, 0.64180194E-08_JPRB, 0.64997026E-08_JPRB, 0.65668195E-08_JPRB, 0.66272614E-08_JPRB, &
  & 0.66748660E-08_JPRB, 0.67000694E-08_JPRB, 0.66973382E-08_JPRB, 0.66799153E-08_JPRB, 0.66310046E-08_JPRB, 0.65681296E-08_JPRB, &
  & 0.64770491E-08_JPRB, 0.63682650E-08_JPRB, 0.62476380E-08_JPRB, 0.61317520E-08_JPRB, 0.60220775E-08_JPRB, 0.58678560E-08_JPRB, &
  & 0.57257754E-08_JPRB, 0.56158913E-08_JPRB, 0.55315610E-08_JPRB, 0.54073661E-08_JPRB /)

RGHG4(:,18, 7) = (/ &
  & 0.18144768E-09_JPRB, 0.27776503E-09_JPRB, 0.38744993E-09_JPRB, 0.56159932E-09_JPRB, 0.84742657E-09_JPRB, 0.13939132E-08_JPRB, &
  & 0.55942323E-09_JPRB, 0.92586444E-09_JPRB, 0.13064589E-08_JPRB, 0.17909758E-08_JPRB, 0.23032651E-08_JPRB, 0.27680116E-08_JPRB, &
  & 0.31953107E-08_JPRB, 0.35878147E-08_JPRB, 0.39426027E-08_JPRB, 0.42567971E-08_JPRB, 0.45147996E-08_JPRB, 0.47162114E-08_JPRB, &
  & 0.48625410E-08_JPRB, 0.49698756E-08_JPRB, 0.50350661E-08_JPRB, 0.50624926E-08_JPRB, 0.50509854E-08_JPRB, 0.50018989E-08_JPRB, &
  & 0.49113198E-08_JPRB, 0.48073914E-08_JPRB, 0.47025122E-08_JPRB, 0.46070374E-08_JPRB, 0.45398392E-08_JPRB, 0.45130086E-08_JPRB, &
  & 0.45384243E-08_JPRB, 0.46048316E-08_JPRB, 0.46982422E-08_JPRB, 0.48201048E-08_JPRB, 0.49478319E-08_JPRB, 0.50619575E-08_JPRB, &
  & 0.51566529E-08_JPRB, 0.52352207E-08_JPRB, 0.52714983E-08_JPRB, 0.52870490E-08_JPRB, 0.52942850E-08_JPRB, 0.53210822E-08_JPRB, &
  & 0.53662723E-08_JPRB, 0.54337073E-08_JPRB, 0.55129474E-08_JPRB, 0.55991696E-08_JPRB, 0.56862444E-08_JPRB, 0.57741993E-08_JPRB, &
  & 0.58556595E-08_JPRB, 0.59189422E-08_JPRB, 0.59570096E-08_JPRB, 0.59790293E-08_JPRB, 0.59702279E-08_JPRB, 0.59464118E-08_JPRB, &
  & 0.58939849E-08_JPRB, 0.58238587E-08_JPRB, 0.57454788E-08_JPRB, 0.56801110E-08_JPRB, 0.56204588E-08_JPRB, 0.54916698E-08_JPRB, &
  & 0.53688618E-08_JPRB, 0.52729523E-08_JPRB, 0.51993947E-08_JPRB, 0.50829558E-08_JPRB /)

RGHG4(:,19, 7) = (/ &
  & 0.13633029E-09_JPRB, 0.21296184E-09_JPRB, 0.30433434E-09_JPRB, 0.45090007E-09_JPRB, 0.68537487E-09_JPRB, 0.11379092E-08_JPRB, &
  & 0.49182824E-09_JPRB, 0.86298901E-09_JPRB, 0.12063369E-08_JPRB, 0.16067780E-08_JPRB, 0.20926247E-08_JPRB, 0.25468994E-08_JPRB, &
  & 0.29433940E-08_JPRB, 0.32814269E-08_JPRB, 0.35692322E-08_JPRB, 0.38032217E-08_JPRB, 0.39676538E-08_JPRB, 0.40697810E-08_JPRB, &
  & 0.41197930E-08_JPRB, 0.41342965E-08_JPRB, 0.41109005E-08_JPRB, 0.40513868E-08_JPRB, 0.39568544E-08_JPRB, 0.38276995E-08_JPRB, &
  & 0.36718586E-08_JPRB, 0.35117886E-08_JPRB, 0.33614447E-08_JPRB, 0.32493830E-08_JPRB, 0.31931819E-08_JPRB, 0.32074094E-08_JPRB, &
  & 0.32877123E-08_JPRB, 0.34290437E-08_JPRB, 0.36064316E-08_JPRB, 0.38138741E-08_JPRB, 0.40271591E-08_JPRB, 0.42078141E-08_JPRB, &
  & 0.43379003E-08_JPRB, 0.44060968E-08_JPRB, 0.44168802E-08_JPRB, 0.43942792E-08_JPRB, 0.43587369E-08_JPRB, 0.43382129E-08_JPRB, &
  & 0.43415684E-08_JPRB, 0.43773083E-08_JPRB, 0.44350488E-08_JPRB, 0.45134039E-08_JPRB, 0.46048036E-08_JPRB, 0.47086237E-08_JPRB, &
  & 0.48152207E-08_JPRB, 0.49126774E-08_JPRB, 0.49914295E-08_JPRB, 0.50575131E-08_JPRB, 0.50973976E-08_JPRB, 0.51211613E-08_JPRB, &
  & 0.51163433E-08_JPRB, 0.50927227E-08_JPRB, 0.50636273E-08_JPRB, 0.50555702E-08_JPRB, 0.50526050E-08_JPRB, 0.49596931E-08_JPRB, &
  & 0.48639599E-08_JPRB, 0.47891375E-08_JPRB, 0.47344173E-08_JPRB, 0.46339168E-08_JPRB /)

RGHG4(:,20, 7) = (/ &
  & 0.10451862E-09_JPRB, 0.16653051E-09_JPRB, 0.23900565E-09_JPRB, 0.36005432E-09_JPRB, 0.55077304E-09_JPRB, 0.91992680E-09_JPRB, &
  & 0.42513704E-09_JPRB, 0.78700918E-09_JPRB, 0.10861736E-08_JPRB, 0.14248863E-08_JPRB, 0.18134018E-08_JPRB, 0.22583071E-08_JPRB, &
  & 0.26148221E-08_JPRB, 0.29026188E-08_JPRB, 0.31186462E-08_JPRB, 0.32782099E-08_JPRB, 0.33794880E-08_JPRB, 0.34174392E-08_JPRB, &
  & 0.34050822E-08_JPRB, 0.33607148E-08_JPRB, 0.32870695E-08_JPRB, 0.31849965E-08_JPRB, 0.30520633E-08_JPRB, 0.28941456E-08_JPRB, &
  & 0.27133733E-08_JPRB, 0.25333602E-08_JPRB, 0.23773157E-08_JPRB, 0.22663980E-08_JPRB, 0.22165878E-08_JPRB, 0.22359974E-08_JPRB, &
  & 0.23234423E-08_JPRB, 0.24750049E-08_JPRB, 0.26717688E-08_JPRB, 0.28983378E-08_JPRB, 0.31281999E-08_JPRB, 0.33214127E-08_JPRB, &
  & 0.34588747E-08_JPRB, 0.35231662E-08_JPRB, 0.35296648E-08_JPRB, 0.34915768E-08_JPRB, 0.34309977E-08_JPRB, 0.33843672E-08_JPRB, &
  & 0.33632916E-08_JPRB, 0.33726670E-08_JPRB, 0.34091558E-08_JPRB, 0.34745407E-08_JPRB, 0.35598002E-08_JPRB, 0.36652172E-08_JPRB, &
  & 0.37798760E-08_JPRB, 0.38926271E-08_JPRB, 0.39936330E-08_JPRB, 0.40890611E-08_JPRB, 0.41632808E-08_JPRB, 0.42249031E-08_JPRB, &
  & 0.42624437E-08_JPRB, 0.42839661E-08_JPRB, 0.43034154E-08_JPRB, 0.43483577E-08_JPRB, 0.43945678E-08_JPRB, 0.43369957E-08_JPRB, &
  & 0.42696113E-08_JPRB, 0.42163228E-08_JPRB, 0.41756518E-08_JPRB, 0.40979242E-08_JPRB /)

RGHG4(:,21, 7) = (/ &
  & 0.81292299E-10_JPRB, 0.13035066E-09_JPRB, 0.18803993E-09_JPRB, 0.28361569E-09_JPRB, 0.43818130E-09_JPRB, 0.72979806E-09_JPRB, &
  & 0.35948802E-09_JPRB, 0.66817801E-09_JPRB, 0.93740060E-09_JPRB, 0.12462870E-08_JPRB, 0.15709458E-08_JPRB, 0.19330861E-08_JPRB, &
  & 0.22544904E-08_JPRB, 0.25036100E-08_JPRB, 0.26755416E-08_JPRB, 0.27771645E-08_JPRB, 0.28265210E-08_JPRB, 0.28273803E-08_JPRB, &
  & 0.27925857E-08_JPRB, 0.27312985E-08_JPRB, 0.26432254E-08_JPRB, 0.25309779E-08_JPRB, 0.23927735E-08_JPRB, 0.22314117E-08_JPRB, &
  & 0.20528179E-08_JPRB, 0.18821529E-08_JPRB, 0.17358434E-08_JPRB, 0.16315276E-08_JPRB, 0.15811389E-08_JPRB, 0.15881297E-08_JPRB, &
  & 0.16532621E-08_JPRB, 0.17747279E-08_JPRB, 0.19437700E-08_JPRB, 0.21451187E-08_JPRB, 0.23510689E-08_JPRB, 0.25277891E-08_JPRB, &
  & 0.26552289E-08_JPRB, 0.27201621E-08_JPRB, 0.27145139E-08_JPRB, 0.26733578E-08_JPRB, 0.26153171E-08_JPRB, 0.25667548E-08_JPRB, &
  & 0.25401632E-08_JPRB, 0.25412565E-08_JPRB, 0.25706182E-08_JPRB, 0.26235074E-08_JPRB, 0.26963278E-08_JPRB, 0.27919715E-08_JPRB, &
  & 0.29004599E-08_JPRB, 0.30121221E-08_JPRB, 0.31211091E-08_JPRB, 0.32283478E-08_JPRB, 0.33222258E-08_JPRB, 0.34057952E-08_JPRB, &
  & 0.34697833E-08_JPRB, 0.35215326E-08_JPRB, 0.35753986E-08_JPRB, 0.36590790E-08_JPRB, 0.37405155E-08_JPRB, 0.37132593E-08_JPRB, &
  & 0.36712231E-08_JPRB, 0.36387513E-08_JPRB, 0.36150865E-08_JPRB, 0.35560879E-08_JPRB /)

RGHG4(:,22, 7) = (/ &
  & 0.62413907E-10_JPRB, 0.10149912E-09_JPRB, 0.14726662E-09_JPRB, 0.21993346E-09_JPRB, 0.34044337E-09_JPRB, 0.56948374E-09_JPRB, &
  & 0.29429431E-09_JPRB, 0.57261956E-09_JPRB, 0.80302293E-09_JPRB, 0.10667357E-08_JPRB, 0.13352440E-08_JPRB, 0.16135415E-08_JPRB, &
  & 0.18985871E-08_JPRB, 0.21116995E-08_JPRB, 0.22538893E-08_JPRB, 0.23288884E-08_JPRB, 0.23508748E-08_JPRB, 0.23325839E-08_JPRB, &
  & 0.22871813E-08_JPRB, 0.22196729E-08_JPRB, 0.21303326E-08_JPRB, 0.20220761E-08_JPRB, 0.18983193E-08_JPRB, 0.17579818E-08_JPRB, &
  & 0.16074391E-08_JPRB, 0.14576772E-08_JPRB, 0.13286353E-08_JPRB, 0.12313027E-08_JPRB, 0.11752675E-08_JPRB, 0.11644473E-08_JPRB, &
  & 0.11996234E-08_JPRB, 0.12768900E-08_JPRB, 0.13912768E-08_JPRB, 0.15337550E-08_JPRB, 0.16849590E-08_JPRB, 0.18224641E-08_JPRB, &
  & 0.19211901E-08_JPRB, 0.19696229E-08_JPRB, 0.19791504E-08_JPRB, 0.19519828E-08_JPRB, 0.19144697E-08_JPRB, 0.18864299E-08_JPRB, &
  & 0.18710089E-08_JPRB, 0.18738506E-08_JPRB, 0.18996247E-08_JPRB, 0.19482833E-08_JPRB, 0.20179642E-08_JPRB, 0.21055191E-08_JPRB, &
  & 0.22027362E-08_JPRB, 0.23063633E-08_JPRB, 0.24093465E-08_JPRB, 0.25126810E-08_JPRB, 0.26057438E-08_JPRB, 0.26916036E-08_JPRB, &
  & 0.27653408E-08_JPRB, 0.28333222E-08_JPRB, 0.29086336E-08_JPRB, 0.30155229E-08_JPRB, 0.31155634E-08_JPRB, 0.31115863E-08_JPRB, &
  & 0.30893250E-08_JPRB, 0.30723648E-08_JPRB, 0.30601854E-08_JPRB, 0.30194915E-08_JPRB /)

RGHG4(:,23, 7) = (/ &
  & 0.46545146E-10_JPRB, 0.76181020E-10_JPRB, 0.11095349E-09_JPRB, 0.16746006E-09_JPRB, 0.26131319E-09_JPRB, 0.43902754E-09_JPRB, &
  & 0.23910959E-09_JPRB, 0.48551907E-09_JPRB, 0.67748940E-09_JPRB, 0.89176733E-09_JPRB, 0.11303224E-08_JPRB, 0.13553790E-08_JPRB, &
  & 0.15703340E-08_JPRB, 0.17578877E-08_JPRB, 0.18821880E-08_JPRB, 0.19473814E-08_JPRB, 0.19632913E-08_JPRB, 0.19422504E-08_JPRB, &
  & 0.18930184E-08_JPRB, 0.18254859E-08_JPRB, 0.17449941E-08_JPRB, 0.16516123E-08_JPRB, 0.15463404E-08_JPRB, 0.14289513E-08_JPRB, &
  & 0.13006694E-08_JPRB, 0.11730047E-08_JPRB, 0.10571104E-08_JPRB, 0.96583541E-09_JPRB, 0.90785185E-09_JPRB, 0.88336349E-09_JPRB, &
  & 0.89235991E-09_JPRB, 0.93191932E-09_JPRB, 0.99888586E-09_JPRB, 0.10855901E-08_JPRB, 0.11825564E-08_JPRB, 0.12701692E-08_JPRB, &
  & 0.13387308E-08_JPRB, 0.13807844E-08_JPRB, 0.13945368E-08_JPRB, 0.13889043E-08_JPRB, 0.13743097E-08_JPRB, 0.13643839E-08_JPRB, &
  & 0.13639742E-08_JPRB, 0.13791744E-08_JPRB, 0.14115795E-08_JPRB, 0.14608921E-08_JPRB, 0.15265674E-08_JPRB, 0.16061583E-08_JPRB, &
  & 0.16953906E-08_JPRB, 0.17872654E-08_JPRB, 0.18779724E-08_JPRB, 0.19691113E-08_JPRB, 0.20538020E-08_JPRB, 0.21349222E-08_JPRB, &
  & 0.22079039E-08_JPRB, 0.22779520E-08_JPRB, 0.23581814E-08_JPRB, 0.24707514E-08_JPRB, 0.25755293E-08_JPRB, 0.25887008E-08_JPRB, &
  & 0.25822362E-08_JPRB, 0.25764824E-08_JPRB, 0.25718323E-08_JPRB, 0.25405436E-08_JPRB /)

RGHG4(:,24, 7) = (/ &
  & 0.34876192E-10_JPRB, 0.57622154E-10_JPRB, 0.85134920E-10_JPRB, 0.12784072E-09_JPRB, 0.20030830E-09_JPRB, 0.33981898E-09_JPRB, &
  & 0.19262282E-09_JPRB, 0.40736542E-09_JPRB, 0.56467786E-09_JPRB, 0.74224915E-09_JPRB, 0.94155850E-09_JPRB, 0.11267397E-08_JPRB, &
  & 0.12940080E-08_JPRB, 0.14429916E-08_JPRB, 0.15487051E-08_JPRB, 0.16055236E-08_JPRB, 0.16208529E-08_JPRB, 0.16050387E-08_JPRB, &
  & 0.15661715E-08_JPRB, 0.15108383E-08_JPRB, 0.14423435E-08_JPRB, 0.13626640E-08_JPRB, 0.12731786E-08_JPRB, 0.11743017E-08_JPRB, &
  & 0.10681903E-08_JPRB, 0.96155950E-09_JPRB, 0.86381541E-09_JPRB, 0.78268408E-09_JPRB, 0.72280876E-09_JPRB, 0.68831257E-09_JPRB, &
  & 0.67803352E-09_JPRB, 0.68890665E-09_JPRB, 0.71804185E-09_JPRB, 0.76159556E-09_JPRB, 0.81292101E-09_JPRB, 0.86265850E-09_JPRB, &
  & 0.90520941E-09_JPRB, 0.93525132E-09_JPRB, 0.95529684E-09_JPRB, 0.96598252E-09_JPRB, 0.97398090E-09_JPRB, 0.98540931E-09_JPRB, &
  & 0.10039191E-08_JPRB, 0.10311300E-08_JPRB, 0.10698736E-08_JPRB, 0.11193975E-08_JPRB, 0.11781094E-08_JPRB, 0.12479391E-08_JPRB, &
  & 0.13255091E-08_JPRB, 0.14047224E-08_JPRB, 0.14837792E-08_JPRB, 0.15613906E-08_JPRB, 0.16342535E-08_JPRB, 0.17039019E-08_JPRB, &
  & 0.17689720E-08_JPRB, 0.18353394E-08_JPRB, 0.19136537E-08_JPRB, 0.20218456E-08_JPRB, 0.21213376E-08_JPRB, 0.21424604E-08_JPRB, &
  & 0.21450970E-08_JPRB, 0.21467637E-08_JPRB, 0.21494639E-08_JPRB, 0.21342490E-08_JPRB /)

RGHG4(:,25, 7) = (/ &
  & 0.25887657E-10_JPRB, 0.42976279E-10_JPRB, 0.63470403E-10_JPRB, 0.96706275E-10_JPRB, 0.15269822E-09_JPRB, 0.26080552E-09_JPRB, &
  & 0.15467384E-09_JPRB, 0.32731370E-09_JPRB, 0.45869022E-09_JPRB, 0.61915140E-09_JPRB, 0.78197715E-09_JPRB, 0.93342190E-09_JPRB, &
  & 0.10634260E-08_JPRB, 0.11728393E-08_JPRB, 0.12603778E-08_JPRB, 0.13081971E-08_JPRB, 0.13230399E-08_JPRB, 0.13117610E-08_JPRB, &
  & 0.12802720E-08_JPRB, 0.12342886E-08_JPRB, 0.11776813E-08_JPRB, 0.11126083E-08_JPRB, 0.10408953E-08_JPRB, 0.96291097E-09_JPRB, &
  & 0.87944535E-09_JPRB, 0.79520407E-09_JPRB, 0.71496514E-09_JPRB, 0.64506117E-09_JPRB, 0.59074534E-09_JPRB, 0.55157051E-09_JPRB, &
  & 0.52854654E-09_JPRB, 0.51987753E-09_JPRB, 0.52319821E-09_JPRB, 0.53698906E-09_JPRB, 0.55724353E-09_JPRB, 0.58104560E-09_JPRB, &
  & 0.60481420E-09_JPRB, 0.62719036E-09_JPRB, 0.64981398E-09_JPRB, 0.67090228E-09_JPRB, 0.69354350E-09_JPRB, 0.72058692E-09_JPRB, &
  & 0.75224543E-09_JPRB, 0.78949941E-09_JPRB, 0.83216112E-09_JPRB, 0.88054575E-09_JPRB, 0.93444874E-09_JPRB, 0.99540287E-09_JPRB, &
  & 0.10593062E-08_JPRB, 0.11262351E-08_JPRB, 0.11941871E-08_JPRB, 0.12617934E-08_JPRB, 0.13249172E-08_JPRB, 0.13854008E-08_JPRB, &
  & 0.14435320E-08_JPRB, 0.15034411E-08_JPRB, 0.15758276E-08_JPRB, 0.16759756E-08_JPRB, 0.17674887E-08_JPRB, 0.17926738E-08_JPRB, &
  & 0.18009199E-08_JPRB, 0.18081148E-08_JPRB, 0.18153860E-08_JPRB, 0.17978378E-08_JPRB /)

RGHG4(:,26, 7) = (/ &
  & 0.20576122E-10_JPRB, 0.33986421E-10_JPRB, 0.50496909E-10_JPRB, 0.76230695E-10_JPRB, 0.12012756E-09_JPRB, 0.20249181E-09_JPRB, &
  & 0.12485958E-09_JPRB, 0.27119618E-09_JPRB, 0.37806655E-09_JPRB, 0.50736970E-09_JPRB, 0.63525285E-09_JPRB, 0.76093393E-09_JPRB, &
  & 0.86476237E-09_JPRB, 0.94661001E-09_JPRB, 0.10079720E-08_JPRB, 0.10449648E-08_JPRB, 0.10574049E-08_JPRB, 0.10493399E-08_JPRB, &
  & 0.10254019E-08_JPRB, 0.98968789E-09_JPRB, 0.94573660E-09_JPRB, 0.89546448E-09_JPRB, 0.84114155E-09_JPRB, 0.78323348E-09_JPRB, &
  & 0.72232681E-09_JPRB, 0.65993105E-09_JPRB, 0.59880179E-09_JPRB, 0.54152016E-09_JPRB, 0.49117060E-09_JPRB, 0.45157744E-09_JPRB, &
  & 0.42185003E-09_JPRB, 0.40124828E-09_JPRB, 0.38908474E-09_JPRB, 0.38499781E-09_JPRB, 0.38730166E-09_JPRB, 0.39519402E-09_JPRB, &
  & 0.40789988E-09_JPRB, 0.42528356E-09_JPRB, 0.44738088E-09_JPRB, 0.47422893E-09_JPRB, 0.50440774E-09_JPRB, 0.54020555E-09_JPRB, &
  & 0.57957128E-09_JPRB, 0.62348032E-09_JPRB, 0.67055705E-09_JPRB, 0.72029088E-09_JPRB, 0.77091489E-09_JPRB, 0.82325879E-09_JPRB, &
  & 0.87669610E-09_JPRB, 0.93079716E-09_JPRB, 0.98586039E-09_JPRB, 0.10424845E-08_JPRB, 0.10962419E-08_JPRB, 0.11477446E-08_JPRB, &
  & 0.11975588E-08_JPRB, 0.12508835E-08_JPRB, 0.13169297E-08_JPRB, 0.14083172E-08_JPRB, 0.14915216E-08_JPRB, 0.15179489E-08_JPRB, &
  & 0.15286636E-08_JPRB, 0.15376733E-08_JPRB, 0.15462307E-08_JPRB, 0.15349353E-08_JPRB /)

RGHG4(:,27, 7) = (/ &
  & 0.16875746E-10_JPRB, 0.27534804E-10_JPRB, 0.40583138E-10_JPRB, 0.60694512E-10_JPRB, 0.94493788E-10_JPRB, 0.15708188E-09_JPRB, &
  & 0.10068037E-09_JPRB, 0.22380428E-09_JPRB, 0.31109890E-09_JPRB, 0.41512346E-09_JPRB, 0.51804994E-09_JPRB, 0.61638283E-09_JPRB, &
  & 0.69740963E-09_JPRB, 0.75813539E-09_JPRB, 0.80103341E-09_JPRB, 0.82776663E-09_JPRB, 0.83600232E-09_JPRB, 0.82844476E-09_JPRB, &
  & 0.80895574E-09_JPRB, 0.78086021E-09_JPRB, 0.74698581E-09_JPRB, 0.70936357E-09_JPRB, 0.67072115E-09_JPRB, 0.63091510E-09_JPRB, &
  & 0.58915517E-09_JPRB, 0.54624183E-09_JPRB, 0.50198368E-09_JPRB, 0.45758919E-09_JPRB, 0.41497236E-09_JPRB, 0.37620901E-09_JPRB, &
  & 0.34299460E-09_JPRB, 0.31601047E-09_JPRB, 0.29561248E-09_JPRB, 0.28228331E-09_JPRB, 0.27573219E-09_JPRB, 0.27594252E-09_JPRB, &
  & 0.28301589E-09_JPRB, 0.29726524E-09_JPRB, 0.31805150E-09_JPRB, 0.34614198E-09_JPRB, 0.37901585E-09_JPRB, 0.41771875E-09_JPRB, &
  & 0.46011639E-09_JPRB, 0.50578458E-09_JPRB, 0.55342669E-09_JPRB, 0.60162331E-09_JPRB, 0.64904038E-09_JPRB, 0.69569023E-09_JPRB, &
  & 0.74099160E-09_JPRB, 0.78531964E-09_JPRB, 0.82876256E-09_JPRB, 0.87347074E-09_JPRB, 0.91878988E-09_JPRB, 0.96300090E-09_JPRB, &
  & 0.10067178E-08_JPRB, 0.10540699E-08_JPRB, 0.11137085E-08_JPRB, 0.11964331E-08_JPRB, 0.12718807E-08_JPRB, 0.12986696E-08_JPRB, &
  & 0.13111749E-08_JPRB, 0.13215870E-08_JPRB, 0.13331733E-08_JPRB, 0.13435566E-08_JPRB /)

RGHG4(:,28, 7) = (/ &
  & 0.14210492E-10_JPRB, 0.22748303E-10_JPRB, 0.33059059E-10_JPRB, 0.48759351E-10_JPRB, 0.74784179E-10_JPRB, 0.12326856E-09_JPRB, &
  & 0.81278533E-10_JPRB, 0.18327377E-09_JPRB, 0.25365551E-09_JPRB, 0.33165742E-09_JPRB, 0.41959081E-09_JPRB, 0.49503873E-09_JPRB, &
  & 0.55982419E-09_JPRB, 0.60631772E-09_JPRB, 0.63635680E-09_JPRB, 0.65377814E-09_JPRB, 0.65825706E-09_JPRB, 0.65081529E-09_JPRB, &
  & 0.63462774E-09_JPRB, 0.61250277E-09_JPRB, 0.58679217E-09_JPRB, 0.55957855E-09_JPRB, 0.53279603E-09_JPRB, 0.50649462E-09_JPRB, &
  & 0.47966225E-09_JPRB, 0.45144449E-09_JPRB, 0.42072396E-09_JPRB, 0.38743755E-09_JPRB, 0.35180933E-09_JPRB, 0.31614583E-09_JPRB, &
  & 0.28319819E-09_JPRB, 0.25393240E-09_JPRB, 0.23009372E-09_JPRB, 0.21290417E-09_JPRB, 0.20279170E-09_JPRB, 0.19997690E-09_JPRB, &
  & 0.20463777E-09_JPRB, 0.21708756E-09_JPRB, 0.23673277E-09_JPRB, 0.26358440E-09_JPRB, 0.29694922E-09_JPRB, 0.33533676E-09_JPRB, &
  & 0.37788542E-09_JPRB, 0.42259671E-09_JPRB, 0.46847348E-09_JPRB, 0.51321447E-09_JPRB, 0.55567057E-09_JPRB, 0.59641730E-09_JPRB, &
  & 0.63504541E-09_JPRB, 0.67197731E-09_JPRB, 0.70801148E-09_JPRB, 0.74469469E-09_JPRB, 0.78236878E-09_JPRB, 0.81956308E-09_JPRB, &
  & 0.85701829E-09_JPRB, 0.89879604E-09_JPRB, 0.95250841E-09_JPRB, 0.10275114E-08_JPRB, 0.10964611E-08_JPRB, 0.11231018E-08_JPRB, &
  & 0.11365263E-08_JPRB, 0.11481894E-08_JPRB, 0.11606898E-08_JPRB, 0.11815700E-08_JPRB /)

RGHG4(:,29, 7) = (/ &
  & 0.12065633E-10_JPRB, 0.18987988E-10_JPRB, 0.27318602E-10_JPRB, 0.39829577E-10_JPRB, 0.60271226E-10_JPRB, 0.97692986E-10_JPRB, &
  & 0.66015651E-10_JPRB, 0.15080645E-09_JPRB, 0.20766711E-09_JPRB, 0.27062624E-09_JPRB, 0.34059847E-09_JPRB, 0.39952641E-09_JPRB, &
  & 0.44926710E-09_JPRB, 0.48498983E-09_JPRB, 0.50752019E-09_JPRB, 0.51858379E-09_JPRB, 0.51998433E-09_JPRB, 0.51270316E-09_JPRB, &
  & 0.49874149E-09_JPRB, 0.48051979E-09_JPRB, 0.46043319E-09_JPRB, 0.44050860E-09_JPRB, 0.42221970E-09_JPRB, 0.40546352E-09_JPRB, &
  & 0.38940443E-09_JPRB, 0.37218983E-09_JPRB, 0.35199665E-09_JPRB, 0.32722400E-09_JPRB, 0.29874453E-09_JPRB, 0.26708044E-09_JPRB, &
  & 0.23519009E-09_JPRB, 0.20601407E-09_JPRB, 0.18143756E-09_JPRB, 0.16325909E-09_JPRB, 0.15222441E-09_JPRB, 0.14849311E-09_JPRB, &
  & 0.15210022E-09_JPRB, 0.16316441E-09_JPRB, 0.18158562E-09_JPRB, 0.20672700E-09_JPRB, 0.23853960E-09_JPRB, 0.27593322E-09_JPRB, &
  & 0.31662942E-09_JPRB, 0.35970779E-09_JPRB, 0.40253231E-09_JPRB, 0.44320617E-09_JPRB, 0.48074239E-09_JPRB, 0.51557431E-09_JPRB, &
  & 0.54794835E-09_JPRB, 0.57874627E-09_JPRB, 0.60848349E-09_JPRB, 0.63892480E-09_JPRB, 0.67038602E-09_JPRB, 0.70193729E-09_JPRB, &
  & 0.73456452E-09_JPRB, 0.77156642E-09_JPRB, 0.82008955E-09_JPRB, 0.88735375E-09_JPRB, 0.94915265E-09_JPRB, 0.97466157E-09_JPRB, &
  & 0.98815278E-09_JPRB, 0.10003944E-08_JPRB, 0.10152502E-08_JPRB, 0.10398161E-08_JPRB /)

RGHG4(:,30, 7) = (/ &
  & 0.97707155E-11_JPRB, 0.15351255E-10_JPRB, 0.21917858E-10_JPRB, 0.31812677E-10_JPRB, 0.47805763E-10_JPRB, 0.77269045E-10_JPRB, &
  & 0.54160173E-10_JPRB, 0.12493015E-09_JPRB, 0.17183115E-09_JPRB, 0.22316000E-09_JPRB, 0.27923122E-09_JPRB, 0.32689249E-09_JPRB, &
  & 0.36518741E-09_JPRB, 0.39369416E-09_JPRB, 0.41033796E-09_JPRB, 0.41761317E-09_JPRB, 0.41688733E-09_JPRB, 0.40937762E-09_JPRB, &
  & 0.39682205E-09_JPRB, 0.38130046E-09_JPRB, 0.36507133E-09_JPRB, 0.34969067E-09_JPRB, 0.33677872E-09_JPRB, 0.32602329E-09_JPRB, &
  & 0.31645145E-09_JPRB, 0.30621453E-09_JPRB, 0.29285241E-09_JPRB, 0.27497302E-09_JPRB, 0.25158883E-09_JPRB, 0.22456333E-09_JPRB, &
  & 0.19547644E-09_JPRB, 0.16772982E-09_JPRB, 0.14416514E-09_JPRB, 0.12659916E-09_JPRB, 0.11600323E-09_JPRB, 0.11246327E-09_JPRB, &
  & 0.11579424E-09_JPRB, 0.12589266E-09_JPRB, 0.14288098E-09_JPRB, 0.16646655E-09_JPRB, 0.19605859E-09_JPRB, 0.23098652E-09_JPRB, &
  & 0.26945407E-09_JPRB, 0.30913017E-09_JPRB, 0.34821651E-09_JPRB, 0.38492881E-09_JPRB, 0.41780882E-09_JPRB, 0.44790741E-09_JPRB, &
  & 0.47541454E-09_JPRB, 0.50108340E-09_JPRB, 0.52607391E-09_JPRB, 0.55145533E-09_JPRB, 0.57795640E-09_JPRB, 0.60526273E-09_JPRB, &
  & 0.63392824E-09_JPRB, 0.66717654E-09_JPRB, 0.71086315E-09_JPRB, 0.77121931E-09_JPRB, 0.82697188E-09_JPRB, 0.85122603E-09_JPRB, &
  & 0.86507762E-09_JPRB, 0.87817215E-09_JPRB, 0.89676033E-09_JPRB, 0.92975228E-09_JPRB /)

RGHG4(:,31, 7) = (/ &
  & 0.76021620E-11_JPRB, 0.11920353E-10_JPRB, 0.17283792E-10_JPRB, 0.25022763E-10_JPRB, 0.37826870E-10_JPRB, 0.61471925E-10_JPRB, &
  & 0.44287018E-10_JPRB, 0.10380556E-09_JPRB, 0.14297494E-09_JPRB, 0.18568247E-09_JPRB, 0.23074807E-09_JPRB, 0.26941194E-09_JPRB, &
  & 0.30011998E-09_JPRB, 0.32291583E-09_JPRB, 0.33599543E-09_JPRB, 0.34059297E-09_JPRB, 0.33831821E-09_JPRB, 0.33067618E-09_JPRB, &
  & 0.31885058E-09_JPRB, 0.30488165E-09_JPRB, 0.29082317E-09_JPRB, 0.27829172E-09_JPRB, 0.26842464E-09_JPRB, 0.26125507E-09_JPRB, &
  & 0.25555710E-09_JPRB, 0.24945965E-09_JPRB, 0.24081040E-09_JPRB, 0.22786546E-09_JPRB, 0.20950741E-09_JPRB, 0.18624541E-09_JPRB, &
  & 0.16042244E-09_JPRB, 0.13507374E-09_JPRB, 0.11343746E-09_JPRB, 0.97408373E-10_JPRB, 0.88013027E-10_JPRB, 0.84974153E-10_JPRB, &
  & 0.88170124E-10_JPRB, 0.97232278E-10_JPRB, 0.11231472E-09_JPRB, 0.13353103E-09_JPRB, 0.16067274E-09_JPRB, 0.19272554E-09_JPRB, &
  & 0.22789025E-09_JPRB, 0.26437555E-09_JPRB, 0.29950833E-09_JPRB, 0.33189354E-09_JPRB, 0.36068912E-09_JPRB, 0.38668854E-09_JPRB, &
  & 0.41069859E-09_JPRB, 0.43245618E-09_JPRB, 0.45369550E-09_JPRB, 0.47517718E-09_JPRB, 0.49746435E-09_JPRB, 0.52184179E-09_JPRB, &
  & 0.54786059E-09_JPRB, 0.57814470E-09_JPRB, 0.61785471E-09_JPRB, 0.67212286E-09_JPRB, 0.72245349E-09_JPRB, 0.74578643E-09_JPRB, &
  & 0.76015100E-09_JPRB, 0.77435519E-09_JPRB, 0.79342893E-09_JPRB, 0.82063889E-09_JPRB /)

RGHG4(:,32, 7) = (/ &
  & 0.56663433E-11_JPRB, 0.90941647E-11_JPRB, 0.13329659E-10_JPRB, 0.19517457E-10_JPRB, 0.29836966E-10_JPRB, 0.48768000E-10_JPRB, &
  & 0.36838074E-10_JPRB, 0.86986043E-10_JPRB, 0.11816753E-09_JPRB, 0.15635269E-09_JPRB, 0.19168148E-09_JPRB, 0.22589321E-09_JPRB, &
  & 0.25099456E-09_JPRB, 0.26901217E-09_JPRB, 0.27909655E-09_JPRB, 0.28216465E-09_JPRB, 0.27906805E-09_JPRB, 0.27123581E-09_JPRB, &
  & 0.25998942E-09_JPRB, 0.24719082E-09_JPRB, 0.23461263E-09_JPRB, 0.22381481E-09_JPRB, 0.21574942E-09_JPRB, 0.21028869E-09_JPRB, &
  & 0.20638112E-09_JPRB, 0.20231646E-09_JPRB, 0.19626895E-09_JPRB, 0.18625308E-09_JPRB, 0.17124974E-09_JPRB, 0.15145889E-09_JPRB, &
  & 0.12902523E-09_JPRB, 0.10664175E-09_JPRB, 0.87664175E-10_JPRB, 0.73830421E-10_JPRB, 0.65896615E-10_JPRB, 0.63705159E-10_JPRB, &
  & 0.66665395E-10_JPRB, 0.74622336E-10_JPRB, 0.87754942E-10_JPRB, 0.10628660E-09_JPRB, 0.13037453E-09_JPRB, 0.15899400E-09_JPRB, &
  & 0.19050755E-09_JPRB, 0.22273514E-09_JPRB, 0.25448013E-09_JPRB, 0.28336863E-09_JPRB, 0.30921296E-09_JPRB, 0.33220340E-09_JPRB, &
  & 0.35346592E-09_JPRB, 0.37284498E-09_JPRB, 0.39141460E-09_JPRB, 0.41042253E-09_JPRB, 0.43011805E-09_JPRB, 0.45183854E-09_JPRB, &
  & 0.47545512E-09_JPRB, 0.50300208E-09_JPRB, 0.53900157E-09_JPRB, 0.58801947E-09_JPRB, 0.63393651E-09_JPRB, 0.65627276E-09_JPRB, &
  & 0.67029171E-09_JPRB, 0.68501987E-09_JPRB, 0.70372913E-09_JPRB, 0.73418177E-09_JPRB /)

RGHG4(:,33, 7) = (/ &
  & 0.41068555E-11_JPRB, 0.67316508E-11_JPRB, 0.10213797E-10_JPRB, 0.15201613E-10_JPRB, 0.23620727E-10_JPRB, 0.39359661E-10_JPRB, &
  & 0.30667479E-10_JPRB, 0.71173137E-10_JPRB, 0.99804574E-10_JPRB, 0.13219022E-09_JPRB, 0.16193870E-09_JPRB, 0.19033097E-09_JPRB, &
  & 0.21128319E-09_JPRB, 0.22581960E-09_JPRB, 0.23429234E-09_JPRB, 0.23623659E-09_JPRB, 0.23259208E-09_JPRB, 0.22462043E-09_JPRB, &
  & 0.21364388E-09_JPRB, 0.20131756E-09_JPRB, 0.18939625E-09_JPRB, 0.17925135E-09_JPRB, 0.17178094E-09_JPRB, 0.16673968E-09_JPRB, &
  & 0.16318802E-09_JPRB, 0.15984133E-09_JPRB, 0.15492993E-09_JPRB, 0.14700909E-09_JPRB, 0.13487776E-09_JPRB, 0.11841499E-09_JPRB, &
  & 0.99477343E-10_JPRB, 0.80706795E-10_JPRB, 0.64777433E-10_JPRB, 0.53795430E-10_JPRB, 0.47468453E-10_JPRB, 0.46189549E-10_JPRB, &
  & 0.48830773E-10_JPRB, 0.55573220E-10_JPRB, 0.66482410E-10_JPRB, 0.82026545E-10_JPRB, 0.10232207E-09_JPRB, 0.12695879E-09_JPRB, &
  & 0.15459478E-09_JPRB, 0.18292269E-09_JPRB, 0.21075713E-09_JPRB, 0.23675870E-09_JPRB, 0.26019722E-09_JPRB, 0.28118838E-09_JPRB, &
  & 0.30046077E-09_JPRB, 0.31860353E-09_JPRB, 0.33574399E-09_JPRB, 0.35335310E-09_JPRB, 0.37169978E-09_JPRB, 0.39143574E-09_JPRB, &
  & 0.41276896E-09_JPRB, 0.43777140E-09_JPRB, 0.47047649E-09_JPRB, 0.51458293E-09_JPRB, 0.55599847E-09_JPRB, 0.57712224E-09_JPRB, &
  & 0.59121813E-09_JPRB, 0.60577671E-09_JPRB, 0.62367561E-09_JPRB, 0.65054540E-09_JPRB /)

RGHG4(:,34, 7) = (/ &
  & 0.29537627E-11_JPRB, 0.49579780E-11_JPRB, 0.77418428E-11_JPRB, 0.11984607E-10_JPRB, 0.19067933E-10_JPRB, 0.32310581E-10_JPRB, &
  & 0.26160607E-10_JPRB, 0.60944652E-10_JPRB, 0.85782909E-10_JPRB, 0.11342301E-09_JPRB, 0.13835984E-09_JPRB, 0.16193881E-09_JPRB, &
  & 0.17978793E-09_JPRB, 0.19210265E-09_JPRB, 0.19905973E-09_JPRB, 0.20019143E-09_JPRB, 0.19623772E-09_JPRB, 0.18823158E-09_JPRB, &
  & 0.17751560E-09_JPRB, 0.16548062E-09_JPRB, 0.15380022E-09_JPRB, 0.14389197E-09_JPRB, 0.13625137E-09_JPRB, 0.13094960E-09_JPRB, &
  & 0.12700514E-09_JPRB, 0.12366819E-09_JPRB, 0.11909408E-09_JPRB, 0.11219359E-09_JPRB, 0.10200102E-09_JPRB, 0.88417391E-10_JPRB, &
  & 0.72991412E-10_JPRB, 0.57994817E-10_JPRB, 0.45587277E-10_JPRB, 0.37291489E-10_JPRB, 0.32918758E-10_JPRB, 0.32211386E-10_JPRB, &
  & 0.34577171E-10_JPRB, 0.40097880E-10_JPRB, 0.48820389E-10_JPRB, 0.61330649E-10_JPRB, 0.77984348E-10_JPRB, 0.98388901E-10_JPRB, &
  & 0.12150347E-09_JPRB, 0.14605417E-09_JPRB, 0.17041717E-09_JPRB, 0.19390380E-09_JPRB, 0.21569881E-09_JPRB, 0.23572563E-09_JPRB, &
  & 0.25388044E-09_JPRB, 0.27118022E-09_JPRB, 0.28775082E-09_JPRB, 0.30442818E-09_JPRB, 0.32178479E-09_JPRB, 0.33975198E-09_JPRB, &
  & 0.35922285E-09_JPRB, 0.38197578E-09_JPRB, 0.41155013E-09_JPRB, 0.45119034E-09_JPRB, 0.48871773E-09_JPRB, 0.50865806E-09_JPRB, &
  & 0.52234100E-09_JPRB, 0.53628402E-09_JPRB, 0.55354582E-09_JPRB, 0.57996496E-09_JPRB /)

RGHG4(:,35, 7) = (/ &
  & 0.21495577E-11_JPRB, 0.37416229E-11_JPRB, 0.60697961E-11_JPRB, 0.97049339E-11_JPRB, 0.15711321E-10_JPRB, 0.27125566E-10_JPRB, &
  & 0.22583725E-10_JPRB, 0.52971905E-10_JPRB, 0.74221511E-10_JPRB, 0.97605028E-10_JPRB, 0.11883032E-09_JPRB, 0.13873613E-09_JPRB, &
  & 0.15399253E-09_JPRB, 0.16441357E-09_JPRB, 0.17008116E-09_JPRB, 0.17066244E-09_JPRB, 0.16654272E-09_JPRB, 0.15850586E-09_JPRB, &
  & 0.14776293E-09_JPRB, 0.13572420E-09_JPRB, 0.12386465E-09_JPRB, 0.11339611E-09_JPRB, 0.10493258E-09_JPRB, 0.98662190E-10_JPRB, &
  & 0.93860648E-10_JPRB, 0.89716228E-10_JPRB, 0.85102474E-10_JPRB, 0.78968124E-10_JPRB, 0.70752036E-10_JPRB, 0.60276090E-10_JPRB, &
  & 0.48742177E-10_JPRB, 0.37957932E-10_JPRB, 0.29384953E-10_JPRB, 0.23837394E-10_JPRB, 0.21191677E-10_JPRB, 0.21011087E-10_JPRB, &
  & 0.23007917E-10_JPRB, 0.27198395E-10_JPRB, 0.33790391E-10_JPRB, 0.43309842E-10_JPRB, 0.56116212E-10_JPRB, 0.72222464E-10_JPRB, &
  & 0.91022523E-10_JPRB, 0.11157452E-09_JPRB, 0.13280962E-09_JPRB, 0.15396040E-09_JPRB, 0.17442264E-09_JPRB, 0.19357881E-09_JPRB, &
  & 0.21123787E-09_JPRB, 0.22803734E-09_JPRB, 0.24425809E-09_JPRB, 0.26037472E-09_JPRB, 0.27696750E-09_JPRB, 0.29375297E-09_JPRB, &
  & 0.31153477E-09_JPRB, 0.33222797E-09_JPRB, 0.35899378E-09_JPRB, 0.39444870E-09_JPRB, 0.42810969E-09_JPRB, 0.44677884E-09_JPRB, &
  & 0.46001367E-09_JPRB, 0.47340099E-09_JPRB, 0.48944021E-09_JPRB, 0.51426208E-09_JPRB /)

RGHG4(:,36, 7) = (/ &
  & 0.16126052E-11_JPRB, 0.28625518E-11_JPRB, 0.47793523E-11_JPRB, 0.79194299E-11_JPRB, 0.13195971E-10_JPRB, 0.23091758E-10_JPRB, &
  & 0.19692532E-10_JPRB, 0.45978714E-10_JPRB, 0.63907907E-10_JPRB, 0.83956737E-10_JPRB, 0.10249898E-09_JPRB, 0.11972412E-09_JPRB, &
  & 0.13297896E-09_JPRB, 0.14202770E-09_JPRB, 0.14675190E-09_JPRB, 0.14681220E-09_JPRB, 0.14253893E-09_JPRB, 0.13458863E-09_JPRB, &
  & 0.12381321E-09_JPRB, 0.11169182E-09_JPRB, 0.99467184E-10_JPRB, 0.88273382E-10_JPRB, 0.79093565E-10_JPRB, 0.71846806E-10_JPRB, &
  & 0.66364546E-10_JPRB, 0.61661821E-10_JPRB, 0.57095710E-10_JPRB, 0.51773984E-10_JPRB, 0.45359286E-10_JPRB, 0.37849949E-10_JPRB, &
  & 0.30029770E-10_JPRB, 0.22992610E-10_JPRB, 0.17745262E-10_JPRB, 0.14441051E-10_JPRB, 0.13049300E-10_JPRB, 0.13145909E-10_JPRB, &
  & 0.14658587E-10_JPRB, 0.17672390E-10_JPRB, 0.22311555E-10_JPRB, 0.29135909E-10_JPRB, 0.38654295E-10_JPRB, 0.50747958E-10_JPRB, &
  & 0.65496580E-10_JPRB, 0.82393405E-10_JPRB, 0.10053774E-09_JPRB, 0.11954637E-09_JPRB, 0.13865245E-09_JPRB, 0.15704167E-09_JPRB, &
  & 0.17437427E-09_JPRB, 0.19100804E-09_JPRB, 0.20701853E-09_JPRB, 0.22268552E-09_JPRB, 0.23843405E-09_JPRB, 0.25415595E-09_JPRB, &
  & 0.27071625E-09_JPRB, 0.28968633E-09_JPRB, 0.31381878E-09_JPRB, 0.34544859E-09_JPRB, 0.37564168E-09_JPRB, 0.39296749E-09_JPRB, &
  & 0.40540238E-09_JPRB, 0.41781900E-09_JPRB, 0.43275980E-09_JPRB, 0.45590542E-09_JPRB /)

RGHG4(:,37, 7) = (/ &
  & 0.13685031E-11_JPRB, 0.24206641E-11_JPRB, 0.41511794E-11_JPRB, 0.68663812E-11_JPRB, 0.11561772E-10_JPRB, 0.20267623E-10_JPRB, &
  & 0.17420733E-10_JPRB, 0.40404027E-10_JPRB, 0.55529335E-10_JPRB, 0.72694011E-10_JPRB, 0.88834391E-10_JPRB, 0.10361713E-09_JPRB, &
  & 0.11510608E-09_JPRB, 0.12283866E-09_JPRB, 0.12682223E-09_JPRB, 0.12662948E-09_JPRB, 0.12230955E-09_JPRB, 0.11440751E-09_JPRB, &
  & 0.10363745E-09_JPRB, 0.91194254E-10_JPRB, 0.78472964E-10_JPRB, 0.66740981E-10_JPRB, 0.56935314E-10_JPRB, 0.49337451E-10_JPRB, &
  & 0.43605692E-10_JPRB, 0.39023756E-10_JPRB, 0.34970731E-10_JPRB, 0.30825894E-10_JPRB, 0.26354139E-10_JPRB, 0.21556659E-10_JPRB, &
  & 0.16978322E-10_JPRB, 0.12994205E-10_JPRB, 0.10177570E-10_JPRB, 0.84565749E-11_JPRB, 0.78159770E-11_JPRB, 0.79874250E-11_JPRB, &
  & 0.90145729E-11_JPRB, 0.10907270E-10_JPRB, 0.13865678E-10_JPRB, 0.18395721E-10_JPRB, 0.24719803E-10_JPRB, 0.33267774E-10_JPRB, &
  & 0.44347952E-10_JPRB, 0.57627361E-10_JPRB, 0.72940910E-10_JPRB, 0.89706617E-10_JPRB, 0.10731694E-09_JPRB, 0.12483123E-09_JPRB, &
  & 0.14186302E-09_JPRB, 0.15828873E-09_JPRB, 0.17392883E-09_JPRB, 0.18907823E-09_JPRB, 0.20409235E-09_JPRB, 0.21891369E-09_JPRB, &
  & 0.23422569E-09_JPRB, 0.25157668E-09_JPRB, 0.27346314E-09_JPRB, 0.30174649E-09_JPRB, 0.32870254E-09_JPRB, 0.34474693E-09_JPRB, &
  & 0.35649381E-09_JPRB, 0.36815478E-09_JPRB, 0.38186124E-09_JPRB, 0.40292455E-09_JPRB /)

RGHG4(:,38, 7) = (/ &
  & 0.12576799E-11_JPRB, 0.21709262E-11_JPRB, 0.36944753E-11_JPRB, 0.61506585E-11_JPRB, 0.10475864E-10_JPRB, 0.18249534E-10_JPRB, &
  & 0.15657937E-10_JPRB, 0.35813269E-10_JPRB, 0.48411088E-10_JPRB, 0.63138293E-10_JPRB, 0.77082535E-10_JPRB, 0.89329849E-10_JPRB, &
  & 0.99878057E-10_JPRB, 0.10667194E-09_JPRB, 0.10989751E-09_JPRB, 0.10958021E-09_JPRB, 0.10536439E-09_JPRB, 0.97667714E-10_JPRB, &
  & 0.87065515E-10_JPRB, 0.74705936E-10_JPRB, 0.61848124E-10_JPRB, 0.50192191E-10_JPRB, 0.40788407E-10_JPRB, 0.33792399E-10_JPRB, &
  & 0.28792838E-10_JPRB, 0.25019591E-10_JPRB, 0.21838902E-10_JPRB, 0.18825176E-10_JPRB, 0.15835897E-10_JPRB, 0.12826946E-10_JPRB, &
  & 0.10139333E-10_JPRB, 0.78738700E-11_JPRB, 0.63466359E-11_JPRB, 0.54202116E-11_JPRB, 0.51336327E-11_JPRB, 0.52908164E-11_JPRB, &
  & 0.59590375E-11_JPRB, 0.71327553E-11_JPRB, 0.89734106E-11_JPRB, 0.11787745E-10_JPRB, 0.15788433E-10_JPRB, 0.21526570E-10_JPRB, &
  & 0.29210242E-10_JPRB, 0.39198332E-10_JPRB, 0.51381614E-10_JPRB, 0.65664141E-10_JPRB, 0.81450305E-10_JPRB, 0.97855522E-10_JPRB, &
  & 0.11434152E-09_JPRB, 0.13031347E-09_JPRB, 0.14559179E-09_JPRB, 0.16031675E-09_JPRB, 0.17467941E-09_JPRB, 0.18862729E-09_JPRB, &
  & 0.20290633E-09_JPRB, 0.21888283E-09_JPRB, 0.23866184E-09_JPRB, 0.26383179E-09_JPRB, 0.28787003E-09_JPRB, 0.30269062E-09_JPRB, &
  & 0.31364980E-09_JPRB, 0.32439532E-09_JPRB, 0.33697295E-09_JPRB, 0.35626829E-09_JPRB /)

RGHG4(:,39, 7) = (/ &
  & 0.12531006E-11_JPRB, 0.20747202E-11_JPRB, 0.34618387E-11_JPRB, 0.58346101E-11_JPRB, 0.96606516E-11_JPRB, 0.16691320E-10_JPRB, &
  & 0.14157659E-10_JPRB, 0.31716987E-10_JPRB, 0.42307477E-10_JPRB, 0.54956924E-10_JPRB, 0.66971984E-10_JPRB, 0.77494802E-10_JPRB, &
  & 0.86580097E-10_JPRB, 0.92520852E-10_JPRB, 0.95332700E-10_JPRB, 0.94941340E-10_JPRB, 0.90943621E-10_JPRB, 0.83648817E-10_JPRB, &
  & 0.73507721E-10_JPRB, 0.61481722E-10_JPRB, 0.49336028E-10_JPRB, 0.38572857E-10_JPRB, 0.30253008E-10_JPRB, 0.24390009E-10_JPRB, &
  & 0.20343102E-10_JPRB, 0.17362653E-10_JPRB, 0.14937397E-10_JPRB, 0.12696999E-10_JPRB, 0.10596236E-10_JPRB, 0.85724761E-11_JPRB, &
  & 0.68445935E-11_JPRB, 0.54259180E-11_JPRB, 0.44999295E-11_JPRB, 0.39579221E-11_JPRB, 0.38233340E-11_JPRB, 0.39596369E-11_JPRB, &
  & 0.44326522E-11_JPRB, 0.52103014E-11_JPRB, 0.64192644E-11_JPRB, 0.82133640E-11_JPRB, 0.10779290E-10_JPRB, 0.14485183E-10_JPRB, &
  & 0.19568805E-10_JPRB, 0.26587297E-10_JPRB, 0.35673051E-10_JPRB, 0.47204653E-10_JPRB, 0.60679940E-10_JPRB, 0.75621918E-10_JPRB, &
  & 0.91075703E-10_JPRB, 0.10634751E-09_JPRB, 0.12102880E-09_JPRB, 0.13504577E-09_JPRB, 0.14852397E-09_JPRB, 0.16156386E-09_JPRB, &
  & 0.17483230E-09_JPRB, 0.18952685E-09_JPRB, 0.20754411E-09_JPRB, 0.23009317E-09_JPRB, 0.25154609E-09_JPRB, 0.26520697E-09_JPRB, &
  & 0.27548558E-09_JPRB, 0.28551117E-09_JPRB, 0.29708261E-09_JPRB, 0.31449149E-09_JPRB /)

RGHG4(:,40, 7) = (/ &
  & 0.12742479E-11_JPRB, 0.20763755E-11_JPRB, 0.33456324E-11_JPRB, 0.55176731E-11_JPRB, 0.91437049E-11_JPRB, 0.15624524E-10_JPRB, &
  & 0.13017492E-10_JPRB, 0.28486932E-10_JPRB, 0.37261121E-10_JPRB, 0.48002657E-10_JPRB, 0.58323152E-10_JPRB, 0.67433413E-10_JPRB, &
  & 0.75292356E-10_JPRB, 0.80416201E-10_JPRB, 0.82792162E-10_JPRB, 0.82346852E-10_JPRB, 0.78698700E-10_JPRB, 0.71980991E-10_JPRB, &
  & 0.62634967E-10_JPRB, 0.51656828E-10_JPRB, 0.40460694E-10_JPRB, 0.30926688E-10_JPRB, 0.23853213E-10_JPRB, 0.19001406E-10_JPRB, &
  & 0.15718092E-10_JPRB, 0.13296806E-10_JPRB, 0.11323871E-10_JPRB, 0.95470316E-11_JPRB, 0.79254355E-11_JPRB, 0.64392922E-11_JPRB, &
  & 0.51878328E-11_JPRB, 0.41975295E-11_JPRB, 0.35630743E-11_JPRB, 0.32156485E-11_JPRB, 0.31483670E-11_JPRB, 0.32787640E-11_JPRB, &
  & 0.36451870E-11_JPRB, 0.42174471E-11_JPRB, 0.50966939E-11_JPRB, 0.63357570E-11_JPRB, 0.80987179E-11_JPRB, 0.10573130E-10_JPRB, &
  & 0.13951139E-10_JPRB, 0.18749989E-10_JPRB, 0.25166138E-10_JPRB, 0.33915138E-10_JPRB, 0.44854107E-10_JPRB, 0.57851005E-10_JPRB, &
  & 0.71889383E-10_JPRB, 0.86174456E-10_JPRB, 0.10003295E-09_JPRB, 0.11329914E-09_JPRB, 0.12602303E-09_JPRB, 0.13824025E-09_JPRB, &
  & 0.15056752E-09_JPRB, 0.16410492E-09_JPRB, 0.18041776E-09_JPRB, 0.20049716E-09_JPRB, 0.21956417E-09_JPRB, 0.23214083E-09_JPRB, &
  & 0.24171479E-09_JPRB, 0.25096639E-09_JPRB, 0.26156591E-09_JPRB, 0.27740674E-09_JPRB /)

RGHG4(:,41, 7) = (/ &
  & 0.12710097E-11_JPRB, 0.20081105E-11_JPRB, 0.32173144E-11_JPRB, 0.53389272E-11_JPRB, 0.87102409E-11_JPRB, 0.14794218E-10_JPRB, &
  & 0.12149556E-10_JPRB, 0.25840018E-10_JPRB, 0.33063094E-10_JPRB, 0.42124405E-10_JPRB, 0.50875314E-10_JPRB, 0.58664469E-10_JPRB, &
  & 0.65390041E-10_JPRB, 0.69838281E-10_JPRB, 0.71905856E-10_JPRB, 0.71480641E-10_JPRB, 0.68280208E-10_JPRB, 0.62329128E-10_JPRB, &
  & 0.53958518E-10_JPRB, 0.44014965E-10_JPRB, 0.34244746E-10_JPRB, 0.26001871E-10_JPRB, 0.19976132E-10_JPRB, 0.15879978E-10_JPRB, &
  & 0.13097735E-10_JPRB, 0.11035299E-10_JPRB, 0.93449172E-11_JPRB, 0.78409076E-11_JPRB, 0.64933870E-11_JPRB, 0.52947156E-11_JPRB, &
  & 0.42969751E-11_JPRB, 0.35349451E-11_JPRB, 0.30521924E-11_JPRB, 0.28100974E-11_JPRB, 0.27786165E-11_JPRB, 0.29088340E-11_JPRB, &
  & 0.32118073E-11_JPRB, 0.36809392E-11_JPRB, 0.43698170E-11_JPRB, 0.53195699E-11_JPRB, 0.66299613E-11_JPRB, 0.84076478E-11_JPRB, &
  & 0.10726452E-10_JPRB, 0.14087964E-10_JPRB, 0.18541070E-10_JPRB, 0.24970781E-10_JPRB, 0.33411194E-10_JPRB, 0.44270650E-10_JPRB, &
  & 0.56498119E-10_JPRB, 0.69503146E-10_JPRB, 0.82303594E-10_JPRB, 0.94608085E-10_JPRB, 0.10633147E-09_JPRB, 0.11754493E-09_JPRB, &
  & 0.12892148E-09_JPRB, 0.14134410E-09_JPRB, 0.15623848E-09_JPRB, 0.17424878E-09_JPRB, 0.19129594E-09_JPRB, 0.20282118E-09_JPRB, &
  & 0.21172357E-09_JPRB, 0.22029856E-09_JPRB, 0.23007114E-09_JPRB, 0.24455921E-09_JPRB /)

RGHG4(:,42, 7) = (/ &
  & 0.12635114E-11_JPRB, 0.19283728E-11_JPRB, 0.30841423E-11_JPRB, 0.49646155E-11_JPRB, 0.82450704E-11_JPRB, 0.14028326E-10_JPRB, &
  & 0.11442166E-10_JPRB, 0.23611066E-10_JPRB, 0.29518978E-10_JPRB, 0.37094449E-10_JPRB, 0.44476259E-10_JPRB, 0.51107216E-10_JPRB, &
  & 0.56836612E-10_JPRB, 0.60635698E-10_JPRB, 0.62420624E-10_JPRB, 0.62053467E-10_JPRB, 0.59292307E-10_JPRB, 0.54178825E-10_JPRB, &
  & 0.46956262E-10_JPRB, 0.38349553E-10_JPRB, 0.29680224E-10_JPRB, 0.22469252E-10_JPRB, 0.17280505E-10_JPRB, 0.13773488E-10_JPRB, &
  & 0.11362646E-10_JPRB, 0.95436315E-11_JPRB, 0.80447125E-11_JPRB, 0.67346202E-11_JPRB, 0.55737541E-11_JPRB, 0.45634494E-11_JPRB, &
  & 0.37254271E-11_JPRB, 0.31016713E-11_JPRB, 0.27168899E-11_JPRB, 0.25369858E-11_JPRB, 0.25283879E-11_JPRB, 0.26531047E-11_JPRB, &
  & 0.29148283E-11_JPRB, 0.33135888E-11_JPRB, 0.38785056E-11_JPRB, 0.46482033E-11_JPRB, 0.56698912E-11_JPRB, 0.70162279E-11_JPRB, &
  & 0.86817463E-11_JPRB, 0.11099637E-10_JPRB, 0.14190779E-10_JPRB, 0.18826368E-10_JPRB, 0.25165226E-10_JPRB, 0.33826601E-10_JPRB, &
  & 0.44205601E-10_JPRB, 0.55746709E-10_JPRB, 0.67370810E-10_JPRB, 0.78676329E-10_JPRB, 0.89422754E-10_JPRB, 0.99743096E-10_JPRB, &
  & 0.11014458E-09_JPRB, 0.12147373E-09_JPRB, 0.13488212E-09_JPRB, 0.15088444E-09_JPRB, 0.16596642E-09_JPRB, 0.17648516E-09_JPRB, &
  & 0.18474024E-09_JPRB, 0.19266663E-09_JPRB, 0.20172086E-09_JPRB, 0.21501800E-09_JPRB /)

RGHG4(:,43, 7) = (/ &
  & 0.12022598E-11_JPRB, 0.18030965E-11_JPRB, 0.28817391E-11_JPRB, 0.46599963E-11_JPRB, 0.77557960E-11_JPRB, 0.13343951E-10_JPRB, &
  & 0.10867967E-10_JPRB, 0.21616493E-10_JPRB, 0.26368354E-10_JPRB, 0.32654379E-10_JPRB, 0.38827289E-10_JPRB, 0.44412345E-10_JPRB, &
  & 0.49268919E-10_JPRB, 0.52512095E-10_JPRB, 0.54030058E-10_JPRB, 0.53737372E-10_JPRB, 0.51427963E-10_JPRB, 0.47076985E-10_JPRB, &
  & 0.40892057E-10_JPRB, 0.33398780E-10_JPRB, 0.25976889E-10_JPRB, 0.19790761E-10_JPRB, 0.15319883E-10_JPRB, 0.12267504E-10_JPRB, &
  & 0.10141595E-10_JPRB, 0.85142804E-11_JPRB, 0.71629863E-11_JPRB, 0.59885027E-11_JPRB, 0.49607696E-11_JPRB, 0.40702615E-11_JPRB, &
  & 0.33409742E-11_JPRB, 0.28058523E-11_JPRB, 0.24844233E-11_JPRB, 0.23439015E-11_JPRB, 0.23489060E-11_JPRB, 0.24660968E-11_JPRB, &
  & 0.27002480E-11_JPRB, 0.30465786E-11_JPRB, 0.35338650E-11_JPRB, 0.41814018E-11_JPRB, 0.50225319E-11_JPRB, 0.60917664E-11_JPRB, &
  & 0.73631726E-11_JPRB, 0.91221388E-11_JPRB, 0.11336761E-10_JPRB, 0.14674668E-10_JPRB, 0.19292136E-10_JPRB, 0.25999130E-10_JPRB, &
  & 0.34463789E-10_JPRB, 0.44392125E-10_JPRB, 0.54653518E-10_JPRB, 0.64743995E-10_JPRB, 0.74336669E-10_JPRB, 0.83557265E-10_JPRB, &
  & 0.92929345E-10_JPRB, 0.10312986E-09_JPRB, 0.11520008E-09_JPRB, 0.12937709E-09_JPRB, 0.14271556E-09_JPRB, 0.15223448E-09_JPRB, &
  & 0.15982735E-09_JPRB, 0.16713921E-09_JPRB, 0.17552346E-09_JPRB, 0.18791779E-09_JPRB /)

RGHG4(:,44, 7) = (/ &
  & 0.11448741E-11_JPRB, 0.16592283E-11_JPRB, 0.26590787E-11_JPRB, 0.42184403E-11_JPRB, 0.73163758E-11_JPRB, 0.12578215E-10_JPRB, &
  & 0.10394980E-10_JPRB, 0.19832216E-10_JPRB, 0.23551208E-10_JPRB, 0.28534904E-10_JPRB, 0.33773137E-10_JPRB, 0.38415385E-10_JPRB, &
  & 0.42444465E-10_JPRB, 0.45190008E-10_JPRB, 0.46490839E-10_JPRB, 0.46248651E-10_JPRB, 0.44345135E-10_JPRB, 0.40769013E-10_JPRB, &
  & 0.35603760E-10_JPRB, 0.29324758E-10_JPRB, 0.22909872E-10_JPRB, 0.17573212E-10_JPRB, 0.13726008E-10_JPRB, 0.11079252E-10_JPRB, &
  & 0.91901885E-11_JPRB, 0.77192636E-11_JPRB, 0.64932586E-11_JPRB, 0.54318511E-11_JPRB, 0.45045560E-11_JPRB, 0.37039447E-11_JPRB, &
  & 0.30503213E-11_JPRB, 0.25780823E-11_JPRB, 0.23015730E-11_JPRB, 0.21858368E-11_JPRB, 0.21981338E-11_JPRB, 0.23068587E-11_JPRB, &
  & 0.25164981E-11_JPRB, 0.28234227E-11_JPRB, 0.32489692E-11_JPRB, 0.38105318E-11_JPRB, 0.45179190E-11_JPRB, 0.54016500E-11_JPRB, &
  & 0.64083751E-11_JPRB, 0.76951232E-11_JPRB, 0.93456284E-11_JPRB, 0.11675134E-10_JPRB, 0.14991806E-10_JPRB, 0.20003924E-10_JPRB, &
  & 0.26667656E-10_JPRB, 0.35002418E-10_JPRB, 0.43798545E-10_JPRB, 0.52616987E-10_JPRB, 0.61030542E-10_JPRB, 0.69194463E-10_JPRB, &
  & 0.77516715E-10_JPRB, 0.86552085E-10_JPRB, 0.97155541E-10_JPRB, 0.10943228E-09_JPRB, 0.12097084E-09_JPRB, 0.12950083E-09_JPRB, &
  & 0.13645780E-09_JPRB, 0.14314459E-09_JPRB, 0.15086761E-09_JPRB, 0.16247705E-09_JPRB /)

RGHG4(:,45, 7) = (/ &
  & 0.10724649E-11_JPRB, 0.15530208E-11_JPRB, 0.24491049E-11_JPRB, 0.38990491E-11_JPRB, 0.66997679E-11_JPRB, 0.11926532E-10_JPRB, &
  & 0.98666630E-11_JPRB, 0.18183550E-10_JPRB, 0.20923241E-10_JPRB, 0.24945745E-10_JPRB, 0.29164404E-10_JPRB, 0.32937843E-10_JPRB, &
  & 0.36225280E-10_JPRB, 0.38481367E-10_JPRB, 0.39541481E-10_JPRB, 0.39345339E-10_JPRB, 0.37809259E-10_JPRB, 0.34865631E-10_JPRB, &
  & 0.30657418E-10_JPRB, 0.25385475E-10_JPRB, 0.20091054E-10_JPRB, 0.15620265E-10_JPRB, 0.12364013E-10_JPRB, 0.10073034E-10_JPRB, &
  & 0.84036189E-11_JPRB, 0.70768448E-11_JPRB, 0.59609071E-11_JPRB, 0.49915636E-11_JPRB, 0.41465425E-11_JPRB, 0.34141739E-11_JPRB, &
  & 0.28200233E-11_JPRB, 0.23948064E-11_JPRB, 0.21499068E-11_JPRB, 0.20511151E-11_JPRB, 0.20655630E-11_JPRB, 0.21641985E-11_JPRB, &
  & 0.23534445E-11_JPRB, 0.26286705E-11_JPRB, 0.30058501E-11_JPRB, 0.34989073E-11_JPRB, 0.41134708E-11_JPRB, 0.48517548E-11_JPRB, &
  & 0.56718289E-11_JPRB, 0.66337847E-11_JPRB, 0.78740504E-11_JPRB, 0.94846787E-11_JPRB, 0.11841319E-10_JPRB, 0.15402837E-10_JPRB, &
  & 0.20493334E-10_JPRB, 0.27159401E-10_JPRB, 0.34540652E-10_JPRB, 0.42040118E-10_JPRB, 0.49176611E-10_JPRB, 0.56089813E-10_JPRB, &
  & 0.63156549E-10_JPRB, 0.70813640E-10_JPRB, 0.79799334E-10_JPRB, 0.90018500E-10_JPRB, 0.99662265E-10_JPRB, 0.10707243E-09_JPRB, &
  & 0.11325033E-09_JPRB, 0.11925493E-09_JPRB, 0.12630744E-09_JPRB, 0.13730198E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART14',0,ZHOOK_HANDLE)



RGHG4(:,46, 7) = (/ &
  & 0.10330848E-11_JPRB, 0.14165793E-11_JPRB, 0.22387545E-11_JPRB, 0.34922627E-11_JPRB, 0.62923881E-11_JPRB, 0.11014450E-10_JPRB, &
  & 0.93031182E-11_JPRB, 0.16487905E-10_JPRB, 0.18410488E-10_JPRB, 0.21524418E-10_JPRB, 0.24814649E-10_JPRB, 0.27761486E-10_JPRB, &
  & 0.30362633E-10_JPRB, 0.32145082E-10_JPRB, 0.32990062E-10_JPRB, 0.32827296E-10_JPRB, 0.31602710E-10_JPRB, 0.29315300E-10_JPRB, &
  & 0.25960565E-10_JPRB, 0.21860850E-10_JPRB, 0.17571576E-10_JPRB, 0.13926636E-10_JPRB, 0.11200986E-10_JPRB, 0.92363400E-11_JPRB, &
  & 0.77588500E-11_JPRB, 0.65611709E-11_JPRB, 0.55416327E-11_JPRB, 0.46507594E-11_JPRB, 0.38699829E-11_JPRB, 0.31910930E-11_JPRB, &
  & 0.26399850E-11_JPRB, 0.22474006E-11_JPRB, 0.20252775E-11_JPRB, 0.19347564E-11_JPRB, 0.19469127E-11_JPRB, 0.20360519E-11_JPRB, &
  & 0.22087208E-11_JPRB, 0.24573442E-11_JPRB, 0.27964504E-11_JPRB, 0.32404053E-11_JPRB, 0.37829549E-11_JPRB, 0.44190324E-11_JPRB, &
  & 0.51104030E-11_JPRB, 0.58578793E-11_JPRB, 0.67790738E-11_JPRB, 0.79230502E-11_JPRB, 0.95523537E-11_JPRB, 0.12023937E-10_JPRB, &
  & 0.15632671E-10_JPRB, 0.20706605E-10_JPRB, 0.26560899E-10_JPRB, 0.32678305E-10_JPRB, 0.38530065E-10_JPRB, 0.44139376E-10_JPRB, &
  & 0.49868526E-10_JPRB, 0.56014460E-10_JPRB, 0.63116484E-10_JPRB, 0.71015457E-10_JPRB, 0.78501892E-10_JPRB, 0.84595407E-10_JPRB, &
  & 0.89839233E-10_JPRB, 0.94980843E-10_JPRB, 0.10115644E-09_JPRB, 0.11125258E-09_JPRB /)

RGHG4(:,47, 7) = (/ &
  & 0.99374870E-12_JPRB, 0.13474248E-11_JPRB, 0.20178288E-11_JPRB, 0.32151541E-11_JPRB, 0.55836494E-11_JPRB, 0.10238250E-10_JPRB, &
  & 0.83423190E-11_JPRB, 0.14585704E-10_JPRB, 0.15511148E-10_JPRB, 0.17861334E-10_JPRB, 0.20252751E-10_JPRB, 0.22449854E-10_JPRB, &
  & 0.24413150E-10_JPRB, 0.25775626E-10_JPRB, 0.26431881E-10_JPRB, 0.26342019E-10_JPRB, 0.25469255E-10_JPRB, 0.23777126E-10_JPRB, &
  & 0.21385855E-10_JPRB, 0.18350555E-10_JPRB, 0.15190576E-10_JPRB, 0.12360974E-10_JPRB, 0.10160474E-10_JPRB, 0.84950831E-11_JPRB, &
  & 0.72005873E-11_JPRB, 0.61211006E-11_JPRB, 0.51905815E-11_JPRB, 0.43667951E-11_JPRB, 0.36414348E-11_JPRB, 0.30060724E-11_JPRB, &
  & 0.24920302E-11_JPRB, 0.21249441E-11_JPRB, 0.19212613E-11_JPRB, 0.18289578E-11_JPRB, 0.18431086E-11_JPRB, 0.19202105E-11_JPRB, &
  & 0.20773320E-11_JPRB, 0.23039320E-11_JPRB, 0.26096907E-11_JPRB, 0.30118638E-11_JPRB, 0.34936791E-11_JPRB, 0.40509250E-11_JPRB, &
  & 0.46336173E-11_JPRB, 0.52429185E-11_JPRB, 0.59143901E-11_JPRB, 0.67537352E-11_JPRB, 0.78370574E-11_JPRB, 0.94562266E-11_JPRB, &
  & 0.11862135E-10_JPRB, 0.15372561E-10_JPRB, 0.19731619E-10_JPRB, 0.24448173E-10_JPRB, 0.29056329E-10_JPRB, 0.33472877E-10_JPRB, &
  & 0.37967719E-10_JPRB, 0.42730871E-10_JPRB, 0.48237716E-10_JPRB, 0.54133757E-10_JPRB, 0.59794426E-10_JPRB, 0.64588959E-10_JPRB, &
  & 0.68790439E-10_JPRB, 0.72955690E-10_JPRB, 0.78048921E-10_JPRB, 0.86714268E-10_JPRB /)

RGHG4(:,48, 7) = (/ &
  & 0.95934545E-12_JPRB, 0.12790612E-11_JPRB, 0.18620702E-11_JPRB, 0.28141562E-11_JPRB, 0.50713054E-11_JPRB, 0.89492832E-11_JPRB, &
  & 0.71790781E-11_JPRB, 0.12167149E-10_JPRB, 0.12267332E-10_JPRB, 0.13779413E-10_JPRB, 0.15386119E-10_JPRB, 0.16881815E-10_JPRB, &
  & 0.18288386E-10_JPRB, 0.19299494E-10_JPRB, 0.19848114E-10_JPRB, 0.19894111E-10_JPRB, 0.19428150E-10_JPRB, 0.18461115E-10_JPRB, &
  & 0.17015866E-10_JPRB, 0.15163037E-10_JPRB, 0.13060699E-10_JPRB, 0.11008078E-10_JPRB, 0.92796751E-11_JPRB, 0.78845264E-11_JPRB, &
  & 0.67470569E-11_JPRB, 0.57732712E-11_JPRB, 0.49163013E-11_JPRB, 0.41510948E-11_JPRB, 0.34694957E-11_JPRB, 0.28677685E-11_JPRB, &
  & 0.23809674E-11_JPRB, 0.20328745E-11_JPRB, 0.18382396E-11_JPRB, 0.17415319E-11_JPRB, 0.17621260E-11_JPRB, 0.18154855E-11_JPRB, &
  & 0.19704824E-11_JPRB, 0.21747246E-11_JPRB, 0.24579889E-11_JPRB, 0.28222741E-11_JPRB, 0.32618853E-11_JPRB, 0.37621885E-11_JPRB, &
  & 0.42729756E-11_JPRB, 0.47777880E-11_JPRB, 0.53011428E-11_JPRB, 0.58964001E-11_JPRB, 0.66233911E-11_JPRB, 0.76505200E-11_JPRB, &
  & 0.91112092E-11_JPRB, 0.11306724E-10_JPRB, 0.14056123E-10_JPRB, 0.17347729E-10_JPRB, 0.20636749E-10_JPRB, 0.23912436E-10_JPRB, &
  & 0.27278901E-10_JPRB, 0.30858375E-10_JPRB, 0.34998587E-10_JPRB, 0.39245256E-10_JPRB, 0.43277028E-10_JPRB, 0.46813969E-10_JPRB, &
  & 0.49968658E-10_JPRB, 0.53139798E-10_JPRB, 0.57146225E-10_JPRB, 0.64351614E-10_JPRB /)

RGHG4(:,49, 7) = (/ &
  & 0.95321028E-12_JPRB, 0.12092036E-11_JPRB, 0.17562533E-11_JPRB, 0.24746010E-11_JPRB, 0.44061677E-11_JPRB, 0.76281377E-11_JPRB, &
  & 0.56849399E-11_JPRB, 0.93331514E-11_JPRB, 0.86286577E-11_JPRB, 0.94260294E-11_JPRB, 0.10328203E-10_JPRB, 0.11227778E-10_JPRB, &
  & 0.12147941E-10_JPRB, 0.12883955E-10_JPRB, 0.13377863E-10_JPRB, 0.13621071E-10_JPRB, 0.13626243E-10_JPRB, 0.13401052E-10_JPRB, &
  & 0.12956179E-10_JPRB, 0.12204785E-10_JPRB, 0.11088593E-10_JPRB, 0.97810137E-11_JPRB, 0.84932608E-11_JPRB, 0.73477960E-11_JPRB, &
  & 0.63572546E-11_JPRB, 0.54774948E-11_JPRB, 0.46903536E-11_JPRB, 0.39744462E-11_JPRB, 0.33333503E-11_JPRB, 0.27609169E-11_JPRB, &
  & 0.22959928E-11_JPRB, 0.19615182E-11_JPRB, 0.17706917E-11_JPRB, 0.16789954E-11_JPRB, 0.16903367E-11_JPRB, 0.17297487E-11_JPRB, &
  & 0.18863205E-11_JPRB, 0.20675375E-11_JPRB, 0.23279525E-11_JPRB, 0.26609695E-11_JPRB, 0.30576199E-11_JPRB, 0.35157547E-11_JPRB, &
  & 0.39652500E-11_JPRB, 0.43930849E-11_JPRB, 0.48069357E-11_JPRB, 0.52329265E-11_JPRB, 0.57214424E-11_JPRB, 0.63153285E-11_JPRB, &
  & 0.71266153E-11_JPRB, 0.82506085E-11_JPRB, 0.97289260E-11_JPRB, 0.11453147E-10_JPRB, 0.13395420E-10_JPRB, 0.15430763E-10_JPRB, &
  & 0.17645678E-10_JPRB, 0.20166589E-10_JPRB, 0.23260333E-10_JPRB, 0.26301150E-10_JPRB, 0.29245804E-10_JPRB, 0.31850744E-10_JPRB, &
  & 0.34201954E-10_JPRB, 0.36571926E-10_JPRB, 0.39587507E-10_JPRB, 0.45239045E-10_JPRB /)

RGHG4(:,50, 7) = (/ &
  & 0.99384812E-12_JPRB, 0.11819828E-11_JPRB, 0.16885876E-11_JPRB, 0.22498470E-11_JPRB, 0.37780209E-11_JPRB, 0.62754480E-11_JPRB, &
  & 0.42954312E-11_JPRB, 0.68109316E-11_JPRB, 0.56051149E-11_JPRB, 0.59739943E-11_JPRB, 0.63902629E-11_JPRB, 0.68903390E-11_JPRB, &
  & 0.74601306E-11_JPRB, 0.79906897E-11_JPRB, 0.84503160E-11_JPRB, 0.88281040E-11_JPRB, 0.91534792E-11_JPRB, 0.94388117E-11_JPRB, &
  & 0.96607783E-11_JPRB, 0.96855883E-11_JPRB, 0.93853241E-11_JPRB, 0.86856512E-11_JPRB, 0.78052096E-11_JPRB, 0.68859506E-11_JPRB, &
  & 0.60269840E-11_JPRB, 0.52325227E-11_JPRB, 0.45067691E-11_JPRB, 0.38372808E-11_JPRB, 0.32308067E-11_JPRB, 0.26826421E-11_JPRB, &
  & 0.22417426E-11_JPRB, 0.19119402E-11_JPRB, 0.17329168E-11_JPRB, 0.16373412E-11_JPRB, 0.16353197E-11_JPRB, 0.16793511E-11_JPRB, &
  & 0.18255924E-11_JPRB, 0.19850220E-11_JPRB, 0.22292634E-11_JPRB, 0.25311309E-11_JPRB, 0.28977257E-11_JPRB, 0.33188901E-11_JPRB, &
  & 0.37272481E-11_JPRB, 0.40892758E-11_JPRB, 0.44257922E-11_JPRB, 0.47456171E-11_JPRB, 0.50527000E-11_JPRB, 0.53865185E-11_JPRB, &
  & 0.57870592E-11_JPRB, 0.63017946E-11_JPRB, 0.69168638E-11_JPRB, 0.76841884E-11_JPRB, 0.85221170E-11_JPRB, 0.94972233E-11_JPRB, &
  & 0.10684824E-10_JPRB, 0.12099938E-10_JPRB, 0.14198879E-10_JPRB, 0.16201865E-10_JPRB, 0.18203140E-10_JPRB, 0.20085357E-10_JPRB, &
  & 0.21843118E-10_JPRB, 0.23684849E-10_JPRB, 0.26092514E-10_JPRB, 0.30771666E-10_JPRB /)

RGHG4(:,51, 7) = (/ &
  & 0.10641764E-11_JPRB, 0.12200022E-11_JPRB, 0.16372047E-11_JPRB, 0.21893149E-11_JPRB, 0.33339525E-11_JPRB, 0.52179528E-11_JPRB, &
  & 0.33645510E-11_JPRB, 0.50897671E-11_JPRB, 0.38584873E-11_JPRB, 0.39814155E-11_JPRB, 0.42032623E-11_JPRB, 0.44817149E-11_JPRB, &
  & 0.48662866E-11_JPRB, 0.52692425E-11_JPRB, 0.56680732E-11_JPRB, 0.60577919E-11_JPRB, 0.64506031E-11_JPRB, 0.68663820E-11_JPRB, &
  & 0.73200343E-11_JPRB, 0.77190953E-11_JPRB, 0.79090319E-11_JPRB, 0.77248364E-11_JPRB, 0.71967757E-11_JPRB, 0.64929954E-11_JPRB, &
  & 0.57522593E-11_JPRB, 0.50330113E-11_JPRB, 0.43636835E-11_JPRB, 0.37360700E-11_JPRB, 0.31648035E-11_JPRB, 0.26370546E-11_JPRB, &
  & 0.22178832E-11_JPRB, 0.18874075E-11_JPRB, 0.17233520E-11_JPRB, 0.16133687E-11_JPRB, 0.16148934E-11_JPRB, 0.16598524E-11_JPRB, &
  & 0.17861333E-11_JPRB, 0.19355695E-11_JPRB, 0.21599185E-11_JPRB, 0.24348858E-11_JPRB, 0.27722716E-11_JPRB, 0.31599315E-11_JPRB, &
  & 0.35330211E-11_JPRB, 0.38496372E-11_JPRB, 0.41282789E-11_JPRB, 0.43734096E-11_JPRB, 0.45714470E-11_JPRB, 0.47399502E-11_JPRB, &
  & 0.49046604E-11_JPRB, 0.50946478E-11_JPRB, 0.53209433E-11_JPRB, 0.55829117E-11_JPRB, 0.59032315E-11_JPRB, 0.62778120E-11_JPRB, &
  & 0.67252128E-11_JPRB, 0.73508248E-11_JPRB, 0.84827050E-11_JPRB, 0.94226328E-11_JPRB, 0.10446748E-10_JPRB, 0.11465751E-10_JPRB, &
  & 0.12545377E-10_JPRB, 0.13743890E-10_JPRB, 0.15471130E-10_JPRB, 0.19278239E-10_JPRB /)

RGHG4(:,52, 7) = (/ &
  & 0.11298164E-11_JPRB, 0.13599546E-11_JPRB, 0.16264114E-11_JPRB, 0.21729929E-11_JPRB, 0.30932737E-11_JPRB, 0.46027223E-11_JPRB, &
  & 0.27789730E-11_JPRB, 0.41363679E-11_JPRB, 0.29377796E-11_JPRB, 0.30031739E-11_JPRB, 0.31180035E-11_JPRB, 0.33035961E-11_JPRB, &
  & 0.35899547E-11_JPRB, 0.39197590E-11_JPRB, 0.42687208E-11_JPRB, 0.46151802E-11_JPRB, 0.49699958E-11_JPRB, 0.53676213E-11_JPRB, &
  & 0.57929798E-11_JPRB, 0.62888965E-11_JPRB, 0.66963184E-11_JPRB, 0.68627443E-11_JPRB, 0.66534573E-11_JPRB, 0.61508689E-11_JPRB, &
  & 0.55229692E-11_JPRB, 0.48718755E-11_JPRB, 0.42550074E-11_JPRB, 0.36701510E-11_JPRB, 0.31286427E-11_JPRB, 0.26279888E-11_JPRB, &
  & 0.22191444E-11_JPRB, 0.19139746E-11_JPRB, 0.17373850E-11_JPRB, 0.16360601E-11_JPRB, 0.16324925E-11_JPRB, 0.16726380E-11_JPRB, &
  & 0.17838971E-11_JPRB, 0.19284136E-11_JPRB, 0.21342730E-11_JPRB, 0.23878844E-11_JPRB, 0.27008005E-11_JPRB, 0.30613938E-11_JPRB, &
  & 0.34019014E-11_JPRB, 0.36695937E-11_JPRB, 0.39022670E-11_JPRB, 0.40936178E-11_JPRB, 0.42189550E-11_JPRB, 0.42816935E-11_JPRB, &
  & 0.43281182E-11_JPRB, 0.43640625E-11_JPRB, 0.44145247E-11_JPRB, 0.44933675E-11_JPRB, 0.45918499E-11_JPRB, 0.47141635E-11_JPRB, &
  & 0.48935747E-11_JPRB, 0.51061438E-11_JPRB, 0.58429325E-11_JPRB, 0.61768706E-11_JPRB, 0.65453654E-11_JPRB, 0.69816375E-11_JPRB, &
  & 0.74641335E-11_JPRB, 0.80711887E-11_JPRB, 0.90586210E-11_JPRB, 0.11547603E-10_JPRB /)

RGHG4(:,53, 7) = (/ &
  & 0.11902310E-11_JPRB, 0.14815392E-11_JPRB, 0.17203531E-11_JPRB, 0.21672041E-11_JPRB, 0.29648445E-11_JPRB, 0.41062787E-11_JPRB, &
  & 0.24452016E-11_JPRB, 0.35184403E-11_JPRB, 0.24692143E-11_JPRB, 0.24794706E-11_JPRB, 0.25642069E-11_JPRB, 0.26998753E-11_JPRB, &
  & 0.29295626E-11_JPRB, 0.32191389E-11_JPRB, 0.35240758E-11_JPRB, 0.38381169E-11_JPRB, 0.41506087E-11_JPRB, 0.44749386E-11_JPRB, &
  & 0.48709916E-11_JPRB, 0.52953883E-11_JPRB, 0.57888217E-11_JPRB, 0.61273135E-11_JPRB, 0.61831135E-11_JPRB, 0.58772149E-11_JPRB, &
  & 0.53552939E-11_JPRB, 0.47654923E-11_JPRB, 0.41955757E-11_JPRB, 0.36534898E-11_JPRB, 0.31430609E-11_JPRB, 0.26736326E-11_JPRB, &
  & 0.22661244E-11_JPRB, 0.19742660E-11_JPRB, 0.17860488E-11_JPRB, 0.16987988E-11_JPRB, 0.16834390E-11_JPRB, 0.17210452E-11_JPRB, &
  & 0.18217916E-11_JPRB, 0.19600278E-11_JPRB, 0.21474721E-11_JPRB, 0.23810587E-11_JPRB, 0.26744791E-11_JPRB, 0.30069656E-11_JPRB, &
  & 0.33238765E-11_JPRB, 0.35520887E-11_JPRB, 0.37561742E-11_JPRB, 0.39109996E-11_JPRB, 0.39881293E-11_JPRB, 0.39922900E-11_JPRB, &
  & 0.39746062E-11_JPRB, 0.39489202E-11_JPRB, 0.39301696E-11_JPRB, 0.39285858E-11_JPRB, 0.39424943E-11_JPRB, 0.39738859E-11_JPRB, &
  & 0.40186843E-11_JPRB, 0.40943217E-11_JPRB, 0.46604066E-11_JPRB, 0.47730184E-11_JPRB, 0.49228976E-11_JPRB, 0.50841917E-11_JPRB, &
  & 0.52961693E-11_JPRB, 0.55600407E-11_JPRB, 0.60078366E-11_JPRB, 0.73296829E-11_JPRB /)

RGHG4(:,54, 7) = (/ &
  & 0.13001767E-11_JPRB, 0.15667129E-11_JPRB, 0.18116471E-11_JPRB, 0.22127918E-11_JPRB, 0.28797030E-11_JPRB, 0.38230066E-11_JPRB, &
  & 0.21961038E-11_JPRB, 0.31530440E-11_JPRB, 0.21892739E-11_JPRB, 0.21966064E-11_JPRB, 0.22475884E-11_JPRB, 0.23537322E-11_JPRB, &
  & 0.25519450E-11_JPRB, 0.28038817E-11_JPRB, 0.30823360E-11_JPRB, 0.33575686E-11_JPRB, 0.36247797E-11_JPRB, 0.39228642E-11_JPRB, &
  & 0.42307976E-11_JPRB, 0.46336663E-11_JPRB, 0.50838166E-11_JPRB, 0.55489814E-11_JPRB, 0.57862382E-11_JPRB, 0.56756900E-11_JPRB, &
  & 0.52620117E-11_JPRB, 0.47306148E-11_JPRB, 0.42033451E-11_JPRB, 0.37049617E-11_JPRB, 0.32182963E-11_JPRB, 0.27673896E-11_JPRB, &
  & 0.23798841E-11_JPRB, 0.20886238E-11_JPRB, 0.19069145E-11_JPRB, 0.18208024E-11_JPRB, 0.17983960E-11_JPRB, 0.18348198E-11_JPRB, &
  & 0.19275736E-11_JPRB, 0.20600158E-11_JPRB, 0.22320104E-11_JPRB, 0.24524254E-11_JPRB, 0.27294655E-11_JPRB, 0.30425734E-11_JPRB, &
  & 0.33289909E-11_JPRB, 0.35096683E-11_JPRB, 0.36801985E-11_JPRB, 0.38123541E-11_JPRB, 0.38562768E-11_JPRB, 0.38202050E-11_JPRB, &
  & 0.37657416E-11_JPRB, 0.37067628E-11_JPRB, 0.36587964E-11_JPRB, 0.36268495E-11_JPRB, 0.36101460E-11_JPRB, 0.36041010E-11_JPRB, &
  & 0.36113996E-11_JPRB, 0.36419474E-11_JPRB, 0.41673973E-11_JPRB, 0.42156031E-11_JPRB, 0.42599158E-11_JPRB, 0.43258301E-11_JPRB, &
  & 0.44324965E-11_JPRB, 0.45498093E-11_JPRB, 0.47373772E-11_JPRB, 0.51270134E-11_JPRB /)

RGHG4(:,55, 7) = (/ &
  & 0.14301222E-11_JPRB, 0.16490357E-11_JPRB, 0.18791746E-11_JPRB, 0.22412573E-11_JPRB, 0.28089239E-11_JPRB, 0.35489528E-11_JPRB, &
  & 0.20381669E-11_JPRB, 0.28707683E-11_JPRB, 0.20332072E-11_JPRB, 0.20236575E-11_JPRB, 0.20677141E-11_JPRB, 0.21549362E-11_JPRB, &
  & 0.23227210E-11_JPRB, 0.25537239E-11_JPRB, 0.28083222E-11_JPRB, 0.30614493E-11_JPRB, 0.33150546E-11_JPRB, 0.35501209E-11_JPRB, &
  & 0.38665833E-11_JPRB, 0.41931363E-11_JPRB, 0.46355493E-11_JPRB, 0.51177756E-11_JPRB, 0.55092909E-11_JPRB, 0.55671088E-11_JPRB, &
  & 0.52607801E-11_JPRB, 0.47866598E-11_JPRB, 0.42957443E-11_JPRB, 0.38327557E-11_JPRB, 0.33729762E-11_JPRB, 0.29389789E-11_JPRB, &
  & 0.25471610E-11_JPRB, 0.22541244E-11_JPRB, 0.20668339E-11_JPRB, 0.19742858E-11_JPRB, 0.19462624E-11_JPRB, 0.19773885E-11_JPRB, &
  & 0.20632107E-11_JPRB, 0.21883914E-11_JPRB, 0.23514506E-11_JPRB, 0.25630576E-11_JPRB, 0.28301521E-11_JPRB, 0.31290417E-11_JPRB, &
  & 0.33937046E-11_JPRB, 0.35525244E-11_JPRB, 0.37027863E-11_JPRB, 0.38174056E-11_JPRB, 0.38334032E-11_JPRB, 0.37690836E-11_JPRB, &
  & 0.37007303E-11_JPRB, 0.36231927E-11_JPRB, 0.35625942E-11_JPRB, 0.35177837E-11_JPRB, 0.34880614E-11_JPRB, 0.34674900E-11_JPRB, &
  & 0.34563376E-11_JPRB, 0.34560861E-11_JPRB, 0.39390366E-11_JPRB, 0.39614406E-11_JPRB, 0.39903341E-11_JPRB, 0.40453678E-11_JPRB, &
  & 0.41133815E-11_JPRB, 0.41975316E-11_JPRB, 0.43230051E-11_JPRB, 0.44154138E-11_JPRB /)

RGHG4(:,56, 7) = (/ &
  & 0.15157969E-11_JPRB, 0.17136385E-11_JPRB, 0.19446675E-11_JPRB, 0.22562828E-11_JPRB, 0.27471929E-11_JPRB, 0.33700991E-11_JPRB, &
  & 0.19098846E-11_JPRB, 0.26956978E-11_JPRB, 0.19389958E-11_JPRB, 0.19307609E-11_JPRB, 0.19618487E-11_JPRB, 0.20322121E-11_JPRB, &
  & 0.21853279E-11_JPRB, 0.23853692E-11_JPRB, 0.26231196E-11_JPRB, 0.28585129E-11_JPRB, 0.30928587E-11_JPRB, 0.33411652E-11_JPRB, &
  & 0.35880997E-11_JPRB, 0.39397851E-11_JPRB, 0.43469278E-11_JPRB, 0.48703207E-11_JPRB, 0.53642529E-11_JPRB, 0.55754277E-11_JPRB, &
  & 0.53696036E-11_JPRB, 0.49478321E-11_JPRB, 0.44856926E-11_JPRB, 0.40560962E-11_JPRB, 0.36009227E-11_JPRB, 0.31627606E-11_JPRB, &
  & 0.27668887E-11_JPRB, 0.24637436E-11_JPRB, 0.22668217E-11_JPRB, 0.21675465E-11_JPRB, 0.21350673E-11_JPRB, 0.21599664E-11_JPRB, &
  & 0.22379171E-11_JPRB, 0.23575358E-11_JPRB, 0.25134352E-11_JPRB, 0.27201802E-11_JPRB, 0.29809870E-11_JPRB, 0.32680616E-11_JPRB, &
  & 0.35185904E-11_JPRB, 0.36646996E-11_JPRB, 0.38007119E-11_JPRB, 0.39016659E-11_JPRB, 0.39031283E-11_JPRB, 0.38235140E-11_JPRB, &
  & 0.37394896E-11_JPRB, 0.36457213E-11_JPRB, 0.35769712E-11_JPRB, 0.35225549E-11_JPRB, 0.34838332E-11_JPRB, 0.34604407E-11_JPRB, &
  & 0.34378264E-11_JPRB, 0.34395952E-11_JPRB, 0.39074295E-11_JPRB, 0.39312629E-11_JPRB, 0.39483625E-11_JPRB, 0.39794843E-11_JPRB, &
  & 0.40430576E-11_JPRB, 0.41337801E-11_JPRB, 0.42885543E-11_JPRB, 0.45694390E-11_JPRB /)

RGHG4(:,57, 7) = (/ &
  & 0.15717448E-11_JPRB, 0.17619630E-11_JPRB, 0.19707812E-11_JPRB, 0.22695758E-11_JPRB, 0.26762778E-11_JPRB, 0.31884731E-11_JPRB, &
  & 0.18204667E-11_JPRB, 0.25455278E-11_JPRB, 0.18906374E-11_JPRB, 0.18787120E-11_JPRB, 0.19083099E-11_JPRB, 0.19715345E-11_JPRB, &
  & 0.21033815E-11_JPRB, 0.22952233E-11_JPRB, 0.25133376E-11_JPRB, 0.27475945E-11_JPRB, 0.29771036E-11_JPRB, 0.32163989E-11_JPRB, &
  & 0.34954619E-11_JPRB, 0.38140879E-11_JPRB, 0.42379481E-11_JPRB, 0.48011916E-11_JPRB, 0.53748204E-11_JPRB, 0.57153744E-11_JPRB, &
  & 0.55939515E-11_JPRB, 0.52118704E-11_JPRB, 0.47547920E-11_JPRB, 0.43136406E-11_JPRB, 0.38575263E-11_JPRB, 0.34162475E-11_JPRB, &
  & 0.30171031E-11_JPRB, 0.27015937E-11_JPRB, 0.24955151E-11_JPRB, 0.23891319E-11_JPRB, 0.23517184E-11_JPRB, 0.23695529E-11_JPRB, &
  & 0.24402821E-11_JPRB, 0.25528091E-11_JPRB, 0.27038400E-11_JPRB, 0.29062260E-11_JPRB, 0.31609472E-11_JPRB, 0.34392511E-11_JPRB, &
  & 0.36778558E-11_JPRB, 0.38247396E-11_JPRB, 0.39541586E-11_JPRB, 0.40481260E-11_JPRB, 0.40481125E-11_JPRB, 0.39697095E-11_JPRB, &
  & 0.38826689E-11_JPRB, 0.37807630E-11_JPRB, 0.37019814E-11_JPRB, 0.36389993E-11_JPRB, 0.35979288E-11_JPRB, 0.35660810E-11_JPRB, &
  & 0.35429932E-11_JPRB, 0.35364968E-11_JPRB, 0.39651511E-11_JPRB, 0.39824051E-11_JPRB, 0.40010304E-11_JPRB, 0.40456878E-11_JPRB, &
  & 0.41082975E-11_JPRB, 0.41905333E-11_JPRB, 0.43157461E-11_JPRB, 0.44878073E-11_JPRB /)

RGHG4(:,58, 7) = (/ &
  & 0.16068733E-11_JPRB, 0.17960326E-11_JPRB, 0.20065817E-11_JPRB, 0.22603982E-11_JPRB, 0.26312817E-11_JPRB, 0.30724789E-11_JPRB, &
  & 0.17599323E-11_JPRB, 0.24651635E-11_JPRB, 0.18817203E-11_JPRB, 0.18738351E-11_JPRB, 0.18992063E-11_JPRB, 0.19562516E-11_JPRB, &
  & 0.20790062E-11_JPRB, 0.22556002E-11_JPRB, 0.24694097E-11_JPRB, 0.27074716E-11_JPRB, 0.29448783E-11_JPRB, 0.32101470E-11_JPRB, &
  & 0.34725239E-11_JPRB, 0.38447839E-11_JPRB, 0.42934055E-11_JPRB, 0.48781920E-11_JPRB, 0.55350546E-11_JPRB, 0.59102558E-11_JPRB, &
  & 0.58410529E-11_JPRB, 0.54960641E-11_JPRB, 0.50527364E-11_JPRB, 0.46150288E-11_JPRB, 0.41534272E-11_JPRB, 0.37054318E-11_JPRB, &
  & 0.32960551E-11_JPRB, 0.29705112E-11_JPRB, 0.27575262E-11_JPRB, 0.26454340E-11_JPRB, 0.26042168E-11_JPRB, 0.26159073E-11_JPRB, &
  & 0.26787279E-11_JPRB, 0.27839198E-11_JPRB, 0.29284476E-11_JPRB, 0.31264425E-11_JPRB, 0.33750153E-11_JPRB, 0.36435872E-11_JPRB, &
  & 0.38741254E-11_JPRB, 0.40242172E-11_JPRB, 0.41482724E-11_JPRB, 0.42354488E-11_JPRB, 0.42398641E-11_JPRB, 0.41754889E-11_JPRB, &
  & 0.41001725E-11_JPRB, 0.40028059E-11_JPRB, 0.39241388E-11_JPRB, 0.38565063E-11_JPRB, 0.38087897E-11_JPRB, 0.37768521E-11_JPRB, &
  & 0.37484195E-11_JPRB, 0.37455607E-11_JPRB, 0.41554182E-11_JPRB, 0.41838416E-11_JPRB, 0.42017917E-11_JPRB, 0.42361436E-11_JPRB, &
  & 0.42964261E-11_JPRB, 0.43913376E-11_JPRB, 0.45368839E-11_JPRB, 0.47243025E-11_JPRB /)

RGHG4(:,59, 7) = (/ &
  & 0.16317973E-11_JPRB, 0.18197470E-11_JPRB, 0.20202555E-11_JPRB, 0.22677136E-11_JPRB, 0.25856617E-11_JPRB, 0.29726495E-11_JPRB, &
  & 0.17208756E-11_JPRB, 0.24107381E-11_JPRB, 0.19064340E-11_JPRB, 0.19054253E-11_JPRB, 0.19330954E-11_JPRB, 0.19943322E-11_JPRB, &
  & 0.21120549E-11_JPRB, 0.22906080E-11_JPRB, 0.25043257E-11_JPRB, 0.27564255E-11_JPRB, 0.30205200E-11_JPRB, 0.33077677E-11_JPRB, &
  & 0.36207064E-11_JPRB, 0.39976928E-11_JPRB, 0.44786922E-11_JPRB, 0.51316074E-11_JPRB, 0.57668562E-11_JPRB, 0.61661462E-11_JPRB, &
  & 0.61311277E-11_JPRB, 0.58128697E-11_JPRB, 0.53757910E-11_JPRB, 0.49241392E-11_JPRB, 0.44543202E-11_JPRB, 0.40008856E-11_JPRB, &
  & 0.35917185E-11_JPRB, 0.32629099E-11_JPRB, 0.30451629E-11_JPRB, 0.29294401E-11_JPRB, 0.28857066E-11_JPRB, 0.28929632E-11_JPRB, &
  & 0.29485171E-11_JPRB, 0.30456581E-11_JPRB, 0.31840116E-11_JPRB, 0.33762357E-11_JPRB, 0.36165268E-11_JPRB, 0.38776747E-11_JPRB, &
  & 0.41010984E-11_JPRB, 0.42542740E-11_JPRB, 0.43779585E-11_JPRB, 0.44624482E-11_JPRB, 0.44794008E-11_JPRB, 0.44343288E-11_JPRB, &
  & 0.43795436E-11_JPRB, 0.42978529E-11_JPRB, 0.42304129E-11_JPRB, 0.41648802E-11_JPRB, 0.41230491E-11_JPRB, 0.40885238E-11_JPRB, &
  & 0.40601394E-11_JPRB, 0.40594754E-11_JPRB, 0.44410469E-11_JPRB, 0.44664160E-11_JPRB, 0.44839961E-11_JPRB, 0.45266915E-11_JPRB, &
  & 0.45932789E-11_JPRB, 0.46898613E-11_JPRB, 0.48235482E-11_JPRB, 0.49861742E-11_JPRB /)

RGHG4(:,60, 7) = (/ &
  & 0.16613833E-11_JPRB, 0.18467120E-11_JPRB, 0.20436357E-11_JPRB, 0.22706453E-11_JPRB, 0.25765941E-11_JPRB, 0.29337147E-11_JPRB, &
  & 0.17229070E-11_JPRB, 0.24217648E-11_JPRB, 0.19840538E-11_JPRB, 0.19913340E-11_JPRB, 0.20282400E-11_JPRB, 0.20918330E-11_JPRB, &
  & 0.22213177E-11_JPRB, 0.24069143E-11_JPRB, 0.26431251E-11_JPRB, 0.29147132E-11_JPRB, 0.32194232E-11_JPRB, 0.35459565E-11_JPRB, &
  & 0.38785425E-11_JPRB, 0.42975987E-11_JPRB, 0.48246953E-11_JPRB, 0.54302192E-11_JPRB, 0.60665960E-11_JPRB, 0.64451942E-11_JPRB, &
  & 0.64289876E-11_JPRB, 0.61330047E-11_JPRB, 0.57034074E-11_JPRB, 0.52434741E-11_JPRB, 0.47721068E-11_JPRB, 0.43186227E-11_JPRB, &
  & 0.39081633E-11_JPRB, 0.35844426E-11_JPRB, 0.33696190E-11_JPRB, 0.32558040E-11_JPRB, 0.32123210E-11_JPRB, 0.32176174E-11_JPRB, &
  & 0.32670049E-11_JPRB, 0.33549409E-11_JPRB, 0.34837155E-11_JPRB, 0.36656949E-11_JPRB, 0.38991115E-11_JPRB, 0.41512752E-11_JPRB, &
  & 0.43656741E-11_JPRB, 0.45279770E-11_JPRB, 0.46470562E-11_JPRB, 0.47350305E-11_JPRB, 0.47601792E-11_JPRB, 0.47369968E-11_JPRB, &
  & 0.47037391E-11_JPRB, 0.46465466E-11_JPRB, 0.46002512E-11_JPRB, 0.45518797E-11_JPRB, 0.45248002E-11_JPRB, 0.44998844E-11_JPRB, &
  & 0.44744811E-11_JPRB, 0.44938068E-11_JPRB, 0.48709621E-11_JPRB, 0.49092757E-11_JPRB, 0.49285428E-11_JPRB, 0.49665797E-11_JPRB, &
  & 0.50329198E-11_JPRB, 0.51389600E-11_JPRB, 0.52792120E-11_JPRB, 0.53939392E-11_JPRB /)

RGHG4(:,61, 7) = (/ &
  & 0.16830726E-11_JPRB, 0.18660472E-11_JPRB, 0.20624878E-11_JPRB, 0.22891190E-11_JPRB, 0.25783997E-11_JPRB, 0.29277238E-11_JPRB, &
  & 0.17487995E-11_JPRB, 0.24822622E-11_JPRB, 0.21110383E-11_JPRB, 0.21400674E-11_JPRB, 0.21908812E-11_JPRB, 0.22799592E-11_JPRB, &
  & 0.24224867E-11_JPRB, 0.26417393E-11_JPRB, 0.29066630E-11_JPRB, 0.32208747E-11_JPRB, 0.35679363E-11_JPRB, 0.39369757E-11_JPRB, &
  & 0.42938149E-11_JPRB, 0.47185047E-11_JPRB, 0.52085914E-11_JPRB, 0.58176376E-11_JPRB, 0.63840023E-11_JPRB, 0.67407907E-11_JPRB, &
  & 0.67354204E-11_JPRB, 0.64560987E-11_JPRB, 0.60324445E-11_JPRB, 0.55692217E-11_JPRB, 0.50934760E-11_JPRB, 0.46493295E-11_JPRB, &
  & 0.42521334E-11_JPRB, 0.39431700E-11_JPRB, 0.37401176E-11_JPRB, 0.36357664E-11_JPRB, 0.35967982E-11_JPRB, 0.36009527E-11_JPRB, &
  & 0.36442897E-11_JPRB, 0.37219785E-11_JPRB, 0.38403196E-11_JPRB, 0.40130434E-11_JPRB, 0.42316840E-11_JPRB, 0.44721904E-11_JPRB, &
  & 0.46832785E-11_JPRB, 0.48475030E-11_JPRB, 0.49670298E-11_JPRB, 0.50610796E-11_JPRB, 0.50989417E-11_JPRB, 0.51062722E-11_JPRB, &
  & 0.50964398E-11_JPRB, 0.50671854E-11_JPRB, 0.50359673E-11_JPRB, 0.50126630E-11_JPRB, 0.50022738E-11_JPRB, 0.49951510E-11_JPRB, &
  & 0.49810212E-11_JPRB, 0.50287331E-11_JPRB, 0.54171364E-11_JPRB, 0.54608184E-11_JPRB, 0.54862217E-11_JPRB, 0.55327739E-11_JPRB, &
  & 0.56101178E-11_JPRB, 0.57273912E-11_JPRB, 0.58693215E-11_JPRB, 0.59473073E-11_JPRB /)

RGHG4(:,62, 7) = (/ &
  & 0.17002121E-11_JPRB, 0.18802271E-11_JPRB, 0.20780597E-11_JPRB, 0.23090061E-11_JPRB, 0.26086045E-11_JPRB, 0.29681073E-11_JPRB, &
  & 0.18221986E-11_JPRB, 0.26123561E-11_JPRB, 0.23149681E-11_JPRB, 0.23713399E-11_JPRB, 0.24537737E-11_JPRB, 0.25720992E-11_JPRB, &
  & 0.27601914E-11_JPRB, 0.30207828E-11_JPRB, 0.33373590E-11_JPRB, 0.36894771E-11_JPRB, 0.40777650E-11_JPRB, 0.44656822E-11_JPRB, &
  & 0.48200866E-11_JPRB, 0.52157553E-11_JPRB, 0.56975475E-11_JPRB, 0.62128861E-11_JPRB, 0.67353935E-11_JPRB, 0.70537430E-11_JPRB, &
  & 0.70501409E-11_JPRB, 0.67828547E-11_JPRB, 0.63661715E-11_JPRB, 0.59027193E-11_JPRB, 0.54371152E-11_JPRB, 0.50054947E-11_JPRB, &
  & 0.46346030E-11_JPRB, 0.43534239E-11_JPRB, 0.41757613E-11_JPRB, 0.40900842E-11_JPRB, 0.40606611E-11_JPRB, 0.40665674E-11_JPRB, &
  & 0.41045695E-11_JPRB, 0.41703481E-11_JPRB, 0.42733829E-11_JPRB, 0.44260333E-11_JPRB, 0.46345939E-11_JPRB, 0.48649153E-11_JPRB, &
  & 0.50670518E-11_JPRB, 0.52360343E-11_JPRB, 0.53543710E-11_JPRB, 0.54573195E-11_JPRB, 0.55044727E-11_JPRB, 0.55376771E-11_JPRB, &
  & 0.55496020E-11_JPRB, 0.55495292E-11_JPRB, 0.55413330E-11_JPRB, 0.55522609E-11_JPRB, 0.55606331E-11_JPRB, 0.55799705E-11_JPRB, &
  & 0.55792909E-11_JPRB, 0.56678928E-11_JPRB, 0.60945229E-11_JPRB, 0.61646083E-11_JPRB, 0.62046713E-11_JPRB, 0.62627464E-11_JPRB, &
  & 0.63519355E-11_JPRB, 0.64895832E-11_JPRB, 0.66393440E-11_JPRB, 0.66573522E-11_JPRB /)

RGHG4(:,63, 7) = (/ &
  & 0.16957542E-11_JPRB, 0.18820605E-11_JPRB, 0.20829694E-11_JPRB, 0.23241005E-11_JPRB, 0.26388026E-11_JPRB, 0.30291442E-11_JPRB, &
  & 0.19190686E-11_JPRB, 0.28057882E-11_JPRB, 0.25887172E-11_JPRB, 0.27014779E-11_JPRB, 0.28323875E-11_JPRB, 0.30092239E-11_JPRB, &
  & 0.32606684E-11_JPRB, 0.35829540E-11_JPRB, 0.39537028E-11_JPRB, 0.43387152E-11_JPRB, 0.47282425E-11_JPRB, 0.51056338E-11_JPRB, &
  & 0.54282672E-11_JPRB, 0.57876234E-11_JPRB, 0.61937378E-11_JPRB, 0.66658116E-11_JPRB, 0.71104689E-11_JPRB, 0.73831280E-11_JPRB, &
  & 0.73731915E-11_JPRB, 0.71140290E-11_JPRB, 0.67082923E-11_JPRB, 0.62539735E-11_JPRB, 0.58046519E-11_JPRB, 0.54040908E-11_JPRB, &
  & 0.50746326E-11_JPRB, 0.48408708E-11_JPRB, 0.47000381E-11_JPRB, 0.46391671E-11_JPRB, 0.46252069E-11_JPRB, 0.46361235E-11_JPRB, &
  & 0.46710968E-11_JPRB, 0.47253681E-11_JPRB, 0.48120652E-11_JPRB, 0.49501909E-11_JPRB, 0.51345256E-11_JPRB, 0.53486542E-11_JPRB, &
  & 0.55445141E-11_JPRB, 0.57101975E-11_JPRB, 0.58333850E-11_JPRB, 0.59408689E-11_JPRB, 0.60017221E-11_JPRB, 0.60662812E-11_JPRB, &
  & 0.61070350E-11_JPRB, 0.61359025E-11_JPRB, 0.61495774E-11_JPRB, 0.61882574E-11_JPRB, 0.62177477E-11_JPRB, 0.62661339E-11_JPRB, &
  & 0.62864020E-11_JPRB, 0.64122882E-11_JPRB, 0.68758410E-11_JPRB, 0.69686891E-11_JPRB, 0.70288927E-11_JPRB, 0.71130415E-11_JPRB, &
  & 0.72322604E-11_JPRB, 0.74057973E-11_JPRB, 0.75695969E-11_JPRB, 0.75093456E-11_JPRB /)

RGHG4(:,64, 7) = (/ &
  & 0.16768493E-11_JPRB, 0.18637906E-11_JPRB, 0.20710720E-11_JPRB, 0.23239353E-11_JPRB, 0.26635020E-11_JPRB, 0.30970818E-11_JPRB, &
  & 0.20462583E-11_JPRB, 0.30562900E-11_JPRB, 0.29561197E-11_JPRB, 0.31405987E-11_JPRB, 0.33623232E-11_JPRB, 0.36109466E-11_JPRB, &
  & 0.39506311E-11_JPRB, 0.43297865E-11_JPRB, 0.47327728E-11_JPRB, 0.51181802E-11_JPRB, 0.54848066E-11_JPRB, 0.58219107E-11_JPRB, &
  & 0.61076985E-11_JPRB, 0.64134258E-11_JPRB, 0.67731471E-11_JPRB, 0.71487421E-11_JPRB, 0.75217272E-11_JPRB, 0.77420136E-11_JPRB, &
  & 0.77180467E-11_JPRB, 0.74679377E-11_JPRB, 0.70771371E-11_JPRB, 0.66454299E-11_JPRB, 0.62291123E-11_JPRB, 0.58751198E-11_JPRB, &
  & 0.56022097E-11_JPRB, 0.54291923E-11_JPRB, 0.53406624E-11_JPRB, 0.53126661E-11_JPRB, 0.53173976E-11_JPRB, 0.53366799E-11_JPRB, &
  & 0.53700915E-11_JPRB, 0.54122939E-11_JPRB, 0.54773148E-11_JPRB, 0.55854986E-11_JPRB, 0.57543757E-11_JPRB, 0.59553148E-11_JPRB, &
  & 0.61403890E-11_JPRB, 0.63061240E-11_JPRB, 0.64291771E-11_JPRB, 0.65362446E-11_JPRB, 0.66112645E-11_JPRB, 0.66985367E-11_JPRB, &
  & 0.67571890E-11_JPRB, 0.68112230E-11_JPRB, 0.68508996E-11_JPRB, 0.69282405E-11_JPRB, 0.69860411E-11_JPRB, 0.70671559E-11_JPRB, &
  & 0.71117279E-11_JPRB, 0.72802138E-11_JPRB, 0.77859186E-11_JPRB, 0.79112454E-11_JPRB, 0.80005837E-11_JPRB, 0.81151665E-11_JPRB, &
  & 0.82701450E-11_JPRB, 0.84809165E-11_JPRB, 0.86580786E-11_JPRB, 0.85011052E-11_JPRB /)

RGHG4(:,65, 7) = (/ &
  & 0.16475364E-11_JPRB, 0.18249048E-11_JPRB, 0.20323888E-11_JPRB, 0.22958608E-11_JPRB, 0.26591314E-11_JPRB, 0.31489698E-11_JPRB, &
  & 0.21808495E-11_JPRB, 0.33594748E-11_JPRB, 0.34002766E-11_JPRB, 0.37163306E-11_JPRB, 0.40461675E-11_JPRB, 0.44083097E-11_JPRB, &
  & 0.48275546E-11_JPRB, 0.52536456E-11_JPRB, 0.56473025E-11_JPRB, 0.60072893E-11_JPRB, 0.63245628E-11_JPRB, 0.66109067E-11_JPRB, &
  & 0.68492685E-11_JPRB, 0.71001083E-11_JPRB, 0.73781823E-11_JPRB, 0.76881080E-11_JPRB, 0.79798347E-11_JPRB, 0.81448659E-11_JPRB, &
  & 0.81047244E-11_JPRB, 0.78681237E-11_JPRB, 0.75025776E-11_JPRB, 0.71064044E-11_JPRB, 0.67396986E-11_JPRB, 0.64479689E-11_JPRB, &
  & 0.62538889E-11_JPRB, 0.61547152E-11_JPRB, 0.61242287E-11_JPRB, 0.61341084E-11_JPRB, 0.61591210E-11_JPRB, 0.61892323E-11_JPRB, &
  & 0.62242269E-11_JPRB, 0.62576129E-11_JPRB, 0.63061032E-11_JPRB, 0.63987158E-11_JPRB, 0.65373835E-11_JPRB, 0.67166546E-11_JPRB, &
  & 0.68909700E-11_JPRB, 0.70502527E-11_JPRB, 0.71715581E-11_JPRB, 0.72784322E-11_JPRB, 0.73704463E-11_JPRB, 0.74788925E-11_JPRB, &
  & 0.75654734E-11_JPRB, 0.76502294E-11_JPRB, 0.77154984E-11_JPRB, 0.78220598E-11_JPRB, 0.79015709E-11_JPRB, 0.80135169E-11_JPRB, &
  & 0.80852217E-11_JPRB, 0.82896459E-11_JPRB, 0.88333420E-11_JPRB, 0.89832091E-11_JPRB, 0.90993220E-11_JPRB, 0.92541409E-11_JPRB, &
  & 0.94547955E-11_JPRB, 0.97067250E-11_JPRB, 0.98970328E-11_JPRB, 0.96531125E-11_JPRB /)

RGHG4(:,66, 7) = (/ &
  & 0.16049821E-11_JPRB, 0.17687542E-11_JPRB, 0.19792837E-11_JPRB, 0.22529814E-11_JPRB, 0.26375568E-11_JPRB, 0.31896506E-11_JPRB, &
  & 0.23391467E-11_JPRB, 0.37166784E-11_JPRB, 0.39679926E-11_JPRB, 0.44342108E-11_JPRB, 0.49287310E-11_JPRB, 0.53761964E-11_JPRB, &
  & 0.58523230E-11_JPRB, 0.62712583E-11_JPRB, 0.66303521E-11_JPRB, 0.69525150E-11_JPRB, 0.72260249E-11_JPRB, 0.74600543E-11_JPRB, &
  & 0.76511818E-11_JPRB, 0.78411479E-11_JPRB, 0.80596614E-11_JPRB, 0.82859856E-11_JPRB, 0.85025233E-11_JPRB, 0.86143436E-11_JPRB, &
  & 0.85601881E-11_JPRB, 0.83432844E-11_JPRB, 0.80163775E-11_JPRB, 0.76725050E-11_JPRB, 0.73725401E-11_JPRB, 0.71558701E-11_JPRB, &
  & 0.70426026E-11_JPRB, 0.70278705E-11_JPRB, 0.70631881E-11_JPRB, 0.71153183E-11_JPRB, 0.71646708E-11_JPRB, 0.72087726E-11_JPRB, &
  & 0.72501783E-11_JPRB, 0.72770774E-11_JPRB, 0.73079442E-11_JPRB, 0.73720457E-11_JPRB, 0.74957636E-11_JPRB, 0.76658705E-11_JPRB, &
  & 0.78299303E-11_JPRB, 0.79830647E-11_JPRB, 0.80995722E-11_JPRB, 0.82054103E-11_JPRB, 0.83087270E-11_JPRB, 0.84293189E-11_JPRB, &
  & 0.85309572E-11_JPRB, 0.86351881E-11_JPRB, 0.87230379E-11_JPRB, 0.88683566E-11_JPRB, 0.89849881E-11_JPRB, 0.91340806E-11_JPRB, &
  & 0.92339114E-11_JPRB, 0.94702926E-11_JPRB, 0.10056157E-10_JPRB, 0.10231418E-10_JPRB, 0.10375215E-10_JPRB, 0.10570182E-10_JPRB, &
  & 0.10817901E-10_JPRB, 0.11113336E-10_JPRB, 0.11314374E-10_JPRB, 0.11002440E-10_JPRB /)

RGHG4(:,67, 7) = (/ &
  & 0.15455778E-11_JPRB, 0.17169301E-11_JPRB, 0.19324967E-11_JPRB, 0.22164881E-11_JPRB, 0.26251191E-11_JPRB, 0.32507137E-11_JPRB, &
  & 0.25351359E-11_JPRB, 0.41913985E-11_JPRB, 0.46634233E-11_JPRB, 0.53485215E-11_JPRB, 0.59573505E-11_JPRB, 0.64949070E-11_JPRB, &
  & 0.69679176E-11_JPRB, 0.73685875E-11_JPRB, 0.76926998E-11_JPRB, 0.79713094E-11_JPRB, 0.81964218E-11_JPRB, 0.83785791E-11_JPRB, &
  & 0.85199304E-11_JPRB, 0.86530349E-11_JPRB, 0.88019314E-11_JPRB, 0.89655757E-11_JPRB, 0.91158314E-11_JPRB, 0.91807412E-11_JPRB, &
  & 0.91206070E-11_JPRB, 0.89326047E-11_JPRB, 0.86587768E-11_JPRB, 0.83806339E-11_JPRB, 0.81561589E-11_JPRB, 0.80244379E-11_JPRB, &
  & 0.80094490E-11_JPRB, 0.80807193E-11_JPRB, 0.81806107E-11_JPRB, 0.82755643E-11_JPRB, 0.83519355E-11_JPRB, 0.84155530E-11_JPRB, &
  & 0.84693528E-11_JPRB, 0.84993670E-11_JPRB, 0.85260627E-11_JPRB, 0.85861275E-11_JPRB, 0.86910132E-11_JPRB, 0.88390276E-11_JPRB, &
  & 0.89938517E-11_JPRB, 0.91424585E-11_JPRB, 0.92544895E-11_JPRB, 0.93609183E-11_JPRB, 0.94728782E-11_JPRB, 0.96052688E-11_JPRB, &
  & 0.97414464E-11_JPRB, 0.98739263E-11_JPRB, 0.99947993E-11_JPRB, 0.10169397E-10_JPRB, 0.10312393E-10_JPRB, 0.10486585E-10_JPRB, &
  & 0.10610264E-10_JPRB, 0.10870997E-10_JPRB, 0.11494809E-10_JPRB, 0.11685321E-10_JPRB, 0.11853529E-10_JPRB, 0.12090841E-10_JPRB, &
  & 0.12392022E-10_JPRB, 0.12737911E-10_JPRB, 0.12951370E-10_JPRB, 0.12569883E-10_JPRB /)

RGHG4(:,68, 7) = (/ &
  & 0.15101023E-11_JPRB, 0.16988416E-11_JPRB, 0.19324368E-11_JPRB, 0.22343817E-11_JPRB, 0.26583727E-11_JPRB, 0.33766989E-11_JPRB, &
  & 0.28068021E-11_JPRB, 0.48248983E-11_JPRB, 0.55573883E-11_JPRB, 0.64001092E-11_JPRB, 0.71545751E-11_JPRB, 0.76708778E-11_JPRB, &
  & 0.81322961E-11_JPRB, 0.85049884E-11_JPRB, 0.87863536E-11_JPRB, 0.90410188E-11_JPRB, 0.92246011E-11_JPRB, 0.93689110E-11_JPRB, &
  & 0.94682569E-11_JPRB, 0.95503397E-11_JPRB, 0.96465370E-11_JPRB, 0.97488649E-11_JPRB, 0.98457397E-11_JPRB, 0.98766273E-11_JPRB, &
  & 0.98194976E-11_JPRB, 0.96710981E-11_JPRB, 0.94617265E-11_JPRB, 0.92627815E-11_JPRB, 0.91269674E-11_JPRB, 0.90881573E-11_JPRB, &
  & 0.91609125E-11_JPRB, 0.93206814E-11_JPRB, 0.94954079E-11_JPRB, 0.96382876E-11_JPRB, 0.97497522E-11_JPRB, 0.98384721E-11_JPRB, &
  & 0.99108968E-11_JPRB, 0.99449763E-11_JPRB, 0.99650678E-11_JPRB, 0.10007514E-10_JPRB, 0.10104240E-10_JPRB, 0.10264707E-10_JPRB, &
  & 0.10420449E-10_JPRB, 0.10568361E-10_JPRB, 0.10678203E-10_JPRB, 0.10785337E-10_JPRB, 0.10906139E-10_JPRB, 0.11053802E-10_JPRB, &
  & 0.11207065E-10_JPRB, 0.11351828E-10_JPRB, 0.11497865E-10_JPRB, 0.11708715E-10_JPRB, 0.11896702E-10_JPRB, 0.12111416E-10_JPRB, &
  & 0.12263558E-10_JPRB, 0.12543543E-10_JPRB, 0.13205342E-10_JPRB, 0.13407783E-10_JPRB, 0.13597440E-10_JPRB, 0.13876884E-10_JPRB, &
  & 0.14236649E-10_JPRB, 0.14645868E-10_JPRB, 0.14884144E-10_JPRB, 0.14437477E-10_JPRB /)

RGHG4(:,69, 7) = (/ &
  & 0.15228916E-11_JPRB, 0.17594203E-11_JPRB, 0.20312445E-11_JPRB, 0.23607680E-11_JPRB, 0.28030544E-11_JPRB, 0.36089643E-11_JPRB, &
  & 0.32119340E-11_JPRB, 0.56188986E-11_JPRB, 0.66435707E-11_JPRB, 0.76447069E-11_JPRB, 0.83844815E-11_JPRB, 0.89291855E-11_JPRB, &
  & 0.93601533E-11_JPRB, 0.97261001E-11_JPRB, 0.99646654E-11_JPRB, 0.10202871E-10_JPRB, 0.10341962E-10_JPRB, 0.10455863E-10_JPRB, &
  & 0.10516377E-10_JPRB, 0.10559936E-10_JPRB, 0.10608535E-10_JPRB, 0.10669399E-10_JPRB, 0.10727740E-10_JPRB, 0.10739483E-10_JPRB, &
  & 0.10696311E-10_JPRB, 0.10596954E-10_JPRB, 0.10461936E-10_JPRB, 0.10351694E-10_JPRB, 0.10308808E-10_JPRB, 0.10368225E-10_JPRB, &
  & 0.10549971E-10_JPRB, 0.10798010E-10_JPRB, 0.11046871E-10_JPRB, 0.11241769E-10_JPRB, 0.11389863E-10_JPRB, 0.11511719E-10_JPRB, &
  & 0.11611292E-10_JPRB, 0.11664563E-10_JPRB, 0.11698633E-10_JPRB, 0.11751830E-10_JPRB, 0.11850696E-10_JPRB, 0.11997195E-10_JPRB, &
  & 0.12153524E-10_JPRB, 0.12307325E-10_JPRB, 0.12422768E-10_JPRB, 0.12536283E-10_JPRB, 0.12670475E-10_JPRB, 0.12840114E-10_JPRB, &
  & 0.13031465E-10_JPRB, 0.13209150E-10_JPRB, 0.13403175E-10_JPRB, 0.13648924E-10_JPRB, 0.13874954E-10_JPRB, 0.14108261E-10_JPRB, &
  & 0.14278069E-10_JPRB, 0.14570616E-10_JPRB, 0.15266824E-10_JPRB, 0.15472387E-10_JPRB, 0.15680169E-10_JPRB, 0.16005468E-10_JPRB, &
  & 0.16431044E-10_JPRB, 0.16918328E-10_JPRB, 0.17203152E-10_JPRB, 0.16719369E-10_JPRB /)

RGHG4(:,70, 7) = (/ &
  & 0.16266861E-11_JPRB, 0.19500866E-11_JPRB, 0.23044305E-11_JPRB, 0.26731464E-11_JPRB, 0.31372708E-11_JPRB, 0.40364483E-11_JPRB, &
  & 0.37482708E-11_JPRB, 0.66357067E-11_JPRB, 0.79544470E-11_JPRB, 0.88913555E-11_JPRB, 0.97377280E-11_JPRB, 0.10201785E-10_JPRB, &
  & 0.10659355E-10_JPRB, 0.10985754E-10_JPRB, 0.11196578E-10_JPRB, 0.11428935E-10_JPRB, 0.11551695E-10_JPRB, 0.11652374E-10_JPRB, &
  & 0.11693662E-10_JPRB, 0.11713117E-10_JPRB, 0.11730720E-10_JPRB, 0.11760263E-10_JPRB, 0.11795330E-10_JPRB, 0.11804595E-10_JPRB, &
  & 0.11787173E-10_JPRB, 0.11744920E-10_JPRB, 0.11691987E-10_JPRB, 0.11677618E-10_JPRB, 0.11739558E-10_JPRB, 0.11904239E-10_JPRB, &
  & 0.12174421E-10_JPRB, 0.12520594E-10_JPRB, 0.12847581E-10_JPRB, 0.13101828E-10_JPRB, 0.13297672E-10_JPRB, 0.13460125E-10_JPRB, &
  & 0.13595626E-10_JPRB, 0.13668489E-10_JPRB, 0.13709798E-10_JPRB, 0.13761926E-10_JPRB, 0.13868945E-10_JPRB, 0.14058633E-10_JPRB, &
  & 0.14241461E-10_JPRB, 0.14415060E-10_JPRB, 0.14543301E-10_JPRB, 0.14673303E-10_JPRB, 0.14829638E-10_JPRB, 0.15026222E-10_JPRB, &
  & 0.15246589E-10_JPRB, 0.15445834E-10_JPRB, 0.15669542E-10_JPRB, 0.15955775E-10_JPRB, 0.16237166E-10_JPRB, 0.16521834E-10_JPRB, &
  & 0.16733752E-10_JPRB, 0.17038305E-10_JPRB, 0.17760132E-10_JPRB, 0.17971093E-10_JPRB, 0.18196659E-10_JPRB, 0.18567332E-10_JPRB, &
  & 0.19068259E-10_JPRB, 0.19640426E-10_JPRB, 0.19995137E-10_JPRB, 0.19457944E-10_JPRB /)

RGHG4(:,71, 7) = (/ &
  & 0.18730050E-11_JPRB, 0.23468762E-11_JPRB, 0.28272870E-11_JPRB, 0.32715768E-11_JPRB, 0.37768694E-11_JPRB, 0.48435002E-11_JPRB, &
  & 0.44855803E-11_JPRB, 0.78536309E-11_JPRB, 0.94072944E-11_JPRB, 0.10193713E-10_JPRB, 0.11195715E-10_JPRB, 0.11556847E-10_JPRB, &
  & 0.12062083E-10_JPRB, 0.12366915E-10_JPRB, 0.12563492E-10_JPRB, 0.12780127E-10_JPRB, 0.12890403E-10_JPRB, 0.12992667E-10_JPRB, &
  & 0.13024330E-10_JPRB, 0.13037645E-10_JPRB, 0.13039453E-10_JPRB, 0.13057774E-10_JPRB, 0.13084323E-10_JPRB, 0.13107890E-10_JPRB, &
  & 0.13129663E-10_JPRB, 0.13155822E-10_JPRB, 0.13194831E-10_JPRB, 0.13285449E-10_JPRB, 0.13452158E-10_JPRB, 0.13722856E-10_JPRB, &
  & 0.14117001E-10_JPRB, 0.14562485E-10_JPRB, 0.14976112E-10_JPRB, 0.15295912E-10_JPRB, 0.15541313E-10_JPRB, 0.15756422E-10_JPRB, &
  & 0.15940334E-10_JPRB, 0.16057636E-10_JPRB, 0.16138353E-10_JPRB, 0.16223536E-10_JPRB, 0.16359107E-10_JPRB, 0.16550815E-10_JPRB, &
  & 0.16750041E-10_JPRB, 0.16946130E-10_JPRB, 0.17103180E-10_JPRB, 0.17259031E-10_JPRB, 0.17450841E-10_JPRB, 0.17686488E-10_JPRB, &
  & 0.17959636E-10_JPRB, 0.18208317E-10_JPRB, 0.18488317E-10_JPRB, 0.18828586E-10_JPRB, 0.19169862E-10_JPRB, 0.19487346E-10_JPRB, &
  & 0.19721233E-10_JPRB, 0.20035900E-10_JPRB, 0.20775898E-10_JPRB, 0.20990713E-10_JPRB, 0.21230500E-10_JPRB, 0.21647623E-10_JPRB, &
  & 0.22216631E-10_JPRB, 0.22889718E-10_JPRB, 0.23348247E-10_JPRB, 0.22864833E-10_JPRB /)

RGHG4(:,72, 7) = (/ &
  & 0.23261078E-11_JPRB, 0.30379072E-11_JPRB, 0.37170544E-11_JPRB, 0.42532137E-11_JPRB, 0.49072135E-11_JPRB, 0.61847346E-11_JPRB, &
  & 0.54528452E-11_JPRB, 0.93956631E-11_JPRB, 0.10821156E-10_JPRB, 0.11701517E-10_JPRB, 0.12681408E-10_JPRB, 0.13058226E-10_JPRB, &
  & 0.13517237E-10_JPRB, 0.13843643E-10_JPRB, 0.14024860E-10_JPRB, 0.14268821E-10_JPRB, 0.14376969E-10_JPRB, 0.14503575E-10_JPRB, &
  & 0.14549806E-10_JPRB, 0.14572371E-10_JPRB, 0.14574671E-10_JPRB, 0.14596411E-10_JPRB, 0.14630805E-10_JPRB, 0.14686322E-10_JPRB, &
  & 0.14762502E-10_JPRB, 0.14868695E-10_JPRB, 0.15012718E-10_JPRB, 0.15216578E-10_JPRB, 0.15497298E-10_JPRB, 0.15894360E-10_JPRB, &
  & 0.16372752E-10_JPRB, 0.16926387E-10_JPRB, 0.17427657E-10_JPRB, 0.17820568E-10_JPRB, 0.18140543E-10_JPRB, 0.18419363E-10_JPRB, &
  & 0.18660518E-10_JPRB, 0.18815364E-10_JPRB, 0.18922820E-10_JPRB, 0.19031087E-10_JPRB, 0.19198759E-10_JPRB, 0.19464543E-10_JPRB, &
  & 0.19724585E-10_JPRB, 0.19974454E-10_JPRB, 0.20163446E-10_JPRB, 0.20364186E-10_JPRB, 0.20603829E-10_JPRB, 0.20888831E-10_JPRB, &
  & 0.21200290E-10_JPRB, 0.21487553E-10_JPRB, 0.21805235E-10_JPRB, 0.22202271E-10_JPRB, 0.22610021E-10_JPRB, 0.22997869E-10_JPRB, &
  & 0.23300493E-10_JPRB, 0.23648052E-10_JPRB, 0.24381230E-10_JPRB, 0.24606889E-10_JPRB, 0.24858296E-10_JPRB, 0.25304247E-10_JPRB, &
  & 0.25936456E-10_JPRB, 0.26684805E-10_JPRB, 0.27236373E-10_JPRB, 0.26770057E-10_JPRB /)

RGHG4(:,73, 7) = (/ &
  & 0.30801715E-11_JPRB, 0.41922594E-11_JPRB, 0.50856225E-11_JPRB, 0.57739989E-11_JPRB, 0.66126870E-11_JPRB, 0.82207071E-11_JPRB, &
  & 0.66660874E-11_JPRB, 0.11043167E-10_JPRB, 0.12528527E-10_JPRB, 0.13213008E-10_JPRB, 0.14274867E-10_JPRB, 0.14680623E-10_JPRB, &
  & 0.15122454E-10_JPRB, 0.15481120E-10_JPRB, 0.15638293E-10_JPRB, 0.15907603E-10_JPRB, 0.16039595E-10_JPRB, 0.16176871E-10_JPRB, &
  & 0.16258977E-10_JPRB, 0.16307974E-10_JPRB, 0.16335242E-10_JPRB, 0.16380440E-10_JPRB, 0.16444688E-10_JPRB, 0.16549142E-10_JPRB, &
  & 0.16700984E-10_JPRB, 0.16906181E-10_JPRB, 0.17167549E-10_JPRB, 0.17500701E-10_JPRB, 0.17905200E-10_JPRB, 0.18433402E-10_JPRB, &
  & 0.19038309E-10_JPRB, 0.19704819E-10_JPRB, 0.20326607E-10_JPRB, 0.20811566E-10_JPRB, 0.21204477E-10_JPRB, 0.21563671E-10_JPRB, &
  & 0.21883863E-10_JPRB, 0.22116540E-10_JPRB, 0.22294517E-10_JPRB, 0.22459869E-10_JPRB, 0.22674147E-10_JPRB, 0.22961596E-10_JPRB, &
  & 0.23249111E-10_JPRB, 0.23537946E-10_JPRB, 0.23788771E-10_JPRB, 0.24044308E-10_JPRB, 0.24349267E-10_JPRB, 0.24694323E-10_JPRB, &
  & 0.25073726E-10_JPRB, 0.25422194E-10_JPRB, 0.25805028E-10_JPRB, 0.26272609E-10_JPRB, 0.26764414E-10_JPRB, 0.27211003E-10_JPRB, &
  & 0.27556625E-10_JPRB, 0.27905823E-10_JPRB, 0.28624526E-10_JPRB, 0.28846269E-10_JPRB, 0.29094355E-10_JPRB, 0.29552458E-10_JPRB, &
  & 0.30220382E-10_JPRB, 0.31027264E-10_JPRB, 0.31645849E-10_JPRB, 0.31137839E-10_JPRB /)

RGHG4(:,74, 7) = (/ &
  & 0.44234295E-11_JPRB, 0.59530002E-11_JPRB, 0.70725730E-11_JPRB, 0.79022188E-11_JPRB, 0.89804943E-11_JPRB, 0.10806869E-10_JPRB, &
  & 0.80435728E-11_JPRB, 0.13099889E-10_JPRB, 0.14148850E-10_JPRB, 0.15166861E-10_JPRB, 0.15856448E-10_JPRB, 0.16474837E-10_JPRB, &
  & 0.16784735E-10_JPRB, 0.17214169E-10_JPRB, 0.17393363E-10_JPRB, 0.17681513E-10_JPRB, 0.17882772E-10_JPRB, 0.18053678E-10_JPRB, &
  & 0.18189237E-10_JPRB, 0.18287434E-10_JPRB, 0.18357692E-10_JPRB, 0.18448118E-10_JPRB, 0.18564190E-10_JPRB, 0.18739564E-10_JPRB, &
  & 0.18987645E-10_JPRB, 0.19309271E-10_JPRB, 0.19704889E-10_JPRB, 0.20185208E-10_JPRB, 0.20744130E-10_JPRB, 0.21389914E-10_JPRB, &
  & 0.22119178E-10_JPRB, 0.22890511E-10_JPRB, 0.23590109E-10_JPRB, 0.24172969E-10_JPRB, 0.24677252E-10_JPRB, 0.25133484E-10_JPRB, &
  & 0.25542943E-10_JPRB, 0.25836859E-10_JPRB, 0.26068000E-10_JPRB, 0.26291466E-10_JPRB, 0.26574161E-10_JPRB, 0.26954945E-10_JPRB, &
  & 0.27347164E-10_JPRB, 0.27736629E-10_JPRB, 0.28048269E-10_JPRB, 0.28384715E-10_JPRB, 0.28762831E-10_JPRB, 0.29175221E-10_JPRB, &
  & 0.29592939E-10_JPRB, 0.29997282E-10_JPRB, 0.30430877E-10_JPRB, 0.30963149E-10_JPRB, 0.31534757E-10_JPRB, 0.32069694E-10_JPRB, &
  & 0.32489664E-10_JPRB, 0.32881652E-10_JPRB, 0.33563180E-10_JPRB, 0.33772325E-10_JPRB, 0.33998436E-10_JPRB, 0.34455609E-10_JPRB, &
  & 0.35138347E-10_JPRB, 0.35990984E-10_JPRB, 0.36637991E-10_JPRB, 0.36028586E-10_JPRB /)

RGHG4(:,75, 7) = (/ &
  & 0.63158875E-11_JPRB, 0.83662487E-11_JPRB, 0.97023977E-11_JPRB, 0.10644119E-10_JPRB, 0.11830654E-10_JPRB, 0.13703400E-10_JPRB, &
  & 0.95886485E-11_JPRB, 0.15107280E-10_JPRB, 0.16256633E-10_JPRB, 0.16899107E-10_JPRB, 0.17806045E-10_JPRB, 0.18271567E-10_JPRB, &
  & 0.18674132E-10_JPRB, 0.19071796E-10_JPRB, 0.19325229E-10_JPRB, 0.19632693E-10_JPRB, 0.19893406E-10_JPRB, 0.20144978E-10_JPRB, &
  & 0.20340582E-10_JPRB, 0.20515516E-10_JPRB, 0.20659228E-10_JPRB, 0.20823220E-10_JPRB, 0.21025341E-10_JPRB, 0.21301721E-10_JPRB, &
  & 0.21663664E-10_JPRB, 0.22117724E-10_JPRB, 0.22668112E-10_JPRB, 0.23316314E-10_JPRB, 0.24028068E-10_JPRB, 0.24817199E-10_JPRB, &
  & 0.25686108E-10_JPRB, 0.26615071E-10_JPRB, 0.27495744E-10_JPRB, 0.28234186E-10_JPRB, 0.28852979E-10_JPRB, 0.29433542E-10_JPRB, &
  & 0.29962578E-10_JPRB, 0.30373110E-10_JPRB, 0.30701445E-10_JPRB, 0.30999009E-10_JPRB, 0.31335996E-10_JPRB, 0.31756132E-10_JPRB, &
  & 0.32184314E-10_JPRB, 0.32620070E-10_JPRB, 0.33025652E-10_JPRB, 0.33460682E-10_JPRB, 0.33947574E-10_JPRB, 0.34456046E-10_JPRB, &
  & 0.34969697E-10_JPRB, 0.35433257E-10_JPRB, 0.35944206E-10_JPRB, 0.36552001E-10_JPRB, 0.37206238E-10_JPRB, 0.37807080E-10_JPRB, &
  & 0.38254303E-10_JPRB, 0.38625641E-10_JPRB, 0.39275905E-10_JPRB, 0.39446613E-10_JPRB, 0.39645807E-10_JPRB, 0.40090337E-10_JPRB, &
  & 0.40804238E-10_JPRB, 0.41669054E-10_JPRB, 0.42319648E-10_JPRB, 0.41521755E-10_JPRB /)

RGHG4(:,76, 7) = (/ &
  & 0.88040564E-11_JPRB, 0.11449496E-10_JPRB, 0.12951792E-10_JPRB, 0.13947198E-10_JPRB, 0.15107053E-10_JPRB, 0.16907495E-10_JPRB, &
  & 0.11211335E-10_JPRB, 0.17434314E-10_JPRB, 0.18198155E-10_JPRB, 0.19046270E-10_JPRB, 0.19546401E-10_JPRB, 0.20179580E-10_JPRB, &
  & 0.20516762E-10_JPRB, 0.20960607E-10_JPRB, 0.21305456E-10_JPRB, 0.21695919E-10_JPRB, 0.22052880E-10_JPRB, 0.22397735E-10_JPRB, &
  & 0.22701287E-10_JPRB, 0.22979256E-10_JPRB, 0.23223824E-10_JPRB, 0.23498314E-10_JPRB, 0.23817559E-10_JPRB, 0.24226888E-10_JPRB, &
  & 0.24727493E-10_JPRB, 0.25336877E-10_JPRB, 0.26068524E-10_JPRB, 0.26896386E-10_JPRB, 0.27777001E-10_JPRB, 0.28738076E-10_JPRB, &
  & 0.29733015E-10_JPRB, 0.30755586E-10_JPRB, 0.31667224E-10_JPRB, 0.32515109E-10_JPRB, 0.33295887E-10_JPRB, 0.34021144E-10_JPRB, &
  & 0.34679825E-10_JPRB, 0.35203396E-10_JPRB, 0.35646371E-10_JPRB, 0.36073859E-10_JPRB, 0.36548528E-10_JPRB, 0.37107831E-10_JPRB, &
  & 0.37669944E-10_JPRB, 0.38248418E-10_JPRB, 0.38772287E-10_JPRB, 0.39326514E-10_JPRB, 0.39916577E-10_JPRB, 0.40508423E-10_JPRB, &
  & 0.41096664E-10_JPRB, 0.41631872E-10_JPRB, 0.42202065E-10_JPRB, 0.42862831E-10_JPRB, 0.43566109E-10_JPRB, 0.44222803E-10_JPRB, &
  & 0.44734331E-10_JPRB, 0.45145492E-10_JPRB, 0.45770669E-10_JPRB, 0.45912184E-10_JPRB, 0.46070224E-10_JPRB, 0.46524951E-10_JPRB, &
  & 0.47229106E-10_JPRB, 0.48117711E-10_JPRB, 0.48706782E-10_JPRB, 0.47599747E-10_JPRB /)

RGHG4(:,77, 7) = (/ &
  & 0.11935827E-10_JPRB, 0.15133081E-10_JPRB, 0.16770712E-10_JPRB, 0.17721304E-10_JPRB, 0.18752361E-10_JPRB, 0.20281547E-10_JPRB, &
  & 0.12814869E-10_JPRB, 0.19571181E-10_JPRB, 0.20316245E-10_JPRB, 0.20829406E-10_JPRB, 0.21548319E-10_JPRB, 0.21954369E-10_JPRB, &
  & 0.22447986E-10_JPRB, 0.22895016E-10_JPRB, 0.23327021E-10_JPRB, 0.23804066E-10_JPRB, 0.24267014E-10_JPRB, 0.24739580E-10_JPRB, &
  & 0.25170491E-10_JPRB, 0.25599139E-10_JPRB, 0.25987480E-10_JPRB, 0.26417344E-10_JPRB, 0.26895567E-10_JPRB, 0.27471022E-10_JPRB, &
  & 0.28140405E-10_JPRB, 0.28928542E-10_JPRB, 0.29858543E-10_JPRB, 0.30861567E-10_JPRB, 0.31939444E-10_JPRB, 0.33053827E-10_JPRB, &
  & 0.34195383E-10_JPRB, 0.35449008E-10_JPRB, 0.36669921E-10_JPRB, 0.37748332E-10_JPRB, 0.38732722E-10_JPRB, 0.39654800E-10_JPRB, &
  & 0.40473295E-10_JPRB, 0.41128913E-10_JPRB, 0.41672086E-10_JPRB, 0.42166774E-10_JPRB, 0.42694386E-10_JPRB, 0.43304547E-10_JPRB, &
  & 0.43917692E-10_JPRB, 0.44595667E-10_JPRB, 0.45249318E-10_JPRB, 0.45941084E-10_JPRB, 0.46676264E-10_JPRB, 0.47374705E-10_JPRB, &
  & 0.48042133E-10_JPRB, 0.48645178E-10_JPRB, 0.49274862E-10_JPRB, 0.49990595E-10_JPRB, 0.50717458E-10_JPRB, 0.51395548E-10_JPRB, &
  & 0.51887827E-10_JPRB, 0.52293999E-10_JPRB, 0.52920144E-10_JPRB, 0.53064091E-10_JPRB, 0.53221996E-10_JPRB, 0.53659389E-10_JPRB, &
  & 0.54374658E-10_JPRB, 0.55224499E-10_JPRB, 0.55693471E-10_JPRB, 0.54227851E-10_JPRB /)

RGHG4(:,78, 7) = (/ &
  & 0.15693365E-10_JPRB, 0.19246183E-10_JPRB, 0.20840172E-10_JPRB, 0.21719770E-10_JPRB, 0.22538230E-10_JPRB, 0.23735958E-10_JPRB, &
  & 0.14373226E-10_JPRB, 0.21569694E-10_JPRB, 0.22043908E-10_JPRB, 0.22555098E-10_JPRB, 0.23026430E-10_JPRB, 0.23591278E-10_JPRB, &
  & 0.24051733E-10_JPRB, 0.24596635E-10_JPRB, 0.25134873E-10_JPRB, 0.25730097E-10_JPRB, 0.26324731E-10_JPRB, 0.26928930E-10_JPRB, &
  & 0.27526998E-10_JPRB, 0.28128279E-10_JPRB, 0.28705168E-10_JPRB, 0.29330125E-10_JPRB, 0.30014581E-10_JPRB, 0.30790051E-10_JPRB, &
  & 0.31649315E-10_JPRB, 0.32635134E-10_JPRB, 0.33748723E-10_JPRB, 0.34913083E-10_JPRB, 0.36157442E-10_JPRB, 0.37401970E-10_JPRB, &
  & 0.38667104E-10_JPRB, 0.39859133E-10_JPRB, 0.41008176E-10_JPRB, 0.42141905E-10_JPRB, 0.43238566E-10_JPRB, 0.44308751E-10_JPRB, &
  & 0.45323356E-10_JPRB, 0.46218137E-10_JPRB, 0.47032121E-10_JPRB, 0.47793762E-10_JPRB, 0.48563403E-10_JPRB, 0.49368093E-10_JPRB, &
  & 0.50150308E-10_JPRB, 0.50977507E-10_JPRB, 0.51767677E-10_JPRB, 0.52596451E-10_JPRB, 0.53437307E-10_JPRB, 0.54191904E-10_JPRB, &
  & 0.54917473E-10_JPRB, 0.55564695E-10_JPRB, 0.56223477E-10_JPRB, 0.56923580E-10_JPRB, 0.57626421E-10_JPRB, 0.58278320E-10_JPRB, &
  & 0.58822579E-10_JPRB, 0.59309876E-10_JPRB, 0.59992768E-10_JPRB, 0.60217248E-10_JPRB, 0.60415825E-10_JPRB, 0.60863099E-10_JPRB, &
  & 0.61552916E-10_JPRB, 0.62343936E-10_JPRB, 0.62811555E-10_JPRB, 0.61256174E-10_JPRB /)

RGHG4(:,79, 7) = (/ &
  & 0.20048180E-10_JPRB, 0.23099652E-10_JPRB, 0.24072236E-10_JPRB, 0.24642618E-10_JPRB, 0.25175398E-10_JPRB, 0.25997886E-10_JPRB, &
  & 0.15273095E-10_JPRB, 0.22723547E-10_JPRB, 0.23031205E-10_JPRB, 0.23480332E-10_JPRB, 0.24028663E-10_JPRB, 0.24462024E-10_JPRB, &
  & 0.25049140E-10_JPRB, 0.25604865E-10_JPRB, 0.26203394E-10_JPRB, 0.26878472E-10_JPRB, 0.27579985E-10_JPRB, 0.28329016E-10_JPRB, &
  & 0.29074255E-10_JPRB, 0.29860822E-10_JPRB, 0.30634419E-10_JPRB, 0.31457448E-10_JPRB, 0.32346154E-10_JPRB, 0.33278245E-10_JPRB, &
  & 0.34259547E-10_JPRB, 0.35342822E-10_JPRB, 0.36458135E-10_JPRB, 0.37590941E-10_JPRB, 0.38732927E-10_JPRB, 0.39858596E-10_JPRB, &
  & 0.41036934E-10_JPRB, 0.42291649E-10_JPRB, 0.43490073E-10_JPRB, 0.44648858E-10_JPRB, 0.45799031E-10_JPRB, 0.46949892E-10_JPRB, &
  & 0.48075040E-10_JPRB, 0.49117335E-10_JPRB, 0.50100337E-10_JPRB, 0.51030794E-10_JPRB, 0.51951630E-10_JPRB, 0.52874084E-10_JPRB, &
  & 0.53738732E-10_JPRB, 0.54643654E-10_JPRB, 0.55503047E-10_JPRB, 0.56401120E-10_JPRB, 0.57310417E-10_JPRB, 0.58100250E-10_JPRB, &
  & 0.58844860E-10_JPRB, 0.59505824E-10_JPRB, 0.60166427E-10_JPRB, 0.60849756E-10_JPRB, 0.61521031E-10_JPRB, 0.62155087E-10_JPRB, &
  & 0.62683671E-10_JPRB, 0.63213872E-10_JPRB, 0.64010908E-10_JPRB, 0.64402442E-10_JPRB, 0.64770397E-10_JPRB, 0.65322102E-10_JPRB, &
  & 0.66067270E-10_JPRB, 0.66972525E-10_JPRB, 0.67702677E-10_JPRB, 0.67070467E-10_JPRB /)

RGHG4(:,80, 7) = (/ &
  & 0.22919406E-10_JPRB, 0.24715950E-10_JPRB, 0.25133489E-10_JPRB, 0.25521795E-10_JPRB, 0.25915107E-10_JPRB, 0.26681487E-10_JPRB, &
  & 0.15665916E-10_JPRB, 0.23169482E-10_JPRB, 0.23668121E-10_JPRB, 0.23963982E-10_JPRB, 0.24551351E-10_JPRB, 0.25045759E-10_JPRB, &
  & 0.25593938E-10_JPRB, 0.26205454E-10_JPRB, 0.26829192E-10_JPRB, 0.27539407E-10_JPRB, 0.28257926E-10_JPRB, 0.29030712E-10_JPRB, &
  & 0.29806765E-10_JPRB, 0.30631844E-10_JPRB, 0.31463672E-10_JPRB, 0.32354716E-10_JPRB, 0.33311576E-10_JPRB, 0.34271818E-10_JPRB, &
  & 0.35311195E-10_JPRB, 0.36442970E-10_JPRB, 0.37548475E-10_JPRB, 0.38758195E-10_JPRB, 0.39968643E-10_JPRB, 0.41219687E-10_JPRB, &
  & 0.42408528E-10_JPRB, 0.43586749E-10_JPRB, 0.44758405E-10_JPRB, 0.45939804E-10_JPRB, 0.47121054E-10_JPRB, 0.48309006E-10_JPRB, &
  & 0.49489482E-10_JPRB, 0.50604586E-10_JPRB, 0.51675900E-10_JPRB, 0.52694078E-10_JPRB, 0.53688470E-10_JPRB, 0.54669019E-10_JPRB, &
  & 0.55579964E-10_JPRB, 0.56520854E-10_JPRB, 0.57419160E-10_JPRB, 0.58349811E-10_JPRB, 0.59284348E-10_JPRB, 0.60078865E-10_JPRB, &
  & 0.60832991E-10_JPRB, 0.61499257E-10_JPRB, 0.62157883E-10_JPRB, 0.62834085E-10_JPRB, 0.63505173E-10_JPRB, 0.64148638E-10_JPRB, &
  & 0.64722644E-10_JPRB, 0.65272891E-10_JPRB, 0.65998727E-10_JPRB, 0.66286816E-10_JPRB, 0.66577736E-10_JPRB, 0.67051156E-10_JPRB, &
  & 0.67801369E-10_JPRB, 0.68739167E-10_JPRB, 0.69667459E-10_JPRB, 0.70121388E-10_JPRB /)

RGHG4(:,81, 7) = (/ &
  & 0.24829392E-10_JPRB, 0.25461647E-10_JPRB, 0.25756028E-10_JPRB, 0.26117969E-10_JPRB, 0.26488185E-10_JPRB, 0.27251836E-10_JPRB, &
  & 0.15907359E-10_JPRB, 0.23678037E-10_JPRB, 0.23868333E-10_JPRB, 0.24442698E-10_JPRB, 0.24850701E-10_JPRB, 0.25378298E-10_JPRB, &
  & 0.25963124E-10_JPRB, 0.26570886E-10_JPRB, 0.27224981E-10_JPRB, 0.27954004E-10_JPRB, 0.28725732E-10_JPRB, 0.29541831E-10_JPRB, &
  & 0.30367917E-10_JPRB, 0.31227205E-10_JPRB, 0.32098008E-10_JPRB, 0.33036015E-10_JPRB, 0.34014420E-10_JPRB, 0.34980480E-10_JPRB, &
  & 0.36120641E-10_JPRB, 0.37218374E-10_JPRB, 0.38345351E-10_JPRB, 0.39522014E-10_JPRB, 0.40659250E-10_JPRB, 0.41843359E-10_JPRB, &
  & 0.43046351E-10_JPRB, 0.44263624E-10_JPRB, 0.45455487E-10_JPRB, 0.46650735E-10_JPRB, 0.47850557E-10_JPRB, 0.49055853E-10_JPRB, &
  & 0.50260563E-10_JPRB, 0.51415153E-10_JPRB, 0.52528291E-10_JPRB, 0.53582850E-10_JPRB, 0.54616540E-10_JPRB, 0.55619048E-10_JPRB, &
  & 0.56556957E-10_JPRB, 0.57530290E-10_JPRB, 0.58433695E-10_JPRB, 0.59383068E-10_JPRB, 0.60331781E-10_JPRB, 0.61142723E-10_JPRB, &
  & 0.61900547E-10_JPRB, 0.62583945E-10_JPRB, 0.63232329E-10_JPRB, 0.63923027E-10_JPRB, 0.64583380E-10_JPRB, 0.65233208E-10_JPRB, &
  & 0.65778910E-10_JPRB, 0.66326548E-10_JPRB, 0.67095170E-10_JPRB, 0.67460558E-10_JPRB, 0.67829652E-10_JPRB, 0.68338078E-10_JPRB, &
  & 0.69061361E-10_JPRB, 0.70063608E-10_JPRB, 0.71079503E-10_JPRB, 0.72738759E-10_JPRB /)

RGHG4(:,82, 7) = (/ &
  & 0.26202512E-10_JPRB, 0.25770096E-10_JPRB, 0.25977302E-10_JPRB, 0.26232972E-10_JPRB, 0.26585616E-10_JPRB, 0.27328900E-10_JPRB, &
  & 0.16030387E-10_JPRB, 0.23639490E-10_JPRB, 0.24319359E-10_JPRB, 0.24528485E-10_JPRB, 0.25207784E-10_JPRB, 0.25609058E-10_JPRB, &
  & 0.26230837E-10_JPRB, 0.26860646E-10_JPRB, 0.27505623E-10_JPRB, 0.28256413E-10_JPRB, 0.29002007E-10_JPRB, 0.29824431E-10_JPRB, &
  & 0.30644629E-10_JPRB, 0.31516949E-10_JPRB, 0.32396603E-10_JPRB, 0.33373367E-10_JPRB, 0.34328197E-10_JPRB, 0.35335821E-10_JPRB, &
  & 0.36510479E-10_JPRB, 0.37528734E-10_JPRB, 0.38741968E-10_JPRB, 0.39890858E-10_JPRB, 0.41131234E-10_JPRB, 0.42323169E-10_JPRB, &
  & 0.43529690E-10_JPRB, 0.44709379E-10_JPRB, 0.45907153E-10_JPRB, 0.47118191E-10_JPRB, 0.48331027E-10_JPRB, 0.49551616E-10_JPRB, &
  & 0.50773784E-10_JPRB, 0.51953285E-10_JPRB, 0.53088211E-10_JPRB, 0.54175352E-10_JPRB, 0.55216262E-10_JPRB, 0.56233841E-10_JPRB, &
  & 0.57170099E-10_JPRB, 0.58130303E-10_JPRB, 0.59047579E-10_JPRB, 0.60019698E-10_JPRB, 0.60992350E-10_JPRB, 0.61815005E-10_JPRB, &
  & 0.62575743E-10_JPRB, 0.63278154E-10_JPRB, 0.63912611E-10_JPRB, 0.64632869E-10_JPRB, 0.65265238E-10_JPRB, 0.65965504E-10_JPRB, &
  & 0.66513184E-10_JPRB, 0.67115744E-10_JPRB, 0.67773821E-10_JPRB, 0.68017800E-10_JPRB, 0.68276343E-10_JPRB, 0.68759914E-10_JPRB, &
  & 0.69422114E-10_JPRB, 0.70469713E-10_JPRB, 0.71417525E-10_JPRB, 0.73717726E-10_JPRB /)

RGHG4(:,83, 7) = (/ &
  & 0.26256166E-10_JPRB, 0.25874285E-10_JPRB, 0.26092710E-10_JPRB, 0.26349298E-10_JPRB, 0.26788115E-10_JPRB, 0.27565960E-10_JPRB, &
  & 0.16132953E-10_JPRB, 0.24138106E-10_JPRB, 0.24256184E-10_JPRB, 0.24959434E-10_JPRB, 0.25283888E-10_JPRB, 0.25868439E-10_JPRB, &
  & 0.26424085E-10_JPRB, 0.27067517E-10_JPRB, 0.27739857E-10_JPRB, 0.28485395E-10_JPRB, 0.29275447E-10_JPRB, 0.30105599E-10_JPRB, &
  & 0.30944899E-10_JPRB, 0.31818617E-10_JPRB, 0.32702483E-10_JPRB, 0.33679635E-10_JPRB, 0.34595226E-10_JPRB, 0.35709550E-10_JPRB, &
  & 0.36800948E-10_JPRB, 0.37873312E-10_JPRB, 0.39097885E-10_JPRB, 0.40226530E-10_JPRB, 0.41414861E-10_JPRB, 0.42625199E-10_JPRB, &
  & 0.43831893E-10_JPRB, 0.45037699E-10_JPRB, 0.46237271E-10_JPRB, 0.47458256E-10_JPRB, 0.48682183E-10_JPRB, 0.49910413E-10_JPRB, &
  & 0.51154636E-10_JPRB, 0.52341752E-10_JPRB, 0.53500215E-10_JPRB, 0.54581898E-10_JPRB, 0.55646945E-10_JPRB, 0.56667334E-10_JPRB, &
  & 0.57630560E-10_JPRB, 0.58614349E-10_JPRB, 0.59536015E-10_JPRB, 0.60495810E-10_JPRB, 0.61463973E-10_JPRB, 0.62284886E-10_JPRB, &
  & 0.63060765E-10_JPRB, 0.63769469E-10_JPRB, 0.64405280E-10_JPRB, 0.65144688E-10_JPRB, 0.65752875E-10_JPRB, 0.66499264E-10_JPRB, &
  & 0.66967001E-10_JPRB, 0.67611632E-10_JPRB, 0.68249711E-10_JPRB, 0.68629602E-10_JPRB, 0.68858037E-10_JPRB, 0.69443958E-10_JPRB, &
  & 0.69981305E-10_JPRB, 0.71080253E-10_JPRB, 0.71913475E-10_JPRB, 0.73727011E-10_JPRB /)

RGHG4(:,84, 7) = (/ &
  & 0.26432242E-10_JPRB, 0.26014043E-10_JPRB, 0.26118045E-10_JPRB, 0.26401511E-10_JPRB, 0.26857294E-10_JPRB, 0.27554532E-10_JPRB, &
  & 0.16188429E-10_JPRB, 0.23932294E-10_JPRB, 0.24772816E-10_JPRB, 0.24921988E-10_JPRB, 0.25620471E-10_JPRB, 0.25982183E-10_JPRB, &
  & 0.26616806E-10_JPRB, 0.27246276E-10_JPRB, 0.27903874E-10_JPRB, 0.28652644E-10_JPRB, 0.29427120E-10_JPRB, 0.30251617E-10_JPRB, &
  & 0.31102079E-10_JPRB, 0.31979919E-10_JPRB, 0.32874748E-10_JPRB, 0.33833429E-10_JPRB, 0.34783797E-10_JPRB, 0.35926217E-10_JPRB, &
  & 0.36913757E-10_JPRB, 0.38138014E-10_JPRB, 0.39246849E-10_JPRB, 0.40457401E-10_JPRB, 0.41677200E-10_JPRB, 0.42877150E-10_JPRB, &
  & 0.44096393E-10_JPRB, 0.45288759E-10_JPRB, 0.46501469E-10_JPRB, 0.47732155E-10_JPRB, 0.48966858E-10_JPRB, 0.50217039E-10_JPRB, &
  & 0.51463986E-10_JPRB, 0.52678847E-10_JPRB, 0.53837042E-10_JPRB, 0.54946579E-10_JPRB, 0.55996915E-10_JPRB, 0.57017068E-10_JPRB, &
  & 0.57954246E-10_JPRB, 0.58928404E-10_JPRB, 0.59816950E-10_JPRB, 0.60819412E-10_JPRB, 0.61805762E-10_JPRB, 0.62642370E-10_JPRB, &
  & 0.63436104E-10_JPRB, 0.64135634E-10_JPRB, 0.64797806E-10_JPRB, 0.65526778E-10_JPRB, 0.66140773E-10_JPRB, 0.66919796E-10_JPRB, &
  & 0.67366952E-10_JPRB, 0.68124208E-10_JPRB, 0.68591695E-10_JPRB, 0.68967401E-10_JPRB, 0.68980467E-10_JPRB, 0.69675758E-10_JPRB, &
  & 0.70112742E-10_JPRB, 0.71275978E-10_JPRB, 0.72119942E-10_JPRB, 0.74190813E-10_JPRB /)

RGHG4(:,85, 7) = (/ &
  & 0.26171275E-10_JPRB, 0.26064118E-10_JPRB, 0.26094252E-10_JPRB, 0.26495414E-10_JPRB, 0.26928086E-10_JPRB, 0.27673417E-10_JPRB, &
  & 0.16308481E-10_JPRB, 0.24437573E-10_JPRB, 0.24606877E-10_JPRB, 0.25368974E-10_JPRB, 0.25664937E-10_JPRB, 0.26225768E-10_JPRB, &
  & 0.26757728E-10_JPRB, 0.27382856E-10_JPRB, 0.28022898E-10_JPRB, 0.28767868E-10_JPRB, 0.29551913E-10_JPRB, 0.30402299E-10_JPRB, &
  & 0.31258777E-10_JPRB, 0.32131697E-10_JPRB, 0.33040383E-10_JPRB, 0.33980974E-10_JPRB, 0.34982850E-10_JPRB, 0.36028455E-10_JPRB, &
  & 0.37116626E-10_JPRB, 0.38262740E-10_JPRB, 0.39417112E-10_JPRB, 0.40632765E-10_JPRB, 0.41811415E-10_JPRB, 0.43068656E-10_JPRB, &
  & 0.44270799E-10_JPRB, 0.45490053E-10_JPRB, 0.46700904E-10_JPRB, 0.47935877E-10_JPRB, 0.49174095E-10_JPRB, 0.50427988E-10_JPRB, &
  & 0.51707555E-10_JPRB, 0.52920539E-10_JPRB, 0.54096411E-10_JPRB, 0.55199265E-10_JPRB, 0.56272414E-10_JPRB, 0.57306122E-10_JPRB, &
  & 0.58281782E-10_JPRB, 0.59251139E-10_JPRB, 0.60183504E-10_JPRB, 0.61121719E-10_JPRB, 0.62104842E-10_JPRB, 0.62915555E-10_JPRB, &
  & 0.63716137E-10_JPRB, 0.64415633E-10_JPRB, 0.65091037E-10_JPRB, 0.65811322E-10_JPRB, 0.66451976E-10_JPRB, 0.67224677E-10_JPRB, &
  & 0.67649351E-10_JPRB, 0.68422774E-10_JPRB, 0.68842460E-10_JPRB, 0.69392776E-10_JPRB, 0.69326662E-10_JPRB, 0.70121381E-10_JPRB, &
  & 0.70486388E-10_JPRB, 0.71632589E-10_JPRB, 0.72421978E-10_JPRB, 0.74338036E-10_JPRB /)

RGHG4(:,86, 7) = (/ &
  & 0.27322280E-10_JPRB, 0.26314957E-10_JPRB, 0.26085793E-10_JPRB, 0.26587064E-10_JPRB, 0.26941479E-10_JPRB, 0.27740223E-10_JPRB, &
  & 0.16335338E-10_JPRB, 0.24263409E-10_JPRB, 0.25227887E-10_JPRB, 0.25342398E-10_JPRB, 0.26002762E-10_JPRB, 0.26335243E-10_JPRB, &
  & 0.26932300E-10_JPRB, 0.27463807E-10_JPRB, 0.28096950E-10_JPRB, 0.28791726E-10_JPRB, 0.29576810E-10_JPRB, 0.30391904E-10_JPRB, &
  & 0.31286338E-10_JPRB, 0.32181733E-10_JPRB, 0.33128559E-10_JPRB, 0.34065063E-10_JPRB, 0.35072698E-10_JPRB, 0.36103807E-10_JPRB, &
  & 0.37204569E-10_JPRB, 0.38347461E-10_JPRB, 0.39512397E-10_JPRB, 0.40711198E-10_JPRB, 0.41959356E-10_JPRB, 0.43184255E-10_JPRB, &
  & 0.44434591E-10_JPRB, 0.45645095E-10_JPRB, 0.46873193E-10_JPRB, 0.48124650E-10_JPRB, 0.49381426E-10_JPRB, 0.50646740E-10_JPRB, &
  & 0.51915715E-10_JPRB, 0.53152430E-10_JPRB, 0.54341611E-10_JPRB, 0.55450897E-10_JPRB, 0.56513575E-10_JPRB, 0.57538731E-10_JPRB, &
  & 0.58488270E-10_JPRB, 0.59458029E-10_JPRB, 0.60327271E-10_JPRB, 0.61314218E-10_JPRB, 0.62291866E-10_JPRB, 0.63132929E-10_JPRB, &
  & 0.63936231E-10_JPRB, 0.64636678E-10_JPRB, 0.65324704E-10_JPRB, 0.66030126E-10_JPRB, 0.66703684E-10_JPRB, 0.67461967E-10_JPRB, &
  & 0.67936254E-10_JPRB, 0.68722937E-10_JPRB, 0.69104972E-10_JPRB, 0.69568400E-10_JPRB, 0.69444651E-10_JPRB, 0.70212447E-10_JPRB, &
  & 0.70621932E-10_JPRB, 0.71757968E-10_JPRB, 0.72578908E-10_JPRB, 0.74590223E-10_JPRB /)

RGHG4(:,87, 7) = (/ &
  & 0.25878235E-10_JPRB, 0.26007595E-10_JPRB, 0.26058026E-10_JPRB, 0.26646853E-10_JPRB, 0.26914289E-10_JPRB, 0.27850460E-10_JPRB, &
  & 0.16470748E-10_JPRB, 0.24746488E-10_JPRB, 0.25006599E-10_JPRB, 0.25728437E-10_JPRB, 0.26062548E-10_JPRB, 0.26510906E-10_JPRB, &
  & 0.27020036E-10_JPRB, 0.27558910E-10_JPRB, 0.28105523E-10_JPRB, 0.28805746E-10_JPRB, 0.29560077E-10_JPRB, 0.30415049E-10_JPRB, &
  & 0.31305965E-10_JPRB, 0.32240394E-10_JPRB, 0.33181721E-10_JPRB, 0.34142845E-10_JPRB, 0.35148957E-10_JPRB, 0.36181232E-10_JPRB, &
  & 0.37288953E-10_JPRB, 0.38407694E-10_JPRB, 0.39583951E-10_JPRB, 0.40810126E-10_JPRB, 0.42036350E-10_JPRB, 0.43310605E-10_JPRB, &
  & 0.44550856E-10_JPRB, 0.45788654E-10_JPRB, 0.47014805E-10_JPRB, 0.48244308E-10_JPRB, 0.49487820E-10_JPRB, 0.50771509E-10_JPRB, &
  & 0.52065640E-10_JPRB, 0.53304351E-10_JPRB, 0.54496400E-10_JPRB, 0.55622510E-10_JPRB, 0.56720083E-10_JPRB, 0.57773859E-10_JPRB, &
  & 0.58756125E-10_JPRB, 0.59739824E-10_JPRB, 0.60632735E-10_JPRB, 0.61562512E-10_JPRB, 0.62520766E-10_JPRB, 0.63310510E-10_JPRB, &
  & 0.64108621E-10_JPRB, 0.64788258E-10_JPRB, 0.65482161E-10_JPRB, 0.66184752E-10_JPRB, 0.66887856E-10_JPRB, 0.67631047E-10_JPRB, &
  & 0.68133263E-10_JPRB, 0.68858468E-10_JPRB, 0.69321562E-10_JPRB, 0.69759858E-10_JPRB, 0.69756458E-10_JPRB, 0.70439002E-10_JPRB, &
  & 0.70904588E-10_JPRB, 0.71981580E-10_JPRB, 0.72777707E-10_JPRB, 0.74723054E-10_JPRB /)

RGHG4(:,88, 7) = (/ &
  & 0.26143853E-10_JPRB, 0.26390739E-10_JPRB, 0.26080291E-10_JPRB, 0.26673063E-10_JPRB, 0.26939400E-10_JPRB, 0.28004323E-10_JPRB, &
  & 0.16424220E-10_JPRB, 0.24527415E-10_JPRB, 0.25517338E-10_JPRB, 0.25631709E-10_JPRB, 0.26141370E-10_JPRB, 0.26568638E-10_JPRB, &
  & 0.26999068E-10_JPRB, 0.27624712E-10_JPRB, 0.28193033E-10_JPRB, 0.28875326E-10_JPRB, 0.29560104E-10_JPRB, 0.30414248E-10_JPRB, &
  & 0.31278913E-10_JPRB, 0.32245612E-10_JPRB, 0.33201612E-10_JPRB, 0.34192760E-10_JPRB, 0.35188068E-10_JPRB, 0.36234557E-10_JPRB, &
  & 0.37318690E-10_JPRB, 0.38451530E-10_JPRB, 0.39625369E-10_JPRB, 0.40842975E-10_JPRB, 0.42098797E-10_JPRB, 0.43368250E-10_JPRB, &
  & 0.44632156E-10_JPRB, 0.45872407E-10_JPRB, 0.47135993E-10_JPRB, 0.48430464E-10_JPRB, 0.49694120E-10_JPRB, 0.50948627E-10_JPRB, &
  & 0.52233246E-10_JPRB, 0.53485244E-10_JPRB, 0.54675101E-10_JPRB, 0.55805832E-10_JPRB, 0.56887595E-10_JPRB, 0.57945041E-10_JPRB, &
  & 0.58913541E-10_JPRB, 0.59873446E-10_JPRB, 0.60745846E-10_JPRB, 0.61684859E-10_JPRB, 0.62640074E-10_JPRB, 0.63461021E-10_JPRB, &
  & 0.64245151E-10_JPRB, 0.64936362E-10_JPRB, 0.65615388E-10_JPRB, 0.66319943E-10_JPRB, 0.67032414E-10_JPRB, 0.67768895E-10_JPRB, &
  & 0.68323590E-10_JPRB, 0.69032460E-10_JPRB, 0.69526440E-10_JPRB, 0.69844082E-10_JPRB, 0.69869888E-10_JPRB, 0.70487227E-10_JPRB, &
  & 0.71002974E-10_JPRB, 0.72068206E-10_JPRB, 0.72899534E-10_JPRB, 0.74858737E-10_JPRB /)

RGHG4(:,89, 7) = (/ &
  & 0.27300729E-10_JPRB, 0.26078018E-10_JPRB, 0.26133757E-10_JPRB, 0.26607406E-10_JPRB, 0.26907957E-10_JPRB, 0.27724417E-10_JPRB, &
  & 0.16365647E-10_JPRB, 0.24905805E-10_JPRB, 0.25094170E-10_JPRB, 0.25556510E-10_JPRB, 0.26075822E-10_JPRB, 0.26389975E-10_JPRB, &
  & 0.26982118E-10_JPRB, 0.27380313E-10_JPRB, 0.27906989E-10_JPRB, 0.28741176E-10_JPRB, 0.29580432E-10_JPRB, 0.30471122E-10_JPRB, &
  & 0.31355675E-10_JPRB, 0.32309721E-10_JPRB, 0.33252068E-10_JPRB, 0.34213438E-10_JPRB, 0.35208864E-10_JPRB, 0.36236562E-10_JPRB, &
  & 0.37322884E-10_JPRB, 0.38445250E-10_JPRB, 0.39612414E-10_JPRB, 0.40835346E-10_JPRB, 0.42089075E-10_JPRB, 0.43381135E-10_JPRB, &
  & 0.44662617E-10_JPRB, 0.45911056E-10_JPRB, 0.47134054E-10_JPRB, 0.48388758E-10_JPRB, 0.49678567E-10_JPRB, 0.51008902E-10_JPRB, &
  & 0.52330633E-10_JPRB, 0.53575040E-10_JPRB, 0.54790061E-10_JPRB, 0.55942494E-10_JPRB, 0.57042399E-10_JPRB, 0.58119627E-10_JPRB, &
  & 0.59118904E-10_JPRB, 0.60102819E-10_JPRB, 0.60952396E-10_JPRB, 0.61880299E-10_JPRB, 0.62809535E-10_JPRB, 0.63590085E-10_JPRB, &
  & 0.64357582E-10_JPRB, 0.65030537E-10_JPRB, 0.65705850E-10_JPRB, 0.66404472E-10_JPRB, 0.67134652E-10_JPRB, 0.67870480E-10_JPRB, &
  & 0.68438762E-10_JPRB, 0.69120237E-10_JPRB, 0.69659598E-10_JPRB, 0.69971057E-10_JPRB, 0.70061151E-10_JPRB, 0.70637315E-10_JPRB, &
  & 0.71186911E-10_JPRB, 0.72193224E-10_JPRB, 0.73051398E-10_JPRB, 0.74944828E-10_JPRB /)

RGHG4(:,90, 7) = (/ &
  & 0.26050075E-10_JPRB, 0.26417913E-10_JPRB, 0.26088754E-10_JPRB, 0.26551518E-10_JPRB, 0.26803388E-10_JPRB, 0.27503911E-10_JPRB, &
  & 0.16234082E-10_JPRB, 0.24250411E-10_JPRB, 0.24915393E-10_JPRB, 0.25434915E-10_JPRB, 0.25728558E-10_JPRB, 0.27101937E-10_JPRB, &
  & 0.26794150E-10_JPRB, 0.27557508E-10_JPRB, 0.28135657E-10_JPRB, 0.29366912E-10_JPRB, 0.29707934E-10_JPRB, 0.30543464E-10_JPRB, &
  & 0.31351984E-10_JPRB, 0.32270818E-10_JPRB, 0.33184063E-10_JPRB, 0.34162385E-10_JPRB, 0.35150466E-10_JPRB, 0.36180423E-10_JPRB, &
  & 0.37246622E-10_JPRB, 0.38351211E-10_JPRB, 0.39510603E-10_JPRB, 0.40732782E-10_JPRB, 0.41995133E-10_JPRB, 0.43300696E-10_JPRB, &
  & 0.44615919E-10_JPRB, 0.45938378E-10_JPRB, 0.47265150E-10_JPRB, 0.48605186E-10_JPRB, 0.49892732E-10_JPRB, 0.51156173E-10_JPRB, &
  & 0.52484097E-10_JPRB, 0.53749147E-10_JPRB, 0.54955381E-10_JPRB, 0.56080630E-10_JPRB, 0.57183400E-10_JPRB, 0.58217993E-10_JPRB, &
  & 0.59189507E-10_JPRB, 0.60157032E-10_JPRB, 0.61007380E-10_JPRB, 0.61906563E-10_JPRB, 0.62862181E-10_JPRB, 0.63672179E-10_JPRB, &
  & 0.64448995E-10_JPRB, 0.65134786E-10_JPRB, 0.65802183E-10_JPRB, 0.66499924E-10_JPRB, 0.67237417E-10_JPRB, 0.67965078E-10_JPRB, &
  & 0.68560206E-10_JPRB, 0.69231842E-10_JPRB, 0.69793817E-10_JPRB, 0.70028476E-10_JPRB, 0.70159906E-10_JPRB, 0.70656835E-10_JPRB, &
  & 0.71295747E-10_JPRB, 0.72222069E-10_JPRB, 0.73182002E-10_JPRB, 0.75020781E-10_JPRB /)

RGHG4(:,91, 7) = (/ &
  & 0.26221728E-10_JPRB, 0.26374292E-10_JPRB, 0.26062447E-10_JPRB, 0.26329314E-10_JPRB, 0.26635333E-10_JPRB, 0.27026055E-10_JPRB, &
  & 0.12473428E-10_JPRB, 0.57295522E-11_JPRB, 0.13112141E-10_JPRB, 0.27760431E-10_JPRB, 0.27957007E-10_JPRB, 0.35960155E-10_JPRB, &
  & 0.33881200E-10_JPRB, 0.27475055E-10_JPRB, 0.20978044E-10_JPRB, 0.30982949E-10_JPRB, 0.29719647E-10_JPRB, 0.30173950E-10_JPRB, &
  & 0.31531611E-10_JPRB, 0.32309034E-10_JPRB, 0.33182537E-10_JPRB, 0.34087941E-10_JPRB, 0.35045168E-10_JPRB, 0.36028399E-10_JPRB, &
  & 0.37036089E-10_JPRB, 0.38117377E-10_JPRB, 0.39286234E-10_JPRB, 0.40517686E-10_JPRB, 0.41794318E-10_JPRB, 0.43099409E-10_JPRB, &
  & 0.44416658E-10_JPRB, 0.45742306E-10_JPRB, 0.47027753E-10_JPRB, 0.48417950E-10_JPRB, 0.49793107E-10_JPRB, 0.51188068E-10_JPRB, &
  & 0.52533755E-10_JPRB, 0.53837754E-10_JPRB, 0.55072145E-10_JPRB, 0.56235589E-10_JPRB, 0.54512256E-10_JPRB, 0.55650946E-10_JPRB, &
  & 0.59255482E-10_JPRB, 0.60317938E-10_JPRB, 0.61127603E-10_JPRB, 0.61944075E-10_JPRB, 0.62927497E-10_JPRB, 0.63787788E-10_JPRB, &
  & 0.64498198E-10_JPRB, 0.65221099E-10_JPRB, 0.65886227E-10_JPRB, 0.66568730E-10_JPRB, 0.67347371E-10_JPRB, 0.68058524E-10_JPRB, &
  & 0.68647199E-10_JPRB, 0.69306873E-10_JPRB, 0.69899538E-10_JPRB, 0.70092321E-10_JPRB, 0.70305851E-10_JPRB, 0.70708620E-10_JPRB, &
  & 0.71467755E-10_JPRB, 0.72242372E-10_JPRB, 0.73376701E-10_JPRB, 0.75059341E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG4(:, 1, 8) = (/ &
  & 0.96362207E-09_JPRB, 0.96223762E-09_JPRB, 0.96152653E-09_JPRB, 0.15694385E-13_JPRB, 0.12517129E-13_JPRB, 0.14521490E-13_JPRB, &
  & 0.21471584E-13_JPRB, 0.34785543E-13_JPRB, 0.57226847E-13_JPRB, 0.69029072E-13_JPRB, 0.83326541E-13_JPRB, 0.88555763E-13_JPRB, &
  & 0.92154901E-13_JPRB, 0.94887246E-13_JPRB, 0.96761520E-13_JPRB, 0.98281978E-13_JPRB, 0.99644421E-13_JPRB, 0.10643565E-12_JPRB, &
  & 0.10627640E-12_JPRB, 0.10632254E-12_JPRB, 0.10654953E-12_JPRB, 0.10629769E-12_JPRB, 0.10567851E-12_JPRB, 0.10493878E-12_JPRB, &
  & 0.10439618E-12_JPRB, 0.10432767E-12_JPRB, 0.10499011E-12_JPRB, 0.10652814E-12_JPRB, 0.10895671E-12_JPRB, 0.11215812E-12_JPRB, &
  & 0.11583479E-12_JPRB, 0.11951938E-12_JPRB, 0.12860763E-12_JPRB, 0.12886991E-12_JPRB, 0.12827665E-12_JPRB, 0.12640174E-12_JPRB, &
  & 0.12336024E-12_JPRB, 0.11973499E-12_JPRB, 0.11595812E-12_JPRB, 0.11270813E-12_JPRB, 0.11013139E-12_JPRB, 0.10810037E-12_JPRB, &
  & 0.10674384E-12_JPRB, 0.10560823E-12_JPRB, 0.10489057E-12_JPRB, 0.10411837E-12_JPRB, 0.10408687E-12_JPRB, 0.11005126E-12_JPRB, &
  & 0.10935389E-12_JPRB, 0.10941348E-12_JPRB, 0.10985689E-12_JPRB, 0.11051032E-12_JPRB, 0.11128817E-12_JPRB, 0.11215798E-12_JPRB, &
  & 0.11772208E-12_JPRB, 0.11713067E-12_JPRB, 0.11689469E-12_JPRB, 0.11895613E-12_JPRB, 0.11604216E-12_JPRB, 0.11382469E-12_JPRB, &
  & 0.11093273E-12_JPRB, 0.10730771E-12_JPRB, 0.92078953E-13_JPRB, 0.80649849E-13_JPRB /)

RGHG4(:, 2, 8) = (/ &
  & 0.10149954E-19_JPRB, 0.10148828E-19_JPRB, 0.10146834E-19_JPRB, 0.13786779E-12_JPRB, 0.13972989E-12_JPRB, 0.14420224E-12_JPRB, &
  & 0.14796398E-12_JPRB, 0.15027642E-12_JPRB, 0.19092819E-12_JPRB, 0.20577061E-12_JPRB, 0.22170648E-12_JPRB, 0.23749671E-12_JPRB, &
  & 0.25339583E-12_JPRB, 0.27244122E-12_JPRB, 0.29538037E-12_JPRB, 0.32373803E-12_JPRB, 0.35730563E-12_JPRB, 0.38891744E-12_JPRB, &
  & 0.41758131E-12_JPRB, 0.43981770E-12_JPRB, 0.45697051E-12_JPRB, 0.46968180E-12_JPRB, 0.48142149E-12_JPRB, 0.49391399E-12_JPRB, &
  & 0.50854015E-12_JPRB, 0.52788898E-12_JPRB, 0.55730241E-12_JPRB, 0.60399401E-12_JPRB, 0.67179308E-12_JPRB, 0.75819792E-12_JPRB, &
  & 0.85671043E-12_JPRB, 0.97254594E-12_JPRB, 0.10500472E-11_JPRB, 0.11085283E-11_JPRB, 0.11386696E-11_JPRB, 0.11413584E-11_JPRB, &
  & 0.11199846E-11_JPRB, 0.10808383E-11_JPRB, 0.10316300E-11_JPRB, 0.98275110E-12_JPRB, 0.94239785E-12_JPRB, 0.90313222E-12_JPRB, &
  & 0.87327449E-12_JPRB, 0.83461650E-12_JPRB, 0.80234902E-12_JPRB, 0.76013702E-12_JPRB, 0.72380106E-12_JPRB, 0.69146061E-12_JPRB, &
  & 0.65382682E-12_JPRB, 0.61647302E-12_JPRB, 0.58493520E-12_JPRB, 0.55960049E-12_JPRB, 0.53882018E-12_JPRB, 0.52415716E-12_JPRB, &
  & 0.51886056E-12_JPRB, 0.50356827E-12_JPRB, 0.47957807E-12_JPRB, 0.45161699E-12_JPRB, 0.41847081E-12_JPRB, 0.38124790E-12_JPRB, &
  & 0.34983849E-12_JPRB, 0.33012617E-12_JPRB, 0.31737590E-12_JPRB, 0.29926934E-12_JPRB /)

RGHG4(:, 3, 8) = (/ &
  & 0.56646702E-20_JPRB, 0.56660531E-20_JPRB, 0.56670402E-20_JPRB, 0.44637026E-12_JPRB, 0.35019581E-12_JPRB, 0.34922659E-12_JPRB, &
  & 0.34892675E-12_JPRB, 0.34468378E-12_JPRB, 0.38332442E-12_JPRB, 0.40301668E-12_JPRB, 0.43469593E-12_JPRB, 0.47941116E-12_JPRB, &
  & 0.53404601E-12_JPRB, 0.59487631E-12_JPRB, 0.65758933E-12_JPRB, 0.72303990E-12_JPRB, 0.79337513E-12_JPRB, 0.85965339E-12_JPRB, &
  & 0.92151699E-12_JPRB, 0.97127352E-12_JPRB, 0.10088625E-11_JPRB, 0.10331717E-11_JPRB, 0.10502287E-11_JPRB, 0.10643358E-11_JPRB, &
  & 0.10866246E-11_JPRB, 0.11313456E-11_JPRB, 0.12072262E-11_JPRB, 0.13177657E-11_JPRB, 0.14541997E-11_JPRB, 0.16102857E-11_JPRB, &
  & 0.17753493E-11_JPRB, 0.19640236E-11_JPRB, 0.20944785E-11_JPRB, 0.22038226E-11_JPRB, 0.22710681E-11_JPRB, 0.23000547E-11_JPRB, &
  & 0.22950164E-11_JPRB, 0.22613484E-11_JPRB, 0.22021827E-11_JPRB, 0.21342737E-11_JPRB, 0.20666561E-11_JPRB, 0.19953136E-11_JPRB, &
  & 0.19372908E-11_JPRB, 0.18617519E-11_JPRB, 0.17962657E-11_JPRB, 0.17127986E-11_JPRB, 0.16385771E-11_JPRB, 0.15679081E-11_JPRB, &
  & 0.14818335E-11_JPRB, 0.13916468E-11_JPRB, 0.13044282E-11_JPRB, 0.12276007E-11_JPRB, 0.11507145E-11_JPRB, 0.10796535E-11_JPRB, &
  & 0.10132943E-11_JPRB, 0.93243588E-12_JPRB, 0.81695154E-12_JPRB, 0.73468580E-12_JPRB, 0.67395037E-12_JPRB, 0.62319204E-12_JPRB, &
  & 0.58808871E-12_JPRB, 0.55626163E-12_JPRB, 0.50774315E-12_JPRB, 0.44049977E-12_JPRB /)

RGHG4(:, 4, 8) = (/ &
  & 0.33010597E-20_JPRB, 0.33040730E-20_JPRB, 0.33073617E-20_JPRB, 0.18332751E-11_JPRB, 0.10097328E-11_JPRB, 0.91311496E-12_JPRB, &
  & 0.90862815E-12_JPRB, 0.90488538E-12_JPRB, 0.10532330E-11_JPRB, 0.11317779E-11_JPRB, 0.12295107E-11_JPRB, 0.13428888E-11_JPRB, &
  & 0.14722497E-11_JPRB, 0.16198072E-11_JPRB, 0.17746025E-11_JPRB, 0.19286048E-11_JPRB, 0.20829254E-11_JPRB, 0.22272102E-11_JPRB, &
  & 0.23679958E-11_JPRB, 0.24943311E-11_JPRB, 0.26028301E-11_JPRB, 0.26859873E-11_JPRB, 0.27537265E-11_JPRB, 0.28109641E-11_JPRB, &
  & 0.28671945E-11_JPRB, 0.29416558E-11_JPRB, 0.30504210E-11_JPRB, 0.32064494E-11_JPRB, 0.33975498E-11_JPRB, 0.36202135E-11_JPRB, &
  & 0.38552096E-11_JPRB, 0.41229359E-11_JPRB, 0.43141441E-11_JPRB, 0.44973261E-11_JPRB, 0.46287215E-11_JPRB, 0.47138296E-11_JPRB, &
  & 0.47571756E-11_JPRB, 0.47678567E-11_JPRB, 0.47413662E-11_JPRB, 0.46996638E-11_JPRB, 0.46507203E-11_JPRB, 0.45817980E-11_JPRB, &
  & 0.45260449E-11_JPRB, 0.44340781E-11_JPRB, 0.43513309E-11_JPRB, 0.42385019E-11_JPRB, 0.41334497E-11_JPRB, 0.40309691E-11_JPRB, &
  & 0.38827045E-11_JPRB, 0.37203582E-11_JPRB, 0.35403082E-11_JPRB, 0.33607184E-11_JPRB, 0.31576235E-11_JPRB, 0.29689545E-11_JPRB, &
  & 0.27704325E-11_JPRB, 0.25708979E-11_JPRB, 0.23487100E-11_JPRB, 0.21461563E-11_JPRB, 0.19724485E-11_JPRB, 0.18229326E-11_JPRB, &
  & 0.16946732E-11_JPRB, 0.15747615E-11_JPRB, 0.14753540E-11_JPRB, 0.12721758E-11_JPRB /)

RGHG4(:, 5, 8) = (/ &
  & 0.19970701E-20_JPRB, 0.19996875E-20_JPRB, 0.20033250E-20_JPRB, 0.56560156E-11_JPRB, 0.32763174E-11_JPRB, 0.25835918E-11_JPRB, &
  & 0.25338869E-11_JPRB, 0.25523442E-11_JPRB, 0.28458449E-11_JPRB, 0.30725986E-11_JPRB, 0.33616462E-11_JPRB, 0.36988108E-11_JPRB, &
  & 0.40643430E-11_JPRB, 0.44542586E-11_JPRB, 0.48688900E-11_JPRB, 0.53054830E-11_JPRB, 0.57408154E-11_JPRB, 0.61391326E-11_JPRB, &
  & 0.65207631E-11_JPRB, 0.68901378E-11_JPRB, 0.72536686E-11_JPRB, 0.75921795E-11_JPRB, 0.79061740E-11_JPRB, 0.81827722E-11_JPRB, &
  & 0.84243480E-11_JPRB, 0.86434766E-11_JPRB, 0.88526608E-11_JPRB, 0.90794074E-11_JPRB, 0.93225106E-11_JPRB, 0.96047476E-11_JPRB, &
  & 0.99127043E-11_JPRB, 0.10282333E-10_JPRB, 0.10563607E-10_JPRB, 0.10875949E-10_JPRB, 0.11143906E-10_JPRB, 0.11370889E-10_JPRB, &
  & 0.11560092E-10_JPRB, 0.11720899E-10_JPRB, 0.11844742E-10_JPRB, 0.11946711E-10_JPRB, 0.12029872E-10_JPRB, 0.12053095E-10_JPRB, &
  & 0.12069294E-10_JPRB, 0.12006005E-10_JPRB, 0.11923594E-10_JPRB, 0.11775713E-10_JPRB, 0.11617571E-10_JPRB, 0.11448603E-10_JPRB, &
  & 0.11156796E-10_JPRB, 0.10813097E-10_JPRB, 0.10385567E-10_JPRB, 0.99153645E-11_JPRB, 0.93657911E-11_JPRB, 0.88024527E-11_JPRB, &
  & 0.81956100E-11_JPRB, 0.75407892E-11_JPRB, 0.68951711E-11_JPRB, 0.63284239E-11_JPRB, 0.58103166E-11_JPRB, 0.53546980E-11_JPRB, &
  & 0.49752355E-11_JPRB, 0.46501492E-11_JPRB, 0.44452489E-11_JPRB, 0.40131531E-11_JPRB /)

RGHG4(:, 6, 8) = (/ &
  & 0.12456175E-20_JPRB, 0.12473434E-20_JPRB, 0.14577631E-09_JPRB, 0.13849624E-10_JPRB, 0.99230901E-11_JPRB, 0.77341406E-11_JPRB, &
  & 0.73871621E-11_JPRB, 0.73693794E-11_JPRB, 0.78556727E-11_JPRB, 0.85116532E-11_JPRB, 0.93445711E-11_JPRB, 0.10298467E-10_JPRB, &
  & 0.11352222E-10_JPRB, 0.12470546E-10_JPRB, 0.13593694E-10_JPRB, 0.14734129E-10_JPRB, 0.15914025E-10_JPRB, 0.17069637E-10_JPRB, &
  & 0.18143639E-10_JPRB, 0.19129880E-10_JPRB, 0.20097512E-10_JPRB, 0.21039528E-10_JPRB, 0.21962862E-10_JPRB, 0.22845763E-10_JPRB, &
  & 0.23654233E-10_JPRB, 0.24349552E-10_JPRB, 0.24893575E-10_JPRB, 0.25286766E-10_JPRB, 0.25565152E-10_JPRB, 0.25798254E-10_JPRB, &
  & 0.26046226E-10_JPRB, 0.26355614E-10_JPRB, 0.26595939E-10_JPRB, 0.27037858E-10_JPRB, 0.27566916E-10_JPRB, 0.28155782E-10_JPRB, &
  & 0.28769896E-10_JPRB, 0.29389088E-10_JPRB, 0.29988050E-10_JPRB, 0.30543641E-10_JPRB, 0.31042433E-10_JPRB, 0.31398297E-10_JPRB, &
  & 0.31659699E-10_JPRB, 0.31759987E-10_JPRB, 0.31735510E-10_JPRB, 0.31553381E-10_JPRB, 0.31306575E-10_JPRB, 0.30963124E-10_JPRB, &
  & 0.30383397E-10_JPRB, 0.29634070E-10_JPRB, 0.28688722E-10_JPRB, 0.27596422E-10_JPRB, 0.26320637E-10_JPRB, 0.24965108E-10_JPRB, &
  & 0.23537004E-10_JPRB, 0.22029260E-10_JPRB, 0.20508694E-10_JPRB, 0.19011483E-10_JPRB, 0.17678560E-10_JPRB, 0.16482631E-10_JPRB, &
  & 0.15363967E-10_JPRB, 0.14442112E-10_JPRB, 0.14253265E-10_JPRB, 0.13710244E-10_JPRB /)

RGHG4(:, 7, 8) = (/ &
  & 0.87736457E-10_JPRB, 0.70497630E-09_JPRB, 0.11736615E-08_JPRB, 0.29862047E-10_JPRB, 0.26795635E-10_JPRB, 0.23279436E-10_JPRB, &
  & 0.22202098E-10_JPRB, 0.21944179E-10_JPRB, 0.22857057E-10_JPRB, 0.24556046E-10_JPRB, 0.26707135E-10_JPRB, 0.29085295E-10_JPRB, &
  & 0.31662031E-10_JPRB, 0.34414190E-10_JPRB, 0.37214343E-10_JPRB, 0.39896066E-10_JPRB, 0.42370850E-10_JPRB, 0.44742363E-10_JPRB, &
  & 0.47055332E-10_JPRB, 0.49290415E-10_JPRB, 0.51556200E-10_JPRB, 0.53909596E-10_JPRB, 0.56396606E-10_JPRB, 0.58956291E-10_JPRB, &
  & 0.61458783E-10_JPRB, 0.63689595E-10_JPRB, 0.65466167E-10_JPRB, 0.66647070E-10_JPRB, 0.67317547E-10_JPRB, 0.67519684E-10_JPRB, &
  & 0.67542825E-10_JPRB, 0.67483755E-10_JPRB, 0.67447763E-10_JPRB, 0.68141923E-10_JPRB, 0.69340034E-10_JPRB, 0.70939976E-10_JPRB, &
  & 0.72794215E-10_JPRB, 0.74771245E-10_JPRB, 0.76765198E-10_JPRB, 0.78629082E-10_JPRB, 0.80310272E-10_JPRB, 0.81608997E-10_JPRB, &
  & 0.82562068E-10_JPRB, 0.83166696E-10_JPRB, 0.83317547E-10_JPRB, 0.83108839E-10_JPRB, 0.82722669E-10_JPRB, 0.82010877E-10_JPRB, &
  & 0.80915739E-10_JPRB, 0.79395650E-10_JPRB, 0.77477302E-10_JPRB, 0.75165131E-10_JPRB, 0.72393418E-10_JPRB, 0.69410082E-10_JPRB, &
  & 0.66222437E-10_JPRB, 0.63022247E-10_JPRB, 0.60116301E-10_JPRB, 0.57345732E-10_JPRB, 0.54747575E-10_JPRB, 0.52636052E-10_JPRB, &
  & 0.50819335E-10_JPRB, 0.49928166E-10_JPRB, 0.52393482E-10_JPRB, 0.53226461E-10_JPRB /)

RGHG4(:, 8, 8) = (/ &
  & 0.85942264E-09_JPRB, 0.12820823E-08_JPRB, 0.17569165E-08_JPRB, 0.59224688E-10_JPRB, 0.63635562E-10_JPRB, 0.64442320E-10_JPRB, &
  & 0.64380001E-10_JPRB, 0.64009395E-10_JPRB, 0.66047515E-10_JPRB, 0.70156075E-10_JPRB, 0.75415785E-10_JPRB, 0.81123830E-10_JPRB, &
  & 0.87085346E-10_JPRB, 0.93098439E-10_JPRB, 0.98988387E-10_JPRB, 0.10475276E-09_JPRB, 0.11019650E-09_JPRB, 0.11526347E-09_JPRB, &
  & 0.12012698E-09_JPRB, 0.12514949E-09_JPRB, 0.13040201E-09_JPRB, 0.13584722E-09_JPRB, 0.14165837E-09_JPRB, 0.14776083E-09_JPRB, &
  & 0.15391627E-09_JPRB, 0.15954936E-09_JPRB, 0.16428348E-09_JPRB, 0.16764151E-09_JPRB, 0.16979772E-09_JPRB, 0.17059675E-09_JPRB, &
  & 0.17099830E-09_JPRB, 0.17093064E-09_JPRB, 0.17085920E-09_JPRB, 0.17246295E-09_JPRB, 0.17519991E-09_JPRB, 0.17887344E-09_JPRB, &
  & 0.18326558E-09_JPRB, 0.18804594E-09_JPRB, 0.19294724E-09_JPRB, 0.19752276E-09_JPRB, 0.20173309E-09_JPRB, 0.20506946E-09_JPRB, &
  & 0.20762037E-09_JPRB, 0.20945497E-09_JPRB, 0.21004973E-09_JPRB, 0.20984603E-09_JPRB, 0.20923402E-09_JPRB, 0.20794301E-09_JPRB, &
  & 0.20625336E-09_JPRB, 0.20378227E-09_JPRB, 0.20078300E-09_JPRB, 0.19714093E-09_JPRB, 0.19263109E-09_JPRB, 0.18804730E-09_JPRB, &
  & 0.18321725E-09_JPRB, 0.17803381E-09_JPRB, 0.17292777E-09_JPRB, 0.16802361E-09_JPRB, 0.16426839E-09_JPRB, 0.16148467E-09_JPRB, &
  & 0.15939911E-09_JPRB, 0.16141627E-09_JPRB, 0.17250090E-09_JPRB, 0.18393445E-09_JPRB /)

RGHG4(:, 9, 8) = (/ &
  & 0.11608816E-08_JPRB, 0.16719081E-08_JPRB, 0.22478652E-08_JPRB, 0.10898127E-09_JPRB, 0.12989564E-09_JPRB, 0.14732948E-09_JPRB, &
  & 0.16174058E-09_JPRB, 0.17098177E-09_JPRB, 0.18008008E-09_JPRB, 0.19073081E-09_JPRB, 0.20259980E-09_JPRB, 0.21479475E-09_JPRB, &
  & 0.22722779E-09_JPRB, 0.23978938E-09_JPRB, 0.25198166E-09_JPRB, 0.26335337E-09_JPRB, 0.27380290E-09_JPRB, 0.28342645E-09_JPRB, &
  & 0.29216815E-09_JPRB, 0.30082073E-09_JPRB, 0.31040362E-09_JPRB, 0.32104117E-09_JPRB, 0.33279271E-09_JPRB, 0.34550940E-09_JPRB, &
  & 0.35884712E-09_JPRB, 0.37166212E-09_JPRB, 0.38299938E-09_JPRB, 0.39173928E-09_JPRB, 0.39855236E-09_JPRB, 0.40291412E-09_JPRB, &
  & 0.40678125E-09_JPRB, 0.40866110E-09_JPRB, 0.40952286E-09_JPRB, 0.41347134E-09_JPRB, 0.41928519E-09_JPRB, 0.42669052E-09_JPRB, &
  & 0.43551263E-09_JPRB, 0.44500223E-09_JPRB, 0.45480605E-09_JPRB, 0.46401830E-09_JPRB, 0.47264098E-09_JPRB, 0.47949750E-09_JPRB, &
  & 0.48520687E-09_JPRB, 0.48935889E-09_JPRB, 0.49093840E-09_JPRB, 0.49077437E-09_JPRB, 0.49013643E-09_JPRB, 0.48818510E-09_JPRB, &
  & 0.48592191E-09_JPRB, 0.48256948E-09_JPRB, 0.47896509E-09_JPRB, 0.47475762E-09_JPRB, 0.46965531E-09_JPRB, 0.46572668E-09_JPRB, &
  & 0.46209966E-09_JPRB, 0.45891699E-09_JPRB, 0.45870793E-09_JPRB, 0.45915388E-09_JPRB, 0.46372528E-09_JPRB, 0.46806004E-09_JPRB, &
  & 0.47727144E-09_JPRB, 0.49381110E-09_JPRB, 0.53360821E-09_JPRB, 0.56621879E-09_JPRB /)

RGHG4(:,10, 8) = (/ &
  & 0.13718510E-08_JPRB, 0.19892743E-08_JPRB, 0.26885432E-08_JPRB, 0.18346712E-09_JPRB, 0.23061067E-09_JPRB, 0.27743968E-09_JPRB, &
  & 0.32561609E-09_JPRB, 0.36865533E-09_JPRB, 0.40703657E-09_JPRB, 0.44203016E-09_JPRB, 0.47442739E-09_JPRB, 0.50434767E-09_JPRB, &
  & 0.53168464E-09_JPRB, 0.55695570E-09_JPRB, 0.58010519E-09_JPRB, 0.60092104E-09_JPRB, 0.61912991E-09_JPRB, 0.63489192E-09_JPRB, &
  & 0.64992123E-09_JPRB, 0.66515160E-09_JPRB, 0.68170902E-09_JPRB, 0.70053791E-09_JPRB, 0.72275369E-09_JPRB, 0.74875012E-09_JPRB, &
  & 0.77688000E-09_JPRB, 0.80408163E-09_JPRB, 0.82967849E-09_JPRB, 0.85201668E-09_JPRB, 0.87209867E-09_JPRB, 0.88797875E-09_JPRB, &
  & 0.90273639E-09_JPRB, 0.91167152E-09_JPRB, 0.91670060E-09_JPRB, 0.92636415E-09_JPRB, 0.93783181E-09_JPRB, 0.95101171E-09_JPRB, &
  & 0.96536457E-09_JPRB, 0.98027708E-09_JPRB, 0.99539788E-09_JPRB, 0.10094118E-08_JPRB, 0.10227527E-08_JPRB, 0.10337190E-08_JPRB, &
  & 0.10434362E-08_JPRB, 0.10503275E-08_JPRB, 0.10533350E-08_JPRB, 0.10530696E-08_JPRB, 0.10524674E-08_JPRB, 0.10491000E-08_JPRB, &
  & 0.10461271E-08_JPRB, 0.10421003E-08_JPRB, 0.10380840E-08_JPRB, 0.10333897E-08_JPRB, 0.10278186E-08_JPRB, 0.10253997E-08_JPRB, &
  & 0.10244872E-08_JPRB, 0.10261453E-08_JPRB, 0.10335809E-08_JPRB, 0.10399991E-08_JPRB, 0.10551247E-08_JPRB, 0.10695115E-08_JPRB, &
  & 0.10892891E-08_JPRB, 0.11161552E-08_JPRB, 0.11683738E-08_JPRB, 0.12387663E-08_JPRB /)

RGHG4(:,11, 8) = (/ &
  & 0.15619018E-08_JPRB, 0.22431255E-08_JPRB, 0.29188381E-08_JPRB, 0.28034663E-09_JPRB, 0.35627531E-09_JPRB, 0.44134907E-09_JPRB, &
  & 0.53554672E-09_JPRB, 0.63432404E-09_JPRB, 0.73218076E-09_JPRB, 0.82349072E-09_JPRB, 0.90537733E-09_JPRB, 0.97835107E-09_JPRB, &
  & 0.10421520E-08_JPRB, 0.10979090E-08_JPRB, 0.11465169E-08_JPRB, 0.11884489E-08_JPRB, 0.12244237E-08_JPRB, 0.12545455E-08_JPRB, &
  & 0.12820540E-08_JPRB, 0.13084380E-08_JPRB, 0.13370713E-08_JPRB, 0.13700006E-08_JPRB, 0.14085138E-08_JPRB, 0.14528055E-08_JPRB, &
  & 0.15029468E-08_JPRB, 0.15573765E-08_JPRB, 0.16112420E-08_JPRB, 0.16605747E-08_JPRB, 0.17081271E-08_JPRB, 0.17501127E-08_JPRB, &
  & 0.17900416E-08_JPRB, 0.18175615E-08_JPRB, 0.18349566E-08_JPRB, 0.18560519E-08_JPRB, 0.18761901E-08_JPRB, 0.18952322E-08_JPRB, &
  & 0.19133521E-08_JPRB, 0.19304616E-08_JPRB, 0.19469582E-08_JPRB, 0.19620676E-08_JPRB, 0.19764594E-08_JPRB, 0.19886994E-08_JPRB, &
  & 0.19996285E-08_JPRB, 0.20076998E-08_JPRB, 0.20115398E-08_JPRB, 0.20108326E-08_JPRB, 0.20096889E-08_JPRB, 0.20040194E-08_JPRB, &
  & 0.20000255E-08_JPRB, 0.19943236E-08_JPRB, 0.19884097E-08_JPRB, 0.19815412E-08_JPRB, 0.19733704E-08_JPRB, 0.19686350E-08_JPRB, &
  & 0.19639663E-08_JPRB, 0.19626007E-08_JPRB, 0.19671256E-08_JPRB, 0.19682673E-08_JPRB, 0.19771347E-08_JPRB, 0.19787278E-08_JPRB, &
  & 0.19775592E-08_JPRB, 0.19711885E-08_JPRB, 0.19937743E-08_JPRB, 0.20745790E-08_JPRB /)

RGHG4(:,12, 8) = (/ &
  & 0.15853504E-08_JPRB, 0.21527184E-08_JPRB, 0.28602716E-08_JPRB, 0.36035977E-09_JPRB, 0.47309340E-09_JPRB, 0.59453314E-09_JPRB, &
  & 0.73505013E-09_JPRB, 0.89189789E-09_JPRB, 0.10597836E-08_JPRB, 0.12293144E-08_JPRB, 0.13921870E-08_JPRB, 0.15449153E-08_JPRB, &
  & 0.16838759E-08_JPRB, 0.18077642E-08_JPRB, 0.19174287E-08_JPRB, 0.20130402E-08_JPRB, 0.20944035E-08_JPRB, 0.21618505E-08_JPRB, &
  & 0.22219842E-08_JPRB, 0.22761477E-08_JPRB, 0.23292288E-08_JPRB, 0.23844056E-08_JPRB, 0.24453999E-08_JPRB, 0.25156424E-08_JPRB, &
  & 0.25938540E-08_JPRB, 0.26725053E-08_JPRB, 0.27535627E-08_JPRB, 0.28348099E-08_JPRB, 0.29132015E-08_JPRB, 0.29839022E-08_JPRB, &
  & 0.30492322E-08_JPRB, 0.30946889E-08_JPRB, 0.31220613E-08_JPRB, 0.31511851E-08_JPRB, 0.31758154E-08_JPRB, 0.31986371E-08_JPRB, &
  & 0.32183933E-08_JPRB, 0.32372949E-08_JPRB, 0.32550744E-08_JPRB, 0.32718572E-08_JPRB, 0.32884342E-08_JPRB, 0.33032974E-08_JPRB, &
  & 0.33170537E-08_JPRB, 0.33279075E-08_JPRB, 0.33335963E-08_JPRB, 0.33329042E-08_JPRB, 0.33313301E-08_JPRB, 0.33215581E-08_JPRB, &
  & 0.33141925E-08_JPRB, 0.33054810E-08_JPRB, 0.32955034E-08_JPRB, 0.32831404E-08_JPRB, 0.32673846E-08_JPRB, 0.32513960E-08_JPRB, &
  & 0.32299146E-08_JPRB, 0.32092577E-08_JPRB, 0.31873830E-08_JPRB, 0.31541985E-08_JPRB, 0.31177463E-08_JPRB, 0.30641072E-08_JPRB, &
  & 0.29920613E-08_JPRB, 0.29028218E-08_JPRB, 0.28423703E-08_JPRB, 0.28546230E-08_JPRB /)

RGHG4(:,13, 8) = (/ &
  & 0.13178750E-08_JPRB, 0.18079324E-08_JPRB, 0.24125371E-08_JPRB, 0.42475501E-09_JPRB, 0.56016414E-09_JPRB, 0.72202161E-09_JPRB, &
  & 0.91078817E-09_JPRB, 0.11297198E-08_JPRB, 0.13746210E-08_JPRB, 0.16359822E-08_JPRB, 0.19028503E-08_JPRB, 0.21706341E-08_JPRB, &
  & 0.24308935E-08_JPRB, 0.26763554E-08_JPRB, 0.29019271E-08_JPRB, 0.31001433E-08_JPRB, 0.32678269E-08_JPRB, 0.33996368E-08_JPRB, &
  & 0.35069128E-08_JPRB, 0.35922323E-08_JPRB, 0.36625978E-08_JPRB, 0.37255803E-08_JPRB, 0.37885566E-08_JPRB, 0.38554711E-08_JPRB, &
  & 0.39296433E-08_JPRB, 0.40170516E-08_JPRB, 0.41101149E-08_JPRB, 0.42032928E-08_JPRB, 0.42989923E-08_JPRB, 0.43846788E-08_JPRB, &
  & 0.44560684E-08_JPRB, 0.45006323E-08_JPRB, 0.45201825E-08_JPRB, 0.45413495E-08_JPRB, 0.45558544E-08_JPRB, 0.45706838E-08_JPRB, &
  & 0.45865143E-08_JPRB, 0.46063917E-08_JPRB, 0.46287316E-08_JPRB, 0.46520556E-08_JPRB, 0.46754618E-08_JPRB, 0.46970619E-08_JPRB, &
  & 0.47161834E-08_JPRB, 0.47311706E-08_JPRB, 0.47412367E-08_JPRB, 0.47441580E-08_JPRB, 0.47417035E-08_JPRB, 0.47262514E-08_JPRB, &
  & 0.47134039E-08_JPRB, 0.46965143E-08_JPRB, 0.46740625E-08_JPRB, 0.46452064E-08_JPRB, 0.46082036E-08_JPRB, 0.45637107E-08_JPRB, &
  & 0.45054307E-08_JPRB, 0.44428052E-08_JPRB, 0.43691051E-08_JPRB, 0.42749990E-08_JPRB, 0.41678425E-08_JPRB, 0.40383856E-08_JPRB, &
  & 0.38847898E-08_JPRB, 0.37152192E-08_JPRB, 0.35785661E-08_JPRB, 0.35394205E-08_JPRB /)

RGHG4(:,14, 8) = (/ &
  & 0.97528097E-09_JPRB, 0.14539103E-08_JPRB, 0.20812503E-08_JPRB, 0.48255133E-09_JPRB, 0.65639366E-09_JPRB, 0.86021557E-09_JPRB, &
  & 0.11033814E-08_JPRB, 0.13912973E-08_JPRB, 0.17226645E-08_JPRB, 0.20899575E-08_JPRB, 0.24799527E-08_JPRB, 0.28824856E-08_JPRB, &
  & 0.32772891E-08_JPRB, 0.36450176E-08_JPRB, 0.39740145E-08_JPRB, 0.42561146E-08_JPRB, 0.44893653E-08_JPRB, 0.46735602E-08_JPRB, &
  & 0.48232591E-08_JPRB, 0.49403681E-08_JPRB, 0.50321378E-08_JPRB, 0.51029212E-08_JPRB, 0.51623887E-08_JPRB, 0.52173652E-08_JPRB, &
  & 0.52739586E-08_JPRB, 0.53328342E-08_JPRB, 0.54030518E-08_JPRB, 0.54780083E-08_JPRB, 0.55494076E-08_JPRB, 0.56100737E-08_JPRB, &
  & 0.56570748E-08_JPRB, 0.56739715E-08_JPRB, 0.56628084E-08_JPRB, 0.56514740E-08_JPRB, 0.56373413E-08_JPRB, 0.56342651E-08_JPRB, &
  & 0.56431650E-08_JPRB, 0.56635518E-08_JPRB, 0.56940768E-08_JPRB, 0.57307719E-08_JPRB, 0.57692895E-08_JPRB, 0.58069647E-08_JPRB, &
  & 0.58408678E-08_JPRB, 0.58690883E-08_JPRB, 0.58902869E-08_JPRB, 0.59015055E-08_JPRB, 0.59030287E-08_JPRB, 0.58843184E-08_JPRB, &
  & 0.58629124E-08_JPRB, 0.58321894E-08_JPRB, 0.57902234E-08_JPRB, 0.57356271E-08_JPRB, 0.56667360E-08_JPRB, 0.55826654E-08_JPRB, &
  & 0.54761768E-08_JPRB, 0.53605986E-08_JPRB, 0.52272484E-08_JPRB, 0.50692694E-08_JPRB, 0.48958113E-08_JPRB, 0.47027275E-08_JPRB, &
  & 0.44910804E-08_JPRB, 0.42769313E-08_JPRB, 0.40948991E-08_JPRB, 0.40248751E-08_JPRB /)

RGHG4(:,15, 8) = (/ &
  & 0.80094076E-09_JPRB, 0.13077488E-08_JPRB, 0.19736699E-08_JPRB, 0.58343563E-09_JPRB, 0.78591078E-09_JPRB, 0.10487528E-08_JPRB, &
  & 0.13422006E-08_JPRB, 0.16847872E-08_JPRB, 0.20774196E-08_JPRB, 0.25105729E-08_JPRB, 0.29663287E-08_JPRB, 0.34322163E-08_JPRB, &
  & 0.38886445E-08_JPRB, 0.43136739E-08_JPRB, 0.46936459E-08_JPRB, 0.50203934E-08_JPRB, 0.52936127E-08_JPRB, 0.55138023E-08_JPRB, &
  & 0.56973826E-08_JPRB, 0.58476712E-08_JPRB, 0.59689911E-08_JPRB, 0.60648779E-08_JPRB, 0.61423364E-08_JPRB, 0.62030527E-08_JPRB, &
  & 0.62557914E-08_JPRB, 0.63010424E-08_JPRB, 0.63414385E-08_JPRB, 0.63765659E-08_JPRB, 0.64070194E-08_JPRB, 0.64185759E-08_JPRB, &
  & 0.64105539E-08_JPRB, 0.63691123E-08_JPRB, 0.63030754E-08_JPRB, 0.62418359E-08_JPRB, 0.61940768E-08_JPRB, 0.61597505E-08_JPRB, &
  & 0.61484471E-08_JPRB, 0.61654655E-08_JPRB, 0.62022205E-08_JPRB, 0.62518808E-08_JPRB, 0.63062848E-08_JPRB, 0.63622609E-08_JPRB, &
  & 0.64168453E-08_JPRB, 0.64675176E-08_JPRB, 0.65109300E-08_JPRB, 0.65425820E-08_JPRB, 0.65562400E-08_JPRB, 0.65412507E-08_JPRB, &
  & 0.65179568E-08_JPRB, 0.64779151E-08_JPRB, 0.64185492E-08_JPRB, 0.63391377E-08_JPRB, 0.62385168E-08_JPRB, 0.61163314E-08_JPRB, &
  & 0.59666445E-08_JPRB, 0.58066352E-08_JPRB, 0.56278071E-08_JPRB, 0.54254823E-08_JPRB, 0.52129550E-08_JPRB, 0.49882116E-08_JPRB, &
  & 0.47603552E-08_JPRB, 0.45457340E-08_JPRB, 0.43547792E-08_JPRB, 0.42698884E-08_JPRB /)

RGHG4(:,16, 8) = (/ &
  & 0.70295897E-09_JPRB, 0.11869740E-08_JPRB, 0.18318616E-08_JPRB, 0.63819167E-09_JPRB, 0.87088098E-09_JPRB, 0.11764999E-08_JPRB, &
  & 0.15087851E-08_JPRB, 0.18737039E-08_JPRB, 0.22857711E-08_JPRB, 0.27364175E-08_JPRB, 0.32135226E-08_JPRB, 0.37023005E-08_JPRB, &
  & 0.41806514E-08_JPRB, 0.46264281E-08_JPRB, 0.50253504E-08_JPRB, 0.53679199E-08_JPRB, 0.56527449E-08_JPRB, 0.58838099E-08_JPRB, &
  & 0.60780603E-08_JPRB, 0.62403220E-08_JPRB, 0.63728121E-08_JPRB, 0.64789170E-08_JPRB, 0.65656915E-08_JPRB, 0.66329742E-08_JPRB, &
  & 0.66824271E-08_JPRB, 0.67111485E-08_JPRB, 0.67230186E-08_JPRB, 0.67154540E-08_JPRB, 0.66926744E-08_JPRB, 0.66500681E-08_JPRB, &
  & 0.65865047E-08_JPRB, 0.65004468E-08_JPRB, 0.63941981E-08_JPRB, 0.63030812E-08_JPRB, 0.62271472E-08_JPRB, 0.61814842E-08_JPRB, &
  & 0.61697598E-08_JPRB, 0.61801955E-08_JPRB, 0.62077685E-08_JPRB, 0.62508141E-08_JPRB, 0.63064181E-08_JPRB, 0.63668613E-08_JPRB, &
  & 0.64340027E-08_JPRB, 0.65005255E-08_JPRB, 0.65639965E-08_JPRB, 0.66152950E-08_JPRB, 0.66461148E-08_JPRB, 0.66429622E-08_JPRB, &
  & 0.66263479E-08_JPRB, 0.65868537E-08_JPRB, 0.65221939E-08_JPRB, 0.64323507E-08_JPRB, 0.63169043E-08_JPRB, 0.61765300E-08_JPRB, &
  & 0.60073302E-08_JPRB, 0.58294081E-08_JPRB, 0.56352762E-08_JPRB, 0.54214517E-08_JPRB, 0.52041216E-08_JPRB, 0.49836175E-08_JPRB, &
  & 0.47766830E-08_JPRB, 0.46038289E-08_JPRB, 0.44321662E-08_JPRB, 0.43518038E-08_JPRB /)

RGHG4(:,17, 8) = (/ &
  & 0.61009825E-09_JPRB, 0.10556247E-08_JPRB, 0.16533631E-08_JPRB, 0.65738393E-09_JPRB, 0.87543617E-09_JPRB, 0.11942287E-08_JPRB, &
  & 0.15417894E-08_JPRB, 0.19179074E-08_JPRB, 0.23280771E-08_JPRB, 0.27720957E-08_JPRB, 0.32344365E-08_JPRB, 0.37107653E-08_JPRB, &
  & 0.41728172E-08_JPRB, 0.45991535E-08_JPRB, 0.49724753E-08_JPRB, 0.52853419E-08_JPRB, 0.55381264E-08_JPRB, 0.57348180E-08_JPRB, &
  & 0.58931082E-08_JPRB, 0.60188619E-08_JPRB, 0.61151186E-08_JPRB, 0.61847141E-08_JPRB, 0.62321690E-08_JPRB, 0.62580203E-08_JPRB, &
  & 0.62619150E-08_JPRB, 0.62422170E-08_JPRB, 0.62014185E-08_JPRB, 0.61453385E-08_JPRB, 0.60851186E-08_JPRB, 0.60278706E-08_JPRB, &
  & 0.59704548E-08_JPRB, 0.59110654E-08_JPRB, 0.58389613E-08_JPRB, 0.57865215E-08_JPRB, 0.57561409E-08_JPRB, 0.57462919E-08_JPRB, &
  & 0.57354730E-08_JPRB, 0.57343077E-08_JPRB, 0.57396630E-08_JPRB, 0.57506835E-08_JPRB, 0.57751697E-08_JPRB, 0.58095506E-08_JPRB, &
  & 0.58583103E-08_JPRB, 0.59175420E-08_JPRB, 0.59816907E-08_JPRB, 0.60438659E-08_JPRB, 0.60925802E-08_JPRB, 0.61107466E-08_JPRB, &
  & 0.61165082E-08_JPRB, 0.60990302E-08_JPRB, 0.60553487E-08_JPRB, 0.59850662E-08_JPRB, 0.58879071E-08_JPRB, 0.57643765E-08_JPRB, &
  & 0.56120495E-08_JPRB, 0.54514935E-08_JPRB, 0.52768625E-08_JPRB, 0.50866173E-08_JPRB, 0.48980886E-08_JPRB, 0.47141193E-08_JPRB, &
  & 0.45580779E-08_JPRB, 0.44543476E-08_JPRB, 0.43205284E-08_JPRB, 0.42463961E-08_JPRB /)

RGHG4(:,18, 8) = (/ &
  & 0.53823274E-09_JPRB, 0.96029906E-09_JPRB, 0.15434503E-08_JPRB, 0.62877059E-09_JPRB, 0.86403851E-09_JPRB, 0.11398531E-08_JPRB, &
  & 0.15124058E-08_JPRB, 0.18877153E-08_JPRB, 0.22837050E-08_JPRB, 0.27050040E-08_JPRB, 0.31315428E-08_JPRB, 0.35641936E-08_JPRB, &
  & 0.39813846E-08_JPRB, 0.43502157E-08_JPRB, 0.46586299E-08_JPRB, 0.48991131E-08_JPRB, 0.50750608E-08_JPRB, 0.51947415E-08_JPRB, &
  & 0.52741469E-08_JPRB, 0.53191971E-08_JPRB, 0.53335167E-08_JPRB, 0.53207962E-08_JPRB, 0.52810973E-08_JPRB, 0.52161924E-08_JPRB, &
  & 0.51343956E-08_JPRB, 0.50390341E-08_JPRB, 0.49418190E-08_JPRB, 0.48557465E-08_JPRB, 0.47966382E-08_JPRB, 0.47713899E-08_JPRB, &
  & 0.47792375E-08_JPRB, 0.48112514E-08_JPRB, 0.48500364E-08_JPRB, 0.49048530E-08_JPRB, 0.49571964E-08_JPRB, 0.49957132E-08_JPRB, &
  & 0.50230642E-08_JPRB, 0.50269335E-08_JPRB, 0.50085078E-08_JPRB, 0.49782818E-08_JPRB, 0.49521729E-08_JPRB, 0.49368407E-08_JPRB, &
  & 0.49419517E-08_JPRB, 0.49692592E-08_JPRB, 0.50142166E-08_JPRB, 0.50706390E-08_JPRB, 0.51283071E-08_JPRB, 0.51698175E-08_JPRB, &
  & 0.52065436E-08_JPRB, 0.52257110E-08_JPRB, 0.52227040E-08_JPRB, 0.51950040E-08_JPRB, 0.51418185E-08_JPRB, 0.50630922E-08_JPRB, &
  & 0.49571334E-08_JPRB, 0.48419562E-08_JPRB, 0.47129851E-08_JPRB, 0.45697632E-08_JPRB, 0.44291917E-08_JPRB, 0.42981823E-08_JPRB, &
  & 0.42050203E-08_JPRB, 0.41815187E-08_JPRB, 0.40763077E-08_JPRB, 0.39814285E-08_JPRB /)

RGHG4(:,19, 8) = (/ &
  & 0.49110743E-09_JPRB, 0.88285579E-09_JPRB, 0.14385152E-08_JPRB, 0.62129568E-09_JPRB, 0.84212032E-09_JPRB, 0.10936536E-08_JPRB, &
  & 0.14239993E-08_JPRB, 0.17995821E-08_JPRB, 0.21741817E-08_JPRB, 0.25658902E-08_JPRB, 0.29483420E-08_JPRB, 0.33165333E-08_JPRB, &
  & 0.36575485E-08_JPRB, 0.39500758E-08_JPRB, 0.41706101E-08_JPRB, 0.43187414E-08_JPRB, 0.44019868E-08_JPRB, 0.44324540E-08_JPRB, &
  & 0.44289821E-08_JPRB, 0.43974504E-08_JPRB, 0.43382520E-08_JPRB, 0.42558277E-08_JPRB, 0.41509853E-08_JPRB, 0.40267807E-08_JPRB, &
  & 0.38832071E-08_JPRB, 0.37353467E-08_JPRB, 0.35996730E-08_JPRB, 0.34988541E-08_JPRB, 0.34500096E-08_JPRB, 0.34629908E-08_JPRB, &
  & 0.35299048E-08_JPRB, 0.36397494E-08_JPRB, 0.37665102E-08_JPRB, 0.39102561E-08_JPRB, 0.40378083E-08_JPRB, 0.41326484E-08_JPRB, &
  & 0.41923509E-08_JPRB, 0.42043777E-08_JPRB, 0.41701997E-08_JPRB, 0.41076307E-08_JPRB, 0.40400310E-08_JPRB, 0.39812846E-08_JPRB, &
  & 0.39454813E-08_JPRB, 0.39365995E-08_JPRB, 0.39530557E-08_JPRB, 0.39926253E-08_JPRB, 0.40467563E-08_JPRB, 0.41011337E-08_JPRB, &
  & 0.41608330E-08_JPRB, 0.42133026E-08_JPRB, 0.42522075E-08_JPRB, 0.42721733E-08_JPRB, 0.42702299E-08_JPRB, 0.42442738E-08_JPRB, &
  & 0.41924815E-08_JPRB, 0.41291099E-08_JPRB, 0.40521395E-08_JPRB, 0.39621963E-08_JPRB, 0.38740042E-08_JPRB, 0.37976733E-08_JPRB, &
  & 0.37658685E-08_JPRB, 0.38181347E-08_JPRB, 0.37408432E-08_JPRB, 0.36160794E-08_JPRB /)

RGHG4(:,20, 8) = (/ &
  & 0.45345766E-09_JPRB, 0.80950396E-09_JPRB, 0.13053897E-08_JPRB, 0.59232519E-09_JPRB, 0.75758805E-09_JPRB, 0.98447062E-09_JPRB, &
  & 0.12595160E-08_JPRB, 0.16215169E-08_JPRB, 0.19955884E-08_JPRB, 0.23613616E-08_JPRB, 0.27000093E-08_JPRB, 0.30053666E-08_JPRB, &
  & 0.32645160E-08_JPRB, 0.34719185E-08_JPRB, 0.36175576E-08_JPRB, 0.36928005E-08_JPRB, 0.37093120E-08_JPRB, 0.36809944E-08_JPRB, &
  & 0.36239247E-08_JPRB, 0.35482273E-08_JPRB, 0.34536596E-08_JPRB, 0.33393217E-08_JPRB, 0.32076191E-08_JPRB, 0.30579290E-08_JPRB, &
  & 0.28959770E-08_JPRB, 0.27327016E-08_JPRB, 0.25894322E-08_JPRB, 0.24863116E-08_JPRB, 0.24412889E-08_JPRB, 0.24595921E-08_JPRB, &
  & 0.25379547E-08_JPRB, 0.26669220E-08_JPRB, 0.28227030E-08_JPRB, 0.29969618E-08_JPRB, 0.31609166E-08_JPRB, 0.32936485E-08_JPRB, &
  & 0.33592924E-08_JPRB, 0.33681620E-08_JPRB, 0.33340803E-08_JPRB, 0.32639882E-08_JPRB, 0.31803420E-08_JPRB, 0.31012828E-08_JPRB, &
  & 0.30432612E-08_JPRB, 0.30109160E-08_JPRB, 0.30070990E-08_JPRB, 0.30308118E-08_JPRB, 0.30753209E-08_JPRB, 0.31300498E-08_JPRB, &
  & 0.31970491E-08_JPRB, 0.32668879E-08_JPRB, 0.33310483E-08_JPRB, 0.33825376E-08_JPRB, 0.34174790E-08_JPRB, 0.34329732E-08_JPRB, &
  & 0.34269001E-08_JPRB, 0.34089271E-08_JPRB, 0.33780572E-08_JPRB, 0.33349801E-08_JPRB, 0.32918481E-08_JPRB, 0.32602312E-08_JPRB, &
  & 0.32731011E-08_JPRB, 0.33714671E-08_JPRB, 0.33129695E-08_JPRB, 0.31351610E-08_JPRB /)

RGHG4(:,21, 8) = (/ &
  & 0.41136131E-09_JPRB, 0.73397488E-09_JPRB, 0.11660417E-08_JPRB, 0.51533638E-09_JPRB, 0.68924416E-09_JPRB, 0.87999857E-09_JPRB, &
  & 0.11160013E-08_JPRB, 0.13973881E-08_JPRB, 0.17729369E-08_JPRB, 0.21134172E-08_JPRB, 0.24187181E-08_JPRB, 0.26722726E-08_JPRB, &
  & 0.28685117E-08_JPRB, 0.30067657E-08_JPRB, 0.30925500E-08_JPRB, 0.31251761E-08_JPRB, 0.31049405E-08_JPRB, 0.30476908E-08_JPRB, &
  & 0.29692862E-08_JPRB, 0.28747000E-08_JPRB, 0.27677884E-08_JPRB, 0.26476135E-08_JPRB, 0.25147089E-08_JPRB, 0.23675193E-08_JPRB, &
  & 0.22081668E-08_JPRB, 0.20482664E-08_JPRB, 0.19097210E-08_JPRB, 0.18090764E-08_JPRB, 0.17594678E-08_JPRB, 0.17646441E-08_JPRB, &
  & 0.18243467E-08_JPRB, 0.19323578E-08_JPRB, 0.20755093E-08_JPRB, 0.22370943E-08_JPRB, 0.23945386E-08_JPRB, 0.25151681E-08_JPRB, &
  & 0.25942730E-08_JPRB, 0.26155496E-08_JPRB, 0.25809936E-08_JPRB, 0.25182620E-08_JPRB, 0.24422548E-08_JPRB, 0.23688205E-08_JPRB, &
  & 0.23103901E-08_JPRB, 0.22735223E-08_JPRB, 0.22617122E-08_JPRB, 0.22742057E-08_JPRB, 0.23090116E-08_JPRB, 0.23586728E-08_JPRB, &
  & 0.24247835E-08_JPRB, 0.24980962E-08_JPRB, 0.25707567E-08_JPRB, 0.26375722E-08_JPRB, 0.26932312E-08_JPRB, 0.27344602E-08_JPRB, &
  & 0.27579583E-08_JPRB, 0.27698546E-08_JPRB, 0.27695464E-08_JPRB, 0.27584466E-08_JPRB, 0.27463460E-08_JPRB, 0.27442646E-08_JPRB, &
  & 0.27815008E-08_JPRB, 0.29082063E-08_JPRB, 0.28365825E-08_JPRB, 0.27039078E-08_JPRB /)

RGHG4(:,22, 8) = (/ &
  & 0.36878497E-09_JPRB, 0.66314593E-09_JPRB, 0.10550967E-08_JPRB, 0.47394788E-09_JPRB, 0.60884486E-09_JPRB, 0.76617251E-09_JPRB, &
  & 0.95606967E-09_JPRB, 0.12075768E-08_JPRB, 0.15231608E-08_JPRB, 0.18374052E-08_JPRB, 0.21142044E-08_JPRB, 0.23323690E-08_JPRB, &
  & 0.24862501E-08_JPRB, 0.25783107E-08_JPRB, 0.26175155E-08_JPRB, 0.26159666E-08_JPRB, 0.25779407E-08_JPRB, 0.25103988E-08_JPRB, &
  & 0.24276294E-08_JPRB, 0.23338063E-08_JPRB, 0.22313906E-08_JPRB, 0.21183755E-08_JPRB, 0.19970785E-08_JPRB, 0.18663848E-08_JPRB, &
  & 0.17275659E-08_JPRB, 0.15875825E-08_JPRB, 0.14616451E-08_JPRB, 0.13647690E-08_JPRB, 0.13088536E-08_JPRB, 0.12971962E-08_JPRB, &
  & 0.13287255E-08_JPRB, 0.13976614E-08_JPRB, 0.14959758E-08_JPRB, 0.16137622E-08_JPRB, 0.17312252E-08_JPRB, 0.18288874E-08_JPRB, &
  & 0.18903981E-08_JPRB, 0.19124335E-08_JPRB, 0.19012043E-08_JPRB, 0.18589894E-08_JPRB, 0.18085213E-08_JPRB, 0.17596693E-08_JPRB, &
  & 0.17183027E-08_JPRB, 0.16909590E-08_JPRB, 0.16831458E-08_JPRB, 0.16968231E-08_JPRB, 0.17300185E-08_JPRB, 0.17772880E-08_JPRB, &
  & 0.18383574E-08_JPRB, 0.19069732E-08_JPRB, 0.19784536E-08_JPRB, 0.20465547E-08_JPRB, 0.21069764E-08_JPRB, 0.21566040E-08_JPRB, &
  & 0.21932665E-08_JPRB, 0.22210889E-08_JPRB, 0.22394080E-08_JPRB, 0.22489857E-08_JPRB, 0.22559192E-08_JPRB, 0.22709854E-08_JPRB, &
  & 0.23201538E-08_JPRB, 0.24563267E-08_JPRB, 0.23968840E-08_JPRB, 0.23284086E-08_JPRB /)

RGHG4(:,23, 8) = (/ &
  & 0.31170752E-09_JPRB, 0.56357335E-09_JPRB, 0.89563368E-09_JPRB, 0.41992060E-09_JPRB, 0.53042243E-09_JPRB, 0.64283329E-09_JPRB, &
  & 0.81504387E-09_JPRB, 0.10291187E-08_JPRB, 0.12805261E-08_JPRB, 0.15735648E-08_JPRB, 0.18255235E-08_JPRB, 0.20215218E-08_JPRB, &
  & 0.21521074E-08_JPRB, 0.22219542E-08_JPRB, 0.22408277E-08_JPRB, 0.22193423E-08_JPRB, 0.21703255E-08_JPRB, 0.21023752E-08_JPRB, &
  & 0.20244275E-08_JPRB, 0.19384838E-08_JPRB, 0.18460588E-08_JPRB, 0.17483777E-08_JPRB, 0.16420183E-08_JPRB, 0.15267951E-08_JPRB, &
  & 0.14027776E-08_JPRB, 0.12777382E-08_JPRB, 0.11627683E-08_JPRB, 0.10701006E-08_JPRB, 0.10079422E-08_JPRB, 0.97998798E-09_JPRB, &
  & 0.98555220E-09_JPRB, 0.10200985E-08_JPRB, 0.10777870E-08_JPRB, 0.11514545E-08_JPRB, 0.12300585E-08_JPRB, 0.12961324E-08_JPRB, &
  & 0.13430063E-08_JPRB, 0.13650144E-08_JPRB, 0.13593827E-08_JPRB, 0.13417057E-08_JPRB, 0.13146066E-08_JPRB, 0.12870158E-08_JPRB, &
  & 0.12634321E-08_JPRB, 0.12512655E-08_JPRB, 0.12528933E-08_JPRB, 0.12693163E-08_JPRB, 0.13031579E-08_JPRB, 0.13521775E-08_JPRB, &
  & 0.14110889E-08_JPRB, 0.14760564E-08_JPRB, 0.15421752E-08_JPRB, 0.16055519E-08_JPRB, 0.16635197E-08_JPRB, 0.17135459E-08_JPRB, &
  & 0.17541200E-08_JPRB, 0.17872294E-08_JPRB, 0.18127223E-08_JPRB, 0.18319843E-08_JPRB, 0.18484321E-08_JPRB, 0.18715482E-08_JPRB, &
  & 0.19207016E-08_JPRB, 0.20390210E-08_JPRB, 0.20425677E-08_JPRB, 0.20330779E-08_JPRB /)

RGHG4(:,24, 8) = (/ &
  & 0.25842664E-09_JPRB, 0.46634291E-09_JPRB, 0.74564788E-09_JPRB, 0.36723466E-09_JPRB, 0.43424506E-09_JPRB, 0.54487415E-09_JPRB, &
  & 0.68454947E-09_JPRB, 0.85725760E-09_JPRB, 0.10781809E-08_JPRB, 0.13298764E-08_JPRB, 0.15556247E-08_JPRB, 0.17335208E-08_JPRB, &
  & 0.18475352E-08_JPRB, 0.19062441E-08_JPRB, 0.19197752E-08_JPRB, 0.19000586E-08_JPRB, 0.18560292E-08_JPRB, 0.17947793E-08_JPRB, &
  & 0.17235844E-08_JPRB, 0.16451565E-08_JPRB, 0.15606069E-08_JPRB, 0.14700826E-08_JPRB, 0.13738983E-08_JPRB, 0.12711077E-08_JPRB, &
  & 0.11621373E-08_JPRB, 0.10510769E-08_JPRB, 0.94664443E-09_JPRB, 0.85845847E-09_JPRB, 0.79494034E-09_JPRB, 0.75705153E-09_JPRB, &
  & 0.74289713E-09_JPRB, 0.74976708E-09_JPRB, 0.77289036E-09_JPRB, 0.80925106E-09_JPRB, 0.84998192E-09_JPRB, 0.88811780E-09_JPRB, &
  & 0.91750185E-09_JPRB, 0.93602670E-09_JPRB, 0.94406294E-09_JPRB, 0.94409625E-09_JPRB, 0.94073405E-09_JPRB, 0.93616381E-09_JPRB, &
  & 0.93532160E-09_JPRB, 0.93917418E-09_JPRB, 0.95248576E-09_JPRB, 0.97540176E-09_JPRB, 0.10075865E-08_JPRB, 0.10480548E-08_JPRB, &
  & 0.10978707E-08_JPRB, 0.11552330E-08_JPRB, 0.12176647E-08_JPRB, 0.12774779E-08_JPRB, 0.13306060E-08_JPRB, 0.13770075E-08_JPRB, &
  & 0.14158036E-08_JPRB, 0.14487535E-08_JPRB, 0.14756026E-08_JPRB, 0.14972633E-08_JPRB, 0.15164916E-08_JPRB, 0.15433881E-08_JPRB, &
  & 0.15982328E-08_JPRB, 0.17280314E-08_JPRB, 0.17573428E-08_JPRB, 0.17822184E-08_JPRB /)

RGHG4(:,25, 8) = (/ &
  & 0.22172383E-09_JPRB, 0.39920933E-09_JPRB, 0.63111866E-09_JPRB, 0.32795522E-09_JPRB, 0.37992196E-09_JPRB, 0.46989007E-09_JPRB, &
  & 0.58411120E-09_JPRB, 0.72746015E-09_JPRB, 0.91186825E-09_JPRB, 0.11134442E-08_JPRB, 0.13189226E-08_JPRB, 0.14766162E-08_JPRB, &
  & 0.15815860E-08_JPRB, 0.16348850E-08_JPRB, 0.16465047E-08_JPRB, 0.16272782E-08_JPRB, 0.15864368E-08_JPRB, 0.15303931E-08_JPRB, &
  & 0.14657983E-08_JPRB, 0.13946352E-08_JPRB, 0.13186253E-08_JPRB, 0.12382017E-08_JPRB, 0.11537756E-08_JPRB, 0.10647745E-08_JPRB, &
  & 0.97168440E-09_JPRB, 0.87740604E-09_JPRB, 0.78815698E-09_JPRB, 0.71035128E-09_JPRB, 0.64653943E-09_JPRB, 0.60079580E-09_JPRB, &
  & 0.57285171E-09_JPRB, 0.55998994E-09_JPRB, 0.55882471E-09_JPRB, 0.56762850E-09_JPRB, 0.58213739E-09_JPRB, 0.59899186E-09_JPRB, &
  & 0.61548566E-09_JPRB, 0.63000222E-09_JPRB, 0.64477201E-09_JPRB, 0.65642813E-09_JPRB, 0.66947264E-09_JPRB, 0.68258260E-09_JPRB, &
  & 0.69884054E-09_JPRB, 0.71771927E-09_JPRB, 0.74101347E-09_JPRB, 0.76943540E-09_JPRB, 0.80402268E-09_JPRB, 0.84305307E-09_JPRB, &
  & 0.88689955E-09_JPRB, 0.93446828E-09_JPRB, 0.98487829E-09_JPRB, 0.10366997E-08_JPRB, 0.10856660E-08_JPRB, 0.11278081E-08_JPRB, &
  & 0.11637162E-08_JPRB, 0.11943844E-08_JPRB, 0.12201802E-08_JPRB, 0.12418907E-08_JPRB, 0.12622885E-08_JPRB, 0.12923596E-08_JPRB, &
  & 0.13492607E-08_JPRB, 0.14954818E-08_JPRB, 0.15473292E-08_JPRB, 0.15890451E-08_JPRB /)

RGHG4(:,26, 8) = (/ &
  & 0.20807393E-09_JPRB, 0.36427886E-09_JPRB, 0.56966543E-09_JPRB, 0.30068109E-09_JPRB, 0.34180098E-09_JPRB, 0.41219400E-09_JPRB, &
  & 0.49696197E-09_JPRB, 0.61888145E-09_JPRB, 0.76697726E-09_JPRB, 0.93657238E-09_JPRB, 0.11048326E-08_JPRB, 0.12422310E-08_JPRB, &
  & 0.13344131E-08_JPRB, 0.13818249E-08_JPRB, 0.13921103E-08_JPRB, 0.13747891E-08_JPRB, 0.13380684E-08_JPRB, 0.12883725E-08_JPRB, &
  & 0.12311072E-08_JPRB, 0.11683193E-08_JPRB, 0.11019194E-08_JPRB, 0.10328618E-08_JPRB, 0.96201791E-09_JPRB, 0.88836871E-09_JPRB, &
  & 0.81265578E-09_JPRB, 0.73570383E-09_JPRB, 0.66002614E-09_JPRB, 0.59054545E-09_JPRB, 0.53262117E-09_JPRB, 0.48656340E-09_JPRB, &
  & 0.45151574E-09_JPRB, 0.42664916E-09_JPRB, 0.41040848E-09_JPRB, 0.40225195E-09_JPRB, 0.40041956E-09_JPRB, 0.40383721E-09_JPRB, &
  & 0.41196085E-09_JPRB, 0.42392936E-09_JPRB, 0.44029852E-09_JPRB, 0.45940671E-09_JPRB, 0.48173959E-09_JPRB, 0.50611892E-09_JPRB, &
  & 0.53251642E-09_JPRB, 0.56113864E-09_JPRB, 0.59194594E-09_JPRB, 0.62466055E-09_JPRB, 0.65908196E-09_JPRB, 0.69527017E-09_JPRB, &
  & 0.73412465E-09_JPRB, 0.77516071E-09_JPRB, 0.81673929E-09_JPRB, 0.85923024E-09_JPRB, 0.90161539E-09_JPRB, 0.93972918E-09_JPRB, &
  & 0.97222297E-09_JPRB, 0.10002459E-08_JPRB, 0.10239523E-08_JPRB, 0.10444586E-08_JPRB, 0.10654916E-08_JPRB, 0.10982607E-08_JPRB, &
  & 0.11655957E-08_JPRB, 0.13147796E-08_JPRB, 0.13801000E-08_JPRB, 0.14400724E-08_JPRB /)

RGHG4(:,27, 8) = (/ &
  & 0.20859645E-09_JPRB, 0.36011402E-09_JPRB, 0.55075400E-09_JPRB, 0.28739139E-09_JPRB, 0.31059622E-09_JPRB, 0.36862960E-09_JPRB, &
  & 0.43662571E-09_JPRB, 0.53604532E-09_JPRB, 0.65480643E-09_JPRB, 0.79259210E-09_JPRB, 0.92552360E-09_JPRB, 0.10392295E-08_JPRB, &
  & 0.11159466E-08_JPRB, 0.11546137E-08_JPRB, 0.11610026E-08_JPRB, 0.11436859E-08_JPRB, 0.11098317E-08_JPRB, 0.10652219E-08_JPRB, &
  & 0.10143234E-08_JPRB, 0.96006836E-09_JPRB, 0.90402985E-09_JPRB, 0.84752266E-09_JPRB, 0.79133372E-09_JPRB, 0.73406720E-09_JPRB, &
  & 0.67587325E-09_JPRB, 0.61686750E-09_JPRB, 0.55843274E-09_JPRB, 0.50180576E-09_JPRB, 0.44829232E-09_JPRB, 0.40159751E-09_JPRB, &
  & 0.36279871E-09_JPRB, 0.33147854E-09_JPRB, 0.30719491E-09_JPRB, 0.29024655E-09_JPRB, 0.28017030E-09_JPRB, 0.27689279E-09_JPRB, &
  & 0.28042169E-09_JPRB, 0.29053046E-09_JPRB, 0.30681588E-09_JPRB, 0.32881659E-09_JPRB, 0.35494879E-09_JPRB, 0.38474418E-09_JPRB, &
  & 0.41641918E-09_JPRB, 0.45004594E-09_JPRB, 0.48459703E-09_JPRB, 0.51991023E-09_JPRB, 0.55513605E-09_JPRB, 0.58966509E-09_JPRB, &
  & 0.62382322E-09_JPRB, 0.65818334E-09_JPRB, 0.69214479E-09_JPRB, 0.72611173E-09_JPRB, 0.76010048E-09_JPRB, 0.79390744E-09_JPRB, &
  & 0.82335694E-09_JPRB, 0.84897939E-09_JPRB, 0.87133972E-09_JPRB, 0.89168412E-09_JPRB, 0.91333802E-09_JPRB, 0.94846098E-09_JPRB, &
  & 0.10210327E-08_JPRB, 0.11689234E-08_JPRB, 0.12410311E-08_JPRB, 0.13117929E-08_JPRB /)

RGHG4(:,28, 8) = (/ &
  & 0.20261823E-09_JPRB, 0.33396758E-09_JPRB, 0.50035959E-09_JPRB, 0.26423363E-09_JPRB, 0.28336541E-09_JPRB, 0.32829020E-09_JPRB, &
  & 0.38498935E-09_JPRB, 0.46571957E-09_JPRB, 0.56129540E-09_JPRB, 0.67027561E-09_JPRB, 0.77621609E-09_JPRB, 0.86389423E-09_JPRB, &
  & 0.92341745E-09_JPRB, 0.95206443E-09_JPRB, 0.95428521E-09_JPRB, 0.93676433E-09_JPRB, 0.90589225E-09_JPRB, 0.86642543E-09_JPRB, &
  & 0.82273272E-09_JPRB, 0.77729317E-09_JPRB, 0.73161377E-09_JPRB, 0.68718636E-09_JPRB, 0.64393824E-09_JPRB, 0.60149036E-09_JPRB, &
  & 0.55899624E-09_JPRB, 0.51558696E-09_JPRB, 0.47045190E-09_JPRB, 0.42440707E-09_JPRB, 0.37862805E-09_JPRB, 0.33560330E-09_JPRB, &
  & 0.29653818E-09_JPRB, 0.26281222E-09_JPRB, 0.23534705E-09_JPRB, 0.21486769E-09_JPRB, 0.20169680E-09_JPRB, 0.19584041E-09_JPRB, &
  & 0.19739486E-09_JPRB, 0.20634977E-09_JPRB, 0.22191296E-09_JPRB, 0.24412711E-09_JPRB, 0.27136782E-09_JPRB, 0.30269709E-09_JPRB, &
  & 0.33648559E-09_JPRB, 0.37167064E-09_JPRB, 0.40729403E-09_JPRB, 0.44209206E-09_JPRB, 0.47555065E-09_JPRB, 0.50718518E-09_JPRB, &
  & 0.53771787E-09_JPRB, 0.56719807E-09_JPRB, 0.59556599E-09_JPRB, 0.62372962E-09_JPRB, 0.65196953E-09_JPRB, 0.68074418E-09_JPRB, &
  & 0.70633932E-09_JPRB, 0.72925022E-09_JPRB, 0.74972595E-09_JPRB, 0.76950146E-09_JPRB, 0.79195522E-09_JPRB, 0.83072710E-09_JPRB, &
  & 0.90400937E-09_JPRB, 0.10465320E-08_JPRB, 0.11210046E-08_JPRB, 0.11900460E-08_JPRB /)

RGHG4(:,29, 8) = (/ &
  & 0.18387446E-09_JPRB, 0.29615582E-09_JPRB, 0.42982531E-09_JPRB, 0.23068632E-09_JPRB, 0.25146463E-09_JPRB, 0.29058064E-09_JPRB, &
  & 0.33718228E-09_JPRB, 0.40387166E-09_JPRB, 0.48021825E-09_JPRB, 0.56522681E-09_JPRB, 0.64740124E-09_JPRB, 0.71248907E-09_JPRB, &
  & 0.75692491E-09_JPRB, 0.77704687E-09_JPRB, 0.77592138E-09_JPRB, 0.75872725E-09_JPRB, 0.73086348E-09_JPRB, 0.69651424E-09_JPRB, &
  & 0.65946271E-09_JPRB, 0.62189076E-09_JPRB, 0.58523919E-09_JPRB, 0.55061528E-09_JPRB, 0.51846499E-09_JPRB, 0.48819676E-09_JPRB, &
  & 0.45857565E-09_JPRB, 0.42763268E-09_JPRB, 0.39445741E-09_JPRB, 0.35820447E-09_JPRB, 0.32004355E-09_JPRB, 0.28081490E-09_JPRB, &
  & 0.24378330E-09_JPRB, 0.21040995E-09_JPRB, 0.18257354E-09_JPRB, 0.16163432E-09_JPRB, 0.14790966E-09_JPRB, 0.14159623E-09_JPRB, &
  & 0.14249758E-09_JPRB, 0.15059284E-09_JPRB, 0.16535313E-09_JPRB, 0.18648905E-09_JPRB, 0.21325543E-09_JPRB, 0.24423127E-09_JPRB, &
  & 0.27815181E-09_JPRB, 0.31318995E-09_JPRB, 0.34830663E-09_JPRB, 0.38166034E-09_JPRB, 0.41249826E-09_JPRB, 0.44089765E-09_JPRB, &
  & 0.46736987E-09_JPRB, 0.49247662E-09_JPRB, 0.51624338E-09_JPRB, 0.53988863E-09_JPRB, 0.56370086E-09_JPRB, 0.58831029E-09_JPRB, &
  & 0.61073857E-09_JPRB, 0.63112393E-09_JPRB, 0.65012135E-09_JPRB, 0.66870076E-09_JPRB, 0.69086731E-09_JPRB, 0.72895434E-09_JPRB, &
  & 0.79940765E-09_JPRB, 0.93210073E-09_JPRB, 0.10065984E-08_JPRB, 0.10829802E-08_JPRB /)

RGHG4(:,30, 8) = (/ &
  & 0.15598654E-09_JPRB, 0.24952324E-09_JPRB, 0.36076805E-09_JPRB, 0.20241536E-09_JPRB, 0.22287648E-09_JPRB, 0.24684729E-09_JPRB, &
  & 0.29491781E-09_JPRB, 0.34701592E-09_JPRB, 0.41267331E-09_JPRB, 0.48021770E-09_JPRB, 0.54290589E-09_JPRB, 0.59207150E-09_JPRB, &
  & 0.62310884E-09_JPRB, 0.63559574E-09_JPRB, 0.63140765E-09_JPRB, 0.61481770E-09_JPRB, 0.58997845E-09_JPRB, 0.56024352E-09_JPRB, &
  & 0.52882404E-09_JPRB, 0.49776017E-09_JPRB, 0.46821980E-09_JPRB, 0.44124687E-09_JPRB, 0.41737019E-09_JPRB, 0.39569067E-09_JPRB, &
  & 0.37486636E-09_JPRB, 0.35307246E-09_JPRB, 0.32851194E-09_JPRB, 0.30037903E-09_JPRB, 0.26851738E-09_JPRB, 0.23464666E-09_JPRB, &
  & 0.20050200E-09_JPRB, 0.16913868E-09_JPRB, 0.14262651E-09_JPRB, 0.12290997E-09_JPRB, 0.11009692E-09_JPRB, 0.10445930E-09_JPRB, &
  & 0.10549493E-09_JPRB, 0.11306159E-09_JPRB, 0.12696243E-09_JPRB, 0.14670146E-09_JPRB, 0.17207945E-09_JPRB, 0.20190843E-09_JPRB, &
  & 0.23440358E-09_JPRB, 0.26806285E-09_JPRB, 0.30098882E-09_JPRB, 0.33189809E-09_JPRB, 0.36007461E-09_JPRB, 0.38553194E-09_JPRB, &
  & 0.40879791E-09_JPRB, 0.43044682E-09_JPRB, 0.45064322E-09_JPRB, 0.47052795E-09_JPRB, 0.49093885E-09_JPRB, 0.51207855E-09_JPRB, &
  & 0.53167465E-09_JPRB, 0.55002219E-09_JPRB, 0.56701188E-09_JPRB, 0.58421745E-09_JPRB, 0.60680816E-09_JPRB, 0.64458522E-09_JPRB, &
  & 0.71241202E-09_JPRB, 0.83687290E-09_JPRB, 0.91191726E-09_JPRB, 0.98462449E-09_JPRB /)

RGHG4(:,31, 8) = (/ &
  & 0.12660684E-09_JPRB, 0.20187071E-09_JPRB, 0.29018851E-09_JPRB, 0.17646246E-09_JPRB, 0.19340082E-09_JPRB, 0.21594759E-09_JPRB, &
  & 0.25677960E-09_JPRB, 0.30095604E-09_JPRB, 0.35479211E-09_JPRB, 0.40814788E-09_JPRB, 0.45628659E-09_JPRB, 0.49271437E-09_JPRB, &
  & 0.51368010E-09_JPRB, 0.52050353E-09_JPRB, 0.51464094E-09_JPRB, 0.49908916E-09_JPRB, 0.47702209E-09_JPRB, 0.45139972E-09_JPRB, &
  & 0.42449813E-09_JPRB, 0.39824616E-09_JPRB, 0.37382375E-09_JPRB, 0.35221384E-09_JPRB, 0.33376824E-09_JPRB, 0.31784564E-09_JPRB, &
  & 0.30296721E-09_JPRB, 0.28743988E-09_JPRB, 0.26959743E-09_JPRB, 0.24793342E-09_JPRB, 0.22195688E-09_JPRB, 0.19269442E-09_JPRB, &
  & 0.16233671E-09_JPRB, 0.13405840E-09_JPRB, 0.11005843E-09_JPRB, 0.92455134E-10_JPRB, 0.81440812E-10_JPRB, 0.76839320E-10_JPRB, &
  & 0.78181545E-10_JPRB, 0.85212025E-10_JPRB, 0.97873390E-10_JPRB, 0.11604379E-09_JPRB, 0.13934934E-09_JPRB, 0.16723010E-09_JPRB, &
  & 0.19787466E-09_JPRB, 0.22915264E-09_JPRB, 0.25979710E-09_JPRB, 0.28824082E-09_JPRB, 0.31360495E-09_JPRB, 0.33623071E-09_JPRB, &
  & 0.35669021E-09_JPRB, 0.37546227E-09_JPRB, 0.39311074E-09_JPRB, 0.41034964E-09_JPRB, 0.42833392E-09_JPRB, 0.44701012E-09_JPRB, &
  & 0.46452084E-09_JPRB, 0.48083809E-09_JPRB, 0.49649795E-09_JPRB, 0.51336374E-09_JPRB, 0.53541077E-09_JPRB, 0.57162497E-09_JPRB, &
  & 0.63528338E-09_JPRB, 0.74971351E-09_JPRB, 0.81959434E-09_JPRB, 0.89041263E-09_JPRB /)

RGHG4(:,32, 8) = (/ &
  & 0.98396742E-10_JPRB, 0.15969392E-09_JPRB, 0.23206320E-09_JPRB, 0.15065592E-09_JPRB, 0.16948588E-09_JPRB, 0.18971875E-09_JPRB, &
  & 0.22626150E-09_JPRB, 0.26429453E-09_JPRB, 0.30899241E-09_JPRB, 0.35169401E-09_JPRB, 0.38837217E-09_JPRB, 0.41461926E-09_JPRB, &
  & 0.42877318E-09_JPRB, 0.43137430E-09_JPRB, 0.42414575E-09_JPRB, 0.40953110E-09_JPRB, 0.38989012E-09_JPRB, 0.36745970E-09_JPRB, &
  & 0.34419928E-09_JPRB, 0.32164740E-09_JPRB, 0.30097103E-09_JPRB, 0.28306862E-09_JPRB, 0.26806299E-09_JPRB, 0.25555347E-09_JPRB, &
  & 0.24407712E-09_JPRB, 0.23221482E-09_JPRB, 0.21827329E-09_JPRB, 0.20095359E-09_JPRB, 0.17953260E-09_JPRB, 0.15468520E-09_JPRB, &
  & 0.12842831E-09_JPRB, 0.10384090E-09_JPRB, 0.83233899E-10_JPRB, 0.68330321E-10_JPRB, 0.59470422E-10_JPRB, 0.56075519E-10_JPRB, &
  & 0.57773408E-10_JPRB, 0.64205342E-10_JPRB, 0.75477798E-10_JPRB, 0.91649945E-10_JPRB, 0.11273890E-09_JPRB, 0.13783061E-09_JPRB, &
  & 0.16564167E-09_JPRB, 0.19450486E-09_JPRB, 0.22233115E-09_JPRB, 0.24836788E-09_JPRB, 0.27139418E-09_JPRB, 0.29200450E-09_JPRB, &
  & 0.31045749E-09_JPRB, 0.32705086E-09_JPRB, 0.34287351E-09_JPRB, 0.35816192E-09_JPRB, 0.37411049E-09_JPRB, 0.39084797E-09_JPRB, &
  & 0.40656700E-09_JPRB, 0.42162726E-09_JPRB, 0.43639850E-09_JPRB, 0.45240992E-09_JPRB, 0.47320964E-09_JPRB, 0.50704285E-09_JPRB, &
  & 0.56608751E-09_JPRB, 0.67088035E-09_JPRB, 0.73721335E-09_JPRB, 0.80596013E-09_JPRB /)

RGHG4(:,33, 8) = (/ &
  & 0.76118341E-10_JPRB, 0.12431106E-09_JPRB, 0.18297062E-09_JPRB, 0.12836424E-09_JPRB, 0.14211278E-09_JPRB, 0.16696580E-09_JPRB, &
  & 0.19935609E-09_JPRB, 0.23253999E-09_JPRB, 0.26987171E-09_JPRB, 0.30396072E-09_JPRB, 0.33194450E-09_JPRB, 0.35072539E-09_JPRB, &
  & 0.35967240E-09_JPRB, 0.35940723E-09_JPRB, 0.35186964E-09_JPRB, 0.33855013E-09_JPRB, 0.32100950E-09_JPRB, 0.30109740E-09_JPRB, &
  & 0.28039343E-09_JPRB, 0.26030636E-09_JPRB, 0.24188959E-09_JPRB, 0.22575562E-09_JPRB, 0.21258130E-09_JPRB, 0.20159632E-09_JPRB, &
  & 0.19175739E-09_JPRB, 0.18187936E-09_JPRB, 0.17059093E-09_JPRB, 0.15654392E-09_JPRB, 0.13903129E-09_JPRB, 0.11847036E-09_JPRB, &
  & 0.96679685E-10_JPRB, 0.76457909E-10_JPRB, 0.59870039E-10_JPRB, 0.48187742E-10_JPRB, 0.41675552E-10_JPRB, 0.39509139E-10_JPRB, &
  & 0.41440251E-10_JPRB, 0.47122067E-10_JPRB, 0.56751836E-10_JPRB, 0.70604925E-10_JPRB, 0.88805636E-10_JPRB, 0.11092029E-09_JPRB, &
  & 0.13557289E-09_JPRB, 0.16118076E-09_JPRB, 0.18673964E-09_JPRB, 0.21010813E-09_JPRB, 0.23143905E-09_JPRB, 0.25029648E-09_JPRB, &
  & 0.26733804E-09_JPRB, 0.28260880E-09_JPRB, 0.29728767E-09_JPRB, 0.31150385E-09_JPRB, 0.32616468E-09_JPRB, 0.34164330E-09_JPRB, &
  & 0.35601372E-09_JPRB, 0.36962736E-09_JPRB, 0.38317022E-09_JPRB, 0.39817324E-09_JPRB, 0.41752077E-09_JPRB, 0.44885951E-09_JPRB, &
  & 0.50306737E-09_JPRB, 0.59889965E-09_JPRB, 0.66113154E-09_JPRB, 0.72568457E-09_JPRB /)

RGHG4(:,34, 8) = (/ &
  & 0.57981744E-10_JPRB, 0.97478442E-10_JPRB, 0.14549840E-09_JPRB, 0.10898430E-09_JPRB, 0.12455587E-09_JPRB, 0.14746387E-09_JPRB, &
  & 0.17688651E-09_JPRB, 0.20584019E-09_JPRB, 0.23569685E-09_JPRB, 0.26428654E-09_JPRB, 0.28564212E-09_JPRB, 0.29922392E-09_JPRB, &
  & 0.30476902E-09_JPRB, 0.30312916E-09_JPRB, 0.29541958E-09_JPRB, 0.28317693E-09_JPRB, 0.26747554E-09_JPRB, 0.24949454E-09_JPRB, &
  & 0.23070644E-09_JPRB, 0.21219738E-09_JPRB, 0.19498776E-09_JPRB, 0.18024097E-09_JPRB, 0.16759195E-09_JPRB, 0.15707889E-09_JPRB, &
  & 0.14777211E-09_JPRB, 0.13877711E-09_JPRB, 0.12890812E-09_JPRB, 0.11701694E-09_JPRB, 0.10260109E-09_JPRB, 0.86000776E-10_JPRB, &
  & 0.68778094E-10_JPRB, 0.53079260E-10_JPRB, 0.40764541E-10_JPRB, 0.32446136E-10_JPRB, 0.28082455E-10_JPRB, 0.26981769E-10_JPRB, &
  & 0.28883418E-10_JPRB, 0.33684649E-10_JPRB, 0.41628201E-10_JPRB, 0.53005579E-10_JPRB, 0.68192021E-10_JPRB, 0.86911686E-10_JPRB, &
  & 0.10819396E-09_JPRB, 0.13041004E-09_JPRB, 0.15304581E-09_JPRB, 0.17476914E-09_JPRB, 0.19434193E-09_JPRB, 0.21228057E-09_JPRB, &
  & 0.22846769E-09_JPRB, 0.24308053E-09_JPRB, 0.25700458E-09_JPRB, 0.27079683E-09_JPRB, 0.28452588E-09_JPRB, 0.29867733E-09_JPRB, &
  & 0.31192923E-09_JPRB, 0.32455424E-09_JPRB, 0.33705483E-09_JPRB, 0.35086808E-09_JPRB, 0.36889994E-09_JPRB, 0.39771725E-09_JPRB, &
  & 0.44699178E-09_JPRB, 0.53328114E-09_JPRB, 0.59053662E-09_JPRB, 0.65321459E-09_JPRB /)

RGHG4(:,35, 8) = (/ &
  & 0.44850332E-10_JPRB, 0.75908550E-10_JPRB, 0.11590678E-09_JPRB, 0.92834962E-10_JPRB, 0.10863130E-09_JPRB, 0.13036747E-09_JPRB, &
  & 0.15675317E-09_JPRB, 0.18241685E-09_JPRB, 0.20765616E-09_JPRB, 0.23067070E-09_JPRB, 0.24695920E-09_JPRB, 0.25652605E-09_JPRB, &
  & 0.25957067E-09_JPRB, 0.25717584E-09_JPRB, 0.24982227E-09_JPRB, 0.23854493E-09_JPRB, 0.22427679E-09_JPRB, 0.20774735E-09_JPRB, &
  & 0.19024593E-09_JPRB, 0.17257569E-09_JPRB, 0.15604519E-09_JPRB, 0.14113756E-09_JPRB, 0.12807784E-09_JPRB, 0.11713953E-09_JPRB, &
  & 0.10769480E-09_JPRB, 0.98951444E-10_JPRB, 0.90108830E-10_JPRB, 0.80266620E-10_JPRB, 0.68963654E-10_JPRB, 0.56564680E-10_JPRB, &
  & 0.44242540E-10_JPRB, 0.33416821E-10_JPRB, 0.25372964E-10_JPRB, 0.20149177E-10_JPRB, 0.17668911E-10_JPRB, 0.17326899E-10_JPRB, &
  & 0.19058156E-10_JPRB, 0.22837204E-10_JPRB, 0.28945497E-10_JPRB, 0.37800200E-10_JPRB, 0.49784035E-10_JPRB, 0.64941677E-10_JPRB, &
  & 0.82548447E-10_JPRB, 0.10135101E-09_JPRB, 0.12123641E-09_JPRB, 0.14114898E-09_JPRB, 0.15932926E-09_JPRB, 0.17635582E-09_JPRB, &
  & 0.19201191E-09_JPRB, 0.20635949E-09_JPRB, 0.21993335E-09_JPRB, 0.23352290E-09_JPRB, 0.24700625E-09_JPRB, 0.26021166E-09_JPRB, &
  & 0.27232833E-09_JPRB, 0.28367061E-09_JPRB, 0.29514072E-09_JPRB, 0.30800945E-09_JPRB, 0.32453285E-09_JPRB, 0.35075334E-09_JPRB, &
  & 0.39552808E-09_JPRB, 0.47308679E-09_JPRB, 0.52643861E-09_JPRB, 0.58286392E-09_JPRB /)

RGHG4(:,36, 8) = (/ &
  & 0.34565916E-10_JPRB, 0.60365234E-10_JPRB, 0.93349009E-10_JPRB, 0.79427513E-10_JPRB, 0.95502654E-10_JPRB, 0.11554237E-09_JPRB, &
  & 0.13931963E-09_JPRB, 0.16189383E-09_JPRB, 0.18304183E-09_JPRB, 0.20177565E-09_JPRB, 0.21451717E-09_JPRB, 0.22149410E-09_JPRB, &
  & 0.22312314E-09_JPRB, 0.22018186E-09_JPRB, 0.21326677E-09_JPRB, 0.20300961E-09_JPRB, 0.18995801E-09_JPRB, 0.17470744E-09_JPRB, &
  & 0.15805623E-09_JPRB, 0.14112819E-09_JPRB, 0.12457291E-09_JPRB, 0.10923928E-09_JPRB, 0.95784061E-10_JPRB, 0.84411013E-10_JPRB, &
  & 0.74964389E-10_JPRB, 0.66691729E-10_JPRB, 0.58929646E-10_JPRB, 0.51038770E-10_JPRB, 0.42775658E-10_JPRB, 0.34140041E-10_JPRB, &
  & 0.26212886E-10_JPRB, 0.19494252E-10_JPRB, 0.14800050E-10_JPRB, 0.11880410E-10_JPRB, 0.10647568E-10_JPRB, 0.10705642E-10_JPRB, &
  & 0.12100859E-10_JPRB, 0.14841517E-10_JPRB, 0.19272150E-10_JPRB, 0.25790993E-10_JPRB, 0.34848076E-10_JPRB, 0.46609279E-10_JPRB, &
  & 0.60531212E-10_JPRB, 0.76367607E-10_JPRB, 0.93618405E-10_JPRB, 0.11133459E-09_JPRB, 0.12845687E-09_JPRB, 0.14478264E-09_JPRB, &
  & 0.16017830E-09_JPRB, 0.17430783E-09_JPRB, 0.18774329E-09_JPRB, 0.20103190E-09_JPRB, 0.21404858E-09_JPRB, 0.22621580E-09_JPRB, &
  & 0.23746899E-09_JPRB, 0.24813460E-09_JPRB, 0.25877592E-09_JPRB, 0.27051220E-09_JPRB, 0.28556535E-09_JPRB, 0.30923356E-09_JPRB, &
  & 0.34921724E-09_JPRB, 0.41777337E-09_JPRB, 0.46627041E-09_JPRB, 0.51908017E-09_JPRB /)

RGHG4(:,37, 8) = (/ &
  & 0.27632509E-10_JPRB, 0.48536054E-10_JPRB, 0.76449971E-10_JPRB, 0.68601048E-10_JPRB, 0.84170296E-10_JPRB, 0.10262136E-09_JPRB, &
  & 0.12355454E-09_JPRB, 0.14306888E-09_JPRB, 0.16064187E-09_JPRB, 0.17577849E-09_JPRB, 0.18579240E-09_JPRB, 0.19107255E-09_JPRB, &
  & 0.19192863E-09_JPRB, 0.18899991E-09_JPRB, 0.18266916E-09_JPRB, 0.17342426E-09_JPRB, 0.16145178E-09_JPRB, 0.14738159E-09_JPRB, &
  & 0.13144412E-09_JPRB, 0.11456339E-09_JPRB, 0.97904525E-10_JPRB, 0.82267693E-10_JPRB, 0.68704084E-10_JPRB, 0.57620547E-10_JPRB, &
  & 0.48796356E-10_JPRB, 0.41632173E-10_JPRB, 0.35499364E-10_JPRB, 0.29713461E-10_JPRB, 0.24279032E-10_JPRB, 0.18971385E-10_JPRB, &
  & 0.14400646E-10_JPRB, 0.10748997E-10_JPRB, 0.82734080E-11_JPRB, 0.68319491E-11_JPRB, 0.62833835E-11_JPRB, 0.64740331E-11_JPRB, &
  & 0.74194010E-11_JPRB, 0.91997694E-11_JPRB, 0.12082161E-10_JPRB, 0.16440732E-10_JPRB, 0.22735740E-10_JPRB, 0.31181922E-10_JPRB, &
  & 0.41819732E-10_JPRB, 0.54784358E-10_JPRB, 0.69175672E-10_JPRB, 0.84749111E-10_JPRB, 0.10067016E-09_JPRB, 0.11626382E-09_JPRB, &
  & 0.13116559E-09_JPRB, 0.14511006E-09_JPRB, 0.15837438E-09_JPRB, 0.17122757E-09_JPRB, 0.18366943E-09_JPRB, 0.19523239E-09_JPRB, &
  & 0.20574359E-09_JPRB, 0.21550317E-09_JPRB, 0.22525772E-09_JPRB, 0.23613467E-09_JPRB, 0.24992394E-09_JPRB, 0.27116798E-09_JPRB, &
  & 0.30697900E-09_JPRB, 0.36745595E-09_JPRB, 0.41151788E-09_JPRB, 0.46004864E-09_JPRB /)

RGHG4(:,38, 8) = (/ &
  & 0.22493576E-10_JPRB, 0.39756570E-10_JPRB, 0.63273761E-10_JPRB, 0.59323491E-10_JPRB, 0.74394969E-10_JPRB, 0.90931269E-10_JPRB, &
  & 0.10770969E-09_JPRB, 0.12610600E-09_JPRB, 0.14061149E-09_JPRB, 0.15252598E-09_JPRB, 0.16107872E-09_JPRB, 0.16522141E-09_JPRB, &
  & 0.16568685E-09_JPRB, 0.16293744E-09_JPRB, 0.15729074E-09_JPRB, 0.14893960E-09_JPRB, 0.13805439E-09_JPRB, 0.12487403E-09_JPRB, &
  & 0.10987765E-09_JPRB, 0.93572074E-10_JPRB, 0.77116397E-10_JPRB, 0.62010362E-10_JPRB, 0.49342672E-10_JPRB, 0.39471502E-10_JPRB, &
  & 0.32193078E-10_JPRB, 0.26540445E-10_JPRB, 0.22004322E-10_JPRB, 0.17993209E-10_JPRB, 0.14408061E-10_JPRB, 0.11174882E-10_JPRB, &
  & 0.84843027E-11_JPRB, 0.64382302E-11_JPRB, 0.50904441E-11_JPRB, 0.43425866E-11_JPRB, 0.41006664E-11_JPRB, 0.42828753E-11_JPRB, &
  & 0.49016329E-11_JPRB, 0.60174504E-11_JPRB, 0.78042364E-11_JPRB, 0.10561738E-10_JPRB, 0.14632922E-10_JPRB, 0.20297050E-10_JPRB, &
  & 0.28052364E-10_JPRB, 0.37895378E-10_JPRB, 0.49497247E-10_JPRB, 0.62906423E-10_JPRB, 0.77252947E-10_JPRB, 0.91931622E-10_JPRB, &
  & 0.10630954E-09_JPRB, 0.12002749E-09_JPRB, 0.13313625E-09_JPRB, 0.14566939E-09_JPRB, 0.15758808E-09_JPRB, 0.16842898E-09_JPRB, &
  & 0.17820902E-09_JPRB, 0.18734088E-09_JPRB, 0.19635976E-09_JPRB, 0.20625972E-09_JPRB, 0.21877108E-09_JPRB, 0.23779856E-09_JPRB, &
  & 0.26933733E-09_JPRB, 0.32170003E-09_JPRB, 0.36150871E-09_JPRB, 0.40616083E-09_JPRB /)

RGHG4(:,39, 8) = (/ &
  & 0.18873986E-10_JPRB, 0.33103624E-10_JPRB, 0.52747785E-10_JPRB, 0.51721800E-10_JPRB, 0.65775149E-10_JPRB, 0.80830911E-10_JPRB, &
  & 0.95548937E-10_JPRB, 0.11099800E-09_JPRB, 0.12252639E-09_JPRB, 0.13229884E-09_JPRB, 0.13930979E-09_JPRB, 0.14267576E-09_JPRB, &
  & 0.14296914E-09_JPRB, 0.14054187E-09_JPRB, 0.13561785E-09_JPRB, 0.12828258E-09_JPRB, 0.11855034E-09_JPRB, 0.10648788E-09_JPRB, &
  & 0.92431125E-10_JPRB, 0.77034400E-10_JPRB, 0.61680834E-10_JPRB, 0.47790879E-10_JPRB, 0.36719759E-10_JPRB, 0.28548740E-10_JPRB, &
  & 0.22705438E-10_JPRB, 0.18384906E-10_JPRB, 0.14979299E-10_JPRB, 0.12096483E-10_JPRB, 0.96008730E-11_JPRB, 0.74490128E-11_JPRB, &
  & 0.57057354E-11_JPRB, 0.44231363E-11_JPRB, 0.36000387E-11_JPRB, 0.31662661E-11_JPRB, 0.30547418E-11_JPRB, 0.32142641E-11_JPRB, &
  & 0.36481087E-11_JPRB, 0.43943898E-11_JPRB, 0.55503011E-11_JPRB, 0.73241612E-11_JPRB, 0.99018198E-11_JPRB, 0.13589822E-10_JPRB, &
  & 0.18872983E-10_JPRB, 0.25811424E-10_JPRB, 0.34672674E-10_JPRB, 0.45582160E-10_JPRB, 0.57927343E-10_JPRB, 0.71398810E-10_JPRB, &
  & 0.84922645E-10_JPRB, 0.98222631E-10_JPRB, 0.11091177E-09_JPRB, 0.12285443E-09_JPRB, 0.13401570E-09_JPRB, 0.14411149E-09_JPRB, &
  & 0.15317164E-09_JPRB, 0.16151316E-09_JPRB, 0.16976691E-09_JPRB, 0.17889348E-09_JPRB, 0.19037029E-09_JPRB, 0.20748393E-09_JPRB, &
  & 0.23527524E-09_JPRB, 0.28053507E-09_JPRB, 0.31636407E-09_JPRB, 0.35753667E-09_JPRB /)

RGHG4(:,40, 8) = (/ &
  & 0.15969970E-10_JPRB, 0.27598425E-10_JPRB, 0.44240202E-10_JPRB, 0.44687448E-10_JPRB, 0.58285647E-10_JPRB, 0.72045030E-10_JPRB, &
  & 0.84831690E-10_JPRB, 0.97805375E-10_JPRB, 0.10667119E-09_JPRB, 0.11477305E-09_JPRB, 0.12054054E-09_JPRB, 0.12328276E-09_JPRB, &
  & 0.12351148E-09_JPRB, 0.12146671E-09_JPRB, 0.11723285E-09_JPRB, 0.11084787E-09_JPRB, 0.10223788E-09_JPRB, 0.91465988E-10_JPRB, &
  & 0.78636382E-10_JPRB, 0.64589570E-10_JPRB, 0.50590667E-10_JPRB, 0.38432785E-10_JPRB, 0.28976216E-10_JPRB, 0.22198444E-10_JPRB, &
  & 0.17467035E-10_JPRB, 0.14000978E-10_JPRB, 0.11298649E-10_JPRB, 0.90626734E-11_JPRB, 0.71712809E-11_JPRB, 0.55869606E-11_JPRB, &
  & 0.43297497E-11_JPRB, 0.34221844E-11_JPRB, 0.28574140E-11_JPRB, 0.25754177E-11_JPRB, 0.25260015E-11_JPRB, 0.26698953E-11_JPRB, &
  & 0.30072143E-11_JPRB, 0.35588648E-11_JPRB, 0.43828582E-11_JPRB, 0.56116344E-11_JPRB, 0.73383990E-11_JPRB, 0.97976956E-11_JPRB, &
  & 0.13336081E-10_JPRB, 0.18026259E-10_JPRB, 0.24403406E-10_JPRB, 0.32720094E-10_JPRB, 0.42854387E-10_JPRB, 0.54682207E-10_JPRB, &
  & 0.67103156E-10_JPRB, 0.79763564E-10_JPRB, 0.91894638E-10_JPRB, 0.10333850E-09_JPRB, 0.11388816E-09_JPRB, 0.12327156E-09_JPRB, &
  & 0.13158896E-09_JPRB, 0.13924066E-09_JPRB, 0.14677677E-09_JPRB, 0.15503843E-09_JPRB, 0.16538972E-09_JPRB, 0.18064029E-09_JPRB, &
  & 0.20482882E-09_JPRB, 0.24341071E-09_JPRB, 0.27548935E-09_JPRB, 0.31341113E-09_JPRB /)

RGHG4(:,41, 8) = (/ &
  & 0.13469089E-10_JPRB, 0.23077344E-10_JPRB, 0.36617289E-10_JPRB, 0.38845559E-10_JPRB, 0.51643790E-10_JPRB, 0.64370287E-10_JPRB, &
  & 0.75870032E-10_JPRB, 0.86635053E-10_JPRB, 0.93123967E-10_JPRB, 0.99675955E-10_JPRB, 0.10433816E-09_JPRB, 0.10657197E-09_JPRB, &
  & 0.10672626E-09_JPRB, 0.10499987E-09_JPRB, 0.10145419E-09_JPRB, 0.96015654E-10_JPRB, 0.88610327E-10_JPRB, 0.79090089E-10_JPRB, &
  & 0.67785777E-10_JPRB, 0.55183236E-10_JPRB, 0.42878104E-10_JPRB, 0.32209079E-10_JPRB, 0.24137642E-10_JPRB, 0.18424005E-10_JPRB, &
  & 0.14440495E-10_JPRB, 0.11532678E-10_JPRB, 0.92690213E-11_JPRB, 0.74110353E-11_JPRB, 0.58663885E-11_JPRB, 0.45896303E-11_JPRB, &
  & 0.35925915E-11_JPRB, 0.28860250E-11_JPRB, 0.24557552E-11_JPRB, 0.22555664E-11_JPRB, 0.22389575E-11_JPRB, 0.23748336E-11_JPRB, &
  & 0.26598574E-11_JPRB, 0.31075730E-11_JPRB, 0.37524415E-11_JPRB, 0.46832429E-11_JPRB, 0.59427858E-11_JPRB, 0.76827711E-11_JPRB, &
  & 0.10129526E-10_JPRB, 0.13325167E-10_JPRB, 0.17814205E-10_JPRB, 0.23855688E-10_JPRB, 0.31756382E-10_JPRB, 0.41683094E-10_JPRB, &
  & 0.52628426E-10_JPRB, 0.64342566E-10_JPRB, 0.75698031E-10_JPRB, 0.86444955E-10_JPRB, 0.96098872E-10_JPRB, 0.10458922E-09_JPRB, &
  & 0.11213713E-09_JPRB, 0.11904183E-09_JPRB, 0.12587621E-09_JPRB, 0.13339981E-09_JPRB, 0.14282216E-09_JPRB, 0.15640018E-09_JPRB, &
  & 0.17744028E-09_JPRB, 0.21039423E-09_JPRB, 0.23920280E-09_JPRB, 0.27370703E-09_JPRB /)

RGHG4(:,42, 8) = (/ &
  & 0.11364115E-10_JPRB, 0.19078048E-10_JPRB, 0.30545649E-10_JPRB, 0.33295984E-10_JPRB, 0.45566610E-10_JPRB, 0.57593548E-10_JPRB, &
  & 0.67576188E-10_JPRB, 0.76676214E-10_JPRB, 0.81188709E-10_JPRB, 0.86507655E-10_JPRB, 0.90252326E-10_JPRB, 0.92068339E-10_JPRB, &
  & 0.92193898E-10_JPRB, 0.90754106E-10_JPRB, 0.87786368E-10_JPRB, 0.83202292E-10_JPRB, 0.76886796E-10_JPRB, 0.68752205E-10_JPRB, &
  & 0.58798723E-10_JPRB, 0.47778628E-10_JPRB, 0.36906738E-10_JPRB, 0.27686910E-10_JPRB, 0.20728565E-10_JPRB, 0.15832405E-10_JPRB, &
  & 0.12408563E-10_JPRB, 0.98884676E-11_JPRB, 0.79300039E-11_JPRB, 0.63402590E-11_JPRB, 0.50264914E-11_JPRB, 0.39534266E-11_JPRB, &
  & 0.31210421E-11_JPRB, 0.25385707E-11_JPRB, 0.21935116E-11_JPRB, 0.20431142E-11_JPRB, 0.20456859E-11_JPRB, 0.21739225E-11_JPRB, &
  & 0.24241696E-11_JPRB, 0.28035931E-11_JPRB, 0.33338237E-11_JPRB, 0.40803628E-11_JPRB, 0.50542470E-11_JPRB, 0.63389142E-11_JPRB, &
  & 0.81003858E-11_JPRB, 0.10327184E-10_JPRB, 0.13435398E-10_JPRB, 0.17726848E-10_JPRB, 0.23653128E-10_JPRB, 0.31554297E-10_JPRB, &
  & 0.40929409E-10_JPRB, 0.51450195E-10_JPRB, 0.61879744E-10_JPRB, 0.71868171E-10_JPRB, 0.80765970E-10_JPRB, 0.88542847E-10_JPRB, &
  & 0.95362766E-10_JPRB, 0.10154622E-09_JPRB, 0.10765401E-09_JPRB, 0.11434290E-09_JPRB, 0.12270329E-09_JPRB, 0.13463282E-09_JPRB, &
  & 0.15270206E-09_JPRB, 0.18047716E-09_JPRB, 0.20597883E-09_JPRB, 0.23746677E-09_JPRB /)

RGHG4(:,43, 8) = (/ &
  & 0.97637558E-11_JPRB, 0.16115510E-10_JPRB, 0.25436342E-10_JPRB, 0.28749158E-10_JPRB, 0.40201946E-10_JPRB, 0.51136623E-10_JPRB, &
  & 0.60134724E-10_JPRB, 0.67641781E-10_JPRB, 0.70626623E-10_JPRB, 0.74861013E-10_JPRB, 0.77727394E-10_JPRB, 0.79273331E-10_JPRB, &
  & 0.79367485E-10_JPRB, 0.78167944E-10_JPRB, 0.75700266E-10_JPRB, 0.71880557E-10_JPRB, 0.66590400E-10_JPRB, 0.59625138E-10_JPRB, &
  & 0.51146965E-10_JPRB, 0.41540028E-10_JPRB, 0.32146175E-10_JPRB, 0.24149628E-10_JPRB, 0.18171603E-10_JPRB, 0.13943405E-10_JPRB, &
  & 0.10960179E-10_JPRB, 0.87469199E-11_JPRB, 0.70168654E-11_JPRB, 0.56161018E-11_JPRB, 0.44651652E-11_JPRB, 0.35276320E-11_JPRB, &
  & 0.28043089E-11_JPRB, 0.23038761E-11_JPRB, 0.20122549E-11_JPRB, 0.18947443E-11_JPRB, 0.19073057E-11_JPRB, 0.20295354E-11_JPRB, &
  & 0.22542430E-11_JPRB, 0.25890195E-11_JPRB, 0.30461079E-11_JPRB, 0.36705786E-11_JPRB, 0.44686494E-11_JPRB, 0.54625458E-11_JPRB, &
  & 0.67806780E-11_JPRB, 0.83869621E-11_JPRB, 0.10556785E-10_JPRB, 0.13594543E-10_JPRB, 0.17870606E-10_JPRB, 0.23956634E-10_JPRB, &
  & 0.31648059E-10_JPRB, 0.40723976E-10_JPRB, 0.49963859E-10_JPRB, 0.58966929E-10_JPRB, 0.66923793E-10_JPRB, 0.73819818E-10_JPRB, &
  & 0.79871040E-10_JPRB, 0.85343579E-10_JPRB, 0.90784782E-10_JPRB, 0.96753043E-10_JPRB, 0.10419038E-09_JPRB, 0.11455107E-09_JPRB, &
  & 0.12984026E-09_JPRB, 0.15294481E-09_JPRB, 0.17511055E-09_JPRB, 0.20356840E-09_JPRB /)

RGHG4(:,44, 8) = (/ &
  & 0.86779525E-11_JPRB, 0.13803157E-10_JPRB, 0.21739296E-10_JPRB, 0.24785190E-10_JPRB, 0.35130145E-10_JPRB, 0.45185959E-10_JPRB, &
  & 0.52941349E-10_JPRB, 0.59190222E-10_JPRB, 0.60987611E-10_JPRB, 0.64367990E-10_JPRB, 0.66624109E-10_JPRB, 0.67835515E-10_JPRB, &
  & 0.67879230E-10_JPRB, 0.66843135E-10_JPRB, 0.64762126E-10_JPRB, 0.61585056E-10_JPRB, 0.57178619E-10_JPRB, 0.51417700E-10_JPRB, &
  & 0.44194190E-10_JPRB, 0.36045073E-10_JPRB, 0.27988488E-10_JPRB, 0.21193599E-10_JPRB, 0.16092190E-10_JPRB, 0.12445350E-10_JPRB, &
  & 0.98312972E-11_JPRB, 0.78675269E-11_JPRB, 0.63274269E-11_JPRB, 0.50789767E-11_JPRB, 0.40503972E-11_JPRB, 0.32134217E-11_JPRB, &
  & 0.25679975E-11_JPRB, 0.21248760E-11_JPRB, 0.18709912E-11_JPRB, 0.17756165E-11_JPRB, 0.17918349E-11_JPRB, 0.19085267E-11_JPRB, &
  & 0.21110702E-11_JPRB, 0.24123375E-11_JPRB, 0.28150557E-11_JPRB, 0.33529345E-11_JPRB, 0.40272000E-11_JPRB, 0.48214401E-11_JPRB, &
  & 0.58312491E-11_JPRB, 0.70135330E-11_JPRB, 0.85228855E-11_JPRB, 0.10638850E-10_JPRB, 0.13634081E-10_JPRB, 0.18127753E-10_JPRB, &
  & 0.24195295E-10_JPRB, 0.31766815E-10_JPRB, 0.39820546E-10_JPRB, 0.47790178E-10_JPRB, 0.54836084E-10_JPRB, 0.60953152E-10_JPRB, &
  & 0.66256389E-10_JPRB, 0.71012779E-10_JPRB, 0.75718841E-10_JPRB, 0.80855288E-10_JPRB, 0.87245183E-10_JPRB, 0.96088214E-10_JPRB, &
  & 0.10877249E-09_JPRB, 0.12749832E-09_JPRB, 0.14637044E-09_JPRB, 0.17175257E-09_JPRB /)

RGHG4(:,45, 8) = (/ &
  & 0.77689799E-11_JPRB, 0.12177732E-10_JPRB, 0.18849223E-10_JPRB, 0.21492615E-10_JPRB, 0.30615486E-10_JPRB, 0.39390758E-10_JPRB, &
  & 0.46003187E-10_JPRB, 0.51117922E-10_JPRB, 0.51909772E-10_JPRB, 0.54553605E-10_JPRB, 0.56285261E-10_JPRB, 0.57190253E-10_JPRB, &
  & 0.57177745E-10_JPRB, 0.56301096E-10_JPRB, 0.54586852E-10_JPRB, 0.51969394E-10_JPRB, 0.48391187E-10_JPRB, 0.43604780E-10_JPRB, &
  & 0.37728324E-10_JPRB, 0.30913473E-10_JPRB, 0.24262847E-10_JPRB, 0.18590371E-10_JPRB, 0.14301847E-10_JPRB, 0.11184724E-10_JPRB, &
  & 0.89042541E-11_JPRB, 0.71638021E-11_JPRB, 0.57842975E-11_JPRB, 0.46592773E-11_JPRB, 0.37300341E-11_JPRB, 0.29694623E-11_JPRB, &
  & 0.23846719E-11_JPRB, 0.19826031E-11_JPRB, 0.17575787E-11_JPRB, 0.16746563E-11_JPRB, 0.16926359E-11_JPRB, 0.18022089E-11_JPRB, &
  & 0.19854047E-11_JPRB, 0.22613864E-11_JPRB, 0.26224515E-11_JPRB, 0.30923914E-11_JPRB, 0.36738221E-11_JPRB, 0.43280371E-11_JPRB, &
  & 0.51017380E-11_JPRB, 0.59983069E-11_JPRB, 0.70445329E-11_JPRB, 0.85068532E-11_JPRB, 0.10549067E-10_JPRB, 0.13724010E-10_JPRB, &
  & 0.18323270E-10_JPRB, 0.24385691E-10_JPRB, 0.31209386E-10_JPRB, 0.38030853E-10_JPRB, 0.44065817E-10_JPRB, 0.49229978E-10_JPRB, &
  & 0.53643045E-10_JPRB, 0.57604622E-10_JPRB, 0.61564365E-10_JPRB, 0.65908577E-10_JPRB, 0.71311054E-10_JPRB, 0.78577395E-10_JPRB, &
  & 0.88637958E-10_JPRB, 0.10313245E-09_JPRB, 0.11858219E-09_JPRB, 0.14068058E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART16',0,ZHOOK_HANDLE)



RGHG4(:,46, 8) = (/ &
  & 0.72478733E-11_JPRB, 0.10917448E-10_JPRB, 0.16646099E-10_JPRB, 0.18528056E-10_JPRB, 0.26233049E-10_JPRB, 0.33595345E-10_JPRB, &
  & 0.39094568E-10_JPRB, 0.43055250E-10_JPRB, 0.43077927E-10_JPRB, 0.45092600E-10_JPRB, 0.46397362E-10_JPRB, 0.47066673E-10_JPRB, &
  & 0.47028489E-10_JPRB, 0.46306084E-10_JPRB, 0.44915949E-10_JPRB, 0.42832623E-10_JPRB, 0.39955716E-10_JPRB, 0.36225016E-10_JPRB, &
  & 0.31483278E-10_JPRB, 0.26175369E-10_JPRB, 0.20870456E-10_JPRB, 0.16336847E-10_JPRB, 0.12805971E-10_JPRB, 0.10152665E-10_JPRB, &
  & 0.81602962E-11_JPRB, 0.66101976E-11_JPRB, 0.53662595E-11_JPRB, 0.43414812E-11_JPRB, 0.34892488E-11_JPRB, 0.27857948E-11_JPRB, &
  & 0.22450921E-11_JPRB, 0.18695885E-11_JPRB, 0.16685060E-11_JPRB, 0.15859373E-11_JPRB, 0.16097975E-11_JPRB, 0.17060732E-11_JPRB, &
  & 0.18765545E-11_JPRB, 0.21315673E-11_JPRB, 0.24604420E-11_JPRB, 0.28816051E-11_JPRB, 0.33941884E-11_JPRB, 0.39467045E-11_JPRB, &
  & 0.45574460E-11_JPRB, 0.52392517E-11_JPRB, 0.59806890E-11_JPRB, 0.69734067E-11_JPRB, 0.83478172E-11_JPRB, 0.10500012E-10_JPRB, &
  & 0.13765699E-10_JPRB, 0.18369046E-10_JPRB, 0.23884186E-10_JPRB, 0.29513680E-10_JPRB, 0.34508056E-10_JPRB, 0.38716252E-10_JPRB, &
  & 0.42263578E-10_JPRB, 0.45410117E-10_JPRB, 0.48558647E-10_JPRB, 0.51977415E-10_JPRB, 0.56228820E-10_JPRB, 0.61854959E-10_JPRB, &
  & 0.69347111E-10_JPRB, 0.79733567E-10_JPRB, 0.91520319E-10_JPRB, 0.10982715E-09_JPRB /)

RGHG4(:,47, 8) = (/ &
  & 0.66710392E-11_JPRB, 0.97618033E-11_JPRB, 0.14486945E-10_JPRB, 0.15618846E-10_JPRB, 0.21752582E-10_JPRB, 0.27582603E-10_JPRB, &
  & 0.31715758E-10_JPRB, 0.34724289E-10_JPRB, 0.33909660E-10_JPRB, 0.35414442E-10_JPRB, 0.36376735E-10_JPRB, 0.36899674E-10_JPRB, &
  & 0.36902988E-10_JPRB, 0.36388018E-10_JPRB, 0.35372490E-10_JPRB, 0.33804105E-10_JPRB, 0.31687125E-10_JPRB, 0.28868002E-10_JPRB, &
  & 0.25491715E-10_JPRB, 0.21606298E-10_JPRB, 0.17760392E-10_JPRB, 0.14295776E-10_JPRB, 0.11474917E-10_JPRB, 0.92570222E-11_JPRB, &
  & 0.75297138E-11_JPRB, 0.61506178E-11_JPRB, 0.50263552E-11_JPRB, 0.40841046E-11_JPRB, 0.32955411E-11_JPRB, 0.26391283E-11_JPRB, &
  & 0.21323247E-11_JPRB, 0.17805111E-11_JPRB, 0.15945477E-11_JPRB, 0.15090747E-11_JPRB, 0.15415922E-11_JPRB, 0.16170670E-11_JPRB, &
  & 0.17834473E-11_JPRB, 0.20160609E-11_JPRB, 0.23183163E-11_JPRB, 0.26995990E-11_JPRB, 0.31499066E-11_JPRB, 0.36269434E-11_JPRB, &
  & 0.41126833E-11_JPRB, 0.46380321E-11_JPRB, 0.51768264E-11_JPRB, 0.58394812E-11_JPRB, 0.67562731E-11_JPRB, 0.81335797E-11_JPRB, &
  & 0.10330876E-10_JPRB, 0.13526764E-10_JPRB, 0.17713785E-10_JPRB, 0.22110149E-10_JPRB, 0.26080816E-10_JPRB, 0.29390195E-10_JPRB, &
  & 0.32107737E-10_JPRB, 0.34544371E-10_JPRB, 0.37010145E-10_JPRB, 0.39677893E-10_JPRB, 0.42989157E-10_JPRB, 0.47180784E-10_JPRB, &
  & 0.52476645E-10_JPRB, 0.59497379E-10_JPRB, 0.67933437E-10_JPRB, 0.81921643E-10_JPRB /)

RGHG4(:,48, 8) = (/ &
  & 0.61169828E-11_JPRB, 0.86059779E-11_JPRB, 0.12365052E-10_JPRB, 0.12628710E-10_JPRB, 0.17157905E-10_JPRB, 0.21248338E-10_JPRB, &
  & 0.24128194E-10_JPRB, 0.26086421E-10_JPRB, 0.24576017E-10_JPRB, 0.25604982E-10_JPRB, 0.26316714E-10_JPRB, 0.26764039E-10_JPRB, &
  & 0.26892412E-10_JPRB, 0.26657947E-10_JPRB, 0.26060222E-10_JPRB, 0.25086051E-10_JPRB, 0.23730457E-10_JPRB, 0.22005226E-10_JPRB, &
  & 0.19914886E-10_JPRB, 0.17541293E-10_JPRB, 0.15025739E-10_JPRB, 0.12564240E-10_JPRB, 0.10378446E-10_JPRB, 0.85349817E-11_JPRB, &
  & 0.70328704E-11_JPRB, 0.57994985E-11_JPRB, 0.47715660E-11_JPRB, 0.38986618E-11_JPRB, 0.31548048E-11_JPRB, 0.25353066E-11_JPRB, &
  & 0.20488322E-11_JPRB, 0.17216614E-11_JPRB, 0.15315227E-11_JPRB, 0.14585403E-11_JPRB, 0.14819734E-11_JPRB, 0.15455822E-11_JPRB, &
  & 0.17100097E-11_JPRB, 0.19211046E-11_JPRB, 0.22060858E-11_JPRB, 0.25548736E-11_JPRB, 0.29638043E-11_JPRB, 0.33811716E-11_JPRB, &
  & 0.37888069E-11_JPRB, 0.41891677E-11_JPRB, 0.45990403E-11_JPRB, 0.50452138E-11_JPRB, 0.56497649E-11_JPRB, 0.65170421E-11_JPRB, &
  & 0.78678817E-11_JPRB, 0.99186831E-11_JPRB, 0.12672442E-10_JPRB, 0.15814341E-10_JPRB, 0.18739321E-10_JPRB, 0.21192777E-10_JPRB, &
  & 0.23237924E-10_JPRB, 0.25085430E-10_JPRB, 0.27001840E-10_JPRB, 0.29005499E-10_JPRB, 0.31465955E-10_JPRB, 0.34472689E-10_JPRB, &
  & 0.38092272E-10_JPRB, 0.42616962E-10_JPRB, 0.48336862E-10_JPRB, 0.58612559E-10_JPRB /)

RGHG4(:,49, 8) = (/ &
  & 0.55518190E-11_JPRB, 0.74502540E-11_JPRB, 0.10260856E-10_JPRB, 0.98330233E-11_JPRB, 0.12847977E-10_JPRB, 0.15382352E-10_JPRB, &
  & 0.17019618E-10_JPRB, 0.18062276E-10_JPRB, 0.15887439E-10_JPRB, 0.16441891E-10_JPRB, 0.16897607E-10_JPRB, 0.17261628E-10_JPRB, &
  & 0.17477762E-10_JPRB, 0.17509194E-10_JPRB, 0.17342900E-10_JPRB, 0.16966525E-10_JPRB, 0.16446438E-10_JPRB, 0.15783376E-10_JPRB, &
  & 0.14977129E-10_JPRB, 0.13955372E-10_JPRB, 0.12613883E-10_JPRB, 0.11042498E-10_JPRB, 0.94210889E-11_JPRB, 0.79163941E-11_JPRB, &
  & 0.66177511E-11_JPRB, 0.55121554E-11_JPRB, 0.45689047E-11_JPRB, 0.37537196E-11_JPRB, 0.30486501E-11_JPRB, 0.24577033E-11_JPRB, &
  & 0.19875122E-11_JPRB, 0.16804626E-11_JPRB, 0.14810487E-11_JPRB, 0.14321943E-11_JPRB, 0.14257658E-11_JPRB, 0.14993236E-11_JPRB, &
  & 0.16497171E-11_JPRB, 0.18441422E-11_JPRB, 0.21109197E-11_JPRB, 0.24339075E-11_JPRB, 0.28001724E-11_JPRB, 0.31735873E-11_JPRB, &
  & 0.35200946E-11_JPRB, 0.38385337E-11_JPRB, 0.41491745E-11_JPRB, 0.44648261E-11_JPRB, 0.48484979E-11_JPRB, 0.53718466E-11_JPRB, &
  & 0.61416848E-11_JPRB, 0.72800542E-11_JPRB, 0.88354003E-11_JPRB, 0.10624712E-10_JPRB, 0.12432254E-10_JPRB, 0.14003115E-10_JPRB, &
  & 0.15376435E-10_JPRB, 0.16681328E-10_JPRB, 0.18145241E-10_JPRB, 0.19653864E-10_JPRB, 0.21488734E-10_JPRB, 0.23644942E-10_JPRB, &
  & 0.26100875E-10_JPRB, 0.28931555E-10_JPRB, 0.32682388E-10_JPRB, 0.39929577E-10_JPRB /)

RGHG4(:,50, 8) = (/ &
  & 0.49592526E-11_JPRB, 0.64268629E-11_JPRB, 0.84721622E-11_JPRB, 0.76054319E-11_JPRB, 0.95497143E-11_JPRB, 0.11025197E-10_JPRB, &
  & 0.11832917E-10_JPRB, 0.12318133E-10_JPRB, 0.98277289E-11_JPRB, 0.10051647E-10_JPRB, 0.10240702E-10_JPRB, 0.10459840E-10_JPRB, &
  & 0.10659147E-10_JPRB, 0.10812388E-10_JPRB, 0.10918235E-10_JPRB, 0.10988544E-10_JPRB, 0.11056322E-10_JPRB, 0.11134790E-10_JPRB, &
  & 0.11190916E-10_JPRB, 0.11058068E-10_JPRB, 0.10614912E-10_JPRB, 0.97428402E-11_JPRB, 0.86090926E-11_JPRB, 0.74004327E-11_JPRB, &
  & 0.62763969E-11_JPRB, 0.52820127E-11_JPRB, 0.44111663E-11_JPRB, 0.36433053E-11_JPRB, 0.29747567E-11_JPRB, 0.24010171E-11_JPRB, &
  & 0.19585097E-11_JPRB, 0.16481931E-11_JPRB, 0.14681681E-11_JPRB, 0.14134766E-11_JPRB, 0.13933701E-11_JPRB, 0.14785791E-11_JPRB, &
  & 0.16079836E-11_JPRB, 0.17915761E-11_JPRB, 0.20422381E-11_JPRB, 0.23398466E-11_JPRB, 0.26776957E-11_JPRB, 0.30148909E-11_JPRB, &
  & 0.33172152E-11_JPRB, 0.35738728E-11_JPRB, 0.38128255E-11_JPRB, 0.40435402E-11_JPRB, 0.42829169E-11_JPRB, 0.45891567E-11_JPRB, &
  & 0.49986937E-11_JPRB, 0.55773732E-11_JPRB, 0.62938309E-11_JPRB, 0.71502791E-11_JPRB, 0.79919986E-11_JPRB, 0.87993579E-11_JPRB, &
  & 0.95630413E-11_JPRB, 0.10358673E-10_JPRB, 0.11398072E-10_JPRB, 0.12420271E-10_JPRB, 0.13690689E-10_JPRB, 0.15209211E-10_JPRB, &
  & 0.16912451E-10_JPRB, 0.18772343E-10_JPRB, 0.21320149E-10_JPRB, 0.26547263E-10_JPRB /)

RGHG4(:,51, 8) = (/ &
  & 0.45670022E-11_JPRB, 0.55898268E-11_JPRB, 0.72107398E-11_JPRB, 0.60293328E-11_JPRB, 0.73768595E-11_JPRB, 0.82691614E-11_JPRB, &
  & 0.87188095E-11_JPRB, 0.89086325E-11_JPRB, 0.65686640E-11_JPRB, 0.66157639E-11_JPRB, 0.66930719E-11_JPRB, 0.68006221E-11_JPRB, &
  & 0.69476950E-11_JPRB, 0.71136851E-11_JPRB, 0.73111378E-11_JPRB, 0.75366579E-11_JPRB, 0.78244590E-11_JPRB, 0.81710029E-11_JPRB, &
  & 0.85615248E-11_JPRB, 0.88963255E-11_JPRB, 0.89722969E-11_JPRB, 0.86445798E-11_JPRB, 0.79175928E-11_JPRB, 0.69708683E-11_JPRB, &
  & 0.60003495E-11_JPRB, 0.51006660E-11_JPRB, 0.42947564E-11_JPRB, 0.35659930E-11_JPRB, 0.29330113E-11_JPRB, 0.23734127E-11_JPRB, &
  & 0.19543757E-11_JPRB, 0.16352652E-11_JPRB, 0.14869039E-11_JPRB, 0.14036120E-11_JPRB, 0.13993118E-11_JPRB, 0.14787529E-11_JPRB, &
  & 0.15913748E-11_JPRB, 0.17669284E-11_JPRB, 0.19973526E-11_JPRB, 0.22725901E-11_JPRB, 0.25828337E-11_JPRB, 0.28920208E-11_JPRB, &
  & 0.31563766E-11_JPRB, 0.33816988E-11_JPRB, 0.35691023E-11_JPRB, 0.37398283E-11_JPRB, 0.38974002E-11_JPRB, 0.40587273E-11_JPRB, &
  & 0.42617472E-11_JPRB, 0.45106588E-11_JPRB, 0.48112443E-11_JPRB, 0.51331430E-11_JPRB, 0.54570190E-11_JPRB, 0.57757007E-11_JPRB, &
  & 0.60907520E-11_JPRB, 0.64351341E-11_JPRB, 0.70910972E-11_JPRB, 0.75987628E-11_JPRB, 0.82616214E-11_JPRB, 0.91321169E-11_JPRB, &
  & 0.10139332E-10_JPRB, 0.11233381E-10_JPRB, 0.12909927E-10_JPRB, 0.16689620E-10_JPRB /)

RGHG4(:,52, 8) = (/ &
  & 0.42517075E-11_JPRB, 0.50265018E-11_JPRB, 0.62281577E-11_JPRB, 0.50400764E-11_JPRB, 0.59490152E-11_JPRB, 0.66137499E-11_JPRB, &
  & 0.68652332E-11_JPRB, 0.69864743E-11_JPRB, 0.48734502E-11_JPRB, 0.48885206E-11_JPRB, 0.49144998E-11_JPRB, 0.49870741E-11_JPRB, &
  & 0.51002913E-11_JPRB, 0.52575422E-11_JPRB, 0.54590226E-11_JPRB, 0.57088301E-11_JPRB, 0.60207204E-11_JPRB, 0.64054586E-11_JPRB, &
  & 0.68531530E-11_JPRB, 0.73187342E-11_JPRB, 0.76728129E-11_JPRB, 0.77005459E-11_JPRB, 0.73155241E-11_JPRB, 0.66048503E-11_JPRB, &
  & 0.57731146E-11_JPRB, 0.49593649E-11_JPRB, 0.42134694E-11_JPRB, 0.35254456E-11_JPRB, 0.29136504E-11_JPRB, 0.23870107E-11_JPRB, &
  & 0.19667842E-11_JPRB, 0.16789296E-11_JPRB, 0.15218908E-11_JPRB, 0.14336544E-11_JPRB, 0.14437787E-11_JPRB, 0.15077001E-11_JPRB, &
  & 0.16125349E-11_JPRB, 0.17797406E-11_JPRB, 0.19926107E-11_JPRB, 0.22483545E-11_JPRB, 0.25363097E-11_JPRB, 0.28206398E-11_JPRB, &
  & 0.30499902E-11_JPRB, 0.32398929E-11_JPRB, 0.33974262E-11_JPRB, 0.35251305E-11_JPRB, 0.36189292E-11_JPRB, 0.36967248E-11_JPRB, &
  & 0.37752514E-11_JPRB, 0.38631490E-11_JPRB, 0.39609002E-11_JPRB, 0.40591593E-11_JPRB, 0.41613119E-11_JPRB, 0.42569021E-11_JPRB, &
  & 0.43717152E-11_JPRB, 0.45096548E-11_JPRB, 0.49781932E-11_JPRB, 0.51893741E-11_JPRB, 0.54679677E-11_JPRB, 0.58613513E-11_JPRB, &
  & 0.63493954E-11_JPRB, 0.69094227E-11_JPRB, 0.78700987E-11_JPRB, 0.10263753E-10_JPRB /)

RGHG4(:,53, 8) = (/ &
  & 0.40359105E-11_JPRB, 0.46391220E-11_JPRB, 0.56077560E-11_JPRB, 0.43276945E-11_JPRB, 0.50610067E-11_JPRB, 0.55235343E-11_JPRB, &
  & 0.57373099E-11_JPRB, 0.57835915E-11_JPRB, 0.39653866E-11_JPRB, 0.39524807E-11_JPRB, 0.39737809E-11_JPRB, 0.40289304E-11_JPRB, &
  & 0.41275568E-11_JPRB, 0.42706680E-11_JPRB, 0.44601584E-11_JPRB, 0.46958544E-11_JPRB, 0.49873035E-11_JPRB, 0.53398249E-11_JPRB, &
  & 0.57619903E-11_JPRB, 0.62344236E-11_JPRB, 0.66819545E-11_JPRB, 0.69291326E-11_JPRB, 0.68091852E-11_JPRB, 0.63120685E-11_JPRB, &
  & 0.56076753E-11_JPRB, 0.48726852E-11_JPRB, 0.41818194E-11_JPRB, 0.35351930E-11_JPRB, 0.29431852E-11_JPRB, 0.24485193E-11_JPRB, &
  & 0.20191576E-11_JPRB, 0.17580039E-11_JPRB, 0.15785405E-11_JPRB, 0.15098362E-11_JPRB, 0.15189750E-11_JPRB, 0.15707714E-11_JPRB, &
  & 0.16716601E-11_JPRB, 0.18277266E-11_JPRB, 0.20234263E-11_JPRB, 0.22610225E-11_JPRB, 0.25292609E-11_JPRB, 0.27938153E-11_JPRB, &
  & 0.29908454E-11_JPRB, 0.31683690E-11_JPRB, 0.33017261E-11_JPRB, 0.34022592E-11_JPRB, 0.34521047E-11_JPRB, 0.34767879E-11_JPRB, &
  & 0.34853908E-11_JPRB, 0.34924548E-11_JPRB, 0.34950053E-11_JPRB, 0.35042845E-11_JPRB, 0.35119787E-11_JPRB, 0.35299545E-11_JPRB, &
  & 0.35618808E-11_JPRB, 0.36035135E-11_JPRB, 0.40001895E-11_JPRB, 0.40811560E-11_JPRB, 0.41888984E-11_JPRB, 0.43609886E-11_JPRB, &
  & 0.45783759E-11_JPRB, 0.48267015E-11_JPRB, 0.53178850E-11_JPRB, 0.66965977E-11_JPRB /)

RGHG4(:,54, 8) = (/ &
  & 0.38244525E-11_JPRB, 0.43853198E-11_JPRB, 0.51414207E-11_JPRB, 0.38763502E-11_JPRB, 0.44304022E-11_JPRB, 0.48157997E-11_JPRB, &
  & 0.49624185E-11_JPRB, 0.50108468E-11_JPRB, 0.34080046E-11_JPRB, 0.33992629E-11_JPRB, 0.34053270E-11_JPRB, 0.34559859E-11_JPRB, &
  & 0.35428949E-11_JPRB, 0.36741946E-11_JPRB, 0.38465641E-11_JPRB, 0.40606264E-11_JPRB, 0.43184271E-11_JPRB, 0.46366188E-11_JPRB, &
  & 0.50109114E-11_JPRB, 0.54516691E-11_JPRB, 0.59258050E-11_JPRB, 0.63020366E-11_JPRB, 0.63933182E-11_JPRB, 0.60968123E-11_JPRB, &
  & 0.55144140E-11_JPRB, 0.48571711E-11_JPRB, 0.42195258E-11_JPRB, 0.36104778E-11_JPRB, 0.30368555E-11_JPRB, 0.25496825E-11_JPRB, &
  & 0.21496221E-11_JPRB, 0.18775530E-11_JPRB, 0.17053674E-11_JPRB, 0.16478001E-11_JPRB, 0.16498370E-11_JPRB, 0.16966349E-11_JPRB, &
  & 0.17950975E-11_JPRB, 0.19416354E-11_JPRB, 0.21235663E-11_JPRB, 0.23465808E-11_JPRB, 0.25988523E-11_JPRB, 0.28414664E-11_JPRB, &
  & 0.30034306E-11_JPRB, 0.31582551E-11_JPRB, 0.32757124E-11_JPRB, 0.33562161E-11_JPRB, 0.33701839E-11_JPRB, 0.33565191E-11_JPRB, &
  & 0.33220447E-11_JPRB, 0.32745026E-11_JPRB, 0.32433362E-11_JPRB, 0.32096738E-11_JPRB, 0.31826466E-11_JPRB, 0.31715691E-11_JPRB, &
  & 0.31687706E-11_JPRB, 0.31886035E-11_JPRB, 0.35707294E-11_JPRB, 0.36132818E-11_JPRB, 0.36657452E-11_JPRB, 0.37423558E-11_JPRB, &
  & 0.38454214E-11_JPRB, 0.39503366E-11_JPRB, 0.41769387E-11_JPRB, 0.47468743E-11_JPRB /)

RGHG4(:,55, 8) = (/ &
  & 0.36584559E-11_JPRB, 0.41693242E-11_JPRB, 0.48374135E-11_JPRB, 0.35608272E-11_JPRB, 0.39912466E-11_JPRB, 0.42825244E-11_JPRB, &
  & 0.44200399E-11_JPRB, 0.44416202E-11_JPRB, 0.30640614E-11_JPRB, 0.30475672E-11_JPRB, 0.30570802E-11_JPRB, 0.30977029E-11_JPRB, &
  & 0.31777610E-11_JPRB, 0.32979279E-11_JPRB, 0.34572497E-11_JPRB, 0.36523293E-11_JPRB, 0.38896039E-11_JPRB, 0.41677976E-11_JPRB, &
  & 0.45178167E-11_JPRB, 0.49252690E-11_JPRB, 0.53958856E-11_JPRB, 0.58450007E-11_JPRB, 0.60933264E-11_JPRB, 0.59767152E-11_JPRB, &
  & 0.55113206E-11_JPRB, 0.49273819E-11_JPRB, 0.43397078E-11_JPRB, 0.37583881E-11_JPRB, 0.32107364E-11_JPRB, 0.27245487E-11_JPRB, &
  & 0.23270836E-11_JPRB, 0.20390621E-11_JPRB, 0.18757671E-11_JPRB, 0.18116682E-11_JPRB, 0.18072972E-11_JPRB, 0.18514678E-11_JPRB, &
  & 0.19476825E-11_JPRB, 0.20864788E-11_JPRB, 0.22591820E-11_JPRB, 0.24740310E-11_JPRB, 0.27166054E-11_JPRB, 0.29468225E-11_JPRB, &
  & 0.30889210E-11_JPRB, 0.32350678E-11_JPRB, 0.33379365E-11_JPRB, 0.34039616E-11_JPRB, 0.33840929E-11_JPRB, 0.33443988E-11_JPRB, &
  & 0.32764143E-11_JPRB, 0.32095769E-11_JPRB, 0.31506573E-11_JPRB, 0.30974581E-11_JPRB, 0.30620179E-11_JPRB, 0.30336597E-11_JPRB, &
  & 0.30226876E-11_JPRB, 0.30279214E-11_JPRB, 0.33810634E-11_JPRB, 0.34081869E-11_JPRB, 0.34355012E-11_JPRB, 0.34807320E-11_JPRB, &
  & 0.35479024E-11_JPRB, 0.36070775E-11_JPRB, 0.37618563E-11_JPRB, 0.40038237E-11_JPRB /)

RGHG4(:,56, 8) = (/ &
  & 0.35704892E-11_JPRB, 0.40106252E-11_JPRB, 0.46036742E-11_JPRB, 0.33259727E-11_JPRB, 0.36712031E-11_JPRB, 0.39075457E-11_JPRB, &
  & 0.40113000E-11_JPRB, 0.40392594E-11_JPRB, 0.28297787E-11_JPRB, 0.28158706E-11_JPRB, 0.28187912E-11_JPRB, 0.28560856E-11_JPRB, &
  & 0.29271648E-11_JPRB, 0.30342940E-11_JPRB, 0.31825048E-11_JPRB, 0.33600507E-11_JPRB, 0.35814075E-11_JPRB, 0.38430704E-11_JPRB, &
  & 0.41651791E-11_JPRB, 0.45613205E-11_JPRB, 0.50396987E-11_JPRB, 0.55491718E-11_JPRB, 0.59325730E-11_JPRB, 0.59708176E-11_JPRB, &
  & 0.56140930E-11_JPRB, 0.50978176E-11_JPRB, 0.45650051E-11_JPRB, 0.39957855E-11_JPRB, 0.34478943E-11_JPRB, 0.29549076E-11_JPRB, &
  & 0.25427327E-11_JPRB, 0.22519220E-11_JPRB, 0.20834558E-11_JPRB, 0.20104595E-11_JPRB, 0.20037741E-11_JPRB, 0.20465467E-11_JPRB, &
  & 0.21392358E-11_JPRB, 0.22722345E-11_JPRB, 0.24385205E-11_JPRB, 0.26466919E-11_JPRB, 0.28841001E-11_JPRB, 0.31073826E-11_JPRB, &
  & 0.32441632E-11_JPRB, 0.33825241E-11_JPRB, 0.34791393E-11_JPRB, 0.35335751E-11_JPRB, 0.34901802E-11_JPRB, 0.34326099E-11_JPRB, &
  & 0.33341923E-11_JPRB, 0.32403899E-11_JPRB, 0.31714698E-11_JPRB, 0.31131614E-11_JPRB, 0.30629934E-11_JPRB, 0.30306964E-11_JPRB, &
  & 0.30130599E-11_JPRB, 0.30131340E-11_JPRB, 0.33590233E-11_JPRB, 0.33887047E-11_JPRB, 0.34097935E-11_JPRB, 0.34439790E-11_JPRB, &
  & 0.34937433E-11_JPRB, 0.35428719E-11_JPRB, 0.37025209E-11_JPRB, 0.40417934E-11_JPRB /)

RGHG4(:,57, 8) = (/ &
  & 0.34884010E-11_JPRB, 0.39033395E-11_JPRB, 0.44030027E-11_JPRB, 0.31692676E-11_JPRB, 0.34188739E-11_JPRB, 0.36046298E-11_JPRB, &
  & 0.37012780E-11_JPRB, 0.37190533E-11_JPRB, 0.26795564E-11_JPRB, 0.26619737E-11_JPRB, 0.26657027E-11_JPRB, 0.26972296E-11_JPRB, &
  & 0.27633854E-11_JPRB, 0.28649969E-11_JPRB, 0.30028211E-11_JPRB, 0.31748733E-11_JPRB, 0.33852209E-11_JPRB, 0.36404894E-11_JPRB, &
  & 0.39578197E-11_JPRB, 0.43586341E-11_JPRB, 0.48544133E-11_JPRB, 0.54268348E-11_JPRB, 0.59143463E-11_JPRB, 0.60938806E-11_JPRB, &
  & 0.58255900E-11_JPRB, 0.53520569E-11_JPRB, 0.48188836E-11_JPRB, 0.42565526E-11_JPRB, 0.37087972E-11_JPRB, 0.32147789E-11_JPRB, &
  & 0.27952471E-11_JPRB, 0.24937134E-11_JPRB, 0.23156854E-11_JPRB, 0.22376959E-11_JPRB, 0.22297672E-11_JPRB, 0.22703618E-11_JPRB, &
  & 0.23589668E-11_JPRB, 0.24858204E-11_JPRB, 0.26464707E-11_JPRB, 0.28511696E-11_JPRB, 0.30851790E-11_JPRB, 0.33049518E-11_JPRB, &
  & 0.34459304E-11_JPRB, 0.35835753E-11_JPRB, 0.36795740E-11_JPRB, 0.37332225E-11_JPRB, 0.36868360E-11_JPRB, 0.36210256E-11_JPRB, &
  & 0.35015402E-11_JPRB, 0.33873058E-11_JPRB, 0.33072226E-11_JPRB, 0.32370738E-11_JPRB, 0.31852938E-11_JPRB, 0.31426224E-11_JPRB, &
  & 0.31194914E-11_JPRB, 0.31171198E-11_JPRB, 0.34387747E-11_JPRB, 0.34605606E-11_JPRB, 0.34745327E-11_JPRB, 0.35040291E-11_JPRB, &
  & 0.35477511E-11_JPRB, 0.35902763E-11_JPRB, 0.37225618E-11_JPRB, 0.39695872E-11_JPRB /)

RGHG4(:,58, 8) = (/ &
  & 0.34703082E-11_JPRB, 0.38273924E-11_JPRB, 0.42745633E-11_JPRB, 0.30384319E-11_JPRB, 0.32447009E-11_JPRB, 0.33934739E-11_JPRB, &
  & 0.34736270E-11_JPRB, 0.34965754E-11_JPRB, 0.25871007E-11_JPRB, 0.25755619E-11_JPRB, 0.25745352E-11_JPRB, 0.26049469E-11_JPRB, &
  & 0.26635636E-11_JPRB, 0.27630136E-11_JPRB, 0.28975613E-11_JPRB, 0.30705761E-11_JPRB, 0.32809610E-11_JPRB, 0.35451670E-11_JPRB, &
  & 0.38658473E-11_JPRB, 0.42900683E-11_JPRB, 0.48279926E-11_JPRB, 0.54569270E-11_JPRB, 0.60279199E-11_JPRB, 0.62551791E-11_JPRB, &
  & 0.60551286E-11_JPRB, 0.56248508E-11_JPRB, 0.51169446E-11_JPRB, 0.45589348E-11_JPRB, 0.40079242E-11_JPRB, 0.35016220E-11_JPRB, &
  & 0.30746412E-11_JPRB, 0.27656792E-11_JPRB, 0.25816588E-11_JPRB, 0.25019836E-11_JPRB, 0.24937444E-11_JPRB, 0.25325857E-11_JPRB, &
  & 0.26162453E-11_JPRB, 0.27364079E-11_JPRB, 0.28913540E-11_JPRB, 0.30895486E-11_JPRB, 0.33186292E-11_JPRB, 0.35394131E-11_JPRB, &
  & 0.36888166E-11_JPRB, 0.38272736E-11_JPRB, 0.39231179E-11_JPRB, 0.39787305E-11_JPRB, 0.39447382E-11_JPRB, 0.38848373E-11_JPRB, &
  & 0.37668636E-11_JPRB, 0.36416065E-11_JPRB, 0.35582444E-11_JPRB, 0.34842513E-11_JPRB, 0.34150001E-11_JPRB, 0.33687027E-11_JPRB, &
  & 0.33402146E-11_JPRB, 0.33376372E-11_JPRB, 0.36405848E-11_JPRB, 0.36645327E-11_JPRB, 0.36782214E-11_JPRB, 0.37016523E-11_JPRB, &
  & 0.37393231E-11_JPRB, 0.37796394E-11_JPRB, 0.39160342E-11_JPRB, 0.41460433E-11_JPRB /)

RGHG4(:,59, 8) = (/ &
  & 0.34430937E-11_JPRB, 0.37838734E-11_JPRB, 0.41572167E-11_JPRB, 0.29602722E-11_JPRB, 0.31127971E-11_JPRB, 0.32344290E-11_JPRB, &
  & 0.33107224E-11_JPRB, 0.33367573E-11_JPRB, 0.25501946E-11_JPRB, 0.25400376E-11_JPRB, 0.25435674E-11_JPRB, 0.25775267E-11_JPRB, &
  & 0.26369607E-11_JPRB, 0.27401987E-11_JPRB, 0.28792582E-11_JPRB, 0.30648711E-11_JPRB, 0.32869330E-11_JPRB, 0.35704907E-11_JPRB, &
  & 0.39110291E-11_JPRB, 0.43693621E-11_JPRB, 0.49464573E-11_JPRB, 0.56190864E-11_JPRB, 0.61990283E-11_JPRB, 0.64695849E-11_JPRB, &
  & 0.63203769E-11_JPRB, 0.59250027E-11_JPRB, 0.54187657E-11_JPRB, 0.48640254E-11_JPRB, 0.43103398E-11_JPRB, 0.38045470E-11_JPRB, &
  & 0.33749986E-11_JPRB, 0.30616774E-11_JPRB, 0.28757337E-11_JPRB, 0.27969274E-11_JPRB, 0.27898174E-11_JPRB, 0.28267352E-11_JPRB, &
  & 0.29051969E-11_JPRB, 0.30184566E-11_JPRB, 0.31666380E-11_JPRB, 0.33600594E-11_JPRB, 0.35872321E-11_JPRB, 0.38064296E-11_JPRB, &
  & 0.39631649E-11_JPRB, 0.41061525E-11_JPRB, 0.42055187E-11_JPRB, 0.42707101E-11_JPRB, 0.42578332E-11_JPRB, 0.42161487E-11_JPRB, &
  & 0.41216392E-11_JPRB, 0.40044378E-11_JPRB, 0.39303977E-11_JPRB, 0.38546987E-11_JPRB, 0.37782607E-11_JPRB, 0.37235059E-11_JPRB, &
  & 0.36854447E-11_JPRB, 0.36758934E-11_JPRB, 0.39552541E-11_JPRB, 0.39743334E-11_JPRB, 0.39761944E-11_JPRB, 0.39921577E-11_JPRB, &
  & 0.40242614E-11_JPRB, 0.40618294E-11_JPRB, 0.41888350E-11_JPRB, 0.43936486E-11_JPRB /)

RGHG4(:,60, 8) = (/ &
  & 0.34521815E-11_JPRB, 0.37609165E-11_JPRB, 0.40838916E-11_JPRB, 0.29184166E-11_JPRB, 0.30481928E-11_JPRB, 0.31566464E-11_JPRB, &
  & 0.32316257E-11_JPRB, 0.32665615E-11_JPRB, 0.25803264E-11_JPRB, 0.25772860E-11_JPRB, 0.25827522E-11_JPRB, 0.26216950E-11_JPRB, &
  & 0.26914723E-11_JPRB, 0.28026895E-11_JPRB, 0.29624814E-11_JPRB, 0.31669242E-11_JPRB, 0.34174582E-11_JPRB, 0.37271744E-11_JPRB, &
  & 0.40936842E-11_JPRB, 0.45797428E-11_JPRB, 0.51873514E-11_JPRB, 0.58446984E-11_JPRB, 0.64214493E-11_JPRB, 0.66993711E-11_JPRB, &
  & 0.65901212E-11_JPRB, 0.62256879E-11_JPRB, 0.57318243E-11_JPRB, 0.51796445E-11_JPRB, 0.46287488E-11_JPRB, 0.41216362E-11_JPRB, &
  & 0.36957225E-11_JPRB, 0.33902059E-11_JPRB, 0.32100976E-11_JPRB, 0.31373164E-11_JPRB, 0.31340781E-11_JPRB, 0.31703958E-11_JPRB, &
  & 0.32440157E-11_JPRB, 0.33484827E-11_JPRB, 0.34875904E-11_JPRB, 0.36711654E-11_JPRB, 0.38908612E-11_JPRB, 0.41138620E-11_JPRB, &
  & 0.42784751E-11_JPRB, 0.44292846E-11_JPRB, 0.45324751E-11_JPRB, 0.46092097E-11_JPRB, 0.46154803E-11_JPRB, 0.45967665E-11_JPRB, &
  & 0.45359038E-11_JPRB, 0.44483367E-11_JPRB, 0.43996911E-11_JPRB, 0.43455799E-11_JPRB, 0.42696376E-11_JPRB, 0.42132825E-11_JPRB, &
  & 0.41747456E-11_JPRB, 0.41668127E-11_JPRB, 0.44350695E-11_JPRB, 0.44475782E-11_JPRB, 0.44408895E-11_JPRB, 0.44429035E-11_JPRB, &
  & 0.44629565E-11_JPRB, 0.44929659E-11_JPRB, 0.46110151E-11_JPRB, 0.47807817E-11_JPRB /)

RGHG4(:,61, 8) = (/ &
  & 0.34650752E-11_JPRB, 0.37586991E-11_JPRB, 0.40487401E-11_JPRB, 0.29168651E-11_JPRB, 0.30330447E-11_JPRB, 0.31385250E-11_JPRB, &
  & 0.32236468E-11_JPRB, 0.32739410E-11_JPRB, 0.26768262E-11_JPRB, 0.26851017E-11_JPRB, 0.27042574E-11_JPRB, 0.27552327E-11_JPRB, &
  & 0.28419389E-11_JPRB, 0.29788450E-11_JPRB, 0.31668476E-11_JPRB, 0.34099416E-11_JPRB, 0.36877407E-11_JPRB, 0.40340634E-11_JPRB, &
  & 0.44109130E-11_JPRB, 0.49092687E-11_JPRB, 0.54913105E-11_JPRB, 0.61247201E-11_JPRB, 0.66656173E-11_JPRB, 0.69466715E-11_JPRB, &
  & 0.68660368E-11_JPRB, 0.65266507E-11_JPRB, 0.60402291E-11_JPRB, 0.54927855E-11_JPRB, 0.49468745E-11_JPRB, 0.44551082E-11_JPRB, &
  & 0.40463141E-11_JPRB, 0.37572827E-11_JPRB, 0.35930690E-11_JPRB, 0.35337189E-11_JPRB, 0.35386468E-11_JPRB, 0.35761186E-11_JPRB, &
  & 0.36445096E-11_JPRB, 0.37383451E-11_JPRB, 0.38658590E-11_JPRB, 0.40406541E-11_JPRB, 0.42561805E-11_JPRB, 0.44722394E-11_JPRB, &
  & 0.46428300E-11_JPRB, 0.48017150E-11_JPRB, 0.49124368E-11_JPRB, 0.50045684E-11_JPRB, 0.50373672E-11_JPRB, 0.50527772E-11_JPRB, &
  & 0.50296885E-11_JPRB, 0.49801838E-11_JPRB, 0.49556878E-11_JPRB, 0.49374970E-11_JPRB, 0.48843043E-11_JPRB, 0.48473773E-11_JPRB, &
  & 0.48111996E-11_JPRB, 0.48145580E-11_JPRB, 0.50735150E-11_JPRB, 0.50836774E-11_JPRB, 0.50632614E-11_JPRB, 0.50454719E-11_JPRB, &
  & 0.50505698E-11_JPRB, 0.50714411E-11_JPRB, 0.51785000E-11_JPRB, 0.52970180E-11_JPRB /)

RGHG4(:,62, 8) = (/ &
  & 0.34886722E-11_JPRB, 0.37732608E-11_JPRB, 0.40481546E-11_JPRB, 0.29674245E-11_JPRB, 0.30836009E-11_JPRB, 0.32024273E-11_JPRB, &
  & 0.33090084E-11_JPRB, 0.33871478E-11_JPRB, 0.28675127E-11_JPRB, 0.28921945E-11_JPRB, 0.29275291E-11_JPRB, 0.30042451E-11_JPRB, &
  & 0.31183767E-11_JPRB, 0.32860385E-11_JPRB, 0.35190546E-11_JPRB, 0.37974298E-11_JPRB, 0.41018430E-11_JPRB, 0.44572662E-11_JPRB, &
  & 0.48364008E-11_JPRB, 0.53075083E-11_JPRB, 0.58635011E-11_JPRB, 0.64399137E-11_JPRB, 0.69445552E-11_JPRB, 0.72087267E-11_JPRB, &
  & 0.71466015E-11_JPRB, 0.68291124E-11_JPRB, 0.63544257E-11_JPRB, 0.58171068E-11_JPRB, 0.52856647E-11_JPRB, 0.48141543E-11_JPRB, &
  & 0.44336119E-11_JPRB, 0.41801571E-11_JPRB, 0.40448695E-11_JPRB, 0.40079645E-11_JPRB, 0.40253070E-11_JPRB, 0.40660977E-11_JPRB, &
  & 0.41296029E-11_JPRB, 0.42103079E-11_JPRB, 0.43214165E-11_JPRB, 0.44790087E-11_JPRB, 0.46790948E-11_JPRB, 0.48952591E-11_JPRB, &
  & 0.50755056E-11_JPRB, 0.52430998E-11_JPRB, 0.53596290E-11_JPRB, 0.54712593E-11_JPRB, 0.55275372E-11_JPRB, 0.55752833E-11_JPRB, &
  & 0.55889924E-11_JPRB, 0.55823458E-11_JPRB, 0.55909570E-11_JPRB, 0.56191627E-11_JPRB, 0.56057333E-11_JPRB, 0.56046374E-11_JPRB, &
  & 0.55907930E-11_JPRB, 0.56322841E-11_JPRB, 0.59196307E-11_JPRB, 0.59365425E-11_JPRB, 0.58980290E-11_JPRB, 0.58527267E-11_JPRB, &
  & 0.58374694E-11_JPRB, 0.58430994E-11_JPRB, 0.59336477E-11_JPRB, 0.59712079E-11_JPRB /)

RGHG4(:,63, 8) = (/ &
  & 0.35150036E-11_JPRB, 0.38172846E-11_JPRB, 0.40976320E-11_JPRB, 0.30581822E-11_JPRB, 0.31923492E-11_JPRB, 0.33357856E-11_JPRB, &
  & 0.34793301E-11_JPRB, 0.35991756E-11_JPRB, 0.31566989E-11_JPRB, 0.32096944E-11_JPRB, 0.32749511E-11_JPRB, 0.33829768E-11_JPRB, &
  & 0.35426104E-11_JPRB, 0.37584454E-11_JPRB, 0.40229560E-11_JPRB, 0.43343228E-11_JPRB, 0.46297493E-11_JPRB, 0.49815087E-11_JPRB, &
  & 0.53325547E-11_JPRB, 0.57760459E-11_JPRB, 0.62739241E-11_JPRB, 0.67959783E-11_JPRB, 0.72444242E-11_JPRB, 0.74857108E-11_JPRB, &
  & 0.74321981E-11_JPRB, 0.71308228E-11_JPRB, 0.66735528E-11_JPRB, 0.61531171E-11_JPRB, 0.56480380E-11_JPRB, 0.52146503E-11_JPRB, &
  & 0.48854965E-11_JPRB, 0.46781932E-11_JPRB, 0.45873431E-11_JPRB, 0.45804515E-11_JPRB, 0.46138861E-11_JPRB, 0.46605905E-11_JPRB, &
  & 0.47194011E-11_JPRB, 0.47873914E-11_JPRB, 0.48800573E-11_JPRB, 0.50217452E-11_JPRB, 0.52115161E-11_JPRB, 0.54173454E-11_JPRB, &
  & 0.55978412E-11_JPRB, 0.57682184E-11_JPRB, 0.58973854E-11_JPRB, 0.60289642E-11_JPRB, 0.61114534E-11_JPRB, 0.62021456E-11_JPRB, &
  & 0.62603755E-11_JPRB, 0.63000321E-11_JPRB, 0.63421061E-11_JPRB, 0.64099954E-11_JPRB, 0.64374790E-11_JPRB, 0.64853873E-11_JPRB, &
  & 0.64998415E-11_JPRB, 0.65919171E-11_JPRB, 0.69306661E-11_JPRB, 0.69706883E-11_JPRB, 0.69304983E-11_JPRB, 0.68661149E-11_JPRB, &
  & 0.68189066E-11_JPRB, 0.68181225E-11_JPRB, 0.68978950E-11_JPRB, 0.68331217E-11_JPRB /)

RGHG4(:,64, 8) = (/ &
  & 0.35519784E-11_JPRB, 0.38839448E-11_JPRB, 0.41874269E-11_JPRB, 0.32018648E-11_JPRB, 0.33636399E-11_JPRB, 0.35505036E-11_JPRB, &
  & 0.37520876E-11_JPRB, 0.39325288E-11_JPRB, 0.35693870E-11_JPRB, 0.36633196E-11_JPRB, 0.37710824E-11_JPRB, 0.39291231E-11_JPRB, &
  & 0.41326955E-11_JPRB, 0.43788554E-11_JPRB, 0.46657092E-11_JPRB, 0.49658437E-11_JPRB, 0.52506255E-11_JPRB, 0.55703623E-11_JPRB, &
  & 0.58976244E-11_JPRB, 0.62944918E-11_JPRB, 0.67398569E-11_JPRB, 0.71907129E-11_JPRB, 0.75801570E-11_JPRB, 0.77870852E-11_JPRB, &
  & 0.77337659E-11_JPRB, 0.74495765E-11_JPRB, 0.70174209E-11_JPRB, 0.65284271E-11_JPRB, 0.60644007E-11_JPRB, 0.56863373E-11_JPRB, &
  & 0.54180059E-11_JPRB, 0.52806167E-11_JPRB, 0.52466946E-11_JPRB, 0.52782349E-11_JPRB, 0.53319172E-11_JPRB, 0.53862700E-11_JPRB, &
  & 0.54423380E-11_JPRB, 0.54958598E-11_JPRB, 0.55669744E-11_JPRB, 0.56813412E-11_JPRB, 0.58468508E-11_JPRB, 0.60465860E-11_JPRB, &
  & 0.62335640E-11_JPRB, 0.64086995E-11_JPRB, 0.65513372E-11_JPRB, 0.66990957E-11_JPRB, 0.68063372E-11_JPRB, 0.69345866E-11_JPRB, &
  & 0.70269983E-11_JPRB, 0.71095465E-11_JPRB, 0.71898828E-11_JPRB, 0.73096112E-11_JPRB, 0.73901571E-11_JPRB, 0.74909376E-11_JPRB, &
  & 0.75425837E-11_JPRB, 0.77051213E-11_JPRB, 0.81252808E-11_JPRB, 0.81991809E-11_JPRB, 0.81564686E-11_JPRB, 0.80673471E-11_JPRB, &
  & 0.80120528E-11_JPRB, 0.80121769E-11_JPRB, 0.80816248E-11_JPRB, 0.78717154E-11_JPRB /)

RGHG4(:,65, 8) = (/ &
  & 0.36020247E-11_JPRB, 0.39738391E-11_JPRB, 0.43178438E-11_JPRB, 0.33862472E-11_JPRB, 0.35956284E-11_JPRB, 0.38424333E-11_JPRB, &
  & 0.41145165E-11_JPRB, 0.43896007E-11_JPRB, 0.41134149E-11_JPRB, 0.42657601E-11_JPRB, 0.44246915E-11_JPRB, 0.46268094E-11_JPRB, &
  & 0.48738101E-11_JPRB, 0.51384444E-11_JPRB, 0.54077081E-11_JPRB, 0.56926816E-11_JPRB, 0.59450994E-11_JPRB, 0.62328545E-11_JPRB, &
  & 0.65211820E-11_JPRB, 0.68736761E-11_JPRB, 0.72515089E-11_JPRB, 0.76363794E-11_JPRB, 0.79593658E-11_JPRB, 0.81292846E-11_JPRB, &
  & 0.80716102E-11_JPRB, 0.78084752E-11_JPRB, 0.74121473E-11_JPRB, 0.69672198E-11_JPRB, 0.65627152E-11_JPRB, 0.62557459E-11_JPRB, &
  & 0.60731802E-11_JPRB, 0.60137065E-11_JPRB, 0.60455386E-11_JPRB, 0.61197332E-11_JPRB, 0.61975750E-11_JPRB, 0.62632555E-11_JPRB, &
  & 0.63194016E-11_JPRB, 0.63618754E-11_JPRB, 0.64142107E-11_JPRB, 0.65094922E-11_JPRB, 0.66590383E-11_JPRB, 0.68457735E-11_JPRB, &
  & 0.70200217E-11_JPRB, 0.71980109E-11_JPRB, 0.73519220E-11_JPRB, 0.75113553E-11_JPRB, 0.76480836E-11_JPRB, 0.78177777E-11_JPRB, &
  & 0.79521259E-11_JPRB, 0.80863875E-11_JPRB, 0.82085588E-11_JPRB, 0.83768270E-11_JPRB, 0.84973721E-11_JPRB, 0.86482644E-11_JPRB, &
  & 0.87470396E-11_JPRB, 0.89742103E-11_JPRB, 0.94711227E-11_JPRB, 0.95960974E-11_JPRB, 0.95612268E-11_JPRB, 0.94654675E-11_JPRB, &
  & 0.93954644E-11_JPRB, 0.93963526E-11_JPRB, 0.94522211E-11_JPRB, 0.91006499E-11_JPRB /)

RGHG4(:,66, 8) = (/ &
  & 0.36573791E-11_JPRB, 0.40690489E-11_JPRB, 0.44801237E-11_JPRB, 0.36223166E-11_JPRB, 0.38960454E-11_JPRB, 0.42214374E-11_JPRB, &
  & 0.45996843E-11_JPRB, 0.49741647E-11_JPRB, 0.48146660E-11_JPRB, 0.50204047E-11_JPRB, 0.52376354E-11_JPRB, 0.54671124E-11_JPRB, &
  & 0.57223176E-11_JPRB, 0.59733355E-11_JPRB, 0.62223950E-11_JPRB, 0.64771062E-11_JPRB, 0.67009263E-11_JPRB, 0.69586138E-11_JPRB, &
  & 0.72087041E-11_JPRB, 0.75092797E-11_JPRB, 0.78288487E-11_JPRB, 0.81449491E-11_JPRB, 0.84038644E-11_JPRB, 0.85347146E-11_JPRB, &
  & 0.84729593E-11_JPRB, 0.82371644E-11_JPRB, 0.78889499E-11_JPRB, 0.75084886E-11_JPRB, 0.71772106E-11_JPRB, 0.69556726E-11_JPRB, &
  & 0.68613062E-11_JPRB, 0.68933808E-11_JPRB, 0.69959511E-11_JPRB, 0.71161909E-11_JPRB, 0.72210966E-11_JPRB, 0.73022326E-11_JPRB, &
  & 0.73652751E-11_JPRB, 0.74009930E-11_JPRB, 0.74371021E-11_JPRB, 0.75074278E-11_JPRB, 0.76317997E-11_JPRB, 0.78079505E-11_JPRB, &
  & 0.79900322E-11_JPRB, 0.81728018E-11_JPRB, 0.83343671E-11_JPRB, 0.85052503E-11_JPRB, 0.86737466E-11_JPRB, 0.88701841E-11_JPRB, &
  & 0.90361633E-11_JPRB, 0.92095775E-11_JPRB, 0.93680836E-11_JPRB, 0.95885582E-11_JPRB, 0.97657412E-11_JPRB, 0.99841281E-11_JPRB, &
  & 0.10130774E-10_JPRB, 0.10426897E-10_JPRB, 0.11003786E-10_JPRB, 0.11183577E-10_JPRB, 0.11165044E-10_JPRB, 0.11058443E-10_JPRB, &
  & 0.10982207E-10_JPRB, 0.10990259E-10_JPRB, 0.11037384E-10_JPRB, 0.10551368E-10_JPRB /)

RGHG4(:,67, 8) = (/ &
  & 0.36802575E-11_JPRB, 0.41638329E-11_JPRB, 0.46715275E-11_JPRB, 0.39102163E-11_JPRB, 0.42786425E-11_JPRB, 0.47051555E-11_JPRB, &
  & 0.51985452E-11_JPRB, 0.57263816E-11_JPRB, 0.56544699E-11_JPRB, 0.59329937E-11_JPRB, 0.61658877E-11_JPRB, 0.64046767E-11_JPRB, &
  & 0.66473758E-11_JPRB, 0.68789215E-11_JPRB, 0.71100036E-11_JPRB, 0.73435988E-11_JPRB, 0.75371176E-11_JPRB, 0.77587685E-11_JPRB, &
  & 0.79696597E-11_JPRB, 0.82240629E-11_JPRB, 0.84824925E-11_JPRB, 0.87385489E-11_JPRB, 0.89411334E-11_JPRB, 0.90371191E-11_JPRB, &
  & 0.89767759E-11_JPRB, 0.87769167E-11_JPRB, 0.84887054E-11_JPRB, 0.81854298E-11_JPRB, 0.79407253E-11_JPRB, 0.78132978E-11_JPRB, &
  & 0.78250956E-11_JPRB, 0.79431852E-11_JPRB, 0.81186047E-11_JPRB, 0.82863317E-11_JPRB, 0.84201734E-11_JPRB, 0.85234033E-11_JPRB, &
  & 0.86002811E-11_JPRB, 0.86401077E-11_JPRB, 0.86726763E-11_JPRB, 0.87383009E-11_JPRB, 0.88557972E-11_JPRB, 0.90233047E-11_JPRB, &
  & 0.91917767E-11_JPRB, 0.93736251E-11_JPRB, 0.95420035E-11_JPRB, 0.97257246E-11_JPRB, 0.99210995E-11_JPRB, 0.10142621E-10_JPRB, &
  & 0.10358273E-10_JPRB, 0.10578444E-10_JPRB, 0.10786295E-10_JPRB, 0.11061422E-10_JPRB, 0.11284454E-10_JPRB, 0.11551020E-10_JPRB, &
  & 0.11741060E-10_JPRB, 0.12099152E-10_JPRB, 0.12753155E-10_JPRB, 0.12982937E-10_JPRB, 0.12993429E-10_JPRB, 0.12885329E-10_JPRB, &
  & 0.12813036E-10_JPRB, 0.12822995E-10_JPRB, 0.12854363E-10_JPRB, 0.12246183E-10_JPRB /)

RGHG4(:,68, 8) = (/ &
  & 0.36698526E-11_JPRB, 0.42372464E-11_JPRB, 0.48961898E-11_JPRB, 0.42718533E-11_JPRB, 0.47652078E-11_JPRB, 0.53213861E-11_JPRB, &
  & 0.59497025E-11_JPRB, 0.66146828E-11_JPRB, 0.66459355E-11_JPRB, 0.69380565E-11_JPRB, 0.71889200E-11_JPRB, 0.74086501E-11_JPRB, &
  & 0.76352076E-11_JPRB, 0.78488709E-11_JPRB, 0.80560289E-11_JPRB, 0.82647205E-11_JPRB, 0.84478093E-11_JPRB, 0.86368655E-11_JPRB, &
  & 0.88231063E-11_JPRB, 0.90298082E-11_JPRB, 0.92402336E-11_JPRB, 0.94447254E-11_JPRB, 0.96004767E-11_JPRB, 0.96711250E-11_JPRB, &
  & 0.96203514E-11_JPRB, 0.94651240E-11_JPRB, 0.92467761E-11_JPRB, 0.90324397E-11_JPRB, 0.88848729E-11_JPRB, 0.88595051E-11_JPRB, &
  & 0.89678985E-11_JPRB, 0.91837779E-11_JPRB, 0.94340733E-11_JPRB, 0.96561517E-11_JPRB, 0.98295634E-11_JPRB, 0.99607284E-11_JPRB, &
  & 0.10058441E-10_JPRB, 0.10105225E-10_JPRB, 0.10134824E-10_JPRB, 0.10187403E-10_JPRB, 0.10292726E-10_JPRB, 0.10462124E-10_JPRB, &
  & 0.10646566E-10_JPRB, 0.10841679E-10_JPRB, 0.11018811E-10_JPRB, 0.11217309E-10_JPRB, 0.11436575E-10_JPRB, 0.11684806E-10_JPRB, &
  & 0.11941027E-10_JPRB, 0.12187861E-10_JPRB, 0.12436697E-10_JPRB, 0.12758585E-10_JPRB, 0.13039164E-10_JPRB, 0.13372333E-10_JPRB, &
  & 0.13616674E-10_JPRB, 0.14031687E-10_JPRB, 0.14772706E-10_JPRB, 0.15052638E-10_JPRB, 0.15095487E-10_JPRB, 0.14986248E-10_JPRB, &
  & 0.14918650E-10_JPRB, 0.14938632E-10_JPRB, 0.14950322E-10_JPRB, 0.14227754E-10_JPRB /)

RGHG4(:,69, 8) = (/ &
  & 0.36160604E-11_JPRB, 0.42899182E-11_JPRB, 0.51627687E-11_JPRB, 0.47402338E-11_JPRB, 0.53975262E-11_JPRB, 0.60916641E-11_JPRB, &
  & 0.68740721E-11_JPRB, 0.76503378E-11_JPRB, 0.77407698E-11_JPRB, 0.80607960E-11_JPRB, 0.82668733E-11_JPRB, 0.84805730E-11_JPRB, &
  & 0.86844455E-11_JPRB, 0.88930001E-11_JPRB, 0.91064899E-11_JPRB, 0.92905987E-11_JPRB, 0.94590447E-11_JPRB, 0.96214746E-11_JPRB, &
  & 0.97887228E-11_JPRB, 0.99568392E-11_JPRB, 0.10129781E-10_JPRB, 0.10294749E-10_JPRB, 0.10419366E-10_JPRB, 0.10476221E-10_JPRB, &
  & 0.10444326E-10_JPRB, 0.10341997E-10_JPRB, 0.10202976E-10_JPRB, 0.10084498E-10_JPRB, 0.10042095E-10_JPRB, 0.10121600E-10_JPRB, &
  & 0.10341649E-10_JPRB, 0.10651897E-10_JPRB, 0.10982162E-10_JPRB, 0.11261192E-10_JPRB, 0.11476430E-10_JPRB, 0.11644281E-10_JPRB, &
  & 0.11771082E-10_JPRB, 0.11839423E-10_JPRB, 0.11884434E-10_JPRB, 0.11950626E-10_JPRB, 0.12066824E-10_JPRB, 0.12242124E-10_JPRB, &
  & 0.12425281E-10_JPRB, 0.12625381E-10_JPRB, 0.12815323E-10_JPRB, 0.13032565E-10_JPRB, 0.13279688E-10_JPRB, 0.13560771E-10_JPRB, &
  & 0.13863240E-10_JPRB, 0.14155988E-10_JPRB, 0.14475691E-10_JPRB, 0.14853717E-10_JPRB, 0.15194141E-10_JPRB, 0.15563753E-10_JPRB, &
  & 0.15840631E-10_JPRB, 0.16305629E-10_JPRB, 0.17129595E-10_JPRB, 0.17461959E-10_JPRB, 0.17542082E-10_JPRB, 0.17447351E-10_JPRB, &
  & 0.17390756E-10_JPRB, 0.17434028E-10_JPRB, 0.17440804E-10_JPRB, 0.16645669E-10_JPRB /)

RGHG4(:,70, 8) = (/ &
  & 0.35226978E-11_JPRB, 0.43343176E-11_JPRB, 0.55139868E-11_JPRB, 0.53639627E-11_JPRB, 0.62129199E-11_JPRB, 0.70546772E-11_JPRB, &
  & 0.79422224E-11_JPRB, 0.88328381E-11_JPRB, 0.89523363E-11_JPRB, 0.92152831E-11_JPRB, 0.94455659E-11_JPRB, 0.96323730E-11_JPRB, &
  & 0.98274071E-11_JPRB, 0.10014245E-10_JPRB, 0.10211238E-10_JPRB, 0.10413813E-10_JPRB, 0.10577711E-10_JPRB, 0.10730633E-10_JPRB, &
  & 0.10894677E-10_JPRB, 0.11035591E-10_JPRB, 0.11185138E-10_JPRB, 0.11323610E-10_JPRB, 0.11430033E-10_JPRB, 0.11488139E-10_JPRB, &
  & 0.11485880E-10_JPRB, 0.11443638E-10_JPRB, 0.11392043E-10_JPRB, 0.11377481E-10_JPRB, 0.11444678E-10_JPRB, 0.11637634E-10_JPRB, &
  & 0.11956588E-10_JPRB, 0.12369440E-10_JPRB, 0.12779662E-10_JPRB, 0.13120183E-10_JPRB, 0.13387479E-10_JPRB, 0.13600495E-10_JPRB, &
  & 0.13766955E-10_JPRB, 0.13857851E-10_JPRB, 0.13915232E-10_JPRB, 0.13986187E-10_JPRB, 0.14111733E-10_JPRB, 0.14315742E-10_JPRB, &
  & 0.14536382E-10_JPRB, 0.14772799E-10_JPRB, 0.14986819E-10_JPRB, 0.15231490E-10_JPRB, 0.15515835E-10_JPRB, 0.15835937E-10_JPRB, &
  & 0.16187964E-10_JPRB, 0.16523304E-10_JPRB, 0.16888562E-10_JPRB, 0.17305237E-10_JPRB, 0.17705674E-10_JPRB, 0.18136152E-10_JPRB, &
  & 0.18480573E-10_JPRB, 0.18998593E-10_JPRB, 0.19903480E-10_JPRB, 0.20296861E-10_JPRB, 0.20418455E-10_JPRB, 0.20355750E-10_JPRB, &
  & 0.20316485E-10_JPRB, 0.20401418E-10_JPRB, 0.20433821E-10_JPRB, 0.19587106E-10_JPRB /)

RGHG4(:,71, 8) = (/ &
  & 0.34748504E-11_JPRB, 0.44388048E-11_JPRB, 0.60227231E-11_JPRB, 0.62080683E-11_JPRB, 0.72355676E-11_JPRB, 0.82012704E-11_JPRB, &
  & 0.91942695E-11_JPRB, 0.10115936E-10_JPRB, 0.10218700E-10_JPRB, 0.10479920E-10_JPRB, 0.10685065E-10_JPRB, 0.10872512E-10_JPRB, &
  & 0.11051887E-10_JPRB, 0.11303724E-10_JPRB, 0.11458371E-10_JPRB, 0.11672912E-10_JPRB, 0.11852036E-10_JPRB, 0.12000440E-10_JPRB, &
  & 0.12163551E-10_JPRB, 0.12298363E-10_JPRB, 0.12437545E-10_JPRB, 0.12565607E-10_JPRB, 0.12670282E-10_JPRB, 0.12745255E-10_JPRB, &
  & 0.12786282E-10_JPRB, 0.12814401E-10_JPRB, 0.12858949E-10_JPRB, 0.12953413E-10_JPRB, 0.13135405E-10_JPRB, 0.13440810E-10_JPRB, &
  & 0.13883786E-10_JPRB, 0.14395349E-10_JPRB, 0.14899615E-10_JPRB, 0.15308898E-10_JPRB, 0.15630022E-10_JPRB, 0.15899670E-10_JPRB, &
  & 0.16118065E-10_JPRB, 0.16255337E-10_JPRB, 0.16354499E-10_JPRB, 0.16462469E-10_JPRB, 0.16620740E-10_JPRB, 0.16846968E-10_JPRB, &
  & 0.17091478E-10_JPRB, 0.17347358E-10_JPRB, 0.17594251E-10_JPRB, 0.17880850E-10_JPRB, 0.18211913E-10_JPRB, 0.18585633E-10_JPRB, &
  & 0.18993767E-10_JPRB, 0.19388588E-10_JPRB, 0.19825740E-10_JPRB, 0.20312996E-10_JPRB, 0.20790999E-10_JPRB, 0.21263746E-10_JPRB, &
  & 0.21642247E-10_JPRB, 0.22191977E-10_JPRB, 0.23173140E-10_JPRB, 0.23625234E-10_JPRB, 0.23801608E-10_JPRB, 0.23791259E-10_JPRB, &
  & 0.23785607E-10_JPRB, 0.23926220E-10_JPRB, 0.24055776E-10_JPRB, 0.23329332E-10_JPRB /)

RGHG4(:,72, 8) = (/ &
  & 0.35845524E-11_JPRB, 0.47944418E-11_JPRB, 0.68066087E-11_JPRB, 0.73153913E-11_JPRB, 0.84942964E-11_JPRB, 0.95334825E-11_JPRB, &
  & 0.10585455E-10_JPRB, 0.11531357E-10_JPRB, 0.11565309E-10_JPRB, 0.11873136E-10_JPRB, 0.12039322E-10_JPRB, 0.12289645E-10_JPRB, &
  & 0.12372441E-10_JPRB, 0.12671350E-10_JPRB, 0.12865946E-10_JPRB, 0.13072014E-10_JPRB, 0.13278499E-10_JPRB, 0.13467285E-10_JPRB, &
  & 0.13632932E-10_JPRB, 0.13781209E-10_JPRB, 0.13921464E-10_JPRB, 0.14056340E-10_JPRB, 0.14175092E-10_JPRB, 0.14284213E-10_JPRB, &
  & 0.14385172E-10_JPRB, 0.14495568E-10_JPRB, 0.14644293E-10_JPRB, 0.14854467E-10_JPRB, 0.15158107E-10_JPRB, 0.15589445E-10_JPRB, &
  & 0.16138474E-10_JPRB, 0.16758527E-10_JPRB, 0.17340322E-10_JPRB, 0.17832600E-10_JPRB, 0.18230521E-10_JPRB, 0.18569308E-10_JPRB, &
  & 0.18850229E-10_JPRB, 0.19030283E-10_JPRB, 0.19159020E-10_JPRB, 0.19289903E-10_JPRB, 0.19483620E-10_JPRB, 0.19774744E-10_JPRB, &
  & 0.20079544E-10_JPRB, 0.20402419E-10_JPRB, 0.20703451E-10_JPRB, 0.21044418E-10_JPRB, 0.21440509E-10_JPRB, 0.21878244E-10_JPRB, &
  & 0.22355555E-10_JPRB, 0.22806283E-10_JPRB, 0.23291756E-10_JPRB, 0.23828883E-10_JPRB, 0.24365064E-10_JPRB, 0.24888870E-10_JPRB, &
  & 0.25351700E-10_JPRB, 0.25950799E-10_JPRB, 0.26987921E-10_JPRB, 0.27507109E-10_JPRB, 0.27743523E-10_JPRB, 0.27798434E-10_JPRB, &
  & 0.27833860E-10_JPRB, 0.28023266E-10_JPRB, 0.28252520E-10_JPRB, 0.27669100E-10_JPRB /)

RGHG4(:,73, 8) = (/ &
  & 0.40456054E-11_JPRB, 0.56143250E-11_JPRB, 0.80968834E-11_JPRB, 0.86757190E-11_JPRB, 0.99585028E-11_JPRB, 0.11031651E-10_JPRB, &
  & 0.12149940E-10_JPRB, 0.12966267E-10_JPRB, 0.13067312E-10_JPRB, 0.13313075E-10_JPRB, 0.13496763E-10_JPRB, 0.13808192E-10_JPRB, &
  & 0.13944342E-10_JPRB, 0.14187230E-10_JPRB, 0.14448986E-10_JPRB, 0.14682880E-10_JPRB, 0.14886273E-10_JPRB, 0.15120957E-10_JPRB, &
  & 0.15297021E-10_JPRB, 0.15481894E-10_JPRB, 0.15640685E-10_JPRB, 0.15801463E-10_JPRB, 0.15953671E-10_JPRB, 0.16118740E-10_JPRB, &
  & 0.16300666E-10_JPRB, 0.16513834E-10_JPRB, 0.16778553E-10_JPRB, 0.17113524E-10_JPRB, 0.17553603E-10_JPRB, 0.18122205E-10_JPRB, &
  & 0.18779847E-10_JPRB, 0.19526941E-10_JPRB, 0.20229160E-10_JPRB, 0.20815450E-10_JPRB, 0.21289756E-10_JPRB, 0.21713638E-10_JPRB, &
  & 0.22079182E-10_JPRB, 0.22340071E-10_JPRB, 0.22542806E-10_JPRB, 0.22733194E-10_JPRB, 0.22974936E-10_JPRB, 0.23297036E-10_JPRB, &
  & 0.23640924E-10_JPRB, 0.24005038E-10_JPRB, 0.24365208E-10_JPRB, 0.24778303E-10_JPRB, 0.25250241E-10_JPRB, 0.25762181E-10_JPRB, &
  & 0.26306015E-10_JPRB, 0.26822385E-10_JPRB, 0.27382095E-10_JPRB, 0.28006757E-10_JPRB, 0.28616000E-10_JPRB, 0.29195996E-10_JPRB, &
  & 0.29689175E-10_JPRB, 0.30304471E-10_JPRB, 0.31362829E-10_JPRB, 0.31926878E-10_JPRB, 0.32225594E-10_JPRB, 0.32343125E-10_JPRB, &
  & 0.32432012E-10_JPRB, 0.32648672E-10_JPRB, 0.32966001E-10_JPRB, 0.32468299E-10_JPRB /)

RGHG4(:,74, 8) = (/ &
  & 0.51015221E-11_JPRB, 0.71343166E-11_JPRB, 0.99304566E-11_JPRB, 0.10282433E-10_JPRB, 0.11617611E-10_JPRB, 0.12685122E-10_JPRB, &
  & 0.13771800E-10_JPRB, 0.14595158E-10_JPRB, 0.14596895E-10_JPRB, 0.14978319E-10_JPRB, 0.15069116E-10_JPRB, 0.15410945E-10_JPRB, &
  & 0.15618649E-10_JPRB, 0.15864952E-10_JPRB, 0.16159747E-10_JPRB, 0.16455164E-10_JPRB, 0.16714735E-10_JPRB, 0.16973044E-10_JPRB, &
  & 0.17212795E-10_JPRB, 0.17430571E-10_JPRB, 0.17632791E-10_JPRB, 0.17838939E-10_JPRB, 0.18045843E-10_JPRB, 0.18288385E-10_JPRB, &
  & 0.18574548E-10_JPRB, 0.18908953E-10_JPRB, 0.19302945E-10_JPRB, 0.19779114E-10_JPRB, 0.20382213E-10_JPRB, 0.21070118E-10_JPRB, &
  & 0.21862403E-10_JPRB, 0.22703320E-10_JPRB, 0.23484709E-10_JPRB, 0.24173779E-10_JPRB, 0.24765745E-10_JPRB, 0.25296109E-10_JPRB, &
  & 0.25757858E-10_JPRB, 0.26083974E-10_JPRB, 0.26339483E-10_JPRB, 0.26581744E-10_JPRB, 0.26894018E-10_JPRB, 0.27311702E-10_JPRB, &
  & 0.27747461E-10_JPRB, 0.28205448E-10_JPRB, 0.28654249E-10_JPRB, 0.29153187E-10_JPRB, 0.29710491E-10_JPRB, 0.30316336E-10_JPRB, &
  & 0.30935910E-10_JPRB, 0.31517906E-10_JPRB, 0.32127617E-10_JPRB, 0.32787002E-10_JPRB, 0.33450680E-10_JPRB, 0.34063804E-10_JPRB, &
  & 0.34634559E-10_JPRB, 0.35280910E-10_JPRB, 0.36341447E-10_JPRB, 0.36935673E-10_JPRB, 0.37275290E-10_JPRB, 0.37447243E-10_JPRB, &
  & 0.37584914E-10_JPRB, 0.37820354E-10_JPRB, 0.38188289E-10_JPRB, 0.37646539E-10_JPRB /)

RGHG4(:,75, 8) = (/ &
  & 0.67738788E-11_JPRB, 0.93245993E-11_JPRB, 0.12333747E-10_JPRB, 0.12056415E-10_JPRB, 0.13381089E-10_JPRB, 0.14425076E-10_JPRB, &
  & 0.15494103E-10_JPRB, 0.16203813E-10_JPRB, 0.16310248E-10_JPRB, 0.16626218E-10_JPRB, 0.16877440E-10_JPRB, 0.17158887E-10_JPRB, &
  & 0.17474999E-10_JPRB, 0.17757162E-10_JPRB, 0.18083353E-10_JPRB, 0.18429149E-10_JPRB, 0.18744324E-10_JPRB, 0.19070035E-10_JPRB, &
  & 0.19366444E-10_JPRB, 0.19644878E-10_JPRB, 0.19913557E-10_JPRB, 0.20193184E-10_JPRB, 0.20486387E-10_JPRB, 0.20833049E-10_JPRB, &
  & 0.21242626E-10_JPRB, 0.21715298E-10_JPRB, 0.22255761E-10_JPRB, 0.22906441E-10_JPRB, 0.23671140E-10_JPRB, 0.24489088E-10_JPRB, &
  & 0.25424319E-10_JPRB, 0.26419736E-10_JPRB, 0.27381628E-10_JPRB, 0.28222704E-10_JPRB, 0.28935339E-10_JPRB, 0.29594830E-10_JPRB, &
  & 0.30184293E-10_JPRB, 0.30632746E-10_JPRB, 0.30991584E-10_JPRB, 0.31312258E-10_JPRB, 0.31670319E-10_JPRB, 0.32119751E-10_JPRB, &
  & 0.32594545E-10_JPRB, 0.33117634E-10_JPRB, 0.33644875E-10_JPRB, 0.34237682E-10_JPRB, 0.34900770E-10_JPRB, 0.35583834E-10_JPRB, &
  & 0.36281762E-10_JPRB, 0.36931128E-10_JPRB, 0.37617756E-10_JPRB, 0.38359132E-10_JPRB, 0.39079281E-10_JPRB, 0.39746095E-10_JPRB, &
  & 0.40310592E-10_JPRB, 0.40941115E-10_JPRB, 0.41962971E-10_JPRB, 0.42557520E-10_JPRB, 0.42922350E-10_JPRB, 0.43139492E-10_JPRB, &
  & 0.43331339E-10_JPRB, 0.43577138E-10_JPRB, 0.43980639E-10_JPRB, 0.43396092E-10_JPRB /)

RGHG4(:,76, 8) = (/ &
  & 0.90845257E-11_JPRB, 0.12176276E-10_JPRB, 0.15094691E-10_JPRB, 0.14046101E-10_JPRB, 0.15227096E-10_JPRB, 0.16210694E-10_JPRB, &
  & 0.17239680E-10_JPRB, 0.17984836E-10_JPRB, 0.17979595E-10_JPRB, 0.18438627E-10_JPRB, 0.18588363E-10_JPRB, 0.19001654E-10_JPRB, &
  & 0.19317561E-10_JPRB, 0.19698868E-10_JPRB, 0.20106163E-10_JPRB, 0.20531587E-10_JPRB, 0.20945391E-10_JPRB, 0.21352498E-10_JPRB, &
  & 0.21747824E-10_JPRB, 0.22110693E-10_JPRB, 0.22475693E-10_JPRB, 0.22860517E-10_JPRB, 0.23271421E-10_JPRB, 0.23752627E-10_JPRB, &
  & 0.24311362E-10_JPRB, 0.24939332E-10_JPRB, 0.25656140E-10_JPRB, 0.26509137E-10_JPRB, 0.27413389E-10_JPRB, 0.28422261E-10_JPRB, &
  & 0.29470631E-10_JPRB, 0.30560245E-10_JPRB, 0.31549069E-10_JPRB, 0.32497584E-10_JPRB, 0.33378116E-10_JPRB, 0.34190276E-10_JPRB, &
  & 0.34919005E-10_JPRB, 0.35480539E-10_JPRB, 0.35952075E-10_JPRB, 0.36394526E-10_JPRB, 0.36893079E-10_JPRB, 0.37482819E-10_JPRB, &
  & 0.38090670E-10_JPRB, 0.38738547E-10_JPRB, 0.39380207E-10_JPRB, 0.40085508E-10_JPRB, 0.40855076E-10_JPRB, 0.41636396E-10_JPRB, &
  & 0.42408421E-10_JPRB, 0.43111986E-10_JPRB, 0.43833489E-10_JPRB, 0.44597319E-10_JPRB, 0.45337158E-10_JPRB, 0.46027258E-10_JPRB, &
  & 0.46627355E-10_JPRB, 0.47262149E-10_JPRB, 0.48240058E-10_JPRB, 0.48811108E-10_JPRB, 0.49174491E-10_JPRB, 0.49427754E-10_JPRB, &
  & 0.49661747E-10_JPRB, 0.49923690E-10_JPRB, 0.50319051E-10_JPRB, 0.49552671E-10_JPRB /)

RGHG4(:,77, 8) = (/ &
  & 0.12085879E-10_JPRB, 0.15593525E-10_JPRB, 0.18396321E-10_JPRB, 0.16088512E-10_JPRB, 0.17123972E-10_JPRB, 0.18009927E-10_JPRB, &
  & 0.18949731E-10_JPRB, 0.19657173E-10_JPRB, 0.19753157E-10_JPRB, 0.20132790E-10_JPRB, 0.20487792E-10_JPRB, 0.20858750E-10_JPRB, &
  & 0.21292608E-10_JPRB, 0.21731920E-10_JPRB, 0.22210076E-10_JPRB, 0.22718169E-10_JPRB, 0.23228719E-10_JPRB, 0.23756106E-10_JPRB, &
  & 0.24265014E-10_JPRB, 0.24760262E-10_JPRB, 0.25259557E-10_JPRB, 0.25794127E-10_JPRB, 0.26358611E-10_JPRB, 0.27012370E-10_JPRB, &
  & 0.27742543E-10_JPRB, 0.28542311E-10_JPRB, 0.29469718E-10_JPRB, 0.30510417E-10_JPRB, 0.31579024E-10_JPRB, 0.32762522E-10_JPRB, &
  & 0.33935785E-10_JPRB, 0.35249862E-10_JPRB, 0.36552407E-10_JPRB, 0.37727002E-10_JPRB, 0.38815468E-10_JPRB, 0.39831673E-10_JPRB, &
  & 0.40727886E-10_JPRB, 0.41431993E-10_JPRB, 0.42006457E-10_JPRB, 0.42516064E-10_JPRB, 0.43047382E-10_JPRB, 0.43660683E-10_JPRB, &
  & 0.44296022E-10_JPRB, 0.45019013E-10_JPRB, 0.45749408E-10_JPRB, 0.46555995E-10_JPRB, 0.47412831E-10_JPRB, 0.48242604E-10_JPRB, &
  & 0.49058646E-10_JPRB, 0.49813789E-10_JPRB, 0.50596118E-10_JPRB, 0.51409196E-10_JPRB, 0.52206479E-10_JPRB, 0.52916518E-10_JPRB, &
  & 0.53508271E-10_JPRB, 0.54108825E-10_JPRB, 0.55025675E-10_JPRB, 0.55561718E-10_JPRB, 0.55916893E-10_JPRB, 0.56196870E-10_JPRB, &
  & 0.56485532E-10_JPRB, 0.56760329E-10_JPRB, 0.57107100E-10_JPRB, 0.56109537E-10_JPRB /)

RGHG4(:,78, 8) = (/ &
  & 0.15738359E-10_JPRB, 0.19515573E-10_JPRB, 0.21822563E-10_JPRB, 0.18170201E-10_JPRB, 0.18942367E-10_JPRB, 0.19660443E-10_JPRB, &
  & 0.20508177E-10_JPRB, 0.21216483E-10_JPRB, 0.21271603E-10_JPRB, 0.21717593E-10_JPRB, 0.22007672E-10_JPRB, 0.22538691E-10_JPRB, &
  & 0.22986385E-10_JPRB, 0.23530332E-10_JPRB, 0.24114708E-10_JPRB, 0.24737691E-10_JPRB, 0.25372794E-10_JPRB, 0.26026655E-10_JPRB, &
  & 0.26692083E-10_JPRB, 0.27348977E-10_JPRB, 0.28023476E-10_JPRB, 0.28747057E-10_JPRB, 0.29509110E-10_JPRB, 0.30369981E-10_JPRB, &
  & 0.31287535E-10_JPRB, 0.32271300E-10_JPRB, 0.33419177E-10_JPRB, 0.34585036E-10_JPRB, 0.35844095E-10_JPRB, 0.37121486E-10_JPRB, &
  & 0.38441219E-10_JPRB, 0.39682899E-10_JPRB, 0.40898347E-10_JPRB, 0.42099400E-10_JPRB, 0.43282655E-10_JPRB, 0.44435247E-10_JPRB, &
  & 0.45519179E-10_JPRB, 0.46462487E-10_JPRB, 0.47314309E-10_JPRB, 0.48099504E-10_JPRB, 0.48889542E-10_JPRB, 0.49700102E-10_JPRB, &
  & 0.50485120E-10_JPRB, 0.51333108E-10_JPRB, 0.52175354E-10_JPRB, 0.53059109E-10_JPRB, 0.53985372E-10_JPRB, 0.54828982E-10_JPRB, &
  & 0.55641717E-10_JPRB, 0.56385514E-10_JPRB, 0.57145243E-10_JPRB, 0.57962916E-10_JPRB, 0.58739159E-10_JPRB, 0.59487915E-10_JPRB, &
  & 0.60111416E-10_JPRB, 0.60744632E-10_JPRB, 0.61620098E-10_JPRB, 0.62138891E-10_JPRB, 0.62498319E-10_JPRB, 0.62821789E-10_JPRB, &
  & 0.63177866E-10_JPRB, 0.63496632E-10_JPRB, 0.63920709E-10_JPRB, 0.62863263E-10_JPRB /)

RGHG4(:,79, 8) = (/ &
  & 0.20023401E-10_JPRB, 0.23216975E-10_JPRB, 0.24678733E-10_JPRB, 0.19614506E-10_JPRB, 0.20195314E-10_JPRB, 0.20724842E-10_JPRB, &
  & 0.21405246E-10_JPRB, 0.22121416E-10_JPRB, 0.22210079E-10_JPRB, 0.22575797E-10_JPRB, 0.23024953E-10_JPRB, 0.23483228E-10_JPRB, &
  & 0.24023044E-10_JPRB, 0.24603918E-10_JPRB, 0.25243085E-10_JPRB, 0.25944476E-10_JPRB, 0.26698300E-10_JPRB, 0.27499005E-10_JPRB, &
  & 0.28308385E-10_JPRB, 0.29146952E-10_JPRB, 0.30003229E-10_JPRB, 0.30911079E-10_JPRB, 0.31867821E-10_JPRB, 0.32882454E-10_JPRB, &
  & 0.33906711E-10_JPRB, 0.34991846E-10_JPRB, 0.36173571E-10_JPRB, 0.37272407E-10_JPRB, 0.38486794E-10_JPRB, 0.39603567E-10_JPRB, &
  & 0.40838187E-10_JPRB, 0.42116241E-10_JPRB, 0.43382697E-10_JPRB, 0.44597919E-10_JPRB, 0.45815945E-10_JPRB, 0.47035899E-10_JPRB, &
  & 0.48220317E-10_JPRB, 0.49311107E-10_JPRB, 0.50331860E-10_JPRB, 0.51299045E-10_JPRB, 0.52244993E-10_JPRB, 0.53180384E-10_JPRB, &
  & 0.54059236E-10_JPRB, 0.54993933E-10_JPRB, 0.55895514E-10_JPRB, 0.56822491E-10_JPRB, 0.57756386E-10_JPRB, 0.58587815E-10_JPRB, &
  & 0.59386537E-10_JPRB, 0.60110916E-10_JPRB, 0.60860074E-10_JPRB, 0.61641296E-10_JPRB, 0.62428902E-10_JPRB, 0.63153392E-10_JPRB, &
  & 0.63801839E-10_JPRB, 0.64486763E-10_JPRB, 0.65424777E-10_JPRB, 0.66023201E-10_JPRB, 0.66482576E-10_JPRB, 0.66915230E-10_JPRB, &
  & 0.67401286E-10_JPRB, 0.67907992E-10_JPRB, 0.68657822E-10_JPRB, 0.68514576E-10_JPRB /)

RGHG4(:,80, 8) = (/ &
  & 0.22869880E-10_JPRB, 0.24775465E-10_JPRB, 0.25589907E-10_JPRB, 0.20176631E-10_JPRB, 0.20660631E-10_JPRB, 0.21133501E-10_JPRB, &
  & 0.21829117E-10_JPRB, 0.22621507E-10_JPRB, 0.22738663E-10_JPRB, 0.23123484E-10_JPRB, 0.23541624E-10_JPRB, 0.24087152E-10_JPRB, &
  & 0.24613669E-10_JPRB, 0.25240145E-10_JPRB, 0.25911270E-10_JPRB, 0.26639720E-10_JPRB, 0.27413585E-10_JPRB, 0.28221784E-10_JPRB, &
  & 0.29065460E-10_JPRB, 0.29942434E-10_JPRB, 0.30849837E-10_JPRB, 0.31819745E-10_JPRB, 0.32847353E-10_JPRB, 0.33899106E-10_JPRB, &
  & 0.34944606E-10_JPRB, 0.36125641E-10_JPRB, 0.37267852E-10_JPRB, 0.38462108E-10_JPRB, 0.39724418E-10_JPRB, 0.40979341E-10_JPRB, &
  & 0.42224790E-10_JPRB, 0.43434003E-10_JPRB, 0.44649364E-10_JPRB, 0.45882294E-10_JPRB, 0.47122872E-10_JPRB, 0.48375540E-10_JPRB, &
  & 0.49612852E-10_JPRB, 0.50773184E-10_JPRB, 0.51883556E-10_JPRB, 0.52933363E-10_JPRB, 0.53962158E-10_JPRB, 0.54956616E-10_JPRB, &
  & 0.55877185E-10_JPRB, 0.56836875E-10_JPRB, 0.57749815E-10_JPRB, 0.58701627E-10_JPRB, 0.59667271E-10_JPRB, 0.60503637E-10_JPRB, &
  & 0.61295538E-10_JPRB, 0.62021277E-10_JPRB, 0.62749216E-10_JPRB, 0.63529251E-10_JPRB, 0.64298435E-10_JPRB, 0.65040855E-10_JPRB, &
  & 0.65695449E-10_JPRB, 0.66332217E-10_JPRB, 0.67170734E-10_JPRB, 0.67676198E-10_JPRB, 0.68082595E-10_JPRB, 0.68481713E-10_JPRB, &
  & 0.68977331E-10_JPRB, 0.69562689E-10_JPRB, 0.70557386E-10_JPRB, 0.71519762E-10_JPRB /)

RGHG4(:,81, 8) = (/ &
  & 0.24784100E-10_JPRB, 0.25503750E-10_JPRB, 0.26167967E-10_JPRB, 0.20537759E-10_JPRB, 0.20979931E-10_JPRB, 0.21431643E-10_JPRB, &
  & 0.22113561E-10_JPRB, 0.22995212E-10_JPRB, 0.23005667E-10_JPRB, 0.23508336E-10_JPRB, 0.23917909E-10_JPRB, 0.24430222E-10_JPRB, &
  & 0.24998080E-10_JPRB, 0.25632291E-10_JPRB, 0.26326474E-10_JPRB, 0.27085926E-10_JPRB, 0.27902644E-10_JPRB, 0.28771934E-10_JPRB, &
  & 0.29650216E-10_JPRB, 0.30562924E-10_JPRB, 0.31507109E-10_JPRB, 0.32512354E-10_JPRB, 0.33582925E-10_JPRB, 0.34625879E-10_JPRB, &
  & 0.35749115E-10_JPRB, 0.36963901E-10_JPRB, 0.38034891E-10_JPRB, 0.39280641E-10_JPRB, 0.40408819E-10_JPRB, 0.41636004E-10_JPRB, &
  & 0.42852159E-10_JPRB, 0.44111215E-10_JPRB, 0.45341432E-10_JPRB, 0.46586159E-10_JPRB, 0.47842084E-10_JPRB, 0.49106798E-10_JPRB, &
  & 0.50363300E-10_JPRB, 0.51569221E-10_JPRB, 0.52719287E-10_JPRB, 0.53818477E-10_JPRB, 0.54878255E-10_JPRB, 0.55896718E-10_JPRB, &
  & 0.56847856E-10_JPRB, 0.57832631E-10_JPRB, 0.58767879E-10_JPRB, 0.59740150E-10_JPRB, 0.60697385E-10_JPRB, 0.61556774E-10_JPRB, &
  & 0.62330800E-10_JPRB, 0.63084399E-10_JPRB, 0.63783610E-10_JPRB, 0.64579737E-10_JPRB, 0.65333995E-10_JPRB, 0.66067429E-10_JPRB, &
  & 0.66715827E-10_JPRB, 0.67394187E-10_JPRB, 0.68280930E-10_JPRB, 0.68814135E-10_JPRB, 0.69242959E-10_JPRB, 0.69656822E-10_JPRB, &
  & 0.70168427E-10_JPRB, 0.70801552E-10_JPRB, 0.71910172E-10_JPRB, 0.73942220E-10_JPRB /)

RGHG4(:,82, 8) = (/ &
  & 0.26138531E-10_JPRB, 0.25800423E-10_JPRB, 0.26363084E-10_JPRB, 0.20662139E-10_JPRB, 0.21098664E-10_JPRB, 0.21544166E-10_JPRB, &
  & 0.22310676E-10_JPRB, 0.23130095E-10_JPRB, 0.23351480E-10_JPRB, 0.23715738E-10_JPRB, 0.24212302E-10_JPRB, 0.24709434E-10_JPRB, &
  & 0.25295106E-10_JPRB, 0.25942665E-10_JPRB, 0.26635258E-10_JPRB, 0.27396635E-10_JPRB, 0.28201741E-10_JPRB, 0.29058807E-10_JPRB, &
  & 0.29939683E-10_JPRB, 0.30864495E-10_JPRB, 0.31821146E-10_JPRB, 0.32851402E-10_JPRB, 0.33924037E-10_JPRB, 0.34948870E-10_JPRB, &
  & 0.36170515E-10_JPRB, 0.37268154E-10_JPRB, 0.38427001E-10_JPRB, 0.39663203E-10_JPRB, 0.40876649E-10_JPRB, 0.42122777E-10_JPRB, &
  & 0.43345477E-10_JPRB, 0.44556130E-10_JPRB, 0.45789091E-10_JPRB, 0.47044275E-10_JPRB, 0.48315577E-10_JPRB, 0.49601483E-10_JPRB, &
  & 0.50885043E-10_JPRB, 0.52105327E-10_JPRB, 0.53280935E-10_JPRB, 0.54396401E-10_JPRB, 0.55475086E-10_JPRB, 0.56511611E-10_JPRB, &
  & 0.57458774E-10_JPRB, 0.58447885E-10_JPRB, 0.59380043E-10_JPRB, 0.60368370E-10_JPRB, 0.61344478E-10_JPRB, 0.62235550E-10_JPRB, &
  & 0.62985658E-10_JPRB, 0.63783014E-10_JPRB, 0.64444138E-10_JPRB, 0.65272315E-10_JPRB, 0.66012806E-10_JPRB, 0.66760708E-10_JPRB, &
  & 0.67432830E-10_JPRB, 0.68022685E-10_JPRB, 0.68804261E-10_JPRB, 0.69247177E-10_JPRB, 0.69640474E-10_JPRB, 0.70026047E-10_JPRB, &
  & 0.70502749E-10_JPRB, 0.71171749E-10_JPRB, 0.72276810E-10_JPRB, 0.74986940E-10_JPRB /)

RGHG4(:,83, 8) = (/ &
  & 0.26243162E-10_JPRB, 0.25906029E-10_JPRB, 0.26464435E-10_JPRB, 0.20750079E-10_JPRB, 0.21244100E-10_JPRB, 0.21685006E-10_JPRB, &
  & 0.22447731E-10_JPRB, 0.23422703E-10_JPRB, 0.23428369E-10_JPRB, 0.24042870E-10_JPRB, 0.24378013E-10_JPRB, 0.24955713E-10_JPRB, &
  & 0.25491487E-10_JPRB, 0.26163205E-10_JPRB, 0.26873696E-10_JPRB, 0.27652679E-10_JPRB, 0.28484552E-10_JPRB, 0.29363668E-10_JPRB, &
  & 0.30258372E-10_JPRB, 0.31181047E-10_JPRB, 0.32138271E-10_JPRB, 0.33176153E-10_JPRB, 0.34208653E-10_JPRB, 0.35302625E-10_JPRB, &
  & 0.36529366E-10_JPRB, 0.37567983E-10_JPRB, 0.38845767E-10_JPRB, 0.39969399E-10_JPRB, 0.41197726E-10_JPRB, 0.42414326E-10_JPRB, &
  & 0.43652276E-10_JPRB, 0.44876668E-10_JPRB, 0.46115750E-10_JPRB, 0.47380745E-10_JPRB, 0.48655462E-10_JPRB, 0.49936826E-10_JPRB, &
  & 0.51229316E-10_JPRB, 0.52482515E-10_JPRB, 0.53680529E-10_JPRB, 0.54811124E-10_JPRB, 0.55900184E-10_JPRB, 0.56931425E-10_JPRB, &
  & 0.57914864E-10_JPRB, 0.58909634E-10_JPRB, 0.59869429E-10_JPRB, 0.60858520E-10_JPRB, 0.61819334E-10_JPRB, 0.62719434E-10_JPRB, &
  & 0.63463443E-10_JPRB, 0.64288720E-10_JPRB, 0.64926231E-10_JPRB, 0.65781262E-10_JPRB, 0.66497190E-10_JPRB, 0.67252114E-10_JPRB, &
  & 0.67892199E-10_JPRB, 0.68564876E-10_JPRB, 0.69396072E-10_JPRB, 0.69853519E-10_JPRB, 0.70233930E-10_JPRB, 0.70645330E-10_JPRB, &
  & 0.71058527E-10_JPRB, 0.71726090E-10_JPRB, 0.72749348E-10_JPRB, 0.74967893E-10_JPRB /)

RGHG4(:,84, 8) = (/ &
  & 0.26311935E-10_JPRB, 0.26030350E-10_JPRB, 0.26475882E-10_JPRB, 0.20796876E-10_JPRB, 0.21328895E-10_JPRB, 0.21729051E-10_JPRB, &
  & 0.22608089E-10_JPRB, 0.23432589E-10_JPRB, 0.23789425E-10_JPRB, 0.24119292E-10_JPRB, 0.24664380E-10_JPRB, 0.25105347E-10_JPRB, &
  & 0.25737225E-10_JPRB, 0.26376639E-10_JPRB, 0.27062567E-10_JPRB, 0.27824455E-10_JPRB, 0.28645726E-10_JPRB, 0.29525656E-10_JPRB, &
  & 0.30418893E-10_JPRB, 0.31360917E-10_JPRB, 0.32316316E-10_JPRB, 0.33351263E-10_JPRB, 0.34377355E-10_JPRB, 0.35540664E-10_JPRB, &
  & 0.36648230E-10_JPRB, 0.37815442E-10_JPRB, 0.39005230E-10_JPRB, 0.40209284E-10_JPRB, 0.41456637E-10_JPRB, 0.42676154E-10_JPRB, &
  & 0.43916766E-10_JPRB, 0.45123665E-10_JPRB, 0.46371278E-10_JPRB, 0.47637710E-10_JPRB, 0.48943363E-10_JPRB, 0.50274299E-10_JPRB, &
  & 0.51582117E-10_JPRB, 0.52826098E-10_JPRB, 0.54019560E-10_JPRB, 0.55160463E-10_JPRB, 0.56248825E-10_JPRB, 0.57295599E-10_JPRB, &
  & 0.58238657E-10_JPRB, 0.59253769E-10_JPRB, 0.60159010E-10_JPRB, 0.61196062E-10_JPRB, 0.62178221E-10_JPRB, 0.63080846E-10_JPRB, &
  & 0.63839468E-10_JPRB, 0.64670165E-10_JPRB, 0.65311229E-10_JPRB, 0.66173463E-10_JPRB, 0.66877490E-10_JPRB, 0.67697063E-10_JPRB, &
  & 0.68296271E-10_JPRB, 0.68951587E-10_JPRB, 0.69626069E-10_JPRB, 0.70077812E-10_JPRB, 0.70357005E-10_JPRB, 0.70837426E-10_JPRB, &
  & 0.71209844E-10_JPRB, 0.71902470E-10_JPRB, 0.72993347E-10_JPRB, 0.75372139E-10_JPRB /)

RGHG4(:,85, 8) = (/ &
  & 0.26385836E-10_JPRB, 0.26130206E-10_JPRB, 0.26446763E-10_JPRB, 0.20866961E-10_JPRB, 0.21404104E-10_JPRB, 0.21820663E-10_JPRB, &
  & 0.22737326E-10_JPRB, 0.23727523E-10_JPRB, 0.23841183E-10_JPRB, 0.24460066E-10_JPRB, 0.24780752E-10_JPRB, 0.25332512E-10_JPRB, &
  & 0.25856275E-10_JPRB, 0.26456708E-10_JPRB, 0.27166911E-10_JPRB, 0.27961567E-10_JPRB, 0.28788760E-10_JPRB, 0.29688665E-10_JPRB, &
  & 0.30600255E-10_JPRB, 0.31526729E-10_JPRB, 0.32483554E-10_JPRB, 0.33514035E-10_JPRB, 0.34556209E-10_JPRB, 0.35693309E-10_JPRB, &
  & 0.36795227E-10_JPRB, 0.37991648E-10_JPRB, 0.39165858E-10_JPRB, 0.40386194E-10_JPRB, 0.41593472E-10_JPRB, 0.42863629E-10_JPRB, &
  & 0.44085891E-10_JPRB, 0.45321705E-10_JPRB, 0.46571868E-10_JPRB, 0.47855279E-10_JPRB, 0.49100949E-10_JPRB, 0.50379763E-10_JPRB, &
  & 0.51731959E-10_JPRB, 0.53040097E-10_JPRB, 0.54273874E-10_JPRB, 0.55422014E-10_JPRB, 0.56517544E-10_JPRB, 0.57556477E-10_JPRB, &
  & 0.58564063E-10_JPRB, 0.59546999E-10_JPRB, 0.60528603E-10_JPRB, 0.61490896E-10_JPRB, 0.62490575E-10_JPRB, 0.63357160E-10_JPRB, &
  & 0.64149276E-10_JPRB, 0.64954986E-10_JPRB, 0.65618719E-10_JPRB, 0.66474645E-10_JPRB, 0.67170672E-10_JPRB, 0.68005761E-10_JPRB, &
  & 0.68533519E-10_JPRB, 0.69329077E-10_JPRB, 0.69981881E-10_JPRB, 0.70541899E-10_JPRB, 0.70733051E-10_JPRB, 0.71248306E-10_JPRB, &
  & 0.71595521E-10_JPRB, 0.72220785E-10_JPRB, 0.73297764E-10_JPRB, 0.75528639E-10_JPRB /)

RGHG4(:,86, 8) = (/ &
  & 0.26430344E-10_JPRB, 0.26187288E-10_JPRB, 0.26402327E-10_JPRB, 0.20928032E-10_JPRB, 0.21464547E-10_JPRB, 0.21883634E-10_JPRB, &
  & 0.22932043E-10_JPRB, 0.23777386E-10_JPRB, 0.24203814E-10_JPRB, 0.24580145E-10_JPRB, 0.25064457E-10_JPRB, 0.25499073E-10_JPRB, &
  & 0.26036081E-10_JPRB, 0.26652911E-10_JPRB, 0.27327049E-10_JPRB, 0.27982333E-10_JPRB, 0.28824656E-10_JPRB, 0.29706560E-10_JPRB, &
  & 0.30639113E-10_JPRB, 0.31587618E-10_JPRB, 0.32585375E-10_JPRB, 0.33600525E-10_JPRB, 0.34654290E-10_JPRB, 0.35749313E-10_JPRB, &
  & 0.36892218E-10_JPRB, 0.38066085E-10_JPRB, 0.39238956E-10_JPRB, 0.40470516E-10_JPRB, 0.41731573E-10_JPRB, 0.42974378E-10_JPRB, &
  & 0.44245409E-10_JPRB, 0.45467199E-10_JPRB, 0.46709293E-10_JPRB, 0.48009964E-10_JPRB, 0.49430238E-10_JPRB, 0.50802224E-10_JPRB, &
  & 0.52061265E-10_JPRB, 0.53285980E-10_JPRB, 0.54506753E-10_JPRB, 0.55650512E-10_JPRB, 0.56761464E-10_JPRB, 0.57818687E-10_JPRB, &
  & 0.58767442E-10_JPRB, 0.59787550E-10_JPRB, 0.60684804E-10_JPRB, 0.61711032E-10_JPRB, 0.62707527E-10_JPRB, 0.63572626E-10_JPRB, &
  & 0.64384172E-10_JPRB, 0.65175219E-10_JPRB, 0.65865417E-10_JPRB, 0.66705710E-10_JPRB, 0.67428438E-10_JPRB, 0.68284114E-10_JPRB, &
  & 0.68829886E-10_JPRB, 0.69574742E-10_JPRB, 0.70128819E-10_JPRB, 0.70654538E-10_JPRB, 0.70840341E-10_JPRB, 0.71316106E-10_JPRB, &
  & 0.71752861E-10_JPRB, 0.72335526E-10_JPRB, 0.73485815E-10_JPRB, 0.75739519E-10_JPRB /)

RGHG4(:,87, 8) = (/ &
  & 0.26714998E-10_JPRB, 0.26251761E-10_JPRB, 0.26380039E-10_JPRB, 0.20976918E-10_JPRB, 0.21482437E-10_JPRB, 0.22002221E-10_JPRB, &
  & 0.23085717E-10_JPRB, 0.24022144E-10_JPRB, 0.24263912E-10_JPRB, 0.24863105E-10_JPRB, 0.25179877E-10_JPRB, 0.25647600E-10_JPRB, &
  & 0.26127416E-10_JPRB, 0.26658632E-10_JPRB, 0.27219432E-10_JPRB, 0.28025957E-10_JPRB, 0.28856879E-10_JPRB, 0.29737195E-10_JPRB, &
  & 0.30682575E-10_JPRB, 0.31656733E-10_JPRB, 0.32652579E-10_JPRB, 0.33671368E-10_JPRB, 0.34726985E-10_JPRB, 0.35820132E-10_JPRB, &
  & 0.36959651E-10_JPRB, 0.38107194E-10_JPRB, 0.39305573E-10_JPRB, 0.40545445E-10_JPRB, 0.41794790E-10_JPRB, 0.43091569E-10_JPRB, &
  & 0.44343001E-10_JPRB, 0.45618127E-10_JPRB, 0.46916093E-10_JPRB, 0.48114134E-10_JPRB, 0.49210139E-10_JPRB, 0.50523336E-10_JPRB, &
  & 0.52018504E-10_JPRB, 0.53404555E-10_JPRB, 0.54646121E-10_JPRB, 0.55829941E-10_JPRB, 0.56950885E-10_JPRB, 0.58010426E-10_JPRB, &
  & 0.59044797E-10_JPRB, 0.60025804E-10_JPRB, 0.60986334E-10_JPRB, 0.61933084E-10_JPRB, 0.62926865E-10_JPRB, 0.63759581E-10_JPRB, &
  & 0.64583103E-10_JPRB, 0.65335286E-10_JPRB, 0.66053413E-10_JPRB, 0.66875110E-10_JPRB, 0.67625426E-10_JPRB, 0.68433634E-10_JPRB, &
  & 0.69013184E-10_JPRB, 0.69748977E-10_JPRB, 0.70430259E-10_JPRB, 0.70891931E-10_JPRB, 0.71176100E-10_JPRB, 0.71534417E-10_JPRB, &
  & 0.72029875E-10_JPRB, 0.72545303E-10_JPRB, 0.73683164E-10_JPRB, 0.75878193E-10_JPRB /)

RGHG4(:,88, 8) = (/ &
  & 0.26612433E-10_JPRB, 0.26233911E-10_JPRB, 0.26374162E-10_JPRB, 0.20968768E-10_JPRB, 0.21496841E-10_JPRB, 0.22061677E-10_JPRB, &
  & 0.23175949E-10_JPRB, 0.23924031E-10_JPRB, 0.24500289E-10_JPRB, 0.24898203E-10_JPRB, 0.25264879E-10_JPRB, 0.25728480E-10_JPRB, &
  & 0.26210561E-10_JPRB, 0.26807856E-10_JPRB, 0.27452235E-10_JPRB, 0.28053431E-10_JPRB, 0.28826568E-10_JPRB, 0.29658841E-10_JPRB, &
  & 0.30680552E-10_JPRB, 0.31664161E-10_JPRB, 0.32688161E-10_JPRB, 0.33712914E-10_JPRB, 0.34769940E-10_JPRB, 0.35852651E-10_JPRB, &
  & 0.36978694E-10_JPRB, 0.38132594E-10_JPRB, 0.39321626E-10_JPRB, 0.40557585E-10_JPRB, 0.41833998E-10_JPRB, 0.43128369E-10_JPRB, &
  & 0.44413466E-10_JPRB, 0.45616382E-10_JPRB, 0.46908689E-10_JPRB, 0.48449522E-10_JPRB, 0.50034140E-10_JPRB, 0.51308850E-10_JPRB, &
  & 0.52392073E-10_JPRB, 0.53586535E-10_JPRB, 0.54826241E-10_JPRB, 0.55996124E-10_JPRB, 0.57119816E-10_JPRB, 0.58210825E-10_JPRB, &
  & 0.59175366E-10_JPRB, 0.60211315E-10_JPRB, 0.61096288E-10_JPRB, 0.62079404E-10_JPRB, 0.63070840E-10_JPRB, 0.63896020E-10_JPRB, &
  & 0.64731533E-10_JPRB, 0.65474529E-10_JPRB, 0.66207699E-10_JPRB, 0.67015164E-10_JPRB, 0.67795859E-10_JPRB, 0.68600937E-10_JPRB, &
  & 0.69235125E-10_JPRB, 0.69888546E-10_JPRB, 0.70573040E-10_JPRB, 0.70933655E-10_JPRB, 0.71270781E-10_JPRB, 0.71587167E-10_JPRB, &
  & 0.72122190E-10_JPRB, 0.72644148E-10_JPRB, 0.73814919E-10_JPRB, 0.76003537E-10_JPRB /)

RGHG4(:,89, 8) = (/ &
  & 0.26492019E-10_JPRB, 0.26314718E-10_JPRB, 0.26390608E-10_JPRB, 0.20902745E-10_JPRB, 0.21471607E-10_JPRB, 0.22008595E-10_JPRB, &
  & 0.22994478E-10_JPRB, 0.23980049E-10_JPRB, 0.24385679E-10_JPRB, 0.24793778E-10_JPRB, 0.25229983E-10_JPRB, 0.25653741E-10_JPRB, &
  & 0.26102441E-10_JPRB, 0.26610835E-10_JPRB, 0.27342224E-10_JPRB, 0.27987975E-10_JPRB, 0.28915460E-10_JPRB, 0.29906144E-10_JPRB, &
  & 0.30863229E-10_JPRB, 0.31758970E-10_JPRB, 0.32719161E-10_JPRB, 0.33730383E-10_JPRB, 0.34771314E-10_JPRB, 0.35843519E-10_JPRB, &
  & 0.36960227E-10_JPRB, 0.38098462E-10_JPRB, 0.39278157E-10_JPRB, 0.40513162E-10_JPRB, 0.41786088E-10_JPRB, 0.43123959E-10_JPRB, &
  & 0.44485284E-10_JPRB, 0.45793310E-10_JPRB, 0.46915350E-10_JPRB, 0.47872466E-10_JPRB, 0.48953359E-10_JPRB, 0.50459872E-10_JPRB, &
  & 0.52218750E-10_JPRB, 0.53641185E-10_JPRB, 0.54906819E-10_JPRB, 0.56111001E-10_JPRB, 0.57267940E-10_JPRB, 0.58362273E-10_JPRB, &
  & 0.59395898E-10_JPRB, 0.60393912E-10_JPRB, 0.61319248E-10_JPRB, 0.62248470E-10_JPRB, 0.63231261E-10_JPRB, 0.64036006E-10_JPRB, &
  & 0.64859687E-10_JPRB, 0.65583317E-10_JPRB, 0.66316369E-10_JPRB, 0.67121982E-10_JPRB, 0.67916138E-10_JPRB, 0.68695015E-10_JPRB, &
  & 0.69345273E-10_JPRB, 0.70009415E-10_JPRB, 0.70748511E-10_JPRB, 0.71115100E-10_JPRB, 0.71460331E-10_JPRB, 0.71761472E-10_JPRB, &
  & 0.72282166E-10_JPRB, 0.72778568E-10_JPRB, 0.73961191E-10_JPRB, 0.76103485E-10_JPRB /)

RGHG4(:,90, 8) = (/ &
  & 0.26519236E-10_JPRB, 0.26302460E-10_JPRB, 0.26384311E-10_JPRB, 0.20719945E-10_JPRB, 0.21363290E-10_JPRB, 0.21854562E-10_JPRB, &
  & 0.22764049E-10_JPRB, 0.23652627E-10_JPRB, 0.24082151E-10_JPRB, 0.24583132E-10_JPRB, 0.25243382E-10_JPRB, 0.25529344E-10_JPRB, &
  & 0.25917735E-10_JPRB, 0.26559824E-10_JPRB, 0.27915958E-10_JPRB, 0.28330746E-10_JPRB, 0.29084643E-10_JPRB, 0.29758172E-10_JPRB, &
  & 0.30500352E-10_JPRB, 0.31487410E-10_JPRB, 0.32584865E-10_JPRB, 0.33667277E-10_JPRB, 0.34713867E-10_JPRB, 0.35772749E-10_JPRB, &
  & 0.36856213E-10_JPRB, 0.37973080E-10_JPRB, 0.39142387E-10_JPRB, 0.40338927E-10_JPRB, 0.41583390E-10_JPRB, 0.42917784E-10_JPRB, &
  & 0.44287466E-10_JPRB, 0.45746504E-10_JPRB, 0.47360581E-10_JPRB, 0.49034145E-10_JPRB, 0.50539548E-10_JPRB, 0.51694222E-10_JPRB, &
  & 0.52589617E-10_JPRB, 0.53811858E-10_JPRB, 0.55090696E-10_JPRB, 0.56276747E-10_JPRB, 0.57418480E-10_JPRB, 0.58499157E-10_JPRB, &
  & 0.59482301E-10_JPRB, 0.60503921E-10_JPRB, 0.61380588E-10_JPRB, 0.62315438E-10_JPRB, 0.63305770E-10_JPRB, 0.64117850E-10_JPRB, &
  & 0.64938922E-10_JPRB, 0.65688809E-10_JPRB, 0.66413521E-10_JPRB, 0.67217010E-10_JPRB, 0.68032878E-10_JPRB, 0.68816813E-10_JPRB, &
  & 0.69475023E-10_JPRB, 0.70126432E-10_JPRB, 0.70836254E-10_JPRB, 0.71182206E-10_JPRB, 0.71518284E-10_JPRB, 0.71812528E-10_JPRB, &
  & 0.72357009E-10_JPRB, 0.72830117E-10_JPRB, 0.74088381E-10_JPRB, 0.76186217E-10_JPRB /)

RGHG4(:,91, 8) = (/ &
  & 0.26193077E-10_JPRB, 0.26472128E-10_JPRB, 0.26269041E-10_JPRB, 0.20394290E-10_JPRB, 0.21184582E-10_JPRB, 0.21610760E-10_JPRB, &
  & 0.68817486E-11_JPRB, 0.16062405E-10_JPRB, 0.22622048E-10_JPRB, 0.28211530E-10_JPRB, 0.34008584E-10_JPRB, 0.32408756E-10_JPRB, &
  & 0.25571191E-10_JPRB, 0.20127624E-10_JPRB, 0.29249402E-10_JPRB, 0.27864351E-10_JPRB, 0.28627925E-10_JPRB, 0.30048151E-10_JPRB, &
  & 0.30970188E-10_JPRB, 0.31945155E-10_JPRB, 0.32785729E-10_JPRB, 0.33624027E-10_JPRB, 0.34540950E-10_JPRB, 0.35549379E-10_JPRB, &
  & 0.36605437E-10_JPRB, 0.37674381E-10_JPRB, 0.38863312E-10_JPRB, 0.40161305E-10_JPRB, 0.41519000E-10_JPRB, 0.42799854E-10_JPRB, &
  & 0.44049341E-10_JPRB, 0.45280283E-10_JPRB, 0.46486714E-10_JPRB, 0.47794765E-10_JPRB, 0.49160124E-10_JPRB, 0.50708493E-10_JPRB, &
  & 0.52456046E-10_JPRB, 0.53857967E-10_JPRB, 0.55157986E-10_JPRB, 0.56397609E-10_JPRB, 0.54776801E-10_JPRB, 0.55969798E-10_JPRB, &
  & 0.59623480E-10_JPRB, 0.60666382E-10_JPRB, 0.61547378E-10_JPRB, 0.62403527E-10_JPRB, 0.63413344E-10_JPRB, 0.64251979E-10_JPRB, &
  & 0.65007874E-10_JPRB, 0.65793593E-10_JPRB, 0.66481411E-10_JPRB, 0.67306966E-10_JPRB, 0.68132146E-10_JPRB, 0.68905867E-10_JPRB, &
  & 0.69554626E-10_JPRB, 0.70234638E-10_JPRB, 0.70949711E-10_JPRB, 0.71304629E-10_JPRB, 0.71635378E-10_JPRB, 0.71911886E-10_JPRB, &
  & 0.72466241E-10_JPRB, 0.72878897E-10_JPRB, 0.74257690E-10_JPRB, 0.76255315E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG4(:, 1, 9) = (/ &
  & 0.12916975E-13_JPRB, 0.15985634E-13_JPRB, 0.20845501E-13_JPRB, 0.29065075E-13_JPRB, 0.40692666E-13_JPRB, 0.51086725E-13_JPRB, &
  & 0.62718839E-13_JPRB, 0.74305972E-13_JPRB, 0.84815469E-13_JPRB, 0.86799451E-13_JPRB, 0.90932307E-13_JPRB, 0.93839385E-13_JPRB, &
  & 0.95838681E-13_JPRB, 0.97261202E-13_JPRB, 0.98541001E-13_JPRB, 0.99869271E-13_JPRB, 0.10122638E-12_JPRB, 0.10257786E-12_JPRB, &
  & 0.10382636E-12_JPRB, 0.10489539E-12_JPRB, 0.10561236E-12_JPRB, 0.10633810E-12_JPRB, 0.10723983E-12_JPRB, 0.10759967E-12_JPRB, &
  & 0.10788495E-12_JPRB, 0.10836883E-12_JPRB, 0.10946017E-12_JPRB, 0.11141970E-12_JPRB, 0.11435683E-12_JPRB, 0.11774501E-12_JPRB, &
  & 0.12126111E-12_JPRB, 0.11766347E-12_JPRB, 0.11959776E-12_JPRB, 0.12067936E-12_JPRB, 0.12078580E-12_JPRB, 0.11974394E-12_JPRB, &
  & 0.11791142E-12_JPRB, 0.11546294E-12_JPRB, 0.11324285E-12_JPRB, 0.11128445E-12_JPRB, 0.11010359E-12_JPRB, 0.10920972E-12_JPRB, &
  & 0.10879599E-12_JPRB, 0.10847402E-12_JPRB, 0.10815657E-12_JPRB, 0.10775453E-12_JPRB, 0.10713176E-12_JPRB, 0.10662060E-12_JPRB, &
  & 0.10582907E-12_JPRB, 0.10538575E-12_JPRB, 0.10486393E-12_JPRB, 0.10470803E-12_JPRB, 0.10489090E-12_JPRB, 0.10546333E-12_JPRB, &
  & 0.10660873E-12_JPRB, 0.99675998E-13_JPRB, 0.98824283E-13_JPRB, 0.97538941E-13_JPRB, 0.95996900E-13_JPRB, 0.88457921E-13_JPRB, &
  & 0.87286074E-13_JPRB, 0.86589671E-13_JPRB, 0.10354046E-12_JPRB, 0.97222774E-09_JPRB /)

RGHG4(:, 2, 9) = (/ &
  & 0.15421352E-12_JPRB, 0.16620562E-12_JPRB, 0.17250596E-12_JPRB, 0.17632815E-12_JPRB, 0.17839400E-12_JPRB, 0.17885316E-12_JPRB, &
  & 0.17795607E-12_JPRB, 0.17689673E-12_JPRB, 0.20079778E-12_JPRB, 0.21393186E-12_JPRB, 0.23469524E-12_JPRB, 0.26307686E-12_JPRB, &
  & 0.29859042E-12_JPRB, 0.33994603E-12_JPRB, 0.38237008E-12_JPRB, 0.42519425E-12_JPRB, 0.46723297E-12_JPRB, 0.50633028E-12_JPRB, &
  & 0.54003438E-12_JPRB, 0.56472725E-12_JPRB, 0.57810148E-12_JPRB, 0.57563589E-12_JPRB, 0.55415888E-12_JPRB, 0.51966889E-12_JPRB, &
  & 0.49751755E-12_JPRB, 0.48671288E-12_JPRB, 0.47954408E-12_JPRB, 0.47834881E-12_JPRB, 0.48181646E-12_JPRB, 0.48671890E-12_JPRB, &
  & 0.48881504E-12_JPRB, 0.49053703E-12_JPRB, 0.51399445E-12_JPRB, 0.55561377E-12_JPRB, 0.60729010E-12_JPRB, 0.66074403E-12_JPRB, &
  & 0.71257724E-12_JPRB, 0.76557749E-12_JPRB, 0.82046273E-12_JPRB, 0.86949810E-12_JPRB, 0.90902025E-12_JPRB, 0.92976538E-12_JPRB, &
  & 0.93289005E-12_JPRB, 0.91905574E-12_JPRB, 0.88856255E-12_JPRB, 0.84357396E-12_JPRB, 0.78936819E-12_JPRB, 0.72697555E-12_JPRB, &
  & 0.66448003E-12_JPRB, 0.60511741E-12_JPRB, 0.55112241E-12_JPRB, 0.50520758E-12_JPRB, 0.46688673E-12_JPRB, 0.43560850E-12_JPRB, &
  & 0.40906455E-12_JPRB, 0.38399430E-12_JPRB, 0.36143124E-12_JPRB, 0.34525226E-12_JPRB, 0.33165902E-12_JPRB, 0.31698494E-12_JPRB, &
  & 0.29962258E-12_JPRB, 0.27974525E-12_JPRB, 0.25923537E-12_JPRB, 0.45198019E-10_JPRB /)

RGHG4(:, 3, 9) = (/ &
  & 0.56461189E-12_JPRB, 0.54093123E-12_JPRB, 0.54234026E-12_JPRB, 0.53594049E-12_JPRB, 0.52538865E-12_JPRB, 0.51300240E-12_JPRB, &
  & 0.50268833E-12_JPRB, 0.49853199E-12_JPRB, 0.55059126E-12_JPRB, 0.58454294E-12_JPRB, 0.62943222E-12_JPRB, 0.68181176E-12_JPRB, &
  & 0.74025015E-12_JPRB, 0.80624743E-12_JPRB, 0.87993734E-12_JPRB, 0.95967711E-12_JPRB, 0.10345425E-11_JPRB, 0.10986246E-11_JPRB, &
  & 0.11533014E-11_JPRB, 0.11901173E-11_JPRB, 0.12014424E-11_JPRB, 0.11802990E-11_JPRB, 0.11339937E-11_JPRB, 0.10743969E-11_JPRB, &
  & 0.10017060E-11_JPRB, 0.92276620E-12_JPRB, 0.86133656E-12_JPRB, 0.83409110E-12_JPRB, 0.84550921E-12_JPRB, 0.89435127E-12_JPRB, &
  & 0.96234435E-12_JPRB, 0.10437697E-11_JPRB, 0.11398113E-11_JPRB, 0.12501751E-11_JPRB, 0.13624399E-11_JPRB, 0.14642601E-11_JPRB, &
  & 0.15652601E-11_JPRB, 0.16608267E-11_JPRB, 0.17534647E-11_JPRB, 0.18368798E-11_JPRB, 0.19060435E-11_JPRB, 0.19457333E-11_JPRB, &
  & 0.19516045E-11_JPRB, 0.19230910E-11_JPRB, 0.18631806E-11_JPRB, 0.17746619E-11_JPRB, 0.16717711E-11_JPRB, 0.15493859E-11_JPRB, &
  & 0.14288793E-11_JPRB, 0.13083129E-11_JPRB, 0.11983784E-11_JPRB, 0.10953808E-11_JPRB, 0.10066347E-11_JPRB, 0.92671899E-12_JPRB, &
  & 0.85160942E-12_JPRB, 0.77819175E-12_JPRB, 0.69909459E-12_JPRB, 0.63718985E-12_JPRB, 0.58375060E-12_JPRB, 0.53031798E-12_JPRB, &
  & 0.48241928E-12_JPRB, 0.44575530E-12_JPRB, 0.42339165E-12_JPRB, 0.43469989E-09_JPRB /)

RGHG4(:, 4, 9) = (/ &
  & 0.23114965E-11_JPRB, 0.14953277E-11_JPRB, 0.14166871E-11_JPRB, 0.13892523E-11_JPRB, 0.13778755E-11_JPRB, 0.13805901E-11_JPRB, &
  & 0.13970478E-11_JPRB, 0.14232958E-11_JPRB, 0.15888622E-11_JPRB, 0.16538249E-11_JPRB, 0.17443831E-11_JPRB, 0.18552434E-11_JPRB, &
  & 0.19817693E-11_JPRB, 0.21153502E-11_JPRB, 0.22429437E-11_JPRB, 0.23699103E-11_JPRB, 0.24960695E-11_JPRB, 0.26114291E-11_JPRB, &
  & 0.27076568E-11_JPRB, 0.27696907E-11_JPRB, 0.27923881E-11_JPRB, 0.27733954E-11_JPRB, 0.27196789E-11_JPRB, 0.26324060E-11_JPRB, &
  & 0.25233387E-11_JPRB, 0.24103744E-11_JPRB, 0.23276543E-11_JPRB, 0.22957808E-11_JPRB, 0.23244963E-11_JPRB, 0.24110965E-11_JPRB, &
  & 0.25314494E-11_JPRB, 0.26791698E-11_JPRB, 0.28432888E-11_JPRB, 0.30379648E-11_JPRB, 0.32360993E-11_JPRB, 0.34248990E-11_JPRB, &
  & 0.36101029E-11_JPRB, 0.37849958E-11_JPRB, 0.39574902E-11_JPRB, 0.41092403E-11_JPRB, 0.42436285E-11_JPRB, 0.43291455E-11_JPRB, &
  & 0.43546521E-11_JPRB, 0.43154122E-11_JPRB, 0.42199625E-11_JPRB, 0.40735059E-11_JPRB, 0.39030979E-11_JPRB, 0.36997011E-11_JPRB, &
  & 0.34945152E-11_JPRB, 0.32776863E-11_JPRB, 0.30643554E-11_JPRB, 0.28566661E-11_JPRB, 0.26495538E-11_JPRB, 0.24432140E-11_JPRB, &
  & 0.22416116E-11_JPRB, 0.20431690E-11_JPRB, 0.18551285E-11_JPRB, 0.16833510E-11_JPRB, 0.15186604E-11_JPRB, 0.13617324E-11_JPRB, &
  & 0.12261497E-11_JPRB, 0.11133147E-11_JPRB, 0.10317828E-11_JPRB, 0.97525699E-09_JPRB /)

RGHG4(:, 5, 9) = (/ &
  & 0.69985688E-11_JPRB, 0.43456345E-11_JPRB, 0.40254410E-11_JPRB, 0.38835385E-11_JPRB, 0.38436762E-11_JPRB, 0.38312899E-11_JPRB, &
  & 0.39089439E-11_JPRB, 0.40694076E-11_JPRB, 0.44177379E-11_JPRB, 0.46707651E-11_JPRB, 0.49627711E-11_JPRB, 0.52844925E-11_JPRB, &
  & 0.56198505E-11_JPRB, 0.59577725E-11_JPRB, 0.62923525E-11_JPRB, 0.66203722E-11_JPRB, 0.69205605E-11_JPRB, 0.71919653E-11_JPRB, &
  & 0.74394267E-11_JPRB, 0.76420537E-11_JPRB, 0.77859889E-11_JPRB, 0.78529579E-11_JPRB, 0.78340563E-11_JPRB, 0.77268556E-11_JPRB, &
  & 0.75680764E-11_JPRB, 0.74045154E-11_JPRB, 0.72882863E-11_JPRB, 0.72535307E-11_JPRB, 0.73245125E-11_JPRB, 0.74830992E-11_JPRB, &
  & 0.76954693E-11_JPRB, 0.79587864E-11_JPRB, 0.82416487E-11_JPRB, 0.85839547E-11_JPRB, 0.89506484E-11_JPRB, 0.93241725E-11_JPRB, &
  & 0.96968189E-11_JPRB, 0.10058589E-10_JPRB, 0.10403285E-10_JPRB, 0.10700809E-10_JPRB, 0.10953978E-10_JPRB, 0.11116108E-10_JPRB, &
  & 0.11164941E-10_JPRB, 0.11099336E-10_JPRB, 0.10930667E-10_JPRB, 0.10673640E-10_JPRB, 0.10370891E-10_JPRB, 0.10010831E-10_JPRB, &
  & 0.96221997E-11_JPRB, 0.91914046E-11_JPRB, 0.87139731E-11_JPRB, 0.82101183E-11_JPRB, 0.76706480E-11_JPRB, 0.71029558E-11_JPRB, &
  & 0.65235616E-11_JPRB, 0.59603125E-11_JPRB, 0.54335733E-11_JPRB, 0.49273276E-11_JPRB, 0.44529510E-11_JPRB, 0.40261609E-11_JPRB, &
  & 0.36597093E-11_JPRB, 0.33551267E-11_JPRB, 0.33471138E-11_JPRB, 0.17465274E-08_JPRB /)

RGHG4(:, 6, 9) = (/ &
  & 0.17945100E-10_JPRB, 0.11268243E-10_JPRB, 0.10223109E-10_JPRB, 0.99296092E-11_JPRB, 0.10109331E-10_JPRB, 0.10457156E-10_JPRB, &
  & 0.10985816E-10_JPRB, 0.11540002E-10_JPRB, 0.12216761E-10_JPRB, 0.12974831E-10_JPRB, 0.13797443E-10_JPRB, 0.14644961E-10_JPRB, &
  & 0.15514305E-10_JPRB, 0.16377061E-10_JPRB, 0.17171620E-10_JPRB, 0.17901083E-10_JPRB, 0.18585978E-10_JPRB, 0.19214514E-10_JPRB, &
  & 0.19794406E-10_JPRB, 0.20331552E-10_JPRB, 0.20833640E-10_JPRB, 0.21288244E-10_JPRB, 0.21681254E-10_JPRB, 0.21991298E-10_JPRB, &
  & 0.22211420E-10_JPRB, 0.22376668E-10_JPRB, 0.22530654E-10_JPRB, 0.22683024E-10_JPRB, 0.22875549E-10_JPRB, 0.23100926E-10_JPRB, &
  & 0.23359191E-10_JPRB, 0.23689467E-10_JPRB, 0.24022289E-10_JPRB, 0.24433412E-10_JPRB, 0.24928977E-10_JPRB, 0.25491508E-10_JPRB, &
  & 0.26105723E-10_JPRB, 0.26747989E-10_JPRB, 0.27375024E-10_JPRB, 0.27924000E-10_JPRB, 0.28378746E-10_JPRB, 0.28665932E-10_JPRB, &
  & 0.28749315E-10_JPRB, 0.28639221E-10_JPRB, 0.28362887E-10_JPRB, 0.27958443E-10_JPRB, 0.27466463E-10_JPRB, 0.26873186E-10_JPRB, &
  & 0.26199411E-10_JPRB, 0.25418837E-10_JPRB, 0.24510578E-10_JPRB, 0.23478629E-10_JPRB, 0.22309756E-10_JPRB, 0.21036246E-10_JPRB, &
  & 0.19648281E-10_JPRB, 0.18204110E-10_JPRB, 0.16731132E-10_JPRB, 0.15329694E-10_JPRB, 0.14082952E-10_JPRB, 0.13036420E-10_JPRB, &
  & 0.12142905E-10_JPRB, 0.11499540E-10_JPRB, 0.12975700E-10_JPRB, 0.29593181E-08_JPRB /)

RGHG4(:, 7, 9) = (/ &
  & 0.40383259E-10_JPRB, 0.32359164E-10_JPRB, 0.30652408E-10_JPRB, 0.29652503E-10_JPRB, 0.29694816E-10_JPRB, 0.30127671E-10_JPRB, &
  & 0.31193662E-10_JPRB, 0.32399149E-10_JPRB, 0.33877647E-10_JPRB, 0.35671337E-10_JPRB, 0.37656760E-10_JPRB, 0.39709670E-10_JPRB, &
  & 0.41651033E-10_JPRB, 0.43437403E-10_JPRB, 0.45129147E-10_JPRB, 0.46721262E-10_JPRB, 0.48197932E-10_JPRB, 0.49607974E-10_JPRB, &
  & 0.51004544E-10_JPRB, 0.52399741E-10_JPRB, 0.53829646E-10_JPRB, 0.55308629E-10_JPRB, 0.56851676E-10_JPRB, 0.58413295E-10_JPRB, &
  & 0.59917495E-10_JPRB, 0.61236585E-10_JPRB, 0.62331251E-10_JPRB, 0.63199661E-10_JPRB, 0.63854713E-10_JPRB, 0.64372035E-10_JPRB, &
  & 0.64765894E-10_JPRB, 0.65271073E-10_JPRB, 0.65665182E-10_JPRB, 0.66127777E-10_JPRB, 0.66842754E-10_JPRB, 0.67848685E-10_JPRB, &
  & 0.69112049E-10_JPRB, 0.70551558E-10_JPRB, 0.72004354E-10_JPRB, 0.73323583E-10_JPRB, 0.74422114E-10_JPRB, 0.75167532E-10_JPRB, &
  & 0.75511909E-10_JPRB, 0.75481767E-10_JPRB, 0.75131942E-10_JPRB, 0.74520438E-10_JPRB, 0.73679653E-10_JPRB, 0.72602938E-10_JPRB, &
  & 0.71277019E-10_JPRB, 0.69650757E-10_JPRB, 0.67691401E-10_JPRB, 0.65406083E-10_JPRB, 0.62803235E-10_JPRB, 0.59953119E-10_JPRB, &
  & 0.56998770E-10_JPRB, 0.54264461E-10_JPRB, 0.51673887E-10_JPRB, 0.49219007E-10_JPRB, 0.47046499E-10_JPRB, 0.45315342E-10_JPRB, &
  & 0.44658881E-10_JPRB, 0.46548973E-10_JPRB, 0.57572253E-10_JPRB, 0.49045643E-08_JPRB /)

RGHG4(:, 8, 9) = (/ &
  & 0.85806993E-10_JPRB, 0.80939332E-10_JPRB, 0.78488674E-10_JPRB, 0.77667955E-10_JPRB, 0.79388211E-10_JPRB, 0.81638106E-10_JPRB, &
  & 0.84613101E-10_JPRB, 0.87786563E-10_JPRB, 0.91682197E-10_JPRB, 0.96244117E-10_JPRB, 0.10085286E-09_JPRB, 0.10540288E-09_JPRB, &
  & 0.10990343E-09_JPRB, 0.11415031E-09_JPRB, 0.11795567E-09_JPRB, 0.12140490E-09_JPRB, 0.12466253E-09_JPRB, 0.12778711E-09_JPRB, &
  & 0.13088199E-09_JPRB, 0.13406094E-09_JPRB, 0.13748386E-09_JPRB, 0.14126508E-09_JPRB, 0.14553660E-09_JPRB, 0.15018846E-09_JPRB, &
  & 0.15501744E-09_JPRB, 0.15947996E-09_JPRB, 0.16337627E-09_JPRB, 0.16646209E-09_JPRB, 0.16874067E-09_JPRB, 0.17043959E-09_JPRB, &
  & 0.17159063E-09_JPRB, 0.17312822E-09_JPRB, 0.17413863E-09_JPRB, 0.17507991E-09_JPRB, 0.17648726E-09_JPRB, 0.17847721E-09_JPRB, &
  & 0.18100517E-09_JPRB, 0.18394603E-09_JPRB, 0.18696390E-09_JPRB, 0.18985773E-09_JPRB, 0.19237711E-09_JPRB, 0.19434890E-09_JPRB, &
  & 0.19563492E-09_JPRB, 0.19626603E-09_JPRB, 0.19629397E-09_JPRB, 0.19580458E-09_JPRB, 0.19483416E-09_JPRB, 0.19338134E-09_JPRB, &
  & 0.19137508E-09_JPRB, 0.18880299E-09_JPRB, 0.18556387E-09_JPRB, 0.18170371E-09_JPRB, 0.17726559E-09_JPRB, 0.17243067E-09_JPRB, &
  & 0.16730750E-09_JPRB, 0.16205759E-09_JPRB, 0.15649991E-09_JPRB, 0.15259426E-09_JPRB, 0.15119703E-09_JPRB, 0.15263046E-09_JPRB, &
  & 0.15720039E-09_JPRB, 0.16569195E-09_JPRB, 0.18030936E-09_JPRB, 0.76187607E-08_JPRB /)

RGHG4(:, 9, 9) = (/ &
  & 0.17053690E-09_JPRB, 0.18981748E-09_JPRB, 0.19985862E-09_JPRB, 0.20352982E-09_JPRB, 0.20721898E-09_JPRB, 0.21231530E-09_JPRB, &
  & 0.21952572E-09_JPRB, 0.22687922E-09_JPRB, 0.23534830E-09_JPRB, 0.24524263E-09_JPRB, 0.25568514E-09_JPRB, 0.26595193E-09_JPRB, &
  & 0.27532698E-09_JPRB, 0.28369015E-09_JPRB, 0.29118741E-09_JPRB, 0.29782313E-09_JPRB, 0.30382061E-09_JPRB, 0.30950650E-09_JPRB, &
  & 0.31527797E-09_JPRB, 0.32137840E-09_JPRB, 0.32821496E-09_JPRB, 0.33605813E-09_JPRB, 0.34538955E-09_JPRB, 0.35615189E-09_JPRB, &
  & 0.36792758E-09_JPRB, 0.37922787E-09_JPRB, 0.38953291E-09_JPRB, 0.39808914E-09_JPRB, 0.40499737E-09_JPRB, 0.41063755E-09_JPRB, &
  & 0.41521689E-09_JPRB, 0.42110254E-09_JPRB, 0.42521081E-09_JPRB, 0.42849205E-09_JPRB, 0.43221010E-09_JPRB, 0.43663401E-09_JPRB, &
  & 0.44176893E-09_JPRB, 0.44746468E-09_JPRB, 0.45320572E-09_JPRB, 0.45886248E-09_JPRB, 0.46400123E-09_JPRB, 0.46837223E-09_JPRB, &
  & 0.47183002E-09_JPRB, 0.47432536E-09_JPRB, 0.47587628E-09_JPRB, 0.47652265E-09_JPRB, 0.47626325E-09_JPRB, 0.47523618E-09_JPRB, &
  & 0.47339727E-09_JPRB, 0.47080378E-09_JPRB, 0.46736109E-09_JPRB, 0.46341003E-09_JPRB, 0.45908716E-09_JPRB, 0.45485771E-09_JPRB, &
  & 0.45132359E-09_JPRB, 0.45141571E-09_JPRB, 0.45316517E-09_JPRB, 0.45530066E-09_JPRB, 0.45825418E-09_JPRB, 0.46424151E-09_JPRB, &
  & 0.46723819E-09_JPRB, 0.46506232E-09_JPRB, 0.46220150E-09_JPRB, 0.10904852E-07_JPRB /)

RGHG4(:,10, 9) = (/ &
  & 0.31521838E-09_JPRB, 0.36698136E-09_JPRB, 0.39958731E-09_JPRB, 0.42312351E-09_JPRB, 0.44698503E-09_JPRB, 0.46852688E-09_JPRB, &
  & 0.49087451E-09_JPRB, 0.51314364E-09_JPRB, 0.53619564E-09_JPRB, 0.56008592E-09_JPRB, 0.58236865E-09_JPRB, 0.60291472E-09_JPRB, &
  & 0.62153122E-09_JPRB, 0.63776895E-09_JPRB, 0.65156391E-09_JPRB, 0.66344158E-09_JPRB, 0.67415673E-09_JPRB, 0.68422251E-09_JPRB, &
  & 0.69432676E-09_JPRB, 0.70507589E-09_JPRB, 0.71737011E-09_JPRB, 0.73198703E-09_JPRB, 0.75000794E-09_JPRB, 0.77121665E-09_JPRB, &
  & 0.79533286E-09_JPRB, 0.82016488E-09_JPRB, 0.84441942E-09_JPRB, 0.86627983E-09_JPRB, 0.88598878E-09_JPRB, 0.90383001E-09_JPRB, &
  & 0.92013697E-09_JPRB, 0.93916908E-09_JPRB, 0.95283792E-09_JPRB, 0.96312713E-09_JPRB, 0.97250219E-09_JPRB, 0.98169772E-09_JPRB, &
  & 0.99090403E-09_JPRB, 0.10001916E-08_JPRB, 0.10090216E-08_JPRB, 0.10177003E-08_JPRB, 0.10257358E-08_JPRB, 0.10329934E-08_JPRB, &
  & 0.10392031E-08_JPRB, 0.10442757E-08_JPRB, 0.10481231E-08_JPRB, 0.10507493E-08_JPRB, 0.10522679E-08_JPRB, 0.10528709E-08_JPRB, &
  & 0.10524838E-08_JPRB, 0.10515432E-08_JPRB, 0.10500545E-08_JPRB, 0.10487431E-08_JPRB, 0.10479307E-08_JPRB, 0.10486519E-08_JPRB, &
  & 0.10512428E-08_JPRB, 0.10536853E-08_JPRB, 0.10518497E-08_JPRB, 0.10510360E-08_JPRB, 0.10506883E-08_JPRB, 0.10389252E-08_JPRB, &
  & 0.10049390E-08_JPRB, 0.94624419E-09_JPRB, 0.89700225E-09_JPRB, 0.14290847E-07_JPRB /)

RGHG4(:,11, 9) = (/ &
  & 0.52379245E-09_JPRB, 0.61990085E-09_JPRB, 0.68385742E-09_JPRB, 0.74402001E-09_JPRB, 0.80077561E-09_JPRB, 0.86158630E-09_JPRB, &
  & 0.92199542E-09_JPRB, 0.98006803E-09_JPRB, 0.10353423E-08_JPRB, 0.10886901E-08_JPRB, 0.11376725E-08_JPRB, 0.11816149E-08_JPRB, &
  & 0.12195664E-08_JPRB, 0.12518635E-08_JPRB, 0.12791973E-08_JPRB, 0.13024145E-08_JPRB, 0.13225405E-08_JPRB, 0.13411634E-08_JPRB, &
  & 0.13593613E-08_JPRB, 0.13784821E-08_JPRB, 0.14001599E-08_JPRB, 0.14259247E-08_JPRB, 0.14577939E-08_JPRB, 0.14964857E-08_JPRB, &
  & 0.15415724E-08_JPRB, 0.15891595E-08_JPRB, 0.16377469E-08_JPRB, 0.16844600E-08_JPRB, 0.17291787E-08_JPRB, 0.17707573E-08_JPRB, &
  & 0.18095087E-08_JPRB, 0.18518647E-08_JPRB, 0.18824011E-08_JPRB, 0.19049935E-08_JPRB, 0.19236202E-08_JPRB, 0.19396387E-08_JPRB, &
  & 0.19536301E-08_JPRB, 0.19659832E-08_JPRB, 0.19765996E-08_JPRB, 0.19862789E-08_JPRB, 0.19950035E-08_JPRB, 0.20028603E-08_JPRB, &
  & 0.20097239E-08_JPRB, 0.20156012E-08_JPRB, 0.20203392E-08_JPRB, 0.20236408E-08_JPRB, 0.20253574E-08_JPRB, 0.20252873E-08_JPRB, &
  & 0.20231627E-08_JPRB, 0.20191102E-08_JPRB, 0.20132296E-08_JPRB, 0.20063604E-08_JPRB, 0.19989055E-08_JPRB, 0.19910698E-08_JPRB, &
  & 0.19831483E-08_JPRB, 0.19773689E-08_JPRB, 0.19680559E-08_JPRB, 0.19454496E-08_JPRB, 0.19028821E-08_JPRB, 0.18360534E-08_JPRB, &
  & 0.17398675E-08_JPRB, 0.16265213E-08_JPRB, 0.14986336E-08_JPRB, 0.16974251E-07_JPRB /)

RGHG4(:,12, 9) = (/ &
  & 0.77664242E-09_JPRB, 0.89499513E-09_JPRB, 0.99192410E-09_JPRB, 0.10825680E-08_JPRB, 0.11866811E-08_JPRB, 0.12969712E-08_JPRB, &
  & 0.14162804E-08_JPRB, 0.15382265E-08_JPRB, 0.16588595E-08_JPRB, 0.17749114E-08_JPRB, 0.18806436E-08_JPRB, 0.19751245E-08_JPRB, &
  & 0.20583386E-08_JPRB, 0.21299631E-08_JPRB, 0.21915127E-08_JPRB, 0.22434035E-08_JPRB, 0.22887945E-08_JPRB, 0.23287003E-08_JPRB, &
  & 0.23658244E-08_JPRB, 0.24026294E-08_JPRB, 0.24409534E-08_JPRB, 0.24831790E-08_JPRB, 0.25316698E-08_JPRB, 0.25878557E-08_JPRB, &
  & 0.26517379E-08_JPRB, 0.27197722E-08_JPRB, 0.27897795E-08_JPRB, 0.28591574E-08_JPRB, 0.29272060E-08_JPRB, 0.29924325E-08_JPRB, &
  & 0.30543943E-08_JPRB, 0.31191343E-08_JPRB, 0.31649057E-08_JPRB, 0.31980789E-08_JPRB, 0.32242302E-08_JPRB, 0.32453953E-08_JPRB, &
  & 0.32628498E-08_JPRB, 0.32775740E-08_JPRB, 0.32898240E-08_JPRB, 0.33004042E-08_JPRB, 0.33093583E-08_JPRB, 0.33165517E-08_JPRB, &
  & 0.33219751E-08_JPRB, 0.33256118E-08_JPRB, 0.33271077E-08_JPRB, 0.33257284E-08_JPRB, 0.33211747E-08_JPRB, 0.33124761E-08_JPRB, &
  & 0.32984750E-08_JPRB, 0.32788037E-08_JPRB, 0.32529603E-08_JPRB, 0.32202951E-08_JPRB, 0.31805709E-08_JPRB, 0.31332579E-08_JPRB, &
  & 0.30776324E-08_JPRB, 0.30125997E-08_JPRB, 0.29245804E-08_JPRB, 0.28103042E-08_JPRB, 0.26696054E-08_JPRB, 0.25037625E-08_JPRB, &
  & 0.23153879E-08_JPRB, 0.21078610E-08_JPRB, 0.19377013E-08_JPRB, 0.17450279E-07_JPRB /)

RGHG4(:,13, 9) = (/ &
  & 0.10491400E-08_JPRB, 0.11747409E-08_JPRB, 0.12895828E-08_JPRB, 0.14146976E-08_JPRB, 0.15545569E-08_JPRB, 0.17190179E-08_JPRB, &
  & 0.19009134E-08_JPRB, 0.20957178E-08_JPRB, 0.22968729E-08_JPRB, 0.24991420E-08_JPRB, 0.26934039E-08_JPRB, 0.28752580E-08_JPRB, &
  & 0.30418099E-08_JPRB, 0.31901828E-08_JPRB, 0.33213041E-08_JPRB, 0.34349874E-08_JPRB, 0.35325245E-08_JPRB, 0.36167735E-08_JPRB, &
  & 0.36894618E-08_JPRB, 0.37528194E-08_JPRB, 0.38101096E-08_JPRB, 0.38645700E-08_JPRB, 0.39195927E-08_JPRB, 0.39783492E-08_JPRB, &
  & 0.40416146E-08_JPRB, 0.41105865E-08_JPRB, 0.41833177E-08_JPRB, 0.42574126E-08_JPRB, 0.43311590E-08_JPRB, 0.44015604E-08_JPRB, &
  & 0.44665236E-08_JPRB, 0.45324442E-08_JPRB, 0.45755253E-08_JPRB, 0.46034367E-08_JPRB, 0.46216329E-08_JPRB, 0.46345892E-08_JPRB, &
  & 0.46450355E-08_JPRB, 0.46548130E-08_JPRB, 0.46625366E-08_JPRB, 0.46688040E-08_JPRB, 0.46724775E-08_JPRB, 0.46731174E-08_JPRB, &
  & 0.46707420E-08_JPRB, 0.46653108E-08_JPRB, 0.46567181E-08_JPRB, 0.46432249E-08_JPRB, 0.46236535E-08_JPRB, 0.45953628E-08_JPRB, &
  & 0.45566200E-08_JPRB, 0.45057758E-08_JPRB, 0.44420045E-08_JPRB, 0.43647908E-08_JPRB, 0.42733523E-08_JPRB, 0.41665991E-08_JPRB, &
  & 0.40435304E-08_JPRB, 0.39049790E-08_JPRB, 0.37381147E-08_JPRB, 0.35458250E-08_JPRB, 0.33313896E-08_JPRB, 0.31023686E-08_JPRB, &
  & 0.28587164E-08_JPRB, 0.26071163E-08_JPRB, 0.23834719E-08_JPRB, 0.16294868E-07_JPRB /)

RGHG4(:,14, 9) = (/ &
  & 0.12637557E-08_JPRB, 0.13925460E-08_JPRB, 0.15174030E-08_JPRB, 0.16668638E-08_JPRB, 0.18445135E-08_JPRB, 0.20573021E-08_JPRB, &
  & 0.23034206E-08_JPRB, 0.25788589E-08_JPRB, 0.28758551E-08_JPRB, 0.31847120E-08_JPRB, 0.34900522E-08_JPRB, 0.37814392E-08_JPRB, &
  & 0.40509178E-08_JPRB, 0.42899169E-08_JPRB, 0.44957194E-08_JPRB, 0.46696202E-08_JPRB, 0.48167577E-08_JPRB, 0.49398912E-08_JPRB, &
  & 0.50436992E-08_JPRB, 0.51306963E-08_JPRB, 0.52049622E-08_JPRB, 0.52689280E-08_JPRB, 0.53252016E-08_JPRB, 0.53760640E-08_JPRB, &
  & 0.54244587E-08_JPRB, 0.54726983E-08_JPRB, 0.55218252E-08_JPRB, 0.55725051E-08_JPRB, 0.56207274E-08_JPRB, 0.56658771E-08_JPRB, &
  & 0.57069505E-08_JPRB, 0.57462728E-08_JPRB, 0.57613203E-08_JPRB, 0.57611769E-08_JPRB, 0.57525100E-08_JPRB, 0.57424088E-08_JPRB, &
  & 0.57333445E-08_JPRB, 0.57276739E-08_JPRB, 0.57242002E-08_JPRB, 0.57208114E-08_JPRB, 0.57162448E-08_JPRB, 0.57093135E-08_JPRB, &
  & 0.56993743E-08_JPRB, 0.56866813E-08_JPRB, 0.56694200E-08_JPRB, 0.56451896E-08_JPRB, 0.56105440E-08_JPRB, 0.55608620E-08_JPRB, &
  & 0.54929421E-08_JPRB, 0.54059579E-08_JPRB, 0.52992015E-08_JPRB, 0.51723150E-08_JPRB, 0.50246833E-08_JPRB, 0.48559263E-08_JPRB, &
  & 0.46671729E-08_JPRB, 0.44619779E-08_JPRB, 0.42302237E-08_JPRB, 0.39794101E-08_JPRB, 0.37162711E-08_JPRB, 0.34461538E-08_JPRB, &
  & 0.31588878E-08_JPRB, 0.28232772E-08_JPRB, 0.25967526E-08_JPRB, 0.13955964E-07_JPRB /)

RGHG4(:,15, 9) = (/ &
  & 0.13932014E-08_JPRB, 0.15245292E-08_JPRB, 0.16788622E-08_JPRB, 0.18518198E-08_JPRB, 0.20718125E-08_JPRB, 0.23350928E-08_JPRB, &
  & 0.26444889E-08_JPRB, 0.29931857E-08_JPRB, 0.33708210E-08_JPRB, 0.37641947E-08_JPRB, 0.41510835E-08_JPRB, 0.45148165E-08_JPRB, &
  & 0.48434221E-08_JPRB, 0.51304889E-08_JPRB, 0.53741949E-08_JPRB, 0.55776330E-08_JPRB, 0.57456351E-08_JPRB, 0.58849876E-08_JPRB, &
  & 0.60015308E-08_JPRB, 0.60989613E-08_JPRB, 0.61811969E-08_JPRB, 0.62507941E-08_JPRB, 0.63109020E-08_JPRB, 0.63623635E-08_JPRB, &
  & 0.64051786E-08_JPRB, 0.64408496E-08_JPRB, 0.64693948E-08_JPRB, 0.64913994E-08_JPRB, 0.65052013E-08_JPRB, 0.65088237E-08_JPRB, &
  & 0.65031469E-08_JPRB, 0.64966788E-08_JPRB, 0.64653332E-08_JPRB, 0.64224026E-08_JPRB, 0.63740782E-08_JPRB, 0.63237247E-08_JPRB, &
  & 0.62809900E-08_JPRB, 0.62486190E-08_JPRB, 0.62249566E-08_JPRB, 0.62064167E-08_JPRB, 0.61922076E-08_JPRB, 0.61806755E-08_JPRB, &
  & 0.61714274E-08_JPRB, 0.61623950E-08_JPRB, 0.61502758E-08_JPRB, 0.61295444E-08_JPRB, 0.60924439E-08_JPRB, 0.60321907E-08_JPRB, &
  & 0.59455711E-08_JPRB, 0.58327272E-08_JPRB, 0.56948641E-08_JPRB, 0.55322480E-08_JPRB, 0.53450138E-08_JPRB, 0.51342637E-08_JPRB, &
  & 0.49041766E-08_JPRB, 0.46608659E-08_JPRB, 0.43980855E-08_JPRB, 0.41252508E-08_JPRB, 0.38490446E-08_JPRB, 0.35660268E-08_JPRB, &
  & 0.32612686E-08_JPRB, 0.28526759E-08_JPRB, 0.27671381E-08_JPRB, 0.11380746E-07_JPRB /)

RGHG4(:,16, 9) = (/ &
  & 0.14146698E-08_JPRB, 0.16019807E-08_JPRB, 0.17720150E-08_JPRB, 0.19867512E-08_JPRB, 0.22349265E-08_JPRB, 0.25355904E-08_JPRB, &
  & 0.28801768E-08_JPRB, 0.32652661E-08_JPRB, 0.36792280E-08_JPRB, 0.41073598E-08_JPRB, 0.45237449E-08_JPRB, 0.49130522E-08_JPRB, &
  & 0.52608553E-08_JPRB, 0.55585141E-08_JPRB, 0.58044023E-08_JPRB, 0.60036003E-08_JPRB, 0.61638801E-08_JPRB, 0.62917369E-08_JPRB, &
  & 0.63959780E-08_JPRB, 0.64817560E-08_JPRB, 0.65544383E-08_JPRB, 0.66182597E-08_JPRB, 0.66762547E-08_JPRB, 0.67285684E-08_JPRB, &
  & 0.67719745E-08_JPRB, 0.68019204E-08_JPRB, 0.68193309E-08_JPRB, 0.68236230E-08_JPRB, 0.68123671E-08_JPRB, 0.67877397E-08_JPRB, &
  & 0.67481132E-08_JPRB, 0.67034560E-08_JPRB, 0.66315851E-08_JPRB, 0.65518626E-08_JPRB, 0.64675194E-08_JPRB, 0.63887140E-08_JPRB, &
  & 0.63190551E-08_JPRB, 0.62575962E-08_JPRB, 0.62050196E-08_JPRB, 0.61616285E-08_JPRB, 0.61279271E-08_JPRB, 0.61051209E-08_JPRB, &
  & 0.60935248E-08_JPRB, 0.60902696E-08_JPRB, 0.60877130E-08_JPRB, 0.60751080E-08_JPRB, 0.60423986E-08_JPRB, 0.59818785E-08_JPRB, &
  & 0.58905432E-08_JPRB, 0.57693947E-08_JPRB, 0.56209082E-08_JPRB, 0.54468776E-08_JPRB, 0.52489497E-08_JPRB, 0.50295128E-08_JPRB, &
  & 0.47948183E-08_JPRB, 0.45509672E-08_JPRB, 0.42944537E-08_JPRB, 0.40327905E-08_JPRB, 0.37661758E-08_JPRB, 0.34864402E-08_JPRB, &
  & 0.31711718E-08_JPRB, 0.28122882E-08_JPRB, 0.27332088E-08_JPRB, 0.89444958E-08_JPRB /)

RGHG4(:,17, 9) = (/ &
  & 0.14007050E-08_JPRB, 0.16147792E-08_JPRB, 0.18079529E-08_JPRB, 0.20272937E-08_JPRB, 0.22860458E-08_JPRB, 0.25922757E-08_JPRB, &
  & 0.29372513E-08_JPRB, 0.33179495E-08_JPRB, 0.37241932E-08_JPRB, 0.41421515E-08_JPRB, 0.45447708E-08_JPRB, 0.49148827E-08_JPRB, &
  & 0.52375126E-08_JPRB, 0.55046074E-08_JPRB, 0.57156075E-08_JPRB, 0.58758109E-08_JPRB, 0.59957732E-08_JPRB, 0.60837122E-08_JPRB, &
  & 0.61470606E-08_JPRB, 0.61935892E-08_JPRB, 0.62273142E-08_JPRB, 0.62532379E-08_JPRB, 0.62784618E-08_JPRB, 0.63046435E-08_JPRB, &
  & 0.63311285E-08_JPRB, 0.63509091E-08_JPRB, 0.63562666E-08_JPRB, 0.63516796E-08_JPRB, 0.63422516E-08_JPRB, 0.63204793E-08_JPRB, &
  & 0.62841834E-08_JPRB, 0.62418306E-08_JPRB, 0.61753052E-08_JPRB, 0.61003824E-08_JPRB, 0.60220398E-08_JPRB, 0.59421503E-08_JPRB, &
  & 0.58587357E-08_JPRB, 0.57739520E-08_JPRB, 0.56903482E-08_JPRB, 0.56143414E-08_JPRB, 0.55499707E-08_JPRB, 0.55027600E-08_JPRB, &
  & 0.54764517E-08_JPRB, 0.54676836E-08_JPRB, 0.54677041E-08_JPRB, 0.54630589E-08_JPRB, 0.54412590E-08_JPRB, 0.53936584E-08_JPRB, &
  & 0.53170552E-08_JPRB, 0.52130931E-08_JPRB, 0.50849378E-08_JPRB, 0.49349542E-08_JPRB, 0.47648991E-08_JPRB, 0.45774748E-08_JPRB, &
  & 0.43781343E-08_JPRB, 0.41716324E-08_JPRB, 0.39559214E-08_JPRB, 0.37317824E-08_JPRB, 0.34955268E-08_JPRB, 0.32219869E-08_JPRB, &
  & 0.28531368E-08_JPRB, 0.25883409E-08_JPRB, 0.26218752E-08_JPRB, 0.66211010E-08_JPRB /)

RGHG4(:,18, 9) = (/ &
  & 0.13703333E-08_JPRB, 0.15622845E-08_JPRB, 0.17818775E-08_JPRB, 0.19962039E-08_JPRB, 0.22448947E-08_JPRB, 0.25330678E-08_JPRB, &
  & 0.28563771E-08_JPRB, 0.32116969E-08_JPRB, 0.35863210E-08_JPRB, 0.39663237E-08_JPRB, 0.43249209E-08_JPRB, 0.46447353E-08_JPRB, &
  & 0.49108579E-08_JPRB, 0.51168301E-08_JPRB, 0.52638724E-08_JPRB, 0.53602962E-08_JPRB, 0.54162554E-08_JPRB, 0.54423523E-08_JPRB, &
  & 0.54447438E-08_JPRB, 0.54298939E-08_JPRB, 0.54045701E-08_JPRB, 0.53728089E-08_JPRB, 0.53395839E-08_JPRB, 0.53074398E-08_JPRB, &
  & 0.52794245E-08_JPRB, 0.52589106E-08_JPRB, 0.52471050E-08_JPRB, 0.52393760E-08_JPRB, 0.52337472E-08_JPRB, 0.52406683E-08_JPRB, &
  & 0.52553148E-08_JPRB, 0.52771871E-08_JPRB, 0.52746105E-08_JPRB, 0.52510507E-08_JPRB, 0.52144742E-08_JPRB, 0.51647717E-08_JPRB, &
  & 0.50983702E-08_JPRB, 0.50108997E-08_JPRB, 0.49096047E-08_JPRB, 0.48069988E-08_JPRB, 0.47132267E-08_JPRB, 0.46377253E-08_JPRB, &
  & 0.45870898E-08_JPRB, 0.45609152E-08_JPRB, 0.45508308E-08_JPRB, 0.45450665E-08_JPRB, 0.45316857E-08_JPRB, 0.45023723E-08_JPRB, &
  & 0.44530517E-08_JPRB, 0.43837480E-08_JPRB, 0.42966848E-08_JPRB, 0.41934918E-08_JPRB, 0.40751202E-08_JPRB, 0.39433394E-08_JPRB, &
  & 0.38004191E-08_JPRB, 0.36491299E-08_JPRB, 0.34856800E-08_JPRB, 0.33065866E-08_JPRB, 0.30970171E-08_JPRB, 0.28437332E-08_JPRB, &
  & 0.25603359E-08_JPRB, 0.23452869E-08_JPRB, 0.23957407E-08_JPRB, 0.47608841E-08_JPRB /)

RGHG4(:,19, 9) = (/ &
  & 0.13666362E-08_JPRB, 0.14926180E-08_JPRB, 0.16874098E-08_JPRB, 0.19087343E-08_JPRB, 0.21415860E-08_JPRB, 0.24066404E-08_JPRB, &
  & 0.26981979E-08_JPRB, 0.30129355E-08_JPRB, 0.33425069E-08_JPRB, 0.36693590E-08_JPRB, 0.39659760E-08_JPRB, 0.42161998E-08_JPRB, &
  & 0.44091468E-08_JPRB, 0.45424007E-08_JPRB, 0.46206634E-08_JPRB, 0.46535567E-08_JPRB, 0.46528146E-08_JPRB, 0.46272883E-08_JPRB, &
  & 0.45835513E-08_JPRB, 0.45241633E-08_JPRB, 0.44543476E-08_JPRB, 0.43770161E-08_JPRB, 0.42948396E-08_JPRB, 0.42104942E-08_JPRB, &
  & 0.41296895E-08_JPRB, 0.40596517E-08_JPRB, 0.40083408E-08_JPRB, 0.39819263E-08_JPRB, 0.39832826E-08_JPRB, 0.40117198E-08_JPRB, &
  & 0.40616683E-08_JPRB, 0.41313002E-08_JPRB, 0.41911119E-08_JPRB, 0.42343324E-08_JPRB, 0.42482946E-08_JPRB, 0.42322732E-08_JPRB, &
  & 0.41941575E-08_JPRB, 0.41259769E-08_JPRB, 0.40287049E-08_JPRB, 0.39194181E-08_JPRB, 0.38137475E-08_JPRB, 0.37228063E-08_JPRB, &
  & 0.36549759E-08_JPRB, 0.36120855E-08_JPRB, 0.35888768E-08_JPRB, 0.35773522E-08_JPRB, 0.35684686E-08_JPRB, 0.35552514E-08_JPRB, &
  & 0.35326051E-08_JPRB, 0.34994667E-08_JPRB, 0.34559953E-08_JPRB, 0.34023111E-08_JPRB, 0.33377865E-08_JPRB, 0.32619125E-08_JPRB, &
  & 0.31743701E-08_JPRB, 0.30758980E-08_JPRB, 0.29600558E-08_JPRB, 0.28180371E-08_JPRB, 0.26306533E-08_JPRB, 0.23806295E-08_JPRB, &
  & 0.21802269E-08_JPRB, 0.20076643E-08_JPRB, 0.20279365E-08_JPRB, 0.33179128E-08_JPRB /)

RGHG4(:,20, 9) = (/ &
  & 0.13141377E-08_JPRB, 0.13851270E-08_JPRB, 0.15359228E-08_JPRB, 0.17671127E-08_JPRB, 0.19947730E-08_JPRB, 0.22404021E-08_JPRB, &
  & 0.25024629E-08_JPRB, 0.27737870E-08_JPRB, 0.30491571E-08_JPRB, 0.33184970E-08_JPRB, 0.35517496E-08_JPRB, 0.37319410E-08_JPRB, &
  & 0.38546157E-08_JPRB, 0.39228865E-08_JPRB, 0.39449572E-08_JPRB, 0.39310963E-08_JPRB, 0.38905443E-08_JPRB, 0.38315235E-08_JPRB, &
  & 0.37586028E-08_JPRB, 0.36741106E-08_JPRB, 0.35795658E-08_JPRB, 0.34763910E-08_JPRB, 0.33661414E-08_JPRB, 0.32500755E-08_JPRB, &
  & 0.31360570E-08_JPRB, 0.30341918E-08_JPRB, 0.29565053E-08_JPRB, 0.29110547E-08_JPRB, 0.29034426E-08_JPRB, 0.29327278E-08_JPRB, &
  & 0.29946281E-08_JPRB, 0.30844343E-08_JPRB, 0.31754697E-08_JPRB, 0.32614094E-08_JPRB, 0.33258265E-08_JPRB, 0.33592569E-08_JPRB, &
  & 0.33316687E-08_JPRB, 0.32648257E-08_JPRB, 0.31794098E-08_JPRB, 0.30782130E-08_JPRB, 0.29770224E-08_JPRB, 0.28866454E-08_JPRB, &
  & 0.28164602E-08_JPRB, 0.27683507E-08_JPRB, 0.27397875E-08_JPRB, 0.27260270E-08_JPRB, 0.27215050E-08_JPRB, 0.27204123E-08_JPRB, &
  & 0.27178948E-08_JPRB, 0.27121747E-08_JPRB, 0.27022073E-08_JPRB, 0.26862330E-08_JPRB, 0.26619880E-08_JPRB, 0.26275280E-08_JPRB, &
  & 0.25808247E-08_JPRB, 0.25193565E-08_JPRB, 0.24337556E-08_JPRB, 0.23119497E-08_JPRB, 0.21565096E-08_JPRB, 0.19810302E-08_JPRB, &
  & 0.18303676E-08_JPRB, 0.16842200E-08_JPRB, 0.17016489E-08_JPRB, 0.22513884E-08_JPRB /)

RGHG4(:,21, 9) = (/ &
  & 0.11494116E-08_JPRB, 0.12110589E-08_JPRB, 0.13375743E-08_JPRB, 0.15461488E-08_JPRB, 0.17761637E-08_JPRB, 0.20219546E-08_JPRB, &
  & 0.22703202E-08_JPRB, 0.25164246E-08_JPRB, 0.27498508E-08_JPRB, 0.29654401E-08_JPRB, 0.31454990E-08_JPRB, 0.32707590E-08_JPRB, &
  & 0.33408032E-08_JPRB, 0.33628509E-08_JPRB, 0.33464980E-08_JPRB, 0.33023890E-08_JPRB, 0.32393497E-08_JPRB, 0.31622558E-08_JPRB, &
  & 0.30750196E-08_JPRB, 0.29790408E-08_JPRB, 0.28733849E-08_JPRB, 0.27579286E-08_JPRB, 0.26358118E-08_JPRB, 0.25077191E-08_JPRB, &
  & 0.23826343E-08_JPRB, 0.22701374E-08_JPRB, 0.21812612E-08_JPRB, 0.21238871E-08_JPRB, 0.21026991E-08_JPRB, 0.21177611E-08_JPRB, &
  & 0.21671676E-08_JPRB, 0.22470081E-08_JPRB, 0.23350952E-08_JPRB, 0.24225011E-08_JPRB, 0.24885383E-08_JPRB, 0.25152549E-08_JPRB, &
  & 0.25222360E-08_JPRB, 0.24919335E-08_JPRB, 0.24241600E-08_JPRB, 0.23440432E-08_JPRB, 0.22607001E-08_JPRB, 0.21892554E-08_JPRB, &
  & 0.21314697E-08_JPRB, 0.20911857E-08_JPRB, 0.20669149E-08_JPRB, 0.20561584E-08_JPRB, 0.20567548E-08_JPRB, 0.20644222E-08_JPRB, &
  & 0.20755120E-08_JPRB, 0.20880193E-08_JPRB, 0.20991364E-08_JPRB, 0.21061517E-08_JPRB, 0.21061346E-08_JPRB, 0.20963098E-08_JPRB, &
  & 0.20736501E-08_JPRB, 0.20346445E-08_JPRB, 0.19713939E-08_JPRB, 0.18723534E-08_JPRB, 0.17407262E-08_JPRB, 0.16236434E-08_JPRB, &
  & 0.15001425E-08_JPRB, 0.13737740E-08_JPRB, 0.13609461E-08_JPRB, 0.15827587E-08_JPRB /)

RGHG4(:,22, 9) = (/ &
  & 0.84245738E-09_JPRB, 0.92161828E-09_JPRB, 0.10544794E-08_JPRB, 0.12238185E-08_JPRB, 0.14756698E-08_JPRB, 0.17331058E-08_JPRB, &
  & 0.19863680E-08_JPRB, 0.22252422E-08_JPRB, 0.24364761E-08_JPRB, 0.26136002E-08_JPRB, 0.27459306E-08_JPRB, 0.28292966E-08_JPRB, &
  & 0.28693785E-08_JPRB, 0.28657035E-08_JPRB, 0.28293148E-08_JPRB, 0.27696581E-08_JPRB, 0.26934623E-08_JPRB, 0.26046099E-08_JPRB, &
  & 0.25071154E-08_JPRB, 0.24056228E-08_JPRB, 0.22999933E-08_JPRB, 0.21879361E-08_JPRB, 0.20692579E-08_JPRB, 0.19464137E-08_JPRB, &
  & 0.18239550E-08_JPRB, 0.17116710E-08_JPRB, 0.16199381E-08_JPRB, 0.15562428E-08_JPRB, 0.15233642E-08_JPRB, 0.15208392E-08_JPRB, &
  & 0.15473629E-08_JPRB, 0.16007804E-08_JPRB, 0.16660614E-08_JPRB, 0.17357872E-08_JPRB, 0.17942998E-08_JPRB, 0.18330647E-08_JPRB, &
  & 0.18372124E-08_JPRB, 0.18114822E-08_JPRB, 0.17694962E-08_JPRB, 0.17140429E-08_JPRB, 0.16589330E-08_JPRB, 0.16069862E-08_JPRB, &
  & 0.15694792E-08_JPRB, 0.15485686E-08_JPRB, 0.15365164E-08_JPRB, 0.15352714E-08_JPRB, 0.15442350E-08_JPRB, 0.15609016E-08_JPRB, &
  & 0.15823227E-08_JPRB, 0.16064796E-08_JPRB, 0.16301630E-08_JPRB, 0.16502767E-08_JPRB, 0.16633146E-08_JPRB, 0.16663323E-08_JPRB, &
  & 0.16557985E-08_JPRB, 0.16264869E-08_JPRB, 0.15685484E-08_JPRB, 0.14831993E-08_JPRB, 0.14048026E-08_JPRB, 0.13272848E-08_JPRB, &
  & 0.12326287E-08_JPRB, 0.11198498E-08_JPRB, 0.10954154E-08_JPRB, 0.11149611E-08_JPRB /)

RGHG4(:,23, 9) = (/ &
  & 0.60679489E-09_JPRB, 0.68393891E-09_JPRB, 0.78441748E-09_JPRB, 0.94303731E-09_JPRB, 0.11667626E-08_JPRB, 0.14228316E-08_JPRB, &
  & 0.16857735E-08_JPRB, 0.19329705E-08_JPRB, 0.21417030E-08_JPRB, 0.23004458E-08_JPRB, 0.24025049E-08_JPRB, 0.24500388E-08_JPRB, &
  & 0.24553641E-08_JPRB, 0.24293720E-08_JPRB, 0.23804487E-08_JPRB, 0.23164513E-08_JPRB, 0.22427418E-08_JPRB, 0.21615918E-08_JPRB, &
  & 0.20756279E-08_JPRB, 0.19855548E-08_JPRB, 0.18885313E-08_JPRB, 0.17856070E-08_JPRB, 0.16746042E-08_JPRB, 0.15595104E-08_JPRB, &
  & 0.14444432E-08_JPRB, 0.13390797E-08_JPRB, 0.12504459E-08_JPRB, 0.11830735E-08_JPRB, 0.11392676E-08_JPRB, 0.11207136E-08_JPRB, &
  & 0.11259437E-08_JPRB, 0.11528978E-08_JPRB, 0.11915336E-08_JPRB, 0.12356393E-08_JPRB, 0.12748474E-08_JPRB, 0.13002235E-08_JPRB, &
  & 0.13109946E-08_JPRB, 0.13015020E-08_JPRB, 0.12767105E-08_JPRB, 0.12453930E-08_JPRB, 0.12126181E-08_JPRB, 0.11836405E-08_JPRB, &
  & 0.11595354E-08_JPRB, 0.11453193E-08_JPRB, 0.11406220E-08_JPRB, 0.11438601E-08_JPRB, 0.11566054E-08_JPRB, 0.11773109E-08_JPRB, &
  & 0.12039487E-08_JPRB, 0.12353687E-08_JPRB, 0.12690137E-08_JPRB, 0.12992665E-08_JPRB, 0.13202491E-08_JPRB, 0.13299880E-08_JPRB, &
  & 0.13257905E-08_JPRB, 0.13041809E-08_JPRB, 0.12607155E-08_JPRB, 0.11988682E-08_JPRB, 0.11396505E-08_JPRB, 0.10800969E-08_JPRB, &
  & 0.10037730E-08_JPRB, 0.91532143E-09_JPRB, 0.86746688E-09_JPRB, 0.80485918E-09_JPRB /)

RGHG4(:,24, 9) = (/ &
  & 0.44786116E-09_JPRB, 0.51090460E-09_JPRB, 0.58945993E-09_JPRB, 0.71088591E-09_JPRB, 0.88248187E-09_JPRB, 0.11225281E-08_JPRB, &
  & 0.13808547E-08_JPRB, 0.16331593E-08_JPRB, 0.18484358E-08_JPRB, 0.20072000E-08_JPRB, 0.21022903E-08_JPRB, 0.21389823E-08_JPRB, &
  & 0.21334576E-08_JPRB, 0.20989201E-08_JPRB, 0.20464350E-08_JPRB, 0.19822715E-08_JPRB, 0.19106756E-08_JPRB, 0.18338461E-08_JPRB, &
  & 0.17522980E-08_JPRB, 0.16664957E-08_JPRB, 0.15761361E-08_JPRB, 0.14801933E-08_JPRB, 0.13785907E-08_JPRB, 0.12733689E-08_JPRB, &
  & 0.11692306E-08_JPRB, 0.10711649E-08_JPRB, 0.98561592E-09_JPRB, 0.91885216E-09_JPRB, 0.87237439E-09_JPRB, 0.84435892E-09_JPRB, &
  & 0.83359880E-09_JPRB, 0.83885876E-09_JPRB, 0.85384344E-09_JPRB, 0.87463786E-09_JPRB, 0.89583596E-09_JPRB, 0.91343100E-09_JPRB, &
  & 0.92025776E-09_JPRB, 0.91864144E-09_JPRB, 0.90874669E-09_JPRB, 0.89714702E-09_JPRB, 0.88346214E-09_JPRB, 0.87349128E-09_JPRB, &
  & 0.86649093E-09_JPRB, 0.86356938E-09_JPRB, 0.86763424E-09_JPRB, 0.87832536E-09_JPRB, 0.89485436E-09_JPRB, 0.91564950E-09_JPRB, &
  & 0.94043640E-09_JPRB, 0.96769404E-09_JPRB, 0.99445818E-09_JPRB, 0.10179226E-08_JPRB, 0.10349055E-08_JPRB, 0.10438503E-08_JPRB, &
  & 0.10415557E-08_JPRB, 0.10264705E-08_JPRB, 0.99491515E-09_JPRB, 0.96191022E-09_JPRB, 0.92518487E-09_JPRB, 0.87793062E-09_JPRB, &
  & 0.82188839E-09_JPRB, 0.74545042E-09_JPRB, 0.69889244E-09_JPRB, 0.60184818E-09_JPRB /)

RGHG4(:,25, 9) = (/ &
  & 0.35252759E-09_JPRB, 0.40306133E-09_JPRB, 0.46061119E-09_JPRB, 0.55338478E-09_JPRB, 0.68486194E-09_JPRB, 0.88030050E-09_JPRB, &
  & 0.11151904E-08_JPRB, 0.13602568E-08_JPRB, 0.15785886E-08_JPRB, 0.17411276E-08_JPRB, 0.18399866E-08_JPRB, 0.18772608E-08_JPRB, &
  & 0.18698376E-08_JPRB, 0.18327639E-08_JPRB, 0.17782655E-08_JPRB, 0.17140719E-08_JPRB, 0.16438961E-08_JPRB, 0.15695949E-08_JPRB, &
  & 0.14921616E-08_JPRB, 0.14116356E-08_JPRB, 0.13281459E-08_JPRB, 0.12409394E-08_JPRB, 0.11500032E-08_JPRB, 0.10564567E-08_JPRB, &
  & 0.96374286E-09_JPRB, 0.87756030E-09_JPRB, 0.80219315E-09_JPRB, 0.73893103E-09_JPRB, 0.68904971E-09_JPRB, 0.65398720E-09_JPRB, &
  & 0.63213884E-09_JPRB, 0.62215300E-09_JPRB, 0.61994315E-09_JPRB, 0.62368372E-09_JPRB, 0.62973821E-09_JPRB, 0.63585931E-09_JPRB, &
  & 0.64152800E-09_JPRB, 0.64493133E-09_JPRB, 0.64666145E-09_JPRB, 0.64752675E-09_JPRB, 0.64909100E-09_JPRB, 0.65191152E-09_JPRB, &
  & 0.65780786E-09_JPRB, 0.66587930E-09_JPRB, 0.67753692E-09_JPRB, 0.69308692E-09_JPRB, 0.71313527E-09_JPRB, 0.73595319E-09_JPRB, &
  & 0.76010398E-09_JPRB, 0.78474510E-09_JPRB, 0.80772899E-09_JPRB, 0.82728269E-09_JPRB, 0.84124074E-09_JPRB, 0.84778701E-09_JPRB, &
  & 0.84543950E-09_JPRB, 0.83232737E-09_JPRB, 0.81498808E-09_JPRB, 0.79355744E-09_JPRB, 0.76702478E-09_JPRB, 0.72899226E-09_JPRB, &
  & 0.67387707E-09_JPRB, 0.61574579E-09_JPRB, 0.56363453E-09_JPRB, 0.45093138E-09_JPRB /)

RGHG4(:,26, 9) = (/ &
  & 0.29878075E-09_JPRB, 0.33820430E-09_JPRB, 0.38117740E-09_JPRB, 0.44621110E-09_JPRB, 0.55160765E-09_JPRB, 0.69606670E-09_JPRB, &
  & 0.89716168E-09_JPRB, 0.11174639E-08_JPRB, 0.13261456E-08_JPRB, 0.14905371E-08_JPRB, 0.15928339E-08_JPRB, 0.16355578E-08_JPRB, &
  & 0.16329097E-08_JPRB, 0.15999997E-08_JPRB, 0.15482928E-08_JPRB, 0.14854501E-08_JPRB, 0.14166487E-08_JPRB, 0.13444628E-08_JPRB, &
  & 0.12708121E-08_JPRB, 0.11957323E-08_JPRB, 0.11192129E-08_JPRB, 0.10410248E-08_JPRB, 0.96127750E-09_JPRB, 0.88093305E-09_JPRB, &
  & 0.80198592E-09_JPRB, 0.72814293E-09_JPRB, 0.66117178E-09_JPRB, 0.60326755E-09_JPRB, 0.55613142E-09_JPRB, 0.51824811E-09_JPRB, &
  & 0.49009080E-09_JPRB, 0.47076038E-09_JPRB, 0.45768186E-09_JPRB, 0.45026091E-09_JPRB, 0.44749779E-09_JPRB, 0.44827622E-09_JPRB, &
  & 0.45183429E-09_JPRB, 0.45772361E-09_JPRB, 0.46535109E-09_JPRB, 0.47421872E-09_JPRB, 0.48479193E-09_JPRB, 0.49657012E-09_JPRB, &
  & 0.51010152E-09_JPRB, 0.52528260E-09_JPRB, 0.54255678E-09_JPRB, 0.56170540E-09_JPRB, 0.58275862E-09_JPRB, 0.60540450E-09_JPRB, &
  & 0.62901007E-09_JPRB, 0.65200834E-09_JPRB, 0.67265249E-09_JPRB, 0.68964645E-09_JPRB, 0.70151229E-09_JPRB, 0.70732409E-09_JPRB, &
  & 0.70535627E-09_JPRB, 0.69682077E-09_JPRB, 0.68506162E-09_JPRB, 0.66951078E-09_JPRB, 0.64616468E-09_JPRB, 0.61639055E-09_JPRB, &
  & 0.56778482E-09_JPRB, 0.50970450E-09_JPRB, 0.46245963E-09_JPRB, 0.35448253E-09_JPRB /)

RGHG4(:,27, 9) = (/ &
  & 0.26656785E-09_JPRB, 0.29061778E-09_JPRB, 0.33046274E-09_JPRB, 0.38063222E-09_JPRB, 0.45827342E-09_JPRB, 0.57151733E-09_JPRB, &
  & 0.72752265E-09_JPRB, 0.91509461E-09_JPRB, 0.11031176E-08_JPRB, 0.12594191E-08_JPRB, 0.13647850E-08_JPRB, 0.14136573E-08_JPRB, &
  & 0.14167176E-08_JPRB, 0.13875256E-08_JPRB, 0.13382112E-08_JPRB, 0.12775204E-08_JPRB, 0.12110722E-08_JPRB, 0.11422390E-08_JPRB, &
  & 0.10735106E-08_JPRB, 0.10046313E-08_JPRB, 0.93606423E-09_JPRB, 0.86770341E-09_JPRB, 0.79979484E-09_JPRB, 0.73250112E-09_JPRB, &
  & 0.66697714E-09_JPRB, 0.60461730E-09_JPRB, 0.54710830E-09_JPRB, 0.49602900E-09_JPRB, 0.45208384E-09_JPRB, 0.41600770E-09_JPRB, &
  & 0.38593967E-09_JPRB, 0.36187850E-09_JPRB, 0.34294081E-09_JPRB, 0.32936465E-09_JPRB, 0.32134112E-09_JPRB, 0.31870415E-09_JPRB, &
  & 0.32121455E-09_JPRB, 0.32831296E-09_JPRB, 0.33918751E-09_JPRB, 0.35287873E-09_JPRB, 0.36867309E-09_JPRB, 0.38598763E-09_JPRB, &
  & 0.40421153E-09_JPRB, 0.42360190E-09_JPRB, 0.44411316E-09_JPRB, 0.46575777E-09_JPRB, 0.48784132E-09_JPRB, 0.50999194E-09_JPRB, &
  & 0.53154692E-09_JPRB, 0.55200144E-09_JPRB, 0.57010707E-09_JPRB, 0.58478533E-09_JPRB, 0.59494881E-09_JPRB, 0.59981697E-09_JPRB, &
  & 0.59870209E-09_JPRB, 0.59495670E-09_JPRB, 0.58846983E-09_JPRB, 0.57825134E-09_JPRB, 0.56081273E-09_JPRB, 0.53675497E-09_JPRB, &
  & 0.49603277E-09_JPRB, 0.44443232E-09_JPRB, 0.40142481E-09_JPRB, 0.29168054E-09_JPRB /)

RGHG4(:,28, 9) = (/ &
  & 0.25471772E-09_JPRB, 0.26835378E-09_JPRB, 0.29939087E-09_JPRB, 0.33615921E-09_JPRB, 0.39852868E-09_JPRB, 0.48303161E-09_JPRB, &
  & 0.60547806E-09_JPRB, 0.75706652E-09_JPRB, 0.91689295E-09_JPRB, 0.10570235E-08_JPRB, 0.11566994E-08_JPRB, 0.12070751E-08_JPRB, &
  & 0.12142811E-08_JPRB, 0.11897732E-08_JPRB, 0.11449253E-08_JPRB, 0.10883250E-08_JPRB, 0.10259934E-08_JPRB, 0.96260511E-09_JPRB, &
  & 0.89953373E-09_JPRB, 0.83766327E-09_JPRB, 0.77730605E-09_JPRB, 0.71877371E-09_JPRB, 0.66218686E-09_JPRB, 0.60733324E-09_JPRB, &
  & 0.55424609E-09_JPRB, 0.50390658E-09_JPRB, 0.45726825E-09_JPRB, 0.41416842E-09_JPRB, 0.37464887E-09_JPRB, 0.33911676E-09_JPRB, &
  & 0.30842662E-09_JPRB, 0.28240776E-09_JPRB, 0.26091504E-09_JPRB, 0.24478894E-09_JPRB, 0.23446914E-09_JPRB, 0.23021948E-09_JPRB, &
  & 0.23216398E-09_JPRB, 0.23963256E-09_JPRB, 0.25199584E-09_JPRB, 0.26798688E-09_JPRB, 0.28648742E-09_JPRB, 0.30674377E-09_JPRB, &
  & 0.32758649E-09_JPRB, 0.34909897E-09_JPRB, 0.37097189E-09_JPRB, 0.39306014E-09_JPRB, 0.41479128E-09_JPRB, 0.43586151E-09_JPRB, &
  & 0.45578416E-09_JPRB, 0.47394183E-09_JPRB, 0.48975474E-09_JPRB, 0.50260801E-09_JPRB, 0.51166360E-09_JPRB, 0.51673726E-09_JPRB, &
  & 0.51753618E-09_JPRB, 0.51616572E-09_JPRB, 0.51182725E-09_JPRB, 0.50228055E-09_JPRB, 0.48831222E-09_JPRB, 0.46593795E-09_JPRB, &
  & 0.42734230E-09_JPRB, 0.37966782E-09_JPRB, 0.32577202E-09_JPRB, 0.23321911E-09_JPRB /)

RGHG4(:,29, 9) = (/ &
  & 0.24515673E-09_JPRB, 0.25249805E-09_JPRB, 0.27632810E-09_JPRB, 0.30534356E-09_JPRB, 0.35054845E-09_JPRB, 0.41678655E-09_JPRB, &
  & 0.50928833E-09_JPRB, 0.63064670E-09_JPRB, 0.76232326E-09_JPRB, 0.88269497E-09_JPRB, 0.97148578E-09_JPRB, 0.10193110E-08_JPRB, &
  & 0.10284517E-08_JPRB, 0.10078862E-08_JPRB, 0.96774266E-09_JPRB, 0.91611657E-09_JPRB, 0.85929053E-09_JPRB, 0.80201273E-09_JPRB, &
  & 0.74520312E-09_JPRB, 0.69053124E-09_JPRB, 0.63833838E-09_JPRB, 0.58900534E-09_JPRB, 0.54249977E-09_JPRB, 0.49842935E-09_JPRB, &
  & 0.45638224E-09_JPRB, 0.41672213E-09_JPRB, 0.37888914E-09_JPRB, 0.34254818E-09_JPRB, 0.30845315E-09_JPRB, 0.27623287E-09_JPRB, &
  & 0.24661531E-09_JPRB, 0.22080786E-09_JPRB, 0.19908440E-09_JPRB, 0.18255997E-09_JPRB, 0.17181007E-09_JPRB, 0.16721743E-09_JPRB, &
  & 0.16892762E-09_JPRB, 0.17647532E-09_JPRB, 0.18912399E-09_JPRB, 0.20582271E-09_JPRB, 0.22532372E-09_JPRB, 0.24666524E-09_JPRB, &
  & 0.26867353E-09_JPRB, 0.29089825E-09_JPRB, 0.31313788E-09_JPRB, 0.33490258E-09_JPRB, 0.35589195E-09_JPRB, 0.37584391E-09_JPRB, &
  & 0.39454082E-09_JPRB, 0.41126327E-09_JPRB, 0.42537396E-09_JPRB, 0.43666859E-09_JPRB, 0.44482959E-09_JPRB, 0.44964585E-09_JPRB, &
  & 0.45174223E-09_JPRB, 0.45182613E-09_JPRB, 0.44855189E-09_JPRB, 0.44057202E-09_JPRB, 0.42761095E-09_JPRB, 0.40457565E-09_JPRB, &
  & 0.37458561E-09_JPRB, 0.33342912E-09_JPRB, 0.29082245E-09_JPRB, 0.20697932E-09_JPRB /)

RGHG4(:,30, 9) = (/ &
  & 0.24231353E-09_JPRB, 0.24254806E-09_JPRB, 0.26097635E-09_JPRB, 0.28116579E-09_JPRB, 0.31562880E-09_JPRB, 0.36755432E-09_JPRB, &
  & 0.44058379E-09_JPRB, 0.53647303E-09_JPRB, 0.64437666E-09_JPRB, 0.74522338E-09_JPRB, 0.82074569E-09_JPRB, 0.86175983E-09_JPRB, &
  & 0.86924973E-09_JPRB, 0.85046686E-09_JPRB, 0.81417001E-09_JPRB, 0.76753182E-09_JPRB, 0.71672196E-09_JPRB, 0.66533745E-09_JPRB, &
  & 0.61515670E-09_JPRB, 0.56741389E-09_JPRB, 0.52268340E-09_JPRB, 0.48115295E-09_JPRB, 0.44271692E-09_JPRB, 0.40707412E-09_JPRB, &
  & 0.37367642E-09_JPRB, 0.34206937E-09_JPRB, 0.31164685E-09_JPRB, 0.28170979E-09_JPRB, 0.25225513E-09_JPRB, 0.22370200E-09_JPRB, &
  & 0.19656744E-09_JPRB, 0.17231638E-09_JPRB, 0.15187576E-09_JPRB, 0.13626790E-09_JPRB, 0.12629310E-09_JPRB, 0.12217022E-09_JPRB, &
  & 0.12394177E-09_JPRB, 0.13140990E-09_JPRB, 0.14363702E-09_JPRB, 0.16005057E-09_JPRB, 0.17960912E-09_JPRB, 0.20081853E-09_JPRB, &
  & 0.22306842E-09_JPRB, 0.24510971E-09_JPRB, 0.26695607E-09_JPRB, 0.28809466E-09_JPRB, 0.30792613E-09_JPRB, 0.32652098E-09_JPRB, &
  & 0.34347961E-09_JPRB, 0.35842504E-09_JPRB, 0.37112760E-09_JPRB, 0.38135917E-09_JPRB, 0.38876441E-09_JPRB, 0.39383216E-09_JPRB, &
  & 0.39682560E-09_JPRB, 0.39783987E-09_JPRB, 0.39622641E-09_JPRB, 0.39042669E-09_JPRB, 0.38060044E-09_JPRB, 0.36150863E-09_JPRB, &
  & 0.33434655E-09_JPRB, 0.29698793E-09_JPRB, 0.24873639E-09_JPRB, 0.16884552E-09_JPRB /)

RGHG4(:,31, 9) = (/ &
  & 0.23890068E-09_JPRB, 0.23489674E-09_JPRB, 0.24801702E-09_JPRB, 0.26404631E-09_JPRB, 0.28964622E-09_JPRB, 0.33162517E-09_JPRB, &
  & 0.38910219E-09_JPRB, 0.46491744E-09_JPRB, 0.55280780E-09_JPRB, 0.63469752E-09_JPRB, 0.69610429E-09_JPRB, 0.72852102E-09_JPRB, &
  & 0.73264367E-09_JPRB, 0.71446554E-09_JPRB, 0.68136846E-09_JPRB, 0.63979033E-09_JPRB, 0.59455818E-09_JPRB, 0.54902988E-09_JPRB, &
  & 0.50475890E-09_JPRB, 0.46302720E-09_JPRB, 0.42432574E-09_JPRB, 0.38881426E-09_JPRB, 0.35678480E-09_JPRB, 0.32751260E-09_JPRB, &
  & 0.30079395E-09_JPRB, 0.27556266E-09_JPRB, 0.25102664E-09_JPRB, 0.22668890E-09_JPRB, 0.20198045E-09_JPRB, 0.17734848E-09_JPRB, &
  & 0.15344676E-09_JPRB, 0.13174484E-09_JPRB, 0.11360136E-09_JPRB, 0.99788337E-10_JPRB, 0.91227914E-10_JPRB, 0.87889258E-10_JPRB, &
  & 0.89785006E-10_JPRB, 0.96905504E-10_JPRB, 0.10826622E-09_JPRB, 0.12375412E-09_JPRB, 0.14238355E-09_JPRB, 0.16298848E-09_JPRB, &
  & 0.18441414E-09_JPRB, 0.20597551E-09_JPRB, 0.22704208E-09_JPRB, 0.24732180E-09_JPRB, 0.26622202E-09_JPRB, 0.28354591E-09_JPRB, &
  & 0.29906527E-09_JPRB, 0.31248087E-09_JPRB, 0.32388492E-09_JPRB, 0.33334491E-09_JPRB, 0.34080785E-09_JPRB, 0.34637487E-09_JPRB, &
  & 0.35029174E-09_JPRB, 0.35230763E-09_JPRB, 0.35125994E-09_JPRB, 0.34781536E-09_JPRB, 0.33899231E-09_JPRB, 0.32057332E-09_JPRB, &
  & 0.29474576E-09_JPRB, 0.25893737E-09_JPRB, 0.21763993E-09_JPRB, 0.15076818E-09_JPRB /)

RGHG4(:,32, 9) = (/ &
  & 0.24086805E-09_JPRB, 0.23186850E-09_JPRB, 0.24106667E-09_JPRB, 0.25255617E-09_JPRB, 0.27390892E-09_JPRB, 0.30752728E-09_JPRB, &
  & 0.35450745E-09_JPRB, 0.41627443E-09_JPRB, 0.48716164E-09_JPRB, 0.55226046E-09_JPRB, 0.59933225E-09_JPRB, 0.62213762E-09_JPRB, &
  & 0.62172129E-09_JPRB, 0.60306588E-09_JPRB, 0.57246846E-09_JPRB, 0.53514126E-09_JPRB, 0.49490162E-09_JPRB, 0.45451290E-09_JPRB, &
  & 0.41553752E-09_JPRB, 0.37876347E-09_JPRB, 0.34511174E-09_JPRB, 0.31457636E-09_JPRB, 0.28708744E-09_JPRB, 0.26255884E-09_JPRB, &
  & 0.24025212E-09_JPRB, 0.21946607E-09_JPRB, 0.19936555E-09_JPRB, 0.17919254E-09_JPRB, 0.15846381E-09_JPRB, 0.13747715E-09_JPRB, &
  & 0.11709728E-09_JPRB, 0.98473819E-10_JPRB, 0.83112406E-10_JPRB, 0.71509493E-10_JPRB, 0.64608249E-10_JPRB, 0.62171338E-10_JPRB, &
  & 0.64252763E-10_JPRB, 0.70828711E-10_JPRB, 0.81173492E-10_JPRB, 0.95265441E-10_JPRB, 0.11226457E-09_JPRB, 0.13165773E-09_JPRB, &
  & 0.15196452E-09_JPRB, 0.17242083E-09_JPRB, 0.19260618E-09_JPRB, 0.21192217E-09_JPRB, 0.22963964E-09_JPRB, 0.24594843E-09_JPRB, &
  & 0.26039934E-09_JPRB, 0.27294980E-09_JPRB, 0.28360653E-09_JPRB, 0.29255595E-09_JPRB, 0.29986139E-09_JPRB, 0.30568958E-09_JPRB, &
  & 0.31050298E-09_JPRB, 0.31346506E-09_JPRB, 0.31373767E-09_JPRB, 0.31101383E-09_JPRB, 0.30306069E-09_JPRB, 0.28688393E-09_JPRB, &
  & 0.26140637E-09_JPRB, 0.23211577E-09_JPRB, 0.19253490E-09_JPRB, 0.12787546E-09_JPRB /)

RGHG4(:,33, 9) = (/ &
  & 0.24250804E-09_JPRB, 0.23137200E-09_JPRB, 0.23771607E-09_JPRB, 0.24649460E-09_JPRB, 0.26329289E-09_JPRB, 0.29158256E-09_JPRB, &
  & 0.33045028E-09_JPRB, 0.38065567E-09_JPRB, 0.43611292E-09_JPRB, 0.48588378E-09_JPRB, 0.51986176E-09_JPRB, 0.53387927E-09_JPRB, &
  & 0.52907073E-09_JPRB, 0.50998555E-09_JPRB, 0.48155846E-09_JPRB, 0.44809398E-09_JPRB, 0.41232792E-09_JPRB, 0.37643200E-09_JPRB, &
  & 0.34160030E-09_JPRB, 0.30893288E-09_JPRB, 0.27860558E-09_JPRB, 0.25111138E-09_JPRB, 0.22683622E-09_JPRB, 0.20546632E-09_JPRB, &
  & 0.18633423E-09_JPRB, 0.16891122E-09_JPRB, 0.15234888E-09_JPRB, 0.13589417E-09_JPRB, 0.11892522E-09_JPRB, 0.10169209E-09_JPRB, &
  & 0.85131777E-10_JPRB, 0.70032646E-10_JPRB, 0.57884027E-10_JPRB, 0.48902379E-10_JPRB, 0.43820822E-10_JPRB, 0.42303938E-10_JPRB, &
  & 0.44404692E-10_JPRB, 0.50142241E-10_JPRB, 0.59102057E-10_JPRB, 0.71444593E-10_JPRB, 0.86320590E-10_JPRB, 0.10403670E-09_JPRB, &
  & 0.12290061E-09_JPRB, 0.14207756E-09_JPRB, 0.16105607E-09_JPRB, 0.17952645E-09_JPRB, 0.19645376E-09_JPRB, 0.21179464E-09_JPRB, &
  & 0.22539588E-09_JPRB, 0.23714977E-09_JPRB, 0.24739205E-09_JPRB, 0.25611904E-09_JPRB, 0.26377875E-09_JPRB, 0.27014843E-09_JPRB, &
  & 0.27565339E-09_JPRB, 0.27956842E-09_JPRB, 0.28067151E-09_JPRB, 0.27914901E-09_JPRB, 0.27183722E-09_JPRB, 0.25866950E-09_JPRB, &
  & 0.23524999E-09_JPRB, 0.20670939E-09_JPRB, 0.16750394E-09_JPRB, 0.11314864E-09_JPRB /)

RGHG4(:,34, 9) = (/ &
  & 0.24871952E-09_JPRB, 0.23379848E-09_JPRB, 0.23826285E-09_JPRB, 0.24413702E-09_JPRB, 0.25832680E-09_JPRB, 0.28065297E-09_JPRB, &
  & 0.31386924E-09_JPRB, 0.35450251E-09_JPRB, 0.39723269E-09_JPRB, 0.43363491E-09_JPRB, 0.45619503E-09_JPRB, 0.46241880E-09_JPRB, &
  & 0.45410717E-09_JPRB, 0.43483844E-09_JPRB, 0.40840228E-09_JPRB, 0.37807243E-09_JPRB, 0.34606590E-09_JPRB, 0.31380781E-09_JPRB, &
  & 0.28240757E-09_JPRB, 0.25261407E-09_JPRB, 0.22473347E-09_JPRB, 0.19981553E-09_JPRB, 0.17774890E-09_JPRB, 0.15840142E-09_JPRB, &
  & 0.14148474E-09_JPRB, 0.12645698E-09_JPRB, 0.11254842E-09_JPRB, 0.99004936E-10_JPRB, 0.85387829E-10_JPRB, 0.71662593E-10_JPRB, &
  & 0.58795795E-10_JPRB, 0.47333075E-10_JPRB, 0.38322467E-10_JPRB, 0.32009846E-10_JPRB, 0.28593298E-10_JPRB, 0.27865953E-10_JPRB, &
  & 0.29815820E-10_JPRB, 0.34533158E-10_JPRB, 0.42000063E-10_JPRB, 0.52211829E-10_JPRB, 0.65065842E-10_JPRB, 0.80599048E-10_JPRB, &
  & 0.97565934E-10_JPRB, 0.11544582E-09_JPRB, 0.13300651E-09_JPRB, 0.15037285E-09_JPRB, 0.16678679E-09_JPRB, 0.18125768E-09_JPRB, &
  & 0.19437942E-09_JPRB, 0.20574810E-09_JPRB, 0.21570004E-09_JPRB, 0.22436628E-09_JPRB, 0.23229393E-09_JPRB, 0.23913665E-09_JPRB, &
  & 0.24518873E-09_JPRB, 0.25017055E-09_JPRB, 0.25282343E-09_JPRB, 0.25246377E-09_JPRB, 0.24575209E-09_JPRB, 0.23327706E-09_JPRB, &
  & 0.21126170E-09_JPRB, 0.18492631E-09_JPRB, 0.14948985E-09_JPRB, 0.99336560E-10_JPRB /)

RGHG4(:,35, 9) = (/ &
  & 0.25416030E-09_JPRB, 0.23622504E-09_JPRB, 0.23946661E-09_JPRB, 0.24383165E-09_JPRB, 0.25493410E-09_JPRB, 0.27336455E-09_JPRB, &
  & 0.30042449E-09_JPRB, 0.33214079E-09_JPRB, 0.36366929E-09_JPRB, 0.38828141E-09_JPRB, 0.40132933E-09_JPRB, 0.40164855E-09_JPRB, &
  & 0.39077069E-09_JPRB, 0.37174802E-09_JPRB, 0.34728526E-09_JPRB, 0.31989503E-09_JPRB, 0.29115763E-09_JPRB, 0.26180882E-09_JPRB, &
  & 0.23312774E-09_JPRB, 0.20534902E-09_JPRB, 0.17935900E-09_JPRB, 0.15576621E-09_JPRB, 0.13491376E-09_JPRB, 0.11695982E-09_JPRB, &
  & 0.10175859E-09_JPRB, 0.88778734E-10_JPRB, 0.77343368E-10_JPRB, 0.66614089E-10_JPRB, 0.56352031E-10_JPRB, 0.46263503E-10_JPRB, &
  & 0.37109572E-10_JPRB, 0.29292908E-10_JPRB, 0.23348849E-10_JPRB, 0.19396769E-10_JPRB, 0.17402406E-10_JPRB, 0.17222744E-10_JPRB, &
  & 0.18870629E-10_JPRB, 0.22509501E-10_JPRB, 0.28281653E-10_JPRB, 0.36303561E-10_JPRB, 0.46845475E-10_JPRB, 0.60032472E-10_JPRB, &
  & 0.74961412E-10_JPRB, 0.91098851E-10_JPRB, 0.10729791E-09_JPRB, 0.12369654E-09_JPRB, 0.13948073E-09_JPRB, 0.15330151E-09_JPRB, &
  & 0.16587025E-09_JPRB, 0.17703509E-09_JPRB, 0.18681869E-09_JPRB, 0.19552479E-09_JPRB, 0.20352731E-09_JPRB, 0.21095987E-09_JPRB, &
  & 0.21751441E-09_JPRB, 0.22277105E-09_JPRB, 0.22593508E-09_JPRB, 0.22548893E-09_JPRB, 0.21934701E-09_JPRB, 0.20813908E-09_JPRB, &
  & 0.18848297E-09_JPRB, 0.16444689E-09_JPRB, 0.13169217E-09_JPRB, 0.88303427E-10_JPRB /)

RGHG4(:,36, 9) = (/ &
  & 0.25119848E-09_JPRB, 0.23922198E-09_JPRB, 0.24056310E-09_JPRB, 0.24354971E-09_JPRB, 0.25269858E-09_JPRB, 0.26751287E-09_JPRB, &
  & 0.28891878E-09_JPRB, 0.31285577E-09_JPRB, 0.33466427E-09_JPRB, 0.34980840E-09_JPRB, 0.35556422E-09_JPRB, 0.35138703E-09_JPRB, &
  & 0.33892694E-09_JPRB, 0.32043831E-09_JPRB, 0.29793654E-09_JPRB, 0.27300837E-09_JPRB, 0.24711366E-09_JPRB, 0.22039932E-09_JPRB, &
  & 0.19374646E-09_JPRB, 0.16790451E-09_JPRB, 0.14316055E-09_JPRB, 0.12042667E-09_JPRB, 0.10051533E-09_JPRB, 0.83758583E-10_JPRB, &
  & 0.70223313E-10_JPRB, 0.59145903E-10_JPRB, 0.50006776E-10_JPRB, 0.41868582E-10_JPRB, 0.34530986E-10_JPRB, 0.27705888E-10_JPRB, &
  & 0.21736217E-10_JPRB, 0.16894491E-10_JPRB, 0.13358112E-10_JPRB, 0.11119228E-10_JPRB, 0.10085303E-10_JPRB, 0.10169418E-10_JPRB, &
  & 0.11427506E-10_JPRB, 0.14041312E-10_JPRB, 0.18204091E-10_JPRB, 0.24180142E-10_JPRB, 0.32550782E-10_JPRB, 0.43424087E-10_JPRB, &
  & 0.56054442E-10_JPRB, 0.70147319E-10_JPRB, 0.85095812E-10_JPRB, 0.10049863E-09_JPRB, 0.11525211E-09_JPRB, 0.12883017E-09_JPRB, &
  & 0.14104153E-09_JPRB, 0.15225499E-09_JPRB, 0.16201493E-09_JPRB, 0.17089109E-09_JPRB, 0.17908589E-09_JPRB, 0.18667298E-09_JPRB, &
  & 0.19325175E-09_JPRB, 0.19844777E-09_JPRB, 0.20135228E-09_JPRB, 0.20081967E-09_JPRB, 0.19521723E-09_JPRB, 0.18494657E-09_JPRB, &
  & 0.16676960E-09_JPRB, 0.14364145E-09_JPRB, 0.11544882E-09_JPRB, 0.78209064E-10_JPRB /)

RGHG4(:,37, 9) = (/ &
  & 0.25193186E-09_JPRB, 0.23931318E-09_JPRB, 0.23860700E-09_JPRB, 0.24044300E-09_JPRB, 0.24747004E-09_JPRB, 0.25927979E-09_JPRB, &
  & 0.27550379E-09_JPRB, 0.29206859E-09_JPRB, 0.30578395E-09_JPRB, 0.31353756E-09_JPRB, 0.31387140E-09_JPRB, 0.30693903E-09_JPRB, &
  & 0.29386815E-09_JPRB, 0.27643030E-09_JPRB, 0.25599178E-09_JPRB, 0.23365024E-09_JPRB, 0.21001105E-09_JPRB, 0.18602946E-09_JPRB, &
  & 0.16109515E-09_JPRB, 0.13631844E-09_JPRB, 0.11265275E-09_JPRB, 0.90842806E-10_JPRB, 0.72180838E-10_JPRB, 0.57143484E-10_JPRB, &
  & 0.45628425E-10_JPRB, 0.36832003E-10_JPRB, 0.29979585E-10_JPRB, 0.24340918E-10_JPRB, 0.19540047E-10_JPRB, 0.15368764E-10_JPRB, &
  & 0.11895341E-10_JPRB, 0.92021651E-11_JPRB, 0.73177471E-11_JPRB, 0.61764053E-11_JPRB, 0.57044330E-11_JPRB, 0.58558150E-11_JPRB, &
  & 0.66901653E-11_JPRB, 0.83629857E-11_JPRB, 0.11045854E-10_JPRB, 0.15129625E-10_JPRB, 0.21277346E-10_JPRB, 0.29547895E-10_JPRB, &
  & 0.39758349E-10_JPRB, 0.52000831E-10_JPRB, 0.65479157E-10_JPRB, 0.79537057E-10_JPRB, 0.93326243E-10_JPRB, 0.10646589E-09_JPRB, &
  & 0.11840301E-09_JPRB, 0.12928673E-09_JPRB, 0.13904744E-09_JPRB, 0.14790974E-09_JPRB, 0.15609743E-09_JPRB, 0.16367104E-09_JPRB, &
  & 0.17023745E-09_JPRB, 0.17493601E-09_JPRB, 0.17744604E-09_JPRB, 0.17701486E-09_JPRB, 0.17219562E-09_JPRB, 0.16329291E-09_JPRB, &
  & 0.14774257E-09_JPRB, 0.12756907E-09_JPRB, 0.10286645E-09_JPRB, 0.69872365E-10_JPRB /)

RGHG4(:,38, 9) = (/ &
  & 0.25125327E-09_JPRB, 0.23483543E-09_JPRB, 0.23054930E-09_JPRB, 0.23355892E-09_JPRB, 0.23929661E-09_JPRB, 0.24821420E-09_JPRB, &
  & 0.25919925E-09_JPRB, 0.27015595E-09_JPRB, 0.27740138E-09_JPRB, 0.27980576E-09_JPRB, 0.27667010E-09_JPRB, 0.26827240E-09_JPRB, &
  & 0.25550345E-09_JPRB, 0.23942714E-09_JPRB, 0.22100330E-09_JPRB, 0.20104797E-09_JPRB, 0.17965868E-09_JPRB, 0.15731939E-09_JPRB, &
  & 0.13459335E-09_JPRB, 0.11133246E-09_JPRB, 0.88806060E-10_JPRB, 0.68576519E-10_JPRB, 0.51884920E-10_JPRB, 0.39150943E-10_JPRB, &
  & 0.30013179E-10_JPRB, 0.23428759E-10_JPRB, 0.18538691E-10_JPRB, 0.14708722E-10_JPRB, 0.11604948E-10_JPRB, 0.90387784E-11_JPRB, &
  & 0.69880182E-11_JPRB, 0.54540769E-11_JPRB, 0.44122392E-11_JPRB, 0.38085034E-11_JPRB, 0.35896193E-11_JPRB, 0.37267581E-11_JPRB, &
  & 0.42644725E-11_JPRB, 0.52960830E-11_JPRB, 0.69494631E-11_JPRB, 0.95819888E-11_JPRB, 0.13725868E-10_JPRB, 0.19548207E-10_JPRB, &
  & 0.27442689E-10_JPRB, 0.37473292E-10_JPRB, 0.49026790E-10_JPRB, 0.61600086E-10_JPRB, 0.74523054E-10_JPRB, 0.87168640E-10_JPRB, &
  & 0.98884921E-10_JPRB, 0.10971102E-09_JPRB, 0.11952703E-09_JPRB, 0.12845154E-09_JPRB, 0.13664643E-09_JPRB, 0.14395195E-09_JPRB, &
  & 0.14981996E-09_JPRB, 0.15398935E-09_JPRB, 0.15628472E-09_JPRB, 0.15593682E-09_JPRB, 0.15189007E-09_JPRB, 0.14436560E-09_JPRB, &
  & 0.13084758E-09_JPRB, 0.11305168E-09_JPRB, 0.90915046E-10_JPRB, 0.62797240E-10_JPRB /)

RGHG4(:,39, 9) = (/ &
  & 0.24313759E-09_JPRB, 0.22605251E-09_JPRB, 0.22117015E-09_JPRB, 0.22332446E-09_JPRB, 0.22750452E-09_JPRB, 0.23373045E-09_JPRB, &
  & 0.24052671E-09_JPRB, 0.24623698E-09_JPRB, 0.24857891E-09_JPRB, 0.24747143E-09_JPRB, 0.24233435E-09_JPRB, 0.23353827E-09_JPRB, &
  & 0.22161833E-09_JPRB, 0.20732087E-09_JPRB, 0.19109542E-09_JPRB, 0.17341222E-09_JPRB, 0.15455602E-09_JPRB, 0.13431624E-09_JPRB, &
  & 0.11319459E-09_JPRB, 0.91699474E-10_JPRB, 0.71099120E-10_JPRB, 0.52920231E-10_JPRB, 0.38616978E-10_JPRB, 0.28298882E-10_JPRB, &
  & 0.21178148E-10_JPRB, 0.16248874E-10_JPRB, 0.12675132E-10_JPRB, 0.99471143E-11_JPRB, 0.77944829E-11_JPRB, 0.60725999E-11_JPRB, &
  & 0.47265286E-11_JPRB, 0.37460833E-11_JPRB, 0.30922051E-11_JPRB, 0.27319935E-11_JPRB, 0.26190703E-11_JPRB, 0.27381116E-11_JPRB, &
  & 0.31115050E-11_JPRB, 0.37963417E-11_JPRB, 0.48639140E-11_JPRB, 0.65713819E-11_JPRB, 0.92899985E-11_JPRB, 0.13202299E-10_JPRB, &
  & 0.18888254E-10_JPRB, 0.26508989E-10_JPRB, 0.35860613E-10_JPRB, 0.46740053E-10_JPRB, 0.58435402E-10_JPRB, 0.70182658E-10_JPRB, &
  & 0.81431230E-10_JPRB, 0.91995397E-10_JPRB, 0.10157595E-09_JPRB, 0.11025467E-09_JPRB, 0.11797653E-09_JPRB, 0.12474158E-09_JPRB, &
  & 0.13015374E-09_JPRB, 0.13392412E-09_JPRB, 0.13594076E-09_JPRB, 0.13580451E-09_JPRB, 0.13262794E-09_JPRB, 0.12646949E-09_JPRB, &
  & 0.11533356E-09_JPRB, 0.10049698E-09_JPRB, 0.81531205E-10_JPRB, 0.56795655E-10_JPRB /)

RGHG4(:,40, 9) = (/ &
  & 0.23174269E-09_JPRB, 0.21336215E-09_JPRB, 0.20816539E-09_JPRB, 0.20916811E-09_JPRB, 0.21213356E-09_JPRB, 0.21589852E-09_JPRB, &
  & 0.21922915E-09_JPRB, 0.22113349E-09_JPRB, 0.22007249E-09_JPRB, 0.21691203E-09_JPRB, 0.21103691E-09_JPRB, 0.20262475E-09_JPRB, &
  & 0.19198514E-09_JPRB, 0.17947623E-09_JPRB, 0.16544106E-09_JPRB, 0.14999889E-09_JPRB, 0.13323144E-09_JPRB, 0.11530061E-09_JPRB, &
  & 0.96216070E-10_JPRB, 0.76790789E-10_JPRB, 0.58216806E-10_JPRB, 0.42434483E-10_JPRB, 0.30381187E-10_JPRB, 0.21955916E-10_JPRB, &
  & 0.16294197E-10_JPRB, 0.12422082E-10_JPRB, 0.96433000E-11_JPRB, 0.75497074E-11_JPRB, 0.59143840E-11_JPRB, 0.46290975E-11_JPRB, &
  & 0.36353995E-11_JPRB, 0.29240939E-11_JPRB, 0.24555100E-11_JPRB, 0.22112355E-11_JPRB, 0.21472893E-11_JPRB, 0.22552032E-11_JPRB, &
  & 0.25453131E-11_JPRB, 0.30505357E-11_JPRB, 0.38121095E-11_JPRB, 0.50014159E-11_JPRB, 0.68620227E-11_JPRB, 0.95197652E-11_JPRB, &
  & 0.13496353E-10_JPRB, 0.18975576E-10_JPRB, 0.26120744E-10_JPRB, 0.35020143E-10_JPRB, 0.45112192E-10_JPRB, 0.55809756E-10_JPRB, &
  & 0.66536859E-10_JPRB, 0.76773109E-10_JPRB, 0.86138381E-10_JPRB, 0.94627271E-10_JPRB, 0.10204160E-09_JPRB, 0.10829585E-09_JPRB, &
  & 0.11307338E-09_JPRB, 0.11635578E-09_JPRB, 0.11816521E-09_JPRB, 0.11788261E-09_JPRB, 0.11556023E-09_JPRB, 0.11056981E-09_JPRB, &
  & 0.10135173E-09_JPRB, 0.88712239E-10_JPRB, 0.72305099E-10_JPRB, 0.50902973E-10_JPRB /)

RGHG4(:,41, 9) = (/ &
  & 0.21790565E-09_JPRB, 0.19888353E-09_JPRB, 0.19282005E-09_JPRB, 0.19311545E-09_JPRB, 0.19475888E-09_JPRB, 0.19644603E-09_JPRB, &
  & 0.19715589E-09_JPRB, 0.19628979E-09_JPRB, 0.19289284E-09_JPRB, 0.18873268E-09_JPRB, 0.18275610E-09_JPRB, 0.17507239E-09_JPRB, &
  & 0.16580186E-09_JPRB, 0.15510253E-09_JPRB, 0.14309341E-09_JPRB, 0.12986939E-09_JPRB, 0.11535636E-09_JPRB, 0.99494184E-10_JPRB, &
  & 0.82659372E-10_JPRB, 0.65265002E-10_JPRB, 0.49029763E-10_JPRB, 0.35324063E-10_JPRB, 0.25160941E-10_JPRB, 0.18169738E-10_JPRB, &
  & 0.13495277E-10_JPRB, 0.10300405E-10_JPRB, 0.80044730E-11_JPRB, 0.62749953E-11_JPRB, 0.49286807E-11_JPRB, 0.38761607E-11_JPRB, &
  & 0.30689045E-11_JPRB, 0.24931127E-11_JPRB, 0.21234147E-11_JPRB, 0.19365620E-11_JPRB, 0.19009503E-11_JPRB, 0.20030212E-11_JPRB, &
  & 0.22488986E-11_JPRB, 0.26609750E-11_JPRB, 0.32581641E-11_JPRB, 0.41539597E-11_JPRB, 0.55330272E-11_JPRB, 0.74248385E-11_JPRB, &
  & 0.10255591E-10_JPRB, 0.14149684E-10_JPRB, 0.19411372E-10_JPRB, 0.26263833E-10_JPRB, 0.34591996E-10_JPRB, 0.43973179E-10_JPRB, &
  & 0.53823498E-10_JPRB, 0.63472373E-10_JPRB, 0.72411875E-10_JPRB, 0.80469451E-10_JPRB, 0.87264487E-10_JPRB, 0.92751425E-10_JPRB, &
  & 0.96916003E-10_JPRB, 0.99882165E-10_JPRB, 0.10151945E-09_JPRB, 0.10144099E-09_JPRB, 0.99761262E-10_JPRB, 0.95838053E-10_JPRB, &
  & 0.88350237E-10_JPRB, 0.78045084E-10_JPRB, 0.64255649E-10_JPRB, 0.46631237E-10_JPRB /)

RGHG4(:,42, 9) = (/ &
  & 0.20007496E-09_JPRB, 0.18099704E-09_JPRB, 0.17475134E-09_JPRB, 0.17399601E-09_JPRB, 0.17477819E-09_JPRB, 0.17509015E-09_JPRB, &
  & 0.17412592E-09_JPRB, 0.17154680E-09_JPRB, 0.16701671E-09_JPRB, 0.16265650E-09_JPRB, 0.15709105E-09_JPRB, 0.15034443E-09_JPRB, &
  & 0.14244640E-09_JPRB, 0.13343304E-09_JPRB, 0.12333611E-09_JPRB, 0.11210963E-09_JPRB, 0.99694773E-10_JPRB, 0.86013252E-10_JPRB, &
  & 0.71168745E-10_JPRB, 0.56009097E-10_JPRB, 0.41737492E-10_JPRB, 0.30045404E-10_JPRB, 0.21439163E-10_JPRB, 0.15556827E-10_JPRB, &
  & 0.11612860E-10_JPRB, 0.88973022E-11_JPRB, 0.69388262E-11_JPRB, 0.54567470E-11_JPRB, 0.43056604E-11_JPRB, 0.33981088E-11_JPRB, &
  & 0.27130295E-11_JPRB, 0.22165468E-11_JPRB, 0.19124739E-11_JPRB, 0.17571257E-11_JPRB, 0.17422281E-11_JPRB, 0.18379367E-11_JPRB, &
  & 0.20555686E-11_JPRB, 0.24096922E-11_JPRB, 0.28990478E-11_JPRB, 0.36159799E-11_JPRB, 0.46837399E-11_JPRB, 0.60888668E-11_JPRB, &
  & 0.81497465E-11_JPRB, 0.10925003E-10_JPRB, 0.14673882E-10_JPRB, 0.19794026E-10_JPRB, 0.26334429E-10_JPRB, 0.34287625E-10_JPRB, &
  & 0.43092762E-10_JPRB, 0.51978057E-10_JPRB, 0.60391366E-10_JPRB, 0.67950222E-10_JPRB, 0.74239219E-10_JPRB, 0.79259231E-10_JPRB, &
  & 0.82949751E-10_JPRB, 0.85550809E-10_JPRB, 0.87058014E-10_JPRB, 0.87115648E-10_JPRB, 0.85835228E-10_JPRB, 0.82713926E-10_JPRB, &
  & 0.76731718E-10_JPRB, 0.68261508E-10_JPRB, 0.56811285E-10_JPRB, 0.42406453E-10_JPRB /)

RGHG4(:,43, 9) = (/ &
  & 0.17974090E-09_JPRB, 0.16117523E-09_JPRB, 0.15478965E-09_JPRB, 0.15359078E-09_JPRB, 0.15384628E-09_JPRB, 0.15336962E-09_JPRB, &
  & 0.15152880E-09_JPRB, 0.14824625E-09_JPRB, 0.14294976E-09_JPRB, 0.13878458E-09_JPRB, 0.13382435E-09_JPRB, 0.12803253E-09_JPRB, &
  & 0.12137689E-09_JPRB, 0.11381469E-09_JPRB, 0.10539263E-09_JPRB, 0.96000610E-10_JPRB, 0.85541428E-10_JPRB, 0.73834071E-10_JPRB, &
  & 0.61134299E-10_JPRB, 0.47921847E-10_JPRB, 0.35792262E-10_JPRB, 0.25855885E-10_JPRB, 0.18638495E-10_JPRB, 0.13670173E-10_JPRB, &
  & 0.10297939E-10_JPRB, 0.79400913E-11_JPRB, 0.62251653E-11_JPRB, 0.49135379E-11_JPRB, 0.38963411E-11_JPRB, 0.30837232E-11_JPRB, &
  & 0.24787130E-11_JPRB, 0.20315177E-11_JPRB, 0.17708651E-11_JPRB, 0.16343175E-11_JPRB, 0.16343579E-11_JPRB, 0.17241005E-11_JPRB, &
  & 0.19230531E-11_JPRB, 0.22397034E-11_JPRB, 0.26585700E-11_JPRB, 0.32590456E-11_JPRB, 0.41226792E-11_JPRB, 0.52132192E-11_JPRB, &
  & 0.67572536E-11_JPRB, 0.87542794E-11_JPRB, 0.11427593E-10_JPRB, 0.15112321E-10_JPRB, 0.20081947E-10_JPRB, 0.26514645E-10_JPRB, &
  & 0.34045863E-10_JPRB, 0.41999546E-10_JPRB, 0.49672516E-10_JPRB, 0.56512815E-10_JPRB, 0.62098562E-10_JPRB, 0.66445092E-10_JPRB, &
  & 0.69651541E-10_JPRB, 0.71955553E-10_JPRB, 0.73356828E-10_JPRB, 0.73605851E-10_JPRB, 0.72816975E-10_JPRB, 0.70535681E-10_JPRB, &
  & 0.65923565E-10_JPRB, 0.59326793E-10_JPRB, 0.50076589E-10_JPRB, 0.38795953E-10_JPRB /)

RGHG4(:,44, 9) = (/ &
  & 0.15745737E-09_JPRB, 0.13972200E-09_JPRB, 0.13345744E-09_JPRB, 0.13201687E-09_JPRB, 0.13204055E-09_JPRB, 0.13138615E-09_JPRB, &
  & 0.12933514E-09_JPRB, 0.12593249E-09_JPRB, 0.12041643E-09_JPRB, 0.11670510E-09_JPRB, 0.11244022E-09_JPRB, 0.10757950E-09_JPRB, &
  & 0.10203687E-09_JPRB, 0.95785616E-10_JPRB, 0.88792466E-10_JPRB, 0.81015354E-10_JPRB, 0.72299257E-10_JPRB, 0.62536150E-10_JPRB, &
  & 0.51724951E-10_JPRB, 0.40692755E-10_JPRB, 0.30509619E-10_JPRB, 0.22344930E-10_JPRB, 0.16358703E-10_JPRB, 0.12170794E-10_JPRB, &
  & 0.92729964E-11_JPRB, 0.72076650E-11_JPRB, 0.56892251E-11_JPRB, 0.45114637E-11_JPRB, 0.35942460E-11_JPRB, 0.28512492E-11_JPRB, &
  & 0.23036614E-11_JPRB, 0.18909698E-11_JPRB, 0.16622401E-11_JPRB, 0.15381249E-11_JPRB, 0.15488151E-11_JPRB, 0.16323623E-11_JPRB, &
  & 0.18166784E-11_JPRB, 0.21040333E-11_JPRB, 0.24718832E-11_JPRB, 0.29892991E-11_JPRB, 0.37028852E-11_JPRB, 0.45748006E-11_JPRB, &
  & 0.57407551E-11_JPRB, 0.71918621E-11_JPRB, 0.90501252E-11_JPRB, 0.11628770E-10_JPRB, 0.15219067E-10_JPRB, 0.20169135E-10_JPRB, &
  & 0.26446198E-10_JPRB, 0.33368357E-10_JPRB, 0.40216056E-10_JPRB, 0.46321228E-10_JPRB, 0.51266536E-10_JPRB, 0.55135823E-10_JPRB, &
  & 0.57961233E-10_JPRB, 0.59981291E-10_JPRB, 0.61273958E-10_JPRB, 0.61632498E-10_JPRB, 0.61177050E-10_JPRB, 0.59545230E-10_JPRB, &
  & 0.56109280E-10_JPRB, 0.51101328E-10_JPRB, 0.44073929E-10_JPRB, 0.36171774E-10_JPRB /)

RGHG4(:,45, 9) = (/ &
  & 0.13107584E-09_JPRB, 0.11662657E-09_JPRB, 0.11156445E-09_JPRB, 0.10985796E-09_JPRB, 0.11043434E-09_JPRB, 0.10986621E-09_JPRB, &
  & 0.10793147E-09_JPRB, 0.10479181E-09_JPRB, 0.99324861E-10_JPRB, 0.96142559E-10_JPRB, 0.92599942E-10_JPRB, 0.88579463E-10_JPRB, &
  & 0.84069536E-10_JPRB, 0.78929030E-10_JPRB, 0.73242613E-10_JPRB, 0.66865263E-10_JPRB, 0.59761432E-10_JPRB, 0.51665200E-10_JPRB, &
  & 0.42914380E-10_JPRB, 0.33860897E-10_JPRB, 0.25801555E-10_JPRB, 0.19257729E-10_JPRB, 0.14412110E-10_JPRB, 0.10921910E-10_JPRB, &
  & 0.84361918E-11_JPRB, 0.66207135E-11_JPRB, 0.52635283E-11_JPRB, 0.41972051E-11_JPRB, 0.33567242E-11_JPRB, 0.26738698E-11_JPRB, &
  & 0.21630933E-11_JPRB, 0.17841004E-11_JPRB, 0.15723765E-11_JPRB, 0.14621353E-11_JPRB, 0.14768266E-11_JPRB, 0.15554234E-11_JPRB, &
  & 0.17267671E-11_JPRB, 0.19898803E-11_JPRB, 0.23209262E-11_JPRB, 0.27716982E-11_JPRB, 0.33719238E-11_JPRB, 0.40833430E-11_JPRB, &
  & 0.49669774E-11_JPRB, 0.60237605E-11_JPRB, 0.72998621E-11_JPRB, 0.90399320E-11_JPRB, 0.11503558E-10_JPRB, 0.15162963E-10_JPRB, &
  & 0.20121444E-10_JPRB, 0.25960673E-10_JPRB, 0.31886438E-10_JPRB, 0.37137390E-10_JPRB, 0.41331879E-10_JPRB, 0.44550610E-10_JPRB, &
  & 0.46895605E-10_JPRB, 0.48641591E-10_JPRB, 0.49847869E-10_JPRB, 0.50366638E-10_JPRB, 0.50315870E-10_JPRB, 0.49352786E-10_JPRB, &
  & 0.46987077E-10_JPRB, 0.43574293E-10_JPRB, 0.38657123E-10_JPRB, 0.33949506E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART18',0,ZHOOK_HANDLE)



RGHG4(:,46, 9) = (/ &
  & 0.10975947E-09_JPRB, 0.96541483E-10_JPRB, 0.91405807E-10_JPRB, 0.89494814E-10_JPRB, 0.89672131E-10_JPRB, 0.89113945E-10_JPRB, &
  & 0.87429557E-10_JPRB, 0.84690512E-10_JPRB, 0.79481290E-10_JPRB, 0.76944909E-10_JPRB, 0.74102571E-10_JPRB, 0.70928131E-10_JPRB, &
  & 0.67299458E-10_JPRB, 0.63214371E-10_JPRB, 0.58608174E-10_JPRB, 0.53502137E-10_JPRB, 0.47753669E-10_JPRB, 0.41403846E-10_JPRB, &
  & 0.34475398E-10_JPRB, 0.27721070E-10_JPRB, 0.21611780E-10_JPRB, 0.16645662E-10_JPRB, 0.12798051E-10_JPRB, 0.99021997E-11_JPRB, &
  & 0.77649285E-11_JPRB, 0.61605204E-11_JPRB, 0.49334144E-11_JPRB, 0.39612146E-11_JPRB, 0.31723936E-11_JPRB, 0.25444800E-11_JPRB, &
  & 0.20470659E-11_JPRB, 0.17084697E-11_JPRB, 0.14941622E-11_JPRB, 0.14057362E-11_JPRB, 0.14141210E-11_JPRB, 0.14915669E-11_JPRB, &
  & 0.16506731E-11_JPRB, 0.18944145E-11_JPRB, 0.21994728E-11_JPRB, 0.25981901E-11_JPRB, 0.31148541E-11_JPRB, 0.37043385E-11_JPRB, &
  & 0.43793654E-11_JPRB, 0.51581144E-11_JPRB, 0.60202433E-11_JPRB, 0.71626364E-11_JPRB, 0.87942344E-11_JPRB, 0.11298999E-10_JPRB, &
  & 0.14987707E-10_JPRB, 0.19641407E-10_JPRB, 0.24544741E-10_JPRB, 0.28969023E-10_JPRB, 0.32425857E-10_JPRB, 0.35044138E-10_JPRB, &
  & 0.36986889E-10_JPRB, 0.38460565E-10_JPRB, 0.39533099E-10_JPRB, 0.40109166E-10_JPRB, 0.40320580E-10_JPRB, 0.39876231E-10_JPRB, &
  & 0.38464079E-10_JPRB, 0.36379753E-10_JPRB, 0.33335536E-10_JPRB, 0.31838056E-10_JPRB /)

RGHG4(:,47, 9) = (/ &
  & 0.89203485E-10_JPRB, 0.76622798E-10_JPRB, 0.71981324E-10_JPRB, 0.69902903E-10_JPRB, 0.69612392E-10_JPRB, 0.68897478E-10_JPRB, &
  & 0.67441060E-10_JPRB, 0.65218983E-10_JPRB, 0.60427885E-10_JPRB, 0.58536190E-10_JPRB, 0.56446927E-10_JPRB, 0.54058345E-10_JPRB, &
  & 0.51365436E-10_JPRB, 0.48215727E-10_JPRB, 0.44692170E-10_JPRB, 0.40696314E-10_JPRB, 0.36353646E-10_JPRB, 0.31569924E-10_JPRB, &
  & 0.26778822E-10_JPRB, 0.22090567E-10_JPRB, 0.17937393E-10_JPRB, 0.14335774E-10_JPRB, 0.11382386E-10_JPRB, 0.90184952E-11_JPRB, &
  & 0.71889547E-11_JPRB, 0.57721987E-11_JPRB, 0.46551734E-11_JPRB, 0.37664034E-11_JPRB, 0.30181209E-11_JPRB, 0.24400464E-11_JPRB, &
  & 0.19490939E-11_JPRB, 0.16506036E-11_JPRB, 0.14258508E-11_JPRB, 0.13637245E-11_JPRB, 0.13587179E-11_JPRB, 0.14382495E-11_JPRB, &
  & 0.15849819E-11_JPRB, 0.18110058E-11_JPRB, 0.20952400E-11_JPRB, 0.24506074E-11_JPRB, 0.28970194E-11_JPRB, 0.33928498E-11_JPRB, &
  & 0.39113240E-11_JPRB, 0.44870188E-11_JPRB, 0.50654355E-11_JPRB, 0.58003697E-11_JPRB, 0.68249013E-11_JPRB, 0.84449392E-11_JPRB, &
  & 0.10968106E-10_JPRB, 0.14375205E-10_JPRB, 0.18248606E-10_JPRB, 0.21776725E-10_JPRB, 0.24540482E-10_JPRB, 0.26558790E-10_JPRB, &
  & 0.28059740E-10_JPRB, 0.29237709E-10_JPRB, 0.30174325E-10_JPRB, 0.30801185E-10_JPRB, 0.31248403E-10_JPRB, 0.31190911E-10_JPRB, &
  & 0.30630141E-10_JPRB, 0.29653665E-10_JPRB, 0.28111910E-10_JPRB, 0.29385463E-10_JPRB /)

RGHG4(:,48, 9) = (/ &
  & 0.68344608E-10_JPRB, 0.58634340E-10_JPRB, 0.54343193E-10_JPRB, 0.51964575E-10_JPRB, 0.50990288E-10_JPRB, 0.49889346E-10_JPRB, &
  & 0.48509811E-10_JPRB, 0.46817997E-10_JPRB, 0.42494945E-10_JPRB, 0.41282824E-10_JPRB, 0.39932530E-10_JPRB, 0.38397317E-10_JPRB, &
  & 0.36571635E-10_JPRB, 0.34407997E-10_JPRB, 0.31886317E-10_JPRB, 0.29109489E-10_JPRB, 0.26110661E-10_JPRB, 0.23135252E-10_JPRB, &
  & 0.20233371E-10_JPRB, 0.17504352E-10_JPRB, 0.14918714E-10_JPRB, 0.12463959E-10_JPRB, 0.10233852E-10_JPRB, 0.83070764E-11_JPRB, &
  & 0.67316001E-11_JPRB, 0.54696972E-11_JPRB, 0.44428597E-11_JPRB, 0.36163576E-11_JPRB, 0.29075366E-11_JPRB, 0.23538654E-11_JPRB, &
  & 0.18865599E-11_JPRB, 0.16007004E-11_JPRB, 0.13814326E-11_JPRB, 0.13321165E-11_JPRB, 0.13171006E-11_JPRB, 0.13985007E-11_JPRB, &
  & 0.15346932E-11_JPRB, 0.17474261E-11_JPRB, 0.20172273E-11_JPRB, 0.23402816E-11_JPRB, 0.27323666E-11_JPRB, 0.31575857E-11_JPRB, &
  & 0.35634308E-11_JPRB, 0.39943704E-11_JPRB, 0.43901753E-11_JPRB, 0.48607607E-11_JPRB, 0.55016317E-11_JPRB, 0.64880623E-11_JPRB, &
  & 0.80743554E-11_JPRB, 0.10321926E-10_JPRB, 0.13030007E-10_JPRB, 0.15691528E-10_JPRB, 0.17803760E-10_JPRB, 0.19364968E-10_JPRB, &
  & 0.20563839E-10_JPRB, 0.21512059E-10_JPRB, 0.22333021E-10_JPRB, 0.22936998E-10_JPRB, 0.23453389E-10_JPRB, 0.23660622E-10_JPRB, &
  & 0.23642035E-10_JPRB, 0.23406813E-10_JPRB, 0.22932810E-10_JPRB, 0.26444402E-10_JPRB /)

RGHG4(:,49, 9) = (/ &
  & 0.53574711E-10_JPRB, 0.43671729E-10_JPRB, 0.39572512E-10_JPRB, 0.36914603E-10_JPRB, 0.35252919E-10_JPRB, 0.33599068E-10_JPRB, &
  & 0.32116039E-10_JPRB, 0.30762622E-10_JPRB, 0.26724204E-10_JPRB, 0.26013870E-10_JPRB, 0.25308727E-10_JPRB, 0.24484947E-10_JPRB, &
  & 0.23489660E-10_JPRB, 0.22245077E-10_JPRB, 0.20811970E-10_JPRB, 0.19240701E-10_JPRB, 0.17757601E-10_JPRB, 0.16348959E-10_JPRB, &
  & 0.15083395E-10_JPRB, 0.13830867E-10_JPRB, 0.12441491E-10_JPRB, 0.10885640E-10_JPRB, 0.92538642E-11_JPRB, 0.76990107E-11_JPRB, &
  & 0.63441899E-11_JPRB, 0.52114315E-11_JPRB, 0.42689632E-11_JPRB, 0.34833243E-11_JPRB, 0.28271840E-11_JPRB, 0.22693707E-11_JPRB, &
  & 0.18541562E-11_JPRB, 0.15478150E-11_JPRB, 0.13637530E-11_JPRB, 0.13053974E-11_JPRB, 0.12913262E-11_JPRB, 0.13706345E-11_JPRB, &
  & 0.14975870E-11_JPRB, 0.16974095E-11_JPRB, 0.19525345E-11_JPRB, 0.22514367E-11_JPRB, 0.25953781E-11_JPRB, 0.29675186E-11_JPRB, &
  & 0.32926901E-11_JPRB, 0.36172597E-11_JPRB, 0.38924588E-11_JPRB, 0.41897393E-11_JPRB, 0.45786114E-11_JPRB, 0.51499889E-11_JPRB, &
  & 0.60628451E-11_JPRB, 0.73553559E-11_JPRB, 0.89702169E-11_JPRB, 0.10640794E-10_JPRB, 0.12073632E-10_JPRB, 0.13173267E-10_JPRB, &
  & 0.14060522E-10_JPRB, 0.14778520E-10_JPRB, 0.15523161E-10_JPRB, 0.16101433E-10_JPRB, 0.16686109E-10_JPRB, 0.17109817E-10_JPRB, &
  & 0.17444109E-10_JPRB, 0.17658128E-10_JPRB, 0.17852653E-10_JPRB, 0.22952047E-10_JPRB /)

RGHG4(:,50, 9) = (/ &
  & 0.37971432E-10_JPRB, 0.31154194E-10_JPRB, 0.28067998E-10_JPRB, 0.25754236E-10_JPRB, 0.23946045E-10_JPRB, 0.22155413E-10_JPRB, &
  & 0.20705057E-10_JPRB, 0.19631359E-10_JPRB, 0.15861975E-10_JPRB, 0.15429004E-10_JPRB, 0.15035202E-10_JPRB, 0.14650788E-10_JPRB, &
  & 0.14204249E-10_JPRB, 0.13666103E-10_JPRB, 0.13088801E-10_JPRB, 0.12556767E-10_JPRB, 0.12105952E-10_JPRB, 0.11768204E-10_JPRB, &
  & 0.11487130E-10_JPRB, 0.11111403E-10_JPRB, 0.10530234E-10_JPRB, 0.96107150E-11_JPRB, 0.84474476E-11_JPRB, 0.71936007E-11_JPRB, &
  & 0.60228350E-11_JPRB, 0.49952850E-11_JPRB, 0.41276991E-11_JPRB, 0.33714650E-11_JPRB, 0.27619649E-11_JPRB, 0.22084029E-11_JPRB, &
  & 0.18348142E-11_JPRB, 0.15137989E-11_JPRB, 0.13671415E-11_JPRB, 0.12915121E-11_JPRB, 0.12862292E-11_JPRB, 0.13601586E-11_JPRB, &
  & 0.14805607E-11_JPRB, 0.16685171E-11_JPRB, 0.19106234E-11_JPRB, 0.21903499E-11_JPRB, 0.24953893E-11_JPRB, 0.28188164E-11_JPRB, &
  & 0.30925594E-11_JPRB, 0.33297098E-11_JPRB, 0.35344648E-11_JPRB, 0.37185593E-11_JPRB, 0.39580752E-11_JPRB, 0.42728872E-11_JPRB, &
  & 0.47645000E-11_JPRB, 0.54183611E-11_JPRB, 0.62228582E-11_JPRB, 0.70647255E-11_JPRB, 0.78285971E-11_JPRB, 0.84778920E-11_JPRB, &
  & 0.90428750E-11_JPRB, 0.95546470E-11_JPRB, 0.10193041E-10_JPRB, 0.10658741E-10_JPRB, 0.11184810E-10_JPRB, 0.11665347E-10_JPRB, &
  & 0.12148840E-10_JPRB, 0.12584105E-10_JPRB, 0.13220501E-10_JPRB, 0.19112496E-10_JPRB /)

RGHG4(:,51, 9) = (/ &
  & 0.27967812E-10_JPRB, 0.22505345E-10_JPRB, 0.20252081E-10_JPRB, 0.18437026E-10_JPRB, 0.16871270E-10_JPRB, 0.15322269E-10_JPRB, &
  & 0.14146813E-10_JPRB, 0.13374963E-10_JPRB, 0.10027894E-10_JPRB, 0.97425696E-11_JPRB, 0.95127491E-11_JPRB, 0.93006366E-11_JPRB, &
  & 0.91085360E-11_JPRB, 0.89242815E-11_JPRB, 0.87988462E-11_JPRB, 0.87420036E-11_JPRB, 0.87924034E-11_JPRB, 0.89133865E-11_JPRB, &
  & 0.90722299E-11_JPRB, 0.91683423E-11_JPRB, 0.90392346E-11_JPRB, 0.85811332E-11_JPRB, 0.77802322E-11_JPRB, 0.67752626E-11_JPRB, &
  & 0.57606910E-11_JPRB, 0.48215247E-11_JPRB, 0.40115745E-11_JPRB, 0.32978893E-11_JPRB, 0.27020209E-11_JPRB, 0.21907658E-11_JPRB, &
  & 0.18092713E-11_JPRB, 0.15175554E-11_JPRB, 0.13813739E-11_JPRB, 0.12994376E-11_JPRB, 0.13034675E-11_JPRB, 0.13710227E-11_JPRB, &
  & 0.14852135E-11_JPRB, 0.16611065E-11_JPRB, 0.18882710E-11_JPRB, 0.21510747E-11_JPRB, 0.24292378E-11_JPRB, 0.27118975E-11_JPRB, &
  & 0.29511651E-11_JPRB, 0.31327996E-11_JPRB, 0.32808539E-11_JPRB, 0.33987205E-11_JPRB, 0.35363032E-11_JPRB, 0.36990072E-11_JPRB, &
  & 0.39380227E-11_JPRB, 0.42339205E-11_JPRB, 0.45626424E-11_JPRB, 0.48956880E-11_JPRB, 0.51988257E-11_JPRB, 0.54687058E-11_JPRB, &
  & 0.57312484E-11_JPRB, 0.59785718E-11_JPRB, 0.64301325E-11_JPRB, 0.66998416E-11_JPRB, 0.70705447E-11_JPRB, 0.74557322E-11_JPRB, &
  & 0.78893949E-11_JPRB, 0.83632328E-11_JPRB, 0.91024454E-11_JPRB, 0.15055757E-10_JPRB /)

RGHG4(:,52, 9) = (/ &
  & 0.19621691E-10_JPRB, 0.16380765E-10_JPRB, 0.15029178E-10_JPRB, 0.13736067E-10_JPRB, 0.12570777E-10_JPRB, 0.11387050E-10_JPRB, &
  & 0.10534479E-10_JPRB, 0.99904703E-11_JPRB, 0.71083335E-11_JPRB, 0.69189658E-11_JPRB, 0.67681650E-11_JPRB, 0.66481590E-11_JPRB, &
  & 0.65603803E-11_JPRB, 0.65168999E-11_JPRB, 0.65454586E-11_JPRB, 0.66655869E-11_JPRB, 0.68703411E-11_JPRB, 0.71472264E-11_JPRB, &
  & 0.74644345E-11_JPRB, 0.77484087E-11_JPRB, 0.78873314E-11_JPRB, 0.77277655E-11_JPRB, 0.72150996E-11_JPRB, 0.64206570E-11_JPRB, &
  & 0.55458086E-11_JPRB, 0.46880767E-11_JPRB, 0.39223737E-11_JPRB, 0.32583372E-11_JPRB, 0.26616806E-11_JPRB, 0.22111696E-11_JPRB, &
  & 0.18077364E-11_JPRB, 0.15662421E-11_JPRB, 0.14171042E-11_JPRB, 0.13430077E-11_JPRB, 0.13523787E-11_JPRB, 0.14145948E-11_JPRB, &
  & 0.15242666E-11_JPRB, 0.16899163E-11_JPRB, 0.19023613E-11_JPRB, 0.21457209E-11_JPRB, 0.23987420E-11_JPRB, 0.26433621E-11_JPRB, &
  & 0.28512277E-11_JPRB, 0.29913361E-11_JPRB, 0.30954516E-11_JPRB, 0.31738620E-11_JPRB, 0.32446326E-11_JPRB, 0.33171595E-11_JPRB, &
  & 0.34127605E-11_JPRB, 0.35143368E-11_JPRB, 0.36184129E-11_JPRB, 0.37090617E-11_JPRB, 0.37933775E-11_JPRB, 0.38736059E-11_JPRB, &
  & 0.39670953E-11_JPRB, 0.40735718E-11_JPRB, 0.44024875E-11_JPRB, 0.45217636E-11_JPRB, 0.47015373E-11_JPRB, 0.48868522E-11_JPRB, &
  & 0.51571607E-11_JPRB, 0.55049116E-11_JPRB, 0.61072401E-11_JPRB, 0.11235528E-10_JPRB /)

RGHG4(:,53, 9) = (/ &
  & 0.14866840E-10_JPRB, 0.12675048E-10_JPRB, 0.11676755E-10_JPRB, 0.10770928E-10_JPRB, 0.98778277E-11_JPRB, 0.90304153E-11_JPRB, &
  & 0.84195055E-11_JPRB, 0.80383113E-11_JPRB, 0.55758245E-11_JPRB, 0.54404402E-11_JPRB, 0.53386228E-11_JPRB, 0.52629251E-11_JPRB, &
  & 0.52219509E-11_JPRB, 0.52313761E-11_JPRB, 0.53165831E-11_JPRB, 0.54806242E-11_JPRB, 0.57255732E-11_JPRB, 0.60357301E-11_JPRB, &
  & 0.63944566E-11_JPRB, 0.67489634E-11_JPRB, 0.70115684E-11_JPRB, 0.70494309E-11_JPRB, 0.67551516E-11_JPRB, 0.61385675E-11_JPRB, &
  & 0.53919408E-11_JPRB, 0.46113356E-11_JPRB, 0.38841022E-11_JPRB, 0.32593685E-11_JPRB, 0.26875641E-11_JPRB, 0.22452361E-11_JPRB, &
  & 0.18566808E-11_JPRB, 0.16380643E-11_JPRB, 0.14798889E-11_JPRB, 0.14218640E-11_JPRB, 0.14327013E-11_JPRB, 0.14907890E-11_JPRB, &
  & 0.15955824E-11_JPRB, 0.17514951E-11_JPRB, 0.19505064E-11_JPRB, 0.21769396E-11_JPRB, 0.24068009E-11_JPRB, 0.26318739E-11_JPRB, &
  & 0.28040287E-11_JPRB, 0.29231327E-11_JPRB, 0.29924236E-11_JPRB, 0.30408523E-11_JPRB, 0.30711308E-11_JPRB, 0.30803979E-11_JPRB, &
  & 0.31002306E-11_JPRB, 0.31009637E-11_JPRB, 0.31037774E-11_JPRB, 0.30926791E-11_JPRB, 0.30916662E-11_JPRB, 0.30962273E-11_JPRB, &
  & 0.31213927E-11_JPRB, 0.31608455E-11_JPRB, 0.34245590E-11_JPRB, 0.34744620E-11_JPRB, 0.35610469E-11_JPRB, 0.36534074E-11_JPRB, &
  & 0.38155902E-11_JPRB, 0.40252480E-11_JPRB, 0.44013512E-11_JPRB, 0.84364711E-11_JPRB /)

RGHG4(:,54, 9) = (/ &
  & 0.11776327E-10_JPRB, 0.10043430E-10_JPRB, 0.93776445E-11_JPRB, 0.87133608E-11_JPRB, 0.81053575E-11_JPRB, 0.74849311E-11_JPRB, &
  & 0.70658787E-11_JPRB, 0.67857269E-11_JPRB, 0.46641185E-11_JPRB, 0.45654223E-11_JPRB, 0.44886868E-11_JPRB, 0.44392853E-11_JPRB, &
  & 0.44214593E-11_JPRB, 0.44497943E-11_JPRB, 0.45471066E-11_JPRB, 0.47190793E-11_JPRB, 0.49607796E-11_JPRB, 0.52654625E-11_JPRB, &
  & 0.56214642E-11_JPRB, 0.60000351E-11_JPRB, 0.63334108E-11_JPRB, 0.65057794E-11_JPRB, 0.63902377E-11_JPRB, 0.59341312E-11_JPRB, &
  & 0.53123781E-11_JPRB, 0.46054935E-11_JPRB, 0.39197447E-11_JPRB, 0.33106961E-11_JPRB, 0.27813732E-11_JPRB, 0.23232824E-11_JPRB, &
  & 0.19844341E-11_JPRB, 0.17554765E-11_JPRB, 0.16037371E-11_JPRB, 0.15605127E-11_JPRB, 0.15705785E-11_JPRB, 0.16261981E-11_JPRB, &
  & 0.17275567E-11_JPRB, 0.18761442E-11_JPRB, 0.20628360E-11_JPRB, 0.22711897E-11_JPRB, 0.24669403E-11_JPRB, 0.26719605E-11_JPRB, &
  & 0.28279768E-11_JPRB, 0.29085486E-11_JPRB, 0.29627206E-11_JPRB, 0.29759457E-11_JPRB, 0.29784925E-11_JPRB, 0.29452361E-11_JPRB, &
  & 0.29174378E-11_JPRB, 0.28634328E-11_JPRB, 0.28161945E-11_JPRB, 0.27671236E-11_JPRB, 0.27307993E-11_JPRB, 0.27131199E-11_JPRB, &
  & 0.27130383E-11_JPRB, 0.27335957E-11_JPRB, 0.29877572E-11_JPRB, 0.30191928E-11_JPRB, 0.30695923E-11_JPRB, 0.31152522E-11_JPRB, &
  & 0.32105152E-11_JPRB, 0.33412756E-11_JPRB, 0.35953330E-11_JPRB, 0.68381108E-11_JPRB /)

RGHG4(:,55, 9) = (/ &
  & 0.92659838E-11_JPRB, 0.82399877E-11_JPRB, 0.77644592E-11_JPRB, 0.73018059E-11_JPRB, 0.68576655E-11_JPRB, 0.64340941E-11_JPRB, &
  & 0.61271127E-11_JPRB, 0.59175512E-11_JPRB, 0.40922647E-11_JPRB, 0.40177119E-11_JPRB, 0.39601586E-11_JPRB, 0.39247720E-11_JPRB, &
  & 0.39195322E-11_JPRB, 0.39562138E-11_JPRB, 0.40525968E-11_JPRB, 0.42164410E-11_JPRB, 0.44474376E-11_JPRB, 0.47360340E-11_JPRB, &
  & 0.50886348E-11_JPRB, 0.54726584E-11_JPRB, 0.58487564E-11_JPRB, 0.61173926E-11_JPRB, 0.61422369E-11_JPRB, 0.58224905E-11_JPRB, &
  & 0.53142386E-11_JPRB, 0.46755716E-11_JPRB, 0.40333878E-11_JPRB, 0.34384980E-11_JPRB, 0.29359024E-11_JPRB, 0.24690373E-11_JPRB, &
  & 0.21518386E-11_JPRB, 0.19034188E-11_JPRB, 0.17675237E-11_JPRB, 0.17304799E-11_JPRB, 0.17387126E-11_JPRB, 0.17936017E-11_JPRB, &
  & 0.18932629E-11_JPRB, 0.20377239E-11_JPRB, 0.22184643E-11_JPRB, 0.24185172E-11_JPRB, 0.25982840E-11_JPRB, 0.27862478E-11_JPRB, &
  & 0.29184639E-11_JPRB, 0.29738898E-11_JPRB, 0.30048988E-11_JPRB, 0.29987063E-11_JPRB, 0.29767412E-11_JPRB, 0.29166849E-11_JPRB, &
  & 0.28561394E-11_JPRB, 0.27747049E-11_JPRB, 0.27003751E-11_JPRB, 0.26325650E-11_JPRB, 0.25883152E-11_JPRB, 0.25583127E-11_JPRB, &
  & 0.25524966E-11_JPRB, 0.25662361E-11_JPRB, 0.28032810E-11_JPRB, 0.28225048E-11_JPRB, 0.28659397E-11_JPRB, 0.29031293E-11_JPRB, &
  & 0.29926190E-11_JPRB, 0.31101525E-11_JPRB, 0.33212781E-11_JPRB, 0.60438481E-11_JPRB /)

RGHG4(:,56, 9) = (/ &
  & 0.78963181E-11_JPRB, 0.69645748E-11_JPRB, 0.66136263E-11_JPRB, 0.62614514E-11_JPRB, 0.59621700E-11_JPRB, 0.56627021E-11_JPRB, &
  & 0.54512666E-11_JPRB, 0.52871752E-11_JPRB, 0.37026250E-11_JPRB, 0.36412240E-11_JPRB, 0.35946816E-11_JPRB, 0.35672864E-11_JPRB, &
  & 0.35679261E-11_JPRB, 0.36038594E-11_JPRB, 0.36962954E-11_JPRB, 0.38472541E-11_JPRB, 0.40672739E-11_JPRB, 0.43455630E-11_JPRB, &
  & 0.46930749E-11_JPRB, 0.50970998E-11_JPRB, 0.55186307E-11_JPRB, 0.58745808E-11_JPRB, 0.60170016E-11_JPRB, 0.58142844E-11_JPRB, &
  & 0.54232374E-11_JPRB, 0.48411761E-11_JPRB, 0.42290837E-11_JPRB, 0.36395748E-11_JPRB, 0.31291063E-11_JPRB, 0.26773507E-11_JPRB, &
  & 0.23462037E-11_JPRB, 0.20960599E-11_JPRB, 0.19748526E-11_JPRB, 0.19371616E-11_JPRB, 0.19450576E-11_JPRB, 0.20004551E-11_JPRB, &
  & 0.20999543E-11_JPRB, 0.22420028E-11_JPRB, 0.24197150E-11_JPRB, 0.26164888E-11_JPRB, 0.27933255E-11_JPRB, 0.29728607E-11_JPRB, &
  & 0.30947694E-11_JPRB, 0.31270600E-11_JPRB, 0.31444027E-11_JPRB, 0.31149785E-11_JPRB, 0.30712824E-11_JPRB, 0.29851596E-11_JPRB, &
  & 0.28971708E-11_JPRB, 0.27893785E-11_JPRB, 0.26933601E-11_JPRB, 0.26189508E-11_JPRB, 0.25637175E-11_JPRB, 0.25359838E-11_JPRB, &
  & 0.25261939E-11_JPRB, 0.25389356E-11_JPRB, 0.27743545E-11_JPRB, 0.28007466E-11_JPRB, 0.28484951E-11_JPRB, 0.28792320E-11_JPRB, &
  & 0.29651784E-11_JPRB, 0.30775176E-11_JPRB, 0.32952334E-11_JPRB, 0.58877790E-11_JPRB /)

RGHG4(:,57, 9) = (/ &
  & 0.65756172E-11_JPRB, 0.60096047E-11_JPRB, 0.57684955E-11_JPRB, 0.55123805E-11_JPRB, 0.52978819E-11_JPRB, 0.50842074E-11_JPRB, &
  & 0.49258167E-11_JPRB, 0.47999738E-11_JPRB, 0.34349958E-11_JPRB, 0.33841298E-11_JPRB, 0.33458806E-11_JPRB, 0.33234212E-11_JPRB, &
  & 0.33280162E-11_JPRB, 0.33647310E-11_JPRB, 0.34512120E-11_JPRB, 0.35959187E-11_JPRB, 0.38046398E-11_JPRB, 0.40797960E-11_JPRB, &
  & 0.44381213E-11_JPRB, 0.48690631E-11_JPRB, 0.53435216E-11_JPRB, 0.57741863E-11_JPRB, 0.60194141E-11_JPRB, 0.59012508E-11_JPRB, &
  & 0.55535129E-11_JPRB, 0.50182458E-11_JPRB, 0.44354321E-11_JPRB, 0.38651062E-11_JPRB, 0.33503066E-11_JPRB, 0.29133896E-11_JPRB, &
  & 0.25649595E-11_JPRB, 0.23253717E-11_JPRB, 0.22112158E-11_JPRB, 0.21712551E-11_JPRB, 0.21815329E-11_JPRB, 0.22381838E-11_JPRB, &
  & 0.23373341E-11_JPRB, 0.24772155E-11_JPRB, 0.26540406E-11_JPRB, 0.28546850E-11_JPRB, 0.30380247E-11_JPRB, 0.32168836E-11_JPRB, &
  & 0.33358761E-11_JPRB, 0.33638630E-11_JPRB, 0.33756038E-11_JPRB, 0.33307408E-11_JPRB, 0.32752061E-11_JPRB, 0.31616060E-11_JPRB, &
  & 0.30533904E-11_JPRB, 0.29200570E-11_JPRB, 0.28082482E-11_JPRB, 0.27178741E-11_JPRB, 0.26667230E-11_JPRB, 0.26314031E-11_JPRB, &
  & 0.26233900E-11_JPRB, 0.26360099E-11_JPRB, 0.28630191E-11_JPRB, 0.28878141E-11_JPRB, 0.29306707E-11_JPRB, 0.29670376E-11_JPRB, &
  & 0.30612424E-11_JPRB, 0.31773002E-11_JPRB, 0.33762244E-11_JPRB, 0.57686351E-11_JPRB /)

RGHG4(:,58, 9) = (/ &
  & 0.59175533E-11_JPRB, 0.53622371E-11_JPRB, 0.51580905E-11_JPRB, 0.49539127E-11_JPRB, 0.48051784E-11_JPRB, 0.46551981E-11_JPRB, &
  & 0.45407640E-11_JPRB, 0.44377913E-11_JPRB, 0.32529624E-11_JPRB, 0.32105568E-11_JPRB, 0.31767462E-11_JPRB, 0.31578492E-11_JPRB, &
  & 0.31632106E-11_JPRB, 0.32018045E-11_JPRB, 0.32851217E-11_JPRB, 0.34291383E-11_JPRB, 0.36382607E-11_JPRB, 0.39208584E-11_JPRB, &
  & 0.42988386E-11_JPRB, 0.47737912E-11_JPRB, 0.52998860E-11_JPRB, 0.57941577E-11_JPRB, 0.60700243E-11_JPRB, 0.60094100E-11_JPRB, &
  & 0.57232582E-11_JPRB, 0.52381819E-11_JPRB, 0.46814406E-11_JPRB, 0.41241238E-11_JPRB, 0.36060534E-11_JPRB, 0.31656871E-11_JPRB, &
  & 0.28181695E-11_JPRB, 0.25923890E-11_JPRB, 0.24814231E-11_JPRB, 0.24422534E-11_JPRB, 0.24577905E-11_JPRB, 0.25165881E-11_JPRB, &
  & 0.26150737E-11_JPRB, 0.27513495E-11_JPRB, 0.29262515E-11_JPRB, 0.31273538E-11_JPRB, 0.33224389E-11_JPRB, 0.35056968E-11_JPRB, &
  & 0.36281041E-11_JPRB, 0.36688209E-11_JPRB, 0.36867718E-11_JPRB, 0.36476859E-11_JPRB, 0.35929970E-11_JPRB, 0.34627425E-11_JPRB, &
  & 0.33400136E-11_JPRB, 0.31754831E-11_JPRB, 0.30361920E-11_JPRB, 0.29410523E-11_JPRB, 0.28741324E-11_JPRB, 0.28433664E-11_JPRB, &
  & 0.28304767E-11_JPRB, 0.28436903E-11_JPRB, 0.30664048E-11_JPRB, 0.30935686E-11_JPRB, 0.31474877E-11_JPRB, 0.31824398E-11_JPRB, &
  & 0.32766311E-11_JPRB, 0.33920245E-11_JPRB, 0.35954937E-11_JPRB, 0.58762335E-11_JPRB /)

RGHG4(:,59, 9) = (/ &
  & 0.52398537E-11_JPRB, 0.48448420E-11_JPRB, 0.47067029E-11_JPRB, 0.45504043E-11_JPRB, 0.44395503E-11_JPRB, 0.43272564E-11_JPRB, &
  & 0.42448449E-11_JPRB, 0.41674338E-11_JPRB, 0.31433315E-11_JPRB, 0.31077870E-11_JPRB, 0.30816159E-11_JPRB, 0.30679135E-11_JPRB, &
  & 0.30794423E-11_JPRB, 0.31213957E-11_JPRB, 0.32111449E-11_JPRB, 0.33619735E-11_JPRB, 0.35828185E-11_JPRB, 0.38798196E-11_JPRB, &
  & 0.42898016E-11_JPRB, 0.48051298E-11_JPRB, 0.53706670E-11_JPRB, 0.58709756E-11_JPRB, 0.61802377E-11_JPRB, 0.61711309E-11_JPRB, &
  & 0.59169514E-11_JPRB, 0.54633797E-11_JPRB, 0.49267912E-11_JPRB, 0.43822736E-11_JPRB, 0.38759130E-11_JPRB, 0.34365223E-11_JPRB, &
  & 0.31012569E-11_JPRB, 0.28857522E-11_JPRB, 0.27798052E-11_JPRB, 0.27458678E-11_JPRB, 0.27679144E-11_JPRB, 0.28283951E-11_JPRB, &
  & 0.29263855E-11_JPRB, 0.30595277E-11_JPRB, 0.32317413E-11_JPRB, 0.34391238E-11_JPRB, 0.36439224E-11_JPRB, 0.38345078E-11_JPRB, &
  & 0.39652040E-11_JPRB, 0.40252931E-11_JPRB, 0.40570468E-11_JPRB, 0.40418970E-11_JPRB, 0.40083219E-11_JPRB, 0.38852302E-11_JPRB, &
  & 0.37628277E-11_JPRB, 0.35771692E-11_JPRB, 0.34120846E-11_JPRB, 0.33029315E-11_JPRB, 0.32332845E-11_JPRB, 0.31933124E-11_JPRB, &
  & 0.31778341E-11_JPRB, 0.31908209E-11_JPRB, 0.34039796E-11_JPRB, 0.34316237E-11_JPRB, 0.34765964E-11_JPRB, 0.35093341E-11_JPRB, &
  & 0.36072519E-11_JPRB, 0.37267875E-11_JPRB, 0.39257686E-11_JPRB, 0.61296467E-11_JPRB /)

RGHG4(:,60, 9) = (/ &
  & 0.48611822E-11_JPRB, 0.45139838E-11_JPRB, 0.43957234E-11_JPRB, 0.42702721E-11_JPRB, 0.41943450E-11_JPRB, 0.41176940E-11_JPRB, &
  & 0.40607131E-11_JPRB, 0.40023124E-11_JPRB, 0.31122687E-11_JPRB, 0.30822326E-11_JPRB, 0.30631957E-11_JPRB, 0.30537834E-11_JPRB, &
  & 0.30750626E-11_JPRB, 0.31245800E-11_JPRB, 0.32298120E-11_JPRB, 0.33961312E-11_JPRB, 0.36451866E-11_JPRB, 0.39617151E-11_JPRB, &
  & 0.44022650E-11_JPRB, 0.49386888E-11_JPRB, 0.55005570E-11_JPRB, 0.60059865E-11_JPRB, 0.63164239E-11_JPRB, 0.63396705E-11_JPRB, &
  & 0.61220347E-11_JPRB, 0.57041516E-11_JPRB, 0.51893810E-11_JPRB, 0.46577269E-11_JPRB, 0.41608210E-11_JPRB, 0.37321253E-11_JPRB, &
  & 0.34136374E-11_JPRB, 0.32165633E-11_JPRB, 0.31225695E-11_JPRB, 0.30999361E-11_JPRB, 0.31292885E-11_JPRB, 0.31915438E-11_JPRB, &
  & 0.32883524E-11_JPRB, 0.34159656E-11_JPRB, 0.35829471E-11_JPRB, 0.37883034E-11_JPRB, 0.40041455E-11_JPRB, 0.42089301E-11_JPRB, &
  & 0.43519871E-11_JPRB, 0.44344979E-11_JPRB, 0.44863679E-11_JPRB, 0.45019080E-11_JPRB, 0.44944009E-11_JPRB, 0.44019059E-11_JPRB, &
  & 0.43066080E-11_JPRB, 0.41255267E-11_JPRB, 0.39575791E-11_JPRB, 0.38459119E-11_JPRB, 0.37592984E-11_JPRB, 0.37161936E-11_JPRB, &
  & 0.36939011E-11_JPRB, 0.37036164E-11_JPRB, 0.39110265E-11_JPRB, 0.39340302E-11_JPRB, 0.39766363E-11_JPRB, 0.40025804E-11_JPRB, &
  & 0.40968587E-11_JPRB, 0.42146217E-11_JPRB, 0.44012550E-11_JPRB, 0.65176089E-11_JPRB /)

RGHG4(:,61, 9) = (/ &
  & 0.45420633E-11_JPRB, 0.42684268E-11_JPRB, 0.41915260E-11_JPRB, 0.40951019E-11_JPRB, 0.40419191E-11_JPRB, 0.39935837E-11_JPRB, &
  & 0.39652517E-11_JPRB, 0.39290021E-11_JPRB, 0.31543123E-11_JPRB, 0.31344482E-11_JPRB, 0.31278701E-11_JPRB, 0.31300804E-11_JPRB, &
  & 0.31653879E-11_JPRB, 0.32355260E-11_JPRB, 0.33600733E-11_JPRB, 0.35602190E-11_JPRB, 0.38347667E-11_JPRB, 0.41696967E-11_JPRB, &
  & 0.46138588E-11_JPRB, 0.51427751E-11_JPRB, 0.56893921E-11_JPRB, 0.61710684E-11_JPRB, 0.64888464E-11_JPRB, 0.65362264E-11_JPRB, &
  & 0.63402695E-11_JPRB, 0.59472895E-11_JPRB, 0.54525429E-11_JPRB, 0.49374216E-11_JPRB, 0.44587606E-11_JPRB, 0.40553489E-11_JPRB, &
  & 0.37627744E-11_JPRB, 0.35911771E-11_JPRB, 0.35184765E-11_JPRB, 0.35137468E-11_JPRB, 0.35537862E-11_JPRB, 0.36181641E-11_JPRB, &
  & 0.37107839E-11_JPRB, 0.38311390E-11_JPRB, 0.39913940E-11_JPRB, 0.41967306E-11_JPRB, 0.44191395E-11_JPRB, 0.46342843E-11_JPRB, &
  & 0.47923592E-11_JPRB, 0.49005162E-11_JPRB, 0.49776060E-11_JPRB, 0.50324987E-11_JPRB, 0.50630268E-11_JPRB, 0.50203934E-11_JPRB, &
  & 0.49626726E-11_JPRB, 0.48261022E-11_JPRB, 0.46811374E-11_JPRB, 0.45842895E-11_JPRB, 0.44981180E-11_JPRB, 0.44499352E-11_JPRB, &
  & 0.44182470E-11_JPRB, 0.44276661E-11_JPRB, 0.46276433E-11_JPRB, 0.46463445E-11_JPRB, 0.46703188E-11_JPRB, 0.46842161E-11_JPRB, &
  & 0.47723409E-11_JPRB, 0.48875565E-11_JPRB, 0.50628295E-11_JPRB, 0.71406700E-11_JPRB /)

RGHG4(:,62, 9) = (/ &
  & 0.43524897E-11_JPRB, 0.41392176E-11_JPRB, 0.40869244E-11_JPRB, 0.40164001E-11_JPRB, 0.39914469E-11_JPRB, 0.39746752E-11_JPRB, &
  & 0.39782578E-11_JPRB, 0.39724357E-11_JPRB, 0.32905993E-11_JPRB, 0.32849207E-11_JPRB, 0.32915268E-11_JPRB, 0.33113993E-11_JPRB, &
  & 0.33674812E-11_JPRB, 0.34667221E-11_JPRB, 0.36184556E-11_JPRB, 0.38433401E-11_JPRB, 0.41384860E-11_JPRB, 0.44696985E-11_JPRB, &
  & 0.49042524E-11_JPRB, 0.54082294E-11_JPRB, 0.59221369E-11_JPRB, 0.63852005E-11_JPRB, 0.66871868E-11_JPRB, 0.67465634E-11_JPRB, &
  & 0.65714743E-11_JPRB, 0.62051471E-11_JPRB, 0.57325746E-11_JPRB, 0.52398936E-11_JPRB, 0.47860075E-11_JPRB, 0.44159901E-11_JPRB, &
  & 0.41615947E-11_JPRB, 0.40300532E-11_JPRB, 0.39895079E-11_JPRB, 0.40100956E-11_JPRB, 0.40631743E-11_JPRB, 0.41295027E-11_JPRB, &
  & 0.42160503E-11_JPRB, 0.43246140E-11_JPRB, 0.44735353E-11_JPRB, 0.46699541E-11_JPRB, 0.48969873E-11_JPRB, 0.51281770E-11_JPRB, &
  & 0.53010782E-11_JPRB, 0.54395516E-11_JPRB, 0.55453610E-11_JPRB, 0.56426565E-11_JPRB, 0.57113511E-11_JPRB, 0.57212772E-11_JPRB, &
  & 0.57139939E-11_JPRB, 0.56393093E-11_JPRB, 0.55595151E-11_JPRB, 0.55171237E-11_JPRB, 0.54532177E-11_JPRB, 0.54201196E-11_JPRB, &
  & 0.53953200E-11_JPRB, 0.54077272E-11_JPRB, 0.56122633E-11_JPRB, 0.56231148E-11_JPRB, 0.56267113E-11_JPRB, 0.56181648E-11_JPRB, &
  & 0.56916212E-11_JPRB, 0.57959527E-11_JPRB, 0.59496401E-11_JPRB, 0.79797939E-11_JPRB /)

RGHG4(:,63, 9) = (/ &
  & 0.42435096E-11_JPRB, 0.40893643E-11_JPRB, 0.40690611E-11_JPRB, 0.40240992E-11_JPRB, 0.40242349E-11_JPRB, 0.40424331E-11_JPRB, &
  & 0.40864551E-11_JPRB, 0.41192223E-11_JPRB, 0.35217101E-11_JPRB, 0.35389235E-11_JPRB, 0.35653316E-11_JPRB, 0.36147418E-11_JPRB, &
  & 0.36992605E-11_JPRB, 0.38321551E-11_JPRB, 0.40061491E-11_JPRB, 0.42467627E-11_JPRB, 0.45304403E-11_JPRB, 0.48511755E-11_JPRB, &
  & 0.52547420E-11_JPRB, 0.57234304E-11_JPRB, 0.62023733E-11_JPRB, 0.66277873E-11_JPRB, 0.69138024E-11_JPRB, 0.69778215E-11_JPRB, &
  & 0.68164432E-11_JPRB, 0.64728873E-11_JPRB, 0.60271887E-11_JPRB, 0.55659787E-11_JPRB, 0.51503307E-11_JPRB, 0.48302699E-11_JPRB, &
  & 0.46319415E-11_JPRB, 0.45535129E-11_JPRB, 0.45575132E-11_JPRB, 0.46086017E-11_JPRB, 0.46766310E-11_JPRB, 0.47456778E-11_JPRB, &
  & 0.48243679E-11_JPRB, 0.49196576E-11_JPRB, 0.50544746E-11_JPRB, 0.52424371E-11_JPRB, 0.54678679E-11_JPRB, 0.57040167E-11_JPRB, &
  & 0.58955323E-11_JPRB, 0.60671060E-11_JPRB, 0.62040958E-11_JPRB, 0.63488286E-11_JPRB, 0.64686225E-11_JPRB, 0.65458563E-11_JPRB, &
  & 0.66024139E-11_JPRB, 0.65962626E-11_JPRB, 0.65848290E-11_JPRB, 0.66100680E-11_JPRB, 0.66013657E-11_JPRB, 0.66128882E-11_JPRB, &
  & 0.66126635E-11_JPRB, 0.66533576E-11_JPRB, 0.68894313E-11_JPRB, 0.69053621E-11_JPRB, 0.68851851E-11_JPRB, 0.68448836E-11_JPRB, &
  & 0.68984575E-11_JPRB, 0.69885044E-11_JPRB, 0.71144414E-11_JPRB, 0.91225543E-11_JPRB /)

RGHG4(:,64, 9) = (/ &
  & 0.42186775E-11_JPRB, 0.41265789E-11_JPRB, 0.41343608E-11_JPRB, 0.41161549E-11_JPRB, 0.41419216E-11_JPRB, 0.42084535E-11_JPRB, &
  & 0.43041677E-11_JPRB, 0.43908805E-11_JPRB, 0.38696763E-11_JPRB, 0.39183088E-11_JPRB, 0.39716485E-11_JPRB, 0.40490259E-11_JPRB, &
  & 0.41638169E-11_JPRB, 0.43204728E-11_JPRB, 0.45020012E-11_JPRB, 0.47274871E-11_JPRB, 0.49958145E-11_JPRB, 0.52935234E-11_JPRB, &
  & 0.56659612E-11_JPRB, 0.60945979E-11_JPRB, 0.65300495E-11_JPRB, 0.69207353E-11_JPRB, 0.71781071E-11_JPRB, 0.72350728E-11_JPRB, &
  & 0.70858970E-11_JPRB, 0.67698737E-11_JPRB, 0.63603220E-11_JPRB, 0.59435265E-11_JPRB, 0.55813739E-11_JPRB, 0.53237497E-11_JPRB, &
  & 0.51968659E-11_JPRB, 0.51857255E-11_JPRB, 0.52453528E-11_JPRB, 0.53336419E-11_JPRB, 0.54196166E-11_JPRB, 0.54916527E-11_JPRB, &
  & 0.55632309E-11_JPRB, 0.56414335E-11_JPRB, 0.57557977E-11_JPRB, 0.59259472E-11_JPRB, 0.61471778E-11_JPRB, 0.63940736E-11_JPRB, &
  & 0.66031239E-11_JPRB, 0.68041696E-11_JPRB, 0.69740286E-11_JPRB, 0.71710918E-11_JPRB, 0.73386869E-11_JPRB, 0.74784762E-11_JPRB, &
  & 0.75985728E-11_JPRB, 0.76667934E-11_JPRB, 0.77345699E-11_JPRB, 0.78447969E-11_JPRB, 0.79123479E-11_JPRB, 0.79884042E-11_JPRB, &
  & 0.80389419E-11_JPRB, 0.81454010E-11_JPRB, 0.84658955E-11_JPRB, 0.85276708E-11_JPRB, 0.84820579E-11_JPRB, 0.84015772E-11_JPRB, &
  & 0.84315055E-11_JPRB, 0.84960424E-11_JPRB, 0.85871119E-11_JPRB, 0.10588321E-10_JPRB /)

RGHG4(:,65, 9) = (/ &
  & 0.42630400E-11_JPRB, 0.42320375E-11_JPRB, 0.42729132E-11_JPRB, 0.42847063E-11_JPRB, 0.43434700E-11_JPRB, 0.44598296E-11_JPRB, &
  & 0.46166152E-11_JPRB, 0.47773873E-11_JPRB, 0.43338198E-11_JPRB, 0.44184617E-11_JPRB, 0.45028083E-11_JPRB, 0.46114631E-11_JPRB, &
  & 0.47430922E-11_JPRB, 0.49045950E-11_JPRB, 0.50827532E-11_JPRB, 0.52922749E-11_JPRB, 0.55336400E-11_JPRB, 0.58033153E-11_JPRB, &
  & 0.61373315E-11_JPRB, 0.65238847E-11_JPRB, 0.69133917E-11_JPRB, 0.72600064E-11_JPRB, 0.74883884E-11_JPRB, 0.75386425E-11_JPRB, &
  & 0.74007276E-11_JPRB, 0.71161991E-11_JPRB, 0.67538583E-11_JPRB, 0.63961653E-11_JPRB, 0.61036180E-11_JPRB, 0.59260869E-11_JPRB, &
  & 0.58841486E-11_JPRB, 0.59512352E-11_JPRB, 0.60729529E-11_JPRB, 0.62027688E-11_JPRB, 0.63096785E-11_JPRB, 0.63888543E-11_JPRB, &
  & 0.64555583E-11_JPRB, 0.65202570E-11_JPRB, 0.66154708E-11_JPRB, 0.67692319E-11_JPRB, 0.69761033E-11_JPRB, 0.72206434E-11_JPRB, &
  & 0.74487751E-11_JPRB, 0.76766041E-11_JPRB, 0.78866974E-11_JPRB, 0.81337463E-11_JPRB, 0.83548880E-11_JPRB, 0.85731101E-11_JPRB, &
  & 0.87687357E-11_JPRB, 0.89190469E-11_JPRB, 0.90662885E-11_JPRB, 0.92539006E-11_JPRB, 0.93953153E-11_JPRB, 0.95476873E-11_JPRB, &
  & 0.96574276E-11_JPRB, 0.98532814E-11_JPRB, 0.10295787E-10_JPRB, 0.10429597E-10_JPRB, 0.10397412E-10_JPRB, 0.10311495E-10_JPRB, &
  & 0.10301439E-10_JPRB, 0.10329805E-10_JPRB, 0.10359548E-10_JPRB, 0.12369609E-10_JPRB /)

RGHG4(:,66, 9) = (/ &
  & 0.43759471E-11_JPRB, 0.44039945E-11_JPRB, 0.44834440E-11_JPRB, 0.45295994E-11_JPRB, 0.46284387E-11_JPRB, 0.48024193E-11_JPRB, &
  & 0.50410739E-11_JPRB, 0.52812884E-11_JPRB, 0.49256614E-11_JPRB, 0.50433728E-11_JPRB, 0.51479975E-11_JPRB, 0.52695513E-11_JPRB, &
  & 0.54115601E-11_JPRB, 0.55623939E-11_JPRB, 0.57273817E-11_JPRB, 0.59189567E-11_JPRB, 0.61392137E-11_JPRB, 0.63837230E-11_JPRB, &
  & 0.66804270E-11_JPRB, 0.70245493E-11_JPRB, 0.73700004E-11_JPRB, 0.76751279E-11_JPRB, 0.78722549E-11_JPRB, 0.79122793E-11_JPRB, &
  & 0.77900195E-11_JPRB, 0.75447253E-11_JPRB, 0.72416248E-11_JPRB, 0.69576562E-11_JPRB, 0.67483688E-11_JPRB, 0.66607410E-11_JPRB, &
  & 0.67116421E-11_JPRB, 0.68628601E-11_JPRB, 0.70528574E-11_JPRB, 0.72272687E-11_JPRB, 0.73596450E-11_JPRB, 0.74497656E-11_JPRB, &
  & 0.75184858E-11_JPRB, 0.75712396E-11_JPRB, 0.76493950E-11_JPRB, 0.77826122E-11_JPRB, 0.79832460E-11_JPRB, 0.82358981E-11_JPRB, &
  & 0.84753688E-11_JPRB, 0.87268604E-11_JPRB, 0.89775591E-11_JPRB, 0.92686969E-11_JPRB, 0.95464036E-11_JPRB, 0.98320900E-11_JPRB, &
  & 0.10090083E-10_JPRB, 0.10316625E-10_JPRB, 0.10541330E-10_JPRB, 0.10818299E-10_JPRB, 0.11056172E-10_JPRB, 0.11295329E-10_JPRB, &
  & 0.11476625E-10_JPRB, 0.11781018E-10_JPRB, 0.12360996E-10_JPRB, 0.12594687E-10_JPRB, 0.12598010E-10_JPRB, 0.12515124E-10_JPRB, &
  & 0.12481965E-10_JPRB, 0.12493098E-10_JPRB, 0.12429366E-10_JPRB, 0.14354458E-10_JPRB /)

RGHG4(:,67, 9) = (/ &
  & 0.45406040E-11_JPRB, 0.46366929E-11_JPRB, 0.47626464E-11_JPRB, 0.48500314E-11_JPRB, 0.49966528E-11_JPRB, 0.52397895E-11_JPRB, &
  & 0.55647514E-11_JPRB, 0.59210046E-11_JPRB, 0.56237398E-11_JPRB, 0.57730621E-11_JPRB, 0.58888064E-11_JPRB, 0.60097266E-11_JPRB, &
  & 0.61466522E-11_JPRB, 0.63009528E-11_JPRB, 0.64587988E-11_JPRB, 0.66352930E-11_JPRB, 0.68314850E-11_JPRB, 0.70472573E-11_JPRB, &
  & 0.73115611E-11_JPRB, 0.76153632E-11_JPRB, 0.79180724E-11_JPRB, 0.81858088E-11_JPRB, 0.83578413E-11_JPRB, 0.83934665E-11_JPRB, &
  & 0.82925212E-11_JPRB, 0.80947020E-11_JPRB, 0.78599228E-11_JPRB, 0.76599196E-11_JPRB, 0.75433427E-11_JPRB, 0.75558240E-11_JPRB, &
  & 0.77027586E-11_JPRB, 0.79450344E-11_JPRB, 0.82038282E-11_JPRB, 0.84252327E-11_JPRB, 0.85862237E-11_JPRB, 0.86959745E-11_JPRB, &
  & 0.87738428E-11_JPRB, 0.88288890E-11_JPRB, 0.89012010E-11_JPRB, 0.90247506E-11_JPRB, 0.92104709E-11_JPRB, 0.94574713E-11_JPRB, &
  & 0.97121790E-11_JPRB, 0.99955365E-11_JPRB, 0.10284503E-10_JPRB, 0.10619315E-10_JPRB, 0.10956810E-10_JPRB, 0.11309191E-10_JPRB, &
  & 0.11644870E-10_JPRB, 0.11961635E-10_JPRB, 0.12271714E-10_JPRB, 0.12637405E-10_JPRB, 0.12949027E-10_JPRB, 0.13269139E-10_JPRB, &
  & 0.13526734E-10_JPRB, 0.13944768E-10_JPRB, 0.14655570E-10_JPRB, 0.14997049E-10_JPRB, 0.15071203E-10_JPRB, 0.15030407E-10_JPRB, &
  & 0.14992788E-10_JPRB, 0.14956609E-10_JPRB, 0.14715618E-10_JPRB, 0.16380026E-10_JPRB /)

RGHG4(:,68, 9) = (/ &
  & 0.47425050E-11_JPRB, 0.49312672E-11_JPRB, 0.51183246E-11_JPRB, 0.52576168E-11_JPRB, 0.54631707E-11_JPRB, 0.57891196E-11_JPRB, &
  & 0.62174250E-11_JPRB, 0.66778562E-11_JPRB, 0.64362361E-11_JPRB, 0.65875374E-11_JPRB, 0.67014168E-11_JPRB, 0.68235942E-11_JPRB, &
  & 0.69556943E-11_JPRB, 0.71028413E-11_JPRB, 0.72596000E-11_JPRB, 0.74286827E-11_JPRB, 0.76142270E-11_JPRB, 0.78089471E-11_JPRB, &
  & 0.80506591E-11_JPRB, 0.83176833E-11_JPRB, 0.85862081E-11_JPRB, 0.88248861E-11_JPRB, 0.89780882E-11_JPRB, 0.90162114E-11_JPRB, &
  & 0.89446671E-11_JPRB, 0.88017761E-11_JPRB, 0.86443240E-11_JPRB, 0.85356756E-11_JPRB, 0.85205410E-11_JPRB, 0.86364084E-11_JPRB, &
  & 0.88826333E-11_JPRB, 0.92136793E-11_JPRB, 0.95470775E-11_JPRB, 0.98222125E-11_JPRB, 0.10023139E-10_JPRB, 0.10159405E-10_JPRB, &
  & 0.10254178E-10_JPRB, 0.10310864E-10_JPRB, 0.10379706E-10_JPRB, 0.10496500E-10_JPRB, 0.10690238E-10_JPRB, 0.10954292E-10_JPRB, &
  & 0.11225554E-10_JPRB, 0.11528024E-10_JPRB, 0.11851060E-10_JPRB, 0.12233011E-10_JPRB, 0.12630330E-10_JPRB, 0.13039275E-10_JPRB, &
  & 0.13443453E-10_JPRB, 0.13830436E-10_JPRB, 0.14208653E-10_JPRB, 0.14658641E-10_JPRB, 0.15065246E-10_JPRB, 0.15487518E-10_JPRB, &
  & 0.15830599E-10_JPRB, 0.16360097E-10_JPRB, 0.17205008E-10_JPRB, 0.17660788E-10_JPRB, 0.17817919E-10_JPRB, 0.17834933E-10_JPRB, &
  & 0.17820731E-10_JPRB, 0.17764372E-10_JPRB, 0.17273774E-10_JPRB, 0.18226332E-10_JPRB /)

RGHG4(:,69, 9) = (/ &
  & 0.49903475E-11_JPRB, 0.52961251E-11_JPRB, 0.55631554E-11_JPRB, 0.57692904E-11_JPRB, 0.60439900E-11_JPRB, 0.64665127E-11_JPRB, &
  & 0.70064111E-11_JPRB, 0.75588130E-11_JPRB, 0.73375230E-11_JPRB, 0.74848313E-11_JPRB, 0.75964877E-11_JPRB, 0.77096350E-11_JPRB, &
  & 0.78639361E-11_JPRB, 0.80122723E-11_JPRB, 0.81752235E-11_JPRB, 0.83384376E-11_JPRB, 0.85168721E-11_JPRB, 0.86991222E-11_JPRB, &
  & 0.89163616E-11_JPRB, 0.91620279E-11_JPRB, 0.94062249E-11_JPRB, 0.96241860E-11_JPRB, 0.97705420E-11_JPRB, 0.98208611E-11_JPRB, &
  & 0.97865119E-11_JPRB, 0.97060086E-11_JPRB, 0.96310598E-11_JPRB, 0.96184154E-11_JPRB, 0.97094555E-11_JPRB, 0.99340943E-11_JPRB, &
  & 0.10280598E-10_JPRB, 0.10711278E-10_JPRB, 0.11120192E-10_JPRB, 0.11452330E-10_JPRB, 0.11696647E-10_JPRB, 0.11870752E-10_JPRB, &
  & 0.11991966E-10_JPRB, 0.12069798E-10_JPRB, 0.12151432E-10_JPRB, 0.12274608E-10_JPRB, 0.12462806E-10_JPRB, 0.12730053E-10_JPRB, &
  & 0.13020777E-10_JPRB, 0.13365023E-10_JPRB, 0.13736151E-10_JPRB, 0.14163406E-10_JPRB, 0.14622371E-10_JPRB, 0.15090715E-10_JPRB, &
  & 0.15572774E-10_JPRB, 0.16039229E-10_JPRB, 0.16508161E-10_JPRB, 0.17056464E-10_JPRB, 0.17541331E-10_JPRB, 0.18032235E-10_JPRB, &
  & 0.18450146E-10_JPRB, 0.19084687E-10_JPRB, 0.20062048E-10_JPRB, 0.20631677E-10_JPRB, 0.20883958E-10_JPRB, 0.20974960E-10_JPRB, &
  & 0.21020128E-10_JPRB, 0.20971528E-10_JPRB, 0.20176562E-10_JPRB, 0.19941953E-10_JPRB /)

RGHG4(:,70, 9) = (/ &
  & 0.52852644E-11_JPRB, 0.57443095E-11_JPRB, 0.61241871E-11_JPRB, 0.64057613E-11_JPRB, 0.67638764E-11_JPRB, 0.72796985E-11_JPRB, &
  & 0.79171149E-11_JPRB, 0.85530793E-11_JPRB, 0.83378426E-11_JPRB, 0.84508711E-11_JPRB, 0.85870295E-11_JPRB, 0.86866573E-11_JPRB, &
  & 0.88518576E-11_JPRB, 0.90096177E-11_JPRB, 0.91905494E-11_JPRB, 0.93613546E-11_JPRB, 0.95411795E-11_JPRB, 0.97381972E-11_JPRB, &
  & 0.99429562E-11_JPRB, 0.10178653E-10_JPRB, 0.10406871E-10_JPRB, 0.10618278E-10_JPRB, 0.10766957E-10_JPRB, 0.10840535E-10_JPRB, &
  & 0.10854065E-10_JPRB, 0.10842770E-10_JPRB, 0.10855009E-10_JPRB, 0.10944443E-10_JPRB, 0.11143674E-10_JPRB, 0.11474319E-10_JPRB, &
  & 0.11932096E-10_JPRB, 0.12449441E-10_JPRB, 0.12939480E-10_JPRB, 0.13335759E-10_JPRB, 0.13634698E-10_JPRB, 0.13852285E-10_JPRB, &
  & 0.14010467E-10_JPRB, 0.14106160E-10_JPRB, 0.14202299E-10_JPRB, 0.14343763E-10_JPRB, 0.14566941E-10_JPRB, 0.14876099E-10_JPRB, &
  & 0.15206090E-10_JPRB, 0.15581317E-10_JPRB, 0.15986807E-10_JPRB, 0.16471725E-10_JPRB, 0.16990496E-10_JPRB, 0.17527068E-10_JPRB, &
  & 0.18088147E-10_JPRB, 0.18609662E-10_JPRB, 0.19152411E-10_JPRB, 0.19773709E-10_JPRB, 0.20335135E-10_JPRB, 0.20931843E-10_JPRB, &
  & 0.21441644E-10_JPRB, 0.22176870E-10_JPRB, 0.23285377E-10_JPRB, 0.23970473E-10_JPRB, 0.24328010E-10_JPRB, 0.24502685E-10_JPRB, &
  & 0.24612277E-10_JPRB, 0.24620537E-10_JPRB, 0.23490579E-10_JPRB, 0.21713242E-10_JPRB /)

RGHG4(:,71, 9) = (/ &
  & 0.56494076E-11_JPRB, 0.63119865E-11_JPRB, 0.68338338E-11_JPRB, 0.72037458E-11_JPRB, 0.76401854E-11_JPRB, 0.82516346E-11_JPRB, &
  & 0.89738165E-11_JPRB, 0.96494774E-11_JPRB, 0.94166723E-11_JPRB, 0.95366440E-11_JPRB, 0.96851980E-11_JPRB, 0.98052547E-11_JPRB, &
  & 0.99922700E-11_JPRB, 0.10158208E-10_JPRB, 0.10365295E-10_JPRB, 0.10559620E-10_JPRB, 0.10737860E-10_JPRB, 0.10945712E-10_JPRB, &
  & 0.11150546E-10_JPRB, 0.11392488E-10_JPRB, 0.11619993E-10_JPRB, 0.11836934E-10_JPRB, 0.12003322E-10_JPRB, 0.12112505E-10_JPRB, &
  & 0.12185913E-10_JPRB, 0.12253659E-10_JPRB, 0.12359558E-10_JPRB, 0.12554861E-10_JPRB, 0.12863431E-10_JPRB, 0.13314107E-10_JPRB, &
  & 0.13875218E-10_JPRB, 0.14505577E-10_JPRB, 0.15081459E-10_JPRB, 0.15545119E-10_JPRB, 0.15902920E-10_JPRB, 0.16179780E-10_JPRB, &
  & 0.16389981E-10_JPRB, 0.16533363E-10_JPRB, 0.16667050E-10_JPRB, 0.16831557E-10_JPRB, 0.17060055E-10_JPRB, 0.17383688E-10_JPRB, &
  & 0.17749106E-10_JPRB, 0.18184371E-10_JPRB, 0.18668223E-10_JPRB, 0.19216474E-10_JPRB, 0.19806465E-10_JPRB, 0.20413657E-10_JPRB, &
  & 0.21046262E-10_JPRB, 0.21652033E-10_JPRB, 0.22298080E-10_JPRB, 0.23006541E-10_JPRB, 0.23657389E-10_JPRB, 0.24318492E-10_JPRB, &
  & 0.24884352E-10_JPRB, 0.25707840E-10_JPRB, 0.26936288E-10_JPRB, 0.27735123E-10_JPRB, 0.28204593E-10_JPRB, 0.28477058E-10_JPRB, &
  & 0.28666108E-10_JPRB, 0.28753914E-10_JPRB, 0.27352081E-10_JPRB, 0.23946373E-10_JPRB /)

RGHG4(:,72, 9) = (/ &
  & 0.61300262E-11_JPRB, 0.70523578E-11_JPRB, 0.77294976E-11_JPRB, 0.81864732E-11_JPRB, 0.86863156E-11_JPRB, 0.93717404E-11_JPRB, &
  & 0.10144136E-10_JPRB, 0.10867868E-10_JPRB, 0.10586739E-10_JPRB, 0.10768791E-10_JPRB, 0.10899654E-10_JPRB, 0.11042227E-10_JPRB, &
  & 0.11272532E-10_JPRB, 0.11453918E-10_JPRB, 0.11679636E-10_JPRB, 0.11920990E-10_JPRB, 0.12127048E-10_JPRB, 0.12353112E-10_JPRB, &
  & 0.12588097E-10_JPRB, 0.12834255E-10_JPRB, 0.13075716E-10_JPRB, 0.13314516E-10_JPRB, 0.13513531E-10_JPRB, 0.13671896E-10_JPRB, &
  & 0.13820708E-10_JPRB, 0.13979014E-10_JPRB, 0.14185577E-10_JPRB, 0.14491693E-10_JPRB, 0.14915151E-10_JPRB, 0.15496557E-10_JPRB, &
  & 0.16155971E-10_JPRB, 0.16871801E-10_JPRB, 0.17539701E-10_JPRB, 0.18091206E-10_JPRB, 0.18530164E-10_JPRB, 0.18875563E-10_JPRB, &
  & 0.19145590E-10_JPRB, 0.19325168E-10_JPRB, 0.19489615E-10_JPRB, 0.19694683E-10_JPRB, 0.19992128E-10_JPRB, 0.20389170E-10_JPRB, &
  & 0.20820026E-10_JPRB, 0.21306939E-10_JPRB, 0.21833479E-10_JPRB, 0.22455164E-10_JPRB, 0.23126927E-10_JPRB, 0.23811494E-10_JPRB, &
  & 0.24527127E-10_JPRB, 0.25212799E-10_JPRB, 0.25923321E-10_JPRB, 0.26678383E-10_JPRB, 0.27409774E-10_JPRB, 0.28142376E-10_JPRB, &
  & 0.28821947E-10_JPRB, 0.29714911E-10_JPRB, 0.31059648E-10_JPRB, 0.31959040E-10_JPRB, 0.32542719E-10_JPRB, 0.32925704E-10_JPRB, &
  & 0.33190208E-10_JPRB, 0.33364918E-10_JPRB, 0.31772376E-10_JPRB, 0.26867826E-10_JPRB /)

RGHG4(:,73, 9) = (/ &
  & 0.68003160E-11_JPRB, 0.80039638E-11_JPRB, 0.88441060E-11_JPRB, 0.93561825E-11_JPRB, 0.99180351E-11_JPRB, 0.10643284E-10_JPRB, &
  & 0.11459224E-10_JPRB, 0.12148495E-10_JPRB, 0.11899613E-10_JPRB, 0.12095674E-10_JPRB, 0.12316381E-10_JPRB, 0.12447304E-10_JPRB, &
  & 0.12745576E-10_JPRB, 0.12961640E-10_JPRB, 0.13206562E-10_JPRB, 0.13481057E-10_JPRB, 0.13718264E-10_JPRB, 0.13973982E-10_JPRB, &
  & 0.14231481E-10_JPRB, 0.14510371E-10_JPRB, 0.14782188E-10_JPRB, 0.15058564E-10_JPRB, 0.15306962E-10_JPRB, 0.15535592E-10_JPRB, &
  & 0.15777418E-10_JPRB, 0.16046289E-10_JPRB, 0.16367730E-10_JPRB, 0.16791209E-10_JPRB, 0.17346390E-10_JPRB, 0.18046349E-10_JPRB, &
  & 0.18827008E-10_JPRB, 0.19670959E-10_JPRB, 0.20448950E-10_JPRB, 0.21088015E-10_JPRB, 0.21611515E-10_JPRB, 0.22048948E-10_JPRB, &
  & 0.22405265E-10_JPRB, 0.22666251E-10_JPRB, 0.22893411E-10_JPRB, 0.23131162E-10_JPRB, 0.23433686E-10_JPRB, 0.23846166E-10_JPRB, &
  & 0.24316660E-10_JPRB, 0.24879572E-10_JPRB, 0.25514197E-10_JPRB, 0.26221395E-10_JPRB, 0.26981020E-10_JPRB, 0.27748434E-10_JPRB, &
  & 0.28537896E-10_JPRB, 0.29294525E-10_JPRB, 0.30094795E-10_JPRB, 0.30946162E-10_JPRB, 0.31761028E-10_JPRB, 0.32552721E-10_JPRB, &
  & 0.33262074E-10_JPRB, 0.34217820E-10_JPRB, 0.35595672E-10_JPRB, 0.36604435E-10_JPRB, 0.37277962E-10_JPRB, 0.37777646E-10_JPRB, &
  & 0.38122599E-10_JPRB, 0.38369915E-10_JPRB, 0.36695962E-10_JPRB, 0.30690062E-10_JPRB /)

RGHG4(:,74, 9) = (/ &
  & 0.77658652E-11_JPRB, 0.92164410E-11_JPRB, 0.10155075E-10_JPRB, 0.10720196E-10_JPRB, 0.11291855E-10_JPRB, 0.12048777E-10_JPRB, &
  & 0.12870227E-10_JPRB, 0.13605494E-10_JPRB, 0.13306299E-10_JPRB, 0.13597402E-10_JPRB, 0.13827909E-10_JPRB, 0.14008229E-10_JPRB, &
  & 0.14347784E-10_JPRB, 0.14622130E-10_JPRB, 0.14920542E-10_JPRB, 0.15228712E-10_JPRB, 0.15531701E-10_JPRB, 0.15829883E-10_JPRB, &
  & 0.16135464E-10_JPRB, 0.16454688E-10_JPRB, 0.16773543E-10_JPRB, 0.17106264E-10_JPRB, 0.17425726E-10_JPRB, 0.17744658E-10_JPRB, &
  & 0.18100297E-10_JPRB, 0.18497912E-10_JPRB, 0.18946669E-10_JPRB, 0.19503118E-10_JPRB, 0.20209353E-10_JPRB, 0.21011215E-10_JPRB, &
  & 0.21925515E-10_JPRB, 0.22832866E-10_JPRB, 0.23707182E-10_JPRB, 0.24465119E-10_JPRB, 0.25110660E-10_JPRB, 0.25653406E-10_JPRB, &
  & 0.26098082E-10_JPRB, 0.26416220E-10_JPRB, 0.26699190E-10_JPRB, 0.27007832E-10_JPRB, 0.27423029E-10_JPRB, 0.27939444E-10_JPRB, &
  & 0.28495281E-10_JPRB, 0.29116657E-10_JPRB, 0.29795777E-10_JPRB, 0.30575351E-10_JPRB, 0.31417726E-10_JPRB, 0.32277226E-10_JPRB, &
  & 0.33143713E-10_JPRB, 0.33970628E-10_JPRB, 0.34824171E-10_JPRB, 0.35706112E-10_JPRB, 0.36574192E-10_JPRB, 0.37399205E-10_JPRB, &
  & 0.38209644E-10_JPRB, 0.39174494E-10_JPRB, 0.40606830E-10_JPRB, 0.41638810E-10_JPRB, 0.42406318E-10_JPRB, 0.42991746E-10_JPRB, &
  & 0.43418696E-10_JPRB, 0.43722592E-10_JPRB, 0.42062711E-10_JPRB, 0.35467327E-10_JPRB /)

RGHG4(:,75, 9) = (/ &
  & 0.89806374E-11_JPRB, 0.10645113E-10_JPRB, 0.11668813E-10_JPRB, 0.12222749E-10_JPRB, 0.12807595E-10_JPRB, 0.13572967E-10_JPRB, &
  & 0.14423638E-10_JPRB, 0.15142687E-10_JPRB, 0.14917829E-10_JPRB, 0.15206636E-10_JPRB, 0.15583472E-10_JPRB, 0.15778543E-10_JPRB, &
  & 0.16186920E-10_JPRB, 0.16508624E-10_JPRB, 0.16870890E-10_JPRB, 0.17230602E-10_JPRB, 0.17582373E-10_JPRB, 0.17938366E-10_JPRB, &
  & 0.18297509E-10_JPRB, 0.18685241E-10_JPRB, 0.19069713E-10_JPRB, 0.19484801E-10_JPRB, 0.19903345E-10_JPRB, 0.20335145E-10_JPRB, &
  & 0.20824748E-10_JPRB, 0.21368319E-10_JPRB, 0.21956575E-10_JPRB, 0.22678467E-10_JPRB, 0.23528212E-10_JPRB, 0.24457100E-10_JPRB, &
  & 0.25500574E-10_JPRB, 0.26606014E-10_JPRB, 0.27626089E-10_JPRB, 0.28512847E-10_JPRB, 0.29285279E-10_JPRB, 0.29965239E-10_JPRB, &
  & 0.30541309E-10_JPRB, 0.30975607E-10_JPRB, 0.31337107E-10_JPRB, 0.31680169E-10_JPRB, 0.32084130E-10_JPRB, 0.32603864E-10_JPRB, &
  & 0.33189354E-10_JPRB, 0.33897798E-10_JPRB, 0.34691385E-10_JPRB, 0.35572080E-10_JPRB, 0.36511086E-10_JPRB, 0.37429702E-10_JPRB, &
  & 0.38355923E-10_JPRB, 0.39229116E-10_JPRB, 0.40148111E-10_JPRB, 0.41107149E-10_JPRB, 0.42029116E-10_JPRB, 0.42888203E-10_JPRB, &
  & 0.43683390E-10_JPRB, 0.44645284E-10_JPRB, 0.46027050E-10_JPRB, 0.47088104E-10_JPRB, 0.47887978E-10_JPRB, 0.48535839E-10_JPRB, &
  & 0.49042999E-10_JPRB, 0.49397778E-10_JPRB, 0.47818648E-10_JPRB, 0.41370903E-10_JPRB /)

RGHG4(:,76, 9) = (/ &
  & 0.10433504E-10_JPRB, 0.12276138E-10_JPRB, 0.13332206E-10_JPRB, 0.13872953E-10_JPRB, 0.14425858E-10_JPRB, 0.15198251E-10_JPRB, &
  & 0.16074007E-10_JPRB, 0.16860536E-10_JPRB, 0.16579316E-10_JPRB, 0.16992898E-10_JPRB, 0.17314799E-10_JPRB, 0.17672553E-10_JPRB, &
  & 0.18082291E-10_JPRB, 0.18512239E-10_JPRB, 0.18944218E-10_JPRB, 0.19394054E-10_JPRB, 0.19842135E-10_JPRB, 0.20278597E-10_JPRB, &
  & 0.20722441E-10_JPRB, 0.21198298E-10_JPRB, 0.21672322E-10_JPRB, 0.22200124E-10_JPRB, 0.22744051E-10_JPRB, 0.23315343E-10_JPRB, &
  & 0.23966325E-10_JPRB, 0.24670203E-10_JPRB, 0.25420447E-10_JPRB, 0.26337908E-10_JPRB, 0.27309811E-10_JPRB, 0.28409077E-10_JPRB, &
  & 0.29533185E-10_JPRB, 0.30675993E-10_JPRB, 0.31769355E-10_JPRB, 0.32794711E-10_JPRB, 0.33731681E-10_JPRB, 0.34560643E-10_JPRB, &
  & 0.35272729E-10_JPRB, 0.35814497E-10_JPRB, 0.36296129E-10_JPRB, 0.36777879E-10_JPRB, 0.37356163E-10_JPRB, 0.38017721E-10_JPRB, &
  & 0.38710403E-10_JPRB, 0.39482927E-10_JPRB, 0.40303580E-10_JPRB, 0.41224225E-10_JPRB, 0.42219721E-10_JPRB, 0.43209426E-10_JPRB, &
  & 0.44185995E-10_JPRB, 0.45109447E-10_JPRB, 0.46047378E-10_JPRB, 0.47011138E-10_JPRB, 0.47925393E-10_JPRB, 0.48802934E-10_JPRB, &
  & 0.49610344E-10_JPRB, 0.50555587E-10_JPRB, 0.51883241E-10_JPRB, 0.52897724E-10_JPRB, 0.53701411E-10_JPRB, 0.54374470E-10_JPRB, &
  & 0.54941798E-10_JPRB, 0.55357472E-10_JPRB, 0.53989622E-10_JPRB, 0.48339003E-10_JPRB /)

RGHG4(:,77, 9) = (/ &
  & 0.12132807E-10_JPRB, 0.14064748E-10_JPRB, 0.15171709E-10_JPRB, 0.15641264E-10_JPRB, 0.16154784E-10_JPRB, 0.16895806E-10_JPRB, &
  & 0.17778039E-10_JPRB, 0.18594033E-10_JPRB, 0.18374574E-10_JPRB, 0.18830540E-10_JPRB, 0.19268975E-10_JPRB, 0.19671953E-10_JPRB, &
  & 0.20162838E-10_JPRB, 0.20640932E-10_JPRB, 0.21163241E-10_JPRB, 0.21686385E-10_JPRB, 0.22233240E-10_JPRB, 0.22787999E-10_JPRB, &
  & 0.23339304E-10_JPRB, 0.23936334E-10_JPRB, 0.24544075E-10_JPRB, 0.25212497E-10_JPRB, 0.25914370E-10_JPRB, 0.26658354E-10_JPRB, &
  & 0.27488621E-10_JPRB, 0.28359639E-10_JPRB, 0.29301742E-10_JPRB, 0.30409442E-10_JPRB, 0.31509934E-10_JPRB, 0.32765721E-10_JPRB, &
  & 0.34032683E-10_JPRB, 0.35452433E-10_JPRB, 0.36788704E-10_JPRB, 0.38003926E-10_JPRB, 0.39140132E-10_JPRB, 0.40163810E-10_JPRB, &
  & 0.41033850E-10_JPRB, 0.41699144E-10_JPRB, 0.42241780E-10_JPRB, 0.42738087E-10_JPRB, 0.43286260E-10_JPRB, 0.43928212E-10_JPRB, &
  & 0.44624571E-10_JPRB, 0.45470978E-10_JPRB, 0.46381819E-10_JPRB, 0.47390133E-10_JPRB, 0.48448745E-10_JPRB, 0.49447467E-10_JPRB, &
  & 0.50413191E-10_JPRB, 0.51322686E-10_JPRB, 0.52289527E-10_JPRB, 0.53292554E-10_JPRB, 0.54256519E-10_JPRB, 0.55111197E-10_JPRB, &
  & 0.55896836E-10_JPRB, 0.56765516E-10_JPRB, 0.58010152E-10_JPRB, 0.58937535E-10_JPRB, 0.59712721E-10_JPRB, 0.60377023E-10_JPRB, &
  & 0.61006734E-10_JPRB, 0.61486968E-10_JPRB, 0.60398631E-10_JPRB, 0.56402313E-10_JPRB /)

RGHG4(:,78, 9) = (/ &
  & 0.14089658E-10_JPRB, 0.16062693E-10_JPRB, 0.17066635E-10_JPRB, 0.17455370E-10_JPRB, 0.17850046E-10_JPRB, 0.18549138E-10_JPRB, &
  & 0.19412227E-10_JPRB, 0.20245888E-10_JPRB, 0.19992688E-10_JPRB, 0.20543863E-10_JPRB, 0.20935888E-10_JPRB, 0.21471044E-10_JPRB, &
  & 0.21992722E-10_JPRB, 0.22590194E-10_JPRB, 0.23200305E-10_JPRB, 0.23849291E-10_JPRB, 0.24521486E-10_JPRB, 0.25212821E-10_JPRB, &
  & 0.25916694E-10_JPRB, 0.26668872E-10_JPRB, 0.27438829E-10_JPRB, 0.28286855E-10_JPRB, 0.29169861E-10_JPRB, 0.30118765E-10_JPRB, &
  & 0.31134383E-10_JPRB, 0.32160882E-10_JPRB, 0.33323275E-10_JPRB, 0.34545648E-10_JPRB, 0.35798992E-10_JPRB, 0.37147670E-10_JPRB, &
  & 0.38476975E-10_JPRB, 0.39754013E-10_JPRB, 0.41059749E-10_JPRB, 0.42317382E-10_JPRB, 0.43550979E-10_JPRB, 0.44729043E-10_JPRB, &
  & 0.45810068E-10_JPRB, 0.46734634E-10_JPRB, 0.47567471E-10_JPRB, 0.48342070E-10_JPRB, 0.49133631E-10_JPRB, 0.49956175E-10_JPRB, &
  & 0.50775145E-10_JPRB, 0.51659080E-10_JPRB, 0.52556279E-10_JPRB, 0.53528185E-10_JPRB, 0.54561411E-10_JPRB, 0.55523600E-10_JPRB, &
  & 0.56485615E-10_JPRB, 0.57372777E-10_JPRB, 0.58286424E-10_JPRB, 0.59259014E-10_JPRB, 0.60184295E-10_JPRB, 0.61070343E-10_JPRB, &
  & 0.61822984E-10_JPRB, 0.62677086E-10_JPRB, 0.63797349E-10_JPRB, 0.64643860E-10_JPRB, 0.65368447E-10_JPRB, 0.66027683E-10_JPRB, &
  & 0.66706481E-10_JPRB, 0.67290784E-10_JPRB, 0.66711081E-10_JPRB, 0.65498128E-10_JPRB /)

RGHG4(:,79, 9) = (/ &
  & 0.16305315E-10_JPRB, 0.17861051E-10_JPRB, 0.18572404E-10_JPRB, 0.18784313E-10_JPRB, 0.19041803E-10_JPRB, 0.19628493E-10_JPRB, &
  & 0.20402735E-10_JPRB, 0.21187734E-10_JPRB, 0.20994361E-10_JPRB, 0.21483036E-10_JPRB, 0.22015008E-10_JPRB, 0.22495948E-10_JPRB, &
  & 0.23092745E-10_JPRB, 0.23706407E-10_JPRB, 0.24403866E-10_JPRB, 0.25138379E-10_JPRB, 0.25939450E-10_JPRB, 0.26791666E-10_JPRB, &
  & 0.27657090E-10_JPRB, 0.28574337E-10_JPRB, 0.29515047E-10_JPRB, 0.30522355E-10_JPRB, 0.31556775E-10_JPRB, 0.32651548E-10_JPRB, &
  & 0.33749843E-10_JPRB, 0.34828737E-10_JPRB, 0.36063087E-10_JPRB, 0.37165545E-10_JPRB, 0.38401622E-10_JPRB, 0.39548399E-10_JPRB, &
  & 0.40872989E-10_JPRB, 0.42195459E-10_JPRB, 0.43505859E-10_JPRB, 0.44772089E-10_JPRB, 0.46042860E-10_JPRB, 0.47299387E-10_JPRB, &
  & 0.48499538E-10_JPRB, 0.49587664E-10_JPRB, 0.50597842E-10_JPRB, 0.51556426E-10_JPRB, 0.52504855E-10_JPRB, 0.53441491E-10_JPRB, &
  & 0.54323747E-10_JPRB, 0.55289797E-10_JPRB, 0.56220084E-10_JPRB, 0.57204561E-10_JPRB, 0.58205173E-10_JPRB, 0.59106435E-10_JPRB, &
  & 0.59969085E-10_JPRB, 0.60795341E-10_JPRB, 0.61685934E-10_JPRB, 0.62618979E-10_JPRB, 0.63555168E-10_JPRB, 0.64396898E-10_JPRB, &
  & 0.65167725E-10_JPRB, 0.66035649E-10_JPRB, 0.67162886E-10_JPRB, 0.68018466E-10_JPRB, 0.68794206E-10_JPRB, 0.69510259E-10_JPRB, &
  & 0.70292210E-10_JPRB, 0.71102062E-10_JPRB, 0.71287955E-10_JPRB, 0.74320571E-10_JPRB /)

RGHG4(:,80, 9) = (/ &
  & 0.17791662E-10_JPRB, 0.18674205E-10_JPRB, 0.19136149E-10_JPRB, 0.19277999E-10_JPRB, 0.19456048E-10_JPRB, 0.20074203E-10_JPRB, &
  & 0.20856298E-10_JPRB, 0.21668799E-10_JPRB, 0.21589220E-10_JPRB, 0.22044026E-10_JPRB, 0.22594152E-10_JPRB, 0.23126055E-10_JPRB, &
  & 0.23725480E-10_JPRB, 0.24408087E-10_JPRB, 0.25116699E-10_JPRB, 0.25879290E-10_JPRB, 0.26697972E-10_JPRB, 0.27554086E-10_JPRB, &
  & 0.28452534E-10_JPRB, 0.29405960E-10_JPRB, 0.30394656E-10_JPRB, 0.31455866E-10_JPRB, 0.32542410E-10_JPRB, 0.33693454E-10_JPRB, &
  & 0.34780602E-10_JPRB, 0.35957255E-10_JPRB, 0.37200049E-10_JPRB, 0.38357633E-10_JPRB, 0.39700260E-10_JPRB, 0.40941382E-10_JPRB, &
  & 0.42221306E-10_JPRB, 0.43471379E-10_JPRB, 0.44749874E-10_JPRB, 0.46039565E-10_JPRB, 0.47330709E-10_JPRB, 0.48625472E-10_JPRB, &
  & 0.49881863E-10_JPRB, 0.51048540E-10_JPRB, 0.52152130E-10_JPRB, 0.53200021E-10_JPRB, 0.54225350E-10_JPRB, 0.55209264E-10_JPRB, &
  & 0.56123713E-10_JPRB, 0.57062254E-10_JPRB, 0.57961729E-10_JPRB, 0.58936696E-10_JPRB, 0.59967170E-10_JPRB, 0.60879912E-10_JPRB, &
  & 0.61777812E-10_JPRB, 0.62580406E-10_JPRB, 0.63438768E-10_JPRB, 0.64359587E-10_JPRB, 0.65267500E-10_JPRB, 0.66113580E-10_JPRB, &
  & 0.66842615E-10_JPRB, 0.67654028E-10_JPRB, 0.68688007E-10_JPRB, 0.69469763E-10_JPRB, 0.70177121E-10_JPRB, 0.70874140E-10_JPRB, &
  & 0.71648257E-10_JPRB, 0.72549106E-10_JPRB, 0.73076024E-10_JPRB, 0.78968429E-10_JPRB /)

RGHG4(:,81, 9) = (/ &
  & 0.18801566E-10_JPRB, 0.19108713E-10_JPRB, 0.19511096E-10_JPRB, 0.19618652E-10_JPRB, 0.19795188E-10_JPRB, 0.20402973E-10_JPRB, &
  & 0.21155737E-10_JPRB, 0.22014227E-10_JPRB, 0.21916469E-10_JPRB, 0.22442982E-10_JPRB, 0.22981781E-10_JPRB, 0.23503538E-10_JPRB, &
  & 0.24130987E-10_JPRB, 0.24792607E-10_JPRB, 0.25545269E-10_JPRB, 0.26349570E-10_JPRB, 0.27214534E-10_JPRB, 0.28133787E-10_JPRB, &
  & 0.29072883E-10_JPRB, 0.30057748E-10_JPRB, 0.31083226E-10_JPRB, 0.32179592E-10_JPRB, 0.33303610E-10_JPRB, 0.34473511E-10_JPRB, &
  & 0.35560253E-10_JPRB, 0.36843591E-10_JPRB, 0.37936657E-10_JPRB, 0.39175555E-10_JPRB, 0.40340981E-10_JPRB, 0.41593964E-10_JPRB, &
  & 0.42856982E-10_JPRB, 0.44159260E-10_JPRB, 0.45433511E-10_JPRB, 0.46734287E-10_JPRB, 0.48043815E-10_JPRB, 0.49354094E-10_JPRB, &
  & 0.50644464E-10_JPRB, 0.51854913E-10_JPRB, 0.52995278E-10_JPRB, 0.54085687E-10_JPRB, 0.55151026E-10_JPRB, 0.56163567E-10_JPRB, &
  & 0.57101709E-10_JPRB, 0.58083833E-10_JPRB, 0.59037802E-10_JPRB, 0.60027303E-10_JPRB, 0.61010245E-10_JPRB, 0.61895898E-10_JPRB, &
  & 0.62760033E-10_JPRB, 0.63580627E-10_JPRB, 0.64425194E-10_JPRB, 0.65329749E-10_JPRB, 0.66242373E-10_JPRB, 0.67065617E-10_JPRB, &
  & 0.67815094E-10_JPRB, 0.68624537E-10_JPRB, 0.69670138E-10_JPRB, 0.70462129E-10_JPRB, 0.71158100E-10_JPRB, 0.71858852E-10_JPRB, &
  & 0.72619875E-10_JPRB, 0.73549958E-10_JPRB, 0.74297776E-10_JPRB, 0.82204750E-10_JPRB /)

RGHG4(:,82, 9) = (/ &
  & 0.19495490E-10_JPRB, 0.19314895E-10_JPRB, 0.19666550E-10_JPRB, 0.19734098E-10_JPRB, 0.19919580E-10_JPRB, 0.20527731E-10_JPRB, &
  & 0.21321531E-10_JPRB, 0.22204018E-10_JPRB, 0.22212529E-10_JPRB, 0.22713970E-10_JPRB, 0.23263277E-10_JPRB, 0.23797809E-10_JPRB, &
  & 0.24437265E-10_JPRB, 0.25145393E-10_JPRB, 0.25882175E-10_JPRB, 0.26675150E-10_JPRB, 0.27529871E-10_JPRB, 0.28434824E-10_JPRB, &
  & 0.29371013E-10_JPRB, 0.30363819E-10_JPRB, 0.31409226E-10_JPRB, 0.32509152E-10_JPRB, 0.33654926E-10_JPRB, 0.34784765E-10_JPRB, &
  & 0.35932705E-10_JPRB, 0.37193179E-10_JPRB, 0.38270106E-10_JPRB, 0.39617642E-10_JPRB, 0.40795936E-10_JPRB, 0.42107803E-10_JPRB, &
  & 0.43324268E-10_JPRB, 0.44595726E-10_JPRB, 0.45878107E-10_JPRB, 0.47192604E-10_JPRB, 0.48519470E-10_JPRB, 0.49853333E-10_JPRB, &
  & 0.51155982E-10_JPRB, 0.52391074E-10_JPRB, 0.53556111E-10_JPRB, 0.54671791E-10_JPRB, 0.55742171E-10_JPRB, 0.56770245E-10_JPRB, &
  & 0.57707755E-10_JPRB, 0.58671852E-10_JPRB, 0.59586773E-10_JPRB, 0.60593183E-10_JPRB, 0.61632394E-10_JPRB, 0.62560866E-10_JPRB, &
  & 0.63420554E-10_JPRB, 0.64231238E-10_JPRB, 0.65087047E-10_JPRB, 0.65972235E-10_JPRB, 0.66882423E-10_JPRB, 0.67692907E-10_JPRB, &
  & 0.68404463E-10_JPRB, 0.69160150E-10_JPRB, 0.70135273E-10_JPRB, 0.70896310E-10_JPRB, 0.71531128E-10_JPRB, 0.72223671E-10_JPRB, &
  & 0.72948585E-10_JPRB, 0.73899366E-10_JPRB, 0.74699566E-10_JPRB, 0.83885128E-10_JPRB /)

RGHG4(:,83, 9) = (/ &
  & 0.19504490E-10_JPRB, 0.19424615E-10_JPRB, 0.19748363E-10_JPRB, 0.19846376E-10_JPRB, 0.20079233E-10_JPRB, 0.20658249E-10_JPRB, &
  & 0.21489610E-10_JPRB, 0.22440947E-10_JPRB, 0.22350663E-10_JPRB, 0.23043199E-10_JPRB, 0.23448216E-10_JPRB, 0.24051264E-10_JPRB, &
  & 0.24663853E-10_JPRB, 0.25353789E-10_JPRB, 0.26121534E-10_JPRB, 0.26946981E-10_JPRB, 0.27829024E-10_JPRB, 0.28756173E-10_JPRB, &
  & 0.29707025E-10_JPRB, 0.30698517E-10_JPRB, 0.31743806E-10_JPRB, 0.32853741E-10_JPRB, 0.33987424E-10_JPRB, 0.35124494E-10_JPRB, &
  & 0.36348521E-10_JPRB, 0.37509326E-10_JPRB, 0.38694339E-10_JPRB, 0.39908011E-10_JPRB, 0.41122446E-10_JPRB, 0.42377910E-10_JPRB, &
  & 0.43649421E-10_JPRB, 0.44905475E-10_JPRB, 0.46205394E-10_JPRB, 0.47521948E-10_JPRB, 0.48857616E-10_JPRB, 0.50198012E-10_JPRB, &
  & 0.51535366E-10_JPRB, 0.52784305E-10_JPRB, 0.53960874E-10_JPRB, 0.55078622E-10_JPRB, 0.56174794E-10_JPRB, 0.57206608E-10_JPRB, &
  & 0.58179662E-10_JPRB, 0.59204752E-10_JPRB, 0.60117793E-10_JPRB, 0.61161784E-10_JPRB, 0.62119573E-10_JPRB, 0.63047650E-10_JPRB, &
  & 0.63920175E-10_JPRB, 0.64716961E-10_JPRB, 0.65577169E-10_JPRB, 0.66468352E-10_JPRB, 0.67370963E-10_JPRB, 0.68188184E-10_JPRB, &
  & 0.68907005E-10_JPRB, 0.69686708E-10_JPRB, 0.70644740E-10_JPRB, 0.71431930E-10_JPRB, 0.72035919E-10_JPRB, 0.72714154E-10_JPRB, &
  & 0.73392063E-10_JPRB, 0.74299317E-10_JPRB, 0.75042195E-10_JPRB, 0.83517145E-10_JPRB /)

RGHG4(:,84, 9) = (/ &
  & 0.19511337E-10_JPRB, 0.19528512E-10_JPRB, 0.19763880E-10_JPRB, 0.19928252E-10_JPRB, 0.20144450E-10_JPRB, 0.20701317E-10_JPRB, &
  & 0.21660798E-10_JPRB, 0.22457623E-10_JPRB, 0.22672945E-10_JPRB, 0.23161433E-10_JPRB, 0.23707206E-10_JPRB, 0.24217559E-10_JPRB, &
  & 0.24877930E-10_JPRB, 0.25584838E-10_JPRB, 0.26326649E-10_JPRB, 0.27136992E-10_JPRB, 0.28003710E-10_JPRB, 0.28928868E-10_JPRB, &
  & 0.29880293E-10_JPRB, 0.30878133E-10_JPRB, 0.31938358E-10_JPRB, 0.33025933E-10_JPRB, 0.34170489E-10_JPRB, 0.35318141E-10_JPRB, &
  & 0.36543883E-10_JPRB, 0.37664434E-10_JPRB, 0.38924541E-10_JPRB, 0.40132692E-10_JPRB, 0.41395058E-10_JPRB, 0.42642521E-10_JPRB, &
  & 0.43900921E-10_JPRB, 0.45155005E-10_JPRB, 0.46454656E-10_JPRB, 0.47794407E-10_JPRB, 0.49153546E-10_JPRB, 0.50522468E-10_JPRB, &
  & 0.51849663E-10_JPRB, 0.53116660E-10_JPRB, 0.54290156E-10_JPRB, 0.55454100E-10_JPRB, 0.56488057E-10_JPRB, 0.57588354E-10_JPRB, &
  & 0.58456039E-10_JPRB, 0.59541004E-10_JPRB, 0.60380922E-10_JPRB, 0.61501748E-10_JPRB, 0.62502392E-10_JPRB, 0.63419846E-10_JPRB, &
  & 0.64304360E-10_JPRB, 0.65106837E-10_JPRB, 0.65949746E-10_JPRB, 0.66839125E-10_JPRB, 0.67740244E-10_JPRB, 0.68554232E-10_JPRB, &
  & 0.69220019E-10_JPRB, 0.69998583E-10_JPRB, 0.70863392E-10_JPRB, 0.71670642E-10_JPRB, 0.72226218E-10_JPRB, 0.72921273E-10_JPRB, &
  & 0.73573862E-10_JPRB, 0.74478104E-10_JPRB, 0.75291010E-10_JPRB, 0.83668156E-10_JPRB /)

RGHG4(:,85, 9) = (/ &
  & 0.19505871E-10_JPRB, 0.19614881E-10_JPRB, 0.19755850E-10_JPRB, 0.20031627E-10_JPRB, 0.20185801E-10_JPRB, 0.20834917E-10_JPRB, &
  & 0.21777748E-10_JPRB, 0.22690396E-10_JPRB, 0.22846265E-10_JPRB, 0.23433385E-10_JPRB, 0.23865835E-10_JPRB, 0.24449477E-10_JPRB, &
  & 0.25039694E-10_JPRB, 0.25706557E-10_JPRB, 0.26460530E-10_JPRB, 0.27274464E-10_JPRB, 0.28168065E-10_JPRB, 0.29109135E-10_JPRB, &
  & 0.30071761E-10_JPRB, 0.31069258E-10_JPRB, 0.32109242E-10_JPRB, 0.33204984E-10_JPRB, 0.34351789E-10_JPRB, 0.35512541E-10_JPRB, &
  & 0.36683167E-10_JPRB, 0.37887322E-10_JPRB, 0.39094231E-10_JPRB, 0.40297200E-10_JPRB, 0.41549295E-10_JPRB, 0.42811664E-10_JPRB, &
  & 0.44081613E-10_JPRB, 0.45342917E-10_JPRB, 0.46655096E-10_JPRB, 0.47985338E-10_JPRB, 0.49327979E-10_JPRB, 0.50695864E-10_JPRB, &
  & 0.52081336E-10_JPRB, 0.53359907E-10_JPRB, 0.54542829E-10_JPRB, 0.55713548E-10_JPRB, 0.56749765E-10_JPRB, 0.57895622E-10_JPRB, &
  & 0.58790979E-10_JPRB, 0.59916946E-10_JPRB, 0.60790165E-10_JPRB, 0.61819536E-10_JPRB, 0.62828694E-10_JPRB, 0.63731173E-10_JPRB, &
  & 0.64604939E-10_JPRB, 0.65430987E-10_JPRB, 0.66267471E-10_JPRB, 0.67183301E-10_JPRB, 0.68034058E-10_JPRB, 0.68900809E-10_JPRB, &
  & 0.69536911E-10_JPRB, 0.70379036E-10_JPRB, 0.71207214E-10_JPRB, 0.72022735E-10_JPRB, 0.72566016E-10_JPRB, 0.73229971E-10_JPRB, &
  & 0.73879701E-10_JPRB, 0.74701571E-10_JPRB, 0.75508926E-10_JPRB, 0.83738773E-10_JPRB /)

RGHG4(:,86, 9) = (/ &
  & 0.19497222E-10_JPRB, 0.19664376E-10_JPRB, 0.19757864E-10_JPRB, 0.20116370E-10_JPRB, 0.20210184E-10_JPRB, 0.20956702E-10_JPRB, &
  & 0.21955522E-10_JPRB, 0.22759522E-10_JPRB, 0.23181523E-10_JPRB, 0.23580320E-10_JPRB, 0.24116136E-10_JPRB, 0.24600088E-10_JPRB, &
  & 0.25187059E-10_JPRB, 0.25833863E-10_JPRB, 0.26533730E-10_JPRB, 0.27337818E-10_JPRB, 0.28205049E-10_JPRB, 0.29155647E-10_JPRB, &
  & 0.30135446E-10_JPRB, 0.31133016E-10_JPRB, 0.32207004E-10_JPRB, 0.33307360E-10_JPRB, 0.34439798E-10_JPRB, 0.35571369E-10_JPRB, &
  & 0.36780055E-10_JPRB, 0.37957342E-10_JPRB, 0.39160539E-10_JPRB, 0.40416785E-10_JPRB, 0.41675989E-10_JPRB, 0.42946396E-10_JPRB, &
  & 0.44228770E-10_JPRB, 0.45493526E-10_JPRB, 0.46811326E-10_JPRB, 0.48178270E-10_JPRB, 0.49578341E-10_JPRB, 0.50967997E-10_JPRB, &
  & 0.52296452E-10_JPRB, 0.53572143E-10_JPRB, 0.54786176E-10_JPRB, 0.55968483E-10_JPRB, 0.57014178E-10_JPRB, 0.58142807E-10_JPRB, &
  & 0.59000485E-10_JPRB, 0.60102874E-10_JPRB, 0.60987139E-10_JPRB, 0.62057082E-10_JPRB, 0.63061729E-10_JPRB, 0.63978302E-10_JPRB, &
  & 0.64842853E-10_JPRB, 0.65669206E-10_JPRB, 0.66484020E-10_JPRB, 0.67425211E-10_JPRB, 0.68282130E-10_JPRB, 0.69144870E-10_JPRB, &
  & 0.69747971E-10_JPRB, 0.70563819E-10_JPRB, 0.71375066E-10_JPRB, 0.72160833E-10_JPRB, 0.72718762E-10_JPRB, 0.73349292E-10_JPRB, &
  & 0.74056275E-10_JPRB, 0.74831308E-10_JPRB, 0.75670983E-10_JPRB, 0.83780829E-10_JPRB /)

RGHG4(:,87, 9) = (/ &
  & 0.19633652E-10_JPRB, 0.19812089E-10_JPRB, 0.19768917E-10_JPRB, 0.20160226E-10_JPRB, 0.20241728E-10_JPRB, 0.21160464E-10_JPRB, &
  & 0.21978903E-10_JPRB, 0.23117654E-10_JPRB, 0.23294092E-10_JPRB, 0.23803081E-10_JPRB, 0.24289451E-10_JPRB, 0.24765892E-10_JPRB, &
  & 0.25301060E-10_JPRB, 0.25907167E-10_JPRB, 0.26602174E-10_JPRB, 0.27365223E-10_JPRB, 0.28250308E-10_JPRB, 0.29198352E-10_JPRB, &
  & 0.30176091E-10_JPRB, 0.31219912E-10_JPRB, 0.32284994E-10_JPRB, 0.33383657E-10_JPRB, 0.34499268E-10_JPRB, 0.35654681E-10_JPRB, &
  & 0.36823926E-10_JPRB, 0.38013218E-10_JPRB, 0.39231576E-10_JPRB, 0.40474110E-10_JPRB, 0.41747421E-10_JPRB, 0.43050959E-10_JPRB, &
  & 0.44336115E-10_JPRB, 0.45628282E-10_JPRB, 0.46948299E-10_JPRB, 0.48271758E-10_JPRB, 0.49588923E-10_JPRB, 0.50965364E-10_JPRB, &
  & 0.52402829E-10_JPRB, 0.53724743E-10_JPRB, 0.54944063E-10_JPRB, 0.56122135E-10_JPRB, 0.57230196E-10_JPRB, 0.58339888E-10_JPRB, &
  & 0.59337563E-10_JPRB, 0.60341239E-10_JPRB, 0.61281265E-10_JPRB, 0.62271202E-10_JPRB, 0.63281644E-10_JPRB, 0.64175429E-10_JPRB, &
  & 0.65048168E-10_JPRB, 0.65880038E-10_JPRB, 0.66715057E-10_JPRB, 0.67615788E-10_JPRB, 0.68488860E-10_JPRB, 0.69331998E-10_JPRB, &
  & 0.69990132E-10_JPRB, 0.70779195E-10_JPRB, 0.71647376E-10_JPRB, 0.72363136E-10_JPRB, 0.72982648E-10_JPRB, 0.73523257E-10_JPRB, &
  & 0.74267370E-10_JPRB, 0.74990236E-10_JPRB, 0.75801788E-10_JPRB, 0.83818896E-10_JPRB /)

RGHG4(:,88, 9) = (/ &
  & 0.19588739E-10_JPRB, 0.19789394E-10_JPRB, 0.19798758E-10_JPRB, 0.20159489E-10_JPRB, 0.20306220E-10_JPRB, 0.21172558E-10_JPRB, &
  & 0.22135746E-10_JPRB, 0.23090264E-10_JPRB, 0.23412288E-10_JPRB, 0.23927579E-10_JPRB, 0.24349116E-10_JPRB, 0.24846221E-10_JPRB, &
  & 0.25374050E-10_JPRB, 0.25986642E-10_JPRB, 0.26639512E-10_JPRB, 0.27410898E-10_JPRB, 0.28257431E-10_JPRB, 0.29201731E-10_JPRB, &
  & 0.30208065E-10_JPRB, 0.31234532E-10_JPRB, 0.32319043E-10_JPRB, 0.33415170E-10_JPRB, 0.34537671E-10_JPRB, 0.35665592E-10_JPRB, &
  & 0.36837509E-10_JPRB, 0.38020295E-10_JPRB, 0.39228648E-10_JPRB, 0.40486312E-10_JPRB, 0.41778924E-10_JPRB, 0.43085049E-10_JPRB, &
  & 0.44405330E-10_JPRB, 0.45692679E-10_JPRB, 0.47043577E-10_JPRB, 0.48449664E-10_JPRB, 0.49890484E-10_JPRB, 0.51297671E-10_JPRB, &
  & 0.52577963E-10_JPRB, 0.53873139E-10_JPRB, 0.55122996E-10_JPRB, 0.56309648E-10_JPRB, 0.57456238E-10_JPRB, 0.58515102E-10_JPRB, &
  & 0.59498129E-10_JPRB, 0.60526521E-10_JPRB, 0.61427599E-10_JPRB, 0.62439151E-10_JPRB, 0.63440815E-10_JPRB, 0.64325691E-10_JPRB, &
  & 0.65201199E-10_JPRB, 0.66006159E-10_JPRB, 0.66865805E-10_JPRB, 0.67770192E-10_JPRB, 0.68670541E-10_JPRB, 0.69488623E-10_JPRB, &
  & 0.70152842E-10_JPRB, 0.70893832E-10_JPRB, 0.71778319E-10_JPRB, 0.72452939E-10_JPRB, 0.73098930E-10_JPRB, 0.73617897E-10_JPRB, &
  & 0.74373292E-10_JPRB, 0.75102757E-10_JPRB, 0.75896969E-10_JPRB, 0.83832136E-10_JPRB /)

RGHG4(:,89, 9) = (/ &
  & 0.19432424E-10_JPRB, 0.19798161E-10_JPRB, 0.19828070E-10_JPRB, 0.20135071E-10_JPRB, 0.20319420E-10_JPRB, 0.21136372E-10_JPRB, &
  & 0.21975812E-10_JPRB, 0.23139631E-10_JPRB, 0.23394033E-10_JPRB, 0.23856675E-10_JPRB, 0.24356669E-10_JPRB, 0.24813793E-10_JPRB, &
  & 0.25382694E-10_JPRB, 0.25992229E-10_JPRB, 0.26689977E-10_JPRB, 0.27458438E-10_JPRB, 0.28324497E-10_JPRB, 0.29291344E-10_JPRB, &
  & 0.30258556E-10_JPRB, 0.31292389E-10_JPRB, 0.32343090E-10_JPRB, 0.33438991E-10_JPRB, 0.34527693E-10_JPRB, 0.35646430E-10_JPRB, &
  & 0.36798037E-10_JPRB, 0.37966710E-10_JPRB, 0.39173890E-10_JPRB, 0.40429691E-10_JPRB, 0.41728440E-10_JPRB, 0.43064937E-10_JPRB, &
  & 0.44397493E-10_JPRB, 0.45719935E-10_JPRB, 0.47056862E-10_JPRB, 0.48398608E-10_JPRB, 0.49709511E-10_JPRB, 0.51092588E-10_JPRB, &
  & 0.52615634E-10_JPRB, 0.53966127E-10_JPRB, 0.55253042E-10_JPRB, 0.56453366E-10_JPRB, 0.57612644E-10_JPRB, 0.58707705E-10_JPRB, &
  & 0.59704401E-10_JPRB, 0.60699369E-10_JPRB, 0.61616601E-10_JPRB, 0.62587081E-10_JPRB, 0.63590487E-10_JPRB, 0.64458112E-10_JPRB, &
  & 0.65346735E-10_JPRB, 0.66152951E-10_JPRB, 0.67004853E-10_JPRB, 0.67898069E-10_JPRB, 0.68797551E-10_JPRB, 0.69620233E-10_JPRB, &
  & 0.70299766E-10_JPRB, 0.71052435E-10_JPRB, 0.71942015E-10_JPRB, 0.72609044E-10_JPRB, 0.73255436E-10_JPRB, 0.73760192E-10_JPRB, &
  & 0.74496763E-10_JPRB, 0.75219754E-10_JPRB, 0.75973547E-10_JPRB, 0.83837041E-10_JPRB /)

RGHG4(:,90, 9) = (/ &
  & 0.19491598E-10_JPRB, 0.19814360E-10_JPRB, 0.19832721E-10_JPRB, 0.20091628E-10_JPRB, 0.20262745E-10_JPRB, 0.20902419E-10_JPRB, &
  & 0.21874658E-10_JPRB, 0.22862861E-10_JPRB, 0.23140198E-10_JPRB, 0.23710842E-10_JPRB, 0.24169789E-10_JPRB, 0.24713540E-10_JPRB, &
  & 0.25301006E-10_JPRB, 0.25972741E-10_JPRB, 0.26703632E-10_JPRB, 0.27500653E-10_JPRB, 0.28394139E-10_JPRB, 0.29326094E-10_JPRB, &
  & 0.30295173E-10_JPRB, 0.31289207E-10_JPRB, 0.32328373E-10_JPRB, 0.33387907E-10_JPRB, 0.34453811E-10_JPRB, 0.35549397E-10_JPRB, &
  & 0.36667946E-10_JPRB, 0.37816802E-10_JPRB, 0.39014385E-10_JPRB, 0.40271383E-10_JPRB, 0.41585214E-10_JPRB, 0.42939433E-10_JPRB, &
  & 0.44309095E-10_JPRB, 0.45667730E-10_JPRB, 0.47071132E-10_JPRB, 0.48533882E-10_JPRB, 0.50046151E-10_JPRB, 0.51528858E-10_JPRB, &
  & 0.52776259E-10_JPRB, 0.54146781E-10_JPRB, 0.55413580E-10_JPRB, 0.56626245E-10_JPRB, 0.57794991E-10_JPRB, 0.58873323E-10_JPRB, &
  & 0.59866612E-10_JPRB, 0.60850908E-10_JPRB, 0.61746726E-10_JPRB, 0.62709900E-10_JPRB, 0.63700031E-10_JPRB, 0.64558865E-10_JPRB, &
  & 0.65432909E-10_JPRB, 0.66242414E-10_JPRB, 0.67105876E-10_JPRB, 0.68013595E-10_JPRB, 0.68916491E-10_JPRB, 0.69744426E-10_JPRB, &
  & 0.70406431E-10_JPRB, 0.71159981E-10_JPRB, 0.72040020E-10_JPRB, 0.72696321E-10_JPRB, 0.73337912E-10_JPRB, 0.73841842E-10_JPRB, &
  & 0.74587649E-10_JPRB, 0.75305533E-10_JPRB, 0.76003502E-10_JPRB, 0.83831969E-10_JPRB /)

RGHG4(:,91, 9) = (/ &
  & 0.19716267E-10_JPRB, 0.19804743E-10_JPRB, 0.19833657E-10_JPRB, 0.19978763E-10_JPRB, 0.20194750E-10_JPRB, 0.20738694E-10_JPRB, &
  & 0.19482103E-10_JPRB, 0.21710285E-10_JPRB, 0.22786472E-10_JPRB, 0.23360584E-10_JPRB, 0.23899428E-10_JPRB, 0.24470152E-10_JPRB, &
  & 0.25130970E-10_JPRB, 0.25881930E-10_JPRB, 0.26672754E-10_JPRB, 0.27521430E-10_JPRB, 0.28422162E-10_JPRB, 0.29361950E-10_JPRB, &
  & 0.30300540E-10_JPRB, 0.31262298E-10_JPRB, 0.32250660E-10_JPRB, 0.33256946E-10_JPRB, 0.34264841E-10_JPRB, 0.35326117E-10_JPRB, &
  & 0.36407263E-10_JPRB, 0.37498477E-10_JPRB, 0.38718424E-10_JPRB, 0.39990306E-10_JPRB, 0.41315153E-10_JPRB, 0.42678146E-10_JPRB, &
  & 0.44095894E-10_JPRB, 0.45507605E-10_JPRB, 0.46907696E-10_JPRB, 0.48369846E-10_JPRB, 0.49796771E-10_JPRB, 0.51274703E-10_JPRB, &
  & 0.52805833E-10_JPRB, 0.54223678E-10_JPRB, 0.55555859E-10_JPRB, 0.56812055E-10_JPRB, 0.55398366E-10_JPRB, 0.56575106E-10_JPRB, &
  & 0.60065820E-10_JPRB, 0.61033026E-10_JPRB, 0.61913842E-10_JPRB, 0.62860592E-10_JPRB, 0.63831697E-10_JPRB, 0.64681149E-10_JPRB, &
  & 0.65550905E-10_JPRB, 0.66351181E-10_JPRB, 0.67208808E-10_JPRB, 0.68119191E-10_JPRB, 0.69020407E-10_JPRB, 0.69856676E-10_JPRB, &
  & 0.70516495E-10_JPRB, 0.71281266E-10_JPRB, 0.72170457E-10_JPRB, 0.72807968E-10_JPRB, 0.73454562E-10_JPRB, 0.73923555E-10_JPRB, &
  & 0.74683683E-10_JPRB, 0.75431564E-10_JPRB, 0.75974019E-10_JPRB, 0.83813484E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG4(:, 1,10) = (/ &
  & 0.33414637E-13_JPRB, 0.49600898E-13_JPRB, 0.65506723E-13_JPRB, 0.81757545E-13_JPRB, 0.97110850E-13_JPRB, 0.10248880E-12_JPRB, &
  & 0.10268444E-12_JPRB, 0.10168862E-12_JPRB, 0.10089433E-12_JPRB, 0.10253835E-12_JPRB, 0.98725173E-13_JPRB, 0.10062657E-12_JPRB, &
  & 0.98329615E-13_JPRB, 0.99276185E-13_JPRB, 0.10105535E-12_JPRB, 0.10393785E-12_JPRB, 0.10170617E-12_JPRB, 0.10367168E-12_JPRB, &
  & 0.10587730E-12_JPRB, 0.10767060E-12_JPRB, 0.10934732E-12_JPRB, 0.11098066E-12_JPRB, 0.10699322E-12_JPRB, 0.10700966E-12_JPRB, &
  & 0.10742918E-12_JPRB, 0.10832282E-12_JPRB, 0.10973526E-12_JPRB, 0.11149197E-12_JPRB, 0.11341864E-12_JPRB, 0.11529513E-12_JPRB, &
  & 0.11693241E-12_JPRB, 0.11856571E-12_JPRB, 0.11249436E-12_JPRB, 0.11106429E-12_JPRB, 0.10934139E-12_JPRB, 0.10789338E-12_JPRB, &
  & 0.10693336E-12_JPRB, 0.10683061E-12_JPRB, 0.10747096E-12_JPRB, 0.10903056E-12_JPRB, 0.11145981E-12_JPRB, 0.10761215E-12_JPRB, &
  & 0.10859702E-12_JPRB, 0.10939321E-12_JPRB, 0.10992086E-12_JPRB, 0.11009658E-12_JPRB, 0.11002261E-12_JPRB, 0.11052370E-12_JPRB, &
  & 0.10321464E-12_JPRB, 0.10174186E-12_JPRB, 0.10027446E-12_JPRB, 0.10012629E-12_JPRB, 0.92473175E-13_JPRB, 0.90802271E-13_JPRB, &
  & 0.84068786E-13_JPRB, 0.82406853E-13_JPRB, 0.76232484E-13_JPRB, 0.76016484E-13_JPRB, 0.93629802E-13_JPRB, 0.97190112E-09_JPRB, &
  & 0.97290231E-09_JPRB, 0.97306518E-09_JPRB, 0.97276476E-09_JPRB, 0.97236352E-09_JPRB /)

RGHG4(:, 2,10) = (/ &
  & 0.40866873E-12_JPRB, 0.35108309E-12_JPRB, 0.32665141E-12_JPRB, 0.31108528E-12_JPRB, 0.29751763E-12_JPRB, 0.28589072E-12_JPRB, &
  & 0.27691434E-12_JPRB, 0.27537768E-12_JPRB, 0.31799609E-12_JPRB, 0.35406864E-12_JPRB, 0.39676370E-12_JPRB, 0.44693589E-12_JPRB, &
  & 0.50213983E-12_JPRB, 0.56532985E-12_JPRB, 0.63701513E-12_JPRB, 0.70986110E-12_JPRB, 0.77137043E-12_JPRB, 0.82299857E-12_JPRB, &
  & 0.87524692E-12_JPRB, 0.91268215E-12_JPRB, 0.93256848E-12_JPRB, 0.93096266E-12_JPRB, 0.90673725E-12_JPRB, 0.85746276E-12_JPRB, &
  & 0.81128442E-12_JPRB, 0.76343906E-12_JPRB, 0.71259730E-12_JPRB, 0.65872481E-12_JPRB, 0.60285061E-12_JPRB, 0.54905635E-12_JPRB, &
  & 0.50331343E-12_JPRB, 0.46945542E-12_JPRB, 0.44702135E-12_JPRB, 0.43036741E-12_JPRB, 0.43599312E-12_JPRB, 0.44549813E-12_JPRB, &
  & 0.46042895E-12_JPRB, 0.47778562E-12_JPRB, 0.50841471E-12_JPRB, 0.55380212E-12_JPRB, 0.61030266E-12_JPRB, 0.65714144E-12_JPRB, &
  & 0.67325041E-12_JPRB, 0.67395183E-12_JPRB, 0.65863135E-12_JPRB, 0.62932900E-12_JPRB, 0.59000065E-12_JPRB, 0.54405655E-12_JPRB, &
  & 0.49779137E-12_JPRB, 0.45448259E-12_JPRB, 0.42525681E-12_JPRB, 0.40681027E-12_JPRB, 0.39123435E-12_JPRB, 0.37335282E-12_JPRB, &
  & 0.35552510E-12_JPRB, 0.33568192E-12_JPRB, 0.31633536E-12_JPRB, 0.29578252E-12_JPRB, 0.27561371E-12_JPRB, 0.39285845E-10_JPRB, &
  & 0.19009570E-10_JPRB, 0.16490516E-10_JPRB, 0.18510060E-10_JPRB, 0.10041813E-19_JPRB /)

RGHG4(:, 3,10) = (/ &
  & 0.11884422E-11_JPRB, 0.10945181E-11_JPRB, 0.10304056E-11_JPRB, 0.98005100E-12_JPRB, 0.93873672E-12_JPRB, 0.90822255E-12_JPRB, &
  & 0.88282626E-12_JPRB, 0.86954510E-12_JPRB, 0.95758666E-12_JPRB, 0.10035767E-11_JPRB, 0.10666449E-11_JPRB, 0.11423196E-11_JPRB, &
  & 0.12242195E-11_JPRB, 0.13156088E-11_JPRB, 0.14197318E-11_JPRB, 0.15346470E-11_JPRB, 0.16416038E-11_JPRB, 0.17365730E-11_JPRB, &
  & 0.18182678E-11_JPRB, 0.18765902E-11_JPRB, 0.18994153E-11_JPRB, 0.18809537E-11_JPRB, 0.18152628E-11_JPRB, 0.17131287E-11_JPRB, &
  & 0.16202012E-11_JPRB, 0.15110869E-11_JPRB, 0.13980153E-11_JPRB, 0.12821311E-11_JPRB, 0.11679986E-11_JPRB, 0.10645948E-11_JPRB, &
  & 0.97454098E-12_JPRB, 0.89552606E-12_JPRB, 0.82132391E-12_JPRB, 0.75786306E-12_JPRB, 0.74189830E-12_JPRB, 0.76299996E-12_JPRB, &
  & 0.82260679E-12_JPRB, 0.91508452E-12_JPRB, 0.10285843E-11_JPRB, 0.11467365E-11_JPRB, 0.12576360E-11_JPRB, 0.13440162E-11_JPRB, &
  & 0.13857681E-11_JPRB, 0.13925262E-11_JPRB, 0.13615644E-11_JPRB, 0.13070545E-11_JPRB, 0.12298345E-11_JPRB, 0.11397778E-11_JPRB, &
  & 0.10473082E-11_JPRB, 0.95155134E-12_JPRB, 0.86089659E-12_JPRB, 0.77540752E-12_JPRB, 0.69655371E-12_JPRB, 0.62998375E-12_JPRB, &
  & 0.58351045E-12_JPRB, 0.54536220E-12_JPRB, 0.50980628E-12_JPRB, 0.48051352E-12_JPRB, 0.45722085E-12_JPRB, 0.63342143E-09_JPRB, &
  & 0.57248595E-09_JPRB, 0.50674881E-09_JPRB, 0.46414136E-09_JPRB, 0.40888981E-09_JPRB /)

RGHG4(:, 4,10) = (/ &
  & 0.32356641E-11_JPRB, 0.29052730E-11_JPRB, 0.26861395E-11_JPRB, 0.25448142E-11_JPRB, 0.24522910E-11_JPRB, 0.24241687E-11_JPRB, &
  & 0.24270759E-11_JPRB, 0.24742133E-11_JPRB, 0.26941832E-11_JPRB, 0.27800553E-11_JPRB, 0.28899257E-11_JPRB, 0.30252339E-11_JPRB, &
  & 0.31810930E-11_JPRB, 0.33612915E-11_JPRB, 0.35237557E-11_JPRB, 0.36698452E-11_JPRB, 0.38024254E-11_JPRB, 0.39178248E-11_JPRB, &
  & 0.40189215E-11_JPRB, 0.40797730E-11_JPRB, 0.40825390E-11_JPRB, 0.40068799E-11_JPRB, 0.38286106E-11_JPRB, 0.35880611E-11_JPRB, &
  & 0.33405362E-11_JPRB, 0.30975398E-11_JPRB, 0.28479092E-11_JPRB, 0.26168178E-11_JPRB, 0.24054081E-11_JPRB, 0.22208509E-11_JPRB, &
  & 0.20565526E-11_JPRB, 0.19195572E-11_JPRB, 0.18273944E-11_JPRB, 0.17814235E-11_JPRB, 0.18193622E-11_JPRB, 0.19197437E-11_JPRB, &
  & 0.20854275E-11_JPRB, 0.22903374E-11_JPRB, 0.25267444E-11_JPRB, 0.27626790E-11_JPRB, 0.29746834E-11_JPRB, 0.31261170E-11_JPRB, &
  & 0.32016902E-11_JPRB, 0.32141588E-11_JPRB, 0.31526394E-11_JPRB, 0.30384189E-11_JPRB, 0.28826223E-11_JPRB, 0.26997814E-11_JPRB, &
  & 0.25104396E-11_JPRB, 0.23102700E-11_JPRB, 0.21114538E-11_JPRB, 0.19158668E-11_JPRB, 0.17237644E-11_JPRB, 0.15341863E-11_JPRB, &
  & 0.13597464E-11_JPRB, 0.12077096E-11_JPRB, 0.10837413E-11_JPRB, 0.99700597E-12_JPRB, 0.95923963E-12_JPRB, 0.95734420E-09_JPRB, &
  & 0.90971952E-09_JPRB, 0.88565139E-09_JPRB, 0.86966190E-09_JPRB, 0.84245527E-09_JPRB /)

RGHG4(:, 5,10) = (/ &
  & 0.86637199E-11_JPRB, 0.77889310E-11_JPRB, 0.71974878E-11_JPRB, 0.68164732E-11_JPRB, 0.66169288E-11_JPRB, 0.66644108E-11_JPRB, &
  & 0.68057608E-11_JPRB, 0.69974616E-11_JPRB, 0.72988126E-11_JPRB, 0.75283174E-11_JPRB, 0.78060483E-11_JPRB, 0.81032620E-11_JPRB, &
  & 0.83850279E-11_JPRB, 0.86869409E-11_JPRB, 0.89904629E-11_JPRB, 0.92761007E-11_JPRB, 0.95008688E-11_JPRB, 0.96650066E-11_JPRB, &
  & 0.97898738E-11_JPRB, 0.98449677E-11_JPRB, 0.98143915E-11_JPRB, 0.96464026E-11_JPRB, 0.92876089E-11_JPRB, 0.88366935E-11_JPRB, &
  & 0.82850836E-11_JPRB, 0.77053208E-11_JPRB, 0.71770667E-11_JPRB, 0.67278271E-11_JPRB, 0.63680519E-11_JPRB, 0.61032021E-11_JPRB, &
  & 0.59291842E-11_JPRB, 0.58450905E-11_JPRB, 0.58483821E-11_JPRB, 0.59060560E-11_JPRB, 0.60861546E-11_JPRB, 0.63466138E-11_JPRB, &
  & 0.67165527E-11_JPRB, 0.71486051E-11_JPRB, 0.76323548E-11_JPRB, 0.80935354E-11_JPRB, 0.84610487E-11_JPRB, 0.86559726E-11_JPRB, &
  & 0.86622124E-11_JPRB, 0.85246211E-11_JPRB, 0.82566584E-11_JPRB, 0.78989757E-11_JPRB, 0.74865244E-11_JPRB, 0.70349481E-11_JPRB, &
  & 0.65762669E-11_JPRB, 0.60943828E-11_JPRB, 0.56026021E-11_JPRB, 0.51098691E-11_JPRB, 0.46156052E-11_JPRB, 0.41347282E-11_JPRB, &
  & 0.36891709E-11_JPRB, 0.32915998E-11_JPRB, 0.29615260E-11_JPRB, 0.27222775E-11_JPRB, 0.27434277E-11_JPRB, 0.18417573E-08_JPRB, &
  & 0.17024547E-08_JPRB, 0.15885389E-08_JPRB, 0.15034477E-08_JPRB, 0.14027529E-08_JPRB /)

RGHG4(:, 6,10) = (/ &
  & 0.24464916E-10_JPRB, 0.21907028E-10_JPRB, 0.20062443E-10_JPRB, 0.18876543E-10_JPRB, 0.18149305E-10_JPRB, 0.18204953E-10_JPRB, &
  & 0.18553282E-10_JPRB, 0.18920771E-10_JPRB, 0.19337278E-10_JPRB, 0.19849108E-10_JPRB, 0.20437816E-10_JPRB, 0.21074000E-10_JPRB, &
  & 0.21692969E-10_JPRB, 0.22248019E-10_JPRB, 0.22721516E-10_JPRB, 0.23166399E-10_JPRB, 0.23565897E-10_JPRB, 0.23895953E-10_JPRB, &
  & 0.24164755E-10_JPRB, 0.24293590E-10_JPRB, 0.24251641E-10_JPRB, 0.24005912E-10_JPRB, 0.23486258E-10_JPRB, 0.22796388E-10_JPRB, &
  & 0.22074448E-10_JPRB, 0.21407133E-10_JPRB, 0.20848342E-10_JPRB, 0.20446780E-10_JPRB, 0.20223033E-10_JPRB, 0.20163055E-10_JPRB, &
  & 0.20256345E-10_JPRB, 0.20451151E-10_JPRB, 0.20771716E-10_JPRB, 0.21003518E-10_JPRB, 0.21278536E-10_JPRB, 0.21552602E-10_JPRB, &
  & 0.21891882E-10_JPRB, 0.22282020E-10_JPRB, 0.22689633E-10_JPRB, 0.23035740E-10_JPRB, 0.23222028E-10_JPRB, 0.23180695E-10_JPRB, &
  & 0.22891399E-10_JPRB, 0.22387873E-10_JPRB, 0.21717529E-10_JPRB, 0.20929158E-10_JPRB, 0.20049065E-10_JPRB, 0.19086469E-10_JPRB, &
  & 0.18066331E-10_JPRB, 0.16979402E-10_JPRB, 0.15842593E-10_JPRB, 0.14675964E-10_JPRB, 0.13503148E-10_JPRB, 0.12345105E-10_JPRB, &
  & 0.11259126E-10_JPRB, 0.10287347E-10_JPRB, 0.95239953E-11_JPRB, 0.91877504E-11_JPRB, 0.10801199E-10_JPRB, 0.29953606E-08_JPRB, &
  & 0.28141416E-08_JPRB, 0.26875013E-08_JPRB, 0.25792843E-08_JPRB, 0.24433238E-08_JPRB /)

RGHG4(:, 7,10) = (/ &
  & 0.65943986E-10_JPRB, 0.59781957E-10_JPRB, 0.54823777E-10_JPRB, 0.51318071E-10_JPRB, 0.49083501E-10_JPRB, 0.48632591E-10_JPRB, &
  & 0.49134544E-10_JPRB, 0.49764626E-10_JPRB, 0.50570530E-10_JPRB, 0.51631831E-10_JPRB, 0.52894172E-10_JPRB, 0.54217242E-10_JPRB, &
  & 0.55502398E-10_JPRB, 0.56689431E-10_JPRB, 0.57762573E-10_JPRB, 0.58740054E-10_JPRB, 0.59561384E-10_JPRB, 0.60179695E-10_JPRB, &
  & 0.60692715E-10_JPRB, 0.61125417E-10_JPRB, 0.61522919E-10_JPRB, 0.61806928E-10_JPRB, 0.61688182E-10_JPRB, 0.61254404E-10_JPRB, &
  & 0.60755255E-10_JPRB, 0.60302673E-10_JPRB, 0.60054836E-10_JPRB, 0.60127493E-10_JPRB, 0.60520415E-10_JPRB, 0.61187402E-10_JPRB, &
  & 0.61985896E-10_JPRB, 0.62850627E-10_JPRB, 0.63728127E-10_JPRB, 0.64059869E-10_JPRB, 0.64094598E-10_JPRB, 0.63971960E-10_JPRB, &
  & 0.63725643E-10_JPRB, 0.63526760E-10_JPRB, 0.63311890E-10_JPRB, 0.63045909E-10_JPRB, 0.62560693E-10_JPRB, 0.61780359E-10_JPRB, &
  & 0.60638980E-10_JPRB, 0.59171654E-10_JPRB, 0.57477564E-10_JPRB, 0.55692811E-10_JPRB, 0.53849984E-10_JPRB, 0.52002572E-10_JPRB, &
  & 0.50184901E-10_JPRB, 0.48330250E-10_JPRB, 0.46352956E-10_JPRB, 0.44151897E-10_JPRB, 0.41848667E-10_JPRB, 0.39517799E-10_JPRB, &
  & 0.37393699E-10_JPRB, 0.35658854E-10_JPRB, 0.34852461E-10_JPRB, 0.36215718E-10_JPRB, 0.45483783E-10_JPRB, 0.51039448E-08_JPRB, &
  & 0.48073110E-08_JPRB, 0.45924606E-08_JPRB, 0.44220587E-08_JPRB, 0.41944159E-08_JPRB /)

RGHG4(:, 8,10) = (/ &
  & 0.16646209E-09_JPRB, 0.15454782E-09_JPRB, 0.14295376E-09_JPRB, 0.13372362E-09_JPRB, 0.12770451E-09_JPRB, 0.12644895E-09_JPRB, &
  & 0.12758083E-09_JPRB, 0.12872710E-09_JPRB, 0.13019867E-09_JPRB, 0.13239589E-09_JPRB, 0.13501245E-09_JPRB, 0.13773835E-09_JPRB, &
  & 0.14042145E-09_JPRB, 0.14280153E-09_JPRB, 0.14489547E-09_JPRB, 0.14682056E-09_JPRB, 0.14856630E-09_JPRB, 0.15007139E-09_JPRB, &
  & 0.15155238E-09_JPRB, 0.15300319E-09_JPRB, 0.15446033E-09_JPRB, 0.15621107E-09_JPRB, 0.15793072E-09_JPRB, 0.15948423E-09_JPRB, &
  & 0.16112084E-09_JPRB, 0.16276974E-09_JPRB, 0.16452756E-09_JPRB, 0.16641533E-09_JPRB, 0.16841688E-09_JPRB, 0.17048124E-09_JPRB, &
  & 0.17234345E-09_JPRB, 0.17414906E-09_JPRB, 0.17601116E-09_JPRB, 0.17660086E-09_JPRB, 0.17600620E-09_JPRB, 0.17515177E-09_JPRB, &
  & 0.17368026E-09_JPRB, 0.17221363E-09_JPRB, 0.17071292E-09_JPRB, 0.16928575E-09_JPRB, 0.16784102E-09_JPRB, 0.16637149E-09_JPRB, &
  & 0.16455810E-09_JPRB, 0.16213444E-09_JPRB, 0.15922656E-09_JPRB, 0.15620087E-09_JPRB, 0.15305794E-09_JPRB, 0.14990173E-09_JPRB, &
  & 0.14667255E-09_JPRB, 0.14311818E-09_JPRB, 0.13923394E-09_JPRB, 0.13507305E-09_JPRB, 0.13135416E-09_JPRB, 0.12835255E-09_JPRB, &
  & 0.12663638E-09_JPRB, 0.12698564E-09_JPRB, 0.13053442E-09_JPRB, 0.13945341E-09_JPRB, 0.15906228E-09_JPRB, 0.77702262E-08_JPRB, &
  & 0.72657387E-08_JPRB, 0.69044495E-08_JPRB, 0.66316992E-08_JPRB, 0.62845076E-08_JPRB /)

RGHG4(:, 9,10) = (/ &
  & 0.40222006E-09_JPRB, 0.37390266E-09_JPRB, 0.34973618E-09_JPRB, 0.33045752E-09_JPRB, 0.31622788E-09_JPRB, 0.31044031E-09_JPRB, &
  & 0.31108918E-09_JPRB, 0.31280303E-09_JPRB, 0.31539182E-09_JPRB, 0.31907835E-09_JPRB, 0.32365313E-09_JPRB, 0.32845279E-09_JPRB, &
  & 0.33309419E-09_JPRB, 0.33716888E-09_JPRB, 0.34100314E-09_JPRB, 0.34475645E-09_JPRB, 0.34824379E-09_JPRB, 0.35118972E-09_JPRB, &
  & 0.35418285E-09_JPRB, 0.35776421E-09_JPRB, 0.36266631E-09_JPRB, 0.36964137E-09_JPRB, 0.37695821E-09_JPRB, 0.38328424E-09_JPRB, &
  & 0.38914655E-09_JPRB, 0.39487405E-09_JPRB, 0.40068027E-09_JPRB, 0.40651402E-09_JPRB, 0.41220571E-09_JPRB, 0.41760806E-09_JPRB, &
  & 0.42225778E-09_JPRB, 0.42647416E-09_JPRB, 0.43135864E-09_JPRB, 0.43348430E-09_JPRB, 0.43253862E-09_JPRB, 0.43139267E-09_JPRB, &
  & 0.42911663E-09_JPRB, 0.42691933E-09_JPRB, 0.42481113E-09_JPRB, 0.42312279E-09_JPRB, 0.42176881E-09_JPRB, 0.42125492E-09_JPRB, &
  & 0.42062803E-09_JPRB, 0.41901918E-09_JPRB, 0.41645193E-09_JPRB, 0.41386003E-09_JPRB, 0.41112155E-09_JPRB, 0.40853712E-09_JPRB, &
  & 0.40615486E-09_JPRB, 0.40328346E-09_JPRB, 0.39994513E-09_JPRB, 0.39614245E-09_JPRB, 0.39298748E-09_JPRB, 0.39066991E-09_JPRB, &
  & 0.39008047E-09_JPRB, 0.39064868E-09_JPRB, 0.38994372E-09_JPRB, 0.38412659E-09_JPRB, 0.38558945E-09_JPRB, 0.10316821E-07_JPRB, &
  & 0.94199946E-08_JPRB, 0.88462508E-08_JPRB, 0.83574481E-08_JPRB, 0.79271665E-08_JPRB /)

RGHG4(:,10,10) = (/ &
  & 0.77499862E-09_JPRB, 0.75238310E-09_JPRB, 0.72258016E-09_JPRB, 0.69979300E-09_JPRB, 0.68449352E-09_JPRB, 0.67945510E-09_JPRB, &
  & 0.68284284E-09_JPRB, 0.68647282E-09_JPRB, 0.69104128E-09_JPRB, 0.69757455E-09_JPRB, 0.70559469E-09_JPRB, 0.71391476E-09_JPRB, &
  & 0.72210182E-09_JPRB, 0.72915207E-09_JPRB, 0.73562867E-09_JPRB, 0.74193601E-09_JPRB, 0.74801637E-09_JPRB, 0.75342488E-09_JPRB, &
  & 0.75948636E-09_JPRB, 0.76711765E-09_JPRB, 0.77721046E-09_JPRB, 0.79129403E-09_JPRB, 0.80688395E-09_JPRB, 0.82195800E-09_JPRB, &
  & 0.83762769E-09_JPRB, 0.85345858E-09_JPRB, 0.86874846E-09_JPRB, 0.88337521E-09_JPRB, 0.89681090E-09_JPRB, 0.91043656E-09_JPRB, &
  & 0.92322333E-09_JPRB, 0.93597552E-09_JPRB, 0.95063302E-09_JPRB, 0.95974384E-09_JPRB, 0.96284514E-09_JPRB, 0.96512798E-09_JPRB, &
  & 0.96535735E-09_JPRB, 0.96522801E-09_JPRB, 0.96507036E-09_JPRB, 0.96558184E-09_JPRB, 0.96716568E-09_JPRB, 0.97128028E-09_JPRB, &
  & 0.97587916E-09_JPRB, 0.97868158E-09_JPRB, 0.97980801E-09_JPRB, 0.98071617E-09_JPRB, 0.98115072E-09_JPRB, 0.98152397E-09_JPRB, &
  & 0.98228126E-09_JPRB, 0.98131603E-09_JPRB, 0.97783570E-09_JPRB, 0.97150799E-09_JPRB, 0.96320585E-09_JPRB, 0.95057984E-09_JPRB, &
  & 0.93128305E-09_JPRB, 0.89930002E-09_JPRB, 0.85019697E-09_JPRB, 0.78558132E-09_JPRB, 0.72743356E-09_JPRB, 0.12181195E-07_JPRB, &
  & 0.10880614E-07_JPRB, 0.99320605E-08_JPRB, 0.93571719E-08_JPRB, 0.86606518E-08_JPRB /)

RGHG4(:,11,10) = (/ &
  & 0.13718585E-08_JPRB, 0.13503068E-08_JPRB, 0.13224583E-08_JPRB, 0.13000458E-08_JPRB, 0.12881456E-08_JPRB, 0.12893694E-08_JPRB, &
  & 0.13012684E-08_JPRB, 0.13142629E-08_JPRB, 0.13279804E-08_JPRB, 0.13425968E-08_JPRB, 0.13587377E-08_JPRB, 0.13751520E-08_JPRB, &
  & 0.13917306E-08_JPRB, 0.14065398E-08_JPRB, 0.14205223E-08_JPRB, 0.14344195E-08_JPRB, 0.14477010E-08_JPRB, 0.14592426E-08_JPRB, &
  & 0.14710613E-08_JPRB, 0.14851099E-08_JPRB, 0.15036378E-08_JPRB, 0.15293474E-08_JPRB, 0.15589159E-08_JPRB, 0.15880952E-08_JPRB, &
  & 0.16178701E-08_JPRB, 0.16477887E-08_JPRB, 0.16771392E-08_JPRB, 0.17065880E-08_JPRB, 0.17361803E-08_JPRB, 0.17663906E-08_JPRB, &
  & 0.17941439E-08_JPRB, 0.18226197E-08_JPRB, 0.18560750E-08_JPRB, 0.18796826E-08_JPRB, 0.18938513E-08_JPRB, 0.19055808E-08_JPRB, &
  & 0.19133670E-08_JPRB, 0.19191084E-08_JPRB, 0.19233657E-08_JPRB, 0.19271864E-08_JPRB, 0.19319852E-08_JPRB, 0.19407493E-08_JPRB, &
  & 0.19488338E-08_JPRB, 0.19530411E-08_JPRB, 0.19543185E-08_JPRB, 0.19540176E-08_JPRB, 0.19516826E-08_JPRB, 0.19470521E-08_JPRB, &
  & 0.19405693E-08_JPRB, 0.19262403E-08_JPRB, 0.19023918E-08_JPRB, 0.18682083E-08_JPRB, 0.18228060E-08_JPRB, 0.17594967E-08_JPRB, &
  & 0.16762343E-08_JPRB, 0.15674616E-08_JPRB, 0.14339874E-08_JPRB, 0.12819413E-08_JPRB, 0.11322490E-08_JPRB, 0.12959109E-07_JPRB, &
  & 0.11164099E-07_JPRB, 0.10134535E-07_JPRB, 0.92353769E-08_JPRB, 0.86380316E-08_JPRB /)

RGHG4(:,12,10) = (/ &
  & 0.19679438E-08_JPRB, 0.19750359E-08_JPRB, 0.19813491E-08_JPRB, 0.20030071E-08_JPRB, 0.20342918E-08_JPRB, 0.20778048E-08_JPRB, &
  & 0.21278668E-08_JPRB, 0.21746724E-08_JPRB, 0.22185622E-08_JPRB, 0.22606190E-08_JPRB, 0.23029609E-08_JPRB, 0.23432700E-08_JPRB, &
  & 0.23829010E-08_JPRB, 0.24185633E-08_JPRB, 0.24519375E-08_JPRB, 0.24843860E-08_JPRB, 0.25162952E-08_JPRB, 0.25445186E-08_JPRB, &
  & 0.25714304E-08_JPRB, 0.25997078E-08_JPRB, 0.26319618E-08_JPRB, 0.26703268E-08_JPRB, 0.27143523E-08_JPRB, 0.27544160E-08_JPRB, &
  & 0.27927189E-08_JPRB, 0.28311402E-08_JPRB, 0.28702472E-08_JPRB, 0.29111400E-08_JPRB, 0.29516150E-08_JPRB, 0.29943850E-08_JPRB, &
  & 0.30365477E-08_JPRB, 0.30792195E-08_JPRB, 0.31286358E-08_JPRB, 0.31650860E-08_JPRB, 0.31905214E-08_JPRB, 0.32108616E-08_JPRB, &
  & 0.32254353E-08_JPRB, 0.32355698E-08_JPRB, 0.32417835E-08_JPRB, 0.32453848E-08_JPRB, 0.32485075E-08_JPRB, 0.32554082E-08_JPRB, &
  & 0.32568455E-08_JPRB, 0.32504683E-08_JPRB, 0.32373904E-08_JPRB, 0.32178624E-08_JPRB, 0.31906140E-08_JPRB, 0.31540293E-08_JPRB, &
  & 0.31086866E-08_JPRB, 0.30453984E-08_JPRB, 0.29631597E-08_JPRB, 0.28621110E-08_JPRB, 0.27433673E-08_JPRB, 0.25987583E-08_JPRB, &
  & 0.24275049E-08_JPRB, 0.22226323E-08_JPRB, 0.19823947E-08_JPRB, 0.17200590E-08_JPRB, 0.14720407E-08_JPRB, 0.13122928E-07_JPRB, &
  & 0.11095363E-07_JPRB, 0.96975263E-08_JPRB, 0.88767456E-08_JPRB, 0.80026394E-08_JPRB /)

RGHG4(:,13,10) = (/ &
  & 0.26121858E-08_JPRB, 0.26528146E-08_JPRB, 0.26895901E-08_JPRB, 0.27459821E-08_JPRB, 0.28255607E-08_JPRB, 0.29257490E-08_JPRB, &
  & 0.30352385E-08_JPRB, 0.31443848E-08_JPRB, 0.32512244E-08_JPRB, 0.33529415E-08_JPRB, 0.34516257E-08_JPRB, 0.35438417E-08_JPRB, &
  & 0.36317143E-08_JPRB, 0.37114245E-08_JPRB, 0.37837156E-08_JPRB, 0.38490531E-08_JPRB, 0.39103960E-08_JPRB, 0.39638284E-08_JPRB, &
  & 0.40122536E-08_JPRB, 0.40579082E-08_JPRB, 0.41016466E-08_JPRB, 0.41475032E-08_JPRB, 0.41962731E-08_JPRB, 0.42362935E-08_JPRB, &
  & 0.42706714E-08_JPRB, 0.43036463E-08_JPRB, 0.43337036E-08_JPRB, 0.43639568E-08_JPRB, 0.43967621E-08_JPRB, 0.44344985E-08_JPRB, &
  & 0.44740305E-08_JPRB, 0.45182467E-08_JPRB, 0.45700665E-08_JPRB, 0.46043236E-08_JPRB, 0.46265338E-08_JPRB, 0.46404955E-08_JPRB, &
  & 0.46466959E-08_JPRB, 0.46460160E-08_JPRB, 0.46386557E-08_JPRB, 0.46256141E-08_JPRB, 0.46091495E-08_JPRB, 0.45945265E-08_JPRB, &
  & 0.45683310E-08_JPRB, 0.45318269E-08_JPRB, 0.44861621E-08_JPRB, 0.44302757E-08_JPRB, 0.43622341E-08_JPRB, 0.42793151E-08_JPRB, &
  & 0.41825596E-08_JPRB, 0.40591921E-08_JPRB, 0.39118300E-08_JPRB, 0.37417927E-08_JPRB, 0.35514622E-08_JPRB, 0.33330654E-08_JPRB, &
  & 0.30924532E-08_JPRB, 0.28304694E-08_JPRB, 0.25403053E-08_JPRB, 0.21944455E-08_JPRB, 0.18490234E-08_JPRB, 0.12121087E-07_JPRB, &
  & 0.97768540E-08_JPRB, 0.84812823E-08_JPRB, 0.74692421E-08_JPRB, 0.68376829E-08_JPRB /)

RGHG4(:,14,10) = (/ &
  & 0.30985607E-08_JPRB, 0.31531655E-08_JPRB, 0.32321321E-08_JPRB, 0.33478740E-08_JPRB, 0.34916163E-08_JPRB, 0.36608738E-08_JPRB, &
  & 0.38429073E-08_JPRB, 0.40269823E-08_JPRB, 0.42073571E-08_JPRB, 0.43774979E-08_JPRB, 0.45387392E-08_JPRB, 0.46854161E-08_JPRB, &
  & 0.48209969E-08_JPRB, 0.49408873E-08_JPRB, 0.50494653E-08_JPRB, 0.51470463E-08_JPRB, 0.52354299E-08_JPRB, 0.53098104E-08_JPRB, &
  & 0.53747877E-08_JPRB, 0.54325744E-08_JPRB, 0.54845093E-08_JPRB, 0.55335900E-08_JPRB, 0.55848957E-08_JPRB, 0.56231459E-08_JPRB, &
  & 0.56514793E-08_JPRB, 0.56746337E-08_JPRB, 0.56932001E-08_JPRB, 0.57119700E-08_JPRB, 0.57313212E-08_JPRB, 0.57513478E-08_JPRB, &
  & 0.57711396E-08_JPRB, 0.57953460E-08_JPRB, 0.58257883E-08_JPRB, 0.58361431E-08_JPRB, 0.58309482E-08_JPRB, 0.58138396E-08_JPRB, &
  & 0.57883756E-08_JPRB, 0.57559992E-08_JPRB, 0.57168941E-08_JPRB, 0.56714380E-08_JPRB, 0.56218687E-08_JPRB, 0.55743365E-08_JPRB, &
  & 0.55132454E-08_JPRB, 0.54437117E-08_JPRB, 0.53653677E-08_JPRB, 0.52758686E-08_JPRB, 0.51710463E-08_JPRB, 0.50468887E-08_JPRB, &
  & 0.49049373E-08_JPRB, 0.47328110E-08_JPRB, 0.45338027E-08_JPRB, 0.43118109E-08_JPRB, 0.40720685E-08_JPRB, 0.38051224E-08_JPRB, &
  & 0.35163696E-08_JPRB, 0.31880514E-08_JPRB, 0.28063920E-08_JPRB, 0.23623354E-08_JPRB, 0.19616138E-08_JPRB, 0.10732195E-07_JPRB, &
  & 0.83076763E-08_JPRB, 0.68371961E-08_JPRB, 0.58710263E-08_JPRB, 0.51950590E-08_JPRB /)

RGHG4(:,15,10) = (/ &
  & 0.34653893E-08_JPRB, 0.35581305E-08_JPRB, 0.36694239E-08_JPRB, 0.38224850E-08_JPRB, 0.40135215E-08_JPRB, 0.42304653E-08_JPRB, &
  & 0.44616932E-08_JPRB, 0.46983528E-08_JPRB, 0.49316791E-08_JPRB, 0.51494178E-08_JPRB, 0.53503948E-08_JPRB, 0.55264300E-08_JPRB, &
  & 0.56828946E-08_JPRB, 0.58141980E-08_JPRB, 0.59262044E-08_JPRB, 0.60244454E-08_JPRB, 0.61115806E-08_JPRB, 0.61793517E-08_JPRB, &
  & 0.62343068E-08_JPRB, 0.62802457E-08_JPRB, 0.63211627E-08_JPRB, 0.63620562E-08_JPRB, 0.64115584E-08_JPRB, 0.64542576E-08_JPRB, &
  & 0.64927801E-08_JPRB, 0.65283396E-08_JPRB, 0.65610197E-08_JPRB, 0.65899894E-08_JPRB, 0.66061623E-08_JPRB, 0.66146972E-08_JPRB, &
  & 0.66148829E-08_JPRB, 0.66098402E-08_JPRB, 0.66080612E-08_JPRB, 0.65797376E-08_JPRB, 0.65328400E-08_JPRB, 0.64696501E-08_JPRB, &
  & 0.63954699E-08_JPRB, 0.63159207E-08_JPRB, 0.62341319E-08_JPRB, 0.61510605E-08_JPRB, 0.60688761E-08_JPRB, 0.59944525E-08_JPRB, &
  & 0.59103904E-08_JPRB, 0.58233596E-08_JPRB, 0.57308727E-08_JPRB, 0.56266729E-08_JPRB, 0.55039244E-08_JPRB, 0.53592704E-08_JPRB, &
  & 0.51939351E-08_JPRB, 0.49959730E-08_JPRB, 0.47727347E-08_JPRB, 0.45292210E-08_JPRB, 0.42702517E-08_JPRB, 0.39846735E-08_JPRB, &
  & 0.36773475E-08_JPRB, 0.33234515E-08_JPRB, 0.29049132E-08_JPRB, 0.23876741E-08_JPRB, 0.20538018E-08_JPRB, 0.88868273E-08_JPRB, &
  & 0.66883565E-08_JPRB, 0.53555995E-08_JPRB, 0.45277702E-08_JPRB, 0.38523287E-08_JPRB /)

RGHG4(:,16,10) = (/ &
  & 0.37152204E-08_JPRB, 0.38056536E-08_JPRB, 0.39385273E-08_JPRB, 0.41217354E-08_JPRB, 0.43427812E-08_JPRB, 0.45823030E-08_JPRB, &
  & 0.48344955E-08_JPRB, 0.50921485E-08_JPRB, 0.53429972E-08_JPRB, 0.55722507E-08_JPRB, 0.57785297E-08_JPRB, 0.59509482E-08_JPRB, &
  & 0.60959424E-08_JPRB, 0.62079888E-08_JPRB, 0.62944072E-08_JPRB, 0.63623502E-08_JPRB, 0.64198415E-08_JPRB, 0.64573418E-08_JPRB, &
  & 0.64821442E-08_JPRB, 0.64999832E-08_JPRB, 0.65170549E-08_JPRB, 0.65412609E-08_JPRB, 0.65842185E-08_JPRB, 0.66305019E-08_JPRB, &
  & 0.66846697E-08_JPRB, 0.67475887E-08_JPRB, 0.68141084E-08_JPRB, 0.68720860E-08_JPRB, 0.69133699E-08_JPRB, 0.69351320E-08_JPRB, &
  & 0.69329769E-08_JPRB, 0.69090715E-08_JPRB, 0.68684334E-08_JPRB, 0.67941821E-08_JPRB, 0.66967205E-08_JPRB, 0.65808137E-08_JPRB, &
  & 0.64558949E-08_JPRB, 0.63275345E-08_JPRB, 0.62009797E-08_JPRB, 0.60804344E-08_JPRB, 0.59708900E-08_JPRB, 0.58794383E-08_JPRB, &
  & 0.57861596E-08_JPRB, 0.56967062E-08_JPRB, 0.56042095E-08_JPRB, 0.55003726E-08_JPRB, 0.53767950E-08_JPRB, 0.52302052E-08_JPRB, &
  & 0.50628750E-08_JPRB, 0.48661186E-08_JPRB, 0.46481530E-08_JPRB, 0.44132928E-08_JPRB, 0.41652246E-08_JPRB, 0.38920263E-08_JPRB, &
  & 0.35902590E-08_JPRB, 0.32313032E-08_JPRB, 0.28081348E-08_JPRB, 0.22698543E-08_JPRB, 0.19522872E-08_JPRB, 0.68080563E-08_JPRB, &
  & 0.49465934E-08_JPRB, 0.38723438E-08_JPRB, 0.30901948E-08_JPRB, 0.26375204E-08_JPRB /)

RGHG4(:,17,10) = (/ &
  & 0.37854173E-08_JPRB, 0.38745829E-08_JPRB, 0.40094954E-08_JPRB, 0.41984869E-08_JPRB, 0.44235793E-08_JPRB, 0.46543436E-08_JPRB, &
  & 0.48927991E-08_JPRB, 0.51351616E-08_JPRB, 0.53687219E-08_JPRB, 0.55759721E-08_JPRB, 0.57551262E-08_JPRB, 0.58945733E-08_JPRB, &
  & 0.60022667E-08_JPRB, 0.60723404E-08_JPRB, 0.61142562E-08_JPRB, 0.61353771E-08_JPRB, 0.61454610E-08_JPRB, 0.61363767E-08_JPRB, &
  & 0.61150636E-08_JPRB, 0.60903713E-08_JPRB, 0.60703051E-08_JPRB, 0.60653385E-08_JPRB, 0.60901217E-08_JPRB, 0.61315450E-08_JPRB, &
  & 0.61956720E-08_JPRB, 0.62825611E-08_JPRB, 0.63821548E-08_JPRB, 0.64755086E-08_JPRB, 0.65548083E-08_JPRB, 0.65980275E-08_JPRB, &
  & 0.66076864E-08_JPRB, 0.65815646E-08_JPRB, 0.65266361E-08_JPRB, 0.64223400E-08_JPRB, 0.62869385E-08_JPRB, 0.61362675E-08_JPRB, &
  & 0.59775167E-08_JPRB, 0.58138103E-08_JPRB, 0.56543854E-08_JPRB, 0.55073435E-08_JPRB, 0.53801217E-08_JPRB, 0.52801838E-08_JPRB, &
  & 0.51871201E-08_JPRB, 0.51040532E-08_JPRB, 0.50218696E-08_JPRB, 0.49297069E-08_JPRB, 0.48204534E-08_JPRB, 0.46903974E-08_JPRB, &
  & 0.45437218E-08_JPRB, 0.43741797E-08_JPRB, 0.41898653E-08_JPRB, 0.39933910E-08_JPRB, 0.37846548E-08_JPRB, 0.35496590E-08_JPRB, &
  & 0.32764791E-08_JPRB, 0.29290259E-08_JPRB, 0.24591258E-08_JPRB, 0.20347681E-08_JPRB, 0.17828419E-08_JPRB, 0.48768096E-08_JPRB, &
  & 0.34708494E-08_JPRB, 0.26316491E-08_JPRB, 0.21239610E-08_JPRB, 0.17033965E-08_JPRB /)

RGHG4(:,18,10) = (/ &
  & 0.37417376E-08_JPRB, 0.38057006E-08_JPRB, 0.39297183E-08_JPRB, 0.41041126E-08_JPRB, 0.43107278E-08_JPRB, 0.45082609E-08_JPRB, &
  & 0.47101647E-08_JPRB, 0.49152002E-08_JPRB, 0.51086113E-08_JPRB, 0.52725961E-08_JPRB, 0.54066458E-08_JPRB, 0.54993317E-08_JPRB, &
  & 0.55592793E-08_JPRB, 0.55813514E-08_JPRB, 0.55755125E-08_JPRB, 0.55506000E-08_JPRB, 0.55156146E-08_JPRB, 0.54649236E-08_JPRB, &
  & 0.54050640E-08_JPRB, 0.53437690E-08_JPRB, 0.52883484E-08_JPRB, 0.52494173E-08_JPRB, 0.52442837E-08_JPRB, 0.52622418E-08_JPRB, &
  & 0.53111626E-08_JPRB, 0.53906404E-08_JPRB, 0.54865525E-08_JPRB, 0.55883591E-08_JPRB, 0.56788805E-08_JPRB, 0.57481744E-08_JPRB, &
  & 0.57793685E-08_JPRB, 0.57686838E-08_JPRB, 0.57232796E-08_JPRB, 0.56300102E-08_JPRB, 0.55001843E-08_JPRB, 0.53441691E-08_JPRB, &
  & 0.51747966E-08_JPRB, 0.50014242E-08_JPRB, 0.48306927E-08_JPRB, 0.46745052E-08_JPRB, 0.45414019E-08_JPRB, 0.44393103E-08_JPRB, &
  & 0.43503667E-08_JPRB, 0.42748649E-08_JPRB, 0.42035917E-08_JPRB, 0.41257620E-08_JPRB, 0.40357349E-08_JPRB, 0.39316288E-08_JPRB, &
  & 0.38175831E-08_JPRB, 0.36894632E-08_JPRB, 0.35517822E-08_JPRB, 0.34044221E-08_JPRB, 0.32431113E-08_JPRB, 0.30508676E-08_JPRB, &
  & 0.28055371E-08_JPRB, 0.24835454E-08_JPRB, 0.20982356E-08_JPRB, 0.17152172E-08_JPRB, 0.14939850E-08_JPRB, 0.32982479E-08_JPRB, &
  & 0.23125837E-08_JPRB, 0.17181697E-08_JPRB, 0.13278421E-08_JPRB, 0.10646255E-08_JPRB /)

RGHG4(:,19,10) = (/ &
  & 0.36016101E-08_JPRB, 0.36420598E-08_JPRB, 0.37341352E-08_JPRB, 0.38854759E-08_JPRB, 0.40558290E-08_JPRB, 0.42076018E-08_JPRB, &
  & 0.43606159E-08_JPRB, 0.45174211E-08_JPRB, 0.46632271E-08_JPRB, 0.47798681E-08_JPRB, 0.48661728E-08_JPRB, 0.49126769E-08_JPRB, &
  & 0.49282018E-08_JPRB, 0.49092250E-08_JPRB, 0.48655808E-08_JPRB, 0.48058029E-08_JPRB, 0.47383026E-08_JPRB, 0.46569819E-08_JPRB, &
  & 0.45667532E-08_JPRB, 0.44742570E-08_JPRB, 0.43882267E-08_JPRB, 0.43175299E-08_JPRB, 0.42774819E-08_JPRB, 0.42611119E-08_JPRB, &
  & 0.42764006E-08_JPRB, 0.43228803E-08_JPRB, 0.43925867E-08_JPRB, 0.44734234E-08_JPRB, 0.45529189E-08_JPRB, 0.46203579E-08_JPRB, &
  & 0.46623243E-08_JPRB, 0.46750572E-08_JPRB, 0.46595119E-08_JPRB, 0.46003277E-08_JPRB, 0.45083390E-08_JPRB, 0.43835304E-08_JPRB, &
  & 0.42326178E-08_JPRB, 0.40745221E-08_JPRB, 0.39147063E-08_JPRB, 0.37677208E-08_JPRB, 0.36418748E-08_JPRB, 0.35467889E-08_JPRB, &
  & 0.34658640E-08_JPRB, 0.33994070E-08_JPRB, 0.33396241E-08_JPRB, 0.32780771E-08_JPRB, 0.32106005E-08_JPRB, 0.31358993E-08_JPRB, &
  & 0.30571301E-08_JPRB, 0.29699843E-08_JPRB, 0.28754823E-08_JPRB, 0.27709304E-08_JPRB, 0.26473921E-08_JPRB, 0.24848732E-08_JPRB, &
  & 0.22704261E-08_JPRB, 0.19728297E-08_JPRB, 0.16843955E-08_JPRB, 0.13898275E-08_JPRB, 0.12097184E-08_JPRB, 0.21436115E-08_JPRB, &
  & 0.14531283E-08_JPRB, 0.10599447E-08_JPRB, 0.79000484E-09_JPRB, 0.64435873E-09_JPRB /)

RGHG4(:,20,10) = (/ &
  & 0.33857999E-08_JPRB, 0.34044987E-08_JPRB, 0.34714012E-08_JPRB, 0.35873635E-08_JPRB, 0.37194634E-08_JPRB, 0.38239270E-08_JPRB, &
  & 0.39282884E-08_JPRB, 0.40372661E-08_JPRB, 0.41362722E-08_JPRB, 0.42085162E-08_JPRB, 0.42521022E-08_JPRB, 0.42589976E-08_JPRB, &
  & 0.42385961E-08_JPRB, 0.41887547E-08_JPRB, 0.41187898E-08_JPRB, 0.40360582E-08_JPRB, 0.39475676E-08_JPRB, 0.38492662E-08_JPRB, &
  & 0.37475796E-08_JPRB, 0.36428387E-08_JPRB, 0.35400292E-08_JPRB, 0.34487602E-08_JPRB, 0.33810508E-08_JPRB, 0.33304788E-08_JPRB, &
  & 0.33050833E-08_JPRB, 0.33081871E-08_JPRB, 0.33360799E-08_JPRB, 0.33795251E-08_JPRB, 0.34288357E-08_JPRB, 0.34804679E-08_JPRB, &
  & 0.35232122E-08_JPRB, 0.35529051E-08_JPRB, 0.35688861E-08_JPRB, 0.35488075E-08_JPRB, 0.34951311E-08_JPRB, 0.34193963E-08_JPRB, &
  & 0.33139025E-08_JPRB, 0.31794922E-08_JPRB, 0.30466929E-08_JPRB, 0.29200378E-08_JPRB, 0.28132159E-08_JPRB, 0.27284779E-08_JPRB, &
  & 0.26596099E-08_JPRB, 0.26049831E-08_JPRB, 0.25588309E-08_JPRB, 0.25151043E-08_JPRB, 0.24703295E-08_JPRB, 0.24234861E-08_JPRB, &
  & 0.23751432E-08_JPRB, 0.23205102E-08_JPRB, 0.22581037E-08_JPRB, 0.21820330E-08_JPRB, 0.20811046E-08_JPRB, 0.19430964E-08_JPRB, &
  & 0.17539936E-08_JPRB, 0.15392386E-08_JPRB, 0.13273479E-08_JPRB, 0.11001241E-08_JPRB, 0.95516062E-09_JPRB, 0.14174913E-08_JPRB, &
  & 0.94800268E-09_JPRB, 0.65708022E-09_JPRB, 0.50140891E-09_JPRB, 0.37837583E-09_JPRB /)

RGHG4(:,21,10) = (/ &
  & 0.31599114E-08_JPRB, 0.31574052E-08_JPRB, 0.32077425E-08_JPRB, 0.32895455E-08_JPRB, 0.33869147E-08_JPRB, 0.34485774E-08_JPRB, &
  & 0.35082512E-08_JPRB, 0.35734777E-08_JPRB, 0.36308121E-08_JPRB, 0.36651266E-08_JPRB, 0.36740395E-08_JPRB, 0.36513697E-08_JPRB, &
  & 0.36056818E-08_JPRB, 0.35368968E-08_JPRB, 0.34529570E-08_JPRB, 0.33598251E-08_JPRB, 0.32632053E-08_JPRB, 0.31568319E-08_JPRB, &
  & 0.30439491E-08_JPRB, 0.29304850E-08_JPRB, 0.28180798E-08_JPRB, 0.27125791E-08_JPRB, 0.26244000E-08_JPRB, 0.25498257E-08_JPRB, &
  & 0.24969564E-08_JPRB, 0.24678217E-08_JPRB, 0.24602169E-08_JPRB, 0.24690225E-08_JPRB, 0.24895996E-08_JPRB, 0.25177755E-08_JPRB, &
  & 0.25510862E-08_JPRB, 0.25849958E-08_JPRB, 0.26164009E-08_JPRB, 0.26275095E-08_JPRB, 0.26074316E-08_JPRB, 0.25565203E-08_JPRB, &
  & 0.24840985E-08_JPRB, 0.23991873E-08_JPRB, 0.22973676E-08_JPRB, 0.21984301E-08_JPRB, 0.21098319E-08_JPRB, 0.20432929E-08_JPRB, &
  & 0.19894157E-08_JPRB, 0.19489790E-08_JPRB, 0.19176130E-08_JPRB, 0.18910142E-08_JPRB, 0.18664144E-08_JPRB, 0.18416303E-08_JPRB, &
  & 0.18148716E-08_JPRB, 0.17814360E-08_JPRB, 0.17365358E-08_JPRB, 0.16725819E-08_JPRB, 0.15859520E-08_JPRB, 0.14709799E-08_JPRB, &
  & 0.13303634E-08_JPRB, 0.11839384E-08_JPRB, 0.10181954E-08_JPRB, 0.83595392E-09_JPRB, 0.72570072E-09_JPRB, 0.91634228E-09_JPRB, &
  & 0.58850874E-09_JPRB, 0.40536008E-09_JPRB, 0.28962988E-09_JPRB, 0.22289214E-09_JPRB /)

RGHG4(:,22,10) = (/ &
  & 0.29205944E-08_JPRB, 0.28859106E-08_JPRB, 0.29144112E-08_JPRB, 0.29729474E-08_JPRB, 0.30425085E-08_JPRB, 0.30741585E-08_JPRB, &
  & 0.31017251E-08_JPRB, 0.31333860E-08_JPRB, 0.31595448E-08_JPRB, 0.31659155E-08_JPRB, 0.31498648E-08_JPRB, 0.31072511E-08_JPRB, &
  & 0.30459562E-08_JPRB, 0.29659251E-08_JPRB, 0.28745091E-08_JPRB, 0.27751399E-08_JPRB, 0.26722524E-08_JPRB, 0.25620108E-08_JPRB, &
  & 0.24478890E-08_JPRB, 0.23352020E-08_JPRB, 0.22245477E-08_JPRB, 0.21183744E-08_JPRB, 0.20229760E-08_JPRB, 0.19361104E-08_JPRB, &
  & 0.18643576E-08_JPRB, 0.18122011E-08_JPRB, 0.17790859E-08_JPRB, 0.17623842E-08_JPRB, 0.17596876E-08_JPRB, 0.17689370E-08_JPRB, &
  & 0.17885933E-08_JPRB, 0.18164764E-08_JPRB, 0.18495289E-08_JPRB, 0.18739217E-08_JPRB, 0.18787127E-08_JPRB, 0.18633914E-08_JPRB, &
  & 0.18196988E-08_JPRB, 0.17483885E-08_JPRB, 0.16734246E-08_JPRB, 0.15994330E-08_JPRB, 0.15347583E-08_JPRB, 0.14838490E-08_JPRB, &
  & 0.14441882E-08_JPRB, 0.14147069E-08_JPRB, 0.13931422E-08_JPRB, 0.13774919E-08_JPRB, 0.13657502E-08_JPRB, 0.13543817E-08_JPRB, &
  & 0.13421998E-08_JPRB, 0.13243803E-08_JPRB, 0.12964652E-08_JPRB, 0.12545942E-08_JPRB, 0.11938481E-08_JPRB, 0.11076007E-08_JPRB, &
  & 0.10173624E-08_JPRB, 0.91651897E-09_JPRB, 0.79244228E-09_JPRB, 0.65048428E-09_JPRB, 0.54409943E-09_JPRB, 0.61682232E-09_JPRB, &
  & 0.38790055E-09_JPRB, 0.26232230E-09_JPRB, 0.18730682E-09_JPRB, 0.13149250E-09_JPRB /)

RGHG4(:,23,10) = (/ &
  & 0.26384996E-08_JPRB, 0.26075400E-08_JPRB, 0.26191898E-08_JPRB, 0.26620912E-08_JPRB, 0.27128946E-08_JPRB, 0.27276954E-08_JPRB, &
  & 0.27364644E-08_JPRB, 0.27493630E-08_JPRB, 0.27551723E-08_JPRB, 0.27439442E-08_JPRB, 0.27122620E-08_JPRB, 0.26575682E-08_JPRB, &
  & 0.25867570E-08_JPRB, 0.25006988E-08_JPRB, 0.24046483E-08_JPRB, 0.23047979E-08_JPRB, 0.22071722E-08_JPRB, 0.21072377E-08_JPRB, &
  & 0.20041089E-08_JPRB, 0.18997677E-08_JPRB, 0.17949652E-08_JPRB, 0.16907830E-08_JPRB, 0.15932284E-08_JPRB, 0.15011047E-08_JPRB, &
  & 0.14218021E-08_JPRB, 0.13584663E-08_JPRB, 0.13116269E-08_JPRB, 0.12802158E-08_JPRB, 0.12629828E-08_JPRB, 0.12587340E-08_JPRB, &
  & 0.12666632E-08_JPRB, 0.12852455E-08_JPRB, 0.13105150E-08_JPRB, 0.13332454E-08_JPRB, 0.13423369E-08_JPRB, 0.13338003E-08_JPRB, &
  & 0.13094181E-08_JPRB, 0.12736999E-08_JPRB, 0.12269097E-08_JPRB, 0.11764717E-08_JPRB, 0.11324852E-08_JPRB, 0.10969108E-08_JPRB, &
  & 0.10692179E-08_JPRB, 0.10516180E-08_JPRB, 0.10412019E-08_JPRB, 0.10353903E-08_JPRB, 0.10334368E-08_JPRB, 0.10320065E-08_JPRB, &
  & 0.10288537E-08_JPRB, 0.10202850E-08_JPRB, 0.10026414E-08_JPRB, 0.97066022E-09_JPRB, 0.92438457E-09_JPRB, 0.86551816E-09_JPRB, &
  & 0.79871493E-09_JPRB, 0.71767231E-09_JPRB, 0.62506189E-09_JPRB, 0.51264948E-09_JPRB, 0.42177506E-09_JPRB, 0.43289636E-09_JPRB, &
  & 0.26720240E-09_JPRB, 0.17112453E-09_JPRB, 0.11718911E-09_JPRB, 0.81367121E-10_JPRB /)

RGHG4(:,24,10) = (/ &
  & 0.23675697E-08_JPRB, 0.22795725E-08_JPRB, 0.22733193E-08_JPRB, 0.23178623E-08_JPRB, 0.23712567E-08_JPRB, 0.23918265E-08_JPRB, &
  & 0.23977900E-08_JPRB, 0.23988467E-08_JPRB, 0.23896296E-08_JPRB, 0.23636841E-08_JPRB, 0.23208955E-08_JPRB, 0.22603466E-08_JPRB, &
  & 0.21887476E-08_JPRB, 0.21077573E-08_JPRB, 0.20218200E-08_JPRB, 0.19336395E-08_JPRB, 0.18456042E-08_JPRB, 0.17546794E-08_JPRB, &
  & 0.16614821E-08_JPRB, 0.15658702E-08_JPRB, 0.14683484E-08_JPRB, 0.13707228E-08_JPRB, 0.12768878E-08_JPRB, 0.11872492E-08_JPRB, &
  & 0.11079502E-08_JPRB, 0.10420637E-08_JPRB, 0.99043551E-09_JPRB, 0.95198993E-09_JPRB, 0.92637836E-09_JPRB, 0.91285884E-09_JPRB, &
  & 0.91110908E-09_JPRB, 0.91996627E-09_JPRB, 0.93658503E-09_JPRB, 0.95286679E-09_JPRB, 0.96422059E-09_JPRB, 0.96708730E-09_JPRB, &
  & 0.95574015E-09_JPRB, 0.93158947E-09_JPRB, 0.90210800E-09_JPRB, 0.87148083E-09_JPRB, 0.84287372E-09_JPRB, 0.82145418E-09_JPRB, &
  & 0.80514928E-09_JPRB, 0.79615714E-09_JPRB, 0.79397255E-09_JPRB, 0.79618345E-09_JPRB, 0.80103135E-09_JPRB, 0.80586682E-09_JPRB, &
  & 0.80867768E-09_JPRB, 0.80539753E-09_JPRB, 0.79304713E-09_JPRB, 0.76867862E-09_JPRB, 0.73244644E-09_JPRB, 0.69075989E-09_JPRB, &
  & 0.64114836E-09_JPRB, 0.57757216E-09_JPRB, 0.50281534E-09_JPRB, 0.41030065E-09_JPRB, 0.33126193E-09_JPRB, 0.31074568E-09_JPRB, &
  & 0.18352167E-09_JPRB, 0.11868900E-09_JPRB, 0.74788099E-10_JPRB, 0.51675338E-10_JPRB /)

RGHG4(:,25,10) = (/ &
  & 0.20357311E-08_JPRB, 0.18993542E-08_JPRB, 0.18978454E-08_JPRB, 0.19511683E-08_JPRB, 0.20264599E-08_JPRB, 0.20747615E-08_JPRB, &
  & 0.21016640E-08_JPRB, 0.21114086E-08_JPRB, 0.21033679E-08_JPRB, 0.20754884E-08_JPRB, 0.20307298E-08_JPRB, 0.19704443E-08_JPRB, &
  & 0.19000568E-08_JPRB, 0.18214072E-08_JPRB, 0.17391515E-08_JPRB, 0.16558586E-08_JPRB, 0.15731720E-08_JPRB, 0.14884168E-08_JPRB, &
  & 0.14017515E-08_JPRB, 0.13133929E-08_JPRB, 0.12230508E-08_JPRB, 0.11324889E-08_JPRB, 0.10447772E-08_JPRB, 0.96069164E-09_JPRB, &
  & 0.88502927E-09_JPRB, 0.82027712E-09_JPRB, 0.76756657E-09_JPRB, 0.72742157E-09_JPRB, 0.69863704E-09_JPRB, 0.68029854E-09_JPRB, &
  & 0.67185069E-09_JPRB, 0.67251610E-09_JPRB, 0.68038097E-09_JPRB, 0.68979661E-09_JPRB, 0.69820694E-09_JPRB, 0.70126133E-09_JPRB, &
  & 0.69641726E-09_JPRB, 0.68677569E-09_JPRB, 0.67073352E-09_JPRB, 0.65326550E-09_JPRB, 0.63753847E-09_JPRB, 0.62657601E-09_JPRB, &
  & 0.61967326E-09_JPRB, 0.61774019E-09_JPRB, 0.62113242E-09_JPRB, 0.62831051E-09_JPRB, 0.63748645E-09_JPRB, 0.64587730E-09_JPRB, &
  & 0.65135064E-09_JPRB, 0.65111255E-09_JPRB, 0.64298949E-09_JPRB, 0.62400862E-09_JPRB, 0.59969335E-09_JPRB, 0.56876237E-09_JPRB, &
  & 0.52675442E-09_JPRB, 0.47602688E-09_JPRB, 0.40814424E-09_JPRB, 0.33040012E-09_JPRB, 0.26913724E-09_JPRB, 0.23620941E-09_JPRB, &
  & 0.13785739E-09_JPRB, 0.81766663E-10_JPRB, 0.57113834E-10_JPRB, 0.33508106E-10_JPRB /)

RGHG4(:,26,10) = (/ &
  & 0.16001135E-08_JPRB, 0.14460263E-08_JPRB, 0.14693068E-08_JPRB, 0.15547227E-08_JPRB, 0.16623587E-08_JPRB, 0.17503010E-08_JPRB, &
  & 0.18121392E-08_JPRB, 0.18451558E-08_JPRB, 0.18515794E-08_JPRB, 0.18318075E-08_JPRB, 0.17909434E-08_JPRB, 0.17328513E-08_JPRB, &
  & 0.16646439E-08_JPRB, 0.15893321E-08_JPRB, 0.15108580E-08_JPRB, 0.14315319E-08_JPRB, 0.13527367E-08_JPRB, 0.12732128E-08_JPRB, &
  & 0.11928184E-08_JPRB, 0.11118898E-08_JPRB, 0.10295761E-08_JPRB, 0.94734676E-09_JPRB, 0.86776591E-09_JPRB, 0.79115164E-09_JPRB, &
  & 0.72126738E-09_JPRB, 0.66098343E-09_JPRB, 0.61106564E-09_JPRB, 0.57111671E-09_JPRB, 0.54104915E-09_JPRB, 0.52013227E-09_JPRB, &
  & 0.50743693E-09_JPRB, 0.50194210E-09_JPRB, 0.50262222E-09_JPRB, 0.50601556E-09_JPRB, 0.50985244E-09_JPRB, 0.51281168E-09_JPRB, &
  & 0.51313981E-09_JPRB, 0.50935728E-09_JPRB, 0.50315407E-09_JPRB, 0.49601617E-09_JPRB, 0.48967108E-09_JPRB, 0.48631504E-09_JPRB, &
  & 0.48611026E-09_JPRB, 0.48975307E-09_JPRB, 0.49726534E-09_JPRB, 0.50764093E-09_JPRB, 0.51940852E-09_JPRB, 0.53067051E-09_JPRB, &
  & 0.53910454E-09_JPRB, 0.54172972E-09_JPRB, 0.53650057E-09_JPRB, 0.52324606E-09_JPRB, 0.50421994E-09_JPRB, 0.47862408E-09_JPRB, &
  & 0.44347701E-09_JPRB, 0.40034123E-09_JPRB, 0.34291472E-09_JPRB, 0.27696453E-09_JPRB, 0.22352800E-09_JPRB, 0.18397625E-09_JPRB, &
  & 0.10408509E-09_JPRB, 0.64362966E-10_JPRB, 0.36344084E-10_JPRB, 0.23287492E-10_JPRB /)

RGHG4(:,27,10) = (/ &
  & 0.10759962E-08_JPRB, 0.99837139E-09_JPRB, 0.10648017E-08_JPRB, 0.11792207E-08_JPRB, 0.13152409E-08_JPRB, 0.14368035E-08_JPRB, &
  & 0.15293589E-08_JPRB, 0.15884278E-08_JPRB, 0.16144952E-08_JPRB, 0.16092228E-08_JPRB, 0.15782473E-08_JPRB, 0.15270787E-08_JPRB, &
  & 0.14632117E-08_JPRB, 0.13913549E-08_JPRB, 0.13164011E-08_JPRB, 0.12402865E-08_JPRB, 0.11659114E-08_JPRB, 0.10912387E-08_JPRB, &
  & 0.10171815E-08_JPRB, 0.94292874E-09_JPRB, 0.86885560E-09_JPRB, 0.79523649E-09_JPRB, 0.72421957E-09_JPRB, 0.65631767E-09_JPRB, &
  & 0.59408567E-09_JPRB, 0.53985821E-09_JPRB, 0.49386323E-09_JPRB, 0.45655490E-09_JPRB, 0.42712181E-09_JPRB, 0.40511780E-09_JPRB, &
  & 0.38973808E-09_JPRB, 0.38020667E-09_JPRB, 0.37575551E-09_JPRB, 0.37450459E-09_JPRB, 0.37524506E-09_JPRB, 0.37684408E-09_JPRB, &
  & 0.37875281E-09_JPRB, 0.37976025E-09_JPRB, 0.37999676E-09_JPRB, 0.37995448E-09_JPRB, 0.38048253E-09_JPRB, 0.38277395E-09_JPRB, &
  & 0.38727704E-09_JPRB, 0.39468856E-09_JPRB, 0.40501766E-09_JPRB, 0.41756693E-09_JPRB, 0.43066578E-09_JPRB, 0.44249424E-09_JPRB, &
  & 0.45076759E-09_JPRB, 0.45419712E-09_JPRB, 0.45134343E-09_JPRB, 0.44311818E-09_JPRB, 0.42899800E-09_JPRB, 0.40820358E-09_JPRB, &
  & 0.37843625E-09_JPRB, 0.34126521E-09_JPRB, 0.29137318E-09_JPRB, 0.23415134E-09_JPRB, 0.18501886E-09_JPRB, 0.14394150E-09_JPRB, &
  & 0.81688517E-10_JPRB, 0.48525677E-10_JPRB, 0.32461922E-10_JPRB, 0.17242418E-10_JPRB /)

RGHG4(:,28,10) = (/ &
  & 0.66958827E-09_JPRB, 0.68375111E-09_JPRB, 0.76618478E-09_JPRB, 0.89030650E-09_JPRB, 0.10320760E-08_JPRB, 0.11667263E-08_JPRB, &
  & 0.12768860E-08_JPRB, 0.13539747E-08_JPRB, 0.13961238E-08_JPRB, 0.14047957E-08_JPRB, 0.13849627E-08_JPRB, 0.13424798E-08_JPRB, &
  & 0.12852541E-08_JPRB, 0.12187673E-08_JPRB, 0.11478203E-08_JPRB, 0.10761879E-08_JPRB, 0.10061245E-08_JPRB, 0.93628616E-09_JPRB, &
  & 0.86792062E-09_JPRB, 0.80036666E-09_JPRB, 0.73387041E-09_JPRB, 0.66859041E-09_JPRB, 0.60610456E-09_JPRB, 0.54699845E-09_JPRB, &
  & 0.49299709E-09_JPRB, 0.44519699E-09_JPRB, 0.40472603E-09_JPRB, 0.37022838E-09_JPRB, 0.34220360E-09_JPRB, 0.32024849E-09_JPRB, &
  & 0.30353209E-09_JPRB, 0.29152170E-09_JPRB, 0.28378516E-09_JPRB, 0.27943617E-09_JPRB, 0.27788127E-09_JPRB, 0.27847588E-09_JPRB, &
  & 0.28100899E-09_JPRB, 0.28447597E-09_JPRB, 0.28868449E-09_JPRB, 0.29330030E-09_JPRB, 0.29869604E-09_JPRB, 0.30522285E-09_JPRB, &
  & 0.31337025E-09_JPRB, 0.32355901E-09_JPRB, 0.33590755E-09_JPRB, 0.34975242E-09_JPRB, 0.36361578E-09_JPRB, 0.37614947E-09_JPRB, &
  & 0.38579717E-09_JPRB, 0.39094070E-09_JPRB, 0.38959774E-09_JPRB, 0.38258083E-09_JPRB, 0.36993286E-09_JPRB, 0.35013253E-09_JPRB, &
  & 0.32418396E-09_JPRB, 0.28836611E-09_JPRB, 0.24729688E-09_JPRB, 0.19809460E-09_JPRB, 0.15488096E-09_JPRB, 0.11800069E-09_JPRB, &
  & 0.68449239E-10_JPRB, 0.41981457E-10_JPRB, 0.22409494E-10_JPRB, 0.13578931E-10_JPRB /)

RGHG4(:,29,10) = (/ &
  & 0.46301354E-09_JPRB, 0.49645937E-09_JPRB, 0.57546545E-09_JPRB, 0.68624068E-09_JPRB, 0.81613949E-09_JPRB, 0.94586949E-09_JPRB, &
  & 0.10580405E-08_JPRB, 0.11421781E-08_JPRB, 0.11942317E-08_JPRB, 0.12135718E-08_JPRB, 0.12041055E-08_JPRB, 0.11707848E-08_JPRB, &
  & 0.11209226E-08_JPRB, 0.10604038E-08_JPRB, 0.99445885E-09_JPRB, 0.92832203E-09_JPRB, 0.86244006E-09_JPRB, 0.79802193E-09_JPRB, &
  & 0.73535172E-09_JPRB, 0.67435402E-09_JPRB, 0.61492966E-09_JPRB, 0.55757926E-09_JPRB, 0.50332533E-09_JPRB, 0.45249826E-09_JPRB, &
  & 0.40644324E-09_JPRB, 0.36550196E-09_JPRB, 0.32994152E-09_JPRB, 0.29944372E-09_JPRB, 0.27386082E-09_JPRB, 0.25299213E-09_JPRB, &
  & 0.23620955E-09_JPRB, 0.22312804E-09_JPRB, 0.21367765E-09_JPRB, 0.20752192E-09_JPRB, 0.20447420E-09_JPRB, 0.20436555E-09_JPRB, &
  & 0.20707037E-09_JPRB, 0.21204730E-09_JPRB, 0.21843247E-09_JPRB, 0.22599524E-09_JPRB, 0.23443886E-09_JPRB, 0.24390837E-09_JPRB, &
  & 0.25450148E-09_JPRB, 0.26664171E-09_JPRB, 0.28036157E-09_JPRB, 0.29502156E-09_JPRB, 0.30946426E-09_JPRB, 0.32242231E-09_JPRB, &
  & 0.33228709E-09_JPRB, 0.33692188E-09_JPRB, 0.33655148E-09_JPRB, 0.33136824E-09_JPRB, 0.32083117E-09_JPRB, 0.30370292E-09_JPRB, &
  & 0.28086419E-09_JPRB, 0.24980001E-09_JPRB, 0.21425051E-09_JPRB, 0.17193791E-09_JPRB, 0.13278048E-09_JPRB, 0.99917283E-10_JPRB, &
  & 0.56820229E-10_JPRB, 0.31267249E-10_JPRB, 0.20132264E-10_JPRB, 0.10759436E-10_JPRB /)

RGHG4(:,30,10) = (/ &
  & 0.35560316E-09_JPRB, 0.39508191E-09_JPRB, 0.46039897E-09_JPRB, 0.55444116E-09_JPRB, 0.66577988E-09_JPRB, 0.78106405E-09_JPRB, &
  & 0.88628305E-09_JPRB, 0.96855257E-09_JPRB, 0.10236562E-08_JPRB, 0.10485205E-08_JPRB, 0.10455933E-08_JPRB, 0.10190464E-08_JPRB, &
  & 0.97552555E-09_JPRB, 0.92073998E-09_JPRB, 0.86029489E-09_JPRB, 0.79894380E-09_JPRB, 0.73786705E-09_JPRB, 0.67853251E-09_JPRB, &
  & 0.62140465E-09_JPRB, 0.56639521E-09_JPRB, 0.51357801E-09_JPRB, 0.46317616E-09_JPRB, 0.41616235E-09_JPRB, 0.37265077E-09_JPRB, &
  & 0.33346845E-09_JPRB, 0.29883132E-09_JPRB, 0.26841943E-09_JPRB, 0.24191935E-09_JPRB, 0.21900487E-09_JPRB, 0.19965542E-09_JPRB, &
  & 0.18350890E-09_JPRB, 0.17032355E-09_JPRB, 0.16035760E-09_JPRB, 0.15343340E-09_JPRB, 0.14965090E-09_JPRB, 0.14917666E-09_JPRB, &
  & 0.15171457E-09_JPRB, 0.15736012E-09_JPRB, 0.16477127E-09_JPRB, 0.17411710E-09_JPRB, 0.18432185E-09_JPRB, 0.19584845E-09_JPRB, &
  & 0.20801418E-09_JPRB, 0.22148207E-09_JPRB, 0.23607216E-09_JPRB, 0.25109131E-09_JPRB, 0.26564470E-09_JPRB, 0.27830782E-09_JPRB, &
  & 0.28764297E-09_JPRB, 0.29235511E-09_JPRB, 0.29292102E-09_JPRB, 0.28921016E-09_JPRB, 0.28035363E-09_JPRB, 0.26557864E-09_JPRB, &
  & 0.24566540E-09_JPRB, 0.21823714E-09_JPRB, 0.18631877E-09_JPRB, 0.14825885E-09_JPRB, 0.11091214E-09_JPRB, 0.78020888E-10_JPRB, &
  & 0.42031975E-10_JPRB, 0.24817676E-10_JPRB, 0.16287917E-10_JPRB, 0.85084708E-11_JPRB /)

RGHG4(:,31,10) = (/ &
  & 0.29424452E-09_JPRB, 0.33296826E-09_JPRB, 0.38835710E-09_JPRB, 0.46362239E-09_JPRB, 0.55802957E-09_JPRB, 0.65637151E-09_JPRB, &
  & 0.74912343E-09_JPRB, 0.82453883E-09_JPRB, 0.87697782E-09_JPRB, 0.90329050E-09_JPRB, 0.90395036E-09_JPRB, 0.88240498E-09_JPRB, &
  & 0.84420632E-09_JPRB, 0.79487156E-09_JPRB, 0.73977469E-09_JPRB, 0.68322964E-09_JPRB, 0.62713501E-09_JPRB, 0.57268640E-09_JPRB, &
  & 0.52064542E-09_JPRB, 0.47094856E-09_JPRB, 0.42370729E-09_JPRB, 0.37938519E-09_JPRB, 0.33855163E-09_JPRB, 0.30147235E-09_JPRB, &
  & 0.26846103E-09_JPRB, 0.23952831E-09_JPRB, 0.21410337E-09_JPRB, 0.19168966E-09_JPRB, 0.17187983E-09_JPRB, 0.15455646E-09_JPRB, &
  & 0.13979104E-09_JPRB, 0.12733156E-09_JPRB, 0.11774674E-09_JPRB, 0.11086586E-09_JPRB, 0.10695343E-09_JPRB, 0.10634373E-09_JPRB, &
  & 0.10865351E-09_JPRB, 0.11434937E-09_JPRB, 0.12198710E-09_JPRB, 0.13207703E-09_JPRB, 0.14309096E-09_JPRB, 0.15582428E-09_JPRB, &
  & 0.16890980E-09_JPRB, 0.18328240E-09_JPRB, 0.19844949E-09_JPRB, 0.21382025E-09_JPRB, 0.22851433E-09_JPRB, 0.24131655E-09_JPRB, &
  & 0.25079311E-09_JPRB, 0.25620370E-09_JPRB, 0.25753080E-09_JPRB, 0.25423841E-09_JPRB, 0.24581304E-09_JPRB, 0.23311675E-09_JPRB, &
  & 0.21517335E-09_JPRB, 0.19039767E-09_JPRB, 0.16012361E-09_JPRB, 0.12784346E-09_JPRB, 0.95132478E-10_JPRB, 0.67829173E-10_JPRB, &
  & 0.39513788E-10_JPRB, 0.23957739E-10_JPRB, 0.11467503E-10_JPRB, 0.67650976E-11_JPRB /)

RGHG4(:,32,10) = (/ &
  & 0.26488703E-09_JPRB, 0.30036523E-09_JPRB, 0.34591871E-09_JPRB, 0.40861367E-09_JPRB, 0.48606652E-09_JPRB, 0.56915705E-09_JPRB, &
  & 0.64807165E-09_JPRB, 0.71420525E-09_JPRB, 0.76064444E-09_JPRB, 0.78452017E-09_JPRB, 0.78552176E-09_JPRB, 0.76636780E-09_JPRB, &
  & 0.73181572E-09_JPRB, 0.68697847E-09_JPRB, 0.63661382E-09_JPRB, 0.58462601E-09_JPRB, 0.53314320E-09_JPRB, 0.48333343E-09_JPRB, &
  & 0.43601739E-09_JPRB, 0.39104456E-09_JPRB, 0.34905034E-09_JPRB, 0.31007608E-09_JPRB, 0.27448474E-09_JPRB, 0.24254493E-09_JPRB, &
  & 0.21443475E-09_JPRB, 0.19005707E-09_JPRB, 0.16877739E-09_JPRB, 0.14986033E-09_JPRB, 0.13291902E-09_JPRB, 0.11771782E-09_JPRB, &
  & 0.10458930E-09_JPRB, 0.93370561E-10_JPRB, 0.84669161E-10_JPRB, 0.78393028E-10_JPRB, 0.74809783E-10_JPRB, 0.74240739E-10_JPRB, &
  & 0.76475742E-10_JPRB, 0.81797076E-10_JPRB, 0.89340313E-10_JPRB, 0.99348564E-10_JPRB, 0.11054255E-09_JPRB, 0.12365166E-09_JPRB, &
  & 0.13716644E-09_JPRB, 0.15193752E-09_JPRB, 0.16722665E-09_JPRB, 0.18271036E-09_JPRB, 0.19708876E-09_JPRB, 0.20932189E-09_JPRB, &
  & 0.21834909E-09_JPRB, 0.22385858E-09_JPRB, 0.22540833E-09_JPRB, 0.22276143E-09_JPRB, 0.21551237E-09_JPRB, 0.20424060E-09_JPRB, &
  & 0.18739002E-09_JPRB, 0.16681247E-09_JPRB, 0.14019259E-09_JPRB, 0.11159947E-09_JPRB, 0.81804258E-10_JPRB, 0.55594692E-10_JPRB, &
  & 0.29276272E-10_JPRB, 0.14854779E-10_JPRB, 0.10535713E-10_JPRB, 0.56646593E-11_JPRB /)

RGHG4(:,33,10) = (/ &
  & 0.25041422E-09_JPRB, 0.28295777E-09_JPRB, 0.32256514E-09_JPRB, 0.37493708E-09_JPRB, 0.43969386E-09_JPRB, 0.50802446E-09_JPRB, &
  & 0.57370980E-09_JPRB, 0.62789846E-09_JPRB, 0.66609718E-09_JPRB, 0.68487105E-09_JPRB, 0.68397310E-09_JPRB, 0.66558992E-09_JPRB, &
  & 0.63369221E-09_JPRB, 0.59264466E-09_JPRB, 0.54656712E-09_JPRB, 0.49901588E-09_JPRB, 0.45178869E-09_JPRB, 0.40628914E-09_JPRB, &
  & 0.36278697E-09_JPRB, 0.32200023E-09_JPRB, 0.28401323E-09_JPRB, 0.24915628E-09_JPRB, 0.21788750E-09_JPRB, 0.19024217E-09_JPRB, &
  & 0.16638013E-09_JPRB, 0.14601016E-09_JPRB, 0.12842796E-09_JPRB, 0.11289904E-09_JPRB, 0.98904065E-10_JPRB, 0.86043658E-10_JPRB, &
  & 0.74937154E-10_JPRB, 0.65490675E-10_JPRB, 0.58140798E-10_JPRB, 0.52894154E-10_JPRB, 0.49939511E-10_JPRB, 0.49505587E-10_JPRB, &
  & 0.51583942E-10_JPRB, 0.56269569E-10_JPRB, 0.63342991E-10_JPRB, 0.72573718E-10_JPRB, 0.83466040E-10_JPRB, 0.96298726E-10_JPRB, &
  & 0.10984717E-09_JPRB, 0.12470226E-09_JPRB, 0.13995351E-09_JPRB, 0.15538835E-09_JPRB, 0.16944908E-09_JPRB, 0.18143842E-09_JPRB, &
  & 0.19038060E-09_JPRB, 0.19572473E-09_JPRB, 0.19733598E-09_JPRB, 0.19528973E-09_JPRB, 0.18929032E-09_JPRB, 0.17973581E-09_JPRB, &
  & 0.16509039E-09_JPRB, 0.14692475E-09_JPRB, 0.12353173E-09_JPRB, 0.97638120E-10_JPRB, 0.70062234E-10_JPRB, 0.46691949E-10_JPRB, &
  & 0.25739164E-10_JPRB, 0.16401028E-10_JPRB, 0.91553969E-11_JPRB, 0.46487003E-11_JPRB /)

RGHG4(:,34,10) = (/ &
  & 0.24947791E-09_JPRB, 0.27958466E-09_JPRB, 0.31516220E-09_JPRB, 0.36069411E-09_JPRB, 0.41486525E-09_JPRB, 0.47168219E-09_JPRB, &
  & 0.52345983E-09_JPRB, 0.56576915E-09_JPRB, 0.59395788E-09_JPRB, 0.60570615E-09_JPRB, 0.60115729E-09_JPRB, 0.58207067E-09_JPRB, &
  & 0.55170352E-09_JPRB, 0.51371141E-09_JPRB, 0.47146459E-09_JPRB, 0.42780726E-09_JPRB, 0.38441639E-09_JPRB, 0.34258352E-09_JPRB, &
  & 0.30268588E-09_JPRB, 0.26534505E-09_JPRB, 0.23075333E-09_JPRB, 0.19930152E-09_JPRB, 0.17143575E-09_JPRB, 0.14727203E-09_JPRB, &
  & 0.12676075E-09_JPRB, 0.10957032E-09_JPRB, 0.95019506E-10_JPRB, 0.82241824E-10_JPRB, 0.70845232E-10_JPRB, 0.60481564E-10_JPRB, &
  & 0.51433340E-10_JPRB, 0.43918306E-10_JPRB, 0.38116753E-10_JPRB, 0.34080062E-10_JPRB, 0.31899039E-10_JPRB, 0.31697523E-10_JPRB, &
  & 0.33512366E-10_JPRB, 0.37560080E-10_JPRB, 0.43797719E-10_JPRB, 0.51991238E-10_JPRB, 0.62160228E-10_JPRB, 0.74192472E-10_JPRB, &
  & 0.87378438E-10_JPRB, 0.10185813E-09_JPRB, 0.11685414E-09_JPRB, 0.13184646E-09_JPRB, 0.14548381E-09_JPRB, 0.15708135E-09_JPRB, &
  & 0.16566629E-09_JPRB, 0.17111096E-09_JPRB, 0.17320083E-09_JPRB, 0.17158071E-09_JPRB, 0.16685021E-09_JPRB, 0.15862034E-09_JPRB, &
  & 0.14601134E-09_JPRB, 0.13007881E-09_JPRB, 0.10937916E-09_JPRB, 0.86145251E-10_JPRB, 0.61895114E-10_JPRB, 0.42319960E-10_JPRB, &
  & 0.23763852E-10_JPRB, 0.12509736E-10_JPRB, 0.69460514E-11_JPRB, 0.43466225E-11_JPRB /)

RGHG4(:,35,10) = (/ &
  & 0.25727503E-09_JPRB, 0.28591629E-09_JPRB, 0.31830116E-09_JPRB, 0.35798620E-09_JPRB, 0.40319667E-09_JPRB, 0.44766960E-09_JPRB, &
  & 0.48707344E-09_JPRB, 0.51662252E-09_JPRB, 0.53434174E-09_JPRB, 0.53874966E-09_JPRB, 0.52986227E-09_JPRB, 0.50960003E-09_JPRB, &
  & 0.48032467E-09_JPRB, 0.44507806E-09_JPRB, 0.40637010E-09_JPRB, 0.36642836E-09_JPRB, 0.32669598E-09_JPRB, 0.28806035E-09_JPRB, &
  & 0.25108124E-09_JPRB, 0.21642110E-09_JPRB, 0.18455548E-09_JPRB, 0.15584303E-09_JPRB, 0.13075559E-09_JPRB, 0.10942230E-09_JPRB, &
  & 0.91891675E-10_JPRB, 0.77564836E-10_JPRB, 0.65847827E-10_JPRB, 0.55853846E-10_JPRB, 0.47113022E-10_JPRB, 0.39325366E-10_JPRB, &
  & 0.32620507E-10_JPRB, 0.27176473E-10_JPRB, 0.23089541E-10_JPRB, 0.20330015E-10_JPRB, 0.18944943E-10_JPRB, 0.18959737E-10_JPRB, &
  & 0.20429047E-10_JPRB, 0.23657822E-10_JPRB, 0.28695617E-10_JPRB, 0.35589302E-10_JPRB, 0.44543518E-10_JPRB, 0.55396864E-10_JPRB, &
  & 0.67833586E-10_JPRB, 0.81752723E-10_JPRB, 0.96331242E-10_JPRB, 0.11081470E-09_JPRB, 0.12403251E-09_JPRB, 0.13524527E-09_JPRB, &
  & 0.14357544E-09_JPRB, 0.14888368E-09_JPRB, 0.15116632E-09_JPRB, 0.15013027E-09_JPRB, 0.14640740E-09_JPRB, 0.13949422E-09_JPRB, &
  & 0.12869017E-09_JPRB, 0.11458771E-09_JPRB, 0.96109870E-10_JPRB, 0.74600645E-10_JPRB, 0.52928655E-10_JPRB, 0.34488409E-10_JPRB, &
  & 0.18010548E-10_JPRB, 0.10760563E-10_JPRB, 0.73943872E-11_JPRB, 0.39932463E-11_JPRB /)

RGHG4(:,36,10) = (/ &
  & 0.27641375E-09_JPRB, 0.30468705E-09_JPRB, 0.33301467E-09_JPRB, 0.36591688E-09_JPRB, 0.40198758E-09_JPRB, 0.43523718E-09_JPRB, &
  & 0.46141521E-09_JPRB, 0.47912929E-09_JPRB, 0.48664156E-09_JPRB, 0.48359661E-09_JPRB, 0.47056348E-09_JPRB, 0.44900578E-09_JPRB, &
  & 0.42076267E-09_JPRB, 0.38799058E-09_JPRB, 0.35264500E-09_JPRB, 0.31593145E-09_JPRB, 0.27969618E-09_JPRB, 0.24375532E-09_JPRB, &
  & 0.20960747E-09_JPRB, 0.17711817E-09_JPRB, 0.14727332E-09_JPRB, 0.12059410E-09_JPRB, 0.97751279E-10_JPRB, 0.78866247E-10_JPRB, &
  & 0.63923179E-10_JPRB, 0.52281238E-10_JPRB, 0.43092339E-10_JPRB, 0.35617186E-10_JPRB, 0.29309395E-10_JPRB, 0.23883456E-10_JPRB, &
  & 0.19333471E-10_JPRB, 0.15773013E-10_JPRB, 0.13172215E-10_JPRB, 0.11481600E-10_JPRB, 0.10712851E-10_JPRB, 0.10818691E-10_JPRB, &
  & 0.11933276E-10_JPRB, 0.14288554E-10_JPRB, 0.18090196E-10_JPRB, 0.23553909E-10_JPRB, 0.31031618E-10_JPRB, 0.40490930E-10_JPRB, &
  & 0.51910330E-10_JPRB, 0.65003655E-10_JPRB, 0.78884600E-10_JPRB, 0.92652101E-10_JPRB, 0.10530976E-09_JPRB, 0.11612982E-09_JPRB, &
  & 0.12429048E-09_JPRB, 0.12968719E-09_JPRB, 0.13237918E-09_JPRB, 0.13192825E-09_JPRB, 0.12889644E-09_JPRB, 0.12315071E-09_JPRB, &
  & 0.11402122E-09_JPRB, 0.10196867E-09_JPRB, 0.85722096E-10_JPRB, 0.66414277E-10_JPRB, 0.46987039E-10_JPRB, 0.31674805E-10_JPRB, &
  & 0.18169655E-10_JPRB, 0.10753308E-10_JPRB, 0.59134321E-11_JPRB, 0.37953568E-11_JPRB /)

RGHG4(:,37,10) = (/ &
  & 0.30412903E-09_JPRB, 0.32947181E-09_JPRB, 0.35227485E-09_JPRB, 0.37696460E-09_JPRB, 0.40319589E-09_JPRB, 0.42402296E-09_JPRB, &
  & 0.43811155E-09_JPRB, 0.44424786E-09_JPRB, 0.44266557E-09_JPRB, 0.43351370E-09_JPRB, 0.41725151E-09_JPRB, 0.39511283E-09_JPRB, &
  & 0.36821596E-09_JPRB, 0.33803252E-09_JPRB, 0.30589453E-09_JPRB, 0.27259009E-09_JPRB, 0.23916627E-09_JPRB, 0.20642597E-09_JPRB, &
  & 0.17426698E-09_JPRB, 0.14375823E-09_JPRB, 0.11555500E-09_JPRB, 0.90687846E-10_JPRB, 0.70016125E-10_JPRB, 0.53847451E-10_JPRB, &
  & 0.41746811E-10_JPRB, 0.32843568E-10_JPRB, 0.26187613E-10_JPRB, 0.21042191E-10_JPRB, 0.16881122E-10_JPRB, 0.13488648E-10_JPRB, &
  & 0.10749567E-10_JPRB, 0.86728819E-11_JPRB, 0.72017956E-11_JPRB, 0.62822512E-11_JPRB, 0.59064611E-11_JPRB, 0.60237952E-11_JPRB, &
  & 0.67621993E-11_JPRB, 0.82878877E-11_JPRB, 0.10831580E-10_JPRB, 0.14745212E-10_JPRB, 0.20451365E-10_JPRB, 0.28191059E-10_JPRB, &
  & 0.38223494E-10_JPRB, 0.50188093E-10_JPRB, 0.63180676E-10_JPRB, 0.76268533E-10_JPRB, 0.88451316E-10_JPRB, 0.98858428E-10_JPRB, &
  & 0.10682398E-09_JPRB, 0.11226266E-09_JPRB, 0.11509557E-09_JPRB, 0.11529570E-09_JPRB, 0.11304635E-09_JPRB, 0.10836415E-09_JPRB, &
  & 0.10057397E-09_JPRB, 0.90201457E-10_JPRB, 0.76020960E-10_JPRB, 0.59211920E-10_JPRB, 0.42119457E-10_JPRB, 0.28075891E-10_JPRB, &
  & 0.15227082E-10_JPRB, 0.88566324E-11_JPRB, 0.60952610E-11_JPRB, 0.38172725E-11_JPRB /)

RGHG4(:,38,10) = (/ &
  & 0.34246447E-09_JPRB, 0.36045569E-09_JPRB, 0.37367026E-09_JPRB, 0.38928255E-09_JPRB, 0.40447184E-09_JPRB, 0.41345746E-09_JPRB, &
  & 0.41524129E-09_JPRB, 0.41148365E-09_JPRB, 0.40240325E-09_JPRB, 0.38851375E-09_JPRB, 0.37015416E-09_JPRB, 0.34813918E-09_JPRB, &
  & 0.32304065E-09_JPRB, 0.29555441E-09_JPRB, 0.26631872E-09_JPRB, 0.23630217E-09_JPRB, 0.20542347E-09_JPRB, 0.17500618E-09_JPRB, &
  & 0.14527195E-09_JPRB, 0.11679199E-09_JPRB, 0.90517774E-10_JPRB, 0.67896286E-10_JPRB, 0.49939046E-10_JPRB, 0.36682376E-10_JPRB, &
  & 0.27381264E-10_JPRB, 0.20917082E-10_JPRB, 0.16290212E-10_JPRB, 0.12849302E-10_JPRB, 0.10178349E-10_JPRB, 0.80749782E-11_JPRB, &
  & 0.64245276E-11_JPRB, 0.52004299E-11_JPRB, 0.43444037E-11_JPRB, 0.38329899E-11_JPRB, 0.36361669E-11_JPRB, 0.37385052E-11_JPRB, &
  & 0.41994758E-11_JPRB, 0.51746099E-11_JPRB, 0.67722399E-11_JPRB, 0.94046420E-11_JPRB, 0.13395527E-10_JPRB, 0.19306159E-10_JPRB, &
  & 0.27561562E-10_JPRB, 0.37957373E-10_JPRB, 0.49785835E-10_JPRB, 0.61976715E-10_JPRB, 0.73529960E-10_JPRB, 0.83566175E-10_JPRB, &
  & 0.91504491E-10_JPRB, 0.97178890E-10_JPRB, 0.10035159E-09_JPRB, 0.10108219E-09_JPRB, 0.99459781E-10_JPRB, 0.95662159E-10_JPRB, &
  & 0.89169352E-10_JPRB, 0.80360212E-10_JPRB, 0.68191938E-10_JPRB, 0.53437060E-10_JPRB, 0.37939842E-10_JPRB, 0.25364780E-10_JPRB, &
  & 0.14390964E-10_JPRB, 0.88780216E-11_JPRB, 0.56124953E-11_JPRB, 0.37333634E-11_JPRB /)

RGHG4(:,39,10) = (/ &
  & 0.38470474E-09_JPRB, 0.38839751E-09_JPRB, 0.39070708E-09_JPRB, 0.39572332E-09_JPRB, 0.39993156E-09_JPRB, 0.39711739E-09_JPRB, &
  & 0.38888293E-09_JPRB, 0.37685391E-09_JPRB, 0.36228123E-09_JPRB, 0.34549938E-09_JPRB, 0.32646663E-09_JPRB, 0.30551692E-09_JPRB, &
  & 0.28262895E-09_JPRB, 0.25803565E-09_JPRB, 0.23186722E-09_JPRB, 0.20470078E-09_JPRB, 0.17712200E-09_JPRB, 0.14896338E-09_JPRB, &
  & 0.12138762E-09_JPRB, 0.94969893E-10_JPRB, 0.71226934E-10_JPRB, 0.51432591E-10_JPRB, 0.36517463E-10_JPRB, 0.26120415E-10_JPRB, &
  & 0.19148651E-10_JPRB, 0.14459373E-10_JPRB, 0.11194236E-10_JPRB, 0.87757943E-11_JPRB, 0.69790120E-11_JPRB, 0.55336517E-11_JPRB, &
  & 0.44522988E-11_JPRB, 0.36349127E-11_JPRB, 0.30707878E-11_JPRB, 0.27481760E-11_JPRB, 0.26268781E-11_JPRB, 0.27065299E-11_JPRB, &
  & 0.30335493E-11_JPRB, 0.36797575E-11_JPRB, 0.47441352E-11_JPRB, 0.65163977E-11_JPRB, 0.92406352E-11_JPRB, 0.13546467E-10_JPRB, &
  & 0.19850807E-10_JPRB, 0.28320719E-10_JPRB, 0.38542294E-10_JPRB, 0.49617185E-10_JPRB, 0.60415450E-10_JPRB, 0.69964527E-10_JPRB, &
  & 0.77681646E-10_JPRB, 0.83347995E-10_JPRB, 0.86728298E-10_JPRB, 0.87837966E-10_JPRB, 0.86872343E-10_JPRB, 0.83824739E-10_JPRB, &
  & 0.78518129E-10_JPRB, 0.71181720E-10_JPRB, 0.60837502E-10_JPRB, 0.48013014E-10_JPRB, 0.34489370E-10_JPRB, 0.23618645E-10_JPRB, &
  & 0.13397681E-10_JPRB, 0.82558465E-11_JPRB, 0.54699105E-11_JPRB, 0.38022259E-11_JPRB /)

RGHG4(:,40,10) = (/ &
  & 0.42006842E-09_JPRB, 0.40652307E-09_JPRB, 0.39776291E-09_JPRB, 0.39275888E-09_JPRB, 0.38690062E-09_JPRB, 0.37440173E-09_JPRB, &
  & 0.35782211E-09_JPRB, 0.34023434E-09_JPRB, 0.32239458E-09_JPRB, 0.30459610E-09_JPRB, 0.28613142E-09_JPRB, 0.26693783E-09_JPRB, &
  & 0.24661451E-09_JPRB, 0.22489696E-09_JPRB, 0.20174927E-09_JPRB, 0.17734683E-09_JPRB, 0.15217672E-09_JPRB, 0.12685047E-09_JPRB, &
  & 0.10168009E-09_JPRB, 0.77840678E-10_JPRB, 0.56784622E-10_JPRB, 0.40102366E-10_JPRB, 0.28048815E-10_JPRB, 0.19916886E-10_JPRB, &
  & 0.14615113E-10_JPRB, 0.11044287E-10_JPRB, 0.85960735E-11_JPRB, 0.67664060E-11_JPRB, 0.54003199E-11_JPRB, 0.43321254E-11_JPRB, &
  & 0.35037526E-11_JPRB, 0.28972085E-11_JPRB, 0.24722349E-11_JPRB, 0.22330636E-11_JPRB, 0.21574435E-11_JPRB, 0.22116133E-11_JPRB, &
  & 0.24839811E-11_JPRB, 0.29426472E-11_JPRB, 0.37404177E-11_JPRB, 0.49956198E-11_JPRB, 0.69448640E-11_JPRB, 0.10077269E-10_JPRB, &
  & 0.14703521E-10_JPRB, 0.21244267E-10_JPRB, 0.29641786E-10_JPRB, 0.39237443E-10_JPRB, 0.48993740E-10_JPRB, 0.57996833E-10_JPRB, &
  & 0.65600476E-10_JPRB, 0.71437446E-10_JPRB, 0.75199492E-10_JPRB, 0.76774344E-10_JPRB, 0.76253677E-10_JPRB, 0.73654118E-10_JPRB, &
  & 0.69491100E-10_JPRB, 0.63354294E-10_JPRB, 0.54665984E-10_JPRB, 0.43660044E-10_JPRB, 0.31609899E-10_JPRB, 0.21755034E-10_JPRB, &
  & 0.12463679E-10_JPRB, 0.78474345E-11_JPRB, 0.55754190E-11_JPRB, 0.38838867E-11_JPRB /)

RGHG4(:,41,10) = (/ &
  & 0.44160858E-09_JPRB, 0.41162712E-09_JPRB, 0.39338116E-09_JPRB, 0.37998615E-09_JPRB, 0.36610234E-09_JPRB, 0.34582204E-09_JPRB, &
  & 0.32357270E-09_JPRB, 0.30238081E-09_JPRB, 0.28304628E-09_JPRB, 0.26550456E-09_JPRB, 0.24848998E-09_JPRB, 0.23148182E-09_JPRB, &
  & 0.21380424E-09_JPRB, 0.19494857E-09_JPRB, 0.17470900E-09_JPRB, 0.15322507E-09_JPRB, 0.13087353E-09_JPRB, 0.10801861E-09_JPRB, &
  & 0.85532970E-10_JPRB, 0.64411372E-10_JPRB, 0.46404835E-10_JPRB, 0.32519692E-10_JPRB, 0.22828831E-10_JPRB, 0.16324601E-10_JPRB, &
  & 0.12090721E-10_JPRB, 0.92135197E-11_JPRB, 0.72009894E-11_JPRB, 0.57376261E-11_JPRB, 0.45814138E-11_JPRB, 0.37181668E-11_JPRB, &
  & 0.30212987E-11_JPRB, 0.25211805E-11_JPRB, 0.21665315E-11_JPRB, 0.19748454E-11_JPRB, 0.19171028E-11_JPRB, 0.19702679E-11_JPRB, &
  & 0.22032153E-11_JPRB, 0.25703697E-11_JPRB, 0.32184917E-11_JPRB, 0.41644600E-11_JPRB, 0.56778033E-11_JPRB, 0.79984214E-11_JPRB, &
  & 0.11418550E-10_JPRB, 0.16409140E-10_JPRB, 0.23024018E-10_JPRB, 0.30918251E-10_JPRB, 0.39490137E-10_JPRB, 0.47684360E-10_JPRB, &
  & 0.54847672E-10_JPRB, 0.60578140E-10_JPRB, 0.64485105E-10_JPRB, 0.66307917E-10_JPRB, 0.66184516E-10_JPRB, 0.64215917E-10_JPRB, &
  & 0.60901582E-10_JPRB, 0.55951653E-10_JPRB, 0.48682679E-10_JPRB, 0.39213365E-10_JPRB, 0.28635547E-10_JPRB, 0.20264537E-10_JPRB, &
  & 0.11867260E-10_JPRB, 0.77823789E-11_JPRB, 0.52804150E-11_JPRB, 0.39837517E-11_JPRB /)

RGHG4(:,42,10) = (/ &
  & 0.44017606E-09_JPRB, 0.39913503E-09_JPRB, 0.37436662E-09_JPRB, 0.35551639E-09_JPRB, 0.33611153E-09_JPRB, 0.31089603E-09_JPRB, &
  & 0.28570429E-09_JPRB, 0.26338035E-09_JPRB, 0.24422889E-09_JPRB, 0.22812169E-09_JPRB, 0.21317453E-09_JPRB, 0.19863081E-09_JPRB, &
  & 0.18366238E-09_JPRB, 0.16757794E-09_JPRB, 0.15009610E-09_JPRB, 0.13129374E-09_JPRB, 0.11157252E-09_JPRB, 0.91445497E-10_JPRB, &
  & 0.71624658E-10_JPRB, 0.53401183E-10_JPRB, 0.38257748E-10_JPRB, 0.26961815E-10_JPRB, 0.19153790E-10_JPRB, 0.13913653E-10_JPRB, &
  & 0.10410565E-10_JPRB, 0.80494812E-11_JPRB, 0.63002377E-11_JPRB, 0.50829987E-11_JPRB, 0.40612999E-11_JPRB, 0.33317309E-11_JPRB, &
  & 0.27128764E-11_JPRB, 0.22832127E-11_JPRB, 0.19734988E-11_JPRB, 0.18108905E-11_JPRB, 0.17677808E-11_JPRB, 0.18183883E-11_JPRB, &
  & 0.20307148E-11_JPRB, 0.23399030E-11_JPRB, 0.28858981E-11_JPRB, 0.36439584E-11_JPRB, 0.48510696E-11_JPRB, 0.66015613E-11_JPRB, &
  & 0.91925538E-11_JPRB, 0.12934161E-10_JPRB, 0.17899267E-10_JPRB, 0.24234262E-10_JPRB, 0.31390782E-10_JPRB, 0.38747477E-10_JPRB, &
  & 0.45493460E-10_JPRB, 0.51163244E-10_JPRB, 0.55247199E-10_JPRB, 0.57402683E-10_JPRB, 0.57736971E-10_JPRB, 0.56341359E-10_JPRB, &
  & 0.53677708E-10_JPRB, 0.49534748E-10_JPRB, 0.43399347E-10_JPRB, 0.35304471E-10_JPRB, 0.26104539E-10_JPRB, 0.18896116E-10_JPRB, &
  & 0.11260275E-10_JPRB, 0.75285316E-11_JPRB, 0.55445826E-11_JPRB, 0.41118966E-11_JPRB /)

RGHG4(:,43,10) = (/ &
  & 0.41946979E-09_JPRB, 0.37223069E-09_JPRB, 0.34456138E-09_JPRB, 0.32275746E-09_JPRB, 0.30019340E-09_JPRB, 0.27256750E-09_JPRB, &
  & 0.24650731E-09_JPRB, 0.22466726E-09_JPRB, 0.20669569E-09_JPRB, 0.19255189E-09_JPRB, 0.17988896E-09_JPRB, 0.16777407E-09_JPRB, &
  & 0.15535112E-09_JPRB, 0.14191145E-09_JPRB, 0.12707575E-09_JPRB, 0.11091889E-09_JPRB, 0.93879737E-10_JPRB, 0.76411773E-10_JPRB, &
  & 0.59420961E-10_JPRB, 0.44106920E-10_JPRB, 0.31818680E-10_JPRB, 0.22767973E-10_JPRB, 0.16499900E-10_JPRB, 0.12245550E-10_JPRB, &
  & 0.92699702E-11_JPRB, 0.72688149E-11_JPRB, 0.57236208E-11_JPRB, 0.46421990E-11_JPRB, 0.37343796E-11_JPRB, 0.30655450E-11_JPRB, &
  & 0.25164749E-11_JPRB, 0.21221701E-11_JPRB, 0.18429839E-11_JPRB, 0.17069872E-11_JPRB, 0.16669563E-11_JPRB, 0.17267372E-11_JPRB, &
  & 0.19190699E-11_JPRB, 0.21933271E-11_JPRB, 0.26718436E-11_JPRB, 0.33012711E-11_JPRB, 0.42933925E-11_JPRB, 0.56457803E-11_JPRB, &
  & 0.76515296E-11_JPRB, 0.10406787E-10_JPRB, 0.14127209E-10_JPRB, 0.18959001E-10_JPRB, 0.24826889E-10_JPRB, 0.31095546E-10_JPRB, &
  & 0.37173535E-10_JPRB, 0.42495164E-10_JPRB, 0.46447939E-10_JPRB, 0.48726939E-10_JPRB, 0.49283605E-10_JPRB, 0.48298650E-10_JPRB, &
  & 0.46271206E-10_JPRB, 0.43015834E-10_JPRB, 0.38028195E-10_JPRB, 0.31246943E-10_JPRB, 0.23374063E-10_JPRB, 0.17494535E-10_JPRB, &
  & 0.10734517E-10_JPRB, 0.74483961E-11_JPRB, 0.54348219E-11_JPRB, 0.42531655E-11_JPRB /)

RGHG4(:,44,10) = (/ &
  & 0.38169087E-09_JPRB, 0.33353301E-09_JPRB, 0.30562361E-09_JPRB, 0.28315542E-09_JPRB, 0.25984143E-09_JPRB, 0.23203051E-09_JPRB, &
  & 0.20718775E-09_JPRB, 0.18708493E-09_JPRB, 0.17090571E-09_JPRB, 0.15904644E-09_JPRB, 0.14867356E-09_JPRB, 0.13890103E-09_JPRB, &
  & 0.12890053E-09_JPRB, 0.11784783E-09_JPRB, 0.10550293E-09_JPRB, 0.91831903E-10_JPRB, 0.77303768E-10_JPRB, 0.62531966E-10_JPRB, &
  & 0.48393289E-10_JPRB, 0.36088570E-10_JPRB, 0.26421421E-10_JPRB, 0.19410185E-10_JPRB, 0.14405710E-10_JPRB, 0.10948293E-10_JPRB, &
  & 0.84174603E-11_JPRB, 0.66620784E-11_JPRB, 0.53074277E-11_JPRB, 0.42957890E-11_JPRB, 0.34962187E-11_JPRB, 0.28550344E-11_JPRB, &
  & 0.23636262E-11_JPRB, 0.19956354E-11_JPRB, 0.17405607E-11_JPRB, 0.16263796E-11_JPRB, 0.15891223E-11_JPRB, 0.16601718E-11_JPRB, &
  & 0.18312554E-11_JPRB, 0.20896906E-11_JPRB, 0.25118688E-11_JPRB, 0.30471394E-11_JPRB, 0.38721127E-11_JPRB, 0.49397522E-11_JPRB, &
  & 0.64859515E-11_JPRB, 0.85021651E-11_JPRB, 0.11192404E-10_JPRB, 0.14783478E-10_JPRB, 0.19252096E-10_JPRB, 0.24499484E-10_JPRB, &
  & 0.29851552E-10_JPRB, 0.34758561E-10_JPRB, 0.38543446E-10_JPRB, 0.40867108E-10_JPRB, 0.41676027E-10_JPRB, 0.41130491E-10_JPRB, &
  & 0.39600243E-10_JPRB, 0.37014163E-10_JPRB, 0.32960624E-10_JPRB, 0.27371463E-10_JPRB, 0.20825706E-10_JPRB, 0.16309714E-10_JPRB, &
  & 0.10258860E-10_JPRB, 0.73053950E-11_JPRB, 0.55561814E-11_JPRB, 0.43538914E-11_JPRB /)

RGHG4(:,45,10) = (/ &
  & 0.33283531E-09_JPRB, 0.28773051E-09_JPRB, 0.26154798E-09_JPRB, 0.24038943E-09_JPRB, 0.21780958E-09_JPRB, 0.19189637E-09_JPRB, &
  & 0.16932612E-09_JPRB, 0.15179313E-09_JPRB, 0.13778281E-09_JPRB, 0.12811280E-09_JPRB, 0.11992100E-09_JPRB, 0.11227232E-09_JPRB, &
  & 0.10433417E-09_JPRB, 0.95565590E-10_JPRB, 0.85448884E-10_JPRB, 0.74084530E-10_JPRB, 0.61995374E-10_JPRB, 0.49797270E-10_JPRB, &
  & 0.38599832E-10_JPRB, 0.29151199E-10_JPRB, 0.21945942E-10_JPRB, 0.16626631E-10_JPRB, 0.12712551E-10_JPRB, 0.98756333E-11_JPRB, &
  & 0.77437059E-11_JPRB, 0.61642770E-11_JPRB, 0.49766233E-11_JPRB, 0.40160713E-11_JPRB, 0.32974725E-11_JPRB, 0.26840502E-11_JPRB, &
  & 0.22339860E-11_JPRB, 0.18901820E-11_JPRB, 0.16564396E-11_JPRB, 0.15572772E-11_JPRB, 0.15291386E-11_JPRB, 0.16011499E-11_JPRB, &
  & 0.17644301E-11_JPRB, 0.20063534E-11_JPRB, 0.23803555E-11_JPRB, 0.28483390E-11_JPRB, 0.35383272E-11_JPRB, 0.43871391E-11_JPRB, &
  & 0.55801522E-11_JPRB, 0.70283605E-11_JPRB, 0.89496492E-11_JPRB, 0.11439487E-10_JPRB, 0.14747668E-10_JPRB, 0.18868993E-10_JPRB, &
  & 0.23409216E-10_JPRB, 0.27765245E-10_JPRB, 0.31228287E-10_JPRB, 0.33394794E-10_JPRB, 0.34213608E-10_JPRB, 0.33856602E-10_JPRB, &
  & 0.32759580E-10_JPRB, 0.30854222E-10_JPRB, 0.27776252E-10_JPRB, 0.23427375E-10_JPRB, 0.18248883E-10_JPRB, 0.15090772E-10_JPRB, &
  & 0.98390445E-11_JPRB, 0.72587960E-11_JPRB, 0.55022887E-11_JPRB, 0.43657074E-11_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART20',0,ZHOOK_HANDLE)



RGHG4(:,46,10) = (/ &
  & 0.27970626E-09_JPRB, 0.23930971E-09_JPRB, 0.21622744E-09_JPRB, 0.19701341E-09_JPRB, 0.17683620E-09_JPRB, 0.15352365E-09_JPRB, &
  & 0.13433379E-09_JPRB, 0.11963922E-09_JPRB, 0.10774595E-09_JPRB, 0.10023038E-09_JPRB, 0.93903101E-10_JPRB, 0.88014401E-10_JPRB, &
  & 0.82007699E-10_JPRB, 0.75068167E-10_JPRB, 0.67054591E-10_JPRB, 0.57845662E-10_JPRB, 0.48028796E-10_JPRB, 0.38555367E-10_JPRB, &
  & 0.30175331E-10_JPRB, 0.23476870E-10_JPRB, 0.18287800E-10_JPRB, 0.14391690E-10_JPRB, 0.11352336E-10_JPRB, 0.90108225E-11_JPRB, &
  & 0.72094197E-11_JPRB, 0.57723652E-11_JPRB, 0.47102005E-11_JPRB, 0.37936269E-11_JPRB, 0.31322510E-11_JPRB, 0.25419907E-11_JPRB, &
  & 0.21240579E-11_JPRB, 0.18003452E-11_JPRB, 0.15867022E-11_JPRB, 0.14977595E-11_JPRB, 0.14826929E-11_JPRB, 0.15505264E-11_JPRB, &
  & 0.17155516E-11_JPRB, 0.19348861E-11_JPRB, 0.22799187E-11_JPRB, 0.26909165E-11_JPRB, 0.32756616E-11_JPRB, 0.39598992E-11_JPRB, &
  & 0.48791353E-11_JPRB, 0.59215449E-11_JPRB, 0.72500933E-11_JPRB, 0.89080826E-11_JPRB, 0.11159500E-10_JPRB, 0.14199946E-10_JPRB, &
  & 0.17837648E-10_JPRB, 0.21539296E-10_JPRB, 0.24586914E-10_JPRB, 0.26562277E-10_JPRB, 0.27417875E-10_JPRB, 0.27335174E-10_JPRB, &
  & 0.26653896E-10_JPRB, 0.25314757E-10_JPRB, 0.23047633E-10_JPRB, 0.19793491E-10_JPRB, 0.15873374E-10_JPRB, 0.14074047E-10_JPRB, &
  & 0.94759547E-11_JPRB, 0.71472268E-11_JPRB, 0.55117031E-11_JPRB, 0.43242584E-11_JPRB /)

RGHG4(:,47,10) = (/ &
  & 0.22540507E-09_JPRB, 0.19086036E-09_JPRB, 0.17109313E-09_JPRB, 0.15485588E-09_JPRB, 0.13711698E-09_JPRB, 0.11796554E-09_JPRB, &
  & 0.10209500E-09_JPRB, 0.90491704E-10_JPRB, 0.80767039E-10_JPRB, 0.75109939E-10_JPRB, 0.70487310E-10_JPRB, 0.66199102E-10_JPRB, &
  & 0.61664659E-10_JPRB, 0.56524948E-10_JPRB, 0.50284815E-10_JPRB, 0.43102723E-10_JPRB, 0.35683845E-10_JPRB, 0.28810244E-10_JPRB, &
  & 0.23209795E-10_JPRB, 0.18762899E-10_JPRB, 0.15299808E-10_JPRB, 0.12495016E-10_JPRB, 0.10196153E-10_JPRB, 0.82591165E-11_JPRB, &
  & 0.67344919E-11_JPRB, 0.54291645E-11_JPRB, 0.44694838E-11_JPRB, 0.35937770E-11_JPRB, 0.29793791E-11_JPRB, 0.24128566E-11_JPRB, &
  & 0.20235150E-11_JPRB, 0.17204390E-11_JPRB, 0.15258427E-11_JPRB, 0.14448262E-11_JPRB, 0.14442429E-11_JPRB, 0.15048465E-11_JPRB, &
  & 0.16732477E-11_JPRB, 0.18708548E-11_JPRB, 0.21954203E-11_JPRB, 0.25549174E-11_JPRB, 0.30555051E-11_JPRB, 0.36092327E-11_JPRB, &
  & 0.43173364E-11_JPRB, 0.50588765E-11_JPRB, 0.59559367E-11_JPRB, 0.69921386E-11_JPRB, 0.84180649E-11_JPRB, 0.10471758E-10_JPRB, &
  & 0.13103751E-10_JPRB, 0.16081473E-10_JPRB, 0.18644688E-10_JPRB, 0.20372950E-10_JPRB, 0.21185408E-10_JPRB, 0.21236799E-10_JPRB, &
  & 0.20857573E-10_JPRB, 0.19976371E-10_JPRB, 0.18548416E-10_JPRB, 0.16328923E-10_JPRB, 0.13583884E-10_JPRB, 0.13009796E-10_JPRB, &
  & 0.91267861E-11_JPRB, 0.70668159E-11_JPRB, 0.55178809E-11_JPRB, 0.42932190E-11_JPRB /)

RGHG4(:,48,10) = (/ &
  & 0.17425514E-09_JPRB, 0.14510365E-09_JPRB, 0.12895106E-09_JPRB, 0.11523630E-09_JPRB, 0.10099145E-09_JPRB, 0.85399555E-10_JPRB, &
  & 0.73417897E-10_JPRB, 0.64783304E-10_JPRB, 0.57052404E-10_JPRB, 0.53176425E-10_JPRB, 0.50002905E-10_JPRB, 0.47043303E-10_JPRB, &
  & 0.43950964E-10_JPRB, 0.40220341E-10_JPRB, 0.35779064E-10_JPRB, 0.30630155E-10_JPRB, 0.25574850E-10_JPRB, 0.21281183E-10_JPRB, &
  & 0.17884983E-10_JPRB, 0.15224095E-10_JPRB, 0.12981891E-10_JPRB, 0.11008906E-10_JPRB, 0.92602453E-11_JPRB, 0.76536008E-11_JPRB, &
  & 0.63421503E-11_JPRB, 0.51478080E-11_JPRB, 0.42628154E-11_JPRB, 0.34279669E-11_JPRB, 0.28462332E-11_JPRB, 0.23041517E-11_JPRB, &
  & 0.19380797E-11_JPRB, 0.16545682E-11_JPRB, 0.14780406E-11_JPRB, 0.14037288E-11_JPRB, 0.14165992E-11_JPRB, 0.14725038E-11_JPRB, &
  & 0.16413982E-11_JPRB, 0.18252645E-11_JPRB, 0.21291671E-11_JPRB, 0.24515260E-11_JPRB, 0.28891956E-11_JPRB, 0.33432408E-11_JPRB, &
  & 0.38951806E-11_JPRB, 0.44252427E-11_JPRB, 0.50246422E-11_JPRB, 0.56457083E-11_JPRB, 0.65009131E-11_JPRB, 0.77279893E-11_JPRB, &
  & 0.94572744E-11_JPRB, 0.11532346E-10_JPRB, 0.13538670E-10_JPRB, 0.14976438E-10_JPRB, 0.15759742E-10_JPRB, 0.15985475E-10_JPRB, &
  & 0.15923811E-10_JPRB, 0.15463511E-10_JPRB, 0.14617621E-10_JPRB, 0.13211100E-10_JPRB, 0.11365579E-10_JPRB, 0.11889291E-10_JPRB, &
  & 0.87414607E-11_JPRB, 0.69514412E-11_JPRB, 0.54923704E-11_JPRB, 0.43831085E-11_JPRB /)

RGHG4(:,49,10) = (/ &
  & 0.12740027E-09_JPRB, 0.10357076E-09_JPRB, 0.90551157E-10_JPRB, 0.79762370E-10_JPRB, 0.68398454E-10_JPRB, 0.56996404E-10_JPRB, &
  & 0.48348103E-10_JPRB, 0.42596444E-10_JPRB, 0.36647612E-10_JPRB, 0.34260737E-10_JPRB, 0.32381837E-10_JPRB, 0.30619635E-10_JPRB, &
  & 0.28715546E-10_JPRB, 0.26474465E-10_JPRB, 0.23691177E-10_JPRB, 0.20695452E-10_JPRB, 0.17905299E-10_JPRB, 0.15663052E-10_JPRB, &
  & 0.13930804E-10_JPRB, 0.12480132E-10_JPRB, 0.11137222E-10_JPRB, 0.97743723E-11_JPRB, 0.84596184E-11_JPRB, 0.71276470E-11_JPRB, &
  & 0.59854183E-11_JPRB, 0.48977176E-11_JPRB, 0.40633443E-11_JPRB, 0.32752477E-11_JPRB, 0.27160095E-11_JPRB, 0.22063425E-11_JPRB, &
  & 0.18623909E-11_JPRB, 0.16003851E-11_JPRB, 0.14412984E-11_JPRB, 0.13742369E-11_JPRB, 0.13954182E-11_JPRB, 0.14530630E-11_JPRB, &
  & 0.16123343E-11_JPRB, 0.17932561E-11_JPRB, 0.20718058E-11_JPRB, 0.23702696E-11_JPRB, 0.27512341E-11_JPRB, 0.31300262E-11_JPRB, &
  & 0.35596064E-11_JPRB, 0.39403259E-11_JPRB, 0.43305893E-11_JPRB, 0.46864171E-11_JPRB, 0.51516304E-11_JPRB, 0.58138004E-11_JPRB, &
  & 0.67516466E-11_JPRB, 0.80109929E-11_JPRB, 0.92677229E-11_JPRB, 0.10326936E-10_JPRB, 0.10975739E-10_JPRB, 0.11264135E-10_JPRB, &
  & 0.11377064E-10_JPRB, 0.11220049E-10_JPRB, 0.10862706E-10_JPRB, 0.10103776E-10_JPRB, 0.90423502E-11_JPRB, 0.10458734E-10_JPRB, &
  & 0.80342781E-11_JPRB, 0.65834677E-11_JPRB, 0.53461155E-11_JPRB, 0.45429524E-11_JPRB /)

RGHG4(:,50,10) = (/ &
  & 0.87762089E-10_JPRB, 0.69070361E-10_JPRB, 0.59361169E-10_JPRB, 0.51283235E-10_JPRB, 0.43010043E-10_JPRB, 0.35110800E-10_JPRB, &
  & 0.29612979E-10_JPRB, 0.26179840E-10_JPRB, 0.21660330E-10_JPRB, 0.20421838E-10_JPRB, 0.19457097E-10_JPRB, 0.18591602E-10_JPRB, &
  & 0.17680361E-10_JPRB, 0.16569619E-10_JPRB, 0.15326065E-10_JPRB, 0.13970971E-10_JPRB, 0.12815343E-10_JPRB, 0.11895428E-10_JPRB, &
  & 0.11168183E-10_JPRB, 0.10471871E-10_JPRB, 0.97103150E-11_JPRB, 0.87840065E-11_JPRB, 0.77873940E-11_JPRB, 0.66829107E-11_JPRB, &
  & 0.56643249E-11_JPRB, 0.46767043E-11_JPRB, 0.38745044E-11_JPRB, 0.31478669E-11_JPRB, 0.26020837E-11_JPRB, 0.21287297E-11_JPRB, &
  & 0.18040934E-11_JPRB, 0.15632373E-11_JPRB, 0.14212093E-11_JPRB, 0.13634756E-11_JPRB, 0.13877448E-11_JPRB, 0.14542940E-11_JPRB, &
  & 0.15966177E-11_JPRB, 0.17804694E-11_JPRB, 0.20267692E-11_JPRB, 0.23124558E-11_JPRB, 0.26431062E-11_JPRB, 0.29694639E-11_JPRB, &
  & 0.33050242E-11_JPRB, 0.35799931E-11_JPRB, 0.38293951E-11_JPRB, 0.40177336E-11_JPRB, 0.42462414E-11_JPRB, 0.45520267E-11_JPRB, &
  & 0.49947485E-11_JPRB, 0.55740564E-11_JPRB, 0.62146403E-11_JPRB, 0.67693763E-11_JPRB, 0.71928010E-11_JPRB, 0.74525689E-11_JPRB, &
  & 0.76507533E-11_JPRB, 0.76929817E-11_JPRB, 0.76545124E-11_JPRB, 0.73143774E-11_JPRB, 0.68115440E-11_JPRB, 0.87891690E-11_JPRB, &
  & 0.70341202E-11_JPRB, 0.59490958E-11_JPRB, 0.50607869E-11_JPRB, 0.45827244E-11_JPRB /)

RGHG4(:,51,10) = (/ &
  & 0.57277492E-10_JPRB, 0.44112811E-10_JPRB, 0.37592270E-10_JPRB, 0.32106259E-10_JPRB, 0.26624447E-10_JPRB, 0.21600397E-10_JPRB, &
  & 0.18332055E-10_JPRB, 0.16469083E-10_JPRB, 0.12977994E-10_JPRB, 0.12371081E-10_JPRB, 0.11929962E-10_JPRB, 0.11543794E-10_JPRB, &
  & 0.11171333E-10_JPRB, 0.10776363E-10_JPRB, 0.10339109E-10_JPRB, 0.99412943E-11_JPRB, 0.96285454E-11_JPRB, 0.94136079E-11_JPRB, &
  & 0.92296535E-11_JPRB, 0.89813166E-11_JPRB, 0.85902899E-11_JPRB, 0.79820707E-11_JPRB, 0.72209578E-11_JPRB, 0.63071523E-11_JPRB, &
  & 0.53823959E-11_JPRB, 0.44915178E-11_JPRB, 0.37052349E-11_JPRB, 0.30372128E-11_JPRB, 0.25027454E-11_JPRB, 0.20695832E-11_JPRB, &
  & 0.17660907E-11_JPRB, 0.15463243E-11_JPRB, 0.14212807E-11_JPRB, 0.13739071E-11_JPRB, 0.13977273E-11_JPRB, 0.14714839E-11_JPRB, &
  & 0.15999915E-11_JPRB, 0.17802241E-11_JPRB, 0.20066871E-11_JPRB, 0.22798801E-11_JPRB, 0.25706197E-11_JPRB, 0.28554800E-11_JPRB, &
  & 0.31157698E-11_JPRB, 0.33179410E-11_JPRB, 0.34658611E-11_JPRB, 0.35526484E-11_JPRB, 0.36352197E-11_JPRB, 0.37375441E-11_JPRB, &
  & 0.38848898E-11_JPRB, 0.40861177E-11_JPRB, 0.42826805E-11_JPRB, 0.44766140E-11_JPRB, 0.46239909E-11_JPRB, 0.47342403E-11_JPRB, &
  & 0.48450688E-11_JPRB, 0.48882847E-11_JPRB, 0.49681587E-11_JPRB, 0.48709179E-11_JPRB, 0.47210209E-11_JPRB, 0.68937551E-11_JPRB, &
  & 0.57548020E-11_JPRB, 0.50790930E-11_JPRB, 0.45396261E-11_JPRB, 0.43197264E-11_JPRB /)

RGHG4(:,52,10) = (/ &
  & 0.35575508E-10_JPRB, 0.28034056E-10_JPRB, 0.24303197E-10_JPRB, 0.20958357E-10_JPRB, 0.17435827E-10_JPRB, 0.14342773E-10_JPRB, &
  & 0.12456090E-10_JPRB, 0.11430274E-10_JPRB, 0.86264424E-11_JPRB, 0.83208093E-11_JPRB, 0.81032056E-11_JPRB, 0.79328991E-11_JPRB, &
  & 0.78000566E-11_JPRB, 0.76785557E-11_JPRB, 0.76074841E-11_JPRB, 0.75905636E-11_JPRB, 0.76475276E-11_JPRB, 0.77475517E-11_JPRB, &
  & 0.78428739E-11_JPRB, 0.78428609E-11_JPRB, 0.76944137E-11_JPRB, 0.73123634E-11_JPRB, 0.67347161E-11_JPRB, 0.59836650E-11_JPRB, &
  & 0.51417095E-11_JPRB, 0.43317650E-11_JPRB, 0.35748579E-11_JPRB, 0.29635270E-11_JPRB, 0.24456971E-11_JPRB, 0.20493962E-11_JPRB, &
  & 0.17643841E-11_JPRB, 0.15631794E-11_JPRB, 0.14540536E-11_JPRB, 0.14176697E-11_JPRB, 0.14418410E-11_JPRB, 0.15185078E-11_JPRB, &
  & 0.16393418E-11_JPRB, 0.18007441E-11_JPRB, 0.20127849E-11_JPRB, 0.22640271E-11_JPRB, 0.25291546E-11_JPRB, 0.27755771E-11_JPRB, &
  & 0.29819341E-11_JPRB, 0.31239256E-11_JPRB, 0.32024199E-11_JPRB, 0.32205382E-11_JPRB, 0.32119782E-11_JPRB, 0.32004985E-11_JPRB, &
  & 0.31953286E-11_JPRB, 0.32002487E-11_JPRB, 0.32015428E-11_JPRB, 0.31995580E-11_JPRB, 0.31980863E-11_JPRB, 0.32038764E-11_JPRB, &
  & 0.32246096E-11_JPRB, 0.32378924E-11_JPRB, 0.33334993E-11_JPRB, 0.32845404E-11_JPRB, 0.32464782E-11_JPRB, 0.52472735E-11_JPRB, &
  & 0.45714071E-11_JPRB, 0.41576326E-11_JPRB, 0.38625166E-11_JPRB, 0.37943915E-11_JPRB /)

RGHG4(:,53,10) = (/ &
  & 0.23729966E-10_JPRB, 0.19289410E-10_JPRB, 0.16856735E-10_JPRB, 0.14673490E-10_JPRB, 0.12390662E-10_JPRB, 0.10463590E-10_JPRB, &
  & 0.93209928E-11_JPRB, 0.87292500E-11_JPRB, 0.64310792E-11_JPRB, 0.62570721E-11_JPRB, 0.61424212E-11_JPRB, 0.60607639E-11_JPRB, &
  & 0.60164655E-11_JPRB, 0.60131622E-11_JPRB, 0.60634592E-11_JPRB, 0.61870695E-11_JPRB, 0.63877324E-11_JPRB, 0.66219235E-11_JPRB, &
  & 0.68455779E-11_JPRB, 0.69914643E-11_JPRB, 0.69926760E-11_JPRB, 0.67779411E-11_JPRB, 0.63378703E-11_JPRB, 0.57264319E-11_JPRB, &
  & 0.49646042E-11_JPRB, 0.42253887E-11_JPRB, 0.35036477E-11_JPRB, 0.29259273E-11_JPRB, 0.24287660E-11_JPRB, 0.20626545E-11_JPRB, &
  & 0.17955781E-11_JPRB, 0.16127822E-11_JPRB, 0.15190582E-11_JPRB, 0.14926459E-11_JPRB, 0.15185671E-11_JPRB, 0.15940471E-11_JPRB, &
  & 0.17110484E-11_JPRB, 0.18583462E-11_JPRB, 0.20535663E-11_JPRB, 0.22929013E-11_JPRB, 0.25332091E-11_JPRB, 0.27455503E-11_JPRB, &
  & 0.29070377E-11_JPRB, 0.30048470E-11_JPRB, 0.30310353E-11_JPRB, 0.30050678E-11_JPRB, 0.29408004E-11_JPRB, 0.28671271E-11_JPRB, &
  & 0.27869673E-11_JPRB, 0.27080239E-11_JPRB, 0.26278821E-11_JPRB, 0.25578229E-11_JPRB, 0.25050636E-11_JPRB, 0.24609258E-11_JPRB, &
  & 0.24499224E-11_JPRB, 0.24286940E-11_JPRB, 0.25087107E-11_JPRB, 0.24721536E-11_JPRB, 0.24622034E-11_JPRB, 0.42666543E-11_JPRB, &
  & 0.38179529E-11_JPRB, 0.35280177E-11_JPRB, 0.33381956E-11_JPRB, 0.32715801E-11_JPRB /)

RGHG4(:,54,10) = (/ &
  & 0.17663074E-10_JPRB, 0.14062207E-10_JPRB, 0.12426347E-10_JPRB, 0.10934150E-10_JPRB, 0.94452345E-11_JPRB, 0.82032818E-11_JPRB, &
  & 0.75213247E-11_JPRB, 0.71479472E-11_JPRB, 0.51886707E-11_JPRB, 0.50890169E-11_JPRB, 0.50186183E-11_JPRB, 0.49794912E-11_JPRB, &
  & 0.49709065E-11_JPRB, 0.50024455E-11_JPRB, 0.50967403E-11_JPRB, 0.52692139E-11_JPRB, 0.55116745E-11_JPRB, 0.57971427E-11_JPRB, &
  & 0.60864976E-11_JPRB, 0.63186570E-11_JPRB, 0.64318256E-11_JPRB, 0.63480905E-11_JPRB, 0.60310004E-11_JPRB, 0.55408243E-11_JPRB, &
  & 0.48708793E-11_JPRB, 0.41770610E-11_JPRB, 0.35127324E-11_JPRB, 0.29570422E-11_JPRB, 0.24864184E-11_JPRB, 0.21438097E-11_JPRB, &
  & 0.18900419E-11_JPRB, 0.17240093E-11_JPRB, 0.16448041E-11_JPRB, 0.16269426E-11_JPRB, 0.16555917E-11_JPRB, 0.17293973E-11_JPRB, &
  & 0.18378079E-11_JPRB, 0.19617502E-11_JPRB, 0.21467778E-11_JPRB, 0.23656376E-11_JPRB, 0.25893374E-11_JPRB, 0.27647719E-11_JPRB, &
  & 0.28925553E-11_JPRB, 0.29464517E-11_JPRB, 0.29344953E-11_JPRB, 0.28726006E-11_JPRB, 0.27724342E-11_JPRB, 0.26609374E-11_JPRB, &
  & 0.25453409E-11_JPRB, 0.24297407E-11_JPRB, 0.23224526E-11_JPRB, 0.22341404E-11_JPRB, 0.21640871E-11_JPRB, 0.21197690E-11_JPRB, &
  & 0.20954213E-11_JPRB, 0.20825388E-11_JPRB, 0.21741211E-11_JPRB, 0.21491739E-11_JPRB, 0.21497259E-11_JPRB, 0.37960425E-11_JPRB, &
  & 0.34491377E-11_JPRB, 0.32228562E-11_JPRB, 0.30867778E-11_JPRB, 0.29651388E-11_JPRB /)

RGHG4(:,55,10) = (/ &
  & 0.12619497E-10_JPRB, 0.10662772E-10_JPRB, 0.95929237E-11_JPRB, 0.86174002E-11_JPRB, 0.76015340E-11_JPRB, 0.68224974E-11_JPRB, &
  & 0.63815563E-11_JPRB, 0.61435418E-11_JPRB, 0.44572202E-11_JPRB, 0.43904086E-11_JPRB, 0.43459082E-11_JPRB, 0.43226022E-11_JPRB, &
  & 0.43304414E-11_JPRB, 0.43742301E-11_JPRB, 0.44757969E-11_JPRB, 0.46503929E-11_JPRB, 0.49059316E-11_JPRB, 0.52070670E-11_JPRB, &
  & 0.55266039E-11_JPRB, 0.58202965E-11_JPRB, 0.60157803E-11_JPRB, 0.60437506E-11_JPRB, 0.58270567E-11_JPRB, 0.54385897E-11_JPRB, &
  & 0.48540828E-11_JPRB, 0.42105768E-11_JPRB, 0.35886554E-11_JPRB, 0.30435064E-11_JPRB, 0.25954612E-11_JPRB, 0.22638720E-11_JPRB, &
  & 0.20197795E-11_JPRB, 0.18703769E-11_JPRB, 0.18054202E-11_JPRB, 0.17957154E-11_JPRB, 0.18296361E-11_JPRB, 0.19065574E-11_JPRB, &
  & 0.20123324E-11_JPRB, 0.21267380E-11_JPRB, 0.23008821E-11_JPRB, 0.25090967E-11_JPRB, 0.27140744E-11_JPRB, 0.28559128E-11_JPRB, &
  & 0.29524267E-11_JPRB, 0.29651928E-11_JPRB, 0.29280725E-11_JPRB, 0.28342910E-11_JPRB, 0.27130351E-11_JPRB, 0.25798478E-11_JPRB, &
  & 0.24447775E-11_JPRB, 0.23128697E-11_JPRB, 0.21953899E-11_JPRB, 0.21020312E-11_JPRB, 0.20369858E-11_JPRB, 0.19868213E-11_JPRB, &
  & 0.19721759E-11_JPRB, 0.19567980E-11_JPRB, 0.20479599E-11_JPRB, 0.20338219E-11_JPRB, 0.20439199E-11_JPRB, 0.36109702E-11_JPRB, &
  & 0.33519858E-11_JPRB, 0.31688218E-11_JPRB, 0.30473200E-11_JPRB, 0.28839654E-11_JPRB /)

RGHG4(:,56,10) = (/ &
  & 0.10354489E-10_JPRB, 0.85862975E-11_JPRB, 0.77809131E-11_JPRB, 0.70621317E-11_JPRB, 0.63999457E-11_JPRB, 0.58825436E-11_JPRB, &
  & 0.56033051E-11_JPRB, 0.54385520E-11_JPRB, 0.39710106E-11_JPRB, 0.39228907E-11_JPRB, 0.38900853E-11_JPRB, 0.38739658E-11_JPRB, &
  & 0.38853499E-11_JPRB, 0.39302836E-11_JPRB, 0.40283718E-11_JPRB, 0.42008354E-11_JPRB, 0.44508837E-11_JPRB, 0.47585343E-11_JPRB, &
  & 0.51074089E-11_JPRB, 0.54542872E-11_JPRB, 0.57322441E-11_JPRB, 0.58515536E-11_JPRB, 0.57228410E-11_JPRB, 0.54303372E-11_JPRB, &
  & 0.49153528E-11_JPRB, 0.43081597E-11_JPRB, 0.37184140E-11_JPRB, 0.31800211E-11_JPRB, 0.27506710E-11_JPRB, 0.24252525E-11_JPRB, &
  & 0.21911498E-11_JPRB, 0.20594995E-11_JPRB, 0.20068302E-11_JPRB, 0.20045226E-11_JPRB, 0.20457312E-11_JPRB, 0.21286874E-11_JPRB, &
  & 0.22365337E-11_JPRB, 0.23504738E-11_JPRB, 0.25245160E-11_JPRB, 0.27264590E-11_JPRB, 0.29183494E-11_JPRB, 0.30309737E-11_JPRB, &
  & 0.30990393E-11_JPRB, 0.30768758E-11_JPRB, 0.30135781E-11_JPRB, 0.28939206E-11_JPRB, 0.27481179E-11_JPRB, 0.26012168E-11_JPRB, &
  & 0.24474641E-11_JPRB, 0.23038244E-11_JPRB, 0.21791271E-11_JPRB, 0.20865813E-11_JPRB, 0.20203951E-11_JPRB, 0.19811531E-11_JPRB, &
  & 0.19650813E-11_JPRB, 0.19613998E-11_JPRB, 0.20662300E-11_JPRB, 0.20692710E-11_JPRB, 0.20998305E-11_JPRB, 0.36299501E-11_JPRB, &
  & 0.33947654E-11_JPRB, 0.32305228E-11_JPRB, 0.31294375E-11_JPRB, 0.29785098E-11_JPRB /)

RGHG4(:,57,10) = (/ &
  & 0.80587993E-11_JPRB, 0.70019255E-11_JPRB, 0.65069981E-11_JPRB, 0.60178507E-11_JPRB, 0.55622481E-11_JPRB, 0.52280797E-11_JPRB, &
  & 0.50362002E-11_JPRB, 0.49150631E-11_JPRB, 0.36401676E-11_JPRB, 0.36059036E-11_JPRB, 0.35824390E-11_JPRB, 0.35715337E-11_JPRB, &
  & 0.35843728E-11_JPRB, 0.36270544E-11_JPRB, 0.37202984E-11_JPRB, 0.38815665E-11_JPRB, 0.41302452E-11_JPRB, 0.44434755E-11_JPRB, &
  & 0.48191911E-11_JPRB, 0.52216712E-11_JPRB, 0.55665607E-11_JPRB, 0.57687761E-11_JPRB, 0.57029789E-11_JPRB, 0.54490514E-11_JPRB, &
  & 0.49923984E-11_JPRB, 0.44303870E-11_JPRB, 0.38694738E-11_JPRB, 0.33514257E-11_JPRB, 0.29306668E-11_JPRB, 0.26123537E-11_JPRB, &
  & 0.23939895E-11_JPRB, 0.22801509E-11_JPRB, 0.22368936E-11_JPRB, 0.22428166E-11_JPRB, 0.22939721E-11_JPRB, 0.23847400E-11_JPRB, &
  & 0.24975651E-11_JPRB, 0.26207675E-11_JPRB, 0.27979270E-11_JPRB, 0.30058156E-11_JPRB, 0.31956768E-11_JPRB, 0.32955424E-11_JPRB, &
  & 0.33441494E-11_JPRB, 0.32941391E-11_JPRB, 0.32140326E-11_JPRB, 0.30686985E-11_JPRB, 0.29011186E-11_JPRB, 0.27403700E-11_JPRB, &
  & 0.25703445E-11_JPRB, 0.24074829E-11_JPRB, 0.22774124E-11_JPRB, 0.21790508E-11_JPRB, 0.21216843E-11_JPRB, 0.20776423E-11_JPRB, &
  & 0.20726133E-11_JPRB, 0.20692968E-11_JPRB, 0.21781505E-11_JPRB, 0.21862213E-11_JPRB, 0.22182200E-11_JPRB, 0.37254496E-11_JPRB, &
  & 0.35356587E-11_JPRB, 0.33901152E-11_JPRB, 0.32896752E-11_JPRB, 0.31137133E-11_JPRB /)

RGHG4(:,58,10) = (/ &
  & 0.69486587E-11_JPRB, 0.60589823E-11_JPRB, 0.56343762E-11_JPRB, 0.52784326E-11_JPRB, 0.49683916E-11_JPRB, 0.47479013E-11_JPRB, &
  & 0.46218290E-11_JPRB, 0.45337085E-11_JPRB, 0.34163750E-11_JPRB, 0.33886858E-11_JPRB, 0.33667171E-11_JPRB, 0.33593237E-11_JPRB, &
  & 0.33707939E-11_JPRB, 0.34131081E-11_JPRB, 0.35031062E-11_JPRB, 0.36637499E-11_JPRB, 0.39161552E-11_JPRB, 0.42436822E-11_JPRB, &
  & 0.46549223E-11_JPRB, 0.51043657E-11_JPRB, 0.55020107E-11_JPRB, 0.57300133E-11_JPRB, 0.57148652E-11_JPRB, 0.55139127E-11_JPRB, &
  & 0.51082840E-11_JPRB, 0.45849288E-11_JPRB, 0.40415787E-11_JPRB, 0.35474750E-11_JPRB, 0.31349936E-11_JPRB, 0.28330051E-11_JPRB, &
  & 0.26343110E-11_JPRB, 0.25362726E-11_JPRB, 0.25023885E-11_JPRB, 0.25215674E-11_JPRB, 0.25850910E-11_JPRB, 0.26833824E-11_JPRB, &
  & 0.27999783E-11_JPRB, 0.29314916E-11_JPRB, 0.31155419E-11_JPRB, 0.33258450E-11_JPRB, 0.35231163E-11_JPRB, 0.36385721E-11_JPRB, &
  & 0.36833483E-11_JPRB, 0.36211075E-11_JPRB, 0.35347007E-11_JPRB, 0.33756080E-11_JPRB, 0.31862514E-11_JPRB, 0.30153443E-11_JPRB, &
  & 0.28168496E-11_JPRB, 0.26323113E-11_JPRB, 0.24869171E-11_JPRB, 0.23841591E-11_JPRB, 0.23201755E-11_JPRB, 0.22831697E-11_JPRB, &
  & 0.22740577E-11_JPRB, 0.22753316E-11_JPRB, 0.23891113E-11_JPRB, 0.24025595E-11_JPRB, 0.24473455E-11_JPRB, 0.39697390E-11_JPRB, &
  & 0.37728293E-11_JPRB, 0.36211130E-11_JPRB, 0.35144184E-11_JPRB, 0.33216507E-11_JPRB /)

RGHG4(:,59,10) = (/ &
  & 0.58564134E-11_JPRB, 0.52623266E-11_JPRB, 0.50245585E-11_JPRB, 0.47599073E-11_JPRB, 0.45522423E-11_JPRB, 0.43975765E-11_JPRB, &
  & 0.43055793E-11_JPRB, 0.42405441E-11_JPRB, 0.32711390E-11_JPRB, 0.32530838E-11_JPRB, 0.32369600E-11_JPRB, 0.32338613E-11_JPRB, &
  & 0.32469483E-11_JPRB, 0.32937637E-11_JPRB, 0.33832733E-11_JPRB, 0.35514345E-11_JPRB, 0.38172768E-11_JPRB, 0.41600057E-11_JPRB, &
  & 0.45994484E-11_JPRB, 0.50810914E-11_JPRB, 0.54905412E-11_JPRB, 0.57476363E-11_JPRB, 0.57707892E-11_JPRB, 0.55921760E-11_JPRB, &
  & 0.52270150E-11_JPRB, 0.47415596E-11_JPRB, 0.42248865E-11_JPRB, 0.37561499E-11_JPRB, 0.33572598E-11_JPRB, 0.30823781E-11_JPRB, &
  & 0.29016537E-11_JPRB, 0.28192631E-11_JPRB, 0.28005669E-11_JPRB, 0.28373022E-11_JPRB, 0.29118444E-11_JPRB, 0.30146773E-11_JPRB, &
  & 0.31355946E-11_JPRB, 0.32782900E-11_JPRB, 0.34689786E-11_JPRB, 0.36895617E-11_JPRB, 0.38993305E-11_JPRB, 0.40224529E-11_JPRB, &
  & 0.40829228E-11_JPRB, 0.40469303E-11_JPRB, 0.39671231E-11_JPRB, 0.38170027E-11_JPRB, 0.36262313E-11_JPRB, 0.34523738E-11_JPRB, &
  & 0.32258436E-11_JPRB, 0.30101707E-11_JPRB, 0.28454038E-11_JPRB, 0.27278594E-11_JPRB, 0.26621598E-11_JPRB, 0.26138770E-11_JPRB, &
  & 0.26065773E-11_JPRB, 0.26005743E-11_JPRB, 0.27109541E-11_JPRB, 0.27184190E-11_JPRB, 0.27482524E-11_JPRB, 0.42743417E-11_JPRB, &
  & 0.40794568E-11_JPRB, 0.39251562E-11_JPRB, 0.38085793E-11_JPRB, 0.35865497E-11_JPRB /)

RGHG4(:,60,10) = (/ &
  & 0.53535735E-11_JPRB, 0.48436663E-11_JPRB, 0.46019104E-11_JPRB, 0.44112773E-11_JPRB, 0.42645032E-11_JPRB, 0.41695241E-11_JPRB, &
  & 0.41104997E-11_JPRB, 0.40635494E-11_JPRB, 0.32126389E-11_JPRB, 0.31979428E-11_JPRB, 0.31868408E-11_JPRB, 0.31858069E-11_JPRB, &
  & 0.32063772E-11_JPRB, 0.32545670E-11_JPRB, 0.33580903E-11_JPRB, 0.35407799E-11_JPRB, 0.38275177E-11_JPRB, 0.41862369E-11_JPRB, &
  & 0.46408242E-11_JPRB, 0.51210121E-11_JPRB, 0.55301427E-11_JPRB, 0.57920270E-11_JPRB, 0.58434394E-11_JPRB, 0.56988711E-11_JPRB, &
  & 0.53728072E-11_JPRB, 0.49182368E-11_JPRB, 0.44271730E-11_JPRB, 0.39807953E-11_JPRB, 0.36093869E-11_JPRB, 0.33634085E-11_JPRB, &
  & 0.32047930E-11_JPRB, 0.31463445E-11_JPRB, 0.31511170E-11_JPRB, 0.32071633E-11_JPRB, 0.32902741E-11_JPRB, 0.33954721E-11_JPRB, &
  & 0.35182172E-11_JPRB, 0.36673728E-11_JPRB, 0.38660494E-11_JPRB, 0.40954848E-11_JPRB, 0.43206571E-11_JPRB, 0.44698681E-11_JPRB, &
  & 0.45466274E-11_JPRB, 0.45311493E-11_JPRB, 0.44854068E-11_JPRB, 0.43890265E-11_JPRB, 0.42296869E-11_JPRB, 0.40699154E-11_JPRB, &
  & 0.38270368E-11_JPRB, 0.35768467E-11_JPRB, 0.33911378E-11_JPRB, 0.32542658E-11_JPRB, 0.31653042E-11_JPRB, 0.31115921E-11_JPRB, &
  & 0.30874643E-11_JPRB, 0.30719084E-11_JPRB, 0.31690362E-11_JPRB, 0.31585910E-11_JPRB, 0.31708336E-11_JPRB, 0.47239127E-11_JPRB, &
  & 0.44886308E-11_JPRB, 0.43035870E-11_JPRB, 0.41585229E-11_JPRB, 0.38908633E-11_JPRB /)

RGHG4(:,61,10) = (/ &
  & 0.48449487E-11_JPRB, 0.44600426E-11_JPRB, 0.43299370E-11_JPRB, 0.41827826E-11_JPRB, 0.40904008E-11_JPRB, 0.40292392E-11_JPRB, &
  & 0.39965288E-11_JPRB, 0.39703518E-11_JPRB, 0.32268793E-11_JPRB, 0.32211842E-11_JPRB, 0.32204838E-11_JPRB, 0.32299950E-11_JPRB, &
  & 0.32559235E-11_JPRB, 0.33193743E-11_JPRB, 0.34358868E-11_JPRB, 0.36417644E-11_JPRB, 0.39427090E-11_JPRB, 0.43012044E-11_JPRB, &
  & 0.47439400E-11_JPRB, 0.52073198E-11_JPRB, 0.56057455E-11_JPRB, 0.58765792E-11_JPRB, 0.59473910E-11_JPRB, 0.58216891E-11_JPRB, &
  & 0.55223408E-11_JPRB, 0.51009717E-11_JPRB, 0.46452174E-11_JPRB, 0.42277007E-11_JPRB, 0.38957548E-11_JPRB, 0.36797670E-11_JPRB, &
  & 0.35525736E-11_JPRB, 0.35273180E-11_JPRB, 0.35608959E-11_JPRB, 0.36366199E-11_JPRB, 0.37295978E-11_JPRB, 0.38365092E-11_JPRB, &
  & 0.39590939E-11_JPRB, 0.41121186E-11_JPRB, 0.43139728E-11_JPRB, 0.45527276E-11_JPRB, 0.47931919E-11_JPRB, 0.49696384E-11_JPRB, &
  & 0.50725565E-11_JPRB, 0.50982395E-11_JPRB, 0.50857465E-11_JPRB, 0.50480882E-11_JPRB, 0.49600766E-11_JPRB, 0.48541531E-11_JPRB, &
  & 0.46399347E-11_JPRB, 0.43837451E-11_JPRB, 0.41736458E-11_JPRB, 0.40127467E-11_JPRB, 0.39031148E-11_JPRB, 0.38176077E-11_JPRB, &
  & 0.37766418E-11_JPRB, 0.37332815E-11_JPRB, 0.37999729E-11_JPRB, 0.37527099E-11_JPRB, 0.37097404E-11_JPRB, 0.52574503E-11_JPRB, &
  & 0.49663125E-11_JPRB, 0.47448534E-11_JPRB, 0.45679146E-11_JPRB, 0.42412137E-11_JPRB /)

RGHG4(:,62,10) = (/ &
  & 0.45761593E-11_JPRB, 0.42883570E-11_JPRB, 0.41632440E-11_JPRB, 0.40653739E-11_JPRB, 0.40136857E-11_JPRB, 0.39970726E-11_JPRB, &
  & 0.39990663E-11_JPRB, 0.39954207E-11_JPRB, 0.33345627E-11_JPRB, 0.33385033E-11_JPRB, 0.33464325E-11_JPRB, 0.33671811E-11_JPRB, &
  & 0.34095777E-11_JPRB, 0.34843712E-11_JPRB, 0.36231883E-11_JPRB, 0.38412151E-11_JPRB, 0.41388754E-11_JPRB, 0.44847914E-11_JPRB, &
  & 0.49073271E-11_JPRB, 0.53461814E-11_JPRB, 0.57300393E-11_JPRB, 0.59943110E-11_JPRB, 0.60771453E-11_JPRB, 0.59741574E-11_JPRB, &
  & 0.57034395E-11_JPRB, 0.53128977E-11_JPRB, 0.48932945E-11_JPRB, 0.45105369E-11_JPRB, 0.42245764E-11_JPRB, 0.40452025E-11_JPRB, &
  & 0.39654621E-11_JPRB, 0.39829433E-11_JPRB, 0.40503117E-11_JPRB, 0.41479879E-11_JPRB, 0.42512781E-11_JPRB, 0.43582694E-11_JPRB, &
  & 0.44775633E-11_JPRB, 0.46270175E-11_JPRB, 0.48299038E-11_JPRB, 0.50769671E-11_JPRB, 0.53324246E-11_JPRB, 0.55403481E-11_JPRB, &
  & 0.56747007E-11_JPRB, 0.57495024E-11_JPRB, 0.57967862E-11_JPRB, 0.58314365E-11_JPRB, 0.58201417E-11_JPRB, 0.57783574E-11_JPRB, &
  & 0.56376718E-11_JPRB, 0.54211102E-11_JPRB, 0.52381944E-11_JPRB, 0.50574007E-11_JPRB, 0.49261133E-11_JPRB, 0.48056841E-11_JPRB, &
  & 0.47238021E-11_JPRB, 0.46408459E-11_JPRB, 0.46580847E-11_JPRB, 0.45343395E-11_JPRB, 0.44013521E-11_JPRB, 0.59163061E-11_JPRB, &
  & 0.55168725E-11_JPRB, 0.52264759E-11_JPRB, 0.50003747E-11_JPRB, 0.46225979E-11_JPRB /)

RGHG4(:,63,10) = (/ &
  & 0.43804075E-11_JPRB, 0.41629053E-11_JPRB, 0.41057873E-11_JPRB, 0.40371712E-11_JPRB, 0.40248278E-11_JPRB, 0.40465708E-11_JPRB, &
  & 0.40841263E-11_JPRB, 0.41128346E-11_JPRB, 0.35266763E-11_JPRB, 0.35480408E-11_JPRB, 0.35732472E-11_JPRB, 0.36137048E-11_JPRB, &
  & 0.36722695E-11_JPRB, 0.37638837E-11_JPRB, 0.39132256E-11_JPRB, 0.41271400E-11_JPRB, 0.44062974E-11_JPRB, 0.47280435E-11_JPRB, &
  & 0.51208842E-11_JPRB, 0.55310955E-11_JPRB, 0.58941745E-11_JPRB, 0.61512575E-11_JPRB, 0.62419605E-11_JPRB, 0.61528664E-11_JPRB, &
  & 0.59066003E-11_JPRB, 0.55523672E-11_JPRB, 0.51760566E-11_JPRB, 0.48422243E-11_JPRB, 0.46113595E-11_JPRB, 0.44841487E-11_JPRB, &
  & 0.44635472E-11_JPRB, 0.45319725E-11_JPRB, 0.46407140E-11_JPRB, 0.47638577E-11_JPRB, 0.48778251E-11_JPRB, 0.49819975E-11_JPRB, &
  & 0.50956873E-11_JPRB, 0.52384611E-11_JPRB, 0.54325195E-11_JPRB, 0.56787704E-11_JPRB, 0.59489740E-11_JPRB, 0.61875921E-11_JPRB, &
  & 0.63577594E-11_JPRB, 0.64849280E-11_JPRB, 0.65942646E-11_JPRB, 0.67187293E-11_JPRB, 0.68096822E-11_JPRB, 0.68652163E-11_JPRB, &
  & 0.68324591E-11_JPRB, 0.67101186E-11_JPRB, 0.65834387E-11_JPRB, 0.64242205E-11_JPRB, 0.62825604E-11_JPRB, 0.61307357E-11_JPRB, &
  & 0.60075790E-11_JPRB, 0.58613557E-11_JPRB, 0.57990288E-11_JPRB, 0.55540629E-11_JPRB, 0.52553513E-11_JPRB, 0.66461511E-11_JPRB, &
  & 0.60836453E-11_JPRB, 0.57015534E-11_JPRB, 0.54203768E-11_JPRB, 0.50098007E-11_JPRB /)

RGHG4(:,64,10) = (/ &
  & 0.43087413E-11_JPRB, 0.41726184E-11_JPRB, 0.41344159E-11_JPRB, 0.41016249E-11_JPRB, 0.41242882E-11_JPRB, 0.41926432E-11_JPRB, &
  & 0.42802120E-11_JPRB, 0.43480545E-11_JPRB, 0.38245678E-11_JPRB, 0.38625995E-11_JPRB, 0.39019825E-11_JPRB, 0.39597015E-11_JPRB, &
  & 0.40328769E-11_JPRB, 0.41325775E-11_JPRB, 0.42797818E-11_JPRB, 0.44829492E-11_JPRB, 0.47336145E-11_JPRB, 0.50342282E-11_JPRB, &
  & 0.53951860E-11_JPRB, 0.57744430E-11_JPRB, 0.61134409E-11_JPRB, 0.63606061E-11_JPRB, 0.64509721E-11_JPRB, 0.63771020E-11_JPRB, &
  & 0.61610140E-11_JPRB, 0.58476791E-11_JPRB, 0.55215988E-11_JPRB, 0.52462765E-11_JPRB, 0.50783657E-11_JPRB, 0.50187020E-11_JPRB, &
  & 0.50667183E-11_JPRB, 0.51969713E-11_JPRB, 0.53544842E-11_JPRB, 0.55081330E-11_JPRB, 0.56338489E-11_JPRB, 0.57353280E-11_JPRB, &
  & 0.58381247E-11_JPRB, 0.59647205E-11_JPRB, 0.61483748E-11_JPRB, 0.63942996E-11_JPRB, 0.66720930E-11_JPRB, 0.69438622E-11_JPRB, &
  & 0.71557265E-11_JPRB, 0.73460873E-11_JPRB, 0.75286392E-11_JPRB, 0.77434812E-11_JPRB, 0.79365394E-11_JPRB, 0.80860284E-11_JPRB, &
  & 0.81582059E-11_JPRB, 0.81432916E-11_JPRB, 0.81292533E-11_JPRB, 0.80653305E-11_JPRB, 0.79733008E-11_JPRB, 0.78237035E-11_JPRB, &
  & 0.76682731E-11_JPRB, 0.74596267E-11_JPRB, 0.73075357E-11_JPRB, 0.68709882E-11_JPRB, 0.62991704E-11_JPRB, 0.74352642E-11_JPRB, &
  & 0.66103178E-11_JPRB, 0.61089753E-11_JPRB, 0.57633277E-11_JPRB, 0.53264667E-11_JPRB /)

RGHG4(:,65,10) = (/ &
  & 0.43165064E-11_JPRB, 0.42455119E-11_JPRB, 0.42536018E-11_JPRB, 0.42466638E-11_JPRB, 0.43019468E-11_JPRB, 0.44195459E-11_JPRB, &
  & 0.45586256E-11_JPRB, 0.46823352E-11_JPRB, 0.42123835E-11_JPRB, 0.42722124E-11_JPRB, 0.43281060E-11_JPRB, 0.44014558E-11_JPRB, &
  & 0.44840056E-11_JPRB, 0.45849973E-11_JPRB, 0.47253200E-11_JPRB, 0.49094470E-11_JPRB, 0.51343435E-11_JPRB, 0.54083227E-11_JPRB, &
  & 0.57354572E-11_JPRB, 0.60841449E-11_JPRB, 0.63997809E-11_JPRB, 0.66307142E-11_JPRB, 0.67250754E-11_JPRB, 0.66694168E-11_JPRB, &
  & 0.64824621E-11_JPRB, 0.62174046E-11_JPRB, 0.59523298E-11_JPRB, 0.57467512E-11_JPRB, 0.56532626E-11_JPRB, 0.56717868E-11_JPRB, &
  & 0.58019956E-11_JPRB, 0.60006015E-11_JPRB, 0.62114151E-11_JPRB, 0.63986615E-11_JPRB, 0.65397631E-11_JPRB, 0.66426292E-11_JPRB, &
  & 0.67356190E-11_JPRB, 0.68495322E-11_JPRB, 0.70091038E-11_JPRB, 0.72407401E-11_JPRB, 0.75247629E-11_JPRB, 0.78200562E-11_JPRB, &
  & 0.80715538E-11_JPRB, 0.83266258E-11_JPRB, 0.85899265E-11_JPRB, 0.89100914E-11_JPRB, 0.92154210E-11_JPRB, 0.94899774E-11_JPRB, &
  & 0.96976602E-11_JPRB, 0.98133168E-11_JPRB, 0.99098837E-11_JPRB, 0.99517825E-11_JPRB, 0.99475367E-11_JPRB, 0.98465507E-11_JPRB, &
  & 0.97032729E-11_JPRB, 0.95022792E-11_JPRB, 0.92266481E-11_JPRB, 0.85565053E-11_JPRB, 0.75653997E-11_JPRB, 0.82119467E-11_JPRB, &
  & 0.70154074E-11_JPRB, 0.63949349E-11_JPRB, 0.60002116E-11_JPRB, 0.55560600E-11_JPRB /)

RGHG4(:,66,10) = (/ &
  & 0.44083383E-11_JPRB, 0.44161025E-11_JPRB, 0.44551723E-11_JPRB, 0.44784059E-11_JPRB, 0.45680755E-11_JPRB, 0.47387927E-11_JPRB, &
  & 0.49497299E-11_JPRB, 0.51290413E-11_JPRB, 0.47053763E-11_JPRB, 0.47712702E-11_JPRB, 0.48358453E-11_JPRB, 0.49141025E-11_JPRB, &
  & 0.49988225E-11_JPRB, 0.51044355E-11_JPRB, 0.52379902E-11_JPRB, 0.54064704E-11_JPRB, 0.56123348E-11_JPRB, 0.58622326E-11_JPRB, &
  & 0.61602663E-11_JPRB, 0.64795608E-11_JPRB, 0.67695931E-11_JPRB, 0.69931968E-11_JPRB, 0.70906501E-11_JPRB, 0.70548112E-11_JPRB, &
  & 0.69069589E-11_JPRB, 0.66980596E-11_JPRB, 0.65013342E-11_JPRB, 0.63744348E-11_JPRB, 0.63610996E-11_JPRB, 0.64676736E-11_JPRB, &
  & 0.66792249E-11_JPRB, 0.69532019E-11_JPRB, 0.72243045E-11_JPRB, 0.74503268E-11_JPRB, 0.76121262E-11_JPRB, 0.77196695E-11_JPRB, &
  & 0.78042755E-11_JPRB, 0.78990460E-11_JPRB, 0.80466744E-11_JPRB, 0.82681422E-11_JPRB, 0.85490365E-11_JPRB, 0.88677485E-11_JPRB, &
  & 0.91624564E-11_JPRB, 0.94846943E-11_JPRB, 0.98237295E-11_JPRB, 0.10248124E-10_JPRB, 0.10668833E-10_JPRB, 0.11056287E-10_JPRB, &
  & 0.11378826E-10_JPRB, 0.11608807E-10_JPRB, 0.11830193E-10_JPRB, 0.12023682E-10_JPRB, 0.12149393E-10_JPRB, 0.12154344E-10_JPRB, &
  & 0.12054520E-10_JPRB, 0.11890887E-10_JPRB, 0.11600928E-10_JPRB, 0.10686273E-10_JPRB, 0.91229030E-11_JPRB, 0.89633379E-11_JPRB, &
  & 0.72581242E-11_JPRB, 0.65806241E-11_JPRB, 0.61666527E-11_JPRB, 0.57325694E-11_JPRB /)

RGHG4(:,67,10) = (/ &
  & 0.45749784E-11_JPRB, 0.46615901E-11_JPRB, 0.47454866E-11_JPRB, 0.47973158E-11_JPRB, 0.49219209E-11_JPRB, 0.51540282E-11_JPRB, &
  & 0.54272190E-11_JPRB, 0.56877797E-11_JPRB, 0.52784456E-11_JPRB, 0.53539213E-11_JPRB, 0.54181976E-11_JPRB, 0.55099762E-11_JPRB, &
  & 0.56032692E-11_JPRB, 0.57106759E-11_JPRB, 0.58453182E-11_JPRB, 0.59977197E-11_JPRB, 0.61873445E-11_JPRB, 0.64144870E-11_JPRB, &
  & 0.66874158E-11_JPRB, 0.69823201E-11_JPRB, 0.72560686E-11_JPRB, 0.74723517E-11_JPRB, 0.75804371E-11_JPRB, 0.75711087E-11_JPRB, &
  & 0.74661336E-11_JPRB, 0.73189952E-11_JPRB, 0.71967423E-11_JPRB, 0.71543878E-11_JPRB, 0.72270189E-11_JPRB, 0.74263252E-11_JPRB, &
  & 0.77278054E-11_JPRB, 0.80780738E-11_JPRB, 0.84104650E-11_JPRB, 0.86797496E-11_JPRB, 0.88686176E-11_JPRB, 0.89904828E-11_JPRB, &
  & 0.90781471E-11_JPRB, 0.91686840E-11_JPRB, 0.92933647E-11_JPRB, 0.94943359E-11_JPRB, 0.97795721E-11_JPRB, 0.10119934E-10_JPRB, &
  & 0.10454371E-10_JPRB, 0.10841459E-10_JPRB, 0.11266683E-10_JPRB, 0.11793903E-10_JPRB, 0.12327798E-10_JPRB, 0.12846986E-10_JPRB, &
  & 0.13315913E-10_JPRB, 0.13693334E-10_JPRB, 0.14044791E-10_JPRB, 0.14357829E-10_JPRB, 0.14588303E-10_JPRB, 0.14715066E-10_JPRB, &
  & 0.14690034E-10_JPRB, 0.14615222E-10_JPRB, 0.14345066E-10_JPRB, 0.13234571E-10_JPRB, 0.11047081E-10_JPRB, 0.96962993E-11_JPRB, &
  & 0.73825095E-11_JPRB, 0.67933992E-11_JPRB, 0.64168748E-11_JPRB, 0.59531286E-11_JPRB /)

RGHG4(:,68,10) = (/ &
  & 0.48088668E-11_JPRB, 0.49948240E-11_JPRB, 0.51271895E-11_JPRB, 0.52123869E-11_JPRB, 0.53747978E-11_JPRB, 0.56724981E-11_JPRB, &
  & 0.60269129E-11_JPRB, 0.63457763E-11_JPRB, 0.59446402E-11_JPRB, 0.60090453E-11_JPRB, 0.60800453E-11_JPRB, 0.61702028E-11_JPRB, &
  & 0.62829143E-11_JPRB, 0.63951179E-11_JPRB, 0.65367677E-11_JPRB, 0.66878777E-11_JPRB, 0.68684329E-11_JPRB, 0.70857573E-11_JPRB, &
  & 0.73410427E-11_JPRB, 0.76184857E-11_JPRB, 0.78807343E-11_JPRB, 0.80998151E-11_JPRB, 0.82238365E-11_JPRB, 0.82464530E-11_JPRB, &
  & 0.81931241E-11_JPRB, 0.81134292E-11_JPRB, 0.80696561E-11_JPRB, 0.81140069E-11_JPRB, 0.82765799E-11_JPRB, 0.85695583E-11_JPRB, &
  & 0.89558777E-11_JPRB, 0.93897745E-11_JPRB, 0.97906804E-11_JPRB, 0.10110067E-10_JPRB, 0.10335692E-10_JPRB, 0.10480597E-10_JPRB, &
  & 0.10576143E-10_JPRB, 0.10654965E-10_JPRB, 0.10784909E-10_JPRB, 0.10982751E-10_JPRB, 0.11267365E-10_JPRB, 0.11624736E-10_JPRB, &
  & 0.12001526E-10_JPRB, 0.12448720E-10_JPRB, 0.12956186E-10_JPRB, 0.13579699E-10_JPRB, 0.14231533E-10_JPRB, 0.14870593E-10_JPRB, &
  & 0.15439518E-10_JPRB, 0.15930717E-10_JPRB, 0.16404432E-10_JPRB, 0.16871494E-10_JPRB, 0.17257423E-10_JPRB, 0.17522027E-10_JPRB, &
  & 0.17598143E-10_JPRB, 0.17635161E-10_JPRB, 0.17453011E-10_JPRB, 0.16204231E-10_JPRB, 0.13339418E-10_JPRB, 0.10570112E-10_JPRB, &
  & 0.75641368E-11_JPRB, 0.72671235E-11_JPRB, 0.69432979E-11_JPRB, 0.63671017E-11_JPRB /)

RGHG4(:,69,10) = (/ &
  & 0.51143933E-11_JPRB, 0.54178988E-11_JPRB, 0.56130764E-11_JPRB, 0.57312531E-11_JPRB, 0.59325925E-11_JPRB, 0.62979014E-11_JPRB, &
  & 0.67301321E-11_JPRB, 0.71022901E-11_JPRB, 0.66945329E-11_JPRB, 0.67524467E-11_JPRB, 0.68414423E-11_JPRB, 0.69428968E-11_JPRB, &
  & 0.70808012E-11_JPRB, 0.72090684E-11_JPRB, 0.73551712E-11_JPRB, 0.75083941E-11_JPRB, 0.76898141E-11_JPRB, 0.78956876E-11_JPRB, &
  & 0.81447384E-11_JPRB, 0.84155148E-11_JPRB, 0.86769914E-11_JPRB, 0.89061909E-11_JPRB, 0.90539486E-11_JPRB, 0.91166866E-11_JPRB, &
  & 0.91196425E-11_JPRB, 0.91107009E-11_JPRB, 0.91482238E-11_JPRB, 0.92809970E-11_JPRB, 0.95399600E-11_JPRB, 0.99271728E-11_JPRB, &
  & 0.10416742E-10_JPRB, 0.10932712E-10_JPRB, 0.11399645E-10_JPRB, 0.11774258E-10_JPRB, 0.12043914E-10_JPRB, 0.12225151E-10_JPRB, &
  & 0.12347003E-10_JPRB, 0.12438123E-10_JPRB, 0.12552417E-10_JPRB, 0.12737886E-10_JPRB, 0.13036992E-10_JPRB, 0.13425909E-10_JPRB, &
  & 0.13846144E-10_JPRB, 0.14359588E-10_JPRB, 0.14953674E-10_JPRB, 0.15670373E-10_JPRB, 0.16430942E-10_JPRB, 0.17189163E-10_JPRB, &
  & 0.17905897E-10_JPRB, 0.18548104E-10_JPRB, 0.19159882E-10_JPRB, 0.19750016E-10_JPRB, 0.20230225E-10_JPRB, 0.20614618E-10_JPRB, &
  & 0.20795164E-10_JPRB, 0.20976380E-10_JPRB, 0.20851992E-10_JPRB, 0.19556518E-10_JPRB, 0.16107064E-10_JPRB, 0.11605018E-10_JPRB, &
  & 0.81513242E-11_JPRB, 0.82024916E-11_JPRB, 0.79253036E-11_JPRB, 0.71013065E-11_JPRB /)

RGHG4(:,70,10) = (/ &
  & 0.54987139E-11_JPRB, 0.59472379E-11_JPRB, 0.62159631E-11_JPRB, 0.63674170E-11_JPRB, 0.66040290E-11_JPRB, 0.70420280E-11_JPRB, &
  & 0.75365495E-11_JPRB, 0.79689328E-11_JPRB, 0.75490950E-11_JPRB, 0.75985173E-11_JPRB, 0.77071361E-11_JPRB, 0.78212341E-11_JPRB, &
  & 0.79749037E-11_JPRB, 0.81305102E-11_JPRB, 0.83028029E-11_JPRB, 0.84580138E-11_JPRB, 0.86655457E-11_JPRB, 0.88730811E-11_JPRB, &
  & 0.91267644E-11_JPRB, 0.93978601E-11_JPRB, 0.96690607E-11_JPRB, 0.99186336E-11_JPRB, 0.10098431E-10_JPRB, 0.10209265E-10_JPRB, &
  & 0.10277183E-10_JPRB, 0.10344476E-10_JPRB, 0.10465998E-10_JPRB, 0.10689662E-10_JPRB, 0.11045111E-10_JPRB, 0.11531630E-10_JPRB, &
  & 0.12103620E-10_JPRB, 0.12709162E-10_JPRB, 0.13256335E-10_JPRB, 0.13695939E-10_JPRB, 0.14017091E-10_JPRB, 0.14237275E-10_JPRB, &
  & 0.14385952E-10_JPRB, 0.14484513E-10_JPRB, 0.14632021E-10_JPRB, 0.14840580E-10_JPRB, 0.15152792E-10_JPRB, 0.15568295E-10_JPRB, &
  & 0.16038622E-10_JPRB, 0.16620592E-10_JPRB, 0.17300239E-10_JPRB, 0.18111582E-10_JPRB, 0.18982378E-10_JPRB, 0.19850928E-10_JPRB, &
  & 0.20668517E-10_JPRB, 0.21406736E-10_JPRB, 0.22119610E-10_JPRB, 0.22841272E-10_JPRB, 0.23478327E-10_JPRB, 0.24017795E-10_JPRB, &
  & 0.24318188E-10_JPRB, 0.24591508E-10_JPRB, 0.24602891E-10_JPRB, 0.23202298E-10_JPRB, 0.19383503E-10_JPRB, 0.13239957E-10_JPRB, &
  & 0.94388265E-11_JPRB, 0.97693693E-11_JPRB, 0.94945119E-11_JPRB, 0.82337678E-11_JPRB /)

RGHG4(:,71,10) = (/ &
  & 0.59786364E-11_JPRB, 0.66030866E-11_JPRB, 0.69534261E-11_JPRB, 0.71333065E-11_JPRB, 0.74095235E-11_JPRB, 0.79080284E-11_JPRB, &
  & 0.84740426E-11_JPRB, 0.89438379E-11_JPRB, 0.85100633E-11_JPRB, 0.85851022E-11_JPRB, 0.87144588E-11_JPRB, 0.88712327E-11_JPRB, &
  & 0.90500879E-11_JPRB, 0.92274643E-11_JPRB, 0.94305475E-11_JPRB, 0.95976517E-11_JPRB, 0.98207605E-11_JPRB, 0.10042164E-10_JPRB, &
  & 0.10305646E-10_JPRB, 0.10593621E-10_JPRB, 0.10883528E-10_JPRB, 0.11165050E-10_JPRB, 0.11387976E-10_JPRB, 0.11557839E-10_JPRB, &
  & 0.11698960E-10_JPRB, 0.11849149E-10_JPRB, 0.12059968E-10_JPRB, 0.12379263E-10_JPRB, 0.12834075E-10_JPRB, 0.13424411E-10_JPRB, &
  & 0.14116173E-10_JPRB, 0.14809624E-10_JPRB, 0.15430700E-10_JPRB, 0.15939640E-10_JPRB, 0.16324256E-10_JPRB, 0.16603999E-10_JPRB, &
  & 0.16804762E-10_JPRB, 0.16944451E-10_JPRB, 0.17080965E-10_JPRB, 0.17285583E-10_JPRB, 0.17631585E-10_JPRB, 0.18096871E-10_JPRB, &
  & 0.18628323E-10_JPRB, 0.19285467E-10_JPRB, 0.20050288E-10_JPRB, 0.20965287E-10_JPRB, 0.21944783E-10_JPRB, 0.22911005E-10_JPRB, &
  & 0.23855608E-10_JPRB, 0.24734916E-10_JPRB, 0.25580291E-10_JPRB, 0.26428743E-10_JPRB, 0.27152964E-10_JPRB, 0.27780835E-10_JPRB, &
  & 0.28200770E-10_JPRB, 0.28614259E-10_JPRB, 0.28755508E-10_JPRB, 0.27170353E-10_JPRB, 0.23157599E-10_JPRB, 0.15883508E-10_JPRB, &
  & 0.11697143E-10_JPRB, 0.12161677E-10_JPRB, 0.11858974E-10_JPRB, 0.99696024E-11_JPRB /)

RGHG4(:,72,10) = (/ &
  & 0.65864514E-11_JPRB, 0.74143035E-11_JPRB, 0.78369975E-11_JPRB, 0.80476372E-11_JPRB, 0.83531081E-11_JPRB, 0.89127655E-11_JPRB, &
  & 0.95289471E-11_JPRB, 0.10051177E-10_JPRB, 0.96024369E-11_JPRB, 0.97267628E-11_JPRB, 0.98679034E-11_JPRB, 0.10052605E-10_JPRB, &
  & 0.10269063E-10_JPRB, 0.10490500E-10_JPRB, 0.10716727E-10_JPRB, 0.10934633E-10_JPRB, 0.11177445E-10_JPRB, 0.11434320E-10_JPRB, &
  & 0.11717875E-10_JPRB, 0.12029568E-10_JPRB, 0.12350537E-10_JPRB, 0.12675218E-10_JPRB, 0.12955653E-10_JPRB, 0.13196444E-10_JPRB, &
  & 0.13422478E-10_JPRB, 0.13664495E-10_JPRB, 0.13972455E-10_JPRB, 0.14391404E-10_JPRB, 0.14953438E-10_JPRB, 0.15647220E-10_JPRB, &
  & 0.16413810E-10_JPRB, 0.17206531E-10_JPRB, 0.17926079E-10_JPRB, 0.18522853E-10_JPRB, 0.18985124E-10_JPRB, 0.19329203E-10_JPRB, &
  & 0.19570212E-10_JPRB, 0.19737946E-10_JPRB, 0.19937519E-10_JPRB, 0.20202867E-10_JPRB, 0.20568006E-10_JPRB, 0.21073714E-10_JPRB, &
  & 0.21664098E-10_JPRB, 0.22400932E-10_JPRB, 0.23261542E-10_JPRB, 0.24268015E-10_JPRB, 0.25347113E-10_JPRB, 0.26418459E-10_JPRB, &
  & 0.27455149E-10_JPRB, 0.28404489E-10_JPRB, 0.29332922E-10_JPRB, 0.30282363E-10_JPRB, 0.31134768E-10_JPRB, 0.31902578E-10_JPRB, &
  & 0.32469121E-10_JPRB, 0.32999707E-10_JPRB, 0.33241025E-10_JPRB, 0.31583736E-10_JPRB, 0.27533732E-10_JPRB, 0.19659172E-10_JPRB, &
  & 0.15257635E-10_JPRB, 0.15679820E-10_JPRB, 0.15282664E-10_JPRB, 0.12604433E-10_JPRB /)

RGHG4(:,73,10) = (/ &
  & 0.73702554E-11_JPRB, 0.83940285E-11_JPRB, 0.88827392E-11_JPRB, 0.91061447E-11_JPRB, 0.94483414E-11_JPRB, 0.10052093E-10_JPRB, &
  & 0.10723843E-10_JPRB, 0.11262643E-10_JPRB, 0.10843490E-10_JPRB, 0.11009754E-10_JPRB, 0.11221984E-10_JPRB, 0.11450290E-10_JPRB, &
  & 0.11702491E-10_JPRB, 0.11978755E-10_JPRB, 0.12229786E-10_JPRB, 0.12486642E-10_JPRB, 0.12755266E-10_JPRB, 0.13043243E-10_JPRB, &
  & 0.13362910E-10_JPRB, 0.13714888E-10_JPRB, 0.14080379E-10_JPRB, 0.14464530E-10_JPRB, 0.14817170E-10_JPRB, 0.15146233E-10_JPRB, &
  & 0.15469523E-10_JPRB, 0.15818218E-10_JPRB, 0.16235369E-10_JPRB, 0.16763139E-10_JPRB, 0.17440849E-10_JPRB, 0.18245837E-10_JPRB, &
  & 0.19158673E-10_JPRB, 0.20054786E-10_JPRB, 0.20860504E-10_JPRB, 0.21547429E-10_JPRB, 0.22101314E-10_JPRB, 0.22541299E-10_JPRB, &
  & 0.22865683E-10_JPRB, 0.23098259E-10_JPRB, 0.23292448E-10_JPRB, 0.23536348E-10_JPRB, 0.23956009E-10_JPRB, 0.24523668E-10_JPRB, &
  & 0.25180439E-10_JPRB, 0.25996474E-10_JPRB, 0.26942119E-10_JPRB, 0.28033612E-10_JPRB, 0.29212487E-10_JPRB, 0.30362615E-10_JPRB, &
  & 0.31495213E-10_JPRB, 0.32556645E-10_JPRB, 0.33623909E-10_JPRB, 0.34661184E-10_JPRB, 0.35591637E-10_JPRB, 0.36421852E-10_JPRB, &
  & 0.37064667E-10_JPRB, 0.37691204E-10_JPRB, 0.38041070E-10_JPRB, 0.36434477E-10_JPRB, 0.32222072E-10_JPRB, 0.25139328E-10_JPRB, &
  & 0.20292344E-10_JPRB, 0.20557689E-10_JPRB, 0.20022744E-10_JPRB, 0.16446089E-10_JPRB /)

RGHG4(:,74,10) = (/ &
  & 0.83656857E-11_JPRB, 0.95554138E-11_JPRB, 0.10082885E-10_JPRB, 0.10327524E-10_JPRB, 0.10695105E-10_JPRB, 0.11341180E-10_JPRB, &
  & 0.12048412E-10_JPRB, 0.12642130E-10_JPRB, 0.12220399E-10_JPRB, 0.12469650E-10_JPRB, 0.12697540E-10_JPRB, 0.12995064E-10_JPRB, &
  & 0.13298588E-10_JPRB, 0.13623176E-10_JPRB, 0.13940002E-10_JPRB, 0.14256615E-10_JPRB, 0.14576030E-10_JPRB, 0.14911685E-10_JPRB, &
  & 0.15281791E-10_JPRB, 0.15683517E-10_JPRB, 0.16110700E-10_JPRB, 0.16570143E-10_JPRB, 0.17012879E-10_JPRB, 0.17446990E-10_JPRB, &
  & 0.17884630E-10_JPRB, 0.18354587E-10_JPRB, 0.18895366E-10_JPRB, 0.19541240E-10_JPRB, 0.20345168E-10_JPRB, 0.21250788E-10_JPRB, &
  & 0.22223808E-10_JPRB, 0.23223623E-10_JPRB, 0.24153159E-10_JPRB, 0.24961058E-10_JPRB, 0.25624784E-10_JPRB, 0.26156100E-10_JPRB, &
  & 0.26540594E-10_JPRB, 0.26826142E-10_JPRB, 0.27128150E-10_JPRB, 0.27484156E-10_JPRB, 0.27925121E-10_JPRB, 0.28532605E-10_JPRB, &
  & 0.29243465E-10_JPRB, 0.30122734E-10_JPRB, 0.31148178E-10_JPRB, 0.32317760E-10_JPRB, 0.33560991E-10_JPRB, 0.34791409E-10_JPRB, &
  & 0.35987987E-10_JPRB, 0.37099799E-10_JPRB, 0.38200713E-10_JPRB, 0.39294915E-10_JPRB, 0.40341560E-10_JPRB, 0.41242332E-10_JPRB, &
  & 0.42027552E-10_JPRB, 0.42685574E-10_JPRB, 0.43154879E-10_JPRB, 0.41591956E-10_JPRB, 0.37933601E-10_JPRB, 0.31602148E-10_JPRB, &
  & 0.26967388E-10_JPRB, 0.26992603E-10_JPRB, 0.26241105E-10_JPRB, 0.21697788E-10_JPRB /)

RGHG4(:,75,10) = (/ &
  & 0.95633805E-11_JPRB, 0.10906723E-10_JPRB, 0.11461034E-10_JPRB, 0.11711845E-10_JPRB, 0.12101844E-10_JPRB, 0.12778875E-10_JPRB, &
  & 0.13535904E-10_JPRB, 0.14157688E-10_JPRB, 0.13800327E-10_JPRB, 0.14097726E-10_JPRB, 0.14446742E-10_JPRB, 0.14779945E-10_JPRB, &
  & 0.15175703E-10_JPRB, 0.15547797E-10_JPRB, 0.15919472E-10_JPRB, 0.16281110E-10_JPRB, 0.16660166E-10_JPRB, 0.17052195E-10_JPRB, &
  & 0.17483789E-10_JPRB, 0.17956961E-10_JPRB, 0.18466065E-10_JPRB, 0.19018535E-10_JPRB, 0.19575652E-10_JPRB, 0.20135222E-10_JPRB, &
  & 0.20704034E-10_JPRB, 0.21316782E-10_JPRB, 0.21994937E-10_JPRB, 0.22775311E-10_JPRB, 0.23704585E-10_JPRB, 0.24744234E-10_JPRB, &
  & 0.25903843E-10_JPRB, 0.27044559E-10_JPRB, 0.28088264E-10_JPRB, 0.29018206E-10_JPRB, 0.29815424E-10_JPRB, 0.30479747E-10_JPRB, &
  & 0.30985364E-10_JPRB, 0.31349000E-10_JPRB, 0.31631774E-10_JPRB, 0.31914214E-10_JPRB, 0.32445772E-10_JPRB, 0.33119948E-10_JPRB, &
  & 0.33890515E-10_JPRB, 0.34839888E-10_JPRB, 0.35924586E-10_JPRB, 0.37149551E-10_JPRB, 0.38452928E-10_JPRB, 0.39714121E-10_JPRB, &
  & 0.40959881E-10_JPRB, 0.42130001E-10_JPRB, 0.43326544E-10_JPRB, 0.44503502E-10_JPRB, 0.45570100E-10_JPRB, 0.46505348E-10_JPRB, &
  & 0.47284263E-10_JPRB, 0.48029910E-10_JPRB, 0.48582235E-10_JPRB, 0.47400684E-10_JPRB, 0.43777499E-10_JPRB, 0.39713486E-10_JPRB, &
  & 0.35126846E-10_JPRB, 0.35038542E-10_JPRB, 0.34030848E-10_JPRB, 0.28448650E-10_JPRB /)

RGHG4(:,76,10) = (/ &
  & 0.10969503E-10_JPRB, 0.12430338E-10_JPRB, 0.13019261E-10_JPRB, 0.13272199E-10_JPRB, 0.13662910E-10_JPRB, 0.14375719E-10_JPRB, &
  & 0.15168368E-10_JPRB, 0.15873669E-10_JPRB, 0.15505642E-10_JPRB, 0.15907995E-10_JPRB, 0.16265923E-10_JPRB, 0.16697340E-10_JPRB, &
  & 0.17143804E-10_JPRB, 0.17602570E-10_JPRB, 0.18062819E-10_JPRB, 0.18526172E-10_JPRB, 0.18985912E-10_JPRB, 0.19466059E-10_JPRB, &
  & 0.19981452E-10_JPRB, 0.20547434E-10_JPRB, 0.21155171E-10_JPRB, 0.21828171E-10_JPRB, 0.22516612E-10_JPRB, 0.23224037E-10_JPRB, &
  & 0.23945202E-10_JPRB, 0.24720725E-10_JPRB, 0.25548780E-10_JPRB, 0.26485775E-10_JPRB, 0.27534515E-10_JPRB, 0.28672991E-10_JPRB, &
  & 0.29845466E-10_JPRB, 0.31068453E-10_JPRB, 0.32243260E-10_JPRB, 0.33315670E-10_JPRB, 0.34260702E-10_JPRB, 0.35054900E-10_JPRB, &
  & 0.35677260E-10_JPRB, 0.36154819E-10_JPRB, 0.36603106E-10_JPRB, 0.37107574E-10_JPRB, 0.37648877E-10_JPRB, 0.38347110E-10_JPRB, &
  & 0.39159100E-10_JPRB, 0.40145942E-10_JPRB, 0.41267597E-10_JPRB, 0.42524290E-10_JPRB, 0.43846250E-10_JPRB, 0.45125820E-10_JPRB, &
  & 0.46381152E-10_JPRB, 0.47556650E-10_JPRB, 0.48728858E-10_JPRB, 0.49911561E-10_JPRB, 0.51037143E-10_JPRB, 0.51992913E-10_JPRB, &
  & 0.52869629E-10_JPRB, 0.53635419E-10_JPRB, 0.54325121E-10_JPRB, 0.53392034E-10_JPRB, 0.50889879E-10_JPRB, 0.48690347E-10_JPRB, &
  & 0.44777147E-10_JPRB, 0.44691664E-10_JPRB, 0.43405148E-10_JPRB, 0.36734272E-10_JPRB /)

RGHG4(:,77,10) = (/ &
  & 0.12589566E-10_JPRB, 0.14156635E-10_JPRB, 0.14765663E-10_JPRB, 0.15005415E-10_JPRB, 0.15383370E-10_JPRB, 0.16101747E-10_JPRB, &
  & 0.16936204E-10_JPRB, 0.17679061E-10_JPRB, 0.17385000E-10_JPRB, 0.17842250E-10_JPRB, 0.18342966E-10_JPRB, 0.18813104E-10_JPRB, &
  & 0.19347543E-10_JPRB, 0.19876477E-10_JPRB, 0.20407028E-10_JPRB, 0.20949279E-10_JPRB, 0.21510831E-10_JPRB, 0.22095563E-10_JPRB, &
  & 0.22722177E-10_JPRB, 0.23408230E-10_JPRB, 0.24154281E-10_JPRB, 0.24964123E-10_JPRB, 0.25809766E-10_JPRB, 0.26676850E-10_JPRB, &
  & 0.27572241E-10_JPRB, 0.28516538E-10_JPRB, 0.29498324E-10_JPRB, 0.30609144E-10_JPRB, 0.31765788E-10_JPRB, 0.33078672E-10_JPRB, &
  & 0.34490227E-10_JPRB, 0.35907385E-10_JPRB, 0.37255178E-10_JPRB, 0.38501743E-10_JPRB, 0.39626875E-10_JPRB, 0.40580612E-10_JPRB, &
  & 0.41324100E-10_JPRB, 0.41848486E-10_JPRB, 0.42260445E-10_JPRB, 0.42665739E-10_JPRB, 0.43294982E-10_JPRB, 0.44077561E-10_JPRB, &
  & 0.44930729E-10_JPRB, 0.45947100E-10_JPRB, 0.47069453E-10_JPRB, 0.48320185E-10_JPRB, 0.49628357E-10_JPRB, 0.50874676E-10_JPRB, &
  & 0.52101001E-10_JPRB, 0.53267012E-10_JPRB, 0.54452592E-10_JPRB, 0.55655761E-10_JPRB, 0.56778166E-10_JPRB, 0.57716606E-10_JPRB, &
  & 0.58560379E-10_JPRB, 0.59374568E-10_JPRB, 0.60173609E-10_JPRB, 0.59825679E-10_JPRB, 0.58031396E-10_JPRB, 0.58624640E-10_JPRB, &
  & 0.55853797E-10_JPRB, 0.55768942E-10_JPRB, 0.54150958E-10_JPRB, 0.46588712E-10_JPRB /)

RGHG4(:,78,10) = (/ &
  & 0.14408548E-10_JPRB, 0.16008953E-10_JPRB, 0.16599163E-10_JPRB, 0.16806246E-10_JPRB, 0.17137776E-10_JPRB, 0.17834229E-10_JPRB, &
  & 0.18666532E-10_JPRB, 0.19460260E-10_JPRB, 0.19159894E-10_JPRB, 0.19692893E-10_JPRB, 0.20184217E-10_JPRB, 0.20743749E-10_JPRB, &
  & 0.21319840E-10_JPRB, 0.21942871E-10_JPRB, 0.22597216E-10_JPRB, 0.23278903E-10_JPRB, 0.23967488E-10_JPRB, 0.24700410E-10_JPRB, &
  & 0.25470362E-10_JPRB, 0.26314503E-10_JPRB, 0.27212550E-10_JPRB, 0.28188681E-10_JPRB, 0.29196430E-10_JPRB, 0.30229114E-10_JPRB, &
  & 0.31304456E-10_JPRB, 0.32395024E-10_JPRB, 0.33537676E-10_JPRB, 0.34787589E-10_JPRB, 0.36057810E-10_JPRB, 0.37393488E-10_JPRB, &
  & 0.38725294E-10_JPRB, 0.40085910E-10_JPRB, 0.41440955E-10_JPRB, 0.42737813E-10_JPRB, 0.43977162E-10_JPRB, 0.45118888E-10_JPRB, &
  & 0.46116520E-10_JPRB, 0.46946527E-10_JPRB, 0.47675280E-10_JPRB, 0.48404926E-10_JPRB, 0.49103117E-10_JPRB, 0.49902207E-10_JPRB, &
  & 0.50753617E-10_JPRB, 0.51750090E-10_JPRB, 0.52817438E-10_JPRB, 0.53998871E-10_JPRB, 0.55244830E-10_JPRB, 0.56408545E-10_JPRB, &
  & 0.57578779E-10_JPRB, 0.58675849E-10_JPRB, 0.59786731E-10_JPRB, 0.60943049E-10_JPRB, 0.62051822E-10_JPRB, 0.62987289E-10_JPRB, &
  & 0.63856469E-10_JPRB, 0.64693209E-10_JPRB, 0.65614805E-10_JPRB, 0.65649847E-10_JPRB, 0.65155409E-10_JPRB, 0.69108642E-10_JPRB, &
  & 0.67098826E-10_JPRB, 0.67147427E-10_JPRB, 0.65539942E-10_JPRB, 0.57796958E-10_JPRB /)

RGHG4(:,79,10) = (/ &
  & 0.16380182E-10_JPRB, 0.17608477E-10_JPRB, 0.18003991E-10_JPRB, 0.18108784E-10_JPRB, 0.18357234E-10_JPRB, 0.18969305E-10_JPRB, &
  & 0.19739113E-10_JPRB, 0.20503505E-10_JPRB, 0.20226064E-10_JPRB, 0.20769044E-10_JPRB, 0.21309017E-10_JPRB, 0.21875500E-10_JPRB, &
  & 0.22497166E-10_JPRB, 0.23173333E-10_JPRB, 0.23883728E-10_JPRB, 0.24662545E-10_JPRB, 0.25494055E-10_JPRB, 0.26389946E-10_JPRB, &
  & 0.27324984E-10_JPRB, 0.28315539E-10_JPRB, 0.29356396E-10_JPRB, 0.30451950E-10_JPRB, 0.31558877E-10_JPRB, 0.32678867E-10_JPRB, &
  & 0.33826063E-10_JPRB, 0.34922228E-10_JPRB, 0.36117449E-10_JPRB, 0.37278659E-10_JPRB, 0.38507187E-10_JPRB, 0.39757489E-10_JPRB, &
  & 0.41151287E-10_JPRB, 0.42488221E-10_JPRB, 0.43819288E-10_JPRB, 0.45135479E-10_JPRB, 0.46429617E-10_JPRB, 0.47673365E-10_JPRB, &
  & 0.48828077E-10_JPRB, 0.49849312E-10_JPRB, 0.50796374E-10_JPRB, 0.51710830E-10_JPRB, 0.52698321E-10_JPRB, 0.53708146E-10_JPRB, &
  & 0.54618716E-10_JPRB, 0.55593006E-10_JPRB, 0.56567459E-10_JPRB, 0.57645180E-10_JPRB, 0.58750400E-10_JPRB, 0.59791248E-10_JPRB, &
  & 0.60818239E-10_JPRB, 0.61805151E-10_JPRB, 0.62842113E-10_JPRB, 0.63954654E-10_JPRB, 0.65016624E-10_JPRB, 0.65946193E-10_JPRB, &
  & 0.66830756E-10_JPRB, 0.67739647E-10_JPRB, 0.68791452E-10_JPRB, 0.69156673E-10_JPRB, 0.69441654E-10_JPRB, 0.75391630E-10_JPRB, &
  & 0.74745050E-10_JPRB, 0.75107635E-10_JPRB, 0.74346619E-10_JPRB, 0.69398293E-10_JPRB /)

RGHG4(:,80,10) = (/ &
  & 0.17573984E-10_JPRB, 0.18260806E-10_JPRB, 0.18534603E-10_JPRB, 0.18589248E-10_JPRB, 0.18801911E-10_JPRB, 0.19417714E-10_JPRB, &
  & 0.20223052E-10_JPRB, 0.21029100E-10_JPRB, 0.20844718E-10_JPRB, 0.21383192E-10_JPRB, 0.21930733E-10_JPRB, 0.22524255E-10_JPRB, &
  & 0.23172712E-10_JPRB, 0.23876585E-10_JPRB, 0.24638059E-10_JPRB, 0.25448968E-10_JPRB, 0.26291211E-10_JPRB, 0.27200806E-10_JPRB, &
  & 0.28158972E-10_JPRB, 0.29186507E-10_JPRB, 0.30266550E-10_JPRB, 0.31409660E-10_JPRB, 0.32552572E-10_JPRB, 0.33718226E-10_JPRB, &
  & 0.34890663E-10_JPRB, 0.36024746E-10_JPRB, 0.37327703E-10_JPRB, 0.38508460E-10_JPRB, 0.39878573E-10_JPRB, 0.41102968E-10_JPRB, &
  & 0.42405607E-10_JPRB, 0.43727584E-10_JPRB, 0.45046075E-10_JPRB, 0.46379310E-10_JPRB, 0.47697499E-10_JPRB, 0.48997466E-10_JPRB, &
  & 0.50221560E-10_JPRB, 0.51345556E-10_JPRB, 0.52396552E-10_JPRB, 0.53398060E-10_JPRB, 0.54383609E-10_JPRB, 0.55287268E-10_JPRB, &
  & 0.56186583E-10_JPRB, 0.57148737E-10_JPRB, 0.58123149E-10_JPRB, 0.59182916E-10_JPRB, 0.60310465E-10_JPRB, 0.61343888E-10_JPRB, &
  & 0.62395589E-10_JPRB, 0.63397967E-10_JPRB, 0.64425638E-10_JPRB, 0.65514955E-10_JPRB, 0.66567474E-10_JPRB, 0.67483692E-10_JPRB, &
  & 0.68309705E-10_JPRB, 0.69189703E-10_JPRB, 0.70193407E-10_JPRB, 0.70611066E-10_JPRB, 0.70984864E-10_JPRB, 0.77672535E-10_JPRB, &
  & 0.76667679E-10_JPRB, 0.77496995E-10_JPRB, 0.77393952E-10_JPRB, 0.75831834E-10_JPRB /)

RGHG4(:,81,10) = (/ &
  & 0.18443221E-10_JPRB, 0.18673675E-10_JPRB, 0.18931431E-10_JPRB, 0.18966509E-10_JPRB, 0.19166290E-10_JPRB, 0.19776734E-10_JPRB, &
  & 0.20563952E-10_JPRB, 0.21377820E-10_JPRB, 0.21202453E-10_JPRB, 0.21794686E-10_JPRB, 0.22324999E-10_JPRB, 0.22936045E-10_JPRB, &
  & 0.23591972E-10_JPRB, 0.24316063E-10_JPRB, 0.25081959E-10_JPRB, 0.25927299E-10_JPRB, 0.26832741E-10_JPRB, 0.27800876E-10_JPRB, &
  & 0.28807078E-10_JPRB, 0.29866446E-10_JPRB, 0.30981828E-10_JPRB, 0.32159421E-10_JPRB, 0.33320822E-10_JPRB, 0.34511533E-10_JPRB, &
  & 0.35654944E-10_JPRB, 0.36842820E-10_JPRB, 0.38049126E-10_JPRB, 0.39219603E-10_JPRB, 0.40476119E-10_JPRB, 0.41769126E-10_JPRB, &
  & 0.43076921E-10_JPRB, 0.44406326E-10_JPRB, 0.45724539E-10_JPRB, 0.47075184E-10_JPRB, 0.48416805E-10_JPRB, 0.49737093E-10_JPRB, &
  & 0.51002737E-10_JPRB, 0.52166490E-10_JPRB, 0.53259966E-10_JPRB, 0.54305227E-10_JPRB, 0.55391768E-10_JPRB, 0.56442517E-10_JPRB, &
  & 0.57372142E-10_JPRB, 0.58351060E-10_JPRB, 0.59301807E-10_JPRB, 0.60356171E-10_JPRB, 0.61435482E-10_JPRB, 0.62430658E-10_JPRB, &
  & 0.63413344E-10_JPRB, 0.64333407E-10_JPRB, 0.65321339E-10_JPRB, 0.66396964E-10_JPRB, 0.67420257E-10_JPRB, 0.68335657E-10_JPRB, &
  & 0.69153870E-10_JPRB, 0.70056946E-10_JPRB, 0.71094110E-10_JPRB, 0.71602911E-10_JPRB, 0.71956587E-10_JPRB, 0.79037825E-10_JPRB, &
  & 0.78386929E-10_JPRB, 0.79260494E-10_JPRB, 0.79388073E-10_JPRB, 0.79628262E-10_JPRB /)

RGHG4(:,82,10) = (/ &
  & 0.18961607E-10_JPRB, 0.18845894E-10_JPRB, 0.19095314E-10_JPRB, 0.19082404E-10_JPRB, 0.19283181E-10_JPRB, 0.19911215E-10_JPRB, &
  & 0.20720528E-10_JPRB, 0.21571571E-10_JPRB, 0.21517926E-10_JPRB, 0.22059753E-10_JPRB, 0.22636190E-10_JPRB, 0.23231604E-10_JPRB, &
  & 0.23911933E-10_JPRB, 0.24641034E-10_JPRB, 0.25432371E-10_JPRB, 0.26270229E-10_JPRB, 0.27156338E-10_JPRB, 0.28106066E-10_JPRB, &
  & 0.29107241E-10_JPRB, 0.30166401E-10_JPRB, 0.31297010E-10_JPRB, 0.32474766E-10_JPRB, 0.33640958E-10_JPRB, 0.34826801E-10_JPRB, &
  & 0.35971295E-10_JPRB, 0.37221063E-10_JPRB, 0.38381801E-10_JPRB, 0.39714954E-10_JPRB, 0.40946389E-10_JPRB, 0.42259946E-10_JPRB, &
  & 0.43523005E-10_JPRB, 0.44841218E-10_JPRB, 0.46173246E-10_JPRB, 0.47539504E-10_JPRB, 0.48894368E-10_JPRB, 0.50243931E-10_JPRB, &
  & 0.51522907E-10_JPRB, 0.52719346E-10_JPRB, 0.53825149E-10_JPRB, 0.54913150E-10_JPRB, 0.55935690E-10_JPRB, 0.56922397E-10_JPRB, &
  & 0.57831951E-10_JPRB, 0.58807778E-10_JPRB, 0.59770890E-10_JPRB, 0.60819433E-10_JPRB, 0.61922245E-10_JPRB, 0.62925928E-10_JPRB, &
  & 0.63946591E-10_JPRB, 0.64927147E-10_JPRB, 0.65926896E-10_JPRB, 0.66993508E-10_JPRB, 0.68001313E-10_JPRB, 0.68904875E-10_JPRB, &
  & 0.69661714E-10_JPRB, 0.70530567E-10_JPRB, 0.71511734E-10_JPRB, 0.72052551E-10_JPRB, 0.72233441E-10_JPRB, 0.79440766E-10_JPRB, &
  & 0.78433426E-10_JPRB, 0.79493571E-10_JPRB, 0.79893044E-10_JPRB, 0.81894699E-10_JPRB /)

RGHG4(:,83,10) = (/ &
  & 0.19142991E-10_JPRB, 0.18943477E-10_JPRB, 0.19242110E-10_JPRB, 0.19214668E-10_JPRB, 0.19462041E-10_JPRB, 0.20087178E-10_JPRB, &
  & 0.20895934E-10_JPRB, 0.21793485E-10_JPRB, 0.21711636E-10_JPRB, 0.22335231E-10_JPRB, 0.22848359E-10_JPRB, 0.23485125E-10_JPRB, &
  & 0.24145878E-10_JPRB, 0.24888829E-10_JPRB, 0.25677377E-10_JPRB, 0.26541254E-10_JPRB, 0.27466043E-10_JPRB, 0.28444714E-10_JPRB, &
  & 0.29454765E-10_JPRB, 0.30524337E-10_JPRB, 0.31652982E-10_JPRB, 0.32844765E-10_JPRB, 0.34006874E-10_JPRB, 0.35209780E-10_JPRB, &
  & 0.36369886E-10_JPRB, 0.37589733E-10_JPRB, 0.38731608E-10_JPRB, 0.40004590E-10_JPRB, 0.41229794E-10_JPRB, 0.42545512E-10_JPRB, &
  & 0.43849927E-10_JPRB, 0.45156739E-10_JPRB, 0.46501612E-10_JPRB, 0.47881612E-10_JPRB, 0.49261588E-10_JPRB, 0.50616025E-10_JPRB, &
  & 0.51921547E-10_JPRB, 0.53112764E-10_JPRB, 0.54240921E-10_JPRB, 0.55322098E-10_JPRB, 0.56425906E-10_JPRB, 0.57476062E-10_JPRB, &
  & 0.58435805E-10_JPRB, 0.59427865E-10_JPRB, 0.60395182E-10_JPRB, 0.61459227E-10_JPRB, 0.62551818E-10_JPRB, 0.63533658E-10_JPRB, &
  & 0.64506095E-10_JPRB, 0.65392365E-10_JPRB, 0.66372706E-10_JPRB, 0.67466255E-10_JPRB, 0.68444771E-10_JPRB, 0.69353689E-10_JPRB, &
  & 0.70067917E-10_JPRB, 0.71000976E-10_JPRB, 0.71914676E-10_JPRB, 0.72608017E-10_JPRB, 0.72604103E-10_JPRB, 0.79979530E-10_JPRB, &
  & 0.79093385E-10_JPRB, 0.79850460E-10_JPRB, 0.80268098E-10_JPRB, 0.81608352E-10_JPRB /)

RGHG4(:,84,10) = (/ &
  & 0.19207759E-10_JPRB, 0.19026980E-10_JPRB, 0.19317685E-10_JPRB, 0.19272226E-10_JPRB, 0.19549503E-10_JPRB, 0.20140471E-10_JPRB, &
  & 0.21014645E-10_JPRB, 0.21899886E-10_JPRB, 0.21961852E-10_JPRB, 0.22507905E-10_JPRB, 0.23090830E-10_JPRB, 0.23671572E-10_JPRB, &
  & 0.24355800E-10_JPRB, 0.25095566E-10_JPRB, 0.25890474E-10_JPRB, 0.26747176E-10_JPRB, 0.27650802E-10_JPRB, 0.28615076E-10_JPRB, &
  & 0.29630041E-10_JPRB, 0.30691179E-10_JPRB, 0.31838646E-10_JPRB, 0.32999867E-10_JPRB, 0.34185491E-10_JPRB, 0.35375303E-10_JPRB, &
  & 0.36554409E-10_JPRB, 0.37745244E-10_JPRB, 0.38973953E-10_JPRB, 0.40249935E-10_JPRB, 0.41512332E-10_JPRB, 0.42805339E-10_JPRB, &
  & 0.44093736E-10_JPRB, 0.45409027E-10_JPRB, 0.46762628E-10_JPRB, 0.48157627E-10_JPRB, 0.49547859E-10_JPRB, 0.50926784E-10_JPRB, &
  & 0.52234665E-10_JPRB, 0.53451337E-10_JPRB, 0.54584729E-10_JPRB, 0.55677591E-10_JPRB, 0.56741920E-10_JPRB, 0.57748063E-10_JPRB, &
  & 0.58688672E-10_JPRB, 0.59690274E-10_JPRB, 0.60659602E-10_JPRB, 0.61713058E-10_JPRB, 0.62804276E-10_JPRB, 0.63783298E-10_JPRB, &
  & 0.64813065E-10_JPRB, 0.65781471E-10_JPRB, 0.66707577E-10_JPRB, 0.67790787E-10_JPRB, 0.68767513E-10_JPRB, 0.69695819E-10_JPRB, &
  & 0.70321131E-10_JPRB, 0.71272578E-10_JPRB, 0.72108458E-10_JPRB, 0.72835453E-10_JPRB, 0.72764926E-10_JPRB, 0.79874517E-10_JPRB, &
  & 0.79214121E-10_JPRB, 0.79792700E-10_JPRB, 0.80509419E-10_JPRB, 0.81684846E-10_JPRB /)

RGHG4(:,85,10) = (/ &
  & 0.19245489E-10_JPRB, 0.19086552E-10_JPRB, 0.19376556E-10_JPRB, 0.19360501E-10_JPRB, 0.19653012E-10_JPRB, 0.20263312E-10_JPRB, &
  & 0.21176064E-10_JPRB, 0.22116616E-10_JPRB, 0.22158718E-10_JPRB, 0.22743701E-10_JPRB, 0.23266548E-10_JPRB, 0.23872154E-10_JPRB, &
  & 0.24507139E-10_JPRB, 0.25232318E-10_JPRB, 0.26025728E-10_JPRB, 0.26890041E-10_JPRB, 0.27831239E-10_JPRB, 0.28819882E-10_JPRB, &
  & 0.29833403E-10_JPRB, 0.30906833E-10_JPRB, 0.32027426E-10_JPRB, 0.33199225E-10_JPRB, 0.34401735E-10_JPRB, 0.35577850E-10_JPRB, &
  & 0.36755338E-10_JPRB, 0.37960121E-10_JPRB, 0.39159266E-10_JPRB, 0.40394819E-10_JPRB, 0.41672780E-10_JPRB, 0.42968594E-10_JPRB, &
  & 0.44289083E-10_JPRB, 0.45594636E-10_JPRB, 0.46966212E-10_JPRB, 0.48370346E-10_JPRB, 0.49777155E-10_JPRB, 0.51160458E-10_JPRB, &
  & 0.52482910E-10_JPRB, 0.53701515E-10_JPRB, 0.54837974E-10_JPRB, 0.55942161E-10_JPRB, 0.57061928E-10_JPRB, 0.58111137E-10_JPRB, &
  & 0.59099996E-10_JPRB, 0.60106017E-10_JPRB, 0.61096253E-10_JPRB, 0.62156467E-10_JPRB, 0.63258600E-10_JPRB, 0.64217479E-10_JPRB, &
  & 0.65136091E-10_JPRB, 0.66084020E-10_JPRB, 0.67057443E-10_JPRB, 0.68138425E-10_JPRB, 0.69071589E-10_JPRB, 0.70010296E-10_JPRB, &
  & 0.70628371E-10_JPRB, 0.71519117E-10_JPRB, 0.72478690E-10_JPRB, 0.73054306E-10_JPRB, 0.73152456E-10_JPRB, 0.79969281E-10_JPRB, &
  & 0.79639406E-10_JPRB, 0.79887791E-10_JPRB, 0.80676306E-10_JPRB, 0.81947275E-10_JPRB /)

RGHG4(:,86,10) = (/ &
  & 0.19311969E-10_JPRB, 0.19134541E-10_JPRB, 0.19422594E-10_JPRB, 0.19434216E-10_JPRB, 0.19720302E-10_JPRB, 0.20342644E-10_JPRB, &
  & 0.21389394E-10_JPRB, 0.22217211E-10_JPRB, 0.22436141E-10_JPRB, 0.22950284E-10_JPRB, 0.23485450E-10_JPRB, 0.24031282E-10_JPRB, &
  & 0.24657944E-10_JPRB, 0.25348045E-10_JPRB, 0.26106084E-10_JPRB, 0.26971009E-10_JPRB, 0.27884271E-10_JPRB, 0.28872854E-10_JPRB, &
  & 0.29917870E-10_JPRB, 0.30967603E-10_JPRB, 0.32116778E-10_JPRB, 0.33291467E-10_JPRB, 0.34482230E-10_JPRB, 0.35627088E-10_JPRB, &
  & 0.36856698E-10_JPRB, 0.38032914E-10_JPRB, 0.39268627E-10_JPRB, 0.40539946E-10_JPRB, 0.41815936E-10_JPRB, 0.43119380E-10_JPRB, &
  & 0.44431323E-10_JPRB, 0.45758734E-10_JPRB, 0.47129949E-10_JPRB, 0.48546615E-10_JPRB, 0.49958638E-10_JPRB, 0.51349886E-10_JPRB, &
  & 0.52691265E-10_JPRB, 0.53925801E-10_JPRB, 0.55094311E-10_JPRB, 0.56209596E-10_JPRB, 0.57297712E-10_JPRB, 0.58340888E-10_JPRB, &
  & 0.59291218E-10_JPRB, 0.60310659E-10_JPRB, 0.61277393E-10_JPRB, 0.62320489E-10_JPRB, 0.63380599E-10_JPRB, 0.64400027E-10_JPRB, &
  & 0.65387161E-10_JPRB, 0.66293762E-10_JPRB, 0.67211924E-10_JPRB, 0.68316956E-10_JPRB, 0.69290081E-10_JPRB, 0.70181583E-10_JPRB, &
  & 0.70893999E-10_JPRB, 0.71552216E-10_JPRB, 0.72751277E-10_JPRB, 0.73077405E-10_JPRB, 0.73360304E-10_JPRB, 0.79776692E-10_JPRB, &
  & 0.79684578E-10_JPRB, 0.79884925E-10_JPRB, 0.80774533E-10_JPRB, 0.82047161E-10_JPRB /)

RGHG4(:,87,10) = (/ &
  & 0.19345029E-10_JPRB, 0.19166614E-10_JPRB, 0.19460039E-10_JPRB, 0.19500559E-10_JPRB, 0.19769015E-10_JPRB, 0.20555200E-10_JPRB, &
  & 0.21471736E-10_JPRB, 0.22518742E-10_JPRB, 0.22619302E-10_JPRB, 0.23148169E-10_JPRB, 0.23652752E-10_JPRB, 0.24177053E-10_JPRB, &
  & 0.24753651E-10_JPRB, 0.25418194E-10_JPRB, 0.26172238E-10_JPRB, 0.26995422E-10_JPRB, 0.27945739E-10_JPRB, 0.28957340E-10_JPRB, &
  & 0.29979380E-10_JPRB, 0.31064921E-10_JPRB, 0.32215466E-10_JPRB, 0.33384896E-10_JPRB, 0.34549960E-10_JPRB, 0.35735876E-10_JPRB, &
  & 0.36927877E-10_JPRB, 0.38116243E-10_JPRB, 0.39350700E-10_JPRB, 0.40612048E-10_JPRB, 0.41905004E-10_JPRB, 0.43225167E-10_JPRB, &
  & 0.44550818E-10_JPRB, 0.45880570E-10_JPRB, 0.47259627E-10_JPRB, 0.48674866E-10_JPRB, 0.50087996E-10_JPRB, 0.51482627E-10_JPRB, &
  & 0.52822528E-10_JPRB, 0.54077524E-10_JPRB, 0.55248656E-10_JPRB, 0.56404128E-10_JPRB, 0.57537988E-10_JPRB, 0.58611616E-10_JPRB, &
  & 0.59599208E-10_JPRB, 0.60610766E-10_JPRB, 0.61580532E-10_JPRB, 0.62652980E-10_JPRB, 0.63696826E-10_JPRB, 0.64630454E-10_JPRB, &
  & 0.65601823E-10_JPRB, 0.66586431E-10_JPRB, 0.67524597E-10_JPRB, 0.68543116E-10_JPRB, 0.69531297E-10_JPRB, 0.70337652E-10_JPRB, &
  & 0.71200032E-10_JPRB, 0.71671537E-10_JPRB, 0.73007718E-10_JPRB, 0.73265574E-10_JPRB, 0.73501531E-10_JPRB, 0.79895889E-10_JPRB, &
  & 0.79806273E-10_JPRB, 0.79978170E-10_JPRB, 0.80831342E-10_JPRB, 0.82119180E-10_JPRB /)

RGHG4(:,88,10) = (/ &
  & 0.19363964E-10_JPRB, 0.19196009E-10_JPRB, 0.19489681E-10_JPRB, 0.19532055E-10_JPRB, 0.19834636E-10_JPRB, 0.20560161E-10_JPRB, &
  & 0.21667123E-10_JPRB, 0.22508844E-10_JPRB, 0.22748071E-10_JPRB, 0.23270153E-10_JPRB, 0.23739885E-10_JPRB, 0.24281181E-10_JPRB, &
  & 0.24842999E-10_JPRB, 0.25498470E-10_JPRB, 0.26213264E-10_JPRB, 0.27056203E-10_JPRB, 0.27971007E-10_JPRB, 0.28958717E-10_JPRB, &
  & 0.30009249E-10_JPRB, 0.31099279E-10_JPRB, 0.32253731E-10_JPRB, 0.33401254E-10_JPRB, 0.34586684E-10_JPRB, 0.35745525E-10_JPRB, &
  & 0.36939066E-10_JPRB, 0.38138683E-10_JPRB, 0.39373668E-10_JPRB, 0.40655430E-10_JPRB, 0.41959953E-10_JPRB, 0.43286923E-10_JPRB, &
  & 0.44628808E-10_JPRB, 0.45969163E-10_JPRB, 0.47363679E-10_JPRB, 0.48789930E-10_JPRB, 0.50211772E-10_JPRB, 0.51625305E-10_JPRB, &
  & 0.52979381E-10_JPRB, 0.54253657E-10_JPRB, 0.55459821E-10_JPRB, 0.56611330E-10_JPRB, 0.57735886E-10_JPRB, 0.58792145E-10_JPRB, &
  & 0.59754708E-10_JPRB, 0.60760973E-10_JPRB, 0.61692769E-10_JPRB, 0.62729689E-10_JPRB, 0.63812115E-10_JPRB, 0.64781541E-10_JPRB, &
  & 0.65691112E-10_JPRB, 0.66597249E-10_JPRB, 0.67610570E-10_JPRB, 0.68667703E-10_JPRB, 0.69697220E-10_JPRB, 0.70412946E-10_JPRB, &
  & 0.71366059E-10_JPRB, 0.71776071E-10_JPRB, 0.73082776E-10_JPRB, 0.73424884E-10_JPRB, 0.73537496E-10_JPRB, 0.79855692E-10_JPRB, &
  & 0.79765181E-10_JPRB, 0.79988904E-10_JPRB, 0.80886631E-10_JPRB, 0.82134299E-10_JPRB /)

RGHG4(:,89,10) = (/ &
  & 0.19373808E-10_JPRB, 0.19234225E-10_JPRB, 0.19503005E-10_JPRB, 0.19552998E-10_JPRB, 0.19817236E-10_JPRB, 0.20609731E-10_JPRB, &
  & 0.21496775E-10_JPRB, 0.22575693E-10_JPRB, 0.22762618E-10_JPRB, 0.23235644E-10_JPRB, 0.23769819E-10_JPRB, 0.24262866E-10_JPRB, &
  & 0.24871711E-10_JPRB, 0.25526687E-10_JPRB, 0.26285045E-10_JPRB, 0.27111343E-10_JPRB, 0.28040644E-10_JPRB, 0.29056353E-10_JPRB, &
  & 0.30082679E-10_JPRB, 0.31168661E-10_JPRB, 0.32267650E-10_JPRB, 0.33444168E-10_JPRB, 0.34584679E-10_JPRB, 0.35739602E-10_JPRB, &
  & 0.36921209E-10_JPRB, 0.38110366E-10_JPRB, 0.39343459E-10_JPRB, 0.40628223E-10_JPRB, 0.41940097E-10_JPRB, 0.43288772E-10_JPRB, &
  & 0.44643178E-10_JPRB, 0.45998341E-10_JPRB, 0.47398790E-10_JPRB, 0.48842385E-10_JPRB, 0.50281133E-10_JPRB, 0.51674939E-10_JPRB, &
  & 0.53065177E-10_JPRB, 0.54376930E-10_JPRB, 0.55591486E-10_JPRB, 0.56778162E-10_JPRB, 0.57932242E-10_JPRB, 0.59006550E-10_JPRB, &
  & 0.59980819E-10_JPRB, 0.60980290E-10_JPRB, 0.61930572E-10_JPRB, 0.62942984E-10_JPRB, 0.63982007E-10_JPRB, 0.64973769E-10_JPRB, &
  & 0.65980166E-10_JPRB, 0.66858949E-10_JPRB, 0.67789531E-10_JPRB, 0.68801104E-10_JPRB, 0.69893175E-10_JPRB, 0.70550003E-10_JPRB, &
  & 0.71486678E-10_JPRB, 0.71956600E-10_JPRB, 0.73164245E-10_JPRB, 0.73636444E-10_JPRB, 0.73551366E-10_JPRB, 0.79884488E-10_JPRB, &
  & 0.79823065E-10_JPRB, 0.80006037E-10_JPRB, 0.80944432E-10_JPRB, 0.82140836E-10_JPRB /)

RGHG4(:,90,10) = (/ &
  & 0.19379571E-10_JPRB, 0.19276237E-10_JPRB, 0.19495027E-10_JPRB, 0.19558499E-10_JPRB, 0.19765804E-10_JPRB, 0.20398495E-10_JPRB, &
  & 0.21434349E-10_JPRB, 0.22383860E-10_JPRB, 0.22546260E-10_JPRB, 0.23143463E-10_JPRB, 0.23628681E-10_JPRB, 0.24222275E-10_JPRB, &
  & 0.24834411E-10_JPRB, 0.25548084E-10_JPRB, 0.26319761E-10_JPRB, 0.27176660E-10_JPRB, 0.28117781E-10_JPRB, 0.29090411E-10_JPRB, &
  & 0.30112492E-10_JPRB, 0.31147380E-10_JPRB, 0.32266047E-10_JPRB, 0.33394638E-10_JPRB, 0.34514776E-10_JPRB, 0.35657845E-10_JPRB, &
  & 0.36819114E-10_JPRB, 0.37999347E-10_JPRB, 0.39229349E-10_JPRB, 0.40519411E-10_JPRB, 0.41848303E-10_JPRB, 0.43212791E-10_JPRB, &
  & 0.44592573E-10_JPRB, 0.45982350E-10_JPRB, 0.47419599E-10_JPRB, 0.48898195E-10_JPRB, 0.50364699E-10_JPRB, 0.51853008E-10_JPRB, &
  & 0.53269507E-10_JPRB, 0.54571542E-10_JPRB, 0.55802134E-10_JPRB, 0.56987755E-10_JPRB, 0.58124696E-10_JPRB, 0.59172278E-10_JPRB, &
  & 0.60125793E-10_JPRB, 0.61095330E-10_JPRB, 0.62027661E-10_JPRB, 0.63041419E-10_JPRB, 0.64054886E-10_JPRB, 0.64960495E-10_JPRB, &
  & 0.65949655E-10_JPRB, 0.66898743E-10_JPRB, 0.67905757E-10_JPRB, 0.68895792E-10_JPRB, 0.69979189E-10_JPRB, 0.70690044E-10_JPRB, &
  & 0.71555616E-10_JPRB, 0.72077129E-10_JPRB, 0.73150722E-10_JPRB, 0.73899269E-10_JPRB, 0.73469328E-10_JPRB, 0.79742102E-10_JPRB, &
  & 0.79811560E-10_JPRB, 0.79995233E-10_JPRB, 0.81033895E-10_JPRB, 0.82148781E-10_JPRB /)

RGHG4(:,91,10) = (/ &
  & 0.19373284E-10_JPRB, 0.19333009E-10_JPRB, 0.19464853E-10_JPRB, 0.19543964E-10_JPRB, 0.19707043E-10_JPRB, 0.20254467E-10_JPRB, &
  & 0.18831724E-10_JPRB, 0.21266076E-10_JPRB, 0.22303088E-10_JPRB, 0.22856798E-10_JPRB, 0.23423541E-10_JPRB, 0.24056701E-10_JPRB, &
  & 0.24750537E-10_JPRB, 0.25519109E-10_JPRB, 0.26340532E-10_JPRB, 0.27220653E-10_JPRB, 0.28153181E-10_JPRB, 0.29127943E-10_JPRB, &
  & 0.30115417E-10_JPRB, 0.31137020E-10_JPRB, 0.32197276E-10_JPRB, 0.33281863E-10_JPRB, 0.34361198E-10_JPRB, 0.35465558E-10_JPRB, &
  & 0.36606676E-10_JPRB, 0.37740460E-10_JPRB, 0.38999245E-10_JPRB, 0.40304357E-10_JPRB, 0.41652896E-10_JPRB, 0.43043631E-10_JPRB, &
  & 0.44455210E-10_JPRB, 0.45869343E-10_JPRB, 0.47330955E-10_JPRB, 0.48874911E-10_JPRB, 0.50404191E-10_JPRB, 0.51872322E-10_JPRB, &
  & 0.53329945E-10_JPRB, 0.54732854E-10_JPRB, 0.56016757E-10_JPRB, 0.57228406E-10_JPRB, 0.56026735E-10_JPRB, 0.57168933E-10_JPRB, &
  & 0.60374532E-10_JPRB, 0.61327464E-10_JPRB, 0.62237861E-10_JPRB, 0.63245208E-10_JPRB, 0.64296776E-10_JPRB, 0.65222931E-10_JPRB, &
  & 0.66141197E-10_JPRB, 0.67047201E-10_JPRB, 0.68022761E-10_JPRB, 0.69034278E-10_JPRB, 0.70085861E-10_JPRB, 0.70827788E-10_JPRB, &
  & 0.71634490E-10_JPRB, 0.72324237E-10_JPRB, 0.73000717E-10_JPRB, 0.74258495E-10_JPRB, 0.73379754E-10_JPRB, 0.79537051E-10_JPRB, &
  & 0.79810707E-10_JPRB, 0.80021371E-10_JPRB, 0.81178252E-10_JPRB, 0.82185606E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG4(:, 1,11) = (/ &
  & 0.88651139E-13_JPRB, 0.96863923E-13_JPRB, 0.88777652E-13_JPRB, 0.10646253E-12_JPRB, 0.11205780E-12_JPRB, 0.12619692E-12_JPRB, &
  & 0.13568046E-12_JPRB, 0.15104243E-12_JPRB, 0.14990488E-12_JPRB, 0.14488820E-12_JPRB, 0.13806014E-12_JPRB, 0.13554635E-12_JPRB, &
  & 0.12626426E-12_JPRB, 0.12448555E-12_JPRB, 0.11674044E-12_JPRB, 0.11581781E-12_JPRB, 0.11219994E-12_JPRB, 0.11247660E-12_JPRB, &
  & 0.11370451E-12_JPRB, 0.11563729E-12_JPRB, 0.11240450E-12_JPRB, 0.11249024E-12_JPRB, 0.11279270E-12_JPRB, 0.11347479E-12_JPRB, &
  & 0.11489389E-12_JPRB, 0.11214545E-12_JPRB, 0.11334714E-12_JPRB, 0.11497308E-12_JPRB, 0.11668215E-12_JPRB, 0.11808457E-12_JPRB, &
  & 0.11887923E-12_JPRB, 0.11925297E-12_JPRB, 0.11187142E-12_JPRB, 0.10857611E-12_JPRB, 0.10519600E-12_JPRB, 0.10241358E-12_JPRB, &
  & 0.10078547E-12_JPRB, 0.10076156E-12_JPRB, 0.97013821E-13_JPRB, 0.98589912E-13_JPRB, 0.10065084E-12_JPRB, 0.10292001E-12_JPRB, &
  & 0.10515797E-12_JPRB, 0.10796212E-12_JPRB, 0.10175773E-12_JPRB, 0.10100104E-12_JPRB, 0.99946032E-13_JPRB, 0.10057823E-12_JPRB, &
  & 0.91708515E-13_JPRB, 0.89990569E-13_JPRB, 0.83376557E-13_JPRB, 0.81144598E-13_JPRB, 0.74064724E-13_JPRB, 0.73343770E-13_JPRB, &
  & 0.68483976E-13_JPRB, 0.65296299E-13_JPRB, 0.96918662E-09_JPRB, 0.97030206E-09_JPRB, 0.97026354E-09_JPRB, 0.97190944E-09_JPRB, &
  & 0.97400921E-09_JPRB, 0.96881680E-09_JPRB, 0.98452024E-09_JPRB, 0.97024933E-09_JPRB /)

RGHG4(:, 2,11) = (/ &
  & 0.83267827E-12_JPRB, 0.68106713E-12_JPRB, 0.53276052E-12_JPRB, 0.50021668E-12_JPRB, 0.46273152E-12_JPRB, 0.45003785E-12_JPRB, &
  & 0.44872805E-12_JPRB, 0.47421447E-12_JPRB, 0.57478452E-12_JPRB, 0.64786127E-12_JPRB, 0.68249372E-12_JPRB, 0.72831151E-12_JPRB, &
  & 0.77135808E-12_JPRB, 0.81995473E-12_JPRB, 0.88578353E-12_JPRB, 0.94628179E-12_JPRB, 0.10237785E-11_JPRB, 0.10746358E-11_JPRB, &
  & 0.11279086E-11_JPRB, 0.11606125E-11_JPRB, 0.11656299E-11_JPRB, 0.11280312E-11_JPRB, 0.10893992E-11_JPRB, 0.10471915E-11_JPRB, &
  & 0.10033687E-11_JPRB, 0.96115553E-12_JPRB, 0.90299816E-12_JPRB, 0.85707537E-12_JPRB, 0.81759642E-12_JPRB, 0.78088257E-12_JPRB, &
  & 0.74702928E-12_JPRB, 0.71547867E-12_JPRB, 0.68937694E-12_JPRB, 0.64641066E-12_JPRB, 0.61754931E-12_JPRB, 0.59742386E-12_JPRB, &
  & 0.58242593E-12_JPRB, 0.57304275E-12_JPRB, 0.56736695E-12_JPRB, 0.55639293E-12_JPRB, 0.54716361E-12_JPRB, 0.53036991E-12_JPRB, &
  & 0.50908919E-12_JPRB, 0.48178513E-12_JPRB, 0.44707670E-12_JPRB, 0.40688449E-12_JPRB, 0.36980025E-12_JPRB, 0.34117010E-12_JPRB, &
  & 0.32725258E-12_JPRB, 0.32260154E-12_JPRB, 0.32097656E-12_JPRB, 0.31445696E-12_JPRB, 0.30193822E-12_JPRB, 0.28546447E-12_JPRB, &
  & 0.26813960E-12_JPRB, 0.25100430E-12_JPRB, 0.10077004E-19_JPRB, 0.10072456E-19_JPRB, 0.10064788E-19_JPRB, 0.10054758E-19_JPRB, &
  & 0.35738069E-10_JPRB, 0.66849241E-10_JPRB, 0.18470875E-09_JPRB, 0.22416005E-09_JPRB /)

RGHG4(:, 3,11) = (/ &
  & 0.21129951E-11_JPRB, 0.17417693E-11_JPRB, 0.15391784E-11_JPRB, 0.14199929E-11_JPRB, 0.13319929E-11_JPRB, 0.12713995E-11_JPRB, &
  & 0.12355776E-11_JPRB, 0.12367363E-11_JPRB, 0.13849743E-11_JPRB, 0.14515503E-11_JPRB, 0.14968124E-11_JPRB, 0.15807546E-11_JPRB, &
  & 0.16655791E-11_JPRB, 0.17828013E-11_JPRB, 0.19061764E-11_JPRB, 0.20365790E-11_JPRB, 0.21682968E-11_JPRB, 0.22572352E-11_JPRB, &
  & 0.23432324E-11_JPRB, 0.23833682E-11_JPRB, 0.23734907E-11_JPRB, 0.23002949E-11_JPRB, 0.22323250E-11_JPRB, 0.21501557E-11_JPRB, &
  & 0.20665173E-11_JPRB, 0.19804572E-11_JPRB, 0.18716424E-11_JPRB, 0.17892066E-11_JPRB, 0.17148270E-11_JPRB, 0.16477525E-11_JPRB, &
  & 0.15834469E-11_JPRB, 0.15193857E-11_JPRB, 0.14642438E-11_JPRB, 0.13846728E-11_JPRB, 0.13286796E-11_JPRB, 0.12849639E-11_JPRB, &
  & 0.12535178E-11_JPRB, 0.12314106E-11_JPRB, 0.12135204E-11_JPRB, 0.11881712E-11_JPRB, 0.11629313E-11_JPRB, 0.11258185E-11_JPRB, &
  & 0.10720809E-11_JPRB, 0.10030959E-11_JPRB, 0.92880293E-12_JPRB, 0.85103349E-12_JPRB, 0.78346265E-12_JPRB, 0.72197489E-12_JPRB, &
  & 0.65874004E-12_JPRB, 0.58651142E-12_JPRB, 0.52295787E-12_JPRB, 0.48169644E-12_JPRB, 0.45884141E-12_JPRB, 0.43984079E-12_JPRB, &
  & 0.42049656E-12_JPRB, 0.40042072E-12_JPRB, 0.29383149E-09_JPRB, 0.27525721E-09_JPRB, 0.29494354E-09_JPRB, 0.33171232E-09_JPRB, &
  & 0.40656983E-09_JPRB, 0.42084272E-09_JPRB, 0.55684490E-09_JPRB, 0.66131356E-09_JPRB /)

RGHG4(:, 4,11) = (/ &
  & 0.54689395E-11_JPRB, 0.46949467E-11_JPRB, 0.42491843E-11_JPRB, 0.39653831E-11_JPRB, 0.37865436E-11_JPRB, 0.36873720E-11_JPRB, &
  & 0.36433252E-11_JPRB, 0.36763084E-11_JPRB, 0.38834999E-11_JPRB, 0.39122165E-11_JPRB, 0.39573757E-11_JPRB, 0.40562818E-11_JPRB, &
  & 0.41817322E-11_JPRB, 0.43651241E-11_JPRB, 0.45330658E-11_JPRB, 0.47120246E-11_JPRB, 0.48517219E-11_JPRB, 0.49364809E-11_JPRB, &
  & 0.50103021E-11_JPRB, 0.50111425E-11_JPRB, 0.49409743E-11_JPRB, 0.47844250E-11_JPRB, 0.46396589E-11_JPRB, 0.44661835E-11_JPRB, &
  & 0.42961112E-11_JPRB, 0.41219098E-11_JPRB, 0.39282167E-11_JPRB, 0.37829627E-11_JPRB, 0.36507828E-11_JPRB, 0.35331226E-11_JPRB, &
  & 0.34189129E-11_JPRB, 0.33047291E-11_JPRB, 0.32101520E-11_JPRB, 0.30818766E-11_JPRB, 0.29867948E-11_JPRB, 0.29087609E-11_JPRB, &
  & 0.28516176E-11_JPRB, 0.28083714E-11_JPRB, 0.27704933E-11_JPRB, 0.27229792E-11_JPRB, 0.26632863E-11_JPRB, 0.25745755E-11_JPRB, &
  & 0.24561529E-11_JPRB, 0.23116166E-11_JPRB, 0.21576259E-11_JPRB, 0.19892003E-11_JPRB, 0.18156845E-11_JPRB, 0.16367190E-11_JPRB, &
  & 0.14673266E-11_JPRB, 0.13181258E-11_JPRB, 0.11900991E-11_JPRB, 0.10673133E-11_JPRB, 0.95441580E-12_JPRB, 0.86535488E-12_JPRB, &
  & 0.80546789E-12_JPRB, 0.77374419E-12_JPRB, 0.69989226E-09_JPRB, 0.69553319E-09_JPRB, 0.73395057E-09_JPRB, 0.79399470E-09_JPRB, &
  & 0.90144792E-09_JPRB, 0.98082620E-09_JPRB, 0.11722596E-08_JPRB, 0.13780995E-08_JPRB /)

RGHG4(:, 5,11) = (/ &
  & 0.14586384E-10_JPRB, 0.13097756E-10_JPRB, 0.12121257E-10_JPRB, 0.11388733E-10_JPRB, 0.10852270E-10_JPRB, 0.10495665E-10_JPRB, &
  & 0.10282261E-10_JPRB, 0.10209086E-10_JPRB, 0.10361711E-10_JPRB, 0.10430608E-10_JPRB, 0.10559759E-10_JPRB, 0.10760046E-10_JPRB, &
  & 0.10971370E-10_JPRB, 0.11238979E-10_JPRB, 0.11465155E-10_JPRB, 0.11697966E-10_JPRB, 0.11864142E-10_JPRB, 0.11942451E-10_JPRB, &
  & 0.11982621E-10_JPRB, 0.11914719E-10_JPRB, 0.11729648E-10_JPRB, 0.11428861E-10_JPRB, 0.11126522E-10_JPRB, 0.10769295E-10_JPRB, &
  & 0.10429305E-10_JPRB, 0.10093818E-10_JPRB, 0.97536241E-11_JPRB, 0.95002391E-11_JPRB, 0.92727588E-11_JPRB, 0.90862656E-11_JPRB, &
  & 0.89101322E-11_JPRB, 0.87337698E-11_JPRB, 0.85825938E-11_JPRB, 0.83503508E-11_JPRB, 0.81597003E-11_JPRB, 0.80015517E-11_JPRB, &
  & 0.78858257E-11_JPRB, 0.77895407E-11_JPRB, 0.76806339E-11_JPRB, 0.75234758E-11_JPRB, 0.72927515E-11_JPRB, 0.69506384E-11_JPRB, &
  & 0.65294476E-11_JPRB, 0.60502475E-11_JPRB, 0.55579482E-11_JPRB, 0.50608549E-11_JPRB, 0.45979999E-11_JPRB, 0.41783001E-11_JPRB, &
  & 0.37884990E-11_JPRB, 0.33988621E-11_JPRB, 0.30179114E-11_JPRB, 0.26759192E-11_JPRB, 0.23862778E-11_JPRB, 0.21407520E-11_JPRB, &
  & 0.19562637E-11_JPRB, 0.18905563E-11_JPRB, 0.12251190E-08_JPRB, 0.12006428E-08_JPRB, 0.12453435E-08_JPRB, 0.13467060E-08_JPRB, &
  & 0.14944919E-08_JPRB, 0.16572301E-08_JPRB, 0.18600447E-08_JPRB, 0.21934103E-08_JPRB /)

RGHG4(:, 6,11) = (/ &
  & 0.39288621E-10_JPRB, 0.36165921E-10_JPRB, 0.33303551E-10_JPRB, 0.31058420E-10_JPRB, 0.29335478E-10_JPRB, 0.28051460E-10_JPRB, &
  & 0.27163201E-10_JPRB, 0.26620421E-10_JPRB, 0.26832609E-10_JPRB, 0.26977897E-10_JPRB, 0.27213965E-10_JPRB, 0.27542756E-10_JPRB, &
  & 0.27907248E-10_JPRB, 0.28315267E-10_JPRB, 0.28642441E-10_JPRB, 0.28919495E-10_JPRB, 0.29112851E-10_JPRB, 0.29155744E-10_JPRB, &
  & 0.29105076E-10_JPRB, 0.28921931E-10_JPRB, 0.28599415E-10_JPRB, 0.28114818E-10_JPRB, 0.27606136E-10_JPRB, 0.27043041E-10_JPRB, &
  & 0.26488475E-10_JPRB, 0.25979512E-10_JPRB, 0.25456822E-10_JPRB, 0.25040589E-10_JPRB, 0.24699444E-10_JPRB, 0.24434415E-10_JPRB, &
  & 0.24215154E-10_JPRB, 0.24028434E-10_JPRB, 0.23949148E-10_JPRB, 0.23738291E-10_JPRB, 0.23520439E-10_JPRB, 0.23300710E-10_JPRB, &
  & 0.23055790E-10_JPRB, 0.22746130E-10_JPRB, 0.22307619E-10_JPRB, 0.21671420E-10_JPRB, 0.20794097E-10_JPRB, 0.19664144E-10_JPRB, &
  & 0.18404511E-10_JPRB, 0.17071062E-10_JPRB, 0.15750108E-10_JPRB, 0.14475188E-10_JPRB, 0.13258031E-10_JPRB, 0.12064090E-10_JPRB, &
  & 0.10912164E-10_JPRB, 0.98299346E-11_JPRB, 0.88243250E-11_JPRB, 0.78930690E-11_JPRB, 0.70476411E-11_JPRB, 0.63397135E-11_JPRB, &
  & 0.58785667E-11_JPRB, 0.60211476E-11_JPRB, 0.18852748E-08_JPRB, 0.18552001E-08_JPRB, 0.19341917E-08_JPRB, 0.20821835E-08_JPRB, &
  & 0.22618019E-08_JPRB, 0.24478966E-08_JPRB, 0.26638249E-08_JPRB, 0.30156637E-08_JPRB /)

RGHG4(:, 7,11) = (/ &
  & 0.10075139E-09_JPRB, 0.93859219E-10_JPRB, 0.87053927E-10_JPRB, 0.81306697E-10_JPRB, 0.76861191E-10_JPRB, 0.73299596E-10_JPRB, &
  & 0.70425721E-10_JPRB, 0.68277425E-10_JPRB, 0.68577574E-10_JPRB, 0.68875489E-10_JPRB, 0.69330069E-10_JPRB, 0.69838378E-10_JPRB, &
  & 0.70381131E-10_JPRB, 0.70920027E-10_JPRB, 0.71364428E-10_JPRB, 0.71657687E-10_JPRB, 0.71939864E-10_JPRB, 0.71933098E-10_JPRB, &
  & 0.71755865E-10_JPRB, 0.71483507E-10_JPRB, 0.71212106E-10_JPRB, 0.70705219E-10_JPRB, 0.70082870E-10_JPRB, 0.69391305E-10_JPRB, &
  & 0.68728107E-10_JPRB, 0.68206517E-10_JPRB, 0.67633732E-10_JPRB, 0.67092575E-10_JPRB, 0.66738885E-10_JPRB, 0.66516986E-10_JPRB, &
  & 0.66444107E-10_JPRB, 0.66435996E-10_JPRB, 0.66644752E-10_JPRB, 0.66492936E-10_JPRB, 0.66029654E-10_JPRB, 0.65426956E-10_JPRB, &
  & 0.64519813E-10_JPRB, 0.63297138E-10_JPRB, 0.61613360E-10_JPRB, 0.59339512E-10_JPRB, 0.56357176E-10_JPRB, 0.52870413E-10_JPRB, &
  & 0.49374543E-10_JPRB, 0.46086572E-10_JPRB, 0.43275876E-10_JPRB, 0.40723223E-10_JPRB, 0.38218404E-10_JPRB, 0.35692446E-10_JPRB, &
  & 0.33214122E-10_JPRB, 0.30668138E-10_JPRB, 0.28096331E-10_JPRB, 0.25649460E-10_JPRB, 0.23489313E-10_JPRB, 0.21799307E-10_JPRB, &
  & 0.21168232E-10_JPRB, 0.23251663E-10_JPRB, 0.30184055E-08_JPRB, 0.29394580E-08_JPRB, 0.29892533E-08_JPRB, 0.31113720E-08_JPRB, &
  & 0.32630860E-08_JPRB, 0.34161372E-08_JPRB, 0.36172854E-08_JPRB, 0.38941268E-08_JPRB /)

RGHG4(:, 8,11) = (/ &
  & 0.25116781E-09_JPRB, 0.23756500E-09_JPRB, 0.22114886E-09_JPRB, 0.20623742E-09_JPRB, 0.19362924E-09_JPRB, 0.18339309E-09_JPRB, &
  & 0.17548331E-09_JPRB, 0.16971329E-09_JPRB, 0.16987141E-09_JPRB, 0.17013371E-09_JPRB, 0.17066715E-09_JPRB, 0.17125606E-09_JPRB, &
  & 0.17197473E-09_JPRB, 0.17273137E-09_JPRB, 0.17340564E-09_JPRB, 0.17377359E-09_JPRB, 0.17454213E-09_JPRB, 0.17479092E-09_JPRB, &
  & 0.17474990E-09_JPRB, 0.17465385E-09_JPRB, 0.17504349E-09_JPRB, 0.17498494E-09_JPRB, 0.17473435E-09_JPRB, 0.17436863E-09_JPRB, &
  & 0.17408855E-09_JPRB, 0.17426317E-09_JPRB, 0.17414836E-09_JPRB, 0.17368036E-09_JPRB, 0.17363166E-09_JPRB, 0.17366826E-09_JPRB, &
  & 0.17396272E-09_JPRB, 0.17430063E-09_JPRB, 0.17509069E-09_JPRB, 0.17501187E-09_JPRB, 0.17378340E-09_JPRB, 0.17225871E-09_JPRB, &
  & 0.16983769E-09_JPRB, 0.16670436E-09_JPRB, 0.16260110E-09_JPRB, 0.15721724E-09_JPRB, 0.15020889E-09_JPRB, 0.14206655E-09_JPRB, &
  & 0.13430877E-09_JPRB, 0.12732240E-09_JPRB, 0.12123116E-09_JPRB, 0.11542215E-09_JPRB, 0.10973913E-09_JPRB, 0.10451803E-09_JPRB, &
  & 0.99575993E-10_JPRB, 0.94702295E-10_JPRB, 0.89906443E-10_JPRB, 0.85288325E-10_JPRB, 0.81365192E-10_JPRB, 0.78892698E-10_JPRB, &
  & 0.79555112E-10_JPRB, 0.85085078E-10_JPRB, 0.46221635E-08_JPRB, 0.43962647E-08_JPRB, 0.43180064E-08_JPRB, 0.43248400E-08_JPRB, &
  & 0.43637249E-08_JPRB, 0.44208899E-08_JPRB, 0.44549697E-08_JPRB, 0.45577631E-08_JPRB /)

RGHG4(:, 9,11) = (/ &
  & 0.55054072E-09_JPRB, 0.52373705E-09_JPRB, 0.49293819E-09_JPRB, 0.46560986E-09_JPRB, 0.44282719E-09_JPRB, 0.42352247E-09_JPRB, &
  & 0.40723711E-09_JPRB, 0.39413031E-09_JPRB, 0.39196896E-09_JPRB, 0.39133302E-09_JPRB, 0.39159334E-09_JPRB, 0.39197806E-09_JPRB, &
  & 0.39262846E-09_JPRB, 0.39350606E-09_JPRB, 0.39448858E-09_JPRB, 0.39489603E-09_JPRB, 0.39659934E-09_JPRB, 0.39734488E-09_JPRB, &
  & 0.39801515E-09_JPRB, 0.39900111E-09_JPRB, 0.40178474E-09_JPRB, 0.40333314E-09_JPRB, 0.40448786E-09_JPRB, 0.40526432E-09_JPRB, &
  & 0.40632075E-09_JPRB, 0.40862094E-09_JPRB, 0.41026124E-09_JPRB, 0.41061907E-09_JPRB, 0.41186873E-09_JPRB, 0.41305689E-09_JPRB, &
  & 0.41438702E-09_JPRB, 0.41588077E-09_JPRB, 0.41864151E-09_JPRB, 0.41951553E-09_JPRB, 0.41726467E-09_JPRB, 0.41462150E-09_JPRB, &
  & 0.41016379E-09_JPRB, 0.40499079E-09_JPRB, 0.39860307E-09_JPRB, 0.39031375E-09_JPRB, 0.37861492E-09_JPRB, 0.36384665E-09_JPRB, &
  & 0.34917930E-09_JPRB, 0.33578365E-09_JPRB, 0.32497485E-09_JPRB, 0.31540567E-09_JPRB, 0.30656633E-09_JPRB, 0.29811145E-09_JPRB, &
  & 0.28984348E-09_JPRB, 0.28108693E-09_JPRB, 0.27183772E-09_JPRB, 0.26261154E-09_JPRB, 0.25441313E-09_JPRB, 0.24641186E-09_JPRB, &
  & 0.23867855E-09_JPRB, 0.23147562E-09_JPRB, 0.64120487E-08_JPRB, 0.58364740E-08_JPRB, 0.54630678E-08_JPRB, 0.52397189E-08_JPRB, &
  & 0.50934252E-08_JPRB, 0.50002620E-08_JPRB, 0.49304472E-08_JPRB, 0.48422382E-08_JPRB /)

RGHG4(:,10,11) = (/ &
  & 0.11020794E-08_JPRB, 0.10574734E-08_JPRB, 0.10060647E-08_JPRB, 0.95846808E-09_JPRB, 0.91723762E-09_JPRB, 0.88271523E-09_JPRB, &
  & 0.85467589E-09_JPRB, 0.83311336E-09_JPRB, 0.82702811E-09_JPRB, 0.82474261E-09_JPRB, 0.82392615E-09_JPRB, 0.82370272E-09_JPRB, &
  & 0.82462215E-09_JPRB, 0.82648449E-09_JPRB, 0.82942681E-09_JPRB, 0.83236668E-09_JPRB, 0.83829005E-09_JPRB, 0.84186652E-09_JPRB, &
  & 0.84515656E-09_JPRB, 0.84905782E-09_JPRB, 0.85698376E-09_JPRB, 0.86208979E-09_JPRB, 0.86639568E-09_JPRB, 0.87003005E-09_JPRB, &
  & 0.87414453E-09_JPRB, 0.88101171E-09_JPRB, 0.88628765E-09_JPRB, 0.88842061E-09_JPRB, 0.89210189E-09_JPRB, 0.89595809E-09_JPRB, &
  & 0.90029273E-09_JPRB, 0.90544616E-09_JPRB, 0.91330227E-09_JPRB, 0.91781877E-09_JPRB, 0.91632441E-09_JPRB, 0.91480373E-09_JPRB, &
  & 0.91059965E-09_JPRB, 0.90587421E-09_JPRB, 0.89990476E-09_JPRB, 0.89159474E-09_JPRB, 0.87891361E-09_JPRB, 0.86146046E-09_JPRB, &
  & 0.84467655E-09_JPRB, 0.82895474E-09_JPRB, 0.81585033E-09_JPRB, 0.80138590E-09_JPRB, 0.78567375E-09_JPRB, 0.76925516E-09_JPRB, &
  & 0.75219431E-09_JPRB, 0.73112139E-09_JPRB, 0.70617379E-09_JPRB, 0.67559663E-09_JPRB, 0.63902572E-09_JPRB, 0.59371130E-09_JPRB, &
  & 0.54202187E-09_JPRB, 0.48912402E-09_JPRB, 0.80164160E-08_JPRB, 0.69291293E-08_JPRB, 0.61970677E-08_JPRB, 0.57417426E-08_JPRB, &
  & 0.54281841E-08_JPRB, 0.51798610E-08_JPRB, 0.50373141E-08_JPRB, 0.48705298E-08_JPRB /)

RGHG4(:,11,11) = (/ &
  & 0.18867150E-08_JPRB, 0.18183925E-08_JPRB, 0.17556816E-08_JPRB, 0.17028927E-08_JPRB, 0.16592281E-08_JPRB, 0.16230116E-08_JPRB, &
  & 0.15937790E-08_JPRB, 0.15710554E-08_JPRB, 0.15641675E-08_JPRB, 0.15637552E-08_JPRB, 0.15655649E-08_JPRB, 0.15683228E-08_JPRB, &
  & 0.15731938E-08_JPRB, 0.15800653E-08_JPRB, 0.15888043E-08_JPRB, 0.15981787E-08_JPRB, 0.16138372E-08_JPRB, 0.16268140E-08_JPRB, &
  & 0.16391366E-08_JPRB, 0.16528223E-08_JPRB, 0.16726227E-08_JPRB, 0.16865507E-08_JPRB, 0.16977789E-08_JPRB, 0.17076511E-08_JPRB, &
  & 0.17169670E-08_JPRB, 0.17308671E-08_JPRB, 0.17404082E-08_JPRB, 0.17436402E-08_JPRB, 0.17487738E-08_JPRB, 0.17545703E-08_JPRB, &
  & 0.17609720E-08_JPRB, 0.17708583E-08_JPRB, 0.17885460E-08_JPRB, 0.18019697E-08_JPRB, 0.18070565E-08_JPRB, 0.18120160E-08_JPRB, &
  & 0.18108987E-08_JPRB, 0.18094781E-08_JPRB, 0.18086910E-08_JPRB, 0.18083953E-08_JPRB, 0.18045547E-08_JPRB, 0.17949767E-08_JPRB, &
  & 0.17825846E-08_JPRB, 0.17670742E-08_JPRB, 0.17504598E-08_JPRB, 0.17262906E-08_JPRB, 0.16955022E-08_JPRB, 0.16566107E-08_JPRB, &
  & 0.16079927E-08_JPRB, 0.15446954E-08_JPRB, 0.14664684E-08_JPRB, 0.13707084E-08_JPRB, 0.12596579E-08_JPRB, 0.11329433E-08_JPRB, &
  & 0.99576791E-09_JPRB, 0.85411139E-09_JPRB, 0.92506633E-08_JPRB, 0.75758404E-08_JPRB, 0.64906813E-08_JPRB, 0.58315379E-08_JPRB, &
  & 0.53320770E-08_JPRB, 0.50358673E-08_JPRB, 0.47887303E-08_JPRB, 0.46203104E-08_JPRB /)

RGHG4(:,12,11) = (/ &
  & 0.28792411E-08_JPRB, 0.28221272E-08_JPRB, 0.27638360E-08_JPRB, 0.27151150E-08_JPRB, 0.26790707E-08_JPRB, 0.26548639E-08_JPRB, &
  & 0.26405194E-08_JPRB, 0.26345093E-08_JPRB, 0.26441702E-08_JPRB, 0.26596427E-08_JPRB, 0.26758080E-08_JPRB, 0.26919944E-08_JPRB, &
  & 0.27105960E-08_JPRB, 0.27315392E-08_JPRB, 0.27572473E-08_JPRB, 0.27828861E-08_JPRB, 0.28151024E-08_JPRB, 0.28426768E-08_JPRB, &
  & 0.28680165E-08_JPRB, 0.28942875E-08_JPRB, 0.29274048E-08_JPRB, 0.29494838E-08_JPRB, 0.29661200E-08_JPRB, 0.29794949E-08_JPRB, &
  & 0.29906031E-08_JPRB, 0.30075158E-08_JPRB, 0.30159348E-08_JPRB, 0.30145995E-08_JPRB, 0.30136762E-08_JPRB, 0.30140406E-08_JPRB, &
  & 0.30182863E-08_JPRB, 0.30288674E-08_JPRB, 0.30523439E-08_JPRB, 0.30731913E-08_JPRB, 0.30835277E-08_JPRB, 0.30916154E-08_JPRB, &
  & 0.30930276E-08_JPRB, 0.30980714E-08_JPRB, 0.31062195E-08_JPRB, 0.31100558E-08_JPRB, 0.31068541E-08_JPRB, 0.30951048E-08_JPRB, &
  & 0.30764495E-08_JPRB, 0.30486980E-08_JPRB, 0.30127796E-08_JPRB, 0.29568248E-08_JPRB, 0.28829097E-08_JPRB, 0.27908063E-08_JPRB, &
  & 0.26798370E-08_JPRB, 0.25430591E-08_JPRB, 0.23823750E-08_JPRB, 0.21926809E-08_JPRB, 0.19819457E-08_JPRB, 0.17487388E-08_JPRB, &
  & 0.14979985E-08_JPRB, 0.12368202E-08_JPRB, 0.97760635E-08_JPRB, 0.76252062E-08_JPRB, 0.63020535E-08_JPRB, 0.55002292E-08_JPRB, &
  & 0.49404361E-08_JPRB, 0.45370756E-08_JPRB, 0.43386628E-08_JPRB, 0.40881130E-08_JPRB /)

RGHG4(:,13,11) = (/ &
  & 0.38647534E-08_JPRB, 0.38329779E-08_JPRB, 0.38081995E-08_JPRB, 0.37983470E-08_JPRB, 0.38027337E-08_JPRB, 0.38204178E-08_JPRB, &
  & 0.38491246E-08_JPRB, 0.38839931E-08_JPRB, 0.39291046E-08_JPRB, 0.39742019E-08_JPRB, 0.40157060E-08_JPRB, 0.40544128E-08_JPRB, &
  & 0.40950585E-08_JPRB, 0.41343222E-08_JPRB, 0.41776689E-08_JPRB, 0.42214539E-08_JPRB, 0.42702011E-08_JPRB, 0.43105355E-08_JPRB, &
  & 0.43452406E-08_JPRB, 0.43778181E-08_JPRB, 0.44154067E-08_JPRB, 0.44376729E-08_JPRB, 0.44523514E-08_JPRB, 0.44639985E-08_JPRB, &
  & 0.44729962E-08_JPRB, 0.44882840E-08_JPRB, 0.44928314E-08_JPRB, 0.44865560E-08_JPRB, 0.44803947E-08_JPRB, 0.44773407E-08_JPRB, &
  & 0.44763984E-08_JPRB, 0.44860609E-08_JPRB, 0.45115844E-08_JPRB, 0.45260249E-08_JPRB, 0.45265418E-08_JPRB, 0.45286837E-08_JPRB, &
  & 0.45260742E-08_JPRB, 0.45207966E-08_JPRB, 0.45148250E-08_JPRB, 0.44977093E-08_JPRB, 0.44698729E-08_JPRB, 0.44298525E-08_JPRB, &
  & 0.43770827E-08_JPRB, 0.43090398E-08_JPRB, 0.42273336E-08_JPRB, 0.41175139E-08_JPRB, 0.39826777E-08_JPRB, 0.38232058E-08_JPRB, &
  & 0.36401335E-08_JPRB, 0.34252339E-08_JPRB, 0.31840979E-08_JPRB, 0.29115561E-08_JPRB, 0.26139155E-08_JPRB, 0.22870212E-08_JPRB, &
  & 0.19259225E-08_JPRB, 0.15306529E-08_JPRB, 0.92738688E-08_JPRB, 0.69136656E-08_JPRB, 0.55173301E-08_JPRB, 0.47025783E-08_JPRB, &
  & 0.40998760E-08_JPRB, 0.37654955E-08_JPRB, 0.35050551E-08_JPRB, 0.33497918E-08_JPRB /)

RGHG4(:,14,11) = (/ &
  & 0.47365503E-08_JPRB, 0.47526054E-08_JPRB, 0.47554360E-08_JPRB, 0.47747513E-08_JPRB, 0.48151585E-08_JPRB, 0.48746482E-08_JPRB, &
  & 0.49485194E-08_JPRB, 0.50286570E-08_JPRB, 0.51118252E-08_JPRB, 0.51904401E-08_JPRB, 0.52598073E-08_JPRB, 0.53195732E-08_JPRB, &
  & 0.53785594E-08_JPRB, 0.54337770E-08_JPRB, 0.54895355E-08_JPRB, 0.55403051E-08_JPRB, 0.55924558E-08_JPRB, 0.56307470E-08_JPRB, &
  & 0.56592131E-08_JPRB, 0.56819633E-08_JPRB, 0.57083760E-08_JPRB, 0.57200298E-08_JPRB, 0.57259113E-08_JPRB, 0.57318252E-08_JPRB, &
  & 0.57394769E-08_JPRB, 0.57556835E-08_JPRB, 0.57629412E-08_JPRB, 0.57615468E-08_JPRB, 0.57596088E-08_JPRB, 0.57581437E-08_JPRB, &
  & 0.57618461E-08_JPRB, 0.57653642E-08_JPRB, 0.57773826E-08_JPRB, 0.57820833E-08_JPRB, 0.57768403E-08_JPRB, 0.57595471E-08_JPRB, &
  & 0.57277476E-08_JPRB, 0.56875109E-08_JPRB, 0.56451732E-08_JPRB, 0.55859735E-08_JPRB, 0.55124363E-08_JPRB, 0.54237770E-08_JPRB, &
  & 0.53188471E-08_JPRB, 0.51982143E-08_JPRB, 0.50650435E-08_JPRB, 0.49046718E-08_JPRB, 0.47178581E-08_JPRB, 0.45049262E-08_JPRB, &
  & 0.42682955E-08_JPRB, 0.39999670E-08_JPRB, 0.37080186E-08_JPRB, 0.33846446E-08_JPRB, 0.30349214E-08_JPRB, 0.26468587E-08_JPRB, &
  & 0.22078608E-08_JPRB, 0.17356411E-08_JPRB, 0.84475218E-08_JPRB, 0.60431660E-08_JPRB, 0.46426831E-08_JPRB, 0.38316919E-08_JPRB, &
  & 0.32500589E-08_JPRB, 0.28834264E-08_JPRB, 0.26621874E-08_JPRB, 0.25285669E-08_JPRB /)

RGHG4(:,15,11) = (/ &
  & 0.53612697E-08_JPRB, 0.53990012E-08_JPRB, 0.54254392E-08_JPRB, 0.54713754E-08_JPRB, 0.55413030E-08_JPRB, 0.56340821E-08_JPRB, &
  & 0.57438232E-08_JPRB, 0.58554961E-08_JPRB, 0.59527814E-08_JPRB, 0.60432015E-08_JPRB, 0.61214314E-08_JPRB, 0.61846728E-08_JPRB, &
  & 0.62417298E-08_JPRB, 0.62892576E-08_JPRB, 0.63353296E-08_JPRB, 0.63702794E-08_JPRB, 0.64018688E-08_JPRB, 0.64153602E-08_JPRB, &
  & 0.64160459E-08_JPRB, 0.64097829E-08_JPRB, 0.64089010E-08_JPRB, 0.63993633E-08_JPRB, 0.63939729E-08_JPRB, 0.63980781E-08_JPRB, &
  & 0.64141488E-08_JPRB, 0.64483343E-08_JPRB, 0.64801515E-08_JPRB, 0.65114469E-08_JPRB, 0.65432211E-08_JPRB, 0.65759891E-08_JPRB, &
  & 0.65969901E-08_JPRB, 0.66142727E-08_JPRB, 0.66256103E-08_JPRB, 0.66057031E-08_JPRB, 0.65592412E-08_JPRB, 0.64966388E-08_JPRB, &
  & 0.64206156E-08_JPRB, 0.63350005E-08_JPRB, 0.62465024E-08_JPRB, 0.61391043E-08_JPRB, 0.60176197E-08_JPRB, 0.58834178E-08_JPRB, &
  & 0.57366982E-08_JPRB, 0.55801315E-08_JPRB, 0.54162395E-08_JPRB, 0.52282041E-08_JPRB, 0.50166786E-08_JPRB, 0.47825153E-08_JPRB, &
  & 0.45289976E-08_JPRB, 0.42469361E-08_JPRB, 0.39414672E-08_JPRB, 0.36032051E-08_JPRB, 0.32324703E-08_JPRB, 0.28107512E-08_JPRB, &
  & 0.23209410E-08_JPRB, 0.18104828E-08_JPRB, 0.73221780E-08_JPRB, 0.50906794E-08_JPRB, 0.37989345E-08_JPRB, 0.30554266E-08_JPRB, &
  & 0.25335760E-08_JPRB, 0.21970696E-08_JPRB, 0.19768418E-08_JPRB, 0.18201146E-08_JPRB /)

RGHG4(:,16,11) = (/ &
  & 0.57715228E-08_JPRB, 0.58136336E-08_JPRB, 0.58420220E-08_JPRB, 0.58925314E-08_JPRB, 0.59709953E-08_JPRB, 0.60753615E-08_JPRB, &
  & 0.61974612E-08_JPRB, 0.63152172E-08_JPRB, 0.63963168E-08_JPRB, 0.64719412E-08_JPRB, 0.65338988E-08_JPRB, 0.65764918E-08_JPRB, &
  & 0.66097452E-08_JPRB, 0.66285524E-08_JPRB, 0.66433827E-08_JPRB, 0.66446186E-08_JPRB, 0.66401715E-08_JPRB, 0.66166495E-08_JPRB, &
  & 0.65815766E-08_JPRB, 0.65435333E-08_JPRB, 0.65175287E-08_JPRB, 0.64925119E-08_JPRB, 0.64820171E-08_JPRB, 0.64928956E-08_JPRB, &
  & 0.65274457E-08_JPRB, 0.65930896E-08_JPRB, 0.66646209E-08_JPRB, 0.67370651E-08_JPRB, 0.68122814E-08_JPRB, 0.68738979E-08_JPRB, &
  & 0.69200703E-08_JPRB, 0.69355943E-08_JPRB, 0.69307262E-08_JPRB, 0.68794184E-08_JPRB, 0.67920811E-08_JPRB, 0.66788668E-08_JPRB, &
  & 0.65501182E-08_JPRB, 0.64154295E-08_JPRB, 0.62819665E-08_JPRB, 0.61319154E-08_JPRB, 0.59750711E-08_JPRB, 0.58129936E-08_JPRB, &
  & 0.56480522E-08_JPRB, 0.54798575E-08_JPRB, 0.53078320E-08_JPRB, 0.51165219E-08_JPRB, 0.49061035E-08_JPRB, 0.46774562E-08_JPRB, &
  & 0.44322910E-08_JPRB, 0.41633910E-08_JPRB, 0.38737134E-08_JPRB, 0.35497940E-08_JPRB, 0.31813021E-08_JPRB, 0.27447857E-08_JPRB, &
  & 0.22080524E-08_JPRB, 0.17295545E-08_JPRB, 0.58071254E-08_JPRB, 0.39435126E-08_JPRB, 0.28661840E-08_JPRB, 0.22417515E-08_JPRB, &
  & 0.18030070E-08_JPRB, 0.15423699E-08_JPRB, 0.13518938E-08_JPRB, 0.12775199E-08_JPRB /)

RGHG4(:,17,11) = (/ &
  & 0.59022263E-08_JPRB, 0.59251271E-08_JPRB, 0.59433178E-08_JPRB, 0.59851013E-08_JPRB, 0.60563656E-08_JPRB, 0.61545542E-08_JPRB, &
  & 0.62691909E-08_JPRB, 0.63685088E-08_JPRB, 0.64029821E-08_JPRB, 0.64370536E-08_JPRB, 0.64611378E-08_JPRB, 0.64651902E-08_JPRB, &
  & 0.64584751E-08_JPRB, 0.64355050E-08_JPRB, 0.64075047E-08_JPRB, 0.63658847E-08_JPRB, 0.63194996E-08_JPRB, 0.62547034E-08_JPRB, &
  & 0.61817342E-08_JPRB, 0.61124386E-08_JPRB, 0.60638450E-08_JPRB, 0.60255050E-08_JPRB, 0.60121264E-08_JPRB, 0.60332335E-08_JPRB, &
  & 0.60903829E-08_JPRB, 0.61888445E-08_JPRB, 0.62980274E-08_JPRB, 0.64096337E-08_JPRB, 0.65093073E-08_JPRB, 0.65903154E-08_JPRB, &
  & 0.66382064E-08_JPRB, 0.66493260E-08_JPRB, 0.66238095E-08_JPRB, 0.65417498E-08_JPRB, 0.64185266E-08_JPRB, 0.62639560E-08_JPRB, &
  & 0.60960952E-08_JPRB, 0.59249579E-08_JPRB, 0.57626819E-08_JPRB, 0.55919220E-08_JPRB, 0.54257727E-08_JPRB, 0.52635918E-08_JPRB, &
  & 0.51068558E-08_JPRB, 0.49526649E-08_JPRB, 0.47986308E-08_JPRB, 0.46299737E-08_JPRB, 0.44463171E-08_JPRB, 0.42475694E-08_JPRB, &
  & 0.40360257E-08_JPRB, 0.38046184E-08_JPRB, 0.35511363E-08_JPRB, 0.32575640E-08_JPRB, 0.29111626E-08_JPRB, 0.24752100E-08_JPRB, &
  & 0.19764774E-08_JPRB, 0.15672882E-08_JPRB, 0.43166319E-08_JPRB, 0.28779161E-08_JPRB, 0.20540396E-08_JPRB, 0.15594651E-08_JPRB, &
  & 0.12402909E-08_JPRB, 0.10130027E-08_JPRB, 0.87335644E-09_JPRB, 0.77871015E-09_JPRB /)

RGHG4(:,18,11) = (/ &
  & 0.58062875E-08_JPRB, 0.57984075E-08_JPRB, 0.57969824E-08_JPRB, 0.58212746E-08_JPRB, 0.58761120E-08_JPRB, 0.59572325E-08_JPRB, &
  & 0.60498992E-08_JPRB, 0.61160548E-08_JPRB, 0.60893557E-08_JPRB, 0.60684182E-08_JPRB, 0.60431402E-08_JPRB, 0.60018386E-08_JPRB, &
  & 0.59517857E-08_JPRB, 0.58861884E-08_JPRB, 0.58160228E-08_JPRB, 0.57331353E-08_JPRB, 0.56475442E-08_JPRB, 0.55499476E-08_JPRB, &
  & 0.54493086E-08_JPRB, 0.53578906E-08_JPRB, 0.52928466E-08_JPRB, 0.52472480E-08_JPRB, 0.52353761E-08_JPRB, 0.52660059E-08_JPRB, &
  & 0.53388178E-08_JPRB, 0.54521720E-08_JPRB, 0.55735536E-08_JPRB, 0.56912879E-08_JPRB, 0.57953167E-08_JPRB, 0.58692220E-08_JPRB, &
  & 0.59104557E-08_JPRB, 0.59046026E-08_JPRB, 0.58616649E-08_JPRB, 0.57627147E-08_JPRB, 0.56240355E-08_JPRB, 0.54559650E-08_JPRB, &
  & 0.52708571E-08_JPRB, 0.50884803E-08_JPRB, 0.49181113E-08_JPRB, 0.47535011E-08_JPRB, 0.45994191E-08_JPRB, 0.44570161E-08_JPRB, &
  & 0.43243600E-08_JPRB, 0.41980961E-08_JPRB, 0.40736743E-08_JPRB, 0.39387902E-08_JPRB, 0.37923606E-08_JPRB, 0.36340506E-08_JPRB, &
  & 0.34660272E-08_JPRB, 0.32787464E-08_JPRB, 0.30649845E-08_JPRB, 0.28051361E-08_JPRB, 0.24774527E-08_JPRB, 0.20616076E-08_JPRB, &
  & 0.16696088E-08_JPRB, 0.13332843E-08_JPRB, 0.29747447E-08_JPRB, 0.19290118E-08_JPRB, 0.13181807E-08_JPRB, 0.96386032E-09_JPRB, &
  & 0.75475404E-09_JPRB, 0.60706645E-09_JPRB, 0.52168586E-09_JPRB, 0.47551174E-09_JPRB /)

RGHG4(:,19,11) = (/ &
  & 0.55332805E-08_JPRB, 0.54851128E-08_JPRB, 0.54597975E-08_JPRB, 0.54624691E-08_JPRB, 0.54969540E-08_JPRB, 0.55561404E-08_JPRB, &
  & 0.56209841E-08_JPRB, 0.56475895E-08_JPRB, 0.55589253E-08_JPRB, 0.54840577E-08_JPRB, 0.54119682E-08_JPRB, 0.53290115E-08_JPRB, &
  & 0.52413620E-08_JPRB, 0.51413744E-08_JPRB, 0.50389990E-08_JPRB, 0.49277555E-08_JPRB, 0.48161413E-08_JPRB, 0.46939133E-08_JPRB, &
  & 0.45740247E-08_JPRB, 0.44680091E-08_JPRB, 0.43909814E-08_JPRB, 0.43386796E-08_JPRB, 0.43248836E-08_JPRB, 0.43547055E-08_JPRB, &
  & 0.44257131E-08_JPRB, 0.45336908E-08_JPRB, 0.46424589E-08_JPRB, 0.47425130E-08_JPRB, 0.48206932E-08_JPRB, 0.48745874E-08_JPRB, &
  & 0.48867994E-08_JPRB, 0.48635900E-08_JPRB, 0.48117812E-08_JPRB, 0.47161355E-08_JPRB, 0.45865183E-08_JPRB, 0.44356696E-08_JPRB, &
  & 0.42717518E-08_JPRB, 0.41071568E-08_JPRB, 0.39544239E-08_JPRB, 0.38105488E-08_JPRB, 0.36833927E-08_JPRB, 0.35704488E-08_JPRB, &
  & 0.34695429E-08_JPRB, 0.33751233E-08_JPRB, 0.32840204E-08_JPRB, 0.31851053E-08_JPRB, 0.30775931E-08_JPRB, 0.29602902E-08_JPRB, &
  & 0.28320029E-08_JPRB, 0.26818785E-08_JPRB, 0.24998146E-08_JPRB, 0.22655979E-08_JPRB, 0.19777047E-08_JPRB, 0.16464495E-08_JPRB, &
  & 0.13397432E-08_JPRB, 0.10516668E-08_JPRB, 0.19593354E-08_JPRB, 0.12558506E-08_JPRB, 0.84918306E-09_JPRB, 0.60787836E-09_JPRB, &
  & 0.46719217E-09_JPRB, 0.36366912E-09_JPRB, 0.29752498E-09_JPRB, 0.24896782E-09_JPRB /)

RGHG4(:,20,11) = (/ &
  & 0.51069691E-08_JPRB, 0.50276627E-08_JPRB, 0.49816000E-08_JPRB, 0.49659876E-08_JPRB, 0.49797455E-08_JPRB, 0.50153877E-08_JPRB, &
  & 0.50491749E-08_JPRB, 0.50370930E-08_JPRB, 0.48997322E-08_JPRB, 0.47833719E-08_JPRB, 0.46771698E-08_JPRB, 0.45653858E-08_JPRB, &
  & 0.44521706E-08_JPRB, 0.43305102E-08_JPRB, 0.42074078E-08_JPRB, 0.40773456E-08_JPRB, 0.39517247E-08_JPRB, 0.38241685E-08_JPRB, &
  & 0.37016159E-08_JPRB, 0.35933798E-08_JPRB, 0.35131185E-08_JPRB, 0.34567575E-08_JPRB, 0.34364562E-08_JPRB, 0.34550987E-08_JPRB, &
  & 0.35076446E-08_JPRB, 0.35863190E-08_JPRB, 0.36608956E-08_JPRB, 0.37250967E-08_JPRB, 0.37677910E-08_JPRB, 0.37848138E-08_JPRB, &
  & 0.37771692E-08_JPRB, 0.37451691E-08_JPRB, 0.36974868E-08_JPRB, 0.36229002E-08_JPRB, 0.35271599E-08_JPRB, 0.34133294E-08_JPRB, &
  & 0.32863410E-08_JPRB, 0.31555181E-08_JPRB, 0.30408212E-08_JPRB, 0.29232170E-08_JPRB, 0.28270402E-08_JPRB, 0.27427107E-08_JPRB, &
  & 0.26704949E-08_JPRB, 0.26038152E-08_JPRB, 0.25406375E-08_JPRB, 0.24722611E-08_JPRB, 0.23964741E-08_JPRB, 0.23109152E-08_JPRB, &
  & 0.22111397E-08_JPRB, 0.20867623E-08_JPRB, 0.19289090E-08_JPRB, 0.17293162E-08_JPRB, 0.14923237E-08_JPRB, 0.12568243E-08_JPRB, &
  & 0.10178678E-08_JPRB, 0.80654411E-09_JPRB, 0.12544992E-08_JPRB, 0.77724810E-09_JPRB, 0.50125537E-09_JPRB, 0.34476874E-09_JPRB, &
  & 0.26725902E-09_JPRB, 0.20197254E-09_JPRB, 0.16212150E-09_JPRB, 0.13839276E-09_JPRB /)

RGHG4(:,21,11) = (/ &
  & 0.46260822E-08_JPRB, 0.45220512E-08_JPRB, 0.44616804E-08_JPRB, 0.44313153E-08_JPRB, 0.44273145E-08_JPRB, 0.44405728E-08_JPRB, &
  & 0.44464805E-08_JPRB, 0.44027080E-08_JPRB, 0.42347161E-08_JPRB, 0.40933692E-08_JPRB, 0.39681893E-08_JPRB, 0.38425769E-08_JPRB, &
  & 0.37181327E-08_JPRB, 0.35893430E-08_JPRB, 0.34629075E-08_JPRB, 0.33320064E-08_JPRB, 0.32024989E-08_JPRB, 0.30700860E-08_JPRB, &
  & 0.29436045E-08_JPRB, 0.28322971E-08_JPRB, 0.27464682E-08_JPRB, 0.26829319E-08_JPRB, 0.26504445E-08_JPRB, 0.26500782E-08_JPRB, &
  & 0.26769209E-08_JPRB, 0.27224309E-08_JPRB, 0.27621005E-08_JPRB, 0.27890059E-08_JPRB, 0.27995612E-08_JPRB, 0.27936187E-08_JPRB, &
  & 0.27724674E-08_JPRB, 0.27421754E-08_JPRB, 0.27089000E-08_JPRB, 0.26615496E-08_JPRB, 0.26020874E-08_JPRB, 0.25299571E-08_JPRB, &
  & 0.24435145E-08_JPRB, 0.23544322E-08_JPRB, 0.22619000E-08_JPRB, 0.21808531E-08_JPRB, 0.21040889E-08_JPRB, 0.20435122E-08_JPRB, &
  & 0.19870814E-08_JPRB, 0.19330426E-08_JPRB, 0.18858259E-08_JPRB, 0.18360550E-08_JPRB, 0.17829407E-08_JPRB, 0.17232349E-08_JPRB, &
  & 0.16507966E-08_JPRB, 0.15564341E-08_JPRB, 0.14304341E-08_JPRB, 0.12723855E-08_JPRB, 0.11129667E-08_JPRB, 0.94855079E-09_JPRB, &
  & 0.76929868E-09_JPRB, 0.59180616E-09_JPRB, 0.80704893E-09_JPRB, 0.49430243E-09_JPRB, 0.30996411E-09_JPRB, 0.21019372E-09_JPRB, &
  & 0.15977274E-09_JPRB, 0.11754454E-09_JPRB, 0.91743092E-10_JPRB, 0.70113117E-10_JPRB /)

RGHG4(:,22,11) = (/ &
  & 0.41136246E-08_JPRB, 0.39887653E-08_JPRB, 0.39219819E-08_JPRB, 0.38812060E-08_JPRB, 0.38628314E-08_JPRB, 0.38571004E-08_JPRB, &
  & 0.38401406E-08_JPRB, 0.37752947E-08_JPRB, 0.35991881E-08_JPRB, 0.34500349E-08_JPRB, 0.33203398E-08_JPRB, 0.31936134E-08_JPRB, &
  & 0.30690608E-08_JPRB, 0.29412961E-08_JPRB, 0.28135951E-08_JPRB, 0.26837523E-08_JPRB, 0.25583675E-08_JPRB, 0.24326601E-08_JPRB, &
  & 0.23116364E-08_JPRB, 0.22054107E-08_JPRB, 0.21193760E-08_JPRB, 0.20493278E-08_JPRB, 0.20012574E-08_JPRB, 0.19771116E-08_JPRB, &
  & 0.19735389E-08_JPRB, 0.19836011E-08_JPRB, 0.19908271E-08_JPRB, 0.19901747E-08_JPRB, 0.19812534E-08_JPRB, 0.19643138E-08_JPRB, &
  & 0.19430022E-08_JPRB, 0.19220017E-08_JPRB, 0.19049069E-08_JPRB, 0.18812802E-08_JPRB, 0.18489293E-08_JPRB, 0.18081555E-08_JPRB, &
  & 0.17540061E-08_JPRB, 0.16920157E-08_JPRB, 0.16348036E-08_JPRB, 0.15739079E-08_JPRB, 0.15213838E-08_JPRB, 0.14776859E-08_JPRB, &
  & 0.14438097E-08_JPRB, 0.14136534E-08_JPRB, 0.13873956E-08_JPRB, 0.13608087E-08_JPRB, 0.13285556E-08_JPRB, 0.12886240E-08_JPRB, &
  & 0.12358852E-08_JPRB, 0.11639086E-08_JPRB, 0.10679482E-08_JPRB, 0.95861674E-09_JPRB, 0.84289653E-09_JPRB, 0.71516082E-09_JPRB, &
  & 0.57452226E-09_JPRB, 0.44696430E-09_JPRB, 0.54288646E-09_JPRB, 0.32420994E-09_JPRB, 0.19861603E-09_JPRB, 0.13075757E-09_JPRB, &
  & 0.95803490E-10_JPRB, 0.66825788E-10_JPRB, 0.48477378E-10_JPRB, 0.39490581E-10_JPRB /)

RGHG4(:,23,11) = (/ &
  & 0.36564134E-08_JPRB, 0.35173988E-08_JPRB, 0.34449741E-08_JPRB, 0.33954148E-08_JPRB, 0.33653447E-08_JPRB, 0.33443068E-08_JPRB, &
  & 0.33118412E-08_JPRB, 0.32358998E-08_JPRB, 0.30641374E-08_JPRB, 0.29181404E-08_JPRB, 0.27914704E-08_JPRB, 0.26698788E-08_JPRB, &
  & 0.25499629E-08_JPRB, 0.24285634E-08_JPRB, 0.23086808E-08_JPRB, 0.21871569E-08_JPRB, 0.20712774E-08_JPRB, 0.19571162E-08_JPRB, &
  & 0.18482351E-08_JPRB, 0.17480805E-08_JPRB, 0.16609821E-08_JPRB, 0.15850887E-08_JPRB, 0.15247573E-08_JPRB, 0.14814830E-08_JPRB, &
  & 0.14547084E-08_JPRB, 0.14398333E-08_JPRB, 0.14263390E-08_JPRB, 0.14113006E-08_JPRB, 0.13945861E-08_JPRB, 0.13777005E-08_JPRB, &
  & 0.13623584E-08_JPRB, 0.13510183E-08_JPRB, 0.13448580E-08_JPRB, 0.13371568E-08_JPRB, 0.13233665E-08_JPRB, 0.13037558E-08_JPRB, &
  & 0.12730451E-08_JPRB, 0.12369604E-08_JPRB, 0.11965585E-08_JPRB, 0.11547931E-08_JPRB, 0.11208527E-08_JPRB, 0.10912227E-08_JPRB, &
  & 0.10689898E-08_JPRB, 0.10529999E-08_JPRB, 0.10386899E-08_JPRB, 0.10243583E-08_JPRB, 0.10057986E-08_JPRB, 0.97897690E-09_JPRB, &
  & 0.94064567E-09_JPRB, 0.88576274E-09_JPRB, 0.81641666E-09_JPRB, 0.74141454E-09_JPRB, 0.65884181E-09_JPRB, 0.56125232E-09_JPRB, &
  & 0.45044127E-09_JPRB, 0.34834718E-09_JPRB, 0.38068185E-09_JPRB, 0.21916498E-09_JPRB, 0.12792627E-09_JPRB, 0.82896884E-10_JPRB, &
  & 0.54099985E-10_JPRB, 0.38031488E-10_JPRB, 0.30136959E-10_JPRB, 0.20754058E-10_JPRB /)

RGHG4(:,24,11) = (/ &
  & 0.32488401E-08_JPRB, 0.31042677E-08_JPRB, 0.30271099E-08_JPRB, 0.29716447E-08_JPRB, 0.29328284E-08_JPRB, 0.29009213E-08_JPRB, &
  & 0.28590872E-08_JPRB, 0.27797171E-08_JPRB, 0.26198994E-08_JPRB, 0.24825619E-08_JPRB, 0.23633444E-08_JPRB, 0.22496474E-08_JPRB, &
  & 0.21380167E-08_JPRB, 0.20243118E-08_JPRB, 0.19150170E-08_JPRB, 0.18074240E-08_JPRB, 0.17037828E-08_JPRB, 0.16013184E-08_JPRB, &
  & 0.15021994E-08_JPRB, 0.14083115E-08_JPRB, 0.13220908E-08_JPRB, 0.12431082E-08_JPRB, 0.11752019E-08_JPRB, 0.11203641E-08_JPRB, &
  & 0.10796892E-08_JPRB, 0.10501244E-08_JPRB, 0.10260703E-08_JPRB, 0.10056976E-08_JPRB, 0.98838659E-09_JPRB, 0.97437269E-09_JPRB, &
  & 0.96450536E-09_JPRB, 0.95979036E-09_JPRB, 0.95977848E-09_JPRB, 0.96017050E-09_JPRB, 0.95723562E-09_JPRB, 0.94844521E-09_JPRB, &
  & 0.93324037E-09_JPRB, 0.91163843E-09_JPRB, 0.88728425E-09_JPRB, 0.86169333E-09_JPRB, 0.83777374E-09_JPRB, 0.81941309E-09_JPRB, &
  & 0.80566598E-09_JPRB, 0.79785600E-09_JPRB, 0.79249013E-09_JPRB, 0.78641293E-09_JPRB, 0.77688694E-09_JPRB, 0.76000789E-09_JPRB, &
  & 0.73368123E-09_JPRB, 0.69315065E-09_JPRB, 0.64619721E-09_JPRB, 0.59097410E-09_JPRB, 0.52319293E-09_JPRB, 0.44620299E-09_JPRB, &
  & 0.35609948E-09_JPRB, 0.27140906E-09_JPRB, 0.27017449E-09_JPRB, 0.15109844E-09_JPRB, 0.85670901E-10_JPRB, 0.53707358E-10_JPRB, &
  & 0.31493270E-10_JPRB, 0.22415217E-10_JPRB, 0.13819407E-10_JPRB, 0.11672214E-10_JPRB /)

RGHG4(:,25,11) = (/ &
  & 0.29170042E-08_JPRB, 0.27735598E-08_JPRB, 0.26920572E-08_JPRB, 0.26314722E-08_JPRB, 0.25850506E-08_JPRB, 0.25445599E-08_JPRB, &
  & 0.24960303E-08_JPRB, 0.24156408E-08_JPRB, 0.22677282E-08_JPRB, 0.21395159E-08_JPRB, 0.20279411E-08_JPRB, 0.19224677E-08_JPRB, &
  & 0.18225539E-08_JPRB, 0.17240204E-08_JPRB, 0.16278763E-08_JPRB, 0.15320933E-08_JPRB, 0.14378569E-08_JPRB, 0.13432444E-08_JPRB, &
  & 0.12509436E-08_JPRB, 0.11618847E-08_JPRB, 0.10773828E-08_JPRB, 0.99789299E-09_JPRB, 0.92718777E-09_JPRB, 0.86719010E-09_JPRB, &
  & 0.81953355E-09_JPRB, 0.78292156E-09_JPRB, 0.75403450E-09_JPRB, 0.73177808E-09_JPRB, 0.71539163E-09_JPRB, 0.70428785E-09_JPRB, &
  & 0.69833167E-09_JPRB, 0.69714828E-09_JPRB, 0.69972628E-09_JPRB, 0.70280576E-09_JPRB, 0.70459683E-09_JPRB, 0.70217521E-09_JPRB, &
  & 0.69462924E-09_JPRB, 0.68333467E-09_JPRB, 0.66857714E-09_JPRB, 0.65303485E-09_JPRB, 0.63884237E-09_JPRB, 0.62801692E-09_JPRB, &
  & 0.62123051E-09_JPRB, 0.61879385E-09_JPRB, 0.61900862E-09_JPRB, 0.61868421E-09_JPRB, 0.61531397E-09_JPRB, 0.60539923E-09_JPRB, &
  & 0.58736344E-09_JPRB, 0.55860799E-09_JPRB, 0.52337973E-09_JPRB, 0.48016990E-09_JPRB, 0.42560791E-09_JPRB, 0.36345219E-09_JPRB, &
  & 0.29110775E-09_JPRB, 0.22200922E-09_JPRB, 0.20883478E-09_JPRB, 0.11508228E-09_JPRB, 0.63700038E-10_JPRB, 0.35431404E-10_JPRB, &
  & 0.20241335E-10_JPRB, 0.12027589E-10_JPRB, 0.84705697E-11_JPRB, 0.59240243E-11_JPRB /)

RGHG4(:,26,11) = (/ &
  & 0.26470652E-08_JPRB, 0.25005904E-08_JPRB, 0.24137443E-08_JPRB, 0.23479136E-08_JPRB, 0.22961153E-08_JPRB, 0.22501045E-08_JPRB, &
  & 0.21981486E-08_JPRB, 0.21191868E-08_JPRB, 0.19831023E-08_JPRB, 0.18648902E-08_JPRB, 0.17635107E-08_JPRB, 0.16700522E-08_JPRB, &
  & 0.15812922E-08_JPRB, 0.14932569E-08_JPRB, 0.14066831E-08_JPRB, 0.13203071E-08_JPRB, 0.12348041E-08_JPRB, 0.11484249E-08_JPRB, &
  & 0.10626725E-08_JPRB, 0.97860631E-09_JPRB, 0.89747726E-09_JPRB, 0.82015111E-09_JPRB, 0.75017292E-09_JPRB, 0.68939698E-09_JPRB, &
  & 0.63962113E-09_JPRB, 0.60041533E-09_JPRB, 0.56964800E-09_JPRB, 0.54694710E-09_JPRB, 0.53133026E-09_JPRB, 0.52197213E-09_JPRB, &
  & 0.51781252E-09_JPRB, 0.51766275E-09_JPRB, 0.52048804E-09_JPRB, 0.52366178E-09_JPRB, 0.52670945E-09_JPRB, 0.52737281E-09_JPRB, &
  & 0.52460042E-09_JPRB, 0.51884275E-09_JPRB, 0.51125248E-09_JPRB, 0.50279531E-09_JPRB, 0.49515603E-09_JPRB, 0.49020049E-09_JPRB, &
  & 0.48838150E-09_JPRB, 0.48993770E-09_JPRB, 0.49361237E-09_JPRB, 0.49687543E-09_JPRB, 0.49733495E-09_JPRB, 0.49235938E-09_JPRB, &
  & 0.47924448E-09_JPRB, 0.45977999E-09_JPRB, 0.43290696E-09_JPRB, 0.39589576E-09_JPRB, 0.35127654E-09_JPRB, 0.29581831E-09_JPRB, &
  & 0.23855004E-09_JPRB, 0.18069739E-09_JPRB, 0.15956288E-09_JPRB, 0.86491474E-10_JPRB, 0.47927884E-10_JPRB, 0.27808377E-10_JPRB, &
  & 0.15643349E-10_JPRB, 0.89142244E-11_JPRB, 0.45394955E-11_JPRB, 0.29544253E-11_JPRB /)

RGHG4(:,27,11) = (/ &
  & 0.24108313E-08_JPRB, 0.22566899E-08_JPRB, 0.21659743E-08_JPRB, 0.20971402E-08_JPRB, 0.20437594E-08_JPRB, 0.19963555E-08_JPRB, &
  & 0.19457222E-08_JPRB, 0.18723874E-08_JPRB, 0.17514129E-08_JPRB, 0.16451260E-08_JPRB, 0.15533331E-08_JPRB, 0.14681629E-08_JPRB, &
  & 0.13870393E-08_JPRB, 0.13066336E-08_JPRB, 0.12274612E-08_JPRB, 0.11481239E-08_JPRB, 0.10697461E-08_JPRB, 0.99082487E-09_JPRB, &
  & 0.91197488E-09_JPRB, 0.83393170E-09_JPRB, 0.75824236E-09_JPRB, 0.68517997E-09_JPRB, 0.61861605E-09_JPRB, 0.55984140E-09_JPRB, &
  & 0.51074261E-09_JPRB, 0.47164961E-09_JPRB, 0.44076648E-09_JPRB, 0.41823792E-09_JPRB, 0.40302833E-09_JPRB, 0.39433137E-09_JPRB, &
  & 0.39060566E-09_JPRB, 0.39029191E-09_JPRB, 0.39239878E-09_JPRB, 0.39494047E-09_JPRB, 0.39760184E-09_JPRB, 0.39943623E-09_JPRB, &
  & 0.39915793E-09_JPRB, 0.39707848E-09_JPRB, 0.39435788E-09_JPRB, 0.39091011E-09_JPRB, 0.38831643E-09_JPRB, 0.38754755E-09_JPRB, &
  & 0.38939918E-09_JPRB, 0.39394488E-09_JPRB, 0.40022291E-09_JPRB, 0.40607678E-09_JPRB, 0.40904338E-09_JPRB, 0.40727938E-09_JPRB, &
  & 0.39896145E-09_JPRB, 0.38478579E-09_JPRB, 0.36374351E-09_JPRB, 0.33354955E-09_JPRB, 0.29606578E-09_JPRB, 0.24844138E-09_JPRB, &
  & 0.19597414E-09_JPRB, 0.14691423E-09_JPRB, 0.12796691E-09_JPRB, 0.69992158E-10_JPRB, 0.38285746E-10_JPRB, 0.20536099E-10_JPRB, &
  & 0.12299973E-10_JPRB, 0.66264984E-11_JPRB, 0.44188589E-11_JPRB, 0.20069311E-11_JPRB /)

RGHG4(:,28,11) = (/ &
  & 0.22015363E-08_JPRB, 0.20400597E-08_JPRB, 0.19467015E-08_JPRB, 0.18768243E-08_JPRB, 0.18233963E-08_JPRB, 0.17773716E-08_JPRB, &
  & 0.17304282E-08_JPRB, 0.16645958E-08_JPRB, 0.15583633E-08_JPRB, 0.14628522E-08_JPRB, 0.13794134E-08_JPRB, 0.13020235E-08_JPRB, &
  & 0.12277737E-08_JPRB, 0.11539258E-08_JPRB, 0.10813014E-08_JPRB, 0.10083994E-08_JPRB, 0.93610608E-09_JPRB, 0.86319829E-09_JPRB, &
  & 0.79040607E-09_JPRB, 0.71830913E-09_JPRB, 0.64822225E-09_JPRB, 0.58053895E-09_JPRB, 0.51841648E-09_JPRB, 0.46339324E-09_JPRB, &
  & 0.41678483E-09_JPRB, 0.37927980E-09_JPRB, 0.34922321E-09_JPRB, 0.32694641E-09_JPRB, 0.31169586E-09_JPRB, 0.30287461E-09_JPRB, &
  & 0.29871586E-09_JPRB, 0.29771047E-09_JPRB, 0.29868658E-09_JPRB, 0.30035005E-09_JPRB, 0.30218802E-09_JPRB, 0.30405081E-09_JPRB, &
  & 0.30513334E-09_JPRB, 0.30536923E-09_JPRB, 0.30569219E-09_JPRB, 0.30593558E-09_JPRB, 0.30715827E-09_JPRB, 0.30992986E-09_JPRB, &
  & 0.31476083E-09_JPRB, 0.32165903E-09_JPRB, 0.32983688E-09_JPRB, 0.33737771E-09_JPRB, 0.34244099E-09_JPRB, 0.34324305E-09_JPRB, &
  & 0.33939826E-09_JPRB, 0.32913872E-09_JPRB, 0.31112088E-09_JPRB, 0.28473085E-09_JPRB, 0.25199601E-09_JPRB, 0.21075332E-09_JPRB, &
  & 0.16532584E-09_JPRB, 0.12282397E-09_JPRB, 0.10196753E-09_JPRB, 0.55153052E-10_JPRB, 0.30247440E-10_JPRB, 0.17386148E-10_JPRB, &
  & 0.91688324E-11_JPRB, 0.62820808E-11_JPRB, 0.33888782E-11_JPRB, 0.17700937E-11_JPRB /)

RGHG4(:,29,11) = (/ &
  & 0.19920818E-08_JPRB, 0.18261810E-08_JPRB, 0.17327003E-08_JPRB, 0.16654041E-08_JPRB, 0.16145253E-08_JPRB, 0.15721255E-08_JPRB, &
  & 0.15297210E-08_JPRB, 0.14721956E-08_JPRB, 0.13811530E-08_JPRB, 0.12977540E-08_JPRB, 0.12234698E-08_JPRB, 0.11538679E-08_JPRB, &
  & 0.10861509E-08_JPRB, 0.10189978E-08_JPRB, 0.95208941E-09_JPRB, 0.88506841E-09_JPRB, 0.81851270E-09_JPRB, 0.75177176E-09_JPRB, &
  & 0.68504058E-09_JPRB, 0.61890310E-09_JPRB, 0.55442345E-09_JPRB, 0.49241411E-09_JPRB, 0.43541076E-09_JPRB, 0.38497094E-09_JPRB, &
  & 0.34183875E-09_JPRB, 0.30672770E-09_JPRB, 0.27836000E-09_JPRB, 0.25685293E-09_JPRB, 0.24183136E-09_JPRB, 0.23278653E-09_JPRB, &
  & 0.22813797E-09_JPRB, 0.22639041E-09_JPRB, 0.22624978E-09_JPRB, 0.22710368E-09_JPRB, 0.22816268E-09_JPRB, 0.22989929E-09_JPRB, &
  & 0.23161385E-09_JPRB, 0.23342703E-09_JPRB, 0.23567884E-09_JPRB, 0.23856456E-09_JPRB, 0.24251179E-09_JPRB, 0.24807653E-09_JPRB, &
  & 0.25523084E-09_JPRB, 0.26408739E-09_JPRB, 0.27378408E-09_JPRB, 0.28277625E-09_JPRB, 0.28944688E-09_JPRB, 0.29205005E-09_JPRB, &
  & 0.28907057E-09_JPRB, 0.28005620E-09_JPRB, 0.26441674E-09_JPRB, 0.24286878E-09_JPRB, 0.21298270E-09_JPRB, 0.17952839E-09_JPRB, &
  & 0.14112973E-09_JPRB, 0.10496020E-09_JPRB, 0.85982506E-10_JPRB, 0.48154310E-10_JPRB, 0.27388175E-10_JPRB, 0.15659174E-10_JPRB, &
  & 0.90951526E-11_JPRB, 0.52571710E-11_JPRB, 0.30645291E-11_JPRB, 0.15852870E-11_JPRB /)

RGHG4(:,30,11) = (/ &
  & 0.17902290E-08_JPRB, 0.16208715E-08_JPRB, 0.15326708E-08_JPRB, 0.14715429E-08_JPRB, 0.14258473E-08_JPRB, 0.13885130E-08_JPRB, &
  & 0.13516661E-08_JPRB, 0.13020205E-08_JPRB, 0.12247430E-08_JPRB, 0.11521668E-08_JPRB, 0.10864678E-08_JPRB, 0.10241117E-08_JPRB, &
  & 0.96275288E-09_JPRB, 0.90150870E-09_JPRB, 0.83979673E-09_JPRB, 0.77764589E-09_JPRB, 0.71596301E-09_JPRB, 0.65435324E-09_JPRB, &
  & 0.59323196E-09_JPRB, 0.53280025E-09_JPRB, 0.47423293E-09_JPRB, 0.41826981E-09_JPRB, 0.36672315E-09_JPRB, 0.32087372E-09_JPRB, &
  & 0.28170330E-09_JPRB, 0.24949992E-09_JPRB, 0.22336194E-09_JPRB, 0.20298088E-09_JPRB, 0.18839381E-09_JPRB, 0.17904805E-09_JPRB, &
  & 0.17373311E-09_JPRB, 0.17130025E-09_JPRB, 0.17029969E-09_JPRB, 0.17047472E-09_JPRB, 0.17085991E-09_JPRB, 0.17242459E-09_JPRB, &
  & 0.17429393E-09_JPRB, 0.17717312E-09_JPRB, 0.18072563E-09_JPRB, 0.18565637E-09_JPRB, 0.19165045E-09_JPRB, 0.19942931E-09_JPRB, &
  & 0.20836891E-09_JPRB, 0.21876558E-09_JPRB, 0.22950472E-09_JPRB, 0.23955291E-09_JPRB, 0.24719549E-09_JPRB, 0.25098068E-09_JPRB, &
  & 0.25019989E-09_JPRB, 0.24412450E-09_JPRB, 0.23098810E-09_JPRB, 0.21157089E-09_JPRB, 0.18494985E-09_JPRB, 0.15570036E-09_JPRB, &
  & 0.12205795E-09_JPRB, 0.90153530E-10_JPRB, 0.71928102E-10_JPRB, 0.39895011E-10_JPRB, 0.22274424E-10_JPRB, 0.12461207E-10_JPRB, &
  & 0.64777962E-11_JPRB, 0.46560950E-11_JPRB, 0.27084901E-11_JPRB, 0.13257331E-11_JPRB /)

RGHG4(:,31,11) = (/ &
  & 0.15696259E-08_JPRB, 0.14124883E-08_JPRB, 0.13356405E-08_JPRB, 0.12841731E-08_JPRB, 0.12470721E-08_JPRB, 0.12161763E-08_JPRB, &
  & 0.11858939E-08_JPRB, 0.11441139E-08_JPRB, 0.10793619E-08_JPRB, 0.10172967E-08_JPRB, 0.95988062E-09_JPRB, 0.90450825E-09_JPRB, &
  & 0.84928836E-09_JPRB, 0.79349161E-09_JPRB, 0.73673895E-09_JPRB, 0.67931505E-09_JPRB, 0.62206790E-09_JPRB, 0.56500049E-09_JPRB, &
  & 0.50866783E-09_JPRB, 0.45379198E-09_JPRB, 0.40088621E-09_JPRB, 0.35069025E-09_JPRB, 0.30447858E-09_JPRB, 0.26360844E-09_JPRB, &
  & 0.22878399E-09_JPRB, 0.20011499E-09_JPRB, 0.17667404E-09_JPRB, 0.15800600E-09_JPRB, 0.14426554E-09_JPRB, 0.13499118E-09_JPRB, &
  & 0.12940286E-09_JPRB, 0.12651735E-09_JPRB, 0.12501519E-09_JPRB, 0.12466808E-09_JPRB, 0.12470502E-09_JPRB, 0.12606820E-09_JPRB, &
  & 0.12798948E-09_JPRB, 0.13139431E-09_JPRB, 0.13576799E-09_JPRB, 0.14192196E-09_JPRB, 0.14936823E-09_JPRB, 0.15871533E-09_JPRB, &
  & 0.16909472E-09_JPRB, 0.18076139E-09_JPRB, 0.19250973E-09_JPRB, 0.20354558E-09_JPRB, 0.21197601E-09_JPRB, 0.21669606E-09_JPRB, &
  & 0.21682829E-09_JPRB, 0.21117287E-09_JPRB, 0.19929246E-09_JPRB, 0.18263999E-09_JPRB, 0.16015485E-09_JPRB, 0.13500975E-09_JPRB, &
  & 0.10586938E-09_JPRB, 0.77802285E-10_JPRB, 0.60395917E-10_JPRB, 0.32819799E-10_JPRB, 0.16990891E-10_JPRB, 0.94788023E-11_JPRB, &
  & 0.61088912E-11_JPRB, 0.34862983E-11_JPRB, 0.19743614E-11_JPRB, 0.11394951E-11_JPRB /)

RGHG4(:,32,11) = (/ &
  & 0.13635922E-08_JPRB, 0.12276661E-08_JPRB, 0.11634173E-08_JPRB, 0.11216675E-08_JPRB, 0.10919697E-08_JPRB, 0.10672029E-08_JPRB, &
  & 0.10425079E-08_JPRB, 0.10073286E-08_JPRB, 0.95254260E-09_JPRB, 0.89889235E-09_JPRB, 0.84843060E-09_JPRB, 0.79914625E-09_JPRB, &
  & 0.74936568E-09_JPRB, 0.69836348E-09_JPRB, 0.64612032E-09_JPRB, 0.59281058E-09_JPRB, 0.53952531E-09_JPRB, 0.48667687E-09_JPRB, &
  & 0.43505152E-09_JPRB, 0.38515646E-09_JPRB, 0.33770195E-09_JPRB, 0.29306918E-09_JPRB, 0.25207803E-09_JPRB, 0.21582318E-09_JPRB, &
  & 0.18487950E-09_JPRB, 0.15922343E-09_JPRB, 0.13839520E-09_JPRB, 0.12164975E-09_JPRB, 0.10899601E-09_JPRB, 0.10003889E-09_JPRB, &
  & 0.94359166E-10_JPRB, 0.91149553E-10_JPRB, 0.89415572E-10_JPRB, 0.88679307E-10_JPRB, 0.88728545E-10_JPRB, 0.89942082E-10_JPRB, &
  & 0.92103408E-10_JPRB, 0.95783270E-10_JPRB, 0.10079153E-09_JPRB, 0.10762660E-09_JPRB, 0.11601789E-09_JPRB, 0.12615159E-09_JPRB, &
  & 0.13746963E-09_JPRB, 0.14985911E-09_JPRB, 0.16224641E-09_JPRB, 0.17380010E-09_JPRB, 0.18258095E-09_JPRB, 0.18768372E-09_JPRB, &
  & 0.18830659E-09_JPRB, 0.18357692E-09_JPRB, 0.17425754E-09_JPRB, 0.16012040E-09_JPRB, 0.14050901E-09_JPRB, 0.11845849E-09_JPRB, &
  & 0.92934084E-10_JPRB, 0.67837000E-10_JPRB, 0.51136921E-10_JPRB, 0.26971293E-10_JPRB, 0.14434076E-10_JPRB, 0.90597382E-11_JPRB, &
  & 0.53495723E-11_JPRB, 0.31758918E-11_JPRB, 0.18783965E-11_JPRB, 0.92719137E-12_JPRB /)

RGHG4(:,33,11) = (/ &
  & 0.11811148E-08_JPRB, 0.10688670E-08_JPRB, 0.10161219E-08_JPRB, 0.98198649E-09_JPRB, 0.95828678E-09_JPRB, 0.93781527E-09_JPRB, &
  & 0.91672564E-09_JPRB, 0.88638302E-09_JPRB, 0.83901208E-09_JPRB, 0.79216927E-09_JPRB, 0.74758799E-09_JPRB, 0.70361378E-09_JPRB, &
  & 0.65861272E-09_JPRB, 0.61201622E-09_JPRB, 0.56367577E-09_JPRB, 0.51426324E-09_JPRB, 0.46442505E-09_JPRB, 0.41506296E-09_JPRB, &
  & 0.36744213E-09_JPRB, 0.32208863E-09_JPRB, 0.27954428E-09_JPRB, 0.23989516E-09_JPRB, 0.20387939E-09_JPRB, 0.17215135E-09_JPRB, &
  & 0.14525095E-09_JPRB, 0.12304381E-09_JPRB, 0.10494700E-09_JPRB, 0.90381085E-10_JPRB, 0.79163884E-10_JPRB, 0.71020877E-10_JPRB, &
  & 0.65638897E-10_JPRB, 0.62455277E-10_JPRB, 0.60705219E-10_JPRB, 0.59900168E-10_JPRB, 0.59997306E-10_JPRB, 0.61073958E-10_JPRB, &
  & 0.63300823E-10_JPRB, 0.66957974E-10_JPRB, 0.72108042E-10_JPRB, 0.79148521E-10_JPRB, 0.87882888E-10_JPRB, 0.98396083E-10_JPRB, &
  & 0.11029249E-09_JPRB, 0.12313818E-09_JPRB, 0.13601470E-09_JPRB, 0.14779149E-09_JPRB, 0.15688138E-09_JPRB, 0.16262684E-09_JPRB, &
  & 0.16393431E-09_JPRB, 0.16020255E-09_JPRB, 0.15209828E-09_JPRB, 0.13966414E-09_JPRB, 0.12259667E-09_JPRB, 0.10324274E-09_JPRB, &
  & 0.80825242E-10_JPRB, 0.58682059E-10_JPRB, 0.43880580E-10_JPRB, 0.23993885E-10_JPRB, 0.13555074E-10_JPRB, 0.76463098E-11_JPRB, &
  & 0.39940638E-11_JPRB, 0.25148009E-11_JPRB, 0.15948722E-11_JPRB, 0.88441440E-12_JPRB /)

RGHG4(:,34,11) = (/ &
  & 0.10369595E-08_JPRB, 0.94678121E-09_JPRB, 0.90251434E-09_JPRB, 0.87352037E-09_JPRB, 0.85251961E-09_JPRB, 0.83408752E-09_JPRB, &
  & 0.81418822E-09_JPRB, 0.78591711E-09_JPRB, 0.74322287E-09_JPRB, 0.70086176E-09_JPRB, 0.66066819E-09_JPRB, 0.62093530E-09_JPRB, &
  & 0.58007604E-09_JPRB, 0.53740690E-09_JPRB, 0.49258259E-09_JPRB, 0.44647305E-09_JPRB, 0.39976247E-09_JPRB, 0.35381983E-09_JPRB, &
  & 0.30970107E-09_JPRB, 0.26820682E-09_JPRB, 0.22972910E-09_JPRB, 0.19447721E-09_JPRB, 0.16280981E-09_JPRB, 0.13522948E-09_JPRB, &
  & 0.11197489E-09_JPRB, 0.92906967E-10_JPRB, 0.77385112E-10_JPRB, 0.64965235E-10_JPRB, 0.55330969E-10_JPRB, 0.48244613E-10_JPRB, &
  & 0.43469964E-10_JPRB, 0.40577770E-10_JPRB, 0.38994301E-10_JPRB, 0.38356013E-10_JPRB, 0.38503960E-10_JPRB, 0.39551435E-10_JPRB, &
  & 0.41769949E-10_JPRB, 0.45176772E-10_JPRB, 0.50230233E-10_JPRB, 0.56995970E-10_JPRB, 0.65574289E-10_JPRB, 0.76011038E-10_JPRB, &
  & 0.87976675E-10_JPRB, 0.10093225E-09_JPRB, 0.11394621E-09_JPRB, 0.12579417E-09_JPRB, 0.13508866E-09_JPRB, 0.14092481E-09_JPRB, &
  & 0.14238140E-09_JPRB, 0.13927924E-09_JPRB, 0.13232987E-09_JPRB, 0.12161813E-09_JPRB, 0.10697088E-09_JPRB, 0.90370489E-10_JPRB, &
  & 0.71148767E-10_JPRB, 0.51825318E-10_JPRB, 0.38701990E-10_JPRB, 0.20594261E-10_JPRB, 0.10647914E-10_JPRB, 0.57384197E-11_JPRB, &
  & 0.39426834E-11_JPRB, 0.25969762E-11_JPRB, 0.14079853E-11_JPRB, 0.79767703E-12_JPRB /)

RGHG4(:,35,11) = (/ &
  & 0.92665942E-09_JPRB, 0.85125434E-09_JPRB, 0.81213086E-09_JPRB, 0.78492529E-09_JPRB, 0.76455153E-09_JPRB, 0.74580864E-09_JPRB, &
  & 0.72564232E-09_JPRB, 0.69778722E-09_JPRB, 0.65786288E-09_JPRB, 0.61888100E-09_JPRB, 0.58226995E-09_JPRB, 0.54632088E-09_JPRB, &
  & 0.50924959E-09_JPRB, 0.47021498E-09_JPRB, 0.42881090E-09_JPRB, 0.38587541E-09_JPRB, 0.34216249E-09_JPRB, 0.29915306E-09_JPRB, &
  & 0.25790944E-09_JPRB, 0.21948716E-09_JPRB, 0.18436733E-09_JPRB, 0.15280197E-09_JPRB, 0.12503863E-09_JPRB, 0.10136466E-09_JPRB, &
  & 0.81837682E-10_JPRB, 0.66113101E-10_JPRB, 0.53565246E-10_JPRB, 0.43646330E-10_JPRB, 0.35965793E-10_JPRB, 0.30323990E-10_JPRB, &
  & 0.26506372E-10_JPRB, 0.24172820E-10_JPRB, 0.22954477E-10_JPRB, 0.22515463E-10_JPRB, 0.22710549E-10_JPRB, 0.23717649E-10_JPRB, &
  & 0.25577816E-10_JPRB, 0.28510744E-10_JPRB, 0.32930658E-10_JPRB, 0.38923989E-10_JPRB, 0.46856637E-10_JPRB, 0.56712454E-10_JPRB, &
  & 0.68398662E-10_JPRB, 0.81260443E-10_JPRB, 0.94278141E-10_JPRB, 0.10615536E-09_JPRB, 0.11551276E-09_JPRB, 0.12148588E-09_JPRB, &
  & 0.12345330E-09_JPRB, 0.12124968E-09_JPRB, 0.11527081E-09_JPRB, 0.10541479E-09_JPRB, 0.93261586E-10_JPRB, 0.78091478E-10_JPRB, &
  & 0.62008745E-10_JPRB, 0.45141980E-10_JPRB, 0.33557112E-10_JPRB, 0.17944504E-10_JPRB, 0.99848151E-11_JPRB, 0.60939539E-11_JPRB, &
  & 0.36668268E-11_JPRB, 0.18435845E-11_JPRB, 0.13551943E-11_JPRB, 0.81406973E-12_JPRB /)

RGHG4(:,36,11) = (/ &
  & 0.84831919E-09_JPRB, 0.78222889E-09_JPRB, 0.74456241E-09_JPRB, 0.71697093E-09_JPRB, 0.69480210E-09_JPRB, 0.67444977E-09_JPRB, &
  & 0.65249278E-09_JPRB, 0.62396416E-09_JPRB, 0.58539795E-09_JPRB, 0.54870564E-09_JPRB, 0.51494559E-09_JPRB, 0.48230336E-09_JPRB, &
  & 0.44876949E-09_JPRB, 0.41316559E-09_JPRB, 0.37507619E-09_JPRB, 0.33489830E-09_JPRB, 0.29383979E-09_JPRB, 0.25314736E-09_JPRB, &
  & 0.21452105E-09_JPRB, 0.17872170E-09_JPRB, 0.14648024E-09_JPRB, 0.11803400E-09_JPRB, 0.93710047E-10_JPRB, 0.73602228E-10_JPRB, &
  & 0.57550398E-10_JPRB, 0.45068255E-10_JPRB, 0.35331838E-10_JPRB, 0.27865994E-10_JPRB, 0.22199640E-10_JPRB, 0.18090657E-10_JPRB, &
  & 0.15322479E-10_JPRB, 0.13640258E-10_JPRB, 0.12774385E-10_JPRB, 0.12489077E-10_JPRB, 0.12672217E-10_JPRB, 0.13519152E-10_JPRB, &
  & 0.14870639E-10_JPRB, 0.17250880E-10_JPRB, 0.20671891E-10_JPRB, 0.25663116E-10_JPRB, 0.32419917E-10_JPRB, 0.41323424E-10_JPRB, &
  & 0.52298898E-10_JPRB, 0.64702139E-10_JPRB, 0.77438160E-10_JPRB, 0.89136622E-10_JPRB, 0.98455036E-10_JPRB, 0.10453453E-09_JPRB, &
  & 0.10681264E-09_JPRB, 0.10528228E-09_JPRB, 0.10037407E-09_JPRB, 0.92052276E-10_JPRB, 0.81575545E-10_JPRB, 0.68327129E-10_JPRB, &
  & 0.54363136E-10_JPRB, 0.39684162E-10_JPRB, 0.29692190E-10_JPRB, 0.15973976E-10_JPRB, 0.87999781E-11_JPRB, 0.47891313E-11_JPRB, &
  & 0.27958037E-11_JPRB, 0.22519278E-11_JPRB, 0.13253575E-11_JPRB, 0.78448576E-12_JPRB /)

RGHG4(:,37,11) = (/ &
  & 0.78667151E-09_JPRB, 0.72421541E-09_JPRB, 0.68678446E-09_JPRB, 0.65762518E-09_JPRB, 0.63347849E-09_JPRB, 0.61058575E-09_JPRB, &
  & 0.58662647E-09_JPRB, 0.55710669E-09_JPRB, 0.51965571E-09_JPRB, 0.48511045E-09_JPRB, 0.45408147E-09_JPRB, 0.42461612E-09_JPRB, &
  & 0.39449924E-09_JPRB, 0.36213482E-09_JPRB, 0.32736946E-09_JPRB, 0.28986291E-09_JPRB, 0.25154348E-09_JPRB, 0.21301380E-09_JPRB, &
  & 0.17624169E-09_JPRB, 0.14247598E-09_JPRB, 0.11270265E-09_JPRB, 0.87257694E-10_JPRB, 0.66374684E-10_JPRB, 0.50053441E-10_JPRB, &
  & 0.37764146E-10_JPRB, 0.28627569E-10_JPRB, 0.21916474E-10_JPRB, 0.16867495E-10_JPRB, 0.13160332E-10_JPRB, 0.10491178E-10_JPRB, &
  & 0.86982912E-11_JPRB, 0.75962153E-11_JPRB, 0.70456922E-11_JPRB, 0.68007366E-11_JPRB, 0.69938426E-11_JPRB, 0.74815111E-11_JPRB, &
  & 0.84554915E-11_JPRB, 0.10033913E-10_JPRB, 0.12451130E-10_JPRB, 0.16107981E-10_JPRB, 0.21320133E-10_JPRB, 0.28754958E-10_JPRB, &
  & 0.38397122E-10_JPRB, 0.49955606E-10_JPRB, 0.62170505E-10_JPRB, 0.73671999E-10_JPRB, 0.82980484E-10_JPRB, 0.89182405E-10_JPRB, &
  & 0.91784517E-10_JPRB, 0.91090274E-10_JPRB, 0.87107564E-10_JPRB, 0.79967109E-10_JPRB, 0.71034761E-10_JPRB, 0.59650396E-10_JPRB, &
  & 0.47564241E-10_JPRB, 0.34689331E-10_JPRB, 0.25876259E-10_JPRB, 0.13910708E-10_JPRB, 0.76024551E-11_JPRB, 0.46375208E-11_JPRB, &
  & 0.31095198E-11_JPRB, 0.18584017E-11_JPRB, 0.12166376E-11_JPRB, 0.82693710E-12_JPRB /)

RGHG4(:,38,11) = (/ &
  & 0.73633249E-09_JPRB, 0.67509942E-09_JPRB, 0.63663685E-09_JPRB, 0.60588823E-09_JPRB, 0.57928590E-09_JPRB, 0.55425892E-09_JPRB, &
  & 0.52807975E-09_JPRB, 0.49771470E-09_JPRB, 0.46140247E-09_JPRB, 0.42899068E-09_JPRB, 0.40062240E-09_JPRB, 0.37416356E-09_JPRB, &
  & 0.34733891E-09_JPRB, 0.31824965E-09_JPRB, 0.28631067E-09_JPRB, 0.25176206E-09_JPRB, 0.21510214E-09_JPRB, 0.17884630E-09_JPRB, &
  & 0.14407167E-09_JPRB, 0.11234277E-09_JPRB, 0.85054200E-10_JPRB, 0.62918615E-10_JPRB, 0.45952398E-10_JPRB, 0.33543706E-10_JPRB, &
  & 0.24780651E-10_JPRB, 0.18571035E-10_JPRB, 0.14109346E-10_JPRB, 0.10857497E-10_JPRB, 0.84430041E-11_JPRB, 0.67309691E-11_JPRB, &
  & 0.55435582E-11_JPRB, 0.48058267E-11_JPRB, 0.44128269E-11_JPRB, 0.42260362E-11_JPRB, 0.43534000E-11_JPRB, 0.46426838E-11_JPRB, &
  & 0.53040745E-11_JPRB, 0.63178555E-11_JPRB, 0.79766497E-11_JPRB, 0.10444493E-10_JPRB, 0.14264576E-10_JPRB, 0.19915852E-10_JPRB, &
  & 0.27828698E-10_JPRB, 0.37888824E-10_JPRB, 0.49210330E-10_JPRB, 0.60235782E-10_JPRB, 0.69373104E-10_JPRB, 0.75699509E-10_JPRB, &
  & 0.78699963E-10_JPRB, 0.78645070E-10_JPRB, 0.75615729E-10_JPRB, 0.69772792E-10_JPRB, 0.62112183E-10_JPRB, 0.52318292E-10_JPRB, &
  & 0.41792497E-10_JPRB, 0.30709168E-10_JPRB, 0.23196049E-10_JPRB, 0.12694627E-10_JPRB, 0.70473779E-11_JPRB, 0.41459557E-11_JPRB, &
  & 0.23038958E-11_JPRB, 0.16205914E-11_JPRB, 0.11844414E-11_JPRB, 0.81206412E-12_JPRB /)

RGHG4(:,39,11) = (/ &
  & 0.68378059E-09_JPRB, 0.62339089E-09_JPRB, 0.58515437E-09_JPRB, 0.55380994E-09_JPRB, 0.52607080E-09_JPRB, 0.49935733E-09_JPRB, &
  & 0.47206783E-09_JPRB, 0.44154494E-09_JPRB, 0.40712850E-09_JPRB, 0.37727491E-09_JPRB, 0.35168807E-09_JPRB, 0.32827732E-09_JPRB, &
  & 0.30451833E-09_JPRB, 0.27887387E-09_JPRB, 0.24981994E-09_JPRB, 0.21800751E-09_JPRB, 0.18415759E-09_JPRB, 0.14970571E-09_JPRB, &
  & 0.11713355E-09_JPRB, 0.88148391E-10_JPRB, 0.64195142E-10_JPRB, 0.45911202E-10_JPRB, 0.32787939E-10_JPRB, 0.23677069E-10_JPRB, &
  & 0.17437518E-10_JPRB, 0.13172682E-10_JPRB, 0.10063794E-10_JPRB, 0.78434776E-11_JPRB, 0.61648360E-11_JPRB, 0.49495299E-11_JPRB, &
  & 0.40842442E-11_JPRB, 0.35481960E-11_JPRB, 0.32094134E-11_JPRB, 0.30969615E-11_JPRB, 0.31413264E-11_JPRB, 0.33665507E-11_JPRB, &
  & 0.38108054E-11_JPRB, 0.45325232E-11_JPRB, 0.56855649E-11_JPRB, 0.74354195E-11_JPRB, 0.10190591E-10_JPRB, 0.14323992E-10_JPRB, &
  & 0.20381394E-10_JPRB, 0.28644162E-10_JPRB, 0.38547943E-10_JPRB, 0.48665023E-10_JPRB, 0.57469658E-10_JPRB, 0.63805447E-10_JPRB, &
  & 0.67120226E-10_JPRB, 0.67561241E-10_JPRB, 0.65230106E-10_JPRB, 0.60308480E-10_JPRB, 0.53693661E-10_JPRB, 0.45425958E-10_JPRB, &
  & 0.36364925E-10_JPRB, 0.26944509E-10_JPRB, 0.20636244E-10_JPRB, 0.11586677E-10_JPRB, 0.63887194E-11_JPRB, 0.38082853E-11_JPRB, &
  & 0.25313354E-11_JPRB, 0.19345623E-11_JPRB, 0.11859320E-11_JPRB, 0.83828251E-12_JPRB /)

RGHG4(:,40,11) = (/ &
  & 0.62457262E-09_JPRB, 0.56714339E-09_JPRB, 0.53043014E-09_JPRB, 0.49990345E-09_JPRB, 0.47211285E-09_JPRB, 0.44519261E-09_JPRB, &
  & 0.41781661E-09_JPRB, 0.38834810E-09_JPRB, 0.35653933E-09_JPRB, 0.32966660E-09_JPRB, 0.30706018E-09_JPRB, 0.28651681E-09_JPRB, &
  & 0.26591115E-09_JPRB, 0.24323465E-09_JPRB, 0.21751138E-09_JPRB, 0.18808567E-09_JPRB, 0.15659977E-09_JPRB, 0.12479023E-09_JPRB, &
  & 0.94979601E-10_JPRB, 0.69316941E-10_JPRB, 0.49316520E-10_JPRB, 0.34780717E-10_JPRB, 0.24791542E-10_JPRB, 0.18071369E-10_JPRB, &
  & 0.13451222E-10_JPRB, 0.10289037E-10_JPRB, 0.79976104E-11_JPRB, 0.62913693E-11_JPRB, 0.50179526E-11_JPRB, 0.40581943E-11_JPRB, &
  & 0.33602543E-11_JPRB, 0.29320795E-11_JPRB, 0.26249651E-11_JPRB, 0.25493730E-11_JPRB, 0.25491085E-11_JPRB, 0.27465491E-11_JPRB, &
  & 0.30675779E-11_JPRB, 0.36401199E-11_JPRB, 0.44941980E-11_JPRB, 0.58319191E-11_JPRB, 0.78697439E-11_JPRB, 0.10919430E-10_JPRB, &
  & 0.15549194E-10_JPRB, 0.22080209E-10_JPRB, 0.30285496E-10_JPRB, 0.39204948E-10_JPRB, 0.47310100E-10_JPRB, 0.53492502E-10_JPRB, &
  & 0.57006632E-10_JPRB, 0.57941124E-10_JPRB, 0.56316306E-10_JPRB, 0.52247220E-10_JPRB, 0.46596192E-10_JPRB, 0.39375978E-10_JPRB, &
  & 0.31720283E-10_JPRB, 0.23735914E-10_JPRB, 0.18606828E-10_JPRB, 0.10579085E-10_JPRB, 0.59791586E-11_JPRB, 0.37085101E-11_JPRB, &
  & 0.23444213E-11_JPRB, 0.14505545E-11_JPRB, 0.11953352E-11_JPRB, 0.87841805E-12_JPRB /)

RGHG4(:,41,11) = (/ &
  & 0.56269817E-09_JPRB, 0.50907190E-09_JPRB, 0.47460008E-09_JPRB, 0.44578113E-09_JPRB, 0.41887896E-09_JPRB, 0.39233405E-09_JPRB, &
  & 0.36572378E-09_JPRB, 0.33779057E-09_JPRB, 0.30894398E-09_JPRB, 0.28529035E-09_JPRB, 0.26554811E-09_JPRB, 0.24792943E-09_JPRB, &
  & 0.23007665E-09_JPRB, 0.21052192E-09_JPRB, 0.18772861E-09_JPRB, 0.16161117E-09_JPRB, 0.13285391E-09_JPRB, 0.10382641E-09_JPRB, &
  & 0.77152486E-10_JPRB, 0.55253177E-10_JPRB, 0.38892018E-10_JPRB, 0.27649357E-10_JPRB, 0.19957874E-10_JPRB, 0.14826411E-10_JPRB, &
  & 0.11268731E-10_JPRB, 0.87232452E-11_JPRB, 0.69010184E-11_JPRB, 0.54756993E-11_JPRB, 0.44130281E-11_JPRB, 0.35877341E-11_JPRB, &
  & 0.29823401E-11_JPRB, 0.26066822E-11_JPRB, 0.23207861E-11_JPRB, 0.22598887E-11_JPRB, 0.22480856E-11_JPRB, 0.24237448E-11_JPRB, &
  & 0.26825634E-11_JPRB, 0.31651550E-11_JPRB, 0.38530407E-11_JPRB, 0.49371332E-11_JPRB, 0.65056133E-11_JPRB, 0.88920876E-11_JPRB, &
  & 0.12499377E-10_JPRB, 0.17558391E-10_JPRB, 0.24191645E-10_JPRB, 0.31671901E-10_JPRB, 0.38967423E-10_JPRB, 0.44732992E-10_JPRB, &
  & 0.48283842E-10_JPRB, 0.49485575E-10_JPRB, 0.48306029E-10_JPRB, 0.44900368E-10_JPRB, 0.40025788E-10_JPRB, 0.33970396E-10_JPRB, &
  & 0.27438350E-10_JPRB, 0.20638047E-10_JPRB, 0.16439548E-10_JPRB, 0.96249874E-11_JPRB, 0.55874155E-11_JPRB, 0.33139925E-11_JPRB, &
  & 0.21175112E-11_JPRB, 0.17832578E-11_JPRB, 0.11617013E-11_JPRB, 0.89146664E-12_JPRB /)

RGHG4(:,42,11) = (/ &
  & 0.49638954E-09_JPRB, 0.44770593E-09_JPRB, 0.41646478E-09_JPRB, 0.38989534E-09_JPRB, 0.36468947E-09_JPRB, 0.33944411E-09_JPRB, &
  & 0.31454186E-09_JPRB, 0.28914238E-09_JPRB, 0.26377675E-09_JPRB, 0.24346528E-09_JPRB, 0.22675951E-09_JPRB, 0.21177769E-09_JPRB, &
  & 0.19686609E-09_JPRB, 0.18010764E-09_JPRB, 0.16043560E-09_JPRB, 0.13712578E-09_JPRB, 0.11146754E-09_JPRB, 0.85601963E-10_JPRB, &
  & 0.62584195E-10_JPRB, 0.44338453E-10_JPRB, 0.31375121E-10_JPRB, 0.22641609E-10_JPRB, 0.16762761E-10_JPRB, 0.12650951E-10_JPRB, &
  & 0.98408634E-11_JPRB, 0.77027950E-11_JPRB, 0.61784649E-11_JPRB, 0.49398905E-11_JPRB, 0.40115203E-11_JPRB, 0.32730155E-11_JPRB, &
  & 0.27377421E-11_JPRB, 0.23791225E-11_JPRB, 0.21317152E-11_JPRB, 0.20685617E-11_JPRB, 0.20576043E-11_JPRB, 0.22166847E-11_JPRB, &
  & 0.24405428E-11_JPRB, 0.28608752E-11_JPRB, 0.34405397E-11_JPRB, 0.43387537E-11_JPRB, 0.55991162E-11_JPRB, 0.75265410E-11_JPRB, &
  & 0.10303419E-10_JPRB, 0.14237592E-10_JPRB, 0.19478918E-10_JPRB, 0.25695428E-10_JPRB, 0.31904316E-10_JPRB, 0.37203105E-10_JPRB, &
  & 0.40682759E-10_JPRB, 0.42171697E-10_JPRB, 0.41528392E-10_JPRB, 0.38745868E-10_JPRB, 0.34631280E-10_JPRB, 0.29323474E-10_JPRB, &
  & 0.23773336E-10_JPRB, 0.18050993E-10_JPRB, 0.14797911E-10_JPRB, 0.88284484E-11_JPRB, 0.52221864E-11_JPRB, 0.33221802E-11_JPRB, &
  & 0.23276088E-11_JPRB, 0.15611339E-11_JPRB, 0.12284453E-11_JPRB, 0.93598794E-12_JPRB /)

RGHG4(:,43,11) = (/ &
  & 0.43072407E-09_JPRB, 0.38696030E-09_JPRB, 0.35873995E-09_JPRB, 0.33474215E-09_JPRB, 0.31129713E-09_JPRB, 0.28770927E-09_JPRB, &
  & 0.26485200E-09_JPRB, 0.24215827E-09_JPRB, 0.22024124E-09_JPRB, 0.20332269E-09_JPRB, 0.18948761E-09_JPRB, 0.17724881E-09_JPRB, &
  & 0.16492296E-09_JPRB, 0.15114748E-09_JPRB, 0.13452968E-09_JPRB, 0.11460151E-09_JPRB, 0.92172603E-10_JPRB, 0.69868326E-10_JPRB, &
  & 0.50480412E-10_JPRB, 0.35957032E-10_JPRB, 0.25882472E-10_JPRB, 0.19093966E-10_JPRB, 0.14539756E-10_JPRB, 0.11196365E-10_JPRB, &
  & 0.88814425E-11_JPRB, 0.70300467E-11_JPRB, 0.56968779E-11_JPRB, 0.45832448E-11_JPRB, 0.37365150E-11_JPRB, 0.30549823E-11_JPRB, &
  & 0.25668664E-11_JPRB, 0.22242598E-11_JPRB, 0.20034328E-11_JPRB, 0.19367886E-11_JPRB, 0.19364740E-11_JPRB, 0.20789976E-11_JPRB, &
  & 0.22874675E-11_JPRB, 0.26615214E-11_JPRB, 0.31689712E-11_JPRB, 0.39297710E-11_JPRB, 0.49831593E-11_JPRB, 0.65373557E-11_JPRB, &
  & 0.87121282E-11_JPRB, 0.11792675E-10_JPRB, 0.15899082E-10_JPRB, 0.20802960E-10_JPRB, 0.26093412E-10_JPRB, 0.30754590E-10_JPRB, &
  & 0.34030244E-10_JPRB, 0.35604030E-10_JPRB, 0.35238656E-10_JPRB, 0.32955787E-10_JPRB, 0.29451080E-10_JPRB, 0.25001119E-10_JPRB, &
  & 0.20344474E-10_JPRB, 0.15496660E-10_JPRB, 0.13045166E-10_JPRB, 0.80315008E-11_JPRB, 0.49689038E-11_JPRB, 0.31700057E-11_JPRB, &
  & 0.20778377E-11_JPRB, 0.16771952E-11_JPRB, 0.12594322E-11_JPRB, 0.97564556E-12_JPRB /)

RGHG4(:,44,11) = (/ &
  & 0.36576886E-09_JPRB, 0.32688019E-09_JPRB, 0.30219124E-09_JPRB, 0.28075040E-09_JPRB, 0.25957622E-09_JPRB, 0.23788757E-09_JPRB, &
  & 0.21745772E-09_JPRB, 0.19772557E-09_JPRB, 0.17934149E-09_JPRB, 0.16566860E-09_JPRB, 0.15463816E-09_JPRB, 0.14488384E-09_JPRB, &
  & 0.13516961E-09_JPRB, 0.12405464E-09_JPRB, 0.11045900E-09_JPRB, 0.93639721E-10_JPRB, 0.74636616E-10_JPRB, 0.55945193E-10_JPRB, &
  & 0.40445262E-10_JPRB, 0.29147330E-10_JPRB, 0.21591413E-10_JPRB, 0.16371267E-10_JPRB, 0.12830932E-10_JPRB, 0.10079493E-10_JPRB, &
  & 0.81475816E-11_JPRB, 0.65112399E-11_JPRB, 0.53306873E-11_JPRB, 0.42926331E-11_JPRB, 0.35153122E-11_JPRB, 0.28726153E-11_JPRB, &
  & 0.24303782E-11_JPRB, 0.20916847E-11_JPRB, 0.19054493E-11_JPRB, 0.18294131E-11_JPRB, 0.18461482E-11_JPRB, 0.19731118E-11_JPRB, &
  & 0.21759536E-11_JPRB, 0.25128751E-11_JPRB, 0.29671734E-11_JPRB, 0.36228965E-11_JPRB, 0.45076651E-11_JPRB, 0.57631582E-11_JPRB, &
  & 0.74824548E-11_JPRB, 0.98607598E-11_JPRB, 0.12957183E-10_JPRB, 0.16828525E-10_JPRB, 0.21091606E-10_JPRB, 0.25139429E-10_JPRB, &
  & 0.28151270E-10_JPRB, 0.29826735E-10_JPRB, 0.29850823E-10_JPRB, 0.28142254E-10_JPRB, 0.25290927E-10_JPRB, 0.21589156E-10_JPRB, &
  & 0.17647158E-10_JPRB, 0.13610651E-10_JPRB, 0.11875039E-10_JPRB, 0.75167286E-11_JPRB, 0.47464593E-11_JPRB, 0.31564059E-11_JPRB, &
  & 0.22742069E-11_JPRB, 0.17726493E-11_JPRB, 0.13233763E-11_JPRB, 0.10238091E-11_JPRB /)

RGHG4(:,45,11) = (/ &
  & 0.30349845E-09_JPRB, 0.26997821E-09_JPRB, 0.24855148E-09_JPRB, 0.23007546E-09_JPRB, 0.21110565E-09_JPRB, 0.19182825E-09_JPRB, &
  & 0.17394376E-09_JPRB, 0.15725972E-09_JPRB, 0.14214827E-09_JPRB, 0.13140761E-09_JPRB, 0.12286552E-09_JPRB, 0.11539261E-09_JPRB, &
  & 0.10790060E-09_JPRB, 0.99292317E-10_JPRB, 0.88494261E-10_JPRB, 0.74717295E-10_JPRB, 0.59036318E-10_JPRB, 0.43996751E-10_JPRB, &
  & 0.32089772E-10_JPRB, 0.23718428E-10_JPRB, 0.18183486E-10_JPRB, 0.14194245E-10_JPRB, 0.11455884E-10_JPRB, 0.91758328E-11_JPRB, &
  & 0.75434511E-11_JPRB, 0.60848310E-11_JPRB, 0.50098935E-11_JPRB, 0.40505147E-11_JPRB, 0.33138845E-11_JPRB, 0.27110415E-11_JPRB, &
  & 0.23085041E-11_JPRB, 0.19765092E-11_JPRB, 0.18205641E-11_JPRB, 0.17405093E-11_JPRB, 0.17702195E-11_JPRB, 0.18880975E-11_JPRB, &
  & 0.20857331E-11_JPRB, 0.23936263E-11_JPRB, 0.28050949E-11_JPRB, 0.33737776E-11_JPRB, 0.41196421E-11_JPRB, 0.51400980E-11_JPRB, &
  & 0.64886742E-11_JPRB, 0.82854539E-11_JPRB, 0.10600388E-10_JPRB, 0.13490400E-10_JPRB, 0.16882823E-10_JPRB, 0.20233851E-10_JPRB, &
  & 0.22930741E-10_JPRB, 0.24555488E-10_JPRB, 0.24764574E-10_JPRB, 0.23476944E-10_JPRB, 0.21193098E-10_JPRB, 0.18192900E-10_JPRB, &
  & 0.15077986E-10_JPRB, 0.11853212E-10_JPRB, 0.10846521E-10_JPRB, 0.70909550E-11_JPRB, 0.46941461E-11_JPRB, 0.32586776E-11_JPRB, &
  & 0.23261744E-11_JPRB, 0.18574469E-11_JPRB, 0.14580447E-11_JPRB, 0.11043920E-11_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART22',0,ZHOOK_HANDLE)



RGHG4(:,46,11) = (/ &
  & 0.24608654E-09_JPRB, 0.21736882E-09_JPRB, 0.19955977E-09_JPRB, 0.18366188E-09_JPRB, 0.16741089E-09_JPRB, 0.15038833E-09_JPRB, &
  & 0.13522052E-09_JPRB, 0.12147705E-09_JPRB, 0.10929943E-09_JPRB, 0.10117966E-09_JPRB, 0.94774057E-10_JPRB, 0.89211451E-10_JPRB, &
  & 0.83669183E-10_JPRB, 0.77188110E-10_JPRB, 0.68790487E-10_JPRB, 0.57991334E-10_JPRB, 0.45483235E-10_JPRB, 0.34094495E-10_JPRB, &
  & 0.25461829E-10_JPRB, 0.19490572E-10_JPRB, 0.15526035E-10_JPRB, 0.12514535E-10_JPRB, 0.10351474E-10_JPRB, 0.84638329E-11_JPRB, &
  & 0.70358029E-11_JPRB, 0.57506014E-11_JPRB, 0.47291736E-11_JPRB, 0.38421089E-11_JPRB, 0.31317306E-11_JPRB, 0.25663939E-11_JPRB, &
  & 0.21930157E-11_JPRB, 0.18790672E-11_JPRB, 0.17417804E-11_JPRB, 0.16691962E-11_JPRB, 0.17036505E-11_JPRB, 0.18215054E-11_JPRB, &
  & 0.20123733E-11_JPRB, 0.23014665E-11_JPRB, 0.26768078E-11_JPRB, 0.31764107E-11_JPRB, 0.38100881E-11_JPRB, 0.46394967E-11_JPRB, &
  & 0.56932610E-11_JPRB, 0.70344208E-11_JPRB, 0.86987197E-11_JPRB, 0.10787915E-10_JPRB, 0.13282151E-10_JPRB, 0.15978592E-10_JPRB, &
  & 0.18307076E-10_JPRB, 0.19865170E-10_JPRB, 0.20281370E-10_JPRB, 0.19428749E-10_JPRB, 0.17768009E-10_JPRB, 0.15483316E-10_JPRB, &
  & 0.13061332E-10_JPRB, 0.10503713E-10_JPRB, 0.10172974E-10_JPRB, 0.69131961E-11_JPRB, 0.47345830E-11_JPRB, 0.33729751E-11_JPRB, &
  & 0.25241844E-11_JPRB, 0.20976372E-11_JPRB, 0.16092370E-11_JPRB, 0.12272500E-11_JPRB /)

RGHG4(:,47,11) = (/ &
  & 0.19407692E-09_JPRB, 0.17048267E-09_JPRB, 0.15574797E-09_JPRB, 0.14289984E-09_JPRB, 0.12899121E-09_JPRB, 0.11480469E-09_JPRB, &
  & 0.10214965E-09_JPRB, 0.91152599E-10_JPRB, 0.81569536E-10_JPRB, 0.75517925E-10_JPRB, 0.70860241E-10_JPRB, 0.66820618E-10_JPRB, &
  & 0.62787289E-10_JPRB, 0.57981234E-10_JPRB, 0.51753182E-10_JPRB, 0.43389646E-10_JPRB, 0.34168588E-10_JPRB, 0.25991142E-10_JPRB, &
  & 0.20191199E-10_JPRB, 0.16110514E-10_JPRB, 0.13351876E-10_JPRB, 0.11105132E-10_JPRB, 0.93954523E-11_JPRB, 0.78435652E-11_JPRB, &
  & 0.65630973E-11_JPRB, 0.54352469E-11_JPRB, 0.44548744E-11_JPRB, 0.36373164E-11_JPRB, 0.29548224E-11_JPRB, 0.24259277E-11_JPRB, &
  & 0.20817753E-11_JPRB, 0.17927365E-11_JPRB, 0.16656578E-11_JPRB, 0.16102346E-11_JPRB, 0.16418974E-11_JPRB, 0.17649383E-11_JPRB, &
  & 0.19464140E-11_JPRB, 0.22213206E-11_JPRB, 0.25635143E-11_JPRB, 0.30062344E-11_JPRB, 0.35442975E-11_JPRB, 0.42184186E-11_JPRB, &
  & 0.50317229E-11_JPRB, 0.60151320E-11_JPRB, 0.71731861E-11_JPRB, 0.85807143E-11_JPRB, 0.10307313E-10_JPRB, 0.12302243E-10_JPRB, &
  & 0.14189499E-10_JPRB, 0.15581607E-10_JPRB, 0.16084472E-10_JPRB, 0.15575765E-10_JPRB, 0.14350372E-10_JPRB, 0.12692191E-10_JPRB, &
  & 0.10900477E-10_JPRB, 0.90344000E-11_JPRB, 0.93896505E-11_JPRB, 0.66260721E-11_JPRB, 0.47168697E-11_JPRB, 0.35230998E-11_JPRB, &
  & 0.27417606E-11_JPRB, 0.22868842E-11_JPRB, 0.18153292E-11_JPRB, 0.13947657E-11_JPRB /)

RGHG4(:,48,11) = (/ &
  & 0.14930629E-09_JPRB, 0.13013186E-09_JPRB, 0.11855539E-09_JPRB, 0.10806298E-09_JPRB, 0.96908509E-10_JPRB, 0.85010020E-10_JPRB, &
  & 0.74851313E-10_JPRB, 0.66369056E-10_JPRB, 0.58772043E-10_JPRB, 0.54458781E-10_JPRB, 0.51120181E-10_JPRB, 0.48262373E-10_JPRB, &
  & 0.45403070E-10_JPRB, 0.41993239E-10_JPRB, 0.37493696E-10_JPRB, 0.31617080E-10_JPRB, 0.25281548E-10_JPRB, 0.19977247E-10_JPRB, &
  & 0.16270221E-10_JPRB, 0.13604744E-10_JPRB, 0.11682032E-10_JPRB, 0.10014043E-10_JPRB, 0.86138692E-11_JPRB, 0.73322147E-11_JPRB, &
  & 0.61610101E-11_JPRB, 0.51573368E-11_JPRB, 0.42133688E-11_JPRB, 0.34466195E-11_JPRB, 0.27937704E-11_JPRB, 0.22984041E-11_JPRB, &
  & 0.19809551E-11_JPRB, 0.17227905E-11_JPRB, 0.15988958E-11_JPRB, 0.15647779E-11_JPRB, 0.15935690E-11_JPRB, 0.17216321E-11_JPRB, &
  & 0.18946691E-11_JPRB, 0.21580058E-11_JPRB, 0.24735450E-11_JPRB, 0.28705339E-11_JPRB, 0.33318522E-11_JPRB, 0.38833789E-11_JPRB, &
  & 0.45148290E-11_JPRB, 0.52273984E-11_JPRB, 0.60102409E-11_JPRB, 0.68958081E-11_JPRB, 0.79760989E-11_JPRB, 0.92856573E-11_JPRB, &
  & 0.10656628E-10_JPRB, 0.11795045E-10_JPRB, 0.12329522E-10_JPRB, 0.12096718E-10_JPRB, 0.11362852E-10_JPRB, 0.10250375E-10_JPRB, &
  & 0.90607834E-11_JPRB, 0.76976715E-11_JPRB, 0.85765336E-11_JPRB, 0.62753114E-11_JPRB, 0.46242142E-11_JPRB, 0.35777425E-11_JPRB, &
  & 0.28882951E-11_JPRB, 0.24677183E-11_JPRB, 0.19963623E-11_JPRB, 0.15987407E-11_JPRB /)

RGHG4(:,49,11) = (/ &
  & 0.11119317E-09_JPRB, 0.95986004E-10_JPRB, 0.86978959E-10_JPRB, 0.78855242E-10_JPRB, 0.69839461E-10_JPRB, 0.60331823E-10_JPRB, &
  & 0.52244840E-10_JPRB, 0.45901533E-10_JPRB, 0.39941848E-10_JPRB, 0.36951407E-10_JPRB, 0.34705048E-10_JPRB, 0.32804381E-10_JPRB, &
  & 0.30911596E-10_JPRB, 0.28738711E-10_JPRB, 0.25847751E-10_JPRB, 0.22320368E-10_JPRB, 0.18551889E-10_JPRB, 0.15476394E-10_JPRB, &
  & 0.13304332E-10_JPRB, 0.11625455E-10_JPRB, 0.10318062E-10_JPRB, 0.90916120E-11_JPRB, 0.79400791E-11_JPRB, 0.68663829E-11_JPRB, &
  & 0.57867422E-11_JPRB, 0.48690691E-11_JPRB, 0.39779503E-11_JPRB, 0.32504242E-11_JPRB, 0.26398443E-11_JPRB, 0.21819341E-11_JPRB, &
  & 0.18882578E-11_JPRB, 0.16655282E-11_JPRB, 0.15458011E-11_JPRB, 0.15259414E-11_JPRB, 0.15590202E-11_JPRB, 0.16852179E-11_JPRB, &
  & 0.18552703E-11_JPRB, 0.21045173E-11_JPRB, 0.23985844E-11_JPRB, 0.27538876E-11_JPRB, 0.31532023E-11_JPRB, 0.36057661E-11_JPRB, &
  & 0.40930865E-11_JPRB, 0.46034830E-11_JPRB, 0.51053372E-11_JPRB, 0.56170294E-11_JPRB, 0.61920959E-11_JPRB, 0.69079551E-11_JPRB, &
  & 0.77039408E-11_JPRB, 0.84523074E-11_JPRB, 0.89036460E-11_JPRB, 0.88558241E-11_JPRB, 0.84488224E-11_JPRB, 0.77883594E-11_JPRB, &
  & 0.70239743E-11_JPRB, 0.61490726E-11_JPRB, 0.74931025E-11_JPRB, 0.57001201E-11_JPRB, 0.43430121E-11_JPRB, 0.35004085E-11_JPRB, &
  & 0.29314144E-11_JPRB, 0.25387270E-11_JPRB, 0.21080477E-11_JPRB, 0.17944669E-11_JPRB /)

RGHG4(:,50,11) = (/ &
  & 0.80062651E-10_JPRB, 0.68361920E-10_JPRB, 0.61521725E-10_JPRB, 0.55251241E-10_JPRB, 0.48129153E-10_JPRB, 0.40562744E-10_JPRB, &
  & 0.34432561E-10_JPRB, 0.29989490E-10_JPRB, 0.25322310E-10_JPRB, 0.23468423E-10_JPRB, 0.22111155E-10_JPRB, 0.21002080E-10_JPRB, &
  & 0.19995568E-10_JPRB, 0.18803197E-10_JPRB, 0.17475145E-10_JPRB, 0.15669370E-10_JPRB, 0.13905305E-10_JPRB, 0.12311470E-10_JPRB, &
  & 0.11142813E-10_JPRB, 0.10135455E-10_JPRB, 0.92365707E-11_JPRB, 0.83301690E-11_JPRB, 0.73656524E-11_JPRB, 0.64404502E-11_JPRB, &
  & 0.54587055E-11_JPRB, 0.45926223E-11_JPRB, 0.37604134E-11_JPRB, 0.30746514E-11_JPRB, 0.25057803E-11_JPRB, 0.20865436E-11_JPRB, &
  & 0.18134220E-11_JPRB, 0.16228710E-11_JPRB, 0.15160761E-11_JPRB, 0.15013892E-11_JPRB, 0.15456505E-11_JPRB, 0.16629068E-11_JPRB, &
  & 0.18335763E-11_JPRB, 0.20626051E-11_JPRB, 0.23417887E-11_JPRB, 0.26605306E-11_JPRB, 0.30105165E-11_JPRB, 0.33840329E-11_JPRB, &
  & 0.37627518E-11_JPRB, 0.41216332E-11_JPRB, 0.44274731E-11_JPRB, 0.46755239E-11_JPRB, 0.49102662E-11_JPRB, 0.51876116E-11_JPRB, &
  & 0.55035672E-11_JPRB, 0.58360270E-11_JPRB, 0.60571825E-11_JPRB, 0.60617913E-11_JPRB, 0.58964673E-11_JPRB, 0.55788273E-11_JPRB, &
  & 0.51834140E-11_JPRB, 0.47269146E-11_JPRB, 0.63394112E-11_JPRB, 0.49441536E-11_JPRB, 0.38967011E-11_JPRB, 0.32738630E-11_JPRB, &
  & 0.28015006E-11_JPRB, 0.24767083E-11_JPRB, 0.21077428E-11_JPRB, 0.19293456E-11_JPRB /)

RGHG4(:,51,11) = (/ &
  & 0.55432939E-10_JPRB, 0.46540449E-10_JPRB, 0.41504435E-10_JPRB, 0.36758541E-10_JPRB, 0.31342692E-10_JPRB, 0.25716740E-10_JPRB, &
  & 0.21454023E-10_JPRB, 0.18767769E-10_JPRB, 0.15317693E-10_JPRB, 0.14347692E-10_JPRB, 0.13686473E-10_JPRB, 0.13185839E-10_JPRB, &
  & 0.12762404E-10_JPRB, 0.12387292E-10_JPRB, 0.11907694E-10_JPRB, 0.11376986E-10_JPRB, 0.10729938E-10_JPRB, 0.10088592E-10_JPRB, &
  & 0.95411908E-11_JPRB, 0.89707504E-11_JPRB, 0.83655253E-11_JPRB, 0.76912287E-11_JPRB, 0.68837700E-11_JPRB, 0.60612604E-11_JPRB, &
  & 0.51594965E-11_JPRB, 0.43296265E-11_JPRB, 0.35635000E-11_JPRB, 0.29133326E-11_JPRB, 0.23967601E-11_JPRB, 0.20156446E-11_JPRB, &
  & 0.17638650E-11_JPRB, 0.15979992E-11_JPRB, 0.15097897E-11_JPRB, 0.14970873E-11_JPRB, 0.15531382E-11_JPRB, 0.16576217E-11_JPRB, &
  & 0.18331636E-11_JPRB, 0.20414640E-11_JPRB, 0.23084473E-11_JPRB, 0.25932396E-11_JPRB, 0.29034340E-11_JPRB, 0.32142817E-11_JPRB, &
  & 0.35086573E-11_JPRB, 0.37561235E-11_JPRB, 0.39185712E-11_JPRB, 0.39930910E-11_JPRB, 0.40124549E-11_JPRB, 0.40198686E-11_JPRB, &
  & 0.40270625E-11_JPRB, 0.40443035E-11_JPRB, 0.40391674E-11_JPRB, 0.39651971E-11_JPRB, 0.38599696E-11_JPRB, 0.37029585E-11_JPRB, &
  & 0.35146775E-11_JPRB, 0.32980346E-11_JPRB, 0.49790901E-11_JPRB, 0.40433507E-11_JPRB, 0.33385332E-11_JPRB, 0.28959263E-11_JPRB, &
  & 0.25345483E-11_JPRB, 0.23231955E-11_JPRB, 0.20221151E-11_JPRB, 0.19734895E-11_JPRB /)

RGHG4(:,52,11) = (/ &
  & 0.36997849E-10_JPRB, 0.30526571E-10_JPRB, 0.26944192E-10_JPRB, 0.23583968E-10_JPRB, 0.19728630E-10_JPRB, 0.15976907E-10_JPRB, &
  & 0.13533514E-10_JPRB, 0.12165777E-10_JPRB, 0.96660761E-11_JPRB, 0.92488300E-11_JPRB, 0.89796989E-11_JPRB, 0.88110162E-11_JPRB, &
  & 0.87090560E-11_JPRB, 0.86495403E-11_JPRB, 0.86540592E-11_JPRB, 0.86419457E-11_JPRB, 0.86072547E-11_JPRB, 0.84884660E-11_JPRB, &
  & 0.83226091E-11_JPRB, 0.80458981E-11_JPRB, 0.76485285E-11_JPRB, 0.71416297E-11_JPRB, 0.64700962E-11_JPRB, 0.57208053E-11_JPRB, &
  & 0.49071290E-11_JPRB, 0.41172690E-11_JPRB, 0.34080989E-11_JPRB, 0.28054043E-11_JPRB, 0.23315744E-11_JPRB, 0.19857427E-11_JPRB, &
  & 0.17546244E-11_JPRB, 0.16076142E-11_JPRB, 0.15367914E-11_JPRB, 0.15292640E-11_JPRB, 0.15932112E-11_JPRB, 0.16890199E-11_JPRB, &
  & 0.18532385E-11_JPRB, 0.20440370E-11_JPRB, 0.22957662E-11_JPRB, 0.25537437E-11_JPRB, 0.28289350E-11_JPRB, 0.30876230E-11_JPRB, &
  & 0.33159744E-11_JPRB, 0.34756701E-11_JPRB, 0.35349195E-11_JPRB, 0.34922475E-11_JPRB, 0.33837245E-11_JPRB, 0.32499335E-11_JPRB, &
  & 0.31078623E-11_JPRB, 0.29759619E-11_JPRB, 0.28489695E-11_JPRB, 0.27160897E-11_JPRB, 0.26135253E-11_JPRB, 0.25088681E-11_JPRB, &
  & 0.24165643E-11_JPRB, 0.23421571E-11_JPRB, 0.39389715E-11_JPRB, 0.32861496E-11_JPRB, 0.28027233E-11_JPRB, 0.24923215E-11_JPRB, &
  & 0.22507415E-11_JPRB, 0.21092707E-11_JPRB, 0.19140143E-11_JPRB, 0.19230314E-11_JPRB /)

RGHG4(:,53,11) = (/ &
  & 0.24295338E-10_JPRB, 0.19812421E-10_JPRB, 0.17370140E-10_JPRB, 0.15168814E-10_JPRB, 0.12725960E-10_JPRB, 0.10594691E-10_JPRB, &
  & 0.93206311E-11_JPRB, 0.87099945E-11_JPRB, 0.68206365E-11_JPRB, 0.66499167E-11_JPRB, 0.65545000E-11_JPRB, 0.65064612E-11_JPRB, &
  & 0.65203945E-11_JPRB, 0.65867264E-11_JPRB, 0.67361585E-11_JPRB, 0.69342461E-11_JPRB, 0.71792047E-11_JPRB, 0.73404841E-11_JPRB, &
  & 0.74086050E-11_JPRB, 0.73247719E-11_JPRB, 0.70782351E-11_JPRB, 0.67018110E-11_JPRB, 0.61346930E-11_JPRB, 0.54583573E-11_JPRB, &
  & 0.46983498E-11_JPRB, 0.39595618E-11_JPRB, 0.32949273E-11_JPRB, 0.27387712E-11_JPRB, 0.23065373E-11_JPRB, 0.19924377E-11_JPRB, &
  & 0.17827956E-11_JPRB, 0.16531588E-11_JPRB, 0.15963960E-11_JPRB, 0.15967191E-11_JPRB, 0.16618702E-11_JPRB, 0.17624781E-11_JPRB, &
  & 0.19048888E-11_JPRB, 0.20932041E-11_JPRB, 0.23212972E-11_JPRB, 0.25574256E-11_JPRB, 0.27983512E-11_JPRB, 0.30159388E-11_JPRB, &
  & 0.31892486E-11_JPRB, 0.32823531E-11_JPRB, 0.32655768E-11_JPRB, 0.31466199E-11_JPRB, 0.29719454E-11_JPRB, 0.27740217E-11_JPRB, &
  & 0.25771924E-11_JPRB, 0.23947740E-11_JPRB, 0.22355945E-11_JPRB, 0.20974526E-11_JPRB, 0.19953423E-11_JPRB, 0.19128742E-11_JPRB, &
  & 0.18523865E-11_JPRB, 0.17991168E-11_JPRB, 0.32457192E-11_JPRB, 0.28028294E-11_JPRB, 0.24765081E-11_JPRB, 0.22459604E-11_JPRB, &
  & 0.20751968E-11_JPRB, 0.19675457E-11_JPRB, 0.18451894E-11_JPRB, 0.18254408E-11_JPRB /)

RGHG4(:,54,11) = (/ &
  & 0.16158165E-10_JPRB, 0.13193159E-10_JPRB, 0.11660275E-10_JPRB, 0.10300970E-10_JPRB, 0.88878392E-11_JPRB, 0.77244149E-11_JPRB, &
  & 0.71390480E-11_JPRB, 0.68706612E-11_JPRB, 0.53189536E-11_JPRB, 0.52501662E-11_JPRB, 0.52191506E-11_JPRB, 0.52173955E-11_JPRB, &
  & 0.52559159E-11_JPRB, 0.53559626E-11_JPRB, 0.55275485E-11_JPRB, 0.58095612E-11_JPRB, 0.61433831E-11_JPRB, 0.64679390E-11_JPRB, &
  & 0.66872168E-11_JPRB, 0.67486494E-11_JPRB, 0.66212929E-11_JPRB, 0.63531571E-11_JPRB, 0.58893645E-11_JPRB, 0.52684788E-11_JPRB, &
  & 0.45822543E-11_JPRB, 0.38899968E-11_JPRB, 0.32743383E-11_JPRB, 0.27559463E-11_JPRB, 0.23561528E-11_JPRB, 0.20680003E-11_JPRB, &
  & 0.18766481E-11_JPRB, 0.17634466E-11_JPRB, 0.17182706E-11_JPRB, 0.17286901E-11_JPRB, 0.17920550E-11_JPRB, 0.18923079E-11_JPRB, &
  & 0.20089182E-11_JPRB, 0.21874390E-11_JPRB, 0.23944208E-11_JPRB, 0.26154634E-11_JPRB, 0.28211435E-11_JPRB, 0.30014953E-11_JPRB, &
  & 0.31242053E-11_JPRB, 0.31609945E-11_JPRB, 0.30829525E-11_JPRB, 0.29147312E-11_JPRB, 0.27020506E-11_JPRB, 0.24822009E-11_JPRB, &
  & 0.22716844E-11_JPRB, 0.20863361E-11_JPRB, 0.19302869E-11_JPRB, 0.18021693E-11_JPRB, 0.17194924E-11_JPRB, 0.16549639E-11_JPRB, &
  & 0.16124264E-11_JPRB, 0.16018055E-11_JPRB, 0.29824272E-11_JPRB, 0.26340638E-11_JPRB, 0.23486909E-11_JPRB, 0.21564655E-11_JPRB, &
  & 0.20254657E-11_JPRB, 0.19339829E-11_JPRB, 0.18505841E-11_JPRB, 0.17865861E-11_JPRB /)

RGHG4(:,55,11) = (/ &
  & 0.11334459E-10_JPRB, 0.93771883E-11_JPRB, 0.84036146E-11_JPRB, 0.75926513E-11_JPRB, 0.67744304E-11_JPRB, 0.61752721E-11_JPRB, &
  & 0.59016381E-11_JPRB, 0.57969059E-11_JPRB, 0.44759348E-11_JPRB, 0.44554330E-11_JPRB, 0.44463439E-11_JPRB, 0.44601540E-11_JPRB, &
  & 0.45058592E-11_JPRB, 0.45948098E-11_JPRB, 0.47703252E-11_JPRB, 0.50298112E-11_JPRB, 0.54175891E-11_JPRB, 0.58219961E-11_JPRB, &
  & 0.61469740E-11_JPRB, 0.63232987E-11_JPRB, 0.62856205E-11_JPRB, 0.61063771E-11_JPRB, 0.57215400E-11_JPRB, 0.51706946E-11_JPRB, &
  & 0.45347077E-11_JPRB, 0.38940105E-11_JPRB, 0.33047675E-11_JPRB, 0.28201361E-11_JPRB, 0.24440951E-11_JPRB, 0.21785338E-11_JPRB, &
  & 0.20051146E-11_JPRB, 0.19085386E-11_JPRB, 0.18765820E-11_JPRB, 0.19004828E-11_JPRB, 0.19687769E-11_JPRB, 0.20696038E-11_JPRB, &
  & 0.21798739E-11_JPRB, 0.23433961E-11_JPRB, 0.25424062E-11_JPRB, 0.27429333E-11_JPRB, 0.29131584E-11_JPRB, 0.30607717E-11_JPRB, &
  & 0.31352165E-11_JPRB, 0.31270889E-11_JPRB, 0.30029401E-11_JPRB, 0.27988313E-11_JPRB, 0.25710311E-11_JPRB, 0.23428460E-11_JPRB, &
  & 0.21368766E-11_JPRB, 0.19538785E-11_JPRB, 0.18088359E-11_JPRB, 0.16967778E-11_JPRB, 0.16244543E-11_JPRB, 0.15753131E-11_JPRB, &
  & 0.15524834E-11_JPRB, 0.15443296E-11_JPRB, 0.28572244E-11_JPRB, 0.25618175E-11_JPRB, 0.23386254E-11_JPRB, 0.21859597E-11_JPRB, &
  & 0.20670802E-11_JPRB, 0.19791135E-11_JPRB, 0.19098145E-11_JPRB, 0.18162991E-11_JPRB /)

RGHG4(:,56,11) = (/ &
  & 0.83337590E-11_JPRB, 0.70975261E-11_JPRB, 0.64919398E-11_JPRB, 0.60105458E-11_JPRB, 0.55617498E-11_JPRB, 0.52601404E-11_JPRB, &
  & 0.51469835E-11_JPRB, 0.51107972E-11_JPRB, 0.39475367E-11_JPRB, 0.39436514E-11_JPRB, 0.39437477E-11_JPRB, 0.39561158E-11_JPRB, &
  & 0.39949038E-11_JPRB, 0.40792972E-11_JPRB, 0.42244832E-11_JPRB, 0.44856397E-11_JPRB, 0.48589917E-11_JPRB, 0.53298941E-11_JPRB, &
  & 0.57462585E-11_JPRB, 0.60094772E-11_JPRB, 0.60489586E-11_JPRB, 0.59526099E-11_JPRB, 0.56347323E-11_JPRB, 0.51348652E-11_JPRB, &
  & 0.45501419E-11_JPRB, 0.39424249E-11_JPRB, 0.33906862E-11_JPRB, 0.29300143E-11_JPRB, 0.25765924E-11_JPRB, 0.23314543E-11_JPRB, &
  & 0.21750666E-11_JPRB, 0.20952784E-11_JPRB, 0.20779363E-11_JPRB, 0.21163930E-11_JPRB, 0.21938900E-11_JPRB, 0.22995449E-11_JPRB, &
  & 0.24136327E-11_JPRB, 0.25784483E-11_JPRB, 0.27662497E-11_JPRB, 0.29516886E-11_JPRB, 0.30946688E-11_JPRB, 0.32129611E-11_JPRB, &
  & 0.32377582E-11_JPRB, 0.31932638E-11_JPRB, 0.30222498E-11_JPRB, 0.27913511E-11_JPRB, 0.25458695E-11_JPRB, 0.23164257E-11_JPRB, &
  & 0.21099398E-11_JPRB, 0.19363105E-11_JPRB, 0.17970382E-11_JPRB, 0.16946677E-11_JPRB, 0.16373450E-11_JPRB, 0.15998948E-11_JPRB, &
  & 0.15820434E-11_JPRB, 0.15950183E-11_JPRB, 0.29001085E-11_JPRB, 0.26515365E-11_JPRB, 0.24353067E-11_JPRB, 0.22745016E-11_JPRB, &
  & 0.21542438E-11_JPRB, 0.20779301E-11_JPRB, 0.20096357E-11_JPRB, 0.19039458E-11_JPRB /)

RGHG4(:,57,11) = (/ &
  & 0.65973186E-11_JPRB, 0.57230228E-11_JPRB, 0.53566938E-11_JPRB, 0.50566929E-11_JPRB, 0.48013186E-11_JPRB, 0.46560199E-11_JPRB, &
  & 0.46230632E-11_JPRB, 0.46169978E-11_JPRB, 0.36000313E-11_JPRB, 0.36038152E-11_JPRB, 0.36104700E-11_JPRB, 0.36243441E-11_JPRB, &
  & 0.36597791E-11_JPRB, 0.37301013E-11_JPRB, 0.38638871E-11_JPRB, 0.40863346E-11_JPRB, 0.44677439E-11_JPRB, 0.49743317E-11_JPRB, &
  & 0.54542620E-11_JPRB, 0.58026453E-11_JPRB, 0.58974835E-11_JPRB, 0.58407502E-11_JPRB, 0.55727254E-11_JPRB, 0.51338590E-11_JPRB, &
  & 0.45968286E-11_JPRB, 0.40272273E-11_JPRB, 0.35005857E-11_JPRB, 0.30659492E-11_JPRB, 0.27337622E-11_JPRB, 0.25106141E-11_JPRB, &
  & 0.23743373E-11_JPRB, 0.23120293E-11_JPRB, 0.23110871E-11_JPRB, 0.23641399E-11_JPRB, 0.24519239E-11_JPRB, 0.25685623E-11_JPRB, &
  & 0.26966014E-11_JPRB, 0.28670083E-11_JPRB, 0.30626723E-11_JPRB, 0.32481671E-11_JPRB, 0.33685619E-11_JPRB, 0.34653664E-11_JPRB, &
  & 0.34525226E-11_JPRB, 0.33778963E-11_JPRB, 0.31660347E-11_JPRB, 0.29072799E-11_JPRB, 0.26472925E-11_JPRB, 0.24083717E-11_JPRB, &
  & 0.22045759E-11_JPRB, 0.20239658E-11_JPRB, 0.18895586E-11_JPRB, 0.17948037E-11_JPRB, 0.17426903E-11_JPRB, 0.17107085E-11_JPRB, &
  & 0.17027435E-11_JPRB, 0.17163259E-11_JPRB, 0.30102728E-11_JPRB, 0.27606045E-11_JPRB, 0.25552195E-11_JPRB, 0.24071446E-11_JPRB, &
  & 0.23005948E-11_JPRB, 0.22103348E-11_JPRB, 0.21327824E-11_JPRB, 0.20146758E-11_JPRB /)

RGHG4(:,58,11) = (/ &
  & 0.53294851E-11_JPRB, 0.48349536E-11_JPRB, 0.46242910E-11_JPRB, 0.44622804E-11_JPRB, 0.43316245E-11_JPRB, 0.42643176E-11_JPRB, &
  & 0.42610507E-11_JPRB, 0.42684012E-11_JPRB, 0.33687137E-11_JPRB, 0.33750962E-11_JPRB, 0.33798142E-11_JPRB, 0.33912549E-11_JPRB, &
  & 0.34235286E-11_JPRB, 0.34869327E-11_JPRB, 0.36056156E-11_JPRB, 0.38258546E-11_JPRB, 0.41893160E-11_JPRB, 0.47320407E-11_JPRB, &
  & 0.52667050E-11_JPRB, 0.56505412E-11_JPRB, 0.57872040E-11_JPRB, 0.57704059E-11_JPRB, 0.55476418E-11_JPRB, 0.51647397E-11_JPRB, &
  & 0.46643592E-11_JPRB, 0.41304868E-11_JPRB, 0.36361439E-11_JPRB, 0.32290173E-11_JPRB, 0.29214853E-11_JPRB, 0.27238858E-11_JPRB, &
  & 0.26097009E-11_JPRB, 0.25665880E-11_JPRB, 0.25840016E-11_JPRB, 0.26516270E-11_JPRB, 0.27513133E-11_JPRB, 0.28806246E-11_JPRB, &
  & 0.30234105E-11_JPRB, 0.32018839E-11_JPRB, 0.33982658E-11_JPRB, 0.35899062E-11_JPRB, 0.37292960E-11_JPRB, 0.38268256E-11_JPRB, &
  & 0.37846748E-11_JPRB, 0.36929483E-11_JPRB, 0.34497463E-11_JPRB, 0.31625017E-11_JPRB, 0.28804823E-11_JPRB, 0.26290057E-11_JPRB, &
  & 0.24122473E-11_JPRB, 0.22259022E-11_JPRB, 0.20822265E-11_JPRB, 0.19852739E-11_JPRB, 0.19369996E-11_JPRB, 0.19067558E-11_JPRB, &
  & 0.18950768E-11_JPRB, 0.19123737E-11_JPRB, 0.32231598E-11_JPRB, 0.29820055E-11_JPRB, 0.27683288E-11_JPRB, 0.26054527E-11_JPRB, &
  & 0.24675067E-11_JPRB, 0.23717050E-11_JPRB, 0.22866771E-11_JPRB, 0.21518007E-11_JPRB /)

RGHG4(:,59,11) = (/ &
  & 0.45437677E-11_JPRB, 0.42901906E-11_JPRB, 0.41831751E-11_JPRB, 0.40785045E-11_JPRB, 0.40072576E-11_JPRB, 0.39824203E-11_JPRB, &
  & 0.39969863E-11_JPRB, 0.40061652E-11_JPRB, 0.32180025E-11_JPRB, 0.32309949E-11_JPRB, 0.32395152E-11_JPRB, 0.32555003E-11_JPRB, &
  & 0.32851178E-11_JPRB, 0.33470230E-11_JPRB, 0.34615251E-11_JPRB, 0.36687966E-11_JPRB, 0.40376474E-11_JPRB, 0.45938054E-11_JPRB, &
  & 0.51426936E-11_JPRB, 0.55440917E-11_JPRB, 0.57113676E-11_JPRB, 0.57225288E-11_JPRB, 0.55456291E-11_JPRB, 0.52048947E-11_JPRB, &
  & 0.47493402E-11_JPRB, 0.42528333E-11_JPRB, 0.37907195E-11_JPRB, 0.34110399E-11_JPRB, 0.31339920E-11_JPRB, 0.29644169E-11_JPRB, &
  & 0.28744322E-11_JPRB, 0.28529980E-11_JPRB, 0.28897349E-11_JPRB, 0.29718582E-11_JPRB, 0.30852189E-11_JPRB, 0.32271440E-11_JPRB, &
  & 0.33871718E-11_JPRB, 0.35758529E-11_JPRB, 0.37890398E-11_JPRB, 0.39898206E-11_JPRB, 0.41353132E-11_JPRB, 0.42399274E-11_JPRB, &
  & 0.42268554E-11_JPRB, 0.41368358E-11_JPRB, 0.38796579E-11_JPRB, 0.35825600E-11_JPRB, 0.32820959E-11_JPRB, 0.30080799E-11_JPRB, &
  & 0.27825455E-11_JPRB, 0.25654947E-11_JPRB, 0.24070286E-11_JPRB, 0.23003927E-11_JPRB, 0.22457841E-11_JPRB, 0.22059487E-11_JPRB, &
  & 0.21873857E-11_JPRB, 0.21909299E-11_JPRB, 0.35209411E-11_JPRB, 0.32434418E-11_JPRB, 0.30048173E-11_JPRB, 0.28173126E-11_JPRB, &
  & 0.26800979E-11_JPRB, 0.25662625E-11_JPRB, 0.24638631E-11_JPRB, 0.23086537E-11_JPRB /)

RGHG4(:,60,11) = (/ &
  & 0.42437321E-11_JPRB, 0.40092699E-11_JPRB, 0.39311263E-11_JPRB, 0.38623020E-11_JPRB, 0.38269318E-11_JPRB, 0.38169602E-11_JPRB, &
  & 0.38353795E-11_JPRB, 0.38547525E-11_JPRB, 0.31556209E-11_JPRB, 0.31709670E-11_JPRB, 0.31793433E-11_JPRB, 0.31972962E-11_JPRB, &
  & 0.32312230E-11_JPRB, 0.32934512E-11_JPRB, 0.34118066E-11_JPRB, 0.36228459E-11_JPRB, 0.39962764E-11_JPRB, 0.45498106E-11_JPRB, &
  & 0.50827042E-11_JPRB, 0.54777029E-11_JPRB, 0.56720492E-11_JPRB, 0.57119682E-11_JPRB, 0.55679992E-11_JPRB, 0.52683253E-11_JPRB, &
  & 0.48530316E-11_JPRB, 0.43906870E-11_JPRB, 0.39658368E-11_JPRB, 0.36207749E-11_JPRB, 0.33805422E-11_JPRB, 0.32418393E-11_JPRB, &
  & 0.31810331E-11_JPRB, 0.31858017E-11_JPRB, 0.32440407E-11_JPRB, 0.33422447E-11_JPRB, 0.34688719E-11_JPRB, 0.36206320E-11_JPRB, &
  & 0.37930431E-11_JPRB, 0.39947763E-11_JPRB, 0.42136711E-11_JPRB, 0.44320225E-11_JPRB, 0.46069121E-11_JPRB, 0.47293688E-11_JPRB, &
  & 0.47257515E-11_JPRB, 0.46561717E-11_JPRB, 0.44508117E-11_JPRB, 0.41744312E-11_JPRB, 0.38764872E-11_JPRB, 0.35891466E-11_JPRB, &
  & 0.33409471E-11_JPRB, 0.30904040E-11_JPRB, 0.28951221E-11_JPRB, 0.27703612E-11_JPRB, 0.26896662E-11_JPRB, 0.26353550E-11_JPRB, &
  & 0.25874177E-11_JPRB, 0.25704142E-11_JPRB, 0.39220576E-11_JPRB, 0.36025367E-11_JPRB, 0.33205049E-11_JPRB, 0.31036302E-11_JPRB, &
  & 0.29202060E-11_JPRB, 0.27853202E-11_JPRB, 0.26622912E-11_JPRB, 0.24808428E-11_JPRB /)

RGHG4(:,61,11) = (/ &
  & 0.39458883E-11_JPRB, 0.38320640E-11_JPRB, 0.37990808E-11_JPRB, 0.37531432E-11_JPRB, 0.37320589E-11_JPRB, 0.37379956E-11_JPRB, &
  & 0.37611654E-11_JPRB, 0.37820116E-11_JPRB, 0.31647699E-11_JPRB, 0.31868299E-11_JPRB, 0.32045826E-11_JPRB, 0.32303405E-11_JPRB, &
  & 0.32717284E-11_JPRB, 0.33443140E-11_JPRB, 0.34661471E-11_JPRB, 0.36865819E-11_JPRB, 0.40561222E-11_JPRB, 0.45730065E-11_JPRB, &
  & 0.50705239E-11_JPRB, 0.54576734E-11_JPRB, 0.56713566E-11_JPRB, 0.57306724E-11_JPRB, 0.56152656E-11_JPRB, 0.53494314E-11_JPRB, &
  & 0.49758444E-11_JPRB, 0.45527319E-11_JPRB, 0.41693810E-11_JPRB, 0.38653291E-11_JPRB, 0.36660202E-11_JPRB, 0.35647490E-11_JPRB, &
  & 0.35386507E-11_JPRB, 0.35740857E-11_JPRB, 0.36561578E-11_JPRB, 0.37716202E-11_JPRB, 0.39101760E-11_JPRB, 0.40699080E-11_JPRB, &
  & 0.42526043E-11_JPRB, 0.44629769E-11_JPRB, 0.46990229E-11_JPRB, 0.49314550E-11_JPRB, 0.51258876E-11_JPRB, 0.52727458E-11_JPRB, &
  & 0.53119549E-11_JPRB, 0.52789184E-11_JPRB, 0.51213066E-11_JPRB, 0.49297454E-11_JPRB, 0.46820698E-11_JPRB, 0.44091354E-11_JPRB, &
  & 0.41657008E-11_JPRB, 0.38623401E-11_JPRB, 0.36164693E-11_JPRB, 0.34427517E-11_JPRB, 0.33299175E-11_JPRB, 0.32305718E-11_JPRB, &
  & 0.31419199E-11_JPRB, 0.30692040E-11_JPRB, 0.44298090E-11_JPRB, 0.40209307E-11_JPRB, 0.36708145E-11_JPRB, 0.33940966E-11_JPRB, &
  & 0.31861228E-11_JPRB, 0.30204528E-11_JPRB, 0.28741532E-11_JPRB, 0.26644591E-11_JPRB /)

RGHG4(:,62,11) = (/ &
  & 0.39038685E-11_JPRB, 0.38038717E-11_JPRB, 0.37805275E-11_JPRB, 0.37448087E-11_JPRB, 0.37390520E-11_JPRB, 0.37537608E-11_JPRB, &
  & 0.37875536E-11_JPRB, 0.38212120E-11_JPRB, 0.32657382E-11_JPRB, 0.32907492E-11_JPRB, 0.33137622E-11_JPRB, 0.33478754E-11_JPRB, &
  & 0.33985189E-11_JPRB, 0.34789934E-11_JPRB, 0.36159519E-11_JPRB, 0.38358899E-11_JPRB, 0.41885349E-11_JPRB, 0.46611976E-11_JPRB, &
  & 0.51196681E-11_JPRB, 0.54898074E-11_JPRB, 0.57086354E-11_JPRB, 0.57835789E-11_JPRB, 0.56958357E-11_JPRB, 0.54660421E-11_JPRB, &
  & 0.51315736E-11_JPRB, 0.47502141E-11_JPRB, 0.44138022E-11_JPRB, 0.41585598E-11_JPRB, 0.40064939E-11_JPRB, 0.39489401E-11_JPRB, &
  & 0.39671886E-11_JPRB, 0.40398618E-11_JPRB, 0.41482672E-11_JPRB, 0.42812988E-11_JPRB, 0.44293172E-11_JPRB, 0.45933747E-11_JPRB, &
  & 0.47809274E-11_JPRB, 0.50006293E-11_JPRB, 0.52424727E-11_JPRB, 0.54934989E-11_JPRB, 0.57176421E-11_JPRB, 0.58974288E-11_JPRB, &
  & 0.59707452E-11_JPRB, 0.59917609E-11_JPRB, 0.59228321E-11_JPRB, 0.58249881E-11_JPRB, 0.56879597E-11_JPRB, 0.54823043E-11_JPRB, &
  & 0.52611795E-11_JPRB, 0.49189988E-11_JPRB, 0.46219157E-11_JPRB, 0.43925315E-11_JPRB, 0.42240751E-11_JPRB, 0.40566548E-11_JPRB, &
  & 0.38757110E-11_JPRB, 0.37154633E-11_JPRB, 0.50495615E-11_JPRB, 0.45139396E-11_JPRB, 0.40645967E-11_JPRB, 0.37247028E-11_JPRB, &
  & 0.34540259E-11_JPRB, 0.32558077E-11_JPRB, 0.30823055E-11_JPRB, 0.28390634E-11_JPRB /)

RGHG4(:,63,11) = (/ &
  & 0.38746732E-11_JPRB, 0.38393138E-11_JPRB, 0.38453511E-11_JPRB, 0.38239494E-11_JPRB, 0.38260159E-11_JPRB, 0.38570310E-11_JPRB, &
  & 0.39028386E-11_JPRB, 0.39459026E-11_JPRB, 0.34432257E-11_JPRB, 0.34748094E-11_JPRB, 0.35082490E-11_JPRB, 0.35529956E-11_JPRB, &
  & 0.36176281E-11_JPRB, 0.37088848E-11_JPRB, 0.38476618E-11_JPRB, 0.40591801E-11_JPRB, 0.43827979E-11_JPRB, 0.48016031E-11_JPRB, &
  & 0.52189611E-11_JPRB, 0.55684081E-11_JPRB, 0.57921428E-11_JPRB, 0.58819546E-11_JPRB, 0.58174667E-11_JPRB, 0.56197031E-11_JPRB, &
  & 0.53290332E-11_JPRB, 0.49994067E-11_JPRB, 0.47177865E-11_JPRB, 0.45187435E-11_JPRB, 0.44208309E-11_JPRB, 0.44203716E-11_JPRB, &
  & 0.44882088E-11_JPRB, 0.46029257E-11_JPRB, 0.47418163E-11_JPRB, 0.48928275E-11_JPRB, 0.50487180E-11_JPRB, 0.52132634E-11_JPRB, &
  & 0.54020685E-11_JPRB, 0.56205296E-11_JPRB, 0.58670842E-11_JPRB, 0.61337324E-11_JPRB, 0.63828938E-11_JPRB, 0.65991036E-11_JPRB, &
  & 0.67275764E-11_JPRB, 0.68161748E-11_JPRB, 0.68396929E-11_JPRB, 0.68663074E-11_JPRB, 0.68557733E-11_JPRB, 0.67847867E-11_JPRB, &
  & 0.66630603E-11_JPRB, 0.63472357E-11_JPRB, 0.60106681E-11_JPRB, 0.57224104E-11_JPRB, 0.54471900E-11_JPRB, 0.51626429E-11_JPRB, &
  & 0.48563271E-11_JPRB, 0.45329721E-11_JPRB, 0.57712563E-11_JPRB, 0.50492492E-11_JPRB, 0.44668566E-11_JPRB, 0.40282890E-11_JPRB, &
  & 0.37021245E-11_JPRB, 0.34648523E-11_JPRB, 0.32671767E-11_JPRB, 0.29955769E-11_JPRB /)

RGHG4(:,64,11) = (/ &
  & 0.39880412E-11_JPRB, 0.39897248E-11_JPRB, 0.40060182E-11_JPRB, 0.39913121E-11_JPRB, 0.40061951E-11_JPRB, 0.40522958E-11_JPRB, &
  & 0.41211865E-11_JPRB, 0.41789142E-11_JPRB, 0.37121703E-11_JPRB, 0.37464762E-11_JPRB, 0.37818715E-11_JPRB, 0.38340936E-11_JPRB, &
  & 0.39070795E-11_JPRB, 0.40039907E-11_JPRB, 0.41414342E-11_JPRB, 0.43399629E-11_JPRB, 0.46300637E-11_JPRB, 0.50036355E-11_JPRB, &
  & 0.53836072E-11_JPRB, 0.57140009E-11_JPRB, 0.59361626E-11_JPRB, 0.60359747E-11_JPRB, 0.59973380E-11_JPRB, 0.58374872E-11_JPRB, &
  & 0.55936896E-11_JPRB, 0.53220813E-11_JPRB, 0.51018864E-11_JPRB, 0.49681921E-11_JPRB, 0.49345745E-11_JPRB, 0.49945946E-11_JPRB, &
  & 0.51231497E-11_JPRB, 0.52874350E-11_JPRB, 0.54606662E-11_JPRB, 0.56311960E-11_JPRB, 0.57938832E-11_JPRB, 0.59546400E-11_JPRB, &
  & 0.61372960E-11_JPRB, 0.63544968E-11_JPRB, 0.65974040E-11_JPRB, 0.68735360E-11_JPRB, 0.71492942E-11_JPRB, 0.74057210E-11_JPRB, &
  & 0.75872199E-11_JPRB, 0.77580086E-11_JPRB, 0.78980295E-11_JPRB, 0.80685085E-11_JPRB, 0.82069551E-11_JPRB, 0.82650640E-11_JPRB, &
  & 0.82552819E-11_JPRB, 0.80415787E-11_JPRB, 0.77512996E-11_JPRB, 0.74422439E-11_JPRB, 0.70927019E-11_JPRB, 0.66618937E-11_JPRB, &
  & 0.61359208E-11_JPRB, 0.55464557E-11_JPRB, 0.65892864E-11_JPRB, 0.56112641E-11_JPRB, 0.48564468E-11_JPRB, 0.43049262E-11_JPRB, &
  & 0.39008618E-11_JPRB, 0.36304486E-11_JPRB, 0.34142615E-11_JPRB, 0.31349630E-11_JPRB /)

RGHG4(:,65,11) = (/ &
  & 0.41554715E-11_JPRB, 0.42064629E-11_JPRB, 0.42494541E-11_JPRB, 0.42466837E-11_JPRB, 0.42704386E-11_JPRB, 0.43376344E-11_JPRB, &
  & 0.44230023E-11_JPRB, 0.45003480E-11_JPRB, 0.40521237E-11_JPRB, 0.40857638E-11_JPRB, 0.41287715E-11_JPRB, 0.41908391E-11_JPRB, &
  & 0.42771663E-11_JPRB, 0.43766687E-11_JPRB, 0.45109238E-11_JPRB, 0.46888600E-11_JPRB, 0.49482636E-11_JPRB, 0.52770102E-11_JPRB, &
  & 0.56228737E-11_JPRB, 0.59333970E-11_JPRB, 0.61528716E-11_JPRB, 0.62674262E-11_JPRB, 0.62563982E-11_JPRB, 0.61383299E-11_JPRB, &
  & 0.59495503E-11_JPRB, 0.57458066E-11_JPRB, 0.55949880E-11_JPRB, 0.55339687E-11_JPRB, 0.55726894E-11_JPRB, 0.57057167E-11_JPRB, &
  & 0.58967974E-11_JPRB, 0.61147641E-11_JPRB, 0.63259315E-11_JPRB, 0.65172568E-11_JPRB, 0.66882238E-11_JPRB, 0.68465698E-11_JPRB, &
  & 0.70225574E-11_JPRB, 0.72239363E-11_JPRB, 0.74590377E-11_JPRB, 0.77416441E-11_JPRB, 0.80369383E-11_JPRB, 0.83334060E-11_JPRB, &
  & 0.85801817E-11_JPRB, 0.88410347E-11_JPRB, 0.90991051E-11_JPRB, 0.94117214E-11_JPRB, 0.97205542E-11_JPRB, 0.99579893E-11_JPRB, &
  & 0.10107303E-10_JPRB, 0.10037471E-10_JPRB, 0.98564950E-11_JPRB, 0.95980524E-11_JPRB, 0.91733478E-11_JPRB, 0.85930178E-11_JPRB, &
  & 0.78013611E-11_JPRB, 0.68112603E-11_JPRB, 0.74577601E-11_JPRB, 0.61704101E-11_JPRB, 0.52135254E-11_JPRB, 0.45231371E-11_JPRB, &
  & 0.40377311E-11_JPRB, 0.37503915E-11_JPRB, 0.35276463E-11_JPRB, 0.32502338E-11_JPRB /)

RGHG4(:,66,11) = (/ &
  & 0.44099772E-11_JPRB, 0.45191581E-11_JPRB, 0.45840415E-11_JPRB, 0.45898641E-11_JPRB, 0.46271593E-11_JPRB, 0.47135395E-11_JPRB, &
  & 0.48248458E-11_JPRB, 0.49147956E-11_JPRB, 0.44678549E-11_JPRB, 0.44966995E-11_JPRB, 0.45434342E-11_JPRB, 0.46141988E-11_JPRB, &
  & 0.47062011E-11_JPRB, 0.48109594E-11_JPRB, 0.49436575E-11_JPRB, 0.51100144E-11_JPRB, 0.53445868E-11_JPRB, 0.56403133E-11_JPRB, &
  & 0.59585809E-11_JPRB, 0.62528377E-11_JPRB, 0.64734767E-11_JPRB, 0.66035749E-11_JPRB, 0.66246583E-11_JPRB, 0.65554931E-11_JPRB, &
  & 0.64286818E-11_JPRB, 0.62971048E-11_JPRB, 0.62211464E-11_JPRB, 0.62390449E-11_JPRB, 0.63533298E-11_JPRB, 0.65557273E-11_JPRB, &
  & 0.68188970E-11_JPRB, 0.70974090E-11_JPRB, 0.73506990E-11_JPRB, 0.75667536E-11_JPRB, 0.77476393E-11_JPRB, 0.79071055E-11_JPRB, &
  & 0.80760693E-11_JPRB, 0.82700314E-11_JPRB, 0.84934646E-11_JPRB, 0.87705086E-11_JPRB, 0.90827823E-11_JPRB, 0.94198659E-11_JPRB, &
  & 0.97296615E-11_JPRB, 0.10088568E-10_JPRB, 0.10481915E-10_JPRB, 0.10962445E-10_JPRB, 0.11432123E-10_JPRB, 0.11818421E-10_JPRB, &
  & 0.12110583E-10_JPRB, 0.12187621E-10_JPRB, 0.12165284E-10_JPRB, 0.12039138E-10_JPRB, 0.11667779E-10_JPRB, 0.10979843E-10_JPRB, &
  & 0.99007382E-11_JPRB, 0.83488182E-11_JPRB, 0.83801386E-11_JPRB, 0.67459506E-11_JPRB, 0.55809402E-11_JPRB, 0.47175757E-11_JPRB, &
  & 0.41509188E-11_JPRB, 0.38817209E-11_JPRB, 0.36736365E-11_JPRB, 0.33660453E-11_JPRB /)

RGHG4(:,67,11) = (/ &
  & 0.47308511E-11_JPRB, 0.49069251E-11_JPRB, 0.50060494E-11_JPRB, 0.50244327E-11_JPRB, 0.50724802E-11_JPRB, 0.51787034E-11_JPRB, &
  & 0.53088311E-11_JPRB, 0.54090261E-11_JPRB, 0.49518349E-11_JPRB, 0.49782591E-11_JPRB, 0.50353684E-11_JPRB, 0.51248415E-11_JPRB, &
  & 0.52321303E-11_JPRB, 0.53433911E-11_JPRB, 0.54772354E-11_JPRB, 0.56337170E-11_JPRB, 0.58451889E-11_JPRB, 0.61138724E-11_JPRB, &
  & 0.64098934E-11_JPRB, 0.66944141E-11_JPRB, 0.69197031E-11_JPRB, 0.70731997E-11_JPRB, 0.71334327E-11_JPRB, 0.71181008E-11_JPRB, &
  & 0.70575533E-11_JPRB, 0.70035583E-11_JPRB, 0.70061487E-11_JPRB, 0.71051897E-11_JPRB, 0.73013965E-11_JPRB, 0.75856266E-11_JPRB, &
  & 0.79158208E-11_JPRB, 0.82538976E-11_JPRB, 0.85526239E-11_JPRB, 0.87982139E-11_JPRB, 0.89965058E-11_JPRB, 0.91681038E-11_JPRB, &
  & 0.93396115E-11_JPRB, 0.95110178E-11_JPRB, 0.97254383E-11_JPRB, 0.10002050E-10_JPRB, 0.10328019E-10_JPRB, 0.10704013E-10_JPRB, &
  & 0.11081810E-10_JPRB, 0.11538971E-10_JPRB, 0.12054223E-10_JPRB, 0.12683620E-10_JPRB, 0.13337334E-10_JPRB, 0.13915796E-10_JPRB, &
  & 0.14392320E-10_JPRB, 0.14638782E-10_JPRB, 0.14770006E-10_JPRB, 0.14771009E-10_JPRB, 0.14470493E-10_JPRB, 0.13780697E-10_JPRB, &
  & 0.12409866E-10_JPRB, 0.10307644E-10_JPRB, 0.93268657E-11_JPRB, 0.74100370E-11_JPRB, 0.60528340E-11_JPRB, 0.49800272E-11_JPRB, &
  & 0.43117406E-11_JPRB, 0.41397862E-11_JPRB, 0.39674384E-11_JPRB, 0.35793508E-11_JPRB /)

RGHG4(:,68,11) = (/ &
  & 0.51243775E-11_JPRB, 0.53863741E-11_JPRB, 0.55206482E-11_JPRB, 0.55490590E-11_JPRB, 0.56071532E-11_JPRB, 0.57349078E-11_JPRB, &
  & 0.58792290E-11_JPRB, 0.59909274E-11_JPRB, 0.55165590E-11_JPRB, 0.55413894E-11_JPRB, 0.56130955E-11_JPRB, 0.57119292E-11_JPRB, &
  & 0.58362746E-11_JPRB, 0.59591355E-11_JPRB, 0.61005910E-11_JPRB, 0.62601673E-11_JPRB, 0.64640962E-11_JPRB, 0.67183984E-11_JPRB, &
  & 0.70031303E-11_JPRB, 0.72867745E-11_JPRB, 0.75241610E-11_JPRB, 0.77040744E-11_JPRB, 0.78077709E-11_JPRB, 0.78520922E-11_JPRB, &
  & 0.78632422E-11_JPRB, 0.78895241E-11_JPRB, 0.79726781E-11_JPRB, 0.81535976E-11_JPRB, 0.84307682E-11_JPRB, 0.87881065E-11_JPRB, &
  & 0.91990296E-11_JPRB, 0.96037041E-11_JPRB, 0.99522586E-11_JPRB, 0.10232791E-10_JPRB, 0.10453496E-10_JPRB, 0.10639379E-10_JPRB, &
  & 0.10815809E-10_JPRB, 0.10999349E-10_JPRB, 0.11206624E-10_JPRB, 0.11472131E-10_JPRB, 0.11813182E-10_JPRB, 0.12230381E-10_JPRB, &
  & 0.12675413E-10_JPRB, 0.13231622E-10_JPRB, 0.13882334E-10_JPRB, 0.14675500E-10_JPRB, 0.15487424E-10_JPRB, 0.16215911E-10_JPRB, &
  & 0.16842229E-10_JPRB, 0.17242322E-10_JPRB, 0.17539111E-10_JPRB, 0.17708952E-10_JPRB, 0.17554203E-10_JPRB, 0.16879777E-10_JPRB, &
  & 0.15367515E-10_JPRB, 0.12612388E-10_JPRB, 0.10402032E-10_JPRB, 0.83295549E-11_JPRB, 0.68186741E-11_JPRB, 0.54419850E-11_JPRB, &
  & 0.46516970E-11_JPRB, 0.46994865E-11_JPRB, 0.45728608E-11_JPRB, 0.39991144E-11_JPRB /)

RGHG4(:,69,11) = (/ &
  & 0.55853421E-11_JPRB, 0.59470488E-11_JPRB, 0.61280785E-11_JPRB, 0.61657702E-11_JPRB, 0.62353083E-11_JPRB, 0.63785461E-11_JPRB, &
  & 0.65443792E-11_JPRB, 0.66597431E-11_JPRB, 0.61739659E-11_JPRB, 0.62046921E-11_JPRB, 0.63027552E-11_JPRB, 0.64255819E-11_JPRB, &
  & 0.65767088E-11_JPRB, 0.67176234E-11_JPRB, 0.68677364E-11_JPRB, 0.70317762E-11_JPRB, 0.72312343E-11_JPRB, 0.74759574E-11_JPRB, &
  & 0.77596601E-11_JPRB, 0.80511067E-11_JPRB, 0.83082898E-11_JPRB, 0.85241311E-11_JPRB, 0.86779143E-11_JPRB, 0.87842502E-11_JPRB, &
  & 0.88717861E-11_JPRB, 0.89810511E-11_JPRB, 0.91475230E-11_JPRB, 0.94117760E-11_JPRB, 0.97798089E-11_JPRB, 0.10230211E-10_JPRB, &
  & 0.10713375E-10_JPRB, 0.11182666E-10_JPRB, 0.11584038E-10_JPRB, 0.11905731E-10_JPRB, 0.12161089E-10_JPRB, 0.12376810E-10_JPRB, &
  & 0.12572111E-10_JPRB, 0.12737440E-10_JPRB, 0.12948165E-10_JPRB, 0.13221231E-10_JPRB, 0.13583358E-10_JPRB, 0.14044170E-10_JPRB, &
  & 0.14559326E-10_JPRB, 0.15214073E-10_JPRB, 0.15980061E-10_JPRB, 0.16918441E-10_JPRB, 0.17898393E-10_JPRB, 0.18813293E-10_JPRB, &
  & 0.19617466E-10_JPRB, 0.20194457E-10_JPRB, 0.20650344E-10_JPRB, 0.20950545E-10_JPRB, 0.20905935E-10_JPRB, 0.20282980E-10_JPRB, &
  & 0.18661420E-10_JPRB, 0.15389082E-10_JPRB, 0.11757399E-10_JPRB, 0.97170492E-11_JPRB, 0.80617795E-11_JPRB, 0.63227271E-11_JPRB, &
  & 0.53429171E-11_JPRB, 0.57399962E-11_JPRB, 0.56320001E-11_JPRB, 0.47259735E-11_JPRB /)

RGHG4(:,70,11) = (/ &
  & 0.61276240E-11_JPRB, 0.66116184E-11_JPRB, 0.68365929E-11_JPRB, 0.68815604E-11_JPRB, 0.69578887E-11_JPRB, 0.71258364E-11_JPRB, &
  & 0.73069901E-11_JPRB, 0.74425006E-11_JPRB, 0.69482957E-11_JPRB, 0.69920198E-11_JPRB, 0.71167061E-11_JPRB, 0.72541435E-11_JPRB, &
  & 0.74279749E-11_JPRB, 0.75954720E-11_JPRB, 0.77658166E-11_JPRB, 0.79530818E-11_JPRB, 0.81629642E-11_JPRB, 0.84153301E-11_JPRB, &
  & 0.87066257E-11_JPRB, 0.90142173E-11_JPRB, 0.92990901E-11_JPRB, 0.95561389E-11_JPRB, 0.97670812E-11_JPRB, 0.99417011E-11_JPRB, &
  & 0.10110953E-10_JPRB, 0.10305611E-10_JPRB, 0.10557741E-10_JPRB, 0.10909399E-10_JPRB, 0.11357245E-10_JPRB, 0.11885293E-10_JPRB, &
  & 0.12459042E-10_JPRB, 0.13004669E-10_JPRB, 0.13466465E-10_JPRB, 0.13836642E-10_JPRB, 0.14128518E-10_JPRB, 0.14372373E-10_JPRB, &
  & 0.14591411E-10_JPRB, 0.14803332E-10_JPRB, 0.15011709E-10_JPRB, 0.15287757E-10_JPRB, 0.15677537E-10_JPRB, 0.16188228E-10_JPRB, &
  & 0.16779758E-10_JPRB, 0.17536894E-10_JPRB, 0.18430779E-10_JPRB, 0.19514555E-10_JPRB, 0.20636534E-10_JPRB, 0.21689026E-10_JPRB, &
  & 0.22633997E-10_JPRB, 0.23346757E-10_JPRB, 0.23954620E-10_JPRB, 0.24412632E-10_JPRB, 0.24519753E-10_JPRB, 0.23992157E-10_JPRB, &
  & 0.22141112E-10_JPRB, 0.18631959E-10_JPRB, 0.13740145E-10_JPRB, 0.11797859E-10_JPRB, 0.99707274E-11_JPRB, 0.78040126E-11_JPRB, &
  & 0.66784642E-11_JPRB, 0.74346831E-11_JPRB, 0.72937021E-11_JPRB, 0.59039774E-11_JPRB /)

RGHG4(:,71,11) = (/ &
  & 0.67704974E-11_JPRB, 0.73747466E-11_JPRB, 0.76507351E-11_JPRB, 0.77011470E-11_JPRB, 0.77915088E-11_JPRB, 0.79802848E-11_JPRB, &
  & 0.81936246E-11_JPRB, 0.83482804E-11_JPRB, 0.78557594E-11_JPRB, 0.79305685E-11_JPRB, 0.80922456E-11_JPRB, 0.82738989E-11_JPRB, &
  & 0.84752040E-11_JPRB, 0.86698071E-11_JPRB, 0.88672663E-11_JPRB, 0.90643404E-11_JPRB, 0.92882308E-11_JPRB, 0.95544605E-11_JPRB, &
  & 0.98627547E-11_JPRB, 0.10196934E-10_JPRB, 0.10518516E-10_JPRB, 0.10827972E-10_JPRB, 0.11104460E-10_JPRB, 0.11355119E-10_JPRB, &
  & 0.11611726E-10_JPRB, 0.11898133E-10_JPRB, 0.12236696E-10_JPRB, 0.12684977E-10_JPRB, 0.13240203E-10_JPRB, 0.13870412E-10_JPRB, &
  & 0.14523172E-10_JPRB, 0.15141497E-10_JPRB, 0.15668808E-10_JPRB, 0.16097346E-10_JPRB, 0.16444974E-10_JPRB, 0.16742099E-10_JPRB, &
  & 0.16999823E-10_JPRB, 0.17185451E-10_JPRB, 0.17416363E-10_JPRB, 0.17719088E-10_JPRB, 0.18142748E-10_JPRB, 0.18708698E-10_JPRB, &
  & 0.19380294E-10_JPRB, 0.20240561E-10_JPRB, 0.21247176E-10_JPRB, 0.22463397E-10_JPRB, 0.23723499E-10_JPRB, 0.24925019E-10_JPRB, &
  & 0.26023888E-10_JPRB, 0.26900425E-10_JPRB, 0.27679560E-10_JPRB, 0.28227155E-10_JPRB, 0.28445893E-10_JPRB, 0.27987557E-10_JPRB, &
  & 0.26053874E-10_JPRB, 0.22244147E-10_JPRB, 0.16838591E-10_JPRB, 0.14786670E-10_JPRB, 0.12698627E-10_JPRB, 0.10239152E-10_JPRB, &
  & 0.89508002E-11_JPRB, 0.99319147E-11_JPRB, 0.97677075E-11_JPRB, 0.77839714E-11_JPRB /)

RGHG4(:,72,11) = (/ &
  & 0.75389400E-11_JPRB, 0.82772678E-11_JPRB, 0.85836191E-11_JPRB, 0.86419301E-11_JPRB, 0.87448980E-11_JPRB, 0.89659538E-11_JPRB, &
  & 0.92052373E-11_JPRB, 0.94050731E-11_JPRB, 0.89198648E-11_JPRB, 0.90497349E-11_JPRB, 0.92284782E-11_JPRB, 0.94428285E-11_JPRB, &
  & 0.96807831E-11_JPRB, 0.99065443E-11_JPRB, 0.10143456E-10_JPRB, 0.10379310E-10_JPRB, 0.10631294E-10_JPRB, 0.10925243E-10_JPRB, &
  & 0.11260186E-10_JPRB, 0.11631836E-10_JPRB, 0.12000394E-10_JPRB, 0.12369304E-10_JPRB, 0.12722971E-10_JPRB, 0.13058582E-10_JPRB, &
  & 0.13411192E-10_JPRB, 0.13795945E-10_JPRB, 0.14223765E-10_JPRB, 0.14774027E-10_JPRB, 0.15403095E-10_JPRB, 0.16122804E-10_JPRB, &
  & 0.16879002E-10_JPRB, 0.17589709E-10_JPRB, 0.18196569E-10_JPRB, 0.18694947E-10_JPRB, 0.19097514E-10_JPRB, 0.19439108E-10_JPRB, &
  & 0.19737188E-10_JPRB, 0.20014743E-10_JPRB, 0.20251651E-10_JPRB, 0.20569700E-10_JPRB, 0.21031080E-10_JPRB, 0.21657103E-10_JPRB, &
  & 0.22411151E-10_JPRB, 0.23373916E-10_JPRB, 0.24502006E-10_JPRB, 0.25835788E-10_JPRB, 0.27223479E-10_JPRB, 0.28533240E-10_JPRB, &
  & 0.29739405E-10_JPRB, 0.30724756E-10_JPRB, 0.31619450E-10_JPRB, 0.32281143E-10_JPRB, 0.32663556E-10_JPRB, 0.32291458E-10_JPRB, &
  & 0.30277017E-10_JPRB, 0.26470073E-10_JPRB, 0.21187668E-10_JPRB, 0.18850962E-10_JPRB, 0.16646995E-10_JPRB, 0.13760330E-10_JPRB, &
  & 0.12469147E-10_JPRB, 0.13509694E-10_JPRB, 0.13284544E-10_JPRB, 0.10627856E-10_JPRB /)

RGHG4(:,73,11) = (/ &
  & 0.84565402E-11_JPRB, 0.92980901E-11_JPRB, 0.96451935E-11_JPRB, 0.97044317E-11_JPRB, 0.98252552E-11_JPRB, 0.10075136E-10_JPRB, &
  & 0.10363709E-10_JPRB, 0.10608250E-10_JPRB, 0.10146563E-10_JPRB, 0.10322863E-10_JPRB, 0.10573518E-10_JPRB, 0.10833295E-10_JPRB, &
  & 0.11118538E-10_JPRB, 0.11391894E-10_JPRB, 0.11660437E-10_JPRB, 0.11923142E-10_JPRB, 0.12207318E-10_JPRB, 0.12533856E-10_JPRB, &
  & 0.12907725E-10_JPRB, 0.13329125E-10_JPRB, 0.13758237E-10_JPRB, 0.14202256E-10_JPRB, 0.14643146E-10_JPRB, 0.15077243E-10_JPRB, &
  & 0.15534045E-10_JPRB, 0.16029447E-10_JPRB, 0.16555070E-10_JPRB, 0.17223268E-10_JPRB, 0.17994075E-10_JPRB, 0.18826801E-10_JPRB, &
  & 0.19671672E-10_JPRB, 0.20468009E-10_JPRB, 0.21160079E-10_JPRB, 0.21743935E-10_JPRB, 0.22231720E-10_JPRB, 0.22649752E-10_JPRB, &
  & 0.23006212E-10_JPRB, 0.23239579E-10_JPRB, 0.23512079E-10_JPRB, 0.23872465E-10_JPRB, 0.24375359E-10_JPRB, 0.25060653E-10_JPRB, &
  & 0.25891622E-10_JPRB, 0.26945142E-10_JPRB, 0.28172817E-10_JPRB, 0.29601151E-10_JPRB, 0.31089756E-10_JPRB, 0.32504218E-10_JPRB, &
  & 0.33819756E-10_JPRB, 0.34951687E-10_JPRB, 0.35982040E-10_JPRB, 0.36714860E-10_JPRB, 0.37206852E-10_JPRB, 0.36847834E-10_JPRB, &
  & 0.34953991E-10_JPRB, 0.31179823E-10_JPRB, 0.26843068E-10_JPRB, 0.24233126E-10_JPRB, 0.21822547E-10_JPRB, 0.18823261E-10_JPRB, &
  & 0.17418261E-10_JPRB, 0.18368930E-10_JPRB, 0.18050140E-10_JPRB, 0.14616279E-10_JPRB /)

RGHG4(:,74,11) = (/ &
  & 0.95489953E-11_JPRB, 0.10473761E-10_JPRB, 0.10839980E-10_JPRB, 0.10905544E-10_JPRB, 0.11043385E-10_JPRB, 0.11332989E-10_JPRB, &
  & 0.11668374E-10_JPRB, 0.11988710E-10_JPRB, 0.11535458E-10_JPRB, 0.11798998E-10_JPRB, 0.12064239E-10_JPRB, 0.12391667E-10_JPRB, &
  & 0.12720892E-10_JPRB, 0.13052861E-10_JPRB, 0.13380013E-10_JPRB, 0.13709576E-10_JPRB, 0.14041996E-10_JPRB, 0.14418315E-10_JPRB, &
  & 0.14842506E-10_JPRB, 0.15329137E-10_JPRB, 0.15832422E-10_JPRB, 0.16364483E-10_JPRB, 0.16906827E-10_JPRB, 0.17450605E-10_JPRB, &
  & 0.18026986E-10_JPRB, 0.18639063E-10_JPRB, 0.19281210E-10_JPRB, 0.20050947E-10_JPRB, 0.20888728E-10_JPRB, 0.21818521E-10_JPRB, &
  & 0.22780267E-10_JPRB, 0.23689283E-10_JPRB, 0.24487697E-10_JPRB, 0.25170518E-10_JPRB, 0.25738411E-10_JPRB, 0.26220189E-10_JPRB, &
  & 0.26643864E-10_JPRB, 0.27014283E-10_JPRB, 0.27313296E-10_JPRB, 0.27690248E-10_JPRB, 0.28237680E-10_JPRB, 0.28979357E-10_JPRB, &
  & 0.29876695E-10_JPRB, 0.31006558E-10_JPRB, 0.32318297E-10_JPRB, 0.33818004E-10_JPRB, 0.35382648E-10_JPRB, 0.36859259E-10_JPRB, &
  & 0.38248179E-10_JPRB, 0.39437731E-10_JPRB, 0.40543627E-10_JPRB, 0.41416915E-10_JPRB, 0.42060262E-10_JPRB, 0.41755523E-10_JPRB, &
  & 0.40060236E-10_JPRB, 0.36690043E-10_JPRB, 0.33545423E-10_JPRB, 0.30783619E-10_JPRB, 0.28526927E-10_JPRB, 0.25341210E-10_JPRB, &
  & 0.23944168E-10_JPRB, 0.24761970E-10_JPRB, 0.24250877E-10_JPRB, 0.19910448E-10_JPRB /)

RGHG4(:,75,11) = (/ &
  & 0.10767861E-10_JPRB, 0.11787873E-10_JPRB, 0.12190336E-10_JPRB, 0.12259787E-10_JPRB, 0.12416558E-10_JPRB, 0.12744465E-10_JPRB, &
  & 0.13150683E-10_JPRB, 0.13535794E-10_JPRB, 0.13143872E-10_JPRB, 0.13449499E-10_JPRB, 0.13839153E-10_JPRB, 0.14216541E-10_JPRB, &
  & 0.14627086E-10_JPRB, 0.15022306E-10_JPRB, 0.15399926E-10_JPRB, 0.15772229E-10_JPRB, 0.16161508E-10_JPRB, 0.16593883E-10_JPRB, &
  & 0.17087070E-10_JPRB, 0.17650529E-10_JPRB, 0.18251062E-10_JPRB, 0.18889876E-10_JPRB, 0.19551399E-10_JPRB, 0.20220145E-10_JPRB, &
  & 0.20929028E-10_JPRB, 0.21665983E-10_JPRB, 0.22446215E-10_JPRB, 0.23346781E-10_JPRB, 0.24373774E-10_JPRB, 0.25441781E-10_JPRB, &
  & 0.26514362E-10_JPRB, 0.27533698E-10_JPRB, 0.28449928E-10_JPRB, 0.29252743E-10_JPRB, 0.29941761E-10_JPRB, 0.30513720E-10_JPRB, &
  & 0.30993371E-10_JPRB, 0.31290390E-10_JPRB, 0.31628297E-10_JPRB, 0.32063397E-10_JPRB, 0.32655014E-10_JPRB, 0.33451398E-10_JPRB, &
  & 0.34405312E-10_JPRB, 0.35593656E-10_JPRB, 0.36956174E-10_JPRB, 0.38500342E-10_JPRB, 0.40108191E-10_JPRB, 0.41621383E-10_JPRB, &
  & 0.43062279E-10_JPRB, 0.44359957E-10_JPRB, 0.45569531E-10_JPRB, 0.46513394E-10_JPRB, 0.47276787E-10_JPRB, 0.47085957E-10_JPRB, &
  & 0.45847940E-10_JPRB, 0.42692943E-10_JPRB, 0.41129072E-10_JPRB, 0.38721745E-10_JPRB, 0.36610204E-10_JPRB, 0.33495824E-10_JPRB, &
  & 0.32119956E-10_JPRB, 0.32805588E-10_JPRB, 0.32057940E-10_JPRB, 0.26689513E-10_JPRB /)

RGHG4(:,76,11) = (/ &
  & 0.12153176E-10_JPRB, 0.13274996E-10_JPRB, 0.13700878E-10_JPRB, 0.13777127E-10_JPRB, 0.13951056E-10_JPRB, 0.14323958E-10_JPRB, &
  & 0.14795344E-10_JPRB, 0.15281561E-10_JPRB, 0.14905398E-10_JPRB, 0.15332352E-10_JPRB, 0.15729272E-10_JPRB, 0.16205674E-10_JPRB, &
  & 0.16666177E-10_JPRB, 0.17141432E-10_JPRB, 0.17614986E-10_JPRB, 0.18090212E-10_JPRB, 0.18570185E-10_JPRB, 0.19079103E-10_JPRB, &
  & 0.19653274E-10_JPRB, 0.20316020E-10_JPRB, 0.21027218E-10_JPRB, 0.21798823E-10_JPRB, 0.22590542E-10_JPRB, 0.23402922E-10_JPRB, &
  & 0.24258040E-10_JPRB, 0.25124900E-10_JPRB, 0.26063591E-10_JPRB, 0.27061919E-10_JPRB, 0.28108847E-10_JPRB, 0.29259369E-10_JPRB, &
  & 0.30442461E-10_JPRB, 0.31584617E-10_JPRB, 0.32633105E-10_JPRB, 0.33563954E-10_JPRB, 0.34374070E-10_JPRB, 0.35074211E-10_JPRB, &
  & 0.35686207E-10_JPRB, 0.36162386E-10_JPRB, 0.36569969E-10_JPRB, 0.37012230E-10_JPRB, 0.37652936E-10_JPRB, 0.38490433E-10_JPRB, &
  & 0.39486799E-10_JPRB, 0.40703520E-10_JPRB, 0.42089592E-10_JPRB, 0.43643544E-10_JPRB, 0.45247944E-10_JPRB, 0.46758524E-10_JPRB, &
  & 0.48190389E-10_JPRB, 0.49466778E-10_JPRB, 0.50719436E-10_JPRB, 0.51775997E-10_JPRB, 0.52740166E-10_JPRB, 0.52750970E-10_JPRB, &
  & 0.51854680E-10_JPRB, 0.49460915E-10_JPRB, 0.49798519E-10_JPRB, 0.47916573E-10_JPRB, 0.46130388E-10_JPRB, 0.43336702E-10_JPRB, &
  & 0.42004882E-10_JPRB, 0.42600624E-10_JPRB, 0.41521640E-10_JPRB, 0.35013704E-10_JPRB /)

RGHG4(:,77,11) = (/ &
  & 0.13708500E-10_JPRB, 0.14917395E-10_JPRB, 0.15366691E-10_JPRB, 0.15447919E-10_JPRB, 0.15634173E-10_JPRB, 0.16045901E-10_JPRB, &
  & 0.16598844E-10_JPRB, 0.17163130E-10_JPRB, 0.16868137E-10_JPRB, 0.17336941E-10_JPRB, 0.17879405E-10_JPRB, 0.18400316E-10_JPRB, &
  & 0.18969231E-10_JPRB, 0.19523393E-10_JPRB, 0.20068685E-10_JPRB, 0.20621865E-10_JPRB, 0.21197117E-10_JPRB, 0.21815874E-10_JPRB, &
  & 0.22505791E-10_JPRB, 0.23285884E-10_JPRB, 0.24136963E-10_JPRB, 0.25051183E-10_JPRB, 0.25992600E-10_JPRB, 0.26951824E-10_JPRB, &
  & 0.27958282E-10_JPRB, 0.28959786E-10_JPRB, 0.30061991E-10_JPRB, 0.31239455E-10_JPRB, 0.32514116E-10_JPRB, 0.33835441E-10_JPRB, &
  & 0.35162043E-10_JPRB, 0.36456598E-10_JPRB, 0.37661822E-10_JPRB, 0.38748567E-10_JPRB, 0.39703810E-10_JPRB, 0.40472053E-10_JPRB, &
  & 0.41042610E-10_JPRB, 0.41483251E-10_JPRB, 0.41918864E-10_JPRB, 0.42473618E-10_JPRB, 0.43159691E-10_JPRB, 0.44032798E-10_JPRB, &
  & 0.45042747E-10_JPRB, 0.46260506E-10_JPRB, 0.47608112E-10_JPRB, 0.49123910E-10_JPRB, 0.50680259E-10_JPRB, 0.52130480E-10_JPRB, &
  & 0.53526666E-10_JPRB, 0.54850971E-10_JPRB, 0.56128803E-10_JPRB, 0.57158202E-10_JPRB, 0.58283829E-10_JPRB, 0.58519717E-10_JPRB, &
  & 0.58092260E-10_JPRB, 0.56474520E-10_JPRB, 0.59337771E-10_JPRB, 0.58175745E-10_JPRB, 0.57053591E-10_JPRB, 0.54421610E-10_JPRB, &
  & 0.53478725E-10_JPRB, 0.53923560E-10_JPRB, 0.52458336E-10_JPRB, 0.44962548E-10_JPRB /)

RGHG4(:,78,11) = (/ &
  & 0.15416857E-10_JPRB, 0.16640795E-10_JPRB, 0.17063512E-10_JPRB, 0.17142442E-10_JPRB, 0.17334236E-10_JPRB, 0.17776806E-10_JPRB, &
  & 0.18393391E-10_JPRB, 0.19042230E-10_JPRB, 0.18772102E-10_JPRB, 0.19323435E-10_JPRB, 0.19859723E-10_JPRB, 0.20454945E-10_JPRB, &
  & 0.21062060E-10_JPRB, 0.21715711E-10_JPRB, 0.22389481E-10_JPRB, 0.23089582E-10_JPRB, 0.23803248E-10_JPRB, 0.24571708E-10_JPRB, &
  & 0.25401415E-10_JPRB, 0.26327246E-10_JPRB, 0.27324459E-10_JPRB, 0.28393132E-10_JPRB, 0.29474791E-10_JPRB, 0.30574730E-10_JPRB, &
  & 0.31705603E-10_JPRB, 0.32850632E-10_JPRB, 0.34075773E-10_JPRB, 0.35316201E-10_JPRB, 0.36560283E-10_JPRB, 0.37870346E-10_JPRB, &
  & 0.39207970E-10_JPRB, 0.40532969E-10_JPRB, 0.41806798E-10_JPRB, 0.43012458E-10_JPRB, 0.44146430E-10_JPRB, 0.45167127E-10_JPRB, &
  & 0.46107659E-10_JPRB, 0.46808554E-10_JPRB, 0.47388305E-10_JPRB, 0.48021160E-10_JPRB, 0.48780674E-10_JPRB, 0.49677321E-10_JPRB, &
  & 0.50665933E-10_JPRB, 0.51821401E-10_JPRB, 0.53090275E-10_JPRB, 0.54486683E-10_JPRB, 0.55932120E-10_JPRB, 0.57266032E-10_JPRB, &
  & 0.58566471E-10_JPRB, 0.59773006E-10_JPRB, 0.61042969E-10_JPRB, 0.62055888E-10_JPRB, 0.63308303E-10_JPRB, 0.63842251E-10_JPRB, &
  & 0.63744135E-10_JPRB, 0.63135309E-10_JPRB, 0.69159810E-10_JPRB, 0.68582126E-10_JPRB, 0.67766549E-10_JPRB, 0.66204146E-10_JPRB, &
  & 0.65420662E-10_JPRB, 0.65694970E-10_JPRB, 0.64131395E-10_JPRB, 0.56356433E-10_JPRB /)

RGHG4(:,79,11) = (/ &
  & 0.17094199E-10_JPRB, 0.17976599E-10_JPRB, 0.18269181E-10_JPRB, 0.18301324E-10_JPRB, 0.18465800E-10_JPRB, 0.18903934E-10_JPRB, &
  & 0.19523990E-10_JPRB, 0.20198825E-10_JPRB, 0.19938216E-10_JPRB, 0.20489927E-10_JPRB, 0.21054006E-10_JPRB, 0.21658590E-10_JPRB, &
  & 0.22317634E-10_JPRB, 0.23015832E-10_JPRB, 0.23754646E-10_JPRB, 0.24549810E-10_JPRB, 0.25421823E-10_JPRB, 0.26347461E-10_JPRB, &
  & 0.27334633E-10_JPRB, 0.28385069E-10_JPRB, 0.29490240E-10_JPRB, 0.30632104E-10_JPRB, 0.31758089E-10_JPRB, 0.32881756E-10_JPRB, &
  & 0.34000500E-10_JPRB, 0.35140495E-10_JPRB, 0.36317848E-10_JPRB, 0.37590028E-10_JPRB, 0.38888885E-10_JPRB, 0.40202831E-10_JPRB, &
  & 0.41531018E-10_JPRB, 0.42855653E-10_JPRB, 0.44154451E-10_JPRB, 0.45429216E-10_JPRB, 0.46672211E-10_JPRB, 0.47820286E-10_JPRB, &
  & 0.48854292E-10_JPRB, 0.49808133E-10_JPRB, 0.50829875E-10_JPRB, 0.51786648E-10_JPRB, 0.52759186E-10_JPRB, 0.53723491E-10_JPRB, &
  & 0.54667215E-10_JPRB, 0.55717216E-10_JPRB, 0.56790645E-10_JPRB, 0.58002096E-10_JPRB, 0.59223251E-10_JPRB, 0.60357497E-10_JPRB, &
  & 0.61476574E-10_JPRB, 0.62598655E-10_JPRB, 0.63807813E-10_JPRB, 0.64773360E-10_JPRB, 0.65986078E-10_JPRB, 0.66772948E-10_JPRB, &
  & 0.66981275E-10_JPRB, 0.66853564E-10_JPRB, 0.74820226E-10_JPRB, 0.74764445E-10_JPRB, 0.74783194E-10_JPRB, 0.73636514E-10_JPRB, &
  & 0.73534595E-10_JPRB, 0.74106304E-10_JPRB, 0.73354357E-10_JPRB, 0.68276086E-10_JPRB /)

RGHG4(:,80,11) = (/ &
  & 0.18043013E-10_JPRB, 0.18543295E-10_JPRB, 0.18757456E-10_JPRB, 0.18769760E-10_JPRB, 0.18926595E-10_JPRB, 0.19374701E-10_JPRB, &
  & 0.20035060E-10_JPRB, 0.20735840E-10_JPRB, 0.20584852E-10_JPRB, 0.21137397E-10_JPRB, 0.21730397E-10_JPRB, 0.22344628E-10_JPRB, &
  & 0.23016481E-10_JPRB, 0.23755201E-10_JPRB, 0.24536701E-10_JPRB, 0.25372015E-10_JPRB, 0.26245263E-10_JPRB, 0.27193055E-10_JPRB, &
  & 0.28198478E-10_JPRB, 0.29285751E-10_JPRB, 0.30424992E-10_JPRB, 0.31614576E-10_JPRB, 0.32782714E-10_JPRB, 0.33945541E-10_JPRB, &
  & 0.35136876E-10_JPRB, 0.36336698E-10_JPRB, 0.37604780E-10_JPRB, 0.38851495E-10_JPRB, 0.40124480E-10_JPRB, 0.41419056E-10_JPRB, &
  & 0.42739780E-10_JPRB, 0.44060391E-10_JPRB, 0.45374229E-10_JPRB, 0.46687099E-10_JPRB, 0.47974406E-10_JPRB, 0.49203988E-10_JPRB, &
  & 0.50434133E-10_JPRB, 0.51461134E-10_JPRB, 0.52394897E-10_JPRB, 0.53307078E-10_JPRB, 0.54312582E-10_JPRB, 0.55299012E-10_JPRB, &
  & 0.56232161E-10_JPRB, 0.57255301E-10_JPRB, 0.58319440E-10_JPRB, 0.59483890E-10_JPRB, 0.60714843E-10_JPRB, 0.61848214E-10_JPRB, &
  & 0.62983424E-10_JPRB, 0.64069396E-10_JPRB, 0.65287220E-10_JPRB, 0.66309777E-10_JPRB, 0.67408912E-10_JPRB, 0.68266844E-10_JPRB, &
  & 0.68572897E-10_JPRB, 0.68489221E-10_JPRB, 0.76971970E-10_JPRB, 0.76829723E-10_JPRB, 0.76648583E-10_JPRB, 0.76039848E-10_JPRB, &
  & 0.75766567E-10_JPRB, 0.76662426E-10_JPRB, 0.76577189E-10_JPRB, 0.74906636E-10_JPRB /)

RGHG4(:,81,11) = (/ &
  & 0.18758196E-10_JPRB, 0.18963817E-10_JPRB, 0.19141508E-10_JPRB, 0.19151843E-10_JPRB, 0.19292741E-10_JPRB, 0.19751881E-10_JPRB, &
  & 0.20395720E-10_JPRB, 0.21138574E-10_JPRB, 0.20965441E-10_JPRB, 0.21567872E-10_JPRB, 0.22125034E-10_JPRB, 0.22773844E-10_JPRB, &
  & 0.23458673E-10_JPRB, 0.24200239E-10_JPRB, 0.24997096E-10_JPRB, 0.25858487E-10_JPRB, 0.26804592E-10_JPRB, 0.27803797E-10_JPRB, &
  & 0.28864258E-10_JPRB, 0.29973392E-10_JPRB, 0.31150957E-10_JPRB, 0.32353120E-10_JPRB, 0.33526029E-10_JPRB, 0.34671922E-10_JPRB, &
  & 0.35830464E-10_JPRB, 0.36972755E-10_JPRB, 0.38187422E-10_JPRB, 0.39460907E-10_JPRB, 0.40773107E-10_JPRB, 0.42089238E-10_JPRB, &
  & 0.43409571E-10_JPRB, 0.44731087E-10_JPRB, 0.46059059E-10_JPRB, 0.47398814E-10_JPRB, 0.48718481E-10_JPRB, 0.49984950E-10_JPRB, &
  & 0.51152003E-10_JPRB, 0.52228694E-10_JPRB, 0.53390455E-10_JPRB, 0.54448526E-10_JPRB, 0.55490421E-10_JPRB, 0.56501311E-10_JPRB, &
  & 0.57424128E-10_JPRB, 0.58443451E-10_JPRB, 0.59470588E-10_JPRB, 0.60617747E-10_JPRB, 0.61771289E-10_JPRB, 0.62830859E-10_JPRB, &
  & 0.63870485E-10_JPRB, 0.64907774E-10_JPRB, 0.66056195E-10_JPRB, 0.67132598E-10_JPRB, 0.68138939E-10_JPRB, 0.69049579E-10_JPRB, &
  & 0.69427283E-10_JPRB, 0.69420122E-10_JPRB, 0.78067407E-10_JPRB, 0.78277503E-10_JPRB, 0.78186888E-10_JPRB, 0.77686330E-10_JPRB, &
  & 0.77492249E-10_JPRB, 0.78500234E-10_JPRB, 0.78619618E-10_JPRB, 0.78759228E-10_JPRB /)

RGHG4(:,82,11) = (/ &
  & 0.19182942E-10_JPRB, 0.19119610E-10_JPRB, 0.19293935E-10_JPRB, 0.19297723E-10_JPRB, 0.19432228E-10_JPRB, 0.19901058E-10_JPRB, &
  & 0.20569707E-10_JPRB, 0.21326921E-10_JPRB, 0.21276779E-10_JPRB, 0.21843034E-10_JPRB, 0.22454871E-10_JPRB, 0.23076121E-10_JPRB, &
  & 0.23774991E-10_JPRB, 0.24536604E-10_JPRB, 0.25345007E-10_JPRB, 0.26210584E-10_JPRB, 0.27120792E-10_JPRB, 0.28108684E-10_JPRB, &
  & 0.29153596E-10_JPRB, 0.30271719E-10_JPRB, 0.31444979E-10_JPRB, 0.32664611E-10_JPRB, 0.33831576E-10_JPRB, 0.35008201E-10_JPRB, &
  & 0.36189940E-10_JPRB, 0.37406352E-10_JPRB, 0.38652064E-10_JPRB, 0.39937074E-10_JPRB, 0.41215434E-10_JPRB, 0.42530420E-10_JPRB, &
  & 0.43850392E-10_JPRB, 0.45173462E-10_JPRB, 0.46517994E-10_JPRB, 0.47879818E-10_JPRB, 0.49219403E-10_JPRB, 0.50502415E-10_JPRB, &
  & 0.51749768E-10_JPRB, 0.52900448E-10_JPRB, 0.53900273E-10_JPRB, 0.54939511E-10_JPRB, 0.55952045E-10_JPRB, 0.56992182E-10_JPRB, &
  & 0.57921199E-10_JPRB, 0.58926072E-10_JPRB, 0.59957546E-10_JPRB, 0.61078760E-10_JPRB, 0.62252356E-10_JPRB, 0.63324686E-10_JPRB, &
  & 0.64413433E-10_JPRB, 0.65470476E-10_JPRB, 0.66601447E-10_JPRB, 0.67747634E-10_JPRB, 0.68692781E-10_JPRB, 0.69590944E-10_JPRB, &
  & 0.69905366E-10_JPRB, 0.69906129E-10_JPRB, 0.78297209E-10_JPRB, 0.78524201E-10_JPRB, 0.78249823E-10_JPRB, 0.78044328E-10_JPRB, &
  & 0.77650483E-10_JPRB, 0.78802458E-10_JPRB, 0.79188156E-10_JPRB, 0.81241229E-10_JPRB /)

RGHG4(:,83,11) = (/ &
  & 0.19212357E-10_JPRB, 0.19262021E-10_JPRB, 0.19476129E-10_JPRB, 0.19482237E-10_JPRB, 0.19620649E-10_JPRB, 0.20108875E-10_JPRB, &
  & 0.20774757E-10_JPRB, 0.21557089E-10_JPRB, 0.21493628E-10_JPRB, 0.22107394E-10_JPRB, 0.22663768E-10_JPRB, 0.23329639E-10_JPRB, &
  & 0.24016261E-10_JPRB, 0.24779189E-10_JPRB, 0.25596768E-10_JPRB, 0.26477671E-10_JPRB, 0.27438687E-10_JPRB, 0.28448898E-10_JPRB, &
  & 0.29514113E-10_JPRB, 0.30632687E-10_JPRB, 0.31821008E-10_JPRB, 0.33036265E-10_JPRB, 0.34209541E-10_JPRB, 0.35386440E-10_JPRB, &
  & 0.36530445E-10_JPRB, 0.37703878E-10_JPRB, 0.38903464E-10_JPRB, 0.40201887E-10_JPRB, 0.41513418E-10_JPRB, 0.42844787E-10_JPRB, &
  & 0.44172492E-10_JPRB, 0.45497515E-10_JPRB, 0.46860779E-10_JPRB, 0.48241015E-10_JPRB, 0.49599932E-10_JPRB, 0.50896853E-10_JPRB, &
  & 0.52114060E-10_JPRB, 0.53235721E-10_JPRB, 0.54355444E-10_JPRB, 0.55467429E-10_JPRB, 0.56518946E-10_JPRB, 0.57529596E-10_JPRB, &
  & 0.58490914E-10_JPRB, 0.59497192E-10_JPRB, 0.60538345E-10_JPRB, 0.61682159E-10_JPRB, 0.62832718E-10_JPRB, 0.63877660E-10_JPRB, &
  & 0.64885368E-10_JPRB, 0.65909826E-10_JPRB, 0.66980720E-10_JPRB, 0.68152609E-10_JPRB, 0.69059938E-10_JPRB, 0.69981659E-10_JPRB, &
  & 0.70270241E-10_JPRB, 0.70363028E-10_JPRB, 0.78695377E-10_JPRB, 0.79104459E-10_JPRB, 0.78746447E-10_JPRB, 0.78598482E-10_JPRB, &
  & 0.78237146E-10_JPRB, 0.79159387E-10_JPRB, 0.79563592E-10_JPRB, 0.81117446E-10_JPRB /)

RGHG4(:,84,11) = (/ &
  & 0.19326716E-10_JPRB, 0.19353475E-10_JPRB, 0.19576398E-10_JPRB, 0.19559547E-10_JPRB, 0.19705593E-10_JPRB, 0.20198530E-10_JPRB, &
  & 0.20874627E-10_JPRB, 0.21691884E-10_JPRB, 0.21713907E-10_JPRB, 0.22301716E-10_JPRB, 0.22902492E-10_JPRB, 0.23510707E-10_JPRB, &
  & 0.24221521E-10_JPRB, 0.24980525E-10_JPRB, 0.25810366E-10_JPRB, 0.26691177E-10_JPRB, 0.27618303E-10_JPRB, 0.28615667E-10_JPRB, &
  & 0.29676612E-10_JPRB, 0.30790669E-10_JPRB, 0.31977306E-10_JPRB, 0.33182051E-10_JPRB, 0.34365285E-10_JPRB, 0.35553088E-10_JPRB, &
  & 0.36713636E-10_JPRB, 0.37943412E-10_JPRB, 0.39178570E-10_JPRB, 0.40470426E-10_JPRB, 0.41763901E-10_JPRB, 0.43090895E-10_JPRB, &
  & 0.44427198E-10_JPRB, 0.45754876E-10_JPRB, 0.47136697E-10_JPRB, 0.48533347E-10_JPRB, 0.49906031E-10_JPRB, 0.51210241E-10_JPRB, &
  & 0.52471562E-10_JPRB, 0.53626284E-10_JPRB, 0.54700619E-10_JPRB, 0.55758381E-10_JPRB, 0.56800047E-10_JPRB, 0.57824093E-10_JPRB, &
  & 0.58777719E-10_JPRB, 0.59802809E-10_JPRB, 0.60821972E-10_JPRB, 0.61952991E-10_JPRB, 0.63092746E-10_JPRB, 0.64145279E-10_JPRB, &
  & 0.65195703E-10_JPRB, 0.66237849E-10_JPRB, 0.67292671E-10_JPRB, 0.68499338E-10_JPRB, 0.69390320E-10_JPRB, 0.70287894E-10_JPRB, &
  & 0.70506281E-10_JPRB, 0.70504241E-10_JPRB, 0.78673887E-10_JPRB, 0.79065435E-10_JPRB, 0.78740695E-10_JPRB, 0.78550257E-10_JPRB, &
  & 0.78398468E-10_JPRB, 0.79131195E-10_JPRB, 0.79830337E-10_JPRB, 0.81241805E-10_JPRB /)

RGHG4(:,85,11) = (/ &
  & 0.19422098E-10_JPRB, 0.19428379E-10_JPRB, 0.19692047E-10_JPRB, 0.19665448E-10_JPRB, 0.19844119E-10_JPRB, 0.20340977E-10_JPRB, &
  & 0.21058103E-10_JPRB, 0.21902950E-10_JPRB, 0.21924287E-10_JPRB, 0.22517991E-10_JPRB, 0.23072894E-10_JPRB, 0.23693419E-10_JPRB, &
  & 0.24348308E-10_JPRB, 0.25118326E-10_JPRB, 0.25944557E-10_JPRB, 0.26848643E-10_JPRB, 0.27818225E-10_JPRB, 0.28836926E-10_JPRB, &
  & 0.29890979E-10_JPRB, 0.31018878E-10_JPRB, 0.32183867E-10_JPRB, 0.33396647E-10_JPRB, 0.34605010E-10_JPRB, 0.35748463E-10_JPRB, &
  & 0.36928738E-10_JPRB, 0.38097671E-10_JPRB, 0.39327659E-10_JPRB, 0.40616194E-10_JPRB, 0.41938283E-10_JPRB, 0.43272035E-10_JPRB, &
  & 0.44619912E-10_JPRB, 0.45957415E-10_JPRB, 0.47350346E-10_JPRB, 0.48760874E-10_JPRB, 0.50144448E-10_JPRB, 0.51463864E-10_JPRB, &
  & 0.52701524E-10_JPRB, 0.53858588E-10_JPRB, 0.54973682E-10_JPRB, 0.56077309E-10_JPRB, 0.57175289E-10_JPRB, 0.58170298E-10_JPRB, &
  & 0.59147465E-10_JPRB, 0.60173207E-10_JPRB, 0.61218364E-10_JPRB, 0.62361408E-10_JPRB, 0.63497402E-10_JPRB, 0.64544987E-10_JPRB, &
  & 0.65514316E-10_JPRB, 0.66559092E-10_JPRB, 0.67570186E-10_JPRB, 0.68763585E-10_JPRB, 0.69656753E-10_JPRB, 0.70526592E-10_JPRB, &
  & 0.70814792E-10_JPRB, 0.70750725E-10_JPRB, 0.78992889E-10_JPRB, 0.79259488E-10_JPRB, 0.79100747E-10_JPRB, 0.78641059E-10_JPRB, &
  & 0.78769984E-10_JPRB, 0.79224419E-10_JPRB, 0.79998515E-10_JPRB, 0.81513511E-10_JPRB /)

RGHG4(:,86,11) = (/ &
  & 0.19504079E-10_JPRB, 0.19479621E-10_JPRB, 0.19776441E-10_JPRB, 0.19720631E-10_JPRB, 0.19933293E-10_JPRB, 0.20413846E-10_JPRB, &
  & 0.21240568E-10_JPRB, 0.22038494E-10_JPRB, 0.22169204E-10_JPRB, 0.22721382E-10_JPRB, 0.23273241E-10_JPRB, 0.23833113E-10_JPRB, &
  & 0.24490401E-10_JPRB, 0.25204384E-10_JPRB, 0.26039650E-10_JPRB, 0.26937438E-10_JPRB, 0.27892516E-10_JPRB, 0.28901452E-10_JPRB, &
  & 0.29983672E-10_JPRB, 0.31072103E-10_JPRB, 0.32261627E-10_JPRB, 0.33480562E-10_JPRB, 0.34651188E-10_JPRB, 0.35820246E-10_JPRB, &
  & 0.37024175E-10_JPRB, 0.38222925E-10_JPRB, 0.39483534E-10_JPRB, 0.40778200E-10_JPRB, 0.42089367E-10_JPRB, 0.43426228E-10_JPRB, &
  & 0.44775156E-10_JPRB, 0.46129867E-10_JPRB, 0.47524810E-10_JPRB, 0.48950802E-10_JPRB, 0.50340471E-10_JPRB, 0.51654112E-10_JPRB, &
  & 0.52934237E-10_JPRB, 0.54109439E-10_JPRB, 0.55233113E-10_JPRB, 0.56318616E-10_JPRB, 0.57375656E-10_JPRB, 0.58436020E-10_JPRB, &
  & 0.59373360E-10_JPRB, 0.60416429E-10_JPRB, 0.61423658E-10_JPRB, 0.62567777E-10_JPRB, 0.63641509E-10_JPRB, 0.64722526E-10_JPRB, &
  & 0.65723121E-10_JPRB, 0.66745776E-10_JPRB, 0.67767118E-10_JPRB, 0.68963280E-10_JPRB, 0.69891100E-10_JPRB, 0.70683973E-10_JPRB, &
  & 0.70998186E-10_JPRB, 0.70712977E-10_JPRB, 0.79006579E-10_JPRB, 0.79109455E-10_JPRB, 0.79162656E-10_JPRB, 0.78532368E-10_JPRB, &
  & 0.78843557E-10_JPRB, 0.79243744E-10_JPRB, 0.80097734E-10_JPRB, 0.81583032E-10_JPRB /)

RGHG4(:,87,11) = (/ &
  & 0.19567639E-10_JPRB, 0.19519280E-10_JPRB, 0.19860650E-10_JPRB, 0.19788466E-10_JPRB, 0.20027594E-10_JPRB, 0.20587808E-10_JPRB, &
  & 0.21396674E-10_JPRB, 0.22277626E-10_JPRB, 0.22372342E-10_JPRB, 0.22897824E-10_JPRB, 0.23435592E-10_JPRB, 0.23965290E-10_JPRB, &
  & 0.24563884E-10_JPRB, 0.25285862E-10_JPRB, 0.26082823E-10_JPRB, 0.26996731E-10_JPRB, 0.27978618E-10_JPRB, 0.29026935E-10_JPRB, &
  & 0.30068316E-10_JPRB, 0.31198367E-10_JPRB, 0.32375141E-10_JPRB, 0.33580184E-10_JPRB, 0.34758633E-10_JPRB, 0.35937239E-10_JPRB, &
  & 0.37120283E-10_JPRB, 0.38311871E-10_JPRB, 0.39559068E-10_JPRB, 0.40861575E-10_JPRB, 0.42190803E-10_JPRB, 0.43534999E-10_JPRB, &
  & 0.44891674E-10_JPRB, 0.46249230E-10_JPRB, 0.47645530E-10_JPRB, 0.49068603E-10_JPRB, 0.50460296E-10_JPRB, 0.51803652E-10_JPRB, &
  & 0.53072852E-10_JPRB, 0.54268832E-10_JPRB, 0.55408296E-10_JPRB, 0.56552787E-10_JPRB, 0.57650794E-10_JPRB, 0.58678763E-10_JPRB, &
  & 0.59658528E-10_JPRB, 0.60696531E-10_JPRB, 0.61694441E-10_JPRB, 0.62863277E-10_JPRB, 0.63954911E-10_JPRB, 0.64955583E-10_JPRB, &
  & 0.65979090E-10_JPRB, 0.67013214E-10_JPRB, 0.67988656E-10_JPRB, 0.69141540E-10_JPRB, 0.70090087E-10_JPRB, 0.70852199E-10_JPRB, &
  & 0.71252081E-10_JPRB, 0.70874036E-10_JPRB, 0.79189107E-10_JPRB, 0.79210673E-10_JPRB, 0.79292670E-10_JPRB, 0.78626425E-10_JPRB, &
  & 0.78939827E-10_JPRB, 0.79321938E-10_JPRB, 0.80161995E-10_JPRB, 0.81609504E-10_JPRB /)

RGHG4(:,88,11) = (/ &
  & 0.19616996E-10_JPRB, 0.19559382E-10_JPRB, 0.19919304E-10_JPRB, 0.19818923E-10_JPRB, 0.20105096E-10_JPRB, 0.20609929E-10_JPRB, &
  & 0.21546763E-10_JPRB, 0.22308572E-10_JPRB, 0.22503959E-10_JPRB, 0.23017291E-10_JPRB, 0.23529139E-10_JPRB, 0.24067599E-10_JPRB, &
  & 0.24666142E-10_JPRB, 0.25343113E-10_JPRB, 0.26158584E-10_JPRB, 0.27043964E-10_JPRB, 0.28021257E-10_JPRB, 0.29034716E-10_JPRB, &
  & 0.30112361E-10_JPRB, 0.31226143E-10_JPRB, 0.32414470E-10_JPRB, 0.33598894E-10_JPRB, 0.34786736E-10_JPRB, 0.35959027E-10_JPRB, &
  & 0.37151889E-10_JPRB, 0.38368992E-10_JPRB, 0.39632016E-10_JPRB, 0.40941549E-10_JPRB, 0.42269001E-10_JPRB, 0.43619493E-10_JPRB, &
  & 0.44985411E-10_JPRB, 0.46358795E-10_JPRB, 0.47761722E-10_JPRB, 0.49214202E-10_JPRB, 0.50619765E-10_JPRB, 0.51940337E-10_JPRB, &
  & 0.53239850E-10_JPRB, 0.54451051E-10_JPRB, 0.55608157E-10_JPRB, 0.56735165E-10_JPRB, 0.57834387E-10_JPRB, 0.58886118E-10_JPRB, &
  & 0.59831855E-10_JPRB, 0.60869594E-10_JPRB, 0.61859171E-10_JPRB, 0.62949840E-10_JPRB, 0.64079832E-10_JPRB, 0.65082301E-10_JPRB, &
  & 0.66039382E-10_JPRB, 0.67112017E-10_JPRB, 0.68125727E-10_JPRB, 0.69272643E-10_JPRB, 0.70225749E-10_JPRB, 0.70954249E-10_JPRB, &
  & 0.71371194E-10_JPRB, 0.70862011E-10_JPRB, 0.79138952E-10_JPRB, 0.79184770E-10_JPRB, 0.79254096E-10_JPRB, 0.78610736E-10_JPRB, &
  & 0.78942103E-10_JPRB, 0.79337592E-10_JPRB, 0.80214016E-10_JPRB, 0.81627392E-10_JPRB /)

RGHG4(:,89,11) = (/ &
  & 0.19656020E-10_JPRB, 0.19604205E-10_JPRB, 0.19959867E-10_JPRB, 0.19854569E-10_JPRB, 0.20122104E-10_JPRB, 0.20665129E-10_JPRB, &
  & 0.21469510E-10_JPRB, 0.22372172E-10_JPRB, 0.22519745E-10_JPRB, 0.23019227E-10_JPRB, 0.23567088E-10_JPRB, 0.24085314E-10_JPRB, &
  & 0.24705675E-10_JPRB, 0.25414407E-10_JPRB, 0.26220002E-10_JPRB, 0.27122566E-10_JPRB, 0.28103837E-10_JPRB, 0.29134591E-10_JPRB, &
  & 0.30191662E-10_JPRB, 0.31308300E-10_JPRB, 0.32440682E-10_JPRB, 0.33649743E-10_JPRB, 0.34812750E-10_JPRB, 0.35974671E-10_JPRB, &
  & 0.37165156E-10_JPRB, 0.38371695E-10_JPRB, 0.39633106E-10_JPRB, 0.40948737E-10_JPRB, 0.42287656E-10_JPRB, 0.43647395E-10_JPRB, &
  & 0.45018645E-10_JPRB, 0.46397865E-10_JPRB, 0.47821736E-10_JPRB, 0.49252075E-10_JPRB, 0.50658873E-10_JPRB, 0.52049389E-10_JPRB, &
  & 0.53384214E-10_JPRB, 0.54615926E-10_JPRB, 0.55786036E-10_JPRB, 0.56932882E-10_JPRB, 0.58036489E-10_JPRB, 0.59081559E-10_JPRB, &
  & 0.60049819E-10_JPRB, 0.61057034E-10_JPRB, 0.62075928E-10_JPRB, 0.63172668E-10_JPRB, 0.64252867E-10_JPRB, 0.65320166E-10_JPRB, &
  & 0.66270822E-10_JPRB, 0.67289570E-10_JPRB, 0.68292566E-10_JPRB, 0.69421045E-10_JPRB, 0.70363347E-10_JPRB, 0.71066673E-10_JPRB, &
  & 0.71599671E-10_JPRB, 0.70908897E-10_JPRB, 0.79186914E-10_JPRB, 0.79248767E-10_JPRB, 0.79293475E-10_JPRB, 0.78626695E-10_JPRB, &
  & 0.78996053E-10_JPRB, 0.79343518E-10_JPRB, 0.80280123E-10_JPRB, 0.81639306E-10_JPRB /)

RGHG4(:,90,11) = (/ &
  & 0.19678870E-10_JPRB, 0.19655640E-10_JPRB, 0.19961989E-10_JPRB, 0.19884327E-10_JPRB, 0.20096282E-10_JPRB, 0.20554870E-10_JPRB, &
  & 0.21407069E-10_JPRB, 0.22210440E-10_JPRB, 0.22361869E-10_JPRB, 0.22958968E-10_JPRB, 0.23484993E-10_JPRB, 0.24089758E-10_JPRB, &
  & 0.24727588E-10_JPRB, 0.25471071E-10_JPRB, 0.26295945E-10_JPRB, 0.27201585E-10_JPRB, 0.28155320E-10_JPRB, 0.29160015E-10_JPRB, &
  & 0.30208624E-10_JPRB, 0.31277290E-10_JPRB, 0.32438999E-10_JPRB, 0.33610514E-10_JPRB, 0.34754914E-10_JPRB, 0.35918862E-10_JPRB, &
  & 0.37101829E-10_JPRB, 0.38315719E-10_JPRB, 0.39584294E-10_JPRB, 0.40910327E-10_JPRB, 0.42262867E-10_JPRB, 0.43643297E-10_JPRB, &
  & 0.45042057E-10_JPRB, 0.46446250E-10_JPRB, 0.47881997E-10_JPRB, 0.49411811E-10_JPRB, 0.50870381E-10_JPRB, 0.52245066E-10_JPRB, &
  & 0.53579630E-10_JPRB, 0.54825255E-10_JPRB, 0.55998147E-10_JPRB, 0.57140938E-10_JPRB, 0.58233911E-10_JPRB, 0.59260451E-10_JPRB, &
  & 0.60211336E-10_JPRB, 0.61198255E-10_JPRB, 0.62173655E-10_JPRB, 0.63271374E-10_JPRB, 0.64314845E-10_JPRB, 0.65340837E-10_JPRB, &
  & 0.66330719E-10_JPRB, 0.67363407E-10_JPRB, 0.68394429E-10_JPRB, 0.69521500E-10_JPRB, 0.70471254E-10_JPRB, 0.71055793E-10_JPRB, &
  & 0.71869996E-10_JPRB, 0.70805653E-10_JPRB, 0.79119059E-10_JPRB, 0.79244000E-10_JPRB, 0.79272991E-10_JPRB, 0.78563885E-10_JPRB, &
  & 0.79027833E-10_JPRB, 0.79329841E-10_JPRB, 0.80374318E-10_JPRB, 0.81656064E-10_JPRB /)

RGHG4(:,91,11) = (/ &
  & 0.19660449E-10_JPRB, 0.19729211E-10_JPRB, 0.19919779E-10_JPRB, 0.19923773E-10_JPRB, 0.20041829E-10_JPRB, 0.20506059E-10_JPRB, &
  & 0.18955728E-10_JPRB, 0.21207106E-10_JPRB, 0.22137460E-10_JPRB, 0.22759477E-10_JPRB, 0.23348906E-10_JPRB, 0.24004177E-10_JPRB, &
  & 0.24721921E-10_JPRB, 0.25512046E-10_JPRB, 0.26354013E-10_JPRB, 0.27246042E-10_JPRB, 0.28191408E-10_JPRB, 0.29186480E-10_JPRB, &
  & 0.30208891E-10_JPRB, 0.31272630E-10_JPRB, 0.32383232E-10_JPRB, 0.33521280E-10_JPRB, 0.34645353E-10_JPRB, 0.35793705E-10_JPRB, &
  & 0.36965646E-10_JPRB, 0.38138676E-10_JPRB, 0.39450852E-10_JPRB, 0.40786902E-10_JPRB, 0.42151713E-10_JPRB, 0.43550590E-10_JPRB, &
  & 0.44978170E-10_JPRB, 0.46414147E-10_JPRB, 0.47899011E-10_JPRB, 0.49428822E-10_JPRB, 0.50894081E-10_JPRB, 0.52352702E-10_JPRB, &
  & 0.53797598E-10_JPRB, 0.55090075E-10_JPRB, 0.56271855E-10_JPRB, 0.57414410E-10_JPRB, 0.56353141E-10_JPRB, 0.57460602E-10_JPRB, &
  & 0.60458243E-10_JPRB, 0.61433747E-10_JPRB, 0.62403187E-10_JPRB, 0.63488124E-10_JPRB, 0.64552551E-10_JPRB, 0.65547567E-10_JPRB, &
  & 0.66511449E-10_JPRB, 0.67497813E-10_JPRB, 0.68536392E-10_JPRB, 0.69639704E-10_JPRB, 0.70699044E-10_JPRB, 0.70882925E-10_JPRB, &
  & 0.72299534E-10_JPRB, 0.70678206E-10_JPRB, 0.79032565E-10_JPRB, 0.79309691E-10_JPRB, 0.79259196E-10_JPRB, 0.78481804E-10_JPRB, &
  & 0.79075052E-10_JPRB, 0.79340923E-10_JPRB, 0.80544987E-10_JPRB, 0.81682598E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG4(:, 1,12) = (/ &
  & 0.11688060E-12_JPRB, 0.11912104E-12_JPRB, 0.98299224E-13_JPRB, 0.11806100E-12_JPRB, 0.11914050E-12_JPRB, 0.13221200E-12_JPRB, &
  & 0.13867825E-12_JPRB, 0.14974622E-12_JPRB, 0.15488636E-12_JPRB, 0.15380606E-12_JPRB, 0.15258500E-12_JPRB, 0.14853177E-12_JPRB, &
  & 0.14331707E-12_JPRB, 0.14150283E-12_JPRB, 0.13602151E-12_JPRB, 0.13427105E-12_JPRB, 0.13433273E-12_JPRB, 0.12977184E-12_JPRB, &
  & 0.12921100E-12_JPRB, 0.12936914E-12_JPRB, 0.13076043E-12_JPRB, 0.12554942E-12_JPRB, 0.12510500E-12_JPRB, 0.12547999E-12_JPRB, &
  & 0.12672185E-12_JPRB, 0.12941006E-12_JPRB, 0.12587303E-12_JPRB, 0.12736497E-12_JPRB, 0.12876524E-12_JPRB, 0.12968355E-12_JPRB, &
  & 0.12975673E-12_JPRB, 0.12924640E-12_JPRB, 0.12039630E-12_JPRB, 0.11580786E-12_JPRB, 0.11118142E-12_JPRB, 0.10735536E-12_JPRB, &
  & 0.10512251E-12_JPRB, 0.10524105E-12_JPRB, 0.10083257E-12_JPRB, 0.10207725E-12_JPRB, 0.10419318E-12_JPRB, 0.10655872E-12_JPRB, &
  & 0.10912965E-12_JPRB, 0.10447132E-12_JPRB, 0.10336290E-12_JPRB, 0.10172469E-12_JPRB, 0.10054977E-12_JPRB, 0.92276067E-13_JPRB, &
  & 0.88622198E-13_JPRB, 0.86589813E-13_JPRB, 0.75920979E-13_JPRB, 0.72566309E-13_JPRB, 0.60464796E-13_JPRB, 0.51205581E-13_JPRB, &
  & 0.47782833E-13_JPRB, 0.59872537E-13_JPRB, 0.96292163E-09_JPRB, 0.96946651E-09_JPRB, 0.97315145E-09_JPRB, 0.97290687E-09_JPRB, &
  & 0.97404129E-09_JPRB, 0.97552855E-09_JPRB, 0.98151298E-09_JPRB, 0.98856412E-09_JPRB /)

RGHG4(:, 2,12) = (/ &
  & 0.92047485E-12_JPRB, 0.68098348E-12_JPRB, 0.54277508E-12_JPRB, 0.52108079E-12_JPRB, 0.51226758E-12_JPRB, 0.53794881E-12_JPRB, &
  & 0.58929619E-12_JPRB, 0.67280150E-12_JPRB, 0.81444102E-12_JPRB, 0.91651459E-12_JPRB, 0.96727498E-12_JPRB, 0.10012852E-11_JPRB, &
  & 0.10302780E-11_JPRB, 0.10691732E-11_JPRB, 0.11375725E-11_JPRB, 0.11947161E-11_JPRB, 0.12709097E-11_JPRB, 0.13393342E-11_JPRB, &
  & 0.13523081E-11_JPRB, 0.13559489E-11_JPRB, 0.13373731E-11_JPRB, 0.12985537E-11_JPRB, 0.12219136E-11_JPRB, 0.11532070E-11_JPRB, &
  & 0.10889865E-11_JPRB, 0.10299032E-11_JPRB, 0.98312818E-12_JPRB, 0.92046162E-12_JPRB, 0.87076125E-12_JPRB, 0.82780571E-12_JPRB, &
  & 0.79201088E-12_JPRB, 0.76388933E-12_JPRB, 0.74300695E-12_JPRB, 0.70105271E-12_JPRB, 0.67141545E-12_JPRB, 0.64755503E-12_JPRB, &
  & 0.62905741E-12_JPRB, 0.61709757E-12_JPRB, 0.61139982E-12_JPRB, 0.59172334E-12_JPRB, 0.57542680E-12_JPRB, 0.55127300E-12_JPRB, &
  & 0.52556348E-12_JPRB, 0.49533007E-12_JPRB, 0.45317626E-12_JPRB, 0.40748253E-12_JPRB, 0.36245117E-12_JPRB, 0.32930687E-12_JPRB, &
  & 0.30706647E-12_JPRB, 0.30005498E-12_JPRB, 0.30090744E-12_JPRB, 0.29692004E-12_JPRB, 0.28610640E-12_JPRB, 0.27080058E-12_JPRB, &
  & 0.25516769E-12_JPRB, 0.24208752E-12_JPRB, 0.10075801E-19_JPRB, 0.10071878E-19_JPRB, 0.10065144E-19_JPRB, 0.10056253E-19_JPRB, &
  & 0.10046316E-19_JPRB, 0.34916670E-10_JPRB, 0.90248524E-10_JPRB, 0.18049134E-09_JPRB /)

RGHG4(:, 3,12) = (/ &
  & 0.22988905E-11_JPRB, 0.17420732E-11_JPRB, 0.15398492E-11_JPRB, 0.14307044E-11_JPRB, 0.13702808E-11_JPRB, 0.13438982E-11_JPRB, &
  & 0.13537816E-11_JPRB, 0.14073081E-11_JPRB, 0.16034799E-11_JPRB, 0.17131455E-11_JPRB, 0.18019763E-11_JPRB, 0.19066435E-11_JPRB, &
  & 0.20130505E-11_JPRB, 0.21378214E-11_JPRB, 0.22888343E-11_JPRB, 0.24138647E-11_JPRB, 0.25485762E-11_JPRB, 0.26376564E-11_JPRB, &
  & 0.26483670E-11_JPRB, 0.26474779E-11_JPRB, 0.26026403E-11_JPRB, 0.25302874E-11_JPRB, 0.24026196E-11_JPRB, 0.22947484E-11_JPRB, &
  & 0.21915063E-11_JPRB, 0.20971215E-11_JPRB, 0.20152081E-11_JPRB, 0.19043688E-11_JPRB, 0.18222223E-11_JPRB, 0.17528213E-11_JPRB, &
  & 0.16914130E-11_JPRB, 0.16325643E-11_JPRB, 0.15885217E-11_JPRB, 0.15134566E-11_JPRB, 0.14614012E-11_JPRB, 0.14222135E-11_JPRB, &
  & 0.13948683E-11_JPRB, 0.13770184E-11_JPRB, 0.13742553E-11_JPRB, 0.13466729E-11_JPRB, 0.13169639E-11_JPRB, 0.12722592E-11_JPRB, &
  & 0.12083187E-11_JPRB, 0.11361388E-11_JPRB, 0.10387502E-11_JPRB, 0.94076851E-12_JPRB, 0.84557535E-12_JPRB, 0.76427889E-12_JPRB, &
  & 0.68383510E-12_JPRB, 0.60488290E-12_JPRB, 0.53205248E-12_JPRB, 0.47775548E-12_JPRB, 0.44834863E-12_JPRB, 0.42937862E-12_JPRB, &
  & 0.41346909E-12_JPRB, 0.40650553E-12_JPRB, 0.19052671E-09_JPRB, 0.14737477E-09_JPRB, 0.15209344E-09_JPRB, 0.17736350E-09_JPRB, &
  & 0.23169161E-09_JPRB, 0.27776087E-09_JPRB, 0.36362952E-09_JPRB, 0.49030618E-09_JPRB /)

RGHG4(:, 4,12) = (/ &
  & 0.60972451E-11_JPRB, 0.50904086E-11_JPRB, 0.46350532E-11_JPRB, 0.43721628E-11_JPRB, 0.42187252E-11_JPRB, 0.41510883E-11_JPRB, &
  & 0.41366472E-11_JPRB, 0.41858370E-11_JPRB, 0.43765993E-11_JPRB, 0.44631096E-11_JPRB, 0.45559021E-11_JPRB, 0.46777942E-11_JPRB, &
  & 0.48297451E-11_JPRB, 0.49965392E-11_JPRB, 0.51805335E-11_JPRB, 0.53118308E-11_JPRB, 0.54351636E-11_JPRB, 0.54851245E-11_JPRB, &
  & 0.54467485E-11_JPRB, 0.53914373E-11_JPRB, 0.52808400E-11_JPRB, 0.51370527E-11_JPRB, 0.49229466E-11_JPRB, 0.47464454E-11_JPRB, &
  & 0.45722432E-11_JPRB, 0.44200446E-11_JPRB, 0.42874805E-11_JPRB, 0.41236992E-11_JPRB, 0.40043416E-11_JPRB, 0.38942066E-11_JPRB, &
  & 0.37922079E-11_JPRB, 0.36897260E-11_JPRB, 0.36177357E-11_JPRB, 0.35007370E-11_JPRB, 0.34224728E-11_JPRB, 0.33707707E-11_JPRB, &
  & 0.33492939E-11_JPRB, 0.33468265E-11_JPRB, 0.33692116E-11_JPRB, 0.33391911E-11_JPRB, 0.32800305E-11_JPRB, 0.31684176E-11_JPRB, &
  & 0.30057244E-11_JPRB, 0.28185614E-11_JPRB, 0.25839749E-11_JPRB, 0.23457698E-11_JPRB, 0.21154779E-11_JPRB, 0.19074026E-11_JPRB, &
  & 0.16950859E-11_JPRB, 0.14971905E-11_JPRB, 0.13343164E-11_JPRB, 0.11931512E-11_JPRB, 0.10639177E-11_JPRB, 0.95935326E-12_JPRB, &
  & 0.89360604E-12_JPRB, 0.91061728E-12_JPRB, 0.76003426E-09_JPRB, 0.70160167E-09_JPRB, 0.69316702E-09_JPRB, 0.71002570E-09_JPRB, &
  & 0.76880496E-09_JPRB, 0.81897167E-09_JPRB, 0.93539221E-09_JPRB, 0.10957436E-08_JPRB /)

RGHG4(:, 5,12) = (/ &
  & 0.16327623E-10_JPRB, 0.14763017E-10_JPRB, 0.13752959E-10_JPRB, 0.13022756E-10_JPRB, 0.12491819E-10_JPRB, 0.12126071E-10_JPRB, &
  & 0.11889226E-10_JPRB, 0.11766877E-10_JPRB, 0.11860441E-10_JPRB, 0.11993329E-10_JPRB, 0.12142084E-10_JPRB, 0.12326892E-10_JPRB, &
  & 0.12533411E-10_JPRB, 0.12729497E-10_JPRB, 0.12925780E-10_JPRB, 0.13023351E-10_JPRB, 0.13086065E-10_JPRB, 0.13063121E-10_JPRB, &
  & 0.12930443E-10_JPRB, 0.12768157E-10_JPRB, 0.12541656E-10_JPRB, 0.12278952E-10_JPRB, 0.11928507E-10_JPRB, 0.11633738E-10_JPRB, &
  & 0.11343956E-10_JPRB, 0.11096583E-10_JPRB, 0.10885760E-10_JPRB, 0.10631692E-10_JPRB, 0.10432265E-10_JPRB, 0.10234589E-10_JPRB, &
  & 0.10043681E-10_JPRB, 0.98434646E-11_JPRB, 0.97049634E-11_JPRB, 0.94962285E-11_JPRB, 0.93604291E-11_JPRB, 0.92843146E-11_JPRB, &
  & 0.92668503E-11_JPRB, 0.92692650E-11_JPRB, 0.92825444E-11_JPRB, 0.91411297E-11_JPRB, 0.88712475E-11_JPRB, 0.84553059E-11_JPRB, &
  & 0.79247225E-11_JPRB, 0.73573708E-11_JPRB, 0.67309053E-11_JPRB, 0.61238584E-11_JPRB, 0.55524387E-11_JPRB, 0.50165033E-11_JPRB, &
  & 0.44791428E-11_JPRB, 0.39888830E-11_JPRB, 0.35496406E-11_JPRB, 0.31440198E-11_JPRB, 0.28039274E-11_JPRB, 0.25355627E-11_JPRB, &
  & 0.23576230E-11_JPRB, 0.27036416E-11_JPRB, 0.13993097E-08_JPRB, 0.12872662E-08_JPRB, 0.12528764E-08_JPRB, 0.12723691E-08_JPRB, &
  & 0.13364577E-08_JPRB, 0.14156264E-08_JPRB, 0.15363253E-08_JPRB, 0.16988435E-08_JPRB /)

RGHG4(:, 6,12) = (/ &
  & 0.43494305E-10_JPRB, 0.40734721E-10_JPRB, 0.38128896E-10_JPRB, 0.35943186E-10_JPRB, 0.34184065E-10_JPRB, 0.32817912E-10_JPRB, &
  & 0.31793367E-10_JPRB, 0.31066670E-10_JPRB, 0.30994082E-10_JPRB, 0.31207200E-10_JPRB, 0.31392236E-10_JPRB, 0.31604448E-10_JPRB, &
  & 0.31812754E-10_JPRB, 0.31932519E-10_JPRB, 0.32057926E-10_JPRB, 0.32015914E-10_JPRB, 0.31892607E-10_JPRB, 0.31724345E-10_JPRB, &
  & 0.31408345E-10_JPRB, 0.31061178E-10_JPRB, 0.30664367E-10_JPRB, 0.30269450E-10_JPRB, 0.29768039E-10_JPRB, 0.29307761E-10_JPRB, &
  & 0.28864012E-10_JPRB, 0.28453653E-10_JPRB, 0.28118180E-10_JPRB, 0.27704106E-10_JPRB, 0.27332428E-10_JPRB, 0.26983691E-10_JPRB, &
  & 0.26655709E-10_JPRB, 0.26339762E-10_JPRB, 0.26156922E-10_JPRB, 0.25865090E-10_JPRB, 0.25629514E-10_JPRB, 0.25459043E-10_JPRB, &
  & 0.25312015E-10_JPRB, 0.25113559E-10_JPRB, 0.24826292E-10_JPRB, 0.24156677E-10_JPRB, 0.23132059E-10_JPRB, 0.21844365E-10_JPRB, &
  & 0.20414127E-10_JPRB, 0.19008928E-10_JPRB, 0.17589508E-10_JPRB, 0.16226335E-10_JPRB, 0.14904513E-10_JPRB, 0.13629699E-10_JPRB, &
  & 0.12402271E-10_JPRB, 0.11232081E-10_JPRB, 0.10119951E-10_JPRB, 0.91122101E-11_JPRB, 0.82384169E-11_JPRB, 0.75464088E-11_JPRB, &
  & 0.72747485E-11_JPRB, 0.95179151E-11_JPRB, 0.20986421E-08_JPRB, 0.19387913E-08_JPRB, 0.18725288E-08_JPRB, 0.18757613E-08_JPRB, &
  & 0.19228890E-08_JPRB, 0.19982709E-08_JPRB, 0.20884077E-08_JPRB, 0.22635271E-08_JPRB /)

RGHG4(:, 7,12) = (/ &
  & 0.11386979E-09_JPRB, 0.10788131E-09_JPRB, 0.10100212E-09_JPRB, 0.95033148E-10_JPRB, 0.90152892E-10_JPRB, 0.86208506E-10_JPRB, &
  & 0.82978915E-10_JPRB, 0.80369641E-10_JPRB, 0.79571572E-10_JPRB, 0.79797093E-10_JPRB, 0.79891399E-10_JPRB, 0.79990063E-10_JPRB, &
  & 0.80068854E-10_JPRB, 0.79916275E-10_JPRB, 0.79840599E-10_JPRB, 0.79504063E-10_JPRB, 0.78993485E-10_JPRB, 0.78610445E-10_JPRB, &
  & 0.77979248E-10_JPRB, 0.77290674E-10_JPRB, 0.76618566E-10_JPRB, 0.76079067E-10_JPRB, 0.75390784E-10_JPRB, 0.74619512E-10_JPRB, &
  & 0.73905888E-10_JPRB, 0.73153671E-10_JPRB, 0.72610695E-10_JPRB, 0.71922010E-10_JPRB, 0.71239771E-10_JPRB, 0.70710722E-10_JPRB, &
  & 0.70258917E-10_JPRB, 0.69907295E-10_JPRB, 0.69828185E-10_JPRB, 0.69503091E-10_JPRB, 0.68981057E-10_JPRB, 0.68434577E-10_JPRB, &
  & 0.67668524E-10_JPRB, 0.66599663E-10_JPRB, 0.65119958E-10_JPRB, 0.62715784E-10_JPRB, 0.59369308E-10_JPRB, 0.55589078E-10_JPRB, &
  & 0.51777301E-10_JPRB, 0.48364496E-10_JPRB, 0.45257777E-10_JPRB, 0.42433178E-10_JPRB, 0.39759741E-10_JPRB, 0.37212990E-10_JPRB, &
  & 0.34684294E-10_JPRB, 0.32115414E-10_JPRB, 0.29705495E-10_JPRB, 0.27472972E-10_JPRB, 0.25552786E-10_JPRB, 0.24320941E-10_JPRB, &
  & 0.24776023E-10_JPRB, 0.31085336E-10_JPRB, 0.29901854E-08_JPRB, 0.27447487E-08_JPRB, 0.26165650E-08_JPRB, 0.25746885E-08_JPRB, &
  & 0.25805260E-08_JPRB, 0.26266773E-08_JPRB, 0.26965659E-08_JPRB, 0.28050153E-08_JPRB /)

RGHG4(:, 8,12) = (/ &
  & 0.28073968E-09_JPRB, 0.26965835E-09_JPRB, 0.25412111E-09_JPRB, 0.23958885E-09_JPRB, 0.22705163E-09_JPRB, 0.21641590E-09_JPRB, &
  & 0.20743643E-09_JPRB, 0.19992745E-09_JPRB, 0.19679608E-09_JPRB, 0.19676147E-09_JPRB, 0.19647066E-09_JPRB, 0.19621682E-09_JPRB, &
  & 0.19596808E-09_JPRB, 0.19518541E-09_JPRB, 0.19472338E-09_JPRB, 0.19389215E-09_JPRB, 0.19279471E-09_JPRB, 0.19240839E-09_JPRB, &
  & 0.19151121E-09_JPRB, 0.19043622E-09_JPRB, 0.18953762E-09_JPRB, 0.18904463E-09_JPRB, 0.18819953E-09_JPRB, 0.18678421E-09_JPRB, &
  & 0.18551158E-09_JPRB, 0.18400204E-09_JPRB, 0.18312535E-09_JPRB, 0.18193645E-09_JPRB, 0.18053217E-09_JPRB, 0.17961990E-09_JPRB, &
  & 0.17881149E-09_JPRB, 0.17828938E-09_JPRB, 0.17835737E-09_JPRB, 0.17781890E-09_JPRB, 0.17627695E-09_JPRB, 0.17459298E-09_JPRB, &
  & 0.17217251E-09_JPRB, 0.16904195E-09_JPRB, 0.16493239E-09_JPRB, 0.15881445E-09_JPRB, 0.15038540E-09_JPRB, 0.14127201E-09_JPRB, &
  & 0.13252707E-09_JPRB, 0.12510468E-09_JPRB, 0.11849563E-09_JPRB, 0.11235274E-09_JPRB, 0.10671720E-09_JPRB, 0.10168046E-09_JPRB, &
  & 0.96842021E-10_JPRB, 0.92082647E-10_JPRB, 0.87607102E-10_JPRB, 0.83457352E-10_JPRB, 0.80186066E-10_JPRB, 0.78523542E-10_JPRB, &
  & 0.79651716E-10_JPRB, 0.86404169E-10_JPRB, 0.39452224E-08_JPRB, 0.35726333E-08_JPRB, 0.33446832E-08_JPRB, 0.32155512E-08_JPRB, &
  & 0.31505556E-08_JPRB, 0.31158354E-08_JPRB, 0.30939198E-08_JPRB, 0.30878562E-08_JPRB /)

RGHG4(:, 9,12) = (/ &
  & 0.62079175E-09_JPRB, 0.59912514E-09_JPRB, 0.56740235E-09_JPRB, 0.53835431E-09_JPRB, 0.51407295E-09_JPRB, 0.49381083E-09_JPRB, &
  & 0.47603727E-09_JPRB, 0.46053933E-09_JPRB, 0.45257326E-09_JPRB, 0.45131845E-09_JPRB, 0.44971532E-09_JPRB, 0.44848161E-09_JPRB, &
  & 0.44771356E-09_JPRB, 0.44620582E-09_JPRB, 0.44572690E-09_JPRB, 0.44461934E-09_JPRB, 0.44308060E-09_JPRB, 0.44363882E-09_JPRB, &
  & 0.44303414E-09_JPRB, 0.44185819E-09_JPRB, 0.44125226E-09_JPRB, 0.44167306E-09_JPRB, 0.44107309E-09_JPRB, 0.43869300E-09_JPRB, &
  & 0.43651990E-09_JPRB, 0.43368351E-09_JPRB, 0.43244885E-09_JPRB, 0.43044310E-09_JPRB, 0.42742462E-09_JPRB, 0.42555789E-09_JPRB, &
  & 0.42358964E-09_JPRB, 0.42225004E-09_JPRB, 0.42219253E-09_JPRB, 0.42084758E-09_JPRB, 0.41680692E-09_JPRB, 0.41260742E-09_JPRB, &
  & 0.40678289E-09_JPRB, 0.39985959E-09_JPRB, 0.39134188E-09_JPRB, 0.37916947E-09_JPRB, 0.36161743E-09_JPRB, 0.34256747E-09_JPRB, &
  & 0.32429681E-09_JPRB, 0.30928185E-09_JPRB, 0.29647973E-09_JPRB, 0.28554104E-09_JPRB, 0.27640765E-09_JPRB, 0.26789948E-09_JPRB, &
  & 0.25917604E-09_JPRB, 0.24996505E-09_JPRB, 0.24087368E-09_JPRB, 0.23159269E-09_JPRB, 0.22181897E-09_JPRB, 0.21079842E-09_JPRB, &
  & 0.19789732E-09_JPRB, 0.18988487E-09_JPRB, 0.47838187E-08_JPRB, 0.42085468E-08_JPRB, 0.38182941E-08_JPRB, 0.35468273E-08_JPRB, &
  & 0.33645466E-08_JPRB, 0.32390848E-08_JPRB, 0.31370768E-08_JPRB, 0.30189107E-08_JPRB /)

RGHG4(:,10,12) = (/ &
  & 0.12270813E-08_JPRB, 0.11843715E-08_JPRB, 0.11312997E-08_JPRB, 0.10861372E-08_JPRB, 0.10469615E-08_JPRB, 0.10144323E-08_JPRB, &
  & 0.98662867E-09_JPRB, 0.96222386E-09_JPRB, 0.94813046E-09_JPRB, 0.94599095E-09_JPRB, 0.94401587E-09_JPRB, 0.94313191E-09_JPRB, &
  & 0.94317321E-09_JPRB, 0.94214114E-09_JPRB, 0.94402497E-09_JPRB, 0.94493136E-09_JPRB, 0.94512054E-09_JPRB, 0.94956998E-09_JPRB, &
  & 0.95145136E-09_JPRB, 0.95179920E-09_JPRB, 0.95315433E-09_JPRB, 0.95679364E-09_JPRB, 0.95765351E-09_JPRB, 0.95452535E-09_JPRB, &
  & 0.95163044E-09_JPRB, 0.94739472E-09_JPRB, 0.94641028E-09_JPRB, 0.94344155E-09_JPRB, 0.93719210E-09_JPRB, 0.93293195E-09_JPRB, &
  & 0.92776387E-09_JPRB, 0.92377667E-09_JPRB, 0.92238694E-09_JPRB, 0.91835323E-09_JPRB, 0.90875929E-09_JPRB, 0.89944985E-09_JPRB, &
  & 0.88720575E-09_JPRB, 0.87407215E-09_JPRB, 0.85973922E-09_JPRB, 0.83878499E-09_JPRB, 0.80699797E-09_JPRB, 0.77235479E-09_JPRB, &
  & 0.73983097E-09_JPRB, 0.71414752E-09_JPRB, 0.69157374E-09_JPRB, 0.67129657E-09_JPRB, 0.65216410E-09_JPRB, 0.63328870E-09_JPRB, &
  & 0.61302696E-09_JPRB, 0.58945343E-09_JPRB, 0.56228744E-09_JPRB, 0.52871435E-09_JPRB, 0.48811355E-09_JPRB, 0.44047435E-09_JPRB, &
  & 0.38912576E-09_JPRB, 0.34714262E-09_JPRB, 0.53111688E-08_JPRB, 0.44780681E-08_JPRB, 0.39048431E-08_JPRB, 0.34967034E-08_JPRB, &
  & 0.32381946E-08_JPRB, 0.30412906E-08_JPRB, 0.29076590E-08_JPRB, 0.27749638E-08_JPRB /)

RGHG4(:,11,12) = (/ &
  & 0.21665552E-08_JPRB, 0.20881328E-08_JPRB, 0.20095752E-08_JPRB, 0.19462831E-08_JPRB, 0.18969795E-08_JPRB, 0.18585117E-08_JPRB, &
  & 0.18276418E-08_JPRB, 0.18028453E-08_JPRB, 0.17889157E-08_JPRB, 0.17896863E-08_JPRB, 0.17910203E-08_JPRB, 0.17950870E-08_JPRB, &
  & 0.18012221E-08_JPRB, 0.18047328E-08_JPRB, 0.18127092E-08_JPRB, 0.18186339E-08_JPRB, 0.18238620E-08_JPRB, 0.18363137E-08_JPRB, &
  & 0.18434209E-08_JPRB, 0.18474878E-08_JPRB, 0.18528621E-08_JPRB, 0.18625725E-08_JPRB, 0.18663717E-08_JPRB, 0.18631416E-08_JPRB, &
  & 0.18599537E-08_JPRB, 0.18547924E-08_JPRB, 0.18546709E-08_JPRB, 0.18499265E-08_JPRB, 0.18375672E-08_JPRB, 0.18275620E-08_JPRB, &
  & 0.18154522E-08_JPRB, 0.18057009E-08_JPRB, 0.18012020E-08_JPRB, 0.17923845E-08_JPRB, 0.17738145E-08_JPRB, 0.17558396E-08_JPRB, &
  & 0.17355843E-08_JPRB, 0.17150729E-08_JPRB, 0.16909553E-08_JPRB, 0.16595998E-08_JPRB, 0.16184921E-08_JPRB, 0.15737835E-08_JPRB, &
  & 0.15245081E-08_JPRB, 0.14793278E-08_JPRB, 0.14333120E-08_JPRB, 0.13869351E-08_JPRB, 0.13391465E-08_JPRB, 0.12877381E-08_JPRB, &
  & 0.12275418E-08_JPRB, 0.11557795E-08_JPRB, 0.10739856E-08_JPRB, 0.98022512E-09_JPRB, 0.87663093E-09_JPRB, 0.76572532E-09_JPRB, &
  & 0.65234945E-09_JPRB, 0.55659655E-09_JPRB, 0.55415112E-08_JPRB, 0.44683488E-08_JPRB, 0.37532026E-08_JPRB, 0.32655485E-08_JPRB, &
  & 0.29562321E-08_JPRB, 0.27423055E-08_JPRB, 0.25838705E-08_JPRB, 0.24703972E-08_JPRB /)

RGHG4(:,12,12) = (/ &
  & 0.33305361E-08_JPRB, 0.32414105E-08_JPRB, 0.31623784E-08_JPRB, 0.31030862E-08_JPRB, 0.30614047E-08_JPRB, 0.30342990E-08_JPRB, &
  & 0.30166625E-08_JPRB, 0.30063458E-08_JPRB, 0.30067111E-08_JPRB, 0.30200886E-08_JPRB, 0.30315510E-08_JPRB, 0.30449316E-08_JPRB, &
  & 0.30601992E-08_JPRB, 0.30719005E-08_JPRB, 0.30894272E-08_JPRB, 0.31017009E-08_JPRB, 0.31124665E-08_JPRB, 0.31317431E-08_JPRB, &
  & 0.31419294E-08_JPRB, 0.31469505E-08_JPRB, 0.31530061E-08_JPRB, 0.31654042E-08_JPRB, 0.31684999E-08_JPRB, 0.31626537E-08_JPRB, &
  & 0.31568939E-08_JPRB, 0.31497029E-08_JPRB, 0.31490202E-08_JPRB, 0.31407239E-08_JPRB, 0.31208880E-08_JPRB, 0.31027867E-08_JPRB, &
  & 0.30818568E-08_JPRB, 0.30643978E-08_JPRB, 0.30537353E-08_JPRB, 0.30374168E-08_JPRB, 0.30098393E-08_JPRB, 0.29846765E-08_JPRB, &
  & 0.29538205E-08_JPRB, 0.29262419E-08_JPRB, 0.29078444E-08_JPRB, 0.28806031E-08_JPRB, 0.28351022E-08_JPRB, 0.27807734E-08_JPRB, &
  & 0.27188005E-08_JPRB, 0.26521734E-08_JPRB, 0.25699196E-08_JPRB, 0.24727265E-08_JPRB, 0.23621987E-08_JPRB, 0.22371613E-08_JPRB, &
  & 0.20932862E-08_JPRB, 0.19326551E-08_JPRB, 0.17600622E-08_JPRB, 0.15735478E-08_JPRB, 0.13799695E-08_JPRB, 0.11819942E-08_JPRB, &
  & 0.98289243E-09_JPRB, 0.81231716E-09_JPRB, 0.56377512E-08_JPRB, 0.43324042E-08_JPRB, 0.34964969E-08_JPRB, 0.29533651E-08_JPRB, &
  & 0.26385476E-08_JPRB, 0.23762090E-08_JPRB, 0.22608622E-08_JPRB, 0.21444950E-08_JPRB /)

RGHG4(:,13,12) = (/ &
  & 0.44501731E-08_JPRB, 0.43970374E-08_JPRB, 0.43488737E-08_JPRB, 0.43217998E-08_JPRB, 0.43153761E-08_JPRB, 0.43253383E-08_JPRB, &
  & 0.43457220E-08_JPRB, 0.43730575E-08_JPRB, 0.44071387E-08_JPRB, 0.44461959E-08_JPRB, 0.44772310E-08_JPRB, 0.45062354E-08_JPRB, &
  & 0.45327950E-08_JPRB, 0.45512953E-08_JPRB, 0.45747082E-08_JPRB, 0.45887063E-08_JPRB, 0.45990314E-08_JPRB, 0.46159578E-08_JPRB, &
  & 0.46193653E-08_JPRB, 0.46150794E-08_JPRB, 0.46102238E-08_JPRB, 0.46128137E-08_JPRB, 0.46049031E-08_JPRB, 0.45894777E-08_JPRB, &
  & 0.45753041E-08_JPRB, 0.45623874E-08_JPRB, 0.45584252E-08_JPRB, 0.45475579E-08_JPRB, 0.45274318E-08_JPRB, 0.45114965E-08_JPRB, &
  & 0.44931268E-08_JPRB, 0.44793862E-08_JPRB, 0.44720578E-08_JPRB, 0.44549600E-08_JPRB, 0.44227004E-08_JPRB, 0.43859356E-08_JPRB, &
  & 0.43523505E-08_JPRB, 0.43232435E-08_JPRB, 0.42913619E-08_JPRB, 0.42522479E-08_JPRB, 0.42048161E-08_JPRB, 0.41445958E-08_JPRB, &
  & 0.40648285E-08_JPRB, 0.39661545E-08_JPRB, 0.38376609E-08_JPRB, 0.36820913E-08_JPRB, 0.35045782E-08_JPRB, 0.33061947E-08_JPRB, &
  & 0.30808107E-08_JPRB, 0.28307356E-08_JPRB, 0.25625386E-08_JPRB, 0.22782001E-08_JPRB, 0.19860809E-08_JPRB, 0.16868038E-08_JPRB, &
  & 0.13770904E-08_JPRB, 0.11209473E-08_JPRB, 0.56352043E-08_JPRB, 0.41064800E-08_JPRB, 0.31664482E-08_JPRB, 0.25987033E-08_JPRB, &
  & 0.22531805E-08_JPRB, 0.20125699E-08_JPRB, 0.18762236E-08_JPRB, 0.17824587E-08_JPRB /)

RGHG4(:,14,12) = (/ &
  & 0.53239884E-08_JPRB, 0.53285718E-08_JPRB, 0.53282041E-08_JPRB, 0.53469038E-08_JPRB, 0.53851084E-08_JPRB, 0.54404325E-08_JPRB, &
  & 0.55078102E-08_JPRB, 0.55809757E-08_JPRB, 0.56526797E-08_JPRB, 0.57200582E-08_JPRB, 0.57735661E-08_JPRB, 0.58183129E-08_JPRB, &
  & 0.58539960E-08_JPRB, 0.58748211E-08_JPRB, 0.58958656E-08_JPRB, 0.59014118E-08_JPRB, 0.58989791E-08_JPRB, 0.58983467E-08_JPRB, &
  & 0.58804011E-08_JPRB, 0.58526877E-08_JPRB, 0.58229594E-08_JPRB, 0.58018044E-08_JPRB, 0.57726974E-08_JPRB, 0.57411480E-08_JPRB, &
  & 0.57150786E-08_JPRB, 0.56956231E-08_JPRB, 0.56920513E-08_JPRB, 0.56885492E-08_JPRB, 0.56831815E-08_JPRB, 0.56864344E-08_JPRB, &
  & 0.56909188E-08_JPRB, 0.56966716E-08_JPRB, 0.57045422E-08_JPRB, 0.56896172E-08_JPRB, 0.56590674E-08_JPRB, 0.56267631E-08_JPRB, &
  & 0.55790981E-08_JPRB, 0.55285132E-08_JPRB, 0.54847917E-08_JPRB, 0.54265770E-08_JPRB, 0.53489662E-08_JPRB, 0.52498725E-08_JPRB, &
  & 0.51284328E-08_JPRB, 0.49858575E-08_JPRB, 0.48113660E-08_JPRB, 0.46080393E-08_JPRB, 0.43798805E-08_JPRB, 0.41279882E-08_JPRB, &
  & 0.38461394E-08_JPRB, 0.35400558E-08_JPRB, 0.32174756E-08_JPRB, 0.28741898E-08_JPRB, 0.25130178E-08_JPRB, 0.21239821E-08_JPRB, &
  & 0.17058391E-08_JPRB, 0.13628239E-08_JPRB, 0.54132956E-08_JPRB, 0.37548213E-08_JPRB, 0.27685971E-08_JPRB, 0.21873137E-08_JPRB, &
  & 0.18400527E-08_JPRB, 0.15891686E-08_JPRB, 0.14743567E-08_JPRB, 0.13964582E-08_JPRB /)

RGHG4(:,15,12) = (/ &
  & 0.58575722E-08_JPRB, 0.59301315E-08_JPRB, 0.59690337E-08_JPRB, 0.60180487E-08_JPRB, 0.60865539E-08_JPRB, 0.61728080E-08_JPRB, &
  & 0.62728627E-08_JPRB, 0.63774257E-08_JPRB, 0.64655961E-08_JPRB, 0.65426256E-08_JPRB, 0.66044210E-08_JPRB, 0.66531638E-08_JPRB, &
  & 0.66863595E-08_JPRB, 0.66976189E-08_JPRB, 0.67034294E-08_JPRB, 0.66873445E-08_JPRB, 0.66585497E-08_JPRB, 0.66269519E-08_JPRB, &
  & 0.65755730E-08_JPRB, 0.65131478E-08_JPRB, 0.64500716E-08_JPRB, 0.63991799E-08_JPRB, 0.63476007E-08_JPRB, 0.63022827E-08_JPRB, &
  & 0.62716761E-08_JPRB, 0.62562111E-08_JPRB, 0.62690706E-08_JPRB, 0.62962262E-08_JPRB, 0.63350298E-08_JPRB, 0.63908860E-08_JPRB, &
  & 0.64377668E-08_JPRB, 0.64776855E-08_JPRB, 0.65039854E-08_JPRB, 0.65025447E-08_JPRB, 0.64708825E-08_JPRB, 0.64193331E-08_JPRB, &
  & 0.63602079E-08_JPRB, 0.62883294E-08_JPRB, 0.62032046E-08_JPRB, 0.60955991E-08_JPRB, 0.59724279E-08_JPRB, 0.58325464E-08_JPRB, &
  & 0.56750173E-08_JPRB, 0.55005471E-08_JPRB, 0.52980447E-08_JPRB, 0.50691695E-08_JPRB, 0.48174638E-08_JPRB, 0.45445558E-08_JPRB, &
  & 0.42432915E-08_JPRB, 0.39177461E-08_JPRB, 0.35728762E-08_JPRB, 0.32014449E-08_JPRB, 0.27992553E-08_JPRB, 0.23469804E-08_JPRB, &
  & 0.18395717E-08_JPRB, 0.14586192E-08_JPRB, 0.48009823E-08_JPRB, 0.32127963E-08_JPRB, 0.22916553E-08_JPRB, 0.17487980E-08_JPRB, &
  & 0.14365443E-08_JPRB, 0.12036026E-08_JPRB, 0.10899012E-08_JPRB, 0.10080889E-08_JPRB /)

RGHG4(:,16,12) = (/ &
  & 0.61750569E-08_JPRB, 0.62696968E-08_JPRB, 0.63070127E-08_JPRB, 0.63618253E-08_JPRB, 0.64399051E-08_JPRB, 0.65384076E-08_JPRB, &
  & 0.66516677E-08_JPRB, 0.67667485E-08_JPRB, 0.68439379E-08_JPRB, 0.69047497E-08_JPRB, 0.69517831E-08_JPRB, 0.69841501E-08_JPRB, &
  & 0.69973192E-08_JPRB, 0.69834467E-08_JPRB, 0.69602208E-08_JPRB, 0.69110224E-08_JPRB, 0.68464927E-08_JPRB, 0.67785750E-08_JPRB, &
  & 0.66930270E-08_JPRB, 0.65999264E-08_JPRB, 0.65114216E-08_JPRB, 0.64422534E-08_JPRB, 0.63815828E-08_JPRB, 0.63358443E-08_JPRB, &
  & 0.63183885E-08_JPRB, 0.63297771E-08_JPRB, 0.63817245E-08_JPRB, 0.64535413E-08_JPRB, 0.65380195E-08_JPRB, 0.66340404E-08_JPRB, &
  & 0.67245338E-08_JPRB, 0.67934454E-08_JPRB, 0.68350463E-08_JPRB, 0.68225186E-08_JPRB, 0.67780697E-08_JPRB, 0.67042629E-08_JPRB, &
  & 0.66012618E-08_JPRB, 0.64810943E-08_JPRB, 0.63543832E-08_JPRB, 0.62067813E-08_JPRB, 0.60461258E-08_JPRB, 0.58766774E-08_JPRB, &
  & 0.56982059E-08_JPRB, 0.55125051E-08_JPRB, 0.53059912E-08_JPRB, 0.50782276E-08_JPRB, 0.48314721E-08_JPRB, 0.45658002E-08_JPRB, &
  & 0.42743249E-08_JPRB, 0.39601349E-08_JPRB, 0.36255972E-08_JPRB, 0.32564771E-08_JPRB, 0.28425731E-08_JPRB, 0.23591560E-08_JPRB, &
  & 0.18241730E-08_JPRB, 0.14877665E-08_JPRB, 0.39400989E-08_JPRB, 0.25704956E-08_JPRB, 0.17885606E-08_JPRB, 0.13260320E-08_JPRB, &
  & 0.10548130E-08_JPRB, 0.87451063E-09_JPRB, 0.75713930E-09_JPRB, 0.70182088E-09_JPRB /)

RGHG4(:,17,12) = (/ &
  & 0.62248033E-08_JPRB, 0.62861254E-08_JPRB, 0.63207350E-08_JPRB, 0.63693335E-08_JPRB, 0.64385577E-08_JPRB, 0.65272951E-08_JPRB, &
  & 0.66313004E-08_JPRB, 0.67311361E-08_JPRB, 0.67683232E-08_JPRB, 0.67869568E-08_JPRB, 0.67960881E-08_JPRB, 0.67914403E-08_JPRB, &
  & 0.67665988E-08_JPRB, 0.67131061E-08_JPRB, 0.66502532E-08_JPRB, 0.65623884E-08_JPRB, 0.64606662E-08_JPRB, 0.63570225E-08_JPRB, &
  & 0.62410686E-08_JPRB, 0.61247443E-08_JPRB, 0.60233263E-08_JPRB, 0.59501724E-08_JPRB, 0.58984004E-08_JPRB, 0.58715672E-08_JPRB, &
  & 0.58842193E-08_JPRB, 0.59343810E-08_JPRB, 0.60298397E-08_JPRB, 0.61426260E-08_JPRB, 0.62627179E-08_JPRB, 0.63871970E-08_JPRB, &
  & 0.64892656E-08_JPRB, 0.65553225E-08_JPRB, 0.65899477E-08_JPRB, 0.65619576E-08_JPRB, 0.64780856E-08_JPRB, 0.63530576E-08_JPRB, &
  & 0.62049907E-08_JPRB, 0.60469274E-08_JPRB, 0.58911409E-08_JPRB, 0.57252461E-08_JPRB, 0.55570588E-08_JPRB, 0.53913540E-08_JPRB, &
  & 0.52260578E-08_JPRB, 0.50622231E-08_JPRB, 0.48844369E-08_JPRB, 0.46895963E-08_JPRB, 0.44794208E-08_JPRB, 0.42511918E-08_JPRB, &
  & 0.39991166E-08_JPRB, 0.37233354E-08_JPRB, 0.34200587E-08_JPRB, 0.30731990E-08_JPRB, 0.26596643E-08_JPRB, 0.21438928E-08_JPRB, &
  & 0.16777485E-08_JPRB, 0.13950531E-08_JPRB, 0.29880360E-08_JPRB, 0.19070561E-08_JPRB, 0.13045481E-08_JPRB, 0.93265684E-09_JPRB, &
  & 0.72887674E-09_JPRB, 0.58713190E-09_JPRB, 0.50425664E-09_JPRB, 0.45842624E-09_JPRB /)

RGHG4(:,18,12) = (/ &
  & 0.60800875E-08_JPRB, 0.61244050E-08_JPRB, 0.61329990E-08_JPRB, 0.61543659E-08_JPRB, 0.61954126E-08_JPRB, 0.62567755E-08_JPRB, &
  & 0.63335683E-08_JPRB, 0.63993082E-08_JPRB, 0.63769541E-08_JPRB, 0.63367613E-08_JPRB, 0.62942855E-08_JPRB, 0.62416263E-08_JPRB, &
  & 0.61706427E-08_JPRB, 0.60722889E-08_JPRB, 0.59657466E-08_JPRB, 0.58390395E-08_JPRB, 0.57043406E-08_JPRB, 0.55747429E-08_JPRB, &
  & 0.54410423E-08_JPRB, 0.53164575E-08_JPRB, 0.52174061E-08_JPRB, 0.51570468E-08_JPRB, 0.51294426E-08_JPRB, 0.51372200E-08_JPRB, &
  & 0.51902118E-08_JPRB, 0.52805444E-08_JPRB, 0.54083529E-08_JPRB, 0.55422951E-08_JPRB, 0.56656919E-08_JPRB, 0.57738694E-08_JPRB, &
  & 0.58544218E-08_JPRB, 0.58906289E-08_JPRB, 0.58866161E-08_JPRB, 0.58227356E-08_JPRB, 0.57097234E-08_JPRB, 0.55558926E-08_JPRB, &
  & 0.53807225E-08_JPRB, 0.52021267E-08_JPRB, 0.50409801E-08_JPRB, 0.48854569E-08_JPRB, 0.47393418E-08_JPRB, 0.46041113E-08_JPRB, &
  & 0.44735375E-08_JPRB, 0.43505008E-08_JPRB, 0.42166914E-08_JPRB, 0.40701926E-08_JPRB, 0.39097747E-08_JPRB, 0.37324588E-08_JPRB, &
  & 0.35315231E-08_JPRB, 0.33014262E-08_JPRB, 0.30335876E-08_JPRB, 0.27068698E-08_JPRB, 0.23078663E-08_JPRB, 0.18559915E-08_JPRB, &
  & 0.14240298E-08_JPRB, 0.11748780E-08_JPRB, 0.20881361E-08_JPRB, 0.13269033E-08_JPRB, 0.89397362E-09_JPRB, 0.61716304E-09_JPRB, &
  & 0.47348742E-09_JPRB, 0.37519893E-09_JPRB, 0.31538921E-09_JPRB, 0.28588829E-09_JPRB /)

RGHG4(:,19,12) = (/ &
  & 0.57987504E-08_JPRB, 0.57813252E-08_JPRB, 0.57570362E-08_JPRB, 0.57492113E-08_JPRB, 0.57598868E-08_JPRB, 0.57888818E-08_JPRB, &
  & 0.58328107E-08_JPRB, 0.58552887E-08_JPRB, 0.57686420E-08_JPRB, 0.56672764E-08_JPRB, 0.55722218E-08_JPRB, 0.54718541E-08_JPRB, &
  & 0.53573341E-08_JPRB, 0.52213718E-08_JPRB, 0.50819793E-08_JPRB, 0.49287316E-08_JPRB, 0.47743254E-08_JPRB, 0.46305764E-08_JPRB, &
  & 0.44927440E-08_JPRB, 0.43724699E-08_JPRB, 0.42846500E-08_JPRB, 0.42447370E-08_JPRB, 0.42448898E-08_JPRB, 0.42857704E-08_JPRB, &
  & 0.43695474E-08_JPRB, 0.44837054E-08_JPRB, 0.46207647E-08_JPRB, 0.47410209E-08_JPRB, 0.48424829E-08_JPRB, 0.49142046E-08_JPRB, &
  & 0.49406088E-08_JPRB, 0.49280224E-08_JPRB, 0.48820059E-08_JPRB, 0.47841051E-08_JPRB, 0.46504058E-08_JPRB, 0.44917079E-08_JPRB, &
  & 0.43235300E-08_JPRB, 0.41655364E-08_JPRB, 0.40286774E-08_JPRB, 0.39031991E-08_JPRB, 0.37939625E-08_JPRB, 0.37024306E-08_JPRB, &
  & 0.36182364E-08_JPRB, 0.35392831E-08_JPRB, 0.34534664E-08_JPRB, 0.33554179E-08_JPRB, 0.32447096E-08_JPRB, 0.31162724E-08_JPRB, &
  & 0.29615688E-08_JPRB, 0.27712548E-08_JPRB, 0.25334428E-08_JPRB, 0.22382782E-08_JPRB, 0.18634385E-08_JPRB, 0.15012963E-08_JPRB, &
  & 0.11649559E-08_JPRB, 0.96303709E-09_JPRB, 0.14004919E-08_JPRB, 0.88068608E-09_JPRB, 0.58071115E-09_JPRB, 0.39012904E-09_JPRB, &
  & 0.28965577E-09_JPRB, 0.22481553E-09_JPRB, 0.18589370E-09_JPRB, 0.16572356E-09_JPRB /)

RGHG4(:,20,12) = (/ &
  & 0.53290030E-08_JPRB, 0.52724367E-08_JPRB, 0.52238733E-08_JPRB, 0.51926179E-08_JPRB, 0.51766120E-08_JPRB, 0.51762159E-08_JPRB, &
  & 0.51880509E-08_JPRB, 0.51703393E-08_JPRB, 0.50312341E-08_JPRB, 0.48816537E-08_JPRB, 0.47465782E-08_JPRB, 0.46126156E-08_JPRB, &
  & 0.44695128E-08_JPRB, 0.43111958E-08_JPRB, 0.41531933E-08_JPRB, 0.39885548E-08_JPRB, 0.38304888E-08_JPRB, 0.36889856E-08_JPRB, &
  & 0.35593073E-08_JPRB, 0.34552659E-08_JPRB, 0.33869245E-08_JPRB, 0.33658962E-08_JPRB, 0.33860714E-08_JPRB, 0.34451928E-08_JPRB, &
  & 0.35398573E-08_JPRB, 0.36526449E-08_JPRB, 0.37688710E-08_JPRB, 0.38662678E-08_JPRB, 0.39233830E-08_JPRB, 0.39381245E-08_JPRB, &
  & 0.39177270E-08_JPRB, 0.38611847E-08_JPRB, 0.37816843E-08_JPRB, 0.36701735E-08_JPRB, 0.35408634E-08_JPRB, 0.34047234E-08_JPRB, &
  & 0.32673981E-08_JPRB, 0.31386995E-08_JPRB, 0.30350531E-08_JPRB, 0.29567253E-08_JPRB, 0.28878162E-08_JPRB, 0.28362077E-08_JPRB, &
  & 0.27921951E-08_JPRB, 0.27503475E-08_JPRB, 0.27044771E-08_JPRB, 0.26456906E-08_JPRB, 0.25734008E-08_JPRB, 0.24804745E-08_JPRB, &
  & 0.23570945E-08_JPRB, 0.21921092E-08_JPRB, 0.19793776E-08_JPRB, 0.17055147E-08_JPRB, 0.14249103E-08_JPRB, 0.11584652E-08_JPRB, &
  & 0.90321373E-09_JPRB, 0.74047118E-09_JPRB, 0.91227642E-09_JPRB, 0.56862814E-09_JPRB, 0.37161821E-09_JPRB, 0.24366867E-09_JPRB, &
  & 0.18029536E-09_JPRB, 0.13001751E-09_JPRB, 0.11099167E-09_JPRB, 0.92856389E-10_JPRB /)

RGHG4(:,21,12) = (/ &
  & 0.48151998E-08_JPRB, 0.47150763E-08_JPRB, 0.46434976E-08_JPRB, 0.45911528E-08_JPRB, 0.45527431E-08_JPRB, 0.45275956E-08_JPRB, &
  & 0.45120343E-08_JPRB, 0.44619952E-08_JPRB, 0.42903068E-08_JPRB, 0.41124553E-08_JPRB, 0.39546149E-08_JPRB, 0.38029104E-08_JPRB, &
  & 0.36474017E-08_JPRB, 0.34845240E-08_JPRB, 0.33259666E-08_JPRB, 0.31667242E-08_JPRB, 0.30173986E-08_JPRB, 0.28876055E-08_JPRB, &
  & 0.27705058E-08_JPRB, 0.26761258E-08_JPRB, 0.26172169E-08_JPRB, 0.26037132E-08_JPRB, 0.26278071E-08_JPRB, 0.26867792E-08_JPRB, &
  & 0.27709954E-08_JPRB, 0.28652998E-08_JPRB, 0.29577851E-08_JPRB, 0.30131919E-08_JPRB, 0.30290281E-08_JPRB, 0.30083978E-08_JPRB, &
  & 0.29516372E-08_JPRB, 0.28718203E-08_JPRB, 0.27789440E-08_JPRB, 0.26748412E-08_JPRB, 0.25695757E-08_JPRB, 0.24622215E-08_JPRB, &
  & 0.23630882E-08_JPRB, 0.22793907E-08_JPRB, 0.22068332E-08_JPRB, 0.21473885E-08_JPRB, 0.21060222E-08_JPRB, 0.20790873E-08_JPRB, &
  & 0.20575877E-08_JPRB, 0.20408051E-08_JPRB, 0.20164743E-08_JPRB, 0.19846143E-08_JPRB, 0.19376762E-08_JPRB, 0.18706621E-08_JPRB, &
  & 0.17747170E-08_JPRB, 0.16439823E-08_JPRB, 0.14738262E-08_JPRB, 0.12728951E-08_JPRB, 0.10720272E-08_JPRB, 0.86945184E-09_JPRB, &
  & 0.66794487E-09_JPRB, 0.53459764E-09_JPRB, 0.58881233E-09_JPRB, 0.36497277E-09_JPRB, 0.23418259E-09_JPRB, 0.15146079E-09_JPRB, &
  & 0.10667780E-09_JPRB, 0.77339184E-10_JPRB, 0.64520222E-10_JPRB, 0.49860636E-10_JPRB /)

RGHG4(:,22,12) = (/ &
  & 0.42523367E-08_JPRB, 0.41266732E-08_JPRB, 0.40429469E-08_JPRB, 0.39772732E-08_JPRB, 0.39225134E-08_JPRB, 0.38781640E-08_JPRB, &
  & 0.38393528E-08_JPRB, 0.37669499E-08_JPRB, 0.35855539E-08_JPRB, 0.34029952E-08_JPRB, 0.32425005E-08_JPRB, 0.30922855E-08_JPRB, &
  & 0.29417841E-08_JPRB, 0.27888811E-08_JPRB, 0.26415219E-08_JPRB, 0.24954327E-08_JPRB, 0.23581828E-08_JPRB, 0.22388458E-08_JPRB, &
  & 0.21330646E-08_JPRB, 0.20474520E-08_JPRB, 0.19934594E-08_JPRB, 0.19766517E-08_JPRB, 0.19879463E-08_JPRB, 0.20265829E-08_JPRB, &
  & 0.20825957E-08_JPRB, 0.21448696E-08_JPRB, 0.21987741E-08_JPRB, 0.22236675E-08_JPRB, 0.22146840E-08_JPRB, 0.21743551E-08_JPRB, &
  & 0.21132256E-08_JPRB, 0.20368522E-08_JPRB, 0.19585349E-08_JPRB, 0.18805622E-08_JPRB, 0.18048449E-08_JPRB, 0.17345103E-08_JPRB, &
  & 0.16689011E-08_JPRB, 0.16158730E-08_JPRB, 0.15779648E-08_JPRB, 0.15552437E-08_JPRB, 0.15364567E-08_JPRB, 0.15233257E-08_JPRB, &
  & 0.15175547E-08_JPRB, 0.15107953E-08_JPRB, 0.14990776E-08_JPRB, 0.14775743E-08_JPRB, 0.14439329E-08_JPRB, 0.13918265E-08_JPRB, &
  & 0.13178463E-08_JPRB, 0.12176422E-08_JPRB, 0.10881672E-08_JPRB, 0.95417407E-09_JPRB, 0.81366347E-09_JPRB, 0.65937322E-09_JPRB, &
  & 0.50611765E-09_JPRB, 0.40139303E-09_JPRB, 0.39318274E-09_JPRB, 0.23805219E-09_JPRB, 0.14938259E-09_JPRB, 0.94587817E-10_JPRB, &
  & 0.63618250E-10_JPRB, 0.45355792E-10_JPRB, 0.35305748E-10_JPRB, 0.27983340E-10_JPRB /)

RGHG4(:,23,12) = (/ &
  & 0.37154244E-08_JPRB, 0.35824359E-08_JPRB, 0.34967182E-08_JPRB, 0.34265617E-08_JPRB, 0.33653285E-08_JPRB, 0.33120338E-08_JPRB, &
  & 0.32608982E-08_JPRB, 0.31781990E-08_JPRB, 0.30022829E-08_JPRB, 0.28284473E-08_JPRB, 0.26760920E-08_JPRB, 0.25351348E-08_JPRB, &
  & 0.23959648E-08_JPRB, 0.22548807E-08_JPRB, 0.21193254E-08_JPRB, 0.19867690E-08_JPRB, 0.18631419E-08_JPRB, 0.17572783E-08_JPRB, &
  & 0.16646341E-08_JPRB, 0.15889889E-08_JPRB, 0.15355327E-08_JPRB, 0.15079218E-08_JPRB, 0.15015631E-08_JPRB, 0.15138879E-08_JPRB, &
  & 0.15382134E-08_JPRB, 0.15669580E-08_JPRB, 0.15904018E-08_JPRB, 0.15931307E-08_JPRB, 0.15750420E-08_JPRB, 0.15392068E-08_JPRB, &
  & 0.14886203E-08_JPRB, 0.14314320E-08_JPRB, 0.13783099E-08_JPRB, 0.13259811E-08_JPRB, 0.12777160E-08_JPRB, 0.12361808E-08_JPRB, &
  & 0.12019823E-08_JPRB, 0.11759281E-08_JPRB, 0.11542913E-08_JPRB, 0.11397320E-08_JPRB, 0.11327771E-08_JPRB, 0.11313929E-08_JPRB, &
  & 0.11347430E-08_JPRB, 0.11358533E-08_JPRB, 0.11360193E-08_JPRB, 0.11267840E-08_JPRB, 0.11065525E-08_JPRB, 0.10696117E-08_JPRB, &
  & 0.10104537E-08_JPRB, 0.92896918E-09_JPRB, 0.83412599E-09_JPRB, 0.73306056E-09_JPRB, 0.62291733E-09_JPRB, 0.50964127E-09_JPRB, &
  & 0.39134238E-09_JPRB, 0.30468825E-09_JPRB, 0.26960326E-09_JPRB, 0.15868594E-09_JPRB, 0.96182430E-10_JPRB, 0.58124224E-10_JPRB, &
  & 0.37242348E-10_JPRB, 0.25360941E-10_JPRB, 0.18200427E-10_JPRB, 0.14347691E-10_JPRB /)

RGHG4(:,24,12) = (/ &
  & 0.32299519E-08_JPRB, 0.30985530E-08_JPRB, 0.30155498E-08_JPRB, 0.29457370E-08_JPRB, 0.28837759E-08_JPRB, 0.28277445E-08_JPRB, &
  & 0.27715474E-08_JPRB, 0.26872822E-08_JPRB, 0.25250386E-08_JPRB, 0.23665443E-08_JPRB, 0.22277520E-08_JPRB, 0.20981834E-08_JPRB, &
  & 0.19710809E-08_JPRB, 0.18448196E-08_JPRB, 0.17266780E-08_JPRB, 0.16132460E-08_JPRB, 0.15079321E-08_JPRB, 0.14134079E-08_JPRB, &
  & 0.13275824E-08_JPRB, 0.12538406E-08_JPRB, 0.11964093E-08_JPRB, 0.11571556E-08_JPRB, 0.11321580E-08_JPRB, 0.11204306E-08_JPRB, &
  & 0.11185549E-08_JPRB, 0.11216403E-08_JPRB, 0.11254520E-08_JPRB, 0.11202800E-08_JPRB, 0.11039776E-08_JPRB, 0.10783680E-08_JPRB, &
  & 0.10452585E-08_JPRB, 0.10106503E-08_JPRB, 0.97776853E-09_JPRB, 0.94678021E-09_JPRB, 0.91846580E-09_JPRB, 0.89492758E-09_JPRB, &
  & 0.87539631E-09_JPRB, 0.86030782E-09_JPRB, 0.85338886E-09_JPRB, 0.85073298E-09_JPRB, 0.84963403E-09_JPRB, 0.85386359E-09_JPRB, &
  & 0.85912905E-09_JPRB, 0.86596441E-09_JPRB, 0.86835678E-09_JPRB, 0.86479390E-09_JPRB, 0.84990748E-09_JPRB, 0.82211765E-09_JPRB, &
  & 0.77617462E-09_JPRB, 0.71567618E-09_JPRB, 0.64818956E-09_JPRB, 0.57430399E-09_JPRB, 0.48756105E-09_JPRB, 0.39011500E-09_JPRB, &
  & 0.29465061E-09_JPRB, 0.22786222E-09_JPRB, 0.18516909E-09_JPRB, 0.10525495E-09_JPRB, 0.61786465E-10_JPRB, 0.36215135E-10_JPRB, &
  & 0.22417214E-10_JPRB, 0.14648083E-10_JPRB, 0.10251761E-10_JPRB, 0.68154740E-11_JPRB /)

RGHG4(:,25,12) = (/ &
  & 0.28294798E-08_JPRB, 0.27053364E-08_JPRB, 0.26265008E-08_JPRB, 0.25599471E-08_JPRB, 0.25002900E-08_JPRB, 0.24453899E-08_JPRB, &
  & 0.23883813E-08_JPRB, 0.23072328E-08_JPRB, 0.21601572E-08_JPRB, 0.20162896E-08_JPRB, 0.18901329E-08_JPRB, 0.17730257E-08_JPRB, &
  & 0.16596789E-08_JPRB, 0.15504572E-08_JPRB, 0.14469371E-08_JPRB, 0.13472986E-08_JPRB, 0.12533869E-08_JPRB, 0.11666481E-08_JPRB, &
  & 0.10865711E-08_JPRB, 0.10146490E-08_JPRB, 0.95315167E-09_JPRB, 0.90348351E-09_JPRB, 0.86395802E-09_JPRB, 0.83520146E-09_JPRB, &
  & 0.81541912E-09_JPRB, 0.80284129E-09_JPRB, 0.79389639E-09_JPRB, 0.78414530E-09_JPRB, 0.77275542E-09_JPRB, 0.75853368E-09_JPRB, &
  & 0.74186091E-09_JPRB, 0.72387707E-09_JPRB, 0.70724832E-09_JPRB, 0.69127792E-09_JPRB, 0.67654760E-09_JPRB, 0.66424038E-09_JPRB, &
  & 0.65567685E-09_JPRB, 0.65053862E-09_JPRB, 0.64813521E-09_JPRB, 0.64912731E-09_JPRB, 0.65242234E-09_JPRB, 0.65810590E-09_JPRB, &
  & 0.66548728E-09_JPRB, 0.67350808E-09_JPRB, 0.67847494E-09_JPRB, 0.67834510E-09_JPRB, 0.66884431E-09_JPRB, 0.64869038E-09_JPRB, &
  & 0.61478428E-09_JPRB, 0.57275729E-09_JPRB, 0.52211085E-09_JPRB, 0.45990373E-09_JPRB, 0.39082271E-09_JPRB, 0.31141967E-09_JPRB, &
  & 0.23318300E-09_JPRB, 0.17609438E-09_JPRB, 0.13277383E-09_JPRB, 0.72968506E-10_JPRB, 0.42008438E-10_JPRB, 0.23407122E-10_JPRB, &
  & 0.12983650E-10_JPRB, 0.76146424E-11_JPRB, 0.50045176E-11_JPRB, 0.34240321E-11_JPRB /)

RGHG4(:,26,12) = (/ &
  & 0.24974220E-08_JPRB, 0.23845947E-08_JPRB, 0.23111670E-08_JPRB, 0.22488298E-08_JPRB, 0.21928468E-08_JPRB, 0.21403905E-08_JPRB, &
  & 0.20850475E-08_JPRB, 0.20086164E-08_JPRB, 0.18753421E-08_JPRB, 0.17446767E-08_JPRB, 0.16310814E-08_JPRB, 0.15286586E-08_JPRB, &
  & 0.14310355E-08_JPRB, 0.13365298E-08_JPRB, 0.12456761E-08_JPRB, 0.11566368E-08_JPRB, 0.10721536E-08_JPRB, 0.99266795E-09_JPRB, &
  & 0.91632485E-09_JPRB, 0.84447205E-09_JPRB, 0.77940415E-09_JPRB, 0.72294187E-09_JPRB, 0.67447359E-09_JPRB, 0.63534489E-09_JPRB, &
  & 0.60467431E-09_JPRB, 0.58250182E-09_JPRB, 0.56699634E-09_JPRB, 0.55577065E-09_JPRB, 0.54758925E-09_JPRB, 0.54078225E-09_JPRB, &
  & 0.53412264E-09_JPRB, 0.52755933E-09_JPRB, 0.52192556E-09_JPRB, 0.51576199E-09_JPRB, 0.51003002E-09_JPRB, 0.50514759E-09_JPRB, &
  & 0.50228188E-09_JPRB, 0.50116705E-09_JPRB, 0.50248061E-09_JPRB, 0.50566229E-09_JPRB, 0.51053339E-09_JPRB, 0.51729687E-09_JPRB, &
  & 0.52526122E-09_JPRB, 0.53383947E-09_JPRB, 0.54032540E-09_JPRB, 0.54217875E-09_JPRB, 0.53644228E-09_JPRB, 0.52161403E-09_JPRB, &
  & 0.49636545E-09_JPRB, 0.46314241E-09_JPRB, 0.42268880E-09_JPRB, 0.37224643E-09_JPRB, 0.31584915E-09_JPRB, 0.25245331E-09_JPRB, &
  & 0.18955686E-09_JPRB, 0.13834937E-09_JPRB, 0.10111727E-09_JPRB, 0.54359069E-10_JPRB, 0.29691749E-10_JPRB, 0.15873617E-10_JPRB, &
  & 0.86561713E-11_JPRB, 0.53290232E-11_JPRB, 0.29912863E-11_JPRB, 0.15875028E-11_JPRB /)

RGHG4(:,27,12) = (/ &
  & 0.22225399E-08_JPRB, 0.21211215E-08_JPRB, 0.20520881E-08_JPRB, 0.19927175E-08_JPRB, 0.19395530E-08_JPRB, 0.18894031E-08_JPRB, &
  & 0.18360434E-08_JPRB, 0.17640200E-08_JPRB, 0.16436308E-08_JPRB, 0.15273571E-08_JPRB, 0.14276298E-08_JPRB, 0.13379625E-08_JPRB, &
  & 0.12526504E-08_JPRB, 0.11694544E-08_JPRB, 0.10894150E-08_JPRB, 0.10107579E-08_JPRB, 0.93407471E-09_JPRB, 0.85949348E-09_JPRB, &
  & 0.78659917E-09_JPRB, 0.71672490E-09_JPRB, 0.65155314E-09_JPRB, 0.59271837E-09_JPRB, 0.54034360E-09_JPRB, 0.49607135E-09_JPRB, &
  & 0.45996526E-09_JPRB, 0.43257661E-09_JPRB, 0.41308187E-09_JPRB, 0.40042589E-09_JPRB, 0.39336800E-09_JPRB, 0.39049125E-09_JPRB, &
  & 0.38940112E-09_JPRB, 0.38965381E-09_JPRB, 0.39052317E-09_JPRB, 0.39055340E-09_JPRB, 0.39038334E-09_JPRB, 0.39022696E-09_JPRB, &
  & 0.39078488E-09_JPRB, 0.39266979E-09_JPRB, 0.39564566E-09_JPRB, 0.39958728E-09_JPRB, 0.40523535E-09_JPRB, 0.41222820E-09_JPRB, &
  & 0.42060319E-09_JPRB, 0.42946771E-09_JPRB, 0.43685622E-09_JPRB, 0.44015866E-09_JPRB, 0.43713394E-09_JPRB, 0.42587744E-09_JPRB, &
  & 0.40760595E-09_JPRB, 0.38176198E-09_JPRB, 0.34709965E-09_JPRB, 0.30635675E-09_JPRB, 0.25762031E-09_JPRB, 0.20797478E-09_JPRB, &
  & 0.15581852E-09_JPRB, 0.11226362E-09_JPRB, 0.78724742E-10_JPRB, 0.42666207E-10_JPRB, 0.23558447E-10_JPRB, 0.12823419E-10_JPRB, &
  & 0.68964660E-11_JPRB, 0.37771513E-11_JPRB, 0.20539425E-11_JPRB, 0.10698829E-11_JPRB /)

RGHG4(:,28,12) = (/ &
  & 0.20001629E-08_JPRB, 0.19047408E-08_JPRB, 0.18388551E-08_JPRB, 0.17819761E-08_JPRB, 0.17314180E-08_JPRB, 0.16835423E-08_JPRB, &
  & 0.16332625E-08_JPRB, 0.15673552E-08_JPRB, 0.14602178E-08_JPRB, 0.13562158E-08_JPRB, 0.12671735E-08_JPRB, 0.11868818E-08_JPRB, &
  & 0.11111135E-08_JPRB, 0.10370936E-08_JPRB, 0.96476427E-09_JPRB, 0.89338881E-09_JPRB, 0.82337359E-09_JPRB, 0.75471857E-09_JPRB, &
  & 0.68681799E-09_JPRB, 0.62047867E-09_JPRB, 0.55718952E-09_JPRB, 0.49866078E-09_JPRB, 0.44566426E-09_JPRB, 0.39952672E-09_JPRB, &
  & 0.36158018E-09_JPRB, 0.33138661E-09_JPRB, 0.30979444E-09_JPRB, 0.29527567E-09_JPRB, 0.28779409E-09_JPRB, 0.28596872E-09_JPRB, &
  & 0.28714400E-09_JPRB, 0.29078592E-09_JPRB, 0.29511310E-09_JPRB, 0.29898073E-09_JPRB, 0.30200584E-09_JPRB, 0.30483913E-09_JPRB, &
  & 0.30734973E-09_JPRB, 0.31058403E-09_JPRB, 0.31441666E-09_JPRB, 0.31895131E-09_JPRB, 0.32495925E-09_JPRB, 0.33236200E-09_JPRB, &
  & 0.34094313E-09_JPRB, 0.35003109E-09_JPRB, 0.35793987E-09_JPRB, 0.36228687E-09_JPRB, 0.36155751E-09_JPRB, 0.35395833E-09_JPRB, &
  & 0.33976724E-09_JPRB, 0.31897388E-09_JPRB, 0.29040398E-09_JPRB, 0.25589872E-09_JPRB, 0.21420229E-09_JPRB, 0.17216695E-09_JPRB, &
  & 0.12882077E-09_JPRB, 0.92909312E-10_JPRB, 0.64789306E-10_JPRB, 0.35653470E-10_JPRB, 0.19596399E-10_JPRB, 0.10592823E-10_JPRB, &
  & 0.53669447E-11_JPRB, 0.30264547E-11_JPRB, 0.16571669E-11_JPRB, 0.83710643E-12_JPRB /)

RGHG4(:,29,12) = (/ &
  & 0.17992396E-08_JPRB, 0.17112962E-08_JPRB, 0.16484601E-08_JPRB, 0.15939275E-08_JPRB, 0.15457223E-08_JPRB, 0.15006856E-08_JPRB, &
  & 0.14540662E-08_JPRB, 0.13942599E-08_JPRB, 0.12999082E-08_JPRB, 0.12082928E-08_JPRB, 0.11291039E-08_JPRB, 0.10577117E-08_JPRB, &
  & 0.98989772E-09_JPRB, 0.92364388E-09_JPRB, 0.85876312E-09_JPRB, 0.79440443E-09_JPRB, 0.73088591E-09_JPRB, 0.66782613E-09_JPRB, &
  & 0.60478256E-09_JPRB, 0.54241905E-09_JPRB, 0.48191551E-09_JPRB, 0.42521678E-09_JPRB, 0.37340309E-09_JPRB, 0.32757555E-09_JPRB, &
  & 0.28955391E-09_JPRB, 0.25832542E-09_JPRB, 0.23580016E-09_JPRB, 0.21992631E-09_JPRB, 0.21159734E-09_JPRB, 0.20953653E-09_JPRB, &
  & 0.21124097E-09_JPRB, 0.21612778E-09_JPRB, 0.22194246E-09_JPRB, 0.22799240E-09_JPRB, 0.23275934E-09_JPRB, 0.23745281E-09_JPRB, &
  & 0.24109811E-09_JPRB, 0.24511007E-09_JPRB, 0.24923225E-09_JPRB, 0.25412170E-09_JPRB, 0.26034952E-09_JPRB, 0.26816674E-09_JPRB, &
  & 0.27704838E-09_JPRB, 0.28654742E-09_JPRB, 0.29507446E-09_JPRB, 0.30073294E-09_JPRB, 0.30162786E-09_JPRB, 0.29703978E-09_JPRB, &
  & 0.28629829E-09_JPRB, 0.26904937E-09_JPRB, 0.24473207E-09_JPRB, 0.21551769E-09_JPRB, 0.18065432E-09_JPRB, 0.14549606E-09_JPRB, &
  & 0.10972943E-09_JPRB, 0.79456115E-10_JPRB, 0.54691338E-10_JPRB, 0.29838965E-10_JPRB, 0.16324220E-10_JPRB, 0.86240702E-11_JPRB, &
  & 0.46864717E-11_JPRB, 0.24253238E-11_JPRB, 0.15586471E-11_JPRB, 0.69396968E-12_JPRB /)

RGHG4(:,30,12) = (/ &
  & 0.16308286E-08_JPRB, 0.15439867E-08_JPRB, 0.14823460E-08_JPRB, 0.14300513E-08_JPRB, 0.13840609E-08_JPRB, 0.13418944E-08_JPRB, &
  & 0.12991065E-08_JPRB, 0.12452688E-08_JPRB, 0.11622068E-08_JPRB, 0.10811854E-08_JPRB, 0.10109459E-08_JPRB, 0.94764530E-09_JPRB, &
  & 0.88723984E-09_JPRB, 0.82786095E-09_JPRB, 0.76916973E-09_JPRB, 0.71043160E-09_JPRB, 0.65184336E-09_JPRB, 0.59339667E-09_JPRB, &
  & 0.53475557E-09_JPRB, 0.47662368E-09_JPRB, 0.41995157E-09_JPRB, 0.36615647E-09_JPRB, 0.31671291E-09_JPRB, 0.27269137E-09_JPRB, &
  & 0.23571878E-09_JPRB, 0.20490559E-09_JPRB, 0.18193859E-09_JPRB, 0.16552430E-09_JPRB, 0.15613608E-09_JPRB, 0.15304905E-09_JPRB, &
  & 0.15435316E-09_JPRB, 0.15900838E-09_JPRB, 0.16525756E-09_JPRB, 0.17217694E-09_JPRB, 0.17782903E-09_JPRB, 0.18343888E-09_JPRB, &
  & 0.18771773E-09_JPRB, 0.19232733E-09_JPRB, 0.19672958E-09_JPRB, 0.20213337E-09_JPRB, 0.20876623E-09_JPRB, 0.21706251E-09_JPRB, &
  & 0.22635505E-09_JPRB, 0.23632690E-09_JPRB, 0.24545468E-09_JPRB, 0.25218458E-09_JPRB, 0.25462371E-09_JPRB, 0.25198069E-09_JPRB, &
  & 0.24370569E-09_JPRB, 0.22883573E-09_JPRB, 0.20873941E-09_JPRB, 0.18361766E-09_JPRB, 0.15337563E-09_JPRB, 0.12137358E-09_JPRB, &
  & 0.92452067E-10_JPRB, 0.66418683E-10_JPRB, 0.44876075E-10_JPRB, 0.24653026E-10_JPRB, 0.13748632E-10_JPRB, 0.72274803E-11_JPRB, &
  & 0.38849171E-11_JPRB, 0.25137930E-11_JPRB, 0.10993359E-11_JPRB, 0.59506848E-12_JPRB /)

RGHG4(:,31,12) = (/ &
  & 0.14749632E-08_JPRB, 0.13887324E-08_JPRB, 0.13293595E-08_JPRB, 0.12794252E-08_JPRB, 0.12358601E-08_JPRB, 0.11962927E-08_JPRB, &
  & 0.11569912E-08_JPRB, 0.11083814E-08_JPRB, 0.10357427E-08_JPRB, 0.96485375E-09_JPRB, 0.90297347E-09_JPRB, 0.84699692E-09_JPRB, &
  & 0.79326273E-09_JPRB, 0.74006196E-09_JPRB, 0.68706540E-09_JPRB, 0.63351058E-09_JPRB, 0.57945126E-09_JPRB, 0.52505827E-09_JPRB, &
  & 0.47012000E-09_JPRB, 0.41570250E-09_JPRB, 0.36284603E-09_JPRB, 0.31255576E-09_JPRB, 0.26625832E-09_JPRB, 0.22495998E-09_JPRB, &
  & 0.19011452E-09_JPRB, 0.16115854E-09_JPRB, 0.13902984E-09_JPRB, 0.12291075E-09_JPRB, 0.11304083E-09_JPRB, 0.10908323E-09_JPRB, &
  & 0.10965257E-09_JPRB, 0.11347345E-09_JPRB, 0.11943499E-09_JPRB, 0.12618294E-09_JPRB, 0.13213979E-09_JPRB, 0.13789697E-09_JPRB, &
  & 0.14251994E-09_JPRB, 0.14728378E-09_JPRB, 0.15188403E-09_JPRB, 0.15768248E-09_JPRB, 0.16477683E-09_JPRB, 0.17361973E-09_JPRB, &
  & 0.18351486E-09_JPRB, 0.19411454E-09_JPRB, 0.20400677E-09_JPRB, 0.21174387E-09_JPRB, 0.21548160E-09_JPRB, 0.21437394E-09_JPRB, &
  & 0.20761037E-09_JPRB, 0.19487424E-09_JPRB, 0.17752583E-09_JPRB, 0.15495964E-09_JPRB, 0.13070942E-09_JPRB, 0.10369620E-09_JPRB, &
  & 0.79030671E-10_JPRB, 0.56519903E-10_JPRB, 0.38055926E-10_JPRB, 0.20854676E-10_JPRB, 0.11429373E-10_JPRB, 0.61614923E-11_JPRB, &
  & 0.31132967E-11_JPRB, 0.19494371E-11_JPRB, 0.11873292E-11_JPRB, 0.57524157E-12_JPRB /)

RGHG4(:,32,12) = (/ &
  & 0.13350063E-08_JPRB, 0.12515479E-08_JPRB, 0.11953046E-08_JPRB, 0.11480187E-08_JPRB, 0.11067044E-08_JPRB, 0.10692850E-08_JPRB, &
  & 0.10328139E-08_JPRB, 0.98848985E-09_JPRB, 0.92427904E-09_JPRB, 0.86177426E-09_JPRB, 0.80714063E-09_JPRB, 0.75756157E-09_JPRB, &
  & 0.70968303E-09_JPRB, 0.66162875E-09_JPRB, 0.61298061E-09_JPRB, 0.56346744E-09_JPRB, 0.51316468E-09_JPRB, 0.46233406E-09_JPRB, &
  & 0.41116419E-09_JPRB, 0.36074399E-09_JPRB, 0.31190731E-09_JPRB, 0.26562560E-09_JPRB, 0.22295939E-09_JPRB, 0.18514380E-09_JPRB, &
  & 0.15293380E-09_JPRB, 0.12630193E-09_JPRB, 0.10544658E-09_JPRB, 0.90184686E-10_JPRB, 0.80470339E-10_JPRB, 0.75855773E-10_JPRB, &
  & 0.75521284E-10_JPRB, 0.78253737E-10_JPRB, 0.83263042E-10_JPRB, 0.89209189E-10_JPRB, 0.94981363E-10_JPRB, 0.10054022E-09_JPRB, &
  & 0.10546033E-09_JPRB, 0.11031964E-09_JPRB, 0.11541241E-09_JPRB, 0.12165273E-09_JPRB, 0.12918626E-09_JPRB, 0.13832438E-09_JPRB, &
  & 0.14864410E-09_JPRB, 0.15965126E-09_JPRB, 0.17008131E-09_JPRB, 0.17841102E-09_JPRB, 0.18309707E-09_JPRB, 0.18339005E-09_JPRB, &
  & 0.17855974E-09_JPRB, 0.16826378E-09_JPRB, 0.15350932E-09_JPRB, 0.13380069E-09_JPRB, 0.11249461E-09_JPRB, 0.88811077E-10_JPRB, &
  & 0.65730060E-10_JPRB, 0.47087584E-10_JPRB, 0.31467384E-10_JPRB, 0.17326076E-10_JPRB, 0.96931439E-11_JPRB, 0.53313374E-11_JPRB, &
  & 0.28110888E-11_JPRB, 0.17391426E-11_JPRB, 0.80660093E-12_JPRB, 0.47055204E-12_JPRB /)

RGHG4(:,33,12) = (/ &
  & 0.12055940E-08_JPRB, 0.11264554E-08_JPRB, 0.10736039E-08_JPRB, 0.10288478E-08_JPRB, 0.99006592E-09_JPRB, 0.95467723E-09_JPRB, &
  & 0.92035268E-09_JPRB, 0.87937330E-09_JPRB, 0.82212692E-09_JPRB, 0.76685269E-09_JPRB, 0.71856354E-09_JPRB, 0.67462347E-09_JPRB, &
  & 0.63190869E-09_JPRB, 0.58843647E-09_JPRB, 0.54359034E-09_JPRB, 0.49724030E-09_JPRB, 0.44972692E-09_JPRB, 0.40162940E-09_JPRB, &
  & 0.35379558E-09_JPRB, 0.30698380E-09_JPRB, 0.26201263E-09_JPRB, 0.21995607E-09_JPRB, 0.18154139E-09_JPRB, 0.14760083E-09_JPRB, &
  & 0.11902641E-09_JPRB, 0.95625417E-10_JPRB, 0.77372296E-10_JPRB, 0.63916400E-10_JPRB, 0.54965383E-10_JPRB, 0.50262110E-10_JPRB, &
  & 0.49083619E-10_JPRB, 0.50712011E-10_JPRB, 0.54309869E-10_JPRB, 0.59109738E-10_JPRB, 0.64127745E-10_JPRB, 0.69105353E-10_JPRB, &
  & 0.73759700E-10_JPRB, 0.78478737E-10_JPRB, 0.83780684E-10_JPRB, 0.90232703E-10_JPRB, 0.98092784E-10_JPRB, 0.10752211E-09_JPRB, &
  & 0.11826376E-09_JPRB, 0.12976101E-09_JPRB, 0.14076036E-09_JPRB, 0.14974952E-09_JPRB, 0.15535026E-09_JPRB, 0.15675244E-09_JPRB, &
  & 0.15305245E-09_JPRB, 0.14429220E-09_JPRB, 0.13163534E-09_JPRB, 0.11509072E-09_JPRB, 0.97171764E-10_JPRB, 0.77028967E-10_JPRB, &
  & 0.57256925E-10_JPRB, 0.40992147E-10_JPRB, 0.27630679E-10_JPRB, 0.15270401E-10_JPRB, 0.82939064E-11_JPRB, 0.41944885E-11_JPRB, &
  & 0.22111846E-11_JPRB, 0.14095613E-11_JPRB, 0.80915754E-12_JPRB, 0.45471876E-12_JPRB /)

RGHG4(:,34,12) = (/ &
  & 0.10901182E-08_JPRB, 0.10169401E-08_JPRB, 0.96685138E-09_JPRB, 0.92482361E-09_JPRB, 0.88799285E-09_JPRB, 0.85452556E-09_JPRB, &
  & 0.82182305E-09_JPRB, 0.78354850E-09_JPRB, 0.73181539E-09_JPRB, 0.68247996E-09_JPRB, 0.63955036E-09_JPRB, 0.60057082E-09_JPRB, &
  & 0.56231508E-09_JPRB, 0.52294419E-09_JPRB, 0.48132354E-09_JPRB, 0.43759549E-09_JPRB, 0.39262818E-09_JPRB, 0.34692668E-09_JPRB, &
  & 0.30170666E-09_JPRB, 0.25801242E-09_JPRB, 0.21694713E-09_JPRB, 0.17914567E-09_JPRB, 0.14495634E-09_JPRB, 0.11524042E-09_JPRB, &
  & 0.90537036E-10_JPRB, 0.70768141E-10_JPRB, 0.55440135E-10_JPRB, 0.44123247E-10_JPRB, 0.36458472E-10_JPRB, 0.32027291E-10_JPRB, &
  & 0.30445872E-10_JPRB, 0.30987646E-10_JPRB, 0.33177655E-10_JPRB, 0.36653409E-10_JPRB, 0.40566502E-10_JPRB, 0.44765639E-10_JPRB, &
  & 0.48992570E-10_JPRB, 0.53455334E-10_JPRB, 0.58630746E-10_JPRB, 0.64963090E-10_JPRB, 0.72782495E-10_JPRB, 0.82165198E-10_JPRB, &
  & 0.93109118E-10_JPRB, 0.10483447E-09_JPRB, 0.11617842E-09_JPRB, 0.12568326E-09_JPRB, 0.13197166E-09_JPRB, 0.13402020E-09_JPRB, &
  & 0.13129994E-09_JPRB, 0.12470742E-09_JPRB, 0.11451459E-09_JPRB, 0.10061453E-09_JPRB, 0.84955480E-10_JPRB, 0.67422901E-10_JPRB, &
  & 0.50014309E-10_JPRB, 0.35605699E-10_JPRB, 0.23891222E-10_JPRB, 0.13024915E-10_JPRB, 0.70714164E-11_JPRB, 0.38929329E-11_JPRB, &
  & 0.21407719E-11_JPRB, 0.13192035E-11_JPRB, 0.62467083E-12_JPRB, 0.42469790E-12_JPRB /)

RGHG4(:,35,12) = (/ &
  & 0.98130981E-09_JPRB, 0.91334029E-09_JPRB, 0.86708363E-09_JPRB, 0.82750423E-09_JPRB, 0.79276447E-09_JPRB, 0.76091516E-09_JPRB, &
  & 0.72973810E-09_JPRB, 0.69379064E-09_JPRB, 0.64716654E-09_JPRB, 0.60336230E-09_JPRB, 0.56553118E-09_JPRB, 0.53121690E-09_JPRB, &
  & 0.49710536E-09_JPRB, 0.46140852E-09_JPRB, 0.42281967E-09_JPRB, 0.38152326E-09_JPRB, 0.33831388E-09_JPRB, 0.29471009E-09_JPRB, &
  & 0.25180996E-09_JPRB, 0.21102566E-09_JPRB, 0.17351598E-09_JPRB, 0.13971040E-09_JPRB, 0.11003577E-09_JPRB, 0.85112500E-10_JPRB, &
  & 0.65002094E-10_JPRB, 0.49297105E-10_JPRB, 0.37421989E-10_JPRB, 0.28744916E-10_JPRB, 0.22793522E-10_JPRB, 0.19182170E-10_JPRB, &
  & 0.17626125E-10_JPRB, 0.17463057E-10_JPRB, 0.18602345E-10_JPRB, 0.20685330E-10_JPRB, 0.23347661E-10_JPRB, 0.26417478E-10_JPRB, &
  & 0.29774398E-10_JPRB, 0.33529578E-10_JPRB, 0.38080560E-10_JPRB, 0.43821009E-10_JPRB, 0.51065423E-10_JPRB, 0.60146214E-10_JPRB, &
  & 0.70964193E-10_JPRB, 0.82818509E-10_JPRB, 0.94489444E-10_JPRB, 0.10441076E-09_JPRB, 0.11125732E-09_JPRB, 0.11410867E-09_JPRB, &
  & 0.11259166E-09_JPRB, 0.10741767E-09_JPRB, 0.98678656E-10_JPRB, 0.86661525E-10_JPRB, 0.73328905E-10_JPRB, 0.58417368E-10_JPRB, &
  & 0.43490725E-10_JPRB, 0.30856376E-10_JPRB, 0.20863521E-10_JPRB, 0.11559643E-10_JPRB, 0.64747639E-11_JPRB, 0.34959373E-11_JPRB, &
  & 0.18682848E-11_JPRB, 0.10868781E-11_JPRB, 0.62104185E-12_JPRB, 0.41924190E-12_JPRB /)

RGHG4(:,36,12) = (/ &
  & 0.88100710E-09_JPRB, 0.81933799E-09_JPRB, 0.77644219E-09_JPRB, 0.73989914E-09_JPRB, 0.70726175E-09_JPRB, 0.67707479E-09_JPRB, &
  & 0.64744760E-09_JPRB, 0.61369376E-09_JPRB, 0.57159671E-09_JPRB, 0.53278082E-09_JPRB, 0.49956594E-09_JPRB, 0.46951176E-09_JPRB, &
  & 0.43942208E-09_JPRB, 0.40726095E-09_JPRB, 0.37146461E-09_JPRB, 0.33240197E-09_JPRB, 0.29079811E-09_JPRB, 0.24878949E-09_JPRB, &
  & 0.20810020E-09_JPRB, 0.16993729E-09_JPRB, 0.13553839E-09_JPRB, 0.10549853E-09_JPRB, 0.80284203E-10_JPRB, 0.60058736E-10_JPRB, &
  & 0.44587750E-10_JPRB, 0.33001456E-10_JPRB, 0.24481493E-10_JPRB, 0.18392822E-10_JPRB, 0.14187015E-10_JPRB, 0.11599056E-10_JPRB, &
  & 0.10305545E-10_JPRB, 0.99242021E-11_JPRB, 0.10373829E-10_JPRB, 0.11526574E-10_JPRB, 0.13070339E-10_JPRB, 0.15127099E-10_JPRB, &
  & 0.17469023E-10_JPRB, 0.20310155E-10_JPRB, 0.23918636E-10_JPRB, 0.28574206E-10_JPRB, 0.34825955E-10_JPRB, 0.42953533E-10_JPRB, &
  & 0.53087056E-10_JPRB, 0.64658189E-10_JPRB, 0.76257063E-10_JPRB, 0.86446829E-10_JPRB, 0.93732758E-10_JPRB, 0.97257931E-10_JPRB, &
  & 0.96679859E-10_JPRB, 0.92622465E-10_JPRB, 0.85471637E-10_JPRB, 0.75531560E-10_JPRB, 0.64112333E-10_JPRB, 0.51190899E-10_JPRB, &
  & 0.37973992E-10_JPRB, 0.26730137E-10_JPRB, 0.17984310E-10_JPRB, 0.99310829E-11_JPRB, 0.54392237E-11_JPRB, 0.28241127E-11_JPRB, &
  & 0.14630916E-11_JPRB, 0.97468789E-12_JPRB, 0.58327849E-12_JPRB, 0.38439992E-12_JPRB /)

RGHG4(:,37,12) = (/ &
  & 0.78609108E-09_JPRB, 0.73035955E-09_JPRB, 0.69167105E-09_JPRB, 0.65790423E-09_JPRB, 0.62749173E-09_JPRB, 0.59904814E-09_JPRB, &
  & 0.57094357E-09_JPRB, 0.53941107E-09_JPRB, 0.50156834E-09_JPRB, 0.46744969E-09_JPRB, 0.43851786E-09_JPRB, 0.41239379E-09_JPRB, &
  & 0.38601583E-09_JPRB, 0.35711809E-09_JPRB, 0.32430603E-09_JPRB, 0.28737887E-09_JPRB, 0.24795865E-09_JPRB, 0.20723373E-09_JPRB, &
  & 0.16812651E-09_JPRB, 0.13235366E-09_JPRB, 0.10116588E-09_JPRB, 0.75360863E-10_JPRB, 0.55062132E-10_JPRB, 0.39931690E-10_JPRB, &
  & 0.28980962E-10_JPRB, 0.21268909E-10_JPRB, 0.15766348E-10_JPRB, 0.11875802E-10_JPRB, 0.91697162E-11_JPRB, 0.74497717E-11_JPRB, &
  & 0.64949608E-11_JPRB, 0.60909069E-11_JPRB, 0.62391641E-11_JPRB, 0.67838101E-11_JPRB, 0.76625815E-11_JPRB, 0.89176791E-11_JPRB, &
  & 0.10407099E-10_JPRB, 0.12385494E-10_JPRB, 0.14911850E-10_JPRB, 0.18388995E-10_JPRB, 0.23179077E-10_JPRB, 0.29783336E-10_JPRB, &
  & 0.38567469E-10_JPRB, 0.49114726E-10_JPRB, 0.60411301E-10_JPRB, 0.70641958E-10_JPRB, 0.78255319E-10_JPRB, 0.82325848E-10_JPRB, &
  & 0.82619189E-10_JPRB, 0.79729078E-10_JPRB, 0.73939743E-10_JPRB, 0.65459423E-10_JPRB, 0.55495854E-10_JPRB, 0.44152761E-10_JPRB, &
  & 0.32580869E-10_JPRB, 0.22709739E-10_JPRB, 0.15351396E-10_JPRB, 0.84479090E-11_JPRB, 0.45230924E-11_JPRB, 0.23893847E-11_JPRB, &
  & 0.14670955E-11_JPRB, 0.82519283E-12_JPRB, 0.52126473E-12_JPRB, 0.35610113E-12_JPRB /)

RGHG4(:,38,12) = (/ &
  & 0.69897471E-09_JPRB, 0.64933725E-09_JPRB, 0.61431760E-09_JPRB, 0.58363625E-09_JPRB, 0.55548943E-09_JPRB, 0.52876964E-09_JPRB, &
  & 0.50217064E-09_JPRB, 0.47279025E-09_JPRB, 0.43894186E-09_JPRB, 0.40909925E-09_JPRB, 0.38411205E-09_JPRB, 0.36146977E-09_JPRB, &
  & 0.33875547E-09_JPRB, 0.31293887E-09_JPRB, 0.28308506E-09_JPRB, 0.24798871E-09_JPRB, 0.20979628E-09_JPRB, 0.17105489E-09_JPRB, &
  & 0.13406039E-09_JPRB, 0.10098693E-09_JPRB, 0.73695543E-10_JPRB, 0.52647438E-10_JPRB, 0.37365475E-10_JPRB, 0.26779615E-10_JPRB, &
  & 0.19518585E-10_JPRB, 0.14516217E-10_JPRB, 0.11021828E-10_JPRB, 0.84932729E-11_JPRB, 0.66771046E-11_JPRB, 0.54912043E-11_JPRB, &
  & 0.47257597E-11_JPRB, 0.43875550E-11_JPRB, 0.43684782E-11_JPRB, 0.46681218E-11_JPRB, 0.51878515E-11_JPRB, 0.59895227E-11_JPRB, &
  & 0.69966507E-11_JPRB, 0.83808707E-11_JPRB, 0.10160249E-10_JPRB, 0.12672096E-10_JPRB, 0.16163987E-10_JPRB, 0.21207435E-10_JPRB, &
  & 0.28246867E-10_JPRB, 0.37349408E-10_JPRB, 0.47672508E-10_JPRB, 0.57522306E-10_JPRB, 0.65130880E-10_JPRB, 0.69594927E-10_JPRB, &
  & 0.70531352E-10_JPRB, 0.68380086E-10_JPRB, 0.63239254E-10_JPRB, 0.56323713E-10_JPRB, 0.47834143E-10_JPRB, 0.38125982E-10_JPRB, &
  & 0.28255792E-10_JPRB, 0.19692399E-10_JPRB, 0.13280586E-10_JPRB, 0.71923374E-11_JPRB, 0.39947147E-11_JPRB, 0.22117065E-11_JPRB, &
  & 0.11515354E-11_JPRB, 0.66277843E-12_JPRB, 0.50318273E-12_JPRB, 0.33089192E-12_JPRB /)

RGHG4(:,39,12) = (/ &
  & 0.61635846E-09_JPRB, 0.57249133E-09_JPRB, 0.54151705E-09_JPRB, 0.51397520E-09_JPRB, 0.48826970E-09_JPRB, 0.46358653E-09_JPRB, &
  & 0.43867435E-09_JPRB, 0.41162385E-09_JPRB, 0.38160883E-09_JPRB, 0.35582179E-09_JPRB, 0.33422287E-09_JPRB, 0.31490982E-09_JPRB, &
  & 0.29513902E-09_JPRB, 0.27275446E-09_JPRB, 0.24541064E-09_JPRB, 0.21346618E-09_JPRB, 0.17725880E-09_JPRB, 0.14006150E-09_JPRB, &
  & 0.10565958E-09_JPRB, 0.76468117E-10_JPRB, 0.53689914E-10_JPRB, 0.37528120E-10_JPRB, 0.26543504E-10_JPRB, 0.19205164E-10_JPRB, &
  & 0.14326858E-10_JPRB, 0.10918095E-10_JPRB, 0.85261052E-11_JPRB, 0.67441482E-11_JPRB, 0.54116603E-11_JPRB, 0.45183744E-11_JPRB, &
  & 0.38452943E-11_JPRB, 0.35703909E-11_JPRB, 0.34569455E-11_JPRB, 0.36463918E-11_JPRB, 0.39833735E-11_JPRB, 0.45497404E-11_JPRB, &
  & 0.52891216E-11_JPRB, 0.63118928E-11_JPRB, 0.76514524E-11_JPRB, 0.95353864E-11_JPRB, 0.12143416E-10_JPRB, 0.16008514E-10_JPRB, &
  & 0.21503939E-10_JPRB, 0.28965967E-10_JPRB, 0.37872303E-10_JPRB, 0.46774008E-10_JPRB, 0.54137445E-10_JPRB, 0.58681775E-10_JPRB, &
  & 0.60054475E-10_JPRB, 0.58599486E-10_JPRB, 0.54420846E-10_JPRB, 0.48544595E-10_JPRB, 0.41242558E-10_JPRB, 0.32873159E-10_JPRB, &
  & 0.24303580E-10_JPRB, 0.16855909E-10_JPRB, 0.11418574E-10_JPRB, 0.63453687E-11_JPRB, 0.35487681E-11_JPRB, 0.17762932E-11_JPRB, &
  & 0.10442238E-11_JPRB, 0.67279808E-12_JPRB, 0.44217917E-12_JPRB, 0.32444081E-12_JPRB /)

RGHG4(:,40,12) = (/ &
  & 0.53983773E-09_JPRB, 0.50142390E-09_JPRB, 0.47396598E-09_JPRB, 0.44946288E-09_JPRB, 0.42639414E-09_JPRB, 0.40382211E-09_JPRB, &
  & 0.38103976E-09_JPRB, 0.35648839E-09_JPRB, 0.33019310E-09_JPRB, 0.30786013E-09_JPRB, 0.28952094E-09_JPRB, 0.27288416E-09_JPRB, &
  & 0.25601332E-09_JPRB, 0.23646587E-09_JPRB, 0.21226376E-09_JPRB, 0.18211142E-09_JPRB, 0.14857668E-09_JPRB, 0.11430277E-09_JPRB, &
  & 0.83126152E-10_JPRB, 0.58329952E-10_JPRB, 0.40426308E-10_JPRB, 0.28249391E-10_JPRB, 0.20346671E-10_JPRB, 0.15000364E-10_JPRB, &
  & 0.11493562E-10_JPRB, 0.89560668E-11_JPRB, 0.71652302E-11_JPRB, 0.57796697E-11_JPRB, 0.47277373E-11_JPRB, 0.39492138E-11_JPRB, &
  & 0.34051113E-11_JPRB, 0.30861598E-11_JPRB, 0.29952256E-11_JPRB, 0.30752120E-11_JPRB, 0.33437708E-11_JPRB, 0.37637541E-11_JPRB, &
  & 0.43597760E-11_JPRB, 0.51673010E-11_JPRB, 0.62427368E-11_JPRB, 0.77237886E-11_JPRB, 0.98116706E-11_JPRB, 0.12851887E-10_JPRB, &
  & 0.17195700E-10_JPRB, 0.23173267E-10_JPRB, 0.30553740E-10_JPRB, 0.38431310E-10_JPRB, 0.45096930E-10_JPRB, 0.49529256E-10_JPRB, &
  & 0.51156451E-10_JPRB, 0.50229352E-10_JPRB, 0.46780940E-10_JPRB, 0.41742710E-10_JPRB, 0.35463368E-10_JPRB, 0.28116487E-10_JPRB, &
  & 0.20831559E-10_JPRB, 0.14593623E-10_JPRB, 0.10106079E-10_JPRB, 0.56121084E-11_JPRB, 0.30765308E-11_JPRB, 0.17053896E-11_JPRB, &
  & 0.10293347E-11_JPRB, 0.62161468E-12_JPRB, 0.41786737E-12_JPRB, 0.33678025E-12_JPRB /)

RGHG4(:,41,12) = (/ &
  & 0.47143245E-09_JPRB, 0.43737056E-09_JPRB, 0.41311524E-09_JPRB, 0.39146025E-09_JPRB, 0.37060643E-09_JPRB, 0.35000991E-09_JPRB, &
  & 0.32915456E-09_JPRB, 0.30698449E-09_JPRB, 0.28381394E-09_JPRB, 0.26474345E-09_JPRB, 0.24883201E-09_JPRB, 0.23485677E-09_JPRB, &
  & 0.22021526E-09_JPRB, 0.20337911E-09_JPRB, 0.18209285E-09_JPRB, 0.15541696E-09_JPRB, 0.12435643E-09_JPRB, 0.93556822E-10_JPRB, &
  & 0.66499167E-10_JPRB, 0.45915636E-10_JPRB, 0.31911081E-10_JPRB, 0.22640697E-10_JPRB, 0.16719312E-10_JPRB, 0.12617437E-10_JPRB, &
  & 0.98907705E-11_JPRB, 0.78817768E-11_JPRB, 0.63906675E-11_JPRB, 0.52286634E-11_JPRB, 0.43561287E-11_JPRB, 0.36060011E-11_JPRB, &
  & 0.31595447E-11_JPRB, 0.28114659E-11_JPRB, 0.27244279E-11_JPRB, 0.27582073E-11_JPRB, 0.29769648E-11_JPRB, 0.33192008E-11_JPRB, &
  & 0.38279605E-11_JPRB, 0.44995661E-11_JPRB, 0.54155278E-11_JPRB, 0.66495381E-11_JPRB, 0.83732197E-11_JPRB, 0.10826087E-10_JPRB, &
  & 0.14319167E-10_JPRB, 0.19178674E-10_JPRB, 0.25328219E-10_JPRB, 0.31925174E-10_JPRB, 0.37851680E-10_JPRB, 0.41912369E-10_JPRB, &
  & 0.43634665E-10_JPRB, 0.43071838E-10_JPRB, 0.40203240E-10_JPRB, 0.35837409E-10_JPRB, 0.30198861E-10_JPRB, 0.23953263E-10_JPRB, &
  & 0.17742238E-10_JPRB, 0.12569844E-10_JPRB, 0.87151623E-11_JPRB, 0.49631354E-11_JPRB, 0.28843846E-11_JPRB, 0.16418345E-11_JPRB, &
  & 0.88658730E-12_JPRB, 0.61443250E-12_JPRB, 0.42494767E-12_JPRB, 0.34825026E-12_JPRB /)

RGHG4(:,42,12) = (/ &
  & 0.40814060E-09_JPRB, 0.37811354E-09_JPRB, 0.35658287E-09_JPRB, 0.33733472E-09_JPRB, 0.31878744E-09_JPRB, 0.30020211E-09_JPRB, &
  & 0.28157560E-09_JPRB, 0.26196342E-09_JPRB, 0.24189209E-09_JPRB, 0.22550567E-09_JPRB, 0.21208339E-09_JPRB, 0.20001643E-09_JPRB, &
  & 0.18782470E-09_JPRB, 0.17325540E-09_JPRB, 0.15472455E-09_JPRB, 0.13071015E-09_JPRB, 0.10305226E-09_JPRB, 0.75863503E-10_JPRB, &
  & 0.53412979E-10_JPRB, 0.36839795E-10_JPRB, 0.26027267E-10_JPRB, 0.18829055E-10_JPRB, 0.14262755E-10_JPRB, 0.11062691E-10_JPRB, &
  & 0.87679412E-11_JPRB, 0.71411575E-11_JPRB, 0.58520138E-11_JPRB, 0.48239442E-11_JPRB, 0.40568590E-11_JPRB, 0.33757407E-11_JPRB, &
  & 0.29480624E-11_JPRB, 0.26307084E-11_JPRB, 0.25194755E-11_JPRB, 0.25408909E-11_JPRB, 0.27206076E-11_JPRB, 0.30198598E-11_JPRB, &
  & 0.34619423E-11_JPRB, 0.40502016E-11_JPRB, 0.48408105E-11_JPRB, 0.58948055E-11_JPRB, 0.73528145E-11_JPRB, 0.93924200E-11_JPRB, &
  & 0.12290910E-10_JPRB, 0.16255363E-10_JPRB, 0.21225924E-10_JPRB, 0.26768121E-10_JPRB, 0.31811092E-10_JPRB, 0.35510692E-10_JPRB, &
  & 0.37204941E-10_JPRB, 0.36920501E-10_JPRB, 0.34573150E-10_JPRB, 0.30709060E-10_JPRB, 0.25658522E-10_JPRB, 0.20312044E-10_JPRB, &
  & 0.15104817E-10_JPRB, 0.10720139E-10_JPRB, 0.76345449E-11_JPRB, 0.44524714E-11_JPRB, 0.25569891E-11_JPRB, 0.14783550E-11_JPRB, &
  & 0.95484113E-12_JPRB, 0.65236797E-12_JPRB, 0.44865424E-12_JPRB, 0.36009894E-12_JPRB /)

RGHG4(:,43,12) = (/ &
  & 0.35050643E-09_JPRB, 0.32331249E-09_JPRB, 0.30416211E-09_JPRB, 0.28711775E-09_JPRB, 0.27037303E-09_JPRB, 0.25351626E-09_JPRB, &
  & 0.23686869E-09_JPRB, 0.21961724E-09_JPRB, 0.20229744E-09_JPRB, 0.18855979E-09_JPRB, 0.17723595E-09_JPRB, 0.16723553E-09_JPRB, &
  & 0.15692757E-09_JPRB, 0.14491040E-09_JPRB, 0.12918588E-09_JPRB, 0.10875267E-09_JPRB, 0.84583743E-10_JPRB, 0.61197727E-10_JPRB, &
  & 0.42874367E-10_JPRB, 0.30019452E-10_JPRB, 0.21776641E-10_JPRB, 0.16268785E-10_JPRB, 0.12528882E-10_JPRB, 0.99859140E-11_JPRB, &
  & 0.80300940E-11_JPRB, 0.65901056E-11_JPRB, 0.54659354E-11_JPRB, 0.45401152E-11_JPRB, 0.38014405E-11_JPRB, 0.32058022E-11_JPRB, &
  & 0.27813255E-11_JPRB, 0.24872905E-11_JPRB, 0.23761292E-11_JPRB, 0.23790462E-11_JPRB, 0.25420356E-11_JPRB, 0.28085746E-11_JPRB, &
  & 0.32071604E-11_JPRB, 0.37355791E-11_JPRB, 0.44344567E-11_JPRB, 0.53574584E-11_JPRB, 0.66107042E-11_JPRB, 0.83351563E-11_JPRB, &
  & 0.10721009E-10_JPRB, 0.13910009E-10_JPRB, 0.17971140E-10_JPRB, 0.22509073E-10_JPRB, 0.26800140E-10_JPRB, 0.30006247E-10_JPRB, &
  & 0.31629040E-10_JPRB, 0.31581640E-10_JPRB, 0.29643548E-10_JPRB, 0.26319166E-10_JPRB, 0.21810139E-10_JPRB, 0.17250725E-10_JPRB, &
  & 0.12850454E-10_JPRB, 0.92199529E-11_JPRB, 0.67366902E-11_JPRB, 0.40078674E-11_JPRB, 0.24195843E-11_JPRB, 0.15519772E-11_JPRB, &
  & 0.98254597E-12_JPRB, 0.65472524E-12_JPRB, 0.50103481E-12_JPRB, 0.39093557E-12_JPRB /)

RGHG4(:,44,12) = (/ &
  & 0.29647218E-09_JPRB, 0.27215555E-09_JPRB, 0.25505781E-09_JPRB, 0.23987259E-09_JPRB, 0.22488651E-09_JPRB, 0.20975492E-09_JPRB, &
  & 0.19511269E-09_JPRB, 0.18023513E-09_JPRB, 0.16562271E-09_JPRB, 0.15429218E-09_JPRB, 0.14504861E-09_JPRB, 0.13685075E-09_JPRB, &
  & 0.12856523E-09_JPRB, 0.11868252E-09_JPRB, 0.10575633E-09_JPRB, 0.88359521E-10_JPRB, 0.68206385E-10_JPRB, 0.49094426E-10_JPRB, &
  & 0.34609770E-10_JPRB, 0.24781101E-10_JPRB, 0.18442827E-10_JPRB, 0.14268102E-10_JPRB, 0.11244373E-10_JPRB, 0.90893022E-11_JPRB, &
  & 0.74660113E-11_JPRB, 0.61357534E-11_JPRB, 0.51224311E-11_JPRB, 0.42775119E-11_JPRB, 0.35774391E-11_JPRB, 0.30246003E-11_JPRB, &
  & 0.26378689E-11_JPRB, 0.23528564E-11_JPRB, 0.22529344E-11_JPRB, 0.22451884E-11_JPRB, 0.23982010E-11_JPRB, 0.26408192E-11_JPRB, &
  & 0.30106490E-11_JPRB, 0.34877750E-11_JPRB, 0.41153591E-11_JPRB, 0.49285506E-11_JPRB, 0.60104829E-11_JPRB, 0.74568659E-11_JPRB, &
  & 0.94149671E-11_JPRB, 0.12005390E-10_JPRB, 0.15259016E-10_JPRB, 0.18918648E-10_JPRB, 0.22425497E-10_JPRB, 0.25187699E-10_JPRB, &
  & 0.26729702E-10_JPRB, 0.26871897E-10_JPRB, 0.25385997E-10_JPRB, 0.22611390E-10_JPRB, 0.18761433E-10_JPRB, 0.14860033E-10_JPRB, &
  & 0.11116107E-10_JPRB, 0.80824184E-11_JPRB, 0.61145910E-11_JPRB, 0.37646830E-11_JPRB, 0.23565965E-11_JPRB, 0.15136950E-11_JPRB, &
  & 0.10153207E-11_JPRB, 0.78460703E-12_JPRB, 0.56888289E-12_JPRB, 0.43636557E-12_JPRB /)

RGHG4(:,45,12) = (/ &
  & 0.24622793E-09_JPRB, 0.22425213E-09_JPRB, 0.20925194E-09_JPRB, 0.19590379E-09_JPRB, 0.18265299E-09_JPRB, 0.16921826E-09_JPRB, &
  & 0.15658529E-09_JPRB, 0.14398725E-09_JPRB, 0.13187622E-09_JPRB, 0.12279924E-09_JPRB, 0.11546421E-09_JPRB, 0.10897656E-09_JPRB, &
  & 0.10246753E-09_JPRB, 0.94718365E-10_JPRB, 0.84467155E-10_JPRB, 0.70418935E-10_JPRB, 0.53951971E-10_JPRB, 0.38777048E-10_JPRB, &
  & 0.27919294E-10_JPRB, 0.20673688E-10_JPRB, 0.15862301E-10_JPRB, 0.12611793E-10_JPRB, 0.10233620E-10_JPRB, 0.83467079E-11_JPRB, &
  & 0.69534773E-11_JPRB, 0.57551377E-11_JPRB, 0.48021717E-11_JPRB, 0.40235801E-11_JPRB, 0.33529219E-11_JPRB, 0.28599566E-11_JPRB, &
  & 0.24834176E-11_JPRB, 0.22383070E-11_JPRB, 0.21343470E-11_JPRB, 0.21323262E-11_JPRB, 0.22734585E-11_JPRB, 0.25016677E-11_JPRB, &
  & 0.28481230E-11_JPRB, 0.32861795E-11_JPRB, 0.38547386E-11_JPRB, 0.45727562E-11_JPRB, 0.55048448E-11_JPRB, 0.67226385E-11_JPRB, &
  & 0.83219924E-11_JPRB, 0.10363026E-10_JPRB, 0.12888033E-10_JPRB, 0.15752819E-10_JPRB, 0.18635348E-10_JPRB, 0.20977130E-10_JPRB, &
  & 0.22406013E-10_JPRB, 0.22679312E-10_JPRB, 0.21524371E-10_JPRB, 0.19243336E-10_JPRB, 0.16030264E-10_JPRB, 0.12780582E-10_JPRB, &
  & 0.97188967E-11_JPRB, 0.71727845E-11_JPRB, 0.56735463E-11_JPRB, 0.36071272E-11_JPRB, 0.23368915E-11_JPRB, 0.16132820E-11_JPRB, &
  & 0.11861215E-11_JPRB, 0.85180035E-12_JPRB, 0.68100647E-12_JPRB, 0.51449968E-12_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART24',0,ZHOOK_HANDLE)



RGHG4(:,46,12) = (/ &
  & 0.19936973E-09_JPRB, 0.17994088E-09_JPRB, 0.16686293E-09_JPRB, 0.15536553E-09_JPRB, 0.14380440E-09_JPRB, 0.13219657E-09_JPRB, &
  & 0.12144413E-09_JPRB, 0.11112455E-09_JPRB, 0.10139169E-09_JPRB, 0.94483220E-10_JPRB, 0.88891033E-10_JPRB, 0.84069356E-10_JPRB, &
  & 0.79165965E-10_JPRB, 0.73438429E-10_JPRB, 0.65493631E-10_JPRB, 0.54681294E-10_JPRB, 0.41925706E-10_JPRB, 0.30643738E-10_JPRB, &
  & 0.22637463E-10_JPRB, 0.17456750E-10_JPRB, 0.13891717E-10_JPRB, 0.11301069E-10_JPRB, 0.93871308E-11_JPRB, 0.77738788E-11_JPRB, &
  & 0.65010436E-11_JPRB, 0.54163449E-11_JPRB, 0.44941030E-11_JPRB, 0.37946126E-11_JPRB, 0.31156998E-11_JPRB, 0.27038491E-11_JPRB, &
  & 0.23308614E-11_JPRB, 0.21282672E-11_JPRB, 0.20261022E-11_JPRB, 0.20331098E-11_JPRB, 0.21665215E-11_JPRB, 0.23880767E-11_JPRB, &
  & 0.27164286E-11_JPRB, 0.31249228E-11_JPRB, 0.36430655E-11_JPRB, 0.42802060E-11_JPRB, 0.50852868E-11_JPRB, 0.60952450E-11_JPRB, &
  & 0.73720734E-11_JPRB, 0.89495269E-11_JPRB, 0.10860504E-10_JPRB, 0.13037769E-10_JPRB, 0.15274585E-10_JPRB, 0.17236632E-10_JPRB, &
  & 0.18506819E-10_JPRB, 0.18885830E-10_JPRB, 0.18105182E-10_JPRB, 0.16311875E-10_JPRB, 0.13748392E-10_JPRB, 0.11058315E-10_JPRB, &
  & 0.85363661E-11_JPRB, 0.64774046E-11_JPRB, 0.53975982E-11_JPRB, 0.35721246E-11_JPRB, 0.24292612E-11_JPRB, 0.17394027E-11_JPRB, &
  & 0.12743897E-11_JPRB, 0.10512417E-11_JPRB, 0.82583777E-12_JPRB, 0.63378599E-12_JPRB /)

RGHG4(:,47,12) = (/ &
  & 0.15747101E-09_JPRB, 0.14069686E-09_JPRB, 0.12970851E-09_JPRB, 0.12009679E-09_JPRB, 0.11044163E-09_JPRB, 0.10064836E-09_JPRB, &
  & 0.91840792E-10_JPRB, 0.83469183E-10_JPRB, 0.75773395E-10_JPRB, 0.70540199E-10_JPRB, 0.66440728E-10_JPRB, 0.62818424E-10_JPRB, &
  & 0.59345438E-10_JPRB, 0.55027677E-10_JPRB, 0.49424458E-10_JPRB, 0.41227088E-10_JPRB, 0.32061735E-10_JPRB, 0.24044837E-10_JPRB, &
  & 0.18505336E-10_JPRB, 0.14823354E-10_JPRB, 0.12255326E-10_JPRB, 0.10212259E-10_JPRB, 0.86313864E-11_JPRB, 0.72336308E-11_JPRB, &
  & 0.60860032E-11_JPRB, 0.50798901E-11_JPRB, 0.41942053E-11_JPRB, 0.35413864E-11_JPRB, 0.29029864E-11_JPRB, 0.25292362E-11_JPRB, &
  & 0.21941856E-11_JPRB, 0.20146146E-11_JPRB, 0.19287358E-11_JPRB, 0.19402626E-11_JPRB, 0.20721612E-11_JPRB, 0.22863707E-11_JPRB, &
  & 0.25996304E-11_JPRB, 0.29816908E-11_JPRB, 0.34561134E-11_JPRB, 0.40233316E-11_JPRB, 0.47144727E-11_JPRB, 0.55490629E-11_JPRB, &
  & 0.65574586E-11_JPRB, 0.77379483E-11_JPRB, 0.91027229E-11_JPRB, 0.10631236E-10_JPRB, 0.12295689E-10_JPRB, 0.13834288E-10_JPRB, &
  & 0.14954610E-10_JPRB, 0.15392776E-10_JPRB, 0.14849630E-10_JPRB, 0.13514744E-10_JPRB, 0.11458369E-10_JPRB, 0.94386035E-11_JPRB, &
  & 0.74685796E-11_JPRB, 0.58223283E-11_JPRB, 0.51683267E-11_JPRB, 0.35652739E-11_JPRB, 0.25200085E-11_JPRB, 0.18758428E-11_JPRB, &
  & 0.14824709E-11_JPRB, 0.12200014E-11_JPRB, 0.99692542E-12_JPRB, 0.79649828E-12_JPRB /)

RGHG4(:,48,12) = (/ &
  & 0.12130869E-09_JPRB, 0.10710058E-09_JPRB, 0.98163928E-10_JPRB, 0.90338952E-10_JPRB, 0.82439271E-10_JPRB, 0.74501065E-10_JPRB, &
  & 0.67359340E-10_JPRB, 0.60907127E-10_JPRB, 0.54792709E-10_JPRB, 0.51024483E-10_JPRB, 0.48021156E-10_JPRB, 0.45504378E-10_JPRB, &
  & 0.42970506E-10_JPRB, 0.40067307E-10_JPRB, 0.36062677E-10_JPRB, 0.30594163E-10_JPRB, 0.24353604E-10_JPRB, 0.19108048E-10_JPRB, &
  & 0.15410588E-10_JPRB, 0.12843372E-10_JPRB, 0.10958747E-10_JPRB, 0.93393687E-11_JPRB, 0.80132932E-11_JPRB, 0.67820571E-11_JPRB, &
  & 0.57027612E-11_JPRB, 0.47744647E-11_JPRB, 0.39229371E-11_JPRB, 0.32873272E-11_JPRB, 0.27093447E-11_JPRB, 0.23616467E-11_JPRB, &
  & 0.20742637E-11_JPRB, 0.19077832E-11_JPRB, 0.18480363E-11_JPRB, 0.18588306E-11_JPRB, 0.19966554E-11_JPRB, 0.22029397E-11_JPRB, &
  & 0.25063254E-11_JPRB, 0.28669443E-11_JPRB, 0.33060980E-11_JPRB, 0.38138078E-11_JPRB, 0.44099511E-11_JPRB, 0.50940393E-11_JPRB, &
  & 0.58741840E-11_JPRB, 0.67261756E-11_JPRB, 0.76471173E-11_JPRB, 0.86365940E-11_JPRB, 0.97217226E-11_JPRB, 0.10820105E-10_JPRB, &
  & 0.11706360E-10_JPRB, 0.12157997E-10_JPRB, 0.11898631E-10_JPRB, 0.10949027E-10_JPRB, 0.95043201E-11_JPRB, 0.79257954E-11_JPRB, &
  & 0.64359256E-11_JPRB, 0.51663248E-11_JPRB, 0.49080184E-11_JPRB, 0.35185624E-11_JPRB, 0.25723781E-11_JPRB, 0.20173474E-11_JPRB, &
  & 0.16242587E-11_JPRB, 0.13723234E-11_JPRB, 0.11687419E-11_JPRB, 0.98397592E-12_JPRB /)

RGHG4(:,49,12) = (/ &
  & 0.90883724E-10_JPRB, 0.79432731E-10_JPRB, 0.72253245E-10_JPRB, 0.66073709E-10_JPRB, 0.59705990E-10_JPRB, 0.53226829E-10_JPRB, &
  & 0.47508115E-10_JPRB, 0.42471100E-10_JPRB, 0.37626086E-10_JPRB, 0.34923703E-10_JPRB, 0.32857658E-10_JPRB, 0.31118743E-10_JPRB, &
  & 0.29497200E-10_JPRB, 0.27651083E-10_JPRB, 0.25294777E-10_JPRB, 0.22119287E-10_JPRB, 0.18459373E-10_JPRB, 0.15316599E-10_JPRB, &
  & 0.12998522E-10_JPRB, 0.11244845E-10_JPRB, 0.98853850E-11_JPRB, 0.85888813E-11_JPRB, 0.74583074E-11_JPRB, 0.63641666E-11_JPRB, &
  & 0.53472253E-11_JPRB, 0.44599758E-11_JPRB, 0.36591940E-11_JPRB, 0.30485892E-11_JPRB, 0.25308286E-11_JPRB, 0.22045313E-11_JPRB, &
  & 0.19719768E-11_JPRB, 0.18095974E-11_JPRB, 0.17821127E-11_JPRB, 0.17879062E-11_JPRB, 0.19345682E-11_JPRB, 0.21336268E-11_JPRB, &
  & 0.24283923E-11_JPRB, 0.27686278E-11_JPRB, 0.31761022E-11_JPRB, 0.36314131E-11_JPRB, 0.41451374E-11_JPRB, 0.47039954E-11_JPRB, &
  & 0.52986604E-11_JPRB, 0.58876146E-11_JPRB, 0.64449327E-11_JPRB, 0.69749874E-11_JPRB, 0.75397709E-11_JPRB, 0.81509643E-11_JPRB, &
  & 0.87231108E-11_JPRB, 0.90926242E-11_JPRB, 0.89772096E-11_JPRB, 0.83851823E-11_JPRB, 0.73906072E-11_JPRB, 0.63473610E-11_JPRB, &
  & 0.53243477E-11_JPRB, 0.44394952E-11_JPRB, 0.45619472E-11_JPRB, 0.34054244E-11_JPRB, 0.25825236E-11_JPRB, 0.20849754E-11_JPRB, &
  & 0.17216145E-11_JPRB, 0.15343368E-11_JPRB, 0.13120816E-11_JPRB, 0.11740251E-11_JPRB /)

RGHG4(:,50,12) = (/ &
  & 0.67218744E-10_JPRB, 0.57828086E-10_JPRB, 0.52307905E-10_JPRB, 0.47248108E-10_JPRB, 0.42018944E-10_JPRB, 0.36605215E-10_JPRB, &
  & 0.31939874E-10_JPRB, 0.28194017E-10_JPRB, 0.24297305E-10_JPRB, 0.22563919E-10_JPRB, 0.21279348E-10_JPRB, 0.20259707E-10_JPRB, &
  & 0.19401560E-10_JPRB, 0.18437123E-10_JPRB, 0.17437886E-10_JPRB, 0.15928377E-10_JPRB, 0.14202517E-10_JPRB, 0.12518181E-10_JPRB, &
  & 0.11166160E-10_JPRB, 0.99998534E-11_JPRB, 0.89953401E-11_JPRB, 0.79545823E-11_JPRB, 0.69733126E-11_JPRB, 0.59782040E-11_JPRB, &
  & 0.50254106E-11_JPRB, 0.41713204E-11_JPRB, 0.34107329E-11_JPRB, 0.28415590E-11_JPRB, 0.23808178E-11_JPRB, 0.20735165E-11_JPRB, &
  & 0.18901059E-11_JPRB, 0.17341963E-11_JPRB, 0.17326335E-11_JPRB, 0.17422948E-11_JPRB, 0.18900372E-11_JPRB, 0.20835150E-11_JPRB, &
  & 0.23669504E-11_JPRB, 0.26897313E-11_JPRB, 0.30692742E-11_JPRB, 0.34801283E-11_JPRB, 0.39249086E-11_JPRB, 0.43801291E-11_JPRB, &
  & 0.48221262E-11_JPRB, 0.52009686E-11_JPRB, 0.54852073E-11_JPRB, 0.56695642E-11_JPRB, 0.58286752E-11_JPRB, 0.60112154E-11_JPRB, &
  & 0.62194438E-11_JPRB, 0.63873963E-11_JPRB, 0.63269385E-11_JPRB, 0.60081380E-11_JPRB, 0.54437405E-11_JPRB, 0.48348487E-11_JPRB, &
  & 0.42034926E-11_JPRB, 0.36381592E-11_JPRB, 0.41285551E-11_JPRB, 0.31822700E-11_JPRB, 0.24833215E-11_JPRB, 0.20986548E-11_JPRB, &
  & 0.17956064E-11_JPRB, 0.16003921E-11_JPRB, 0.14237345E-11_JPRB, 0.13366819E-11_JPRB /)

RGHG4(:,51,12) = (/ &
  & 0.48581368E-10_JPRB, 0.41329797E-10_JPRB, 0.36735753E-10_JPRB, 0.32763004E-10_JPRB, 0.28261598E-10_JPRB, 0.23835718E-10_JPRB, &
  & 0.20204751E-10_JPRB, 0.17751559E-10_JPRB, 0.14882626E-10_JPRB, 0.13971001E-10_JPRB, 0.13353490E-10_JPRB, 0.12922643E-10_JPRB, &
  & 0.12593908E-10_JPRB, 0.12343988E-10_JPRB, 0.12088532E-10_JPRB, 0.11757405E-10_JPRB, 0.11166258E-10_JPRB, 0.10463768E-10_JPRB, &
  & 0.97480739E-11_JPRB, 0.90033883E-11_JPRB, 0.82650995E-11_JPRB, 0.74264189E-11_JPRB, 0.65439507E-11_JPRB, 0.56416022E-11_JPRB, &
  & 0.47459237E-11_JPRB, 0.39201476E-11_JPRB, 0.31991749E-11_JPRB, 0.26692750E-11_JPRB, 0.22657145E-11_JPRB, 0.19814591E-11_JPRB, &
  & 0.18308317E-11_JPRB, 0.16944677E-11_JPRB, 0.16956181E-11_JPRB, 0.17268490E-11_JPRB, 0.18656743E-11_JPRB, 0.20597289E-11_JPRB, &
  & 0.23308517E-11_JPRB, 0.26350220E-11_JPRB, 0.29889552E-11_JPRB, 0.33616163E-11_JPRB, 0.37475535E-11_JPRB, 0.41174100E-11_JPRB, &
  & 0.44365236E-11_JPRB, 0.46553438E-11_JPRB, 0.47322315E-11_JPRB, 0.46841511E-11_JPRB, 0.45689507E-11_JPRB, 0.44543865E-11_JPRB, &
  & 0.43734920E-11_JPRB, 0.43008817E-11_JPRB, 0.41573871E-11_JPRB, 0.39273125E-11_JPRB, 0.36304510E-11_JPRB, 0.33068678E-11_JPRB, &
  & 0.30025607E-11_JPRB, 0.27508035E-11_JPRB, 0.35199554E-11_JPRB, 0.28316472E-11_JPRB, 0.23195452E-11_JPRB, 0.20227487E-11_JPRB, &
  & 0.17402955E-11_JPRB, 0.16459053E-11_JPRB, 0.15016217E-11_JPRB, 0.14486021E-11_JPRB /)

RGHG4(:,52,12) = (/ &
  & 0.34962876E-10_JPRB, 0.28900269E-10_JPRB, 0.25526858E-10_JPRB, 0.22051101E-10_JPRB, 0.18560558E-10_JPRB, 0.15070879E-10_JPRB, &
  & 0.12787846E-10_JPRB, 0.11487284E-10_JPRB, 0.94614967E-11_JPRB, 0.90839645E-11_JPRB, 0.88705640E-11_JPRB, 0.87324566E-11_JPRB, &
  & 0.87069223E-11_JPRB, 0.87263313E-11_JPRB, 0.88510527E-11_JPRB, 0.89997940E-11_JPRB, 0.90479065E-11_JPRB, 0.89191267E-11_JPRB, &
  & 0.86284322E-11_JPRB, 0.81920443E-11_JPRB, 0.76355719E-11_JPRB, 0.69674691E-11_JPRB, 0.61858791E-11_JPRB, 0.53437458E-11_JPRB, &
  & 0.44973821E-11_JPRB, 0.37216627E-11_JPRB, 0.30433440E-11_JPRB, 0.25517984E-11_JPRB, 0.21946266E-11_JPRB, 0.19396195E-11_JPRB, &
  & 0.18077968E-11_JPRB, 0.17020293E-11_JPRB, 0.16932010E-11_JPRB, 0.17453080E-11_JPRB, 0.18769307E-11_JPRB, 0.20650406E-11_JPRB, &
  & 0.23192180E-11_JPRB, 0.26063732E-11_JPRB, 0.29371683E-11_JPRB, 0.32755005E-11_JPRB, 0.36093227E-11_JPRB, 0.39062659E-11_JPRB, &
  & 0.41234503E-11_JPRB, 0.42125392E-11_JPRB, 0.41462914E-11_JPRB, 0.39467301E-11_JPRB, 0.36881978E-11_JPRB, 0.34289496E-11_JPRB, &
  & 0.31970117E-11_JPRB, 0.29916091E-11_JPRB, 0.27762137E-11_JPRB, 0.25835074E-11_JPRB, 0.23885618E-11_JPRB, 0.22371042E-11_JPRB, &
  & 0.21079744E-11_JPRB, 0.20101377E-11_JPRB, 0.29410218E-11_JPRB, 0.24462478E-11_JPRB, 0.21022867E-11_JPRB, 0.18635755E-11_JPRB, &
  & 0.16827977E-11_JPRB, 0.16344415E-11_JPRB, 0.15039341E-11_JPRB, 0.14776254E-11_JPRB /)

RGHG4(:,53,12) = (/ &
  & 0.24850254E-10_JPRB, 0.20316051E-10_JPRB, 0.17294988E-10_JPRB, 0.14868988E-10_JPRB, 0.12082548E-10_JPRB, 0.99892187E-11_JPRB, &
  & 0.87406696E-11_JPRB, 0.81994359E-11_JPRB, 0.66986959E-11_JPRB, 0.65750803E-11_JPRB, 0.65162775E-11_JPRB, 0.65015705E-11_JPRB, &
  & 0.65637044E-11_JPRB, 0.66742662E-11_JPRB, 0.69264108E-11_JPRB, 0.72281417E-11_JPRB, 0.75805733E-11_JPRB, 0.77807509E-11_JPRB, &
  & 0.77681455E-11_JPRB, 0.75560955E-11_JPRB, 0.71397710E-11_JPRB, 0.66031547E-11_JPRB, 0.59038334E-11_JPRB, 0.51295752E-11_JPRB, &
  & 0.43344547E-11_JPRB, 0.36019699E-11_JPRB, 0.29481413E-11_JPRB, 0.24895175E-11_JPRB, 0.21694883E-11_JPRB, 0.19447660E-11_JPRB, &
  & 0.18240982E-11_JPRB, 0.17462272E-11_JPRB, 0.17365227E-11_JPRB, 0.17963568E-11_JPRB, 0.19260077E-11_JPRB, 0.21210904E-11_JPRB, &
  & 0.23488134E-11_JPRB, 0.26219497E-11_JPRB, 0.29273463E-11_JPRB, 0.32369404E-11_JPRB, 0.35238618E-11_JPRB, 0.37589112E-11_JPRB, &
  & 0.38911270E-11_JPRB, 0.38815453E-11_JPRB, 0.37144740E-11_JPRB, 0.34347414E-11_JPRB, 0.31147719E-11_JPRB, 0.28047198E-11_JPRB, &
  & 0.25309900E-11_JPRB, 0.22887059E-11_JPRB, 0.20719980E-11_JPRB, 0.18948239E-11_JPRB, 0.17574412E-11_JPRB, 0.16573394E-11_JPRB, &
  & 0.15912090E-11_JPRB, 0.15658959E-11_JPRB, 0.25187207E-11_JPRB, 0.22035524E-11_JPRB, 0.19529428E-11_JPRB, 0.17700060E-11_JPRB, &
  & 0.16581401E-11_JPRB, 0.16020395E-11_JPRB, 0.14894596E-11_JPRB, 0.14743174E-11_JPRB /)

RGHG4(:,54,12) = (/ &
  & 0.17748572E-10_JPRB, 0.14012373E-10_JPRB, 0.12057048E-10_JPRB, 0.10063971E-10_JPRB, 0.84269458E-11_JPRB, 0.72037896E-11_JPRB, &
  & 0.66745238E-11_JPRB, 0.64870084E-11_JPRB, 0.52559866E-11_JPRB, 0.52291899E-11_JPRB, 0.52306128E-11_JPRB, 0.52485737E-11_JPRB, &
  & 0.53187819E-11_JPRB, 0.54551359E-11_JPRB, 0.56763214E-11_JPRB, 0.60597209E-11_JPRB, 0.64947288E-11_JPRB, 0.68951260E-11_JPRB, &
  & 0.70898253E-11_JPRB, 0.70442927E-11_JPRB, 0.67498307E-11_JPRB, 0.63055507E-11_JPRB, 0.56936630E-11_JPRB, 0.49658845E-11_JPRB, &
  & 0.42312100E-11_JPRB, 0.35430875E-11_JPRB, 0.29388226E-11_JPRB, 0.25128870E-11_JPRB, 0.22230690E-11_JPRB, 0.20247786E-11_JPRB, &
  & 0.19112073E-11_JPRB, 0.18506381E-11_JPRB, 0.18485450E-11_JPRB, 0.19154645E-11_JPRB, 0.20335740E-11_JPRB, 0.22259200E-11_JPRB, &
  & 0.24290121E-11_JPRB, 0.26925352E-11_JPRB, 0.29747517E-11_JPRB, 0.32588066E-11_JPRB, 0.34989852E-11_JPRB, 0.36767160E-11_JPRB, &
  & 0.37316834E-11_JPRB, 0.36388553E-11_JPRB, 0.34009549E-11_JPRB, 0.30798755E-11_JPRB, 0.27410385E-11_JPRB, 0.24301045E-11_JPRB, &
  & 0.21600692E-11_JPRB, 0.19285702E-11_JPRB, 0.17285707E-11_JPRB, 0.15861582E-11_JPRB, 0.14775958E-11_JPRB, 0.14173968E-11_JPRB, &
  & 0.13899128E-11_JPRB, 0.13972001E-11_JPRB, 0.23795824E-11_JPRB, 0.21036155E-11_JPRB, 0.19044521E-11_JPRB, 0.17622569E-11_JPRB, &
  & 0.16741046E-11_JPRB, 0.16095942E-11_JPRB, 0.15363466E-11_JPRB, 0.15165444E-11_JPRB /)

RGHG4(:,55,12) = (/ &
  & 0.12865455E-10_JPRB, 0.10089843E-10_JPRB, 0.84854346E-11_JPRB, 0.73330586E-11_JPRB, 0.63060676E-11_JPRB, 0.57392971E-11_JPRB, &
  & 0.55420894E-11_JPRB, 0.55076473E-11_JPRB, 0.44608857E-11_JPRB, 0.44631404E-11_JPRB, 0.44831248E-11_JPRB, 0.45116389E-11_JPRB, &
  & 0.45814862E-11_JPRB, 0.46892668E-11_JPRB, 0.49134134E-11_JPRB, 0.52277666E-11_JPRB, 0.57261817E-11_JPRB, 0.62331884E-11_JPRB, &
  & 0.65736665E-11_JPRB, 0.66509736E-11_JPRB, 0.64539433E-11_JPRB, 0.60936299E-11_JPRB, 0.55435274E-11_JPRB, 0.48767943E-11_JPRB, &
  & 0.41822622E-11_JPRB, 0.35358840E-11_JPRB, 0.29680147E-11_JPRB, 0.25738665E-11_JPRB, 0.23103360E-11_JPRB, 0.21372697E-11_JPRB, &
  & 0.20346784E-11_JPRB, 0.19884342E-11_JPRB, 0.19988529E-11_JPRB, 0.20780942E-11_JPRB, 0.22071227E-11_JPRB, 0.23900213E-11_JPRB, &
  & 0.25921602E-11_JPRB, 0.28313463E-11_JPRB, 0.30994601E-11_JPRB, 0.33576338E-11_JPRB, 0.35523054E-11_JPRB, 0.36780704E-11_JPRB, &
  & 0.36631345E-11_JPRB, 0.35013758E-11_JPRB, 0.32162159E-11_JPRB, 0.28731013E-11_JPRB, 0.25392728E-11_JPRB, 0.22379160E-11_JPRB, &
  & 0.19845659E-11_JPRB, 0.17676510E-11_JPRB, 0.15925747E-11_JPRB, 0.14682908E-11_JPRB, 0.13843309E-11_JPRB, 0.13423984E-11_JPRB, &
  & 0.13268665E-11_JPRB, 0.13501441E-11_JPRB, 0.22977529E-11_JPRB, 0.20947384E-11_JPRB, 0.19461661E-11_JPRB, 0.18149571E-11_JPRB, &
  & 0.17324952E-11_JPRB, 0.16650220E-11_JPRB, 0.16151005E-11_JPRB, 0.15737329E-11_JPRB /)

RGHG4(:,56,12) = (/ &
  & 0.94240935E-11_JPRB, 0.74184079E-11_JPRB, 0.64122891E-11_JPRB, 0.56531208E-11_JPRB, 0.51257132E-11_JPRB, 0.48771716E-11_JPRB, &
  & 0.48497942E-11_JPRB, 0.48831017E-11_JPRB, 0.39607141E-11_JPRB, 0.39847492E-11_JPRB, 0.40028016E-11_JPRB, 0.40305558E-11_JPRB, &
  & 0.40808654E-11_JPRB, 0.41854979E-11_JPRB, 0.43548125E-11_JPRB, 0.46764602E-11_JPRB, 0.51315480E-11_JPRB, 0.57225349E-11_JPRB, &
  & 0.61727394E-11_JPRB, 0.63700174E-11_JPRB, 0.62421826E-11_JPRB, 0.59361331E-11_JPRB, 0.54284854E-11_JPRB, 0.48213915E-11_JPRB, &
  & 0.41773677E-11_JPRB, 0.35707121E-11_JPRB, 0.30460723E-11_JPRB, 0.26805513E-11_JPRB, 0.24420301E-11_JPRB, 0.22909621E-11_JPRB, &
  & 0.22020877E-11_JPRB, 0.21694586E-11_JPRB, 0.21938436E-11_JPRB, 0.22841150E-11_JPRB, 0.24309803E-11_JPRB, 0.26120655E-11_JPRB, &
  & 0.28185947E-11_JPRB, 0.30492471E-11_JPRB, 0.33136790E-11_JPRB, 0.35496616E-11_JPRB, 0.37045918E-11_JPRB, 0.37835052E-11_JPRB, &
  & 0.36986113E-11_JPRB, 0.34736454E-11_JPRB, 0.31437158E-11_JPRB, 0.27882713E-11_JPRB, 0.24542159E-11_JPRB, 0.21671716E-11_JPRB, &
  & 0.19258631E-11_JPRB, 0.17260108E-11_JPRB, 0.15627728E-11_JPRB, 0.14583835E-11_JPRB, 0.13892330E-11_JPRB, 0.13604817E-11_JPRB, &
  & 0.13602119E-11_JPRB, 0.13963321E-11_JPRB, 0.23746137E-11_JPRB, 0.21908096E-11_JPRB, 0.20307846E-11_JPRB, 0.18993310E-11_JPRB, &
  & 0.18220666E-11_JPRB, 0.17598588E-11_JPRB, 0.17159772E-11_JPRB, 0.16503510E-11_JPRB /)

RGHG4(:,57,12) = (/ &
  & 0.73070369E-11_JPRB, 0.57412829E-11_JPRB, 0.51412368E-11_JPRB, 0.46935368E-11_JPRB, 0.44341592E-11_JPRB, 0.43516302E-11_JPRB, &
  & 0.43999570E-11_JPRB, 0.44551251E-11_JPRB, 0.36299249E-11_JPRB, 0.36616296E-11_JPRB, 0.36842135E-11_JPRB, 0.37120897E-11_JPRB, &
  & 0.37578868E-11_JPRB, 0.38416384E-11_JPRB, 0.40014385E-11_JPRB, 0.42603586E-11_JPRB, 0.47227651E-11_JPRB, 0.53373647E-11_JPRB, &
  & 0.58798140E-11_JPRB, 0.61391677E-11_JPRB, 0.60581943E-11_JPRB, 0.58022432E-11_JPRB, 0.53579116E-11_JPRB, 0.48003047E-11_JPRB, &
  & 0.41990725E-11_JPRB, 0.36325363E-11_JPRB, 0.31488436E-11_JPRB, 0.28150158E-11_JPRB, 0.26011626E-11_JPRB, 0.24713408E-11_JPRB, &
  & 0.24000120E-11_JPRB, 0.23822888E-11_JPRB, 0.24210623E-11_JPRB, 0.25238544E-11_JPRB, 0.26852648E-11_JPRB, 0.28818779E-11_JPRB, &
  & 0.31058431E-11_JPRB, 0.33509055E-11_JPRB, 0.36167761E-11_JPRB, 0.38421974E-11_JPRB, 0.39605940E-11_JPRB, 0.40019381E-11_JPRB, &
  & 0.38592849E-11_JPRB, 0.35743392E-11_JPRB, 0.32043426E-11_JPRB, 0.28314074E-11_JPRB, 0.25011881E-11_JPRB, 0.22144328E-11_JPRB, &
  & 0.19832476E-11_JPRB, 0.17849786E-11_JPRB, 0.16341750E-11_JPRB, 0.15375126E-11_JPRB, 0.14764543E-11_JPRB, 0.14563972E-11_JPRB, &
  & 0.14593757E-11_JPRB, 0.15016563E-11_JPRB, 0.24678063E-11_JPRB, 0.22914181E-11_JPRB, 0.21511467E-11_JPRB, 0.20339422E-11_JPRB, &
  & 0.19535968E-11_JPRB, 0.18807852E-11_JPRB, 0.18318047E-11_JPRB, 0.17501509E-11_JPRB /)

RGHG4(:,58,12) = (/ &
  & 0.57330312E-11_JPRB, 0.47842156E-11_JPRB, 0.43557141E-11_JPRB, 0.41283678E-11_JPRB, 0.40027881E-11_JPRB, 0.40093475E-11_JPRB, &
  & 0.40772559E-11_JPRB, 0.41515233E-11_JPRB, 0.34234204E-11_JPRB, 0.34537115E-11_JPRB, 0.34709744E-11_JPRB, 0.34966856E-11_JPRB, &
  & 0.35360911E-11_JPRB, 0.36164418E-11_JPRB, 0.37505437E-11_JPRB, 0.40115016E-11_JPRB, 0.44320281E-11_JPRB, 0.50813533E-11_JPRB, &
  & 0.56573721E-11_JPRB, 0.59490689E-11_JPRB, 0.59195170E-11_JPRB, 0.57087468E-11_JPRB, 0.53075903E-11_JPRB, 0.47996572E-11_JPRB, &
  & 0.42462466E-11_JPRB, 0.37226797E-11_JPRB, 0.32836275E-11_JPRB, 0.29822332E-11_JPRB, 0.27945088E-11_JPRB, 0.26876793E-11_JPRB, &
  & 0.26358624E-11_JPRB, 0.26337120E-11_JPRB, 0.26870546E-11_JPRB, 0.28021348E-11_JPRB, 0.29761703E-11_JPRB, 0.31902107E-11_JPRB, &
  & 0.34248004E-11_JPRB, 0.36851312E-11_JPRB, 0.39566080E-11_JPRB, 0.41848356E-11_JPRB, 0.43176192E-11_JPRB, 0.43458557E-11_JPRB, &
  & 0.41525884E-11_JPRB, 0.38206808E-11_JPRB, 0.34083728E-11_JPRB, 0.30156064E-11_JPRB, 0.26711680E-11_JPRB, 0.23830783E-11_JPRB, &
  & 0.21442297E-11_JPRB, 0.19462446E-11_JPRB, 0.17911747E-11_JPRB, 0.16963639E-11_JPRB, 0.16396814E-11_JPRB, 0.16200498E-11_JPRB, &
  & 0.16256910E-11_JPRB, 0.16688965E-11_JPRB, 0.26675851E-11_JPRB, 0.24976488E-11_JPRB, 0.23448363E-11_JPRB, 0.22004917E-11_JPRB, &
  & 0.21027782E-11_JPRB, 0.20290822E-11_JPRB, 0.19734364E-11_JPRB, 0.18728166E-11_JPRB /)

RGHG4(:,59,12) = (/ &
  & 0.48080893E-11_JPRB, 0.41009075E-11_JPRB, 0.39265514E-11_JPRB, 0.37909467E-11_JPRB, 0.37489113E-11_JPRB, 0.37852612E-11_JPRB, &
  & 0.38616358E-11_JPRB, 0.39234345E-11_JPRB, 0.32829963E-11_JPRB, 0.33220165E-11_JPRB, 0.33462439E-11_JPRB, 0.33736161E-11_JPRB, &
  & 0.34165316E-11_JPRB, 0.34879595E-11_JPRB, 0.36247500E-11_JPRB, 0.38568545E-11_JPRB, 0.42860806E-11_JPRB, 0.49106426E-11_JPRB, &
  & 0.54851813E-11_JPRB, 0.57948321E-11_JPRB, 0.58078867E-11_JPRB, 0.56360021E-11_JPRB, 0.52815595E-11_JPRB, 0.48229597E-11_JPRB, &
  & 0.43150036E-11_JPRB, 0.38346739E-11_JPRB, 0.34409123E-11_JPRB, 0.31753170E-11_JPRB, 0.30155776E-11_JPRB, 0.29345176E-11_JPRB, &
  & 0.29036337E-11_JPRB, 0.29179131E-11_JPRB, 0.29847726E-11_JPRB, 0.31121752E-11_JPRB, 0.32985101E-11_JPRB, 0.35297475E-11_JPRB, &
  & 0.37902168E-11_JPRB, 0.40698846E-11_JPRB, 0.43506088E-11_JPRB, 0.45866371E-11_JPRB, 0.47189232E-11_JPRB, 0.47472161E-11_JPRB, &
  & 0.45720502E-11_JPRB, 0.42193072E-11_JPRB, 0.37791051E-11_JPRB, 0.33664367E-11_JPRB, 0.30090023E-11_JPRB, 0.26983949E-11_JPRB, &
  & 0.24518861E-11_JPRB, 0.22303175E-11_JPRB, 0.20636301E-11_JPRB, 0.19610537E-11_JPRB, 0.18937664E-11_JPRB, 0.18717183E-11_JPRB, &
  & 0.18675250E-11_JPRB, 0.19072703E-11_JPRB, 0.29201448E-11_JPRB, 0.27298170E-11_JPRB, 0.25533228E-11_JPRB, 0.24035873E-11_JPRB, &
  & 0.23033142E-11_JPRB, 0.22098827E-11_JPRB, 0.21381753E-11_JPRB, 0.20194584E-11_JPRB /)

RGHG4(:,60,12) = (/ &
  & 0.40337078E-11_JPRB, 0.37625012E-11_JPRB, 0.36694319E-11_JPRB, 0.36181611E-11_JPRB, 0.36179052E-11_JPRB, 0.36632490E-11_JPRB, &
  & 0.37378126E-11_JPRB, 0.38076400E-11_JPRB, 0.32389660E-11_JPRB, 0.32740332E-11_JPRB, 0.32999072E-11_JPRB, 0.33292533E-11_JPRB, &
  & 0.33744396E-11_JPRB, 0.34507844E-11_JPRB, 0.35800141E-11_JPRB, 0.38228891E-11_JPRB, 0.42336885E-11_JPRB, 0.48327405E-11_JPRB, &
  & 0.53707845E-11_JPRB, 0.56826245E-11_JPRB, 0.57312610E-11_JPRB, 0.55908000E-11_JPRB, 0.52803673E-11_JPRB, 0.48671228E-11_JPRB, &
  & 0.44083760E-11_JPRB, 0.39787449E-11_JPRB, 0.36335271E-11_JPRB, 0.34079610E-11_JPRB, 0.32807168E-11_JPRB, 0.32275719E-11_JPRB, &
  & 0.32188859E-11_JPRB, 0.32499123E-11_JPRB, 0.33283118E-11_JPRB, 0.34648152E-11_JPRB, 0.36604600E-11_JPRB, 0.39058856E-11_JPRB, &
  & 0.41842567E-11_JPRB, 0.44817054E-11_JPRB, 0.47803532E-11_JPRB, 0.50306074E-11_JPRB, 0.51865331E-11_JPRB, 0.52285550E-11_JPRB, &
  & 0.50662833E-11_JPRB, 0.47579315E-11_JPRB, 0.43274746E-11_JPRB, 0.39132139E-11_JPRB, 0.35369353E-11_JPRB, 0.32073101E-11_JPRB, &
  & 0.29277030E-11_JPRB, 0.26736107E-11_JPRB, 0.24732356E-11_JPRB, 0.23496977E-11_JPRB, 0.22689864E-11_JPRB, 0.22226364E-11_JPRB, &
  & 0.22039538E-11_JPRB, 0.22266976E-11_JPRB, 0.32776976E-11_JPRB, 0.30525825E-11_JPRB, 0.28502389E-11_JPRB, 0.26647133E-11_JPRB, &
  & 0.25246962E-11_JPRB, 0.24146032E-11_JPRB, 0.23303629E-11_JPRB, 0.21867198E-11_JPRB /)

RGHG4(:,61,12) = (/ &
  & 0.36748100E-11_JPRB, 0.36027346E-11_JPRB, 0.35959842E-11_JPRB, 0.35697532E-11_JPRB, 0.35809652E-11_JPRB, 0.36302595E-11_JPRB, &
  & 0.36960955E-11_JPRB, 0.37565428E-11_JPRB, 0.32562447E-11_JPRB, 0.32973533E-11_JPRB, 0.33295589E-11_JPRB, 0.33675623E-11_JPRB, &
  & 0.34186159E-11_JPRB, 0.34993219E-11_JPRB, 0.36373374E-11_JPRB, 0.38709929E-11_JPRB, 0.42705956E-11_JPRB, 0.48127986E-11_JPRB, &
  & 0.53028849E-11_JPRB, 0.56078098E-11_JPRB, 0.56822719E-11_JPRB, 0.55740568E-11_JPRB, 0.53076528E-11_JPRB, 0.49408914E-11_JPRB, &
  & 0.45348460E-11_JPRB, 0.41575810E-11_JPRB, 0.38668916E-11_JPRB, 0.36862739E-11_JPRB, 0.35970346E-11_JPRB, 0.35749678E-11_JPRB, &
  & 0.35905226E-11_JPRB, 0.36382360E-11_JPRB, 0.37271054E-11_JPRB, 0.38698623E-11_JPRB, 0.40717204E-11_JPRB, 0.43269598E-11_JPRB, &
  & 0.46242290E-11_JPRB, 0.49400657E-11_JPRB, 0.52542831E-11_JPRB, 0.55221478E-11_JPRB, 0.56994218E-11_JPRB, 0.57661584E-11_JPRB, &
  & 0.56490442E-11_JPRB, 0.53914724E-11_JPRB, 0.50353146E-11_JPRB, 0.46716706E-11_JPRB, 0.43109700E-11_JPRB, 0.39576185E-11_JPRB, &
  & 0.36619553E-11_JPRB, 0.33395418E-11_JPRB, 0.30863556E-11_JPRB, 0.29157846E-11_JPRB, 0.27789010E-11_JPRB, 0.27110105E-11_JPRB, &
  & 0.26565469E-11_JPRB, 0.26541651E-11_JPRB, 0.37149012E-11_JPRB, 0.34392717E-11_JPRB, 0.31754887E-11_JPRB, 0.29473759E-11_JPRB, &
  & 0.27858839E-11_JPRB, 0.26515402E-11_JPRB, 0.25440260E-11_JPRB, 0.23727808E-11_JPRB /)

RGHG4(:,62,12) = (/ &
  & 0.37069471E-11_JPRB, 0.36347982E-11_JPRB, 0.36322421E-11_JPRB, 0.36213270E-11_JPRB, 0.36454060E-11_JPRB, 0.36947841E-11_JPRB, &
  & 0.37618892E-11_JPRB, 0.38259257E-11_JPRB, 0.33661923E-11_JPRB, 0.34038768E-11_JPRB, 0.34360490E-11_JPRB, 0.34778194E-11_JPRB, &
  & 0.35354844E-11_JPRB, 0.36220996E-11_JPRB, 0.37603692E-11_JPRB, 0.39910800E-11_JPRB, 0.43639554E-11_JPRB, 0.48474258E-11_JPRB, &
  & 0.52890964E-11_JPRB, 0.55835935E-11_JPRB, 0.56773778E-11_JPRB, 0.55981404E-11_JPRB, 0.53715817E-11_JPRB, 0.50536120E-11_JPRB, &
  & 0.47051378E-11_JPRB, 0.43885772E-11_JPRB, 0.41571798E-11_JPRB, 0.40299461E-11_JPRB, 0.39842873E-11_JPRB, 0.39974538E-11_JPRB, &
  & 0.40397386E-11_JPRB, 0.41052938E-11_JPRB, 0.42016564E-11_JPRB, 0.43461693E-11_JPRB, 0.45474562E-11_JPRB, 0.48072687E-11_JPRB, &
  & 0.51152966E-11_JPRB, 0.54461934E-11_JPRB, 0.57805787E-11_JPRB, 0.60699865E-11_JPRB, 0.62798399E-11_JPRB, 0.63839541E-11_JPRB, &
  & 0.63194979E-11_JPRB, 0.61444495E-11_JPRB, 0.58785845E-11_JPRB, 0.56250365E-11_JPRB, 0.53366981E-11_JPRB, 0.49960101E-11_JPRB, &
  & 0.46706007E-11_JPRB, 0.42861695E-11_JPRB, 0.39360351E-11_JPRB, 0.37054630E-11_JPRB, 0.35194723E-11_JPRB, 0.33955083E-11_JPRB, &
  & 0.32684001E-11_JPRB, 0.31958076E-11_JPRB, 0.42786638E-11_JPRB, 0.39014399E-11_JPRB, 0.35669091E-11_JPRB, 0.32766127E-11_JPRB, &
  & 0.30615894E-11_JPRB, 0.28952494E-11_JPRB, 0.27646895E-11_JPRB, 0.25600381E-11_JPRB /)

RGHG4(:,63,12) = (/ &
  & 0.37258898E-11_JPRB, 0.37372692E-11_JPRB, 0.37696508E-11_JPRB, 0.37667139E-11_JPRB, 0.37906249E-11_JPRB, 0.38449717E-11_JPRB, &
  & 0.39115443E-11_JPRB, 0.39698470E-11_JPRB, 0.35443128E-11_JPRB, 0.35791359E-11_JPRB, 0.36136242E-11_JPRB, 0.36596342E-11_JPRB, &
  & 0.37260095E-11_JPRB, 0.38151956E-11_JPRB, 0.39536733E-11_JPRB, 0.41693276E-11_JPRB, 0.45058146E-11_JPRB, 0.49275193E-11_JPRB, &
  & 0.53244700E-11_JPRB, 0.56042948E-11_JPRB, 0.57136184E-11_JPRB, 0.56671065E-11_JPRB, 0.54842650E-11_JPRB, 0.52219232E-11_JPRB, &
  & 0.49376922E-11_JPRB, 0.46884050E-11_JPRB, 0.45265619E-11_JPRB, 0.44574257E-11_JPRB, 0.44618215E-11_JPRB, 0.45147263E-11_JPRB, &
  & 0.45870573E-11_JPRB, 0.46710947E-11_JPRB, 0.47738202E-11_JPRB, 0.49155862E-11_JPRB, 0.51105162E-11_JPRB, 0.53656589E-11_JPRB, &
  & 0.56791681E-11_JPRB, 0.60219334E-11_JPRB, 0.63708153E-11_JPRB, 0.66846858E-11_JPRB, 0.69294193E-11_JPRB, 0.70811876E-11_JPRB, &
  & 0.70875866E-11_JPRB, 0.70079524E-11_JPRB, 0.68652414E-11_JPRB, 0.67469832E-11_JPRB, 0.65967019E-11_JPRB, 0.63544495E-11_JPRB, &
  & 0.60547348E-11_JPRB, 0.55970194E-11_JPRB, 0.51576811E-11_JPRB, 0.48145641E-11_JPRB, 0.45126997E-11_JPRB, 0.42763909E-11_JPRB, &
  & 0.40470028E-11_JPRB, 0.39012257E-11_JPRB, 0.49362133E-11_JPRB, 0.44287751E-11_JPRB, 0.39807788E-11_JPRB, 0.36043492E-11_JPRB, &
  & 0.33370964E-11_JPRB, 0.31352464E-11_JPRB, 0.29797807E-11_JPRB, 0.27409867E-11_JPRB /)

RGHG4(:,64,12) = (/ &
  & 0.39223100E-11_JPRB, 0.39627537E-11_JPRB, 0.39982345E-11_JPRB, 0.40033354E-11_JPRB, 0.40343848E-11_JPRB, 0.40961288E-11_JPRB, &
  & 0.41663144E-11_JPRB, 0.42274183E-11_JPRB, 0.38051233E-11_JPRB, 0.38253493E-11_JPRB, 0.38535785E-11_JPRB, 0.39018294E-11_JPRB, &
  & 0.39708237E-11_JPRB, 0.40636630E-11_JPRB, 0.41980560E-11_JPRB, 0.43971185E-11_JPRB, 0.46970609E-11_JPRB, 0.50679309E-11_JPRB, &
  & 0.54267740E-11_JPRB, 0.56932206E-11_JPRB, 0.58146513E-11_JPRB, 0.57994768E-11_JPRB, 0.56651788E-11_JPRB, 0.54637540E-11_JPRB, &
  & 0.52526004E-11_JPRB, 0.50798766E-11_JPRB, 0.49928911E-11_JPRB, 0.49906221E-11_JPRB, 0.50514033E-11_JPRB, 0.51495106E-11_JPRB, &
  & 0.52560738E-11_JPRB, 0.53612553E-11_JPRB, 0.54680973E-11_JPRB, 0.56019746E-11_JPRB, 0.57841045E-11_JPRB, 0.60312354E-11_JPRB, &
  & 0.63421417E-11_JPRB, 0.66869548E-11_JPRB, 0.70483775E-11_JPRB, 0.73864309E-11_JPRB, 0.76703279E-11_JPRB, 0.78802780E-11_JPRB, &
  & 0.79678234E-11_JPRB, 0.80039005E-11_JPRB, 0.79989826E-11_JPRB, 0.80436517E-11_JPRB, 0.80500441E-11_JPRB, 0.79391615E-11_JPRB, &
  & 0.77282798E-11_JPRB, 0.72735832E-11_JPRB, 0.67673536E-11_JPRB, 0.63178022E-11_JPRB, 0.58803865E-11_JPRB, 0.55030455E-11_JPRB, &
  & 0.51294585E-11_JPRB, 0.47616633E-11_JPRB, 0.57080798E-11_JPRB, 0.49954090E-11_JPRB, 0.44062054E-11_JPRB, 0.39169796E-11_JPRB, &
  & 0.35792693E-11_JPRB, 0.33409094E-11_JPRB, 0.31637470E-11_JPRB, 0.29117804E-11_JPRB /)

RGHG4(:,65,12) = (/ &
  & 0.41722476E-11_JPRB, 0.42593641E-11_JPRB, 0.43182138E-11_JPRB, 0.43272031E-11_JPRB, 0.43603723E-11_JPRB, 0.44256356E-11_JPRB, &
  & 0.45018941E-11_JPRB, 0.45552828E-11_JPRB, 0.41229038E-11_JPRB, 0.41290686E-11_JPRB, 0.41579335E-11_JPRB, 0.42131997E-11_JPRB, &
  & 0.42937767E-11_JPRB, 0.43865289E-11_JPRB, 0.45151031E-11_JPRB, 0.46927540E-11_JPRB, 0.49558708E-11_JPRB, 0.52815178E-11_JPRB, &
  & 0.56050815E-11_JPRB, 0.58610274E-11_JPRB, 0.59984266E-11_JPRB, 0.60186470E-11_JPRB, 0.59385951E-11_JPRB, 0.58077562E-11_JPRB, &
  & 0.56757711E-11_JPRB, 0.55922489E-11_JPRB, 0.55855177E-11_JPRB, 0.56512872E-11_JPRB, 0.57721610E-11_JPRB, 0.59197374E-11_JPRB, &
  & 0.60651479E-11_JPRB, 0.61952110E-11_JPRB, 0.63081085E-11_JPRB, 0.64342190E-11_JPRB, 0.66016866E-11_JPRB, 0.68298214E-11_JPRB, &
  & 0.71309239E-11_JPRB, 0.74756520E-11_JPRB, 0.78426207E-11_JPRB, 0.82006164E-11_JPRB, 0.85249290E-11_JPRB, 0.87989590E-11_JPRB, &
  & 0.89791386E-11_JPRB, 0.91406084E-11_JPRB, 0.92930342E-11_JPRB, 0.95081772E-11_JPRB, 0.97023318E-11_JPRB, 0.97637341E-11_JPRB, &
  & 0.96847192E-11_JPRB, 0.93197550E-11_JPRB, 0.88187227E-11_JPRB, 0.82892261E-11_JPRB, 0.76900986E-11_JPRB, 0.70935167E-11_JPRB, &
  & 0.64231402E-11_JPRB, 0.58235413E-11_JPRB, 0.65466768E-11_JPRB, 0.55738686E-11_JPRB, 0.47935982E-11_JPRB, 0.41752764E-11_JPRB, &
  & 0.37647520E-11_JPRB, 0.35002845E-11_JPRB, 0.33120928E-11_JPRB, 0.30577951E-11_JPRB /)

RGHG4(:,66,12) = (/ &
  & 0.45161752E-11_JPRB, 0.46514494E-11_JPRB, 0.47218384E-11_JPRB, 0.47385988E-11_JPRB, 0.47736034E-11_JPRB, 0.48481067E-11_JPRB, &
  & 0.49246406E-11_JPRB, 0.49704013E-11_JPRB, 0.45115777E-11_JPRB, 0.45001767E-11_JPRB, 0.45282359E-11_JPRB, 0.45907362E-11_JPRB, &
  & 0.46742814E-11_JPRB, 0.47710672E-11_JPRB, 0.48972671E-11_JPRB, 0.50630199E-11_JPRB, 0.52980155E-11_JPRB, 0.55901139E-11_JPRB, &
  & 0.58880019E-11_JPRB, 0.61379677E-11_JPRB, 0.62918338E-11_JPRB, 0.63517364E-11_JPRB, 0.63322464E-11_JPRB, 0.62777986E-11_JPRB, &
  & 0.62327036E-11_JPRB, 0.62357888E-11_JPRB, 0.63112892E-11_JPRB, 0.64539359E-11_JPRB, 0.66387547E-11_JPRB, 0.68393759E-11_JPRB, &
  & 0.70272841E-11_JPRB, 0.71838746E-11_JPRB, 0.73038953E-11_JPRB, 0.74237422E-11_JPRB, 0.75763874E-11_JPRB, 0.77973860E-11_JPRB, &
  & 0.80872401E-11_JPRB, 0.84209020E-11_JPRB, 0.87878047E-11_JPRB, 0.91626255E-11_JPRB, 0.95271985E-11_JPRB, 0.98709079E-11_JPRB, &
  & 0.10150384E-10_JPRB, 0.10448333E-10_JPRB, 0.10764055E-10_JPRB, 0.11169801E-10_JPRB, 0.11539989E-10_JPRB, 0.11771621E-10_JPRB, &
  & 0.11840526E-10_JPRB, 0.11613711E-10_JPRB, 0.11227240E-10_JPRB, 0.10685729E-10_JPRB, 0.99889012E-11_JPRB, 0.91566711E-11_JPRB, &
  & 0.81957765E-11_JPRB, 0.71102729E-11_JPRB, 0.74404337E-11_JPRB, 0.61296862E-11_JPRB, 0.51563289E-11_JPRB, 0.43886964E-11_JPRB, &
  & 0.39044484E-11_JPRB, 0.36478017E-11_JPRB, 0.34647552E-11_JPRB, 0.31859469E-11_JPRB /)

RGHG4(:,67,12) = (/ &
  & 0.49287878E-11_JPRB, 0.51189712E-11_JPRB, 0.52124190E-11_JPRB, 0.52294319E-11_JPRB, 0.52654005E-11_JPRB, 0.53407201E-11_JPRB, &
  & 0.54178415E-11_JPRB, 0.54503832E-11_JPRB, 0.49614974E-11_JPRB, 0.49401884E-11_JPRB, 0.49794743E-11_JPRB, 0.50590370E-11_JPRB, &
  & 0.51588243E-11_JPRB, 0.52599093E-11_JPRB, 0.53863884E-11_JPRB, 0.55385518E-11_JPRB, 0.57497978E-11_JPRB, 0.60150465E-11_JPRB, &
  & 0.62942563E-11_JPRB, 0.65445583E-11_JPRB, 0.67233901E-11_JPRB, 0.68284462E-11_JPRB, 0.68744398E-11_JPRB, 0.69021728E-11_JPRB, &
  & 0.69464426E-11_JPRB, 0.70444622E-11_JPRB, 0.72038018E-11_JPRB, 0.74192302E-11_JPRB, 0.76686062E-11_JPRB, 0.79246566E-11_JPRB, &
  & 0.81586517E-11_JPRB, 0.83455074E-11_JPRB, 0.84790100E-11_JPRB, 0.86013080E-11_JPRB, 0.87486095E-11_JPRB, 0.89543780E-11_JPRB, &
  & 0.92325895E-11_JPRB, 0.95608799E-11_JPRB, 0.99260530E-11_JPRB, 0.10313864E-10_JPRB, 0.10718471E-10_JPRB, 0.11134763E-10_JPRB, &
  & 0.11517311E-10_JPRB, 0.11953867E-10_JPRB, 0.12436241E-10_JPRB, 0.13021330E-10_JPRB, 0.13595008E-10_JPRB, 0.14020133E-10_JPRB, &
  & 0.14246204E-10_JPRB, 0.14182299E-10_JPRB, 0.13927358E-10_JPRB, 0.13459834E-10_JPRB, 0.12745037E-10_JPRB, 0.11715316E-10_JPRB, &
  & 0.10333930E-10_JPRB, 0.86816873E-11_JPRB, 0.83133266E-11_JPRB, 0.67299326E-11_JPRB, 0.55573597E-11_JPRB, 0.46303807E-11_JPRB, &
  & 0.40741941E-11_JPRB, 0.38910264E-11_JPRB, 0.37351641E-11_JPRB, 0.33859172E-11_JPRB /)

RGHG4(:,68,12) = (/ &
  & 0.54239087E-11_JPRB, 0.56739500E-11_JPRB, 0.57803259E-11_JPRB, 0.58013087E-11_JPRB, 0.58359615E-11_JPRB, 0.59147470E-11_JPRB, &
  & 0.59922184E-11_JPRB, 0.60135672E-11_JPRB, 0.54954188E-11_JPRB, 0.54691212E-11_JPRB, 0.55223664E-11_JPRB, 0.56114176E-11_JPRB, &
  & 0.57246716E-11_JPRB, 0.58380479E-11_JPRB, 0.59715301E-11_JPRB, 0.61263971E-11_JPRB, 0.63291720E-11_JPRB, 0.65803660E-11_JPRB, &
  & 0.68528295E-11_JPRB, 0.71124859E-11_JPRB, 0.73183369E-11_JPRB, 0.74727663E-11_JPRB, 0.75876814E-11_JPRB, 0.77000940E-11_JPRB, &
  & 0.78344857E-11_JPRB, 0.80188616E-11_JPRB, 0.82650059E-11_JPRB, 0.85619003E-11_JPRB, 0.88807121E-11_JPRB, 0.91971101E-11_JPRB, &
  & 0.94813055E-11_JPRB, 0.97027282E-11_JPRB, 0.98520176E-11_JPRB, 0.99747988E-11_JPRB, 0.10116707E-10_JPRB, 0.10333982E-10_JPRB, &
  & 0.10609407E-10_JPRB, 0.10927693E-10_JPRB, 0.11292228E-10_JPRB, 0.11693885E-10_JPRB, 0.12138735E-10_JPRB, 0.12629195E-10_JPRB, &
  & 0.13118455E-10_JPRB, 0.13693327E-10_JPRB, 0.14342304E-10_JPRB, 0.15117513E-10_JPRB, 0.15867103E-10_JPRB, 0.16470596E-10_JPRB, &
  & 0.16846736E-10_JPRB, 0.16948817E-10_JPRB, 0.16879895E-10_JPRB, 0.16509473E-10_JPRB, 0.15863290E-10_JPRB, 0.14691868E-10_JPRB, &
  & 0.13043025E-10_JPRB, 0.10615250E-10_JPRB, 0.92412302E-11_JPRB, 0.75091417E-11_JPRB, 0.61901643E-11_JPRB, 0.50556018E-11_JPRB, &
  & 0.44058385E-11_JPRB, 0.44096129E-11_JPRB, 0.42935356E-11_JPRB, 0.37772125E-11_JPRB /)

RGHG4(:,69,12) = (/ &
  & 0.59832616E-11_JPRB, 0.63006588E-11_JPRB, 0.64342962E-11_JPRB, 0.64514110E-11_JPRB, 0.64835498E-11_JPRB, 0.65675573E-11_JPRB, &
  & 0.66462478E-11_JPRB, 0.66629202E-11_JPRB, 0.61205090E-11_JPRB, 0.61045145E-11_JPRB, 0.61843117E-11_JPRB, 0.62987944E-11_JPRB, &
  & 0.64406766E-11_JPRB, 0.65673877E-11_JPRB, 0.67114031E-11_JPRB, 0.68637864E-11_JPRB, 0.70635637E-11_JPRB, 0.73089113E-11_JPRB, &
  & 0.75840332E-11_JPRB, 0.78601743E-11_JPRB, 0.81025195E-11_JPRB, 0.83110576E-11_JPRB, 0.84973946E-11_JPRB, 0.86971185E-11_JPRB, &
  & 0.89240802E-11_JPRB, 0.92108109E-11_JPRB, 0.95430009E-11_JPRB, 0.99154634E-11_JPRB, 0.10304491E-10_JPRB, 0.10684866E-10_JPRB, &
  & 0.11024957E-10_JPRB, 0.11288723E-10_JPRB, 0.11464334E-10_JPRB, 0.11601576E-10_JPRB, 0.11753806E-10_JPRB, 0.11958877E-10_JPRB, &
  & 0.12237161E-10_JPRB, 0.12561895E-10_JPRB, 0.12929441E-10_JPRB, 0.13347192E-10_JPRB, 0.13835393E-10_JPRB, 0.14402963E-10_JPRB, &
  & 0.14999051E-10_JPRB, 0.15712530E-10_JPRB, 0.16518547E-10_JPRB, 0.17460243E-10_JPRB, 0.18405012E-10_JPRB, 0.19208741E-10_JPRB, &
  & 0.19760166E-10_JPRB, 0.19987526E-10_JPRB, 0.20172640E-10_JPRB, 0.19773294E-10_JPRB, 0.19300429E-10_JPRB, 0.18072134E-10_JPRB, &
  & 0.16172546E-10_JPRB, 0.12955849E-10_JPRB, 0.10418864E-10_JPRB, 0.87381257E-11_JPRB, 0.73119974E-11_JPRB, 0.58783564E-11_JPRB, &
  & 0.50794573E-11_JPRB, 0.53944557E-11_JPRB, 0.53032383E-11_JPRB, 0.44738245E-11_JPRB /)

RGHG4(:,70,12) = (/ &
  & 0.66202022E-11_JPRB, 0.70202316E-11_JPRB, 0.71738969E-11_JPRB, 0.71929246E-11_JPRB, 0.72262027E-11_JPRB, 0.73171252E-11_JPRB, &
  & 0.74041129E-11_JPRB, 0.74239738E-11_JPRB, 0.68698693E-11_JPRB, 0.68761537E-11_JPRB, 0.69820755E-11_JPRB, 0.71116750E-11_JPRB, &
  & 0.72750673E-11_JPRB, 0.74288527E-11_JPRB, 0.75893025E-11_JPRB, 0.77649987E-11_JPRB, 0.79746409E-11_JPRB, 0.82269434E-11_JPRB, &
  & 0.85135232E-11_JPRB, 0.88154839E-11_JPRB, 0.90977408E-11_JPRB, 0.93650383E-11_JPRB, 0.96270509E-11_JPRB, 0.99149551E-11_JPRB, &
  & 0.10230579E-10_JPRB, 0.10599677E-10_JPRB, 0.11025162E-10_JPRB, 0.11488443E-10_JPRB, 0.11956994E-10_JPRB, 0.12409339E-10_JPRB, &
  & 0.12811689E-10_JPRB, 0.13122023E-10_JPRB, 0.13323981E-10_JPRB, 0.13478945E-10_JPRB, 0.13644911E-10_JPRB, 0.13887772E-10_JPRB, &
  & 0.14178469E-10_JPRB, 0.14502506E-10_JPRB, 0.14877363E-10_JPRB, 0.15315074E-10_JPRB, 0.15852470E-10_JPRB, 0.16497550E-10_JPRB, &
  & 0.17207045E-10_JPRB, 0.18054596E-10_JPRB, 0.19019541E-10_JPRB, 0.20132028E-10_JPRB, 0.21238650E-10_JPRB, 0.22187804E-10_JPRB, &
  & 0.22904140E-10_JPRB, 0.23259610E-10_JPRB, 0.23723148E-10_JPRB, 0.23270309E-10_JPRB, 0.23147550E-10_JPRB, 0.21605514E-10_JPRB, &
  & 0.19915561E-10_JPRB, 0.15722385E-10_JPRB, 0.12278701E-10_JPRB, 0.10681006E-10_JPRB, 0.91221032E-11_JPRB, 0.72995360E-11_JPRB, &
  & 0.63422076E-11_JPRB, 0.70233389E-11_JPRB, 0.69080848E-11_JPRB, 0.55916595E-11_JPRB /)

RGHG4(:,71,12) = (/ &
  & 0.73251639E-11_JPRB, 0.78259656E-11_JPRB, 0.80146627E-11_JPRB, 0.80325217E-11_JPRB, 0.80680931E-11_JPRB, 0.81733613E-11_JPRB, &
  & 0.82737385E-11_JPRB, 0.83112189E-11_JPRB, 0.77644748E-11_JPRB, 0.78087259E-11_JPRB, 0.79559623E-11_JPRB, 0.81257249E-11_JPRB, &
  & 0.83182775E-11_JPRB, 0.84976852E-11_JPRB, 0.86778510E-11_JPRB, 0.88655376E-11_JPRB, 0.90863367E-11_JPRB, 0.93526393E-11_JPRB, &
  & 0.96617055E-11_JPRB, 0.99983008E-11_JPRB, 0.10330506E-10_JPRB, 0.10663493E-10_JPRB, 0.11004323E-10_JPRB, 0.11386688E-10_JPRB, &
  & 0.11805151E-10_JPRB, 0.12287083E-10_JPRB, 0.12802447E-10_JPRB, 0.13348087E-10_JPRB, 0.13896178E-10_JPRB, 0.14424815E-10_JPRB, &
  & 0.14898431E-10_JPRB, 0.15269671E-10_JPRB, 0.15517082E-10_JPRB, 0.15711850E-10_JPRB, 0.15906944E-10_JPRB, 0.16142816E-10_JPRB, &
  & 0.16452393E-10_JPRB, 0.16797445E-10_JPRB, 0.17184452E-10_JPRB, 0.17646154E-10_JPRB, 0.18236850E-10_JPRB, 0.18965517E-10_JPRB, &
  & 0.19784773E-10_JPRB, 0.20769674E-10_JPRB, 0.21872587E-10_JPRB, 0.23129818E-10_JPRB, 0.24408630E-10_JPRB, 0.25508354E-10_JPRB, &
  & 0.26396361E-10_JPRB, 0.26932278E-10_JPRB, 0.27573558E-10_JPRB, 0.27098251E-10_JPRB, 0.27262480E-10_JPRB, 0.25487218E-10_JPRB, &
  & 0.24009208E-10_JPRB, 0.19076423E-10_JPRB, 0.15288139E-10_JPRB, 0.13570331E-10_JPRB, 0.11788522E-10_JPRB, 0.96130933E-11_JPRB, &
  & 0.84969618E-11_JPRB, 0.94649462E-11_JPRB, 0.93120789E-11_JPRB, 0.73501916E-11_JPRB /)

RGHG4(:,72,12) = (/ &
  & 0.81321417E-11_JPRB, 0.87484594E-11_JPRB, 0.89710427E-11_JPRB, 0.89920961E-11_JPRB, 0.90369396E-11_JPRB, 0.91583971E-11_JPRB, &
  & 0.92847206E-11_JPRB, 0.93557462E-11_JPRB, 0.88373406E-11_JPRB, 0.89358148E-11_JPRB, 0.91056390E-11_JPRB, 0.93093961E-11_JPRB, &
  & 0.95257691E-11_JPRB, 0.97390550E-11_JPRB, 0.99504042E-11_JPRB, 0.10177255E-10_JPRB, 0.10426361E-10_JPRB, 0.10718990E-10_JPRB, &
  & 0.11060671E-10_JPRB, 0.11442383E-10_JPRB, 0.11833241E-10_JPRB, 0.12237570E-10_JPRB, 0.12664654E-10_JPRB, 0.13143862E-10_JPRB, &
  & 0.13653705E-10_JPRB, 0.14214367E-10_JPRB, 0.14834287E-10_JPRB, 0.15486168E-10_JPRB, 0.16129232E-10_JPRB, 0.16746118E-10_JPRB, &
  & 0.17298303E-10_JPRB, 0.17735516E-10_JPRB, 0.18029848E-10_JPRB, 0.18271390E-10_JPRB, 0.18498019E-10_JPRB, 0.18812819E-10_JPRB, &
  & 0.19148289E-10_JPRB, 0.19497478E-10_JPRB, 0.19905523E-10_JPRB, 0.20392965E-10_JPRB, 0.21042928E-10_JPRB, 0.21854546E-10_JPRB, &
  & 0.22785017E-10_JPRB, 0.23894007E-10_JPRB, 0.25137083E-10_JPRB, 0.26541659E-10_JPRB, 0.27940938E-10_JPRB, 0.29145408E-10_JPRB, &
  & 0.30195117E-10_JPRB, 0.30880055E-10_JPRB, 0.31622347E-10_JPRB, 0.31298724E-10_JPRB, 0.31645259E-10_JPRB, 0.29798528E-10_JPRB, &
  & 0.28517274E-10_JPRB, 0.23124396E-10_JPRB, 0.19641556E-10_JPRB, 0.17598985E-10_JPRB, 0.15620815E-10_JPRB, 0.13026645E-10_JPRB, &
  & 0.11845174E-10_JPRB, 0.12976522E-10_JPRB, 0.12762474E-10_JPRB, 0.10051399E-10_JPRB /)

RGHG4(:,73,12) = (/ &
  & 0.90691673E-11_JPRB, 0.98006282E-11_JPRB, 0.10060056E-10_JPRB, 0.10081058E-10_JPRB, 0.10132944E-10_JPRB, 0.10280898E-10_JPRB, &
  & 0.10442799E-10_JPRB, 0.10570424E-10_JPRB, 0.10086835E-10_JPRB, 0.10239801E-10_JPRB, 0.10478706E-10_JPRB, 0.10721255E-10_JPRB, &
  & 0.10985279E-10_JPRB, 0.11233329E-10_JPRB, 0.11479625E-10_JPRB, 0.11727137E-10_JPRB, 0.12005730E-10_JPRB, 0.12334754E-10_JPRB, &
  & 0.12721161E-10_JPRB, 0.13160208E-10_JPRB, 0.13622169E-10_JPRB, 0.14112530E-10_JPRB, 0.14632955E-10_JPRB, 0.15217124E-10_JPRB, &
  & 0.15852627E-10_JPRB, 0.16545256E-10_JPRB, 0.17268825E-10_JPRB, 0.18014923E-10_JPRB, 0.18750859E-10_JPRB, 0.19460820E-10_JPRB, &
  & 0.20105230E-10_JPRB, 0.20627774E-10_JPRB, 0.21001919E-10_JPRB, 0.21306875E-10_JPRB, 0.21581117E-10_JPRB, 0.21899257E-10_JPRB, &
  & 0.22263635E-10_JPRB, 0.22642698E-10_JPRB, 0.23075732E-10_JPRB, 0.23593441E-10_JPRB, 0.24298735E-10_JPRB, 0.25187803E-10_JPRB, &
  & 0.26221081E-10_JPRB, 0.27437086E-10_JPRB, 0.28792782E-10_JPRB, 0.30296637E-10_JPRB, 0.31819186E-10_JPRB, 0.33141483E-10_JPRB, &
  & 0.34328471E-10_JPRB, 0.35194323E-10_JPRB, 0.35991678E-10_JPRB, 0.35821911E-10_JPRB, 0.36217918E-10_JPRB, 0.34573292E-10_JPRB, &
  & 0.33250132E-10_JPRB, 0.28174095E-10_JPRB, 0.25187468E-10_JPRB, 0.22940814E-10_JPRB, 0.20753748E-10_JPRB, 0.17897572E-10_JPRB, &
  & 0.16618281E-10_JPRB, 0.17782194E-10_JPRB, 0.17468846E-10_JPRB, 0.13907020E-10_JPRB /)

RGHG4(:,74,12) = (/ &
  & 0.10185720E-10_JPRB, 0.11008569E-10_JPRB, 0.11290375E-10_JPRB, 0.11312628E-10_JPRB, 0.11379075E-10_JPRB, 0.11557662E-10_JPRB, &
  & 0.11773814E-10_JPRB, 0.11972647E-10_JPRB, 0.11522682E-10_JPRB, 0.11761468E-10_JPRB, 0.12014679E-10_JPRB, 0.12323639E-10_JPRB, &
  & 0.12617447E-10_JPRB, 0.12919050E-10_JPRB, 0.13217827E-10_JPRB, 0.13529321E-10_JPRB, 0.13856407E-10_JPRB, 0.14241622E-10_JPRB, &
  & 0.14683537E-10_JPRB, 0.15194332E-10_JPRB, 0.15740968E-10_JPRB, 0.16326936E-10_JPRB, 0.16955701E-10_JPRB, 0.17644965E-10_JPRB, &
  & 0.18366886E-10_JPRB, 0.19145713E-10_JPRB, 0.19979619E-10_JPRB, 0.20846668E-10_JPRB, 0.21699999E-10_JPRB, 0.22520130E-10_JPRB, &
  & 0.23262657E-10_JPRB, 0.23871098E-10_JPRB, 0.24329993E-10_JPRB, 0.24718196E-10_JPRB, 0.25074796E-10_JPRB, 0.25498461E-10_JPRB, &
  & 0.25910255E-10_JPRB, 0.26294317E-10_JPRB, 0.26757855E-10_JPRB, 0.27309677E-10_JPRB, 0.28064110E-10_JPRB, 0.29026484E-10_JPRB, &
  & 0.30136456E-10_JPRB, 0.31445919E-10_JPRB, 0.32884140E-10_JPRB, 0.34490206E-10_JPRB, 0.36071261E-10_JPRB, 0.37470128E-10_JPRB, &
  & 0.38729856E-10_JPRB, 0.39675402E-10_JPRB, 0.40608333E-10_JPRB, 0.40648530E-10_JPRB, 0.41232139E-10_JPRB, 0.39740475E-10_JPRB, &
  & 0.38659118E-10_JPRB, 0.33682463E-10_JPRB, 0.31972876E-10_JPRB, 0.29515834E-10_JPRB, 0.27383045E-10_JPRB, 0.24294334E-10_JPRB, &
  & 0.22982302E-10_JPRB, 0.24104446E-10_JPRB, 0.23613356E-10_JPRB, 0.19069520E-10_JPRB /)

RGHG4(:,75,12) = (/ &
  & 0.11425949E-10_JPRB, 0.12350969E-10_JPRB, 0.12673231E-10_JPRB, 0.12699311E-10_JPRB, 0.12780904E-10_JPRB, 0.13003462E-10_JPRB, &
  & 0.13285090E-10_JPRB, 0.13567831E-10_JPRB, 0.13173889E-10_JPRB, 0.13465559E-10_JPRB, 0.13844936E-10_JPRB, 0.14190916E-10_JPRB, &
  & 0.14576956E-10_JPRB, 0.14929408E-10_JPRB, 0.15280232E-10_JPRB, 0.15630835E-10_JPRB, 0.16013118E-10_JPRB, 0.16457492E-10_JPRB, &
  & 0.16972526E-10_JPRB, 0.17568001E-10_JPRB, 0.18216694E-10_JPRB, 0.18916898E-10_JPRB, 0.19669964E-10_JPRB, 0.20475718E-10_JPRB, &
  & 0.21361801E-10_JPRB, 0.22301683E-10_JPRB, 0.23272224E-10_JPRB, 0.24254574E-10_JPRB, 0.25217503E-10_JPRB, 0.26147084E-10_JPRB, &
  & 0.27007259E-10_JPRB, 0.27740662E-10_JPRB, 0.28325016E-10_JPRB, 0.28778127E-10_JPRB, 0.29191136E-10_JPRB, 0.29627453E-10_JPRB, &
  & 0.30066758E-10_JPRB, 0.30492903E-10_JPRB, 0.30984222E-10_JPRB, 0.31579125E-10_JPRB, 0.32383856E-10_JPRB, 0.33398288E-10_JPRB, &
  & 0.34576959E-10_JPRB, 0.35938853E-10_JPRB, 0.37442847E-10_JPRB, 0.39075299E-10_JPRB, 0.40724087E-10_JPRB, 0.42165483E-10_JPRB, &
  & 0.43518716E-10_JPRB, 0.44581953E-10_JPRB, 0.45678877E-10_JPRB, 0.45786566E-10_JPRB, 0.46554417E-10_JPRB, 0.45362596E-10_JPRB, &
  & 0.44522934E-10_JPRB, 0.40158727E-10_JPRB, 0.39577897E-10_JPRB, 0.37449200E-10_JPRB, 0.35487422E-10_JPRB, 0.32349304E-10_JPRB, &
  & 0.31065050E-10_JPRB, 0.32104115E-10_JPRB, 0.31364765E-10_JPRB, 0.25720438E-10_JPRB /)

RGHG4(:,76,12) = (/ &
  & 0.12823229E-10_JPRB, 0.13854949E-10_JPRB, 0.14203150E-10_JPRB, 0.14239681E-10_JPRB, 0.14342255E-10_JPRB, 0.14613621E-10_JPRB, &
  & 0.14973224E-10_JPRB, 0.15355500E-10_JPRB, 0.15000431E-10_JPRB, 0.15412274E-10_JPRB, 0.15792333E-10_JPRB, 0.16252302E-10_JPRB, &
  & 0.16666814E-10_JPRB, 0.17116844E-10_JPRB, 0.17552388E-10_JPRB, 0.18008943E-10_JPRB, 0.18477372E-10_JPRB, 0.19003512E-10_JPRB, &
  & 0.19606938E-10_JPRB, 0.20307884E-10_JPRB, 0.21073263E-10_JPRB, 0.21904409E-10_JPRB, 0.22796055E-10_JPRB, 0.23720493E-10_JPRB, &
  & 0.24683892E-10_JPRB, 0.25688285E-10_JPRB, 0.26752947E-10_JPRB, 0.27849785E-10_JPRB, 0.28931982E-10_JPRB, 0.29980411E-10_JPRB, &
  & 0.30960800E-10_JPRB, 0.31811255E-10_JPRB, 0.32519584E-10_JPRB, 0.33146885E-10_JPRB, 0.33766916E-10_JPRB, 0.34312497E-10_JPRB, &
  & 0.34819005E-10_JPRB, 0.35261155E-10_JPRB, 0.35784976E-10_JPRB, 0.36424690E-10_JPRB, 0.37271280E-10_JPRB, 0.38328785E-10_JPRB, &
  & 0.39530816E-10_JPRB, 0.40928112E-10_JPRB, 0.42444180E-10_JPRB, 0.44102427E-10_JPRB, 0.45731093E-10_JPRB, 0.47162319E-10_JPRB, &
  & 0.48485830E-10_JPRB, 0.49568589E-10_JPRB, 0.50827707E-10_JPRB, 0.51082982E-10_JPRB, 0.52207905E-10_JPRB, 0.51203628E-10_JPRB, &
  & 0.51025503E-10_JPRB, 0.47015461E-10_JPRB, 0.48279002E-10_JPRB, 0.46689715E-10_JPRB, 0.45071030E-10_JPRB, 0.42127454E-10_JPRB, &
  & 0.40952318E-10_JPRB, 0.41880326E-10_JPRB, 0.40787613E-10_JPRB, 0.33997166E-10_JPRB /)

RGHG4(:,77,12) = (/ &
  & 0.14377001E-10_JPRB, 0.15488541E-10_JPRB, 0.15864945E-10_JPRB, 0.15915956E-10_JPRB, 0.16039382E-10_JPRB, 0.16368060E-10_JPRB, &
  & 0.16812222E-10_JPRB, 0.17291333E-10_JPRB, 0.17011770E-10_JPRB, 0.17464977E-10_JPRB, 0.17998165E-10_JPRB, 0.18483961E-10_JPRB, &
  & 0.19041381E-10_JPRB, 0.19565599E-10_JPRB, 0.20098498E-10_JPRB, 0.20629873E-10_JPRB, 0.21196935E-10_JPRB, 0.21831847E-10_JPRB, &
  & 0.22551717E-10_JPRB, 0.23375682E-10_JPRB, 0.24281972E-10_JPRB, 0.25251991E-10_JPRB, 0.26287004E-10_JPRB, 0.27340397E-10_JPRB, &
  & 0.28487337E-10_JPRB, 0.29700804E-10_JPRB, 0.30948581E-10_JPRB, 0.32197231E-10_JPRB, 0.33421200E-10_JPRB, 0.34601141E-10_JPRB, &
  & 0.35712620E-10_JPRB, 0.36715995E-10_JPRB, 0.37591447E-10_JPRB, 0.38299735E-10_JPRB, 0.38873932E-10_JPRB, 0.39451015E-10_JPRB, &
  & 0.40030847E-10_JPRB, 0.40530593E-10_JPRB, 0.41094798E-10_JPRB, 0.41788899E-10_JPRB, 0.42674600E-10_JPRB, 0.43747322E-10_JPRB, &
  & 0.44948198E-10_JPRB, 0.46324035E-10_JPRB, 0.47796676E-10_JPRB, 0.49394749E-10_JPRB, 0.50982430E-10_JPRB, 0.52363239E-10_JPRB, &
  & 0.53710082E-10_JPRB, 0.54821914E-10_JPRB, 0.56148589E-10_JPRB, 0.56556822E-10_JPRB, 0.57807519E-10_JPRB, 0.57109074E-10_JPRB, &
  & 0.57621661E-10_JPRB, 0.54384448E-10_JPRB, 0.58172283E-10_JPRB, 0.57139942E-10_JPRB, 0.56007116E-10_JPRB, 0.53418235E-10_JPRB, &
  & 0.52513827E-10_JPRB, 0.53180328E-10_JPRB, 0.51721679E-10_JPRB, 0.43953206E-10_JPRB /)

RGHG4(:,78,12) = (/ &
  & 0.16075943E-10_JPRB, 0.17173101E-10_JPRB, 0.17531959E-10_JPRB, 0.17591938E-10_JPRB, 0.17736748E-10_JPRB, 0.18115552E-10_JPRB, &
  & 0.18645585E-10_JPRB, 0.19219026E-10_JPRB, 0.18985044E-10_JPRB, 0.19517256E-10_JPRB, 0.20037619E-10_JPRB, 0.20616077E-10_JPRB, &
  & 0.21203305E-10_JPRB, 0.21855264E-10_JPRB, 0.22520283E-10_JPRB, 0.23214430E-10_JPRB, 0.23928913E-10_JPRB, 0.24702891E-10_JPRB, &
  & 0.25563249E-10_JPRB, 0.26530490E-10_JPRB, 0.27576835E-10_JPRB, 0.28685738E-10_JPRB, 0.29834416E-10_JPRB, 0.31001597E-10_JPRB, &
  & 0.32184148E-10_JPRB, 0.33386991E-10_JPRB, 0.34635232E-10_JPRB, 0.35901036E-10_JPRB, 0.37161555E-10_JPRB, 0.38399953E-10_JPRB, &
  & 0.39604632E-10_JPRB, 0.40753508E-10_JPRB, 0.41816068E-10_JPRB, 0.42801467E-10_JPRB, 0.43797691E-10_JPRB, 0.44609143E-10_JPRB, &
  & 0.45294983E-10_JPRB, 0.45900474E-10_JPRB, 0.46556644E-10_JPRB, 0.47317431E-10_JPRB, 0.48239315E-10_JPRB, 0.49303089E-10_JPRB, &
  & 0.50440631E-10_JPRB, 0.51726373E-10_JPRB, 0.53097554E-10_JPRB, 0.54564193E-10_JPRB, 0.56021729E-10_JPRB, 0.57283536E-10_JPRB, &
  & 0.58516740E-10_JPRB, 0.59567143E-10_JPRB, 0.60852046E-10_JPRB, 0.61508805E-10_JPRB, 0.62901559E-10_JPRB, 0.62572003E-10_JPRB, &
  & 0.63597953E-10_JPRB, 0.61524313E-10_JPRB, 0.68190072E-10_JPRB, 0.67668857E-10_JPRB, 0.67055701E-10_JPRB, 0.65178946E-10_JPRB, &
  & 0.64651742E-10_JPRB, 0.65082495E-10_JPRB, 0.63467356E-10_JPRB, 0.55443657E-10_JPRB /)

RGHG4(:,79,12) = (/ &
  & 0.17667994E-10_JPRB, 0.18443502E-10_JPRB, 0.18691788E-10_JPRB, 0.18716447E-10_JPRB, 0.18850812E-10_JPRB, 0.19248395E-10_JPRB, &
  & 0.19803723E-10_JPRB, 0.20419390E-10_JPRB, 0.20198806E-10_JPRB, 0.20726235E-10_JPRB, 0.21271934E-10_JPRB, 0.21857575E-10_JPRB, &
  & 0.22510121E-10_JPRB, 0.23211631E-10_JPRB, 0.23955409E-10_JPRB, 0.24744887E-10_JPRB, 0.25612243E-10_JPRB, 0.26551893E-10_JPRB, &
  & 0.27556063E-10_JPRB, 0.28628312E-10_JPRB, 0.29749168E-10_JPRB, 0.30886169E-10_JPRB, 0.31998234E-10_JPRB, 0.33119400E-10_JPRB, &
  & 0.34275905E-10_JPRB, 0.35503381E-10_JPRB, 0.36763096E-10_JPRB, 0.38035793E-10_JPRB, 0.39311967E-10_JPRB, 0.40577659E-10_JPRB, &
  & 0.41828652E-10_JPRB, 0.43049918E-10_JPRB, 0.44232017E-10_JPRB, 0.45365919E-10_JPRB, 0.46408235E-10_JPRB, 0.47419180E-10_JPRB, &
  & 0.48534024E-10_JPRB, 0.49520069E-10_JPRB, 0.50469278E-10_JPRB, 0.51410619E-10_JPRB, 0.52409424E-10_JPRB, 0.53439309E-10_JPRB, &
  & 0.54444005E-10_JPRB, 0.55541120E-10_JPRB, 0.56657890E-10_JPRB, 0.57889905E-10_JPRB, 0.59099045E-10_JPRB, 0.60155859E-10_JPRB, &
  & 0.61271654E-10_JPRB, 0.62264513E-10_JPRB, 0.63489679E-10_JPRB, 0.64254782E-10_JPRB, 0.65556643E-10_JPRB, 0.65671371E-10_JPRB, &
  & 0.66842878E-10_JPRB, 0.65852955E-10_JPRB, 0.74349228E-10_JPRB, 0.74217070E-10_JPRB, 0.74246928E-10_JPRB, 0.73161220E-10_JPRB, &
  & 0.73060620E-10_JPRB, 0.73663395E-10_JPRB, 0.72936324E-10_JPRB, 0.67497966E-10_JPRB /)

RGHG4(:,80,12) = (/ &
  & 0.18569063E-10_JPRB, 0.19000268E-10_JPRB, 0.19188316E-10_JPRB, 0.19193700E-10_JPRB, 0.19326757E-10_JPRB, 0.19737463E-10_JPRB, &
  & 0.20333518E-10_JPRB, 0.20966480E-10_JPRB, 0.20856546E-10_JPRB, 0.21397420E-10_JPRB, 0.21976141E-10_JPRB, 0.22570777E-10_JPRB, &
  & 0.23234881E-10_JPRB, 0.23966627E-10_JPRB, 0.24751822E-10_JPRB, 0.25585620E-10_JPRB, 0.26462227E-10_JPRB, 0.27413181E-10_JPRB, &
  & 0.28439398E-10_JPRB, 0.29550140E-10_JPRB, 0.30707697E-10_JPRB, 0.31902730E-10_JPRB, 0.33077544E-10_JPRB, 0.34262208E-10_JPRB, &
  & 0.35453255E-10_JPRB, 0.36642162E-10_JPRB, 0.37883849E-10_JPRB, 0.39155606E-10_JPRB, 0.40440540E-10_JPRB, 0.41723919E-10_JPRB, &
  & 0.42997137E-10_JPRB, 0.44252688E-10_JPRB, 0.45484252E-10_JPRB, 0.46698943E-10_JPRB, 0.47916286E-10_JPRB, 0.49072336E-10_JPRB, &
  & 0.50090293E-10_JPRB, 0.51027859E-10_JPRB, 0.52015059E-10_JPRB, 0.53013330E-10_JPRB, 0.54031231E-10_JPRB, 0.55062201E-10_JPRB, &
  & 0.56021625E-10_JPRB, 0.57071681E-10_JPRB, 0.58158946E-10_JPRB, 0.59356423E-10_JPRB, 0.60581581E-10_JPRB, 0.61639541E-10_JPRB, &
  & 0.62740729E-10_JPRB, 0.63714520E-10_JPRB, 0.64925232E-10_JPRB, 0.65745749E-10_JPRB, 0.67071217E-10_JPRB, 0.67268337E-10_JPRB, &
  & 0.68326012E-10_JPRB, 0.67492234E-10_JPRB, 0.76367621E-10_JPRB, 0.76225685E-10_JPRB, 0.76280038E-10_JPRB, 0.75440446E-10_JPRB, &
  & 0.75376205E-10_JPRB, 0.76342356E-10_JPRB, 0.76285901E-10_JPRB, 0.74254290E-10_JPRB /)

RGHG4(:,81,12) = (/ &
  & 0.19287089E-10_JPRB, 0.19422202E-10_JPRB, 0.19577250E-10_JPRB, 0.19572247E-10_JPRB, 0.19699955E-10_JPRB, 0.20120666E-10_JPRB, &
  & 0.20715974E-10_JPRB, 0.21379431E-10_JPRB, 0.21263201E-10_JPRB, 0.21825814E-10_JPRB, 0.22374508E-10_JPRB, 0.23005516E-10_JPRB, &
  & 0.23679258E-10_JPRB, 0.24425913E-10_JPRB, 0.25223792E-10_JPRB, 0.26081403E-10_JPRB, 0.27025630E-10_JPRB, 0.28036688E-10_JPRB, &
  & 0.29112070E-10_JPRB, 0.30239571E-10_JPRB, 0.31425154E-10_JPRB, 0.32601890E-10_JPRB, 0.33750586E-10_JPRB, 0.34862922E-10_JPRB, &
  & 0.36018570E-10_JPRB, 0.37230680E-10_JPRB, 0.38491592E-10_JPRB, 0.39779798E-10_JPRB, 0.41078183E-10_JPRB, 0.42373473E-10_JPRB, &
  & 0.43662338E-10_JPRB, 0.44930799E-10_JPRB, 0.46195218E-10_JPRB, 0.47457888E-10_JPRB, 0.48654910E-10_JPRB, 0.49791022E-10_JPRB, &
  & 0.50974128E-10_JPRB, 0.52095123E-10_JPRB, 0.53142400E-10_JPRB, 0.54194416E-10_JPRB, 0.55212539E-10_JPRB, 0.56239440E-10_JPRB, &
  & 0.57192473E-10_JPRB, 0.58234015E-10_JPRB, 0.59275071E-10_JPRB, 0.60433804E-10_JPRB, 0.61561659E-10_JPRB, 0.62538974E-10_JPRB, &
  & 0.63573688E-10_JPRB, 0.64516441E-10_JPRB, 0.65670226E-10_JPRB, 0.66529282E-10_JPRB, 0.67773370E-10_JPRB, 0.68070903E-10_JPRB, &
  & 0.69217986E-10_JPRB, 0.68629831E-10_JPRB, 0.77693046E-10_JPRB, 0.77788560E-10_JPRB, 0.77799614E-10_JPRB, 0.77294095E-10_JPRB, &
  & 0.77125209E-10_JPRB, 0.78154573E-10_JPRB, 0.78337212E-10_JPRB, 0.78245944E-10_JPRB /)

RGHG4(:,82,12) = (/ &
  & 0.19689026E-10_JPRB, 0.19585548E-10_JPRB, 0.19749515E-10_JPRB, 0.19729550E-10_JPRB, 0.19857161E-10_JPRB, 0.20284762E-10_JPRB, &
  & 0.20898554E-10_JPRB, 0.21562602E-10_JPRB, 0.21560091E-10_JPRB, 0.22105493E-10_JPRB, 0.22718933E-10_JPRB, 0.23315086E-10_JPRB, &
  & 0.24000163E-10_JPRB, 0.24754528E-10_JPRB, 0.25562561E-10_JPRB, 0.26427006E-10_JPRB, 0.27335077E-10_JPRB, 0.28330113E-10_JPRB, &
  & 0.29391968E-10_JPRB, 0.30534401E-10_JPRB, 0.31707734E-10_JPRB, 0.32926221E-10_JPRB, 0.34096666E-10_JPRB, 0.35277260E-10_JPRB, &
  & 0.36476509E-10_JPRB, 0.37664250E-10_JPRB, 0.38905861E-10_JPRB, 0.40196180E-10_JPRB, 0.41499568E-10_JPRB, 0.42806196E-10_JPRB, &
  & 0.44105719E-10_JPRB, 0.45386469E-10_JPRB, 0.46673370E-10_JPRB, 0.47959418E-10_JPRB, 0.49209217E-10_JPRB, 0.50426118E-10_JPRB, &
  & 0.51547187E-10_JPRB, 0.52606166E-10_JPRB, 0.53633056E-10_JPRB, 0.54715819E-10_JPRB, 0.55741078E-10_JPRB, 0.56777135E-10_JPRB, &
  & 0.57702731E-10_JPRB, 0.58737758E-10_JPRB, 0.59762320E-10_JPRB, 0.60911429E-10_JPRB, 0.62066949E-10_JPRB, 0.63070882E-10_JPRB, &
  & 0.64135322E-10_JPRB, 0.65074716E-10_JPRB, 0.66233942E-10_JPRB, 0.67132556E-10_JPRB, 0.68345378E-10_JPRB, 0.68651529E-10_JPRB, &
  & 0.69604683E-10_JPRB, 0.69039517E-10_JPRB, 0.77818536E-10_JPRB, 0.78062973E-10_JPRB, 0.77888383E-10_JPRB, 0.77584918E-10_JPRB, &
  & 0.77323974E-10_JPRB, 0.78514459E-10_JPRB, 0.78962024E-10_JPRB, 0.80974928E-10_JPRB /)

RGHG4(:,83,12) = (/ &
  & 0.19739340E-10_JPRB, 0.19748802E-10_JPRB, 0.19953424E-10_JPRB, 0.19924524E-10_JPRB, 0.20061454E-10_JPRB, 0.20500530E-10_JPRB, &
  & 0.21109895E-10_JPRB, 0.21811868E-10_JPRB, 0.21771874E-10_JPRB, 0.22380132E-10_JPRB, 0.22908253E-10_JPRB, 0.23576110E-10_JPRB, &
  & 0.24233653E-10_JPRB, 0.25004514E-10_JPRB, 0.25815681E-10_JPRB, 0.26694015E-10_JPRB, 0.27657180E-10_JPRB, 0.28674568E-10_JPRB, &
  & 0.29759008E-10_JPRB, 0.30891848E-10_JPRB, 0.32091319E-10_JPRB, 0.33279941E-10_JPRB, 0.34438223E-10_JPRB, 0.35568302E-10_JPRB, &
  & 0.36717671E-10_JPRB, 0.37928723E-10_JPRB, 0.39187122E-10_JPRB, 0.40490285E-10_JPRB, 0.41808196E-10_JPRB, 0.43122086E-10_JPRB, &
  & 0.44433224E-10_JPRB, 0.45728473E-10_JPRB, 0.47034869E-10_JPRB, 0.48345321E-10_JPRB, 0.49596608E-10_JPRB, 0.50777216E-10_JPRB, &
  & 0.51948851E-10_JPRB, 0.53088811E-10_JPRB, 0.54155836E-10_JPRB, 0.55230438E-10_JPRB, 0.56264302E-10_JPRB, 0.57296150E-10_JPRB, &
  & 0.58238719E-10_JPRB, 0.59287582E-10_JPRB, 0.60331171E-10_JPRB, 0.61490923E-10_JPRB, 0.62609230E-10_JPRB, 0.63572189E-10_JPRB, &
  & 0.64574179E-10_JPRB, 0.65485402E-10_JPRB, 0.66601606E-10_JPRB, 0.67511371E-10_JPRB, 0.68667037E-10_JPRB, 0.69044770E-10_JPRB, &
  & 0.69983096E-10_JPRB, 0.69576435E-10_JPRB, 0.78248644E-10_JPRB, 0.78663263E-10_JPRB, 0.78374238E-10_JPRB, 0.78208946E-10_JPRB, &
  & 0.77888106E-10_JPRB, 0.78835105E-10_JPRB, 0.79337842E-10_JPRB, 0.80972125E-10_JPRB /)

RGHG4(:,84,12) = (/ &
  & 0.19894517E-10_JPRB, 0.19849495E-10_JPRB, 0.20069838E-10_JPRB, 0.20010191E-10_JPRB, 0.20157691E-10_JPRB, 0.20596141E-10_JPRB, &
  & 0.21215875E-10_JPRB, 0.21923741E-10_JPRB, 0.21998211E-10_JPRB, 0.22551966E-10_JPRB, 0.23171260E-10_JPRB, 0.23746964E-10_JPRB, &
  & 0.24446313E-10_JPRB, 0.25194532E-10_JPRB, 0.26023829E-10_JPRB, 0.26900197E-10_JPRB, 0.27819578E-10_JPRB, 0.28830207E-10_JPRB, &
  & 0.29905529E-10_JPRB, 0.31045857E-10_JPRB, 0.32220691E-10_JPRB, 0.33442811E-10_JPRB, 0.34601398E-10_JPRB, 0.35794874E-10_JPRB, &
  & 0.36980356E-10_JPRB, 0.38187828E-10_JPRB, 0.39437252E-10_JPRB, 0.40728424E-10_JPRB, 0.42049600E-10_JPRB, 0.43372830E-10_JPRB, &
  & 0.44693475E-10_JPRB, 0.46002022E-10_JPRB, 0.47327767E-10_JPRB, 0.48649230E-10_JPRB, 0.49922497E-10_JPRB, 0.51133653E-10_JPRB, &
  & 0.52315818E-10_JPRB, 0.53407740E-10_JPRB, 0.54463711E-10_JPRB, 0.55558717E-10_JPRB, 0.56573021E-10_JPRB, 0.57620263E-10_JPRB, &
  & 0.58546321E-10_JPRB, 0.59600894E-10_JPRB, 0.60615825E-10_JPRB, 0.61772559E-10_JPRB, 0.62883747E-10_JPRB, 0.63867953E-10_JPRB, &
  & 0.64913727E-10_JPRB, 0.65808844E-10_JPRB, 0.66932224E-10_JPRB, 0.67861008E-10_JPRB, 0.68999965E-10_JPRB, 0.69342906E-10_JPRB, &
  & 0.70162057E-10_JPRB, 0.69711834E-10_JPRB, 0.78212763E-10_JPRB, 0.78657081E-10_JPRB, 0.78356883E-10_JPRB, 0.78150521E-10_JPRB, &
  & 0.78085823E-10_JPRB, 0.78825516E-10_JPRB, 0.79626208E-10_JPRB, 0.81026318E-10_JPRB /)

RGHG4(:,85,12) = (/ &
  & 0.20001483E-10_JPRB, 0.19941607E-10_JPRB, 0.20208269E-10_JPRB, 0.20126087E-10_JPRB, 0.20306016E-10_JPRB, 0.20741195E-10_JPRB, &
  & 0.21389734E-10_JPRB, 0.22140140E-10_JPRB, 0.22185255E-10_JPRB, 0.22787511E-10_JPRB, 0.23312239E-10_JPRB, 0.23921719E-10_JPRB, &
  & 0.24567553E-10_JPRB, 0.25332863E-10_JPRB, 0.26163707E-10_JPRB, 0.27066056E-10_JPRB, 0.28037496E-10_JPRB, 0.29059016E-10_JPRB, &
  & 0.30133358E-10_JPRB, 0.31269723E-10_JPRB, 0.32452190E-10_JPRB, 0.33646926E-10_JPRB, 0.34827773E-10_JPRB, 0.35952092E-10_JPRB, &
  & 0.37123565E-10_JPRB, 0.38322418E-10_JPRB, 0.39594456E-10_JPRB, 0.40909113E-10_JPRB, 0.42228429E-10_JPRB, 0.43566324E-10_JPRB, &
  & 0.44895046E-10_JPRB, 0.46219684E-10_JPRB, 0.47561999E-10_JPRB, 0.48901033E-10_JPRB, 0.50173050E-10_JPRB, 0.51379487E-10_JPRB, &
  & 0.52561986E-10_JPRB, 0.53703736E-10_JPRB, 0.54797073E-10_JPRB, 0.55860792E-10_JPRB, 0.56934537E-10_JPRB, 0.57933935E-10_JPRB, &
  & 0.58906074E-10_JPRB, 0.59954881E-10_JPRB, 0.61006152E-10_JPRB, 0.62174745E-10_JPRB, 0.63272707E-10_JPRB, 0.64197599E-10_JPRB, &
  & 0.65247634E-10_JPRB, 0.66100035E-10_JPRB, 0.67210487E-10_JPRB, 0.68105896E-10_JPRB, 0.69250369E-10_JPRB, 0.69575921E-10_JPRB, &
  & 0.70448203E-10_JPRB, 0.69966873E-10_JPRB, 0.78503995E-10_JPRB, 0.78852501E-10_JPRB, 0.78725297E-10_JPRB, 0.78248324E-10_JPRB, &
  & 0.78452890E-10_JPRB, 0.78896140E-10_JPRB, 0.79799369E-10_JPRB, 0.81255960E-10_JPRB /)

RGHG4(:,86,12) = (/ &
  & 0.20102232E-10_JPRB, 0.20002630E-10_JPRB, 0.20304270E-10_JPRB, 0.20177398E-10_JPRB, 0.20394441E-10_JPRB, 0.20813080E-10_JPRB, &
  & 0.21519115E-10_JPRB, 0.22282069E-10_JPRB, 0.22400410E-10_JPRB, 0.22971680E-10_JPRB, 0.23507193E-10_JPRB, 0.24068442E-10_JPRB, &
  & 0.24679134E-10_JPRB, 0.25426302E-10_JPRB, 0.26258660E-10_JPRB, 0.27162061E-10_JPRB, 0.28106633E-10_JPRB, 0.29124172E-10_JPRB, &
  & 0.30214647E-10_JPRB, 0.31322535E-10_JPRB, 0.32512992E-10_JPRB, 0.33737683E-10_JPRB, 0.34876803E-10_JPRB, 0.36075466E-10_JPRB, &
  & 0.37272754E-10_JPRB, 0.38494118E-10_JPRB, 0.39751900E-10_JPRB, 0.41060651E-10_JPRB, 0.42387132E-10_JPRB, 0.43725589E-10_JPRB, &
  & 0.45065229E-10_JPRB, 0.46401143E-10_JPRB, 0.47751681E-10_JPRB, 0.49089247E-10_JPRB, 0.50378254E-10_JPRB, 0.51592907E-10_JPRB, &
  & 0.52805631E-10_JPRB, 0.53932209E-10_JPRB, 0.55034026E-10_JPRB, 0.56129129E-10_JPRB, 0.57163430E-10_JPRB, 0.58218388E-10_JPRB, &
  & 0.59147472E-10_JPRB, 0.60212967E-10_JPRB, 0.61213014E-10_JPRB, 0.62371566E-10_JPRB, 0.63499546E-10_JPRB, 0.64351892E-10_JPRB, &
  & 0.65463121E-10_JPRB, 0.66290959E-10_JPRB, 0.67416864E-10_JPRB, 0.68304966E-10_JPRB, 0.69479221E-10_JPRB, 0.69716656E-10_JPRB, &
  & 0.70603072E-10_JPRB, 0.69966533E-10_JPRB, 0.78534415E-10_JPRB, 0.78704737E-10_JPRB, 0.78791799E-10_JPRB, 0.78132292E-10_JPRB, &
  & 0.78553095E-10_JPRB, 0.78927184E-10_JPRB, 0.79903709E-10_JPRB, 0.81308321E-10_JPRB /)

RGHG4(:,87,12) = (/ &
  & 0.20182588E-10_JPRB, 0.20060032E-10_JPRB, 0.20400664E-10_JPRB, 0.20246612E-10_JPRB, 0.20509665E-10_JPRB, 0.20928002E-10_JPRB, &
  & 0.21712286E-10_JPRB, 0.22456885E-10_JPRB, 0.22613574E-10_JPRB, 0.23134572E-10_JPRB, 0.23656611E-10_JPRB, 0.24163090E-10_JPRB, &
  & 0.24784817E-10_JPRB, 0.25475694E-10_JPRB, 0.26319598E-10_JPRB, 0.27240444E-10_JPRB, 0.28227037E-10_JPRB, 0.29268352E-10_JPRB, &
  & 0.30316753E-10_JPRB, 0.31465362E-10_JPRB, 0.32648492E-10_JPRB, 0.33824176E-10_JPRB, 0.35009062E-10_JPRB, 0.36160203E-10_JPRB, &
  & 0.37345724E-10_JPRB, 0.38563111E-10_JPRB, 0.39841838E-10_JPRB, 0.41164086E-10_JPRB, 0.42494383E-10_JPRB, 0.43831591E-10_JPRB, &
  & 0.45178986E-10_JPRB, 0.46516790E-10_JPRB, 0.47878375E-10_JPRB, 0.49237014E-10_JPRB, 0.50522381E-10_JPRB, 0.51746708E-10_JPRB, &
  & 0.52962242E-10_JPRB, 0.54130218E-10_JPRB, 0.55248563E-10_JPRB, 0.56357547E-10_JPRB, 0.57441545E-10_JPRB, 0.58457877E-10_JPRB, &
  & 0.59437066E-10_JPRB, 0.60478934E-10_JPRB, 0.61530711E-10_JPRB, 0.62595776E-10_JPRB, 0.63824446E-10_JPRB, 0.64611559E-10_JPRB, &
  & 0.65692632E-10_JPRB, 0.66535770E-10_JPRB, 0.67649143E-10_JPRB, 0.68492240E-10_JPRB, 0.69682378E-10_JPRB, 0.69884855E-10_JPRB, &
  & 0.70819690E-10_JPRB, 0.70114130E-10_JPRB, 0.78706472E-10_JPRB, 0.78802576E-10_JPRB, 0.78930598E-10_JPRB, 0.78225044E-10_JPRB, &
  & 0.78637749E-10_JPRB, 0.79004740E-10_JPRB, 0.79965076E-10_JPRB, 0.81337811E-10_JPRB /)

RGHG4(:,88,12) = (/ &
  & 0.20241803E-10_JPRB, 0.20112871E-10_JPRB, 0.20461969E-10_JPRB, 0.20282413E-10_JPRB, 0.20575933E-10_JPRB, 0.20971076E-10_JPRB, &
  & 0.21797378E-10_JPRB, 0.22535840E-10_JPRB, 0.22717170E-10_JPRB, 0.23238765E-10_JPRB, 0.23758537E-10_JPRB, 0.24277096E-10_JPRB, &
  & 0.24846663E-10_JPRB, 0.25569779E-10_JPRB, 0.26379482E-10_JPRB, 0.27294037E-10_JPRB, 0.28257834E-10_JPRB, 0.29274909E-10_JPRB, &
  & 0.30364010E-10_JPRB, 0.31491920E-10_JPRB, 0.32661977E-10_JPRB, 0.33870500E-10_JPRB, 0.35033271E-10_JPRB, 0.36215132E-10_JPRB, &
  & 0.37420480E-10_JPRB, 0.38653511E-10_JPRB, 0.39931815E-10_JPRB, 0.41255176E-10_JPRB, 0.42598532E-10_JPRB, 0.43934231E-10_JPRB, &
  & 0.45294483E-10_JPRB, 0.46653129E-10_JPRB, 0.48018173E-10_JPRB, 0.49367482E-10_JPRB, 0.50661749E-10_JPRB, 0.51909123E-10_JPRB, &
  & 0.53144433E-10_JPRB, 0.54311600E-10_JPRB, 0.55443372E-10_JPRB, 0.56554587E-10_JPRB, 0.57638911E-10_JPRB, 0.58676251E-10_JPRB, &
  & 0.59642985E-10_JPRB, 0.60632638E-10_JPRB, 0.61731710E-10_JPRB, 0.62713654E-10_JPRB, 0.63917545E-10_JPRB, 0.64758088E-10_JPRB, &
  & 0.65799081E-10_JPRB, 0.66627100E-10_JPRB, 0.67754649E-10_JPRB, 0.68616744E-10_JPRB, 0.69812336E-10_JPRB, 0.69976948E-10_JPRB, &
  & 0.70907578E-10_JPRB, 0.70126148E-10_JPRB, 0.78660807E-10_JPRB, 0.78778449E-10_JPRB, 0.78888091E-10_JPRB, 0.78222831E-10_JPRB, &
  & 0.78642752E-10_JPRB, 0.79032614E-10_JPRB, 0.80012941E-10_JPRB, 0.81370861E-10_JPRB /)

RGHG4(:,89,12) = (/ &
  & 0.20291288E-10_JPRB, 0.20169786E-10_JPRB, 0.20507337E-10_JPRB, 0.20334370E-10_JPRB, 0.20618991E-10_JPRB, 0.21002531E-10_JPRB, &
  & 0.21826266E-10_JPRB, 0.22536166E-10_JPRB, 0.22757254E-10_JPRB, 0.23256818E-10_JPRB, 0.23789189E-10_JPRB, 0.24301609E-10_JPRB, &
  & 0.24919861E-10_JPRB, 0.25621338E-10_JPRB, 0.26456603E-10_JPRB, 0.27378405E-10_JPRB, 0.28351441E-10_JPRB, 0.29386507E-10_JPRB, &
  & 0.30443936E-10_JPRB, 0.31567797E-10_JPRB, 0.32718130E-10_JPRB, 0.33915429E-10_JPRB, 0.35070918E-10_JPRB, 0.36236944E-10_JPRB, &
  & 0.37435912E-10_JPRB, 0.38665904E-10_JPRB, 0.39952094E-10_JPRB, 0.41283275E-10_JPRB, 0.42625556E-10_JPRB, 0.43980868E-10_JPRB, &
  & 0.45352236E-10_JPRB, 0.46699464E-10_JPRB, 0.48080751E-10_JPRB, 0.49473359E-10_JPRB, 0.50805603E-10_JPRB, 0.52071483E-10_JPRB, &
  & 0.53326014E-10_JPRB, 0.54508627E-10_JPRB, 0.55646453E-10_JPRB, 0.56764576E-10_JPRB, 0.57850880E-10_JPRB, 0.58874301E-10_JPRB, &
  & 0.59867285E-10_JPRB, 0.60836169E-10_JPRB, 0.61918873E-10_JPRB, 0.62970511E-10_JPRB, 0.64094591E-10_JPRB, 0.64974248E-10_JPRB, &
  & 0.66003397E-10_JPRB, 0.66859872E-10_JPRB, 0.67925034E-10_JPRB, 0.68781314E-10_JPRB, 0.69960232E-10_JPRB, 0.70108558E-10_JPRB, &
  & 0.71064980E-10_JPRB, 0.70201824E-10_JPRB, 0.78705473E-10_JPRB, 0.78847595E-10_JPRB, 0.78921585E-10_JPRB, 0.78241177E-10_JPRB, &
  & 0.78689479E-10_JPRB, 0.79044271E-10_JPRB, 0.80075044E-10_JPRB, 0.81391803E-10_JPRB /)

RGHG4(:,90,12) = (/ &
  & 0.20319461E-10_JPRB, 0.20226933E-10_JPRB, 0.20512201E-10_JPRB, 0.20378130E-10_JPRB, 0.20599902E-10_JPRB, 0.20978150E-10_JPRB, &
  & 0.21723932E-10_JPRB, 0.22451072E-10_JPRB, 0.22637491E-10_JPRB, 0.23192292E-10_JPRB, 0.23750016E-10_JPRB, 0.24312273E-10_JPRB, &
  & 0.24956206E-10_JPRB, 0.25697132E-10_JPRB, 0.26547507E-10_JPRB, 0.27430629E-10_JPRB, 0.28394008E-10_JPRB, 0.29378836E-10_JPRB, &
  & 0.30448612E-10_JPRB, 0.31535406E-10_JPRB, 0.32705821E-10_JPRB, 0.33881144E-10_JPRB, 0.35034541E-10_JPRB, 0.36207506E-10_JPRB, &
  & 0.37413756E-10_JPRB, 0.38656637E-10_JPRB, 0.39955306E-10_JPRB, 0.41306857E-10_JPRB, 0.42671706E-10_JPRB, 0.44039345E-10_JPRB, &
  & 0.45425424E-10_JPRB, 0.46825946E-10_JPRB, 0.48246015E-10_JPRB, 0.49654079E-10_JPRB, 0.50981223E-10_JPRB, 0.52285166E-10_JPRB, &
  & 0.53558952E-10_JPRB, 0.54744407E-10_JPRB, 0.55872997E-10_JPRB, 0.56985566E-10_JPRB, 0.58061035E-10_JPRB, 0.59071609E-10_JPRB, &
  & 0.60026491E-10_JPRB, 0.61009080E-10_JPRB, 0.62006004E-10_JPRB, 0.63090477E-10_JPRB, 0.64161856E-10_JPRB, 0.65061657E-10_JPRB, &
  & 0.66024859E-10_JPRB, 0.66945102E-10_JPRB, 0.67986602E-10_JPRB, 0.68894258E-10_JPRB, 0.70046594E-10_JPRB, 0.70172063E-10_JPRB, &
  & 0.71182386E-10_JPRB, 0.70133108E-10_JPRB, 0.78657893E-10_JPRB, 0.78852209E-10_JPRB, 0.78899220E-10_JPRB, 0.78187207E-10_JPRB, &
  & 0.78722057E-10_JPRB, 0.79042342E-10_JPRB, 0.80164604E-10_JPRB, 0.81416672E-10_JPRB /)

RGHG4(:,91,12) = (/ &
  & 0.20300884E-10_JPRB, 0.20302359E-10_JPRB, 0.20470592E-10_JPRB, 0.20440169E-10_JPRB, 0.20554379E-10_JPRB, 0.20966152E-10_JPRB, &
  & 0.19468340E-10_JPRB, 0.21611971E-10_JPRB, 0.22442345E-10_JPRB, 0.23031873E-10_JPRB, 0.23630058E-10_JPRB, 0.24269335E-10_JPRB, &
  & 0.24976597E-10_JPRB, 0.25760947E-10_JPRB, 0.26597106E-10_JPRB, 0.27480636E-10_JPRB, 0.28416526E-10_JPRB, 0.29409360E-10_JPRB, &
  & 0.30448477E-10_JPRB, 0.31526375E-10_JPRB, 0.32658508E-10_JPRB, 0.33812786E-10_JPRB, 0.34949894E-10_JPRB, 0.36115121E-10_JPRB, &
  & 0.37320241E-10_JPRB, 0.38530647E-10_JPRB, 0.39876446E-10_JPRB, 0.41243474E-10_JPRB, 0.42629539E-10_JPRB, 0.44041198E-10_JPRB, &
  & 0.45454470E-10_JPRB, 0.46856727E-10_JPRB, 0.48302744E-10_JPRB, 0.49801607E-10_JPRB, 0.51165742E-10_JPRB, 0.52560324E-10_JPRB, &
  & 0.53878325E-10_JPRB, 0.55064748E-10_JPRB, 0.56187471E-10_JPRB, 0.57290919E-10_JPRB, 0.56295205E-10_JPRB, 0.57378224E-10_JPRB, &
  & 0.60278178E-10_JPRB, 0.61260545E-10_JPRB, 0.62235196E-10_JPRB, 0.63322389E-10_JPRB, 0.64363917E-10_JPRB, 0.65297753E-10_JPRB, &
  & 0.66191566E-10_JPRB, 0.67148967E-10_JPRB, 0.68087536E-10_JPRB, 0.69064282E-10_JPRB, 0.70141615E-10_JPRB, 0.70257924E-10_JPRB, &
  & 0.71418517E-10_JPRB, 0.69958227E-10_JPRB, 0.78630658E-10_JPRB, 0.78933859E-10_JPRB, 0.78875871E-10_JPRB, 0.78109449E-10_JPRB, &
  & 0.78769470E-10_JPRB, 0.79069001E-10_JPRB, 0.80331700E-10_JPRB, 0.81458409E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_NO2CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_NO2CLIM
