!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_OZOCLIM


!**   OZONE FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_OZOCLIM* FROM *SU_GHGCLIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG7

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLOZO(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG9(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG7(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLOZO(:,:,:)=ZGHG9(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG7(:, 1, 1) = (/ &
  & 0.10244170E-06_JPRB, 0.87350955E-07_JPRB, 0.81038387E-07_JPRB, 0.74772849E-07_JPRB, 0.72049509E-07_JPRB, 0.69850522E-07_JPRB, &
  & 0.69082780E-07_JPRB, 0.68604685E-07_JPRB, 0.68582679E-07_JPRB, 0.68581038E-07_JPRB, 0.68945525E-07_JPRB, 0.69309124E-07_JPRB, &
  & 0.69722937E-07_JPRB, 0.70244738E-07_JPRB, 0.70545475E-07_JPRB, 0.70831106E-07_JPRB, 0.71162489E-07_JPRB, 0.71156606E-07_JPRB, &
  & 0.71030890E-07_JPRB, 0.70994048E-07_JPRB, 0.70629753E-07_JPRB, 0.70102381E-07_JPRB, 0.69524539E-07_JPRB, 0.68914574E-07_JPRB, &
  & 0.68273792E-07_JPRB, 0.67699482E-07_JPRB, 0.67135929E-07_JPRB, 0.66637568E-07_JPRB, 0.66264498E-07_JPRB, 0.66054348E-07_JPRB, &
  & 0.66057247E-07_JPRB, 0.66312261E-07_JPRB, 0.66834765E-07_JPRB, 0.67621471E-07_JPRB, 0.68457524E-07_JPRB, 0.69258469E-07_JPRB, &
  & 0.69895734E-07_JPRB, 0.70259205E-07_JPRB, 0.70301937E-07_JPRB, 0.70070286E-07_JPRB, 0.69767907E-07_JPRB, 0.69302395E-07_JPRB, &
  & 0.68806230E-07_JPRB, 0.68347141E-07_JPRB, 0.67961992E-07_JPRB, 0.67655748E-07_JPRB, 0.67421269E-07_JPRB, 0.67145521E-07_JPRB, &
  & 0.66836833E-07_JPRB, 0.66542469E-07_JPRB, 0.66337385E-07_JPRB, 0.66214518E-07_JPRB, 0.66234023E-07_JPRB, 0.66431127E-07_JPRB, &
  & 0.66817741E-07_JPRB, 0.67452810E-07_JPRB, 0.68440023E-07_JPRB, 0.75295830E-07_JPRB, 0.60362431E-05_JPRB, 0.60492280E-05_JPRB, &
  & 0.60431471E-05_JPRB, 0.60501566E-05_JPRB, 0.60950856E-05_JPRB, 0.61820888E-05_JPRB /)

RGHG7(:, 2, 1) = (/ &
  & 0.29225527E-06_JPRB, 0.34611080E-06_JPRB, 0.33856784E-06_JPRB, 0.30258332E-06_JPRB, 0.26971924E-06_JPRB, 0.24052997E-06_JPRB, &
  & 0.22007153E-06_JPRB, 0.20748635E-06_JPRB, 0.19999524E-06_JPRB, 0.19278458E-06_JPRB, 0.19400827E-06_JPRB, 0.19481713E-06_JPRB, &
  & 0.19527734E-06_JPRB, 0.19766783E-06_JPRB, 0.19469812E-06_JPRB, 0.19420320E-06_JPRB, 0.19742761E-06_JPRB, 0.19571661E-06_JPRB, &
  & 0.19588933E-06_JPRB, 0.20098571E-06_JPRB, 0.20192954E-06_JPRB, 0.20230210E-06_JPRB, 0.20305818E-06_JPRB, 0.20424599E-06_JPRB, &
  & 0.20571450E-06_JPRB, 0.21030324E-06_JPRB, 0.21153618E-06_JPRB, 0.21123915E-06_JPRB, 0.21086223E-06_JPRB, 0.21050010E-06_JPRB, &
  & 0.21041544E-06_JPRB, 0.21094731E-06_JPRB, 0.21287508E-06_JPRB, 0.22110316E-06_JPRB, 0.22459746E-06_JPRB, 0.22583932E-06_JPRB, &
  & 0.22593383E-06_JPRB, 0.22493960E-06_JPRB, 0.22344258E-06_JPRB, 0.22200044E-06_JPRB, 0.22659682E-06_JPRB, 0.22722230E-06_JPRB, &
  & 0.22708950E-06_JPRB, 0.22835329E-06_JPRB, 0.23119350E-06_JPRB, 0.23519273E-06_JPRB, 0.24187966E-06_JPRB, 0.24568408E-06_JPRB, &
  & 0.24739757E-06_JPRB, 0.24707848E-06_JPRB, 0.24689894E-06_JPRB, 0.24354529E-06_JPRB, 0.23936340E-06_JPRB, 0.23637912E-06_JPRB, &
  & 0.23415542E-06_JPRB, 0.23626841E-06_JPRB, 0.24217846E-06_JPRB, 0.33588390E-06_JPRB, 0.77322493E-05_JPRB, 0.77550358E-05_JPRB, &
  & 0.78218300E-05_JPRB, 0.78287903E-05_JPRB, 0.78194107E-05_JPRB, 0.78002004E-05_JPRB /)

RGHG7(:, 3, 1) = (/ &
  & 0.45009986E-06_JPRB, 0.54151985E-06_JPRB, 0.54272789E-06_JPRB, 0.52133953E-06_JPRB, 0.49654494E-06_JPRB, 0.47288449E-06_JPRB, &
  & 0.45947874E-06_JPRB, 0.44774305E-06_JPRB, 0.42706642E-06_JPRB, 0.40995698E-06_JPRB, 0.40599559E-06_JPRB, 0.39949595E-06_JPRB, &
  & 0.39712813E-06_JPRB, 0.39425117E-06_JPRB, 0.38779518E-06_JPRB, 0.38872494E-06_JPRB, 0.39399845E-06_JPRB, 0.38794764E-06_JPRB, &
  & 0.39494330E-06_JPRB, 0.40270075E-06_JPRB, 0.39971158E-06_JPRB, 0.39984775E-06_JPRB, 0.39969672E-06_JPRB, 0.40167592E-06_JPRB, &
  & 0.40620372E-06_JPRB, 0.41395637E-06_JPRB, 0.41204174E-06_JPRB, 0.41026561E-06_JPRB, 0.40866885E-06_JPRB, 0.40805398E-06_JPRB, &
  & 0.40843102E-06_JPRB, 0.41032564E-06_JPRB, 0.41638469E-06_JPRB, 0.42851798E-06_JPRB, 0.43007927E-06_JPRB, 0.42967196E-06_JPRB, &
  & 0.42739234E-06_JPRB, 0.42422448E-06_JPRB, 0.42100115E-06_JPRB, 0.41966362E-06_JPRB, 0.42747502E-06_JPRB, 0.42699290E-06_JPRB, &
  & 0.42739052E-06_JPRB, 0.42919368E-06_JPRB, 0.43225717E-06_JPRB, 0.43789902E-06_JPRB, 0.44965611E-06_JPRB, 0.45812496E-06_JPRB, &
  & 0.46811908E-06_JPRB, 0.48130266E-06_JPRB, 0.49552659E-06_JPRB, 0.50029399E-06_JPRB, 0.50032361E-06_JPRB, 0.50390605E-06_JPRB, &
  & 0.51735691E-06_JPRB, 0.55333021E-06_JPRB, 0.61758743E-06_JPRB, 0.13454649E-05_JPRB, 0.71261934E-05_JPRB, 0.70673391E-05_JPRB, &
  & 0.68782592E-05_JPRB, 0.67261394E-05_JPRB, 0.64878564E-05_JPRB, 0.60649236E-05_JPRB /)

RGHG7(:, 4, 1) = (/ &
  & 0.67299419E-06_JPRB, 0.71292550E-06_JPRB, 0.69458446E-06_JPRB, 0.66394762E-06_JPRB, 0.63691380E-06_JPRB, 0.61876386E-06_JPRB, &
  & 0.62452801E-06_JPRB, 0.64134809E-06_JPRB, 0.64503058E-06_JPRB, 0.65387798E-06_JPRB, 0.66518885E-06_JPRB, 0.66871854E-06_JPRB, &
  & 0.67950850E-06_JPRB, 0.68124848E-06_JPRB, 0.68387459E-06_JPRB, 0.69619580E-06_JPRB, 0.70817657E-06_JPRB, 0.70676293E-06_JPRB, &
  & 0.72613835E-06_JPRB, 0.73905915E-06_JPRB, 0.73315829E-06_JPRB, 0.73210037E-06_JPRB, 0.73289459E-06_JPRB, 0.73508846E-06_JPRB, &
  & 0.74703593E-06_JPRB, 0.75624888E-06_JPRB, 0.74436031E-06_JPRB, 0.74205741E-06_JPRB, 0.73671873E-06_JPRB, 0.73492805E-06_JPRB, &
  & 0.73386315E-06_JPRB, 0.73391169E-06_JPRB, 0.74042754E-06_JPRB, 0.75047268E-06_JPRB, 0.74256656E-06_JPRB, 0.73519578E-06_JPRB, &
  & 0.72569543E-06_JPRB, 0.71642677E-06_JPRB, 0.70731960E-06_JPRB, 0.70285699E-06_JPRB, 0.71136975E-06_JPRB, 0.70362933E-06_JPRB, &
  & 0.69671756E-06_JPRB, 0.68864790E-06_JPRB, 0.68146397E-06_JPRB, 0.67835680E-06_JPRB, 0.68220123E-06_JPRB, 0.68126064E-06_JPRB, &
  & 0.67576894E-06_JPRB, 0.65844540E-06_JPRB, 0.63323478E-06_JPRB, 0.60850357E-06_JPRB, 0.60432495E-06_JPRB, 0.62559326E-06_JPRB, &
  & 0.67601667E-06_JPRB, 0.77992519E-06_JPRB, 0.96596045E-06_JPRB, 0.23063722E-05_JPRB, 0.43445557E-05_JPRB, 0.43816603E-05_JPRB, &
  & 0.43091354E-05_JPRB, 0.41897861E-05_JPRB, 0.40469376E-05_JPRB, 0.37788320E-05_JPRB /)

RGHG7(:, 5, 1) = (/ &
  & 0.93887854E-06_JPRB, 0.90717327E-06_JPRB, 0.86459107E-06_JPRB, 0.83416347E-06_JPRB, 0.81350248E-06_JPRB, 0.80159708E-06_JPRB, &
  & 0.82142151E-06_JPRB, 0.85836263E-06_JPRB, 0.88236561E-06_JPRB, 0.90680970E-06_JPRB, 0.93280727E-06_JPRB, 0.94743979E-06_JPRB, &
  & 0.97364102E-06_JPRB, 0.98525300E-06_JPRB, 0.99917156E-06_JPRB, 0.10287177E-05_JPRB, 0.10462342E-05_JPRB, 0.10581891E-05_JPRB, &
  & 0.10881392E-05_JPRB, 0.11061449E-05_JPRB, 0.11046413E-05_JPRB, 0.11010383E-05_JPRB, 0.11021192E-05_JPRB, 0.11078843E-05_JPRB, &
  & 0.11239033E-05_JPRB, 0.11334528E-05_JPRB, 0.11125661E-05_JPRB, 0.11049655E-05_JPRB, 0.11002840E-05_JPRB, 0.10909658E-05_JPRB, &
  & 0.10873208E-05_JPRB, 0.10821601E-05_JPRB, 0.10874605E-05_JPRB, 0.10931573E-05_JPRB, 0.10749070E-05_JPRB, 0.10620942E-05_JPRB, &
  & 0.10446749E-05_JPRB, 0.10295419E-05_JPRB, 0.10157798E-05_JPRB, 0.10109437E-05_JPRB, 0.10210997E-05_JPRB, 0.10073906E-05_JPRB, &
  & 0.99532633E-06_JPRB, 0.98023190E-06_JPRB, 0.96698830E-06_JPRB, 0.95862617E-06_JPRB, 0.95547682E-06_JPRB, 0.94185191E-06_JPRB, &
  & 0.92108894E-06_JPRB, 0.90372640E-06_JPRB, 0.90908162E-06_JPRB, 0.92220125E-06_JPRB, 0.93054467E-06_JPRB, 0.93936643E-06_JPRB, &
  & 0.97689963E-06_JPRB, 0.10891631E-05_JPRB, 0.13508080E-05_JPRB, 0.22849067E-05_JPRB, 0.28271418E-05_JPRB, 0.28565537E-05_JPRB, &
  & 0.28008117E-05_JPRB, 0.27494200E-05_JPRB, 0.26822245E-05_JPRB, 0.25716986E-05_JPRB /)

RGHG7(:, 6, 1) = (/ &
  & 0.12651982E-05_JPRB, 0.12280083E-05_JPRB, 0.11771169E-05_JPRB, 0.11340074E-05_JPRB, 0.11003084E-05_JPRB, 0.10778995E-05_JPRB, &
  & 0.10932129E-05_JPRB, 0.11351065E-05_JPRB, 0.11689860E-05_JPRB, 0.12045260E-05_JPRB, 0.12435115E-05_JPRB, 0.12705536E-05_JPRB, &
  & 0.13119368E-05_JPRB, 0.13366695E-05_JPRB, 0.13631590E-05_JPRB, 0.14073319E-05_JPRB, 0.14320924E-05_JPRB, 0.14550201E-05_JPRB, &
  & 0.14934228E-05_JPRB, 0.15120448E-05_JPRB, 0.15143669E-05_JPRB, 0.15115073E-05_JPRB, 0.15104176E-05_JPRB, 0.15174155E-05_JPRB, &
  & 0.15371219E-05_JPRB, 0.15429310E-05_JPRB, 0.15228679E-05_JPRB, 0.15072455E-05_JPRB, 0.14986643E-05_JPRB, 0.14799799E-05_JPRB, &
  & 0.14676182E-05_JPRB, 0.14524574E-05_JPRB, 0.14556197E-05_JPRB, 0.14585652E-05_JPRB, 0.14364765E-05_JPRB, 0.14263404E-05_JPRB, &
  & 0.14114199E-05_JPRB, 0.14007400E-05_JPRB, 0.13898259E-05_JPRB, 0.13881512E-05_JPRB, 0.13962518E-05_JPRB, 0.13730888E-05_JPRB, &
  & 0.13509949E-05_JPRB, 0.13236947E-05_JPRB, 0.12998811E-05_JPRB, 0.12805575E-05_JPRB, 0.12651194E-05_JPRB, 0.12427487E-05_JPRB, &
  & 0.12283161E-05_JPRB, 0.12264359E-05_JPRB, 0.12206320E-05_JPRB, 0.11930180E-05_JPRB, 0.11814677E-05_JPRB, 0.12086887E-05_JPRB, &
  & 0.12789026E-05_JPRB, 0.14170409E-05_JPRB, 0.16609608E-05_JPRB, 0.20359209E-05_JPRB, 0.21748260E-05_JPRB, 0.21931689E-05_JPRB, &
  & 0.21722703E-05_JPRB, 0.21566202E-05_JPRB, 0.21382291E-05_JPRB, 0.21057019E-05_JPRB /)

RGHG7(:, 7, 1) = (/ &
  & 0.15815381E-05_JPRB, 0.15370907E-05_JPRB, 0.14891336E-05_JPRB, 0.14541118E-05_JPRB, 0.14282199E-05_JPRB, 0.14117195E-05_JPRB, &
  & 0.14268670E-05_JPRB, 0.14730047E-05_JPRB, 0.15157188E-05_JPRB, 0.15625760E-05_JPRB, 0.16127627E-05_JPRB, 0.16523444E-05_JPRB, &
  & 0.17060003E-05_JPRB, 0.17431001E-05_JPRB, 0.17820445E-05_JPRB, 0.18382015E-05_JPRB, 0.18728315E-05_JPRB, 0.19079048E-05_JPRB, &
  & 0.19560994E-05_JPRB, 0.19826152E-05_JPRB, 0.19933050E-05_JPRB, 0.19967699E-05_JPRB, 0.19991603E-05_JPRB, 0.20093198E-05_JPRB, &
  & 0.20339685E-05_JPRB, 0.20412647E-05_JPRB, 0.20243351E-05_JPRB, 0.20052835E-05_JPRB, 0.19927745E-05_JPRB, 0.19655263E-05_JPRB, &
  & 0.19449674E-05_JPRB, 0.19198328E-05_JPRB, 0.19209092E-05_JPRB, 0.19215395E-05_JPRB, 0.18993459E-05_JPRB, 0.18944154E-05_JPRB, &
  & 0.18850560E-05_JPRB, 0.18804375E-05_JPRB, 0.18736408E-05_JPRB, 0.18754821E-05_JPRB, 0.18804269E-05_JPRB, 0.18515727E-05_JPRB, &
  & 0.18261715E-05_JPRB, 0.17969325E-05_JPRB, 0.17741318E-05_JPRB, 0.17553823E-05_JPRB, 0.17393878E-05_JPRB, 0.17195157E-05_JPRB, &
  & 0.17071656E-05_JPRB, 0.16909206E-05_JPRB, 0.16755408E-05_JPRB, 0.16802790E-05_JPRB, 0.17096555E-05_JPRB, 0.17418116E-05_JPRB, &
  & 0.17898681E-05_JPRB, 0.18759728E-05_JPRB, 0.19907584E-05_JPRB, 0.20842685E-05_JPRB, 0.21097783E-05_JPRB, 0.21134483E-05_JPRB, &
  & 0.20874036E-05_JPRB, 0.20835241E-05_JPRB, 0.20753512E-05_JPRB, 0.20714201E-05_JPRB /)

RGHG7(:, 8, 1) = (/ &
  & 0.18757605E-05_JPRB, 0.18397058E-05_JPRB, 0.18062103E-05_JPRB, 0.17852705E-05_JPRB, 0.17700704E-05_JPRB, 0.17623836E-05_JPRB, &
  & 0.17796469E-05_JPRB, 0.18245777E-05_JPRB, 0.18698867E-05_JPRB, 0.19204915E-05_JPRB, 0.19752581E-05_JPRB, 0.20220220E-05_JPRB, &
  & 0.20818886E-05_JPRB, 0.21273804E-05_JPRB, 0.21746068E-05_JPRB, 0.22378015E-05_JPRB, 0.22801562E-05_JPRB, 0.23236960E-05_JPRB, &
  & 0.23768766E-05_JPRB, 0.24119972E-05_JPRB, 0.24334242E-05_JPRB, 0.24467563E-05_JPRB, 0.24579870E-05_JPRB, 0.24750304E-05_JPRB, &
  & 0.25059960E-05_JPRB, 0.25196466E-05_JPRB, 0.25106619E-05_JPRB, 0.24947194E-05_JPRB, 0.24865440E-05_JPRB, 0.24634166E-05_JPRB, &
  & 0.24483741E-05_JPRB, 0.24287056E-05_JPRB, 0.24364026E-05_JPRB, 0.24373428E-05_JPRB, 0.24122005E-05_JPRB, 0.24009066E-05_JPRB, &
  & 0.23828645E-05_JPRB, 0.23701471E-05_JPRB, 0.23567752E-05_JPRB, 0.23556627E-05_JPRB, 0.23555135E-05_JPRB, 0.23275338E-05_JPRB, &
  & 0.23063053E-05_JPRB, 0.22835593E-05_JPRB, 0.22696443E-05_JPRB, 0.22594925E-05_JPRB, 0.22548711E-05_JPRB, 0.22495278E-05_JPRB, &
  & 0.22492923E-05_JPRB, 0.22509134E-05_JPRB, 0.22657166E-05_JPRB, 0.22773495E-05_JPRB, 0.22854447E-05_JPRB, 0.23038376E-05_JPRB, &
  & 0.23341986E-05_JPRB, 0.23541861E-05_JPRB, 0.23454231E-05_JPRB, 0.23159446E-05_JPRB, 0.22971101E-05_JPRB, 0.22701520E-05_JPRB, &
  & 0.22487850E-05_JPRB, 0.22426073E-05_JPRB, 0.22312370E-05_JPRB, 0.22278987E-05_JPRB /)

RGHG7(:, 9, 1) = (/ &
  & 0.21916778E-05_JPRB, 0.21601754E-05_JPRB, 0.21382468E-05_JPRB, 0.21269432E-05_JPRB, 0.21255166E-05_JPRB, 0.21340882E-05_JPRB, &
  & 0.21605708E-05_JPRB, 0.22103302E-05_JPRB, 0.22620864E-05_JPRB, 0.23200032E-05_JPRB, 0.23820203E-05_JPRB, 0.24386484E-05_JPRB, &
  & 0.25082127E-05_JPRB, 0.25666038E-05_JPRB, 0.26252865E-05_JPRB, 0.26989396E-05_JPRB, 0.27528845E-05_JPRB, 0.28092361E-05_JPRB, &
  & 0.28741169E-05_JPRB, 0.29230791E-05_JPRB, 0.29614523E-05_JPRB, 0.29901573E-05_JPRB, 0.30160941E-05_JPRB, 0.30461440E-05_JPRB, &
  & 0.30887572E-05_JPRB, 0.31140785E-05_JPRB, 0.31189595E-05_JPRB, 0.31123795E-05_JPRB, 0.31154243E-05_JPRB, 0.31052789E-05_JPRB, &
  & 0.31045813E-05_JPRB, 0.31005368E-05_JPRB, 0.31211864E-05_JPRB, 0.31264985E-05_JPRB, 0.30955223E-05_JPRB, 0.30692499E-05_JPRB, &
  & 0.30299261E-05_JPRB, 0.29955968E-05_JPRB, 0.29621592E-05_JPRB, 0.29471828E-05_JPRB, 0.29351961E-05_JPRB, 0.29051935E-05_JPRB, &
  & 0.28889465E-05_JPRB, 0.28781808E-05_JPRB, 0.28817824E-05_JPRB, 0.28936238E-05_JPRB, 0.29102935E-05_JPRB, 0.29190765E-05_JPRB, &
  & 0.29294774E-05_JPRB, 0.29420585E-05_JPRB, 0.29549908E-05_JPRB, 0.29604594E-05_JPRB, 0.29720800E-05_JPRB, 0.29679118E-05_JPRB, &
  & 0.29224748E-05_JPRB, 0.28277352E-05_JPRB, 0.27077597E-05_JPRB, 0.26172856E-05_JPRB, 0.25799043E-05_JPRB, 0.25381930E-05_JPRB, &
  & 0.25197442E-05_JPRB, 0.25089998E-05_JPRB, 0.24932363E-05_JPRB, 0.24855781E-05_JPRB /)

RGHG7(:,10, 1) = (/ &
  & 0.26618807E-05_JPRB, 0.26163038E-05_JPRB, 0.25859779E-05_JPRB, 0.25768686E-05_JPRB, 0.25799918E-05_JPRB, 0.25989086E-05_JPRB, &
  & 0.26364064E-05_JPRB, 0.26935277E-05_JPRB, 0.27522767E-05_JPRB, 0.28183445E-05_JPRB, 0.28896177E-05_JPRB, 0.29568819E-05_JPRB, &
  & 0.30362287E-05_JPRB, 0.31067475E-05_JPRB, 0.31789459E-05_JPRB, 0.32664950E-05_JPRB, 0.33343988E-05_JPRB, 0.34048760E-05_JPRB, &
  & 0.34863688E-05_JPRB, 0.35506760E-05_JPRB, 0.36080833E-05_JPRB, 0.36548042E-05_JPRB, 0.36970910E-05_JPRB, 0.37432371E-05_JPRB, &
  & 0.38014489E-05_JPRB, 0.38405178E-05_JPRB, 0.38625699E-05_JPRB, 0.38689172E-05_JPRB, 0.38860435E-05_JPRB, 0.38910871E-05_JPRB, &
  & 0.39041452E-05_JPRB, 0.39122187E-05_JPRB, 0.39379656E-05_JPRB, 0.39388506E-05_JPRB, 0.38927537E-05_JPRB, 0.38420308E-05_JPRB, &
  & 0.37728496E-05_JPRB, 0.37110451E-05_JPRB, 0.36572569E-05_JPRB, 0.36284443E-05_JPRB, 0.36064018E-05_JPRB, 0.35796909E-05_JPRB, &
  & 0.35750202E-05_JPRB, 0.35855978E-05_JPRB, 0.36172164E-05_JPRB, 0.36564952E-05_JPRB, 0.36907211E-05_JPRB, 0.37148031E-05_JPRB, &
  & 0.37399079E-05_JPRB, 0.37613613E-05_JPRB, 0.37705217E-05_JPRB, 0.37614541E-05_JPRB, 0.37222815E-05_JPRB, 0.36292979E-05_JPRB, &
  & 0.34789284E-05_JPRB, 0.32808252E-05_JPRB, 0.30881356E-05_JPRB, 0.29651715E-05_JPRB, 0.29022883E-05_JPRB, 0.28538955E-05_JPRB, &
  & 0.28273089E-05_JPRB, 0.28079783E-05_JPRB, 0.27820042E-05_JPRB, 0.27586175E-05_JPRB /)

RGHG7(:,11, 1) = (/ &
  & 0.34061020E-05_JPRB, 0.33410488E-05_JPRB, 0.32942701E-05_JPRB, 0.32801058E-05_JPRB, 0.32759467E-05_JPRB, 0.32923010E-05_JPRB, &
  & 0.33299277E-05_JPRB, 0.33852903E-05_JPRB, 0.34406642E-05_JPRB, 0.35035507E-05_JPRB, 0.35718920E-05_JPRB, 0.36385886E-05_JPRB, &
  & 0.37195705E-05_JPRB, 0.37934863E-05_JPRB, 0.38704907E-05_JPRB, 0.39667152E-05_JPRB, 0.40464643E-05_JPRB, 0.41281151E-05_JPRB, &
  & 0.42247007E-05_JPRB, 0.43011555E-05_JPRB, 0.43704990E-05_JPRB, 0.44310791E-05_JPRB, 0.44849439E-05_JPRB, 0.45436682E-05_JPRB, &
  & 0.46173373E-05_JPRB, 0.46706796E-05_JPRB, 0.47133249E-05_JPRB, 0.47388171E-05_JPRB, 0.47747685E-05_JPRB, 0.47983503E-05_JPRB, &
  & 0.48258280E-05_JPRB, 0.48439470E-05_JPRB, 0.48700972E-05_JPRB, 0.48617935E-05_JPRB, 0.47984267E-05_JPRB, 0.47227018E-05_JPRB, &
  & 0.46319524E-05_JPRB, 0.45453676E-05_JPRB, 0.44745011E-05_JPRB, 0.44438348E-05_JPRB, 0.44222338E-05_JPRB, 0.44108515E-05_JPRB, &
  & 0.44318681E-05_JPRB, 0.44735930E-05_JPRB, 0.45263464E-05_JPRB, 0.45813290E-05_JPRB, 0.46205232E-05_JPRB, 0.46447926E-05_JPRB, &
  & 0.46510754E-05_JPRB, 0.46407622E-05_JPRB, 0.45998058E-05_JPRB, 0.45152515E-05_JPRB, 0.43794616E-05_JPRB, 0.41795229E-05_JPRB, &
  & 0.39229953E-05_JPRB, 0.36469251E-05_JPRB, 0.34276086E-05_JPRB, 0.32991966E-05_JPRB, 0.32286960E-05_JPRB, 0.31823602E-05_JPRB, &
  & 0.31479697E-05_JPRB, 0.31309344E-05_JPRB, 0.31041609E-05_JPRB, 0.30765702E-05_JPRB /)

RGHG7(:,12, 1) = (/ &
  & 0.40916884E-05_JPRB, 0.40340028E-05_JPRB, 0.39931037E-05_JPRB, 0.39800643E-05_JPRB, 0.39787024E-05_JPRB, 0.39967690E-05_JPRB, &
  & 0.40418709E-05_JPRB, 0.41076146E-05_JPRB, 0.41707622E-05_JPRB, 0.42412189E-05_JPRB, 0.43177065E-05_JPRB, 0.43941400E-05_JPRB, &
  & 0.44864264E-05_JPRB, 0.45743814E-05_JPRB, 0.46668119E-05_JPRB, 0.47780077E-05_JPRB, 0.48758966E-05_JPRB, 0.49756704E-05_JPRB, &
  & 0.50925091E-05_JPRB, 0.51895822E-05_JPRB, 0.52773162E-05_JPRB, 0.53589374E-05_JPRB, 0.54349657E-05_JPRB, 0.55158343E-05_JPRB, &
  & 0.56157296E-05_JPRB, 0.56940376E-05_JPRB, 0.57637858E-05_JPRB, 0.58144001E-05_JPRB, 0.58690434E-05_JPRB, 0.59049357E-05_JPRB, &
  & 0.59338913E-05_JPRB, 0.59446488E-05_JPRB, 0.59529293E-05_JPRB, 0.59190484E-05_JPRB, 0.58308410E-05_JPRB, 0.57250018E-05_JPRB, &
  & 0.56005815E-05_JPRB, 0.54980451E-05_JPRB, 0.54096486E-05_JPRB, 0.53635858E-05_JPRB, 0.53455738E-05_JPRB, 0.53514377E-05_JPRB, &
  & 0.53784979E-05_JPRB, 0.54241086E-05_JPRB, 0.54742645E-05_JPRB, 0.55207420E-05_JPRB, 0.55333931E-05_JPRB, 0.55155688E-05_JPRB, &
  & 0.54685001E-05_JPRB, 0.53915146E-05_JPRB, 0.52663222E-05_JPRB, 0.50846061E-05_JPRB, 0.48463094E-05_JPRB, 0.45495258E-05_JPRB, &
  & 0.42278621E-05_JPRB, 0.39307115E-05_JPRB, 0.37116426E-05_JPRB, 0.35878556E-05_JPRB, 0.35169173E-05_JPRB, 0.34726995E-05_JPRB, &
  & 0.34389766E-05_JPRB, 0.34201416E-05_JPRB, 0.33887375E-05_JPRB, 0.33574913E-05_JPRB /)

RGHG7(:,13, 1) = (/ &
  & 0.45053189E-05_JPRB, 0.44789404E-05_JPRB, 0.44749972E-05_JPRB, 0.44885314E-05_JPRB, 0.45177449E-05_JPRB, 0.45671345E-05_JPRB, &
  & 0.46465047E-05_JPRB, 0.47492549E-05_JPRB, 0.48439597E-05_JPRB, 0.49414539E-05_JPRB, 0.50413073E-05_JPRB, 0.51383990E-05_JPRB, &
  & 0.52490145E-05_JPRB, 0.53537497E-05_JPRB, 0.54641914E-05_JPRB, 0.55925857E-05_JPRB, 0.57102602E-05_JPRB, 0.58314622E-05_JPRB, &
  & 0.59703698E-05_JPRB, 0.60922221E-05_JPRB, 0.62054473E-05_JPRB, 0.63143593E-05_JPRB, 0.64206624E-05_JPRB, 0.65318786E-05_JPRB, &
  & 0.66613156E-05_JPRB, 0.67664691E-05_JPRB, 0.68565532E-05_JPRB, 0.69186085E-05_JPRB, 0.69679404E-05_JPRB, 0.69840207E-05_JPRB, &
  & 0.69781559E-05_JPRB, 0.69474995E-05_JPRB, 0.69128096E-05_JPRB, 0.68445033E-05_JPRB, 0.67379115E-05_JPRB, 0.66311982E-05_JPRB, &
  & 0.65188387E-05_JPRB, 0.64154315E-05_JPRB, 0.63363941E-05_JPRB, 0.62835425E-05_JPRB, 0.62321001E-05_JPRB, 0.61952751E-05_JPRB, &
  & 0.61721162E-05_JPRB, 0.61542955E-05_JPRB, 0.61307360E-05_JPRB, 0.61001265E-05_JPRB, 0.60423795E-05_JPRB, 0.59589565E-05_JPRB, &
  & 0.58515416E-05_JPRB, 0.57118127E-05_JPRB, 0.55268260E-05_JPRB, 0.52916826E-05_JPRB, 0.50140252E-05_JPRB, 0.46990635E-05_JPRB, &
  & 0.43836353E-05_JPRB, 0.41047738E-05_JPRB, 0.39014940E-05_JPRB, 0.37937314E-05_JPRB, 0.37371963E-05_JPRB, 0.36974714E-05_JPRB, &
  & 0.36705098E-05_JPRB, 0.36524943E-05_JPRB, 0.36294045E-05_JPRB, 0.35969763E-05_JPRB /)

RGHG7(:,14, 1) = (/ &
  & 0.47220060E-05_JPRB, 0.47308772E-05_JPRB, 0.47617245E-05_JPRB, 0.48102461E-05_JPRB, 0.48787510E-05_JPRB, 0.49715932E-05_JPRB, &
  & 0.50990088E-05_JPRB, 0.52518212E-05_JPRB, 0.53918902E-05_JPRB, 0.55292294E-05_JPRB, 0.56655194E-05_JPRB, 0.57954585E-05_JPRB, &
  & 0.59356867E-05_JPRB, 0.60684038E-05_JPRB, 0.62057688E-05_JPRB, 0.63593338E-05_JPRB, 0.65054578E-05_JPRB, 0.66564812E-05_JPRB, &
  & 0.68243894E-05_JPRB, 0.69774646E-05_JPRB, 0.71228246E-05_JPRB, 0.72632783E-05_JPRB, 0.74000122E-05_JPRB, 0.75374182E-05_JPRB, &
  & 0.76858332E-05_JPRB, 0.78027042E-05_JPRB, 0.78942985E-05_JPRB, 0.79447909E-05_JPRB, 0.79639485E-05_JPRB, 0.79354168E-05_JPRB, &
  & 0.78728563E-05_JPRB, 0.77845671E-05_JPRB, 0.76966426E-05_JPRB, 0.75906514E-05_JPRB, 0.74630443E-05_JPRB, 0.73373044E-05_JPRB, &
  & 0.72243570E-05_JPRB, 0.71213672E-05_JPRB, 0.70370124E-05_JPRB, 0.69670136E-05_JPRB, 0.68884801E-05_JPRB, 0.67989440E-05_JPRB, &
  & 0.67046194E-05_JPRB, 0.66054836E-05_JPRB, 0.65018826E-05_JPRB, 0.63920124E-05_JPRB, 0.62625450E-05_JPRB, 0.61085152E-05_JPRB, &
  & 0.59367494E-05_JPRB, 0.57408738E-05_JPRB, 0.55147912E-05_JPRB, 0.52581431E-05_JPRB, 0.49824994E-05_JPRB, 0.46935356E-05_JPRB, &
  & 0.44200069E-05_JPRB, 0.41874823E-05_JPRB, 0.40195177E-05_JPRB, 0.39375263E-05_JPRB, 0.38909152E-05_JPRB, 0.38615340E-05_JPRB, &
  & 0.38379130E-05_JPRB, 0.38220255E-05_JPRB, 0.38026201E-05_JPRB, 0.37758437E-05_JPRB /)

RGHG7(:,15, 1) = (/ &
  & 0.47643334E-05_JPRB, 0.48095321E-05_JPRB, 0.48686948E-05_JPRB, 0.49489004E-05_JPRB, 0.50544354E-05_JPRB, 0.51897027E-05_JPRB, &
  & 0.53639537E-05_JPRB, 0.55675187E-05_JPRB, 0.57586258E-05_JPRB, 0.59426739E-05_JPRB, 0.61217734E-05_JPRB, 0.62908707E-05_JPRB, &
  & 0.64651463E-05_JPRB, 0.66302291E-05_JPRB, 0.67982073E-05_JPRB, 0.69795738E-05_JPRB, 0.71552627E-05_JPRB, 0.73361025E-05_JPRB, &
  & 0.75318253E-05_JPRB, 0.77128570E-05_JPRB, 0.78855737E-05_JPRB, 0.80495947E-05_JPRB, 0.82032284E-05_JPRB, 0.83498089E-05_JPRB, &
  & 0.84945405E-05_JPRB, 0.86007021E-05_JPRB, 0.86708733E-05_JPRB, 0.86919863E-05_JPRB, 0.86729588E-05_JPRB, 0.86038826E-05_JPRB, &
  & 0.85017946E-05_JPRB, 0.83811874E-05_JPRB, 0.82611523E-05_JPRB, 0.81186199E-05_JPRB, 0.79724896E-05_JPRB, 0.78363109E-05_JPRB, &
  & 0.77126188E-05_JPRB, 0.76038968E-05_JPRB, 0.75062985E-05_JPRB, 0.74119916E-05_JPRB, 0.73031056E-05_JPRB, 0.71773252E-05_JPRB, &
  & 0.70367073E-05_JPRB, 0.68847876E-05_JPRB, 0.67254086E-05_JPRB, 0.65596346E-05_JPRB, 0.63790721E-05_JPRB, 0.61805013E-05_JPRB, &
  & 0.59683548E-05_JPRB, 0.57393677E-05_JPRB, 0.54906654E-05_JPRB, 0.52277223E-05_JPRB, 0.49601513E-05_JPRB, 0.46983046E-05_JPRB, &
  & 0.44598860E-05_JPRB, 0.42633569E-05_JPRB, 0.41280327E-05_JPRB, 0.40644900E-05_JPRB, 0.40242253E-05_JPRB, 0.40005916E-05_JPRB, &
  & 0.39792112E-05_JPRB, 0.39650517E-05_JPRB, 0.39473516E-05_JPRB, 0.39136598E-05_JPRB /)

RGHG7(:,16, 1) = (/ &
  & 0.47066692E-05_JPRB, 0.47625299E-05_JPRB, 0.48325473E-05_JPRB, 0.49278756E-05_JPRB, 0.50544204E-05_JPRB, 0.52174819E-05_JPRB, &
  & 0.54241159E-05_JPRB, 0.56657564E-05_JPRB, 0.58985779E-05_JPRB, 0.61242681E-05_JPRB, 0.63438856E-05_JPRB, 0.65535096E-05_JPRB, &
  & 0.67663018E-05_JPRB, 0.69708703E-05_JPRB, 0.71779382E-05_JPRB, 0.73960041E-05_JPRB, 0.76082138E-05_JPRB, 0.78226503E-05_JPRB, &
  & 0.80454483E-05_JPRB, 0.82495935E-05_JPRB, 0.84392059E-05_JPRB, 0.86137079E-05_JPRB, 0.87682311E-05_JPRB, 0.89053856E-05_JPRB, &
  & 0.90259618E-05_JPRB, 0.91008142E-05_JPRB, 0.91317397E-05_JPRB, 0.91109441E-05_JPRB, 0.90478215E-05_JPRB, 0.89422119E-05_JPRB, &
  & 0.88097850E-05_JPRB, 0.86710716E-05_JPRB, 0.85386873E-05_JPRB, 0.84038256E-05_JPRB, 0.82579272E-05_JPRB, 0.81190774E-05_JPRB, &
  & 0.79882602E-05_JPRB, 0.78648736E-05_JPRB, 0.77487584E-05_JPRB, 0.76303977E-05_JPRB, 0.74923391E-05_JPRB, 0.73369761E-05_JPRB, &
  & 0.71686932E-05_JPRB, 0.69914831E-05_JPRB, 0.68077638E-05_JPRB, 0.66185944E-05_JPRB, 0.64173532E-05_JPRB, 0.62019667E-05_JPRB, &
  & 0.59754279E-05_JPRB, 0.57375328E-05_JPRB, 0.54912507E-05_JPRB, 0.52422110E-05_JPRB, 0.49991340E-05_JPRB, 0.47668509E-05_JPRB, &
  & 0.45546676E-05_JPRB, 0.43793893E-05_JPRB, 0.42742759E-05_JPRB, 0.42254715E-05_JPRB, 0.41923349E-05_JPRB, 0.41701323E-05_JPRB, &
  & 0.41497569E-05_JPRB, 0.41336953E-05_JPRB, 0.41112780E-05_JPRB, 0.40710961E-05_JPRB /)

RGHG7(:,17, 1) = (/ &
  & 0.46567261E-05_JPRB, 0.47158333E-05_JPRB, 0.47908425E-05_JPRB, 0.48947823E-05_JPRB, 0.50355097E-05_JPRB, 0.52177020E-05_JPRB, &
  & 0.54484799E-05_JPRB, 0.57186048E-05_JPRB, 0.59867684E-05_JPRB, 0.62499039E-05_JPRB, 0.65076347E-05_JPRB, 0.67558703E-05_JPRB, &
  & 0.70051751E-05_JPRB, 0.72465773E-05_JPRB, 0.74876516E-05_JPRB, 0.77347995E-05_JPRB, 0.79731981E-05_JPRB, 0.82070146E-05_JPRB, &
  & 0.84415260E-05_JPRB, 0.86523933E-05_JPRB, 0.88409024E-05_JPRB, 0.90049161E-05_JPRB, 0.91412712E-05_JPRB, 0.92524942E-05_JPRB, &
  & 0.93387116E-05_JPRB, 0.93789286E-05_JPRB, 0.93751005E-05_JPRB, 0.93264616E-05_JPRB, 0.92421096E-05_JPRB, 0.91248448E-05_JPRB, &
  & 0.89882833E-05_JPRB, 0.88482939E-05_JPRB, 0.87187209E-05_JPRB, 0.85800066E-05_JPRB, 0.84477106E-05_JPRB, 0.83140812E-05_JPRB, &
  & 0.81871367E-05_JPRB, 0.80611098E-05_JPRB, 0.79318179E-05_JPRB, 0.77959121E-05_JPRB, 0.76390143E-05_JPRB, 0.74655522E-05_JPRB, &
  & 0.72807047E-05_JPRB, 0.70889801E-05_JPRB, 0.68926170E-05_JPRB, 0.66930793E-05_JPRB, 0.64829160E-05_JPRB, 0.62612535E-05_JPRB, &
  & 0.60297243E-05_JPRB, 0.57916004E-05_JPRB, 0.55517917E-05_JPRB, 0.53141944E-05_JPRB, 0.50852777E-05_JPRB, 0.48688821E-05_JPRB, &
  & 0.46785490E-05_JPRB, 0.45343536E-05_JPRB, 0.44507328E-05_JPRB, 0.44055141E-05_JPRB, 0.43745326E-05_JPRB, 0.43494119E-05_JPRB, &
  & 0.43295699E-05_JPRB, 0.43092155E-05_JPRB, 0.42865340E-05_JPRB, 0.42397164E-05_JPRB /)

RGHG7(:,18, 1) = (/ &
  & 0.46100449E-05_JPRB, 0.46689265E-05_JPRB, 0.47440740E-05_JPRB, 0.48491042E-05_JPRB, 0.49929090E-05_JPRB, 0.51830493E-05_JPRB, &
  & 0.54244629E-05_JPRB, 0.57107050E-05_JPRB, 0.60005973E-05_JPRB, 0.62888298E-05_JPRB, 0.65732620E-05_JPRB, 0.68487129E-05_JPRB, &
  & 0.71222080E-05_JPRB, 0.73868900E-05_JPRB, 0.76466913E-05_JPRB, 0.79054871E-05_JPRB, 0.81513426E-05_JPRB, 0.83830919E-05_JPRB, &
  & 0.86056471E-05_JPRB, 0.88013940E-05_JPRB, 0.89710011E-05_JPRB, 0.91127040E-05_JPRB, 0.92269911E-05_JPRB, 0.93158314E-05_JPRB, &
  & 0.93799663E-05_JPRB, 0.94037523E-05_JPRB, 0.93887447E-05_JPRB, 0.93358112E-05_JPRB, 0.92577220E-05_JPRB, 0.91562943E-05_JPRB, &
  & 0.90446129E-05_JPRB, 0.89292207E-05_JPRB, 0.88207717E-05_JPRB, 0.87037379E-05_JPRB, 0.85808633E-05_JPRB, 0.84587400E-05_JPRB, &
  & 0.83268369E-05_JPRB, 0.81862800E-05_JPRB, 0.80389782E-05_JPRB, 0.78848616E-05_JPRB, 0.77152590E-05_JPRB, 0.75323701E-05_JPRB, &
  & 0.73405913E-05_JPRB, 0.71456179E-05_JPRB, 0.69486928E-05_JPRB, 0.67499072E-05_JPRB, 0.65433110E-05_JPRB, 0.63289140E-05_JPRB, &
  & 0.61074115E-05_JPRB, 0.58818873E-05_JPRB, 0.56556178E-05_JPRB, 0.54309817E-05_JPRB, 0.52144960E-05_JPRB, 0.50134454E-05_JPRB, &
  & 0.48401525E-05_JPRB, 0.47211547E-05_JPRB, 0.46508685E-05_JPRB, 0.46079394E-05_JPRB, 0.45753313E-05_JPRB, 0.45466663E-05_JPRB, &
  & 0.45233405E-05_JPRB, 0.44979429E-05_JPRB, 0.44683716E-05_JPRB, 0.44112803E-05_JPRB /)

RGHG7(:,19, 1) = (/ &
  & 0.45870938E-05_JPRB, 0.46447840E-05_JPRB, 0.47173544E-05_JPRB, 0.48189977E-05_JPRB, 0.49595983E-05_JPRB, 0.51477887E-05_JPRB, &
  & 0.53896820E-05_JPRB, 0.56775993E-05_JPRB, 0.59740578E-05_JPRB, 0.62705149E-05_JPRB, 0.65626455E-05_JPRB, 0.68450713E-05_JPRB, &
  & 0.71203317E-05_JPRB, 0.73822944E-05_JPRB, 0.76333554E-05_JPRB, 0.78732428E-05_JPRB, 0.80955997E-05_JPRB, 0.82999022E-05_JPRB, &
  & 0.84884423E-05_JPRB, 0.86526525E-05_JPRB, 0.87969602E-05_JPRB, 0.89207924E-05_JPRB, 0.90273943E-05_JPRB, 0.91183238E-05_JPRB, &
  & 0.91904685E-05_JPRB, 0.92286582E-05_JPRB, 0.92325681E-05_JPRB, 0.92033570E-05_JPRB, 0.91453021E-05_JPRB, 0.90697722E-05_JPRB, &
  & 0.89816158E-05_JPRB, 0.88904826E-05_JPRB, 0.88016368E-05_JPRB, 0.86984992E-05_JPRB, 0.85850570E-05_JPRB, 0.84573276E-05_JPRB, &
  & 0.83212244E-05_JPRB, 0.81740400E-05_JPRB, 0.80172895E-05_JPRB, 0.78547946E-05_JPRB, 0.76803399E-05_JPRB, 0.75007847E-05_JPRB, &
  & 0.73187362E-05_JPRB, 0.71355744E-05_JPRB, 0.69508033E-05_JPRB, 0.67649685E-05_JPRB, 0.65739378E-05_JPRB, 0.63757252E-05_JPRB, &
  & 0.61711326E-05_JPRB, 0.59619688E-05_JPRB, 0.57514835E-05_JPRB, 0.55424362E-05_JPRB, 0.53434737E-05_JPRB, 0.51627858E-05_JPRB, &
  & 0.50184722E-05_JPRB, 0.49224532E-05_JPRB, 0.48600677E-05_JPRB, 0.48195902E-05_JPRB, 0.47847875E-05_JPRB, 0.47538665E-05_JPRB, &
  & 0.47267422E-05_JPRB, 0.46976443E-05_JPRB, 0.46618288E-05_JPRB, 0.45960783E-05_JPRB /)

RGHG7(:,20, 1) = (/ &
  & 0.45870624E-05_JPRB, 0.46447876E-05_JPRB, 0.47140247E-05_JPRB, 0.48097140E-05_JPRB, 0.49418295E-05_JPRB, 0.51191187E-05_JPRB, &
  & 0.53466301E-05_JPRB, 0.56185818E-05_JPRB, 0.58996397E-05_JPRB, 0.61788442E-05_JPRB, 0.64506789E-05_JPRB, 0.67086830E-05_JPRB, &
  & 0.69540647E-05_JPRB, 0.71808076E-05_JPRB, 0.73927326E-05_JPRB, 0.75879243E-05_JPRB, 0.77617633E-05_JPRB, 0.79209822E-05_JPRB, &
  & 0.80695208E-05_JPRB, 0.82028682E-05_JPRB, 0.83307268E-05_JPRB, 0.84557778E-05_JPRB, 0.85786260E-05_JPRB, 0.86985765E-05_JPRB, &
  & 0.88086772E-05_JPRB, 0.88881843E-05_JPRB, 0.89325067E-05_JPRB, 0.89370524E-05_JPRB, 0.89119412E-05_JPRB, 0.88606930E-05_JPRB, &
  & 0.87908929E-05_JPRB, 0.87071840E-05_JPRB, 0.86196960E-05_JPRB, 0.85120500E-05_JPRB, 0.83896739E-05_JPRB, 0.82529177E-05_JPRB, &
  & 0.81013495E-05_JPRB, 0.79419933E-05_JPRB, 0.77781060E-05_JPRB, 0.76221818E-05_JPRB, 0.74656059E-05_JPRB, 0.73124315E-05_JPRB, &
  & 0.71580071E-05_JPRB, 0.70053106E-05_JPRB, 0.68506297E-05_JPRB, 0.66943667E-05_JPRB, 0.65322047E-05_JPRB, 0.63625844E-05_JPRB, &
  & 0.61868409E-05_JPRB, 0.60059874E-05_JPRB, 0.58223968E-05_JPRB, 0.56400809E-05_JPRB, 0.54679381E-05_JPRB, 0.53166104E-05_JPRB, &
  & 0.52049950E-05_JPRB, 0.51284551E-05_JPRB, 0.50754425E-05_JPRB, 0.50364806E-05_JPRB, 0.50013409E-05_JPRB, 0.49694281E-05_JPRB, &
  & 0.49394434E-05_JPRB, 0.49066261E-05_JPRB, 0.48672132E-05_JPRB, 0.47874232E-05_JPRB /)

RGHG7(:,21, 1) = (/ &
  & 0.45742331E-05_JPRB, 0.46335308E-05_JPRB, 0.46965183E-05_JPRB, 0.47816670E-05_JPRB, 0.48985617E-05_JPRB, 0.50551121E-05_JPRB, &
  & 0.52555656E-05_JPRB, 0.54928278E-05_JPRB, 0.57366528E-05_JPRB, 0.59763474E-05_JPRB, 0.62035447E-05_JPRB, 0.64137098E-05_JPRB, &
  & 0.66064285E-05_JPRB, 0.67783699E-05_JPRB, 0.69336061E-05_JPRB, 0.70750630E-05_JPRB, 0.71983518E-05_JPRB, 0.73132978E-05_JPRB, &
  & 0.74299005E-05_JPRB, 0.75471658E-05_JPRB, 0.76730794E-05_JPRB, 0.78116072E-05_JPRB, 0.79614429E-05_JPRB, 0.81196331E-05_JPRB, &
  & 0.82714751E-05_JPRB, 0.83964987E-05_JPRB, 0.84796593E-05_JPRB, 0.85187457E-05_JPRB, 0.85112715E-05_JPRB, 0.84638341E-05_JPRB, &
  & 0.83851473E-05_JPRB, 0.82832612E-05_JPRB, 0.81713270E-05_JPRB, 0.80379041E-05_JPRB, 0.78921157E-05_JPRB, 0.77386294E-05_JPRB, &
  & 0.75779185E-05_JPRB, 0.74228651E-05_JPRB, 0.72772286E-05_JPRB, 0.71495010E-05_JPRB, 0.70315905E-05_JPRB, 0.69232337E-05_JPRB, &
  & 0.68197201E-05_JPRB, 0.67179421E-05_JPRB, 0.66113062E-05_JPRB, 0.65009390E-05_JPRB, 0.63809011E-05_JPRB, 0.62523218E-05_JPRB, &
  & 0.61160567E-05_JPRB, 0.59720041E-05_JPRB, 0.58237556E-05_JPRB, 0.56779122E-05_JPRB, 0.55446449E-05_JPRB, 0.54343477E-05_JPRB, &
  & 0.53547196E-05_JPRB, 0.52986511E-05_JPRB, 0.52593473E-05_JPRB, 0.52274791E-05_JPRB, 0.51980114E-05_JPRB, 0.51692045E-05_JPRB, &
  & 0.51396792E-05_JPRB, 0.51083553E-05_JPRB, 0.50654812E-05_JPRB, 0.49839477E-05_JPRB /)

RGHG7(:,22, 1) = (/ &
  & 0.45404677E-05_JPRB, 0.45956704E-05_JPRB, 0.46503533E-05_JPRB, 0.47222070E-05_JPRB, 0.48193456E-05_JPRB, 0.49481787E-05_JPRB, &
  & 0.51114171E-05_JPRB, 0.53023218E-05_JPRB, 0.54944167E-05_JPRB, 0.56774338E-05_JPRB, 0.58457172E-05_JPRB, 0.59948115E-05_JPRB, &
  & 0.61266173E-05_JPRB, 0.62393615E-05_JPRB, 0.63387097E-05_JPRB, 0.64308647E-05_JPRB, 0.65166246E-05_JPRB, 0.66034409E-05_JPRB, &
  & 0.66995713E-05_JPRB, 0.68059121E-05_JPRB, 0.69302769E-05_JPRB, 0.70788656E-05_JPRB, 0.72476032E-05_JPRB, 0.74279164E-05_JPRB, &
  & 0.76119213E-05_JPRB, 0.77619288E-05_JPRB, 0.78703933E-05_JPRB, 0.79228066E-05_JPRB, 0.79162974E-05_JPRB, 0.78548892E-05_JPRB, &
  & 0.77482055E-05_JPRB, 0.76113761E-05_JPRB, 0.74588779E-05_JPRB, 0.72931480E-05_JPRB, 0.71242512E-05_JPRB, 0.69607486E-05_JPRB, &
  & 0.68086774E-05_JPRB, 0.66768303E-05_JPRB, 0.65688450E-05_JPRB, 0.64884357E-05_JPRB, 0.64278224E-05_JPRB, 0.63786861E-05_JPRB, &
  & 0.63347479E-05_JPRB, 0.62913591E-05_JPRB, 0.62418771E-05_JPRB, 0.61840210E-05_JPRB, 0.61149481E-05_JPRB, 0.60339275E-05_JPRB, &
  & 0.59416857E-05_JPRB, 0.58399983E-05_JPRB, 0.57337529E-05_JPRB, 0.56308181E-05_JPRB, 0.55419719E-05_JPRB, 0.54751572E-05_JPRB, &
  & 0.54276652E-05_JPRB, 0.53957110E-05_JPRB, 0.53729846E-05_JPRB, 0.53539247E-05_JPRB, 0.53350641E-05_JPRB, 0.53150434E-05_JPRB, &
  & 0.52933947E-05_JPRB, 0.52684027E-05_JPRB, 0.52347386E-05_JPRB, 0.51610691E-05_JPRB /)

RGHG7(:,23, 1) = (/ &
  & 0.44669791E-05_JPRB, 0.45045235E-05_JPRB, 0.45439997E-05_JPRB, 0.45970346E-05_JPRB, 0.46690157E-05_JPRB, 0.47635313E-05_JPRB, &
  & 0.48825950E-05_JPRB, 0.50207941E-05_JPRB, 0.51566085E-05_JPRB, 0.52822793E-05_JPRB, 0.53930917E-05_JPRB, 0.54875327E-05_JPRB, &
  & 0.55684777E-05_JPRB, 0.56370523E-05_JPRB, 0.56982067E-05_JPRB, 0.57568022E-05_JPRB, 0.58139112E-05_JPRB, 0.58766955E-05_JPRB, &
  & 0.59538097E-05_JPRB, 0.60468719E-05_JPRB, 0.61616061E-05_JPRB, 0.62986242E-05_JPRB, 0.64577716E-05_JPRB, 0.66372527E-05_JPRB, &
  & 0.68118857E-05_JPRB, 0.69645471E-05_JPRB, 0.70739193E-05_JPRB, 0.71249196E-05_JPRB, 0.71089817E-05_JPRB, 0.70269662E-05_JPRB, &
  & 0.68999611E-05_JPRB, 0.67380361E-05_JPRB, 0.65606882E-05_JPRB, 0.63790731E-05_JPRB, 0.62066952E-05_JPRB, 0.60534712E-05_JPRB, &
  & 0.59241115E-05_JPRB, 0.58296437E-05_JPRB, 0.57676989E-05_JPRB, 0.57393872E-05_JPRB, 0.57335710E-05_JPRB, 0.57406496E-05_JPRB, &
  & 0.57542670E-05_JPRB, 0.57668753E-05_JPRB, 0.57712405E-05_JPRB, 0.57672564E-05_JPRB, 0.57497664E-05_JPRB, 0.57183456E-05_JPRB, &
  & 0.56739837E-05_JPRB, 0.56182944E-05_JPRB, 0.55587666E-05_JPRB, 0.55011415E-05_JPRB, 0.54575298E-05_JPRB, 0.54280717E-05_JPRB, &
  & 0.54104889E-05_JPRB, 0.54020925E-05_JPRB, 0.53978674E-05_JPRB, 0.53949875E-05_JPRB, 0.53907556E-05_JPRB, 0.53841582E-05_JPRB, &
  & 0.53750000E-05_JPRB, 0.53620820E-05_JPRB, 0.53422668E-05_JPRB, 0.52908567E-05_JPRB /)

RGHG7(:,24, 1) = (/ &
  & 0.43186501E-05_JPRB, 0.43280434E-05_JPRB, 0.43498717E-05_JPRB, 0.43838750E-05_JPRB, 0.44317612E-05_JPRB, 0.44952753E-05_JPRB, &
  & 0.45745592E-05_JPRB, 0.46658247E-05_JPRB, 0.47537119E-05_JPRB, 0.48315942E-05_JPRB, 0.48970883E-05_JPRB, 0.49495670E-05_JPRB, &
  & 0.49921750E-05_JPRB, 0.50272779E-05_JPRB, 0.50591370E-05_JPRB, 0.50937292E-05_JPRB, 0.51336842E-05_JPRB, 0.51828129E-05_JPRB, &
  & 0.52436681E-05_JPRB, 0.53142780E-05_JPRB, 0.53983845E-05_JPRB, 0.55015767E-05_JPRB, 0.56268318E-05_JPRB, 0.57621637E-05_JPRB, &
  & 0.59009749E-05_JPRB, 0.60234470E-05_JPRB, 0.61108231E-05_JPRB, 0.61513770E-05_JPRB, 0.61269534E-05_JPRB, 0.60470429E-05_JPRB, &
  & 0.59201961E-05_JPRB, 0.57610682E-05_JPRB, 0.55931532E-05_JPRB, 0.54264979E-05_JPRB, 0.52751834E-05_JPRB, 0.51494139E-05_JPRB, &
  & 0.50550457E-05_JPRB, 0.50009257E-05_JPRB, 0.49827458E-05_JPRB, 0.49974160E-05_JPRB, 0.50368021E-05_JPRB, 0.50881517E-05_JPRB, &
  & 0.51468874E-05_JPRB, 0.52048249E-05_JPRB, 0.52555033E-05_JPRB, 0.52989221E-05_JPRB, 0.53264666E-05_JPRB, 0.53387289E-05_JPRB, &
  & 0.53367362E-05_JPRB, 0.53231824E-05_JPRB, 0.53059134E-05_JPRB, 0.52900587E-05_JPRB, 0.52832397E-05_JPRB, 0.52842192E-05_JPRB, &
  & 0.52927148E-05_JPRB, 0.53058698E-05_JPRB, 0.53212020E-05_JPRB, 0.53363328E-05_JPRB, 0.53491890E-05_JPRB, 0.53594067E-05_JPRB, &
  & 0.53665476E-05_JPRB, 0.53715171E-05_JPRB, 0.53705207E-05_JPRB, 0.53588105E-05_JPRB /)

RGHG7(:,25, 1) = (/ &
  & 0.40969312E-05_JPRB, 0.40733839E-05_JPRB, 0.40777977E-05_JPRB, 0.40944851E-05_JPRB, 0.41218091E-05_JPRB, 0.41596559E-05_JPRB, &
  & 0.42079455E-05_JPRB, 0.42632705E-05_JPRB, 0.43155346E-05_JPRB, 0.43602345E-05_JPRB, 0.43960567E-05_JPRB, 0.44239919E-05_JPRB, &
  & 0.44462795E-05_JPRB, 0.44646208E-05_JPRB, 0.44848489E-05_JPRB, 0.45084521E-05_JPRB, 0.45331062E-05_JPRB, 0.45596494E-05_JPRB, &
  & 0.45903203E-05_JPRB, 0.46259038E-05_JPRB, 0.46695582E-05_JPRB, 0.47231188E-05_JPRB, 0.47863714E-05_JPRB, 0.48585935E-05_JPRB, &
  & 0.49396112E-05_JPRB, 0.50119315E-05_JPRB, 0.50654789E-05_JPRB, 0.50911585E-05_JPRB, 0.50703848E-05_JPRB, 0.50098465E-05_JPRB, &
  & 0.49097907E-05_JPRB, 0.47885032E-05_JPRB, 0.46563309E-05_JPRB, 0.45280635E-05_JPRB, 0.44158073E-05_JPRB, 0.43279392E-05_JPRB, &
  & 0.42734432E-05_JPRB, 0.42557504E-05_JPRB, 0.42732013E-05_JPRB, 0.43190807E-05_JPRB, 0.43867431E-05_JPRB, 0.44681456E-05_JPRB, &
  & 0.45552961E-05_JPRB, 0.46444629E-05_JPRB, 0.47299509E-05_JPRB, 0.48076772E-05_JPRB, 0.48693455E-05_JPRB, 0.49174464E-05_JPRB, &
  & 0.49518244E-05_JPRB, 0.49744658E-05_JPRB, 0.49923920E-05_JPRB, 0.50106078E-05_JPRB, 0.50318154E-05_JPRB, 0.50571675E-05_JPRB, &
  & 0.50860835E-05_JPRB, 0.51172601E-05_JPRB, 0.51497682E-05_JPRB, 0.51818006E-05_JPRB, 0.52122687E-05_JPRB, 0.52409496E-05_JPRB, &
  & 0.52676605E-05_JPRB, 0.52923488E-05_JPRB, 0.53186932E-05_JPRB, 0.53494605E-05_JPRB /)

RGHG7(:,26, 1) = (/ &
  & 0.38012245E-05_JPRB, 0.37500770E-05_JPRB, 0.37404334E-05_JPRB, 0.37435618E-05_JPRB, 0.37560169E-05_JPRB, 0.37765046E-05_JPRB, &
  & 0.38044191E-05_JPRB, 0.38371209E-05_JPRB, 0.38673197E-05_JPRB, 0.38919807E-05_JPRB, 0.39107599E-05_JPRB, 0.39234519E-05_JPRB, &
  & 0.39338411E-05_JPRB, 0.39424267E-05_JPRB, 0.39505112E-05_JPRB, 0.39587112E-05_JPRB, 0.39679080E-05_JPRB, 0.39791289E-05_JPRB, &
  & 0.39904417E-05_JPRB, 0.39970660E-05_JPRB, 0.39979664E-05_JPRB, 0.39961456E-05_JPRB, 0.39961201E-05_JPRB, 0.40026312E-05_JPRB, &
  & 0.40189830E-05_JPRB, 0.40392842E-05_JPRB, 0.40566269E-05_JPRB, 0.40615346E-05_JPRB, 0.40513792E-05_JPRB, 0.40177824E-05_JPRB, &
  & 0.39627539E-05_JPRB, 0.38908343E-05_JPRB, 0.38088886E-05_JPRB, 0.37312909E-05_JPRB, 0.36640961E-05_JPRB, 0.36176773E-05_JPRB, &
  & 0.36003057E-05_JPRB, 0.36124027E-05_JPRB, 0.36535425E-05_JPRB, 0.37187860E-05_JPRB, 0.38015007E-05_JPRB, 0.38985377E-05_JPRB, &
  & 0.40024870E-05_JPRB, 0.41096750E-05_JPRB, 0.42164538E-05_JPRB, 0.43158248E-05_JPRB, 0.44029944E-05_JPRB, 0.44798203E-05_JPRB, &
  & 0.45416623E-05_JPRB, 0.45934466E-05_JPRB, 0.46381333E-05_JPRB, 0.46809723E-05_JPRB, 0.47227149E-05_JPRB, 0.47652702E-05_JPRB, &
  & 0.48093234E-05_JPRB, 0.48542606E-05_JPRB, 0.49003970E-05_JPRB, 0.49471305E-05_JPRB, 0.49935570E-05_JPRB, 0.50398926E-05_JPRB, &
  & 0.50860003E-05_JPRB, 0.51326620E-05_JPRB, 0.51842089E-05_JPRB, 0.52665469E-05_JPRB /)

RGHG7(:,27, 1) = (/ &
  & 0.34525651E-05_JPRB, 0.33784484E-05_JPRB, 0.33580739E-05_JPRB, 0.33537754E-05_JPRB, 0.33591361E-05_JPRB, 0.33714807E-05_JPRB, &
  & 0.33893807E-05_JPRB, 0.34108673E-05_JPRB, 0.34306356E-05_JPRB, 0.34465420E-05_JPRB, 0.34579680E-05_JPRB, 0.34659686E-05_JPRB, &
  & 0.34706150E-05_JPRB, 0.34739408E-05_JPRB, 0.34777029E-05_JPRB, 0.34829184E-05_JPRB, 0.34859179E-05_JPRB, 0.34830641E-05_JPRB, &
  & 0.34704040E-05_JPRB, 0.34442587E-05_JPRB, 0.34046375E-05_JPRB, 0.33561132E-05_JPRB, 0.33037190E-05_JPRB, 0.32564437E-05_JPRB, &
  & 0.32175697E-05_JPRB, 0.31922389E-05_JPRB, 0.31762954E-05_JPRB, 0.31698264E-05_JPRB, 0.31650222E-05_JPRB, 0.31549696E-05_JPRB, &
  & 0.31362886E-05_JPRB, 0.31118623E-05_JPRB, 0.30782846E-05_JPRB, 0.30499866E-05_JPRB, 0.30256576E-05_JPRB, 0.30169842E-05_JPRB, &
  & 0.30294416E-05_JPRB, 0.30627416E-05_JPRB, 0.31181680E-05_JPRB, 0.31935656E-05_JPRB, 0.32830421E-05_JPRB, 0.33832755E-05_JPRB, &
  & 0.34931634E-05_JPRB, 0.36075876E-05_JPRB, 0.37247305E-05_JPRB, 0.38391863E-05_JPRB, 0.39468691E-05_JPRB, 0.40428986E-05_JPRB, &
  & 0.41245135E-05_JPRB, 0.41963344E-05_JPRB, 0.42607876E-05_JPRB, 0.43197315E-05_JPRB, 0.43761115E-05_JPRB, 0.44304352E-05_JPRB, &
  & 0.44852459E-05_JPRB, 0.45399515E-05_JPRB, 0.45961124E-05_JPRB, 0.46533905E-05_JPRB, 0.47122935E-05_JPRB, 0.47731392E-05_JPRB, &
  & 0.48357501E-05_JPRB, 0.49018863E-05_JPRB, 0.49779128E-05_JPRB, 0.51119587E-05_JPRB /)

RGHG7(:,28, 1) = (/ &
  & 0.30660899E-05_JPRB, 0.29801554E-05_JPRB, 0.29559897E-05_JPRB, 0.29494661E-05_JPRB, 0.29534922E-05_JPRB, 0.29643320E-05_JPRB, &
  & 0.29799874E-05_JPRB, 0.29984972E-05_JPRB, 0.30162712E-05_JPRB, 0.30310525E-05_JPRB, 0.30424453E-05_JPRB, 0.30501305E-05_JPRB, &
  & 0.30570845E-05_JPRB, 0.30616084E-05_JPRB, 0.30644544E-05_JPRB, 0.30640601E-05_JPRB, 0.30569752E-05_JPRB, 0.30398135E-05_JPRB, &
  & 0.30084996E-05_JPRB, 0.29596874E-05_JPRB, 0.28935056E-05_JPRB, 0.28140760E-05_JPRB, 0.27270953E-05_JPRB, 0.26422870E-05_JPRB, &
  & 0.25656093E-05_JPRB, 0.25065906E-05_JPRB, 0.24640194E-05_JPRB, 0.24440355E-05_JPRB, 0.24383335E-05_JPRB, 0.24428339E-05_JPRB, &
  & 0.24507060E-05_JPRB, 0.24618380E-05_JPRB, 0.24675335E-05_JPRB, 0.24788076E-05_JPRB, 0.24906424E-05_JPRB, 0.25123359E-05_JPRB, &
  & 0.25475772E-05_JPRB, 0.25962863E-05_JPRB, 0.26597570E-05_JPRB, 0.27366582E-05_JPRB, 0.28243662E-05_JPRB, 0.29208425E-05_JPRB, &
  & 0.30278868E-05_JPRB, 0.31428485E-05_JPRB, 0.32642122E-05_JPRB, 0.33875970E-05_JPRB, 0.35059174E-05_JPRB, 0.36146780E-05_JPRB, &
  & 0.37116458E-05_JPRB, 0.37981906E-05_JPRB, 0.38759381E-05_JPRB, 0.39459223E-05_JPRB, 0.40121054E-05_JPRB, 0.40745781E-05_JPRB, &
  & 0.41363592E-05_JPRB, 0.41976859E-05_JPRB, 0.42598758E-05_JPRB, 0.43241243E-05_JPRB, 0.43910454E-05_JPRB, 0.44617668E-05_JPRB, &
  & 0.45362713E-05_JPRB, 0.46158534E-05_JPRB, 0.47122794E-05_JPRB, 0.48886413E-05_JPRB /)

RGHG7(:,29, 1) = (/ &
  & 0.26728733E-05_JPRB, 0.25864617E-05_JPRB, 0.25627753E-05_JPRB, 0.25578663E-05_JPRB, 0.25638224E-05_JPRB, 0.25767386E-05_JPRB, &
  & 0.25942247E-05_JPRB, 0.26142034E-05_JPRB, 0.26337661E-05_JPRB, 0.26506430E-05_JPRB, 0.26648393E-05_JPRB, 0.26747896E-05_JPRB, &
  & 0.26812625E-05_JPRB, 0.26854218E-05_JPRB, 0.26859489E-05_JPRB, 0.26809323E-05_JPRB, 0.26673749E-05_JPRB, 0.26416785E-05_JPRB, &
  & 0.26000657E-05_JPRB, 0.25390293E-05_JPRB, 0.24593746E-05_JPRB, 0.23641142E-05_JPRB, 0.22592130E-05_JPRB, 0.21534547E-05_JPRB, &
  & 0.20555917E-05_JPRB, 0.19746287E-05_JPRB, 0.19146378E-05_JPRB, 0.18815862E-05_JPRB, 0.18709039E-05_JPRB, 0.18797357E-05_JPRB, &
  & 0.19008925E-05_JPRB, 0.19331394E-05_JPRB, 0.19655549E-05_JPRB, 0.20043162E-05_JPRB, 0.20433101E-05_JPRB, 0.20869413E-05_JPRB, &
  & 0.21384215E-05_JPRB, 0.21966862E-05_JPRB, 0.22623208E-05_JPRB, 0.23351606E-05_JPRB, 0.24161643E-05_JPRB, 0.25060501E-05_JPRB, &
  & 0.26067705E-05_JPRB, 0.27184030E-05_JPRB, 0.28394845E-05_JPRB, 0.29656662E-05_JPRB, 0.30902752E-05_JPRB, 0.32074113E-05_JPRB, &
  & 0.33144697E-05_JPRB, 0.34103700E-05_JPRB, 0.34962654E-05_JPRB, 0.35738533E-05_JPRB, 0.36456524E-05_JPRB, 0.37137800E-05_JPRB, &
  & 0.37800019E-05_JPRB, 0.38453691E-05_JPRB, 0.39116308E-05_JPRB, 0.39800552E-05_JPRB, 0.40519935E-05_JPRB, 0.41282178E-05_JPRB, &
  & 0.42092529E-05_JPRB, 0.42963511E-05_JPRB, 0.44038088E-05_JPRB, 0.46069927E-05_JPRB /)

RGHG7(:,30, 1) = (/ &
  & 0.22941381E-05_JPRB, 0.22182085E-05_JPRB, 0.21990754E-05_JPRB, 0.21980836E-05_JPRB, 0.22078766E-05_JPRB, 0.22243753E-05_JPRB, &
  & 0.22452173E-05_JPRB, 0.22680458E-05_JPRB, 0.22903764E-05_JPRB, 0.23100215E-05_JPRB, 0.23265750E-05_JPRB, 0.23394869E-05_JPRB, &
  & 0.23480591E-05_JPRB, 0.23515170E-05_JPRB, 0.23497760E-05_JPRB, 0.23414932E-05_JPRB, 0.23233640E-05_JPRB, 0.22921554E-05_JPRB, &
  & 0.22445565E-05_JPRB, 0.21778071E-05_JPRB, 0.20920281E-05_JPRB, 0.19908582E-05_JPRB, 0.18799996E-05_JPRB, 0.17662206E-05_JPRB, &
  & 0.16593043E-05_JPRB, 0.15673577E-05_JPRB, 0.14967560E-05_JPRB, 0.14531552E-05_JPRB, 0.14355984E-05_JPRB, 0.14420319E-05_JPRB, &
  & 0.14666375E-05_JPRB, 0.15078509E-05_JPRB, 0.15553104E-05_JPRB, 0.16101894E-05_JPRB, 0.16665787E-05_JPRB, 0.17241917E-05_JPRB, &
  & 0.17847643E-05_JPRB, 0.18463802E-05_JPRB, 0.19102504E-05_JPRB, 0.19779532E-05_JPRB, 0.20517780E-05_JPRB, 0.21343594E-05_JPRB, &
  & 0.22282525E-05_JPRB, 0.23346504E-05_JPRB, 0.24527521E-05_JPRB, 0.25783338E-05_JPRB, 0.27052597E-05_JPRB, 0.28273062E-05_JPRB, &
  & 0.29393889E-05_JPRB, 0.30404240E-05_JPRB, 0.31309660E-05_JPRB, 0.32131802E-05_JPRB, 0.32894252E-05_JPRB, 0.33612107E-05_JPRB, &
  & 0.34304589E-05_JPRB, 0.34987365E-05_JPRB, 0.35675941E-05_JPRB, 0.36387694E-05_JPRB, 0.37132013E-05_JPRB, 0.37921195E-05_JPRB, &
  & 0.38745925E-05_JPRB, 0.39644915E-05_JPRB, 0.40720583E-05_JPRB, 0.42888864E-05_JPRB /)

RGHG7(:,31, 1) = (/ &
  & 0.19539680E-05_JPRB, 0.18938313E-05_JPRB, 0.18811639E-05_JPRB, 0.18845677E-05_JPRB, 0.18975684E-05_JPRB, 0.19172119E-05_JPRB, &
  & 0.19407739E-05_JPRB, 0.19658530E-05_JPRB, 0.19899803E-05_JPRB, 0.20112993E-05_JPRB, 0.20292518E-05_JPRB, 0.20427567E-05_JPRB, &
  & 0.20516406E-05_JPRB, 0.20552463E-05_JPRB, 0.20522709E-05_JPRB, 0.20412429E-05_JPRB, 0.20189318E-05_JPRB, 0.19831284E-05_JPRB, &
  & 0.19313527E-05_JPRB, 0.18623601E-05_JPRB, 0.17765432E-05_JPRB, 0.16762565E-05_JPRB, 0.15664164E-05_JPRB, 0.14538123E-05_JPRB, &
  & 0.13463338E-05_JPRB, 0.12512928E-05_JPRB, 0.11759856E-05_JPRB, 0.11254642E-05_JPRB, 0.11009267E-05_JPRB, 0.11019019E-05_JPRB, &
  & 0.11239933E-05_JPRB, 0.11655626E-05_JPRB, 0.12188722E-05_JPRB, 0.12805160E-05_JPRB, 0.13456091E-05_JPRB, 0.14100142E-05_JPRB, &
  & 0.14742322E-05_JPRB, 0.15359457E-05_JPRB, 0.15967341E-05_JPRB, 0.16591496E-05_JPRB, 0.17264884E-05_JPRB, 0.18023834E-05_JPRB, &
  & 0.18902185E-05_JPRB, 0.19915428E-05_JPRB, 0.21055528E-05_JPRB, 0.22286661E-05_JPRB, 0.23548998E-05_JPRB, 0.24768069E-05_JPRB, &
  & 0.25911120E-05_JPRB, 0.26942353E-05_JPRB, 0.27873098E-05_JPRB, 0.28723521E-05_JPRB, 0.29509383E-05_JPRB, 0.30255169E-05_JPRB, &
  & 0.30970373E-05_JPRB, 0.31676841E-05_JPRB, 0.32383903E-05_JPRB, 0.33111080E-05_JPRB, 0.33869132E-05_JPRB, 0.34659959E-05_JPRB, &
  & 0.35485018E-05_JPRB, 0.36347108E-05_JPRB, 0.37437571E-05_JPRB, 0.39531838E-05_JPRB /)

RGHG7(:,32, 1) = (/ &
  & 0.16667053E-05_JPRB, 0.16230578E-05_JPRB, 0.16166481E-05_JPRB, 0.16231297E-05_JPRB, 0.16382671E-05_JPRB, 0.16590774E-05_JPRB, &
  & 0.16835618E-05_JPRB, 0.17089747E-05_JPRB, 0.17331423E-05_JPRB, 0.17545512E-05_JPRB, 0.17722358E-05_JPRB, 0.17854397E-05_JPRB, &
  & 0.17935931E-05_JPRB, 0.17953230E-05_JPRB, 0.17894010E-05_JPRB, 0.17745264E-05_JPRB, 0.17480213E-05_JPRB, 0.17084908E-05_JPRB, &
  & 0.16543963E-05_JPRB, 0.15846621E-05_JPRB, 0.15006540E-05_JPRB, 0.14044649E-05_JPRB, 0.13004300E-05_JPRB, 0.11934484E-05_JPRB, &
  & 0.10909778E-05_JPRB, 0.99902911E-06_JPRB, 0.92367605E-06_JPRB, 0.86982419E-06_JPRB, 0.83985248E-06_JPRB, 0.83463630E-06_JPRB, &
  & 0.85085253E-06_JPRB, 0.88785436E-06_JPRB, 0.93984329E-06_JPRB, 0.10013233E-05_JPRB, 0.10679153E-05_JPRB, 0.11334835E-05_JPRB, &
  & 0.11969437E-05_JPRB, 0.12567325E-05_JPRB, 0.13140498E-05_JPRB, 0.13721248E-05_JPRB, 0.14346145E-05_JPRB, 0.15058844E-05_JPRB, &
  & 0.15894078E-05_JPRB, 0.16868743E-05_JPRB, 0.17973882E-05_JPRB, 0.19169624E-05_JPRB, 0.20398440E-05_JPRB, 0.21602434E-05_JPRB, &
  & 0.22728839E-05_JPRB, 0.23759367E-05_JPRB, 0.24696662E-05_JPRB, 0.25559070E-05_JPRB, 0.26361022E-05_JPRB, 0.27121691E-05_JPRB, &
  & 0.27855820E-05_JPRB, 0.28576717E-05_JPRB, 0.29296691E-05_JPRB, 0.30033268E-05_JPRB, 0.30793119E-05_JPRB, 0.31578643E-05_JPRB, &
  & 0.32377723E-05_JPRB, 0.33232027E-05_JPRB, 0.34235459E-05_JPRB, 0.36276542E-05_JPRB /)

RGHG7(:,33, 1) = (/ &
  & 0.14349667E-05_JPRB, 0.14056167E-05_JPRB, 0.14035282E-05_JPRB, 0.14114931E-05_JPRB, 0.14271068E-05_JPRB, 0.14473995E-05_JPRB, &
  & 0.14707927E-05_JPRB, 0.14947203E-05_JPRB, 0.15169370E-05_JPRB, 0.15365664E-05_JPRB, 0.15521330E-05_JPRB, 0.15631310E-05_JPRB, &
  & 0.15689701E-05_JPRB, 0.15682964E-05_JPRB, 0.15589221E-05_JPRB, 0.15397325E-05_JPRB, 0.15085991E-05_JPRB, 0.14648148E-05_JPRB, &
  & 0.14079158E-05_JPRB, 0.13379008E-05_JPRB, 0.12565295E-05_JPRB, 0.11655628E-05_JPRB, 0.10681591E-05_JPRB, 0.96998701E-06_JPRB, &
  & 0.87571107E-06_JPRB, 0.79067860E-06_JPRB, 0.71927610E-06_JPRB, 0.66564365E-06_JPRB, 0.63234285E-06_JPRB, 0.62170886E-06_JPRB, &
  & 0.63082933E-06_JPRB, 0.66053701E-06_JPRB, 0.70603039E-06_JPRB, 0.76230464E-06_JPRB, 0.82493693E-06_JPRB, 0.88730582E-06_JPRB, &
  & 0.94762731E-06_JPRB, 0.10039208E-05_JPRB, 0.10574008E-05_JPRB, 0.11116454E-05_JPRB, 0.11711804E-05_JPRB, 0.12403329E-05_JPRB, &
  & 0.13220955E-05_JPRB, 0.14178245E-05_JPRB, 0.15255677E-05_JPRB, 0.16417283E-05_JPRB, 0.17609112E-05_JPRB, 0.18772207E-05_JPRB, &
  & 0.19869890E-05_JPRB, 0.20878406E-05_JPRB, 0.21805317E-05_JPRB, 0.22664447E-05_JPRB, 0.23470323E-05_JPRB, 0.24242502E-05_JPRB, &
  & 0.24986496E-05_JPRB, 0.25716211E-05_JPRB, 0.26442547E-05_JPRB, 0.27182457E-05_JPRB, 0.27938686E-05_JPRB, 0.28710540E-05_JPRB, &
  & 0.29496969E-05_JPRB, 0.30304830E-05_JPRB, 0.31308612E-05_JPRB, 0.33228050E-05_JPRB /)

RGHG7(:,34, 1) = (/ &
  & 0.12533562E-05_JPRB, 0.12339251E-05_JPRB, 0.12346189E-05_JPRB, 0.12426808E-05_JPRB, 0.12573437E-05_JPRB, 0.12756101E-05_JPRB, &
  & 0.12964441E-05_JPRB, 0.13174198E-05_JPRB, 0.13363552E-05_JPRB, 0.13526901E-05_JPRB, 0.13648229E-05_JPRB, 0.13727189E-05_JPRB, &
  & 0.13751995E-05_JPRB, 0.13708008E-05_JPRB, 0.13577368E-05_JPRB, 0.13340995E-05_JPRB, 0.12981934E-05_JPRB, 0.12498169E-05_JPRB, &
  & 0.11892992E-05_JPRB, 0.11189467E-05_JPRB, 0.10392270E-05_JPRB, 0.95216024E-06_JPRB, 0.86230619E-06_JPRB, 0.77329099E-06_JPRB, &
  & 0.68957922E-06_JPRB, 0.61403102E-06_JPRB, 0.54987441E-06_JPRB, 0.49978740E-06_JPRB, 0.46655313E-06_JPRB, 0.45195782E-06_JPRB, &
  & 0.45455658E-06_JPRB, 0.47576557E-06_JPRB, 0.51131622E-06_JPRB, 0.55878928E-06_JPRB, 0.61308975E-06_JPRB, 0.66860537E-06_JPRB, &
  & 0.72303544E-06_JPRB, 0.77420719E-06_JPRB, 0.82363908E-06_JPRB, 0.87518134E-06_JPRB, 0.93312531E-06_JPRB, 0.10020967E-05_JPRB, &
  & 0.10846110E-05_JPRB, 0.11803547E-05_JPRB, 0.12872930E-05_JPRB, 0.14004905E-05_JPRB, 0.15150893E-05_JPRB, 0.16270362E-05_JPRB, &
  & 0.17321862E-05_JPRB, 0.18301572E-05_JPRB, 0.19208578E-05_JPRB, 0.20056223E-05_JPRB, 0.20863174E-05_JPRB, 0.21633525E-05_JPRB, &
  & 0.22381676E-05_JPRB, 0.23112318E-05_JPRB, 0.23843274E-05_JPRB, 0.24578428E-05_JPRB, 0.25326824E-05_JPRB, 0.26086129E-05_JPRB, &
  & 0.26851653E-05_JPRB, 0.27659314E-05_JPRB, 0.28605577E-05_JPRB, 0.30467311E-05_JPRB /)

RGHG7(:,35, 1) = (/ &
  & 0.11113782E-05_JPRB, 0.10983013E-05_JPRB, 0.11002212E-05_JPRB, 0.11074566E-05_JPRB, 0.11201373E-05_JPRB, 0.11357262E-05_JPRB, &
  & 0.11530790E-05_JPRB, 0.11702144E-05_JPRB, 0.11851577E-05_JPRB, 0.11973699E-05_JPRB, 0.12056178E-05_JPRB, 0.12099274E-05_JPRB, &
  & 0.12090103E-05_JPRB, 0.12010123E-05_JPRB, 0.11837457E-05_JPRB, 0.11550217E-05_JPRB, 0.11141151E-05_JPRB, 0.10608848E-05_JPRB, &
  & 0.99701174E-06_JPRB, 0.92474596E-06_JPRB, 0.84537390E-06_JPRB, 0.76238416E-06_JPRB, 0.67945217E-06_JPRB, 0.60044925E-06_JPRB, &
  & 0.52813789E-06_JPRB, 0.46450796E-06_JPRB, 0.41097476E-06_JPRB, 0.36815305E-06_JPRB, 0.33889268E-06_JPRB, 0.32331093E-06_JPRB, &
  & 0.32194117E-06_JPRB, 0.33471818E-06_JPRB, 0.36003254E-06_JPRB, 0.39622148E-06_JPRB, 0.43900565E-06_JPRB, 0.48497299E-06_JPRB, &
  & 0.53084540E-06_JPRB, 0.57506298E-06_JPRB, 0.61947850E-06_JPRB, 0.66771196E-06_JPRB, 0.72400525E-06_JPRB, 0.79276776E-06_JPRB, &
  & 0.87594003E-06_JPRB, 0.97300153E-06_JPRB, 0.10791949E-05_JPRB, 0.11896041E-05_JPRB, 0.13004886E-05_JPRB, 0.14070541E-05_JPRB, &
  & 0.15082688E-05_JPRB, 0.16024517E-05_JPRB, 0.16907040E-05_JPRB, 0.17742564E-05_JPRB, 0.18540157E-05_JPRB, 0.19308361E-05_JPRB, &
  & 0.20051430E-05_JPRB, 0.20782172E-05_JPRB, 0.21506219E-05_JPRB, 0.22236159E-05_JPRB, 0.22972515E-05_JPRB, 0.23717189E-05_JPRB, &
  & 0.24471512E-05_JPRB, 0.25249897E-05_JPRB, 0.26193618E-05_JPRB, 0.27994133E-05_JPRB /)

RGHG7(:,36, 1) = (/ &
  & 0.99911290E-06_JPRB, 0.98988357E-06_JPRB, 0.99180863E-06_JPRB, 0.99759677E-06_JPRB, 0.10077176E-05_JPRB, 0.10201559E-05_JPRB, &
  & 0.10336915E-05_JPRB, 0.10466098E-05_JPRB, 0.10573870E-05_JPRB, 0.10653041E-05_JPRB, 0.10696644E-05_JPRB, 0.10704706E-05_JPRB, &
  & 0.10661173E-05_JPRB, 0.10547933E-05_JPRB, 0.10340003E-05_JPRB, 0.10017205E-05_JPRB, 0.95589087E-06_JPRB, 0.89746356E-06_JPRB, &
  & 0.82912914E-06_JPRB, 0.75364409E-06_JPRB, 0.67431392E-06_JPRB, 0.59509478E-06_JPRB, 0.52010063E-06_JPRB, 0.45269297E-06_JPRB, &
  & 0.39438325E-06_JPRB, 0.34504552E-06_JPRB, 0.30451784E-06_JPRB, 0.27219596E-06_JPRB, 0.24957137E-06_JPRB, 0.23609157E-06_JPRB, &
  & 0.23337667E-06_JPRB, 0.24024214E-06_JPRB, 0.25752732E-06_JPRB, 0.28297836E-06_JPRB, 0.31492047E-06_JPRB, 0.35039866E-06_JPRB, &
  & 0.38681225E-06_JPRB, 0.42340395E-06_JPRB, 0.46138362E-06_JPRB, 0.50371085E-06_JPRB, 0.55507780E-06_JPRB, 0.61994234E-06_JPRB, &
  & 0.70054148E-06_JPRB, 0.79545117E-06_JPRB, 0.89964072E-06_JPRB, 0.10075588E-05_JPRB, 0.11137290E-05_JPRB, 0.12161433E-05_JPRB, &
  & 0.13125276E-05_JPRB, 0.14035562E-05_JPRB, 0.14897289E-05_JPRB, 0.15716674E-05_JPRB, 0.16503866E-05_JPRB, 0.17260720E-05_JPRB, &
  & 0.17996961E-05_JPRB, 0.18718027E-05_JPRB, 0.19434683E-05_JPRB, 0.20150933E-05_JPRB, 0.20874718E-05_JPRB, 0.21603762E-05_JPRB, &
  & 0.22339034E-05_JPRB, 0.23107657E-05_JPRB, 0.24017465E-05_JPRB, 0.25750833E-05_JPRB /)

RGHG7(:,37, 1) = (/ &
  & 0.90862005E-06_JPRB, 0.90130129E-06_JPRB, 0.90261329E-06_JPRB, 0.90667305E-06_JPRB, 0.91404240E-06_JPRB, 0.92300252E-06_JPRB, &
  & 0.93259916E-06_JPRB, 0.94129308E-06_JPRB, 0.94787401E-06_JPRB, 0.95181923E-06_JPRB, 0.95266290E-06_JPRB, 0.95038922E-06_JPRB, &
  & 0.94314225E-06_JPRB, 0.92937114E-06_JPRB, 0.90503011E-06_JPRB, 0.86851901E-06_JPRB, 0.81888373E-06_JPRB, 0.75632329E-06_JPRB, &
  & 0.68375584E-06_JPRB, 0.60579805E-06_JPRB, 0.52788005E-06_JPRB, 0.45466192E-06_JPRB, 0.39104251E-06_JPRB, 0.33781913E-06_JPRB, &
  & 0.29481063E-06_JPRB, 0.25989328E-06_JPRB, 0.23204137E-06_JPRB, 0.20936895E-06_JPRB, 0.19319094E-06_JPRB, 0.18286711E-06_JPRB, &
  & 0.17970200E-06_JPRB, 0.18379522E-06_JPRB, 0.19542144E-06_JPRB, 0.21377599E-06_JPRB, 0.23758243E-06_JPRB, 0.26462340E-06_JPRB, &
  & 0.29335177E-06_JPRB, 0.32308412E-06_JPRB, 0.35446556E-06_JPRB, 0.39006082E-06_JPRB, 0.43369872E-06_JPRB, 0.48989216E-06_JPRB, &
  & 0.56206704E-06_JPRB, 0.65004474E-06_JPRB, 0.74923366E-06_JPRB, 0.85230090E-06_JPRB, 0.95390646E-06_JPRB, 0.10510349E-05_JPRB, &
  & 0.11436524E-05_JPRB, 0.12315093E-05_JPRB, 0.13152783E-05_JPRB, 0.13957267E-05_JPRB, 0.14731320E-05_JPRB, 0.15477995E-05_JPRB, &
  & 0.16198081E-05_JPRB, 0.16901121E-05_JPRB, 0.17596237E-05_JPRB, 0.18296976E-05_JPRB, 0.19003307E-05_JPRB, 0.19717295E-05_JPRB, &
  & 0.20435778E-05_JPRB, 0.21178257E-05_JPRB, 0.22052477E-05_JPRB, 0.23725663E-05_JPRB /)

RGHG7(:,38, 1) = (/ &
  & 0.83360749E-06_JPRB, 0.82692424E-06_JPRB, 0.82714143E-06_JPRB, 0.82936668E-06_JPRB, 0.83388102E-06_JPRB, 0.83958639E-06_JPRB, &
  & 0.84521599E-06_JPRB, 0.84990364E-06_JPRB, 0.85260359E-06_JPRB, 0.85310631E-06_JPRB, 0.85107524E-06_JPRB, 0.84632546E-06_JPRB, &
  & 0.83711865E-06_JPRB, 0.82130936E-06_JPRB, 0.79571413E-06_JPRB, 0.75616623E-06_JPRB, 0.70269442E-06_JPRB, 0.63676595E-06_JPRB, &
  & 0.56193375E-06_JPRB, 0.48420344E-06_JPRB, 0.41140692E-06_JPRB, 0.34905526E-06_JPRB, 0.29862196E-06_JPRB, 0.25954236E-06_JPRB, &
  & 0.22962597E-06_JPRB, 0.20542828E-06_JPRB, 0.18651131E-06_JPRB, 0.17069682E-06_JPRB, 0.15868746E-06_JPRB, 0.15091686E-06_JPRB, &
  & 0.14764815E-06_JPRB, 0.15028925E-06_JPRB, 0.15853608E-06_JPRB, 0.17258732E-06_JPRB, 0.19101724E-06_JPRB, 0.21256585E-06_JPRB, &
  & 0.23587091E-06_JPRB, 0.26033382E-06_JPRB, 0.28647278E-06_JPRB, 0.31615002E-06_JPRB, 0.35266589E-06_JPRB, 0.40007828E-06_JPRB, &
  & 0.46177095E-06_JPRB, 0.53927215E-06_JPRB, 0.62880684E-06_JPRB, 0.72424621E-06_JPRB, 0.81922855E-06_JPRB, 0.91149059E-06_JPRB, &
  & 0.99964325E-06_JPRB, 0.10842316E-05_JPRB, 0.11659597E-05_JPRB, 0.12447302E-05_JPRB, 0.13205637E-05_JPRB, 0.13927448E-05_JPRB, &
  & 0.14618161E-05_JPRB, 0.15290951E-05_JPRB, 0.15956887E-05_JPRB, 0.16630534E-05_JPRB, 0.17317267E-05_JPRB, 0.18015430E-05_JPRB, &
  & 0.18716772E-05_JPRB, 0.19433510E-05_JPRB, 0.20273569E-05_JPRB, 0.21842329E-05_JPRB /)

RGHG7(:,39, 1) = (/ &
  & 0.76924039E-06_JPRB, 0.76239860E-06_JPRB, 0.76138747E-06_JPRB, 0.76185773E-06_JPRB, 0.76386652E-06_JPRB, 0.76626361E-06_JPRB, &
  & 0.76840490E-06_JPRB, 0.76947424E-06_JPRB, 0.76883560E-06_JPRB, 0.76657614E-06_JPRB, 0.76243191E-06_JPRB, 0.75587519E-06_JPRB, &
  & 0.74567771E-06_JPRB, 0.72875417E-06_JPRB, 0.70207085E-06_JPRB, 0.66186976E-06_JPRB, 0.60622187E-06_JPRB, 0.53798465E-06_JPRB, &
  & 0.46373563E-06_JPRB, 0.39116875E-06_JPRB, 0.32779818E-06_JPRB, 0.27716212E-06_JPRB, 0.23925350E-06_JPRB, 0.21039440E-06_JPRB, &
  & 0.18908777E-06_JPRB, 0.17162789E-06_JPRB, 0.15786379E-06_JPRB, 0.14613548E-06_JPRB, 0.13674423E-06_JPRB, 0.13036025E-06_JPRB, &
  & 0.12732045E-06_JPRB, 0.12889818E-06_JPRB, 0.13523504E-06_JPRB, 0.14647887E-06_JPRB, 0.16157823E-06_JPRB, 0.17945253E-06_JPRB, &
  & 0.19892188E-06_JPRB, 0.21964529E-06_JPRB, 0.24193349E-06_JPRB, 0.26726957E-06_JPRB, 0.29820544E-06_JPRB, 0.33803931E-06_JPRB, &
  & 0.39038414E-06_JPRB, 0.45664055E-06_JPRB, 0.53549718E-06_JPRB, 0.62109086E-06_JPRB, 0.70907902E-06_JPRB, 0.79492827E-06_JPRB, &
  & 0.87834513E-06_JPRB, 0.95970404E-06_JPRB, 0.10387967E-05_JPRB, 0.11154417E-05_JPRB, 0.11886253E-05_JPRB, 0.12576376E-05_JPRB, &
  & 0.13230863E-05_JPRB, 0.13857469E-05_JPRB, 0.14480171E-05_JPRB, 0.15115570E-05_JPRB, 0.15776618E-05_JPRB, 0.16456660E-05_JPRB, &
  & 0.17138645E-05_JPRB, 0.17829428E-05_JPRB, 0.18617536E-05_JPRB, 0.20101475E-05_JPRB /)

RGHG7(:,40, 1) = (/ &
  & 0.71229226E-06_JPRB, 0.70497589E-06_JPRB, 0.70288627E-06_JPRB, 0.70175264E-06_JPRB, 0.70135764E-06_JPRB, 0.70102561E-06_JPRB, &
  & 0.69995673E-06_JPRB, 0.69801882E-06_JPRB, 0.69482752E-06_JPRB, 0.69041835E-06_JPRB, 0.68503346E-06_JPRB, 0.67720816E-06_JPRB, &
  & 0.66658401E-06_JPRB, 0.64981054E-06_JPRB, 0.62276479E-06_JPRB, 0.58156240E-06_JPRB, 0.52602405E-06_JPRB, 0.45911085E-06_JPRB, &
  & 0.38814693E-06_JPRB, 0.32348888E-06_JPRB, 0.27077783E-06_JPRB, 0.23057810E-06_JPRB, 0.20134473E-06_JPRB, 0.17942764E-06_JPRB, &
  & 0.16294713E-06_JPRB, 0.14962465E-06_JPRB, 0.13867886E-06_JPRB, 0.12929307E-06_JPRB, 0.12153869E-06_JPRB, 0.11594845E-06_JPRB, &
  & 0.11314836E-06_JPRB, 0.11402499E-06_JPRB, 0.11914276E-06_JPRB, 0.12852330E-06_JPRB, 0.14142485E-06_JPRB, 0.15676798E-06_JPRB, &
  & 0.17360968E-06_JPRB, 0.19162997E-06_JPRB, 0.21117697E-06_JPRB, 0.23348929E-06_JPRB, 0.26042576E-06_JPRB, 0.29482214E-06_JPRB, &
  & 0.33939384E-06_JPRB, 0.39627241E-06_JPRB, 0.46444174E-06_JPRB, 0.54092726E-06_JPRB, 0.61976283E-06_JPRB, 0.69890928E-06_JPRB, &
  & 0.77720455E-06_JPRB, 0.85429923E-06_JPRB, 0.93044702E-06_JPRB, 0.10045217E-05_JPRB, 0.10747483E-05_JPRB, 0.11401588E-05_JPRB, &
  & 0.12002661E-05_JPRB, 0.12576317E-05_JPRB, 0.13143457E-05_JPRB, 0.13731249E-05_JPRB, 0.14354423E-05_JPRB, 0.15007347E-05_JPRB, &
  & 0.15665846E-05_JPRB, 0.16322685E-05_JPRB, 0.17070744E-05_JPRB, 0.18446758E-05_JPRB /)

RGHG7(:,41, 1) = (/ &
  & 0.66080042E-06_JPRB, 0.65299497E-06_JPRB, 0.64984994E-06_JPRB, 0.64743028E-06_JPRB, 0.64510363E-06_JPRB, 0.64223178E-06_JPRB, &
  & 0.63868691E-06_JPRB, 0.63437204E-06_JPRB, 0.62928899E-06_JPRB, 0.62360795E-06_JPRB, 0.61702900E-06_JPRB, 0.60922866E-06_JPRB, &
  & 0.59788681E-06_JPRB, 0.58168149E-06_JPRB, 0.55600185E-06_JPRB, 0.51602342E-06_JPRB, 0.46044698E-06_JPRB, 0.39594681E-06_JPRB, &
  & 0.33209068E-06_JPRB, 0.27551303E-06_JPRB, 0.23160372E-06_JPRB, 0.19932334E-06_JPRB, 0.17565388E-06_JPRB, 0.15855554E-06_JPRB, &
  & 0.14463288E-06_JPRB, 0.13399487E-06_JPRB, 0.12464446E-06_JPRB, 0.11667388E-06_JPRB, 0.10995538E-06_JPRB, 0.10490982E-06_JPRB, &
  & 0.10230877E-06_JPRB, 0.10278971E-06_JPRB, 0.10705622E-06_JPRB, 0.11515036E-06_JPRB, 0.12650735E-06_JPRB, 0.14004803E-06_JPRB, &
  & 0.15494186E-06_JPRB, 0.17091894E-06_JPRB, 0.18837353E-06_JPRB, 0.20815074E-06_JPRB, 0.23194863E-06_JPRB, 0.26209074E-06_JPRB, &
  & 0.30107478E-06_JPRB, 0.35048430E-06_JPRB, 0.41008627E-06_JPRB, 0.47663278E-06_JPRB, 0.54757334E-06_JPRB, 0.61961839E-06_JPRB, &
  & 0.69181931E-06_JPRB, 0.76460276E-06_JPRB, 0.83755032E-06_JPRB, 0.90868133E-06_JPRB, 0.97593318E-06_JPRB, 0.10364636E-05_JPRB, &
  & 0.10915103E-05_JPRB, 0.11425353E-05_JPRB, 0.11932749E-05_JPRB, 0.12460731E-05_JPRB, 0.13034262E-05_JPRB, 0.13646974E-05_JPRB, &
  & 0.14267218E-05_JPRB, 0.14888066E-05_JPRB, 0.15582151E-05_JPRB, 0.16868009E-05_JPRB /)

RGHG7(:,42, 1) = (/ &
  & 0.61360453E-06_JPRB, 0.60548223E-06_JPRB, 0.60159016E-06_JPRB, 0.59804046E-06_JPRB, 0.59393255E-06_JPRB, 0.58913974E-06_JPRB, &
  & 0.58347825E-06_JPRB, 0.57750600E-06_JPRB, 0.57113601E-06_JPRB, 0.56462142E-06_JPRB, 0.55745443E-06_JPRB, 0.54922936E-06_JPRB, &
  & 0.53866864E-06_JPRB, 0.52253597E-06_JPRB, 0.49744546E-06_JPRB, 0.45896692E-06_JPRB, 0.40598260E-06_JPRB, 0.34455908E-06_JPRB, &
  & 0.28638769E-06_JPRB, 0.23938458E-06_JPRB, 0.20306743E-06_JPRB, 0.17690908E-06_JPRB, 0.15705152E-06_JPRB, 0.14302768E-06_JPRB, &
  & 0.13088788E-06_JPRB, 0.12186968E-06_JPRB, 0.11351700E-06_JPRB, 0.10642377E-06_JPRB, 0.10042761E-06_JPRB, 0.95825271E-07_JPRB, &
  & 0.93405831E-07_JPRB, 0.93700642E-07_JPRB, 0.97362737E-07_JPRB, 0.10454850E-06_JPRB, 0.11475677E-06_JPRB, 0.12697602E-06_JPRB, &
  & 0.14039335E-06_JPRB, 0.15477528E-06_JPRB, 0.17046793E-06_JPRB, 0.18833572E-06_JPRB, 0.20978023E-06_JPRB, 0.23657229E-06_JPRB, &
  & 0.27065877E-06_JPRB, 0.31365440E-06_JPRB, 0.36558953E-06_JPRB, 0.42485362E-06_JPRB, 0.48787052E-06_JPRB, 0.55277314E-06_JPRB, &
  & 0.61902125E-06_JPRB, 0.68687820E-06_JPRB, 0.75583381E-06_JPRB, 0.82425680E-06_JPRB, 0.88754797E-06_JPRB, 0.94389321E-06_JPRB, &
  & 0.99307567E-06_JPRB, 0.10380479E-05_JPRB, 0.10822878E-05_JPRB, 0.11288250E-05_JPRB, 0.11800357E-05_JPRB, 0.12355060E-05_JPRB, &
  & 0.12926856E-05_JPRB, 0.13496956E-05_JPRB, 0.14143387E-05_JPRB, 0.15330025E-05_JPRB /)

RGHG7(:,43, 1) = (/ &
  & 0.57014199E-06_JPRB, 0.56178027E-06_JPRB, 0.55725064E-06_JPRB, 0.55280316E-06_JPRB, 0.54735301E-06_JPRB, 0.54072922E-06_JPRB, &
  & 0.53358184E-06_JPRB, 0.52631759E-06_JPRB, 0.51904527E-06_JPRB, 0.51195548E-06_JPRB, 0.50452235E-06_JPRB, 0.49618808E-06_JPRB, &
  & 0.48556478E-06_JPRB, 0.47077356E-06_JPRB, 0.44698899E-06_JPRB, 0.40993112E-06_JPRB, 0.35940698E-06_JPRB, 0.30388381E-06_JPRB, &
  & 0.25246354E-06_JPRB, 0.21160771E-06_JPRB, 0.18133461E-06_JPRB, 0.15960909E-06_JPRB, 0.14278511E-06_JPRB, 0.13060064E-06_JPRB, &
  & 0.11992266E-06_JPRB, 0.11176893E-06_JPRB, 0.10417322E-06_JPRB, 0.97635656E-07_JPRB, 0.92150920E-07_JPRB, 0.87935391E-07_JPRB, &
  & 0.85737071E-07_JPRB, 0.85981981E-07_JPRB, 0.89242555E-07_JPRB, 0.95746486E-07_JPRB, 0.10508815E-06_JPRB, 0.11629979E-06_JPRB, &
  & 0.12855182E-06_JPRB, 0.14163007E-06_JPRB, 0.15590085E-06_JPRB, 0.17209874E-06_JPRB, 0.19134940E-06_JPRB, 0.21523351E-06_JPRB, &
  & 0.24548751E-06_JPRB, 0.28347139E-06_JPRB, 0.32925658E-06_JPRB, 0.38120191E-06_JPRB, 0.43720263E-06_JPRB, 0.49546048E-06_JPRB, &
  & 0.55558121E-06_JPRB, 0.61812267E-06_JPRB, 0.68318411E-06_JPRB, 0.74752592E-06_JPRB, 0.80717120E-06_JPRB, 0.85827816E-06_JPRB, &
  & 0.90178617E-06_JPRB, 0.94085709E-06_JPRB, 0.97887300E-06_JPRB, 0.10190970E-05_JPRB, 0.10634456E-05_JPRB, 0.11121999E-05_JPRB, &
  & 0.11627686E-05_JPRB, 0.12141899E-05_JPRB, 0.12726980E-05_JPRB, 0.13821489E-05_JPRB /)

RGHG7(:,44, 1) = (/ &
  & 0.52972587E-06_JPRB, 0.52114592E-06_JPRB, 0.51619674E-06_JPRB, 0.51092695E-06_JPRB, 0.50420311E-06_JPRB, 0.49620337E-06_JPRB, &
  & 0.48767032E-06_JPRB, 0.47940853E-06_JPRB, 0.47146730E-06_JPRB, 0.46385216E-06_JPRB, 0.45624151E-06_JPRB, 0.44796093E-06_JPRB, &
  & 0.43779721E-06_JPRB, 0.42326238E-06_JPRB, 0.40107471E-06_JPRB, 0.36578083E-06_JPRB, 0.31770759E-06_JPRB, 0.26667695E-06_JPRB, &
  & 0.22310132E-06_JPRB, 0.18946243E-06_JPRB, 0.16408605E-06_JPRB, 0.14570249E-06_JPRB, 0.13123753E-06_JPRB, 0.12029031E-06_JPRB, &
  & 0.11075249E-06_JPRB, 0.10308665E-06_JPRB, 0.96015512E-07_JPRB, 0.89850566E-07_JPRB, 0.84761389E-07_JPRB, 0.80918475E-07_JPRB, &
  & 0.78944524E-07_JPRB, 0.79248487E-07_JPRB, 0.82248448E-07_JPRB, 0.88253003E-07_JPRB, 0.96924971E-07_JPRB, 0.10734242E-06_JPRB, &
  & 0.11866800E-06_JPRB, 0.13067596E-06_JPRB, 0.14371082E-06_JPRB, 0.15843035E-06_JPRB, 0.17586052E-06_JPRB, 0.19724700E-06_JPRB, &
  & 0.22391447E-06_JPRB, 0.25705921E-06_JPRB, 0.29716631E-06_JPRB, 0.34318680E-06_JPRB, 0.39309634E-06_JPRB, 0.44512925E-06_JPRB, &
  & 0.49934852E-06_JPRB, 0.55651429E-06_JPRB, 0.61636911E-06_JPRB, 0.67649813E-06_JPRB, 0.73093253E-06_JPRB, 0.77661440E-06_JPRB, &
  & 0.81471563E-06_JPRB, 0.84815036E-06_JPRB, 0.88063166E-06_JPRB, 0.91471475E-06_JPRB, 0.95241757E-06_JPRB, 0.99377564E-06_JPRB, &
  & 0.10370067E-05_JPRB, 0.10816590E-05_JPRB, 0.11337557E-05_JPRB, 0.12324228E-05_JPRB /)

RGHG7(:,45, 1) = (/ &
  & 0.49159718E-06_JPRB, 0.48278270E-06_JPRB, 0.47734085E-06_JPRB, 0.47138488E-06_JPRB, 0.46362669E-06_JPRB, 0.45415476E-06_JPRB, &
  & 0.44445608E-06_JPRB, 0.43517014E-06_JPRB, 0.42647781E-06_JPRB, 0.41845507E-06_JPRB, 0.41068483E-06_JPRB, 0.40245069E-06_JPRB, &
  & 0.39271788E-06_JPRB, 0.37925057E-06_JPRB, 0.35831656E-06_JPRB, 0.32559018E-06_JPRB, 0.28182012E-06_JPRB, 0.23677620E-06_JPRB, &
  & 0.19919226E-06_JPRB, 0.17118461E-06_JPRB, 0.15013606E-06_JPRB, 0.13416246E-06_JPRB, 0.12173726E-06_JPRB, 0.11147427E-06_JPRB, &
  & 0.10286624E-06_JPRB, 0.95444506E-07_JPRB, 0.88784795E-07_JPRB, 0.82881506E-07_JPRB, 0.78075836E-07_JPRB, 0.74582410E-07_JPRB, &
  & 0.72903362E-07_JPRB, 0.73308847E-07_JPRB, 0.76179482E-07_JPRB, 0.81810391E-07_JPRB, 0.89964679E-07_JPRB, 0.99758928E-07_JPRB, &
  & 0.11032746E-06_JPRB, 0.12145046E-06_JPRB, 0.13343725E-06_JPRB, 0.14688831E-06_JPRB, 0.16264514E-06_JPRB, 0.18174515E-06_JPRB, &
  & 0.20528933E-06_JPRB, 0.23434873E-06_JPRB, 0.26927697E-06_JPRB, 0.30958810E-06_JPRB, 0.35353537E-06_JPRB, 0.39987313E-06_JPRB, &
  & 0.44837537E-06_JPRB, 0.49991974E-06_JPRB, 0.55469809E-06_JPRB, 0.60876010E-06_JPRB, 0.65760224E-06_JPRB, 0.69728543E-06_JPRB, &
  & 0.72987103E-06_JPRB, 0.75835277E-06_JPRB, 0.78564318E-06_JPRB, 0.81439248E-06_JPRB, 0.84578045E-06_JPRB, 0.88003060E-06_JPRB, &
  & 0.91585895E-06_JPRB, 0.95336082E-06_JPRB, 0.99781482E-06_JPRB, 0.10847241E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART2',0,ZHOOK_HANDLE)



RGHG7(:,46, 1) = (/ &
  & 0.45500011E-06_JPRB, 0.44563072E-06_JPRB, 0.43988061E-06_JPRB, 0.43318235E-06_JPRB, 0.42434320E-06_JPRB, 0.41360818E-06_JPRB, &
  & 0.40252138E-06_JPRB, 0.39207339E-06_JPRB, 0.38256024E-06_JPRB, 0.37406960E-06_JPRB, 0.36619500E-06_JPRB, 0.35835251E-06_JPRB, &
  & 0.34905401E-06_JPRB, 0.33679962E-06_JPRB, 0.31741533E-06_JPRB, 0.28745129E-06_JPRB, 0.24801102E-06_JPRB, 0.20996882E-06_JPRB, &
  & 0.17930857E-06_JPRB, 0.15611575E-06_JPRB, 0.13857699E-06_JPRB, 0.12454888E-06_JPRB, 0.11360252E-06_JPRB, 0.10390202E-06_JPRB, &
  & 0.95985335E-07_JPRB, 0.88701057E-07_JPRB, 0.82248349E-07_JPRB, 0.76562714E-07_JPRB, 0.72030154E-07_JPRB, 0.68887054E-07_JPRB, &
  & 0.67494113E-07_JPRB, 0.68073923E-07_JPRB, 0.70894849E-07_JPRB, 0.76279235E-07_JPRB, 0.84034298E-07_JPRB, 0.93317112E-07_JPRB, &
  & 0.10328034E-06_JPRB, 0.11366328E-06_JPRB, 0.12476292E-06_JPRB, 0.13709146E-06_JPRB, 0.15138431E-06_JPRB, 0.16844629E-06_JPRB, &
  & 0.18907227E-06_JPRB, 0.21404058E-06_JPRB, 0.24395908E-06_JPRB, 0.27870971E-06_JPRB, 0.31713165E-06_JPRB, 0.35790907E-06_JPRB, &
  & 0.40084450E-06_JPRB, 0.44694451E-06_JPRB, 0.49539040E-06_JPRB, 0.54397702E-06_JPRB, 0.58540616E-06_JPRB, 0.61954751E-06_JPRB, &
  & 0.64669075E-06_JPRB, 0.67045841E-06_JPRB, 0.69339512E-06_JPRB, 0.71714021E-06_JPRB, 0.74314556E-06_JPRB, 0.77104448E-06_JPRB, &
  & 0.79998586E-06_JPRB, 0.83044887E-06_JPRB, 0.86747616E-06_JPRB, 0.94083543E-06_JPRB /)

RGHG7(:,47, 1) = (/ &
  & 0.41889712E-06_JPRB, 0.40910933E-06_JPRB, 0.40268529E-06_JPRB, 0.39539361E-06_JPRB, 0.38553554E-06_JPRB, 0.37330301E-06_JPRB, &
  & 0.36079746E-06_JPRB, 0.34888879E-06_JPRB, 0.33844205E-06_JPRB, 0.32955492E-06_JPRB, 0.32182220E-06_JPRB, 0.31422732E-06_JPRB, &
  & 0.30604366E-06_JPRB, 0.29469388E-06_JPRB, 0.27834216E-06_JPRB, 0.25189436E-06_JPRB, 0.21882121E-06_JPRB, 0.18728657E-06_JPRB, &
  & 0.16258859E-06_JPRB, 0.14357849E-06_JPRB, 0.12892231E-06_JPRB, 0.11646190E-06_JPRB, 0.10662277E-06_JPRB, 0.97378681E-07_JPRB, &
  & 0.89821462E-07_JPRB, 0.82637925E-07_JPRB, 0.76327566E-07_JPRB, 0.70812398E-07_JPRB, 0.66561668E-07_JPRB, 0.63748736E-07_JPRB, &
  & 0.62709795E-07_JPRB, 0.63477991E-07_JPRB, 0.66331289E-07_JPRB, 0.71549131E-07_JPRB, 0.78999506E-07_JPRB, 0.87887528E-07_JPRB, &
  & 0.97333647E-07_JPRB, 0.10711675E-06_JPRB, 0.11746267E-06_JPRB, 0.12884605E-06_JPRB, 0.14185163E-06_JPRB, 0.15710033E-06_JPRB, &
  & 0.17511618E-06_JPRB, 0.19640973E-06_JPRB, 0.22145964E-06_JPRB, 0.25038489E-06_JPRB, 0.28296637E-06_JPRB, 0.31781303E-06_JPRB, &
  & 0.35512505E-06_JPRB, 0.39514612E-06_JPRB, 0.43821055E-06_JPRB, 0.47906383E-06_JPRB, 0.51515048E-06_JPRB, 0.54259652E-06_JPRB, &
  & 0.56520122E-06_JPRB, 0.58467981E-06_JPRB, 0.60349083E-06_JPRB, 0.62324068E-06_JPRB, 0.64440803E-06_JPRB, 0.66699153E-06_JPRB, &
  & 0.69004994E-06_JPRB, 0.71440542E-06_JPRB, 0.74400634E-06_JPRB, 0.80448751E-06_JPRB /)

RGHG7(:,48, 1) = (/ &
  & 0.38284006E-06_JPRB, 0.37215489E-06_JPRB, 0.36539052E-06_JPRB, 0.35723176E-06_JPRB, 0.34631680E-06_JPRB, 0.33262361E-06_JPRB, &
  & 0.31821514E-06_JPRB, 0.30484406E-06_JPRB, 0.29334362E-06_JPRB, 0.28432720E-06_JPRB, 0.27685249E-06_JPRB, 0.27011095E-06_JPRB, &
  & 0.26268296E-06_JPRB, 0.25348203E-06_JPRB, 0.23927859E-06_JPRB, 0.21869005E-06_JPRB, 0.19228099E-06_JPRB, 0.16803641E-06_JPRB, &
  & 0.14873552E-06_JPRB, 0.13321758E-06_JPRB, 0.12070890E-06_JPRB, 0.10972376E-06_JPRB, 0.10038924E-06_JPRB, 0.91749563E-07_JPRB, &
  & 0.84252058E-07_JPRB, 0.77113313E-07_JPRB, 0.70902352E-07_JPRB, 0.65546871E-07_JPRB, 0.61637238E-07_JPRB, 0.59193326E-07_JPRB, &
  & 0.58473102E-07_JPRB, 0.59480733E-07_JPRB, 0.62401796E-07_JPRB, 0.67542018E-07_JPRB, 0.74765772E-07_JPRB, 0.83305466E-07_JPRB, &
  & 0.92344443E-07_JPRB, 0.10161711E-06_JPRB, 0.11134890E-06_JPRB, 0.12191953E-06_JPRB, 0.13382964E-06_JPRB, 0.14748406E-06_JPRB, &
  & 0.16312976E-06_JPRB, 0.18095712E-06_JPRB, 0.20113262E-06_JPRB, 0.22421213E-06_JPRB, 0.25004184E-06_JPRB, 0.27871278E-06_JPRB, &
  & 0.30958512E-06_JPRB, 0.34369859E-06_JPRB, 0.37979240E-06_JPRB, 0.41529256E-06_JPRB, 0.44402046E-06_JPRB, 0.46688271E-06_JPRB, &
  & 0.48480086E-06_JPRB, 0.50063619E-06_JPRB, 0.51604923E-06_JPRB, 0.53218309E-06_JPRB, 0.54957627E-06_JPRB, 0.56773604E-06_JPRB, &
  & 0.58620338E-06_JPRB, 0.60536729E-06_JPRB, 0.62915024E-06_JPRB, 0.67792018E-06_JPRB /)

RGHG7(:,49, 1) = (/ &
  & 0.34611404E-06_JPRB, 0.33480464E-06_JPRB, 0.32718907E-06_JPRB, 0.31834145E-06_JPRB, 0.30610914E-06_JPRB, 0.29060442E-06_JPRB, &
  & 0.27424304E-06_JPRB, 0.25910791E-06_JPRB, 0.24711875E-06_JPRB, 0.23828444E-06_JPRB, 0.23157378E-06_JPRB, 0.22575431E-06_JPRB, &
  & 0.21991353E-06_JPRB, 0.21280056E-06_JPRB, 0.20279394E-06_JPRB, 0.18811984E-06_JPRB, 0.16953119E-06_JPRB, 0.15162813E-06_JPRB, &
  & 0.13695096E-06_JPRB, 0.12449537E-06_JPRB, 0.11370322E-06_JPRB, 0.10394835E-06_JPRB, 0.94939189E-07_JPRB, 0.86701036E-07_JPRB, &
  & 0.79095358E-07_JPRB, 0.72063543E-07_JPRB, 0.65899918E-07_JPRB, 0.60787762E-07_JPRB, 0.57222341E-07_JPRB, 0.55180422E-07_JPRB, &
  & 0.54776859E-07_JPRB, 0.56017324E-07_JPRB, 0.59061364E-07_JPRB, 0.64160602E-07_JPRB, 0.71205463E-07_JPRB, 0.79468442E-07_JPRB, &
  & 0.88144262E-07_JPRB, 0.97005170E-07_JPRB, 0.10621108E-06_JPRB, 0.11612318E-06_JPRB, 0.12709398E-06_JPRB, 0.13938271E-06_JPRB, &
  & 0.15295691E-06_JPRB, 0.16763038E-06_JPRB, 0.18326203E-06_JPRB, 0.20011156E-06_JPRB, 0.21887641E-06_JPRB, 0.23990938E-06_JPRB, &
  & 0.26389301E-06_JPRB, 0.29111243E-06_JPRB, 0.32084577E-06_JPRB, 0.34923380E-06_JPRB, 0.37262924E-06_JPRB, 0.39045716E-06_JPRB, &
  & 0.40471457E-06_JPRB, 0.41737232E-06_JPRB, 0.42993346E-06_JPRB, 0.44321445E-06_JPRB, 0.45750627E-06_JPRB, 0.47244862E-06_JPRB, &
  & 0.48730880E-06_JPRB, 0.50284274E-06_JPRB, 0.52197498E-06_JPRB, 0.56192766E-06_JPRB /)

RGHG7(:,50, 1) = (/ &
  & 0.30887793E-06_JPRB, 0.29643090E-06_JPRB, 0.28844283E-06_JPRB, 0.27837299E-06_JPRB, 0.26474888E-06_JPRB, 0.24687222E-06_JPRB, &
  & 0.22847128E-06_JPRB, 0.21242576E-06_JPRB, 0.20081949E-06_JPRB, 0.19322781E-06_JPRB, 0.18790944E-06_JPRB, 0.18365597E-06_JPRB, &
  & 0.17995005E-06_JPRB, 0.17543485E-06_JPRB, 0.17002471E-06_JPRB, 0.16136002E-06_JPRB, 0.15014115E-06_JPRB, 0.13796981E-06_JPRB, &
  & 0.12703377E-06_JPRB, 0.11707950E-06_JPRB, 0.10763168E-06_JPRB, 0.98841745E-07_JPRB, 0.90091426E-07_JPRB, 0.82049631E-07_JPRB, &
  & 0.74367151E-07_JPRB, 0.67331861E-07_JPRB, 0.61362314E-07_JPRB, 0.56524240E-07_JPRB, 0.53323664E-07_JPRB, 0.51660432E-07_JPRB, &
  & 0.51583779E-07_JPRB, 0.53032018E-07_JPRB, 0.56221101E-07_JPRB, 0.61324279E-07_JPRB, 0.68224494E-07_JPRB, 0.76230037E-07_JPRB, &
  & 0.84599520E-07_JPRB, 0.93097114E-07_JPRB, 0.10188156E-06_JPRB, 0.11123555E-06_JPRB, 0.12143347E-06_JPRB, 0.13254630E-06_JPRB, &
  & 0.14429168E-06_JPRB, 0.15610384E-06_JPRB, 0.16752945E-06_JPRB, 0.17852312E-06_JPRB, 0.19008775E-06_JPRB, 0.20318564E-06_JPRB, &
  & 0.21923640E-06_JPRB, 0.23855716E-06_JPRB, 0.26070148E-06_JPRB, 0.28189135E-06_JPRB, 0.29961981E-06_JPRB, 0.31288582E-06_JPRB, &
  & 0.32394379E-06_JPRB, 0.33388386E-06_JPRB, 0.34389350E-06_JPRB, 0.35490783E-06_JPRB, 0.36674197E-06_JPRB, 0.37918736E-06_JPRB, &
  & 0.39164792E-06_JPRB, 0.40453207E-06_JPRB, 0.42080117E-06_JPRB, 0.45493991E-06_JPRB /)

RGHG7(:,51, 1) = (/ &
  & 0.27111577E-06_JPRB, 0.25838264E-06_JPRB, 0.24906331E-06_JPRB, 0.23836903E-06_JPRB, 0.22247839E-06_JPRB, 0.20296343E-06_JPRB, &
  & 0.18318777E-06_JPRB, 0.16860790E-06_JPRB, 0.15945471E-06_JPRB, 0.15419658E-06_JPRB, 0.15094007E-06_JPRB, 0.14876959E-06_JPRB, &
  & 0.14695027E-06_JPRB, 0.14546970E-06_JPRB, 0.14318330E-06_JPRB, 0.13993294E-06_JPRB, 0.13391555E-06_JPRB, 0.12641054E-06_JPRB, &
  & 0.11846407E-06_JPRB, 0.11052792E-06_JPRB, 0.10233352E-06_JPRB, 0.94085756E-07_JPRB, 0.85763652E-07_JPRB, 0.77658498E-07_JPRB, &
  & 0.69940469E-07_JPRB, 0.63023471E-07_JPRB, 0.57241859E-07_JPRB, 0.52785822E-07_JPRB, 0.49932023E-07_JPRB, 0.48588660E-07_JPRB, &
  & 0.48803297E-07_JPRB, 0.50496830E-07_JPRB, 0.53803980E-07_JPRB, 0.58944721E-07_JPRB, 0.65713671E-07_JPRB, 0.73487485E-07_JPRB, &
  & 0.81568459E-07_JPRB, 0.89755382E-07_JPRB, 0.98177374E-07_JPRB, 0.10707507E-06_JPRB, 0.11662238E-06_JPRB, 0.12673036E-06_JPRB, &
  & 0.13685043E-06_JPRB, 0.14617170E-06_JPRB, 0.15384531E-06_JPRB, 0.16001067E-06_JPRB, 0.16537383E-06_JPRB, 0.17165351E-06_JPRB, &
  & 0.17981949E-06_JPRB, 0.19095485E-06_JPRB, 0.20413464E-06_JPRB, 0.21779101E-06_JPRB, 0.22891423E-06_JPRB, 0.23822987E-06_JPRB, &
  & 0.24575212E-06_JPRB, 0.25299872E-06_JPRB, 0.26067903E-06_JPRB, 0.26908646E-06_JPRB, 0.27874631E-06_JPRB, 0.28899396E-06_JPRB, &
  & 0.29925587E-06_JPRB, 0.31036069E-06_JPRB, 0.32450097E-06_JPRB, 0.35513841E-06_JPRB /)

RGHG7(:,52, 1) = (/ &
  & 0.23473211E-06_JPRB, 0.22043311E-06_JPRB, 0.21153816E-06_JPRB, 0.19886747E-06_JPRB, 0.18280190E-06_JPRB, 0.16215667E-06_JPRB, &
  & 0.14553136E-06_JPRB, 0.13481788E-06_JPRB, 0.12929522E-06_JPRB, 0.12648735E-06_JPRB, 0.12507039E-06_JPRB, 0.12423554E-06_JPRB, &
  & 0.12391310E-06_JPRB, 0.12375430E-06_JPRB, 0.12370566E-06_JPRB, 0.12315138E-06_JPRB, 0.12102035E-06_JPRB, 0.11669759E-06_JPRB, &
  & 0.11103612E-06_JPRB, 0.10458712E-06_JPRB, 0.97430949E-07_JPRB, 0.89662898E-07_JPRB, 0.81617415E-07_JPRB, 0.73526763E-07_JPRB, &
  & 0.65867972E-07_JPRB, 0.59094351E-07_JPRB, 0.53599511E-07_JPRB, 0.49503971E-07_JPRB, 0.46995158E-07_JPRB, 0.45949321E-07_JPRB, &
  & 0.46381274E-07_JPRB, 0.48317769E-07_JPRB, 0.51772833E-07_JPRB, 0.56931132E-07_JPRB, 0.63593959E-07_JPRB, 0.71129364E-07_JPRB, &
  & 0.78944304E-07_JPRB, 0.86842981E-07_JPRB, 0.94950693E-07_JPRB, 0.10345731E-06_JPRB, 0.11244707E-06_JPRB, 0.12166285E-06_JPRB, &
  & 0.13034860E-06_JPRB, 0.13742135E-06_JPRB, 0.14213998E-06_JPRB, 0.14461001E-06_JPRB, 0.14605382E-06_JPRB, 0.14765716E-06_JPRB, &
  & 0.15059523E-06_JPRB, 0.15522123E-06_JPRB, 0.16150369E-06_JPRB, 0.16808850E-06_JPRB, 0.17428214E-06_JPRB, 0.17914563E-06_JPRB, &
  & 0.18373026E-06_JPRB, 0.18812545E-06_JPRB, 0.19290694E-06_JPRB, 0.19876546E-06_JPRB, 0.20536002E-06_JPRB, 0.21274795E-06_JPRB, &
  & 0.22039083E-06_JPRB, 0.22880216E-06_JPRB, 0.24013411E-06_JPRB, 0.26621990E-06_JPRB /)

RGHG7(:,53, 1) = (/ &
  & 0.19994177E-06_JPRB, 0.18656164E-06_JPRB, 0.17573510E-06_JPRB, 0.16457457E-06_JPRB, 0.14789440E-06_JPRB, 0.13164833E-06_JPRB, &
  & 0.11951944E-06_JPRB, 0.11340290E-06_JPRB, 0.11054740E-06_JPRB, 0.10925291E-06_JPRB, 0.10870746E-06_JPRB, 0.10855126E-06_JPRB, &
  & 0.10871152E-06_JPRB, 0.10911648E-06_JPRB, 0.10989492E-06_JPRB, 0.11052739E-06_JPRB, 0.11043105E-06_JPRB, 0.10836720E-06_JPRB, &
  & 0.10443660E-06_JPRB, 0.99117727E-07_JPRB, 0.92724619E-07_JPRB, 0.85438231E-07_JPRB, 0.77574974E-07_JPRB, 0.69615318E-07_JPRB, &
  & 0.62130489E-07_JPRB, 0.55584501E-07_JPRB, 0.50370240E-07_JPRB, 0.46629847E-07_JPRB, 0.44429324E-07_JPRB, 0.43667495E-07_JPRB, &
  & 0.44320249E-07_JPRB, 0.46409696E-07_JPRB, 0.50059874E-07_JPRB, 0.55218326E-07_JPRB, 0.61771523E-07_JPRB, 0.69079420E-07_JPRB, &
  & 0.76632844E-07_JPRB, 0.84259035E-07_JPRB, 0.92070565E-07_JPRB, 0.10022094E-06_JPRB, 0.10870094E-06_JPRB, 0.11710543E-06_JPRB, &
  & 0.12447552E-06_JPRB, 0.12968748E-06_JPRB, 0.13213811E-06_JPRB, 0.13236807E-06_JPRB, 0.13162820E-06_JPRB, 0.13110255E-06_JPRB, &
  & 0.13147793E-06_JPRB, 0.13301826E-06_JPRB, 0.13556793E-06_JPRB, 0.13866324E-06_JPRB, 0.14145733E-06_JPRB, 0.14408596E-06_JPRB, &
  & 0.14635722E-06_JPRB, 0.14874190E-06_JPRB, 0.15152746E-06_JPRB, 0.15474279E-06_JPRB, 0.15875491E-06_JPRB, 0.16311937E-06_JPRB, &
  & 0.16768900E-06_JPRB, 0.17281035E-06_JPRB, 0.17972810E-06_JPRB, 0.19782141E-06_JPRB /)

RGHG7(:,54, 1) = (/ &
  & 0.16984744E-06_JPRB, 0.15524056E-06_JPRB, 0.14674421E-06_JPRB, 0.13500853E-06_JPRB, 0.12293337E-06_JPRB, 0.11066240E-06_JPRB, &
  & 0.10367697E-06_JPRB, 0.10027669E-06_JPRB, 0.98879838E-07_JPRB, 0.98303140E-07_JPRB, 0.98120623E-07_JPRB, 0.98180536E-07_JPRB, &
  & 0.98398871E-07_JPRB, 0.98979825E-07_JPRB, 0.99693921E-07_JPRB, 0.10100065E-06_JPRB, 0.10175952E-06_JPRB, 0.10113258E-06_JPRB, &
  & 0.98422142E-07_JPRB, 0.93993314E-07_JPRB, 0.88158586E-07_JPRB, 0.81254825E-07_JPRB, 0.73662036E-07_JPRB, 0.65949330E-07_JPRB, &
  & 0.58697520E-07_JPRB, 0.52428277E-07_JPRB, 0.47518160E-07_JPRB, 0.44088985E-07_JPRB, 0.42175497E-07_JPRB, 0.41665018E-07_JPRB, &
  & 0.42545743E-07_JPRB, 0.44796913E-07_JPRB, 0.48519070E-07_JPRB, 0.53770201E-07_JPRB, 0.60151031E-07_JPRB, 0.67271166E-07_JPRB, &
  & 0.74551828E-07_JPRB, 0.81910095E-07_JPRB, 0.89426052E-07_JPRB, 0.97224650E-07_JPRB, 0.10520172E-06_JPRB, 0.11283128E-06_JPRB, &
  & 0.11903037E-06_JPRB, 0.12274450E-06_JPRB, 0.12365612E-06_JPRB, 0.12266834E-06_JPRB, 0.12103172E-06_JPRB, 0.11975153E-06_JPRB, &
  & 0.11924166E-06_JPRB, 0.11959580E-06_JPRB, 0.12071258E-06_JPRB, 0.12217714E-06_JPRB, 0.12370717E-06_JPRB, 0.12501698E-06_JPRB, &
  & 0.12631529E-06_JPRB, 0.12766718E-06_JPRB, 0.12917961E-06_JPRB, 0.13113282E-06_JPRB, 0.13336111E-06_JPRB, 0.13586433E-06_JPRB, &
  & 0.13834158E-06_JPRB, 0.14084972E-06_JPRB, 0.14386733E-06_JPRB, 0.15222817E-06_JPRB /)

RGHG7(:,55, 1) = (/ &
  & 0.14404306E-06_JPRB, 0.13125893E-06_JPRB, 0.12223802E-06_JPRB, 0.11435858E-06_JPRB, 0.10502736E-06_JPRB, 0.97671034E-07_JPRB, &
  & 0.93495942E-07_JPRB, 0.91708550E-07_JPRB, 0.90999187E-07_JPRB, 0.90739235E-07_JPRB, 0.90652293E-07_JPRB, 0.90746113E-07_JPRB, &
  & 0.90968236E-07_JPRB, 0.91363425E-07_JPRB, 0.92157869E-07_JPRB, 0.93165788E-07_JPRB, 0.94491575E-07_JPRB, 0.94683280E-07_JPRB, &
  & 0.92865598E-07_JPRB, 0.89078881E-07_JPRB, 0.83729539E-07_JPRB, 0.77184872E-07_JPRB, 0.69895179E-07_JPRB, 0.62485093E-07_JPRB, &
  & 0.55542753E-07_JPRB, 0.49582205E-07_JPRB, 0.44960604E-07_JPRB, 0.41847290E-07_JPRB, 0.40187093E-07_JPRB, 0.39895060E-07_JPRB, &
  & 0.40971226E-07_JPRB, 0.43399403E-07_JPRB, 0.47186379E-07_JPRB, 0.52413505E-07_JPRB, 0.58718246E-07_JPRB, 0.65595984E-07_JPRB, &
  & 0.72630073E-07_JPRB, 0.79709650E-07_JPRB, 0.86932339E-07_JPRB, 0.94347740E-07_JPRB, 0.10181441E-06_JPRB, 0.10868631E-06_JPRB, &
  & 0.11389240E-06_JPRB, 0.11646282E-06_JPRB, 0.11645981E-06_JPRB, 0.11487676E-06_JPRB, 0.11301209E-06_JPRB, 0.11160526E-06_JPRB, &
  & 0.11089082E-06_JPRB, 0.11090098E-06_JPRB, 0.11146115E-06_JPRB, 0.11231450E-06_JPRB, 0.11316391E-06_JPRB, 0.11398307E-06_JPRB, &
  & 0.11474350E-06_JPRB, 0.11554894E-06_JPRB, 0.11652229E-06_JPRB, 0.11767445E-06_JPRB, 0.11911603E-06_JPRB, 0.12065725E-06_JPRB, &
  & 0.12221545E-06_JPRB, 0.12375249E-06_JPRB, 0.12550916E-06_JPRB, 0.12849762E-06_JPRB /)

RGHG7(:,56, 1) = (/ &
  & 0.12331449E-06_JPRB, 0.11181509E-06_JPRB, 0.10538758E-06_JPRB, 0.99320552E-07_JPRB, 0.93549367E-07_JPRB, 0.88840416E-07_JPRB, &
  & 0.86483155E-07_JPRB, 0.85479861E-07_JPRB, 0.85075165E-07_JPRB, 0.84940837E-07_JPRB, 0.84880242E-07_JPRB, 0.84942364E-07_JPRB, &
  & 0.85055454E-07_JPRB, 0.85419778E-07_JPRB, 0.85916753E-07_JPRB, 0.86941938E-07_JPRB, 0.88128473E-07_JPRB, 0.88849085E-07_JPRB, &
  & 0.87608313E-07_JPRB, 0.84337813E-07_JPRB, 0.79398390E-07_JPRB, 0.73210686E-07_JPRB, 0.66284130E-07_JPRB, 0.59216973E-07_JPRB, &
  & 0.52614830E-07_JPRB, 0.46978414E-07_JPRB, 0.42684746E-07_JPRB, 0.39848278E-07_JPRB, 0.38430169E-07_JPRB, 0.38332214E-07_JPRB, &
  & 0.39562707E-07_JPRB, 0.42117659E-07_JPRB, 0.46004541E-07_JPRB, 0.51120942E-07_JPRB, 0.57345229E-07_JPRB, 0.63991607E-07_JPRB, &
  & 0.70780295E-07_JPRB, 0.77596944E-07_JPRB, 0.84494495E-07_JPRB, 0.91517904E-07_JPRB, 0.98440516E-07_JPRB, 0.10461682E-06_JPRB, &
  & 0.10897066E-06_JPRB, 0.11078148E-06_JPRB, 0.11022619E-06_JPRB, 0.10847687E-06_JPRB, 0.10664373E-06_JPRB, 0.10537219E-06_JPRB, &
  & 0.10473386E-06_JPRB, 0.10470600E-06_JPRB, 0.10508003E-06_JPRB, 0.10565261E-06_JPRB, 0.10625037E-06_JPRB, 0.10678853E-06_JPRB, &
  & 0.10731968E-06_JPRB, 0.10788991E-06_JPRB, 0.10853785E-06_JPRB, 0.10937226E-06_JPRB, 0.11033979E-06_JPRB, 0.11144920E-06_JPRB, &
  & 0.11255936E-06_JPRB, 0.11373652E-06_JPRB, 0.11529166E-06_JPRB, 0.11938786E-06_JPRB /)

RGHG7(:,57, 1) = (/ &
  & 0.10801863E-06_JPRB, 0.97922602E-07_JPRB, 0.93302738E-07_JPRB, 0.89226788E-07_JPRB, 0.85550255E-07_JPRB, 0.82665622E-07_JPRB, &
  & 0.81187608E-07_JPRB, 0.80564824E-07_JPRB, 0.80285815E-07_JPRB, 0.80160760E-07_JPRB, 0.80082550E-07_JPRB, 0.80089777E-07_JPRB, &
  & 0.80154535E-07_JPRB, 0.80341700E-07_JPRB, 0.80777767E-07_JPRB, 0.81474575E-07_JPRB, 0.82648597E-07_JPRB, 0.83449592E-07_JPRB, &
  & 0.82597431E-07_JPRB, 0.79744197E-07_JPRB, 0.75185234E-07_JPRB, 0.69363132E-07_JPRB, 0.62803871E-07_JPRB, 0.56122136E-07_JPRB, &
  & 0.49880107E-07_JPRB, 0.44610992E-07_JPRB, 0.40630297E-07_JPRB, 0.38081030E-07_JPRB, 0.36873772E-07_JPRB, 0.36947924E-07_JPRB, &
  & 0.38303931E-07_JPRB, 0.40925890E-07_JPRB, 0.44830632E-07_JPRB, 0.49943335E-07_JPRB, 0.55945289E-07_JPRB, 0.62393831E-07_JPRB, &
  & 0.68950222E-07_JPRB, 0.75488884E-07_JPRB, 0.82056623E-07_JPRB, 0.88669651E-07_JPRB, 0.95061239E-07_JPRB, 0.10058130E-06_JPRB, &
  & 0.10429036E-06_JPRB, 0.10555942E-06_JPRB, 0.10478053E-06_JPRB, 0.10301999E-06_JPRB, 0.10139153E-06_JPRB, 0.10031765E-06_JPRB, &
  & 0.99861481E-07_JPRB, 0.99907375E-07_JPRB, 0.10024731E-06_JPRB, 0.10073092E-06_JPRB, 0.10118082E-06_JPRB, 0.10161242E-06_JPRB, &
  & 0.10201229E-06_JPRB, 0.10242968E-06_JPRB, 0.10292666E-06_JPRB, 0.10351486E-06_JPRB, 0.10424844E-06_JPRB, 0.10503889E-06_JPRB, &
  & 0.10585255E-06_JPRB, 0.10665757E-06_JPRB, 0.10759683E-06_JPRB, 0.10960186E-06_JPRB /)

RGHG7(:,58, 1) = (/ &
  & 0.95494649E-07_JPRB, 0.88412826E-07_JPRB, 0.84670013E-07_JPRB, 0.82261003E-07_JPRB, 0.79764042E-07_JPRB, 0.77890242E-07_JPRB, &
  & 0.76863692E-07_JPRB, 0.76386847E-07_JPRB, 0.76140218E-07_JPRB, 0.75999615E-07_JPRB, 0.75879449E-07_JPRB, 0.75825433E-07_JPRB, &
  & 0.75812643E-07_JPRB, 0.75938225E-07_JPRB, 0.76187582E-07_JPRB, 0.76767456E-07_JPRB, 0.77649354E-07_JPRB, 0.78462215E-07_JPRB, &
  & 0.77836887E-07_JPRB, 0.75275203E-07_JPRB, 0.71060768E-07_JPRB, 0.65623858E-07_JPRB, 0.59463368E-07_JPRB, 0.53165941E-07_JPRB, &
  & 0.47333273E-07_JPRB, 0.42439947E-07_JPRB, 0.38807073E-07_JPRB, 0.36515257E-07_JPRB, 0.35504463E-07_JPRB, 0.35722721E-07_JPRB, &
  & 0.37166441E-07_JPRB, 0.39817390E-07_JPRB, 0.43684238E-07_JPRB, 0.48686765E-07_JPRB, 0.54518573E-07_JPRB, 0.60774560E-07_JPRB, &
  & 0.67082453E-07_JPRB, 0.73327570E-07_JPRB, 0.79586513E-07_JPRB, 0.85780613E-07_JPRB, 0.91664980E-07_JPRB, 0.96622259E-07_JPRB, &
  & 0.99803344E-07_JPRB, 0.10077144E-06_JPRB, 0.99906686E-07_JPRB, 0.98288893E-07_JPRB, 0.96864795E-07_JPRB, 0.96051231E-07_JPRB, &
  & 0.95810343E-07_JPRB, 0.95966300E-07_JPRB, 0.96338354E-07_JPRB, 0.96787375E-07_JPRB, 0.97207490E-07_JPRB, 0.97579161E-07_JPRB, &
  & 0.97921010E-07_JPRB, 0.98290059E-07_JPRB, 0.98697051E-07_JPRB, 0.99204840E-07_JPRB, 0.99788814E-07_JPRB, 0.10046340E-06_JPRB, &
  & 0.10115277E-06_JPRB, 0.10190364E-06_JPRB, 0.10289739E-06_JPRB, 0.10511730E-06_JPRB /)

RGHG7(:,59, 1) = (/ &
  & 0.86634842E-07_JPRB, 0.80569201E-07_JPRB, 0.78690753E-07_JPRB, 0.76865319E-07_JPRB, 0.75368334E-07_JPRB, 0.74002216E-07_JPRB, &
  & 0.73188893E-07_JPRB, 0.72740960E-07_JPRB, 0.72456231E-07_JPRB, 0.72264285E-07_JPRB, 0.72103198E-07_JPRB, 0.71967051E-07_JPRB, &
  & 0.71905674E-07_JPRB, 0.71917107E-07_JPRB, 0.72084106E-07_JPRB, 0.72452849E-07_JPRB, 0.73184104E-07_JPRB, 0.73808835E-07_JPRB, &
  & 0.73253830E-07_JPRB, 0.70931414E-07_JPRB, 0.67072669E-07_JPRB, 0.61997170E-07_JPRB, 0.56239280E-07_JPRB, 0.50375284E-07_JPRB, &
  & 0.44960643E-07_JPRB, 0.40477797E-07_JPRB, 0.37187537E-07_JPRB, 0.35156042E-07_JPRB, 0.34316589E-07_JPRB, 0.34644348E-07_JPRB, &
  & 0.36135262E-07_JPRB, 0.38766455E-07_JPRB, 0.42544148E-07_JPRB, 0.47411252E-07_JPRB, 0.53067566E-07_JPRB, 0.59084375E-07_JPRB, &
  & 0.65124304E-07_JPRB, 0.71127502E-07_JPRB, 0.77047432E-07_JPRB, 0.82865178E-07_JPRB, 0.88280153E-07_JPRB, 0.92744990E-07_JPRB, &
  & 0.95554419E-07_JPRB, 0.96320932E-07_JPRB, 0.95504710E-07_JPRB, 0.94067886E-07_JPRB, 0.92907065E-07_JPRB, 0.92330993E-07_JPRB, &
  & 0.92287173E-07_JPRB, 0.92582965E-07_JPRB, 0.93017661E-07_JPRB, 0.93488900E-07_JPRB, 0.93893611E-07_JPRB, 0.94255775E-07_JPRB, &
  & 0.94577992E-07_JPRB, 0.94905808E-07_JPRB, 0.95271119E-07_JPRB, 0.95694077E-07_JPRB, 0.96207984E-07_JPRB, 0.96756736E-07_JPRB, &
  & 0.97330236E-07_JPRB, 0.97911709E-07_JPRB, 0.98641699E-07_JPRB, 0.10047973E-06_JPRB /)

RGHG7(:,60, 1) = (/ &
  & 0.77816729E-07_JPRB, 0.75068684E-07_JPRB, 0.73720997E-07_JPRB, 0.72829160E-07_JPRB, 0.71711575E-07_JPRB, 0.70710307E-07_JPRB, &
  & 0.69952314E-07_JPRB, 0.69463077E-07_JPRB, 0.69123345E-07_JPRB, 0.68843853E-07_JPRB, 0.68621979E-07_JPRB, 0.68417293E-07_JPRB, &
  & 0.68272186E-07_JPRB, 0.68195078E-07_JPRB, 0.68238464E-07_JPRB, 0.68480936E-07_JPRB, 0.68987440E-07_JPRB, 0.69443523E-07_JPRB, &
  & 0.68883679E-07_JPRB, 0.66758069E-07_JPRB, 0.63197064E-07_JPRB, 0.58498884E-07_JPRB, 0.53159017E-07_JPRB, 0.47735426E-07_JPRB, &
  & 0.42779707E-07_JPRB, 0.38714990E-07_JPRB, 0.35778935E-07_JPRB, 0.33994660E-07_JPRB, 0.33313032E-07_JPRB, 0.33715850E-07_JPRB, &
  & 0.35206735E-07_JPRB, 0.37771638E-07_JPRB, 0.41418101E-07_JPRB, 0.46108195E-07_JPRB, 0.51519059E-07_JPRB, 0.57309943E-07_JPRB, &
  & 0.63132298E-07_JPRB, 0.68847136E-07_JPRB, 0.74488092E-07_JPRB, 0.79939518E-07_JPRB, 0.84939494E-07_JPRB, 0.89005724E-07_JPRB, &
  & 0.91499835E-07_JPRB, 0.92196913E-07_JPRB, 0.91489568E-07_JPRB, 0.90272756E-07_JPRB, 0.89349577E-07_JPRB, 0.89004921E-07_JPRB, &
  & 0.89146631E-07_JPRB, 0.89588404E-07_JPRB, 0.90101217E-07_JPRB, 0.90618762E-07_JPRB, 0.91046140E-07_JPRB, 0.91418030E-07_JPRB, &
  & 0.91736325E-07_JPRB, 0.92068461E-07_JPRB, 0.92418787E-07_JPRB, 0.92840772E-07_JPRB, 0.93301011E-07_JPRB, 0.93821740E-07_JPRB, &
  & 0.94350789E-07_JPRB, 0.94916011E-07_JPRB, 0.95644708E-07_JPRB, 0.97252610E-07_JPRB /)

RGHG7(:,61, 1) = (/ &
  & 0.71828680E-07_JPRB, 0.70703862E-07_JPRB, 0.70126589E-07_JPRB, 0.69400201E-07_JPRB, 0.68667241E-07_JPRB, 0.67816813E-07_JPRB, &
  & 0.67099357E-07_JPRB, 0.66523185E-07_JPRB, 0.66081043E-07_JPRB, 0.65716613E-07_JPRB, 0.65383581E-07_JPRB, 0.65103002E-07_JPRB, &
  & 0.64849189E-07_JPRB, 0.64675618E-07_JPRB, 0.64600705E-07_JPRB, 0.64708352E-07_JPRB, 0.65051815E-07_JPRB, 0.65314559E-07_JPRB, &
  & 0.64705418E-07_JPRB, 0.62745826E-07_JPRB, 0.59473876E-07_JPRB, 0.55143914E-07_JPRB, 0.50235002E-07_JPRB, 0.45281539E-07_JPRB, &
  & 0.40794724E-07_JPRB, 0.37163229E-07_JPRB, 0.34578502E-07_JPRB, 0.33038706E-07_JPRB, 0.32495159E-07_JPRB, 0.32941568E-07_JPRB, &
  & 0.34399960E-07_JPRB, 0.36850928E-07_JPRB, 0.40314269E-07_JPRB, 0.44775277E-07_JPRB, 0.49953240E-07_JPRB, 0.55509407E-07_JPRB, &
  & 0.61071191E-07_JPRB, 0.66560460E-07_JPRB, 0.71913647E-07_JPRB, 0.77044589E-07_JPRB, 0.81693578E-07_JPRB, 0.85398590E-07_JPRB, &
  & 0.87690111E-07_JPRB, 0.88346475E-07_JPRB, 0.87786383E-07_JPRB, 0.86806338E-07_JPRB, 0.86111058E-07_JPRB, 0.85981164E-07_JPRB, &
  & 0.86286583E-07_JPRB, 0.86864638E-07_JPRB, 0.87478952E-07_JPRB, 0.88054591E-07_JPRB, 0.88522789E-07_JPRB, 0.88912842E-07_JPRB, &
  & 0.89257910E-07_JPRB, 0.89594785E-07_JPRB, 0.89955741E-07_JPRB, 0.90349218E-07_JPRB, 0.90806203E-07_JPRB, 0.91288165E-07_JPRB, &
  & 0.91778297E-07_JPRB, 0.92278519E-07_JPRB, 0.92914540E-07_JPRB, 0.94437411E-07_JPRB /)

RGHG7(:,62, 1) = (/ &
  & 0.69280233E-07_JPRB, 0.67719832E-07_JPRB, 0.67019222E-07_JPRB, 0.66541823E-07_JPRB, 0.65958297E-07_JPRB, 0.65260913E-07_JPRB, &
  & 0.64535648E-07_JPRB, 0.63878765E-07_JPRB, 0.63303979E-07_JPRB, 0.62812468E-07_JPRB, 0.62367022E-07_JPRB, 0.61949564E-07_JPRB, &
  & 0.61589731E-07_JPRB, 0.61289633E-07_JPRB, 0.61110548E-07_JPRB, 0.61111038E-07_JPRB, 0.61315866E-07_JPRB, 0.61409224E-07_JPRB, &
  & 0.60759753E-07_JPRB, 0.58931345E-07_JPRB, 0.55921802E-07_JPRB, 0.51961688E-07_JPRB, 0.47493007E-07_JPRB, 0.43019760E-07_JPRB, &
  & 0.39023824E-07_JPRB, 0.35827608E-07_JPRB, 0.33592649E-07_JPRB, 0.32291528E-07_JPRB, 0.31870776E-07_JPRB, 0.32338630E-07_JPRB, &
  & 0.33730974E-07_JPRB, 0.36030805E-07_JPRB, 0.39269104E-07_JPRB, 0.43454818E-07_JPRB, 0.48382255E-07_JPRB, 0.53683713E-07_JPRB, &
  & 0.59023680E-07_JPRB, 0.64272292E-07_JPRB, 0.69372810E-07_JPRB, 0.74219429E-07_JPRB, 0.78548943E-07_JPRB, 0.81980687E-07_JPRB, &
  & 0.84087553E-07_JPRB, 0.84768160E-07_JPRB, 0.84383593E-07_JPRB, 0.83624890E-07_JPRB, 0.83135085E-07_JPRB, 0.83175195E-07_JPRB, &
  & 0.83646640E-07_JPRB, 0.84338247E-07_JPRB, 0.85074234E-07_JPRB, 0.85712188E-07_JPRB, 0.86246608E-07_JPRB, 0.86670447E-07_JPRB, &
  & 0.87052541E-07_JPRB, 0.87415231E-07_JPRB, 0.87792564E-07_JPRB, 0.88221036E-07_JPRB, 0.88678412E-07_JPRB, 0.89166306E-07_JPRB, &
  & 0.89651110E-07_JPRB, 0.90151268E-07_JPRB, 0.90770882E-07_JPRB, 0.92152256E-07_JPRB /)

RGHG7(:,63, 1) = (/ &
  & 0.65767445E-07_JPRB, 0.64758680E-07_JPRB, 0.64357536E-07_JPRB, 0.63945450E-07_JPRB, 0.63486702E-07_JPRB, 0.62887509E-07_JPRB, &
  & 0.62196534E-07_JPRB, 0.61456106E-07_JPRB, 0.60738977E-07_JPRB, 0.60099943E-07_JPRB, 0.59499687E-07_JPRB, 0.58952221E-07_JPRB, &
  & 0.58442840E-07_JPRB, 0.58045362E-07_JPRB, 0.57778148E-07_JPRB, 0.57707059E-07_JPRB, 0.57791507E-07_JPRB, 0.57733605E-07_JPRB, &
  & 0.57036399E-07_JPRB, 0.55327526E-07_JPRB, 0.52577992E-07_JPRB, 0.48978976E-07_JPRB, 0.44966612E-07_JPRB, 0.40989097E-07_JPRB, &
  & 0.37485339E-07_JPRB, 0.34732381E-07_JPRB, 0.32838038E-07_JPRB, 0.31768529E-07_JPRB, 0.31459116E-07_JPRB, 0.31932629E-07_JPRB, &
  & 0.33236969E-07_JPRB, 0.35355399E-07_JPRB, 0.38334740E-07_JPRB, 0.42225246E-07_JPRB, 0.46858446E-07_JPRB, 0.51900514E-07_JPRB, &
  & 0.57008950E-07_JPRB, 0.62035532E-07_JPRB, 0.66906253E-07_JPRB, 0.71480663E-07_JPRB, 0.75553729E-07_JPRB, 0.78738573E-07_JPRB, &
  & 0.80732988E-07_JPRB, 0.81441677E-07_JPRB, 0.81223995E-07_JPRB, 0.80698491E-07_JPRB, 0.80395800E-07_JPRB, 0.80568888E-07_JPRB, &
  & 0.81162518E-07_JPRB, 0.81974754E-07_JPRB, 0.82813592E-07_JPRB, 0.83550439E-07_JPRB, 0.84139941E-07_JPRB, 0.84627644E-07_JPRB, &
  & 0.85049081E-07_JPRB, 0.85448264E-07_JPRB, 0.85872955E-07_JPRB, 0.86314728E-07_JPRB, 0.86799943E-07_JPRB, 0.87297799E-07_JPRB, &
  & 0.87786482E-07_JPRB, 0.88276302E-07_JPRB, 0.88877485E-07_JPRB, 0.90207216E-07_JPRB /)

RGHG7(:,64, 1) = (/ &
  & 0.63503464E-07_JPRB, 0.62413918E-07_JPRB, 0.61928731E-07_JPRB, 0.61586597E-07_JPRB, 0.61200865E-07_JPRB, 0.60663908E-07_JPRB, &
  & 0.59975100E-07_JPRB, 0.59184920E-07_JPRB, 0.58305876E-07_JPRB, 0.57515678E-07_JPRB, 0.56774731E-07_JPRB, 0.56075503E-07_JPRB, &
  & 0.55475908E-07_JPRB, 0.54998786E-07_JPRB, 0.54688567E-07_JPRB, 0.54553364E-07_JPRB, 0.54525749E-07_JPRB, 0.54338628E-07_JPRB, &
  & 0.53607007E-07_JPRB, 0.51999358E-07_JPRB, 0.49491366E-07_JPRB, 0.46267232E-07_JPRB, 0.42705256E-07_JPRB, 0.39231896E-07_JPRB, &
  & 0.36222676E-07_JPRB, 0.33898854E-07_JPRB, 0.32336686E-07_JPRB, 0.31485797E-07_JPRB, 0.31278901E-07_JPRB, 0.31751249E-07_JPRB, &
  & 0.32958855E-07_JPRB, 0.34885080E-07_JPRB, 0.37587871E-07_JPRB, 0.41145590E-07_JPRB, 0.45463761E-07_JPRB, 0.50239080E-07_JPRB, &
  & 0.55080552E-07_JPRB, 0.59908587E-07_JPRB, 0.64538952E-07_JPRB, 0.68885853E-07_JPRB, 0.72712005E-07_JPRB, 0.75718233E-07_JPRB, &
  & 0.77616455E-07_JPRB, 0.78386890E-07_JPRB, 0.78341699E-07_JPRB, 0.78019561E-07_JPRB, 0.77887059E-07_JPRB, 0.78168405E-07_JPRB, &
  & 0.78845147E-07_JPRB, 0.79750691E-07_JPRB, 0.80684735E-07_JPRB, 0.81511963E-07_JPRB, 0.82189658E-07_JPRB, 0.82738040E-07_JPRB, &
  & 0.83217621E-07_JPRB, 0.83683126E-07_JPRB, 0.84146158E-07_JPRB, 0.84646118E-07_JPRB, 0.85167706E-07_JPRB, 0.85693344E-07_JPRB, &
  & 0.86202853E-07_JPRB, 0.86704866E-07_JPRB, 0.87304763E-07_JPRB, 0.88578233E-07_JPRB /)

RGHG7(:,65, 1) = (/ &
  & 0.61047380E-07_JPRB, 0.60074065E-07_JPRB, 0.59710025E-07_JPRB, 0.59390640E-07_JPRB, 0.59027720E-07_JPRB, 0.58536269E-07_JPRB, &
  & 0.57857477E-07_JPRB, 0.56978077E-07_JPRB, 0.55970961E-07_JPRB, 0.55021211E-07_JPRB, 0.54173388E-07_JPRB, 0.53389400E-07_JPRB, &
  & 0.52724221E-07_JPRB, 0.52217331E-07_JPRB, 0.51872874E-07_JPRB, 0.51670959E-07_JPRB, 0.51548941E-07_JPRB, 0.51253885E-07_JPRB, &
  & 0.50489891E-07_JPRB, 0.48986966E-07_JPRB, 0.46722015E-07_JPRB, 0.43861512E-07_JPRB, 0.40766086E-07_JPRB, 0.37791068E-07_JPRB, &
  & 0.35258054E-07_JPRB, 0.33346506E-07_JPRB, 0.32091698E-07_JPRB, 0.31444685E-07_JPRB, 0.31332437E-07_JPRB, 0.31803950E-07_JPRB, &
  & 0.32919452E-07_JPRB, 0.34661856E-07_JPRB, 0.37081431E-07_JPRB, 0.40292797E-07_JPRB, 0.44264027E-07_JPRB, 0.48741807E-07_JPRB, &
  & 0.53343367E-07_JPRB, 0.57926570E-07_JPRB, 0.62345990E-07_JPRB, 0.66452316E-07_JPRB, 0.70076837E-07_JPRB, 0.72921438E-07_JPRB, &
  & 0.74768053E-07_JPRB, 0.75601477E-07_JPRB, 0.75717907E-07_JPRB, 0.75587188E-07_JPRB, 0.75607417E-07_JPRB, 0.75978456E-07_JPRB, &
  & 0.76705867E-07_JPRB, 0.77661355E-07_JPRB, 0.78675797E-07_JPRB, 0.79589825E-07_JPRB, 0.80345636E-07_JPRB, 0.80977173E-07_JPRB, &
  & 0.81533216E-07_JPRB, 0.82056850E-07_JPRB, 0.82593893E-07_JPRB, 0.83144826E-07_JPRB, 0.83710859E-07_JPRB, 0.84274063E-07_JPRB, &
  & 0.84805336E-07_JPRB, 0.85329702E-07_JPRB, 0.85949054E-07_JPRB, 0.87216350E-07_JPRB /)

RGHG7(:,66, 1) = (/ &
  & 0.59028480E-07_JPRB, 0.58064174E-07_JPRB, 0.57636008E-07_JPRB, 0.57324893E-07_JPRB, 0.56985193E-07_JPRB, 0.56488997E-07_JPRB, &
  & 0.55787190E-07_JPRB, 0.54853782E-07_JPRB, 0.53671712E-07_JPRB, 0.52647710E-07_JPRB, 0.51709417E-07_JPRB, 0.50898347E-07_JPRB, &
  & 0.50218290E-07_JPRB, 0.49696730E-07_JPRB, 0.49339686E-07_JPRB, 0.49077997E-07_JPRB, 0.48878928E-07_JPRB, 0.48502542E-07_JPRB, &
  & 0.47728847E-07_JPRB, 0.46334812E-07_JPRB, 0.44312834E-07_JPRB, 0.41821892E-07_JPRB, 0.39172736E-07_JPRB, 0.36679904E-07_JPRB, &
  & 0.34598632E-07_JPRB, 0.33062939E-07_JPRB, 0.32093194E-07_JPRB, 0.31628531E-07_JPRB, 0.31604166E-07_JPRB, 0.32079861E-07_JPRB, &
  & 0.33115331E-07_JPRB, 0.34687140E-07_JPRB, 0.36836489E-07_JPRB, 0.39712774E-07_JPRB, 0.43335387E-07_JPRB, 0.47504290E-07_JPRB, &
  & 0.51830135E-07_JPRB, 0.56176443E-07_JPRB, 0.60340106E-07_JPRB, 0.64231543E-07_JPRB, 0.67653495E-07_JPRB, 0.70366596E-07_JPRB, &
  & 0.72176313E-07_JPRB, 0.73085033E-07_JPRB, 0.73352844E-07_JPRB, 0.73392442E-07_JPRB, 0.73546943E-07_JPRB, 0.73998137E-07_JPRB, &
  & 0.74758596E-07_JPRB, 0.75738427E-07_JPRB, 0.76782072E-07_JPRB, 0.77759310E-07_JPRB, 0.78600948E-07_JPRB, 0.79304719E-07_JPRB, &
  & 0.79941103E-07_JPRB, 0.80550919E-07_JPRB, 0.81156870E-07_JPRB, 0.81776420E-07_JPRB, 0.82391189E-07_JPRB, 0.82986340E-07_JPRB, &
  & 0.83553743E-07_JPRB, 0.84107278E-07_JPRB, 0.84772438E-07_JPRB, 0.86083041E-07_JPRB /)

RGHG7(:,67, 1) = (/ &
  & 0.57104558E-07_JPRB, 0.56083064E-07_JPRB, 0.55685060E-07_JPRB, 0.55367821E-07_JPRB, 0.55012915E-07_JPRB, 0.54524183E-07_JPRB, &
  & 0.53791300E-07_JPRB, 0.52780997E-07_JPRB, 0.51504308E-07_JPRB, 0.50379658E-07_JPRB, 0.49436480E-07_JPRB, 0.48617803E-07_JPRB, &
  & 0.47965440E-07_JPRB, 0.47428681E-07_JPRB, 0.47077258E-07_JPRB, 0.46783533E-07_JPRB, 0.46529870E-07_JPRB, 0.46110117E-07_JPRB, &
  & 0.45348187E-07_JPRB, 0.44078742E-07_JPRB, 0.42299419E-07_JPRB, 0.40163961E-07_JPRB, 0.37946915E-07_JPRB, 0.35900783E-07_JPRB, &
  & 0.34227419E-07_JPRB, 0.33032023E-07_JPRB, 0.32314240E-07_JPRB, 0.32012768E-07_JPRB, 0.32071458E-07_JPRB, 0.32557036E-07_JPRB, &
  & 0.33526884E-07_JPRB, 0.34948265E-07_JPRB, 0.36857493E-07_JPRB, 0.39423771E-07_JPRB, 0.42701192E-07_JPRB, 0.46535447E-07_JPRB, &
  & 0.50599894E-07_JPRB, 0.54659409E-07_JPRB, 0.58583602E-07_JPRB, 0.62239081E-07_JPRB, 0.65472285E-07_JPRB, 0.68060757E-07_JPRB, &
  & 0.69847317E-07_JPRB, 0.70821834E-07_JPRB, 0.71229451E-07_JPRB, 0.71418633E-07_JPRB, 0.71693385E-07_JPRB, 0.72213531E-07_JPRB, &
  & 0.72999683E-07_JPRB, 0.73979599E-07_JPRB, 0.75033718E-07_JPRB, 0.76042753E-07_JPRB, 0.76924039E-07_JPRB, 0.77707412E-07_JPRB, &
  & 0.78416775E-07_JPRB, 0.79103494E-07_JPRB, 0.79791526E-07_JPRB, 0.80470855E-07_JPRB, 0.81119595E-07_JPRB, 0.81750883E-07_JPRB, &
  & 0.82344670E-07_JPRB, 0.82950720E-07_JPRB, 0.83689088E-07_JPRB, 0.85121087E-07_JPRB /)

RGHG7(:,68, 1) = (/ &
  & 0.55283916E-07_JPRB, 0.54254425E-07_JPRB, 0.53810844E-07_JPRB, 0.53481216E-07_JPRB, 0.53124282E-07_JPRB, 0.52605831E-07_JPRB, &
  & 0.51844214E-07_JPRB, 0.50776254E-07_JPRB, 0.49432082E-07_JPRB, 0.48262407E-07_JPRB, 0.47356938E-07_JPRB, 0.46539611E-07_JPRB, &
  & 0.45943835E-07_JPRB, 0.45429626E-07_JPRB, 0.45086662E-07_JPRB, 0.44792770E-07_JPRB, 0.44512170E-07_JPRB, 0.44082519E-07_JPRB, &
  & 0.43363549E-07_JPRB, 0.42231143E-07_JPRB, 0.40695522E-07_JPRB, 0.38894701E-07_JPRB, 0.37068453E-07_JPRB, 0.35421714E-07_JPRB, &
  & 0.34112396E-07_JPRB, 0.33222662E-07_JPRB, 0.32728710E-07_JPRB, 0.32574487E-07_JPRB, 0.32712634E-07_JPRB, 0.33216672E-07_JPRB, &
  & 0.34133663E-07_JPRB, 0.35423433E-07_JPRB, 0.37118106E-07_JPRB, 0.39399662E-07_JPRB, 0.42360821E-07_JPRB, 0.45879130E-07_JPRB, &
  & 0.49634291E-07_JPRB, 0.53422028E-07_JPRB, 0.57082335E-07_JPRB, 0.60503943E-07_JPRB, 0.63539893E-07_JPRB, 0.66012547E-07_JPRB, &
  & 0.67769861E-07_JPRB, 0.68802912E-07_JPRB, 0.69327307E-07_JPRB, 0.69648820E-07_JPRB, 0.70023852E-07_JPRB, 0.70604735E-07_JPRB, &
  & 0.71411613E-07_JPRB, 0.72385639E-07_JPRB, 0.73425355E-07_JPRB, 0.74430794E-07_JPRB, 0.75344118E-07_JPRB, 0.76166053E-07_JPRB, &
  & 0.76934192E-07_JPRB, 0.77689407E-07_JPRB, 0.78446497E-07_JPRB, 0.79171720E-07_JPRB, 0.79849187E-07_JPRB, 0.80494061E-07_JPRB, &
  & 0.81121478E-07_JPRB, 0.81781408E-07_JPRB, 0.82633896E-07_JPRB, 0.84278639E-07_JPRB /)

RGHG7(:,69, 1) = (/ &
  & 0.53587737E-07_JPRB, 0.52465033E-07_JPRB, 0.52003319E-07_JPRB, 0.51654499E-07_JPRB, 0.51269517E-07_JPRB, 0.50742543E-07_JPRB, &
  & 0.49947566E-07_JPRB, 0.48848147E-07_JPRB, 0.47466763E-07_JPRB, 0.46312202E-07_JPRB, 0.45449518E-07_JPRB, 0.44684437E-07_JPRB, &
  & 0.44139977E-07_JPRB, 0.43677804E-07_JPRB, 0.43365997E-07_JPRB, 0.43095145E-07_JPRB, 0.42821899E-07_JPRB, 0.42417220E-07_JPRB, &
  & 0.41765539E-07_JPRB, 0.40779252E-07_JPRB, 0.39474685E-07_JPRB, 0.37982964E-07_JPRB, 0.36510531E-07_JPRB, 0.35223533E-07_JPRB, &
  & 0.34238418E-07_JPRB, 0.33612078E-07_JPRB, 0.33316642E-07_JPRB, 0.33295873E-07_JPRB, 0.33513011E-07_JPRB, 0.34041705E-07_JPRB, &
  & 0.34918912E-07_JPRB, 0.36100019E-07_JPRB, 0.37604490E-07_JPRB, 0.39623313E-07_JPRB, 0.42292204E-07_JPRB, 0.45486257E-07_JPRB, &
  & 0.48952902E-07_JPRB, 0.52451444E-07_JPRB, 0.55845017E-07_JPRB, 0.59027556E-07_JPRB, 0.61860824E-07_JPRB, 0.64220650E-07_JPRB, &
  & 0.65930742E-07_JPRB, 0.67004123E-07_JPRB, 0.67626445E-07_JPRB, 0.68054099E-07_JPRB, 0.68516982E-07_JPRB, 0.69142580E-07_JPRB, &
  & 0.69960848E-07_JPRB, 0.70921999E-07_JPRB, 0.71941926E-07_JPRB, 0.72933268E-07_JPRB, 0.73841086E-07_JPRB, 0.74678148E-07_JPRB, &
  & 0.75482120E-07_JPRB, 0.76281758E-07_JPRB, 0.77079541E-07_JPRB, 0.77846437E-07_JPRB, 0.78519435E-07_JPRB, 0.79174846E-07_JPRB, &
  & 0.79825156E-07_JPRB, 0.80533454E-07_JPRB, 0.81533322E-07_JPRB, 0.83418627E-07_JPRB /)

RGHG7(:,70, 1) = (/ &
  & 0.51930204E-07_JPRB, 0.50718658E-07_JPRB, 0.50209945E-07_JPRB, 0.49836643E-07_JPRB, 0.49443944E-07_JPRB, 0.48891014E-07_JPRB, &
  & 0.48071204E-07_JPRB, 0.46975742E-07_JPRB, 0.45611841E-07_JPRB, 0.44508621E-07_JPRB, 0.43720274E-07_JPRB, 0.43035055E-07_JPRB, &
  & 0.42562554E-07_JPRB, 0.42171020E-07_JPRB, 0.41903853E-07_JPRB, 0.41682160E-07_JPRB, 0.41440451E-07_JPRB, 0.41087457E-07_JPRB, &
  & 0.40522824E-07_JPRB, 0.39688320E-07_JPRB, 0.38605581E-07_JPRB, 0.37396433E-07_JPRB, 0.36236109E-07_JPRB, 0.35259134E-07_JPRB, &
  & 0.34562202E-07_JPRB, 0.34174786E-07_JPRB, 0.34057170E-07_JPRB, 0.34160504E-07_JPRB, 0.34454509E-07_JPRB, 0.35014359E-07_JPRB, &
  & 0.35859063E-07_JPRB, 0.36951448E-07_JPRB, 0.38282195E-07_JPRB, 0.40072404E-07_JPRB, 0.42464382E-07_JPRB, 0.45364349E-07_JPRB, &
  & 0.48524029E-07_JPRB, 0.51735704E-07_JPRB, 0.54861069E-07_JPRB, 0.57793279E-07_JPRB, 0.60438097E-07_JPRB, 0.62660135E-07_JPRB, &
  & 0.64317994E-07_JPRB, 0.65406454E-07_JPRB, 0.66103574E-07_JPRB, 0.66621055E-07_JPRB, 0.67150523E-07_JPRB, 0.67814469E-07_JPRB, &
  & 0.68634201E-07_JPRB, 0.69575442E-07_JPRB, 0.70561889E-07_JPRB, 0.71525278E-07_JPRB, 0.72409698E-07_JPRB, 0.73245360E-07_JPRB, &
  & 0.74039654E-07_JPRB, 0.74860800E-07_JPRB, 0.75689506E-07_JPRB, 0.76455301E-07_JPRB, 0.77126124E-07_JPRB, 0.77777983E-07_JPRB, &
  & 0.78427647E-07_JPRB, 0.79189419E-07_JPRB, 0.80289524E-07_JPRB, 0.82516053E-07_JPRB /)

RGHG7(:,71, 1) = (/ &
  & 0.50307406E-07_JPRB, 0.48968900E-07_JPRB, 0.48413714E-07_JPRB, 0.48020119E-07_JPRB, 0.47604011E-07_JPRB, 0.47044082E-07_JPRB, &
  & 0.46226823E-07_JPRB, 0.45138982E-07_JPRB, 0.43863974E-07_JPRB, 0.42879034E-07_JPRB, 0.42160448E-07_JPRB, 0.41597101E-07_JPRB, &
  & 0.41196497E-07_JPRB, 0.40893955E-07_JPRB, 0.40689912E-07_JPRB, 0.40529823E-07_JPRB, 0.40345494E-07_JPRB, 0.40062442E-07_JPRB, &
  & 0.39597655E-07_JPRB, 0.38915825E-07_JPRB, 0.38043588E-07_JPRB, 0.37092249E-07_JPRB, 0.36219166E-07_JPRB, 0.35530519E-07_JPRB, &
  & 0.35082163E-07_JPRB, 0.34898584E-07_JPRB, 0.34938278E-07_JPRB, 0.35154244E-07_JPRB, 0.35524664E-07_JPRB, 0.36116610E-07_JPRB, &
  & 0.36943405E-07_JPRB, 0.37955708E-07_JPRB, 0.39144869E-07_JPRB, 0.40730750E-07_JPRB, 0.42852065E-07_JPRB, 0.45477996E-07_JPRB, &
  & 0.48332669E-07_JPRB, 0.51263317E-07_JPRB, 0.54105268E-07_JPRB, 0.56803088E-07_JPRB, 0.59242190E-07_JPRB, 0.61331264E-07_JPRB, &
  & 0.62905066E-07_JPRB, 0.64002066E-07_JPRB, 0.64746949E-07_JPRB, 0.65330966E-07_JPRB, 0.65916922E-07_JPRB, 0.66602631E-07_JPRB, &
  & 0.67413090E-07_JPRB, 0.68327552E-07_JPRB, 0.69279331E-07_JPRB, 0.70199370E-07_JPRB, 0.71047289E-07_JPRB, 0.71850323E-07_JPRB, &
  & 0.72624687E-07_JPRB, 0.73425966E-07_JPRB, 0.74253002E-07_JPRB, 0.75018505E-07_JPRB, 0.75668233E-07_JPRB, 0.76298818E-07_JPRB, &
  & 0.76951352E-07_JPRB, 0.77707298E-07_JPRB, 0.78907405E-07_JPRB, 0.81417312E-07_JPRB /)

RGHG7(:,72, 1) = (/ &
  & 0.48649870E-07_JPRB, 0.47175543E-07_JPRB, 0.46574968E-07_JPRB, 0.46162668E-07_JPRB, 0.45753804E-07_JPRB, 0.45188543E-07_JPRB, &
  & 0.44375792E-07_JPRB, 0.43380830E-07_JPRB, 0.42247542E-07_JPRB, 0.41388301E-07_JPRB, 0.40811283E-07_JPRB, 0.40339561E-07_JPRB, &
  & 0.40047798E-07_JPRB, 0.39830297E-07_JPRB, 0.39702091E-07_JPRB, 0.39614484E-07_JPRB, 0.39503671E-07_JPRB, 0.39299945E-07_JPRB, &
  & 0.38947370E-07_JPRB, 0.38419639E-07_JPRB, 0.37749718E-07_JPRB, 0.37040529E-07_JPRB, 0.36419706E-07_JPRB, 0.35972530E-07_JPRB, &
  & 0.35747224E-07_JPRB, 0.35750759E-07_JPRB, 0.35934459E-07_JPRB, 0.36257138E-07_JPRB, 0.36699966E-07_JPRB, 0.37325936E-07_JPRB, &
  & 0.38138225E-07_JPRB, 0.39075776E-07_JPRB, 0.40162220E-07_JPRB, 0.41540950E-07_JPRB, 0.43470553E-07_JPRB, 0.45787655E-07_JPRB, &
  & 0.48359166E-07_JPRB, 0.51006779E-07_JPRB, 0.53575143E-07_JPRB, 0.56026650E-07_JPRB, 0.58271176E-07_JPRB, 0.60199099E-07_JPRB, &
  & 0.61694180E-07_JPRB, 0.62768201E-07_JPRB, 0.63549649E-07_JPRB, 0.64182842E-07_JPRB, 0.64805050E-07_JPRB, 0.65502761E-07_JPRB, &
  & 0.66307635E-07_JPRB, 0.67180352E-07_JPRB, 0.68087651E-07_JPRB, 0.68956354E-07_JPRB, 0.69741610E-07_JPRB, 0.70517842E-07_JPRB, &
  & 0.71224562E-07_JPRB, 0.72014267E-07_JPRB, 0.72800638E-07_JPRB, 0.73556699E-07_JPRB, 0.74172640E-07_JPRB, 0.74784381E-07_JPRB, &
  & 0.75399484E-07_JPRB, 0.76149227E-07_JPRB, 0.77359026E-07_JPRB, 0.80058363E-07_JPRB /)

RGHG7(:,73, 1) = (/ &
  & 0.46862649E-07_JPRB, 0.45298204E-07_JPRB, 0.44683368E-07_JPRB, 0.44288459E-07_JPRB, 0.43884135E-07_JPRB, 0.43344311E-07_JPRB, &
  & 0.42605922E-07_JPRB, 0.41702030E-07_JPRB, 0.40765944E-07_JPRB, 0.40097547E-07_JPRB, 0.39604551E-07_JPRB, 0.39290104E-07_JPRB, &
  & 0.39070940E-07_JPRB, 0.38959495E-07_JPRB, 0.38914969E-07_JPRB, 0.38907039E-07_JPRB, 0.38879215E-07_JPRB, 0.38769162E-07_JPRB, &
  & 0.38532640E-07_JPRB, 0.38161460E-07_JPRB, 0.37686441E-07_JPRB, 0.37200831E-07_JPRB, 0.36814683E-07_JPRB, 0.36595178E-07_JPRB, &
  & 0.36569464E-07_JPRB, 0.36730583E-07_JPRB, 0.37038713E-07_JPRB, 0.37455600E-07_JPRB, 0.37967308E-07_JPRB, 0.38626041E-07_JPRB, &
  & 0.39433399E-07_JPRB, 0.40313701E-07_JPRB, 0.41303750E-07_JPRB, 0.42513669E-07_JPRB, 0.44271054E-07_JPRB, 0.46283294E-07_JPRB, &
  & 0.48570701E-07_JPRB, 0.50949147E-07_JPRB, 0.53241720E-07_JPRB, 0.55457981E-07_JPRB, 0.57494677E-07_JPRB, 0.59262089E-07_JPRB, &
  & 0.60658842E-07_JPRB, 0.61705705E-07_JPRB, 0.62502437E-07_JPRB, 0.63162979E-07_JPRB, 0.63817382E-07_JPRB, 0.64519867E-07_JPRB, &
  & 0.65287558E-07_JPRB, 0.66134930E-07_JPRB, 0.66980974E-07_JPRB, 0.67792804E-07_JPRB, 0.68536323E-07_JPRB, 0.69229493E-07_JPRB, &
  & 0.69923146E-07_JPRB, 0.70621795E-07_JPRB, 0.71402525E-07_JPRB, 0.72102175E-07_JPRB, 0.72702292E-07_JPRB, 0.73263692E-07_JPRB, &
  & 0.73848142E-07_JPRB, 0.74544758E-07_JPRB, 0.75745838E-07_JPRB, 0.78507227E-07_JPRB /)

RGHG7(:,74, 1) = (/ &
  & 0.44884292E-07_JPRB, 0.43344780E-07_JPRB, 0.42775522E-07_JPRB, 0.42407763E-07_JPRB, 0.42058822E-07_JPRB, 0.41574268E-07_JPRB, &
  & 0.40925187E-07_JPRB, 0.40191232E-07_JPRB, 0.39457937E-07_JPRB, 0.38919698E-07_JPRB, 0.38597285E-07_JPRB, 0.38364611E-07_JPRB, &
  & 0.38273178E-07_JPRB, 0.38248267E-07_JPRB, 0.38297262E-07_JPRB, 0.38376594E-07_JPRB, 0.38438181E-07_JPRB, 0.38425995E-07_JPRB, &
  & 0.38315154E-07_JPRB, 0.38099458E-07_JPRB, 0.37815070E-07_JPRB, 0.37538925E-07_JPRB, 0.37361481E-07_JPRB, 0.37334054E-07_JPRB, &
  & 0.37472084E-07_JPRB, 0.37778964E-07_JPRB, 0.38202803E-07_JPRB, 0.38709970E-07_JPRB, 0.39284544E-07_JPRB, 0.39973767E-07_JPRB, &
  & 0.40769152E-07_JPRB, 0.41603929E-07_JPRB, 0.42515072E-07_JPRB, 0.43633584E-07_JPRB, 0.45169323E-07_JPRB, 0.46965461E-07_JPRB, &
  & 0.48946983E-07_JPRB, 0.51052190E-07_JPRB, 0.53089401E-07_JPRB, 0.55068860E-07_JPRB, 0.56897083E-07_JPRB, 0.58501417E-07_JPRB, &
  & 0.59789265E-07_JPRB, 0.60798094E-07_JPRB, 0.61591059E-07_JPRB, 0.62280030E-07_JPRB, 0.62937254E-07_JPRB, 0.63632925E-07_JPRB, &
  & 0.64391507E-07_JPRB, 0.65173211E-07_JPRB, 0.65977460E-07_JPRB, 0.66729989E-07_JPRB, 0.67401217E-07_JPRB, 0.68076190E-07_JPRB, &
  & 0.68670317E-07_JPRB, 0.69368170E-07_JPRB, 0.70055101E-07_JPRB, 0.70734359E-07_JPRB, 0.71279104E-07_JPRB, 0.71802297E-07_JPRB, &
  & 0.72332782E-07_JPRB, 0.72965669E-07_JPRB, 0.74111988E-07_JPRB, 0.76847599E-07_JPRB /)

RGHG7(:,75, 1) = (/ &
  & 0.42946226E-07_JPRB, 0.41434632E-07_JPRB, 0.40893763E-07_JPRB, 0.40586130E-07_JPRB, 0.40293763E-07_JPRB, 0.39906659E-07_JPRB, &
  & 0.39400394E-07_JPRB, 0.38825561E-07_JPRB, 0.38269942E-07_JPRB, 0.37913654E-07_JPRB, 0.37692107E-07_JPRB, 0.37600817E-07_JPRB, &
  & 0.37597335E-07_JPRB, 0.37677403E-07_JPRB, 0.37821767E-07_JPRB, 0.37991299E-07_JPRB, 0.38144446E-07_JPRB, 0.38242025E-07_JPRB, &
  & 0.38256402E-07_JPRB, 0.38199598E-07_JPRB, 0.38096470E-07_JPRB, 0.38016921E-07_JPRB, 0.38033967E-07_JPRB, 0.38194415E-07_JPRB, &
  & 0.38499046E-07_JPRB, 0.38928189E-07_JPRB, 0.39448640E-07_JPRB, 0.40029633E-07_JPRB, 0.40660538E-07_JPRB, 0.41378573E-07_JPRB, &
  & 0.42171155E-07_JPRB, 0.42976893E-07_JPRB, 0.43823562E-07_JPRB, 0.44839815E-07_JPRB, 0.46156394E-07_JPRB, 0.47774979E-07_JPRB, &
  & 0.49480231E-07_JPRB, 0.51288730E-07_JPRB, 0.53082768E-07_JPRB, 0.54832494E-07_JPRB, 0.56458443E-07_JPRB, 0.57887377E-07_JPRB, &
  & 0.59076037E-07_JPRB, 0.60023339E-07_JPRB, 0.60811928E-07_JPRB, 0.61495982E-07_JPRB, 0.62170798E-07_JPRB, 0.62847249E-07_JPRB, &
  & 0.63560378E-07_JPRB, 0.64314470E-07_JPRB, 0.65050465E-07_JPRB, 0.65751308E-07_JPRB, 0.66394783E-07_JPRB, 0.66990353E-07_JPRB, &
  & 0.67584814E-07_JPRB, 0.68179766E-07_JPRB, 0.68838986E-07_JPRB, 0.69448070E-07_JPRB, 0.69940292E-07_JPRB, 0.70419794E-07_JPRB, &
  & 0.70884830E-07_JPRB, 0.71445562E-07_JPRB, 0.72499788E-07_JPRB, 0.75125186E-07_JPRB /)

RGHG7(:,76, 1) = (/ &
  & 0.41015383E-07_JPRB, 0.39548283E-07_JPRB, 0.39064801E-07_JPRB, 0.38822755E-07_JPRB, 0.38627316E-07_JPRB, 0.38349974E-07_JPRB, &
  & 0.37996021E-07_JPRB, 0.37591978E-07_JPRB, 0.37217742E-07_JPRB, 0.36999644E-07_JPRB, 0.36920561E-07_JPRB, 0.36940726E-07_JPRB, &
  & 0.37046359E-07_JPRB, 0.37229487E-07_JPRB, 0.37461287E-07_JPRB, 0.37722732E-07_JPRB, 0.37969819E-07_JPRB, 0.38173244E-07_JPRB, &
  & 0.38320497E-07_JPRB, 0.38417479E-07_JPRB, 0.38493074E-07_JPRB, 0.38598401E-07_JPRB, 0.38791271E-07_JPRB, 0.39098794E-07_JPRB, &
  & 0.39519762E-07_JPRB, 0.40052445E-07_JPRB, 0.40655713E-07_JPRB, 0.41305181E-07_JPRB, 0.41985473E-07_JPRB, 0.42725880E-07_JPRB, &
  & 0.43508827E-07_JPRB, 0.44296801E-07_JPRB, 0.45121329E-07_JPRB, 0.46065690E-07_JPRB, 0.47264777E-07_JPRB, 0.48600182E-07_JPRB, &
  & 0.50140041E-07_JPRB, 0.51646055E-07_JPRB, 0.53193027E-07_JPRB, 0.54718182E-07_JPRB, 0.56142088E-07_JPRB, 0.57417274E-07_JPRB, &
  & 0.58481188E-07_JPRB, 0.59375157E-07_JPRB, 0.60137367E-07_JPRB, 0.60829585E-07_JPRB, 0.61484322E-07_JPRB, 0.62154697E-07_JPRB, &
  & 0.62843654E-07_JPRB, 0.63535559E-07_JPRB, 0.64227265E-07_JPRB, 0.64876581E-07_JPRB, 0.65460661E-07_JPRB, 0.66040840E-07_JPRB, &
  & 0.66557952E-07_JPRB, 0.67135765E-07_JPRB, 0.67715952E-07_JPRB, 0.68246919E-07_JPRB, 0.68700984E-07_JPRB, 0.69106420E-07_JPRB, &
  & 0.69532568E-07_JPRB, 0.69991160E-07_JPRB, 0.70941319E-07_JPRB, 0.73377798E-07_JPRB /)

RGHG7(:,77, 1) = (/ &
  & 0.39137920E-07_JPRB, 0.37737205E-07_JPRB, 0.37317520E-07_JPRB, 0.37154070E-07_JPRB, 0.37044170E-07_JPRB, 0.36897486E-07_JPRB, &
  & 0.36696747E-07_JPRB, 0.36472859E-07_JPRB, 0.36277818E-07_JPRB, 0.36213549E-07_JPRB, 0.36274621E-07_JPRB, 0.36395406E-07_JPRB, &
  & 0.36613308E-07_JPRB, 0.36874987E-07_JPRB, 0.37199506E-07_JPRB, 0.37541533E-07_JPRB, 0.37883328E-07_JPRB, 0.38194258E-07_JPRB, &
  & 0.38468531E-07_JPRB, 0.38717491E-07_JPRB, 0.38962263E-07_JPRB, 0.39242522E-07_JPRB, 0.39601506E-07_JPRB, 0.40068720E-07_JPRB, &
  & 0.40619195E-07_JPRB, 0.41247581E-07_JPRB, 0.41926956E-07_JPRB, 0.42633804E-07_JPRB, 0.43358163E-07_JPRB, 0.44116817E-07_JPRB, &
  & 0.44896510E-07_JPRB, 0.45677719E-07_JPRB, 0.46452449E-07_JPRB, 0.47306902E-07_JPRB, 0.48360850E-07_JPRB, 0.49494531E-07_JPRB, &
  & 0.50802146E-07_JPRB, 0.52103758E-07_JPRB, 0.53397770E-07_JPRB, 0.54693132E-07_JPRB, 0.55933722E-07_JPRB, 0.57044009E-07_JPRB, &
  & 0.58008354E-07_JPRB, 0.58831656E-07_JPRB, 0.59568155E-07_JPRB, 0.60243366E-07_JPRB, 0.60900462E-07_JPRB, 0.61541655E-07_JPRB, &
  & 0.62194616E-07_JPRB, 0.62847462E-07_JPRB, 0.63482773E-07_JPRB, 0.64087267E-07_JPRB, 0.64639053E-07_JPRB, 0.65170347E-07_JPRB, &
  & 0.65667209E-07_JPRB, 0.66170010E-07_JPRB, 0.66680833E-07_JPRB, 0.67162468E-07_JPRB, 0.67532298E-07_JPRB, 0.67907941E-07_JPRB, &
  & 0.68260640E-07_JPRB, 0.68634229E-07_JPRB, 0.69452696E-07_JPRB, 0.71633735E-07_JPRB /)

RGHG7(:,78, 1) = (/ &
  & 0.37304929E-07_JPRB, 0.36070180E-07_JPRB, 0.35746631E-07_JPRB, 0.35668940E-07_JPRB, 0.35654992E-07_JPRB, 0.35615987E-07_JPRB, &
  & 0.35572171E-07_JPRB, 0.35512503E-07_JPRB, 0.35491620E-07_JPRB, 0.35581031E-07_JPRB, 0.35746879E-07_JPRB, 0.35991153E-07_JPRB, &
  & 0.36279690E-07_JPRB, 0.36628037E-07_JPRB, 0.37013706E-07_JPRB, 0.37427416E-07_JPRB, 0.37845911E-07_JPRB, 0.38257195E-07_JPRB, &
  & 0.38651987E-07_JPRB, 0.39040568E-07_JPRB, 0.39435186E-07_JPRB, 0.39870752E-07_JPRB, 0.40353498E-07_JPRB, 0.40901984E-07_JPRB, &
  & 0.41514202E-07_JPRB, 0.42178367E-07_JPRB, 0.42881883E-07_JPRB, 0.43612545E-07_JPRB, 0.44360402E-07_JPRB, 0.45137522E-07_JPRB, &
  & 0.45933238E-07_JPRB, 0.46729820E-07_JPRB, 0.47525916E-07_JPRB, 0.48401528E-07_JPRB, 0.49336748E-07_JPRB, 0.50369785E-07_JPRB, &
  & 0.51422639E-07_JPRB, 0.52556643E-07_JPRB, 0.53662330E-07_JPRB, 0.54739544E-07_JPRB, 0.55794224E-07_JPRB, 0.56777349E-07_JPRB, &
  & 0.57633695E-07_JPRB, 0.58401000E-07_JPRB, 0.59115337E-07_JPRB, 0.59776674E-07_JPRB, 0.60413669E-07_JPRB, 0.61048468E-07_JPRB, &
  & 0.61675038E-07_JPRB, 0.62287064E-07_JPRB, 0.62878719E-07_JPRB, 0.63439700E-07_JPRB, 0.63946338E-07_JPRB, 0.64446908E-07_JPRB, &
  & 0.64899162E-07_JPRB, 0.65356275E-07_JPRB, 0.65802823E-07_JPRB, 0.66196755E-07_JPRB, 0.66540721E-07_JPRB, 0.66838474E-07_JPRB, &
  & 0.67161146E-07_JPRB, 0.67426136E-07_JPRB, 0.68077881E-07_JPRB, 0.69924809E-07_JPRB /)

RGHG7(:,79, 1) = (/ &
  & 0.35765002E-07_JPRB, 0.34920767E-07_JPRB, 0.34766270E-07_JPRB, 0.34789910E-07_JPRB, 0.34837687E-07_JPRB, 0.34888160E-07_JPRB, &
  & 0.34932029E-07_JPRB, 0.34993178E-07_JPRB, 0.35084543E-07_JPRB, 0.35261635E-07_JPRB, 0.35500168E-07_JPRB, 0.35781284E-07_JPRB, &
  & 0.36119911E-07_JPRB, 0.36498690E-07_JPRB, 0.36918568E-07_JPRB, 0.37366203E-07_JPRB, 0.37831509E-07_JPRB, 0.38300538E-07_JPRB, &
  & 0.38768988E-07_JPRB, 0.39236589E-07_JPRB, 0.39713843E-07_JPRB, 0.40224169E-07_JPRB, 0.40740698E-07_JPRB, 0.41343402E-07_JPRB, &
  & 0.41979103E-07_JPRB, 0.42659991E-07_JPRB, 0.43374619E-07_JPRB, 0.44115595E-07_JPRB, 0.44877318E-07_JPRB, 0.45666606E-07_JPRB, &
  & 0.46473144E-07_JPRB, 0.47281961E-07_JPRB, 0.48092225E-07_JPRB, 0.48942653E-07_JPRB, 0.49860713E-07_JPRB, 0.50843340E-07_JPRB, &
  & 0.51853089E-07_JPRB, 0.52831396E-07_JPRB, 0.53861037E-07_JPRB, 0.54808563E-07_JPRB, 0.55728577E-07_JPRB, 0.56610070E-07_JPRB, &
  & 0.57420561E-07_JPRB, 0.58151631E-07_JPRB, 0.58851189E-07_JPRB, 0.59516047E-07_JPRB, 0.60158733E-07_JPRB, 0.60786185E-07_JPRB, &
  & 0.61402716E-07_JPRB, 0.61994896E-07_JPRB, 0.62566912E-07_JPRB, 0.63105794E-07_JPRB, 0.63593262E-07_JPRB, 0.64061908E-07_JPRB, &
  & 0.64487217E-07_JPRB, 0.64896469E-07_JPRB, 0.65286393E-07_JPRB, 0.65640641E-07_JPRB, 0.65935488E-07_JPRB, 0.66185173E-07_JPRB, &
  & 0.66475948E-07_JPRB, 0.66636431E-07_JPRB, 0.67084528E-07_JPRB, 0.68397057E-07_JPRB /)

RGHG7(:,80, 1) = (/ &
  & 0.34898978E-07_JPRB, 0.34452981E-07_JPRB, 0.34399594E-07_JPRB, 0.34478930E-07_JPRB, 0.34549647E-07_JPRB, 0.34616853E-07_JPRB, &
  & 0.34696527E-07_JPRB, 0.34781433E-07_JPRB, 0.34917559E-07_JPRB, 0.35101490E-07_JPRB, 0.35374132E-07_JPRB, 0.35682309E-07_JPRB, &
  & 0.36043570E-07_JPRB, 0.36441545E-07_JPRB, 0.36877115E-07_JPRB, 0.37339870E-07_JPRB, 0.37819706E-07_JPRB, 0.38308812E-07_JPRB, &
  & 0.38801993E-07_JPRB, 0.39305270E-07_JPRB, 0.39815163E-07_JPRB, 0.40373951E-07_JPRB, 0.40925489E-07_JPRB, 0.41546929E-07_JPRB, &
  & 0.42188613E-07_JPRB, 0.42874426E-07_JPRB, 0.43593381E-07_JPRB, 0.44341665E-07_JPRB, 0.45110518E-07_JPRB, 0.45907367E-07_JPRB, &
  & 0.46720480E-07_JPRB, 0.47535892E-07_JPRB, 0.48353780E-07_JPRB, 0.49213231E-07_JPRB, 0.50124235E-07_JPRB, 0.51050822E-07_JPRB, &
  & 0.52024724E-07_JPRB, 0.52952103E-07_JPRB, 0.53897455E-07_JPRB, 0.54844339E-07_JPRB, 0.55697608E-07_JPRB, 0.56535285E-07_JPRB, &
  & 0.57327870E-07_JPRB, 0.58049036E-07_JPRB, 0.58749784E-07_JPRB, 0.59403966E-07_JPRB, 0.60044862E-07_JPRB, 0.60671766E-07_JPRB, &
  & 0.61280716E-07_JPRB, 0.61866444E-07_JPRB, 0.62428491E-07_JPRB, 0.62955536E-07_JPRB, 0.63440595E-07_JPRB, 0.63898035E-07_JPRB, &
  & 0.64325235E-07_JPRB, 0.64723196E-07_JPRB, 0.65105347E-07_JPRB, 0.65424182E-07_JPRB, 0.65739094E-07_JPRB, 0.65937009E-07_JPRB, &
  & 0.66241164E-07_JPRB, 0.66347333E-07_JPRB, 0.66647658E-07_JPRB, 0.67454479E-07_JPRB /)

RGHG7(:,81, 1) = (/ &
  & 0.34315384E-07_JPRB, 0.34157793E-07_JPRB, 0.34191853E-07_JPRB, 0.34303842E-07_JPRB, 0.34370064E-07_JPRB, 0.34462754E-07_JPRB, &
  & 0.34555523E-07_JPRB, 0.34680014E-07_JPRB, 0.34823508E-07_JPRB, 0.35061113E-07_JPRB, 0.35326451E-07_JPRB, 0.35648743E-07_JPRB, &
  & 0.36012796E-07_JPRB, 0.36417468E-07_JPRB, 0.36859038E-07_JPRB, 0.37327304E-07_JPRB, 0.37818573E-07_JPRB, 0.38319747E-07_JPRB, &
  & 0.38833456E-07_JPRB, 0.39349072E-07_JPRB, 0.39884391E-07_JPRB, 0.40437754E-07_JPRB, 0.41007926E-07_JPRB, 0.41624485E-07_JPRB, &
  & 0.42275882E-07_JPRB, 0.42966885E-07_JPRB, 0.43690452E-07_JPRB, 0.44441350E-07_JPRB, 0.45216730E-07_JPRB, 0.46017966E-07_JPRB, &
  & 0.46836117E-07_JPRB, 0.47656300E-07_JPRB, 0.48477663E-07_JPRB, 0.49337363E-07_JPRB, 0.50228603E-07_JPRB, 0.51172094E-07_JPRB, &
  & 0.52099356E-07_JPRB, 0.53060727E-07_JPRB, 0.53928922E-07_JPRB, 0.54857264E-07_JPRB, 0.55717397E-07_JPRB, 0.56496383E-07_JPRB, &
  & 0.57286226E-07_JPRB, 0.58003494E-07_JPRB, 0.58692130E-07_JPRB, 0.59354974E-07_JPRB, 0.59998165E-07_JPRB, 0.60620778E-07_JPRB, &
  & 0.61232235E-07_JPRB, 0.61810141E-07_JPRB, 0.62373360E-07_JPRB, 0.62892425E-07_JPRB, 0.63380554E-07_JPRB, 0.63820991E-07_JPRB, &
  & 0.64247871E-07_JPRB, 0.64621588E-07_JPRB, 0.65014738E-07_JPRB, 0.65299510E-07_JPRB, 0.65633976E-07_JPRB, 0.65798481E-07_JPRB, &
  & 0.66108164E-07_JPRB, 0.66212962E-07_JPRB, 0.66404233E-07_JPRB, 0.66867997E-07_JPRB /)

RGHG7(:,82, 1) = (/ &
  & 0.34038951E-07_JPRB, 0.34046572E-07_JPRB, 0.34157448E-07_JPRB, 0.34272770E-07_JPRB, 0.34324213E-07_JPRB, 0.34426542E-07_JPRB, &
  & 0.34526344E-07_JPRB, 0.34639626E-07_JPRB, 0.34807226E-07_JPRB, 0.34999552E-07_JPRB, 0.35305550E-07_JPRB, 0.35614864E-07_JPRB, &
  & 0.35995338E-07_JPRB, 0.36405346E-07_JPRB, 0.36849375E-07_JPRB, 0.37323030E-07_JPRB, 0.37813184E-07_JPRB, 0.38318596E-07_JPRB, &
  & 0.38831526E-07_JPRB, 0.39358760E-07_JPRB, 0.39890445E-07_JPRB, 0.40461401E-07_JPRB, 0.41048942E-07_JPRB, 0.41669434E-07_JPRB, &
  & 0.42320234E-07_JPRB, 0.43009084E-07_JPRB, 0.43734737E-07_JPRB, 0.44490204E-07_JPRB, 0.45267676E-07_JPRB, 0.46073826E-07_JPRB, &
  & 0.46895810E-07_JPRB, 0.47719517E-07_JPRB, 0.48550628E-07_JPRB, 0.49408346E-07_JPRB, 0.50309485E-07_JPRB, 0.51227477E-07_JPRB, &
  & 0.52151357E-07_JPRB, 0.53077414E-07_JPRB, 0.53981189E-07_JPRB, 0.54825520E-07_JPRB, 0.55734887E-07_JPRB, 0.56491068E-07_JPRB, &
  & 0.57260213E-07_JPRB, 0.57994129E-07_JPRB, 0.58680083E-07_JPRB, 0.59341044E-07_JPRB, 0.59980870E-07_JPRB, 0.60604101E-07_JPRB, &
  & 0.61208361E-07_JPRB, 0.61786245E-07_JPRB, 0.62346523E-07_JPRB, 0.62859890E-07_JPRB, 0.63354776E-07_JPRB, 0.63787908E-07_JPRB, &
  & 0.64230385E-07_JPRB, 0.64587070E-07_JPRB, 0.64998673E-07_JPRB, 0.65256764E-07_JPRB, 0.65611559E-07_JPRB, 0.65762549E-07_JPRB, &
  & 0.66052863E-07_JPRB, 0.66201139E-07_JPRB, 0.66302768E-07_JPRB, 0.66522539E-07_JPRB /)

RGHG7(:,83, 1) = (/ &
  & 0.34138562E-07_JPRB, 0.33928309E-07_JPRB, 0.34148798E-07_JPRB, 0.34208480E-07_JPRB, 0.34248846E-07_JPRB, 0.34382005E-07_JPRB, &
  & 0.34469178E-07_JPRB, 0.34610618E-07_JPRB, 0.34756876E-07_JPRB, 0.35021184E-07_JPRB, 0.35276695E-07_JPRB, 0.35626794E-07_JPRB, &
  & 0.35979873E-07_JPRB, 0.36398301E-07_JPRB, 0.36844622E-07_JPRB, 0.37317641E-07_JPRB, 0.37816442E-07_JPRB, 0.38321833E-07_JPRB, &
  & 0.38846970E-07_JPRB, 0.39366554E-07_JPRB, 0.39920341E-07_JPRB, 0.40469136E-07_JPRB, 0.41065558E-07_JPRB, 0.41676884E-07_JPRB, &
  & 0.42337856E-07_JPRB, 0.43027512E-07_JPRB, 0.43757328E-07_JPRB, 0.44514234E-07_JPRB, 0.45296282E-07_JPRB, 0.46105335E-07_JPRB, &
  & 0.46931827E-07_JPRB, 0.47763727E-07_JPRB, 0.48599006E-07_JPRB, 0.49462678E-07_JPRB, 0.50355553E-07_JPRB, 0.51262990E-07_JPRB, &
  & 0.52203799E-07_JPRB, 0.53081067E-07_JPRB, 0.54034903E-07_JPRB, 0.54824802E-07_JPRB, 0.55721646E-07_JPRB, 0.56510231E-07_JPRB, &
  & 0.57245998E-07_JPRB, 0.57989748E-07_JPRB, 0.58671333E-07_JPRB, 0.59336205E-07_JPRB, 0.59978134E-07_JPRB, 0.60596626E-07_JPRB, &
  & 0.61201433E-07_JPRB, 0.61774713E-07_JPRB, 0.62334017E-07_JPRB, 0.62844364E-07_JPRB, 0.63339535E-07_JPRB, 0.63765320E-07_JPRB, &
  & 0.64208237E-07_JPRB, 0.64555437E-07_JPRB, 0.64970969E-07_JPRB, 0.65226132E-07_JPRB, 0.65567349E-07_JPRB, 0.65750150E-07_JPRB, &
  & 0.65980288E-07_JPRB, 0.66211278E-07_JPRB, 0.66250216E-07_JPRB, 0.66528003E-07_JPRB /)

RGHG7(:,84, 1) = (/ &
  & 0.34169936E-07_JPRB, 0.33810082E-07_JPRB, 0.34221014E-07_JPRB, 0.34156383E-07_JPRB, 0.34248671E-07_JPRB, 0.34392563E-07_JPRB, &
  & 0.34460381E-07_JPRB, 0.34607744E-07_JPRB, 0.34781287E-07_JPRB, 0.34980623E-07_JPRB, 0.35288981E-07_JPRB, 0.35589942E-07_JPRB, &
  & 0.35976612E-07_JPRB, 0.36383881E-07_JPRB, 0.36837179E-07_JPRB, 0.37315974E-07_JPRB, 0.37809464E-07_JPRB, 0.38319239E-07_JPRB, &
  & 0.38837822E-07_JPRB, 0.39364508E-07_JPRB, 0.39902272E-07_JPRB, 0.40480479E-07_JPRB, 0.41062986E-07_JPRB, 0.41691219E-07_JPRB, &
  & 0.42345000E-07_JPRB, 0.43037659E-07_JPRB, 0.43765574E-07_JPRB, 0.44526750E-07_JPRB, 0.45310518E-07_JPRB, 0.46123080E-07_JPRB, &
  & 0.46954543E-07_JPRB, 0.47793240E-07_JPRB, 0.48638892E-07_JPRB, 0.49504145E-07_JPRB, 0.50397400E-07_JPRB, 0.51296727E-07_JPRB, &
  & 0.52224777E-07_JPRB, 0.53123713E-07_JPRB, 0.54017136E-07_JPRB, 0.54891846E-07_JPRB, 0.55677003E-07_JPRB, 0.56543222E-07_JPRB, &
  & 0.57245124E-07_JPRB, 0.58003472E-07_JPRB, 0.58687107E-07_JPRB, 0.59348970E-07_JPRB, 0.59985844E-07_JPRB, 0.60600705E-07_JPRB, &
  & 0.61200687E-07_JPRB, 0.61775829E-07_JPRB, 0.62328617E-07_JPRB, 0.62840549E-07_JPRB, 0.63331555E-07_JPRB, 0.63763949E-07_JPRB, &
  & 0.64200009E-07_JPRB, 0.64559714E-07_JPRB, 0.64954641E-07_JPRB, 0.65240428E-07_JPRB, 0.65531339E-07_JPRB, 0.65781528E-07_JPRB, &
  & 0.65923857E-07_JPRB, 0.66232808E-07_JPRB, 0.66209743E-07_JPRB, 0.66529800E-07_JPRB /)

RGHG7(:,85, 1) = (/ &
  & 0.34220022E-07_JPRB, 0.33684167E-07_JPRB, 0.34314915E-07_JPRB, 0.34031437E-07_JPRB, 0.34271704E-07_JPRB, 0.34354290E-07_JPRB, &
  & 0.34429696E-07_JPRB, 0.34630709E-07_JPRB, 0.34759111E-07_JPRB, 0.35037043E-07_JPRB, 0.35273043E-07_JPRB, 0.35607165E-07_JPRB, &
  & 0.35949885E-07_JPRB, 0.36367489E-07_JPRB, 0.36822208E-07_JPRB, 0.37304989E-07_JPRB, 0.37807293E-07_JPRB, 0.38315950E-07_JPRB, &
  & 0.38838621E-07_JPRB, 0.39355768E-07_JPRB, 0.39922107E-07_JPRB, 0.40457394E-07_JPRB, 0.41063213E-07_JPRB, 0.41677460E-07_JPRB, &
  & 0.42343554E-07_JPRB, 0.43038842E-07_JPRB, 0.43766505E-07_JPRB, 0.44535202E-07_JPRB, 0.45320814E-07_JPRB, 0.46137860E-07_JPRB, &
  & 0.46974613E-07_JPRB, 0.47821345E-07_JPRB, 0.48672305E-07_JPRB, 0.49544017E-07_JPRB, 0.50420876E-07_JPRB, 0.51334684E-07_JPRB, &
  & 0.52237603E-07_JPRB, 0.53166715E-07_JPRB, 0.54033841E-07_JPRB, 0.54925188E-07_JPRB, 0.55715713E-07_JPRB, 0.56537012E-07_JPRB, &
  & 0.57292922E-07_JPRB, 0.58006840E-07_JPRB, 0.58712715E-07_JPRB, 0.59366460E-07_JPRB, 0.59998349E-07_JPRB, 0.60611690E-07_JPRB, &
  & 0.61204574E-07_JPRB, 0.61780256E-07_JPRB, 0.62325917E-07_JPRB, 0.62841806E-07_JPRB, 0.63321913E-07_JPRB, 0.63766024E-07_JPRB, &
  & 0.64180576E-07_JPRB, 0.64566180E-07_JPRB, 0.64920741E-07_JPRB, 0.65258767E-07_JPRB, 0.65481366E-07_JPRB, 0.65808749E-07_JPRB, &
  & 0.65878041E-07_JPRB, 0.66241213E-07_JPRB, 0.66190822E-07_JPRB, 0.66505642E-07_JPRB /)

RGHG7(:,86, 1) = (/ &
  & 0.34283225E-07_JPRB, 0.33571300E-07_JPRB, 0.34430787E-07_JPRB, 0.33899454E-07_JPRB, 0.34388538E-07_JPRB, 0.34287133E-07_JPRB, &
  & 0.34504602E-07_JPRB, 0.34642518E-07_JPRB, 0.34824989E-07_JPRB, 0.35046952E-07_JPRB, 0.35296456E-07_JPRB, 0.35583358E-07_JPRB, &
  & 0.35934328E-07_JPRB, 0.36334733E-07_JPRB, 0.36797289E-07_JPRB, 0.37284970E-07_JPRB, 0.37792159E-07_JPRB, 0.38297177E-07_JPRB, &
  & 0.38821565E-07_JPRB, 0.39343814E-07_JPRB, 0.39887997E-07_JPRB, 0.40452075E-07_JPRB, 0.41046636E-07_JPRB, 0.41667388E-07_JPRB, &
  & 0.42334985E-07_JPRB, 0.43034280E-07_JPRB, 0.43769042E-07_JPRB, 0.44533842E-07_JPRB, 0.45324761E-07_JPRB, 0.46142684E-07_JPRB, &
  & 0.46984162E-07_JPRB, 0.47836394E-07_JPRB, 0.48694247E-07_JPRB, 0.49563333E-07_JPRB, 0.50452840E-07_JPRB, 0.51351194E-07_JPRB, &
  & 0.52279944E-07_JPRB, 0.53194857E-07_JPRB, 0.54081362E-07_JPRB, 0.54962946E-07_JPRB, 0.55771839E-07_JPRB, 0.56579459E-07_JPRB, &
  & 0.57332475E-07_JPRB, 0.58059239E-07_JPRB, 0.58736113E-07_JPRB, 0.59398637E-07_JPRB, 0.60017527E-07_JPRB, 0.60629979E-07_JPRB, &
  & 0.61216156E-07_JPRB, 0.61794267E-07_JPRB, 0.62332674E-07_JPRB, 0.62851377E-07_JPRB, 0.63320869E-07_JPRB, 0.63778018E-07_JPRB, &
  & 0.64173491E-07_JPRB, 0.64584981E-07_JPRB, 0.64904270E-07_JPRB, 0.65283004E-07_JPRB, 0.65459616E-07_JPRB, 0.65825077E-07_JPRB, &
  & 0.65865528E-07_JPRB, 0.66238222E-07_JPRB, 0.66184164E-07_JPRB, 0.66498338E-07_JPRB /)

RGHG7(:,87, 1) = (/ &
  & 0.34329613E-07_JPRB, 0.33505259E-07_JPRB, 0.34492839E-07_JPRB, 0.33792446E-07_JPRB, 0.34484575E-07_JPRB, 0.34183760E-07_JPRB, &
  & 0.34600095E-07_JPRB, 0.34613116E-07_JPRB, 0.34894832E-07_JPRB, 0.35054303E-07_JPRB, 0.35338875E-07_JPRB, 0.35576026E-07_JPRB, &
  & 0.35931553E-07_JPRB, 0.36303135E-07_JPRB, 0.36767915E-07_JPRB, 0.37260225E-07_JPRB, 0.37769119E-07_JPRB, 0.38285165E-07_JPRB, &
  & 0.38801836E-07_JPRB, 0.39332932E-07_JPRB, 0.39882984E-07_JPRB, 0.40428557E-07_JPRB, 0.41031040E-07_JPRB, 0.41653990E-07_JPRB, &
  & 0.42322210E-07_JPRB, 0.43024922E-07_JPRB, 0.43765059E-07_JPRB, 0.44530680E-07_JPRB, 0.45324565E-07_JPRB, 0.46146162E-07_JPRB, &
  & 0.46988706E-07_JPRB, 0.47842487E-07_JPRB, 0.48701821E-07_JPRB, 0.49575835E-07_JPRB, 0.50460823E-07_JPRB, 0.51373899E-07_JPRB, &
  & 0.52296038E-07_JPRB, 0.53236885E-07_JPRB, 0.54136159E-07_JPRB, 0.54998782E-07_JPRB, 0.55849021E-07_JPRB, 0.56623133E-07_JPRB, &
  & 0.57388803E-07_JPRB, 0.58099353E-07_JPRB, 0.58772425E-07_JPRB, 0.59420270E-07_JPRB, 0.60036577E-07_JPRB, 0.60644751E-07_JPRB, &
  & 0.61224625E-07_JPRB, 0.61800172E-07_JPRB, 0.62335658E-07_JPRB, 0.62855015E-07_JPRB, 0.63319064E-07_JPRB, 0.63780156E-07_JPRB, &
  & 0.64168148E-07_JPRB, 0.64585976E-07_JPRB, 0.64897677E-07_JPRB, 0.65279245E-07_JPRB, 0.65459439E-07_JPRB, 0.65812841E-07_JPRB, &
  & 0.65874019E-07_JPRB, 0.66221766E-07_JPRB, 0.66191213E-07_JPRB, 0.66489392E-07_JPRB /)

RGHG7(:,88, 1) = (/ &
  & 0.34335010E-07_JPRB, 0.33495084E-07_JPRB, 0.34503909E-07_JPRB, 0.33760998E-07_JPRB, 0.34537205E-07_JPRB, 0.34128391E-07_JPRB, &
  & 0.34688842E-07_JPRB, 0.34571325E-07_JPRB, 0.34952322E-07_JPRB, 0.35033892E-07_JPRB, 0.35344900E-07_JPRB, 0.35569563E-07_JPRB, &
  & 0.35910173E-07_JPRB, 0.36292978E-07_JPRB, 0.36751690E-07_JPRB, 0.37236919E-07_JPRB, 0.37758564E-07_JPRB, 0.38256957E-07_JPRB, &
  & 0.38793598E-07_JPRB, 0.39309274E-07_JPRB, 0.39851269E-07_JPRB, 0.40416118E-07_JPRB, 0.41006533E-07_JPRB, 0.41637108E-07_JPRB, &
  & 0.42307246E-07_JPRB, 0.43013767E-07_JPRB, 0.43755719E-07_JPRB, 0.44522825E-07_JPRB, 0.45321425E-07_JPRB, 0.46143001E-07_JPRB, &
  & 0.46990316E-07_JPRB, 0.47850083E-07_JPRB, 0.48716306E-07_JPRB, 0.49596768E-07_JPRB, 0.50495292E-07_JPRB, 0.51414741E-07_JPRB, &
  & 0.52357318E-07_JPRB, 0.53287607E-07_JPRB, 0.54202665E-07_JPRB, 0.55070913E-07_JPRB, 0.55897225E-07_JPRB, 0.56702280E-07_JPRB, &
  & 0.57431386E-07_JPRB, 0.58146110E-07_JPRB, 0.58806979E-07_JPRB, 0.59446577E-07_JPRB, 0.60058291E-07_JPRB, 0.60663346E-07_JPRB, &
  & 0.61243242E-07_JPRB, 0.61814120E-07_JPRB, 0.62348995E-07_JPRB, 0.62864224E-07_JPRB, 0.63328322E-07_JPRB, 0.63784974E-07_JPRB, &
  & 0.64177165E-07_JPRB, 0.64586793E-07_JPRB, 0.64908981E-07_JPRB, 0.65272872E-07_JPRB, 0.65473728E-07_JPRB, 0.65799853E-07_JPRB, &
  & 0.65889466E-07_JPRB, 0.66205168E-07_JPRB, 0.66206056E-07_JPRB, 0.66472289E-07_JPRB /)

RGHG7(:,89, 1) = (/ &
  & 0.34322817E-07_JPRB, 0.33517090E-07_JPRB, 0.34468162E-07_JPRB, 0.33783149E-07_JPRB, 0.34493599E-07_JPRB, 0.34137084E-07_JPRB, &
  & 0.34635615E-07_JPRB, 0.34553437E-07_JPRB, 0.34911253E-07_JPRB, 0.35009393E-07_JPRB, 0.35319168E-07_JPRB, 0.35555029E-07_JPRB, &
  & 0.35911306E-07_JPRB, 0.36287201E-07_JPRB, 0.36747739E-07_JPRB, 0.37240152E-07_JPRB, 0.37744151E-07_JPRB, 0.38255696E-07_JPRB, &
  & 0.38773461E-07_JPRB, 0.39291198E-07_JPRB, 0.39838540E-07_JPRB, 0.40389207E-07_JPRB, 0.40982918E-07_JPRB, 0.41608040E-07_JPRB, &
  & 0.42281062E-07_JPRB, 0.42991154E-07_JPRB, 0.43738730E-07_JPRB, 0.44513701E-07_JPRB, 0.45317229E-07_JPRB, 0.46150074E-07_JPRB, &
  & 0.47006544E-07_JPRB, 0.47870241E-07_JPRB, 0.48744141E-07_JPRB, 0.49641070E-07_JPRB, 0.50556089E-07_JPRB, 0.51499580E-07_JPRB, &
  & 0.52449035E-07_JPRB, 0.53388476E-07_JPRB, 0.54292723E-07_JPRB, 0.55161397E-07_JPRB, 0.55983879E-07_JPRB, 0.56765423E-07_JPRB, &
  & 0.57500376E-07_JPRB, 0.58189027E-07_JPRB, 0.58846211E-07_JPRB, 0.59476083E-07_JPRB, 0.60084247E-07_JPRB, 0.60682410E-07_JPRB, &
  & 0.61262796E-07_JPRB, 0.61828167E-07_JPRB, 0.62364265E-07_JPRB, 0.62874761E-07_JPRB, 0.63341979E-07_JPRB, 0.63790559E-07_JPRB, &
  & 0.64190040E-07_JPRB, 0.64587489E-07_JPRB, 0.64923135E-07_JPRB, 0.65267471E-07_JPRB, 0.65489346E-07_JPRB, 0.65789997E-07_JPRB, &
  & 0.65906590E-07_JPRB, 0.66192499E-07_JPRB, 0.66223876E-07_JPRB, 0.66456593E-07_JPRB /)

RGHG7(:,90, 1) = (/ &
  & 0.34275470E-07_JPRB, 0.33597967E-07_JPRB, 0.34370007E-07_JPRB, 0.33870410E-07_JPRB, 0.34392077E-07_JPRB, 0.34193281E-07_JPRB, &
  & 0.34527091E-07_JPRB, 0.34547522E-07_JPRB, 0.34797981E-07_JPRB, 0.34969599E-07_JPRB, 0.35247279E-07_JPRB, 0.35533937E-07_JPRB, &
  & 0.35892043E-07_JPRB, 0.36295511E-07_JPRB, 0.36761769E-07_JPRB, 0.37236241E-07_JPRB, 0.37745078E-07_JPRB, 0.38238426E-07_JPRB, &
  & 0.38753480E-07_JPRB, 0.39265458E-07_JPRB, 0.39801442E-07_JPRB, 0.40352944E-07_JPRB, 0.40940382E-07_JPRB, 0.41570360E-07_JPRB, &
  & 0.42243467E-07_JPRB, 0.42958902E-07_JPRB, 0.43712500E-07_JPRB, 0.44498599E-07_JPRB, 0.45306813E-07_JPRB, 0.46154913E-07_JPRB, &
  & 0.47021686E-07_JPRB, 0.47898112E-07_JPRB, 0.48806051E-07_JPRB, 0.49727269E-07_JPRB, 0.50674888E-07_JPRB, 0.51645916E-07_JPRB, &
  & 0.52612581E-07_JPRB, 0.53543374E-07_JPRB, 0.54435812E-07_JPRB, 0.55288233E-07_JPRB, 0.56100056E-07_JPRB, 0.56865002E-07_JPRB, &
  & 0.57580873E-07_JPRB, 0.58257559E-07_JPRB, 0.58901897E-07_JPRB, 0.59522865E-07_JPRB, 0.60128137E-07_JPRB, 0.60720623E-07_JPRB, &
  & 0.61299453E-07_JPRB, 0.61860042E-07_JPRB, 0.62395323E-07_JPRB, 0.62899240E-07_JPRB, 0.63369122E-07_JPRB, 0.63809303E-07_JPRB, &
  & 0.64214028E-07_JPRB, 0.64600883E-07_JPRB, 0.64947471E-07_JPRB, 0.65272275E-07_JPRB, 0.65512701E-07_JPRB, 0.65786239E-07_JPRB, &
  & 0.65931737E-07_JPRB, 0.66181599E-07_JPRB, 0.66251914E-07_JPRB, 0.66440037E-07_JPRB /)

RGHG7(:,91, 1) = (/ &
  & 0.34098704E-07_JPRB, 0.33803765E-07_JPRB, 0.34165975E-07_JPRB, 0.34017511E-07_JPRB, 0.34248711E-07_JPRB, 0.34259656E-07_JPRB, &
  & 0.34408270E-07_JPRB, 0.34502971E-07_JPRB, 0.34666702E-07_JPRB, 0.34855258E-07_JPRB, 0.35163570E-07_JPRB, 0.35501458E-07_JPRB, &
  & 0.35887822E-07_JPRB, 0.36310016E-07_JPRB, 0.36762788E-07_JPRB, 0.37237555E-07_JPRB, 0.37725130E-07_JPRB, 0.38217202E-07_JPRB, &
  & 0.38715825E-07_JPRB, 0.39224009E-07_JPRB, 0.39747103E-07_JPRB, 0.40294335E-07_JPRB, 0.40876476E-07_JPRB, 0.41505995E-07_JPRB, &
  & 0.42184151E-07_JPRB, 0.42909079E-07_JPRB, 0.43676611E-07_JPRB, 0.44481752E-07_JPRB, 0.45301910E-07_JPRB, 0.46180489E-07_JPRB, &
  & 0.47071293E-07_JPRB, 0.47965383E-07_JPRB, 0.48920935E-07_JPRB, 0.49870781E-07_JPRB, 0.50857356E-07_JPRB, 0.51889877E-07_JPRB, &
  & 0.52865047E-07_JPRB, 0.53790394E-07_JPRB, 0.54672594E-07_JPRB, 0.55504565E-07_JPRB, 0.56291036E-07_JPRB, 0.57022060E-07_JPRB, &
  & 0.57711752E-07_JPRB, 0.58367000E-07_JPRB, 0.58991954E-07_JPRB, 0.59597568E-07_JPRB, 0.60193351E-07_JPRB, 0.60779342E-07_JPRB, &
  & 0.61354378E-07_JPRB, 0.61910448E-07_JPRB, 0.62443895E-07_JPRB, 0.62941979E-07_JPRB, 0.63410845E-07_JPRB, 0.63846130E-07_JPRB, &
  & 0.64251033E-07_JPRB, 0.64630520E-07_JPRB, 0.64984626E-07_JPRB, 0.65290884E-07_JPRB, 0.65546274E-07_JPRB, 0.65792712E-07_JPRB, &
  & 0.65968877E-07_JPRB, 0.66175737E-07_JPRB, 0.66300387E-07_JPRB, 0.66411459E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG7(:, 1, 2) = (/ &
  & 0.82067928E-07_JPRB, 0.72492426E-07_JPRB, 0.69881800E-07_JPRB, 0.69057322E-07_JPRB, 0.69081104E-07_JPRB, 0.68799039E-07_JPRB, &
  & 0.68737997E-07_JPRB, 0.68663098E-07_JPRB, 0.68745621E-07_JPRB, 0.68859570E-07_JPRB, 0.69143681E-07_JPRB, 0.69368220E-07_JPRB, &
  & 0.69803527E-07_JPRB, 0.69969687E-07_JPRB, 0.70205154E-07_JPRB, 0.70305546E-07_JPRB, 0.70471231E-07_JPRB, 0.70464473E-07_JPRB, &
  & 0.70536892E-07_JPRB, 0.70560674E-07_JPRB, 0.70287527E-07_JPRB, 0.69973701E-07_JPRB, 0.69467909E-07_JPRB, 0.68916933E-07_JPRB, &
  & 0.68334636E-07_JPRB, 0.67752985E-07_JPRB, 0.67240109E-07_JPRB, 0.66843505E-07_JPRB, 0.66599824E-07_JPRB, 0.66540132E-07_JPRB, &
  & 0.66679199E-07_JPRB, 0.67012287E-07_JPRB, 0.67526315E-07_JPRB, 0.68160467E-07_JPRB, 0.68740150E-07_JPRB, 0.69286088E-07_JPRB, &
  & 0.69699517E-07_JPRB, 0.69953771E-07_JPRB, 0.70040841E-07_JPRB, 0.69986882E-07_JPRB, 0.69827706E-07_JPRB, 0.69601548E-07_JPRB, &
  & 0.69320826E-07_JPRB, 0.69002830E-07_JPRB, 0.68653833E-07_JPRB, 0.68357664E-07_JPRB, 0.68115817E-07_JPRB, 0.67963278E-07_JPRB, &
  & 0.67830143E-07_JPRB, 0.67779347E-07_JPRB, 0.67826946E-07_JPRB, 0.68001476E-07_JPRB, 0.68326308E-07_JPRB, 0.68839412E-07_JPRB, &
  & 0.69586861E-07_JPRB, 0.70552318E-07_JPRB, 0.71707788E-07_JPRB, 0.72776984E-07_JPRB, 0.73578889E-07_JPRB, 0.74598709E-07_JPRB, &
  & 0.14227939E-06_JPRB, 0.64376050E-05_JPRB, 0.66556468E-05_JPRB, 0.71551576E-05_JPRB /)

RGHG7(:, 2, 2) = (/ &
  & 0.19003399E-06_JPRB, 0.18295269E-06_JPRB, 0.17830968E-06_JPRB, 0.18002467E-06_JPRB, 0.18227288E-06_JPRB, 0.18196414E-06_JPRB, &
  & 0.18042431E-06_JPRB, 0.17850448E-06_JPRB, 0.18020444E-06_JPRB, 0.18044925E-06_JPRB, 0.18329973E-06_JPRB, 0.18783489E-06_JPRB, &
  & 0.19178314E-06_JPRB, 0.19127482E-06_JPRB, 0.19159901E-06_JPRB, 0.18959939E-06_JPRB, 0.19004719E-06_JPRB, 0.19037442E-06_JPRB, &
  & 0.19464620E-06_JPRB, 0.20068194E-06_JPRB, 0.20108698E-06_JPRB, 0.20315223E-06_JPRB, 0.20431726E-06_JPRB, 0.20515996E-06_JPRB, &
  & 0.20566897E-06_JPRB, 0.20573157E-06_JPRB, 0.20548862E-06_JPRB, 0.20523188E-06_JPRB, 0.20518439E-06_JPRB, 0.20545770E-06_JPRB, &
  & 0.20618958E-06_JPRB, 0.20792729E-06_JPRB, 0.21321961E-06_JPRB, 0.22165385E-06_JPRB, 0.22328700E-06_JPRB, 0.22495939E-06_JPRB, &
  & 0.22555632E-06_JPRB, 0.22561996E-06_JPRB, 0.22500157E-06_JPRB, 0.22414842E-06_JPRB, 0.22384354E-06_JPRB, 0.22457790E-06_JPRB, &
  & 0.22654957E-06_JPRB, 0.22997658E-06_JPRB, 0.23509077E-06_JPRB, 0.24227654E-06_JPRB, 0.25168333E-06_JPRB, 0.26441668E-06_JPRB, &
  & 0.27301760E-06_JPRB, 0.28033242E-06_JPRB, 0.28835177E-06_JPRB, 0.30005597E-06_JPRB, 0.31939362E-06_JPRB, 0.35094112E-06_JPRB, &
  & 0.39943413E-06_JPRB, 0.46624439E-06_JPRB, 0.54876301E-06_JPRB, 0.62554494E-06_JPRB, 0.67918734E-06_JPRB, 0.73911906E-06_JPRB, &
  & 0.34298632E-05_JPRB, 0.23479452E-04_JPRB, 0.23262621E-04_JPRB, 0.22969967E-04_JPRB /)

RGHG7(:, 3, 2) = (/ &
  & 0.31718378E-06_JPRB, 0.31896718E-06_JPRB, 0.32188640E-06_JPRB, 0.34727304E-06_JPRB, 0.36959938E-06_JPRB, 0.38205619E-06_JPRB, &
  & 0.38681375E-06_JPRB, 0.37989437E-06_JPRB, 0.37296132E-06_JPRB, 0.36820157E-06_JPRB, 0.36930160E-06_JPRB, 0.37869341E-06_JPRB, &
  & 0.38019485E-06_JPRB, 0.37847391E-06_JPRB, 0.37751624E-06_JPRB, 0.37617122E-06_JPRB, 0.37594327E-06_JPRB, 0.37921276E-06_JPRB, &
  & 0.39082022E-06_JPRB, 0.39770188E-06_JPRB, 0.39982916E-06_JPRB, 0.40170943E-06_JPRB, 0.40154546E-06_JPRB, 0.40342337E-06_JPRB, &
  & 0.40253383E-06_JPRB, 0.40209397E-06_JPRB, 0.40138332E-06_JPRB, 0.40059336E-06_JPRB, 0.40099621E-06_JPRB, 0.40180078E-06_JPRB, &
  & 0.40394039E-06_JPRB, 0.40811810E-06_JPRB, 0.41858505E-06_JPRB, 0.43038818E-06_JPRB, 0.43099274E-06_JPRB, 0.43394107E-06_JPRB, &
  & 0.43423384E-06_JPRB, 0.43484002E-06_JPRB, 0.43426934E-06_JPRB, 0.43369275E-06_JPRB, 0.43464263E-06_JPRB, 0.43742460E-06_JPRB, &
  & 0.44202673E-06_JPRB, 0.44880730E-06_JPRB, 0.45810492E-06_JPRB, 0.47080442E-06_JPRB, 0.48725940E-06_JPRB, 0.50969771E-06_JPRB, &
  & 0.53055254E-06_JPRB, 0.55805788E-06_JPRB, 0.59096288E-06_JPRB, 0.63021798E-06_JPRB, 0.68146579E-06_JPRB, 0.75827580E-06_JPRB, &
  & 0.87609783E-06_JPRB, 0.10440981E-05_JPRB, 0.12640860E-05_JPRB, 0.14770195E-05_JPRB, 0.15812116E-05_JPRB, 0.18299160E-05_JPRB, &
  & 0.72887287E-05_JPRB, 0.15831884E-04_JPRB, 0.15469610E-04_JPRB, 0.14691203E-04_JPRB /)

RGHG7(:, 4, 2) = (/ &
  & 0.52447439E-06_JPRB, 0.48232243E-06_JPRB, 0.46281406E-06_JPRB, 0.48358612E-06_JPRB, 0.51183935E-06_JPRB, 0.53412975E-06_JPRB, &
  & 0.55426949E-06_JPRB, 0.56537465E-06_JPRB, 0.58079922E-06_JPRB, 0.59178910E-06_JPRB, 0.60630282E-06_JPRB, 0.63154567E-06_JPRB, &
  & 0.64390235E-06_JPRB, 0.65165784E-06_JPRB, 0.65827959E-06_JPRB, 0.66582271E-06_JPRB, 0.67346372E-06_JPRB, 0.68530494E-06_JPRB, &
  & 0.71380225E-06_JPRB, 0.72520533E-06_JPRB, 0.72969283E-06_JPRB, 0.73235088E-06_JPRB, 0.73447779E-06_JPRB, 0.73576552E-06_JPRB, &
  & 0.73507272E-06_JPRB, 0.73409529E-06_JPRB, 0.73120430E-06_JPRB, 0.73111448E-06_JPRB, 0.73066610E-06_JPRB, 0.73201954E-06_JPRB, &
  & 0.73413008E-06_JPRB, 0.73899287E-06_JPRB, 0.75274727E-06_JPRB, 0.76457763E-06_JPRB, 0.76130630E-06_JPRB, 0.76256896E-06_JPRB, &
  & 0.75882559E-06_JPRB, 0.75663860E-06_JPRB, 0.75125524E-06_JPRB, 0.74533108E-06_JPRB, 0.74101416E-06_JPRB, 0.73841460E-06_JPRB, &
  & 0.73675676E-06_JPRB, 0.73628570E-06_JPRB, 0.73765386E-06_JPRB, 0.74393319E-06_JPRB, 0.75485514E-06_JPRB, 0.76987084E-06_JPRB, &
  & 0.77405525E-06_JPRB, 0.76711154E-06_JPRB, 0.74246879E-06_JPRB, 0.71422272E-06_JPRB, 0.69799972E-06_JPRB, 0.70571684E-06_JPRB, &
  & 0.75211494E-06_JPRB, 0.85546924E-06_JPRB, 0.10336964E-05_JPRB, 0.12359862E-05_JPRB, 0.14085600E-05_JPRB, 0.20237826E-05_JPRB, &
  & 0.48439483E-05_JPRB, 0.66379985E-05_JPRB, 0.65088475E-05_JPRB, 0.63741491E-05_JPRB /)

RGHG7(:, 5, 2) = (/ &
  & 0.83758960E-06_JPRB, 0.74997951E-06_JPRB, 0.70256488E-06_JPRB, 0.70950557E-06_JPRB, 0.73294819E-06_JPRB, 0.75323129E-06_JPRB, &
  & 0.77593154E-06_JPRB, 0.79324252E-06_JPRB, 0.82092856E-06_JPRB, 0.84075100E-06_JPRB, 0.86564268E-06_JPRB, 0.90343445E-06_JPRB, &
  & 0.92701754E-06_JPRB, 0.94578922E-06_JPRB, 0.96298561E-06_JPRB, 0.98155670E-06_JPRB, 0.99973613E-06_JPRB, 0.10234370E-05_JPRB, &
  & 0.10676816E-05_JPRB, 0.10845812E-05_JPRB, 0.10948440E-05_JPRB, 0.10989650E-05_JPRB, 0.11031926E-05_JPRB, 0.11039616E-05_JPRB, &
  & 0.11032226E-05_JPRB, 0.11014085E-05_JPRB, 0.10993498E-05_JPRB, 0.10968142E-05_JPRB, 0.10965191E-05_JPRB, 0.10950550E-05_JPRB, &
  & 0.10947767E-05_JPRB, 0.10976809E-05_JPRB, 0.11124674E-05_JPRB, 0.11225432E-05_JPRB, 0.11124647E-05_JPRB, 0.11117477E-05_JPRB, &
  & 0.11033657E-05_JPRB, 0.11004022E-05_JPRB, 0.10931180E-05_JPRB, 0.10859712E-05_JPRB, 0.10778335E-05_JPRB, 0.10690999E-05_JPRB, &
  & 0.10582798E-05_JPRB, 0.10468746E-05_JPRB, 0.10366803E-05_JPRB, 0.10314761E-05_JPRB, 0.10322208E-05_JPRB, 0.10322160E-05_JPRB, &
  & 0.10139506E-05_JPRB, 0.99690624E-06_JPRB, 0.99280419E-06_JPRB, 0.10087298E-05_JPRB, 0.10309784E-05_JPRB, 0.10610293E-05_JPRB, &
  & 0.11205218E-05_JPRB, 0.12341941E-05_JPRB, 0.14411280E-05_JPRB, 0.17100292E-05_JPRB, 0.19615784E-05_JPRB, 0.25227819E-05_JPRB, &
  & 0.33020833E-05_JPRB, 0.38115563E-05_JPRB, 0.38002031E-05_JPRB, 0.37773334E-05_JPRB /)

RGHG7(:, 6, 2) = (/ &
  & 0.12202361E-05_JPRB, 0.11110322E-05_JPRB, 0.10420845E-05_JPRB, 0.10306748E-05_JPRB, 0.10447840E-05_JPRB, 0.10592091E-05_JPRB, &
  & 0.10795983E-05_JPRB, 0.10971789E-05_JPRB, 0.11281426E-05_JPRB, 0.11524231E-05_JPRB, 0.11838498E-05_JPRB, 0.12304718E-05_JPRB, &
  & 0.12634706E-05_JPRB, 0.12919385E-05_JPRB, 0.13185622E-05_JPRB, 0.13458825E-05_JPRB, 0.13719615E-05_JPRB, 0.14031812E-05_JPRB, &
  & 0.14550816E-05_JPRB, 0.14760913E-05_JPRB, 0.14894805E-05_JPRB, 0.14949110E-05_JPRB, 0.14994060E-05_JPRB, 0.15016268E-05_JPRB, &
  & 0.15026410E-05_JPRB, 0.15028185E-05_JPRB, 0.15024777E-05_JPRB, 0.14997545E-05_JPRB, 0.14957935E-05_JPRB, 0.14909607E-05_JPRB, &
  & 0.14825443E-05_JPRB, 0.14818461E-05_JPRB, 0.14953772E-05_JPRB, 0.15049142E-05_JPRB, 0.14915917E-05_JPRB, 0.14937403E-05_JPRB, &
  & 0.14854023E-05_JPRB, 0.14849454E-05_JPRB, 0.14778024E-05_JPRB, 0.14707933E-05_JPRB, 0.14587466E-05_JPRB, 0.14431912E-05_JPRB, &
  & 0.14220099E-05_JPRB, 0.13984703E-05_JPRB, 0.13754851E-05_JPRB, 0.13571432E-05_JPRB, 0.13439710E-05_JPRB, 0.13308747E-05_JPRB, &
  & 0.13074895E-05_JPRB, 0.12947917E-05_JPRB, 0.12766399E-05_JPRB, 0.12400192E-05_JPRB, 0.11986006E-05_JPRB, 0.11829768E-05_JPRB, &
  & 0.12107186E-05_JPRB, 0.12880478E-05_JPRB, 0.14293601E-05_JPRB, 0.16155609E-05_JPRB, 0.18350294E-05_JPRB, 0.22189520E-05_JPRB, &
  & 0.25717584E-05_JPRB, 0.27855094E-05_JPRB, 0.27250765E-05_JPRB, 0.27458736E-05_JPRB /)

RGHG7(:, 7, 2) = (/ &
  & 0.16499833E-05_JPRB, 0.15536586E-05_JPRB, 0.14870064E-05_JPRB, 0.14638088E-05_JPRB, 0.14666577E-05_JPRB, 0.14765122E-05_JPRB, &
  & 0.14944629E-05_JPRB, 0.15118528E-05_JPRB, 0.15441020E-05_JPRB, 0.15709289E-05_JPRB, 0.16055759E-05_JPRB, 0.16571097E-05_JPRB, &
  & 0.16963382E-05_JPRB, 0.17320672E-05_JPRB, 0.17660989E-05_JPRB, 0.18006047E-05_JPRB, 0.18343333E-05_JPRB, 0.18723940E-05_JPRB, &
  & 0.19299830E-05_JPRB, 0.19581996E-05_JPRB, 0.19738652E-05_JPRB, 0.19819145E-05_JPRB, 0.19872971E-05_JPRB, 0.19921545E-05_JPRB, &
  & 0.19953704E-05_JPRB, 0.19977363E-05_JPRB, 0.20003558E-05_JPRB, 0.19968923E-05_JPRB, 0.19914612E-05_JPRB, 0.19823194E-05_JPRB, &
  & 0.19680524E-05_JPRB, 0.19629852E-05_JPRB, 0.19776908E-05_JPRB, 0.19874385E-05_JPRB, 0.19748582E-05_JPRB, 0.19810807E-05_JPRB, &
  & 0.19763629E-05_JPRB, 0.19797162E-05_JPRB, 0.19741019E-05_JPRB, 0.19670845E-05_JPRB, 0.19512322E-05_JPRB, 0.19287529E-05_JPRB, &
  & 0.18982447E-05_JPRB, 0.18649062E-05_JPRB, 0.18335845E-05_JPRB, 0.18082268E-05_JPRB, 0.17871176E-05_JPRB, 0.17693606E-05_JPRB, &
  & 0.17453001E-05_JPRB, 0.17236410E-05_JPRB, 0.16967740E-05_JPRB, 0.16872773E-05_JPRB, 0.17095829E-05_JPRB, 0.17496396E-05_JPRB, &
  & 0.18010595E-05_JPRB, 0.18743052E-05_JPRB, 0.19940048E-05_JPRB, 0.21495000E-05_JPRB, 0.23094597E-05_JPRB, 0.24358337E-05_JPRB, &
  & 0.24762901E-05_JPRB, 0.25442234E-05_JPRB, 0.25243573E-05_JPRB, 0.25585821E-05_JPRB /)

RGHG7(:, 8, 2) = (/ &
  & 0.19914437E-05_JPRB, 0.19388094E-05_JPRB, 0.19051779E-05_JPRB, 0.18948422E-05_JPRB, 0.19002900E-05_JPRB, 0.19104259E-05_JPRB, &
  & 0.19275201E-05_JPRB, 0.19446582E-05_JPRB, 0.19749511E-05_JPRB, 0.20015220E-05_JPRB, 0.20357554E-05_JPRB, 0.20870800E-05_JPRB, &
  & 0.21278929E-05_JPRB, 0.21667270E-05_JPRB, 0.22042032E-05_JPRB, 0.22407635E-05_JPRB, 0.22762083E-05_JPRB, 0.23157706E-05_JPRB, &
  & 0.23732700E-05_JPRB, 0.24061690E-05_JPRB, 0.24258122E-05_JPRB, 0.24437884E-05_JPRB, 0.24543447E-05_JPRB, 0.24650103E-05_JPRB, &
  & 0.24720848E-05_JPRB, 0.24791323E-05_JPRB, 0.24837436E-05_JPRB, 0.24818864E-05_JPRB, 0.24800734E-05_JPRB, 0.24746096E-05_JPRB, &
  & 0.24655958E-05_JPRB, 0.24657759E-05_JPRB, 0.24868227E-05_JPRB, 0.24966009E-05_JPRB, 0.24825549E-05_JPRB, 0.24827139E-05_JPRB, &
  & 0.24721926E-05_JPRB, 0.24682647E-05_JPRB, 0.24557610E-05_JPRB, 0.24417755E-05_JPRB, 0.24203332E-05_JPRB, 0.23945836E-05_JPRB, &
  & 0.23643204E-05_JPRB, 0.23352527E-05_JPRB, 0.23102800E-05_JPRB, 0.22914903E-05_JPRB, 0.22752793E-05_JPRB, 0.22657434E-05_JPRB, &
  & 0.22526604E-05_JPRB, 0.22406373E-05_JPRB, 0.22366937E-05_JPRB, 0.22401193E-05_JPRB, 0.22402917E-05_JPRB, 0.22457723E-05_JPRB, &
  & 0.22788927E-05_JPRB, 0.23384882E-05_JPRB, 0.24160511E-05_JPRB, 0.24868932E-05_JPRB, 0.25423294E-05_JPRB, 0.25804031E-05_JPRB, &
  & 0.26075641E-05_JPRB, 0.26365244E-05_JPRB, 0.26078676E-05_JPRB, 0.26158598E-05_JPRB /)

RGHG7(:, 9, 2) = (/ &
  & 0.23785435E-05_JPRB, 0.23671455E-05_JPRB, 0.23677571E-05_JPRB, 0.23799114E-05_JPRB, 0.23890982E-05_JPRB, 0.24010674E-05_JPRB, &
  & 0.24197805E-05_JPRB, 0.24371921E-05_JPRB, 0.24692943E-05_JPRB, 0.24986214E-05_JPRB, 0.25352012E-05_JPRB, 0.25895613E-05_JPRB, &
  & 0.26349617E-05_JPRB, 0.26791331E-05_JPRB, 0.27225028E-05_JPRB, 0.27655403E-05_JPRB, 0.28076183E-05_JPRB, 0.28537611E-05_JPRB, &
  & 0.29151058E-05_JPRB, 0.29554519E-05_JPRB, 0.29827042E-05_JPRB, 0.30104886E-05_JPRB, 0.30285064E-05_JPRB, 0.30437070E-05_JPRB, &
  & 0.30560045E-05_JPRB, 0.30663859E-05_JPRB, 0.30735689E-05_JPRB, 0.30767783E-05_JPRB, 0.30829513E-05_JPRB, 0.30885280E-05_JPRB, &
  & 0.30931501E-05_JPRB, 0.31070513E-05_JPRB, 0.31410955E-05_JPRB, 0.31545067E-05_JPRB, 0.31384698E-05_JPRB, 0.31259419E-05_JPRB, &
  & 0.30992276E-05_JPRB, 0.30761464E-05_JPRB, 0.30478611E-05_JPRB, 0.30196400E-05_JPRB, 0.29874989E-05_JPRB, 0.29561575E-05_JPRB, &
  & 0.29268588E-05_JPRB, 0.29038572E-05_JPRB, 0.28889285E-05_JPRB, 0.28845720E-05_JPRB, 0.28866414E-05_JPRB, 0.28908485E-05_JPRB, &
  & 0.28918189E-05_JPRB, 0.28931108E-05_JPRB, 0.28989650E-05_JPRB, 0.29086530E-05_JPRB, 0.29340210E-05_JPRB, 0.29794976E-05_JPRB, &
  & 0.30271608E-05_JPRB, 0.30587744E-05_JPRB, 0.30729216E-05_JPRB, 0.30532042E-05_JPRB, 0.30030556E-05_JPRB, 0.29399489E-05_JPRB, &
  & 0.28966206E-05_JPRB, 0.28821485E-05_JPRB, 0.28586530E-05_JPRB, 0.28437296E-05_JPRB /)

RGHG7(:,10, 2) = (/ &
  & 0.27718336E-05_JPRB, 0.28039392E-05_JPRB, 0.28494094E-05_JPRB, 0.29017258E-05_JPRB, 0.29375340E-05_JPRB, 0.29649518E-05_JPRB, &
  & 0.29931800E-05_JPRB, 0.30192462E-05_JPRB, 0.30590804E-05_JPRB, 0.30958070E-05_JPRB, 0.31401892E-05_JPRB, 0.32020648E-05_JPRB, &
  & 0.32552327E-05_JPRB, 0.33081044E-05_JPRB, 0.33594144E-05_JPRB, 0.34088798E-05_JPRB, 0.34571767E-05_JPRB, 0.35094417E-05_JPRB, &
  & 0.35763881E-05_JPRB, 0.36241422E-05_JPRB, 0.36613478E-05_JPRB, 0.36961444E-05_JPRB, 0.37249379E-05_JPRB, 0.37436757E-05_JPRB, &
  & 0.37594007E-05_JPRB, 0.37709285E-05_JPRB, 0.37793504E-05_JPRB, 0.37854236E-05_JPRB, 0.37959235E-05_JPRB, 0.38095345E-05_JPRB, &
  & 0.38236353E-05_JPRB, 0.38460848E-05_JPRB, 0.38866128E-05_JPRB, 0.38995590E-05_JPRB, 0.38789240E-05_JPRB, 0.38533231E-05_JPRB, &
  & 0.38118608E-05_JPRB, 0.37664925E-05_JPRB, 0.37160871E-05_JPRB, 0.36726890E-05_JPRB, 0.36316392E-05_JPRB, 0.35995295E-05_JPRB, &
  & 0.35778085E-05_JPRB, 0.35711655E-05_JPRB, 0.35785824E-05_JPRB, 0.35987457E-05_JPRB, 0.36252743E-05_JPRB, 0.36473814E-05_JPRB, &
  & 0.36673639E-05_JPRB, 0.36900160E-05_JPRB, 0.37141649E-05_JPRB, 0.37419700E-05_JPRB, 0.37724465E-05_JPRB, 0.37903671E-05_JPRB, &
  & 0.37862553E-05_JPRB, 0.37534039E-05_JPRB, 0.36812405E-05_JPRB, 0.35635642E-05_JPRB, 0.34330876E-05_JPRB, 0.33313527E-05_JPRB, &
  & 0.32711373E-05_JPRB, 0.32444382E-05_JPRB, 0.32159869E-05_JPRB, 0.31771756E-05_JPRB /)

RGHG7(:,11, 2) = (/ &
  & 0.32570920E-05_JPRB, 0.34121547E-05_JPRB, 0.35359558E-05_JPRB, 0.36617432E-05_JPRB, 0.37374389E-05_JPRB, 0.37848718E-05_JPRB, &
  & 0.38218536E-05_JPRB, 0.38482003E-05_JPRB, 0.38837793E-05_JPRB, 0.39126335E-05_JPRB, 0.39471943E-05_JPRB, 0.40000609E-05_JPRB, &
  & 0.40449299E-05_JPRB, 0.40912760E-05_JPRB, 0.41398212E-05_JPRB, 0.41891467E-05_JPRB, 0.42400397E-05_JPRB, 0.42955012E-05_JPRB, &
  & 0.43674245E-05_JPRB, 0.44175417E-05_JPRB, 0.44592234E-05_JPRB, 0.44915109E-05_JPRB, 0.45199781E-05_JPRB, 0.45401489E-05_JPRB, &
  & 0.45541706E-05_JPRB, 0.45678676E-05_JPRB, 0.45816550E-05_JPRB, 0.45960173E-05_JPRB, 0.46159707E-05_JPRB, 0.46415275E-05_JPRB, &
  & 0.46670589E-05_JPRB, 0.46978612E-05_JPRB, 0.47409785E-05_JPRB, 0.47475532E-05_JPRB, 0.47133444E-05_JPRB, 0.46644491E-05_JPRB, &
  & 0.46023920E-05_JPRB, 0.45487204E-05_JPRB, 0.44905187E-05_JPRB, 0.44445046E-05_JPRB, 0.44121798E-05_JPRB, 0.43988703E-05_JPRB, &
  & 0.44051567E-05_JPRB, 0.44323551E-05_JPRB, 0.44734857E-05_JPRB, 0.45223924E-05_JPRB, 0.45744787E-05_JPRB, 0.46164491E-05_JPRB, &
  & 0.46505988E-05_JPRB, 0.46761352E-05_JPRB, 0.46937639E-05_JPRB, 0.47009148E-05_JPRB, 0.46927939E-05_JPRB, 0.46595273E-05_JPRB, &
  & 0.45776742E-05_JPRB, 0.44304043E-05_JPRB, 0.42324668E-05_JPRB, 0.40157379E-05_JPRB, 0.38402359E-05_JPRB, 0.37172488E-05_JPRB, &
  & 0.36500276E-05_JPRB, 0.36161318E-05_JPRB, 0.35866767E-05_JPRB, 0.35370024E-05_JPRB /)

RGHG7(:,12, 2) = (/ &
  & 0.36947015E-05_JPRB, 0.38482435E-05_JPRB, 0.40068658E-05_JPRB, 0.41941262E-05_JPRB, 0.43310506E-05_JPRB, 0.44294152E-05_JPRB, &
  & 0.45054803E-05_JPRB, 0.45619636E-05_JPRB, 0.46206278E-05_JPRB, 0.46681221E-05_JPRB, 0.47176036E-05_JPRB, 0.47825124E-05_JPRB, &
  & 0.48386473E-05_JPRB, 0.48955267E-05_JPRB, 0.49548730E-05_JPRB, 0.50158551E-05_JPRB, 0.50807093E-05_JPRB, 0.51519878E-05_JPRB, &
  & 0.52393743E-05_JPRB, 0.53065269E-05_JPRB, 0.53642470E-05_JPRB, 0.54141801E-05_JPRB, 0.54567518E-05_JPRB, 0.54958837E-05_JPRB, &
  & 0.55302326E-05_JPRB, 0.55620685E-05_JPRB, 0.55961004E-05_JPRB, 0.56302461E-05_JPRB, 0.56648446E-05_JPRB, 0.57008501E-05_JPRB, &
  & 0.57307116E-05_JPRB, 0.57596462E-05_JPRB, 0.57956631E-05_JPRB, 0.57895627E-05_JPRB, 0.57407015E-05_JPRB, 0.56748313E-05_JPRB, &
  & 0.55872488E-05_JPRB, 0.54996135E-05_JPRB, 0.54306583E-05_JPRB, 0.53783078E-05_JPRB, 0.53486256E-05_JPRB, 0.53490053E-05_JPRB, &
  & 0.53790909E-05_JPRB, 0.54324919E-05_JPRB, 0.54978846E-05_JPRB, 0.55651240E-05_JPRB, 0.56288159E-05_JPRB, 0.56690651E-05_JPRB, &
  & 0.56876929E-05_JPRB, 0.56868253E-05_JPRB, 0.56637396E-05_JPRB, 0.56098938E-05_JPRB, 0.55182841E-05_JPRB, 0.53759159E-05_JPRB, &
  & 0.51635093E-05_JPRB, 0.48954425E-05_JPRB, 0.46099490E-05_JPRB, 0.43559216E-05_JPRB, 0.41633507E-05_JPRB, 0.40482964E-05_JPRB, &
  & 0.39811785E-05_JPRB, 0.39458291E-05_JPRB, 0.39168713E-05_JPRB, 0.38670237E-05_JPRB /)

RGHG7(:,13, 2) = (/ &
  & 0.38551966E-05_JPRB, 0.40068039E-05_JPRB, 0.41877879E-05_JPRB, 0.44193957E-05_JPRB, 0.46242667E-05_JPRB, 0.47951999E-05_JPRB, &
  & 0.49397008E-05_JPRB, 0.50592494E-05_JPRB, 0.51720999E-05_JPRB, 0.52672699E-05_JPRB, 0.53579761E-05_JPRB, 0.54562051E-05_JPRB, &
  & 0.55409723E-05_JPRB, 0.56217991E-05_JPRB, 0.57033112E-05_JPRB, 0.57856114E-05_JPRB, 0.58719629E-05_JPRB, 0.59679373E-05_JPRB, &
  & 0.60781740E-05_JPRB, 0.61733672E-05_JPRB, 0.62589766E-05_JPRB, 0.63369785E-05_JPRB, 0.64098704E-05_JPRB, 0.64792816E-05_JPRB, &
  & 0.65476961E-05_JPRB, 0.66122698E-05_JPRB, 0.66732255E-05_JPRB, 0.67287315E-05_JPRB, 0.67715337E-05_JPRB, 0.68029954E-05_JPRB, &
  & 0.68160862E-05_JPRB, 0.68183640E-05_JPRB, 0.68234121E-05_JPRB, 0.67899778E-05_JPRB, 0.67196370E-05_JPRB, 0.66340544E-05_JPRB, &
  & 0.65482086E-05_JPRB, 0.64654828E-05_JPRB, 0.63948796E-05_JPRB, 0.63397538E-05_JPRB, 0.63052898E-05_JPRB, 0.62929171E-05_JPRB, &
  & 0.63037892E-05_JPRB, 0.63293423E-05_JPRB, 0.63613702E-05_JPRB, 0.63904631E-05_JPRB, 0.64118935E-05_JPRB, 0.64051915E-05_JPRB, &
  & 0.63721636E-05_JPRB, 0.63114535E-05_JPRB, 0.62172771E-05_JPRB, 0.60842585E-05_JPRB, 0.59069184E-05_JPRB, 0.56808144E-05_JPRB, &
  & 0.53994777E-05_JPRB, 0.50825665E-05_JPRB, 0.47728295E-05_JPRB, 0.45099509E-05_JPRB, 0.43328000E-05_JPRB, 0.42235979E-05_JPRB, &
  & 0.41683857E-05_JPRB, 0.41399067E-05_JPRB, 0.41176490E-05_JPRB, 0.40821947E-05_JPRB /)

RGHG7(:,14, 2) = (/ &
  & 0.39652718E-05_JPRB, 0.41057210E-05_JPRB, 0.42920924E-05_JPRB, 0.45418160E-05_JPRB, 0.47893300E-05_JPRB, 0.50152266E-05_JPRB, &
  & 0.52178561E-05_JPRB, 0.53946819E-05_JPRB, 0.55603650E-05_JPRB, 0.57056845E-05_JPRB, 0.58425417E-05_JPRB, 0.59815361E-05_JPRB, &
  & 0.61056185E-05_JPRB, 0.62224321E-05_JPRB, 0.63381667E-05_JPRB, 0.64543538E-05_JPRB, 0.65755639E-05_JPRB, 0.67075252E-05_JPRB, &
  & 0.68534778E-05_JPRB, 0.69877897E-05_JPRB, 0.71126938E-05_JPRB, 0.72290973E-05_JPRB, 0.73399833E-05_JPRB, 0.74445293E-05_JPRB, &
  & 0.75444418E-05_JPRB, 0.76362221E-05_JPRB, 0.77143895E-05_JPRB, 0.77749373E-05_JPRB, 0.78073472E-05_JPRB, 0.78129842E-05_JPRB, &
  & 0.77895356E-05_JPRB, 0.77488667E-05_JPRB, 0.77097111E-05_JPRB, 0.76410815E-05_JPRB, 0.75490620E-05_JPRB, 0.74477794E-05_JPRB, &
  & 0.73513138E-05_JPRB, 0.72618886E-05_JPRB, 0.71878367E-05_JPRB, 0.71230525E-05_JPRB, 0.70725691E-05_JPRB, 0.70299884E-05_JPRB, &
  & 0.69945099E-05_JPRB, 0.69611251E-05_JPRB, 0.69273119E-05_JPRB, 0.68888858E-05_JPRB, 0.68431614E-05_JPRB, 0.67697520E-05_JPRB, &
  & 0.66692710E-05_JPRB, 0.65394138E-05_JPRB, 0.63795023E-05_JPRB, 0.61843475E-05_JPRB, 0.59529193E-05_JPRB, 0.56862682E-05_JPRB, &
  & 0.53848944E-05_JPRB, 0.50717886E-05_JPRB, 0.47833319E-05_JPRB, 0.45505212E-05_JPRB, 0.43872224E-05_JPRB, 0.42914835E-05_JPRB, &
  & 0.42447464E-05_JPRB, 0.42236420E-05_JPRB, 0.42084598E-05_JPRB, 0.41898261E-05_JPRB /)

RGHG7(:,15, 2) = (/ &
  & 0.40545847E-05_JPRB, 0.41814637E-05_JPRB, 0.43582945E-05_JPRB, 0.46055075E-05_JPRB, 0.48703309E-05_JPRB, 0.51278566E-05_JPRB, &
  & 0.53705548E-05_JPRB, 0.55914561E-05_JPRB, 0.58010105E-05_JPRB, 0.59916088E-05_JPRB, 0.61731903E-05_JPRB, 0.63535449E-05_JPRB, &
  & 0.65189979E-05_JPRB, 0.66755724E-05_JPRB, 0.68292593E-05_JPRB, 0.69826128E-05_JPRB, 0.71406780E-05_JPRB, 0.73085289E-05_JPRB, &
  & 0.74916134E-05_JPRB, 0.76642600E-05_JPRB, 0.78263747E-05_JPRB, 0.79790198E-05_JPRB, 0.81209864E-05_JPRB, 0.82501601E-05_JPRB, &
  & 0.83666100E-05_JPRB, 0.84663479E-05_JPRB, 0.85420206E-05_JPRB, 0.85891215E-05_JPRB, 0.85987476E-05_JPRB, 0.85734455E-05_JPRB, &
  & 0.85168122E-05_JPRB, 0.84432831E-05_JPRB, 0.83705927E-05_JPRB, 0.82649713E-05_JPRB, 0.81449853E-05_JPRB, 0.80366144E-05_JPRB, &
  & 0.79382071E-05_JPRB, 0.78507828E-05_JPRB, 0.77734658E-05_JPRB, 0.77001951E-05_JPRB, 0.76279016E-05_JPRB, 0.75514204E-05_JPRB, &
  & 0.74668533E-05_JPRB, 0.73738902E-05_JPRB, 0.72733433E-05_JPRB, 0.71660629E-05_JPRB, 0.70519909E-05_JPRB, 0.69144216E-05_JPRB, &
  & 0.67549167E-05_JPRB, 0.65709446E-05_JPRB, 0.63636726E-05_JPRB, 0.61287624E-05_JPRB, 0.58714372E-05_JPRB, 0.55947316E-05_JPRB, &
  & 0.53050521E-05_JPRB, 0.50205635E-05_JPRB, 0.47633139E-05_JPRB, 0.45520974E-05_JPRB, 0.44020330E-05_JPRB, 0.43092246E-05_JPRB, &
  & 0.42690085E-05_JPRB, 0.42512111E-05_JPRB, 0.42415022E-05_JPRB, 0.42298702E-05_JPRB /)

RGHG7(:,16, 2) = (/ &
  & 0.40501736E-05_JPRB, 0.41735243E-05_JPRB, 0.43352798E-05_JPRB, 0.45656361E-05_JPRB, 0.48267193E-05_JPRB, 0.50949238E-05_JPRB, &
  & 0.53563522E-05_JPRB, 0.56053614E-05_JPRB, 0.58458327E-05_JPRB, 0.60722218E-05_JPRB, 0.62917943E-05_JPRB, 0.65101362E-05_JPRB, &
  & 0.67163787E-05_JPRB, 0.69151438E-05_JPRB, 0.71119057E-05_JPRB, 0.73088581E-05_JPRB, 0.75088569E-05_JPRB, 0.77169052E-05_JPRB, &
  & 0.79368592E-05_JPRB, 0.81432072E-05_JPRB, 0.83363748E-05_JPRB, 0.85142765E-05_JPRB, 0.86726495E-05_JPRB, 0.88088764E-05_JPRB, &
  & 0.89213963E-05_JPRB, 0.90059129E-05_JPRB, 0.90593785E-05_JPRB, 0.90772000E-05_JPRB, 0.90552494E-05_JPRB, 0.89989999E-05_JPRB, &
  & 0.89155474E-05_JPRB, 0.88191364E-05_JPRB, 0.87243834E-05_JPRB, 0.86174887E-05_JPRB, 0.85051661E-05_JPRB, 0.83865698E-05_JPRB, &
  & 0.82827555E-05_JPRB, 0.81894841E-05_JPRB, 0.81021872E-05_JPRB, 0.80123837E-05_JPRB, 0.79177325E-05_JPRB, 0.78116736E-05_JPRB, &
  & 0.76906226E-05_JPRB, 0.75540229E-05_JPRB, 0.74045297E-05_JPRB, 0.72465486E-05_JPRB, 0.70812271E-05_JPRB, 0.68981926E-05_JPRB, &
  & 0.66976645E-05_JPRB, 0.64793248E-05_JPRB, 0.62457293E-05_JPRB, 0.59967319E-05_JPRB, 0.57386333E-05_JPRB, 0.54756142E-05_JPRB, &
  & 0.52153755E-05_JPRB, 0.49692426E-05_JPRB, 0.47505869E-05_JPRB, 0.45660709E-05_JPRB, 0.44295748E-05_JPRB, 0.43482182E-05_JPRB, &
  & 0.43095311E-05_JPRB, 0.42903689E-05_JPRB, 0.42758761E-05_JPRB, 0.42570059E-05_JPRB /)

RGHG7(:,17, 2) = (/ &
  & 0.40746827E-05_JPRB, 0.41970566E-05_JPRB, 0.43461851E-05_JPRB, 0.45585930E-05_JPRB, 0.48096240E-05_JPRB, 0.50785957E-05_JPRB, &
  & 0.53514987E-05_JPRB, 0.56187296E-05_JPRB, 0.58828282E-05_JPRB, 0.61379424E-05_JPRB, 0.63901566E-05_JPRB, 0.66431958E-05_JPRB, &
  & 0.68856434E-05_JPRB, 0.71205623E-05_JPRB, 0.73547935E-05_JPRB, 0.75873240E-05_JPRB, 0.78186076E-05_JPRB, 0.80547943E-05_JPRB, &
  & 0.82949437E-05_JPRB, 0.85168213E-05_JPRB, 0.87202252E-05_JPRB, 0.89002015E-05_JPRB, 0.90530784E-05_JPRB, 0.91768698E-05_JPRB, &
  & 0.92691162E-05_JPRB, 0.93288709E-05_JPRB, 0.93563476E-05_JPRB, 0.93522931E-05_JPRB, 0.93146582E-05_JPRB, 0.92449809E-05_JPRB, &
  & 0.91576494E-05_JPRB, 0.90580861E-05_JPRB, 0.89626610E-05_JPRB, 0.88506440E-05_JPRB, 0.87363378E-05_JPRB, 0.86316832E-05_JPRB, &
  & 0.85335823E-05_JPRB, 0.84390322E-05_JPRB, 0.83457398E-05_JPRB, 0.82452825E-05_JPRB, 0.81304916E-05_JPRB, 0.79975407E-05_JPRB, &
  & 0.78460725E-05_JPRB, 0.76777415E-05_JPRB, 0.74956470E-05_JPRB, 0.73041133E-05_JPRB, 0.71051950E-05_JPRB, 0.68923991E-05_JPRB, &
  & 0.66649850E-05_JPRB, 0.64260362E-05_JPRB, 0.61789920E-05_JPRB, 0.59264908E-05_JPRB, 0.56743447E-05_JPRB, 0.54274819E-05_JPRB, &
  & 0.51910501E-05_JPRB, 0.49717942E-05_JPRB, 0.47740564E-05_JPRB, 0.46049231E-05_JPRB, 0.44783278E-05_JPRB, 0.44054354E-05_JPRB, &
  & 0.43702153E-05_JPRB, 0.43490259E-05_JPRB, 0.43320520E-05_JPRB, 0.43083860E-05_JPRB /)

RGHG7(:,18, 2) = (/ &
  & 0.40724685E-05_JPRB, 0.42087099E-05_JPRB, 0.43552382E-05_JPRB, 0.45539773E-05_JPRB, 0.47916360E-05_JPRB, 0.50541880E-05_JPRB, &
  & 0.53275116E-05_JPRB, 0.56035342E-05_JPRB, 0.58812775E-05_JPRB, 0.61545420E-05_JPRB, 0.64266787E-05_JPRB, 0.67030342E-05_JPRB, &
  & 0.69700968E-05_JPRB, 0.72264806E-05_JPRB, 0.74826321E-05_JPRB, 0.77341419E-05_JPRB, 0.79787369E-05_JPRB, 0.82203505E-05_JPRB, &
  & 0.84577669E-05_JPRB, 0.86729406E-05_JPRB, 0.88635416E-05_JPRB, 0.90285548E-05_JPRB, 0.91647044E-05_JPRB, 0.92703713E-05_JPRB, &
  & 0.93446552E-05_JPRB, 0.93885046E-05_JPRB, 0.94043808E-05_JPRB, 0.93914650E-05_JPRB, 0.93541894E-05_JPRB, 0.92997170E-05_JPRB, &
  & 0.92287100E-05_JPRB, 0.91497150E-05_JPRB, 0.90724343E-05_JPRB, 0.89826826E-05_JPRB, 0.88882498E-05_JPRB, 0.87890530E-05_JPRB, &
  & 0.86884411E-05_JPRB, 0.85838146E-05_JPRB, 0.84718877E-05_JPRB, 0.83491268E-05_JPRB, 0.82138868E-05_JPRB, 0.80618029E-05_JPRB, &
  & 0.78918893E-05_JPRB, 0.77058103E-05_JPRB, 0.75073685E-05_JPRB, 0.73023107E-05_JPRB, 0.70913848E-05_JPRB, 0.68691347E-05_JPRB, &
  & 0.66367706E-05_JPRB, 0.63981033E-05_JPRB, 0.61556466E-05_JPRB, 0.59135236E-05_JPRB, 0.56767849E-05_JPRB, 0.54489210E-05_JPRB, &
  & 0.52345922E-05_JPRB, 0.50378007E-05_JPRB, 0.48622028E-05_JPRB, 0.47110725E-05_JPRB, 0.46008181E-05_JPRB, 0.45342063E-05_JPRB, &
  & 0.44953281E-05_JPRB, 0.44694398E-05_JPRB, 0.44424423E-05_JPRB, 0.44000540E-05_JPRB /)

RGHG7(:,19, 2) = (/ &
  & 0.40667178E-05_JPRB, 0.42235602E-05_JPRB, 0.43698560E-05_JPRB, 0.45624802E-05_JPRB, 0.47897047E-05_JPRB, 0.50413846E-05_JPRB, &
  & 0.53082326E-05_JPRB, 0.55818705E-05_JPRB, 0.58606602E-05_JPRB, 0.61381534E-05_JPRB, 0.64138176E-05_JPRB, 0.66930565E-05_JPRB, &
  & 0.69646076E-05_JPRB, 0.72212842E-05_JPRB, 0.74725476E-05_JPRB, 0.77169398E-05_JPRB, 0.79480387E-05_JPRB, 0.81681283E-05_JPRB, &
  & 0.83782370E-05_JPRB, 0.85660731E-05_JPRB, 0.87323888E-05_JPRB, 0.88783945E-05_JPRB, 0.90022249E-05_JPRB, 0.91025131E-05_JPRB, &
  & 0.91781694E-05_JPRB, 0.92276032E-05_JPRB, 0.92517594E-05_JPRB, 0.92548644E-05_JPRB, 0.92381524E-05_JPRB, 0.91994498E-05_JPRB, &
  & 0.91499287E-05_JPRB, 0.90921458E-05_JPRB, 0.90342446E-05_JPRB, 0.89600562E-05_JPRB, 0.88769366E-05_JPRB, 0.87819035E-05_JPRB, &
  & 0.86767886E-05_JPRB, 0.85605534E-05_JPRB, 0.84337571E-05_JPRB, 0.82962833E-05_JPRB, 0.81462149E-05_JPRB, 0.79845231E-05_JPRB, &
  & 0.78101402E-05_JPRB, 0.76251076E-05_JPRB, 0.74316872E-05_JPRB, 0.72325352E-05_JPRB, 0.70268534E-05_JPRB, 0.68125414E-05_JPRB, &
  & 0.65908512E-05_JPRB, 0.63648549E-05_JPRB, 0.61386845E-05_JPRB, 0.59166864E-05_JPRB, 0.57023703E-05_JPRB, 0.54981697E-05_JPRB, &
  & 0.53080093E-05_JPRB, 0.51338093E-05_JPRB, 0.49780738E-05_JPRB, 0.48492575E-05_JPRB, 0.47589042E-05_JPRB, 0.47002295E-05_JPRB, &
  & 0.46612386E-05_JPRB, 0.46304262E-05_JPRB, 0.45955712E-05_JPRB, 0.45379288E-05_JPRB /)

RGHG7(:,20, 2) = (/ &
  & 0.40761893E-05_JPRB, 0.42372990E-05_JPRB, 0.43919349E-05_JPRB, 0.45794500E-05_JPRB, 0.47977560E-05_JPRB, 0.50377039E-05_JPRB, &
  & 0.52890700E-05_JPRB, 0.55473452E-05_JPRB, 0.58098631E-05_JPRB, 0.60709599E-05_JPRB, 0.63277821E-05_JPRB, 0.65823247E-05_JPRB, &
  & 0.68280865E-05_JPRB, 0.70576461E-05_JPRB, 0.72743601E-05_JPRB, 0.74811974E-05_JPRB, 0.76734532E-05_JPRB, 0.78528356E-05_JPRB, &
  & 0.80231157E-05_JPRB, 0.81778444E-05_JPRB, 0.83209334E-05_JPRB, 0.84560952E-05_JPRB, 0.85834590E-05_JPRB, 0.86992213E-05_JPRB, &
  & 0.87981725E-05_JPRB, 0.88775641E-05_JPRB, 0.89317900E-05_JPRB, 0.89594851E-05_JPRB, 0.89593095E-05_JPRB, 0.89379619E-05_JPRB, &
  & 0.89019049E-05_JPRB, 0.88528996E-05_JPRB, 0.87973776E-05_JPRB, 0.87241024E-05_JPRB, 0.86344780E-05_JPRB, 0.85303845E-05_JPRB, &
  & 0.84095709E-05_JPRB, 0.82770994E-05_JPRB, 0.81370126E-05_JPRB, 0.79959191E-05_JPRB, 0.78519543E-05_JPRB, 0.77063623E-05_JPRB, &
  & 0.75554153E-05_JPRB, 0.73987276E-05_JPRB, 0.72332386E-05_JPRB, 0.70609181E-05_JPRB, 0.68811219E-05_JPRB, 0.66933862E-05_JPRB, &
  & 0.64985034E-05_JPRB, 0.63007342E-05_JPRB, 0.61036603E-05_JPRB, 0.59105805E-05_JPRB, 0.57242833E-05_JPRB, 0.55477994E-05_JPRB, &
  & 0.53844365E-05_JPRB, 0.52360533E-05_JPRB, 0.51072566E-05_JPRB, 0.50049493E-05_JPRB, 0.49310138E-05_JPRB, 0.48784541E-05_JPRB, &
  & 0.48399852E-05_JPRB, 0.48057341E-05_JPRB, 0.47685094E-05_JPRB, 0.46982273E-05_JPRB /)

RGHG7(:,21, 2) = (/ &
  & 0.40949189E-05_JPRB, 0.42506531E-05_JPRB, 0.43983746E-05_JPRB, 0.45709439E-05_JPRB, 0.47705348E-05_JPRB, 0.49877785E-05_JPRB, &
  & 0.52144865E-05_JPRB, 0.54429270E-05_JPRB, 0.56709118E-05_JPRB, 0.58948071E-05_JPRB, 0.61113187E-05_JPRB, 0.63207558E-05_JPRB, &
  & 0.65179784E-05_JPRB, 0.67005267E-05_JPRB, 0.68680683E-05_JPRB, 0.70237643E-05_JPRB, 0.71687223E-05_JPRB, 0.73047454E-05_JPRB, &
  & 0.74378181E-05_JPRB, 0.75666258E-05_JPRB, 0.76973138E-05_JPRB, 0.78324765E-05_JPRB, 0.79706779E-05_JPRB, 0.81114749E-05_JPRB, &
  & 0.82418755E-05_JPRB, 0.83536879E-05_JPRB, 0.84377161E-05_JPRB, 0.84866997E-05_JPRB, 0.84993881E-05_JPRB, 0.84766389E-05_JPRB, &
  & 0.84287876E-05_JPRB, 0.83568702E-05_JPRB, 0.82717042E-05_JPRB, 0.81696917E-05_JPRB, 0.80501586E-05_JPRB, 0.79195916E-05_JPRB, &
  & 0.77827135E-05_JPRB, 0.76487977E-05_JPRB, 0.75213025E-05_JPRB, 0.74063241E-05_JPRB, 0.72998423E-05_JPRB, 0.71998147E-05_JPRB, &
  & 0.70991041E-05_JPRB, 0.69939201E-05_JPRB, 0.68799595E-05_JPRB, 0.67567130E-05_JPRB, 0.66240600E-05_JPRB, 0.64812652E-05_JPRB, &
  & 0.63295797E-05_JPRB, 0.61739120E-05_JPRB, 0.60165576E-05_JPRB, 0.58618339E-05_JPRB, 0.57124130E-05_JPRB, 0.55704627E-05_JPRB, &
  & 0.54389557E-05_JPRB, 0.53208028E-05_JPRB, 0.52217488E-05_JPRB, 0.51457587E-05_JPRB, 0.50887502E-05_JPRB, 0.50461904E-05_JPRB, &
  & 0.50111785E-05_JPRB, 0.49788218E-05_JPRB, 0.49388141E-05_JPRB, 0.48626198E-05_JPRB /)

RGHG7(:,22, 2) = (/ &
  & 0.41030339E-05_JPRB, 0.42299926E-05_JPRB, 0.43656669E-05_JPRB, 0.45219986E-05_JPRB, 0.46973446E-05_JPRB, 0.48838160E-05_JPRB, &
  & 0.50747053E-05_JPRB, 0.52646851E-05_JPRB, 0.54484535E-05_JPRB, 0.56225549E-05_JPRB, 0.57854936E-05_JPRB, 0.59374424E-05_JPRB, &
  & 0.60759849E-05_JPRB, 0.62014387E-05_JPRB, 0.63158150E-05_JPRB, 0.64214214E-05_JPRB, 0.65224872E-05_JPRB, 0.66232119E-05_JPRB, &
  & 0.67290334E-05_JPRB, 0.68394784E-05_JPRB, 0.69596540E-05_JPRB, 0.70935862E-05_JPRB, 0.72422649E-05_JPRB, 0.73961619E-05_JPRB, &
  & 0.75511116E-05_JPRB, 0.76864599E-05_JPRB, 0.77901286E-05_JPRB, 0.78494795E-05_JPRB, 0.78590419E-05_JPRB, 0.78176126E-05_JPRB, &
  & 0.77348595E-05_JPRB, 0.76158340E-05_JPRB, 0.74839559E-05_JPRB, 0.73301144E-05_JPRB, 0.71731210E-05_JPRB, 0.70216215E-05_JPRB, &
  & 0.68831246E-05_JPRB, 0.67670276E-05_JPRB, 0.66766988E-05_JPRB, 0.66122102E-05_JPRB, 0.65659874E-05_JPRB, 0.65303589E-05_JPRB, &
  & 0.64960095E-05_JPRB, 0.64564915E-05_JPRB, 0.64058740E-05_JPRB, 0.63436482E-05_JPRB, 0.62681447E-05_JPRB, 0.61788455E-05_JPRB, &
  & 0.60794973E-05_JPRB, 0.59727608E-05_JPRB, 0.58618994E-05_JPRB, 0.57508892E-05_JPRB, 0.56413828E-05_JPRB, 0.55359224E-05_JPRB, &
  & 0.54383868E-05_JPRB, 0.53543390E-05_JPRB, 0.52892296E-05_JPRB, 0.52394043E-05_JPRB, 0.52014698E-05_JPRB, 0.51716488E-05_JPRB, &
  & 0.51453940E-05_JPRB, 0.51187153E-05_JPRB, 0.50849203E-05_JPRB, 0.50132057E-05_JPRB /)

RGHG7(:,23, 2) = (/ &
  & 0.40946902E-05_JPRB, 0.41821691E-05_JPRB, 0.42855859E-05_JPRB, 0.44147187E-05_JPRB, 0.45618772E-05_JPRB, 0.47127141E-05_JPRB, &
  & 0.48598476E-05_JPRB, 0.50007843E-05_JPRB, 0.51330649E-05_JPRB, 0.52540904E-05_JPRB, 0.53630251E-05_JPRB, 0.54608217E-05_JPRB, &
  & 0.55466821E-05_JPRB, 0.56234235E-05_JPRB, 0.56938720E-05_JPRB, 0.57606812E-05_JPRB, 0.58278288E-05_JPRB, 0.58992241E-05_JPRB, &
  & 0.59795561E-05_JPRB, 0.60698403E-05_JPRB, 0.61754886E-05_JPRB, 0.62982049E-05_JPRB, 0.64363553E-05_JPRB, 0.65895947E-05_JPRB, &
  & 0.67433257E-05_JPRB, 0.68816175E-05_JPRB, 0.69893626E-05_JPRB, 0.70484621E-05_JPRB, 0.70471910E-05_JPRB, 0.69828320E-05_JPRB, &
  & 0.68640229E-05_JPRB, 0.67085839E-05_JPRB, 0.65308800E-05_JPRB, 0.63455905E-05_JPRB, 0.61680480E-05_JPRB, 0.60123684E-05_JPRB, &
  & 0.58893420E-05_JPRB, 0.58057922E-05_JPRB, 0.57635962E-05_JPRB, 0.57555226E-05_JPRB, 0.57716798E-05_JPRB, 0.57999459E-05_JPRB, &
  & 0.58290639E-05_JPRB, 0.58522160E-05_JPRB, 0.58633423E-05_JPRB, 0.58603759E-05_JPRB, 0.58415676E-05_JPRB, 0.58084497E-05_JPRB, &
  & 0.57611560E-05_JPRB, 0.57039279E-05_JPRB, 0.56401459E-05_JPRB, 0.55726700E-05_JPRB, 0.55050068E-05_JPRB, 0.54402690E-05_JPRB, &
  & 0.53820418E-05_JPRB, 0.53339177E-05_JPRB, 0.52979822E-05_JPRB, 0.52715677E-05_JPRB, 0.52521978E-05_JPRB, 0.52366572E-05_JPRB, &
  & 0.52229516E-05_JPRB, 0.52070209E-05_JPRB, 0.51839779E-05_JPRB, 0.51281145E-05_JPRB /)

RGHG7(:,24, 2) = (/ &
  & 0.40403602E-05_JPRB, 0.40781288E-05_JPRB, 0.41412359E-05_JPRB, 0.42358320E-05_JPRB, 0.43455539E-05_JPRB, 0.44600361E-05_JPRB, &
  & 0.45679053E-05_JPRB, 0.46654932E-05_JPRB, 0.47523649E-05_JPRB, 0.48274269E-05_JPRB, 0.48913676E-05_JPRB, 0.49453570E-05_JPRB, &
  & 0.49904943E-05_JPRB, 0.50295275E-05_JPRB, 0.50652143E-05_JPRB, 0.51012380E-05_JPRB, 0.51411826E-05_JPRB, 0.51887432E-05_JPRB, &
  & 0.52468545E-05_JPRB, 0.53150452E-05_JPRB, 0.53955805E-05_JPRB, 0.54901011E-05_JPRB, 0.56023305E-05_JPRB, 0.57285638E-05_JPRB, &
  & 0.58583532E-05_JPRB, 0.59791769E-05_JPRB, 0.60728207E-05_JPRB, 0.61221444E-05_JPRB, 0.61132878E-05_JPRB, 0.60359635E-05_JPRB, &
  & 0.59068866E-05_JPRB, 0.57373641E-05_JPRB, 0.55470600E-05_JPRB, 0.53562944E-05_JPRB, 0.51846573E-05_JPRB, 0.50464228E-05_JPRB, &
  & 0.49523687E-05_JPRB, 0.49078990E-05_JPRB, 0.49109544E-05_JPRB, 0.49513383E-05_JPRB, 0.50171502E-05_JPRB, 0.50937842E-05_JPRB, &
  & 0.51722841E-05_JPRB, 0.52455248E-05_JPRB, 0.53077042E-05_JPRB, 0.53549211E-05_JPRB, 0.53870099E-05_JPRB, 0.54003758E-05_JPRB, &
  & 0.53996728E-05_JPRB, 0.53872122E-05_JPRB, 0.53652752E-05_JPRB, 0.53384406E-05_JPRB, 0.53097510E-05_JPRB, 0.52821078E-05_JPRB, &
  & 0.52591154E-05_JPRB, 0.52439241E-05_JPRB, 0.52357418E-05_JPRB, 0.52330738E-05_JPRB, 0.52332794E-05_JPRB, 0.52352834E-05_JPRB, &
  & 0.52371111E-05_JPRB, 0.52357900E-05_JPRB, 0.52280529E-05_JPRB, 0.51993179E-05_JPRB /)

RGHG7(:,25, 2) = (/ &
  & 0.39224810E-05_JPRB, 0.39159759E-05_JPRB, 0.39446018E-05_JPRB, 0.40011037E-05_JPRB, 0.40758073E-05_JPRB, 0.41549920E-05_JPRB, &
  & 0.42267725E-05_JPRB, 0.42887582E-05_JPRB, 0.43395576E-05_JPRB, 0.43801779E-05_JPRB, 0.44108110E-05_JPRB, 0.44338040E-05_JPRB, &
  & 0.44507356E-05_JPRB, 0.44631406E-05_JPRB, 0.44752210E-05_JPRB, 0.44900526E-05_JPRB, 0.45093720E-05_JPRB, 0.45347133E-05_JPRB, &
  & 0.45668498E-05_JPRB, 0.46049013E-05_JPRB, 0.46513051E-05_JPRB, 0.47089798E-05_JPRB, 0.47800995E-05_JPRB, 0.48629063E-05_JPRB, &
  & 0.49514483E-05_JPRB, 0.50401081E-05_JPRB, 0.51065426E-05_JPRB, 0.51434831E-05_JPRB, 0.51276247E-05_JPRB, 0.50577305E-05_JPRB, &
  & 0.49377236E-05_JPRB, 0.47819940E-05_JPRB, 0.46122082E-05_JPRB, 0.44470089E-05_JPRB, 0.43033479E-05_JPRB, 0.41995040E-05_JPRB, &
  & 0.41411440E-05_JPRB, 0.41353019E-05_JPRB, 0.41747494E-05_JPRB, 0.42485199E-05_JPRB, 0.43448699E-05_JPRB, 0.44527933E-05_JPRB, &
  & 0.45635315E-05_JPRB, 0.46703740E-05_JPRB, 0.47683593E-05_JPRB, 0.48547890E-05_JPRB, 0.49249388E-05_JPRB, 0.49788937E-05_JPRB, &
  & 0.50178373E-05_JPRB, 0.50425729E-05_JPRB, 0.50568033E-05_JPRB, 0.50641647E-05_JPRB, 0.50685194E-05_JPRB, 0.50729054E-05_JPRB, &
  & 0.50814506E-05_JPRB, 0.50939348E-05_JPRB, 0.51105981E-05_JPRB, 0.51298694E-05_JPRB, 0.51503816E-05_JPRB, 0.51714301E-05_JPRB, &
  & 0.51911879E-05_JPRB, 0.52073542E-05_JPRB, 0.52201613E-05_JPRB, 0.52225087E-05_JPRB /)

RGHG7(:,26, 2) = (/ &
  & 0.37468747E-05_JPRB, 0.36975230E-05_JPRB, 0.36969277E-05_JPRB, 0.37219002E-05_JPRB, 0.37655566E-05_JPRB, 0.38142741E-05_JPRB, &
  & 0.38585736E-05_JPRB, 0.38945873E-05_JPRB, 0.39211245E-05_JPRB, 0.39377319E-05_JPRB, 0.39480283E-05_JPRB, 0.39508855E-05_JPRB, &
  & 0.39490651E-05_JPRB, 0.39453107E-05_JPRB, 0.39411048E-05_JPRB, 0.39383422E-05_JPRB, 0.39380843E-05_JPRB, 0.39409188E-05_JPRB, &
  & 0.39472702E-05_JPRB, 0.39563129E-05_JPRB, 0.39686138E-05_JPRB, 0.39858469E-05_JPRB, 0.40103218E-05_JPRB, 0.40428940E-05_JPRB, &
  & 0.40848090E-05_JPRB, 0.41317376E-05_JPRB, 0.41705498E-05_JPRB, 0.41887015E-05_JPRB, 0.41734002E-05_JPRB, 0.41192452E-05_JPRB, &
  & 0.40272876E-05_JPRB, 0.39062020E-05_JPRB, 0.37754087E-05_JPRB, 0.36523295E-05_JPRB, 0.35499729E-05_JPRB, 0.34869640E-05_JPRB, &
  & 0.34656259E-05_JPRB, 0.34916188E-05_JPRB, 0.35552762E-05_JPRB, 0.36480681E-05_JPRB, 0.37622726E-05_JPRB, 0.38863900E-05_JPRB, &
  & 0.40139912E-05_JPRB, 0.41413605E-05_JPRB, 0.42639272E-05_JPRB, 0.43761679E-05_JPRB, 0.44750482E-05_JPRB, 0.45593838E-05_JPRB, &
  & 0.46263453E-05_JPRB, 0.46801988E-05_JPRB, 0.47225321E-05_JPRB, 0.47574608E-05_JPRB, 0.47884018E-05_JPRB, 0.48185930E-05_JPRB, &
  & 0.48515476E-05_JPRB, 0.48869433E-05_JPRB, 0.49248792E-05_JPRB, 0.49643982E-05_JPRB, 0.50055628E-05_JPRB, 0.50470780E-05_JPRB, &
  & 0.50874551E-05_JPRB, 0.51250690E-05_JPRB, 0.51604356E-05_JPRB, 0.52023793E-05_JPRB /)

RGHG7(:,27, 2) = (/ &
  & 0.35132316E-05_JPRB, 0.34306472E-05_JPRB, 0.34087475E-05_JPRB, 0.34114828E-05_JPRB, 0.34303841E-05_JPRB, 0.34575114E-05_JPRB, &
  & 0.34825307E-05_JPRB, 0.35016756E-05_JPRB, 0.35134290E-05_JPRB, 0.35168191E-05_JPRB, 0.35121577E-05_JPRB, 0.35050618E-05_JPRB, &
  & 0.34921884E-05_JPRB, 0.34754021E-05_JPRB, 0.34571697E-05_JPRB, 0.34395666E-05_JPRB, 0.34232128E-05_JPRB, 0.34087177E-05_JPRB, &
  & 0.33948356E-05_JPRB, 0.33793071E-05_JPRB, 0.33609838E-05_JPRB, 0.33423280E-05_JPRB, 0.33254601E-05_JPRB, 0.33153315E-05_JPRB, &
  & 0.33130282E-05_JPRB, 0.33193257E-05_JPRB, 0.33282302E-05_JPRB, 0.33296553E-05_JPRB, 0.33151703E-05_JPRB, 0.32778041E-05_JPRB, &
  & 0.32162420E-05_JPRB, 0.31374350E-05_JPRB, 0.30532758E-05_JPRB, 0.29773455E-05_JPRB, 0.29197538E-05_JPRB, 0.28960353E-05_JPRB, &
  & 0.29069060E-05_JPRB, 0.29557348E-05_JPRB, 0.30354440E-05_JPRB, 0.31387190E-05_JPRB, 0.32568762E-05_JPRB, 0.33844990E-05_JPRB, &
  & 0.35180155E-05_JPRB, 0.36542674E-05_JPRB, 0.37890302E-05_JPRB, 0.39184970E-05_JPRB, 0.40386408E-05_JPRB, 0.41426115E-05_JPRB, &
  & 0.42318043E-05_JPRB, 0.43075461E-05_JPRB, 0.43704881E-05_JPRB, 0.44257581E-05_JPRB, 0.44763437E-05_JPRB, 0.45268416E-05_JPRB, &
  & 0.45785127E-05_JPRB, 0.46323817E-05_JPRB, 0.46886507E-05_JPRB, 0.47472199E-05_JPRB, 0.48083984E-05_JPRB, 0.48708603E-05_JPRB, &
  & 0.49329597E-05_JPRB, 0.49929909E-05_JPRB, 0.50544436E-05_JPRB, 0.51390407E-05_JPRB /)

RGHG7(:,28, 2) = (/ &
  & 0.32352241E-05_JPRB, 0.31304378E-05_JPRB, 0.30957301E-05_JPRB, 0.30848512E-05_JPRB, 0.30888159E-05_JPRB, 0.31009390E-05_JPRB, &
  & 0.31139577E-05_JPRB, 0.31231095E-05_JPRB, 0.31264981E-05_JPRB, 0.31242496E-05_JPRB, 0.31141133E-05_JPRB, 0.30963372E-05_JPRB, &
  & 0.30778833E-05_JPRB, 0.30565573E-05_JPRB, 0.30325521E-05_JPRB, 0.30064875E-05_JPRB, 0.29786047E-05_JPRB, 0.29484247E-05_JPRB, &
  & 0.29148994E-05_JPRB, 0.28769994E-05_JPRB, 0.28340571E-05_JPRB, 0.27878375E-05_JPRB, 0.27401102E-05_JPRB, 0.26964822E-05_JPRB, &
  & 0.26590383E-05_JPRB, 0.26325517E-05_JPRB, 0.26134908E-05_JPRB, 0.25998370E-05_JPRB, 0.25839579E-05_JPRB, 0.25602594E-05_JPRB, &
  & 0.25274103E-05_JPRB, 0.24869189E-05_JPRB, 0.24457945E-05_JPRB, 0.24134602E-05_JPRB, 0.23964101E-05_JPRB, 0.24060801E-05_JPRB, &
  & 0.24422336E-05_JPRB, 0.25068546E-05_JPRB, 0.25937607E-05_JPRB, 0.26959849E-05_JPRB, 0.28104726E-05_JPRB, 0.29349414E-05_JPRB, &
  & 0.30668868E-05_JPRB, 0.32039763E-05_JPRB, 0.33449091E-05_JPRB, 0.34840102E-05_JPRB, 0.36153181E-05_JPRB, 0.37344264E-05_JPRB, &
  & 0.38392609E-05_JPRB, 0.39298825E-05_JPRB, 0.40076629E-05_JPRB, 0.40782447E-05_JPRB, 0.41436747E-05_JPRB, 0.42085826E-05_JPRB, &
  & 0.42744177E-05_JPRB, 0.43426157E-05_JPRB, 0.44141934E-05_JPRB, 0.44893795E-05_JPRB, 0.45686793E-05_JPRB, 0.46509895E-05_JPRB, &
  & 0.47340563E-05_JPRB, 0.48164934E-05_JPRB, 0.49024088E-05_JPRB, 0.50326516E-05_JPRB /)

RGHG7(:,29, 2) = (/ &
  & 0.29299908E-05_JPRB, 0.28150278E-05_JPRB, 0.27742660E-05_JPRB, 0.27564652E-05_JPRB, 0.27523211E-05_JPRB, 0.27559017E-05_JPRB, &
  & 0.27628355E-05_JPRB, 0.27674755E-05_JPRB, 0.27678941E-05_JPRB, 0.27624519E-05_JPRB, 0.27538092E-05_JPRB, 0.27369294E-05_JPRB, &
  & 0.27118417E-05_JPRB, 0.26842720E-05_JPRB, 0.26537348E-05_JPRB, 0.26197902E-05_JPRB, 0.25821316E-05_JPRB, 0.25405598E-05_JPRB, &
  & 0.24941521E-05_JPRB, 0.24414212E-05_JPRB, 0.23823288E-05_JPRB, 0.23182656E-05_JPRB, 0.22508693E-05_JPRB, 0.21845851E-05_JPRB, &
  & 0.21232613E-05_JPRB, 0.20726654E-05_JPRB, 0.20336420E-05_JPRB, 0.20067616E-05_JPRB, 0.19880290E-05_JPRB, 0.19734525E-05_JPRB, &
  & 0.19612221E-05_JPRB, 0.19500442E-05_JPRB, 0.19432109E-05_JPRB, 0.19458746E-05_JPRB, 0.19611377E-05_JPRB, 0.19961915E-05_JPRB, &
  & 0.20502016E-05_JPRB, 0.21223459E-05_JPRB, 0.22079851E-05_JPRB, 0.23050466E-05_JPRB, 0.24126257E-05_JPRB, 0.25290585E-05_JPRB, &
  & 0.26542757E-05_JPRB, 0.27879591E-05_JPRB, 0.29282307E-05_JPRB, 0.30705355E-05_JPRB, 0.32090345E-05_JPRB, 0.33373415E-05_JPRB, &
  & 0.34523814E-05_JPRB, 0.35531191E-05_JPRB, 0.36420827E-05_JPRB, 0.37230225E-05_JPRB, 0.37994530E-05_JPRB, 0.38745757E-05_JPRB, &
  & 0.39513843E-05_JPRB, 0.40302762E-05_JPRB, 0.41143385E-05_JPRB, 0.42032607E-05_JPRB, 0.42985303E-05_JPRB, 0.43981809E-05_JPRB, &
  & 0.44995732E-05_JPRB, 0.45993729E-05_JPRB, 0.47081480E-05_JPRB, 0.48789771E-05_JPRB /)

RGHG7(:,30, 2) = (/ &
  & 0.26171008E-05_JPRB, 0.25020665E-05_JPRB, 0.24608330E-05_JPRB, 0.24413944E-05_JPRB, 0.24343219E-05_JPRB, 0.24345743E-05_JPRB, &
  & 0.24384676E-05_JPRB, 0.24414248E-05_JPRB, 0.24412154E-05_JPRB, 0.24351148E-05_JPRB, 0.24232895E-05_JPRB, 0.24085587E-05_JPRB, &
  & 0.23861596E-05_JPRB, 0.23550631E-05_JPRB, 0.23187899E-05_JPRB, 0.22780794E-05_JPRB, 0.22325983E-05_JPRB, 0.21819294E-05_JPRB, &
  & 0.21263513E-05_JPRB, 0.20646266E-05_JPRB, 0.19966133E-05_JPRB, 0.19226241E-05_JPRB, 0.18445231E-05_JPRB, 0.17655926E-05_JPRB, &
  & 0.16905448E-05_JPRB, 0.16256718E-05_JPRB, 0.15736714E-05_JPRB, 0.15374812E-05_JPRB, 0.15154806E-05_JPRB, 0.15055878E-05_JPRB, &
  & 0.15054467E-05_JPRB, 0.15141055E-05_JPRB, 0.15308232E-05_JPRB, 0.15583610E-05_JPRB, 0.15960518E-05_JPRB, 0.16473630E-05_JPRB, &
  & 0.17101597E-05_JPRB, 0.17837503E-05_JPRB, 0.18667245E-05_JPRB, 0.19570025E-05_JPRB, 0.20543705E-05_JPRB, 0.21605040E-05_JPRB, &
  & 0.22769129E-05_JPRB, 0.24042861E-05_JPRB, 0.25409863E-05_JPRB, 0.26827549E-05_JPRB, 0.28231539E-05_JPRB, 0.29562048E-05_JPRB, &
  & 0.30766414E-05_JPRB, 0.31844820E-05_JPRB, 0.32808675E-05_JPRB, 0.33689785E-05_JPRB, 0.34532895E-05_JPRB, 0.35359380E-05_JPRB, &
  & 0.36204967E-05_JPRB, 0.37081934E-05_JPRB, 0.38017781E-05_JPRB, 0.39024239E-05_JPRB, 0.40105992E-05_JPRB, 0.41241333E-05_JPRB, &
  & 0.42378110E-05_JPRB, 0.43509731E-05_JPRB, 0.44720732E-05_JPRB, 0.46773121E-05_JPRB /)

RGHG7(:,31, 2) = (/ &
  & 0.23136390E-05_JPRB, 0.22069062E-05_JPRB, 0.21686358E-05_JPRB, 0.21503636E-05_JPRB, 0.21431711E-05_JPRB, 0.21425831E-05_JPRB, &
  & 0.21454000E-05_JPRB, 0.21478916E-05_JPRB, 0.21476137E-05_JPRB, 0.21429207E-05_JPRB, 0.21317360E-05_JPRB, 0.21136239E-05_JPRB, &
  & 0.20906625E-05_JPRB, 0.20609887E-05_JPRB, 0.20228154E-05_JPRB, 0.19773408E-05_JPRB, 0.19257639E-05_JPRB, 0.18687712E-05_JPRB, &
  & 0.18065730E-05_JPRB, 0.17392254E-05_JPRB, 0.16663249E-05_JPRB, 0.15880860E-05_JPRB, 0.15056896E-05_JPRB, 0.14219023E-05_JPRB, &
  & 0.13413146E-05_JPRB, 0.12701037E-05_JPRB, 0.12114773E-05_JPRB, 0.11702388E-05_JPRB, 0.11454756E-05_JPRB, 0.11367969E-05_JPRB, &
  & 0.11426350E-05_JPRB, 0.11622806E-05_JPRB, 0.11927398E-05_JPRB, 0.12353609E-05_JPRB, 0.12863305E-05_JPRB, 0.13466891E-05_JPRB, &
  & 0.14137420E-05_JPRB, 0.14865331E-05_JPRB, 0.15632955E-05_JPRB, 0.16437383E-05_JPRB, 0.17303802E-05_JPRB, 0.18261206E-05_JPRB, &
  & 0.19336562E-05_JPRB, 0.20542848E-05_JPRB, 0.21856858E-05_JPRB, 0.23241548E-05_JPRB, 0.24634819E-05_JPRB, 0.25965303E-05_JPRB, &
  & 0.27197741E-05_JPRB, 0.28305226E-05_JPRB, 0.29312066E-05_JPRB, 0.30247129E-05_JPRB, 0.31139123E-05_JPRB, 0.32023493E-05_JPRB, &
  & 0.32923972E-05_JPRB, 0.33866245E-05_JPRB, 0.34875645E-05_JPRB, 0.35966607E-05_JPRB, 0.37145621E-05_JPRB, 0.38372345E-05_JPRB, &
  & 0.39590295E-05_JPRB, 0.40762611E-05_JPRB, 0.42059141E-05_JPRB, 0.44299636E-05_JPRB /)

RGHG7(:,32, 2) = (/ &
  & 0.20349344E-05_JPRB, 0.19394654E-05_JPRB, 0.19064378E-05_JPRB, 0.18908007E-05_JPRB, 0.18847128E-05_JPRB, 0.18842896E-05_JPRB, &
  & 0.18867653E-05_JPRB, 0.18891660E-05_JPRB, 0.18889464E-05_JPRB, 0.18841586E-05_JPRB, 0.18745210E-05_JPRB, 0.18583498E-05_JPRB, &
  & 0.18339405E-05_JPRB, 0.18016494E-05_JPRB, 0.17610885E-05_JPRB, 0.17125129E-05_JPRB, 0.16567055E-05_JPRB, 0.15948842E-05_JPRB, &
  & 0.15282532E-05_JPRB, 0.14572138E-05_JPRB, 0.13821083E-05_JPRB, 0.13026988E-05_JPRB, 0.12202454E-05_JPRB, 0.11365729E-05_JPRB, &
  & 0.10568457E-05_JPRB, 0.98480973E-06_JPRB, 0.92523857E-06_JPRB, 0.88199488E-06_JPRB, 0.85574857E-06_JPRB, 0.84622957E-06_JPRB, &
  & 0.85413677E-06_JPRB, 0.87720946E-06_JPRB, 0.91383657E-06_JPRB, 0.96269514E-06_JPRB, 0.10192374E-05_JPRB, 0.10824638E-05_JPRB, &
  & 0.11488086E-05_JPRB, 0.12166339E-05_JPRB, 0.12859599E-05_JPRB, 0.13580553E-05_JPRB, 0.14358711E-05_JPRB, 0.15232025E-05_JPRB, &
  & 0.16236014E-05_JPRB, 0.17380720E-05_JPRB, 0.18648506E-05_JPRB, 0.19987833E-05_JPRB, 0.21341505E-05_JPRB, 0.22653812E-05_JPRB, &
  & 0.23870559E-05_JPRB, 0.24985870E-05_JPRB, 0.26012528E-05_JPRB, 0.26971311E-05_JPRB, 0.27897515E-05_JPRB, 0.28815407E-05_JPRB, &
  & 0.29752825E-05_JPRB, 0.30735837E-05_JPRB, 0.31790810E-05_JPRB, 0.32940254E-05_JPRB, 0.34178117E-05_JPRB, 0.35456965E-05_JPRB, &
  & 0.36692932E-05_JPRB, 0.37880586E-05_JPRB, 0.39174793E-05_JPRB, 0.41493654E-05_JPRB /)

RGHG7(:,33, 2) = (/ &
  & 0.17876787E-05_JPRB, 0.17061129E-05_JPRB, 0.16780217E-05_JPRB, 0.16649567E-05_JPRB, 0.16602545E-05_JPRB, 0.16600504E-05_JPRB, &
  & 0.16621287E-05_JPRB, 0.16639303E-05_JPRB, 0.16631287E-05_JPRB, 0.16580798E-05_JPRB, 0.16476628E-05_JPRB, 0.16310312E-05_JPRB, &
  & 0.16070317E-05_JPRB, 0.15745293E-05_JPRB, 0.15324584E-05_JPRB, 0.14808693E-05_JPRB, 0.14214781E-05_JPRB, 0.13556885E-05_JPRB, &
  & 0.12853785E-05_JPRB, 0.12121513E-05_JPRB, 0.11359222E-05_JPRB, 0.10573195E-05_JPRB, 0.97700911E-06_JPRB, 0.89733311E-06_JPRB, &
  & 0.82172687E-06_JPRB, 0.75319917E-06_JPRB, 0.69674695E-06_JPRB, 0.65430407E-06_JPRB, 0.62782277E-06_JPRB, 0.61696619E-06_JPRB, &
  & 0.62393298E-06_JPRB, 0.64542752E-06_JPRB, 0.68203121E-06_JPRB, 0.72997886E-06_JPRB, 0.78585492E-06_JPRB, 0.84629272E-06_JPRB, &
  & 0.90754827E-06_JPRB, 0.96939004E-06_JPRB, 0.10315161E-05_JPRB, 0.10960687E-05_JPRB, 0.11674591E-05_JPRB, 0.12497059E-05_JPRB, &
  & 0.13455232E-05_JPRB, 0.14563346E-05_JPRB, 0.15788594E-05_JPRB, 0.17083782E-05_JPRB, 0.18393193E-05_JPRB, 0.19655688E-05_JPRB, &
  & 0.20844545E-05_JPRB, 0.21940959E-05_JPRB, 0.22962756E-05_JPRB, 0.23929604E-05_JPRB, 0.24865460E-05_JPRB, 0.25800814E-05_JPRB, &
  & 0.26752646E-05_JPRB, 0.27754506E-05_JPRB, 0.28829861E-05_JPRB, 0.30002589E-05_JPRB, 0.31260292E-05_JPRB, 0.32546163E-05_JPRB, &
  & 0.33775507E-05_JPRB, 0.34937545E-05_JPRB, 0.36212314E-05_JPRB, 0.38541880E-05_JPRB /)

RGHG7(:,34, 2) = (/ &
  & 0.15755531E-05_JPRB, 0.15065241E-05_JPRB, 0.14835235E-05_JPRB, 0.14724221E-05_JPRB, 0.14686037E-05_JPRB, 0.14681498E-05_JPRB, &
  & 0.14692596E-05_JPRB, 0.14699067E-05_JPRB, 0.14678207E-05_JPRB, 0.14619860E-05_JPRB, 0.14514484E-05_JPRB, 0.14347864E-05_JPRB, &
  & 0.14101497E-05_JPRB, 0.13765341E-05_JPRB, 0.13327515E-05_JPRB, 0.12791124E-05_JPRB, 0.12164967E-05_JPRB, 0.11470555E-05_JPRB, &
  & 0.10741348E-05_JPRB, 0.99881333E-06_JPRB, 0.92210070E-06_JPRB, 0.84500624E-06_JPRB, 0.76866701E-06_JPRB, 0.69436726E-06_JPRB, &
  & 0.62586651E-06_JPRB, 0.56391434E-06_JPRB, 0.51363486E-06_JPRB, 0.47462640E-06_JPRB, 0.44958665E-06_JPRB, 0.43822919E-06_JPRB, &
  & 0.44223134E-06_JPRB, 0.45963287E-06_JPRB, 0.49102368E-06_JPRB, 0.53316063E-06_JPRB, 0.58324292E-06_JPRB, 0.63680142E-06_JPRB, &
  & 0.69149837E-06_JPRB, 0.74590292E-06_JPRB, 0.80017628E-06_JPRB, 0.85812474E-06_JPRB, 0.92436807E-06_JPRB, 0.10034571E-05_JPRB, &
  & 0.10981977E-05_JPRB, 0.12070335E-05_JPRB, 0.13272034E-05_JPRB, 0.14529339E-05_JPRB, 0.15785490E-05_JPRB, 0.17001333E-05_JPRB, &
  & 0.18140104E-05_JPRB, 0.19205359E-05_JPRB, 0.20204930E-05_JPRB, 0.21159210E-05_JPRB, 0.22093748E-05_JPRB, 0.23025675E-05_JPRB, &
  & 0.23977721E-05_JPRB, 0.24977523E-05_JPRB, 0.26049511E-05_JPRB, 0.27212234E-05_JPRB, 0.28453367E-05_JPRB, 0.29712262E-05_JPRB, &
  & 0.30907445E-05_JPRB, 0.32037983E-05_JPRB, 0.33286944E-05_JPRB, 0.35566518E-05_JPRB /)

RGHG7(:,35, 2) = (/ &
  & 0.13968478E-05_JPRB, 0.13389730E-05_JPRB, 0.13194757E-05_JPRB, 0.13096211E-05_JPRB, 0.13060171E-05_JPRB, 0.13048261E-05_JPRB, &
  & 0.13044614E-05_JPRB, 0.13034604E-05_JPRB, 0.12996733E-05_JPRB, 0.12926403E-05_JPRB, 0.12810552E-05_JPRB, 0.12638478E-05_JPRB, &
  & 0.12392449E-05_JPRB, 0.12051165E-05_JPRB, 0.11600227E-05_JPRB, 0.11042441E-05_JPRB, 0.10387754E-05_JPRB, 0.96650319E-06_JPRB, &
  & 0.89082744E-06_JPRB, 0.81376845E-06_JPRB, 0.73707082E-06_JPRB, 0.66213113E-06_JPRB, 0.59069941E-06_JPRB, 0.52373861E-06_JPRB, &
  & 0.46459297E-06_JPRB, 0.41224791E-06_JPRB, 0.37128450E-06_JPRB, 0.33875102E-06_JPRB, 0.31762931E-06_JPRB, 0.30735166E-06_JPRB, &
  & 0.30868412E-06_JPRB, 0.32117310E-06_JPRB, 0.34494752E-06_JPRB, 0.37845336E-06_JPRB, 0.41905957E-06_JPRB, 0.46344164E-06_JPRB, &
  & 0.50931328E-06_JPRB, 0.55469184E-06_JPRB, 0.60154122E-06_JPRB, 0.65304880E-06_JPRB, 0.71413842E-06_JPRB, 0.78975154E-06_JPRB, &
  & 0.88176785E-06_JPRB, 0.99014540E-06_JPRB, 0.11083549E-05_JPRB, 0.12308385E-05_JPRB, 0.13522279E-05_JPRB, 0.14677954E-05_JPRB, &
  & 0.15771575E-05_JPRB, 0.16792586E-05_JPRB, 0.17759629E-05_JPRB, 0.18694087E-05_JPRB, 0.19609711E-05_JPRB, 0.20528187E-05_JPRB, &
  & 0.21468636E-05_JPRB, 0.22452305E-05_JPRB, 0.23499749E-05_JPRB, 0.24630119E-05_JPRB, 0.25822230E-05_JPRB, 0.27025903E-05_JPRB, &
  & 0.28167351E-05_JPRB, 0.29256969E-05_JPRB, 0.30454039E-05_JPRB, 0.32702412E-05_JPRB /)

RGHG7(:,36, 2) = (/ &
  & 0.12467896E-05_JPRB, 0.11976038E-05_JPRB, 0.11810586E-05_JPRB, 0.11718164E-05_JPRB, 0.11676448E-05_JPRB, 0.11652962E-05_JPRB, &
  & 0.11631294E-05_JPRB, 0.11601026E-05_JPRB, 0.11545026E-05_JPRB, 0.11461758E-05_JPRB, 0.11339071E-05_JPRB, 0.11162501E-05_JPRB, &
  & 0.10913922E-05_JPRB, 0.10570448E-05_JPRB, 0.10113499E-05_JPRB, 0.95389237E-06_JPRB, 0.88599364E-06_JPRB, 0.81101257E-06_JPRB, &
  & 0.73298003E-06_JPRB, 0.65440935E-06_JPRB, 0.57850576E-06_JPRB, 0.50709463E-06_JPRB, 0.44278880E-06_JPRB, 0.38599512E-06_JPRB, &
  & 0.33904240E-06_JPRB, 0.29946565E-06_JPRB, 0.26926057E-06_JPRB, 0.24555374E-06_JPRB, 0.22980647E-06_JPRB, 0.22184973E-06_JPRB, &
  & 0.22195739E-06_JPRB, 0.23049495E-06_JPRB, 0.24760001E-06_JPRB, 0.27269863E-06_JPRB, 0.30394543E-06_JPRB, 0.33906818E-06_JPRB, &
  & 0.37574742E-06_JPRB, 0.41300279E-06_JPRB, 0.45237113E-06_JPRB, 0.49656944E-06_JPRB, 0.55060468E-06_JPRB, 0.61895059E-06_JPRB, &
  & 0.70562413E-06_JPRB, 0.80836253E-06_JPRB, 0.92333778E-06_JPRB, 0.10417218E-05_JPRB, 0.11576905E-05_JPRB, 0.12684214E-05_JPRB, &
  & 0.13721583E-05_JPRB, 0.14699617E-05_JPRB, 0.15632824E-05_JPRB, 0.16535867E-05_JPRB, 0.17429059E-05_JPRB, 0.18325618E-05_JPRB, &
  & 0.19243225E-05_JPRB, 0.20197381E-05_JPRB, 0.21210192E-05_JPRB, 0.22284971E-05_JPRB, 0.23412251E-05_JPRB, 0.24536512E-05_JPRB, &
  & 0.25610527E-05_JPRB, 0.26634864E-05_JPRB, 0.27799529E-05_JPRB, 0.29938251E-05_JPRB /)

RGHG7(:,37, 2) = (/ &
  & 0.11200685E-05_JPRB, 0.10776967E-05_JPRB, 0.10628709E-05_JPRB, 0.10539188E-05_JPRB, 0.10488129E-05_JPRB, 0.10448853E-05_JPRB, &
  & 0.10407695E-05_JPRB, 0.10355877E-05_JPRB, 0.10283115E-05_JPRB, 0.10187994E-05_JPRB, 0.10058661E-05_JPRB, 0.98834505E-06_JPRB, &
  & 0.96392580E-06_JPRB, 0.92976717E-06_JPRB, 0.88342483E-06_JPRB, 0.82458678E-06_JPRB, 0.75509689E-06_JPRB, 0.67805894E-06_JPRB, &
  & 0.59780069E-06_JPRB, 0.51956329E-06_JPRB, 0.44684452E-06_JPRB, 0.38201659E-06_JPRB, 0.32872512E-06_JPRB, 0.28479874E-06_JPRB, &
  & 0.25109338E-06_JPRB, 0.22390437E-06_JPRB, 0.20364337E-06_JPRB, 0.18747127E-06_JPRB, 0.17651872E-06_JPRB, 0.17069401E-06_JPRB, &
  & 0.17043108E-06_JPRB, 0.17647517E-06_JPRB, 0.18909998E-06_JPRB, 0.20821356E-06_JPRB, 0.23255065E-06_JPRB, 0.26047633E-06_JPRB, &
  & 0.29008811E-06_JPRB, 0.32082232E-06_JPRB, 0.35355785E-06_JPRB, 0.39079703E-06_JPRB, 0.43654984E-06_JPRB, 0.49569519E-06_JPRB, &
  & 0.57134764E-06_JPRB, 0.66535148E-06_JPRB, 0.77178174E-06_JPRB, 0.88399469E-06_JPRB, 0.99408521E-06_JPRB, 0.10988108E-05_JPRB, &
  & 0.11976941E-05_JPRB, 0.12911374E-05_JPRB, 0.13806163E-05_JPRB, 0.14678267E-05_JPRB, 0.15540710E-05_JPRB, 0.16407636E-05_JPRB, &
  & 0.17292050E-05_JPRB, 0.18207219E-05_JPRB, 0.19166675E-05_JPRB, 0.20178402E-05_JPRB, 0.21222797E-05_JPRB, 0.22262091E-05_JPRB, &
  & 0.23251000E-05_JPRB, 0.24218800E-05_JPRB, 0.25287022E-05_JPRB, 0.27350377E-05_JPRB /)

RGHG7(:,38, 2) = (/ &
  & 0.10113316E-05_JPRB, 0.97426869E-06_JPRB, 0.96072756E-06_JPRB, 0.95156008E-06_JPRB, 0.94522932E-06_JPRB, 0.93957055E-06_JPRB, &
  & 0.93345267E-06_JPRB, 0.92629534E-06_JPRB, 0.91755834E-06_JPRB, 0.90720340E-06_JPRB, 0.89400078E-06_JPRB, 0.87682116E-06_JPRB, &
  & 0.85315872E-06_JPRB, 0.82009615E-06_JPRB, 0.77472828E-06_JPRB, 0.71548857E-06_JPRB, 0.64467582E-06_JPRB, 0.56685747E-06_JPRB, &
  & 0.48678481E-06_JPRB, 0.41078002E-06_JPRB, 0.34509520E-06_JPRB, 0.29136271E-06_JPRB, 0.24986147E-06_JPRB, 0.21863200E-06_JPRB, &
  & 0.19538385E-06_JPRB, 0.17721894E-06_JPRB, 0.16349927E-06_JPRB, 0.15235781E-06_JPRB, 0.14445683E-06_JPRB, 0.14003112E-06_JPRB, &
  & 0.13962025E-06_JPRB, 0.14413693E-06_JPRB, 0.15396957E-06_JPRB, 0.16926795E-06_JPRB, 0.18907620E-06_JPRB, 0.21207876E-06_JPRB, &
  & 0.23674937E-06_JPRB, 0.26267742E-06_JPRB, 0.29046993E-06_JPRB, 0.32220052E-06_JPRB, 0.36106408E-06_JPRB, 0.41094944E-06_JPRB, &
  & 0.47604897E-06_JPRB, 0.55767907E-06_JPRB, 0.65368670E-06_JPRB, 0.75607869E-06_JPRB, 0.85865514E-06_JPRB, 0.95731173E-06_JPRB, &
  & 0.10508278E-05_JPRB, 0.11399279E-05_JPRB, 0.12258979E-05_JPRB, 0.13096553E-05_JPRB, 0.13925196E-05_JPRB, 0.14753642E-05_JPRB, &
  & 0.15591672E-05_JPRB, 0.16452201E-05_JPRB, 0.17345075E-05_JPRB, 0.18277944E-05_JPRB, 0.19234824E-05_JPRB, 0.20183181E-05_JPRB, &
  & 0.21095573E-05_JPRB, 0.21972824E-05_JPRB, 0.22994691E-05_JPRB, 0.24884721E-05_JPRB /)

RGHG7(:,39, 2) = (/ &
  & 0.91691948E-06_JPRB, 0.88406648E-06_JPRB, 0.87094094E-06_JPRB, 0.86151147E-06_JPRB, 0.85382470E-06_JPRB, 0.84636821E-06_JPRB, &
  & 0.83834169E-06_JPRB, 0.82957115E-06_JPRB, 0.81977083E-06_JPRB, 0.80895649E-06_JPRB, 0.79581184E-06_JPRB, 0.77959828E-06_JPRB, &
  & 0.75733891E-06_JPRB, 0.72565967E-06_JPRB, 0.68105686E-06_JPRB, 0.62273529E-06_JPRB, 0.55230731E-06_JPRB, 0.47524972E-06_JPRB, &
  & 0.39914676E-06_JPRB, 0.32980520E-06_JPRB, 0.27373653E-06_JPRB, 0.23116809E-06_JPRB, 0.20013545E-06_JPRB, 0.17770789E-06_JPRB, &
  & 0.16107440E-06_JPRB, 0.14827182E-06_JPRB, 0.13831389E-06_JPRB, 0.13006770E-06_JPRB, 0.12391537E-06_JPRB, 0.12026497E-06_JPRB, &
  & 0.11974907E-06_JPRB, 0.12324465E-06_JPRB, 0.13130958E-06_JPRB, 0.14410232E-06_JPRB, 0.16092325E-06_JPRB, 0.18055914E-06_JPRB, &
  & 0.20176819E-06_JPRB, 0.22417859E-06_JPRB, 0.24841250E-06_JPRB, 0.27607567E-06_JPRB, 0.30966387E-06_JPRB, 0.35260371E-06_JPRB, &
  & 0.40812370E-06_JPRB, 0.47843804E-06_JPRB, 0.56222876E-06_JPRB, 0.65453509E-06_JPRB, 0.74865301E-06_JPRB, 0.84024828E-06_JPRB, &
  & 0.92808529E-06_JPRB, 0.10131016E-05_JPRB, 0.10953823E-05_JPRB, 0.11758486E-05_JPRB, 0.12550155E-05_JPRB, 0.13333020E-05_JPRB, &
  & 0.14115932E-05_JPRB, 0.14904952E-05_JPRB, 0.15718222E-05_JPRB, 0.16559486E-05_JPRB, 0.17423250E-05_JPRB, 0.18282568E-05_JPRB, &
  & 0.19106963E-05_JPRB, 0.19925740E-05_JPRB, 0.20835157E-05_JPRB, 0.22603590E-05_JPRB /)

RGHG7(:,40, 2) = (/ &
  & 0.83383730E-06_JPRB, 0.80416572E-06_JPRB, 0.79148953E-06_JPRB, 0.78139368E-06_JPRB, 0.77233483E-06_JPRB, 0.76320373E-06_JPRB, &
  & 0.75353574E-06_JPRB, 0.74364385E-06_JPRB, 0.73326919E-06_JPRB, 0.72228784E-06_JPRB, 0.70987426E-06_JPRB, 0.69435492E-06_JPRB, &
  & 0.67401987E-06_JPRB, 0.64479201E-06_JPRB, 0.60267973E-06_JPRB, 0.54561724E-06_JPRB, 0.47692509E-06_JPRB, 0.40271962E-06_JPRB, &
  & 0.33225831E-06_JPRB, 0.27264107E-06_JPRB, 0.22598303E-06_JPRB, 0.19274003E-06_JPRB, 0.16864351E-06_JPRB, 0.15186261E-06_JPRB, &
  & 0.13893667E-06_JPRB, 0.12923252E-06_JPRB, 0.12129357E-06_JPRB, 0.11467976E-06_JPRB, 0.10954924E-06_JPRB, 0.10633860E-06_JPRB, &
  & 0.10572817E-06_JPRB, 0.10853061E-06_JPRB, 0.11536959E-06_JPRB, 0.12645894E-06_JPRB, 0.14119752E-06_JPRB, 0.15845959E-06_JPRB, &
  & 0.17714106E-06_JPRB, 0.19696537E-06_JPRB, 0.21850219E-06_JPRB, 0.24302324E-06_JPRB, 0.27271423E-06_JPRB, 0.31022188E-06_JPRB, &
  & 0.35846961E-06_JPRB, 0.41973979E-06_JPRB, 0.49324052E-06_JPRB, 0.57508561E-06_JPRB, 0.65958710E-06_JPRB, 0.74339937E-06_JPRB, &
  & 0.82568789E-06_JPRB, 0.90593608E-06_JPRB, 0.98499493E-06_JPRB, 0.10625648E-05_JPRB, 0.11380963E-05_JPRB, 0.12117108E-05_JPRB, &
  & 0.12833369E-05_JPRB, 0.13545163E-05_JPRB, 0.14265325E-05_JPRB, 0.15010110E-05_JPRB, 0.15773255E-05_JPRB, 0.16538287E-05_JPRB, &
  & 0.17284348E-05_JPRB, 0.18013251E-05_JPRB, 0.18864678E-05_JPRB, 0.20458069E-05_JPRB /)

RGHG7(:,41, 2) = (/ &
  & 0.76048718E-06_JPRB, 0.73318643E-06_JPRB, 0.72056423E-06_JPRB, 0.70992860E-06_JPRB, 0.69950914E-06_JPRB, 0.68881968E-06_JPRB, &
  & 0.67796680E-06_JPRB, 0.66733662E-06_JPRB, 0.65694445E-06_JPRB, 0.64608253E-06_JPRB, 0.63449608E-06_JPRB, 0.62037122E-06_JPRB, &
  & 0.60158732E-06_JPRB, 0.57467207E-06_JPRB, 0.53533392E-06_JPRB, 0.48088259E-06_JPRB, 0.41498129E-06_JPRB, 0.34532931E-06_JPRB, &
  & 0.28218847E-06_JPRB, 0.23155923E-06_JPRB, 0.19356284E-06_JPRB, 0.16689719E-06_JPRB, 0.14752369E-06_JPRB, 0.13417737E-06_JPRB, &
  & 0.12341347E-06_JPRB, 0.11552972E-06_JPRB, 0.10874690E-06_JPRB, 0.10309660E-06_JPRB, 0.98572869E-07_JPRB, 0.95645817E-07_JPRB, &
  & 0.94992323E-07_JPRB, 0.97323969E-07_JPRB, 0.10328785E-06_JPRB, 0.11312506E-06_JPRB, 0.12634962E-06_JPRB, 0.14184997E-06_JPRB, &
  & 0.15862251E-06_JPRB, 0.17642445E-06_JPRB, 0.19578061E-06_JPRB, 0.21788227E-06_JPRB, 0.24446484E-06_JPRB, 0.27781456E-06_JPRB, &
  & 0.32034851E-06_JPRB, 0.37382713E-06_JPRB, 0.43834780E-06_JPRB, 0.51061124E-06_JPRB, 0.58659020E-06_JPRB, 0.66278204E-06_JPRB, &
  & 0.73839692E-06_JPRB, 0.81427658E-06_JPRB, 0.89034648E-06_JPRB, 0.96508677E-06_JPRB, 0.10376936E-05_JPRB, 0.11062931E-05_JPRB, &
  & 0.11715370E-05_JPRB, 0.12343882E-05_JPRB, 0.12971901E-05_JPRB, 0.13614120E-05_JPRB, 0.14275211E-05_JPRB, 0.14942905E-05_JPRB, &
  & 0.15597716E-05_JPRB, 0.16259351E-05_JPRB, 0.17012521E-05_JPRB, 0.18466702E-05_JPRB /)

RGHG7(:,42, 2) = (/ &
  & 0.69497355E-06_JPRB, 0.66974519E-06_JPRB, 0.65714664E-06_JPRB, 0.64592547E-06_JPRB, 0.63428251E-06_JPRB, 0.62239695E-06_JPRB, &
  & 0.61070193E-06_JPRB, 0.59980425E-06_JPRB, 0.58955823E-06_JPRB, 0.57928514E-06_JPRB, 0.56835472E-06_JPRB, 0.55553107E-06_JPRB, &
  & 0.53862573E-06_JPRB, 0.51415856E-06_JPRB, 0.47767929E-06_JPRB, 0.42651604E-06_JPRB, 0.36385035E-06_JPRB, 0.30034661E-06_JPRB, &
  & 0.24413194E-06_JPRB, 0.20154491E-06_JPRB, 0.17021812E-06_JPRB, 0.14834411E-06_JPRB, 0.13223074E-06_JPRB, 0.12099366E-06_JPRB, &
  & 0.11167164E-06_JPRB, 0.10487175E-06_JPRB, 0.98739683E-07_JPRB, 0.93697018E-07_JPRB, 0.89584915E-07_JPRB, 0.86896677E-07_JPRB, &
  & 0.86229093E-07_JPRB, 0.88262937E-07_JPRB, 0.93577995E-07_JPRB, 0.10248247E-06_JPRB, 0.11453523E-06_JPRB, 0.12869030E-06_JPRB, &
  & 0.14395954E-06_JPRB, 0.16012582E-06_JPRB, 0.17771480E-06_JPRB, 0.19773189E-06_JPRB, 0.22173080E-06_JPRB, 0.25158613E-06_JPRB, &
  & 0.28936580E-06_JPRB, 0.33692774E-06_JPRB, 0.39406973E-06_JPRB, 0.45829287E-06_JPRB, 0.52548233E-06_JPRB, 0.59379715E-06_JPRB, &
  & 0.66304267E-06_JPRB, 0.73423087E-06_JPRB, 0.80681247E-06_JPRB, 0.87972791E-06_JPRB, 0.94892903E-06_JPRB, 0.10131206E-05_JPRB, &
  & 0.10716727E-05_JPRB, 0.11266226E-05_JPRB, 0.11804392E-05_JPRB, 0.12349932E-05_JPRB, 0.12910084E-05_JPRB, 0.13478370E-05_JPRB, &
  & 0.14045827E-05_JPRB, 0.14621020E-05_JPRB, 0.15302367E-05_JPRB, 0.16604946E-05_JPRB /)

RGHG7(:,43, 2) = (/ &
  & 0.63629039E-06_JPRB, 0.61267696E-06_JPRB, 0.60019556E-06_JPRB, 0.58854010E-06_JPRB, 0.57599709E-06_JPRB, 0.56312189E-06_JPRB, &
  & 0.55096069E-06_JPRB, 0.54005824E-06_JPRB, 0.52996654E-06_JPRB, 0.52042117E-06_JPRB, 0.51021419E-06_JPRB, 0.49846597E-06_JPRB, &
  & 0.48305577E-06_JPRB, 0.46087825E-06_JPRB, 0.42714575E-06_JPRB, 0.37914273E-06_JPRB, 0.32081866E-06_JPRB, 0.26305366E-06_JPRB, &
  & 0.21484381E-06_JPRB, 0.17860225E-06_JPRB, 0.15257599E-06_JPRB, 0.13413958E-06_JPRB, 0.12041339E-06_JPRB, 0.11050831E-06_JPRB, &
  & 0.10221145E-06_JPRB, 0.95989087E-07_JPRB, 0.90360849E-07_JPRB, 0.85666983E-07_JPRB, 0.81862801E-07_JPRB, 0.79372377E-07_JPRB, &
  & 0.78779280E-07_JPRB, 0.80636951E-07_JPRB, 0.85479300E-07_JPRB, 0.93644623E-07_JPRB, 0.10478299E-06_JPRB, 0.11786672E-06_JPRB, &
  & 0.13192101E-06_JPRB, 0.14673401E-06_JPRB, 0.16278392E-06_JPRB, 0.18101075E-06_JPRB, 0.20273812E-06_JPRB, 0.22959929E-06_JPRB, &
  & 0.26333197E-06_JPRB, 0.30542907E-06_JPRB, 0.35605220E-06_JPRB, 0.41292321E-06_JPRB, 0.47290149E-06_JPRB, 0.53388897E-06_JPRB, &
  & 0.59677126E-06_JPRB, 0.66263652E-06_JPRB, 0.73210941E-06_JPRB, 0.80167598E-06_JPRB, 0.86797365E-06_JPRB, 0.92697258E-06_JPRB, &
  & 0.97919474E-06_JPRB, 0.10268615E-05_JPRB, 0.10725867E-05_JPRB, 0.11183427E-05_JPRB, 0.11651363E-05_JPRB, 0.12126116E-05_JPRB, &
  & 0.12604727E-05_JPRB, 0.13104864E-05_JPRB, 0.13699861E-05_JPRB, 0.14865556E-05_JPRB /)

RGHG7(:,44, 2) = (/ &
  & 0.58315845E-06_JPRB, 0.56083661E-06_JPRB, 0.54868951E-06_JPRB, 0.53674574E-06_JPRB, 0.52356069E-06_JPRB, 0.51004605E-06_JPRB, &
  & 0.49751742E-06_JPRB, 0.48652913E-06_JPRB, 0.47674175E-06_JPRB, 0.46755864E-06_JPRB, 0.45817021E-06_JPRB, 0.44735077E-06_JPRB, &
  & 0.43331113E-06_JPRB, 0.41296047E-06_JPRB, 0.38192985E-06_JPRB, 0.33708176E-06_JPRB, 0.28335648E-06_JPRB, 0.23209132E-06_JPRB, &
  & 0.19079785E-06_JPRB, 0.16055294E-06_JPRB, 0.13864776E-06_JPRB, 0.12280336E-06_JPRB, 0.11082270E-06_JPRB, 0.10180815E-06_JPRB, &
  & 0.94295409E-07_JPRB, 0.88414616E-07_JPRB, 0.83049670E-07_JPRB, 0.78628432E-07_JPRB, 0.75056015E-07_JPRB, 0.72784594E-07_JPRB, &
  & 0.72283918E-07_JPRB, 0.74069760E-07_JPRB, 0.78570309E-07_JPRB, 0.86164775E-07_JPRB, 0.96559880E-07_JPRB, 0.10877112E-06_JPRB, &
  & 0.12182494E-06_JPRB, 0.13548843E-06_JPRB, 0.15022881E-06_JPRB, 0.16686924E-06_JPRB, 0.18659107E-06_JPRB, 0.21073747E-06_JPRB, &
  & 0.24079452E-06_JPRB, 0.27817518E-06_JPRB, 0.32316888E-06_JPRB, 0.37369608E-06_JPRB, 0.42670862E-06_JPRB, 0.48104999E-06_JPRB, &
  & 0.53757088E-06_JPRB, 0.59825334E-06_JPRB, 0.66288192E-06_JPRB, 0.72906596E-06_JPRB, 0.79049698E-06_JPRB, 0.84429320E-06_JPRB, &
  & 0.89032915E-06_JPRB, 0.93127926E-06_JPRB, 0.97013015E-06_JPRB, 0.10083243E-05_JPRB, 0.10470907E-05_JPRB, 0.10862506E-05_JPRB, &
  & 0.11261236E-05_JPRB, 0.11682866E-05_JPRB, 0.12202798E-05_JPRB, 0.13231543E-05_JPRB /)

RGHG7(:,45, 2) = (/ &
  & 0.53421712E-06_JPRB, 0.51354311E-06_JPRB, 0.50123504E-06_JPRB, 0.48944770E-06_JPRB, 0.47574119E-06_JPRB, 0.46167639E-06_JPRB, &
  & 0.44860329E-06_JPRB, 0.43751453E-06_JPRB, 0.42768707E-06_JPRB, 0.41887603E-06_JPRB, 0.40998509E-06_JPRB, 0.39999205E-06_JPRB, &
  & 0.38727333E-06_JPRB, 0.36865072E-06_JPRB, 0.34011160E-06_JPRB, 0.29884407E-06_JPRB, 0.25032415E-06_JPRB, 0.20601072E-06_JPRB, &
  & 0.17136151E-06_JPRB, 0.14591943E-06_JPRB, 0.12740284E-06_JPRB, 0.11345463E-06_JPRB, 0.10293574E-06_JPRB, 0.94425125E-07_JPRB, &
  & 0.87510728E-07_JPRB, 0.81746386E-07_JPRB, 0.76676947E-07_JPRB, 0.72376999E-07_JPRB, 0.69001324E-07_JPRB, 0.66938007E-07_JPRB, &
  & 0.66608557E-07_JPRB, 0.68383230E-07_JPRB, 0.72659432E-07_JPRB, 0.79799314E-07_JPRB, 0.89593584E-07_JPRB, 0.10109068E-06_JPRB, &
  & 0.11328733E-06_JPRB, 0.12598603E-06_JPRB, 0.13957708E-06_JPRB, 0.15483725E-06_JPRB, 0.17275093E-06_JPRB, 0.19445422E-06_JPRB, &
  & 0.22110652E-06_JPRB, 0.25396551E-06_JPRB, 0.29337403E-06_JPRB, 0.33797511E-06_JPRB, 0.38497836E-06_JPRB, 0.43315546E-06_JPRB, &
  & 0.48387335E-06_JPRB, 0.53884128E-06_JPRB, 0.59865903E-06_JPRB, 0.65903271E-06_JPRB, 0.71534322E-06_JPRB, 0.76268475E-06_JPRB, &
  & 0.80279392E-06_JPRB, 0.83786023E-06_JPRB, 0.87062904E-06_JPRB, 0.90268099E-06_JPRB, 0.93466400E-06_JPRB, 0.96682174E-06_JPRB, &
  & 0.99958470E-06_JPRB, 0.10349656E-05_JPRB, 0.10791307E-05_JPRB, 0.11690217E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART4',0,ZHOOK_HANDLE)



RGHG7(:,46, 2) = (/ &
  & 0.48901597E-06_JPRB, 0.46879111E-06_JPRB, 0.45732020E-06_JPRB, 0.44499822E-06_JPRB, 0.43117709E-06_JPRB, 0.41633405E-06_JPRB, &
  & 0.40269003E-06_JPRB, 0.39095266E-06_JPRB, 0.38111386E-06_JPRB, 0.37237777E-06_JPRB, 0.36395008E-06_JPRB, 0.35483293E-06_JPRB, &
  & 0.34308400E-06_JPRB, 0.32670636E-06_JPRB, 0.30053036E-06_JPRB, 0.26351171E-06_JPRB, 0.22111406E-06_JPRB, 0.18372526E-06_JPRB, &
  & 0.15521377E-06_JPRB, 0.13399935E-06_JPRB, 0.11818784E-06_JPRB, 0.10575644E-06_JPRB, 0.96210726E-07_JPRB, 0.88108131E-07_JPRB, &
  & 0.81635804E-07_JPRB, 0.75936939E-07_JPRB, 0.70958670E-07_JPRB, 0.66805043E-07_JPRB, 0.63618948E-07_JPRB, 0.61773257E-07_JPRB, &
  & 0.61640023E-07_JPRB, 0.63463425E-07_JPRB, 0.67603480E-07_JPRB, 0.74414828E-07_JPRB, 0.83724835E-07_JPRB, 0.94600239E-07_JPRB, &
  & 0.10609247E-06_JPRB, 0.11794688E-06_JPRB, 0.13057596E-06_JPRB, 0.14462172E-06_JPRB, 0.16096088E-06_JPRB, 0.18043455E-06_JPRB, &
  & 0.20393688E-06_JPRB, 0.23244105E-06_JPRB, 0.26652623E-06_JPRB, 0.30513567E-06_JPRB, 0.34610056E-06_JPRB, 0.38851286E-06_JPRB, &
  & 0.43337471E-06_JPRB, 0.48292475E-06_JPRB, 0.53643316E-06_JPRB, 0.59143781E-06_JPRB, 0.64021305E-06_JPRB, 0.68194589E-06_JPRB, &
  & 0.71582548E-06_JPRB, 0.74562018E-06_JPRB, 0.77331771E-06_JPRB, 0.80010062E-06_JPRB, 0.82659608E-06_JPRB, 0.85298996E-06_JPRB, &
  & 0.87982318E-06_JPRB, 0.90894969E-06_JPRB, 0.94626944E-06_JPRB, 0.10233468E-05_JPRB /)

RGHG7(:,47, 2) = (/ &
  & 0.44603033E-06_JPRB, 0.42675600E-06_JPRB, 0.41488275E-06_JPRB, 0.40288003E-06_JPRB, 0.38838274E-06_JPRB, 0.37276649E-06_JPRB, &
  & 0.35814097E-06_JPRB, 0.34572543E-06_JPRB, 0.33555685E-06_JPRB, 0.32689630E-06_JPRB, 0.31898415E-06_JPRB, 0.31044092E-06_JPRB, &
  & 0.30032993E-06_JPRB, 0.28525838E-06_JPRB, 0.26327100E-06_JPRB, 0.23079238E-06_JPRB, 0.19559657E-06_JPRB, 0.16512512E-06_JPRB, &
  & 0.14193996E-06_JPRB, 0.12417806E-06_JPRB, 0.11055242E-06_JPRB, 0.99325398E-07_JPRB, 0.90530826E-07_JPRB, 0.82714557E-07_JPRB, &
  & 0.76435178E-07_JPRB, 0.70746594E-07_JPRB, 0.65870431E-07_JPRB, 0.61796833E-07_JPRB, 0.58828665E-07_JPRB, 0.57212446E-07_JPRB, &
  & 0.57325991E-07_JPRB, 0.59242147E-07_JPRB, 0.63328415E-07_JPRB, 0.69895002E-07_JPRB, 0.78809144E-07_JPRB, 0.89180027E-07_JPRB, &
  & 0.10003503E-06_JPRB, 0.11120064E-06_JPRB, 0.12298376E-06_JPRB, 0.13602211E-06_JPRB, 0.15095840E-06_JPRB, 0.16844031E-06_JPRB, &
  & 0.18897246E-06_JPRB, 0.21323225E-06_JPRB, 0.24170160E-06_JPRB, 0.27397141E-06_JPRB, 0.30871050E-06_JPRB, 0.34493854E-06_JPRB, &
  & 0.38414800E-06_JPRB, 0.42750705E-06_JPRB, 0.47566314E-06_JPRB, 0.52309747E-06_JPRB, 0.56651578E-06_JPRB, 0.60095806E-06_JPRB, &
  & 0.62991745E-06_JPRB, 0.65470181E-06_JPRB, 0.67794662E-06_JPRB, 0.70042756E-06_JPRB, 0.72239311E-06_JPRB, 0.74410030E-06_JPRB, &
  & 0.76602481E-06_JPRB, 0.79005798E-06_JPRB, 0.82100877E-06_JPRB, 0.88633413E-06_JPRB /)

RGHG7(:,48, 2) = (/ &
  & 0.40454646E-06_JPRB, 0.38560108E-06_JPRB, 0.37399951E-06_JPRB, 0.36143496E-06_JPRB, 0.34646783E-06_JPRB, 0.32979281E-06_JPRB, &
  & 0.31393665E-06_JPRB, 0.30077817E-06_JPRB, 0.29018884E-06_JPRB, 0.28183308E-06_JPRB, 0.27428609E-06_JPRB, 0.26682883E-06_JPRB, &
  & 0.25767585E-06_JPRB, 0.24559066E-06_JPRB, 0.22670670E-06_JPRB, 0.20134618E-06_JPRB, 0.17325547E-06_JPRB, 0.14946258E-06_JPRB, &
  & 0.13093181E-06_JPRB, 0.11615938E-06_JPRB, 0.10416478E-06_JPRB, 0.94039152E-07_JPRB, 0.85517954E-07_JPRB, 0.78073718E-07_JPRB, &
  & 0.71800279E-07_JPRB, 0.66077803E-07_JPRB, 0.61249146E-07_JPRB, 0.57277930E-07_JPRB, 0.54579314E-07_JPRB, 0.53243795E-07_JPRB, &
  & 0.53581726E-07_JPRB, 0.55648655E-07_JPRB, 0.59718268E-07_JPRB, 0.66135861E-07_JPRB, 0.74734345E-07_JPRB, 0.84641037E-07_JPRB, &
  & 0.94980614E-07_JPRB, 0.10553282E-06_JPRB, 0.11664478E-06_JPRB, 0.12879802E-06_JPRB, 0.14255501E-06_JPRB, 0.15824435E-06_JPRB, &
  & 0.17605544E-06_JPRB, 0.19623353E-06_JPRB, 0.21900497E-06_JPRB, 0.24431887E-06_JPRB, 0.27167161E-06_JPRB, 0.30127268E-06_JPRB, &
  & 0.33381832E-06_JPRB, 0.37130661E-06_JPRB, 0.41265179E-06_JPRB, 0.45477051E-06_JPRB, 0.49077750E-06_JPRB, 0.52037007E-06_JPRB, &
  & 0.54401744E-06_JPRB, 0.56483299E-06_JPRB, 0.58427685E-06_JPRB, 0.60311567E-06_JPRB, 0.62155959E-06_JPRB, 0.63951580E-06_JPRB, &
  & 0.65760918E-06_JPRB, 0.67744219E-06_JPRB, 0.70322250E-06_JPRB, 0.75839824E-06_JPRB /)

RGHG7(:,49, 2) = (/ &
  & 0.36426280E-06_JPRB, 0.34514466E-06_JPRB, 0.33336269E-06_JPRB, 0.32037366E-06_JPRB, 0.30454513E-06_JPRB, 0.28644877E-06_JPRB, &
  & 0.26936803E-06_JPRB, 0.25534993E-06_JPRB, 0.24484720E-06_JPRB, 0.23676036E-06_JPRB, 0.23007989E-06_JPRB, 0.22356615E-06_JPRB, &
  & 0.21632755E-06_JPRB, 0.20673353E-06_JPRB, 0.19325222E-06_JPRB, 0.17476650E-06_JPRB, 0.15446979E-06_JPRB, 0.13644765E-06_JPRB, &
  & 0.12177301E-06_JPRB, 0.10949227E-06_JPRB, 0.98841234E-07_JPRB, 0.89553822E-07_JPRB, 0.81228855E-07_JPRB, 0.73978931E-07_JPRB, &
  & 0.67528099E-07_JPRB, 0.61843451E-07_JPRB, 0.57026075E-07_JPRB, 0.53245380E-07_JPRB, 0.50806818E-07_JPRB, 0.49820738E-07_JPRB, &
  & 0.50359091E-07_JPRB, 0.52601958E-07_JPRB, 0.56704575E-07_JPRB, 0.63015193E-07_JPRB, 0.71340779E-07_JPRB, 0.80861305E-07_JPRB, &
  & 0.90729856E-07_JPRB, 0.10079172E-06_JPRB, 0.11131470E-06_JPRB, 0.12276220E-06_JPRB, 0.13547761E-06_JPRB, 0.14959120E-06_JPRB, &
  & 0.16490696E-06_JPRB, 0.18120031E-06_JPRB, 0.19828545E-06_JPRB, 0.21622803E-06_JPRB, 0.23538168E-06_JPRB, 0.25681919E-06_JPRB, &
  & 0.28219137E-06_JPRB, 0.31257571E-06_JPRB, 0.34746347E-06_JPRB, 0.38270792E-06_JPRB, 0.41310355E-06_JPRB, 0.43738228E-06_JPRB, &
  & 0.45696976E-06_JPRB, 0.47426872E-06_JPRB, 0.49072889E-06_JPRB, 0.50677130E-06_JPRB, 0.52251687E-06_JPRB, 0.53780269E-06_JPRB, &
  & 0.55307521E-06_JPRB, 0.56989643E-06_JPRB, 0.59176250E-06_JPRB, 0.63908465E-06_JPRB /)

RGHG7(:,50, 2) = (/ &
  & 0.32424785E-06_JPRB, 0.30511404E-06_JPRB, 0.29299795E-06_JPRB, 0.27923969E-06_JPRB, 0.26211922E-06_JPRB, 0.24226267E-06_JPRB, &
  & 0.22402592E-06_JPRB, 0.20979193E-06_JPRB, 0.19988975E-06_JPRB, 0.19291987E-06_JPRB, 0.18755387E-06_JPRB, 0.18271500E-06_JPRB, &
  & 0.17789775E-06_JPRB, 0.17167564E-06_JPRB, 0.16386869E-06_JPRB, 0.15201647E-06_JPRB, 0.13864148E-06_JPRB, 0.12560621E-06_JPRB, &
  & 0.11411421E-06_JPRB, 0.10386957E-06_JPRB, 0.94317443E-07_JPRB, 0.85651422E-07_JPRB, 0.77443005E-07_JPRB, 0.70208650E-07_JPRB, &
  & 0.63649715E-07_JPRB, 0.57895051E-07_JPRB, 0.53229503E-07_JPRB, 0.49664063E-07_JPRB, 0.47517940E-07_JPRB, 0.46858919E-07_JPRB, &
  & 0.47630024E-07_JPRB, 0.50007824E-07_JPRB, 0.54186241E-07_JPRB, 0.60419836E-07_JPRB, 0.68510118E-07_JPRB, 0.77670293E-07_JPRB, &
  & 0.87140414E-07_JPRB, 0.96770762E-07_JPRB, 0.10683001E-06_JPRB, 0.11766750E-06_JPRB, 0.12950699E-06_JPRB, 0.14222118E-06_JPRB, &
  & 0.15527672E-06_JPRB, 0.16800534E-06_JPRB, 0.17985703E-06_JPRB, 0.19070184E-06_JPRB, 0.20176789E-06_JPRB, 0.21468632E-06_JPRB, &
  & 0.23157602E-06_JPRB, 0.25357053E-06_JPRB, 0.28032426E-06_JPRB, 0.30748879E-06_JPRB, 0.33191242E-06_JPRB, 0.35075402E-06_JPRB, &
  & 0.36696005E-06_JPRB, 0.38118750E-06_JPRB, 0.39516800E-06_JPRB, 0.40922686E-06_JPRB, 0.42313076E-06_JPRB, 0.43665466E-06_JPRB, &
  & 0.45020406E-06_JPRB, 0.46508015E-06_JPRB, 0.48454552E-06_JPRB, 0.52680792E-06_JPRB /)

RGHG7(:,51, 2) = (/ &
  & 0.28483328E-06_JPRB, 0.26574963E-06_JPRB, 0.25280659E-06_JPRB, 0.23846968E-06_JPRB, 0.21950693E-06_JPRB, 0.19844499E-06_JPRB, &
  & 0.17967695E-06_JPRB, 0.16712085E-06_JPRB, 0.15924194E-06_JPRB, 0.15434702E-06_JPRB, 0.15099545E-06_JPRB, 0.14842634E-06_JPRB, &
  & 0.14599081E-06_JPRB, 0.14349476E-06_JPRB, 0.13957084E-06_JPRB, 0.13402531E-06_JPRB, 0.12554777E-06_JPRB, 0.11654929E-06_JPRB, &
  & 0.10755878E-06_JPRB, 0.98957848E-07_JPRB, 0.90423661E-07_JPRB, 0.82070819E-07_JPRB, 0.74096178E-07_JPRB, 0.66697147E-07_JPRB, &
  & 0.60004481E-07_JPRB, 0.54333047E-07_JPRB, 0.49802367E-07_JPRB, 0.46566175E-07_JPRB, 0.44699643E-07_JPRB, 0.44286203E-07_JPRB, &
  & 0.45310664E-07_JPRB, 0.47820762E-07_JPRB, 0.52075084E-07_JPRB, 0.58254386E-07_JPRB, 0.66122887E-07_JPRB, 0.74953348E-07_JPRB, &
  & 0.84058264E-07_JPRB, 0.93328815E-07_JPRB, 0.10298851E-06_JPRB, 0.11331753E-06_JPRB, 0.12439041E-06_JPRB, 0.13585431E-06_JPRB, &
  & 0.14686117E-06_JPRB, 0.15642901E-06_JPRB, 0.16374014E-06_JPRB, 0.16906895E-06_JPRB, 0.17364242E-06_JPRB, 0.17961318E-06_JPRB, &
  & 0.18851495E-06_JPRB, 0.20150914E-06_JPRB, 0.21789918E-06_JPRB, 0.23605033E-06_JPRB, 0.25178531E-06_JPRB, 0.26587193E-06_JPRB, &
  & 0.27726836E-06_JPRB, 0.28856897E-06_JPRB, 0.30000112E-06_JPRB, 0.31195975E-06_JPRB, 0.32430844E-06_JPRB, 0.33650417E-06_JPRB, &
  & 0.34881626E-06_JPRB, 0.36250984E-06_JPRB, 0.38058491E-06_JPRB, 0.41984367E-06_JPRB /)

RGHG7(:,52, 2) = (/ &
  & 0.24718898E-06_JPRB, 0.22707799E-06_JPRB, 0.21475701E-06_JPRB, 0.19871719E-06_JPRB, 0.17968708E-06_JPRB, 0.15829406E-06_JPRB, &
  & 0.14295826E-06_JPRB, 0.13379639E-06_JPRB, 0.12903054E-06_JPRB, 0.12639200E-06_JPRB, 0.12491007E-06_JPRB, 0.12393104E-06_JPRB, &
  & 0.12338056E-06_JPRB, 0.12271127E-06_JPRB, 0.12187924E-06_JPRB, 0.11945613E-06_JPRB, 0.11503891E-06_JPRB, 0.10882681E-06_JPRB, &
  & 0.10186319E-06_JPRB, 0.94467545E-07_JPRB, 0.86786443E-07_JPRB, 0.78750972E-07_JPRB, 0.70868303E-07_JPRB, 0.63388008E-07_JPRB, &
  & 0.56692798E-07_JPRB, 0.51098077E-07_JPRB, 0.46815948E-07_JPRB, 0.43877296E-07_JPRB, 0.42303018E-07_JPRB, 0.42094392E-07_JPRB, &
  & 0.43301224E-07_JPRB, 0.45991353E-07_JPRB, 0.50294819E-07_JPRB, 0.56438498E-07_JPRB, 0.64089647E-07_JPRB, 0.72601708E-07_JPRB, &
  & 0.81379270E-07_JPRB, 0.90320981E-07_JPRB, 0.99632061E-07_JPRB, 0.10950787E-06_JPRB, 0.11989327E-06_JPRB, 0.13020707E-06_JPRB, &
  & 0.13937989E-06_JPRB, 0.14621199E-06_JPRB, 0.15011030E-06_JPRB, 0.15167382E-06_JPRB, 0.15249697E-06_JPRB, 0.15415513E-06_JPRB, &
  & 0.15785376E-06_JPRB, 0.16392450E-06_JPRB, 0.17223898E-06_JPRB, 0.18129640E-06_JPRB, 0.19032289E-06_JPRB, 0.19770083E-06_JPRB, &
  & 0.20509194E-06_JPRB, 0.21215985E-06_JPRB, 0.22002898E-06_JPRB, 0.22896886E-06_JPRB, 0.23840353E-06_JPRB, 0.24820508E-06_JPRB, &
  & 0.25840518E-06_JPRB, 0.26998026E-06_JPRB, 0.28574323E-06_JPRB, 0.32119871E-06_JPRB /)

RGHG7(:,53, 2) = (/ &
  & 0.21135037E-06_JPRB, 0.19252452E-06_JPRB, 0.17849673E-06_JPRB, 0.16416193E-06_JPRB, 0.14519524E-06_JPRB, 0.12850397E-06_JPRB, &
  & 0.11774193E-06_JPRB, 0.11259986E-06_JPRB, 0.11013921E-06_JPRB, 0.10895896E-06_JPRB, 0.10841271E-06_JPRB, 0.10820487E-06_JPRB, &
  & 0.10832910E-06_JPRB, 0.10854115E-06_JPRB, 0.10885277E-06_JPRB, 0.10844825E-06_JPRB, 0.10627854E-06_JPRB, 0.10220163E-06_JPRB, &
  & 0.96714992E-07_JPRB, 0.90314352E-07_JPRB, 0.83191097E-07_JPRB, 0.75542204E-07_JPRB, 0.67736906E-07_JPRB, 0.60264142E-07_JPRB, &
  & 0.53668423E-07_JPRB, 0.48247841E-07_JPRB, 0.44203077E-07_JPRB, 0.41554610E-07_JPRB, 0.40238739E-07_JPRB, 0.40230763E-07_JPRB, &
  & 0.41583935E-07_JPRB, 0.44410644E-07_JPRB, 0.48819416E-07_JPRB, 0.54883742E-07_JPRB, 0.62338934E-07_JPRB, 0.70550733E-07_JPRB, &
  & 0.79008117E-07_JPRB, 0.87644921E-07_JPRB, 0.96615402E-07_JPRB, 0.10606202E-06_JPRB, 0.11577702E-06_JPRB, 0.12502949E-06_JPRB, &
  & 0.13253383E-06_JPRB, 0.13716911E-06_JPRB, 0.13872496E-06_JPRB, 0.13819256E-06_JPRB, 0.13720563E-06_JPRB, 0.13697827E-06_JPRB, &
  & 0.13814879E-06_JPRB, 0.14075880E-06_JPRB, 0.14460994E-06_JPRB, 0.14913321E-06_JPRB, 0.15330586E-06_JPRB, 0.15740748E-06_JPRB, &
  & 0.16104640E-06_JPRB, 0.16501765E-06_JPRB, 0.16960222E-06_JPRB, 0.17482276E-06_JPRB, 0.18082628E-06_JPRB, 0.18711376E-06_JPRB, &
  & 0.19382308E-06_JPRB, 0.20169767E-06_JPRB, 0.21275228E-06_JPRB, 0.24014190E-06_JPRB /)

RGHG7(:,54, 2) = (/ &
  & 0.17988363E-06_JPRB, 0.16026921E-06_JPRB, 0.14883527E-06_JPRB, 0.13465348E-06_JPRB, 0.12049126E-06_JPRB, 0.10849126E-06_JPRB, &
  & 0.10243110E-06_JPRB, 0.99649874E-07_JPRB, 0.98483042E-07_JPRB, 0.97967167E-07_JPRB, 0.97819672E-07_JPRB, 0.97853302E-07_JPRB, &
  & 0.98124197E-07_JPRB, 0.98618010E-07_JPRB, 0.99169092E-07_JPRB, 0.99757159E-07_JPRB, 0.98956676E-07_JPRB, 0.96333451E-07_JPRB, &
  & 0.91959592E-07_JPRB, 0.86312298E-07_JPRB, 0.79656360E-07_JPRB, 0.72280855E-07_JPRB, 0.64640581E-07_JPRB, 0.57366460E-07_JPRB, &
  & 0.50919500E-07_JPRB, 0.45718483E-07_JPRB, 0.41925770E-07_JPRB, 0.39523428E-07_JPRB, 0.38436561E-07_JPRB, 0.38620598E-07_JPRB, &
  & 0.40139060E-07_JPRB, 0.43037652E-07_JPRB, 0.47558750E-07_JPRB, 0.53534819E-07_JPRB, 0.60806087E-07_JPRB, 0.68718585E-07_JPRB, &
  & 0.76875793E-07_JPRB, 0.85198202E-07_JPRB, 0.93822059E-07_JPRB, 0.10281214E-06_JPRB, 0.11185885E-06_JPRB, 0.12008124E-06_JPRB, &
  & 0.12615534E-06_JPRB, 0.12914685E-06_JPRB, 0.12921494E-06_JPRB, 0.12774731E-06_JPRB, 0.12604643E-06_JPRB, 0.12523272E-06_JPRB, &
  & 0.12540883E-06_JPRB, 0.12658697E-06_JPRB, 0.12858084E-06_JPRB, 0.13087339E-06_JPRB, 0.13323722E-06_JPRB, 0.13527921E-06_JPRB, &
  & 0.13735043E-06_JPRB, 0.13952713E-06_JPRB, 0.14203518E-06_JPRB, 0.14511730E-06_JPRB, 0.14853097E-06_JPRB, 0.15216790E-06_JPRB, &
  & 0.15600352E-06_JPRB, 0.16029584E-06_JPRB, 0.16623591E-06_JPRB, 0.18161413E-06_JPRB /)

RGHG7(:,55, 2) = (/ &
  & 0.15239345E-06_JPRB, 0.13484949E-06_JPRB, 0.12362872E-06_JPRB, 0.11357793E-06_JPRB, 0.10332015E-06_JPRB, 0.96109169E-07_JPRB, &
  & 0.92636370E-07_JPRB, 0.91258684E-07_JPRB, 0.90674234E-07_JPRB, 0.90451763E-07_JPRB, 0.90408626E-07_JPRB, 0.90489536E-07_JPRB, &
  & 0.90763415E-07_JPRB, 0.91166541E-07_JPRB, 0.91872913E-07_JPRB, 0.92530485E-07_JPRB, 0.92692609E-07_JPRB, 0.91032057E-07_JPRB, &
  & 0.87486420E-07_JPRB, 0.82403460E-07_JPRB, 0.76133311E-07_JPRB, 0.69051737E-07_JPRB, 0.61662107E-07_JPRB, 0.54607447E-07_JPRB, &
  & 0.48425800E-07_JPRB, 0.43461178E-07_JPRB, 0.39909374E-07_JPRB, 0.37745036E-07_JPRB, 0.36853852E-07_JPRB, 0.37204963E-07_JPRB, &
  & 0.38880355E-07_JPRB, 0.41883030E-07_JPRB, 0.46386603E-07_JPRB, 0.52373682E-07_JPRB, 0.59399646E-07_JPRB, 0.67041931E-07_JPRB, &
  & 0.74901571E-07_JPRB, 0.82895731E-07_JPRB, 0.91151477E-07_JPRB, 0.99638889E-07_JPRB, 0.10799689E-06_JPRB, 0.11524730E-06_JPRB, &
  & 0.12015376E-06_JPRB, 0.12195761E-06_JPRB, 0.12129144E-06_JPRB, 0.11936943E-06_JPRB, 0.11762521E-06_JPRB, 0.11673251E-06_JPRB, &
  & 0.11657572E-06_JPRB, 0.11726506E-06_JPRB, 0.11841202E-06_JPRB, 0.11984814E-06_JPRB, 0.12116431E-06_JPRB, 0.12243086E-06_JPRB, &
  & 0.12360358E-06_JPRB, 0.12487807E-06_JPRB, 0.12639430E-06_JPRB, 0.12820904E-06_JPRB, 0.13031847E-06_JPRB, 0.13251777E-06_JPRB, &
  & 0.13481529E-06_JPRB, 0.13737426E-06_JPRB, 0.14069290E-06_JPRB, 0.14834889E-06_JPRB /)

RGHG7(:,56, 2) = (/ &
  & 0.12935429E-06_JPRB, 0.11402934E-06_JPRB, 0.10578366E-06_JPRB, 0.98665069E-07_JPRB, 0.92148461E-07_JPRB, 0.87831509E-07_JPRB, &
  & 0.85926359E-07_JPRB, 0.85177938E-07_JPRB, 0.84865022E-07_JPRB, 0.84758263E-07_JPRB, 0.84721400E-07_JPRB, 0.84795793E-07_JPRB, &
  & 0.84946151E-07_JPRB, 0.85325922E-07_JPRB, 0.85821256E-07_JPRB, 0.86646004E-07_JPRB, 0.87006704E-07_JPRB, 0.86120920E-07_JPRB, &
  & 0.83184226E-07_JPRB, 0.78552674E-07_JPRB, 0.72627245E-07_JPRB, 0.65855566E-07_JPRB, 0.58796360E-07_JPRB, 0.52033013E-07_JPRB, &
  & 0.46115755E-07_JPRB, 0.41422844E-07_JPRB, 0.38127840E-07_JPRB, 0.36173827E-07_JPRB, 0.35461781E-07_JPRB, 0.35955964E-07_JPRB, &
  & 0.37753111E-07_JPRB, 0.40871402E-07_JPRB, 0.45349008E-07_JPRB, 0.51249337E-07_JPRB, 0.58062305E-07_JPRB, 0.65455382E-07_JPRB, &
  & 0.72997452E-07_JPRB, 0.80668251E-07_JPRB, 0.88508784E-07_JPRB, 0.96482552E-07_JPRB, 0.10410980E-06_JPRB, 0.11051043E-06_JPRB, &
  & 0.11445533E-06_JPRB, 0.11555863E-06_JPRB, 0.11445942E-06_JPRB, 0.11251194E-06_JPRB, 0.11091562E-06_JPRB, 0.11011431E-06_JPRB, &
  & 0.10999459E-06_JPRB, 0.11050582E-06_JPRB, 0.11132811E-06_JPRB, 0.11230640E-06_JPRB, 0.11322248E-06_JPRB, 0.11405605E-06_JPRB, &
  & 0.11485565E-06_JPRB, 0.11572153E-06_JPRB, 0.11672628E-06_JPRB, 0.11797638E-06_JPRB, 0.11933791E-06_JPRB, 0.12081748E-06_JPRB, &
  & 0.12230986E-06_JPRB, 0.12392435E-06_JPRB, 0.12617140E-06_JPRB, 0.13227140E-06_JPRB /)

RGHG7(:,57, 2) = (/ &
  & 0.11182154E-06_JPRB, 0.98822078E-07_JPRB, 0.93300407E-07_JPRB, 0.88461206E-07_JPRB, 0.84594895E-07_JPRB, 0.81983124E-07_JPRB, &
  & 0.80832322E-07_JPRB, 0.80408405E-07_JPRB, 0.80187377E-07_JPRB, 0.80103618E-07_JPRB, 0.80036891E-07_JPRB, 0.80066165E-07_JPRB, &
  & 0.80153420E-07_JPRB, 0.80365041E-07_JPRB, 0.80799538E-07_JPRB, 0.81392329E-07_JPRB, 0.82024968E-07_JPRB, 0.81446181E-07_JPRB, &
  & 0.78973528E-07_JPRB, 0.74739795E-07_JPRB, 0.69188637E-07_JPRB, 0.62758062E-07_JPRB, 0.56001227E-07_JPRB, 0.49589257E-07_JPRB, &
  & 0.43979139E-07_JPRB, 0.39582108E-07_JPRB, 0.36535944E-07_JPRB, 0.34793803E-07_JPRB, 0.34239822E-07_JPRB, 0.34856832E-07_JPRB, &
  & 0.36733713E-07_JPRB, 0.39905615E-07_JPRB, 0.44402480E-07_JPRB, 0.50109787E-07_JPRB, 0.56766087E-07_JPRB, 0.63867837E-07_JPRB, &
  & 0.71110804E-07_JPRB, 0.78431306E-07_JPRB, 0.85858822E-07_JPRB, 0.93268376E-07_JPRB, 0.10023589E-06_JPRB, 0.10582682E-06_JPRB, &
  & 0.10912320E-06_JPRB, 0.10973188E-06_JPRB, 0.10853692E-06_JPRB, 0.10664107E-06_JPRB, 0.10533880E-06_JPRB, 0.10469370E-06_JPRB, &
  & 0.10474041E-06_JPRB, 0.10519637E-06_JPRB, 0.10591364E-06_JPRB, 0.10669319E-06_JPRB, 0.10739370E-06_JPRB, 0.10803833E-06_JPRB, &
  & 0.10862745E-06_JPRB, 0.10926222E-06_JPRB, 0.11000843E-06_JPRB, 0.11088895E-06_JPRB, 0.11193555E-06_JPRB, 0.11300266E-06_JPRB, &
  & 0.11405526E-06_JPRB, 0.11517007E-06_JPRB, 0.11641371E-06_JPRB, 0.11887211E-06_JPRB /)

RGHG7(:,58, 2) = (/ &
  & 0.97402761E-07_JPRB, 0.88606832E-07_JPRB, 0.84301575E-07_JPRB, 0.81632898E-07_JPRB, 0.79023501E-07_JPRB, 0.77445080E-07_JPRB, &
  & 0.76678113E-07_JPRB, 0.76365922E-07_JPRB, 0.76181529E-07_JPRB, 0.76075061E-07_JPRB, 0.75970732E-07_JPRB, 0.75940100E-07_JPRB, &
  & 0.75939248E-07_JPRB, 0.76080696E-07_JPRB, 0.76352144E-07_JPRB, 0.76831661E-07_JPRB, 0.77313338E-07_JPRB, 0.76982289E-07_JPRB, &
  & 0.74870847E-07_JPRB, 0.70997530E-07_JPRB, 0.65791546E-07_JPRB, 0.59701208E-07_JPRB, 0.53344042E-07_JPRB, 0.47249802E-07_JPRB, &
  & 0.41998611E-07_JPRB, 0.37913928E-07_JPRB, 0.35135496E-07_JPRB, 0.33587323E-07_JPRB, 0.33175720E-07_JPRB, 0.33889091E-07_JPRB, &
  & 0.35810459E-07_JPRB, 0.38984094E-07_JPRB, 0.43434735E-07_JPRB, 0.48996270E-07_JPRB, 0.55437386E-07_JPRB, 0.62242854E-07_JPRB, &
  & 0.69182619E-07_JPRB, 0.76148588E-07_JPRB, 0.83145693E-07_JPRB, 0.90035890E-07_JPRB, 0.96327057E-07_JPRB, 0.10131275E-06_JPRB, &
  & 0.10405651E-06_JPRB, 0.10444803E-06_JPRB, 0.10323627E-06_JPRB, 0.10155789E-06_JPRB, 0.10049909E-06_JPRB, 0.10006985E-06_JPRB, &
  & 0.10028636E-06_JPRB, 0.10079329E-06_JPRB, 0.10150141E-06_JPRB, 0.10218196E-06_JPRB, 0.10282596E-06_JPRB, 0.10335921E-06_JPRB, &
  & 0.10387483E-06_JPRB, 0.10442108E-06_JPRB, 0.10504390E-06_JPRB, 0.10581795E-06_JPRB, 0.10664277E-06_JPRB, 0.10751404E-06_JPRB, &
  & 0.10840849E-06_JPRB, 0.10938005E-06_JPRB, 0.11071987E-06_JPRB, 0.11374663E-06_JPRB /)

RGHG7(:,59, 2) = (/ &
  & 0.87340624E-07_JPRB, 0.80376005E-07_JPRB, 0.78236333E-07_JPRB, 0.76297205E-07_JPRB, 0.74810053E-07_JPRB, 0.73693116E-07_JPRB, &
  & 0.73120866E-07_JPRB, 0.72831575E-07_JPRB, 0.72627657E-07_JPRB, 0.72481086E-07_JPRB, 0.72341976E-07_JPRB, 0.72224047E-07_JPRB, &
  & 0.72173471E-07_JPRB, 0.72201118E-07_JPRB, 0.72352719E-07_JPRB, 0.72682575E-07_JPRB, 0.73065330E-07_JPRB, 0.72710577E-07_JPRB, &
  & 0.70841558E-07_JPRB, 0.67299503E-07_JPRB, 0.62436499E-07_JPRB, 0.56752700E-07_JPRB, 0.50734602E-07_JPRB, 0.45054556E-07_JPRB, &
  & 0.40165286E-07_JPRB, 0.36427412E-07_JPRB, 0.33913725E-07_JPRB, 0.32558241E-07_JPRB, 0.32267337E-07_JPRB, 0.33044625E-07_JPRB, &
  & 0.34972409E-07_JPRB, 0.38094569E-07_JPRB, 0.42435989E-07_JPRB, 0.47850069E-07_JPRB, 0.54015121E-07_JPRB, 0.60560708E-07_JPRB, &
  & 0.67180459E-07_JPRB, 0.73805424E-07_JPRB, 0.80381682E-07_JPRB, 0.86756749E-07_JPRB, 0.92503853E-07_JPRB, 0.96904856E-07_JPRB, &
  & 0.99319806E-07_JPRB, 0.99563941E-07_JPRB, 0.98460468E-07_JPRB, 0.96997034E-07_JPRB, 0.96187755E-07_JPRB, 0.95997777E-07_JPRB, &
  & 0.96379424E-07_JPRB, 0.96989041E-07_JPRB, 0.97719258E-07_JPRB, 0.98402886E-07_JPRB, 0.99006826E-07_JPRB, 0.99519767E-07_JPRB, &
  & 0.10000279E-06_JPRB, 0.10049366E-06_JPRB, 0.10106510E-06_JPRB, 0.10170657E-06_JPRB, 0.10244076E-06_JPRB, 0.10319645E-06_JPRB, &
  & 0.10393526E-06_JPRB, 0.10469909E-06_JPRB, 0.10561509E-06_JPRB, 0.10785614E-06_JPRB /)

RGHG7(:,60, 2) = (/ &
  & 0.78108435E-07_JPRB, 0.74735581E-07_JPRB, 0.73213251E-07_JPRB, 0.72297546E-07_JPRB, 0.71258462E-07_JPRB, 0.70478471E-07_JPRB, &
  & 0.69955277E-07_JPRB, 0.69645679E-07_JPRB, 0.69411897E-07_JPRB, 0.69195359E-07_JPRB, 0.69010298E-07_JPRB, 0.68832087E-07_JPRB, &
  & 0.68695883E-07_JPRB, 0.68619237E-07_JPRB, 0.68646834E-07_JPRB, 0.68805228E-07_JPRB, 0.69004862E-07_JPRB, 0.68652909E-07_JPRB, &
  & 0.66942924E-07_JPRB, 0.63659606E-07_JPRB, 0.59171978E-07_JPRB, 0.53849817E-07_JPRB, 0.48263367E-07_JPRB, 0.42974772E-07_JPRB, &
  & 0.38504794E-07_JPRB, 0.35119371E-07_JPRB, 0.32879271E-07_JPRB, 0.31707113E-07_JPRB, 0.31517935E-07_JPRB, 0.32324820E-07_JPRB, &
  & 0.34212455E-07_JPRB, 0.37235232E-07_JPRB, 0.41417078E-07_JPRB, 0.46631044E-07_JPRB, 0.52554526E-07_JPRB, 0.58796701E-07_JPRB, &
  & 0.65127480E-07_JPRB, 0.71393664E-07_JPRB, 0.77586186E-07_JPRB, 0.83511885E-07_JPRB, 0.88734446E-07_JPRB, 0.92717329E-07_JPRB, &
  & 0.94825786E-07_JPRB, 0.95054922E-07_JPRB, 0.94099136E-07_JPRB, 0.92901644E-07_JPRB, 0.92290669E-07_JPRB, 0.92327497E-07_JPRB, &
  & 0.92867452E-07_JPRB, 0.93584447E-07_JPRB, 0.94388113E-07_JPRB, 0.95092986E-07_JPRB, 0.95726996E-07_JPRB, 0.96239432E-07_JPRB, &
  & 0.96729295E-07_JPRB, 0.97225488E-07_JPRB, 0.97777367E-07_JPRB, 0.98420820E-07_JPRB, 0.99099822E-07_JPRB, 0.99783897E-07_JPRB, &
  & 0.10045593E-06_JPRB, 0.10117125E-06_JPRB, 0.10209420E-06_JPRB, 0.10408439E-06_JPRB /)

RGHG7(:,61, 2) = (/ &
  & 0.71747657E-07_JPRB, 0.70252213E-07_JPRB, 0.69616853E-07_JPRB, 0.68928394E-07_JPRB, 0.68262473E-07_JPRB, 0.67623610E-07_JPRB, &
  & 0.67138735E-07_JPRB, 0.66766290E-07_JPRB, 0.66469191E-07_JPRB, 0.66200712E-07_JPRB, 0.65922961E-07_JPRB, 0.65672452E-07_JPRB, &
  & 0.65432801E-07_JPRB, 0.65244677E-07_JPRB, 0.65134628E-07_JPRB, 0.65158524E-07_JPRB, 0.65219709E-07_JPRB, 0.64752818E-07_JPRB, &
  & 0.63137925E-07_JPRB, 0.60134930E-07_JPRB, 0.55998850E-07_JPRB, 0.51052503E-07_JPRB, 0.45895863E-07_JPRB, 0.41062698E-07_JPRB, &
  & 0.37015393E-07_JPRB, 0.34001175E-07_JPRB, 0.32034574E-07_JPRB, 0.31040269E-07_JPRB, 0.30931830E-07_JPRB, 0.31734892E-07_JPRB, &
  & 0.33546865E-07_JPRB, 0.36416480E-07_JPRB, 0.40390642E-07_JPRB, 0.45359922E-07_JPRB, 0.51003521E-07_JPRB, 0.56990206E-07_JPRB, &
  & 0.63002169E-07_JPRB, 0.68974053E-07_JPRB, 0.74796674E-07_JPRB, 0.80308936E-07_JPRB, 0.85119922E-07_JPRB, 0.88698378E-07_JPRB, &
  & 0.90631445E-07_JPRB, 0.90863189E-07_JPRB, 0.90076028E-07_JPRB, 0.89123560E-07_JPRB, 0.88719432E-07_JPRB, 0.88942620E-07_JPRB, &
  & 0.89623121E-07_JPRB, 0.90485166E-07_JPRB, 0.91351261E-07_JPRB, 0.92145314E-07_JPRB, 0.92795361E-07_JPRB, 0.93363120E-07_JPRB, &
  & 0.93873332E-07_JPRB, 0.94392099E-07_JPRB, 0.94960676E-07_JPRB, 0.95577171E-07_JPRB, 0.96232050E-07_JPRB, 0.96876740E-07_JPRB, &
  & 0.97502408E-07_JPRB, 0.98130307E-07_JPRB, 0.98901253E-07_JPRB, 0.10069132E-06_JPRB /)

RGHG7(:,62, 2) = (/ &
  & 0.68916300E-07_JPRB, 0.67287814E-07_JPRB, 0.66557284E-07_JPRB, 0.66107987E-07_JPRB, 0.65607004E-07_JPRB, 0.65072847E-07_JPRB, &
  & 0.64574635E-07_JPRB, 0.64146903E-07_JPRB, 0.63764119E-07_JPRB, 0.63399078E-07_JPRB, 0.63048454E-07_JPRB, 0.62668086E-07_JPRB, &
  & 0.62316353E-07_JPRB, 0.61988949E-07_JPRB, 0.61760765E-07_JPRB, 0.61661474E-07_JPRB, 0.61574696E-07_JPRB, 0.61049931E-07_JPRB, &
  & 0.59522343E-07_JPRB, 0.56748732E-07_JPRB, 0.52928961E-07_JPRB, 0.48390500E-07_JPRB, 0.43681116E-07_JPRB, 0.39315651E-07_JPRB, &
  & 0.35719626E-07_JPRB, 0.33077328E-07_JPRB, 0.31386037E-07_JPRB, 0.30563175E-07_JPRB, 0.30517867E-07_JPRB, 0.31293375E-07_JPRB, &
  & 0.32992912E-07_JPRB, 0.35670908E-07_JPRB, 0.39387348E-07_JPRB, 0.44066947E-07_JPRB, 0.49442292E-07_JPRB, 0.55118637E-07_JPRB, &
  & 0.60889029E-07_JPRB, 0.66550434E-07_JPRB, 0.72056672E-07_JPRB, 0.77207289E-07_JPRB, 0.81639222E-07_JPRB, 0.84916351E-07_JPRB, &
  & 0.86681659E-07_JPRB, 0.86967319E-07_JPRB, 0.86371919E-07_JPRB, 0.85647955E-07_JPRB, 0.85423089E-07_JPRB, 0.85799947E-07_JPRB, &
  & 0.86605532E-07_JPRB, 0.87581043E-07_JPRB, 0.88562253E-07_JPRB, 0.89420581E-07_JPRB, 0.90153044E-07_JPRB, 0.90767010E-07_JPRB, &
  & 0.91331827E-07_JPRB, 0.91899537E-07_JPRB, 0.92500251E-07_JPRB, 0.93157809E-07_JPRB, 0.93812147E-07_JPRB, 0.94449028E-07_JPRB, &
  & 0.95051128E-07_JPRB, 0.95667922E-07_JPRB, 0.96407938E-07_JPRB, 0.98024188E-07_JPRB /)

RGHG7(:,63, 2) = (/ &
  & 0.65517447E-07_JPRB, 0.64356854E-07_JPRB, 0.63942373E-07_JPRB, 0.63569502E-07_JPRB, 0.63171328E-07_JPRB, 0.62716090E-07_JPRB, &
  & 0.62233120E-07_JPRB, 0.61738703E-07_JPRB, 0.61257403E-07_JPRB, 0.60793056E-07_JPRB, 0.60291839E-07_JPRB, 0.59804727E-07_JPRB, &
  & 0.59286762E-07_JPRB, 0.58853864E-07_JPRB, 0.58522932E-07_JPRB, 0.58344575E-07_JPRB, 0.58147165E-07_JPRB, 0.57547485E-07_JPRB, &
  & 0.56071372E-07_JPRB, 0.53519216E-07_JPRB, 0.50020475E-07_JPRB, 0.45885415E-07_JPRB, 0.41650555E-07_JPRB, 0.37773788E-07_JPRB, &
  & 0.34632713E-07_JPRB, 0.32367243E-07_JPRB, 0.30948403E-07_JPRB, 0.30288181E-07_JPRB, 0.30295116E-07_JPRB, 0.31027696E-07_JPRB, &
  & 0.32593110E-07_JPRB, 0.35044330E-07_JPRB, 0.38466389E-07_JPRB, 0.42818414E-07_JPRB, 0.47854183E-07_JPRB, 0.53285305E-07_JPRB, &
  & 0.58775065E-07_JPRB, 0.64188342E-07_JPRB, 0.69395320E-07_JPRB, 0.74217965E-07_JPRB, 0.78337983E-07_JPRB, 0.81343501E-07_JPRB, &
  & 0.83004075E-07_JPRB, 0.83350209E-07_JPRB, 0.82937319E-07_JPRB, 0.82437204E-07_JPRB, 0.82373361E-07_JPRB, 0.82866592E-07_JPRB, &
  & 0.83770828E-07_JPRB, 0.84853774E-07_JPRB, 0.85925365E-07_JPRB, 0.86886537E-07_JPRB, 0.87689131E-07_JPRB, 0.88385384E-07_JPRB, &
  & 0.89017639E-07_JPRB, 0.89651486E-07_JPRB, 0.90316931E-07_JPRB, 0.90999613E-07_JPRB, 0.91670600E-07_JPRB, 0.92310536E-07_JPRB, &
  & 0.92911606E-07_JPRB, 0.93498031E-07_JPRB, 0.94212339E-07_JPRB, 0.95733547E-07_JPRB /)

RGHG7(:,64, 2) = (/ &
  & 0.63152612E-07_JPRB, 0.62074186E-07_JPRB, 0.61587741E-07_JPRB, 0.61264473E-07_JPRB, 0.60931221E-07_JPRB, 0.60507098E-07_JPRB, &
  & 0.60014663E-07_JPRB, 0.59478602E-07_JPRB, 0.58883408E-07_JPRB, 0.58284787E-07_JPRB, 0.57677411E-07_JPRB, 0.57009117E-07_JPRB, &
  & 0.56404705E-07_JPRB, 0.55883710E-07_JPRB, 0.55511364E-07_JPRB, 0.55260394E-07_JPRB, 0.54958399E-07_JPRB, 0.54293729E-07_JPRB, &
  & 0.52875073E-07_JPRB, 0.50511968E-07_JPRB, 0.47320675E-07_JPRB, 0.43609969E-07_JPRB, 0.39846451E-07_JPRB, 0.36475019E-07_JPRB, &
  & 0.33787099E-07_JPRB, 0.31889627E-07_JPRB, 0.30734920E-07_JPRB, 0.30227042E-07_JPRB, 0.30280667E-07_JPRB, 0.30966579E-07_JPRB, &
  & 0.32390957E-07_JPRB, 0.34604170E-07_JPRB, 0.37702531E-07_JPRB, 0.41677030E-07_JPRB, 0.46387260E-07_JPRB, 0.51502223E-07_JPRB, &
  & 0.56756431E-07_JPRB, 0.61912360E-07_JPRB, 0.66845431E-07_JPRB, 0.71380590E-07_JPRB, 0.75216981E-07_JPRB, 0.78013422E-07_JPRB, &
  & 0.79590237E-07_JPRB, 0.80019127E-07_JPRB, 0.79797026E-07_JPRB, 0.79496814E-07_JPRB, 0.79580467E-07_JPRB, 0.80161641E-07_JPRB, &
  & 0.81133912E-07_JPRB, 0.82286711E-07_JPRB, 0.83445016E-07_JPRB, 0.84488562E-07_JPRB, 0.85390774E-07_JPRB, 0.86163624E-07_JPRB, &
  & 0.86891284E-07_JPRB, 0.87607610E-07_JPRB, 0.88344073E-07_JPRB, 0.89086321E-07_JPRB, 0.89791733E-07_JPRB, 0.90450811E-07_JPRB, &
  & 0.91058681E-07_JPRB, 0.91668383E-07_JPRB, 0.92371053E-07_JPRB, 0.93834984E-07_JPRB /)

RGHG7(:,65, 2) = (/ &
  & 0.60888709E-07_JPRB, 0.59835706E-07_JPRB, 0.59444194E-07_JPRB, 0.59128531E-07_JPRB, 0.58799657E-07_JPRB, 0.58402943E-07_JPRB, &
  & 0.57909499E-07_JPRB, 0.57295466E-07_JPRB, 0.56606666E-07_JPRB, 0.55863872E-07_JPRB, 0.55125504E-07_JPRB, 0.54376173E-07_JPRB, &
  & 0.53700823E-07_JPRB, 0.53161106E-07_JPRB, 0.52751652E-07_JPRB, 0.52427474E-07_JPRB, 0.52045582E-07_JPRB, 0.51319081E-07_JPRB, &
  & 0.49943559E-07_JPRB, 0.47770953E-07_JPRB, 0.44892758E-07_JPRB, 0.41598611E-07_JPRB, 0.38327922E-07_JPRB, 0.35447975E-07_JPRB, &
  & 0.33200511E-07_JPRB, 0.31652590E-07_JPRB, 0.30744499E-07_JPRB, 0.30377237E-07_JPRB, 0.30475643E-07_JPRB, 0.31120056E-07_JPRB, &
  & 0.32411844E-07_JPRB, 0.34395171E-07_JPRB, 0.37156777E-07_JPRB, 0.40742204E-07_JPRB, 0.45094168E-07_JPRB, 0.49896627E-07_JPRB, &
  & 0.54884669E-07_JPRB, 0.59779055E-07_JPRB, 0.64456394E-07_JPRB, 0.68713206E-07_JPRB, 0.72309135E-07_JPRB, 0.74931229E-07_JPRB, &
  & 0.76458512E-07_JPRB, 0.76980342E-07_JPRB, 0.76929233E-07_JPRB, 0.76822076E-07_JPRB, 0.77039942E-07_JPRB, 0.77693969E-07_JPRB, &
  & 0.78702563E-07_JPRB, 0.79896999E-07_JPRB, 0.81114642E-07_JPRB, 0.82230741E-07_JPRB, 0.83207269E-07_JPRB, 0.84082117E-07_JPRB, &
  & 0.84895511E-07_JPRB, 0.85705878E-07_JPRB, 0.86534619E-07_JPRB, 0.87329902E-07_JPRB, 0.88072468E-07_JPRB, 0.88758746E-07_JPRB, &
  & 0.89399734E-07_JPRB, 0.90026404E-07_JPRB, 0.90773192E-07_JPRB, 0.92240128E-07_JPRB /)

RGHG7(:,66, 2) = (/ &
  & 0.58929821E-07_JPRB, 0.57900898E-07_JPRB, 0.57447291E-07_JPRB, 0.57120726E-07_JPRB, 0.56793464E-07_JPRB, 0.56376177E-07_JPRB, &
  & 0.55854379E-07_JPRB, 0.55199042E-07_JPRB, 0.54356139E-07_JPRB, 0.53543030E-07_JPRB, 0.52694705E-07_JPRB, 0.51915833E-07_JPRB, &
  & 0.51232000E-07_JPRB, 0.50672877E-07_JPRB, 0.50253547E-07_JPRB, 0.49860621E-07_JPRB, 0.49421935E-07_JPRB, 0.48648207E-07_JPRB, &
  & 0.47339029E-07_JPRB, 0.45347679E-07_JPRB, 0.42783885E-07_JPRB, 0.39909445E-07_JPRB, 0.37111430E-07_JPRB, 0.34704136E-07_JPRB, &
  & 0.32869835E-07_JPRB, 0.31643999E-07_JPRB, 0.30962191E-07_JPRB, 0.30722340E-07_JPRB, 0.30865426E-07_JPRB, 0.31480063E-07_JPRB, &
  & 0.32655525E-07_JPRB, 0.34425952E-07_JPRB, 0.36872795E-07_JPRB, 0.40072749E-07_JPRB, 0.44056488E-07_JPRB, 0.48532655E-07_JPRB, &
  & 0.53216876E-07_JPRB, 0.57851718E-07_JPRB, 0.62248702E-07_JPRB, 0.66253818E-07_JPRB, 0.69620086E-07_JPRB, 0.72101571E-07_JPRB, &
  & 0.73600717E-07_JPRB, 0.74219969E-07_JPRB, 0.74341386E-07_JPRB, 0.74405378E-07_JPRB, 0.74745344E-07_JPRB, 0.75460740E-07_JPRB, &
  & 0.76493038E-07_JPRB, 0.77703056E-07_JPRB, 0.78937617E-07_JPRB, 0.80105963E-07_JPRB, 0.81147448E-07_JPRB, 0.82091809E-07_JPRB, &
  & 0.82996330E-07_JPRB, 0.83903551E-07_JPRB, 0.84812953E-07_JPRB, 0.85672774E-07_JPRB, 0.86455508E-07_JPRB, 0.87178357E-07_JPRB, &
  & 0.87855852E-07_JPRB, 0.88542997E-07_JPRB, 0.89354124E-07_JPRB, 0.90912756E-07_JPRB /)

RGHG7(:,67, 2) = (/ &
  & 0.57114409E-07_JPRB, 0.56013945E-07_JPRB, 0.55565280E-07_JPRB, 0.55212340E-07_JPRB, 0.54852748E-07_JPRB, 0.54423278E-07_JPRB, &
  & 0.53862880E-07_JPRB, 0.53142880E-07_JPRB, 0.52226753E-07_JPRB, 0.51284118E-07_JPRB, 0.50443852E-07_JPRB, 0.49636100E-07_JPRB, &
  & 0.48991879E-07_JPRB, 0.48419317E-07_JPRB, 0.48003333E-07_JPRB, 0.47572787E-07_JPRB, 0.47097011E-07_JPRB, 0.46311847E-07_JPRB, &
  & 0.45078288E-07_JPRB, 0.43282014E-07_JPRB, 0.41028944E-07_JPRB, 0.38559932E-07_JPRB, 0.36213365E-07_JPRB, 0.34242184E-07_JPRB, &
  & 0.32779518E-07_JPRB, 0.31845111E-07_JPRB, 0.31363534E-07_JPRB, 0.31240731E-07_JPRB, 0.31431036E-07_JPRB, 0.32026218E-07_JPRB, &
  & 0.33108719E-07_JPRB, 0.34689190E-07_JPRB, 0.36847950E-07_JPRB, 0.39700854E-07_JPRB, 0.43307608E-07_JPRB, 0.47436124E-07_JPRB, &
  & 0.51823857E-07_JPRB, 0.56151727E-07_JPRB, 0.60279902E-07_JPRB, 0.64017769E-07_JPRB, 0.67176380E-07_JPRB, 0.69531914E-07_JPRB, &
  & 0.71019677E-07_JPRB, 0.71733155E-07_JPRB, 0.72011083E-07_JPRB, 0.72230037E-07_JPRB, 0.72677956E-07_JPRB, 0.73446486E-07_JPRB, &
  & 0.74492029E-07_JPRB, 0.75699589E-07_JPRB, 0.76943351E-07_JPRB, 0.78117303E-07_JPRB, 0.79192525E-07_JPRB, 0.80190695E-07_JPRB, &
  & 0.81158284E-07_JPRB, 0.82138754E-07_JPRB, 0.83136484E-07_JPRB, 0.84041609E-07_JPRB, 0.84860659E-07_JPRB, 0.85614857E-07_JPRB, &
  & 0.86344762E-07_JPRB, 0.87096751E-07_JPRB, 0.88031811E-07_JPRB, 0.89773131E-07_JPRB /)

RGHG7(:,68, 2) = (/ &
  & 0.55416177E-07_JPRB, 0.54271172E-07_JPRB, 0.53764268E-07_JPRB, 0.53375686E-07_JPRB, 0.52986998E-07_JPRB, 0.52513620E-07_JPRB, &
  & 0.51926371E-07_JPRB, 0.51142987E-07_JPRB, 0.50152202E-07_JPRB, 0.49185971E-07_JPRB, 0.48350678E-07_JPRB, 0.47559944E-07_JPRB, &
  & 0.46957883E-07_JPRB, 0.46406750E-07_JPRB, 0.46002040E-07_JPRB, 0.45569383E-07_JPRB, 0.45082995E-07_JPRB, 0.44322594E-07_JPRB, &
  & 0.43188422E-07_JPRB, 0.41593353E-07_JPRB, 0.39643595E-07_JPRB, 0.37553576E-07_JPRB, 0.35615564E-07_JPRB, 0.34032123E-07_JPRB, &
  & 0.32903962E-07_JPRB, 0.32230449E-07_JPRB, 0.31928359E-07_JPRB, 0.31914787E-07_JPRB, 0.32154325E-07_JPRB, 0.32743728E-07_JPRB, &
  & 0.33747426E-07_JPRB, 0.35170384E-07_JPRB, 0.37067110E-07_JPRB, 0.39603325E-07_JPRB, 0.42843382E-07_JPRB, 0.46646910E-07_JPRB, &
  & 0.50695885E-07_JPRB, 0.54729643E-07_JPRB, 0.58557671E-07_JPRB, 0.62039270E-07_JPRB, 0.64984569E-07_JPRB, 0.67234133E-07_JPRB, &
  & 0.68706292E-07_JPRB, 0.69508062E-07_JPRB, 0.69926649E-07_JPRB, 0.70282027E-07_JPRB, 0.70820406E-07_JPRB, 0.71635213E-07_JPRB, &
  & 0.72683001E-07_JPRB, 0.73877985E-07_JPRB, 0.75096452E-07_JPRB, 0.76269430E-07_JPRB, 0.77348446E-07_JPRB, 0.78368181E-07_JPRB, &
  & 0.79370366E-07_JPRB, 0.80402039E-07_JPRB, 0.81462176E-07_JPRB, 0.82403162E-07_JPRB, 0.83242000E-07_JPRB, 0.84024670E-07_JPRB, &
  & 0.84786862E-07_JPRB, 0.85626560E-07_JPRB, 0.86720974E-07_JPRB, 0.88745679E-07_JPRB /)

RGHG7(:,69, 2) = (/ &
  & 0.53847934E-07_JPRB, 0.52580116E-07_JPRB, 0.52017100E-07_JPRB, 0.51581612E-07_JPRB, 0.51145946E-07_JPRB, 0.50646243E-07_JPRB, &
  & 0.50014620E-07_JPRB, 0.49215799E-07_JPRB, 0.48171334E-07_JPRB, 0.47209294E-07_JPRB, 0.46411369E-07_JPRB, 0.45676213E-07_JPRB, &
  & 0.45125233E-07_JPRB, 0.44623025E-07_JPRB, 0.44247518E-07_JPRB, 0.43841759E-07_JPRB, 0.43377600E-07_JPRB, 0.42675193E-07_JPRB, &
  & 0.41659675E-07_JPRB, 0.40270166E-07_JPRB, 0.38607521E-07_JPRB, 0.36865693E-07_JPRB, 0.35297429E-07_JPRB, 0.34062605E-07_JPRB, &
  & 0.33229409E-07_JPRB, 0.32783035E-07_JPRB, 0.32642518E-07_JPRB, 0.32731347E-07_JPRB, 0.33024474E-07_JPRB, 0.33616271E-07_JPRB, &
  & 0.34560536E-07_JPRB, 0.35850984E-07_JPRB, 0.37514848E-07_JPRB, 0.39750223E-07_JPRB, 0.42675730E-07_JPRB, 0.46127038E-07_JPRB, &
  & 0.49861256E-07_JPRB, 0.53567028E-07_JPRB, 0.57104579E-07_JPRB, 0.60321462E-07_JPRB, 0.63062920E-07_JPRB, 0.65201128E-07_JPRB, &
  & 0.66656249E-07_JPRB, 0.67527246E-07_JPRB, 0.68064459E-07_JPRB, 0.68530142E-07_JPRB, 0.69148825E-07_JPRB, 0.69988523E-07_JPRB, &
  & 0.71033227E-07_JPRB, 0.72201175E-07_JPRB, 0.73397182E-07_JPRB, 0.74535890E-07_JPRB, 0.75598315E-07_JPRB, 0.76611926E-07_JPRB, &
  & 0.77623703E-07_JPRB, 0.78680401E-07_JPRB, 0.79768157E-07_JPRB, 0.80726693E-07_JPRB, 0.81570526E-07_JPRB, 0.82352500E-07_JPRB, &
  & 0.83147647E-07_JPRB, 0.84033573E-07_JPRB, 0.85330782E-07_JPRB, 0.87669854E-07_JPRB /)

RGHG7(:,70, 2) = (/ &
  & 0.52322058E-07_JPRB, 0.50909041E-07_JPRB, 0.50274288E-07_JPRB, 0.49788031E-07_JPRB, 0.49318160E-07_JPRB, 0.48784187E-07_JPRB, &
  & 0.48139121E-07_JPRB, 0.47310191E-07_JPRB, 0.46283958E-07_JPRB, 0.45366750E-07_JPRB, 0.44631854E-07_JPRB, 0.43973611E-07_JPRB, &
  & 0.43488594E-07_JPRB, 0.43060567E-07_JPRB, 0.42731287E-07_JPRB, 0.42382588E-07_JPRB, 0.41965556E-07_JPRB, 0.41350031E-07_JPRB, &
  & 0.40466954E-07_JPRB, 0.39282828E-07_JPRB, 0.37890903E-07_JPRB, 0.36467892E-07_JPRB, 0.35225643E-07_JPRB, 0.34296210E-07_JPRB, &
  & 0.33725271E-07_JPRB, 0.33484678E-07_JPRB, 0.33491059E-07_JPRB, 0.33677399E-07_JPRB, 0.34025774E-07_JPRB, 0.34628645E-07_JPRB, &
  & 0.35525051E-07_JPRB, 0.36702499E-07_JPRB, 0.38161730E-07_JPRB, 0.40126967E-07_JPRB, 0.42764992E-07_JPRB, 0.45883716E-07_JPRB, &
  & 0.49280658E-07_JPRB, 0.52673506E-07_JPRB, 0.55908242E-07_JPRB, 0.58862842E-07_JPRB, 0.61406546E-07_JPRB, 0.63428907E-07_JPRB, &
  & 0.64853886E-07_JPRB, 0.65775346E-07_JPRB, 0.66406947E-07_JPRB, 0.66967424E-07_JPRB, 0.67639121E-07_JPRB, 0.68504164E-07_JPRB, &
  & 0.69526138E-07_JPRB, 0.70661912E-07_JPRB, 0.71804926E-07_JPRB, 0.72906090E-07_JPRB, 0.73929655E-07_JPRB, 0.74919804E-07_JPRB, &
  & 0.75900232E-07_JPRB, 0.76956987E-07_JPRB, 0.78054811E-07_JPRB, 0.78995299E-07_JPRB, 0.79828716E-07_JPRB, 0.80601353E-07_JPRB, &
  & 0.81380414E-07_JPRB, 0.82314287E-07_JPRB, 0.83728608E-07_JPRB, 0.86472077E-07_JPRB /)

RGHG7(:,71, 2) = (/ &
  & 0.50809518E-07_JPRB, 0.49227584E-07_JPRB, 0.48506209E-07_JPRB, 0.47974702E-07_JPRB, 0.47469303E-07_JPRB, 0.46926168E-07_JPRB, &
  & 0.46269559E-07_JPRB, 0.45466233E-07_JPRB, 0.44478504E-07_JPRB, 0.43662027E-07_JPRB, 0.43002601E-07_JPRB, 0.42456580E-07_JPRB, &
  & 0.42046238E-07_JPRB, 0.41705775E-07_JPRB, 0.41444682E-07_JPRB, 0.41170725E-07_JPRB, 0.40825505E-07_JPRB, 0.40313434E-07_JPRB, &
  & 0.39571734E-07_JPRB, 0.38590461E-07_JPRB, 0.37456488E-07_JPRB, 0.36325417E-07_JPRB, 0.35384303E-07_JPRB, 0.34731727E-07_JPRB, &
  & 0.34389824E-07_JPRB, 0.34326874E-07_JPRB, 0.34464453E-07_JPRB, 0.34741980E-07_JPRB, 0.35147934E-07_JPRB, 0.35766853E-07_JPRB, &
  & 0.36632230E-07_JPRB, 0.37705135E-07_JPRB, 0.38978616E-07_JPRB, 0.40748002E-07_JPRB, 0.43077840E-07_JPRB, 0.45875996E-07_JPRB, &
  & 0.48962676E-07_JPRB, 0.52024220E-07_JPRB, 0.54963529E-07_JPRB, 0.57659591E-07_JPRB, 0.60007096E-07_JPRB, 0.61907329E-07_JPRB, &
  & 0.63286009E-07_JPRB, 0.64243359E-07_JPRB, 0.64942490E-07_JPRB, 0.65571896E-07_JPRB, 0.66290035E-07_JPRB, 0.67152705E-07_JPRB, &
  & 0.68149816E-07_JPRB, 0.69234950E-07_JPRB, 0.70332369E-07_JPRB, 0.71368291E-07_JPRB, 0.72340768E-07_JPRB, 0.73279480E-07_JPRB, &
  & 0.74219678E-07_JPRB, 0.75241623E-07_JPRB, 0.76304929E-07_JPRB, 0.77225472E-07_JPRB, 0.78026581E-07_JPRB, 0.78766050E-07_JPRB, &
  & 0.79527879E-07_JPRB, 0.80431271E-07_JPRB, 0.81934218E-07_JPRB, 0.84990340E-07_JPRB /)

RGHG7(:,72, 2) = (/ &
  & 0.49255867E-07_JPRB, 0.47475542E-07_JPRB, 0.46684303E-07_JPRB, 0.46113477E-07_JPRB, 0.45605116E-07_JPRB, 0.45060329E-07_JPRB, &
  & 0.44422432E-07_JPRB, 0.43664208E-07_JPRB, 0.42800000E-07_JPRB, 0.42087080E-07_JPRB, 0.41548823E-07_JPRB, 0.41099430E-07_JPRB, &
  & 0.40794102E-07_JPRB, 0.40547548E-07_JPRB, 0.40369418E-07_JPRB, 0.40183831E-07_JPRB, 0.39928345E-07_JPRB, 0.39530740E-07_JPRB, &
  & 0.38939390E-07_JPRB, 0.38160440E-07_JPRB, 0.37270688E-07_JPRB, 0.36411432E-07_JPRB, 0.35732437E-07_JPRB, 0.35320074E-07_JPRB, &
  & 0.35182438E-07_JPRB, 0.35283215E-07_JPRB, 0.35542588E-07_JPRB, 0.35907718E-07_JPRB, 0.36369968E-07_JPRB, 0.37008647E-07_JPRB, &
  & 0.37842614E-07_JPRB, 0.38814129E-07_JPRB, 0.39979081E-07_JPRB, 0.41552507E-07_JPRB, 0.43586962E-07_JPRB, 0.46082103E-07_JPRB, &
  & 0.48875236E-07_JPRB, 0.51613551E-07_JPRB, 0.54257811E-07_JPRB, 0.56699847E-07_JPRB, 0.58853612E-07_JPRB, 0.60616941E-07_JPRB, &
  & 0.61945606E-07_JPRB, 0.62912008E-07_JPRB, 0.63662377E-07_JPRB, 0.64345258E-07_JPRB, 0.65086823E-07_JPRB, 0.65943176E-07_JPRB, &
  & 0.66903603E-07_JPRB, 0.67936156E-07_JPRB, 0.68956716E-07_JPRB, 0.69935339E-07_JPRB, 0.70822026E-07_JPRB, 0.71713814E-07_JPRB, &
  & 0.72579937E-07_JPRB, 0.73552215E-07_JPRB, 0.74571936E-07_JPRB, 0.75437256E-07_JPRB, 0.76205325E-07_JPRB, 0.76898544E-07_JPRB, &
  & 0.77612128E-07_JPRB, 0.78473356E-07_JPRB, 0.79979465E-07_JPRB, 0.83207297E-07_JPRB /)

RGHG7(:,73, 2) = (/ &
  & 0.47572609E-07_JPRB, 0.45630159E-07_JPRB, 0.44789900E-07_JPRB, 0.44230728E-07_JPRB, 0.43729624E-07_JPRB, 0.43220627E-07_JPRB, &
  & 0.42629747E-07_JPRB, 0.41964853E-07_JPRB, 0.41227956E-07_JPRB, 0.40674262E-07_JPRB, 0.40240703E-07_JPRB, 0.39925666E-07_JPRB, &
  & 0.39710091E-07_JPRB, 0.39571837E-07_JPRB, 0.39487198E-07_JPRB, 0.39397349E-07_JPRB, 0.39244036E-07_JPRB, 0.38967713E-07_JPRB, &
  & 0.38532637E-07_JPRB, 0.37951072E-07_JPRB, 0.37298634E-07_JPRB, 0.36691191E-07_JPRB, 0.36258552E-07_JPRB, 0.36071317E-07_JPRB, &
  & 0.36113910E-07_JPRB, 0.36352777E-07_JPRB, 0.36718490E-07_JPRB, 0.37162785E-07_JPRB, 0.37681328E-07_JPRB, 0.38340733E-07_JPRB, &
  & 0.39149921E-07_JPRB, 0.40055557E-07_JPRB, 0.41131624E-07_JPRB, 0.42464425E-07_JPRB, 0.44328878E-07_JPRB, 0.46464830E-07_JPRB, &
  & 0.48995339E-07_JPRB, 0.51413199E-07_JPRB, 0.53777875E-07_JPRB, 0.55972713E-07_JPRB, 0.57923462E-07_JPRB, 0.59551354E-07_JPRB, &
  & 0.60813868E-07_JPRB, 0.61775310E-07_JPRB, 0.62556857E-07_JPRB, 0.63264906E-07_JPRB, 0.64022750E-07_JPRB, 0.64859840E-07_JPRB, &
  & 0.65772845E-07_JPRB, 0.66743937E-07_JPRB, 0.67702572E-07_JPRB, 0.68590168E-07_JPRB, 0.69429582E-07_JPRB, 0.70221454E-07_JPRB, &
  & 0.71038826E-07_JPRB, 0.71932675E-07_JPRB, 0.72881392E-07_JPRB, 0.73697727E-07_JPRB, 0.74411176E-07_JPRB, 0.75053315E-07_JPRB, &
  & 0.75712734E-07_JPRB, 0.76494800E-07_JPRB, 0.77959200E-07_JPRB, 0.81256552E-07_JPRB /)

RGHG7(:,74, 2) = (/ &
  & 0.45675684E-07_JPRB, 0.43677552E-07_JPRB, 0.42875847E-07_JPRB, 0.42347210E-07_JPRB, 0.41903995E-07_JPRB, 0.41448395E-07_JPRB, &
  & 0.40938712E-07_JPRB, 0.40389910E-07_JPRB, 0.39827821E-07_JPRB, 0.39393885E-07_JPRB, 0.39099653E-07_JPRB, 0.38890995E-07_JPRB, &
  & 0.38793260E-07_JPRB, 0.38757413E-07_JPRB, 0.38773695E-07_JPRB, 0.38786030E-07_JPRB, 0.38742137E-07_JPRB, 0.38593601E-07_JPRB, &
  & 0.38317562E-07_JPRB, 0.37933919E-07_JPRB, 0.37505682E-07_JPRB, 0.37132050E-07_JPRB, 0.36918564E-07_JPRB, 0.36912201E-07_JPRB, &
  & 0.37113537E-07_JPRB, 0.37483534E-07_JPRB, 0.37948801E-07_JPRB, 0.38470105E-07_JPRB, 0.39039971E-07_JPRB, 0.39715371E-07_JPRB, &
  & 0.40501700E-07_JPRB, 0.41369670E-07_JPRB, 0.42344052E-07_JPRB, 0.43519773E-07_JPRB, 0.45224311E-07_JPRB, 0.47058066E-07_JPRB, &
  & 0.49260009E-07_JPRB, 0.51403052E-07_JPRB, 0.53500898E-07_JPRB, 0.55453661E-07_JPRB, 0.57201031E-07_JPRB, 0.58692827E-07_JPRB, &
  & 0.59873173E-07_JPRB, 0.60817165E-07_JPRB, 0.61603892E-07_JPRB, 0.62340526E-07_JPRB, 0.63086588E-07_JPRB, 0.63900480E-07_JPRB, &
  & 0.64768741E-07_JPRB, 0.65670363E-07_JPRB, 0.66548111E-07_JPRB, 0.67377727E-07_JPRB, 0.68121246E-07_JPRB, 0.68876012E-07_JPRB, &
  & 0.69600411E-07_JPRB, 0.70423226E-07_JPRB, 0.71297940E-07_JPRB, 0.72038148E-07_JPRB, 0.72698093E-07_JPRB, 0.73276901E-07_JPRB, &
  & 0.73877331E-07_JPRB, 0.74566238E-07_JPRB, 0.75937706E-07_JPRB, 0.79195694E-07_JPRB /)

RGHG7(:,75, 2) = (/ &
  & 0.43742798E-07_JPRB, 0.41749896E-07_JPRB, 0.40988219E-07_JPRB, 0.40527013E-07_JPRB, 0.40151985E-07_JPRB, 0.39786993E-07_JPRB, &
  & 0.39384897E-07_JPRB, 0.38967546E-07_JPRB, 0.38548599E-07_JPRB, 0.38265004E-07_JPRB, 0.38089023E-07_JPRB, 0.38003812E-07_JPRB, &
  & 0.38010249E-07_JPRB, 0.38084799E-07_JPRB, 0.38204160E-07_JPRB, 0.38321101E-07_JPRB, 0.38390404E-07_JPRB, 0.38375145E-07_JPRB, &
  & 0.38259319E-07_JPRB, 0.38067032E-07_JPRB, 0.37853404E-07_JPRB, 0.37700133E-07_JPRB, 0.37693770E-07_JPRB, 0.37875470E-07_JPRB, &
  & 0.38227302E-07_JPRB, 0.38703874E-07_JPRB, 0.39253358E-07_JPRB, 0.39839215E-07_JPRB, 0.40458506E-07_JPRB, 0.41155470E-07_JPRB, &
  & 0.41937703E-07_JPRB, 0.42762188E-07_JPRB, 0.43631864E-07_JPRB, 0.44736684E-07_JPRB, 0.46144123E-07_JPRB, 0.47843770E-07_JPRB, &
  & 0.49677517E-07_JPRB, 0.51540127E-07_JPRB, 0.53392018E-07_JPRB, 0.55116317E-07_JPRB, 0.56665307E-07_JPRB, 0.58007114E-07_JPRB, &
  & 0.59110032E-07_JPRB, 0.60011097E-07_JPRB, 0.60800005E-07_JPRB, 0.61522606E-07_JPRB, 0.62274374E-07_JPRB, 0.63046492E-07_JPRB, &
  & 0.63858820E-07_JPRB, 0.64696628E-07_JPRB, 0.65506740E-07_JPRB, 0.66258650E-07_JPRB, 0.66959970E-07_JPRB, 0.67626800E-07_JPRB, &
  & 0.68301716E-07_JPRB, 0.69041945E-07_JPRB, 0.69823159E-07_JPRB, 0.70491488E-07_JPRB, 0.71079413E-07_JPRB, 0.71596666E-07_JPRB, &
  & 0.72130241E-07_JPRB, 0.72722436E-07_JPRB, 0.73961147E-07_JPRB, 0.77081296E-07_JPRB /)

RGHG7(:,76, 2) = (/ &
  & 0.41796696E-07_JPRB, 0.39844799E-07_JPRB, 0.39155022E-07_JPRB, 0.38781071E-07_JPRB, 0.38504805E-07_JPRB, 0.38238486E-07_JPRB, &
  & 0.37959353E-07_JPRB, 0.37678873E-07_JPRB, 0.37414416E-07_JPRB, 0.37262197E-07_JPRB, 0.37206537E-07_JPRB, 0.37245847E-07_JPRB, &
  & 0.37358475E-07_JPRB, 0.37537390E-07_JPRB, 0.37754745E-07_JPRB, 0.37974612E-07_JPRB, 0.38158522E-07_JPRB, 0.38276696E-07_JPRB, &
  & 0.38322174E-07_JPRB, 0.38318245E-07_JPRB, 0.38309778E-07_JPRB, 0.38361129E-07_JPRB, 0.38535536E-07_JPRB, 0.38858417E-07_JPRB, &
  & 0.39321012E-07_JPRB, 0.39892615E-07_JPRB, 0.40514699E-07_JPRB, 0.41161709E-07_JPRB, 0.41824240E-07_JPRB, 0.42538492E-07_JPRB, &
  & 0.43308550E-07_JPRB, 0.44104194E-07_JPRB, 0.44960043E-07_JPRB, 0.45974733E-07_JPRB, 0.47192486E-07_JPRB, 0.48671165E-07_JPRB, &
  & 0.50251415E-07_JPRB, 0.51806985E-07_JPRB, 0.53409988E-07_JPRB, 0.54926325E-07_JPRB, 0.56281973E-07_JPRB, 0.57481991E-07_JPRB, &
  & 0.58483973E-07_JPRB, 0.59348338E-07_JPRB, 0.60110963E-07_JPRB, 0.60836456E-07_JPRB, 0.61549258E-07_JPRB, 0.62299861E-07_JPRB, &
  & 0.63059574E-07_JPRB, 0.63826135E-07_JPRB, 0.64567665E-07_JPRB, 0.65257979E-07_JPRB, 0.65892259E-07_JPRB, 0.66514907E-07_JPRB, &
  & 0.67118066E-07_JPRB, 0.67775083E-07_JPRB, 0.68470079E-07_JPRB, 0.69046756E-07_JPRB, 0.69568493E-07_JPRB, 0.70010145E-07_JPRB, &
  & 0.70487829E-07_JPRB, 0.70971829E-07_JPRB, 0.72061354E-07_JPRB, 0.74968753E-07_JPRB /)

RGHG7(:,77, 2) = (/ &
  & 0.39855426E-07_JPRB, 0.38001048E-07_JPRB, 0.37409240E-07_JPRB, 0.37132651E-07_JPRB, 0.36959523E-07_JPRB, 0.36809350E-07_JPRB, &
  & 0.36659671E-07_JPRB, 0.36516241E-07_JPRB, 0.36397935E-07_JPRB, 0.36381451E-07_JPRB, 0.36462787E-07_JPRB, 0.36601488E-07_JPRB, &
  & 0.36826165E-07_JPRB, 0.37096022E-07_JPRB, 0.37405144E-07_JPRB, 0.37721001E-07_JPRB, 0.38013923E-07_JPRB, 0.38266609E-07_JPRB, &
  & 0.38469736E-07_JPRB, 0.38644835E-07_JPRB, 0.38831732E-07_JPRB, 0.39073363E-07_JPRB, 0.39419941E-07_JPRB, 0.39908858E-07_JPRB, &
  & 0.40491905E-07_JPRB, 0.41146794E-07_JPRB, 0.41837122E-07_JPRB, 0.42536978E-07_JPRB, 0.43242423E-07_JPRB, 0.43975213E-07_JPRB, &
  & 0.44738933E-07_JPRB, 0.45515570E-07_JPRB, 0.46310102E-07_JPRB, 0.47198366E-07_JPRB, 0.48312355E-07_JPRB, 0.49500684E-07_JPRB, &
  & 0.50898265E-07_JPRB, 0.52193908E-07_JPRB, 0.53523557E-07_JPRB, 0.54840154E-07_JPRB, 0.56030451E-07_JPRB, 0.57071777E-07_JPRB, &
  & 0.57995063E-07_JPRB, 0.58801923E-07_JPRB, 0.59539836E-07_JPRB, 0.60233951E-07_JPRB, 0.60940273E-07_JPRB, 0.61639959E-07_JPRB, &
  & 0.62347496E-07_JPRB, 0.63051367E-07_JPRB, 0.63725231E-07_JPRB, 0.64359689E-07_JPRB, 0.64940743E-07_JPRB, 0.65507699E-07_JPRB, &
  & 0.66048912E-07_JPRB, 0.66630854E-07_JPRB, 0.67220377E-07_JPRB, 0.67716229E-07_JPRB, 0.68164034E-07_JPRB, 0.68538888E-07_JPRB, &
  & 0.68954314E-07_JPRB, 0.69335961E-07_JPRB, 0.70255851E-07_JPRB, 0.72881164E-07_JPRB /)

RGHG7(:,78, 2) = (/ &
  & 0.37933578E-07_JPRB, 0.36291762E-07_JPRB, 0.35830112E-07_JPRB, 0.35671796E-07_JPRB, 0.35607084E-07_JPRB, 0.35562294E-07_JPRB, &
  & 0.35541209E-07_JPRB, 0.35536836E-07_JPRB, 0.35572121E-07_JPRB, 0.35688139E-07_JPRB, 0.35871508E-07_JPRB, 0.36124614E-07_JPRB, &
  & 0.36421909E-07_JPRB, 0.36768892E-07_JPRB, 0.37147441E-07_JPRB, 0.37542744E-07_JPRB, 0.37933766E-07_JPRB, 0.38304968E-07_JPRB, &
  & 0.38652729E-07_JPRB, 0.38994745E-07_JPRB, 0.39350503E-07_JPRB, 0.39756404E-07_JPRB, 0.40234006E-07_JPRB, 0.40805695E-07_JPRB, &
  & 0.41428734E-07_JPRB, 0.42112681E-07_JPRB, 0.42821874E-07_JPRB, 0.43547697E-07_JPRB, 0.44282732E-07_JPRB, 0.45042459E-07_JPRB, &
  & 0.45826720E-07_JPRB, 0.46622834E-07_JPRB, 0.47435041E-07_JPRB, 0.48328047E-07_JPRB, 0.49297885E-07_JPRB, 0.50355816E-07_JPRB, &
  & 0.51469627E-07_JPRB, 0.52641322E-07_JPRB, 0.53706781E-07_JPRB, 0.54825822E-07_JPRB, 0.55865257E-07_JPRB, 0.56785890E-07_JPRB, &
  & 0.57615559E-07_JPRB, 0.58381723E-07_JPRB, 0.59087753E-07_JPRB, 0.59766045E-07_JPRB, 0.60438950E-07_JPRB, 0.61113617E-07_JPRB, &
  & 0.61769612E-07_JPRB, 0.62416312E-07_JPRB, 0.63032672E-07_JPRB, 0.63609718E-07_JPRB, 0.64144437E-07_JPRB, 0.64659915E-07_JPRB, &
  & 0.65147333E-07_JPRB, 0.65646297E-07_JPRB, 0.66146946E-07_JPRB, 0.66559409E-07_JPRB, 0.66947827E-07_JPRB, 0.67246852E-07_JPRB, &
  & 0.67613399E-07_JPRB, 0.67893865E-07_JPRB, 0.68591611E-07_JPRB, 0.70842439E-07_JPRB /)

RGHG7(:,79, 2) = (/ &
  & 0.36216544E-07_JPRB, 0.35053883E-07_JPRB, 0.34809457E-07_JPRB, 0.34779038E-07_JPRB, 0.34807751E-07_JPRB, 0.34848473E-07_JPRB, &
  & 0.34925883E-07_JPRB, 0.35017106E-07_JPRB, 0.35144097E-07_JPRB, 0.35337692E-07_JPRB, 0.35586201E-07_JPRB, 0.35873541E-07_JPRB, &
  & 0.36221390E-07_JPRB, 0.36600103E-07_JPRB, 0.37013333E-07_JPRB, 0.37447936E-07_JPRB, 0.37892395E-07_JPRB, 0.38334807E-07_JPRB, &
  & 0.38772221E-07_JPRB, 0.39206455E-07_JPRB, 0.39655013E-07_JPRB, 0.40131283E-07_JPRB, 0.40660886E-07_JPRB, 0.41268382E-07_JPRB, &
  & 0.41917399E-07_JPRB, 0.42608804E-07_JPRB, 0.43329287E-07_JPRB, 0.44066550E-07_JPRB, 0.44820673E-07_JPRB, 0.45598242E-07_JPRB, &
  & 0.46398277E-07_JPRB, 0.47207045E-07_JPRB, 0.48021885E-07_JPRB, 0.48896709E-07_JPRB, 0.49813753E-07_JPRB, 0.50868167E-07_JPRB, &
  & 0.51831879E-07_JPRB, 0.52909996E-07_JPRB, 0.53891497E-07_JPRB, 0.54825222E-07_JPRB, 0.55780934E-07_JPRB, 0.56621143E-07_JPRB, &
  & 0.57404542E-07_JPRB, 0.58142316E-07_JPRB, 0.58832562E-07_JPRB, 0.59505744E-07_JPRB, 0.60183325E-07_JPRB, 0.60831653E-07_JPRB, &
  & 0.61470779E-07_JPRB, 0.62086045E-07_JPRB, 0.62671496E-07_JPRB, 0.63220853E-07_JPRB, 0.63723988E-07_JPRB, 0.64207335E-07_JPRB, &
  & 0.64653271E-07_JPRB, 0.65094994E-07_JPRB, 0.65527836E-07_JPRB, 0.65875817E-07_JPRB, 0.66223990E-07_JPRB, 0.66453900E-07_JPRB, &
  & 0.66783642E-07_JPRB, 0.66965526E-07_JPRB, 0.67397337E-07_JPRB, 0.69039565E-07_JPRB /)

RGHG7(:,80, 2) = (/ &
  & 0.35171421E-07_JPRB, 0.34542296E-07_JPRB, 0.34422378E-07_JPRB, 0.34467686E-07_JPRB, 0.34524188E-07_JPRB, 0.34582794E-07_JPRB, &
  & 0.34689776E-07_JPRB, 0.34795764E-07_JPRB, 0.34970856E-07_JPRB, 0.35167506E-07_JPRB, 0.35450253E-07_JPRB, 0.35767169E-07_JPRB, &
  & 0.36125659E-07_JPRB, 0.36525680E-07_JPRB, 0.36953821E-07_JPRB, 0.37404970E-07_JPRB, 0.37868254E-07_JPRB, 0.38336449E-07_JPRB, &
  & 0.38804064E-07_JPRB, 0.39277992E-07_JPRB, 0.39763478E-07_JPRB, 0.40292100E-07_JPRB, 0.40865675E-07_JPRB, 0.41477485E-07_JPRB, &
  & 0.42133419E-07_JPRB, 0.42831360E-07_JPRB, 0.43553722E-07_JPRB, 0.44301178E-07_JPRB, 0.45064361E-07_JPRB, 0.45853170E-07_JPRB, &
  & 0.46661480E-07_JPRB, 0.47474909E-07_JPRB, 0.48305296E-07_JPRB, 0.49167593E-07_JPRB, 0.50097459E-07_JPRB, 0.51038693E-07_JPRB, &
  & 0.52036359E-07_JPRB, 0.52951208E-07_JPRB, 0.53971860E-07_JPRB, 0.54826469E-07_JPRB, 0.55715763E-07_JPRB, 0.56559045E-07_JPRB, &
  & 0.57309652E-07_JPRB, 0.58041810E-07_JPRB, 0.58729146E-07_JPRB, 0.59401660E-07_JPRB, 0.60065666E-07_JPRB, 0.60712871E-07_JPRB, &
  & 0.61335449E-07_JPRB, 0.61942792E-07_JPRB, 0.62511987E-07_JPRB, 0.63050578E-07_JPRB, 0.63547240E-07_JPRB, 0.64019034E-07_JPRB, &
  & 0.64460835E-07_JPRB, 0.64881959E-07_JPRB, 0.65306949E-07_JPRB, 0.65621776E-07_JPRB, 0.65976558E-07_JPRB, 0.66168411E-07_JPRB, &
  & 0.66483977E-07_JPRB, 0.66639970E-07_JPRB, 0.66866690E-07_JPRB, 0.67950317E-07_JPRB /)

RGHG7(:,81, 2) = (/ &
  & 0.34530768E-07_JPRB, 0.34242213E-07_JPRB, 0.34202788E-07_JPRB, 0.34293834E-07_JPRB, 0.34352503E-07_JPRB, 0.34431352E-07_JPRB, &
  & 0.34558187E-07_JPRB, 0.34701870E-07_JPRB, 0.34873242E-07_JPRB, 0.35125630E-07_JPRB, 0.35390212E-07_JPRB, 0.35718756E-07_JPRB, &
  & 0.36088402E-07_JPRB, 0.36492956E-07_JPRB, 0.36928068E-07_JPRB, 0.37386183E-07_JPRB, 0.37861792E-07_JPRB, 0.38345785E-07_JPRB, &
  & 0.38834973E-07_JPRB, 0.39322821E-07_JPRB, 0.39837300E-07_JPRB, 0.40370139E-07_JPRB, 0.40940815E-07_JPRB, 0.41564249E-07_JPRB, &
  & 0.42227931E-07_JPRB, 0.42924412E-07_JPRB, 0.43656005E-07_JPRB, 0.44405382E-07_JPRB, 0.45177721E-07_JPRB, 0.45972364E-07_JPRB, &
  & 0.46784852E-07_JPRB, 0.47605408E-07_JPRB, 0.48432781E-07_JPRB, 0.49293295E-07_JPRB, 0.50211192E-07_JPRB, 0.51137022E-07_JPRB, &
  & 0.52137263E-07_JPRB, 0.53020155E-07_JPRB, 0.53986650E-07_JPRB, 0.54880413E-07_JPRB, 0.55686705E-07_JPRB, 0.56525391E-07_JPRB, &
  & 0.57273112E-07_JPRB, 0.57993550E-07_JPRB, 0.58677550E-07_JPRB, 0.59351812E-07_JPRB, 0.60020291E-07_JPRB, 0.60657783E-07_JPRB, &
  & 0.61284091E-07_JPRB, 0.61879412E-07_JPRB, 0.62447711E-07_JPRB, 0.62976454E-07_JPRB, 0.63471113E-07_JPRB, 0.63928006E-07_JPRB, &
  & 0.64368926E-07_JPRB, 0.64762489E-07_JPRB, 0.65191024E-07_JPRB, 0.65474062E-07_JPRB, 0.65839743E-07_JPRB, 0.66012113E-07_JPRB, &
  & 0.66305418E-07_JPRB, 0.66493833E-07_JPRB, 0.66561959E-07_JPRB, 0.67261148E-07_JPRB /)

RGHG7(:,82, 2) = (/ &
  & 0.34161456E-07_JPRB, 0.34116592E-07_JPRB, 0.34146133E-07_JPRB, 0.34272947E-07_JPRB, 0.34300186E-07_JPRB, 0.34394876E-07_JPRB, &
  & 0.34526103E-07_JPRB, 0.34648703E-07_JPRB, 0.34858452E-07_JPRB, 0.35053016E-07_JPRB, 0.35374701E-07_JPRB, 0.35689201E-07_JPRB, &
  & 0.36065813E-07_JPRB, 0.36476159E-07_JPRB, 0.36915122E-07_JPRB, 0.37378133E-07_JPRB, 0.37854534E-07_JPRB, 0.38341852E-07_JPRB, &
  & 0.38831022E-07_JPRB, 0.39328810E-07_JPRB, 0.39848175E-07_JPRB, 0.40400909E-07_JPRB, 0.40981480E-07_JPRB, 0.41606022E-07_JPRB, &
  & 0.42271402E-07_JPRB, 0.42970935E-07_JPRB, 0.43702258E-07_JPRB, 0.44459174E-07_JPRB, 0.45234152E-07_JPRB, 0.46034039E-07_JPRB, &
  & 0.46850687E-07_JPRB, 0.47675108E-07_JPRB, 0.48505822E-07_JPRB, 0.49377284E-07_JPRB, 0.50271570E-07_JPRB, 0.51218812E-07_JPRB, &
  & 0.52131551E-07_JPRB, 0.53104344E-07_JPRB, 0.53939214E-07_JPRB, 0.54912825E-07_JPRB, 0.55687192E-07_JPRB, 0.56499552E-07_JPRB, &
  & 0.57267460E-07_JPRB, 0.57976706E-07_JPRB, 0.58672740E-07_JPRB, 0.59344732E-07_JPRB, 0.60000396E-07_JPRB, 0.60641327E-07_JPRB, &
  & 0.61259477E-07_JPRB, 0.61854834E-07_JPRB, 0.62420746E-07_JPRB, 0.62942725E-07_JPRB, 0.63444631E-07_JPRB, 0.63890738E-07_JPRB, &
  & 0.64347823E-07_JPRB, 0.64723508E-07_JPRB, 0.65167391E-07_JPRB, 0.65433468E-07_JPRB, 0.65798957E-07_JPRB, 0.65985617E-07_JPRB, &
  & 0.66223677E-07_JPRB, 0.66494181E-07_JPRB, 0.66433969E-07_JPRB, 0.66864182E-07_JPRB /)

RGHG7(:,83, 2) = (/ &
  & 0.34196699E-07_JPRB, 0.34010753E-07_JPRB, 0.34130345E-07_JPRB, 0.34231750E-07_JPRB, 0.34216370E-07_JPRB, 0.34359321E-07_JPRB, &
  & 0.34468382E-07_JPRB, 0.34637175E-07_JPRB, 0.34801204E-07_JPRB, 0.35088600E-07_JPRB, 0.35328799E-07_JPRB, 0.35694068E-07_JPRB, &
  & 0.36050636E-07_JPRB, 0.36466698E-07_JPRB, 0.36907675E-07_JPRB, 0.37370505E-07_JPRB, 0.37853258E-07_JPRB, 0.38344908E-07_JPRB, &
  & 0.38842721E-07_JPRB, 0.39339717E-07_JPRB, 0.39883322E-07_JPRB, 0.40403037E-07_JPRB, 0.40999812E-07_JPRB, 0.41618065E-07_JPRB, &
  & 0.42290857E-07_JPRB, 0.42991022E-07_JPRB, 0.43729035E-07_JPRB, 0.44487035E-07_JPRB, 0.45268070E-07_JPRB, 0.46071253E-07_JPRB, &
  & 0.46893259E-07_JPRB, 0.47722651E-07_JPRB, 0.48560878E-07_JPRB, 0.49431598E-07_JPRB, 0.50317595E-07_JPRB, 0.51256073E-07_JPRB, &
  & 0.52159514E-07_JPRB, 0.53128879E-07_JPRB, 0.53975111E-07_JPRB, 0.54878150E-07_JPRB, 0.55732389E-07_JPRB, 0.56477781E-07_JPRB, &
  & 0.57270359E-07_JPRB, 0.57974031E-07_JPRB, 0.58664146E-07_JPRB, 0.59344774E-07_JPRB, 0.60003288E-07_JPRB, 0.60631926E-07_JPRB, &
  & 0.61254305E-07_JPRB, 0.61838996E-07_JPRB, 0.62408439E-07_JPRB, 0.62921295E-07_JPRB, 0.63427670E-07_JPRB, 0.63860391E-07_JPRB, &
  & 0.64323260E-07_JPRB, 0.64686525E-07_JPRB, 0.65127551E-07_JPRB, 0.65402332E-07_JPRB, 0.65735321E-07_JPRB, 0.65979322E-07_JPRB, &
  & 0.66124315E-07_JPRB, 0.66514275E-07_JPRB, 0.66362539E-07_JPRB, 0.66889214E-07_JPRB /)

RGHG7(:,84, 2) = (/ &
  & 0.34254185E-07_JPRB, 0.33891741E-07_JPRB, 0.34190109E-07_JPRB, 0.34193455E-07_JPRB, 0.34190432E-07_JPRB, 0.34383959E-07_JPRB, &
  & 0.34453024E-07_JPRB, 0.34626467E-07_JPRB, 0.34826403E-07_JPRB, 0.35034763E-07_JPRB, 0.35352048E-07_JPRB, 0.35653215E-07_JPRB, &
  & 0.36046906E-07_JPRB, 0.36451510E-07_JPRB, 0.36899380E-07_JPRB, 0.37367702E-07_JPRB, 0.37848086E-07_JPRB, 0.38339788E-07_JPRB, &
  & 0.38830439E-07_JPRB, 0.39342083E-07_JPRB, 0.39863178E-07_JPRB, 0.40409169E-07_JPRB, 0.41005961E-07_JPRB, 0.41620837E-07_JPRB, &
  & 0.42300766E-07_JPRB, 0.43003336E-07_JPRB, 0.43739501E-07_JPRB, 0.44503231E-07_JPRB, 0.45287550E-07_JPRB, 0.46094900E-07_JPRB, &
  & 0.46921368E-07_JPRB, 0.47758423E-07_JPRB, 0.48607813E-07_JPRB, 0.49472110E-07_JPRB, 0.50371238E-07_JPRB, 0.51270376E-07_JPRB, &
  & 0.52214649E-07_JPRB, 0.53100472E-07_JPRB, 0.54050115E-07_JPRB, 0.54841525E-07_JPRB, 0.55751478E-07_JPRB, 0.56496582E-07_JPRB, &
  & 0.57267329E-07_JPRB, 0.58001199E-07_JPRB, 0.58684275E-07_JPRB, 0.59356317E-07_JPRB, 0.60013491E-07_JPRB, 0.60639216E-07_JPRB, &
  & 0.61258156E-07_JPRB, 0.61841675E-07_JPRB, 0.62409740E-07_JPRB, 0.62919661E-07_JPRB, 0.63425531E-07_JPRB, 0.63860391E-07_JPRB, &
  & 0.64317021E-07_JPRB, 0.64695833E-07_JPRB, 0.65105461E-07_JPRB, 0.65426654E-07_JPRB, 0.65684333E-07_JPRB, 0.66027347E-07_JPRB, &
  & 0.66046603E-07_JPRB, 0.66549774E-07_JPRB, 0.66307642E-07_JPRB, 0.66888383E-07_JPRB /)

RGHG7(:,85, 2) = (/ &
  & 0.34287424E-07_JPRB, 0.33772210E-07_JPRB, 0.34286916E-07_JPRB, 0.34079427E-07_JPRB, 0.34201754E-07_JPRB, 0.34372224E-07_JPRB, &
  & 0.34408792E-07_JPRB, 0.34681346E-07_JPRB, 0.34794844E-07_JPRB, 0.35102424E-07_JPRB, 0.35322849E-07_JPRB, 0.35665806E-07_JPRB, &
  & 0.36016246E-07_JPRB, 0.36433200E-07_JPRB, 0.36882309E-07_JPRB, 0.37354969E-07_JPRB, 0.37841431E-07_JPRB, 0.38334470E-07_JPRB, &
  & 0.38829779E-07_JPRB, 0.39340009E-07_JPRB, 0.39872567E-07_JPRB, 0.40399492E-07_JPRB, 0.40997925E-07_JPRB, 0.41619341E-07_JPRB, &
  & 0.42292729E-07_JPRB, 0.43006953E-07_JPRB, 0.43744318E-07_JPRB, 0.44515570E-07_JPRB, 0.45303327E-07_JPRB, 0.46115492E-07_JPRB, &
  & 0.46948184E-07_JPRB, 0.47792593E-07_JPRB, 0.48646562E-07_JPRB, 0.49517347E-07_JPRB, 0.50401379E-07_JPRB, 0.51312494E-07_JPRB, &
  & 0.52233229E-07_JPRB, 0.53141889E-07_JPRB, 0.54066053E-07_JPRB, 0.54899260E-07_JPRB, 0.55743442E-07_JPRB, 0.56541090E-07_JPRB, &
  & 0.57281699E-07_JPRB, 0.58017982E-07_JPRB, 0.58715464E-07_JPRB, 0.59373711E-07_JPRB, 0.60029436E-07_JPRB, 0.60649981E-07_JPRB, &
  & 0.61263457E-07_JPRB, 0.61843956E-07_JPRB, 0.62405213E-07_JPRB, 0.62920918E-07_JPRB, 0.63412806E-07_JPRB, 0.63863801E-07_JPRB, &
  & 0.64289644E-07_JPRB, 0.64709852E-07_JPRB, 0.65056270E-07_JPRB, 0.65457762E-07_JPRB, 0.65612504E-07_JPRB, 0.66070882E-07_JPRB, &
  & 0.65979442E-07_JPRB, 0.66567814E-07_JPRB, 0.66279142E-07_JPRB, 0.66863933E-07_JPRB /)

RGHG7(:,86, 2) = (/ &
  & 0.34339330E-07_JPRB, 0.33664492E-07_JPRB, 0.34400664E-07_JPRB, 0.33941351E-07_JPRB, 0.34316638E-07_JPRB, 0.34311281E-07_JPRB, &
  & 0.34491148E-07_JPRB, 0.34684927E-07_JPRB, 0.34868812E-07_JPRB, 0.35095702E-07_JPRB, 0.35356980E-07_JPRB, 0.35634521E-07_JPRB, &
  & 0.36000873E-07_JPRB, 0.36395335E-07_JPRB, 0.36853493E-07_JPRB, 0.37331745E-07_JPRB, 0.37824819E-07_JPRB, 0.38312301E-07_JPRB, &
  & 0.38814616E-07_JPRB, 0.39329894E-07_JPRB, 0.39831239E-07_JPRB, 0.40400774E-07_JPRB, 0.40979039E-07_JPRB, 0.41614008E-07_JPRB, &
  & 0.42291536E-07_JPRB, 0.43002604E-07_JPRB, 0.43747018E-07_JPRB, 0.44519318E-07_JPRB, 0.45311321E-07_JPRB, 0.46126399E-07_JPRB, &
  & 0.46964164E-07_JPRB, 0.47814133E-07_JPRB, 0.48672327E-07_JPRB, 0.49546788E-07_JPRB, 0.50435744E-07_JPRB, 0.51344454E-07_JPRB, &
  & 0.52281148E-07_JPRB, 0.53191886E-07_JPRB, 0.54095185E-07_JPRB, 0.54982038E-07_JPRB, 0.55772770E-07_JPRB, 0.56592498E-07_JPRB, &
  & 0.57335054E-07_JPRB, 0.58052436E-07_JPRB, 0.58750445E-07_JPRB, 0.59406744E-07_JPRB, 0.60049928E-07_JPRB, 0.60672065E-07_JPRB, &
  & 0.61279188E-07_JPRB, 0.61865400E-07_JPRB, 0.62413896E-07_JPRB, 0.62939755E-07_JPRB, 0.63411932E-07_JPRB, 0.63887924E-07_JPRB, &
  & 0.64275817E-07_JPRB, 0.64745961E-07_JPRB, 0.65026441E-07_JPRB, 0.65500195E-07_JPRB, 0.65574653E-07_JPRB, 0.66101784E-07_JPRB, &
  & 0.65956741E-07_JPRB, 0.66568752E-07_JPRB, 0.66268377E-07_JPRB, 0.66859236E-07_JPRB /)

RGHG7(:,87, 2) = (/ &
  & 0.34389071E-07_JPRB, 0.33600163E-07_JPRB, 0.34466165E-07_JPRB, 0.33832897E-07_JPRB, 0.34425522E-07_JPRB, 0.34219507E-07_JPRB, &
  & 0.34586296E-07_JPRB, 0.34680752E-07_JPRB, 0.34933553E-07_JPRB, 0.35110496E-07_JPRB, 0.35383934E-07_JPRB, 0.35630354E-07_JPRB, &
  & 0.35983810E-07_JPRB, 0.36361708E-07_JPRB, 0.36819678E-07_JPRB, 0.37301483E-07_JPRB, 0.37797900E-07_JPRB, 0.38298118E-07_JPRB, &
  & 0.38802945E-07_JPRB, 0.39302890E-07_JPRB, 0.39841229E-07_JPRB, 0.40379362E-07_JPRB, 0.40965570E-07_JPRB, 0.41597875E-07_JPRB, &
  & 0.42277513E-07_JPRB, 0.42998018E-07_JPRB, 0.43745249E-07_JPRB, 0.44521634E-07_JPRB, 0.45316600E-07_JPRB, 0.46135579E-07_JPRB, &
  & 0.46973494E-07_JPRB, 0.47822489E-07_JPRB, 0.48688541E-07_JPRB, 0.49559063E-07_JPRB, 0.50458929E-07_JPRB, 0.51379637E-07_JPRB, &
  & 0.52310053E-07_JPRB, 0.53265676E-07_JPRB, 0.54157244E-07_JPRB, 0.55027822E-07_JPRB, 0.55867350E-07_JPRB, 0.56632643E-07_JPRB, &
  & 0.57395450E-07_JPRB, 0.58100156E-07_JPRB, 0.58781183E-07_JPRB, 0.59434598E-07_JPRB, 0.60067784E-07_JPRB, 0.60686290E-07_JPRB, &
  & 0.61283437E-07_JPRB, 0.61871908E-07_JPRB, 0.62413584E-07_JPRB, 0.62946100E-07_JPRB, 0.63407057E-07_JPRB, 0.63895534E-07_JPRB, &
  & 0.64264562E-07_JPRB, 0.64753728E-07_JPRB, 0.65014930E-07_JPRB, 0.65498760E-07_JPRB, 0.65574007E-07_JPRB, 0.66083601E-07_JPRB, &
  & 0.65972493E-07_JPRB, 0.66541205E-07_JPRB, 0.66283647E-07_JPRB, 0.66845871E-07_JPRB /)

RGHG7(:,88, 2) = (/ &
  & 0.34404071E-07_JPRB, 0.33587277E-07_JPRB, 0.34475406E-07_JPRB, 0.33801744E-07_JPRB, 0.34481150E-07_JPRB, 0.34154994E-07_JPRB, &
  & 0.34693208E-07_JPRB, 0.34621191E-07_JPRB, 0.34985607E-07_JPRB, 0.35091428E-07_JPRB, 0.35389743E-07_JPRB, 0.35621245E-07_JPRB, &
  & 0.35965591E-07_JPRB, 0.36345085E-07_JPRB, 0.36800614E-07_JPRB, 0.37274223E-07_JPRB, 0.37784687E-07_JPRB, 0.38272173E-07_JPRB, &
  & 0.38784357E-07_JPRB, 0.39289048E-07_JPRB, 0.39811852E-07_JPRB, 0.40359840E-07_JPRB, 0.40952418E-07_JPRB, 0.41586134E-07_JPRB, &
  & 0.42267772E-07_JPRB, 0.42986493E-07_JPRB, 0.43741153E-07_JPRB, 0.44515502E-07_JPRB, 0.45316149E-07_JPRB, 0.46138162E-07_JPRB, &
  & 0.46981445E-07_JPRB, 0.47840874E-07_JPRB, 0.48701281E-07_JPRB, 0.49594775E-07_JPRB, 0.50498265E-07_JPRB, 0.51444914E-07_JPRB, &
  & 0.52396079E-07_JPRB, 0.53327984E-07_JPRB, 0.54252720E-07_JPRB, 0.55112796E-07_JPRB, 0.55930609E-07_JPRB, 0.56718996E-07_JPRB, &
  & 0.57448272E-07_JPRB, 0.58151688E-07_JPRB, 0.58818966E-07_JPRB, 0.59463279E-07_JPRB, 0.60091651E-07_JPRB, 0.60710114E-07_JPRB, &
  & 0.61305393E-07_JPRB, 0.61890312E-07_JPRB, 0.62429500E-07_JPRB, 0.62958378E-07_JPRB, 0.63419598E-07_JPRB, 0.63903713E-07_JPRB, &
  & 0.64278041E-07_JPRB, 0.64753841E-07_JPRB, 0.65034776E-07_JPRB, 0.65484578E-07_JPRB, 0.65601846E-07_JPRB, 0.66056089E-07_JPRB, &
  & 0.66004510E-07_JPRB, 0.66506828E-07_JPRB, 0.66316510E-07_JPRB, 0.66814017E-07_JPRB /)

RGHG7(:,89, 2) = (/ &
  & 0.34402635E-07_JPRB, 0.33598269E-07_JPRB, 0.34445524E-07_JPRB, 0.33828019E-07_JPRB, 0.34427572E-07_JPRB, 0.34179791E-07_JPRB, &
  & 0.34604707E-07_JPRB, 0.34623170E-07_JPRB, 0.34934935E-07_JPRB, 0.35064723E-07_JPRB, 0.35356962E-07_JPRB, 0.35607545E-07_JPRB, &
  & 0.35959523E-07_JPRB, 0.36339163E-07_JPRB, 0.36796834E-07_JPRB, 0.37274127E-07_JPRB, 0.37774115E-07_JPRB, 0.38263256E-07_JPRB, &
  & 0.38771216E-07_JPRB, 0.39264538E-07_JPRB, 0.39796411E-07_JPRB, 0.40337515E-07_JPRB, 0.40925805E-07_JPRB, 0.41559655E-07_JPRB, &
  & 0.42245382E-07_JPRB, 0.42970285E-07_JPRB, 0.43730939E-07_JPRB, 0.44511967E-07_JPRB, 0.45321293E-07_JPRB, 0.46156135E-07_JPRB, &
  & 0.47008090E-07_JPRB, 0.47864791E-07_JPRB, 0.48746102E-07_JPRB, 0.49645703E-07_JPRB, 0.50591009E-07_JPRB, 0.51547488E-07_JPRB, &
  & 0.52511279E-07_JPRB, 0.53457555E-07_JPRB, 0.54358111E-07_JPRB, 0.55221605E-07_JPRB, 0.56034089E-07_JPRB, 0.56798736E-07_JPRB, &
  & 0.57522417E-07_JPRB, 0.58206798E-07_JPRB, 0.58861840E-07_JPRB, 0.59495484E-07_JPRB, 0.60115532E-07_JPRB, 0.60726855E-07_JPRB, &
  & 0.61322687E-07_JPRB, 0.61904124E-07_JPRB, 0.62446695E-07_JPRB, 0.62969320E-07_JPRB, 0.63437078E-07_JPRB, 0.63908040E-07_JPRB, &
  & 0.64298952E-07_JPRB, 0.64747944E-07_JPRB, 0.65061776E-07_JPRB, 0.65466025E-07_JPRB, 0.65633948E-07_JPRB, 0.66028640E-07_JPRB, &
  & 0.66040059E-07_JPRB, 0.66475003E-07_JPRB, 0.66353671E-07_JPRB, 0.66782405E-07_JPRB /)

RGHG7(:,90, 2) = (/ &
  & 0.34379578E-07_JPRB, 0.33662996E-07_JPRB, 0.34356379E-07_JPRB, 0.33912922E-07_JPRB, 0.34318067E-07_JPRB, 0.34214274E-07_JPRB, &
  & 0.34493407E-07_JPRB, 0.34591235E-07_JPRB, 0.34810473E-07_JPRB, 0.35022158E-07_JPRB, 0.35278887E-07_JPRB, 0.35587433E-07_JPRB, &
  & 0.35940364E-07_JPRB, 0.36352485E-07_JPRB, 0.36804508E-07_JPRB, 0.37277733E-07_JPRB, 0.37767943E-07_JPRB, 0.38249237E-07_JPRB, &
  & 0.38744407E-07_JPRB, 0.39240970E-07_JPRB, 0.39759286E-07_JPRB, 0.40301011E-07_JPRB, 0.40886398E-07_JPRB, 0.41522952E-07_JPRB, &
  & 0.42210438E-07_JPRB, 0.42941640E-07_JPRB, 0.43709797E-07_JPRB, 0.44502507E-07_JPRB, 0.45320405E-07_JPRB, 0.46172943E-07_JPRB, &
  & 0.47035385E-07_JPRB, 0.47917826E-07_JPRB, 0.48827371E-07_JPRB, 0.49761852E-07_JPRB, 0.50734954E-07_JPRB, 0.51729629E-07_JPRB, &
  & 0.52700276E-07_JPRB, 0.53636676E-07_JPRB, 0.54530719E-07_JPRB, 0.55369764E-07_JPRB, 0.56164748E-07_JPRB, 0.56915464E-07_JPRB, &
  & 0.57617736E-07_JPRB, 0.58283486E-07_JPRB, 0.58924911E-07_JPRB, 0.59549368E-07_JPRB, 0.60165227E-07_JPRB, 0.60770432E-07_JPRB, &
  & 0.61363274E-07_JPRB, 0.61938678E-07_JPRB, 0.62481220E-07_JPRB, 0.62996556E-07_JPRB, 0.63470118E-07_JPRB, 0.63927359E-07_JPRB, &
  & 0.64333065E-07_JPRB, 0.64758360E-07_JPRB, 0.65099229E-07_JPRB, 0.65460263E-07_JPRB, 0.65675529E-07_JPRB, 0.66006223E-07_JPRB, &
  & 0.66087821E-07_JPRB, 0.66439853E-07_JPRB, 0.66408404E-07_JPRB, 0.66745791E-07_JPRB /)

RGHG7(:,91, 2) = (/ &
  & 0.34224477E-07_JPRB, 0.33858687E-07_JPRB, 0.34171268E-07_JPRB, 0.34039441E-07_JPRB, 0.34194965E-07_JPRB, 0.34244042E-07_JPRB, &
  & 0.34367520E-07_JPRB, 0.34500033E-07_JPRB, 0.34678372E-07_JPRB, 0.34888398E-07_JPRB, 0.35196905E-07_JPRB, 0.35548123E-07_JPRB, &
  & 0.35938097E-07_JPRB, 0.36361826E-07_JPRB, 0.36810270E-07_JPRB, 0.37276806E-07_JPRB, 0.37748212E-07_JPRB, 0.38224901E-07_JPRB, &
  & 0.38705309E-07_JPRB, 0.39194607E-07_JPRB, 0.39702496E-07_JPRB, 0.40241321E-07_JPRB, 0.40822716E-07_JPRB, 0.41461828E-07_JPRB, &
  & 0.42156763E-07_JPRB, 0.42901068E-07_JPRB, 0.43685155E-07_JPRB, 0.44496176E-07_JPRB, 0.45332836E-07_JPRB, 0.46221569E-07_JPRB, &
  & 0.47106251E-07_JPRB, 0.48013217E-07_JPRB, 0.48970232E-07_JPRB, 0.49942781E-07_JPRB, 0.50974524E-07_JPRB, 0.51995091E-07_JPRB, &
  & 0.52977828E-07_JPRB, 0.53913968E-07_JPRB, 0.54797198E-07_JPRB, 0.55618170E-07_JPRB, 0.56382589E-07_JPRB, 0.57098045E-07_JPRB, &
  & 0.57763870E-07_JPRB, 0.58404829E-07_JPRB, 0.59022838E-07_JPRB, 0.59629080E-07_JPRB, 0.60234193E-07_JPRB, 0.60832754E-07_JPRB, &
  & 0.61422888E-07_JPRB, 0.61994513E-07_JPRB, 0.62535257E-07_JPRB, 0.63044965E-07_JPRB, 0.63519579E-07_JPRB, 0.63967910E-07_JPRB, &
  & 0.64378732E-07_JPRB, 0.64792680E-07_JPRB, 0.65146189E-07_JPRB, 0.65472754E-07_JPRB, 0.65726347E-07_JPRB, 0.65993966E-07_JPRB, &
  & 0.66152055E-07_JPRB, 0.66401199E-07_JPRB, 0.66499695E-07_JPRB, 0.66679718E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG7(:, 1, 3) = (/ &
  & 0.58291503E-05_JPRB, 0.66943961E-07_JPRB, 0.66229489E-07_JPRB, 0.66365025E-07_JPRB, 0.66659162E-07_JPRB, 0.67017332E-07_JPRB, &
  & 0.67224306E-07_JPRB, 0.67384839E-07_JPRB, 0.67550090E-07_JPRB, 0.67819848E-07_JPRB, 0.68067258E-07_JPRB, 0.68401079E-07_JPRB, &
  & 0.68688124E-07_JPRB, 0.69008777E-07_JPRB, 0.69259627E-07_JPRB, 0.69566624E-07_JPRB, 0.69739222E-07_JPRB, 0.69939809E-07_JPRB, &
  & 0.70071131E-07_JPRB, 0.70158094E-07_JPRB, 0.70124827E-07_JPRB, 0.69971371E-07_JPRB, 0.69706452E-07_JPRB, 0.69311426E-07_JPRB, &
  & 0.68851314E-07_JPRB, 0.68330884E-07_JPRB, 0.67863361E-07_JPRB, 0.67473792E-07_JPRB, 0.67219879E-07_JPRB, 0.67116240E-07_JPRB, &
  & 0.67192936E-07_JPRB, 0.67477757E-07_JPRB, 0.67815584E-07_JPRB, 0.68202013E-07_JPRB, 0.68738252E-07_JPRB, 0.69136753E-07_JPRB, &
  & 0.69537279E-07_JPRB, 0.69819656E-07_JPRB, 0.70004923E-07_JPRB, 0.70169918E-07_JPRB, 0.70190779E-07_JPRB, 0.70224274E-07_JPRB, &
  & 0.70106616E-07_JPRB, 0.69957380E-07_JPRB, 0.69683416E-07_JPRB, 0.69348715E-07_JPRB, 0.68986296E-07_JPRB, 0.68620778E-07_JPRB, &
  & 0.68325349E-07_JPRB, 0.68188072E-07_JPRB, 0.68235728E-07_JPRB, 0.68451676E-07_JPRB, 0.68819276E-07_JPRB, 0.69373790E-07_JPRB, &
  & 0.70256590E-07_JPRB, 0.71754165E-07_JPRB, 0.74068240E-07_JPRB, 0.76311736E-07_JPRB, 0.77670137E-07_JPRB, 0.78828990E-07_JPRB, &
  & 0.79533713E-07_JPRB, 0.79939895E-07_JPRB, 0.80265593E-07_JPRB, 0.84088072E-07_JPRB /)

RGHG7(:, 2, 3) = (/ &
  & 0.59981389E-05_JPRB, 0.16366452E-06_JPRB, 0.15126028E-06_JPRB, 0.14674077E-06_JPRB, 0.14499328E-06_JPRB, 0.14814604E-06_JPRB, &
  & 0.15077491E-06_JPRB, 0.15529160E-06_JPRB, 0.16125978E-06_JPRB, 0.16734491E-06_JPRB, 0.17292442E-06_JPRB, 0.17775683E-06_JPRB, &
  & 0.18195983E-06_JPRB, 0.18537118E-06_JPRB, 0.18815966E-06_JPRB, 0.19038416E-06_JPRB, 0.19237993E-06_JPRB, 0.19408051E-06_JPRB, &
  & 0.19600296E-06_JPRB, 0.19799833E-06_JPRB, 0.20046215E-06_JPRB, 0.20349390E-06_JPRB, 0.20640898E-06_JPRB, 0.20893060E-06_JPRB, &
  & 0.21091631E-06_JPRB, 0.21249291E-06_JPRB, 0.21348033E-06_JPRB, 0.21421999E-06_JPRB, 0.21532209E-06_JPRB, 0.21609507E-06_JPRB, &
  & 0.21652447E-06_JPRB, 0.21904887E-06_JPRB, 0.21595530E-06_JPRB, 0.20981582E-06_JPRB, 0.20886421E-06_JPRB, 0.20868947E-06_JPRB, &
  & 0.20913699E-06_JPRB, 0.20955601E-06_JPRB, 0.21010945E-06_JPRB, 0.21166380E-06_JPRB, 0.21374737E-06_JPRB, 0.21697635E-06_JPRB, &
  & 0.22083164E-06_JPRB, 0.22578784E-06_JPRB, 0.23166155E-06_JPRB, 0.23873315E-06_JPRB, 0.24689768E-06_JPRB, 0.25652292E-06_JPRB, &
  & 0.26769993E-06_JPRB, 0.28010655E-06_JPRB, 0.29431021E-06_JPRB, 0.31240819E-06_JPRB, 0.33941720E-06_JPRB, 0.38494233E-06_JPRB, &
  & 0.46650871E-06_JPRB, 0.61125951E-06_JPRB, 0.83626855E-06_JPRB, 0.10641116E-05_JPRB, 0.12201290E-05_JPRB, 0.13588150E-05_JPRB, &
  & 0.14544154E-05_JPRB, 0.15355781E-05_JPRB, 0.16047114E-05_JPRB, 0.19897936E-05_JPRB /)

RGHG7(:, 3, 3) = (/ &
  & 0.36137737E-05_JPRB, 0.18696790E-06_JPRB, 0.19526183E-06_JPRB, 0.22421250E-06_JPRB, 0.25472619E-06_JPRB, 0.28084841E-06_JPRB, &
  & 0.29121915E-06_JPRB, 0.29484812E-06_JPRB, 0.30245752E-06_JPRB, 0.31404082E-06_JPRB, 0.32596498E-06_JPRB, 0.33622885E-06_JPRB, &
  & 0.34575814E-06_JPRB, 0.35374106E-06_JPRB, 0.36075434E-06_JPRB, 0.36644576E-06_JPRB, 0.37183455E-06_JPRB, 0.37660811E-06_JPRB, &
  & 0.38175017E-06_JPRB, 0.38711130E-06_JPRB, 0.39271430E-06_JPRB, 0.39746658E-06_JPRB, 0.40217992E-06_JPRB, 0.40662954E-06_JPRB, &
  & 0.41063183E-06_JPRB, 0.41350168E-06_JPRB, 0.41516407E-06_JPRB, 0.41531678E-06_JPRB, 0.41657285E-06_JPRB, 0.41675293E-06_JPRB, &
  & 0.41749402E-06_JPRB, 0.41944375E-06_JPRB, 0.41479527E-06_JPRB, 0.40367513E-06_JPRB, 0.40323852E-06_JPRB, 0.40662289E-06_JPRB, &
  & 0.40924877E-06_JPRB, 0.41282226E-06_JPRB, 0.41550135E-06_JPRB, 0.41926199E-06_JPRB, 0.42365281E-06_JPRB, 0.43021106E-06_JPRB, &
  & 0.43809416E-06_JPRB, 0.44820419E-06_JPRB, 0.46004268E-06_JPRB, 0.47424911E-06_JPRB, 0.48985191E-06_JPRB, 0.50669996E-06_JPRB, &
  & 0.52535785E-06_JPRB, 0.54844571E-06_JPRB, 0.57880311E-06_JPRB, 0.61738484E-06_JPRB, 0.66674397E-06_JPRB, 0.73626910E-06_JPRB, &
  & 0.85000914E-06_JPRB, 0.10546839E-05_JPRB, 0.14021662E-05_JPRB, 0.17509357E-05_JPRB, 0.19062884E-05_JPRB, 0.20541399E-05_JPRB, &
  & 0.21267115E-05_JPRB, 0.22139584E-05_JPRB, 0.23455812E-05_JPRB, 0.39072024E-05_JPRB /)

RGHG7(:, 4, 3) = (/ &
  & 0.23671830E-05_JPRB, 0.48761473E-06_JPRB, 0.46323299E-06_JPRB, 0.44339194E-06_JPRB, 0.42339201E-06_JPRB, 0.42912396E-06_JPRB, &
  & 0.44645708E-06_JPRB, 0.46005269E-06_JPRB, 0.47790604E-06_JPRB, 0.49858807E-06_JPRB, 0.52118446E-06_JPRB, 0.54267343E-06_JPRB, &
  & 0.56480883E-06_JPRB, 0.58478884E-06_JPRB, 0.60431961E-06_JPRB, 0.62255862E-06_JPRB, 0.64052688E-06_JPRB, 0.65676920E-06_JPRB, &
  & 0.67232321E-06_JPRB, 0.68663070E-06_JPRB, 0.69920975E-06_JPRB, 0.71093410E-06_JPRB, 0.72169405E-06_JPRB, 0.73046550E-06_JPRB, &
  & 0.73686141E-06_JPRB, 0.74070198E-06_JPRB, 0.74462133E-06_JPRB, 0.74836612E-06_JPRB, 0.75106038E-06_JPRB, 0.75443438E-06_JPRB, &
  & 0.75605146E-06_JPRB, 0.75825449E-06_JPRB, 0.74940476E-06_JPRB, 0.72774492E-06_JPRB, 0.72639438E-06_JPRB, 0.73111090E-06_JPRB, &
  & 0.73336025E-06_JPRB, 0.73781791E-06_JPRB, 0.73940481E-06_JPRB, 0.74223414E-06_JPRB, 0.74470620E-06_JPRB, 0.74932711E-06_JPRB, &
  & 0.75418302E-06_JPRB, 0.76092311E-06_JPRB, 0.76809306E-06_JPRB, 0.77684439E-06_JPRB, 0.78591324E-06_JPRB, 0.79576017E-06_JPRB, &
  & 0.80685857E-06_JPRB, 0.81618998E-06_JPRB, 0.81720384E-06_JPRB, 0.80652205E-06_JPRB, 0.78762338E-06_JPRB, 0.76759994E-06_JPRB, &
  & 0.75853484E-06_JPRB, 0.79262901E-06_JPRB, 0.90138195E-06_JPRB, 0.10356266E-05_JPRB, 0.11303442E-05_JPRB, 0.13052911E-05_JPRB, &
  & 0.13849575E-05_JPRB, 0.15398967E-05_JPRB, 0.16655281E-05_JPRB, 0.26303428E-05_JPRB /)

RGHG7(:, 5, 3) = (/ &
  & 0.15626931E-05_JPRB, 0.58202056E-06_JPRB, 0.60305052E-06_JPRB, 0.66772600E-06_JPRB, 0.69967302E-06_JPRB, 0.70756079E-06_JPRB, &
  & 0.70436596E-06_JPRB, 0.70880094E-06_JPRB, 0.72572266E-06_JPRB, 0.74845150E-06_JPRB, 0.77511970E-06_JPRB, 0.80164131E-06_JPRB, &
  & 0.83064094E-06_JPRB, 0.85752549E-06_JPRB, 0.88627257E-06_JPRB, 0.91441990E-06_JPRB, 0.94149812E-06_JPRB, 0.96855183E-06_JPRB, &
  & 0.99332465E-06_JPRB, 0.10174139E-05_JPRB, 0.10382857E-05_JPRB, 0.10571038E-05_JPRB, 0.10730729E-05_JPRB, 0.10869747E-05_JPRB, &
  & 0.10975505E-05_JPRB, 0.11054849E-05_JPRB, 0.11127062E-05_JPRB, 0.11190630E-05_JPRB, 0.11236532E-05_JPRB, 0.11293499E-05_JPRB, &
  & 0.11311150E-05_JPRB, 0.11322463E-05_JPRB, 0.11202005E-05_JPRB, 0.10899120E-05_JPRB, 0.10869492E-05_JPRB, 0.10935595E-05_JPRB, &
  & 0.10966129E-05_JPRB, 0.11024565E-05_JPRB, 0.11032847E-05_JPRB, 0.11042885E-05_JPRB, 0.11022765E-05_JPRB, 0.11011631E-05_JPRB, &
  & 0.10979105E-05_JPRB, 0.10951811E-05_JPRB, 0.10909644E-05_JPRB, 0.10872355E-05_JPRB, 0.10824908E-05_JPRB, 0.10768300E-05_JPRB, &
  & 0.10673759E-05_JPRB, 0.10536431E-05_JPRB, 0.10431792E-05_JPRB, 0.10434122E-05_JPRB, 0.10548725E-05_JPRB, 0.10743943E-05_JPRB, &
  & 0.11062408E-05_JPRB, 0.11687364E-05_JPRB, 0.12843601E-05_JPRB, 0.14392959E-05_JPRB, 0.15253731E-05_JPRB, 0.16880540E-05_JPRB, &
  & 0.18165687E-05_JPRB, 0.20930124E-05_JPRB, 0.24136527E-05_JPRB, 0.37469786E-05_JPRB /)

RGHG7(:, 6, 3) = (/ &
  & 0.12529525E-05_JPRB, 0.11365096E-05_JPRB, 0.10725535E-05_JPRB, 0.10484805E-05_JPRB, 0.10505421E-05_JPRB, 0.10676287E-05_JPRB, &
  & 0.10763048E-05_JPRB, 0.10747597E-05_JPRB, 0.10821019E-05_JPRB, 0.10989978E-05_JPRB, 0.11218245E-05_JPRB, 0.11463665E-05_JPRB, &
  & 0.11742370E-05_JPRB, 0.12017302E-05_JPRB, 0.12353967E-05_JPRB, 0.12653253E-05_JPRB, 0.12971703E-05_JPRB, 0.13281025E-05_JPRB, &
  & 0.13552880E-05_JPRB, 0.13833259E-05_JPRB, 0.14054326E-05_JPRB, 0.14289002E-05_JPRB, 0.14474330E-05_JPRB, 0.14670729E-05_JPRB, &
  & 0.14825241E-05_JPRB, 0.14983278E-05_JPRB, 0.15112581E-05_JPRB, 0.15227095E-05_JPRB, 0.15306774E-05_JPRB, 0.15369745E-05_JPRB, &
  & 0.15372168E-05_JPRB, 0.15345205E-05_JPRB, 0.15207984E-05_JPRB, 0.14842466E-05_JPRB, 0.14799892E-05_JPRB, 0.14869258E-05_JPRB, &
  & 0.14911556E-05_JPRB, 0.14978434E-05_JPRB, 0.14999173E-05_JPRB, 0.15014680E-05_JPRB, 0.14975665E-05_JPRB, 0.14915403E-05_JPRB, &
  & 0.14800593E-05_JPRB, 0.14661541E-05_JPRB, 0.14489395E-05_JPRB, 0.14312759E-05_JPRB, 0.14120378E-05_JPRB, 0.13923061E-05_JPRB, &
  & 0.13721443E-05_JPRB, 0.13549119E-05_JPRB, 0.13387677E-05_JPRB, 0.13126762E-05_JPRB, 0.12707793E-05_JPRB, 0.12196554E-05_JPRB, &
  & 0.11707721E-05_JPRB, 0.11362449E-05_JPRB, 0.11368227E-05_JPRB, 0.11668469E-05_JPRB, 0.12481056E-05_JPRB, 0.13473577E-05_JPRB, &
  & 0.14635606E-05_JPRB, 0.16244218E-05_JPRB, 0.18218717E-05_JPRB, 0.21870142E-05_JPRB /)

RGHG7(:, 7, 3) = (/ &
  & 0.13915491E-05_JPRB, 0.15055583E-05_JPRB, 0.16056998E-05_JPRB, 0.16233197E-05_JPRB, 0.16154528E-05_JPRB, 0.16130035E-05_JPRB, &
  & 0.16112102E-05_JPRB, 0.16021892E-05_JPRB, 0.16034678E-05_JPRB, 0.16137766E-05_JPRB, 0.16284682E-05_JPRB, 0.16461181E-05_JPRB, &
  & 0.16691715E-05_JPRB, 0.16949167E-05_JPRB, 0.17234320E-05_JPRB, 0.17508298E-05_JPRB, 0.17830375E-05_JPRB, 0.18077546E-05_JPRB, &
  & 0.18349594E-05_JPRB, 0.18592178E-05_JPRB, 0.18830386E-05_JPRB, 0.19039327E-05_JPRB, 0.19248594E-05_JPRB, 0.19468093E-05_JPRB, &
  & 0.19661054E-05_JPRB, 0.19884631E-05_JPRB, 0.20054226E-05_JPRB, 0.20222776E-05_JPRB, 0.20322896E-05_JPRB, 0.20380000E-05_JPRB, &
  & 0.20373700E-05_JPRB, 0.20317671E-05_JPRB, 0.20192056E-05_JPRB, 0.19793217E-05_JPRB, 0.19755039E-05_JPRB, 0.19815930E-05_JPRB, &
  & 0.19868294E-05_JPRB, 0.19923091E-05_JPRB, 0.19938798E-05_JPRB, 0.19946151E-05_JPRB, 0.19893137E-05_JPRB, 0.19791246E-05_JPRB, &
  & 0.19612498E-05_JPRB, 0.19383529E-05_JPRB, 0.19112877E-05_JPRB, 0.18821951E-05_JPRB, 0.18520186E-05_JPRB, 0.18228416E-05_JPRB, &
  & 0.17943345E-05_JPRB, 0.17665878E-05_JPRB, 0.17370057E-05_JPRB, 0.17108189E-05_JPRB, 0.17005543E-05_JPRB, 0.17088391E-05_JPRB, &
  & 0.17289588E-05_JPRB, 0.17604863E-05_JPRB, 0.18034185E-05_JPRB, 0.18536732E-05_JPRB, 0.19156728E-05_JPRB, 0.20117623E-05_JPRB, &
  & 0.21487933E-05_JPRB, 0.23336800E-05_JPRB, 0.24783037E-05_JPRB, 0.27925355E-05_JPRB /)

RGHG7(:, 8, 3) = (/ &
  & 0.16439091E-05_JPRB, 0.19065046E-05_JPRB, 0.21437288E-05_JPRB, 0.22252398E-05_JPRB, 0.22321728E-05_JPRB, 0.22240249E-05_JPRB, &
  & 0.22093573E-05_JPRB, 0.21843423E-05_JPRB, 0.21724049E-05_JPRB, 0.21698363E-05_JPRB, 0.21716110E-05_JPRB, 0.21787234E-05_JPRB, &
  & 0.21914689E-05_JPRB, 0.22070706E-05_JPRB, 0.22262293E-05_JPRB, 0.22455699E-05_JPRB, 0.22671736E-05_JPRB, 0.22863455E-05_JPRB, &
  & 0.23078117E-05_JPRB, 0.23265293E-05_JPRB, 0.23498801E-05_JPRB, 0.23699295E-05_JPRB, 0.23937152E-05_JPRB, 0.24168676E-05_JPRB, &
  & 0.24404708E-05_JPRB, 0.24620094E-05_JPRB, 0.24813253E-05_JPRB, 0.24982769E-05_JPRB, 0.25095333E-05_JPRB, 0.25177826E-05_JPRB, &
  & 0.25212369E-05_JPRB, 0.25189613E-05_JPRB, 0.25113870E-05_JPRB, 0.24734293E-05_JPRB, 0.24690910E-05_JPRB, 0.24709095E-05_JPRB, &
  & 0.24725402E-05_JPRB, 0.24721840E-05_JPRB, 0.24673120E-05_JPRB, 0.24599328E-05_JPRB, 0.24478979E-05_JPRB, 0.24313586E-05_JPRB, &
  & 0.24096439E-05_JPRB, 0.23841035E-05_JPRB, 0.23555010E-05_JPRB, 0.23264786E-05_JPRB, 0.22991576E-05_JPRB, 0.22739353E-05_JPRB, &
  & 0.22501824E-05_JPRB, 0.22289933E-05_JPRB, 0.22116917E-05_JPRB, 0.21994019E-05_JPRB, 0.21838794E-05_JPRB, 0.21583182E-05_JPRB, &
  & 0.21316005E-05_JPRB, 0.21146889E-05_JPRB, 0.21115113E-05_JPRB, 0.21221365E-05_JPRB, 0.21540507E-05_JPRB, 0.22050458E-05_JPRB, &
  & 0.22666532E-05_JPRB, 0.23518035E-05_JPRB, 0.25062659E-05_JPRB, 0.24950195E-05_JPRB /)

RGHG7(:, 9, 3) = (/ &
  & 0.18734429E-05_JPRB, 0.21948358E-05_JPRB, 0.26144398E-05_JPRB, 0.28439538E-05_JPRB, 0.29224186E-05_JPRB, 0.29378066E-05_JPRB, &
  & 0.29223722E-05_JPRB, 0.28854522E-05_JPRB, 0.28608633E-05_JPRB, 0.28450741E-05_JPRB, 0.28345407E-05_JPRB, 0.28316351E-05_JPRB, &
  & 0.28350246E-05_JPRB, 0.28418917E-05_JPRB, 0.28531997E-05_JPRB, 0.28643612E-05_JPRB, 0.28777267E-05_JPRB, 0.28891870E-05_JPRB, &
  & 0.29026928E-05_JPRB, 0.29165415E-05_JPRB, 0.29336825E-05_JPRB, 0.29531025E-05_JPRB, 0.29746666E-05_JPRB, 0.29970154E-05_JPRB, &
  & 0.30175754E-05_JPRB, 0.30360034E-05_JPRB, 0.30521305E-05_JPRB, 0.30670069E-05_JPRB, 0.30805666E-05_JPRB, 0.30945218E-05_JPRB, &
  & 0.31071802E-05_JPRB, 0.31137122E-05_JPRB, 0.31123689E-05_JPRB, 0.30760782E-05_JPRB, 0.30656420E-05_JPRB, 0.30548663E-05_JPRB, &
  & 0.30456717E-05_JPRB, 0.30353383E-05_JPRB, 0.30210219E-05_JPRB, 0.30038645E-05_JPRB, 0.29841387E-05_JPRB, 0.29618732E-05_JPRB, &
  & 0.29369551E-05_JPRB, 0.29109106E-05_JPRB, 0.28859984E-05_JPRB, 0.28634001E-05_JPRB, 0.28429372E-05_JPRB, 0.28248216E-05_JPRB, &
  & 0.28104926E-05_JPRB, 0.27994643E-05_JPRB, 0.27926653E-05_JPRB, 0.27891317E-05_JPRB, 0.27929068E-05_JPRB, 0.28145780E-05_JPRB, &
  & 0.28517695E-05_JPRB, 0.28962208E-05_JPRB, 0.29464427E-05_JPRB, 0.30026631E-05_JPRB, 0.30682825E-05_JPRB, 0.31290201E-05_JPRB, &
  & 0.31561726E-05_JPRB, 0.30988633E-05_JPRB, 0.29305229E-05_JPRB, 0.26513042E-05_JPRB /)

RGHG7(:,10, 3) = (/ &
  & 0.21515364E-05_JPRB, 0.24758499E-05_JPRB, 0.29326268E-05_JPRB, 0.33043641E-05_JPRB, 0.35324640E-05_JPRB, 0.36506763E-05_JPRB, &
  & 0.36906004E-05_JPRB, 0.36756983E-05_JPRB, 0.36552897E-05_JPRB, 0.36347976E-05_JPRB, 0.36179808E-05_JPRB, 0.36077861E-05_JPRB, &
  & 0.36038557E-05_JPRB, 0.36039480E-05_JPRB, 0.36099939E-05_JPRB, 0.36148224E-05_JPRB, 0.36225006E-05_JPRB, 0.36276156E-05_JPRB, &
  & 0.36346671E-05_JPRB, 0.36423974E-05_JPRB, 0.36529655E-05_JPRB, 0.36664205E-05_JPRB, 0.36805420E-05_JPRB, 0.36948163E-05_JPRB, &
  & 0.37064269E-05_JPRB, 0.37143116E-05_JPRB, 0.37205282E-05_JPRB, 0.37264026E-05_JPRB, 0.37341435E-05_JPRB, 0.37459422E-05_JPRB, &
  & 0.37601442E-05_JPRB, 0.37712134E-05_JPRB, 0.37748252E-05_JPRB, 0.37440871E-05_JPRB, 0.37373134E-05_JPRB, 0.37239747E-05_JPRB, &
  & 0.37009163E-05_JPRB, 0.36699957E-05_JPRB, 0.36448223E-05_JPRB, 0.36182685E-05_JPRB, 0.35902631E-05_JPRB, 0.35628891E-05_JPRB, &
  & 0.35386629E-05_JPRB, 0.35185305E-05_JPRB, 0.35029889E-05_JPRB, 0.34917534E-05_JPRB, 0.34850566E-05_JPRB, 0.34834011E-05_JPRB, &
  & 0.34864402E-05_JPRB, 0.34949196E-05_JPRB, 0.35091382E-05_JPRB, 0.35304772E-05_JPRB, 0.35571568E-05_JPRB, 0.35832147E-05_JPRB, &
  & 0.36078568E-05_JPRB, 0.36378665E-05_JPRB, 0.36697218E-05_JPRB, 0.36871629E-05_JPRB, 0.36882545E-05_JPRB, 0.36623087E-05_JPRB, &
  & 0.36101108E-05_JPRB, 0.35337496E-05_JPRB, 0.33890551E-05_JPRB, 0.30267693E-05_JPRB /)

RGHG7(:,11, 3) = (/ &
  & 0.24003753E-05_JPRB, 0.27714427E-05_JPRB, 0.32319649E-05_JPRB, 0.36609160E-05_JPRB, 0.40092568E-05_JPRB, 0.42694569E-05_JPRB, &
  & 0.44360322E-05_JPRB, 0.45191182E-05_JPRB, 0.45672150E-05_JPRB, 0.45879669E-05_JPRB, 0.45922038E-05_JPRB, 0.45882998E-05_JPRB, &
  & 0.45814918E-05_JPRB, 0.45712350E-05_JPRB, 0.45645743E-05_JPRB, 0.45566826E-05_JPRB, 0.45506631E-05_JPRB, 0.45457277E-05_JPRB, &
  & 0.45403694E-05_JPRB, 0.45353336E-05_JPRB, 0.45288834E-05_JPRB, 0.45217707E-05_JPRB, 0.45139141E-05_JPRB, 0.45043721E-05_JPRB, &
  & 0.44938024E-05_JPRB, 0.44822082E-05_JPRB, 0.44712942E-05_JPRB, 0.44647986E-05_JPRB, 0.44656999E-05_JPRB, 0.44759877E-05_JPRB, &
  & 0.44939138E-05_JPRB, 0.45113411E-05_JPRB, 0.45185129E-05_JPRB, 0.44892095E-05_JPRB, 0.44708945E-05_JPRB, 0.44485282E-05_JPRB, &
  & 0.44402564E-05_JPRB, 0.44279936E-05_JPRB, 0.44008671E-05_JPRB, 0.43754026E-05_JPRB, 0.43571699E-05_JPRB, 0.43449686E-05_JPRB, &
  & 0.43403893E-05_JPRB, 0.43430714E-05_JPRB, 0.43533109E-05_JPRB, 0.43700911E-05_JPRB, 0.43915538E-05_JPRB, 0.44160429E-05_JPRB, &
  & 0.44446865E-05_JPRB, 0.44781368E-05_JPRB, 0.45161942E-05_JPRB, 0.45580937E-05_JPRB, 0.46033892E-05_JPRB, 0.46525893E-05_JPRB, &
  & 0.47012495E-05_JPRB, 0.47369103E-05_JPRB, 0.47455906E-05_JPRB, 0.47133881E-05_JPRB, 0.46441155E-05_JPRB, 0.45237121E-05_JPRB, &
  & 0.43463274E-05_JPRB, 0.40962641E-05_JPRB, 0.38031776E-05_JPRB, 0.33455285E-05_JPRB /)

RGHG7(:,12, 3) = (/ &
  & 0.26877558E-05_JPRB, 0.30263550E-05_JPRB, 0.34622822E-05_JPRB, 0.38730504E-05_JPRB, 0.42575903E-05_JPRB, 0.45881384E-05_JPRB, &
  & 0.48463880E-05_JPRB, 0.50258082E-05_JPRB, 0.51572160E-05_JPRB, 0.52473119E-05_JPRB, 0.53062231E-05_JPRB, 0.53413701E-05_JPRB, &
  & 0.53634353E-05_JPRB, 0.53762560E-05_JPRB, 0.53875769E-05_JPRB, 0.54008738E-05_JPRB, 0.54127163E-05_JPRB, 0.54284701E-05_JPRB, &
  & 0.54411144E-05_JPRB, 0.54509560E-05_JPRB, 0.54563702E-05_JPRB, 0.54561569E-05_JPRB, 0.54521975E-05_JPRB, 0.54451070E-05_JPRB, &
  & 0.54376378E-05_JPRB, 0.54303482E-05_JPRB, 0.54247357E-05_JPRB, 0.54236612E-05_JPRB, 0.54296238E-05_JPRB, 0.54434217E-05_JPRB, &
  & 0.54624352E-05_JPRB, 0.54799689E-05_JPRB, 0.54857978E-05_JPRB, 0.54547700E-05_JPRB, 0.54454085E-05_JPRB, 0.54310581E-05_JPRB, &
  & 0.53978692E-05_JPRB, 0.53638128E-05_JPRB, 0.53399303E-05_JPRB, 0.53163390E-05_JPRB, 0.52983323E-05_JPRB, 0.52897362E-05_JPRB, &
  & 0.52947262E-05_JPRB, 0.53137401E-05_JPRB, 0.53456833E-05_JPRB, 0.53860072E-05_JPRB, 0.54333600E-05_JPRB, 0.54851439E-05_JPRB, &
  & 0.55405312E-05_JPRB, 0.55978317E-05_JPRB, 0.56553122E-05_JPRB, 0.57088291E-05_JPRB, 0.57521911E-05_JPRB, 0.57763682E-05_JPRB, &
  & 0.57716147E-05_JPRB, 0.57291750E-05_JPRB, 0.56373165E-05_JPRB, 0.54854931E-05_JPRB, 0.52875207E-05_JPRB, 0.50549024E-05_JPRB, &
  & 0.47943922E-05_JPRB, 0.45331162E-05_JPRB, 0.42281358E-05_JPRB, 0.38003914E-05_JPRB /)

RGHG7(:,13, 3) = (/ &
  & 0.29996911E-05_JPRB, 0.32455866E-05_JPRB, 0.36218353E-05_JPRB, 0.39638985E-05_JPRB, 0.43034170E-05_JPRB, 0.46326227E-05_JPRB, &
  & 0.49281766E-05_JPRB, 0.51723096E-05_JPRB, 0.53785852E-05_JPRB, 0.55460446E-05_JPRB, 0.56804843E-05_JPRB, 0.57850452E-05_JPRB, &
  & 0.58680857E-05_JPRB, 0.59345448E-05_JPRB, 0.59920935E-05_JPRB, 0.60501966E-05_JPRB, 0.61045589E-05_JPRB, 0.61585893E-05_JPRB, &
  & 0.62112586E-05_JPRB, 0.62557478E-05_JPRB, 0.62933568E-05_JPRB, 0.63202160E-05_JPRB, 0.63385787E-05_JPRB, 0.63556736E-05_JPRB, &
  & 0.63719453E-05_JPRB, 0.63911230E-05_JPRB, 0.64123110E-05_JPRB, 0.64346350E-05_JPRB, 0.64566871E-05_JPRB, 0.64758970E-05_JPRB, &
  & 0.64901128E-05_JPRB, 0.64951978E-05_JPRB, 0.64856767E-05_JPRB, 0.64458509E-05_JPRB, 0.64174847E-05_JPRB, 0.63818875E-05_JPRB, &
  & 0.63599091E-05_JPRB, 0.63323123E-05_JPRB, 0.63064053E-05_JPRB, 0.62827671E-05_JPRB, 0.62662966E-05_JPRB, 0.62549193E-05_JPRB, &
  & 0.62580061E-05_JPRB, 0.62758995E-05_JPRB, 0.63081779E-05_JPRB, 0.63490656E-05_JPRB, 0.63949897E-05_JPRB, 0.64407291E-05_JPRB, &
  & 0.64841811E-05_JPRB, 0.65205304E-05_JPRB, 0.65444628E-05_JPRB, 0.65509712E-05_JPRB, 0.65324621E-05_JPRB, 0.64830188E-05_JPRB, &
  & 0.63949451E-05_JPRB, 0.62599415E-05_JPRB, 0.60711536E-05_JPRB, 0.58292030E-05_JPRB, 0.55582950E-05_JPRB, 0.52696037E-05_JPRB, &
  & 0.49873306E-05_JPRB, 0.46972145E-05_JPRB, 0.44184499E-05_JPRB, 0.40244909E-05_JPRB /)

RGHG7(:,14, 3) = (/ &
  & 0.32177350E-05_JPRB, 0.34077104E-05_JPRB, 0.37286616E-05_JPRB, 0.40378272E-05_JPRB, 0.43418413E-05_JPRB, 0.46473624E-05_JPRB, &
  & 0.49442147E-05_JPRB, 0.52166606E-05_JPRB, 0.54684174E-05_JPRB, 0.56909194E-05_JPRB, 0.58834398E-05_JPRB, 0.60459838E-05_JPRB, &
  & 0.61860583E-05_JPRB, 0.63076695E-05_JPRB, 0.64166611E-05_JPRB, 0.65241211E-05_JPRB, 0.66295243E-05_JPRB, 0.67327110E-05_JPRB, &
  & 0.68338186E-05_JPRB, 0.69248576E-05_JPRB, 0.70044384E-05_JPRB, 0.70724868E-05_JPRB, 0.71263821E-05_JPRB, 0.71748555E-05_JPRB, &
  & 0.72213957E-05_JPRB, 0.72683874E-05_JPRB, 0.73158963E-05_JPRB, 0.73589613E-05_JPRB, 0.73945907E-05_JPRB, 0.74163459E-05_JPRB, &
  & 0.74224890E-05_JPRB, 0.74118793E-05_JPRB, 0.73820415E-05_JPRB, 0.73209476E-05_JPRB, 0.72763110E-05_JPRB, 0.72342232E-05_JPRB, &
  & 0.71994523E-05_JPRB, 0.71668128E-05_JPRB, 0.71373352E-05_JPRB, 0.71131544E-05_JPRB, 0.70964284E-05_JPRB, 0.70826322E-05_JPRB, &
  & 0.70774954E-05_JPRB, 0.70812112E-05_JPRB, 0.70903138E-05_JPRB, 0.71043437E-05_JPRB, 0.71186482E-05_JPRB, 0.71302211E-05_JPRB, &
  & 0.71308536E-05_JPRB, 0.71148979E-05_JPRB, 0.70754454E-05_JPRB, 0.70084702E-05_JPRB, 0.69093953E-05_JPRB, 0.67743099E-05_JPRB, &
  & 0.65995659E-05_JPRB, 0.63840816E-05_JPRB, 0.61293508E-05_JPRB, 0.58411902E-05_JPRB, 0.55432101E-05_JPRB, 0.52535706E-05_JPRB, &
  & 0.49772711E-05_JPRB, 0.47283902E-05_JPRB, 0.44698909E-05_JPRB, 0.41173921E-05_JPRB /)

RGHG7(:,15, 3) = (/ &
  & 0.33689885E-05_JPRB, 0.35714406E-05_JPRB, 0.38392513E-05_JPRB, 0.41632411E-05_JPRB, 0.44631461E-05_JPRB, 0.47520030E-05_JPRB, &
  & 0.50336271E-05_JPRB, 0.53039844E-05_JPRB, 0.55653150E-05_JPRB, 0.58094288E-05_JPRB, 0.60330067E-05_JPRB, 0.62327977E-05_JPRB, &
  & 0.64122878E-05_JPRB, 0.65749819E-05_JPRB, 0.67258097E-05_JPRB, 0.68734512E-05_JPRB, 0.70180313E-05_JPRB, 0.71624536E-05_JPRB, &
  & 0.73053752E-05_JPRB, 0.74393852E-05_JPRB, 0.75631810E-05_JPRB, 0.76745009E-05_JPRB, 0.77700379E-05_JPRB, 0.78566691E-05_JPRB, &
  & 0.79366728E-05_JPRB, 0.80102955E-05_JPRB, 0.80785003E-05_JPRB, 0.81331700E-05_JPRB, 0.81728986E-05_JPRB, 0.81912003E-05_JPRB, &
  & 0.81880180E-05_JPRB, 0.81615444E-05_JPRB, 0.81124754E-05_JPRB, 0.80322552E-05_JPRB, 0.79689980E-05_JPRB, 0.79151296E-05_JPRB, &
  & 0.78701960E-05_JPRB, 0.78334369E-05_JPRB, 0.78033363E-05_JPRB, 0.77762979E-05_JPRB, 0.77505019E-05_JPRB, 0.77262830E-05_JPRB, &
  & 0.77028753E-05_JPRB, 0.76777033E-05_JPRB, 0.76515753E-05_JPRB, 0.76236443E-05_JPRB, 0.75909416E-05_JPRB, 0.75477587E-05_JPRB, &
  & 0.74867480E-05_JPRB, 0.74038030E-05_JPRB, 0.72939170E-05_JPRB, 0.71560803E-05_JPRB, 0.69872103E-05_JPRB, 0.67876558E-05_JPRB, &
  & 0.65583872E-05_JPRB, 0.63026159E-05_JPRB, 0.60246216E-05_JPRB, 0.57329835E-05_JPRB, 0.54478828E-05_JPRB, 0.51805760E-05_JPRB, &
  & 0.49423438E-05_JPRB, 0.47186822E-05_JPRB, 0.44947051E-05_JPRB, 0.41714839E-05_JPRB /)

RGHG7(:,16, 3) = (/ &
  & 0.35300586E-05_JPRB, 0.37107802E-05_JPRB, 0.39254505E-05_JPRB, 0.42193915E-05_JPRB, 0.45077991E-05_JPRB, 0.47815279E-05_JPRB, &
  & 0.50438084E-05_JPRB, 0.52984024E-05_JPRB, 0.55521832E-05_JPRB, 0.57996604E-05_JPRB, 0.60373050E-05_JPRB, 0.62601794E-05_JPRB, &
  & 0.64695364E-05_JPRB, 0.66656867E-05_JPRB, 0.68531235E-05_JPRB, 0.70364540E-05_JPRB, 0.72190210E-05_JPRB, 0.74037580E-05_JPRB, &
  & 0.75867652E-05_JPRB, 0.77636514E-05_JPRB, 0.79294350E-05_JPRB, 0.80792279E-05_JPRB, 0.82106626E-05_JPRB, 0.83275918E-05_JPRB, &
  & 0.84301982E-05_JPRB, 0.85200254E-05_JPRB, 0.85948359E-05_JPRB, 0.86503633E-05_JPRB, 0.86850296E-05_JPRB, 0.86968839E-05_JPRB, &
  & 0.86810924E-05_JPRB, 0.86424634E-05_JPRB, 0.85807715E-05_JPRB, 0.84962876E-05_JPRB, 0.84234043E-05_JPRB, 0.83586019E-05_JPRB, &
  & 0.83066716E-05_JPRB, 0.82652459E-05_JPRB, 0.82308861E-05_JPRB, 0.82007082E-05_JPRB, 0.81687831E-05_JPRB, 0.81308408E-05_JPRB, &
  & 0.80830632E-05_JPRB, 0.80233731E-05_JPRB, 0.79519632E-05_JPRB, 0.78690764E-05_JPRB, 0.77737677E-05_JPRB, 0.76630195E-05_JPRB, &
  & 0.75349676E-05_JPRB, 0.73881156E-05_JPRB, 0.72206039E-05_JPRB, 0.70316496E-05_JPRB, 0.68207637E-05_JPRB, 0.65892928E-05_JPRB, &
  & 0.63404200E-05_JPRB, 0.60790649E-05_JPRB, 0.58118490E-05_JPRB, 0.55461010E-05_JPRB, 0.52970095E-05_JPRB, 0.50735257E-05_JPRB, &
  & 0.48733136E-05_JPRB, 0.46915084E-05_JPRB, 0.45061561E-05_JPRB, 0.42426295E-05_JPRB /)

RGHG7(:,17, 3) = (/ &
  & 0.36592951E-05_JPRB, 0.38232188E-05_JPRB, 0.40182495E-05_JPRB, 0.42767774E-05_JPRB, 0.45626020E-05_JPRB, 0.48292472E-05_JPRB, &
  & 0.50850181E-05_JPRB, 0.53315225E-05_JPRB, 0.55780288E-05_JPRB, 0.58246114E-05_JPRB, 0.60690750E-05_JPRB, 0.63054913E-05_JPRB, &
  & 0.65342465E-05_JPRB, 0.67569918E-05_JPRB, 0.69728976E-05_JPRB, 0.71865061E-05_JPRB, 0.74006739E-05_JPRB, 0.76132105E-05_JPRB, &
  & 0.78254125E-05_JPRB, 0.80318296E-05_JPRB, 0.82247079E-05_JPRB, 0.83989098E-05_JPRB, 0.85525580E-05_JPRB, 0.86863429E-05_JPRB, &
  & 0.88002071E-05_JPRB, 0.88937613E-05_JPRB, 0.89729765E-05_JPRB, 0.90313897E-05_JPRB, 0.90639214E-05_JPRB, 0.90710364E-05_JPRB, &
  & 0.90545282E-05_JPRB, 0.90153399E-05_JPRB, 0.89540072E-05_JPRB, 0.88664819E-05_JPRB, 0.87916860E-05_JPRB, 0.87298813E-05_JPRB, &
  & 0.86793243E-05_JPRB, 0.86369810E-05_JPRB, 0.86002547E-05_JPRB, 0.85602496E-05_JPRB, 0.85110196E-05_JPRB, 0.84491121E-05_JPRB, &
  & 0.83713403E-05_JPRB, 0.82744027E-05_JPRB, 0.81574435E-05_JPRB, 0.80217233E-05_JPRB, 0.78683388E-05_JPRB, 0.76992264E-05_JPRB, &
  & 0.75159423E-05_JPRB, 0.73197630E-05_JPRB, 0.71109007E-05_JPRB, 0.68893914E-05_JPRB, 0.66556067E-05_JPRB, 0.64107494E-05_JPRB, &
  & 0.61589080E-05_JPRB, 0.59051854E-05_JPRB, 0.56553654E-05_JPRB, 0.54161223E-05_JPRB, 0.51975694E-05_JPRB, 0.50017129E-05_JPRB, &
  & 0.48275601E-05_JPRB, 0.46649784E-05_JPRB, 0.45051106E-05_JPRB, 0.43078344E-05_JPRB /)

RGHG7(:,18, 3) = (/ &
  & 0.37621805E-05_JPRB, 0.39290831E-05_JPRB, 0.41047410E-05_JPRB, 0.43247796E-05_JPRB, 0.45952952E-05_JPRB, 0.48682464E-05_JPRB, &
  & 0.51241159E-05_JPRB, 0.53713566E-05_JPRB, 0.56151248E-05_JPRB, 0.58602377E-05_JPRB, 0.61091459E-05_JPRB, 0.63518446E-05_JPRB, &
  & 0.65895547E-05_JPRB, 0.68256077E-05_JPRB, 0.70541987E-05_JPRB, 0.72827311E-05_JPRB, 0.75103958E-05_JPRB, 0.77344603E-05_JPRB, &
  & 0.79578222E-05_JPRB, 0.81711751E-05_JPRB, 0.83708373E-05_JPRB, 0.85516913E-05_JPRB, 0.87097496E-05_JPRB, 0.88455336E-05_JPRB, &
  & 0.89592495E-05_JPRB, 0.90556468E-05_JPRB, 0.91349948E-05_JPRB, 0.91870352E-05_JPRB, 0.92243763E-05_JPRB, 0.92389764E-05_JPRB, &
  & 0.92352793E-05_JPRB, 0.92112641E-05_JPRB, 0.91693782E-05_JPRB, 0.91046595E-05_JPRB, 0.90464710E-05_JPRB, 0.89906016E-05_JPRB, &
  & 0.89378946E-05_JPRB, 0.88864954E-05_JPRB, 0.88324441E-05_JPRB, 0.87716953E-05_JPRB, 0.87008339E-05_JPRB, 0.86143027E-05_JPRB, &
  & 0.85075135E-05_JPRB, 0.83771629E-05_JPRB, 0.82221195E-05_JPRB, 0.80439650E-05_JPRB, 0.78471703E-05_JPRB, 0.76377210E-05_JPRB, &
  & 0.74193063E-05_JPRB, 0.71951840E-05_JPRB, 0.69665093E-05_JPRB, 0.67341143E-05_JPRB, 0.64975179E-05_JPRB, 0.62580034E-05_JPRB, &
  & 0.60186017E-05_JPRB, 0.57831176E-05_JPRB, 0.55563582E-05_JPRB, 0.53426775E-05_JPRB, 0.51484772E-05_JPRB, 0.49751325E-05_JPRB, &
  & 0.48199454E-05_JPRB, 0.46728878E-05_JPRB, 0.45321822E-05_JPRB, 0.43808627E-05_JPRB /)

RGHG7(:,19, 3) = (/ &
  & 0.38685544E-05_JPRB, 0.40370605E-05_JPRB, 0.41981125E-05_JPRB, 0.44004505E-05_JPRB, 0.46471691E-05_JPRB, 0.49160817E-05_JPRB, &
  & 0.51728407E-05_JPRB, 0.54206648E-05_JPRB, 0.56631811E-05_JPRB, 0.59033164E-05_JPRB, 0.61493070E-05_JPRB, 0.63893717E-05_JPRB, &
  & 0.66224388E-05_JPRB, 0.68559343E-05_JPRB, 0.70816327E-05_JPRB, 0.73056663E-05_JPRB, 0.75257581E-05_JPRB, 0.77421982E-05_JPRB, &
  & 0.79535057E-05_JPRB, 0.81537455E-05_JPRB, 0.83418827E-05_JPRB, 0.85120409E-05_JPRB, 0.86618656E-05_JPRB, 0.87902863E-05_JPRB, &
  & 0.88999905E-05_JPRB, 0.89919613E-05_JPRB, 0.90596177E-05_JPRB, 0.91212087E-05_JPRB, 0.91666934E-05_JPRB, 0.91947750E-05_JPRB, &
  & 0.92061218E-05_JPRB, 0.92014388E-05_JPRB, 0.91810998E-05_JPRB, 0.91383636E-05_JPRB, 0.90951753E-05_JPRB, 0.90485519E-05_JPRB, &
  & 0.89959585E-05_JPRB, 0.89354853E-05_JPRB, 0.88666693E-05_JPRB, 0.87873632E-05_JPRB, 0.86955988E-05_JPRB, 0.85890906E-05_JPRB, &
  & 0.84632793E-05_JPRB, 0.83144669E-05_JPRB, 0.81396847E-05_JPRB, 0.79422207E-05_JPRB, 0.77277309E-05_JPRB, 0.75033736E-05_JPRB, &
  & 0.72741959E-05_JPRB, 0.70449209E-05_JPRB, 0.68169902E-05_JPRB, 0.65911076E-05_JPRB, 0.63668326E-05_JPRB, 0.61449205E-05_JPRB, &
  & 0.59273243E-05_JPRB, 0.57163884E-05_JPRB, 0.55151336E-05_JPRB, 0.53262174E-05_JPRB, 0.51542829E-05_JPRB, 0.50012354E-05_JPRB, &
  & 0.48638221E-05_JPRB, 0.47388075E-05_JPRB, 0.46221949E-05_JPRB, 0.44989138E-05_JPRB /)

RGHG7(:,20, 3) = (/ &
  & 0.39683227E-05_JPRB, 0.41393537E-05_JPRB, 0.42923948E-05_JPRB, 0.44774956E-05_JPRB, 0.46974837E-05_JPRB, 0.49493624E-05_JPRB, &
  & 0.52060132E-05_JPRB, 0.54526995E-05_JPRB, 0.56900949E-05_JPRB, 0.59198505E-05_JPRB, 0.61522314E-05_JPRB, 0.63785192E-05_JPRB, &
  & 0.65926529E-05_JPRB, 0.68045538E-05_JPRB, 0.70099322E-05_JPRB, 0.72094954E-05_JPRB, 0.74032955E-05_JPRB, 0.75907078E-05_JPRB, &
  & 0.77715040E-05_JPRB, 0.79431411E-05_JPRB, 0.81044027E-05_JPRB, 0.82533625E-05_JPRB, 0.83872683E-05_JPRB, 0.85063357E-05_JPRB, &
  & 0.86118334E-05_JPRB, 0.86952559E-05_JPRB, 0.87733324E-05_JPRB, 0.88320703E-05_JPRB, 0.88760953E-05_JPRB, 0.89034138E-05_JPRB, &
  & 0.89154964E-05_JPRB, 0.89150635E-05_JPRB, 0.88993120E-05_JPRB, 0.88640800E-05_JPRB, 0.88247607E-05_JPRB, 0.87763847E-05_JPRB, &
  & 0.87162271E-05_JPRB, 0.86480759E-05_JPRB, 0.85717456E-05_JPRB, 0.84893090E-05_JPRB, 0.83985497E-05_JPRB, 0.82977112E-05_JPRB, &
  & 0.81810867E-05_JPRB, 0.80438558E-05_JPRB, 0.78822477E-05_JPRB, 0.76979795E-05_JPRB, 0.74961308E-05_JPRB, 0.72849116E-05_JPRB, &
  & 0.70713172E-05_JPRB, 0.68598465E-05_JPRB, 0.66515545E-05_JPRB, 0.64479159E-05_JPRB, 0.62483300E-05_JPRB, 0.60536663E-05_JPRB, &
  & 0.58645937E-05_JPRB, 0.56819572E-05_JPRB, 0.55069672E-05_JPRB, 0.53408476E-05_JPRB, 0.51878005E-05_JPRB, 0.50493240E-05_JPRB, &
  & 0.49268333E-05_JPRB, 0.48187203E-05_JPRB, 0.47325234E-05_JPRB, 0.46318510E-05_JPRB /)

RGHG7(:,21, 3) = (/ &
  & 0.40654763E-05_JPRB, 0.42306533E-05_JPRB, 0.43711957E-05_JPRB, 0.45327624E-05_JPRB, 0.47238550E-05_JPRB, 0.49414161E-05_JPRB, &
  & 0.51815923E-05_JPRB, 0.54145762E-05_JPRB, 0.56348854E-05_JPRB, 0.58423630E-05_JPRB, 0.60440038E-05_JPRB, 0.62387394E-05_JPRB, &
  & 0.64198721E-05_JPRB, 0.65936565E-05_JPRB, 0.67624983E-05_JPRB, 0.69248072E-05_JPRB, 0.70816586E-05_JPRB, 0.72328180E-05_JPRB, &
  & 0.73779520E-05_JPRB, 0.75159478E-05_JPRB, 0.76470924E-05_JPRB, 0.77703298E-05_JPRB, 0.78870926E-05_JPRB, 0.79970514E-05_JPRB, &
  & 0.80908540E-05_JPRB, 0.81826111E-05_JPRB, 0.82553552E-05_JPRB, 0.83066652E-05_JPRB, 0.83394261E-05_JPRB, 0.83483064E-05_JPRB, &
  & 0.83375253E-05_JPRB, 0.83111099E-05_JPRB, 0.82670613E-05_JPRB, 0.82104943E-05_JPRB, 0.81500339E-05_JPRB, 0.80867094E-05_JPRB, &
  & 0.80199443E-05_JPRB, 0.79558595E-05_JPRB, 0.78942940E-05_JPRB, 0.78373332E-05_JPRB, 0.77805162E-05_JPRB, 0.77187215E-05_JPRB, &
  & 0.76444003E-05_JPRB, 0.75508169E-05_JPRB, 0.74323771E-05_JPRB, 0.72900034E-05_JPRB, 0.71291779E-05_JPRB, 0.69583543E-05_JPRB, &
  & 0.67834608E-05_JPRB, 0.66082948E-05_JPRB, 0.64356036E-05_JPRB, 0.62669951E-05_JPRB, 0.61027745E-05_JPRB, 0.59437111E-05_JPRB, &
  & 0.57894863E-05_JPRB, 0.56401400E-05_JPRB, 0.54957345E-05_JPRB, 0.53567333E-05_JPRB, 0.52268047E-05_JPRB, 0.51088191E-05_JPRB, &
  & 0.50037997E-05_JPRB, 0.49239302E-05_JPRB, 0.48538177E-05_JPRB, 0.47766962E-05_JPRB /)

RGHG7(:,22, 3) = (/ &
  & 0.41418921E-05_JPRB, 0.42853439E-05_JPRB, 0.44042486E-05_JPRB, 0.45391989E-05_JPRB, 0.46974851E-05_JPRB, 0.48790139E-05_JPRB, &
  & 0.50795243E-05_JPRB, 0.52827122E-05_JPRB, 0.54751081E-05_JPRB, 0.56517511E-05_JPRB, 0.58148266E-05_JPRB, 0.59666531E-05_JPRB, &
  & 0.61065230E-05_JPRB, 0.62362969E-05_JPRB, 0.63606362E-05_JPRB, 0.64803553E-05_JPRB, 0.65960207E-05_JPRB, 0.67081505E-05_JPRB, &
  & 0.68163990E-05_JPRB, 0.69200842E-05_JPRB, 0.70201072E-05_JPRB, 0.71174936E-05_JPRB, 0.72134558E-05_JPRB, 0.73064616E-05_JPRB, &
  & 0.73989386E-05_JPRB, 0.74812397E-05_JPRB, 0.75463740E-05_JPRB, 0.75875892E-05_JPRB, 0.76017486E-05_JPRB, 0.75810285E-05_JPRB, &
  & 0.75347102E-05_JPRB, 0.74625750E-05_JPRB, 0.73747319E-05_JPRB, 0.72781972E-05_JPRB, 0.71862032E-05_JPRB, 0.71053742E-05_JPRB, &
  & 0.70394012E-05_JPRB, 0.69932066E-05_JPRB, 0.69665839E-05_JPRB, 0.69562002E-05_JPRB, 0.69543121E-05_JPRB, 0.69517341E-05_JPRB, &
  & 0.69385319E-05_JPRB, 0.69053740E-05_JPRB, 0.68472855E-05_JPRB, 0.67644733E-05_JPRB, 0.66621160E-05_JPRB, 0.65462277E-05_JPRB, &
  & 0.64215969E-05_JPRB, 0.62940130E-05_JPRB, 0.61665360E-05_JPRB, 0.60409334E-05_JPRB, 0.59179042E-05_JPRB, 0.57978232E-05_JPRB, &
  & 0.56804711E-05_JPRB, 0.55655328E-05_JPRB, 0.54525976E-05_JPRB, 0.53425179E-05_JPRB, 0.52385844E-05_JPRB, 0.51453021E-05_JPRB, &
  & 0.50685931E-05_JPRB, 0.50080866E-05_JPRB, 0.49600540E-05_JPRB, 0.49007949E-05_JPRB /)

RGHG7(:,23, 3) = (/ &
  & 0.41806575E-05_JPRB, 0.42892407E-05_JPRB, 0.43788850E-05_JPRB, 0.44831486E-05_JPRB, 0.46037248E-05_JPRB, 0.47431909E-05_JPRB, &
  & 0.48969623E-05_JPRB, 0.50585181E-05_JPRB, 0.52099872E-05_JPRB, 0.53466883E-05_JPRB, 0.54668926E-05_JPRB, 0.55719343E-05_JPRB, &
  & 0.56659856E-05_JPRB, 0.57513348E-05_JPRB, 0.58318619E-05_JPRB, 0.59104004E-05_JPRB, 0.59876611E-05_JPRB, 0.60638440E-05_JPRB, &
  & 0.61384294E-05_JPRB, 0.62095319E-05_JPRB, 0.62796703E-05_JPRB, 0.63507555E-05_JPRB, 0.64218839E-05_JPRB, 0.64973824E-05_JPRB, &
  & 0.65748050E-05_JPRB, 0.66465636E-05_JPRB, 0.67031192E-05_JPRB, 0.67330275E-05_JPRB, 0.67277297E-05_JPRB, 0.66841658E-05_JPRB, &
  & 0.66016510E-05_JPRB, 0.64900996E-05_JPRB, 0.63659231E-05_JPRB, 0.62379072E-05_JPRB, 0.61270471E-05_JPRB, 0.60420039E-05_JPRB, &
  & 0.59884633E-05_JPRB, 0.59705362E-05_JPRB, 0.59833178E-05_JPRB, 0.60218231E-05_JPRB, 0.60733601E-05_JPRB, 0.61268047E-05_JPRB, &
  & 0.61699679E-05_JPRB, 0.61944197E-05_JPRB, 0.61953697E-05_JPRB, 0.61728210E-05_JPRB, 0.61289520E-05_JPRB, 0.60681400E-05_JPRB, &
  & 0.59972153E-05_JPRB, 0.59203931E-05_JPRB, 0.58397322E-05_JPRB, 0.57579164E-05_JPRB, 0.56756598E-05_JPRB, 0.55941373E-05_JPRB, &
  & 0.55129904E-05_JPRB, 0.54320012E-05_JPRB, 0.53511876E-05_JPRB, 0.52712867E-05_JPRB, 0.51965217E-05_JPRB, 0.51307861E-05_JPRB, &
  & 0.50807203E-05_JPRB, 0.50444191E-05_JPRB, 0.50142526E-05_JPRB, 0.49799210E-05_JPRB /)

RGHG7(:,24, 3) = (/ &
  & 0.41714311E-05_JPRB, 0.42339270E-05_JPRB, 0.42906959E-05_JPRB, 0.43624245E-05_JPRB, 0.44478165E-05_JPRB, 0.45443107E-05_JPRB, &
  & 0.46490227E-05_JPRB, 0.47589315E-05_JPRB, 0.48677948E-05_JPRB, 0.49629912E-05_JPRB, 0.50423951E-05_JPRB, 0.51066704E-05_JPRB, &
  & 0.51594070E-05_JPRB, 0.52046826E-05_JPRB, 0.52464670E-05_JPRB, 0.52877049E-05_JPRB, 0.53294298E-05_JPRB, 0.53719273E-05_JPRB, &
  & 0.54146467E-05_JPRB, 0.54562638E-05_JPRB, 0.54986781E-05_JPRB, 0.55422584E-05_JPRB, 0.55890027E-05_JPRB, 0.56441504E-05_JPRB, &
  & 0.57015227E-05_JPRB, 0.57591797E-05_JPRB, 0.58044388E-05_JPRB, 0.58213682E-05_JPRB, 0.58064793E-05_JPRB, 0.57434008E-05_JPRB, &
  & 0.56424328E-05_JPRB, 0.55124178E-05_JPRB, 0.53718786E-05_JPRB, 0.52357263E-05_JPRB, 0.51265456E-05_JPRB, 0.50541362E-05_JPRB, &
  & 0.50228696E-05_JPRB, 0.50360918E-05_JPRB, 0.50845906E-05_JPRB, 0.51616062E-05_JPRB, 0.52510900E-05_JPRB, 0.53441213E-05_JPRB, &
  & 0.54280213E-05_JPRB, 0.54957195E-05_JPRB, 0.55436562E-05_JPRB, 0.55696923E-05_JPRB, 0.55753317E-05_JPRB, 0.55654250E-05_JPRB, &
  & 0.55430714E-05_JPRB, 0.55116184E-05_JPRB, 0.54741754E-05_JPRB, 0.54323937E-05_JPRB, 0.53881213E-05_JPRB, 0.53420399E-05_JPRB, &
  & 0.52943110E-05_JPRB, 0.52453152E-05_JPRB, 0.51955431E-05_JPRB, 0.51464890E-05_JPRB, 0.51016918E-05_JPRB, 0.50675940E-05_JPRB, &
  & 0.50441809E-05_JPRB, 0.50286121E-05_JPRB, 0.50180897E-05_JPRB, 0.50094554E-05_JPRB /)

RGHG7(:,25, 3) = (/ &
  & 0.41067883E-05_JPRB, 0.41165335E-05_JPRB, 0.41408907E-05_JPRB, 0.41797075E-05_JPRB, 0.42307061E-05_JPRB, 0.42904580E-05_JPRB, &
  & 0.43549376E-05_JPRB, 0.44212775E-05_JPRB, 0.44867488E-05_JPRB, 0.45432898E-05_JPRB, 0.45858719E-05_JPRB, 0.46150526E-05_JPRB, &
  & 0.46334608E-05_JPRB, 0.46450104E-05_JPRB, 0.46538748E-05_JPRB, 0.46633158E-05_JPRB, 0.46745968E-05_JPRB, 0.46881528E-05_JPRB, &
  & 0.47033145E-05_JPRB, 0.47191929E-05_JPRB, 0.47359890E-05_JPRB, 0.47550011E-05_JPRB, 0.47785493E-05_JPRB, 0.48107750E-05_JPRB, &
  & 0.48464262E-05_JPRB, 0.48870079E-05_JPRB, 0.49165046E-05_JPRB, 0.49249356E-05_JPRB, 0.48993838E-05_JPRB, 0.48317747E-05_JPRB, &
  & 0.47289950E-05_JPRB, 0.46005034E-05_JPRB, 0.44664243E-05_JPRB, 0.43439582E-05_JPRB, 0.42534743E-05_JPRB, 0.42051788E-05_JPRB, &
  & 0.42018814E-05_JPRB, 0.42435677E-05_JPRB, 0.43184855E-05_JPRB, 0.44191593E-05_JPRB, 0.45319925E-05_JPRB, 0.46463847E-05_JPRB, &
  & 0.47537169E-05_JPRB, 0.48483716E-05_JPRB, 0.49277910E-05_JPRB, 0.49898722E-05_JPRB, 0.50361814E-05_JPRB, 0.50674007E-05_JPRB, &
  & 0.50859167E-05_JPRB, 0.50939898E-05_JPRB, 0.50932395E-05_JPRB, 0.50864405E-05_JPRB, 0.50751146E-05_JPRB, 0.50607614E-05_JPRB, &
  & 0.50443105E-05_JPRB, 0.50262220E-05_JPRB, 0.50072767E-05_JPRB, 0.49884752E-05_JPRB, 0.49736973E-05_JPRB, 0.49662867E-05_JPRB, &
  & 0.49653909E-05_JPRB, 0.49695900E-05_JPRB, 0.49784608E-05_JPRB, 0.49940513E-05_JPRB /)

RGHG7(:,26, 3) = (/ &
  & 0.39869442E-05_JPRB, 0.39437118E-05_JPRB, 0.39368092E-05_JPRB, 0.39468218E-05_JPRB, 0.39680749E-05_JPRB, 0.39964384E-05_JPRB, &
  & 0.40289119E-05_JPRB, 0.40613409E-05_JPRB, 0.40903351E-05_JPRB, 0.41143448E-05_JPRB, 0.41281301E-05_JPRB, 0.41289891E-05_JPRB, &
  & 0.41195658E-05_JPRB, 0.41049670E-05_JPRB, 0.40885675E-05_JPRB, 0.40730861E-05_JPRB, 0.40599716E-05_JPRB, 0.40497571E-05_JPRB, &
  & 0.40417399E-05_JPRB, 0.40354698E-05_JPRB, 0.40309301E-05_JPRB, 0.40289383E-05_JPRB, 0.40318678E-05_JPRB, 0.40412910E-05_JPRB, &
  & 0.40566670E-05_JPRB, 0.40757204E-05_JPRB, 0.40896152E-05_JPRB, 0.40880500E-05_JPRB, 0.40553919E-05_JPRB, 0.39931479E-05_JPRB, &
  & 0.38986673E-05_JPRB, 0.37881443E-05_JPRB, 0.36766016E-05_JPRB, 0.35812825E-05_JPRB, 0.35193270E-05_JPRB, 0.34993679E-05_JPRB, &
  & 0.35223989E-05_JPRB, 0.35854332E-05_JPRB, 0.36788433E-05_JPRB, 0.37917343E-05_JPRB, 0.39127622E-05_JPRB, 0.40352757E-05_JPRB, &
  & 0.41526837E-05_JPRB, 0.42619272E-05_JPRB, 0.43610971E-05_JPRB, 0.44493486E-05_JPRB, 0.45251322E-05_JPRB, 0.45885126E-05_JPRB, &
  & 0.46392511E-05_JPRB, 0.46784121E-05_JPRB, 0.47085296E-05_JPRB, 0.47307203E-05_JPRB, 0.47473077E-05_JPRB, 0.47602957E-05_JPRB, &
  & 0.47704389E-05_JPRB, 0.47790259E-05_JPRB, 0.47876379E-05_JPRB, 0.47967046E-05_JPRB, 0.48105899E-05_JPRB, 0.48284478E-05_JPRB, &
  & 0.48491484E-05_JPRB, 0.48724519E-05_JPRB, 0.48992092E-05_JPRB, 0.49410355E-05_JPRB /)

RGHG7(:,27, 3) = (/ &
  & 0.38138000E-05_JPRB, 0.37269997E-05_JPRB, 0.36935710E-05_JPRB, 0.36811305E-05_JPRB, 0.36795534E-05_JPRB, 0.36842989E-05_JPRB, &
  & 0.36914755E-05_JPRB, 0.36984291E-05_JPRB, 0.37028528E-05_JPRB, 0.37012678E-05_JPRB, 0.36922354E-05_JPRB, 0.36760175E-05_JPRB, &
  & 0.36501363E-05_JPRB, 0.36166368E-05_JPRB, 0.35797286E-05_JPRB, 0.35428302E-05_JPRB, 0.35075752E-05_JPRB, 0.34758873E-05_JPRB, &
  & 0.34478812E-05_JPRB, 0.34236332E-05_JPRB, 0.34018599E-05_JPRB, 0.33833553E-05_JPRB, 0.33685403E-05_JPRB, 0.33591966E-05_JPRB, &
  & 0.33546096E-05_JPRB, 0.33526935E-05_JPRB, 0.33491376E-05_JPRB, 0.33347587E-05_JPRB, 0.33020183E-05_JPRB, 0.32468017E-05_JPRB, &
  & 0.31712391E-05_JPRB, 0.30861268E-05_JPRB, 0.30046717E-05_JPRB, 0.29414609E-05_JPRB, 0.29100322E-05_JPRB, 0.29171690E-05_JPRB, &
  & 0.29627090E-05_JPRB, 0.30418137E-05_JPRB, 0.31421498E-05_JPRB, 0.32557357E-05_JPRB, 0.33768617E-05_JPRB, 0.34980578E-05_JPRB, &
  & 0.36164811E-05_JPRB, 0.37311495E-05_JPRB, 0.38410167E-05_JPRB, 0.39456090E-05_JPRB, 0.40430982E-05_JPRB, 0.41304252E-05_JPRB, &
  & 0.42064371E-05_JPRB, 0.42716761E-05_JPRB, 0.43261002E-05_JPRB, 0.43724299E-05_JPRB, 0.44124113E-05_JPRB, 0.44485737E-05_JPRB, &
  & 0.44824128E-05_JPRB, 0.45157190E-05_JPRB, 0.45499010E-05_JPRB, 0.45849520E-05_JPRB, 0.46230116E-05_JPRB, 0.46623568E-05_JPRB, &
  & 0.47023545E-05_JPRB, 0.47429744E-05_JPRB, 0.47873500E-05_JPRB, 0.48545094E-05_JPRB /)

RGHG7(:,28, 3) = (/ &
  & 0.35968430E-05_JPRB, 0.34730751E-05_JPRB, 0.34215186E-05_JPRB, 0.33919093E-05_JPRB, 0.33737240E-05_JPRB, 0.33619247E-05_JPRB, &
  & 0.33522197E-05_JPRB, 0.33414904E-05_JPRB, 0.33279860E-05_JPRB, 0.33103390E-05_JPRB, 0.32847827E-05_JPRB, 0.32493690E-05_JPRB, &
  & 0.32063631E-05_JPRB, 0.31584123E-05_JPRB, 0.31080265E-05_JPRB, 0.30582280E-05_JPRB, 0.30104061E-05_JPRB, 0.29655889E-05_JPRB, &
  & 0.29241899E-05_JPRB, 0.28869188E-05_JPRB, 0.28526936E-05_JPRB, 0.28216991E-05_JPRB, 0.27934320E-05_JPRB, 0.27690808E-05_JPRB, &
  & 0.27476842E-05_JPRB, 0.27291176E-05_JPRB, 0.27097235E-05_JPRB, 0.26854761E-05_JPRB, 0.26519067E-05_JPRB, 0.26061334E-05_JPRB, &
  & 0.25502079E-05_JPRB, 0.24917581E-05_JPRB, 0.24410544E-05_JPRB, 0.24085555E-05_JPRB, 0.24047545E-05_JPRB, 0.24341120E-05_JPRB, &
  & 0.24945098E-05_JPRB, 0.25789416E-05_JPRB, 0.26807268E-05_JPRB, 0.27915664E-05_JPRB, 0.29047744E-05_JPRB, 0.30193414E-05_JPRB, &
  & 0.31333655E-05_JPRB, 0.32475953E-05_JPRB, 0.33626227E-05_JPRB, 0.34773282E-05_JPRB, 0.35888479E-05_JPRB, 0.36932713E-05_JPRB, &
  & 0.37886873E-05_JPRB, 0.38726926E-05_JPRB, 0.39468860E-05_JPRB, 0.40130667E-05_JPRB, 0.40726409E-05_JPRB, 0.41292014E-05_JPRB, &
  & 0.41836120E-05_JPRB, 0.42381548E-05_JPRB, 0.42938177E-05_JPRB, 0.43520995E-05_JPRB, 0.44117646E-05_JPRB, 0.44710041E-05_JPRB, &
  & 0.45288321E-05_JPRB, 0.45854204E-05_JPRB, 0.46461646E-05_JPRB, 0.47377671E-05_JPRB /)

RGHG7(:,29, 3) = (/ &
  & 0.33452693E-05_JPRB, 0.31980321E-05_JPRB, 0.31328586E-05_JPRB, 0.30925314E-05_JPRB, 0.30639485E-05_JPRB, 0.30413717E-05_JPRB, &
  & 0.30210942E-05_JPRB, 0.30001590E-05_JPRB, 0.29757566E-05_JPRB, 0.29468179E-05_JPRB, 0.29136900E-05_JPRB, 0.28735781E-05_JPRB, &
  & 0.28242812E-05_JPRB, 0.27660133E-05_JPRB, 0.27029423E-05_JPRB, 0.26396531E-05_JPRB, 0.25790130E-05_JPRB, 0.25227091E-05_JPRB, &
  & 0.24708454E-05_JPRB, 0.24235085E-05_JPRB, 0.23800160E-05_JPRB, 0.23397804E-05_JPRB, 0.23016182E-05_JPRB, 0.22658171E-05_JPRB, &
  & 0.22315430E-05_JPRB, 0.21996177E-05_JPRB, 0.21684461E-05_JPRB, 0.21372234E-05_JPRB, 0.21039996E-05_JPRB, 0.20674445E-05_JPRB, &
  & 0.20296200E-05_JPRB, 0.19953748E-05_JPRB, 0.19713411E-05_JPRB, 0.19649192E-05_JPRB, 0.19829838E-05_JPRB, 0.20278919E-05_JPRB, &
  & 0.20968687E-05_JPRB, 0.21846599E-05_JPRB, 0.22811284E-05_JPRB, 0.23813907E-05_JPRB, 0.24840213E-05_JPRB, 0.25884299E-05_JPRB, &
  & 0.26950070E-05_JPRB, 0.28060531E-05_JPRB, 0.29215455E-05_JPRB, 0.30410276E-05_JPRB, 0.31609381E-05_JPRB, 0.32771841E-05_JPRB, &
  & 0.33857618E-05_JPRB, 0.34845796E-05_JPRB, 0.35745695E-05_JPRB, 0.36564206E-05_JPRB, 0.37321427E-05_JPRB, 0.38054254E-05_JPRB, &
  & 0.38771573E-05_JPRB, 0.39503216E-05_JPRB, 0.40255500E-05_JPRB, 0.41034241E-05_JPRB, 0.41821145E-05_JPRB, 0.42592765E-05_JPRB, &
  & 0.43334931E-05_JPRB, 0.44050776E-05_JPRB, 0.44802773E-05_JPRB, 0.45959887E-05_JPRB /)

RGHG7(:,30, 3) = (/ &
  & 0.30750248E-05_JPRB, 0.29126661E-05_JPRB, 0.28420682E-05_JPRB, 0.27955380E-05_JPRB, 0.27612180E-05_JPRB, 0.27325698E-05_JPRB, &
  & 0.27060328E-05_JPRB, 0.26789444E-05_JPRB, 0.26499306E-05_JPRB, 0.26153562E-05_JPRB, 0.25732763E-05_JPRB, 0.25242164E-05_JPRB, &
  & 0.24701360E-05_JPRB, 0.24097535E-05_JPRB, 0.23428456E-05_JPRB, 0.22734207E-05_JPRB, 0.22054944E-05_JPRB, 0.21409819E-05_JPRB, &
  & 0.20813620E-05_JPRB, 0.20265991E-05_JPRB, 0.19761560E-05_JPRB, 0.19288445E-05_JPRB, 0.18834007E-05_JPRB, 0.18394159E-05_JPRB, &
  & 0.17960419E-05_JPRB, 0.17553483E-05_JPRB, 0.17161794E-05_JPRB, 0.16812864E-05_JPRB, 0.16495142E-05_JPRB, 0.16214003E-05_JPRB, &
  & 0.15986525E-05_JPRB, 0.15837827E-05_JPRB, 0.15807283E-05_JPRB, 0.15939245E-05_JPRB, 0.16274283E-05_JPRB, 0.16821293E-05_JPRB, &
  & 0.17541304E-05_JPRB, 0.18357355E-05_JPRB, 0.19230970E-05_JPRB, 0.20136463E-05_JPRB, 0.21053809E-05_JPRB, 0.21993346E-05_JPRB, &
  & 0.22973913E-05_JPRB, 0.24026949E-05_JPRB, 0.25166510E-05_JPRB, 0.26373932E-05_JPRB, 0.27615356E-05_JPRB, 0.28844945E-05_JPRB, &
  & 0.30016924E-05_JPRB, 0.31114346E-05_JPRB, 0.32128532E-05_JPRB, 0.33069493E-05_JPRB, 0.33961658E-05_JPRB, 0.34829152E-05_JPRB, &
  & 0.35689886E-05_JPRB, 0.36570441E-05_JPRB, 0.37482730E-05_JPRB, 0.38424932E-05_JPRB, 0.39382558E-05_JPRB, 0.40318528E-05_JPRB, &
  & 0.41212315E-05_JPRB, 0.42065876E-05_JPRB, 0.42958150E-05_JPRB, 0.44329454E-05_JPRB /)

RGHG7(:,31, 3) = (/ &
  & 0.27983974E-05_JPRB, 0.26313207E-05_JPRB, 0.25569930E-05_JPRB, 0.25086333E-05_JPRB, 0.24718556E-05_JPRB, 0.24403760E-05_JPRB, &
  & 0.24115632E-05_JPRB, 0.23817574E-05_JPRB, 0.23496261E-05_JPRB, 0.23136949E-05_JPRB, 0.22724528E-05_JPRB, 0.22220268E-05_JPRB, &
  & 0.21620547E-05_JPRB, 0.20976261E-05_JPRB, 0.20286236E-05_JPRB, 0.19554971E-05_JPRB, 0.18827159E-05_JPRB, 0.18131454E-05_JPRB, &
  & 0.17481229E-05_JPRB, 0.16879370E-05_JPRB, 0.16322139E-05_JPRB, 0.15795839E-05_JPRB, 0.15288108E-05_JPRB, 0.14793968E-05_JPRB, &
  & 0.14303835E-05_JPRB, 0.13851179E-05_JPRB, 0.13417190E-05_JPRB, 0.13062066E-05_JPRB, 0.12766213E-05_JPRB, 0.12556376E-05_JPRB, &
  & 0.12443602E-05_JPRB, 0.12433275E-05_JPRB, 0.12552173E-05_JPRB, 0.12812130E-05_JPRB, 0.13237182E-05_JPRB, 0.13813089E-05_JPRB, &
  & 0.14493424E-05_JPRB, 0.15251939E-05_JPRB, 0.16043709E-05_JPRB, 0.16837643E-05_JPRB, 0.17647537E-05_JPRB, 0.18491843E-05_JPRB, &
  & 0.19396171E-05_JPRB, 0.20394789E-05_JPRB, 0.21496735E-05_JPRB, 0.22691179E-05_JPRB, 0.23943371E-05_JPRB, 0.25199138E-05_JPRB, &
  & 0.26422993E-05_JPRB, 0.27584667E-05_JPRB, 0.28679390E-05_JPRB, 0.29713838E-05_JPRB, 0.30704305E-05_JPRB, 0.31672341E-05_JPRB, &
  & 0.32644041E-05_JPRB, 0.33636891E-05_JPRB, 0.34674595E-05_JPRB, 0.35748826E-05_JPRB, 0.36850988E-05_JPRB, 0.37929801E-05_JPRB, &
  & 0.38962376E-05_JPRB, 0.39937513E-05_JPRB, 0.40953610E-05_JPRB, 0.42531410E-05_JPRB /)

RGHG7(:,32, 3) = (/ &
  & 0.25264326E-05_JPRB, 0.23606976E-05_JPRB, 0.22885661E-05_JPRB, 0.22398528E-05_JPRB, 0.22029387E-05_JPRB, 0.21711744E-05_JPRB, &
  & 0.21417356E-05_JPRB, 0.21119495E-05_JPRB, 0.20796545E-05_JPRB, 0.20424347E-05_JPRB, 0.19991355E-05_JPRB, 0.19506742E-05_JPRB, &
  & 0.18927759E-05_JPRB, 0.18253741E-05_JPRB, 0.17541539E-05_JPRB, 0.16804870E-05_JPRB, 0.16056271E-05_JPRB, 0.15328379E-05_JPRB, &
  & 0.14640391E-05_JPRB, 0.13998534E-05_JPRB, 0.13400031E-05_JPRB, 0.12830432E-05_JPRB, 0.12288320E-05_JPRB, 0.11755739E-05_JPRB, &
  & 0.11245338E-05_JPRB, 0.10773465E-05_JPRB, 0.10332296E-05_JPRB, 0.99879389E-06_JPRB, 0.97215673E-06_JPRB, 0.95669088E-06_JPRB, &
  & 0.95315420E-06_JPRB, 0.96114900E-06_JPRB, 0.98199848E-06_JPRB, 0.10149746E-05_JPRB, 0.10610862E-05_JPRB, 0.11177482E-05_JPRB, &
  & 0.11822482E-05_JPRB, 0.12507783E-05_JPRB, 0.13192326E-05_JPRB, 0.13877701E-05_JPRB, 0.14585522E-05_JPRB, 0.15352246E-05_JPRB, &
  & 0.16205609E-05_JPRB, 0.17161500E-05_JPRB, 0.18227544E-05_JPRB, 0.19394668E-05_JPRB, 0.20628434E-05_JPRB, 0.21887977E-05_JPRB, &
  & 0.23122420E-05_JPRB, 0.24317872E-05_JPRB, 0.25462259E-05_JPRB, 0.26553394E-05_JPRB, 0.27611586E-05_JPRB, 0.28648528E-05_JPRB, &
  & 0.29690898E-05_JPRB, 0.30763038E-05_JPRB, 0.31883342E-05_JPRB, 0.33055055E-05_JPRB, 0.34265402E-05_JPRB, 0.35464172E-05_JPRB, &
  & 0.36606643E-05_JPRB, 0.37689449E-05_JPRB, 0.38816474E-05_JPRB, 0.40584514E-05_JPRB /)

RGHG7(:,33, 3) = (/ &
  & 0.22681477E-05_JPRB, 0.21102042E-05_JPRB, 0.20405855E-05_JPRB, 0.19944364E-05_JPRB, 0.19585491E-05_JPRB, 0.19275324E-05_JPRB, &
  & 0.18987864E-05_JPRB, 0.18694459E-05_JPRB, 0.18380138E-05_JPRB, 0.18028053E-05_JPRB, 0.17608912E-05_JPRB, 0.17108923E-05_JPRB, &
  & 0.16550941E-05_JPRB, 0.15913113E-05_JPRB, 0.15198138E-05_JPRB, 0.14447169E-05_JPRB, 0.13686167E-05_JPRB, 0.12939229E-05_JPRB, &
  & 0.12225840E-05_JPRB, 0.11552452E-05_JPRB, 0.10923727E-05_JPRB, 0.10320471E-05_JPRB, 0.97585723E-06_JPRB, 0.92028023E-06_JPRB, &
  & 0.86945619E-06_JPRB, 0.82231384E-06_JPRB, 0.78003211E-06_JPRB, 0.74771657E-06_JPRB, 0.72429356E-06_JPRB, 0.71282648E-06_JPRB, &
  & 0.71379105E-06_JPRB, 0.72668178E-06_JPRB, 0.75131300E-06_JPRB, 0.78654466E-06_JPRB, 0.83179214E-06_JPRB, 0.88468818E-06_JPRB, &
  & 0.94208912E-06_JPRB, 0.10005308E-05_JPRB, 0.10595437E-05_JPRB, 0.11204196E-05_JPRB, 0.11852458E-05_JPRB, 0.12565731E-05_JPRB, &
  & 0.13377921E-05_JPRB, 0.14308980E-05_JPRB, 0.15355386E-05_JPRB, 0.16498229E-05_JPRB, 0.17706769E-05_JPRB, 0.18937610E-05_JPRB, &
  & 0.20166735E-05_JPRB, 0.21363439E-05_JPRB, 0.22522813E-05_JPRB, 0.23644156E-05_JPRB, 0.24735514E-05_JPRB, 0.25809486E-05_JPRB, &
  & 0.26890618E-05_JPRB, 0.28002007E-05_JPRB, 0.29164598E-05_JPRB, 0.30391750E-05_JPRB, 0.31668465E-05_JPRB, 0.32944829E-05_JPRB, &
  & 0.34171530E-05_JPRB, 0.35334135E-05_JPRB, 0.36554122E-05_JPRB, 0.38497005E-05_JPRB /)

RGHG7(:,34, 3) = (/ &
  & 0.20285238E-05_JPRB, 0.18817751E-05_JPRB, 0.18179117E-05_JPRB, 0.17741745E-05_JPRB, 0.17402763E-05_JPRB, 0.17106870E-05_JPRB, &
  & 0.16829910E-05_JPRB, 0.16549342E-05_JPRB, 0.16246574E-05_JPRB, 0.15904499E-05_JPRB, 0.15513870E-05_JPRB, 0.15050872E-05_JPRB, &
  & 0.14495289E-05_JPRB, 0.13864443E-05_JPRB, 0.13171964E-05_JPRB, 0.12430577E-05_JPRB, 0.11665576E-05_JPRB, 0.10909275E-05_JPRB, &
  & 0.10178861E-05_JPRB, 0.94821235E-06_JPRB, 0.88322491E-06_JPRB, 0.82050644E-06_JPRB, 0.76338563E-06_JPRB, 0.70717584E-06_JPRB, &
  & 0.65765499E-06_JPRB, 0.61255435E-06_JPRB, 0.57346983E-06_JPRB, 0.54432138E-06_JPRB, 0.52413321E-06_JPRB, 0.51546368E-06_JPRB, &
  & 0.51848247E-06_JPRB, 0.53268650E-06_JPRB, 0.55717618E-06_JPRB, 0.59052911E-06_JPRB, 0.63167738E-06_JPRB, 0.67789364E-06_JPRB, &
  & 0.72645867E-06_JPRB, 0.77605847E-06_JPRB, 0.82723767E-06_JPRB, 0.88178160E-06_JPRB, 0.94247804E-06_JPRB, 0.10122653E-05_JPRB, &
  & 0.10932363E-05_JPRB, 0.11855524E-05_JPRB, 0.12888081E-05_JPRB, 0.14003729E-05_JPRB, 0.15172866E-05_JPRB, 0.16371959E-05_JPRB, &
  & 0.17568158E-05_JPRB, 0.18747393E-05_JPRB, 0.19899849E-05_JPRB, 0.21020273E-05_JPRB, 0.22117720E-05_JPRB, 0.23199327E-05_JPRB, &
  & 0.24287310E-05_JPRB, 0.25404361E-05_JPRB, 0.26571799E-05_JPRB, 0.27809713E-05_JPRB, 0.29105113E-05_JPRB, 0.30417625E-05_JPRB, &
  & 0.31685518E-05_JPRB, 0.32902772E-05_JPRB, 0.34196896E-05_JPRB, 0.36290023E-05_JPRB /)

RGHG7(:,35, 3) = (/ &
  & 0.18114756E-05_JPRB, 0.16782974E-05_JPRB, 0.16195895E-05_JPRB, 0.15795433E-05_JPRB, 0.15477274E-05_JPRB, 0.15196105E-05_JPRB, &
  & 0.14931393E-05_JPRB, 0.14664158E-05_JPRB, 0.14379376E-05_JPRB, 0.14057820E-05_JPRB, 0.13678931E-05_JPRB, 0.13237292E-05_JPRB, &
  & 0.12721142E-05_JPRB, 0.12118678E-05_JPRB, 0.11440308E-05_JPRB, 0.10709432E-05_JPRB, 0.99495514E-06_JPRB, 0.91874404E-06_JPRB, &
  & 0.84483679E-06_JPRB, 0.77373704E-06_JPRB, 0.70737110E-06_JPRB, 0.64362797E-06_JPRB, 0.58615569E-06_JPRB, 0.53153713E-06_JPRB, &
  & 0.48463960E-06_JPRB, 0.44355755E-06_JPRB, 0.40956928E-06_JPRB, 0.38494846E-06_JPRB, 0.36853012E-06_JPRB, 0.36211358E-06_JPRB, &
  & 0.36572445E-06_JPRB, 0.37875418E-06_JPRB, 0.40030591E-06_JPRB, 0.42916250E-06_JPRB, 0.46383758E-06_JPRB, 0.50216892E-06_JPRB, &
  & 0.54223574E-06_JPRB, 0.58383716E-06_JPRB, 0.62819271E-06_JPRB, 0.67752336E-06_JPRB, 0.73507215E-06_JPRB, 0.80360707E-06_JPRB, &
  & 0.88416124E-06_JPRB, 0.97709403E-06_JPRB, 0.10792844E-05_JPRB, 0.11883114E-05_JPRB, 0.13016535E-05_JPRB, 0.14169550E-05_JPRB, &
  & 0.15330805E-05_JPRB, 0.16477520E-05_JPRB, 0.17603589E-05_JPRB, 0.18705800E-05_JPRB, 0.19783174E-05_JPRB, 0.20848527E-05_JPRB, &
  & 0.21917010E-05_JPRB, 0.23009657E-05_JPRB, 0.24149801E-05_JPRB, 0.25360480E-05_JPRB, 0.26634248E-05_JPRB, 0.27935059E-05_JPRB, &
  & 0.29208327E-05_JPRB, 0.30448348E-05_JPRB, 0.31785175E-05_JPRB, 0.33997228E-05_JPRB /)

RGHG7(:,36, 3) = (/ &
  & 0.16168393E-05_JPRB, 0.14978876E-05_JPRB, 0.14456217E-05_JPRB, 0.14085232E-05_JPRB, 0.13788095E-05_JPRB, 0.13523675E-05_JPRB, &
  & 0.13269279E-05_JPRB, 0.13015463E-05_JPRB, 0.12744653E-05_JPRB, 0.12444361E-05_JPRB, 0.12097586E-05_JPRB, 0.11683508E-05_JPRB, &
  & 0.11188490E-05_JPRB, 0.10612199E-05_JPRB, 0.99585748E-06_JPRB, 0.92438393E-06_JPRB, 0.84955673E-06_JPRB, 0.77363956E-06_JPRB, &
  & 0.69946799E-06_JPRB, 0.62740395E-06_JPRB, 0.56025920E-06_JPRB, 0.49718614E-06_JPRB, 0.44123865E-06_JPRB, 0.39092257E-06_JPRB, &
  & 0.34948235E-06_JPRB, 0.31547734E-06_JPRB, 0.28860623E-06_JPRB, 0.27002810E-06_JPRB, 0.25804482E-06_JPRB, 0.25385663E-06_JPRB, &
  & 0.25735045E-06_JPRB, 0.26815133E-06_JPRB, 0.28566424E-06_JPRB, 0.30888501E-06_JPRB, 0.33675758E-06_JPRB, 0.36746411E-06_JPRB, &
  & 0.40014928E-06_JPRB, 0.43478789E-06_JPRB, 0.47291579E-06_JPRB, 0.51707201E-06_JPRB, 0.57068661E-06_JPRB, 0.63607081E-06_JPRB, &
  & 0.71508674E-06_JPRB, 0.80562313E-06_JPRB, 0.90576100E-06_JPRB, 0.10112486E-05_JPRB, 0.11201611E-05_JPRB, 0.12311518E-05_JPRB, &
  & 0.13426099E-05_JPRB, 0.14536033E-05_JPRB, 0.15628426E-05_JPRB, 0.16694381E-05_JPRB, 0.17738877E-05_JPRB, 0.18767605E-05_JPRB, &
  & 0.19794779E-05_JPRB, 0.20841292E-05_JPRB, 0.21931035E-05_JPRB, 0.23085345E-05_JPRB, 0.24304088E-05_JPRB, 0.25558925E-05_JPRB, &
  & 0.26801488E-05_JPRB, 0.28030247E-05_JPRB, 0.29381576E-05_JPRB, 0.31664656E-05_JPRB /)

RGHG7(:,37, 3) = (/ &
  & 0.14454241E-05_JPRB, 0.13394387E-05_JPRB, 0.12925932E-05_JPRB, 0.12586112E-05_JPRB, 0.12305571E-05_JPRB, 0.12054236E-05_JPRB, &
  & 0.11811521E-05_JPRB, 0.11571867E-05_JPRB, 0.11318039E-05_JPRB, 0.11036029E-05_JPRB, 0.10710887E-05_JPRB, 0.10327042E-05_JPRB, &
  & 0.98670591E-06_JPRB, 0.93209468E-06_JPRB, 0.86905976E-06_JPRB, 0.79951315E-06_JPRB, 0.72628188E-06_JPRB, 0.65120048E-06_JPRB, &
  & 0.57715010E-06_JPRB, 0.50556014E-06_JPRB, 0.43910205E-06_JPRB, 0.37918548E-06_JPRB, 0.32847910E-06_JPRB, 0.28600280E-06_JPRB, &
  & 0.25337292E-06_JPRB, 0.22791782E-06_JPRB, 0.20911455E-06_JPRB, 0.19628993E-06_JPRB, 0.18832476E-06_JPRB, 0.18587822E-06_JPRB, &
  & 0.18901474E-06_JPRB, 0.19764363E-06_JPRB, 0.21150156E-06_JPRB, 0.22996748E-06_JPRB, 0.25216971E-06_JPRB, 0.27696302E-06_JPRB, &
  & 0.30375415E-06_JPRB, 0.33264115E-06_JPRB, 0.36518657E-06_JPRB, 0.40384094E-06_JPRB, 0.45176336E-06_JPRB, 0.51193200E-06_JPRB, &
  & 0.58499245E-06_JPRB, 0.67100405E-06_JPRB, 0.76554261E-06_JPRB, 0.86585663E-06_JPRB, 0.96922167E-06_JPRB, 0.10748294E-05_JPRB, &
  & 0.11818645E-05_JPRB, 0.12888105E-05_JPRB, 0.13940690E-05_JPRB, 0.14967706E-05_JPRB, 0.15966365E-05_JPRB, 0.16944498E-05_JPRB, &
  & 0.17915867E-05_JPRB, 0.18899948E-05_JPRB, 0.19921192E-05_JPRB, 0.21001110E-05_JPRB, 0.22142883E-05_JPRB, 0.23325429E-05_JPRB, &
  & 0.24507603E-05_JPRB, 0.25696934E-05_JPRB, 0.27026279E-05_JPRB, 0.29324870E-05_JPRB /)

RGHG7(:,38, 3) = (/ &
  & 0.12935977E-05_JPRB, 0.12006127E-05_JPRB, 0.11584459E-05_JPRB, 0.11268302E-05_JPRB, 0.11000770E-05_JPRB, 0.10759427E-05_JPRB, &
  & 0.10527128E-05_JPRB, 0.10299809E-05_JPRB, 0.10062164E-05_JPRB, 0.98024191E-06_JPRB, 0.95051826E-06_JPRB, 0.91508394E-06_JPRB, &
  & 0.87221815E-06_JPRB, 0.82080743E-06_JPRB, 0.76079368E-06_JPRB, 0.69342667E-06_JPRB, 0.62208977E-06_JPRB, 0.54894741E-06_JPRB, &
  & 0.47650420E-06_JPRB, 0.40719468E-06_JPRB, 0.34456033E-06_JPRB, 0.29100124E-06_JPRB, 0.24879157E-06_JPRB, 0.21586760E-06_JPRB, &
  & 0.19212841E-06_JPRB, 0.17427583E-06_JPRB, 0.16141351E-06_JPRB, 0.15269048E-06_JPRB, 0.14727071E-06_JPRB, 0.14577761E-06_JPRB, &
  & 0.14841001E-06_JPRB, 0.15537780E-06_JPRB, 0.16660697E-06_JPRB, 0.18167648E-06_JPRB, 0.19990789E-06_JPRB, 0.22048771E-06_JPRB, &
  & 0.24290458E-06_JPRB, 0.26750831E-06_JPRB, 0.29548218E-06_JPRB, 0.32905024E-06_JPRB, 0.37113699E-06_JPRB, 0.42420325E-06_JPRB, &
  & 0.49012738E-06_JPRB, 0.56761877E-06_JPRB, 0.65483096E-06_JPRB, 0.74767695E-06_JPRB, 0.84458748E-06_JPRB, 0.94430999E-06_JPRB, &
  & 0.10463028E-05_JPRB, 0.11489936E-05_JPRB, 0.12504207E-05_JPRB, 0.13487461E-05_JPRB, 0.14436428E-05_JPRB, 0.15356317E-05_JPRB, &
  & 0.16261303E-05_JPRB, 0.17172304E-05_JPRB, 0.18113249E-05_JPRB, 0.19106117E-05_JPRB, 0.20156831E-05_JPRB, 0.21245814E-05_JPRB, &
  & 0.22346596E-05_JPRB, 0.23465934E-05_JPRB, 0.24742660E-05_JPRB, 0.26999492E-05_JPRB /)

RGHG7(:,39, 3) = (/ &
  & 0.11606562E-05_JPRB, 0.10778623E-05_JPRB, 0.10402282E-05_JPRB, 0.10105856E-05_JPRB, 0.98486964E-06_JPRB, 0.96134534E-06_JPRB, &
  & 0.93904225E-06_JPRB, 0.91753435E-06_JPRB, 0.89543124E-06_JPRB, 0.87158179E-06_JPRB, 0.84447959E-06_JPRB, 0.81230849E-06_JPRB, &
  & 0.77302417E-06_JPRB, 0.72495419E-06_JPRB, 0.66809747E-06_JPRB, 0.60381552E-06_JPRB, 0.53442136E-06_JPRB, 0.46362052E-06_JPRB, &
  & 0.39465701E-06_JPRB, 0.33089339E-06_JPRB, 0.27565105E-06_JPRB, 0.23074455E-06_JPRB, 0.19729330E-06_JPRB, 0.17250015E-06_JPRB, &
  & 0.15525200E-06_JPRB, 0.14229158E-06_JPRB, 0.13310463E-06_JPRB, 0.12666784E-06_JPRB, 0.12259898E-06_JPRB, 0.12147329E-06_JPRB, &
  & 0.12359784E-06_JPRB, 0.12934849E-06_JPRB, 0.13878012E-06_JPRB, 0.15158425E-06_JPRB, 0.16711236E-06_JPRB, 0.18476261E-06_JPRB, &
  & 0.20408336E-06_JPRB, 0.22550253E-06_JPRB, 0.25002205E-06_JPRB, 0.27950662E-06_JPRB, 0.31640326E-06_JPRB, 0.36327359E-06_JPRB, &
  & 0.42128249E-06_JPRB, 0.49067216E-06_JPRB, 0.56881021E-06_JPRB, 0.65347837E-06_JPRB, 0.74239199E-06_JPRB, 0.83530671E-06_JPRB, &
  & 0.93145519E-06_JPRB, 0.10298401E-05_JPRB, 0.11271725E-05_JPRB, 0.12213775E-05_JPRB, 0.13112242E-05_JPRB, 0.13970895E-05_JPRB, &
  & 0.14805830E-05_JPRB, 0.15636957E-05_JPRB, 0.16491988E-05_JPRB, 0.17389580E-05_JPRB, 0.18337369E-05_JPRB, 0.19320491E-05_JPRB, &
  & 0.20317586E-05_JPRB, 0.21346732E-05_JPRB, 0.22536692E-05_JPRB, 0.24693823E-05_JPRB /)

RGHG7(:,40, 3) = (/ &
  & 0.10422132E-05_JPRB, 0.96994472E-06_JPRB, 0.93539853E-06_JPRB, 0.90776825E-06_JPRB, 0.88262863E-06_JPRB, 0.85958487E-06_JPRB, &
  & 0.83806287E-06_JPRB, 0.81776716E-06_JPRB, 0.79731228E-06_JPRB, 0.77588902E-06_JPRB, 0.75157635E-06_JPRB, 0.72263043E-06_JPRB, &
  & 0.68691753E-06_JPRB, 0.64268261E-06_JPRB, 0.58917135E-06_JPRB, 0.52835628E-06_JPRB, 0.46296194E-06_JPRB, 0.39597700E-06_JPRB, &
  & 0.33150110E-06_JPRB, 0.27429726E-06_JPRB, 0.22757634E-06_JPRB, 0.19110654E-06_JPRB, 0.16470422E-06_JPRB, 0.14551070E-06_JPRB, &
  & 0.13234776E-06_JPRB, 0.12229519E-06_JPRB, 0.11517066E-06_JPRB, 0.10997961E-06_JPRB, 0.10659544E-06_JPRB, 0.10555401E-06_JPRB, &
  & 0.10723571E-06_JPRB, 0.11210243E-06_JPRB, 0.12028345E-06_JPRB, 0.13151846E-06_JPRB, 0.14521873E-06_JPRB, 0.16076234E-06_JPRB, &
  & 0.17787814E-06_JPRB, 0.19689213E-06_JPRB, 0.21875053E-06_JPRB, 0.24504573E-06_JPRB, 0.27793075E-06_JPRB, 0.31946558E-06_JPRB, &
  & 0.37106275E-06_JPRB, 0.43244287E-06_JPRB, 0.50223372E-06_JPRB, 0.57806091E-06_JPRB, 0.65860013E-06_JPRB, 0.74368404E-06_JPRB, &
  & 0.83371390E-06_JPRB, 0.92668301E-06_JPRB, 0.10202416E-05_JPRB, 0.11104280E-05_JPRB, 0.11954322E-05_JPRB, 0.12754799E-05_JPRB, &
  & 0.13518332E-05_JPRB, 0.14270863E-05_JPRB, 0.15035890E-05_JPRB, 0.15835706E-05_JPRB, 0.16673652E-05_JPRB, 0.17539949E-05_JPRB, &
  & 0.18422054E-05_JPRB, 0.19337958E-05_JPRB, 0.20418461E-05_JPRB, 0.22417842E-05_JPRB /)

RGHG7(:,41, 3) = (/ &
  & 0.93747622E-06_JPRB, 0.87327913E-06_JPRB, 0.84237121E-06_JPRB, 0.81608874E-06_JPRB, 0.79169342E-06_JPRB, 0.76897334E-06_JPRB, &
  & 0.74816194E-06_JPRB, 0.72906403E-06_JPRB, 0.71046514E-06_JPRB, 0.69128458E-06_JPRB, 0.66996029E-06_JPRB, 0.64442008E-06_JPRB, &
  & 0.61233209E-06_JPRB, 0.57172821E-06_JPRB, 0.52202694E-06_JPRB, 0.46436591E-06_JPRB, 0.40264268E-06_JPRB, 0.34081415E-06_JPRB, &
  & 0.28322819E-06_JPRB, 0.23326562E-06_JPRB, 0.19389097E-06_JPRB, 0.16428291E-06_JPRB, 0.14295277E-06_JPRB, 0.12753191E-06_JPRB, &
  & 0.11688460E-06_JPRB, 0.10858595E-06_JPRB, 0.10269205E-06_JPRB, 0.98188401E-07_JPRB, 0.95164950E-07_JPRB, 0.94109744E-07_JPRB, &
  & 0.95438402E-07_JPRB, 0.99642364E-07_JPRB, 0.10690906E-06_JPRB, 0.11701989E-06_JPRB, 0.12936577E-06_JPRB, 0.14342335E-06_JPRB, &
  & 0.15885128E-06_JPRB, 0.17603544E-06_JPRB, 0.19577011E-06_JPRB, 0.21948843E-06_JPRB, 0.24900376E-06_JPRB, 0.28620298E-06_JPRB, &
  & 0.33212436E-06_JPRB, 0.38688825E-06_JPRB, 0.44894679E-06_JPRB, 0.51645122E-06_JPRB, 0.58879044E-06_JPRB, 0.66606117E-06_JPRB, &
  & 0.74873566E-06_JPRB, 0.83654027E-06_JPRB, 0.92562533E-06_JPRB, 0.10118151E-05_JPRB, 0.10925072E-05_JPRB, 0.11667926E-05_JPRB, &
  & 0.12366058E-05_JPRB, 0.13040953E-05_JPRB, 0.13720392E-05_JPRB, 0.14420993E-05_JPRB, 0.15148445E-05_JPRB, 0.15894157E-05_JPRB, &
  & 0.16651908E-05_JPRB, 0.17447009E-05_JPRB, 0.18396843E-05_JPRB, 0.20192510E-05_JPRB /)

RGHG7(:,42, 3) = (/ &
  & 0.84329997E-06_JPRB, 0.78728107E-06_JPRB, 0.75872413E-06_JPRB, 0.73426645E-06_JPRB, 0.71033753E-06_JPRB, 0.68802751E-06_JPRB, &
  & 0.66795218E-06_JPRB, 0.65002683E-06_JPRB, 0.63331589E-06_JPRB, 0.61642839E-06_JPRB, 0.59790119E-06_JPRB, 0.57560715E-06_JPRB, &
  & 0.54726831E-06_JPRB, 0.51036369E-06_JPRB, 0.46437549E-06_JPRB, 0.41077271E-06_JPRB, 0.35280524E-06_JPRB, 0.29588787E-06_JPRB, &
  & 0.24457199E-06_JPRB, 0.20226341E-06_JPRB, 0.16937344E-06_JPRB, 0.14498755E-06_JPRB, 0.12735396E-06_JPRB, 0.11451285E-06_JPRB, &
  & 0.10548751E-06_JPRB, 0.98323774E-07_JPRB, 0.93187097E-07_JPRB, 0.89096218E-07_JPRB, 0.86295159E-07_JPRB, 0.85195921E-07_JPRB, &
  & 0.86252662E-07_JPRB, 0.89951151E-07_JPRB, 0.96515883E-07_JPRB, 0.10574809E-06_JPRB, 0.11710899E-06_JPRB, 0.12999820E-06_JPRB, &
  & 0.14417165E-06_JPRB, 0.15988638E-06_JPRB, 0.17790593E-06_JPRB, 0.19942638E-06_JPRB, 0.22606700E-06_JPRB, 0.25935176E-06_JPRB, &
  & 0.30034658E-06_JPRB, 0.34903169E-06_JPRB, 0.40432602E-06_JPRB, 0.46469705E-06_JPRB, 0.52912560E-06_JPRB, 0.59865181E-06_JPRB, &
  & 0.67439890E-06_JPRB, 0.75587883E-06_JPRB, 0.84021531E-06_JPRB, 0.92249451E-06_JPRB, 0.99839747E-06_JPRB, 0.10675441E-05_JPRB, &
  & 0.11309302E-05_JPRB, 0.11912817E-05_JPRB, 0.12510209E-05_JPRB, 0.13117791E-05_JPRB, 0.13737958E-05_JPRB, 0.14366592E-05_JPRB, &
  & 0.15002561E-05_JPRB, 0.15673381E-05_JPRB, 0.16485208E-05_JPRB, 0.18053310E-05_JPRB /)

RGHG7(:,43, 3) = (/ &
  & 0.75886970E-06_JPRB, 0.70926967E-06_JPRB, 0.68362561E-06_JPRB, 0.66055674E-06_JPRB, 0.63739623E-06_JPRB, 0.61556034E-06_JPRB, &
  & 0.59611006E-06_JPRB, 0.57940110E-06_JPRB, 0.56441934E-06_JPRB, 0.54970093E-06_JPRB, 0.53378068E-06_JPRB, 0.51464900E-06_JPRB, &
  & 0.48961340E-06_JPRB, 0.45637341E-06_JPRB, 0.41364618E-06_JPRB, 0.36364852E-06_JPRB, 0.31040369E-06_JPRB, 0.25888187E-06_JPRB, &
  & 0.21402825E-06_JPRB, 0.17805122E-06_JPRB, 0.15061889E-06_JPRB, 0.13034972E-06_JPRB, 0.11539107E-06_JPRB, 0.10443086E-06_JPRB, &
  & 0.96471609E-07_JPRB, 0.90102269E-07_JPRB, 0.85455852E-07_JPRB, 0.81615916E-07_JPRB, 0.78963261E-07_JPRB, 0.77833405E-07_JPRB, &
  & 0.78693112E-07_JPRB, 0.82005300E-07_JPRB, 0.87998359E-07_JPRB, 0.96543936E-07_JPRB, 0.10710107E-06_JPRB, 0.11912090E-06_JPRB, &
  & 0.13228848E-06_JPRB, 0.14683906E-06_JPRB, 0.16340421E-06_JPRB, 0.18303703E-06_JPRB, 0.20704992E-06_JPRB, 0.23679448E-06_JPRB, &
  & 0.27308494E-06_JPRB, 0.31618694E-06_JPRB, 0.36521925E-06_JPRB, 0.41876717E-06_JPRB, 0.47643712E-06_JPRB, 0.53884440E-06_JPRB, &
  & 0.60748073E-06_JPRB, 0.68272823E-06_JPRB, 0.76174621E-06_JPRB, 0.83889830E-06_JPRB, 0.91022451E-06_JPRB, 0.97376119E-06_JPRB, &
  & 0.10312581E-05_JPRB, 0.10850080E-05_JPRB, 0.11373722E-05_JPRB, 0.11896012E-05_JPRB, 0.12418941E-05_JPRB, 0.12940093E-05_JPRB, &
  & 0.13463549E-05_JPRB, 0.14018010E-05_JPRB, 0.14698392E-05_JPRB, 0.16028880E-05_JPRB /)

RGHG7(:,44, 3) = (/ &
  & 0.68287295E-06_JPRB, 0.63891736E-06_JPRB, 0.61562190E-06_JPRB, 0.59392278E-06_JPRB, 0.57169575E-06_JPRB, 0.55007803E-06_JPRB, &
  & 0.53151410E-06_JPRB, 0.51570237E-06_JPRB, 0.50229659E-06_JPRB, 0.48946742E-06_JPRB, 0.47584783E-06_JPRB, 0.45932831E-06_JPRB, &
  & 0.43764982E-06_JPRB, 0.40756566E-06_JPRB, 0.36830835E-06_JPRB, 0.32162581E-06_JPRB, 0.27253327E-06_JPRB, 0.22695947E-06_JPRB, &
  & 0.18851426E-06_JPRB, 0.15861872E-06_JPRB, 0.13573332E-06_JPRB, 0.11872089E-06_JPRB, 0.10580587E-06_JPRB, 0.96266440E-07_JPRB, &
  & 0.89017291E-07_JPRB, 0.83243755E-07_JPRB, 0.78870848E-07_JPRB, 0.75224087E-07_JPRB, 0.72681210E-07_JPRB, 0.71536974E-07_JPRB, &
  & 0.72268847E-07_JPRB, 0.75275850E-07_JPRB, 0.80817799E-07_JPRB, 0.88776702E-07_JPRB, 0.98708419E-07_JPRB, 0.11002480E-06_JPRB, &
  & 0.12241476E-06_JPRB, 0.13600780E-06_JPRB, 0.15136131E-06_JPRB, 0.16931197E-06_JPRB, 0.19096994E-06_JPRB, 0.21732647E-06_JPRB, &
  & 0.24910037E-06_JPRB, 0.28660230E-06_JPRB, 0.32956299E-06_JPRB, 0.37699778E-06_JPRB, 0.42819971E-06_JPRB, 0.48406389E-06_JPRB, &
  & 0.54611269E-06_JPRB, 0.61493461E-06_JPRB, 0.68773619E-06_JPRB, 0.75951982E-06_JPRB, 0.82486497E-06_JPRB, 0.88299259E-06_JPRB, &
  & 0.93476757E-06_JPRB, 0.98250280E-06_JPRB, 0.10283765E-05_JPRB, 0.10731912E-05_JPRB, 0.11170454E-05_JPRB, 0.11599176E-05_JPRB, &
  & 0.12025379E-05_JPRB, 0.12477276E-05_JPRB, 0.13035727E-05_JPRB, 0.14148072E-05_JPRB /)

RGHG7(:,45, 3) = (/ &
  & 0.61420099E-06_JPRB, 0.57528763E-06_JPRB, 0.55347112E-06_JPRB, 0.53346866E-06_JPRB, 0.51160634E-06_JPRB, 0.49068638E-06_JPRB, &
  & 0.47220817E-06_JPRB, 0.45766930E-06_JPRB, 0.44524353E-06_JPRB, 0.43411964E-06_JPRB, 0.42231795E-06_JPRB, 0.40826524E-06_JPRB, &
  & 0.38906705E-06_JPRB, 0.36223906E-06_JPRB, 0.32567064E-06_JPRB, 0.28271197E-06_JPRB, 0.23861790E-06_JPRB, 0.19915515E-06_JPRB, &
  & 0.16721776E-06_JPRB, 0.14262422E-06_JPRB, 0.12366593E-06_JPRB, 0.10926957E-06_JPRB, 0.97940934E-07_JPRB, 0.89474753E-07_JPRB, &
  & 0.82703224E-07_JPRB, 0.77382609E-07_JPRB, 0.73176068E-07_JPRB, 0.69644237E-07_JPRB, 0.67189276E-07_JPRB, 0.66061972E-07_JPRB, &
  & 0.66730564E-07_JPRB, 0.69516084E-07_JPRB, 0.74678269E-07_JPRB, 0.82166700E-07_JPRB, 0.91575700E-07_JPRB, 0.10234793E-06_JPRB, &
  & 0.11410634E-06_JPRB, 0.12693455E-06_JPRB, 0.14124319E-06_JPRB, 0.15774077E-06_JPRB, 0.17721385E-06_JPRB, 0.20040417E-06_JPRB, &
  & 0.22770435E-06_JPRB, 0.25957169E-06_JPRB, 0.29609424E-06_JPRB, 0.33705462E-06_JPRB, 0.38213591E-06_JPRB, 0.43188720E-06_JPRB, &
  & 0.48794726E-06_JPRB, 0.55043392E-06_JPRB, 0.61717981E-06_JPRB, 0.68188439E-06_JPRB, 0.74141298E-06_JPRB, 0.79344568E-06_JPRB, &
  & 0.83970747E-06_JPRB, 0.88214165E-06_JPRB, 0.92232233E-06_JPRB, 0.96091969E-06_JPRB, 0.99781050E-06_JPRB, 0.10330449E-05_JPRB, &
  & 0.10676328E-05_JPRB, 0.11042558E-05_JPRB, 0.11499047E-05_JPRB, 0.12415733E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART6',0,ZHOOK_HANDLE)



RGHG7(:,46, 3) = (/ &
  & 0.55235546E-06_JPRB, 0.51676011E-06_JPRB, 0.49694381E-06_JPRB, 0.47732584E-06_JPRB, 0.45641650E-06_JPRB, 0.43537676E-06_JPRB, &
  & 0.41751662E-06_JPRB, 0.40343701E-06_JPRB, 0.39218949E-06_JPRB, 0.38214444E-06_JPRB, 0.37188906E-06_JPRB, 0.35958246E-06_JPRB, &
  & 0.34284429E-06_JPRB, 0.31847958E-06_JPRB, 0.28510019E-06_JPRB, 0.24591324E-06_JPRB, 0.20753586E-06_JPRB, 0.17506552E-06_JPRB, &
  & 0.14928109E-06_JPRB, 0.12949796E-06_JPRB, 0.11378218E-06_JPRB, 0.10148202E-06_JPRB, 0.91417917E-07_JPRB, 0.83751679E-07_JPRB, &
  & 0.77310119E-07_JPRB, 0.72315650E-07_JPRB, 0.68157874E-07_JPRB, 0.64733811E-07_JPRB, 0.62355760E-07_JPRB, 0.61272623E-07_JPRB, &
  & 0.61926514E-07_JPRB, 0.64555763E-07_JPRB, 0.69432780E-07_JPRB, 0.76524785E-07_JPRB, 0.85517136E-07_JPRB, 0.95839376E-07_JPRB, &
  & 0.10710892E-06_JPRB, 0.11928836E-06_JPRB, 0.13274195E-06_JPRB, 0.14793066E-06_JPRB, 0.16547553E-06_JPRB, 0.18565747E-06_JPRB, &
  & 0.20866416E-06_JPRB, 0.23466798E-06_JPRB, 0.26433261E-06_JPRB, 0.29807256E-06_JPRB, 0.33637937E-06_JPRB, 0.38021810E-06_JPRB, &
  & 0.43039998E-06_JPRB, 0.48756471E-06_JPRB, 0.54732152E-06_JPRB, 0.60611717E-06_JPRB, 0.65822837E-06_JPRB, 0.70463449E-06_JPRB, &
  & 0.74558199E-06_JPRB, 0.78302014E-06_JPRB, 0.81848168E-06_JPRB, 0.85184575E-06_JPRB, 0.88315267E-06_JPRB, 0.91230203E-06_JPRB, &
  & 0.94058583E-06_JPRB, 0.97026680E-06_JPRB, 0.10074530E-05_JPRB, 0.10828952E-05_JPRB /)

RGHG7(:,47, 3) = (/ &
  & 0.49628926E-06_JPRB, 0.46316606E-06_JPRB, 0.44397902E-06_JPRB, 0.42534256E-06_JPRB, 0.40438010E-06_JPRB, 0.38353366E-06_JPRB, &
  & 0.36580309E-06_JPRB, 0.35230468E-06_JPRB, 0.34180101E-06_JPRB, 0.33269058E-06_JPRB, 0.32354964E-06_JPRB, 0.31262809E-06_JPRB, &
  & 0.29770050E-06_JPRB, 0.27559736E-06_JPRB, 0.24562456E-06_JPRB, 0.21142468E-06_JPRB, 0.18002774E-06_JPRB, 0.15438019E-06_JPRB, &
  & 0.13444055E-06_JPRB, 0.11863729E-06_JPRB, 0.10567425E-06_JPRB, 0.95007778E-07_JPRB, 0.85991246E-07_JPRB, 0.78850341E-07_JPRB, &
  & 0.72667255E-07_JPRB, 0.67867305E-07_JPRB, 0.63734802E-07_JPRB, 0.60377879E-07_JPRB, 0.58079582E-07_JPRB, 0.57081241E-07_JPRB, &
  & 0.57751073E-07_JPRB, 0.60304238E-07_JPRB, 0.64939030E-07_JPRB, 0.71733623E-07_JPRB, 0.80374377E-07_JPRB, 0.90344955E-07_JPRB, &
  & 0.10118930E-06_JPRB, 0.11285984E-06_JPRB, 0.12554196E-06_JPRB, 0.13964447E-06_JPRB, 0.15539931E-06_JPRB, 0.17289769E-06_JPRB, &
  & 0.19178140E-06_JPRB, 0.21211702E-06_JPRB, 0.23433542E-06_JPRB, 0.25989073E-06_JPRB, 0.29023832E-06_JPRB, 0.32706478E-06_JPRB, &
  & 0.37202483E-06_JPRB, 0.42325215E-06_JPRB, 0.47825301E-06_JPRB, 0.52920910E-06_JPRB, 0.57585413E-06_JPRB, 0.61599280E-06_JPRB, &
  & 0.65206189E-06_JPRB, 0.68519614E-06_JPRB, 0.71637288E-06_JPRB, 0.74558881E-06_JPRB, 0.77237212E-06_JPRB, 0.79686322E-06_JPRB, &
  & 0.82015356E-06_JPRB, 0.84454479E-06_JPRB, 0.87509181E-06_JPRB, 0.93740698E-06_JPRB /)

RGHG7(:,48, 3) = (/ &
  & 0.44432596E-06_JPRB, 0.41322781E-06_JPRB, 0.39434272E-06_JPRB, 0.37575396E-06_JPRB, 0.35472129E-06_JPRB, 0.33371106E-06_JPRB, &
  & 0.31602468E-06_JPRB, 0.30300106E-06_JPRB, 0.29305750E-06_JPRB, 0.28469967E-06_JPRB, 0.27635591E-06_JPRB, 0.26656980E-06_JPRB, &
  & 0.25309691E-06_JPRB, 0.23389225E-06_JPRB, 0.20771064E-06_JPRB, 0.18047481E-06_JPRB, 0.15635673E-06_JPRB, 0.13739279E-06_JPRB, &
  & 0.12226349E-06_JPRB, 0.10977593E-06_JPRB, 0.99025755E-07_JPRB, 0.89627399E-07_JPRB, 0.81457223E-07_JPRB, 0.74600180E-07_JPRB, &
  & 0.68654806E-07_JPRB, 0.63908345E-07_JPRB, 0.59779516E-07_JPRB, 0.56500266E-07_JPRB, 0.54298329E-07_JPRB, 0.53420258E-07_JPRB, &
  & 0.54125138E-07_JPRB, 0.56640147E-07_JPRB, 0.61104181E-07_JPRB, 0.67662306E-07_JPRB, 0.76015361E-07_JPRB, 0.85676461E-07_JPRB, &
  & 0.96182326E-07_JPRB, 0.10738571E-06_JPRB, 0.11946251E-06_JPRB, 0.13255976E-06_JPRB, 0.14681066E-06_JPRB, 0.16184998E-06_JPRB, &
  & 0.17709037E-06_JPRB, 0.19209362E-06_JPRB, 0.20737198E-06_JPRB, 0.22427913E-06_JPRB, 0.24564403E-06_JPRB, 0.27419119E-06_JPRB, &
  & 0.31166570E-06_JPRB, 0.35803606E-06_JPRB, 0.40573184E-06_JPRB, 0.45183609E-06_JPRB, 0.49146007E-06_JPRB, 0.52685795E-06_JPRB, &
  & 0.55841622E-06_JPRB, 0.58769893E-06_JPRB, 0.61550060E-06_JPRB, 0.64126999E-06_JPRB, 0.66462979E-06_JPRB, 0.68556449E-06_JPRB, &
  & 0.70520286E-06_JPRB, 0.72555338E-06_JPRB, 0.75110256E-06_JPRB, 0.80350060E-06_JPRB /)

RGHG7(:,49, 3) = (/ &
  & 0.39668979E-06_JPRB, 0.36540482E-06_JPRB, 0.34696583E-06_JPRB, 0.32768193E-06_JPRB, 0.30631401E-06_JPRB, 0.28466727E-06_JPRB, &
  & 0.26715242E-06_JPRB, 0.25446974E-06_JPRB, 0.24514281E-06_JPRB, 0.23742554E-06_JPRB, 0.22987314E-06_JPRB, 0.22127645E-06_JPRB, &
  & 0.20980711E-06_JPRB, 0.19372401E-06_JPRB, 0.17423469E-06_JPRB, 0.15403749E-06_JPRB, 0.13727139E-06_JPRB, 0.12363569E-06_JPRB, &
  & 0.11242758E-06_JPRB, 0.10250854E-06_JPRB, 0.93537899E-07_JPRB, 0.85106912E-07_JPRB, 0.77613571E-07_JPRB, 0.70863834E-07_JPRB, &
  & 0.65104267E-07_JPRB, 0.60326528E-07_JPRB, 0.56220934E-07_JPRB, 0.53040687E-07_JPRB, 0.50956022E-07_JPRB, 0.50220756E-07_JPRB, &
  & 0.50979136E-07_JPRB, 0.53474185E-07_JPRB, 0.57822298E-07_JPRB, 0.64176724E-07_JPRB, 0.72294995E-07_JPRB, 0.81684711E-07_JPRB, &
  & 0.91871321E-07_JPRB, 0.10270517E-06_JPRB, 0.11421682E-06_JPRB, 0.12650663E-06_JPRB, 0.13940773E-06_JPRB, 0.15234693E-06_JPRB, &
  & 0.16441059E-06_JPRB, 0.17499823E-06_JPRB, 0.18430320E-06_JPRB, 0.19411972E-06_JPRB, 0.20689257E-06_JPRB, 0.22615531E-06_JPRB, &
  & 0.25494475E-06_JPRB, 0.29165395E-06_JPRB, 0.33302132E-06_JPRB, 0.37076970E-06_JPRB, 0.40499950E-06_JPRB, 0.43537281E-06_JPRB, &
  & 0.46315188E-06_JPRB, 0.48927927E-06_JPRB, 0.51433068E-06_JPRB, 0.53761818E-06_JPRB, 0.55847266E-06_JPRB, 0.57696013E-06_JPRB, &
  & 0.59395768E-06_JPRB, 0.61158522E-06_JPRB, 0.63366878E-06_JPRB, 0.67886077E-06_JPRB /)

RGHG7(:,50, 3) = (/ &
  & 0.35139055E-06_JPRB, 0.32009231E-06_JPRB, 0.30084286E-06_JPRB, 0.28086146E-06_JPRB, 0.25829095E-06_JPRB, 0.23602570E-06_JPRB, &
  & 0.21876913E-06_JPRB, 0.20679161E-06_JPRB, 0.19839618E-06_JPRB, 0.19165610E-06_JPRB, 0.18557958E-06_JPRB, 0.17865035E-06_JPRB, &
  & 0.17035488E-06_JPRB, 0.15948811E-06_JPRB, 0.14638640E-06_JPRB, 0.13356416E-06_JPRB, 0.12235796E-06_JPRB, 0.11284342E-06_JPRB, &
  & 0.10450835E-06_JPRB, 0.96557017E-07_JPRB, 0.88955204E-07_JPRB, 0.81322881E-07_JPRB, 0.74241633E-07_JPRB, 0.67553010E-07_JPRB, &
  & 0.61884911E-07_JPRB, 0.57037248E-07_JPRB, 0.52997578E-07_JPRB, 0.49944124E-07_JPRB, 0.48008832E-07_JPRB, 0.47412989E-07_JPRB, &
  & 0.48251025E-07_JPRB, 0.50717887E-07_JPRB, 0.54992586E-07_JPRB, 0.61177268E-07_JPRB, 0.69079150E-07_JPRB, 0.78209851E-07_JPRB, &
  & 0.88117979E-07_JPRB, 0.98602847E-07_JPRB, 0.10966475E-06_JPRB, 0.12124318E-06_JPRB, 0.13299876E-06_JPRB, 0.14414576E-06_JPRB, &
  & 0.15355160E-06_JPRB, 0.16060444E-06_JPRB, 0.16576718E-06_JPRB, 0.17049058E-06_JPRB, 0.17740052E-06_JPRB, 0.18892530E-06_JPRB, &
  & 0.20758606E-06_JPRB, 0.23407735E-06_JPRB, 0.26277650E-06_JPRB, 0.29154799E-06_JPRB, 0.31820574E-06_JPRB, 0.34274802E-06_JPRB, &
  & 0.36649135E-06_JPRB, 0.38958061E-06_JPRB, 0.41211783E-06_JPRB, 0.43359026E-06_JPRB, 0.45277517E-06_JPRB, 0.46957689E-06_JPRB, &
  & 0.48502869E-06_JPRB, 0.50089159E-06_JPRB, 0.52067412E-06_JPRB, 0.56146564E-06_JPRB /)

RGHG7(:,51, 3) = (/ &
  & 0.30813663E-06_JPRB, 0.27654318E-06_JPRB, 0.25606298E-06_JPRB, 0.23526400E-06_JPRB, 0.21134552E-06_JPRB, 0.18926340E-06_JPRB, &
  & 0.17315026E-06_JPRB, 0.16312633E-06_JPRB, 0.15651786E-06_JPRB, 0.15181776E-06_JPRB, 0.14767313E-06_JPRB, 0.14375254E-06_JPRB, &
  & 0.13892803E-06_JPRB, 0.13305656E-06_JPRB, 0.12586143E-06_JPRB, 0.11819545E-06_JPRB, 0.11102103E-06_JPRB, 0.10436369E-06_JPRB, &
  & 0.98024522E-07_JPRB, 0.91619853E-07_JPRB, 0.84992891E-07_JPRB, 0.78064645E-07_JPRB, 0.71180239E-07_JPRB, 0.64582288E-07_JPRB, &
  & 0.58881771E-07_JPRB, 0.54007373E-07_JPRB, 0.50065651E-07_JPRB, 0.47179757E-07_JPRB, 0.45409671E-07_JPRB, 0.44937046E-07_JPRB, &
  & 0.45866013E-07_JPRB, 0.48316327E-07_JPRB, 0.52527657E-07_JPRB, 0.58570354E-07_JPRB, 0.66261627E-07_JPRB, 0.75145138E-07_JPRB, &
  & 0.84780616E-07_JPRB, 0.94960384E-07_JPRB, 0.10562025E-06_JPRB, 0.11658963E-06_JPRB, 0.12736898E-06_JPRB, 0.13693082E-06_JPRB, &
  & 0.14415778E-06_JPRB, 0.14861456E-06_JPRB, 0.15100512E-06_JPRB, 0.15296204E-06_JPRB, 0.15616583E-06_JPRB, 0.16281577E-06_JPRB, &
  & 0.17419782E-06_JPRB, 0.18934999E-06_JPRB, 0.20703544E-06_JPRB, 0.22442703E-06_JPRB, 0.24109553E-06_JPRB, 0.25848604E-06_JPRB, &
  & 0.27588507E-06_JPRB, 0.29416404E-06_JPRB, 0.31349214E-06_JPRB, 0.33225720E-06_JPRB, 0.34967667E-06_JPRB, 0.36506734E-06_JPRB, &
  & 0.37923590E-06_JPRB, 0.39381587E-06_JPRB, 0.41222449E-06_JPRB, 0.44983955E-06_JPRB /)

RGHG7(:,52, 3) = (/ &
  & 0.26780296E-06_JPRB, 0.23399063E-06_JPRB, 0.21435740E-06_JPRB, 0.19184195E-06_JPRB, 0.16894907E-06_JPRB, 0.14879292E-06_JPRB, &
  & 0.13660647E-06_JPRB, 0.12961976E-06_JPRB, 0.12567880E-06_JPRB, 0.12296677E-06_JPRB, 0.12113037E-06_JPRB, 0.11918620E-06_JPRB, &
  & 0.11731957E-06_JPRB, 0.11468162E-06_JPRB, 0.11124144E-06_JPRB, 0.10692746E-06_JPRB, 0.10234212E-06_JPRB, 0.97603447E-07_JPRB, &
  & 0.92672387E-07_JPRB, 0.87388891E-07_JPRB, 0.81488430E-07_JPRB, 0.75125548E-07_JPRB, 0.68328958E-07_JPRB, 0.61839373E-07_JPRB, &
  & 0.56064241E-07_JPRB, 0.51221946E-07_JPRB, 0.47420922E-07_JPRB, 0.44708848E-07_JPRB, 0.43116120E-07_JPRB, 0.42753516E-07_JPRB, &
  & 0.43759158E-07_JPRB, 0.46224674E-07_JPRB, 0.50358345E-07_JPRB, 0.56284613E-07_JPRB, 0.63764809E-07_JPRB, 0.72410998E-07_JPRB, &
  & 0.81773891E-07_JPRB, 0.91658855E-07_JPRB, 0.10195252E-06_JPRB, 0.11237181E-06_JPRB, 0.12225006E-06_JPRB, 0.13045428E-06_JPRB, &
  & 0.13588797E-06_JPRB, 0.13849969E-06_JPRB, 0.13929329E-06_JPRB, 0.13969756E-06_JPRB, 0.14120434E-06_JPRB, 0.14498164E-06_JPRB, &
  & 0.15132777E-06_JPRB, 0.16003057E-06_JPRB, 0.16907788E-06_JPRB, 0.17783941E-06_JPRB, 0.18701509E-06_JPRB, 0.19616661E-06_JPRB, &
  & 0.20675446E-06_JPRB, 0.21873664E-06_JPRB, 0.23197485E-06_JPRB, 0.24640181E-06_JPRB, 0.26008081E-06_JPRB, 0.27263118E-06_JPRB, &
  & 0.28454073E-06_JPRB, 0.29703253E-06_JPRB, 0.31312874E-06_JPRB, 0.34731295E-06_JPRB /)

RGHG7(:,53, 3) = (/ &
  & 0.22910741E-06_JPRB, 0.19655232E-06_JPRB, 0.17481386E-06_JPRB, 0.15517524E-06_JPRB, 0.13461346E-06_JPRB, 0.12019285E-06_JPRB, &
  & 0.11241672E-06_JPRB, 0.10855646E-06_JPRB, 0.10651351E-06_JPRB, 0.10530400E-06_JPRB, 0.10442019E-06_JPRB, 0.10384703E-06_JPRB, &
  & 0.10315139E-06_JPRB, 0.10228744E-06_JPRB, 0.10075702E-06_JPRB, 0.98499875E-07_JPRB, 0.95508348E-07_JPRB, 0.92092201E-07_JPRB, &
  & 0.88096691E-07_JPRB, 0.83624734E-07_JPRB, 0.78296857E-07_JPRB, 0.72263425E-07_JPRB, 0.65664508E-07_JPRB, 0.59199017E-07_JPRB, &
  & 0.53449394E-07_JPRB, 0.48692218E-07_JPRB, 0.45038895E-07_JPRB, 0.42506727E-07_JPRB, 0.41080789E-07_JPRB, 0.40827516E-07_JPRB, &
  & 0.41890914E-07_JPRB, 0.44387143E-07_JPRB, 0.48452968E-07_JPRB, 0.54261868E-07_JPRB, 0.61538458E-07_JPRB, 0.69944910E-07_JPRB, &
  & 0.79028482E-07_JPRB, 0.88628312E-07_JPRB, 0.98533938E-07_JPRB, 0.10841474E-06_JPRB, 0.11744775E-06_JPRB, 0.12445074E-06_JPRB, &
  & 0.12849493E-06_JPRB, 0.12986422E-06_JPRB, 0.12980126E-06_JPRB, 0.12947154E-06_JPRB, 0.13011872E-06_JPRB, 0.13236917E-06_JPRB, &
  & 0.13614964E-06_JPRB, 0.14092356E-06_JPRB, 0.14562210E-06_JPRB, 0.15024347E-06_JPRB, 0.15451876E-06_JPRB, 0.15944057E-06_JPRB, &
  & 0.16483403E-06_JPRB, 0.17133928E-06_JPRB, 0.17931653E-06_JPRB, 0.18795268E-06_JPRB, 0.19677290E-06_JPRB, 0.20510736E-06_JPRB, &
  & 0.21310605E-06_JPRB, 0.22197830E-06_JPRB, 0.23404033E-06_JPRB, 0.26137269E-06_JPRB /)

RGHG7(:,54, 3) = (/ &
  & 0.19413166E-06_JPRB, 0.16099112E-06_JPRB, 0.14312280E-06_JPRB, 0.12567183E-06_JPRB, 0.11136832E-06_JPRB, 0.10215834E-06_JPRB, &
  & 0.97913684E-07_JPRB, 0.95873396E-07_JPRB, 0.94904941E-07_JPRB, 0.94309385E-07_JPRB, 0.94030803E-07_JPRB, 0.93797986E-07_JPRB, &
  & 0.93696030E-07_JPRB, 0.93532684E-07_JPRB, 0.93037436E-07_JPRB, 0.91879471E-07_JPRB, 0.89963763E-07_JPRB, 0.87398035E-07_JPRB, &
  & 0.84131727E-07_JPRB, 0.80128252E-07_JPRB, 0.75282479E-07_JPRB, 0.69444482E-07_JPRB, 0.63046393E-07_JPRB, 0.56695374E-07_JPRB, &
  & 0.51024880E-07_JPRB, 0.46406679E-07_JPRB, 0.42903864E-07_JPRB, 0.40528970E-07_JPRB, 0.39265437E-07_JPRB, 0.39127364E-07_JPRB, &
  & 0.40241449E-07_JPRB, 0.42751516E-07_JPRB, 0.46786539E-07_JPRB, 0.52430870E-07_JPRB, 0.59547958E-07_JPRB, 0.67685193E-07_JPRB, &
  & 0.76509529E-07_JPRB, 0.85773927E-07_JPRB, 0.95277812E-07_JPRB, 0.10457386E-06_JPRB, 0.11280305E-06_JPRB, 0.11876853E-06_JPRB, &
  & 0.12178573E-06_JPRB, 0.12241304E-06_JPRB, 0.12186914E-06_JPRB, 0.12124214E-06_JPRB, 0.12162548E-06_JPRB, 0.12296239E-06_JPRB, &
  & 0.12544227E-06_JPRB, 0.12833027E-06_JPRB, 0.13099545E-06_JPRB, 0.13342117E-06_JPRB, 0.13582344E-06_JPRB, 0.13830591E-06_JPRB, &
  & 0.14130987E-06_JPRB, 0.14491383E-06_JPRB, 0.14923427E-06_JPRB, 0.15424418E-06_JPRB, 0.15921380E-06_JPRB, 0.16384534E-06_JPRB, &
  & 0.16840582E-06_JPRB, 0.17340670E-06_JPRB, 0.18054587E-06_JPRB, 0.19800109E-06_JPRB /)

RGHG7(:,55, 3) = (/ &
  & 0.16281388E-06_JPRB, 0.13272320E-06_JPRB, 0.11749654E-06_JPRB, 0.10555461E-06_JPRB, 0.96424408E-07_JPRB, 0.91098492E-07_JPRB, &
  & 0.88801784E-07_JPRB, 0.87750585E-07_JPRB, 0.87267622E-07_JPRB, 0.87008338E-07_JPRB, 0.86867253E-07_JPRB, 0.86865235E-07_JPRB, &
  & 0.86889564E-07_JPRB, 0.86985480E-07_JPRB, 0.86921972E-07_JPRB, 0.86468056E-07_JPRB, 0.85240465E-07_JPRB, 0.83271928E-07_JPRB, &
  & 0.80511093E-07_JPRB, 0.76875871E-07_JPRB, 0.72278027E-07_JPRB, 0.66689573E-07_JPRB, 0.60467947E-07_JPRB, 0.54290339E-07_JPRB, &
  & 0.48811529E-07_JPRB, 0.44326800E-07_JPRB, 0.40971898E-07_JPRB, 0.38754106E-07_JPRB, 0.37634656E-07_JPRB, 0.37614971E-07_JPRB, &
  & 0.38788698E-07_JPRB, 0.41290807E-07_JPRB, 0.45303718E-07_JPRB, 0.50786014E-07_JPRB, 0.57715233E-07_JPRB, 0.65593241E-07_JPRB, &
  & 0.74132764E-07_JPRB, 0.83046864E-07_JPRB, 0.92097721E-07_JPRB, 0.10077692E-06_JPRB, 0.10820822E-06_JPRB, 0.11335862E-06_JPRB, &
  & 0.11567679E-06_JPRB, 0.11582256E-06_JPRB, 0.11510878E-06_JPRB, 0.11439484E-06_JPRB, 0.11465954E-06_JPRB, 0.11561252E-06_JPRB, &
  & 0.11755613E-06_JPRB, 0.11934613E-06_JPRB, 0.12113540E-06_JPRB, 0.12263720E-06_JPRB, 0.12402641E-06_JPRB, 0.12563244E-06_JPRB, &
  & 0.12729964E-06_JPRB, 0.12941732E-06_JPRB, 0.13195564E-06_JPRB, 0.13481322E-06_JPRB, 0.13769991E-06_JPRB, 0.14034337E-06_JPRB, &
  & 0.14278989E-06_JPRB, 0.14557189E-06_JPRB, 0.14948058E-06_JPRB, 0.16003217E-06_JPRB /)

RGHG7(:,56, 3) = (/ &
  & 0.13467944E-06_JPRB, 0.11097191E-06_JPRB, 0.99767732E-07_JPRB, 0.92459615E-07_JPRB, 0.86854520E-07_JPRB, 0.83856747E-07_JPRB, &
  & 0.82563382E-07_JPRB, 0.82014274E-07_JPRB, 0.81727222E-07_JPRB, 0.81614331E-07_JPRB, 0.81521783E-07_JPRB, 0.81545508E-07_JPRB, &
  & 0.81597086E-07_JPRB, 0.81771255E-07_JPRB, 0.81889503E-07_JPRB, 0.81757683E-07_JPRB, 0.81034372E-07_JPRB, 0.79504382E-07_JPRB, &
  & 0.77093119E-07_JPRB, 0.73758272E-07_JPRB, 0.69343358E-07_JPRB, 0.63940888E-07_JPRB, 0.57975502E-07_JPRB, 0.52034896E-07_JPRB, &
  & 0.46737803E-07_JPRB, 0.42425977E-07_JPRB, 0.39222062E-07_JPRB, 0.37150137E-07_JPRB, 0.36168117E-07_JPRB, 0.36260818E-07_JPRB, &
  & 0.37506560E-07_JPRB, 0.39986823E-07_JPRB, 0.43938357E-07_JPRB, 0.49313556E-07_JPRB, 0.55973128E-07_JPRB, 0.63620739E-07_JPRB, &
  & 0.71845555E-07_JPRB, 0.80382740E-07_JPRB, 0.88934044E-07_JPRB, 0.96981303E-07_JPRB, 0.10368816E-06_JPRB, 0.10818430E-06_JPRB, &
  & 0.11004766E-06_JPRB, 0.10995235E-06_JPRB, 0.10915187E-06_JPRB, 0.10850742E-06_JPRB, 0.10875875E-06_JPRB, 0.10962761E-06_JPRB, &
  & 0.11123059E-06_JPRB, 0.11258422E-06_JPRB, 0.11396132E-06_JPRB, 0.11491587E-06_JPRB, 0.11603845E-06_JPRB, 0.11699500E-06_JPRB, &
  & 0.11817654E-06_JPRB, 0.11951848E-06_JPRB, 0.12112058E-06_JPRB, 0.12301868E-06_JPRB, 0.12478010E-06_JPRB, 0.12632860E-06_JPRB, &
  & 0.12773653E-06_JPRB, 0.12909720E-06_JPRB, 0.13093747E-06_JPRB, 0.13617955E-06_JPRB /)

RGHG7(:,57, 3) = (/ &
  & 0.11348932E-06_JPRB, 0.94645650E-07_JPRB, 0.88411980E-07_JPRB, 0.83527119E-07_JPRB, 0.80489791E-07_JPRB, 0.78657742E-07_JPRB, &
  & 0.77884792E-07_JPRB, 0.77574512E-07_JPRB, 0.77365470E-07_JPRB, 0.77298239E-07_JPRB, 0.77204263E-07_JPRB, 0.77225181E-07_JPRB, &
  & 0.77239115E-07_JPRB, 0.77366856E-07_JPRB, 0.77514677E-07_JPRB, 0.77566696E-07_JPRB, 0.77125755E-07_JPRB, 0.75938118E-07_JPRB, &
  & 0.73802809E-07_JPRB, 0.70668314E-07_JPRB, 0.66448365E-07_JPRB, 0.61284204E-07_JPRB, 0.55538283E-07_JPRB, 0.49888822E-07_JPRB, &
  & 0.44802366E-07_JPRB, 0.40665839E-07_JPRB, 0.37629174E-07_JPRB, 0.35708435E-07_JPRB, 0.34852764E-07_JPRB, 0.35045868E-07_JPRB, &
  & 0.36353967E-07_JPRB, 0.38827235E-07_JPRB, 0.42654744E-07_JPRB, 0.47951900E-07_JPRB, 0.54302745E-07_JPRB, 0.61707233E-07_JPRB, &
  & 0.69587756E-07_JPRB, 0.77720870E-07_JPRB, 0.85780300E-07_JPRB, 0.93181299E-07_JPRB, 0.99261179E-07_JPRB, 0.10325336E-06_JPRB, &
  & 0.10485530E-06_JPRB, 0.10460928E-06_JPRB, 0.10383406E-06_JPRB, 0.10326959E-06_JPRB, 0.10357780E-06_JPRB, 0.10449986E-06_JPRB, &
  & 0.10598301E-06_JPRB, 0.10712973E-06_JPRB, 0.10827911E-06_JPRB, 0.10909108E-06_JPRB, 0.10995901E-06_JPRB, 0.11071783E-06_JPRB, &
  & 0.11160861E-06_JPRB, 0.11259109E-06_JPRB, 0.11380020E-06_JPRB, 0.11509869E-06_JPRB, 0.11636025E-06_JPRB, 0.11749155E-06_JPRB, &
  & 0.11839352E-06_JPRB, 0.11929242E-06_JPRB, 0.12015818E-06_JPRB, 0.12099034E-06_JPRB /)

RGHG7(:,58, 3) = (/ &
  & 0.95879869E-07_JPRB, 0.84787160E-07_JPRB, 0.80138186E-07_JPRB, 0.77691702E-07_JPRB, 0.75676887E-07_JPRB, 0.74627124E-07_JPRB, &
  & 0.74080965E-07_JPRB, 0.73872869E-07_JPRB, 0.73696903E-07_JPRB, 0.73629806E-07_JPRB, 0.73513121E-07_JPRB, 0.73507529E-07_JPRB, &
  & 0.73465266E-07_JPRB, 0.73550282E-07_JPRB, 0.73641701E-07_JPRB, 0.73696569E-07_JPRB, 0.73455197E-07_JPRB, 0.72453389E-07_JPRB, &
  & 0.70544431E-07_JPRB, 0.67634652E-07_JPRB, 0.63611225E-07_JPRB, 0.58680598E-07_JPRB, 0.53234551E-07_JPRB, 0.47814080E-07_JPRB, &
  & 0.42977124E-07_JPRB, 0.39040234E-07_JPRB, 0.36188922E-07_JPRB, 0.34421312E-07_JPRB, 0.33684646E-07_JPRB, 0.33960646E-07_JPRB, &
  & 0.35313565E-07_JPRB, 0.37773471E-07_JPRB, 0.41464826E-07_JPRB, 0.46594590E-07_JPRB, 0.52705118E-07_JPRB, 0.59803334E-07_JPRB, &
  & 0.67326297E-07_JPRB, 0.75050338E-07_JPRB, 0.82599890E-07_JPRB, 0.89441237E-07_JPRB, 0.94965145E-07_JPRB, 0.98569849E-07_JPRB, &
  & 0.99991574E-07_JPRB, 0.99722300E-07_JPRB, 0.98987748E-07_JPRB, 0.98539388E-07_JPRB, 0.98937477E-07_JPRB, 0.99975637E-07_JPRB, &
  & 0.10136784E-06_JPRB, 0.10254326E-06_JPRB, 0.10356973E-06_JPRB, 0.10432939E-06_JPRB, 0.10513546E-06_JPRB, 0.10578215E-06_JPRB, &
  & 0.10658864E-06_JPRB, 0.10738393E-06_JPRB, 0.10834380E-06_JPRB, 0.10941513E-06_JPRB, 0.11044919E-06_JPRB, 0.11132599E-06_JPRB, &
  & 0.11210832E-06_JPRB, 0.11291662E-06_JPRB, 0.11407755E-06_JPRB, 0.11696948E-06_JPRB /)

RGHG7(:,59, 3) = (/ &
  & 0.84364800E-07_JPRB, 0.77010469E-07_JPRB, 0.74857830E-07_JPRB, 0.73108801E-07_JPRB, 0.71978107E-07_JPRB, 0.71244543E-07_JPRB, &
  & 0.70853673E-07_JPRB, 0.70662338E-07_JPRB, 0.70495354E-07_JPRB, 0.70394925E-07_JPRB, 0.70273302E-07_JPRB, 0.70193231E-07_JPRB, &
  & 0.70118297E-07_JPRB, 0.70100228E-07_JPRB, 0.70122532E-07_JPRB, 0.70134270E-07_JPRB, 0.69929605E-07_JPRB, 0.69045484E-07_JPRB, &
  & 0.67371097E-07_JPRB, 0.64617922E-07_JPRB, 0.60831809E-07_JPRB, 0.56161291E-07_JPRB, 0.50976180E-07_JPRB, 0.45851856E-07_JPRB, &
  & 0.41251496E-07_JPRB, 0.37558063E-07_JPRB, 0.34904762E-07_JPRB, 0.33295784E-07_JPRB, 0.32670165E-07_JPRB, 0.33010789E-07_JPRB, &
  & 0.34376416E-07_JPRB, 0.36798692E-07_JPRB, 0.40377166E-07_JPRB, 0.45222137E-07_JPRB, 0.51162324E-07_JPRB, 0.57881326E-07_JPRB, &
  & 0.65050507E-07_JPRB, 0.72356755E-07_JPRB, 0.79441584E-07_JPRB, 0.85768086E-07_JPRB, 0.90842732E-07_JPRB, 0.94110945E-07_JPRB, &
  & 0.95450460E-07_JPRB, 0.95204783E-07_JPRB, 0.94548241E-07_JPRB, 0.94207898E-07_JPRB, 0.94675094E-07_JPRB, 0.95836626E-07_JPRB, &
  & 0.97272768E-07_JPRB, 0.98481436E-07_JPRB, 0.99496049E-07_JPRB, 0.10032231E-06_JPRB, 0.10105902E-06_JPRB, 0.10174094E-06_JPRB, &
  & 0.10245309E-06_JPRB, 0.10317149E-06_JPRB, 0.10405260E-06_JPRB, 0.10496498E-06_JPRB, 0.10584513E-06_JPRB, 0.10660394E-06_JPRB, &
  & 0.10723018E-06_JPRB, 0.10786184E-06_JPRB, 0.10853615E-06_JPRB, 0.11002304E-06_JPRB /)

RGHG7(:,60, 3) = (/ &
  & 0.76627721E-07_JPRB, 0.72209062E-07_JPRB, 0.70546726E-07_JPRB, 0.69645260E-07_JPRB, 0.68842674E-07_JPRB, 0.68322876E-07_JPRB, &
  & 0.67982207E-07_JPRB, 0.67783077E-07_JPRB, 0.67615474E-07_JPRB, 0.67462331E-07_JPRB, 0.67330433E-07_JPRB, 0.67183642E-07_JPRB, &
  & 0.67067944E-07_JPRB, 0.66951557E-07_JPRB, 0.66873099E-07_JPRB, 0.66791955E-07_JPRB, 0.66551706E-07_JPRB, 0.65773548E-07_JPRB, &
  & 0.64223187E-07_JPRB, 0.61646823E-07_JPRB, 0.58112462E-07_JPRB, 0.53682285E-07_JPRB, 0.48801564E-07_JPRB, 0.43964345E-07_JPRB, &
  & 0.39660922E-07_JPRB, 0.36225213E-07_JPRB, 0.33790265E-07_JPRB, 0.32340932E-07_JPRB, 0.31819027E-07_JPRB, 0.32204522E-07_JPRB, &
  & 0.33550947E-07_JPRB, 0.35900833E-07_JPRB, 0.39338229E-07_JPRB, 0.43910230E-07_JPRB, 0.49605621E-07_JPRB, 0.55956988E-07_JPRB, &
  & 0.62767626E-07_JPRB, 0.69678848E-07_JPRB, 0.76320205E-07_JPRB, 0.82215223E-07_JPRB, 0.86886139E-07_JPRB, 0.89910195E-07_JPRB, &
  & 0.91159116E-07_JPRB, 0.91005653E-07_JPRB, 0.90434128E-07_JPRB, 0.90200338E-07_JPRB, 0.90739590E-07_JPRB, 0.91984575E-07_JPRB, &
  & 0.93465538E-07_JPRB, 0.94822056E-07_JPRB, 0.95882683E-07_JPRB, 0.96778898E-07_JPRB, 0.97565369E-07_JPRB, 0.98268991E-07_JPRB, &
  & 0.98986114E-07_JPRB, 0.99711812E-07_JPRB, 0.10053754E-06_JPRB, 0.10138379E-06_JPRB, 0.10219721E-06_JPRB, 0.10287192E-06_JPRB, &
  & 0.10347426E-06_JPRB, 0.10407364E-06_JPRB, 0.10489443E-06_JPRB, 0.10664908E-06_JPRB /)

RGHG7(:,61, 3) = (/ &
  & 0.70639544E-07_JPRB, 0.68240432E-07_JPRB, 0.67386161E-07_JPRB, 0.66706839E-07_JPRB, 0.66154854E-07_JPRB, 0.65718432E-07_JPRB, &
  & 0.65409964E-07_JPRB, 0.65173033E-07_JPRB, 0.64987255E-07_JPRB, 0.64794513E-07_JPRB, 0.64606652E-07_JPRB, 0.64419872E-07_JPRB, &
  & 0.64208955E-07_JPRB, 0.64000467E-07_JPRB, 0.63791447E-07_JPRB, 0.63615211E-07_JPRB, 0.63325537E-07_JPRB, 0.62602524E-07_JPRB, &
  & 0.61143545E-07_JPRB, 0.58768450E-07_JPRB, 0.55449515E-07_JPRB, 0.51274565E-07_JPRB, 0.46717247E-07_JPRB, 0.42193811E-07_JPRB, &
  & 0.38209460E-07_JPRB, 0.35064378E-07_JPRB, 0.32852626E-07_JPRB, 0.31568153E-07_JPRB, 0.31139965E-07_JPRB, 0.31550325E-07_JPRB, &
  & 0.32852569E-07_JPRB, 0.35088330E-07_JPRB, 0.38356582E-07_JPRB, 0.42655365E-07_JPRB, 0.48031360E-07_JPRB, 0.54049448E-07_JPRB, &
  & 0.60514949E-07_JPRB, 0.67028282E-07_JPRB, 0.73291069E-07_JPRB, 0.78787856E-07_JPRB, 0.83134893E-07_JPRB, 0.85928939E-07_JPRB, &
  & 0.87136939E-07_JPRB, 0.87075719E-07_JPRB, 0.86628404E-07_JPRB, 0.86489443E-07_JPRB, 0.87060002E-07_JPRB, 0.88354810E-07_JPRB, &
  & 0.89935355E-07_JPRB, 0.91377700E-07_JPRB, 0.92599706E-07_JPRB, 0.93601265E-07_JPRB, 0.94452254E-07_JPRB, 0.95240281E-07_JPRB, &
  & 0.95967948E-07_JPRB, 0.96723461E-07_JPRB, 0.97533423E-07_JPRB, 0.98354299E-07_JPRB, 0.99121237E-07_JPRB, 0.99748497E-07_JPRB, &
  & 0.10027530E-06_JPRB, 0.10078992E-06_JPRB, 0.10139084E-06_JPRB, 0.10285902E-06_JPRB /)

RGHG7(:,62, 3) = (/ &
  & 0.67618409E-07_JPRB, 0.65529413E-07_JPRB, 0.64709717E-07_JPRB, 0.64207811E-07_JPRB, 0.63767004E-07_JPRB, 0.63366429E-07_JPRB, &
  & 0.63044425E-07_JPRB, 0.62777346E-07_JPRB, 0.62543194E-07_JPRB, 0.62311869E-07_JPRB, 0.62074889E-07_JPRB, 0.61804464E-07_JPRB, &
  & 0.61508878E-07_JPRB, 0.61165167E-07_JPRB, 0.60843767E-07_JPRB, 0.60581726E-07_JPRB, 0.60243480E-07_JPRB, 0.59536770E-07_JPRB, &
  & 0.58180174E-07_JPRB, 0.55975100E-07_JPRB, 0.52855480E-07_JPRB, 0.48975387E-07_JPRB, 0.44727329E-07_JPRB, 0.40561535E-07_JPRB, &
  & 0.36919914E-07_JPRB, 0.34079761E-07_JPRB, 0.32104094E-07_JPRB, 0.30984008E-07_JPRB, 0.30642319E-07_JPRB, 0.31061848E-07_JPRB, &
  & 0.32295290E-07_JPRB, 0.34390613E-07_JPRB, 0.37437836E-07_JPRB, 0.41448974E-07_JPRB, 0.46485667E-07_JPRB, 0.52187822E-07_JPRB, &
  & 0.58294184E-07_JPRB, 0.64465247E-07_JPRB, 0.70353913E-07_JPRB, 0.75531631E-07_JPRB, 0.79565027E-07_JPRB, 0.82194397E-07_JPRB, &
  & 0.83346926E-07_JPRB, 0.83395705E-07_JPRB, 0.83081574E-07_JPRB, 0.83044604E-07_JPRB, 0.83655181E-07_JPRB, 0.84933767E-07_JPRB, &
  & 0.86578858E-07_JPRB, 0.88158856E-07_JPRB, 0.89521656E-07_JPRB, 0.90657046E-07_JPRB, 0.91643109E-07_JPRB, 0.92490637E-07_JPRB, &
  & 0.93303328E-07_JPRB, 0.94109424E-07_JPRB, 0.94950096E-07_JPRB, 0.95786227E-07_JPRB, 0.96519237E-07_JPRB, 0.97112355E-07_JPRB, &
  & 0.97630277E-07_JPRB, 0.98136148E-07_JPRB, 0.98785016E-07_JPRB, 0.10013420E-06_JPRB /)

RGHG7(:,63, 3) = (/ &
  & 0.64614724E-07_JPRB, 0.62955316E-07_JPRB, 0.62370695E-07_JPRB, 0.61962020E-07_JPRB, 0.61578952E-07_JPRB, 0.61212305E-07_JPRB, &
  & 0.60873667E-07_JPRB, 0.60559856E-07_JPRB, 0.60274758E-07_JPRB, 0.59971185E-07_JPRB, 0.59663435E-07_JPRB, 0.59305918E-07_JPRB, &
  & 0.58883074E-07_JPRB, 0.58428846E-07_JPRB, 0.58018529E-07_JPRB, 0.57702241E-07_JPRB, 0.57330201E-07_JPRB, 0.56650038E-07_JPRB, &
  & 0.55356118E-07_JPRB, 0.53284694E-07_JPRB, 0.50379331E-07_JPRB, 0.46780993E-07_JPRB, 0.42884938E-07_JPRB, 0.39084131E-07_JPRB, &
  & 0.35819372E-07_JPRB, 0.33290913E-07_JPRB, 0.31559470E-07_JPRB, 0.30604657E-07_JPRB, 0.30343006E-07_JPRB, 0.30760745E-07_JPRB, &
  & 0.31911753E-07_JPRB, 0.33840326E-07_JPRB, 0.36639193E-07_JPRB, 0.40344659E-07_JPRB, 0.45011330E-07_JPRB, 0.50388294E-07_JPRB, &
  & 0.56158793E-07_JPRB, 0.61994399E-07_JPRB, 0.67560933E-07_JPRB, 0.72430460E-07_JPRB, 0.76206661E-07_JPRB, 0.78671427E-07_JPRB, &
  & 0.79810604E-07_JPRB, 0.79951683E-07_JPRB, 0.79786091E-07_JPRB, 0.79853848E-07_JPRB, 0.80500513E-07_JPRB, 0.81771354E-07_JPRB, &
  & 0.83419799E-07_JPRB, 0.85100318E-07_JPRB, 0.86606228E-07_JPRB, 0.87902741E-07_JPRB, 0.88993865E-07_JPRB, 0.89971628E-07_JPRB, &
  & 0.90863708E-07_JPRB, 0.91745896E-07_JPRB, 0.92646523E-07_JPRB, 0.93493405E-07_JPRB, 0.94218692E-07_JPRB, 0.94798963E-07_JPRB, &
  & 0.95292243E-07_JPRB, 0.95760228E-07_JPRB, 0.96331071E-07_JPRB, 0.97639919E-07_JPRB /)

RGHG7(:,64, 3) = (/ &
  & 0.62286041E-07_JPRB, 0.60851320E-07_JPRB, 0.60289537E-07_JPRB, 0.59911493E-07_JPRB, 0.59579303E-07_JPRB, 0.59213033E-07_JPRB, &
  & 0.58848737E-07_JPRB, 0.58490826E-07_JPRB, 0.58129107E-07_JPRB, 0.57759980E-07_JPRB, 0.57348448E-07_JPRB, 0.56876885E-07_JPRB, &
  & 0.56349577E-07_JPRB, 0.55814343E-07_JPRB, 0.55369988E-07_JPRB, 0.55014933E-07_JPRB, 0.54607192E-07_JPRB, 0.53905861E-07_JPRB, &
  & 0.52676434E-07_JPRB, 0.50753890E-07_JPRB, 0.48061736E-07_JPRB, 0.44758625E-07_JPRB, 0.41211770E-07_JPRB, 0.37813631E-07_JPRB, &
  & 0.34927126E-07_JPRB, 0.32721957E-07_JPRB, 0.31238102E-07_JPRB, 0.30445324E-07_JPRB, 0.30259610E-07_JPRB, 0.30672485E-07_JPRB, &
  & 0.31735993E-07_JPRB, 0.33487460E-07_JPRB, 0.36012651E-07_JPRB, 0.39371375E-07_JPRB, 0.43691482E-07_JPRB, 0.48712412E-07_JPRB, &
  & 0.54150657E-07_JPRB, 0.59670420E-07_JPRB, 0.64923981E-07_JPRB, 0.69516858E-07_JPRB, 0.73057258E-07_JPRB, 0.75392322E-07_JPRB, &
  & 0.76515327E-07_JPRB, 0.76770775E-07_JPRB, 0.76745266E-07_JPRB, 0.76930888E-07_JPRB, 0.77631363E-07_JPRB, 0.78884177E-07_JPRB, &
  & 0.80524217E-07_JPRB, 0.82244028E-07_JPRB, 0.83849478E-07_JPRB, 0.85267928E-07_JPRB, 0.86499583E-07_JPRB, 0.87584709E-07_JPRB, &
  & 0.88586546E-07_JPRB, 0.89576758E-07_JPRB, 0.90552788E-07_JPRB, 0.91443908E-07_JPRB, 0.92167895E-07_JPRB, 0.92751044E-07_JPRB, &
  & 0.93243564E-07_JPRB, 0.93729078E-07_JPRB, 0.94329195E-07_JPRB, 0.95572204E-07_JPRB /)

RGHG7(:,65, 3) = (/ &
  & 0.60239202E-07_JPRB, 0.58876054E-07_JPRB, 0.58362975E-07_JPRB, 0.58011612E-07_JPRB, 0.57679419E-07_JPRB, 0.57333903E-07_JPRB, &
  & 0.56950839E-07_JPRB, 0.56533754E-07_JPRB, 0.56099587E-07_JPRB, 0.55613757E-07_JPRB, 0.55110334E-07_JPRB, 0.54526925E-07_JPRB, &
  & 0.53938987E-07_JPRB, 0.53383239E-07_JPRB, 0.52931252E-07_JPRB, 0.52537057E-07_JPRB, 0.52102418E-07_JPRB, 0.51405323E-07_JPRB, &
  & 0.50230582E-07_JPRB, 0.48422518E-07_JPRB, 0.45937231E-07_JPRB, 0.42942201E-07_JPRB, 0.39768597E-07_JPRB, 0.36776406E-07_JPRB, &
  & 0.34273850E-07_JPRB, 0.32386495E-07_JPRB, 0.31145724E-07_JPRB, 0.30507397E-07_JPRB, 0.30395725E-07_JPRB, 0.30805655E-07_JPRB, &
  & 0.31787515E-07_JPRB, 0.33365676E-07_JPRB, 0.35614878E-07_JPRB, 0.38644977E-07_JPRB, 0.42573948E-07_JPRB, 0.47235321E-07_JPRB, &
  & 0.52330765E-07_JPRB, 0.57536148E-07_JPRB, 0.62484837E-07_JPRB, 0.66799352E-07_JPRB, 0.70150811E-07_JPRB, 0.72355299E-07_JPRB, &
  & 0.73487222E-07_JPRB, 0.73852391E-07_JPRB, 0.73975968E-07_JPRB, 0.74273785E-07_JPRB, 0.75027835E-07_JPRB, 0.76289481E-07_JPRB, &
  & 0.77899777E-07_JPRB, 0.79629771E-07_JPRB, 0.81287503E-07_JPRB, 0.82774264E-07_JPRB, 0.84113211E-07_JPRB, 0.85300805E-07_JPRB, &
  & 0.86424983E-07_JPRB, 0.87513776E-07_JPRB, 0.88594824E-07_JPRB, 0.89519069E-07_JPRB, 0.90266845E-07_JPRB, 0.90856908E-07_JPRB, &
  & 0.91369280E-07_JPRB, 0.91866653E-07_JPRB, 0.92484953E-07_JPRB, 0.93783342E-07_JPRB /)

RGHG7(:,66, 3) = (/ &
  & 0.58426004E-07_JPRB, 0.57097918E-07_JPRB, 0.56570030E-07_JPRB, 0.56202904E-07_JPRB, 0.55875873E-07_JPRB, 0.55512373E-07_JPRB, &
  & 0.55109997E-07_JPRB, 0.54654581E-07_JPRB, 0.54107254E-07_JPRB, 0.53554150E-07_JPRB, 0.52930094E-07_JPRB, 0.52310366E-07_JPRB, &
  & 0.51707659E-07_JPRB, 0.51154849E-07_JPRB, 0.50701860E-07_JPRB, 0.50277503E-07_JPRB, 0.49822642E-07_JPRB, 0.49105356E-07_JPRB, &
  & 0.47985846E-07_JPRB, 0.46314298E-07_JPRB, 0.44055426E-07_JPRB, 0.41368491E-07_JPRB, 0.38576893E-07_JPRB, 0.35991846E-07_JPRB, &
  & 0.33857940E-07_JPRB, 0.32283321E-07_JPRB, 0.31270364E-07_JPRB, 0.30777873E-07_JPRB, 0.30738054E-07_JPRB, 0.31151018E-07_JPRB, &
  & 0.32061802E-07_JPRB, 0.33480962E-07_JPRB, 0.35470396E-07_JPRB, 0.38180229E-07_JPRB, 0.41718561E-07_JPRB, 0.46008449E-07_JPRB, &
  & 0.50753645E-07_JPRB, 0.55632189E-07_JPRB, 0.60269969E-07_JPRB, 0.64307294E-07_JPRB, 0.67472733E-07_JPRB, 0.69580736E-07_JPRB, &
  & 0.70716894E-07_JPRB, 0.71205520E-07_JPRB, 0.71470531E-07_JPRB, 0.71882269E-07_JPRB, 0.72695748E-07_JPRB, 0.73957175E-07_JPRB, &
  & 0.75551164E-07_JPRB, 0.77265319E-07_JPRB, 0.78918902E-07_JPRB, 0.80461930E-07_JPRB, 0.81836625E-07_JPRB, 0.83120419E-07_JPRB, &
  & 0.84319325E-07_JPRB, 0.85530239E-07_JPRB, 0.86704524E-07_JPRB, 0.87685073E-07_JPRB, 0.88452516E-07_JPRB, 0.89074980E-07_JPRB, &
  & 0.89612080E-07_JPRB, 0.90162281E-07_JPRB, 0.90851024E-07_JPRB, 0.92242061E-07_JPRB /)

RGHG7(:,67, 3) = (/ &
  & 0.56765700E-07_JPRB, 0.55396089E-07_JPRB, 0.54845156E-07_JPRB, 0.54461822E-07_JPRB, 0.54106451E-07_JPRB, 0.53736631E-07_JPRB, &
  & 0.53305513E-07_JPRB, 0.52799532E-07_JPRB, 0.52199521E-07_JPRB, 0.51521290E-07_JPRB, 0.50881798E-07_JPRB, 0.50234576E-07_JPRB, &
  & 0.49658890E-07_JPRB, 0.49124537E-07_JPRB, 0.48673257E-07_JPRB, 0.48238839E-07_JPRB, 0.47772836E-07_JPRB, 0.47070419E-07_JPRB, &
  & 0.46019338E-07_JPRB, 0.44472834E-07_JPRB, 0.42436536E-07_JPRB, 0.40074212E-07_JPRB, 0.37657710E-07_JPRB, 0.35464925E-07_JPRB, &
  & 0.33683477E-07_JPRB, 0.32395928E-07_JPRB, 0.31592062E-07_JPRB, 0.31235533E-07_JPRB, 0.31266179E-07_JPRB, 0.31688110E-07_JPRB, &
  & 0.32543191E-07_JPRB, 0.33821753E-07_JPRB, 0.35582680E-07_JPRB, 0.37983884E-07_JPRB, 0.41152905E-07_JPRB, 0.45069715E-07_JPRB, &
  & 0.49462358E-07_JPRB, 0.53993702E-07_JPRB, 0.58309855E-07_JPRB, 0.62066619E-07_JPRB, 0.65040375E-07_JPRB, 0.67073003E-07_JPRB, &
  & 0.68222995E-07_JPRB, 0.68824626E-07_JPRB, 0.69227340E-07_JPRB, 0.69742185E-07_JPRB, 0.70608607E-07_JPRB, 0.71876805E-07_JPRB, &
  & 0.73442578E-07_JPRB, 0.75127048E-07_JPRB, 0.76776274E-07_JPRB, 0.78300005E-07_JPRB, 0.79718227E-07_JPRB, 0.81019216E-07_JPRB, &
  & 0.82292267E-07_JPRB, 0.83569212E-07_JPRB, 0.84848125E-07_JPRB, 0.85869011E-07_JPRB, 0.86673381E-07_JPRB, 0.87315932E-07_JPRB, &
  & 0.87896268E-07_JPRB, 0.88495888E-07_JPRB, 0.89285315E-07_JPRB, 0.90883461E-07_JPRB /)

RGHG7(:,68, 3) = (/ &
  & 0.55188430E-07_JPRB, 0.53762715E-07_JPRB, 0.53174169E-07_JPRB, 0.52755322E-07_JPRB, 0.52376855E-07_JPRB, 0.51972066E-07_JPRB, &
  & 0.51522129E-07_JPRB, 0.50978183E-07_JPRB, 0.50298635E-07_JPRB, 0.49600519E-07_JPRB, 0.48945800E-07_JPRB, 0.48325376E-07_JPRB, &
  & 0.47780990E-07_JPRB, 0.47276870E-07_JPRB, 0.46842935E-07_JPRB, 0.46419519E-07_JPRB, 0.45957659E-07_JPRB, 0.45281251E-07_JPRB, &
  & 0.44304834E-07_JPRB, 0.42909129E-07_JPRB, 0.41112255E-07_JPRB, 0.39059010E-07_JPRB, 0.37008746E-07_JPRB, 0.35176651E-07_JPRB, &
  & 0.33721143E-07_JPRB, 0.32698598E-07_JPRB, 0.32087790E-07_JPRB, 0.31859852E-07_JPRB, 0.31960528E-07_JPRB, 0.32398486E-07_JPRB, &
  & 0.33207467E-07_JPRB, 0.34368664E-07_JPRB, 0.35926082E-07_JPRB, 0.38041996E-07_JPRB, 0.40867661E-07_JPRB, 0.44437140E-07_JPRB, &
  & 0.48462699E-07_JPRB, 0.52644349E-07_JPRB, 0.56624856E-07_JPRB, 0.60097882E-07_JPRB, 0.62875017E-07_JPRB, 0.64836300E-07_JPRB, &
  & 0.66005740E-07_JPRB, 0.66711650E-07_JPRB, 0.67237615E-07_JPRB, 0.67850863E-07_JPRB, 0.68761175E-07_JPRB, 0.70027561E-07_JPRB, &
  & 0.71557992E-07_JPRB, 0.73205435E-07_JPRB, 0.74810728E-07_JPRB, 0.76320333E-07_JPRB, 0.77712102E-07_JPRB, 0.79044604E-07_JPRB, &
  & 0.80326316E-07_JPRB, 0.81647869E-07_JPRB, 0.83006341E-07_JPRB, 0.84061760E-07_JPRB, 0.84886281E-07_JPRB, 0.85556472E-07_JPRB, &
  & 0.86156518E-07_JPRB, 0.86819817E-07_JPRB, 0.87735117E-07_JPRB, 0.89590600E-07_JPRB /)

RGHG7(:,69, 3) = (/ &
  & 0.53686808E-07_JPRB, 0.52171579E-07_JPRB, 0.51524676E-07_JPRB, 0.51064973E-07_JPRB, 0.50647873E-07_JPRB, 0.50223800E-07_JPRB, &
  & 0.49745886E-07_JPRB, 0.49180386E-07_JPRB, 0.48462550E-07_JPRB, 0.47750557E-07_JPRB, 0.47126615E-07_JPRB, 0.46546401E-07_JPRB, &
  & 0.46052151E-07_JPRB, 0.45598316E-07_JPRB, 0.45200526E-07_JPRB, 0.44807329E-07_JPRB, 0.44375682E-07_JPRB, 0.43753495E-07_JPRB, &
  & 0.42874991E-07_JPRB, 0.41633818E-07_JPRB, 0.40070439E-07_JPRB, 0.38326121E-07_JPRB, 0.36610054E-07_JPRB, 0.35119506E-07_JPRB, &
  & 0.33961246E-07_JPRB, 0.33177152E-07_JPRB, 0.32743962E-07_JPRB, 0.32637178E-07_JPRB, 0.32808185E-07_JPRB, 0.33267938E-07_JPRB, &
  & 0.34044064E-07_JPRB, 0.35108371E-07_JPRB, 0.36484533E-07_JPRB, 0.38333908E-07_JPRB, 0.40870269E-07_JPRB, 0.44085677E-07_JPRB, &
  & 0.47762963E-07_JPRB, 0.51582433E-07_JPRB, 0.55227162E-07_JPRB, 0.58412937E-07_JPRB, 0.60997074E-07_JPRB, 0.62876865E-07_JPRB, &
  & 0.64068480E-07_JPRB, 0.64861609E-07_JPRB, 0.65491619E-07_JPRB, 0.66187148E-07_JPRB, 0.67132767E-07_JPRB, 0.68383230E-07_JPRB, &
  & 0.69869259E-07_JPRB, 0.71458878E-07_JPRB, 0.73016011E-07_JPRB, 0.74480802E-07_JPRB, 0.75849286E-07_JPRB, 0.77146431E-07_JPRB, &
  & 0.78428847E-07_JPRB, 0.79773621E-07_JPRB, 0.81157388E-07_JPRB, 0.82233313E-07_JPRB, 0.83066929E-07_JPRB, 0.83735848E-07_JPRB, &
  & 0.84356380E-07_JPRB, 0.85047510E-07_JPRB, 0.86091582E-07_JPRB, 0.88197744E-07_JPRB /)

RGHG7(:,70, 3) = (/ &
  & 0.52224031E-07_JPRB, 0.50583303E-07_JPRB, 0.49866241E-07_JPRB, 0.49358842E-07_JPRB, 0.48908589E-07_JPRB, 0.48463221E-07_JPRB, &
  & 0.47973568E-07_JPRB, 0.47395968E-07_JPRB, 0.46678814E-07_JPRB, 0.45988372E-07_JPRB, 0.45420300E-07_JPRB, 0.44904052E-07_JPRB, &
  & 0.44469044E-07_JPRB, 0.44080824E-07_JPRB, 0.43740730E-07_JPRB, 0.43396682E-07_JPRB, 0.43017391E-07_JPRB, 0.42468930E-07_JPRB, &
  & 0.41700265E-07_JPRB, 0.40630894E-07_JPRB, 0.39304769E-07_JPRB, 0.37845446E-07_JPRB, 0.36448231E-07_JPRB, 0.35257976E-07_JPRB, &
  & 0.34368803E-07_JPRB, 0.33806757E-07_JPRB, 0.33541092E-07_JPRB, 0.33550982E-07_JPRB, 0.33792919E-07_JPRB, 0.34278695E-07_JPRB, &
  & 0.35030244E-07_JPRB, 0.36011198E-07_JPRB, 0.37222531E-07_JPRB, 0.38862805E-07_JPRB, 0.41110610E-07_JPRB, 0.44015618E-07_JPRB, &
  & 0.47338773E-07_JPRB, 0.50804793E-07_JPRB, 0.54112917E-07_JPRB, 0.57020245E-07_JPRB, 0.59405725E-07_JPRB, 0.61204808E-07_JPRB, &
  & 0.62406841E-07_JPRB, 0.63267898E-07_JPRB, 0.63985830E-07_JPRB, 0.64745109E-07_JPRB, 0.65713380E-07_JPRB, 0.66939727E-07_JPRB, &
  & 0.68365487E-07_JPRB, 0.69887726E-07_JPRB, 0.71372114E-07_JPRB, 0.72778235E-07_JPRB, 0.74087254E-07_JPRB, 0.75353363E-07_JPRB, &
  & 0.76586780E-07_JPRB, 0.77917491E-07_JPRB, 0.79314560E-07_JPRB, 0.80366704E-07_JPRB, 0.81192901E-07_JPRB, 0.81855617E-07_JPRB, &
  & 0.82460822E-07_JPRB, 0.83170086E-07_JPRB, 0.84299252E-07_JPRB, 0.86634294E-07_JPRB /)

RGHG7(:,71, 3) = (/ &
  & 0.50758960E-07_JPRB, 0.48989861E-07_JPRB, 0.48173536E-07_JPRB, 0.47617473E-07_JPRB, 0.47137423E-07_JPRB, 0.46685678E-07_JPRB, &
  & 0.46197464E-07_JPRB, 0.45634771E-07_JPRB, 0.44943118E-07_JPRB, 0.44312568E-07_JPRB, 0.43802974E-07_JPRB, 0.43377792E-07_JPRB, &
  & 0.43026262E-07_JPRB, 0.42712610E-07_JPRB, 0.42452925E-07_JPRB, 0.42178879E-07_JPRB, 0.41870667E-07_JPRB, 0.41417358E-07_JPRB, &
  & 0.40771262E-07_JPRB, 0.39878465E-07_JPRB, 0.38783146E-07_JPRB, 0.37599669E-07_JPRB, 0.36491432E-07_JPRB, 0.35587725E-07_JPRB, &
  & 0.34948659E-07_JPRB, 0.34587060E-07_JPRB, 0.34474056E-07_JPRB, 0.34593459E-07_JPRB, 0.34905696E-07_JPRB, 0.35421451E-07_JPRB, &
  & 0.36158600E-07_JPRB, 0.37065863E-07_JPRB, 0.38141462E-07_JPRB, 0.39611617E-07_JPRB, 0.41571145E-07_JPRB, 0.44198863E-07_JPRB, &
  & 0.47179114E-07_JPRB, 0.50299764E-07_JPRB, 0.53277937E-07_JPRB, 0.55911677E-07_JPRB, 0.58111773E-07_JPRB, 0.59812749E-07_JPRB, &
  & 0.61017417E-07_JPRB, 0.61930599E-07_JPRB, 0.62709269E-07_JPRB, 0.63521519E-07_JPRB, 0.64492355E-07_JPRB, 0.65678350E-07_JPRB, &
  & 0.67030754E-07_JPRB, 0.68467472E-07_JPRB, 0.69867447E-07_JPRB, 0.71199118E-07_JPRB, 0.72430502E-07_JPRB, 0.73642049E-07_JPRB, &
  & 0.74805037E-07_JPRB, 0.76100719E-07_JPRB, 0.77442536E-07_JPRB, 0.78475310E-07_JPRB, 0.79263586E-07_JPRB, 0.79901078E-07_JPRB, &
  & 0.80490054E-07_JPRB, 0.81177660E-07_JPRB, 0.82313349E-07_JPRB, 0.84830155E-07_JPRB /)

RGHG7(:,72, 3) = (/ &
  & 0.49302024E-07_JPRB, 0.47320196E-07_JPRB, 0.46421668E-07_JPRB, 0.45820119E-07_JPRB, 0.45332790E-07_JPRB, 0.44889802E-07_JPRB, &
  & 0.44420879E-07_JPRB, 0.43897547E-07_JPRB, 0.43273154E-07_JPRB, 0.42726100E-07_JPRB, 0.42302162E-07_JPRB, 0.41968960E-07_JPRB, &
  & 0.41718735E-07_JPRB, 0.41500140E-07_JPRB, 0.41325428E-07_JPRB, 0.41141483E-07_JPRB, 0.40919474E-07_JPRB, 0.40572601E-07_JPRB, &
  & 0.40060865E-07_JPRB, 0.39352123E-07_JPRB, 0.38479893E-07_JPRB, 0.37560845E-07_JPRB, 0.36725538E-07_JPRB, 0.36071970E-07_JPRB, &
  & 0.35654665E-07_JPRB, 0.35481474E-07_JPRB, 0.35515143E-07_JPRB, 0.35741532E-07_JPRB, 0.36123147E-07_JPRB, 0.36668869E-07_JPRB, &
  & 0.37390869E-07_JPRB, 0.38234862E-07_JPRB, 0.39230923E-07_JPRB, 0.40523286E-07_JPRB, 0.42249503E-07_JPRB, 0.44600863E-07_JPRB, &
  & 0.47265473E-07_JPRB, 0.50049660E-07_JPRB, 0.52708543E-07_JPRB, 0.55081880E-07_JPRB, 0.57097186E-07_JPRB, 0.58698031E-07_JPRB, &
  & 0.59886375E-07_JPRB, 0.60822636E-07_JPRB, 0.61655342E-07_JPRB, 0.62497293E-07_JPRB, 0.63460654E-07_JPRB, 0.64596897E-07_JPRB, &
  & 0.65864747E-07_JPRB, 0.67206756E-07_JPRB, 0.68505578E-07_JPRB, 0.69743763E-07_JPRB, 0.70887815E-07_JPRB, 0.72006181E-07_JPRB, &
  & 0.73105127E-07_JPRB, 0.74304324E-07_JPRB, 0.75597413E-07_JPRB, 0.76559573E-07_JPRB, 0.77315462E-07_JPRB, 0.77915495E-07_JPRB, &
  & 0.78469810E-07_JPRB, 0.79118500E-07_JPRB, 0.80238792E-07_JPRB, 0.82770050E-07_JPRB /)

RGHG7(:,73, 3) = (/ &
  & 0.47755581E-07_JPRB, 0.45556124E-07_JPRB, 0.44580769E-07_JPRB, 0.43983892E-07_JPRB, 0.43509015E-07_JPRB, 0.43101547E-07_JPRB, &
  & 0.42677435E-07_JPRB, 0.42219124E-07_JPRB, 0.41670607E-07_JPRB, 0.41239709E-07_JPRB, 0.40913953E-07_JPRB, 0.40680938E-07_JPRB, &
  & 0.40537024E-07_JPRB, 0.40427949E-07_JPRB, 0.40353527E-07_JPRB, 0.40270272E-07_JPRB, 0.40144393E-07_JPRB, 0.39917651E-07_JPRB, &
  & 0.39544727E-07_JPRB, 0.39017301E-07_JPRB, 0.38368139E-07_JPRB, 0.37701781E-07_JPRB, 0.37116926E-07_JPRB, 0.36706560E-07_JPRB, &
  & 0.36504126E-07_JPRB, 0.36500939E-07_JPRB, 0.36667725E-07_JPRB, 0.36991654E-07_JPRB, 0.37439808E-07_JPRB, 0.38016783E-07_JPRB, &
  & 0.38733706E-07_JPRB, 0.39547157E-07_JPRB, 0.40462314E-07_JPRB, 0.41566587E-07_JPRB, 0.43155435E-07_JPRB, 0.45183832E-07_JPRB, &
  & 0.47565798E-07_JPRB, 0.50038576E-07_JPRB, 0.52384284E-07_JPRB, 0.54513105E-07_JPRB, 0.56353684E-07_JPRB, 0.57839362E-07_JPRB, &
  & 0.58989908E-07_JPRB, 0.59935502E-07_JPRB, 0.60795429E-07_JPRB, 0.61652599E-07_JPRB, 0.62600641E-07_JPRB, 0.63666313E-07_JPRB, &
  & 0.64850738E-07_JPRB, 0.66075991E-07_JPRB, 0.67278130E-07_JPRB, 0.68412540E-07_JPRB, 0.69453620E-07_JPRB, 0.70489961E-07_JPRB, &
  & 0.71475974E-07_JPRB, 0.72604877E-07_JPRB, 0.73769627E-07_JPRB, 0.74688998E-07_JPRB, 0.75383326E-07_JPRB, 0.75945820E-07_JPRB, &
  & 0.76461639E-07_JPRB, 0.77060591E-07_JPRB, 0.78114986E-07_JPRB, 0.80610903E-07_JPRB /)

RGHG7(:,74, 3) = (/ &
  & 0.45971998E-07_JPRB, 0.43643315E-07_JPRB, 0.42703384E-07_JPRB, 0.42136683E-07_JPRB, 0.41719886E-07_JPRB, 0.41362277E-07_JPRB, &
  & 0.41001389E-07_JPRB, 0.40625842E-07_JPRB, 0.40194099E-07_JPRB, 0.39873214E-07_JPRB, 0.39655678E-07_JPRB, 0.39540517E-07_JPRB, &
  & 0.39496744E-07_JPRB, 0.39497614E-07_JPRB, 0.39525620E-07_JPRB, 0.39547707E-07_JPRB, 0.39530093E-07_JPRB, 0.39424471E-07_JPRB, &
  & 0.39197193E-07_JPRB, 0.38853248E-07_JPRB, 0.38422627E-07_JPRB, 0.37990031E-07_JPRB, 0.37646885E-07_JPRB, 0.37443385E-07_JPRB, &
  & 0.37422481E-07_JPRB, 0.37578822E-07_JPRB, 0.37873498E-07_JPRB, 0.38293763E-07_JPRB, 0.38805354E-07_JPRB, 0.39411006E-07_JPRB, &
  & 0.40126761E-07_JPRB, 0.40916031E-07_JPRB, 0.41747526E-07_JPRB, 0.42771642E-07_JPRB, 0.44198877E-07_JPRB, 0.45961112E-07_JPRB, &
  & 0.48039599E-07_JPRB, 0.50231982E-07_JPRB, 0.52284765E-07_JPRB, 0.54179079E-07_JPRB, 0.55850368E-07_JPRB, 0.57217001E-07_JPRB, &
  & 0.58299261E-07_JPRB, 0.59235227E-07_JPRB, 0.60117948E-07_JPRB, 0.60972773E-07_JPRB, 0.61878204E-07_JPRB, 0.62893577E-07_JPRB, &
  & 0.63967803E-07_JPRB, 0.65096870E-07_JPRB, 0.66177336E-07_JPRB, 0.67204034E-07_JPRB, 0.68155543E-07_JPRB, 0.69069095E-07_JPRB, &
  & 0.69987792E-07_JPRB, 0.70973414E-07_JPRB, 0.72054121E-07_JPRB, 0.72878834E-07_JPRB, 0.73525605E-07_JPRB, 0.74041118E-07_JPRB, &
  & 0.74512855E-07_JPRB, 0.75051766E-07_JPRB, 0.76033764E-07_JPRB, 0.78424286E-07_JPRB /)

RGHG7(:,75, 3) = (/ &
  & 0.44099728E-07_JPRB, 0.41753562E-07_JPRB, 0.40846516E-07_JPRB, 0.40351669E-07_JPRB, 0.39998380E-07_JPRB, 0.39715861E-07_JPRB, &
  & 0.39434248E-07_JPRB, 0.39149725E-07_JPRB, 0.38837417E-07_JPRB, 0.38629551E-07_JPRB, 0.38535237E-07_JPRB, 0.38513896E-07_JPRB, &
  & 0.38584581E-07_JPRB, 0.38692061E-07_JPRB, 0.38827054E-07_JPRB, 0.38954322E-07_JPRB, 0.39048906E-07_JPRB, 0.39068006E-07_JPRB, &
  & 0.38990969E-07_JPRB, 0.38829590E-07_JPRB, 0.38606601E-07_JPRB, 0.38397019E-07_JPRB, 0.38274525E-07_JPRB, 0.38283872E-07_JPRB, &
  & 0.38452374E-07_JPRB, 0.38756788E-07_JPRB, 0.39169343E-07_JPRB, 0.39674610E-07_JPRB, 0.40246050E-07_JPRB, 0.40886558E-07_JPRB, &
  & 0.41615991E-07_JPRB, 0.42375273E-07_JPRB, 0.43144318E-07_JPRB, 0.44112511E-07_JPRB, 0.45313797E-07_JPRB, 0.46919062E-07_JPRB, &
  & 0.48654986E-07_JPRB, 0.50593520E-07_JPRB, 0.52375693E-07_JPRB, 0.54043245E-07_JPRB, 0.55556018E-07_JPRB, 0.56780898E-07_JPRB, &
  & 0.57789340E-07_JPRB, 0.58715997E-07_JPRB, 0.59593379E-07_JPRB, 0.60411274E-07_JPRB, 0.61291580E-07_JPRB, 0.62214944E-07_JPRB, &
  & 0.63211388E-07_JPRB, 0.64212990E-07_JPRB, 0.65195600E-07_JPRB, 0.66117678E-07_JPRB, 0.66964382E-07_JPRB, 0.67798041E-07_JPRB, &
  & 0.68590275E-07_JPRB, 0.69487960E-07_JPRB, 0.70427575E-07_JPRB, 0.71174100E-07_JPRB, 0.71755906E-07_JPRB, 0.72224012E-07_JPRB, &
  & 0.72649399E-07_JPRB, 0.73122123E-07_JPRB, 0.74022985E-07_JPRB, 0.76274553E-07_JPRB /)

RGHG7(:,76, 3) = (/ &
  & 0.42198167E-07_JPRB, 0.39880781E-07_JPRB, 0.39052114E-07_JPRB, 0.38644913E-07_JPRB, 0.38379987E-07_JPRB, 0.38175440E-07_JPRB, &
  & 0.37984471E-07_JPRB, 0.37803716E-07_JPRB, 0.37615898E-07_JPRB, 0.37538467E-07_JPRB, 0.37538150E-07_JPRB, 0.37645581E-07_JPRB, &
  & 0.37801559E-07_JPRB, 0.38009151E-07_JPRB, 0.38241904E-07_JPRB, 0.38470898E-07_JPRB, 0.38677879E-07_JPRB, 0.38824666E-07_JPRB, &
  & 0.38899501E-07_JPRB, 0.38916337E-07_JPRB, 0.38895656E-07_JPRB, 0.38891997E-07_JPRB, 0.38983366E-07_JPRB, 0.39167453E-07_JPRB, &
  & 0.39479719E-07_JPRB, 0.39909200E-07_JPRB, 0.40423245E-07_JPRB, 0.41007979E-07_JPRB, 0.41634074E-07_JPRB, 0.42308482E-07_JPRB, &
  & 0.43040536E-07_JPRB, 0.43771120E-07_JPRB, 0.44563095E-07_JPRB, 0.45480324E-07_JPRB, 0.46518700E-07_JPRB, 0.47979675E-07_JPRB, &
  & 0.49401979E-07_JPRB, 0.51075855E-07_JPRB, 0.52621370E-07_JPRB, 0.54066675E-07_JPRB, 0.55415384E-07_JPRB, 0.56507755E-07_JPRB, &
  & 0.57432768E-07_JPRB, 0.58351567E-07_JPRB, 0.59184892E-07_JPRB, 0.59965629E-07_JPRB, 0.60791933E-07_JPRB, 0.61662163E-07_JPRB, &
  & 0.62549582E-07_JPRB, 0.63455246E-07_JPRB, 0.64318840E-07_JPRB, 0.65137314E-07_JPRB, 0.65895875E-07_JPRB, 0.66621482E-07_JPRB, &
  & 0.67336224E-07_JPRB, 0.68101791E-07_JPRB, 0.68919420E-07_JPRB, 0.69573154E-07_JPRB, 0.70083587E-07_JPRB, 0.70502054E-07_JPRB, &
  & 0.70880866E-07_JPRB, 0.71280525E-07_JPRB, 0.72099304E-07_JPRB, 0.74208785E-07_JPRB /)

RGHG7(:,77, 3) = (/ &
  & 0.40288111E-07_JPRB, 0.38068919E-07_JPRB, 0.37353754E-07_JPRB, 0.37045172E-07_JPRB, 0.36873420E-07_JPRB, 0.36762358E-07_JPRB, &
  & 0.36666659E-07_JPRB, 0.36594383E-07_JPRB, 0.36541355E-07_JPRB, 0.36565307E-07_JPRB, 0.36698285E-07_JPRB, 0.36872752E-07_JPRB, &
  & 0.37138960E-07_JPRB, 0.37433939E-07_JPRB, 0.37754543E-07_JPRB, 0.38081499E-07_JPRB, 0.38393356E-07_JPRB, 0.38665146E-07_JPRB, &
  & 0.38889745E-07_JPRB, 0.39076120E-07_JPRB, 0.39247254E-07_JPRB, 0.39447720E-07_JPRB, 0.39712472E-07_JPRB, 0.40092498E-07_JPRB, &
  & 0.40568111E-07_JPRB, 0.41127368E-07_JPRB, 0.41744300E-07_JPRB, 0.42403304E-07_JPRB, 0.43085073E-07_JPRB, 0.43794131E-07_JPRB, &
  & 0.44526868E-07_JPRB, 0.45256996E-07_JPRB, 0.46051056E-07_JPRB, 0.46820794E-07_JPRB, 0.47819540E-07_JPRB, 0.49014719E-07_JPRB, &
  & 0.50275816E-07_JPRB, 0.51618045E-07_JPRB, 0.52988476E-07_JPRB, 0.54194118E-07_JPRB, 0.55401131E-07_JPRB, 0.56345982E-07_JPRB, &
  & 0.57219207E-07_JPRB, 0.58102998E-07_JPRB, 0.58864334E-07_JPRB, 0.59605426E-07_JPRB, 0.60396523E-07_JPRB, 0.61177317E-07_JPRB, &
  & 0.61984366E-07_JPRB, 0.62776898E-07_JPRB, 0.63543382E-07_JPRB, 0.64263531E-07_JPRB, 0.64930781E-07_JPRB, 0.65575549E-07_JPRB, &
  & 0.66185393E-07_JPRB, 0.66844201E-07_JPRB, 0.67533421E-07_JPRB, 0.68077831E-07_JPRB, 0.68524862E-07_JPRB, 0.68887758E-07_JPRB, &
  & 0.69224022E-07_JPRB, 0.69542416E-07_JPRB, 0.70273863E-07_JPRB, 0.72224751E-07_JPRB /)

RGHG7(:,78, 3) = (/ &
  & 0.38371091E-07_JPRB, 0.36389629E-07_JPRB, 0.35817578E-07_JPRB, 0.35635697E-07_JPRB, 0.35563072E-07_JPRB, 0.35544254E-07_JPRB, &
  & 0.35553356E-07_JPRB, 0.35594738E-07_JPRB, 0.35669412E-07_JPRB, 0.35821429E-07_JPRB, 0.36020595E-07_JPRB, 0.36312748E-07_JPRB, &
  & 0.36628268E-07_JPRB, 0.36991331E-07_JPRB, 0.37377724E-07_JPRB, 0.37780080E-07_JPRB, 0.38183497E-07_JPRB, 0.38567777E-07_JPRB, &
  & 0.38926590E-07_JPRB, 0.39269604E-07_JPRB, 0.39612292E-07_JPRB, 0.39992038E-07_JPRB, 0.40412996E-07_JPRB, 0.40917424E-07_JPRB, &
  & 0.41480590E-07_JPRB, 0.42100030E-07_JPRB, 0.42759861E-07_JPRB, 0.43456883E-07_JPRB, 0.44173554E-07_JPRB, 0.44915257E-07_JPRB, &
  & 0.45667043E-07_JPRB, 0.46444335E-07_JPRB, 0.47246424E-07_JPRB, 0.48018158E-07_JPRB, 0.49038860E-07_JPRB, 0.49946028E-07_JPRB, &
  & 0.51165831E-07_JPRB, 0.52160321E-07_JPRB, 0.53391716E-07_JPRB, 0.54396583E-07_JPRB, 0.55448822E-07_JPRB, 0.56287920E-07_JPRB, &
  & 0.57101023E-07_JPRB, 0.57935448E-07_JPRB, 0.58626835E-07_JPRB, 0.59352274E-07_JPRB, 0.60082890E-07_JPRB, 0.60811182E-07_JPRB, &
  & 0.61529384E-07_JPRB, 0.62235543E-07_JPRB, 0.62904945E-07_JPRB, 0.63537264E-07_JPRB, 0.64125416E-07_JPRB, 0.64688450E-07_JPRB, &
  & 0.65220405E-07_JPRB, 0.65771992E-07_JPRB, 0.66326045E-07_JPRB, 0.66787770E-07_JPRB, 0.67160279E-07_JPRB, 0.67467852E-07_JPRB, &
  & 0.67774714E-07_JPRB, 0.67998720E-07_JPRB, 0.68599341E-07_JPRB, 0.70306577E-07_JPRB /)

RGHG7(:,79, 3) = (/ &
  & 0.36591722E-07_JPRB, 0.35122991E-07_JPRB, 0.34793729E-07_JPRB, 0.34754354E-07_JPRB, 0.34777980E-07_JPRB, 0.34846902E-07_JPRB, &
  & 0.34943188E-07_JPRB, 0.35082646E-07_JPRB, 0.35232826E-07_JPRB, 0.35440461E-07_JPRB, 0.35709423E-07_JPRB, 0.35999765E-07_JPRB, &
  & 0.36373429E-07_JPRB, 0.36762241E-07_JPRB, 0.37179721E-07_JPRB, 0.37617994E-07_JPRB, 0.38067576E-07_JPRB, 0.38515257E-07_JPRB, &
  & 0.38957470E-07_JPRB, 0.39392702E-07_JPRB, 0.39843421E-07_JPRB, 0.40301188E-07_JPRB, 0.40800607E-07_JPRB, 0.41344105E-07_JPRB, &
  & 0.41953850E-07_JPRB, 0.42601151E-07_JPRB, 0.43284384E-07_JPRB, 0.43998181E-07_JPRB, 0.44736385E-07_JPRB, 0.45495334E-07_JPRB, &
  & 0.46267616E-07_JPRB, 0.47077830E-07_JPRB, 0.47852797E-07_JPRB, 0.48677649E-07_JPRB, 0.49624877E-07_JPRB, 0.50494567E-07_JPRB, &
  & 0.51671478E-07_JPRB, 0.52530226E-07_JPRB, 0.53644239E-07_JPRB, 0.54551148E-07_JPRB, 0.55496631E-07_JPRB, 0.56268693E-07_JPRB, &
  & 0.57049739E-07_JPRB, 0.57839340E-07_JPRB, 0.58500440E-07_JPRB, 0.59213889E-07_JPRB, 0.59924979E-07_JPRB, 0.60615371E-07_JPRB, &
  & 0.61298032E-07_JPRB, 0.61954410E-07_JPRB, 0.62579872E-07_JPRB, 0.63164549E-07_JPRB, 0.63705514E-07_JPRB, 0.64221837E-07_JPRB, &
  & 0.64696081E-07_JPRB, 0.65176955E-07_JPRB, 0.65648813E-07_JPRB, 0.66028306E-07_JPRB, 0.66364031E-07_JPRB, 0.66604066E-07_JPRB, &
  & 0.66900746E-07_JPRB, 0.67020288E-07_JPRB, 0.67416238E-07_JPRB, 0.68662068E-07_JPRB /)

RGHG7(:,80, 3) = (/ &
  & 0.35434130E-07_JPRB, 0.34565399E-07_JPRB, 0.34391554E-07_JPRB, 0.34447552E-07_JPRB, 0.34497358E-07_JPRB, 0.34587202E-07_JPRB, &
  & 0.34712755E-07_JPRB, 0.34856100E-07_JPRB, 0.35055034E-07_JPRB, 0.35266794E-07_JPRB, 0.35543458E-07_JPRB, 0.35883239E-07_JPRB, &
  & 0.36249865E-07_JPRB, 0.36660474E-07_JPRB, 0.37092029E-07_JPRB, 0.37546396E-07_JPRB, 0.38012697E-07_JPRB, 0.38485304E-07_JPRB, &
  & 0.38953971E-07_JPRB, 0.39430201E-07_JPRB, 0.39923162E-07_JPRB, 0.40400774E-07_JPRB, 0.40980723E-07_JPRB, 0.41538996E-07_JPRB, &
  & 0.42163094E-07_JPRB, 0.42823221E-07_JPRB, 0.43514955E-07_JPRB, 0.44240736E-07_JPRB, 0.44988589E-07_JPRB, 0.45757936E-07_JPRB, &
  & 0.46548294E-07_JPRB, 0.47356913E-07_JPRB, 0.48132119E-07_JPRB, 0.49020098E-07_JPRB, 0.49854574E-07_JPRB, 0.50834714E-07_JPRB, &
  & 0.51778677E-07_JPRB, 0.52749545E-07_JPRB, 0.53671751E-07_JPRB, 0.54625517E-07_JPRB, 0.55474313E-07_JPRB, 0.56261364E-07_JPRB, &
  & 0.57013263E-07_JPRB, 0.57788338E-07_JPRB, 0.58448727E-07_JPRB, 0.59161046E-07_JPRB, 0.59853107E-07_JPRB, 0.60534731E-07_JPRB, &
  & 0.61194868E-07_JPRB, 0.61831877E-07_JPRB, 0.62435127E-07_JPRB, 0.63000321E-07_JPRB, 0.63526272E-07_JPRB, 0.64025514E-07_JPRB, &
  & 0.64491744E-07_JPRB, 0.64946832E-07_JPRB, 0.65399625E-07_JPRB, 0.65751522E-07_JPRB, 0.66093101E-07_JPRB, 0.66284635E-07_JPRB, &
  & 0.66602951E-07_JPRB, 0.66671276E-07_JPRB, 0.66907070E-07_JPRB, 0.67710509E-07_JPRB /)

RGHG7(:,81, 3) = (/ &
  & 0.34714581E-07_JPRB, 0.34255372E-07_JPRB, 0.34181969E-07_JPRB, 0.34288455E-07_JPRB, 0.34328313E-07_JPRB, 0.34440792E-07_JPRB, &
  & 0.34578846E-07_JPRB, 0.34776090E-07_JPRB, 0.34949945E-07_JPRB, 0.35216328E-07_JPRB, 0.35484359E-07_JPRB, 0.35813741E-07_JPRB, &
  & 0.36198944E-07_JPRB, 0.36616537E-07_JPRB, 0.37053301E-07_JPRB, 0.37512628E-07_JPRB, 0.37989992E-07_JPRB, 0.38473004E-07_JPRB, &
  & 0.38962490E-07_JPRB, 0.39467658E-07_JPRB, 0.39964004E-07_JPRB, 0.40476714E-07_JPRB, 0.41044810E-07_JPRB, 0.41621668E-07_JPRB, &
  & 0.42244785E-07_JPRB, 0.42916149E-07_JPRB, 0.43617341E-07_JPRB, 0.44346610E-07_JPRB, 0.45103747E-07_JPRB, 0.45879709E-07_JPRB, &
  & 0.46678622E-07_JPRB, 0.47480061E-07_JPRB, 0.48283802E-07_JPRB, 0.49152806E-07_JPRB, 0.49954824E-07_JPRB, 0.51016322E-07_JPRB, &
  & 0.51788941E-07_JPRB, 0.52934162E-07_JPRB, 0.53665467E-07_JPRB, 0.54700720E-07_JPRB, 0.55466234E-07_JPRB, 0.56277177E-07_JPRB, &
  & 0.57002303E-07_JPRB, 0.57764819E-07_JPRB, 0.58433812E-07_JPRB, 0.59134369E-07_JPRB, 0.59826966E-07_JPRB, 0.60499026E-07_JPRB, &
  & 0.61156584E-07_JPRB, 0.61781662E-07_JPRB, 0.62379677E-07_JPRB, 0.62932656E-07_JPRB, 0.63453768E-07_JPRB, 0.63932561E-07_JPRB, &
  & 0.64395053E-07_JPRB, 0.64817812E-07_JPRB, 0.65275437E-07_JPRB, 0.65575719E-07_JPRB, 0.65952882E-07_JPRB, 0.66093065E-07_JPRB, &
  & 0.66421698E-07_JPRB, 0.66510935E-07_JPRB, 0.66589088E-07_JPRB, 0.67083768E-07_JPRB /)

RGHG7(:,82, 3) = (/ &
  & 0.34291752E-07_JPRB, 0.34099003E-07_JPRB, 0.34129211E-07_JPRB, 0.34261088E-07_JPRB, 0.34267430E-07_JPRB, 0.34405719E-07_JPRB, &
  & 0.34555224E-07_JPRB, 0.34705899E-07_JPRB, 0.34952457E-07_JPRB, 0.35141433E-07_JPRB, 0.35464389E-07_JPRB, 0.35782730E-07_JPRB, &
  & 0.36172466E-07_JPRB, 0.36591231E-07_JPRB, 0.37033942E-07_JPRB, 0.37497372E-07_JPRB, 0.37974587E-07_JPRB, 0.38461074E-07_JPRB, &
  & 0.38960263E-07_JPRB, 0.39463501E-07_JPRB, 0.39947381E-07_JPRB, 0.40516760E-07_JPRB, 0.41044842E-07_JPRB, 0.41670816E-07_JPRB, &
  & 0.42289287E-07_JPRB, 0.42959169E-07_JPRB, 0.43664496E-07_JPRB, 0.44399872E-07_JPRB, 0.45160142E-07_JPRB, 0.45942883E-07_JPRB, &
  & 0.46744734E-07_JPRB, 0.47546909E-07_JPRB, 0.48373867E-07_JPRB, 0.49200622E-07_JPRB, 0.50083198E-07_JPRB, 0.51038462E-07_JPRB, &
  & 0.51868117E-07_JPRB, 0.52947751E-07_JPRB, 0.53686446E-07_JPRB, 0.54697157E-07_JPRB, 0.55466060E-07_JPRB, 0.56272331E-07_JPRB, &
  & 0.57001593E-07_JPRB, 0.57746611E-07_JPRB, 0.58439230E-07_JPRB, 0.59135679E-07_JPRB, 0.59818539E-07_JPRB, 0.60488553E-07_JPRB, &
  & 0.61141122E-07_JPRB, 0.61757873E-07_JPRB, 0.62355014E-07_JPRB, 0.62896405E-07_JPRB, 0.63428622E-07_JPRB, 0.63889466E-07_JPRB, &
  & 0.64377680E-07_JPRB, 0.64769459E-07_JPRB, 0.65259250E-07_JPRB, 0.65521569E-07_JPRB, 0.65924233E-07_JPRB, 0.66053758E-07_JPRB, &
  & 0.66343297E-07_JPRB, 0.66521878E-07_JPRB, 0.66452060E-07_JPRB, 0.66757345E-07_JPRB /)

RGHG7(:,83, 3) = (/ &
  & 0.34302403E-07_JPRB, 0.33983699E-07_JPRB, 0.34140591E-07_JPRB, 0.34213265E-07_JPRB, 0.34191995E-07_JPRB, 0.34379617E-07_JPRB, &
  & 0.34486821E-07_JPRB, 0.34724348E-07_JPRB, 0.34869718E-07_JPRB, 0.35192112E-07_JPRB, 0.35413926E-07_JPRB, 0.35781596E-07_JPRB, &
  & 0.36144684E-07_JPRB, 0.36578680E-07_JPRB, 0.37021856E-07_JPRB, 0.37485769E-07_JPRB, 0.37967521E-07_JPRB, 0.38458044E-07_JPRB, &
  & 0.38965446E-07_JPRB, 0.39452431E-07_JPRB, 0.39973429E-07_JPRB, 0.40528363E-07_JPRB, 0.41060567E-07_JPRB, 0.41671029E-07_JPRB, &
  & 0.42305782E-07_JPRB, 0.42978105E-07_JPRB, 0.43688775E-07_JPRB, 0.44426876E-07_JPRB, 0.45194387E-07_JPRB, 0.45980482E-07_JPRB, &
  & 0.46784706E-07_JPRB, 0.47597357E-07_JPRB, 0.48425456E-07_JPRB, 0.49256762E-07_JPRB, 0.50159905E-07_JPRB, 0.51023925E-07_JPRB, &
  & 0.51996555E-07_JPRB, 0.52866206E-07_JPRB, 0.53819296E-07_JPRB, 0.54624518E-07_JPRB, 0.55528329E-07_JPRB, 0.56234914E-07_JPRB, &
  & 0.57027048E-07_JPRB, 0.57737360E-07_JPRB, 0.58446147E-07_JPRB, 0.59137815E-07_JPRB, 0.59824465E-07_JPRB, 0.60483714E-07_JPRB, &
  & 0.61137740E-07_JPRB, 0.61748331E-07_JPRB, 0.62348697E-07_JPRB, 0.62879081E-07_JPRB, 0.63417787E-07_JPRB, 0.63858643E-07_JPRB, &
  & 0.64356598E-07_JPRB, 0.64724397E-07_JPRB, 0.65222878E-07_JPRB, 0.65473621E-07_JPRB, 0.65858515E-07_JPRB, 0.66043619E-07_JPRB, &
  & 0.66221638E-07_JPRB, 0.66562706E-07_JPRB, 0.66344420E-07_JPRB, 0.66827837E-07_JPRB /)

RGHG7(:,84, 3) = (/ &
  & 0.34343142E-07_JPRB, 0.33858644E-07_JPRB, 0.34212327E-07_JPRB, 0.34149579E-07_JPRB, 0.34180534E-07_JPRB, 0.34390045E-07_JPRB, &
  & 0.34490096E-07_JPRB, 0.34683971E-07_JPRB, 0.34935798E-07_JPRB, 0.35122429E-07_JPRB, 0.35457660E-07_JPRB, 0.35742911E-07_JPRB, &
  & 0.36140044E-07_JPRB, 0.36557509E-07_JPRB, 0.37007545E-07_JPRB, 0.37476202E-07_JPRB, 0.37957964E-07_JPRB, 0.38451770E-07_JPRB, &
  & 0.38946084E-07_JPRB, 0.39433058E-07_JPRB, 0.39986254E-07_JPRB, 0.40483542E-07_JPRB, 0.41083876E-07_JPRB, 0.41666510E-07_JPRB, &
  & 0.42316028E-07_JPRB, 0.42987939E-07_JPRB, 0.43699469E-07_JPRB, 0.44443691E-07_JPRB, 0.45213326E-07_JPRB, 0.46003542E-07_JPRB, &
  & 0.46812460E-07_JPRB, 0.47633282E-07_JPRB, 0.48469300E-07_JPRB, 0.49307008E-07_JPRB, 0.50210289E-07_JPRB, 0.51069787E-07_JPRB, &
  & 0.52053196E-07_JPRB, 0.52855963E-07_JPRB, 0.53890560E-07_JPRB, 0.54585783E-07_JPRB, 0.55558552E-07_JPRB, 0.56223108E-07_JPRB, &
  & 0.57020802E-07_JPRB, 0.57744892E-07_JPRB, 0.58460341E-07_JPRB, 0.59151443E-07_JPRB, 0.59836708E-07_JPRB, 0.60492063E-07_JPRB, &
  & 0.61140682E-07_JPRB, 0.61748878E-07_JPRB, 0.62343986E-07_JPRB, 0.62876886E-07_JPRB, 0.63409949E-07_JPRB, 0.63861137E-07_JPRB, &
  & 0.64347859E-07_JPRB, 0.64738259E-07_JPRB, 0.65199067E-07_JPRB, 0.65509241E-07_JPRB, 0.65792356E-07_JPRB, 0.66119206E-07_JPRB, &
  & 0.66109898E-07_JPRB, 0.66640780E-07_JPRB, 0.66251786E-07_JPRB, 0.66837295E-07_JPRB /)

RGHG7(:,85, 3) = (/ &
  & 0.34387305E-07_JPRB, 0.33749721E-07_JPRB, 0.34307423E-07_JPRB, 0.34036344E-07_JPRB, 0.34207769E-07_JPRB, 0.34371222E-07_JPRB, &
  & 0.34455386E-07_JPRB, 0.34760113E-07_JPRB, 0.34878124E-07_JPRB, 0.35208771E-07_JPRB, 0.35421021E-07_JPRB, 0.35764696E-07_JPRB, &
  & 0.36110400E-07_JPRB, 0.36534697E-07_JPRB, 0.36982442E-07_JPRB, 0.37455692E-07_JPRB, 0.37946503E-07_JPRB, 0.38437616E-07_JPRB, &
  & 0.38925201E-07_JPRB, 0.39447396E-07_JPRB, 0.39964050E-07_JPRB, 0.40491177E-07_JPRB, 0.41065690E-07_JPRB, 0.41661870E-07_JPRB, &
  & 0.42302897E-07_JPRB, 0.42986972E-07_JPRB, 0.43702432E-07_JPRB, 0.44453117E-07_JPRB, 0.45227655E-07_JPRB, 0.46022919E-07_JPRB, &
  & 0.46837517E-07_JPRB, 0.47667861E-07_JPRB, 0.48500247E-07_JPRB, 0.49371110E-07_JPRB, 0.50233552E-07_JPRB, 0.51146703E-07_JPRB, &
  & 0.52050147E-07_JPRB, 0.52955272E-07_JPRB, 0.53895288E-07_JPRB, 0.54659434E-07_JPRB, 0.55530229E-07_JPRB, 0.56279688E-07_JPRB, &
  & 0.57008823E-07_JPRB, 0.57756399E-07_JPRB, 0.58473745E-07_JPRB, 0.59165977E-07_JPRB, 0.59847544E-07_JPRB, 0.60500746E-07_JPRB, &
  & 0.61141080E-07_JPRB, 0.61759302E-07_JPRB, 0.62338266E-07_JPRB, 0.62891488E-07_JPRB, 0.63392001E-07_JPRB, 0.63879817E-07_JPRB, &
  & 0.64306477E-07_JPRB, 0.64769885E-07_JPRB, 0.65124276E-07_JPRB, 0.65567839E-07_JPRB, 0.65678265E-07_JPRB, 0.66205509E-07_JPRB, &
  & 0.65987876E-07_JPRB, 0.66706292E-07_JPRB, 0.66179027E-07_JPRB, 0.66848543E-07_JPRB /)

RGHG7(:,86, 3) = (/ &
  & 0.34432237E-07_JPRB, 0.33662140E-07_JPRB, 0.34396109E-07_JPRB, 0.33918372E-07_JPRB, 0.34300903E-07_JPRB, 0.34326213E-07_JPRB, &
  & 0.34527609E-07_JPRB, 0.34749242E-07_JPRB, 0.34981227E-07_JPRB, 0.35191764E-07_JPRB, 0.35475292E-07_JPRB, 0.35749299E-07_JPRB, &
  & 0.36103689E-07_JPRB, 0.36496107E-07_JPRB, 0.36942552E-07_JPRB, 0.37420389E-07_JPRB, 0.37918628E-07_JPRB, 0.38402248E-07_JPRB, &
  & 0.38912908E-07_JPRB, 0.39432557E-07_JPRB, 0.39923311E-07_JPRB, 0.40488377E-07_JPRB, 0.41039435E-07_JPRB, 0.41656957E-07_JPRB, &
  & 0.42296833E-07_JPRB, 0.42981704E-07_JPRB, 0.43702546E-07_JPRB, 0.44456694E-07_JPRB, 0.45234394E-07_JPRB, 0.46033445E-07_JPRB, &
  & 0.46854673E-07_JPRB, 0.47683123E-07_JPRB, 0.48536890E-07_JPRB, 0.49385534E-07_JPRB, 0.50284523E-07_JPRB, 0.51177338E-07_JPRB, &
  & 0.52122449E-07_JPRB, 0.53028003E-07_JPRB, 0.53897534E-07_JPRB, 0.54800335E-07_JPRB, 0.55524215E-07_JPRB, 0.56324595E-07_JPRB, &
  & 0.57055022E-07_JPRB, 0.57776788E-07_JPRB, 0.58505524E-07_JPRB, 0.59190388E-07_JPRB, 0.59864391E-07_JPRB, 0.60523263E-07_JPRB, &
  & 0.61149223E-07_JPRB, 0.61775438E-07_JPRB, 0.62335332E-07_JPRB, 0.62911191E-07_JPRB, 0.63379360E-07_JPRB, 0.63915742E-07_JPRB, &
  & 0.64276655E-07_JPRB, 0.64832889E-07_JPRB, 0.65065194E-07_JPRB, 0.65653012E-07_JPRB, 0.65594861E-07_JPRB, 0.66287640E-07_JPRB, &
  & 0.65916929E-07_JPRB, 0.66752008E-07_JPRB, 0.66128329E-07_JPRB, 0.66874684E-07_JPRB /)

RGHG7(:,87, 3) = (/ &
  & 0.34469146E-07_JPRB, 0.33612316E-07_JPRB, 0.34443580E-07_JPRB, 0.33833413E-07_JPRB, 0.34392574E-07_JPRB, 0.34255962E-07_JPRB, &
  & 0.34606582E-07_JPRB, 0.34784254E-07_JPRB, 0.34993231E-07_JPRB, 0.35232411E-07_JPRB, 0.35487815E-07_JPRB, 0.35756301E-07_JPRB, &
  & 0.36086028E-07_JPRB, 0.36466041E-07_JPRB, 0.36898836E-07_JPRB, 0.37377472E-07_JPRB, 0.37874081E-07_JPRB, 0.38379671E-07_JPRB, &
  & 0.38901515E-07_JPRB, 0.39390901E-07_JPRB, 0.39930427E-07_JPRB, 0.40465096E-07_JPRB, 0.41030667E-07_JPRB, 0.41636316E-07_JPRB, &
  & 0.42285436E-07_JPRB, 0.42974637E-07_JPRB, 0.43699618E-07_JPRB, 0.44460521E-07_JPRB, 0.45239961E-07_JPRB, 0.46046004E-07_JPRB, &
  & 0.46864624E-07_JPRB, 0.47699100E-07_JPRB, 0.48543235E-07_JPRB, 0.49409966E-07_JPRB, 0.50298123E-07_JPRB, 0.51235482E-07_JPRB, &
  & 0.52147801E-07_JPRB, 0.53114888E-07_JPRB, 0.53987172E-07_JPRB, 0.54822411E-07_JPRB, 0.55651586E-07_JPRB, 0.56373853E-07_JPRB, &
  & 0.57111087E-07_JPRB, 0.57835102E-07_JPRB, 0.58535129E-07_JPRB, 0.59220454E-07_JPRB, 0.59874139E-07_JPRB, 0.60530567E-07_JPRB, &
  & 0.61152505E-07_JPRB, 0.61783503E-07_JPRB, 0.62338565E-07_JPRB, 0.62920890E-07_JPRB, 0.63376369E-07_JPRB, 0.63928219E-07_JPRB, &
  & 0.64260348E-07_JPRB, 0.64851584E-07_JPRB, 0.65037334E-07_JPRB, 0.65670733E-07_JPRB, 0.65570802E-07_JPRB, 0.66290823E-07_JPRB, &
  & 0.65909191E-07_JPRB, 0.66744505E-07_JPRB, 0.66119945E-07_JPRB, 0.66884404E-07_JPRB /)

RGHG7(:,88, 3) = (/ &
  & 0.34485417E-07_JPRB, 0.33604259E-07_JPRB, 0.34448188E-07_JPRB, 0.33805531E-07_JPRB, 0.34443534E-07_JPRB, 0.34194258E-07_JPRB, &
  & 0.34702900E-07_JPRB, 0.34691084E-07_JPRB, 0.35070048E-07_JPRB, 0.35197210E-07_JPRB, 0.35482881E-07_JPRB, 0.35744836E-07_JPRB, &
  & 0.36071700E-07_JPRB, 0.36440195E-07_JPRB, 0.36874034E-07_JPRB, 0.37341668E-07_JPRB, 0.37851891E-07_JPRB, 0.38354155E-07_JPRB, &
  & 0.38866542E-07_JPRB, 0.39379852E-07_JPRB, 0.39908709E-07_JPRB, 0.40439033E-07_JPRB, 0.41015330E-07_JPRB, 0.41621259E-07_JPRB, &
  & 0.42272731E-07_JPRB, 0.42963329E-07_JPRB, 0.43692634E-07_JPRB, 0.44457448E-07_JPRB, 0.45239123E-07_JPRB, 0.46047461E-07_JPRB, &
  & 0.46872497E-07_JPRB, 0.47713968E-07_JPRB, 0.48560036E-07_JPRB, 0.49436146E-07_JPRB, 0.50342766E-07_JPRB, 0.51281440E-07_JPRB, &
  & 0.52249366E-07_JPRB, 0.53173451E-07_JPRB, 0.54101228E-07_JPRB, 0.54937871E-07_JPRB, 0.55716033E-07_JPRB, 0.56475656E-07_JPRB, &
  & 0.57196523E-07_JPRB, 0.57897690E-07_JPRB, 0.58582941E-07_JPRB, 0.59252766E-07_JPRB, 0.59901168E-07_JPRB, 0.60550263E-07_JPRB, &
  & 0.61168656E-07_JPRB, 0.61791063E-07_JPRB, 0.62351496E-07_JPRB, 0.62924535E-07_JPRB, 0.63391475E-07_JPRB, 0.63930614E-07_JPRB, &
  & 0.64280208E-07_JPRB, 0.64849054E-07_JPRB, 0.65064185E-07_JPRB, 0.65653069E-07_JPRB, 0.65604674E-07_JPRB, 0.66260270E-07_JPRB, &
  & 0.65944043E-07_JPRB, 0.66709958E-07_JPRB, 0.66148850E-07_JPRB, 0.66860864E-07_JPRB /)

RGHG7(:,89, 3) = (/ &
  & 0.34485549E-07_JPRB, 0.33607503E-07_JPRB, 0.34424264E-07_JPRB, 0.33827053E-07_JPRB, 0.34396574E-07_JPRB, 0.34195079E-07_JPRB, &
  & 0.34607897E-07_JPRB, 0.34711640E-07_JPRB, 0.34972377E-07_JPRB, 0.35151590E-07_JPRB, 0.35429586E-07_JPRB, 0.35698623E-07_JPRB, &
  & 0.36045336E-07_JPRB, 0.36424254E-07_JPRB, 0.36861223E-07_JPRB, 0.37337575E-07_JPRB, 0.37837118E-07_JPRB, 0.38338801E-07_JPRB, &
  & 0.38853269E-07_JPRB, 0.39358625E-07_JPRB, 0.39881943E-07_JPRB, 0.40418982E-07_JPRB, 0.40986915E-07_JPRB, 0.41596433E-07_JPRB, &
  & 0.42248789E-07_JPRB, 0.42944404E-07_JPRB, 0.43679044E-07_JPRB, 0.44450278E-07_JPRB, 0.45243638E-07_JPRB, 0.46063519E-07_JPRB, &
  & 0.46900862E-07_JPRB, 0.47740411E-07_JPRB, 0.48604296E-07_JPRB, 0.49480864E-07_JPRB, 0.50426522E-07_JPRB, 0.51387619E-07_JPRB, &
  & 0.52360441E-07_JPRB, 0.53321688E-07_JPRB, 0.54210709E-07_JPRB, 0.55065282E-07_JPRB, 0.55854152E-07_JPRB, 0.56581488E-07_JPRB, &
  & 0.57285249E-07_JPRB, 0.57979516E-07_JPRB, 0.58634772E-07_JPRB, 0.59281941E-07_JPRB, 0.59918733E-07_JPRB, 0.60559984E-07_JPRB, &
  & 0.61185048E-07_JPRB, 0.61801138E-07_JPRB, 0.62371363E-07_JPRB, 0.62931029E-07_JPRB, 0.63415889E-07_JPRB, 0.63927821E-07_JPRB, &
  & 0.64311941E-07_JPRB, 0.64830942E-07_JPRB, 0.65108580E-07_JPRB, 0.65615417E-07_JPRB, 0.65656273E-07_JPRB, 0.66213097E-07_JPRB, &
  & 0.65995891E-07_JPRB, 0.66663844E-07_JPRB, 0.66192797E-07_JPRB, 0.66827035E-07_JPRB /)

RGHG7(:,90, 3) = (/ &
  & 0.34486277E-07_JPRB, 0.33670215E-07_JPRB, 0.34330256E-07_JPRB, 0.33928188E-07_JPRB, 0.34246270E-07_JPRB, 0.34242237E-07_JPRB, &
  & 0.34458871E-07_JPRB, 0.34615056E-07_JPRB, 0.34813777E-07_JPRB, 0.35057315E-07_JPRB, 0.35313217E-07_JPRB, 0.35636418E-07_JPRB, &
  & 0.35997829E-07_JPRB, 0.36410864E-07_JPRB, 0.36859980E-07_JPRB, 0.37337752E-07_JPRB, 0.37829672E-07_JPRB, 0.38327968E-07_JPRB, &
  & 0.38825085E-07_JPRB, 0.39329787E-07_JPRB, 0.39844590E-07_JPRB, 0.40378524E-07_JPRB, 0.40945338E-07_JPRB, 0.41554841E-07_JPRB, &
  & 0.42210853E-07_JPRB, 0.42911797E-07_JPRB, 0.43653266E-07_JPRB, 0.44432841E-07_JPRB, 0.45236614E-07_JPRB, 0.46073477E-07_JPRB, &
  & 0.46919773E-07_JPRB, 0.47786301E-07_JPRB, 0.48671943E-07_JPRB, 0.49593638E-07_JPRB, 0.50563788E-07_JPRB, 0.51565060E-07_JPRB, &
  & 0.52559020E-07_JPRB, 0.53509275E-07_JPRB, 0.54405266E-07_JPRB, 0.55232952E-07_JPRB, 0.56002484E-07_JPRB, 0.56724698E-07_JPRB, &
  & 0.57407991E-07_JPRB, 0.58063900E-07_JPRB, 0.58705268E-07_JPRB, 0.59335914E-07_JPRB, 0.59964648E-07_JPRB, 0.60592519E-07_JPRB, &
  & 0.61215907E-07_JPRB, 0.61824821E-07_JPRB, 0.62401497E-07_JPRB, 0.62950747E-07_JPRB, 0.63451139E-07_JPRB, 0.63940355E-07_JPRB, &
  & 0.64355945E-07_JPRB, 0.64830374E-07_JPRB, 0.65167477E-07_JPRB, 0.65587038E-07_JPRB, 0.65727882E-07_JPRB, 0.66158378E-07_JPRB, &
  & 0.66077043E-07_JPRB, 0.66595476E-07_JPRB, 0.66272307E-07_JPRB, 0.66772216E-07_JPRB /)

RGHG7(:,91, 3) = (/ &
  & 0.34337120E-07_JPRB, 0.33885765E-07_JPRB, 0.34135258E-07_JPRB, 0.34048963E-07_JPRB, 0.34130508E-07_JPRB, 0.34217919E-07_JPRB, &
  & 0.34314549E-07_JPRB, 0.34461348E-07_JPRB, 0.34635594E-07_JPRB, 0.34856896E-07_JPRB, 0.35153267E-07_JPRB, 0.35524359E-07_JPRB, &
  & 0.35945025E-07_JPRB, 0.36390219E-07_JPRB, 0.36854832E-07_JPRB, 0.37330093E-07_JPRB, 0.37813162E-07_JPRB, 0.38297511E-07_JPRB, &
  & 0.38782566E-07_JPRB, 0.39275868E-07_JPRB, 0.39782677E-07_JPRB, 0.40312170E-07_JPRB, 0.40875001E-07_JPRB, 0.41485965E-07_JPRB, &
  & 0.42147470E-07_JPRB, 0.42859305E-07_JPRB, 0.43615238E-07_JPRB, 0.44411625E-07_JPRB, 0.45236593E-07_JPRB, 0.46106589E-07_JPRB, &
  & 0.46981054E-07_JPRB, 0.47873424E-07_JPRB, 0.48802491E-07_JPRB, 0.49762711E-07_JPRB, 0.50783239E-07_JPRB, 0.51813490E-07_JPRB, &
  & 0.52840381E-07_JPRB, 0.53793297E-07_JPRB, 0.54679980E-07_JPRB, 0.55507659E-07_JPRB, 0.56249334E-07_JPRB, 0.56930688E-07_JPRB, &
  & 0.57573263E-07_JPRB, 0.58197799E-07_JPRB, 0.58801430E-07_JPRB, 0.59404396E-07_JPRB, 0.60020263E-07_JPRB, 0.60640645E-07_JPRB, &
  & 0.61263250E-07_JPRB, 0.61869173E-07_JPRB, 0.62448265E-07_JPRB, 0.62993621E-07_JPRB, 0.63500678E-07_JPRB, 0.63977375E-07_JPRB, &
  & 0.64407246E-07_JPRB, 0.64859556E-07_JPRB, 0.65232292E-07_JPRB, 0.65578931E-07_JPRB, 0.65810880E-07_JPRB, 0.66103517E-07_JPRB, &
  & 0.66192399E-07_JPRB, 0.66493129E-07_JPRB, 0.66422672E-07_JPRB, 0.66645640E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG7(:, 1, 4) = (/ &
  & 0.59702215E-05_JPRB, 0.59483759E-05_JPRB, 0.59300851E-05_JPRB, 0.59114982E-05_JPRB, 0.58737091E-05_JPRB, 0.66917409E-07_JPRB, &
  & 0.65816742E-07_JPRB, 0.65589710E-07_JPRB, 0.65634701E-07_JPRB, 0.65847580E-07_JPRB, 0.66161192E-07_JPRB, 0.66510069E-07_JPRB, &
  & 0.66948736E-07_JPRB, 0.67411904E-07_JPRB, 0.67852753E-07_JPRB, 0.68201352E-07_JPRB, 0.68550584E-07_JPRB, 0.68862192E-07_JPRB, &
  & 0.69130756E-07_JPRB, 0.69346910E-07_JPRB, 0.69542224E-07_JPRB, 0.69608525E-07_JPRB, 0.69638119E-07_JPRB, 0.69557537E-07_JPRB, &
  & 0.69324045E-07_JPRB, 0.68920642E-07_JPRB, 0.68440301E-07_JPRB, 0.67991671E-07_JPRB, 0.67648131E-07_JPRB, 0.67430939E-07_JPRB, &
  & 0.67356602E-07_JPRB, 0.67355209E-07_JPRB, 0.67616391E-07_JPRB, 0.68042866E-07_JPRB, 0.68586765E-07_JPRB, 0.69139304E-07_JPRB, &
  & 0.69687218E-07_JPRB, 0.70121352E-07_JPRB, 0.70487104E-07_JPRB, 0.70705944E-07_JPRB, 0.70807040E-07_JPRB, 0.70786051E-07_JPRB, &
  & 0.70629966E-07_JPRB, 0.70454909E-07_JPRB, 0.70258025E-07_JPRB, 0.70097549E-07_JPRB, 0.69747550E-07_JPRB, 0.69538466E-07_JPRB, &
  & 0.69256373E-07_JPRB, 0.68990531E-07_JPRB, 0.68810508E-07_JPRB, 0.68807473E-07_JPRB, 0.68909699E-07_JPRB, 0.69059993E-07_JPRB, &
  & 0.69440475E-07_JPRB, 0.70274311E-07_JPRB, 0.72364706E-07_JPRB, 0.74118660E-07_JPRB, 0.74963346E-07_JPRB, 0.75638617E-07_JPRB, &
  & 0.76963751E-07_JPRB, 0.79699483E-07_JPRB, 0.84497692E-07_JPRB, 0.92524623E-07_JPRB /)

RGHG7(:, 2, 4) = (/ &
  & 0.61264091E-05_JPRB, 0.62005356E-05_JPRB, 0.61010333E-05_JPRB, 0.59417976E-05_JPRB, 0.52072810E-05_JPRB, 0.15123790E-06_JPRB, &
  & 0.14738200E-06_JPRB, 0.15045774E-06_JPRB, 0.15404859E-06_JPRB, 0.16042370E-06_JPRB, 0.16796463E-06_JPRB, 0.17096993E-06_JPRB, &
  & 0.17612759E-06_JPRB, 0.18196046E-06_JPRB, 0.18691067E-06_JPRB, 0.18642082E-06_JPRB, 0.18908324E-06_JPRB, 0.19312633E-06_JPRB, &
  & 0.19711013E-06_JPRB, 0.20054604E-06_JPRB, 0.20362057E-06_JPRB, 0.20242811E-06_JPRB, 0.20306412E-06_JPRB, 0.20563027E-06_JPRB, &
  & 0.20981497E-06_JPRB, 0.21414307E-06_JPRB, 0.21723797E-06_JPRB, 0.21875761E-06_JPRB, 0.21904614E-06_JPRB, 0.21824711E-06_JPRB, &
  & 0.21751204E-06_JPRB, 0.20962493E-06_JPRB, 0.20562426E-06_JPRB, 0.20493080E-06_JPRB, 0.20548077E-06_JPRB, 0.20645240E-06_JPRB, &
  & 0.20800506E-06_JPRB, 0.20967916E-06_JPRB, 0.21198983E-06_JPRB, 0.21457882E-06_JPRB, 0.21691289E-06_JPRB, 0.21853026E-06_JPRB, &
  & 0.21815268E-06_JPRB, 0.22137037E-06_JPRB, 0.22607198E-06_JPRB, 0.23396379E-06_JPRB, 0.24121991E-06_JPRB, 0.25078134E-06_JPRB, &
  & 0.25990107E-06_JPRB, 0.26626262E-06_JPRB, 0.27562541E-06_JPRB, 0.29364605E-06_JPRB, 0.31524095E-06_JPRB, 0.33981664E-06_JPRB, &
  & 0.38809313E-06_JPRB, 0.48764542E-06_JPRB, 0.69689190E-06_JPRB, 0.89062257E-06_JPRB, 0.10071971E-05_JPRB, 0.11137674E-05_JPRB, &
  & 0.12525092E-05_JPRB, 0.14632006E-05_JPRB, 0.17566417E-05_JPRB, 0.21766068E-05_JPRB /)

RGHG7(:, 3, 4) = (/ &
  & 0.57752522E-05_JPRB, 0.50023336E-05_JPRB, 0.41032927E-05_JPRB, 0.31900877E-05_JPRB, 0.22070478E-05_JPRB, 0.17837307E-06_JPRB, &
  & 0.18748544E-06_JPRB, 0.20831938E-06_JPRB, 0.23096182E-06_JPRB, 0.25618053E-06_JPRB, 0.28204863E-06_JPRB, 0.29678120E-06_JPRB, &
  & 0.31180008E-06_JPRB, 0.32645644E-06_JPRB, 0.34175795E-06_JPRB, 0.34593390E-06_JPRB, 0.35148872E-06_JPRB, 0.35909875E-06_JPRB, &
  & 0.36757288E-06_JPRB, 0.37351876E-06_JPRB, 0.38018945E-06_JPRB, 0.37899619E-06_JPRB, 0.38137296E-06_JPRB, 0.38714271E-06_JPRB, &
  & 0.39337263E-06_JPRB, 0.39831909E-06_JPRB, 0.40238569E-06_JPRB, 0.40444115E-06_JPRB, 0.40737899E-06_JPRB, 0.40690369E-06_JPRB, &
  & 0.41091420E-06_JPRB, 0.40205049E-06_JPRB, 0.39663195E-06_JPRB, 0.39734084E-06_JPRB, 0.40096430E-06_JPRB, 0.40467853E-06_JPRB, &
  & 0.40908543E-06_JPRB, 0.41313871E-06_JPRB, 0.41835941E-06_JPRB, 0.42348518E-06_JPRB, 0.42861291E-06_JPRB, 0.43169095E-06_JPRB, &
  & 0.42965013E-06_JPRB, 0.43653503E-06_JPRB, 0.44722731E-06_JPRB, 0.46222681E-06_JPRB, 0.47893730E-06_JPRB, 0.49693853E-06_JPRB, &
  & 0.51362616E-06_JPRB, 0.52684459E-06_JPRB, 0.54628674E-06_JPRB, 0.57611339E-06_JPRB, 0.61155941E-06_JPRB, 0.64430907E-06_JPRB, &
  & 0.70395856E-06_JPRB, 0.83145744E-06_JPRB, 0.11161645E-05_JPRB, 0.13762310E-05_JPRB, 0.14460247E-05_JPRB, 0.15409397E-05_JPRB, &
  & 0.16474675E-05_JPRB, 0.18997418E-05_JPRB, 0.22361505E-05_JPRB, 0.28795930E-05_JPRB /)

RGHG7(:, 4, 4) = (/ &
  & 0.47692406E-05_JPRB, 0.33413414E-05_JPRB, 0.26982900E-05_JPRB, 0.23722573E-05_JPRB, 0.21480212E-05_JPRB, 0.45824643E-06_JPRB, &
  & 0.43066402E-06_JPRB, 0.42223195E-06_JPRB, 0.41608624E-06_JPRB, 0.42135503E-06_JPRB, 0.44899815E-06_JPRB, 0.46869167E-06_JPRB, &
  & 0.49145854E-06_JPRB, 0.51680883E-06_JPRB, 0.54462623E-06_JPRB, 0.55662008E-06_JPRB, 0.56780038E-06_JPRB, 0.58884126E-06_JPRB, &
  & 0.61275807E-06_JPRB, 0.63311654E-06_JPRB, 0.65682752E-06_JPRB, 0.66030020E-06_JPRB, 0.66561000E-06_JPRB, 0.67585404E-06_JPRB, &
  & 0.68754656E-06_JPRB, 0.69680743E-06_JPRB, 0.70635576E-06_JPRB, 0.71140602E-06_JPRB, 0.72114824E-06_JPRB, 0.72252794E-06_JPRB, &
  & 0.73573472E-06_JPRB, 0.72720388E-06_JPRB, 0.72175709E-06_JPRB, 0.72350002E-06_JPRB, 0.73241858E-06_JPRB, 0.73895529E-06_JPRB, &
  & 0.74684903E-06_JPRB, 0.75307804E-06_JPRB, 0.75987435E-06_JPRB, 0.76550731E-06_JPRB, 0.77110525E-06_JPRB, 0.77134820E-06_JPRB, &
  & 0.75900789E-06_JPRB, 0.76266900E-06_JPRB, 0.77265986E-06_JPRB, 0.78566990E-06_JPRB, 0.79819876E-06_JPRB, 0.81208327E-06_JPRB, &
  & 0.81944012E-06_JPRB, 0.81659721E-06_JPRB, 0.82234658E-06_JPRB, 0.82904705E-06_JPRB, 0.83292679E-06_JPRB, 0.82195089E-06_JPRB, &
  & 0.81578116E-06_JPRB, 0.82540868E-06_JPRB, 0.91011731E-06_JPRB, 0.98497367E-06_JPRB, 0.10334027E-05_JPRB, 0.11626275E-05_JPRB, &
  & 0.12719518E-05_JPRB, 0.15411125E-05_JPRB, 0.17119843E-05_JPRB, 0.19195506E-05_JPRB /)

RGHG7(:, 5, 4) = (/ &
  & 0.38212115E-05_JPRB, 0.25317170E-05_JPRB, 0.20756358E-05_JPRB, 0.16066067E-05_JPRB, 0.12848722E-05_JPRB, 0.61649172E-06_JPRB, &
  & 0.62822778E-06_JPRB, 0.66254387E-06_JPRB, 0.68459042E-06_JPRB, 0.69353109E-06_JPRB, 0.71132246E-06_JPRB, 0.72103984E-06_JPRB, &
  & 0.74369700E-06_JPRB, 0.77258250E-06_JPRB, 0.80882029E-06_JPRB, 0.83003630E-06_JPRB, 0.84590056E-06_JPRB, 0.87721412E-06_JPRB, &
  & 0.90590402E-06_JPRB, 0.93447989E-06_JPRB, 0.96854217E-06_JPRB, 0.97518853E-06_JPRB, 0.98269163E-06_JPRB, 0.99781880E-06_JPRB, &
  & 0.10169517E-05_JPRB, 0.10309351E-05_JPRB, 0.10481257E-05_JPRB, 0.10568497E-05_JPRB, 0.10757361E-05_JPRB, 0.10817400E-05_JPRB, &
  & 0.11036118E-05_JPRB, 0.10995212E-05_JPRB, 0.10934547E-05_JPRB, 0.10976565E-05_JPRB, 0.11110322E-05_JPRB, 0.11196348E-05_JPRB, &
  & 0.11292547E-05_JPRB, 0.11358428E-05_JPRB, 0.11431566E-05_JPRB, 0.11475640E-05_JPRB, 0.11503059E-05_JPRB, 0.11434199E-05_JPRB, &
  & 0.11166837E-05_JPRB, 0.11147811E-05_JPRB, 0.11179793E-05_JPRB, 0.11211556E-05_JPRB, 0.11222722E-05_JPRB, 0.11217741E-05_JPRB, &
  & 0.11136734E-05_JPRB, 0.10915953E-05_JPRB, 0.10801724E-05_JPRB, 0.10731103E-05_JPRB, 0.10664556E-05_JPRB, 0.10525505E-05_JPRB, &
  & 0.10503409E-05_JPRB, 0.10633340E-05_JPRB, 0.11136385E-05_JPRB, 0.11620946E-05_JPRB, 0.11797351E-05_JPRB, 0.11790968E-05_JPRB, &
  & 0.12436838E-05_JPRB, 0.14174198E-05_JPRB, 0.16319173E-05_JPRB, 0.23103867E-05_JPRB /)

RGHG7(:, 6, 4) = (/ &
  & 0.30001224E-05_JPRB, 0.19779575E-05_JPRB, 0.16022385E-05_JPRB, 0.14221322E-05_JPRB, 0.14302043E-05_JPRB, 0.11527291E-05_JPRB, &
  & 0.10975529E-05_JPRB, 0.10899721E-05_JPRB, 0.10894023E-05_JPRB, 0.10965384E-05_JPRB, 0.11065745E-05_JPRB, 0.11117131E-05_JPRB, &
  & 0.11169618E-05_JPRB, 0.11286896E-05_JPRB, 0.11538020E-05_JPRB, 0.11708672E-05_JPRB, 0.11860444E-05_JPRB, 0.12161375E-05_JPRB, &
  & 0.12439536E-05_JPRB, 0.12806838E-05_JPRB, 0.13174466E-05_JPRB, 0.13291341E-05_JPRB, 0.13389965E-05_JPRB, 0.13576531E-05_JPRB, &
  & 0.13859411E-05_JPRB, 0.14064929E-05_JPRB, 0.14361643E-05_JPRB, 0.14519676E-05_JPRB, 0.14808195E-05_JPRB, 0.14909889E-05_JPRB, &
  & 0.15173767E-05_JPRB, 0.15141904E-05_JPRB, 0.15061661E-05_JPRB, 0.15111254E-05_JPRB, 0.15236418E-05_JPRB, 0.15322809E-05_JPRB, &
  & 0.15434414E-05_JPRB, 0.15505206E-05_JPRB, 0.15581559E-05_JPRB, 0.15622217E-05_JPRB, 0.15638603E-05_JPRB, 0.15541634E-05_JPRB, &
  & 0.15168678E-05_JPRB, 0.15049599E-05_JPRB, 0.14938690E-05_JPRB, 0.14845730E-05_JPRB, 0.14736135E-05_JPRB, 0.14594906E-05_JPRB, &
  & 0.14377579E-05_JPRB, 0.14004123E-05_JPRB, 0.13788286E-05_JPRB, 0.13609676E-05_JPRB, 0.13386659E-05_JPRB, 0.13011816E-05_JPRB, &
  & 0.12567989E-05_JPRB, 0.11981997E-05_JPRB, 0.11535453E-05_JPRB, 0.11490527E-05_JPRB, 0.11382804E-05_JPRB, 0.11264631E-05_JPRB, &
  & 0.11746953E-05_JPRB, 0.12834864E-05_JPRB, 0.13863338E-05_JPRB, 0.15312027E-05_JPRB /)

RGHG7(:, 7, 4) = (/ &
  & 0.23448681E-05_JPRB, 0.17311930E-05_JPRB, 0.15652558E-05_JPRB, 0.15152865E-05_JPRB, 0.15655778E-05_JPRB, 0.16176925E-05_JPRB, &
  & 0.16950116E-05_JPRB, 0.17096065E-05_JPRB, 0.16981938E-05_JPRB, 0.16864770E-05_JPRB, 0.16874208E-05_JPRB, 0.16899114E-05_JPRB, &
  & 0.16810468E-05_JPRB, 0.16820705E-05_JPRB, 0.16922994E-05_JPRB, 0.16958932E-05_JPRB, 0.16964671E-05_JPRB, 0.17104705E-05_JPRB, &
  & 0.17327287E-05_JPRB, 0.17648414E-05_JPRB, 0.17910188E-05_JPRB, 0.18052474E-05_JPRB, 0.18115239E-05_JPRB, 0.18321858E-05_JPRB, &
  & 0.18650017E-05_JPRB, 0.18916554E-05_JPRB, 0.19308825E-05_JPRB, 0.19530651E-05_JPRB, 0.19894103E-05_JPRB, 0.20021998E-05_JPRB, &
  & 0.20291529E-05_JPRB, 0.20230727E-05_JPRB, 0.20027019E-05_JPRB, 0.20052448E-05_JPRB, 0.20197213E-05_JPRB, 0.20315824E-05_JPRB, &
  & 0.20429668E-05_JPRB, 0.20506393E-05_JPRB, 0.20588463E-05_JPRB, 0.20637792E-05_JPRB, 0.20640657E-05_JPRB, 0.20486984E-05_JPRB, &
  & 0.20000018E-05_JPRB, 0.19805784E-05_JPRB, 0.19630374E-05_JPRB, 0.19441788E-05_JPRB, 0.19197189E-05_JPRB, 0.18921717E-05_JPRB, &
  & 0.18578222E-05_JPRB, 0.18099023E-05_JPRB, 0.17772278E-05_JPRB, 0.17484540E-05_JPRB, 0.17143676E-05_JPRB, 0.16751934E-05_JPRB, &
  & 0.16540182E-05_JPRB, 0.16419045E-05_JPRB, 0.16404005E-05_JPRB, 0.16222569E-05_JPRB, 0.15961766E-05_JPRB, 0.16031833E-05_JPRB, &
  & 0.16590674E-05_JPRB, 0.17556373E-05_JPRB, 0.18959228E-05_JPRB, 0.22049860E-05_JPRB /)

RGHG7(:, 8, 4) = (/ &
  & 0.19961617E-05_JPRB, 0.17361091E-05_JPRB, 0.17485886E-05_JPRB, 0.18670802E-05_JPRB, 0.20399684E-05_JPRB, 0.21669446E-05_JPRB, &
  & 0.23757095E-05_JPRB, 0.24458373E-05_JPRB, 0.24324991E-05_JPRB, 0.23931436E-05_JPRB, 0.23665827E-05_JPRB, 0.23425450E-05_JPRB, &
  & 0.23100799E-05_JPRB, 0.22928261E-05_JPRB, 0.22846566E-05_JPRB, 0.22718082E-05_JPRB, 0.22524393E-05_JPRB, 0.22478748E-05_JPRB, &
  & 0.22555753E-05_JPRB, 0.22690731E-05_JPRB, 0.22835898E-05_JPRB, 0.22963952E-05_JPRB, 0.22960321E-05_JPRB, 0.23171165E-05_JPRB, &
  & 0.23457958E-05_JPRB, 0.23768660E-05_JPRB, 0.24136668E-05_JPRB, 0.24376668E-05_JPRB, 0.24726007E-05_JPRB, 0.24869189E-05_JPRB, &
  & 0.25143022E-05_JPRB, 0.25105217E-05_JPRB, 0.24969877E-05_JPRB, 0.24999902E-05_JPRB, 0.25040219E-05_JPRB, 0.25036220E-05_JPRB, &
  & 0.25096756E-05_JPRB, 0.25140396E-05_JPRB, 0.25169554E-05_JPRB, 0.25134611E-05_JPRB, 0.25059619E-05_JPRB, 0.24864053E-05_JPRB, &
  & 0.24365625E-05_JPRB, 0.24118165E-05_JPRB, 0.23859279E-05_JPRB, 0.23590026E-05_JPRB, 0.23303412E-05_JPRB, 0.23006498E-05_JPRB, &
  & 0.22639215E-05_JPRB, 0.22139379E-05_JPRB, 0.21788926E-05_JPRB, 0.21495730E-05_JPRB, 0.21204999E-05_JPRB, 0.20802718E-05_JPRB, &
  & 0.20368796E-05_JPRB, 0.19830679E-05_JPRB, 0.19346264E-05_JPRB, 0.19095830E-05_JPRB, 0.19059926E-05_JPRB, 0.19055663E-05_JPRB, &
  & 0.19345146E-05_JPRB, 0.19903566E-05_JPRB, 0.20608159E-05_JPRB, 0.21324515E-05_JPRB /)

RGHG7(:, 9, 4) = (/ &
  & 0.19027573E-05_JPRB, 0.19986448E-05_JPRB, 0.21374080E-05_JPRB, 0.22685606E-05_JPRB, 0.24292497E-05_JPRB, 0.26077528E-05_JPRB, &
  & 0.29515436E-05_JPRB, 0.31894137E-05_JPRB, 0.32688895E-05_JPRB, 0.32559715E-05_JPRB, 0.32201824E-05_JPRB, 0.31716756E-05_JPRB, &
  & 0.31079037E-05_JPRB, 0.30607257E-05_JPRB, 0.30235415E-05_JPRB, 0.29836706E-05_JPRB, 0.29382300E-05_JPRB, 0.29106361E-05_JPRB, &
  & 0.28979193E-05_JPRB, 0.28916047E-05_JPRB, 0.28925654E-05_JPRB, 0.28945572E-05_JPRB, 0.28866061E-05_JPRB, 0.29026103E-05_JPRB, &
  & 0.29288849E-05_JPRB, 0.29575381E-05_JPRB, 0.29858966E-05_JPRB, 0.30111207E-05_JPRB, 0.30438935E-05_JPRB, 0.30595118E-05_JPRB, &
  & 0.30847925E-05_JPRB, 0.30791025E-05_JPRB, 0.30515182E-05_JPRB, 0.30459519E-05_JPRB, 0.30582498E-05_JPRB, 0.30668666E-05_JPRB, &
  & 0.30687049E-05_JPRB, 0.30592225E-05_JPRB, 0.30484503E-05_JPRB, 0.30361336E-05_JPRB, 0.30210269E-05_JPRB, 0.29933835E-05_JPRB, &
  & 0.29378180E-05_JPRB, 0.29041680E-05_JPRB, 0.28743289E-05_JPRB, 0.28459540E-05_JPRB, 0.28151433E-05_JPRB, 0.27817914E-05_JPRB, &
  & 0.27447829E-05_JPRB, 0.26971156E-05_JPRB, 0.26643613E-05_JPRB, 0.26384448E-05_JPRB, 0.26115749E-05_JPRB, 0.25801742E-05_JPRB, &
  & 0.25643376E-05_JPRB, 0.25551064E-05_JPRB, 0.25549220E-05_JPRB, 0.25557138E-05_JPRB, 0.25518139E-05_JPRB, 0.25522054E-05_JPRB, &
  & 0.25824311E-05_JPRB, 0.26404828E-05_JPRB, 0.27252613E-05_JPRB, 0.28853199E-05_JPRB /)

RGHG7(:,10, 4) = (/ &
  & 0.20745870E-05_JPRB, 0.23540097E-05_JPRB, 0.25439788E-05_JPRB, 0.27232256E-05_JPRB, 0.29037592E-05_JPRB, 0.30933443E-05_JPRB, &
  & 0.34461041E-05_JPRB, 0.37977691E-05_JPRB, 0.40264849E-05_JPRB, 0.41281273E-05_JPRB, 0.41552121E-05_JPRB, 0.41275553E-05_JPRB, &
  & 0.40599243E-05_JPRB, 0.39973820E-05_JPRB, 0.39387851E-05_JPRB, 0.38751969E-05_JPRB, 0.38017906E-05_JPRB, 0.37478069E-05_JPRB, &
  & 0.37086909E-05_JPRB, 0.36784825E-05_JPRB, 0.36558122E-05_JPRB, 0.36374524E-05_JPRB, 0.36103904E-05_JPRB, 0.36101346E-05_JPRB, &
  & 0.36202662E-05_JPRB, 0.36347651E-05_JPRB, 0.36504950E-05_JPRB, 0.36650451E-05_JPRB, 0.36833558E-05_JPRB, 0.36934180E-05_JPRB, &
  & 0.37171628E-05_JPRB, 0.37154189E-05_JPRB, 0.36998938E-05_JPRB, 0.37074426E-05_JPRB, 0.37061134E-05_JPRB, 0.36957224E-05_JPRB, &
  & 0.36866554E-05_JPRB, 0.36741212E-05_JPRB, 0.36586646E-05_JPRB, 0.36367130E-05_JPRB, 0.36109641E-05_JPRB, 0.35767100E-05_JPRB, &
  & 0.35195746E-05_JPRB, 0.34826705E-05_JPRB, 0.34513562E-05_JPRB, 0.34221316E-05_JPRB, 0.33928945E-05_JPRB, 0.33623869E-05_JPRB, &
  & 0.33275244E-05_JPRB, 0.32811765E-05_JPRB, 0.32519501E-05_JPRB, 0.32313055E-05_JPRB, 0.32141309E-05_JPRB, 0.31894074E-05_JPRB, &
  & 0.31691745E-05_JPRB, 0.31440388E-05_JPRB, 0.31238235E-05_JPRB, 0.31129982E-05_JPRB, 0.31101397E-05_JPRB, 0.31078753E-05_JPRB, &
  & 0.31199822E-05_JPRB, 0.31496293E-05_JPRB, 0.31940274E-05_JPRB, 0.32469191E-05_JPRB /)

RGHG7(:,11, 4) = (/ &
  & 0.24235919E-05_JPRB, 0.27815097E-05_JPRB, 0.29668067E-05_JPRB, 0.31270990E-05_JPRB, 0.32848850E-05_JPRB, 0.34522225E-05_JPRB, &
  & 0.37928164E-05_JPRB, 0.41909211E-05_JPRB, 0.45384572E-05_JPRB, 0.47933904E-05_JPRB, 0.49664313E-05_JPRB, 0.50547833E-05_JPRB, &
  & 0.50674803E-05_JPRB, 0.50534713E-05_JPRB, 0.50160506E-05_JPRB, 0.49563405E-05_JPRB, 0.48728348E-05_JPRB, 0.48038805E-05_JPRB, &
  & 0.47422800E-05_JPRB, 0.46860573E-05_JPRB, 0.46325081E-05_JPRB, 0.45775037E-05_JPRB, 0.45133538E-05_JPRB, 0.44743233E-05_JPRB, &
  & 0.44478838E-05_JPRB, 0.44267049E-05_JPRB, 0.44102690E-05_JPRB, 0.43998439E-05_JPRB, 0.44001331E-05_JPRB, 0.44030830E-05_JPRB, &
  & 0.44232202E-05_JPRB, 0.44284352E-05_JPRB, 0.44213816E-05_JPRB, 0.44294443E-05_JPRB, 0.44444178E-05_JPRB, 0.44550079E-05_JPRB, &
  & 0.44565591E-05_JPRB, 0.44474355E-05_JPRB, 0.44315602E-05_JPRB, 0.44092558E-05_JPRB, 0.43830032E-05_JPRB, 0.43480445E-05_JPRB, &
  & 0.42939364E-05_JPRB, 0.42599781E-05_JPRB, 0.42363549E-05_JPRB, 0.42173101E-05_JPRB, 0.41990033E-05_JPRB, 0.41821254E-05_JPRB, &
  & 0.41642243E-05_JPRB, 0.41370090E-05_JPRB, 0.41261205E-05_JPRB, 0.41232406E-05_JPRB, 0.41192898E-05_JPRB, 0.41092367E-05_JPRB, &
  & 0.41119902E-05_JPRB, 0.41132403E-05_JPRB, 0.41172375E-05_JPRB, 0.41222570E-05_JPRB, 0.41182925E-05_JPRB, 0.40965956E-05_JPRB, &
  & 0.40849081E-05_JPRB, 0.40830523E-05_JPRB, 0.40899195E-05_JPRB, 0.41418461E-05_JPRB /)

RGHG7(:,12, 4) = (/ &
  & 0.28675738E-05_JPRB, 0.31654486E-05_JPRB, 0.33334579E-05_JPRB, 0.34706623E-05_JPRB, 0.36044960E-05_JPRB, 0.37396517E-05_JPRB, &
  & 0.40430514E-05_JPRB, 0.44198528E-05_JPRB, 0.47922799E-05_JPRB, 0.51143443E-05_JPRB, 0.53735007E-05_JPRB, 0.55535129E-05_JPRB, &
  & 0.56541212E-05_JPRB, 0.57191291E-05_JPRB, 0.57484071E-05_JPRB, 0.57442694E-05_JPRB, 0.57101838E-05_JPRB, 0.56785216E-05_JPRB, &
  & 0.56466311E-05_JPRB, 0.56115282E-05_JPRB, 0.55721139E-05_JPRB, 0.55220989E-05_JPRB, 0.54560428E-05_JPRB, 0.54096595E-05_JPRB, &
  & 0.53733561E-05_JPRB, 0.53432341E-05_JPRB, 0.53189410E-05_JPRB, 0.53019003E-05_JPRB, 0.52980454E-05_JPRB, 0.53075623E-05_JPRB, &
  & 0.53397271E-05_JPRB, 0.53554172E-05_JPRB, 0.53611529E-05_JPRB, 0.53825374E-05_JPRB, 0.54036686E-05_JPRB, 0.54122524E-05_JPRB, &
  & 0.54134052E-05_JPRB, 0.54029269E-05_JPRB, 0.53864483E-05_JPRB, 0.53624735E-05_JPRB, 0.53315198E-05_JPRB, 0.52926457E-05_JPRB, &
  & 0.52371374E-05_JPRB, 0.52029332E-05_JPRB, 0.51828047E-05_JPRB, 0.51715647E-05_JPRB, 0.51680472E-05_JPRB, 0.51701413E-05_JPRB, &
  & 0.51696506E-05_JPRB, 0.51576767E-05_JPRB, 0.51633933E-05_JPRB, 0.51784900E-05_JPRB, 0.51943616E-05_JPRB, 0.52004502E-05_JPRB, &
  & 0.52092864E-05_JPRB, 0.52049654E-05_JPRB, 0.51889183E-05_JPRB, 0.51580660E-05_JPRB, 0.51018210E-05_JPRB, 0.50145168E-05_JPRB, &
  & 0.49420669E-05_JPRB, 0.48865254E-05_JPRB, 0.48416737E-05_JPRB, 0.47913381E-05_JPRB /)

RGHG7(:,13, 4) = (/ &
  & 0.32274406E-05_JPRB, 0.34625893E-05_JPRB, 0.35914009E-05_JPRB, 0.37084151E-05_JPRB, 0.38210123E-05_JPRB, 0.39290021E-05_JPRB, &
  & 0.41752228E-05_JPRB, 0.44892504E-05_JPRB, 0.48244369E-05_JPRB, 0.51493298E-05_JPRB, 0.54458828E-05_JPRB, 0.56879380E-05_JPRB, &
  & 0.58600781E-05_JPRB, 0.59939412E-05_JPRB, 0.60951402E-05_JPRB, 0.61628489E-05_JPRB, 0.62039840E-05_JPRB, 0.62427207E-05_JPRB, &
  & 0.62754571E-05_JPRB, 0.62992435E-05_JPRB, 0.63084813E-05_JPRB, 0.63030980E-05_JPRB, 0.62751628E-05_JPRB, 0.62575373E-05_JPRB, &
  & 0.62441013E-05_JPRB, 0.62356012E-05_JPRB, 0.62321333E-05_JPRB, 0.62350659E-05_JPRB, 0.62458412E-05_JPRB, 0.62627573E-05_JPRB, &
  & 0.62923841E-05_JPRB, 0.63077705E-05_JPRB, 0.63127973E-05_JPRB, 0.63398556E-05_JPRB, 0.63658931E-05_JPRB, 0.63813977E-05_JPRB, &
  & 0.63874895E-05_JPRB, 0.63797956E-05_JPRB, 0.63615139E-05_JPRB, 0.63365283E-05_JPRB, 0.63041384E-05_JPRB, 0.62643562E-05_JPRB, &
  & 0.62096319E-05_JPRB, 0.61781361E-05_JPRB, 0.61618443E-05_JPRB, 0.61597580E-05_JPRB, 0.61650107E-05_JPRB, 0.61743422E-05_JPRB, &
  & 0.61794635E-05_JPRB, 0.61729484E-05_JPRB, 0.61793667E-05_JPRB, 0.61869355E-05_JPRB, 0.61841902E-05_JPRB, 0.61598867E-05_JPRB, &
  & 0.61276451E-05_JPRB, 0.60708489E-05_JPRB, 0.59905947E-05_JPRB, 0.58849887E-05_JPRB, 0.57473439E-05_JPRB, 0.55776140E-05_JPRB, &
  & 0.54341513E-05_JPRB, 0.53137405E-05_JPRB, 0.52162513E-05_JPRB, 0.51233351E-05_JPRB /)

RGHG7(:,14, 4) = (/ &
  & 0.34875563E-05_JPRB, 0.36662977E-05_JPRB, 0.37714810E-05_JPRB, 0.38601115E-05_JPRB, 0.39543543E-05_JPRB, 0.40600366E-05_JPRB, &
  & 0.42683696E-05_JPRB, 0.45430297E-05_JPRB, 0.48356583E-05_JPRB, 0.51304173E-05_JPRB, 0.54194152E-05_JPRB, 0.56861877E-05_JPRB, &
  & 0.59113017E-05_JPRB, 0.61054075E-05_JPRB, 0.62703721E-05_JPRB, 0.64045594E-05_JPRB, 0.65153113E-05_JPRB, 0.66224457E-05_JPRB, &
  & 0.67212400E-05_JPRB, 0.68033887E-05_JPRB, 0.68647778E-05_JPRB, 0.69043658E-05_JPRB, 0.69201164E-05_JPRB, 0.69370749E-05_JPRB, &
  & 0.69581279E-05_JPRB, 0.69806247E-05_JPRB, 0.70086767E-05_JPRB, 0.70400301E-05_JPRB, 0.70762653E-05_JPRB, 0.71090071E-05_JPRB, &
  & 0.71378181E-05_JPRB, 0.71535906E-05_JPRB, 0.71541976E-05_JPRB, 0.71605759E-05_JPRB, 0.71811928E-05_JPRB, 0.72027447E-05_JPRB, &
  & 0.72169682E-05_JPRB, 0.72223997E-05_JPRB, 0.72235316E-05_JPRB, 0.72135417E-05_JPRB, 0.71909417E-05_JPRB, 0.71564177E-05_JPRB, &
  & 0.71039321E-05_JPRB, 0.70704391E-05_JPRB, 0.70495348E-05_JPRB, 0.70408068E-05_JPRB, 0.70373753E-05_JPRB, 0.70394817E-05_JPRB, &
  & 0.70349342E-05_JPRB, 0.70139840E-05_JPRB, 0.69944263E-05_JPRB, 0.69642551E-05_JPRB, 0.69122984E-05_JPRB, 0.68292634E-05_JPRB, &
  & 0.67285127E-05_JPRB, 0.65962199E-05_JPRB, 0.64363303E-05_JPRB, 0.62499103E-05_JPRB, 0.60367988E-05_JPRB, 0.58039773E-05_JPRB, &
  & 0.56101571E-05_JPRB, 0.54540265E-05_JPRB, 0.53244148E-05_JPRB, 0.52047963E-05_JPRB /)

RGHG7(:,15, 4) = (/ &
  & 0.36861020E-05_JPRB, 0.38226003E-05_JPRB, 0.39137994E-05_JPRB, 0.40000455E-05_JPRB, 0.40911223E-05_JPRB, 0.41920889E-05_JPRB, &
  & 0.43743330E-05_JPRB, 0.46441160E-05_JPRB, 0.49271453E-05_JPRB, 0.52055052E-05_JPRB, 0.54776974E-05_JPRB, 0.57379434E-05_JPRB, &
  & 0.59750496E-05_JPRB, 0.61959536E-05_JPRB, 0.63971825E-05_JPRB, 0.65724303E-05_JPRB, 0.67265319E-05_JPRB, 0.68774157E-05_JPRB, &
  & 0.70220121E-05_JPRB, 0.71522245E-05_JPRB, 0.72620915E-05_JPRB, 0.73491287E-05_JPRB, 0.74152140E-05_JPRB, 0.74790705E-05_JPRB, &
  & 0.75431485E-05_JPRB, 0.76072056E-05_JPRB, 0.76722508E-05_JPRB, 0.77328777E-05_JPRB, 0.77912182E-05_JPRB, 0.78362609E-05_JPRB, &
  & 0.78622143E-05_JPRB, 0.78660651E-05_JPRB, 0.78489093E-05_JPRB, 0.78432740E-05_JPRB, 0.78495777E-05_JPRB, 0.78601824E-05_JPRB, &
  & 0.78758358E-05_JPRB, 0.78880576E-05_JPRB, 0.78916883E-05_JPRB, 0.78885823E-05_JPRB, 0.78761041E-05_JPRB, 0.78480980E-05_JPRB, &
  & 0.77989844E-05_JPRB, 0.77608756E-05_JPRB, 0.77298992E-05_JPRB, 0.77059976E-05_JPRB, 0.76867482E-05_JPRB, 0.76681517E-05_JPRB, &
  & 0.76358965E-05_JPRB, 0.75801759E-05_JPRB, 0.75150492E-05_JPRB, 0.74324330E-05_JPRB, 0.73218689E-05_JPRB, 0.71787804E-05_JPRB, &
  & 0.70149263E-05_JPRB, 0.68214199E-05_JPRB, 0.66027901E-05_JPRB, 0.63632110E-05_JPRB, 0.61056703E-05_JPRB, 0.58425658E-05_JPRB, &
  & 0.56278964E-05_JPRB, 0.54553416E-05_JPRB, 0.53195208E-05_JPRB, 0.51851093E-05_JPRB /)

RGHG7(:,16, 4) = (/ &
  & 0.38462363E-05_JPRB, 0.39809674E-05_JPRB, 0.40691962E-05_JPRB, 0.41553981E-05_JPRB, 0.42459428E-05_JPRB, 0.43444816E-05_JPRB, &
  & 0.45045399E-05_JPRB, 0.47542703E-05_JPRB, 0.50191525E-05_JPRB, 0.52742539E-05_JPRB, 0.55198079E-05_JPRB, 0.57585767E-05_JPRB, &
  & 0.59848494E-05_JPRB, 0.62037293E-05_JPRB, 0.64160490E-05_JPRB, 0.66140265E-05_JPRB, 0.67964543E-05_JPRB, 0.69770213E-05_JPRB, &
  & 0.71572222E-05_JPRB, 0.73285946E-05_JPRB, 0.74823142E-05_JPRB, 0.76155138E-05_JPRB, 0.77270734E-05_JPRB, 0.78347284E-05_JPRB, &
  & 0.79365191E-05_JPRB, 0.80344689E-05_JPRB, 0.81271592E-05_JPRB, 0.82133874E-05_JPRB, 0.82814868E-05_JPRB, 0.83353652E-05_JPRB, &
  & 0.83630621E-05_JPRB, 0.83628101E-05_JPRB, 0.83369796E-05_JPRB, 0.83195728E-05_JPRB, 0.83088853E-05_JPRB, 0.83073528E-05_JPRB, &
  & 0.83135683E-05_JPRB, 0.83262667E-05_JPRB, 0.83386913E-05_JPRB, 0.83439454E-05_JPRB, 0.83365203E-05_JPRB, 0.83080222E-05_JPRB, &
  & 0.82539618E-05_JPRB, 0.82009410E-05_JPRB, 0.81464532E-05_JPRB, 0.80908230E-05_JPRB, 0.80336386E-05_JPRB, 0.79686415E-05_JPRB, &
  & 0.78872463E-05_JPRB, 0.77807190E-05_JPRB, 0.76637871E-05_JPRB, 0.75294192E-05_JPRB, 0.73706510E-05_JPRB, 0.71846716E-05_JPRB, &
  & 0.69809216E-05_JPRB, 0.67535607E-05_JPRB, 0.65079116E-05_JPRB, 0.62484905E-05_JPRB, 0.59824879E-05_JPRB, 0.57222810E-05_JPRB, &
  & 0.55133596E-05_JPRB, 0.53509025E-05_JPRB, 0.52218961E-05_JPRB, 0.51072120E-05_JPRB /)

RGHG7(:,17, 4) = (/ &
  & 0.40065647E-05_JPRB, 0.41284075E-05_JPRB, 0.42074889E-05_JPRB, 0.42842175E-05_JPRB, 0.43667978E-05_JPRB, 0.44593794E-05_JPRB, &
  & 0.46020909E-05_JPRB, 0.48135289E-05_JPRB, 0.50708663E-05_JPRB, 0.53271383E-05_JPRB, 0.55684877E-05_JPRB, 0.58005749E-05_JPRB, &
  & 0.60228404E-05_JPRB, 0.62419585E-05_JPRB, 0.64589262E-05_JPRB, 0.66724201E-05_JPRB, 0.68788331E-05_JPRB, 0.70809378E-05_JPRB, &
  & 0.72837011E-05_JPRB, 0.74830464E-05_JPRB, 0.76723081E-05_JPRB, 0.78436315E-05_JPRB, 0.79969159E-05_JPRB, 0.81428398E-05_JPRB, &
  & 0.82795414E-05_JPRB, 0.84087906E-05_JPRB, 0.85278261E-05_JPRB, 0.86330747E-05_JPRB, 0.87180870E-05_JPRB, 0.87758217E-05_JPRB, &
  & 0.88080888E-05_JPRB, 0.88062998E-05_JPRB, 0.87764347E-05_JPRB, 0.87454437E-05_JPRB, 0.87229546E-05_JPRB, 0.87120006E-05_JPRB, &
  & 0.87136796E-05_JPRB, 0.87227754E-05_JPRB, 0.87320232E-05_JPRB, 0.87326807E-05_JPRB, 0.87151602E-05_JPRB, 0.86759228E-05_JPRB, &
  & 0.86087166E-05_JPRB, 0.85342299E-05_JPRB, 0.84509375E-05_JPRB, 0.83596187E-05_JPRB, 0.82594788E-05_JPRB, 0.81461458E-05_JPRB, &
  & 0.80148066E-05_JPRB, 0.78604689E-05_JPRB, 0.76969391E-05_JPRB, 0.75186590E-05_JPRB, 0.73224910E-05_JPRB, 0.71059358E-05_JPRB, &
  & 0.68769623E-05_JPRB, 0.66317521E-05_JPRB, 0.63754956E-05_JPRB, 0.61147684E-05_JPRB, 0.58559626E-05_JPRB, 0.56130289E-05_JPRB, &
  & 0.54212455E-05_JPRB, 0.52745181E-05_JPRB, 0.51607230E-05_JPRB, 0.50524213E-05_JPRB /)

RGHG7(:,18, 4) = (/ &
  & 0.41520925E-05_JPRB, 0.42657416E-05_JPRB, 0.43433888E-05_JPRB, 0.44207154E-05_JPRB, 0.45054780E-05_JPRB, 0.45983534E-05_JPRB, &
  & 0.47284593E-05_JPRB, 0.49163277E-05_JPRB, 0.51614102E-05_JPRB, 0.54149914E-05_JPRB, 0.56533991E-05_JPRB, 0.58794922E-05_JPRB, &
  & 0.60967168E-05_JPRB, 0.63084194E-05_JPRB, 0.65178506E-05_JPRB, 0.67264368E-05_JPRB, 0.69374405E-05_JPRB, 0.71504246E-05_JPRB, &
  & 0.73621982E-05_JPRB, 0.75724593E-05_JPRB, 0.77755340E-05_JPRB, 0.79670817E-05_JPRB, 0.81439021E-05_JPRB, 0.83098166E-05_JPRB, &
  & 0.84684880E-05_JPRB, 0.86145328E-05_JPRB, 0.87458893E-05_JPRB, 0.88609995E-05_JPRB, 0.89565774E-05_JPRB, 0.90262938E-05_JPRB, &
  & 0.90720932E-05_JPRB, 0.90846079E-05_JPRB, 0.90718213E-05_JPRB, 0.90546764E-05_JPRB, 0.90376116E-05_JPRB, 0.90227468E-05_JPRB, &
  & 0.90140211E-05_JPRB, 0.90083013E-05_JPRB, 0.90007834E-05_JPRB, 0.89859523E-05_JPRB, 0.89536425E-05_JPRB, 0.88967145E-05_JPRB, &
  & 0.88102506E-05_JPRB, 0.87112930E-05_JPRB, 0.85982438E-05_JPRB, 0.84705307E-05_JPRB, 0.83277300E-05_JPRB, 0.81689514E-05_JPRB, &
  & 0.79935808E-05_JPRB, 0.77990389E-05_JPRB, 0.75980597E-05_JPRB, 0.73885690E-05_JPRB, 0.71687368E-05_JPRB, 0.69360808E-05_JPRB, &
  & 0.66970865E-05_JPRB, 0.64492106E-05_JPRB, 0.61977867E-05_JPRB, 0.59483409E-05_JPRB, 0.57085103E-05_JPRB, 0.54890616E-05_JPRB, &
  & 0.53194372E-05_JPRB, 0.51904426E-05_JPRB, 0.50902731E-05_JPRB, 0.49873929E-05_JPRB /)

RGHG7(:,19, 4) = (/ &
  & 0.42871307E-05_JPRB, 0.43993723E-05_JPRB, 0.44745889E-05_JPRB, 0.45511938E-05_JPRB, 0.46346631E-05_JPRB, 0.47280437E-05_JPRB, &
  & 0.48529341E-05_JPRB, 0.50222820E-05_JPRB, 0.52378605E-05_JPRB, 0.54874013E-05_JPRB, 0.57314055E-05_JPRB, 0.59575646E-05_JPRB, &
  & 0.61698047E-05_JPRB, 0.63735720E-05_JPRB, 0.65735885E-05_JPRB, 0.67691412E-05_JPRB, 0.69657826E-05_JPRB, 0.71685636E-05_JPRB, &
  & 0.73735664E-05_JPRB, 0.75748103E-05_JPRB, 0.77705754E-05_JPRB, 0.79587126E-05_JPRB, 0.81306453E-05_JPRB, 0.82964525E-05_JPRB, &
  & 0.84520279E-05_JPRB, 0.85920638E-05_JPRB, 0.87201752E-05_JPRB, 0.88355064E-05_JPRB, 0.89329124E-05_JPRB, 0.90129370E-05_JPRB, &
  & 0.90757012E-05_JPRB, 0.91142574E-05_JPRB, 0.91323936E-05_JPRB, 0.91415523E-05_JPRB, 0.91432021E-05_JPRB, 0.91398770E-05_JPRB, &
  & 0.91306501E-05_JPRB, 0.91165393E-05_JPRB, 0.90948442E-05_JPRB, 0.90595377E-05_JPRB, 0.90071344E-05_JPRB, 0.89330788E-05_JPRB, &
  & 0.88317329E-05_JPRB, 0.87156168E-05_JPRB, 0.85812362E-05_JPRB, 0.84281610E-05_JPRB, 0.82567703E-05_JPRB, 0.80706250E-05_JPRB, &
  & 0.78698740E-05_JPRB, 0.76540591E-05_JPRB, 0.74345021E-05_JPRB, 0.72115627E-05_JPRB, 0.69838252E-05_JPRB, 0.67498790E-05_JPRB, &
  & 0.65149297E-05_JPRB, 0.62772083E-05_JPRB, 0.60408652E-05_JPRB, 0.58111000E-05_JPRB, 0.55942214E-05_JPRB, 0.54002562E-05_JPRB, &
  & 0.52507839E-05_JPRB, 0.51396300E-05_JPRB, 0.50491694E-05_JPRB, 0.49562177E-05_JPRB /)

RGHG7(:,20, 4) = (/ &
  & 0.44163698E-05_JPRB, 0.45235165E-05_JPRB, 0.46003661E-05_JPRB, 0.46762461E-05_JPRB, 0.47612471E-05_JPRB, 0.48561005E-05_JPRB, &
  & 0.49770529E-05_JPRB, 0.51346697E-05_JPRB, 0.53304448E-05_JPRB, 0.55589458E-05_JPRB, 0.57935467E-05_JPRB, 0.60171346E-05_JPRB, &
  & 0.62199792E-05_JPRB, 0.64078736E-05_JPRB, 0.65882132E-05_JPRB, 0.67616465E-05_JPRB, 0.69324119E-05_JPRB, 0.71060458E-05_JPRB, &
  & 0.72825178E-05_JPRB, 0.74563345E-05_JPRB, 0.76240863E-05_JPRB, 0.77820159E-05_JPRB, 0.79309066E-05_JPRB, 0.80675918E-05_JPRB, &
  & 0.81960561E-05_JPRB, 0.83111509E-05_JPRB, 0.84176218E-05_JPRB, 0.85143865E-05_JPRB, 0.85997663E-05_JPRB, 0.86756218E-05_JPRB, &
  & 0.87415401E-05_JPRB, 0.87957942E-05_JPRB, 0.88371798E-05_JPRB, 0.88735160E-05_JPRB, 0.89003506E-05_JPRB, 0.89144442E-05_JPRB, &
  & 0.89125388E-05_JPRB, 0.88981360E-05_JPRB, 0.88674778E-05_JPRB, 0.88251008E-05_JPRB, 0.87684812E-05_JPRB, 0.86956588E-05_JPRB, &
  & 0.86006112E-05_JPRB, 0.84906687E-05_JPRB, 0.83606301E-05_JPRB, 0.82092220E-05_JPRB, 0.80382652E-05_JPRB, 0.78506737E-05_JPRB, &
  & 0.76482238E-05_JPRB, 0.74332315E-05_JPRB, 0.72160074E-05_JPRB, 0.69982534E-05_JPRB, 0.67798214E-05_JPRB, 0.65604099E-05_JPRB, &
  & 0.63436519E-05_JPRB, 0.61279552E-05_JPRB, 0.59160948E-05_JPRB, 0.57117122E-05_JPRB, 0.55196797E-05_JPRB, 0.53479916E-05_JPRB, &
  & 0.52154833E-05_JPRB, 0.51109209E-05_JPRB, 0.50250301E-05_JPRB, 0.49228374E-05_JPRB /)

RGHG7(:,21, 4) = (/ &
  & 0.45318438E-05_JPRB, 0.46372425E-05_JPRB, 0.47086842E-05_JPRB, 0.47835420E-05_JPRB, 0.48660268E-05_JPRB, 0.49602550E-05_JPRB, &
  & 0.50742105E-05_JPRB, 0.52151395E-05_JPRB, 0.53870885E-05_JPRB, 0.55857427E-05_JPRB, 0.57983184E-05_JPRB, 0.60026496E-05_JPRB, &
  & 0.61843716E-05_JPRB, 0.63471516E-05_JPRB, 0.64957931E-05_JPRB, 0.66352927E-05_JPRB, 0.67699025E-05_JPRB, 0.69024236E-05_JPRB, &
  & 0.70349802E-05_JPRB, 0.71662198E-05_JPRB, 0.72917815E-05_JPRB, 0.74127838E-05_JPRB, 0.75193734E-05_JPRB, 0.76236629E-05_JPRB, &
  & 0.77191926E-05_JPRB, 0.78033336E-05_JPRB, 0.78791236E-05_JPRB, 0.79440470E-05_JPRB, 0.80000118E-05_JPRB, 0.80474356E-05_JPRB, &
  & 0.80874388E-05_JPRB, 0.81217640E-05_JPRB, 0.81502149E-05_JPRB, 0.81826074E-05_JPRB, 0.82104798E-05_JPRB, 0.82326915E-05_JPRB, &
  & 0.82411525E-05_JPRB, 0.82401693E-05_JPRB, 0.82282113E-05_JPRB, 0.82102033E-05_JPRB, 0.81841381E-05_JPRB, 0.81472790E-05_JPRB, &
  & 0.80910340E-05_JPRB, 0.80172231E-05_JPRB, 0.79191004E-05_JPRB, 0.77959203E-05_JPRB, 0.76483902E-05_JPRB, 0.74821533E-05_JPRB, &
  & 0.73014958E-05_JPRB, 0.71102090E-05_JPRB, 0.69164657E-05_JPRB, 0.67225856E-05_JPRB, 0.65296995E-05_JPRB, 0.63384559E-05_JPRB, &
  & 0.61513852E-05_JPRB, 0.59671584E-05_JPRB, 0.57868542E-05_JPRB, 0.56121739E-05_JPRB, 0.54468292E-05_JPRB, 0.52970249E-05_JPRB, &
  & 0.51757970E-05_JPRB, 0.50791873E-05_JPRB, 0.49920859E-05_JPRB, 0.48893403E-05_JPRB /)

RGHG7(:,22, 4) = (/ &
  & 0.46184600E-05_JPRB, 0.47089102E-05_JPRB, 0.47756207E-05_JPRB, 0.48426414E-05_JPRB, 0.49172395E-05_JPRB, 0.50017516E-05_JPRB, &
  & 0.51037086E-05_JPRB, 0.52257496E-05_JPRB, 0.53678232E-05_JPRB, 0.55264932E-05_JPRB, 0.56934809E-05_JPRB, 0.58614005E-05_JPRB, &
  & 0.60131965E-05_JPRB, 0.61435562E-05_JPRB, 0.62572267E-05_JPRB, 0.63582620E-05_JPRB, 0.64516980E-05_JPRB, 0.65406657E-05_JPRB, &
  & 0.66276266E-05_JPRB, 0.67124811E-05_JPRB, 0.67940800E-05_JPRB, 0.68703603E-05_JPRB, 0.69415573E-05_JPRB, 0.70094920E-05_JPRB, &
  & 0.70739061E-05_JPRB, 0.71309842E-05_JPRB, 0.71793925E-05_JPRB, 0.72125113E-05_JPRB, 0.72306034E-05_JPRB, 0.72344742E-05_JPRB, &
  & 0.72280991E-05_JPRB, 0.72138073E-05_JPRB, 0.72004786E-05_JPRB, 0.71973159E-05_JPRB, 0.72023008E-05_JPRB, 0.72172625E-05_JPRB, &
  & 0.72347434E-05_JPRB, 0.72584239E-05_JPRB, 0.72857169E-05_JPRB, 0.73180508E-05_JPRB, 0.73497176E-05_JPRB, 0.73741207E-05_JPRB, &
  & 0.73789988E-05_JPRB, 0.73625110E-05_JPRB, 0.73159995E-05_JPRB, 0.72385751E-05_JPRB, 0.71339628E-05_JPRB, 0.70090891E-05_JPRB, &
  & 0.68686718E-05_JPRB, 0.67163846E-05_JPRB, 0.65597064E-05_JPRB, 0.64016849E-05_JPRB, 0.62443064E-05_JPRB, 0.60886900E-05_JPRB, &
  & 0.59371328E-05_JPRB, 0.57884499E-05_JPRB, 0.56425779E-05_JPRB, 0.55001506E-05_JPRB, 0.53629892E-05_JPRB, 0.52355131E-05_JPRB, &
  & 0.51296638E-05_JPRB, 0.50386575E-05_JPRB, 0.49605542E-05_JPRB, 0.48625984E-05_JPRB /)

RGHG7(:,23, 4) = (/ &
  & 0.46547725E-05_JPRB, 0.47206513E-05_JPRB, 0.47712970E-05_JPRB, 0.48264260E-05_JPRB, 0.48877905E-05_JPRB, 0.49575224E-05_JPRB, &
  & 0.50397230E-05_JPRB, 0.51363613E-05_JPRB, 0.52453752E-05_JPRB, 0.53637882E-05_JPRB, 0.54854122E-05_JPRB, 0.56047656E-05_JPRB, &
  & 0.57112684E-05_JPRB, 0.57987727E-05_JPRB, 0.58697560E-05_JPRB, 0.59290255E-05_JPRB, 0.59810814E-05_JPRB, 0.60282159E-05_JPRB, &
  & 0.60722168E-05_JPRB, 0.61154724E-05_JPRB, 0.61569549E-05_JPRB, 0.61971059E-05_JPRB, 0.62353979E-05_JPRB, 0.62747708E-05_JPRB, &
  & 0.63147918E-05_JPRB, 0.63505759E-05_JPRB, 0.63784469E-05_JPRB, 0.63888388E-05_JPRB, 0.63774696E-05_JPRB, 0.63400644E-05_JPRB, &
  & 0.62878021E-05_JPRB, 0.62231657E-05_JPRB, 0.61637284E-05_JPRB, 0.61186361E-05_JPRB, 0.60963785E-05_JPRB, 0.60995603E-05_JPRB, &
  & 0.61251067E-05_JPRB, 0.61752967E-05_JPRB, 0.62441454E-05_JPRB, 0.63290363E-05_JPRB, 0.64183846E-05_JPRB, 0.65038594E-05_JPRB, &
  & 0.65682034E-05_JPRB, 0.66071830E-05_JPRB, 0.66127641E-05_JPRB, 0.65868389E-05_JPRB, 0.65315794E-05_JPRB, 0.64539627E-05_JPRB, &
  & 0.63594789E-05_JPRB, 0.62531112E-05_JPRB, 0.61404285E-05_JPRB, 0.60240486E-05_JPRB, 0.59062022E-05_JPRB, 0.57885309E-05_JPRB, &
  & 0.56729314E-05_JPRB, 0.55589117E-05_JPRB, 0.54463258E-05_JPRB, 0.53348076E-05_JPRB, 0.52253940E-05_JPRB, 0.51209845E-05_JPRB, &
  & 0.50299268E-05_JPRB, 0.49514947E-05_JPRB, 0.48815073E-05_JPRB, 0.48009897E-05_JPRB /)

RGHG7(:,24, 4) = (/ &
  & 0.46288951E-05_JPRB, 0.46634786E-05_JPRB, 0.46952950E-05_JPRB, 0.47331732E-05_JPRB, 0.47773306E-05_JPRB, 0.48270413E-05_JPRB, &
  & 0.48844845E-05_JPRB, 0.49513478E-05_JPRB, 0.50246763E-05_JPRB, 0.50996018E-05_JPRB, 0.51726920E-05_JPRB, 0.52403234E-05_JPRB, &
  & 0.52998967E-05_JPRB, 0.53446829E-05_JPRB, 0.53751810E-05_JPRB, 0.53943540E-05_JPRB, 0.54074626E-05_JPRB, 0.54168654E-05_JPRB, &
  & 0.54258644E-05_JPRB, 0.54360039E-05_JPRB, 0.54464576E-05_JPRB, 0.54594943E-05_JPRB, 0.54731645E-05_JPRB, 0.54924330E-05_JPRB, &
  & 0.55143755E-05_JPRB, 0.55350142E-05_JPRB, 0.55494470E-05_JPRB, 0.55430346E-05_JPRB, 0.55120277E-05_JPRB, 0.54512379E-05_JPRB, &
  & 0.53681824E-05_JPRB, 0.52704145E-05_JPRB, 0.51785873E-05_JPRB, 0.51068068E-05_JPRB, 0.50674485E-05_JPRB, 0.50653521E-05_JPRB, &
  & 0.51010711E-05_JPRB, 0.51723000E-05_JPRB, 0.52726423E-05_JPRB, 0.53966337E-05_JPRB, 0.55279947E-05_JPRB, 0.56557174E-05_JPRB, &
  & 0.57620550E-05_JPRB, 0.58428886E-05_JPRB, 0.58914543E-05_JPRB, 0.59083891E-05_JPRB, 0.58961555E-05_JPRB, 0.58627293E-05_JPRB, &
  & 0.58137739E-05_JPRB, 0.57520006E-05_JPRB, 0.56818521E-05_JPRB, 0.56064314E-05_JPRB, 0.55274081E-05_JPRB, 0.54465881E-05_JPRB, &
  & 0.53656295E-05_JPRB, 0.52846749E-05_JPRB, 0.52035953E-05_JPRB, 0.51221673E-05_JPRB, 0.50406234E-05_JPRB, 0.49606201E-05_JPRB, &
  & 0.48895208E-05_JPRB, 0.48267084E-05_JPRB, 0.47741296E-05_JPRB, 0.47188787E-05_JPRB /)

RGHG7(:,25, 4) = (/ &
  & 0.45409301E-05_JPRB, 0.45373854E-05_JPRB, 0.45478982E-05_JPRB, 0.45656857E-05_JPRB, 0.45894535E-05_JPRB, 0.46170571E-05_JPRB, &
  & 0.46487812E-05_JPRB, 0.46854689E-05_JPRB, 0.47238618E-05_JPRB, 0.47603303E-05_JPRB, 0.47914914E-05_JPRB, 0.48143829E-05_JPRB, &
  & 0.48280385E-05_JPRB, 0.48311563E-05_JPRB, 0.48242396E-05_JPRB, 0.48099560E-05_JPRB, 0.47917765E-05_JPRB, 0.47724507E-05_JPRB, &
  & 0.47545868E-05_JPRB, 0.47393632E-05_JPRB, 0.47272010E-05_JPRB, 0.47201838E-05_JPRB, 0.47168151E-05_JPRB, 0.47215617E-05_JPRB, &
  & 0.47308504E-05_JPRB, 0.47421008E-05_JPRB, 0.47461731E-05_JPRB, 0.47316739E-05_JPRB, 0.46919954E-05_JPRB, 0.46204650E-05_JPRB, &
  & 0.45241732E-05_JPRB, 0.44140484E-05_JPRB, 0.43101027E-05_JPRB, 0.42302640E-05_JPRB, 0.41875410E-05_JPRB, 0.41883454E-05_JPRB, &
  & 0.42345946E-05_JPRB, 0.43237874E-05_JPRB, 0.44441808E-05_JPRB, 0.45874926E-05_JPRB, 0.47392964E-05_JPRB, 0.48883030E-05_JPRB, &
  & 0.50167073E-05_JPRB, 0.51225102E-05_JPRB, 0.51989864E-05_JPRB, 0.52465984E-05_JPRB, 0.52708456E-05_JPRB, 0.52764749E-05_JPRB, &
  & 0.52666487E-05_JPRB, 0.52443825E-05_JPRB, 0.52135615E-05_JPRB, 0.51754673E-05_JPRB, 0.51321454E-05_JPRB, 0.50851363E-05_JPRB, &
  & 0.50364642E-05_JPRB, 0.49864921E-05_JPRB, 0.49352407E-05_JPRB, 0.48824909E-05_JPRB, 0.48281822E-05_JPRB, 0.47733361E-05_JPRB, &
  & 0.47239823E-05_JPRB, 0.46821006E-05_JPRB, 0.46480004E-05_JPRB, 0.46186083E-05_JPRB /)

RGHG7(:,26, 4) = (/ &
  & 0.43937289E-05_JPRB, 0.43532968E-05_JPRB, 0.43416821E-05_JPRB, 0.43401446E-05_JPRB, 0.43437035E-05_JPRB, 0.43499917E-05_JPRB, &
  & 0.43576838E-05_JPRB, 0.43673090E-05_JPRB, 0.43754990E-05_JPRB, 0.43796413E-05_JPRB, 0.43764176E-05_JPRB, 0.43641971E-05_JPRB, &
  & 0.43426207E-05_JPRB, 0.43133928E-05_JPRB, 0.42766860E-05_JPRB, 0.42344518E-05_JPRB, 0.41900980E-05_JPRB, 0.41470485E-05_JPRB, &
  & 0.41077692E-05_JPRB, 0.40733598E-05_JPRB, 0.40449027E-05_JPRB, 0.40226723E-05_JPRB, 0.40072164E-05_JPRB, 0.40002851E-05_JPRB, &
  & 0.40003256E-05_JPRB, 0.40034188E-05_JPRB, 0.39998949E-05_JPRB, 0.39842930E-05_JPRB, 0.39404335E-05_JPRB, 0.38701037E-05_JPRB, &
  & 0.37757882E-05_JPRB, 0.36703461E-05_JPRB, 0.35710275E-05_JPRB, 0.34970637E-05_JPRB, 0.34616155E-05_JPRB, 0.34716327E-05_JPRB, &
  & 0.35291646E-05_JPRB, 0.36258530E-05_JPRB, 0.37543537E-05_JPRB, 0.39043093E-05_JPRB, 0.40615660E-05_JPRB, 0.42130941E-05_JPRB, &
  & 0.43489167E-05_JPRB, 0.44642297E-05_JPRB, 0.45562310E-05_JPRB, 0.46266787E-05_JPRB, 0.46788755E-05_JPRB, 0.47148806E-05_JPRB, &
  & 0.47381091E-05_JPRB, 0.47501176E-05_JPRB, 0.47527124E-05_JPRB, 0.47477447E-05_JPRB, 0.47363396E-05_JPRB, 0.47202543E-05_JPRB, &
  & 0.47012559E-05_JPRB, 0.46799787E-05_JPRB, 0.46566847E-05_JPRB, 0.46312221E-05_JPRB, 0.46032987E-05_JPRB, 0.45733705E-05_JPRB, &
  & 0.45464931E-05_JPRB, 0.45244997E-05_JPRB, 0.45108468E-05_JPRB, 0.45038887E-05_JPRB /)

RGHG7(:,27, 4) = (/ &
  & 0.41937074E-05_JPRB, 0.41219268E-05_JPRB, 0.40904429E-05_JPRB, 0.40724940E-05_JPRB, 0.40589093E-05_JPRB, 0.40467412E-05_JPRB, &
  & 0.40346108E-05_JPRB, 0.40217901E-05_JPRB, 0.40063792E-05_JPRB, 0.39855349E-05_JPRB, 0.39563615E-05_JPRB, 0.39178763E-05_JPRB, &
  & 0.38698640E-05_JPRB, 0.38148264E-05_JPRB, 0.37549744E-05_JPRB, 0.36924421E-05_JPRB, 0.36294819E-05_JPRB, 0.35693884E-05_JPRB, &
  & 0.35142064E-05_JPRB, 0.34658590E-05_JPRB, 0.34244690E-05_JPRB, 0.33909616E-05_JPRB, 0.33653721E-05_JPRB, 0.33489200E-05_JPRB, &
  & 0.33404024E-05_JPRB, 0.33353317E-05_JPRB, 0.33278020E-05_JPRB, 0.33085505E-05_JPRB, 0.32683311E-05_JPRB, 0.32071457E-05_JPRB, &
  & 0.31249845E-05_JPRB, 0.30343501E-05_JPRB, 0.29501059E-05_JPRB, 0.28903971E-05_JPRB, 0.28677080E-05_JPRB, 0.28878858E-05_JPRB, &
  & 0.29504970E-05_JPRB, 0.30535696E-05_JPRB, 0.31839350E-05_JPRB, 0.33278789E-05_JPRB, 0.34780123E-05_JPRB, 0.36228271E-05_JPRB, &
  & 0.37547698E-05_JPRB, 0.38710145E-05_JPRB, 0.39702372E-05_JPRB, 0.40553527E-05_JPRB, 0.41274943E-05_JPRB, 0.41883800E-05_JPRB, &
  & 0.42386155E-05_JPRB, 0.42787842E-05_JPRB, 0.43102395E-05_JPRB, 0.43332916E-05_JPRB, 0.43496457E-05_JPRB, 0.43607620E-05_JPRB, &
  & 0.43681730E-05_JPRB, 0.43730397E-05_JPRB, 0.43753666E-05_JPRB, 0.43752898E-05_JPRB, 0.43722857E-05_JPRB, 0.43660948E-05_JPRB, &
  & 0.43603327E-05_JPRB, 0.43574837E-05_JPRB, 0.43601481E-05_JPRB, 0.43722848E-05_JPRB /)

RGHG7(:,28, 4) = (/ &
  & 0.39550259E-05_JPRB, 0.38538847E-05_JPRB, 0.38098005E-05_JPRB, 0.37773912E-05_JPRB, 0.37508375E-05_JPRB, 0.37245127E-05_JPRB, &
  & 0.36968809E-05_JPRB, 0.36676483E-05_JPRB, 0.36353872E-05_JPRB, 0.35971302E-05_JPRB, 0.35504031E-05_JPRB, 0.34938803E-05_JPRB, &
  & 0.34280497E-05_JPRB, 0.33544818E-05_JPRB, 0.32763348E-05_JPRB, 0.31980117E-05_JPRB, 0.31224324E-05_JPRB, 0.30514170E-05_JPRB, &
  & 0.29854375E-05_JPRB, 0.29268228E-05_JPRB, 0.28756333E-05_JPRB, 0.28332083E-05_JPRB, 0.27989636E-05_JPRB, 0.27742685E-05_JPRB, &
  & 0.27572842E-05_JPRB, 0.27456715E-05_JPRB, 0.27342548E-05_JPRB, 0.27143683E-05_JPRB, 0.26801947E-05_JPRB, 0.26301100E-05_JPRB, &
  & 0.25648014E-05_JPRB, 0.24936687E-05_JPRB, 0.24295491E-05_JPRB, 0.23875798E-05_JPRB, 0.23791224E-05_JPRB, 0.24092374E-05_JPRB, &
  & 0.24797314E-05_JPRB, 0.25796710E-05_JPRB, 0.26990583E-05_JPRB, 0.28327647E-05_JPRB, 0.29698679E-05_JPRB, 0.31020520E-05_JPRB, &
  & 0.32243863E-05_JPRB, 0.33359261E-05_JPRB, 0.34385998E-05_JPRB, 0.35331952E-05_JPRB, 0.36203674E-05_JPRB, 0.36993879E-05_JPRB, &
  & 0.37707002E-05_JPRB, 0.38332737E-05_JPRB, 0.38876838E-05_JPRB, 0.39345146E-05_JPRB, 0.39746897E-05_JPRB, 0.40095251E-05_JPRB, &
  & 0.40404266E-05_JPRB, 0.40685673E-05_JPRB, 0.40937730E-05_JPRB, 0.41164230E-05_JPRB, 0.41355197E-05_JPRB, 0.41505705E-05_JPRB, &
  & 0.41637049E-05_JPRB, 0.41777389E-05_JPRB, 0.41947446E-05_JPRB, 0.42237734E-05_JPRB /)

RGHG7(:,29, 4) = (/ &
  & 0.36861204E-05_JPRB, 0.35697537E-05_JPRB, 0.35116109E-05_JPRB, 0.34710395E-05_JPRB, 0.34341590E-05_JPRB, 0.33978833E-05_JPRB, &
  & 0.33603619E-05_JPRB, 0.33200681E-05_JPRB, 0.32763444E-05_JPRB, 0.32263952E-05_JPRB, 0.31681805E-05_JPRB, 0.31006489E-05_JPRB, &
  & 0.30248245E-05_JPRB, 0.29433236E-05_JPRB, 0.28576512E-05_JPRB, 0.27688220E-05_JPRB, 0.26809721E-05_JPRB, 0.25996799E-05_JPRB, &
  & 0.25253405E-05_JPRB, 0.24586777E-05_JPRB, 0.23997623E-05_JPRB, 0.23499651E-05_JPRB, 0.23082218E-05_JPRB, 0.22761310E-05_JPRB, &
  & 0.22513493E-05_JPRB, 0.22334202E-05_JPRB, 0.22174938E-05_JPRB, 0.21977371E-05_JPRB, 0.21705594E-05_JPRB, 0.21331382E-05_JPRB, &
  & 0.20858513E-05_JPRB, 0.20356724E-05_JPRB, 0.19924373E-05_JPRB, 0.19686884E-05_JPRB, 0.19737040E-05_JPRB, 0.20115822E-05_JPRB, &
  & 0.20787697E-05_JPRB, 0.21705828E-05_JPRB, 0.22830632E-05_JPRB, 0.24029930E-05_JPRB, 0.25236791E-05_JPRB, 0.26407108E-05_JPRB, &
  & 0.27508936E-05_JPRB, 0.28559032E-05_JPRB, 0.29571615E-05_JPRB, 0.30567451E-05_JPRB, 0.31540983E-05_JPRB, 0.32476974E-05_JPRB, &
  & 0.33349152E-05_JPRB, 0.34150223E-05_JPRB, 0.34887446E-05_JPRB, 0.35548878E-05_JPRB, 0.36149977E-05_JPRB, 0.36700585E-05_JPRB, &
  & 0.37211007E-05_JPRB, 0.37697491E-05_JPRB, 0.38154876E-05_JPRB, 0.38588541E-05_JPRB, 0.38978974E-05_JPRB, 0.39321621E-05_JPRB, &
  & 0.39621300E-05_JPRB, 0.39897182E-05_JPRB, 0.40180976E-05_JPRB, 0.40621903E-05_JPRB /)

RGHG7(:,30, 4) = (/ &
  & 0.34070567E-05_JPRB, 0.32736170E-05_JPRB, 0.32122052E-05_JPRB, 0.31635125E-05_JPRB, 0.31210770E-05_JPRB, 0.30782865E-05_JPRB, &
  & 0.30337465E-05_JPRB, 0.29875159E-05_JPRB, 0.29373803E-05_JPRB, 0.28812115E-05_JPRB, 0.28172433E-05_JPRB, 0.27436151E-05_JPRB, &
  & 0.26604198E-05_JPRB, 0.25701936E-05_JPRB, 0.24781191E-05_JPRB, 0.23875900E-05_JPRB, 0.22970548E-05_JPRB, 0.22097747E-05_JPRB, &
  & 0.21295045E-05_JPRB, 0.20570815E-05_JPRB, 0.19922295E-05_JPRB, 0.19365641E-05_JPRB, 0.18883858E-05_JPRB, 0.18503588E-05_JPRB, &
  & 0.18185249E-05_JPRB, 0.17956700E-05_JPRB, 0.17755316E-05_JPRB, 0.17565839E-05_JPRB, 0.17353166E-05_JPRB, 0.17096539E-05_JPRB, &
  & 0.16790869E-05_JPRB, 0.16484352E-05_JPRB, 0.16244175E-05_JPRB, 0.16168440E-05_JPRB, 0.16325172E-05_JPRB, 0.16739534E-05_JPRB, &
  & 0.17408670E-05_JPRB, 0.18298230E-05_JPRB, 0.19267789E-05_JPRB, 0.20278935E-05_JPRB, 0.21305161E-05_JPRB, 0.22319612E-05_JPRB, &
  & 0.23307543E-05_JPRB, 0.24281185E-05_JPRB, 0.25276106E-05_JPRB, 0.26288619E-05_JPRB, 0.27318943E-05_JPRB, 0.28343370E-05_JPRB, &
  & 0.29330968E-05_JPRB, 0.30268895E-05_JPRB, 0.31146462E-05_JPRB, 0.31962538E-05_JPRB, 0.32728180E-05_JPRB, 0.33444996E-05_JPRB, &
  & 0.34128132E-05_JPRB, 0.34788702E-05_JPRB, 0.35422429E-05_JPRB, 0.36034439E-05_JPRB, 0.36600848E-05_JPRB, 0.37107013E-05_JPRB, &
  & 0.37548787E-05_JPRB, 0.37938034E-05_JPRB, 0.38320222E-05_JPRB, 0.38888948E-05_JPRB /)

RGHG7(:,31, 4) = (/ &
  & 0.31244551E-05_JPRB, 0.29859411E-05_JPRB, 0.29161265E-05_JPRB, 0.28655659E-05_JPRB, 0.28186334E-05_JPRB, 0.27725712E-05_JPRB, &
  & 0.27248557E-05_JPRB, 0.26749162E-05_JPRB, 0.26220487E-05_JPRB, 0.25631132E-05_JPRB, 0.24967976E-05_JPRB, 0.24223693E-05_JPRB, &
  & 0.23398627E-05_JPRB, 0.22498862E-05_JPRB, 0.21542269E-05_JPRB, 0.20581554E-05_JPRB, 0.19653119E-05_JPRB, 0.18756912E-05_JPRB, &
  & 0.17919417E-05_JPRB, 0.17155819E-05_JPRB, 0.16465232E-05_JPRB, 0.15864556E-05_JPRB, 0.15331569E-05_JPRB, 0.14906287E-05_JPRB, &
  & 0.14532129E-05_JPRB, 0.14265527E-05_JPRB, 0.14032435E-05_JPRB, 0.13852600E-05_JPRB, 0.13685019E-05_JPRB, 0.13525167E-05_JPRB, &
  & 0.13359397E-05_JPRB, 0.13215257E-05_JPRB, 0.13137825E-05_JPRB, 0.13193300E-05_JPRB, 0.13430559E-05_JPRB, 0.13875979E-05_JPRB, &
  & 0.14513763E-05_JPRB, 0.15257000E-05_JPRB, 0.16088651E-05_JPRB, 0.16969783E-05_JPRB, 0.17849649E-05_JPRB, 0.18722598E-05_JPRB, &
  & 0.19597660E-05_JPRB, 0.20507416E-05_JPRB, 0.21467486E-05_JPRB, 0.22485901E-05_JPRB, 0.23543346E-05_JPRB, 0.24612991E-05_JPRB, &
  & 0.25674794E-05_JPRB, 0.26703137E-05_JPRB, 0.27684810E-05_JPRB, 0.28621732E-05_JPRB, 0.29510804E-05_JPRB, 0.30358697E-05_JPRB, &
  & 0.31178863E-05_JPRB, 0.31979155E-05_JPRB, 0.32761161E-05_JPRB, 0.33522786E-05_JPRB, 0.34239129E-05_JPRB, 0.34881696E-05_JPRB, &
  & 0.35440551E-05_JPRB, 0.35919168E-05_JPRB, 0.36382978E-05_JPRB, 0.37066802E-05_JPRB /)

RGHG7(:,32, 4) = (/ &
  & 0.28498362E-05_JPRB, 0.27044623E-05_JPRB, 0.26357664E-05_JPRB, 0.25812983E-05_JPRB, 0.25334066E-05_JPRB, 0.24857568E-05_JPRB, &
  & 0.24372639E-05_JPRB, 0.23866842E-05_JPRB, 0.23334821E-05_JPRB, 0.22750769E-05_JPRB, 0.22094034E-05_JPRB, 0.21347564E-05_JPRB, &
  & 0.20519230E-05_JPRB, 0.19634062E-05_JPRB, 0.18709572E-05_JPRB, 0.17761233E-05_JPRB, 0.16821672E-05_JPRB, 0.15912940E-05_JPRB, &
  & 0.15058051E-05_JPRB, 0.14269117E-05_JPRB, 0.13554279E-05_JPRB, 0.12920694E-05_JPRB, 0.12353204E-05_JPRB, 0.11891640E-05_JPRB, &
  & 0.11484760E-05_JPRB, 0.11182943E-05_JPRB, 0.10935503E-05_JPRB, 0.10756561E-05_JPRB, 0.10625831E-05_JPRB, 0.10535745E-05_JPRB, &
  & 0.10475743E-05_JPRB, 0.10456113E-05_JPRB, 0.10501541E-05_JPRB, 0.10654344E-05_JPRB, 0.10946301E-05_JPRB, 0.11390399E-05_JPRB, &
  & 0.11947528E-05_JPRB, 0.12599688E-05_JPRB, 0.13315619E-05_JPRB, 0.14056939E-05_JPRB, 0.14816945E-05_JPRB, 0.15585792E-05_JPRB, &
  & 0.16383029E-05_JPRB, 0.17233571E-05_JPRB, 0.18157235E-05_JPRB, 0.19155809E-05_JPRB, 0.20215091E-05_JPRB, 0.21305170E-05_JPRB, &
  & 0.22397780E-05_JPRB, 0.23479636E-05_JPRB, 0.24531907E-05_JPRB, 0.25546528E-05_JPRB, 0.26524185E-05_JPRB, 0.27467852E-05_JPRB, &
  & 0.28390225E-05_JPRB, 0.29296607E-05_JPRB, 0.30194781E-05_JPRB, 0.31073000E-05_JPRB, 0.31906488E-05_JPRB, 0.32658095E-05_JPRB, &
  & 0.33305707E-05_JPRB, 0.33858291E-05_JPRB, 0.34388754E-05_JPRB, 0.35175212E-05_JPRB /)

RGHG7(:,33, 4) = (/ &
  & 0.25868383E-05_JPRB, 0.24416247E-05_JPRB, 0.23700184E-05_JPRB, 0.23170364E-05_JPRB, 0.22684965E-05_JPRB, 0.22210013E-05_JPRB, &
  & 0.21732903E-05_JPRB, 0.21240596E-05_JPRB, 0.20719124E-05_JPRB, 0.20152415E-05_JPRB, 0.19521192E-05_JPRB, 0.18817403E-05_JPRB, &
  & 0.18028448E-05_JPRB, 0.17164610E-05_JPRB, 0.16256720E-05_JPRB, 0.15328308E-05_JPRB, 0.14405949E-05_JPRB, 0.13503620E-05_JPRB, &
  & 0.12647994E-05_JPRB, 0.11844450E-05_JPRB, 0.11116740E-05_JPRB, 0.10463992E-05_JPRB, 0.98757425E-06_JPRB, 0.93872114E-06_JPRB, &
  & 0.89629782E-06_JPRB, 0.86354243E-06_JPRB, 0.83811432E-06_JPRB, 0.82012997E-06_JPRB, 0.80950076E-06_JPRB, 0.80508192E-06_JPRB, &
  & 0.80630963E-06_JPRB, 0.81289653E-06_JPRB, 0.82588105E-06_JPRB, 0.84753498E-06_JPRB, 0.87934802E-06_JPRB, 0.92090067E-06_JPRB, &
  & 0.97115776E-06_JPRB, 0.10282196E-05_JPRB, 0.10891629E-05_JPRB, 0.11524260E-05_JPRB, 0.12183190E-05_JPRB, 0.12873782E-05_JPRB, &
  & 0.13612886E-05_JPRB, 0.14423514E-05_JPRB, 0.15315502E-05_JPRB, 0.16291458E-05_JPRB, 0.17333019E-05_JPRB, 0.18414594E-05_JPRB, &
  & 0.19516174E-05_JPRB, 0.20616130E-05_JPRB, 0.21702515E-05_JPRB, 0.22762506E-05_JPRB, 0.23792099E-05_JPRB, 0.24794463E-05_JPRB, &
  & 0.25781580E-05_JPRB, 0.26760583E-05_JPRB, 0.27738681E-05_JPRB, 0.28702516E-05_JPRB, 0.29622322E-05_JPRB, 0.30450215E-05_JPRB, &
  & 0.31164495E-05_JPRB, 0.31770483E-05_JPRB, 0.32356618E-05_JPRB, 0.33232982E-05_JPRB /)

RGHG7(:,34, 4) = (/ &
  & 0.23378520E-05_JPRB, 0.21946596E-05_JPRB, 0.21262445E-05_JPRB, 0.20730258E-05_JPRB, 0.20261089E-05_JPRB, 0.19800434E-05_JPRB, &
  & 0.19337099E-05_JPRB, 0.18867527E-05_JPRB, 0.18374544E-05_JPRB, 0.17841329E-05_JPRB, 0.17242755E-05_JPRB, 0.16568131E-05_JPRB, &
  & 0.15824930E-05_JPRB, 0.15011789E-05_JPRB, 0.14143907E-05_JPRB, 0.13248115E-05_JPRB, 0.12349589E-05_JPRB, 0.11465255E-05_JPRB, &
  & 0.10623872E-05_JPRB, 0.98217288E-06_JPRB, 0.90858691E-06_JPRB, 0.84249007E-06_JPRB, 0.78269534E-06_JPRB, 0.73209918E-06_JPRB, &
  & 0.68897236E-06_JPRB, 0.65474393E-06_JPRB, 0.62900926E-06_JPRB, 0.61109426E-06_JPRB, 0.60177223E-06_JPRB, 0.60002128E-06_JPRB, &
  & 0.60534506E-06_JPRB, 0.61696596E-06_JPRB, 0.63469980E-06_JPRB, 0.65941907E-06_JPRB, 0.69121251E-06_JPRB, 0.72943777E-06_JPRB, &
  & 0.77393378E-06_JPRB, 0.82271470E-06_JPRB, 0.87495249E-06_JPRB, 0.93075920E-06_JPRB, 0.99060242E-06_JPRB, 0.10553146E-05_JPRB, &
  & 0.11260065E-05_JPRB, 0.12045026E-05_JPRB, 0.12914569E-05_JPRB, 0.13863254E-05_JPRB, 0.14877222E-05_JPRB, 0.15937100E-05_JPRB, &
  & 0.17021912E-05_JPRB, 0.18116608E-05_JPRB, 0.19209806E-05_JPRB, 0.20282032E-05_JPRB, 0.21331300E-05_JPRB, 0.22358402E-05_JPRB, &
  & 0.23375171E-05_JPRB, 0.24391393E-05_JPRB, 0.25415281E-05_JPRB, 0.26430346E-05_JPRB, 0.27401604E-05_JPRB, 0.28280508E-05_JPRB, &
  & 0.29034939E-05_JPRB, 0.29681678E-05_JPRB, 0.30309627E-05_JPRB, 0.31262664E-05_JPRB /)

RGHG7(:,35, 4) = (/ &
  & 0.21068706E-05_JPRB, 0.19686179E-05_JPRB, 0.19022848E-05_JPRB, 0.18520331E-05_JPRB, 0.18066071E-05_JPRB, 0.17626617E-05_JPRB, &
  & 0.17189502E-05_JPRB, 0.16745188E-05_JPRB, 0.16282427E-05_JPRB, 0.15785757E-05_JPRB, 0.15236594E-05_JPRB, 0.14615711E-05_JPRB, &
  & 0.13915114E-05_JPRB, 0.13151021E-05_JPRB, 0.12326790E-05_JPRB, 0.11466601E-05_JPRB, 0.10600554E-05_JPRB, 0.97405973E-06_JPRB, &
  & 0.89187586E-06_JPRB, 0.81333434E-06_JPRB, 0.73999922E-06_JPRB, 0.67369433E-06_JPRB, 0.61389869E-06_JPRB, 0.56257755E-06_JPRB, &
  & 0.51965418E-06_JPRB, 0.48534349E-06_JPRB, 0.45993721E-06_JPRB, 0.44260841E-06_JPRB, 0.43403773E-06_JPRB, 0.43344639E-06_JPRB, &
  & 0.44036193E-06_JPRB, 0.45388902E-06_JPRB, 0.47315308E-06_JPRB, 0.49810023E-06_JPRB, 0.52815324E-06_JPRB, 0.56275837E-06_JPRB, &
  & 0.60117293E-06_JPRB, 0.64268579E-06_JPRB, 0.68796334E-06_JPRB, 0.73826925E-06_JPRB, 0.79506941E-06_JPRB, 0.85843487E-06_JPRB, &
  & 0.92869993E-06_JPRB, 0.10064609E-05_JPRB, 0.10917017E-05_JPRB, 0.11838712E-05_JPRB, 0.12814944E-05_JPRB, 0.13837238E-05_JPRB, &
  & 0.14895884E-05_JPRB, 0.15970106E-05_JPRB, 0.17046211E-05_JPRB, 0.18109630E-05_JPRB, 0.19151187E-05_JPRB, 0.20173411E-05_JPRB, &
  & 0.21189376E-05_JPRB, 0.22211207E-05_JPRB, 0.23245202E-05_JPRB, 0.24277892E-05_JPRB, 0.25269396E-05_JPRB, 0.26169328E-05_JPRB, &
  & 0.26944986E-05_JPRB, 0.27615852E-05_JPRB, 0.28272893E-05_JPRB, 0.29287526E-05_JPRB /)

RGHG7(:,36, 4) = (/ &
  & 0.18915670E-05_JPRB, 0.17630819E-05_JPRB, 0.17005484E-05_JPRB, 0.16525576E-05_JPRB, 0.16096584E-05_JPRB, 0.15682233E-05_JPRB, &
  & 0.15271801E-05_JPRB, 0.14859875E-05_JPRB, 0.14433803E-05_JPRB, 0.13976420E-05_JPRB, 0.13467012E-05_JPRB, 0.12896834E-05_JPRB, &
  & 0.12252938E-05_JPRB, 0.11534611E-05_JPRB, 0.10763181E-05_JPRB, 0.99489137E-06_JPRB, 0.91200002E-06_JPRB, 0.82909031E-06_JPRB, &
  & 0.74901345E-06_JPRB, 0.67235175E-06_JPRB, 0.59994375E-06_JPRB, 0.53406808E-06_JPRB, 0.47530301E-06_JPRB, 0.42492937E-06_JPRB, &
  & 0.38374918E-06_JPRB, 0.35155341E-06_JPRB, 0.32809916E-06_JPRB, 0.31249044E-06_JPRB, 0.30487860E-06_JPRB, 0.30465247E-06_JPRB, &
  & 0.31125302E-06_JPRB, 0.32421383E-06_JPRB, 0.34230644E-06_JPRB, 0.36512353E-06_JPRB, 0.39187765E-06_JPRB, 0.42185485E-06_JPRB, &
  & 0.45445648E-06_JPRB, 0.49003523E-06_JPRB, 0.52978817E-06_JPRB, 0.57584157E-06_JPRB, 0.63013761E-06_JPRB, 0.69329457E-06_JPRB, &
  & 0.76414295E-06_JPRB, 0.84187479E-06_JPRB, 0.92558690E-06_JPRB, 0.10143726E-05_JPRB, 0.11085867E-05_JPRB, 0.12074837E-05_JPRB, &
  & 0.13098094E-05_JPRB, 0.14145237E-05_JPRB, 0.15195626E-05_JPRB, 0.16233137E-05_JPRB, 0.17248742E-05_JPRB, 0.18244357E-05_JPRB, &
  & 0.19233746E-05_JPRB, 0.20232753E-05_JPRB, 0.21248304E-05_JPRB, 0.22266001E-05_JPRB, 0.23247826E-05_JPRB, 0.24143528E-05_JPRB, &
  & 0.24919946E-05_JPRB, 0.25598968E-05_JPRB, 0.26272685E-05_JPRB, 0.27329745E-05_JPRB /)

RGHG7(:,37, 4) = (/ &
  & 0.16965939E-05_JPRB, 0.15761876E-05_JPRB, 0.15193099E-05_JPRB, 0.14740376E-05_JPRB, 0.14334955E-05_JPRB, 0.13946487E-05_JPRB, &
  & 0.13564476E-05_JPRB, 0.13184431E-05_JPRB, 0.12793851E-05_JPRB, 0.12379371E-05_JPRB, 0.11919003E-05_JPRB, 0.11395362E-05_JPRB, &
  & 0.10805235E-05_JPRB, 0.10143265E-05_JPRB, 0.94177511E-06_JPRB, 0.86509226E-06_JPRB, 0.78647599E-06_JPRB, 0.70736280E-06_JPRB, &
  & 0.62975607E-06_JPRB, 0.55512834E-06_JPRB, 0.48416331E-06_JPRB, 0.41957321E-06_JPRB, 0.36360882E-06_JPRB, 0.31722541E-06_JPRB, &
  & 0.28081772E-06_JPRB, 0.25344173E-06_JPRB, 0.23421622E-06_JPRB, 0.22169692E-06_JPRB, 0.21559907E-06_JPRB, 0.21549924E-06_JPRB, &
  & 0.22084183E-06_JPRB, 0.23161964E-06_JPRB, 0.24679144E-06_JPRB, 0.26587000E-06_JPRB, 0.28804743E-06_JPRB, 0.31279237E-06_JPRB, &
  & 0.33992762E-06_JPRB, 0.37021658E-06_JPRB, 0.40531134E-06_JPRB, 0.44716344E-06_JPRB, 0.49814508E-06_JPRB, 0.55923971E-06_JPRB, &
  & 0.62916718E-06_JPRB, 0.70600976E-06_JPRB, 0.78774224E-06_JPRB, 0.87415481E-06_JPRB, 0.96461144E-06_JPRB, 0.10593386E-05_JPRB, &
  & 0.11582903E-05_JPRB, 0.12598744E-05_JPRB, 0.13619477E-05_JPRB, 0.14625208E-05_JPRB, 0.15603094E-05_JPRB, 0.16556347E-05_JPRB, &
  & 0.17501569E-05_JPRB, 0.18455730E-05_JPRB, 0.19426798E-05_JPRB, 0.20404930E-05_JPRB, 0.21350595E-05_JPRB, 0.22218051E-05_JPRB, &
  & 0.22975698E-05_JPRB, 0.23647538E-05_JPRB, 0.24322862E-05_JPRB, 0.25401148E-05_JPRB /)

RGHG7(:,38, 4) = (/ &
  & 0.15167331E-05_JPRB, 0.14102997E-05_JPRB, 0.13565131E-05_JPRB, 0.13147858E-05_JPRB, 0.12760838E-05_JPRB, 0.12396321E-05_JPRB, &
  & 0.12042183E-05_JPRB, 0.11694979E-05_JPRB, 0.11341461E-05_JPRB, 0.10965820E-05_JPRB, 0.10550888E-05_JPRB, 0.10081134E-05_JPRB, &
  & 0.95391420E-06_JPRB, 0.89281752E-06_JPRB, 0.82575298E-06_JPRB, 0.75400504E-06_JPRB, 0.68013378E-06_JPRB, 0.60514554E-06_JPRB, &
  & 0.53055089E-06_JPRB, 0.45849268E-06_JPRB, 0.39090600E-06_JPRB, 0.32999873E-06_JPRB, 0.27948315E-06_JPRB, 0.24012635E-06_JPRB, &
  & 0.21085219E-06_JPRB, 0.18985494E-06_JPRB, 0.17542543E-06_JPRB, 0.16620753E-06_JPRB, 0.16161887E-06_JPRB, 0.16159910E-06_JPRB, &
  & 0.16562176E-06_JPRB, 0.17407909E-06_JPRB, 0.18620973E-06_JPRB, 0.20155586E-06_JPRB, 0.21949579E-06_JPRB, 0.23952498E-06_JPRB, &
  & 0.26186140E-06_JPRB, 0.28736935E-06_JPRB, 0.31765157E-06_JPRB, 0.35482856E-06_JPRB, 0.40113846E-06_JPRB, 0.45766646E-06_JPRB, &
  & 0.52391670E-06_JPRB, 0.59741456E-06_JPRB, 0.67609278E-06_JPRB, 0.75807526E-06_JPRB, 0.84408106E-06_JPRB, 0.93480725E-06_JPRB, &
  & 0.10300264E-05_JPRB, 0.11285476E-05_JPRB, 0.12277235E-05_JPRB, 0.13248159E-05_JPRB, 0.14182640E-05_JPRB, 0.15085158E-05_JPRB, &
  & 0.15973093E-05_JPRB, 0.16867085E-05_JPRB, 0.17777113E-05_JPRB, 0.18694598E-05_JPRB, 0.19583842E-05_JPRB, 0.20401676E-05_JPRB, &
  & 0.21123203E-05_JPRB, 0.21771036E-05_JPRB, 0.22433021E-05_JPRB, 0.23511650E-05_JPRB /)

RGHG7(:,39, 4) = (/ &
  & 0.13567067E-05_JPRB, 0.12590990E-05_JPRB, 0.12124279E-05_JPRB, 0.11721991E-05_JPRB, 0.11357835E-05_JPRB, 0.11012095E-05_JPRB, &
  & 0.10682097E-05_JPRB, 0.10366647E-05_JPRB, 0.10050532E-05_JPRB, 0.97162615E-06_JPRB, 0.93451655E-06_JPRB, 0.89225387E-06_JPRB, &
  & 0.84363865E-06_JPRB, 0.78775668E-06_JPRB, 0.72575108E-06_JPRB, 0.65901708E-06_JPRB, 0.58960666E-06_JPRB, 0.51928089E-06_JPRB, &
  & 0.44893923E-06_JPRB, 0.38057590E-06_JPRB, 0.31826841E-06_JPRB, 0.26468771E-06_JPRB, 0.22171582E-06_JPRB, 0.19010714E-06_JPRB, &
  & 0.16769926E-06_JPRB, 0.15198134E-06_JPRB, 0.14128844E-06_JPRB, 0.13440396E-06_JPRB, 0.13083147E-06_JPRB, 0.13079045E-06_JPRB, &
  & 0.13382981E-06_JPRB, 0.14054179E-06_JPRB, 0.15041881E-06_JPRB, 0.16303670E-06_JPRB, 0.17783756E-06_JPRB, 0.19450992E-06_JPRB, &
  & 0.21316859E-06_JPRB, 0.23467635E-06_JPRB, 0.26054573E-06_JPRB, 0.29281000E-06_JPRB, 0.33366359E-06_JPRB, 0.38459703E-06_JPRB, &
  & 0.44499564E-06_JPRB, 0.51326782E-06_JPRB, 0.58619230E-06_JPRB, 0.66303130E-06_JPRB, 0.74361287E-06_JPRB, 0.82919331E-06_JPRB, &
  & 0.92047731E-06_JPRB, 0.10160555E-05_JPRB, 0.11125185E-05_JPRB, 0.12061709E-05_JPRB, 0.12951566E-05_JPRB, 0.13798207E-05_JPRB, &
  & 0.14622580E-05_JPRB, 0.15446932E-05_JPRB, 0.16285617E-05_JPRB, 0.17129224E-05_JPRB, 0.17946801E-05_JPRB, 0.18699491E-05_JPRB, &
  & 0.19368347E-05_JPRB, 0.19978481E-05_JPRB, 0.20613820E-05_JPRB, 0.21667604E-05_JPRB /)

RGHG7(:,40, 4) = (/ &
  & 0.12118172E-05_JPRB, 0.11268636E-05_JPRB, 0.10825230E-05_JPRB, 0.10460105E-05_JPRB, 0.10103635E-05_JPRB, 0.97747602E-06_JPRB, &
  & 0.94682684E-06_JPRB, 0.91822329E-06_JPRB, 0.89005601E-06_JPRB, 0.86070605E-06_JPRB, 0.82819463E-06_JPRB, 0.79071941E-06_JPRB, &
  & 0.74686267E-06_JPRB, 0.69619927E-06_JPRB, 0.63942787E-06_JPRB, 0.57809467E-06_JPRB, 0.51385979E-06_JPRB, 0.44812938E-06_JPRB, &
  & 0.38315440E-06_JPRB, 0.32051224E-06_JPRB, 0.26446449E-06_JPRB, 0.21890244E-06_JPRB, 0.18388262E-06_JPRB, 0.15868035E-06_JPRB, &
  & 0.14130300E-06_JPRB, 0.12920970E-06_JPRB, 0.12087563E-06_JPRB, 0.11543246E-06_JPRB, 0.11243243E-06_JPRB, 0.11230300E-06_JPRB, &
  & 0.11465615E-06_JPRB, 0.12019571E-06_JPRB, 0.12855060E-06_JPRB, 0.13933290E-06_JPRB, 0.15207524E-06_JPRB, 0.16639457E-06_JPRB, &
  & 0.18252042E-06_JPRB, 0.20103394E-06_JPRB, 0.22331164E-06_JPRB, 0.25118086E-06_JPRB, 0.28672719E-06_JPRB, 0.33144482E-06_JPRB, &
  & 0.38545033E-06_JPRB, 0.44677469E-06_JPRB, 0.51339669E-06_JPRB, 0.58339486E-06_JPRB, 0.65792000E-06_JPRB, 0.73846115E-06_JPRB, &
  & 0.82569528E-06_JPRB, 0.91821710E-06_JPRB, 0.10121252E-05_JPRB, 0.11024835E-05_JPRB, 0.11869552E-05_JPRB, 0.12658838E-05_JPRB, &
  & 0.13417063E-05_JPRB, 0.14170159E-05_JPRB, 0.14931967E-05_JPRB, 0.15696663E-05_JPRB, 0.16433605E-05_JPRB, 0.17110591E-05_JPRB, &
  & 0.17716826E-05_JPRB, 0.18277536E-05_JPRB, 0.18872739E-05_JPRB, 0.19885083E-05_JPRB /)

RGHG7(:,41, 4) = (/ &
  & 0.10836733E-05_JPRB, 0.10072489E-05_JPRB, 0.96814802E-06_JPRB, 0.93267209E-06_JPRB, 0.89868558E-06_JPRB, 0.86680848E-06_JPRB, &
  & 0.83813956E-06_JPRB, 0.81241762E-06_JPRB, 0.78776685E-06_JPRB, 0.76224450E-06_JPRB, 0.73404078E-06_JPRB, 0.70127294E-06_JPRB, &
  & 0.66244672E-06_JPRB, 0.61679174E-06_JPRB, 0.56499061E-06_JPRB, 0.50866510E-06_JPRB, 0.44961430E-06_JPRB, 0.38923903E-06_JPRB, &
  & 0.32955043E-06_JPRB, 0.27407705E-06_JPRB, 0.22531771E-06_JPRB, 0.18674426E-06_JPRB, 0.15826906E-06_JPRB, 0.13796009E-06_JPRB, &
  & 0.12402664E-06_JPRB, 0.11429210E-06_JPRB, 0.10747497E-06_JPRB, 0.10289200E-06_JPRB, 0.10022456E-06_JPRB, 0.99974940E-07_JPRB, &
  & 0.10184719E-06_JPRB, 0.10654968E-06_JPRB, 0.11387315E-06_JPRB, 0.12339325E-06_JPRB, 0.13468856E-06_JPRB, 0.14744398E-06_JPRB, &
  & 0.16171197E-06_JPRB, 0.17806532E-06_JPRB, 0.19758150E-06_JPRB, 0.22176822E-06_JPRB, 0.25251643E-06_JPRB, 0.29126562E-06_JPRB, &
  & 0.33826643E-06_JPRB, 0.39273877E-06_JPRB, 0.45211732E-06_JPRB, 0.51578922E-06_JPRB, 0.58415242E-06_JPRB, 0.65907886E-06_JPRB, &
  & 0.74198493E-06_JPRB, 0.83150928E-06_JPRB, 0.92266981E-06_JPRB, 0.10098089E-05_JPRB, 0.10895960E-05_JPRB, 0.11628090E-05_JPRB, &
  & 0.12320968E-05_JPRB, 0.13002805E-05_JPRB, 0.13689616E-05_JPRB, 0.14373961E-05_JPRB, 0.15028686E-05_JPRB, 0.15626756E-05_JPRB, &
  & 0.16164563E-05_JPRB, 0.16669526E-05_JPRB, 0.17218968E-05_JPRB, 0.18171528E-05_JPRB /)

RGHG7(:,42, 4) = (/ &
  & 0.96945212E-06_JPRB, 0.90125639E-06_JPRB, 0.86478747E-06_JPRB, 0.83161586E-06_JPRB, 0.79825946E-06_JPRB, 0.76740469E-06_JPRB, &
  & 0.74065679E-06_JPRB, 0.71759109E-06_JPRB, 0.69613662E-06_JPRB, 0.67450532E-06_JPRB, 0.65054894E-06_JPRB, 0.62233801E-06_JPRB, &
  & 0.58812526E-06_JPRB, 0.54731908E-06_JPRB, 0.50041882E-06_JPRB, 0.44898064E-06_JPRB, 0.39490416E-06_JPRB, 0.33989559E-06_JPRB, &
  & 0.28629145E-06_JPRB, 0.23713608E-06_JPRB, 0.19577898E-06_JPRB, 0.16335902E-06_JPRB, 0.13987746E-06_JPRB, 0.12320497E-06_JPRB, &
  & 0.11167003E-06_JPRB, 0.10354372E-06_JPRB, 0.97718292E-07_JPRB, 0.93692549E-07_JPRB, 0.91228898E-07_JPRB, 0.90845838E-07_JPRB, &
  & 0.92359706E-07_JPRB, 0.96448112E-07_JPRB, 0.10298293E-06_JPRB, 0.11157760E-06_JPRB, 0.12186081E-06_JPRB, 0.13343973E-06_JPRB, &
  & 0.14638877E-06_JPRB, 0.16110566E-06_JPRB, 0.17846806E-06_JPRB, 0.19972057E-06_JPRB, 0.22627815E-06_JPRB, 0.25934946E-06_JPRB, &
  & 0.29955967E-06_JPRB, 0.34640794E-06_JPRB, 0.39894888E-06_JPRB, 0.45564312E-06_JPRB, 0.51789772E-06_JPRB, 0.58771752E-06_JPRB, &
  & 0.66632663E-06_JPRB, 0.75237625E-06_JPRB, 0.84073145E-06_JPRB, 0.92402422E-06_JPRB, 0.99901342E-06_JPRB, 0.10663944E-05_JPRB, &
  & 0.11293337E-05_JPRB, 0.11907408E-05_JPRB, 0.12522798E-05_JPRB, 0.13131315E-05_JPRB, 0.13706783E-05_JPRB, 0.14228420E-05_JPRB, &
  & 0.14698554E-05_JPRB, 0.15146796E-05_JPRB, 0.15644366E-05_JPRB, 0.16531134E-05_JPRB /)

RGHG7(:,43, 4) = (/ &
  & 0.86656723E-06_JPRB, 0.80560557E-06_JPRB, 0.77174082E-06_JPRB, 0.74022091E-06_JPRB, 0.70759023E-06_JPRB, 0.67778285E-06_JPRB, &
  & 0.65270302E-06_JPRB, 0.63217885E-06_JPRB, 0.61375960E-06_JPRB, 0.59558408E-06_JPRB, 0.57558742E-06_JPRB, 0.55172944E-06_JPRB, &
  & 0.52214091E-06_JPRB, 0.48581200E-06_JPRB, 0.44345640E-06_JPRB, 0.39667128E-06_JPRB, 0.34738162E-06_JPRB, 0.29756021E-06_JPRB, &
  & 0.24989913E-06_JPRB, 0.20744397E-06_JPRB, 0.17242630E-06_JPRB, 0.14546552E-06_JPRB, 0.12586074E-06_JPRB, 0.11193244E-06_JPRB, &
  & 0.10215350E-06_JPRB, 0.95140777E-07_JPRB, 0.90021565E-07_JPRB, 0.86356835E-07_JPRB, 0.84030496E-07_JPRB, 0.83523538E-07_JPRB, &
  & 0.84756905E-07_JPRB, 0.88336634E-07_JPRB, 0.94265395E-07_JPRB, 0.10213044E-06_JPRB, 0.11161154E-06_JPRB, 0.12236133E-06_JPRB, &
  & 0.13429968E-06_JPRB, 0.14776371E-06_JPRB, 0.16343554E-06_JPRB, 0.18223037E-06_JPRB, 0.20521601E-06_JPRB, 0.23319596E-06_JPRB, &
  & 0.26658077E-06_JPRB, 0.30586520E-06_JPRB, 0.35049973E-06_JPRB, 0.40076108E-06_JPRB, 0.45693733E-06_JPRB, 0.52142411E-06_JPRB, &
  & 0.59562063E-06_JPRB, 0.67808338E-06_JPRB, 0.76258453E-06_JPRB, 0.84163304E-06_JPRB, 0.91126327E-06_JPRB, 0.97280815E-06_JPRB, &
  & 0.10295779E-05_JPRB, 0.10847428E-05_JPRB, 0.11397383E-05_JPRB, 0.11936860E-05_JPRB, 0.12440361E-05_JPRB, 0.12892417E-05_JPRB, &
  & 0.13299568E-05_JPRB, 0.13692700E-05_JPRB, 0.14139583E-05_JPRB, 0.14953803E-05_JPRB /)

RGHG7(:,44, 4) = (/ &
  & 0.77402751E-06_JPRB, 0.71818658E-06_JPRB, 0.68719788E-06_JPRB, 0.65675937E-06_JPRB, 0.62529790E-06_JPRB, 0.59618782E-06_JPRB, &
  & 0.57304976E-06_JPRB, 0.55453904E-06_JPRB, 0.53899743E-06_JPRB, 0.52387935E-06_JPRB, 0.50752584E-06_JPRB, 0.48764213E-06_JPRB, &
  & 0.46226904E-06_JPRB, 0.43015174E-06_JPRB, 0.39186415E-06_JPRB, 0.34928607E-06_JPRB, 0.30452873E-06_JPRB, 0.26009863E-06_JPRB, &
  & 0.21849685E-06_JPRB, 0.18256833E-06_JPRB, 0.15345923E-06_JPRB, 0.13112926E-06_JPRB, 0.11470469E-06_JPRB, 0.10288135E-06_JPRB, &
  & 0.94416841E-07_JPRB, 0.88224311E-07_JPRB, 0.83600405E-07_JPRB, 0.80192095E-07_JPRB, 0.77955605E-07_JPRB, 0.77336800E-07_JPRB, &
  & 0.78339326E-07_JPRB, 0.81514877E-07_JPRB, 0.86908564E-07_JPRB, 0.94167447E-07_JPRB, 0.10304354E-06_JPRB, 0.11313571E-06_JPRB, &
  & 0.12433823E-06_JPRB, 0.13684986E-06_JPRB, 0.15114722E-06_JPRB, 0.16791746E-06_JPRB, 0.18778222E-06_JPRB, 0.21110569E-06_JPRB, &
  & 0.23819324E-06_JPRB, 0.26939529E-06_JPRB, 0.30607117E-06_JPRB, 0.34839414E-06_JPRB, 0.39835257E-06_JPRB, 0.45759646E-06_JPRB, &
  & 0.52726944E-06_JPRB, 0.60549468E-06_JPRB, 0.68575088E-06_JPRB, 0.75953722E-06_JPRB, 0.82346594E-06_JPRB, 0.87911224E-06_JPRB, &
  & 0.93013540E-06_JPRB, 0.97947077E-06_JPRB, 0.10286537E-05_JPRB, 0.10764892E-05_JPRB, 0.11206010E-05_JPRB, 0.11597152E-05_JPRB, &
  & 0.11948724E-05_JPRB, 0.12291341E-05_JPRB, 0.12687510E-05_JPRB, 0.13427772E-05_JPRB /)

RGHG7(:,45, 4) = (/ &
  & 0.68968723E-06_JPRB, 0.63892554E-06_JPRB, 0.60932172E-06_JPRB, 0.58065518E-06_JPRB, 0.54961481E-06_JPRB, 0.52163830E-06_JPRB, &
  & 0.49995106E-06_JPRB, 0.48362358E-06_JPRB, 0.47027851E-06_JPRB, 0.45793530E-06_JPRB, 0.44451741E-06_JPRB, 0.42823041E-06_JPRB, &
  & 0.40667780E-06_JPRB, 0.37836807E-06_JPRB, 0.34376171E-06_JPRB, 0.30495713E-06_JPRB, 0.26485628E-06_JPRB, 0.22580926E-06_JPRB, &
  & 0.19097558E-06_JPRB, 0.16145546E-06_JPRB, 0.13781239E-06_JPRB, 0.11939703E-06_JPRB, 0.10558631E-06_JPRB, 0.95387335E-07_JPRB, &
  & 0.87951925E-07_JPRB, 0.82349814E-07_JPRB, 0.78086686E-07_JPRB, 0.74849062E-07_JPRB, 0.72672954E-07_JPRB, 0.71965836E-07_JPRB, &
  & 0.72773361E-07_JPRB, 0.75606351E-07_JPRB, 0.80543430E-07_JPRB, 0.87298275E-07_JPRB, 0.95662827E-07_JPRB, 0.10528369E-06_JPRB, &
  & 0.11593632E-06_JPRB, 0.12772377E-06_JPRB, 0.14094495E-06_JPRB, 0.15601124E-06_JPRB, 0.17318679E-06_JPRB, 0.19242844E-06_JPRB, &
  & 0.21353326E-06_JPRB, 0.23734088E-06_JPRB, 0.26482843E-06_JPRB, 0.29906852E-06_JPRB, 0.34134354E-06_JPRB, 0.39449887E-06_JPRB, &
  & 0.45922351E-06_JPRB, 0.53295719E-06_JPRB, 0.60810964E-06_JPRB, 0.67617248E-06_JPRB, 0.73402055E-06_JPRB, 0.78402081E-06_JPRB, &
  & 0.82942023E-06_JPRB, 0.87360331E-06_JPRB, 0.91754077E-06_JPRB, 0.96013434E-06_JPRB, 0.99887473E-06_JPRB, 0.10328786E-05_JPRB, &
  & 0.10632009E-05_JPRB, 0.10929358E-05_JPRB, 0.11277386E-05_JPRB, 0.11941519E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART8',0,ZHOOK_HANDLE)



RGHG7(:,46, 4) = (/ &
  & 0.61294685E-06_JPRB, 0.56610060E-06_JPRB, 0.53802125E-06_JPRB, 0.51013097E-06_JPRB, 0.47994837E-06_JPRB, 0.45282826E-06_JPRB, &
  & 0.43260931E-06_JPRB, 0.41808397E-06_JPRB, 0.40672447E-06_JPRB, 0.39637720E-06_JPRB, 0.38549916E-06_JPRB, 0.37192257E-06_JPRB, &
  & 0.35368012E-06_JPRB, 0.32876468E-06_JPRB, 0.29733286E-06_JPRB, 0.26253866E-06_JPRB, 0.22717862E-06_JPRB, 0.19480748E-06_JPRB, &
  & 0.16668096E-06_JPRB, 0.14363829E-06_JPRB, 0.12477241E-06_JPRB, 0.10972723E-06_JPRB, 0.98017523E-07_JPRB, 0.89114216E-07_JPRB, &
  & 0.82447727E-07_JPRB, 0.77275779E-07_JPRB, 0.73278670E-07_JPRB, 0.70145333E-07_JPRB, 0.68008269E-07_JPRB, 0.67221400E-07_JPRB, &
  & 0.67873081E-07_JPRB, 0.70426005E-07_JPRB, 0.74966508E-07_JPRB, 0.81273640E-07_JPRB, 0.89251706E-07_JPRB, 0.98495939E-07_JPRB, &
  & 0.10876303E-06_JPRB, 0.12000191E-06_JPRB, 0.13235920E-06_JPRB, 0.14601862E-06_JPRB, 0.16091455E-06_JPRB, 0.17658458E-06_JPRB, &
  & 0.19270479E-06_JPRB, 0.20944972E-06_JPRB, 0.22892554E-06_JPRB, 0.25339881E-06_JPRB, 0.28703502E-06_JPRB, 0.33219646E-06_JPRB, &
  & 0.39068695E-06_JPRB, 0.45920399E-06_JPRB, 0.52899856E-06_JPRB, 0.59089018E-06_JPRB, 0.64291152E-06_JPRB, 0.68703605E-06_JPRB, &
  & 0.72761992E-06_JPRB, 0.76681226E-06_JPRB, 0.80625387E-06_JPRB, 0.84421782E-06_JPRB, 0.87848844E-06_JPRB, 0.90812802E-06_JPRB, &
  & 0.93441849E-06_JPRB, 0.96009808E-06_JPRB, 0.99045189E-06_JPRB, 0.10491451E-05_JPRB /)

RGHG7(:,47, 4) = (/ &
  & 0.54381587E-06_JPRB, 0.49880833E-06_JPRB, 0.47243142E-06_JPRB, 0.44473316E-06_JPRB, 0.41533752E-06_JPRB, 0.38904381E-06_JPRB, &
  & 0.37013038E-06_JPRB, 0.35718571E-06_JPRB, 0.34725807E-06_JPRB, 0.33861951E-06_JPRB, 0.32935057E-06_JPRB, 0.31814406E-06_JPRB, &
  & 0.30232044E-06_JPRB, 0.28020159E-06_JPRB, 0.25224028E-06_JPRB, 0.22143530E-06_JPRB, 0.19244325E-06_JPRB, 0.16702506E-06_JPRB, &
  & 0.14613350E-06_JPRB, 0.12869273E-06_JPRB, 0.11403072E-06_JPRB, 0.10170729E-06_JPRB, 0.91703299E-07_JPRB, 0.83796337E-07_JPRB, &
  & 0.77720976E-07_JPRB, 0.72858811E-07_JPRB, 0.69045988E-07_JPRB, 0.65967896E-07_JPRB, 0.63859197E-07_JPRB, 0.63001302E-07_JPRB, &
  & 0.63525611E-07_JPRB, 0.65850919E-07_JPRB, 0.70038887E-07_JPRB, 0.75997967E-07_JPRB, 0.83636891E-07_JPRB, 0.92595151E-07_JPRB, &
  & 0.10257842E-06_JPRB, 0.11339907E-06_JPRB, 0.12506280E-06_JPRB, 0.13754732E-06_JPRB, 0.15050706E-06_JPRB, 0.16330789E-06_JPRB, &
  & 0.17519658E-06_JPRB, 0.18662817E-06_JPRB, 0.19888533E-06_JPRB, 0.21520619E-06_JPRB, 0.23891906E-06_JPRB, 0.27419594E-06_JPRB, &
  & 0.32361433E-06_JPRB, 0.38517859E-06_JPRB, 0.44856793E-06_JPRB, 0.50423398E-06_JPRB, 0.54995746E-06_JPRB, 0.58916248E-06_JPRB, &
  & 0.62465705E-06_JPRB, 0.65981351E-06_JPRB, 0.69503005E-06_JPRB, 0.72914611E-06_JPRB, 0.75955194E-06_JPRB, 0.78560538E-06_JPRB, &
  & 0.80844131E-06_JPRB, 0.83072445E-06_JPRB, 0.85704227E-06_JPRB, 0.90856645E-06_JPRB /)

RGHG7(:,48, 4) = (/ &
  & 0.48030057E-06_JPRB, 0.43807279E-06_JPRB, 0.41084877E-06_JPRB, 0.38441871E-06_JPRB, 0.35462122E-06_JPRB, 0.32939374E-06_JPRB, &
  & 0.31154454E-06_JPRB, 0.29970766E-06_JPRB, 0.29102679E-06_JPRB, 0.28340526E-06_JPRB, 0.27562277E-06_JPRB, 0.26576714E-06_JPRB, &
  & 0.25224401E-06_JPRB, 0.23292358E-06_JPRB, 0.20861756E-06_JPRB, 0.18392576E-06_JPRB, 0.16190742E-06_JPRB, 0.14394355E-06_JPRB, &
  & 0.12917296E-06_JPRB, 0.11655388E-06_JPRB, 0.10520569E-06_JPRB, 0.95103005E-07_JPRB, 0.86403482E-07_JPRB, 0.79286032E-07_JPRB, &
  & 0.73610977E-07_JPRB, 0.68983297E-07_JPRB, 0.65298821E-07_JPRB, 0.62239579E-07_JPRB, 0.60154683E-07_JPRB, 0.59229652E-07_JPRB, &
  & 0.59654887E-07_JPRB, 0.61781854E-07_JPRB, 0.65683352E-07_JPRB, 0.71332757E-07_JPRB, 0.78695010E-07_JPRB, 0.87439744E-07_JPRB, &
  & 0.97183324E-07_JPRB, 0.10767307E-06_JPRB, 0.11878119E-06_JPRB, 0.13027956E-06_JPRB, 0.14168316E-06_JPRB, 0.15210530E-06_JPRB, &
  & 0.16091290E-06_JPRB, 0.16824364E-06_JPRB, 0.17569278E-06_JPRB, 0.18543973E-06_JPRB, 0.20084222E-06_JPRB, 0.22552419E-06_JPRB, &
  & 0.26358924E-06_JPRB, 0.31414959E-06_JPRB, 0.36833399E-06_JPRB, 0.41630310E-06_JPRB, 0.45599123E-06_JPRB, 0.48982372E-06_JPRB, &
  & 0.52130446E-06_JPRB, 0.55240389E-06_JPRB, 0.58430811E-06_JPRB, 0.61503187E-06_JPRB, 0.64238236E-06_JPRB, 0.66538973E-06_JPRB, &
  & 0.68555181E-06_JPRB, 0.70498106E-06_JPRB, 0.72805244E-06_JPRB, 0.77343708E-06_JPRB /)

RGHG7(:,49, 4) = (/ &
  & 0.42265353E-06_JPRB, 0.38061341E-06_JPRB, 0.35440240E-06_JPRB, 0.32677099E-06_JPRB, 0.29772747E-06_JPRB, 0.27268476E-06_JPRB, &
  & 0.25589824E-06_JPRB, 0.24497308E-06_JPRB, 0.23712799E-06_JPRB, 0.23054760E-06_JPRB, 0.22370666E-06_JPRB, 0.21561648E-06_JPRB, &
  & 0.20408663E-06_JPRB, 0.18852946E-06_JPRB, 0.17000215E-06_JPRB, 0.15225081E-06_JPRB, 0.13756248E-06_JPRB, 0.12578208E-06_JPRB, &
  & 0.11584097E-06_JPRB, 0.10679851E-06_JPRB, 0.98039308E-07_JPRB, 0.89640878E-07_JPRB, 0.81955129E-07_JPRB, 0.75420395E-07_JPRB, &
  & 0.69996098E-07_JPRB, 0.65566731E-07_JPRB, 0.61924297E-07_JPRB, 0.58901708E-07_JPRB, 0.56841706E-07_JPRB, 0.55851743E-07_JPRB, &
  & 0.56192093E-07_JPRB, 0.58150739E-07_JPRB, 0.61802226E-07_JPRB, 0.67197483E-07_JPRB, 0.74325101E-07_JPRB, 0.82849411E-07_JPRB, &
  & 0.92410815E-07_JPRB, 0.10263119E-06_JPRB, 0.11327485E-06_JPRB, 0.12398580E-06_JPRB, 0.13409759E-06_JPRB, 0.14269436E-06_JPRB, &
  & 0.14912919E-06_JPRB, 0.15382598E-06_JPRB, 0.15802644E-06_JPRB, 0.16383377E-06_JPRB, 0.17327808E-06_JPRB, 0.18957071E-06_JPRB, &
  & 0.21560837E-06_JPRB, 0.25214192E-06_JPRB, 0.29320796E-06_JPRB, 0.33057717E-06_JPRB, 0.36274449E-06_JPRB, 0.39092308E-06_JPRB, &
  & 0.41798714E-06_JPRB, 0.44557947E-06_JPRB, 0.47430677E-06_JPRB, 0.50233115E-06_JPRB, 0.52706827E-06_JPRB, 0.54783715E-06_JPRB, &
  & 0.56581081E-06_JPRB, 0.58311991E-06_JPRB, 0.60382126E-06_JPRB, 0.64436040E-06_JPRB /)

RGHG7(:,50, 4) = (/ &
  & 0.37013089E-06_JPRB, 0.32724776E-06_JPRB, 0.30082745E-06_JPRB, 0.27281729E-06_JPRB, 0.24358221E-06_JPRB, 0.21940288E-06_JPRB, &
  & 0.20376892E-06_JPRB, 0.19401564E-06_JPRB, 0.18727165E-06_JPRB, 0.18180765E-06_JPRB, 0.17657767E-06_JPRB, 0.17021164E-06_JPRB, &
  & 0.16234875E-06_JPRB, 0.15152531E-06_JPRB, 0.13970566E-06_JPRB, 0.12867211E-06_JPRB, 0.11967911E-06_JPRB, 0.11219279E-06_JPRB, &
  & 0.10558434E-06_JPRB, 0.99040662E-07_JPRB, 0.92198071E-07_JPRB, 0.85117598E-07_JPRB, 0.78201012E-07_JPRB, 0.72051918E-07_JPRB, &
  & 0.66798101E-07_JPRB, 0.62492553E-07_JPRB, 0.58847071E-07_JPRB, 0.55905105E-07_JPRB, 0.53849664E-07_JPRB, 0.52818649E-07_JPRB, &
  & 0.53088577E-07_JPRB, 0.54888471E-07_JPRB, 0.58330841E-07_JPRB, 0.63503293E-07_JPRB, 0.70397995E-07_JPRB, 0.78745337E-07_JPRB, &
  & 0.88112316E-07_JPRB, 0.98108202E-07_JPRB, 0.10838492E-06_JPRB, 0.11845038E-06_JPRB, 0.12752048E-06_JPRB, 0.13464933E-06_JPRB, &
  & 0.13937064E-06_JPRB, 0.14226680E-06_JPRB, 0.14470056E-06_JPRB, 0.14805100E-06_JPRB, 0.15417109E-06_JPRB, 0.16450967E-06_JPRB, &
  & 0.18131526E-06_JPRB, 0.20507780E-06_JPRB, 0.23096884E-06_JPRB, 0.25589932E-06_JPRB, 0.27786214E-06_JPRB, 0.29902574E-06_JPRB, &
  & 0.32007796E-06_JPRB, 0.34302735E-06_JPRB, 0.36785869E-06_JPRB, 0.39285797E-06_JPRB, 0.41514875E-06_JPRB, 0.43383372E-06_JPRB, &
  & 0.45004538E-06_JPRB, 0.46586797E-06_JPRB, 0.48459492E-06_JPRB, 0.52208441E-06_JPRB /)

RGHG7(:,51, 4) = (/ &
  & 0.32008512E-06_JPRB, 0.27890442E-06_JPRB, 0.24990658E-06_JPRB, 0.22309577E-06_JPRB, 0.19396708E-06_JPRB, 0.17217617E-06_JPRB, &
  & 0.15896468E-06_JPRB, 0.15128815E-06_JPRB, 0.14640280E-06_JPRB, 0.14269493E-06_JPRB, 0.13923685E-06_JPRB, 0.13578337E-06_JPRB, &
  & 0.13093451E-06_JPRB, 0.12530326E-06_JPRB, 0.11857061E-06_JPRB, 0.11237347E-06_JPRB, 0.10695740E-06_JPRB, 0.10222450E-06_JPRB, &
  & 0.97664746E-07_JPRB, 0.92823889E-07_JPRB, 0.87410442E-07_JPRB, 0.81291645E-07_JPRB, 0.75015798E-07_JPRB, 0.69054892E-07_JPRB, &
  & 0.63956847E-07_JPRB, 0.59630764E-07_JPRB, 0.56041852E-07_JPRB, 0.53172773E-07_JPRB, 0.51133767E-07_JPRB, 0.50079425E-07_JPRB, &
  & 0.50291657E-07_JPRB, 0.51951602E-07_JPRB, 0.55208520E-07_JPRB, 0.60179040E-07_JPRB, 0.66854497E-07_JPRB, 0.75007442E-07_JPRB, &
  & 0.84196252E-07_JPRB, 0.93996910E-07_JPRB, 0.10396604E-06_JPRB, 0.11349595E-06_JPRB, 0.12170196E-06_JPRB, 0.12761430E-06_JPRB, &
  & 0.13105502E-06_JPRB, 0.13284404E-06_JPRB, 0.13418006E-06_JPRB, 0.13639634E-06_JPRB, 0.14038395E-06_JPRB, 0.14725811E-06_JPRB, &
  & 0.15812985E-06_JPRB, 0.17205139E-06_JPRB, 0.18702053E-06_JPRB, 0.20042266E-06_JPRB, 0.21317979E-06_JPRB, 0.22550479E-06_JPRB, &
  & 0.23915896E-06_JPRB, 0.25496493E-06_JPRB, 0.27371325E-06_JPRB, 0.29362161E-06_JPRB, 0.31220688E-06_JPRB, 0.32826935E-06_JPRB, &
  & 0.34238948E-06_JPRB, 0.35635549E-06_JPRB, 0.37366607E-06_JPRB, 0.40787361E-06_JPRB /)

RGHG7(:,52, 4) = (/ &
  & 0.27584500E-06_JPRB, 0.23109862E-06_JPRB, 0.20612755E-06_JPRB, 0.17768747E-06_JPRB, 0.15325891E-06_JPRB, 0.13558230E-06_JPRB, &
  & 0.12631688E-06_JPRB, 0.12143515E-06_JPRB, 0.11846952E-06_JPRB, 0.11646683E-06_JPRB, 0.11480630E-06_JPRB, 0.11289860E-06_JPRB, &
  & 0.11097892E-06_JPRB, 0.10802266E-06_JPRB, 0.10470121E-06_JPRB, 0.10116873E-06_JPRB, 0.97896951E-07_JPRB, 0.94722942E-07_JPRB, &
  & 0.91481127E-07_JPRB, 0.87761677E-07_JPRB, 0.83333511E-07_JPRB, 0.78025764E-07_JPRB, 0.72175801E-07_JPRB, 0.66381446E-07_JPRB, &
  & 0.61334546E-07_JPRB, 0.56972674E-07_JPRB, 0.53477443E-07_JPRB, 0.50655093E-07_JPRB, 0.48641709E-07_JPRB, 0.47599169E-07_JPRB, &
  & 0.47767500E-07_JPRB, 0.49305484E-07_JPRB, 0.52398430E-07_JPRB, 0.57171857E-07_JPRB, 0.63630871E-07_JPRB, 0.71589795E-07_JPRB, &
  & 0.80597850E-07_JPRB, 0.90213526E-07_JPRB, 0.99897669E-07_JPRB, 0.10896200E-06_JPRB, 0.11638129E-06_JPRB, 0.12131822E-06_JPRB, &
  & 0.12380374E-06_JPRB, 0.12487783E-06_JPRB, 0.12568687E-06_JPRB, 0.12717459E-06_JPRB, 0.13009547E-06_JPRB, 0.13481552E-06_JPRB, &
  & 0.14197728E-06_JPRB, 0.15041265E-06_JPRB, 0.15829721E-06_JPRB, 0.16528328E-06_JPRB, 0.17138042E-06_JPRB, 0.17760171E-06_JPRB, &
  & 0.18463382E-06_JPRB, 0.19340138E-06_JPRB, 0.20462544E-06_JPRB, 0.21779292E-06_JPRB, 0.23077570E-06_JPRB, 0.24241848E-06_JPRB, &
  & 0.25312480E-06_JPRB, 0.26426861E-06_JPRB, 0.27821542E-06_JPRB, 0.30841096E-06_JPRB /)

RGHG7(:,53, 4) = (/ &
  & 0.23416450E-06_JPRB, 0.19302544E-06_JPRB, 0.16522949E-06_JPRB, 0.14350481E-06_JPRB, 0.12317250E-06_JPRB, 0.11152034E-06_JPRB, &
  & 0.10588320E-06_JPRB, 0.10310358E-06_JPRB, 0.10162431E-06_JPRB, 0.10055490E-06_JPRB, 0.99804616E-07_JPRB, 0.99128854E-07_JPRB, &
  & 0.98092720E-07_JPRB, 0.96949066E-07_JPRB, 0.95195318E-07_JPRB, 0.93246754E-07_JPRB, 0.91144344E-07_JPRB, 0.88953804E-07_JPRB, &
  & 0.86479020E-07_JPRB, 0.83528029E-07_JPRB, 0.79794646E-07_JPRB, 0.75087542E-07_JPRB, 0.69562873E-07_JPRB, 0.63955170E-07_JPRB, &
  & 0.58828832E-07_JPRB, 0.54561792E-07_JPRB, 0.51091114E-07_JPRB, 0.48313844E-07_JPRB, 0.46365454E-07_JPRB, 0.45346383E-07_JPRB, &
  & 0.45485745E-07_JPRB, 0.46930051E-07_JPRB, 0.49868120E-07_JPRB, 0.54457768E-07_JPRB, 0.60694475E-07_JPRB, 0.68443555E-07_JPRB, &
  & 0.77262953E-07_JPRB, 0.86690719E-07_JPRB, 0.96085039E-07_JPRB, 0.10467259E-06_JPRB, 0.11140482E-06_JPRB, 0.11551480E-06_JPRB, &
  & 0.11733486E-06_JPRB, 0.11797850E-06_JPRB, 0.11845372E-06_JPRB, 0.11963982E-06_JPRB, 0.12182750E-06_JPRB, 0.12548176E-06_JPRB, &
  & 0.13051675E-06_JPRB, 0.13553223E-06_JPRB, 0.14012451E-06_JPRB, 0.14354102E-06_JPRB, 0.14659300E-06_JPRB, 0.14965188E-06_JPRB, &
  & 0.15304346E-06_JPRB, 0.15754699E-06_JPRB, 0.16354316E-06_JPRB, 0.17091139E-06_JPRB, 0.17848407E-06_JPRB, 0.18556742E-06_JPRB, &
  & 0.19211052E-06_JPRB, 0.19915097E-06_JPRB, 0.20889418E-06_JPRB, 0.23108079E-06_JPRB /)

RGHG7(:,54, 4) = (/ &
  & 0.19793713E-06_JPRB, 0.15728853E-06_JPRB, 0.13636298E-06_JPRB, 0.11723471E-06_JPRB, 0.10409777E-06_JPRB, 0.96667627E-07_JPRB, &
  & 0.93505022E-07_JPRB, 0.91999837E-07_JPRB, 0.91215306E-07_JPRB, 0.90748344E-07_JPRB, 0.90360750E-07_JPRB, 0.90047287E-07_JPRB, &
  & 0.89778688E-07_JPRB, 0.89204548E-07_JPRB, 0.88395225E-07_JPRB, 0.87265775E-07_JPRB, 0.85885105E-07_JPRB, 0.84284864E-07_JPRB, &
  & 0.82322750E-07_JPRB, 0.79871803E-07_JPRB, 0.76581294E-07_JPRB, 0.72335283E-07_JPRB, 0.67079775E-07_JPRB, 0.61601362E-07_JPRB, &
  & 0.56531590E-07_JPRB, 0.52318921E-07_JPRB, 0.48860180E-07_JPRB, 0.46164949E-07_JPRB, 0.44280416E-07_JPRB, 0.43297998E-07_JPRB, &
  & 0.43427814E-07_JPRB, 0.44802896E-07_JPRB, 0.47600764E-07_JPRB, 0.51999130E-07_JPRB, 0.58014912E-07_JPRB, 0.65534685E-07_JPRB, &
  & 0.74164269E-07_JPRB, 0.83365506E-07_JPRB, 0.92437240E-07_JPRB, 0.10052502E-06_JPRB, 0.10661433E-06_JPRB, 0.11010565E-06_JPRB, &
  & 0.11145206E-06_JPRB, 0.11181660E-06_JPRB, 0.11217249E-06_JPRB, 0.11310641E-06_JPRB, 0.11507454E-06_JPRB, 0.11800769E-06_JPRB, &
  & 0.12174057E-06_JPRB, 0.12516351E-06_JPRB, 0.12787648E-06_JPRB, 0.12974877E-06_JPRB, 0.13150979E-06_JPRB, 0.13302459E-06_JPRB, &
  & 0.13490769E-06_JPRB, 0.13727836E-06_JPRB, 0.14055811E-06_JPRB, 0.14471728E-06_JPRB, 0.14901521E-06_JPRB, 0.15285649E-06_JPRB, &
  & 0.15644864E-06_JPRB, 0.16020520E-06_JPRB, 0.16526921E-06_JPRB, 0.17747318E-06_JPRB /)

RGHG7(:,55, 4) = (/ &
  & 0.16779124E-06_JPRB, 0.13090298E-06_JPRB, 0.11326668E-06_JPRB, 0.10059479E-06_JPRB, 0.91774901E-07_JPRB, 0.87420652E-07_JPRB, &
  & 0.85596575E-07_JPRB, 0.84783103E-07_JPRB, 0.84337948E-07_JPRB, 0.84084114E-07_JPRB, 0.83947477E-07_JPRB, 0.83799243E-07_JPRB, &
  & 0.83657149E-07_JPRB, 0.83507643E-07_JPRB, 0.83130544E-07_JPRB, 0.82495724E-07_JPRB, 0.81575578E-07_JPRB, 0.80354482E-07_JPRB, &
  & 0.78744264E-07_JPRB, 0.76586034E-07_JPRB, 0.73638603E-07_JPRB, 0.69617442E-07_JPRB, 0.64666509E-07_JPRB, 0.59297125E-07_JPRB, &
  & 0.54383623E-07_JPRB, 0.50203784E-07_JPRB, 0.46801020E-07_JPRB, 0.44186574E-07_JPRB, 0.42369635E-07_JPRB, 0.41431960E-07_JPRB, &
  & 0.41568352E-07_JPRB, 0.42898566E-07_JPRB, 0.45572875E-07_JPRB, 0.49774744E-07_JPRB, 0.55567469E-07_JPRB, 0.62844663E-07_JPRB, &
  & 0.71248458E-07_JPRB, 0.80190283E-07_JPRB, 0.88880213E-07_JPRB, 0.96439791E-07_JPRB, 0.10195667E-06_JPRB, 0.10499922E-06_JPRB, &
  & 0.10607089E-06_JPRB, 0.10621994E-06_JPRB, 0.10648029E-06_JPRB, 0.10736429E-06_JPRB, 0.10915855E-06_JPRB, 0.11183200E-06_JPRB, &
  & 0.11487069E-06_JPRB, 0.11727602E-06_JPRB, 0.11913633E-06_JPRB, 0.12038350E-06_JPRB, 0.12149827E-06_JPRB, 0.12247635E-06_JPRB, &
  & 0.12365135E-06_JPRB, 0.12505780E-06_JPRB, 0.12704157E-06_JPRB, 0.12954388E-06_JPRB, 0.13204598E-06_JPRB, 0.13439072E-06_JPRB, &
  & 0.13634900E-06_JPRB, 0.13848016E-06_JPRB, 0.14125624E-06_JPRB, 0.14812716E-06_JPRB /)

RGHG7(:,56, 4) = (/ &
  & 0.13970772E-06_JPRB, 0.11110106E-06_JPRB, 0.97692045E-07_JPRB, 0.89321482E-07_JPRB, 0.83775426E-07_JPRB, 0.81160167E-07_JPRB, &
  & 0.80044153E-07_JPRB, 0.79571137E-07_JPRB, 0.79335734E-07_JPRB, 0.79156457E-07_JPRB, 0.79064193E-07_JPRB, 0.79021056E-07_JPRB, &
  & 0.78999825E-07_JPRB, 0.78925680E-07_JPRB, 0.78801015E-07_JPRB, 0.78448466E-07_JPRB, 0.77850622E-07_JPRB, 0.76892398E-07_JPRB, &
  & 0.75537706E-07_JPRB, 0.73573254E-07_JPRB, 0.70811190E-07_JPRB, 0.66990971E-07_JPRB, 0.62220110E-07_JPRB, 0.57095018E-07_JPRB, &
  & 0.52315727E-07_JPRB, 0.48218798E-07_JPRB, 0.44891827E-07_JPRB, 0.42348031E-07_JPRB, 0.40611660E-07_JPRB, 0.39730718E-07_JPRB, &
  & 0.39884455E-07_JPRB, 0.41186656E-07_JPRB, 0.43755637E-07_JPRB, 0.47756771E-07_JPRB, 0.53308973E-07_JPRB, 0.60332781E-07_JPRB, &
  & 0.68480887E-07_JPRB, 0.77107124E-07_JPRB, 0.85366821E-07_JPRB, 0.92432472E-07_JPRB, 0.97461182E-07_JPRB, 0.10010812E-06_JPRB, &
  & 0.10103305E-06_JPRB, 0.10110313E-06_JPRB, 0.10127971E-06_JPRB, 0.10214651E-06_JPRB, 0.10394777E-06_JPRB, 0.10643041E-06_JPRB, &
  & 0.10905945E-06_JPRB, 0.11102383E-06_JPRB, 0.11243912E-06_JPRB, 0.11336331E-06_JPRB, 0.11423578E-06_JPRB, 0.11490849E-06_JPRB, &
  & 0.11577334E-06_JPRB, 0.11673409E-06_JPRB, 0.11816685E-06_JPRB, 0.11983155E-06_JPRB, 0.12159404E-06_JPRB, 0.12302719E-06_JPRB, &
  & 0.12426923E-06_JPRB, 0.12545972E-06_JPRB, 0.12702507E-06_JPRB, 0.13116080E-06_JPRB /)

RGHG7(:,57, 4) = (/ &
  & 0.11970036E-06_JPRB, 0.95067428E-07_JPRB, 0.87387662E-07_JPRB, 0.81542012E-07_JPRB, 0.78219017E-07_JPRB, 0.76534434E-07_JPRB, &
  & 0.75859823E-07_JPRB, 0.75524014E-07_JPRB, 0.75348545E-07_JPRB, 0.75263138E-07_JPRB, 0.75164316E-07_JPRB, 0.75112638E-07_JPRB, &
  & 0.75086668E-07_JPRB, 0.75095294E-07_JPRB, 0.75049641E-07_JPRB, 0.74880148E-07_JPRB, 0.74476084E-07_JPRB, 0.73738228E-07_JPRB, &
  & 0.72545454E-07_JPRB, 0.70735460E-07_JPRB, 0.68081754E-07_JPRB, 0.64410635E-07_JPRB, 0.59842698E-07_JPRB, 0.54937633E-07_JPRB, &
  & 0.50327692E-07_JPRB, 0.46339792E-07_JPRB, 0.43089287E-07_JPRB, 0.40632926E-07_JPRB, 0.38984577E-07_JPRB, 0.38179309E-07_JPRB, &
  & 0.38358838E-07_JPRB, 0.39635580E-07_JPRB, 0.42115303E-07_JPRB, 0.45920824E-07_JPRB, 0.51224568E-07_JPRB, 0.57961660E-07_JPRB, &
  & 0.65803469E-07_JPRB, 0.74082806E-07_JPRB, 0.81909477E-07_JPRB, 0.88522746E-07_JPRB, 0.93107666E-07_JPRB, 0.95471457E-07_JPRB, &
  & 0.96259825E-07_JPRB, 0.96331419E-07_JPRB, 0.96486431E-07_JPRB, 0.97366296E-07_JPRB, 0.99151748E-07_JPRB, 0.10163242E-06_JPRB, &
  & 0.10403148E-06_JPRB, 0.10574286E-06_JPRB, 0.10697585E-06_JPRB, 0.10783247E-06_JPRB, 0.10856401E-06_JPRB, 0.10920606E-06_JPRB, &
  & 0.10994975E-06_JPRB, 0.11076926E-06_JPRB, 0.11185963E-06_JPRB, 0.11312602E-06_JPRB, 0.11442391E-06_JPRB, 0.11551116E-06_JPRB, &
  & 0.11638571E-06_JPRB, 0.11721386E-06_JPRB, 0.11798463E-06_JPRB, 0.11897961E-06_JPRB /)

RGHG7(:,58, 4) = (/ &
  & 0.10055747E-06_JPRB, 0.85593413E-07_JPRB, 0.79350102E-07_JPRB, 0.76222129E-07_JPRB, 0.73952918E-07_JPRB, 0.72881143E-07_JPRB, &
  & 0.72382271E-07_JPRB, 0.72175702E-07_JPRB, 0.72003267E-07_JPRB, 0.71912531E-07_JPRB, 0.71830783E-07_JPRB, 0.71790595E-07_JPRB, &
  & 0.71726980E-07_JPRB, 0.71719214E-07_JPRB, 0.71687381E-07_JPRB, 0.71609477E-07_JPRB, 0.71337993E-07_JPRB, 0.70749238E-07_JPRB, &
  & 0.69706203E-07_JPRB, 0.67986001E-07_JPRB, 0.65446692E-07_JPRB, 0.61889324E-07_JPRB, 0.57521618E-07_JPRB, 0.52835158E-07_JPRB, &
  & 0.48409980E-07_JPRB, 0.44535295E-07_JPRB, 0.41388283E-07_JPRB, 0.39025810E-07_JPRB, 0.37482330E-07_JPRB, 0.36765901E-07_JPRB, &
  & 0.36984204E-07_JPRB, 0.38229068E-07_JPRB, 0.40623018E-07_JPRB, 0.44245390E-07_JPRB, 0.49261793E-07_JPRB, 0.55710608E-07_JPRB, &
  & 0.63210841E-07_JPRB, 0.71091456E-07_JPRB, 0.78509402E-07_JPRB, 0.84661913E-07_JPRB, 0.88915094E-07_JPRB, 0.91079869E-07_JPRB, &
  & 0.91787008E-07_JPRB, 0.91859178E-07_JPRB, 0.92033147E-07_JPRB, 0.92910533E-07_JPRB, 0.94709058E-07_JPRB, 0.97170428E-07_JPRB, &
  & 0.99441849E-07_JPRB, 0.10118008E-06_JPRB, 0.10228496E-06_JPRB, 0.10318093E-06_JPRB, 0.10387256E-06_JPRB, 0.10452295E-06_JPRB, &
  & 0.10519635E-06_JPRB, 0.10592525E-06_JPRB, 0.10691984E-06_JPRB, 0.10805242E-06_JPRB, 0.10920485E-06_JPRB, 0.11009748E-06_JPRB, &
  & 0.11089913E-06_JPRB, 0.11165530E-06_JPRB, 0.11274369E-06_JPRB, 0.11526031E-06_JPRB /)

RGHG7(:,59, 4) = (/ &
  & 0.86430298E-07_JPRB, 0.77166320E-07_JPRB, 0.74327339E-07_JPRB, 0.71982463E-07_JPRB, 0.70596592E-07_JPRB, 0.69818576E-07_JPRB, &
  & 0.69435387E-07_JPRB, 0.69239135E-07_JPRB, 0.69105383E-07_JPRB, 0.68995575E-07_JPRB, 0.68878776E-07_JPRB, 0.68809847E-07_JPRB, &
  & 0.68730451E-07_JPRB, 0.68683306E-07_JPRB, 0.68628964E-07_JPRB, 0.68557476E-07_JPRB, 0.68368529E-07_JPRB, 0.67877956E-07_JPRB, &
  & 0.66935293E-07_JPRB, 0.65317657E-07_JPRB, 0.62870228E-07_JPRB, 0.59471446E-07_JPRB, 0.55286424E-07_JPRB, 0.50819988E-07_JPRB, &
  & 0.46551236E-07_JPRB, 0.42821686E-07_JPRB, 0.39792731E-07_JPRB, 0.37552542E-07_JPRB, 0.36115210E-07_JPRB, 0.35493422E-07_JPRB, &
  & 0.35759097E-07_JPRB, 0.36975404E-07_JPRB, 0.39258822E-07_JPRB, 0.42707804E-07_JPRB, 0.47441105E-07_JPRB, 0.53572332E-07_JPRB, &
  & 0.60678140E-07_JPRB, 0.68160631E-07_JPRB, 0.75145202E-07_JPRB, 0.80904663E-07_JPRB, 0.84850853E-07_JPRB, 0.86910909E-07_JPRB, &
  & 0.87579721E-07_JPRB, 0.87687688E-07_JPRB, 0.87895081E-07_JPRB, 0.88760977E-07_JPRB, 0.90527315E-07_JPRB, 0.92919869E-07_JPRB, &
  & 0.95251366E-07_JPRB, 0.96933526E-07_JPRB, 0.98191528E-07_JPRB, 0.99100262E-07_JPRB, 0.99857651E-07_JPRB, 0.10057911E-06_JPRB, &
  & 0.10126109E-06_JPRB, 0.10207347E-06_JPRB, 0.10301928E-06_JPRB, 0.10404791E-06_JPRB, 0.10504657E-06_JPRB, 0.10585430E-06_JPRB, &
  & 0.10652170E-06_JPRB, 0.10714817E-06_JPRB, 0.10782508E-06_JPRB, 0.10934126E-06_JPRB /)

RGHG7(:,60, 4) = (/ &
  & 0.78863863E-07_JPRB, 0.72592805E-07_JPRB, 0.70133517E-07_JPRB, 0.68752847E-07_JPRB, 0.67710232E-07_JPRB, 0.67128887E-07_JPRB, &
  & 0.66808525E-07_JPRB, 0.66617261E-07_JPRB, 0.66463791E-07_JPRB, 0.66347461E-07_JPRB, 0.66230612E-07_JPRB, 0.66106196E-07_JPRB, &
  & 0.65990648E-07_JPRB, 0.65878154E-07_JPRB, 0.65784711E-07_JPRB, 0.65685803E-07_JPRB, 0.65523110E-07_JPRB, 0.65092728E-07_JPRB, &
  & 0.64249477E-07_JPRB, 0.62717710E-07_JPRB, 0.60371789E-07_JPRB, 0.57120612E-07_JPRB, 0.53119713E-07_JPRB, 0.48863278E-07_JPRB, &
  & 0.44782809E-07_JPRB, 0.41210448E-07_JPRB, 0.38342137E-07_JPRB, 0.36233523E-07_JPRB, 0.34911896E-07_JPRB, 0.34377621E-07_JPRB, &
  & 0.34687979E-07_JPRB, 0.35874507E-07_JPRB, 0.38031938E-07_JPRB, 0.41292207E-07_JPRB, 0.45740553E-07_JPRB, 0.51522587E-07_JPRB, &
  & 0.58226163E-07_JPRB, 0.65294401E-07_JPRB, 0.71862360E-07_JPRB, 0.77254846E-07_JPRB, 0.80974907E-07_JPRB, 0.82935458E-07_JPRB, &
  & 0.83623654E-07_JPRB, 0.83769386E-07_JPRB, 0.84026233E-07_JPRB, 0.84883986E-07_JPRB, 0.86575511E-07_JPRB, 0.88902119E-07_JPRB, &
  & 0.91199844E-07_JPRB, 0.93049046E-07_JPRB, 0.94392128E-07_JPRB, 0.95438573E-07_JPRB, 0.96328968E-07_JPRB, 0.97093718E-07_JPRB, &
  & 0.97880729E-07_JPRB, 0.98714480E-07_JPRB, 0.99665236E-07_JPRB, 0.10072417E-06_JPRB, 0.10170238E-06_JPRB, 0.10244585E-06_JPRB, &
  & 0.10311042E-06_JPRB, 0.10372031E-06_JPRB, 0.10457666E-06_JPRB, 0.10627774E-06_JPRB /)

RGHG7(:,61, 4) = (/ &
  & 0.72188392E-07_JPRB, 0.68417584E-07_JPRB, 0.67027294E-07_JPRB, 0.65998016E-07_JPRB, 0.65225727E-07_JPRB, 0.64723963E-07_JPRB, &
  & 0.64424739E-07_JPRB, 0.64229383E-07_JPRB, 0.64064601E-07_JPRB, 0.63907876E-07_JPRB, 0.63757781E-07_JPRB, 0.63606137E-07_JPRB, &
  & 0.63444425E-07_JPRB, 0.63275778E-07_JPRB, 0.63101140E-07_JPRB, 0.62959082E-07_JPRB, 0.62786185E-07_JPRB, 0.62416291E-07_JPRB, &
  & 0.61628036E-07_JPRB, 0.60177143E-07_JPRB, 0.57956143E-07_JPRB, 0.54848158E-07_JPRB, 0.51048122E-07_JPRB, 0.46997737E-07_JPRB, &
  & 0.43118476E-07_JPRB, 0.39744947E-07_JPRB, 0.37049620E-07_JPRB, 0.35097699E-07_JPRB, 0.33892015E-07_JPRB, 0.33439527E-07_JPRB, &
  & 0.33780839E-07_JPRB, 0.34931738E-07_JPRB, 0.36950805E-07_JPRB, 0.39985469E-07_JPRB, 0.44164793E-07_JPRB, 0.49552529E-07_JPRB, &
  & 0.55873745E-07_JPRB, 0.62507993E-07_JPRB, 0.68689886E-07_JPRB, 0.73761797E-07_JPRB, 0.77268176E-07_JPRB, 0.79173049E-07_JPRB, &
  & 0.79878639E-07_JPRB, 0.80096193E-07_JPRB, 0.80409883E-07_JPRB, 0.81267231E-07_JPRB, 0.82869185E-07_JPRB, 0.85066397E-07_JPRB, &
  & 0.87378012E-07_JPRB, 0.89306148E-07_JPRB, 0.90844665E-07_JPRB, 0.92069712E-07_JPRB, 0.93083059E-07_JPRB, 0.94019050E-07_JPRB, &
  & 0.94905197E-07_JPRB, 0.95851412E-07_JPRB, 0.96896535E-07_JPRB, 0.97959116E-07_JPRB, 0.98861392E-07_JPRB, 0.99581875E-07_JPRB, &
  & 0.10017725E-06_JPRB, 0.10073238E-06_JPRB, 0.10139937E-06_JPRB, 0.10295420E-06_JPRB /)

RGHG7(:,62, 4) = (/ &
  & 0.68684209E-07_JPRB, 0.65658575E-07_JPRB, 0.64442254E-07_JPRB, 0.63610429E-07_JPRB, 0.62982153E-07_JPRB, 0.62527690E-07_JPRB, &
  & 0.62221510E-07_JPRB, 0.62003778E-07_JPRB, 0.61814397E-07_JPRB, 0.61643384E-07_JPRB, 0.61451907E-07_JPRB, 0.61260693E-07_JPRB, &
  & 0.61038442E-07_JPRB, 0.60785197E-07_JPRB, 0.60541410E-07_JPRB, 0.60348761E-07_JPRB, 0.60170358E-07_JPRB, 0.59828430E-07_JPRB, &
  & 0.59083444E-07_JPRB, 0.57733057E-07_JPRB, 0.55618461E-07_JPRB, 0.52653618E-07_JPRB, 0.49061470E-07_JPRB, 0.45234330E-07_JPRB, &
  & 0.41586265E-07_JPRB, 0.38433164E-07_JPRB, 0.35935994E-07_JPRB, 0.34148922E-07_JPRB, 0.33071558E-07_JPRB, 0.32695937E-07_JPRB, &
  & 0.33054835E-07_JPRB, 0.34153647E-07_JPRB, 0.36024414E-07_JPRB, 0.38812495E-07_JPRB, 0.42689180E-07_JPRB, 0.47700922E-07_JPRB, &
  & 0.53621484E-07_JPRB, 0.59841057E-07_JPRB, 0.65662270E-07_JPRB, 0.70431568E-07_JPRB, 0.73759097E-07_JPRB, 0.75607538E-07_JPRB, &
  & 0.76360720E-07_JPRB, 0.76650053E-07_JPRB, 0.77030336E-07_JPRB, 0.77897226E-07_JPRB, 0.79423017E-07_JPRB, 0.81499742E-07_JPRB, &
  & 0.83727393E-07_JPRB, 0.85767937E-07_JPRB, 0.87447688E-07_JPRB, 0.88868006E-07_JPRB, 0.90089621E-07_JPRB, 0.91174236E-07_JPRB, &
  & 0.92214520E-07_JPRB, 0.93292137E-07_JPRB, 0.94426454E-07_JPRB, 0.95535775E-07_JPRB, 0.96443060E-07_JPRB, 0.97143783E-07_JPRB, &
  & 0.97732837E-07_JPRB, 0.98294628E-07_JPRB, 0.99053700E-07_JPRB, 0.10052413E-06_JPRB /)

RGHG7(:,63, 4) = (/ &
  & 0.65465464E-07_JPRB, 0.63081757E-07_JPRB, 0.62145723E-07_JPRB, 0.61501723E-07_JPRB, 0.60929310E-07_JPRB, 0.60497875E-07_JPRB, &
  & 0.60181307E-07_JPRB, 0.59934337E-07_JPRB, 0.59713663E-07_JPRB, 0.59498955E-07_JPRB, 0.59268249E-07_JPRB, 0.59017083E-07_JPRB, &
  & 0.58720168E-07_JPRB, 0.58390629E-07_JPRB, 0.58075909E-07_JPRB, 0.57852819E-07_JPRB, 0.57671592E-07_JPRB, 0.57342124E-07_JPRB, &
  & 0.56649732E-07_JPRB, 0.55375970E-07_JPRB, 0.53362811E-07_JPRB, 0.50562814E-07_JPRB, 0.47190081E-07_JPRB, 0.43597709E-07_JPRB, &
  & 0.40206370E-07_JPRB, 0.37297852E-07_JPRB, 0.35015784E-07_JPRB, 0.33411453E-07_JPRB, 0.32466698E-07_JPRB, 0.32169361E-07_JPRB, &
  & 0.32538043E-07_JPRB, 0.33567677E-07_JPRB, 0.35277615E-07_JPRB, 0.37794173E-07_JPRB, 0.41353527E-07_JPRB, 0.45976460E-07_JPRB, &
  & 0.51516977E-07_JPRB, 0.57306199E-07_JPRB, 0.62812454E-07_JPRB, 0.67292710E-07_JPRB, 0.70448685E-07_JPRB, 0.72256725E-07_JPRB, &
  & 0.73056000E-07_JPRB, 0.73438180E-07_JPRB, 0.73894242E-07_JPRB, 0.74778441E-07_JPRB, 0.76250537E-07_JPRB, 0.78216011E-07_JPRB, &
  & 0.80380921E-07_JPRB, 0.82412548E-07_JPRB, 0.84240099E-07_JPRB, 0.85806548E-07_JPRB, 0.87222205E-07_JPRB, 0.88484533E-07_JPRB, &
  & 0.89716664E-07_JPRB, 0.90941143E-07_JPRB, 0.92238693E-07_JPRB, 0.93379569E-07_JPRB, 0.94276245E-07_JPRB, 0.94959880E-07_JPRB, &
  & 0.95530183E-07_JPRB, 0.96083333E-07_JPRB, 0.96787915E-07_JPRB, 0.98324392E-07_JPRB /)

RGHG7(:,64, 4) = (/ &
  & 0.62975815E-07_JPRB, 0.60992797E-07_JPRB, 0.60169548E-07_JPRB, 0.59552484E-07_JPRB, 0.59047345E-07_JPRB, 0.58612102E-07_JPRB, &
  & 0.58268164E-07_JPRB, 0.57988711E-07_JPRB, 0.57728084E-07_JPRB, 0.57465577E-07_JPRB, 0.57185943E-07_JPRB, 0.56864028E-07_JPRB, &
  & 0.56487266E-07_JPRB, 0.56077557E-07_JPRB, 0.55730940E-07_JPRB, 0.55498418E-07_JPRB, 0.55315173E-07_JPRB, 0.54995599E-07_JPRB, &
  & 0.54340667E-07_JPRB, 0.53137608E-07_JPRB, 0.51235183E-07_JPRB, 0.48599599E-07_JPRB, 0.45455959E-07_JPRB, 0.42124736E-07_JPRB, &
  & 0.39011628E-07_JPRB, 0.36365591E-07_JPRB, 0.34317551E-07_JPRB, 0.32907945E-07_JPRB, 0.32102925E-07_JPRB, 0.31883435E-07_JPRB, &
  & 0.32258871E-07_JPRB, 0.33210306E-07_JPRB, 0.34746645E-07_JPRB, 0.36986780E-07_JPRB, 0.40199581E-07_JPRB, 0.44454350E-07_JPRB, &
  & 0.49588390E-07_JPRB, 0.54985964E-07_JPRB, 0.60149617E-07_JPRB, 0.64385851E-07_JPRB, 0.67370365E-07_JPRB, 0.69142544E-07_JPRB, &
  & 0.70004617E-07_JPRB, 0.70482756E-07_JPRB, 0.71022008E-07_JPRB, 0.71937315E-07_JPRB, 0.73372988E-07_JPRB, 0.75260168E-07_JPRB, &
  & 0.77352205E-07_JPRB, 0.79394290E-07_JPRB, 0.81234354E-07_JPRB, 0.82939017E-07_JPRB, 0.84463323E-07_JPRB, 0.85926551E-07_JPRB, &
  & 0.87286260E-07_JPRB, 0.88726281E-07_JPRB, 0.90146379E-07_JPRB, 0.91365301E-07_JPRB, 0.92275563E-07_JPRB, 0.92975746E-07_JPRB, &
  & 0.93554554E-07_JPRB, 0.94142806E-07_JPRB, 0.94919983E-07_JPRB, 0.96466067E-07_JPRB /)

RGHG7(:,65, 4) = (/ &
  & 0.60926553E-07_JPRB, 0.59109695E-07_JPRB, 0.58334070E-07_JPRB, 0.57783659E-07_JPRB, 0.57279451E-07_JPRB, 0.56846932E-07_JPRB, &
  & 0.56483699E-07_JPRB, 0.56156516E-07_JPRB, 0.55858777E-07_JPRB, 0.55531245E-07_JPRB, 0.55184913E-07_JPRB, 0.54774048E-07_JPRB, &
  & 0.54324463E-07_JPRB, 0.53880129E-07_JPRB, 0.53532958E-07_JPRB, 0.53306614E-07_JPRB, 0.53120409E-07_JPRB, 0.52807298E-07_JPRB, &
  & 0.52185456E-07_JPRB, 0.51048481E-07_JPRB, 0.49254314E-07_JPRB, 0.46805869E-07_JPRB, 0.43889234E-07_JPRB, 0.40845986E-07_JPRB, &
  & 0.38027594E-07_JPRB, 0.35662868E-07_JPRB, 0.33863842E-07_JPRB, 0.32650682E-07_JPRB, 0.31987721E-07_JPRB, 0.31846358E-07_JPRB, &
  & 0.32229288E-07_JPRB, 0.33102971E-07_JPRB, 0.34464581E-07_JPRB, 0.36434468E-07_JPRB, 0.39296655E-07_JPRB, 0.43175081E-07_JPRB, &
  & 0.47905964E-07_JPRB, 0.52915773E-07_JPRB, 0.57740198E-07_JPRB, 0.61732720E-07_JPRB, 0.64558932E-07_JPRB, 0.66299663E-07_JPRB, &
  & 0.67222807E-07_JPRB, 0.67807086E-07_JPRB, 0.68432932E-07_JPRB, 0.69384420E-07_JPRB, 0.70796432E-07_JPRB, 0.72624459E-07_JPRB, &
  & 0.74657386E-07_JPRB, 0.76671739E-07_JPRB, 0.78551366E-07_JPRB, 0.80269025E-07_JPRB, 0.81912624E-07_JPRB, 0.83432610E-07_JPRB, &
  & 0.84978907E-07_JPRB, 0.86537796E-07_JPRB, 0.88148553E-07_JPRB, 0.89418883E-07_JPRB, 0.90372104E-07_JPRB, 0.91079670E-07_JPRB, &
  & 0.91690183E-07_JPRB, 0.92302052E-07_JPRB, 0.93118643E-07_JPRB, 0.94839443E-07_JPRB /)

RGHG7(:,66, 4) = (/ &
  & 0.59192121E-07_JPRB, 0.57439177E-07_JPRB, 0.56669215E-07_JPRB, 0.56089377E-07_JPRB, 0.55599180E-07_JPRB, 0.55149304E-07_JPRB, &
  & 0.54762427E-07_JPRB, 0.54406858E-07_JPRB, 0.54036487E-07_JPRB, 0.53672185E-07_JPRB, 0.53229609E-07_JPRB, 0.52761049E-07_JPRB, &
  & 0.52272807E-07_JPRB, 0.51833847E-07_JPRB, 0.51508668E-07_JPRB, 0.51285994E-07_JPRB, 0.51098120E-07_JPRB, 0.50787580E-07_JPRB, &
  & 0.50195407E-07_JPRB, 0.49124377E-07_JPRB, 0.47453298E-07_JPRB, 0.45187573E-07_JPRB, 0.42531703E-07_JPRB, 0.39783611E-07_JPRB, &
  & 0.37276433E-07_JPRB, 0.35200323E-07_JPRB, 0.33650057E-07_JPRB, 0.32634318E-07_JPRB, 0.32109529E-07_JPRB, 0.32045754E-07_JPRB, &
  & 0.32438564E-07_JPRB, 0.33241047E-07_JPRB, 0.34438028E-07_JPRB, 0.36153605E-07_JPRB, 0.38677442E-07_JPRB, 0.42195204E-07_JPRB, &
  & 0.46513247E-07_JPRB, 0.51149442E-07_JPRB, 0.55618781E-07_JPRB, 0.59357575E-07_JPRB, 0.62035745E-07_JPRB, 0.63749155E-07_JPRB, &
  & 0.64733356E-07_JPRB, 0.65419307E-07_JPRB, 0.66136948E-07_JPRB, 0.67130244E-07_JPRB, 0.68523654E-07_JPRB, 0.70294639E-07_JPRB, &
  & 0.72276926E-07_JPRB, 0.74261223E-07_JPRB, 0.76127272E-07_JPRB, 0.77866439E-07_JPRB, 0.79522003E-07_JPRB, 0.81136271E-07_JPRB, &
  & 0.82724647E-07_JPRB, 0.84414033E-07_JPRB, 0.86161883E-07_JPRB, 0.87518849E-07_JPRB, 0.88504848E-07_JPRB, 0.89267616E-07_JPRB, &
  & 0.89896659E-07_JPRB, 0.90559723E-07_JPRB, 0.91465068E-07_JPRB, 0.93325440E-07_JPRB /)

RGHG7(:,67, 4) = (/ &
  & 0.57684847E-07_JPRB, 0.55880875E-07_JPRB, 0.55058219E-07_JPRB, 0.54464554E-07_JPRB, 0.53941541E-07_JPRB, 0.53489408E-07_JPRB, &
  & 0.53072373E-07_JPRB, 0.52685209E-07_JPRB, 0.52275002E-07_JPRB, 0.51816578E-07_JPRB, 0.51346422E-07_JPRB, 0.50831073E-07_JPRB, &
  & 0.50360242E-07_JPRB, 0.49949634E-07_JPRB, 0.49647372E-07_JPRB, 0.49433254E-07_JPRB, 0.49248559E-07_JPRB, 0.48947300E-07_JPRB, &
  & 0.48385317E-07_JPRB, 0.47383487E-07_JPRB, 0.45840817E-07_JPRB, 0.43780897E-07_JPRB, 0.41388034E-07_JPRB, 0.38955061E-07_JPRB, &
  & 0.36756820E-07_JPRB, 0.34975944E-07_JPRB, 0.33668080E-07_JPRB, 0.32839505E-07_JPRB, 0.32447279E-07_JPRB, 0.32458090E-07_JPRB, &
  & 0.32865088E-07_JPRB, 0.33608842E-07_JPRB, 0.34659369E-07_JPRB, 0.36147398E-07_JPRB, 0.38366569E-07_JPRB, 0.41520057E-07_JPRB, &
  & 0.45450328E-07_JPRB, 0.49707499E-07_JPRB, 0.53826408E-07_JPRB, 0.57295502E-07_JPRB, 0.59828068E-07_JPRB, 0.61510001E-07_JPRB, &
  & 0.62542988E-07_JPRB, 0.63338092E-07_JPRB, 0.64138888E-07_JPRB, 0.65168308E-07_JPRB, 0.66544345E-07_JPRB, 0.68265393E-07_JPRB, &
  & 0.70178494E-07_JPRB, 0.72124550E-07_JPRB, 0.73963221E-07_JPRB, 0.75695112E-07_JPRB, 0.77345838E-07_JPRB, 0.78969386E-07_JPRB, &
  & 0.80612033E-07_JPRB, 0.82361368E-07_JPRB, 0.84216026E-07_JPRB, 0.85622531E-07_JPRB, 0.86675648E-07_JPRB, 0.87456129E-07_JPRB, &
  & 0.88129426E-07_JPRB, 0.88812158E-07_JPRB, 0.89797815E-07_JPRB, 0.91816730E-07_JPRB /)

RGHG7(:,68, 4) = (/ &
  & 0.56310441E-07_JPRB, 0.54373889E-07_JPRB, 0.53488847E-07_JPRB, 0.52839642E-07_JPRB, 0.52296691E-07_JPRB, 0.51815043E-07_JPRB, &
  & 0.51395123E-07_JPRB, 0.50972506E-07_JPRB, 0.50511794E-07_JPRB, 0.50033115E-07_JPRB, 0.49524289E-07_JPRB, 0.49029126E-07_JPRB, &
  & 0.48592785E-07_JPRB, 0.48216808E-07_JPRB, 0.47945193E-07_JPRB, 0.47746244E-07_JPRB, 0.47567529E-07_JPRB, 0.47280306E-07_JPRB, &
  & 0.46754984E-07_JPRB, 0.45834305E-07_JPRB, 0.44434714E-07_JPRB, 0.42590152E-07_JPRB, 0.40479257E-07_JPRB, 0.38356507E-07_JPRB, &
  & 0.36471576E-07_JPRB, 0.34963964E-07_JPRB, 0.33888703E-07_JPRB, 0.33240280E-07_JPRB, 0.32975123E-07_JPRB, 0.33058679E-07_JPRB, &
  & 0.33483715E-07_JPRB, 0.34179305E-07_JPRB, 0.35102484E-07_JPRB, 0.36394106E-07_JPRB, 0.38339795E-07_JPRB, 0.41166743E-07_JPRB, &
  & 0.44713111E-07_JPRB, 0.48606864E-07_JPRB, 0.52376283E-07_JPRB, 0.55571252E-07_JPRB, 0.57948277E-07_JPRB, 0.59586860E-07_JPRB, &
  & 0.60671347E-07_JPRB, 0.61566595E-07_JPRB, 0.62430814E-07_JPRB, 0.63498533E-07_JPRB, 0.64855570E-07_JPRB, 0.66514595E-07_JPRB, &
  & 0.68365637E-07_JPRB, 0.70244973E-07_JPRB, 0.72041608E-07_JPRB, 0.73733240E-07_JPRB, 0.75369393E-07_JPRB, 0.76974722E-07_JPRB, &
  & 0.78612558E-07_JPRB, 0.80391800E-07_JPRB, 0.82311828E-07_JPRB, 0.83763076E-07_JPRB, 0.84836401E-07_JPRB, 0.85670308E-07_JPRB, &
  & 0.86339767E-07_JPRB, 0.87052037E-07_JPRB, 0.88114597E-07_JPRB, 0.90193339E-07_JPRB /)

RGHG7(:,69, 4) = (/ &
  & 0.54981349E-07_JPRB, 0.52893348E-07_JPRB, 0.51903474E-07_JPRB, 0.51205049E-07_JPRB, 0.50626088E-07_JPRB, 0.50139619E-07_JPRB, &
  & 0.49695345E-07_JPRB, 0.49271215E-07_JPRB, 0.48777249E-07_JPRB, 0.48276224E-07_JPRB, 0.47790106E-07_JPRB, 0.47326335E-07_JPRB, &
  & 0.46942088E-07_JPRB, 0.46609049E-07_JPRB, 0.46375149E-07_JPRB, 0.46208157E-07_JPRB, 0.46046534E-07_JPRB, 0.45790170E-07_JPRB, &
  & 0.45312166E-07_JPRB, 0.44482235E-07_JPRB, 0.43241933E-07_JPRB, 0.41622858E-07_JPRB, 0.39794582E-07_JPRB, 0.37980918E-07_JPRB, &
  & 0.36391729E-07_JPRB, 0.35156940E-07_JPRB, 0.34299788E-07_JPRB, 0.33820186E-07_JPRB, 0.33675562E-07_JPRB, 0.33830769E-07_JPRB, &
  & 0.34278337E-07_JPRB, 0.34939557E-07_JPRB, 0.35759886E-07_JPRB, 0.36877672E-07_JPRB, 0.38588684E-07_JPRB, 0.41097078E-07_JPRB, &
  & 0.44301238E-07_JPRB, 0.47836707E-07_JPRB, 0.51268039E-07_JPRB, 0.54193613E-07_JPRB, 0.56407934E-07_JPRB, 0.57994185E-07_JPRB, &
  & 0.59123689E-07_JPRB, 0.60095516E-07_JPRB, 0.61007228E-07_JPRB, 0.62110814E-07_JPRB, 0.63438286E-07_JPRB, 0.65036012E-07_JPRB, &
  & 0.66796360E-07_JPRB, 0.68608124E-07_JPRB, 0.70332348E-07_JPRB, 0.71979358E-07_JPRB, 0.73564443E-07_JPRB, 0.75138715E-07_JPRB, &
  & 0.76726330E-07_JPRB, 0.78513800E-07_JPRB, 0.80444352E-07_JPRB, 0.81903906E-07_JPRB, 0.83003201E-07_JPRB, 0.83830848E-07_JPRB, &
  & 0.84518518E-07_JPRB, 0.85207695E-07_JPRB, 0.86300780E-07_JPRB, 0.88480597E-07_JPRB /)

RGHG7(:,70, 4) = (/ &
  & 0.53707655E-07_JPRB, 0.51392458E-07_JPRB, 0.50287856E-07_JPRB, 0.49521148E-07_JPRB, 0.48923578E-07_JPRB, 0.48432767E-07_JPRB, &
  & 0.47995307E-07_JPRB, 0.47553247E-07_JPRB, 0.47063736E-07_JPRB, 0.46577114E-07_JPRB, 0.46135305E-07_JPRB, 0.45724256E-07_JPRB, &
  & 0.45400160E-07_JPRB, 0.45130658E-07_JPRB, 0.44937629E-07_JPRB, 0.44810655E-07_JPRB, 0.44682540E-07_JPRB, 0.44460990E-07_JPRB, &
  & 0.44047052E-07_JPRB, 0.43329369E-07_JPRB, 0.42255635E-07_JPRB, 0.40872965E-07_JPRB, 0.39325968E-07_JPRB, 0.37813582E-07_JPRB, &
  & 0.36509803E-07_JPRB, 0.35519406E-07_JPRB, 0.34870041E-07_JPRB, 0.34553189E-07_JPRB, 0.34526231E-07_JPRB, 0.34752166E-07_JPRB, &
  & 0.35225234E-07_JPRB, 0.35859205E-07_JPRB, 0.36595964E-07_JPRB, 0.37577710E-07_JPRB, 0.39077623E-07_JPRB, 0.41313779E-07_JPRB, &
  & 0.44188596E-07_JPRB, 0.47380709E-07_JPRB, 0.50489888E-07_JPRB, 0.53152036E-07_JPRB, 0.55202708E-07_JPRB, 0.56730482E-07_JPRB, &
  & 0.57896980E-07_JPRB, 0.58904927E-07_JPRB, 0.59875944E-07_JPRB, 0.60992157E-07_JPRB, 0.62286411E-07_JPRB, 0.63806283E-07_JPRB, &
  & 0.65483675E-07_JPRB, 0.67191941E-07_JPRB, 0.68832300E-07_JPRB, 0.70409939E-07_JPRB, 0.71915117E-07_JPRB, 0.73441512E-07_JPRB, &
  & 0.74960354E-07_JPRB, 0.76700744E-07_JPRB, 0.78614399E-07_JPRB, 0.80049730E-07_JPRB, 0.81129386E-07_JPRB, 0.81966846E-07_JPRB, &
  & 0.82613425E-07_JPRB, 0.83289017E-07_JPRB, 0.84390223E-07_JPRB, 0.86662233E-07_JPRB /)

RGHG7(:,71, 4) = (/ &
  & 0.52346650E-07_JPRB, 0.49879166E-07_JPRB, 0.48577970E-07_JPRB, 0.47784734E-07_JPRB, 0.47176453E-07_JPRB, 0.46696258E-07_JPRB, &
  & 0.46267992E-07_JPRB, 0.45849003E-07_JPRB, 0.45373483E-07_JPRB, 0.44926725E-07_JPRB, 0.44540688E-07_JPRB, 0.44203261E-07_JPRB, &
  & 0.43945356E-07_JPRB, 0.43753616E-07_JPRB, 0.43626422E-07_JPRB, 0.43548340E-07_JPRB, 0.43469647E-07_JPRB, 0.43303036E-07_JPRB, &
  & 0.42968701E-07_JPRB, 0.42367134E-07_JPRB, 0.41475722E-07_JPRB, 0.40327301E-07_JPRB, 0.39059174E-07_JPRB, 0.37828471E-07_JPRB, &
  & 0.36797513E-07_JPRB, 0.36053091E-07_JPRB, 0.35600571E-07_JPRB, 0.35434301E-07_JPRB, 0.35518209E-07_JPRB, 0.35813873E-07_JPRB, &
  & 0.36316340E-07_JPRB, 0.36938310E-07_JPRB, 0.37618289E-07_JPRB, 0.38480064E-07_JPRB, 0.39786723E-07_JPRB, 0.41781799E-07_JPRB, &
  & 0.44353122E-07_JPRB, 0.47221821E-07_JPRB, 0.50021043E-07_JPRB, 0.52431993E-07_JPRB, 0.54322427E-07_JPRB, 0.55789492E-07_JPRB, &
  & 0.56968563E-07_JPRB, 0.58010048E-07_JPRB, 0.59010798E-07_JPRB, 0.60132301E-07_JPRB, 0.61378046E-07_JPRB, 0.62823545E-07_JPRB, &
  & 0.64384459E-07_JPRB, 0.65989020E-07_JPRB, 0.67525050E-07_JPRB, 0.69015805E-07_JPRB, 0.70425905E-07_JPRB, 0.71871511E-07_JPRB, &
  & 0.73298736E-07_JPRB, 0.74966835E-07_JPRB, 0.76797583E-07_JPRB, 0.78191150E-07_JPRB, 0.79234560E-07_JPRB, 0.80029253E-07_JPRB, &
  & 0.80654175E-07_JPRB, 0.81259572E-07_JPRB, 0.82316902E-07_JPRB, 0.84615259E-07_JPRB /)

RGHG7(:,72, 4) = (/ &
  & 0.50925586E-07_JPRB, 0.48143129E-07_JPRB, 0.46797162E-07_JPRB, 0.45964249E-07_JPRB, 0.45387239E-07_JPRB, 0.44928562E-07_JPRB, &
  & 0.44530651E-07_JPRB, 0.44141775E-07_JPRB, 0.43710649E-07_JPRB, 0.43325556E-07_JPRB, 0.43012360E-07_JPRB, 0.42766711E-07_JPRB, &
  & 0.42593555E-07_JPRB, 0.42480664E-07_JPRB, 0.42432823E-07_JPRB, 0.42417277E-07_JPRB, 0.42401016E-07_JPRB, 0.42298606E-07_JPRB, &
  & 0.42053479E-07_JPRB, 0.41589352E-07_JPRB, 0.40880504E-07_JPRB, 0.39969962E-07_JPRB, 0.38966089E-07_JPRB, 0.38020083E-07_JPRB, &
  & 0.37244003E-07_JPRB, 0.36714667E-07_JPRB, 0.36448249E-07_JPRB, 0.36430091E-07_JPRB, 0.36622353E-07_JPRB, 0.36986560E-07_JPRB, &
  & 0.37519943E-07_JPRB, 0.38134665E-07_JPRB, 0.38771315E-07_JPRB, 0.39540076E-07_JPRB, 0.40708930E-07_JPRB, 0.42486427E-07_JPRB, &
  & 0.44776048E-07_JPRB, 0.47330595E-07_JPRB, 0.49839208E-07_JPRB, 0.52010378E-07_JPRB, 0.53745509E-07_JPRB, 0.55144717E-07_JPRB, &
  & 0.56334397E-07_JPRB, 0.57365387E-07_JPRB, 0.58402176E-07_JPRB, 0.59491590E-07_JPRB, 0.60701204E-07_JPRB, 0.62052131E-07_JPRB, &
  & 0.63505077E-07_JPRB, 0.64979368E-07_JPRB, 0.66404304E-07_JPRB, 0.67776242E-07_JPRB, 0.69092657E-07_JPRB, 0.70413456E-07_JPRB, &
  & 0.71758883E-07_JPRB, 0.73285008E-07_JPRB, 0.75028318E-07_JPRB, 0.76327687E-07_JPRB, 0.77317431E-07_JPRB, 0.78073285E-07_JPRB, &
  & 0.78637804E-07_JPRB, 0.79186151E-07_JPRB, 0.80149917E-07_JPRB, 0.82334395E-07_JPRB /)

RGHG7(:,73, 4) = (/ &
  & 0.49280388E-07_JPRB, 0.46307495E-07_JPRB, 0.44887013E-07_JPRB, 0.44116323E-07_JPRB, 0.43566583E-07_JPRB, 0.43154181E-07_JPRB, &
  & 0.42800060E-07_JPRB, 0.42460815E-07_JPRB, 0.42085347E-07_JPRB, 0.41785327E-07_JPRB, 0.41553278E-07_JPRB, 0.41394703E-07_JPRB, &
  & 0.41327858E-07_JPRB, 0.41309306E-07_JPRB, 0.41349544E-07_JPRB, 0.41413976E-07_JPRB, 0.41469232E-07_JPRB, 0.41451763E-07_JPRB, &
  & 0.41307892E-07_JPRB, 0.40981988E-07_JPRB, 0.40461128E-07_JPRB, 0.39776669E-07_JPRB, 0.39037069E-07_JPRB, 0.38346894E-07_JPRB, &
  & 0.37817163E-07_JPRB, 0.37513459E-07_JPRB, 0.37427014E-07_JPRB, 0.37547224E-07_JPRB, 0.37838646E-07_JPRB, 0.38270048E-07_JPRB, &
  & 0.38838614E-07_JPRB, 0.39460396E-07_JPRB, 0.40071189E-07_JPRB, 0.40765396E-07_JPRB, 0.41827807E-07_JPRB, 0.43381213E-07_JPRB, &
  & 0.45422006E-07_JPRB, 0.47683063E-07_JPRB, 0.49915567E-07_JPRB, 0.51859967E-07_JPRB, 0.53445024E-07_JPRB, 0.54783300E-07_JPRB, &
  & 0.55942625E-07_JPRB, 0.56968290E-07_JPRB, 0.57988334E-07_JPRB, 0.59064078E-07_JPRB, 0.60216081E-07_JPRB, 0.61465421E-07_JPRB, &
  & 0.62802549E-07_JPRB, 0.64143997E-07_JPRB, 0.65445178E-07_JPRB, 0.66703052E-07_JPRB, 0.67890248E-07_JPRB, 0.69108850E-07_JPRB, &
  & 0.70297602E-07_JPRB, 0.71725864E-07_JPRB, 0.73282081E-07_JPRB, 0.74508954E-07_JPRB, 0.75416551E-07_JPRB, 0.76112187E-07_JPRB, &
  & 0.76636532E-07_JPRB, 0.77111423E-07_JPRB, 0.77987352E-07_JPRB, 0.80052985E-07_JPRB /)

RGHG7(:,74, 4) = (/ &
  & 0.47365628E-07_JPRB, 0.44302503E-07_JPRB, 0.42965262E-07_JPRB, 0.42249191E-07_JPRB, 0.41773696E-07_JPRB, 0.41415060E-07_JPRB, &
  & 0.41120394E-07_JPRB, 0.40837040E-07_JPRB, 0.40551299E-07_JPRB, 0.40340542E-07_JPRB, 0.40199183E-07_JPRB, 0.40147579E-07_JPRB, &
  & 0.40168619E-07_JPRB, 0.40254967E-07_JPRB, 0.40381511E-07_JPRB, 0.40534356E-07_JPRB, 0.40668862E-07_JPRB, 0.40743291E-07_JPRB, &
  & 0.40704268E-07_JPRB, 0.40527510E-07_JPRB, 0.40186855E-07_JPRB, 0.39732630E-07_JPRB, 0.39237385E-07_JPRB, 0.38807244E-07_JPRB, &
  & 0.38500929E-07_JPRB, 0.38387739E-07_JPRB, 0.38463636E-07_JPRB, 0.38717854E-07_JPRB, 0.39109601E-07_JPRB, 0.39606022E-07_JPRB, &
  & 0.40207365E-07_JPRB, 0.40832099E-07_JPRB, 0.41423906E-07_JPRB, 0.42106262E-07_JPRB, 0.43090203E-07_JPRB, 0.44452044E-07_JPRB, &
  & 0.46262659E-07_JPRB, 0.48240430E-07_JPRB, 0.50215160E-07_JPRB, 0.51945243E-07_JPRB, 0.53390448E-07_JPRB, 0.54660067E-07_JPRB, &
  & 0.55770588E-07_JPRB, 0.56746146E-07_JPRB, 0.57771324E-07_JPRB, 0.58797578E-07_JPRB, 0.59877536E-07_JPRB, 0.61038811E-07_JPRB, &
  & 0.62248873E-07_JPRB, 0.63465563E-07_JPRB, 0.64634833E-07_JPRB, 0.65761860E-07_JPRB, 0.66838652E-07_JPRB, 0.67905425E-07_JPRB, &
  & 0.69000066E-07_JPRB, 0.70226534E-07_JPRB, 0.71653758E-07_JPRB, 0.72738715E-07_JPRB, 0.73572934E-07_JPRB, 0.74206170E-07_JPRB, &
  & 0.74674716E-07_JPRB, 0.75098640E-07_JPRB, 0.75873423E-07_JPRB, 0.77805716E-07_JPRB /)

RGHG7(:,75, 4) = (/ &
  & 0.45340197E-07_JPRB, 0.42305420E-07_JPRB, 0.41057067E-07_JPRB, 0.40445649E-07_JPRB, 0.40044068E-07_JPRB, 0.39760845E-07_JPRB, &
  & 0.39531514E-07_JPRB, 0.39324767E-07_JPRB, 0.39122600E-07_JPRB, 0.38990986E-07_JPRB, 0.38973305E-07_JPRB, 0.38994472E-07_JPRB, &
  & 0.39127045E-07_JPRB, 0.39304584E-07_JPRB, 0.39528924E-07_JPRB, 0.39766974E-07_JPRB, 0.39987206E-07_JPRB, 0.40162426E-07_JPRB, &
  & 0.40234589E-07_JPRB, 0.40201531E-07_JPRB, 0.40047329E-07_JPRB, 0.39807649E-07_JPRB, 0.39551683E-07_JPRB, 0.39345444E-07_JPRB, &
  & 0.39265995E-07_JPRB, 0.39357857E-07_JPRB, 0.39604984E-07_JPRB, 0.39982300E-07_JPRB, 0.40469128E-07_JPRB, 0.41027082E-07_JPRB, &
  & 0.41664681E-07_JPRB, 0.42302453E-07_JPRB, 0.42908599E-07_JPRB, 0.43589420E-07_JPRB, 0.44452676E-07_JPRB, 0.45666457E-07_JPRB, &
  & 0.47248477E-07_JPRB, 0.48969582E-07_JPRB, 0.50697967E-07_JPRB, 0.52224554E-07_JPRB, 0.53539885E-07_JPRB, 0.54735381E-07_JPRB, &
  & 0.55755912E-07_JPRB, 0.56709677E-07_JPRB, 0.57693622E-07_JPRB, 0.58658447E-07_JPRB, 0.59663343E-07_JPRB, 0.60727103E-07_JPRB, &
  & 0.61823947E-07_JPRB, 0.62900199E-07_JPRB, 0.63950878E-07_JPRB, 0.64947301E-07_JPRB, 0.65902242E-07_JPRB, 0.66845580E-07_JPRB, &
  & 0.67787923E-07_JPRB, 0.68876908E-07_JPRB, 0.70100121E-07_JPRB, 0.71067788E-07_JPRB, 0.71803548E-07_JPRB, 0.72367946E-07_JPRB, &
  & 0.72789902E-07_JPRB, 0.73154432E-07_JPRB, 0.73849733E-07_JPRB, 0.75648771E-07_JPRB /)

RGHG7(:,76, 4) = (/ &
  & 0.43261494E-07_JPRB, 0.40346567E-07_JPRB, 0.39216481E-07_JPRB, 0.38725680E-07_JPRB, 0.38419085E-07_JPRB, 0.38214022E-07_JPRB, &
  & 0.38060588E-07_JPRB, 0.37936516E-07_JPRB, 0.37833502E-07_JPRB, 0.37827988E-07_JPRB, 0.37856385E-07_JPRB, 0.38018900E-07_JPRB, &
  & 0.38212086E-07_JPRB, 0.38481076E-07_JPRB, 0.38781664E-07_JPRB, 0.39104453E-07_JPRB, 0.39406462E-07_JPRB, 0.39680717E-07_JPRB, &
  & 0.39868262E-07_JPRB, 0.39987327E-07_JPRB, 0.40008068E-07_JPRB, 0.39980495E-07_JPRB, 0.39946826E-07_JPRB, 0.39968864E-07_JPRB, &
  & 0.40089340E-07_JPRB, 0.40344396E-07_JPRB, 0.40723105E-07_JPRB, 0.41209457E-07_JPRB, 0.41780794E-07_JPRB, 0.42397797E-07_JPRB, &
  & 0.43065185E-07_JPRB, 0.43718774E-07_JPRB, 0.44360107E-07_JPRB, 0.45062340E-07_JPRB, 0.45865669E-07_JPRB, 0.46992877E-07_JPRB, &
  & 0.48341718E-07_JPRB, 0.49826586E-07_JPRB, 0.51317787E-07_JPRB, 0.52655295E-07_JPRB, 0.53844936E-07_JPRB, 0.54951837E-07_JPRB, &
  & 0.55881767E-07_JPRB, 0.56801113E-07_JPRB, 0.57732503E-07_JPRB, 0.58615527E-07_JPRB, 0.59543552E-07_JPRB, 0.60521785E-07_JPRB, &
  & 0.61482709E-07_JPRB, 0.62445984E-07_JPRB, 0.63358662E-07_JPRB, 0.64243778E-07_JPRB, 0.65065130E-07_JPRB, 0.65895193E-07_JPRB, &
  & 0.66701901E-07_JPRB, 0.67624356E-07_JPRB, 0.68658728E-07_JPRB, 0.69483477E-07_JPRB, 0.70118880E-07_JPRB, 0.70612408E-07_JPRB, &
  & 0.70982423E-07_JPRB, 0.71293165E-07_JPRB, 0.71914208E-07_JPRB, 0.73597079E-07_JPRB /)

RGHG7(:,77, 4) = (/ &
  & 0.41202398E-07_JPRB, 0.38434450E-07_JPRB, 0.37479033E-07_JPRB, 0.37119882E-07_JPRB, 0.36913082E-07_JPRB, 0.36798451E-07_JPRB, &
  & 0.36728832E-07_JPRB, 0.36697237E-07_JPRB, 0.36701689E-07_JPRB, 0.36752482E-07_JPRB, 0.36936736E-07_JPRB, 0.37118994E-07_JPRB, &
  & 0.37430997E-07_JPRB, 0.37764725E-07_JPRB, 0.38144396E-07_JPRB, 0.38538133E-07_JPRB, 0.38918085E-07_JPRB, 0.39289738E-07_JPRB, &
  & 0.39594354E-07_JPRB, 0.39853621E-07_JPRB, 0.40049333E-07_JPRB, 0.40214022E-07_JPRB, 0.40398273E-07_JPRB, 0.40612733E-07_JPRB, &
  & 0.40923872E-07_JPRB, 0.41377341E-07_JPRB, 0.41899916E-07_JPRB, 0.42501938E-07_JPRB, 0.43157211E-07_JPRB, 0.43833595E-07_JPRB, &
  & 0.44532889E-07_JPRB, 0.45214634E-07_JPRB, 0.45903153E-07_JPRB, 0.46588429E-07_JPRB, 0.47321951E-07_JPRB, 0.48354529E-07_JPRB, &
  & 0.49482885E-07_JPRB, 0.50760558E-07_JPRB, 0.52028650E-07_JPRB, 0.53181992E-07_JPRB, 0.54256859E-07_JPRB, 0.55257903E-07_JPRB, &
  & 0.56104707E-07_JPRB, 0.56990487E-07_JPRB, 0.57839870E-07_JPRB, 0.58643135E-07_JPRB, 0.59511549E-07_JPRB, 0.60375179E-07_JPRB, &
  & 0.61228150E-07_JPRB, 0.62063243E-07_JPRB, 0.62864800E-07_JPRB, 0.63617932E-07_JPRB, 0.64341442E-07_JPRB, 0.65035344E-07_JPRB, &
  & 0.65728074E-07_JPRB, 0.66483018E-07_JPRB, 0.67329211E-07_JPRB, 0.67999999E-07_JPRB, 0.68533652E-07_JPRB, 0.68951650E-07_JPRB, &
  & 0.69274250E-07_JPRB, 0.69528994E-07_JPRB, 0.70076069E-07_JPRB, 0.71653531E-07_JPRB /)

RGHG7(:,78, 4) = (/ &
  & 0.39148613E-07_JPRB, 0.36663483E-07_JPRB, 0.35904161E-07_JPRB, 0.35710841E-07_JPRB, 0.35607147E-07_JPRB, 0.35582893E-07_JPRB, &
  & 0.35609144E-07_JPRB, 0.35675495E-07_JPRB, 0.35782946E-07_JPRB, 0.35971834E-07_JPRB, 0.36161897E-07_JPRB, 0.36488956E-07_JPRB, &
  & 0.36815631E-07_JPRB, 0.37214718E-07_JPRB, 0.37635939E-07_JPRB, 0.38085698E-07_JPRB, 0.38528960E-07_JPRB, 0.38980531E-07_JPRB, &
  & 0.39390113E-07_JPRB, 0.39781156E-07_JPRB, 0.40128995E-07_JPRB, 0.40477790E-07_JPRB, 0.40839037E-07_JPRB, 0.41247823E-07_JPRB, &
  & 0.41689017E-07_JPRB, 0.42274628E-07_JPRB, 0.42853440E-07_JPRB, 0.43511800E-07_JPRB, 0.44208793E-07_JPRB, 0.44925834E-07_JPRB, &
  & 0.45657909E-07_JPRB, 0.46389012E-07_JPRB, 0.47135380E-07_JPRB, 0.47840146E-07_JPRB, 0.48637261E-07_JPRB, 0.49606129E-07_JPRB, &
  & 0.50560281E-07_JPRB, 0.51671957E-07_JPRB, 0.52733387E-07_JPRB, 0.53739559E-07_JPRB, 0.54690442E-07_JPRB, 0.55599415E-07_JPRB, &
  & 0.56368499E-07_JPRB, 0.57209085E-07_JPRB, 0.57969263E-07_JPRB, 0.58722698E-07_JPRB, 0.59514431E-07_JPRB, 0.60288677E-07_JPRB, &
  & 0.61037561E-07_JPRB, 0.61768965E-07_JPRB, 0.62458007E-07_JPRB, 0.63117682E-07_JPRB, 0.63728336E-07_JPRB, 0.64333875E-07_JPRB, &
  & 0.64905784E-07_JPRB, 0.65518933E-07_JPRB, 0.66173243E-07_JPRB, 0.66709198E-07_JPRB, 0.67140590E-07_JPRB, 0.67484542E-07_JPRB, &
  & 0.67769086E-07_JPRB, 0.67961984E-07_JPRB, 0.68404283E-07_JPRB, 0.69792613E-07_JPRB /)

RGHG7(:,79, 4) = (/ &
  & 0.37242536E-07_JPRB, 0.35283005E-07_JPRB, 0.34841403E-07_JPRB, 0.34823199E-07_JPRB, 0.34808341E-07_JPRB, 0.34877768E-07_JPRB, &
  & 0.34987210E-07_JPRB, 0.35148759E-07_JPRB, 0.35325858E-07_JPRB, 0.35533382E-07_JPRB, 0.35833164E-07_JPRB, 0.36114468E-07_JPRB, &
  & 0.36516575E-07_JPRB, 0.36928199E-07_JPRB, 0.37372974E-07_JPRB, 0.37840959E-07_JPRB, 0.38313722E-07_JPRB, 0.38805080E-07_JPRB, &
  & 0.39277786E-07_JPRB, 0.39743881E-07_JPRB, 0.40192621E-07_JPRB, 0.40651749E-07_JPRB, 0.41091667E-07_JPRB, 0.41611543E-07_JPRB, &
  & 0.42081851E-07_JPRB, 0.42734648E-07_JPRB, 0.43347235E-07_JPRB, 0.44030823E-07_JPRB, 0.44749516E-07_JPRB, 0.45489369E-07_JPRB, &
  & 0.46241972E-07_JPRB, 0.47008996E-07_JPRB, 0.47775714E-07_JPRB, 0.48493330E-07_JPRB, 0.49348284E-07_JPRB, 0.50232263E-07_JPRB, &
  & 0.51176190E-07_JPRB, 0.52205269E-07_JPRB, 0.53166534E-07_JPRB, 0.54088748E-07_JPRB, 0.54963202E-07_JPRB, 0.55809334E-07_JPRB, &
  & 0.56530858E-07_JPRB, 0.57339520E-07_JPRB, 0.58050066E-07_JPRB, 0.58764233E-07_JPRB, 0.59520922E-07_JPRB, 0.60242662E-07_JPRB, &
  & 0.60945183E-07_JPRB, 0.61622217E-07_JPRB, 0.62260938E-07_JPRB, 0.62864395E-07_JPRB, 0.63427692E-07_JPRB, 0.63967533E-07_JPRB, &
  & 0.64473646E-07_JPRB, 0.64997884E-07_JPRB, 0.65530770E-07_JPRB, 0.65970220E-07_JPRB, 0.66330870E-07_JPRB, 0.66614255E-07_JPRB, &
  & 0.66874634E-07_JPRB, 0.66997643E-07_JPRB, 0.67269994E-07_JPRB, 0.68286084E-07_JPRB /)

RGHG7(:,80, 4) = (/ &
  & 0.36030475E-07_JPRB, 0.34620399E-07_JPRB, 0.34424829E-07_JPRB, 0.34517999E-07_JPRB, 0.34517353E-07_JPRB, 0.34616132E-07_JPRB, &
  & 0.34753381E-07_JPRB, 0.34921118E-07_JPRB, 0.35132210E-07_JPRB, 0.35372750E-07_JPRB, 0.35627011E-07_JPRB, 0.36006881E-07_JPRB, &
  & 0.36378712E-07_JPRB, 0.36802177E-07_JPRB, 0.37253127E-07_JPRB, 0.37733990E-07_JPRB, 0.38220705E-07_JPRB, 0.38727134E-07_JPRB, &
  & 0.39223664E-07_JPRB, 0.39714653E-07_JPRB, 0.40208398E-07_JPRB, 0.40705043E-07_JPRB, 0.41166679E-07_JPRB, 0.41769880E-07_JPRB, &
  & 0.42262947E-07_JPRB, 0.42931536E-07_JPRB, 0.43571237E-07_JPRB, 0.44258218E-07_JPRB, 0.44988813E-07_JPRB, 0.45740464E-07_JPRB, &
  & 0.46506027E-07_JPRB, 0.47291692E-07_JPRB, 0.48048285E-07_JPRB, 0.48806648E-07_JPRB, 0.49692190E-07_JPRB, 0.50511975E-07_JPRB, &
  & 0.51473695E-07_JPRB, 0.52402537E-07_JPRB, 0.53322164E-07_JPRB, 0.54216681E-07_JPRB, 0.55036647E-07_JPRB, 0.55882559E-07_JPRB, &
  & 0.56574915E-07_JPRB, 0.57381047E-07_JPRB, 0.58076115E-07_JPRB, 0.58790896E-07_JPRB, 0.59523035E-07_JPRB, 0.60225865E-07_JPRB, &
  & 0.60903474E-07_JPRB, 0.61554438E-07_JPRB, 0.62169434E-07_JPRB, 0.62748526E-07_JPRB, 0.63290180E-07_JPRB, 0.63810191E-07_JPRB, &
  & 0.64300593E-07_JPRB, 0.64793284E-07_JPRB, 0.65291232E-07_JPRB, 0.65705215E-07_JPRB, 0.66049047E-07_JPRB, 0.66301759E-07_JPRB, &
  & 0.66571339E-07_JPRB, 0.66652909E-07_JPRB, 0.66798833E-07_JPRB, 0.67463844E-07_JPRB /)

RGHG7(:,81, 4) = (/ &
  & 0.35301287E-07_JPRB, 0.34200667E-07_JPRB, 0.34244099E-07_JPRB, 0.34365186E-07_JPRB, 0.34340150E-07_JPRB, 0.34469803E-07_JPRB, &
  & 0.34616601E-07_JPRB, 0.34833437E-07_JPRB, 0.35023081E-07_JPRB, 0.35290963E-07_JPRB, 0.35585796E-07_JPRB, 0.35889173E-07_JPRB, &
  & 0.36277122E-07_JPRB, 0.36744268E-07_JPRB, 0.37201161E-07_JPRB, 0.37680799E-07_JPRB, 0.38175308E-07_JPRB, 0.38687620E-07_JPRB, &
  & 0.39197797E-07_JPRB, 0.39705956E-07_JPRB, 0.40229523E-07_JPRB, 0.40725716E-07_JPRB, 0.41236785E-07_JPRB, 0.41815479E-07_JPRB, &
  & 0.42358774E-07_JPRB, 0.42987775E-07_JPRB, 0.43665782E-07_JPRB, 0.44358089E-07_JPRB, 0.45093117E-07_JPRB, 0.45852616E-07_JPRB, &
  & 0.46625420E-07_JPRB, 0.47416563E-07_JPRB, 0.48168154E-07_JPRB, 0.48980706E-07_JPRB, 0.49819306E-07_JPRB, 0.50625790E-07_JPRB, &
  & 0.51628419E-07_JPRB, 0.52497906E-07_JPRB, 0.53426383E-07_JPRB, 0.54301797E-07_JPRB, 0.55087867E-07_JPRB, 0.55935569E-07_JPRB, &
  & 0.56608201E-07_JPRB, 0.57406702E-07_JPRB, 0.58097797E-07_JPRB, 0.58801092E-07_JPRB, 0.59526876E-07_JPRB, 0.60216664E-07_JPRB, &
  & 0.60891935E-07_JPRB, 0.61530692E-07_JPRB, 0.62140863E-07_JPRB, 0.62709056E-07_JPRB, 0.63240869E-07_JPRB, 0.63748686E-07_JPRB, &
  & 0.64215008E-07_JPRB, 0.64693594E-07_JPRB, 0.65160030E-07_JPRB, 0.65547560E-07_JPRB, 0.65891953E-07_JPRB, 0.66105848E-07_JPRB, &
  & 0.66390207E-07_JPRB, 0.66476034E-07_JPRB, 0.66496554E-07_JPRB, 0.66876865E-07_JPRB /)

RGHG7(:,82, 4) = (/ &
  & 0.34898815E-07_JPRB, 0.33913164E-07_JPRB, 0.34255404E-07_JPRB, 0.34320657E-07_JPRB, 0.34269618E-07_JPRB, 0.34434137E-07_JPRB, &
  & 0.34590460E-07_JPRB, 0.34761850E-07_JPRB, 0.35025749E-07_JPRB, 0.35237623E-07_JPRB, 0.35543003E-07_JPRB, 0.35898267E-07_JPRB, &
  & 0.36341724E-07_JPRB, 0.36713942E-07_JPRB, 0.37172281E-07_JPRB, 0.37658104E-07_JPRB, 0.38153711E-07_JPRB, 0.38667803E-07_JPRB, &
  & 0.39178921E-07_JPRB, 0.39694910E-07_JPRB, 0.40221387E-07_JPRB, 0.40696833E-07_JPRB, 0.41282213E-07_JPRB, 0.41788290E-07_JPRB, &
  & 0.42424173E-07_JPRB, 0.43022037E-07_JPRB, 0.43704802E-07_JPRB, 0.44406075E-07_JPRB, 0.45144365E-07_JPRB, 0.45907310E-07_JPRB, &
  & 0.46685702E-07_JPRB, 0.47476483E-07_JPRB, 0.48238693E-07_JPRB, 0.49078999E-07_JPRB, 0.49855466E-07_JPRB, 0.50747595E-07_JPRB, &
  & 0.51693451E-07_JPRB, 0.52527700E-07_JPRB, 0.53461147E-07_JPRB, 0.54318217E-07_JPRB, 0.55081969E-07_JPRB, 0.55940170E-07_JPRB, &
  & 0.56606428E-07_JPRB, 0.57397443E-07_JPRB, 0.58104785E-07_JPRB, 0.58813598E-07_JPRB, 0.59525636E-07_JPRB, 0.60216976E-07_JPRB, &
  & 0.60887075E-07_JPRB, 0.61514257E-07_JPRB, 0.62124201E-07_JPRB, 0.62679050E-07_JPRB, 0.63214991E-07_JPRB, 0.63714722E-07_JPRB, &
  & 0.64191411E-07_JPRB, 0.64660313E-07_JPRB, 0.65137279E-07_JPRB, 0.65500458E-07_JPRB, 0.65875362E-07_JPRB, 0.66049495E-07_JPRB, &
  & 0.66341187E-07_JPRB, 0.66471287E-07_JPRB, 0.66386185E-07_JPRB, 0.66630527E-07_JPRB /)

RGHG7(:,83, 4) = (/ &
  & 0.35015855E-07_JPRB, 0.33660559E-07_JPRB, 0.34373617E-07_JPRB, 0.34233473E-07_JPRB, 0.34202703E-07_JPRB, 0.34409741E-07_JPRB, &
  & 0.34526288E-07_JPRB, 0.34778470E-07_JPRB, 0.34940413E-07_JPRB, 0.35268346E-07_JPRB, 0.35512770E-07_JPRB, 0.35856118E-07_JPRB, &
  & 0.36169695E-07_JPRB, 0.36666737E-07_JPRB, 0.37153281E-07_JPRB, 0.37635882E-07_JPRB, 0.38137738E-07_JPRB, 0.38649766E-07_JPRB, &
  & 0.39167826E-07_JPRB, 0.39688906E-07_JPRB, 0.40197634E-07_JPRB, 0.40717090E-07_JPRB, 0.41279986E-07_JPRB, 0.41805155E-07_JPRB, &
  & 0.42421902E-07_JPRB, 0.43040810E-07_JPRB, 0.43718043E-07_JPRB, 0.44429108E-07_JPRB, 0.45171067E-07_JPRB, 0.45938702E-07_JPRB, &
  & 0.46719748E-07_JPRB, 0.47512849E-07_JPRB, 0.48294318E-07_JPRB, 0.49129994E-07_JPRB, 0.49900716E-07_JPRB, 0.50845781E-07_JPRB, &
  & 0.51698539E-07_JPRB, 0.52585914E-07_JPRB, 0.53517034E-07_JPRB, 0.54321713E-07_JPRB, 0.55125042E-07_JPRB, 0.55926812E-07_JPRB, &
  & 0.56625876E-07_JPRB, 0.57387130E-07_JPRB, 0.58111397E-07_JPRB, 0.58823534E-07_JPRB, 0.59536685E-07_JPRB, 0.60216095E-07_JPRB, &
  & 0.60888652E-07_JPRB, 0.61511486E-07_JPRB, 0.62126361E-07_JPRB, 0.62669422E-07_JPRB, 0.63218337E-07_JPRB, 0.63692163E-07_JPRB, &
  & 0.64182331E-07_JPRB, 0.64614163E-07_JPRB, 0.65117277E-07_JPRB, 0.65425979E-07_JPRB, 0.65840595E-07_JPRB, 0.65993945E-07_JPRB, &
  & 0.66244439E-07_JPRB, 0.66488745E-07_JPRB, 0.66272605E-07_JPRB, 0.66725761E-07_JPRB /)

RGHG7(:,84, 4) = (/ &
  & 0.35147206E-07_JPRB, 0.33403836E-07_JPRB, 0.34568298E-07_JPRB, 0.34096715E-07_JPRB, 0.34207030E-07_JPRB, 0.34417397E-07_JPRB, &
  & 0.34530689E-07_JPRB, 0.34734814E-07_JPRB, 0.35028744E-07_JPRB, 0.35212839E-07_JPRB, 0.35536285E-07_JPRB, 0.35853649E-07_JPRB, &
  & 0.36321310E-07_JPRB, 0.36736989E-07_JPRB, 0.37125485E-07_JPRB, 0.37618808E-07_JPRB, 0.38122817E-07_JPRB, 0.38634738E-07_JPRB, &
  & 0.39153345E-07_JPRB, 0.39665078E-07_JPRB, 0.40175152E-07_JPRB, 0.40721968E-07_JPRB, 0.41241751E-07_JPRB, 0.41819312E-07_JPRB, &
  & 0.42411632E-07_JPRB, 0.43053433E-07_JPRB, 0.43725041E-07_JPRB, 0.44439517E-07_JPRB, 0.45186223E-07_JPRB, 0.45956579E-07_JPRB, &
  & 0.46741960E-07_JPRB, 0.47539245E-07_JPRB, 0.48335835E-07_JPRB, 0.49164186E-07_JPRB, 0.49961116E-07_JPRB, 0.50922253E-07_JPRB, &
  & 0.51722264E-07_JPRB, 0.52690623E-07_JPRB, 0.53518129E-07_JPRB, 0.54335825E-07_JPRB, 0.55142579E-07_JPRB, 0.55880655E-07_JPRB, &
  & 0.56628952E-07_JPRB, 0.57358701E-07_JPRB, 0.58096582E-07_JPRB, 0.58823389E-07_JPRB, 0.59540021E-07_JPRB, 0.60222703E-07_JPRB, &
  & 0.60889128E-07_JPRB, 0.61510107E-07_JPRB, 0.62121259E-07_JPRB, 0.62658223E-07_JPRB, 0.63217250E-07_JPRB, 0.63672474E-07_JPRB, &
  & 0.64198495E-07_JPRB, 0.64592776E-07_JPRB, 0.65143311E-07_JPRB, 0.65410426E-07_JPRB, 0.65832864E-07_JPRB, 0.66031809E-07_JPRB, &
  & 0.66154712E-07_JPRB, 0.66573918E-07_JPRB, 0.66172568E-07_JPRB, 0.66718513E-07_JPRB /)

RGHG7(:,85, 4) = (/ &
  & 0.35265462E-07_JPRB, 0.33186364E-07_JPRB, 0.34780491E-07_JPRB, 0.33897845E-07_JPRB, 0.34272936E-07_JPRB, 0.34399303E-07_JPRB, &
  & 0.34505383E-07_JPRB, 0.34806167E-07_JPRB, 0.34951469E-07_JPRB, 0.35299564E-07_JPRB, 0.35513150E-07_JPRB, 0.35863838E-07_JPRB, &
  & 0.36117296E-07_JPRB, 0.36536427E-07_JPRB, 0.37085062E-07_JPRB, 0.37583728E-07_JPRB, 0.38093692E-07_JPRB, 0.38611834E-07_JPRB, &
  & 0.39130089E-07_JPRB, 0.39640042E-07_JPRB, 0.40177721E-07_JPRB, 0.40696559E-07_JPRB, 0.41233374E-07_JPRB, 0.41807390E-07_JPRB, &
  & 0.42401929E-07_JPRB, 0.43041297E-07_JPRB, 0.43721737E-07_JPRB, 0.44440380E-07_JPRB, 0.45192976E-07_JPRB, 0.45968900E-07_JPRB, &
  & 0.46759045E-07_JPRB, 0.47562178E-07_JPRB, 0.48367408E-07_JPRB, 0.49198398E-07_JPRB, 0.50026188E-07_JPRB, 0.50973476E-07_JPRB, &
  & 0.51774148E-07_JPRB, 0.52789414E-07_JPRB, 0.53533174E-07_JPRB, 0.54419523E-07_JPRB, 0.55149389E-07_JPRB, 0.55905375E-07_JPRB, &
  & 0.56590004E-07_JPRB, 0.57389375E-07_JPRB, 0.58081767E-07_JPRB, 0.58822550E-07_JPRB, 0.59544334E-07_JPRB, 0.60224814E-07_JPRB, &
  & 0.60887565E-07_JPRB, 0.61518996E-07_JPRB, 0.62118204E-07_JPRB, 0.62671681E-07_JPRB, 0.63214976E-07_JPRB, 0.63680559E-07_JPRB, &
  & 0.64188626E-07_JPRB, 0.64591561E-07_JPRB, 0.65108082E-07_JPRB, 0.65430790E-07_JPRB, 0.65735968E-07_JPRB, 0.66117579E-07_JPRB, &
  & 0.66002684E-07_JPRB, 0.66668434E-07_JPRB, 0.66069106E-07_JPRB, 0.66760791E-07_JPRB /)

RGHG7(:,86, 4) = (/ &
  & 0.35384417E-07_JPRB, 0.33011990E-07_JPRB, 0.34980815E-07_JPRB, 0.33679189E-07_JPRB, 0.34415869E-07_JPRB, 0.34352563E-07_JPRB, &
  & 0.34529968E-07_JPRB, 0.34830535E-07_JPRB, 0.35057486E-07_JPRB, 0.35284252E-07_JPRB, 0.35570558E-07_JPRB, 0.35875587E-07_JPRB, &
  & 0.36331240E-07_JPRB, 0.36710873E-07_JPRB, 0.37073729E-07_JPRB, 0.37535933E-07_JPRB, 0.38049659E-07_JPRB, 0.38565712E-07_JPRB, &
  & 0.39098133E-07_JPRB, 0.39623867E-07_JPRB, 0.40147810E-07_JPRB, 0.40666563E-07_JPRB, 0.41222485E-07_JPRB, 0.41782638E-07_JPRB, &
  & 0.42387978E-07_JPRB, 0.43031797E-07_JPRB, 0.43714675E-07_JPRB, 0.44439719E-07_JPRB, 0.45196398E-07_JPRB, 0.45977160E-07_JPRB, &
  & 0.46769653E-07_JPRB, 0.47576016E-07_JPRB, 0.48391676E-07_JPRB, 0.49214997E-07_JPRB, 0.50076014E-07_JPRB, 0.50994782E-07_JPRB, &
  & 0.51857349E-07_JPRB, 0.52866639E-07_JPRB, 0.53552640E-07_JPRB, 0.54565191E-07_JPRB, 0.55099612E-07_JPRB, 0.56021051E-07_JPRB, &
  & 0.56555916E-07_JPRB, 0.57390562E-07_JPRB, 0.58113997E-07_JPRB, 0.58832363E-07_JPRB, 0.59550857E-07_JPRB, 0.60240019E-07_JPRB, &
  & 0.60886585E-07_JPRB, 0.61528461E-07_JPRB, 0.62107588E-07_JPRB, 0.62688294E-07_JPRB, 0.63190768E-07_JPRB, 0.63715639E-07_JPRB, &
  & 0.64151024E-07_JPRB, 0.64661478E-07_JPRB, 0.65038265E-07_JPRB, 0.65546665E-07_JPRB, 0.65608049E-07_JPRB, 0.66266452E-07_JPRB, &
  & 0.65868967E-07_JPRB, 0.66769296E-07_JPRB, 0.65983237E-07_JPRB, 0.66803445E-07_JPRB /)

RGHG7(:,87, 4) = (/ &
  & 0.35477520E-07_JPRB, 0.32901099E-07_JPRB, 0.35133482E-07_JPRB, 0.33466037E-07_JPRB, 0.34622182E-07_JPRB, 0.34207655E-07_JPRB, &
  & 0.34648075E-07_JPRB, 0.34861827E-07_JPRB, 0.35037537E-07_JPRB, 0.35375962E-07_JPRB, 0.35596056E-07_JPRB, 0.35887350E-07_JPRB, &
  & 0.36071317E-07_JPRB, 0.36471736E-07_JPRB, 0.36942911E-07_JPRB, 0.37503039E-07_JPRB, 0.37969443E-07_JPRB, 0.38531081E-07_JPRB, &
  & 0.39061792E-07_JPRB, 0.39590919E-07_JPRB, 0.40124188E-07_JPRB, 0.40657234E-07_JPRB, 0.41201243E-07_JPRB, 0.41768750E-07_JPRB, &
  & 0.42372434E-07_JPRB, 0.43019373E-07_JPRB, 0.43707757E-07_JPRB, 0.44433520E-07_JPRB, 0.45198913E-07_JPRB, 0.45984606E-07_JPRB, &
  & 0.46780194E-07_JPRB, 0.47591055E-07_JPRB, 0.48402367E-07_JPRB, 0.49231087E-07_JPRB, 0.50094762E-07_JPRB, 0.51013320E-07_JPRB, &
  & 0.51928989E-07_JPRB, 0.52880853E-07_JPRB, 0.53692375E-07_JPRB, 0.54582085E-07_JPRB, 0.55208361E-07_JPRB, 0.56070213E-07_JPRB, &
  & 0.56686158E-07_JPRB, 0.57407888E-07_JPRB, 0.58158079E-07_JPRB, 0.58872082E-07_JPRB, 0.59558520E-07_JPRB, 0.60245362E-07_JPRB, &
  & 0.60885704E-07_JPRB, 0.61535374E-07_JPRB, 0.62104675E-07_JPRB, 0.62704949E-07_JPRB, 0.63177197E-07_JPRB, 0.63751699E-07_JPRB, &
  & 0.64105713E-07_JPRB, 0.64727026E-07_JPRB, 0.64944771E-07_JPRB, 0.65644024E-07_JPRB, 0.65493282E-07_JPRB, 0.66349507E-07_JPRB, &
  & 0.65794509E-07_JPRB, 0.66803544E-07_JPRB, 0.65945152E-07_JPRB, 0.66830623E-07_JPRB /)

RGHG7(:,88, 4) = (/ &
  & 0.35535592E-07_JPRB, 0.32834766E-07_JPRB, 0.35204057E-07_JPRB, 0.33287570E-07_JPRB, 0.34823142E-07_JPRB, 0.33996120E-07_JPRB, &
  & 0.34819205E-07_JPRB, 0.34716159E-07_JPRB, 0.35176456E-07_JPRB, 0.35290302E-07_JPRB, 0.35602053E-07_JPRB, 0.35960827E-07_JPRB, &
  & 0.36359701E-07_JPRB, 0.36682895E-07_JPRB, 0.37019753E-07_JPRB, 0.37433214E-07_JPRB, 0.37916060E-07_JPRB, 0.38519154E-07_JPRB, &
  & 0.39000806E-07_JPRB, 0.39585323E-07_JPRB, 0.40090939E-07_JPRB, 0.40640970E-07_JPRB, 0.41176325E-07_JPRB, 0.41751271E-07_JPRB, &
  & 0.42354625E-07_JPRB, 0.43003741E-07_JPRB, 0.43698559E-07_JPRB, 0.44435694E-07_JPRB, 0.45195911E-07_JPRB, 0.45987377E-07_JPRB, &
  & 0.46785296E-07_JPRB, 0.47600096E-07_JPRB, 0.48417981E-07_JPRB, 0.49251799E-07_JPRB, 0.50122299E-07_JPRB, 0.51045333E-07_JPRB, &
  & 0.51997265E-07_JPRB, 0.52926662E-07_JPRB, 0.53816617E-07_JPRB, 0.54634551E-07_JPRB, 0.55397411E-07_JPRB, 0.56071837E-07_JPRB, &
  & 0.56834931E-07_JPRB, 0.57508515E-07_JPRB, 0.58209494E-07_JPRB, 0.58918381E-07_JPRB, 0.59583698E-07_JPRB, 0.60261080E-07_JPRB, &
  & 0.60892496E-07_JPRB, 0.61536753E-07_JPRB, 0.62108384E-07_JPRB, 0.62706775E-07_JPRB, 0.63179300E-07_JPRB, 0.63762592E-07_JPRB, &
  & 0.64101357E-07_JPRB, 0.64756698E-07_JPRB, 0.64932088E-07_JPRB, 0.65674321E-07_JPRB, 0.65485132E-07_JPRB, 0.66357366E-07_JPRB, &
  & 0.65805018E-07_JPRB, 0.66788523E-07_JPRB, 0.65959355E-07_JPRB, 0.66818473E-07_JPRB /)

RGHG7(:,89, 4) = (/ &
  & 0.35610736E-07_JPRB, 0.32805278E-07_JPRB, 0.35248107E-07_JPRB, 0.33329236E-07_JPRB, 0.34868375E-07_JPRB, 0.33962465E-07_JPRB, &
  & 0.34773219E-07_JPRB, 0.34729389E-07_JPRB, 0.35048586E-07_JPRB, 0.35322344E-07_JPRB, 0.35505256E-07_JPRB, 0.35605119E-07_JPRB, &
  & 0.36052842E-07_JPRB, 0.36267188E-07_JPRB, 0.36816125E-07_JPRB, 0.37583369E-07_JPRB, 0.38044220E-07_JPRB, 0.38505110E-07_JPRB, &
  & 0.38977316E-07_JPRB, 0.39565936E-07_JPRB, 0.40060797E-07_JPRB, 0.40618346E-07_JPRB, 0.41147342E-07_JPRB, 0.41724789E-07_JPRB, &
  & 0.42325706E-07_JPRB, 0.42984095E-07_JPRB, 0.43677630E-07_JPRB, 0.44406633E-07_JPRB, 0.45188376E-07_JPRB, 0.45988021E-07_JPRB, &
  & 0.46798579E-07_JPRB, 0.47623875E-07_JPRB, 0.48454286E-07_JPRB, 0.49289163E-07_JPRB, 0.50177348E-07_JPRB, 0.51126214E-07_JPRB, &
  & 0.52094769E-07_JPRB, 0.53048332E-07_JPRB, 0.53934389E-07_JPRB, 0.54752633E-07_JPRB, 0.55531480E-07_JPRB, 0.56248314E-07_JPRB, &
  & 0.56915521E-07_JPRB, 0.57626522E-07_JPRB, 0.58288709E-07_JPRB, 0.58959191E-07_JPRB, 0.59604496E-07_JPRB, 0.60268050E-07_JPRB, &
  & 0.60902146E-07_JPRB, 0.61539751E-07_JPRB, 0.62121742E-07_JPRB, 0.62708914E-07_JPRB, 0.63202251E-07_JPRB, 0.63759281E-07_JPRB, &
  & 0.64131072E-07_JPRB, 0.64739943E-07_JPRB, 0.64975758E-07_JPRB, 0.65633778E-07_JPRB, 0.65540576E-07_JPRB, 0.66303315E-07_JPRB, &
  & 0.65858842E-07_JPRB, 0.66740547E-07_JPRB, 0.65999281E-07_JPRB, 0.66789639E-07_JPRB /)

RGHG7(:,90, 4) = (/ &
  & 0.35715548E-07_JPRB, 0.32918638E-07_JPRB, 0.34916084E-07_JPRB, 0.33656733E-07_JPRB, 0.34335802E-07_JPRB, 0.34225291E-07_JPRB, &
  & 0.34418150E-07_JPRB, 0.34631682E-07_JPRB, 0.35336765E-07_JPRB, 0.35413187E-07_JPRB, 0.35400912E-07_JPRB, 0.35863149E-07_JPRB, &
  & 0.36720206E-07_JPRB, 0.36792795E-07_JPRB, 0.37161819E-07_JPRB, 0.37192372E-07_JPRB, 0.37484149E-07_JPRB, 0.38254864E-07_JPRB, &
  & 0.38876127E-07_JPRB, 0.39511065E-07_JPRB, 0.40032695E-07_JPRB, 0.40573589E-07_JPRB, 0.41107736E-07_JPRB, 0.41671541E-07_JPRB, &
  & 0.42259622E-07_JPRB, 0.42902712E-07_JPRB, 0.43602082E-07_JPRB, 0.44372424E-07_JPRB, 0.45164160E-07_JPRB, 0.45982134E-07_JPRB, &
  & 0.46806424E-07_JPRB, 0.47646711E-07_JPRB, 0.48498872E-07_JPRB, 0.49357840E-07_JPRB, 0.50288698E-07_JPRB, 0.51274260E-07_JPRB, &
  & 0.52266873E-07_JPRB, 0.53230366E-07_JPRB, 0.54125010E-07_JPRB, 0.54934976E-07_JPRB, 0.55686744E-07_JPRB, 0.56399383E-07_JPRB, &
  & 0.57074008E-07_JPRB, 0.57725099E-07_JPRB, 0.58364169E-07_JPRB, 0.59007370E-07_JPRB, 0.59644641E-07_JPRB, 0.60288812E-07_JPRB, &
  & 0.60918879E-07_JPRB, 0.61549287E-07_JPRB, 0.62141908E-07_JPRB, 0.62716843E-07_JPRB, 0.63233138E-07_JPRB, 0.63760105E-07_JPRB, &
  & 0.64180625E-07_JPRB, 0.64723523E-07_JPRB, 0.65057712E-07_JPRB, 0.65579520E-07_JPRB, 0.65643071E-07_JPRB, 0.66222739E-07_JPRB, &
  & 0.65962865E-07_JPRB, 0.66653044E-07_JPRB, 0.66091140E-07_JPRB, 0.66726408E-07_JPRB /)

RGHG7(:,91, 4) = (/ &
  & 0.35389469E-07_JPRB, 0.33691965E-07_JPRB, 0.34279086E-07_JPRB, 0.34149792E-07_JPRB, 0.34140335E-07_JPRB, 0.36470915E-07_JPRB, &
  & 0.27115936E-07_JPRB, 0.21952051E-07_JPRB, 0.46493476E-07_JPRB, 0.43867452E-07_JPRB, 0.32861440E-07_JPRB, 0.28968927E-07_JPRB, &
  & 0.39157570E-07_JPRB, 0.35168444E-07_JPRB, 0.37374999E-07_JPRB, 0.37300651E-07_JPRB, 0.38423696E-07_JPRB, 0.38689862E-07_JPRB, &
  & 0.39101607E-07_JPRB, 0.39484441E-07_JPRB, 0.39969862E-07_JPRB, 0.40490185E-07_JPRB, 0.41031079E-07_JPRB, 0.41606640E-07_JPRB, &
  & 0.42241386E-07_JPRB, 0.42902180E-07_JPRB, 0.43608985E-07_JPRB, 0.44346208E-07_JPRB, 0.45136197E-07_JPRB, 0.45973668E-07_JPRB, &
  & 0.46827235E-07_JPRB, 0.47692609E-07_JPRB, 0.48588483E-07_JPRB, 0.49469225E-07_JPRB, 0.50454098E-07_JPRB, 0.51499683E-07_JPRB, &
  & 0.52506536E-07_JPRB, 0.53491831E-07_JPRB, 0.54394079E-07_JPRB, 0.55209625E-07_JPRB, 0.55949968E-07_JPRB, 0.56618912E-07_JPRB, &
  & 0.57247313E-07_JPRB, 0.57872242E-07_JPRB, 0.58465790E-07_JPRB, 0.59060159E-07_JPRB, 0.59693605E-07_JPRB, 0.60321938E-07_JPRB, &
  & 0.60941396E-07_JPRB, 0.61575193E-07_JPRB, 0.62173960E-07_JPRB, 0.62744391E-07_JPRB, 0.63274719E-07_JPRB, 0.63785492E-07_JPRB, &
  & 0.64234264E-07_JPRB, 0.64736732E-07_JPRB, 0.65143688E-07_JPRB, 0.65542892E-07_JPRB, 0.65764816E-07_JPRB, 0.66120563E-07_JPRB, &
  & 0.66129147E-07_JPRB, 0.66491992E-07_JPRB, 0.66289736E-07_JPRB, 0.66559075E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG7(:, 1, 5) = (/ &
  & 0.59920089E-05_JPRB, 0.59911886E-05_JPRB, 0.59801350E-05_JPRB, 0.59583977E-05_JPRB, 0.59294211E-05_JPRB, 0.58961859E-05_JPRB, &
  & 0.58495680E-05_JPRB, 0.58114051E-05_JPRB, 0.65498966E-07_JPRB, 0.64308509E-07_JPRB, 0.63991195E-07_JPRB, 0.63986761E-07_JPRB, &
  & 0.64211569E-07_JPRB, 0.64672001E-07_JPRB, 0.65272459E-07_JPRB, 0.65923437E-07_JPRB, 0.66636616E-07_JPRB, 0.67310005E-07_JPRB, &
  & 0.67893552E-07_JPRB, 0.68359896E-07_JPRB, 0.68764159E-07_JPRB, 0.69087719E-07_JPRB, 0.69320159E-07_JPRB, 0.69444589E-07_JPRB, &
  & 0.69445782E-07_JPRB, 0.69271039E-07_JPRB, 0.69096970E-07_JPRB, 0.68867884E-07_JPRB, 0.68601395E-07_JPRB, 0.68322763E-07_JPRB, &
  & 0.68095133E-07_JPRB, 0.67985724E-07_JPRB, 0.68105336E-07_JPRB, 0.68388950E-07_JPRB, 0.68803395E-07_JPRB, 0.69306452E-07_JPRB, &
  & 0.69781997E-07_JPRB, 0.70245363E-07_JPRB, 0.70431774E-07_JPRB, 0.70576348E-07_JPRB, 0.70802109E-07_JPRB, 0.70731915E-07_JPRB, &
  & 0.70850348E-07_JPRB, 0.70620935E-07_JPRB, 0.70498167E-07_JPRB, 0.70317235E-07_JPRB, 0.70147763E-07_JPRB, 0.69977439E-07_JPRB, &
  & 0.69702693E-07_JPRB, 0.69546985E-07_JPRB, 0.69421993E-07_JPRB, 0.69280631E-07_JPRB, 0.69251364E-07_JPRB, 0.69163754E-07_JPRB, &
  & 0.69069706E-07_JPRB, 0.69025432E-07_JPRB, 0.69536419E-07_JPRB, 0.70121935E-07_JPRB, 0.71068449E-07_JPRB, 0.72718215E-07_JPRB, &
  & 0.74885889E-07_JPRB, 0.78134015E-07_JPRB, 0.81889795E-07_JPRB, 0.86810708E-07_JPRB /)

RGHG7(:, 2, 5) = (/ &
  & 0.60625366E-05_JPRB, 0.61151272E-05_JPRB, 0.61733072E-05_JPRB, 0.62531744E-05_JPRB, 0.62821691E-05_JPRB, 0.62524896E-05_JPRB, &
  & 0.58063792E-05_JPRB, 0.55130286E-05_JPRB, 0.17152132E-06_JPRB, 0.17144002E-06_JPRB, 0.17826900E-06_JPRB, 0.18242103E-06_JPRB, &
  & 0.18491421E-06_JPRB, 0.19008057E-06_JPRB, 0.19398566E-06_JPRB, 0.19443574E-06_JPRB, 0.19780200E-06_JPRB, 0.20095653E-06_JPRB, &
  & 0.20269135E-06_JPRB, 0.20150827E-06_JPRB, 0.20400783E-06_JPRB, 0.20758871E-06_JPRB, 0.21186744E-06_JPRB, 0.21649429E-06_JPRB, &
  & 0.21921127E-06_JPRB, 0.21599104E-06_JPRB, 0.21714743E-06_JPRB, 0.21778904E-06_JPRB, 0.21750412E-06_JPRB, 0.21621560E-06_JPRB, &
  & 0.21237315E-06_JPRB, 0.20346555E-06_JPRB, 0.20087047E-06_JPRB, 0.20010164E-06_JPRB, 0.20073742E-06_JPRB, 0.20266009E-06_JPRB, &
  & 0.20517913E-06_JPRB, 0.20868190E-06_JPRB, 0.20721357E-06_JPRB, 0.20811714E-06_JPRB, 0.21163430E-06_JPRB, 0.21453971E-06_JPRB, &
  & 0.21913517E-06_JPRB, 0.22075177E-06_JPRB, 0.22300426E-06_JPRB, 0.22777603E-06_JPRB, 0.23430420E-06_JPRB, 0.24176910E-06_JPRB, &
  & 0.24460093E-06_JPRB, 0.25422182E-06_JPRB, 0.26503213E-06_JPRB, 0.27042674E-06_JPRB, 0.28217454E-06_JPRB, 0.28813969E-06_JPRB, &
  & 0.29525938E-06_JPRB, 0.31621303E-06_JPRB, 0.37850486E-06_JPRB, 0.45700216E-06_JPRB, 0.53799135E-06_JPRB, 0.64927008E-06_JPRB, &
  & 0.75322140E-06_JPRB, 0.89350118E-06_JPRB, 0.10164993E-05_JPRB, 0.11134151E-05_JPRB /)

RGHG7(:, 3, 5) = (/ &
  & 0.59638969E-05_JPRB, 0.56955150E-05_JPRB, 0.53877125E-05_JPRB, 0.49962437E-05_JPRB, 0.44002390E-05_JPRB, 0.35839287E-05_JPRB, &
  & 0.25731715E-05_JPRB, 0.21717315E-05_JPRB, 0.20171792E-06_JPRB, 0.21448847E-06_JPRB, 0.24104236E-06_JPRB, 0.26678524E-06_JPRB, &
  & 0.28891952E-06_JPRB, 0.31171379E-06_JPRB, 0.33009542E-06_JPRB, 0.33769388E-06_JPRB, 0.34809992E-06_JPRB, 0.35907502E-06_JPRB, &
  & 0.36807316E-06_JPRB, 0.36945843E-06_JPRB, 0.37542716E-06_JPRB, 0.38338106E-06_JPRB, 0.39205247E-06_JPRB, 0.40060243E-06_JPRB, &
  & 0.40726346E-06_JPRB, 0.40274790E-06_JPRB, 0.40277260E-06_JPRB, 0.40409674E-06_JPRB, 0.40546644E-06_JPRB, 0.40563853E-06_JPRB, &
  & 0.40570632E-06_JPRB, 0.39609571E-06_JPRB, 0.39199637E-06_JPRB, 0.39310154E-06_JPRB, 0.39597708E-06_JPRB, 0.40127867E-06_JPRB, &
  & 0.40483511E-06_JPRB, 0.41161721E-06_JPRB, 0.40893764E-06_JPRB, 0.40853263E-06_JPRB, 0.41427830E-06_JPRB, 0.42024445E-06_JPRB, &
  & 0.42953391E-06_JPRB, 0.43238018E-06_JPRB, 0.43498989E-06_JPRB, 0.44371754E-06_JPRB, 0.45660485E-06_JPRB, 0.46947281E-06_JPRB, &
  & 0.47645733E-06_JPRB, 0.49326161E-06_JPRB, 0.51185344E-06_JPRB, 0.52133487E-06_JPRB, 0.54033035E-06_JPRB, 0.55052749E-06_JPRB, &
  & 0.56918907E-06_JPRB, 0.62112645E-06_JPRB, 0.75313005E-06_JPRB, 0.89619834E-06_JPRB, 0.10023879E-05_JPRB, 0.11661197E-05_JPRB, &
  & 0.13207604E-05_JPRB, 0.15655625E-05_JPRB, 0.18630290E-05_JPRB, 0.24500278E-05_JPRB /)

RGHG7(:, 4, 5) = (/ &
  & 0.55274695E-05_JPRB, 0.47792391E-05_JPRB, 0.42205302E-05_JPRB, 0.36658100E-05_JPRB, 0.30884216E-05_JPRB, 0.26055041E-05_JPRB, &
  & 0.20726807E-05_JPRB, 0.19001230E-05_JPRB, 0.46439942E-06_JPRB, 0.44231558E-06_JPRB, 0.44633603E-06_JPRB, 0.44846053E-06_JPRB, &
  & 0.45071198E-06_JPRB, 0.47145838E-06_JPRB, 0.50518685E-06_JPRB, 0.52679388E-06_JPRB, 0.54910021E-06_JPRB, 0.57168177E-06_JPRB, &
  & 0.59388282E-06_JPRB, 0.60342342E-06_JPRB, 0.61771550E-06_JPRB, 0.63614198E-06_JPRB, 0.65628853E-06_JPRB, 0.67391886E-06_JPRB, &
  & 0.69045649E-06_JPRB, 0.68844787E-06_JPRB, 0.69101583E-06_JPRB, 0.69680527E-06_JPRB, 0.70534912E-06_JPRB, 0.71040409E-06_JPRB, &
  & 0.71958181E-06_JPRB, 0.71398671E-06_JPRB, 0.71171394E-06_JPRB, 0.71986761E-06_JPRB, 0.72680507E-06_JPRB, 0.73717473E-06_JPRB, &
  & 0.74267433E-06_JPRB, 0.75470246E-06_JPRB, 0.75123023E-06_JPRB, 0.74775721E-06_JPRB, 0.75436805E-06_JPRB, 0.75961134E-06_JPRB, &
  & 0.77147678E-06_JPRB, 0.76918133E-06_JPRB, 0.76461174E-06_JPRB, 0.77115948E-06_JPRB, 0.78360438E-06_JPRB, 0.79022249E-06_JPRB, &
  & 0.78496623E-06_JPRB, 0.79416412E-06_JPRB, 0.80368852E-06_JPRB, 0.80002775E-06_JPRB, 0.80709395E-06_JPRB, 0.80303710E-06_JPRB, &
  & 0.79527109E-06_JPRB, 0.80303624E-06_JPRB, 0.84208779E-06_JPRB, 0.92403388E-06_JPRB, 0.99777697E-06_JPRB, 0.11103168E-05_JPRB, &
  & 0.11981030E-05_JPRB, 0.13532801E-05_JPRB, 0.14008143E-05_JPRB, 0.14051303E-05_JPRB /)

RGHG7(:, 5, 5) = (/ &
  & 0.49867813E-05_JPRB, 0.41079611E-05_JPRB, 0.35540522E-05_JPRB, 0.30854053E-05_JPRB, 0.25757067E-05_JPRB, 0.21163676E-05_JPRB, &
  & 0.15077197E-05_JPRB, 0.12508571E-05_JPRB, 0.68496939E-06_JPRB, 0.67360224E-06_JPRB, 0.70224462E-06_JPRB, 0.72756995E-06_JPRB, &
  & 0.72950621E-06_JPRB, 0.73067076E-06_JPRB, 0.75033103E-06_JPRB, 0.76485117E-06_JPRB, 0.79266772E-06_JPRB, 0.82783555E-06_JPRB, &
  & 0.86489922E-06_JPRB, 0.88399236E-06_JPRB, 0.90557495E-06_JPRB, 0.93044360E-06_JPRB, 0.95850180E-06_JPRB, 0.98317776E-06_JPRB, &
  & 0.10099614E-05_JPRB, 0.10099558E-05_JPRB, 0.10142685E-05_JPRB, 0.10229776E-05_JPRB, 0.10405934E-05_JPRB, 0.10548899E-05_JPRB, &
  & 0.10836396E-05_JPRB, 0.10895552E-05_JPRB, 0.10900540E-05_JPRB, 0.11026452E-05_JPRB, 0.11121086E-05_JPRB, 0.11288416E-05_JPRB, &
  & 0.11354985E-05_JPRB, 0.11483163E-05_JPRB, 0.11382948E-05_JPRB, 0.11268395E-05_JPRB, 0.11310602E-05_JPRB, 0.11326775E-05_JPRB, &
  & 0.11447638E-05_JPRB, 0.11334023E-05_JPRB, 0.11162341E-05_JPRB, 0.11149093E-05_JPRB, 0.11201024E-05_JPRB, 0.11137161E-05_JPRB, &
  & 0.10954126E-05_JPRB, 0.10939261E-05_JPRB, 0.10921432E-05_JPRB, 0.10732249E-05_JPRB, 0.10632109E-05_JPRB, 0.10364964E-05_JPRB, &
  & 0.10055453E-05_JPRB, 0.98055125E-06_JPRB, 0.96401357E-06_JPRB, 0.10053872E-05_JPRB, 0.10697688E-05_JPRB, 0.11801583E-05_JPRB, &
  & 0.12784967E-05_JPRB, 0.14738719E-05_JPRB, 0.16475328E-05_JPRB, 0.22930169E-05_JPRB /)

RGHG7(:, 6, 5) = (/ &
  & 0.44078256E-05_JPRB, 0.33708679E-05_JPRB, 0.28286004E-05_JPRB, 0.24107151E-05_JPRB, 0.20104787E-05_JPRB, 0.17156325E-05_JPRB, &
  & 0.14449092E-05_JPRB, 0.13761746E-05_JPRB, 0.11797540E-05_JPRB, 0.11276427E-05_JPRB, 0.11128174E-05_JPRB, 0.11158006E-05_JPRB, &
  & 0.11136441E-05_JPRB, 0.11173631E-05_JPRB, 0.11399331E-05_JPRB, 0.11441367E-05_JPRB, 0.11509168E-05_JPRB, 0.11700112E-05_JPRB, &
  & 0.12014166E-05_JPRB, 0.12216120E-05_JPRB, 0.12435859E-05_JPRB, 0.12736032E-05_JPRB, 0.13104875E-05_JPRB, 0.13389712E-05_JPRB, &
  & 0.13783294E-05_JPRB, 0.13862721E-05_JPRB, 0.13979057E-05_JPRB, 0.14166262E-05_JPRB, 0.14485282E-05_JPRB, 0.14658488E-05_JPRB, &
  & 0.14898942E-05_JPRB, 0.14868682E-05_JPRB, 0.14862937E-05_JPRB, 0.15073175E-05_JPRB, 0.15233448E-05_JPRB, 0.15441674E-05_JPRB, &
  & 0.15512037E-05_JPRB, 0.15693245E-05_JPRB, 0.15620991E-05_JPRB, 0.15522164E-05_JPRB, 0.15587494E-05_JPRB, 0.15573526E-05_JPRB, &
  & 0.15651433E-05_JPRB, 0.15429266E-05_JPRB, 0.15129135E-05_JPRB, 0.14998506E-05_JPRB, 0.14913554E-05_JPRB, 0.14691727E-05_JPRB, &
  & 0.14357067E-05_JPRB, 0.14183611E-05_JPRB, 0.13996544E-05_JPRB, 0.13644725E-05_JPRB, 0.13449322E-05_JPRB, 0.13155955E-05_JPRB, &
  & 0.12819712E-05_JPRB, 0.12397186E-05_JPRB, 0.11779533E-05_JPRB, 0.11623555E-05_JPRB, 0.11855597E-05_JPRB, 0.12193834E-05_JPRB, &
  & 0.12548152E-05_JPRB, 0.13123159E-05_JPRB, 0.13535988E-05_JPRB, 0.13354708E-05_JPRB /)

RGHG7(:, 7, 5) = (/ &
  & 0.36505369E-05_JPRB, 0.26560936E-05_JPRB, 0.22325146E-05_JPRB, 0.19277759E-05_JPRB, 0.17417525E-05_JPRB, 0.16301539E-05_JPRB, &
  & 0.15745396E-05_JPRB, 0.16309139E-05_JPRB, 0.17399873E-05_JPRB, 0.17527935E-05_JPRB, 0.17389090E-05_JPRB, 0.17294476E-05_JPRB, &
  & 0.16955310E-05_JPRB, 0.16679986E-05_JPRB, 0.16686536E-05_JPRB, 0.16682312E-05_JPRB, 0.16703999E-05_JPRB, 0.16828873E-05_JPRB, &
  & 0.17061648E-05_JPRB, 0.17191009E-05_JPRB, 0.17300891E-05_JPRB, 0.17583510E-05_JPRB, 0.17899386E-05_JPRB, 0.18195757E-05_JPRB, &
  & 0.18651754E-05_JPRB, 0.18776760E-05_JPRB, 0.18917466E-05_JPRB, 0.19120978E-05_JPRB, 0.19415643E-05_JPRB, 0.19598353E-05_JPRB, &
  & 0.19996803E-05_JPRB, 0.20093053E-05_JPRB, 0.20046607E-05_JPRB, 0.20145735E-05_JPRB, 0.20237333E-05_JPRB, 0.20446912E-05_JPRB, &
  & 0.20527489E-05_JPRB, 0.20736925E-05_JPRB, 0.20636119E-05_JPRB, 0.20467451E-05_JPRB, 0.20476944E-05_JPRB, 0.20431398E-05_JPRB, &
  & 0.20462417E-05_JPRB, 0.20162795E-05_JPRB, 0.19741751E-05_JPRB, 0.19496249E-05_JPRB, 0.19316669E-05_JPRB, 0.19020005E-05_JPRB, &
  & 0.18589168E-05_JPRB, 0.18319374E-05_JPRB, 0.18039723E-05_JPRB, 0.17585231E-05_JPRB, 0.17206908E-05_JPRB, 0.16648906E-05_JPRB, &
  & 0.16094497E-05_JPRB, 0.15625822E-05_JPRB, 0.15177724E-05_JPRB, 0.15216983E-05_JPRB, 0.15355965E-05_JPRB, 0.15767962E-05_JPRB, &
  & 0.16341670E-05_JPRB, 0.16939774E-05_JPRB, 0.17987171E-05_JPRB, 0.19943425E-05_JPRB /)

RGHG7(:, 8, 5) = (/ &
  & 0.28602869E-05_JPRB, 0.21647188E-05_JPRB, 0.19282061E-05_JPRB, 0.18275560E-05_JPRB, 0.18033595E-05_JPRB, 0.18259210E-05_JPRB, &
  & 0.19128640E-05_JPRB, 0.20798775E-05_JPRB, 0.23087991E-05_JPRB, 0.24578237E-05_JPRB, 0.24931767E-05_JPRB, 0.24784022E-05_JPRB, &
  & 0.24280332E-05_JPRB, 0.23779673E-05_JPRB, 0.23478601E-05_JPRB, 0.23168416E-05_JPRB, 0.22835350E-05_JPRB, 0.22679512E-05_JPRB, &
  & 0.22669451E-05_JPRB, 0.22620393E-05_JPRB, 0.22562049E-05_JPRB, 0.22682664E-05_JPRB, 0.22882166E-05_JPRB, 0.23177374E-05_JPRB, &
  & 0.23522587E-05_JPRB, 0.23681716E-05_JPRB, 0.23819362E-05_JPRB, 0.24043700E-05_JPRB, 0.24425506E-05_JPRB, 0.24668050E-05_JPRB, &
  & 0.24920412E-05_JPRB, 0.24827457E-05_JPRB, 0.24675396E-05_JPRB, 0.24757896E-05_JPRB, 0.24879655E-05_JPRB, 0.25075590E-05_JPRB, &
  & 0.25125994E-05_JPRB, 0.25314646E-05_JPRB, 0.25203176E-05_JPRB, 0.25007937E-05_JPRB, 0.24980541E-05_JPRB, 0.24906617E-05_JPRB, &
  & 0.24837225E-05_JPRB, 0.24481271E-05_JPRB, 0.24014309E-05_JPRB, 0.23730745E-05_JPRB, 0.23485040E-05_JPRB, 0.23076523E-05_JPRB, &
  & 0.22492152E-05_JPRB, 0.22071704E-05_JPRB, 0.21656567E-05_JPRB, 0.21134022E-05_JPRB, 0.20765028E-05_JPRB, 0.20315520E-05_JPRB, &
  & 0.19798397E-05_JPRB, 0.19189056E-05_JPRB, 0.18468968E-05_JPRB, 0.18189771E-05_JPRB, 0.18253069E-05_JPRB, 0.18361787E-05_JPRB, &
  & 0.18600224E-05_JPRB, 0.19065720E-05_JPRB, 0.19625434E-05_JPRB, 0.19224667E-05_JPRB /)

RGHG7(:, 9, 5) = (/ &
  & 0.22981676E-05_JPRB, 0.20158627E-05_JPRB, 0.19824743E-05_JPRB, 0.20211658E-05_JPRB, 0.20967357E-05_JPRB, 0.21985384E-05_JPRB, &
  & 0.23352291E-05_JPRB, 0.25291897E-05_JPRB, 0.28144023E-05_JPRB, 0.31366806E-05_JPRB, 0.33200795E-05_JPRB, 0.33645708E-05_JPRB, &
  & 0.33155720E-05_JPRB, 0.32387925E-05_JPRB, 0.31725754E-05_JPRB, 0.31042882E-05_JPRB, 0.30308029E-05_JPRB, 0.29832652E-05_JPRB, &
  & 0.29499784E-05_JPRB, 0.29191315E-05_JPRB, 0.28868615E-05_JPRB, 0.28772288E-05_JPRB, 0.28848026E-05_JPRB, 0.29036878E-05_JPRB, &
  & 0.29317523E-05_JPRB, 0.29484047E-05_JPRB, 0.29568180E-05_JPRB, 0.29809976E-05_JPRB, 0.30143958E-05_JPRB, 0.30304768E-05_JPRB, &
  & 0.30564581E-05_JPRB, 0.30511262E-05_JPRB, 0.30327217E-05_JPRB, 0.30341457E-05_JPRB, 0.30424510E-05_JPRB, 0.30541000E-05_JPRB, &
  & 0.30558638E-05_JPRB, 0.30676483E-05_JPRB, 0.30476199E-05_JPRB, 0.30137146E-05_JPRB, 0.29962662E-05_JPRB, 0.29802511E-05_JPRB, &
  & 0.29626174E-05_JPRB, 0.29256505E-05_JPRB, 0.28721272E-05_JPRB, 0.28326899E-05_JPRB, 0.27937576E-05_JPRB, 0.27446258E-05_JPRB, &
  & 0.26829935E-05_JPRB, 0.26418149E-05_JPRB, 0.26016403E-05_JPRB, 0.25421543E-05_JPRB, 0.24867829E-05_JPRB, 0.24207627E-05_JPRB, &
  & 0.23623227E-05_JPRB, 0.23157827E-05_JPRB, 0.22739118E-05_JPRB, 0.22574548E-05_JPRB, 0.22586321E-05_JPRB, 0.22772440E-05_JPRB, &
  & 0.23029752E-05_JPRB, 0.23438038E-05_JPRB, 0.24024926E-05_JPRB, 0.24871251E-05_JPRB /)

RGHG7(:,10, 5) = (/ &
  & 0.21444077E-05_JPRB, 0.22326060E-05_JPRB, 0.23333334E-05_JPRB, 0.24335172E-05_JPRB, 0.25417455E-05_JPRB, 0.26707573E-05_JPRB, &
  & 0.28266425E-05_JPRB, 0.30149038E-05_JPRB, 0.32737944E-05_JPRB, 0.36519027E-05_JPRB, 0.39894949E-05_JPRB, 0.41909461E-05_JPRB, &
  & 0.42426286E-05_JPRB, 0.42006700E-05_JPRB, 0.41351718E-05_JPRB, 0.40487666E-05_JPRB, 0.39409319E-05_JPRB, 0.38538242E-05_JPRB, &
  & 0.37794057E-05_JPRB, 0.37112561E-05_JPRB, 0.36401200E-05_JPRB, 0.36030333E-05_JPRB, 0.35893588E-05_JPRB, 0.35916144E-05_JPRB, &
  & 0.36007723E-05_JPRB, 0.36133395E-05_JPRB, 0.36208771E-05_JPRB, 0.36374756E-05_JPRB, 0.36650522E-05_JPRB, 0.36837062E-05_JPRB, &
  & 0.37097386E-05_JPRB, 0.37040031E-05_JPRB, 0.36868537E-05_JPRB, 0.36905517E-05_JPRB, 0.37007721E-05_JPRB, 0.37096970E-05_JPRB, &
  & 0.37122797E-05_JPRB, 0.37130976E-05_JPRB, 0.36845872E-05_JPRB, 0.36372098E-05_JPRB, 0.36063213E-05_JPRB, 0.35779447E-05_JPRB, &
  & 0.35461462E-05_JPRB, 0.35005228E-05_JPRB, 0.34349605E-05_JPRB, 0.33896001E-05_JPRB, 0.33499957E-05_JPRB, 0.33031938E-05_JPRB, &
  & 0.32372106E-05_JPRB, 0.31834470E-05_JPRB, 0.31238872E-05_JPRB, 0.30518020E-05_JPRB, 0.29976484E-05_JPRB, 0.29410526E-05_JPRB, &
  & 0.28850700E-05_JPRB, 0.28293143E-05_JPRB, 0.27708647E-05_JPRB, 0.27371750E-05_JPRB, 0.27277581E-05_JPRB, 0.27365363E-05_JPRB, &
  & 0.27592359E-05_JPRB, 0.27978981E-05_JPRB, 0.28549016E-05_JPRB, 0.29177199E-05_JPRB /)

RGHG7(:,11, 5) = (/ &
  & 0.24402768E-05_JPRB, 0.26846114E-05_JPRB, 0.28214388E-05_JPRB, 0.29425478E-05_JPRB, 0.30581530E-05_JPRB, 0.31789396E-05_JPRB, &
  & 0.33149126E-05_JPRB, 0.34740817E-05_JPRB, 0.36913316E-05_JPRB, 0.40420837E-05_JPRB, 0.44419553E-05_JPRB, 0.47841577E-05_JPRB, &
  & 0.50054527E-05_JPRB, 0.51148595E-05_JPRB, 0.51575162E-05_JPRB, 0.51332440E-05_JPRB, 0.50483191E-05_JPRB, 0.49555165E-05_JPRB, &
  & 0.48562529E-05_JPRB, 0.47514304E-05_JPRB, 0.46354698E-05_JPRB, 0.45541110E-05_JPRB, 0.44975563E-05_JPRB, 0.44634817E-05_JPRB, &
  & 0.44424587E-05_JPRB, 0.44213684E-05_JPRB, 0.43927789E-05_JPRB, 0.43952109E-05_JPRB, 0.44198127E-05_JPRB, 0.44399812E-05_JPRB, &
  & 0.44684443E-05_JPRB, 0.44782873E-05_JPRB, 0.44819390E-05_JPRB, 0.45015581E-05_JPRB, 0.45213346E-05_JPRB, 0.45308566E-05_JPRB, &
  & 0.45299762E-05_JPRB, 0.45182660E-05_JPRB, 0.44805906E-05_JPRB, 0.44188278E-05_JPRB, 0.43747473E-05_JPRB, 0.43376149E-05_JPRB, &
  & 0.42990032E-05_JPRB, 0.42517440E-05_JPRB, 0.41859407E-05_JPRB, 0.41418416E-05_JPRB, 0.41005219E-05_JPRB, 0.40492200E-05_JPRB, &
  & 0.39775337E-05_JPRB, 0.39222882E-05_JPRB, 0.38683615E-05_JPRB, 0.38052594E-05_JPRB, 0.37543841E-05_JPRB, 0.36973763E-05_JPRB, &
  & 0.36441841E-05_JPRB, 0.35989317E-05_JPRB, 0.35535759E-05_JPRB, 0.35297658E-05_JPRB, 0.35285266E-05_JPRB, 0.35457451E-05_JPRB, &
  & 0.35785672E-05_JPRB, 0.36293009E-05_JPRB, 0.36967378E-05_JPRB, 0.37752500E-05_JPRB /)

RGHG7(:,12, 5) = (/ &
  & 0.29772557E-05_JPRB, 0.31943619E-05_JPRB, 0.33146944E-05_JPRB, 0.34086249E-05_JPRB, 0.35041428E-05_JPRB, 0.36079323E-05_JPRB, &
  & 0.37262869E-05_JPRB, 0.38637777E-05_JPRB, 0.40415557E-05_JPRB, 0.43376203E-05_JPRB, 0.47074477E-05_JPRB, 0.50796721E-05_JPRB, &
  & 0.53832737E-05_JPRB, 0.55979754E-05_JPRB, 0.57417897E-05_JPRB, 0.58147348E-05_JPRB, 0.58162045E-05_JPRB, 0.57887059E-05_JPRB, &
  & 0.57368511E-05_JPRB, 0.56614554E-05_JPRB, 0.55618061E-05_JPRB, 0.54856009E-05_JPRB, 0.54266384E-05_JPRB, 0.53812228E-05_JPRB, &
  & 0.53455924E-05_JPRB, 0.53168133E-05_JPRB, 0.52882228E-05_JPRB, 0.52737396E-05_JPRB, 0.52846472E-05_JPRB, 0.53175295E-05_JPRB, &
  & 0.53755712E-05_JPRB, 0.54157576E-05_JPRB, 0.54412653E-05_JPRB, 0.54852667E-05_JPRB, 0.55165310E-05_JPRB, 0.55309993E-05_JPRB, &
  & 0.55301052E-05_JPRB, 0.55101063E-05_JPRB, 0.54629013E-05_JPRB, 0.53881527E-05_JPRB, 0.53300773E-05_JPRB, 0.52805208E-05_JPRB, &
  & 0.52303931E-05_JPRB, 0.51757106E-05_JPRB, 0.51015218E-05_JPRB, 0.50489202E-05_JPRB, 0.50014301E-05_JPRB, 0.49487426E-05_JPRB, &
  & 0.48793581E-05_JPRB, 0.48284905E-05_JPRB, 0.47799463E-05_JPRB, 0.47223043E-05_JPRB, 0.46778810E-05_JPRB, 0.46290575E-05_JPRB, &
  & 0.45832880E-05_JPRB, 0.45424249E-05_JPRB, 0.44962076E-05_JPRB, 0.44726935E-05_JPRB, 0.44759686E-05_JPRB, 0.44940966E-05_JPRB, &
  & 0.45203360E-05_JPRB, 0.45539109E-05_JPRB, 0.46058458E-05_JPRB, 0.46755681E-05_JPRB /)

RGHG7(:,13, 5) = (/ &
  & 0.34826701E-05_JPRB, 0.36193783E-05_JPRB, 0.37003463E-05_JPRB, 0.37716395E-05_JPRB, 0.38419876E-05_JPRB, 0.39215579E-05_JPRB, &
  & 0.40126538E-05_JPRB, 0.41167418E-05_JPRB, 0.42478659E-05_JPRB, 0.45052570E-05_JPRB, 0.48095853E-05_JPRB, 0.51289398E-05_JPRB, &
  & 0.54272314E-05_JPRB, 0.56775066E-05_JPRB, 0.58749406E-05_JPRB, 0.60150828E-05_JPRB, 0.61020191E-05_JPRB, 0.61621367E-05_JPRB, &
  & 0.61931805E-05_JPRB, 0.61964297E-05_JPRB, 0.61750497E-05_JPRB, 0.61620735E-05_JPRB, 0.61548112E-05_JPRB, 0.61498008E-05_JPRB, &
  & 0.61427763E-05_JPRB, 0.61309265E-05_JPRB, 0.61202645E-05_JPRB, 0.61345527E-05_JPRB, 0.61723067E-05_JPRB, 0.62108597E-05_JPRB, &
  & 0.62733570E-05_JPRB, 0.63289804E-05_JPRB, 0.63828688E-05_JPRB, 0.64371852E-05_JPRB, 0.64846181E-05_JPRB, 0.65123490E-05_JPRB, &
  & 0.65129675E-05_JPRB, 0.64916308E-05_JPRB, 0.64414608E-05_JPRB, 0.63636744E-05_JPRB, 0.62995514E-05_JPRB, 0.62418885E-05_JPRB, &
  & 0.61835512E-05_JPRB, 0.61207243E-05_JPRB, 0.60406019E-05_JPRB, 0.59840986E-05_JPRB, 0.59362801E-05_JPRB, 0.58869296E-05_JPRB, &
  & 0.58231431E-05_JPRB, 0.57764751E-05_JPRB, 0.57287480E-05_JPRB, 0.56659246E-05_JPRB, 0.56079621E-05_JPRB, 0.55376922E-05_JPRB, &
  & 0.54636330E-05_JPRB, 0.53874114E-05_JPRB, 0.52991791E-05_JPRB, 0.52351229E-05_JPRB, 0.51992456E-05_JPRB, 0.51808820E-05_JPRB, &
  & 0.51736711E-05_JPRB, 0.51769939E-05_JPRB, 0.51923994E-05_JPRB, 0.52179330E-05_JPRB /)

RGHG7(:,14, 5) = (/ &
  & 0.38251123E-05_JPRB, 0.39077518E-05_JPRB, 0.39565925E-05_JPRB, 0.40077380E-05_JPRB, 0.40626901E-05_JPRB, 0.41238636E-05_JPRB, &
  & 0.41921571E-05_JPRB, 0.42692022E-05_JPRB, 0.43715850E-05_JPRB, 0.45948013E-05_JPRB, 0.48625816E-05_JPRB, 0.51362058E-05_JPRB, &
  & 0.54068614E-05_JPRB, 0.56657973E-05_JPRB, 0.58985934E-05_JPRB, 0.60868324E-05_JPRB, 0.62364161E-05_JPRB, 0.63624834E-05_JPRB, &
  & 0.64615738E-05_JPRB, 0.65312429E-05_JPRB, 0.65829104E-05_JPRB, 0.66329098E-05_JPRB, 0.66808602E-05_JPRB, 0.67253295E-05_JPRB, &
  & 0.67634883E-05_JPRB, 0.67936849E-05_JPRB, 0.68210461E-05_JPRB, 0.68550135E-05_JPRB, 0.69195753E-05_JPRB, 0.69881844E-05_JPRB, &
  & 0.70714982E-05_JPRB, 0.71426848E-05_JPRB, 0.71885552E-05_JPRB, 0.72553471E-05_JPRB, 0.73137371E-05_JPRB, 0.73500742E-05_JPRB, &
  & 0.73733104E-05_JPRB, 0.73709352E-05_JPRB, 0.73374194E-05_JPRB, 0.72739758E-05_JPRB, 0.72163148E-05_JPRB, 0.71585669E-05_JPRB, &
  & 0.70958667E-05_JPRB, 0.70251444E-05_JPRB, 0.69387552E-05_JPRB, 0.68737177E-05_JPRB, 0.68177847E-05_JPRB, 0.67629749E-05_JPRB, &
  & 0.66959869E-05_JPRB, 0.66419443E-05_JPRB, 0.65805029E-05_JPRB, 0.64980663E-05_JPRB, 0.64110536E-05_JPRB, 0.63042430E-05_JPRB, &
  & 0.61850042E-05_JPRB, 0.60541602E-05_JPRB, 0.59056988E-05_JPRB, 0.57848547E-05_JPRB, 0.56978115E-05_JPRB, 0.56308081E-05_JPRB, &
  & 0.55800429E-05_JPRB, 0.55445794E-05_JPRB, 0.55278706E-05_JPRB, 0.55261567E-05_JPRB /)

RGHG7(:,15, 5) = (/ &
  & 0.40277823E-05_JPRB, 0.40900049E-05_JPRB, 0.41220292E-05_JPRB, 0.41644748E-05_JPRB, 0.42109109E-05_JPRB, 0.42664733E-05_JPRB, &
  & 0.43331033E-05_JPRB, 0.44095073E-05_JPRB, 0.45024121E-05_JPRB, 0.46877508E-05_JPRB, 0.49458217E-05_JPRB, 0.52125292E-05_JPRB, &
  & 0.54676480E-05_JPRB, 0.57156408E-05_JPRB, 0.59547992E-05_JPRB, 0.61631326E-05_JPRB, 0.63407265E-05_JPRB, 0.65034378E-05_JPRB, &
  & 0.66526545E-05_JPRB, 0.67790133E-05_JPRB, 0.68913200E-05_JPRB, 0.69965058E-05_JPRB, 0.70903720E-05_JPRB, 0.71815261E-05_JPRB, &
  & 0.72626462E-05_JPRB, 0.73328679E-05_JPRB, 0.74008831E-05_JPRB, 0.74745521E-05_JPRB, 0.75611329E-05_JPRB, 0.76391707E-05_JPRB, &
  & 0.77173991E-05_JPRB, 0.77702007E-05_JPRB, 0.78154508E-05_JPRB, 0.78683033E-05_JPRB, 0.79254496E-05_JPRB, 0.79813653E-05_JPRB, &
  & 0.80126947E-05_JPRB, 0.80246054E-05_JPRB, 0.80082127E-05_JPRB, 0.79665197E-05_JPRB, 0.79258889E-05_JPRB, 0.78776648E-05_JPRB, &
  & 0.78175999E-05_JPRB, 0.77429668E-05_JPRB, 0.76525821E-05_JPRB, 0.75784287E-05_JPRB, 0.75119046E-05_JPRB, 0.74447180E-05_JPRB, &
  & 0.73635779E-05_JPRB, 0.72876464E-05_JPRB, 0.71985551E-05_JPRB, 0.70854398E-05_JPRB, 0.69616358E-05_JPRB, 0.68141635E-05_JPRB, &
  & 0.66478692E-05_JPRB, 0.64641226E-05_JPRB, 0.62613990E-05_JPRB, 0.60898360E-05_JPRB, 0.59546132E-05_JPRB, 0.58446958E-05_JPRB, &
  & 0.57560678E-05_JPRB, 0.56873369E-05_JPRB, 0.56362305E-05_JPRB, 0.55925238E-05_JPRB /)

RGHG7(:,16, 5) = (/ &
  & 0.42125093E-05_JPRB, 0.42585298E-05_JPRB, 0.42855959E-05_JPRB, 0.43217447E-05_JPRB, 0.43629543E-05_JPRB, 0.44146132E-05_JPRB, &
  & 0.44761009E-05_JPRB, 0.45474922E-05_JPRB, 0.46293544E-05_JPRB, 0.47746926E-05_JPRB, 0.50071026E-05_JPRB, 0.52604510E-05_JPRB, &
  & 0.55045643E-05_JPRB, 0.57320340E-05_JPRB, 0.59578488E-05_JPRB, 0.61739261E-05_JPRB, 0.63716070E-05_JPRB, 0.65581789E-05_JPRB, &
  & 0.67372125E-05_JPRB, 0.69001640E-05_JPRB, 0.70516517E-05_JPRB, 0.72027210E-05_JPRB, 0.73463007E-05_JPRB, 0.74858381E-05_JPRB, &
  & 0.76166989E-05_JPRB, 0.77347140E-05_JPRB, 0.78449802E-05_JPRB, 0.79507026E-05_JPRB, 0.80519530E-05_JPRB, 0.81314020E-05_JPRB, &
  & 0.82001252E-05_JPRB, 0.82419510E-05_JPRB, 0.82616034E-05_JPRB, 0.82893157E-05_JPRB, 0.83250443E-05_JPRB, 0.83650584E-05_JPRB, &
  & 0.84084004E-05_JPRB, 0.84397243E-05_JPRB, 0.84509966E-05_JPRB, 0.84332314E-05_JPRB, 0.84083849E-05_JPRB, 0.83688847E-05_JPRB, &
  & 0.83104351E-05_JPRB, 0.82310062E-05_JPRB, 0.81327689E-05_JPRB, 0.80409818E-05_JPRB, 0.79508254E-05_JPRB, 0.78546618E-05_JPRB, &
  & 0.77430113E-05_JPRB, 0.76311981E-05_JPRB, 0.75065432E-05_JPRB, 0.73593392E-05_JPRB, 0.71994900E-05_JPRB, 0.70150440E-05_JPRB, &
  & 0.68095210E-05_JPRB, 0.65851086E-05_JPRB, 0.63441412E-05_JPRB, 0.61365558E-05_JPRB, 0.59680820E-05_JPRB, 0.58301839E-05_JPRB, &
  & 0.57187622E-05_JPRB, 0.56326276E-05_JPRB, 0.55659816E-05_JPRB, 0.55045189E-05_JPRB /)

RGHG7(:,17, 5) = (/ &
  & 0.43817167E-05_JPRB, 0.44178555E-05_JPRB, 0.44435574E-05_JPRB, 0.44753651E-05_JPRB, 0.45148740E-05_JPRB, 0.45611864E-05_JPRB, &
  & 0.46162750E-05_JPRB, 0.46810214E-05_JPRB, 0.47582839E-05_JPRB, 0.48864799E-05_JPRB, 0.50875942E-05_JPRB, 0.53264257E-05_JPRB, &
  & 0.55626297E-05_JPRB, 0.57900634E-05_JPRB, 0.60076350E-05_JPRB, 0.62254012E-05_JPRB, 0.64411756E-05_JPRB, 0.66505550E-05_JPRB, &
  & 0.68536051E-05_JPRB, 0.70470751E-05_JPRB, 0.72351272E-05_JPRB, 0.74246445E-05_JPRB, 0.76119227E-05_JPRB, 0.77962859E-05_JPRB, &
  & 0.79734291E-05_JPRB, 0.81321677E-05_JPRB, 0.82792449E-05_JPRB, 0.84093144E-05_JPRB, 0.85253760E-05_JPRB, 0.86053660E-05_JPRB, &
  & 0.86625641E-05_JPRB, 0.86873988E-05_JPRB, 0.86880291E-05_JPRB, 0.86930640E-05_JPRB, 0.87050894E-05_JPRB, 0.87272656E-05_JPRB, &
  & 0.87565713E-05_JPRB, 0.87874760E-05_JPRB, 0.88036659E-05_JPRB, 0.87993876E-05_JPRB, 0.87873623E-05_JPRB, 0.87568360E-05_JPRB, &
  & 0.87019816E-05_JPRB, 0.86196724E-05_JPRB, 0.85113070E-05_JPRB, 0.83991745E-05_JPRB, 0.82808483E-05_JPRB, 0.81512553E-05_JPRB, &
  & 0.80043828E-05_JPRB, 0.78537523E-05_JPRB, 0.76912183E-05_JPRB, 0.75081675E-05_JPRB, 0.73129099E-05_JPRB, 0.70950618E-05_JPRB, &
  & 0.68577156E-05_JPRB, 0.66035386E-05_JPRB, 0.63378197E-05_JPRB, 0.61068772E-05_JPRB, 0.59171743E-05_JPRB, 0.57613674E-05_JPRB, &
  & 0.56357235E-05_JPRB, 0.55387145E-05_JPRB, 0.54627067E-05_JPRB, 0.53876070E-05_JPRB /)

RGHG7(:,18, 5) = (/ &
  & 0.45425340E-05_JPRB, 0.45645302E-05_JPRB, 0.45866154E-05_JPRB, 0.46154487E-05_JPRB, 0.46518312E-05_JPRB, 0.46979771E-05_JPRB, &
  & 0.47537719E-05_JPRB, 0.48181751E-05_JPRB, 0.48921670E-05_JPRB, 0.50051749E-05_JPRB, 0.51777488E-05_JPRB, 0.54051820E-05_JPRB, &
  & 0.56410440E-05_JPRB, 0.58683654E-05_JPRB, 0.60845878E-05_JPRB, 0.62884856E-05_JPRB, 0.64929368E-05_JPRB, 0.67029268E-05_JPRB, &
  & 0.69158009E-05_JPRB, 0.71243626E-05_JPRB, 0.73311503E-05_JPRB, 0.75414041E-05_JPRB, 0.77517325E-05_JPRB, 0.79587999E-05_JPRB, &
  & 0.81567887E-05_JPRB, 0.83374753E-05_JPRB, 0.85024776E-05_JPRB, 0.86485943E-05_JPRB, 0.87758499E-05_JPRB, 0.88691113E-05_JPRB, &
  & 0.89353962E-05_JPRB, 0.89678988E-05_JPRB, 0.89703781E-05_JPRB, 0.89702162E-05_JPRB, 0.89715859E-05_JPRB, 0.89785626E-05_JPRB, &
  & 0.89943760E-05_JPRB, 0.90138628E-05_JPRB, 0.90276062E-05_JPRB, 0.90237854E-05_JPRB, 0.90123294E-05_JPRB, 0.89811383E-05_JPRB, &
  & 0.89235509E-05_JPRB, 0.88351098E-05_JPRB, 0.87167964E-05_JPRB, 0.85869106E-05_JPRB, 0.84443891E-05_JPRB, 0.82847100E-05_JPRB, &
  & 0.81050812E-05_JPRB, 0.79195015E-05_JPRB, 0.77236118E-05_JPRB, 0.75102312E-05_JPRB, 0.72867824E-05_JPRB, 0.70446276E-05_JPRB, &
  & 0.67869446E-05_JPRB, 0.65173826E-05_JPRB, 0.62424365E-05_JPRB, 0.60034113E-05_JPRB, 0.58070627E-05_JPRB, 0.56470749E-05_JPRB, &
  & 0.55198084E-05_JPRB, 0.54229467E-05_JPRB, 0.53502254E-05_JPRB, 0.52834498E-05_JPRB /)

RGHG7(:,19, 5) = (/ &
  & 0.46946602E-05_JPRB, 0.47114709E-05_JPRB, 0.47324711E-05_JPRB, 0.47598255E-05_JPRB, 0.47950221E-05_JPRB, 0.48391043E-05_JPRB, &
  & 0.48932561E-05_JPRB, 0.49567388E-05_JPRB, 0.50308208E-05_JPRB, 0.51362554E-05_JPRB, 0.52900473E-05_JPRB, 0.54957668E-05_JPRB, &
  & 0.57237767E-05_JPRB, 0.59432473E-05_JPRB, 0.61572209E-05_JPRB, 0.63610414E-05_JPRB, 0.65541803E-05_JPRB, 0.67454152E-05_JPRB, &
  & 0.69393686E-05_JPRB, 0.71347677E-05_JPRB, 0.73313731E-05_JPRB, 0.75263147E-05_JPRB, 0.77167524E-05_JPRB, 0.79066021E-05_JPRB, &
  & 0.80858363E-05_JPRB, 0.82498900E-05_JPRB, 0.84001103E-05_JPRB, 0.85394231E-05_JPRB, 0.86680448E-05_JPRB, 0.87822882E-05_JPRB, &
  & 0.88805655E-05_JPRB, 0.89549976E-05_JPRB, 0.90028670E-05_JPRB, 0.90376043E-05_JPRB, 0.90599133E-05_JPRB, 0.90772483E-05_JPRB, &
  & 0.90919284E-05_JPRB, 0.91046641E-05_JPRB, 0.91074889E-05_JPRB, 0.90915037E-05_JPRB, 0.90658914E-05_JPRB, 0.90237363E-05_JPRB, &
  & 0.89586219E-05_JPRB, 0.88651750E-05_JPRB, 0.87414483E-05_JPRB, 0.86024929E-05_JPRB, 0.84451140E-05_JPRB, 0.82664919E-05_JPRB, &
  & 0.80680511E-05_JPRB, 0.78646799E-05_JPRB, 0.76517881E-05_JPRB, 0.74231589E-05_JPRB, 0.71855688E-05_JPRB, 0.69330445E-05_JPRB, &
  & 0.66697817E-05_JPRB, 0.63998241E-05_JPRB, 0.61299070E-05_JPRB, 0.58962341E-05_JPRB, 0.57048414E-05_JPRB, 0.55505448E-05_JPRB, &
  & 0.54300899E-05_JPRB, 0.53393783E-05_JPRB, 0.52720675E-05_JPRB, 0.52109658E-05_JPRB /)

RGHG7(:,20, 5) = (/ &
  & 0.48272295E-05_JPRB, 0.48457100E-05_JPRB, 0.48689071E-05_JPRB, 0.48979009E-05_JPRB, 0.49343898E-05_JPRB, 0.49802252E-05_JPRB, &
  & 0.50356434E-05_JPRB, 0.51010547E-05_JPRB, 0.51769671E-05_JPRB, 0.52774581E-05_JPRB, 0.54131237E-05_JPRB, 0.55881292E-05_JPRB, &
  & 0.57962757E-05_JPRB, 0.60051975E-05_JPRB, 0.62001909E-05_JPRB, 0.63857924E-05_JPRB, 0.65633972E-05_JPRB, 0.67327310E-05_JPRB, &
  & 0.68958079E-05_JPRB, 0.70525284E-05_JPRB, 0.72084758E-05_JPRB, 0.73652814E-05_JPRB, 0.75122102E-05_JPRB, 0.76506694E-05_JPRB, &
  & 0.77791929E-05_JPRB, 0.78938447E-05_JPRB, 0.79973506E-05_JPRB, 0.81023318E-05_JPRB, 0.82120287E-05_JPRB, 0.83252489E-05_JPRB, &
  & 0.84427038E-05_JPRB, 0.85598394E-05_JPRB, 0.86648342E-05_JPRB, 0.87622238E-05_JPRB, 0.88417491E-05_JPRB, 0.89000878E-05_JPRB, &
  & 0.89355872E-05_JPRB, 0.89499936E-05_JPRB, 0.89412697E-05_JPRB, 0.89122204E-05_JPRB, 0.88711340E-05_JPRB, 0.88164788E-05_JPRB, &
  & 0.87463686E-05_JPRB, 0.86555310E-05_JPRB, 0.85394477E-05_JPRB, 0.84068379E-05_JPRB, 0.82541646E-05_JPRB, 0.80822192E-05_JPRB, &
  & 0.78934918E-05_JPRB, 0.76964934E-05_JPRB, 0.74865784E-05_JPRB, 0.72611119E-05_JPRB, 0.70268729E-05_JPRB, 0.67808746E-05_JPRB, &
  & 0.65275203E-05_JPRB, 0.62709523E-05_JPRB, 0.60181674E-05_JPRB, 0.57984917E-05_JPRB, 0.56182976E-05_JPRB, 0.54732250E-05_JPRB, &
  & 0.53601398E-05_JPRB, 0.52741766E-05_JPRB, 0.52076107E-05_JPRB, 0.51429279E-05_JPRB /)

RGHG7(:,21, 5) = (/ &
  & 0.49233981E-05_JPRB, 0.49516088E-05_JPRB, 0.49789583E-05_JPRB, 0.50112621E-05_JPRB, 0.50507037E-05_JPRB, 0.50982790E-05_JPRB, &
  & 0.51552724E-05_JPRB, 0.52207315E-05_JPRB, 0.52946129E-05_JPRB, 0.53888339E-05_JPRB, 0.55091487E-05_JPRB, 0.56558374E-05_JPRB, &
  & 0.58267351E-05_JPRB, 0.60129064E-05_JPRB, 0.61888227E-05_JPRB, 0.63439365E-05_JPRB, 0.64854662E-05_JPRB, 0.66173552E-05_JPRB, &
  & 0.67392034E-05_JPRB, 0.68504241E-05_JPRB, 0.69529419E-05_JPRB, 0.70508390E-05_JPRB, 0.71453987E-05_JPRB, 0.72267744E-05_JPRB, &
  & 0.72990192E-05_JPRB, 0.73623301E-05_JPRB, 0.74173217E-05_JPRB, 0.74701447E-05_JPRB, 0.75315893E-05_JPRB, 0.76068268E-05_JPRB, &
  & 0.77018667E-05_JPRB, 0.78157991E-05_JPRB, 0.79379988E-05_JPRB, 0.80724585E-05_JPRB, 0.81934568E-05_JPRB, 0.82913984E-05_JPRB, &
  & 0.83593450E-05_JPRB, 0.83979739E-05_JPRB, 0.84043268E-05_JPRB, 0.83861541E-05_JPRB, 0.83555215E-05_JPRB, 0.83155528E-05_JPRB, &
  & 0.82636643E-05_JPRB, 0.81955386E-05_JPRB, 0.81047283E-05_JPRB, 0.79969650E-05_JPRB, 0.78714347E-05_JPRB, 0.77289906E-05_JPRB, &
  & 0.75665275E-05_JPRB, 0.73902279E-05_JPRB, 0.71997897E-05_JPRB, 0.69948564E-05_JPRB, 0.67813598E-05_JPRB, 0.65582590E-05_JPRB, &
  & 0.63297334E-05_JPRB, 0.60997568E-05_JPRB, 0.58740966E-05_JPRB, 0.56770396E-05_JPRB, 0.55141663E-05_JPRB, 0.53826288E-05_JPRB, &
  & 0.52794253E-05_JPRB, 0.52001337E-05_JPRB, 0.51347256E-05_JPRB, 0.50649855E-05_JPRB /)

RGHG7(:,22, 5) = (/ &
  & 0.49649443E-05_JPRB, 0.50037374E-05_JPRB, 0.50369831E-05_JPRB, 0.50739827E-05_JPRB, 0.51169723E-05_JPRB, 0.51677007E-05_JPRB, &
  & 0.52257619E-05_JPRB, 0.52907535E-05_JPRB, 0.53620784E-05_JPRB, 0.54472212E-05_JPRB, 0.55496839E-05_JPRB, 0.56678377E-05_JPRB, &
  & 0.57992279E-05_JPRB, 0.59391759E-05_JPRB, 0.60742955E-05_JPRB, 0.61920123E-05_JPRB, 0.62904951E-05_JPRB, 0.63754396E-05_JPRB, &
  & 0.64485721E-05_JPRB, 0.65126137E-05_JPRB, 0.65655340E-05_JPRB, 0.66104485E-05_JPRB, 0.66514231E-05_JPRB, 0.66860302E-05_JPRB, &
  & 0.67132173E-05_JPRB, 0.67298538E-05_JPRB, 0.67377896E-05_JPRB, 0.67439546E-05_JPRB, 0.67527353E-05_JPRB, 0.67684423E-05_JPRB, &
  & 0.68044214E-05_JPRB, 0.68653681E-05_JPRB, 0.69503985E-05_JPRB, 0.70642864E-05_JPRB, 0.71834097E-05_JPRB, 0.72999887E-05_JPRB, &
  & 0.73922911E-05_JPRB, 0.74641762E-05_JPRB, 0.75077469E-05_JPRB, 0.75321545E-05_JPRB, 0.75467733E-05_JPRB, 0.75573666E-05_JPRB, &
  & 0.75570483E-05_JPRB, 0.75393405E-05_JPRB, 0.74978420E-05_JPRB, 0.74375307E-05_JPRB, 0.73566430E-05_JPRB, 0.72523571E-05_JPRB, &
  & 0.71245740E-05_JPRB, 0.69819343E-05_JPRB, 0.68247186E-05_JPRB, 0.66524167E-05_JPRB, 0.64709784E-05_JPRB, 0.62812287E-05_JPRB, &
  & 0.60869347E-05_JPRB, 0.58911055E-05_JPRB, 0.56984863E-05_JPRB, 0.55271425E-05_JPRB, 0.53829731E-05_JPRB, 0.52641908E-05_JPRB, &
  & 0.51690586E-05_JPRB, 0.50935842E-05_JPRB, 0.50286098E-05_JPRB, 0.49421842E-05_JPRB /)

RGHG7(:,23, 5) = (/ &
  & 0.49386067E-05_JPRB, 0.49871564E-05_JPRB, 0.50252133E-05_JPRB, 0.50658200E-05_JPRB, 0.51119378E-05_JPRB, 0.51632692E-05_JPRB, &
  & 0.52201990E-05_JPRB, 0.52793184E-05_JPRB, 0.53415970E-05_JPRB, 0.54112384E-05_JPRB, 0.54876068E-05_JPRB, 0.55690202E-05_JPRB, &
  & 0.56548329E-05_JPRB, 0.57406232E-05_JPRB, 0.58224146E-05_JPRB, 0.58927508E-05_JPRB, 0.59462645E-05_JPRB, 0.59847098E-05_JPRB, &
  & 0.60106754E-05_JPRB, 0.60283915E-05_JPRB, 0.60402281E-05_JPRB, 0.60476896E-05_JPRB, 0.60541151E-05_JPRB, 0.60596635E-05_JPRB, &
  & 0.60623966E-05_JPRB, 0.60578245E-05_JPRB, 0.60394250E-05_JPRB, 0.60044763E-05_JPRB, 0.59631429E-05_JPRB, 0.59185386E-05_JPRB, &
  & 0.58842884E-05_JPRB, 0.58702403E-05_JPRB, 0.58863138E-05_JPRB, 0.59373629E-05_JPRB, 0.60149036E-05_JPRB, 0.61094324E-05_JPRB, &
  & 0.62088452E-05_JPRB, 0.63070861E-05_JPRB, 0.63986581E-05_JPRB, 0.64848646E-05_JPRB, 0.65692129E-05_JPRB, 0.66500243E-05_JPRB, &
  & 0.67184146E-05_JPRB, 0.67665283E-05_JPRB, 0.67866204E-05_JPRB, 0.67788678E-05_JPRB, 0.67417668E-05_JPRB, 0.66781458E-05_JPRB, &
  & 0.65912268E-05_JPRB, 0.64874675E-05_JPRB, 0.63670614E-05_JPRB, 0.62317299E-05_JPRB, 0.60869156E-05_JPRB, 0.59341351E-05_JPRB, &
  & 0.57767666E-05_JPRB, 0.56175854E-05_JPRB, 0.54599814E-05_JPRB, 0.53174235E-05_JPRB, 0.51948214E-05_JPRB, 0.50915914E-05_JPRB, &
  & 0.50063218E-05_JPRB, 0.49356827E-05_JPRB, 0.48730808E-05_JPRB, 0.47884223E-05_JPRB /)

RGHG7(:,24, 5) = (/ &
  & 0.48488541E-05_JPRB, 0.48994893E-05_JPRB, 0.49386226E-05_JPRB, 0.49799273E-05_JPRB, 0.50245380E-05_JPRB, 0.50728877E-05_JPRB, &
  & 0.51222878E-05_JPRB, 0.51694233E-05_JPRB, 0.52160408E-05_JPRB, 0.52655596E-05_JPRB, 0.53126278E-05_JPRB, 0.53549138E-05_JPRB, &
  & 0.53909366E-05_JPRB, 0.54196798E-05_JPRB, 0.54420789E-05_JPRB, 0.54581596E-05_JPRB, 0.54625516E-05_JPRB, 0.54574857E-05_JPRB, &
  & 0.54444231E-05_JPRB, 0.54278721E-05_JPRB, 0.54106254E-05_JPRB, 0.53962813E-05_JPRB, 0.53862209E-05_JPRB, 0.53818026E-05_JPRB, &
  & 0.53784488E-05_JPRB, 0.53676281E-05_JPRB, 0.53407216E-05_JPRB, 0.52910973E-05_JPRB, 0.52150108E-05_JPRB, 0.51232410E-05_JPRB, &
  & 0.50301965E-05_JPRB, 0.49495238E-05_JPRB, 0.48982056E-05_JPRB, 0.48836105E-05_JPRB, 0.49092337E-05_JPRB, 0.49698619E-05_JPRB, &
  & 0.50607855E-05_JPRB, 0.51730140E-05_JPRB, 0.53041022E-05_JPRB, 0.54428838E-05_JPRB, 0.55893597E-05_JPRB, 0.57347252E-05_JPRB, &
  & 0.58655719E-05_JPRB, 0.59717149E-05_JPRB, 0.60435755E-05_JPRB, 0.60820958E-05_JPRB, 0.60882085E-05_JPRB, 0.60662287E-05_JPRB, &
  & 0.60187035E-05_JPRB, 0.59522949E-05_JPRB, 0.58686810E-05_JPRB, 0.57700718E-05_JPRB, 0.56611375E-05_JPRB, 0.55441092E-05_JPRB, &
  & 0.54222096E-05_JPRB, 0.52981472E-05_JPRB, 0.51746597E-05_JPRB, 0.50612935E-05_JPRB, 0.49621772E-05_JPRB, 0.48772577E-05_JPRB, &
  & 0.48060256E-05_JPRB, 0.47454473E-05_JPRB, 0.46893256E-05_JPRB, 0.46144614E-05_JPRB /)

RGHG7(:,25, 5) = (/ &
  & 0.47016752E-05_JPRB, 0.47473259E-05_JPRB, 0.47839344E-05_JPRB, 0.48206607E-05_JPRB, 0.48600796E-05_JPRB, 0.49005748E-05_JPRB, &
  & 0.49387877E-05_JPRB, 0.49703904E-05_JPRB, 0.49969044E-05_JPRB, 0.50201388E-05_JPRB, 0.50340814E-05_JPRB, 0.50359413E-05_JPRB, &
  & 0.50254171E-05_JPRB, 0.50038088E-05_JPRB, 0.49745327E-05_JPRB, 0.49407317E-05_JPRB, 0.49013988E-05_JPRB, 0.48585412E-05_JPRB, &
  & 0.48142456E-05_JPRB, 0.47732510E-05_JPRB, 0.47377935E-05_JPRB, 0.47118742E-05_JPRB, 0.46987293E-05_JPRB, 0.46953060E-05_JPRB, &
  & 0.46963496E-05_JPRB, 0.46901664E-05_JPRB, 0.46641471E-05_JPRB, 0.46089699E-05_JPRB, 0.45219567E-05_JPRB, 0.44053827E-05_JPRB, &
  & 0.42761999E-05_JPRB, 0.41521821E-05_JPRB, 0.40538862E-05_JPRB, 0.39926490E-05_JPRB, 0.39788888E-05_JPRB, 0.40126001E-05_JPRB, &
  & 0.40928776E-05_JPRB, 0.42101592E-05_JPRB, 0.43604646E-05_JPRB, 0.45336210E-05_JPRB, 0.47190629E-05_JPRB, 0.49064924E-05_JPRB, &
  & 0.50781946E-05_JPRB, 0.52234718E-05_JPRB, 0.53340254E-05_JPRB, 0.54090651E-05_JPRB, 0.54489014E-05_JPRB, 0.54595580E-05_JPRB, &
  & 0.54446045E-05_JPRB, 0.54097782E-05_JPRB, 0.53581293E-05_JPRB, 0.52921878E-05_JPRB, 0.52159721E-05_JPRB, 0.51319462E-05_JPRB, &
  & 0.50430026E-05_JPRB, 0.49515288E-05_JPRB, 0.48598267E-05_JPRB, 0.47747722E-05_JPRB, 0.46997184E-05_JPRB, 0.46351774E-05_JPRB, &
  & 0.45808160E-05_JPRB, 0.45339980E-05_JPRB, 0.44891603E-05_JPRB, 0.44243325E-05_JPRB /)

RGHG7(:,26, 5) = (/ &
  & 0.45049228E-05_JPRB, 0.45425199E-05_JPRB, 0.45706702E-05_JPRB, 0.46004639E-05_JPRB, 0.46305190E-05_JPRB, 0.46600517E-05_JPRB, &
  & 0.46848586E-05_JPRB, 0.46991954E-05_JPRB, 0.47041390E-05_JPRB, 0.47006788E-05_JPRB, 0.46830919E-05_JPRB, 0.46484520E-05_JPRB, &
  & 0.45983566E-05_JPRB, 0.45352799E-05_JPRB, 0.44646845E-05_JPRB, 0.43906666E-05_JPRB, 0.43178352E-05_JPRB, 0.42470515E-05_JPRB, &
  & 0.41815970E-05_JPRB, 0.41241469E-05_JPRB, 0.40783407E-05_JPRB, 0.40485720E-05_JPRB, 0.40349914E-05_JPRB, 0.40345135E-05_JPRB, &
  & 0.40406330E-05_JPRB, 0.40418345E-05_JPRB, 0.40236869E-05_JPRB, 0.39743495E-05_JPRB, 0.38859630E-05_JPRB, 0.37647894E-05_JPRB, &
  & 0.36233257E-05_JPRB, 0.34805882E-05_JPRB, 0.33590090E-05_JPRB, 0.32737403E-05_JPRB, 0.32389157E-05_JPRB, 0.32574992E-05_JPRB, &
  & 0.33288495E-05_JPRB, 0.34475106E-05_JPRB, 0.36043000E-05_JPRB, 0.37907164E-05_JPRB, 0.39932065E-05_JPRB, 0.41974408E-05_JPRB, &
  & 0.43889941E-05_JPRB, 0.45544616E-05_JPRB, 0.46862306E-05_JPRB, 0.47812237E-05_JPRB, 0.48448796E-05_JPRB, 0.48795732E-05_JPRB, &
  & 0.48894181E-05_JPRB, 0.48808683E-05_JPRB, 0.48568136E-05_JPRB, 0.48193328E-05_JPRB, 0.47724866E-05_JPRB, 0.47183776E-05_JPRB, &
  & 0.46595819E-05_JPRB, 0.45980146E-05_JPRB, 0.45355587E-05_JPRB, 0.44770618E-05_JPRB, 0.44252943E-05_JPRB, 0.43809118E-05_JPRB, &
  & 0.43438663E-05_JPRB, 0.43122277E-05_JPRB, 0.42825500E-05_JPRB, 0.42419151E-05_JPRB /)

RGHG7(:,27, 5) = (/ &
  & 0.42708207E-05_JPRB, 0.42935144E-05_JPRB, 0.43140503E-05_JPRB, 0.43336481E-05_JPRB, 0.43534878E-05_JPRB, 0.43707773E-05_JPRB, &
  & 0.43810669E-05_JPRB, 0.43789305E-05_JPRB, 0.43639579E-05_JPRB, 0.43363989E-05_JPRB, 0.42919464E-05_JPRB, 0.42292804E-05_JPRB, &
  & 0.41499684E-05_JPRB, 0.40578070E-05_JPRB, 0.39585175E-05_JPRB, 0.38580683E-05_JPRB, 0.37619068E-05_JPRB, 0.36724955E-05_JPRB, &
  & 0.35924465E-05_JPRB, 0.35243768E-05_JPRB, 0.34725206E-05_JPRB, 0.34385714E-05_JPRB, 0.34221791E-05_JPRB, 0.34208977E-05_JPRB, &
  & 0.34289551E-05_JPRB, 0.34350371E-05_JPRB, 0.34240745E-05_JPRB, 0.33858310E-05_JPRB, 0.33098606E-05_JPRB, 0.31958186E-05_JPRB, &
  & 0.30595895E-05_JPRB, 0.29173441E-05_JPRB, 0.27916369E-05_JPRB, 0.27008905E-05_JPRB, 0.26592979E-05_JPRB, 0.26716248E-05_JPRB, &
  & 0.27376423E-05_JPRB, 0.28546560E-05_JPRB, 0.30110507E-05_JPRB, 0.31943709E-05_JPRB, 0.33963681E-05_JPRB, 0.36003194E-05_JPRB, &
  & 0.37925904E-05_JPRB, 0.39604483E-05_JPRB, 0.40977120E-05_JPRB, 0.42047477E-05_JPRB, 0.42823153E-05_JPRB, 0.43338241E-05_JPRB, &
  & 0.43643913E-05_JPRB, 0.43778941E-05_JPRB, 0.43773548E-05_JPRB, 0.43653399E-05_JPRB, 0.43445643E-05_JPRB, 0.43172768E-05_JPRB, &
  & 0.42854513E-05_JPRB, 0.42507668E-05_JPRB, 0.42145530E-05_JPRB, 0.41803846E-05_JPRB, 0.41502881E-05_JPRB, 0.41249818E-05_JPRB, &
  & 0.41044759E-05_JPRB, 0.40870300E-05_JPRB, 0.40703876E-05_JPRB, 0.40488894E-05_JPRB /)

RGHG7(:,28, 5) = (/ &
  & 0.40064838E-05_JPRB, 0.40162709E-05_JPRB, 0.40260629E-05_JPRB, 0.40367904E-05_JPRB, 0.40460786E-05_JPRB, 0.40515488E-05_JPRB, &
  & 0.40487544E-05_JPRB, 0.40329114E-05_JPRB, 0.40019922E-05_JPRB, 0.39555316E-05_JPRB, 0.38910575E-05_JPRB, 0.38084054E-05_JPRB, &
  & 0.37102952E-05_JPRB, 0.36003923E-05_JPRB, 0.34843049E-05_JPRB, 0.33679089E-05_JPRB, 0.32564494E-05_JPRB, 0.31554302E-05_JPRB, &
  & 0.30656668E-05_JPRB, 0.29905598E-05_JPRB, 0.29320606E-05_JPRB, 0.28920599E-05_JPRB, 0.28705683E-05_JPRB, 0.28654276E-05_JPRB, &
  & 0.28711686E-05_JPRB, 0.28779971E-05_JPRB, 0.28736711E-05_JPRB, 0.28458401E-05_JPRB, 0.27850510E-05_JPRB, 0.26895837E-05_JPRB, &
  & 0.25692086E-05_JPRB, 0.24408898E-05_JPRB, 0.23245830E-05_JPRB, 0.22404797E-05_JPRB, 0.22011827E-05_JPRB, 0.22130821E-05_JPRB, &
  & 0.22766812E-05_JPRB, 0.23869563E-05_JPRB, 0.25351242E-05_JPRB, 0.27095753E-05_JPRB, 0.28994014E-05_JPRB, 0.30901247E-05_JPRB, &
  & 0.32705432E-05_JPRB, 0.34301988E-05_JPRB, 0.35652754E-05_JPRB, 0.36751374E-05_JPRB, 0.37606619E-05_JPRB, 0.38256098E-05_JPRB, &
  & 0.38719277E-05_JPRB, 0.39040037E-05_JPRB, 0.39244419E-05_JPRB, 0.39346191E-05_JPRB, 0.39373058E-05_JPRB, 0.39338156E-05_JPRB, &
  & 0.39260685E-05_JPRB, 0.39152915E-05_JPRB, 0.39024480E-05_JPRB, 0.38902526E-05_JPRB, 0.38799631E-05_JPRB, 0.38722164E-05_JPRB, &
  & 0.38667135E-05_JPRB, 0.38626813E-05_JPRB, 0.38600720E-05_JPRB, 0.38577109E-05_JPRB /)

RGHG7(:,29, 5) = (/ &
  & 0.37267571E-05_JPRB, 0.37220680E-05_JPRB, 0.37231764E-05_JPRB, 0.37250531E-05_JPRB, 0.37252044E-05_JPRB, 0.37204327E-05_JPRB, &
  & 0.37066688E-05_JPRB, 0.36789995E-05_JPRB, 0.36358394E-05_JPRB, 0.35763578E-05_JPRB, 0.34993668E-05_JPRB, 0.34059360E-05_JPRB, &
  & 0.32972225E-05_JPRB, 0.31777938E-05_JPRB, 0.30530605E-05_JPRB, 0.29295181E-05_JPRB, 0.28108927E-05_JPRB, 0.27024814E-05_JPRB, &
  & 0.26066134E-05_JPRB, 0.25256857E-05_JPRB, 0.24607316E-05_JPRB, 0.24142312E-05_JPRB, 0.23855621E-05_JPRB, 0.23735743E-05_JPRB, &
  & 0.23735840E-05_JPRB, 0.23776354E-05_JPRB, 0.23763105E-05_JPRB, 0.23579844E-05_JPRB, 0.23122395E-05_JPRB, 0.22383394E-05_JPRB, &
  & 0.21403314E-05_JPRB, 0.20337761E-05_JPRB, 0.19355593E-05_JPRB, 0.18649096E-05_JPRB, 0.18336566E-05_JPRB, 0.18483904E-05_JPRB, &
  & 0.19088343E-05_JPRB, 0.20110178E-05_JPRB, 0.21465289E-05_JPRB, 0.23048733E-05_JPRB, 0.24757601E-05_JPRB, 0.26470489E-05_JPRB, &
  & 0.28085192E-05_JPRB, 0.29538212E-05_JPRB, 0.30809322E-05_JPRB, 0.31891623E-05_JPRB, 0.32797168E-05_JPRB, 0.33540080E-05_JPRB, &
  & 0.34141412E-05_JPRB, 0.34626605E-05_JPRB, 0.35013645E-05_JPRB, 0.35316536E-05_JPRB, 0.35549078E-05_JPRB, 0.35723090E-05_JPRB, &
  & 0.35855514E-05_JPRB, 0.35953913E-05_JPRB, 0.36028955E-05_JPRB, 0.36099811E-05_JPRB, 0.36172703E-05_JPRB, 0.36253184E-05_JPRB, &
  & 0.36334932E-05_JPRB, 0.36418699E-05_JPRB, 0.36515723E-05_JPRB, 0.36694466E-05_JPRB /)

RGHG7(:,30, 5) = (/ &
  & 0.34442915E-05_JPRB, 0.34251420E-05_JPRB, 0.34184516E-05_JPRB, 0.34126476E-05_JPRB, 0.34050233E-05_JPRB, 0.33916656E-05_JPRB, &
  & 0.33686485E-05_JPRB, 0.33324475E-05_JPRB, 0.32808000E-05_JPRB, 0.32132486E-05_JPRB, 0.31297752E-05_JPRB, 0.30311899E-05_JPRB, &
  & 0.29194794E-05_JPRB, 0.27976951E-05_JPRB, 0.26698845E-05_JPRB, 0.25435029E-05_JPRB, 0.24229364E-05_JPRB, 0.23111427E-05_JPRB, &
  & 0.22112881E-05_JPRB, 0.21262849E-05_JPRB, 0.20557989E-05_JPRB, 0.20031398E-05_JPRB, 0.19666229E-05_JPRB, 0.19465392E-05_JPRB, &
  & 0.19389229E-05_JPRB, 0.19380634E-05_JPRB, 0.19367180E-05_JPRB, 0.19249223E-05_JPRB, 0.18930095E-05_JPRB, 0.18390098E-05_JPRB, &
  & 0.17652186E-05_JPRB, 0.16832669E-05_JPRB, 0.16068162E-05_JPRB, 0.15528470E-05_JPRB, 0.15319840E-05_JPRB, 0.15501017E-05_JPRB, &
  & 0.16076593E-05_JPRB, 0.16998517E-05_JPRB, 0.18193721E-05_JPRB, 0.19572030E-05_JPRB, 0.21053086E-05_JPRB, 0.22533516E-05_JPRB, &
  & 0.23941186E-05_JPRB, 0.25237332E-05_JPRB, 0.26412056E-05_JPRB, 0.27464059E-05_JPRB, 0.28406137E-05_JPRB, 0.29223095E-05_JPRB, &
  & 0.29931889E-05_JPRB, 0.30556948E-05_JPRB, 0.31102811E-05_JPRB, 0.31574782E-05_JPRB, 0.31986515E-05_JPRB, 0.32340627E-05_JPRB, &
  & 0.32650066E-05_JPRB, 0.32922640E-05_JPRB, 0.33168071E-05_JPRB, 0.33401050E-05_JPRB, 0.33625511E-05_JPRB, 0.33845706E-05_JPRB, &
  & 0.34050645E-05_JPRB, 0.34245113E-05_JPRB, 0.34446402E-05_JPRB, 0.34775767E-05_JPRB /)

RGHG7(:,31, 5) = (/ &
  & 0.31663744E-05_JPRB, 0.31360489E-05_JPRB, 0.31212319E-05_JPRB, 0.31092313E-05_JPRB, 0.30948650E-05_JPRB, 0.30744709E-05_JPRB, &
  & 0.30447059E-05_JPRB, 0.30021981E-05_JPRB, 0.29457292E-05_JPRB, 0.28746724E-05_JPRB, 0.27889751E-05_JPRB, 0.26899618E-05_JPRB, &
  & 0.25787044E-05_JPRB, 0.24594081E-05_JPRB, 0.23349342E-05_JPRB, 0.22090885E-05_JPRB, 0.20885245E-05_JPRB, 0.19765228E-05_JPRB, &
  & 0.18745096E-05_JPRB, 0.17868183E-05_JPRB, 0.17120686E-05_JPRB, 0.16537675E-05_JPRB, 0.16101559E-05_JPRB, 0.15821015E-05_JPRB, &
  & 0.15664770E-05_JPRB, 0.15594135E-05_JPRB, 0.15551650E-05_JPRB, 0.15470358E-05_JPRB, 0.15257984E-05_JPRB, 0.14896776E-05_JPRB, &
  & 0.14384328E-05_JPRB, 0.13802239E-05_JPRB, 0.13257452E-05_JPRB, 0.12886829E-05_JPRB, 0.12786847E-05_JPRB, 0.13004181E-05_JPRB, &
  & 0.13541569E-05_JPRB, 0.14352985E-05_JPRB, 0.15378595E-05_JPRB, 0.16547745E-05_JPRB, 0.17789129E-05_JPRB, 0.19039153E-05_JPRB, &
  & 0.20246293E-05_JPRB, 0.21382325E-05_JPRB, 0.22454540E-05_JPRB, 0.23473140E-05_JPRB, 0.24423618E-05_JPRB, 0.25301256E-05_JPRB, &
  & 0.26106316E-05_JPRB, 0.26845562E-05_JPRB, 0.27523031E-05_JPRB, 0.28143950E-05_JPRB, 0.28703626E-05_JPRB, 0.29205466E-05_JPRB, &
  & 0.29659834E-05_JPRB, 0.30072533E-05_JPRB, 0.30455276E-05_JPRB, 0.30819615E-05_JPRB, 0.31167772E-05_JPRB, 0.31501036E-05_JPRB, &
  & 0.31807506E-05_JPRB, 0.32093747E-05_JPRB, 0.32387113E-05_JPRB, 0.32842408E-05_JPRB /)

RGHG7(:,32, 5) = (/ &
  & 0.29025541E-05_JPRB, 0.28585459E-05_JPRB, 0.28380975E-05_JPRB, 0.28198838E-05_JPRB, 0.27999836E-05_JPRB, 0.27744691E-05_JPRB, &
  & 0.27395206E-05_JPRB, 0.26934874E-05_JPRB, 0.26348373E-05_JPRB, 0.25631962E-05_JPRB, 0.24790993E-05_JPRB, 0.23830169E-05_JPRB, &
  & 0.22761781E-05_JPRB, 0.21605501E-05_JPRB, 0.20406653E-05_JPRB, 0.19200306E-05_JPRB, 0.18018073E-05_JPRB, 0.16914034E-05_JPRB, &
  & 0.15892858E-05_JPRB, 0.14997149E-05_JPRB, 0.14224404E-05_JPRB, 0.13593271E-05_JPRB, 0.13102333E-05_JPRB, 0.12749963E-05_JPRB, &
  & 0.12522265E-05_JPRB, 0.12389795E-05_JPRB, 0.12308378E-05_JPRB, 0.12233905E-05_JPRB, 0.12098744E-05_JPRB, 0.11875443E-05_JPRB, &
  & 0.11555891E-05_JPRB, 0.11183112E-05_JPRB, 0.10839489E-05_JPRB, 0.10632942E-05_JPRB, 0.10641794E-05_JPRB, 0.10896146E-05_JPRB, &
  & 0.11385719E-05_JPRB, 0.12080217E-05_JPRB, 0.12934502E-05_JPRB, 0.13897625E-05_JPRB, 0.14921346E-05_JPRB, 0.15960101E-05_JPRB, &
  & 0.16986874E-05_JPRB, 0.17987645E-05_JPRB, 0.18973149E-05_JPRB, 0.19943600E-05_JPRB, 0.20894342E-05_JPRB, 0.21809890E-05_JPRB, &
  & 0.22682409E-05_JPRB, 0.23511520E-05_JPRB, 0.24296066E-05_JPRB, 0.25030834E-05_JPRB, 0.25706115E-05_JPRB, 0.26326520E-05_JPRB, &
  & 0.26893110E-05_JPRB, 0.27415742E-05_JPRB, 0.27905753E-05_JPRB, 0.28370969E-05_JPRB, 0.28815605E-05_JPRB, 0.29237719E-05_JPRB, &
  & 0.29626112E-05_JPRB, 0.29985219E-05_JPRB, 0.30354661E-05_JPRB, 0.30918636E-05_JPRB /)

RGHG7(:,33, 5) = (/ &
  & 0.26518028E-05_JPRB, 0.25982952E-05_JPRB, 0.25705069E-05_JPRB, 0.25479192E-05_JPRB, 0.25234040E-05_JPRB, 0.24935848E-05_JPRB, &
  & 0.24559783E-05_JPRB, 0.24082792E-05_JPRB, 0.23499467E-05_JPRB, 0.22804970E-05_JPRB, 0.21998267E-05_JPRB, 0.21087935E-05_JPRB, &
  & 0.20082057E-05_JPRB, 0.19002757E-05_JPRB, 0.17866099E-05_JPRB, 0.16708469E-05_JPRB, 0.15570082E-05_JPRB, 0.14490167E-05_JPRB, &
  & 0.13485080E-05_JPRB, 0.12581446E-05_JPRB, 0.11793567E-05_JPRB, 0.11129962E-05_JPRB, 0.10596906E-05_JPRB, 0.10189250E-05_JPRB, &
  & 0.99032241E-06_JPRB, 0.97157681E-06_JPRB, 0.95993789E-06_JPRB, 0.95144082E-06_JPRB, 0.94247446E-06_JPRB, 0.92990456E-06_JPRB, &
  & 0.91260819E-06_JPRB, 0.89242701E-06_JPRB, 0.87489025E-06_JPRB, 0.86761901E-06_JPRB, 0.87604917E-06_JPRB, 0.90248466E-06_JPRB, &
  & 0.94763095E-06_JPRB, 0.10077293E-05_JPRB, 0.10786079E-05_JPRB, 0.11572164E-05_JPRB, 0.12413137E-05_JPRB, 0.13280127E-05_JPRB, &
  & 0.14155065E-05_JPRB, 0.15049204E-05_JPRB, 0.15956401E-05_JPRB, 0.16889644E-05_JPRB, 0.17826983E-05_JPRB, 0.18755298E-05_JPRB, &
  & 0.19670731E-05_JPRB, 0.20561370E-05_JPRB, 0.21422022E-05_JPRB, 0.22238733E-05_JPRB, 0.23002224E-05_JPRB, 0.23706823E-05_JPRB, &
  & 0.24355315E-05_JPRB, 0.24958165E-05_JPRB, 0.25525824E-05_JPRB, 0.26065759E-05_JPRB, 0.26583043E-05_JPRB, 0.27069882E-05_JPRB, &
  & 0.27520434E-05_JPRB, 0.27935664E-05_JPRB, 0.28363561E-05_JPRB, 0.29013870E-05_JPRB /)

RGHG7(:,34, 5) = (/ &
  & 0.24180481E-05_JPRB, 0.23536916E-05_JPRB, 0.23217408E-05_JPRB, 0.22944491E-05_JPRB, 0.22667450E-05_JPRB, 0.22342228E-05_JPRB, &
  & 0.21950216E-05_JPRB, 0.21476617E-05_JPRB, 0.20913519E-05_JPRB, 0.20255609E-05_JPRB, 0.19505103E-05_JPRB, 0.18659691E-05_JPRB, &
  & 0.17725830E-05_JPRB, 0.16715506E-05_JPRB, 0.15660322E-05_JPRB, 0.14574169E-05_JPRB, 0.13485823E-05_JPRB, 0.12436319E-05_JPRB, &
  & 0.11453457E-05_JPRB, 0.10556420E-05_JPRB, 0.97602356E-06_JPRB, 0.90774176E-06_JPRB, 0.85138407E-06_JPRB, 0.80670583E-06_JPRB, &
  & 0.77351399E-06_JPRB, 0.75035177E-06_JPRB, 0.73538087E-06_JPRB, 0.72590143E-06_JPRB, 0.71900735E-06_JPRB, 0.71284290E-06_JPRB, &
  & 0.70560463E-06_JPRB, 0.69824483E-06_JPRB, 0.69381355E-06_JPRB, 0.69717936E-06_JPRB, 0.71235979E-06_JPRB, 0.74041134E-06_JPRB, &
  & 0.77958600E-06_JPRB, 0.82972275E-06_JPRB, 0.88848174E-06_JPRB, 0.95348491E-06_JPRB, 0.10235395E-05_JPRB, 0.10970874E-05_JPRB, &
  & 0.11741282E-05_JPRB, 0.12546515E-05_JPRB, 0.13394749E-05_JPRB, 0.14282997E-05_JPRB, 0.15202708E-05_JPRB, 0.16133347E-05_JPRB, &
  & 0.17062604E-05_JPRB, 0.17989320E-05_JPRB, 0.18897498E-05_JPRB, 0.19767015E-05_JPRB, 0.20586817E-05_JPRB, 0.21345963E-05_JPRB, &
  & 0.22049646E-05_JPRB, 0.22706447E-05_JPRB, 0.23326552E-05_JPRB, 0.23916693E-05_JPRB, 0.24480221E-05_JPRB, 0.25010122E-05_JPRB, &
  & 0.25500474E-05_JPRB, 0.25955410E-05_JPRB, 0.26423970E-05_JPRB, 0.27138965E-05_JPRB /)

RGHG7(:,35, 5) = (/ &
  & 0.22000459E-05_JPRB, 0.21280141E-05_JPRB, 0.20913808E-05_JPRB, 0.20611565E-05_JPRB, 0.20311115E-05_JPRB, 0.19971926E-05_JPRB, &
  & 0.19578008E-05_JPRB, 0.19119373E-05_JPRB, 0.18588082E-05_JPRB, 0.17978439E-05_JPRB, 0.17286721E-05_JPRB, 0.16512352E-05_JPRB, &
  & 0.15659992E-05_JPRB, 0.14735007E-05_JPRB, 0.13751793E-05_JPRB, 0.12735923E-05_JPRB, 0.11713433E-05_JPRB, 0.10705588E-05_JPRB, &
  & 0.97454085E-06_JPRB, 0.88608328E-06_JPRB, 0.80636170E-06_JPRB, 0.73682293E-06_JPRB, 0.67843916E-06_JPRB, 0.63108911E-06_JPRB, &
  & 0.59461229E-06_JPRB, 0.56828890E-06_JPRB, 0.55040380E-06_JPRB, 0.53974350E-06_JPRB, 0.53358457E-06_JPRB, 0.53130532E-06_JPRB, &
  & 0.53047387E-06_JPRB, 0.53177916E-06_JPRB, 0.53655003E-06_JPRB, 0.54716776E-06_JPRB, 0.56579751E-06_JPRB, 0.59339675E-06_JPRB, &
  & 0.62924119E-06_JPRB, 0.67125700E-06_JPRB, 0.71977632E-06_JPRB, 0.77477824E-06_JPRB, 0.83525805E-06_JPRB, 0.90036889E-06_JPRB, &
  & 0.97004784E-06_JPRB, 0.10450856E-05_JPRB, 0.11247924E-05_JPRB, 0.12100271E-05_JPRB, 0.12992979E-05_JPRB, 0.13908679E-05_JPRB, &
  & 0.14841119E-05_JPRB, 0.15778116E-05_JPRB, 0.16707955E-05_JPRB, 0.17605290E-05_JPRB, 0.18452841E-05_JPRB, 0.19241627E-05_JPRB, &
  & 0.19975043E-05_JPRB, 0.20661487E-05_JPRB, 0.21311262E-05_JPRB, 0.21929889E-05_JPRB, 0.22518352E-05_JPRB, 0.23069870E-05_JPRB, &
  & 0.23579637E-05_JPRB, 0.24054723E-05_JPRB, 0.24545845E-05_JPRB, 0.25303950E-05_JPRB /)

RGHG7(:,36, 5) = (/ &
  & 0.19979586E-05_JPRB, 0.19206484E-05_JPRB, 0.18808521E-05_JPRB, 0.18483946E-05_JPRB, 0.18165173E-05_JPRB, 0.17821853E-05_JPRB, &
  & 0.17435158E-05_JPRB, 0.16998470E-05_JPRB, 0.16505533E-05_JPRB, 0.15948592E-05_JPRB, 0.15322348E-05_JPRB, 0.14619840E-05_JPRB, &
  & 0.13843229E-05_JPRB, 0.12999948E-05_JPRB, 0.12104048E-05_JPRB, 0.11159839E-05_JPRB, 0.10197938E-05_JPRB, 0.92424716E-06_JPRB, &
  & 0.83128617E-06_JPRB, 0.74405784E-06_JPRB, 0.66454493E-06_JPRB, 0.59420353E-06_JPRB, 0.53443392E-06_JPRB, 0.48559616E-06_JPRB, &
  & 0.44731109E-06_JPRB, 0.41925884E-06_JPRB, 0.39977428E-06_JPRB, 0.38816958E-06_JPRB, 0.38218386E-06_JPRB, 0.38159831E-06_JPRB, &
  & 0.38455309E-06_JPRB, 0.39054385E-06_JPRB, 0.40055212E-06_JPRB, 0.41493141E-06_JPRB, 0.43439553E-06_JPRB, 0.45914894E-06_JPRB, &
  & 0.49048577E-06_JPRB, 0.52777580E-06_JPRB, 0.56939137E-06_JPRB, 0.61724222E-06_JPRB, 0.67212653E-06_JPRB, 0.73268626E-06_JPRB, &
  & 0.79882415E-06_JPRB, 0.86998551E-06_JPRB, 0.94649539E-06_JPRB, 0.10280833E-05_JPRB, 0.11143417E-05_JPRB, 0.12040464E-05_JPRB, &
  & 0.12961236E-05_JPRB, 0.13896076E-05_JPRB, 0.14828644E-05_JPRB, 0.15732645E-05_JPRB, 0.16586920E-05_JPRB, 0.17382553E-05_JPRB, &
  & 0.18123621E-05_JPRB, 0.18819800E-05_JPRB, 0.19480185E-05_JPRB, 0.20107741E-05_JPRB, 0.20701564E-05_JPRB, 0.21255107E-05_JPRB, &
  & 0.21765049E-05_JPRB, 0.22242587E-05_JPRB, 0.22738814E-05_JPRB, 0.23516602E-05_JPRB /)

RGHG7(:,37, 5) = (/ &
  & 0.18130448E-05_JPRB, 0.17305571E-05_JPRB, 0.16894139E-05_JPRB, 0.16549476E-05_JPRB, 0.16222589E-05_JPRB, 0.15876468E-05_JPRB, &
  & 0.15502545E-05_JPRB, 0.15094171E-05_JPRB, 0.14642209E-05_JPRB, 0.14138096E-05_JPRB, 0.13575076E-05_JPRB, 0.12946067E-05_JPRB, &
  & 0.12250083E-05_JPRB, 0.11485404E-05_JPRB, 0.10666973E-05_JPRB, 0.98015653E-06_JPRB, 0.89032756E-06_JPRB, 0.79969686E-06_JPRB, &
  & 0.71038158E-06_JPRB, 0.62487379E-06_JPRB, 0.54592243E-06_JPRB, 0.47525310E-06_JPRB, 0.41537422E-06_JPRB, 0.36700334E-06_JPRB, &
  & 0.32962842E-06_JPRB, 0.30233454E-06_JPRB, 0.28362720E-06_JPRB, 0.27216646E-06_JPRB, 0.26686621E-06_JPRB, 0.26632046E-06_JPRB, &
  & 0.27081506E-06_JPRB, 0.27818700E-06_JPRB, 0.28960875E-06_JPRB, 0.30474698E-06_JPRB, 0.32347643E-06_JPRB, 0.34606077E-06_JPRB, &
  & 0.37158216E-06_JPRB, 0.40223389E-06_JPRB, 0.43879692E-06_JPRB, 0.48116266E-06_JPRB, 0.53164769E-06_JPRB, 0.59011455E-06_JPRB, &
  & 0.65456669E-06_JPRB, 0.72404038E-06_JPRB, 0.79795871E-06_JPRB, 0.87686584E-06_JPRB, 0.96015981E-06_JPRB, 0.10472440E-05_JPRB, &
  & 0.11375429E-05_JPRB, 0.12299628E-05_JPRB, 0.13222185E-05_JPRB, 0.14118344E-05_JPRB, 0.14961347E-05_JPRB, 0.15746389E-05_JPRB, &
  & 0.16477865E-05_JPRB, 0.17166877E-05_JPRB, 0.17821280E-05_JPRB, 0.18442361E-05_JPRB, 0.19025356E-05_JPRB, 0.19564400E-05_JPRB, &
  & 0.20058490E-05_JPRB, 0.20522473E-05_JPRB, 0.21008425E-05_JPRB, 0.21782819E-05_JPRB /)

RGHG7(:,38, 5) = (/ &
  & 0.16410838E-05_JPRB, 0.15591517E-05_JPRB, 0.15152295E-05_JPRB, 0.14802923E-05_JPRB, 0.14461928E-05_JPRB, 0.14118451E-05_JPRB, &
  & 0.13759707E-05_JPRB, 0.13380165E-05_JPRB, 0.12971716E-05_JPRB, 0.12521982E-05_JPRB, 0.12020801E-05_JPRB, 0.11459507E-05_JPRB, &
  & 0.10837306E-05_JPRB, 0.10153638E-05_JPRB, 0.94137181E-06_JPRB, 0.86234968E-06_JPRB, 0.77950136E-06_JPRB, 0.69429262E-06_JPRB, &
  & 0.60878568E-06_JPRB, 0.52557220E-06_JPRB, 0.44833212E-06_JPRB, 0.37984449E-06_JPRB, 0.32228081E-06_JPRB, 0.27774161E-06_JPRB, &
  & 0.24479266E-06_JPRB, 0.22140659E-06_JPRB, 0.20586548E-06_JPRB, 0.19614826E-06_JPRB, 0.19192609E-06_JPRB, 0.19136851E-06_JPRB, &
  & 0.19526784E-06_JPRB, 0.20228622E-06_JPRB, 0.21234452E-06_JPRB, 0.22564126E-06_JPRB, 0.24169751E-06_JPRB, 0.26033439E-06_JPRB, &
  & 0.28175202E-06_JPRB, 0.30609067E-06_JPRB, 0.33636371E-06_JPRB, 0.37361633E-06_JPRB, 0.41881617E-06_JPRB, 0.47289399E-06_JPRB, &
  & 0.53480721E-06_JPRB, 0.60251188E-06_JPRB, 0.67436667E-06_JPRB, 0.75041618E-06_JPRB, 0.83069358E-06_JPRB, 0.91514403E-06_JPRB, &
  & 0.10033904E-05_JPRB, 0.10941144E-05_JPRB, 0.11848711E-05_JPRB, 0.12725196E-05_JPRB, 0.13546721E-05_JPRB, 0.14307840E-05_JPRB, &
  & 0.15016003E-05_JPRB, 0.15684533E-05_JPRB, 0.16320247E-05_JPRB, 0.16921877E-05_JPRB, 0.17481085E-05_JPRB, 0.17992794E-05_JPRB, &
  & 0.18458295E-05_JPRB, 0.18896519E-05_JPRB, 0.19359127E-05_JPRB, 0.20110833E-05_JPRB /)

RGHG7(:,39, 5) = (/ &
  & 0.14846124E-05_JPRB, 0.14009671E-05_JPRB, 0.13587902E-05_JPRB, 0.13217284E-05_JPRB, 0.12874307E-05_JPRB, 0.12529283E-05_JPRB, &
  & 0.12186530E-05_JPRB, 0.11838092E-05_JPRB, 0.11471648E-05_JPRB, 0.11073581E-05_JPRB, 0.10633117E-05_JPRB, 0.10138965E-05_JPRB, &
  & 0.95873986E-06_JPRB, 0.89770532E-06_JPRB, 0.83139889E-06_JPRB, 0.75989499E-06_JPRB, 0.68388783E-06_JPRB, 0.60463339E-06_JPRB, &
  & 0.52414106E-06_JPRB, 0.44450877E-06_JPRB, 0.37081267E-06_JPRB, 0.30757232E-06_JPRB, 0.25647870E-06_JPRB, 0.21803909E-06_JPRB, &
  & 0.19121322E-06_JPRB, 0.17273418E-06_JPRB, 0.16062759E-06_JPRB, 0.15319966E-06_JPRB, 0.14960365E-06_JPRB, 0.14959255E-06_JPRB, &
  & 0.15220279E-06_JPRB, 0.15834283E-06_JPRB, 0.16667107E-06_JPRB, 0.17767709E-06_JPRB, 0.19074670E-06_JPRB, 0.20582461E-06_JPRB, &
  & 0.22301558E-06_JPRB, 0.24309773E-06_JPRB, 0.26709566E-06_JPRB, 0.29775478E-06_JPRB, 0.33665748E-06_JPRB, 0.38425273E-06_JPRB, &
  & 0.44025933E-06_JPRB, 0.50318391E-06_JPRB, 0.57184315E-06_JPRB, 0.64457453E-06_JPRB, 0.72168763E-06_JPRB, 0.80312270E-06_JPRB, &
  & 0.88889288E-06_JPRB, 0.97771203E-06_JPRB, 0.10664482E-05_JPRB, 0.11517252E-05_JPRB, 0.12310041E-05_JPRB, 0.13038029E-05_JPRB, &
  & 0.13714132E-05_JPRB, 0.14352352E-05_JPRB, 0.14960013E-05_JPRB, 0.15532107E-05_JPRB, 0.16058577E-05_JPRB, 0.16533521E-05_JPRB, &
  & 0.16962052E-05_JPRB, 0.17365796E-05_JPRB, 0.17797527E-05_JPRB, 0.18508326E-05_JPRB /)

RGHG7(:,40, 5) = (/ &
  & 0.13382362E-05_JPRB, 0.12594496E-05_JPRB, 0.12156781E-05_JPRB, 0.11797006E-05_JPRB, 0.11435226E-05_JPRB, 0.11095702E-05_JPRB, &
  & 0.10768224E-05_JPRB, 0.10450069E-05_JPRB, 0.10125847E-05_JPRB, 0.97793452E-06_JPRB, 0.93939093E-06_JPRB, 0.89611461E-06_JPRB, &
  & 0.84771358E-06_JPRB, 0.79378304E-06_JPRB, 0.73470750E-06_JPRB, 0.67065258E-06_JPRB, 0.60180560E-06_JPRB, 0.52883939E-06_JPRB, &
  & 0.45377058E-06_JPRB, 0.38038294E-06_JPRB, 0.31208623E-06_JPRB, 0.25558364E-06_JPRB, 0.21230461E-06_JPRB, 0.18065086E-06_JPRB, &
  & 0.15893518E-06_JPRB, 0.14448123E-06_JPRB, 0.13487259E-06_JPRB, 0.12915702E-06_JPRB, 0.12609951E-06_JPRB, 0.12609966E-06_JPRB, &
  & 0.12832908E-06_JPRB, 0.13314219E-06_JPRB, 0.14044834E-06_JPRB, 0.14967279E-06_JPRB, 0.16066456E-06_JPRB, 0.17322303E-06_JPRB, &
  & 0.18748212E-06_JPRB, 0.20393212E-06_JPRB, 0.22354038E-06_JPRB, 0.24794343E-06_JPRB, 0.27940058E-06_JPRB, 0.31939723E-06_JPRB, &
  & 0.36793037E-06_JPRB, 0.42413660E-06_JPRB, 0.48668659E-06_JPRB, 0.55516654E-06_JPRB, 0.62836568E-06_JPRB, 0.70666698E-06_JPRB, &
  & 0.78976177E-06_JPRB, 0.87642758E-06_JPRB, 0.96305064E-06_JPRB, 0.10456132E-05_JPRB, 0.11216002E-05_JPRB, 0.11907240E-05_JPRB, &
  & 0.12546211E-05_JPRB, 0.13149047E-05_JPRB, 0.13721999E-05_JPRB, 0.14258958E-05_JPRB, 0.14745970E-05_JPRB, 0.15178792E-05_JPRB, &
  & 0.15565578E-05_JPRB, 0.15931010E-05_JPRB, 0.16324659E-05_JPRB, 0.16986963E-05_JPRB /)

RGHG7(:,41, 5) = (/ &
  & 0.12034515E-05_JPRB, 0.11279346E-05_JPRB, 0.10874876E-05_JPRB, 0.10502183E-05_JPRB, 0.10142529E-05_JPRB, 0.98007490E-06_JPRB, &
  & 0.94907995E-06_JPRB, 0.92023089E-06_JPRB, 0.89186210E-06_JPRB, 0.86199179E-06_JPRB, 0.82901113E-06_JPRB, 0.79151766E-06_JPRB, &
  & 0.74919757E-06_JPRB, 0.70183853E-06_JPRB, 0.64959727E-06_JPRB, 0.59246003E-06_JPRB, 0.53068646E-06_JPRB, 0.46470313E-06_JPRB, &
  & 0.39603893E-06_JPRB, 0.32881869E-06_JPRB, 0.26852433E-06_JPRB, 0.21868409E-06_JPRB, 0.18211657E-06_JPRB, 0.15626797E-06_JPRB, &
  & 0.13850358E-06_JPRB, 0.12681053E-06_JPRB, 0.11900563E-06_JPRB, 0.11420563E-06_JPRB, 0.11178543E-06_JPRB, 0.11140371E-06_JPRB, &
  & 0.11358031E-06_JPRB, 0.11741694E-06_JPRB, 0.12380038E-06_JPRB, 0.13198552E-06_JPRB, 0.14144919E-06_JPRB, 0.15236192E-06_JPRB, &
  & 0.16464054E-06_JPRB, 0.17854879E-06_JPRB, 0.19486195E-06_JPRB, 0.21473231E-06_JPRB, 0.23979874E-06_JPRB, 0.27161380E-06_JPRB, &
  & 0.31149543E-06_JPRB, 0.35985758E-06_JPRB, 0.41557303E-06_JPRB, 0.47809766E-06_JPRB, 0.54707351E-06_JPRB, 0.62172842E-06_JPRB, &
  & 0.70185683E-06_JPRB, 0.78620513E-06_JPRB, 0.87066297E-06_JPRB, 0.95044089E-06_JPRB, 0.10230011E-05_JPRB, 0.10882964E-05_JPRB, &
  & 0.11482538E-05_JPRB, 0.12046878E-05_JPRB, 0.12582898E-05_JPRB, 0.13080827E-05_JPRB, 0.13526051E-05_JPRB, 0.13914827E-05_JPRB, &
  & 0.14259172E-05_JPRB, 0.14584648E-05_JPRB, 0.14940756E-05_JPRB, 0.15547723E-05_JPRB /)

RGHG7(:,42, 5) = (/ &
  & 0.10775008E-05_JPRB, 0.10083124E-05_JPRB, 0.96924248E-06_JPRB, 0.93356368E-06_JPRB, 0.89683266E-06_JPRB, 0.86321256E-06_JPRB, &
  & 0.83392433E-06_JPRB, 0.80804512E-06_JPRB, 0.78353037E-06_JPRB, 0.75818434E-06_JPRB, 0.73024029E-06_JPRB, 0.69827507E-06_JPRB, &
  & 0.66166018E-06_JPRB, 0.62026135E-06_JPRB, 0.57431055E-06_JPRB, 0.52375935E-06_JPRB, 0.46859350E-06_JPRB, 0.40944369E-06_JPRB, &
  & 0.34784810E-06_JPRB, 0.28761804E-06_JPRB, 0.23427643E-06_JPRB, 0.19171493E-06_JPRB, 0.16044805E-06_JPRB, 0.13905853E-06_JPRB, &
  & 0.12437953E-06_JPRB, 0.11454665E-06_JPRB, 0.10806261E-06_JPRB, 0.10383205E-06_JPRB, 0.10174494E-06_JPRB, 0.10128866E-06_JPRB, &
  & 0.10297885E-06_JPRB, 0.10653471E-06_JPRB, 0.11185256E-06_JPRB, 0.11942663E-06_JPRB, 0.12779971E-06_JPRB, 0.13750180E-06_JPRB, &
  & 0.14841193E-06_JPRB, 0.16058118E-06_JPRB, 0.17448872E-06_JPRB, 0.19104759E-06_JPRB, 0.21134582E-06_JPRB, 0.23660145E-06_JPRB, &
  & 0.26801874E-06_JPRB, 0.30700303E-06_JPRB, 0.35471822E-06_JPRB, 0.41024620E-06_JPRB, 0.47369878E-06_JPRB, 0.54439334E-06_JPRB, &
  & 0.62128305E-06_JPRB, 0.70301604E-06_JPRB, 0.78532264E-06_JPRB, 0.86223065E-06_JPRB, 0.93128756E-06_JPRB, 0.99272825E-06_JPRB, &
  & 0.10487292E-05_JPRB, 0.11013091E-05_JPRB, 0.11511300E-05_JPRB, 0.11970102E-05_JPRB, 0.12373696E-05_JPRB, 0.12719900E-05_JPRB, &
  & 0.13023978E-05_JPRB, 0.13312002E-05_JPRB, 0.13630579E-05_JPRB, 0.14184565E-05_JPRB /)

RGHG7(:,43, 5) = (/ &
  & 0.95984819E-06_JPRB, 0.89685471E-06_JPRB, 0.86125584E-06_JPRB, 0.82661359E-06_JPRB, 0.79037380E-06_JPRB, 0.75750148E-06_JPRB, &
  & 0.72996318E-06_JPRB, 0.70698809E-06_JPRB, 0.68603077E-06_JPRB, 0.66490662E-06_JPRB, 0.64163453E-06_JPRB, 0.61472042E-06_JPRB, &
  & 0.58332819E-06_JPRB, 0.54730435E-06_JPRB, 0.50696241E-06_JPRB, 0.46236102E-06_JPRB, 0.41361085E-06_JPRB, 0.36102981E-06_JPRB, &
  & 0.30646549E-06_JPRB, 0.25333270E-06_JPRB, 0.20698108E-06_JPRB, 0.17053262E-06_JPRB, 0.14411796E-06_JPRB, 0.12598736E-06_JPRB, &
  & 0.11373936E-06_JPRB, 0.10531306E-06_JPRB, 0.99692521E-07_JPRB, 0.95962712E-07_JPRB, 0.93922282E-07_JPRB, 0.93528676E-07_JPRB, &
  & 0.94685952E-07_JPRB, 0.98014404E-07_JPRB, 0.10254853E-06_JPRB, 0.10948318E-06_JPRB, 0.11714020E-06_JPRB, 0.12589636E-06_JPRB, &
  & 0.13585604E-06_JPRB, 0.14674228E-06_JPRB, 0.15897879E-06_JPRB, 0.17302233E-06_JPRB, 0.18966649E-06_JPRB, 0.20966466E-06_JPRB, &
  & 0.23397772E-06_JPRB, 0.26415495E-06_JPRB, 0.30206883E-06_JPRB, 0.34927206E-06_JPRB, 0.40592587E-06_JPRB, 0.47140043E-06_JPRB, &
  & 0.54459173E-06_JPRB, 0.62350472E-06_JPRB, 0.70320897E-06_JPRB, 0.77736098E-06_JPRB, 0.84281004E-06_JPRB, 0.90045683E-06_JPRB, &
  & 0.95251920E-06_JPRB, 0.10013138E-05_JPRB, 0.10474299E-05_JPRB, 0.10895405E-05_JPRB, 0.11260047E-05_JPRB, 0.11567752E-05_JPRB, &
  & 0.11835765E-05_JPRB, 0.12089878E-05_JPRB, 0.12375632E-05_JPRB, 0.12880173E-05_JPRB /)

RGHG7(:,44, 5) = (/ &
  & 0.84996617E-06_JPRB, 0.79396892E-06_JPRB, 0.76097274E-06_JPRB, 0.72857142E-06_JPRB, 0.69345049E-06_JPRB, 0.66145668E-06_JPRB, &
  & 0.63599208E-06_JPRB, 0.61567840E-06_JPRB, 0.59792887E-06_JPRB, 0.58047522E-06_JPRB, 0.56146501E-06_JPRB, 0.53910372E-06_JPRB, &
  & 0.51238862E-06_JPRB, 0.48112145E-06_JPRB, 0.44566571E-06_JPRB, 0.40644008E-06_JPRB, 0.36344440E-06_JPRB, 0.31738043E-06_JPRB, &
  & 0.26960262E-06_JPRB, 0.22391012E-06_JPRB, 0.18410360E-06_JPRB, 0.15332336E-06_JPRB, 0.13103116E-06_JPRB, 0.11562508E-06_JPRB, &
  & 0.10518740E-06_JPRB, 0.97908369E-07_JPRB, 0.92871439E-07_JPRB, 0.89514117E-07_JPRB, 0.87476479E-07_JPRB, 0.87026031E-07_JPRB, &
  & 0.87848726E-07_JPRB, 0.90775501E-07_JPRB, 0.94823235E-07_JPRB, 0.10107843E-06_JPRB, 0.10821325E-06_JPRB, 0.11624917E-06_JPRB, &
  & 0.12549999E-06_JPRB, 0.13551073E-06_JPRB, 0.14647479E-06_JPRB, 0.15869303E-06_JPRB, 0.17245669E-06_JPRB, 0.18817866E-06_JPRB, &
  & 0.20657758E-06_JPRB, 0.22892432E-06_JPRB, 0.25744436E-06_JPRB, 0.29474637E-06_JPRB, 0.34244565E-06_JPRB, 0.40112377E-06_JPRB, &
  & 0.46959178E-06_JPRB, 0.54516784E-06_JPRB, 0.62198785E-06_JPRB, 0.69282794E-06_JPRB, 0.75477249E-06_JPRB, 0.80840852E-06_JPRB, &
  & 0.85670371E-06_JPRB, 0.90177963E-06_JPRB, 0.94432403E-06_JPRB, 0.98293594E-06_JPRB, 0.10158816E-05_JPRB, 0.10433350E-05_JPRB, &
  & 0.10669693E-05_JPRB, 0.10895617E-05_JPRB, 0.11151304E-05_JPRB, 0.11613591E-05_JPRB /)

RGHG7(:,45, 5) = (/ &
  & 0.74851863E-06_JPRB, 0.69778190E-06_JPRB, 0.66888811E-06_JPRB, 0.63820062E-06_JPRB, 0.60463998E-06_JPRB, 0.57413541E-06_JPRB, &
  & 0.55060019E-06_JPRB, 0.53272419E-06_JPRB, 0.51777351E-06_JPRB, 0.50347455E-06_JPRB, 0.48794396E-06_JPRB, 0.46965718E-06_JPRB, &
  & 0.44708983E-06_JPRB, 0.41994753E-06_JPRB, 0.38878326E-06_JPRB, 0.35411307E-06_JPRB, 0.31661148E-06_JPRB, 0.27665996E-06_JPRB, &
  & 0.23619648E-06_JPRB, 0.19765055E-06_JPRB, 0.16477344E-06_JPRB, 0.13892659E-06_JPRB, 0.12027051E-06_JPRB, 0.10712677E-06_JPRB, &
  & 0.98084655E-07_JPRB, 0.91708692E-07_JPRB, 0.87119197E-07_JPRB, 0.83974648E-07_JPRB, 0.81960223E-07_JPRB, 0.81352518E-07_JPRB, &
  & 0.81942133E-07_JPRB, 0.84431747E-07_JPRB, 0.88095774E-07_JPRB, 0.93724033E-07_JPRB, 0.10043760E-06_JPRB, 0.10792578E-06_JPRB, &
  & 0.11667758E-06_JPRB, 0.12603878E-06_JPRB, 0.13613162E-06_JPRB, 0.14691241E-06_JPRB, 0.15850301E-06_JPRB, 0.17092732E-06_JPRB, &
  & 0.18453112E-06_JPRB, 0.20049869E-06_JPRB, 0.22063506E-06_JPRB, 0.24787289E-06_JPRB, 0.28523561E-06_JPRB, 0.33462103E-06_JPRB, &
  & 0.39661677E-06_JPRB, 0.46743011E-06_JPRB, 0.54018500E-06_JPRB, 0.60764211E-06_JPRB, 0.66535154E-06_JPRB, 0.71525682E-06_JPRB, &
  & 0.75950055E-06_JPRB, 0.80097647E-06_JPRB, 0.84009963E-06_JPRB, 0.87543287E-06_JPRB, 0.90532814E-06_JPRB, 0.92983629E-06_JPRB, &
  & 0.95092082E-06_JPRB, 0.97096733E-06_JPRB, 0.99408999E-06_JPRB, 0.10364672E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART10',0,ZHOOK_HANDLE)



RGHG7(:,46, 5) = (/ &
  & 0.65443498E-06_JPRB, 0.61025042E-06_JPRB, 0.58275793E-06_JPRB, 0.55533525E-06_JPRB, 0.52314005E-06_JPRB, 0.49399267E-06_JPRB, &
  & 0.47250643E-06_JPRB, 0.45668065E-06_JPRB, 0.44402566E-06_JPRB, 0.43219760E-06_JPRB, 0.41969409E-06_JPRB, 0.40451687E-06_JPRB, &
  & 0.38563010E-06_JPRB, 0.36205648E-06_JPRB, 0.33448856E-06_JPRB, 0.30407162E-06_JPRB, 0.27157554E-06_JPRB, 0.23814893E-06_JPRB, &
  & 0.20501886E-06_JPRB, 0.17447520E-06_JPRB, 0.14788692E-06_JPRB, 0.12687957E-06_JPRB, 0.11120232E-06_JPRB, 0.10001124E-06_JPRB, &
  & 0.92079013E-07_JPRB, 0.86380190E-07_JPRB, 0.82152994E-07_JPRB, 0.79116326E-07_JPRB, 0.77106726E-07_JPRB, 0.76308041E-07_JPRB, &
  & 0.76695045E-07_JPRB, 0.78780225E-07_JPRB, 0.82056914E-07_JPRB, 0.87204413E-07_JPRB, 0.93493057E-07_JPRB, 0.10060671E-06_JPRB, &
  & 0.10898624E-06_JPRB, 0.11792373E-06_JPRB, 0.12732109E-06_JPRB, 0.13707583E-06_JPRB, 0.14695783E-06_JPRB, 0.15685278E-06_JPRB, &
  & 0.16694776E-06_JPRB, 0.17790053E-06_JPRB, 0.19148074E-06_JPRB, 0.21008829E-06_JPRB, 0.23687092E-06_JPRB, 0.27554307E-06_JPRB, &
  & 0.32756935E-06_JPRB, 0.39119320E-06_JPRB, 0.45889465E-06_JPRB, 0.52116656E-06_JPRB, 0.57512955E-06_JPRB, 0.62025020E-06_JPRB, &
  & 0.66088927E-06_JPRB, 0.69858731E-06_JPRB, 0.73444465E-06_JPRB, 0.76676298E-06_JPRB, 0.79384978E-06_JPRB, 0.81593930E-06_JPRB, &
  & 0.83470820E-06_JPRB, 0.85272160E-06_JPRB, 0.87354454E-06_JPRB, 0.91254475E-06_JPRB /)

RGHG7(:,47, 5) = (/ &
  & 0.56860000E-06_JPRB, 0.52817308E-06_JPRB, 0.50448278E-06_JPRB, 0.47775580E-06_JPRB, 0.44790451E-06_JPRB, 0.42006249E-06_JPRB, &
  & 0.40010181E-06_JPRB, 0.38607101E-06_JPRB, 0.37513104E-06_JPRB, 0.36531088E-06_JPRB, 0.35487466E-06_JPRB, 0.34254981E-06_JPRB, &
  & 0.32642691E-06_JPRB, 0.30602683E-06_JPRB, 0.28175364E-06_JPRB, 0.25525159E-06_JPRB, 0.22810990E-06_JPRB, 0.20166092E-06_JPRB, &
  & 0.17674316E-06_JPRB, 0.15378662E-06_JPRB, 0.13356780E-06_JPRB, 0.11664224E-06_JPRB, 0.10360811E-06_JPRB, 0.93971636E-07_JPRB, &
  & 0.86944205E-07_JPRB, 0.81746201E-07_JPRB, 0.77795086E-07_JPRB, 0.74808966E-07_JPRB, 0.72779542E-07_JPRB, 0.71770266E-07_JPRB, &
  & 0.71985731E-07_JPRB, 0.73674130E-07_JPRB, 0.76595818E-07_JPRB, 0.81360163E-07_JPRB, 0.87227178E-07_JPRB, 0.94098311E-07_JPRB, &
  & 0.10221785E-06_JPRB, 0.11082587E-06_JPRB, 0.11975676E-06_JPRB, 0.12866211E-06_JPRB, 0.13726360E-06_JPRB, 0.14530455E-06_JPRB, &
  & 0.15274200E-06_JPRB, 0.16028423E-06_JPRB, 0.16908331E-06_JPRB, 0.18119238E-06_JPRB, 0.19934514E-06_JPRB, 0.22666335E-06_JPRB, &
  & 0.26669744E-06_JPRB, 0.31959226E-06_JPRB, 0.37889160E-06_JPRB, 0.43573837E-06_JPRB, 0.48387363E-06_JPRB, 0.52507676E-06_JPRB, &
  & 0.56115084E-06_JPRB, 0.59554043E-06_JPRB, 0.62814490E-06_JPRB, 0.65766966E-06_JPRB, 0.68226547E-06_JPRB, 0.70215702E-06_JPRB, &
  & 0.71899689E-06_JPRB, 0.73518311E-06_JPRB, 0.75404648E-06_JPRB, 0.79001580E-06_JPRB /)

RGHG7(:,48, 5) = (/ &
  & 0.49024908E-06_JPRB, 0.45345706E-06_JPRB, 0.43056517E-06_JPRB, 0.40640191E-06_JPRB, 0.37696708E-06_JPRB, 0.35051687E-06_JPRB, &
  & 0.33163178E-06_JPRB, 0.31890210E-06_JPRB, 0.30931659E-06_JPRB, 0.30094941E-06_JPRB, 0.29232376E-06_JPRB, 0.28195595E-06_JPRB, &
  & 0.26849347E-06_JPRB, 0.25087206E-06_JPRB, 0.23014388E-06_JPRB, 0.20827456E-06_JPRB, 0.18760987E-06_JPRB, 0.16881610E-06_JPRB, &
  & 0.15197644E-06_JPRB, 0.13620746E-06_JPRB, 0.12138155E-06_JPRB, 0.10811341E-06_JPRB, 0.97205934E-07_JPRB, 0.88826106E-07_JPRB, &
  & 0.82516586E-07_JPRB, 0.77692150E-07_JPRB, 0.73926650E-07_JPRB, 0.70969257E-07_JPRB, 0.68881988E-07_JPRB, 0.67679224E-07_JPRB, &
  & 0.67733417E-07_JPRB, 0.68998538E-07_JPRB, 0.71681214E-07_JPRB, 0.76056367E-07_JPRB, 0.81545082E-07_JPRB, 0.88272557E-07_JPRB, &
  & 0.96170503E-07_JPRB, 0.10455474E-06_JPRB, 0.11309810E-06_JPRB, 0.12140055E-06_JPRB, 0.12900871E-06_JPRB, 0.13562864E-06_JPRB, &
  & 0.14127674E-06_JPRB, 0.14638195E-06_JPRB, 0.15212015E-06_JPRB, 0.15989856E-06_JPRB, 0.17158905E-06_JPRB, 0.18977958E-06_JPRB, &
  & 0.21757150E-06_JPRB, 0.25675217E-06_JPRB, 0.30448254E-06_JPRB, 0.35196788E-06_JPRB, 0.39386327E-06_JPRB, 0.42940320E-06_JPRB, &
  & 0.46185050E-06_JPRB, 0.49243761E-06_JPRB, 0.52228160E-06_JPRB, 0.54923834E-06_JPRB, 0.57161856E-06_JPRB, 0.58958807E-06_JPRB, &
  & 0.60477919E-06_JPRB, 0.61940204E-06_JPRB, 0.63663703E-06_JPRB, 0.66991686E-06_JPRB /)

RGHG7(:,49, 5) = (/ &
  & 0.41754382E-06_JPRB, 0.38386096E-06_JPRB, 0.36196150E-06_JPRB, 0.33825802E-06_JPRB, 0.30968926E-06_JPRB, 0.28375393E-06_JPRB, &
  & 0.26583189E-06_JPRB, 0.25406774E-06_JPRB, 0.24566697E-06_JPRB, 0.23854642E-06_JPRB, 0.23149987E-06_JPRB, 0.22311215E-06_JPRB, &
  & 0.21223251E-06_JPRB, 0.19825222E-06_JPRB, 0.18218503E-06_JPRB, 0.16682112E-06_JPRB, 0.15323624E-06_JPRB, 0.14198410E-06_JPRB, &
  & 0.13177927E-06_JPRB, 0.12183290E-06_JPRB, 0.11133677E-06_JPRB, 0.10103179E-06_JPRB, 0.91860954E-07_JPRB, 0.84445759E-07_JPRB, &
  & 0.78664911E-07_JPRB, 0.74125381E-07_JPRB, 0.70465553E-07_JPRB, 0.67530536E-07_JPRB, 0.65339975E-07_JPRB, 0.64004638E-07_JPRB, &
  & 0.63819499E-07_JPRB, 0.64762169E-07_JPRB, 0.67239831E-07_JPRB, 0.71187408E-07_JPRB, 0.76406337E-07_JPRB, 0.82991797E-07_JPRB, &
  & 0.90700183E-07_JPRB, 0.98910753E-07_JPRB, 0.10718509E-06_JPRB, 0.11499858E-06_JPRB, 0.12186432E-06_JPRB, 0.12746501E-06_JPRB, &
  & 0.13175639E-06_JPRB, 0.13536264E-06_JPRB, 0.13909367E-06_JPRB, 0.14418093E-06_JPRB, 0.15172758E-06_JPRB, 0.16351574E-06_JPRB, &
  & 0.18148263E-06_JPRB, 0.20767169E-06_JPRB, 0.24059881E-06_JPRB, 0.27548472E-06_JPRB, 0.30821016E-06_JPRB, 0.33699362E-06_JPRB, &
  & 0.36431814E-06_JPRB, 0.39133772E-06_JPRB, 0.41815474E-06_JPRB, 0.44276175E-06_JPRB, 0.46315290E-06_JPRB, 0.47942706E-06_JPRB, &
  & 0.49320755E-06_JPRB, 0.50649044E-06_JPRB, 0.52243041E-06_JPRB, 0.55362767E-06_JPRB /)

RGHG7(:,50, 5) = (/ &
  & 0.35216578E-06_JPRB, 0.31790327E-06_JPRB, 0.29773418E-06_JPRB, 0.27363149E-06_JPRB, 0.24618038E-06_JPRB, 0.22137121E-06_JPRB, &
  & 0.20503344E-06_JPRB, 0.19494155E-06_JPRB, 0.18792670E-06_JPRB, 0.18253964E-06_JPRB, 0.17712877E-06_JPRB, 0.17126936E-06_JPRB, &
  & 0.16364453E-06_JPRB, 0.15429724E-06_JPRB, 0.14445042E-06_JPRB, 0.13537797E-06_JPRB, 0.12814044E-06_JPRB, 0.12203040E-06_JPRB, &
  & 0.11651674E-06_JPRB, 0.11034698E-06_JPRB, 0.10322891E-06_JPRB, 0.95194494E-07_JPRB, 0.87407429E-07_JPRB, 0.80709043E-07_JPRB, &
  & 0.75296725E-07_JPRB, 0.70942733E-07_JPRB, 0.67354485E-07_JPRB, 0.64412944E-07_JPRB, 0.62122055E-07_JPRB, 0.60672598E-07_JPRB, &
  & 0.60213026E-07_JPRB, 0.60970883E-07_JPRB, 0.63151774E-07_JPRB, 0.66731495E-07_JPRB, 0.71740594E-07_JPRB, 0.78175994E-07_JPRB, &
  & 0.85698076E-07_JPRB, 0.93781793E-07_JPRB, 0.10183017E-06_JPRB, 0.10929377E-06_JPRB, 0.11559675E-06_JPRB, 0.12038484E-06_JPRB, &
  & 0.12377728E-06_JPRB, 0.12628955E-06_JPRB, 0.12889316E-06_JPRB, 0.13229929E-06_JPRB, 0.13747072E-06_JPRB, 0.14517767E-06_JPRB, &
  & 0.15679784E-06_JPRB, 0.17297606E-06_JPRB, 0.19311624E-06_JPRB, 0.21532720E-06_JPRB, 0.23569886E-06_JPRB, 0.25618837E-06_JPRB, &
  & 0.27610642E-06_JPRB, 0.29754568E-06_JPRB, 0.31986031E-06_JPRB, 0.34132518E-06_JPRB, 0.35914542E-06_JPRB, 0.37366488E-06_JPRB, &
  & 0.38588641E-06_JPRB, 0.39804050E-06_JPRB, 0.41273609E-06_JPRB, 0.44266557E-06_JPRB /)

RGHG7(:,51, 5) = (/ &
  & 0.29054428E-06_JPRB, 0.25977039E-06_JPRB, 0.23753768E-06_JPRB, 0.21642268E-06_JPRB, 0.19022144E-06_JPRB, 0.16940442E-06_JPRB, &
  & 0.15660954E-06_JPRB, 0.14912447E-06_JPRB, 0.14447640E-06_JPRB, 0.14070542E-06_JPRB, 0.13759058E-06_JPRB, 0.13388755E-06_JPRB, &
  & 0.12969777E-06_JPRB, 0.12463408E-06_JPRB, 0.11938347E-06_JPRB, 0.11491894E-06_JPRB, 0.11123257E-06_JPRB, 0.10822079E-06_JPRB, &
  & 0.10510593E-06_JPRB, 0.10148314E-06_JPRB, 0.96541243E-07_JPRB, 0.90375934E-07_JPRB, 0.83680035E-07_JPRB, 0.77499614E-07_JPRB, &
  & 0.72325776E-07_JPRB, 0.68066669E-07_JPRB, 0.64523533E-07_JPRB, 0.61547986E-07_JPRB, 0.59207061E-07_JPRB, 0.57594576E-07_JPRB, &
  & 0.56966886E-07_JPRB, 0.57518097E-07_JPRB, 0.59377960E-07_JPRB, 0.62683611E-07_JPRB, 0.67488713E-07_JPRB, 0.73739500E-07_JPRB, &
  & 0.81125776E-07_JPRB, 0.89033733E-07_JPRB, 0.96933668E-07_JPRB, 0.10412739E-06_JPRB, 0.10997372E-06_JPRB, 0.11415985E-06_JPRB, &
  & 0.11681114E-06_JPRB, 0.11869575E-06_JPRB, 0.12053177E-06_JPRB, 0.12306350E-06_JPRB, 0.12673044E-06_JPRB, 0.13223796E-06_JPRB, &
  & 0.13984008E-06_JPRB, 0.14998527E-06_JPRB, 0.16190425E-06_JPRB, 0.17372167E-06_JPRB, 0.18546361E-06_JPRB, 0.19648606E-06_JPRB, &
  & 0.20852512E-06_JPRB, 0.22178563E-06_JPRB, 0.23725036E-06_JPRB, 0.25278266E-06_JPRB, 0.26676369E-06_JPRB, 0.27808417E-06_JPRB, &
  & 0.28836681E-06_JPRB, 0.29844611E-06_JPRB, 0.31206264E-06_JPRB, 0.33956016E-06_JPRB /)

RGHG7(:,52, 5) = (/ &
  & 0.23792339E-06_JPRB, 0.20620558E-06_JPRB, 0.18902236E-06_JPRB, 0.16815987E-06_JPRB, 0.14837789E-06_JPRB, 0.13286744E-06_JPRB, &
  & 0.12446732E-06_JPRB, 0.11995790E-06_JPRB, 0.11704731E-06_JPRB, 0.11511977E-06_JPRB, 0.11316926E-06_JPRB, 0.11142356E-06_JPRB, &
  & 0.10917010E-06_JPRB, 0.10664670E-06_JPRB, 0.10410859E-06_JPRB, 0.10187193E-06_JPRB, 0.10009398E-06_JPRB, 0.98446755E-07_JPRB, &
  & 0.96744166E-07_JPRB, 0.94406509E-07_JPRB, 0.91053209E-07_JPRB, 0.86273921E-07_JPRB, 0.80482977E-07_JPRB, 0.74709220E-07_JPRB, &
  & 0.69660267E-07_JPRB, 0.65448639E-07_JPRB, 0.61901439E-07_JPRB, 0.58927139E-07_JPRB, 0.56503627E-07_JPRB, 0.54800839E-07_JPRB, &
  & 0.54020528E-07_JPRB, 0.54343580E-07_JPRB, 0.55951830E-07_JPRB, 0.59011843E-07_JPRB, 0.63591266E-07_JPRB, 0.69655421E-07_JPRB, &
  & 0.76847606E-07_JPRB, 0.84650374E-07_JPRB, 0.92417480E-07_JPRB, 0.99370475E-07_JPRB, 0.10484484E-06_JPRB, 0.10849529E-06_JPRB, &
  & 0.11065315E-06_JPRB, 0.11205015E-06_JPRB, 0.11349231E-06_JPRB, 0.11547327E-06_JPRB, 0.11841554E-06_JPRB, 0.12248280E-06_JPRB, &
  & 0.12800450E-06_JPRB, 0.13461641E-06_JPRB, 0.14156329E-06_JPRB, 0.14833027E-06_JPRB, 0.15395482E-06_JPRB, 0.15989494E-06_JPRB, &
  & 0.16542353E-06_JPRB, 0.17245003E-06_JPRB, 0.18058414E-06_JPRB, 0.18976024E-06_JPRB, 0.19806998E-06_JPRB, 0.20558507E-06_JPRB, &
  & 0.21219991E-06_JPRB, 0.21973359E-06_JPRB, 0.22963660E-06_JPRB, 0.25316211E-06_JPRB /)

RGHG7(:,53, 5) = (/ &
  & 0.19280432E-06_JPRB, 0.16654256E-06_JPRB, 0.14953537E-06_JPRB, 0.13525259E-06_JPRB, 0.12003213E-06_JPRB, 0.11028219E-06_JPRB, &
  & 0.10517662E-06_JPRB, 0.10255640E-06_JPRB, 0.10101314E-06_JPRB, 0.99798577E-07_JPRB, 0.98925042E-07_JPRB, 0.97866817E-07_JPRB, &
  & 0.96819079E-07_JPRB, 0.95556850E-07_JPRB, 0.94296936E-07_JPRB, 0.93221672E-07_JPRB, 0.92276586E-07_JPRB, 0.91407927E-07_JPRB, &
  & 0.90300155E-07_JPRB, 0.88785704E-07_JPRB, 0.86387210E-07_JPRB, 0.82649287E-07_JPRB, 0.77661447E-07_JPRB, 0.72197686E-07_JPRB, &
  & 0.67232271E-07_JPRB, 0.63027137E-07_JPRB, 0.59470718E-07_JPRB, 0.56486563E-07_JPRB, 0.54013476E-07_JPRB, 0.52253345E-07_JPRB, &
  & 0.51322225E-07_JPRB, 0.51470245E-07_JPRB, 0.52863857E-07_JPRB, 0.55680083E-07_JPRB, 0.60018614E-07_JPRB, 0.65867425E-07_JPRB, &
  & 0.72924578E-07_JPRB, 0.80621561E-07_JPRB, 0.88203024E-07_JPRB, 0.94920665E-07_JPRB, 0.10004300E-06_JPRB, 0.10328829E-06_JPRB, &
  & 0.10501944E-06_JPRB, 0.10613463E-06_JPRB, 0.10731380E-06_JPRB, 0.10903086E-06_JPRB, 0.11149659E-06_JPRB, 0.11495476E-06_JPRB, &
  & 0.11912309E-06_JPRB, 0.12383342E-06_JPRB, 0.12839666E-06_JPRB, 0.13208358E-06_JPRB, 0.13550469E-06_JPRB, 0.13823323E-06_JPRB, &
  & 0.14119307E-06_JPRB, 0.14455270E-06_JPRB, 0.14861912E-06_JPRB, 0.15334800E-06_JPRB, 0.15787492E-06_JPRB, 0.16170360E-06_JPRB, &
  & 0.16549382E-06_JPRB, 0.16946643E-06_JPRB, 0.17551353E-06_JPRB, 0.19117324E-06_JPRB /)

RGHG7(:,54, 5) = (/ &
  & 0.15649208E-06_JPRB, 0.13509367E-06_JPRB, 0.12372220E-06_JPRB, 0.11237505E-06_JPRB, 0.10259141E-06_JPRB, 0.96339960E-07_JPRB, &
  & 0.93374545E-07_JPRB, 0.91862340E-07_JPRB, 0.90969792E-07_JPRB, 0.90350063E-07_JPRB, 0.89774950E-07_JPRB, 0.89310518E-07_JPRB, &
  & 0.88723780E-07_JPRB, 0.88116465E-07_JPRB, 0.87511864E-07_JPRB, 0.86974339E-07_JPRB, 0.86491703E-07_JPRB, 0.85946240E-07_JPRB, &
  & 0.85255479E-07_JPRB, 0.84147267E-07_JPRB, 0.82332036E-07_JPRB, 0.79374288E-07_JPRB, 0.74986254E-07_JPRB, 0.69868449E-07_JPRB, &
  & 0.64974579E-07_JPRB, 0.60767192E-07_JPRB, 0.57228004E-07_JPRB, 0.54189464E-07_JPRB, 0.51739253E-07_JPRB, 0.49898667E-07_JPRB, &
  & 0.48874078E-07_JPRB, 0.48887770E-07_JPRB, 0.50089351E-07_JPRB, 0.52662052E-07_JPRB, 0.56747258E-07_JPRB, 0.62382654E-07_JPRB, &
  & 0.69281135E-07_JPRB, 0.76812420E-07_JPRB, 0.84241989E-07_JPRB, 0.90697185E-07_JPRB, 0.95486612E-07_JPRB, 0.98367721E-07_JPRB, &
  & 0.99850730E-07_JPRB, 0.10073285E-06_JPRB, 0.10176159E-06_JPRB, 0.10331456E-06_JPRB, 0.10562897E-06_JPRB, 0.10860532E-06_JPRB, &
  & 0.11224976E-06_JPRB, 0.11585030E-06_JPRB, 0.11902806E-06_JPRB, 0.12163787E-06_JPRB, 0.12357317E-06_JPRB, 0.12523974E-06_JPRB, &
  & 0.12686867E-06_JPRB, 0.12860927E-06_JPRB, 0.13099337E-06_JPRB, 0.13360952E-06_JPRB, 0.13596832E-06_JPRB, 0.13818374E-06_JPRB, &
  & 0.13994467E-06_JPRB, 0.14190728E-06_JPRB, 0.14442523E-06_JPRB, 0.15062200E-06_JPRB /)

RGHG7(:,55, 5) = (/ &
  & 0.13176759E-06_JPRB, 0.11391391E-06_JPRB, 0.10537773E-06_JPRB, 0.97742365E-07_JPRB, 0.91283674E-07_JPRB, 0.87440476E-07_JPRB, &
  & 0.85657170E-07_JPRB, 0.84756280E-07_JPRB, 0.84229008E-07_JPRB, 0.83858318E-07_JPRB, 0.83562348E-07_JPRB, 0.83255031E-07_JPRB, &
  & 0.82976861E-07_JPRB, 0.82666880E-07_JPRB, 0.82383139E-07_JPRB, 0.82137731E-07_JPRB, 0.81886135E-07_JPRB, 0.81567755E-07_JPRB, &
  & 0.81061366E-07_JPRB, 0.80222598E-07_JPRB, 0.78789050E-07_JPRB, 0.76266893E-07_JPRB, 0.72408376E-07_JPRB, 0.67576210E-07_JPRB, &
  & 0.62821819E-07_JPRB, 0.58647299E-07_JPRB, 0.55099250E-07_JPRB, 0.52090542E-07_JPRB, 0.49601891E-07_JPRB, 0.47728914E-07_JPRB, &
  & 0.46655632E-07_JPRB, 0.46564896E-07_JPRB, 0.47601425E-07_JPRB, 0.49940976E-07_JPRB, 0.53761767E-07_JPRB, 0.59156783E-07_JPRB, &
  & 0.65832523E-07_JPRB, 0.73199985E-07_JPRB, 0.80469007E-07_JPRB, 0.86652591E-07_JPRB, 0.91105321E-07_JPRB, 0.93716302E-07_JPRB, &
  & 0.94973792E-07_JPRB, 0.95736034E-07_JPRB, 0.96666923E-07_JPRB, 0.98147630E-07_JPRB, 0.10033320E-06_JPRB, 0.10324833E-06_JPRB, &
  & 0.10641688E-06_JPRB, 0.10955159E-06_JPRB, 0.11211637E-06_JPRB, 0.11393296E-06_JPRB, 0.11539053E-06_JPRB, 0.11646240E-06_JPRB, &
  & 0.11754184E-06_JPRB, 0.11881018E-06_JPRB, 0.12030729E-06_JPRB, 0.12189446E-06_JPRB, 0.12354418E-06_JPRB, 0.12473794E-06_JPRB, &
  & 0.12586901E-06_JPRB, 0.12703009E-06_JPRB, 0.12824997E-06_JPRB, 0.13075177E-06_JPRB /)

RGHG7(:,56, 5) = (/ &
  & 0.11041361E-06_JPRB, 0.99064998E-07_JPRB, 0.92714082E-07_JPRB, 0.87963691E-07_JPRB, 0.83634887E-07_JPRB, 0.81248288E-07_JPRB, &
  & 0.80138165E-07_JPRB, 0.79607013E-07_JPRB, 0.79270066E-07_JPRB, 0.79033128E-07_JPRB, 0.78844316E-07_JPRB, 0.78680301E-07_JPRB, &
  & 0.78507753E-07_JPRB, 0.78354077E-07_JPRB, 0.78230293E-07_JPRB, 0.78131222E-07_JPRB, 0.78026012E-07_JPRB, 0.77831508E-07_JPRB, &
  & 0.77483314E-07_JPRB, 0.76808909E-07_JPRB, 0.75551981E-07_JPRB, 0.73351977E-07_JPRB, 0.69827912E-07_JPRB, 0.65294614E-07_JPRB, &
  & 0.60713454E-07_JPRB, 0.56621946E-07_JPRB, 0.53095846E-07_JPRB, 0.50086019E-07_JPRB, 0.47593417E-07_JPRB, 0.45722150E-07_JPRB, &
  & 0.44627722E-07_JPRB, 0.44470372E-07_JPRB, 0.45368179E-07_JPRB, 0.47489490E-07_JPRB, 0.51045038E-07_JPRB, 0.56173864E-07_JPRB, &
  & 0.62650557E-07_JPRB, 0.69805196E-07_JPRB, 0.76840337E-07_JPRB, 0.82735383E-07_JPRB, 0.86894630E-07_JPRB, 0.89268170E-07_JPRB, &
  & 0.90406104E-07_JPRB, 0.91076707E-07_JPRB, 0.91937558E-07_JPRB, 0.93376002E-07_JPRB, 0.95539725E-07_JPRB, 0.98327540E-07_JPRB, &
  & 0.10143838E-06_JPRB, 0.10428816E-06_JPRB, 0.10645690E-06_JPRB, 0.10809322E-06_JPRB, 0.10919464E-06_JPRB, 0.11011399E-06_JPRB, &
  & 0.11103331E-06_JPRB, 0.11192285E-06_JPRB, 0.11301184E-06_JPRB, 0.11430311E-06_JPRB, 0.11542225E-06_JPRB, 0.11636313E-06_JPRB, &
  & 0.11723131E-06_JPRB, 0.11803946E-06_JPRB, 0.11933867E-06_JPRB, 0.12255731E-06_JPRB /)

RGHG7(:,57, 5) = (/ &
  & 0.95538887E-07_JPRB, 0.87367901E-07_JPRB, 0.84385704E-07_JPRB, 0.80757765E-07_JPRB, 0.78240774E-07_JPRB, 0.76675462E-07_JPRB, &
  & 0.75950396E-07_JPRB, 0.75577027E-07_JPRB, 0.75371922E-07_JPRB, 0.75200596E-07_JPRB, 0.75060683E-07_JPRB, 0.74934078E-07_JPRB, &
  & 0.74824079E-07_JPRB, 0.74727893E-07_JPRB, 0.74673878E-07_JPRB, 0.74652895E-07_JPRB, 0.74634094E-07_JPRB, 0.74544126E-07_JPRB, &
  & 0.74292728E-07_JPRB, 0.73723406E-07_JPRB, 0.72618420E-07_JPRB, 0.70557569E-07_JPRB, 0.67236627E-07_JPRB, 0.63010688E-07_JPRB, &
  & 0.58631549E-07_JPRB, 0.54645753E-07_JPRB, 0.51158509E-07_JPRB, 0.48165123E-07_JPRB, 0.45696570E-07_JPRB, 0.43843752E-07_JPRB, &
  & 0.42758593E-07_JPRB, 0.42567802E-07_JPRB, 0.43356078E-07_JPRB, 0.45279510E-07_JPRB, 0.48570289E-07_JPRB, 0.53432256E-07_JPRB, &
  & 0.59658205E-07_JPRB, 0.66585585E-07_JPRB, 0.73328032E-07_JPRB, 0.78925709E-07_JPRB, 0.82835065E-07_JPRB, 0.85029214E-07_JPRB, &
  & 0.86080277E-07_JPRB, 0.86723972E-07_JPRB, 0.87546091E-07_JPRB, 0.88953833E-07_JPRB, 0.91049927E-07_JPRB, 0.93835219E-07_JPRB, &
  & 0.96851984E-07_JPRB, 0.99601309E-07_JPRB, 0.10174490E-06_JPRB, 0.10314376E-06_JPRB, 0.10420456E-06_JPRB, 0.10504155E-06_JPRB, &
  & 0.10577283E-06_JPRB, 0.10660283E-06_JPRB, 0.10765351E-06_JPRB, 0.10870710E-06_JPRB, 0.10968080E-06_JPRB, 0.11044426E-06_JPRB, &
  & 0.11108840E-06_JPRB, 0.11171161E-06_JPRB, 0.11232014E-06_JPRB, 0.11372465E-06_JPRB /)

RGHG7(:,58, 5) = (/ &
  & 0.86200508E-07_JPRB, 0.80800021E-07_JPRB, 0.77683815E-07_JPRB, 0.75872059E-07_JPRB, 0.73994897E-07_JPRB, 0.73002504E-07_JPRB, &
  & 0.72517928E-07_JPRB, 0.72258445E-07_JPRB, 0.72079239E-07_JPRB, 0.71956393E-07_JPRB, 0.71841527E-07_JPRB, 0.71734021E-07_JPRB, &
  & 0.71632520E-07_JPRB, 0.71549472E-07_JPRB, 0.71508744E-07_JPRB, 0.71516737E-07_JPRB, 0.71551895E-07_JPRB, 0.71538047E-07_JPRB, &
  & 0.71375453E-07_JPRB, 0.70899027E-07_JPRB, 0.69843878E-07_JPRB, 0.67859247E-07_JPRB, 0.64754076E-07_JPRB, 0.60708167E-07_JPRB, &
  & 0.56555656E-07_JPRB, 0.52682164E-07_JPRB, 0.49269733E-07_JPRB, 0.46311584E-07_JPRB, 0.43883865E-07_JPRB, 0.42077058E-07_JPRB, &
  & 0.41025221E-07_JPRB, 0.40830724E-07_JPRB, 0.41536168E-07_JPRB, 0.43284487E-07_JPRB, 0.46322395E-07_JPRB, 0.50889518E-07_JPRB, &
  & 0.56808524E-07_JPRB, 0.63473315E-07_JPRB, 0.69924404E-07_JPRB, 0.75240166E-07_JPRB, 0.78911249E-07_JPRB, 0.80987057E-07_JPRB, &
  & 0.81995417E-07_JPRB, 0.82637420E-07_JPRB, 0.83460513E-07_JPRB, 0.84830283E-07_JPRB, 0.86884427E-07_JPRB, 0.89541260E-07_JPRB, &
  & 0.92572286E-07_JPRB, 0.95328176E-07_JPRB, 0.97402236E-07_JPRB, 0.98892293E-07_JPRB, 0.99903303E-07_JPRB, 0.10074130E-06_JPRB, &
  & 0.10153508E-06_JPRB, 0.10241189E-06_JPRB, 0.10334757E-06_JPRB, 0.10435578E-06_JPRB, 0.10528171E-06_JPRB, 0.10601929E-06_JPRB, &
  & 0.10667852E-06_JPRB, 0.10730273E-06_JPRB, 0.10827978E-06_JPRB, 0.11017011E-06_JPRB /)

RGHG7(:,59, 5) = (/ &
  & 0.77868705E-07_JPRB, 0.74380537E-07_JPRB, 0.73290771E-07_JPRB, 0.71735094E-07_JPRB, 0.70687705E-07_JPRB, 0.69950239E-07_JPRB, &
  & 0.69587493E-07_JPRB, 0.69391582E-07_JPRB, 0.69248500E-07_JPRB, 0.69116112E-07_JPRB, 0.68998894E-07_JPRB, 0.68887424E-07_JPRB, &
  & 0.68773694E-07_JPRB, 0.68680237E-07_JPRB, 0.68617460E-07_JPRB, 0.68625489E-07_JPRB, 0.68685623E-07_JPRB, 0.68732881E-07_JPRB, &
  & 0.68643871E-07_JPRB, 0.68225233E-07_JPRB, 0.67223318E-07_JPRB, 0.65321231E-07_JPRB, 0.62270090E-07_JPRB, 0.58492134E-07_JPRB, &
  & 0.54505140E-07_JPRB, 0.50754661E-07_JPRB, 0.47413565E-07_JPRB, 0.44525475E-07_JPRB, 0.42171333E-07_JPRB, 0.40433612E-07_JPRB, &
  & 0.39431633E-07_JPRB, 0.39250171E-07_JPRB, 0.39893720E-07_JPRB, 0.41489795E-07_JPRB, 0.44289663E-07_JPRB, 0.48554906E-07_JPRB, &
  & 0.54159820E-07_JPRB, 0.60504959E-07_JPRB, 0.66620657E-07_JPRB, 0.71666868E-07_JPRB, 0.75143902E-07_JPRB, 0.77128092E-07_JPRB, &
  & 0.78134022E-07_JPRB, 0.78802522E-07_JPRB, 0.79646590E-07_JPRB, 0.80992606E-07_JPRB, 0.82975504E-07_JPRB, 0.85533401E-07_JPRB, &
  & 0.88448651E-07_JPRB, 0.91246605E-07_JPRB, 0.93432618E-07_JPRB, 0.94945243E-07_JPRB, 0.96051053E-07_JPRB, 0.96959276E-07_JPRB, &
  & 0.97787726E-07_JPRB, 0.98671073E-07_JPRB, 0.99686659E-07_JPRB, 0.10077850E-06_JPRB, 0.10170776E-06_JPRB, 0.10243062E-06_JPRB, &
  & 0.10303970E-06_JPRB, 0.10362334E-06_JPRB, 0.10425057E-06_JPRB, 0.10585445E-06_JPRB /)

RGHG7(:,60, 5) = (/ &
  & 0.73408181E-07_JPRB, 0.70879828E-07_JPRB, 0.69437391E-07_JPRB, 0.68638194E-07_JPRB, 0.67798318E-07_JPRB, 0.67295744E-07_JPRB, &
  & 0.66999007E-07_JPRB, 0.66816582E-07_JPRB, 0.66679462E-07_JPRB, 0.66559736E-07_JPRB, 0.66426985E-07_JPRB, 0.66297062E-07_JPRB, &
  & 0.66163935E-07_JPRB, 0.66026992E-07_JPRB, 0.65929484E-07_JPRB, 0.65912729E-07_JPRB, 0.65980970E-07_JPRB, 0.66074733E-07_JPRB, &
  & 0.66043043E-07_JPRB, 0.65682983E-07_JPRB, 0.64722165E-07_JPRB, 0.62835255E-07_JPRB, 0.59969103E-07_JPRB, 0.56311713E-07_JPRB, &
  & 0.52504792E-07_JPRB, 0.48884797E-07_JPRB, 0.45627459E-07_JPRB, 0.42830649E-07_JPRB, 0.40575550E-07_JPRB, 0.38938001E-07_JPRB, &
  & 0.38005208E-07_JPRB, 0.37842863E-07_JPRB, 0.38429519E-07_JPRB, 0.39879399E-07_JPRB, 0.42469829E-07_JPRB, 0.46424017E-07_JPRB, &
  & 0.51713858E-07_JPRB, 0.57670981E-07_JPRB, 0.63459211E-07_JPRB, 0.68227713E-07_JPRB, 0.71536014E-07_JPRB, 0.73463418E-07_JPRB, &
  & 0.74484944E-07_JPRB, 0.75198031E-07_JPRB, 0.76071892E-07_JPRB, 0.77412778E-07_JPRB, 0.79321914E-07_JPRB, 0.81753548E-07_JPRB, &
  & 0.84559538E-07_JPRB, 0.87305672E-07_JPRB, 0.89588688E-07_JPRB, 0.91245134E-07_JPRB, 0.92480981E-07_JPRB, 0.93465815E-07_JPRB, &
  & 0.94430476E-07_JPRB, 0.95451320E-07_JPRB, 0.96601845E-07_JPRB, 0.97741683E-07_JPRB, 0.98713230E-07_JPRB, 0.99499402E-07_JPRB, &
  & 0.10017317E-06_JPRB, 0.10078782E-06_JPRB, 0.10163866E-06_JPRB, 0.10311901E-06_JPRB /)

RGHG7(:,61, 5) = (/ &
  & 0.69068641E-07_JPRB, 0.67161722E-07_JPRB, 0.66602063E-07_JPRB, 0.65878957E-07_JPRB, 0.65324684E-07_JPRB, 0.64902380E-07_JPRB, &
  & 0.64658373E-07_JPRB, 0.64489100E-07_JPRB, 0.64339460E-07_JPRB, 0.64194644E-07_JPRB, 0.64051711E-07_JPRB, 0.63892969E-07_JPRB, &
  & 0.63710630E-07_JPRB, 0.63543894E-07_JPRB, 0.63404073E-07_JPRB, 0.63347677E-07_JPRB, 0.63406056E-07_JPRB, 0.63529207E-07_JPRB, &
  & 0.63552150E-07_JPRB, 0.63232285E-07_JPRB, 0.62309724E-07_JPRB, 0.60513216E-07_JPRB, 0.57718516E-07_JPRB, 0.54252364E-07_JPRB, &
  & 0.50581413E-07_JPRB, 0.47091504E-07_JPRB, 0.43946326E-07_JPRB, 0.41260677E-07_JPRB, 0.39121776E-07_JPRB, 0.37601637E-07_JPRB, &
  & 0.36760177E-07_JPRB, 0.36629380E-07_JPRB, 0.37160937E-07_JPRB, 0.38460875E-07_JPRB, 0.40836341E-07_JPRB, 0.44491205E-07_JPRB, &
  & 0.49434373E-07_JPRB, 0.55010990E-07_JPRB, 0.60457822E-07_JPRB, 0.64955493E-07_JPRB, 0.68102416E-07_JPRB, 0.69988765E-07_JPRB, &
  & 0.71045832E-07_JPRB, 0.71817666E-07_JPRB, 0.72733442E-07_JPRB, 0.74065781E-07_JPRB, 0.75916368E-07_JPRB, 0.78239040E-07_JPRB, &
  & 0.80872304E-07_JPRB, 0.83561460E-07_JPRB, 0.85867356E-07_JPRB, 0.87673733E-07_JPRB, 0.89040796E-07_JPRB, 0.90215565E-07_JPRB, &
  & 0.91310071E-07_JPRB, 0.92489095E-07_JPRB, 0.93782454E-07_JPRB, 0.95065310E-07_JPRB, 0.96141804E-07_JPRB, 0.96990000E-07_JPRB, &
  & 0.97672142E-07_JPRB, 0.98332357E-07_JPRB, 0.99071556E-07_JPRB, 0.10066343E-06_JPRB /)

RGHG7(:,62, 5) = (/ &
  & 0.66279753E-07_JPRB, 0.64791138E-07_JPRB, 0.64011616E-07_JPRB, 0.63551774E-07_JPRB, 0.63079789E-07_JPRB, 0.62725945E-07_JPRB, &
  & 0.62482108E-07_JPRB, 0.62308409E-07_JPRB, 0.62156026E-07_JPRB, 0.61995017E-07_JPRB, 0.61819946E-07_JPRB, 0.61625222E-07_JPRB, &
  & 0.61411320E-07_JPRB, 0.61180828E-07_JPRB, 0.60982146E-07_JPRB, 0.60890777E-07_JPRB, 0.60949333E-07_JPRB, 0.61094887E-07_JPRB, &
  & 0.61150260E-07_JPRB, 0.60873894E-07_JPRB, 0.60002023E-07_JPRB, 0.58259786E-07_JPRB, 0.55612990E-07_JPRB, 0.52280356E-07_JPRB, &
  & 0.48772193E-07_JPRB, 0.45412573E-07_JPRB, 0.42400831E-07_JPRB, 0.39848899E-07_JPRB, 0.37839659E-07_JPRB, 0.36443687E-07_JPRB, &
  & 0.35701781E-07_JPRB, 0.35610171E-07_JPRB, 0.36096917E-07_JPRB, 0.37244018E-07_JPRB, 0.39402845E-07_JPRB, 0.42770779E-07_JPRB, &
  & 0.47348021E-07_JPRB, 0.52537104E-07_JPRB, 0.57652830E-07_JPRB, 0.61867432E-07_JPRB, 0.64866953E-07_JPRB, 0.66723096E-07_JPRB, &
  & 0.67821603E-07_JPRB, 0.68659141E-07_JPRB, 0.69618437E-07_JPRB, 0.70953291E-07_JPRB, 0.72749316E-07_JPRB, 0.74963275E-07_JPRB, &
  & 0.77477196E-07_JPRB, 0.80004646E-07_JPRB, 0.82322096E-07_JPRB, 0.84220524E-07_JPRB, 0.85757442E-07_JPRB, 0.87077595E-07_JPRB, &
  & 0.88355343E-07_JPRB, 0.89743423E-07_JPRB, 0.91248616E-07_JPRB, 0.92687074E-07_JPRB, 0.93857572E-07_JPRB, 0.94782813E-07_JPRB, &
  & 0.95560154E-07_JPRB, 0.96283429E-07_JPRB, 0.97179424E-07_JPRB, 0.98727249E-07_JPRB /)

RGHG7(:,63, 5) = (/ &
  & 0.63673504E-07_JPRB, 0.62289921E-07_JPRB, 0.61843650E-07_JPRB, 0.61402574E-07_JPRB, 0.61020913E-07_JPRB, 0.60699030E-07_JPRB, &
  & 0.60465986E-07_JPRB, 0.60273322E-07_JPRB, 0.60096859E-07_JPRB, 0.59910882E-07_JPRB, 0.59707595E-07_JPRB, 0.59468451E-07_JPRB, &
  & 0.59194935E-07_JPRB, 0.58898962E-07_JPRB, 0.58648446E-07_JPRB, 0.58533896E-07_JPRB, 0.58595624E-07_JPRB, 0.58759944E-07_JPRB, &
  & 0.58849114E-07_JPRB, 0.58612773E-07_JPRB, 0.57785520E-07_JPRB, 0.56134382E-07_JPRB, 0.53587069E-07_JPRB, 0.50433254E-07_JPRB, &
  & 0.47077091E-07_JPRB, 0.43871509E-07_JPRB, 0.41017319E-07_JPRB, 0.38623387E-07_JPRB, 0.36765098E-07_JPRB, 0.35504556E-07_JPRB, &
  & 0.34867202E-07_JPRB, 0.34811894E-07_JPRB, 0.35252061E-07_JPRB, 0.36260488E-07_JPRB, 0.38174150E-07_JPRB, 0.41268461E-07_JPRB, &
  & 0.45477826E-07_JPRB, 0.50291295E-07_JPRB, 0.55053071E-07_JPRB, 0.59009221E-07_JPRB, 0.61850990E-07_JPRB, 0.63679018E-07_JPRB, &
  & 0.64828569E-07_JPRB, 0.65739663E-07_JPRB, 0.66747091E-07_JPRB, 0.68083644E-07_JPRB, 0.69828374E-07_JPRB, 0.71953714E-07_JPRB, &
  & 0.74336747E-07_JPRB, 0.76762070E-07_JPRB, 0.78997225E-07_JPRB, 0.80922334E-07_JPRB, 0.82605411E-07_JPRB, 0.84059785E-07_JPRB, &
  & 0.85545665E-07_JPRB, 0.87100638E-07_JPRB, 0.88872049E-07_JPRB, 0.90434980E-07_JPRB, 0.91729810E-07_JPRB, 0.92743548E-07_JPRB, &
  & 0.93579864E-07_JPRB, 0.94386962E-07_JPRB, 0.95311506E-07_JPRB, 0.97091885E-07_JPRB /)

RGHG7(:,64, 5) = (/ &
  & 0.61495868E-07_JPRB, 0.60345812E-07_JPRB, 0.59823357E-07_JPRB, 0.59474189E-07_JPRB, 0.59117657E-07_JPRB, 0.58805139E-07_JPRB, &
  & 0.58557184E-07_JPRB, 0.58354420E-07_JPRB, 0.58153020E-07_JPRB, 0.57944533E-07_JPRB, 0.57691036E-07_JPRB, 0.57405970E-07_JPRB, &
  & 0.57060873E-07_JPRB, 0.56697253E-07_JPRB, 0.56410329E-07_JPRB, 0.56294478E-07_JPRB, 0.56368918E-07_JPRB, 0.56550231E-07_JPRB, &
  & 0.56661047E-07_JPRB, 0.56456862E-07_JPRB, 0.55683554E-07_JPRB, 0.54105488E-07_JPRB, 0.51708220E-07_JPRB, 0.48703228E-07_JPRB, &
  & 0.45527052E-07_JPRB, 0.42499050E-07_JPRB, 0.39824872E-07_JPRB, 0.37615944E-07_JPRB, 0.35935049E-07_JPRB, 0.34826250E-07_JPRB, &
  & 0.34297884E-07_JPRB, 0.34277601E-07_JPRB, 0.34665959E-07_JPRB, 0.35535113E-07_JPRB, 0.37225675E-07_JPRB, 0.40034941E-07_JPRB, &
  & 0.43876174E-07_JPRB, 0.48316512E-07_JPRB, 0.52716398E-07_JPRB, 0.56413658E-07_JPRB, 0.59111692E-07_JPRB, 0.60909073E-07_JPRB, &
  & 0.62109784E-07_JPRB, 0.63090724E-07_JPRB, 0.64147820E-07_JPRB, 0.65492657E-07_JPRB, 0.67187869E-07_JPRB, 0.69228456E-07_JPRB, &
  & 0.71508644E-07_JPRB, 0.73822129E-07_JPRB, 0.75979507E-07_JPRB, 0.77923751E-07_JPRB, 0.79612008E-07_JPRB, 0.81245403E-07_JPRB, &
  & 0.82809137E-07_JPRB, 0.84610534E-07_JPRB, 0.86547708E-07_JPRB, 0.88285717E-07_JPRB, 0.89673804E-07_JPRB, 0.90783729E-07_JPRB, &
  & 0.91713495E-07_JPRB, 0.92592948E-07_JPRB, 0.93671481E-07_JPRB, 0.95578287E-07_JPRB /)

RGHG7(:,65, 5) = (/ &
  & 0.59614834E-07_JPRB, 0.58466778E-07_JPRB, 0.58031787E-07_JPRB, 0.57671421E-07_JPRB, 0.57337534E-07_JPRB, 0.57026629E-07_JPRB, &
  & 0.56766758E-07_JPRB, 0.56535860E-07_JPRB, 0.56309190E-07_JPRB, 0.56056074E-07_JPRB, 0.55771686E-07_JPRB, 0.55410361E-07_JPRB, &
  & 0.54990629E-07_JPRB, 0.54583232E-07_JPRB, 0.54285323E-07_JPRB, 0.54192096E-07_JPRB, 0.54281561E-07_JPRB, 0.54473205E-07_JPRB, &
  & 0.54599894E-07_JPRB, 0.54428146E-07_JPRB, 0.53705524E-07_JPRB, 0.52223573E-07_JPRB, 0.49953368E-07_JPRB, 0.47133810E-07_JPRB, &
  & 0.44151303E-07_JPRB, 0.41327176E-07_JPRB, 0.38857991E-07_JPRB, 0.36857788E-07_JPRB, 0.35369506E-07_JPRB, 0.34425192E-07_JPRB, &
  & 0.34010604E-07_JPRB, 0.34027558E-07_JPRB, 0.34365630E-07_JPRB, 0.35104733E-07_JPRB, 0.36576221E-07_JPRB, 0.39097731E-07_JPRB, &
  & 0.42589985E-07_JPRB, 0.46654399E-07_JPRB, 0.50699516E-07_JPRB, 0.54135352E-07_JPRB, 0.56685373E-07_JPRB, 0.58454713E-07_JPRB, &
  & 0.59700852E-07_JPRB, 0.60748896E-07_JPRB, 0.61857200E-07_JPRB, 0.63204098E-07_JPRB, 0.64852912E-07_JPRB, 0.66810429E-07_JPRB, &
  & 0.68989962E-07_JPRB, 0.71206429E-07_JPRB, 0.73300058E-07_JPRB, 0.75195068E-07_JPRB, 0.76949128E-07_JPRB, 0.78590404E-07_JPRB, &
  & 0.80316291E-07_JPRB, 0.82179781E-07_JPRB, 0.84337572E-07_JPRB, 0.86157740E-07_JPRB, 0.87663359E-07_JPRB, 0.88848012E-07_JPRB, &
  & 0.89847795E-07_JPRB, 0.90806978E-07_JPRB, 0.91975537E-07_JPRB, 0.94109545E-07_JPRB /)

RGHG7(:,66, 5) = (/ &
  & 0.57947332E-07_JPRB, 0.56822270E-07_JPRB, 0.56338219E-07_JPRB, 0.55989613E-07_JPRB, 0.55648428E-07_JPRB, 0.55325067E-07_JPRB, &
  & 0.55045422E-07_JPRB, 0.54792952E-07_JPRB, 0.54532546E-07_JPRB, 0.54248019E-07_JPRB, 0.53889814E-07_JPRB, 0.53479965E-07_JPRB, &
  & 0.53004619E-07_JPRB, 0.52584724E-07_JPRB, 0.52313830E-07_JPRB, 0.52239940E-07_JPRB, 0.52340599E-07_JPRB, 0.52537157E-07_JPRB, &
  & 0.52675233E-07_JPRB, 0.52530741E-07_JPRB, 0.51862187E-07_JPRB, 0.50473073E-07_JPRB, 0.48358064E-07_JPRB, 0.45728971E-07_JPRB, &
  & 0.42966946E-07_JPRB, 0.40374747E-07_JPRB, 0.38140769E-07_JPRB, 0.36359801E-07_JPRB, 0.35072148E-07_JPRB, 0.34293240E-07_JPRB, &
  & 0.33993214E-07_JPRB, 0.34051240E-07_JPRB, 0.34348595E-07_JPRB, 0.34966369E-07_JPRB, 0.36244113E-07_JPRB, 0.38497767E-07_JPRB, &
  & 0.41641265E-07_JPRB, 0.45343690E-07_JPRB, 0.49038441E-07_JPRB, 0.52207287E-07_JPRB, 0.54614922E-07_JPRB, 0.56350839E-07_JPRB, &
  & 0.57635607E-07_JPRB, 0.58734408E-07_JPRB, 0.59886013E-07_JPRB, 0.61235234E-07_JPRB, 0.62832960E-07_JPRB, 0.64713632E-07_JPRB, &
  & 0.66786981E-07_JPRB, 0.68914694E-07_JPRB, 0.70929161E-07_JPRB, 0.72791551E-07_JPRB, 0.74527932E-07_JPRB, 0.76214754E-07_JPRB, &
  & 0.77939070E-07_JPRB, 0.79942012E-07_JPRB, 0.82184158E-07_JPRB, 0.84096570E-07_JPRB, 0.85668027E-07_JPRB, 0.86939046E-07_JPRB, &
  & 0.87994422E-07_JPRB, 0.88993588E-07_JPRB, 0.90317386E-07_JPRB, 0.92468127E-07_JPRB /)

RGHG7(:,67, 5) = (/ &
  & 0.56426799E-07_JPRB, 0.55243387E-07_JPRB, 0.54747485E-07_JPRB, 0.54366161E-07_JPRB, 0.54009714E-07_JPRB, 0.53676796E-07_JPRB, &
  & 0.53368939E-07_JPRB, 0.53092730E-07_JPRB, 0.52796661E-07_JPRB, 0.52462660E-07_JPRB, 0.52067421E-07_JPRB, 0.51602559E-07_JPRB, &
  & 0.51117947E-07_JPRB, 0.50727017E-07_JPRB, 0.50486655E-07_JPRB, 0.50436970E-07_JPRB, 0.50546827E-07_JPRB, 0.50744454E-07_JPRB, &
  & 0.50891387E-07_JPRB, 0.50769000E-07_JPRB, 0.50159151E-07_JPRB, 0.48876846E-07_JPRB, 0.46923532E-07_JPRB, 0.44508209E-07_JPRB, &
  & 0.41994344E-07_JPRB, 0.39651912E-07_JPRB, 0.37668421E-07_JPRB, 0.36119257E-07_JPRB, 0.35029522E-07_JPRB, 0.34411190E-07_JPRB, &
  & 0.34220719E-07_JPRB, 0.34323190E-07_JPRB, 0.34593448E-07_JPRB, 0.35115242E-07_JPRB, 0.36222737E-07_JPRB, 0.38209976E-07_JPRB, &
  & 0.41048260E-07_JPRB, 0.44391186E-07_JPRB, 0.47758355E-07_JPRB, 0.50665843E-07_JPRB, 0.52923497E-07_JPRB, 0.54623293E-07_JPRB, &
  & 0.55918200E-07_JPRB, 0.57076939E-07_JPRB, 0.58245966E-07_JPRB, 0.59594722E-07_JPRB, 0.61140710E-07_JPRB, 0.62931669E-07_JPRB, &
  & 0.64907560E-07_JPRB, 0.66939769E-07_JPRB, 0.68863429E-07_JPRB, 0.70690135E-07_JPRB, 0.72378285E-07_JPRB, 0.74081832E-07_JPRB, &
  & 0.75806959E-07_JPRB, 0.77835651E-07_JPRB, 0.80160312E-07_JPRB, 0.82110049E-07_JPRB, 0.83737604E-07_JPRB, 0.85035445E-07_JPRB, &
  & 0.86121759E-07_JPRB, 0.87158000E-07_JPRB, 0.88494843E-07_JPRB, 0.90827541E-07_JPRB /)

RGHG7(:,68, 5) = (/ &
  & 0.55012425E-07_JPRB, 0.53749837E-07_JPRB, 0.53196636E-07_JPRB, 0.52782358E-07_JPRB, 0.52398487E-07_JPRB, 0.52030828E-07_JPRB, &
  & 0.51718757E-07_JPRB, 0.51400679E-07_JPRB, 0.51087333E-07_JPRB, 0.50716267E-07_JPRB, 0.50279120E-07_JPRB, 0.49811010E-07_JPRB, &
  & 0.49366868E-07_JPRB, 0.49013273E-07_JPRB, 0.48807234E-07_JPRB, 0.48777089E-07_JPRB, 0.48894830E-07_JPRB, 0.49093167E-07_JPRB, &
  & 0.49244360E-07_JPRB, 0.49145513E-07_JPRB, 0.48597865E-07_JPRB, 0.47435925E-07_JPRB, 0.45660371E-07_JPRB, 0.43485571E-07_JPRB, &
  & 0.41224290E-07_JPRB, 0.39157680E-07_JPRB, 0.37430176E-07_JPRB, 0.36105888E-07_JPRB, 0.35211446E-07_JPRB, 0.34747625E-07_JPRB, &
  & 0.34661731E-07_JPRB, 0.34812096E-07_JPRB, 0.35068613E-07_JPRB, 0.35511807E-07_JPRB, 0.36471405E-07_JPRB, 0.38243790E-07_JPRB, &
  & 0.40781572E-07_JPRB, 0.43799819E-07_JPRB, 0.46854282E-07_JPRB, 0.49509008E-07_JPRB, 0.51625804E-07_JPRB, 0.53273212E-07_JPRB, &
  & 0.54565035E-07_JPRB, 0.55769043E-07_JPRB, 0.56935537E-07_JPRB, 0.58280541E-07_JPRB, 0.59760019E-07_JPRB, 0.61471518E-07_JPRB, &
  & 0.63342021E-07_JPRB, 0.65271010E-07_JPRB, 0.67105042E-07_JPRB, 0.68869163E-07_JPRB, 0.70507248E-07_JPRB, 0.72188833E-07_JPRB, &
  & 0.73881154E-07_JPRB, 0.75915082E-07_JPRB, 0.78252633E-07_JPRB, 0.80212430E-07_JPRB, 0.81848619E-07_JPRB, 0.83170342E-07_JPRB, &
  & 0.84257429E-07_JPRB, 0.85261398E-07_JPRB, 0.86682306E-07_JPRB, 0.89065161E-07_JPRB /)

RGHG7(:,69, 5) = (/ &
  & 0.53688719E-07_JPRB, 0.52300472E-07_JPRB, 0.51668653E-07_JPRB, 0.51198008E-07_JPRB, 0.50773576E-07_JPRB, 0.50392309E-07_JPRB, &
  & 0.50044054E-07_JPRB, 0.49735078E-07_JPRB, 0.49370293E-07_JPRB, 0.48986006E-07_JPRB, 0.48552511E-07_JPRB, 0.48108721E-07_JPRB, &
  & 0.47707918E-07_JPRB, 0.47405223E-07_JPRB, 0.47241546E-07_JPRB, 0.47243361E-07_JPRB, 0.47373241E-07_JPRB, 0.47574481E-07_JPRB, &
  & 0.47730204E-07_JPRB, 0.47659320E-07_JPRB, 0.47183814E-07_JPRB, 0.46150600E-07_JPRB, 0.44582780E-07_JPRB, 0.42648868E-07_JPRB, &
  & 0.40673072E-07_JPRB, 0.38874912E-07_JPRB, 0.37400795E-07_JPRB, 0.36305927E-07_JPRB, 0.35600070E-07_JPRB, 0.35281381E-07_JPRB, &
  & 0.35296022E-07_JPRB, 0.35498520E-07_JPRB, 0.35755452E-07_JPRB, 0.36147835E-07_JPRB, 0.36989046E-07_JPRB, 0.38550304E-07_JPRB, &
  & 0.40830955E-07_JPRB, 0.43543377E-07_JPRB, 0.46308315E-07_JPRB, 0.48728896E-07_JPRB, 0.50706078E-07_JPRB, 0.52286140E-07_JPRB, &
  & 0.53578916E-07_JPRB, 0.54787090E-07_JPRB, 0.55956772E-07_JPRB, 0.57272061E-07_JPRB, 0.58693697E-07_JPRB, 0.60312253E-07_JPRB, &
  & 0.62081135E-07_JPRB, 0.63898732E-07_JPRB, 0.65634978E-07_JPRB, 0.67318609E-07_JPRB, 0.68889150E-07_JPRB, 0.70512911E-07_JPRB, &
  & 0.72166984E-07_JPRB, 0.74151458E-07_JPRB, 0.76467749E-07_JPRB, 0.78411333E-07_JPRB, 0.80024265E-07_JPRB, 0.81322597E-07_JPRB, &
  & 0.82378030E-07_JPRB, 0.83362863E-07_JPRB, 0.84721250E-07_JPRB, 0.87242654E-07_JPRB /)

RGHG7(:,70, 5) = (/ &
  & 0.52445493E-07_JPRB, 0.50848442E-07_JPRB, 0.50115919E-07_JPRB, 0.49578077E-07_JPRB, 0.49116810E-07_JPRB, 0.48716423E-07_JPRB, &
  & 0.48373618E-07_JPRB, 0.48030657E-07_JPRB, 0.47685681E-07_JPRB, 0.47286591E-07_JPRB, 0.46883013E-07_JPRB, 0.46496680E-07_JPRB, &
  & 0.46158473E-07_JPRB, 0.45914614E-07_JPRB, 0.45797652E-07_JPRB, 0.45827761E-07_JPRB, 0.45975082E-07_JPRB, 0.46180737E-07_JPRB, &
  & 0.46348248E-07_JPRB, 0.46310220E-07_JPRB, 0.45914057E-07_JPRB, 0.45031975E-07_JPRB, 0.43671118E-07_JPRB, 0.42011465E-07_JPRB, &
  & 0.40306286E-07_JPRB, 0.38789516E-07_JPRB, 0.37565080E-07_JPRB, 0.36685236E-07_JPRB, 0.36160792E-07_JPRB, 0.35983714E-07_JPRB, &
  & 0.36095155E-07_JPRB, 0.36351970E-07_JPRB, 0.36623018E-07_JPRB, 0.36980037E-07_JPRB, 0.37723453E-07_JPRB, 0.39118625E-07_JPRB, &
  & 0.41158202E-07_JPRB, 0.43598391E-07_JPRB, 0.46095671E-07_JPRB, 0.48295998E-07_JPRB, 0.50142869E-07_JPRB, 0.51648023E-07_JPRB, &
  & 0.52933000E-07_JPRB, 0.54117301E-07_JPRB, 0.55290599E-07_JPRB, 0.56558608E-07_JPRB, 0.57919621E-07_JPRB, 0.59448240E-07_JPRB, &
  & 0.61108651E-07_JPRB, 0.62805846E-07_JPRB, 0.64442979E-07_JPRB, 0.66025827E-07_JPRB, 0.67523111E-07_JPRB, 0.69065031E-07_JPRB, &
  & 0.70641093E-07_JPRB, 0.72558258E-07_JPRB, 0.74804674E-07_JPRB, 0.76674638E-07_JPRB, 0.78240276E-07_JPRB, 0.79496502E-07_JPRB, &
  & 0.80506815E-07_JPRB, 0.81402014E-07_JPRB, 0.82767812E-07_JPRB, 0.85342663E-07_JPRB /)

RGHG7(:,71, 5) = (/ &
  & 0.51213895E-07_JPRB, 0.49367554E-07_JPRB, 0.48495576E-07_JPRB, 0.47893771E-07_JPRB, 0.47414382E-07_JPRB, 0.47001691E-07_JPRB, &
  & 0.46665370E-07_JPRB, 0.46338823E-07_JPRB, 0.45980595E-07_JPRB, 0.45626798E-07_JPRB, 0.45261931E-07_JPRB, 0.44938684E-07_JPRB, &
  & 0.44670582E-07_JPRB, 0.44495138E-07_JPRB, 0.44441776E-07_JPRB, 0.44518202E-07_JPRB, 0.44692172E-07_JPRB, 0.44915662E-07_JPRB, &
  & 0.45098496E-07_JPRB, 0.45103889E-07_JPRB, 0.44797673E-07_JPRB, 0.44067928E-07_JPRB, 0.42941171E-07_JPRB, 0.41542265E-07_JPRB, &
  & 0.40130953E-07_JPRB, 0.38873551E-07_JPRB, 0.37901717E-07_JPRB, 0.37239136E-07_JPRB, 0.36889052E-07_JPRB, 0.36848043E-07_JPRB, &
  & 0.37051990E-07_JPRB, 0.37365851E-07_JPRB, 0.37662883E-07_JPRB, 0.38013802E-07_JPRB, 0.38689173E-07_JPRB, 0.39928807E-07_JPRB, &
  & 0.41747526E-07_JPRB, 0.43937192E-07_JPRB, 0.46185544E-07_JPRB, 0.48187303E-07_JPRB, 0.49905310E-07_JPRB, 0.51334300E-07_JPRB, &
  & 0.52588916E-07_JPRB, 0.53748998E-07_JPRB, 0.54907986E-07_JPRB, 0.56128641E-07_JPRB, 0.57423950E-07_JPRB, 0.58860461E-07_JPRB, &
  & 0.60408667E-07_JPRB, 0.61989340E-07_JPRB, 0.63508551E-07_JPRB, 0.64985905E-07_JPRB, 0.66379172E-07_JPRB, 0.67824914E-07_JPRB, &
  & 0.69304647E-07_JPRB, 0.71115359E-07_JPRB, 0.73234126E-07_JPRB, 0.75030229E-07_JPRB, 0.76489563E-07_JPRB, 0.77678727E-07_JPRB, &
  & 0.78617781E-07_JPRB, 0.79427288E-07_JPRB, 0.80651937E-07_JPRB, 0.83221444E-07_JPRB /)

RGHG7(:,72, 5) = (/ &
  & 0.49925571E-07_JPRB, 0.47762047E-07_JPRB, 0.46771625E-07_JPRB, 0.46130321E-07_JPRB, 0.45638409E-07_JPRB, 0.45258421E-07_JPRB, &
  & 0.44920569E-07_JPRB, 0.44613177E-07_JPRB, 0.44295401E-07_JPRB, 0.43976399E-07_JPRB, 0.43690200E-07_JPRB, 0.43443904E-07_JPRB, &
  & 0.43266052E-07_JPRB, 0.43173081E-07_JPRB, 0.43189612E-07_JPRB, 0.43312649E-07_JPRB, 0.43524164E-07_JPRB, 0.43772978E-07_JPRB, &
  & 0.43983398E-07_JPRB, 0.44040231E-07_JPRB, 0.43829349E-07_JPRB, 0.43267317E-07_JPRB, 0.42364348E-07_JPRB, 0.41248644E-07_JPRB, &
  & 0.40110955E-07_JPRB, 0.39125400E-07_JPRB, 0.38395566E-07_JPRB, 0.37928750E-07_JPRB, 0.37740168E-07_JPRB, 0.37834656E-07_JPRB, &
  & 0.38126991E-07_JPRB, 0.38502137E-07_JPRB, 0.38836077E-07_JPRB, 0.39190237E-07_JPRB, 0.39813031E-07_JPRB, 0.40931674E-07_JPRB, &
  & 0.42564285E-07_JPRB, 0.44531941E-07_JPRB, 0.46546649E-07_JPRB, 0.48368335E-07_JPRB, 0.49960338E-07_JPRB, 0.51308717E-07_JPRB, &
  & 0.52522616E-07_JPRB, 0.53651810E-07_JPRB, 0.54783577E-07_JPRB, 0.55946821E-07_JPRB, 0.57182952E-07_JPRB, 0.58520694E-07_JPRB, &
  & 0.59959433E-07_JPRB, 0.61412429E-07_JPRB, 0.62816035E-07_JPRB, 0.64169434E-07_JPRB, 0.65461208E-07_JPRB, 0.66783912E-07_JPRB, &
  & 0.68155074E-07_JPRB, 0.69808401E-07_JPRB, 0.71794354E-07_JPRB, 0.73418008E-07_JPRB, 0.74795643E-07_JPRB, 0.75874880E-07_JPRB, &
  & 0.76744328E-07_JPRB, 0.77442408E-07_JPRB, 0.78529737E-07_JPRB, 0.80892036E-07_JPRB /)

RGHG7(:,73, 5) = (/ &
  & 0.48442235E-07_JPRB, 0.46025285E-07_JPRB, 0.44936648E-07_JPRB, 0.44291120E-07_JPRB, 0.43833648E-07_JPRB, 0.43463064E-07_JPRB, &
  & 0.43169791E-07_JPRB, 0.42892779E-07_JPRB, 0.42607763E-07_JPRB, 0.42367763E-07_JPRB, 0.42144944E-07_JPRB, 0.41995275E-07_JPRB, &
  & 0.41905526E-07_JPRB, 0.41902307E-07_JPRB, 0.42016048E-07_JPRB, 0.42211951E-07_JPRB, 0.42466496E-07_JPRB, 0.42755897E-07_JPRB, &
  & 0.43003347E-07_JPRB, 0.43119108E-07_JPRB, 0.43012950E-07_JPRB, 0.42614996E-07_JPRB, 0.41948489E-07_JPRB, 0.41095607E-07_JPRB, &
  & 0.40242487E-07_JPRB, 0.39510493E-07_JPRB, 0.39012960E-07_JPRB, 0.38759811E-07_JPRB, 0.38732924E-07_JPRB, 0.38948855E-07_JPRB, &
  & 0.39325716E-07_JPRB, 0.39762735E-07_JPRB, 0.40147263E-07_JPRB, 0.40529642E-07_JPRB, 0.41129091E-07_JPRB, 0.42143714E-07_JPRB, &
  & 0.43589971E-07_JPRB, 0.45344990E-07_JPRB, 0.47147918E-07_JPRB, 0.48800057E-07_JPRB, 0.50269964E-07_JPRB, 0.51535892E-07_JPRB, &
  & 0.52694904E-07_JPRB, 0.53797972E-07_JPRB, 0.54872846E-07_JPRB, 0.55990057E-07_JPRB, 0.57156281E-07_JPRB, 0.58396459E-07_JPRB, &
  & 0.59723810E-07_JPRB, 0.61052582E-07_JPRB, 0.62334358E-07_JPRB, 0.63561821E-07_JPRB, 0.64735417E-07_JPRB, 0.65931303E-07_JPRB, &
  & 0.67168678E-07_JPRB, 0.68682795E-07_JPRB, 0.70418288E-07_JPRB, 0.71946147E-07_JPRB, 0.73140143E-07_JPRB, 0.74132089E-07_JPRB, &
  & 0.74911220E-07_JPRB, 0.75524696E-07_JPRB, 0.76465490E-07_JPRB, 0.78673146E-07_JPRB /)

RGHG7(:,74, 5) = (/ &
  & 0.46778506E-07_JPRB, 0.44109438E-07_JPRB, 0.43049564E-07_JPRB, 0.42431118E-07_JPRB, 0.42013411E-07_JPRB, 0.41699703E-07_JPRB, &
  & 0.41436277E-07_JPRB, 0.41204462E-07_JPRB, 0.40994617E-07_JPRB, 0.40811180E-07_JPRB, 0.40698026E-07_JPRB, 0.40638401E-07_JPRB, &
  & 0.40667235E-07_JPRB, 0.40764064E-07_JPRB, 0.40948073E-07_JPRB, 0.41210885E-07_JPRB, 0.41523563E-07_JPRB, 0.41857703E-07_JPRB, &
  & 0.42153641E-07_JPRB, 0.42337682E-07_JPRB, 0.42339050E-07_JPRB, 0.42109971E-07_JPRB, 0.41666141E-07_JPRB, 0.41081631E-07_JPRB, &
  & 0.40487802E-07_JPRB, 0.40026240E-07_JPRB, 0.39736097E-07_JPRB, 0.39670493E-07_JPRB, 0.39794905E-07_JPRB, 0.40118646E-07_JPRB, &
  & 0.40582673E-07_JPRB, 0.41079563E-07_JPRB, 0.41518280E-07_JPRB, 0.41937398E-07_JPRB, 0.42526416E-07_JPRB, 0.43459124E-07_JPRB, &
  & 0.44774321E-07_JPRB, 0.46344887E-07_JPRB, 0.47943445E-07_JPRB, 0.49442885E-07_JPRB, 0.50789975E-07_JPRB, 0.51968776E-07_JPRB, &
  & 0.53079781E-07_JPRB, 0.54124779E-07_JPRB, 0.55150281E-07_JPRB, 0.56211352E-07_JPRB, 0.57297033E-07_JPRB, 0.58444581E-07_JPRB, &
  & 0.59653885E-07_JPRB, 0.60862789E-07_JPRB, 0.62011338E-07_JPRB, 0.63119764E-07_JPRB, 0.64170266E-07_JPRB, 0.65236478E-07_JPRB, &
  & 0.66347397E-07_JPRB, 0.67652515E-07_JPRB, 0.69237302E-07_JPRB, 0.70520542E-07_JPRB, 0.71619972E-07_JPRB, 0.72466726E-07_JPRB, &
  & 0.73168003E-07_JPRB, 0.73696107E-07_JPRB, 0.74509245E-07_JPRB, 0.76521424E-07_JPRB /)

RGHG7(:,75, 5) = (/ &
  & 0.44905995E-07_JPRB, 0.42231193E-07_JPRB, 0.41151196E-07_JPRB, 0.40614996E-07_JPRB, 0.40256456E-07_JPRB, 0.39995292E-07_JPRB, &
  & 0.39793218E-07_JPRB, 0.39619977E-07_JPRB, 0.39472546E-07_JPRB, 0.39379596E-07_JPRB, 0.39343586E-07_JPRB, 0.39381472E-07_JPRB, &
  & 0.39498534E-07_JPRB, 0.39684895E-07_JPRB, 0.39979682E-07_JPRB, 0.40312703E-07_JPRB, 0.40688246E-07_JPRB, 0.41074646E-07_JPRB, &
  & 0.41425089E-07_JPRB, 0.41684373E-07_JPRB, 0.41797765E-07_JPRB, 0.41730445E-07_JPRB, 0.41508805E-07_JPRB, 0.41170335E-07_JPRB, &
  & 0.40832351E-07_JPRB, 0.40623430E-07_JPRB, 0.40537014E-07_JPRB, 0.40683240E-07_JPRB, 0.40965592E-07_JPRB, 0.41389509E-07_JPRB, &
  & 0.41938041E-07_JPRB, 0.42493411E-07_JPRB, 0.42996863E-07_JPRB, 0.43472227E-07_JPRB, 0.44075367E-07_JPRB, 0.44945015E-07_JPRB, &
  & 0.46100173E-07_JPRB, 0.47483066E-07_JPRB, 0.48898436E-07_JPRB, 0.50247639E-07_JPRB, 0.51474863E-07_JPRB, 0.52571988E-07_JPRB, &
  & 0.53617246E-07_JPRB, 0.54605135E-07_JPRB, 0.55569188E-07_JPRB, 0.56569057E-07_JPRB, 0.57573086E-07_JPRB, 0.58620255E-07_JPRB, &
  & 0.59723547E-07_JPRB, 0.60798357E-07_JPRB, 0.61831081E-07_JPRB, 0.62808461E-07_JPRB, 0.63747464E-07_JPRB, 0.64678090E-07_JPRB, &
  & 0.65643533E-07_JPRB, 0.66793405E-07_JPRB, 0.68115455E-07_JPRB, 0.69269774E-07_JPRB, 0.70177364E-07_JPRB, 0.70919597E-07_JPRB, &
  & 0.71521782E-07_JPRB, 0.71977418E-07_JPRB, 0.72664527E-07_JPRB, 0.74526788E-07_JPRB /)

RGHG7(:,76, 5) = (/ &
  & 0.43026049E-07_JPRB, 0.40294172E-07_JPRB, 0.39342382E-07_JPRB, 0.38869214E-07_JPRB, 0.38597346E-07_JPRB, 0.38407638E-07_JPRB, &
  & 0.38267526E-07_JPRB, 0.38163410E-07_JPRB, 0.38099873E-07_JPRB, 0.38097628E-07_JPRB, 0.38149061E-07_JPRB, 0.38299849E-07_JPRB, &
  & 0.38513409E-07_JPRB, 0.38799460E-07_JPRB, 0.39123609E-07_JPRB, 0.39526686E-07_JPRB, 0.39947381E-07_JPRB, 0.40391246E-07_JPRB, &
  & 0.40802234E-07_JPRB, 0.41143625E-07_JPRB, 0.41369795E-07_JPRB, 0.41462258E-07_JPRB, 0.41450392E-07_JPRB, 0.41351115E-07_JPRB, &
  & 0.41242750E-07_JPRB, 0.41305334E-07_JPRB, 0.41393548E-07_JPRB, 0.41711967E-07_JPRB, 0.42115374E-07_JPRB, 0.42628070E-07_JPRB, &
  & 0.43251251E-07_JPRB, 0.43862340E-07_JPRB, 0.44427704E-07_JPRB, 0.44963233E-07_JPRB, 0.45592717E-07_JPRB, 0.46422656E-07_JPRB, &
  & 0.47501935E-07_JPRB, 0.48719542E-07_JPRB, 0.49961816E-07_JPRB, 0.51169696E-07_JPRB, 0.52279745E-07_JPRB, 0.53291274E-07_JPRB, &
  & 0.54273848E-07_JPRB, 0.55186611E-07_JPRB, 0.56093601E-07_JPRB, 0.57026512E-07_JPRB, 0.57937491E-07_JPRB, 0.58899587E-07_JPRB, &
  & 0.59873898E-07_JPRB, 0.60828697E-07_JPRB, 0.61733751E-07_JPRB, 0.62597906E-07_JPRB, 0.63410290E-07_JPRB, 0.64225311E-07_JPRB, &
  & 0.65049335E-07_JPRB, 0.66005953E-07_JPRB, 0.67141968E-07_JPRB, 0.68075877E-07_JPRB, 0.68849410E-07_JPRB, 0.69462750E-07_JPRB, &
  & 0.69976970E-07_JPRB, 0.70346019E-07_JPRB, 0.70938377E-07_JPRB, 0.72632361E-07_JPRB /)

RGHG7(:,77, 5) = (/ &
  & 0.41033999E-07_JPRB, 0.38476909E-07_JPRB, 0.37588617E-07_JPRB, 0.37246412E-07_JPRB, 0.37057205E-07_JPRB, 0.36951231E-07_JPRB, &
  & 0.36888451E-07_JPRB, 0.36865135E-07_JPRB, 0.36896679E-07_JPRB, 0.36966036E-07_JPRB, 0.37130206E-07_JPRB, 0.37325972E-07_JPRB, &
  & 0.37618232E-07_JPRB, 0.37958994E-07_JPRB, 0.38380982E-07_JPRB, 0.38839044E-07_JPRB, 0.39306396E-07_JPRB, 0.39799954E-07_JPRB, &
  & 0.40272951E-07_JPRB, 0.40699991E-07_JPRB, 0.41039350E-07_JPRB, 0.41281570E-07_JPRB, 0.41476444E-07_JPRB, 0.41586766E-07_JPRB, &
  & 0.41701384E-07_JPRB, 0.42008267E-07_JPRB, 0.42265185E-07_JPRB, 0.42780879E-07_JPRB, 0.43331244E-07_JPRB, 0.43936069E-07_JPRB, &
  & 0.44631573E-07_JPRB, 0.45301277E-07_JPRB, 0.45935806E-07_JPRB, 0.46541309E-07_JPRB, 0.47203820E-07_JPRB, 0.47998824E-07_JPRB, &
  & 0.48939558E-07_JPRB, 0.49986646E-07_JPRB, 0.51083703E-07_JPRB, 0.52148103E-07_JPRB, 0.53150238E-07_JPRB, 0.54079038E-07_JPRB, &
  & 0.54985705E-07_JPRB, 0.55831247E-07_JPRB, 0.56682087E-07_JPRB, 0.57531217E-07_JPRB, 0.58369668E-07_JPRB, 0.59227730E-07_JPRB, &
  & 0.60093541E-07_JPRB, 0.60925963E-07_JPRB, 0.61714793E-07_JPRB, 0.62461872E-07_JPRB, 0.63168812E-07_JPRB, 0.63858110E-07_JPRB, &
  & 0.64546519E-07_JPRB, 0.65331029E-07_JPRB, 0.66228033E-07_JPRB, 0.66984370E-07_JPRB, 0.67612469E-07_JPRB, 0.68092348E-07_JPRB, &
  & 0.68528699E-07_JPRB, 0.68824434E-07_JPRB, 0.69294742E-07_JPRB, 0.70865937E-07_JPRB /)

RGHG7(:,78, 5) = (/ &
  & 0.39049681E-07_JPRB, 0.36734331E-07_JPRB, 0.36019252E-07_JPRB, 0.35800053E-07_JPRB, 0.35721499E-07_JPRB, 0.35698246E-07_JPRB, &
  & 0.35723126E-07_JPRB, 0.35797559E-07_JPRB, 0.35914955E-07_JPRB, 0.36101472E-07_JPRB, 0.36315637E-07_JPRB, 0.36632066E-07_JPRB, &
  & 0.36975873E-07_JPRB, 0.37375425E-07_JPRB, 0.37795601E-07_JPRB, 0.38284234E-07_JPRB, 0.38793257E-07_JPRB, 0.39320106E-07_JPRB, &
  & 0.39843989E-07_JPRB, 0.40348702E-07_JPRB, 0.40791981E-07_JPRB, 0.41176932E-07_JPRB, 0.41548780E-07_JPRB, 0.41830869E-07_JPRB, &
  & 0.42179753E-07_JPRB, 0.42661267E-07_JPRB, 0.43089081E-07_JPRB, 0.43679048E-07_JPRB, 0.44330534E-07_JPRB, 0.44971515E-07_JPRB, &
  & 0.45706361E-07_JPRB, 0.46422688E-07_JPRB, 0.47115538E-07_JPRB, 0.47792756E-07_JPRB, 0.48511854E-07_JPRB, 0.49318636E-07_JPRB, &
  & 0.50216638E-07_JPRB, 0.51168197E-07_JPRB, 0.52141562E-07_JPRB, 0.53080161E-07_JPRB, 0.53987161E-07_JPRB, 0.54835446E-07_JPRB, &
  & 0.55673592E-07_JPRB, 0.56452663E-07_JPRB, 0.57243163E-07_JPRB, 0.58025922E-07_JPRB, 0.58786448E-07_JPRB, 0.59558491E-07_JPRB, &
  & 0.60312978E-07_JPRB, 0.61038364E-07_JPRB, 0.61725217E-07_JPRB, 0.62373431E-07_JPRB, 0.62980476E-07_JPRB, 0.63569495E-07_JPRB, &
  & 0.64145389E-07_JPRB, 0.64764279E-07_JPRB, 0.65453484E-07_JPRB, 0.66038950E-07_JPRB, 0.66514566E-07_JPRB, 0.66903453E-07_JPRB, &
  & 0.67252607E-07_JPRB, 0.67484180E-07_JPRB, 0.67821624E-07_JPRB, 0.69169054E-07_JPRB /)

RGHG7(:,79, 5) = (/ &
  & 0.37103106E-07_JPRB, 0.35401047E-07_JPRB, 0.34909394E-07_JPRB, 0.34879619E-07_JPRB, 0.34892366E-07_JPRB, 0.34953544E-07_JPRB, &
  & 0.35066108E-07_JPRB, 0.35227448E-07_JPRB, 0.35426595E-07_JPRB, 0.35654065E-07_JPRB, 0.35940410E-07_JPRB, 0.36243630E-07_JPRB, &
  & 0.36615937E-07_JPRB, 0.37034951E-07_JPRB, 0.37498399E-07_JPRB, 0.37992546E-07_JPRB, 0.38513537E-07_JPRB, 0.39055774E-07_JPRB, &
  & 0.39596234E-07_JPRB, 0.40140481E-07_JPRB, 0.40646754E-07_JPRB, 0.41132960E-07_JPRB, 0.41603162E-07_JPRB, 0.41968057E-07_JPRB, &
  & 0.42525535E-07_JPRB, 0.42970846E-07_JPRB, 0.43558664E-07_JPRB, 0.44116589E-07_JPRB, 0.44841237E-07_JPRB, 0.45510742E-07_JPRB, &
  & 0.46253462E-07_JPRB, 0.46998164E-07_JPRB, 0.47725976E-07_JPRB, 0.48445777E-07_JPRB, 0.49196284E-07_JPRB, 0.50017039E-07_JPRB, &
  & 0.50885880E-07_JPRB, 0.51789641E-07_JPRB, 0.52725607E-07_JPRB, 0.53595446E-07_JPRB, 0.54468490E-07_JPRB, 0.55261555E-07_JPRB, &
  & 0.56060866E-07_JPRB, 0.56799973E-07_JPRB, 0.57554775E-07_JPRB, 0.58289530E-07_JPRB, 0.59010826E-07_JPRB, 0.59730290E-07_JPRB, &
  & 0.60430651E-07_JPRB, 0.61101510E-07_JPRB, 0.61735058E-07_JPRB, 0.62336795E-07_JPRB, 0.62895872E-07_JPRB, 0.63435124E-07_JPRB, &
  & 0.63941656E-07_JPRB, 0.64478222E-07_JPRB, 0.65033426E-07_JPRB, 0.65502903E-07_JPRB, 0.65917213E-07_JPRB, 0.66196073E-07_JPRB, &
  & 0.66516868E-07_JPRB, 0.66689232E-07_JPRB, 0.66845381E-07_JPRB, 0.67850223E-07_JPRB /)

RGHG7(:,80, 5) = (/ &
  & 0.35859870E-07_JPRB, 0.34774434E-07_JPRB, 0.34449489E-07_JPRB, 0.34563637E-07_JPRB, 0.34591761E-07_JPRB, 0.34673359E-07_JPRB, &
  & 0.34815660E-07_JPRB, 0.34988791E-07_JPRB, 0.35207876E-07_JPRB, 0.35454860E-07_JPRB, 0.35744716E-07_JPRB, 0.36099323E-07_JPRB, &
  & 0.36486391E-07_JPRB, 0.36914823E-07_JPRB, 0.37361886E-07_JPRB, 0.37862737E-07_JPRB, 0.38391541E-07_JPRB, 0.38944638E-07_JPRB, &
  & 0.39493248E-07_JPRB, 0.40050359E-07_JPRB, 0.40576392E-07_JPRB, 0.41110098E-07_JPRB, 0.41587462E-07_JPRB, 0.42011706E-07_JPRB, &
  & 0.42671424E-07_JPRB, 0.43054207E-07_JPRB, 0.43783469E-07_JPRB, 0.44326121E-07_JPRB, 0.45049376E-07_JPRB, 0.45753936E-07_JPRB, &
  & 0.46499842E-07_JPRB, 0.47257839E-07_JPRB, 0.48001414E-07_JPRB, 0.48739395E-07_JPRB, 0.49506429E-07_JPRB, 0.50333085E-07_JPRB, &
  & 0.51187779E-07_JPRB, 0.52096976E-07_JPRB, 0.52972375E-07_JPRB, 0.53801461E-07_JPRB, 0.54658511E-07_JPRB, 0.55417722E-07_JPRB, &
  & 0.56208282E-07_JPRB, 0.56927227E-07_JPRB, 0.57677639E-07_JPRB, 0.58399525E-07_JPRB, 0.59108661E-07_JPRB, 0.59806503E-07_JPRB, &
  & 0.60482414E-07_JPRB, 0.61127913E-07_JPRB, 0.61738710E-07_JPRB, 0.62315927E-07_JPRB, 0.62851768E-07_JPRB, 0.63366208E-07_JPRB, &
  & 0.63855978E-07_JPRB, 0.64355930E-07_JPRB, 0.64876154E-07_JPRB, 0.65313365E-07_JPRB, 0.65693925E-07_JPRB, 0.65956549E-07_JPRB, &
  & 0.66246614E-07_JPRB, 0.66421151E-07_JPRB, 0.66438474E-07_JPRB, 0.67151738E-07_JPRB /)

RGHG7(:,81, 5) = (/ &
  & 0.35069736E-07_JPRB, 0.34426435E-07_JPRB, 0.34211620E-07_JPRB, 0.34434319E-07_JPRB, 0.34400625E-07_JPRB, 0.34517406E-07_JPRB, &
  & 0.34677161E-07_JPRB, 0.34879534E-07_JPRB, 0.35098473E-07_JPRB, 0.35388481E-07_JPRB, 0.35675562E-07_JPRB, 0.36014871E-07_JPRB, &
  & 0.36402071E-07_JPRB, 0.36828549E-07_JPRB, 0.37303433E-07_JPRB, 0.37803481E-07_JPRB, 0.38329127E-07_JPRB, 0.38884728E-07_JPRB, &
  & 0.39438717E-07_JPRB, 0.40000547E-07_JPRB, 0.40536321E-07_JPRB, 0.41109878E-07_JPRB, 0.41550134E-07_JPRB, 0.42110067E-07_JPRB, &
  & 0.42673776E-07_JPRB, 0.43160494E-07_JPRB, 0.43817106E-07_JPRB, 0.44435016E-07_JPRB, 0.45125653E-07_JPRB, 0.45854865E-07_JPRB, &
  & 0.46599187E-07_JPRB, 0.47362320E-07_JPRB, 0.48119432E-07_JPRB, 0.48870639E-07_JPRB, 0.49646225E-07_JPRB, 0.50479638E-07_JPRB, &
  & 0.51328350E-07_JPRB, 0.52223079E-07_JPRB, 0.53070966E-07_JPRB, 0.53917830E-07_JPRB, 0.54767931E-07_JPRB, 0.55496482E-07_JPRB, &
  & 0.56291661E-07_JPRB, 0.56995294E-07_JPRB, 0.57737250E-07_JPRB, 0.58451771E-07_JPRB, 0.59152786E-07_JPRB, 0.59838854E-07_JPRB, &
  & 0.60508015E-07_JPRB, 0.61140526E-07_JPRB, 0.61745091E-07_JPRB, 0.62312658E-07_JPRB, 0.62843483E-07_JPRB, 0.63350569E-07_JPRB, &
  & 0.63821695E-07_JPRB, 0.64303556E-07_JPRB, 0.64795614E-07_JPRB, 0.65190306E-07_JPRB, 0.65586896E-07_JPRB, 0.65797956E-07_JPRB, &
  & 0.66079494E-07_JPRB, 0.66287640E-07_JPRB, 0.66176305E-07_JPRB, 0.66623777E-07_JPRB /)

RGHG7(:,82, 5) = (/ &
  & 0.34570338E-07_JPRB, 0.34203470E-07_JPRB, 0.34157178E-07_JPRB, 0.34427785E-07_JPRB, 0.34297553E-07_JPRB, 0.34494590E-07_JPRB, &
  & 0.34640049E-07_JPRB, 0.34815564E-07_JPRB, 0.35089144E-07_JPRB, 0.35315896E-07_JPRB, 0.35646195E-07_JPRB, 0.35985863E-07_JPRB, &
  & 0.36373240E-07_JPRB, 0.36817397E-07_JPRB, 0.37266968E-07_JPRB, 0.37774800E-07_JPRB, 0.38300417E-07_JPRB, 0.38859326E-07_JPRB, &
  & 0.39410182E-07_JPRB, 0.39972601E-07_JPRB, 0.40516738E-07_JPRB, 0.41090964E-07_JPRB, 0.41509555E-07_JPRB, 0.42175053E-07_JPRB, &
  & 0.42589082E-07_JPRB, 0.43257664E-07_JPRB, 0.43808047E-07_JPRB, 0.44497284E-07_JPRB, 0.45164825E-07_JPRB, 0.45901839E-07_JPRB, &
  & 0.46661100E-07_JPRB, 0.47426983E-07_JPRB, 0.48184049E-07_JPRB, 0.48940070E-07_JPRB, 0.49721788E-07_JPRB, 0.50560423E-07_JPRB, &
  & 0.51396288E-07_JPRB, 0.52302184E-07_JPRB, 0.53113641E-07_JPRB, 0.53974450E-07_JPRB, 0.54773523E-07_JPRB, 0.55505989E-07_JPRB, &
  & 0.56301154E-07_JPRB, 0.56997180E-07_JPRB, 0.57749997E-07_JPRB, 0.58464451E-07_JPRB, 0.59170048E-07_JPRB, 0.59855367E-07_JPRB, &
  & 0.60520961E-07_JPRB, 0.61144803E-07_JPRB, 0.61749738E-07_JPRB, 0.62303734E-07_JPRB, 0.62835717E-07_JPRB, 0.63328095E-07_JPRB, &
  & 0.63809807E-07_JPRB, 0.64277003E-07_JPRB, 0.64787997E-07_JPRB, 0.65154381E-07_JPRB, 0.65567242E-07_JPRB, 0.65779687E-07_JPRB, &
  & 0.66012866E-07_JPRB, 0.66302640E-07_JPRB, 0.66093001E-07_JPRB, 0.66442006E-07_JPRB /)

RGHG7(:,83, 5) = (/ &
  & 0.34632091E-07_JPRB, 0.34012491E-07_JPRB, 0.34220211E-07_JPRB, 0.34385597E-07_JPRB, 0.34194549E-07_JPRB, 0.34501376E-07_JPRB, &
  & 0.34557111E-07_JPRB, 0.34833782E-07_JPRB, 0.35008970E-07_JPRB, 0.35364881E-07_JPRB, 0.35594958E-07_JPRB, 0.35971368E-07_JPRB, &
  & 0.36342126E-07_JPRB, 0.36758998E-07_JPRB, 0.37242845E-07_JPRB, 0.37748702E-07_JPRB, 0.38278625E-07_JPRB, 0.38827359E-07_JPRB, &
  & 0.39389640E-07_JPRB, 0.39942734E-07_JPRB, 0.40508422E-07_JPRB, 0.41042824E-07_JPRB, 0.41529852E-07_JPRB, 0.42160522E-07_JPRB, &
  & 0.42596021E-07_JPRB, 0.43264855E-07_JPRB, 0.43822080E-07_JPRB, 0.44500567E-07_JPRB, 0.45192547E-07_JPRB, 0.45917524E-07_JPRB, &
  & 0.46672028E-07_JPRB, 0.47441763E-07_JPRB, 0.48213384E-07_JPRB, 0.48983281E-07_JPRB, 0.49775803E-07_JPRB, 0.50614428E-07_JPRB, &
  & 0.51462937E-07_JPRB, 0.52358157E-07_JPRB, 0.53153737E-07_JPRB, 0.54026668E-07_JPRB, 0.54792132E-07_JPRB, 0.55533793E-07_JPRB, &
  & 0.56312125E-07_JPRB, 0.57006126E-07_JPRB, 0.57760698E-07_JPRB, 0.58478101E-07_JPRB, 0.59182785E-07_JPRB, 0.59863410E-07_JPRB, &
  & 0.60527370E-07_JPRB, 0.61149187E-07_JPRB, 0.61755124E-07_JPRB, 0.62301389E-07_JPRB, 0.62847207E-07_JPRB, 0.63320613E-07_JPRB, &
  & 0.63818653E-07_JPRB, 0.64248432E-07_JPRB, 0.64779719E-07_JPRB, 0.65101247E-07_JPRB, 0.65525320E-07_JPRB, 0.65756609E-07_JPRB, &
  & 0.65906328E-07_JPRB, 0.66318371E-07_JPRB, 0.65998485E-07_JPRB, 0.66519434E-07_JPRB /)

RGHG7(:,84, 5) = (/ &
  & 0.34709561E-07_JPRB, 0.33802657E-07_JPRB, 0.34373457E-07_JPRB, 0.34272457E-07_JPRB, 0.34170942E-07_JPRB, 0.34537194E-07_JPRB, &
  & 0.34523239E-07_JPRB, 0.34834233E-07_JPRB, 0.35051098E-07_JPRB, 0.35315754E-07_JPRB, 0.35622474E-07_JPRB, 0.35943906E-07_JPRB, &
  & 0.36329364E-07_JPRB, 0.36763254E-07_JPRB, 0.37211951E-07_JPRB, 0.37726753E-07_JPRB, 0.38257244E-07_JPRB, 0.38807045E-07_JPRB, &
  & 0.39369588E-07_JPRB, 0.39918401E-07_JPRB, 0.40488153E-07_JPRB, 0.40992020E-07_JPRB, 0.41570541E-07_JPRB, 0.42077374E-07_JPRB, &
  & 0.42637541E-07_JPRB, 0.43226066E-07_JPRB, 0.43843119E-07_JPRB, 0.44501139E-07_JPRB, 0.45200871E-07_JPRB, 0.45939075E-07_JPRB, &
  & 0.46713630E-07_JPRB, 0.47487724E-07_JPRB, 0.48246100E-07_JPRB, 0.49019445E-07_JPRB, 0.49820162E-07_JPRB, 0.50674089E-07_JPRB, &
  & 0.51529380E-07_JPRB, 0.52420745E-07_JPRB, 0.53221758E-07_JPRB, 0.54044563E-07_JPRB, 0.54781470E-07_JPRB, 0.55526069E-07_JPRB, &
  & 0.56270800E-07_JPRB, 0.56981282E-07_JPRB, 0.57730357E-07_JPRB, 0.58468288E-07_JPRB, 0.59181719E-07_JPRB, 0.59868761E-07_JPRB, &
  & 0.60528073E-07_JPRB, 0.61153720E-07_JPRB, 0.61751663E-07_JPRB, 0.62301240E-07_JPRB, 0.62844393E-07_JPRB, 0.63307105E-07_JPRB, &
  & 0.63824771E-07_JPRB, 0.64234918E-07_JPRB, 0.64792737E-07_JPRB, 0.65110392E-07_JPRB, 0.65490433E-07_JPRB, 0.65825802E-07_JPRB, &
  & 0.65815605E-07_JPRB, 0.66393042E-07_JPRB, 0.65928155E-07_JPRB, 0.66491779E-07_JPRB /)

RGHG7(:,85, 5) = (/ &
  & 0.34792563E-07_JPRB, 0.33615617E-07_JPRB, 0.34559143E-07_JPRB, 0.34084039E-07_JPRB, 0.34241367E-07_JPRB, 0.34528323E-07_JPRB, &
  & 0.34478600E-07_JPRB, 0.34927950E-07_JPRB, 0.34960593E-07_JPRB, 0.35421486E-07_JPRB, 0.35560014E-07_JPRB, 0.35999321E-07_JPRB, &
  & 0.36295596E-07_JPRB, 0.36733773E-07_JPRB, 0.37184154E-07_JPRB, 0.37681570E-07_JPRB, 0.38216715E-07_JPRB, 0.38773500E-07_JPRB, &
  & 0.39335504E-07_JPRB, 0.39884515E-07_JPRB, 0.40460232E-07_JPRB, 0.40979842E-07_JPRB, 0.41549068E-07_JPRB, 0.42051116E-07_JPRB, &
  & 0.42638966E-07_JPRB, 0.43200600E-07_JPRB, 0.43834788E-07_JPRB, 0.44490335E-07_JPRB, 0.45202963E-07_JPRB, 0.45931259E-07_JPRB, &
  & 0.46678842E-07_JPRB, 0.47457675E-07_JPRB, 0.48253874E-07_JPRB, 0.49045990E-07_JPRB, 0.49862503E-07_JPRB, 0.50720075E-07_JPRB, &
  & 0.51613362E-07_JPRB, 0.52462962E-07_JPRB, 0.53305996E-07_JPRB, 0.54089259E-07_JPRB, 0.54826586E-07_JPRB, 0.55550558E-07_JPRB, &
  & 0.56259577E-07_JPRB, 0.56979683E-07_JPRB, 0.57724055E-07_JPRB, 0.58459449E-07_JPRB, 0.59184615E-07_JPRB, 0.59866757E-07_JPRB, &
  & 0.60525096E-07_JPRB, 0.61159056E-07_JPRB, 0.61742618E-07_JPRB, 0.62316403E-07_JPRB, 0.62834914E-07_JPRB, 0.63329807E-07_JPRB, &
  & 0.63810887E-07_JPRB, 0.64258323E-07_JPRB, 0.64739879E-07_JPRB, 0.65163064E-07_JPRB, 0.65372454E-07_JPRB, 0.65919558E-07_JPRB, &
  & 0.65678591E-07_JPRB, 0.66460785E-07_JPRB, 0.65848113E-07_JPRB, 0.66533055E-07_JPRB /)

RGHG7(:,86, 5) = (/ &
  & 0.34887655E-07_JPRB, 0.33462197E-07_JPRB, 0.34736686E-07_JPRB, 0.33872773E-07_JPRB, 0.34402735E-07_JPRB, 0.34444270E-07_JPRB, &
  & 0.34535390E-07_JPRB, 0.34929187E-07_JPRB, 0.35071295E-07_JPRB, 0.35368583E-07_JPRB, 0.35690128E-07_JPRB, 0.35938534E-07_JPRB, &
  & 0.36362881E-07_JPRB, 0.36700069E-07_JPRB, 0.37148663E-07_JPRB, 0.37640124E-07_JPRB, 0.38162643E-07_JPRB, 0.38712351E-07_JPRB, &
  & 0.39287833E-07_JPRB, 0.39855859E-07_JPRB, 0.40424975E-07_JPRB, 0.40962487E-07_JPRB, 0.41507409E-07_JPRB, 0.42042320E-07_JPRB, &
  & 0.42603627E-07_JPRB, 0.43187601E-07_JPRB, 0.43814751E-07_JPRB, 0.44482412E-07_JPRB, 0.45195531E-07_JPRB, 0.45950735E-07_JPRB, &
  & 0.46764221E-07_JPRB, 0.47539530E-07_JPRB, 0.48285607E-07_JPRB, 0.49061818E-07_JPRB, 0.49889334E-07_JPRB, 0.50751130E-07_JPRB, &
  & 0.51679212E-07_JPRB, 0.52516143E-07_JPRB, 0.53412297E-07_JPRB, 0.54098837E-07_JPRB, 0.54883834E-07_JPRB, 0.55565241E-07_JPRB, &
  & 0.56259445E-07_JPRB, 0.56994672E-07_JPRB, 0.57725483E-07_JPRB, 0.58455623E-07_JPRB, 0.59185236E-07_JPRB, 0.59874935E-07_JPRB, &
  & 0.60519433E-07_JPRB, 0.61161053E-07_JPRB, 0.61729203E-07_JPRB, 0.62329114E-07_JPRB, 0.62805604E-07_JPRB, 0.63365967E-07_JPRB, &
  & 0.63756829E-07_JPRB, 0.64337165E-07_JPRB, 0.64652319E-07_JPRB, 0.65292269E-07_JPRB, 0.65243256E-07_JPRB, 0.66059542E-07_JPRB, &
  & 0.65573218E-07_JPRB, 0.66538192E-07_JPRB, 0.65787013E-07_JPRB, 0.66557320E-07_JPRB /)

RGHG7(:,87, 5) = (/ &
  & 0.35024197E-07_JPRB, 0.33354905E-07_JPRB, 0.34868215E-07_JPRB, 0.33683222E-07_JPRB, 0.34606131E-07_JPRB, 0.34263575E-07_JPRB, &
  & 0.34706289E-07_JPRB, 0.34886391E-07_JPRB, 0.35135461E-07_JPRB, 0.35435725E-07_JPRB, 0.35665554E-07_JPRB, 0.36028155E-07_JPRB, &
  & 0.36313967E-07_JPRB, 0.36694178E-07_JPRB, 0.37126636E-07_JPRB, 0.37560628E-07_JPRB, 0.38101710E-07_JPRB, 0.38647993E-07_JPRB, &
  & 0.39233555E-07_JPRB, 0.39813596E-07_JPRB, 0.40389462E-07_JPRB, 0.40938907E-07_JPRB, 0.41486054E-07_JPRB, 0.42026990E-07_JPRB, &
  & 0.42584354E-07_JPRB, 0.43172498E-07_JPRB, 0.43802661E-07_JPRB, 0.44473772E-07_JPRB, 0.45199030E-07_JPRB, 0.45928509E-07_JPRB, &
  & 0.46637702E-07_JPRB, 0.47436494E-07_JPRB, 0.48293298E-07_JPRB, 0.49078952E-07_JPRB, 0.49897711E-07_JPRB, 0.50787158E-07_JPRB, &
  & 0.51691714E-07_JPRB, 0.52582312E-07_JPRB, 0.53434107E-07_JPRB, 0.54204243E-07_JPRB, 0.54944415E-07_JPRB, 0.55654926E-07_JPRB, &
  & 0.56338695E-07_JPRB, 0.57037596E-07_JPRB, 0.57795418E-07_JPRB, 0.58496834E-07_JPRB, 0.59203639E-07_JPRB, 0.59878687E-07_JPRB, &
  & 0.60520918E-07_JPRB, 0.61152299E-07_JPRB, 0.61723320E-07_JPRB, 0.62331061E-07_JPRB, 0.62790633E-07_JPRB, 0.63402283E-07_JPRB, &
  & 0.63712157E-07_JPRB, 0.64408738E-07_JPRB, 0.64557668E-07_JPRB, 0.65388164E-07_JPRB, 0.65140199E-07_JPRB, 0.66119888E-07_JPRB, &
  & 0.65522286E-07_JPRB, 0.66551067E-07_JPRB, 0.65763466E-07_JPRB, 0.66576042E-07_JPRB /)

RGHG7(:,88, 5) = (/ &
  & 0.35056281E-07_JPRB, 0.33269309E-07_JPRB, 0.34914528E-07_JPRB, 0.33548961E-07_JPRB, 0.34741081E-07_JPRB, 0.34089492E-07_JPRB, &
  & 0.34877967E-07_JPRB, 0.34773866E-07_JPRB, 0.35259021E-07_JPRB, 0.35393363E-07_JPRB, 0.35754397E-07_JPRB, 0.35988833E-07_JPRB, &
  & 0.36321062E-07_JPRB, 0.36679374E-07_JPRB, 0.37039854E-07_JPRB, 0.37548816E-07_JPRB, 0.38020953E-07_JPRB, 0.38612260E-07_JPRB, &
  & 0.39179902E-07_JPRB, 0.39784204E-07_JPRB, 0.40355012E-07_JPRB, 0.40923108E-07_JPRB, 0.41461522E-07_JPRB, 0.42007741E-07_JPRB, &
  & 0.42562498E-07_JPRB, 0.43153570E-07_JPRB, 0.43784464E-07_JPRB, 0.44458574E-07_JPRB, 0.45176897E-07_JPRB, 0.45979196E-07_JPRB, &
  & 0.46859103E-07_JPRB, 0.47597467E-07_JPRB, 0.48311385E-07_JPRB, 0.49093355E-07_JPRB, 0.49925468E-07_JPRB, 0.50806541E-07_JPRB, &
  & 0.51728261E-07_JPRB, 0.52627193E-07_JPRB, 0.53500969E-07_JPRB, 0.54280882E-07_JPRB, 0.55044598E-07_JPRB, 0.55720285E-07_JPRB, &
  & 0.56475415E-07_JPRB, 0.57121348E-07_JPRB, 0.57862071E-07_JPRB, 0.58551784E-07_JPRB, 0.59228206E-07_JPRB, 0.59896884E-07_JPRB, &
  & 0.60519582E-07_JPRB, 0.61147070E-07_JPRB, 0.61714800E-07_JPRB, 0.62321320E-07_JPRB, 0.62786796E-07_JPRB, 0.63403817E-07_JPRB, &
  & 0.63702572E-07_JPRB, 0.64431269E-07_JPRB, 0.64546498E-07_JPRB, 0.65410106E-07_JPRB, 0.65145080E-07_JPRB, 0.66116854E-07_JPRB, &
  & 0.65545279E-07_JPRB, 0.66531982E-07_JPRB, 0.65781030E-07_JPRB, 0.66560773E-07_JPRB /)

RGHG7(:,89, 5) = (/ &
  & 0.35168853E-07_JPRB, 0.33227447E-07_JPRB, 0.34962447E-07_JPRB, 0.33641555E-07_JPRB, 0.34726273E-07_JPRB, 0.34188375E-07_JPRB, &
  & 0.34735979E-07_JPRB, 0.34855859E-07_JPRB, 0.35145849E-07_JPRB, 0.35424172E-07_JPRB, 0.35684220E-07_JPRB, 0.35953548E-07_JPRB, &
  & 0.36271363E-07_JPRB, 0.36581934E-07_JPRB, 0.37048462E-07_JPRB, 0.37458914E-07_JPRB, 0.38048572E-07_JPRB, 0.38559875E-07_JPRB, &
  & 0.39183373E-07_JPRB, 0.39742403E-07_JPRB, 0.40342169E-07_JPRB, 0.40887119E-07_JPRB, 0.41437296E-07_JPRB, 0.41977273E-07_JPRB, &
  & 0.42535181E-07_JPRB, 0.43123478E-07_JPRB, 0.43756554E-07_JPRB, 0.44439748E-07_JPRB, 0.45169827E-07_JPRB, 0.45849806E-07_JPRB, &
  & 0.46537696E-07_JPRB, 0.47427655E-07_JPRB, 0.48323681E-07_JPRB, 0.49129568E-07_JPRB, 0.49969639E-07_JPRB, 0.50859821E-07_JPRB, &
  & 0.51791869E-07_JPRB, 0.52717724E-07_JPRB, 0.53583143E-07_JPRB, 0.54397798E-07_JPRB, 0.55160729E-07_JPRB, 0.55867346E-07_JPRB, &
  & 0.56580340E-07_JPRB, 0.57261577E-07_JPRB, 0.57932546E-07_JPRB, 0.58620046E-07_JPRB, 0.59250286E-07_JPRB, 0.59907485E-07_JPRB, &
  & 0.60526311E-07_JPRB, 0.61137754E-07_JPRB, 0.61717394E-07_JPRB, 0.62308672E-07_JPRB, 0.62802698E-07_JPRB, 0.63391006E-07_JPRB, &
  & 0.63734944E-07_JPRB, 0.64406734E-07_JPRB, 0.64596144E-07_JPRB, 0.65360851E-07_JPRB, 0.65205725E-07_JPRB, 0.66056373E-07_JPRB, &
  & 0.65599842E-07_JPRB, 0.66484709E-07_JPRB, 0.65816948E-07_JPRB, 0.66536877E-07_JPRB /)

RGHG7(:,90, 5) = (/ &
  & 0.35255905E-07_JPRB, 0.33251926E-07_JPRB, 0.34698498E-07_JPRB, 0.33859795E-07_JPRB, 0.34276848E-07_JPRB, 0.34308012E-07_JPRB, &
  & 0.34479942E-07_JPRB, 0.34718894E-07_JPRB, 0.35144364E-07_JPRB, 0.35263877E-07_JPRB, 0.35580697E-07_JPRB, 0.35906247E-07_JPRB, &
  & 0.36154340E-07_JPRB, 0.36583216E-07_JPRB, 0.36940101E-07_JPRB, 0.37501398E-07_JPRB, 0.37985515E-07_JPRB, 0.38591185E-07_JPRB, &
  & 0.39134029E-07_JPRB, 0.39736733E-07_JPRB, 0.40292864E-07_JPRB, 0.40852939E-07_JPRB, 0.41391424E-07_JPRB, 0.41933376E-07_JPRB, &
  & 0.42486501E-07_JPRB, 0.43071704E-07_JPRB, 0.43702713E-07_JPRB, 0.44381245E-07_JPRB, 0.45148237E-07_JPRB, 0.46022269E-07_JPRB, &
  & 0.46919336E-07_JPRB, 0.47632231E-07_JPRB, 0.48345544E-07_JPRB, 0.49172215E-07_JPRB, 0.50035130E-07_JPRB, 0.50965692E-07_JPRB, &
  & 0.51922264E-07_JPRB, 0.52860472E-07_JPRB, 0.53745552E-07_JPRB, 0.54554366E-07_JPRB, 0.55314196E-07_JPRB, 0.56027794E-07_JPRB, &
  & 0.56697978E-07_JPRB, 0.57381175E-07_JPRB, 0.57996758E-07_JPRB, 0.58656699E-07_JPRB, 0.59282463E-07_JPRB, 0.59926961E-07_JPRB, &
  & 0.60529636E-07_JPRB, 0.61142138E-07_JPRB, 0.61720115E-07_JPRB, 0.62307990E-07_JPRB, 0.62824263E-07_JPRB, 0.63378351E-07_JPRB, &
  & 0.63783872E-07_JPRB, 0.64372777E-07_JPRB, 0.64684443E-07_JPRB, 0.65294387E-07_JPRB, 0.65315966E-07_JPRB, 0.65973445E-07_JPRB, &
  & 0.65701911E-07_JPRB, 0.66406223E-07_JPRB, 0.65897979E-07_JPRB, 0.66483054E-07_JPRB /)

RGHG7(:,91, 5) = (/ &
  & 0.35101824E-07_JPRB, 0.33821962E-07_JPRB, 0.34250327E-07_JPRB, 0.34203762E-07_JPRB, 0.34202898E-07_JPRB, 0.34456193E-07_JPRB, &
  & 0.34179717E-07_JPRB, 0.35301703E-07_JPRB, 0.34552947E-07_JPRB, 0.34484462E-07_JPRB, 0.35084106E-07_JPRB, 0.35986275E-07_JPRB, &
  & 0.36089684E-07_JPRB, 0.36568043E-07_JPRB, 0.37029736E-07_JPRB, 0.37488636E-07_JPRB, 0.38030006E-07_JPRB, 0.38555793E-07_JPRB, &
  & 0.39129006E-07_JPRB, 0.39683517E-07_JPRB, 0.40237083E-07_JPRB, 0.40778808E-07_JPRB, 0.41312187E-07_JPRB, 0.41848015E-07_JPRB, &
  & 0.42397911E-07_JPRB, 0.42985143E-07_JPRB, 0.43625107E-07_JPRB, 0.44301359E-07_JPRB, 0.45015991E-07_JPRB, 0.45761418E-07_JPRB, &
  & 0.46565045E-07_JPRB, 0.47468927E-07_JPRB, 0.48383175E-07_JPRB, 0.49236601E-07_JPRB, 0.50139906E-07_JPRB, 0.51112139E-07_JPRB, &
  & 0.52109886E-07_JPRB, 0.53080331E-07_JPRB, 0.53975501E-07_JPRB, 0.54794004E-07_JPRB, 0.55540429E-07_JPRB, 0.56224906E-07_JPRB, &
  & 0.56864152E-07_JPRB, 0.57502191E-07_JPRB, 0.58096976E-07_JPRB, 0.58664106E-07_JPRB, 0.59313543E-07_JPRB, 0.59966887E-07_JPRB, &
  & 0.60521899E-07_JPRB, 0.61168443E-07_JPRB, 0.61732187E-07_JPRB, 0.62331729E-07_JPRB, 0.62860110E-07_JPRB, 0.63390623E-07_JPRB, &
  & 0.63836566E-07_JPRB, 0.64361537E-07_JPRB, 0.64780629E-07_JPRB, 0.65235959E-07_JPRB, 0.65450166E-07_JPRB, 0.65858330E-07_JPRB, &
  & 0.65871212E-07_JPRB, 0.66251559E-07_JPRB, 0.66078456E-07_JPRB, 0.66341592E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG7(:, 1, 6) = (/ &
  & 0.59862564E-05_JPRB, 0.59765221E-05_JPRB, 0.59679173E-05_JPRB, 0.59542326E-05_JPRB, 0.59348768E-05_JPRB, 0.59092185E-05_JPRB, &
  & 0.58776936E-05_JPRB, 0.58331170E-05_JPRB, 0.66071934E-07_JPRB, 0.63972976E-07_JPRB, 0.63390999E-07_JPRB, 0.63269148E-07_JPRB, &
  & 0.63462231E-07_JPRB, 0.63851580E-07_JPRB, 0.64459257E-07_JPRB, 0.65170831E-07_JPRB, 0.65882453E-07_JPRB, 0.66582416E-07_JPRB, &
  & 0.67213200E-07_JPRB, 0.67762898E-07_JPRB, 0.68195668E-07_JPRB, 0.68600400E-07_JPRB, 0.68945269E-07_JPRB, 0.69229131E-07_JPRB, &
  & 0.69419990E-07_JPRB, 0.69468783E-07_JPRB, 0.69501183E-07_JPRB, 0.69412138E-07_JPRB, 0.69185930E-07_JPRB, 0.68879466E-07_JPRB, &
  & 0.68689481E-07_JPRB, 0.68494970E-07_JPRB, 0.68535748E-07_JPRB, 0.68719856E-07_JPRB, 0.69014447E-07_JPRB, 0.69371396E-07_JPRB, &
  & 0.69739500E-07_JPRB, 0.69900778E-07_JPRB, 0.70181834E-07_JPRB, 0.70432137E-07_JPRB, 0.70541226E-07_JPRB, 0.70677096E-07_JPRB, &
  & 0.70627642E-07_JPRB, 0.70633348E-07_JPRB, 0.70611136E-07_JPRB, 0.70540551E-07_JPRB, 0.70544445E-07_JPRB, 0.70157583E-07_JPRB, &
  & 0.70284024E-07_JPRB, 0.69830463E-07_JPRB, 0.69980125E-07_JPRB, 0.69435465E-07_JPRB, 0.69651648E-07_JPRB, 0.68630847E-07_JPRB, &
  & 0.68914524E-07_JPRB, 0.67843729E-07_JPRB, 0.68446852E-07_JPRB, 0.68388573E-07_JPRB, 0.70059706E-07_JPRB, 0.70978466E-07_JPRB, &
  & 0.72757935E-07_JPRB, 0.75899059E-07_JPRB, 0.79206558E-07_JPRB, 0.83183672E-07_JPRB /)

RGHG7(:, 2, 6) = (/ &
  & 0.61713486E-05_JPRB, 0.63617267E-05_JPRB, 0.64679220E-05_JPRB, 0.65452664E-05_JPRB, 0.66086236E-05_JPRB, 0.66297748E-05_JPRB, &
  & 0.65665567E-05_JPRB, 0.60986858E-05_JPRB, 0.19150463E-06_JPRB, 0.18453750E-06_JPRB, 0.18820151E-06_JPRB, 0.19346871E-06_JPRB, &
  & 0.20019529E-06_JPRB, 0.20282660E-06_JPRB, 0.20673647E-06_JPRB, 0.20953748E-06_JPRB, 0.21030473E-06_JPRB, 0.21270496E-06_JPRB, &
  & 0.21324431E-06_JPRB, 0.21400125E-06_JPRB, 0.21350796E-06_JPRB, 0.21690448E-06_JPRB, 0.21981491E-06_JPRB, 0.22238243E-06_JPRB, &
  & 0.22399293E-06_JPRB, 0.22079939E-06_JPRB, 0.22184255E-06_JPRB, 0.22294446E-06_JPRB, 0.22124685E-06_JPRB, 0.21693917E-06_JPRB, &
  & 0.21191217E-06_JPRB, 0.20315720E-06_JPRB, 0.20039566E-06_JPRB, 0.19940539E-06_JPRB, 0.19994408E-06_JPRB, 0.20176256E-06_JPRB, &
  & 0.20405672E-06_JPRB, 0.20273845E-06_JPRB, 0.20591675E-06_JPRB, 0.21084242E-06_JPRB, 0.21499092E-06_JPRB, 0.21949484E-06_JPRB, &
  & 0.22009358E-06_JPRB, 0.22215407E-06_JPRB, 0.22501919E-06_JPRB, 0.23069994E-06_JPRB, 0.23383156E-06_JPRB, 0.23518518E-06_JPRB, &
  & 0.24305228E-06_JPRB, 0.24500815E-06_JPRB, 0.24427410E-06_JPRB, 0.24327539E-06_JPRB, 0.23411869E-06_JPRB, 0.22193196E-06_JPRB, &
  & 0.21248255E-06_JPRB, 0.21263281E-06_JPRB, 0.24058320E-06_JPRB, 0.27537629E-06_JPRB, 0.31463603E-06_JPRB, 0.36499242E-06_JPRB, &
  & 0.42147875E-06_JPRB, 0.48473055E-06_JPRB, 0.53689257E-06_JPRB, 0.58730012E-06_JPRB /)

RGHG7(:, 3, 6) = (/ &
  & 0.62708605E-05_JPRB, 0.62155405E-05_JPRB, 0.60441848E-05_JPRB, 0.58222586E-05_JPRB, 0.54956090E-05_JPRB, 0.49263454E-05_JPRB, &
  & 0.41224639E-05_JPRB, 0.32488215E-05_JPRB, 0.28430350E-06_JPRB, 0.26689665E-06_JPRB, 0.28288471E-06_JPRB, 0.30347871E-06_JPRB, &
  & 0.32858497E-06_JPRB, 0.34478452E-06_JPRB, 0.35959187E-06_JPRB, 0.36988033E-06_JPRB, 0.37222435E-06_JPRB, 0.37956696E-06_JPRB, &
  & 0.38768795E-06_JPRB, 0.39452027E-06_JPRB, 0.39434016E-06_JPRB, 0.40029070E-06_JPRB, 0.40759653E-06_JPRB, 0.41498370E-06_JPRB, &
  & 0.41950426E-06_JPRB, 0.41422467E-06_JPRB, 0.41473936E-06_JPRB, 0.41552198E-06_JPRB, 0.41524831E-06_JPRB, 0.41336162E-06_JPRB, &
  & 0.40952136E-06_JPRB, 0.39705895E-06_JPRB, 0.39221680E-06_JPRB, 0.39143521E-06_JPRB, 0.39334955E-06_JPRB, 0.39627520E-06_JPRB, &
  & 0.40145486E-06_JPRB, 0.39912797E-06_JPRB, 0.40086243E-06_JPRB, 0.40786455E-06_JPRB, 0.41338112E-06_JPRB, 0.42139621E-06_JPRB, &
  & 0.42158504E-06_JPRB, 0.42420092E-06_JPRB, 0.42989197E-06_JPRB, 0.44017153E-06_JPRB, 0.44667837E-06_JPRB, 0.44943101E-06_JPRB, &
  & 0.46272316E-06_JPRB, 0.47060107E-06_JPRB, 0.47547468E-06_JPRB, 0.48331282E-06_JPRB, 0.48471566E-06_JPRB, 0.48382600E-06_JPRB, &
  & 0.48635025E-06_JPRB, 0.50430225E-06_JPRB, 0.58426463E-06_JPRB, 0.66868358E-06_JPRB, 0.74595084E-06_JPRB, 0.83773239E-06_JPRB, &
  & 0.93560988E-06_JPRB, 0.10819532E-05_JPRB, 0.12582202E-05_JPRB, 0.15655738E-05_JPRB /)

RGHG7(:, 4, 6) = (/ &
  & 0.60581706E-05_JPRB, 0.55728010E-05_JPRB, 0.51577285E-05_JPRB, 0.47358349E-05_JPRB, 0.42551901E-05_JPRB, 0.36669701E-05_JPRB, &
  & 0.31233126E-05_JPRB, 0.24764513E-05_JPRB, 0.57947966E-06_JPRB, 0.47587889E-06_JPRB, 0.46674575E-06_JPRB, 0.46143396E-06_JPRB, &
  & 0.47182974E-06_JPRB, 0.48736752E-06_JPRB, 0.51702938E-06_JPRB, 0.55156147E-06_JPRB, 0.57161549E-06_JPRB, 0.59283207E-06_JPRB, &
  & 0.61388562E-06_JPRB, 0.63407043E-06_JPRB, 0.64155125E-06_JPRB, 0.65418942E-06_JPRB, 0.66922809E-06_JPRB, 0.68366808E-06_JPRB, &
  & 0.69657204E-06_JPRB, 0.69474208E-06_JPRB, 0.69864961E-06_JPRB, 0.70548191E-06_JPRB, 0.71356817E-06_JPRB, 0.71972630E-06_JPRB, &
  & 0.72779847E-06_JPRB, 0.72071498E-06_JPRB, 0.71934625E-06_JPRB, 0.72356784E-06_JPRB, 0.73068918E-06_JPRB, 0.73600199E-06_JPRB, &
  & 0.74486064E-06_JPRB, 0.74061643E-06_JPRB, 0.73939486E-06_JPRB, 0.74796588E-06_JPRB, 0.75364215E-06_JPRB, 0.76552408E-06_JPRB, &
  & 0.76154703E-06_JPRB, 0.76074065E-06_JPRB, 0.76480052E-06_JPRB, 0.77421168E-06_JPRB, 0.77419202E-06_JPRB, 0.76674542E-06_JPRB, &
  & 0.77392605E-06_JPRB, 0.77424295E-06_JPRB, 0.77054705E-06_JPRB, 0.77191822E-06_JPRB, 0.76502391E-06_JPRB, 0.75781759E-06_JPRB, &
  & 0.75155850E-06_JPRB, 0.74800693E-06_JPRB, 0.78437688E-06_JPRB, 0.84714873E-06_JPRB, 0.91407225E-06_JPRB, 0.98840940E-06_JPRB, &
  & 0.10600749E-05_JPRB, 0.11212391E-05_JPRB, 0.11255111E-05_JPRB, 0.10726631E-05_JPRB /)

RGHG7(:, 5, 6) = (/ &
  & 0.56781337E-05_JPRB, 0.49242967E-05_JPRB, 0.44210046E-05_JPRB, 0.39548154E-05_JPRB, 0.34824350E-05_JPRB, 0.29170740E-05_JPRB, &
  & 0.23831492E-05_JPRB, 0.17448492E-05_JPRB, 0.89209607E-06_JPRB, 0.73283684E-06_JPRB, 0.74638359E-06_JPRB, 0.75588724E-06_JPRB, &
  & 0.77260808E-06_JPRB, 0.77218857E-06_JPRB, 0.77312473E-06_JPRB, 0.79291567E-06_JPRB, 0.80984591E-06_JPRB, 0.83746244E-06_JPRB, &
  & 0.86940594E-06_JPRB, 0.90337784E-06_JPRB, 0.92107172E-06_JPRB, 0.94079070E-06_JPRB, 0.96308099E-06_JPRB, 0.98305190E-06_JPRB, &
  & 0.10040447E-05_JPRB, 0.10061063E-05_JPRB, 0.10148275E-05_JPRB, 0.10285601E-05_JPRB, 0.10476458E-05_JPRB, 0.10623523E-05_JPRB, &
  & 0.10848966E-05_JPRB, 0.10843141E-05_JPRB, 0.10863345E-05_JPRB, 0.10965392E-05_JPRB, 0.11107608E-05_JPRB, 0.11198036E-05_JPRB, &
  & 0.11328023E-05_JPRB, 0.11260428E-05_JPRB, 0.11206793E-05_JPRB, 0.11280850E-05_JPRB, 0.11305906E-05_JPRB, 0.11417040E-05_JPRB, &
  & 0.11282008E-05_JPRB, 0.11185873E-05_JPRB, 0.11150281E-05_JPRB, 0.11180073E-05_JPRB, 0.11075965E-05_JPRB, 0.10883820E-05_JPRB, &
  & 0.10892733E-05_JPRB, 0.10820136E-05_JPRB, 0.10656738E-05_JPRB, 0.10540158E-05_JPRB, 0.10315931E-05_JPRB, 0.10062151E-05_JPRB, &
  & 0.98112162E-06_JPRB, 0.94697162E-06_JPRB, 0.93464359E-06_JPRB, 0.96377642E-06_JPRB, 0.10072463E-05_JPRB, 0.10711892E-05_JPRB, &
  & 0.11578508E-05_JPRB, 0.12841889E-05_JPRB, 0.14551574E-05_JPRB, 0.18316794E-05_JPRB /)

RGHG7(:, 6, 6) = (/ &
  & 0.52271080E-05_JPRB, 0.43375326E-05_JPRB, 0.38043909E-05_JPRB, 0.33203598E-05_JPRB, 0.28632087E-05_JPRB, 0.23732946E-05_JPRB, &
  & 0.19999427E-05_JPRB, 0.16882540E-05_JPRB, 0.13590709E-05_JPRB, 0.11720231E-05_JPRB, 0.11254920E-05_JPRB, 0.11065184E-05_JPRB, &
  & 0.11115199E-05_JPRB, 0.11259302E-05_JPRB, 0.11403713E-05_JPRB, 0.11664076E-05_JPRB, 0.11774442E-05_JPRB, 0.11958984E-05_JPRB, &
  & 0.12199732E-05_JPRB, 0.12488534E-05_JPRB, 0.12648092E-05_JPRB, 0.12847818E-05_JPRB, 0.13131640E-05_JPRB, 0.13388435E-05_JPRB, &
  & 0.13691943E-05_JPRB, 0.13757747E-05_JPRB, 0.13877574E-05_JPRB, 0.14049092E-05_JPRB, 0.14319129E-05_JPRB, 0.14511763E-05_JPRB, &
  & 0.14845408E-05_JPRB, 0.14898494E-05_JPRB, 0.14960921E-05_JPRB, 0.15135189E-05_JPRB, 0.15355748E-05_JPRB, 0.15497118E-05_JPRB, &
  & 0.15686077E-05_JPRB, 0.15621796E-05_JPRB, 0.15553511E-05_JPRB, 0.15630837E-05_JPRB, 0.15638814E-05_JPRB, 0.15737630E-05_JPRB, &
  & 0.15525633E-05_JPRB, 0.15348462E-05_JPRB, 0.15231797E-05_JPRB, 0.15190120E-05_JPRB, 0.14980459E-05_JPRB, 0.14674151E-05_JPRB, &
  & 0.14570728E-05_JPRB, 0.14322450E-05_JPRB, 0.14000417E-05_JPRB, 0.13820576E-05_JPRB, 0.13564378E-05_JPRB, 0.13274672E-05_JPRB, &
  & 0.12954965E-05_JPRB, 0.12510598E-05_JPRB, 0.12214716E-05_JPRB, 0.12240081E-05_JPRB, 0.12315155E-05_JPRB, 0.12465140E-05_JPRB, &
  & 0.12693574E-05_JPRB, 0.13074352E-05_JPRB, 0.13329709E-05_JPRB, 0.12514781E-05_JPRB /)

RGHG7(:, 7, 6) = (/ &
  & 0.46832224E-05_JPRB, 0.37536518E-05_JPRB, 0.32521773E-05_JPRB, 0.28239319E-05_JPRB, 0.24750229E-05_JPRB, 0.21654980E-05_JPRB, &
  & 0.19684676E-05_JPRB, 0.18525627E-05_JPRB, 0.17922648E-05_JPRB, 0.18178018E-05_JPRB, 0.17889175E-05_JPRB, 0.17513387E-05_JPRB, &
  & 0.17097102E-05_JPRB, 0.16818559E-05_JPRB, 0.16547386E-05_JPRB, 0.16583657E-05_JPRB, 0.16593860E-05_JPRB, 0.16708914E-05_JPRB, &
  & 0.16978747E-05_JPRB, 0.17333357E-05_JPRB, 0.17539552E-05_JPRB, 0.17717160E-05_JPRB, 0.18010574E-05_JPRB, 0.18255138E-05_JPRB, &
  & 0.18587708E-05_JPRB, 0.18671175E-05_JPRB, 0.18806373E-05_JPRB, 0.18987448E-05_JPRB, 0.19275026E-05_JPRB, 0.19446322E-05_JPRB, &
  & 0.19771326E-05_JPRB, 0.19771442E-05_JPRB, 0.19765564E-05_JPRB, 0.19928511E-05_JPRB, 0.20181835E-05_JPRB, 0.20354944E-05_JPRB, &
  & 0.20596372E-05_JPRB, 0.20538855E-05_JPRB, 0.20452742E-05_JPRB, 0.20544762E-05_JPRB, 0.20554596E-05_JPRB, 0.20656478E-05_JPRB, &
  & 0.20401731E-05_JPRB, 0.20147786E-05_JPRB, 0.19956447E-05_JPRB, 0.19822319E-05_JPRB, 0.19503127E-05_JPRB, 0.19058830E-05_JPRB, &
  & 0.18784918E-05_JPRB, 0.18385414E-05_JPRB, 0.17951571E-05_JPRB, 0.17548589E-05_JPRB, 0.16939354E-05_JPRB, 0.16301606E-05_JPRB, &
  & 0.15740418E-05_JPRB, 0.15189977E-05_JPRB, 0.14922417E-05_JPRB, 0.15077006E-05_JPRB, 0.15284087E-05_JPRB, 0.15582525E-05_JPRB, &
  & 0.15951738E-05_JPRB, 0.16380214E-05_JPRB, 0.17321962E-05_JPRB, 0.18453559E-05_JPRB /)

RGHG7(:, 8, 6) = (/ &
  & 0.40072719E-05_JPRB, 0.30656859E-05_JPRB, 0.26362341E-05_JPRB, 0.23614321E-05_JPRB, 0.21923904E-05_JPRB, 0.20810187E-05_JPRB, &
  & 0.20569496E-05_JPRB, 0.20867199E-05_JPRB, 0.22400084E-05_JPRB, 0.24790456E-05_JPRB, 0.25596298E-05_JPRB, 0.25340287E-05_JPRB, &
  & 0.24734306E-05_JPRB, 0.24284784E-05_JPRB, 0.23718389E-05_JPRB, 0.23396035E-05_JPRB, 0.23041757E-05_JPRB, 0.22734355E-05_JPRB, &
  & 0.22611682E-05_JPRB, 0.22667955E-05_JPRB, 0.22707106E-05_JPRB, 0.22734162E-05_JPRB, 0.22960767E-05_JPRB, 0.23157206E-05_JPRB, &
  & 0.23482912E-05_JPRB, 0.23584003E-05_JPRB, 0.23689990E-05_JPRB, 0.23850232E-05_JPRB, 0.24130431E-05_JPRB, 0.24287037E-05_JPRB, &
  & 0.24570311E-05_JPRB, 0.24515689E-05_JPRB, 0.24441579E-05_JPRB, 0.24550482E-05_JPRB, 0.24774940E-05_JPRB, 0.24937196E-05_JPRB, &
  & 0.25199174E-05_JPRB, 0.25163936E-05_JPRB, 0.25066252E-05_JPRB, 0.25169372E-05_JPRB, 0.25165596E-05_JPRB, 0.25248078E-05_JPRB, &
  & 0.24949968E-05_JPRB, 0.24624014E-05_JPRB, 0.24349224E-05_JPRB, 0.24132930E-05_JPRB, 0.23743355E-05_JPRB, 0.23172433E-05_JPRB, &
  & 0.22796748E-05_JPRB, 0.22337224E-05_JPRB, 0.21804869E-05_JPRB, 0.21333685E-05_JPRB, 0.20806538E-05_JPRB, 0.20360571E-05_JPRB, &
  & 0.19908766E-05_JPRB, 0.19292479E-05_JPRB, 0.18706411E-05_JPRB, 0.18408033E-05_JPRB, 0.18321144E-05_JPRB, 0.18307153E-05_JPRB, &
  & 0.18477507E-05_JPRB, 0.18447886E-05_JPRB, 0.19284912E-05_JPRB, 0.18448831E-05_JPRB /)

RGHG7(:, 9, 6) = (/ &
  & 0.32223384E-05_JPRB, 0.25501663E-05_JPRB, 0.23337857E-05_JPRB, 0.22398199E-05_JPRB, 0.22019492E-05_JPRB, 0.22173358E-05_JPRB, &
  & 0.22960064E-05_JPRB, 0.23985128E-05_JPRB, 0.26227151E-05_JPRB, 0.29886608E-05_JPRB, 0.32909411E-05_JPRB, 0.34051573E-05_JPRB, &
  & 0.33832448E-05_JPRB, 0.33169540E-05_JPRB, 0.32216406E-05_JPRB, 0.31521797E-05_JPRB, 0.30845608E-05_JPRB, 0.30198098E-05_JPRB, &
  & 0.29767450E-05_JPRB, 0.29472976E-05_JPRB, 0.29206715E-05_JPRB, 0.28910690E-05_JPRB, 0.28948264E-05_JPRB, 0.29076555E-05_JPRB, &
  & 0.29313262E-05_JPRB, 0.29390312E-05_JPRB, 0.29497799E-05_JPRB, 0.29707328E-05_JPRB, 0.29992359E-05_JPRB, 0.30121564E-05_JPRB, &
  & 0.30328372E-05_JPRB, 0.30188262E-05_JPRB, 0.30024974E-05_JPRB, 0.30058645E-05_JPRB, 0.30234748E-05_JPRB, 0.30369079E-05_JPRB, &
  & 0.30615081E-05_JPRB, 0.30572601E-05_JPRB, 0.30422943E-05_JPRB, 0.30474489E-05_JPRB, 0.30415326E-05_JPRB, 0.30414758E-05_JPRB, &
  & 0.30059948E-05_JPRB, 0.29625451E-05_JPRB, 0.29251873E-05_JPRB, 0.28954182E-05_JPRB, 0.28443001E-05_JPRB, 0.27761912E-05_JPRB, &
  & 0.27267829E-05_JPRB, 0.26659786E-05_JPRB, 0.25911813E-05_JPRB, 0.25214074E-05_JPRB, 0.24402809E-05_JPRB, 0.23575408E-05_JPRB, &
  & 0.22769127E-05_JPRB, 0.22036581E-05_JPRB, 0.21622600E-05_JPRB, 0.21488536E-05_JPRB, 0.21382548E-05_JPRB, 0.21385786E-05_JPRB, &
  & 0.21483950E-05_JPRB, 0.21500898E-05_JPRB, 0.22136439E-05_JPRB, 0.22067195E-05_JPRB /)

RGHG7(:,10, 6) = (/ &
  & 0.26165330E-05_JPRB, 0.23634843E-05_JPRB, 0.23315824E-05_JPRB, 0.23507187E-05_JPRB, 0.23981479E-05_JPRB, 0.24806250E-05_JPRB, &
  & 0.25885172E-05_JPRB, 0.27291585E-05_JPRB, 0.29449077E-05_JPRB, 0.33531899E-05_JPRB, 0.37986556E-05_JPRB, 0.41121402E-05_JPRB, &
  & 0.42593897E-05_JPRB, 0.42805718E-05_JPRB, 0.42077618E-05_JPRB, 0.41127578E-05_JPRB, 0.40026771E-05_JPRB, 0.38816761E-05_JPRB, &
  & 0.37911861E-05_JPRB, 0.37214991E-05_JPRB, 0.36616177E-05_JPRB, 0.36028127E-05_JPRB, 0.35791547E-05_JPRB, 0.35718701E-05_JPRB, &
  & 0.35958262E-05_JPRB, 0.36124529E-05_JPRB, 0.36174881E-05_JPRB, 0.36369122E-05_JPRB, 0.36681017E-05_JPRB, 0.36889451E-05_JPRB, &
  & 0.37147506E-05_JPRB, 0.37048296E-05_JPRB, 0.36896347E-05_JPRB, 0.36919703E-05_JPRB, 0.37087086E-05_JPRB, 0.37200712E-05_JPRB, &
  & 0.37416362E-05_JPRB, 0.37339942E-05_JPRB, 0.37114887E-05_JPRB, 0.37070060E-05_JPRB, 0.36937754E-05_JPRB, 0.36816580E-05_JPRB, &
  & 0.36402103E-05_JPRB, 0.35827779E-05_JPRB, 0.35371972E-05_JPRB, 0.34941902E-05_JPRB, 0.34330465E-05_JPRB, 0.33537476E-05_JPRB, &
  & 0.32866933E-05_JPRB, 0.32083599E-05_JPRB, 0.31157988E-05_JPRB, 0.30352410E-05_JPRB, 0.29480052E-05_JPRB, 0.28668937E-05_JPRB, &
  & 0.27942197E-05_JPRB, 0.27239328E-05_JPRB, 0.26650114E-05_JPRB, 0.26282844E-05_JPRB, 0.26058124E-05_JPRB, 0.25982813E-05_JPRB, &
  & 0.26037526E-05_JPRB, 0.26138569E-05_JPRB, 0.26757696E-05_JPRB, 0.27182430E-05_JPRB /)

RGHG7(:,11, 6) = (/ &
  & 0.24544252E-05_JPRB, 0.25354350E-05_JPRB, 0.26143009E-05_JPRB, 0.26909529E-05_JPRB, 0.27757458E-05_JPRB, 0.28683580E-05_JPRB, &
  & 0.29879850E-05_JPRB, 0.31270654E-05_JPRB, 0.33216804E-05_JPRB, 0.36785198E-05_JPRB, 0.41275007E-05_JPRB, 0.45444613E-05_JPRB, &
  & 0.48556453E-05_JPRB, 0.50415701E-05_JPRB, 0.51085899E-05_JPRB, 0.51020756E-05_JPRB, 0.50369090E-05_JPRB, 0.49184100E-05_JPRB, &
  & 0.48026650E-05_JPRB, 0.46952555E-05_JPRB, 0.45930215E-05_JPRB, 0.44919561E-05_JPRB, 0.44356384E-05_JPRB, 0.44160074E-05_JPRB, &
  & 0.44091512E-05_JPRB, 0.44000990E-05_JPRB, 0.44108415E-05_JPRB, 0.44380467E-05_JPRB, 0.44760077E-05_JPRB, 0.45076617E-05_JPRB, &
  & 0.45457828E-05_JPRB, 0.45517127E-05_JPRB, 0.45510692E-05_JPRB, 0.45630936E-05_JPRB, 0.45817046E-05_JPRB, 0.45891188E-05_JPRB, &
  & 0.45981187E-05_JPRB, 0.45773822E-05_JPRB, 0.45366205E-05_JPRB, 0.45115471E-05_JPRB, 0.44831736E-05_JPRB, 0.44514832E-05_JPRB, &
  & 0.44013454E-05_JPRB, 0.43296805E-05_JPRB, 0.42736078E-05_JPRB, 0.42190131E-05_JPRB, 0.41513435E-05_JPRB, 0.40603745E-05_JPRB, &
  & 0.39820097E-05_JPRB, 0.38988378E-05_JPRB, 0.38034564E-05_JPRB, 0.37194670E-05_JPRB, 0.36245615E-05_JPRB, 0.35349958E-05_JPRB, &
  & 0.34546367E-05_JPRB, 0.33786230E-05_JPRB, 0.33186634E-05_JPRB, 0.32859659E-05_JPRB, 0.32728301E-05_JPRB, 0.32779503E-05_JPRB, &
  & 0.33029157E-05_JPRB, 0.33372635E-05_JPRB, 0.34121813E-05_JPRB, 0.34942207E-05_JPRB /)

RGHG7(:,12, 6) = (/ &
  & 0.28107181E-05_JPRB, 0.29964194E-05_JPRB, 0.31025656E-05_JPRB, 0.31838836E-05_JPRB, 0.32555397E-05_JPRB, 0.33345102E-05_JPRB, &
  & 0.34268080E-05_JPRB, 0.35498142E-05_JPRB, 0.37101574E-05_JPRB, 0.39944298E-05_JPRB, 0.43782447E-05_JPRB, 0.47865719E-05_JPRB, &
  & 0.51594116E-05_JPRB, 0.54535876E-05_JPRB, 0.56484059E-05_JPRB, 0.57603647E-05_JPRB, 0.57919237E-05_JPRB, 0.57509178E-05_JPRB, &
  & 0.56852200E-05_JPRB, 0.56020826E-05_JPRB, 0.55058204E-05_JPRB, 0.54012726E-05_JPRB, 0.53347921E-05_JPRB, 0.52974037E-05_JPRB, &
  & 0.52890805E-05_JPRB, 0.52980786E-05_JPRB, 0.52937021E-05_JPRB, 0.53181875E-05_JPRB, 0.53741019E-05_JPRB, 0.54303077E-05_JPRB, &
  & 0.54964903E-05_JPRB, 0.55355213E-05_JPRB, 0.55625760E-05_JPRB, 0.55943624E-05_JPRB, 0.56235408E-05_JPRB, 0.56295376E-05_JPRB, &
  & 0.56263461E-05_JPRB, 0.55885175E-05_JPRB, 0.55249038E-05_JPRB, 0.54757479E-05_JPRB, 0.54269444E-05_JPRB, 0.53760577E-05_JPRB, &
  & 0.53139397E-05_JPRB, 0.52286382E-05_JPRB, 0.51612437E-05_JPRB, 0.50958974E-05_JPRB, 0.50188901E-05_JPRB, 0.49185442E-05_JPRB, &
  & 0.48331908E-05_JPRB, 0.47458257E-05_JPRB, 0.46426344E-05_JPRB, 0.45494194E-05_JPRB, 0.44477410E-05_JPRB, 0.43553518E-05_JPRB, &
  & 0.42758929E-05_JPRB, 0.42022689E-05_JPRB, 0.41480139E-05_JPRB, 0.41291364E-05_JPRB, 0.41314161E-05_JPRB, 0.41483440E-05_JPRB, &
  & 0.41782614E-05_JPRB, 0.42154479E-05_JPRB, 0.42834517E-05_JPRB, 0.43767504E-05_JPRB /)

RGHG7(:,13, 6) = (/ &
  & 0.34601783E-05_JPRB, 0.35550049E-05_JPRB, 0.36330332E-05_JPRB, 0.36792253E-05_JPRB, 0.37259997E-05_JPRB, 0.37783939E-05_JPRB, &
  & 0.38442331E-05_JPRB, 0.39280899E-05_JPRB, 0.40433692E-05_JPRB, 0.42451738E-05_JPRB, 0.45546885E-05_JPRB, 0.48949473E-05_JPRB, &
  & 0.52222249E-05_JPRB, 0.55107294E-05_JPRB, 0.57371835E-05_JPRB, 0.59104818E-05_JPRB, 0.60188645E-05_JPRB, 0.60654729E-05_JPRB, &
  & 0.60868629E-05_JPRB, 0.60854918E-05_JPRB, 0.60656489E-05_JPRB, 0.60318166E-05_JPRB, 0.60215066E-05_JPRB, 0.60307389E-05_JPRB, &
  & 0.60503990E-05_JPRB, 0.60652128E-05_JPRB, 0.61043988E-05_JPRB, 0.61572373E-05_JPRB, 0.62228778E-05_JPRB, 0.63060716E-05_JPRB, &
  & 0.64042015E-05_JPRB, 0.64796236E-05_JPRB, 0.65399513E-05_JPRB, 0.66019711E-05_JPRB, 0.66458465E-05_JPRB, 0.66600774E-05_JPRB, &
  & 0.66525990E-05_JPRB, 0.66056514E-05_JPRB, 0.65261461E-05_JPRB, 0.64559986E-05_JPRB, 0.63868943E-05_JPRB, 0.63163579E-05_JPRB, &
  & 0.62374911E-05_JPRB, 0.61379010E-05_JPRB, 0.60552325E-05_JPRB, 0.59769532E-05_JPRB, 0.58926080E-05_JPRB, 0.57891825E-05_JPRB, &
  & 0.57010702E-05_JPRB, 0.56107497E-05_JPRB, 0.55035634E-05_JPRB, 0.54038187E-05_JPRB, 0.52925770E-05_JPRB, 0.51844531E-05_JPRB, &
  & 0.50833755E-05_JPRB, 0.49828332E-05_JPRB, 0.49012328E-05_JPRB, 0.48614065E-05_JPRB, 0.48473253E-05_JPRB, 0.48488296E-05_JPRB, &
  & 0.48622073E-05_JPRB, 0.48823790E-05_JPRB, 0.49213286E-05_JPRB, 0.49959208E-05_JPRB /)

RGHG7(:,14, 6) = (/ &
  & 0.39781848E-05_JPRB, 0.39712504E-05_JPRB, 0.40112986E-05_JPRB, 0.40359769E-05_JPRB, 0.40619702E-05_JPRB, 0.40948762E-05_JPRB, &
  & 0.41360991E-05_JPRB, 0.41876601E-05_JPRB, 0.42546535E-05_JPRB, 0.43872342E-05_JPRB, 0.46364230E-05_JPRB, 0.49211071E-05_JPRB, &
  & 0.52095252E-05_JPRB, 0.54783773E-05_JPRB, 0.57137049E-05_JPRB, 0.59180657E-05_JPRB, 0.60774678E-05_JPRB, 0.61944443E-05_JPRB, &
  & 0.62857162E-05_JPRB, 0.63593693E-05_JPRB, 0.64140700E-05_JPRB, 0.64558512E-05_JPRB, 0.65111981E-05_JPRB, 0.65641116E-05_JPRB, &
  & 0.66345183E-05_JPRB, 0.66951065E-05_JPRB, 0.67488104E-05_JPRB, 0.68305621E-05_JPRB, 0.69426565E-05_JPRB, 0.70551423E-05_JPRB, &
  & 0.71738204E-05_JPRB, 0.72783419E-05_JPRB, 0.73680458E-05_JPRB, 0.74570607E-05_JPRB, 0.75331113E-05_JPRB, 0.75744979E-05_JPRB, &
  & 0.75807461E-05_JPRB, 0.75421772E-05_JPRB, 0.74646177E-05_JPRB, 0.73884680E-05_JPRB, 0.73088404E-05_JPRB, 0.72243201E-05_JPRB, &
  & 0.71294212E-05_JPRB, 0.70149058E-05_JPRB, 0.69153275E-05_JPRB, 0.68213712E-05_JPRB, 0.67244537E-05_JPRB, 0.66124567E-05_JPRB, &
  & 0.65138206E-05_JPRB, 0.64139408E-05_JPRB, 0.62971694E-05_JPRB, 0.61826859E-05_JPRB, 0.60521647E-05_JPRB, 0.59176741E-05_JPRB, &
  & 0.57821967E-05_JPRB, 0.56410813E-05_JPRB, 0.55165365E-05_JPRB, 0.54385382E-05_JPRB, 0.53892090E-05_JPRB, 0.53579070E-05_JPRB, &
  & 0.53406975E-05_JPRB, 0.53357699E-05_JPRB, 0.53442973E-05_JPRB, 0.53830831E-05_JPRB /)

RGHG7(:,15, 6) = (/ &
  & 0.42105139E-05_JPRB, 0.42254969E-05_JPRB, 0.42368774E-05_JPRB, 0.42565571E-05_JPRB, 0.42724246E-05_JPRB, 0.42950246E-05_JPRB, &
  & 0.43234750E-05_JPRB, 0.43602272E-05_JPRB, 0.44084254E-05_JPRB, 0.45070919E-05_JPRB, 0.47239346E-05_JPRB, 0.49851619E-05_JPRB, &
  & 0.52490614E-05_JPRB, 0.55061005E-05_JPRB, 0.57439074E-05_JPRB, 0.59652589E-05_JPRB, 0.61519486E-05_JPRB, 0.63055782E-05_JPRB, &
  & 0.64386413E-05_JPRB, 0.65583399E-05_JPRB, 0.66658340E-05_JPRB, 0.67612482E-05_JPRB, 0.68666991E-05_JPRB, 0.69677744E-05_JPRB, &
  & 0.70717128E-05_JPRB, 0.71725053E-05_JPRB, 0.72808152E-05_JPRB, 0.73893966E-05_JPRB, 0.75100561E-05_JPRB, 0.76390625E-05_JPRB, &
  & 0.77844697E-05_JPRB, 0.79099582E-05_JPRB, 0.80110149E-05_JPRB, 0.81050421E-05_JPRB, 0.81741609E-05_JPRB, 0.82196320E-05_JPRB, &
  & 0.82358383E-05_JPRB, 0.82132610E-05_JPRB, 0.81532107E-05_JPRB, 0.80897098E-05_JPRB, 0.80185127E-05_JPRB, 0.79352276E-05_JPRB, &
  & 0.78359808E-05_JPRB, 0.77138975E-05_JPRB, 0.76009574E-05_JPRB, 0.74913919E-05_JPRB, 0.73787869E-05_JPRB, 0.72532903E-05_JPRB, &
  & 0.71375898E-05_JPRB, 0.70179540E-05_JPRB, 0.68801619E-05_JPRB, 0.67407923E-05_JPRB, 0.65837526E-05_JPRB, 0.64179249E-05_JPRB, &
  & 0.62445774E-05_JPRB, 0.60609341E-05_JPRB, 0.58922756E-05_JPRB, 0.57716657E-05_JPRB, 0.56816161E-05_JPRB, 0.56129506E-05_JPRB, &
  & 0.55620953E-05_JPRB, 0.55278115E-05_JPRB, 0.55068526E-05_JPRB, 0.55018968E-05_JPRB /)

RGHG7(:,16, 6) = (/ &
  & 0.43951331E-05_JPRB, 0.44209964E-05_JPRB, 0.44194294E-05_JPRB, 0.44326234E-05_JPRB, 0.44430453E-05_JPRB, 0.44614935E-05_JPRB, &
  & 0.44853787E-05_JPRB, 0.45183492E-05_JPRB, 0.45619199E-05_JPRB, 0.46409459E-05_JPRB, 0.48073271E-05_JPRB, 0.50413910E-05_JPRB, &
  & 0.52832779E-05_JPRB, 0.55149067E-05_JPRB, 0.57311640E-05_JPRB, 0.59442259E-05_JPRB, 0.61424207E-05_JPRB, 0.63292669E-05_JPRB, &
  & 0.65094505E-05_JPRB, 0.66775510E-05_JPRB, 0.68329691E-05_JPRB, 0.69802691E-05_JPRB, 0.71306627E-05_JPRB, 0.72766647E-05_JPRB, &
  & 0.74249965E-05_JPRB, 0.75614525E-05_JPRB, 0.77030190E-05_JPRB, 0.78517905E-05_JPRB, 0.80070704E-05_JPRB, 0.81489625E-05_JPRB, &
  & 0.82737834E-05_JPRB, 0.83732994E-05_JPRB, 0.84494695E-05_JPRB, 0.85193742E-05_JPRB, 0.85853799E-05_JPRB, 0.86317650E-05_JPRB, &
  & 0.86512337E-05_JPRB, 0.86421078E-05_JPRB, 0.86027148E-05_JPRB, 0.85575211E-05_JPRB, 0.84990788E-05_JPRB, 0.84227313E-05_JPRB, &
  & 0.83223695E-05_JPRB, 0.81970338E-05_JPRB, 0.80733134E-05_JPRB, 0.79471683E-05_JPRB, 0.78132871E-05_JPRB, 0.76647948E-05_JPRB, &
  & 0.75214521E-05_JPRB, 0.73727383E-05_JPRB, 0.72083121E-05_JPRB, 0.70412561E-05_JPRB, 0.68574382E-05_JPRB, 0.66622401E-05_JPRB, &
  & 0.64557175E-05_JPRB, 0.62376080E-05_JPRB, 0.60342759E-05_JPRB, 0.58796340E-05_JPRB, 0.57579905E-05_JPRB, 0.56620179E-05_JPRB, &
  & 0.55879932E-05_JPRB, 0.55344558E-05_JPRB, 0.54979137E-05_JPRB, 0.54703341E-05_JPRB /)

RGHG7(:,17, 6) = (/ &
  & 0.45855118E-05_JPRB, 0.45938245E-05_JPRB, 0.45885363E-05_JPRB, 0.45939660E-05_JPRB, 0.46015216E-05_JPRB, 0.46135533E-05_JPRB, &
  & 0.46310602E-05_JPRB, 0.46561690E-05_JPRB, 0.46897303E-05_JPRB, 0.47487333E-05_JPRB, 0.48728702E-05_JPRB, 0.50801391E-05_JPRB, &
  & 0.53184963E-05_JPRB, 0.55590331E-05_JPRB, 0.57869011E-05_JPRB, 0.60082643E-05_JPRB, 0.62272234E-05_JPRB, 0.64371793E-05_JPRB, &
  & 0.66367570E-05_JPRB, 0.68311524E-05_JPRB, 0.70197975E-05_JPRB, 0.72057273E-05_JPRB, 0.73982269E-05_JPRB, 0.75933822E-05_JPRB, &
  & 0.77950363E-05_JPRB, 0.79883421E-05_JPRB, 0.81763783E-05_JPRB, 0.83526238E-05_JPRB, 0.85136071E-05_JPRB, 0.86455357E-05_JPRB, &
  & 0.87513827E-05_JPRB, 0.88226734E-05_JPRB, 0.88632614E-05_JPRB, 0.88968509E-05_JPRB, 0.89214636E-05_JPRB, 0.89375826E-05_JPRB, &
  & 0.89497935E-05_JPRB, 0.89448085E-05_JPRB, 0.89209816E-05_JPRB, 0.88946299E-05_JPRB, 0.88549114E-05_JPRB, 0.87941853E-05_JPRB, &
  & 0.87025728E-05_JPRB, 0.85822458E-05_JPRB, 0.84542853E-05_JPRB, 0.83148198E-05_JPRB, 0.81589278E-05_JPRB, 0.79859628E-05_JPRB, &
  & 0.78137609E-05_JPRB, 0.76346150E-05_JPRB, 0.74413974E-05_JPRB, 0.72439766E-05_JPRB, 0.70303281E-05_JPRB, 0.68042791E-05_JPRB, &
  & 0.65661388E-05_JPRB, 0.63180469E-05_JPRB, 0.60870643E-05_JPRB, 0.59051690E-05_JPRB, 0.57594029E-05_JPRB, 0.56428325E-05_JPRB, &
  & 0.55519831E-05_JPRB, 0.54847269E-05_JPRB, 0.54367965E-05_JPRB, 0.53939602E-05_JPRB /)

RGHG7(:,18, 6) = (/ &
  & 0.47605017E-05_JPRB, 0.47544227E-05_JPRB, 0.47481790E-05_JPRB, 0.47483463E-05_JPRB, 0.47520771E-05_JPRB, 0.47594963E-05_JPRB, &
  & 0.47710864E-05_JPRB, 0.47872745E-05_JPRB, 0.48094103E-05_JPRB, 0.48598909E-05_JPRB, 0.49677387E-05_JPRB, 0.51483048E-05_JPRB, &
  & 0.53812232E-05_JPRB, 0.56218760E-05_JPRB, 0.58658702E-05_JPRB, 0.61067285E-05_JPRB, 0.63341658E-05_JPRB, 0.65559971E-05_JPRB, &
  & 0.67745700E-05_JPRB, 0.69876119E-05_JPRB, 0.71958848E-05_JPRB, 0.74038398E-05_JPRB, 0.76171182E-05_JPRB, 0.78328731E-05_JPRB, &
  & 0.80508580E-05_JPRB, 0.82569959E-05_JPRB, 0.84491576E-05_JPRB, 0.86243645E-05_JPRB, 0.87765984E-05_JPRB, 0.88981069E-05_JPRB, &
  & 0.89897858E-05_JPRB, 0.90487174E-05_JPRB, 0.90729436E-05_JPRB, 0.90854310E-05_JPRB, 0.90906969E-05_JPRB, 0.90950398E-05_JPRB, &
  & 0.90953445E-05_JPRB, 0.90909216E-05_JPRB, 0.90781232E-05_JPRB, 0.90631329E-05_JPRB, 0.90348049E-05_JPRB, 0.89861132E-05_JPRB, &
  & 0.89040359E-05_JPRB, 0.87906192E-05_JPRB, 0.86620921E-05_JPRB, 0.85139172E-05_JPRB, 0.83438481E-05_JPRB, 0.81548806E-05_JPRB, &
  & 0.79627107E-05_JPRB, 0.77609147E-05_JPRB, 0.75444636E-05_JPRB, 0.73213555E-05_JPRB, 0.70823926E-05_JPRB, 0.68311524E-05_JPRB, &
  & 0.65692152E-05_JPRB, 0.63014945E-05_JPRB, 0.60534699E-05_JPRB, 0.58551350E-05_JPRB, 0.56957833E-05_JPRB, 0.55690771E-05_JPRB, &
  & 0.54718444E-05_JPRB, 0.54008847E-05_JPRB, 0.53513231E-05_JPRB, 0.53079907E-05_JPRB /)

RGHG7(:,19, 6) = (/ &
  & 0.49134824E-05_JPRB, 0.49030727E-05_JPRB, 0.48978759E-05_JPRB, 0.48969068E-05_JPRB, 0.48991142E-05_JPRB, 0.49045166E-05_JPRB, &
  & 0.49131131E-05_JPRB, 0.49256723E-05_JPRB, 0.49442383E-05_JPRB, 0.49917548E-05_JPRB, 0.50876674E-05_JPRB, 0.52434407E-05_JPRB, &
  & 0.54578063E-05_JPRB, 0.56985114E-05_JPRB, 0.59367512E-05_JPRB, 0.61728115E-05_JPRB, 0.64038827E-05_JPRB, 0.66237994E-05_JPRB, &
  & 0.68308805E-05_JPRB, 0.70280153E-05_JPRB, 0.72182834E-05_JPRB, 0.74059458E-05_JPRB, 0.75943926E-05_JPRB, 0.77792474E-05_JPRB, &
  & 0.79593156E-05_JPRB, 0.81228454E-05_JPRB, 0.82699289E-05_JPRB, 0.84086732E-05_JPRB, 0.85381344E-05_JPRB, 0.86631753E-05_JPRB, &
  & 0.87790886E-05_JPRB, 0.88810884E-05_JPRB, 0.89583455E-05_JPRB, 0.90197937E-05_JPRB, 0.90641734E-05_JPRB, 0.90888689E-05_JPRB, &
  & 0.91015645E-05_JPRB, 0.91038510E-05_JPRB, 0.90894309E-05_JPRB, 0.90736094E-05_JPRB, 0.90436388E-05_JPRB, 0.89923706E-05_JPRB, &
  & 0.89121122E-05_JPRB, 0.88046872E-05_JPRB, 0.86795708E-05_JPRB, 0.85335241E-05_JPRB, 0.83654795E-05_JPRB, 0.81774015E-05_JPRB, &
  & 0.79806296E-05_JPRB, 0.77703498E-05_JPRB, 0.75435801E-05_JPRB, 0.73075757E-05_JPRB, 0.70558176E-05_JPRB, 0.67927126E-05_JPRB, &
  & 0.65219406E-05_JPRB, 0.62494141E-05_JPRB, 0.59982995E-05_JPRB, 0.57955876E-05_JPRB, 0.56328172E-05_JPRB, 0.55040446E-05_JPRB, &
  & 0.54058769E-05_JPRB, 0.53335502E-05_JPRB, 0.52813775E-05_JPRB, 0.52377204E-05_JPRB /)

RGHG7(:,20, 6) = (/ &
  & 0.50332947E-05_JPRB, 0.50273088E-05_JPRB, 0.50262302E-05_JPRB, 0.50271460E-05_JPRB, 0.50297799E-05_JPRB, 0.50341000E-05_JPRB, &
  & 0.50399276E-05_JPRB, 0.50471749E-05_JPRB, 0.50574763E-05_JPRB, 0.50995209E-05_JPRB, 0.51873258E-05_JPRB, 0.53259746E-05_JPRB, &
  & 0.55161026E-05_JPRB, 0.57469547E-05_JPRB, 0.59832087E-05_JPRB, 0.62098507E-05_JPRB, 0.64183705E-05_JPRB, 0.66095058E-05_JPRB, &
  & 0.67850310E-05_JPRB, 0.69447756E-05_JPRB, 0.70885017E-05_JPRB, 0.72217226E-05_JPRB, 0.73503002E-05_JPRB, 0.74661139E-05_JPRB, &
  & 0.75675744E-05_JPRB, 0.76523374E-05_JPRB, 0.77251043E-05_JPRB, 0.78026569E-05_JPRB, 0.78967842E-05_JPRB, 0.80176233E-05_JPRB, &
  & 0.81613925E-05_JPRB, 0.83222494E-05_JPRB, 0.84795711E-05_JPRB, 0.86265372E-05_JPRB, 0.87489470E-05_JPRB, 0.88358765E-05_JPRB, &
  & 0.88892002E-05_JPRB, 0.89084260E-05_JPRB, 0.88984425E-05_JPRB, 0.88720444E-05_JPRB, 0.88286088E-05_JPRB, 0.87683120E-05_JPRB, &
  & 0.86842128E-05_JPRB, 0.85775782E-05_JPRB, 0.84591757E-05_JPRB, 0.83271043E-05_JPRB, 0.81778526E-05_JPRB, 0.80081718E-05_JPRB, &
  & 0.78258345E-05_JPRB, 0.76284750E-05_JPRB, 0.74132608E-05_JPRB, 0.71853719E-05_JPRB, 0.69412818E-05_JPRB, 0.66861467E-05_JPRB, &
  & 0.64244955E-05_JPRB, 0.61628043E-05_JPRB, 0.59218241E-05_JPRB, 0.57247303E-05_JPRB, 0.55648889E-05_JPRB, 0.54376801E-05_JPRB, &
  & 0.53402696E-05_JPRB, 0.52689520E-05_JPRB, 0.52140585E-05_JPRB, 0.51648299E-05_JPRB /)

RGHG7(:,21, 6) = (/ &
  & 0.51040520E-05_JPRB, 0.51101815E-05_JPRB, 0.51154543E-05_JPRB, 0.51212219E-05_JPRB, 0.51270463E-05_JPRB, 0.51325446E-05_JPRB, &
  & 0.51366874E-05_JPRB, 0.51381749E-05_JPRB, 0.51382344E-05_JPRB, 0.51788279E-05_JPRB, 0.52679529E-05_JPRB, 0.53975168E-05_JPRB, &
  & 0.55664023E-05_JPRB, 0.57669395E-05_JPRB, 0.59744625E-05_JPRB, 0.61731407E-05_JPRB, 0.63517637E-05_JPRB, 0.65054510E-05_JPRB, &
  & 0.66345119E-05_JPRB, 0.67433521E-05_JPRB, 0.68347522E-05_JPRB, 0.69055382E-05_JPRB, 0.69606476E-05_JPRB, 0.69989956E-05_JPRB, &
  & 0.70228125E-05_JPRB, 0.70235451E-05_JPRB, 0.70229758E-05_JPRB, 0.70402289E-05_JPRB, 0.70884080E-05_JPRB, 0.71793556E-05_JPRB, &
  & 0.73196429E-05_JPRB, 0.75037215E-05_JPRB, 0.77104851E-05_JPRB, 0.79287720E-05_JPRB, 0.81236039E-05_JPRB, 0.82806646E-05_JPRB, &
  & 0.83842169E-05_JPRB, 0.84339836E-05_JPRB, 0.84382345E-05_JPRB, 0.84092990E-05_JPRB, 0.83615223E-05_JPRB, 0.82937877E-05_JPRB, &
  & 0.82149154E-05_JPRB, 0.81220223E-05_JPRB, 0.80231739E-05_JPRB, 0.79148513E-05_JPRB, 0.77910090E-05_JPRB, 0.76469232E-05_JPRB, &
  & 0.74918621E-05_JPRB, 0.73232477E-05_JPRB, 0.71353097E-05_JPRB, 0.69344546E-05_JPRB, 0.67175406E-05_JPRB, 0.64882915E-05_JPRB, &
  & 0.62515437E-05_JPRB, 0.60147586E-05_JPRB, 0.57963048E-05_JPRB, 0.56154940E-05_JPRB, 0.54675611E-05_JPRB, 0.53481785E-05_JPRB, &
  & 0.52547803E-05_JPRB, 0.51841052E-05_JPRB, 0.51304951E-05_JPRB, 0.50712724E-05_JPRB /)

RGHG7(:,22, 6) = (/ &
  & 0.51134948E-05_JPRB, 0.51353254E-05_JPRB, 0.51491284E-05_JPRB, 0.51608304E-05_JPRB, 0.51710927E-05_JPRB, 0.51790848E-05_JPRB, &
  & 0.51827874E-05_JPRB, 0.51790962E-05_JPRB, 0.51680790E-05_JPRB, 0.52046948E-05_JPRB, 0.52942696E-05_JPRB, 0.54195816E-05_JPRB, &
  & 0.55694568E-05_JPRB, 0.57355001E-05_JPRB, 0.59090594E-05_JPRB, 0.60685034E-05_JPRB, 0.62050071E-05_JPRB, 0.63147872E-05_JPRB, &
  & 0.63964844E-05_JPRB, 0.64537403E-05_JPRB, 0.64891428E-05_JPRB, 0.65012391E-05_JPRB, 0.64976934E-05_JPRB, 0.64727442E-05_JPRB, &
  & 0.64298883E-05_JPRB, 0.63762418E-05_JPRB, 0.63189691E-05_JPRB, 0.62745644E-05_JPRB, 0.62704053E-05_JPRB, 0.63150401E-05_JPRB, &
  & 0.64153378E-05_JPRB, 0.65710688E-05_JPRB, 0.67708979E-05_JPRB, 0.69985194E-05_JPRB, 0.72242187E-05_JPRB, 0.74145746E-05_JPRB, &
  & 0.75608959E-05_JPRB, 0.76449869E-05_JPRB, 0.76734195E-05_JPRB, 0.76666774E-05_JPRB, 0.76382667E-05_JPRB, 0.75926541E-05_JPRB, &
  & 0.75358444E-05_JPRB, 0.74712011E-05_JPRB, 0.74046420E-05_JPRB, 0.73290976E-05_JPRB, 0.72386283E-05_JPRB, 0.71333802E-05_JPRB, &
  & 0.70194346E-05_JPRB, 0.68906975E-05_JPRB, 0.67450496E-05_JPRB, 0.65856289E-05_JPRB, 0.64079400E-05_JPRB, 0.62161075E-05_JPRB, &
  & 0.60150928E-05_JPRB, 0.58118130E-05_JPRB, 0.56218546E-05_JPRB, 0.54618295E-05_JPRB, 0.53291915E-05_JPRB, 0.52208479E-05_JPRB, &
  & 0.51341831E-05_JPRB, 0.50653816E-05_JPRB, 0.50080789E-05_JPRB, 0.49443020E-05_JPRB /)

RGHG7(:,23, 6) = (/ &
  & 0.50538979E-05_JPRB, 0.50926542E-05_JPRB, 0.51145171E-05_JPRB, 0.51321640E-05_JPRB, 0.51463553E-05_JPRB, 0.51558632E-05_JPRB, &
  & 0.51570732E-05_JPRB, 0.51440056E-05_JPRB, 0.51157981E-05_JPRB, 0.51447955E-05_JPRB, 0.52351370E-05_JPRB, 0.53579906E-05_JPRB, &
  & 0.54913135E-05_JPRB, 0.56259346E-05_JPRB, 0.57551210E-05_JPRB, 0.58716359E-05_JPRB, 0.59625768E-05_JPRB, 0.60261350E-05_JPRB, &
  & 0.60616931E-05_JPRB, 0.60691086E-05_JPRB, 0.60574539E-05_JPRB, 0.60254665E-05_JPRB, 0.59723707E-05_JPRB, 0.59035824E-05_JPRB, &
  & 0.58223536E-05_JPRB, 0.57276343E-05_JPRB, 0.56379668E-05_JPRB, 0.55698411E-05_JPRB, 0.55201449E-05_JPRB, 0.55082000E-05_JPRB, &
  & 0.55462742E-05_JPRB, 0.56365775E-05_JPRB, 0.57761044E-05_JPRB, 0.59513518E-05_JPRB, 0.61475989E-05_JPRB, 0.63215748E-05_JPRB, &
  & 0.64708879E-05_JPRB, 0.65797722E-05_JPRB, 0.66470884E-05_JPRB, 0.66887455E-05_JPRB, 0.67088140E-05_JPRB, 0.67167352E-05_JPRB, &
  & 0.67130400E-05_JPRB, 0.66956477E-05_JPRB, 0.66698099E-05_JPRB, 0.66352181E-05_JPRB, 0.65906333E-05_JPRB, 0.65321110E-05_JPRB, &
  & 0.64591927E-05_JPRB, 0.63714929E-05_JPRB, 0.62662880E-05_JPRB, 0.61447004E-05_JPRB, 0.60062462E-05_JPRB, 0.58546466E-05_JPRB, &
  & 0.56936715E-05_JPRB, 0.55285705E-05_JPRB, 0.53716112E-05_JPRB, 0.52364303E-05_JPRB, 0.51227985E-05_JPRB, 0.50292942E-05_JPRB, &
  & 0.49542118E-05_JPRB, 0.48936145E-05_JPRB, 0.48405823E-05_JPRB, 0.47741419E-05_JPRB /)

RGHG7(:,24, 6) = (/ &
  & 0.49316991E-05_JPRB, 0.49826108E-05_JPRB, 0.50113536E-05_JPRB, 0.50333488E-05_JPRB, 0.50504595E-05_JPRB, 0.50609883E-05_JPRB, &
  & 0.50596709E-05_JPRB, 0.50376266E-05_JPRB, 0.49943806E-05_JPRB, 0.50113658E-05_JPRB, 0.50934941E-05_JPRB, 0.52056835E-05_JPRB, &
  & 0.53192143E-05_JPRB, 0.54198304E-05_JPRB, 0.55030337E-05_JPRB, 0.55688397E-05_JPRB, 0.56097651E-05_JPRB, 0.56249633E-05_JPRB, &
  & 0.56152076E-05_JPRB, 0.55834962E-05_JPRB, 0.55325531E-05_JPRB, 0.54656184E-05_JPRB, 0.53885215E-05_JPRB, 0.53019135E-05_JPRB, &
  & 0.52095284E-05_JPRB, 0.51148436E-05_JPRB, 0.50150411E-05_JPRB, 0.49182286E-05_JPRB, 0.48448633E-05_JPRB, 0.47891917E-05_JPRB, &
  & 0.47640351E-05_JPRB, 0.47777021E-05_JPRB, 0.48334082E-05_JPRB, 0.49274890E-05_JPRB, 0.50527051E-05_JPRB, 0.51849138E-05_JPRB, &
  & 0.53148574E-05_JPRB, 0.54298744E-05_JPRB, 0.55331120E-05_JPRB, 0.56220956E-05_JPRB, 0.57055968E-05_JPRB, 0.57798193E-05_JPRB, &
  & 0.58452024E-05_JPRB, 0.58945343E-05_JPRB, 0.59289655E-05_JPRB, 0.59475765E-05_JPRB, 0.59469094E-05_JPRB, 0.59233435E-05_JPRB, &
  & 0.58832152E-05_JPRB, 0.58267783E-05_JPRB, 0.57513598E-05_JPRB, 0.56618187E-05_JPRB, 0.55577784E-05_JPRB, 0.54422844E-05_JPRB, &
  & 0.53185304E-05_JPRB, 0.51905731E-05_JPRB, 0.50672124E-05_JPRB, 0.49587761E-05_JPRB, 0.48660954E-05_JPRB, 0.47888307E-05_JPRB, &
  & 0.47259068E-05_JPRB, 0.46745017E-05_JPRB, 0.46296555E-05_JPRB, 0.45728516E-05_JPRB /)

RGHG7(:,25, 6) = (/ &
  & 0.47543849E-05_JPRB, 0.48143465E-05_JPRB, 0.48466541E-05_JPRB, 0.48703591E-05_JPRB, 0.48883162E-05_JPRB, 0.48981042E-05_JPRB, &
  & 0.48931192E-05_JPRB, 0.48629540E-05_JPRB, 0.48066495E-05_JPRB, 0.48076386E-05_JPRB, 0.48723564E-05_JPRB, 0.49627333E-05_JPRB, &
  & 0.50475865E-05_JPRB, 0.51108309E-05_JPRB, 0.51480579E-05_JPRB, 0.51606080E-05_JPRB, 0.51516167E-05_JPRB, 0.51213942E-05_JPRB, &
  & 0.50720068E-05_JPRB, 0.50066683E-05_JPRB, 0.49311120E-05_JPRB, 0.48492470E-05_JPRB, 0.47663616E-05_JPRB, 0.46813939E-05_JPRB, &
  & 0.45996608E-05_JPRB, 0.45169845E-05_JPRB, 0.44337908E-05_JPRB, 0.43459249E-05_JPRB, 0.42502857E-05_JPRB, 0.41617500E-05_JPRB, &
  & 0.40854729E-05_JPRB, 0.40317909E-05_JPRB, 0.40092477E-05_JPRB, 0.40239379E-05_JPRB, 0.40730943E-05_JPRB, 0.41504290E-05_JPRB, &
  & 0.42481674E-05_JPRB, 0.43605310E-05_JPRB, 0.44842395E-05_JPRB, 0.46175237E-05_JPRB, 0.47550293E-05_JPRB, 0.48913166E-05_JPRB, &
  & 0.50177105E-05_JPRB, 0.51270217E-05_JPRB, 0.52150922E-05_JPRB, 0.52792298E-05_JPRB, 0.53137555E-05_JPRB, 0.53229437E-05_JPRB, &
  & 0.53110280E-05_JPRB, 0.52793612E-05_JPRB, 0.52306264E-05_JPRB, 0.51681204E-05_JPRB, 0.50930971E-05_JPRB, 0.50087469E-05_JPRB, &
  & 0.49176824E-05_JPRB, 0.48230318E-05_JPRB, 0.47312910E-05_JPRB, 0.46499677E-05_JPRB, 0.45800207E-05_JPRB, 0.45214852E-05_JPRB, &
  & 0.44736325E-05_JPRB, 0.44342837E-05_JPRB, 0.43995051E-05_JPRB, 0.43536797E-05_JPRB /)

RGHG7(:,26, 6) = (/ &
  & 0.45410911E-05_JPRB, 0.46004316E-05_JPRB, 0.46316277E-05_JPRB, 0.46549453E-05_JPRB, 0.46716009E-05_JPRB, 0.46792661E-05_JPRB, &
  & 0.46706523E-05_JPRB, 0.46344062E-05_JPRB, 0.45689180E-05_JPRB, 0.45514735E-05_JPRB, 0.45896686E-05_JPRB, 0.46481314E-05_JPRB, &
  & 0.46955201E-05_JPRB, 0.47157669E-05_JPRB, 0.47060248E-05_JPRB, 0.46717482E-05_JPRB, 0.46180544E-05_JPRB, 0.45497331E-05_JPRB, &
  & 0.44703124E-05_JPRB, 0.43844070E-05_JPRB, 0.42969828E-05_JPRB, 0.42137403E-05_JPRB, 0.41370572E-05_JPRB, 0.40672503E-05_JPRB, &
  & 0.40071668E-05_JPRB, 0.39505785E-05_JPRB, 0.38906524E-05_JPRB, 0.38173889E-05_JPRB, 0.37269522E-05_JPRB, 0.36180702E-05_JPRB, &
  & 0.35065848E-05_JPRB, 0.34045456E-05_JPRB, 0.33249387E-05_JPRB, 0.32797052E-05_JPRB, 0.32725816E-05_JPRB, 0.33047372E-05_JPRB, &
  & 0.33740916E-05_JPRB, 0.34787395E-05_JPRB, 0.36092554E-05_JPRB, 0.37689008E-05_JPRB, 0.39406300E-05_JPRB, 0.41179574E-05_JPRB, &
  & 0.42859829E-05_JPRB, 0.44355738E-05_JPRB, 0.45594797E-05_JPRB, 0.46547702E-05_JPRB, 0.47195736E-05_JPRB, 0.47549656E-05_JPRB, &
  & 0.47658891E-05_JPRB, 0.47567073E-05_JPRB, 0.47299841E-05_JPRB, 0.46902142E-05_JPRB, 0.46398923E-05_JPRB, 0.45815946E-05_JPRB, &
  & 0.45180327E-05_JPRB, 0.44517756E-05_JPRB, 0.43877531E-05_JPRB, 0.43312466E-05_JPRB, 0.42829702E-05_JPRB, 0.42429447E-05_JPRB, &
  & 0.42105148E-05_JPRB, 0.41842145E-05_JPRB, 0.41618091E-05_JPRB, 0.41358794E-05_JPRB /)

RGHG7(:,27, 6) = (/ &
  & 0.42967022E-05_JPRB, 0.43487380E-05_JPRB, 0.43782188E-05_JPRB, 0.43986024E-05_JPRB, 0.44127728E-05_JPRB, 0.44174603E-05_JPRB, &
  & 0.44056369E-05_JPRB, 0.43650020E-05_JPRB, 0.42941128E-05_JPRB, 0.42596039E-05_JPRB, 0.42687589E-05_JPRB, 0.42905076E-05_JPRB, &
  & 0.42978063E-05_JPRB, 0.42773709E-05_JPRB, 0.42270785E-05_JPRB, 0.41536018E-05_JPRB, 0.40645718E-05_JPRB, 0.39679207E-05_JPRB, &
  & 0.38683961E-05_JPRB, 0.37703430E-05_JPRB, 0.36795932E-05_JPRB, 0.36005415E-05_JPRB, 0.35362464E-05_JPRB, 0.34873335E-05_JPRB, &
  & 0.34509806E-05_JPRB, 0.34209138E-05_JPRB, 0.33840151E-05_JPRB, 0.33282458E-05_JPRB, 0.32461139E-05_JPRB, 0.31373916E-05_JPRB, &
  & 0.30110284E-05_JPRB, 0.28822597E-05_JPRB, 0.27692440E-05_JPRB, 0.26879470E-05_JPRB, 0.26469663E-05_JPRB, 0.26510372E-05_JPRB, &
  & 0.27012795E-05_JPRB, 0.27966819E-05_JPRB, 0.29289665E-05_JPRB, 0.30937081E-05_JPRB, 0.32833684E-05_JPRB, 0.34779173E-05_JPRB, &
  & 0.36681342E-05_JPRB, 0.38384346E-05_JPRB, 0.39836577E-05_JPRB, 0.40984546E-05_JPRB, 0.41811677E-05_JPRB, 0.42334300E-05_JPRB, &
  & 0.42613260E-05_JPRB, 0.42688657E-05_JPRB, 0.42601300E-05_JPRB, 0.42396287E-05_JPRB, 0.42099382E-05_JPRB, 0.41739022E-05_JPRB, &
  & 0.41337416E-05_JPRB, 0.40916761E-05_JPRB, 0.40511954E-05_JPRB, 0.40160567E-05_JPRB, 0.39864799E-05_JPRB, 0.39624251E-05_JPRB, &
  & 0.39433658E-05_JPRB, 0.39284419E-05_JPRB, 0.39167094E-05_JPRB, 0.39064657E-05_JPRB /)

RGHG7(:,28, 6) = (/ &
  & 0.40263908E-05_JPRB, 0.40738610E-05_JPRB, 0.40977120E-05_JPRB, 0.41151152E-05_JPRB, 0.41259523E-05_JPRB, 0.41275607E-05_JPRB, &
  & 0.41126382E-05_JPRB, 0.40699879E-05_JPRB, 0.39960710E-05_JPRB, 0.39470906E-05_JPRB, 0.39293191E-05_JPRB, 0.39167139E-05_JPRB, &
  & 0.38874173E-05_JPRB, 0.38311673E-05_JPRB, 0.37484012E-05_JPRB, 0.36459858E-05_JPRB, 0.35329729E-05_JPRB, 0.34176951E-05_JPRB, &
  & 0.33059864E-05_JPRB, 0.32028183E-05_JPRB, 0.31130708E-05_JPRB, 0.30418591E-05_JPRB, 0.29909952E-05_JPRB, 0.29592097E-05_JPRB, &
  & 0.29432554E-05_JPRB, 0.29344865E-05_JPRB, 0.29192981E-05_JPRB, 0.28825596E-05_JPRB, 0.28143747E-05_JPRB, 0.27100773E-05_JPRB, &
  & 0.25821807E-05_JPRB, 0.24450471E-05_JPRB, 0.23183543E-05_JPRB, 0.22206414E-05_JPRB, 0.21633384E-05_JPRB, 0.21532003E-05_JPRB, &
  & 0.21922001E-05_JPRB, 0.22789886E-05_JPRB, 0.24080152E-05_JPRB, 0.25703557E-05_JPRB, 0.27585381E-05_JPRB, 0.29577755E-05_JPRB, &
  & 0.31507277E-05_JPRB, 0.33279719E-05_JPRB, 0.34803447E-05_JPRB, 0.36024383E-05_JPRB, 0.36942542E-05_JPRB, 0.37565576E-05_JPRB, &
  & 0.37958291E-05_JPRB, 0.38164826E-05_JPRB, 0.38226231E-05_JPRB, 0.38184221E-05_JPRB, 0.38067724E-05_JPRB, 0.37899599E-05_JPRB, &
  & 0.37701313E-05_JPRB, 0.37488392E-05_JPRB, 0.37287462E-05_JPRB, 0.37124960E-05_JPRB, 0.37002196E-05_JPRB, 0.36919114E-05_JPRB, &
  & 0.36870010E-05_JPRB, 0.36853639E-05_JPRB, 0.36877391E-05_JPRB, 0.37001396E-05_JPRB /)

RGHG7(:,29, 6) = (/ &
  & 0.37454483E-05_JPRB, 0.37839748E-05_JPRB, 0.38041023E-05_JPRB, 0.38173407E-05_JPRB, 0.38248400E-05_JPRB, 0.38233370E-05_JPRB, &
  & 0.38062012E-05_JPRB, 0.37621398E-05_JPRB, 0.36882334E-05_JPRB, 0.36285423E-05_JPRB, 0.35880555E-05_JPRB, 0.35464263E-05_JPRB, &
  & 0.34870839E-05_JPRB, 0.34035779E-05_JPRB, 0.32976138E-05_JPRB, 0.31766772E-05_JPRB, 0.30490394E-05_JPRB, 0.29233820E-05_JPRB, &
  & 0.28062686E-05_JPRB, 0.27020992E-05_JPRB, 0.26161968E-05_JPRB, 0.25514021E-05_JPRB, 0.25100503E-05_JPRB, 0.24905835E-05_JPRB, &
  & 0.24882916E-05_JPRB, 0.24939209E-05_JPRB, 0.24932945E-05_JPRB, 0.24722995E-05_JPRB, 0.24186272E-05_JPRB, 0.23283560E-05_JPRB, &
  & 0.22067611E-05_JPRB, 0.20735065E-05_JPRB, 0.19471702E-05_JPRB, 0.18470029E-05_JPRB, 0.17858938E-05_JPRB, 0.17705978E-05_JPRB, &
  & 0.18030479E-05_JPRB, 0.18820376E-05_JPRB, 0.20028147E-05_JPRB, 0.21580670E-05_JPRB, 0.23363300E-05_JPRB, 0.25253873E-05_JPRB, &
  & 0.27126459E-05_JPRB, 0.28845438E-05_JPRB, 0.30322062E-05_JPRB, 0.31544391E-05_JPRB, 0.32489388E-05_JPRB, 0.33176595E-05_JPRB, &
  & 0.33653641E-05_JPRB, 0.33972854E-05_JPRB, 0.34166865E-05_JPRB, 0.34274403E-05_JPRB, 0.34319612E-05_JPRB, 0.34323577E-05_JPRB, &
  & 0.34303202E-05_JPRB, 0.34269954E-05_JPRB, 0.34245436E-05_JPRB, 0.34246075E-05_JPRB, 0.34271161E-05_JPRB, 0.34319476E-05_JPRB, &
  & 0.34383686E-05_JPRB, 0.34464426E-05_JPRB, 0.34571240E-05_JPRB, 0.34744928E-05_JPRB /)

RGHG7(:,30, 6) = (/ &
  & 0.34640998E-05_JPRB, 0.34934760E-05_JPRB, 0.35077317E-05_JPRB, 0.35172193E-05_JPRB, 0.35211604E-05_JPRB, 0.35165624E-05_JPRB, &
  & 0.34967104E-05_JPRB, 0.34525608E-05_JPRB, 0.33796262E-05_JPRB, 0.33124275E-05_JPRB, 0.32546880E-05_JPRB, 0.31911209E-05_JPRB, &
  & 0.31102516E-05_JPRB, 0.30083866E-05_JPRB, 0.28881061E-05_JPRB, 0.27567391E-05_JPRB, 0.26223224E-05_JPRB, 0.24927233E-05_JPRB, &
  & 0.23742546E-05_JPRB, 0.22718070E-05_JPRB, 0.21895585E-05_JPRB, 0.21301521E-05_JPRB, 0.20950793E-05_JPRB, 0.20824907E-05_JPRB, &
  & 0.20872396E-05_JPRB, 0.20999980E-05_JPRB, 0.21077590E-05_JPRB, 0.20969178E-05_JPRB, 0.20556677E-05_JPRB, 0.19801264E-05_JPRB, &
  & 0.18735378E-05_JPRB, 0.17520103E-05_JPRB, 0.16350269E-05_JPRB, 0.15409286E-05_JPRB, 0.14830939E-05_JPRB, 0.14684531E-05_JPRB, &
  & 0.14978563E-05_JPRB, 0.15693283E-05_JPRB, 0.16790842E-05_JPRB, 0.18208855E-05_JPRB, 0.19853774E-05_JPRB, 0.21593232E-05_JPRB, &
  & 0.23298151E-05_JPRB, 0.24883846E-05_JPRB, 0.26282580E-05_JPRB, 0.27456065E-05_JPRB, 0.28399279E-05_JPRB, 0.29118605E-05_JPRB, &
  & 0.29672572E-05_JPRB, 0.30089357E-05_JPRB, 0.30405683E-05_JPRB, 0.30650569E-05_JPRB, 0.30842277E-05_JPRB, 0.30998626E-05_JPRB, &
  & 0.31132240E-05_JPRB, 0.31252091E-05_JPRB, 0.31373913E-05_JPRB, 0.31508523E-05_JPRB, 0.31654868E-05_JPRB, 0.31810746E-05_JPRB, &
  & 0.31967743E-05_JPRB, 0.32128823E-05_JPRB, 0.32308926E-05_JPRB, 0.32637101E-05_JPRB /)

RGHG7(:,31, 6) = (/ &
  & 0.31898212E-05_JPRB, 0.32076280E-05_JPRB, 0.32176254E-05_JPRB, 0.32230673E-05_JPRB, 0.32235730E-05_JPRB, 0.32156349E-05_JPRB, &
  & 0.31935169E-05_JPRB, 0.31483050E-05_JPRB, 0.30770732E-05_JPRB, 0.30051510E-05_JPRB, 0.29356902E-05_JPRB, 0.28579736E-05_JPRB, &
  & 0.27634758E-05_JPRB, 0.26511709E-05_JPRB, 0.25241075E-05_JPRB, 0.23890846E-05_JPRB, 0.22534580E-05_JPRB, 0.21244848E-05_JPRB, &
  & 0.20074831E-05_JPRB, 0.19080167E-05_JPRB, 0.18291239E-05_JPRB, 0.17734013E-05_JPRB, 0.17413989E-05_JPRB, 0.17310292E-05_JPRB, &
  & 0.17371616E-05_JPRB, 0.17511780E-05_JPRB, 0.17617555E-05_JPRB, 0.17575429E-05_JPRB, 0.17261336E-05_JPRB, 0.16643347E-05_JPRB, &
  & 0.15745929E-05_JPRB, 0.14693520E-05_JPRB, 0.13670347E-05_JPRB, 0.12850346E-05_JPRB, 0.12347489E-05_JPRB, 0.12224237E-05_JPRB, &
  & 0.12497281E-05_JPRB, 0.13139784E-05_JPRB, 0.14112044E-05_JPRB, 0.15369454E-05_JPRB, 0.16822513E-05_JPRB, 0.18373695E-05_JPRB, &
  & 0.19901249E-05_JPRB, 0.21327901E-05_JPRB, 0.22604568E-05_JPRB, 0.23712307E-05_JPRB, 0.24640626E-05_JPRB, 0.25388008E-05_JPRB, &
  & 0.26006423E-05_JPRB, 0.26516018E-05_JPRB, 0.26944899E-05_JPRB, 0.27315168E-05_JPRB, 0.27638698E-05_JPRB, 0.27927529E-05_JPRB, &
  & 0.28191153E-05_JPRB, 0.28436798E-05_JPRB, 0.28675636E-05_JPRB, 0.28916047E-05_JPRB, 0.29156845E-05_JPRB, 0.29395153E-05_JPRB, &
  & 0.29624516E-05_JPRB, 0.29852545E-05_JPRB, 0.30103649E-05_JPRB, 0.30549916E-05_JPRB /)

RGHG7(:,32, 6) = (/ &
  & 0.29240905E-05_JPRB, 0.29339546E-05_JPRB, 0.29391704E-05_JPRB, 0.29409384E-05_JPRB, 0.29379707E-05_JPRB, 0.29269199E-05_JPRB, &
  & 0.29021560E-05_JPRB, 0.28569339E-05_JPRB, 0.27877354E-05_JPRB, 0.27139631E-05_JPRB, 0.26378405E-05_JPRB, 0.25515583E-05_JPRB, &
  & 0.24499748E-05_JPRB, 0.23329826E-05_JPRB, 0.22049580E-05_JPRB, 0.20713196E-05_JPRB, 0.19381125E-05_JPRB, 0.18127286E-05_JPRB, &
  & 0.16994193E-05_JPRB, 0.16032186E-05_JPRB, 0.15271338E-05_JPRB, 0.14732194E-05_JPRB, 0.14416046E-05_JPRB, 0.14300076E-05_JPRB, &
  & 0.14335130E-05_JPRB, 0.14451487E-05_JPRB, 0.14541780E-05_JPRB, 0.14522419E-05_JPRB, 0.14285490E-05_JPRB, 0.13791622E-05_JPRB, &
  & 0.13055994E-05_JPRB, 0.12183084E-05_JPRB, 0.11328567E-05_JPRB, 0.10642323E-05_JPRB, 0.10239339E-05_JPRB, 0.10161956E-05_JPRB, &
  & 0.10414494E-05_JPRB, 0.10980064E-05_JPRB, 0.11825890E-05_JPRB, 0.12907267E-05_JPRB, 0.14164342E-05_JPRB, 0.15498860E-05_JPRB, &
  & 0.16834074E-05_JPRB, 0.18096960E-05_JPRB, 0.19266679E-05_JPRB, 0.20306752E-05_JPRB, 0.21216488E-05_JPRB, 0.22001809E-05_JPRB, &
  & 0.22674858E-05_JPRB, 0.23264754E-05_JPRB, 0.23794253E-05_JPRB, 0.24273309E-05_JPRB, 0.24707856E-05_JPRB, 0.25108504E-05_JPRB, &
  & 0.25478150E-05_JPRB, 0.25824329E-05_JPRB, 0.26155105E-05_JPRB, 0.26476803E-05_JPRB, 0.26789642E-05_JPRB, 0.27091610E-05_JPRB, &
  & 0.27378458E-05_JPRB, 0.27658555E-05_JPRB, 0.27963999E-05_JPRB, 0.28465900E-05_JPRB /)

RGHG7(:,33, 6) = (/ &
  & 0.26738908E-05_JPRB, 0.26754758E-05_JPRB, 0.26759615E-05_JPRB, 0.26740204E-05_JPRB, 0.26674834E-05_JPRB, 0.26533537E-05_JPRB, &
  & 0.26268267E-05_JPRB, 0.25818713E-05_JPRB, 0.25161767E-05_JPRB, 0.24429353E-05_JPRB, 0.23634757E-05_JPRB, 0.22732802E-05_JPRB, &
  & 0.21693272E-05_JPRB, 0.20526381E-05_JPRB, 0.19270378E-05_JPRB, 0.17983336E-05_JPRB, 0.16705312E-05_JPRB, 0.15500592E-05_JPRB, &
  & 0.14414296E-05_JPRB, 0.13486457E-05_JPRB, 0.12745595E-05_JPRB, 0.12208951E-05_JPRB, 0.11876423E-05_JPRB, 0.11723962E-05_JPRB, &
  & 0.11709782E-05_JPRB, 0.11773111E-05_JPRB, 0.11823390E-05_JPRB, 0.11798130E-05_JPRB, 0.11613582E-05_JPRB, 0.11225302E-05_JPRB, &
  & 0.10640249E-05_JPRB, 0.99441775E-06_JPRB, 0.92619473E-06_JPRB, 0.87212203E-06_JPRB, 0.84060036E-06_JPRB, 0.83721051E-06_JPRB, &
  & 0.86117444E-06_JPRB, 0.91027050E-06_JPRB, 0.98222677E-06_JPRB, 0.10741755E-05_JPRB, 0.11799580E-05_JPRB, 0.12940891E-05_JPRB, &
  & 0.14086876E-05_JPRB, 0.15204548E-05_JPRB, 0.16261071E-05_JPRB, 0.17247072E-05_JPRB, 0.18140021E-05_JPRB, 0.18950022E-05_JPRB, &
  & 0.19680299E-05_JPRB, 0.20342068E-05_JPRB, 0.20956322E-05_JPRB, 0.21524568E-05_JPRB, 0.22052759E-05_JPRB, 0.22542013E-05_JPRB, &
  & 0.22994316E-05_JPRB, 0.23417631E-05_JPRB, 0.23816503E-05_JPRB, 0.24197789E-05_JPRB, 0.24562646E-05_JPRB, 0.24908154E-05_JPRB, &
  & 0.25234258E-05_JPRB, 0.25550266E-05_JPRB, 0.25891138E-05_JPRB, 0.26453038E-05_JPRB /)

RGHG7(:,34, 6) = (/ &
  & 0.24426731E-05_JPRB, 0.24343690E-05_JPRB, 0.24298956E-05_JPRB, 0.24239489E-05_JPRB, 0.24140827E-05_JPRB, 0.23971079E-05_JPRB, &
  & 0.23688106E-05_JPRB, 0.23249445E-05_JPRB, 0.22631627E-05_JPRB, 0.21920973E-05_JPRB, 0.21127594E-05_JPRB, 0.20222126E-05_JPRB, &
  & 0.19198178E-05_JPRB, 0.18068424E-05_JPRB, 0.16867725E-05_JPRB, 0.15644770E-05_JPRB, 0.14438596E-05_JPRB, 0.13293520E-05_JPRB, &
  & 0.12255683E-05_JPRB, 0.11359678E-05_JPRB, 0.10631065E-05_JPRB, 0.10084204E-05_JPRB, 0.97192481E-06_JPRB, 0.95156412E-06_JPRB, &
  & 0.94375531E-06_JPRB, 0.94345717E-06_JPRB, 0.94380863E-06_JPRB, 0.93886342E-06_JPRB, 0.92354105E-06_JPRB, 0.89282332E-06_JPRB, &
  & 0.84753543E-06_JPRB, 0.79389503E-06_JPRB, 0.74163910E-06_JPRB, 0.70087964E-06_JPRB, 0.67912680E-06_JPRB, 0.67899612E-06_JPRB, &
  & 0.70124571E-06_JPRB, 0.74360253E-06_JPRB, 0.80424019E-06_JPRB, 0.88090684E-06_JPRB, 0.97007694E-06_JPRB, 0.10664133E-05_JPRB, &
  & 0.11656541E-05_JPRB, 0.12641923E-05_JPRB, 0.13611742E-05_JPRB, 0.14544678E-05_JPRB, 0.15424597E-05_JPRB, 0.16253194E-05_JPRB, &
  & 0.17027636E-05_JPRB, 0.17750106E-05_JPRB, 0.18429619E-05_JPRB, 0.19070386E-05_JPRB, 0.19669117E-05_JPRB, 0.20223467E-05_JPRB, &
  & 0.20738853E-05_JPRB, 0.21217913E-05_JPRB, 0.21665949E-05_JPRB, 0.22088054E-05_JPRB, 0.22485126E-05_JPRB, 0.22856536E-05_JPRB, &
  & 0.23204664E-05_JPRB, 0.23538314E-05_JPRB, 0.23898958E-05_JPRB, 0.24481492E-05_JPRB /)

RGHG7(:,35, 6) = (/ &
  & 0.22282029E-05_JPRB, 0.22110705E-05_JPRB, 0.22017878E-05_JPRB, 0.21920662E-05_JPRB, 0.21790711E-05_JPRB, 0.21595381E-05_JPRB, &
  & 0.21302626E-05_JPRB, 0.20876232E-05_JPRB, 0.20300488E-05_JPRB, 0.19624385E-05_JPRB, 0.18853905E-05_JPRB, 0.17976015E-05_JPRB, &
  & 0.16993044E-05_JPRB, 0.15923046E-05_JPRB, 0.14795775E-05_JPRB, 0.13648630E-05_JPRB, 0.12519453E-05_JPRB, 0.11440260E-05_JPRB, &
  & 0.10448730E-05_JPRB, 0.95775567E-06_JPRB, 0.88529725E-06_JPRB, 0.82858855E-06_JPRB, 0.78759962E-06_JPRB, 0.76131914E-06_JPRB, &
  & 0.74639127E-06_JPRB, 0.73908200E-06_JPRB, 0.73392420E-06_JPRB, 0.72626040E-06_JPRB, 0.71195933E-06_JPRB, 0.68796095E-06_JPRB, &
  & 0.65404720E-06_JPRB, 0.61451982E-06_JPRB, 0.57638550E-06_JPRB, 0.54753178E-06_JPRB, 0.53370849E-06_JPRB, 0.53715166E-06_JPRB, &
  & 0.55751821E-06_JPRB, 0.59392829E-06_JPRB, 0.64482970E-06_JPRB, 0.70891053E-06_JPRB, 0.78369027E-06_JPRB, 0.86633179E-06_JPRB, &
  & 0.95256985E-06_JPRB, 0.10410761E-05_JPRB, 0.11305319E-05_JPRB, 0.12197038E-05_JPRB, 0.13063604E-05_JPRB, 0.13902678E-05_JPRB, &
  & 0.14711685E-05_JPRB, 0.15477054E-05_JPRB, 0.16207595E-05_JPRB, 0.16899194E-05_JPRB, 0.17547603E-05_JPRB, 0.18148784E-05_JPRB, &
  & 0.18706618E-05_JPRB, 0.19223130E-05_JPRB, 0.19703180E-05_JPRB, 0.20150358E-05_JPRB, 0.20565251E-05_JPRB, 0.20948200E-05_JPRB, &
  & 0.21303144E-05_JPRB, 0.21641338E-05_JPRB, 0.22004115E-05_JPRB, 0.22590746E-05_JPRB /)

RGHG7(:,36, 6) = (/ &
  & 0.20312309E-05_JPRB, 0.20052992E-05_JPRB, 0.19917841E-05_JPRB, 0.19785250E-05_JPRB, 0.19626593E-05_JPRB, 0.19411748E-05_JPRB, &
  & 0.19111519E-05_JPRB, 0.18701879E-05_JPRB, 0.18168189E-05_JPRB, 0.17533937E-05_JPRB, 0.16803513E-05_JPRB, 0.15973251E-05_JPRB, &
  & 0.15051608E-05_JPRB, 0.14055244E-05_JPRB, 0.13010978E-05_JPRB, 0.11947369E-05_JPRB, 0.10893809E-05_JPRB, 0.98810744E-06_JPRB, &
  & 0.89340875E-06_JPRB, 0.80820598E-06_JPRB, 0.73481624E-06_JPRB, 0.67509916E-06_JPRB, 0.62932384E-06_JPRB, 0.59683373E-06_JPRB, &
  & 0.57509635E-06_JPRB, 0.56104017E-06_JPRB, 0.55072553E-06_JPRB, 0.54033393E-06_JPRB, 0.52690928E-06_JPRB, 0.50797519E-06_JPRB, &
  & 0.48354036E-06_JPRB, 0.45607484E-06_JPRB, 0.43038153E-06_JPRB, 0.41184782E-06_JPRB, 0.40451860E-06_JPRB, 0.41006200E-06_JPRB, &
  & 0.42866500E-06_JPRB, 0.45942235E-06_JPRB, 0.50191062E-06_JPRB, 0.55553119E-06_JPRB, 0.61949294E-06_JPRB, 0.69109404E-06_JPRB, &
  & 0.76822477E-06_JPRB, 0.84876200E-06_JPRB, 0.93250952E-06_JPRB, 0.10178885E-05_JPRB, 0.11032577E-05_JPRB, 0.11879330E-05_JPRB, &
  & 0.12707228E-05_JPRB, 0.13503235E-05_JPRB, 0.14267935E-05_JPRB, 0.14992887E-05_JPRB, 0.15673256E-05_JPRB, 0.16302702E-05_JPRB, &
  & 0.16885832E-05_JPRB, 0.17425230E-05_JPRB, 0.17924147E-05_JPRB, 0.18383183E-05_JPRB, 0.18803108E-05_JPRB, 0.19184899E-05_JPRB, &
  & 0.19534059E-05_JPRB, 0.19863903E-05_JPRB, 0.20215905E-05_JPRB, 0.20783327E-05_JPRB /)

RGHG7(:,37, 6) = (/ &
  & 0.18492477E-05_JPRB, 0.18161109E-05_JPRB, 0.17986520E-05_JPRB, 0.17823108E-05_JPRB, 0.17639156E-05_JPRB, 0.17407481E-05_JPRB, &
  & 0.17105759E-05_JPRB, 0.16714760E-05_JPRB, 0.16222207E-05_JPRB, 0.15636125E-05_JPRB, 0.14957353E-05_JPRB, 0.14188035E-05_JPRB, &
  & 0.13340690E-05_JPRB, 0.12427614E-05_JPRB, 0.11470055E-05_JPRB, 0.10493378E-05_JPRB, 0.95170788E-06_JPRB, 0.85662310E-06_JPRB, &
  & 0.76612605E-06_JPRB, 0.68260704E-06_JPRB, 0.60837147E-06_JPRB, 0.54541755E-06_JPRB, 0.49543746E-06_JPRB, 0.45792564E-06_JPRB, &
  & 0.43161643E-06_JPRB, 0.41312549E-06_JPRB, 0.39964715E-06_JPRB, 0.38783182E-06_JPRB, 0.37554659E-06_JPRB, 0.36093613E-06_JPRB, &
  & 0.34403519E-06_JPRB, 0.32620389E-06_JPRB, 0.31034764E-06_JPRB, 0.29992702E-06_JPRB, 0.29726968E-06_JPRB, 0.30392420E-06_JPRB, &
  & 0.31965484E-06_JPRB, 0.34472112E-06_JPRB, 0.37919799E-06_JPRB, 0.42351357E-06_JPRB, 0.47751246E-06_JPRB, 0.54018528E-06_JPRB, &
  & 0.60968370E-06_JPRB, 0.68459667E-06_JPRB, 0.76358566E-06_JPRB, 0.84564351E-06_JPRB, 0.92953593E-06_JPRB, 0.10143093E-05_JPRB, &
  & 0.10980833E-05_JPRB, 0.11794484E-05_JPRB, 0.12578621E-05_JPRB, 0.13323726E-05_JPRB, 0.14018556E-05_JPRB, 0.14662423E-05_JPRB, &
  & 0.15257212E-05_JPRB, 0.15807225E-05_JPRB, 0.16312632E-05_JPRB, 0.16773217E-05_JPRB, 0.17187688E-05_JPRB, 0.17557890E-05_JPRB, &
  & 0.17890995E-05_JPRB, 0.18203035E-05_JPRB, 0.18533328E-05_JPRB, 0.19068872E-05_JPRB /)

RGHG7(:,38, 6) = (/ &
  & 0.16807577E-05_JPRB, 0.16423083E-05_JPRB, 0.16210216E-05_JPRB, 0.16021581E-05_JPRB, 0.15812689E-05_JPRB, 0.15568982E-05_JPRB, &
  & 0.15268860E-05_JPRB, 0.14898643E-05_JPRB, 0.14447660E-05_JPRB, 0.13913383E-05_JPRB, 0.13294800E-05_JPRB, 0.12596740E-05_JPRB, &
  & 0.11828985E-05_JPRB, 0.11003627E-05_JPRB, 0.10136630E-05_JPRB, 0.92454536E-06_JPRB, 0.83476715E-06_JPRB, 0.74582869E-06_JPRB, &
  & 0.65954384E-06_JPRB, 0.57798024E-06_JPRB, 0.50403361E-06_JPRB, 0.44061281E-06_JPRB, 0.38963887E-06_JPRB, 0.35166826E-06_JPRB, &
  & 0.32488708E-06_JPRB, 0.30633583E-06_JPRB, 0.29267611E-06_JPRB, 0.28147397E-06_JPRB, 0.27078647E-06_JPRB, 0.25964931E-06_JPRB, &
  & 0.24796563E-06_JPRB, 0.23655555E-06_JPRB, 0.22724258E-06_JPRB, 0.22185826E-06_JPRB, 0.22200219E-06_JPRB, 0.22832334E-06_JPRB, &
  & 0.24085892E-06_JPRB, 0.26035551E-06_JPRB, 0.28716087E-06_JPRB, 0.32164547E-06_JPRB, 0.36512330E-06_JPRB, 0.41791480E-06_JPRB, &
  & 0.47901892E-06_JPRB, 0.54715713E-06_JPRB, 0.62123058E-06_JPRB, 0.70003580E-06_JPRB, 0.78203527E-06_JPRB, 0.86600613E-06_JPRB, &
  & 0.94985040E-06_JPRB, 0.10316124E-05_JPRB, 0.11108538E-05_JPRB, 0.11859863E-05_JPRB, 0.12558518E-05_JPRB, 0.13204560E-05_JPRB, &
  & 0.13799958E-05_JPRB, 0.14350276E-05_JPRB, 0.14853398E-05_JPRB, 0.15306648E-05_JPRB, 0.15706954E-05_JPRB, 0.16057414E-05_JPRB, &
  & 0.16367104E-05_JPRB, 0.16654436E-05_JPRB, 0.16957217E-05_JPRB, 0.17450940E-05_JPRB /)

RGHG7(:,39, 6) = (/ &
  & 0.15253365E-05_JPRB, 0.14817302E-05_JPRB, 0.14583436E-05_JPRB, 0.14362773E-05_JPRB, 0.14137834E-05_JPRB, 0.13881560E-05_JPRB, &
  & 0.13586816E-05_JPRB, 0.13240735E-05_JPRB, 0.12831534E-05_JPRB, 0.12351476E-05_JPRB, 0.11798223E-05_JPRB, 0.11174355E-05_JPRB, &
  & 0.10490579E-05_JPRB, 0.97545728E-06_JPRB, 0.89774983E-06_JPRB, 0.81728274E-06_JPRB, 0.73522051E-06_JPRB, 0.65272150E-06_JPRB, &
  & 0.57136373E-06_JPRB, 0.49279220E-06_JPRB, 0.42125808E-06_JPRB, 0.36061556E-06_JPRB, 0.31354546E-06_JPRB, 0.27936693E-06_JPRB, &
  & 0.25590191E-06_JPRB, 0.23968562E-06_JPRB, 0.22776692E-06_JPRB, 0.21793392E-06_JPRB, 0.20889419E-06_JPRB, 0.20003250E-06_JPRB, &
  & 0.19139688E-06_JPRB, 0.18356299E-06_JPRB, 0.17785591E-06_JPRB, 0.17509642E-06_JPRB, 0.17649151E-06_JPRB, 0.18225349E-06_JPRB, &
  & 0.19199790E-06_JPRB, 0.20738851E-06_JPRB, 0.22742009E-06_JPRB, 0.25333298E-06_JPRB, 0.28696576E-06_JPRB, 0.32900115E-06_JPRB, &
  & 0.37949528E-06_JPRB, 0.43840390E-06_JPRB, 0.50541314E-06_JPRB, 0.57904560E-06_JPRB, 0.65783502E-06_JPRB, 0.73989173E-06_JPRB, &
  & 0.82259754E-06_JPRB, 0.90381047E-06_JPRB, 0.98267367E-06_JPRB, 0.10573474E-05_JPRB, 0.11265992E-05_JPRB, 0.11904582E-05_JPRB, &
  & 0.12493285E-05_JPRB, 0.13036099E-05_JPRB, 0.13529871E-05_JPRB, 0.13968306E-05_JPRB, 0.14347862E-05_JPRB, 0.14672493E-05_JPRB, &
  & 0.14954340E-05_JPRB, 0.15212920E-05_JPRB, 0.15485987E-05_JPRB, 0.15932764E-05_JPRB /)

RGHG7(:,40, 6) = (/ &
  & 0.13807896E-05_JPRB, 0.13352904E-05_JPRB, 0.13084064E-05_JPRB, 0.12849250E-05_JPRB, 0.12598148E-05_JPRB, 0.12337089E-05_JPRB, &
  & 0.12049845E-05_JPRB, 0.11728656E-05_JPRB, 0.11361921E-05_JPRB, 0.10938226E-05_JPRB, 0.10451221E-05_JPRB, 0.99033377E-06_JPRB, &
  & 0.93011795E-06_JPRB, 0.86526683E-06_JPRB, 0.79644872E-06_JPRB, 0.72452139E-06_JPRB, 0.65039580E-06_JPRB, 0.57485818E-06_JPRB, &
  & 0.49918299E-06_JPRB, 0.42640477E-06_JPRB, 0.35944433E-06_JPRB, 0.30390561E-06_JPRB, 0.26200416E-06_JPRB, 0.23288810E-06_JPRB, &
  & 0.21329438E-06_JPRB, 0.19977168E-06_JPRB, 0.18957682E-06_JPRB, 0.18101463E-06_JPRB, 0.17316613E-06_JPRB, 0.16569165E-06_JPRB, &
  & 0.15877569E-06_JPRB, 0.15283362E-06_JPRB, 0.14897523E-06_JPRB, 0.14761153E-06_JPRB, 0.14948951E-06_JPRB, 0.15473336E-06_JPRB, &
  & 0.16269432E-06_JPRB, 0.17521570E-06_JPRB, 0.19053098E-06_JPRB, 0.21038322E-06_JPRB, 0.23621736E-06_JPRB, 0.26857379E-06_JPRB, &
  & 0.30841065E-06_JPRB, 0.35685522E-06_JPRB, 0.41433819E-06_JPRB, 0.48079158E-06_JPRB, 0.55439511E-06_JPRB, 0.63286836E-06_JPRB, &
  & 0.71350104E-06_JPRB, 0.79302237E-06_JPRB, 0.87042480E-06_JPRB, 0.94386934E-06_JPRB, 0.10116581E-05_JPRB, 0.10741513E-05_JPRB, &
  & 0.11317782E-05_JPRB, 0.11848031E-05_JPRB, 0.12326650E-05_JPRB, 0.12745588E-05_JPRB, 0.13099353E-05_JPRB, 0.13394832E-05_JPRB, &
  & 0.13646275E-05_JPRB, 0.13875925E-05_JPRB, 0.14117310E-05_JPRB, 0.14517996E-05_JPRB /)

RGHG7(:,41, 6) = (/ &
  & 0.12478611E-05_JPRB, 0.11996178E-05_JPRB, 0.11722082E-05_JPRB, 0.11456015E-05_JPRB, 0.11195334E-05_JPRB, 0.10924457E-05_JPRB, &
  & 0.10647750E-05_JPRB, 0.10353455E-05_JPRB, 0.10028502E-05_JPRB, 0.96594567E-06_JPRB, 0.92387660E-06_JPRB, 0.87644463E-06_JPRB, &
  & 0.82416653E-06_JPRB, 0.76755720E-06_JPRB, 0.70720262E-06_JPRB, 0.64360393E-06_JPRB, 0.57741653E-06_JPRB, 0.50938223E-06_JPRB, &
  & 0.44049648E-06_JPRB, 0.37354889E-06_JPRB, 0.31379142E-06_JPRB, 0.26457272E-06_JPRB, 0.22803610E-06_JPRB, 0.20282621E-06_JPRB, &
  & 0.18600882E-06_JPRB, 0.17436589E-06_JPRB, 0.16544296E-06_JPRB, 0.15778770E-06_JPRB, 0.15078319E-06_JPRB, 0.14417851E-06_JPRB, &
  & 0.13824472E-06_JPRB, 0.13342799E-06_JPRB, 0.13050041E-06_JPRB, 0.12996469E-06_JPRB, 0.13192474E-06_JPRB, 0.13685266E-06_JPRB, &
  & 0.14361183E-06_JPRB, 0.15415308E-06_JPRB, 0.16647957E-06_JPRB, 0.18225745E-06_JPRB, 0.20247795E-06_JPRB, 0.22741234E-06_JPRB, &
  & 0.25830619E-06_JPRB, 0.29668567E-06_JPRB, 0.34416834E-06_JPRB, 0.40172401E-06_JPRB, 0.46850712E-06_JPRB, 0.54210449E-06_JPRB, &
  & 0.61927562E-06_JPRB, 0.69635337E-06_JPRB, 0.77133927E-06_JPRB, 0.84279225E-06_JPRB, 0.90860181E-06_JPRB, 0.96924475E-06_JPRB, &
  & 0.10252243E-05_JPRB, 0.10765586E-05_JPRB, 0.11226620E-05_JPRB, 0.11621972E-05_JPRB, 0.11947932E-05_JPRB, 0.12212951E-05_JPRB, &
  & 0.12434722E-05_JPRB, 0.12635345E-05_JPRB, 0.12848152E-05_JPRB, 0.13203879E-05_JPRB /)

RGHG7(:,42, 6) = (/ &
  & 0.11239441E-05_JPRB, 0.10759820E-05_JPRB, 0.10463212E-05_JPRB, 0.10192527E-05_JPRB, 0.99087697E-06_JPRB, 0.96370240E-06_JPRB, &
  & 0.93708348E-06_JPRB, 0.91024162E-06_JPRB, 0.88175148E-06_JPRB, 0.85016904E-06_JPRB, 0.81436849E-06_JPRB, 0.77385329E-06_JPRB, &
  & 0.72894494E-06_JPRB, 0.68008251E-06_JPRB, 0.62765622E-06_JPRB, 0.57214413E-06_JPRB, 0.51379300E-06_JPRB, 0.45338453E-06_JPRB, &
  & 0.39192969E-06_JPRB, 0.33187001E-06_JPRB, 0.27759674E-06_JPRB, 0.23431777E-06_JPRB, 0.20294338E-06_JPRB, 0.18151954E-06_JPRB, &
  & 0.16698151E-06_JPRB, 0.15664573E-06_JPRB, 0.14860196E-06_JPRB, 0.14162764E-06_JPRB, 0.13518340E-06_JPRB, 0.12919767E-06_JPRB, &
  & 0.12385372E-06_JPRB, 0.11972099E-06_JPRB, 0.11732908E-06_JPRB, 0.11725750E-06_JPRB, 0.11918547E-06_JPRB, 0.12384504E-06_JPRB, &
  & 0.12976514E-06_JPRB, 0.13894746E-06_JPRB, 0.14931739E-06_JPRB, 0.16230484E-06_JPRB, 0.17857309E-06_JPRB, 0.19818131E-06_JPRB, &
  & 0.22226054E-06_JPRB, 0.25230912E-06_JPRB, 0.29046598E-06_JPRB, 0.33846726E-06_JPRB, 0.39703886E-06_JPRB, 0.46430486E-06_JPRB, &
  & 0.53702365E-06_JPRB, 0.61073757E-06_JPRB, 0.68267468E-06_JPRB, 0.75143964E-06_JPRB, 0.81486917E-06_JPRB, 0.87317341E-06_JPRB, &
  & 0.92720444E-06_JPRB, 0.97670898E-06_JPRB, 0.10206888E-05_JPRB, 0.10577776E-05_JPRB, 0.10875118E-05_JPRB, 0.11110803E-05_JPRB, &
  & 0.11304603E-05_JPRB, 0.11479431E-05_JPRB, 0.11665520E-05_JPRB, 0.11982379E-05_JPRB /)

RGHG7(:,43, 6) = (/ &
  & 0.10085839E-05_JPRB, 0.96051940E-06_JPRB, 0.93167250E-06_JPRB, 0.90273647E-06_JPRB, 0.87385797E-06_JPRB, 0.84611270E-06_JPRB, &
  & 0.82071745E-06_JPRB, 0.79635259E-06_JPRB, 0.77157546E-06_JPRB, 0.74480278E-06_JPRB, 0.71480144E-06_JPRB, 0.68074507E-06_JPRB, &
  & 0.64259126E-06_JPRB, 0.60073842E-06_JPRB, 0.55568773E-06_JPRB, 0.50769563E-06_JPRB, 0.45715390E-06_JPRB, 0.40427167E-06_JPRB, &
  & 0.35019977E-06_JPRB, 0.29713055E-06_JPRB, 0.24941681E-06_JPRB, 0.21089051E-06_JPRB, 0.18334798E-06_JPRB, 0.16487698E-06_JPRB, &
  & 0.15237383E-06_JPRB, 0.14320258E-06_JPRB, 0.13582034E-06_JPRB, 0.12935328E-06_JPRB, 0.12334723E-06_JPRB, 0.11776094E-06_JPRB, &
  & 0.11282582E-06_JPRB, 0.10909418E-06_JPRB, 0.10705111E-06_JPRB, 0.10714981E-06_JPRB, 0.10911755E-06_JPRB, 0.11336886E-06_JPRB, &
  & 0.11887873E-06_JPRB, 0.12689732E-06_JPRB, 0.13607821E-06_JPRB, 0.14703596E-06_JPRB, 0.16053365E-06_JPRB, 0.17630154E-06_JPRB, &
  & 0.19523490E-06_JPRB, 0.21871723E-06_JPRB, 0.24863374E-06_JPRB, 0.28733723E-06_JPRB, 0.33667550E-06_JPRB, 0.39652747E-06_JPRB, &
  & 0.46352054E-06_JPRB, 0.53315688E-06_JPRB, 0.60176126E-06_JPRB, 0.66727205E-06_JPRB, 0.72790203E-06_JPRB, 0.78360159E-06_JPRB, &
  & 0.83532314E-06_JPRB, 0.88263715E-06_JPRB, 0.92439865E-06_JPRB, 0.95888777E-06_JPRB, 0.98588066E-06_JPRB, 0.10067276E-05_JPRB, &
  & 0.10236623E-05_JPRB, 0.10388594E-05_JPRB, 0.10553156E-05_JPRB, 0.10837474E-05_JPRB /)

RGHG7(:,44, 6) = (/ &
  & 0.89935077E-06_JPRB, 0.85384210E-06_JPRB, 0.82456125E-06_JPRB, 0.79660754E-06_JPRB, 0.76627367E-06_JPRB, 0.73883723E-06_JPRB, &
  & 0.71441025E-06_JPRB, 0.69235534E-06_JPRB, 0.67090303E-06_JPRB, 0.64847649E-06_JPRB, 0.62357270E-06_JPRB, 0.59528116E-06_JPRB, &
  & 0.56322818E-06_JPRB, 0.52777699E-06_JPRB, 0.48933487E-06_JPRB, 0.44850049E-06_JPRB, 0.40526768E-06_JPRB, 0.36004465E-06_JPRB, &
  & 0.31309014E-06_JPRB, 0.26681465E-06_JPRB, 0.22487868E-06_JPRB, 0.19171584E-06_JPRB, 0.16785330E-06_JPRB, 0.15167042E-06_JPRB, &
  & 0.14058787E-06_JPRB, 0.13234596E-06_JPRB, 0.12553414E-06_JPRB, 0.11946376E-06_JPRB, 0.11378160E-06_JPRB, 0.10847923E-06_JPRB, &
  & 0.10381428E-06_JPRB, 0.10031548E-06_JPRB, 0.98495967E-07_JPRB, 0.98629286E-07_JPRB, 0.10060355E-06_JPRB, 0.10445083E-06_JPRB, &
  & 0.10973927E-06_JPRB, 0.11683387E-06_JPRB, 0.12522777E-06_JPRB, 0.13474208E-06_JPRB, 0.14619657E-06_JPRB, 0.15918091E-06_JPRB, &
  & 0.17428779E-06_JPRB, 0.19251634E-06_JPRB, 0.21546406E-06_JPRB, 0.24569198E-06_JPRB, 0.28552020E-06_JPRB, 0.33651222E-06_JPRB, &
  & 0.39665088E-06_JPRB, 0.46147761E-06_JPRB, 0.52623699E-06_JPRB, 0.58801430E-06_JPRB, 0.64541575E-06_JPRB, 0.69812114E-06_JPRB, &
  & 0.74712165E-06_JPRB, 0.79203488E-06_JPRB, 0.83124547E-06_JPRB, 0.86318721E-06_JPRB, 0.88753382E-06_JPRB, 0.90601850E-06_JPRB, &
  & 0.92080802E-06_JPRB, 0.93421187E-06_JPRB, 0.94882489E-06_JPRB, 0.97483587E-06_JPRB /)

RGHG7(:,45, 6) = (/ &
  & 0.79498432E-06_JPRB, 0.75210136E-06_JPRB, 0.72613210E-06_JPRB, 0.69753401E-06_JPRB, 0.66809889E-06_JPRB, 0.64010788E-06_JPRB, &
  & 0.61699188E-06_JPRB, 0.59683947E-06_JPRB, 0.57835916E-06_JPRB, 0.55958020E-06_JPRB, 0.53924003E-06_JPRB, 0.51594202E-06_JPRB, &
  & 0.48932418E-06_JPRB, 0.45948346E-06_JPRB, 0.42716874E-06_JPRB, 0.39268730E-06_JPRB, 0.35656257E-06_JPRB, 0.31846241E-06_JPRB, &
  & 0.27911554E-06_JPRB, 0.23948732E-06_JPRB, 0.20372450E-06_JPRB, 0.17492526E-06_JPRB, 0.15456534E-06_JPRB, 0.14062203E-06_JPRB, &
  & 0.13080957E-06_JPRB, 0.12329772E-06_JPRB, 0.11695361E-06_JPRB, 0.11120094E-06_JPRB, 0.10577050E-06_JPRB, 0.10066210E-06_JPRB, &
  & 0.96179562E-07_JPRB, 0.92820919E-07_JPRB, 0.91106465E-07_JPRB, 0.91211312E-07_JPRB, 0.93104816E-07_JPRB, 0.96681646E-07_JPRB, &
  & 0.10170751E-06_JPRB, 0.10822942E-06_JPRB, 0.11599445E-06_JPRB, 0.12448547E-06_JPRB, 0.13445984E-06_JPRB, 0.14537248E-06_JPRB, &
  & 0.15757050E-06_JPRB, 0.17177494E-06_JPRB, 0.18923191E-06_JPRB, 0.21193222E-06_JPRB, 0.24277597E-06_JPRB, 0.28381646E-06_JPRB, &
  & 0.33573704E-06_JPRB, 0.39432132E-06_JPRB, 0.45458097E-06_JPRB, 0.51219104E-06_JPRB, 0.56565614E-06_JPRB, 0.61506807E-06_JPRB, &
  & 0.66082777E-06_JPRB, 0.70276661E-06_JPRB, 0.73931517E-06_JPRB, 0.76858686E-06_JPRB, 0.79059043E-06_JPRB, 0.80694912E-06_JPRB, &
  & 0.82008449E-06_JPRB, 0.83193464E-06_JPRB, 0.84526283E-06_JPRB, 0.86936041E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART12',0,ZHOOK_HANDLE)



RGHG7(:,46, 6) = (/ &
  & 0.70015159E-06_JPRB, 0.65945704E-06_JPRB, 0.63282005E-06_JPRB, 0.60678434E-06_JPRB, 0.57593002E-06_JPRB, 0.54900920E-06_JPRB, &
  & 0.52632811E-06_JPRB, 0.50822143E-06_JPRB, 0.49209234E-06_JPRB, 0.47662306E-06_JPRB, 0.45993104E-06_JPRB, 0.44112872E-06_JPRB, &
  & 0.41919469E-06_JPRB, 0.39449003E-06_JPRB, 0.36749964E-06_JPRB, 0.33914716E-06_JPRB, 0.30939367E-06_JPRB, 0.27856760E-06_JPRB, &
  & 0.24627826E-06_JPRB, 0.21428362E-06_JPRB, 0.18459235E-06_JPRB, 0.16074115E-06_JPRB, 0.14328127E-06_JPRB, 0.13119910E-06_JPRB, &
  & 0.12247037E-06_JPRB, 0.11559138E-06_JPRB, 0.10964020E-06_JPRB, 0.10415256E-06_JPRB, 0.98915557E-07_JPRB, 0.93954974E-07_JPRB, &
  & 0.89583594E-07_JPRB, 0.86301874E-07_JPRB, 0.84606000E-07_JPRB, 0.84626855E-07_JPRB, 0.86414154E-07_JPRB, 0.89760512E-07_JPRB, &
  & 0.94549264E-07_JPRB, 0.10073920E-06_JPRB, 0.10790819E-06_JPRB, 0.11578350E-06_JPRB, 0.12456425E-06_JPRB, 0.13397002E-06_JPRB, &
  & 0.14402490E-06_JPRB, 0.15518776E-06_JPRB, 0.16834542E-06_JPRB, 0.18516421E-06_JPRB, 0.20774381E-06_JPRB, 0.23918815E-06_JPRB, &
  & 0.28079251E-06_JPRB, 0.33155666E-06_JPRB, 0.38545363E-06_JPRB, 0.43830147E-06_JPRB, 0.48760558E-06_JPRB, 0.53294974E-06_JPRB, &
  & 0.57504320E-06_JPRB, 0.61371946E-06_JPRB, 0.64728374E-06_JPRB, 0.67406836E-06_JPRB, 0.69385629E-06_JPRB, 0.70854054E-06_JPRB, &
  & 0.72022402E-06_JPRB, 0.73098369E-06_JPRB, 0.74316097E-06_JPRB, 0.76597053E-06_JPRB /)

RGHG7(:,47, 6) = (/ &
  & 0.60441374E-06_JPRB, 0.56747274E-06_JPRB, 0.54468092E-06_JPRB, 0.51842596E-06_JPRB, 0.48981821E-06_JPRB, 0.46179224E-06_JPRB, &
  & 0.44069614E-06_JPRB, 0.42388876E-06_JPRB, 0.41024356E-06_JPRB, 0.39733135E-06_JPRB, 0.38412816E-06_JPRB, 0.36897012E-06_JPRB, &
  & 0.35138987E-06_JPRB, 0.33115336E-06_JPRB, 0.30923891E-06_JPRB, 0.28628051E-06_JPRB, 0.26296178E-06_JPRB, 0.23906239E-06_JPRB, &
  & 0.21479785E-06_JPRB, 0.19029839E-06_JPRB, 0.16738410E-06_JPRB, 0.14804381E-06_JPRB, 0.13358367E-06_JPRB, 0.12311554E-06_JPRB, &
  & 0.11530534E-06_JPRB, 0.10895681E-06_JPRB, 0.10334369E-06_JPRB, 0.98073933E-07_JPRB, 0.92994057E-07_JPRB, 0.88140048E-07_JPRB, &
  & 0.83840760E-07_JPRB, 0.80584165E-07_JPRB, 0.78840543E-07_JPRB, 0.78750084E-07_JPRB, 0.80400696E-07_JPRB, 0.83520234E-07_JPRB, &
  & 0.88168385E-07_JPRB, 0.94061640E-07_JPRB, 0.10082166E-06_JPRB, 0.10820334E-06_JPRB, 0.11612606E-06_JPRB, 0.12440505E-06_JPRB, &
  & 0.13285695E-06_JPRB, 0.14178811E-06_JPRB, 0.15182869E-06_JPRB, 0.16397317E-06_JPRB, 0.18014113E-06_JPRB, 0.20246144E-06_JPRB, &
  & 0.23368085E-06_JPRB, 0.27342764E-06_JPRB, 0.31954340E-06_JPRB, 0.36578354E-06_JPRB, 0.40987095E-06_JPRB, 0.45083146E-06_JPRB, &
  & 0.48894015E-06_JPRB, 0.52398906E-06_JPRB, 0.55481036E-06_JPRB, 0.57919505E-06_JPRB, 0.59716518E-06_JPRB, 0.61040390E-06_JPRB, &
  & 0.62101276E-06_JPRB, 0.63085264E-06_JPRB, 0.64223605E-06_JPRB, 0.66407341E-06_JPRB /)

RGHG7(:,48, 6) = (/ &
  & 0.51920915E-06_JPRB, 0.48324193E-06_JPRB, 0.45975455E-06_JPRB, 0.43459860E-06_JPRB, 0.40460793E-06_JPRB, 0.37758443E-06_JPRB, &
  & 0.35662768E-06_JPRB, 0.34178171E-06_JPRB, 0.33004437E-06_JPRB, 0.31985886E-06_JPRB, 0.30946649E-06_JPRB, 0.29795191E-06_JPRB, &
  & 0.28416272E-06_JPRB, 0.26829258E-06_JPRB, 0.25110177E-06_JPRB, 0.23377767E-06_JPRB, 0.21691129E-06_JPRB, 0.20061869E-06_JPRB, &
  & 0.18459919E-06_JPRB, 0.16815129E-06_JPRB, 0.15186980E-06_JPRB, 0.13704411E-06_JPRB, 0.12515483E-06_JPRB, 0.11612691E-06_JPRB, &
  & 0.10909557E-06_JPRB, 0.10320174E-06_JPRB, 0.97872608E-07_JPRB, 0.92794089E-07_JPRB, 0.87841208E-07_JPRB, 0.83076465E-07_JPRB, &
  & 0.78816683E-07_JPRB, 0.75551654E-07_JPRB, 0.73707490E-07_JPRB, 0.73507707E-07_JPRB, 0.74934540E-07_JPRB, 0.77927446E-07_JPRB, &
  & 0.82429118E-07_JPRB, 0.88052879E-07_JPRB, 0.94521219E-07_JPRB, 0.10149784E-06_JPRB, 0.10884436E-06_JPRB, 0.11623648E-06_JPRB, &
  & 0.12355822E-06_JPRB, 0.13087281E-06_JPRB, 0.13855987E-06_JPRB, 0.14744512E-06_JPRB, 0.15859192E-06_JPRB, 0.17378157E-06_JPRB, &
  & 0.19474120E-06_JPRB, 0.22328220E-06_JPRB, 0.25723514E-06_JPRB, 0.29488945E-06_JPRB, 0.33171756E-06_JPRB, 0.36729546E-06_JPRB, &
  & 0.40096612E-06_JPRB, 0.43276975E-06_JPRB, 0.46105274E-06_JPRB, 0.48369844E-06_JPRB, 0.50024499E-06_JPRB, 0.51244945E-06_JPRB, &
  & 0.52228194E-06_JPRB, 0.53148563E-06_JPRB, 0.54235130E-06_JPRB, 0.56359357E-06_JPRB /)

RGHG7(:,49, 6) = (/ &
  & 0.44037918E-06_JPRB, 0.40196676E-06_JPRB, 0.37737107E-06_JPRB, 0.35177118E-06_JPRB, 0.32207808E-06_JPRB, 0.29446772E-06_JPRB, &
  & 0.27500377E-06_JPRB, 0.26181851E-06_JPRB, 0.25239422E-06_JPRB, 0.24457589E-06_JPRB, 0.23715327E-06_JPRB, 0.22881127E-06_JPRB, &
  & 0.21898896E-06_JPRB, 0.20752317E-06_JPRB, 0.19550461E-06_JPRB, 0.18428418E-06_JPRB, 0.17441494E-06_JPRB, 0.16585378E-06_JPRB, &
  & 0.15743562E-06_JPRB, 0.14856826E-06_JPRB, 0.13805885E-06_JPRB, 0.12743141E-06_JPRB, 0.11785990E-06_JPRB, 0.11006120E-06_JPRB, &
  & 0.10368422E-06_JPRB, 0.98170268E-07_JPRB, 0.93089547E-07_JPRB, 0.88173543E-07_JPRB, 0.83334605E-07_JPRB, 0.78640760E-07_JPRB, &
  & 0.74408049E-07_JPRB, 0.71100800E-07_JPRB, 0.69152399E-07_JPRB, 0.68784068E-07_JPRB, 0.70009271E-07_JPRB, 0.72926888E-07_JPRB, &
  & 0.77192460E-07_JPRB, 0.82636504E-07_JPRB, 0.88842675E-07_JPRB, 0.95537395E-07_JPRB, 0.10241888E-06_JPRB, 0.10919825E-06_JPRB, &
  & 0.11565231E-06_JPRB, 0.12178542E-06_JPRB, 0.12784511E-06_JPRB, 0.13435427E-06_JPRB, 0.14204998E-06_JPRB, 0.15196372E-06_JPRB, &
  & 0.16530906E-06_JPRB, 0.18279043E-06_JPRB, 0.20502078E-06_JPRB, 0.22978033E-06_JPRB, 0.25704637E-06_JPRB, 0.28435065E-06_JPRB, &
  & 0.31227415E-06_JPRB, 0.34009332E-06_JPRB, 0.36621194E-06_JPRB, 0.38738045E-06_JPRB, 0.40310096E-06_JPRB, 0.41461152E-06_JPRB, &
  & 0.42398102E-06_JPRB, 0.43285971E-06_JPRB, 0.44352322E-06_JPRB, 0.46485096E-06_JPRB /)

RGHG7(:,50, 6) = (/ &
  & 0.35922591E-06_JPRB, 0.32234504E-06_JPRB, 0.30031410E-06_JPRB, 0.27498470E-06_JPRB, 0.24676058E-06_JPRB, 0.22122701E-06_JPRB, &
  & 0.20420366E-06_JPRB, 0.19370769E-06_JPRB, 0.18670517E-06_JPRB, 0.18140037E-06_JPRB, 0.17640225E-06_JPRB, 0.17122329E-06_JPRB, &
  & 0.16495993E-06_JPRB, 0.15796806E-06_JPRB, 0.15119963E-06_JPRB, 0.14562892E-06_JPRB, 0.14158084E-06_JPRB, 0.13848897E-06_JPRB, &
  & 0.13573010E-06_JPRB, 0.13182465E-06_JPRB, 0.12634810E-06_JPRB, 0.11900825E-06_JPRB, 0.11152832E-06_JPRB, 0.10476105E-06_JPRB, &
  & 0.98932524E-07_JPRB, 0.93735977E-07_JPRB, 0.88860936E-07_JPRB, 0.84095255E-07_JPRB, 0.79356887E-07_JPRB, 0.74730650E-07_JPRB, &
  & 0.70514929E-07_JPRB, 0.67157579E-07_JPRB, 0.65091953E-07_JPRB, 0.64526787E-07_JPRB, 0.65626146E-07_JPRB, 0.68365296E-07_JPRB, &
  & 0.72448302E-07_JPRB, 0.77697450E-07_JPRB, 0.83723698E-07_JPRB, 0.90147545E-07_JPRB, 0.96696446E-07_JPRB, 0.10302249E-06_JPRB, &
  & 0.10884684E-06_JPRB, 0.11405084E-06_JPRB, 0.11896121E-06_JPRB, 0.12383894E-06_JPRB, 0.12931649E-06_JPRB, 0.13578955E-06_JPRB, &
  & 0.14399473E-06_JPRB, 0.15422749E-06_JPRB, 0.16642868E-06_JPRB, 0.18090104E-06_JPRB, 0.19639990E-06_JPRB, 0.21391423E-06_JPRB, &
  & 0.23292915E-06_JPRB, 0.25371870E-06_JPRB, 0.27516785E-06_JPRB, 0.29376511E-06_JPRB, 0.30771088E-06_JPRB, 0.31842518E-06_JPRB, &
  & 0.32709551E-06_JPRB, 0.33580534E-06_JPRB, 0.34640041E-06_JPRB, 0.36870057E-06_JPRB /)

RGHG7(:,51, 6) = (/ &
  & 0.28967878E-06_JPRB, 0.25627210E-06_JPRB, 0.23410161E-06_JPRB, 0.21330338E-06_JPRB, 0.18834314E-06_JPRB, 0.16787106E-06_JPRB, &
  & 0.15500511E-06_JPRB, 0.14781439E-06_JPRB, 0.14325566E-06_JPRB, 0.13982859E-06_JPRB, 0.13695129E-06_JPRB, 0.13377762E-06_JPRB, &
  & 0.13034500E-06_JPRB, 0.12659387E-06_JPRB, 0.12340955E-06_JPRB, 0.12129502E-06_JPRB, 0.12023041E-06_JPRB, 0.11985276E-06_JPRB, &
  & 0.11951748E-06_JPRB, 0.11865159E-06_JPRB, 0.11613291E-06_JPRB, 0.11173786E-06_JPRB, 0.10595435E-06_JPRB, 0.10009772E-06_JPRB, &
  & 0.94713648E-07_JPRB, 0.89773735E-07_JPRB, 0.85071726E-07_JPRB, 0.80439030E-07_JPRB, 0.75798930E-07_JPRB, 0.71246120E-07_JPRB, &
  & 0.67044269E-07_JPRB, 0.63658732E-07_JPRB, 0.61438044E-07_JPRB, 0.60735786E-07_JPRB, 0.61665105E-07_JPRB, 0.64209516E-07_JPRB, &
  & 0.68114851E-07_JPRB, 0.73239306E-07_JPRB, 0.79039573E-07_JPRB, 0.85236017E-07_JPRB, 0.91549360E-07_JPRB, 0.97502515E-07_JPRB, &
  & 0.10278221E-06_JPRB, 0.10738714E-06_JPRB, 0.11134686E-06_JPRB, 0.11525361E-06_JPRB, 0.11921600E-06_JPRB, 0.12377006E-06_JPRB, &
  & 0.12895235E-06_JPRB, 0.13501948E-06_JPRB, 0.14191059E-06_JPRB, 0.14931672E-06_JPRB, 0.15766739E-06_JPRB, 0.16645050E-06_JPRB, &
  & 0.17645468E-06_JPRB, 0.18863987E-06_JPRB, 0.20167741E-06_JPRB, 0.21406633E-06_JPRB, 0.22434148E-06_JPRB, 0.23209303E-06_JPRB, &
  & 0.23933964E-06_JPRB, 0.24660497E-06_JPRB, 0.25679412E-06_JPRB, 0.27859042E-06_JPRB /)

RGHG7(:,52, 6) = (/ &
  & 0.22850126E-06_JPRB, 0.20049197E-06_JPRB, 0.18494940E-06_JPRB, 0.16764409E-06_JPRB, 0.14951306E-06_JPRB, 0.13433252E-06_JPRB, &
  & 0.12586854E-06_JPRB, 0.12116656E-06_JPRB, 0.11833406E-06_JPRB, 0.11631571E-06_JPRB, 0.11446458E-06_JPRB, 0.11275035E-06_JPRB, &
  & 0.11073333E-06_JPRB, 0.10882560E-06_JPRB, 0.10742381E-06_JPRB, 0.10686525E-06_JPRB, 0.10697151E-06_JPRB, 0.10747163E-06_JPRB, &
  & 0.10800943E-06_JPRB, 0.10829880E-06_JPRB, 0.10761008E-06_JPRB, 0.10517966E-06_JPRB, 0.10099923E-06_JPRB, 0.95932961E-07_JPRB, &
  & 0.90918149E-07_JPRB, 0.86180080E-07_JPRB, 0.81619937E-07_JPRB, 0.77106002E-07_JPRB, 0.72574991E-07_JPRB, 0.68086059E-07_JPRB, &
  & 0.63949123E-07_JPRB, 0.60491459E-07_JPRB, 0.58188622E-07_JPRB, 0.57332823E-07_JPRB, 0.58061101E-07_JPRB, 0.60423901E-07_JPRB, &
  & 0.64202297E-07_JPRB, 0.69137549E-07_JPRB, 0.74741507E-07_JPRB, 0.80777951E-07_JPRB, 0.86829743E-07_JPRB, 0.92463829E-07_JPRB, &
  & 0.97359624E-07_JPRB, 0.10135113E-06_JPRB, 0.10481480E-06_JPRB, 0.10790283E-06_JPRB, 0.11112880E-06_JPRB, 0.11443753E-06_JPRB, &
  & 0.11813101E-06_JPRB, 0.12203392E-06_JPRB, 0.12612389E-06_JPRB, 0.13043837E-06_JPRB, 0.13460058E-06_JPRB, 0.13898085E-06_JPRB, &
  & 0.14395580E-06_JPRB, 0.14941247E-06_JPRB, 0.15589220E-06_JPRB, 0.16228313E-06_JPRB, 0.16723540E-06_JPRB, 0.17190426E-06_JPRB, &
  & 0.17585729E-06_JPRB, 0.18082496E-06_JPRB, 0.18773662E-06_JPRB, 0.20594528E-06_JPRB /)

RGHG7(:,53, 6) = (/ &
  & 0.18223142E-06_JPRB, 0.16153764E-06_JPRB, 0.14906668E-06_JPRB, 0.13729874E-06_JPRB, 0.12404243E-06_JPRB, 0.11397172E-06_JPRB, &
  & 0.10830244E-06_JPRB, 0.10540223E-06_JPRB, 0.10364139E-06_JPRB, 0.10235848E-06_JPRB, 0.10133194E-06_JPRB, 0.10021004E-06_JPRB, &
  & 0.99138326E-07_JPRB, 0.98125525E-07_JPRB, 0.97597486E-07_JPRB, 0.97662017E-07_JPRB, 0.98154224E-07_JPRB, 0.98856894E-07_JPRB, &
  & 0.99649547E-07_JPRB, 0.10024394E-06_JPRB, 0.10044208E-06_JPRB, 0.99314697E-07_JPRB, 0.96427407E-07_JPRB, 0.92132673E-07_JPRB, &
  & 0.87446189E-07_JPRB, 0.82870152E-07_JPRB, 0.78429366E-07_JPRB, 0.74020981E-07_JPRB, 0.69604724E-07_JPRB, 0.65213754E-07_JPRB, &
  & 0.61117113E-07_JPRB, 0.57646677E-07_JPRB, 0.55286147E-07_JPRB, 0.54247042E-07_JPRB, 0.54803213E-07_JPRB, 0.56995514E-07_JPRB, &
  & 0.60609587E-07_JPRB, 0.65352737E-07_JPRB, 0.70830659E-07_JPRB, 0.76656995E-07_JPRB, 0.82489350E-07_JPRB, 0.87852683E-07_JPRB, &
  & 0.92308902E-07_JPRB, 0.95942319E-07_JPRB, 0.98886922E-07_JPRB, 0.10162329E-06_JPRB, 0.10424280E-06_JPRB, 0.10704648E-06_JPRB, &
  & 0.10984843E-06_JPRB, 0.11273595E-06_JPRB, 0.11556907E-06_JPRB, 0.11817023E-06_JPRB, 0.12065850E-06_JPRB, 0.12308477E-06_JPRB, &
  & 0.12558111E-06_JPRB, 0.12852020E-06_JPRB, 0.13168392E-06_JPRB, 0.13466085E-06_JPRB, 0.13728130E-06_JPRB, 0.13926282E-06_JPRB, &
  & 0.14131555E-06_JPRB, 0.14362486E-06_JPRB, 0.14725323E-06_JPRB, 0.15824529E-06_JPRB /)

RGHG7(:,54, 6) = (/ &
  & 0.14762416E-06_JPRB, 0.13261153E-06_JPRB, 0.12446095E-06_JPRB, 0.11625872E-06_JPRB, 0.10750851E-06_JPRB, 0.10080601E-06_JPRB, &
  & 0.97242371E-07_JPRB, 0.95368364E-07_JPRB, 0.94252414E-07_JPRB, 0.93469914E-07_JPRB, 0.92777988E-07_JPRB, 0.92172762E-07_JPRB, &
  & 0.91487834E-07_JPRB, 0.90985225E-07_JPRB, 0.90852701E-07_JPRB, 0.91155250E-07_JPRB, 0.91714554E-07_JPRB, 0.92452176E-07_JPRB, &
  & 0.93184013E-07_JPRB, 0.93911964E-07_JPRB, 0.94346341E-07_JPRB, 0.94066692E-07_JPRB, 0.92136709E-07_JPRB, 0.88558252E-07_JPRB, &
  & 0.84195570E-07_JPRB, 0.79773287E-07_JPRB, 0.75437825E-07_JPRB, 0.71141507E-07_JPRB, 0.66814039E-07_JPRB, 0.62564048E-07_JPRB, &
  & 0.58493914E-07_JPRB, 0.55105239E-07_JPRB, 0.52644037E-07_JPRB, 0.51470639E-07_JPRB, 0.51855842E-07_JPRB, 0.53866597E-07_JPRB, &
  & 0.57297257E-07_JPRB, 0.61887697E-07_JPRB, 0.67192161E-07_JPRB, 0.72871757E-07_JPRB, 0.78480738E-07_JPRB, 0.83501973E-07_JPRB, &
  & 0.87648658E-07_JPRB, 0.90895476E-07_JPRB, 0.93563791E-07_JPRB, 0.95948593E-07_JPRB, 0.98349872E-07_JPRB, 0.10076101E-06_JPRB, &
  & 0.10327120E-06_JPRB, 0.10565265E-06_JPRB, 0.10783229E-06_JPRB, 0.10985543E-06_JPRB, 0.11154673E-06_JPRB, 0.11315789E-06_JPRB, &
  & 0.11477130E-06_JPRB, 0.11640083E-06_JPRB, 0.11826992E-06_JPRB, 0.12003260E-06_JPRB, 0.12130317E-06_JPRB, 0.12248415E-06_JPRB, &
  & 0.12339763E-06_JPRB, 0.12440566E-06_JPRB, 0.12564909E-06_JPRB, 0.12893210E-06_JPRB /)

RGHG7(:,55, 6) = (/ &
  & 0.12250496E-06_JPRB, 0.11256856E-06_JPRB, 0.10739765E-06_JPRB, 0.10188386E-06_JPRB, 0.96260138E-07_JPRB, 0.91949900E-07_JPRB, &
  & 0.89581597E-07_JPRB, 0.88371856E-07_JPRB, 0.87655408E-07_JPRB, 0.87134907E-07_JPRB, 0.86718835E-07_JPRB, 0.86300140E-07_JPRB, &
  & 0.85938424E-07_JPRB, 0.85672212E-07_JPRB, 0.85712024E-07_JPRB, 0.86063132E-07_JPRB, 0.86644278E-07_JPRB, 0.87245290E-07_JPRB, &
  & 0.88006985E-07_JPRB, 0.88649756E-07_JPRB, 0.89255494E-07_JPRB, 0.89278259E-07_JPRB, 0.88079013E-07_JPRB, 0.85108312E-07_JPRB, &
  & 0.81075299E-07_JPRB, 0.76822040E-07_JPRB, 0.72602916E-07_JPRB, 0.68408539E-07_JPRB, 0.64206752E-07_JPRB, 0.60018721E-07_JPRB, &
  & 0.56118843E-07_JPRB, 0.52736418E-07_JPRB, 0.50244072E-07_JPRB, 0.48968239E-07_JPRB, 0.49182788E-07_JPRB, 0.50992693E-07_JPRB, &
  & 0.54261204E-07_JPRB, 0.58660525E-07_JPRB, 0.63859041E-07_JPRB, 0.69344530E-07_JPRB, 0.74702953E-07_JPRB, 0.79436923E-07_JPRB, &
  & 0.83254051E-07_JPRB, 0.86212872E-07_JPRB, 0.88631815E-07_JPRB, 0.90829268E-07_JPRB, 0.93028341E-07_JPRB, 0.95341605E-07_JPRB, &
  & 0.97645710E-07_JPRB, 0.99866881E-07_JPRB, 0.10189093E-06_JPRB, 0.10353197E-06_JPRB, 0.10498471E-06_JPRB, 0.10625913E-06_JPRB, &
  & 0.10742174E-06_JPRB, 0.10875016E-06_JPRB, 0.11008773E-06_JPRB, 0.11124856E-06_JPRB, 0.11219272E-06_JPRB, 0.11288617E-06_JPRB, &
  & 0.11346938E-06_JPRB, 0.11413528E-06_JPRB, 0.11473358E-06_JPRB, 0.11532512E-06_JPRB /)

RGHG7(:,56, 6) = (/ &
  & 0.10632223E-06_JPRB, 0.99047220E-07_JPRB, 0.95181385E-07_JPRB, 0.91908213E-07_JPRB, 0.88206768E-07_JPRB, 0.85465388E-07_JPRB, &
  & 0.83947313E-07_JPRB, 0.83135653E-07_JPRB, 0.82646828E-07_JPRB, 0.82309192E-07_JPRB, 0.82018524E-07_JPRB, 0.81762863E-07_JPRB, &
  & 0.81515125E-07_JPRB, 0.81379703E-07_JPRB, 0.81482753E-07_JPRB, 0.81806029E-07_JPRB, 0.82309711E-07_JPRB, 0.82911022E-07_JPRB, &
  & 0.83521002E-07_JPRB, 0.84212573E-07_JPRB, 0.84772282E-07_JPRB, 0.85055845E-07_JPRB, 0.84190930E-07_JPRB, 0.81705060E-07_JPRB, &
  & 0.78017159E-07_JPRB, 0.73954084E-07_JPRB, 0.69862971E-07_JPRB, 0.65775616E-07_JPRB, 0.61693626E-07_JPRB, 0.57649970E-07_JPRB, &
  & 0.53829034E-07_JPRB, 0.50528744E-07_JPRB, 0.48052446E-07_JPRB, 0.46700240E-07_JPRB, 0.46752401E-07_JPRB, 0.48367614E-07_JPRB, &
  & 0.51443504E-07_JPRB, 0.55706284E-07_JPRB, 0.60723728E-07_JPRB, 0.66036748E-07_JPRB, 0.71145649E-07_JPRB, 0.75567016E-07_JPRB, &
  & 0.79099614E-07_JPRB, 0.81838785E-07_JPRB, 0.84053930E-07_JPRB, 0.86099917E-07_JPRB, 0.88191378E-07_JPRB, 0.90397030E-07_JPRB, &
  & 0.92689142E-07_JPRB, 0.94887049E-07_JPRB, 0.96810645E-07_JPRB, 0.98488400E-07_JPRB, 0.99822067E-07_JPRB, 0.10097020E-06_JPRB, &
  & 0.10211603E-06_JPRB, 0.10324482E-06_JPRB, 0.10438090E-06_JPRB, 0.10537514E-06_JPRB, 0.10610871E-06_JPRB, 0.10672355E-06_JPRB, &
  & 0.10723500E-06_JPRB, 0.10787615E-06_JPRB, 0.10872370E-06_JPRB, 0.11105054E-06_JPRB /)

RGHG7(:,57, 6) = (/ &
  & 0.92328499E-07_JPRB, 0.88633101E-07_JPRB, 0.86816634E-07_JPRB, 0.84479758E-07_JPRB, 0.82318365E-07_JPRB, 0.80533987E-07_JPRB, &
  & 0.79502691E-07_JPRB, 0.78948162E-07_JPRB, 0.78606021E-07_JPRB, 0.78347099E-07_JPRB, 0.78148339E-07_JPRB, 0.77953146E-07_JPRB, &
  & 0.77795953E-07_JPRB, 0.77696740E-07_JPRB, 0.77785323E-07_JPRB, 0.78064417E-07_JPRB, 0.78507504E-07_JPRB, 0.79018811E-07_JPRB, &
  & 0.79643236E-07_JPRB, 0.80266489E-07_JPRB, 0.80864616E-07_JPRB, 0.81154283E-07_JPRB, 0.80539287E-07_JPRB, 0.78351675E-07_JPRB, &
  & 0.74955992E-07_JPRB, 0.71115039E-07_JPRB, 0.67170241E-07_JPRB, 0.63205746E-07_JPRB, 0.59220973E-07_JPRB, 0.55306487E-07_JPRB, &
  & 0.51639297E-07_JPRB, 0.48450506E-07_JPRB, 0.46023015E-07_JPRB, 0.44622613E-07_JPRB, 0.44539334E-07_JPRB, 0.45969117E-07_JPRB, &
  & 0.48862418E-07_JPRB, 0.52944788E-07_JPRB, 0.57798026E-07_JPRB, 0.62902771E-07_JPRB, 0.67743585E-07_JPRB, 0.71900523E-07_JPRB, &
  & 0.75180900E-07_JPRB, 0.77716585E-07_JPRB, 0.79802774E-07_JPRB, 0.81724714E-07_JPRB, 0.83716024E-07_JPRB, 0.85860485E-07_JPRB, &
  & 0.88108031E-07_JPRB, 0.90334957E-07_JPRB, 0.92373064E-07_JPRB, 0.94046023E-07_JPRB, 0.95452236E-07_JPRB, 0.96676615E-07_JPRB, &
  & 0.97794484E-07_JPRB, 0.98944511E-07_JPRB, 0.10001132E-06_JPRB, 0.10094008E-06_JPRB, 0.10163673E-06_JPRB, 0.10212317E-06_JPRB, &
  & 0.10260406E-06_JPRB, 0.10307418E-06_JPRB, 0.10356025E-06_JPRB, 0.10481229E-06_JPRB /)

RGHG7(:,58, 6) = (/ &
  & 0.86005095E-07_JPRB, 0.82371869E-07_JPRB, 0.80489620E-07_JPRB, 0.79153189E-07_JPRB, 0.77651642E-07_JPRB, 0.76521779E-07_JPRB, &
  & 0.75822491E-07_JPRB, 0.75426108E-07_JPRB, 0.75172345E-07_JPRB, 0.74978210E-07_JPRB, 0.74806238E-07_JPRB, 0.74648931E-07_JPRB, &
  & 0.74505884E-07_JPRB, 0.74414800E-07_JPRB, 0.74454178E-07_JPRB, 0.74663490E-07_JPRB, 0.75032283E-07_JPRB, 0.75538736E-07_JPRB, &
  & 0.76089769E-07_JPRB, 0.76742936E-07_JPRB, 0.77315839E-07_JPRB, 0.77640379E-07_JPRB, 0.77044653E-07_JPRB, 0.75035139E-07_JPRB, &
  & 0.71903543E-07_JPRB, 0.68269856E-07_JPRB, 0.64483025E-07_JPRB, 0.60637326E-07_JPRB, 0.56794160E-07_JPRB, 0.53046357E-07_JPRB, &
  & 0.49511666E-07_JPRB, 0.46465704E-07_JPRB, 0.44120384E-07_JPRB, 0.42709271E-07_JPRB, 0.42523936E-07_JPRB, 0.43790557E-07_JPRB, &
  & 0.46491621E-07_JPRB, 0.50396164E-07_JPRB, 0.55038100E-07_JPRB, 0.59915642E-07_JPRB, 0.64509749E-07_JPRB, 0.68388900E-07_JPRB, &
  & 0.71455069E-07_JPRB, 0.73854750E-07_JPRB, 0.75821845E-07_JPRB, 0.77668140E-07_JPRB, 0.79576402E-07_JPRB, 0.81643570E-07_JPRB, &
  & 0.83849599E-07_JPRB, 0.86078551E-07_JPRB, 0.88185601E-07_JPRB, 0.90014161E-07_JPRB, 0.91551144E-07_JPRB, 0.92857348E-07_JPRB, &
  & 0.94118064E-07_JPRB, 0.95315336E-07_JPRB, 0.96479404E-07_JPRB, 0.97435951E-07_JPRB, 0.98074693E-07_JPRB, 0.98653636E-07_JPRB, &
  & 0.99148423E-07_JPRB, 0.99658386E-07_JPRB, 0.10042208E-06_JPRB, 0.10196121E-06_JPRB /)

RGHG7(:,59, 6) = (/ &
  & 0.78888462E-07_JPRB, 0.76710371E-07_JPRB, 0.75835466E-07_JPRB, 0.74843150E-07_JPRB, 0.73938963E-07_JPRB, 0.73165552E-07_JPRB, &
  & 0.72675988E-07_JPRB, 0.72363839E-07_JPRB, 0.72152964E-07_JPRB, 0.71975641E-07_JPRB, 0.71825355E-07_JPRB, 0.71667394E-07_JPRB, &
  & 0.71523338E-07_JPRB, 0.71404415E-07_JPRB, 0.71386282E-07_JPRB, 0.71520986E-07_JPRB, 0.71830613E-07_JPRB, 0.72288373E-07_JPRB, &
  & 0.72872808E-07_JPRB, 0.73503521E-07_JPRB, 0.74086486E-07_JPRB, 0.74338921E-07_JPRB, 0.73733865E-07_JPRB, 0.71820516E-07_JPRB, &
  & 0.68870975E-07_JPRB, 0.65426256E-07_JPRB, 0.61784213E-07_JPRB, 0.58082179E-07_JPRB, 0.54391990E-07_JPRB, 0.50783978E-07_JPRB, &
  & 0.47457373E-07_JPRB, 0.44573909E-07_JPRB, 0.42337131E-07_JPRB, 0.40952472E-07_JPRB, 0.40700133E-07_JPRB, 0.41826418E-07_JPRB, &
  & 0.44346024E-07_JPRB, 0.48037379E-07_JPRB, 0.52460535E-07_JPRB, 0.57097157E-07_JPRB, 0.61402368E-07_JPRB, 0.65055460E-07_JPRB, &
  & 0.67948520E-07_JPRB, 0.70210270E-07_JPRB, 0.72117516E-07_JPRB, 0.73891911E-07_JPRB, 0.75749760E-07_JPRB, 0.77743827E-07_JPRB, &
  & 0.79884927E-07_JPRB, 0.82080255E-07_JPRB, 0.84216708E-07_JPRB, 0.86179554E-07_JPRB, 0.87836362E-07_JPRB, 0.89346045E-07_JPRB, &
  & 0.90738361E-07_JPRB, 0.92130570E-07_JPRB, 0.93413881E-07_JPRB, 0.94395837E-07_JPRB, 0.95145076E-07_JPRB, 0.95717944E-07_JPRB, &
  & 0.96197269E-07_JPRB, 0.96707630E-07_JPRB, 0.97323401E-07_JPRB, 0.98799539E-07_JPRB /)

RGHG7(:,60, 6) = (/ &
  & 0.75080266E-07_JPRB, 0.73057763E-07_JPRB, 0.72069810E-07_JPRB, 0.71416991E-07_JPRB, 0.70768301E-07_JPRB, 0.70230477E-07_JPRB, &
  & 0.69855098E-07_JPRB, 0.69614039E-07_JPRB, 0.69424388E-07_JPRB, 0.69259038E-07_JPRB, 0.69093403E-07_JPRB, 0.68931975E-07_JPRB, &
  & 0.68755810E-07_JPRB, 0.68606944E-07_JPRB, 0.68517551E-07_JPRB, 0.68577108E-07_JPRB, 0.68831014E-07_JPRB, 0.69274982E-07_JPRB, &
  & 0.69857990E-07_JPRB, 0.70510794E-07_JPRB, 0.71075107E-07_JPRB, 0.71269064E-07_JPRB, 0.70586580E-07_JPRB, 0.68710357E-07_JPRB, &
  & 0.65911550E-07_JPRB, 0.62619122E-07_JPRB, 0.59121678E-07_JPRB, 0.55545446E-07_JPRB, 0.52024795E-07_JPRB, 0.48597613E-07_JPRB, &
  & 0.45468624E-07_JPRB, 0.42785416E-07_JPRB, 0.40688516E-07_JPRB, 0.39356191E-07_JPRB, 0.39068745E-07_JPRB, 0.40079801E-07_JPRB, &
  & 0.42421757E-07_JPRB, 0.45891309E-07_JPRB, 0.50069087E-07_JPRB, 0.54414969E-07_JPRB, 0.58477557E-07_JPRB, 0.61898923E-07_JPRB, &
  & 0.64623293E-07_JPRB, 0.66815268E-07_JPRB, 0.68642748E-07_JPRB, 0.70390563E-07_JPRB, 0.72191845E-07_JPRB, 0.74140864E-07_JPRB, &
  & 0.76220779E-07_JPRB, 0.78353182E-07_JPRB, 0.80474422E-07_JPRB, 0.82462989E-07_JPRB, 0.84296786E-07_JPRB, 0.85939327E-07_JPRB, &
  & 0.87546297E-07_JPRB, 0.89147186E-07_JPRB, 0.90608744E-07_JPRB, 0.91770225E-07_JPRB, 0.92586042E-07_JPRB, 0.93240146E-07_JPRB, &
  & 0.93808225E-07_JPRB, 0.94389684E-07_JPRB, 0.95147172E-07_JPRB, 0.96527522E-07_JPRB /)

RGHG7(:,61, 6) = (/ &
  & 0.71118791E-07_JPRB, 0.69539254E-07_JPRB, 0.68974899E-07_JPRB, 0.68480460E-07_JPRB, 0.68017727E-07_JPRB, 0.67618728E-07_JPRB, &
  & 0.67319782E-07_JPRB, 0.67090802E-07_JPRB, 0.66909685E-07_JPRB, 0.66732795E-07_JPRB, 0.66560034E-07_JPRB, 0.66366347E-07_JPRB, &
  & 0.66165235E-07_JPRB, 0.65949273E-07_JPRB, 0.65806276E-07_JPRB, 0.65801828E-07_JPRB, 0.66007146E-07_JPRB, 0.66438020E-07_JPRB, &
  & 0.67042620E-07_JPRB, 0.67704839E-07_JPRB, 0.68245122E-07_JPRB, 0.68345031E-07_JPRB, 0.67600510E-07_JPRB, 0.65768539E-07_JPRB, &
  & 0.63064874E-07_JPRB, 0.59897467E-07_JPRB, 0.56518150E-07_JPRB, 0.53097672E-07_JPRB, 0.49722992E-07_JPRB, 0.46500986E-07_JPRB, &
  & 0.43590354E-07_JPRB, 0.41120725E-07_JPRB, 0.39188993E-07_JPRB, 0.37934861E-07_JPRB, 0.37638525E-07_JPRB, 0.38556692E-07_JPRB, &
  & 0.40730189E-07_JPRB, 0.43976087E-07_JPRB, 0.47872398E-07_JPRB, 0.51949350E-07_JPRB, 0.55726275E-07_JPRB, 0.58939154E-07_JPRB, &
  & 0.61541776E-07_JPRB, 0.63629301E-07_JPRB, 0.65437511E-07_JPRB, 0.67133847E-07_JPRB, 0.68905862E-07_JPRB, 0.70804738E-07_JPRB, &
  & 0.72833799E-07_JPRB, 0.74916535E-07_JPRB, 0.76973357E-07_JPRB, 0.78985117E-07_JPRB, 0.80850590E-07_JPRB, 0.82639772E-07_JPRB, &
  & 0.84406359E-07_JPRB, 0.86208019E-07_JPRB, 0.87965830E-07_JPRB, 0.89283212E-07_JPRB, 0.90255369E-07_JPRB, 0.91005965E-07_JPRB, &
  & 0.91644516E-07_JPRB, 0.92299551E-07_JPRB, 0.93072295E-07_JPRB, 0.94611622E-07_JPRB /)

RGHG7(:,62, 6) = (/ &
  & 0.68283697E-07_JPRB, 0.66916137E-07_JPRB, 0.66314854E-07_JPRB, 0.65911124E-07_JPRB, 0.65551269E-07_JPRB, 0.65218146E-07_JPRB, &
  & 0.64955287E-07_JPRB, 0.64747582E-07_JPRB, 0.64554321E-07_JPRB, 0.64367541E-07_JPRB, 0.64160879E-07_JPRB, 0.63945308E-07_JPRB, &
  & 0.63684325E-07_JPRB, 0.63427755E-07_JPRB, 0.63217989E-07_JPRB, 0.63156961E-07_JPRB, 0.63331200E-07_JPRB, 0.63761178E-07_JPRB, &
  & 0.64377993E-07_JPRB, 0.65043672E-07_JPRB, 0.65550374E-07_JPRB, 0.65591465E-07_JPRB, 0.64794428E-07_JPRB, 0.62973484E-07_JPRB, &
  & 0.60359653E-07_JPRB, 0.57289039E-07_JPRB, 0.54039109E-07_JPRB, 0.50738244E-07_JPRB, 0.47534108E-07_JPRB, 0.44516280E-07_JPRB, &
  & 0.41852836E-07_JPRB, 0.39615099E-07_JPRB, 0.37868006E-07_JPRB, 0.36710404E-07_JPRB, 0.36426545E-07_JPRB, 0.37266801E-07_JPRB, &
  & 0.39281847E-07_JPRB, 0.42296158E-07_JPRB, 0.45918565E-07_JPRB, 0.49684253E-07_JPRB, 0.53201763E-07_JPRB, 0.56214091E-07_JPRB, &
  & 0.58667343E-07_JPRB, 0.60716239E-07_JPRB, 0.62464522E-07_JPRB, 0.64145546E-07_JPRB, 0.65875433E-07_JPRB, 0.67726177E-07_JPRB, &
  & 0.69713721E-07_JPRB, 0.71732970E-07_JPRB, 0.73758990E-07_JPRB, 0.75735187E-07_JPRB, 0.77622218E-07_JPRB, 0.79475015E-07_JPRB, &
  & 0.81330064E-07_JPRB, 0.83331123E-07_JPRB, 0.85321076E-07_JPRB, 0.86890971E-07_JPRB, 0.88039890E-07_JPRB, 0.88932616E-07_JPRB, &
  & 0.89710682E-07_JPRB, 0.90473605E-07_JPRB, 0.91400281E-07_JPRB, 0.93032355E-07_JPRB /)

RGHG7(:,63, 6) = (/ &
  & 0.65681142E-07_JPRB, 0.64402236E-07_JPRB, 0.63944483E-07_JPRB, 0.63606564E-07_JPRB, 0.63289711E-07_JPRB, 0.63007107E-07_JPRB, &
  & 0.62756349E-07_JPRB, 0.62537232E-07_JPRB, 0.62334642E-07_JPRB, 0.62118417E-07_JPRB, 0.61887633E-07_JPRB, 0.61611779E-07_JPRB, &
  & 0.61309613E-07_JPRB, 0.60982131E-07_JPRB, 0.60718037E-07_JPRB, 0.60625297E-07_JPRB, 0.60789795E-07_JPRB, 0.61226849E-07_JPRB, &
  & 0.61848390E-07_JPRB, 0.62510928E-07_JPRB, 0.62993699E-07_JPRB, 0.62984050E-07_JPRB, 0.62144935E-07_JPRB, 0.60353813E-07_JPRB, &
  & 0.57802737E-07_JPRB, 0.54831194E-07_JPRB, 0.51685554E-07_JPRB, 0.48540581E-07_JPRB, 0.45494534E-07_JPRB, 0.42703647E-07_JPRB, &
  & 0.40293937E-07_JPRB, 0.38312503E-07_JPRB, 0.36761872E-07_JPRB, 0.35721047E-07_JPRB, 0.35465934E-07_JPRB, 0.36244526E-07_JPRB, &
  & 0.38104218E-07_JPRB, 0.40890072E-07_JPRB, 0.44214264E-07_JPRB, 0.47685834E-07_JPRB, 0.50925593E-07_JPRB, 0.53738226E-07_JPRB, &
  & 0.56091775E-07_JPRB, 0.58054766E-07_JPRB, 0.59785386E-07_JPRB, 0.61428373E-07_JPRB, 0.63116069E-07_JPRB, 0.64925075E-07_JPRB, &
  & 0.66850689E-07_JPRB, 0.68827077E-07_JPRB, 0.70798194E-07_JPRB, 0.72735148E-07_JPRB, 0.74622285E-07_JPRB, 0.76478905E-07_JPRB, &
  & 0.78413059E-07_JPRB, 0.80489528E-07_JPRB, 0.82728526E-07_JPRB, 0.84490900E-07_JPRB, 0.85843482E-07_JPRB, 0.86895909E-07_JPRB, &
  & 0.87797133E-07_JPRB, 0.88676892E-07_JPRB, 0.89736226E-07_JPRB, 0.91619050E-07_JPRB /)

RGHG7(:,64, 6) = (/ &
  & 0.63484414E-07_JPRB, 0.62301574E-07_JPRB, 0.61818739E-07_JPRB, 0.61489892E-07_JPRB, 0.61205206E-07_JPRB, 0.60928095E-07_JPRB, &
  & 0.60682659E-07_JPRB, 0.60454916E-07_JPRB, 0.60226647E-07_JPRB, 0.59985076E-07_JPRB, 0.59710594E-07_JPRB, 0.59389183E-07_JPRB, &
  & 0.59010201E-07_JPRB, 0.58625105E-07_JPRB, 0.58324481E-07_JPRB, 0.58225321E-07_JPRB, 0.58395418E-07_JPRB, 0.58839113E-07_JPRB, &
  & 0.59462089E-07_JPRB, 0.60120186E-07_JPRB, 0.60573370E-07_JPRB, 0.60529487E-07_JPRB, 0.59677532E-07_JPRB, 0.57893594E-07_JPRB, &
  & 0.55425001E-07_JPRB, 0.52544941E-07_JPRB, 0.49522448E-07_JPRB, 0.46533174E-07_JPRB, 0.43708113E-07_JPRB, 0.41150511E-07_JPRB, &
  & 0.39006459E-07_JPRB, 0.37273963E-07_JPRB, 0.35922767E-07_JPRB, 0.35005769E-07_JPRB, 0.34793192E-07_JPRB, 0.35521474E-07_JPRB, &
  & 0.37236831E-07_JPRB, 0.39786492E-07_JPRB, 0.42824269E-07_JPRB, 0.45989022E-07_JPRB, 0.48963607E-07_JPRB, 0.51588060E-07_JPRB, &
  & 0.53814929E-07_JPRB, 0.55726652E-07_JPRB, 0.57409530E-07_JPRB, 0.59026871E-07_JPRB, 0.60666899E-07_JPRB, 0.62427098E-07_JPRB, &
  & 0.64286738E-07_JPRB, 0.66215335E-07_JPRB, 0.68115156E-07_JPRB, 0.70037174E-07_JPRB, 0.71882511E-07_JPRB, 0.73785181E-07_JPRB, &
  & 0.75664609E-07_JPRB, 0.77851460E-07_JPRB, 0.80205403E-07_JPRB, 0.82142748E-07_JPRB, 0.83671580E-07_JPRB, 0.84879652E-07_JPRB, &
  & 0.85904752E-07_JPRB, 0.86885244E-07_JPRB, 0.88087333E-07_JPRB, 0.90122242E-07_JPRB /)

RGHG7(:,65, 6) = (/ &
  & 0.61520630E-07_JPRB, 0.60317412E-07_JPRB, 0.59856596E-07_JPRB, 0.59536173E-07_JPRB, 0.59247018E-07_JPRB, 0.58979960E-07_JPRB, &
  & 0.58723820E-07_JPRB, 0.58477958E-07_JPRB, 0.58229030E-07_JPRB, 0.57946146E-07_JPRB, 0.57625645E-07_JPRB, 0.57232281E-07_JPRB, &
  & 0.56794150E-07_JPRB, 0.56363938E-07_JPRB, 0.56049537E-07_JPRB, 0.55965234E-07_JPRB, 0.56153837E-07_JPRB, 0.56600811E-07_JPRB, &
  & 0.57223595E-07_JPRB, 0.57870103E-07_JPRB, 0.58304263E-07_JPRB, 0.58236708E-07_JPRB, 0.57371981E-07_JPRB, 0.55631009E-07_JPRB, &
  & 0.53236111E-07_JPRB, 0.50479745E-07_JPRB, 0.47594167E-07_JPRB, 0.44792976E-07_JPRB, 0.42185384E-07_JPRB, 0.39911207E-07_JPRB, &
  & 0.38051336E-07_JPRB, 0.36573358E-07_JPRB, 0.35404323E-07_JPRB, 0.34604113E-07_JPRB, 0.34432272E-07_JPRB, 0.35124781E-07_JPRB, &
  & 0.36702371E-07_JPRB, 0.39027487E-07_JPRB, 0.41777980E-07_JPRB, 0.44645599E-07_JPRB, 0.47361784E-07_JPRB, 0.49798405E-07_JPRB, &
  & 0.51916437E-07_JPRB, 0.53750529E-07_JPRB, 0.55396114E-07_JPRB, 0.56964176E-07_JPRB, 0.58557468E-07_JPRB, 0.60256745E-07_JPRB, &
  & 0.62049715E-07_JPRB, 0.63917810E-07_JPRB, 0.65750179E-07_JPRB, 0.67628093E-07_JPRB, 0.69422775E-07_JPRB, 0.71298437E-07_JPRB, &
  & 0.73196162E-07_JPRB, 0.75379170E-07_JPRB, 0.77842827E-07_JPRB, 0.79895131E-07_JPRB, 0.81547540E-07_JPRB, 0.82875196E-07_JPRB, &
  & 0.83989505E-07_JPRB, 0.85019110E-07_JPRB, 0.86308205E-07_JPRB, 0.88528417E-07_JPRB /)

RGHG7(:,66, 6) = (/ &
  & 0.59744806E-07_JPRB, 0.58527863E-07_JPRB, 0.58033027E-07_JPRB, 0.57689810E-07_JPRB, 0.57395301E-07_JPRB, 0.57110906E-07_JPRB, &
  & 0.56846996E-07_JPRB, 0.56580948E-07_JPRB, 0.56301189E-07_JPRB, 0.55986597E-07_JPRB, 0.55607419E-07_JPRB, 0.55165398E-07_JPRB, &
  & 0.54666753E-07_JPRB, 0.54223747E-07_JPRB, 0.53936077E-07_JPRB, 0.53868259E-07_JPRB, 0.54073155E-07_JPRB, 0.54516992E-07_JPRB, &
  & 0.55133363E-07_JPRB, 0.55766723E-07_JPRB, 0.56179385E-07_JPRB, 0.56092588E-07_JPRB, 0.55246531E-07_JPRB, 0.53552245E-07_JPRB, &
  & 0.51263299E-07_JPRB, 0.48646235E-07_JPRB, 0.45954266E-07_JPRB, 0.43351125E-07_JPRB, 0.40999275E-07_JPRB, 0.38999559E-07_JPRB, &
  & 0.37429306E-07_JPRB, 0.36202632E-07_JPRB, 0.35214736E-07_JPRB, 0.34523637E-07_JPRB, 0.34389117E-07_JPRB, 0.35044941E-07_JPRB, &
  & 0.36498626E-07_JPRB, 0.38608636E-07_JPRB, 0.41093095E-07_JPRB, 0.43676057E-07_JPRB, 0.46153463E-07_JPRB, 0.48406086E-07_JPRB, &
  & 0.50402271E-07_JPRB, 0.52159383E-07_JPRB, 0.53747538E-07_JPRB, 0.55269645E-07_JPRB, 0.56796928E-07_JPRB, 0.58428608E-07_JPRB, &
  & 0.60154633E-07_JPRB, 0.61947944E-07_JPRB, 0.63713337E-07_JPRB, 0.65522990E-07_JPRB, 0.67277298E-07_JPRB, 0.69113327E-07_JPRB, &
  & 0.70976277E-07_JPRB, 0.73166902E-07_JPRB, 0.75659500E-07_JPRB, 0.77773130E-07_JPRB, 0.79521676E-07_JPRB, 0.80925233E-07_JPRB, &
  & 0.82092768E-07_JPRB, 0.83152962E-07_JPRB, 0.84495298E-07_JPRB, 0.86793719E-07_JPRB /)

RGHG7(:,67, 6) = (/ &
  & 0.58118101E-07_JPRB, 0.56832391E-07_JPRB, 0.56300259E-07_JPRB, 0.55929632E-07_JPRB, 0.55603170E-07_JPRB, 0.55307456E-07_JPRB, &
  & 0.55017942E-07_JPRB, 0.54737470E-07_JPRB, 0.54425620E-07_JPRB, 0.54069389E-07_JPRB, 0.53652904E-07_JPRB, 0.53156505E-07_JPRB, &
  & 0.52652606E-07_JPRB, 0.52233627E-07_JPRB, 0.51972339E-07_JPRB, 0.51927284E-07_JPRB, 0.52145321E-07_JPRB, 0.52586291E-07_JPRB, &
  & 0.53189613E-07_JPRB, 0.53801344E-07_JPRB, 0.54195251E-07_JPRB, 0.54104493E-07_JPRB, 0.53285046E-07_JPRB, 0.51679859E-07_JPRB, &
  & 0.49513439E-07_JPRB, 0.47074327E-07_JPRB, 0.44589541E-07_JPRB, 0.42226354E-07_JPRB, 0.40148098E-07_JPRB, 0.38429334E-07_JPRB, &
  & 0.37129674E-07_JPRB, 0.36137095E-07_JPRB, 0.35321801E-07_JPRB, 0.34739628E-07_JPRB, 0.34643101E-07_JPRB, 0.35265685E-07_JPRB, &
  & 0.36609311E-07_JPRB, 0.38527158E-07_JPRB, 0.40760192E-07_JPRB, 0.43086388E-07_JPRB, 0.45336918E-07_JPRB, 0.47420940E-07_JPRB, &
  & 0.49288953E-07_JPRB, 0.50963148E-07_JPRB, 0.52475965E-07_JPRB, 0.53943591E-07_JPRB, 0.55400655E-07_JPRB, 0.56950960E-07_JPRB, &
  & 0.58609512E-07_JPRB, 0.60320346E-07_JPRB, 0.62011885E-07_JPRB, 0.63749738E-07_JPRB, 0.65441427E-07_JPRB, 0.67214188E-07_JPRB, &
  & 0.69034101E-07_JPRB, 0.71187415E-07_JPRB, 0.73685179E-07_JPRB, 0.75825412E-07_JPRB, 0.77598898E-07_JPRB, 0.79051738E-07_JPRB, &
  & 0.80240511E-07_JPRB, 0.81300918E-07_JPRB, 0.82654545E-07_JPRB, 0.85063490E-07_JPRB /)

RGHG7(:,68, 6) = (/ &
  & 0.56616209E-07_JPRB, 0.55238466E-07_JPRB, 0.54643920E-07_JPRB, 0.54217196E-07_JPRB, 0.53858258E-07_JPRB, 0.53524658E-07_JPRB, &
  & 0.53225229E-07_JPRB, 0.52909076E-07_JPRB, 0.52585658E-07_JPRB, 0.52192188E-07_JPRB, 0.51738542E-07_JPRB, 0.51245223E-07_JPRB, &
  & 0.50769852E-07_JPRB, 0.50388049E-07_JPRB, 0.50166644E-07_JPRB, 0.50144742E-07_JPRB, 0.50371487E-07_JPRB, 0.50804022E-07_JPRB, &
  & 0.51387438E-07_JPRB, 0.51975878E-07_JPRB, 0.52349971E-07_JPRB, 0.52261981E-07_JPRB, 0.51495174E-07_JPRB, 0.50009366E-07_JPRB, &
  & 0.47992867E-07_JPRB, 0.45770609E-07_JPRB, 0.43518998E-07_JPRB, 0.41418115E-07_JPRB, 0.39609848E-07_JPRB, 0.38159261E-07_JPRB, &
  & 0.37113608E-07_JPRB, 0.36337138E-07_JPRB, 0.35687172E-07_JPRB, 0.35213450E-07_JPRB, 0.35160653E-07_JPRB, 0.35752649E-07_JPRB, &
  & 0.36992908E-07_JPRB, 0.38733532E-07_JPRB, 0.40754060E-07_JPRB, 0.42851696E-07_JPRB, 0.44905125E-07_JPRB, 0.46817952E-07_JPRB, &
  & 0.48569916E-07_JPRB, 0.50149772E-07_JPRB, 0.51585403E-07_JPRB, 0.52984326E-07_JPRB, 0.54353833E-07_JPRB, 0.55835706E-07_JPRB, &
  & 0.57406744E-07_JPRB, 0.59034960E-07_JPRB, 0.60645732E-07_JPRB, 0.62301240E-07_JPRB, 0.63917859E-07_JPRB, 0.65619403E-07_JPRB, &
  & 0.67368063E-07_JPRB, 0.69464967E-07_JPRB, 0.71925946E-07_JPRB, 0.74042333E-07_JPRB, 0.75820921E-07_JPRB, 0.77272510E-07_JPRB, &
  & 0.78468396E-07_JPRB, 0.79484330E-07_JPRB, 0.80857973E-07_JPRB, 0.83267864E-07_JPRB /)

RGHG7(:,69, 6) = (/ &
  & 0.55258091E-07_JPRB, 0.53714636E-07_JPRB, 0.53022696E-07_JPRB, 0.52531636E-07_JPRB, 0.52116921E-07_JPRB, 0.51759503E-07_JPRB, &
  & 0.51426490E-07_JPRB, 0.51113449E-07_JPRB, 0.50747889E-07_JPRB, 0.50351780E-07_JPRB, 0.49893465E-07_JPRB, 0.49424184E-07_JPRB, &
  & 0.48998629E-07_JPRB, 0.48663630E-07_JPRB, 0.48483848E-07_JPRB, 0.48492581E-07_JPRB, 0.48730929E-07_JPRB, 0.49157244E-07_JPRB, &
  & 0.49717475E-07_JPRB, 0.50278729E-07_JPRB, 0.50636427E-07_JPRB, 0.50566943E-07_JPRB, 0.49878189E-07_JPRB, 0.48532904E-07_JPRB, &
  & 0.46711879E-07_JPRB, 0.44713570E-07_JPRB, 0.42721460E-07_JPRB, 0.40888004E-07_JPRB, 0.39350958E-07_JPRB, 0.38160046E-07_JPRB, &
  & 0.37355424E-07_JPRB, 0.36776722E-07_JPRB, 0.36286071E-07_JPRB, 0.35920646E-07_JPRB, 0.35915924E-07_JPRB, 0.36486089E-07_JPRB, &
  & 0.37636955E-07_JPRB, 0.39229644E-07_JPRB, 0.41047116E-07_JPRB, 0.42945409E-07_JPRB, 0.44815337E-07_JPRB, 0.46576002E-07_JPRB, &
  & 0.48212719E-07_JPRB, 0.49689781E-07_JPRB, 0.51052304E-07_JPRB, 0.52366186E-07_JPRB, 0.53665854E-07_JPRB, 0.55056415E-07_JPRB, &
  & 0.56552970E-07_JPRB, 0.58087299E-07_JPRB, 0.59614159E-07_JPRB, 0.61181261E-07_JPRB, 0.62712907E-07_JPRB, 0.64329633E-07_JPRB, &
  & 0.65992374E-07_JPRB, 0.67995330E-07_JPRB, 0.70384296E-07_JPRB, 0.72442859E-07_JPRB, 0.74167595E-07_JPRB, 0.75597853E-07_JPRB, &
  & 0.76761388E-07_JPRB, 0.77742044E-07_JPRB, 0.79022804E-07_JPRB, 0.81457301E-07_JPRB /)

RGHG7(:,70, 6) = (/ &
  & 0.53967977E-07_JPRB, 0.52197549E-07_JPRB, 0.51387865E-07_JPRB, 0.50823747E-07_JPRB, 0.50359859E-07_JPRB, 0.49976869E-07_JPRB, &
  & 0.49633123E-07_JPRB, 0.49293725E-07_JPRB, 0.48945481E-07_JPRB, 0.48528598E-07_JPRB, 0.48113790E-07_JPRB, 0.47692474E-07_JPRB, &
  & 0.47325777E-07_JPRB, 0.47055128E-07_JPRB, 0.46922693E-07_JPRB, 0.46965692E-07_JPRB, 0.47217007E-07_JPRB, 0.47634451E-07_JPRB, &
  & 0.48174218E-07_JPRB, 0.48708376E-07_JPRB, 0.49057356E-07_JPRB, 0.49019533E-07_JPRB, 0.48424173E-07_JPRB, 0.47254478E-07_JPRB, &
  & 0.45650253E-07_JPRB, 0.43895337E-07_JPRB, 0.42171155E-07_JPRB, 0.40616399E-07_JPRB, 0.39334033E-07_JPRB, 0.38386201E-07_JPRB, &
  & 0.37803183E-07_JPRB, 0.37417212E-07_JPRB, 0.37081442E-07_JPRB, 0.36827597E-07_JPRB, 0.36878546E-07_JPRB, 0.37430574E-07_JPRB, &
  & 0.38498214E-07_JPRB, 0.39947853E-07_JPRB, 0.41605240E-07_JPRB, 0.43333660E-07_JPRB, 0.45036597E-07_JPRB, 0.46660343E-07_JPRB, &
  & 0.48182002E-07_JPRB, 0.49565216E-07_JPRB, 0.50843624E-07_JPRB, 0.52081159E-07_JPRB, 0.53301576E-07_JPRB, 0.54614077E-07_JPRB, &
  & 0.56024046E-07_JPRB, 0.57466753E-07_JPRB, 0.58905705E-07_JPRB, 0.60369707E-07_JPRB, 0.61813580E-07_JPRB, 0.63324414E-07_JPRB, &
  & 0.64891459E-07_JPRB, 0.66783485E-07_JPRB, 0.69055140E-07_JPRB, 0.71009474E-07_JPRB, 0.72656690E-07_JPRB, 0.74010998E-07_JPRB, &
  & 0.75145749E-07_JPRB, 0.76037480E-07_JPRB, 0.77278344E-07_JPRB, 0.79638149E-07_JPRB /)

RGHG7(:,71, 6) = (/ &
  & 0.52692286E-07_JPRB, 0.50630881E-07_JPRB, 0.49704084E-07_JPRB, 0.49056698E-07_JPRB, 0.48570850E-07_JPRB, 0.48155126E-07_JPRB, &
  & 0.47816197E-07_JPRB, 0.47477211E-07_JPRB, 0.47113101E-07_JPRB, 0.46758878E-07_JPRB, 0.46370030E-07_JPRB, 0.46025910E-07_JPRB, &
  & 0.45723120E-07_JPRB, 0.45523024E-07_JPRB, 0.45452691E-07_JPRB, 0.45540780E-07_JPRB, 0.45813909E-07_JPRB, 0.46232056E-07_JPRB, &
  & 0.46752508E-07_JPRB, 0.47267530E-07_JPRB, 0.47614627E-07_JPRB, 0.47620496E-07_JPRB, 0.47142482E-07_JPRB, 0.46154650E-07_JPRB, &
  & 0.44798526E-07_JPRB, 0.43297351E-07_JPRB, 0.41848697E-07_JPRB, 0.40551381E-07_JPRB, 0.39535543E-07_JPRB, 0.38827949E-07_JPRB, &
  & 0.38453937E-07_JPRB, 0.38249041E-07_JPRB, 0.38058250E-07_JPRB, 0.37922341E-07_JPRB, 0.38033413E-07_JPRB, 0.38578698E-07_JPRB, &
  & 0.39577039E-07_JPRB, 0.40912290E-07_JPRB, 0.42413404E-07_JPRB, 0.43980410E-07_JPRB, 0.45537220E-07_JPRB, 0.47027893E-07_JPRB, &
  & 0.48457959E-07_JPRB, 0.49735061E-07_JPRB, 0.50944919E-07_JPRB, 0.52102301E-07_JPRB, 0.53252517E-07_JPRB, 0.54481532E-07_JPRB, &
  & 0.55810403E-07_JPRB, 0.57163366E-07_JPRB, 0.58505542E-07_JPRB, 0.59869180E-07_JPRB, 0.61214799E-07_JPRB, 0.62615030E-07_JPRB, &
  & 0.64076588E-07_JPRB, 0.65824835E-07_JPRB, 0.67932142E-07_JPRB, 0.69752367E-07_JPRB, 0.71259535E-07_JPRB, 0.72529353E-07_JPRB, &
  & 0.73582569E-07_JPRB, 0.74419575E-07_JPRB, 0.75487861E-07_JPRB, 0.77702616E-07_JPRB /)

RGHG7(:,72, 6) = (/ &
  & 0.51365163E-07_JPRB, 0.48987893E-07_JPRB, 0.47905910E-07_JPRB, 0.47222489E-07_JPRB, 0.46696233E-07_JPRB, 0.46304844E-07_JPRB, &
  & 0.45944855E-07_JPRB, 0.45619966E-07_JPRB, 0.45309669E-07_JPRB, 0.44964541E-07_JPRB, 0.44673488E-07_JPRB, 0.44395268E-07_JPRB, &
  & 0.44189154E-07_JPRB, 0.44070411E-07_JPRB, 0.44072475E-07_JPRB, 0.44215877E-07_JPRB, 0.44516820E-07_JPRB, 0.44942269E-07_JPRB, &
  & 0.45456954E-07_JPRB, 0.45958405E-07_JPRB, 0.46314032E-07_JPRB, 0.46375096E-07_JPRB, 0.46019743E-07_JPRB, 0.45236270E-07_JPRB, &
  & 0.44130910E-07_JPRB, 0.42898428E-07_JPRB, 0.41715712E-07_JPRB, 0.40700147E-07_JPRB, 0.39930484E-07_JPRB, 0.39430098E-07_JPRB, &
  & 0.39256349E-07_JPRB, 0.39213791E-07_JPRB, 0.39174306E-07_JPRB, 0.39158603E-07_JPRB, 0.39338875E-07_JPRB, 0.39881645E-07_JPRB, &
  & 0.40816911E-07_JPRB, 0.42038533E-07_JPRB, 0.43413962E-07_JPRB, 0.44854641E-07_JPRB, 0.46269534E-07_JPRB, 0.47662702E-07_JPRB, &
  & 0.48978343E-07_JPRB, 0.50182699E-07_JPRB, 0.51309051E-07_JPRB, 0.52401024E-07_JPRB, 0.53477777E-07_JPRB, 0.54631844E-07_JPRB, &
  & 0.55877813E-07_JPRB, 0.57134482E-07_JPRB, 0.58382227E-07_JPRB, 0.59639241E-07_JPRB, 0.60882385E-07_JPRB, 0.62168091E-07_JPRB, &
  & 0.63509539E-07_JPRB, 0.65118861E-07_JPRB, 0.67019144E-07_JPRB, 0.68636758E-07_JPRB, 0.70014337E-07_JPRB, 0.71140398E-07_JPRB, &
  & 0.72121679E-07_JPRB, 0.72874151E-07_JPRB, 0.73821674E-07_JPRB, 0.75744595E-07_JPRB /)

RGHG7(:,73, 6) = (/ &
  & 0.49893366E-07_JPRB, 0.47177522E-07_JPRB, 0.45990355E-07_JPRB, 0.45275261E-07_JPRB, 0.44777927E-07_JPRB, 0.44379156E-07_JPRB, &
  & 0.44057394E-07_JPRB, 0.43759893E-07_JPRB, 0.43461455E-07_JPRB, 0.43226144E-07_JPRB, 0.42973650E-07_JPRB, 0.42811333E-07_JPRB, &
  & 0.42693667E-07_JPRB, 0.42675801E-07_JPRB, 0.42764107E-07_JPRB, 0.42975003E-07_JPRB, 0.43330402E-07_JPRB, 0.43766448E-07_JPRB, &
  & 0.44285361E-07_JPRB, 0.44784553E-07_JPRB, 0.45158146E-07_JPRB, 0.45281471E-07_JPRB, 0.45061146E-07_JPRB, 0.44479538E-07_JPRB, &
  & 0.43633676E-07_JPRB, 0.42674863E-07_JPRB, 0.41745587E-07_JPRB, 0.41039240E-07_JPRB, 0.40482181E-07_JPRB, 0.40195616E-07_JPRB, &
  & 0.40222627E-07_JPRB, 0.40323304E-07_JPRB, 0.40430795E-07_JPRB, 0.40534484E-07_JPRB, 0.40790326E-07_JPRB, 0.41345391E-07_JPRB, &
  & 0.42232912E-07_JPRB, 0.43363315E-07_JPRB, 0.44617707E-07_JPRB, 0.45914444E-07_JPRB, 0.47212762E-07_JPRB, 0.48496290E-07_JPRB, &
  & 0.49728765E-07_JPRB, 0.50841447E-07_JPRB, 0.51907964E-07_JPRB, 0.52928257E-07_JPRB, 0.53941505E-07_JPRB, 0.55022959E-07_JPRB, &
  & 0.56185627E-07_JPRB, 0.57345400E-07_JPRB, 0.58501449E-07_JPRB, 0.59648613E-07_JPRB, 0.60795649E-07_JPRB, 0.61952242E-07_JPRB, &
  & 0.63187578E-07_JPRB, 0.64616231E-07_JPRB, 0.66275788E-07_JPRB, 0.67720691E-07_JPRB, 0.68896753E-07_JPRB, 0.69906399E-07_JPRB, &
  & 0.70771080E-07_JPRB, 0.71471199E-07_JPRB, 0.72280024E-07_JPRB, 0.73994833E-07_JPRB /)

RGHG7(:,74, 6) = (/ &
  & 0.48137249E-07_JPRB, 0.45127418E-07_JPRB, 0.43975081E-07_JPRB, 0.43281361E-07_JPRB, 0.42823153E-07_JPRB, 0.42470418E-07_JPRB, &
  & 0.42173184E-07_JPRB, 0.41916103E-07_JPRB, 0.41701348E-07_JPRB, 0.41498751E-07_JPRB, 0.41375930E-07_JPRB, 0.41291663E-07_JPRB, &
  & 0.41294765E-07_JPRB, 0.41385004E-07_JPRB, 0.41562771E-07_JPRB, 0.41838888E-07_JPRB, 0.42243400E-07_JPRB, 0.42708148E-07_JPRB, &
  & 0.43237925E-07_JPRB, 0.43746148E-07_JPRB, 0.44145594E-07_JPRB, 0.44339910E-07_JPRB, 0.44255174E-07_JPRB, 0.43881329E-07_JPRB, &
  & 0.43284015E-07_JPRB, 0.42597012E-07_JPRB, 0.41938151E-07_JPRB, 0.41519396E-07_JPRB, 0.41176015E-07_JPRB, 0.41069882E-07_JPRB, &
  & 0.41269239E-07_JPRB, 0.41500609E-07_JPRB, 0.41747274E-07_JPRB, 0.41973877E-07_JPRB, 0.42312134E-07_JPRB, 0.42883144E-07_JPRB, &
  & 0.43727905E-07_JPRB, 0.44769973E-07_JPRB, 0.45919847E-07_JPRB, 0.47119492E-07_JPRB, 0.48313964E-07_JPRB, 0.49507825E-07_JPRB, &
  & 0.50638118E-07_JPRB, 0.51688076E-07_JPRB, 0.52684562E-07_JPRB, 0.53643973E-07_JPRB, 0.54588547E-07_JPRB, 0.55607064E-07_JPRB, &
  & 0.56670096E-07_JPRB, 0.57743197E-07_JPRB, 0.58791997E-07_JPRB, 0.59843607E-07_JPRB, 0.60870917E-07_JPRB, 0.61922250E-07_JPRB, &
  & 0.63014596E-07_JPRB, 0.64283775E-07_JPRB, 0.65729793E-07_JPRB, 0.66935776E-07_JPRB, 0.67971193E-07_JPRB, 0.68828811E-07_JPRB, &
  & 0.69591003E-07_JPRB, 0.70208046E-07_JPRB, 0.70919803E-07_JPRB, 0.72392289E-07_JPRB /)

RGHG7(:,75, 6) = (/ &
  & 0.46126473E-07_JPRB, 0.43115246E-07_JPRB, 0.41922132E-07_JPRB, 0.41328384E-07_JPRB, 0.40916007E-07_JPRB, 0.40619923E-07_JPRB, &
  & 0.40383554E-07_JPRB, 0.40185661E-07_JPRB, 0.40018570E-07_JPRB, 0.39916191E-07_JPRB, 0.39866102E-07_JPRB, 0.39888153E-07_JPRB, &
  & 0.39995136E-07_JPRB, 0.40185455E-07_JPRB, 0.40462751E-07_JPRB, 0.40813603E-07_JPRB, 0.41263288E-07_JPRB, 0.41765219E-07_JPRB, &
  & 0.42307239E-07_JPRB, 0.42833250E-07_JPRB, 0.43267917E-07_JPRB, 0.43538776E-07_JPRB, 0.43594600E-07_JPRB, 0.43419060E-07_JPRB, &
  & 0.43065000E-07_JPRB, 0.42640302E-07_JPRB, 0.42287880E-07_JPRB, 0.42067018E-07_JPRB, 0.41986212E-07_JPRB, 0.42061636E-07_JPRB, &
  & 0.42421807E-07_JPRB, 0.42799158E-07_JPRB, 0.43167603E-07_JPRB, 0.43519208E-07_JPRB, 0.43943611E-07_JPRB, 0.44546528E-07_JPRB, &
  & 0.45362491E-07_JPRB, 0.46327933E-07_JPRB, 0.47375654E-07_JPRB, 0.48451778E-07_JPRB, 0.49540279E-07_JPRB, 0.50635585E-07_JPRB, &
  & 0.51682498E-07_JPRB, 0.52662532E-07_JPRB, 0.53599639E-07_JPRB, 0.54494645E-07_JPRB, 0.55383250E-07_JPRB, 0.56323653E-07_JPRB, &
  & 0.57305240E-07_JPRB, 0.58276964E-07_JPRB, 0.59234711E-07_JPRB, 0.60171878E-07_JPRB, 0.61100792E-07_JPRB, 0.62019218E-07_JPRB, &
  & 0.62981947E-07_JPRB, 0.64070122E-07_JPRB, 0.65280297E-07_JPRB, 0.66333008E-07_JPRB, 0.67188530E-07_JPRB, 0.67920155E-07_JPRB, &
  & 0.68568255E-07_JPRB, 0.69108196E-07_JPRB, 0.69700803E-07_JPRB, 0.71009438E-07_JPRB /)

RGHG7(:,76, 6) = (/ &
  & 0.44126541E-07_JPRB, 0.41007947E-07_JPRB, 0.39975554E-07_JPRB, 0.39430180E-07_JPRB, 0.39122259E-07_JPRB, 0.38890523E-07_JPRB, &
  & 0.38720618E-07_JPRB, 0.38590429E-07_JPRB, 0.38510841E-07_JPRB, 0.38493411E-07_JPRB, 0.38531986E-07_JPRB, 0.38672638E-07_JPRB, &
  & 0.38863423E-07_JPRB, 0.39146933E-07_JPRB, 0.39487723E-07_JPRB, 0.39900456E-07_JPRB, 0.40385036E-07_JPRB, 0.40917833E-07_JPRB, &
  & 0.41485702E-07_JPRB, 0.42036035E-07_JPRB, 0.42512763E-07_JPRB, 0.42865075E-07_JPRB, 0.43059149E-07_JPRB, 0.43077808E-07_JPRB, &
  & 0.42951029E-07_JPRB, 0.42792763E-07_JPRB, 0.42739288E-07_JPRB, 0.42682853E-07_JPRB, 0.42877634E-07_JPRB, 0.43106454E-07_JPRB, &
  & 0.43567265E-07_JPRB, 0.44068361E-07_JPRB, 0.44540393E-07_JPRB, 0.45010644E-07_JPRB, 0.45522508E-07_JPRB, 0.46158949E-07_JPRB, &
  & 0.46953936E-07_JPRB, 0.47859618E-07_JPRB, 0.48828436E-07_JPRB, 0.49830895E-07_JPRB, 0.50841106E-07_JPRB, 0.51845326E-07_JPRB, &
  & 0.52809739E-07_JPRB, 0.53727685E-07_JPRB, 0.54598303E-07_JPRB, 0.55441326E-07_JPRB, 0.56268043E-07_JPRB, 0.57139459E-07_JPRB, &
  & 0.58022415E-07_JPRB, 0.58901101E-07_JPRB, 0.59752608E-07_JPRB, 0.60588000E-07_JPRB, 0.61398786E-07_JPRB, 0.62199845E-07_JPRB, &
  & 0.63019840E-07_JPRB, 0.63931864E-07_JPRB, 0.64966457E-07_JPRB, 0.65812664E-07_JPRB, 0.66531101E-07_JPRB, 0.67141464E-07_JPRB, &
  & 0.67680489E-07_JPRB, 0.68119121E-07_JPRB, 0.68625532E-07_JPRB, 0.69759622E-07_JPRB /)

RGHG7(:,77, 6) = (/ &
  & 0.41969784E-07_JPRB, 0.39036717E-07_JPRB, 0.38071949E-07_JPRB, 0.37676635E-07_JPRB, 0.37442703E-07_JPRB, 0.37307018E-07_JPRB, &
  & 0.37222037E-07_JPRB, 0.37173429E-07_JPRB, 0.37189938E-07_JPRB, 0.37241239E-07_JPRB, 0.37408270E-07_JPRB, 0.37592301E-07_JPRB, &
  & 0.37885140E-07_JPRB, 0.38229359E-07_JPRB, 0.38633978E-07_JPRB, 0.39101081E-07_JPRB, 0.39617611E-07_JPRB, 0.40179298E-07_JPRB, &
  & 0.40766249E-07_JPRB, 0.41348528E-07_JPRB, 0.41871349E-07_JPRB, 0.42304439E-07_JPRB, 0.42635996E-07_JPRB, 0.42831982E-07_JPRB, &
  & 0.42921538E-07_JPRB, 0.43044810E-07_JPRB, 0.43202235E-07_JPRB, 0.43385921E-07_JPRB, 0.43765109E-07_JPRB, 0.44201151E-07_JPRB, &
  & 0.44770111E-07_JPRB, 0.45414087E-07_JPRB, 0.45994028E-07_JPRB, 0.46578474E-07_JPRB, 0.47185200E-07_JPRB, 0.47863857E-07_JPRB, &
  & 0.48640000E-07_JPRB, 0.49479425E-07_JPRB, 0.50356913E-07_JPRB, 0.51253860E-07_JPRB, 0.52159557E-07_JPRB, 0.53078036E-07_JPRB, &
  & 0.53968879E-07_JPRB, 0.54819211E-07_JPRB, 0.55633841E-07_JPRB, 0.56420351E-07_JPRB, 0.57197298E-07_JPRB, 0.57992011E-07_JPRB, &
  & 0.58794647E-07_JPRB, 0.59575520E-07_JPRB, 0.60328716E-07_JPRB, 0.61060504E-07_JPRB, 0.61761966E-07_JPRB, 0.62446162E-07_JPRB, &
  & 0.63125583E-07_JPRB, 0.63868526E-07_JPRB, 0.64680471E-07_JPRB, 0.65380348E-07_JPRB, 0.65966987E-07_JPRB, 0.66438609E-07_JPRB, &
  & 0.66887900E-07_JPRB, 0.67236662E-07_JPRB, 0.67615659E-07_JPRB, 0.68655936E-07_JPRB /)

RGHG7(:,78, 6) = (/ &
  & 0.39804981E-07_JPRB, 0.37138435E-07_JPRB, 0.36375067E-07_JPRB, 0.36094587E-07_JPRB, 0.35986144E-07_JPRB, 0.35940033E-07_JPRB, &
  & 0.35950904E-07_JPRB, 0.36005098E-07_JPRB, 0.36115633E-07_JPRB, 0.36303991E-07_JPRB, 0.36497109E-07_JPRB, 0.36818776E-07_JPRB, &
  & 0.37137966E-07_JPRB, 0.37530906E-07_JPRB, 0.37968938E-07_JPRB, 0.38452818E-07_JPRB, 0.39002437E-07_JPRB, 0.39570097E-07_JPRB, &
  & 0.40174676E-07_JPRB, 0.40785530E-07_JPRB, 0.41352543E-07_JPRB, 0.41858915E-07_JPRB, 0.42315808E-07_JPRB, 0.42662574E-07_JPRB, &
  & 0.42957087E-07_JPRB, 0.43339409E-07_JPRB, 0.43624283E-07_JPRB, 0.44107818E-07_JPRB, 0.44564747E-07_JPRB, 0.45177423E-07_JPRB, &
  & 0.45777458E-07_JPRB, 0.46475851E-07_JPRB, 0.47131159E-07_JPRB, 0.47783143E-07_JPRB, 0.48462674E-07_JPRB, 0.49188667E-07_JPRB, &
  & 0.49980766E-07_JPRB, 0.50810232E-07_JPRB, 0.51656500E-07_JPRB, 0.52510504E-07_JPRB, 0.53365302E-07_JPRB, 0.54215135E-07_JPRB, &
  & 0.55037589E-07_JPRB, 0.55825858E-07_JPRB, 0.56589879E-07_JPRB, 0.57331807E-07_JPRB, 0.58058781E-07_JPRB, 0.58782806E-07_JPRB, &
  & 0.59499161E-07_JPRB, 0.60192285E-07_JPRB, 0.60855406E-07_JPRB, 0.61491981E-07_JPRB, 0.62096532E-07_JPRB, 0.62677252E-07_JPRB, &
  & 0.63243100E-07_JPRB, 0.63838499E-07_JPRB, 0.64482137E-07_JPRB, 0.65019279E-07_JPRB, 0.65468541E-07_JPRB, 0.65850095E-07_JPRB, &
  & 0.66200570E-07_JPRB, 0.66464175E-07_JPRB, 0.66731218E-07_JPRB, 0.67613243E-07_JPRB /)

RGHG7(:,79, 6) = (/ &
  & 0.37613162E-07_JPRB, 0.35669778E-07_JPRB, 0.35167702E-07_JPRB, 0.35073821E-07_JPRB, 0.35068474E-07_JPRB, 0.35126490E-07_JPRB, &
  & 0.35225600E-07_JPRB, 0.35379205E-07_JPRB, 0.35571937E-07_JPRB, 0.35800237E-07_JPRB, 0.36093564E-07_JPRB, 0.36386940E-07_JPRB, &
  & 0.36761541E-07_JPRB, 0.37171482E-07_JPRB, 0.37624250E-07_JPRB, 0.38123485E-07_JPRB, 0.38664361E-07_JPRB, 0.39243844E-07_JPRB, &
  & 0.39830155E-07_JPRB, 0.40449233E-07_JPRB, 0.41037651E-07_JPRB, 0.41590486E-07_JPRB, 0.42124725E-07_JPRB, 0.42553491E-07_JPRB, &
  & 0.43018982E-07_JPRB, 0.43511314E-07_JPRB, 0.43891550E-07_JPRB, 0.44496375E-07_JPRB, 0.44981434E-07_JPRB, 0.45646789E-07_JPRB, &
  & 0.46306731E-07_JPRB, 0.47017540E-07_JPRB, 0.47717084E-07_JPRB, 0.48403965E-07_JPRB, 0.49120576E-07_JPRB, 0.49877052E-07_JPRB, &
  & 0.50679713E-07_JPRB, 0.51507431E-07_JPRB, 0.52340962E-07_JPRB, 0.53170996E-07_JPRB, 0.53996512E-07_JPRB, 0.54816574E-07_JPRB, &
  & 0.55601475E-07_JPRB, 0.56363206E-07_JPRB, 0.57096866E-07_JPRB, 0.57812127E-07_JPRB, 0.58509229E-07_JPRB, 0.59194580E-07_JPRB, &
  & 0.59867851E-07_JPRB, 0.60512754E-07_JPRB, 0.61127771E-07_JPRB, 0.61717316E-07_JPRB, 0.62272335E-07_JPRB, 0.62804745E-07_JPRB, &
  & 0.63313351E-07_JPRB, 0.63833212E-07_JPRB, 0.64367704E-07_JPRB, 0.64815374E-07_JPRB, 0.65225684E-07_JPRB, 0.65495264E-07_JPRB, &
  & 0.65810013E-07_JPRB, 0.66025535E-07_JPRB, 0.66133452E-07_JPRB, 0.66840094E-07_JPRB /)

RGHG7(:,80, 6) = (/ &
  & 0.36201513E-07_JPRB, 0.34984353E-07_JPRB, 0.34671899E-07_JPRB, 0.34700538E-07_JPRB, 0.34743422E-07_JPRB, 0.34822047E-07_JPRB, &
  & 0.34948535E-07_JPRB, 0.35106297E-07_JPRB, 0.35347185E-07_JPRB, 0.35576605E-07_JPRB, 0.35872759E-07_JPRB, 0.36219323E-07_JPRB, &
  & 0.36591441E-07_JPRB, 0.37013603E-07_JPRB, 0.37465778E-07_JPRB, 0.37978118E-07_JPRB, 0.38513477E-07_JPRB, 0.39107302E-07_JPRB, &
  & 0.39687251E-07_JPRB, 0.40309931E-07_JPRB, 0.40904958E-07_JPRB, 0.41484189E-07_JPRB, 0.42030024E-07_JPRB, 0.42477602E-07_JPRB, &
  & 0.43066652E-07_JPRB, 0.43500677E-07_JPRB, 0.44040700E-07_JPRB, 0.44600135E-07_JPRB, 0.45211134E-07_JPRB, 0.45841130E-07_JPRB, &
  & 0.46544585E-07_JPRB, 0.47250847E-07_JPRB, 0.47972708E-07_JPRB, 0.48679322E-07_JPRB, 0.49413618E-07_JPRB, 0.50184532E-07_JPRB, &
  & 0.50993595E-07_JPRB, 0.51822152E-07_JPRB, 0.52649156E-07_JPRB, 0.53470725E-07_JPRB, 0.54280861E-07_JPRB, 0.55076804E-07_JPRB, &
  & 0.55842751E-07_JPRB, 0.56587229E-07_JPRB, 0.57315379E-07_JPRB, 0.58017239E-07_JPRB, 0.58707190E-07_JPRB, 0.59376852E-07_JPRB, &
  & 0.60030040E-07_JPRB, 0.60650976E-07_JPRB, 0.61248564E-07_JPRB, 0.61811470E-07_JPRB, 0.62348569E-07_JPRB, 0.62851818E-07_JPRB, &
  & 0.63340025E-07_JPRB, 0.63821375E-07_JPRB, 0.64335239E-07_JPRB, 0.64737236E-07_JPRB, 0.65121469E-07_JPRB, 0.65383929E-07_JPRB, &
  & 0.65656700E-07_JPRB, 0.65885004E-07_JPRB, 0.65876300E-07_JPRB, 0.66436733E-07_JPRB /)

RGHG7(:,81, 6) = (/ &
  & 0.35289375E-07_JPRB, 0.34636848E-07_JPRB, 0.34412455E-07_JPRB, 0.34530746E-07_JPRB, 0.34557143E-07_JPRB, 0.34651187E-07_JPRB, &
  & 0.34788364E-07_JPRB, 0.35015830E-07_JPRB, 0.35196521E-07_JPRB, 0.35523865E-07_JPRB, 0.35785565E-07_JPRB, 0.36135582E-07_JPRB, &
  & 0.36507391E-07_JPRB, 0.36938673E-07_JPRB, 0.37398056E-07_JPRB, 0.37911445E-07_JPRB, 0.38441023E-07_JPRB, 0.39029551E-07_JPRB, &
  & 0.39613969E-07_JPRB, 0.40226009E-07_JPRB, 0.40825654E-07_JPRB, 0.41433886E-07_JPRB, 0.41959417E-07_JPRB, 0.42460659E-07_JPRB, &
  & 0.43106251E-07_JPRB, 0.43466848E-07_JPRB, 0.44154902E-07_JPRB, 0.44619561E-07_JPRB, 0.45301114E-07_JPRB, 0.45913566E-07_JPRB, &
  & 0.46637787E-07_JPRB, 0.47353154E-07_JPRB, 0.48078675E-07_JPRB, 0.48800505E-07_JPRB, 0.49542134E-07_JPRB, 0.50322932E-07_JPRB, &
  & 0.51136109E-07_JPRB, 0.51961063E-07_JPRB, 0.52785136E-07_JPRB, 0.53597411E-07_JPRB, 0.54402154E-07_JPRB, 0.55191357E-07_JPRB, &
  & 0.55950249E-07_JPRB, 0.56693906E-07_JPRB, 0.57409558E-07_JPRB, 0.58110665E-07_JPRB, 0.58790647E-07_JPRB, 0.59454671E-07_JPRB, &
  & 0.60102188E-07_JPRB, 0.60708999E-07_JPRB, 0.61305272E-07_JPRB, 0.61849697E-07_JPRB, 0.62391166E-07_JPRB, 0.62873404E-07_JPRB, &
  & 0.63369875E-07_JPRB, 0.63818199E-07_JPRB, 0.64323622E-07_JPRB, 0.64681565E-07_JPRB, 0.65087342E-07_JPRB, 0.65306395E-07_JPRB, &
  & 0.65548555E-07_JPRB, 0.65833333E-07_JPRB, 0.65688880E-07_JPRB, 0.66134938E-07_JPRB /)

RGHG7(:,82, 6) = (/ &
  & 0.34674290E-07_JPRB, 0.34446867E-07_JPRB, 0.34321182E-07_JPRB, 0.34506186E-07_JPRB, 0.34479001E-07_JPRB, 0.34601452E-07_JPRB, &
  & 0.34768114E-07_JPRB, 0.34922433E-07_JPRB, 0.35229899E-07_JPRB, 0.35415322E-07_JPRB, 0.35770434E-07_JPRB, 0.36076493E-07_JPRB, &
  & 0.36470276E-07_JPRB, 0.36904428E-07_JPRB, 0.37353626E-07_JPRB, 0.37882341E-07_JPRB, 0.38403382E-07_JPRB, 0.39000174E-07_JPRB, &
  & 0.39576804E-07_JPRB, 0.40191431E-07_JPRB, 0.40781913E-07_JPRB, 0.41411088E-07_JPRB, 0.41887656E-07_JPRB, 0.42506901E-07_JPRB, &
  & 0.43031914E-07_JPRB, 0.43503746E-07_JPRB, 0.44140258E-07_JPRB, 0.44663672E-07_JPRB, 0.45323389E-07_JPRB, 0.45964732E-07_JPRB, &
  & 0.46672053E-07_JPRB, 0.47402779E-07_JPRB, 0.48129120E-07_JPRB, 0.48859750E-07_JPRB, 0.49608879E-07_JPRB, 0.50395379E-07_JPRB, &
  & 0.51208659E-07_JPRB, 0.52039347E-07_JPRB, 0.52857601E-07_JPRB, 0.53664365E-07_JPRB, 0.54456265E-07_JPRB, 0.55230707E-07_JPRB, &
  & 0.55980820E-07_JPRB, 0.56723358E-07_JPRB, 0.57441085E-07_JPRB, 0.58140863E-07_JPRB, 0.58829748E-07_JPRB, 0.59490564E-07_JPRB, &
  & 0.60135307E-07_JPRB, 0.60738330E-07_JPRB, 0.61329906E-07_JPRB, 0.61869173E-07_JPRB, 0.62409860E-07_JPRB, 0.62875678E-07_JPRB, &
  & 0.63379844E-07_JPRB, 0.63802624E-07_JPRB, 0.64331260E-07_JPRB, 0.64667077E-07_JPRB, 0.65058558E-07_JPRB, 0.65332749E-07_JPRB, &
  & 0.65482155E-07_JPRB, 0.65872598E-07_JPRB, 0.65617108E-07_JPRB, 0.66054746E-07_JPRB /)

RGHG7(:,83, 6) = (/ &
  & 0.34708055E-07_JPRB, 0.34310329E-07_JPRB, 0.34327019E-07_JPRB, 0.34481250E-07_JPRB, 0.34386300E-07_JPRB, 0.34578282E-07_JPRB, &
  & 0.34701532E-07_JPRB, 0.34952208E-07_JPRB, 0.35115541E-07_JPRB, 0.35483424E-07_JPRB, 0.35708123E-07_JPRB, 0.36079097E-07_JPRB, &
  & 0.36440930E-07_JPRB, 0.36864314E-07_JPRB, 0.37335905E-07_JPRB, 0.37848508E-07_JPRB, 0.38383252E-07_JPRB, 0.38957850E-07_JPRB, &
  & 0.39547832E-07_JPRB, 0.40150663E-07_JPRB, 0.40748827E-07_JPRB, 0.41374651E-07_JPRB, 0.41840480E-07_JPRB, 0.42546549E-07_JPRB, &
  & 0.42931443E-07_JPRB, 0.43583700E-07_JPRB, 0.44084441E-07_JPRB, 0.44710138E-07_JPRB, 0.45309623E-07_JPRB, 0.45993737E-07_JPRB, &
  & 0.46687230E-07_JPRB, 0.47426969E-07_JPRB, 0.48156021E-07_JPRB, 0.48892822E-07_JPRB, 0.49649582E-07_JPRB, 0.50440519E-07_JPRB, &
  & 0.51266575E-07_JPRB, 0.52089792E-07_JPRB, 0.52906760E-07_JPRB, 0.53705740E-07_JPRB, 0.54489359E-07_JPRB, 0.55260298E-07_JPRB, &
  & 0.56014049E-07_JPRB, 0.56745222E-07_JPRB, 0.57463996E-07_JPRB, 0.58159763E-07_JPRB, 0.58847782E-07_JPRB, 0.59508309E-07_JPRB, &
  & 0.60147642E-07_JPRB, 0.60760406E-07_JPRB, 0.61332372E-07_JPRB, 0.61892734E-07_JPRB, 0.62409050E-07_JPRB, 0.62896255E-07_JPRB, &
  & 0.63385031E-07_JPRB, 0.63817687E-07_JPRB, 0.64315785E-07_JPRB, 0.64676399E-07_JPRB, 0.65005089E-07_JPRB, 0.65355927E-07_JPRB, &
  & 0.65384818E-07_JPRB, 0.65913326E-07_JPRB, 0.65528901E-07_JPRB, 0.66120947E-07_JPRB /)

RGHG7(:,84, 6) = (/ &
  & 0.34748425E-07_JPRB, 0.34156013E-07_JPRB, 0.34409613E-07_JPRB, 0.34417088E-07_JPRB, 0.34344964E-07_JPRB, 0.34602039E-07_JPRB, &
  & 0.34695336E-07_JPRB, 0.34902037E-07_JPRB, 0.35225774E-07_JPRB, 0.35393459E-07_JPRB, 0.35759310E-07_JPRB, 0.36030762E-07_JPRB, &
  & 0.36426147E-07_JPRB, 0.36855024E-07_JPRB, 0.37305426E-07_JPRB, 0.37828134E-07_JPRB, 0.38358767E-07_JPRB, 0.38932342E-07_JPRB, &
  & 0.39523233E-07_JPRB, 0.40122998E-07_JPRB, 0.40723450E-07_JPRB, 0.41320508E-07_JPRB, 0.41847198E-07_JPRB, 0.42496467E-07_JPRB, &
  & 0.42913072E-07_JPRB, 0.43581501E-07_JPRB, 0.44067555E-07_JPRB, 0.44705260E-07_JPRB, 0.45318021E-07_JPRB, 0.45995765E-07_JPRB, &
  & 0.46701341E-07_JPRB, 0.47439261E-07_JPRB, 0.48174545E-07_JPRB, 0.48916124E-07_JPRB, 0.49678775E-07_JPRB, 0.50484392E-07_JPRB, &
  & 0.51310614E-07_JPRB, 0.52146564E-07_JPRB, 0.52964314E-07_JPRB, 0.53741569E-07_JPRB, 0.54512380E-07_JPRB, 0.55262671E-07_JPRB, &
  & 0.55987325E-07_JPRB, 0.56743474E-07_JPRB, 0.57442364E-07_JPRB, 0.58160296E-07_JPRB, 0.58849711E-07_JPRB, 0.59515333E-07_JPRB, &
  & 0.60151947E-07_JPRB, 0.60769004E-07_JPRB, 0.61328819E-07_JPRB, 0.61912523E-07_JPRB, 0.62390853E-07_JPRB, 0.62926901E-07_JPRB, &
  & 0.63349901E-07_JPRB, 0.63853037E-07_JPRB, 0.64270523E-07_JPRB, 0.64738387E-07_JPRB, 0.64929054E-07_JPRB, 0.65453918E-07_JPRB, &
  & 0.65294984E-07_JPRB, 0.65989205E-07_JPRB, 0.65466999E-07_JPRB, 0.66119654E-07_JPRB /)

RGHG7(:,85, 6) = (/ &
  & 0.34797825E-07_JPRB, 0.34010579E-07_JPRB, 0.34531674E-07_JPRB, 0.34291372E-07_JPRB, 0.34369588E-07_JPRB, 0.34600081E-07_JPRB, &
  & 0.34645904E-07_JPRB, 0.34998695E-07_JPRB, 0.35098999E-07_JPRB, 0.35521367E-07_JPRB, 0.35696658E-07_JPRB, 0.36107611E-07_JPRB, &
  & 0.36419582E-07_JPRB, 0.36833626E-07_JPRB, 0.37292480E-07_JPRB, 0.37779959E-07_JPRB, 0.38317559E-07_JPRB, 0.38886188E-07_JPRB, &
  & 0.39483421E-07_JPRB, 0.40074472E-07_JPRB, 0.40692385E-07_JPRB, 0.41270887E-07_JPRB, 0.41860552E-07_JPRB, 0.42407581E-07_JPRB, &
  & 0.42951260E-07_JPRB, 0.43513683E-07_JPRB, 0.44071278E-07_JPRB, 0.44685052E-07_JPRB, 0.45310507E-07_JPRB, 0.45994103E-07_JPRB, &
  & 0.46701501E-07_JPRB, 0.47444868E-07_JPRB, 0.48182276E-07_JPRB, 0.48928065E-07_JPRB, 0.49701587E-07_JPRB, 0.50510316E-07_JPRB, &
  & 0.51358512E-07_JPRB, 0.52199038E-07_JPRB, 0.52996828E-07_JPRB, 0.53797130E-07_JPRB, 0.54533412E-07_JPRB, 0.55286890E-07_JPRB, &
  & 0.56020330E-07_JPRB, 0.56741232E-07_JPRB, 0.57465993E-07_JPRB, 0.58153699E-07_JPRB, 0.58855207E-07_JPRB, 0.59514644E-07_JPRB, &
  & 0.60151528E-07_JPRB, 0.60766858E-07_JPRB, 0.61323931E-07_JPRB, 0.61920979E-07_JPRB, 0.62373772E-07_JPRB, 0.62963608E-07_JPRB, &
  & 0.63311283E-07_JPRB, 0.63923359E-07_JPRB, 0.64192236E-07_JPRB, 0.64829933E-07_JPRB, 0.64813456E-07_JPRB, 0.65542700E-07_JPRB, &
  & 0.65186576E-07_JPRB, 0.66050205E-07_JPRB, 0.65398112E-07_JPRB, 0.66161519E-07_JPRB /)

RGHG7(:,86, 6) = (/ &
  & 0.34796575E-07_JPRB, 0.33891531E-07_JPRB, 0.34648302E-07_JPRB, 0.34146044E-07_JPRB, 0.34469746E-07_JPRB, 0.34550315E-07_JPRB, &
  & 0.34696267E-07_JPRB, 0.34978555E-07_JPRB, 0.35263827E-07_JPRB, 0.35472787E-07_JPRB, 0.35817848E-07_JPRB, 0.36056132E-07_JPRB, &
  & 0.36467366E-07_JPRB, 0.36818847E-07_JPRB, 0.37255514E-07_JPRB, 0.37741046E-07_JPRB, 0.38259806E-07_JPRB, 0.38812434E-07_JPRB, &
  & 0.39428034E-07_JPRB, 0.40017433E-07_JPRB, 0.40661810E-07_JPRB, 0.41236227E-07_JPRB, 0.41826983E-07_JPRB, 0.42370846E-07_JPRB, &
  & 0.42928207E-07_JPRB, 0.43476188E-07_JPRB, 0.44055191E-07_JPRB, 0.44654428E-07_JPRB, 0.45304418E-07_JPRB, 0.45984077E-07_JPRB, &
  & 0.46706401E-07_JPRB, 0.47449941E-07_JPRB, 0.48194011E-07_JPRB, 0.48942884E-07_JPRB, 0.49714945E-07_JPRB, 0.50538233E-07_JPRB, &
  & 0.51392476E-07_JPRB, 0.52241827E-07_JPRB, 0.53062475E-07_JPRB, 0.53827339E-07_JPRB, 0.54573150E-07_JPRB, 0.55305986E-07_JPRB, &
  & 0.56022042E-07_JPRB, 0.56755855E-07_JPRB, 0.57459566E-07_JPRB, 0.58168705E-07_JPRB, 0.58849473E-07_JPRB, 0.59517269E-07_JPRB, &
  & 0.60147507E-07_JPRB, 0.60751084E-07_JPRB, 0.61323455E-07_JPRB, 0.61905055E-07_JPRB, 0.62367015E-07_JPRB, 0.62977307E-07_JPRB, &
  & 0.63275280E-07_JPRB, 0.63976714E-07_JPRB, 0.64120762E-07_JPRB, 0.64925395E-07_JPRB, 0.64725498E-07_JPRB, 0.65642247E-07_JPRB, &
  & 0.65116183E-07_JPRB, 0.66108839E-07_JPRB, 0.65353923E-07_JPRB, 0.66183745E-07_JPRB /)

RGHG7(:,87, 6) = (/ &
  & 0.34575905E-07_JPRB, 0.33864403E-07_JPRB, 0.34704609E-07_JPRB, 0.34053642E-07_JPRB, 0.34572768E-07_JPRB, 0.34466574E-07_JPRB, &
  & 0.34773354E-07_JPRB, 0.35047645E-07_JPRB, 0.35191121E-07_JPRB, 0.35595203E-07_JPRB, 0.35795622E-07_JPRB, 0.36147391E-07_JPRB, &
  & 0.36437086E-07_JPRB, 0.36823856E-07_JPRB, 0.37220833E-07_JPRB, 0.37667753E-07_JPRB, 0.38191708E-07_JPRB, 0.38740502E-07_JPRB, &
  & 0.39343618E-07_JPRB, 0.39971024E-07_JPRB, 0.40610633E-07_JPRB, 0.41199268E-07_JPRB, 0.41797740E-07_JPRB, 0.42346652E-07_JPRB, &
  & 0.42904777E-07_JPRB, 0.43453248E-07_JPRB, 0.44033488E-07_JPRB, 0.44645127E-07_JPRB, 0.45291294E-07_JPRB, 0.45986610E-07_JPRB, &
  & 0.46709435E-07_JPRB, 0.47458979E-07_JPRB, 0.48201947E-07_JPRB, 0.48953542E-07_JPRB, 0.49732069E-07_JPRB, 0.50556888E-07_JPRB, &
  & 0.51411870E-07_JPRB, 0.52258216E-07_JPRB, 0.53106177E-07_JPRB, 0.53840381E-07_JPRB, 0.54667787E-07_JPRB, 0.55338514E-07_JPRB, &
  & 0.56115912E-07_JPRB, 0.56806403E-07_JPRB, 0.57511716E-07_JPRB, 0.58200236E-07_JPRB, 0.58871425E-07_JPRB, 0.59515980E-07_JPRB, &
  & 0.60148118E-07_JPRB, 0.60732184E-07_JPRB, 0.61316470E-07_JPRB, 0.61877849E-07_JPRB, 0.62366730E-07_JPRB, 0.62968837E-07_JPRB, &
  & 0.63273838E-07_JPRB, 0.63994854E-07_JPRB, 0.64099090E-07_JPRB, 0.64951706E-07_JPRB, 0.64691704E-07_JPRB, 0.65654412E-07_JPRB, &
  & 0.65099101E-07_JPRB, 0.66105450E-07_JPRB, 0.65347585E-07_JPRB, 0.66191845E-07_JPRB /)

RGHG7(:,88, 6) = (/ &
  & 0.34684017E-07_JPRB, 0.33881680E-07_JPRB, 0.34657926E-07_JPRB, 0.34035953E-07_JPRB, 0.34592055E-07_JPRB, 0.34424065E-07_JPRB, &
  & 0.34868346E-07_JPRB, 0.34960980E-07_JPRB, 0.35376853E-07_JPRB, 0.35529201E-07_JPRB, 0.35827540E-07_JPRB, 0.36114979E-07_JPRB, &
  & 0.36397495E-07_JPRB, 0.36829316E-07_JPRB, 0.37145295E-07_JPRB, 0.37701717E-07_JPRB, 0.38094047E-07_JPRB, 0.38700115E-07_JPRB, &
  & 0.39276081E-07_JPRB, 0.39937760E-07_JPRB, 0.40554436E-07_JPRB, 0.41185416E-07_JPRB, 0.41763180E-07_JPRB, 0.42328971E-07_JPRB, &
  & 0.42875104E-07_JPRB, 0.43430855E-07_JPRB, 0.44009951E-07_JPRB, 0.44620290E-07_JPRB, 0.45275826E-07_JPRB, 0.45971266E-07_JPRB, &
  & 0.46705150E-07_JPRB, 0.47462912E-07_JPRB, 0.48215238E-07_JPRB, 0.48970534E-07_JPRB, 0.49754366E-07_JPRB, 0.50575174E-07_JPRB, &
  & 0.51432689E-07_JPRB, 0.52296496E-07_JPRB, 0.53140948E-07_JPRB, 0.53904390E-07_JPRB, 0.54699676E-07_JPRB, 0.55413999E-07_JPRB, &
  & 0.56162829E-07_JPRB, 0.56883870E-07_JPRB, 0.57559671E-07_JPRB, 0.58234857E-07_JPRB, 0.58889583E-07_JPRB, 0.59531772E-07_JPRB, &
  & 0.60138149E-07_JPRB, 0.60723231E-07_JPRB, 0.61295580E-07_JPRB, 0.61852155E-07_JPRB, 0.62363469E-07_JPRB, 0.62941766E-07_JPRB, &
  & 0.63286230E-07_JPRB, 0.63975413E-07_JPRB, 0.64121615E-07_JPRB, 0.64935108E-07_JPRB, 0.64724851E-07_JPRB, 0.65632939E-07_JPRB, &
  & 0.65133939E-07_JPRB, 0.66077412E-07_JPRB, 0.65379631E-07_JPRB, 0.66164901E-07_JPRB /)

RGHG7(:,89, 6) = (/ &
  & 0.34879971E-07_JPRB, 0.33997466E-07_JPRB, 0.34609570E-07_JPRB, 0.34135542E-07_JPRB, 0.34550773E-07_JPRB, 0.34465828E-07_JPRB, &
  & 0.34798703E-07_JPRB, 0.35028258E-07_JPRB, 0.35247552E-07_JPRB, 0.35493002E-07_JPRB, 0.35775532E-07_JPRB, 0.36014718E-07_JPRB, &
  & 0.36326863E-07_JPRB, 0.36636976E-07_JPRB, 0.37130032E-07_JPRB, 0.37512734E-07_JPRB, 0.38123090E-07_JPRB, 0.38664684E-07_JPRB, &
  & 0.39285869E-07_JPRB, 0.39907974E-07_JPRB, 0.40538474E-07_JPRB, 0.41142176E-07_JPRB, 0.41734872E-07_JPRB, 0.42290893E-07_JPRB, &
  & 0.42842935E-07_JPRB, 0.43396120E-07_JPRB, 0.43974328E-07_JPRB, 0.44587321E-07_JPRB, 0.45245180E-07_JPRB, 0.45949982E-07_JPRB, &
  & 0.46685269E-07_JPRB, 0.47446111E-07_JPRB, 0.48209028E-07_JPRB, 0.48982532E-07_JPRB, 0.49778439E-07_JPRB, 0.50610097E-07_JPRB, &
  & 0.51472153E-07_JPRB, 0.52344067E-07_JPRB, 0.53170634E-07_JPRB, 0.53994814E-07_JPRB, 0.54752284E-07_JPRB, 0.55542216E-07_JPRB, &
  & 0.56217413E-07_JPRB, 0.56986366E-07_JPRB, 0.57608524E-07_JPRB, 0.58280943E-07_JPRB, 0.58912406E-07_JPRB, 0.59537285E-07_JPRB, &
  & 0.60142327E-07_JPRB, 0.60712779E-07_JPRB, 0.61283714E-07_JPRB, 0.61829049E-07_JPRB, 0.62359845E-07_JPRB, 0.62919497E-07_JPRB, &
  & 0.63313017E-07_JPRB, 0.63947617E-07_JPRB, 0.64172220E-07_JPRB, 0.64885477E-07_JPRB, 0.64783507E-07_JPRB, 0.65575158E-07_JPRB, &
  & 0.65188409E-07_JPRB, 0.66026026E-07_JPRB, 0.65425560E-07_JPRB, 0.66132245E-07_JPRB /)

RGHG7(:,90, 6) = (/ &
  & 0.35059927E-07_JPRB, 0.34017546E-07_JPRB, 0.34471128E-07_JPRB, 0.34200124E-07_JPRB, 0.34386616E-07_JPRB, 0.34461987E-07_JPRB, &
  & 0.34682849E-07_JPRB, 0.34884089E-07_JPRB, 0.35145696E-07_JPRB, 0.35399811E-07_JPRB, 0.35616218E-07_JPRB, 0.35918578E-07_JPRB, &
  & 0.36092324E-07_JPRB, 0.36573898E-07_JPRB, 0.37111345E-07_JPRB, 0.37572001E-07_JPRB, 0.38076514E-07_JPRB, 0.38645464E-07_JPRB, &
  & 0.39210519E-07_JPRB, 0.39829693E-07_JPRB, 0.40446885E-07_JPRB, 0.41085471E-07_JPRB, 0.41677183E-07_JPRB, 0.42242863E-07_JPRB, &
  & 0.42789633E-07_JPRB, 0.43338705E-07_JPRB, 0.43910706E-07_JPRB, 0.44518217E-07_JPRB, 0.45180869E-07_JPRB, 0.45894367E-07_JPRB, &
  & 0.46653906E-07_JPRB, 0.47441169E-07_JPRB, 0.48211216E-07_JPRB, 0.49010549E-07_JPRB, 0.49807621E-07_JPRB, 0.50665420E-07_JPRB, &
  & 0.51549296E-07_JPRB, 0.52424280E-07_JPRB, 0.53278043E-07_JPRB, 0.54082889E-07_JPRB, 0.54846826E-07_JPRB, 0.55619619E-07_JPRB, &
  & 0.56315152E-07_JPRB, 0.57002289E-07_JPRB, 0.57682204E-07_JPRB, 0.58276608E-07_JPRB, 0.58930741E-07_JPRB, 0.59549105E-07_JPRB, &
  & 0.60134276E-07_JPRB, 0.60724524E-07_JPRB, 0.61274726E-07_JPRB, 0.61825205E-07_JPRB, 0.62368052E-07_JPRB, 0.62908747E-07_JPRB, &
  & 0.63345574E-07_JPRB, 0.63916652E-07_JPRB, 0.64240425E-07_JPRB, 0.64830573E-07_JPRB, 0.64876836E-07_JPRB, 0.65501879E-07_JPRB, &
  & 0.65284794E-07_JPRB, 0.65949315E-07_JPRB, 0.65510079E-07_JPRB, 0.66073923E-07_JPRB /)

RGHG7(:,91, 6) = (/ &
  & 0.34555477E-07_JPRB, 0.34158433E-07_JPRB, 0.34379013E-07_JPRB, 0.34309515E-07_JPRB, 0.34338143E-07_JPRB, 0.34423699E-07_JPRB, &
  & 0.34509839E-07_JPRB, 0.35054516E-07_JPRB, 0.31989607E-07_JPRB, 0.38114685E-07_JPRB, 0.31560564E-07_JPRB, 0.41134694E-07_JPRB, &
  & 0.35218758E-07_JPRB, 0.35025145E-07_JPRB, 0.37123250E-07_JPRB, 0.37416612E-07_JPRB, 0.37981650E-07_JPRB, 0.38752848E-07_JPRB, &
  & 0.39262726E-07_JPRB, 0.39878636E-07_JPRB, 0.40460783E-07_JPRB, 0.41043737E-07_JPRB, 0.41621799E-07_JPRB, 0.42152337E-07_JPRB, &
  & 0.42683737E-07_JPRB, 0.43232497E-07_JPRB, 0.43810122E-07_JPRB, 0.44430923E-07_JPRB, 0.45082619E-07_JPRB, 0.45788401E-07_JPRB, &
  & 0.46560725E-07_JPRB, 0.47367280E-07_JPRB, 0.48170939E-07_JPRB, 0.49022912E-07_JPRB, 0.49838935E-07_JPRB, 0.50734414E-07_JPRB, &
  & 0.51646502E-07_JPRB, 0.52548735E-07_JPRB, 0.53412336E-07_JPRB, 0.54225644E-07_JPRB, 0.54993297E-07_JPRB, 0.55713851E-07_JPRB, &
  & 0.56399937E-07_JPRB, 0.57090123E-07_JPRB, 0.57690308E-07_JPRB, 0.58277760E-07_JPRB, 0.58912292E-07_JPRB, 0.59581598E-07_JPRB, &
  & 0.60120655E-07_JPRB, 0.60754843E-07_JPRB, 0.61280772E-07_JPRB, 0.61845569E-07_JPRB, 0.62402613E-07_JPRB, 0.62925992E-07_JPRB, &
  & 0.63390495E-07_JPRB, 0.63903911E-07_JPRB, 0.64322712E-07_JPRB, 0.64776714E-07_JPRB, 0.64995355E-07_JPRB, 0.65397060E-07_JPRB, &
  & 0.65440894E-07_JPRB, 0.65806603E-07_JPRB, 0.65680290E-07_JPRB, 0.65943105E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG7(:, 1, 7) = (/ &
  & 0.59957442E-05_JPRB, 0.59850381E-05_JPRB, 0.59779254E-05_JPRB, 0.59683130E-05_JPRB, 0.59596960E-05_JPRB, 0.59522563E-05_JPRB, &
  & 0.15696436E-06_JPRB, 0.65332387E-07_JPRB, 0.64335815E-07_JPRB, 0.63945464E-07_JPRB, 0.63894696E-07_JPRB, 0.64021691E-07_JPRB, &
  & 0.64368642E-07_JPRB, 0.64824128E-07_JPRB, 0.65442855E-07_JPRB, 0.66115341E-07_JPRB, 0.66771783E-07_JPRB, 0.67306431E-07_JPRB, &
  & 0.67799689E-07_JPRB, 0.68208081E-07_JPRB, 0.68526695E-07_JPRB, 0.68762560E-07_JPRB, 0.68925431E-07_JPRB, 0.68972469E-07_JPRB, &
  & 0.69080755E-07_JPRB, 0.69157174E-07_JPRB, 0.69194790E-07_JPRB, 0.69176970E-07_JPRB, 0.69059851E-07_JPRB, 0.68849587E-07_JPRB, &
  & 0.68590822E-07_JPRB, 0.68444074E-07_JPRB, 0.68490230E-07_JPRB, 0.68666225E-07_JPRB, 0.68946370E-07_JPRB, 0.69295830E-07_JPRB, &
  & 0.69661851E-07_JPRB, 0.70048934E-07_JPRB, 0.70348030E-07_JPRB, 0.70461773E-07_JPRB, 0.70543706E-07_JPRB, 0.70692202E-07_JPRB, &
  & 0.70670652E-07_JPRB, 0.70786534E-07_JPRB, 0.70676045E-07_JPRB, 0.70648120E-07_JPRB, 0.70444010E-07_JPRB, 0.70361885E-07_JPRB, &
  & 0.70228140E-07_JPRB, 0.69924830E-07_JPRB, 0.69914968E-07_JPRB, 0.69411591E-07_JPRB, 0.69469067E-07_JPRB, 0.68925836E-07_JPRB, &
  & 0.68941830E-07_JPRB, 0.68548339E-07_JPRB, 0.68627031E-07_JPRB, 0.68525168E-07_JPRB, 0.68790420E-07_JPRB, 0.69625528E-07_JPRB, &
  & 0.71002425E-07_JPRB, 0.73555761E-07_JPRB, 0.77142793E-07_JPRB, 0.81997648E-07_JPRB /)

RGHG7(:, 2, 7) = (/ &
  & 0.64040678E-05_JPRB, 0.68253339E-05_JPRB, 0.71436807E-05_JPRB, 0.74664636E-05_JPRB, 0.79051624E-05_JPRB, 0.84502735E-05_JPRB, &
  & 0.14373812E-05_JPRB, 0.26034104E-06_JPRB, 0.24150239E-06_JPRB, 0.23815907E-06_JPRB, 0.24349441E-06_JPRB, 0.24572827E-06_JPRB, &
  & 0.24890485E-06_JPRB, 0.24686796E-06_JPRB, 0.24676018E-06_JPRB, 0.24502904E-06_JPRB, 0.24176981E-06_JPRB, 0.23604400E-06_JPRB, &
  & 0.23430759E-06_JPRB, 0.23452245E-06_JPRB, 0.23468445E-06_JPRB, 0.23446471E-06_JPRB, 0.23428682E-06_JPRB, 0.22945609E-06_JPRB, &
  & 0.23066590E-06_JPRB, 0.23246460E-06_JPRB, 0.23325926E-06_JPRB, 0.23294105E-06_JPRB, 0.22958470E-06_JPRB, 0.22370850E-06_JPRB, &
  & 0.21731877E-06_JPRB, 0.20653032E-06_JPRB, 0.20208691E-06_JPRB, 0.19960552E-06_JPRB, 0.19890886E-06_JPRB, 0.19992672E-06_JPRB, &
  & 0.20249077E-06_JPRB, 0.20672873E-06_JPRB, 0.21012447E-06_JPRB, 0.21083446E-06_JPRB, 0.21248376E-06_JPRB, 0.21617180E-06_JPRB, &
  & 0.21892765E-06_JPRB, 0.22445195E-06_JPRB, 0.22539936E-06_JPRB, 0.22798575E-06_JPRB, 0.22451891E-06_JPRB, 0.22857699E-06_JPRB, &
  & 0.22702847E-06_JPRB, 0.22719637E-06_JPRB, 0.22127433E-06_JPRB, 0.21609274E-06_JPRB, 0.20842327E-06_JPRB, 0.20095523E-06_JPRB, &
  & 0.19067424E-06_JPRB, 0.18347589E-06_JPRB, 0.18454828E-06_JPRB, 0.18576198E-06_JPRB, 0.18921894E-06_JPRB, 0.20400448E-06_JPRB, &
  & 0.22331790E-06_JPRB, 0.25038457E-06_JPRB, 0.27699292E-06_JPRB, 0.31938845E-06_JPRB /)

RGHG7(:, 3, 7) = (/ &
  & 0.71273366E-05_JPRB, 0.76496681E-05_JPRB, 0.79419387E-05_JPRB, 0.81961716E-05_JPRB, 0.86201835E-05_JPRB, 0.87679527E-05_JPRB, &
  & 0.39827041E-05_JPRB, 0.63404258E-06_JPRB, 0.49247109E-06_JPRB, 0.45035051E-06_JPRB, 0.44926591E-06_JPRB, 0.45076501E-06_JPRB, &
  & 0.45436599E-06_JPRB, 0.44899787E-06_JPRB, 0.44773091E-06_JPRB, 0.44716455E-06_JPRB, 0.44695193E-06_JPRB, 0.43717043E-06_JPRB, &
  & 0.43666850E-06_JPRB, 0.43925655E-06_JPRB, 0.44341539E-06_JPRB, 0.44609422E-06_JPRB, 0.44743786E-06_JPRB, 0.43663363E-06_JPRB, &
  & 0.43818241E-06_JPRB, 0.44114935E-06_JPRB, 0.44165313E-06_JPRB, 0.43993478E-06_JPRB, 0.43628822E-06_JPRB, 0.43092138E-06_JPRB, &
  & 0.42313928E-06_JPRB, 0.40667553E-06_JPRB, 0.39843178E-06_JPRB, 0.39444615E-06_JPRB, 0.39305246E-06_JPRB, 0.39430040E-06_JPRB, &
  & 0.39685301E-06_JPRB, 0.40440369E-06_JPRB, 0.40755842E-06_JPRB, 0.40824750E-06_JPRB, 0.40685984E-06_JPRB, 0.41101876E-06_JPRB, &
  & 0.41481667E-06_JPRB, 0.42488523E-06_JPRB, 0.42610469E-06_JPRB, 0.43086567E-06_JPRB, 0.42436139E-06_JPRB, 0.43227143E-06_JPRB, &
  & 0.43376659E-06_JPRB, 0.43900346E-06_JPRB, 0.43305758E-06_JPRB, 0.43191625E-06_JPRB, 0.42688470E-06_JPRB, 0.42884810E-06_JPRB, &
  & 0.42741434E-06_JPRB, 0.43686489E-06_JPRB, 0.47727673E-06_JPRB, 0.49935613E-06_JPRB, 0.51032822E-06_JPRB, 0.54287790E-06_JPRB, &
  & 0.58363787E-06_JPRB, 0.63435880E-06_JPRB, 0.71612737E-06_JPRB, 0.80597175E-06_JPRB /)

RGHG7(:, 4, 7) = (/ &
  & 0.74979039E-05_JPRB, 0.76403703E-05_JPRB, 0.76456581E-05_JPRB, 0.75195353E-05_JPRB, 0.73895603E-05_JPRB, 0.68421518E-05_JPRB, &
  & 0.50079202E-05_JPRB, 0.12208063E-05_JPRB, 0.71815361E-06_JPRB, 0.58144929E-06_JPRB, 0.56128420E-06_JPRB, 0.56717863E-06_JPRB, &
  & 0.58781023E-06_JPRB, 0.61163820E-06_JPRB, 0.63398954E-06_JPRB, 0.65986399E-06_JPRB, 0.67840233E-06_JPRB, 0.68120255E-06_JPRB, &
  & 0.68850983E-06_JPRB, 0.70271039E-06_JPRB, 0.71803026E-06_JPRB, 0.72886678E-06_JPRB, 0.73431164E-06_JPRB, 0.72421983E-06_JPRB, &
  & 0.72541650E-06_JPRB, 0.73435649E-06_JPRB, 0.74203246E-06_JPRB, 0.74715751E-06_JPRB, 0.75098114E-06_JPRB, 0.75235840E-06_JPRB, &
  & 0.75474304E-06_JPRB, 0.74131862E-06_JPRB, 0.73336770E-06_JPRB, 0.73221008E-06_JPRB, 0.73288277E-06_JPRB, 0.73663193E-06_JPRB, &
  & 0.73943892E-06_JPRB, 0.75149251E-06_JPRB, 0.75421497E-06_JPRB, 0.75178957E-06_JPRB, 0.74254308E-06_JPRB, 0.74353079E-06_JPRB, &
  & 0.74514730E-06_JPRB, 0.75831957E-06_JPRB, 0.75492875E-06_JPRB, 0.75568039E-06_JPRB, 0.73728268E-06_JPRB, 0.74270019E-06_JPRB, &
  & 0.73844291E-06_JPRB, 0.74017174E-06_JPRB, 0.72613147E-06_JPRB, 0.72491002E-06_JPRB, 0.71703710E-06_JPRB, 0.71958726E-06_JPRB, &
  & 0.71021918E-06_JPRB, 0.69988408E-06_JPRB, 0.70488858E-06_JPRB, 0.69100423E-06_JPRB, 0.68030664E-06_JPRB, 0.70377143E-06_JPRB, &
  & 0.72936842E-06_JPRB, 0.76823090E-06_JPRB, 0.75394212E-06_JPRB, 0.73644577E-06_JPRB /)

RGHG7(:, 5, 7) = (/ &
  & 0.72168000E-05_JPRB, 0.67718556E-05_JPRB, 0.63977695E-05_JPRB, 0.59781610E-05_JPRB, 0.56912090E-05_JPRB, 0.49160594E-05_JPRB, &
  & 0.40395366E-05_JPRB, 0.18023114E-05_JPRB, 0.10489258E-05_JPRB, 0.89365631E-06_JPRB, 0.88146408E-06_JPRB, 0.88005220E-06_JPRB, &
  & 0.87752750E-06_JPRB, 0.88095851E-06_JPRB, 0.87809298E-06_JPRB, 0.90564072E-06_JPRB, 0.93832779E-06_JPRB, 0.95856080E-06_JPRB, &
  & 0.97319833E-06_JPRB, 0.99929912E-06_JPRB, 0.10246100E-05_JPRB, 0.10426468E-05_JPRB, 0.10505194E-05_JPRB, 0.10437155E-05_JPRB, &
  & 0.10408361E-05_JPRB, 0.10526489E-05_JPRB, 0.10664761E-05_JPRB, 0.10782863E-05_JPRB, 0.10920484E-05_JPRB, 0.11014091E-05_JPRB, &
  & 0.11180197E-05_JPRB, 0.11115409E-05_JPRB, 0.11068697E-05_JPRB, 0.11124350E-05_JPRB, 0.11179239E-05_JPRB, 0.11257681E-05_JPRB, &
  & 0.11290773E-05_JPRB, 0.11436304E-05_JPRB, 0.11435470E-05_JPRB, 0.11353291E-05_JPRB, 0.11164871E-05_JPRB, 0.11117453E-05_JPRB, &
  & 0.11079031E-05_JPRB, 0.11199816E-05_JPRB, 0.11076392E-05_JPRB, 0.11000715E-05_JPRB, 0.10669980E-05_JPRB, 0.10652551E-05_JPRB, &
  & 0.10504687E-05_JPRB, 0.10423048E-05_JPRB, 0.10137906E-05_JPRB, 0.99274314E-06_JPRB, 0.95455914E-06_JPRB, 0.93297160E-06_JPRB, &
  & 0.90627020E-06_JPRB, 0.89524883E-06_JPRB, 0.89448372E-06_JPRB, 0.87395540E-06_JPRB, 0.86581070E-06_JPRB, 0.89661194E-06_JPRB, &
  & 0.94753892E-06_JPRB, 0.10041983E-05_JPRB, 0.11218702E-05_JPRB, 0.12977374E-05_JPRB /)

RGHG7(:, 6, 7) = (/ &
  & 0.64937644E-05_JPRB, 0.54460802E-05_JPRB, 0.48896650E-05_JPRB, 0.43914970E-05_JPRB, 0.40077721E-05_JPRB, 0.34571781E-05_JPRB, &
  & 0.30824626E-05_JPRB, 0.21697201E-05_JPRB, 0.14450162E-05_JPRB, 0.12149623E-05_JPRB, 0.11609608E-05_JPRB, 0.11552515E-05_JPRB, &
  & 0.11660010E-05_JPRB, 0.11975541E-05_JPRB, 0.12076596E-05_JPRB, 0.12304504E-05_JPRB, 0.12559036E-05_JPRB, 0.12802734E-05_JPRB, &
  & 0.12922567E-05_JPRB, 0.13209324E-05_JPRB, 0.13525670E-05_JPRB, 0.13813172E-05_JPRB, 0.13996553E-05_JPRB, 0.14076634E-05_JPRB, &
  & 0.14089568E-05_JPRB, 0.14258883E-05_JPRB, 0.14456671E-05_JPRB, 0.14607133E-05_JPRB, 0.14798933E-05_JPRB, 0.14914754E-05_JPRB, &
  & 0.15161478E-05_JPRB, 0.15129848E-05_JPRB, 0.15090710E-05_JPRB, 0.15213888E-05_JPRB, 0.15342123E-05_JPRB, 0.15498492E-05_JPRB, &
  & 0.15586272E-05_JPRB, 0.15792243E-05_JPRB, 0.15804046E-05_JPRB, 0.15724979E-05_JPRB, 0.15505176E-05_JPRB, 0.15449045E-05_JPRB, &
  & 0.15382493E-05_JPRB, 0.15479432E-05_JPRB, 0.15276408E-05_JPRB, 0.15135406E-05_JPRB, 0.14678360E-05_JPRB, 0.14579355E-05_JPRB, &
  & 0.14302412E-05_JPRB, 0.14116845E-05_JPRB, 0.13677733E-05_JPRB, 0.13398392E-05_JPRB, 0.13114567E-05_JPRB, 0.13102962E-05_JPRB, &
  & 0.12847976E-05_JPRB, 0.12385152E-05_JPRB, 0.11878863E-05_JPRB, 0.11300874E-05_JPRB, 0.10998141E-05_JPRB, 0.11036417E-05_JPRB, &
  & 0.11192277E-05_JPRB, 0.11477775E-05_JPRB, 0.11661073E-05_JPRB, 0.11252654E-05_JPRB /)

RGHG7(:, 7, 7) = (/ &
  & 0.55408677E-05_JPRB, 0.44446442E-05_JPRB, 0.39040783E-05_JPRB, 0.34697373E-05_JPRB, 0.31471470E-05_JPRB, 0.28322654E-05_JPRB, &
  & 0.27021792E-05_JPRB, 0.24708422E-05_JPRB, 0.20940142E-05_JPRB, 0.18908075E-05_JPRB, 0.18006908E-05_JPRB, 0.17477282E-05_JPRB, &
  & 0.17062512E-05_JPRB, 0.16875314E-05_JPRB, 0.16723295E-05_JPRB, 0.16894259E-05_JPRB, 0.17094898E-05_JPRB, 0.17368311E-05_JPRB, &
  & 0.17530842E-05_JPRB, 0.17864428E-05_JPRB, 0.18200165E-05_JPRB, 0.18532646E-05_JPRB, 0.18761752E-05_JPRB, 0.18925829E-05_JPRB, &
  & 0.18924256E-05_JPRB, 0.19082904E-05_JPRB, 0.19274241E-05_JPRB, 0.19404579E-05_JPRB, 0.19593353E-05_JPRB, 0.19685942E-05_JPRB, &
  & 0.19925103E-05_JPRB, 0.19859990E-05_JPRB, 0.19780871E-05_JPRB, 0.19934992E-05_JPRB, 0.20120531E-05_JPRB, 0.20352015E-05_JPRB, &
  & 0.20503394E-05_JPRB, 0.20783848E-05_JPRB, 0.20827567E-05_JPRB, 0.20798395E-05_JPRB, 0.20579951E-05_JPRB, 0.20541620E-05_JPRB, &
  & 0.20467132E-05_JPRB, 0.20518339E-05_JPRB, 0.20255911E-05_JPRB, 0.20042523E-05_JPRB, 0.19461554E-05_JPRB, 0.19243282E-05_JPRB, &
  & 0.18826925E-05_JPRB, 0.18517659E-05_JPRB, 0.17921940E-05_JPRB, 0.17500300E-05_JPRB, 0.16885430E-05_JPRB, 0.16274474E-05_JPRB, &
  & 0.15569029E-05_JPRB, 0.15146659E-05_JPRB, 0.15011742E-05_JPRB, 0.14808176E-05_JPRB, 0.14768368E-05_JPRB, 0.15075786E-05_JPRB, &
  & 0.15563955E-05_JPRB, 0.15998074E-05_JPRB, 0.16956599E-05_JPRB, 0.18181428E-05_JPRB /)

RGHG7(:, 8, 7) = (/ &
  & 0.46796399E-05_JPRB, 0.37315103E-05_JPRB, 0.32860223E-05_JPRB, 0.29735365E-05_JPRB, 0.27665519E-05_JPRB, 0.26481594E-05_JPRB, &
  & 0.26061196E-05_JPRB, 0.27123831E-05_JPRB, 0.27204344E-05_JPRB, 0.26212349E-05_JPRB, 0.25114837E-05_JPRB, 0.24352073E-05_JPRB, &
  & 0.23797845E-05_JPRB, 0.23422238E-05_JPRB, 0.22989241E-05_JPRB, 0.22807949E-05_JPRB, 0.22739518E-05_JPRB, 0.22701358E-05_JPRB, &
  & 0.22579152E-05_JPRB, 0.22728962E-05_JPRB, 0.22941799E-05_JPRB, 0.23198158E-05_JPRB, 0.23392461E-05_JPRB, 0.23579476E-05_JPRB, &
  & 0.23597456E-05_JPRB, 0.23785194E-05_JPRB, 0.24032156E-05_JPRB, 0.24216602E-05_JPRB, 0.24421572E-05_JPRB, 0.24485651E-05_JPRB, &
  & 0.24655928E-05_JPRB, 0.24529263E-05_JPRB, 0.24390251E-05_JPRB, 0.24513067E-05_JPRB, 0.24692420E-05_JPRB, 0.24946373E-05_JPRB, &
  & 0.25140316E-05_JPRB, 0.25478673E-05_JPRB, 0.25557842E-05_JPRB, 0.25615404E-05_JPRB, 0.25422498E-05_JPRB, 0.25409995E-05_JPRB, &
  & 0.25339434E-05_JPRB, 0.25318204E-05_JPRB, 0.25058534E-05_JPRB, 0.24748038E-05_JPRB, 0.24138976E-05_JPRB, 0.23792279E-05_JPRB, &
  & 0.23275686E-05_JPRB, 0.22823303E-05_JPRB, 0.22088370E-05_JPRB, 0.21503536E-05_JPRB, 0.20836842E-05_JPRB, 0.20411660E-05_JPRB, &
  & 0.20049881E-05_JPRB, 0.19569886E-05_JPRB, 0.18969237E-05_JPRB, 0.18340629E-05_JPRB, 0.18115252E-05_JPRB, 0.17777982E-05_JPRB, &
  & 0.18302237E-05_JPRB, 0.17835952E-05_JPRB, 0.18562602E-05_JPRB, 0.17819934E-05_JPRB /)

RGHG7(:, 9, 7) = (/ &
  & 0.39788615E-05_JPRB, 0.32334412E-05_JPRB, 0.29566836E-05_JPRB, 0.28066299E-05_JPRB, 0.27281030E-05_JPRB, 0.27334647E-05_JPRB, &
  & 0.27756791E-05_JPRB, 0.30017193E-05_JPRB, 0.33146146E-05_JPRB, 0.34585573E-05_JPRB, 0.34422130E-05_JPRB, 0.33639749E-05_JPRB, &
  & 0.32545859E-05_JPRB, 0.31624543E-05_JPRB, 0.30796280E-05_JPRB, 0.30202300E-05_JPRB, 0.29811583E-05_JPRB, 0.29459393E-05_JPRB, &
  & 0.29062705E-05_JPRB, 0.28877232E-05_JPRB, 0.28832374E-05_JPRB, 0.28906989E-05_JPRB, 0.29009429E-05_JPRB, 0.29152268E-05_JPRB, &
  & 0.29155160E-05_JPRB, 0.29372020E-05_JPRB, 0.29675373E-05_JPRB, 0.29904056E-05_JPRB, 0.30123304E-05_JPRB, 0.30205595E-05_JPRB, &
  & 0.30358083E-05_JPRB, 0.30199606E-05_JPRB, 0.30005156E-05_JPRB, 0.30073343E-05_JPRB, 0.30223584E-05_JPRB, 0.30493106E-05_JPRB, &
  & 0.30729852E-05_JPRB, 0.31109469E-05_JPRB, 0.31248235E-05_JPRB, 0.31370841E-05_JPRB, 0.31198363E-05_JPRB, 0.31197803E-05_JPRB, &
  & 0.31097359E-05_JPRB, 0.31013140E-05_JPRB, 0.30687806E-05_JPRB, 0.30238953E-05_JPRB, 0.29590767E-05_JPRB, 0.29032162E-05_JPRB, &
  & 0.28387103E-05_JPRB, 0.27718061E-05_JPRB, 0.26804560E-05_JPRB, 0.26040095E-05_JPRB, 0.25200113E-05_JPRB, 0.24474080E-05_JPRB, &
  & 0.23643988E-05_JPRB, 0.22875597E-05_JPRB, 0.22292934E-05_JPRB, 0.21843434E-05_JPRB, 0.21706701E-05_JPRB, 0.21443332E-05_JPRB, &
  & 0.21814733E-05_JPRB, 0.21633252E-05_JPRB, 0.22228655E-05_JPRB, 0.22705633E-05_JPRB /)

RGHG7(:,10, 7) = (/ &
  & 0.34075354E-05_JPRB, 0.29740279E-05_JPRB, 0.28605700E-05_JPRB, 0.28259524E-05_JPRB, 0.28496240E-05_JPRB, 0.29255248E-05_JPRB, &
  & 0.30611241E-05_JPRB, 0.33354245E-05_JPRB, 0.37668901E-05_JPRB, 0.41226035E-05_JPRB, 0.43033306E-05_JPRB, 0.43503137E-05_JPRB, &
  & 0.42888005E-05_JPRB, 0.41963076E-05_JPRB, 0.40780110E-05_JPRB, 0.39706506E-05_JPRB, 0.38796093E-05_JPRB, 0.37929256E-05_JPRB, &
  & 0.37069321E-05_JPRB, 0.36437762E-05_JPRB, 0.36033193E-05_JPRB, 0.35805820E-05_JPRB, 0.35709656E-05_JPRB, 0.35771102E-05_JPRB, &
  & 0.35800772E-05_JPRB, 0.35982114E-05_JPRB, 0.36288677E-05_JPRB, 0.36619394E-05_JPRB, 0.36990054E-05_JPRB, 0.37226591E-05_JPRB, &
  & 0.37462594E-05_JPRB, 0.37336390E-05_JPRB, 0.37120740E-05_JPRB, 0.37165955E-05_JPRB, 0.37282919E-05_JPRB, 0.37534576E-05_JPRB, &
  & 0.37750331E-05_JPRB, 0.38105677E-05_JPRB, 0.38221956E-05_JPRB, 0.38294825E-05_JPRB, 0.38094763E-05_JPRB, 0.38012474E-05_JPRB, &
  & 0.37885939E-05_JPRB, 0.37683121E-05_JPRB, 0.37271120E-05_JPRB, 0.36757945E-05_JPRB, 0.36006040E-05_JPRB, 0.35311130E-05_JPRB, &
  & 0.34570705E-05_JPRB, 0.33708679E-05_JPRB, 0.32649082E-05_JPRB, 0.31702689E-05_JPRB, 0.30673725E-05_JPRB, 0.29790947E-05_JPRB, &
  & 0.28917334E-05_JPRB, 0.28144418E-05_JPRB, 0.27493925E-05_JPRB, 0.26912644E-05_JPRB, 0.26524108E-05_JPRB, 0.26175508E-05_JPRB, &
  & 0.26316159E-05_JPRB, 0.26248724E-05_JPRB, 0.26786220E-05_JPRB, 0.27446720E-05_JPRB /)

RGHG7(:,11, 7) = (/ &
  & 0.30304625E-05_JPRB, 0.28719760E-05_JPRB, 0.28669685E-05_JPRB, 0.29113542E-05_JPRB, 0.30069136E-05_JPRB, 0.31277677E-05_JPRB, &
  & 0.33261713E-05_JPRB, 0.36174770E-05_JPRB, 0.40680616E-05_JPRB, 0.45372053E-05_JPRB, 0.49076148E-05_JPRB, 0.51381890E-05_JPRB, &
  & 0.52236701E-05_JPRB, 0.52313499E-05_JPRB, 0.51637376E-05_JPRB, 0.50718254E-05_JPRB, 0.49665514E-05_JPRB, 0.48525303E-05_JPRB, &
  & 0.47222434E-05_JPRB, 0.46120376E-05_JPRB, 0.45241231E-05_JPRB, 0.44623694E-05_JPRB, 0.44243980E-05_JPRB, 0.43993673E-05_JPRB, &
  & 0.43746836E-05_JPRB, 0.43941582E-05_JPRB, 0.44413209E-05_JPRB, 0.44906933E-05_JPRB, 0.45424599E-05_JPRB, 0.45832353E-05_JPRB, &
  & 0.46248774E-05_JPRB, 0.46274426E-05_JPRB, 0.46197233E-05_JPRB, 0.46288860E-05_JPRB, 0.46395689E-05_JPRB, 0.46546243E-05_JPRB, &
  & 0.46609684E-05_JPRB, 0.46752502E-05_JPRB, 0.46662994E-05_JPRB, 0.46514779E-05_JPRB, 0.46121199E-05_JPRB, 0.45872443E-05_JPRB, &
  & 0.45599695E-05_JPRB, 0.45238626E-05_JPRB, 0.44752242E-05_JPRB, 0.44101612E-05_JPRB, 0.43230734E-05_JPRB, 0.42449992E-05_JPRB, &
  & 0.41624144E-05_JPRB, 0.40684331E-05_JPRB, 0.39604433E-05_JPRB, 0.38642274E-05_JPRB, 0.37627142E-05_JPRB, 0.36773886E-05_JPRB, &
  & 0.35933188E-05_JPRB, 0.35174110E-05_JPRB, 0.34533962E-05_JPRB, 0.33989245E-05_JPRB, 0.33598637E-05_JPRB, 0.33364117E-05_JPRB, &
  & 0.33497276E-05_JPRB, 0.33626925E-05_JPRB, 0.34221644E-05_JPRB, 0.35309238E-05_JPRB /)

RGHG7(:,12, 7) = (/ &
  & 0.28841960E-05_JPRB, 0.29238636E-05_JPRB, 0.29957187E-05_JPRB, 0.30883241E-05_JPRB, 0.31959569E-05_JPRB, 0.33402653E-05_JPRB, &
  & 0.35226740E-05_JPRB, 0.38053026E-05_JPRB, 0.42299512E-05_JPRB, 0.47099529E-05_JPRB, 0.51583365E-05_JPRB, 0.55210940E-05_JPRB, &
  & 0.57662578E-05_JPRB, 0.59162330E-05_JPRB, 0.59687522E-05_JPRB, 0.59644099E-05_JPRB, 0.59155873E-05_JPRB, 0.58357437E-05_JPRB, &
  & 0.57185412E-05_JPRB, 0.56036351E-05_JPRB, 0.55014716E-05_JPRB, 0.54184511E-05_JPRB, 0.53578410E-05_JPRB, 0.53262897E-05_JPRB, &
  & 0.53094127E-05_JPRB, 0.53117096E-05_JPRB, 0.53397407E-05_JPRB, 0.53985514E-05_JPRB, 0.54761563E-05_JPRB, 0.55489563E-05_JPRB, &
  & 0.56246868E-05_JPRB, 0.56621611E-05_JPRB, 0.56846175E-05_JPRB, 0.57105603E-05_JPRB, 0.57317484E-05_JPRB, 0.57348589E-05_JPRB, &
  & 0.57276038E-05_JPRB, 0.57066959E-05_JPRB, 0.56681793E-05_JPRB, 0.56181025E-05_JPRB, 0.55491191E-05_JPRB, 0.54989709E-05_JPRB, &
  & 0.54505467E-05_JPRB, 0.53974290E-05_JPRB, 0.53331928E-05_JPRB, 0.52542869E-05_JPRB, 0.51573538E-05_JPRB, 0.50716162E-05_JPRB, &
  & 0.49823252E-05_JPRB, 0.48814168E-05_JPRB, 0.47691788E-05_JPRB, 0.46679361E-05_JPRB, 0.45613547E-05_JPRB, 0.44712797E-05_JPRB, &
  & 0.43830960E-05_JPRB, 0.43023183E-05_JPRB, 0.42333177E-05_JPRB, 0.41721291E-05_JPRB, 0.41263788E-05_JPRB, 0.41074650E-05_JPRB, &
  & 0.41143944E-05_JPRB, 0.41321432E-05_JPRB, 0.41773042E-05_JPRB, 0.42696010E-05_JPRB /)

RGHG7(:,13, 7) = (/ &
  & 0.30396961E-05_JPRB, 0.31777524E-05_JPRB, 0.32823077E-05_JPRB, 0.33722642E-05_JPRB, 0.34681168E-05_JPRB, 0.35785529E-05_JPRB, &
  & 0.37174268E-05_JPRB, 0.39300298E-05_JPRB, 0.42889696E-05_JPRB, 0.47095368E-05_JPRB, 0.51267975E-05_JPRB, 0.54901338E-05_JPRB, &
  & 0.57741754E-05_JPRB, 0.59865424E-05_JPRB, 0.61218293E-05_JPRB, 0.62076092E-05_JPRB, 0.62510494E-05_JPRB, 0.62588488E-05_JPRB, &
  & 0.62304894E-05_JPRB, 0.61936266E-05_JPRB, 0.61616947E-05_JPRB, 0.61380692E-05_JPRB, 0.61268347E-05_JPRB, 0.61179799E-05_JPRB, &
  & 0.61108235E-05_JPRB, 0.61417722E-05_JPRB, 0.62031163E-05_JPRB, 0.62746121E-05_JPRB, 0.63664406E-05_JPRB, 0.64638357E-05_JPRB, &
  & 0.65716140E-05_JPRB, 0.66508605E-05_JPRB, 0.67129627E-05_JPRB, 0.67723072E-05_JPRB, 0.68174945E-05_JPRB, 0.68302616E-05_JPRB, &
  & 0.68185227E-05_JPRB, 0.67721444E-05_JPRB, 0.67043770E-05_JPRB, 0.66149319E-05_JPRB, 0.65118652E-05_JPRB, 0.64287910E-05_JPRB, &
  & 0.63501520E-05_JPRB, 0.62724694E-05_JPRB, 0.61880100E-05_JPRB, 0.60903567E-05_JPRB, 0.59803001E-05_JPRB, 0.58826540E-05_JPRB, &
  & 0.57837697E-05_JPRB, 0.56769081E-05_JPRB, 0.55612009E-05_JPRB, 0.54547259E-05_JPRB, 0.53409476E-05_JPRB, 0.52397695E-05_JPRB, &
  & 0.51348184E-05_JPRB, 0.50302378E-05_JPRB, 0.49296591E-05_JPRB, 0.48295747E-05_JPRB, 0.47471131E-05_JPRB, 0.46987234E-05_JPRB, &
  & 0.46724485E-05_JPRB, 0.46636633E-05_JPRB, 0.46751034E-05_JPRB, 0.47261551E-05_JPRB /)

RGHG7(:,14, 7) = (/ &
  & 0.35246931E-05_JPRB, 0.36406809E-05_JPRB, 0.37409550E-05_JPRB, 0.37868108E-05_JPRB, 0.38405146E-05_JPRB, 0.38984945E-05_JPRB, &
  & 0.39750371E-05_JPRB, 0.40897767E-05_JPRB, 0.43576920E-05_JPRB, 0.46852660E-05_JPRB, 0.50323570E-05_JPRB, 0.53634421E-05_JPRB, &
  & 0.56561207E-05_JPRB, 0.59067984E-05_JPRB, 0.60981347E-05_JPRB, 0.62457107E-05_JPRB, 0.63578013E-05_JPRB, 0.64356495E-05_JPRB, &
  & 0.64837072E-05_JPRB, 0.65202826E-05_JPRB, 0.65630402E-05_JPRB, 0.66058328E-05_JPRB, 0.66554248E-05_JPRB, 0.67077135E-05_JPRB, &
  & 0.67591031E-05_JPRB, 0.68140976E-05_JPRB, 0.68908976E-05_JPRB, 0.69901780E-05_JPRB, 0.71130376E-05_JPRB, 0.72456860E-05_JPRB, &
  & 0.73889137E-05_JPRB, 0.75128232E-05_JPRB, 0.76234946E-05_JPRB, 0.77220348E-05_JPRB, 0.77956811E-05_JPRB, 0.78240782E-05_JPRB, &
  & 0.78137336E-05_JPRB, 0.77607110E-05_JPRB, 0.76743581E-05_JPRB, 0.75619118E-05_JPRB, 0.74343989E-05_JPRB, 0.73227689E-05_JPRB, &
  & 0.72168032E-05_JPRB, 0.71087275E-05_JPRB, 0.69963176E-05_JPRB, 0.68743784E-05_JPRB, 0.67458486E-05_JPRB, 0.66299067E-05_JPRB, &
  & 0.65158292E-05_JPRB, 0.63953735E-05_JPRB, 0.62673671E-05_JPRB, 0.61449637E-05_JPRB, 0.60118291E-05_JPRB, 0.58844462E-05_JPRB, &
  & 0.57468328E-05_JPRB, 0.56029062E-05_JPRB, 0.54551901E-05_JPRB, 0.53039744E-05_JPRB, 0.51767161E-05_JPRB, 0.50896288E-05_JPRB, &
  & 0.50273256E-05_JPRB, 0.49868663E-05_JPRB, 0.49661262E-05_JPRB, 0.49717978E-05_JPRB /)

RGHG7(:,15, 7) = (/ &
  & 0.40834025E-05_JPRB, 0.40866357E-05_JPRB, 0.41408425E-05_JPRB, 0.41474332E-05_JPRB, 0.41673698E-05_JPRB, 0.41919006E-05_JPRB, &
  & 0.42244033E-05_JPRB, 0.42890574E-05_JPRB, 0.44690464E-05_JPRB, 0.47407593E-05_JPRB, 0.50302483E-05_JPRB, 0.53166846E-05_JPRB, &
  & 0.55824189E-05_JPRB, 0.58294695E-05_JPRB, 0.60453563E-05_JPRB, 0.62315062E-05_JPRB, 0.63930192E-05_JPRB, 0.65244453E-05_JPRB, &
  & 0.66340681E-05_JPRB, 0.67335814E-05_JPRB, 0.68335726E-05_JPRB, 0.69300609E-05_JPRB, 0.70259716E-05_JPRB, 0.71179456E-05_JPRB, &
  & 0.72099060E-05_JPRB, 0.73170822E-05_JPRB, 0.74377886E-05_JPRB, 0.75692592E-05_JPRB, 0.77192035E-05_JPRB, 0.78780758E-05_JPRB, &
  & 0.80487171E-05_JPRB, 0.81964690E-05_JPRB, 0.83197974E-05_JPRB, 0.84261937E-05_JPRB, 0.85039974E-05_JPRB, 0.85357497E-05_JPRB, &
  & 0.85267693E-05_JPRB, 0.84760386E-05_JPRB, 0.83882414E-05_JPRB, 0.82748684E-05_JPRB, 0.81442167E-05_JPRB, 0.80225673E-05_JPRB, &
  & 0.78996336E-05_JPRB, 0.77721297E-05_JPRB, 0.76374827E-05_JPRB, 0.74931218E-05_JPRB, 0.73428287E-05_JPRB, 0.72044259E-05_JPRB, &
  & 0.70663582E-05_JPRB, 0.69215434E-05_JPRB, 0.67704018E-05_JPRB, 0.66227326E-05_JPRB, 0.64640080E-05_JPRB, 0.63072907E-05_JPRB, &
  & 0.61366177E-05_JPRB, 0.59543236E-05_JPRB, 0.57618349E-05_JPRB, 0.55638857E-05_JPRB, 0.53947037E-05_JPRB, 0.52691225E-05_JPRB, &
  & 0.51729289E-05_JPRB, 0.51026555E-05_JPRB, 0.50543590E-05_JPRB, 0.50237472E-05_JPRB /)

RGHG7(:,16, 7) = (/ &
  & 0.43743571E-05_JPRB, 0.43800883E-05_JPRB, 0.43788668E-05_JPRB, 0.43853743E-05_JPRB, 0.43825285E-05_JPRB, 0.43893174E-05_JPRB, &
  & 0.43986333E-05_JPRB, 0.44271187E-05_JPRB, 0.45445377E-05_JPRB, 0.47640942E-05_JPRB, 0.50193357E-05_JPRB, 0.52761570E-05_JPRB, &
  & 0.55236665E-05_JPRB, 0.57616257E-05_JPRB, 0.59833578E-05_JPRB, 0.61928522E-05_JPRB, 0.63903567E-05_JPRB, 0.65675144E-05_JPRB, &
  & 0.67237888E-05_JPRB, 0.68699296E-05_JPRB, 0.70100605E-05_JPRB, 0.71476647E-05_JPRB, 0.72836751E-05_JPRB, 0.74209456E-05_JPRB, &
  & 0.75547905E-05_JPRB, 0.77006280E-05_JPRB, 0.78626035E-05_JPRB, 0.80314512E-05_JPRB, 0.82071620E-05_JPRB, 0.83752084E-05_JPRB, &
  & 0.85430547E-05_JPRB, 0.86856408E-05_JPRB, 0.88004899E-05_JPRB, 0.88925199E-05_JPRB, 0.89528576E-05_JPRB, 0.89751175E-05_JPRB, &
  & 0.89654222E-05_JPRB, 0.89233772E-05_JPRB, 0.88474808E-05_JPRB, 0.87491753E-05_JPRB, 0.86303717E-05_JPRB, 0.85096799E-05_JPRB, &
  & 0.83802379E-05_JPRB, 0.82370925E-05_JPRB, 0.80799882E-05_JPRB, 0.79123120E-05_JPRB, 0.77379864E-05_JPRB, 0.75707012E-05_JPRB, &
  & 0.74032955E-05_JPRB, 0.72292337E-05_JPRB, 0.70507544E-05_JPRB, 0.68750242E-05_JPRB, 0.66892408E-05_JPRB, 0.65026561E-05_JPRB, &
  & 0.63007624E-05_JPRB, 0.60851453E-05_JPRB, 0.58577511E-05_JPRB, 0.56273416E-05_JPRB, 0.54318261E-05_JPRB, 0.52836067E-05_JPRB, &
  & 0.51699894E-05_JPRB, 0.50863418E-05_JPRB, 0.50292624E-05_JPRB, 0.49890741E-05_JPRB /)

RGHG7(:,17, 7) = (/ &
  & 0.45802522E-05_JPRB, 0.45884494E-05_JPRB, 0.45685019E-05_JPRB, 0.45643496E-05_JPRB, 0.45490851E-05_JPRB, 0.45371194E-05_JPRB, &
  & 0.45198585E-05_JPRB, 0.45184838E-05_JPRB, 0.45873276E-05_JPRB, 0.47592753E-05_JPRB, 0.49911532E-05_JPRB, 0.52402747E-05_JPRB, &
  & 0.54844222E-05_JPRB, 0.57286238E-05_JPRB, 0.59721910E-05_JPRB, 0.62096397E-05_JPRB, 0.64401802E-05_JPRB, 0.66548173E-05_JPRB, &
  & 0.68513209E-05_JPRB, 0.70371711E-05_JPRB, 0.72141802E-05_JPRB, 0.73883853E-05_JPRB, 0.75632997E-05_JPRB, 0.77448749E-05_JPRB, &
  & 0.79304918E-05_JPRB, 0.81288208E-05_JPRB, 0.83388168E-05_JPRB, 0.85458350E-05_JPRB, 0.87424387E-05_JPRB, 0.89119385E-05_JPRB, &
  & 0.90529029E-05_JPRB, 0.91556949E-05_JPRB, 0.92157270E-05_JPRB, 0.92559949E-05_JPRB, 0.92765758E-05_JPRB, 0.92701530E-05_JPRB, &
  & 0.92403443E-05_JPRB, 0.91957936E-05_JPRB, 0.91348966E-05_JPRB, 0.90592384E-05_JPRB, 0.89676405E-05_JPRB, 0.88658053E-05_JPRB, &
  & 0.87467961E-05_JPRB, 0.86074551E-05_JPRB, 0.84430112E-05_JPRB, 0.82625829E-05_JPRB, 0.80715008E-05_JPRB, 0.78781723E-05_JPRB, &
  & 0.76817960E-05_JPRB, 0.74774775E-05_JPRB, 0.72685589E-05_JPRB, 0.70606338E-05_JPRB, 0.68429194E-05_JPRB, 0.66230300E-05_JPRB, &
  & 0.63891171E-05_JPRB, 0.61433248E-05_JPRB, 0.58885294E-05_JPRB, 0.56360986E-05_JPRB, 0.54239372E-05_JPRB, 0.52622381E-05_JPRB, &
  & 0.51391476E-05_JPRB, 0.50498716E-05_JPRB, 0.49888081E-05_JPRB, 0.49436812E-05_JPRB /)

RGHG7(:,18, 7) = (/ &
  & 0.47616313E-05_JPRB, 0.47481308E-05_JPRB, 0.47238636E-05_JPRB, 0.47057456E-05_JPRB, 0.46804403E-05_JPRB, 0.46485120E-05_JPRB, &
  & 0.46057576E-05_JPRB, 0.45769780E-05_JPRB, 0.46178438E-05_JPRB, 0.47533053E-05_JPRB, 0.49764012E-05_JPRB, 0.52310438E-05_JPRB, &
  & 0.54917896E-05_JPRB, 0.57515904E-05_JPRB, 0.60139450E-05_JPRB, 0.62822182E-05_JPRB, 0.65473459E-05_JPRB, 0.67975793E-05_JPRB, &
  & 0.70272004E-05_JPRB, 0.72442886E-05_JPRB, 0.74520021E-05_JPRB, 0.76562983E-05_JPRB, 0.78609246E-05_JPRB, 0.80714699E-05_JPRB, &
  & 0.82839979E-05_JPRB, 0.85019628E-05_JPRB, 0.87125900E-05_JPRB, 0.89046107E-05_JPRB, 0.90696276E-05_JPRB, 0.92026448E-05_JPRB, &
  & 0.92998043E-05_JPRB, 0.93601848E-05_JPRB, 0.93804993E-05_JPRB, 0.93818153E-05_JPRB, 0.93654498E-05_JPRB, 0.93381768E-05_JPRB, &
  & 0.93080416E-05_JPRB, 0.92772570E-05_JPRB, 0.92321679E-05_JPRB, 0.91770462E-05_JPRB, 0.91063475E-05_JPRB, 0.90235972E-05_JPRB, &
  & 0.89195837E-05_JPRB, 0.87910921E-05_JPRB, 0.86318696E-05_JPRB, 0.84496769E-05_JPRB, 0.82526285E-05_JPRB, 0.80454993E-05_JPRB, &
  & 0.78311205E-05_JPRB, 0.76063998E-05_JPRB, 0.73753617E-05_JPRB, 0.71420827E-05_JPRB, 0.68986114E-05_JPRB, 0.66517555E-05_JPRB, &
  & 0.63927068E-05_JPRB, 0.61253149E-05_JPRB, 0.58540950E-05_JPRB, 0.55919427E-05_JPRB, 0.53749172E-05_JPRB, 0.52104074E-05_JPRB, &
  & 0.50879294E-05_JPRB, 0.50017006E-05_JPRB, 0.49422279E-05_JPRB, 0.49038431E-05_JPRB /)

RGHG7(:,19, 7) = (/ &
  & 0.49015125E-05_JPRB, 0.48775082E-05_JPRB, 0.48494308E-05_JPRB, 0.48212692E-05_JPRB, 0.47855151E-05_JPRB, 0.47366393E-05_JPRB, &
  & 0.46674149E-05_JPRB, 0.46139253E-05_JPRB, 0.46357277E-05_JPRB, 0.47478597E-05_JPRB, 0.49520536E-05_JPRB, 0.52124669E-05_JPRB, &
  & 0.54924176E-05_JPRB, 0.57770403E-05_JPRB, 0.60622106E-05_JPRB, 0.63447546E-05_JPRB, 0.66198108E-05_JPRB, 0.68749478E-05_JPRB, &
  & 0.71033110E-05_JPRB, 0.73096057E-05_JPRB, 0.75004832E-05_JPRB, 0.76839615E-05_JPRB, 0.78595740E-05_JPRB, 0.80283098E-05_JPRB, &
  & 0.81881271E-05_JPRB, 0.83410905E-05_JPRB, 0.84817848E-05_JPRB, 0.86138025E-05_JPRB, 0.87386825E-05_JPRB, 0.88610632E-05_JPRB, &
  & 0.89765181E-05_JPRB, 0.90762187E-05_JPRB, 0.91493503E-05_JPRB, 0.92018890E-05_JPRB, 0.92345399E-05_JPRB, 0.92427799E-05_JPRB, &
  & 0.92322334E-05_JPRB, 0.92081455E-05_JPRB, 0.91688007E-05_JPRB, 0.91151205E-05_JPRB, 0.90479125E-05_JPRB, 0.89665527E-05_JPRB, &
  & 0.88656479E-05_JPRB, 0.87449480E-05_JPRB, 0.85972988E-05_JPRB, 0.84289832E-05_JPRB, 0.82437937E-05_JPRB, 0.80460777E-05_JPRB, &
  & 0.78366393E-05_JPRB, 0.76136166E-05_JPRB, 0.73800666E-05_JPRB, 0.71396439E-05_JPRB, 0.68876152E-05_JPRB, 0.66298098E-05_JPRB, &
  & 0.63609064E-05_JPRB, 0.60860843E-05_JPRB, 0.58114506E-05_JPRB, 0.55513569E-05_JPRB, 0.53390336E-05_JPRB, 0.51795887E-05_JPRB, &
  & 0.50618282E-05_JPRB, 0.49793853E-05_JPRB, 0.49254036E-05_JPRB, 0.48866896E-05_JPRB /)

RGHG7(:,20, 7) = (/ &
  & 0.49888777E-05_JPRB, 0.49613027E-05_JPRB, 0.49320583E-05_JPRB, 0.48974111E-05_JPRB, 0.48526067E-05_JPRB, 0.47890571E-05_JPRB, &
  & 0.46960508E-05_JPRB, 0.46212217E-05_JPRB, 0.46332602E-05_JPRB, 0.47392182E-05_JPRB, 0.49303540E-05_JPRB, 0.51933193E-05_JPRB, &
  & 0.54842003E-05_JPRB, 0.57785919E-05_JPRB, 0.60670686E-05_JPRB, 0.63438911E-05_JPRB, 0.66004045E-05_JPRB, 0.68269087E-05_JPRB, &
  & 0.70201281E-05_JPRB, 0.71832974E-05_JPRB, 0.73170245E-05_JPRB, 0.74307463E-05_JPRB, 0.75293924E-05_JPRB, 0.76109591E-05_JPRB, &
  & 0.76718479E-05_JPRB, 0.77195509E-05_JPRB, 0.77665518E-05_JPRB, 0.78278354E-05_JPRB, 0.79187002E-05_JPRB, 0.80473237E-05_JPRB, &
  & 0.82098368E-05_JPRB, 0.83901832E-05_JPRB, 0.85649344E-05_JPRB, 0.87200651E-05_JPRB, 0.88439101E-05_JPRB, 0.89202213E-05_JPRB, &
  & 0.89559398E-05_JPRB, 0.89530840E-05_JPRB, 0.89190871E-05_JPRB, 0.88570177E-05_JPRB, 0.87711487E-05_JPRB, 0.86729087E-05_JPRB, &
  & 0.85628171E-05_JPRB, 0.84387593E-05_JPRB, 0.82986089E-05_JPRB, 0.81475282E-05_JPRB, 0.79858573E-05_JPRB, 0.78154035E-05_JPRB, &
  & 0.76336191E-05_JPRB, 0.74373420E-05_JPRB, 0.72273160E-05_JPRB, 0.70072015E-05_JPRB, 0.67720898E-05_JPRB, 0.65275890E-05_JPRB, &
  & 0.62715035E-05_JPRB, 0.60094853E-05_JPRB, 0.57483539E-05_JPRB, 0.55024539E-05_JPRB, 0.53021736E-05_JPRB, 0.51523007E-05_JPRB, &
  & 0.50423810E-05_JPRB, 0.49643249E-05_JPRB, 0.49092901E-05_JPRB, 0.48653023E-05_JPRB /)

RGHG7(:,21, 7) = (/ &
  & 0.50128274E-05_JPRB, 0.49865798E-05_JPRB, 0.49568607E-05_JPRB, 0.49180517E-05_JPRB, 0.48649104E-05_JPRB, 0.47873559E-05_JPRB, &
  & 0.46700870E-05_JPRB, 0.45710731E-05_JPRB, 0.45724032E-05_JPRB, 0.46786968E-05_JPRB, 0.48692723E-05_JPRB, 0.51273892E-05_JPRB, &
  & 0.54209563E-05_JPRB, 0.57196316E-05_JPRB, 0.60018342E-05_JPRB, 0.62564695E-05_JPRB, 0.64772757E-05_JPRB, 0.66570974E-05_JPRB, &
  & 0.67941514E-05_JPRB, 0.68965755E-05_JPRB, 0.69702032E-05_JPRB, 0.70133487E-05_JPRB, 0.70308156E-05_JPRB, 0.70245696E-05_JPRB, &
  & 0.69933726E-05_JPRB, 0.69513762E-05_JPRB, 0.69171510E-05_JPRB, 0.69176590E-05_JPRB, 0.69756161E-05_JPRB, 0.70978840E-05_JPRB, &
  & 0.72834105E-05_JPRB, 0.75158828E-05_JPRB, 0.77675995E-05_JPRB, 0.80169848E-05_JPRB, 0.82306497E-05_JPRB, 0.83843779E-05_JPRB, &
  & 0.84738422E-05_JPRB, 0.85000856E-05_JPRB, 0.84628327E-05_JPRB, 0.83875384E-05_JPRB, 0.82844999E-05_JPRB, 0.81673843E-05_JPRB, &
  & 0.80425853E-05_JPRB, 0.79152669E-05_JPRB, 0.77863624E-05_JPRB, 0.76538063E-05_JPRB, 0.75179587E-05_JPRB, 0.73801866E-05_JPRB, &
  & 0.72363637E-05_JPRB, 0.70801771E-05_JPRB, 0.69112757E-05_JPRB, 0.67296669E-05_JPRB, 0.65308222E-05_JPRB, 0.63199491E-05_JPRB, &
  & 0.60964189E-05_JPRB, 0.58659643E-05_JPRB, 0.56351164E-05_JPRB, 0.54164211E-05_JPRB, 0.52364762E-05_JPRB, 0.51000520E-05_JPRB, &
  & 0.49993168E-05_JPRB, 0.49268115E-05_JPRB, 0.48720194E-05_JPRB, 0.48155684E-05_JPRB /)

RGHG7(:,22, 7) = (/ &
  & 0.49681785E-05_JPRB, 0.49471819E-05_JPRB, 0.49166883E-05_JPRB, 0.48737802E-05_JPRB, 0.48118445E-05_JPRB, 0.47172894E-05_JPRB, &
  & 0.45718007E-05_JPRB, 0.44388025E-05_JPRB, 0.44293524E-05_JPRB, 0.45423053E-05_JPRB, 0.47454864E-05_JPRB, 0.50066683E-05_JPRB, &
  & 0.53009762E-05_JPRB, 0.55925202E-05_JPRB, 0.58596806E-05_JPRB, 0.60875545E-05_JPRB, 0.62690001E-05_JPRB, 0.64023693E-05_JPRB, &
  & 0.64911869E-05_JPRB, 0.65381892E-05_JPRB, 0.65531585E-05_JPRB, 0.65391810E-05_JPRB, 0.64955457E-05_JPRB, 0.64235269E-05_JPRB, &
  & 0.63304878E-05_JPRB, 0.62226500E-05_JPRB, 0.61351689E-05_JPRB, 0.60892476E-05_JPRB, 0.61047504E-05_JPRB, 0.61953870E-05_JPRB, &
  & 0.63645248E-05_JPRB, 0.65954141E-05_JPRB, 0.68695736E-05_JPRB, 0.71547574E-05_JPRB, 0.74162017E-05_JPRB, 0.76197466E-05_JPRB, &
  & 0.77494215E-05_JPRB, 0.77982450E-05_JPRB, 0.77850964E-05_JPRB, 0.77089571E-05_JPRB, 0.76023061E-05_JPRB, 0.74793857E-05_JPRB, &
  & 0.73580704E-05_JPRB, 0.72373177E-05_JPRB, 0.71211766E-05_JPRB, 0.70108244E-05_JPRB, 0.69057965E-05_JPRB, 0.68056470E-05_JPRB, &
  & 0.67020314E-05_JPRB, 0.65910931E-05_JPRB, 0.64696078E-05_JPRB, 0.63357566E-05_JPRB, 0.61848646E-05_JPRB, 0.60201010E-05_JPRB, &
  & 0.58413020E-05_JPRB, 0.56535714E-05_JPRB, 0.54627917E-05_JPRB, 0.52800096E-05_JPRB, 0.51266979E-05_JPRB, 0.50076915E-05_JPRB, &
  & 0.49165506E-05_JPRB, 0.48469583E-05_JPRB, 0.47909148E-05_JPRB, 0.47256199E-05_JPRB /)

RGHG7(:,23, 7) = (/ &
  & 0.48591373E-05_JPRB, 0.48439056E-05_JPRB, 0.48131510E-05_JPRB, 0.47657945E-05_JPRB, 0.46951550E-05_JPRB, 0.45859633E-05_JPRB, &
  & 0.44141120E-05_JPRB, 0.42536512E-05_JPRB, 0.42264746E-05_JPRB, 0.43384102E-05_JPRB, 0.45505326E-05_JPRB, 0.48174370E-05_JPRB, &
  & 0.51076745E-05_JPRB, 0.53927065E-05_JPRB, 0.56445624E-05_JPRB, 0.58477981E-05_JPRB, 0.59963354E-05_JPRB, 0.60896423E-05_JPRB, &
  & 0.61360397E-05_JPRB, 0.61426949E-05_JPRB, 0.61138589E-05_JPRB, 0.60546527E-05_JPRB, 0.59678991E-05_JPRB, 0.58539022E-05_JPRB, &
  & 0.57187499E-05_JPRB, 0.55764667E-05_JPRB, 0.54503289E-05_JPRB, 0.53666695E-05_JPRB, 0.53468166E-05_JPRB, 0.53945364E-05_JPRB, &
  & 0.55130854E-05_JPRB, 0.56946042E-05_JPRB, 0.59273707E-05_JPRB, 0.61797978E-05_JPRB, 0.64287801E-05_JPRB, 0.66332555E-05_JPRB, &
  & 0.67769333E-05_JPRB, 0.68505465E-05_JPRB, 0.68550739E-05_JPRB, 0.68117579E-05_JPRB, 0.67381789E-05_JPRB, 0.66516695E-05_JPRB, &
  & 0.65603886E-05_JPRB, 0.64754363E-05_JPRB, 0.63955135E-05_JPRB, 0.63178786E-05_JPRB, 0.62451923E-05_JPRB, 0.61772298E-05_JPRB, &
  & 0.61098244E-05_JPRB, 0.60378475E-05_JPRB, 0.59567005E-05_JPRB, 0.58645314E-05_JPRB, 0.57570164E-05_JPRB, 0.56366134E-05_JPRB, &
  & 0.55029154E-05_JPRB, 0.53593267E-05_JPRB, 0.52106607E-05_JPRB, 0.50659773E-05_JPRB, 0.49424925E-05_JPRB, 0.48442589E-05_JPRB, &
  & 0.47666617E-05_JPRB, 0.47041881E-05_JPRB, 0.46485593E-05_JPRB, 0.45748056E-05_JPRB /)

RGHG7(:,24, 7) = (/ &
  & 0.46983428E-05_JPRB, 0.46884634E-05_JPRB, 0.46578798E-05_JPRB, 0.46081946E-05_JPRB, 0.45304614E-05_JPRB, 0.44064495E-05_JPRB, &
  & 0.42094707E-05_JPRB, 0.40107889E-05_JPRB, 0.39481397E-05_JPRB, 0.40538625E-05_JPRB, 0.42762163E-05_JPRB, 0.45554584E-05_JPRB, &
  & 0.48466954E-05_JPRB, 0.51219786E-05_JPRB, 0.53571821E-05_JPRB, 0.55358423E-05_JPRB, 0.56541899E-05_JPRB, 0.57152456E-05_JPRB, &
  & 0.57278357E-05_JPRB, 0.57006087E-05_JPRB, 0.56415856E-05_JPRB, 0.55545124E-05_JPRB, 0.54416514E-05_JPRB, 0.53056224E-05_JPRB, &
  & 0.51547763E-05_JPRB, 0.50007511E-05_JPRB, 0.48644870E-05_JPRB, 0.47622634E-05_JPRB, 0.47010740E-05_JPRB, 0.46962964E-05_JPRB, &
  & 0.47481590E-05_JPRB, 0.48516572E-05_JPRB, 0.49983350E-05_JPRB, 0.51723027E-05_JPRB, 0.53525614E-05_JPRB, 0.55112037E-05_JPRB, &
  & 0.56357735E-05_JPRB, 0.57160719E-05_JPRB, 0.57601242E-05_JPRB, 0.57677357E-05_JPRB, 0.57570073E-05_JPRB, 0.57351117E-05_JPRB, &
  & 0.57108168E-05_JPRB, 0.56821782E-05_JPRB, 0.56548765E-05_JPRB, 0.56271142E-05_JPRB, 0.55953783E-05_JPRB, 0.55619635E-05_JPRB, &
  & 0.55248188E-05_JPRB, 0.54805460E-05_JPRB, 0.54282696E-05_JPRB, 0.53667682E-05_JPRB, 0.52938626E-05_JPRB, 0.52104992E-05_JPRB, &
  & 0.51157235E-05_JPRB, 0.50117842E-05_JPRB, 0.49019650E-05_JPRB, 0.47930703E-05_JPRB, 0.46978171E-05_JPRB, 0.46199157E-05_JPRB, &
  & 0.45562924E-05_JPRB, 0.45026077E-05_JPRB, 0.44536955E-05_JPRB, 0.43880709E-05_JPRB /)

RGHG7(:,25, 7) = (/ &
  & 0.44940584E-05_JPRB, 0.44910548E-05_JPRB, 0.44626181E-05_JPRB, 0.44128460E-05_JPRB, 0.43337441E-05_JPRB, 0.42061324E-05_JPRB, &
  & 0.40022805E-05_JPRB, 0.37915293E-05_JPRB, 0.37132659E-05_JPRB, 0.38008413E-05_JPRB, 0.40060613E-05_JPRB, 0.42705528E-05_JPRB, &
  & 0.45447373E-05_JPRB, 0.47959475E-05_JPRB, 0.50033300E-05_JPRB, 0.51513139E-05_JPRB, 0.52384421E-05_JPRB, 0.52690098E-05_JPRB, &
  & 0.52534988E-05_JPRB, 0.52009373E-05_JPRB, 0.51192746E-05_JPRB, 0.50147901E-05_JPRB, 0.48933302E-05_JPRB, 0.47557673E-05_JPRB, &
  & 0.46107475E-05_JPRB, 0.44665217E-05_JPRB, 0.43329810E-05_JPRB, 0.42220549E-05_JPRB, 0.41442427E-05_JPRB, 0.40931423E-05_JPRB, &
  & 0.40765531E-05_JPRB, 0.40944497E-05_JPRB, 0.41428852E-05_JPRB, 0.42188499E-05_JPRB, 0.43094483E-05_JPRB, 0.44070493E-05_JPRB, &
  & 0.44976432E-05_JPRB, 0.45775223E-05_JPRB, 0.46539080E-05_JPRB, 0.47151261E-05_JPRB, 0.47735502E-05_JPRB, 0.48277511E-05_JPRB, &
  & 0.48765701E-05_JPRB, 0.49160249E-05_JPRB, 0.49426271E-05_JPRB, 0.49577066E-05_JPRB, 0.49648916E-05_JPRB, 0.49663654E-05_JPRB, &
  & 0.49576843E-05_JPRB, 0.49400014E-05_JPRB, 0.49122791E-05_JPRB, 0.48760030E-05_JPRB, 0.48299939E-05_JPRB, 0.47751687E-05_JPRB, &
  & 0.47113585E-05_JPRB, 0.46398368E-05_JPRB, 0.45629213E-05_JPRB, 0.44853423E-05_JPRB, 0.44161029E-05_JPRB, 0.43579116E-05_JPRB, &
  & 0.43089367E-05_JPRB, 0.42667575E-05_JPRB, 0.42272200E-05_JPRB, 0.41732515E-05_JPRB /)

RGHG7(:,26, 7) = (/ &
  & 0.42605589E-05_JPRB, 0.42618735E-05_JPRB, 0.42355405E-05_JPRB, 0.41882704E-05_JPRB, 0.41119733E-05_JPRB, 0.39890751E-05_JPRB, &
  & 0.37916061E-05_JPRB, 0.35838191E-05_JPRB, 0.34929481E-05_JPRB, 0.35566950E-05_JPRB, 0.37338496E-05_JPRB, 0.39678648E-05_JPRB, &
  & 0.42093648E-05_JPRB, 0.44239164E-05_JPRB, 0.45913407E-05_JPRB, 0.47016920E-05_JPRB, 0.47538379E-05_JPRB, 0.47539997E-05_JPRB, &
  & 0.47126096E-05_JPRB, 0.46407449E-05_JPRB, 0.45484499E-05_JPRB, 0.44416224E-05_JPRB, 0.43247678E-05_JPRB, 0.42048819E-05_JPRB, &
  & 0.40828231E-05_JPRB, 0.39646520E-05_JPRB, 0.38540948E-05_JPRB, 0.37498769E-05_JPRB, 0.36518031E-05_JPRB, 0.35685559E-05_JPRB, &
  & 0.34966531E-05_JPRB, 0.34398186E-05_JPRB, 0.34031111E-05_JPRB, 0.33913648E-05_JPRB, 0.34030952E-05_JPRB, 0.34387097E-05_JPRB, &
  & 0.34952166E-05_JPRB, 0.35715952E-05_JPRB, 0.36660545E-05_JPRB, 0.37764153E-05_JPRB, 0.38911462E-05_JPRB, 0.40125055E-05_JPRB, &
  & 0.41245912E-05_JPRB, 0.42262996E-05_JPRB, 0.43083037E-05_JPRB, 0.43710575E-05_JPRB, 0.44131198E-05_JPRB, 0.44383473E-05_JPRB, &
  & 0.44500412E-05_JPRB, 0.44493158E-05_JPRB, 0.44385938E-05_JPRB, 0.44191970E-05_JPRB, 0.43916866E-05_JPRB, 0.43573000E-05_JPRB, &
  & 0.43161717E-05_JPRB, 0.42692609E-05_JPRB, 0.42180500E-05_JPRB, 0.41656353E-05_JPRB, 0.41181133E-05_JPRB, 0.40775426E-05_JPRB, &
  & 0.40426930E-05_JPRB, 0.40119817E-05_JPRB, 0.39827792E-05_JPRB, 0.39439192E-05_JPRB /)

RGHG7(:,27, 7) = (/ &
  & 0.40102641E-05_JPRB, 0.40114533E-05_JPRB, 0.39865972E-05_JPRB, 0.39425563E-05_JPRB, 0.38723674E-05_JPRB, 0.37583980E-05_JPRB, &
  & 0.35780317E-05_JPRB, 0.33824751E-05_JPRB, 0.32874100E-05_JPRB, 0.33283666E-05_JPRB, 0.34698635E-05_JPRB, 0.36605720E-05_JPRB, &
  & 0.38565886E-05_JPRB, 0.40244126E-05_JPRB, 0.41450862E-05_JPRB, 0.42121055E-05_JPRB, 0.42266215E-05_JPRB, 0.41968065E-05_JPRB, &
  & 0.41336612E-05_JPRB, 0.40502664E-05_JPRB, 0.39560377E-05_JPRB, 0.38544863E-05_JPRB, 0.37585328E-05_JPRB, 0.36655035E-05_JPRB, &
  & 0.35769197E-05_JPRB, 0.34948596E-05_JPRB, 0.34128605E-05_JPRB, 0.33254660E-05_JPRB, 0.32279777E-05_JPRB, 0.31185102E-05_JPRB, &
  & 0.30032304E-05_JPRB, 0.28911775E-05_JPRB, 0.27930398E-05_JPRB, 0.27199342E-05_JPRB, 0.26779589E-05_JPRB, 0.26723176E-05_JPRB, &
  & 0.27046046E-05_JPRB, 0.27757937E-05_JPRB, 0.28789107E-05_JPRB, 0.30157385E-05_JPRB, 0.31666871E-05_JPRB, 0.33290098E-05_JPRB, &
  & 0.34853113E-05_JPRB, 0.36277870E-05_JPRB, 0.37486923E-05_JPRB, 0.38442599E-05_JPRB, 0.39147294E-05_JPRB, 0.39622678E-05_JPRB, &
  & 0.39905958E-05_JPRB, 0.40036366E-05_JPRB, 0.40049567E-05_JPRB, 0.39979955E-05_JPRB, 0.39842243E-05_JPRB, 0.39652705E-05_JPRB, &
  & 0.39416323E-05_JPRB, 0.39138768E-05_JPRB, 0.38828803E-05_JPRB, 0.38508729E-05_JPRB, 0.38216654E-05_JPRB, 0.37967257E-05_JPRB, &
  & 0.37750608E-05_JPRB, 0.37558361E-05_JPRB, 0.37394293E-05_JPRB, 0.37244840E-05_JPRB /)

RGHG7(:,28, 7) = (/ &
  & 0.37473017E-05_JPRB, 0.37486946E-05_JPRB, 0.37269476E-05_JPRB, 0.36874387E-05_JPRB, 0.36243121E-05_JPRB, 0.35230009E-05_JPRB, &
  & 0.33613608E-05_JPRB, 0.31854138E-05_JPRB, 0.30897879E-05_JPRB, 0.31075715E-05_JPRB, 0.32106225E-05_JPRB, 0.33555104E-05_JPRB, &
  & 0.35017579E-05_JPRB, 0.36202673E-05_JPRB, 0.36935289E-05_JPRB, 0.37177454E-05_JPRB, 0.36971746E-05_JPRB, 0.36410941E-05_JPRB, &
  & 0.35617068E-05_JPRB, 0.34723460E-05_JPRB, 0.33804674E-05_JPRB, 0.32938979E-05_JPRB, 0.32218088E-05_JPRB, 0.31593820E-05_JPRB, &
  & 0.31066927E-05_JPRB, 0.30578476E-05_JPRB, 0.30030808E-05_JPRB, 0.29339049E-05_JPRB, 0.28388426E-05_JPRB, 0.27177991E-05_JPRB, &
  & 0.25808306E-05_JPRB, 0.24364742E-05_JPRB, 0.23021867E-05_JPRB, 0.21940325E-05_JPRB, 0.21226210E-05_JPRB, 0.20950195E-05_JPRB, &
  & 0.21138783E-05_JPRB, 0.21801729E-05_JPRB, 0.22865695E-05_JPRB, 0.24292547E-05_JPRB, 0.25994912E-05_JPRB, 0.27786375E-05_JPRB, &
  & 0.29588457E-05_JPRB, 0.31224292E-05_JPRB, 0.32652165E-05_JPRB, 0.33791155E-05_JPRB, 0.34647378E-05_JPRB, 0.35263597E-05_JPRB, &
  & 0.35671137E-05_JPRB, 0.35913545E-05_JPRB, 0.36038527E-05_JPRB, 0.36080871E-05_JPRB, 0.36063520E-05_JPRB, 0.36005333E-05_JPRB, &
  & 0.35914286E-05_JPRB, 0.35794567E-05_JPRB, 0.35655746E-05_JPRB, 0.35510056E-05_JPRB, 0.35380178E-05_JPRB, 0.35273288E-05_JPRB, &
  & 0.35181699E-05_JPRB, 0.35107671E-05_JPRB, 0.35056703E-05_JPRB, 0.35060382E-05_JPRB /)

RGHG7(:,29, 7) = (/ &
  & 0.34857167E-05_JPRB, 0.34876139E-05_JPRB, 0.34681118E-05_JPRB, 0.34332088E-05_JPRB, 0.33774836E-05_JPRB, 0.32872144E-05_JPRB, &
  & 0.31458615E-05_JPRB, 0.29870687E-05_JPRB, 0.28932941E-05_JPRB, 0.28923246E-05_JPRB, 0.29616374E-05_JPRB, 0.30632066E-05_JPRB, &
  & 0.31623638E-05_JPRB, 0.32340454E-05_JPRB, 0.32642347E-05_JPRB, 0.32509433E-05_JPRB, 0.32009241E-05_JPRB, 0.31246000E-05_JPRB, &
  & 0.30341512E-05_JPRB, 0.29427738E-05_JPRB, 0.28588352E-05_JPRB, 0.27885837E-05_JPRB, 0.27373089E-05_JPRB, 0.27025701E-05_JPRB, &
  & 0.26796909E-05_JPRB, 0.26589482E-05_JPRB, 0.26300365E-05_JPRB, 0.25758518E-05_JPRB, 0.24911062E-05_JPRB, 0.23684865E-05_JPRB, &
  & 0.22187178E-05_JPRB, 0.20595339E-05_JPRB, 0.19085217E-05_JPRB, 0.17850717E-05_JPRB, 0.17015302E-05_JPRB, 0.16651088E-05_JPRB, &
  & 0.16779068E-05_JPRB, 0.17394375E-05_JPRB, 0.18453471E-05_JPRB, 0.19856279E-05_JPRB, 0.21559329E-05_JPRB, 0.23416580E-05_JPRB, &
  & 0.25259824E-05_JPRB, 0.26999382E-05_JPRB, 0.28500035E-05_JPRB, 0.29718433E-05_JPRB, 0.30654464E-05_JPRB, 0.31334819E-05_JPRB, &
  & 0.31810623E-05_JPRB, 0.32135054E-05_JPRB, 0.32350626E-05_JPRB, 0.32492057E-05_JPRB, 0.32581233E-05_JPRB, 0.32638154E-05_JPRB, &
  & 0.32670509E-05_JPRB, 0.32683681E-05_JPRB, 0.32683658E-05_JPRB, 0.32676228E-05_JPRB, 0.32673854E-05_JPRB, 0.32678524E-05_JPRB, &
  & 0.32679807E-05_JPRB, 0.32686462E-05_JPRB, 0.32713215E-05_JPRB, 0.32843532E-05_JPRB /)

RGHG7(:,30, 7) = (/ &
  & 0.32380340E-05_JPRB, 0.32352266E-05_JPRB, 0.32177049E-05_JPRB, 0.31867839E-05_JPRB, 0.31373695E-05_JPRB, 0.30582223E-05_JPRB, &
  & 0.29321602E-05_JPRB, 0.27904453E-05_JPRB, 0.26995215E-05_JPRB, 0.26843868E-05_JPRB, 0.27252995E-05_JPRB, 0.27897902E-05_JPRB, &
  & 0.28480858E-05_JPRB, 0.28795287E-05_JPRB, 0.28737024E-05_JPRB, 0.28307281E-05_JPRB, 0.27583826E-05_JPRB, 0.26679213E-05_JPRB, &
  & 0.25713086E-05_JPRB, 0.24808248E-05_JPRB, 0.24049766E-05_JPRB, 0.23480904E-05_JPRB, 0.23142502E-05_JPRB, 0.23002096E-05_JPRB, &
  & 0.22990082E-05_JPRB, 0.22991430E-05_JPRB, 0.22857605E-05_JPRB, 0.22457134E-05_JPRB, 0.21670521E-05_JPRB, 0.20520283E-05_JPRB, &
  & 0.19035081E-05_JPRB, 0.17417534E-05_JPRB, 0.15880426E-05_JPRB, 0.14621884E-05_JPRB, 0.13772527E-05_JPRB, 0.13396748E-05_JPRB, &
  & 0.13502690E-05_JPRB, 0.14073388E-05_JPRB, 0.15073014E-05_JPRB, 0.16426217E-05_JPRB, 0.18045913E-05_JPRB, 0.19834024E-05_JPRB, &
  & 0.21651224E-05_JPRB, 0.23346813E-05_JPRB, 0.24839433E-05_JPRB, 0.26070918E-05_JPRB, 0.27019328E-05_JPRB, 0.27737321E-05_JPRB, &
  & 0.28263742E-05_JPRB, 0.28654149E-05_JPRB, 0.28949883E-05_JPRB, 0.29178166E-05_JPRB, 0.29363541E-05_JPRB, 0.29521586E-05_JPRB, &
  & 0.29659259E-05_JPRB, 0.29780738E-05_JPRB, 0.29889529E-05_JPRB, 0.29986938E-05_JPRB, 0.30079350E-05_JPRB, 0.30167591E-05_JPRB, &
  & 0.30249003E-05_JPRB, 0.30334177E-05_JPRB, 0.30459908E-05_JPRB, 0.30746685E-05_JPRB /)

RGHG7(:,31, 7) = (/ &
  & 0.29960495E-05_JPRB, 0.29943608E-05_JPRB, 0.29786929E-05_JPRB, 0.29515143E-05_JPRB, 0.29080550E-05_JPRB, 0.28374789E-05_JPRB, &
  & 0.27268034E-05_JPRB, 0.25991842E-05_JPRB, 0.25132144E-05_JPRB, 0.24876799E-05_JPRB, 0.25054685E-05_JPRB, 0.25387747E-05_JPRB, &
  & 0.25628378E-05_JPRB, 0.25613863E-05_JPRB, 0.25272939E-05_JPRB, 0.24624485E-05_JPRB, 0.23748444E-05_JPRB, 0.22759964E-05_JPRB, &
  & 0.21770454E-05_JPRB, 0.20888406E-05_JPRB, 0.20193697E-05_JPRB, 0.19731706E-05_JPRB, 0.19513614E-05_JPRB, 0.19503630E-05_JPRB, &
  & 0.19617514E-05_JPRB, 0.19730792E-05_JPRB, 0.19695501E-05_JPRB, 0.19392171E-05_JPRB, 0.18712196E-05_JPRB, 0.17628220E-05_JPRB, &
  & 0.16224791E-05_JPRB, 0.14673487E-05_JPRB, 0.13197938E-05_JPRB, 0.11999116E-05_JPRB, 0.11200281E-05_JPRB, 0.10852814E-05_JPRB, &
  & 0.10954240E-05_JPRB, 0.11478739E-05_JPRB, 0.12389496E-05_JPRB, 0.13638789E-05_JPRB, 0.15147666E-05_JPRB, 0.16807311E-05_JPRB, &
  & 0.18500386E-05_JPRB, 0.20122784E-05_JPRB, 0.21542803E-05_JPRB, 0.22731765E-05_JPRB, 0.23673836E-05_JPRB, 0.24408937E-05_JPRB, &
  & 0.24978888E-05_JPRB, 0.25428001E-05_JPRB, 0.25801246E-05_JPRB, 0.26113996E-05_JPRB, 0.26388950E-05_JPRB, 0.26637656E-05_JPRB, &
  & 0.26865041E-05_JPRB, 0.27075864E-05_JPRB, 0.27270760E-05_JPRB, 0.27451981E-05_JPRB, 0.27623180E-05_JPRB, 0.27783078E-05_JPRB, &
  & 0.27932915E-05_JPRB, 0.28084928E-05_JPRB, 0.28268155E-05_JPRB, 0.28582658E-05_JPRB /)

RGHG7(:,32, 7) = (/ &
  & 0.27669669E-05_JPRB, 0.27662879E-05_JPRB, 0.27527908E-05_JPRB, 0.27287795E-05_JPRB, 0.26902997E-05_JPRB, 0.26285247E-05_JPRB, &
  & 0.25305094E-05_JPRB, 0.24191456E-05_JPRB, 0.23406030E-05_JPRB, 0.23071984E-05_JPRB, 0.23046603E-05_JPRB, 0.23110640E-05_JPRB, &
  & 0.23064783E-05_JPRB, 0.22787942E-05_JPRB, 0.22236948E-05_JPRB, 0.21440296E-05_JPRB, 0.20473394E-05_JPRB, 0.19444276E-05_JPRB, &
  & 0.18456506E-05_JPRB, 0.17604056E-05_JPRB, 0.16959127E-05_JPRB, 0.16559501E-05_JPRB, 0.16406603E-05_JPRB, 0.16455695E-05_JPRB, &
  & 0.16618905E-05_JPRB, 0.16769192E-05_JPRB, 0.16781408E-05_JPRB, 0.16531731E-05_JPRB, 0.15928312E-05_JPRB, 0.14947869E-05_JPRB, &
  & 0.13665150E-05_JPRB, 0.12235324E-05_JPRB, 0.10884547E-05_JPRB, 0.97972520E-06_JPRB, 0.90874306E-06_JPRB, 0.87908847E-06_JPRB, &
  & 0.88938071E-06_JPRB, 0.93664897E-06_JPRB, 0.10177873E-05_JPRB, 0.11288078E-05_JPRB, 0.12648846E-05_JPRB, 0.14158228E-05_JPRB, &
  & 0.15701681E-05_JPRB, 0.17173187E-05_JPRB, 0.18512504E-05_JPRB, 0.19646261E-05_JPRB, 0.20568361E-05_JPRB, 0.21318633E-05_JPRB, &
  & 0.21933304E-05_JPRB, 0.22446147E-05_JPRB, 0.22890968E-05_JPRB, 0.23285377E-05_JPRB, 0.23643581E-05_JPRB, 0.23972061E-05_JPRB, &
  & 0.24277388E-05_JPRB, 0.24562014E-05_JPRB, 0.24826852E-05_JPRB, 0.25074357E-05_JPRB, 0.25305687E-05_JPRB, 0.25520681E-05_JPRB, &
  & 0.25719048E-05_JPRB, 0.25915213E-05_JPRB, 0.26133869E-05_JPRB, 0.26536511E-05_JPRB /)

RGHG7(:,33, 7) = (/ &
  & 0.25545276E-05_JPRB, 0.25512020E-05_JPRB, 0.25385507E-05_JPRB, 0.25168349E-05_JPRB, 0.24824064E-05_JPRB, 0.24271549E-05_JPRB, &
  & 0.23416619E-05_JPRB, 0.22442780E-05_JPRB, 0.21738379E-05_JPRB, 0.21352712E-05_JPRB, 0.21166779E-05_JPRB, 0.21015474E-05_JPRB, &
  & 0.20748901E-05_JPRB, 0.20280804E-05_JPRB, 0.19587117E-05_JPRB, 0.18704512E-05_JPRB, 0.17696593E-05_JPRB, 0.16660247E-05_JPRB, &
  & 0.15688120E-05_JPRB, 0.14860705E-05_JPRB, 0.14244227E-05_JPRB, 0.13867631E-05_JPRB, 0.13730536E-05_JPRB, 0.13777640E-05_JPRB, &
  & 0.13924149E-05_JPRB, 0.14062932E-05_JPRB, 0.14065442E-05_JPRB, 0.13843541E-05_JPRB, 0.13311080E-05_JPRB, 0.12437408E-05_JPRB, &
  & 0.11289521E-05_JPRB, 0.10023236E-05_JPRB, 0.88339402E-06_JPRB, 0.78945590E-06_JPRB, 0.72962519E-06_JPRB, 0.70619444E-06_JPRB, &
  & 0.71693285E-06_JPRB, 0.75880723E-06_JPRB, 0.82920565E-06_JPRB, 0.92599089E-06_JPRB, 0.10443821E-05_JPRB, 0.11772700E-05_JPRB, &
  & 0.13154213E-05_JPRB, 0.14479396E-05_JPRB, 0.15700916E-05_JPRB, 0.16777391E-05_JPRB, 0.17698679E-05_JPRB, 0.18462858E-05_JPRB, &
  & 0.19116885E-05_JPRB, 0.19698341E-05_JPRB, 0.20217021E-05_JPRB, 0.20687148E-05_JPRB, 0.21121161E-05_JPRB, 0.21521230E-05_JPRB, &
  & 0.21891160E-05_JPRB, 0.22235342E-05_JPRB, 0.22554193E-05_JPRB, 0.22851577E-05_JPRB, 0.23127493E-05_JPRB, 0.23380685E-05_JPRB, &
  & 0.23612972E-05_JPRB, 0.23838359E-05_JPRB, 0.24086823E-05_JPRB, 0.24510716E-05_JPRB /)

RGHG7(:,34, 7) = (/ &
  & 0.23540003E-05_JPRB, 0.23478808E-05_JPRB, 0.23354660E-05_JPRB, 0.23152563E-05_JPRB, 0.22836152E-05_JPRB, 0.22338552E-05_JPRB, &
  & 0.21573112E-05_JPRB, 0.20716589E-05_JPRB, 0.20069840E-05_JPRB, 0.19655197E-05_JPRB, 0.19363542E-05_JPRB, 0.19063735E-05_JPRB, &
  & 0.18648185E-05_JPRB, 0.18057813E-05_JPRB, 0.17281565E-05_JPRB, 0.16357731E-05_JPRB, 0.15346443E-05_JPRB, 0.14324579E-05_JPRB, &
  & 0.13376743E-05_JPRB, 0.12566725E-05_JPRB, 0.11953748E-05_JPRB, 0.11571663E-05_JPRB, 0.11401404E-05_JPRB, 0.11398421E-05_JPRB, &
  & 0.11479519E-05_JPRB, 0.11562480E-05_JPRB, 0.11528550E-05_JPRB, 0.11303642E-05_JPRB, 0.10820094E-05_JPRB, 0.10054476E-05_JPRB, &
  & 0.90645915E-06_JPRB, 0.79824400E-06_JPRB, 0.69860295E-06_JPRB, 0.62157198E-06_JPRB, 0.57418367E-06_JPRB, 0.55762473E-06_JPRB, &
  & 0.56883965E-06_JPRB, 0.60550587E-06_JPRB, 0.66562603E-06_JPRB, 0.74744889E-06_JPRB, 0.84862324E-06_JPRB, 0.96271924E-06_JPRB, &
  & 0.10820251E-05_JPRB, 0.12008688E-05_JPRB, 0.13119680E-05_JPRB, 0.14139013E-05_JPRB, 0.15052451E-05_JPRB, 0.15856573E-05_JPRB, &
  & 0.16551971E-05_JPRB, 0.17195456E-05_JPRB, 0.17782546E-05_JPRB, 0.18322035E-05_JPRB, 0.18821663E-05_JPRB, 0.19280137E-05_JPRB, &
  & 0.19703452E-05_JPRB, 0.20094360E-05_JPRB, 0.20454813E-05_JPRB, 0.20788696E-05_JPRB, 0.21095250E-05_JPRB, 0.21374519E-05_JPRB, &
  & 0.21631063E-05_JPRB, 0.21875808E-05_JPRB, 0.22143720E-05_JPRB, 0.22593813E-05_JPRB /)

RGHG7(:,35, 7) = (/ &
  & 0.21648409E-05_JPRB, 0.21561766E-05_JPRB, 0.21437006E-05_JPRB, 0.21245658E-05_JPRB, 0.20954067E-05_JPRB, 0.20506106E-05_JPRB, &
  & 0.19837921E-05_JPRB, 0.19093081E-05_JPRB, 0.18495969E-05_JPRB, 0.18054857E-05_JPRB, 0.17681623E-05_JPRB, 0.17276060E-05_JPRB, &
  & 0.16760133E-05_JPRB, 0.16097034E-05_JPRB, 0.15281848E-05_JPRB, 0.14350838E-05_JPRB, 0.13356255E-05_JPRB, 0.12363511E-05_JPRB, &
  & 0.11440508E-05_JPRB, 0.10645817E-05_JPRB, 0.10022497E-05_JPRB, 0.95959149E-06_JPRB, 0.93518571E-06_JPRB, 0.92586220E-06_JPRB, &
  & 0.92436881E-06_JPRB, 0.92307096E-06_JPRB, 0.91373499E-06_JPRB, 0.88959922E-06_JPRB, 0.84564323E-06_JPRB, 0.78007304E-06_JPRB, &
  & 0.69790218E-06_JPRB, 0.61063758E-06_JPRB, 0.53208652E-06_JPRB, 0.47319875E-06_JPRB, 0.43864353E-06_JPRB, 0.42881499E-06_JPRB, &
  & 0.44035076E-06_JPRB, 0.47244143E-06_JPRB, 0.52244616E-06_JPRB, 0.59027224E-06_JPRB, 0.67463776E-06_JPRB, 0.77060065E-06_JPRB, &
  & 0.87307984E-06_JPRB, 0.97706913E-06_JPRB, 0.10786126E-05_JPRB, 0.11748647E-05_JPRB, 0.12659229E-05_JPRB, 0.13492078E-05_JPRB, &
  & 0.14238412E-05_JPRB, 0.14937042E-05_JPRB, 0.15588495E-05_JPRB, 0.16186464E-05_JPRB, 0.16738933E-05_JPRB, 0.17245782E-05_JPRB, &
  & 0.17710620E-05_JPRB, 0.18135503E-05_JPRB, 0.18526293E-05_JPRB, 0.18885667E-05_JPRB, 0.19213269E-05_JPRB, 0.19509741E-05_JPRB, &
  & 0.19779404E-05_JPRB, 0.20033817E-05_JPRB, 0.20306486E-05_JPRB, 0.20764405E-05_JPRB /)

RGHG7(:,36, 7) = (/ &
  & 0.19870126E-05_JPRB, 0.19750510E-05_JPRB, 0.19622673E-05_JPRB, 0.19439397E-05_JPRB, 0.19170730E-05_JPRB, 0.18771117E-05_JPRB, &
  & 0.18190827E-05_JPRB, 0.17549587E-05_JPRB, 0.17002614E-05_JPRB, 0.16546912E-05_JPRB, 0.16119129E-05_JPRB, 0.15644512E-05_JPRB, &
  & 0.15069356E-05_JPRB, 0.14369626E-05_JPRB, 0.13548083E-05_JPRB, 0.12632099E-05_JPRB, 0.11669256E-05_JPRB, 0.10711178E-05_JPRB, &
  & 0.98088981E-06_JPRB, 0.90167015E-06_JPRB, 0.83646125E-06_JPRB, 0.78712571E-06_JPRB, 0.75413556E-06_JPRB, 0.73357501E-06_JPRB, &
  & 0.72094747E-06_JPRB, 0.70940104E-06_JPRB, 0.69307254E-06_JPRB, 0.66708407E-06_JPRB, 0.62765167E-06_JPRB, 0.57397381E-06_JPRB, &
  & 0.51009982E-06_JPRB, 0.44456374E-06_JPRB, 0.38768243E-06_JPRB, 0.34630946E-06_JPRB, 0.32369374E-06_JPRB, 0.31919259E-06_JPRB, &
  & 0.33052166E-06_JPRB, 0.35776750E-06_JPRB, 0.39766937E-06_JPRB, 0.45298415E-06_JPRB, 0.52209765E-06_JPRB, 0.60097102E-06_JPRB, &
  & 0.68798283E-06_JPRB, 0.77947510E-06_JPRB, 0.87146424E-06_JPRB, 0.96355018E-06_JPRB, 0.10537024E-05_JPRB, 0.11387831E-05_JPRB, &
  & 0.12175980E-05_JPRB, 0.12925949E-05_JPRB, 0.13627645E-05_JPRB, 0.14272468E-05_JPRB, 0.14867784E-05_JPRB, 0.15409722E-05_JPRB, &
  & 0.15903792E-05_JPRB, 0.16354003E-05_JPRB, 0.16766426E-05_JPRB, 0.17142089E-05_JPRB, 0.17481836E-05_JPRB, 0.17786057E-05_JPRB, &
  & 0.18060167E-05_JPRB, 0.18315527E-05_JPRB, 0.18588991E-05_JPRB, 0.19041705E-05_JPRB /)

RGHG7(:,37, 7) = (/ &
  & 0.18188960E-05_JPRB, 0.18032094E-05_JPRB, 0.17899546E-05_JPRB, 0.17722350E-05_JPRB, 0.17475013E-05_JPRB, 0.17120761E-05_JPRB, &
  & 0.16624414E-05_JPRB, 0.16073307E-05_JPRB, 0.15572449E-05_JPRB, 0.15117315E-05_JPRB, 0.14660197E-05_JPRB, 0.14149364E-05_JPRB, &
  & 0.13548349E-05_JPRB, 0.12842173E-05_JPRB, 0.12036330E-05_JPRB, 0.11155919E-05_JPRB, 0.10234754E-05_JPRB, 0.93166466E-06_JPRB, &
  & 0.84399568E-06_JPRB, 0.76398112E-06_JPRB, 0.69519371E-06_JPRB, 0.63967275E-06_JPRB, 0.59784196E-06_JPRB, 0.56821449E-06_JPRB, &
  & 0.54634518E-06_JPRB, 0.52761686E-06_JPRB, 0.50726385E-06_JPRB, 0.48130238E-06_JPRB, 0.44765480E-06_JPRB, 0.40595339E-06_JPRB, &
  & 0.35959076E-06_JPRB, 0.31403940E-06_JPRB, 0.27583440E-06_JPRB, 0.24916517E-06_JPRB, 0.23547784E-06_JPRB, 0.23440896E-06_JPRB, &
  & 0.24418875E-06_JPRB, 0.26557422E-06_JPRB, 0.29581730E-06_JPRB, 0.33950872E-06_JPRB, 0.39258202E-06_JPRB, 0.45666451E-06_JPRB, &
  & 0.52996410E-06_JPRB, 0.60894070E-06_JPRB, 0.69302479E-06_JPRB, 0.78014347E-06_JPRB, 0.86792051E-06_JPRB, 0.95345712E-06_JPRB, &
  & 0.10357743E-05_JPRB, 0.11147124E-05_JPRB, 0.11883592E-05_JPRB, 0.12564028E-05_JPRB, 0.13188553E-05_JPRB, 0.13754438E-05_JPRB, &
  & 0.14268483E-05_JPRB, 0.14735426E-05_JPRB, 0.15160280E-05_JPRB, 0.15545596E-05_JPRB, 0.15890515E-05_JPRB, 0.16195896E-05_JPRB, &
  & 0.16466919E-05_JPRB, 0.16717505E-05_JPRB, 0.16982893E-05_JPRB, 0.17421755E-05_JPRB /)

RGHG7(:,38, 7) = (/ &
  & 0.16585186E-05_JPRB, 0.16398377E-05_JPRB, 0.16258371E-05_JPRB, 0.16089765E-05_JPRB, 0.15860264E-05_JPRB, 0.15549465E-05_JPRB, &
  & 0.15129172E-05_JPRB, 0.14658835E-05_JPRB, 0.14205476E-05_JPRB, 0.13761826E-05_JPRB, 0.13295846E-05_JPRB, 0.12773590E-05_JPRB, &
  & 0.12172601E-05_JPRB, 0.11483869E-05_JPRB, 0.10712918E-05_JPRB, 0.98802309E-06_JPRB, 0.90132562E-06_JPRB, 0.81410849E-06_JPRB, &
  & 0.72931596E-06_JPRB, 0.65009795E-06_JPRB, 0.57905908E-06_JPRB, 0.52011080E-06_JPRB, 0.47465824E-06_JPRB, 0.44122501E-06_JPRB, &
  & 0.41649622E-06_JPRB, 0.39582733E-06_JPRB, 0.37518626E-06_JPRB, 0.35178979E-06_JPRB, 0.32418100E-06_JPRB, 0.29259107E-06_JPRB, &
  & 0.25948617E-06_JPRB, 0.22825581E-06_JPRB, 0.20294257E-06_JPRB, 0.18599521E-06_JPRB, 0.17781794E-06_JPRB, 0.17829619E-06_JPRB, &
  & 0.18603428E-06_JPRB, 0.20183724E-06_JPRB, 0.22409604E-06_JPRB, 0.25606406E-06_JPRB, 0.29542096E-06_JPRB, 0.34539752E-06_JPRB, &
  & 0.40374138E-06_JPRB, 0.47054391E-06_JPRB, 0.54477511E-06_JPRB, 0.62508570E-06_JPRB, 0.70900325E-06_JPRB, 0.79390429E-06_JPRB, &
  & 0.87775072E-06_JPRB, 0.95842665E-06_JPRB, 0.10341885E-05_JPRB, 0.11042827E-05_JPRB, 0.11683932E-05_JPRB, 0.12263278E-05_JPRB, &
  & 0.12787513E-05_JPRB, 0.13263824E-05_JPRB, 0.13696069E-05_JPRB, 0.14085456E-05_JPRB, 0.14429654E-05_JPRB, 0.14729904E-05_JPRB, &
  & 0.14992811E-05_JPRB, 0.15233514E-05_JPRB, 0.15486314E-05_JPRB, 0.15904399E-05_JPRB /)

RGHG7(:,39, 7) = (/ &
  & 0.15054395E-05_JPRB, 0.14844994E-05_JPRB, 0.14703789E-05_JPRB, 0.14538724E-05_JPRB, 0.14330221E-05_JPRB, 0.14055574E-05_JPRB, &
  & 0.13701181E-05_JPRB, 0.13302950E-05_JPRB, 0.12895459E-05_JPRB, 0.12473494E-05_JPRB, 0.12016955E-05_JPRB, 0.11503456E-05_JPRB, &
  & 0.10922031E-05_JPRB, 0.10268382E-05_JPRB, 0.95476469E-06_JPRB, 0.87751567E-06_JPRB, 0.79713385E-06_JPRB, 0.71560424E-06_JPRB, &
  & 0.63512823E-06_JPRB, 0.55798495E-06_JPRB, 0.48907543E-06_JPRB, 0.43150462E-06_JPRB, 0.38748914E-06_JPRB, 0.35571247E-06_JPRB, &
  & 0.33216509E-06_JPRB, 0.31255053E-06_JPRB, 0.29351415E-06_JPRB, 0.27287700E-06_JPRB, 0.24995103E-06_JPRB, 0.22514422E-06_JPRB, &
  & 0.20033075E-06_JPRB, 0.17777336E-06_JPRB, 0.16007880E-06_JPRB, 0.14877847E-06_JPRB, 0.14374999E-06_JPRB, 0.14493344E-06_JPRB, &
  & 0.15106401E-06_JPRB, 0.16305975E-06_JPRB, 0.17951589E-06_JPRB, 0.20282214E-06_JPRB, 0.23181211E-06_JPRB, 0.26883575E-06_JPRB, &
  & 0.31327974E-06_JPRB, 0.36652406E-06_JPRB, 0.42866239E-06_JPRB, 0.49953110E-06_JPRB, 0.57719586E-06_JPRB, 0.65895046E-06_JPRB, &
  & 0.74154445E-06_JPRB, 0.82227160E-06_JPRB, 0.89855359E-06_JPRB, 0.96927329E-06_JPRB, 0.10337711E-05_JPRB, 0.10919449E-05_JPRB, &
  & 0.11446550E-05_JPRB, 0.11926354E-05_JPRB, 0.12360683E-05_JPRB, 0.12749393E-05_JPRB, 0.13088678E-05_JPRB, 0.13379891E-05_JPRB, &
  & 0.13631029E-05_JPRB, 0.13858463E-05_JPRB, 0.14096872E-05_JPRB, 0.14487430E-05_JPRB /)

RGHG7(:,40, 7) = (/ &
  & 0.13602187E-05_JPRB, 0.13378487E-05_JPRB, 0.13234627E-05_JPRB, 0.13079630E-05_JPRB, 0.12882856E-05_JPRB, 0.12641048E-05_JPRB, &
  & 0.12340762E-05_JPRB, 0.12000852E-05_JPRB, 0.11639120E-05_JPRB, 0.11248147E-05_JPRB, 0.10814534E-05_JPRB, 0.10326946E-05_JPRB, &
  & 0.97804991E-06_JPRB, 0.91745596E-06_JPRB, 0.85146155E-06_JPRB, 0.78119729E-06_JPRB, 0.70806374E-06_JPRB, 0.63337586E-06_JPRB, &
  & 0.55872448E-06_JPRB, 0.48727401E-06_JPRB, 0.42220370E-06_JPRB, 0.36900224E-06_JPRB, 0.32910714E-06_JPRB, 0.30036813E-06_JPRB, &
  & 0.27893438E-06_JPRB, 0.26080716E-06_JPRB, 0.24321469E-06_JPRB, 0.22481315E-06_JPRB, 0.20514655E-06_JPRB, 0.18484654E-06_JPRB, &
  & 0.16509144E-06_JPRB, 0.14764619E-06_JPRB, 0.13445251E-06_JPRB, 0.12635388E-06_JPRB, 0.12322998E-06_JPRB, 0.12460477E-06_JPRB, &
  & 0.12995696E-06_JPRB, 0.13935968E-06_JPRB, 0.15240155E-06_JPRB, 0.17001651E-06_JPRB, 0.19207828E-06_JPRB, 0.21957807E-06_JPRB, &
  & 0.25285843E-06_JPRB, 0.29371964E-06_JPRB, 0.34310418E-06_JPRB, 0.40255441E-06_JPRB, 0.47139108E-06_JPRB, 0.54714928E-06_JPRB, &
  & 0.62647456E-06_JPRB, 0.70510953E-06_JPRB, 0.78014847E-06_JPRB, 0.84994076E-06_JPRB, 0.91367474E-06_JPRB, 0.97124382E-06_JPRB, &
  & 0.10235090E-05_JPRB, 0.10712777E-05_JPRB, 0.11145108E-05_JPRB, 0.11530144E-05_JPRB, 0.11861044E-05_JPRB, 0.12140250E-05_JPRB, &
  & 0.12377127E-05_JPRB, 0.12590579E-05_JPRB, 0.12811983E-05_JPRB, 0.13176432E-05_JPRB /)

RGHG7(:,41, 7) = (/ &
  & 0.12224284E-05_JPRB, 0.11993969E-05_JPRB, 0.11857904E-05_JPRB, 0.11706398E-05_JPRB, 0.11525301E-05_JPRB, 0.11305518E-05_JPRB, &
  & 0.11045991E-05_JPRB, 0.10754977E-05_JPRB, 0.10435747E-05_JPRB, 0.10081299E-05_JPRB, 0.96830740E-06_JPRB, 0.92336603E-06_JPRB, &
  & 0.87334058E-06_JPRB, 0.81847571E-06_JPRB, 0.75927204E-06_JPRB, 0.69655414E-06_JPRB, 0.63137480E-06_JPRB, 0.56436119E-06_JPRB, &
  & 0.49665954E-06_JPRB, 0.43080047E-06_JPRB, 0.37226570E-06_JPRB, 0.32449307E-06_JPRB, 0.28882425E-06_JPRB, 0.26304301E-06_JPRB, &
  & 0.24339278E-06_JPRB, 0.22652070E-06_JPRB, 0.21020196E-06_JPRB, 0.19343658E-06_JPRB, 0.17615527E-06_JPRB, 0.15877895E-06_JPRB, &
  & 0.14229545E-06_JPRB, 0.12806663E-06_JPRB, 0.11761593E-06_JPRB, 0.11150993E-06_JPRB, 0.10950194E-06_JPRB, 0.11101948E-06_JPRB, &
  & 0.11577861E-06_JPRB, 0.12357140E-06_JPRB, 0.13441463E-06_JPRB, 0.14848510E-06_JPRB, 0.16599304E-06_JPRB, 0.18724910E-06_JPRB, &
  & 0.21229721E-06_JPRB, 0.24385434E-06_JPRB, 0.28187077E-06_JPRB, 0.33010375E-06_JPRB, 0.38848046E-06_JPRB, 0.45669057E-06_JPRB, &
  & 0.53029697E-06_JPRB, 0.60526872E-06_JPRB, 0.67768116E-06_JPRB, 0.74526565E-06_JPRB, 0.80714688E-06_JPRB, 0.86311371E-06_JPRB, &
  & 0.91431150E-06_JPRB, 0.96127735E-06_JPRB, 0.10040393E-05_JPRB, 0.10417721E-05_JPRB, 0.10738281E-05_JPRB, 0.11003522E-05_JPRB, &
  & 0.11225878E-05_JPRB, 0.11424447E-05_JPRB, 0.11631016E-05_JPRB, 0.11968926E-05_JPRB /)

RGHG7(:,42, 7) = (/ &
  & 0.10876015E-05_JPRB, 0.10689437E-05_JPRB, 0.10566741E-05_JPRB, 0.10427162E-05_JPRB, 0.10251116E-05_JPRB, 0.10048562E-05_JPRB, &
  & 0.98192572E-06_JPRB, 0.95650205E-06_JPRB, 0.92853003E-06_JPRB, 0.89714263E-06_JPRB, 0.86155137E-06_JPRB, 0.82133369E-06_JPRB, &
  & 0.77672189E-06_JPRB, 0.72810576E-06_JPRB, 0.67606641E-06_JPRB, 0.62130215E-06_JPRB, 0.56421760E-06_JPRB, 0.50545867E-06_JPRB, &
  & 0.44561503E-06_JPRB, 0.38719793E-06_JPRB, 0.33399360E-06_JPRB, 0.29091632E-06_JPRB, 0.25894562E-06_JPRB, 0.23565261E-06_JPRB, &
  & 0.21748919E-06_JPRB, 0.20159773E-06_JPRB, 0.18634699E-06_JPRB, 0.17106822E-06_JPRB, 0.15559814E-06_JPRB, 0.14040037E-06_JPRB, &
  & 0.12611308E-06_JPRB, 0.11404143E-06_JPRB, 0.10542089E-06_JPRB, 0.10060853E-06_JPRB, 0.99282069E-07_JPRB, 0.10088893E-06_JPRB, &
  & 0.10513000E-06_JPRB, 0.11191782E-06_JPRB, 0.12115936E-06_JPRB, 0.13299571E-06_JPRB, 0.14736700E-06_JPRB, 0.16457858E-06_JPRB, &
  & 0.18399975E-06_JPRB, 0.20867165E-06_JPRB, 0.23779899E-06_JPRB, 0.27614800E-06_JPRB, 0.32441991E-06_JPRB, 0.38352431E-06_JPRB, &
  & 0.45049492E-06_JPRB, 0.52057942E-06_JPRB, 0.58931568E-06_JPRB, 0.65366851E-06_JPRB, 0.71267829E-06_JPRB, 0.76647956E-06_JPRB, &
  & 0.81575178E-06_JPRB, 0.86154250E-06_JPRB, 0.90327717E-06_JPRB, 0.94007038E-06_JPRB, 0.97082864E-06_JPRB, 0.99589056E-06_JPRB, &
  & 0.10166386E-05_JPRB, 0.10351521E-05_JPRB, 0.10544146E-05_JPRB, 0.10860274E-05_JPRB /)

RGHG7(:,43, 7) = (/ &
  & 0.97399209E-06_JPRB, 0.95214762E-06_JPRB, 0.93876247E-06_JPRB, 0.92389763E-06_JPRB, 0.90648626E-06_JPRB, 0.88682083E-06_JPRB, &
  & 0.86588227E-06_JPRB, 0.84337864E-06_JPRB, 0.81892745E-06_JPRB, 0.79160861E-06_JPRB, 0.76064487E-06_JPRB, 0.72565217E-06_JPRB, &
  & 0.68686461E-06_JPRB, 0.64478843E-06_JPRB, 0.60003555E-06_JPRB, 0.55308232E-06_JPRB, 0.50436694E-06_JPRB, 0.45361315E-06_JPRB, &
  & 0.40133054E-06_JPRB, 0.34927683E-06_JPRB, 0.30225135E-06_JPRB, 0.26398621E-06_JPRB, 0.23539074E-06_JPRB, 0.21419181E-06_JPRB, &
  & 0.19732859E-06_JPRB, 0.18238551E-06_JPRB, 0.16809470E-06_JPRB, 0.15401197E-06_JPRB, 0.14005410E-06_JPRB, 0.12641509E-06_JPRB, &
  & 0.11377066E-06_JPRB, 0.10321302E-06_JPRB, 0.95842175E-07_JPRB, 0.91925500E-07_JPRB, 0.91023757E-07_JPRB, 0.92632277E-07_JPRB, &
  & 0.96476889E-07_JPRB, 0.10248540E-06_JPRB, 0.11060717E-06_JPRB, 0.12084168E-06_JPRB, 0.13312479E-06_JPRB, 0.14744157E-06_JPRB, &
  & 0.16313510E-06_JPRB, 0.18259183E-06_JPRB, 0.20525896E-06_JPRB, 0.23537389E-06_JPRB, 0.27417559E-06_JPRB, 0.32429850E-06_JPRB, &
  & 0.38379611E-06_JPRB, 0.44843114E-06_JPRB, 0.51282905E-06_JPRB, 0.57325508E-06_JPRB, 0.62881975E-06_JPRB, 0.67961395E-06_JPRB, &
  & 0.72650380E-06_JPRB, 0.77034355E-06_JPRB, 0.81076831E-06_JPRB, 0.84619518E-06_JPRB, 0.87552178E-06_JPRB, 0.89903028E-06_JPRB, &
  & 0.91835329E-06_JPRB, 0.93562784E-06_JPRB, 0.95374651E-06_JPRB, 0.98375290E-06_JPRB /)

RGHG7(:,44, 7) = (/ &
  & 0.86811343E-06_JPRB, 0.84219204E-06_JPRB, 0.82764092E-06_JPRB, 0.81284901E-06_JPRB, 0.79489234E-06_JPRB, 0.77593677E-06_JPRB, &
  & 0.75621085E-06_JPRB, 0.73612824E-06_JPRB, 0.71476757E-06_JPRB, 0.69140168E-06_JPRB, 0.66510944E-06_JPRB, 0.63540881E-06_JPRB, &
  & 0.60255405E-06_JPRB, 0.56706807E-06_JPRB, 0.52941101E-06_JPRB, 0.49024123E-06_JPRB, 0.44936274E-06_JPRB, 0.40686396E-06_JPRB, &
  & 0.36223520E-06_JPRB, 0.31732534E-06_JPRB, 0.27547259E-06_JPRB, 0.24135502E-06_JPRB, 0.21575033E-06_JPRB, 0.19647899E-06_JPRB, &
  & 0.18077128E-06_JPRB, 0.16675229E-06_JPRB, 0.15344021E-06_JPRB, 0.14046070E-06_JPRB, 0.12768832E-06_JPRB, 0.11530450E-06_JPRB, &
  & 0.10385110E-06_JPRB, 0.94418596E-07_JPRB, 0.87960629E-07_JPRB, 0.84634529E-07_JPRB, 0.83994067E-07_JPRB, 0.85549253E-07_JPRB, &
  & 0.89052413E-07_JPRB, 0.94470522E-07_JPRB, 0.10171294E-06_JPRB, 0.11084376E-06_JPRB, 0.12149904E-06_JPRB, 0.13386713E-06_JPRB, &
  & 0.14700905E-06_JPRB, 0.16231863E-06_JPRB, 0.18052557E-06_JPRB, 0.20356470E-06_JPRB, 0.23436102E-06_JPRB, 0.27564442E-06_JPRB, &
  & 0.32719763E-06_JPRB, 0.38607166E-06_JPRB, 0.44553883E-06_JPRB, 0.50183002E-06_JPRB, 0.55344464E-06_JPRB, 0.60071807E-06_JPRB, &
  & 0.64451081E-06_JPRB, 0.68586797E-06_JPRB, 0.72431783E-06_JPRB, 0.75809760E-06_JPRB, 0.78574504E-06_JPRB, 0.80766989E-06_JPRB, &
  & 0.82565572E-06_JPRB, 0.84182261E-06_JPRB, 0.85908238E-06_JPRB, 0.88791984E-06_JPRB /)

RGHG7(:,45, 7) = (/ &
  & 0.75218458E-06_JPRB, 0.73294427E-06_JPRB, 0.72102648E-06_JPRB, 0.70687457E-06_JPRB, 0.68982064E-06_JPRB, 0.67068197E-06_JPRB, &
  & 0.65252857E-06_JPRB, 0.63420839E-06_JPRB, 0.61582779E-06_JPRB, 0.59606975E-06_JPRB, 0.57424865E-06_JPRB, 0.54975243E-06_JPRB, &
  & 0.52268655E-06_JPRB, 0.49350427E-06_JPRB, 0.46289901E-06_JPRB, 0.43091450E-06_JPRB, 0.39789933E-06_JPRB, 0.36283200E-06_JPRB, &
  & 0.32579689E-06_JPRB, 0.28722766E-06_JPRB, 0.25141799E-06_JPRB, 0.22168130E-06_JPRB, 0.19906834E-06_JPRB, 0.18157284E-06_JPRB, &
  & 0.16700878E-06_JPRB, 0.15386998E-06_JPRB, 0.14144703E-06_JPRB, 0.12941425E-06_JPRB, 0.11764717E-06_JPRB, 0.10621645E-06_JPRB, &
  & 0.95707954E-07_JPRB, 0.87109235E-07_JPRB, 0.81295468E-07_JPRB, 0.78360877E-07_JPRB, 0.77853663E-07_JPRB, 0.79307640E-07_JPRB, &
  & 0.82529063E-07_JPRB, 0.87458091E-07_JPRB, 0.94051657E-07_JPRB, 0.10226695E-06_JPRB, 0.11186338E-06_JPRB, 0.12261791E-06_JPRB, &
  & 0.13399297E-06_JPRB, 0.14634908E-06_JPRB, 0.16102815E-06_JPRB, 0.17852315E-06_JPRB, 0.20267146E-06_JPRB, 0.23512555E-06_JPRB, &
  & 0.27875916E-06_JPRB, 0.33050813E-06_JPRB, 0.38497524E-06_JPRB, 0.43684500E-06_JPRB, 0.48418644E-06_JPRB, 0.52742877E-06_JPRB, &
  & 0.56757563E-06_JPRB, 0.60569965E-06_JPRB, 0.64166551E-06_JPRB, 0.67331894E-06_JPRB, 0.69915222E-06_JPRB, 0.71952093E-06_JPRB, &
  & 0.73625245E-06_JPRB, 0.75149751E-06_JPRB, 0.76804184E-06_JPRB, 0.79630405E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART14',0,ZHOOK_HANDLE)



RGHG7(:,46, 7) = (/ &
  & 0.66156787E-06_JPRB, 0.63659041E-06_JPRB, 0.62166981E-06_JPRB, 0.60696073E-06_JPRB, 0.58864111E-06_JPRB, 0.57041643E-06_JPRB, &
  & 0.55265627E-06_JPRB, 0.53661051E-06_JPRB, 0.52069896E-06_JPRB, 0.50458345E-06_JPRB, 0.48692755E-06_JPRB, 0.46736866E-06_JPRB, &
  & 0.44584164E-06_JPRB, 0.42285947E-06_JPRB, 0.39874928E-06_JPRB, 0.37403797E-06_JPRB, 0.34808681E-06_JPRB, 0.32075698E-06_JPRB, &
  & 0.29089250E-06_JPRB, 0.25981007E-06_JPRB, 0.22967940E-06_JPRB, 0.20441071E-06_JPRB, 0.18458356E-06_JPRB, 0.16882187E-06_JPRB, &
  & 0.15535628E-06_JPRB, 0.14312465E-06_JPRB, 0.13153861E-06_JPRB, 0.12033816E-06_JPRB, 0.10937186E-06_JPRB, 0.98729103E-07_JPRB, &
  & 0.88938933E-07_JPRB, 0.80970736E-07_JPRB, 0.75605804E-07_JPRB, 0.72900860E-07_JPRB, 0.72422850E-07_JPRB, 0.73757008E-07_JPRB, &
  & 0.76738800E-07_JPRB, 0.81249652E-07_JPRB, 0.87322135E-07_JPRB, 0.94858919E-07_JPRB, 0.10356567E-06_JPRB, 0.11319363E-06_JPRB, &
  & 0.12322597E-06_JPRB, 0.13349936E-06_JPRB, 0.14525151E-06_JPRB, 0.15896534E-06_JPRB, 0.17718203E-06_JPRB, 0.20221850E-06_JPRB, &
  & 0.23684703E-06_JPRB, 0.28077324E-06_JPRB, 0.32885288E-06_JPRB, 0.37571016E-06_JPRB, 0.41850248E-06_JPRB, 0.45719858E-06_JPRB, &
  & 0.49319414E-06_JPRB, 0.52769428E-06_JPRB, 0.56049726E-06_JPRB, 0.58983466E-06_JPRB, 0.61371077E-06_JPRB, 0.63261820E-06_JPRB, &
  & 0.64825457E-06_JPRB, 0.66269286E-06_JPRB, 0.67871207E-06_JPRB, 0.70660093E-06_JPRB /)

RGHG7(:,47, 7) = (/ &
  & 0.56054205E-06_JPRB, 0.53638234E-06_JPRB, 0.52272316E-06_JPRB, 0.50761747E-06_JPRB, 0.48987789E-06_JPRB, 0.47088818E-06_JPRB, &
  & 0.45499061E-06_JPRB, 0.44058228E-06_JPRB, 0.42774002E-06_JPRB, 0.41495244E-06_JPRB, 0.40157582E-06_JPRB, 0.38679272E-06_JPRB, &
  & 0.37063990E-06_JPRB, 0.35350658E-06_JPRB, 0.33595032E-06_JPRB, 0.31783955E-06_JPRB, 0.29915037E-06_JPRB, 0.27887751E-06_JPRB, &
  & 0.25686313E-06_JPRB, 0.23296454E-06_JPRB, 0.20959003E-06_JPRB, 0.18895069E-06_JPRB, 0.17205755E-06_JPRB, 0.15793628E-06_JPRB, &
  & 0.14554789E-06_JPRB, 0.13413826E-06_JPRB, 0.12333058E-06_JPRB, 0.11283150E-06_JPRB, 0.10255045E-06_JPRB, 0.92524637E-07_JPRB, &
  & 0.83311448E-07_JPRB, 0.75808622E-07_JPRB, 0.70735595E-07_JPRB, 0.68129943E-07_JPRB, 0.67609228E-07_JPRB, 0.68826665E-07_JPRB, &
  & 0.71551071E-07_JPRB, 0.75750393E-07_JPRB, 0.81370366E-07_JPRB, 0.88344507E-07_JPRB, 0.96372602E-07_JPRB, 0.10514537E-06_JPRB, &
  & 0.11410398E-06_JPRB, 0.12311625E-06_JPRB, 0.13247801E-06_JPRB, 0.14346419E-06_JPRB, 0.15690233E-06_JPRB, 0.17538053E-06_JPRB, &
  & 0.20142330E-06_JPRB, 0.23553893E-06_JPRB, 0.27571465E-06_JPRB, 0.31594757E-06_JPRB, 0.35344007E-06_JPRB, 0.38733322E-06_JPRB, &
  & 0.41892702E-06_JPRB, 0.44937732E-06_JPRB, 0.47907321E-06_JPRB, 0.50585157E-06_JPRB, 0.52798788E-06_JPRB, 0.54557421E-06_JPRB, &
  & 0.56028898E-06_JPRB, 0.57408334E-06_JPRB, 0.58966071E-06_JPRB, 0.61742600E-06_JPRB /)

RGHG7(:,48, 7) = (/ &
  & 0.46942958E-06_JPRB, 0.44585948E-06_JPRB, 0.42928596E-06_JPRB, 0.41224391E-06_JPRB, 0.39197829E-06_JPRB, 0.37318713E-06_JPRB, &
  & 0.35755809E-06_JPRB, 0.34557641E-06_JPRB, 0.33540442E-06_JPRB, 0.32615887E-06_JPRB, 0.31682981E-06_JPRB, 0.30675781E-06_JPRB, &
  & 0.29585740E-06_JPRB, 0.28447107E-06_JPRB, 0.27303992E-06_JPRB, 0.26166765E-06_JPRB, 0.24995393E-06_JPRB, 0.23743165E-06_JPRB, &
  & 0.22334021E-06_JPRB, 0.20765242E-06_JPRB, 0.19104745E-06_JPRB, 0.17516889E-06_JPRB, 0.16109367E-06_JPRB, 0.14860711E-06_JPRB, &
  & 0.13723741E-06_JPRB, 0.12663912E-06_JPRB, 0.11650266E-06_JPRB, 0.10663557E-06_JPRB, 0.96899747E-07_JPRB, 0.87395080E-07_JPRB, &
  & 0.78628361E-07_JPRB, 0.71463234E-07_JPRB, 0.66560787E-07_JPRB, 0.63954474E-07_JPRB, 0.63367317E-07_JPRB, 0.64411964E-07_JPRB, &
  & 0.66936167E-07_JPRB, 0.70841402E-07_JPRB, 0.76108492E-07_JPRB, 0.82541810E-07_JPRB, 0.90064937E-07_JPRB, 0.98171427E-07_JPRB, &
  & 0.10638083E-06_JPRB, 0.11432940E-06_JPRB, 0.12225698E-06_JPRB, 0.13080034E-06_JPRB, 0.14086439E-06_JPRB, 0.15410089E-06_JPRB, &
  & 0.17200573E-06_JPRB, 0.19620703E-06_JPRB, 0.22504575E-06_JPRB, 0.25666043E-06_JPRB, 0.28674060E-06_JPRB, 0.31490902E-06_JPRB, &
  & 0.34169599E-06_JPRB, 0.36829755E-06_JPRB, 0.39487210E-06_JPRB, 0.41971256E-06_JPRB, 0.44039891E-06_JPRB, 0.45711758E-06_JPRB, &
  & 0.47120918E-06_JPRB, 0.48460680E-06_JPRB, 0.49999142E-06_JPRB, 0.52789449E-06_JPRB /)

RGHG7(:,49, 7) = (/ &
  & 0.39861536E-06_JPRB, 0.36423680E-06_JPRB, 0.34427237E-06_JPRB, 0.32441775E-06_JPRB, 0.30264417E-06_JPRB, 0.28233123E-06_JPRB, &
  & 0.26773867E-06_JPRB, 0.25729432E-06_JPRB, 0.24947653E-06_JPRB, 0.24312075E-06_JPRB, 0.23711158E-06_JPRB, 0.23104796E-06_JPRB, &
  & 0.22467130E-06_JPRB, 0.21843135E-06_JPRB, 0.21264415E-06_JPRB, 0.20749118E-06_JPRB, 0.20265040E-06_JPRB, 0.19761582E-06_JPRB, &
  & 0.19162552E-06_JPRB, 0.18390493E-06_JPRB, 0.17390120E-06_JPRB, 0.16280609E-06_JPRB, 0.15149855E-06_JPRB, 0.14058405E-06_JPRB, &
  & 0.13020377E-06_JPRB, 0.12032054E-06_JPRB, 0.11081396E-06_JPRB, 0.10147168E-06_JPRB, 0.92218166E-07_JPRB, 0.83132285E-07_JPRB, &
  & 0.74721150E-07_JPRB, 0.67797899E-07_JPRB, 0.62968098E-07_JPRB, 0.60325576E-07_JPRB, 0.59607160E-07_JPRB, 0.60474875E-07_JPRB, &
  & 0.62827844E-07_JPRB, 0.66500689E-07_JPRB, 0.71362223E-07_JPRB, 0.77413972E-07_JPRB, 0.84421167E-07_JPRB, 0.92079240E-07_JPRB, &
  & 0.99679681E-07_JPRB, 0.10689488E-06_JPRB, 0.11369813E-06_JPRB, 0.12048868E-06_JPRB, 0.12818272E-06_JPRB, 0.13729681E-06_JPRB, &
  & 0.14900880E-06_JPRB, 0.16373905E-06_JPRB, 0.18181949E-06_JPRB, 0.20125745E-06_JPRB, 0.22183714E-06_JPRB, 0.24203965E-06_JPRB, &
  & 0.26245371E-06_JPRB, 0.28451132E-06_JPRB, 0.30784912E-06_JPRB, 0.33065857E-06_JPRB, 0.35048666E-06_JPRB, 0.36659549E-06_JPRB, &
  & 0.38046281E-06_JPRB, 0.39374748E-06_JPRB, 0.40923530E-06_JPRB, 0.43796251E-06_JPRB /)

RGHG7(:,50, 7) = (/ &
  & 0.31470049E-06_JPRB, 0.28786911E-06_JPRB, 0.27086520E-06_JPRB, 0.25217352E-06_JPRB, 0.23120826E-06_JPRB, 0.21206669E-06_JPRB, &
  & 0.19906803E-06_JPRB, 0.19044413E-06_JPRB, 0.18469510E-06_JPRB, 0.18014835E-06_JPRB, 0.17636235E-06_JPRB, 0.17272066E-06_JPRB, &
  & 0.16934744E-06_JPRB, 0.16655052E-06_JPRB, 0.16474984E-06_JPRB, 0.16396929E-06_JPRB, 0.16402504E-06_JPRB, 0.16438678E-06_JPRB, &
  & 0.16433863E-06_JPRB, 0.16266418E-06_JPRB, 0.15853628E-06_JPRB, 0.15160057E-06_JPRB, 0.14302810E-06_JPRB, 0.13362614E-06_JPRB, &
  & 0.12417448E-06_JPRB, 0.11496455E-06_JPRB, 0.10599148E-06_JPRB, 0.97129607E-07_JPRB, 0.88278412E-07_JPRB, 0.79557026E-07_JPRB, &
  & 0.71438507E-07_JPRB, 0.64679227E-07_JPRB, 0.59885551E-07_JPRB, 0.57153002E-07_JPRB, 0.56248826E-07_JPRB, 0.57002250E-07_JPRB, &
  & 0.59189340E-07_JPRB, 0.62563252E-07_JPRB, 0.67144882E-07_JPRB, 0.72775187E-07_JPRB, 0.79399662E-07_JPRB, 0.86626514E-07_JPRB, &
  & 0.93804829E-07_JPRB, 0.10040587E-06_JPRB, 0.10642164E-06_JPRB, 0.11211709E-06_JPRB, 0.11790129E-06_JPRB, 0.12431444E-06_JPRB, &
  & 0.13170644E-06_JPRB, 0.14018200E-06_JPRB, 0.14951945E-06_JPRB, 0.15987440E-06_JPRB, 0.17039544E-06_JPRB, 0.18167749E-06_JPRB, &
  & 0.19443988E-06_JPRB, 0.20884170E-06_JPRB, 0.22636466E-06_JPRB, 0.24491445E-06_JPRB, 0.26184247E-06_JPRB, 0.27665209E-06_JPRB, &
  & 0.28954821E-06_JPRB, 0.30253403E-06_JPRB, 0.31820295E-06_JPRB, 0.34842427E-06_JPRB /)

RGHG7(:,51, 7) = (/ &
  & 0.25842056E-06_JPRB, 0.23175016E-06_JPRB, 0.21586769E-06_JPRB, 0.20036252E-06_JPRB, 0.18220410E-06_JPRB, 0.16670585E-06_JPRB, &
  & 0.15613510E-06_JPRB, 0.15006626E-06_JPRB, 0.14576402E-06_JPRB, 0.14282794E-06_JPRB, 0.14027259E-06_JPRB, 0.13807855E-06_JPRB, &
  & 0.13626280E-06_JPRB, 0.13527671E-06_JPRB, 0.13538396E-06_JPRB, 0.13654068E-06_JPRB, 0.13850021E-06_JPRB, 0.14089490E-06_JPRB, &
  & 0.14333028E-06_JPRB, 0.14497469E-06_JPRB, 0.14467832E-06_JPRB, 0.14149353E-06_JPRB, 0.13540546E-06_JPRB, 0.12752021E-06_JPRB, &
  & 0.11893702E-06_JPRB, 0.11032290E-06_JPRB, 0.10182946E-06_JPRB, 0.93379967E-07_JPRB, 0.84898431E-07_JPRB, 0.76496562E-07_JPRB, &
  & 0.68632311E-07_JPRB, 0.62009654E-07_JPRB, 0.57213782E-07_JPRB, 0.54330211E-07_JPRB, 0.53312167E-07_JPRB, 0.53918026E-07_JPRB, &
  & 0.55879603E-07_JPRB, 0.59040534E-07_JPRB, 0.63316214E-07_JPRB, 0.68618341E-07_JPRB, 0.74872709E-07_JPRB, 0.81705075E-07_JPRB, &
  & 0.88521986E-07_JPRB, 0.94698443E-07_JPRB, 0.10006956E-06_JPRB, 0.10495008E-06_JPRB, 0.10954533E-06_JPRB, 0.11422505E-06_JPRB, &
  & 0.11893616E-06_JPRB, 0.12378054E-06_JPRB, 0.12868945E-06_JPRB, 0.13351952E-06_JPRB, 0.13861077E-06_JPRB, 0.14392091E-06_JPRB, &
  & 0.14970115E-06_JPRB, 0.15739715E-06_JPRB, 0.16640610E-06_JPRB, 0.17731541E-06_JPRB, 0.18830769E-06_JPRB, 0.19829083E-06_JPRB, &
  & 0.20827531E-06_JPRB, 0.21886063E-06_JPRB, 0.23310737E-06_JPRB, 0.26304883E-06_JPRB /)

RGHG7(:,52, 7) = (/ &
  & 0.20421571E-06_JPRB, 0.18605311E-06_JPRB, 0.17549631E-06_JPRB, 0.16385519E-06_JPRB, 0.15046618E-06_JPRB, 0.13844237E-06_JPRB, &
  & 0.13124064E-06_JPRB, 0.12668596E-06_JPRB, 0.12405438E-06_JPRB, 0.12197424E-06_JPRB, 0.12039524E-06_JPRB, 0.11902705E-06_JPRB, &
  & 0.11808224E-06_JPRB, 0.11793057E-06_JPRB, 0.11878191E-06_JPRB, 0.12049360E-06_JPRB, 0.12278934E-06_JPRB, 0.12550333E-06_JPRB, &
  & 0.12820253E-06_JPRB, 0.13099955E-06_JPRB, 0.13264577E-06_JPRB, 0.13214665E-06_JPRB, 0.12845430E-06_JPRB, 0.12203056E-06_JPRB, &
  & 0.11428770E-06_JPRB, 0.10620290E-06_JPRB, 0.98121205E-07_JPRB, 0.90047727E-07_JPRB, 0.81906407E-07_JPRB, 0.73816771E-07_JPRB, &
  & 0.66183382E-07_JPRB, 0.59701492E-07_JPRB, 0.54840285E-07_JPRB, 0.51871140E-07_JPRB, 0.50697217E-07_JPRB, 0.51122527E-07_JPRB, &
  & 0.52896134E-07_JPRB, 0.55839525E-07_JPRB, 0.59863339E-07_JPRB, 0.64864984E-07_JPRB, 0.70748229E-07_JPRB, 0.77275331E-07_JPRB, &
  & 0.83717083E-07_JPRB, 0.89521706E-07_JPRB, 0.94449888E-07_JPRB, 0.98715532E-07_JPRB, 0.10257801E-06_JPRB, 0.10608779E-06_JPRB, &
  & 0.10941684E-06_JPRB, 0.11236978E-06_JPRB, 0.11508124E-06_JPRB, 0.11769951E-06_JPRB, 0.12008360E-06_JPRB, 0.12246895E-06_JPRB, &
  & 0.12533894E-06_JPRB, 0.12839266E-06_JPRB, 0.13274148E-06_JPRB, 0.13758593E-06_JPRB, 0.14248619E-06_JPRB, 0.14778202E-06_JPRB, &
  & 0.15292069E-06_JPRB, 0.15933843E-06_JPRB, 0.16886125E-06_JPRB, 0.19261806E-06_JPRB /)

RGHG7(:,53, 7) = (/ &
  & 0.16835385E-06_JPRB, 0.15522568E-06_JPRB, 0.14703139E-06_JPRB, 0.13877428E-06_JPRB, 0.12899828E-06_JPRB, 0.12075269E-06_JPRB, &
  & 0.11539716E-06_JPRB, 0.11257102E-06_JPRB, 0.11065910E-06_JPRB, 0.10943395E-06_JPRB, 0.10840256E-06_JPRB, 0.10759506E-06_JPRB, &
  & 0.10715538E-06_JPRB, 0.10741217E-06_JPRB, 0.10847366E-06_JPRB, 0.11024128E-06_JPRB, 0.11241223E-06_JPRB, 0.11474241E-06_JPRB, &
  & 0.11742387E-06_JPRB, 0.11996211E-06_JPRB, 0.12254897E-06_JPRB, 0.12356512E-06_JPRB, 0.12190223E-06_JPRB, 0.11697095E-06_JPRB, &
  & 0.11003754E-06_JPRB, 0.10243747E-06_JPRB, 0.94729963E-07_JPRB, 0.86986972E-07_JPRB, 0.79187430E-07_JPRB, 0.71396606E-07_JPRB, &
  & 0.64018387E-07_JPRB, 0.57630405E-07_JPRB, 0.52757187E-07_JPRB, 0.49687255E-07_JPRB, 0.48333263E-07_JPRB, 0.48587619E-07_JPRB, &
  & 0.50191563E-07_JPRB, 0.52935306E-07_JPRB, 0.56729501E-07_JPRB, 0.61439408E-07_JPRB, 0.67054081E-07_JPRB, 0.73203907E-07_JPRB, &
  & 0.79337141E-07_JPRB, 0.84761780E-07_JPRB, 0.89347040E-07_JPRB, 0.93192043E-07_JPRB, 0.96510419E-07_JPRB, 0.99435375E-07_JPRB, &
  & 0.10191244E-06_JPRB, 0.10407300E-06_JPRB, 0.10588433E-06_JPRB, 0.10740677E-06_JPRB, 0.10877774E-06_JPRB, 0.11011375E-06_JPRB, &
  & 0.11135961E-06_JPRB, 0.11305298E-06_JPRB, 0.11491731E-06_JPRB, 0.11718875E-06_JPRB, 0.11975675E-06_JPRB, 0.12199327E-06_JPRB, &
  & 0.12453339E-06_JPRB, 0.12752726E-06_JPRB, 0.13201652E-06_JPRB, 0.14577233E-06_JPRB /)

RGHG7(:,54, 7) = (/ &
  & 0.14256247E-06_JPRB, 0.13226469E-06_JPRB, 0.12666327E-06_JPRB, 0.12096675E-06_JPRB, 0.11440265E-06_JPRB, 0.10861016E-06_JPRB, &
  & 0.10517870E-06_JPRB, 0.10309260E-06_JPRB, 0.10192050E-06_JPRB, 0.10105510E-06_JPRB, 0.10042638E-06_JPRB, 0.99958491E-07_JPRB, &
  & 0.99781360E-07_JPRB, 0.10020143E-06_JPRB, 0.10128626E-06_JPRB, 0.10287444E-06_JPRB, 0.10471987E-06_JPRB, 0.10686971E-06_JPRB, &
  & 0.10895290E-06_JPRB, 0.11146313E-06_JPRB, 0.11390148E-06_JPRB, 0.11592115E-06_JPRB, 0.11565217E-06_JPRB, 0.11212694E-06_JPRB, &
  & 0.10602155E-06_JPRB, 0.98891796E-07_JPRB, 0.91531874E-07_JPRB, 0.84122952E-07_JPRB, 0.76639338E-07_JPRB, 0.69156954E-07_JPRB, &
  & 0.62040868E-07_JPRB, 0.55744465E-07_JPRB, 0.50906685E-07_JPRB, 0.47698212E-07_JPRB, 0.46193403E-07_JPRB, 0.46292666E-07_JPRB, &
  & 0.47721379E-07_JPRB, 0.50295906E-07_JPRB, 0.53858546E-07_JPRB, 0.58348345E-07_JPRB, 0.63659144E-07_JPRB, 0.69508708E-07_JPRB, &
  & 0.75271274E-07_JPRB, 0.80377447E-07_JPRB, 0.84613376E-07_JPRB, 0.88146955E-07_JPRB, 0.91161013E-07_JPRB, 0.93699455E-07_JPRB, &
  & 0.95855363E-07_JPRB, 0.97616343E-07_JPRB, 0.99059626E-07_JPRB, 0.10024853E-06_JPRB, 0.10122043E-06_JPRB, 0.10202444E-06_JPRB, &
  & 0.10295928E-06_JPRB, 0.10388491E-06_JPRB, 0.10506532E-06_JPRB, 0.10636828E-06_JPRB, 0.10749587E-06_JPRB, 0.10870899E-06_JPRB, &
  & 0.10989452E-06_JPRB, 0.11115408E-06_JPRB, 0.11265939E-06_JPRB, 0.11660443E-06_JPRB /)

RGHG7(:,55, 7) = (/ &
  & 0.12155006E-06_JPRB, 0.11558306E-06_JPRB, 0.11190581E-06_JPRB, 0.10801590E-06_JPRB, 0.10370767E-06_JPRB, 0.99958399E-07_JPRB, &
  & 0.97483053E-07_JPRB, 0.96198370E-07_JPRB, 0.95375576E-07_JPRB, 0.94850130E-07_JPRB, 0.94454386E-07_JPRB, 0.94191883E-07_JPRB, &
  & 0.94183946E-07_JPRB, 0.94626230E-07_JPRB, 0.95607966E-07_JPRB, 0.96966723E-07_JPRB, 0.98613874E-07_JPRB, 0.10021719E-06_JPRB, &
  & 0.10234258E-06_JPRB, 0.10432439E-06_JPRB, 0.10675971E-06_JPRB, 0.10898880E-06_JPRB, 0.10978030E-06_JPRB, 0.10738069E-06_JPRB, &
  & 0.10209159E-06_JPRB, 0.95454595E-07_JPRB, 0.88455167E-07_JPRB, 0.81364476E-07_JPRB, 0.74210682E-07_JPRB, 0.67046116E-07_JPRB, &
  & 0.60117344E-07_JPRB, 0.54036157E-07_JPRB, 0.49183786E-07_JPRB, 0.45887962E-07_JPRB, 0.44250424E-07_JPRB, 0.44193357E-07_JPRB, &
  & 0.45470458E-07_JPRB, 0.47857210E-07_JPRB, 0.51247028E-07_JPRB, 0.55508291E-07_JPRB, 0.60575111E-07_JPRB, 0.66101698E-07_JPRB, &
  & 0.71500878E-07_JPRB, 0.76263284E-07_JPRB, 0.80217319E-07_JPRB, 0.83494278E-07_JPRB, 0.86259597E-07_JPRB, 0.88652932E-07_JPRB, &
  & 0.90662333E-07_JPRB, 0.92334730E-07_JPRB, 0.93698098E-07_JPRB, 0.94762420E-07_JPRB, 0.95604186E-07_JPRB, 0.96377512E-07_JPRB, &
  & 0.97043589E-07_JPRB, 0.97824362E-07_JPRB, 0.98638203E-07_JPRB, 0.99536862E-07_JPRB, 0.10044950E-06_JPRB, 0.10128865E-06_JPRB, &
  & 0.10200188E-06_JPRB, 0.10274407E-06_JPRB, 0.10338714E-06_JPRB, 0.10354071E-06_JPRB /)

RGHG7(:,56, 7) = (/ &
  & 0.10966319E-06_JPRB, 0.10408555E-06_JPRB, 0.10122839E-06_JPRB, 0.98701527E-07_JPRB, 0.95854247E-07_JPRB, 0.93373586E-07_JPRB, &
  & 0.91798896E-07_JPRB, 0.90832962E-07_JPRB, 0.90298670E-07_JPRB, 0.89927731E-07_JPRB, 0.89672312E-07_JPRB, 0.89515680E-07_JPRB, &
  & 0.89568246E-07_JPRB, 0.89950618E-07_JPRB, 0.90776290E-07_JPRB, 0.91887962E-07_JPRB, 0.93245873E-07_JPRB, 0.94802637E-07_JPRB, &
  & 0.96336599E-07_JPRB, 0.98428835E-07_JPRB, 0.10058588E-06_JPRB, 0.10292631E-06_JPRB, 0.10419756E-06_JPRB, 0.10270929E-06_JPRB, &
  & 0.98154892E-07_JPRB, 0.92033886E-07_JPRB, 0.85423366E-07_JPRB, 0.78667298E-07_JPRB, 0.71806774E-07_JPRB, 0.64960240E-07_JPRB, &
  & 0.58310725E-07_JPRB, 0.52368890E-07_JPRB, 0.47557020E-07_JPRB, 0.44218329E-07_JPRB, 0.42479922E-07_JPRB, 0.42272632E-07_JPRB, &
  & 0.43385761E-07_JPRB, 0.45629253E-07_JPRB, 0.48834256E-07_JPRB, 0.52915837E-07_JPRB, 0.57720992E-07_JPRB, 0.62921160E-07_JPRB, &
  & 0.67982747E-07_JPRB, 0.72412419E-07_JPRB, 0.76092697E-07_JPRB, 0.79141437E-07_JPRB, 0.81761648E-07_JPRB, 0.84028329E-07_JPRB, &
  & 0.86024293E-07_JPRB, 0.87749974E-07_JPRB, 0.89143946E-07_JPRB, 0.90252009E-07_JPRB, 0.91143335E-07_JPRB, 0.91858368E-07_JPRB, &
  & 0.92588593E-07_JPRB, 0.93288577E-07_JPRB, 0.94116295E-07_JPRB, 0.94899775E-07_JPRB, 0.95572233E-07_JPRB, 0.96185836E-07_JPRB, &
  & 0.96787900E-07_JPRB, 0.97491601E-07_JPRB, 0.98426554E-07_JPRB, 0.10076390E-06_JPRB /)

RGHG7(:,57, 7) = (/ &
  & 0.98055381E-07_JPRB, 0.94922434E-07_JPRB, 0.93226440E-07_JPRB, 0.91477609E-07_JPRB, 0.89701949E-07_JPRB, 0.88085791E-07_JPRB, &
  & 0.86983256E-07_JPRB, 0.86372147E-07_JPRB, 0.85983189E-07_JPRB, 0.85730768E-07_JPRB, 0.85560231E-07_JPRB, 0.85455390E-07_JPRB, &
  & 0.85497597E-07_JPRB, 0.85809774E-07_JPRB, 0.86425189E-07_JPRB, 0.87339991E-07_JPRB, 0.88444395E-07_JPRB, 0.89758046E-07_JPRB, &
  & 0.91346045E-07_JPRB, 0.93093036E-07_JPRB, 0.95173881E-07_JPRB, 0.97549851E-07_JPRB, 0.99070363E-07_JPRB, 0.98079838E-07_JPRB, &
  & 0.94167632E-07_JPRB, 0.88565827E-07_JPRB, 0.82358653E-07_JPRB, 0.75957708E-07_JPRB, 0.69423372E-07_JPRB, 0.62823453E-07_JPRB, &
  & 0.56479720E-07_JPRB, 0.50714732E-07_JPRB, 0.46006477E-07_JPRB, 0.42668187E-07_JPRB, 0.40845133E-07_JPRB, 0.40509260E-07_JPRB, &
  & 0.41482370E-07_JPRB, 0.43564850E-07_JPRB, 0.46627676E-07_JPRB, 0.50503068E-07_JPRB, 0.55073027E-07_JPRB, 0.59963604E-07_JPRB, &
  & 0.64662927E-07_JPRB, 0.68792637E-07_JPRB, 0.72231224E-07_JPRB, 0.75090092E-07_JPRB, 0.77560273E-07_JPRB, 0.79768384E-07_JPRB, &
  & 0.81756099E-07_JPRB, 0.83522671E-07_JPRB, 0.85067455E-07_JPRB, 0.86294456E-07_JPRB, 0.87254826E-07_JPRB, 0.88126846E-07_JPRB, &
  & 0.88872412E-07_JPRB, 0.89704685E-07_JPRB, 0.90481322E-07_JPRB, 0.91240750E-07_JPRB, 0.91944429E-07_JPRB, 0.92555062E-07_JPRB, &
  & 0.93101598E-07_JPRB, 0.93611732E-07_JPRB, 0.94116345E-07_JPRB, 0.95131476E-07_JPRB /)

RGHG7(:,58, 7) = (/ &
  & 0.91809468E-07_JPRB, 0.88706102E-07_JPRB, 0.87224187E-07_JPRB, 0.86060780E-07_JPRB, 0.84854946E-07_JPRB, 0.83782865E-07_JPRB, &
  & 0.83023494E-07_JPRB, 0.82546357E-07_JPRB, 0.82258246E-07_JPRB, 0.82050235E-07_JPRB, 0.81895507E-07_JPRB, 0.81806498E-07_JPRB, &
  & 0.81797218E-07_JPRB, 0.81996795E-07_JPRB, 0.82423661E-07_JPRB, 0.83145778E-07_JPRB, 0.84041361E-07_JPRB, 0.85266500E-07_JPRB, &
  & 0.86573408E-07_JPRB, 0.88423612E-07_JPRB, 0.90464269E-07_JPRB, 0.92661850E-07_JPRB, 0.94273545E-07_JPRB, 0.93571551E-07_JPRB, &
  & 0.90131365E-07_JPRB, 0.85023977E-07_JPRB, 0.79230006E-07_JPRB, 0.73162553E-07_JPRB, 0.66963402E-07_JPRB, 0.60708331E-07_JPRB, &
  & 0.54613739E-07_JPRB, 0.49068330E-07_JPRB, 0.44500005E-07_JPRB, 0.41202494E-07_JPRB, 0.39340733E-07_JPRB, 0.38902741E-07_JPRB, &
  & 0.39743721E-07_JPRB, 0.41689912E-07_JPRB, 0.44582769E-07_JPRB, 0.48287760E-07_JPRB, 0.52588586E-07_JPRB, 0.57159319E-07_JPRB, &
  & 0.61535722E-07_JPRB, 0.65392378E-07_JPRB, 0.68599029E-07_JPRB, 0.71306175E-07_JPRB, 0.73661212E-07_JPRB, 0.75801331E-07_JPRB, &
  & 0.77766131E-07_JPRB, 0.79591643E-07_JPRB, 0.81222488E-07_JPRB, 0.82602980E-07_JPRB, 0.83773791E-07_JPRB, 0.84709782E-07_JPRB, &
  & 0.85692029E-07_JPRB, 0.86570473E-07_JPRB, 0.87502293E-07_JPRB, 0.88333067E-07_JPRB, 0.89009838E-07_JPRB, 0.89606566E-07_JPRB, &
  & 0.90152419E-07_JPRB, 0.90747591E-07_JPRB, 0.91501441E-07_JPRB, 0.92882317E-07_JPRB /)

RGHG7(:,59, 7) = (/ &
  & 0.85401531E-07_JPRB, 0.83289265E-07_JPRB, 0.82367833E-07_JPRB, 0.81540755E-07_JPRB, 0.80745970E-07_JPRB, 0.80008597E-07_JPRB, &
  & 0.79463817E-07_JPRB, 0.79105334E-07_JPRB, 0.78862563E-07_JPRB, 0.78686092E-07_JPRB, 0.78534043E-07_JPRB, 0.78423781E-07_JPRB, &
  & 0.78356777E-07_JPRB, 0.78440820E-07_JPRB, 0.78685275E-07_JPRB, 0.79216903E-07_JPRB, 0.79960628E-07_JPRB, 0.81040241E-07_JPRB, &
  & 0.82408512E-07_JPRB, 0.84083837E-07_JPRB, 0.86066358E-07_JPRB, 0.88328498E-07_JPRB, 0.89790554E-07_JPRB, 0.89170904E-07_JPRB, &
  & 0.86090523E-07_JPRB, 0.81412729E-07_JPRB, 0.76006970E-07_JPRB, 0.70303976E-07_JPRB, 0.64407061E-07_JPRB, 0.58452795E-07_JPRB, &
  & 0.52696866E-07_JPRB, 0.47421338E-07_JPRB, 0.43032472E-07_JPRB, 0.39822098E-07_JPRB, 0.37960170E-07_JPRB, 0.37458832E-07_JPRB, &
  & 0.38191796E-07_JPRB, 0.39996330E-07_JPRB, 0.42738844E-07_JPRB, 0.46227179E-07_JPRB, 0.50277169E-07_JPRB, 0.54536791E-07_JPRB, &
  & 0.58614916E-07_JPRB, 0.62177371E-07_JPRB, 0.65227376E-07_JPRB, 0.67765782E-07_JPRB, 0.70042766E-07_JPRB, 0.72123207E-07_JPRB, &
  & 0.74070627E-07_JPRB, 0.75892210E-07_JPRB, 0.77569794E-07_JPRB, 0.79108169E-07_JPRB, 0.80379003E-07_JPRB, 0.81604412E-07_JPRB, &
  & 0.82658261E-07_JPRB, 0.83796188E-07_JPRB, 0.84833310E-07_JPRB, 0.85747850E-07_JPRB, 0.86534698E-07_JPRB, 0.87191509E-07_JPRB, &
  & 0.87777643E-07_JPRB, 0.88347939E-07_JPRB, 0.88944347E-07_JPRB, 0.90247156E-07_JPRB /)

RGHG7(:,60, 7) = (/ &
  & 0.81371972E-07_JPRB, 0.79365584E-07_JPRB, 0.78484241E-07_JPRB, 0.77856448E-07_JPRB, 0.77273526E-07_JPRB, 0.76730842E-07_JPRB, &
  & 0.76294633E-07_JPRB, 0.75989995E-07_JPRB, 0.75756923E-07_JPRB, 0.75573794E-07_JPRB, 0.75401204E-07_JPRB, 0.75254768E-07_JPRB, &
  & 0.75118678E-07_JPRB, 0.75091307E-07_JPRB, 0.75191792E-07_JPRB, 0.75542175E-07_JPRB, 0.76163523E-07_JPRB, 0.77131681E-07_JPRB, &
  & 0.78425117E-07_JPRB, 0.80139557E-07_JPRB, 0.82187043E-07_JPRB, 0.84186972E-07_JPRB, 0.85535028E-07_JPRB, 0.84919336E-07_JPRB, &
  & 0.82098332E-07_JPRB, 0.77790219E-07_JPRB, 0.72740427E-07_JPRB, 0.67350776E-07_JPRB, 0.61796477E-07_JPRB, 0.56191787E-07_JPRB, &
  & 0.50740990E-07_JPRB, 0.45768587E-07_JPRB, 0.41605894E-07_JPRB, 0.38533923E-07_JPRB, 0.36714457E-07_JPRB, 0.36187775E-07_JPRB, &
  & 0.36835853E-07_JPRB, 0.38512841E-07_JPRB, 0.41078675E-07_JPRB, 0.44362203E-07_JPRB, 0.48132755E-07_JPRB, 0.52098702E-07_JPRB, &
  & 0.55851444E-07_JPRB, 0.59227354E-07_JPRB, 0.62049089E-07_JPRB, 0.64493364E-07_JPRB, 0.66675860E-07_JPRB, 0.68719466E-07_JPRB, &
  & 0.70649058E-07_JPRB, 0.72453716E-07_JPRB, 0.74164149E-07_JPRB, 0.75724969E-07_JPRB, 0.77193405E-07_JPRB, 0.78496065E-07_JPRB, &
  & 0.79833036E-07_JPRB, 0.81133521E-07_JPRB, 0.82411859E-07_JPRB, 0.83476337E-07_JPRB, 0.84338538E-07_JPRB, 0.85068557E-07_JPRB, &
  & 0.85742265E-07_JPRB, 0.86400938E-07_JPRB, 0.87152920E-07_JPRB, 0.88423036E-07_JPRB /)

RGHG7(:,61, 7) = (/ &
  & 0.77422015E-07_JPRB, 0.75688440E-07_JPRB, 0.75051254E-07_JPRB, 0.74568682E-07_JPRB, 0.74125794E-07_JPRB, 0.73706062E-07_JPRB, &
  & 0.73347941E-07_JPRB, 0.73064683E-07_JPRB, 0.72840187E-07_JPRB, 0.72639935E-07_JPRB, 0.72443527E-07_JPRB, 0.72252199E-07_JPRB, &
  & 0.72051620E-07_JPRB, 0.71906122E-07_JPRB, 0.71886788E-07_JPRB, 0.72092924E-07_JPRB, 0.72593203E-07_JPRB, 0.73488437E-07_JPRB, &
  & 0.74786847E-07_JPRB, 0.76463451E-07_JPRB, 0.78377809E-07_JPRB, 0.80363861E-07_JPRB, 0.81470397E-07_JPRB, 0.80830105E-07_JPRB, &
  & 0.78213716E-07_JPRB, 0.74204408E-07_JPRB, 0.69466779E-07_JPRB, 0.64391585E-07_JPRB, 0.59131658E-07_JPRB, 0.53880544E-07_JPRB, &
  & 0.48766918E-07_JPRB, 0.44126825E-07_JPRB, 0.40237502E-07_JPRB, 0.37347885E-07_JPRB, 0.35619919E-07_JPRB, 0.35102740E-07_JPRB, &
  & 0.35690491E-07_JPRB, 0.37248444E-07_JPRB, 0.39641026E-07_JPRB, 0.42693937E-07_JPRB, 0.46192518E-07_JPRB, 0.49844903E-07_JPRB, &
  & 0.53357319E-07_JPRB, 0.56456951E-07_JPRB, 0.59154988E-07_JPRB, 0.61458756E-07_JPRB, 0.63569829E-07_JPRB, 0.65580409E-07_JPRB, &
  & 0.67481025E-07_JPRB, 0.69299453E-07_JPRB, 0.70986431E-07_JPRB, 0.72602944E-07_JPRB, 0.74090167E-07_JPRB, 0.75558219E-07_JPRB, &
  & 0.77015621E-07_JPRB, 0.78544261E-07_JPRB, 0.80026609E-07_JPRB, 0.81267125E-07_JPRB, 0.82281034E-07_JPRB, 0.83155399E-07_JPRB, &
  & 0.83919254E-07_JPRB, 0.84661764E-07_JPRB, 0.85457557E-07_JPRB, 0.86882196E-07_JPRB /)

RGHG7(:,62, 7) = (/ &
  & 0.74257883E-07_JPRB, 0.72717476E-07_JPRB, 0.72096022E-07_JPRB, 0.71675402E-07_JPRB, 0.71304306E-07_JPRB, 0.70943294E-07_JPRB, &
  & 0.70612991E-07_JPRB, 0.70334366E-07_JPRB, 0.70085783E-07_JPRB, 0.69861578E-07_JPRB, 0.69625109E-07_JPRB, 0.69380107E-07_JPRB, &
  & 0.69115266E-07_JPRB, 0.68871223E-07_JPRB, 0.68742054E-07_JPRB, 0.68830573E-07_JPRB, 0.69252110E-07_JPRB, 0.70085342E-07_JPRB, &
  & 0.71352815E-07_JPRB, 0.72989039E-07_JPRB, 0.74912855E-07_JPRB, 0.76625568E-07_JPRB, 0.77588446E-07_JPRB, 0.76920045E-07_JPRB, &
  & 0.74462051E-07_JPRB, 0.70710229E-07_JPRB, 0.66240865E-07_JPRB, 0.61441796E-07_JPRB, 0.56488840E-07_JPRB, 0.51547548E-07_JPRB, &
  & 0.46820972E-07_JPRB, 0.42535017E-07_JPRB, 0.38953754E-07_JPRB, 0.36293038E-07_JPRB, 0.34693141E-07_JPRB, 0.34218793E-07_JPRB, &
  & 0.34771162E-07_JPRB, 0.36218118E-07_JPRB, 0.38433900E-07_JPRB, 0.41247027E-07_JPRB, 0.44465640E-07_JPRB, 0.47847823E-07_JPRB, &
  & 0.51061861E-07_JPRB, 0.54000861E-07_JPRB, 0.56488386E-07_JPRB, 0.58707844E-07_JPRB, 0.60723771E-07_JPRB, 0.62699520E-07_JPRB, &
  & 0.64571026E-07_JPRB, 0.66387493E-07_JPRB, 0.68064352E-07_JPRB, 0.69700164E-07_JPRB, 0.71220867E-07_JPRB, 0.72756023E-07_JPRB, &
  & 0.74316098E-07_JPRB, 0.76017152E-07_JPRB, 0.77727570E-07_JPRB, 0.79113654E-07_JPRB, 0.80284934E-07_JPRB, 0.81279204E-07_JPRB, &
  & 0.82201687E-07_JPRB, 0.83072187E-07_JPRB, 0.84048189E-07_JPRB, 0.85618844E-07_JPRB /)

RGHG7(:,63, 7) = (/ &
  & 0.71398695E-07_JPRB, 0.69918109E-07_JPRB, 0.69379588E-07_JPRB, 0.69002809E-07_JPRB, 0.68669088E-07_JPRB, 0.68343034E-07_JPRB, &
  & 0.68027624E-07_JPRB, 0.67734746E-07_JPRB, 0.67466821E-07_JPRB, 0.67198918E-07_JPRB, 0.66926823E-07_JPRB, 0.66617176E-07_JPRB, &
  & 0.66275227E-07_JPRB, 0.65944924E-07_JPRB, 0.65722389E-07_JPRB, 0.65734802E-07_JPRB, 0.66093172E-07_JPRB, 0.66893634E-07_JPRB, &
  & 0.68122375E-07_JPRB, 0.69723207E-07_JPRB, 0.71480351E-07_JPRB, 0.73113043E-07_JPRB, 0.73900310E-07_JPRB, 0.73198812E-07_JPRB, &
  & 0.70866285E-07_JPRB, 0.67327939E-07_JPRB, 0.63102995E-07_JPRB, 0.58563995E-07_JPRB, 0.53896663E-07_JPRB, 0.49291636E-07_JPRB, &
  & 0.44928981E-07_JPRB, 0.41056076E-07_JPRB, 0.37816129E-07_JPRB, 0.35409158E-07_JPRB, 0.33969695E-07_JPRB, 0.33565993E-07_JPRB, &
  & 0.34101927E-07_JPRB, 0.35451002E-07_JPRB, 0.37487517E-07_JPRB, 0.40060705E-07_JPRB, 0.43002174E-07_JPRB, 0.46090356E-07_JPRB, &
  & 0.49088886E-07_JPRB, 0.51773274E-07_JPRB, 0.54147147E-07_JPRB, 0.56227087E-07_JPRB, 0.58172557E-07_JPRB, 0.60093882E-07_JPRB, &
  & 0.61933264E-07_JPRB, 0.63730617E-07_JPRB, 0.65401757E-07_JPRB, 0.67040482E-07_JPRB, 0.68589713E-07_JPRB, 0.70172177E-07_JPRB, &
  & 0.71796308E-07_JPRB, 0.73578299E-07_JPRB, 0.75439551E-07_JPRB, 0.76980591E-07_JPRB, 0.78281857E-07_JPRB, 0.79444504E-07_JPRB, &
  & 0.80482025E-07_JPRB, 0.81470269E-07_JPRB, 0.82607187E-07_JPRB, 0.84415582E-07_JPRB /)

RGHG7(:,64, 7) = (/ &
  & 0.68911625E-07_JPRB, 0.67490184E-07_JPRB, 0.66931058E-07_JPRB, 0.66557462E-07_JPRB, 0.66235373E-07_JPRB, 0.65916986E-07_JPRB, &
  & 0.65598279E-07_JPRB, 0.65284873E-07_JPRB, 0.64976675E-07_JPRB, 0.64666821E-07_JPRB, 0.64327743E-07_JPRB, 0.63957195E-07_JPRB, &
  & 0.63534095E-07_JPRB, 0.63126961E-07_JPRB, 0.62842055E-07_JPRB, 0.62808986E-07_JPRB, 0.63139076E-07_JPRB, 0.63900558E-07_JPRB, &
  & 0.65094810E-07_JPRB, 0.66619002E-07_JPRB, 0.68321810E-07_JPRB, 0.69760823E-07_JPRB, 0.70415247E-07_JPRB, 0.69676894E-07_JPRB, &
  & 0.67450245E-07_JPRB, 0.64101329E-07_JPRB, 0.60100035E-07_JPRB, 0.55820127E-07_JPRB, 0.51441180E-07_JPRB, 0.47191463E-07_JPRB, &
  & 0.43240188E-07_JPRB, 0.39771482E-07_JPRB, 0.36903870E-07_JPRB, 0.34765119E-07_JPRB, 0.33502126E-07_JPRB, 0.33183170E-07_JPRB, &
  & 0.33718035E-07_JPRB, 0.34977170E-07_JPRB, 0.36837122E-07_JPRB, 0.39168249E-07_JPRB, 0.41832916E-07_JPRB, 0.44667594E-07_JPRB, &
  & 0.47406814E-07_JPRB, 0.49922104E-07_JPRB, 0.52119702E-07_JPRB, 0.54084001E-07_JPRB, 0.55945936E-07_JPRB, 0.57804311E-07_JPRB, &
  & 0.59600954E-07_JPRB, 0.61365924E-07_JPRB, 0.63016373E-07_JPRB, 0.64652980E-07_JPRB, 0.66203675E-07_JPRB, 0.67810852E-07_JPRB, &
  & 0.69462722E-07_JPRB, 0.71333680E-07_JPRB, 0.73272275E-07_JPRB, 0.74903504E-07_JPRB, 0.76350176E-07_JPRB, 0.77604490E-07_JPRB, &
  & 0.78758788E-07_JPRB, 0.79845684E-07_JPRB, 0.81114557E-07_JPRB, 0.83139675E-07_JPRB /)

RGHG7(:,65, 7) = (/ &
  & 0.66647821E-07_JPRB, 0.65194079E-07_JPRB, 0.64637895E-07_JPRB, 0.64259972E-07_JPRB, 0.63934927E-07_JPRB, 0.63618920E-07_JPRB, &
  & 0.63296014E-07_JPRB, 0.62955010E-07_JPRB, 0.62609963E-07_JPRB, 0.62239771E-07_JPRB, 0.61842222E-07_JPRB, 0.61381883E-07_JPRB, &
  & 0.60889782E-07_JPRB, 0.60425968E-07_JPRB, 0.60115006E-07_JPRB, 0.60067201E-07_JPRB, 0.60377651E-07_JPRB, 0.61115728E-07_JPRB, &
  & 0.62262302E-07_JPRB, 0.63726496E-07_JPRB, 0.65293364E-07_JPRB, 0.66627528E-07_JPRB, 0.67149969E-07_JPRB, 0.66380203E-07_JPRB, &
  & 0.64240481E-07_JPRB, 0.61076683E-07_JPRB, 0.57305432E-07_JPRB, 0.53289419E-07_JPRB, 0.49228177E-07_JPRB, 0.45341540E-07_JPRB, &
  & 0.41814971E-07_JPRB, 0.38780787E-07_JPRB, 0.36287073E-07_JPRB, 0.34422776E-07_JPRB, 0.33329563E-07_JPRB, 0.33097283E-07_JPRB, &
  & 0.33637104E-07_JPRB, 0.34814537E-07_JPRB, 0.36509586E-07_JPRB, 0.38610647E-07_JPRB, 0.41011635E-07_JPRB, 0.43581277E-07_JPRB, &
  & 0.46107932E-07_JPRB, 0.48410907E-07_JPRB, 0.50467662E-07_JPRB, 0.52300969E-07_JPRB, 0.54081934E-07_JPRB, 0.55859630E-07_JPRB, &
  & 0.57603270E-07_JPRB, 0.59326617E-07_JPRB, 0.60944359E-07_JPRB, 0.62565412E-07_JPRB, 0.64103304E-07_JPRB, 0.65724045E-07_JPRB, &
  & 0.67385770E-07_JPRB, 0.69278087E-07_JPRB, 0.71279153E-07_JPRB, 0.72962351E-07_JPRB, 0.74483161E-07_JPRB, 0.75843296E-07_JPRB, &
  & 0.77059198E-07_JPRB, 0.78173663E-07_JPRB, 0.79546510E-07_JPRB, 0.81751395E-07_JPRB /)

RGHG7(:,66, 7) = (/ &
  & 0.64568894E-07_JPRB, 0.63090063E-07_JPRB, 0.62496518E-07_JPRB, 0.62090976E-07_JPRB, 0.61749311E-07_JPRB, 0.61420188E-07_JPRB, &
  & 0.61086148E-07_JPRB, 0.60725746E-07_JPRB, 0.60327409E-07_JPRB, 0.59906348E-07_JPRB, 0.59423289E-07_JPRB, 0.58908235E-07_JPRB, &
  & 0.58354281E-07_JPRB, 0.57880118E-07_JPRB, 0.57571182E-07_JPRB, 0.57525966E-07_JPRB, 0.57824998E-07_JPRB, 0.58530233E-07_JPRB, &
  & 0.59626849E-07_JPRB, 0.61010716E-07_JPRB, 0.62494479E-07_JPRB, 0.63683622E-07_JPRB, 0.64099723E-07_JPRB, 0.63304675E-07_JPRB, &
  & 0.61268537E-07_JPRB, 0.58294518E-07_JPRB, 0.54771487E-07_JPRB, 0.51044964E-07_JPRB, 0.47330669E-07_JPRB, 0.43819856E-07_JPRB, &
  & 0.40719481E-07_JPRB, 0.38112866E-07_JPRB, 0.35982470E-07_JPRB, 0.34383884E-07_JPRB, 0.33456065E-07_JPRB, 0.33304175E-07_JPRB, &
  & 0.33849805E-07_JPRB, 0.34954127E-07_JPRB, 0.36495543E-07_JPRB, 0.38379152E-07_JPRB, 0.40540975E-07_JPRB, 0.42870742E-07_JPRB, &
  & 0.45178300E-07_JPRB, 0.47297853E-07_JPRB, 0.49189389E-07_JPRB, 0.50909918E-07_JPRB, 0.52586216E-07_JPRB, 0.54277187E-07_JPRB, &
  & 0.55958857E-07_JPRB, 0.57626750E-07_JPRB, 0.59201223E-07_JPRB, 0.60790157E-07_JPRB, 0.62304004E-07_JPRB, 0.63907137E-07_JPRB, &
  & 0.65560030E-07_JPRB, 0.67452248E-07_JPRB, 0.69472321E-07_JPRB, 0.71186847E-07_JPRB, 0.72749451E-07_JPRB, 0.74156553E-07_JPRB, &
  & 0.75411762E-07_JPRB, 0.76542342E-07_JPRB, 0.77937607E-07_JPRB, 0.80244781E-07_JPRB /)

RGHG7(:,67, 7) = (/ &
  & 0.62664789E-07_JPRB, 0.61098881E-07_JPRB, 0.60450269E-07_JPRB, 0.60001902E-07_JPRB, 0.59623282E-07_JPRB, 0.59274651E-07_JPRB, &
  & 0.58924137E-07_JPRB, 0.58535601E-07_JPRB, 0.58105460E-07_JPRB, 0.57614209E-07_JPRB, 0.57095981E-07_JPRB, 0.56518985E-07_JPRB, &
  & 0.55967565E-07_JPRB, 0.55507837E-07_JPRB, 0.55212332E-07_JPRB, 0.55176539E-07_JPRB, 0.55466778E-07_JPRB, 0.56141428E-07_JPRB, &
  & 0.57182465E-07_JPRB, 0.58489114E-07_JPRB, 0.59853292E-07_JPRB, 0.60936301E-07_JPRB, 0.61265879E-07_JPRB, 0.60472757E-07_JPRB, &
  & 0.58551400E-07_JPRB, 0.55788398E-07_JPRB, 0.52547311E-07_JPRB, 0.49127017E-07_JPRB, 0.45772985E-07_JPRB, 0.42659217E-07_JPRB, &
  & 0.39977152E-07_JPRB, 0.37773603E-07_JPRB, 0.35979433E-07_JPRB, 0.34626034E-07_JPRB, 0.33855358E-07_JPRB, 0.33779465E-07_JPRB, &
  & 0.34331624E-07_JPRB, 0.35372000E-07_JPRB, 0.36780087E-07_JPRB, 0.38480614E-07_JPRB, 0.40415880E-07_JPRB, 0.42531511E-07_JPRB, &
  & 0.44632227E-07_JPRB, 0.46573181E-07_JPRB, 0.48310135E-07_JPRB, 0.49908710E-07_JPRB, 0.51473645E-07_JPRB, 0.53068927E-07_JPRB, &
  & 0.54681241E-07_JPRB, 0.56280648E-07_JPRB, 0.57805416E-07_JPRB, 0.59350249E-07_JPRB, 0.60828562E-07_JPRB, 0.62396467E-07_JPRB, &
  & 0.64016923E-07_JPRB, 0.65872911E-07_JPRB, 0.67883413E-07_JPRB, 0.69597995E-07_JPRB, 0.71161374E-07_JPRB, 0.72590865E-07_JPRB, &
  & 0.73860420E-07_JPRB, 0.74957626E-07_JPRB, 0.76344030E-07_JPRB, 0.78689631E-07_JPRB /)

RGHG7(:,68, 7) = (/ &
  & 0.60913258E-07_JPRB, 0.59224224E-07_JPRB, 0.58484996E-07_JPRB, 0.57966375E-07_JPRB, 0.57538504E-07_JPRB, 0.57151645E-07_JPRB, &
  & 0.56784856E-07_JPRB, 0.56367359E-07_JPRB, 0.55896400E-07_JPRB, 0.55387819E-07_JPRB, 0.54814283E-07_JPRB, 0.54262312E-07_JPRB, &
  & 0.53729700E-07_JPRB, 0.53308430E-07_JPRB, 0.53041195E-07_JPRB, 0.53019736E-07_JPRB, 0.53302401E-07_JPRB, 0.53942152E-07_JPRB, &
  & 0.54920314E-07_JPRB, 0.56137051E-07_JPRB, 0.57403213E-07_JPRB, 0.58375083E-07_JPRB, 0.58645359E-07_JPRB, 0.57885554E-07_JPRB, &
  & 0.56101982E-07_JPRB, 0.53577256E-07_JPRB, 0.50630597E-07_JPRB, 0.47553918E-07_JPRB, 0.44564882E-07_JPRB, 0.41844782E-07_JPRB, &
  & 0.39560060E-07_JPRB, 0.37726124E-07_JPRB, 0.36246739E-07_JPRB, 0.35119488E-07_JPRB, 0.34498594E-07_JPRB, 0.34494906E-07_JPRB, &
  & 0.35053194E-07_JPRB, 0.36035502E-07_JPRB, 0.37326899E-07_JPRB, 0.38855696E-07_JPRB, 0.40610484E-07_JPRB, 0.42527052E-07_JPRB, &
  & 0.44452943E-07_JPRB, 0.46220247E-07_JPRB, 0.47811152E-07_JPRB, 0.49285870E-07_JPRB, 0.50736201E-07_JPRB, 0.52238970E-07_JPRB, &
  & 0.53766627E-07_JPRB, 0.55288513E-07_JPRB, 0.56757166E-07_JPRB, 0.58241842E-07_JPRB, 0.59674576E-07_JPRB, 0.61190846E-07_JPRB, &
  & 0.62760073E-07_JPRB, 0.64559053E-07_JPRB, 0.66525338E-07_JPRB, 0.68208571E-07_JPRB, 0.69745965E-07_JPRB, 0.71147028E-07_JPRB, &
  & 0.72412547E-07_JPRB, 0.73469607E-07_JPRB, 0.74782825E-07_JPRB, 0.77100822E-07_JPRB /)

RGHG7(:,69, 7) = (/ &
  & 0.59357919E-07_JPRB, 0.57433660E-07_JPRB, 0.56562026E-07_JPRB, 0.55950249E-07_JPRB, 0.55458553E-07_JPRB, 0.55037344E-07_JPRB, &
  & 0.54645714E-07_JPRB, 0.54211480E-07_JPRB, 0.53714480E-07_JPRB, 0.53177558E-07_JPRB, 0.52640051E-07_JPRB, 0.52109570E-07_JPRB, &
  & 0.51631041E-07_JPRB, 0.51249117E-07_JPRB, 0.51020336E-07_JPRB, 0.51021171E-07_JPRB, 0.51304212E-07_JPRB, 0.51913236E-07_JPRB, &
  & 0.52827492E-07_JPRB, 0.53956878E-07_JPRB, 0.55112842E-07_JPRB, 0.55997099E-07_JPRB, 0.56235745E-07_JPRB, 0.55538564E-07_JPRB, &
  & 0.53926080E-07_JPRB, 0.51652226E-07_JPRB, 0.49021615E-07_JPRB, 0.46294861E-07_JPRB, 0.43677968E-07_JPRB, 0.41342748E-07_JPRB, &
  & 0.39439268E-07_JPRB, 0.37942979E-07_JPRB, 0.36755051E-07_JPRB, 0.35844437E-07_JPRB, 0.35364042E-07_JPRB, 0.35430453E-07_JPRB, &
  & 0.35995647E-07_JPRB, 0.36929819E-07_JPRB, 0.38120493E-07_JPRB, 0.39515747E-07_JPRB, 0.41099632E-07_JPRB, 0.42847223E-07_JPRB, &
  & 0.44601375E-07_JPRB, 0.46212524E-07_JPRB, 0.47668433E-07_JPRB, 0.49020279E-07_JPRB, 0.50367788E-07_JPRB, 0.51769408E-07_JPRB, &
  & 0.53216727E-07_JPRB, 0.54654368E-07_JPRB, 0.56059207E-07_JPRB, 0.57474910E-07_JPRB, 0.58853260E-07_JPRB, 0.60301815E-07_JPRB, &
  & 0.61795674E-07_JPRB, 0.63511088E-07_JPRB, 0.65407939E-07_JPRB, 0.67025447E-07_JPRB, 0.68504654E-07_JPRB, 0.69851239E-07_JPRB, &
  & 0.71074304E-07_JPRB, 0.72077604E-07_JPRB, 0.73280887E-07_JPRB, 0.75463653E-07_JPRB /)

RGHG7(:,70, 7) = (/ &
  & 0.57918470E-07_JPRB, 0.55666629E-07_JPRB, 0.54619250E-07_JPRB, 0.53913343E-07_JPRB, 0.53360221E-07_JPRB, 0.52909485E-07_JPRB, &
  & 0.52511361E-07_JPRB, 0.52047589E-07_JPRB, 0.51549730E-07_JPRB, 0.51029662E-07_JPRB, 0.50537636E-07_JPRB, 0.50057206E-07_JPRB, &
  & 0.49647344E-07_JPRB, 0.49325092E-07_JPRB, 0.49146294E-07_JPRB, 0.49177743E-07_JPRB, 0.49462194E-07_JPRB, 0.50040924E-07_JPRB, &
  & 0.50892151E-07_JPRB, 0.51931938E-07_JPRB, 0.52992409E-07_JPRB, 0.53799500E-07_JPRB, 0.54025957E-07_JPRB, 0.53426263E-07_JPRB, &
  & 0.52004392E-07_JPRB, 0.50004573E-07_JPRB, 0.47695583E-07_JPRB, 0.45327038E-07_JPRB, 0.43077439E-07_JPRB, 0.41119709E-07_JPRB, &
  & 0.39560934E-07_JPRB, 0.38386393E-07_JPRB, 0.37468375E-07_JPRB, 0.36769457E-07_JPRB, 0.36427387E-07_JPRB, 0.36560767E-07_JPRB, &
  & 0.37133635E-07_JPRB, 0.38021597E-07_JPRB, 0.39123350E-07_JPRB, 0.40392131E-07_JPRB, 0.41837318E-07_JPRB, 0.43441403E-07_JPRB, &
  & 0.45044754E-07_JPRB, 0.46524487E-07_JPRB, 0.47850182E-07_JPRB, 0.49095327E-07_JPRB, 0.50339583E-07_JPRB, 0.51649899E-07_JPRB, &
  & 0.53010570E-07_JPRB, 0.54364268E-07_JPRB, 0.55695530E-07_JPRB, 0.57031119E-07_JPRB, 0.58347283E-07_JPRB, 0.59711645E-07_JPRB, &
  & 0.61128652E-07_JPRB, 0.62737833E-07_JPRB, 0.64530703E-07_JPRB, 0.66055591E-07_JPRB, 0.67449093E-07_JPRB, 0.68702299E-07_JPRB, &
  & 0.69861564E-07_JPRB, 0.70800155E-07_JPRB, 0.71887435E-07_JPRB, 0.73902619E-07_JPRB /)

RGHG7(:,71, 7) = (/ &
  & 0.56554175E-07_JPRB, 0.53841244E-07_JPRB, 0.52619541E-07_JPRB, 0.51811568E-07_JPRB, 0.51225715E-07_JPRB, 0.50751041E-07_JPRB, &
  & 0.50345928E-07_JPRB, 0.49881557E-07_JPRB, 0.49386575E-07_JPRB, 0.48929788E-07_JPRB, 0.48486481E-07_JPRB, 0.48082530E-07_JPRB, &
  & 0.47745047E-07_JPRB, 0.47494261E-07_JPRB, 0.47378048E-07_JPRB, 0.47453572E-07_JPRB, 0.47754039E-07_JPRB, 0.48314018E-07_JPRB, &
  & 0.49109968E-07_JPRB, 0.50069172E-07_JPRB, 0.51039020E-07_JPRB, 0.51783442E-07_JPRB, 0.52018599E-07_JPRB, 0.51531021E-07_JPRB, &
  & 0.50327603E-07_JPRB, 0.48614858E-07_JPRB, 0.46635805E-07_JPRB, 0.44622634E-07_JPRB, 0.42742119E-07_JPRB, 0.41131223E-07_JPRB, &
  & 0.39911217E-07_JPRB, 0.39035005E-07_JPRB, 0.38376275E-07_JPRB, 0.37878252E-07_JPRB, 0.37670077E-07_JPRB, 0.37871267E-07_JPRB, &
  & 0.38453290E-07_JPRB, 0.39306865E-07_JPRB, 0.40335323E-07_JPRB, 0.41503380E-07_JPRB, 0.42828500E-07_JPRB, 0.44283944E-07_JPRB, &
  & 0.45764075E-07_JPRB, 0.47107267E-07_JPRB, 0.48332677E-07_JPRB, 0.49474099E-07_JPRB, 0.50630405E-07_JPRB, 0.51853508E-07_JPRB, &
  & 0.53131100E-07_JPRB, 0.54399855E-07_JPRB, 0.55654642E-07_JPRB, 0.56910565E-07_JPRB, 0.58153873E-07_JPRB, 0.59431155E-07_JPRB, &
  & 0.60747411E-07_JPRB, 0.62231180E-07_JPRB, 0.63895975E-07_JPRB, 0.65302025E-07_JPRB, 0.66571467E-07_JPRB, 0.67723740E-07_JPRB, &
  & 0.68774135E-07_JPRB, 0.69647342E-07_JPRB, 0.70594417E-07_JPRB, 0.72333165E-07_JPRB /)

RGHG7(:,72, 7) = (/ &
  & 0.55105986E-07_JPRB, 0.51920452E-07_JPRB, 0.50491437E-07_JPRB, 0.49636000E-07_JPRB, 0.49016627E-07_JPRB, 0.48543480E-07_JPRB, &
  & 0.48133529E-07_JPRB, 0.47676110E-07_JPRB, 0.47254456E-07_JPRB, 0.46822198E-07_JPRB, 0.46485361E-07_JPRB, 0.46156817E-07_JPRB, &
  & 0.45916504E-07_JPRB, 0.45756302E-07_JPRB, 0.45715741E-07_JPRB, 0.45843311E-07_JPRB, 0.46170445E-07_JPRB, 0.46718423E-07_JPRB, &
  & 0.47476661E-07_JPRB, 0.48362697E-07_JPRB, 0.49256599E-07_JPRB, 0.49950941E-07_JPRB, 0.50206356E-07_JPRB, 0.49848115E-07_JPRB, &
  & 0.48874689E-07_JPRB, 0.47459462E-07_JPRB, 0.45818929E-07_JPRB, 0.44155929E-07_JPRB, 0.42618627E-07_JPRB, 0.41384062E-07_JPRB, &
  & 0.40433555E-07_JPRB, 0.39845521E-07_JPRB, 0.39434191E-07_JPRB, 0.39124746E-07_JPRB, 0.39056573E-07_JPRB, 0.39325609E-07_JPRB, &
  & 0.39919737E-07_JPRB, 0.40736726E-07_JPRB, 0.41696193E-07_JPRB, 0.42772523E-07_JPRB, 0.43984482E-07_JPRB, 0.45340684E-07_JPRB, &
  & 0.46692531E-07_JPRB, 0.47948376E-07_JPRB, 0.49063122E-07_JPRB, 0.50125994E-07_JPRB, 0.51200320E-07_JPRB, 0.52344642E-07_JPRB, &
  & 0.53534222E-07_JPRB, 0.54721710E-07_JPRB, 0.55892869E-07_JPRB, 0.57063769E-07_JPRB, 0.58230842E-07_JPRB, 0.59408453E-07_JPRB, &
  & 0.60630335E-07_JPRB, 0.61991564E-07_JPRB, 0.63482311E-07_JPRB, 0.64752591E-07_JPRB, 0.65888514E-07_JPRB, 0.66903453E-07_JPRB, &
  & 0.67848561E-07_JPRB, 0.68639373E-07_JPRB, 0.69475071E-07_JPRB, 0.70957597E-07_JPRB /)

RGHG7(:,73, 7) = (/ &
  & 0.53530762E-07_JPRB, 0.49761095E-07_JPRB, 0.48241358E-07_JPRB, 0.47350834E-07_JPRB, 0.46747946E-07_JPRB, 0.46284143E-07_JPRB, &
  & 0.45886576E-07_JPRB, 0.45489074E-07_JPRB, 0.45078718E-07_JPRB, 0.44783075E-07_JPRB, 0.44482221E-07_JPRB, 0.44283741E-07_JPRB, &
  & 0.44132840E-07_JPRB, 0.44080210E-07_JPRB, 0.44134250E-07_JPRB, 0.44335845E-07_JPRB, 0.44702109E-07_JPRB, 0.45259931E-07_JPRB, &
  & 0.45986695E-07_JPRB, 0.46817298E-07_JPRB, 0.47647561E-07_JPRB, 0.48302649E-07_JPRB, 0.48589339E-07_JPRB, 0.48367625E-07_JPRB, &
  & 0.47631428E-07_JPRB, 0.46520849E-07_JPRB, 0.45211717E-07_JPRB, 0.43899469E-07_JPRB, 0.42704244E-07_JPRB, 0.41815863E-07_JPRB, &
  & 0.41143551E-07_JPRB, 0.40806412E-07_JPRB, 0.40630827E-07_JPRB, 0.40511100E-07_JPRB, 0.40573010E-07_JPRB, 0.40915783E-07_JPRB, &
  & 0.41524526E-07_JPRB, 0.42320192E-07_JPRB, 0.43226454E-07_JPRB, 0.44224841E-07_JPRB, 0.45344148E-07_JPRB, 0.46575675E-07_JPRB, &
  & 0.47828717E-07_JPRB, 0.48972986E-07_JPRB, 0.50014453E-07_JPRB, 0.51001475E-07_JPRB, 0.52005799E-07_JPRB, 0.53070849E-07_JPRB, &
  & 0.54183097E-07_JPRB, 0.55285454E-07_JPRB, 0.56375441E-07_JPRB, 0.57461062E-07_JPRB, 0.58544110E-07_JPRB, 0.59627290E-07_JPRB, &
  & 0.60747226E-07_JPRB, 0.61950516E-07_JPRB, 0.63276993E-07_JPRB, 0.64390193E-07_JPRB, 0.65377613E-07_JPRB, 0.66264093E-07_JPRB, &
  & 0.67082169E-07_JPRB, 0.67791603E-07_JPRB, 0.68529197E-07_JPRB, 0.69768269E-07_JPRB /)

RGHG7(:,74, 7) = (/ &
  & 0.51404538E-07_JPRB, 0.47394394E-07_JPRB, 0.45868234E-07_JPRB, 0.45021338E-07_JPRB, 0.44465200E-07_JPRB, 0.44031857E-07_JPRB, &
  & 0.43681517E-07_JPRB, 0.43317826E-07_JPRB, 0.43026620E-07_JPRB, 0.42753594E-07_JPRB, 0.42600959E-07_JPRB, 0.42485986E-07_JPRB, &
  & 0.42461490E-07_JPRB, 0.42521116E-07_JPRB, 0.42670049E-07_JPRB, 0.42948141E-07_JPRB, 0.43358995E-07_JPRB, 0.43932140E-07_JPRB, &
  & 0.44639179E-07_JPRB, 0.45427736E-07_JPRB, 0.46207983E-07_JPRB, 0.46835996E-07_JPRB, 0.47165475E-07_JPRB, 0.47084395E-07_JPRB, &
  & 0.46585843E-07_JPRB, 0.45767177E-07_JPRB, 0.44795080E-07_JPRB, 0.43829381E-07_JPRB, 0.42992241E-07_JPRB, 0.42359837E-07_JPRB, &
  & 0.41997584E-07_JPRB, 0.41878234E-07_JPRB, 0.41890981E-07_JPRB, 0.41958348E-07_JPRB, 0.42155392E-07_JPRB, 0.42572029E-07_JPRB, &
  & 0.43200089E-07_JPRB, 0.43968750E-07_JPRB, 0.44823022E-07_JPRB, 0.45753435E-07_JPRB, 0.46787981E-07_JPRB, 0.47933302E-07_JPRB, &
  & 0.49092513E-07_JPRB, 0.50162452E-07_JPRB, 0.51126513E-07_JPRB, 0.52054506E-07_JPRB, 0.52989861E-07_JPRB, 0.53986444E-07_JPRB, &
  & 0.55007959E-07_JPRB, 0.56032963E-07_JPRB, 0.57031396E-07_JPRB, 0.58031333E-07_JPRB, 0.59023343E-07_JPRB, 0.60005497E-07_JPRB, &
  & 0.61009665E-07_JPRB, 0.62089889E-07_JPRB, 0.63223894E-07_JPRB, 0.64192164E-07_JPRB, 0.65032609E-07_JPRB, 0.65797927E-07_JPRB, &
  & 0.66489910E-07_JPRB, 0.67122961E-07_JPRB, 0.67753355E-07_JPRB, 0.68796680E-07_JPRB /)

RGHG7(:,75, 7) = (/ &
  & 0.49062947E-07_JPRB, 0.44965695E-07_JPRB, 0.43495284E-07_JPRB, 0.42738566E-07_JPRB, 0.42234159E-07_JPRB, 0.41874625E-07_JPRB, &
  & 0.41578819E-07_JPRB, 0.41300794E-07_JPRB, 0.41051116E-07_JPRB, 0.40905270E-07_JPRB, 0.40818996E-07_JPRB, 0.40816751E-07_JPRB, &
  & 0.40911232E-07_JPRB, 0.41078764E-07_JPRB, 0.41326235E-07_JPRB, 0.41680753E-07_JPRB, 0.42145036E-07_JPRB, 0.42730644E-07_JPRB, &
  & 0.43424645E-07_JPRB, 0.44183199E-07_JPRB, 0.44924946E-07_JPRB, 0.45544198E-07_JPRB, 0.45923848E-07_JPRB, 0.45985797E-07_JPRB, &
  & 0.45712294E-07_JPRB, 0.45183267E-07_JPRB, 0.44539696E-07_JPRB, 0.43926317E-07_JPRB, 0.43394532E-07_JPRB, 0.43046615E-07_JPRB, &
  & 0.42947139E-07_JPRB, 0.43056087E-07_JPRB, 0.43261714E-07_JPRB, 0.43507608E-07_JPRB, 0.43832515E-07_JPRB, 0.44327905E-07_JPRB, &
  & 0.44980467E-07_JPRB, 0.45738130E-07_JPRB, 0.46553360E-07_JPRB, 0.47422148E-07_JPRB, 0.48374357E-07_JPRB, 0.49418414E-07_JPRB, &
  & 0.50475958E-07_JPRB, 0.51456595E-07_JPRB, 0.52358317E-07_JPRB, 0.53228142E-07_JPRB, 0.54108309E-07_JPRB, 0.55032032E-07_JPRB, &
  & 0.55980919E-07_JPRB, 0.56912665E-07_JPRB, 0.57829812E-07_JPRB, 0.58735640E-07_JPRB, 0.59632605E-07_JPRB, 0.60512029E-07_JPRB, &
  & 0.61399753E-07_JPRB, 0.62321313E-07_JPRB, 0.63297563E-07_JPRB, 0.64114460E-07_JPRB, 0.64836783E-07_JPRB, 0.65469060E-07_JPRB, &
  & 0.66069354E-07_JPRB, 0.66596172E-07_JPRB, 0.67144185E-07_JPRB, 0.68007566E-07_JPRB /)

RGHG7(:,76, 7) = (/ &
  & 0.46586894E-07_JPRB, 0.42539650E-07_JPRB, 0.41201911E-07_JPRB, 0.40532285E-07_JPRB, 0.40140751E-07_JPRB, 0.39851706E-07_JPRB, &
  & 0.39637520E-07_JPRB, 0.39429665E-07_JPRB, 0.39293695E-07_JPRB, 0.39230951E-07_JPRB, 0.39246867E-07_JPRB, 0.39372708E-07_JPRB, &
  & 0.39543860E-07_JPRB, 0.39815024E-07_JPRB, 0.40140634E-07_JPRB, 0.40548798E-07_JPRB, 0.41048416E-07_JPRB, 0.41655003E-07_JPRB, &
  & 0.42335408E-07_JPRB, 0.43068049E-07_JPRB, 0.43791214E-07_JPRB, 0.44409241E-07_JPRB, 0.44849504E-07_JPRB, 0.45052055E-07_JPRB, &
  & 0.44993389E-07_JPRB, 0.44737689E-07_JPRB, 0.44434419E-07_JPRB, 0.44126917E-07_JPRB, 0.43889766E-07_JPRB, 0.43845709E-07_JPRB, &
  & 0.43960007E-07_JPRB, 0.44248289E-07_JPRB, 0.44602238E-07_JPRB, 0.44995044E-07_JPRB, 0.45450047E-07_JPRB, 0.46020684E-07_JPRB, &
  & 0.46700372E-07_JPRB, 0.47447365E-07_JPRB, 0.48232764E-07_JPRB, 0.49060951E-07_JPRB, 0.49957137E-07_JPRB, 0.50926442E-07_JPRB, &
  & 0.51905772E-07_JPRB, 0.52819146E-07_JPRB, 0.53665762E-07_JPRB, 0.54483902E-07_JPRB, 0.55302490E-07_JPRB, 0.56159251E-07_JPRB, &
  & 0.57021847E-07_JPRB, 0.57870210E-07_JPRB, 0.58694628E-07_JPRB, 0.59505826E-07_JPRB, 0.60300657E-07_JPRB, 0.61066807E-07_JPRB, &
  & 0.61834456E-07_JPRB, 0.62622938E-07_JPRB, 0.63445263E-07_JPRB, 0.64137417E-07_JPRB, 0.64727949E-07_JPRB, 0.65274726E-07_JPRB, &
  & 0.65753802E-07_JPRB, 0.66204400E-07_JPRB, 0.66645924E-07_JPRB, 0.67367139E-07_JPRB /)

RGHG7(:,77, 7) = (/ &
  & 0.44012015E-07_JPRB, 0.40194028E-07_JPRB, 0.38995005E-07_JPRB, 0.38479570E-07_JPRB, 0.38179948E-07_JPRB, 0.38000124E-07_JPRB, &
  & 0.37879758E-07_JPRB, 0.37770661E-07_JPRB, 0.37738086E-07_JPRB, 0.37759420E-07_JPRB, 0.37913502E-07_JPRB, 0.38074745E-07_JPRB, &
  & 0.38368334E-07_JPRB, 0.38698946E-07_JPRB, 0.39093802E-07_JPRB, 0.39556902E-07_JPRB, 0.40088029E-07_JPRB, 0.40701838E-07_JPRB, &
  & 0.41372985E-07_JPRB, 0.42090818E-07_JPRB, 0.42794053E-07_JPRB, 0.43425931E-07_JPRB, 0.43928964E-07_JPRB, 0.44265445E-07_JPRB, &
  & 0.44402967E-07_JPRB, 0.44422830E-07_JPRB, 0.44429452E-07_JPRB, 0.44384660E-07_JPRB, 0.44484789E-07_JPRB, 0.44661853E-07_JPRB, &
  & 0.45011575E-07_JPRB, 0.45483272E-07_JPRB, 0.46020254E-07_JPRB, 0.46565148E-07_JPRB, 0.47143498E-07_JPRB, 0.47795027E-07_JPRB, &
  & 0.48504653E-07_JPRB, 0.49244040E-07_JPRB, 0.49996299E-07_JPRB, 0.50770897E-07_JPRB, 0.51593577E-07_JPRB, 0.52472444E-07_JPRB, &
  & 0.53356935E-07_JPRB, 0.54199930E-07_JPRB, 0.54991684E-07_JPRB, 0.55762296E-07_JPRB, 0.56531508E-07_JPRB, 0.57315507E-07_JPRB, &
  & 0.58097040E-07_JPRB, 0.58855633E-07_JPRB, 0.59590764E-07_JPRB, 0.60306419E-07_JPRB, 0.60996143E-07_JPRB, 0.61662156E-07_JPRB, &
  & 0.62304984E-07_JPRB, 0.62961206E-07_JPRB, 0.63629940E-07_JPRB, 0.64195383E-07_JPRB, 0.64696351E-07_JPRB, 0.65124397E-07_JPRB, &
  & 0.65532483E-07_JPRB, 0.65871703E-07_JPRB, 0.66223642E-07_JPRB, 0.66834971E-07_JPRB /)

RGHG7(:,78, 7) = (/ &
  & 0.41388240E-07_JPRB, 0.37972992E-07_JPRB, 0.36999790E-07_JPRB, 0.36634155E-07_JPRB, 0.36478959E-07_JPRB, 0.36399005E-07_JPRB, &
  & 0.36381810E-07_JPRB, 0.36392024E-07_JPRB, 0.36473082E-07_JPRB, 0.36636646E-07_JPRB, 0.36828116E-07_JPRB, 0.37140818E-07_JPRB, &
  & 0.37446235E-07_JPRB, 0.37834347E-07_JPRB, 0.38266311E-07_JPRB, 0.38755061E-07_JPRB, 0.39309249E-07_JPRB, 0.39918891E-07_JPRB, &
  & 0.40582048E-07_JPRB, 0.41274546E-07_JPRB, 0.41971468E-07_JPRB, 0.42610154E-07_JPRB, 0.43175334E-07_JPRB, 0.43626024E-07_JPRB, &
  & 0.43939345E-07_JPRB, 0.44221558E-07_JPRB, 0.44463217E-07_JPRB, 0.44696996E-07_JPRB, 0.45057725E-07_JPRB, 0.45441784E-07_JPRB, &
  & 0.45958643E-07_JPRB, 0.46526331E-07_JPRB, 0.47136417E-07_JPRB, 0.47766097E-07_JPRB, 0.48418119E-07_JPRB, 0.49124885E-07_JPRB, &
  & 0.49874973E-07_JPRB, 0.50642029E-07_JPRB, 0.51414418E-07_JPRB, 0.52195119E-07_JPRB, 0.52999972E-07_JPRB, 0.53831382E-07_JPRB, &
  & 0.54657974E-07_JPRB, 0.55443245E-07_JPRB, 0.56192597E-07_JPRB, 0.56919632E-07_JPRB, 0.57637209E-07_JPRB, 0.58354463E-07_JPRB, &
  & 0.59059566E-07_JPRB, 0.59738326E-07_JPRB, 0.60389617E-07_JPRB, 0.61015911E-07_JPRB, 0.61613839E-07_JPRB, 0.62177840E-07_JPRB, &
  & 0.62725526E-07_JPRB, 0.63264764E-07_JPRB, 0.63815172E-07_JPRB, 0.64278566E-07_JPRB, 0.64675007E-07_JPRB, 0.65025347E-07_JPRB, &
  & 0.65349369E-07_JPRB, 0.65596382E-07_JPRB, 0.65865507E-07_JPRB, 0.66347674E-07_JPRB /)

RGHG7(:,79, 7) = (/ &
  & 0.38723684E-07_JPRB, 0.36235914E-07_JPRB, 0.35585700E-07_JPRB, 0.35442540E-07_JPRB, 0.35413123E-07_JPRB, 0.35449769E-07_JPRB, &
  & 0.35531514E-07_JPRB, 0.35659369E-07_JPRB, 0.35827362E-07_JPRB, 0.36048608E-07_JPRB, 0.36327638E-07_JPRB, 0.36612967E-07_JPRB, &
  & 0.36989945E-07_JPRB, 0.37388677E-07_JPRB, 0.37839474E-07_JPRB, 0.38340072E-07_JPRB, 0.38886949E-07_JPRB, 0.39490249E-07_JPRB, &
  & 0.40122135E-07_JPRB, 0.40790884E-07_JPRB, 0.41463892E-07_JPRB, 0.42101860E-07_JPRB, 0.42704961E-07_JPRB, 0.43218289E-07_JPRB, &
  & 0.43658414E-07_JPRB, 0.44118174E-07_JPRB, 0.44469328E-07_JPRB, 0.44919428E-07_JPRB, 0.45341686E-07_JPRB, 0.45860055E-07_JPRB, &
  & 0.46416101E-07_JPRB, 0.47061604E-07_JPRB, 0.47711730E-07_JPRB, 0.48380706E-07_JPRB, 0.49070604E-07_JPRB, 0.49806083E-07_JPRB, &
  & 0.50578723E-07_JPRB, 0.51365589E-07_JPRB, 0.52152828E-07_JPRB, 0.52940969E-07_JPRB, 0.53739722E-07_JPRB, 0.54546422E-07_JPRB, &
  & 0.55337942E-07_JPRB, 0.56096294E-07_JPRB, 0.56817122E-07_JPRB, 0.57524090E-07_JPRB, 0.58215704E-07_JPRB, 0.58895399E-07_JPRB, &
  & 0.59561316E-07_JPRB, 0.60191581E-07_JPRB, 0.60804467E-07_JPRB, 0.61377072E-07_JPRB, 0.61932269E-07_JPRB, 0.62446254E-07_JPRB, &
  & 0.62948416E-07_JPRB, 0.63429717E-07_JPRB, 0.63909489E-07_JPRB, 0.64311088E-07_JPRB, 0.64673273E-07_JPRB, 0.64959210E-07_JPRB, &
  & 0.65249807E-07_JPRB, 0.65437227E-07_JPRB, 0.65616753E-07_JPRB, 0.66001235E-07_JPRB /)

RGHG7(:,80, 7) = (/ &
  & 0.36998664E-07_JPRB, 0.35423703E-07_JPRB, 0.34999942E-07_JPRB, 0.35012370E-07_JPRB, 0.35036944E-07_JPRB, 0.35090338E-07_JPRB, &
  & 0.35204714E-07_JPRB, 0.35336829E-07_JPRB, 0.35558376E-07_JPRB, 0.35770430E-07_JPRB, 0.36075335E-07_JPRB, 0.36412530E-07_JPRB, &
  & 0.36770700E-07_JPRB, 0.37193296E-07_JPRB, 0.37643794E-07_JPRB, 0.38157275E-07_JPRB, 0.38701579E-07_JPRB, 0.39305153E-07_JPRB, &
  & 0.39933784E-07_JPRB, 0.40590635E-07_JPRB, 0.41257920E-07_JPRB, 0.41896669E-07_JPRB, 0.42513626E-07_JPRB, 0.43031413E-07_JPRB, &
  & 0.43553236E-07_JPRB, 0.44048271E-07_JPRB, 0.44459100E-07_JPRB, 0.44990735E-07_JPRB, 0.45456311E-07_JPRB, 0.46044249E-07_JPRB, &
  & 0.46631886E-07_JPRB, 0.47290964E-07_JPRB, 0.47962924E-07_JPRB, 0.48648715E-07_JPRB, 0.49358047E-07_JPRB, 0.50107715E-07_JPRB, &
  & 0.50893419E-07_JPRB, 0.51688886E-07_JPRB, 0.52483802E-07_JPRB, 0.53275684E-07_JPRB, 0.54068959E-07_JPRB, 0.54865495E-07_JPRB, &
  & 0.55640662E-07_JPRB, 0.56381477E-07_JPRB, 0.57097779E-07_JPRB, 0.57789052E-07_JPRB, 0.58472896E-07_JPRB, 0.59131462E-07_JPRB, &
  & 0.59784988E-07_JPRB, 0.60388082E-07_JPRB, 0.60989720E-07_JPRB, 0.61531296E-07_JPRB, 0.62077852E-07_JPRB, 0.62554513E-07_JPRB, &
  & 0.63051246E-07_JPRB, 0.63486816E-07_JPRB, 0.63962688E-07_JPRB, 0.64327104E-07_JPRB, 0.64682332E-07_JPRB, 0.64923313E-07_JPRB, &
  & 0.65221855E-07_JPRB, 0.65379737E-07_JPRB, 0.65509845E-07_JPRB, 0.65811633E-07_JPRB /)

RGHG7(:,81, 7) = (/ &
  & 0.35872183E-07_JPRB, 0.35017365E-07_JPRB, 0.34698111E-07_JPRB, 0.34821493E-07_JPRB, 0.34815404E-07_JPRB, 0.34890785E-07_JPRB, &
  & 0.35026531E-07_JPRB, 0.35228599E-07_JPRB, 0.35391409E-07_JPRB, 0.35712340E-07_JPRB, 0.35958092E-07_JPRB, 0.36305526E-07_JPRB, &
  & 0.36679541E-07_JPRB, 0.37104389E-07_JPRB, 0.37561573E-07_JPRB, 0.38067764E-07_JPRB, 0.38612370E-07_JPRB, 0.39203332E-07_JPRB, &
  & 0.39828091E-07_JPRB, 0.40474394E-07_JPRB, 0.41135891E-07_JPRB, 0.41787324E-07_JPRB, 0.42404139E-07_JPRB, 0.42925770E-07_JPRB, &
  & 0.43531266E-07_JPRB, 0.43974261E-07_JPRB, 0.44497469E-07_JPRB, 0.44993481E-07_JPRB, 0.45526910E-07_JPRB, 0.46095515E-07_JPRB, &
  & 0.46720348E-07_JPRB, 0.47381128E-07_JPRB, 0.48068774E-07_JPRB, 0.48761795E-07_JPRB, 0.49481653E-07_JPRB, 0.50239858E-07_JPRB, &
  & 0.51031542E-07_JPRB, 0.51833503E-07_JPRB, 0.52632405E-07_JPRB, 0.53422873E-07_JPRB, 0.54215707E-07_JPRB, 0.54998967E-07_JPRB, &
  & 0.55767000E-07_JPRB, 0.56505314E-07_JPRB, 0.57211292E-07_JPRB, 0.57903662E-07_JPRB, 0.58582010E-07_JPRB, 0.59237955E-07_JPRB, &
  & 0.59875482E-07_JPRB, 0.60484098E-07_JPRB, 0.61060817E-07_JPRB, 0.61608837E-07_JPRB, 0.62134760E-07_JPRB, 0.62609246E-07_JPRB, &
  & 0.63102533E-07_JPRB, 0.63515309E-07_JPRB, 0.63993085E-07_JPRB, 0.64313760E-07_JPRB, 0.64699918E-07_JPRB, 0.64905414E-07_JPRB, &
  & 0.65186420E-07_JPRB, 0.65374039E-07_JPRB, 0.65412593E-07_JPRB, 0.65680140E-07_JPRB /)

RGHG7(:,82, 7) = (/ &
  & 0.35093965E-07_JPRB, 0.34802806E-07_JPRB, 0.34594422E-07_JPRB, 0.34794649E-07_JPRB, 0.34716440E-07_JPRB, 0.34839779E-07_JPRB, &
  & 0.34997310E-07_JPRB, 0.35122749E-07_JPRB, 0.35413553E-07_JPRB, 0.35582381E-07_JPRB, 0.35946215E-07_JPRB, 0.36241818E-07_JPRB, &
  & 0.36632237E-07_JPRB, 0.37061000E-07_JPRB, 0.37509661E-07_JPRB, 0.38032745E-07_JPRB, 0.38567073E-07_JPRB, 0.39162945E-07_JPRB, &
  & 0.39781735E-07_JPRB, 0.40428340E-07_JPRB, 0.41077968E-07_JPRB, 0.41742169E-07_JPRB, 0.42332633E-07_JPRB, 0.42895621E-07_JPRB, &
  & 0.43506276E-07_JPRB, 0.43924413E-07_JPRB, 0.44517758E-07_JPRB, 0.44976581E-07_JPRB, 0.45562057E-07_JPRB, 0.46119069E-07_JPRB, &
  & 0.46761631E-07_JPRB, 0.47421270E-07_JPRB, 0.48115339E-07_JPRB, 0.48816151E-07_JPRB, 0.49541960E-07_JPRB, 0.50307456E-07_JPRB, &
  & 0.51103683E-07_JPRB, 0.51910380E-07_JPRB, 0.52706785E-07_JPRB, 0.53501207E-07_JPRB, 0.54282815E-07_JPRB, 0.55068078E-07_JPRB, &
  & 0.55823975E-07_JPRB, 0.56555276E-07_JPRB, 0.57262479E-07_JPRB, 0.57953628E-07_JPRB, 0.58629745E-07_JPRB, 0.59293459E-07_JPRB, &
  & 0.59906121E-07_JPRB, 0.60546292E-07_JPRB, 0.61076378E-07_JPRB, 0.61667592E-07_JPRB, 0.62142981E-07_JPRB, 0.62652745E-07_JPRB, &
  & 0.63111592E-07_JPRB, 0.63532148E-07_JPRB, 0.64010756E-07_JPRB, 0.64314676E-07_JPRB, 0.64701375E-07_JPRB, 0.64916890E-07_JPRB, &
  & 0.65152129E-07_JPRB, 0.65412095E-07_JPRB, 0.65361768E-07_JPRB, 0.65652777E-07_JPRB /)

RGHG7(:,83, 7) = (/ &
  & 0.35089187E-07_JPRB, 0.34664122E-07_JPRB, 0.34600646E-07_JPRB, 0.34758258E-07_JPRB, 0.34607982E-07_JPRB, 0.34820811E-07_JPRB, &
  & 0.34919228E-07_JPRB, 0.35153430E-07_JPRB, 0.35293109E-07_JPRB, 0.35654704E-07_JPRB, 0.35863138E-07_JPRB, 0.36242874E-07_JPRB, &
  & 0.36592560E-07_JPRB, 0.37030819E-07_JPRB, 0.37489166E-07_JPRB, 0.37991075E-07_JPRB, 0.38535916E-07_JPRB, 0.39119236E-07_JPRB, &
  & 0.39736406E-07_JPRB, 0.40382258E-07_JPRB, 0.41025707E-07_JPRB, 0.41697046E-07_JPRB, 0.42259579E-07_JPRB, 0.42901579E-07_JPRB, &
  & 0.43429949E-07_JPRB, 0.43934250E-07_JPRB, 0.44491728E-07_JPRB, 0.44991669E-07_JPRB, 0.45552920E-07_JPRB, 0.46140205E-07_JPRB, &
  & 0.46770619E-07_JPRB, 0.47443649E-07_JPRB, 0.48136300E-07_JPRB, 0.48842541E-07_JPRB, 0.49573792E-07_JPRB, 0.50342404E-07_JPRB, &
  & 0.51147651E-07_JPRB, 0.51953577E-07_JPRB, 0.52759727E-07_JPRB, 0.53542518E-07_JPRB, 0.54330421E-07_JPRB, 0.55098699E-07_JPRB, &
  & 0.55860756E-07_JPRB, 0.56583691E-07_JPRB, 0.57294212E-07_JPRB, 0.57978138E-07_JPRB, 0.58653566E-07_JPRB, 0.59317440E-07_JPRB, &
  & 0.59923622E-07_JPRB, 0.60581634E-07_JPRB, 0.61076769E-07_JPRB, 0.61711084E-07_JPRB, 0.62130169E-07_JPRB, 0.62702895E-07_JPRB, &
  & 0.63092990E-07_JPRB, 0.63577787E-07_JPRB, 0.63989283E-07_JPRB, 0.64347951E-07_JPRB, 0.64662203E-07_JPRB, 0.64970443E-07_JPRB, &
  & 0.65072705E-07_JPRB, 0.65472904E-07_JPRB, 0.65292795E-07_JPRB, 0.65698494E-07_JPRB /)

RGHG7(:,84, 7) = (/ &
  & 0.35085904E-07_JPRB, 0.34514741E-07_JPRB, 0.34682888E-07_JPRB, 0.34678806E-07_JPRB, 0.34573070E-07_JPRB, 0.34846146E-07_JPRB, &
  & 0.34905973E-07_JPRB, 0.35103376E-07_JPRB, 0.35402461E-07_JPRB, 0.35552670E-07_JPRB, 0.35924341E-07_JPRB, 0.36194074E-07_JPRB, &
  & 0.36586908E-07_JPRB, 0.37012075E-07_JPRB, 0.37460051E-07_JPRB, 0.37969954E-07_JPRB, 0.38507970E-07_JPRB, 0.39090285E-07_JPRB, &
  & 0.39708937E-07_JPRB, 0.40352894E-07_JPRB, 0.40986993E-07_JPRB, 0.41650495E-07_JPRB, 0.42224098E-07_JPRB, 0.42887695E-07_JPRB, &
  & 0.43356302E-07_JPRB, 0.43960096E-07_JPRB, 0.44440526E-07_JPRB, 0.44993225E-07_JPRB, 0.45550873E-07_JPRB, 0.46139125E-07_JPRB, &
  & 0.46779085E-07_JPRB, 0.47450143E-07_JPRB, 0.48148713E-07_JPRB, 0.48859910E-07_JPRB, 0.49595577E-07_JPRB, 0.50374595E-07_JPRB, &
  & 0.51177860E-07_JPRB, 0.51996007E-07_JPRB, 0.52791240E-07_JPRB, 0.53582827E-07_JPRB, 0.54358036E-07_JPRB, 0.55129775E-07_JPRB, &
  & 0.55870451E-07_JPRB, 0.56605611E-07_JPRB, 0.57292731E-07_JPRB, 0.57992320E-07_JPRB, 0.58660071E-07_JPRB, 0.59322065E-07_JPRB, &
  & 0.59946132E-07_JPRB, 0.60576767E-07_JPRB, 0.61091178E-07_JPRB, 0.61728961E-07_JPRB, 0.62119561E-07_JPRB, 0.62745585E-07_JPRB, &
  & 0.63051530E-07_JPRB, 0.63642069E-07_JPRB, 0.63928020E-07_JPRB, 0.64430893E-07_JPRB, 0.64574756E-07_JPRB, 0.65069294E-07_JPRB, &
  & 0.64982039E-07_JPRB, 0.65549024E-07_JPRB, 0.65238154E-07_JPRB, 0.65712790E-07_JPRB /)

RGHG7(:,85, 7) = (/ &
  & 0.35058644E-07_JPRB, 0.34390922E-07_JPRB, 0.34791661E-07_JPRB, 0.34544300E-07_JPRB, 0.34607488E-07_JPRB, 0.34829728E-07_JPRB, &
  & 0.34863323E-07_JPRB, 0.35199673E-07_JPRB, 0.35287574E-07_JPRB, 0.35690125E-07_JPRB, 0.35879932E-07_JPRB, 0.36245840E-07_JPRB, &
  & 0.36582211E-07_JPRB, 0.36998557E-07_JPRB, 0.37433253E-07_JPRB, 0.37925869E-07_JPRB, 0.38454587E-07_JPRB, 0.39041971E-07_JPRB, &
  & 0.39658978E-07_JPRB, 0.40299039E-07_JPRB, 0.40944887E-07_JPRB, 0.41602913E-07_JPRB, 0.42206015E-07_JPRB, 0.42816893E-07_JPRB, &
  & 0.43350948E-07_JPRB, 0.43907356E-07_JPRB, 0.44421824E-07_JPRB, 0.44979618E-07_JPRB, 0.45527177E-07_JPRB, 0.46140695E-07_JPRB, &
  & 0.46770467E-07_JPRB, 0.47452581E-07_JPRB, 0.48149346E-07_JPRB, 0.48862670E-07_JPRB, 0.49601667E-07_JPRB, 0.50380773E-07_JPRB, &
  & 0.51201223E-07_JPRB, 0.52016247E-07_JPRB, 0.52825211E-07_JPRB, 0.53609437E-07_JPRB, 0.54381761E-07_JPRB, 0.55149663E-07_JPRB, &
  & 0.55905915E-07_JPRB, 0.56614045E-07_JPRB, 0.57328531E-07_JPRB, 0.57992647E-07_JPRB, 0.58669919E-07_JPRB, 0.59320335E-07_JPRB, &
  & 0.59953095E-07_JPRB, 0.60560161E-07_JPRB, 0.61110505E-07_JPRB, 0.61717962E-07_JPRB, 0.62119312E-07_JPRB, 0.62771178E-07_JPRB, &
  & 0.63020266E-07_JPRB, 0.63713301E-07_JPRB, 0.63848098E-07_JPRB, 0.64537083E-07_JPRB, 0.64463180E-07_JPRB, 0.65178504E-07_JPRB, &
  & 0.64881881E-07_JPRB, 0.65616497E-07_JPRB, 0.65180977E-07_JPRB, 0.65749951E-07_JPRB /)

RGHG7(:,86, 7) = (/ &
  & 0.35015837E-07_JPRB, 0.34309075E-07_JPRB, 0.34877470E-07_JPRB, 0.34412690E-07_JPRB, 0.34707199E-07_JPRB, 0.34775660E-07_JPRB, &
  & 0.34921939E-07_JPRB, 0.35188240E-07_JPRB, 0.35460189E-07_JPRB, 0.35649066E-07_JPRB, 0.35985622E-07_JPRB, 0.36244867E-07_JPRB, &
  & 0.36615436E-07_JPRB, 0.36981440E-07_JPRB, 0.37407993E-07_JPRB, 0.37867366E-07_JPRB, 0.38401282E-07_JPRB, 0.38956319E-07_JPRB, &
  & 0.39598575E-07_JPRB, 0.40236529E-07_JPRB, 0.40914330E-07_JPRB, 0.41551210E-07_JPRB, 0.42171884E-07_JPRB, 0.42766615E-07_JPRB, &
  & 0.43320810E-07_JPRB, 0.43867590E-07_JPRB, 0.44396643E-07_JPRB, 0.44938439E-07_JPRB, 0.45517467E-07_JPRB, 0.46115318E-07_JPRB, &
  & 0.46770047E-07_JPRB, 0.47448122E-07_JPRB, 0.48153879E-07_JPRB, 0.48873570E-07_JPRB, 0.49618880E-07_JPRB, 0.50404321E-07_JPRB, &
  & 0.51217306E-07_JPRB, 0.52042285E-07_JPRB, 0.52844975E-07_JPRB, 0.53641134E-07_JPRB, 0.54408414E-07_JPRB, 0.55181211E-07_JPRB, &
  & 0.55920488E-07_JPRB, 0.56649668E-07_JPRB, 0.57325682E-07_JPRB, 0.58013605E-07_JPRB, 0.58665847E-07_JPRB, 0.59321184E-07_JPRB, &
  & 0.59948533E-07_JPRB, 0.60547919E-07_JPRB, 0.61118257E-07_JPRB, 0.61687395E-07_JPRB, 0.62131924E-07_JPRB, 0.62770560E-07_JPRB, &
  & 0.63004563E-07_JPRB, 0.63751742E-07_JPRB, 0.63792776E-07_JPRB, 0.64619371E-07_JPRB, 0.64381823E-07_JPRB, 0.65263244E-07_JPRB, &
  & 0.64821840E-07_JPRB, 0.65665624E-07_JPRB, 0.65141904E-07_JPRB, 0.65776291E-07_JPRB /)

RGHG7(:,87, 7) = (/ &
  & 0.34919513E-07_JPRB, 0.34305618E-07_JPRB, 0.34896388E-07_JPRB, 0.34348986E-07_JPRB, 0.34787949E-07_JPRB, 0.34702502E-07_JPRB, &
  & 0.34997711E-07_JPRB, 0.35255930E-07_JPRB, 0.35400390E-07_JPRB, 0.35795924E-07_JPRB, 0.35971308E-07_JPRB, 0.36301135E-07_JPRB, &
  & 0.36611091E-07_JPRB, 0.36973557E-07_JPRB, 0.37346183E-07_JPRB, 0.37812288E-07_JPRB, 0.38311455E-07_JPRB, 0.38881648E-07_JPRB, &
  & 0.39511978E-07_JPRB, 0.40173411E-07_JPRB, 0.40856147E-07_JPRB, 0.41503338E-07_JPRB, 0.42140119E-07_JPRB, 0.42727013E-07_JPRB, &
  & 0.43295096E-07_JPRB, 0.43829228E-07_JPRB, 0.44367482E-07_JPRB, 0.44922881E-07_JPRB, 0.45493014E-07_JPRB, 0.46113460E-07_JPRB, &
  & 0.46762601E-07_JPRB, 0.47453401E-07_JPRB, 0.48157993E-07_JPRB, 0.48871900E-07_JPRB, 0.49613938E-07_JPRB, 0.50403376E-07_JPRB, &
  & 0.51227776E-07_JPRB, 0.52057171E-07_JPRB, 0.52867531E-07_JPRB, 0.53656134E-07_JPRB, 0.54441049E-07_JPRB, 0.55210553E-07_JPRB, &
  & 0.55968766E-07_JPRB, 0.56685192E-07_JPRB, 0.57375988E-07_JPRB, 0.58030661E-07_JPRB, 0.58683899E-07_JPRB, 0.59318939E-07_JPRB, &
  & 0.59947808E-07_JPRB, 0.60529992E-07_JPRB, 0.61105290E-07_JPRB, 0.61657786E-07_JPRB, 0.62141311E-07_JPRB, 0.62747120E-07_JPRB, &
  & 0.63019449E-07_JPRB, 0.63750413E-07_JPRB, 0.63793983E-07_JPRB, 0.64628317E-07_JPRB, 0.64372543E-07_JPRB, 0.65268502E-07_JPRB, &
  & 0.64815339E-07_JPRB, 0.65669681E-07_JPRB, 0.65130109E-07_JPRB, 0.65792221E-07_JPRB /)

RGHG7(:,88, 7) = (/ &
  & 0.34956152E-07_JPRB, 0.34344250E-07_JPRB, 0.34837935E-07_JPRB, 0.34361108E-07_JPRB, 0.34794319E-07_JPRB, 0.34673540E-07_JPRB, &
  & 0.35075789E-07_JPRB, 0.35181284E-07_JPRB, 0.35568721E-07_JPRB, 0.35689652E-07_JPRB, 0.35990546E-07_JPRB, 0.36285485E-07_JPRB, &
  & 0.36568931E-07_JPRB, 0.36995388E-07_JPRB, 0.37419181E-07_JPRB, 0.37840053E-07_JPRB, 0.38258008E-07_JPRB, 0.38835676E-07_JPRB, &
  & 0.39444402E-07_JPRB, 0.40123208E-07_JPRB, 0.40807997E-07_JPRB, 0.41474419E-07_JPRB, 0.42103370E-07_JPRB, 0.42699686E-07_JPRB, &
  & 0.43258645E-07_JPRB, 0.43800448E-07_JPRB, 0.44338201E-07_JPRB, 0.44887891E-07_JPRB, 0.45469882E-07_JPRB, 0.46086580E-07_JPRB, &
  & 0.46747676E-07_JPRB, 0.47441212E-07_JPRB, 0.48159396E-07_JPRB, 0.48895043E-07_JPRB, 0.49646840E-07_JPRB, 0.50430536E-07_JPRB, &
  & 0.51249060E-07_JPRB, 0.52076480E-07_JPRB, 0.52887607E-07_JPRB, 0.53675020E-07_JPRB, 0.54477322E-07_JPRB, 0.55243625E-07_JPRB, &
  & 0.56004911E-07_JPRB, 0.56718953E-07_JPRB, 0.57400978E-07_JPRB, 0.58055402E-07_JPRB, 0.58688904E-07_JPRB, 0.59333281E-07_JPRB, &
  & 0.59936866E-07_JPRB, 0.60520684E-07_JPRB, 0.61085601E-07_JPRB, 0.61632626E-07_JPRB, 0.62143187E-07_JPRB, 0.62714633E-07_JPRB, &
  & 0.63042322E-07_JPRB, 0.63719433E-07_JPRB, 0.63827038E-07_JPRB, 0.64600641E-07_JPRB, 0.64408887E-07_JPRB, 0.65244940E-07_JPRB, &
  & 0.64841764E-07_JPRB, 0.65655158E-07_JPRB, 0.65143077E-07_JPRB, 0.65783517E-07_JPRB /)

RGHG7(:,89, 7) = (/ &
  & 0.35018196E-07_JPRB, 0.34438273E-07_JPRB, 0.34786385E-07_JPRB, 0.34439953E-07_JPRB, 0.34740740E-07_JPRB, 0.34689947E-07_JPRB, &
  & 0.35008878E-07_JPRB, 0.35215159E-07_JPRB, 0.35406838E-07_JPRB, 0.35646753E-07_JPRB, 0.35919626E-07_JPRB, 0.36153363E-07_JPRB, &
  & 0.36492001E-07_JPRB, 0.36663220E-07_JPRB, 0.36982303E-07_JPRB, 0.37608334E-07_JPRB, 0.38167990E-07_JPRB, 0.38820968E-07_JPRB, &
  & 0.39424162E-07_JPRB, 0.40092768E-07_JPRB, 0.40771514E-07_JPRB, 0.41433182E-07_JPRB, 0.42063547E-07_JPRB, 0.42654570E-07_JPRB, &
  & 0.43218609E-07_JPRB, 0.43758003E-07_JPRB, 0.44294236E-07_JPRB, 0.44846448E-07_JPRB, 0.45426187E-07_JPRB, 0.46050062E-07_JPRB, &
  & 0.46716345E-07_JPRB, 0.47417078E-07_JPRB, 0.48130829E-07_JPRB, 0.48860187E-07_JPRB, 0.49617615E-07_JPRB, 0.50424163E-07_JPRB, &
  & 0.51266817E-07_JPRB, 0.52092876E-07_JPRB, 0.52920434E-07_JPRB, 0.53710661E-07_JPRB, 0.54500894E-07_JPRB, 0.55280776E-07_JPRB, &
  & 0.56049821E-07_JPRB, 0.56764524E-07_JPRB, 0.57430203E-07_JPRB, 0.58080623E-07_JPRB, 0.58706753E-07_JPRB, 0.59340024E-07_JPRB, &
  & 0.59937918E-07_JPRB, 0.60511944E-07_JPRB, 0.61076612E-07_JPRB, 0.61615445E-07_JPRB, 0.62136458E-07_JPRB, 0.62688130E-07_JPRB, &
  & 0.63071191E-07_JPRB, 0.63687068E-07_JPRB, 0.63877884E-07_JPRB, 0.64554200E-07_JPRB, 0.64463222E-07_JPRB, 0.65200297E-07_JPRB, &
  & 0.64881938E-07_JPRB, 0.65626310E-07_JPRB, 0.65167811E-07_JPRB, 0.65770280E-07_JPRB /)

RGHG7(:,90, 7) = (/ &
  & 0.35332167E-07_JPRB, 0.34485172E-07_JPRB, 0.34694221E-07_JPRB, 0.34501323E-07_JPRB, 0.34624197E-07_JPRB, 0.34697802E-07_JPRB, &
  & 0.34890824E-07_JPRB, 0.35068791E-07_JPRB, 0.35296978E-07_JPRB, 0.35522859E-07_JPRB, 0.35712976E-07_JPRB, 0.36993850E-07_JPRB, &
  & 0.36573198E-07_JPRB, 0.36932164E-07_JPRB, 0.37258179E-07_JPRB, 0.38251379E-07_JPRB, 0.38301526E-07_JPRB, 0.38825299E-07_JPRB, &
  & 0.39387498E-07_JPRB, 0.40041893E-07_JPRB, 0.40712845E-07_JPRB, 0.41382627E-07_JPRB, 0.42002785E-07_JPRB, 0.42595726E-07_JPRB, &
  & 0.43153683E-07_JPRB, 0.43688672E-07_JPRB, 0.44222926E-07_JPRB, 0.44773472E-07_JPRB, 0.45352873E-07_JPRB, 0.45976517E-07_JPRB, &
  & 0.46651682E-07_JPRB, 0.47373739E-07_JPRB, 0.48118277E-07_JPRB, 0.48886886E-07_JPRB, 0.49662638E-07_JPRB, 0.50459619E-07_JPRB, &
  & 0.51300024E-07_JPRB, 0.52138130E-07_JPRB, 0.52964261E-07_JPRB, 0.53753460E-07_JPRB, 0.54550892E-07_JPRB, 0.55309819E-07_JPRB, &
  & 0.56073024E-07_JPRB, 0.56777900E-07_JPRB, 0.57451938E-07_JPRB, 0.58075422E-07_JPRB, 0.58707585E-07_JPRB, 0.59346213E-07_JPRB, &
  & 0.59940476E-07_JPRB, 0.60517650E-07_JPRB, 0.61071951E-07_JPRB, 0.61608198E-07_JPRB, 0.62145880E-07_JPRB, 0.62678140E-07_JPRB, &
  & 0.63104807E-07_JPRB, 0.63655193E-07_JPRB, 0.63941570E-07_JPRB, 0.64502679E-07_JPRB, 0.64545254E-07_JPRB, 0.65139304E-07_JPRB, &
  & 0.64958797E-07_JPRB, 0.65571612E-07_JPRB, 0.65226587E-07_JPRB, 0.65735243E-07_JPRB /)

RGHG7(:,91, 7) = (/ &
  & 0.34921552E-07_JPRB, 0.34541898E-07_JPRB, 0.34641442E-07_JPRB, 0.34573443E-07_JPRB, 0.34575507E-07_JPRB, 0.34637392E-07_JPRB, &
  & 0.34720852E-07_JPRB, 0.39143707E-07_JPRB, 0.20631064E-08_JPRB, 0.38551523E-07_JPRB, 0.39085993E-07_JPRB, 0.47514131E-07_JPRB, &
  & 0.44249109E-07_JPRB, 0.36850775E-07_JPRB, 0.29473544E-07_JPRB, 0.39727308E-07_JPRB, 0.38290811E-07_JPRB, 0.38375738E-07_JPRB, &
  & 0.39522096E-07_JPRB, 0.40009478E-07_JPRB, 0.40674696E-07_JPRB, 0.41306251E-07_JPRB, 0.41865658E-07_JPRB, 0.42484057E-07_JPRB, &
  & 0.43032951E-07_JPRB, 0.43570751E-07_JPRB, 0.44103960E-07_JPRB, 0.44653071E-07_JPRB, 0.45235261E-07_JPRB, 0.45855096E-07_JPRB, &
  & 0.46535227E-07_JPRB, 0.47271730E-07_JPRB, 0.48011312E-07_JPRB, 0.48810389E-07_JPRB, 0.49610570E-07_JPRB, 0.50457093E-07_JPRB, &
  & 0.51316594E-07_JPRB, 0.52185946E-07_JPRB, 0.53018308E-07_JPRB, 0.53829762E-07_JPRB, 0.54590505E-07_JPRB, 0.55377544E-07_JPRB, &
  & 0.56055388E-07_JPRB, 0.56832317E-07_JPRB, 0.57465847E-07_JPRB, 0.58036409E-07_JPRB, 0.58696212E-07_JPRB, 0.59373171E-07_JPRB, &
  & 0.59934877E-07_JPRB, 0.60542106E-07_JPRB, 0.61094454E-07_JPRB, 0.61618458E-07_JPRB, 0.62181712E-07_JPRB, 0.62692727E-07_JPRB, &
  & 0.63149130E-07_JPRB, 0.63639675E-07_JPRB, 0.64020021E-07_JPRB, 0.64448841E-07_JPRB, 0.64656504E-07_JPRB, 0.65044169E-07_JPRB, &
  & 0.65098391E-07_JPRB, 0.65452888E-07_JPRB, 0.65368233E-07_JPRB, 0.65635270E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG7(:, 1, 8) = (/ &
  & 0.61769283E-05_JPRB, 0.61951250E-05_JPRB, 0.62518789E-05_JPRB, 0.72681068E-07_JPRB, 0.70093286E-07_JPRB, 0.69847950E-07_JPRB, &
  & 0.69369889E-07_JPRB, 0.67652770E-07_JPRB, 0.66686290E-07_JPRB, 0.66245491E-07_JPRB, 0.66224437E-07_JPRB, 0.66454199E-07_JPRB, &
  & 0.66826068E-07_JPRB, 0.67284496E-07_JPRB, 0.67767672E-07_JPRB, 0.68232154E-07_JPRB, 0.68608728E-07_JPRB, 0.68961647E-07_JPRB, &
  & 0.69198677E-07_JPRB, 0.69338910E-07_JPRB, 0.69393856E-07_JPRB, 0.69377073E-07_JPRB, 0.69304747E-07_JPRB, 0.69189113E-07_JPRB, &
  & 0.69038222E-07_JPRB, 0.68875870E-07_JPRB, 0.68725321E-07_JPRB, 0.68608280E-07_JPRB, 0.68518773E-07_JPRB, 0.68412518E-07_JPRB, &
  & 0.68247822E-07_JPRB, 0.67989852E-07_JPRB, 0.67948605E-07_JPRB, 0.68047129E-07_JPRB, 0.68254508E-07_JPRB, 0.68551273E-07_JPRB, &
  & 0.68937595E-07_JPRB, 0.69319853E-07_JPRB, 0.69731350E-07_JPRB, 0.70059585E-07_JPRB, 0.70299009E-07_JPRB, 0.70549049E-07_JPRB, &
  & 0.70559587E-07_JPRB, 0.70705610E-07_JPRB, 0.70588932E-07_JPRB, 0.70556624E-07_JPRB, 0.70349863E-07_JPRB, 0.70133026E-07_JPRB, &
  & 0.69946722E-07_JPRB, 0.69809410E-07_JPRB, 0.69622168E-07_JPRB, 0.69558851E-07_JPRB, 0.69335201E-07_JPRB, 0.69322788E-07_JPRB, &
  & 0.68995035E-07_JPRB, 0.69060192E-07_JPRB, 0.68787799E-07_JPRB, 0.69020018E-07_JPRB, 0.68866747E-07_JPRB, 0.69198748E-07_JPRB, &
  & 0.68935286E-07_JPRB, 0.69320684E-07_JPRB, 0.70870435E-07_JPRB, 0.79714638E-07_JPRB /)

RGHG7(:, 2, 8) = (/ &
  & 0.10017921E-04_JPRB, 0.13465768E-04_JPRB, 0.16251744E-04_JPRB, 0.76732476E-06_JPRB, 0.65361377E-06_JPRB, 0.67516623E-06_JPRB, &
  & 0.65994294E-06_JPRB, 0.51801987E-06_JPRB, 0.42105833E-06_JPRB, 0.36186384E-06_JPRB, 0.33177221E-06_JPRB, 0.31564417E-06_JPRB, &
  & 0.30466325E-06_JPRB, 0.29525168E-06_JPRB, 0.28547737E-06_JPRB, 0.27518087E-06_JPRB, 0.26222929E-06_JPRB, 0.25318232E-06_JPRB, &
  & 0.24662796E-06_JPRB, 0.24246910E-06_JPRB, 0.24010336E-06_JPRB, 0.23888015E-06_JPRB, 0.23845507E-06_JPRB, 0.23864550E-06_JPRB, &
  & 0.23901524E-06_JPRB, 0.23896479E-06_JPRB, 0.23800646E-06_JPRB, 0.23606462E-06_JPRB, 0.23300947E-06_JPRB, 0.22872071E-06_JPRB, &
  & 0.22257751E-06_JPRB, 0.21090520E-06_JPRB, 0.20487801E-06_JPRB, 0.20133341E-06_JPRB, 0.19949074E-06_JPRB, 0.19909716E-06_JPRB, &
  & 0.19998366E-06_JPRB, 0.20186775E-06_JPRB, 0.20441574E-06_JPRB, 0.20715513E-06_JPRB, 0.20911314E-06_JPRB, 0.21200057E-06_JPRB, &
  & 0.21230406E-06_JPRB, 0.21553343E-06_JPRB, 0.21544965E-06_JPRB, 0.21733355E-06_JPRB, 0.21591136E-06_JPRB, 0.21077044E-06_JPRB, &
  & 0.20874857E-06_JPRB, 0.20800492E-06_JPRB, 0.20672782E-06_JPRB, 0.20488797E-06_JPRB, 0.20169482E-06_JPRB, 0.19577102E-06_JPRB, &
  & 0.18460882E-06_JPRB, 0.17814672E-06_JPRB, 0.17138380E-06_JPRB, 0.16371423E-06_JPRB, 0.15683551E-06_JPRB, 0.15035094E-06_JPRB, &
  & 0.14037113E-06_JPRB, 0.12890429E-06_JPRB, 0.13119785E-06_JPRB, 0.17234149E-06_JPRB /)

RGHG7(:, 3, 8) = (/ &
  & 0.17779594E-04_JPRB, 0.21196855E-04_JPRB, 0.23542110E-04_JPRB, 0.57246757E-05_JPRB, 0.26424032E-05_JPRB, 0.21772807E-05_JPRB, &
  & 0.17752974E-05_JPRB, 0.12243802E-05_JPRB, 0.88032334E-06_JPRB, 0.70261285E-06_JPRB, 0.61903262E-06_JPRB, 0.57796046E-06_JPRB, &
  & 0.55355491E-06_JPRB, 0.53704349E-06_JPRB, 0.52308667E-06_JPRB, 0.51176772E-06_JPRB, 0.49366514E-06_JPRB, 0.47967103E-06_JPRB, &
  & 0.47082972E-06_JPRB, 0.46454568E-06_JPRB, 0.46082050E-06_JPRB, 0.45886728E-06_JPRB, 0.45848043E-06_JPRB, 0.45948420E-06_JPRB, &
  & 0.46088053E-06_JPRB, 0.46141068E-06_JPRB, 0.45900848E-06_JPRB, 0.45361267E-06_JPRB, 0.44671361E-06_JPRB, 0.43889193E-06_JPRB, &
  & 0.43166838E-06_JPRB, 0.41427560E-06_JPRB, 0.40253767E-06_JPRB, 0.39650953E-06_JPRB, 0.39315699E-06_JPRB, 0.39151513E-06_JPRB, &
  & 0.39154878E-06_JPRB, 0.39278424E-06_JPRB, 0.39555863E-06_JPRB, 0.39780244E-06_JPRB, 0.40008911E-06_JPRB, 0.40372350E-06_JPRB, &
  & 0.40313290E-06_JPRB, 0.40853251E-06_JPRB, 0.40769092E-06_JPRB, 0.41061463E-06_JPRB, 0.40775740E-06_JPRB, 0.39805951E-06_JPRB, &
  & 0.39596705E-06_JPRB, 0.39711719E-06_JPRB, 0.39845975E-06_JPRB, 0.39812110E-06_JPRB, 0.39789867E-06_JPRB, 0.39400098E-06_JPRB, &
  & 0.38335415E-06_JPRB, 0.38512405E-06_JPRB, 0.39582972E-06_JPRB, 0.40186913E-06_JPRB, 0.39645823E-06_JPRB, 0.38801170E-06_JPRB, &
  & 0.36193535E-06_JPRB, 0.32966341E-06_JPRB, 0.33354661E-06_JPRB, 0.35424026E-06_JPRB /)

RGHG7(:, 4, 8) = (/ &
  & 0.18601977E-04_JPRB, 0.17804156E-04_JPRB, 0.14911659E-04_JPRB, 0.70129631E-05_JPRB, 0.31893458E-05_JPRB, 0.21363910E-05_JPRB, &
  & 0.17669943E-05_JPRB, 0.11709991E-05_JPRB, 0.81557636E-06_JPRB, 0.70754714E-06_JPRB, 0.70077954E-06_JPRB, 0.72345381E-06_JPRB, &
  & 0.74977225E-06_JPRB, 0.76906196E-06_JPRB, 0.77554080E-06_JPRB, 0.77476841E-06_JPRB, 0.76097740E-06_JPRB, 0.75475373E-06_JPRB, &
  & 0.75559120E-06_JPRB, 0.75845418E-06_JPRB, 0.76246374E-06_JPRB, 0.76620432E-06_JPRB, 0.76957230E-06_JPRB, 0.77291054E-06_JPRB, &
  & 0.77617091E-06_JPRB, 0.77966740E-06_JPRB, 0.78134917E-06_JPRB, 0.78051397E-06_JPRB, 0.77935715E-06_JPRB, 0.77447595E-06_JPRB, &
  & 0.77355634E-06_JPRB, 0.75638087E-06_JPRB, 0.74186948E-06_JPRB, 0.73578383E-06_JPRB, 0.73223822E-06_JPRB, 0.72959421E-06_JPRB, &
  & 0.72841931E-06_JPRB, 0.72777613E-06_JPRB, 0.72921785E-06_JPRB, 0.72881079E-06_JPRB, 0.72812020E-06_JPRB, 0.73004384E-06_JPRB, &
  & 0.72382022E-06_JPRB, 0.72873462E-06_JPRB, 0.72251254E-06_JPRB, 0.72055155E-06_JPRB, 0.70962187E-06_JPRB, 0.68420172E-06_JPRB, &
  & 0.67537559E-06_JPRB, 0.66782871E-06_JPRB, 0.66186186E-06_JPRB, 0.65386564E-06_JPRB, 0.64950166E-06_JPRB, 0.63565352E-06_JPRB, &
  & 0.61440238E-06_JPRB, 0.59621800E-06_JPRB, 0.58429634E-06_JPRB, 0.57213680E-06_JPRB, 0.55466001E-06_JPRB, 0.53355097E-06_JPRB, &
  & 0.48731971E-06_JPRB, 0.43943541E-06_JPRB, 0.43127386E-06_JPRB, 0.52403720E-06_JPRB /)

RGHG7(:, 5, 8) = (/ &
  & 0.15917029E-04_JPRB, 0.11969438E-04_JPRB, 0.89060077E-05_JPRB, 0.50951048E-05_JPRB, 0.34051020E-05_JPRB, 0.21976828E-05_JPRB, &
  & 0.17535036E-05_JPRB, 0.13037210E-05_JPRB, 0.10504048E-05_JPRB, 0.97364807E-06_JPRB, 0.95659448E-06_JPRB, 0.95571750E-06_JPRB, &
  & 0.96659869E-06_JPRB, 0.99131705E-06_JPRB, 0.10234738E-05_JPRB, 0.10505247E-05_JPRB, 0.10523895E-05_JPRB, 0.10557920E-05_JPRB, &
  & 0.10653303E-05_JPRB, 0.10768985E-05_JPRB, 0.10884332E-05_JPRB, 0.10981264E-05_JPRB, 0.11057876E-05_JPRB, 0.11126169E-05_JPRB, &
  & 0.11186447E-05_JPRB, 0.11238355E-05_JPRB, 0.11285968E-05_JPRB, 0.11305003E-05_JPRB, 0.11365732E-05_JPRB, 0.11362039E-05_JPRB, &
  & 0.11455171E-05_JPRB, 0.11330201E-05_JPRB, 0.11186187E-05_JPRB, 0.11161283E-05_JPRB, 0.11151452E-05_JPRB, 0.11132856E-05_JPRB, &
  & 0.11112111E-05_JPRB, 0.11076871E-05_JPRB, 0.11058428E-05_JPRB, 0.11011131E-05_JPRB, 0.10952956E-05_JPRB, 0.10940265E-05_JPRB, &
  & 0.10802124E-05_JPRB, 0.10815774E-05_JPRB, 0.10680072E-05_JPRB, 0.10570307E-05_JPRB, 0.10362644E-05_JPRB, 0.99293914E-06_JPRB, &
  & 0.97571410E-06_JPRB, 0.95647295E-06_JPRB, 0.94309178E-06_JPRB, 0.92676703E-06_JPRB, 0.91070655E-06_JPRB, 0.88228933E-06_JPRB, &
  & 0.85718983E-06_JPRB, 0.84561924E-06_JPRB, 0.84419332E-06_JPRB, 0.82941358E-06_JPRB, 0.80414043E-06_JPRB, 0.78465661E-06_JPRB, &
  & 0.75962106E-06_JPRB, 0.75709806E-06_JPRB, 0.83941404E-06_JPRB, 0.89738569E-06_JPRB /)

RGHG7(:, 6, 8) = (/ &
  & 0.13095031E-04_JPRB, 0.90870390E-05_JPRB, 0.67355286E-05_JPRB, 0.41808971E-05_JPRB, 0.32180064E-05_JPRB, 0.23474404E-05_JPRB, &
  & 0.18262385E-05_JPRB, 0.13993415E-05_JPRB, 0.12046233E-05_JPRB, 0.11650751E-05_JPRB, 0.11857987E-05_JPRB, 0.12244005E-05_JPRB, &
  & 0.12660114E-05_JPRB, 0.12954296E-05_JPRB, 0.13167166E-05_JPRB, 0.13441698E-05_JPRB, 0.13608030E-05_JPRB, 0.13768237E-05_JPRB, &
  & 0.13939162E-05_JPRB, 0.14145588E-05_JPRB, 0.14366186E-05_JPRB, 0.14569646E-05_JPRB, 0.14746945E-05_JPRB, 0.14891373E-05_JPRB, &
  & 0.15013452E-05_JPRB, 0.15097047E-05_JPRB, 0.15181261E-05_JPRB, 0.15206738E-05_JPRB, 0.15297735E-05_JPRB, 0.15294319E-05_JPRB, &
  & 0.15438676E-05_JPRB, 0.15327263E-05_JPRB, 0.15161581E-05_JPRB, 0.15169190E-05_JPRB, 0.15207000E-05_JPRB, 0.15237081E-05_JPRB, &
  & 0.15258212E-05_JPRB, 0.15249634E-05_JPRB, 0.15255872E-05_JPRB, 0.15224659E-05_JPRB, 0.15181812E-05_JPRB, 0.15181901E-05_JPRB, &
  & 0.15023031E-05_JPRB, 0.15025277E-05_JPRB, 0.14828748E-05_JPRB, 0.14657398E-05_JPRB, 0.14363753E-05_JPRB, 0.13805002E-05_JPRB, &
  & 0.13540605E-05_JPRB, 0.13245668E-05_JPRB, 0.12994988E-05_JPRB, 0.12690701E-05_JPRB, 0.12393667E-05_JPRB, 0.12091770E-05_JPRB, &
  & 0.11723087E-05_JPRB, 0.11306914E-05_JPRB, 0.10790973E-05_JPRB, 0.10528829E-05_JPRB, 0.10480811E-05_JPRB, 0.10454852E-05_JPRB, &
  & 0.10287839E-05_JPRB, 0.99634485E-06_JPRB, 0.10171307E-05_JPRB, 0.11620104E-05_JPRB /)

RGHG7(:, 7, 8) = (/ &
  & 0.10938224E-04_JPRB, 0.74709124E-05_JPRB, 0.55485166E-05_JPRB, 0.39206680E-05_JPRB, 0.32739674E-05_JPRB, 0.26523267E-05_JPRB, &
  & 0.22150418E-05_JPRB, 0.19283882E-05_JPRB, 0.17923140E-05_JPRB, 0.17296726E-05_JPRB, 0.16965258E-05_JPRB, 0.16795354E-05_JPRB, &
  & 0.16895737E-05_JPRB, 0.17206949E-05_JPRB, 0.17541856E-05_JPRB, 0.17821058E-05_JPRB, 0.17986687E-05_JPRB, 0.18225539E-05_JPRB, &
  & 0.18478845E-05_JPRB, 0.18740739E-05_JPRB, 0.19004287E-05_JPRB, 0.19250756E-05_JPRB, 0.19475808E-05_JPRB, 0.19663507E-05_JPRB, &
  & 0.19832867E-05_JPRB, 0.19942620E-05_JPRB, 0.20051652E-05_JPRB, 0.20079779E-05_JPRB, 0.20181790E-05_JPRB, 0.20169375E-05_JPRB, &
  & 0.20305715E-05_JPRB, 0.20154912E-05_JPRB, 0.19939323E-05_JPRB, 0.19958784E-05_JPRB, 0.20041689E-05_JPRB, 0.20129339E-05_JPRB, &
  & 0.20205980E-05_JPRB, 0.20250243E-05_JPRB, 0.20310547E-05_JPRB, 0.20310026E-05_JPRB, 0.20318778E-05_JPRB, 0.20325331E-05_JPRB, &
  & 0.20183156E-05_JPRB, 0.20180153E-05_JPRB, 0.19936294E-05_JPRB, 0.19731438E-05_JPRB, 0.19342272E-05_JPRB, 0.18703022E-05_JPRB, &
  & 0.18333143E-05_JPRB, 0.17933183E-05_JPRB, 0.17570072E-05_JPRB, 0.17197126E-05_JPRB, 0.16844745E-05_JPRB, 0.16444798E-05_JPRB, &
  & 0.15932324E-05_JPRB, 0.15794519E-05_JPRB, 0.15859920E-05_JPRB, 0.15741463E-05_JPRB, 0.15666542E-05_JPRB, 0.15522520E-05_JPRB, &
  & 0.15514073E-05_JPRB, 0.15915672E-05_JPRB, 0.16986615E-05_JPRB, 0.17523405E-05_JPRB /)

RGHG7(:, 8, 8) = (/ &
  & 0.88446159E-05_JPRB, 0.59838144E-05_JPRB, 0.46546506E-05_JPRB, 0.36356685E-05_JPRB, 0.32592634E-05_JPRB, 0.30189756E-05_JPRB, &
  & 0.27472656E-05_JPRB, 0.25020274E-05_JPRB, 0.23555049E-05_JPRB, 0.22866989E-05_JPRB, 0.22551417E-05_JPRB, 0.22448601E-05_JPRB, &
  & 0.22471604E-05_JPRB, 0.22494917E-05_JPRB, 0.22588583E-05_JPRB, 0.22733657E-05_JPRB, 0.22764548E-05_JPRB, 0.22814352E-05_JPRB, &
  & 0.22931879E-05_JPRB, 0.23133525E-05_JPRB, 0.23375355E-05_JPRB, 0.23629925E-05_JPRB, 0.23887619E-05_JPRB, 0.24119024E-05_JPRB, &
  & 0.24347655E-05_JPRB, 0.24526689E-05_JPRB, 0.24717829E-05_JPRB, 0.24826788E-05_JPRB, 0.24974624E-05_JPRB, 0.24969397E-05_JPRB, &
  & 0.25070196E-05_JPRB, 0.24886428E-05_JPRB, 0.24639216E-05_JPRB, 0.24645681E-05_JPRB, 0.24748538E-05_JPRB, 0.24869171E-05_JPRB, &
  & 0.24997219E-05_JPRB, 0.25120810E-05_JPRB, 0.25241686E-05_JPRB, 0.25291404E-05_JPRB, 0.25374522E-05_JPRB, 0.25358906E-05_JPRB, &
  & 0.25284537E-05_JPRB, 0.25244312E-05_JPRB, 0.24998365E-05_JPRB, 0.24766132E-05_JPRB, 0.24347496E-05_JPRB, 0.23716814E-05_JPRB, &
  & 0.23269843E-05_JPRB, 0.22801289E-05_JPRB, 0.22362042E-05_JPRB, 0.21892520E-05_JPRB, 0.21411395E-05_JPRB, 0.20926386E-05_JPRB, &
  & 0.20409286E-05_JPRB, 0.19975353E-05_JPRB, 0.19423476E-05_JPRB, 0.18949362E-05_JPRB, 0.18745973E-05_JPRB, 0.18636918E-05_JPRB, &
  & 0.18424616E-05_JPRB, 0.18415246E-05_JPRB, 0.18501911E-05_JPRB, 0.19573574E-05_JPRB /)

RGHG7(:, 9, 8) = (/ &
  & 0.67794563E-05_JPRB, 0.47522767E-05_JPRB, 0.39995530E-05_JPRB, 0.34681566E-05_JPRB, 0.33534409E-05_JPRB, 0.34403233E-05_JPRB, &
  & 0.34528525E-05_JPRB, 0.33594765E-05_JPRB, 0.32424737E-05_JPRB, 0.31338570E-05_JPRB, 0.30345848E-05_JPRB, 0.29645259E-05_JPRB, &
  & 0.29286427E-05_JPRB, 0.29093178E-05_JPRB, 0.28971326E-05_JPRB, 0.28884335E-05_JPRB, 0.28804297E-05_JPRB, 0.28709967E-05_JPRB, &
  & 0.28658324E-05_JPRB, 0.28706449E-05_JPRB, 0.28797635E-05_JPRB, 0.28935062E-05_JPRB, 0.29139014E-05_JPRB, 0.29374980E-05_JPRB, &
  & 0.29676648E-05_JPRB, 0.29983153E-05_JPRB, 0.30296881E-05_JPRB, 0.30500244E-05_JPRB, 0.30695708E-05_JPRB, 0.30731924E-05_JPRB, &
  & 0.30846518E-05_JPRB, 0.30660922E-05_JPRB, 0.30385709E-05_JPRB, 0.30378847E-05_JPRB, 0.30487920E-05_JPRB, 0.30629715E-05_JPRB, &
  & 0.30837862E-05_JPRB, 0.31029633E-05_JPRB, 0.31222007E-05_JPRB, 0.31362886E-05_JPRB, 0.31470977E-05_JPRB, 0.31462350E-05_JPRB, &
  & 0.31434993E-05_JPRB, 0.31315153E-05_JPRB, 0.31070635E-05_JPRB, 0.30782280E-05_JPRB, 0.30340263E-05_JPRB, 0.29639516E-05_JPRB, &
  & 0.29063533E-05_JPRB, 0.28478216E-05_JPRB, 0.27909584E-05_JPRB, 0.27316057E-05_JPRB, 0.26738749E-05_JPRB, 0.26167781E-05_JPRB, &
  & 0.25514234E-05_JPRB, 0.25053278E-05_JPRB, 0.24892161E-05_JPRB, 0.24662040E-05_JPRB, 0.24836668E-05_JPRB, 0.24592482E-05_JPRB, &
  & 0.24772919E-05_JPRB, 0.24565800E-05_JPRB, 0.24863182E-05_JPRB, 0.24390754E-05_JPRB /)

RGHG7(:,10, 8) = (/ &
  & 0.50704371E-05_JPRB, 0.39998554E-05_JPRB, 0.36516562E-05_JPRB, 0.34734676E-05_JPRB, 0.36021243E-05_JPRB, 0.38929834E-05_JPRB, &
  & 0.41326707E-05_JPRB, 0.42201468E-05_JPRB, 0.41953967E-05_JPRB, 0.41128769E-05_JPRB, 0.40065174E-05_JPRB, 0.39132187E-05_JPRB, &
  & 0.38371832E-05_JPRB, 0.37735713E-05_JPRB, 0.37235818E-05_JPRB, 0.36797758E-05_JPRB, 0.36357508E-05_JPRB, 0.35897633E-05_JPRB, &
  & 0.35591222E-05_JPRB, 0.35401958E-05_JPRB, 0.35313665E-05_JPRB, 0.35315907E-05_JPRB, 0.35428748E-05_JPRB, 0.35678620E-05_JPRB, &
  & 0.36012227E-05_JPRB, 0.36366741E-05_JPRB, 0.36780641E-05_JPRB, 0.37164325E-05_JPRB, 0.37552641E-05_JPRB, 0.37779225E-05_JPRB, &
  & 0.38014457E-05_JPRB, 0.37889229E-05_JPRB, 0.37631103E-05_JPRB, 0.37623035E-05_JPRB, 0.37706675E-05_JPRB, 0.37881971E-05_JPRB, &
  & 0.38083620E-05_JPRB, 0.38302965E-05_JPRB, 0.38510439E-05_JPRB, 0.38634525E-05_JPRB, 0.38720991E-05_JPRB, 0.38697331E-05_JPRB, &
  & 0.38625290E-05_JPRB, 0.38444491E-05_JPRB, 0.38182966E-05_JPRB, 0.37839418E-05_JPRB, 0.37357338E-05_JPRB, 0.36596052E-05_JPRB, &
  & 0.35955338E-05_JPRB, 0.35307769E-05_JPRB, 0.34651366E-05_JPRB, 0.33961194E-05_JPRB, 0.33276626E-05_JPRB, 0.32579321E-05_JPRB, &
  & 0.31807695E-05_JPRB, 0.31230002E-05_JPRB, 0.30786891E-05_JPRB, 0.30132626E-05_JPRB, 0.29820405E-05_JPRB, 0.29314970E-05_JPRB, &
  & 0.28849574E-05_JPRB, 0.28086565E-05_JPRB, 0.27285546E-05_JPRB, 0.26325094E-05_JPRB /)

RGHG7(:,11, 8) = (/ &
  & 0.40568357E-05_JPRB, 0.36631886E-05_JPRB, 0.36092210E-05_JPRB, 0.36423651E-05_JPRB, 0.38784137E-05_JPRB, 0.42676133E-05_JPRB, &
  & 0.46701239E-05_JPRB, 0.49748310E-05_JPRB, 0.51420593E-05_JPRB, 0.51779552E-05_JPRB, 0.51222933E-05_JPRB, 0.50423623E-05_JPRB, &
  & 0.49624741E-05_JPRB, 0.48851680E-05_JPRB, 0.48134948E-05_JPRB, 0.47454123E-05_JPRB, 0.46752107E-05_JPRB, 0.45977613E-05_JPRB, &
  & 0.45344068E-05_JPRB, 0.44816557E-05_JPRB, 0.44390681E-05_JPRB, 0.44085118E-05_JPRB, 0.43924301E-05_JPRB, 0.43906725E-05_JPRB, &
  & 0.44085259E-05_JPRB, 0.44486073E-05_JPRB, 0.44990729E-05_JPRB, 0.45453371E-05_JPRB, 0.45936108E-05_JPRB, 0.46301652E-05_JPRB, &
  & 0.46670975E-05_JPRB, 0.46683422E-05_JPRB, 0.46552327E-05_JPRB, 0.46613513E-05_JPRB, 0.46716900E-05_JPRB, 0.46837231E-05_JPRB, &
  & 0.46938371E-05_JPRB, 0.47042695E-05_JPRB, 0.47090052E-05_JPRB, 0.47104013E-05_JPRB, 0.47039034E-05_JPRB, 0.46915534E-05_JPRB, &
  & 0.46737596E-05_JPRB, 0.46475548E-05_JPRB, 0.46135137E-05_JPRB, 0.45711790E-05_JPRB, 0.45164352E-05_JPRB, 0.44366843E-05_JPRB, &
  & 0.43706841E-05_JPRB, 0.43062582E-05_JPRB, 0.42431525E-05_JPRB, 0.41803887E-05_JPRB, 0.41211306E-05_JPRB, 0.40624464E-05_JPRB, &
  & 0.39972515E-05_JPRB, 0.39515849E-05_JPRB, 0.39162933E-05_JPRB, 0.38671569E-05_JPRB, 0.38370717E-05_JPRB, 0.37783007E-05_JPRB, &
  & 0.36993038E-05_JPRB, 0.35706257E-05_JPRB, 0.34629088E-05_JPRB, 0.33920519E-05_JPRB /)

RGHG7(:,12, 8) = (/ &
  & 0.36681395E-05_JPRB, 0.36668778E-05_JPRB, 0.37523655E-05_JPRB, 0.38742232E-05_JPRB, 0.41697508E-05_JPRB, 0.45746892E-05_JPRB, &
  & 0.50270460E-05_JPRB, 0.54363823E-05_JPRB, 0.57509255E-05_JPRB, 0.59471840E-05_JPRB, 0.60352577E-05_JPRB, 0.60604179E-05_JPRB, &
  & 0.60445404E-05_JPRB, 0.60022580E-05_JPRB, 0.59447789E-05_JPRB, 0.58755695E-05_JPRB, 0.57941661E-05_JPRB, 0.56995959E-05_JPRB, &
  & 0.56157132E-05_JPRB, 0.55401520E-05_JPRB, 0.54726611E-05_JPRB, 0.54173870E-05_JPRB, 0.53764938E-05_JPRB, 0.53591034E-05_JPRB, &
  & 0.53656518E-05_JPRB, 0.53842732E-05_JPRB, 0.54239563E-05_JPRB, 0.54826373E-05_JPRB, 0.55508385E-05_JPRB, 0.56140393E-05_JPRB, &
  & 0.56782724E-05_JPRB, 0.57079201E-05_JPRB, 0.57167899E-05_JPRB, 0.57389611E-05_JPRB, 0.57527395E-05_JPRB, 0.57609741E-05_JPRB, &
  & 0.57538437E-05_JPRB, 0.57430188E-05_JPRB, 0.57209882E-05_JPRB, 0.56948147E-05_JPRB, 0.56639119E-05_JPRB, 0.56292561E-05_JPRB, &
  & 0.55900368E-05_JPRB, 0.55465694E-05_JPRB, 0.54951383E-05_JPRB, 0.54346247E-05_JPRB, 0.53657245E-05_JPRB, 0.52750752E-05_JPRB, &
  & 0.51992965E-05_JPRB, 0.51286916E-05_JPRB, 0.50607946E-05_JPRB, 0.49944374E-05_JPRB, 0.49305240E-05_JPRB, 0.48648621E-05_JPRB, &
  & 0.47907256E-05_JPRB, 0.47309504E-05_JPRB, 0.46724404E-05_JPRB, 0.45964825E-05_JPRB, 0.45186803E-05_JPRB, 0.44068352E-05_JPRB, &
  & 0.42547476E-05_JPRB, 0.40538448E-05_JPRB, 0.38893386E-05_JPRB, 0.37559169E-05_JPRB /)

RGHG7(:,13, 8) = (/ &
  & 0.36494989E-05_JPRB, 0.37932411E-05_JPRB, 0.39043230E-05_JPRB, 0.40502287E-05_JPRB, 0.43316072E-05_JPRB, 0.47102931E-05_JPRB, &
  & 0.51452885E-05_JPRB, 0.55733835E-05_JPRB, 0.59420331E-05_JPRB, 0.62151753E-05_JPRB, 0.63841844E-05_JPRB, 0.64866640E-05_JPRB, &
  & 0.65342842E-05_JPRB, 0.65482609E-05_JPRB, 0.65357895E-05_JPRB, 0.65097915E-05_JPRB, 0.64684527E-05_JPRB, 0.64137948E-05_JPRB, &
  & 0.63690632E-05_JPRB, 0.63296529E-05_JPRB, 0.62969525E-05_JPRB, 0.62713480E-05_JPRB, 0.62553086E-05_JPRB, 0.62508902E-05_JPRB, &
  & 0.62621107E-05_JPRB, 0.63013767E-05_JPRB, 0.63568677E-05_JPRB, 0.64198980E-05_JPRB, 0.64990668E-05_JPRB, 0.65810332E-05_JPRB, &
  & 0.66701987E-05_JPRB, 0.67321066E-05_JPRB, 0.67704241E-05_JPRB, 0.68161594E-05_JPRB, 0.68441695E-05_JPRB, 0.68529071E-05_JPRB, &
  & 0.68353406E-05_JPRB, 0.67994438E-05_JPRB, 0.67484802E-05_JPRB, 0.66887769E-05_JPRB, 0.66245952E-05_JPRB, 0.65580793E-05_JPRB, &
  & 0.64897190E-05_JPRB, 0.64169017E-05_JPRB, 0.63395169E-05_JPRB, 0.62542267E-05_JPRB, 0.61621631E-05_JPRB, 0.60534935E-05_JPRB, &
  & 0.59614117E-05_JPRB, 0.58757655E-05_JPRB, 0.57919183E-05_JPRB, 0.57078528E-05_JPRB, 0.56223180E-05_JPRB, 0.55306105E-05_JPRB, &
  & 0.54258426E-05_JPRB, 0.53249414E-05_JPRB, 0.52144255E-05_JPRB, 0.50800604E-05_JPRB, 0.49319938E-05_JPRB, 0.47504868E-05_JPRB, &
  & 0.45329271E-05_JPRB, 0.42867737E-05_JPRB, 0.40995546E-05_JPRB, 0.39602105E-05_JPRB /)

RGHG7(:,14, 8) = (/ &
  & 0.37145658E-05_JPRB, 0.38292510E-05_JPRB, 0.39286201E-05_JPRB, 0.40503528E-05_JPRB, 0.42880556E-05_JPRB, 0.46220939E-05_JPRB, &
  & 0.50068379E-05_JPRB, 0.53920335E-05_JPRB, 0.57476805E-05_JPRB, 0.60426846E-05_JPRB, 0.62664890E-05_JPRB, 0.64364172E-05_JPRB, &
  & 0.65579070E-05_JPRB, 0.66462053E-05_JPRB, 0.67095871E-05_JPRB, 0.67522842E-05_JPRB, 0.67798851E-05_JPRB, 0.67899355E-05_JPRB, &
  & 0.68064351E-05_JPRB, 0.68244026E-05_JPRB, 0.68494132E-05_JPRB, 0.68771269E-05_JPRB, 0.69148964E-05_JPRB, 0.69596977E-05_JPRB, &
  & 0.70124538E-05_JPRB, 0.70659421E-05_JPRB, 0.71350328E-05_JPRB, 0.72184330E-05_JPRB, 0.73197825E-05_JPRB, 0.74271056E-05_JPRB, &
  & 0.75430967E-05_JPRB, 0.76428087E-05_JPRB, 0.77199056E-05_JPRB, 0.77945542E-05_JPRB, 0.78435178E-05_JPRB, 0.78615840E-05_JPRB, &
  & 0.78427192E-05_JPRB, 0.77897030E-05_JPRB, 0.77140239E-05_JPRB, 0.76245542E-05_JPRB, 0.75270545E-05_JPRB, 0.74261452E-05_JPRB, &
  & 0.73217570E-05_JPRB, 0.72126663E-05_JPRB, 0.70979731E-05_JPRB, 0.69760531E-05_JPRB, 0.68501104E-05_JPRB, 0.67129326E-05_JPRB, &
  & 0.65929094E-05_JPRB, 0.64803380E-05_JPRB, 0.63696107E-05_JPRB, 0.62566642E-05_JPRB, 0.61384703E-05_JPRB, 0.60111342E-05_JPRB, &
  & 0.58677301E-05_JPRB, 0.57200523E-05_JPRB, 0.55573405E-05_JPRB, 0.53693916E-05_JPRB, 0.51649026E-05_JPRB, 0.49345854E-05_JPRB, &
  & 0.46815235E-05_JPRB, 0.44236367E-05_JPRB, 0.42356696E-05_JPRB, 0.41024814E-05_JPRB /)

RGHG7(:,15, 8) = (/ &
  & 0.38249113E-05_JPRB, 0.39089005E-05_JPRB, 0.39981101E-05_JPRB, 0.40671907E-05_JPRB, 0.42268234E-05_JPRB, 0.45055190E-05_JPRB, &
  & 0.48353186E-05_JPRB, 0.51773054E-05_JPRB, 0.55077867E-05_JPRB, 0.58032124E-05_JPRB, 0.60566404E-05_JPRB, 0.62736831E-05_JPRB, &
  & 0.64543829E-05_JPRB, 0.66042758E-05_JPRB, 0.67324859E-05_JPRB, 0.68404047E-05_JPRB, 0.69318144E-05_JPRB, 0.70068904E-05_JPRB, &
  & 0.70807610E-05_JPRB, 0.71539775E-05_JPRB, 0.72286894E-05_JPRB, 0.73035940E-05_JPRB, 0.73829278E-05_JPRB, 0.74645855E-05_JPRB, &
  & 0.75569587E-05_JPRB, 0.76558472E-05_JPRB, 0.77620552E-05_JPRB, 0.78733574E-05_JPRB, 0.79969604E-05_JPRB, 0.81275139E-05_JPRB, &
  & 0.82619499E-05_JPRB, 0.83742016E-05_JPRB, 0.84592612E-05_JPRB, 0.85381280E-05_JPRB, 0.85914335E-05_JPRB, 0.86072559E-05_JPRB, &
  & 0.85830525E-05_JPRB, 0.85247348E-05_JPRB, 0.84396688E-05_JPRB, 0.83384930E-05_JPRB, 0.82246488E-05_JPRB, 0.81021235E-05_JPRB, &
  & 0.79709744E-05_JPRB, 0.78313487E-05_JPRB, 0.76825918E-05_JPRB, 0.75265389E-05_JPRB, 0.73665874E-05_JPRB, 0.71993127E-05_JPRB, &
  & 0.70478336E-05_JPRB, 0.69028993E-05_JPRB, 0.67590440E-05_JPRB, 0.66121329E-05_JPRB, 0.64590454E-05_JPRB, 0.62966687E-05_JPRB, &
  & 0.61177807E-05_JPRB, 0.59308641E-05_JPRB, 0.57280886E-05_JPRB, 0.55023370E-05_JPRB, 0.52628152E-05_JPRB, 0.50068256E-05_JPRB, &
  & 0.47448375E-05_JPRB, 0.44935518E-05_JPRB, 0.43155528E-05_JPRB, 0.41842600E-05_JPRB /)

RGHG7(:,16, 8) = (/ &
  & 0.41337594E-05_JPRB, 0.41712469E-05_JPRB, 0.42165443E-05_JPRB, 0.42231518E-05_JPRB, 0.43196810E-05_JPRB, 0.45173470E-05_JPRB, &
  & 0.47813005E-05_JPRB, 0.50581798E-05_JPRB, 0.53341764E-05_JPRB, 0.55953037E-05_JPRB, 0.58365604E-05_JPRB, 0.60618440E-05_JPRB, &
  & 0.62718591E-05_JPRB, 0.64657652E-05_JPRB, 0.66463290E-05_JPRB, 0.68115633E-05_JPRB, 0.69593580E-05_JPRB, 0.70903948E-05_JPRB, &
  & 0.72135317E-05_JPRB, 0.73334190E-05_JPRB, 0.74512163E-05_JPRB, 0.75687949E-05_JPRB, 0.76894821E-05_JPRB, 0.78133044E-05_JPRB, &
  & 0.79424908E-05_JPRB, 0.80767468E-05_JPRB, 0.82190363E-05_JPRB, 0.83616351E-05_JPRB, 0.85045840E-05_JPRB, 0.86375558E-05_JPRB, &
  & 0.87676399E-05_JPRB, 0.88783072E-05_JPRB, 0.89608075E-05_JPRB, 0.90289623E-05_JPRB, 0.90670192E-05_JPRB, 0.90740332E-05_JPRB, &
  & 0.90496160E-05_JPRB, 0.89954356E-05_JPRB, 0.89153400E-05_JPRB, 0.88167408E-05_JPRB, 0.87019689E-05_JPRB, 0.85687525E-05_JPRB, &
  & 0.84201383E-05_JPRB, 0.82535726E-05_JPRB, 0.80749269E-05_JPRB, 0.78862258E-05_JPRB, 0.76932174E-05_JPRB, 0.74940331E-05_JPRB, &
  & 0.73087281E-05_JPRB, 0.71299742E-05_JPRB, 0.69525645E-05_JPRB, 0.67727055E-05_JPRB, 0.65869549E-05_JPRB, 0.63924917E-05_JPRB, &
  & 0.61826227E-05_JPRB, 0.59641720E-05_JPRB, 0.57328057E-05_JPRB, 0.54850902E-05_JPRB, 0.52309374E-05_JPRB, 0.49727760E-05_JPRB, &
  & 0.47211993E-05_JPRB, 0.44929529E-05_JPRB, 0.43324294E-05_JPRB, 0.42098923E-05_JPRB /)

RGHG7(:,17, 8) = (/ &
  & 0.43641280E-05_JPRB, 0.43519062E-05_JPRB, 0.43115620E-05_JPRB, 0.42832949E-05_JPRB, 0.43107452E-05_JPRB, 0.44470958E-05_JPRB, &
  & 0.46607106E-05_JPRB, 0.49168716E-05_JPRB, 0.51765346E-05_JPRB, 0.54266716E-05_JPRB, 0.56656327E-05_JPRB, 0.58996975E-05_JPRB, &
  & 0.61322239E-05_JPRB, 0.63645639E-05_JPRB, 0.65937488E-05_JPRB, 0.68131267E-05_JPRB, 0.70170072E-05_JPRB, 0.72026169E-05_JPRB, &
  & 0.73744009E-05_JPRB, 0.75375842E-05_JPRB, 0.76955830E-05_JPRB, 0.78524836E-05_JPRB, 0.80131977E-05_JPRB, 0.81804583E-05_JPRB, &
  & 0.83563282E-05_JPRB, 0.85369647E-05_JPRB, 0.87197986E-05_JPRB, 0.88938114E-05_JPRB, 0.90530366E-05_JPRB, 0.91873881E-05_JPRB, &
  & 0.92938199E-05_JPRB, 0.93674280E-05_JPRB, 0.94027882E-05_JPRB, 0.94228953E-05_JPRB, 0.94230963E-05_JPRB, 0.94002435E-05_JPRB, &
  & 0.93529870E-05_JPRB, 0.92932514E-05_JPRB, 0.92218052E-05_JPRB, 0.91349966E-05_JPRB, 0.90336744E-05_JPRB, 0.89116138E-05_JPRB, &
  & 0.87680037E-05_JPRB, 0.85995998E-05_JPRB, 0.84093908E-05_JPRB, 0.82047609E-05_JPRB, 0.79905358E-05_JPRB, 0.77655968E-05_JPRB, &
  & 0.75487396E-05_JPRB, 0.73356609E-05_JPRB, 0.71225277E-05_JPRB, 0.69066828E-05_JPRB, 0.66855796E-05_JPRB, 0.64575788E-05_JPRB, &
  & 0.62175932E-05_JPRB, 0.59721642E-05_JPRB, 0.57195225E-05_JPRB, 0.54594157E-05_JPRB, 0.52016812E-05_JPRB, 0.49503419E-05_JPRB, &
  & 0.47147773E-05_JPRB, 0.45076326E-05_JPRB, 0.43627410E-05_JPRB, 0.42394663E-05_JPRB /)

RGHG7(:,18, 8) = (/ &
  & 0.44714066E-05_JPRB, 0.43982427E-05_JPRB, 0.43105852E-05_JPRB, 0.42240463E-05_JPRB, 0.42009397E-05_JPRB, 0.42811407E-05_JPRB, &
  & 0.44701187E-05_JPRB, 0.47251688E-05_JPRB, 0.49940531E-05_JPRB, 0.52588812E-05_JPRB, 0.55173541E-05_JPRB, 0.57761686E-05_JPRB, &
  & 0.60403650E-05_JPRB, 0.63117250E-05_JPRB, 0.65877948E-05_JPRB, 0.68574750E-05_JPRB, 0.71092159E-05_JPRB, 0.73391020E-05_JPRB, &
  & 0.75505604E-05_JPRB, 0.77495124E-05_JPRB, 0.79399524E-05_JPRB, 0.81267926E-05_JPRB, 0.83160166E-05_JPRB, 0.85131915E-05_JPRB, &
  & 0.87182761E-05_JPRB, 0.89239220E-05_JPRB, 0.91212050E-05_JPRB, 0.92973196E-05_JPRB, 0.94428624E-05_JPRB, 0.95500654E-05_JPRB, &
  & 0.96179601E-05_JPRB, 0.96451113E-05_JPRB, 0.96328877E-05_JPRB, 0.96024150E-05_JPRB, 0.95602027E-05_JPRB, 0.95056648E-05_JPRB, &
  & 0.94468223E-05_JPRB, 0.93846002E-05_JPRB, 0.93167400E-05_JPRB, 0.92394948E-05_JPRB, 0.91499969E-05_JPRB, 0.90407220E-05_JPRB, &
  & 0.89092473E-05_JPRB, 0.87518783E-05_JPRB, 0.85691263E-05_JPRB, 0.83657997E-05_JPRB, 0.81470516E-05_JPRB, 0.79120809E-05_JPRB, &
  & 0.76775996E-05_JPRB, 0.74423774E-05_JPRB, 0.72043335E-05_JPRB, 0.69620223E-05_JPRB, 0.67146225E-05_JPRB, 0.64621163E-05_JPRB, &
  & 0.62023405E-05_JPRB, 0.59420408E-05_JPRB, 0.56809849E-05_JPRB, 0.54204152E-05_JPRB, 0.51694024E-05_JPRB, 0.49319374E-05_JPRB, &
  & 0.47146823E-05_JPRB, 0.45254119E-05_JPRB, 0.43809760E-05_JPRB, 0.42416368E-05_JPRB /)

RGHG7(:,19, 8) = (/ &
  & 0.44452090E-05_JPRB, 0.43432174E-05_JPRB, 0.42212291E-05_JPRB, 0.40865489E-05_JPRB, 0.40361783E-05_JPRB, 0.40881200E-05_JPRB, &
  & 0.42485622E-05_JPRB, 0.44978233E-05_JPRB, 0.47812860E-05_JPRB, 0.50765902E-05_JPRB, 0.53718591E-05_JPRB, 0.56659974E-05_JPRB, &
  & 0.59640483E-05_JPRB, 0.62671825E-05_JPRB, 0.65702325E-05_JPRB, 0.68631020E-05_JPRB, 0.71337827E-05_JPRB, 0.73749752E-05_JPRB, &
  & 0.75876737E-05_JPRB, 0.77794566E-05_JPRB, 0.79577676E-05_JPRB, 0.81275120E-05_JPRB, 0.82904271E-05_JPRB, 0.84531830E-05_JPRB, &
  & 0.86158234E-05_JPRB, 0.87754906E-05_JPRB, 0.89296900E-05_JPRB, 0.90720996E-05_JPRB, 0.92011724E-05_JPRB, 0.93113586E-05_JPRB, &
  & 0.93991130E-05_JPRB, 0.94573634E-05_JPRB, 0.94788975E-05_JPRB, 0.94773241E-05_JPRB, 0.94570642E-05_JPRB, 0.94160632E-05_JPRB, &
  & 0.93635163E-05_JPRB, 0.93013114E-05_JPRB, 0.92290102E-05_JPRB, 0.91452685E-05_JPRB, 0.90479243E-05_JPRB, 0.89340438E-05_JPRB, &
  & 0.88034758E-05_JPRB, 0.86526279E-05_JPRB, 0.84814728E-05_JPRB, 0.82934184E-05_JPRB, 0.80900754E-05_JPRB, 0.78699413E-05_JPRB, &
  & 0.76457418E-05_JPRB, 0.74156546E-05_JPRB, 0.71784016E-05_JPRB, 0.69336056E-05_JPRB, 0.66820407E-05_JPRB, 0.64254673E-05_JPRB, &
  & 0.61642854E-05_JPRB, 0.59054792E-05_JPRB, 0.56502954E-05_JPRB, 0.54006837E-05_JPRB, 0.51635884E-05_JPRB, 0.49421214E-05_JPRB, &
  & 0.47411445E-05_JPRB, 0.45656234E-05_JPRB, 0.44247390E-05_JPRB, 0.42745810E-05_JPRB /)

RGHG7(:,20, 8) = (/ &
  & 0.43114896E-05_JPRB, 0.41853127E-05_JPRB, 0.40402574E-05_JPRB, 0.38662588E-05_JPRB, 0.37962070E-05_JPRB, 0.38355261E-05_JPRB, &
  & 0.39819402E-05_JPRB, 0.42328597E-05_JPRB, 0.45463571E-05_JPRB, 0.48778534E-05_JPRB, 0.52128448E-05_JPRB, 0.55428218E-05_JPRB, &
  & 0.58672535E-05_JPRB, 0.61853948E-05_JPRB, 0.64925152E-05_JPRB, 0.67773044E-05_JPRB, 0.70289589E-05_JPRB, 0.72432717E-05_JPRB, &
  & 0.74231061E-05_JPRB, 0.75718799E-05_JPRB, 0.76950300E-05_JPRB, 0.78030716E-05_JPRB, 0.78976327E-05_JPRB, 0.79811025E-05_JPRB, &
  & 0.80572972E-05_JPRB, 0.81301114E-05_JPRB, 0.82085053E-05_JPRB, 0.82987199E-05_JPRB, 0.84111389E-05_JPRB, 0.85417078E-05_JPRB, &
  & 0.86843911E-05_JPRB, 0.88229544E-05_JPRB, 0.89383648E-05_JPRB, 0.90290669E-05_JPRB, 0.90836411E-05_JPRB, 0.91007050E-05_JPRB, &
  & 0.90775711E-05_JPRB, 0.90257845E-05_JPRB, 0.89501364E-05_JPRB, 0.88503666E-05_JPRB, 0.87311728E-05_JPRB, 0.85974625E-05_JPRB, &
  & 0.84512749E-05_JPRB, 0.82942233E-05_JPRB, 0.81293028E-05_JPRB, 0.79571055E-05_JPRB, 0.77770028E-05_JPRB, 0.75874477E-05_JPRB, &
  & 0.73953966E-05_JPRB, 0.71970121E-05_JPRB, 0.69894149E-05_JPRB, 0.67716151E-05_JPRB, 0.65442487E-05_JPRB, 0.63095627E-05_JPRB, &
  & 0.60696079E-05_JPRB, 0.58308829E-05_JPRB, 0.55957075E-05_JPRB, 0.53667718E-05_JPRB, 0.51490665E-05_JPRB, 0.49443142E-05_JPRB, &
  & 0.47540102E-05_JPRB, 0.45801853E-05_JPRB, 0.44418780E-05_JPRB, 0.42879942E-05_JPRB /)

RGHG7(:,21, 8) = (/ &
  & 0.41011258E-05_JPRB, 0.39556007E-05_JPRB, 0.37899972E-05_JPRB, 0.35904975E-05_JPRB, 0.34930622E-05_JPRB, 0.35189241E-05_JPRB, &
  & 0.36617409E-05_JPRB, 0.39126890E-05_JPRB, 0.42476790E-05_JPRB, 0.46158757E-05_JPRB, 0.49915520E-05_JPRB, 0.53567833E-05_JPRB, &
  & 0.57033321E-05_JPRB, 0.60258485E-05_JPRB, 0.63186117E-05_JPRB, 0.65748613E-05_JPRB, 0.67881347E-05_JPRB, 0.69556659E-05_JPRB, &
  & 0.70817041E-05_JPRB, 0.71763684E-05_JPRB, 0.72403150E-05_JPRB, 0.72803391E-05_JPRB, 0.73035199E-05_JPRB, 0.73095916E-05_JPRB, &
  & 0.73044280E-05_JPRB, 0.72975699E-05_JPRB, 0.73058659E-05_JPRB, 0.73461165E-05_JPRB, 0.74325662E-05_JPRB, 0.75659768E-05_JPRB, &
  & 0.77428922E-05_JPRB, 0.79428919E-05_JPRB, 0.81405988E-05_JPRB, 0.83225732E-05_JPRB, 0.84660751E-05_JPRB, 0.85521806E-05_JPRB, &
  & 0.85814390E-05_JPRB, 0.85521824E-05_JPRB, 0.84753447E-05_JPRB, 0.83637660E-05_JPRB, 0.82275719E-05_JPRB, 0.80725704E-05_JPRB, &
  & 0.79093579E-05_JPRB, 0.77460099E-05_JPRB, 0.75832900E-05_JPRB, 0.74224608E-05_JPRB, 0.72664875E-05_JPRB, 0.71116237E-05_JPRB, &
  & 0.69602115E-05_JPRB, 0.68055137E-05_JPRB, 0.66431771E-05_JPRB, 0.64703081E-05_JPRB, 0.62858890E-05_JPRB, 0.60921725E-05_JPRB, &
  & 0.58910127E-05_JPRB, 0.56876779E-05_JPRB, 0.54844618E-05_JPRB, 0.52833288E-05_JPRB, 0.50882609E-05_JPRB, 0.48992215E-05_JPRB, &
  & 0.47168273E-05_JPRB, 0.45504494E-05_JPRB, 0.44081621E-05_JPRB, 0.42729334E-05_JPRB /)

RGHG7(:,22, 8) = (/ &
  & 0.38503367E-05_JPRB, 0.36878446E-05_JPRB, 0.35009339E-05_JPRB, 0.32693354E-05_JPRB, 0.31454658E-05_JPRB, 0.31443551E-05_JPRB, &
  & 0.32775988E-05_JPRB, 0.35336411E-05_JPRB, 0.38826147E-05_JPRB, 0.42814945E-05_JPRB, 0.46928103E-05_JPRB, 0.50887447E-05_JPRB, &
  & 0.54531497E-05_JPRB, 0.57766883E-05_JPRB, 0.60534417E-05_JPRB, 0.62791823E-05_JPRB, 0.64524174E-05_JPRB, 0.65766258E-05_JPRB, &
  & 0.66573048E-05_JPRB, 0.67001138E-05_JPRB, 0.67160695E-05_JPRB, 0.67031183E-05_JPRB, 0.66693729E-05_JPRB, 0.66173870E-05_JPRB, &
  & 0.65517734E-05_JPRB, 0.64858632E-05_JPRB, 0.64401943E-05_JPRB, 0.64338788E-05_JPRB, 0.64850210E-05_JPRB, 0.65974427E-05_JPRB, &
  & 0.67676638E-05_JPRB, 0.69790667E-05_JPRB, 0.72111225E-05_JPRB, 0.74384261E-05_JPRB, 0.76325550E-05_JPRB, 0.77696459E-05_JPRB, &
  & 0.78403182E-05_JPRB, 0.78453104E-05_JPRB, 0.77908235E-05_JPRB, 0.76864071E-05_JPRB, 0.75526546E-05_JPRB, 0.73961605E-05_JPRB, &
  & 0.72394282E-05_JPRB, 0.70806009E-05_JPRB, 0.69274170E-05_JPRB, 0.67851315E-05_JPRB, 0.66535167E-05_JPRB, 0.65300746E-05_JPRB, &
  & 0.64163155E-05_JPRB, 0.63056982E-05_JPRB, 0.61910246E-05_JPRB, 0.60668990E-05_JPRB, 0.59313597E-05_JPRB, 0.57852212E-05_JPRB, &
  & 0.56295207E-05_JPRB, 0.54681109E-05_JPRB, 0.53026793E-05_JPRB, 0.51346024E-05_JPRB, 0.49657874E-05_JPRB, 0.47968988E-05_JPRB, &
  & 0.46284022E-05_JPRB, 0.44770318E-05_JPRB, 0.43479868E-05_JPRB, 0.42300990E-05_JPRB /)

RGHG7(:,23, 8) = (/ &
  & 0.35958394E-05_JPRB, 0.34132484E-05_JPRB, 0.32075291E-05_JPRB, 0.29544863E-05_JPRB, 0.27999340E-05_JPRB, 0.27672040E-05_JPRB, &
  & 0.28739012E-05_JPRB, 0.31186962E-05_JPRB, 0.34652339E-05_JPRB, 0.38797143E-05_JPRB, 0.43136370E-05_JPRB, 0.47337435E-05_JPRB, &
  & 0.51147517E-05_JPRB, 0.54415241E-05_JPRB, 0.57074731E-05_JPRB, 0.59113286E-05_JPRB, 0.60553266E-05_JPRB, 0.61439132E-05_JPRB, &
  & 0.61896258E-05_JPRB, 0.61961441E-05_JPRB, 0.61729947E-05_JPRB, 0.61253672E-05_JPRB, 0.60535649E-05_JPRB, 0.59641220E-05_JPRB, &
  & 0.58618020E-05_JPRB, 0.57611001E-05_JPRB, 0.56797358E-05_JPRB, 0.56379913E-05_JPRB, 0.56462950E-05_JPRB, 0.57127568E-05_JPRB, &
  & 0.58386772E-05_JPRB, 0.60126090E-05_JPRB, 0.62189420E-05_JPRB, 0.64331589E-05_JPRB, 0.66317048E-05_JPRB, 0.67844458E-05_JPRB, &
  & 0.68780541E-05_JPRB, 0.69084131E-05_JPRB, 0.68781105E-05_JPRB, 0.68089685E-05_JPRB, 0.67099468E-05_JPRB, 0.65918152E-05_JPRB, &
  & 0.64613337E-05_JPRB, 0.63362227E-05_JPRB, 0.62164609E-05_JPRB, 0.61024293E-05_JPRB, 0.60016414E-05_JPRB, 0.59132135E-05_JPRB, &
  & 0.58354999E-05_JPRB, 0.57611132E-05_JPRB, 0.56840577E-05_JPRB, 0.56000708E-05_JPRB, 0.55066848E-05_JPRB, 0.54030352E-05_JPRB, &
  & 0.52892851E-05_JPRB, 0.51676516E-05_JPRB, 0.50390740E-05_JPRB, 0.49041832E-05_JPRB, 0.47642820E-05_JPRB, 0.46195937E-05_JPRB, &
  & 0.44730891E-05_JPRB, 0.43389350E-05_JPRB, 0.42379779E-05_JPRB, 0.41431936E-05_JPRB /)

RGHG7(:,24, 8) = (/ &
  & 0.33453043E-05_JPRB, 0.31525105E-05_JPRB, 0.29295793E-05_JPRB, 0.26526543E-05_JPRB, 0.24732017E-05_JPRB, 0.24048074E-05_JPRB, &
  & 0.24668025E-05_JPRB, 0.26699870E-05_JPRB, 0.30051438E-05_JPRB, 0.34233899E-05_JPRB, 0.38701510E-05_JPRB, 0.43048367E-05_JPRB, &
  & 0.46952500E-05_JPRB, 0.50254971E-05_JPRB, 0.52865093E-05_JPRB, 0.54767252E-05_JPRB, 0.56015988E-05_JPRB, 0.56683225E-05_JPRB, &
  & 0.56883136E-05_JPRB, 0.56714812E-05_JPRB, 0.56245772E-05_JPRB, 0.55538835E-05_JPRB, 0.54636953E-05_JPRB, 0.53569042E-05_JPRB, &
  & 0.52382802E-05_JPRB, 0.51207194E-05_JPRB, 0.50180342E-05_JPRB, 0.49431992E-05_JPRB, 0.49140090E-05_JPRB, 0.49312066E-05_JPRB, &
  & 0.49925911E-05_JPRB, 0.50954336E-05_JPRB, 0.52282876E-05_JPRB, 0.53794793E-05_JPRB, 0.55259275E-05_JPRB, 0.56494382E-05_JPRB, &
  & 0.57395259E-05_JPRB, 0.57882426E-05_JPRB, 0.58027867E-05_JPRB, 0.57857546E-05_JPRB, 0.57489333E-05_JPRB, 0.56946401E-05_JPRB, &
  & 0.56320687E-05_JPRB, 0.55589740E-05_JPRB, 0.54889783E-05_JPRB, 0.54222241E-05_JPRB, 0.53604685E-05_JPRB, 0.53045310E-05_JPRB, &
  & 0.52564301E-05_JPRB, 0.52125665E-05_JPRB, 0.51668248E-05_JPRB, 0.51153611E-05_JPRB, 0.50551521E-05_JPRB, 0.49853343E-05_JPRB, &
  & 0.49057840E-05_JPRB, 0.48177135E-05_JPRB, 0.47214667E-05_JPRB, 0.46171576E-05_JPRB, 0.45052311E-05_JPRB, 0.43870132E-05_JPRB, &
  & 0.42680963E-05_JPRB, 0.41625244E-05_JPRB, 0.40849613E-05_JPRB, 0.40144409E-05_JPRB /)

RGHG7(:,25, 8) = (/ &
  & 0.30976144E-05_JPRB, 0.28992108E-05_JPRB, 0.26754276E-05_JPRB, 0.23915270E-05_JPRB, 0.21994160E-05_JPRB, 0.21072863E-05_JPRB, &
  & 0.21358421E-05_JPRB, 0.22978004E-05_JPRB, 0.25926620E-05_JPRB, 0.29762034E-05_JPRB, 0.34053185E-05_JPRB, 0.38313251E-05_JPRB, &
  & 0.42202960E-05_JPRB, 0.45484571E-05_JPRB, 0.48047496E-05_JPRB, 0.49860487E-05_JPRB, 0.50979593E-05_JPRB, 0.51503907E-05_JPRB, &
  & 0.51554894E-05_JPRB, 0.51246116E-05_JPRB, 0.50664726E-05_JPRB, 0.49870287E-05_JPRB, 0.48911879E-05_JPRB, 0.47829312E-05_JPRB, &
  & 0.46676146E-05_JPRB, 0.45515089E-05_JPRB, 0.44475946E-05_JPRB, 0.43649561E-05_JPRB, 0.42973179E-05_JPRB, 0.42563606E-05_JPRB, &
  & 0.42470228E-05_JPRB, 0.42667198E-05_JPRB, 0.43099808E-05_JPRB, 0.43735054E-05_JPRB, 0.44467042E-05_JPRB, 0.45207494E-05_JPRB, &
  & 0.45873276E-05_JPRB, 0.46418800E-05_JPRB, 0.46956238E-05_JPRB, 0.47312660E-05_JPRB, 0.47640806E-05_JPRB, 0.47839480E-05_JPRB, &
  & 0.47985995E-05_JPRB, 0.47987178E-05_JPRB, 0.47888384E-05_JPRB, 0.47720637E-05_JPRB, 0.47557451E-05_JPRB, 0.47390713E-05_JPRB, &
  & 0.47212852E-05_JPRB, 0.47013082E-05_JPRB, 0.46774030E-05_JPRB, 0.46475925E-05_JPRB, 0.46103660E-05_JPRB, 0.45650049E-05_JPRB, &
  & 0.45115271E-05_JPRB, 0.44501176E-05_JPRB, 0.43806190E-05_JPRB, 0.43026548E-05_JPRB, 0.42169681E-05_JPRB, 0.41262829E-05_JPRB, &
  & 0.40359600E-05_JPRB, 0.39609408E-05_JPRB, 0.39048855E-05_JPRB, 0.38527219E-05_JPRB /)

RGHG7(:,26, 8) = (/ &
  & 0.28434670E-05_JPRB, 0.26544690E-05_JPRB, 0.24372844E-05_JPRB, 0.21773305E-05_JPRB, 0.19848119E-05_JPRB, 0.18828900E-05_JPRB, &
  & 0.18798379E-05_JPRB, 0.19923375E-05_JPRB, 0.22279405E-05_JPRB, 0.25659638E-05_JPRB, 0.29601772E-05_JPRB, 0.33624212E-05_JPRB, &
  & 0.37330356E-05_JPRB, 0.40469786E-05_JPRB, 0.42906486E-05_JPRB, 0.44597364E-05_JPRB, 0.45594379E-05_JPRB, 0.46002979E-05_JPRB, &
  & 0.45958809E-05_JPRB, 0.45582178E-05_JPRB, 0.44972467E-05_JPRB, 0.44200342E-05_JPRB, 0.43316450E-05_JPRB, 0.42357451E-05_JPRB, &
  & 0.41358417E-05_JPRB, 0.40346486E-05_JPRB, 0.39312367E-05_JPRB, 0.38316671E-05_JPRB, 0.37471186E-05_JPRB, 0.36719957E-05_JPRB, &
  & 0.36052245E-05_JPRB, 0.35512037E-05_JPRB, 0.35130950E-05_JPRB, 0.34953162E-05_JPRB, 0.34971254E-05_JPRB, 0.35183607E-05_JPRB, &
  & 0.35587705E-05_JPRB, 0.36151207E-05_JPRB, 0.36915608E-05_JPRB, 0.37764530E-05_JPRB, 0.38682792E-05_JPRB, 0.39565430E-05_JPRB, &
  & 0.40355008E-05_JPRB, 0.41005032E-05_JPRB, 0.41491048E-05_JPRB, 0.41819289E-05_JPRB, 0.42013221E-05_JPRB, 0.42131978E-05_JPRB, &
  & 0.42209062E-05_JPRB, 0.42233351E-05_JPRB, 0.42188644E-05_JPRB, 0.42071420E-05_JPRB, 0.41880689E-05_JPRB, 0.41618405E-05_JPRB, &
  & 0.41284525E-05_JPRB, 0.40877740E-05_JPRB, 0.40394502E-05_JPRB, 0.39833217E-05_JPRB, 0.39210499E-05_JPRB, 0.38556041E-05_JPRB, &
  & 0.37941079E-05_JPRB, 0.37447458E-05_JPRB, 0.37097843E-05_JPRB, 0.36806678E-05_JPRB /)

RGHG7(:,27, 8) = (/ &
  & 0.25999191E-05_JPRB, 0.24209653E-05_JPRB, 0.22302249E-05_JPRB, 0.19923366E-05_JPRB, 0.18260200E-05_JPRB, 0.17252229E-05_JPRB, &
  & 0.17089225E-05_JPRB, 0.17894448E-05_JPRB, 0.19781473E-05_JPRB, 0.22637248E-05_JPRB, 0.26037465E-05_JPRB, 0.29562884E-05_JPRB, &
  & 0.32862042E-05_JPRB, 0.35667863E-05_JPRB, 0.37837776E-05_JPRB, 0.39314523E-05_JPRB, 0.40144164E-05_JPRB, 0.40426880E-05_JPRB, &
  & 0.40306963E-05_JPRB, 0.39909105E-05_JPRB, 0.39331421E-05_JPRB, 0.38657827E-05_JPRB, 0.37938726E-05_JPRB, 0.37181208E-05_JPRB, &
  & 0.36416209E-05_JPRB, 0.35622838E-05_JPRB, 0.34814432E-05_JPRB, 0.33933250E-05_JPRB, 0.32901296E-05_JPRB, 0.31788404E-05_JPRB, &
  & 0.30657609E-05_JPRB, 0.29558275E-05_JPRB, 0.28575475E-05_JPRB, 0.27810454E-05_JPRB, 0.27320114E-05_JPRB, 0.27157889E-05_JPRB, &
  & 0.27353549E-05_JPRB, 0.27899655E-05_JPRB, 0.28775967E-05_JPRB, 0.29930095E-05_JPRB, 0.31217103E-05_JPRB, 0.32569401E-05_JPRB, &
  & 0.33827653E-05_JPRB, 0.34954330E-05_JPRB, 0.35880325E-05_JPRB, 0.36621743E-05_JPRB, 0.37173252E-05_JPRB, 0.37561631E-05_JPRB, &
  & 0.37815344E-05_JPRB, 0.37973919E-05_JPRB, 0.38053029E-05_JPRB, 0.38058056E-05_JPRB, 0.37997070E-05_JPRB, 0.37875579E-05_JPRB, &
  & 0.37695597E-05_JPRB, 0.37455793E-05_JPRB, 0.37154546E-05_JPRB, 0.36790459E-05_JPRB, 0.36373524E-05_JPRB, 0.35941271E-05_JPRB, &
  & 0.35557819E-05_JPRB, 0.35261298E-05_JPRB, 0.35078406E-05_JPRB, 0.34984441E-05_JPRB /)

RGHG7(:,28, 8) = (/ &
  & 0.23831465E-05_JPRB, 0.22187103E-05_JPRB, 0.20466196E-05_JPRB, 0.18541158E-05_JPRB, 0.17017007E-05_JPRB, 0.16117857E-05_JPRB, &
  & 0.15879020E-05_JPRB, 0.16457647E-05_JPRB, 0.17962334E-05_JPRB, 0.20313125E-05_JPRB, 0.23155112E-05_JPRB, 0.26134176E-05_JPRB, &
  & 0.28928794E-05_JPRB, 0.31305945E-05_JPRB, 0.33122112E-05_JPRB, 0.34320985E-05_JPRB, 0.34940042E-05_JPRB, 0.35088217E-05_JPRB, &
  & 0.34894776E-05_JPRB, 0.34489417E-05_JPRB, 0.33973452E-05_JPRB, 0.33439537E-05_JPRB, 0.32889047E-05_JPRB, 0.32361111E-05_JPRB, &
  & 0.31840873E-05_JPRB, 0.31287004E-05_JPRB, 0.30633441E-05_JPRB, 0.29806899E-05_JPRB, 0.28762790E-05_JPRB, 0.27519543E-05_JPRB, &
  & 0.26119981E-05_JPRB, 0.24680965E-05_JPRB, 0.23336743E-05_JPRB, 0.22229001E-05_JPRB, 0.21453004E-05_JPRB, 0.21084713E-05_JPRB, &
  & 0.21157716E-05_JPRB, 0.21676587E-05_JPRB, 0.22585623E-05_JPRB, 0.23858038E-05_JPRB, 0.25337056E-05_JPRB, 0.26918876E-05_JPRB, &
  & 0.28459117E-05_JPRB, 0.29864455E-05_JPRB, 0.31075697E-05_JPRB, 0.32056798E-05_JPRB, 0.32819064E-05_JPRB, 0.33379438E-05_JPRB, &
  & 0.33789854E-05_JPRB, 0.34073273E-05_JPRB, 0.34259938E-05_JPRB, 0.34370082E-05_JPRB, 0.34418501E-05_JPRB, 0.34414977E-05_JPRB, &
  & 0.34364273E-05_JPRB, 0.34266593E-05_JPRB, 0.34121758E-05_JPRB, 0.33929909E-05_JPRB, 0.33698714E-05_JPRB, 0.33464917E-05_JPRB, &
  & 0.33264437E-05_JPRB, 0.33124561E-05_JPRB, 0.33064298E-05_JPRB, 0.33083936E-05_JPRB /)

RGHG7(:,29, 8) = (/ &
  & 0.22034835E-05_JPRB, 0.20541711E-05_JPRB, 0.19069624E-05_JPRB, 0.17321298E-05_JPRB, 0.16065644E-05_JPRB, 0.15219443E-05_JPRB, &
  & 0.14951188E-05_JPRB, 0.15372885E-05_JPRB, 0.16576589E-05_JPRB, 0.18496072E-05_JPRB, 0.20833065E-05_JPRB, 0.23273376E-05_JPRB, &
  & 0.25564466E-05_JPRB, 0.27495494E-05_JPRB, 0.28936086E-05_JPRB, 0.29834471E-05_JPRB, 0.30230597E-05_JPRB, 0.30235692E-05_JPRB, &
  & 0.29968969E-05_JPRB, 0.29559835E-05_JPRB, 0.29104001E-05_JPRB, 0.28671566E-05_JPRB, 0.28287795E-05_JPRB, 0.27968133E-05_JPRB, &
  & 0.27676599E-05_JPRB, 0.27321612E-05_JPRB, 0.26832188E-05_JPRB, 0.26106193E-05_JPRB, 0.25108020E-05_JPRB, 0.23788521E-05_JPRB, &
  & 0.22280556E-05_JPRB, 0.20685266E-05_JPRB, 0.19174022E-05_JPRB, 0.17916042E-05_JPRB, 0.17024184E-05_JPRB, 0.16574230E-05_JPRB, &
  & 0.16594009E-05_JPRB, 0.17084405E-05_JPRB, 0.17988207E-05_JPRB, 0.19254810E-05_JPRB, 0.20791535E-05_JPRB, 0.22440242E-05_JPRB, &
  & 0.24100889E-05_JPRB, 0.25638781E-05_JPRB, 0.26998755E-05_JPRB, 0.28118507E-05_JPRB, 0.28998081E-05_JPRB, 0.29663997E-05_JPRB, &
  & 0.30157669E-05_JPRB, 0.30524470E-05_JPRB, 0.30794720E-05_JPRB, 0.30992198E-05_JPRB, 0.31133643E-05_JPRB, 0.31231489E-05_JPRB, &
  & 0.31290710E-05_JPRB, 0.31312352E-05_JPRB, 0.31293639E-05_JPRB, 0.31230525E-05_JPRB, 0.31136983E-05_JPRB, 0.31038503E-05_JPRB, &
  & 0.30958977E-05_JPRB, 0.30922608E-05_JPRB, 0.30956637E-05_JPRB, 0.31165832E-05_JPRB /)

RGHG7(:,30, 8) = (/ &
  & 0.20630673E-05_JPRB, 0.19251836E-05_JPRB, 0.17905486E-05_JPRB, 0.16447261E-05_JPRB, 0.15257735E-05_JPRB, 0.14486557E-05_JPRB, &
  & 0.14181483E-05_JPRB, 0.14468637E-05_JPRB, 0.15436224E-05_JPRB, 0.17012529E-05_JPRB, 0.18928450E-05_JPRB, 0.20919304E-05_JPRB, &
  & 0.22753945E-05_JPRB, 0.24266117E-05_JPRB, 0.25342592E-05_JPRB, 0.25947440E-05_JPRB, 0.26128871E-05_JPRB, 0.25992395E-05_JPRB, &
  & 0.25651163E-05_JPRB, 0.25229017E-05_JPRB, 0.24808003E-05_JPRB, 0.24462581E-05_JPRB, 0.24218507E-05_JPRB, 0.24052481E-05_JPRB, &
  & 0.23915961E-05_JPRB, 0.23714072E-05_JPRB, 0.23343021E-05_JPRB, 0.22713159E-05_JPRB, 0.21762144E-05_JPRB, 0.20501561E-05_JPRB, &
  & 0.18976319E-05_JPRB, 0.17355932E-05_JPRB, 0.15819130E-05_JPRB, 0.14541690E-05_JPRB, 0.13643496E-05_JPRB, 0.13190523E-05_JPRB, &
  & 0.13198438E-05_JPRB, 0.13660883E-05_JPRB, 0.14532540E-05_JPRB, 0.15739753E-05_JPRB, 0.17226970E-05_JPRB, 0.18858939E-05_JPRB, &
  & 0.20507475E-05_JPRB, 0.22074678E-05_JPRB, 0.23456339E-05_JPRB, 0.24619542E-05_JPRB, 0.25554275E-05_JPRB, 0.26278399E-05_JPRB, &
  & 0.26837688E-05_JPRB, 0.27272331E-05_JPRB, 0.27612177E-05_JPRB, 0.27884698E-05_JPRB, 0.28107879E-05_JPRB, 0.28291922E-05_JPRB, &
  & 0.28444429E-05_JPRB, 0.28563747E-05_JPRB, 0.28645195E-05_JPRB, 0.28689026E-05_JPRB, 0.28712836E-05_JPRB, 0.28732607E-05_JPRB, &
  & 0.28767749E-05_JPRB, 0.28840855E-05_JPRB, 0.28980155E-05_JPRB, 0.29265182E-05_JPRB /)

RGHG7(:,31, 8) = (/ &
  & 0.19477411E-05_JPRB, 0.18228268E-05_JPRB, 0.17036567E-05_JPRB, 0.15657511E-05_JPRB, 0.14620150E-05_JPRB, 0.13865804E-05_JPRB, &
  & 0.13540385E-05_JPRB, 0.13731257E-05_JPRB, 0.14510958E-05_JPRB, 0.15809107E-05_JPRB, 0.17382205E-05_JPRB, 0.18985584E-05_JPRB, &
  & 0.20423145E-05_JPRB, 0.21557807E-05_JPRB, 0.22306272E-05_JPRB, 0.22646170E-05_JPRB, 0.22632189E-05_JPRB, 0.22365725E-05_JPRB, &
  & 0.21956164E-05_JPRB, 0.21505402E-05_JPRB, 0.21106662E-05_JPRB, 0.20814932E-05_JPRB, 0.20646592E-05_JPRB, 0.20573332E-05_JPRB, &
  & 0.20526959E-05_JPRB, 0.20412624E-05_JPRB, 0.20131567E-05_JPRB, 0.19589895E-05_JPRB, 0.18716357E-05_JPRB, 0.17516630E-05_JPRB, &
  & 0.16061872E-05_JPRB, 0.14508241E-05_JPRB, 0.13036839E-05_JPRB, 0.11827907E-05_JPRB, 0.10990584E-05_JPRB, 0.10579204E-05_JPRB, &
  & 0.10597757E-05_JPRB, 0.11031054E-05_JPRB, 0.11841149E-05_JPRB, 0.12973635E-05_JPRB, 0.14348403E-05_JPRB, 0.15889170E-05_JPRB, &
  & 0.17470220E-05_JPRB, 0.18972512E-05_JPRB, 0.20331363E-05_JPRB, 0.21489216E-05_JPRB, 0.22431361E-05_JPRB, 0.23179437E-05_JPRB, &
  & 0.23777288E-05_JPRB, 0.24263120E-05_JPRB, 0.24664171E-05_JPRB, 0.25006150E-05_JPRB, 0.25305619E-05_JPRB, 0.25568356E-05_JPRB, &
  & 0.25802603E-05_JPRB, 0.26004700E-05_JPRB, 0.26173470E-05_JPRB, 0.26314053E-05_JPRB, 0.26438950E-05_JPRB, 0.26553355E-05_JPRB, &
  & 0.26669436E-05_JPRB, 0.26803248E-05_JPRB, 0.26974274E-05_JPRB, 0.27339402E-05_JPRB /)

RGHG7(:,32, 8) = (/ &
  & 0.18549823E-05_JPRB, 0.17375651E-05_JPRB, 0.16274864E-05_JPRB, 0.15056008E-05_JPRB, 0.14057862E-05_JPRB, 0.13356572E-05_JPRB, &
  & 0.13014217E-05_JPRB, 0.13130381E-05_JPRB, 0.13767731E-05_JPRB, 0.14838183E-05_JPRB, 0.16113331E-05_JPRB, 0.17382043E-05_JPRB, &
  & 0.18474431E-05_JPRB, 0.19281360E-05_JPRB, 0.19741553E-05_JPRB, 0.19854576E-05_JPRB, 0.19674367E-05_JPRB, 0.19294314E-05_JPRB, &
  & 0.18816517E-05_JPRB, 0.18337313E-05_JPRB, 0.17935515E-05_JPRB, 0.17661924E-05_JPRB, 0.17514975E-05_JPRB, 0.17471496E-05_JPRB, &
  & 0.17453890E-05_JPRB, 0.17373227E-05_JPRB, 0.17128141E-05_JPRB, 0.16642190E-05_JPRB, 0.15851778E-05_JPRB, 0.14755580E-05_JPRB, &
  & 0.13420887E-05_JPRB, 0.11992944E-05_JPRB, 0.10654044E-05_JPRB, 0.95707355E-06_JPRB, 0.88357058E-06_JPRB, 0.84927706E-06_JPRB, &
  & 0.85308278E-06_JPRB, 0.89324436E-06_JPRB, 0.96669169E-06_JPRB, 0.10690343E-05_JPRB, 0.11947484E-05_JPRB, 0.13345802E-05_JPRB, &
  & 0.14798088E-05_JPRB, 0.16216361E-05_JPRB, 0.17494309E-05_JPRB, 0.18614602E-05_JPRB, 0.19544564E-05_JPRB, 0.20311772E-05_JPRB, &
  & 0.20940104E-05_JPRB, 0.21473884E-05_JPRB, 0.21933158E-05_JPRB, 0.22339327E-05_JPRB, 0.22707582E-05_JPRB, 0.23041057E-05_JPRB, &
  & 0.23346631E-05_JPRB, 0.23622019E-05_JPRB, 0.23866812E-05_JPRB, 0.24084288E-05_JPRB, 0.24278906E-05_JPRB, 0.24454903E-05_JPRB, &
  & 0.24622555E-05_JPRB, 0.24798303E-05_JPRB, 0.25019149E-05_JPRB, 0.25447969E-05_JPRB /)

RGHG7(:,33, 8) = (/ &
  & 0.17700874E-05_JPRB, 0.16632874E-05_JPRB, 0.15625594E-05_JPRB, 0.14480937E-05_JPRB, 0.13584652E-05_JPRB, 0.12924585E-05_JPRB, &
  & 0.12600119E-05_JPRB, 0.12686470E-05_JPRB, 0.13215920E-05_JPRB, 0.14073735E-05_JPRB, 0.15075558E-05_JPRB, 0.16038782E-05_JPRB, &
  & 0.16824572E-05_JPRB, 0.17344704E-05_JPRB, 0.17561550E-05_JPRB, 0.17486867E-05_JPRB, 0.17170897E-05_JPRB, 0.16698281E-05_JPRB, &
  & 0.16160870E-05_JPRB, 0.15647324E-05_JPRB, 0.15221779E-05_JPRB, 0.14915975E-05_JPRB, 0.14752754E-05_JPRB, 0.14685372E-05_JPRB, &
  & 0.14644232E-05_JPRB, 0.14552232E-05_JPRB, 0.14315164E-05_JPRB, 0.13866741E-05_JPRB, 0.13152087E-05_JPRB, 0.12166113E-05_JPRB, &
  & 0.10977346E-05_JPRB, 0.97209477E-06_JPRB, 0.85574567E-06_JPRB, 0.76366393E-06_JPRB, 0.70296181E-06_JPRB, 0.67677968E-06_JPRB, &
  & 0.68290063E-06_JPRB, 0.71993850E-06_JPRB, 0.78494014E-06_JPRB, 0.87526820E-06_JPRB, 0.98629687E-06_JPRB, 0.11117033E-05_JPRB, &
  & 0.12417555E-05_JPRB, 0.13694307E-05_JPRB, 0.14906450E-05_JPRB, 0.15956110E-05_JPRB, 0.16877282E-05_JPRB, 0.17651988E-05_JPRB, &
  & 0.18313261E-05_JPRB, 0.18888151E-05_JPRB, 0.19404752E-05_JPRB, 0.19874844E-05_JPRB, 0.20305201E-05_JPRB, 0.20703437E-05_JPRB, &
  & 0.21071637E-05_JPRB, 0.21405708E-05_JPRB, 0.21708281E-05_JPRB, 0.21982528E-05_JPRB, 0.22229556E-05_JPRB, 0.22454185E-05_JPRB, &
  & 0.22665063E-05_JPRB, 0.22878698E-05_JPRB, 0.23128594E-05_JPRB, 0.23581329E-05_JPRB /)

RGHG7(:,34, 8) = (/ &
  & 0.16902088E-05_JPRB, 0.15915501E-05_JPRB, 0.14999707E-05_JPRB, 0.13975281E-05_JPRB, 0.13145027E-05_JPRB, 0.12553743E-05_JPRB, &
  & 0.12256946E-05_JPRB, 0.12321342E-05_JPRB, 0.12757750E-05_JPRB, 0.13438425E-05_JPRB, 0.14195401E-05_JPRB, 0.14886512E-05_JPRB, &
  & 0.15401249E-05_JPRB, 0.15677454E-05_JPRB, 0.15691526E-05_JPRB, 0.15464279E-05_JPRB, 0.15042897E-05_JPRB, 0.14495587E-05_JPRB, &
  & 0.13904237E-05_JPRB, 0.13340936E-05_JPRB, 0.12862962E-05_JPRB, 0.12523168E-05_JPRB, 0.12296695E-05_JPRB, 0.12163329E-05_JPRB, &
  & 0.12054999E-05_JPRB, 0.11912737E-05_JPRB, 0.11655259E-05_JPRB, 0.11222662E-05_JPRB, 0.10579620E-05_JPRB, 0.97179804E-06_JPRB, &
  & 0.87000393E-06_JPRB, 0.76408941E-06_JPRB, 0.66832979E-06_JPRB, 0.59464975E-06_JPRB, 0.54798664E-06_JPRB, 0.53036473E-06_JPRB, &
  & 0.53881888E-06_JPRB, 0.57282182E-06_JPRB, 0.62940586E-06_JPRB, 0.70710234E-06_JPRB, 0.80326799E-06_JPRB, 0.91249615E-06_JPRB, &
  & 0.10275630E-05_JPRB, 0.11405925E-05_JPRB, 0.12509101E-05_JPRB, 0.13524271E-05_JPRB, 0.14410197E-05_JPRB, 0.15198019E-05_JPRB, &
  & 0.15895915E-05_JPRB, 0.16515036E-05_JPRB, 0.17080895E-05_JPRB, 0.17611108E-05_JPRB, 0.18098284E-05_JPRB, 0.18550744E-05_JPRB, &
  & 0.18968524E-05_JPRB, 0.19350828E-05_JPRB, 0.19698275E-05_JPRB, 0.20015134E-05_JPRB, 0.20301975E-05_JPRB, 0.20561943E-05_JPRB, &
  & 0.20801979E-05_JPRB, 0.21033636E-05_JPRB, 0.21293311E-05_JPRB, 0.21778424E-05_JPRB /)

RGHG7(:,35, 8) = (/ &
  & 0.16115557E-05_JPRB, 0.15237316E-05_JPRB, 0.14393792E-05_JPRB, 0.13460186E-05_JPRB, 0.12724234E-05_JPRB, 0.12201447E-05_JPRB, &
  & 0.11949566E-05_JPRB, 0.12015022E-05_JPRB, 0.12369214E-05_JPRB, 0.12880373E-05_JPRB, 0.13414510E-05_JPRB, 0.13861384E-05_JPRB, &
  & 0.14143149E-05_JPRB, 0.14217648E-05_JPRB, 0.14071371E-05_JPRB, 0.13726784E-05_JPRB, 0.13225689E-05_JPRB, 0.12623249E-05_JPRB, &
  & 0.11990080E-05_JPRB, 0.11377927E-05_JPRB, 0.10851445E-05_JPRB, 0.10427285E-05_JPRB, 0.10103095E-05_JPRB, 0.98670228E-06_JPRB, &
  & 0.96659801E-06_JPRB, 0.94451417E-06_JPRB, 0.91512436E-06_JPRB, 0.87317005E-06_JPRB, 0.81569885E-06_JPRB, 0.74281377E-06_JPRB, &
  & 0.65950667E-06_JPRB, 0.57554837E-06_JPRB, 0.50171371E-06_JPRB, 0.44695969E-06_JPRB, 0.41435905E-06_JPRB, 0.40464067E-06_JPRB, &
  & 0.41527900E-06_JPRB, 0.44607998E-06_JPRB, 0.49413649E-06_JPRB, 0.56021884E-06_JPRB, 0.64168438E-06_JPRB, 0.73523267E-06_JPRB, &
  & 0.83477585E-06_JPRB, 0.93384051E-06_JPRB, 0.10338656E-05_JPRB, 0.11307175E-05_JPRB, 0.12170142E-05_JPRB, 0.12962565E-05_JPRB, &
  & 0.13693109E-05_JPRB, 0.14353199E-05_JPRB, 0.14964141E-05_JPRB, 0.15548319E-05_JPRB, 0.16084329E-05_JPRB, 0.16579914E-05_JPRB, &
  & 0.17038178E-05_JPRB, 0.17453924E-05_JPRB, 0.17833062E-05_JPRB, 0.18179381E-05_JPRB, 0.18493140E-05_JPRB, 0.18776702E-05_JPRB, &
  & 0.19034275E-05_JPRB, 0.19279180E-05_JPRB, 0.19556314E-05_JPRB, 0.20043667E-05_JPRB /)

RGHG7(:,36, 8) = (/ &
  & 0.15354980E-05_JPRB, 0.14534312E-05_JPRB, 0.13782956E-05_JPRB, 0.12947744E-05_JPRB, 0.12291780E-05_JPRB, 0.11840583E-05_JPRB, &
  & 0.11630036E-05_JPRB, 0.11679773E-05_JPRB, 0.11937957E-05_JPRB, 0.12297085E-05_JPRB, 0.12643958E-05_JPRB, 0.12895468E-05_JPRB, &
  & 0.12993694E-05_JPRB, 0.12912964E-05_JPRB, 0.12649219E-05_JPRB, 0.12221541E-05_JPRB, 0.11667232E-05_JPRB, 0.11029127E-05_JPRB, &
  & 0.10354403E-05_JPRB, 0.97031318E-06_JPRB, 0.91017517E-06_JPRB, 0.85820949E-06_JPRB, 0.81522194E-06_JPRB, 0.77991763E-06_JPRB, &
  & 0.74977356E-06_JPRB, 0.72006350E-06_JPRB, 0.68689860E-06_JPRB, 0.64657473E-06_JPRB, 0.59699056E-06_JPRB, 0.53820150E-06_JPRB, &
  & 0.47441466E-06_JPRB, 0.41235492E-06_JPRB, 0.35989723E-06_JPRB, 0.32263307E-06_JPRB, 0.30226920E-06_JPRB, 0.29864663E-06_JPRB, &
  & 0.31035131E-06_JPRB, 0.33682082E-06_JPRB, 0.37695560E-06_JPRB, 0.43166469E-06_JPRB, 0.49960033E-06_JPRB, 0.57826946E-06_JPRB, &
  & 0.66257712E-06_JPRB, 0.75080027E-06_JPRB, 0.84187832E-06_JPRB, 0.93192705E-06_JPRB, 0.10162632E-05_JPRB, 0.10960932E-05_JPRB, &
  & 0.11716974E-05_JPRB, 0.12411995E-05_JPRB, 0.13064408E-05_JPRB, 0.13687840E-05_JPRB, 0.14262507E-05_JPRB, 0.14791008E-05_JPRB, &
  & 0.15274022E-05_JPRB, 0.15712036E-05_JPRB, 0.16111695E-05_JPRB, 0.16475279E-05_JPRB, 0.16805340E-05_JPRB, 0.17101742E-05_JPRB, &
  & 0.17369406E-05_JPRB, 0.17620924E-05_JPRB, 0.17898872E-05_JPRB, 0.18392378E-05_JPRB /)

RGHG7(:,37, 8) = (/ &
  & 0.14562904E-05_JPRB, 0.13831722E-05_JPRB, 0.13158356E-05_JPRB, 0.12411394E-05_JPRB, 0.11836001E-05_JPRB, 0.11447760E-05_JPRB, &
  & 0.11271253E-05_JPRB, 0.11300650E-05_JPRB, 0.11467400E-05_JPRB, 0.11687307E-05_JPRB, 0.11875801E-05_JPRB, 0.11969441E-05_JPRB, &
  & 0.11926840E-05_JPRB, 0.11732792E-05_JPRB, 0.11387998E-05_JPRB, 0.10910647E-05_JPRB, 0.10323870E-05_JPRB, 0.96707481E-06_JPRB, &
  & 0.89724114E-06_JPRB, 0.82686540E-06_JPRB, 0.76028755E-06_JPRB, 0.69969639E-06_JPRB, 0.64752754E-06_JPRB, 0.60389112E-06_JPRB, &
  & 0.56656461E-06_JPRB, 0.53298709E-06_JPRB, 0.49931805E-06_JPRB, 0.46273013E-06_JPRB, 0.42178644E-06_JPRB, 0.37682344E-06_JPRB, &
  & 0.33061755E-06_JPRB, 0.28766721E-06_JPRB, 0.25279687E-06_JPRB, 0.22914658E-06_JPRB, 0.21745555E-06_JPRB, 0.21727091E-06_JPRB, &
  & 0.22789266E-06_JPRB, 0.24889155E-06_JPRB, 0.28050573E-06_JPRB, 0.32353785E-06_JPRB, 0.37831052E-06_JPRB, 0.44222338E-06_JPRB, &
  & 0.51404874E-06_JPRB, 0.59237516E-06_JPRB, 0.67393108E-06_JPRB, 0.75705208E-06_JPRB, 0.83919002E-06_JPRB, 0.91926341E-06_JPRB, &
  & 0.99585020E-06_JPRB, 0.10682119E-05_JPRB, 0.11370138E-05_JPRB, 0.12021649E-05_JPRB, 0.12621354E-05_JPRB, 0.13168478E-05_JPRB, &
  & 0.13666261E-05_JPRB, 0.14114598E-05_JPRB, 0.14522185E-05_JPRB, 0.14893502E-05_JPRB, 0.15230769E-05_JPRB, 0.15532913E-05_JPRB, &
  & 0.15803060E-05_JPRB, 0.16055251E-05_JPRB, 0.16332251E-05_JPRB, 0.16820014E-05_JPRB /)

RGHG7(:,38, 8) = (/ &
  & 0.13755329E-05_JPRB, 0.13103356E-05_JPRB, 0.12514007E-05_JPRB, 0.11862343E-05_JPRB, 0.11358894E-05_JPRB, 0.11030988E-05_JPRB, &
  & 0.10880250E-05_JPRB, 0.10874970E-05_JPRB, 0.10953065E-05_JPRB, 0.11050312E-05_JPRB, 0.11106151E-05_JPRB, 0.11074795E-05_JPRB, &
  & 0.10928674E-05_JPRB, 0.10657856E-05_JPRB, 0.10264788E-05_JPRB, 0.97625866E-06_JPRB, 0.91694596E-06_JPRB, 0.85056701E-06_JPRB, &
  & 0.78023481E-06_JPRB, 0.70793050E-06_JPRB, 0.63698940E-06_JPRB, 0.57220041E-06_JPRB, 0.51629667E-06_JPRB, 0.47014112E-06_JPRB, &
  & 0.43259354E-06_JPRB, 0.39982919E-06_JPRB, 0.36901446E-06_JPRB, 0.33774270E-06_JPRB, 0.30485523E-06_JPRB, 0.27083959E-06_JPRB, &
  & 0.23749355E-06_JPRB, 0.20771321E-06_JPRB, 0.18452135E-06_JPRB, 0.16948135E-06_JPRB, 0.16280238E-06_JPRB, 0.16389392E-06_JPRB, &
  & 0.17236708E-06_JPRB, 0.18794474E-06_JPRB, 0.21118699E-06_JPRB, 0.24321281E-06_JPRB, 0.28456034E-06_JPRB, 0.33419127E-06_JPRB, &
  & 0.39383639E-06_JPRB, 0.45994844E-06_JPRB, 0.53187728E-06_JPRB, 0.60820844E-06_JPRB, 0.68680242E-06_JPRB, 0.76534968E-06_JPRB, &
  & 0.84223126E-06_JPRB, 0.91621763E-06_JPRB, 0.98711007E-06_JPRB, 0.10537394E-05_JPRB, 0.11148792E-05_JPRB, 0.11703587E-05_JPRB, &
  & 0.12202750E-05_JPRB, 0.12650484E-05_JPRB, 0.13057606E-05_JPRB, 0.13428644E-05_JPRB, 0.13764627E-05_JPRB, 0.14063949E-05_JPRB, &
  & 0.14330228E-05_JPRB, 0.14577703E-05_JPRB, 0.14848937E-05_JPRB, 0.15325459E-05_JPRB /)

RGHG7(:,39, 8) = (/ &
  & 0.12931773E-05_JPRB, 0.12361530E-05_JPRB, 0.11858392E-05_JPRB, 0.11285931E-05_JPRB, 0.10854613E-05_JPRB, 0.10573793E-05_JPRB, &
  & 0.10434553E-05_JPRB, 0.10391003E-05_JPRB, 0.10388158E-05_JPRB, 0.10383840E-05_JPRB, 0.10335352E-05_JPRB, 0.10210899E-05_JPRB, &
  & 0.99934084E-06_JPRB, 0.96770714E-06_JPRB, 0.92634167E-06_JPRB, 0.87603746E-06_JPRB, 0.81795253E-06_JPRB, 0.75323817E-06_JPRB, &
  & 0.68365438E-06_JPRB, 0.61162109E-06_JPRB, 0.54136279E-06_JPRB, 0.47706834E-06_JPRB, 0.42313454E-06_JPRB, 0.38000513E-06_JPRB, &
  & 0.34525226E-06_JPRB, 0.31588783E-06_JPRB, 0.28875564E-06_JPRB, 0.26207599E-06_JPRB, 0.23520852E-06_JPRB, 0.20849075E-06_JPRB, &
  & 0.18318111E-06_JPRB, 0.16139253E-06_JPRB, 0.14498134E-06_JPRB, 0.13486898E-06_JPRB, 0.13085435E-06_JPRB, 0.13243067E-06_JPRB, &
  & 0.13912683E-06_JPRB, 0.15085261E-06_JPRB, 0.16784021E-06_JPRB, 0.19125933E-06_JPRB, 0.22124915E-06_JPRB, 0.25845802E-06_JPRB, &
  & 0.30472438E-06_JPRB, 0.35740103E-06_JPRB, 0.41830111E-06_JPRB, 0.48577328E-06_JPRB, 0.55832777E-06_JPRB, 0.63380656E-06_JPRB, &
  & 0.70940968E-06_JPRB, 0.78382885E-06_JPRB, 0.85536868E-06_JPRB, 0.92224678E-06_JPRB, 0.98333373E-06_JPRB, 0.10382837E-05_JPRB, &
  & 0.10873086E-05_JPRB, 0.11312092E-05_JPRB, 0.11710245E-05_JPRB, 0.12073352E-05_JPRB, 0.12401446E-05_JPRB, 0.12692410E-05_JPRB, &
  & 0.12949599E-05_JPRB, 0.13188045E-05_JPRB, 0.13448475E-05_JPRB, 0.13906445E-05_JPRB /)

RGHG7(:,40, 8) = (/ &
  & 0.12091548E-05_JPRB, 0.11605929E-05_JPRB, 0.11178993E-05_JPRB, 0.10703659E-05_JPRB, 0.10332359E-05_JPRB, 0.10090523E-05_JPRB, &
  & 0.99490330E-06_JPRB, 0.98609667E-06_JPRB, 0.97856855E-06_JPRB, 0.96977578E-06_JPRB, 0.95695384E-06_JPRB, 0.93799474E-06_JPRB, &
  & 0.91183358E-06_JPRB, 0.87813436E-06_JPRB, 0.83687070E-06_JPRB, 0.78838764E-06_JPRB, 0.73306313E-06_JPRB, 0.67177950E-06_JPRB, &
  & 0.60525781E-06_JPRB, 0.53660972E-06_JPRB, 0.46933923E-06_JPRB, 0.40955766E-06_JPRB, 0.35996726E-06_JPRB, 0.32078916E-06_JPRB, &
  & 0.28961517E-06_JPRB, 0.26321172E-06_JPRB, 0.23918764E-06_JPRB, 0.21607364E-06_JPRB, 0.19333029E-06_JPRB, 0.17134376E-06_JPRB, &
  & 0.15102763E-06_JPRB, 0.13395147E-06_JPRB, 0.12152584E-06_JPRB, 0.11421230E-06_JPRB, 0.11171142E-06_JPRB, 0.11348144E-06_JPRB, &
  & 0.11909924E-06_JPRB, 0.12841132E-06_JPRB, 0.14150216E-06_JPRB, 0.15921138E-06_JPRB, 0.18138205E-06_JPRB, 0.20906256E-06_JPRB, &
  & 0.24379781E-06_JPRB, 0.28391079E-06_JPRB, 0.33269848E-06_JPRB, 0.38941974E-06_JPRB, 0.45380699E-06_JPRB, 0.52401492E-06_JPRB, &
  & 0.59687488E-06_JPRB, 0.67001650E-06_JPRB, 0.74064496E-06_JPRB, 0.80655718E-06_JPRB, 0.86640563E-06_JPRB, 0.91979683E-06_JPRB, &
  & 0.96708413E-06_JPRB, 0.10093455E-05_JPRB, 0.10476095E-05_JPRB, 0.10826061E-05_JPRB, 0.11140340E-05_JPRB, 0.11417690E-05_JPRB, &
  & 0.11661402E-05_JPRB, 0.11887648E-05_JPRB, 0.12134152E-05_JPRB, 0.12568794E-05_JPRB /)

RGHG7(:,41, 8) = (/ &
  & 0.11230628E-05_JPRB, 0.10818022E-05_JPRB, 0.10484027E-05_JPRB, 0.10086507E-05_JPRB, 0.97763211E-06_JPRB, 0.95572727E-06_JPRB, &
  & 0.94000870E-06_JPRB, 0.92718005E-06_JPRB, 0.91388392E-06_JPRB, 0.89905052E-06_JPRB, 0.88090025E-06_JPRB, 0.85798143E-06_JPRB, &
  & 0.82973514E-06_JPRB, 0.79591007E-06_JPRB, 0.75640190E-06_JPRB, 0.71107274E-06_JPRB, 0.66001508E-06_JPRB, 0.60306178E-06_JPRB, &
  & 0.54162308E-06_JPRB, 0.47729736E-06_JPRB, 0.41544894E-06_JPRB, 0.36036610E-06_JPRB, 0.31555797E-06_JPRB, 0.28027503E-06_JPRB, &
  & 0.25205341E-06_JPRB, 0.22811535E-06_JPRB, 0.20642550E-06_JPRB, 0.18586296E-06_JPRB, 0.16611283E-06_JPRB, 0.14729562E-06_JPRB, &
  & 0.13023777E-06_JPRB, 0.11617269E-06_JPRB, 0.10617568E-06_JPRB, 0.10059424E-06_JPRB, 0.98987982E-07_JPRB, 0.10085851E-06_JPRB, &
  & 0.10577315E-06_JPRB, 0.11359662E-06_JPRB, 0.12426048E-06_JPRB, 0.13831306E-06_JPRB, 0.15550665E-06_JPRB, 0.17657170E-06_JPRB, &
  & 0.20275468E-06_JPRB, 0.23288405E-06_JPRB, 0.27069783E-06_JPRB, 0.31631998E-06_JPRB, 0.37105241E-06_JPRB, 0.43441548E-06_JPRB, &
  & 0.50229647E-06_JPRB, 0.57272274E-06_JPRB, 0.64117120E-06_JPRB, 0.70516586E-06_JPRB, 0.76294208E-06_JPRB, 0.81397195E-06_JPRB, &
  & 0.85892026E-06_JPRB, 0.89884799E-06_JPRB, 0.93505889E-06_JPRB, 0.96809697E-06_JPRB, 0.99775605E-06_JPRB, 0.10237628E-05_JPRB, &
  & 0.10465565E-05_JPRB, 0.10677215E-05_JPRB, 0.10909068E-05_JPRB, 0.11316703E-05_JPRB /)

RGHG7(:,42, 8) = (/ &
  & 0.10284842E-05_JPRB, 0.99833460E-06_JPRB, 0.97300517E-06_JPRB, 0.94238601E-06_JPRB, 0.91559104E-06_JPRB, 0.89415033E-06_JPRB, &
  & 0.87701733E-06_JPRB, 0.86097413E-06_JPRB, 0.84408811E-06_JPRB, 0.82574843E-06_JPRB, 0.80477878E-06_JPRB, 0.78022640E-06_JPRB, &
  & 0.75181123E-06_JPRB, 0.71938433E-06_JPRB, 0.68274818E-06_JPRB, 0.64160673E-06_JPRB, 0.59544925E-06_JPRB, 0.54424549E-06_JPRB, &
  & 0.48793260E-06_JPRB, 0.42944654E-06_JPRB, 0.37253653E-06_JPRB, 0.32271782E-06_JPRB, 0.28210439E-06_JPRB, 0.25010655E-06_JPRB, &
  & 0.22438667E-06_JPRB, 0.20250248E-06_JPRB, 0.18277913E-06_JPRB, 0.16432492E-06_JPRB, 0.14676851E-06_JPRB, 0.13029592E-06_JPRB, &
  & 0.11549342E-06_JPRB, 0.10343439E-06_JPRB, 0.95084452E-07_JPRB, 0.90607649E-07_JPRB, 0.89571841E-07_JPRB, 0.91461544E-07_JPRB, &
  & 0.95899445E-07_JPRB, 0.10271678E-06_JPRB, 0.11176776E-06_JPRB, 0.12348444E-06_JPRB, 0.13741314E-06_JPRB, 0.15394222E-06_JPRB, &
  & 0.17424247E-06_JPRB, 0.19710316E-06_JPRB, 0.22590865E-06_JPRB, 0.26171932E-06_JPRB, 0.30672408E-06_JPRB, 0.36153509E-06_JPRB, &
  & 0.42359875E-06_JPRB, 0.48999993E-06_JPRB, 0.55529324E-06_JPRB, 0.61655385E-06_JPRB, 0.67155935E-06_JPRB, 0.71973778E-06_JPRB, &
  & 0.76168715E-06_JPRB, 0.79880425E-06_JPRB, 0.83237018E-06_JPRB, 0.86308182E-06_JPRB, 0.89059097E-06_JPRB, 0.91467177E-06_JPRB, &
  & 0.93575630E-06_JPRB, 0.95545590E-06_JPRB, 0.97710108E-06_JPRB, 0.10152777E-05_JPRB /)

RGHG7(:,43, 8) = (/ &
  & 0.94079860E-06_JPRB, 0.91417530E-06_JPRB, 0.89431313E-06_JPRB, 0.86970465E-06_JPRB, 0.84575896E-06_JPRB, 0.82470359E-06_JPRB, &
  & 0.80594020E-06_JPRB, 0.78814617E-06_JPRB, 0.76938500E-06_JPRB, 0.74968153E-06_JPRB, 0.72799531E-06_JPRB, 0.70368111E-06_JPRB, &
  & 0.67660358E-06_JPRB, 0.64669877E-06_JPRB, 0.61379029E-06_JPRB, 0.57737520E-06_JPRB, 0.53689160E-06_JPRB, 0.49144336E-06_JPRB, &
  & 0.44151764E-06_JPRB, 0.38845383E-06_JPRB, 0.33713235E-06_JPRB, 0.29199231E-06_JPRB, 0.25541263E-06_JPRB, 0.22639944E-06_JPRB, &
  & 0.20282133E-06_JPRB, 0.18267751E-06_JPRB, 0.16460645E-06_JPRB, 0.14786866E-06_JPRB, 0.13211040E-06_JPRB, 0.11737181E-06_JPRB, &
  & 0.10423017E-06_JPRB, 0.93618205E-07_JPRB, 0.86390706E-07_JPRB, 0.82674688E-07_JPRB, 0.81994479E-07_JPRB, 0.83854090E-07_JPRB, &
  & 0.87917073E-07_JPRB, 0.94017288E-07_JPRB, 0.10198408E-06_JPRB, 0.11201352E-06_JPRB, 0.12381614E-06_JPRB, 0.13719405E-06_JPRB, &
  & 0.15326938E-06_JPRB, 0.17099939E-06_JPRB, 0.19282170E-06_JPRB, 0.22061397E-06_JPRB, 0.25635103E-06_JPRB, 0.30279526E-06_JPRB, &
  & 0.35796202E-06_JPRB, 0.41931068E-06_JPRB, 0.48069637E-06_JPRB, 0.53888721E-06_JPRB, 0.59073875E-06_JPRB, 0.63547230E-06_JPRB, &
  & 0.67401970E-06_JPRB, 0.70777492E-06_JPRB, 0.73828215E-06_JPRB, 0.76625975E-06_JPRB, 0.79144934E-06_JPRB, 0.81351385E-06_JPRB, &
  & 0.83292190E-06_JPRB, 0.85118535E-06_JPRB, 0.87142257E-06_JPRB, 0.90722421E-06_JPRB /)

RGHG7(:,44, 8) = (/ &
  & 0.85796574E-06_JPRB, 0.82744691E-06_JPRB, 0.80954567E-06_JPRB, 0.78930168E-06_JPRB, 0.76787143E-06_JPRB, 0.74675398E-06_JPRB, &
  & 0.72755279E-06_JPRB, 0.70909886E-06_JPRB, 0.69011776E-06_JPRB, 0.67070414E-06_JPRB, 0.64995248E-06_JPRB, 0.62727929E-06_JPRB, &
  & 0.60269292E-06_JPRB, 0.57619906E-06_JPRB, 0.54750427E-06_JPRB, 0.51628848E-06_JPRB, 0.48154754E-06_JPRB, 0.44271434E-06_JPRB, &
  & 0.39882630E-06_JPRB, 0.35207512E-06_JPRB, 0.30607984E-06_JPRB, 0.26583012E-06_JPRB, 0.23300609E-06_JPRB, 0.20670542E-06_JPRB, &
  & 0.18514424E-06_JPRB, 0.16663550E-06_JPRB, 0.15006133E-06_JPRB, 0.13479908E-06_JPRB, 0.12047231E-06_JPRB, 0.10711561E-06_JPRB, &
  & 0.95215832E-07_JPRB, 0.85665697E-07_JPRB, 0.79257141E-07_JPRB, 0.76048174E-07_JPRB, 0.75580360E-07_JPRB, 0.77370352E-07_JPRB, &
  & 0.81131653E-07_JPRB, 0.86684160E-07_JPRB, 0.93852769E-07_JPRB, 0.10270675E-06_JPRB, 0.11295063E-06_JPRB, 0.12410811E-06_JPRB, &
  & 0.13713397E-06_JPRB, 0.15110676E-06_JPRB, 0.16764363E-06_JPRB, 0.18890579E-06_JPRB, 0.21664985E-06_JPRB, 0.25459923E-06_JPRB, &
  & 0.30233284E-06_JPRB, 0.35797885E-06_JPRB, 0.41531388E-06_JPRB, 0.46998437E-06_JPRB, 0.51820570E-06_JPRB, 0.55926125E-06_JPRB, &
  & 0.59388879E-06_JPRB, 0.62391325E-06_JPRB, 0.65095253E-06_JPRB, 0.67599530E-06_JPRB, 0.69876836E-06_JPRB, 0.71887206E-06_JPRB, &
  & 0.73669003E-06_JPRB, 0.75361027E-06_JPRB, 0.77257232E-06_JPRB, 0.80627916E-06_JPRB /)

RGHG7(:,45, 8) = (/ &
  & 0.74753194E-06_JPRB, 0.72760213E-06_JPRB, 0.71528206E-06_JPRB, 0.70010708E-06_JPRB, 0.68113064E-06_JPRB, 0.66125511E-06_JPRB, &
  & 0.64253703E-06_JPRB, 0.62462271E-06_JPRB, 0.60679702E-06_JPRB, 0.58891175E-06_JPRB, 0.57024823E-06_JPRB, 0.55031637E-06_JPRB, &
  & 0.52911003E-06_JPRB, 0.50658321E-06_JPRB, 0.48266884E-06_JPRB, 0.45667775E-06_JPRB, 0.42811402E-06_JPRB, 0.39540666E-06_JPRB, &
  & 0.35864483E-06_JPRB, 0.31806846E-06_JPRB, 0.27830981E-06_JPRB, 0.24300653E-06_JPRB, 0.21393589E-06_JPRB, 0.19024424E-06_JPRB, &
  & 0.17049139E-06_JPRB, 0.15346207E-06_JPRB, 0.13822138E-06_JPRB, 0.12420431E-06_JPRB, 0.11106700E-06_JPRB, 0.98781598E-07_JPRB, &
  & 0.87844683E-07_JPRB, 0.79092096E-07_JPRB, 0.73257873E-07_JPRB, 0.70383784E-07_JPRB, 0.70020903E-07_JPRB, 0.71708790E-07_JPRB, &
  & 0.75208966E-07_JPRB, 0.80335461E-07_JPRB, 0.86931465E-07_JPRB, 0.94861669E-07_JPRB, 0.10397209E-06_JPRB, 0.11357998E-06_JPRB, &
  & 0.12416673E-06_JPRB, 0.13553881E-06_JPRB, 0.14802617E-06_JPRB, 0.16417154E-06_JPRB, 0.18518163E-06_JPRB, 0.21503170E-06_JPRB, &
  & 0.25511847E-06_JPRB, 0.30411013E-06_JPRB, 0.35687077E-06_JPRB, 0.40753076E-06_JPRB, 0.45190205E-06_JPRB, 0.48875353E-06_JPRB, &
  & 0.51905852E-06_JPRB, 0.54504164E-06_JPRB, 0.56845749E-06_JPRB, 0.59044220E-06_JPRB, 0.61086467E-06_JPRB, 0.62912585E-06_JPRB, &
  & 0.64550272E-06_JPRB, 0.66120350E-06_JPRB, 0.67894791E-06_JPRB, 0.71074896E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART16',0,ZHOOK_HANDLE)



RGHG7(:,46, 8) = (/ &
  & 0.66370768E-06_JPRB, 0.63775559E-06_JPRB, 0.62242106E-06_JPRB, 0.60643322E-06_JPRB, 0.58824662E-06_JPRB, 0.56914558E-06_JPRB, &
  & 0.55147069E-06_JPRB, 0.53540367E-06_JPRB, 0.51951986E-06_JPRB, 0.50424194E-06_JPRB, 0.48859920E-06_JPRB, 0.47220098E-06_JPRB, &
  & 0.45500187E-06_JPRB, 0.43707240E-06_JPRB, 0.41804176E-06_JPRB, 0.39770384E-06_JPRB, 0.37489761E-06_JPRB, 0.34914112E-06_JPRB, &
  & 0.31887774E-06_JPRB, 0.28597591E-06_JPRB, 0.25263606E-06_JPRB, 0.22277591E-06_JPRB, 0.19744454E-06_JPRB, 0.17621937E-06_JPRB, &
  & 0.15823201E-06_JPRB, 0.14257760E-06_JPRB, 0.12852323E-06_JPRB, 0.11557216E-06_JPRB, 0.10338705E-06_JPRB, 0.91964800E-07_JPRB, &
  & 0.81764391E-07_JPRB, 0.73603985E-07_JPRB, 0.68171239E-07_JPRB, 0.65497048E-07_JPRB, 0.65148136E-07_JPRB, 0.66724972E-07_JPRB, &
  & 0.69990463E-07_JPRB, 0.74778406E-07_JPRB, 0.80911128E-07_JPRB, 0.88161620E-07_JPRB, 0.96388369E-07_JPRB, 0.10483507E-06_JPRB, &
  & 0.11370982E-06_JPRB, 0.12298842E-06_JPRB, 0.13271313E-06_JPRB, 0.14479699E-06_JPRB, 0.16051277E-06_JPRB, 0.18315238E-06_JPRB, &
  & 0.21497848E-06_JPRB, 0.25651869E-06_JPRB, 0.30347800E-06_JPRB, 0.34947254E-06_JPRB, 0.38943753E-06_JPRB, 0.42160917E-06_JPRB, &
  & 0.44751943E-06_JPRB, 0.46934863E-06_JPRB, 0.48921657E-06_JPRB, 0.50826236E-06_JPRB, 0.52642116E-06_JPRB, 0.54305190E-06_JPRB, &
  & 0.55811228E-06_JPRB, 0.57266720E-06_JPRB, 0.58924326E-06_JPRB, 0.61916865E-06_JPRB /)

RGHG7(:,47, 8) = (/ &
  & 0.57125192E-06_JPRB, 0.54108477E-06_JPRB, 0.52478612E-06_JPRB, 0.50839850E-06_JPRB, 0.48965012E-06_JPRB, 0.47099599E-06_JPRB, &
  & 0.45527790E-06_JPRB, 0.44133242E-06_JPRB, 0.42854299E-06_JPRB, 0.41657756E-06_JPRB, 0.40474518E-06_JPRB, 0.39258063E-06_JPRB, &
  & 0.38002159E-06_JPRB, 0.36694027E-06_JPRB, 0.35325064E-06_JPRB, 0.33830514E-06_JPRB, 0.32172164E-06_JPRB, 0.30225632E-06_JPRB, &
  & 0.27999283E-06_JPRB, 0.25476638E-06_JPRB, 0.22909134E-06_JPRB, 0.20482196E-06_JPRB, 0.18323983E-06_JPRB, 0.16440609E-06_JPRB, &
  & 0.14802545E-06_JPRB, 0.13360527E-06_JPRB, 0.12059806E-06_JPRB, 0.10852271E-06_JPRB, 0.97125906E-07_JPRB, 0.86368296E-07_JPRB, &
  & 0.76741117E-07_JPRB, 0.69018732E-07_JPRB, 0.63849924E-07_JPRB, 0.61266228E-07_JPRB, 0.60876481E-07_JPRB, 0.62326642E-07_JPRB, &
  & 0.65370116E-07_JPRB, 0.69883036E-07_JPRB, 0.75641523E-07_JPRB, 0.82384247E-07_JPRB, 0.89855625E-07_JPRB, 0.97509272E-07_JPRB, &
  & 0.10505960E-06_JPRB, 0.11284103E-06_JPRB, 0.12061221E-06_JPRB, 0.12966767E-06_JPRB, 0.14143086E-06_JPRB, 0.15783129E-06_JPRB, &
  & 0.18197524E-06_JPRB, 0.21442236E-06_JPRB, 0.25406018E-06_JPRB, 0.29382002E-06_JPRB, 0.32861729E-06_JPRB, 0.35612132E-06_JPRB, &
  & 0.37753910E-06_JPRB, 0.39564216E-06_JPRB, 0.41221463E-06_JPRB, 0.42858721E-06_JPRB, 0.44478045E-06_JPRB, 0.45992255E-06_JPRB, &
  & 0.47383136E-06_JPRB, 0.48732460E-06_JPRB, 0.50276412E-06_JPRB, 0.53081766E-06_JPRB /)

RGHG7(:,48, 8) = (/ &
  & 0.47655729E-06_JPRB, 0.44948513E-06_JPRB, 0.43114241E-06_JPRB, 0.41218937E-06_JPRB, 0.39121042E-06_JPRB, 0.37207425E-06_JPRB, &
  & 0.35695572E-06_JPRB, 0.34546213E-06_JPRB, 0.33561292E-06_JPRB, 0.32724299E-06_JPRB, 0.31954539E-06_JPRB, 0.31193284E-06_JPRB, &
  & 0.30423789E-06_JPRB, 0.29628953E-06_JPRB, 0.28782259E-06_JPRB, 0.27860102E-06_JPRB, 0.26809641E-06_JPRB, 0.25598342E-06_JPRB, &
  & 0.24173787E-06_JPRB, 0.22540659E-06_JPRB, 0.20741362E-06_JPRB, 0.18888178E-06_JPRB, 0.17097439E-06_JPRB, 0.15440339E-06_JPRB, &
  & 0.13953050E-06_JPRB, 0.12623678E-06_JPRB, 0.11411204E-06_JPRB, 0.10278515E-06_JPRB, 0.91995510E-07_JPRB, 0.81775759E-07_JPRB, &
  & 0.72580150E-07_JPRB, 0.65174596E-07_JPRB, 0.60174777E-07_JPRB, 0.57595329E-07_JPRB, 0.57140916E-07_JPRB, 0.58429226E-07_JPRB, &
  & 0.61277419E-07_JPRB, 0.65541236E-07_JPRB, 0.70996798E-07_JPRB, 0.77276368E-07_JPRB, 0.84244355E-07_JPRB, 0.91206971E-07_JPRB, &
  & 0.97953603E-07_JPRB, 0.10446649E-06_JPRB, 0.11095852E-06_JPRB, 0.11786098E-06_JPRB, 0.12661287E-06_JPRB, 0.13837041E-06_JPRB, &
  & 0.15522166E-06_JPRB, 0.17877754E-06_JPRB, 0.20818041E-06_JPRB, 0.23990549E-06_JPRB, 0.26816423E-06_JPRB, 0.29038154E-06_JPRB, &
  & 0.30784659E-06_JPRB, 0.32255701E-06_JPRB, 0.33644707E-06_JPRB, 0.35058619E-06_JPRB, 0.36515024E-06_JPRB, 0.37917494E-06_JPRB, &
  & 0.39214393E-06_JPRB, 0.40479568E-06_JPRB, 0.41925730E-06_JPRB, 0.44579838E-06_JPRB /)

RGHG7(:,49, 8) = (/ &
  & 0.40769856E-06_JPRB, 0.37022662E-06_JPRB, 0.34860861E-06_JPRB, 0.32742903E-06_JPRB, 0.30447640E-06_JPRB, 0.28368262E-06_JPRB, &
  & 0.26887901E-06_JPRB, 0.25839441E-06_JPRB, 0.25044045E-06_JPRB, 0.24464393E-06_JPRB, 0.23993405E-06_JPRB, 0.23594968E-06_JPRB, &
  & 0.23231460E-06_JPRB, 0.22884710E-06_JPRB, 0.22529503E-06_JPRB, 0.22148205E-06_JPRB, 0.21728340E-06_JPRB, 0.21248690E-06_JPRB, &
  & 0.20649395E-06_JPRB, 0.19863194E-06_JPRB, 0.18792282E-06_JPRB, 0.17485586E-06_JPRB, 0.16041638E-06_JPRB, 0.14596827E-06_JPRB, &
  & 0.13247084E-06_JPRB, 0.12014807E-06_JPRB, 0.10879653E-06_JPRB, 0.98070203E-07_JPRB, 0.87780862E-07_JPRB, 0.77969851E-07_JPRB, &
  & 0.69108019E-07_JPRB, 0.61947404E-07_JPRB, 0.57021378E-07_JPRB, 0.54429222E-07_JPRB, 0.53858393E-07_JPRB, 0.54973068E-07_JPRB, &
  & 0.57641333E-07_JPRB, 0.61677504E-07_JPRB, 0.66813676E-07_JPRB, 0.72797874E-07_JPRB, 0.79244515E-07_JPRB, 0.85763205E-07_JPRB, &
  & 0.91882256E-07_JPRB, 0.97609963E-07_JPRB, 0.10304108E-06_JPRB, 0.10861698E-06_JPRB, 0.11513568E-06_JPRB, 0.12350787E-06_JPRB, &
  & 0.13484089E-06_JPRB, 0.15007767E-06_JPRB, 0.16930738E-06_JPRB, 0.19023395E-06_JPRB, 0.21006031E-06_JPRB, 0.22619523E-06_JPRB, &
  & 0.23942567E-06_JPRB, 0.25097555E-06_JPRB, 0.26243879E-06_JPRB, 0.27472188E-06_JPRB, 0.28787443E-06_JPRB, 0.30103453E-06_JPRB, &
  & 0.31338683E-06_JPRB, 0.32539975E-06_JPRB, 0.33919653E-06_JPRB, 0.36464274E-06_JPRB /)

RGHG7(:,50, 8) = (/ &
  & 0.32529218E-06_JPRB, 0.29714155E-06_JPRB, 0.27936758E-06_JPRB, 0.26005100E-06_JPRB, 0.23826179E-06_JPRB, 0.21833586E-06_JPRB, &
  & 0.20453218E-06_JPRB, 0.19504938E-06_JPRB, 0.18862288E-06_JPRB, 0.18393266E-06_JPRB, 0.18067897E-06_JPRB, 0.17830222E-06_JPRB, &
  & 0.17679203E-06_JPRB, 0.17596234E-06_JPRB, 0.17567896E-06_JPRB, 0.17586819E-06_JPRB, 0.17639948E-06_JPRB, 0.17702395E-06_JPRB, &
  & 0.17717093E-06_JPRB, 0.17548329E-06_JPRB, 0.17086616E-06_JPRB, 0.16248899E-06_JPRB, 0.15128442E-06_JPRB, 0.13881372E-06_JPRB, &
  & 0.12654526E-06_JPRB, 0.11507927E-06_JPRB, 0.10436224E-06_JPRB, 0.94147055E-07_JPRB, 0.84257969E-07_JPRB, 0.74776750E-07_JPRB, &
  & 0.66189884E-07_JPRB, 0.59192299E-07_JPRB, 0.54322612E-07_JPRB, 0.51687817E-07_JPRB, 0.50946365E-07_JPRB, 0.51918825E-07_JPRB, &
  & 0.54410496E-07_JPRB, 0.58187947E-07_JPRB, 0.63068697E-07_JPRB, 0.68695840E-07_JPRB, 0.74824037E-07_JPRB, 0.80943700E-07_JPRB, &
  & 0.86680721E-07_JPRB, 0.91779448E-07_JPRB, 0.96505190E-07_JPRB, 0.10116118E-06_JPRB, 0.10619063E-06_JPRB, 0.11227243E-06_JPRB, &
  & 0.11980589E-06_JPRB, 0.12916529E-06_JPRB, 0.13996764E-06_JPRB, 0.15178243E-06_JPRB, 0.16268736E-06_JPRB, 0.17227211E-06_JPRB, &
  & 0.18051047E-06_JPRB, 0.18838310E-06_JPRB, 0.19657895E-06_JPRB, 0.20607688E-06_JPRB, 0.21707118E-06_JPRB, 0.22866207E-06_JPRB, &
  & 0.23988119E-06_JPRB, 0.25112897E-06_JPRB, 0.26412863E-06_JPRB, 0.28890381E-06_JPRB /)

RGHG7(:,51, 8) = (/ &
  & 0.27063663E-06_JPRB, 0.24377437E-06_JPRB, 0.22759801E-06_JPRB, 0.21147345E-06_JPRB, 0.19253733E-06_JPRB, 0.17588378E-06_JPRB, &
  & 0.16413723E-06_JPRB, 0.15696685E-06_JPRB, 0.15169577E-06_JPRB, 0.14832958E-06_JPRB, 0.14578953E-06_JPRB, 0.14417589E-06_JPRB, &
  & 0.14343763E-06_JPRB, 0.14365280E-06_JPRB, 0.14477422E-06_JPRB, 0.14664725E-06_JPRB, 0.14917704E-06_JPRB, 0.15207453E-06_JPRB, &
  & 0.15491050E-06_JPRB, 0.15678388E-06_JPRB, 0.15607080E-06_JPRB, 0.15161615E-06_JPRB, 0.14330826E-06_JPRB, 0.13266752E-06_JPRB, &
  & 0.12150123E-06_JPRB, 0.11075918E-06_JPRB, 0.10058218E-06_JPRB, 0.90787502E-07_JPRB, 0.81248352E-07_JPRB, 0.72048650E-07_JPRB, &
  & 0.63696824E-07_JPRB, 0.56817264E-07_JPRB, 0.52025339E-07_JPRB, 0.49250890E-07_JPRB, 0.48388262E-07_JPRB, 0.49225832E-07_JPRB, &
  & 0.51507211E-07_JPRB, 0.55045533E-07_JPRB, 0.59635227E-07_JPRB, 0.64994559E-07_JPRB, 0.70792794E-07_JPRB, 0.76627352E-07_JPRB, &
  & 0.82020669E-07_JPRB, 0.86818844E-07_JPRB, 0.90990831E-07_JPRB, 0.94996338E-07_JPRB, 0.99163721E-07_JPRB, 0.10369595E-06_JPRB, &
  & 0.10889043E-06_JPRB, 0.11456336E-06_JPRB, 0.12057617E-06_JPRB, 0.12647129E-06_JPRB, 0.13180698E-06_JPRB, 0.13643407E-06_JPRB, &
  & 0.14048913E-06_JPRB, 0.14444542E-06_JPRB, 0.14899182E-06_JPRB, 0.15450750E-06_JPRB, 0.16148059E-06_JPRB, 0.16965932E-06_JPRB, &
  & 0.17826929E-06_JPRB, 0.18728770E-06_JPRB, 0.19863828E-06_JPRB, 0.22150546E-06_JPRB /)

RGHG7(:,52, 8) = (/ &
  & 0.21817458E-06_JPRB, 0.19937561E-06_JPRB, 0.18859498E-06_JPRB, 0.17609852E-06_JPRB, 0.16168146E-06_JPRB, 0.14818902E-06_JPRB, &
  & 0.13965075E-06_JPRB, 0.13397248E-06_JPRB, 0.13054192E-06_JPRB, 0.12795032E-06_JPRB, 0.12623917E-06_JPRB, 0.12509977E-06_JPRB, &
  & 0.12477297E-06_JPRB, 0.12536746E-06_JPRB, 0.12686039E-06_JPRB, 0.12914769E-06_JPRB, 0.13203794E-06_JPRB, 0.13538768E-06_JPRB, &
  & 0.13886093E-06_JPRB, 0.14198262E-06_JPRB, 0.14355332E-06_JPRB, 0.14189888E-06_JPRB, 0.13617968E-06_JPRB, 0.12726004E-06_JPRB, &
  & 0.11708981E-06_JPRB, 0.10696886E-06_JPRB, 0.97243273E-07_JPRB, 0.87827729E-07_JPRB, 0.78591732E-07_JPRB, 0.69685946E-07_JPRB, &
  & 0.61514172E-07_JPRB, 0.54814713E-07_JPRB, 0.49981860E-07_JPRB, 0.47109395E-07_JPRB, 0.46154796E-07_JPRB, 0.46822638E-07_JPRB, &
  & 0.48894179E-07_JPRB, 0.52193155E-07_JPRB, 0.56520012E-07_JPRB, 0.61583549E-07_JPRB, 0.67113383E-07_JPRB, 0.72688493E-07_JPRB, &
  & 0.77882092E-07_JPRB, 0.82334779E-07_JPRB, 0.86251944E-07_JPRB, 0.89797524E-07_JPRB, 0.93340851E-07_JPRB, 0.97022699E-07_JPRB, &
  & 0.10076637E-06_JPRB, 0.10446650E-06_JPRB, 0.10796178E-06_JPRB, 0.11104287E-06_JPRB, 0.11365593E-06_JPRB, 0.11568003E-06_JPRB, &
  & 0.11747095E-06_JPRB, 0.11927379E-06_JPRB, 0.12118839E-06_JPRB, 0.12374942E-06_JPRB, 0.12717399E-06_JPRB, 0.13146035E-06_JPRB, &
  & 0.13642639E-06_JPRB, 0.14217720E-06_JPRB, 0.14997009E-06_JPRB, 0.16817860E-06_JPRB /)

RGHG7(:,53, 8) = (/ &
  & 0.18287916E-06_JPRB, 0.16892207E-06_JPRB, 0.16012481E-06_JPRB, 0.15110071E-06_JPRB, 0.13996710E-06_JPRB, 0.13026667E-06_JPRB, &
  & 0.12358169E-06_JPRB, 0.11979897E-06_JPRB, 0.11713643E-06_JPRB, 0.11549952E-06_JPRB, 0.11424623E-06_JPRB, 0.11351666E-06_JPRB, &
  & 0.11340658E-06_JPRB, 0.11409320E-06_JPRB, 0.11558341E-06_JPRB, 0.11776989E-06_JPRB, 0.12050693E-06_JPRB, 0.12363266E-06_JPRB, &
  & 0.12704049E-06_JPRB, 0.13038947E-06_JPRB, 0.13296453E-06_JPRB, 0.13320538E-06_JPRB, 0.12962956E-06_JPRB, 0.12232387E-06_JPRB, &
  & 0.11309155E-06_JPRB, 0.10352144E-06_JPRB, 0.94204623E-07_JPRB, 0.85129450E-07_JPRB, 0.76210398E-07_JPRB, 0.67577140E-07_JPRB, &
  & 0.59619104E-07_JPRB, 0.53051917E-07_JPRB, 0.48157865E-07_JPRB, 0.45264212E-07_JPRB, 0.44171038E-07_JPRB, 0.44655962E-07_JPRB, &
  & 0.46536265E-07_JPRB, 0.49607511E-07_JPRB, 0.53673649E-07_JPRB, 0.58470512E-07_JPRB, 0.63732109E-07_JPRB, 0.69090198E-07_JPRB, &
  & 0.74023902E-07_JPRB, 0.78345401E-07_JPRB, 0.81983373E-07_JPRB, 0.85301771E-07_JPRB, 0.88446079E-07_JPRB, 0.91555876E-07_JPRB, &
  & 0.94498603E-07_JPRB, 0.97185911E-07_JPRB, 0.99431958E-07_JPRB, 0.10130199E-06_JPRB, 0.10265430E-06_JPRB, 0.10372782E-06_JPRB, &
  & 0.10458921E-06_JPRB, 0.10535294E-06_JPRB, 0.10626957E-06_JPRB, 0.10744400E-06_JPRB, 0.10899860E-06_JPRB, 0.11114219E-06_JPRB, &
  & 0.11363274E-06_JPRB, 0.11656806E-06_JPRB, 0.12075961E-06_JPRB, 0.13229800E-06_JPRB /)

RGHG7(:,54, 8) = (/ &
  & 0.15623156E-06_JPRB, 0.14488597E-06_JPRB, 0.13885747E-06_JPRB, 0.13222613E-06_JPRB, 0.12447921E-06_JPRB, 0.11725827E-06_JPRB, &
  & 0.11277017E-06_JPRB, 0.10987922E-06_JPRB, 0.10819473E-06_JPRB, 0.10694527E-06_JPRB, 0.10612948E-06_JPRB, 0.10562882E-06_JPRB, &
  & 0.10562380E-06_JPRB, 0.10628957E-06_JPRB, 0.10762308E-06_JPRB, 0.10956963E-06_JPRB, 0.11195731E-06_JPRB, 0.11479215E-06_JPRB, &
  & 0.11786130E-06_JPRB, 0.12109149E-06_JPRB, 0.12402137E-06_JPRB, 0.12539236E-06_JPRB, 0.12346918E-06_JPRB, 0.11763538E-06_JPRB, &
  & 0.10929914E-06_JPRB, 0.10027792E-06_JPRB, 0.91342677E-07_JPRB, 0.82621298E-07_JPRB, 0.74021521E-07_JPRB, 0.65645821E-07_JPRB, &
  & 0.57968897E-07_JPRB, 0.51420212E-07_JPRB, 0.46598728E-07_JPRB, 0.43627363E-07_JPRB, 0.42377842E-07_JPRB, 0.42701679E-07_JPRB, &
  & 0.44398362E-07_JPRB, 0.47262731E-07_JPRB, 0.51082658E-07_JPRB, 0.55617015E-07_JPRB, 0.60640211E-07_JPRB, 0.65739918E-07_JPRB, &
  & 0.70521693E-07_JPRB, 0.74600315E-07_JPRB, 0.78113175E-07_JPRB, 0.81229892E-07_JPRB, 0.84180336E-07_JPRB, 0.86942102E-07_JPRB, &
  & 0.89489156E-07_JPRB, 0.91569291E-07_JPRB, 0.93355276E-07_JPRB, 0.94626252E-07_JPRB, 0.95562292E-07_JPRB, 0.96214528E-07_JPRB, &
  & 0.96705719E-07_JPRB, 0.97198146E-07_JPRB, 0.97719109E-07_JPRB, 0.98327909E-07_JPRB, 0.99192768E-07_JPRB, 0.10026228E-06_JPRB, &
  & 0.10150572E-06_JPRB, 0.10289231E-06_JPRB, 0.10454411E-06_JPRB, 0.10914515E-06_JPRB /)

RGHG7(:,55, 8) = (/ &
  & 0.13437025E-06_JPRB, 0.12721067E-06_JPRB, 0.12290988E-06_JPRB, 0.11828129E-06_JPRB, 0.11289856E-06_JPRB, 0.10793544E-06_JPRB, &
  & 0.10448745E-06_JPRB, 0.10259319E-06_JPRB, 0.10132217E-06_JPRB, 0.10053250E-06_JPRB, 0.99941566E-07_JPRB, 0.99615605E-07_JPRB, &
  & 0.99659090E-07_JPRB, 0.10021643E-06_JPRB, 0.10134952E-06_JPRB, 0.10299120E-06_JPRB, 0.10509229E-06_JPRB, 0.10750252E-06_JPRB, &
  & 0.11037647E-06_JPRB, 0.11339246E-06_JPRB, 0.11638473E-06_JPRB, 0.11837920E-06_JPRB, 0.11762375E-06_JPRB, 0.11301635E-06_JPRB, &
  & 0.10557370E-06_JPRB, 0.97107332E-07_JPRB, 0.88594049E-07_JPRB, 0.80214512E-07_JPRB, 0.71961693E-07_JPRB, 0.63878659E-07_JPRB, &
  & 0.56386735E-07_JPRB, 0.49981548E-07_JPRB, 0.45208775E-07_JPRB, 0.42139529E-07_JPRB, 0.40750656E-07_JPRB, 0.40931535E-07_JPRB, &
  & 0.42464421E-07_JPRB, 0.45118945E-07_JPRB, 0.48710515E-07_JPRB, 0.53021459E-07_JPRB, 0.57789073E-07_JPRB, 0.62678488E-07_JPRB, &
  & 0.67201505E-07_JPRB, 0.71159427E-07_JPRB, 0.74494956E-07_JPRB, 0.77487059E-07_JPRB, 0.80266425E-07_JPRB, 0.82880973E-07_JPRB, &
  & 0.85163485E-07_JPRB, 0.87144549E-07_JPRB, 0.88612140E-07_JPRB, 0.89722590E-07_JPRB, 0.90481755E-07_JPRB, 0.91014897E-07_JPRB, &
  & 0.91423722E-07_JPRB, 0.91793055E-07_JPRB, 0.92149321E-07_JPRB, 0.92619338E-07_JPRB, 0.93200882E-07_JPRB, 0.93909982E-07_JPRB, &
  & 0.94717301E-07_JPRB, 0.95520640E-07_JPRB, 0.96341999E-07_JPRB, 0.97328588E-07_JPRB /)

RGHG7(:,56, 8) = (/ &
  & 0.12052173E-06_JPRB, 0.11409593E-06_JPRB, 0.11080685E-06_JPRB, 0.10768392E-06_JPRB, 0.10399523E-06_JPRB, 0.10059779E-06_JPRB, &
  & 0.98304234E-07_JPRB, 0.96817637E-07_JPRB, 0.95967572E-07_JPRB, 0.95345555E-07_JPRB, 0.94940091E-07_JPRB, 0.94682974E-07_JPRB, &
  & 0.94717144E-07_JPRB, 0.95128065E-07_JPRB, 0.96037766E-07_JPRB, 0.97362999E-07_JPRB, 0.99161760E-07_JPRB, 0.10132619E-06_JPRB, &
  & 0.10388958E-06_JPRB, 0.10678461E-06_JPRB, 0.10977253E-06_JPRB, 0.11207734E-06_JPRB, 0.11206539E-06_JPRB, 0.10841180E-06_JPRB, &
  & 0.10179516E-06_JPRB, 0.93931867E-07_JPRB, 0.85873332E-07_JPRB, 0.77865579E-07_JPRB, 0.69929747E-07_JPRB, 0.62175452E-07_JPRB, &
  & 0.54875784E-07_JPRB, 0.48665775E-07_JPRB, 0.43916124E-07_JPRB, 0.40768814E-07_JPRB, 0.39285883E-07_JPRB, 0.39330867E-07_JPRB, &
  & 0.40691983E-07_JPRB, 0.43159687E-07_JPRB, 0.46542080E-07_JPRB, 0.50623608E-07_JPRB, 0.55174361E-07_JPRB, 0.59810667E-07_JPRB, &
  & 0.64149603E-07_JPRB, 0.67898270E-07_JPRB, 0.71116283E-07_JPRB, 0.73970085E-07_JPRB, 0.76652604E-07_JPRB, 0.79141898E-07_JPRB, &
  & 0.81384108E-07_JPRB, 0.83249866E-07_JPRB, 0.84763968E-07_JPRB, 0.85829598E-07_JPRB, 0.86572641E-07_JPRB, 0.87077751E-07_JPRB, &
  & 0.87482242E-07_JPRB, 0.87823437E-07_JPRB, 0.88201176E-07_JPRB, 0.88615806E-07_JPRB, 0.89089120E-07_JPRB, 0.89666685E-07_JPRB, &
  & 0.90285219E-07_JPRB, 0.90945321E-07_JPRB, 0.91839695E-07_JPRB, 0.94076050E-07_JPRB /)

RGHG7(:,57, 8) = (/ &
  & 0.10768427E-06_JPRB, 0.10378290E-06_JPRB, 0.10169741E-06_JPRB, 0.99483586E-07_JPRB, 0.97088943E-07_JPRB, 0.94707509E-07_JPRB, &
  & 0.92985651E-07_JPRB, 0.91990444E-07_JPRB, 0.91329426E-07_JPRB, 0.90892755E-07_JPRB, 0.90565848E-07_JPRB, 0.90356281E-07_JPRB, &
  & 0.90344244E-07_JPRB, 0.90619736E-07_JPRB, 0.91276632E-07_JPRB, 0.92347115E-07_JPRB, 0.93842232E-07_JPRB, 0.95778347E-07_JPRB, &
  & 0.98176763E-07_JPRB, 0.10097581E-06_JPRB, 0.10391103E-06_JPRB, 0.10637667E-06_JPRB, 0.10678469E-06_JPRB, 0.10382453E-06_JPRB, &
  & 0.97929103E-07_JPRB, 0.90696382E-07_JPRB, 0.83101021E-07_JPRB, 0.75501454E-07_JPRB, 0.67899464E-07_JPRB, 0.60438822E-07_JPRB, &
  & 0.53440083E-07_JPRB, 0.47379295E-07_JPRB, 0.42679336E-07_JPRB, 0.39529020E-07_JPRB, 0.37957498E-07_JPRB, 0.37875566E-07_JPRB, &
  & 0.39078490E-07_JPRB, 0.41359232E-07_JPRB, 0.44542421E-07_JPRB, 0.48420304E-07_JPRB, 0.52737327E-07_JPRB, 0.57155876E-07_JPRB, &
  & 0.61261332E-07_JPRB, 0.64855314E-07_JPRB, 0.67931126E-07_JPRB, 0.70676379E-07_JPRB, 0.73238802E-07_JPRB, 0.75671089E-07_JPRB, &
  & 0.77890029E-07_JPRB, 0.79806568E-07_JPRB, 0.81350954E-07_JPRB, 0.82528643E-07_JPRB, 0.83320820E-07_JPRB, 0.83892417E-07_JPRB, &
  & 0.84315445E-07_JPRB, 0.84708603E-07_JPRB, 0.85084821E-07_JPRB, 0.85486683E-07_JPRB, 0.85969916E-07_JPRB, 0.86495092E-07_JPRB, &
  & 0.87023459E-07_JPRB, 0.87533607E-07_JPRB, 0.88069044E-07_JPRB, 0.89254847E-07_JPRB /)

RGHG7(:,58, 8) = (/ &
  & 0.10020625E-06_JPRB, 0.96427847E-07_JPRB, 0.94607472E-07_JPRB, 0.93119851E-07_JPRB, 0.91481809E-07_JPRB, 0.89873836E-07_JPRB, &
  & 0.88646232E-07_JPRB, 0.87826081E-07_JPRB, 0.87322022E-07_JPRB, 0.86947828E-07_JPRB, 0.86655923E-07_JPRB, 0.86448317E-07_JPRB, &
  & 0.86345118E-07_JPRB, 0.86495831E-07_JPRB, 0.86915918E-07_JPRB, 0.87751410E-07_JPRB, 0.88981245E-07_JPRB, 0.90755698E-07_JPRB, &
  & 0.92983946E-07_JPRB, 0.95726975E-07_JPRB, 0.98667385E-07_JPRB, 0.10115707E-06_JPRB, 0.10176921E-06_JPRB, 0.99251579E-07_JPRB, &
  & 0.94016002E-07_JPRB, 0.87354287E-07_JPRB, 0.80262666E-07_JPRB, 0.73040411E-07_JPRB, 0.65809793E-07_JPRB, 0.58662337E-07_JPRB, &
  & 0.51947318E-07_JPRB, 0.46098616E-07_JPRB, 0.41511765E-07_JPRB, 0.38379945E-07_JPRB, 0.36760632E-07_JPRB, 0.36563208E-07_JPRB, &
  & 0.37611475E-07_JPRB, 0.39718941E-07_JPRB, 0.42709686E-07_JPRB, 0.46377171E-07_JPRB, 0.50468330E-07_JPRB, 0.54657793E-07_JPRB, &
  & 0.58560737E-07_JPRB, 0.61988594E-07_JPRB, 0.64938725E-07_JPRB, 0.67574696E-07_JPRB, 0.70050987E-07_JPRB, 0.72405889E-07_JPRB, &
  & 0.74596393E-07_JPRB, 0.76591675E-07_JPRB, 0.78266034E-07_JPRB, 0.79542687E-07_JPRB, 0.80480930E-07_JPRB, 0.81129649E-07_JPRB, &
  & 0.81640756E-07_JPRB, 0.82079914E-07_JPRB, 0.82505338E-07_JPRB, 0.82978794E-07_JPRB, 0.83467960E-07_JPRB, 0.84000412E-07_JPRB, &
  & 0.84523926E-07_JPRB, 0.85045521E-07_JPRB, 0.85674252E-07_JPRB, 0.86941093E-07_JPRB /)

RGHG7(:,59, 8) = (/ &
  & 0.92766200E-07_JPRB, 0.90149854E-07_JPRB, 0.88975128E-07_JPRB, 0.87907374E-07_JPRB, 0.86780183E-07_JPRB, 0.85618225E-07_JPRB, &
  & 0.84681730E-07_JPRB, 0.84065519E-07_JPRB, 0.83623846E-07_JPRB, 0.83306709E-07_JPRB, 0.83017845E-07_JPRB, 0.82798515E-07_JPRB, &
  & 0.82613617E-07_JPRB, 0.82628510E-07_JPRB, 0.82837204E-07_JPRB, 0.83469921E-07_JPRB, 0.84488519E-07_JPRB, 0.86106311E-07_JPRB, &
  & 0.88256229E-07_JPRB, 0.90954238E-07_JPRB, 0.93856755E-07_JPRB, 0.96291778E-07_JPRB, 0.96957812E-07_JPRB, 0.94780518E-07_JPRB, &
  & 0.90057171E-07_JPRB, 0.83958895E-07_JPRB, 0.77307966E-07_JPRB, 0.70499595E-07_JPRB, 0.63611942E-07_JPRB, 0.56829169E-07_JPRB, &
  & 0.50419828E-07_JPRB, 0.44814826E-07_JPRB, 0.40385828E-07_JPRB, 0.37327059E-07_JPRB, 0.35684327E-07_JPRB, 0.35399498E-07_JPRB, &
  & 0.36309075E-07_JPRB, 0.38247570E-07_JPRB, 0.41050178E-07_JPRB, 0.44502251E-07_JPRB, 0.48366005E-07_JPRB, 0.52326445E-07_JPRB, &
  & 0.56025236E-07_JPRB, 0.59295346E-07_JPRB, 0.62133843E-07_JPRB, 0.64675099E-07_JPRB, 0.67068200E-07_JPRB, 0.69356510E-07_JPRB, &
  & 0.71533421E-07_JPRB, 0.73514840E-07_JPRB, 0.75313324E-07_JPRB, 0.76785305E-07_JPRB, 0.77864499E-07_JPRB, 0.78655724E-07_JPRB, &
  & 0.79274145E-07_JPRB, 0.79790887E-07_JPRB, 0.80307444E-07_JPRB, 0.80811610E-07_JPRB, 0.81364810E-07_JPRB, 0.81931816E-07_JPRB, &
  & 0.82462321E-07_JPRB, 0.82947125E-07_JPRB, 0.83477111E-07_JPRB, 0.84666716E-07_JPRB /)

RGHG7(:,60, 8) = (/ &
  & 0.87826862E-07_JPRB, 0.85440739E-07_JPRB, 0.84396682E-07_JPRB, 0.83598927E-07_JPRB, 0.82801400E-07_JPRB, 0.81945331E-07_JPRB, &
  & 0.81191743E-07_JPRB, 0.80645947E-07_JPRB, 0.80246878E-07_JPRB, 0.79926785E-07_JPRB, 0.79621842E-07_JPRB, 0.79351757E-07_JPRB, &
  & 0.79099422E-07_JPRB, 0.78956468E-07_JPRB, 0.79030450E-07_JPRB, 0.79438990E-07_JPRB, 0.80318642E-07_JPRB, 0.81779383E-07_JPRB, &
  & 0.83885084E-07_JPRB, 0.86522810E-07_JPRB, 0.89379064E-07_JPRB, 0.91697750E-07_JPRB, 0.92342972E-07_JPRB, 0.90401770E-07_JPRB, &
  & 0.86136545E-07_JPRB, 0.80513843E-07_JPRB, 0.74299173E-07_JPRB, 0.67849342E-07_JPRB, 0.61338810E-07_JPRB, 0.54894048E-07_JPRB, &
  & 0.48838139E-07_JPRB, 0.43530182E-07_JPRB, 0.39299515E-07_JPRB, 0.36359285E-07_JPRB, 0.34738683E-07_JPRB, 0.34397942E-07_JPRB, &
  & 0.35189604E-07_JPRB, 0.36965705E-07_JPRB, 0.39575728E-07_JPRB, 0.42812331E-07_JPRB, 0.46431190E-07_JPRB, 0.50168257E-07_JPRB, &
  & 0.53654158E-07_JPRB, 0.56793905E-07_JPRB, 0.59504099E-07_JPRB, 0.61971882E-07_JPRB, 0.64292976E-07_JPRB, 0.66532799E-07_JPRB, &
  & 0.68657975E-07_JPRB, 0.70661940E-07_JPRB, 0.72470229E-07_JPRB, 0.74092625E-07_JPRB, 0.75357796E-07_JPRB, 0.76338004E-07_JPRB, &
  & 0.77079115E-07_JPRB, 0.77742470E-07_JPRB, 0.78334558E-07_JPRB, 0.78960056E-07_JPRB, 0.79592596E-07_JPRB, 0.80214612E-07_JPRB, &
  & 0.80783856E-07_JPRB, 0.81309317E-07_JPRB, 0.81882604E-07_JPRB, 0.82975639E-07_JPRB /)

RGHG7(:,61, 8) = (/ &
  & 0.83192234E-07_JPRB, 0.81221124E-07_JPRB, 0.80447670E-07_JPRB, 0.79848348E-07_JPRB, 0.79218978E-07_JPRB, 0.78549768E-07_JPRB, &
  & 0.77921854E-07_JPRB, 0.77434372E-07_JPRB, 0.77042870E-07_JPRB, 0.76716212E-07_JPRB, 0.76390805E-07_JPRB, 0.76058051E-07_JPRB, &
  & 0.75731904E-07_JPRB, 0.75470332E-07_JPRB, 0.75394397E-07_JPRB, 0.75644635E-07_JPRB, 0.76374960E-07_JPRB, 0.77775624E-07_JPRB, &
  & 0.79805858E-07_JPRB, 0.82384922E-07_JPRB, 0.85119702E-07_JPRB, 0.87296399E-07_JPRB, 0.87899622E-07_JPRB, 0.86155708E-07_JPRB, &
  & 0.82280465E-07_JPRB, 0.77077516E-07_JPRB, 0.71247129E-07_JPRB, 0.65156392E-07_JPRB, 0.58983733E-07_JPRB, 0.52927899E-07_JPRB, &
  & 0.47222926E-07_JPRB, 0.42244842E-07_JPRB, 0.38270539E-07_JPRB, 0.35483879E-07_JPRB, 0.33932530E-07_JPRB, 0.33570394E-07_JPRB, &
  & 0.34268023E-07_JPRB, 0.35892509E-07_JPRB, 0.38311729E-07_JPRB, 0.41319840E-07_JPRB, 0.44704279E-07_JPRB, 0.48187690E-07_JPRB, &
  & 0.51501477E-07_JPRB, 0.54469020E-07_JPRB, 0.57088332E-07_JPRB, 0.59464824E-07_JPRB, 0.61727661E-07_JPRB, 0.63921746E-07_JPRB, &
  & 0.66023617E-07_JPRB, 0.67994769E-07_JPRB, 0.69827088E-07_JPRB, 0.71470950E-07_JPRB, 0.72941717E-07_JPRB, 0.74057716E-07_JPRB, &
  & 0.75017986E-07_JPRB, 0.75803349E-07_JPRB, 0.76573329E-07_JPRB, 0.77309132E-07_JPRB, 0.78041090E-07_JPRB, 0.78737749E-07_JPRB, &
  & 0.79354926E-07_JPRB, 0.79897468E-07_JPRB, 0.80492050E-07_JPRB, 0.81607503E-07_JPRB /)

RGHG7(:,62, 8) = (/ &
  & 0.79498854E-07_JPRB, 0.77767687E-07_JPRB, 0.77066623E-07_JPRB, 0.76551814E-07_JPRB, 0.76056835E-07_JPRB, 0.75487073E-07_JPRB, &
  & 0.74918070E-07_JPRB, 0.74436535E-07_JPRB, 0.74037359E-07_JPRB, 0.73667785E-07_JPRB, 0.73304768E-07_JPRB, 0.72909216E-07_JPRB, &
  & 0.72481278E-07_JPRB, 0.72111980E-07_JPRB, 0.71902846E-07_JPRB, 0.72033288E-07_JPRB, 0.72691293E-07_JPRB, 0.73985035E-07_JPRB, &
  & 0.75974015E-07_JPRB, 0.78431668E-07_JPRB, 0.81052207E-07_JPRB, 0.83066752E-07_JPRB, 0.83626297E-07_JPRB, 0.82050036E-07_JPRB, &
  & 0.78499625E-07_JPRB, 0.73679885E-07_JPRB, 0.68194026E-07_JPRB, 0.62436030E-07_JPRB, 0.56608862E-07_JPRB, 0.50907882E-07_JPRB, &
  & 0.45597421E-07_JPRB, 0.40990354E-07_JPRB, 0.37308908E-07_JPRB, 0.34729240E-07_JPRB, 0.33279512E-07_JPRB, 0.32929851E-07_JPRB, &
  & 0.33559505E-07_JPRB, 0.35045161E-07_JPRB, 0.37268716E-07_JPRB, 0.40049972E-07_JPRB, 0.43177653E-07_JPRB, 0.46437947E-07_JPRB, &
  & 0.49544965E-07_JPRB, 0.52378869E-07_JPRB, 0.54868377E-07_JPRB, 0.57181065E-07_JPRB, 0.59374173E-07_JPRB, 0.61530521E-07_JPRB, &
  & 0.63599515E-07_JPRB, 0.65565679E-07_JPRB, 0.67361071E-07_JPRB, 0.69060825E-07_JPRB, 0.70526283E-07_JPRB, 0.71893488E-07_JPRB, &
  & 0.72961136E-07_JPRB, 0.73992346E-07_JPRB, 0.74919143E-07_JPRB, 0.75815024E-07_JPRB, 0.76669259E-07_JPRB, 0.77449094E-07_JPRB, &
  & 0.78112087E-07_JPRB, 0.78720937E-07_JPRB, 0.79365329E-07_JPRB, 0.80518262E-07_JPRB /)

RGHG7(:,63, 8) = (/ &
  & 0.76204643E-07_JPRB, 0.74601743E-07_JPRB, 0.73995693E-07_JPRB, 0.73556933E-07_JPRB, 0.73108829E-07_JPRB, 0.72610121E-07_JPRB, &
  & 0.72076510E-07_JPRB, 0.71586236E-07_JPRB, 0.71154368E-07_JPRB, 0.70748875E-07_JPRB, 0.70315629E-07_JPRB, 0.69844866E-07_JPRB, &
  & 0.69333943E-07_JPRB, 0.68838915E-07_JPRB, 0.68536991E-07_JPRB, 0.68596982E-07_JPRB, 0.69181134E-07_JPRB, 0.70444720E-07_JPRB, &
  & 0.72328916E-07_JPRB, 0.74697134E-07_JPRB, 0.77137528E-07_JPRB, 0.79011400E-07_JPRB, 0.79520049E-07_JPRB, 0.78078273E-07_JPRB, &
  & 0.74818281E-07_JPRB, 0.70328106E-07_JPRB, 0.65177673E-07_JPRB, 0.59731128E-07_JPRB, 0.54249547E-07_JPRB, 0.48924846E-07_JPRB, &
  & 0.44022944E-07_JPRB, 0.39813131E-07_JPRB, 0.36476191E-07_JPRB, 0.34136260E-07_JPRB, 0.32819788E-07_JPRB, 0.32506758E-07_JPRB, &
  & 0.33087939E-07_JPRB, 0.34448451E-07_JPRB, 0.36480206E-07_JPRB, 0.39025768E-07_JPRB, 0.41910571E-07_JPRB, 0.44926278E-07_JPRB, &
  & 0.47855522E-07_JPRB, 0.50507861E-07_JPRB, 0.52913606E-07_JPRB, 0.55131856E-07_JPRB, 0.57258486E-07_JPRB, 0.59370542E-07_JPRB, &
  & 0.61406226E-07_JPRB, 0.63357739E-07_JPRB, 0.65143155E-07_JPRB, 0.66825081E-07_JPRB, 0.68356549E-07_JPRB, 0.69744942E-07_JPRB, &
  & 0.71043139E-07_JPRB, 0.72202347E-07_JPRB, 0.73371623E-07_JPRB, 0.74407112E-07_JPRB, 0.75380221E-07_JPRB, 0.76219763E-07_JPRB, &
  & 0.76955601E-07_JPRB, 0.77605478E-07_JPRB, 0.78351164E-07_JPRB, 0.79623867E-07_JPRB /)

RGHG7(:,64, 8) = (/ &
  & 0.73346008E-07_JPRB, 0.71839608E-07_JPRB, 0.71247506E-07_JPRB, 0.70824370E-07_JPRB, 0.70419567E-07_JPRB, 0.69945138E-07_JPRB, &
  & 0.69418128E-07_JPRB, 0.68904413E-07_JPRB, 0.68418643E-07_JPRB, 0.67947980E-07_JPRB, 0.67451971E-07_JPRB, 0.66876360E-07_JPRB, &
  & 0.66252973E-07_JPRB, 0.65681988E-07_JPRB, 0.65320371E-07_JPRB, 0.65345361E-07_JPRB, 0.65908765E-07_JPRB, 0.67094383E-07_JPRB, &
  & 0.68898885E-07_JPRB, 0.71117014E-07_JPRB, 0.73417098E-07_JPRB, 0.75140527E-07_JPRB, 0.75593007E-07_JPRB, 0.74258395E-07_JPRB, &
  & 0.71247754E-07_JPRB, 0.67067958E-07_JPRB, 0.62229759E-07_JPRB, 0.57112548E-07_JPRB, 0.51974066E-07_JPRB, 0.47055597E-07_JPRB, &
  & 0.42580961E-07_JPRB, 0.38800877E-07_JPRB, 0.35841794E-07_JPRB, 0.33764376E-07_JPRB, 0.32596880E-07_JPRB, 0.32335642E-07_JPRB, &
  & 0.32884078E-07_JPRB, 0.34130718E-07_JPRB, 0.35976466E-07_JPRB, 0.38286299E-07_JPRB, 0.40915882E-07_JPRB, 0.43707026E-07_JPRB, &
  & 0.46432103E-07_JPRB, 0.48941864E-07_JPRB, 0.51234416E-07_JPRB, 0.53359937E-07_JPRB, 0.55411288E-07_JPRB, 0.57476285E-07_JPRB, &
  & 0.59464867E-07_JPRB, 0.61393500E-07_JPRB, 0.63164407E-07_JPRB, 0.64844663E-07_JPRB, 0.66373985E-07_JPRB, 0.67852341E-07_JPRB, &
  & 0.69185859E-07_JPRB, 0.70555259E-07_JPRB, 0.71866147E-07_JPRB, 0.73060335E-07_JPRB, 0.74113039E-07_JPRB, 0.75026712E-07_JPRB, &
  & 0.75800926E-07_JPRB, 0.76532409E-07_JPRB, 0.77389039E-07_JPRB, 0.78801087E-07_JPRB /)

RGHG7(:,65, 8) = (/ &
  & 0.70768749E-07_JPRB, 0.69264409E-07_JPRB, 0.68682873E-07_JPRB, 0.68271312E-07_JPRB, 0.67869408E-07_JPRB, 0.67413680E-07_JPRB, &
  & 0.66893996E-07_JPRB, 0.66336497E-07_JPRB, 0.65802375E-07_JPRB, 0.65249708E-07_JPRB, 0.64659623E-07_JPRB, 0.63997255E-07_JPRB, &
  & 0.63286464E-07_JPRB, 0.62655857E-07_JPRB, 0.62284641E-07_JPRB, 0.62304721E-07_JPRB, 0.62836250E-07_JPRB, 0.63973296E-07_JPRB, &
  & 0.65674271E-07_JPRB, 0.67777556E-07_JPRB, 0.69898135E-07_JPRB, 0.71476443E-07_JPRB, 0.71860896E-07_JPRB, 0.70618334E-07_JPRB, &
  & 0.67823670E-07_JPRB, 0.63940568E-07_JPRB, 0.59428697E-07_JPRB, 0.54644062E-07_JPRB, 0.49886985E-07_JPRB, 0.45381555E-07_JPRB, &
  & 0.41360593E-07_JPRB, 0.38034813E-07_JPRB, 0.35458065E-07_JPRB, 0.33649162E-07_JPRB, 0.32633974E-07_JPRB, 0.32433068E-07_JPRB, &
  & 0.32960052E-07_JPRB, 0.34106375E-07_JPRB, 0.35779102E-07_JPRB, 0.37862883E-07_JPRB, 0.40249368E-07_JPRB, 0.42807564E-07_JPRB, &
  & 0.45336790E-07_JPRB, 0.47695028E-07_JPRB, 0.49868060E-07_JPRB, 0.51888918E-07_JPRB, 0.53872864E-07_JPRB, 0.55869616E-07_JPRB, &
  & 0.57804119E-07_JPRB, 0.59699758E-07_JPRB, 0.61444453E-07_JPRB, 0.63119032E-07_JPRB, 0.64651822E-07_JPRB, 0.66145432E-07_JPRB, &
  & 0.67557920E-07_JPRB, 0.69012586E-07_JPRB, 0.70468829E-07_JPRB, 0.71742619E-07_JPRB, 0.72877540E-07_JPRB, 0.73829668E-07_JPRB, &
  & 0.74655262E-07_JPRB, 0.75439672E-07_JPRB, 0.76408497E-07_JPRB, 0.78002486E-07_JPRB /)

RGHG7(:,66, 8) = (/ &
  & 0.68413101E-07_JPRB, 0.66895311E-07_JPRB, 0.66288024E-07_JPRB, 0.65855978E-07_JPRB, 0.65450500E-07_JPRB, 0.64989784E-07_JPRB, &
  & 0.64456096E-07_JPRB, 0.63881785E-07_JPRB, 0.63250191E-07_JPRB, 0.62634378E-07_JPRB, 0.61948242E-07_JPRB, 0.61204680E-07_JPRB, &
  & 0.60446780E-07_JPRB, 0.59822391E-07_JPRB, 0.59461964E-07_JPRB, 0.59485224E-07_JPRB, 0.59993276E-07_JPRB, 0.61062963E-07_JPRB, &
  & 0.62663361E-07_JPRB, 0.64613516E-07_JPRB, 0.66584001E-07_JPRB, 0.68014081E-07_JPRB, 0.68334039E-07_JPRB, 0.67163548E-07_JPRB, &
  & 0.64587169E-07_JPRB, 0.60993948E-07_JPRB, 0.56821435E-07_JPRB, 0.52414382E-07_JPRB, 0.48048751E-07_JPRB, 0.43982620E-07_JPRB, &
  & 0.40422488E-07_JPRB, 0.37545735E-07_JPRB, 0.35342971E-07_JPRB, 0.33793157E-07_JPRB, 0.32927868E-07_JPRB, 0.32790144E-07_JPRB, &
  & 0.33305799E-07_JPRB, 0.34366135E-07_JPRB, 0.35881314E-07_JPRB, 0.37753956E-07_JPRB, 0.39905380E-07_JPRB, 0.42238028E-07_JPRB, &
  & 0.44584027E-07_JPRB, 0.46787061E-07_JPRB, 0.48831435E-07_JPRB, 0.50754291E-07_JPRB, 0.52653284E-07_JPRB, 0.54569689E-07_JPRB, &
  & 0.56437905E-07_JPRB, 0.58289199E-07_JPRB, 0.59989297E-07_JPRB, 0.61644968E-07_JPRB, 0.63167519E-07_JPRB, 0.64682027E-07_JPRB, &
  & 0.66120471E-07_JPRB, 0.67637991E-07_JPRB, 0.69172891E-07_JPRB, 0.70516215E-07_JPRB, 0.71684795E-07_JPRB, 0.72666431E-07_JPRB, &
  & 0.73529108E-07_JPRB, 0.74328561E-07_JPRB, 0.75424431E-07_JPRB, 0.77166206E-07_JPRB /)

RGHG7(:,67, 8) = (/ &
  & 0.66239252E-07_JPRB, 0.64642030E-07_JPRB, 0.63987848E-07_JPRB, 0.63520929E-07_JPRB, 0.63083057E-07_JPRB, 0.62609857E-07_JPRB, &
  & 0.62063485E-07_JPRB, 0.61440019E-07_JPRB, 0.60772081E-07_JPRB, 0.60041778E-07_JPRB, 0.59317212E-07_JPRB, 0.58523767E-07_JPRB, &
  & 0.57776052E-07_JPRB, 0.57182735E-07_JPRB, 0.56846041E-07_JPRB, 0.56874374E-07_JPRB, 0.57360165E-07_JPRB, 0.58366634E-07_JPRB, &
  & 0.59861947E-07_JPRB, 0.61679977E-07_JPRB, 0.63474076E-07_JPRB, 0.64762567E-07_JPRB, 0.65020508E-07_JPRB, 0.63936291E-07_JPRB, &
  & 0.61565402E-07_JPRB, 0.58279628E-07_JPRB, 0.54467840E-07_JPRB, 0.50452588E-07_JPRB, 0.46519233E-07_JPRB, 0.42894250E-07_JPRB, &
  & 0.39801918E-07_JPRB, 0.37338431E-07_JPRB, 0.35485172E-07_JPRB, 0.34179813E-07_JPRB, 0.33458321E-07_JPRB, 0.33385621E-07_JPRB, &
  & 0.33897788E-07_JPRB, 0.34887908E-07_JPRB, 0.36268421E-07_JPRB, 0.37957069E-07_JPRB, 0.39896381E-07_JPRB, 0.42025032E-07_JPRB, &
  & 0.44175646E-07_JPRB, 0.46228685E-07_JPRB, 0.48137871E-07_JPRB, 0.49959013E-07_JPRB, 0.51763955E-07_JPRB, 0.53582038E-07_JPRB, &
  & 0.55388295E-07_JPRB, 0.57170400E-07_JPRB, 0.58819523E-07_JPRB, 0.60443796E-07_JPRB, 0.61939353E-07_JPRB, 0.63447658E-07_JPRB, &
  & 0.64884169E-07_JPRB, 0.66430616E-07_JPRB, 0.68003416E-07_JPRB, 0.69377826E-07_JPRB, 0.70571623E-07_JPRB, 0.71566646E-07_JPRB, &
  & 0.72435526E-07_JPRB, 0.73236549E-07_JPRB, 0.74386271E-07_JPRB, 0.76300189E-07_JPRB /)

RGHG7(:,68, 8) = (/ &
  & 0.64213808E-07_JPRB, 0.62496618E-07_JPRB, 0.61760318E-07_JPRB, 0.61232562E-07_JPRB, 0.60750970E-07_JPRB, 0.60240687E-07_JPRB, &
  & 0.59682407E-07_JPRB, 0.59028757E-07_JPRB, 0.58279934E-07_JPRB, 0.57540362E-07_JPRB, 0.56745371E-07_JPRB, 0.55991897E-07_JPRB, &
  & 0.55286538E-07_JPRB, 0.54738358E-07_JPRB, 0.54439727E-07_JPRB, 0.54475187E-07_JPRB, 0.54937768E-07_JPRB, 0.55878225E-07_JPRB, &
  & 0.57262881E-07_JPRB, 0.58924869E-07_JPRB, 0.60565782E-07_JPRB, 0.61723107E-07_JPRB, 0.61938763E-07_JPRB, 0.60942000E-07_JPRB, &
  & 0.58798076E-07_JPRB, 0.55828156E-07_JPRB, 0.52387481E-07_JPRB, 0.48792714E-07_JPRB, 0.45285386E-07_JPRB, 0.42108415E-07_JPRB, &
  & 0.39457966E-07_JPRB, 0.37393441E-07_JPRB, 0.35860491E-07_JPRB, 0.34784694E-07_JPRB, 0.34204319E-07_JPRB, 0.34196940E-07_JPRB, &
  & 0.34712297E-07_JPRB, 0.35642493E-07_JPRB, 0.36905963E-07_JPRB, 0.38428730E-07_JPRB, 0.40182599E-07_JPRB, 0.42117403E-07_JPRB, &
  & 0.44106997E-07_JPRB, 0.46004647E-07_JPRB, 0.47786582E-07_JPRB, 0.49496670E-07_JPRB, 0.51194334E-07_JPRB, 0.52921781E-07_JPRB, &
  & 0.54643078E-07_JPRB, 0.56343836E-07_JPRB, 0.57933285E-07_JPRB, 0.59506554E-07_JPRB, 0.60960907E-07_JPRB, 0.62442680E-07_JPRB, &
  & 0.63858018E-07_JPRB, 0.65395106E-07_JPRB, 0.66979233E-07_JPRB, 0.68355476E-07_JPRB, 0.69552996E-07_JPRB, 0.70518048E-07_JPRB, &
  & 0.71422441E-07_JPRB, 0.72157917E-07_JPRB, 0.73338633E-07_JPRB, 0.75382374E-07_JPRB /)

RGHG7(:,69, 8) = (/ &
  & 0.62349265E-07_JPRB, 0.60424192E-07_JPRB, 0.59565185E-07_JPRB, 0.58947961E-07_JPRB, 0.58403309E-07_JPRB, 0.57862163E-07_JPRB, &
  & 0.57267403E-07_JPRB, 0.56618191E-07_JPRB, 0.55841969E-07_JPRB, 0.55032967E-07_JPRB, 0.54312213E-07_JPRB, 0.53582173E-07_JPRB, &
  & 0.52950746E-07_JPRB, 0.52453075E-07_JPRB, 0.52200722E-07_JPRB, 0.52256450E-07_JPRB, 0.52702845E-07_JPRB, 0.53581129E-07_JPRB, &
  & 0.54854898E-07_JPRB, 0.56378333E-07_JPRB, 0.57857754E-07_JPRB, 0.58897442E-07_JPRB, 0.59090016E-07_JPRB, 0.58205011E-07_JPRB, &
  & 0.56294258E-07_JPRB, 0.53648556E-07_JPRB, 0.50596903E-07_JPRB, 0.47417373E-07_JPRB, 0.44356625E-07_JPRB, 0.41612079E-07_JPRB, &
  & 0.39378072E-07_JPRB, 0.37685712E-07_JPRB, 0.36451862E-07_JPRB, 0.35593771E-07_JPRB, 0.35149149E-07_JPRB, 0.35209300E-07_JPRB, &
  & 0.35731716E-07_JPRB, 0.36614786E-07_JPRB, 0.37778321E-07_JPRB, 0.39166864E-07_JPRB, 0.40757069E-07_JPRB, 0.42526288E-07_JPRB, &
  & 0.44350571E-07_JPRB, 0.46101110E-07_JPRB, 0.47753865E-07_JPRB, 0.49347761E-07_JPRB, 0.50944230E-07_JPRB, 0.52566765E-07_JPRB, &
  & 0.54201500E-07_JPRB, 0.55810215E-07_JPRB, 0.57337228E-07_JPRB, 0.58843487E-07_JPRB, 0.60245263E-07_JPRB, 0.61673333E-07_JPRB, &
  & 0.63039714E-07_JPRB, 0.64534973E-07_JPRB, 0.66101620E-07_JPRB, 0.67443757E-07_JPRB, 0.68633817E-07_JPRB, 0.69545301E-07_JPRB, &
  & 0.70452110E-07_JPRB, 0.71151916E-07_JPRB, 0.72253563E-07_JPRB, 0.74365069E-07_JPRB /)

RGHG7(:,70, 8) = (/ &
  & 0.60641341E-07_JPRB, 0.58385503E-07_JPRB, 0.57349457E-07_JPRB, 0.56625634E-07_JPRB, 0.56014947E-07_JPRB, 0.55436779E-07_JPRB, &
  & 0.54850926E-07_JPRB, 0.54171267E-07_JPRB, 0.53397812E-07_JPRB, 0.52634679E-07_JPRB, 0.51952124E-07_JPRB, 0.51299970E-07_JPRB, &
  & 0.50751517E-07_JPRB, 0.50331177E-07_JPRB, 0.50131522E-07_JPRB, 0.50215164E-07_JPRB, 0.50647074E-07_JPRB, 0.51463619E-07_JPRB, &
  & 0.52629250E-07_JPRB, 0.54007394E-07_JPRB, 0.55346348E-07_JPRB, 0.56289263E-07_JPRB, 0.56477969E-07_JPRB, 0.55718917E-07_JPRB, &
  & 0.54055466E-07_JPRB, 0.51744479E-07_JPRB, 0.49077645E-07_JPRB, 0.46322437E-07_JPRB, 0.43685404E-07_JPRB, 0.41372026E-07_JPRB, &
  & 0.39522678E-07_JPRB, 0.38181334E-07_JPRB, 0.37231050E-07_JPRB, 0.36580094E-07_JPRB, 0.36272620E-07_JPRB, 0.36401097E-07_JPRB, &
  & 0.36935479E-07_JPRB, 0.37774985E-07_JPRB, 0.38850523E-07_JPRB, 0.40114347E-07_JPRB, 0.41562608E-07_JPRB, 0.43187633E-07_JPRB, &
  & 0.44866507E-07_JPRB, 0.46490499E-07_JPRB, 0.48011675E-07_JPRB, 0.49498095E-07_JPRB, 0.50987712E-07_JPRB, 0.52509904E-07_JPRB, &
  & 0.54048822E-07_JPRB, 0.55562428E-07_JPRB, 0.57012070E-07_JPRB, 0.58432654E-07_JPRB, 0.59770805E-07_JPRB, 0.61123714E-07_JPRB, &
  & 0.62430928E-07_JPRB, 0.63854856E-07_JPRB, 0.65375040E-07_JPRB, 0.66657883E-07_JPRB, 0.67812849E-07_JPRB, 0.68666466E-07_JPRB, &
  & 0.69530408E-07_JPRB, 0.70215194E-07_JPRB, 0.71179258E-07_JPRB, 0.73292846E-07_JPRB /)

RGHG7(:,71, 8) = (/ &
  & 0.59040620E-07_JPRB, 0.56321973E-07_JPRB, 0.55057413E-07_JPRB, 0.54223165E-07_JPRB, 0.53559774E-07_JPRB, 0.52965778E-07_JPRB, &
  & 0.52364022E-07_JPRB, 0.51727611E-07_JPRB, 0.50970510E-07_JPRB, 0.50287827E-07_JPRB, 0.49674199E-07_JPRB, 0.49119073E-07_JPRB, &
  & 0.48652584E-07_JPRB, 0.48320409E-07_JPRB, 0.48190163E-07_JPRB, 0.48316494E-07_JPRB, 0.48746600E-07_JPRB, 0.49515972E-07_JPRB, &
  & 0.50582642E-07_JPRB, 0.51834402E-07_JPRB, 0.53040342E-07_JPRB, 0.53897264E-07_JPRB, 0.54102323E-07_JPRB, 0.53482367E-07_JPRB, &
  & 0.52079233E-07_JPRB, 0.50103402E-07_JPRB, 0.47830127E-07_JPRB, 0.45480437E-07_JPRB, 0.43265672E-07_JPRB, 0.41349573E-07_JPRB, &
  & 0.39897230E-07_JPRB, 0.38865412E-07_JPRB, 0.38183316E-07_JPRB, 0.37733457E-07_JPRB, 0.37559197E-07_JPRB, 0.37759957E-07_JPRB, &
  & 0.38309782E-07_JPRB, 0.39117889E-07_JPRB, 0.40120870E-07_JPRB, 0.41283020E-07_JPRB, 0.42612506E-07_JPRB, 0.44093508E-07_JPRB, &
  & 0.45648466E-07_JPRB, 0.47127614E-07_JPRB, 0.48540759E-07_JPRB, 0.49918093E-07_JPRB, 0.51305712E-07_JPRB, 0.52728758E-07_JPRB, &
  & 0.54168563E-07_JPRB, 0.55585765E-07_JPRB, 0.56948245E-07_JPRB, 0.58280328E-07_JPRB, 0.59543979E-07_JPRB, 0.60811253E-07_JPRB, &
  & 0.62026523E-07_JPRB, 0.63359074E-07_JPRB, 0.64796005E-07_JPRB, 0.66002457E-07_JPRB, 0.67092870E-07_JPRB, 0.67897460E-07_JPRB, &
  & 0.68674659E-07_JPRB, 0.69347436E-07_JPRB, 0.70141311E-07_JPRB, 0.72097563E-07_JPRB /)

RGHG7(:,72, 8) = (/ &
  & 0.57438211E-07_JPRB, 0.54114331E-07_JPRB, 0.52638704E-07_JPRB, 0.51715748E-07_JPRB, 0.51026799E-07_JPRB, 0.50427683E-07_JPRB, &
  & 0.49850350E-07_JPRB, 0.49217508E-07_JPRB, 0.48591204E-07_JPRB, 0.47948408E-07_JPRB, 0.47474209E-07_JPRB, 0.47004093E-07_JPRB, &
  & 0.46659171E-07_JPRB, 0.46427164E-07_JPRB, 0.46376883E-07_JPRB, 0.46553531E-07_JPRB, 0.46998146E-07_JPRB, 0.47720956E-07_JPRB, &
  & 0.48712643E-07_JPRB, 0.49842139E-07_JPRB, 0.50935483E-07_JPRB, 0.51725962E-07_JPRB, 0.51955620E-07_JPRB, 0.51487529E-07_JPRB, &
  & 0.50349975E-07_JPRB, 0.48717613E-07_JPRB, 0.46827221E-07_JPRB, 0.44874763E-07_JPRB, 0.43058979E-07_JPRB, 0.41554927E-07_JPRB, &
  & 0.40429619E-07_JPRB, 0.39718881E-07_JPRB, 0.39270354E-07_JPRB, 0.39015532E-07_JPRB, 0.38980041E-07_JPRB, 0.39255205E-07_JPRB, &
  & 0.39824467E-07_JPRB, 0.40601758E-07_JPRB, 0.41535479E-07_JPRB, 0.42604494E-07_JPRB, 0.43818989E-07_JPRB, 0.45194628E-07_JPRB, &
  & 0.46617711E-07_JPRB, 0.47998544E-07_JPRB, 0.49295043E-07_JPRB, 0.50579054E-07_JPRB, 0.51867421E-07_JPRB, 0.53193315E-07_JPRB, &
  & 0.54535164E-07_JPRB, 0.55848904E-07_JPRB, 0.57118193E-07_JPRB, 0.58348320E-07_JPRB, 0.59533846E-07_JPRB, 0.60682240E-07_JPRB, &
  & 0.61821758E-07_JPRB, 0.63034470E-07_JPRB, 0.64360108E-07_JPRB, 0.65483782E-07_JPRB, 0.66485207E-07_JPRB, 0.67233174E-07_JPRB, &
  & 0.67927353E-07_JPRB, 0.68558371E-07_JPRB, 0.69213840E-07_JPRB, 0.70949255E-07_JPRB /)

RGHG7(:,73, 8) = (/ &
  & 0.55628902E-07_JPRB, 0.51697153E-07_JPRB, 0.50061612E-07_JPRB, 0.49118199E-07_JPRB, 0.48435684E-07_JPRB, 0.47857640E-07_JPRB, &
  & 0.47300414E-07_JPRB, 0.46770086E-07_JPRB, 0.46172492E-07_JPRB, 0.45725319E-07_JPRB, 0.45285773E-07_JPRB, 0.44977376E-07_JPRB, &
  & 0.44727233E-07_JPRB, 0.44616158E-07_JPRB, 0.44665853E-07_JPRB, 0.44909136E-07_JPRB, 0.45377014E-07_JPRB, 0.46091554E-07_JPRB, &
  & 0.47006150E-07_JPRB, 0.48044509E-07_JPRB, 0.49036782E-07_JPRB, 0.49769060E-07_JPRB, 0.50034910E-07_JPRB, 0.49723720E-07_JPRB, &
  & 0.48859015E-07_JPRB, 0.47566434E-07_JPRB, 0.46049838E-07_JPRB, 0.44474355E-07_JPRB, 0.43072664E-07_JPRB, 0.41959616E-07_JPRB, &
  & 0.41121531E-07_JPRB, 0.40706972E-07_JPRB, 0.40498978E-07_JPRB, 0.40426681E-07_JPRB, 0.40523329E-07_JPRB, 0.40876188E-07_JPRB, &
  & 0.41469288E-07_JPRB, 0.42229694E-07_JPRB, 0.43112223E-07_JPRB, 0.44102496E-07_JPRB, 0.45221910E-07_JPRB, 0.46473090E-07_JPRB, &
  & 0.47785367E-07_JPRB, 0.49042598E-07_JPRB, 0.50247174E-07_JPRB, 0.51433290E-07_JPRB, 0.52634647E-07_JPRB, 0.53861864E-07_JPRB, &
  & 0.55106067E-07_JPRB, 0.56317340E-07_JPRB, 0.57484929E-07_JPRB, 0.58626380E-07_JPRB, 0.59703353E-07_JPRB, 0.60765885E-07_JPRB, &
  & 0.61779076E-07_JPRB, 0.62879714E-07_JPRB, 0.64063649E-07_JPRB, 0.65086986E-07_JPRB, 0.65992829E-07_JPRB, 0.66678567E-07_JPRB, &
  & 0.67289172E-07_JPRB, 0.67862615E-07_JPRB, 0.68420427E-07_JPRB, 0.69895663E-07_JPRB /)

RGHG7(:,74, 8) = (/ &
  & 0.53278644E-07_JPRB, 0.49018986E-07_JPRB, 0.47394309E-07_JPRB, 0.46486775E-07_JPRB, 0.45854449E-07_JPRB, 0.45319652E-07_JPRB, &
  & 0.44835147E-07_JPRB, 0.44348475E-07_JPRB, 0.43928402E-07_JPRB, 0.43506162E-07_JPRB, 0.43263270E-07_JPRB, 0.43037996E-07_JPRB, &
  & 0.42940592E-07_JPRB, 0.42943284E-07_JPRB, 0.43092207E-07_JPRB, 0.43405169E-07_JPRB, 0.43906017E-07_JPRB, 0.44603642E-07_JPRB, &
  & 0.45469076E-07_JPRB, 0.46422887E-07_JPRB, 0.47336080E-07_JPRB, 0.48028411E-07_JPRB, 0.48336727E-07_JPRB, 0.48182958E-07_JPRB, &
  & 0.47587676E-07_JPRB, 0.46625590E-07_JPRB, 0.45466187E-07_JPRB, 0.44271477E-07_JPRB, 0.43305942E-07_JPRB, 0.42465576E-07_JPRB, &
  & 0.41988120E-07_JPRB, 0.41780854E-07_JPRB, 0.41790972E-07_JPRB, 0.41896367E-07_JPRB, 0.42130061E-07_JPRB, 0.42561346E-07_JPRB, &
  & 0.43181547E-07_JPRB, 0.43921268E-07_JPRB, 0.44753122E-07_JPRB, 0.45671559E-07_JPRB, 0.46705519E-07_JPRB, 0.47862084E-07_JPRB, &
  & 0.49070152E-07_JPRB, 0.50230881E-07_JPRB, 0.51340862E-07_JPRB, 0.52445909E-07_JPRB, 0.53549485E-07_JPRB, 0.54694940E-07_JPRB, &
  & 0.55832601E-07_JPRB, 0.56943257E-07_JPRB, 0.58009537E-07_JPRB, 0.59038804E-07_JPRB, 0.60029350E-07_JPRB, 0.60957447E-07_JPRB, &
  & 0.61889530E-07_JPRB, 0.62844883E-07_JPRB, 0.63894092E-07_JPRB, 0.64809925E-07_JPRB, 0.65606699E-07_JPRB, 0.66222604E-07_JPRB, &
  & 0.66763420E-07_JPRB, 0.67274250E-07_JPRB, 0.67739798E-07_JPRB, 0.68999952E-07_JPRB /)

RGHG7(:,75, 8) = (/ &
  & 0.50658485E-07_JPRB, 0.46311801E-07_JPRB, 0.44738627E-07_JPRB, 0.43919897E-07_JPRB, 0.43358465E-07_JPRB, 0.42900794E-07_JPRB, &
  & 0.42493692E-07_JPRB, 0.42124441E-07_JPRB, 0.41754863E-07_JPRB, 0.41516106E-07_JPRB, 0.41329507E-07_JPRB, 0.41257668E-07_JPRB, &
  & 0.41280352E-07_JPRB, 0.41402743E-07_JPRB, 0.41651088E-07_JPRB, 0.42031314E-07_JPRB, 0.42567791E-07_JPRB, 0.43256204E-07_JPRB, &
  & 0.44081695E-07_JPRB, 0.44970911E-07_JPRB, 0.45820265E-07_JPRB, 0.46489319E-07_JPRB, 0.46850307E-07_JPRB, 0.46850158E-07_JPRB, &
  & 0.46514096E-07_JPRB, 0.45865441E-07_JPRB, 0.45048292E-07_JPRB, 0.44272767E-07_JPRB, 0.43661935E-07_JPRB, 0.43099387E-07_JPRB, &
  & 0.42951481E-07_JPRB, 0.42977476E-07_JPRB, 0.43183942E-07_JPRB, 0.43465224E-07_JPRB, 0.43825803E-07_JPRB, 0.44336538E-07_JPRB, &
  & 0.44987718E-07_JPRB, 0.45724367E-07_JPRB, 0.46519784E-07_JPRB, 0.47378691E-07_JPRB, 0.48323951E-07_JPRB, 0.49375885E-07_JPRB, &
  & 0.50464635E-07_JPRB, 0.51524875E-07_JPRB, 0.52544248E-07_JPRB, 0.53557464E-07_JPRB, 0.54587304E-07_JPRB, 0.55624447E-07_JPRB, &
  & 0.56670100E-07_JPRB, 0.57674995E-07_JPRB, 0.58640801E-07_JPRB, 0.59571683E-07_JPRB, 0.60450603E-07_JPRB, 0.61289370E-07_JPRB, &
  & 0.62091992E-07_JPRB, 0.62932862E-07_JPRB, 0.63828423E-07_JPRB, 0.64627478E-07_JPRB, 0.65319881E-07_JPRB, 0.65857414E-07_JPRB, &
  & 0.66337329E-07_JPRB, 0.66766901E-07_JPRB, 0.67181084E-07_JPRB, 0.68230150E-07_JPRB /)

RGHG7(:,76, 8) = (/ &
  & 0.47922260E-07_JPRB, 0.43606946E-07_JPRB, 0.42174513E-07_JPRB, 0.41455415E-07_JPRB, 0.41005404E-07_JPRB, 0.40645190E-07_JPRB, &
  & 0.40336118E-07_JPRB, 0.40049560E-07_JPRB, 0.39833484E-07_JPRB, 0.39678376E-07_JPRB, 0.39641709E-07_JPRB, 0.39695845E-07_JPRB, &
  & 0.39825458E-07_JPRB, 0.40055159E-07_JPRB, 0.40380247E-07_JPRB, 0.40814271E-07_JPRB, 0.41365041E-07_JPRB, 0.42055216E-07_JPRB, &
  & 0.42832930E-07_JPRB, 0.43667445E-07_JPRB, 0.44471989E-07_JPRB, 0.45133532E-07_JPRB, 0.45554263E-07_JPRB, 0.45710994E-07_JPRB, &
  & 0.45613554E-07_JPRB, 0.45250836E-07_JPRB, 0.44792365E-07_JPRB, 0.44433964E-07_JPRB, 0.44053362E-07_JPRB, 0.43909647E-07_JPRB, &
  & 0.43944613E-07_JPRB, 0.44200245E-07_JPRB, 0.44542265E-07_JPRB, 0.44968811E-07_JPRB, 0.45460531E-07_JPRB, 0.46046964E-07_JPRB, &
  & 0.46730889E-07_JPRB, 0.47461434E-07_JPRB, 0.48230813E-07_JPRB, 0.49044985E-07_JPRB, 0.49935412E-07_JPRB, 0.50904390E-07_JPRB, &
  & 0.51907950E-07_JPRB, 0.52873673E-07_JPRB, 0.53811636E-07_JPRB, 0.54747368E-07_JPRB, 0.55682076E-07_JPRB, 0.56636406E-07_JPRB, &
  & 0.57568773E-07_JPRB, 0.58474555E-07_JPRB, 0.59333136E-07_JPRB, 0.60159131E-07_JPRB, 0.60935299E-07_JPRB, 0.61662824E-07_JPRB, &
  & 0.62368990E-07_JPRB, 0.63081963E-07_JPRB, 0.63845945E-07_JPRB, 0.64523690E-07_JPRB, 0.65109397E-07_JPRB, 0.65572337E-07_JPRB, &
  & 0.65978362E-07_JPRB, 0.66351816E-07_JPRB, 0.66683491E-07_JPRB, 0.67578036E-07_JPRB /)

RGHG7(:,77, 8) = (/ &
  & 0.45069115E-07_JPRB, 0.41007834E-07_JPRB, 0.39709850E-07_JPRB, 0.39148144E-07_JPRB, 0.38811770E-07_JPRB, 0.38568100E-07_JPRB, &
  & 0.38375607E-07_JPRB, 0.38209926E-07_JPRB, 0.38105149E-07_JPRB, 0.38070425E-07_JPRB, 0.38167855E-07_JPRB, 0.38301398E-07_JPRB, &
  & 0.38554919E-07_JPRB, 0.38864556E-07_JPRB, 0.39259170E-07_JPRB, 0.39741675E-07_JPRB, 0.40311622E-07_JPRB, 0.40983835E-07_JPRB, &
  & 0.41732090E-07_JPRB, 0.42514568E-07_JPRB, 0.43281592E-07_JPRB, 0.43948564E-07_JPRB, 0.44433008E-07_JPRB, 0.44744642E-07_JPRB, &
  & 0.44858329E-07_JPRB, 0.44765027E-07_JPRB, 0.44691671E-07_JPRB, 0.44637307E-07_JPRB, 0.44552561E-07_JPRB, 0.44747377E-07_JPRB, &
  & 0.44984777E-07_JPRB, 0.45454776E-07_JPRB, 0.45990149E-07_JPRB, 0.46552611E-07_JPRB, 0.47166179E-07_JPRB, 0.47833076E-07_JPRB, &
  & 0.48549047E-07_JPRB, 0.49280782E-07_JPRB, 0.50021050E-07_JPRB, 0.50785037E-07_JPRB, 0.51594796E-07_JPRB, 0.52466959E-07_JPRB, &
  & 0.53358619E-07_JPRB, 0.54234832E-07_JPRB, 0.55086169E-07_JPRB, 0.55937587E-07_JPRB, 0.56789972E-07_JPRB, 0.57638186E-07_JPRB, &
  & 0.58474019E-07_JPRB, 0.59271606E-07_JPRB, 0.60039348E-07_JPRB, 0.60758516E-07_JPRB, 0.61446180E-07_JPRB, 0.62075387E-07_JPRB, &
  & 0.62679582E-07_JPRB, 0.63279586E-07_JPRB, 0.63911152E-07_JPRB, 0.64471408E-07_JPRB, 0.64955550E-07_JPRB, 0.65337431E-07_JPRB, &
  & 0.65684340E-07_JPRB, 0.65982427E-07_JPRB, 0.66249292E-07_JPRB, 0.67012962E-07_JPRB /)

RGHG7(:,78, 8) = (/ &
  & 0.42202416E-07_JPRB, 0.38532082E-07_JPRB, 0.37485758E-07_JPRB, 0.37080188E-07_JPRB, 0.36897550E-07_JPRB, 0.36777692E-07_JPRB, &
  & 0.36700314E-07_JPRB, 0.36669277E-07_JPRB, 0.36699685E-07_JPRB, 0.36823739E-07_JPRB, 0.36989849E-07_JPRB, 0.37271160E-07_JPRB, &
  & 0.37569599E-07_JPRB, 0.37939895E-07_JPRB, 0.38374587E-07_JPRB, 0.38877342E-07_JPRB, 0.39457120E-07_JPRB, 0.40109185E-07_JPRB, &
  & 0.40819476E-07_JPRB, 0.41553818E-07_JPRB, 0.42287628E-07_JPRB, 0.42957961E-07_JPRB, 0.43502844E-07_JPRB, 0.43956369E-07_JPRB, &
  & 0.44241684E-07_JPRB, 0.44414691E-07_JPRB, 0.44692474E-07_JPRB, 0.44819007E-07_JPRB, 0.45140041E-07_JPRB, 0.45474604E-07_JPRB, &
  & 0.45965248E-07_JPRB, 0.46497931E-07_JPRB, 0.47126694E-07_JPRB, 0.47761425E-07_JPRB, 0.48437649E-07_JPRB, 0.49156164E-07_JPRB, &
  & 0.49911140E-07_JPRB, 0.50674544E-07_JPRB, 0.51442250E-07_JPRB, 0.52215164E-07_JPRB, 0.53013615E-07_JPRB, 0.53837354E-07_JPRB, &
  & 0.54663253E-07_JPRB, 0.55464174E-07_JPRB, 0.56250020E-07_JPRB, 0.57025076E-07_JPRB, 0.57794971E-07_JPRB, 0.58553098E-07_JPRB, &
  & 0.59287473E-07_JPRB, 0.59993148E-07_JPRB, 0.60659566E-07_JPRB, 0.61304604E-07_JPRB, 0.61889637E-07_JPRB, 0.62451988E-07_JPRB, &
  & 0.62965526E-07_JPRB, 0.63476733E-07_JPRB, 0.63988416E-07_JPRB, 0.64443626E-07_JPRB, 0.64843036E-07_JPRB, 0.65148193E-07_JPRB, &
  & 0.65438961E-07_JPRB, 0.65675614E-07_JPRB, 0.65871156E-07_JPRB, 0.66482791E-07_JPRB /)

RGHG7(:,79, 8) = (/ &
  & 0.39286121E-07_JPRB, 0.36617152E-07_JPRB, 0.35912478E-07_JPRB, 0.35748542E-07_JPRB, 0.35711569E-07_JPRB, 0.35714105E-07_JPRB, &
  & 0.35755711E-07_JPRB, 0.35852032E-07_JPRB, 0.35988236E-07_JPRB, 0.36168188E-07_JPRB, 0.36438102E-07_JPRB, 0.36708418E-07_JPRB, &
  & 0.37070137E-07_JPRB, 0.37466688E-07_JPRB, 0.37919683E-07_JPRB, 0.38429167E-07_JPRB, 0.38992031E-07_JPRB, 0.39616307E-07_JPRB, &
  & 0.40288199E-07_JPRB, 0.40978662E-07_JPRB, 0.41674532E-07_JPRB, 0.42335451E-07_JPRB, 0.42923574E-07_JPRB, 0.43462716E-07_JPRB, &
  & 0.43839130E-07_JPRB, 0.44252062E-07_JPRB, 0.44668315E-07_JPRB, 0.44950113E-07_JPRB, 0.45459480E-07_JPRB, 0.45855838E-07_JPRB, &
  & 0.46445432E-07_JPRB, 0.47043418E-07_JPRB, 0.47707619E-07_JPRB, 0.48382997E-07_JPRB, 0.49085209E-07_JPRB, 0.49828650E-07_JPRB, &
  & 0.50603095E-07_JPRB, 0.51389247E-07_JPRB, 0.52175036E-07_JPRB, 0.52963621E-07_JPRB, 0.53757432E-07_JPRB, 0.54558559E-07_JPRB, &
  & 0.55347439E-07_JPRB, 0.56115848E-07_JPRB, 0.56860479E-07_JPRB, 0.57597376E-07_JPRB, 0.58322030E-07_JPRB, 0.59025176E-07_JPRB, &
  & 0.59712789E-07_JPRB, 0.60359717E-07_JPRB, 0.60989038E-07_JPRB, 0.61569743E-07_JPRB, 0.62131448E-07_JPRB, 0.62634918E-07_JPRB, &
  & 0.63121078E-07_JPRB, 0.63576216E-07_JPRB, 0.64035049E-07_JPRB, 0.64431184E-07_JPRB, 0.64778085E-07_JPRB, 0.65042848E-07_JPRB, &
  & 0.65298657E-07_JPRB, 0.65496636E-07_JPRB, 0.65613129E-07_JPRB, 0.66088973E-07_JPRB /)

RGHG7(:,80, 8) = (/ &
  & 0.37401652E-07_JPRB, 0.35720756E-07_JPRB, 0.35266893E-07_JPRB, 0.35272173E-07_JPRB, 0.35292626E-07_JPRB, 0.35315498E-07_JPRB, &
  & 0.35390016E-07_JPRB, 0.35505025E-07_JPRB, 0.35669824E-07_JPRB, 0.35886909E-07_JPRB, 0.36156791E-07_JPRB, 0.36492402E-07_JPRB, &
  & 0.36846586E-07_JPRB, 0.37255674E-07_JPRB, 0.37713392E-07_JPRB, 0.38226403E-07_JPRB, 0.38798433E-07_JPRB, 0.39407695E-07_JPRB, &
  & 0.40070404E-07_JPRB, 0.40746222E-07_JPRB, 0.41429104E-07_JPRB, 0.42082139E-07_JPRB, 0.42697000E-07_JPRB, 0.43251145E-07_JPRB, &
  & 0.43657071E-07_JPRB, 0.44226979E-07_JPRB, 0.44569326E-07_JPRB, 0.45061967E-07_JPRB, 0.45526043E-07_JPRB, 0.46068152E-07_JPRB, &
  & 0.46641006E-07_JPRB, 0.47289905E-07_JPRB, 0.47956739E-07_JPRB, 0.48653519E-07_JPRB, 0.49370108E-07_JPRB, 0.50127923E-07_JPRB, &
  & 0.50917130E-07_JPRB, 0.51711119E-07_JPRB, 0.52507737E-07_JPRB, 0.53296802E-07_JPRB, 0.54089874E-07_JPRB, 0.54880175E-07_JPRB, &
  & 0.55650819E-07_JPRB, 0.56396864E-07_JPRB, 0.57127501E-07_JPRB, 0.57844172E-07_JPRB, 0.58557571E-07_JPRB, 0.59234434E-07_JPRB, &
  & 0.59901630E-07_JPRB, 0.60525927E-07_JPRB, 0.61129789E-07_JPRB, 0.61692567E-07_JPRB, 0.62234548E-07_JPRB, 0.62716047E-07_JPRB, &
  & 0.63190853E-07_JPRB, 0.63622963E-07_JPRB, 0.64053943E-07_JPRB, 0.64424398E-07_JPRB, 0.64765942E-07_JPRB, 0.64992797E-07_JPRB, &
  & 0.65251321E-07_JPRB, 0.65430960E-07_JPRB, 0.65510072E-07_JPRB, 0.65865194E-07_JPRB /)

RGHG7(:,81, 8) = (/ &
  & 0.36167538E-07_JPRB, 0.35272130E-07_JPRB, 0.34929961E-07_JPRB, 0.35056772E-07_JPRB, 0.35043723E-07_JPRB, 0.35086604E-07_JPRB, &
  & 0.35200646E-07_JPRB, 0.35356557E-07_JPRB, 0.35523481E-07_JPRB, 0.35780740E-07_JPRB, 0.36054100E-07_JPRB, 0.36370960E-07_JPRB, &
  & 0.36742701E-07_JPRB, 0.37161655E-07_JPRB, 0.37626481E-07_JPRB, 0.38133766E-07_JPRB, 0.38691805E-07_JPRB, 0.39295735E-07_JPRB, &
  & 0.39944663E-07_JPRB, 0.40610391E-07_JPRB, 0.41289610E-07_JPRB, 0.41940876E-07_JPRB, 0.42579327E-07_JPRB, 0.43114305E-07_JPRB, &
  & 0.43603666E-07_JPRB, 0.44195644E-07_JPRB, 0.44518103E-07_JPRB, 0.45130896E-07_JPRB, 0.45543196E-07_JPRB, 0.46152060E-07_JPRB, &
  & 0.46718082E-07_JPRB, 0.47387520E-07_JPRB, 0.48062201E-07_JPRB, 0.48765777E-07_JPRB, 0.49490904E-07_JPRB, 0.50250872E-07_JPRB, &
  & 0.51042782E-07_JPRB, 0.51849579E-07_JPRB, 0.52650670E-07_JPRB, 0.53447302E-07_JPRB, 0.54236896E-07_JPRB, 0.55015771E-07_JPRB, &
  & 0.55779115E-07_JPRB, 0.56518761E-07_JPRB, 0.57241344E-07_JPRB, 0.57956111E-07_JPRB, 0.58648823E-07_JPRB, 0.59342241E-07_JPRB, &
  & 0.59969132E-07_JPRB, 0.60615058E-07_JPRB, 0.61183755E-07_JPRB, 0.61749773E-07_JPRB, 0.62283725E-07_JPRB, 0.62750125E-07_JPRB, &
  & 0.63229130E-07_JPRB, 0.63639035E-07_JPRB, 0.64070342E-07_JPRB, 0.64415822E-07_JPRB, 0.64765310E-07_JPRB, 0.64969747E-07_JPRB, &
  & 0.65214671E-07_JPRB, 0.65407256E-07_JPRB, 0.65431777E-07_JPRB, 0.65705422E-07_JPRB /)

RGHG7(:,82, 8) = (/ &
  & 0.35322163E-07_JPRB, 0.35037392E-07_JPRB, 0.34817425E-07_JPRB, 0.35027199E-07_JPRB, 0.34932750E-07_JPRB, 0.35035747E-07_JPRB, &
  & 0.35156294E-07_JPRB, 0.35269174E-07_JPRB, 0.35498999E-07_JPRB, 0.35686341E-07_JPRB, 0.36006870E-07_JPRB, 0.36321076E-07_JPRB, &
  & 0.36705551E-07_JPRB, 0.37118252E-07_JPRB, 0.37576076E-07_JPRB, 0.38090352E-07_JPRB, 0.38652793E-07_JPRB, 0.39252708E-07_JPRB, &
  & 0.39894399E-07_JPRB, 0.40559396E-07_JPRB, 0.41232948E-07_JPRB, 0.41880593E-07_JPRB, 0.42525599E-07_JPRB, 0.43034206E-07_JPRB, &
  & 0.43630848E-07_JPRB, 0.44098627E-07_JPRB, 0.44562160E-07_JPRB, 0.45098773E-07_JPRB, 0.45589672E-07_JPRB, 0.46162928E-07_JPRB, &
  & 0.46767390E-07_JPRB, 0.47422350E-07_JPRB, 0.48110032E-07_JPRB, 0.48814343E-07_JPRB, 0.49550426E-07_JPRB, 0.50326641E-07_JPRB, &
  & 0.51131359E-07_JPRB, 0.51932748E-07_JPRB, 0.52733295E-07_JPRB, 0.53523284E-07_JPRB, 0.54307261E-07_JPRB, 0.55087014E-07_JPRB, &
  & 0.55836981E-07_JPRB, 0.56573850E-07_JPRB, 0.57293775E-07_JPRB, 0.58015413E-07_JPRB, 0.58677699E-07_JPRB, 0.59418369E-07_JPRB, &
  & 0.59982270E-07_JPRB, 0.60679220E-07_JPRB, 0.61196346E-07_JPRB, 0.61789898E-07_JPRB, 0.62305119E-07_JPRB, 0.62762780E-07_JPRB, &
  & 0.63260288E-07_JPRB, 0.63639561E-07_JPRB, 0.64101123E-07_JPRB, 0.64395806E-07_JPRB, 0.64782519E-07_JPRB, 0.64963004E-07_JPRB, &
  & 0.65197099E-07_JPRB, 0.65416586E-07_JPRB, 0.65406674E-07_JPRB, 0.65645089E-07_JPRB /)

RGHG7(:,83, 8) = (/ &
  & 0.35327457E-07_JPRB, 0.34887975E-07_JPRB, 0.34820616E-07_JPRB, 0.34980644E-07_JPRB, 0.34815685E-07_JPRB, 0.35008309E-07_JPRB, &
  & 0.35073985E-07_JPRB, 0.35266808E-07_JPRB, 0.35416619E-07_JPRB, 0.35716010E-07_JPRB, 0.35948073E-07_JPRB, 0.36305181E-07_JPRB, &
  & 0.36646359E-07_JPRB, 0.37079591E-07_JPRB, 0.37550851E-07_JPRB, 0.38053791E-07_JPRB, 0.38610473E-07_JPRB, 0.39205982E-07_JPRB, &
  & 0.39847091E-07_JPRB, 0.40507139E-07_JPRB, 0.41177785E-07_JPRB, 0.41830280E-07_JPRB, 0.42459106E-07_JPRB, 0.42998174E-07_JPRB, &
  & 0.43617113E-07_JPRB, 0.44026489E-07_JPRB, 0.44606200E-07_JPRB, 0.45059103E-07_JPRB, 0.45616140E-07_JPRB, 0.46167461E-07_JPRB, &
  & 0.46785065E-07_JPRB, 0.47439023E-07_JPRB, 0.48130758E-07_JPRB, 0.48841958E-07_JPRB, 0.49571742E-07_JPRB, 0.50330712E-07_JPRB, &
  & 0.51136464E-07_JPRB, 0.51963674E-07_JPRB, 0.52776613E-07_JPRB, 0.53569025E-07_JPRB, 0.54353222E-07_JPRB, 0.55115216E-07_JPRB, &
  & 0.55876388E-07_JPRB, 0.56600090E-07_JPRB, 0.57326105E-07_JPRB, 0.58054990E-07_JPRB, 0.58688226E-07_JPRB, 0.59466384E-07_JPRB, &
  & 0.59977872E-07_JPRB, 0.60729235E-07_JPRB, 0.61191940E-07_JPRB, 0.61826633E-07_JPRB, 0.62305453E-07_JPRB, 0.62784466E-07_JPRB, &
  & 0.63276850E-07_JPRB, 0.63632221E-07_JPRB, 0.64127775E-07_JPRB, 0.64382277E-07_JPRB, 0.64776664E-07_JPRB, 0.64980306E-07_JPRB, &
  & 0.65156627E-07_JPRB, 0.65438485E-07_JPRB, 0.65371140E-07_JPRB, 0.65671735E-07_JPRB /)

RGHG7(:,84, 8) = (/ &
  & 0.35346837E-07_JPRB, 0.34727300E-07_JPRB, 0.34902182E-07_JPRB, 0.34899056E-07_JPRB, 0.34782794E-07_JPRB, 0.35029657E-07_JPRB, &
  & 0.35054732E-07_JPRB, 0.35246000E-07_JPRB, 0.35471675E-07_JPRB, 0.35650189E-07_JPRB, 0.35981209E-07_JPRB, 0.36263753E-07_JPRB, &
  & 0.36681453E-07_JPRB, 0.37091276E-07_JPRB, 0.37524877E-07_JPRB, 0.38027768E-07_JPRB, 0.38585558E-07_JPRB, 0.39185114E-07_JPRB, &
  & 0.39815696E-07_JPRB, 0.40482078E-07_JPRB, 0.41137049E-07_JPRB, 0.41791054E-07_JPRB, 0.42408502E-07_JPRB, 0.42993221E-07_JPRB, &
  & 0.43547413E-07_JPRB, 0.44038348E-07_JPRB, 0.44566022E-07_JPRB, 0.45059060E-07_JPRB, 0.45611671E-07_JPRB, 0.46168328E-07_JPRB, &
  & 0.46790813E-07_JPRB, 0.47443557E-07_JPRB, 0.48136265E-07_JPRB, 0.48844086E-07_JPRB, 0.49611831E-07_JPRB, 0.50424710E-07_JPRB, &
  & 0.51229737E-07_JPRB, 0.52021072E-07_JPRB, 0.52816489E-07_JPRB, 0.53607515E-07_JPRB, 0.54378908E-07_JPRB, 0.55153485E-07_JPRB, &
  & 0.55882882E-07_JPRB, 0.56631698E-07_JPRB, 0.57325945E-07_JPRB, 0.58082936E-07_JPRB, 0.58697616E-07_JPRB, 0.59481966E-07_JPRB, &
  & 0.59978774E-07_JPRB, 0.60760904E-07_JPRB, 0.61184736E-07_JPRB, 0.61857762E-07_JPRB, 0.62292997E-07_JPRB, 0.62815971E-07_JPRB, &
  & 0.63266000E-07_JPRB, 0.63657744E-07_JPRB, 0.64119092E-07_JPRB, 0.64413442E-07_JPRB, 0.64742324E-07_JPRB, 0.65026626E-07_JPRB, &
  & 0.65110562E-07_JPRB, 0.65473536E-07_JPRB, 0.65346214E-07_JPRB, 0.65665418E-07_JPRB /)

RGHG7(:,85, 8) = (/ &
  & 0.35365467E-07_JPRB, 0.34596724E-07_JPRB, 0.35008068E-07_JPRB, 0.34767400E-07_JPRB, 0.34806725E-07_JPRB, 0.35011489E-07_JPRB, &
  & 0.35018115E-07_JPRB, 0.35311100E-07_JPRB, 0.35418076E-07_JPRB, 0.35744765E-07_JPRB, 0.35961055E-07_JPRB, 0.36302453E-07_JPRB, &
  & 0.36633981E-07_JPRB, 0.36994749E-07_JPRB, 0.37475669E-07_JPRB, 0.37990645E-07_JPRB, 0.38529368E-07_JPRB, 0.39133550E-07_JPRB, &
  & 0.39771173E-07_JPRB, 0.40433065E-07_JPRB, 0.41085627E-07_JPRB, 0.41754436E-07_JPRB, 0.42362458E-07_JPRB, 0.42959066E-07_JPRB, &
  & 0.43493372E-07_JPRB, 0.44020965E-07_JPRB, 0.44528559E-07_JPRB, 0.45050673E-07_JPRB, 0.45585224E-07_JPRB, 0.46168868E-07_JPRB, &
  & 0.46778464E-07_JPRB, 0.47442612E-07_JPRB, 0.48143917E-07_JPRB, 0.48864447E-07_JPRB, 0.49543427E-07_JPRB, 0.50274835E-07_JPRB, &
  & 0.51132830E-07_JPRB, 0.52014663E-07_JPRB, 0.52841859E-07_JPRB, 0.53632625E-07_JPRB, 0.54410474E-07_JPRB, 0.55160839E-07_JPRB, &
  & 0.55926581E-07_JPRB, 0.56634708E-07_JPRB, 0.57369359E-07_JPRB, 0.58073926E-07_JPRB, 0.58737420E-07_JPRB, 0.59466412E-07_JPRB, &
  & 0.60000737E-07_JPRB, 0.60767910E-07_JPRB, 0.61182639E-07_JPRB, 0.61878858E-07_JPRB, 0.62276783E-07_JPRB, 0.62860089E-07_JPRB, &
  & 0.63229614E-07_JPRB, 0.63716442E-07_JPRB, 0.64063073E-07_JPRB, 0.64483295E-07_JPRB, 0.64669869E-07_JPRB, 0.65097282E-07_JPRB, &
  & 0.65050003E-07_JPRB, 0.65507344E-07_JPRB, 0.65318453E-07_JPRB, 0.65679494E-07_JPRB /)

RGHG7(:,86, 8) = (/ &
  & 0.35308343E-07_JPRB, 0.34507643E-07_JPRB, 0.35093791E-07_JPRB, 0.34641438E-07_JPRB, 0.34892185E-07_JPRB, 0.34975038E-07_JPRB, &
  & 0.35069299E-07_JPRB, 0.35340815E-07_JPRB, 0.35520468E-07_JPRB, 0.35754990E-07_JPRB, 0.36031434E-07_JPRB, 0.36322046E-07_JPRB, &
  & 0.36678230E-07_JPRB, 0.37092121E-07_JPRB, 0.37527101E-07_JPRB, 0.37923407E-07_JPRB, 0.38478746E-07_JPRB, 0.39067356E-07_JPRB, &
  & 0.39708258E-07_JPRB, 0.40379994E-07_JPRB, 0.41049216E-07_JPRB, 0.41711353E-07_JPRB, 0.42316930E-07_JPRB, 0.42910777E-07_JPRB, &
  & 0.43455380E-07_JPRB, 0.43985530E-07_JPRB, 0.44488132E-07_JPRB, 0.45014424E-07_JPRB, 0.45567990E-07_JPRB, 0.46140329E-07_JPRB, &
  & 0.46774666E-07_JPRB, 0.47432742E-07_JPRB, 0.48105004E-07_JPRB, 0.48846950E-07_JPRB, 0.49749300E-07_JPRB, 0.50606552E-07_JPRB, &
  & 0.51325955E-07_JPRB, 0.52057679E-07_JPRB, 0.52864582E-07_JPRB, 0.53651341E-07_JPRB, 0.54434658E-07_JPRB, 0.55204723E-07_JPRB, &
  & 0.55930954E-07_JPRB, 0.56685085E-07_JPRB, 0.57368208E-07_JPRB, 0.58097729E-07_JPRB, 0.58761614E-07_JPRB, 0.59449548E-07_JPRB, &
  & 0.60029308E-07_JPRB, 0.60753962E-07_JPRB, 0.61186178E-07_JPRB, 0.61885530E-07_JPRB, 0.62266672E-07_JPRB, 0.62891175E-07_JPRB, &
  & 0.63194044E-07_JPRB, 0.63780483E-07_JPRB, 0.63999117E-07_JPRB, 0.64569214E-07_JPRB, 0.64596684E-07_JPRB, 0.65161721E-07_JPRB, &
  & 0.65012728E-07_JPRB, 0.65530834E-07_JPRB, 0.65302451E-07_JPRB, 0.65688781E-07_JPRB /)

RGHG7(:,87, 8) = (/ &
  & 0.35103383E-07_JPRB, 0.34459351E-07_JPRB, 0.35135141E-07_JPRB, 0.34553654E-07_JPRB, 0.34980470E-07_JPRB, 0.34914251E-07_JPRB, &
  & 0.35135571E-07_JPRB, 0.35398241E-07_JPRB, 0.35507316E-07_JPRB, 0.35859031E-07_JPRB, 0.36033391E-07_JPRB, 0.36365456E-07_JPRB, &
  & 0.36656473E-07_JPRB, 0.36980886E-07_JPRB, 0.37328114E-07_JPRB, 0.37876760E-07_JPRB, 0.38423732E-07_JPRB, 0.38978730E-07_JPRB, &
  & 0.39636056E-07_JPRB, 0.40316646E-07_JPRB, 0.40996888E-07_JPRB, 0.41658740E-07_JPRB, 0.42277623E-07_JPRB, 0.42868848E-07_JPRB, &
  & 0.43417216E-07_JPRB, 0.43938485E-07_JPRB, 0.44455021E-07_JPRB, 0.44987129E-07_JPRB, 0.45536812E-07_JPRB, 0.46131913E-07_JPRB, &
  & 0.46753463E-07_JPRB, 0.47452470E-07_JPRB, 0.48199190E-07_JPRB, 0.48806903E-07_JPRB, 0.49294250E-07_JPRB, 0.50044328E-07_JPRB, &
  & 0.51076448E-07_JPRB, 0.52047007E-07_JPRB, 0.52871510E-07_JPRB, 0.53676484E-07_JPRB, 0.54458550E-07_JPRB, 0.55222433E-07_JPRB, &
  & 0.55995315E-07_JPRB, 0.56704209E-07_JPRB, 0.57423282E-07_JPRB, 0.58108736E-07_JPRB, 0.58776155E-07_JPRB, 0.59445249E-07_JPRB, &
  & 0.60052407E-07_JPRB, 0.60720041E-07_JPRB, 0.61199550E-07_JPRB, 0.61870949E-07_JPRB, 0.62271617E-07_JPRB, 0.62897456E-07_JPRB, &
  & 0.63185688E-07_JPRB, 0.63806439E-07_JPRB, 0.63974177E-07_JPRB, 0.64600080E-07_JPRB, 0.64577726E-07_JPRB, 0.65171854E-07_JPRB, &
  & 0.65012678E-07_JPRB, 0.65527956E-07_JPRB, 0.65300199E-07_JPRB, 0.65694820E-07_JPRB /)

RGHG7(:,88, 8) = (/ &
  & 0.35132764E-07_JPRB, 0.34513345E-07_JPRB, 0.35128359E-07_JPRB, 0.34530810E-07_JPRB, 0.35038646E-07_JPRB, 0.34841300E-07_JPRB, &
  & 0.35235068E-07_JPRB, 0.35317601E-07_JPRB, 0.35616392E-07_JPRB, 0.35801339E-07_JPRB, 0.36057543E-07_JPRB, 0.36334246E-07_JPRB, &
  & 0.36681044E-07_JPRB, 0.37085876E-07_JPRB, 0.37486814E-07_JPRB, 0.37846760E-07_JPRB, 0.38321467E-07_JPRB, 0.38850640E-07_JPRB, &
  & 0.39584346E-07_JPRB, 0.40258382E-07_JPRB, 0.40961282E-07_JPRB, 0.41614594E-07_JPRB, 0.42244601E-07_JPRB, 0.42826542E-07_JPRB, &
  & 0.43375618E-07_JPRB, 0.43900855E-07_JPRB, 0.44414403E-07_JPRB, 0.44942450E-07_JPRB, 0.45502286E-07_JPRB, 0.46097608E-07_JPRB, &
  & 0.46729099E-07_JPRB, 0.47337007E-07_JPRB, 0.48055426E-07_JPRB, 0.49079080E-07_JPRB, 0.50175299E-07_JPRB, 0.50924410E-07_JPRB, &
  & 0.51401013E-07_JPRB, 0.52066717E-07_JPRB, 0.52889625E-07_JPRB, 0.53689206E-07_JPRB, 0.54482044E-07_JPRB, 0.55266192E-07_JPRB, &
  & 0.56007629E-07_JPRB, 0.56763540E-07_JPRB, 0.57438776E-07_JPRB, 0.58142383E-07_JPRB, 0.58791393E-07_JPRB, 0.59447022E-07_JPRB, &
  & 0.60066675E-07_JPRB, 0.60697410E-07_JPRB, 0.61212951E-07_JPRB, 0.61850145E-07_JPRB, 0.62284997E-07_JPRB, 0.62882904E-07_JPRB, &
  & 0.63203814E-07_JPRB, 0.63797387E-07_JPRB, 0.63994960E-07_JPRB, 0.64586239E-07_JPRB, 0.64603739E-07_JPRB, 0.65151646E-07_JPRB, &
  & 0.65036474E-07_JPRB, 0.65514762E-07_JPRB, 0.65311362E-07_JPRB, 0.65688766E-07_JPRB /)

RGHG7(:,89, 8) = (/ &
  & 0.35221412E-07_JPRB, 0.34543444E-07_JPRB, 0.35058985E-07_JPRB, 0.34566956E-07_JPRB, 0.34983909E-07_JPRB, 0.34822079E-07_JPRB, &
  & 0.35172292E-07_JPRB, 0.35284565E-07_JPRB, 0.35512855E-07_JPRB, 0.35713356E-07_JPRB, 0.35989775E-07_JPRB, 0.36249414E-07_JPRB, &
  & 0.36505067E-07_JPRB, 0.36798127E-07_JPRB, 0.37337220E-07_JPRB, 0.37697294E-07_JPRB, 0.38342108E-07_JPRB, 0.39029917E-07_JPRB, &
  & 0.39680337E-07_JPRB, 0.40265363E-07_JPRB, 0.40913360E-07_JPRB, 0.41565194E-07_JPRB, 0.42194351E-07_JPRB, 0.42774651E-07_JPRB, &
  & 0.43324413E-07_JPRB, 0.43845827E-07_JPRB, 0.44357900E-07_JPRB, 0.44884708E-07_JPRB, 0.45437059E-07_JPRB, 0.46060251E-07_JPRB, &
  & 0.46779718E-07_JPRB, 0.47500144E-07_JPRB, 0.48004388E-07_JPRB, 0.48287450E-07_JPRB, 0.48739505E-07_JPRB, 0.49688882E-07_JPRB, &
  & 0.51049621E-07_JPRB, 0.52075386E-07_JPRB, 0.52903605E-07_JPRB, 0.53712167E-07_JPRB, 0.54519663E-07_JPRB, 0.55293864E-07_JPRB, &
  & 0.56076878E-07_JPRB, 0.56781452E-07_JPRB, 0.57496166E-07_JPRB, 0.58146831E-07_JPRB, 0.58822742E-07_JPRB, 0.59447522E-07_JPRB, &
  & 0.60078690E-07_JPRB, 0.60685039E-07_JPRB, 0.61224398E-07_JPRB, 0.61829411E-07_JPRB, 0.62304629E-07_JPRB, 0.62866391E-07_JPRB, &
  & 0.63234950E-07_JPRB, 0.63775936E-07_JPRB, 0.64036904E-07_JPRB, 0.64555145E-07_JPRB, 0.64646585E-07_JPRB, 0.65123970E-07_JPRB, &
  & 0.65063844E-07_JPRB, 0.65499876E-07_JPRB, 0.65325636E-07_JPRB, 0.65681888E-07_JPRB /)

RGHG7(:,90, 8) = (/ &
  & 0.35328043E-07_JPRB, 0.34704946E-07_JPRB, 0.34952897E-07_JPRB, 0.34709284E-07_JPRB, 0.34842056E-07_JPRB, 0.34881399E-07_JPRB, &
  & 0.35016065E-07_JPRB, 0.35160895E-07_JPRB, 0.35348602E-07_JPRB, 0.35572516E-07_JPRB, 0.36112688E-07_JPRB, 0.36168409E-07_JPRB, &
  & 0.36289300E-07_JPRB, 0.36753875E-07_JPRB, 0.37945931E-07_JPRB, 0.38024009E-07_JPRB, 0.38473672E-07_JPRB, 0.38781074E-07_JPRB, &
  & 0.39205414E-07_JPRB, 0.39913441E-07_JPRB, 0.40738705E-07_JPRB, 0.41486711E-07_JPRB, 0.42134292E-07_JPRB, 0.42712973E-07_JPRB, &
  & 0.43248654E-07_JPRB, 0.43764274E-07_JPRB, 0.44273669E-07_JPRB, 0.44748916E-07_JPRB, 0.45252325E-07_JPRB, 0.45859625E-07_JPRB, &
  & 0.46553350E-07_JPRB, 0.47428497E-07_JPRB, 0.48519901E-07_JPRB, 0.49675464E-07_JPRB, 0.50632842E-07_JPRB, 0.51221406E-07_JPRB, &
  & 0.51414073E-07_JPRB, 0.52098482E-07_JPRB, 0.52947104E-07_JPRB, 0.53762005E-07_JPRB, 0.54564648E-07_JPRB, 0.55344792E-07_JPRB, &
  & 0.56100820E-07_JPRB, 0.56829460E-07_JPRB, 0.57520342E-07_JPRB, 0.58160939E-07_JPRB, 0.58838289E-07_JPRB, 0.59464718E-07_JPRB, &
  & 0.60083600E-07_JPRB, 0.60696188E-07_JPRB, 0.61235561E-07_JPRB, 0.61824046E-07_JPRB, 0.62328219E-07_JPRB, 0.62858781E-07_JPRB, &
  & 0.63270811E-07_JPRB, 0.63760204E-07_JPRB, 0.64087388E-07_JPRB, 0.64529665E-07_JPRB, 0.64699066E-07_JPRB, 0.65095925E-07_JPRB, &
  & 0.65107997E-07_JPRB, 0.65475255E-07_JPRB, 0.65357824E-07_JPRB, 0.65665986E-07_JPRB /)

RGHG7(:,91, 8) = (/ &
  & 0.35580648E-07_JPRB, 0.34784609E-07_JPRB, 0.34846437E-07_JPRB, 0.34777923E-07_JPRB, 0.34772643E-07_JPRB, 0.34812608E-07_JPRB, &
  & 0.15835674E-07_JPRB, 0.27039590E-07_JPRB, 0.34248966E-07_JPRB, 0.40385821E-07_JPRB, 0.46700322E-07_JPRB, 0.44461064E-07_JPRB, &
  & 0.35981419E-07_JPRB, 0.29243195E-07_JPRB, 0.39527759E-07_JPRB, 0.37405066E-07_JPRB, 0.37867558E-07_JPRB, 0.39079900E-07_JPRB, &
  & 0.39742766E-07_JPRB, 0.40457220E-07_JPRB, 0.40978197E-07_JPRB, 0.41456861E-07_JPRB, 0.41991459E-07_JPRB, 0.42551292E-07_JPRB, &
  & 0.43095604E-07_JPRB, 0.43620663E-07_JPRB, 0.44131024E-07_JPRB, 0.44730832E-07_JPRB, 0.45376897E-07_JPRB, 0.45908024E-07_JPRB, &
  & 0.46403297E-07_JPRB, 0.46928591E-07_JPRB, 0.47492904E-07_JPRB, 0.48153854E-07_JPRB, 0.48917855E-07_JPRB, 0.49891415E-07_JPRB, &
  & 0.51179320E-07_JPRB, 0.52130527E-07_JPRB, 0.52987787E-07_JPRB, 0.53824095E-07_JPRB, 0.54625257E-07_JPRB, 0.55421761E-07_JPRB, &
  & 0.56143019E-07_JPRB, 0.56886176E-07_JPRB, 0.57569714E-07_JPRB, 0.58164645E-07_JPRB, 0.58850425E-07_JPRB, 0.59507272E-07_JPRB, &
  & 0.60083060E-07_JPRB, 0.60730109E-07_JPRB, 0.61249850E-07_JPRB, 0.61836388E-07_JPRB, 0.62365586E-07_JPRB, 0.62870718E-07_JPRB, &
  & 0.63309734E-07_JPRB, 0.63763295E-07_JPRB, 0.64144018E-07_JPRB, 0.64517856E-07_JPRB, 0.64766894E-07_JPRB, 0.65059474E-07_JPRB, &
  & 0.65186086E-07_JPRB, 0.65423286E-07_JPRB, 0.65434520E-07_JPRB, 0.65617584E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG7(:, 1, 9) = (/ &
  & 0.80489592E-07_JPRB, 0.75164188E-07_JPRB, 0.75511217E-07_JPRB, 0.75549067E-07_JPRB, 0.75394738E-07_JPRB, 0.74630428E-07_JPRB, &
  & 0.73642425E-07_JPRB, 0.71755480E-07_JPRB, 0.70294938E-07_JPRB, 0.69501567E-07_JPRB, 0.69212042E-07_JPRB, 0.69221635E-07_JPRB, &
  & 0.69434698E-07_JPRB, 0.69818221E-07_JPRB, 0.70139997E-07_JPRB, 0.70382654E-07_JPRB, 0.70546918E-07_JPRB, 0.70631970E-07_JPRB, &
  & 0.70637476E-07_JPRB, 0.70573535E-07_JPRB, 0.70432108E-07_JPRB, 0.70179219E-07_JPRB, 0.69929428E-07_JPRB, 0.69704086E-07_JPRB, &
  & 0.69415130E-07_JPRB, 0.69095805E-07_JPRB, 0.68782775E-07_JPRB, 0.68429294E-07_JPRB, 0.67992893E-07_JPRB, 0.67520716E-07_JPRB, &
  & 0.67160371E-07_JPRB, 0.67008514E-07_JPRB, 0.66945077E-07_JPRB, 0.67051502E-07_JPRB, 0.67285043E-07_JPRB, 0.67678741E-07_JPRB, &
  & 0.68140203E-07_JPRB, 0.68748861E-07_JPRB, 0.69319213E-07_JPRB, 0.69877643E-07_JPRB, 0.70224829E-07_JPRB, 0.70483821E-07_JPRB, &
  & 0.70536629E-07_JPRB, 0.70483026E-07_JPRB, 0.70343461E-07_JPRB, 0.70084610E-07_JPRB, 0.69862899E-07_JPRB, 0.69546836E-07_JPRB, &
  & 0.69347173E-07_JPRB, 0.69096068E-07_JPRB, 0.68930952E-07_JPRB, 0.68683484E-07_JPRB, 0.68523086E-07_JPRB, 0.68355590E-07_JPRB, &
  & 0.68270438E-07_JPRB, 0.68181158E-07_JPRB, 0.68151216E-07_JPRB, 0.68117252E-07_JPRB, 0.68214376E-07_JPRB, 0.68469951E-07_JPRB, &
  & 0.68827276E-07_JPRB, 0.69518116E-07_JPRB, 0.71631732E-07_JPRB, 0.60364218E-05_JPRB /)

RGHG7(:, 2, 9) = (/ &
  & 0.10702075E-05_JPRB, 0.11417412E-05_JPRB, 0.12199289E-05_JPRB, 0.12352770E-05_JPRB, 0.12139589E-05_JPRB, 0.11312768E-05_JPRB, &
  & 0.10132203E-05_JPRB, 0.80345058E-06_JPRB, 0.62288154E-06_JPRB, 0.50010374E-06_JPRB, 0.42216755E-06_JPRB, 0.37147922E-06_JPRB, &
  & 0.33608470E-06_JPRB, 0.30988792E-06_JPRB, 0.29032495E-06_JPRB, 0.27514184E-06_JPRB, 0.26323937E-06_JPRB, 0.25372975E-06_JPRB, &
  & 0.24629048E-06_JPRB, 0.24068933E-06_JPRB, 0.23691180E-06_JPRB, 0.23490043E-06_JPRB, 0.23428777E-06_JPRB, 0.23401563E-06_JPRB, &
  & 0.23314215E-06_JPRB, 0.23223130E-06_JPRB, 0.23080916E-06_JPRB, 0.22895013E-06_JPRB, 0.22690745E-06_JPRB, 0.22420637E-06_JPRB, &
  & 0.22240552E-06_JPRB, 0.22600507E-06_JPRB, 0.22426545E-06_JPRB, 0.22173002E-06_JPRB, 0.21895188E-06_JPRB, 0.21636701E-06_JPRB, &
  & 0.21446338E-06_JPRB, 0.21243299E-06_JPRB, 0.21029379E-06_JPRB, 0.20823408E-06_JPRB, 0.20601048E-06_JPRB, 0.20412207E-06_JPRB, &
  & 0.20259461E-06_JPRB, 0.20151960E-06_JPRB, 0.20093478E-06_JPRB, 0.20086043E-06_JPRB, 0.20070186E-06_JPRB, 0.20070371E-06_JPRB, &
  & 0.19985923E-06_JPRB, 0.19816643E-06_JPRB, 0.19522516E-06_JPRB, 0.19126408E-06_JPRB, 0.18575375E-06_JPRB, 0.17911987E-06_JPRB, &
  & 0.17131603E-06_JPRB, 0.16438068E-06_JPRB, 0.15571733E-06_JPRB, 0.14249413E-06_JPRB, 0.12788763E-06_JPRB, 0.11429958E-06_JPRB, &
  & 0.10245804E-06_JPRB, 0.95137587E-07_JPRB, 0.10349138E-06_JPRB, 0.39410947E-05_JPRB /)

RGHG7(:, 3, 9) = (/ &
  & 0.67970336E-05_JPRB, 0.38361222E-05_JPRB, 0.32701307E-05_JPRB, 0.28757556E-05_JPRB, 0.25650379E-05_JPRB, 0.21765989E-05_JPRB, &
  & 0.17919464E-05_JPRB, 0.13245497E-05_JPRB, 0.97972440E-06_JPRB, 0.78328117E-06_JPRB, 0.67774084E-06_JPRB, 0.61988050E-06_JPRB, &
  & 0.58427202E-06_JPRB, 0.55753571E-06_JPRB, 0.53462247E-06_JPRB, 0.51484784E-06_JPRB, 0.49813298E-06_JPRB, 0.48371794E-06_JPRB, &
  & 0.47156826E-06_JPRB, 0.46179593E-06_JPRB, 0.45447570E-06_JPRB, 0.44912994E-06_JPRB, 0.44511617E-06_JPRB, 0.44298909E-06_JPRB, &
  & 0.44309755E-06_JPRB, 0.44354962E-06_JPRB, 0.44218248E-06_JPRB, 0.43804809E-06_JPRB, 0.43219273E-06_JPRB, 0.42456244E-06_JPRB, &
  & 0.42487844E-06_JPRB, 0.43219470E-06_JPRB, 0.42917657E-06_JPRB, 0.42339144E-06_JPRB, 0.41694642E-06_JPRB, 0.41368685E-06_JPRB, &
  & 0.40895384E-06_JPRB, 0.40572567E-06_JPRB, 0.40244115E-06_JPRB, 0.39888852E-06_JPRB, 0.39463995E-06_JPRB, 0.39040427E-06_JPRB, &
  & 0.38651072E-06_JPRB, 0.38332442E-06_JPRB, 0.38052988E-06_JPRB, 0.37887006E-06_JPRB, 0.37623337E-06_JPRB, 0.37474342E-06_JPRB, &
  & 0.37094307E-06_JPRB, 0.36721295E-06_JPRB, 0.36035465E-06_JPRB, 0.35269917E-06_JPRB, 0.34094009E-06_JPRB, 0.32819386E-06_JPRB, &
  & 0.31456224E-06_JPRB, 0.30656275E-06_JPRB, 0.29686925E-06_JPRB, 0.28296870E-06_JPRB, 0.26637613E-06_JPRB, 0.25548792E-06_JPRB, &
  & 0.24581806E-06_JPRB, 0.23088549E-06_JPRB, 0.22562335E-06_JPRB, 0.22985475E-05_JPRB /)

RGHG7(:, 4, 9) = (/ &
  & 0.51779298E-05_JPRB, 0.16662730E-05_JPRB, 0.13760117E-05_JPRB, 0.12736439E-05_JPRB, 0.12213258E-05_JPRB, 0.11802189E-05_JPRB, &
  & 0.11994306E-05_JPRB, 0.10410134E-05_JPRB, 0.90676571E-06_JPRB, 0.86398347E-06_JPRB, 0.84878337E-06_JPRB, 0.83448799E-06_JPRB, &
  & 0.82039355E-06_JPRB, 0.81191621E-06_JPRB, 0.80444903E-06_JPRB, 0.79580462E-06_JPRB, 0.78855282E-06_JPRB, 0.78225179E-06_JPRB, &
  & 0.77705891E-06_JPRB, 0.77297136E-06_JPRB, 0.77036646E-06_JPRB, 0.76890075E-06_JPRB, 0.76825143E-06_JPRB, 0.76805168E-06_JPRB, &
  & 0.76608762E-06_JPRB, 0.76381951E-06_JPRB, 0.75813495E-06_JPRB, 0.75386964E-06_JPRB, 0.74754536E-06_JPRB, 0.73987565E-06_JPRB, &
  & 0.74522370E-06_JPRB, 0.76549287E-06_JPRB, 0.77138691E-06_JPRB, 0.76736694E-06_JPRB, 0.76004477E-06_JPRB, 0.75312118E-06_JPRB, &
  & 0.74403312E-06_JPRB, 0.73787703E-06_JPRB, 0.72960046E-06_JPRB, 0.72166438E-06_JPRB, 0.71172360E-06_JPRB, 0.70102232E-06_JPRB, &
  & 0.68993751E-06_JPRB, 0.67937367E-06_JPRB, 0.66796747E-06_JPRB, 0.65753431E-06_JPRB, 0.64445658E-06_JPRB, 0.63229118E-06_JPRB, &
  & 0.61652128E-06_JPRB, 0.60051184E-06_JPRB, 0.58162323E-06_JPRB, 0.56235325E-06_JPRB, 0.53935514E-06_JPRB, 0.51805421E-06_JPRB, &
  & 0.49618006E-06_JPRB, 0.48195807E-06_JPRB, 0.46022751E-06_JPRB, 0.43738982E-06_JPRB, 0.41383944E-06_JPRB, 0.39436969E-06_JPRB, &
  & 0.36431442E-06_JPRB, 0.33317397E-06_JPRB, 0.36564293E-06_JPRB, 0.15958267E-05_JPRB /)

RGHG7(:, 5, 9) = (/ &
  & 0.32674457E-05_JPRB, 0.28857726E-05_JPRB, 0.25805964E-05_JPRB, 0.21789315E-05_JPRB, 0.19430684E-05_JPRB, 0.15882028E-05_JPRB, &
  & 0.13403348E-05_JPRB, 0.11411329E-05_JPRB, 0.10250075E-05_JPRB, 0.99735939E-06_JPRB, 0.10107292E-05_JPRB, 0.10400958E-05_JPRB, &
  & 0.10607193E-05_JPRB, 0.10698949E-05_JPRB, 0.10789147E-05_JPRB, 0.10862020E-05_JPRB, 0.10915921E-05_JPRB, 0.10956020E-05_JPRB, &
  & 0.10991877E-05_JPRB, 0.11023925E-05_JPRB, 0.11058853E-05_JPRB, 0.11090367E-05_JPRB, 0.11125045E-05_JPRB, 0.11155245E-05_JPRB, &
  & 0.11170873E-05_JPRB, 0.11207799E-05_JPRB, 0.11181182E-05_JPRB, 0.11202128E-05_JPRB, 0.11123407E-05_JPRB, 0.11052405E-05_JPRB, &
  & 0.11126812E-05_JPRB, 0.11398731E-05_JPRB, 0.11494876E-05_JPRB, 0.11465849E-05_JPRB, 0.11388128E-05_JPRB, 0.11293424E-05_JPRB, &
  & 0.11182708E-05_JPRB, 0.11075992E-05_JPRB, 0.10946501E-05_JPRB, 0.10821253E-05_JPRB, 0.10661178E-05_JPRB, 0.10482192E-05_JPRB, &
  & 0.10292617E-05_JPRB, 0.10098747E-05_JPRB, 0.98918235E-06_JPRB, 0.96921974E-06_JPRB, 0.94608498E-06_JPRB, 0.92334852E-06_JPRB, &
  & 0.89870252E-06_JPRB, 0.87346120E-06_JPRB, 0.84704692E-06_JPRB, 0.82050047E-06_JPRB, 0.79239317E-06_JPRB, 0.76733261E-06_JPRB, &
  & 0.74275272E-06_JPRB, 0.73687073E-06_JPRB, 0.72671077E-06_JPRB, 0.72053484E-06_JPRB, 0.70674190E-06_JPRB, 0.69729089E-06_JPRB, &
  & 0.69415938E-06_JPRB, 0.68315234E-06_JPRB, 0.71685042E-06_JPRB, 0.11667935E-05_JPRB /)

RGHG7(:, 6, 9) = (/ &
  & 0.29395298E-05_JPRB, 0.18529450E-05_JPRB, 0.15183170E-05_JPRB, 0.13185645E-05_JPRB, 0.12497183E-05_JPRB, 0.12139329E-05_JPRB, &
  & 0.12128451E-05_JPRB, 0.12018434E-05_JPRB, 0.12245564E-05_JPRB, 0.12666635E-05_JPRB, 0.12921438E-05_JPRB, 0.13099267E-05_JPRB, &
  & 0.13379796E-05_JPRB, 0.13683449E-05_JPRB, 0.13921054E-05_JPRB, 0.14130841E-05_JPRB, 0.14328425E-05_JPRB, 0.14502027E-05_JPRB, &
  & 0.14655782E-05_JPRB, 0.14781003E-05_JPRB, 0.14886597E-05_JPRB, 0.14958912E-05_JPRB, 0.15016482E-05_JPRB, 0.15033390E-05_JPRB, &
  & 0.15045941E-05_JPRB, 0.15038238E-05_JPRB, 0.14991363E-05_JPRB, 0.15009247E-05_JPRB, 0.14910939E-05_JPRB, 0.14902228E-05_JPRB, &
  & 0.14985247E-05_JPRB, 0.15313424E-05_JPRB, 0.15420657E-05_JPRB, 0.15404271E-05_JPRB, 0.15339967E-05_JPRB, 0.15258727E-05_JPRB, &
  & 0.15165616E-05_JPRB, 0.15066656E-05_JPRB, 0.14950242E-05_JPRB, 0.14836486E-05_JPRB, 0.14677227E-05_JPRB, 0.14486709E-05_JPRB, &
  & 0.14269398E-05_JPRB, 0.14028233E-05_JPRB, 0.13767793E-05_JPRB, 0.13495725E-05_JPRB, 0.13196599E-05_JPRB, 0.12902547E-05_JPRB, &
  & 0.12591515E-05_JPRB, 0.12278646E-05_JPRB, 0.11955149E-05_JPRB, 0.11643400E-05_JPRB, 0.11328443E-05_JPRB, 0.11083597E-05_JPRB, &
  & 0.10894573E-05_JPRB, 0.10821087E-05_JPRB, 0.10535862E-05_JPRB, 0.10310862E-05_JPRB, 0.10182895E-05_JPRB, 0.10154969E-05_JPRB, &
  & 0.99648958E-06_JPRB, 0.94099926E-06_JPRB, 0.95925407E-06_JPRB, 0.10951373E-05_JPRB /)

RGHG7(:, 7, 9) = (/ &
  & 0.27619842E-05_JPRB, 0.25314073E-05_JPRB, 0.24275287E-05_JPRB, 0.21823182E-05_JPRB, 0.19451047E-05_JPRB, 0.17686643E-05_JPRB, &
  & 0.16784170E-05_JPRB, 0.16304608E-05_JPRB, 0.16119453E-05_JPRB, 0.16285975E-05_JPRB, 0.16700657E-05_JPRB, 0.17162654E-05_JPRB, &
  & 0.17513231E-05_JPRB, 0.17842374E-05_JPRB, 0.18179510E-05_JPRB, 0.18475072E-05_JPRB, 0.18736187E-05_JPRB, 0.18967070E-05_JPRB, &
  & 0.19179470E-05_JPRB, 0.19364902E-05_JPRB, 0.19533445E-05_JPRB, 0.19662129E-05_JPRB, 0.19771046E-05_JPRB, 0.19822062E-05_JPRB, &
  & 0.19872300E-05_JPRB, 0.19867509E-05_JPRB, 0.19871302E-05_JPRB, 0.19874039E-05_JPRB, 0.19802740E-05_JPRB, 0.19819145E-05_JPRB, &
  & 0.19889603E-05_JPRB, 0.20245841E-05_JPRB, 0.20332002E-05_JPRB, 0.20311518E-05_JPRB, 0.20253610E-05_JPRB, 0.20184809E-05_JPRB, &
  & 0.20107259E-05_JPRB, 0.20023313E-05_JPRB, 0.19922668E-05_JPRB, 0.19824354E-05_JPRB, 0.19676331E-05_JPRB, 0.19493034E-05_JPRB, &
  & 0.19278104E-05_JPRB, 0.19039586E-05_JPRB, 0.18780055E-05_JPRB, 0.18509186E-05_JPRB, 0.18227499E-05_JPRB, 0.17949264E-05_JPRB, &
  & 0.17650118E-05_JPRB, 0.17356236E-05_JPRB, 0.17041575E-05_JPRB, 0.16754287E-05_JPRB, 0.16481441E-05_JPRB, 0.16249924E-05_JPRB, &
  & 0.16110934E-05_JPRB, 0.16323427E-05_JPRB, 0.16569204E-05_JPRB, 0.16719270E-05_JPRB, 0.16668440E-05_JPRB, 0.16413871E-05_JPRB, &
  & 0.16272979E-05_JPRB, 0.16242025E-05_JPRB, 0.15113263E-05_JPRB, 0.13589699E-05_JPRB /)

RGHG7(:, 8, 9) = (/ &
  & 0.27166880E-05_JPRB, 0.24733242E-05_JPRB, 0.22479594E-05_JPRB, 0.21245678E-05_JPRB, 0.21001413E-05_JPRB, 0.20870143E-05_JPRB, &
  & 0.20627383E-05_JPRB, 0.20587743E-05_JPRB, 0.20840305E-05_JPRB, 0.21205240E-05_JPRB, 0.21438107E-05_JPRB, 0.21682090E-05_JPRB, &
  & 0.22011557E-05_JPRB, 0.22325269E-05_JPRB, 0.22605198E-05_JPRB, 0.22868517E-05_JPRB, 0.23114135E-05_JPRB, 0.23331443E-05_JPRB, &
  & 0.23530577E-05_JPRB, 0.23704458E-05_JPRB, 0.23871439E-05_JPRB, 0.24013912E-05_JPRB, 0.24157293E-05_JPRB, 0.24260628E-05_JPRB, &
  & 0.24377564E-05_JPRB, 0.24441838E-05_JPRB, 0.24530718E-05_JPRB, 0.24568910E-05_JPRB, 0.24573862E-05_JPRB, 0.24617561E-05_JPRB, &
  & 0.24694386E-05_JPRB, 0.25037996E-05_JPRB, 0.25097208E-05_JPRB, 0.25066640E-05_JPRB, 0.25020977E-05_JPRB, 0.24981061E-05_JPRB, &
  & 0.24945591E-05_JPRB, 0.24909634E-05_JPRB, 0.24854014E-05_JPRB, 0.24792118E-05_JPRB, 0.24679587E-05_JPRB, 0.24532449E-05_JPRB, &
  & 0.24358214E-05_JPRB, 0.24165906E-05_JPRB, 0.23961586E-05_JPRB, 0.23750099E-05_JPRB, 0.23530354E-05_JPRB, 0.23304144E-05_JPRB, &
  & 0.23059154E-05_JPRB, 0.22816471E-05_JPRB, 0.22544955E-05_JPRB, 0.22295435E-05_JPRB, 0.22061899E-05_JPRB, 0.21889980E-05_JPRB, &
  & 0.21787234E-05_JPRB, 0.21605506E-05_JPRB, 0.21085748E-05_JPRB, 0.20904358E-05_JPRB, 0.21169215E-05_JPRB, 0.21521701E-05_JPRB, &
  & 0.21285939E-05_JPRB, 0.19910708E-05_JPRB, 0.17244161E-05_JPRB, 0.16724350E-05_JPRB /)

RGHG7(:, 9, 9) = (/ &
  & 0.27064782E-05_JPRB, 0.29270543E-05_JPRB, 0.30459114E-05_JPRB, 0.30156875E-05_JPRB, 0.29171504E-05_JPRB, 0.28415759E-05_JPRB, &
  & 0.27850735E-05_JPRB, 0.27366279E-05_JPRB, 0.27045260E-05_JPRB, 0.27024960E-05_JPRB, 0.27187371E-05_JPRB, 0.27399401E-05_JPRB, &
  & 0.27596111E-05_JPRB, 0.27812289E-05_JPRB, 0.28033412E-05_JPRB, 0.28223983E-05_JPRB, 0.28391785E-05_JPRB, 0.28534928E-05_JPRB, &
  & 0.28670484E-05_JPRB, 0.28796496E-05_JPRB, 0.28940042E-05_JPRB, 0.29093039E-05_JPRB, 0.29290406E-05_JPRB, 0.29501916E-05_JPRB, &
  & 0.29753310E-05_JPRB, 0.29945204E-05_JPRB, 0.30149286E-05_JPRB, 0.30276381E-05_JPRB, 0.30380982E-05_JPRB, 0.30463957E-05_JPRB, &
  & 0.30563172E-05_JPRB, 0.30906251E-05_JPRB, 0.30963795E-05_JPRB, 0.30937674E-05_JPRB, 0.30915116E-05_JPRB, 0.30914152E-05_JPRB, &
  & 0.30937745E-05_JPRB, 0.30966276E-05_JPRB, 0.30973183E-05_JPRB, 0.30955111E-05_JPRB, 0.30890853E-05_JPRB, 0.30788385E-05_JPRB, &
  & 0.30656295E-05_JPRB, 0.30508816E-05_JPRB, 0.30354252E-05_JPRB, 0.30195995E-05_JPRB, 0.30030021E-05_JPRB, 0.29851844E-05_JPRB, &
  & 0.29656771E-05_JPRB, 0.29452965E-05_JPRB, 0.29228870E-05_JPRB, 0.29028847E-05_JPRB, 0.28847194E-05_JPRB, 0.28707991E-05_JPRB, &
  & 0.28701413E-05_JPRB, 0.29305190E-05_JPRB, 0.29964961E-05_JPRB, 0.30057010E-05_JPRB, 0.29603973E-05_JPRB, 0.28964348E-05_JPRB, &
  & 0.27442609E-05_JPRB, 0.25242916E-05_JPRB, 0.22239267E-05_JPRB, 0.20554376E-05_JPRB /)

RGHG7(:,10, 9) = (/ &
  & 0.28542513E-05_JPRB, 0.32565522E-05_JPRB, 0.34309887E-05_JPRB, 0.35303244E-05_JPRB, 0.35776420E-05_JPRB, 0.35648318E-05_JPRB, &
  & 0.35213955E-05_JPRB, 0.34851093E-05_JPRB, 0.34677687E-05_JPRB, 0.34643319E-05_JPRB, 0.34554721E-05_JPRB, 0.34528307E-05_JPRB, &
  & 0.34578266E-05_JPRB, 0.34648826E-05_JPRB, 0.34720247E-05_JPRB, 0.34785703E-05_JPRB, 0.34842146E-05_JPRB, 0.34878574E-05_JPRB, &
  & 0.34910656E-05_JPRB, 0.34946943E-05_JPRB, 0.35018907E-05_JPRB, 0.35138826E-05_JPRB, 0.35342505E-05_JPRB, 0.35602532E-05_JPRB, &
  & 0.35946739E-05_JPRB, 0.36332735E-05_JPRB, 0.36725121E-05_JPRB, 0.37024447E-05_JPRB, 0.37273469E-05_JPRB, 0.37460395E-05_JPRB, &
  & 0.37662596E-05_JPRB, 0.38084545E-05_JPRB, 0.38201442E-05_JPRB, 0.38223798E-05_JPRB, 0.38238800E-05_JPRB, 0.38277585E-05_JPRB, &
  & 0.38335938E-05_JPRB, 0.38394278E-05_JPRB, 0.38418088E-05_JPRB, 0.38405074E-05_JPRB, 0.38350636E-05_JPRB, 0.38265312E-05_JPRB, &
  & 0.38168828E-05_JPRB, 0.38072508E-05_JPRB, 0.37976708E-05_JPRB, 0.37869788E-05_JPRB, 0.37741320E-05_JPRB, 0.37583584E-05_JPRB, &
  & 0.37391180E-05_JPRB, 0.37182067E-05_JPRB, 0.36959605E-05_JPRB, 0.36754611E-05_JPRB, 0.36569190E-05_JPRB, 0.36430104E-05_JPRB, &
  & 0.36333031E-05_JPRB, 0.36000749E-05_JPRB, 0.35180974E-05_JPRB, 0.34476025E-05_JPRB, 0.33827025E-05_JPRB, 0.32512389E-05_JPRB, &
  & 0.30148492E-05_JPRB, 0.26824796E-05_JPRB, 0.23764167E-05_JPRB, 0.23135028E-05_JPRB /)

RGHG7(:,11, 9) = (/ &
  & 0.31559016E-05_JPRB, 0.37510440E-05_JPRB, 0.40842301E-05_JPRB, 0.43123164E-05_JPRB, 0.44495487E-05_JPRB, 0.45293609E-05_JPRB, &
  & 0.45474453E-05_JPRB, 0.45239804E-05_JPRB, 0.44866892E-05_JPRB, 0.44629128E-05_JPRB, 0.44470853E-05_JPRB, 0.44383469E-05_JPRB, &
  & 0.44328385E-05_JPRB, 0.44321041E-05_JPRB, 0.44320495E-05_JPRB, 0.44294302E-05_JPRB, 0.44238391E-05_JPRB, 0.44144585E-05_JPRB, &
  & 0.44031622E-05_JPRB, 0.43909990E-05_JPRB, 0.43809250E-05_JPRB, 0.43761092E-05_JPRB, 0.43805057E-05_JPRB, 0.43954979E-05_JPRB, &
  & 0.44209846E-05_JPRB, 0.44498661E-05_JPRB, 0.44823632E-05_JPRB, 0.45122651E-05_JPRB, 0.45395386E-05_JPRB, 0.45615948E-05_JPRB, &
  & 0.45872303E-05_JPRB, 0.46356804E-05_JPRB, 0.46541277E-05_JPRB, 0.46637774E-05_JPRB, 0.46711793E-05_JPRB, 0.46797236E-05_JPRB, &
  & 0.46882087E-05_JPRB, 0.46956807E-05_JPRB, 0.47000194E-05_JPRB, 0.47005615E-05_JPRB, 0.46981331E-05_JPRB, 0.46946784E-05_JPRB, &
  & 0.46902633E-05_JPRB, 0.46856026E-05_JPRB, 0.46793816E-05_JPRB, 0.46710438E-05_JPRB, 0.46604277E-05_JPRB, 0.46475275E-05_JPRB, &
  & 0.46337027E-05_JPRB, 0.46210739E-05_JPRB, 0.46102432E-05_JPRB, 0.46002174E-05_JPRB, 0.45886236E-05_JPRB, 0.45719780E-05_JPRB, &
  & 0.45486431E-05_JPRB, 0.45295333E-05_JPRB, 0.44927069E-05_JPRB, 0.43950354E-05_JPRB, 0.42160395E-05_JPRB, 0.39560800E-05_JPRB, &
  & 0.36190022E-05_JPRB, 0.32709415E-05_JPRB, 0.28896504E-05_JPRB, 0.26677724E-05_JPRB /)

RGHG7(:,12, 9) = (/ &
  & 0.35668038E-05_JPRB, 0.41859093E-05_JPRB, 0.45889356E-05_JPRB, 0.48934053E-05_JPRB, 0.51511925E-05_JPRB, 0.53323442E-05_JPRB, &
  & 0.54506454E-05_JPRB, 0.55170435E-05_JPRB, 0.55510222E-05_JPRB, 0.55682794E-05_JPRB, 0.55647879E-05_JPRB, 0.55539426E-05_JPRB, &
  & 0.55433916E-05_JPRB, 0.55337814E-05_JPRB, 0.55219111E-05_JPRB, 0.55085902E-05_JPRB, 0.54933566E-05_JPRB, 0.54744546E-05_JPRB, &
  & 0.54531420E-05_JPRB, 0.54290435E-05_JPRB, 0.54063389E-05_JPRB, 0.53879644E-05_JPRB, 0.53775861E-05_JPRB, 0.53793460E-05_JPRB, &
  & 0.53946628E-05_JPRB, 0.54223483E-05_JPRB, 0.54549178E-05_JPRB, 0.54875513E-05_JPRB, 0.55183314E-05_JPRB, 0.55466503E-05_JPRB, &
  & 0.55812352E-05_JPRB, 0.56386461E-05_JPRB, 0.56660156E-05_JPRB, 0.56822532E-05_JPRB, 0.56930821E-05_JPRB, 0.56997642E-05_JPRB, &
  & 0.57017378E-05_JPRB, 0.56988288E-05_JPRB, 0.56915924E-05_JPRB, 0.56796316E-05_JPRB, 0.56666495E-05_JPRB, 0.56525605E-05_JPRB, &
  & 0.56373888E-05_JPRB, 0.56197723E-05_JPRB, 0.55976507E-05_JPRB, 0.55696796E-05_JPRB, 0.55371675E-05_JPRB, 0.55012147E-05_JPRB, &
  & 0.54645275E-05_JPRB, 0.54293109E-05_JPRB, 0.53955864E-05_JPRB, 0.53594104E-05_JPRB, 0.53162403E-05_JPRB, 0.52593196E-05_JPRB, &
  & 0.51834108E-05_JPRB, 0.50839831E-05_JPRB, 0.49243313E-05_JPRB, 0.46961159E-05_JPRB, 0.44051835E-05_JPRB, 0.40634818E-05_JPRB, &
  & 0.36981614E-05_JPRB, 0.33414410E-05_JPRB, 0.30738054E-05_JPRB, 0.30295216E-05_JPRB /)

RGHG7(:,13, 9) = (/ &
  & 0.39667889E-05_JPRB, 0.45510787E-05_JPRB, 0.49421074E-05_JPRB, 0.52806631E-05_JPRB, 0.55740970E-05_JPRB, 0.58302285E-05_JPRB, &
  & 0.60241023E-05_JPRB, 0.61548944E-05_JPRB, 0.62377726E-05_JPRB, 0.62949266E-05_JPRB, 0.63265597E-05_JPRB, 0.63436105E-05_JPRB, &
  & 0.63541702E-05_JPRB, 0.63621505E-05_JPRB, 0.63669540E-05_JPRB, 0.63685516E-05_JPRB, 0.63699204E-05_JPRB, 0.63666012E-05_JPRB, &
  & 0.63635835E-05_JPRB, 0.63578264E-05_JPRB, 0.63517773E-05_JPRB, 0.63471748E-05_JPRB, 0.63451271E-05_JPRB, 0.63499870E-05_JPRB, &
  & 0.63614953E-05_JPRB, 0.63838893E-05_JPRB, 0.64129495E-05_JPRB, 0.64460746E-05_JPRB, 0.64821711E-05_JPRB, 0.65214176E-05_JPRB, &
  & 0.65698305E-05_JPRB, 0.66384505E-05_JPRB, 0.66772409E-05_JPRB, 0.67012302E-05_JPRB, 0.67142273E-05_JPRB, 0.67159222E-05_JPRB, &
  & 0.67053911E-05_JPRB, 0.66852508E-05_JPRB, 0.66567886E-05_JPRB, 0.66245425E-05_JPRB, 0.65899230E-05_JPRB, 0.65537270E-05_JPRB, &
  & 0.65130603E-05_JPRB, 0.64655715E-05_JPRB, 0.64100664E-05_JPRB, 0.63451948E-05_JPRB, 0.62739809E-05_JPRB, 0.61986461E-05_JPRB, &
  & 0.61221540E-05_JPRB, 0.60452130E-05_JPRB, 0.59661493E-05_JPRB, 0.58802707E-05_JPRB, 0.57821235E-05_JPRB, 0.56640583E-05_JPRB, &
  & 0.55207752E-05_JPRB, 0.53508893E-05_JPRB, 0.51318248E-05_JPRB, 0.48687316E-05_JPRB, 0.45730640E-05_JPRB, 0.42650454E-05_JPRB, &
  & 0.39608067E-05_JPRB, 0.36894396E-05_JPRB, 0.34792865E-05_JPRB, 0.32909809E-05_JPRB /)

RGHG7(:,14, 9) = (/ &
  & 0.41925050E-05_JPRB, 0.47364492E-05_JPRB, 0.50806011E-05_JPRB, 0.53960634E-05_JPRB, 0.56838699E-05_JPRB, 0.59458430E-05_JPRB, &
  & 0.61682358E-05_JPRB, 0.63479497E-05_JPRB, 0.64891883E-05_JPRB, 0.66016523E-05_JPRB, 0.66812568E-05_JPRB, 0.67413253E-05_JPRB, &
  & 0.67927958E-05_JPRB, 0.68390941E-05_JPRB, 0.68832542E-05_JPRB, 0.69236585E-05_JPRB, 0.69622042E-05_JPRB, 0.69966450E-05_JPRB, &
  & 0.70294800E-05_JPRB, 0.70581914E-05_JPRB, 0.70847268E-05_JPRB, 0.71085105E-05_JPRB, 0.71308054E-05_JPRB, 0.71538657E-05_JPRB, &
  & 0.71788413E-05_JPRB, 0.72069124E-05_JPRB, 0.72379430E-05_JPRB, 0.72781900E-05_JPRB, 0.73246347E-05_JPRB, 0.73787232E-05_JPRB, &
  & 0.74439808E-05_JPRB, 0.75276512E-05_JPRB, 0.75832281E-05_JPRB, 0.76199362E-05_JPRB, 0.76396491E-05_JPRB, 0.76416609E-05_JPRB, &
  & 0.76228007E-05_JPRB, 0.75865269E-05_JPRB, 0.75375410E-05_JPRB, 0.74806017E-05_JPRB, 0.74174081E-05_JPRB, 0.73475017E-05_JPRB, &
  & 0.72684661E-05_JPRB, 0.71777326E-05_JPRB, 0.70744800E-05_JPRB, 0.69604494E-05_JPRB, 0.68401387E-05_JPRB, 0.67174506E-05_JPRB, &
  & 0.65954146E-05_JPRB, 0.64740248E-05_JPRB, 0.63494622E-05_JPRB, 0.62167001E-05_JPRB, 0.60699713E-05_JPRB, 0.59035910E-05_JPRB, &
  & 0.57144780E-05_JPRB, 0.55030509E-05_JPRB, 0.52575388E-05_JPRB, 0.49867149E-05_JPRB, 0.47016692E-05_JPRB, 0.44155349E-05_JPRB, &
  & 0.41275462E-05_JPRB, 0.38374733E-05_JPRB, 0.36307226E-05_JPRB, 0.35000041E-05_JPRB /)

RGHG7(:,15, 9) = (/ &
  & 0.42692354E-05_JPRB, 0.47738145E-05_JPRB, 0.51215575E-05_JPRB, 0.53974381E-05_JPRB, 0.56731633E-05_JPRB, 0.59258655E-05_JPRB, &
  & 0.61545811E-05_JPRB, 0.63522093E-05_JPRB, 0.65185218E-05_JPRB, 0.66634066E-05_JPRB, 0.67838746E-05_JPRB, 0.68897339E-05_JPRB, &
  & 0.69883490E-05_JPRB, 0.70823335E-05_JPRB, 0.71720383E-05_JPRB, 0.72571697E-05_JPRB, 0.73377664E-05_JPRB, 0.74133159E-05_JPRB, &
  & 0.74853701E-05_JPRB, 0.75533540E-05_JPRB, 0.76180359E-05_JPRB, 0.76779388E-05_JPRB, 0.77328123E-05_JPRB, 0.77819359E-05_JPRB, &
  & 0.78263975E-05_JPRB, 0.78696521E-05_JPRB, 0.79143883E-05_JPRB, 0.79646416E-05_JPRB, 0.80219515E-05_JPRB, 0.80901364E-05_JPRB, &
  & 0.81696553E-05_JPRB, 0.82614333E-05_JPRB, 0.83228397E-05_JPRB, 0.83618379E-05_JPRB, 0.83802779E-05_JPRB, 0.83761570E-05_JPRB, &
  & 0.83493060E-05_JPRB, 0.83016976E-05_JPRB, 0.82375291E-05_JPRB, 0.81607914E-05_JPRB, 0.80719055E-05_JPRB, 0.79688198E-05_JPRB, &
  & 0.78506328E-05_JPRB, 0.77165241E-05_JPRB, 0.75681410E-05_JPRB, 0.74098102E-05_JPRB, 0.72470152E-05_JPRB, 0.70845417E-05_JPRB, &
  & 0.69243670E-05_JPRB, 0.67646820E-05_JPRB, 0.66015596E-05_JPRB, 0.64302785E-05_JPRB, 0.62461877E-05_JPRB, 0.60466123E-05_JPRB, &
  & 0.58299247E-05_JPRB, 0.56002486E-05_JPRB, 0.53522135E-05_JPRB, 0.50924746E-05_JPRB, 0.48293687E-05_JPRB, 0.45647903E-05_JPRB, &
  & 0.43001487E-05_JPRB, 0.40321625E-05_JPRB, 0.38611706E-05_JPRB, 0.37435059E-05_JPRB /)

RGHG7(:,16, 9) = (/ &
  & 0.42290280E-05_JPRB, 0.47001381E-05_JPRB, 0.49952300E-05_JPRB, 0.52623677E-05_JPRB, 0.55028086E-05_JPRB, 0.57316201E-05_JPRB, &
  & 0.59474760E-05_JPRB, 0.61477535E-05_JPRB, 0.63336201E-05_JPRB, 0.65079794E-05_JPRB, 0.66670054E-05_JPRB, 0.68162267E-05_JPRB, &
  & 0.69614021E-05_JPRB, 0.71033023E-05_JPRB, 0.72399639E-05_JPRB, 0.73695337E-05_JPRB, 0.74917775E-05_JPRB, 0.76060696E-05_JPRB, &
  & 0.77131472E-05_JPRB, 0.78140265E-05_JPRB, 0.79109032E-05_JPRB, 0.80037771E-05_JPRB, 0.80925183E-05_JPRB, 0.81764329E-05_JPRB, &
  & 0.82560555E-05_JPRB, 0.83314426E-05_JPRB, 0.84029198E-05_JPRB, 0.84722014E-05_JPRB, 0.85401425E-05_JPRB, 0.86085256E-05_JPRB, &
  & 0.86810232E-05_JPRB, 0.87657154E-05_JPRB, 0.88258266E-05_JPRB, 0.88619699E-05_JPRB, 0.88734860E-05_JPRB, 0.88627939E-05_JPRB, &
  & 0.88299948E-05_JPRB, 0.87765839E-05_JPRB, 0.87057169E-05_JPRB, 0.86188820E-05_JPRB, 0.85133379E-05_JPRB, 0.83870318E-05_JPRB, &
  & 0.82379547E-05_JPRB, 0.80670234E-05_JPRB, 0.78786134E-05_JPRB, 0.76787901E-05_JPRB, 0.74755926E-05_JPRB, 0.72750681E-05_JPRB, &
  & 0.70790597E-05_JPRB, 0.68858703E-05_JPRB, 0.66911985E-05_JPRB, 0.64906853E-05_JPRB, 0.62812210E-05_JPRB, 0.60616107E-05_JPRB, &
  & 0.58328546E-05_JPRB, 0.56001186E-05_JPRB, 0.53592566E-05_JPRB, 0.51143952E-05_JPRB, 0.48655156E-05_JPRB, 0.46114733E-05_JPRB, &
  & 0.43552322E-05_JPRB, 0.41333378E-05_JPRB, 0.39794481E-05_JPRB, 0.38737080E-05_JPRB /)

RGHG7(:,17, 9) = (/ &
  & 0.41448325E-05_JPRB, 0.45079209E-05_JPRB, 0.47876870E-05_JPRB, 0.50446042E-05_JPRB, 0.52780888E-05_JPRB, 0.55020755E-05_JPRB, &
  & 0.57187663E-05_JPRB, 0.59244439E-05_JPRB, 0.61247492E-05_JPRB, 0.63224556E-05_JPRB, 0.65167173E-05_JPRB, 0.67098927E-05_JPRB, &
  & 0.69037487E-05_JPRB, 0.70972633E-05_JPRB, 0.72869570E-05_JPRB, 0.74684044E-05_JPRB, 0.76391725E-05_JPRB, 0.77989189E-05_JPRB, &
  & 0.79495303E-05_JPRB, 0.80913269E-05_JPRB, 0.82264723E-05_JPRB, 0.83577925E-05_JPRB, 0.84860212E-05_JPRB, 0.86085111E-05_JPRB, &
  & 0.87231183E-05_JPRB, 0.88278057E-05_JPRB, 0.89231207E-05_JPRB, 0.90050644E-05_JPRB, 0.90739941E-05_JPRB, 0.91351121E-05_JPRB, &
  & 0.91926086E-05_JPRB, 0.92514165E-05_JPRB, 0.92839755E-05_JPRB, 0.92913178E-05_JPRB, 0.92755481E-05_JPRB, 0.92399259E-05_JPRB, &
  & 0.91878828E-05_JPRB, 0.91224138E-05_JPRB, 0.90433296E-05_JPRB, 0.89501900E-05_JPRB, 0.88382412E-05_JPRB, 0.87040744E-05_JPRB, &
  & 0.85440979E-05_JPRB, 0.83573868E-05_JPRB, 0.81491862E-05_JPRB, 0.79265110E-05_JPRB, 0.76974038E-05_JPRB, 0.74697050E-05_JPRB, &
  & 0.72467324E-05_JPRB, 0.70268929E-05_JPRB, 0.68064423E-05_JPRB, 0.65818058E-05_JPRB, 0.63509297E-05_JPRB, 0.61144401E-05_JPRB, &
  & 0.58754890E-05_JPRB, 0.56384597E-05_JPRB, 0.54001871E-05_JPRB, 0.51604161E-05_JPRB, 0.49177343E-05_JPRB, 0.46647751E-05_JPRB, &
  & 0.44139724E-05_JPRB, 0.42236302E-05_JPRB, 0.40946547E-05_JPRB, 0.39942884E-05_JPRB /)

RGHG7(:,18, 9) = (/ &
  & 0.40770542E-05_JPRB, 0.43382133E-05_JPRB, 0.46169321E-05_JPRB, 0.48621464E-05_JPRB, 0.50936787E-05_JPRB, 0.53144399E-05_JPRB, &
  & 0.55264331E-05_JPRB, 0.57318916E-05_JPRB, 0.59393728E-05_JPRB, 0.61515802E-05_JPRB, 0.63690145E-05_JPRB, 0.65942368E-05_JPRB, &
  & 0.68257118E-05_JPRB, 0.70589285E-05_JPRB, 0.72865942E-05_JPRB, 0.75032049E-05_JPRB, 0.77056529E-05_JPRB, 0.78939156E-05_JPRB, &
  & 0.80707250E-05_JPRB, 0.82414272E-05_JPRB, 0.84069643E-05_JPRB, 0.85698730E-05_JPRB, 0.87328199E-05_JPRB, 0.88940997E-05_JPRB, &
  & 0.90500789E-05_JPRB, 0.91943757E-05_JPRB, 0.93217932E-05_JPRB, 0.94267562E-05_JPRB, 0.95043388E-05_JPRB, 0.95529585E-05_JPRB, &
  & 0.95804371E-05_JPRB, 0.95976557E-05_JPRB, 0.95864771E-05_JPRB, 0.95521882E-05_JPRB, 0.95019786E-05_JPRB, 0.94343404E-05_JPRB, &
  & 0.93546350E-05_JPRB, 0.92682658E-05_JPRB, 0.91746515E-05_JPRB, 0.90711665E-05_JPRB, 0.89527621E-05_JPRB, 0.88154866E-05_JPRB, &
  & 0.86556374E-05_JPRB, 0.84714065E-05_JPRB, 0.82648094E-05_JPRB, 0.80410082E-05_JPRB, 0.78068651E-05_JPRB, 0.75709390E-05_JPRB, &
  & 0.73374117E-05_JPRB, 0.71060458E-05_JPRB, 0.68737559E-05_JPRB, 0.66378507E-05_JPRB, 0.63971952E-05_JPRB, 0.61539281E-05_JPRB, &
  & 0.59119475E-05_JPRB, 0.56743074E-05_JPRB, 0.54377997E-05_JPRB, 0.52004089E-05_JPRB, 0.49556515E-05_JPRB, 0.47100671E-05_JPRB, &
  & 0.44877320E-05_JPRB, 0.43182536E-05_JPRB, 0.41987919E-05_JPRB, 0.40948407E-05_JPRB /)

RGHG7(:,19, 9) = (/ &
  & 0.39435881E-05_JPRB, 0.40636687E-05_JPRB, 0.42679626E-05_JPRB, 0.45183460E-05_JPRB, 0.47669978E-05_JPRB, 0.50148296E-05_JPRB, &
  & 0.52537193E-05_JPRB, 0.54845164E-05_JPRB, 0.57140664E-05_JPRB, 0.59488461E-05_JPRB, 0.61909300E-05_JPRB, 0.64418832E-05_JPRB, &
  & 0.66987018E-05_JPRB, 0.69540397E-05_JPRB, 0.71999889E-05_JPRB, 0.74292102E-05_JPRB, 0.76384586E-05_JPRB, 0.78285857E-05_JPRB, &
  & 0.80032341E-05_JPRB, 0.81675744E-05_JPRB, 0.83289624E-05_JPRB, 0.84883377E-05_JPRB, 0.86490454E-05_JPRB, 0.88115748E-05_JPRB, &
  & 0.89744826E-05_JPRB, 0.91315233E-05_JPRB, 0.92763348E-05_JPRB, 0.93987373E-05_JPRB, 0.94937050E-05_JPRB, 0.95582918E-05_JPRB, &
  & 0.95951109E-05_JPRB, 0.96156618E-05_JPRB, 0.96005724E-05_JPRB, 0.95580544E-05_JPRB, 0.94937122E-05_JPRB, 0.94116758E-05_JPRB, &
  & 0.93209128E-05_JPRB, 0.92190721E-05_JPRB, 0.91067677E-05_JPRB, 0.89854766E-05_JPRB, 0.88523520E-05_JPRB, 0.87055987E-05_JPRB, &
  & 0.85446763E-05_JPRB, 0.83671266E-05_JPRB, 0.81724393E-05_JPRB, 0.79627634E-05_JPRB, 0.77432969E-05_JPRB, 0.75206312E-05_JPRB, &
  & 0.72984490E-05_JPRB, 0.70765345E-05_JPRB, 0.68525742E-05_JPRB, 0.66244170E-05_JPRB, 0.63915872E-05_JPRB, 0.61566416E-05_JPRB, &
  & 0.59226013E-05_JPRB, 0.56913113E-05_JPRB, 0.54594238E-05_JPRB, 0.52227615E-05_JPRB, 0.49772952E-05_JPRB, 0.47400840E-05_JPRB, &
  & 0.45476349E-05_JPRB, 0.44031644E-05_JPRB, 0.42938200E-05_JPRB, 0.41965791E-05_JPRB /)

RGHG7(:,20, 9) = (/ &
  & 0.34577154E-05_JPRB, 0.35586484E-05_JPRB, 0.37610912E-05_JPRB, 0.40195355E-05_JPRB, 0.43128421E-05_JPRB, 0.46079736E-05_JPRB, &
  & 0.48954489E-05_JPRB, 0.51695324E-05_JPRB, 0.54384000E-05_JPRB, 0.57051234E-05_JPRB, 0.59730796E-05_JPRB, 0.62427293E-05_JPRB, &
  & 0.65096374E-05_JPRB, 0.67667706E-05_JPRB, 0.70052138E-05_JPRB, 0.72199814E-05_JPRB, 0.74098944E-05_JPRB, 0.75756989E-05_JPRB, &
  & 0.77223867E-05_JPRB, 0.78547455E-05_JPRB, 0.79796100E-05_JPRB, 0.81008184E-05_JPRB, 0.82213755E-05_JPRB, 0.83433297E-05_JPRB, &
  & 0.84685362E-05_JPRB, 0.85949250E-05_JPRB, 0.87210310E-05_JPRB, 0.88412025E-05_JPRB, 0.89527039E-05_JPRB, 0.90507665E-05_JPRB, &
  & 0.91334159E-05_JPRB, 0.92015225E-05_JPRB, 0.92365572E-05_JPRB, 0.92379260E-05_JPRB, 0.92088512E-05_JPRB, 0.91521088E-05_JPRB, &
  & 0.90640215E-05_JPRB, 0.89541436E-05_JPRB, 0.88281777E-05_JPRB, 0.86871196E-05_JPRB, 0.85356496E-05_JPRB, 0.83759860E-05_JPRB, &
  & 0.82110992E-05_JPRB, 0.80375039E-05_JPRB, 0.78555422E-05_JPRB, 0.76662927E-05_JPRB, 0.74724703E-05_JPRB, 0.72776647E-05_JPRB, &
  & 0.70840515E-05_JPRB, 0.68907193E-05_JPRB, 0.66948555E-05_JPRB, 0.64941019E-05_JPRB, 0.62881250E-05_JPRB, 0.60784214E-05_JPRB, &
  & 0.58662395E-05_JPRB, 0.56513263E-05_JPRB, 0.54295865E-05_JPRB, 0.51974657E-05_JPRB, 0.49686059E-05_JPRB, 0.47604285E-05_JPRB, &
  & 0.45951288E-05_JPRB, 0.44674057E-05_JPRB, 0.43767350E-05_JPRB, 0.42819947E-05_JPRB /)

RGHG7(:,21, 9) = (/ &
  & 0.26824177E-05_JPRB, 0.28428115E-05_JPRB, 0.30639483E-05_JPRB, 0.33654608E-05_JPRB, 0.37025377E-05_JPRB, 0.40629207E-05_JPRB, &
  & 0.44148310E-05_JPRB, 0.47525018E-05_JPRB, 0.50752774E-05_JPRB, 0.53846461E-05_JPRB, 0.56808303E-05_JPRB, 0.59640111E-05_JPRB, &
  & 0.62303502E-05_JPRB, 0.64735268E-05_JPRB, 0.66891298E-05_JPRB, 0.68739778E-05_JPRB, 0.70288706E-05_JPRB, 0.71584059E-05_JPRB, &
  & 0.72661687E-05_JPRB, 0.73569627E-05_JPRB, 0.74348445E-05_JPRB, 0.75043822E-05_JPRB, 0.75690600E-05_JPRB, 0.76316383E-05_JPRB, &
  & 0.76976630E-05_JPRB, 0.77717241E-05_JPRB, 0.78577386E-05_JPRB, 0.79548099E-05_JPRB, 0.80634418E-05_JPRB, 0.81816834E-05_JPRB, &
  & 0.83065415E-05_JPRB, 0.84309222E-05_JPRB, 0.85312422E-05_JPRB, 0.86016944E-05_JPRB, 0.86302271E-05_JPRB, 0.86137015E-05_JPRB, &
  & 0.85576239E-05_JPRB, 0.84611538E-05_JPRB, 0.83318573E-05_JPRB, 0.81827366E-05_JPRB, 0.80207419E-05_JPRB, 0.78594103E-05_JPRB, &
  & 0.76912183E-05_JPRB, 0.75238299E-05_JPRB, 0.73574329E-05_JPRB, 0.71902841E-05_JPRB, 0.70255651E-05_JPRB, 0.68657150E-05_JPRB, &
  & 0.67096912E-05_JPRB, 0.65546574E-05_JPRB, 0.63967941E-05_JPRB, 0.62336580E-05_JPRB, 0.60640268E-05_JPRB, 0.58877986E-05_JPRB, &
  & 0.57045572E-05_JPRB, 0.55135943E-05_JPRB, 0.53129615E-05_JPRB, 0.51044362E-05_JPRB, 0.49034406E-05_JPRB, 0.47314497E-05_JPRB, &
  & 0.45911565E-05_JPRB, 0.44860149E-05_JPRB, 0.44043550E-05_JPRB, 0.43301166E-05_JPRB /)

RGHG7(:,22, 9) = (/ &
  & 0.17489248E-05_JPRB, 0.19744296E-05_JPRB, 0.22507684E-05_JPRB, 0.25704944E-05_JPRB, 0.29613875E-05_JPRB, 0.33844910E-05_JPRB, &
  & 0.38077742E-05_JPRB, 0.42169027E-05_JPRB, 0.46056512E-05_JPRB, 0.49659975E-05_JPRB, 0.52975129E-05_JPRB, 0.55977816E-05_JPRB, &
  & 0.58640089E-05_JPRB, 0.60935226E-05_JPRB, 0.62840104E-05_JPRB, 0.64379369E-05_JPRB, 0.65591094E-05_JPRB, 0.66513139E-05_JPRB, &
  & 0.67205806E-05_JPRB, 0.67704750E-05_JPRB, 0.68043109E-05_JPRB, 0.68243680E-05_JPRB, 0.68355530E-05_JPRB, 0.68414897E-05_JPRB, &
  & 0.68502004E-05_JPRB, 0.68689483E-05_JPRB, 0.69059415E-05_JPRB, 0.69689536E-05_JPRB, 0.70599863E-05_JPRB, 0.71758982E-05_JPRB, &
  & 0.73139677E-05_JPRB, 0.74662316E-05_JPRB, 0.76087549E-05_JPRB, 0.77308869E-05_JPRB, 0.78122466E-05_JPRB, 0.78406601E-05_JPRB, &
  & 0.78159537E-05_JPRB, 0.77420982E-05_JPRB, 0.76311126E-05_JPRB, 0.74949762E-05_JPRB, 0.73469209E-05_JPRB, 0.71868926E-05_JPRB, &
  & 0.70360243E-05_JPRB, 0.68865493E-05_JPRB, 0.67390447E-05_JPRB, 0.65996683E-05_JPRB, 0.64690716E-05_JPRB, 0.63460679E-05_JPRB, &
  & 0.62293275E-05_JPRB, 0.61148626E-05_JPRB, 0.59981098E-05_JPRB, 0.58755681E-05_JPRB, 0.57449693E-05_JPRB, 0.56050590E-05_JPRB, &
  & 0.54544280E-05_JPRB, 0.52917435E-05_JPRB, 0.51166371E-05_JPRB, 0.49403143E-05_JPRB, 0.47816088E-05_JPRB, 0.46450477E-05_JPRB, &
  & 0.45345182E-05_JPRB, 0.44473841E-05_JPRB, 0.43842983E-05_JPRB, 0.43227610E-05_JPRB /)

RGHG7(:,23, 9) = (/ &
  & 0.11508653E-05_JPRB, 0.13571735E-05_JPRB, 0.15711762E-05_JPRB, 0.18594241E-05_JPRB, 0.22314655E-05_JPRB, 0.26662046E-05_JPRB, &
  & 0.31287757E-05_JPRB, 0.35926644E-05_JPRB, 0.40396590E-05_JPRB, 0.44518406E-05_JPRB, 0.48207194E-05_JPRB, 0.51428237E-05_JPRB, &
  & 0.54150564E-05_JPRB, 0.56364411E-05_JPRB, 0.58095698E-05_JPRB, 0.59385902E-05_JPRB, 0.60304092E-05_JPRB, 0.60926286E-05_JPRB, &
  & 0.61291457E-05_JPRB, 0.61457436E-05_JPRB, 0.61437486E-05_JPRB, 0.61277678E-05_JPRB, 0.60971379E-05_JPRB, 0.60631164E-05_JPRB, &
  & 0.60274228E-05_JPRB, 0.60090188E-05_JPRB, 0.60115431E-05_JPRB, 0.60390234E-05_JPRB, 0.60926045E-05_JPRB, 0.61785645E-05_JPRB, &
  & 0.62954268E-05_JPRB, 0.64360170E-05_JPRB, 0.65803233E-05_JPRB, 0.67124392E-05_JPRB, 0.68142294E-05_JPRB, 0.68721965E-05_JPRB, &
  & 0.68781897E-05_JPRB, 0.68332361E-05_JPRB, 0.67496035E-05_JPRB, 0.66441366E-05_JPRB, 0.65266113E-05_JPRB, 0.64036039E-05_JPRB, &
  & 0.62772478E-05_JPRB, 0.61602655E-05_JPRB, 0.60506995E-05_JPRB, 0.59447516E-05_JPRB, 0.58500068E-05_JPRB, 0.57661478E-05_JPRB, &
  & 0.56887602E-05_JPRB, 0.56125009E-05_JPRB, 0.55331593E-05_JPRB, 0.54473699E-05_JPRB, 0.53520303E-05_JPRB, 0.52454843E-05_JPRB, &
  & 0.51266766E-05_JPRB, 0.49958257E-05_JPRB, 0.48560655E-05_JPRB, 0.47178401E-05_JPRB, 0.45941147E-05_JPRB, 0.44880148E-05_JPRB, &
  & 0.44017911E-05_JPRB, 0.43376808E-05_JPRB, 0.42914553E-05_JPRB, 0.42538195E-05_JPRB /)

RGHG7(:,24, 9) = (/ &
  & 0.81639189E-06_JPRB, 0.97053703E-06_JPRB, 0.11306105E-05_JPRB, 0.13428609E-05_JPRB, 0.16402437E-05_JPRB, 0.20281934E-05_JPRB, &
  & 0.24737037E-05_JPRB, 0.29489283E-05_JPRB, 0.34227414E-05_JPRB, 0.38671078E-05_JPRB, 0.42654283E-05_JPRB, 0.46075138E-05_JPRB, &
  & 0.48890279E-05_JPRB, 0.51097777E-05_JPRB, 0.52737223E-05_JPRB, 0.53881481E-05_JPRB, 0.54626275E-05_JPRB, 0.55038804E-05_JPRB, &
  & 0.55196133E-05_JPRB, 0.55138921E-05_JPRB, 0.54907009E-05_JPRB, 0.54512066E-05_JPRB, 0.53978097E-05_JPRB, 0.53395720E-05_JPRB, &
  & 0.52829787E-05_JPRB, 0.52327573E-05_JPRB, 0.51978996E-05_JPRB, 0.51915836E-05_JPRB, 0.52161236E-05_JPRB, 0.52660830E-05_JPRB, &
  & 0.53411500E-05_JPRB, 0.54393058E-05_JPRB, 0.55471487E-05_JPRB, 0.56512736E-05_JPRB, 0.57390298E-05_JPRB, 0.58009391E-05_JPRB, &
  & 0.58210444E-05_JPRB, 0.58073265E-05_JPRB, 0.57643219E-05_JPRB, 0.57048665E-05_JPRB, 0.56362455E-05_JPRB, 0.55642895E-05_JPRB, &
  & 0.54898919E-05_JPRB, 0.54111206E-05_JPRB, 0.53400231E-05_JPRB, 0.52767964E-05_JPRB, 0.52212417E-05_JPRB, 0.51719685E-05_JPRB, &
  & 0.51292782E-05_JPRB, 0.50879667E-05_JPRB, 0.50419771E-05_JPRB, 0.49878076E-05_JPRB, 0.49226633E-05_JPRB, 0.48456209E-05_JPRB, &
  & 0.47567933E-05_JPRB, 0.46583941E-05_JPRB, 0.45541178E-05_JPRB, 0.44550238E-05_JPRB, 0.43649793E-05_JPRB, 0.42868433E-05_JPRB, &
  & 0.42231695E-05_JPRB, 0.41754420E-05_JPRB, 0.41444332E-05_JPRB, 0.41264975E-05_JPRB /)

RGHG7(:,25, 9) = (/ &
  & 0.61003237E-06_JPRB, 0.72957778E-06_JPRB, 0.84450414E-06_JPRB, 0.99873682E-06_JPRB, 0.12151177E-05_JPRB, 0.15206691E-05_JPRB, &
  & 0.19074746E-05_JPRB, 0.23493446E-05_JPRB, 0.28107845E-05_JPRB, 0.32570704E-05_JPRB, 0.36658869E-05_JPRB, 0.40197569E-05_JPRB, &
  & 0.43101791E-05_JPRB, 0.45348042E-05_JPRB, 0.46985615E-05_JPRB, 0.48076517E-05_JPRB, 0.48733896E-05_JPRB, 0.49051105E-05_JPRB, &
  & 0.49097075E-05_JPRB, 0.48933280E-05_JPRB, 0.48598558E-05_JPRB, 0.48114930E-05_JPRB, 0.47510885E-05_JPRB, 0.46837085E-05_JPRB, &
  & 0.46165774E-05_JPRB, 0.45577463E-05_JPRB, 0.45135412E-05_JPRB, 0.44836020E-05_JPRB, 0.44674966E-05_JPRB, 0.44719131E-05_JPRB, &
  & 0.44960398E-05_JPRB, 0.45383385E-05_JPRB, 0.45910328E-05_JPRB, 0.46479358E-05_JPRB, 0.46980540E-05_JPRB, 0.47364701E-05_JPRB, &
  & 0.47630888E-05_JPRB, 0.47755825E-05_JPRB, 0.47771041E-05_JPRB, 0.47679414E-05_JPRB, 0.47543690E-05_JPRB, 0.47348876E-05_JPRB, &
  & 0.47156009E-05_JPRB, 0.46891601E-05_JPRB, 0.46613095E-05_JPRB, 0.46356508E-05_JPRB, 0.46179871E-05_JPRB, 0.46051441E-05_JPRB, &
  & 0.45930901E-05_JPRB, 0.45787760E-05_JPRB, 0.45589086E-05_JPRB, 0.45299644E-05_JPRB, 0.44897761E-05_JPRB, 0.44378589E-05_JPRB, &
  & 0.43753789E-05_JPRB, 0.43046753E-05_JPRB, 0.42325532E-05_JPRB, 0.41635712E-05_JPRB, 0.41005642E-05_JPRB, 0.40463096E-05_JPRB, &
  & 0.40033851E-05_JPRB, 0.39732940E-05_JPRB, 0.39579272E-05_JPRB, 0.39595275E-05_JPRB /)

RGHG7(:,26, 9) = (/ &
  & 0.48099315E-06_JPRB, 0.57901940E-06_JPRB, 0.66654263E-06_JPRB, 0.77741481E-06_JPRB, 0.93958971E-06_JPRB, 0.11656509E-05_JPRB, &
  & 0.14774984E-05_JPRB, 0.18533802E-05_JPRB, 0.22669165E-05_JPRB, 0.26850566E-05_JPRB, 0.30780832E-05_JPRB, 0.34263489E-05_JPRB, &
  & 0.37167390E-05_JPRB, 0.39435863E-05_JPRB, 0.41089133E-05_JPRB, 0.42192792E-05_JPRB, 0.42836555E-05_JPRB, 0.43129562E-05_JPRB, &
  & 0.43149371E-05_JPRB, 0.42962829E-05_JPRB, 0.42615807E-05_JPRB, 0.42137112E-05_JPRB, 0.41559310E-05_JPRB, 0.40918062E-05_JPRB, &
  & 0.40258642E-05_JPRB, 0.39659080E-05_JPRB, 0.39118331E-05_JPRB, 0.38640428E-05_JPRB, 0.38263183E-05_JPRB, 0.37930374E-05_JPRB, &
  & 0.37706873E-05_JPRB, 0.37599152E-05_JPRB, 0.37578329E-05_JPRB, 0.37647567E-05_JPRB, 0.37796390E-05_JPRB, 0.37999200E-05_JPRB, &
  & 0.38242520E-05_JPRB, 0.38547155E-05_JPRB, 0.38882781E-05_JPRB, 0.39214315E-05_JPRB, 0.39553893E-05_JPRB, 0.39837073E-05_JPRB, &
  & 0.40081977E-05_JPRB, 0.40258683E-05_JPRB, 0.40393998E-05_JPRB, 0.40501941E-05_JPRB, 0.40614827E-05_JPRB, 0.40752043E-05_JPRB, &
  & 0.40896407E-05_JPRB, 0.41001167E-05_JPRB, 0.41024423E-05_JPRB, 0.40950895E-05_JPRB, 0.40764849E-05_JPRB, 0.40465266E-05_JPRB, &
  & 0.40065679E-05_JPRB, 0.39605420E-05_JPRB, 0.39134261E-05_JPRB, 0.38675344E-05_JPRB, 0.38252033E-05_JPRB, 0.37884686E-05_JPRB, &
  & 0.37600087E-05_JPRB, 0.37420612E-05_JPRB, 0.37369323E-05_JPRB, 0.37570201E-05_JPRB /)

RGHG7(:,27, 9) = (/ &
  & 0.39916699E-06_JPRB, 0.48047690E-06_JPRB, 0.55134325E-06_JPRB, 0.63830157E-06_JPRB, 0.75566470E-06_JPRB, 0.92714220E-06_JPRB, &
  & 0.11620322E-05_JPRB, 0.14679713E-05_JPRB, 0.18196590E-05_JPRB, 0.21866172E-05_JPRB, 0.25455042E-05_JPRB, 0.28724523E-05_JPRB, &
  & 0.31523334E-05_JPRB, 0.33757476E-05_JPRB, 0.35413361E-05_JPRB, 0.36531280E-05_JPRB, 0.37198304E-05_JPRB, 0.37501218E-05_JPRB, &
  & 0.37538218E-05_JPRB, 0.37376985E-05_JPRB, 0.37074819E-05_JPRB, 0.36656547E-05_JPRB, 0.36162364E-05_JPRB, 0.35611390E-05_JPRB, &
  & 0.35034241E-05_JPRB, 0.34446737E-05_JPRB, 0.33832084E-05_JPRB, 0.33241649E-05_JPRB, 0.32666978E-05_JPRB, 0.32135088E-05_JPRB, &
  & 0.31587670E-05_JPRB, 0.31069221E-05_JPRB, 0.30611309E-05_JPRB, 0.30272622E-05_JPRB, 0.30098729E-05_JPRB, 0.30110934E-05_JPRB, &
  & 0.30321228E-05_JPRB, 0.30731617E-05_JPRB, 0.31305110E-05_JPRB, 0.31963584E-05_JPRB, 0.32664248E-05_JPRB, 0.33329954E-05_JPRB, &
  & 0.33924184E-05_JPRB, 0.34445616E-05_JPRB, 0.34901241E-05_JPRB, 0.35323587E-05_JPRB, 0.35709795E-05_JPRB, 0.36067004E-05_JPRB, &
  & 0.36378251E-05_JPRB, 0.36640879E-05_JPRB, 0.36828662E-05_JPRB, 0.36920467E-05_JPRB, 0.36904639E-05_JPRB, 0.36787326E-05_JPRB, &
  & 0.36588576E-05_JPRB, 0.36352935E-05_JPRB, 0.36104916E-05_JPRB, 0.35863873E-05_JPRB, 0.35647556E-05_JPRB, 0.35470086E-05_JPRB, &
  & 0.35355242E-05_JPRB, 0.35321671E-05_JPRB, 0.35391063E-05_JPRB, 0.35628327E-05_JPRB /)

RGHG7(:,28, 9) = (/ &
  & 0.35259657E-06_JPRB, 0.42155364E-06_JPRB, 0.48009417E-06_JPRB, 0.54618886E-06_JPRB, 0.63994634E-06_JPRB, 0.76710359E-06_JPRB, &
  & 0.95045556E-06_JPRB, 0.11918933E-05_JPRB, 0.14793703E-05_JPRB, 0.17916209E-05_JPRB, 0.21055293E-05_JPRB, 0.24001615E-05_JPRB, &
  & 0.26585815E-05_JPRB, 0.28695265E-05_JPRB, 0.30293061E-05_JPRB, 0.31393542E-05_JPRB, 0.32063786E-05_JPRB, 0.32371208E-05_JPRB, &
  & 0.32430560E-05_JPRB, 0.32310199E-05_JPRB, 0.32059793E-05_JPRB, 0.31720249E-05_JPRB, 0.31323057E-05_JPRB, 0.30879910E-05_JPRB, &
  & 0.30398312E-05_JPRB, 0.29877183E-05_JPRB, 0.29340733E-05_JPRB, 0.28747008E-05_JPRB, 0.28059537E-05_JPRB, 0.27283622E-05_JPRB, &
  & 0.26482066E-05_JPRB, 0.25675120E-05_JPRB, 0.24920869E-05_JPRB, 0.24308024E-05_JPRB, 0.23915011E-05_JPRB, 0.23792518E-05_JPRB, &
  & 0.23965324E-05_JPRB, 0.24424241E-05_JPRB, 0.25130064E-05_JPRB, 0.25989723E-05_JPRB, 0.26913608E-05_JPRB, 0.27834037E-05_JPRB, &
  & 0.28673367E-05_JPRB, 0.29437217E-05_JPRB, 0.30117210E-05_JPRB, 0.30742051E-05_JPRB, 0.31312136E-05_JPRB, 0.31827926E-05_JPRB, &
  & 0.32282471E-05_JPRB, 0.32669705E-05_JPRB, 0.32985376E-05_JPRB, 0.33212500E-05_JPRB, 0.33345816E-05_JPRB, 0.33390402E-05_JPRB, &
  & 0.33369065E-05_JPRB, 0.33311528E-05_JPRB, 0.33233428E-05_JPRB, 0.33146730E-05_JPRB, 0.33062311E-05_JPRB, 0.32996138E-05_JPRB, &
  & 0.32970506E-05_JPRB, 0.33000558E-05_JPRB, 0.33119679E-05_JPRB, 0.33522529E-05_JPRB /)

RGHG7(:,29, 9) = (/ &
  & 0.32519807E-06_JPRB, 0.38587532E-06_JPRB, 0.43491380E-06_JPRB, 0.49091642E-06_JPRB, 0.56006331E-06_JPRB, 0.66102052E-06_JPRB, &
  & 0.80201056E-06_JPRB, 0.99461101E-06_JPRB, 0.12310030E-05_JPRB, 0.14941501E-05_JPRB, 0.17646590E-05_JPRB, 0.20232176E-05_JPRB, &
  & 0.22542954E-05_JPRB, 0.24459673E-05_JPRB, 0.25934633E-05_JPRB, 0.26966875E-05_JPRB, 0.27585775E-05_JPRB, 0.27875749E-05_JPRB, &
  & 0.27932376E-05_JPRB, 0.27827452E-05_JPRB, 0.27615199E-05_JPRB, 0.27338187E-05_JPRB, 0.27018634E-05_JPRB, 0.26662112E-05_JPRB, &
  & 0.26264595E-05_JPRB, 0.25829163E-05_JPRB, 0.25318980E-05_JPRB, 0.24701369E-05_JPRB, 0.23987318E-05_JPRB, 0.23132950E-05_JPRB, &
  & 0.22185764E-05_JPRB, 0.21218709E-05_JPRB, 0.20302414E-05_JPRB, 0.19542954E-05_JPRB, 0.19033395E-05_JPRB, 0.18836425E-05_JPRB, &
  & 0.18981548E-05_JPRB, 0.19453601E-05_JPRB, 0.20204579E-05_JPRB, 0.21160731E-05_JPRB, 0.22194038E-05_JPRB, 0.23250959E-05_JPRB, &
  & 0.24239937E-05_JPRB, 0.25149543E-05_JPRB, 0.25981039E-05_JPRB, 0.26738612E-05_JPRB, 0.27438314E-05_JPRB, 0.28069569E-05_JPRB, &
  & 0.28642025E-05_JPRB, 0.29142982E-05_JPRB, 0.29558880E-05_JPRB, 0.29884611E-05_JPRB, 0.30123961E-05_JPRB, 0.30289470E-05_JPRB, &
  & 0.30401388E-05_JPRB, 0.30474387E-05_JPRB, 0.30518352E-05_JPRB, 0.30543947E-05_JPRB, 0.30566903E-05_JPRB, 0.30604278E-05_JPRB, &
  & 0.30671506E-05_JPRB, 0.30796298E-05_JPRB, 0.31015807E-05_JPRB, 0.31502202E-05_JPRB /)

RGHG7(:,30, 9) = (/ &
  & 0.31406671E-06_JPRB, 0.36635367E-06_JPRB, 0.40865660E-06_JPRB, 0.45222845E-06_JPRB, 0.50991787E-06_JPRB, 0.58730774E-06_JPRB, &
  & 0.70086554E-06_JPRB, 0.85660309E-06_JPRB, 0.10543346E-05_JPRB, 0.12782754E-05_JPRB, 0.15106625E-05_JPRB, 0.17354237E-05_JPRB, &
  & 0.19378922E-05_JPRB, 0.21069959E-05_JPRB, 0.22371673E-05_JPRB, 0.23284381E-05_JPRB, 0.23805387E-05_JPRB, 0.24035214E-05_JPRB, &
  & 0.24056428E-05_JPRB, 0.23932234E-05_JPRB, 0.23730888E-05_JPRB, 0.23483879E-05_JPRB, 0.23205941E-05_JPRB, 0.22905745E-05_JPRB, &
  & 0.22567474E-05_JPRB, 0.22178529E-05_JPRB, 0.21705812E-05_JPRB, 0.21113960E-05_JPRB, 0.20382238E-05_JPRB, 0.19510358E-05_JPRB, &
  & 0.18523417E-05_JPRB, 0.17500843E-05_JPRB, 0.16530389E-05_JPRB, 0.15724221E-05_JPRB, 0.15176454E-05_JPRB, 0.14953413E-05_JPRB, &
  & 0.15081986E-05_JPRB, 0.15544833E-05_JPRB, 0.16289347E-05_JPRB, 0.17254657E-05_JPRB, 0.18329069E-05_JPRB, 0.19423187E-05_JPRB, &
  & 0.20491641E-05_JPRB, 0.21474218E-05_JPRB, 0.22387844E-05_JPRB, 0.23231155E-05_JPRB, 0.24002670E-05_JPRB, 0.24707415E-05_JPRB, &
  & 0.25341312E-05_JPRB, 0.25906179E-05_JPRB, 0.26398304E-05_JPRB, 0.26810360E-05_JPRB, 0.27145506E-05_JPRB, 0.27417880E-05_JPRB, &
  & 0.27642575E-05_JPRB, 0.27829378E-05_JPRB, 0.27988792E-05_JPRB, 0.28134123E-05_JPRB, 0.28276049E-05_JPRB, 0.28420914E-05_JPRB, &
  & 0.28577060E-05_JPRB, 0.28755803E-05_JPRB, 0.28989762E-05_JPRB, 0.29473863E-05_JPRB /)

RGHG7(:,31, 9) = (/ &
  & 0.31002224E-06_JPRB, 0.35893044E-06_JPRB, 0.39462185E-06_JPRB, 0.43383835E-06_JPRB, 0.47953040E-06_JPRB, 0.54558211E-06_JPRB, &
  & 0.63891190E-06_JPRB, 0.76928711E-06_JPRB, 0.93775321E-06_JPRB, 0.11295995E-05_JPRB, 0.13299656E-05_JPRB, 0.15235738E-05_JPRB, &
  & 0.16974692E-05_JPRB, 0.18417526E-05_JPRB, 0.19517606E-05_JPRB, 0.20262326E-05_JPRB, 0.20659579E-05_JPRB, 0.20795574E-05_JPRB, &
  & 0.20745592E-05_JPRB, 0.20581251E-05_JPRB, 0.20355014E-05_JPRB, 0.20097648E-05_JPRB, 0.19835220E-05_JPRB, 0.19553702E-05_JPRB, &
  & 0.19247962E-05_JPRB, 0.18885916E-05_JPRB, 0.18432975E-05_JPRB, 0.17870599E-05_JPRB, 0.17164831E-05_JPRB, 0.16318176E-05_JPRB, &
  & 0.15355557E-05_JPRB, 0.14355038E-05_JPRB, 0.13406523E-05_JPRB, 0.12623264E-05_JPRB, 0.12092410E-05_JPRB, 0.11876069E-05_JPRB, &
  & 0.11996668E-05_JPRB, 0.12436660E-05_JPRB, 0.13146877E-05_JPRB, 0.14067413E-05_JPRB, 0.15118385E-05_JPRB, 0.16209615E-05_JPRB, &
  & 0.17273909E-05_JPRB, 0.18294261E-05_JPRB, 0.19240597E-05_JPRB, 0.20125531E-05_JPRB, 0.20945602E-05_JPRB, 0.21689461E-05_JPRB, &
  & 0.22363333E-05_JPRB, 0.22969418E-05_JPRB, 0.23508501E-05_JPRB, 0.23984160E-05_JPRB, 0.24398885E-05_JPRB, 0.24763594E-05_JPRB, &
  & 0.25085349E-05_JPRB, 0.25370048E-05_JPRB, 0.25628442E-05_JPRB, 0.25864474E-05_JPRB, 0.26078001E-05_JPRB, 0.26274981E-05_JPRB, &
  & 0.26465955E-05_JPRB, 0.26675821E-05_JPRB, 0.26953783E-05_JPRB, 0.27560068E-05_JPRB /)

RGHG7(:,32, 9) = (/ &
  & 0.31722470E-06_JPRB, 0.36139420E-06_JPRB, 0.39283364E-06_JPRB, 0.42634167E-06_JPRB, 0.46826159E-06_JPRB, 0.52348355E-06_JPRB, &
  & 0.60504334E-06_JPRB, 0.71866907E-06_JPRB, 0.86528149E-06_JPRB, 0.10319499E-05_JPRB, 0.12038807E-05_JPRB, 0.13685841E-05_JPRB, &
  & 0.15146951E-05_JPRB, 0.16336846E-05_JPRB, 0.17217384E-05_JPRB, 0.17777601E-05_JPRB, 0.18035504E-05_JPRB, 0.18063289E-05_JPRB, &
  & 0.17926271E-05_JPRB, 0.17689537E-05_JPRB, 0.17415502E-05_JPRB, 0.17130033E-05_JPRB, 0.16841057E-05_JPRB, 0.16555359E-05_JPRB, &
  & 0.16250376E-05_JPRB, 0.15899622E-05_JPRB, 0.15469246E-05_JPRB, 0.14934103E-05_JPRB, 0.14269854E-05_JPRB, 0.13474266E-05_JPRB, &
  & 0.12576937E-05_JPRB, 0.11648226E-05_JPRB, 0.10773996E-05_JPRB, 0.10059922E-05_JPRB, 0.95812754E-06_JPRB, 0.93929503E-06_JPRB, &
  & 0.95110653E-06_JPRB, 0.99184365E-06_JPRB, 0.10580901E-05_JPRB, 0.11427186E-05_JPRB, 0.12410577E-05_JPRB, 0.13465996E-05_JPRB, &
  & 0.14500722E-05_JPRB, 0.15503646E-05_JPRB, 0.16461918E-05_JPRB, 0.17360746E-05_JPRB, 0.18191462E-05_JPRB, 0.18962039E-05_JPRB, &
  & 0.19662832E-05_JPRB, 0.20303469E-05_JPRB, 0.20884729E-05_JPRB, 0.21412852E-05_JPRB, 0.21888227E-05_JPRB, 0.22322370E-05_JPRB, &
  & 0.22719503E-05_JPRB, 0.23080900E-05_JPRB, 0.23413108E-05_JPRB, 0.23712294E-05_JPRB, 0.23985049E-05_JPRB, 0.24241733E-05_JPRB, &
  & 0.24494711E-05_JPRB, 0.24759515E-05_JPRB, 0.25086899E-05_JPRB, 0.25661086E-05_JPRB /)

RGHG7(:,33, 9) = (/ &
  & 0.32718606E-06_JPRB, 0.37175116E-06_JPRB, 0.40112235E-06_JPRB, 0.43216110E-06_JPRB, 0.46910154E-06_JPRB, 0.52073335E-06_JPRB, &
  & 0.59388964E-06_JPRB, 0.69574577E-06_JPRB, 0.82446968E-06_JPRB, 0.96850158E-06_JPRB, 0.11151629E-05_JPRB, 0.12530289E-05_JPRB, &
  & 0.13724534E-05_JPRB, 0.14669329E-05_JPRB, 0.15332706E-05_JPRB, 0.15710541E-05_JPRB, 0.15828570E-05_JPRB, 0.15744557E-05_JPRB, &
  & 0.15517235E-05_JPRB, 0.15213657E-05_JPRB, 0.14865850E-05_JPRB, 0.14513000E-05_JPRB, 0.14178512E-05_JPRB, 0.13861729E-05_JPRB, &
  & 0.13533324E-05_JPRB, 0.13178176E-05_JPRB, 0.12761036E-05_JPRB, 0.12256987E-05_JPRB, 0.11643316E-05_JPRB, 0.10919950E-05_JPRB, &
  & 0.10113449E-05_JPRB, 0.92889263E-06_JPRB, 0.85225582E-06_JPRB, 0.79049386E-06_JPRB, 0.75007819E-06_JPRB, 0.73523933E-06_JPRB, &
  & 0.74713074E-06_JPRB, 0.78443276E-06_JPRB, 0.84452267E-06_JPRB, 0.92091943E-06_JPRB, 0.10104644E-05_JPRB, 0.11091940E-05_JPRB, &
  & 0.12083166E-05_JPRB, 0.13050515E-05_JPRB, 0.13984932E-05_JPRB, 0.14885396E-05_JPRB, 0.15722090E-05_JPRB, 0.16496638E-05_JPRB, &
  & 0.17215139E-05_JPRB, 0.17875623E-05_JPRB, 0.18487419E-05_JPRB, 0.19055244E-05_JPRB, 0.19581094E-05_JPRB, 0.20070127E-05_JPRB, &
  & 0.20524433E-05_JPRB, 0.20943912E-05_JPRB, 0.21330745E-05_JPRB, 0.21687408E-05_JPRB, 0.22018733E-05_JPRB, 0.22325810E-05_JPRB, &
  & 0.22612451E-05_JPRB, 0.22893732E-05_JPRB, 0.23212535E-05_JPRB, 0.23862235E-05_JPRB /)

RGHG7(:,34, 9) = (/ &
  & 0.34531033E-06_JPRB, 0.38707196E-06_JPRB, 0.41680357E-06_JPRB, 0.44489897E-06_JPRB, 0.48070910E-06_JPRB, 0.52763369E-06_JPRB, &
  & 0.59579412E-06_JPRB, 0.68823692E-06_JPRB, 0.80150568E-06_JPRB, 0.92581752E-06_JPRB, 0.10491353E-05_JPRB, 0.11621541E-05_JPRB, &
  & 0.12571867E-05_JPRB, 0.13292869E-05_JPRB, 0.13756572E-05_JPRB, 0.13968216E-05_JPRB, 0.13953684E-05_JPRB, 0.13761586E-05_JPRB, &
  & 0.13441011E-05_JPRB, 0.13048523E-05_JPRB, 0.12616636E-05_JPRB, 0.12200836E-05_JPRB, 0.11804049E-05_JPRB, 0.11430891E-05_JPRB, &
  & 0.11066772E-05_JPRB, 0.10693822E-05_JPRB, 0.10285249E-05_JPRB, 0.98115925E-06_JPRB, 0.92562692E-06_JPRB, 0.86162856E-06_JPRB, &
  & 0.79184849E-06_JPRB, 0.72167745E-06_JPRB, 0.65768126E-06_JPRB, 0.60712222E-06_JPRB, 0.57520367E-06_JPRB, 0.56494207E-06_JPRB, &
  & 0.57716198E-06_JPRB, 0.61101878E-06_JPRB, 0.66433057E-06_JPRB, 0.73197964E-06_JPRB, 0.81329705E-06_JPRB, 0.90300887E-06_JPRB, &
  & 0.99606507E-06_JPRB, 0.10891457E-05_JPRB, 0.11784156E-05_JPRB, 0.12664210E-05_JPRB, 0.13508441E-05_JPRB, 0.14273656E-05_JPRB, &
  & 0.15000267E-05_JPRB, 0.15678136E-05_JPRB, 0.16313352E-05_JPRB, 0.16908376E-05_JPRB, 0.17471103E-05_JPRB, 0.18000432E-05_JPRB, &
  & 0.18493504E-05_JPRB, 0.18955053E-05_JPRB, 0.19386503E-05_JPRB, 0.19785880E-05_JPRB, 0.20153843E-05_JPRB, 0.20488887E-05_JPRB, &
  & 0.20798971E-05_JPRB, 0.21103422E-05_JPRB, 0.21468077E-05_JPRB, 0.22114900E-05_JPRB /)

RGHG7(:,35, 9) = (/ &
  & 0.36413925E-06_JPRB, 0.40364415E-06_JPRB, 0.43519495E-06_JPRB, 0.46347813E-06_JPRB, 0.49716226E-06_JPRB, 0.54285897E-06_JPRB, &
  & 0.60607266E-06_JPRB, 0.69038327E-06_JPRB, 0.79025949E-06_JPRB, 0.89553856E-06_JPRB, 0.99732392E-06_JPRB, 0.10877160E-05_JPRB, &
  & 0.11608456E-05_JPRB, 0.12129182E-05_JPRB, 0.12418698E-05_JPRB, 0.12484110E-05_JPRB, 0.12353961E-05_JPRB, 0.12059749E-05_JPRB, &
  & 0.11657268E-05_JPRB, 0.11178329E-05_JPRB, 0.10670714E-05_JPRB, 0.10168686E-05_JPRB, 0.96910242E-06_JPRB, 0.92472942E-06_JPRB, &
  & 0.88349401E-06_JPRB, 0.84369248E-06_JPRB, 0.80310843E-06_JPRB, 0.75912988E-06_JPRB, 0.70987812E-06_JPRB, 0.65528786E-06_JPRB, &
  & 0.59735328E-06_JPRB, 0.54049065E-06_JPRB, 0.48995975E-06_JPRB, 0.45106378E-06_JPRB, 0.42779445E-06_JPRB, 0.42208069E-06_JPRB, &
  & 0.43459715E-06_JPRB, 0.46495038E-06_JPRB, 0.51131298E-06_JPRB, 0.57078176E-06_JPRB, 0.64313463E-06_JPRB, 0.72451161E-06_JPRB, &
  & 0.81133277E-06_JPRB, 0.89825727E-06_JPRB, 0.98400892E-06_JPRB, 0.10693818E-05_JPRB, 0.11530886E-05_JPRB, 0.12288200E-05_JPRB, &
  & 0.13011554E-05_JPRB, 0.13702316E-05_JPRB, 0.14352726E-05_JPRB, 0.14966272E-05_JPRB, 0.15552889E-05_JPRB, 0.16108743E-05_JPRB, &
  & 0.16625469E-05_JPRB, 0.17113915E-05_JPRB, 0.17570400E-05_JPRB, 0.17995567E-05_JPRB, 0.18389256E-05_JPRB, 0.18751176E-05_JPRB, &
  & 0.19085646E-05_JPRB, 0.19410222E-05_JPRB, 0.19769589E-05_JPRB, 0.20448397E-05_JPRB /)

RGHG7(:,36, 9) = (/ &
  & 0.37850219E-06_JPRB, 0.42398045E-06_JPRB, 0.45531525E-06_JPRB, 0.48386232E-06_JPRB, 0.51778267E-06_JPRB, 0.56122985E-06_JPRB, &
  & 0.62086019E-06_JPRB, 0.69720937E-06_JPRB, 0.78356982E-06_JPRB, 0.87177858E-06_JPRB, 0.95384769E-06_JPRB, 0.10240177E-05_JPRB, &
  & 0.10777475E-05_JPRB, 0.11123832E-05_JPRB, 0.11264697E-05_JPRB, 0.11206516E-05_JPRB, 0.10980909E-05_JPRB, 0.10605569E-05_JPRB, &
  & 0.10124489E-05_JPRB, 0.95769281E-06_JPRB, 0.89873942E-06_JPRB, 0.83949732E-06_JPRB, 0.78318726E-06_JPRB, 0.73156639E-06_JPRB, &
  & 0.68539021E-06_JPRB, 0.64345028E-06_JPRB, 0.60347617E-06_JPRB, 0.56318657E-06_JPRB, 0.52089206E-06_JPRB, 0.47608751E-06_JPRB, &
  & 0.43036201E-06_JPRB, 0.38691792E-06_JPRB, 0.34943901E-06_JPRB, 0.32171860E-06_JPRB, 0.30623949E-06_JPRB, 0.30426668E-06_JPRB, &
  & 0.31640567E-06_JPRB, 0.34266776E-06_JPRB, 0.38197939E-06_JPRB, 0.43303504E-06_JPRB, 0.49703920E-06_JPRB, 0.57096776E-06_JPRB, &
  & 0.64989945E-06_JPRB, 0.73020550E-06_JPRB, 0.81334338E-06_JPRB, 0.89626991E-06_JPRB, 0.97674035E-06_JPRB, 0.10523820E-05_JPRB, &
  & 0.11241366E-05_JPRB, 0.11942698E-05_JPRB, 0.12603944E-05_JPRB, 0.13228228E-05_JPRB, 0.13824726E-05_JPRB, 0.14391726E-05_JPRB, &
  & 0.14916727E-05_JPRB, 0.15412736E-05_JPRB, 0.15881071E-05_JPRB, 0.16320093E-05_JPRB, 0.16729864E-05_JPRB, 0.17107005E-05_JPRB, &
  & 0.17453362E-05_JPRB, 0.17784822E-05_JPRB, 0.18163547E-05_JPRB, 0.18850046E-05_JPRB /)

RGHG7(:,37, 9) = (/ &
  & 0.39822666E-06_JPRB, 0.44702642E-06_JPRB, 0.47740076E-06_JPRB, 0.50671468E-06_JPRB, 0.54050349E-06_JPRB, 0.58378356E-06_JPRB, &
  & 0.63929247E-06_JPRB, 0.70662412E-06_JPRB, 0.77958788E-06_JPRB, 0.85103483E-06_JPRB, 0.91497481E-06_JPRB, 0.96701046E-06_JPRB, &
  & 0.10037721E-05_JPRB, 0.10234559E-05_JPRB, 0.10251892E-05_JPRB, 0.10098232E-05_JPRB, 0.97884242E-06_JPRB, 0.93659924E-06_JPRB, &
  & 0.88230297E-06_JPRB, 0.82036735E-06_JPRB, 0.75456558E-06_JPRB, 0.68797721E-06_JPRB, 0.62502107E-06_JPRB, 0.56892645E-06_JPRB, &
  & 0.52039547E-06_JPRB, 0.47862221E-06_JPRB, 0.44113870E-06_JPRB, 0.40562350E-06_JPRB, 0.37051527E-06_JPRB, 0.33532027E-06_JPRB, &
  & 0.30096558E-06_JPRB, 0.26951361E-06_JPRB, 0.24342643E-06_JPRB, 0.22494177E-06_JPRB, 0.21547521E-06_JPRB, 0.21568762E-06_JPRB, &
  & 0.22607828E-06_JPRB, 0.24709402E-06_JPRB, 0.27824564E-06_JPRB, 0.32017388E-06_JPRB, 0.37517788E-06_JPRB, 0.43944723E-06_JPRB, &
  & 0.50975240E-06_JPRB, 0.58571220E-06_JPRB, 0.66493436E-06_JPRB, 0.74381671E-06_JPRB, 0.82142623E-06_JPRB, 0.89629202E-06_JPRB, &
  & 0.96824147E-06_JPRB, 0.10379807E-05_JPRB, 0.11044178E-05_JPRB, 0.11674732E-05_JPRB, 0.12273568E-05_JPRB, 0.12835487E-05_JPRB, &
  & 0.13355467E-05_JPRB, 0.13846860E-05_JPRB, 0.14311638E-05_JPRB, 0.14750539E-05_JPRB, 0.15163780E-05_JPRB, 0.15545442E-05_JPRB, &
  & 0.15897338E-05_JPRB, 0.16237742E-05_JPRB, 0.16618819E-05_JPRB, 0.17314176E-05_JPRB /)

RGHG7(:,38, 9) = (/ &
  & 0.42700975E-06_JPRB, 0.47015070E-06_JPRB, 0.49981548E-06_JPRB, 0.52959041E-06_JPRB, 0.56405588E-06_JPRB, 0.60572586E-06_JPRB, &
  & 0.65637778E-06_JPRB, 0.71398659E-06_JPRB, 0.77337444E-06_JPRB, 0.82914073E-06_JPRB, 0.87672385E-06_JPRB, 0.91286552E-06_JPRB, &
  & 0.93540109E-06_JPRB, 0.94294955E-06_JPRB, 0.93501575E-06_JPRB, 0.91255680E-06_JPRB, 0.87619554E-06_JPRB, 0.82805309E-06_JPRB, &
  & 0.77132188E-06_JPRB, 0.70589556E-06_JPRB, 0.63543513E-06_JPRB, 0.56553205E-06_JPRB, 0.50100749E-06_JPRB, 0.44529605E-06_JPRB, &
  & 0.39944004E-06_JPRB, 0.36132437E-06_JPRB, 0.32838517E-06_JPRB, 0.29832719E-06_JPRB, 0.26985597E-06_JPRB, 0.24248263E-06_JPRB, &
  & 0.21683161E-06_JPRB, 0.19421316E-06_JPRB, 0.17612710E-06_JPRB, 0.16388672E-06_JPRB, 0.15818732E-06_JPRB, 0.15919289E-06_JPRB, &
  & 0.16731990E-06_JPRB, 0.18286438E-06_JPRB, 0.20585588E-06_JPRB, 0.23802475E-06_JPRB, 0.28159272E-06_JPRB, 0.33386948E-06_JPRB, &
  & 0.39520356E-06_JPRB, 0.46395641E-06_JPRB, 0.53686534E-06_JPRB, 0.61135842E-06_JPRB, 0.68644806E-06_JPRB, 0.75971099E-06_JPRB, &
  & 0.83108381E-06_JPRB, 0.90041613E-06_JPRB, 0.96687450E-06_JPRB, 0.10296350E-05_JPRB, 0.10884897E-05_JPRB, 0.11429884E-05_JPRB, &
  & 0.11933206E-05_JPRB, 0.12405416E-05_JPRB, 0.12854300E-05_JPRB, 0.13282408E-05_JPRB, 0.13688502E-05_JPRB, 0.14066255E-05_JPRB, &
  & 0.14417550E-05_JPRB, 0.14756705E-05_JPRB, 0.15138041E-05_JPRB, 0.15836708E-05_JPRB /)

RGHG7(:,39, 9) = (/ &
  & 0.44865436E-06_JPRB, 0.49278759E-06_JPRB, 0.52304364E-06_JPRB, 0.55379439E-06_JPRB, 0.58803539E-06_JPRB, 0.62794203E-06_JPRB, &
  & 0.67262931E-06_JPRB, 0.71942100E-06_JPRB, 0.76476317E-06_JPRB, 0.80522983E-06_JPRB, 0.83763462E-06_JPRB, 0.86011494E-06_JPRB, &
  & 0.87088807E-06_JPRB, 0.86909125E-06_JPRB, 0.85429394E-06_JPRB, 0.82695061E-06_JPRB, 0.78841271E-06_JPRB, 0.73874207E-06_JPRB, &
  & 0.67948145E-06_JPRB, 0.61293781E-06_JPRB, 0.54263967E-06_JPRB, 0.47364054E-06_JPRB, 0.41225508E-06_JPRB, 0.36141100E-06_JPRB, &
  & 0.32051727E-06_JPRB, 0.28736883E-06_JPRB, 0.25912161E-06_JPRB, 0.23379326E-06_JPRB, 0.21034849E-06_JPRB, 0.18841152E-06_JPRB, &
  & 0.16840725E-06_JPRB, 0.15124375E-06_JPRB, 0.13796188E-06_JPRB, 0.12936083E-06_JPRB, 0.12572642E-06_JPRB, 0.12703009E-06_JPRB, &
  & 0.13338665E-06_JPRB, 0.14502494E-06_JPRB, 0.16180999E-06_JPRB, 0.18560858E-06_JPRB, 0.21831153E-06_JPRB, 0.25849573E-06_JPRB, &
  & 0.30846357E-06_JPRB, 0.36666913E-06_JPRB, 0.43087067E-06_JPRB, 0.49962642E-06_JPRB, 0.57051273E-06_JPRB, 0.64113459E-06_JPRB, &
  & 0.71128181E-06_JPRB, 0.77983304E-06_JPRB, 0.84559917E-06_JPRB, 0.90744396E-06_JPRB, 0.96445365E-06_JPRB, 0.10163577E-05_JPRB, &
  & 0.10639083E-05_JPRB, 0.11083314E-05_JPRB, 0.11507107E-05_JPRB, 0.11913154E-05_JPRB, 0.12302795E-05_JPRB, 0.12667903E-05_JPRB, &
  & 0.13009591E-05_JPRB, 0.13341838E-05_JPRB, 0.13721318E-05_JPRB, 0.14410800E-05_JPRB /)

RGHG7(:,40, 9) = (/ &
  & 0.47050275E-06_JPRB, 0.51567167E-06_JPRB, 0.54672483E-06_JPRB, 0.57711435E-06_JPRB, 0.61088008E-06_JPRB, 0.64684639E-06_JPRB, &
  & 0.68356155E-06_JPRB, 0.71918453E-06_JPRB, 0.75105805E-06_JPRB, 0.77757028E-06_JPRB, 0.79699947E-06_JPRB, 0.80794274E-06_JPRB, &
  & 0.80946160E-06_JPRB, 0.80076819E-06_JPRB, 0.78150111E-06_JPRB, 0.75169675E-06_JPRB, 0.71171547E-06_JPRB, 0.66263021E-06_JPRB, &
  & 0.60458098E-06_JPRB, 0.53985457E-06_JPRB, 0.47185435E-06_JPRB, 0.40744669E-06_JPRB, 0.35143074E-06_JPRB, 0.30603880E-06_JPRB, &
  & 0.27023188E-06_JPRB, 0.24132706E-06_JPRB, 0.21684421E-06_JPRB, 0.19507505E-06_JPRB, 0.17514348E-06_JPRB, 0.15674543E-06_JPRB, &
  & 0.14025359E-06_JPRB, 0.12634156E-06_JPRB, 0.11584991E-06_JPRB, 0.10931522E-06_JPRB, 0.10685058E-06_JPRB, 0.10827929E-06_JPRB, &
  & 0.11359268E-06_JPRB, 0.12280226E-06_JPRB, 0.13567637E-06_JPRB, 0.15375070E-06_JPRB, 0.17828857E-06_JPRB, 0.20863523E-06_JPRB, &
  & 0.24751839E-06_JPRB, 0.29398356E-06_JPRB, 0.34767572E-06_JPRB, 0.40835624E-06_JPRB, 0.47304670E-06_JPRB, 0.53988845E-06_JPRB, &
  & 0.60804348E-06_JPRB, 0.67495949E-06_JPRB, 0.73941499E-06_JPRB, 0.79949689E-06_JPRB, 0.85388422E-06_JPRB, 0.90264115E-06_JPRB, &
  & 0.94671958E-06_JPRB, 0.98769726E-06_JPRB, 0.10266918E-05_JPRB, 0.10645366E-05_JPRB, 0.11009895E-05_JPRB, 0.11355314E-05_JPRB, &
  & 0.11680982E-05_JPRB, 0.12001917E-05_JPRB, 0.12366290E-05_JPRB, 0.13042677E-05_JPRB /)

RGHG7(:,41, 9) = (/ &
  & 0.49774462E-06_JPRB, 0.54095995E-06_JPRB, 0.56999954E-06_JPRB, 0.59992010E-06_JPRB, 0.63028131E-06_JPRB, 0.66044015E-06_JPRB, &
  & 0.68845810E-06_JPRB, 0.71233484E-06_JPRB, 0.73149522E-06_JPRB, 0.74571187E-06_JPRB, 0.75411327E-06_JPRB, 0.75593880E-06_JPRB, &
  & 0.75043334E-06_JPRB, 0.73699567E-06_JPRB, 0.71514654E-06_JPRB, 0.68474128E-06_JPRB, 0.64575602E-06_JPRB, 0.59810731E-06_JPRB, &
  & 0.54277399E-06_JPRB, 0.48096604E-06_JPRB, 0.41779407E-06_JPRB, 0.35837024E-06_JPRB, 0.30809190E-06_JPRB, 0.26788470E-06_JPRB, &
  & 0.23624251E-06_JPRB, 0.21069721E-06_JPRB, 0.18908659E-06_JPRB, 0.16991682E-06_JPRB, 0.15247154E-06_JPRB, 0.13649823E-06_JPRB, &
  & 0.12226245E-06_JPRB, 0.11041273E-06_JPRB, 0.10161877E-06_JPRB, 0.96361106E-07_JPRB, 0.94589147E-07_JPRB, 0.96109751E-07_JPRB, &
  & 0.10075988E-06_JPRB, 0.10850471E-06_JPRB, 0.11896136E-06_JPRB, 0.13321076E-06_JPRB, 0.15236530E-06_JPRB, 0.17556400E-06_JPRB, &
  & 0.20546958E-06_JPRB, 0.24152862E-06_JPRB, 0.28465496E-06_JPRB, 0.33538629E-06_JPRB, 0.39263119E-06_JPRB, 0.45440976E-06_JPRB, &
  & 0.51913634E-06_JPRB, 0.58383898E-06_JPRB, 0.64641176E-06_JPRB, 0.70417957E-06_JPRB, 0.75552367E-06_JPRB, 0.80061574E-06_JPRB, &
  & 0.84086253E-06_JPRB, 0.87787862E-06_JPRB, 0.91322727E-06_JPRB, 0.94764061E-06_JPRB, 0.98112480E-06_JPRB, 0.10130625E-05_JPRB, &
  & 0.10434501E-05_JPRB, 0.10735107E-05_JPRB, 0.11084253E-05_JPRB, 0.11729950E-05_JPRB /)

RGHG7(:,42, 9) = (/ &
  & 0.52714108E-06_JPRB, 0.56640732E-06_JPRB, 0.59273492E-06_JPRB, 0.61726621E-06_JPRB, 0.64226310E-06_JPRB, 0.66481334E-06_JPRB, &
  & 0.68292479E-06_JPRB, 0.69605500E-06_JPRB, 0.70419333E-06_JPRB, 0.70827610E-06_JPRB, 0.70804714E-06_JPRB, 0.70299683E-06_JPRB, &
  & 0.69257146E-06_JPRB, 0.67618788E-06_JPRB, 0.65329800E-06_JPRB, 0.62349909E-06_JPRB, 0.58641700E-06_JPRB, 0.54188939E-06_JPRB, &
  & 0.48980854E-06_JPRB, 0.43258075E-06_JPRB, 0.37379357E-06_JPRB, 0.32015683E-06_JPRB, 0.27515057E-06_JPRB, 0.23945583E-06_JPRB, &
  & 0.21134447E-06_JPRB, 0.18852678E-06_JPRB, 0.16915361E-06_JPRB, 0.15201151E-06_JPRB, 0.13641775E-06_JPRB, 0.12217610E-06_JPRB, &
  & 0.10953269E-06_JPRB, 0.99052585E-07_JPRB, 0.91406179E-07_JPRB, 0.86974346E-07_JPRB, 0.85662890E-07_JPRB, 0.87233865E-07_JPRB, &
  & 0.91449969E-07_JPRB, 0.98223353E-07_JPRB, 0.10709034E-06_JPRB, 0.11883029E-06_JPRB, 0.13428087E-06_JPRB, 0.15252904E-06_JPRB, &
  & 0.17574027E-06_JPRB, 0.20360825E-06_JPRB, 0.23708627E-06_JPRB, 0.27850479E-06_JPRB, 0.32714632E-06_JPRB, 0.38282718E-06_JPRB, &
  & 0.44328405E-06_JPRB, 0.50488046E-06_JPRB, 0.56480997E-06_JPRB, 0.61972474E-06_JPRB, 0.66753393E-06_JPRB, 0.70887103E-06_JPRB, &
  & 0.74501168E-06_JPRB, 0.77796813E-06_JPRB, 0.80931392E-06_JPRB, 0.84009662E-06_JPRB, 0.87016912E-06_JPRB, 0.89912476E-06_JPRB, &
  & 0.92675606E-06_JPRB, 0.95448456E-06_JPRB, 0.98668477E-06_JPRB, 0.10473234E-05_JPRB /)

RGHG7(:,43, 9) = (/ &
  & 0.55558985E-06_JPRB, 0.58759008E-06_JPRB, 0.60699915E-06_JPRB, 0.62551067E-06_JPRB, 0.64271927E-06_JPRB, 0.65636971E-06_JPRB, &
  & 0.66500621E-06_JPRB, 0.66841108E-06_JPRB, 0.66751886E-06_JPRB, 0.66390760E-06_JPRB, 0.65746912E-06_JPRB, 0.64776327E-06_JPRB, &
  & 0.63430605E-06_JPRB, 0.61647700E-06_JPRB, 0.59378021E-06_JPRB, 0.56560066E-06_JPRB, 0.53139161E-06_JPRB, 0.49031786E-06_JPRB, &
  & 0.44267517E-06_JPRB, 0.38966994E-06_JPRB, 0.33661195E-06_JPRB, 0.28843405E-06_JPRB, 0.24867015E-06_JPRB, 0.21702226E-06_JPRB, &
  & 0.19188626E-06_JPRB, 0.17134099E-06_JPRB, 0.15382103E-06_JPRB, 0.13829325E-06_JPRB, 0.12416081E-06_JPRB, 0.11123480E-06_JPRB, &
  & 0.99743836E-07_JPRB, 0.90261963E-07_JPRB, 0.83415301E-07_JPRB, 0.79565346E-07_JPRB, 0.78571830E-07_JPRB, 0.80158365E-07_JPRB, &
  & 0.84045332E-07_JPRB, 0.90140958E-07_JPRB, 0.97930680E-07_JPRB, 0.10786179E-06_JPRB, 0.12078590E-06_JPRB, 0.13548687E-06_JPRB, &
  & 0.15377813E-06_JPRB, 0.17526327E-06_JPRB, 0.20109007E-06_JPRB, 0.23364397E-06_JPRB, 0.27391488E-06_JPRB, 0.32260547E-06_JPRB, &
  & 0.37780191E-06_JPRB, 0.43570182E-06_JPRB, 0.49242846E-06_JPRB, 0.54401590E-06_JPRB, 0.58831449E-06_JPRB, 0.62569075E-06_JPRB, &
  & 0.65771786E-06_JPRB, 0.68648797E-06_JPRB, 0.71380958E-06_JPRB, 0.74070323E-06_JPRB, 0.76725723E-06_JPRB, 0.79295722E-06_JPRB, &
  & 0.81763983E-06_JPRB, 0.84244363E-06_JPRB, 0.87157628E-06_JPRB, 0.92669660E-06_JPRB /)

RGHG7(:,44, 9) = (/ &
  & 0.57538603E-06_JPRB, 0.59578298E-06_JPRB, 0.60796424E-06_JPRB, 0.61871759E-06_JPRB, 0.62773466E-06_JPRB, 0.63260052E-06_JPRB, &
  & 0.63255243E-06_JPRB, 0.62810932E-06_JPRB, 0.62050799E-06_JPRB, 0.61161614E-06_JPRB, 0.60125666E-06_JPRB, 0.58894335E-06_JPRB, &
  & 0.57406464E-06_JPRB, 0.55615823E-06_JPRB, 0.53455040E-06_JPRB, 0.50876872E-06_JPRB, 0.47783243E-06_JPRB, 0.44113921E-06_JPRB, &
  & 0.39789322E-06_JPRB, 0.35067234E-06_JPRB, 0.30324551E-06_JPRB, 0.26119147E-06_JPRB, 0.22638139E-06_JPRB, 0.19847165E-06_JPRB, &
  & 0.17600148E-06_JPRB, 0.15741949E-06_JPRB, 0.14147436E-06_JPRB, 0.12729178E-06_JPRB, 0.11433051E-06_JPRB, 0.10243332E-06_JPRB, &
  & 0.91830351E-07_JPRB, 0.83081432E-07_JPRB, 0.76842561E-07_JPRB, 0.73399129E-07_JPRB, 0.72631593E-07_JPRB, 0.74196315E-07_JPRB, &
  & 0.77827536E-07_JPRB, 0.83407507E-07_JPRB, 0.90410424E-07_JPRB, 0.99058532E-07_JPRB, 0.11012038E-06_JPRB, 0.12222993E-06_JPRB, &
  & 0.13681777E-06_JPRB, 0.15348819E-06_JPRB, 0.17297046E-06_JPRB, 0.19801955E-06_JPRB, 0.23013089E-06_JPRB, 0.27128419E-06_JPRB, &
  & 0.32089579E-06_JPRB, 0.37441535E-06_JPRB, 0.42747567E-06_JPRB, 0.47555994E-06_JPRB, 0.51593582E-06_JPRB, 0.54935214E-06_JPRB, &
  & 0.57721275E-06_JPRB, 0.60184306E-06_JPRB, 0.62510935E-06_JPRB, 0.64817499E-06_JPRB, 0.67116190E-06_JPRB, 0.69359902E-06_JPRB, &
  & 0.71516251E-06_JPRB, 0.73690495E-06_JPRB, 0.76237887E-06_JPRB, 0.81090366E-06_JPRB /)

RGHG7(:,45, 9) = (/ &
  & 0.57299013E-06_JPRB, 0.58173424E-06_JPRB, 0.58738931E-06_JPRB, 0.59198675E-06_JPRB, 0.59401594E-06_JPRB, 0.59156133E-06_JPRB, &
  & 0.58476826E-06_JPRB, 0.57483373E-06_JPRB, 0.56297552E-06_JPRB, 0.55115612E-06_JPRB, 0.53900527E-06_JPRB, 0.52578724E-06_JPRB, &
  & 0.51105229E-06_JPRB, 0.49403252E-06_JPRB, 0.47442154E-06_JPRB, 0.45139080E-06_JPRB, 0.42432791E-06_JPRB, 0.39185699E-06_JPRB, &
  & 0.35450367E-06_JPRB, 0.31316063E-06_JPRB, 0.27304358E-06_JPRB, 0.23721890E-06_JPRB, 0.20736879E-06_JPRB, 0.18288334E-06_JPRB, &
  & 0.16276424E-06_JPRB, 0.14590695E-06_JPRB, 0.13131152E-06_JPRB, 0.11825520E-06_JPRB, 0.10625516E-06_JPRB, 0.95170883E-07_JPRB, &
  & 0.85257881E-07_JPRB, 0.77070077E-07_JPRB, 0.71286621E-07_JPRB, 0.68140309E-07_JPRB, 0.67520318E-07_JPRB, 0.69036872E-07_JPRB, &
  & 0.72447492E-07_JPRB, 0.77629075E-07_JPRB, 0.84061050E-07_JPRB, 0.91749833E-07_JPRB, 0.10140068E-06_JPRB, 0.11158998E-06_JPRB, &
  & 0.12334685E-06_JPRB, 0.13631060E-06_JPRB, 0.15092996E-06_JPRB, 0.16963139E-06_JPRB, 0.19415653E-06_JPRB, 0.22781424E-06_JPRB, &
  & 0.27072295E-06_JPRB, 0.31926206E-06_JPRB, 0.36820853E-06_JPRB, 0.41221375E-06_JPRB, 0.44876899E-06_JPRB, 0.47807714E-06_JPRB, &
  & 0.50178113E-06_JPRB, 0.52243013E-06_JPRB, 0.54178628E-06_JPRB, 0.56114442E-06_JPRB, 0.58073954E-06_JPRB, 0.60003032E-06_JPRB, &
  & 0.61865103E-06_JPRB, 0.63724599E-06_JPRB, 0.65896967E-06_JPRB, 0.70034457E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART18',0,ZHOOK_HANDLE)



RGHG7(:,46, 9) = (/ &
  & 0.54945360E-06_JPRB, 0.54731902E-06_JPRB, 0.54686348E-06_JPRB, 0.54566277E-06_JPRB, 0.54193197E-06_JPRB, 0.53377784E-06_JPRB, &
  & 0.52256769E-06_JPRB, 0.50952747E-06_JPRB, 0.49575328E-06_JPRB, 0.48313308E-06_JPRB, 0.47092385E-06_JPRB, 0.45844340E-06_JPRB, &
  & 0.44482988E-06_JPRB, 0.42981506E-06_JPRB, 0.41259077E-06_JPRB, 0.39285155E-06_JPRB, 0.36949464E-06_JPRB, 0.34236106E-06_JPRB, &
  & 0.31078790E-06_JPRB, 0.27770946E-06_JPRB, 0.24512670E-06_JPRB, 0.21607374E-06_JPRB, 0.19094540E-06_JPRB, 0.16963121E-06_JPRB, &
  & 0.15164325E-06_JPRB, 0.13629636E-06_JPRB, 0.12286384E-06_JPRB, 0.11075027E-06_JPRB, 0.99532151E-07_JPRB, 0.89099856E-07_JPRB, &
  & 0.79720394E-07_JPRB, 0.71978896E-07_JPRB, 0.66534184E-07_JPRB, 0.63602606E-07_JPRB, 0.63065073E-07_JPRB, 0.64517394E-07_JPRB, &
  & 0.67739364E-07_JPRB, 0.72604024E-07_JPRB, 0.78599037E-07_JPRB, 0.85574726E-07_JPRB, 0.94144802E-07_JPRB, 0.10287540E-06_JPRB, &
  & 0.11248017E-06_JPRB, 0.12269128E-06_JPRB, 0.13358472E-06_JPRB, 0.14727702E-06_JPRB, 0.16547133E-06_JPRB, 0.19137219E-06_JPRB, &
  & 0.22683405E-06_JPRB, 0.26926301E-06_JPRB, 0.31309668E-06_JPRB, 0.35308420E-06_JPRB, 0.38533028E-06_JPRB, 0.41045496E-06_JPRB, &
  & 0.43029164E-06_JPRB, 0.44713650E-06_JPRB, 0.46296336E-06_JPRB, 0.47895850E-06_JPRB, 0.49540648E-06_JPRB, 0.51188562E-06_JPRB, &
  & 0.52773879E-06_JPRB, 0.54345975E-06_JPRB, 0.56160263E-06_JPRB, 0.59603485E-06_JPRB /)

RGHG7(:,47, 9) = (/ &
  & 0.50354595E-06_JPRB, 0.49336029E-06_JPRB, 0.48789110E-06_JPRB, 0.48211785E-06_JPRB, 0.47343551E-06_JPRB, 0.46145487E-06_JPRB, &
  & 0.44789817E-06_JPRB, 0.43385572E-06_JPRB, 0.42031286E-06_JPRB, 0.40862383E-06_JPRB, 0.39794617E-06_JPRB, 0.38722115E-06_JPRB, &
  & 0.37598795E-06_JPRB, 0.36339836E-06_JPRB, 0.34925233E-06_JPRB, 0.33279591E-06_JPRB, 0.31400037E-06_JPRB, 0.29219700E-06_JPRB, &
  & 0.26871368E-06_JPRB, 0.24400501E-06_JPRB, 0.22010003E-06_JPRB, 0.19747229E-06_JPRB, 0.17683109E-06_JPRB, 0.15838619E-06_JPRB, &
  & 0.14227737E-06_JPRB, 0.12825059E-06_JPRB, 0.11581114E-06_JPRB, 0.10447775E-06_JPRB, 0.93892254E-07_JPRB, 0.83982762E-07_JPRB, &
  & 0.75021248E-07_JPRB, 0.67635177E-07_JPRB, 0.62434630E-07_JPRB, 0.59673056E-07_JPRB, 0.59159063E-07_JPRB, 0.60541808E-07_JPRB, &
  & 0.63598968E-07_JPRB, 0.68197984E-07_JPRB, 0.73876883E-07_JPRB, 0.80325314E-07_JPRB, 0.88005820E-07_JPRB, 0.95686950E-07_JPRB, &
  & 0.10364744E-06_JPRB, 0.11184448E-06_JPRB, 0.12008493E-06_JPRB, 0.13009929E-06_JPRB, 0.14313331E-06_JPRB, 0.16218539E-06_JPRB, &
  & 0.18951381E-06_JPRB, 0.22408651E-06_JPRB, 0.26203259E-06_JPRB, 0.29672455E-06_JPRB, 0.32477786E-06_JPRB, 0.34598838E-06_JPRB, &
  & 0.36213240E-06_JPRB, 0.37579579E-06_JPRB, 0.38847719E-06_JPRB, 0.40157346E-06_JPRB, 0.41534136E-06_JPRB, 0.42930881E-06_JPRB, &
  & 0.44279275E-06_JPRB, 0.45598489E-06_JPRB, 0.47103458E-06_JPRB, 0.49955048E-06_JPRB /)

RGHG7(:,48, 9) = (/ &
  & 0.44410473E-06_JPRB, 0.42759632E-06_JPRB, 0.41770798E-06_JPRB, 0.40732692E-06_JPRB, 0.39434647E-06_JPRB, 0.37925537E-06_JPRB, &
  & 0.36436833E-06_JPRB, 0.35093029E-06_JPRB, 0.33896856E-06_JPRB, 0.32954296E-06_JPRB, 0.32132451E-06_JPRB, 0.31347503E-06_JPRB, &
  & 0.30508434E-06_JPRB, 0.29575583E-06_JPRB, 0.28495305E-06_JPRB, 0.27280146E-06_JPRB, 0.25901613E-06_JPRB, 0.24458066E-06_JPRB, &
  & 0.22943760E-06_JPRB, 0.21400619E-06_JPRB, 0.19794912E-06_JPRB, 0.18135069E-06_JPRB, 0.16470595E-06_JPRB, 0.14883406E-06_JPRB, &
  & 0.13438469E-06_JPRB, 0.12149680E-06_JPRB, 0.10988331E-06_JPRB, 0.99192292E-07_JPRB, 0.89113392E-07_JPRB, 0.79616065E-07_JPRB, &
  & 0.70986701E-07_JPRB, 0.63898476E-07_JPRB, 0.58881028E-07_JPRB, 0.56251572E-07_JPRB, 0.55719831E-07_JPRB, 0.57033770E-07_JPRB, &
  & 0.59942352E-07_JPRB, 0.64322649E-07_JPRB, 0.69750463E-07_JPRB, 0.75794397E-07_JPRB, 0.82787039E-07_JPRB, 0.89704045E-07_JPRB, &
  & 0.96445007E-07_JPRB, 0.10317330E-06_JPRB, 0.10957326E-06_JPRB, 0.11695628E-06_JPRB, 0.12633869E-06_JPRB, 0.13970298E-06_JPRB, &
  & 0.15925382E-06_JPRB, 0.18502602E-06_JPRB, 0.21462728E-06_JPRB, 0.24334844E-06_JPRB, 0.26659637E-06_JPRB, 0.28395201E-06_JPRB, &
  & 0.29709389E-06_JPRB, 0.30795991E-06_JPRB, 0.31820670E-06_JPRB, 0.32891549E-06_JPRB, 0.34046889E-06_JPRB, 0.35244540E-06_JPRB, &
  & 0.36401113E-06_JPRB, 0.37519831E-06_JPRB, 0.38787795E-06_JPRB, 0.41182616E-06_JPRB /)

RGHG7(:,49, 9) = (/ &
  & 0.38630725E-06_JPRB, 0.36172293E-06_JPRB, 0.34725323E-06_JPRB, 0.33292469E-06_JPRB, 0.31597224E-06_JPRB, 0.29769160E-06_JPRB, &
  & 0.28190811E-06_JPRB, 0.26917735E-06_JPRB, 0.25918669E-06_JPRB, 0.25208163E-06_JPRB, 0.24663461E-06_JPRB, 0.24163674E-06_JPRB, &
  & 0.23652758E-06_JPRB, 0.23076534E-06_JPRB, 0.22428038E-06_JPRB, 0.21712997E-06_JPRB, 0.21010351E-06_JPRB, 0.20310166E-06_JPRB, &
  & 0.19616655E-06_JPRB, 0.18853645E-06_JPRB, 0.17907254E-06_JPRB, 0.16753509E-06_JPRB, 0.15436162E-06_JPRB, 0.14072280E-06_JPRB, &
  & 0.12770892E-06_JPRB, 0.11577323E-06_JPRB, 0.10484844E-06_JPRB, 0.94665189E-07_JPRB, 0.84996621E-07_JPRB, 0.75820950E-07_JPRB, &
  & 0.67496380E-07_JPRB, 0.60619307E-07_JPRB, 0.55797706E-07_JPRB, 0.53241916E-07_JPRB, 0.52683639E-07_JPRB, 0.53928744E-07_JPRB, &
  & 0.56695828E-07_JPRB, 0.60880915E-07_JPRB, 0.66092888E-07_JPRB, 0.71866182E-07_JPRB, 0.78267732E-07_JPRB, 0.84662162E-07_JPRB, &
  & 0.90505822E-07_JPRB, 0.96212005E-07_JPRB, 0.10136401E-06_JPRB, 0.10697882E-06_JPRB, 0.11379972E-06_JPRB, 0.12307227E-06_JPRB, &
  & 0.13623763E-06_JPRB, 0.15348787E-06_JPRB, 0.17381969E-06_JPRB, 0.19439194E-06_JPRB, 0.21191373E-06_JPRB, 0.22527306E-06_JPRB, &
  & 0.23556008E-06_JPRB, 0.24406947E-06_JPRB, 0.25236977E-06_JPRB, 0.26117326E-06_JPRB, 0.27098773E-06_JPRB, 0.28141883E-06_JPRB, &
  & 0.29153219E-06_JPRB, 0.30124374E-06_JPRB, 0.31223709E-06_JPRB, 0.33300239E-06_JPRB /)

RGHG7(:,50, 9) = (/ &
  & 0.31940451E-06_JPRB, 0.29622174E-06_JPRB, 0.28276372E-06_JPRB, 0.26815738E-06_JPRB, 0.25021635E-06_JPRB, 0.23109224E-06_JPRB, &
  & 0.21544267E-06_JPRB, 0.20396656E-06_JPRB, 0.19582836E-06_JPRB, 0.19061443E-06_JPRB, 0.18686814E-06_JPRB, 0.18395869E-06_JPRB, &
  & 0.18130567E-06_JPRB, 0.17873029E-06_JPRB, 0.17627421E-06_JPRB, 0.17428032E-06_JPRB, 0.17269370E-06_JPRB, 0.17156775E-06_JPRB, &
  & 0.17031473E-06_JPRB, 0.16789544E-06_JPRB, 0.16334741E-06_JPRB, 0.15574064E-06_JPRB, 0.14550535E-06_JPRB, 0.13380364E-06_JPRB, &
  & 0.12200728E-06_JPRB, 0.11086085E-06_JPRB, 0.10048743E-06_JPRB, 0.90709499E-07_JPRB, 0.81373621E-07_JPRB, 0.72463678E-07_JPRB, &
  & 0.64406329E-07_JPRB, 0.57723796E-07_JPRB, 0.53096553E-07_JPRB, 0.50569920E-07_JPRB, 0.49996004E-07_JPRB, 0.51162729E-07_JPRB, &
  & 0.53802761E-07_JPRB, 0.57790814E-07_JPRB, 0.62804112E-07_JPRB, 0.68366660E-07_JPRB, 0.74332448E-07_JPRB, 0.80295273E-07_JPRB, &
  & 0.85615632E-07_JPRB, 0.90428685E-07_JPRB, 0.94868582E-07_JPRB, 0.99240879E-07_JPRB, 0.10446370E-06_JPRB, 0.11098288E-06_JPRB, &
  & 0.11966810E-06_JPRB, 0.13029029E-06_JPRB, 0.14245850E-06_JPRB, 0.15478101E-06_JPRB, 0.16569339E-06_JPRB, 0.17448271E-06_JPRB, &
  & 0.18140072E-06_JPRB, 0.18763716E-06_JPRB, 0.19370516E-06_JPRB, 0.20055774E-06_JPRB, 0.20862416E-06_JPRB, 0.21742565E-06_JPRB, &
  & 0.22618410E-06_JPRB, 0.23473609E-06_JPRB, 0.24437659E-06_JPRB, 0.26316869E-06_JPRB /)

RGHG7(:,51, 9) = (/ &
  & 0.26686192E-06_JPRB, 0.24524942E-06_JPRB, 0.23221533E-06_JPRB, 0.21915488E-06_JPRB, 0.20245082E-06_JPRB, 0.18496736E-06_JPRB, &
  & 0.17132544E-06_JPRB, 0.16216775E-06_JPRB, 0.15609412E-06_JPRB, 0.15220093E-06_JPRB, 0.14965961E-06_JPRB, 0.14776066E-06_JPRB, &
  & 0.14643497E-06_JPRB, 0.14569196E-06_JPRB, 0.14572996E-06_JPRB, 0.14645447E-06_JPRB, 0.14785184E-06_JPRB, 0.14954286E-06_JPRB, &
  & 0.15108621E-06_JPRB, 0.15171821E-06_JPRB, 0.15021041E-06_JPRB, 0.14565930E-06_JPRB, 0.13784516E-06_JPRB, 0.12781408E-06_JPRB, &
  & 0.11705267E-06_JPRB, 0.10655641E-06_JPRB, 0.96618713E-07_JPRB, 0.87179586E-07_JPRB, 0.78100669E-07_JPRB, 0.69467411E-07_JPRB, &
  & 0.61613505E-07_JPRB, 0.55173707E-07_JPRB, 0.50687873E-07_JPRB, 0.48190017E-07_JPRB, 0.47608687E-07_JPRB, 0.48691771E-07_JPRB, &
  & 0.51197851E-07_JPRB, 0.54999479E-07_JPRB, 0.59806382E-07_JPRB, 0.65184103E-07_JPRB, 0.70863415E-07_JPRB, 0.76459486E-07_JPRB, &
  & 0.81429562E-07_JPRB, 0.85738492E-07_JPRB, 0.89561070E-07_JPRB, 0.93230227E-07_JPRB, 0.97332936E-07_JPRB, 0.10214234E-06_JPRB, &
  & 0.10792537E-06_JPRB, 0.11441360E-06_JPRB, 0.12106896E-06_JPRB, 0.12757745E-06_JPRB, 0.13312351E-06_JPRB, 0.13764017E-06_JPRB, &
  & 0.14146489E-06_JPRB, 0.14477396E-06_JPRB, 0.14848510E-06_JPRB, 0.15276373E-06_JPRB, 0.15818672E-06_JPRB, 0.16465597E-06_JPRB, &
  & 0.17145585E-06_JPRB, 0.17829886E-06_JPRB, 0.18664919E-06_JPRB, 0.20313118E-06_JPRB /)

RGHG7(:,52, 9) = (/ &
  & 0.21787025E-06_JPRB, 0.20234096E-06_JPRB, 0.19362504E-06_JPRB, 0.18302210E-06_JPRB, 0.16947689E-06_JPRB, 0.15473387E-06_JPRB, &
  & 0.14403392E-06_JPRB, 0.13714234E-06_JPRB, 0.13279123E-06_JPRB, 0.13014930E-06_JPRB, 0.12830189E-06_JPRB, 0.12708718E-06_JPRB, &
  & 0.12640760E-06_JPRB, 0.12646406E-06_JPRB, 0.12738697E-06_JPRB, 0.12917437E-06_JPRB, 0.13153056E-06_JPRB, 0.13424315E-06_JPRB, &
  & 0.13687189E-06_JPRB, 0.13886496E-06_JPRB, 0.13926700E-06_JPRB, 0.13685744E-06_JPRB, 0.13106309E-06_JPRB, 0.12249488E-06_JPRB, &
  & 0.11263525E-06_JPRB, 0.10267883E-06_JPRB, 0.93108525E-07_JPRB, 0.83962711E-07_JPRB, 0.75113476E-07_JPRB, 0.66750154E-07_JPRB, &
  & 0.59083472E-07_JPRB, 0.52915720E-07_JPRB, 0.48518093E-07_JPRB, 0.46077243E-07_JPRB, 0.45479322E-07_JPRB, 0.46471005E-07_JPRB, &
  & 0.48851824E-07_JPRB, 0.52467556E-07_JPRB, 0.57048990E-07_JPRB, 0.62245910E-07_JPRB, 0.67722475E-07_JPRB, 0.72996784E-07_JPRB, &
  & 0.77761932E-07_JPRB, 0.81643549E-07_JPRB, 0.85141814E-07_JPRB, 0.88345523E-07_JPRB, 0.91746806E-07_JPRB, 0.95535086E-07_JPRB, &
  & 0.99568588E-07_JPRB, 0.10363647E-06_JPRB, 0.10741195E-06_JPRB, 0.11066706E-06_JPRB, 0.11333653E-06_JPRB, 0.11534529E-06_JPRB, &
  & 0.11696259E-06_JPRB, 0.11851332E-06_JPRB, 0.12015600E-06_JPRB, 0.12224795E-06_JPRB, 0.12514089E-06_JPRB, 0.12876984E-06_JPRB, &
  & 0.13296182E-06_JPRB, 0.13758704E-06_JPRB, 0.14339193E-06_JPRB, 0.15654683E-06_JPRB /)

RGHG7(:,53, 9) = (/ &
  & 0.18475757E-06_JPRB, 0.17339262E-06_JPRB, 0.16555160E-06_JPRB, 0.15754092E-06_JPRB, 0.14617783E-06_JPRB, 0.13476482E-06_JPRB, &
  & 0.12655963E-06_JPRB, 0.12162410E-06_JPRB, 0.11860974E-06_JPRB, 0.11668357E-06_JPRB, 0.11543887E-06_JPRB, 0.11457319E-06_JPRB, &
  & 0.11418651E-06_JPRB, 0.11450172E-06_JPRB, 0.11568880E-06_JPRB, 0.11765161E-06_JPRB, 0.12018766E-06_JPRB, 0.12305757E-06_JPRB, &
  & 0.12601504E-06_JPRB, 0.12855521E-06_JPRB, 0.12997209E-06_JPRB, 0.12907863E-06_JPRB, 0.12489892E-06_JPRB, 0.11759512E-06_JPRB, &
  & 0.10855380E-06_JPRB, 0.99098557E-07_JPRB, 0.89857657E-07_JPRB, 0.80980357E-07_JPRB, 0.72393945E-07_JPRB, 0.64228821E-07_JPRB, &
  & 0.56852141E-07_JPRB, 0.50869325E-07_JPRB, 0.46573135E-07_JPRB, 0.44204295E-07_JPRB, 0.43574783E-07_JPRB, 0.44472952E-07_JPRB, &
  & 0.46722789E-07_JPRB, 0.50159013E-07_JPRB, 0.54539171E-07_JPRB, 0.59508139E-07_JPRB, 0.64798179E-07_JPRB, 0.69941862E-07_JPRB, &
  & 0.74357310E-07_JPRB, 0.78173983E-07_JPRB, 0.81257532E-07_JPRB, 0.84265196E-07_JPRB, 0.87223306E-07_JPRB, 0.90336179E-07_JPRB, &
  & 0.93384955E-07_JPRB, 0.96176180E-07_JPRB, 0.98476107E-07_JPRB, 0.10032678E-06_JPRB, 0.10161833E-06_JPRB, 0.10257359E-06_JPRB, &
  & 0.10331073E-06_JPRB, 0.10396175E-06_JPRB, 0.10470072E-06_JPRB, 0.10569326E-06_JPRB, 0.10703742E-06_JPRB, 0.10889855E-06_JPRB, &
  & 0.11108602E-06_JPRB, 0.11352081E-06_JPRB, 0.11684507E-06_JPRB, 0.12540394E-06_JPRB /)

RGHG7(:,54, 9) = (/ &
  & 0.16047511E-06_JPRB, 0.14998331E-06_JPRB, 0.14451291E-06_JPRB, 0.13789079E-06_JPRB, 0.12961593E-06_JPRB, 0.12050215E-06_JPRB, &
  & 0.11459860E-06_JPRB, 0.11107155E-06_JPRB, 0.10896706E-06_JPRB, 0.10765226E-06_JPRB, 0.10672356E-06_JPRB, 0.10613103E-06_JPRB, &
  & 0.10588366E-06_JPRB, 0.10623057E-06_JPRB, 0.10735057E-06_JPRB, 0.10920991E-06_JPRB, 0.11160109E-06_JPRB, 0.11436968E-06_JPRB, &
  & 0.11728271E-06_JPRB, 0.12003879E-06_JPRB, 0.12199750E-06_JPRB, 0.12209107E-06_JPRB, 0.11913203E-06_JPRB, 0.11293568E-06_JPRB, &
  & 0.10464420E-06_JPRB, 0.95694794E-07_JPRB, 0.86805535E-07_JPRB, 0.78188251E-07_JPRB, 0.69894242E-07_JPRB, 0.61902902E-07_JPRB, &
  & 0.54854908E-07_JPRB, 0.48993783E-07_JPRB, 0.44853369E-07_JPRB, 0.42540954E-07_JPRB, 0.41864727E-07_JPRB, 0.42666702E-07_JPRB, &
  & 0.44787548E-07_JPRB, 0.48056172E-07_JPRB, 0.52221289E-07_JPRB, 0.57001895E-07_JPRB, 0.62083210E-07_JPRB, 0.66993820E-07_JPRB, &
  & 0.71367943E-07_JPRB, 0.74878486E-07_JPRB, 0.77962412E-07_JPRB, 0.80677452E-07_JPRB, 0.83429519E-07_JPRB, 0.86123208E-07_JPRB, &
  & 0.88636646E-07_JPRB, 0.90722310E-07_JPRB, 0.92388653E-07_JPRB, 0.93547577E-07_JPRB, 0.94387396E-07_JPRB, 0.94901615E-07_JPRB, &
  & 0.95294183E-07_JPRB, 0.95641603E-07_JPRB, 0.96041525E-07_JPRB, 0.96560669E-07_JPRB, 0.97265513E-07_JPRB, 0.98240697E-07_JPRB, &
  & 0.99334351E-07_JPRB, 0.10050369E-06_JPRB, 0.10194368E-06_JPRB, 0.10556171E-06_JPRB /)

RGHG7(:,55, 9) = (/ &
  & 0.13920226E-06_JPRB, 0.13266269E-06_JPRB, 0.12806930E-06_JPRB, 0.12339360E-06_JPRB, 0.11675234E-06_JPRB, 0.11037478E-06_JPRB, &
  & 0.10586383E-06_JPRB, 0.10336203E-06_JPRB, 0.10186589E-06_JPRB, 0.10090412E-06_JPRB, 0.10024122E-06_JPRB, 0.99775640E-07_JPRB, &
  & 0.99594097E-07_JPRB, 0.99877006E-07_JPRB, 0.10082437E-06_JPRB, 0.10243811E-06_JPRB, 0.10460310E-06_JPRB, 0.10714351E-06_JPRB, &
  & 0.11000381E-06_JPRB, 0.11278836E-06_JPRB, 0.11504181E-06_JPRB, 0.11575464E-06_JPRB, 0.11367700E-06_JPRB, 0.10836214E-06_JPRB, &
  & 0.10081403E-06_JPRB, 0.92382187E-07_JPRB, 0.83889901E-07_JPRB, 0.75560578E-07_JPRB, 0.67521967E-07_JPRB, 0.59814468E-07_JPRB, &
  & 0.53002218E-07_JPRB, 0.47293479E-07_JPRB, 0.43332815E-07_JPRB, 0.41053795E-07_JPRB, 0.40323787E-07_JPRB, 0.41029672E-07_JPRB, &
  & 0.43017973E-07_JPRB, 0.46118551E-07_JPRB, 0.50105189E-07_JPRB, 0.54680836E-07_JPRB, 0.59554353E-07_JPRB, 0.64307329E-07_JPRB, &
  & 0.68421009E-07_JPRB, 0.71915494E-07_JPRB, 0.74792688E-07_JPRB, 0.77476123E-07_JPRB, 0.80051208E-07_JPRB, 0.82547459E-07_JPRB, &
  & 0.84745295E-07_JPRB, 0.86552824E-07_JPRB, 0.87883642E-07_JPRB, 0.88850555E-07_JPRB, 0.89433236E-07_JPRB, 0.89844967E-07_JPRB, &
  & 0.90123244E-07_JPRB, 0.90385711E-07_JPRB, 0.90658553E-07_JPRB, 0.90998320E-07_JPRB, 0.91480160E-07_JPRB, 0.92087603E-07_JPRB, &
  & 0.92756082E-07_JPRB, 0.93472565E-07_JPRB, 0.94190092E-07_JPRB, 0.95400331E-07_JPRB /)

RGHG7(:,56, 9) = (/ &
  & 0.12566215E-06_JPRB, 0.11909851E-06_JPRB, 0.11557254E-06_JPRB, 0.11170599E-06_JPRB, 0.10708325E-06_JPRB, 0.10223934E-06_JPRB, &
  & 0.99182820E-07_JPRB, 0.97325909E-07_JPRB, 0.96242630E-07_JPRB, 0.95519695E-07_JPRB, 0.95001667E-07_JPRB, 0.94624063E-07_JPRB, &
  & 0.94445483E-07_JPRB, 0.94605397E-07_JPRB, 0.95341584E-07_JPRB, 0.96652066E-07_JPRB, 0.98564477E-07_JPRB, 0.10091227E-06_JPRB, &
  & 0.10362030E-06_JPRB, 0.10644784E-06_JPRB, 0.10887069E-06_JPRB, 0.10995475E-06_JPRB, 0.10846301E-06_JPRB, 0.10385003E-06_JPRB, &
  & 0.96983555E-07_JPRB, 0.89115893E-07_JPRB, 0.81041129E-07_JPRB, 0.73040056E-07_JPRB, 0.65254156E-07_JPRB, 0.57876139E-07_JPRB, &
  & 0.51231638E-07_JPRB, 0.45769688E-07_JPRB, 0.41977767E-07_JPRB, 0.39708997E-07_JPRB, 0.38929706E-07_JPRB, 0.39541149E-07_JPRB, &
  & 0.41395939E-07_JPRB, 0.44334644E-07_JPRB, 0.48140599E-07_JPRB, 0.52529661E-07_JPRB, 0.57208947E-07_JPRB, 0.61737154E-07_JPRB, &
  & 0.65742285E-07_JPRB, 0.69048404E-07_JPRB, 0.71890085E-07_JPRB, 0.74462577E-07_JPRB, 0.76981323E-07_JPRB, 0.79344652E-07_JPRB, &
  & 0.81455092E-07_JPRB, 0.83125514E-07_JPRB, 0.84391722E-07_JPRB, 0.85232614E-07_JPRB, 0.85818542E-07_JPRB, 0.86168754E-07_JPRB, &
  & 0.86441915E-07_JPRB, 0.86672244E-07_JPRB, 0.86911584E-07_JPRB, 0.87221267E-07_JPRB, 0.87593548E-07_JPRB, 0.88053447E-07_JPRB, &
  & 0.88584919E-07_JPRB, 0.89148784E-07_JPRB, 0.89940094E-07_JPRB, 0.91836824E-07_JPRB /)

RGHG7(:,57, 9) = (/ &
  & 0.11248365E-06_JPRB, 0.10818095E-06_JPRB, 0.10554015E-06_JPRB, 0.10278978E-06_JPRB, 0.99341463E-07_JPRB, 0.96002708E-07_JPRB, &
  & 0.93638107E-07_JPRB, 0.92308852E-07_JPRB, 0.91485617E-07_JPRB, 0.90913474E-07_JPRB, 0.90491213E-07_JPRB, 0.90143196E-07_JPRB, &
  & 0.89949708E-07_JPRB, 0.89985647E-07_JPRB, 0.90485834E-07_JPRB, 0.91527632E-07_JPRB, 0.93152721E-07_JPRB, 0.95312330E-07_JPRB, &
  & 0.97944543E-07_JPRB, 0.10076931E-06_JPRB, 0.10328639E-06_JPRB, 0.10457813E-06_JPRB, 0.10344785E-06_JPRB, 0.99412240E-07_JPRB, &
  & 0.93148564E-07_JPRB, 0.85843958E-07_JPRB, 0.78206995E-07_JPRB, 0.70565200E-07_JPRB, 0.63049740E-07_JPRB, 0.55985009E-07_JPRB, &
  & 0.49563823E-07_JPRB, 0.44397474E-07_JPRB, 0.40732406E-07_JPRB, 0.38489301E-07_JPRB, 0.37667263E-07_JPRB, 0.38186840E-07_JPRB, &
  & 0.39909349E-07_JPRB, 0.42684078E-07_JPRB, 0.46313652E-07_JPRB, 0.50530360E-07_JPRB, 0.55000292E-07_JPRB, 0.59344128E-07_JPRB, &
  & 0.63165906E-07_JPRB, 0.66383748E-07_JPRB, 0.69124162E-07_JPRB, 0.71642887E-07_JPRB, 0.74079615E-07_JPRB, 0.76431178E-07_JPRB, &
  & 0.78502339E-07_JPRB, 0.80205169E-07_JPRB, 0.81466133E-07_JPRB, 0.82371329E-07_JPRB, 0.82914227E-07_JPRB, 0.83315371E-07_JPRB, &
  & 0.83585761E-07_JPRB, 0.83832973E-07_JPRB, 0.84090381E-07_JPRB, 0.84371138E-07_JPRB, 0.84717897E-07_JPRB, 0.85123588E-07_JPRB, &
  & 0.85541316E-07_JPRB, 0.85943135E-07_JPRB, 0.86387921E-07_JPRB, 0.87547733E-07_JPRB /)

RGHG7(:,58, 9) = (/ &
  & 0.10444893E-06_JPRB, 0.10014268E-06_JPRB, 0.97754345E-07_JPRB, 0.95574229E-07_JPRB, 0.93137828E-07_JPRB, 0.90727433E-07_JPRB, &
  & 0.89056826E-07_JPRB, 0.87993257E-07_JPRB, 0.87333362E-07_JPRB, 0.86853156E-07_JPRB, 0.86462826E-07_JPRB, 0.86135614E-07_JPRB, &
  & 0.85877979E-07_JPRB, 0.85805659E-07_JPRB, 0.86066265E-07_JPRB, 0.86851720E-07_JPRB, 0.88232262E-07_JPRB, 0.90225342E-07_JPRB, &
  & 0.92753993E-07_JPRB, 0.95573711E-07_JPRB, 0.98148540E-07_JPRB, 0.99520413E-07_JPRB, 0.98644705E-07_JPRB, 0.95015210E-07_JPRB, &
  & 0.89348411E-07_JPRB, 0.82548361E-07_JPRB, 0.75352162E-07_JPRB, 0.68073753E-07_JPRB, 0.60906316E-07_JPRB, 0.54086218E-07_JPRB, &
  & 0.48002640E-07_JPRB, 0.43111402E-07_JPRB, 0.39581355E-07_JPRB, 0.37375443E-07_JPRB, 0.36531016E-07_JPRB, 0.36964895E-07_JPRB, &
  & 0.38554724E-07_JPRB, 0.41164736E-07_JPRB, 0.44620091E-07_JPRB, 0.48638547E-07_JPRB, 0.52927945E-07_JPRB, 0.57075386E-07_JPRB, &
  & 0.60749649E-07_JPRB, 0.63855886E-07_JPRB, 0.66526916E-07_JPRB, 0.68986147E-07_JPRB, 0.71378565E-07_JPRB, 0.73692675E-07_JPRB, &
  & 0.75790133E-07_JPRB, 0.77569872E-07_JPRB, 0.78943003E-07_JPRB, 0.79871882E-07_JPRB, 0.80531464E-07_JPRB, 0.80938612E-07_JPRB, &
  & 0.81260197E-07_JPRB, 0.81538950E-07_JPRB, 0.81804437E-07_JPRB, 0.82116763E-07_JPRB, 0.82464020E-07_JPRB, 0.82855180E-07_JPRB, &
  & 0.83235562E-07_JPRB, 0.83632585E-07_JPRB, 0.84163830E-07_JPRB, 0.85249631E-07_JPRB /)

RGHG7(:,59, 9) = (/ &
  & 0.96417530E-07_JPRB, 0.93058695E-07_JPRB, 0.91438856E-07_JPRB, 0.89819501E-07_JPRB, 0.88050008E-07_JPRB, 0.86268209E-07_JPRB, &
  & 0.84957406E-07_JPRB, 0.84124061E-07_JPRB, 0.83555570E-07_JPRB, 0.83126771E-07_JPRB, 0.82748841E-07_JPRB, 0.82412306E-07_JPRB, &
  & 0.82094111E-07_JPRB, 0.81902215E-07_JPRB, 0.81976232E-07_JPRB, 0.82537575E-07_JPRB, 0.83690395E-07_JPRB, 0.85533912E-07_JPRB, &
  & 0.87986692E-07_JPRB, 0.90779849E-07_JPRB, 0.93318988E-07_JPRB, 0.94704433E-07_JPRB, 0.93977029E-07_JPRB, 0.90768147E-07_JPRB, &
  & 0.85548962E-07_JPRB, 0.79256488E-07_JPRB, 0.72470108E-07_JPRB, 0.65552385E-07_JPRB, 0.58752015E-07_JPRB, 0.52223250E-07_JPRB, &
  & 0.46516572E-07_JPRB, 0.41883926E-07_JPRB, 0.38500904E-07_JPRB, 0.36376196E-07_JPRB, 0.35523527E-07_JPRB, 0.35881271E-07_JPRB, &
  & 0.37342698E-07_JPRB, 0.39792415E-07_JPRB, 0.43054268E-07_JPRB, 0.46890307E-07_JPRB, 0.50968055E-07_JPRB, 0.54936411E-07_JPRB, &
  & 0.58465933E-07_JPRB, 0.61475070E-07_JPRB, 0.64083935E-07_JPRB, 0.66487992E-07_JPRB, 0.68835213E-07_JPRB, 0.71116887E-07_JPRB, &
  & 0.73271877E-07_JPRB, 0.75110876E-07_JPRB, 0.76608487E-07_JPRB, 0.77704051E-07_JPRB, 0.78411595E-07_JPRB, 0.78908734E-07_JPRB, &
  & 0.79278927E-07_JPRB, 0.79591537E-07_JPRB, 0.79915779E-07_JPRB, 0.80248462E-07_JPRB, 0.80624510E-07_JPRB, 0.81005581E-07_JPRB, &
  & 0.81371297E-07_JPRB, 0.81711875E-07_JPRB, 0.82098246E-07_JPRB, 0.83120312E-07_JPRB /)

RGHG7(:,60, 9) = (/ &
  & 0.90813025E-07_JPRB, 0.87836256E-07_JPRB, 0.86291806E-07_JPRB, 0.85044782E-07_JPRB, 0.83724387E-07_JPRB, 0.82409500E-07_JPRB, &
  & 0.81347103E-07_JPRB, 0.80620339E-07_JPRB, 0.80095084E-07_JPRB, 0.79679772E-07_JPRB, 0.79286899E-07_JPRB, 0.78914070E-07_JPRB, &
  & 0.78523236E-07_JPRB, 0.78222740E-07_JPRB, 0.78130398E-07_JPRB, 0.78480682E-07_JPRB, 0.79467284E-07_JPRB, 0.81177419E-07_JPRB, &
  & 0.83557822E-07_JPRB, 0.86243162E-07_JPRB, 0.88732740E-07_JPRB, 0.90085827E-07_JPRB, 0.89507544E-07_JPRB, 0.86585175E-07_JPRB, &
  & 0.81834074E-07_JPRB, 0.75963293E-07_JPRB, 0.69579336E-07_JPRB, 0.63029006E-07_JPRB, 0.56574379E-07_JPRB, 0.50413259E-07_JPRB, &
  & 0.45050204E-07_JPRB, 0.40701483E-07_JPRB, 0.37507057E-07_JPRB, 0.35489837E-07_JPRB, 0.34655585E-07_JPRB, 0.34950943E-07_JPRB, &
  & 0.36292359E-07_JPRB, 0.38575948E-07_JPRB, 0.41651322E-07_JPRB, 0.45267118E-07_JPRB, 0.49146315E-07_JPRB, 0.52930375E-07_JPRB, &
  & 0.56320285E-07_JPRB, 0.59241199E-07_JPRB, 0.61792065E-07_JPRB, 0.64156367E-07_JPRB, 0.66461730E-07_JPRB, 0.68732817E-07_JPRB, &
  & 0.70867571E-07_JPRB, 0.72820619E-07_JPRB, 0.74428620E-07_JPRB, 0.75643698E-07_JPRB, 0.76504023E-07_JPRB, 0.77089808E-07_JPRB, &
  & 0.77533407E-07_JPRB, 0.77925151E-07_JPRB, 0.78287748E-07_JPRB, 0.78686135E-07_JPRB, 0.79094200E-07_JPRB, 0.79506911E-07_JPRB, &
  & 0.79868485E-07_JPRB, 0.80204309E-07_JPRB, 0.80611677E-07_JPRB, 0.81479953E-07_JPRB /)

RGHG7(:,61, 9) = (/ &
  & 0.85646924E-07_JPRB, 0.83073949E-07_JPRB, 0.81988119E-07_JPRB, 0.81008388E-07_JPRB, 0.79992269E-07_JPRB, 0.78920792E-07_JPRB, &
  & 0.78022872E-07_JPRB, 0.77359502E-07_JPRB, 0.76851208E-07_JPRB, 0.76418637E-07_JPRB, 0.76007709E-07_JPRB, 0.75569275E-07_JPRB, &
  & 0.75124255E-07_JPRB, 0.74686341E-07_JPRB, 0.74448245E-07_JPRB, 0.74641534E-07_JPRB, 0.75495748E-07_JPRB, 0.77118926E-07_JPRB, &
  & 0.79377344E-07_JPRB, 0.81980254E-07_JPRB, 0.84343760E-07_JPRB, 0.85643023E-07_JPRB, 0.85159286E-07_JPRB, 0.82551558E-07_JPRB, &
  & 0.78170522E-07_JPRB, 0.72707145E-07_JPRB, 0.66701489E-07_JPRB, 0.60509038E-07_JPRB, 0.54403934E-07_JPRB, 0.48645230E-07_JPRB, &
  & 0.43620584E-07_JPRB, 0.39579241E-07_JPRB, 0.36609233E-07_JPRB, 0.34732018E-07_JPRB, 0.33938488E-07_JPRB, 0.34189352E-07_JPRB, &
  & 0.35417411E-07_JPRB, 0.37543568E-07_JPRB, 0.40418801E-07_JPRB, 0.43819487E-07_JPRB, 0.47479574E-07_JPRB, 0.51073954E-07_JPRB, &
  & 0.54325120E-07_JPRB, 0.57159646E-07_JPRB, 0.59660231E-07_JPRB, 0.61992665E-07_JPRB, 0.64270516E-07_JPRB, 0.66513977E-07_JPRB, &
  & 0.68671902E-07_JPRB, 0.70624019E-07_JPRB, 0.72343596E-07_JPRB, 0.73707142E-07_JPRB, 0.74692238E-07_JPRB, 0.75396635E-07_JPRB, &
  & 0.75960862E-07_JPRB, 0.76416995E-07_JPRB, 0.76892910E-07_JPRB, 0.77352190E-07_JPRB, 0.77827458E-07_JPRB, 0.78258701E-07_JPRB, &
  & 0.78621817E-07_JPRB, 0.78940857E-07_JPRB, 0.79303106E-07_JPRB, 0.80139159E-07_JPRB /)

RGHG7(:,62, 9) = (/ &
  & 0.81521321E-07_JPRB, 0.79333986E-07_JPRB, 0.78310059E-07_JPRB, 0.77514983E-07_JPRB, 0.76692480E-07_JPRB, 0.75813269E-07_JPRB, &
  & 0.74996478E-07_JPRB, 0.74338359E-07_JPRB, 0.73815684E-07_JPRB, 0.73342150E-07_JPRB, 0.72876432E-07_JPRB, 0.72369907E-07_JPRB, &
  & 0.71808230E-07_JPRB, 0.71261020E-07_JPRB, 0.70889307E-07_JPRB, 0.70982551E-07_JPRB, 0.71763161E-07_JPRB, 0.73275480E-07_JPRB, &
  & 0.75438628E-07_JPRB, 0.77891848E-07_JPRB, 0.80123783E-07_JPRB, 0.81364668E-07_JPRB, 0.80977117E-07_JPRB, 0.78603534E-07_JPRB, &
  & 0.74586069E-07_JPRB, 0.69498803E-07_JPRB, 0.63850678E-07_JPRB, 0.58017879E-07_JPRB, 0.52264774E-07_JPRB, 0.46907697E-07_JPRB, &
  & 0.42246768E-07_JPRB, 0.38540833E-07_JPRB, 0.35828659E-07_JPRB, 0.34119026E-07_JPRB, 0.33388556E-07_JPRB, 0.33611446E-07_JPRB, &
  & 0.34739305E-07_JPRB, 0.36705774E-07_JPRB, 0.39384034E-07_JPRB, 0.42556280E-07_JPRB, 0.45989641E-07_JPRB, 0.49390255E-07_JPRB, &
  & 0.52498439E-07_JPRB, 0.55251220E-07_JPRB, 0.57701662E-07_JPRB, 0.60003515E-07_JPRB, 0.62257605E-07_JPRB, 0.64488518E-07_JPRB, &
  & 0.66628040E-07_JPRB, 0.68609616E-07_JPRB, 0.70360734E-07_JPRB, 0.71821084E-07_JPRB, 0.72950463E-07_JPRB, 0.73808387E-07_JPRB, &
  & 0.74468872E-07_JPRB, 0.75082518E-07_JPRB, 0.75642376E-07_JPRB, 0.76215393E-07_JPRB, 0.76761445E-07_JPRB, 0.77235541E-07_JPRB, &
  & 0.77610110E-07_JPRB, 0.77930785E-07_JPRB, 0.78289709E-07_JPRB, 0.79036688E-07_JPRB /)

RGHG7(:,63, 9) = (/ &
  & 0.77902875E-07_JPRB, 0.75908900E-07_JPRB, 0.75088209E-07_JPRB, 0.74408419E-07_JPRB, 0.73710410E-07_JPRB, 0.72929950E-07_JPRB, &
  & 0.72162599E-07_JPRB, 0.71497524E-07_JPRB, 0.70918993E-07_JPRB, 0.70395593E-07_JPRB, 0.69851176E-07_JPRB, 0.69255542E-07_JPRB, &
  & 0.68574280E-07_JPRB, 0.67896600E-07_JPRB, 0.67446507E-07_JPRB, 0.67491740E-07_JPRB, 0.68215073E-07_JPRB, 0.69663749E-07_JPRB, &
  & 0.71689776E-07_JPRB, 0.74000525E-07_JPRB, 0.76080092E-07_JPRB, 0.77246497E-07_JPRB, 0.76913807E-07_JPRB, 0.74774206E-07_JPRB, &
  & 0.71077103E-07_JPRB, 0.66342103E-07_JPRB, 0.61049960E-07_JPRB, 0.55577537E-07_JPRB, 0.50189705E-07_JPRB, 0.45233421E-07_JPRB, &
  & 0.40971244E-07_JPRB, 0.37628162E-07_JPRB, 0.35204238E-07_JPRB, 0.33682966E-07_JPRB, 0.33032876E-07_JPRB, 0.33243349E-07_JPRB, &
  & 0.34281573E-07_JPRB, 0.36092292E-07_JPRB, 0.38568039E-07_JPRB, 0.41511253E-07_JPRB, 0.44709573E-07_JPRB, 0.47900951E-07_JPRB, &
  & 0.50874100E-07_JPRB, 0.53538361E-07_JPRB, 0.55934795E-07_JPRB, 0.58208911E-07_JPRB, 0.60436847E-07_JPRB, 0.62650784E-07_JPRB, &
  & 0.64784970E-07_JPRB, 0.66764947E-07_JPRB, 0.68524528E-07_JPRB, 0.70047278E-07_JPRB, 0.71271110E-07_JPRB, 0.72244795E-07_JPRB, &
  & 0.73078887E-07_JPRB, 0.73792798E-07_JPRB, 0.74519626E-07_JPRB, 0.75207396E-07_JPRB, 0.75844198E-07_JPRB, 0.76358333E-07_JPRB, &
  & 0.76754262E-07_JPRB, 0.77085339E-07_JPRB, 0.77438983E-07_JPRB, 0.78151743E-07_JPRB /)

RGHG7(:,64, 9) = (/ &
  & 0.74819788E-07_JPRB, 0.73014398E-07_JPRB, 0.72221191E-07_JPRB, 0.71612142E-07_JPRB, 0.70991774E-07_JPRB, 0.70289182E-07_JPRB, &
  & 0.69536483E-07_JPRB, 0.68830381E-07_JPRB, 0.68191326E-07_JPRB, 0.67566688E-07_JPRB, 0.66933133E-07_JPRB, 0.66206049E-07_JPRB, &
  & 0.65408564E-07_JPRB, 0.64645491E-07_JPRB, 0.64162847E-07_JPRB, 0.64208287E-07_JPRB, 0.64900448E-07_JPRB, 0.66250990E-07_JPRB, &
  & 0.68146399E-07_JPRB, 0.70295542E-07_JPRB, 0.72224481E-07_JPRB, 0.73306943E-07_JPRB, 0.73015102E-07_JPRB, 0.71056597E-07_JPRB, &
  & 0.67661716E-07_JPRB, 0.63270548E-07_JPRB, 0.58335882E-07_JPRB, 0.53232128E-07_JPRB, 0.48241120E-07_JPRB, 0.43690573E-07_JPRB, &
  & 0.39864240E-07_JPRB, 0.36898523E-07_JPRB, 0.34783373E-07_JPRB, 0.33462282E-07_JPRB, 0.32902683E-07_JPRB, 0.33112045E-07_JPRB, &
  & 0.34072112E-07_JPRB, 0.35733372E-07_JPRB, 0.38001780E-07_JPRB, 0.40710518E-07_JPRB, 0.43667040E-07_JPRB, 0.46659085E-07_JPRB, &
  & 0.49486992E-07_JPRB, 0.52049540E-07_JPRB, 0.54393841E-07_JPRB, 0.56637273E-07_JPRB, 0.58831453E-07_JPRB, 0.61023016E-07_JPRB, &
  & 0.63141485E-07_JPRB, 0.65114456E-07_JPRB, 0.66879295E-07_JPRB, 0.68411246E-07_JPRB, 0.69705187E-07_JPRB, 0.70788559E-07_JPRB, &
  & 0.71711924E-07_JPRB, 0.72605012E-07_JPRB, 0.73455340E-07_JPRB, 0.74275484E-07_JPRB, 0.74998155E-07_JPRB, 0.75571641E-07_JPRB, &
  & 0.76004348E-07_JPRB, 0.76362092E-07_JPRB, 0.76746026E-07_JPRB, 0.77438948E-07_JPRB /)

RGHG7(:,65, 9) = (/ &
  & 0.72084006E-07_JPRB, 0.70330792E-07_JPRB, 0.69597924E-07_JPRB, 0.69025234E-07_JPRB, 0.68447314E-07_JPRB, 0.67782700E-07_JPRB, &
  & 0.67051367E-07_JPRB, 0.66285487E-07_JPRB, 0.65560272E-07_JPRB, 0.64836620E-07_JPRB, 0.64072090E-07_JPRB, 0.63240563E-07_JPRB, &
  & 0.62336632E-07_JPRB, 0.61552591E-07_JPRB, 0.61098191E-07_JPRB, 0.61150672E-07_JPRB, 0.61800719E-07_JPRB, 0.63062473E-07_JPRB, &
  & 0.64823816E-07_JPRB, 0.66815673E-07_JPRB, 0.68585052E-07_JPRB, 0.69564265E-07_JPRB, 0.69283821E-07_JPRB, 0.67497659E-07_JPRB, &
  & 0.64376096E-07_JPRB, 0.60327764E-07_JPRB, 0.55759589E-07_JPRB, 0.51053625E-07_JPRB, 0.46477766E-07_JPRB, 0.42364992E-07_JPRB, &
  & 0.38980978E-07_JPRB, 0.36405066E-07_JPRB, 0.34599406E-07_JPRB, 0.33478106E-07_JPRB, 0.33013606E-07_JPRB, 0.33231892E-07_JPRB, &
  & 0.34123961E-07_JPRB, 0.35646256E-07_JPRB, 0.37714475E-07_JPRB, 0.40185508E-07_JPRB, 0.42905057E-07_JPRB, 0.45685564E-07_JPRB, &
  & 0.48356235E-07_JPRB, 0.50817803E-07_JPRB, 0.53109183E-07_JPRB, 0.55310334E-07_JPRB, 0.57461161E-07_JPRB, 0.59626352E-07_JPRB, &
  & 0.61714900E-07_JPRB, 0.63674328E-07_JPRB, 0.65425475E-07_JPRB, 0.66977897E-07_JPRB, 0.68284905E-07_JPRB, 0.69444084E-07_JPRB, &
  & 0.70470506E-07_JPRB, 0.71454167E-07_JPRB, 0.72454107E-07_JPRB, 0.73367744E-07_JPRB, 0.74166543E-07_JPRB, 0.74806586E-07_JPRB, &
  & 0.75290217E-07_JPRB, 0.75705188E-07_JPRB, 0.76138939E-07_JPRB, 0.76875828E-07_JPRB /)

RGHG7(:,66, 9) = (/ &
  & 0.69631163E-07_JPRB, 0.67910733E-07_JPRB, 0.67163100E-07_JPRB, 0.66592619E-07_JPRB, 0.66030552E-07_JPRB, 0.65389735E-07_JPRB, &
  & 0.64647629E-07_JPRB, 0.63856980E-07_JPRB, 0.62991525E-07_JPRB, 0.62164389E-07_JPRB, 0.61288148E-07_JPRB, 0.60352527E-07_JPRB, &
  & 0.59431517E-07_JPRB, 0.58682424E-07_JPRB, 0.58272271E-07_JPRB, 0.58328155E-07_JPRB, 0.58933836E-07_JPRB, 0.60098799E-07_JPRB, &
  & 0.61722247E-07_JPRB, 0.63547347E-07_JPRB, 0.65152612E-07_JPRB, 0.66029280E-07_JPRB, 0.65757057E-07_JPRB, 0.64109862E-07_JPRB, &
  & 0.61265922E-07_JPRB, 0.57557923E-07_JPRB, 0.53384458E-07_JPRB, 0.49094435E-07_JPRB, 0.44965311E-07_JPRB, 0.41301991E-07_JPRB, &
  & 0.38359385E-07_JPRB, 0.36165563E-07_JPRB, 0.34656793E-07_JPRB, 0.33729528E-07_JPRB, 0.33361161E-07_JPRB, 0.33595096E-07_JPRB, &
  & 0.34432471E-07_JPRB, 0.35827270E-07_JPRB, 0.37706116E-07_JPRB, 0.39949718E-07_JPRB, 0.42432287E-07_JPRB, 0.45006690E-07_JPRB, &
  & 0.47515428E-07_JPRB, 0.49870884E-07_JPRB, 0.52095512E-07_JPRB, 0.54238321E-07_JPRB, 0.56341971E-07_JPRB, 0.58464934E-07_JPRB, &
  & 0.60505720E-07_JPRB, 0.62438559E-07_JPRB, 0.64167118E-07_JPRB, 0.65713174E-07_JPRB, 0.67043736E-07_JPRB, 0.68240695E-07_JPRB, &
  & 0.69324003E-07_JPRB, 0.70407886E-07_JPRB, 0.71480436E-07_JPRB, 0.72471479E-07_JPRB, 0.73330561E-07_JPRB, 0.74029828E-07_JPRB, &
  & 0.74586815E-07_JPRB, 0.75064392E-07_JPRB, 0.75602593E-07_JPRB, 0.76392162E-07_JPRB /)

RGHG7(:,67, 9) = (/ &
  & 0.67435401E-07_JPRB, 0.65637188E-07_JPRB, 0.64846020E-07_JPRB, 0.64247573E-07_JPRB, 0.63668899E-07_JPRB, 0.63028104E-07_JPRB, &
  & 0.62286162E-07_JPRB, 0.61421176E-07_JPRB, 0.60489988E-07_JPRB, 0.59512274E-07_JPRB, 0.58570105E-07_JPRB, 0.57610826E-07_JPRB, &
  & 0.56723525E-07_JPRB, 0.56031936E-07_JPRB, 0.55665101E-07_JPRB, 0.55723486E-07_JPRB, 0.56290101E-07_JPRB, 0.57360122E-07_JPRB, &
  & 0.58849498E-07_JPRB, 0.60508334E-07_JPRB, 0.61951759E-07_JPRB, 0.62721810E-07_JPRB, 0.62448812E-07_JPRB, 0.60954342E-07_JPRB, &
  & 0.58371093E-07_JPRB, 0.55025318E-07_JPRB, 0.51254453E-07_JPRB, 0.47405695E-07_JPRB, 0.43733749E-07_JPRB, 0.40519115E-07_JPRB, &
  & 0.38005229E-07_JPRB, 0.36176456E-07_JPRB, 0.34944680E-07_JPRB, 0.34199534E-07_JPRB, 0.33926145E-07_JPRB, 0.34184044E-07_JPRB, &
  & 0.34977401E-07_JPRB, 0.36263788E-07_JPRB, 0.37971919E-07_JPRB, 0.40004810E-07_JPRB, 0.42261700E-07_JPRB, 0.44628106E-07_JPRB, &
  & 0.46972225E-07_JPRB, 0.49216951E-07_JPRB, 0.51356519E-07_JPRB, 0.53431567E-07_JPRB, 0.55482754E-07_JPRB, 0.57540277E-07_JPRB, &
  & 0.59525092E-07_JPRB, 0.61416571E-07_JPRB, 0.63110036E-07_JPRB, 0.64639835E-07_JPRB, 0.65964159E-07_JPRB, 0.67184452E-07_JPRB, &
  & 0.68301425E-07_JPRB, 0.69434243E-07_JPRB, 0.70572064E-07_JPRB, 0.71594734E-07_JPRB, 0.72492163E-07_JPRB, 0.73246660E-07_JPRB, &
  & 0.73855759E-07_JPRB, 0.74419290E-07_JPRB, 0.75058715E-07_JPRB, 0.75995104E-07_JPRB /)

RGHG7(:,68, 9) = (/ &
  & 0.65416025E-07_JPRB, 0.63471738E-07_JPRB, 0.62589969E-07_JPRB, 0.61936959E-07_JPRB, 0.61326695E-07_JPRB, 0.60668391E-07_JPRB, &
  & 0.59914704E-07_JPRB, 0.59025894E-07_JPRB, 0.57957557E-07_JPRB, 0.56945623E-07_JPRB, 0.55953997E-07_JPRB, 0.55025058E-07_JPRB, &
  & 0.54221225E-07_JPRB, 0.53591698E-07_JPRB, 0.53275951E-07_JPRB, 0.53339964E-07_JPRB, 0.53866778E-07_JPRB, 0.54847515E-07_JPRB, &
  & 0.56197976E-07_JPRB, 0.57692510E-07_JPRB, 0.58980639E-07_JPRB, 0.59659321E-07_JPRB, 0.59403344E-07_JPRB, 0.58049149E-07_JPRB, &
  & 0.55749013E-07_JPRB, 0.52759166E-07_JPRB, 0.49406768E-07_JPRB, 0.46002011E-07_JPRB, 0.42786937E-07_JPRB, 0.40025192E-07_JPRB, &
  & 0.37902815E-07_JPRB, 0.36415443E-07_JPRB, 0.35440628E-07_JPRB, 0.34867249E-07_JPRB, 0.34690125E-07_JPRB, 0.34975852E-07_JPRB, &
  & 0.35736903E-07_JPRB, 0.36925716E-07_JPRB, 0.38483059E-07_JPRB, 0.40324331E-07_JPRB, 0.42379249E-07_JPRB, 0.44552216E-07_JPRB, &
  & 0.46736165E-07_JPRB, 0.48851501E-07_JPRB, 0.50895789E-07_JPRB, 0.52897978E-07_JPRB, 0.54868615E-07_JPRB, 0.56855569E-07_JPRB, &
  & 0.58762886E-07_JPRB, 0.60598751E-07_JPRB, 0.62235181E-07_JPRB, 0.63731704E-07_JPRB, 0.65039970E-07_JPRB, 0.66261961E-07_JPRB, &
  & 0.67389358E-07_JPRB, 0.68548928E-07_JPRB, 0.69711916E-07_JPRB, 0.70759569E-07_JPRB, 0.71672090E-07_JPRB, 0.72453481E-07_JPRB, &
  & 0.73113775E-07_JPRB, 0.73719931E-07_JPRB, 0.74498558E-07_JPRB, 0.75627703E-07_JPRB /)

RGHG7(:,69, 9) = (/ &
  & 0.63542025E-07_JPRB, 0.61348921E-07_JPRB, 0.60345741E-07_JPRB, 0.59608567E-07_JPRB, 0.58951795E-07_JPRB, 0.58269386E-07_JPRB, &
  & 0.57496880E-07_JPRB, 0.56589549E-07_JPRB, 0.55489792E-07_JPRB, 0.54398367E-07_JPRB, 0.53481173E-07_JPRB, 0.52600317E-07_JPRB, &
  & 0.51881603E-07_JPRB, 0.51325806E-07_JPRB, 0.51063587E-07_JPRB, 0.51150817E-07_JPRB, 0.51645820E-07_JPRB, 0.52544738E-07_JPRB, &
  & 0.53768609E-07_JPRB, 0.55112967E-07_JPRB, 0.56260159E-07_JPRB, 0.56859875E-07_JPRB, 0.56629961E-07_JPRB, 0.55440566E-07_JPRB, &
  & 0.53410044E-07_JPRB, 0.50785715E-07_JPRB, 0.47846527E-07_JPRB, 0.44881567E-07_JPRB, 0.42117207E-07_JPRB, 0.39775241E-07_JPRB, &
  & 0.38033303E-07_JPRB, 0.36866414E-07_JPRB, 0.36130281E-07_JPRB, 0.35719470E-07_JPRB, 0.35637186E-07_JPRB, 0.35957875E-07_JPRB, &
  & 0.36692981E-07_JPRB, 0.37801925E-07_JPRB, 0.39225782E-07_JPRB, 0.40899202E-07_JPRB, 0.42762935E-07_JPRB, 0.44752536E-07_JPRB, &
  & 0.46776986E-07_JPRB, 0.48765173E-07_JPRB, 0.50708337E-07_JPRB, 0.52613768E-07_JPRB, 0.54504838E-07_JPRB, 0.56389826E-07_JPRB, &
  & 0.58222284E-07_JPRB, 0.59977715E-07_JPRB, 0.61547794E-07_JPRB, 0.62999668E-07_JPRB, 0.64274701E-07_JPRB, 0.65467141E-07_JPRB, &
  & 0.66584889E-07_JPRB, 0.67742732E-07_JPRB, 0.68910687E-07_JPRB, 0.69957224E-07_JPRB, 0.70869781E-07_JPRB, 0.71664317E-07_JPRB, &
  & 0.72347667E-07_JPRB, 0.72977933E-07_JPRB, 0.73853279E-07_JPRB, 0.75214956E-07_JPRB /)

RGHG7(:,70, 9) = (/ &
  & 0.61784917E-07_JPRB, 0.59235035E-07_JPRB, 0.58051832E-07_JPRB, 0.57224703E-07_JPRB, 0.56509609E-07_JPRB, 0.55805810E-07_JPRB, &
  & 0.55039234E-07_JPRB, 0.54118619E-07_JPRB, 0.53001738E-07_JPRB, 0.51964378E-07_JPRB, 0.51116327E-07_JPRB, 0.50327483E-07_JPRB, &
  & 0.49701764E-07_JPRB, 0.49242651E-07_JPRB, 0.49039279E-07_JPRB, 0.49150994E-07_JPRB, 0.49624429E-07_JPRB, 0.50446364E-07_JPRB, &
  & 0.51555528E-07_JPRB, 0.52758704E-07_JPRB, 0.53785300E-07_JPRB, 0.54331501E-07_JPRB, 0.54146422E-07_JPRB, 0.53119688E-07_JPRB, &
  & 0.51370311E-07_JPRB, 0.49103246E-07_JPRB, 0.46566566E-07_JPRB, 0.44034387E-07_JPRB, 0.41696971E-07_JPRB, 0.39747590E-07_JPRB, &
  & 0.38381678E-07_JPRB, 0.37499746E-07_JPRB, 0.36988375E-07_JPRB, 0.36734054E-07_JPRB, 0.36750027E-07_JPRB, 0.37107991E-07_JPRB, &
  & 0.37825224E-07_JPRB, 0.38857632E-07_JPRB, 0.40163414E-07_JPRB, 0.41685169E-07_JPRB, 0.43386660E-07_JPRB, 0.45215771E-07_JPRB, &
  & 0.47089038E-07_JPRB, 0.48945139E-07_JPRB, 0.50769000E-07_JPRB, 0.52578233E-07_JPRB, 0.54365113E-07_JPRB, 0.56149695E-07_JPRB, &
  & 0.57882740E-07_JPRB, 0.59541684E-07_JPRB, 0.61033987E-07_JPRB, 0.62421321E-07_JPRB, 0.63640975E-07_JPRB, 0.64787400E-07_JPRB, &
  & 0.65886184E-07_JPRB, 0.67007761E-07_JPRB, 0.68163786E-07_JPRB, 0.69187813E-07_JPRB, 0.70090820E-07_JPRB, 0.70860487E-07_JPRB, &
  & 0.71572771E-07_JPRB, 0.72187234E-07_JPRB, 0.73113853E-07_JPRB, 0.74699955E-07_JPRB /)

RGHG7(:,71, 9) = (/ &
  & 0.60071152E-07_JPRB, 0.57049196E-07_JPRB, 0.55665321E-07_JPRB, 0.54741434E-07_JPRB, 0.53986874E-07_JPRB, 0.53269137E-07_JPRB, &
  & 0.52500031E-07_JPRB, 0.51631382E-07_JPRB, 0.50537174E-07_JPRB, 0.49621669E-07_JPRB, 0.48834973E-07_JPRB, 0.48182326E-07_JPRB, &
  & 0.47649390E-07_JPRB, 0.47288946E-07_JPRB, 0.47168744E-07_JPRB, 0.47317343E-07_JPRB, 0.47781072E-07_JPRB, 0.48548419E-07_JPRB, &
  & 0.49555897E-07_JPRB, 0.50642061E-07_JPRB, 0.51567984E-07_JPRB, 0.52071286E-07_JPRB, 0.51945317E-07_JPRB, 0.51090691E-07_JPRB, &
  & 0.49620311E-07_JPRB, 0.47702994E-07_JPRB, 0.45562818E-07_JPRB, 0.43440391E-07_JPRB, 0.41502602E-07_JPRB, 0.39959335E-07_JPRB, &
  & 0.38905284E-07_JPRB, 0.38312947E-07_JPRB, 0.38007347E-07_JPRB, 0.37902346E-07_JPRB, 0.38014864E-07_JPRB, 0.38417017E-07_JPRB, &
  & 0.39121421E-07_JPRB, 0.40093667E-07_JPRB, 0.41294779E-07_JPRB, 0.42680867E-07_JPRB, 0.44224567E-07_JPRB, 0.45892534E-07_JPRB, &
  & 0.47624784E-07_JPRB, 0.49349790E-07_JPRB, 0.51062937E-07_JPRB, 0.52761415E-07_JPRB, 0.54439912E-07_JPRB, 0.56111833E-07_JPRB, &
  & 0.57734908E-07_JPRB, 0.59287096E-07_JPRB, 0.60693935E-07_JPRB, 0.62003686E-07_JPRB, 0.63148931E-07_JPRB, 0.64244645E-07_JPRB, &
  & 0.65285320E-07_JPRB, 0.66348584E-07_JPRB, 0.67468697E-07_JPRB, 0.68447534E-07_JPRB, 0.69329424E-07_JPRB, 0.70063244E-07_JPRB, &
  & 0.70761693E-07_JPRB, 0.71370444E-07_JPRB, 0.72268406E-07_JPRB, 0.74013585E-07_JPRB /)

RGHG7(:,72, 9) = (/ &
  & 0.58275862E-07_JPRB, 0.54694901E-07_JPRB, 0.53150995E-07_JPRB, 0.52154064E-07_JPRB, 0.51380166E-07_JPRB, 0.50665154E-07_JPRB, &
  & 0.49932837E-07_JPRB, 0.49079787E-07_JPRB, 0.48185264E-07_JPRB, 0.47305832E-07_JPRB, 0.46710486E-07_JPRB, 0.46134435E-07_JPRB, &
  & 0.45745971E-07_JPRB, 0.45489809E-07_JPRB, 0.45451568E-07_JPRB, 0.45649266E-07_JPRB, 0.46115705E-07_JPRB, 0.46833851E-07_JPRB, &
  & 0.47760732E-07_JPRB, 0.48744507E-07_JPRB, 0.49587737E-07_JPRB, 0.50073339E-07_JPRB, 0.50013746E-07_JPRB, 0.49332577E-07_JPRB, &
  & 0.48142525E-07_JPRB, 0.46575810E-07_JPRB, 0.44810420E-07_JPRB, 0.43081336E-07_JPRB, 0.41519204E-07_JPRB, 0.40386542E-07_JPRB, &
  & 0.39599573E-07_JPRB, 0.39256498E-07_JPRB, 0.39150642E-07_JPRB, 0.39192376E-07_JPRB, 0.39406313E-07_JPRB, 0.39853983E-07_JPRB, &
  & 0.40551132E-07_JPRB, 0.41462020E-07_JPRB, 0.42566903E-07_JPRB, 0.43833033E-07_JPRB, 0.45245041E-07_JPRB, 0.46780006E-07_JPRB, &
  & 0.48375167E-07_JPRB, 0.49970573E-07_JPRB, 0.51557560E-07_JPRB, 0.53141147E-07_JPRB, 0.54705836E-07_JPRB, 0.56257026E-07_JPRB, &
  & 0.57765561E-07_JPRB, 0.59194793E-07_JPRB, 0.60510949E-07_JPRB, 0.61713578E-07_JPRB, 0.62792886E-07_JPRB, 0.63803576E-07_JPRB, &
  & 0.64789823E-07_JPRB, 0.65758513E-07_JPRB, 0.66843931E-07_JPRB, 0.67743038E-07_JPRB, 0.68595689E-07_JPRB, 0.69276588E-07_JPRB, &
  & 0.69941144E-07_JPRB, 0.70529730E-07_JPRB, 0.71357171E-07_JPRB, 0.73164308E-07_JPRB /)

RGHG7(:,73, 9) = (/ &
  & 0.56197500E-07_JPRB, 0.52152739E-07_JPRB, 0.50490314E-07_JPRB, 0.49491703E-07_JPRB, 0.48726076E-07_JPRB, 0.48043056E-07_JPRB, &
  & 0.47347662E-07_JPRB, 0.46642811E-07_JPRB, 0.45793222E-07_JPRB, 0.45186571E-07_JPRB, 0.44606097E-07_JPRB, 0.44223153E-07_JPRB, &
  & 0.43930267E-07_JPRB, 0.43798622E-07_JPRB, 0.43861814E-07_JPRB, 0.44120824E-07_JPRB, 0.44605677E-07_JPRB, 0.45304567E-07_JPRB, &
  & 0.46160903E-07_JPRB, 0.47065686E-07_JPRB, 0.47844303E-07_JPRB, 0.48317126E-07_JPRB, 0.48334950E-07_JPRB, 0.47832227E-07_JPRB, &
  & 0.46922118E-07_JPRB, 0.45695785E-07_JPRB, 0.44295479E-07_JPRB, 0.42929049E-07_JPRB, 0.41763702E-07_JPRB, 0.40949026E-07_JPRB, &
  & 0.40468688E-07_JPRB, 0.40339913E-07_JPRB, 0.40420833E-07_JPRB, 0.40601659E-07_JPRB, 0.40912330E-07_JPRB, 0.41411404E-07_JPRB, &
  & 0.42107608E-07_JPRB, 0.42975543E-07_JPRB, 0.43997375E-07_JPRB, 0.45150720E-07_JPRB, 0.46425104E-07_JPRB, 0.47816847E-07_JPRB, &
  & 0.49274846E-07_JPRB, 0.50745996E-07_JPRB, 0.52216841E-07_JPRB, 0.53682452E-07_JPRB, 0.55130990E-07_JPRB, 0.56557006E-07_JPRB, &
  & 0.57942565E-07_JPRB, 0.59252976E-07_JPRB, 0.60461176E-07_JPRB, 0.61570233E-07_JPRB, 0.62560268E-07_JPRB, 0.63503215E-07_JPRB, &
  & 0.64374703E-07_JPRB, 0.65288006E-07_JPRB, 0.66258572E-07_JPRB, 0.67110726E-07_JPRB, 0.67889054E-07_JPRB, 0.68533041E-07_JPRB, &
  & 0.69124638E-07_JPRB, 0.69691993E-07_JPRB, 0.70427021E-07_JPRB, 0.72199079E-07_JPRB /)

RGHG7(:,74, 9) = (/ &
  & 0.53635745E-07_JPRB, 0.49389637E-07_JPRB, 0.47768602E-07_JPRB, 0.46808111E-07_JPRB, 0.46101224E-07_JPRB, 0.45474788E-07_JPRB, &
  & 0.44873641E-07_JPRB, 0.44236142E-07_JPRB, 0.43646903E-07_JPRB, 0.43067551E-07_JPRB, 0.42733603E-07_JPRB, 0.42422950E-07_JPRB, &
  & 0.42294399E-07_JPRB, 0.42277023E-07_JPRB, 0.42427668E-07_JPRB, 0.42747509E-07_JPRB, 0.43258261E-07_JPRB, 0.43932278E-07_JPRB, &
  & 0.44743718E-07_JPRB, 0.45581373E-07_JPRB, 0.46310014E-07_JPRB, 0.46791808E-07_JPRB, 0.46894861E-07_JPRB, 0.46572136E-07_JPRB, &
  & 0.45934470E-07_JPRB, 0.45042331E-07_JPRB, 0.43979810E-07_JPRB, 0.42977593E-07_JPRB, 0.42210168E-07_JPRB, 0.41630599E-07_JPRB, &
  & 0.41463885E-07_JPRB, 0.41506880E-07_JPRB, 0.41745395E-07_JPRB, 0.42065743E-07_JPRB, 0.42478511E-07_JPRB, 0.43027942E-07_JPRB, &
  & 0.43725976E-07_JPRB, 0.44546997E-07_JPRB, 0.45493127E-07_JPRB, 0.46551207E-07_JPRB, 0.47724779E-07_JPRB, 0.48995538E-07_JPRB, &
  & 0.50333028E-07_JPRB, 0.51668259E-07_JPRB, 0.53010087E-07_JPRB, 0.54354871E-07_JPRB, 0.55674789E-07_JPRB, 0.56984501E-07_JPRB, &
  & 0.58236754E-07_JPRB, 0.59426775E-07_JPRB, 0.60526077E-07_JPRB, 0.61528432E-07_JPRB, 0.62437941E-07_JPRB, 0.63271912E-07_JPRB, &
  & 0.64081853E-07_JPRB, 0.64880183E-07_JPRB, 0.65776433E-07_JPRB, 0.66528656E-07_JPRB, 0.67248386E-07_JPRB, 0.67828573E-07_JPRB, &
  & 0.68355554E-07_JPRB, 0.68878670E-07_JPRB, 0.69518023E-07_JPRB, 0.71188786E-07_JPRB /)

RGHG7(:,75, 9) = (/ &
  & 0.50855309E-07_JPRB, 0.46608672E-07_JPRB, 0.45062976E-07_JPRB, 0.44198000E-07_JPRB, 0.43568757E-07_JPRB, 0.43038426E-07_JPRB, &
  & 0.42534296E-07_JPRB, 0.42058279E-07_JPRB, 0.41539785E-07_JPRB, 0.41199481E-07_JPRB, 0.40919065E-07_JPRB, 0.40788713E-07_JPRB, &
  & 0.40767205E-07_JPRB, 0.40868493E-07_JPRB, 0.41126604E-07_JPRB, 0.41509967E-07_JPRB, 0.42045990E-07_JPRB, 0.42718973E-07_JPRB, &
  & 0.43487947E-07_JPRB, 0.44274099E-07_JPRB, 0.44974236E-07_JPRB, 0.45471168E-07_JPRB, 0.45671616E-07_JPRB, 0.45525550E-07_JPRB, &
  & 0.45158576E-07_JPRB, 0.44575089E-07_JPRB, 0.43835687E-07_JPRB, 0.43218847E-07_JPRB, 0.42774946E-07_JPRB, 0.42466144E-07_JPRB, &
  & 0.42530857E-07_JPRB, 0.42802807E-07_JPRB, 0.43174044E-07_JPRB, 0.43617870E-07_JPRB, 0.44125020E-07_JPRB, 0.44729244E-07_JPRB, &
  & 0.45436757E-07_JPRB, 0.46230820E-07_JPRB, 0.47108916E-07_JPRB, 0.48071598E-07_JPRB, 0.49118004E-07_JPRB, 0.50260770E-07_JPRB, &
  & 0.51454489E-07_JPRB, 0.52670810E-07_JPRB, 0.53891934E-07_JPRB, 0.55113720E-07_JPRB, 0.56320697E-07_JPRB, 0.57489338E-07_JPRB, &
  & 0.58621637E-07_JPRB, 0.59684538E-07_JPRB, 0.60674857E-07_JPRB, 0.61583016E-07_JPRB, 0.62399764E-07_JPRB, 0.63153109E-07_JPRB, &
  & 0.63860639E-07_JPRB, 0.64585741E-07_JPRB, 0.65348225E-07_JPRB, 0.66037529E-07_JPRB, 0.66660135E-07_JPRB, 0.67185972E-07_JPRB, &
  & 0.67641139E-07_JPRB, 0.68107383E-07_JPRB, 0.68665138E-07_JPRB, 0.70184946E-07_JPRB /)

RGHG7(:,76, 9) = (/ &
  & 0.47978705E-07_JPRB, 0.43853397E-07_JPRB, 0.42440117E-07_JPRB, 0.41685414E-07_JPRB, 0.41181849E-07_JPRB, 0.40756433E-07_JPRB, &
  & 0.40376431E-07_JPRB, 0.40008612E-07_JPRB, 0.39685506E-07_JPRB, 0.39440422E-07_JPRB, 0.39348606E-07_JPRB, 0.39345249E-07_JPRB, &
  & 0.39455113E-07_JPRB, 0.39670955E-07_JPRB, 0.39982080E-07_JPRB, 0.40418680E-07_JPRB, 0.40971614E-07_JPRB, 0.41635364E-07_JPRB, &
  & 0.42372445E-07_JPRB, 0.43123695E-07_JPRB, 0.43798618E-07_JPRB, 0.44335327E-07_JPRB, 0.44637240E-07_JPRB, 0.44667107E-07_JPRB, &
  & 0.44560561E-07_JPRB, 0.44258204E-07_JPRB, 0.43838050E-07_JPRB, 0.43623178E-07_JPRB, 0.43390248E-07_JPRB, 0.43440984E-07_JPRB, &
  & 0.43628614E-07_JPRB, 0.44073062E-07_JPRB, 0.44561283E-07_JPRB, 0.45108703E-07_JPRB, 0.45711101E-07_JPRB, 0.46366228E-07_JPRB, &
  & 0.47086147E-07_JPRB, 0.47853831E-07_JPRB, 0.48685255E-07_JPRB, 0.49580599E-07_JPRB, 0.50554764E-07_JPRB, 0.51591204E-07_JPRB, &
  & 0.52674316E-07_JPRB, 0.53755368E-07_JPRB, 0.54843952E-07_JPRB, 0.55935743E-07_JPRB, 0.57005323E-07_JPRB, 0.58059303E-07_JPRB, &
  & 0.59058085E-07_JPRB, 0.60005988E-07_JPRB, 0.60882996E-07_JPRB, 0.61693804E-07_JPRB, 0.62416561E-07_JPRB, 0.63087782E-07_JPRB, &
  & 0.63714815E-07_JPRB, 0.64347084E-07_JPRB, 0.65010596E-07_JPRB, 0.65604553E-07_JPRB, 0.66140004E-07_JPRB, 0.66604294E-07_JPRB, &
  & 0.66982430E-07_JPRB, 0.67396968E-07_JPRB, 0.67854401E-07_JPRB, 0.69219773E-07_JPRB /)

RGHG7(:,77, 9) = (/ &
  & 0.45072092E-07_JPRB, 0.41178939E-07_JPRB, 0.39915072E-07_JPRB, 0.39320174E-07_JPRB, 0.38937937E-07_JPRB, 0.38651411E-07_JPRB, &
  & 0.38403645E-07_JPRB, 0.38178239E-07_JPRB, 0.37985625E-07_JPRB, 0.37896548E-07_JPRB, 0.37936999E-07_JPRB, 0.38050484E-07_JPRB, &
  & 0.38277193E-07_JPRB, 0.38569137E-07_JPRB, 0.38978449E-07_JPRB, 0.39457582E-07_JPRB, 0.40029647E-07_JPRB, 0.40683961E-07_JPRB, &
  & 0.41398554E-07_JPRB, 0.42112948E-07_JPRB, 0.42784588E-07_JPRB, 0.43356241E-07_JPRB, 0.43763642E-07_JPRB, 0.43973081E-07_JPRB, &
  & 0.44109051E-07_JPRB, 0.44046907E-07_JPRB, 0.43983786E-07_JPRB, 0.44090527E-07_JPRB, 0.44079631E-07_JPRB, 0.44432525E-07_JPRB, &
  & 0.44794419E-07_JPRB, 0.45391310E-07_JPRB, 0.46033193E-07_JPRB, 0.46671936E-07_JPRB, 0.47359901E-07_JPRB, 0.48069719E-07_JPRB, &
  & 0.48803351E-07_JPRB, 0.49552543E-07_JPRB, 0.50325554E-07_JPRB, 0.51137299E-07_JPRB, 0.51997830E-07_JPRB, 0.52915293E-07_JPRB, &
  & 0.53862600E-07_JPRB, 0.54825275E-07_JPRB, 0.55795031E-07_JPRB, 0.56767366E-07_JPRB, 0.57720449E-07_JPRB, 0.58639216E-07_JPRB, &
  & 0.59517877E-07_JPRB, 0.60344135E-07_JPRB, 0.61120900E-07_JPRB, 0.61830342E-07_JPRB, 0.62486386E-07_JPRB, 0.63065876E-07_JPRB, &
  & 0.63627823E-07_JPRB, 0.64164389E-07_JPRB, 0.64734962E-07_JPRB, 0.65230324E-07_JPRB, 0.65682300E-07_JPRB, 0.66078869E-07_JPRB, &
  & 0.66389028E-07_JPRB, 0.66737229E-07_JPRB, 0.67110619E-07_JPRB, 0.68295449E-07_JPRB /)

RGHG7(:,78, 9) = (/ &
  & 0.42167905E-07_JPRB, 0.38640056E-07_JPRB, 0.37616800E-07_JPRB, 0.37188261E-07_JPRB, 0.36973013E-07_JPRB, 0.36819618E-07_JPRB, &
  & 0.36710183E-07_JPRB, 0.36631100E-07_JPRB, 0.36601730E-07_JPRB, 0.36678152E-07_JPRB, 0.36832660E-07_JPRB, 0.37085083E-07_JPRB, &
  & 0.37387888E-07_JPRB, 0.37765393E-07_JPRB, 0.38182314E-07_JPRB, 0.38686721E-07_JPRB, 0.39259895E-07_JPRB, 0.39897927E-07_JPRB, &
  & 0.40585338E-07_JPRB, 0.41280003E-07_JPRB, 0.41939124E-07_JPRB, 0.42551974E-07_JPRB, 0.43046899E-07_JPRB, 0.43440565E-07_JPRB, &
  & 0.43775159E-07_JPRB, 0.43913897E-07_JPRB, 0.44246136E-07_JPRB, 0.44492236E-07_JPRB, 0.44832408E-07_JPRB, 0.45287788E-07_JPRB, &
  & 0.45854659E-07_JPRB, 0.46450573E-07_JPRB, 0.47170744E-07_JPRB, 0.47854886E-07_JPRB, 0.48582205E-07_JPRB, 0.49332186E-07_JPRB, &
  & 0.50098517E-07_JPRB, 0.50871904E-07_JPRB, 0.51659079E-07_JPRB, 0.52459033E-07_JPRB, 0.53283859E-07_JPRB, 0.54129622E-07_JPRB, &
  & 0.54986241E-07_JPRB, 0.55835272E-07_JPRB, 0.56687050E-07_JPRB, 0.57534283E-07_JPRB, 0.58368048E-07_JPRB, 0.59172546E-07_JPRB, &
  & 0.59944050E-07_JPRB, 0.60669919E-07_JPRB, 0.61347087E-07_JPRB, 0.61981140E-07_JPRB, 0.62546270E-07_JPRB, 0.63080620E-07_JPRB, &
  & 0.63561743E-07_JPRB, 0.64041672E-07_JPRB, 0.64508363E-07_JPRB, 0.64926226E-07_JPRB, 0.65294152E-07_JPRB, 0.65640940E-07_JPRB, &
  & 0.65872172E-07_JPRB, 0.66173115E-07_JPRB, 0.66439284E-07_JPRB, 0.67410319E-07_JPRB /)

RGHG7(:,79, 9) = (/ &
  & 0.39271807E-07_JPRB, 0.36668951E-07_JPRB, 0.36001719E-07_JPRB, 0.35818740E-07_JPRB, 0.35754272E-07_JPRB, 0.35747270E-07_JPRB, &
  & 0.35761701E-07_JPRB, 0.35815958E-07_JPRB, 0.35906695E-07_JPRB, 0.36056768E-07_JPRB, 0.36302847E-07_JPRB, 0.36574288E-07_JPRB, &
  & 0.36923257E-07_JPRB, 0.37306258E-07_JPRB, 0.37778953E-07_JPRB, 0.38285240E-07_JPRB, 0.38847222E-07_JPRB, 0.39456072E-07_JPRB, &
  & 0.40113019E-07_JPRB, 0.40778488E-07_JPRB, 0.41428400E-07_JPRB, 0.42057565E-07_JPRB, 0.42601858E-07_JPRB, 0.43136108E-07_JPRB, &
  & 0.43557844E-07_JPRB, 0.43860780E-07_JPRB, 0.44445670E-07_JPRB, 0.44668347E-07_JPRB, 0.45294051E-07_JPRB, 0.45688665E-07_JPRB, &
  & 0.46396149E-07_JPRB, 0.47013113E-07_JPRB, 0.47746589E-07_JPRB, 0.48464081E-07_JPRB, 0.49202953E-07_JPRB, 0.49972613E-07_JPRB, &
  & 0.50758793E-07_JPRB, 0.51552924E-07_JPRB, 0.52351194E-07_JPRB, 0.53154960E-07_JPRB, 0.53962985E-07_JPRB, 0.54774009E-07_JPRB, &
  & 0.55575939E-07_JPRB, 0.56372389E-07_JPRB, 0.57161383E-07_JPRB, 0.57948807E-07_JPRB, 0.58714360E-07_JPRB, 0.59458404E-07_JPRB, &
  & 0.60162094E-07_JPRB, 0.60834381E-07_JPRB, 0.61465570E-07_JPRB, 0.62048237E-07_JPRB, 0.62595085E-07_JPRB, 0.63075234E-07_JPRB, &
  & 0.63539275E-07_JPRB, 0.63969559E-07_JPRB, 0.64394975E-07_JPRB, 0.64756421E-07_JPRB, 0.65081352E-07_JPRB, 0.65393351E-07_JPRB, &
  & 0.65568855E-07_JPRB, 0.65830740E-07_JPRB, 0.65984032E-07_JPRB, 0.66680890E-07_JPRB /)

RGHG7(:,80, 9) = (/ &
  & 0.37384414E-07_JPRB, 0.35767282E-07_JPRB, 0.35357122E-07_JPRB, 0.35326572E-07_JPRB, 0.35332530E-07_JPRB, 0.35346602E-07_JPRB, &
  & 0.35389089E-07_JPRB, 0.35475228E-07_JPRB, 0.35589579E-07_JPRB, 0.35787771E-07_JPRB, 0.36047812E-07_JPRB, 0.36371375E-07_JPRB, &
  & 0.36730533E-07_JPRB, 0.37151558E-07_JPRB, 0.37594845E-07_JPRB, 0.38102499E-07_JPRB, 0.38674767E-07_JPRB, 0.39272418E-07_JPRB, &
  & 0.39918060E-07_JPRB, 0.40578218E-07_JPRB, 0.41223810E-07_JPRB, 0.41856293E-07_JPRB, 0.42418741E-07_JPRB, 0.43023689E-07_JPRB, &
  & 0.43405780E-07_JPRB, 0.43903544E-07_JPRB, 0.44442462E-07_JPRB, 0.44781064E-07_JPRB, 0.45442107E-07_JPRB, 0.45921940E-07_JPRB, &
  & 0.46601716E-07_JPRB, 0.47278029E-07_JPRB, 0.47988959E-07_JPRB, 0.48731614E-07_JPRB, 0.49478228E-07_JPRB, 0.50259075E-07_JPRB, &
  & 0.51055210E-07_JPRB, 0.51857217E-07_JPRB, 0.52663918E-07_JPRB, 0.53465907E-07_JPRB, 0.54267435E-07_JPRB, 0.55059850E-07_JPRB, &
  & 0.55838580E-07_JPRB, 0.56602982E-07_JPRB, 0.57363195E-07_JPRB, 0.58119596E-07_JPRB, 0.58870928E-07_JPRB, 0.59584249E-07_JPRB, &
  & 0.60272356E-07_JPRB, 0.60910040E-07_JPRB, 0.61522897E-07_JPRB, 0.62082101E-07_JPRB, 0.62611676E-07_JPRB, 0.63082496E-07_JPRB, &
  & 0.63528539E-07_JPRB, 0.63945400E-07_JPRB, 0.64355639E-07_JPRB, 0.64694625E-07_JPRB, 0.64995035E-07_JPRB, 0.65314680E-07_JPRB, &
  & 0.65449036E-07_JPRB, 0.65713060E-07_JPRB, 0.65795426E-07_JPRB, 0.66269124E-07_JPRB /)

RGHG7(:,81, 9) = (/ &
  & 0.36128615E-07_JPRB, 0.35321719E-07_JPRB, 0.35008359E-07_JPRB, 0.35090775E-07_JPRB, 0.35083836E-07_JPRB, 0.35111711E-07_JPRB, &
  & 0.35199221E-07_JPRB, 0.35320642E-07_JPRB, 0.35461809E-07_JPRB, 0.35682977E-07_JPRB, 0.35950677E-07_JPRB, 0.36267785E-07_JPRB, &
  & 0.36633196E-07_JPRB, 0.37032770E-07_JPRB, 0.37519897E-07_JPRB, 0.38023991E-07_JPRB, 0.38582336E-07_JPRB, 0.39175070E-07_JPRB, &
  & 0.39810523E-07_JPRB, 0.40462293E-07_JPRB, 0.41112251E-07_JPRB, 0.41744766E-07_JPRB, 0.42329781E-07_JPRB, 0.42960377E-07_JPRB, &
  & 0.43307768E-07_JPRB, 0.44008090E-07_JPRB, 0.44330751E-07_JPRB, 0.44948738E-07_JPRB, 0.45414847E-07_JPRB, 0.46062873E-07_JPRB, &
  & 0.46660475E-07_JPRB, 0.47391786E-07_JPRB, 0.48093376E-07_JPRB, 0.48840135E-07_JPRB, 0.49594711E-07_JPRB, 0.50377764E-07_JPRB, &
  & 0.51185051E-07_JPRB, 0.51996125E-07_JPRB, 0.52803049E-07_JPRB, 0.53604250E-07_JPRB, 0.54403269E-07_JPRB, 0.55184554E-07_JPRB, &
  & 0.55951762E-07_JPRB, 0.56708640E-07_JPRB, 0.57460959E-07_JPRB, 0.58204090E-07_JPRB, 0.58938301E-07_JPRB, 0.59638076E-07_JPRB, &
  & 0.60315763E-07_JPRB, 0.60947642E-07_JPRB, 0.61553052E-07_JPRB, 0.62092546E-07_JPRB, 0.62622675E-07_JPRB, 0.63087427E-07_JPRB, &
  & 0.63528624E-07_JPRB, 0.63929164E-07_JPRB, 0.64343503E-07_JPRB, 0.64664249E-07_JPRB, 0.64945631E-07_JPRB, 0.65275188E-07_JPRB, &
  & 0.65376483E-07_JPRB, 0.65654426E-07_JPRB, 0.65679423E-07_JPRB, 0.65987066E-07_JPRB /)

RGHG7(:,82, 9) = (/ &
  & 0.35263444E-07_JPRB, 0.35108460E-07_JPRB, 0.34882280E-07_JPRB, 0.35059074E-07_JPRB, 0.34985298E-07_JPRB, 0.35051325E-07_JPRB, &
  & 0.35153725E-07_JPRB, 0.35241854E-07_JPRB, 0.35417560E-07_JPRB, 0.35600511E-07_JPRB, 0.35900324E-07_JPRB, 0.36221177E-07_JPRB, &
  & 0.36599307E-07_JPRB, 0.37027483E-07_JPRB, 0.37476710E-07_JPRB, 0.37984449E-07_JPRB, 0.38550354E-07_JPRB, 0.39142776E-07_JPRB, &
  & 0.39769457E-07_JPRB, 0.40418030E-07_JPRB, 0.41075513E-07_JPRB, 0.41691276E-07_JPRB, 0.42309594E-07_JPRB, 0.42893372E-07_JPRB, &
  & 0.43301586E-07_JPRB, 0.44017295E-07_JPRB, 0.44279506E-07_JPRB, 0.45017668E-07_JPRB, 0.45410346E-07_JPRB, 0.46113076E-07_JPRB, &
  & 0.46700162E-07_JPRB, 0.47429772E-07_JPRB, 0.48143040E-07_JPRB, 0.48890499E-07_JPRB, 0.49657523E-07_JPRB, 0.50451995E-07_JPRB, &
  & 0.51258027E-07_JPRB, 0.52071123E-07_JPRB, 0.52876558E-07_JPRB, 0.53677834E-07_JPRB, 0.54464767E-07_JPRB, 0.55244250E-07_JPRB, &
  & 0.56007192E-07_JPRB, 0.56749403E-07_JPRB, 0.57505613E-07_JPRB, 0.58244634E-07_JPRB, 0.58976713E-07_JPRB, 0.59682385E-07_JPRB, &
  & 0.60345727E-07_JPRB, 0.60957419E-07_JPRB, 0.61576003E-07_JPRB, 0.62100270E-07_JPRB, 0.62633113E-07_JPRB, 0.63084890E-07_JPRB, &
  & 0.63543105E-07_JPRB, 0.63916616E-07_JPRB, 0.64339261E-07_JPRB, 0.64668249E-07_JPRB, 0.64917373E-07_JPRB, 0.65281029E-07_JPRB, &
  & 0.65346235E-07_JPRB, 0.65652877E-07_JPRB, 0.65642325E-07_JPRB, 0.65846969E-07_JPRB /)

RGHG7(:,83, 9) = (/ &
  & 0.35246053E-07_JPRB, 0.34983660E-07_JPRB, 0.34858953E-07_JPRB, 0.35023465E-07_JPRB, 0.34859067E-07_JPRB, 0.35018001E-07_JPRB, &
  & 0.35076063E-07_JPRB, 0.35215763E-07_JPRB, 0.35364415E-07_JPRB, 0.35621358E-07_JPRB, 0.35851148E-07_JPRB, 0.36205883E-07_JPRB, &
  & 0.36561300E-07_JPRB, 0.36965488E-07_JPRB, 0.37454200E-07_JPRB, 0.37958145E-07_JPRB, 0.38514667E-07_JPRB, 0.39102595E-07_JPRB, &
  & 0.39732477E-07_JPRB, 0.40374694E-07_JPRB, 0.41034376E-07_JPRB, 0.41645968E-07_JPRB, 0.42285727E-07_JPRB, 0.42814992E-07_JPRB, &
  & 0.43356501E-07_JPRB, 0.43926306E-07_JPRB, 0.44351442E-07_JPRB, 0.44964764E-07_JPRB, 0.45466223E-07_JPRB, 0.46097036E-07_JPRB, &
  & 0.46735053E-07_JPRB, 0.47436124E-07_JPRB, 0.48168410E-07_JPRB, 0.48909349E-07_JPRB, 0.49675883E-07_JPRB, 0.50468888E-07_JPRB, &
  & 0.51296357E-07_JPRB, 0.52117208E-07_JPRB, 0.52917930E-07_JPRB, 0.53721500E-07_JPRB, 0.54504277E-07_JPRB, 0.55275390E-07_JPRB, &
  & 0.56041873E-07_JPRB, 0.56799578E-07_JPRB, 0.57529586E-07_JPRB, 0.58302835E-07_JPRB, 0.58991350E-07_JPRB, 0.59698671E-07_JPRB, &
  & 0.60376536E-07_JPRB, 0.60966507E-07_JPRB, 0.61593148E-07_JPRB, 0.62103240E-07_JPRB, 0.62647480E-07_JPRB, 0.63078851E-07_JPRB, &
  & 0.63553571E-07_JPRB, 0.63916630E-07_JPRB, 0.64327814E-07_JPRB, 0.64683562E-07_JPRB, 0.64884595E-07_JPRB, 0.65281945E-07_JPRB, &
  & 0.65311809E-07_JPRB, 0.65652067E-07_JPRB, 0.65611594E-07_JPRB, 0.65874438E-07_JPRB /)

RGHG7(:,84, 9) = (/ &
  & 0.35255276E-07_JPRB, 0.34843630E-07_JPRB, 0.34918891E-07_JPRB, 0.34959267E-07_JPRB, 0.34813077E-07_JPRB, 0.35049432E-07_JPRB, &
  & 0.35038976E-07_JPRB, 0.35214462E-07_JPRB, 0.35372896E-07_JPRB, 0.35578783E-07_JPRB, 0.35872255E-07_JPRB, 0.36170682E-07_JPRB, &
  & 0.36558930E-07_JPRB, 0.36982900E-07_JPRB, 0.37431175E-07_JPRB, 0.37938420E-07_JPRB, 0.38496335E-07_JPRB, 0.39088007E-07_JPRB, &
  & 0.39710962E-07_JPRB, 0.40350006E-07_JPRB, 0.41012349E-07_JPRB, 0.41605812E-07_JPRB, 0.42267285E-07_JPRB, 0.42764675E-07_JPRB, &
  & 0.43391047E-07_JPRB, 0.43837197E-07_JPRB, 0.44406377E-07_JPRB, 0.44915772E-07_JPRB, 0.45492616E-07_JPRB, 0.46086232E-07_JPRB, &
  & 0.46744105E-07_JPRB, 0.47439659E-07_JPRB, 0.48172282E-07_JPRB, 0.48928683E-07_JPRB, 0.49716096E-07_JPRB, 0.50527852E-07_JPRB, &
  & 0.51336496E-07_JPRB, 0.52160718E-07_JPRB, 0.52934279E-07_JPRB, 0.53791236E-07_JPRB, 0.54486890E-07_JPRB, 0.55340564E-07_JPRB, &
  & 0.56011352E-07_JPRB, 0.56865833E-07_JPRB, 0.57514725E-07_JPRB, 0.58334475E-07_JPRB, 0.59028348E-07_JPRB, 0.59709720E-07_JPRB, &
  & 0.60396481E-07_JPRB, 0.60983126E-07_JPRB, 0.61601781E-07_JPRB, 0.62112711E-07_JPRB, 0.62654351E-07_JPRB, 0.63088287E-07_JPRB, &
  & 0.63549194E-07_JPRB, 0.63943631E-07_JPRB, 0.64292855E-07_JPRB, 0.64722862E-07_JPRB, 0.64854817E-07_JPRB, 0.65306608E-07_JPRB, &
  & 0.65287104E-07_JPRB, 0.65667052E-07_JPRB, 0.65588566E-07_JPRB, 0.65864555E-07_JPRB /)

RGHG7(:,85, 9) = (/ &
  & 0.35285986E-07_JPRB, 0.34726447E-07_JPRB, 0.35013674E-07_JPRB, 0.34832269E-07_JPRB, 0.34832297E-07_JPRB, 0.35029707E-07_JPRB, &
  & 0.34991725E-07_JPRB, 0.35268521E-07_JPRB, 0.35350276E-07_JPRB, 0.35650640E-07_JPRB, 0.35865998E-07_JPRB, 0.36206171E-07_JPRB, &
  & 0.36554308E-07_JPRB, 0.36939472E-07_JPRB, 0.37406114E-07_JPRB, 0.37898317E-07_JPRB, 0.38451546E-07_JPRB, 0.39043574E-07_JPRB, &
  & 0.39673481E-07_JPRB, 0.40317733E-07_JPRB, 0.40963144E-07_JPRB, 0.41578197E-07_JPRB, 0.42224748E-07_JPRB, 0.42745306E-07_JPRB, &
  & 0.43341622E-07_JPRB, 0.43823711E-07_JPRB, 0.44389612E-07_JPRB, 0.44895575E-07_JPRB, 0.45482118E-07_JPRB, 0.46076991E-07_JPRB, &
  & 0.46736744E-07_JPRB, 0.47434398E-07_JPRB, 0.48174623E-07_JPRB, 0.48917290E-07_JPRB, 0.49678807E-07_JPRB, 0.50481823E-07_JPRB, &
  & 0.51342891E-07_JPRB, 0.52182251E-07_JPRB, 0.52958548E-07_JPRB, 0.53828710E-07_JPRB, 0.54486634E-07_JPRB, 0.55403081E-07_JPRB, &
  & 0.56022756E-07_JPRB, 0.56902429E-07_JPRB, 0.57578408E-07_JPRB, 0.58338415E-07_JPRB, 0.59060898E-07_JPRB, 0.59731981E-07_JPRB, &
  & 0.60396168E-07_JPRB, 0.61010361E-07_JPRB, 0.61592878E-07_JPRB, 0.62142291E-07_JPRB, 0.62635849E-07_JPRB, 0.63124617E-07_JPRB, &
  & 0.63516630E-07_JPRB, 0.63992871E-07_JPRB, 0.64254614E-07_JPRB, 0.64754495E-07_JPRB, 0.64827418E-07_JPRB, 0.65320080E-07_JPRB, &
  & 0.65263137E-07_JPRB, 0.65675515E-07_JPRB, 0.65569829E-07_JPRB, 0.65864505E-07_JPRB /)

RGHG7(:,86, 9) = (/ &
  & 0.35309245E-07_JPRB, 0.34639648E-07_JPRB, 0.35093919E-07_JPRB, 0.34705891E-07_JPRB, 0.34927051E-07_JPRB, 0.34970849E-07_JPRB, &
  & 0.35063049E-07_JPRB, 0.35281086E-07_JPRB, 0.35432286E-07_JPRB, 0.35678912E-07_JPRB, 0.35926824E-07_JPRB, 0.36217877E-07_JPRB, &
  & 0.36557928E-07_JPRB, 0.36939440E-07_JPRB, 0.37359822E-07_JPRB, 0.37855660E-07_JPRB, 0.38397104E-07_JPRB, 0.38995310E-07_JPRB, &
  & 0.39625185E-07_JPRB, 0.40268112E-07_JPRB, 0.40923712E-07_JPRB, 0.41556952E-07_JPRB, 0.42167343E-07_JPRB, 0.42717630E-07_JPRB, &
  & 0.43293419E-07_JPRB, 0.43804409E-07_JPRB, 0.44336804E-07_JPRB, 0.44878607E-07_JPRB, 0.45454424E-07_JPRB, 0.46060496E-07_JPRB, &
  & 0.46725212E-07_JPRB, 0.47426447E-07_JPRB, 0.48165859E-07_JPRB, 0.48943722E-07_JPRB, 0.49764818E-07_JPRB, 0.50588511E-07_JPRB, &
  & 0.51375384E-07_JPRB, 0.52196789E-07_JPRB, 0.52995084E-07_JPRB, 0.53844246E-07_JPRB, 0.54544103E-07_JPRB, 0.55420838E-07_JPRB, &
  & 0.56069148E-07_JPRB, 0.56915070E-07_JPRB, 0.57612809E-07_JPRB, 0.58366748E-07_JPRB, 0.59062266E-07_JPRB, 0.59761661E-07_JPRB, &
  & 0.60392459E-07_JPRB, 0.61036516E-07_JPRB, 0.61584487E-07_JPRB, 0.62170152E-07_JPRB, 0.62619726E-07_JPRB, 0.63158765E-07_JPRB, &
  & 0.63491576E-07_JPRB, 0.64029649E-07_JPRB, 0.64231131E-07_JPRB, 0.64784793E-07_JPRB, 0.64811530E-07_JPRB, 0.65337126E-07_JPRB, &
  & 0.65255520E-07_JPRB, 0.65683949E-07_JPRB, 0.65558424E-07_JPRB, 0.65869685E-07_JPRB /)

RGHG7(:,87, 9) = (/ &
  & 0.35119832E-07_JPRB, 0.34599918E-07_JPRB, 0.35124827E-07_JPRB, 0.34633750E-07_JPRB, 0.35003037E-07_JPRB, 0.34907533E-07_JPRB, &
  & 0.35134970E-07_JPRB, 0.35314006E-07_JPRB, 0.35481044E-07_JPRB, 0.35727993E-07_JPRB, 0.35970068E-07_JPRB, 0.36255386E-07_JPRB, &
  & 0.36569539E-07_JPRB, 0.36922010E-07_JPRB, 0.37338790E-07_JPRB, 0.37797946E-07_JPRB, 0.38330978E-07_JPRB, 0.38918330E-07_JPRB, &
  & 0.39546709E-07_JPRB, 0.40225341E-07_JPRB, 0.40873879E-07_JPRB, 0.41516014E-07_JPRB, 0.42111420E-07_JPRB, 0.42693586E-07_JPRB, &
  & 0.43233317E-07_JPRB, 0.43769184E-07_JPRB, 0.44300336E-07_JPRB, 0.44845766E-07_JPRB, 0.45426475E-07_JPRB, 0.46046036E-07_JPRB, &
  & 0.46710845E-07_JPRB, 0.47427257E-07_JPRB, 0.48169092E-07_JPRB, 0.48897746E-07_JPRB, 0.49628145E-07_JPRB, 0.50428973E-07_JPRB, &
  & 0.51344578E-07_JPRB, 0.52204360E-07_JPRB, 0.53017079E-07_JPRB, 0.53845621E-07_JPRB, 0.54605248E-07_JPRB, 0.55419520E-07_JPRB, &
  & 0.56178731E-07_JPRB, 0.56919326E-07_JPRB, 0.57669300E-07_JPRB, 0.58396910E-07_JPRB, 0.59074804E-07_JPRB, 0.59777292E-07_JPRB, &
  & 0.60395095E-07_JPRB, 0.61045121E-07_JPRB, 0.61586732E-07_JPRB, 0.62177925E-07_JPRB, 0.62621034E-07_JPRB, 0.63167839E-07_JPRB, &
  & 0.63493083E-07_JPRB, 0.64034218E-07_JPRB, 0.64239622E-07_JPRB, 0.64773985E-07_JPRB, 0.64829145E-07_JPRB, 0.65318162E-07_JPRB, &
  & 0.65268082E-07_JPRB, 0.65676439E-07_JPRB, 0.65558105E-07_JPRB, 0.65871809E-07_JPRB /)

RGHG7(:,88, 9) = (/ &
  & 0.35218200E-07_JPRB, 0.34629046E-07_JPRB, 0.35103159E-07_JPRB, 0.34632652E-07_JPRB, 0.35023451E-07_JPRB, 0.34870709E-07_JPRB, &
  & 0.35217454E-07_JPRB, 0.35259319E-07_JPRB, 0.35546538E-07_JPRB, 0.35715988E-07_JPRB, 0.35970366E-07_JPRB, 0.36240920E-07_JPRB, &
  & 0.36554162E-07_JPRB, 0.36909487E-07_JPRB, 0.37302975E-07_JPRB, 0.37766593E-07_JPRB, 0.38284973E-07_JPRB, 0.38870823E-07_JPRB, &
  & 0.39514706E-07_JPRB, 0.40170058E-07_JPRB, 0.40833548E-07_JPRB, 0.41470773E-07_JPRB, 0.42076710E-07_JPRB, 0.42643514E-07_JPRB, &
  & 0.43189736E-07_JPRB, 0.43724476E-07_JPRB, 0.44249653E-07_JPRB, 0.44798515E-07_JPRB, 0.45385615E-07_JPRB, 0.46005646E-07_JPRB, &
  & 0.46687141E-07_JPRB, 0.47399489E-07_JPRB, 0.48158359E-07_JPRB, 0.48966069E-07_JPRB, 0.49828120E-07_JPRB, 0.50668014E-07_JPRB, &
  & 0.51383282E-07_JPRB, 0.52210019E-07_JPRB, 0.53048648E-07_JPRB, 0.53864749E-07_JPRB, 0.54669837E-07_JPRB, 0.55451316E-07_JPRB, &
  & 0.56212393E-07_JPRB, 0.56986501E-07_JPRB, 0.57681692E-07_JPRB, 0.58430295E-07_JPRB, 0.59092560E-07_JPRB, 0.59786124E-07_JPRB, &
  & 0.60406556E-07_JPRB, 0.61046315E-07_JPRB, 0.61597461E-07_JPRB, 0.62176355E-07_JPRB, 0.62634932E-07_JPRB, 0.63163021E-07_JPRB, &
  & 0.63512800E-07_JPRB, 0.64022032E-07_JPRB, 0.64267041E-07_JPRB, 0.64755113E-07_JPRB, 0.64859549E-07_JPRB, 0.65298117E-07_JPRB, &
  & 0.65290351E-07_JPRB, 0.65665446E-07_JPRB, 0.65567036E-07_JPRB, 0.65867212E-07_JPRB /)

RGHG7(:,89, 9) = (/ &
  & 0.35435406E-07_JPRB, 0.34656164E-07_JPRB, 0.35050117E-07_JPRB, 0.34678632E-07_JPRB, 0.34963335E-07_JPRB, 0.34892487E-07_JPRB, &
  & 0.35124099E-07_JPRB, 0.35261241E-07_JPRB, 0.35470485E-07_JPRB, 0.35649698E-07_JPRB, 0.35919893E-07_JPRB, 0.36181973E-07_JPRB, &
  & 0.36511285E-07_JPRB, 0.36864169E-07_JPRB, 0.37279850E-07_JPRB, 0.37742030E-07_JPRB, 0.38265640E-07_JPRB, 0.38855536E-07_JPRB, &
  & 0.39474379E-07_JPRB, 0.40140666E-07_JPRB, 0.40790944E-07_JPRB, 0.41428702E-07_JPRB, 0.42022634E-07_JPRB, 0.42586446E-07_JPRB, &
  & 0.43128626E-07_JPRB, 0.43658360E-07_JPRB, 0.44185715E-07_JPRB, 0.44732996E-07_JPRB, 0.45320878E-07_JPRB, 0.45951204E-07_JPRB, &
  & 0.46635869E-07_JPRB, 0.47368189E-07_JPRB, 0.48114828E-07_JPRB, 0.48846626E-07_JPRB, 0.49551559E-07_JPRB, 0.50340901E-07_JPRB, &
  & 0.51354490E-07_JPRB, 0.52226746E-07_JPRB, 0.53076832E-07_JPRB, 0.53908931E-07_JPRB, 0.54714508E-07_JPRB, 0.55512121E-07_JPRB, &
  & 0.56268156E-07_JPRB, 0.57018962E-07_JPRB, 0.57731260E-07_JPRB, 0.58443625E-07_JPRB, 0.59116736E-07_JPRB, 0.59793443E-07_JPRB, &
  & 0.60421520E-07_JPRB, 0.61047665E-07_JPRB, 0.61612418E-07_JPRB, 0.62174898E-07_JPRB, 0.62655275E-07_JPRB, 0.63156925E-07_JPRB, &
  & 0.63541286E-07_JPRB, 0.64007878E-07_JPRB, 0.64303933E-07_JPRB, 0.64729562E-07_JPRB, 0.64897833E-07_JPRB, 0.65275579E-07_JPRB, &
  & 0.65313898E-07_JPRB, 0.65654888E-07_JPRB, 0.65578973E-07_JPRB, 0.65861983E-07_JPRB /)

RGHG7(:,90, 9) = (/ &
  & 0.35324785E-07_JPRB, 0.34658704E-07_JPRB, 0.35007712E-07_JPRB, 0.34748567E-07_JPRB, 0.34877718E-07_JPRB, 0.34898978E-07_JPRB, &
  & 0.35034592E-07_JPRB, 0.35160983E-07_JPRB, 0.35327425E-07_JPRB, 0.35536200E-07_JPRB, 0.35774956E-07_JPRB, 0.36078006E-07_JPRB, &
  & 0.36414509E-07_JPRB, 0.36801705E-07_JPRB, 0.37236614E-07_JPRB, 0.37718905E-07_JPRB, 0.38264023E-07_JPRB, 0.38844352E-07_JPRB, &
  & 0.39474816E-07_JPRB, 0.40112731E-07_JPRB, 0.40750475E-07_JPRB, 0.41365002E-07_JPRB, 0.41949345E-07_JPRB, 0.42505786E-07_JPRB, &
  & 0.43036849E-07_JPRB, 0.43561823E-07_JPRB, 0.44087869E-07_JPRB, 0.44632436E-07_JPRB, 0.45221768E-07_JPRB, 0.45854922E-07_JPRB, &
  & 0.46548596E-07_JPRB, 0.47295227E-07_JPRB, 0.48088104E-07_JPRB, 0.48928261E-07_JPRB, 0.49842317E-07_JPRB, 0.50741225E-07_JPRB, &
  & 0.51396526E-07_JPRB, 0.52271719E-07_JPRB, 0.53133718E-07_JPRB, 0.53971448E-07_JPRB, 0.54788018E-07_JPRB, 0.55579960E-07_JPRB, &
  & 0.56341023E-07_JPRB, 0.57077944E-07_JPRB, 0.57783645E-07_JPRB, 0.58479063E-07_JPRB, 0.59148107E-07_JPRB, 0.59810198E-07_JPRB, &
  & 0.60442673E-07_JPRB, 0.61057875E-07_JPRB, 0.61632079E-07_JPRB, 0.62182956E-07_JPRB, 0.62679611E-07_JPRB, 0.63161778E-07_JPRB, &
  & 0.63573424E-07_JPRB, 0.64006130E-07_JPRB, 0.64345848E-07_JPRB, 0.64717717E-07_JPRB, 0.64939890E-07_JPRB, 0.65259371E-07_JPRB, &
  & 0.65350548E-07_JPRB, 0.65638197E-07_JPRB, 0.65605128E-07_JPRB, 0.65851914E-07_JPRB /)

RGHG7(:,91, 9) = (/ &
  & 0.34998944E-07_JPRB, 0.34798916E-07_JPRB, 0.34911885E-07_JPRB, 0.34817930E-07_JPRB, 0.34824232E-07_JPRB, 0.34874066E-07_JPRB, &
  & 0.34934374E-07_JPRB, 0.35035086E-07_JPRB, 0.35164245E-07_JPRB, 0.35334551E-07_JPRB, 0.35585813E-07_JPRB, 0.35904417E-07_JPRB, &
  & 0.36284352E-07_JPRB, 0.36709469E-07_JPRB, 0.37179493E-07_JPRB, 0.37694136E-07_JPRB, 0.38245108E-07_JPRB, 0.38828897E-07_JPRB, &
  & 0.39433960E-07_JPRB, 0.40050541E-07_JPRB, 0.40661376E-07_JPRB, 0.41254435E-07_JPRB, 0.41820769E-07_JPRB, 0.42366626E-07_JPRB, &
  & 0.42887557E-07_JPRB, 0.43410306E-07_JPRB, 0.43934570E-07_JPRB, 0.44479439E-07_JPRB, 0.45073563E-07_JPRB, 0.45705878E-07_JPRB, &
  & 0.46412708E-07_JPRB, 0.47177480E-07_JPRB, 0.47957538E-07_JPRB, 0.48773746E-07_JPRB, 0.49563010E-07_JPRB, 0.50407738E-07_JPRB, &
  & 0.51400388E-07_JPRB, 0.52319511E-07_JPRB, 0.53206676E-07_JPRB, 0.54065392E-07_JPRB, 0.54894816E-07_JPRB, 0.55687796E-07_JPRB, &
  & 0.56440811E-07_JPRB, 0.57161682E-07_JPRB, 0.57858397E-07_JPRB, 0.58536468E-07_JPRB, 0.59197806E-07_JPRB, 0.59845448E-07_JPRB, &
  & 0.60475422E-07_JPRB, 0.61083369E-07_JPRB, 0.61660820E-07_JPRB, 0.62207654E-07_JPRB, 0.62711557E-07_JPRB, 0.63186071E-07_JPRB, &
  & 0.63610322E-07_JPRB, 0.64026281E-07_JPRB, 0.64391479E-07_JPRB, 0.64725185E-07_JPRB, 0.64990537E-07_JPRB, 0.65247747E-07_JPRB, &
  & 0.65407619E-07_JPRB, 0.65610095E-07_JPRB, 0.65666029E-07_JPRB, 0.65816273E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG7(:, 1,10) = (/ &
  & 0.19165664E-06_JPRB, 0.12794892E-06_JPRB, 0.10331865E-06_JPRB, 0.88503690E-07_JPRB, 0.80152610E-07_JPRB, 0.76933517E-07_JPRB, &
  & 0.74725797E-07_JPRB, 0.74291954E-07_JPRB, 0.72561249E-07_JPRB, 0.72182701E-07_JPRB, 0.71943546E-07_JPRB, 0.71580850E-07_JPRB, &
  & 0.71423067E-07_JPRB, 0.71553323E-07_JPRB, 0.71417070E-07_JPRB, 0.71368603E-07_JPRB, 0.71396521E-07_JPRB, 0.71447907E-07_JPRB, &
  & 0.71203672E-07_JPRB, 0.71046159E-07_JPRB, 0.70776451E-07_JPRB, 0.70527904E-07_JPRB, 0.70288230E-07_JPRB, 0.70121096E-07_JPRB, &
  & 0.69780008E-07_JPRB, 0.69362294E-07_JPRB, 0.68880460E-07_JPRB, 0.68307848E-07_JPRB, 0.67702700E-07_JPRB, 0.67133989E-07_JPRB, &
  & 0.66688727E-07_JPRB, 0.66467798E-07_JPRB, 0.66543443E-07_JPRB, 0.66943592E-07_JPRB, 0.67475327E-07_JPRB, 0.68148744E-07_JPRB, &
  & 0.68851591E-07_JPRB, 0.69310424E-07_JPRB, 0.69554652E-07_JPRB, 0.69814462E-07_JPRB, 0.69892586E-07_JPRB, 0.69765861E-07_JPRB, &
  & 0.69626303E-07_JPRB, 0.69310353E-07_JPRB, 0.68954762E-07_JPRB, 0.68601977E-07_JPRB, 0.68356883E-07_JPRB, 0.68049467E-07_JPRB, &
  & 0.67685797E-07_JPRB, 0.67329523E-07_JPRB, 0.66933950E-07_JPRB, 0.66578139E-07_JPRB, 0.66315735E-07_JPRB, 0.66165313E-07_JPRB, &
  & 0.66071721E-07_JPRB, 0.66116655E-07_JPRB, 0.66324311E-07_JPRB, 0.66913913E-07_JPRB, 0.68961931E-07_JPRB, 0.59134172E-05_JPRB, &
  & 0.59357362E-05_JPRB, 0.59546387E-05_JPRB, 0.59663212E-05_JPRB, 0.59713607E-05_JPRB /)

RGHG7(:, 2,10) = (/ &
  & 0.16559411E-05_JPRB, 0.16239048E-05_JPRB, 0.14784320E-05_JPRB, 0.13585759E-05_JPRB, 0.12246060E-05_JPRB, 0.11149673E-05_JPRB, &
  & 0.95933183E-06_JPRB, 0.78062834E-06_JPRB, 0.57777658E-06_JPRB, 0.44446151E-06_JPRB, 0.37301919E-06_JPRB, 0.32861504E-06_JPRB, &
  & 0.30163233E-06_JPRB, 0.28300997E-06_JPRB, 0.26668934E-06_JPRB, 0.25436191E-06_JPRB, 0.24666073E-06_JPRB, 0.24222024E-06_JPRB, &
  & 0.23501656E-06_JPRB, 0.22979330E-06_JPRB, 0.22608776E-06_JPRB, 0.22438647E-06_JPRB, 0.22538302E-06_JPRB, 0.23112260E-06_JPRB, &
  & 0.23294777E-06_JPRB, 0.23362671E-06_JPRB, 0.23390912E-06_JPRB, 0.23368327E-06_JPRB, 0.23317904E-06_JPRB, 0.23251842E-06_JPRB, &
  & 0.23185677E-06_JPRB, 0.23132650E-06_JPRB, 0.23249197E-06_JPRB, 0.23692316E-06_JPRB, 0.23252289E-06_JPRB, 0.22699928E-06_JPRB, &
  & 0.22056950E-06_JPRB, 0.21546452E-06_JPRB, 0.21090813E-06_JPRB, 0.20457178E-06_JPRB, 0.19961618E-06_JPRB, 0.19718077E-06_JPRB, &
  & 0.19851140E-06_JPRB, 0.19713663E-06_JPRB, 0.19637351E-06_JPRB, 0.19593088E-06_JPRB, 0.19512885E-06_JPRB, 0.19462712E-06_JPRB, &
  & 0.19421573E-06_JPRB, 0.19502470E-06_JPRB, 0.19195248E-06_JPRB, 0.18774639E-06_JPRB, 0.18276593E-06_JPRB, 0.17718149E-06_JPRB, &
  & 0.16783660E-06_JPRB, 0.15851951E-06_JPRB, 0.14884002E-06_JPRB, 0.14364984E-06_JPRB, 0.14781341E-06_JPRB, 0.45790111E-05_JPRB, &
  & 0.46236896E-05_JPRB, 0.46121813E-05_JPRB, 0.46034202E-05_JPRB, 0.46790187E-05_JPRB /)

RGHG7(:, 3,10) = (/ &
  & 0.16916425E-05_JPRB, 0.16980010E-05_JPRB, 0.15610185E-05_JPRB, 0.14116944E-05_JPRB, 0.12759099E-05_JPRB, 0.12154750E-05_JPRB, &
  & 0.11383735E-05_JPRB, 0.10050339E-05_JPRB, 0.79905044E-06_JPRB, 0.67283491E-06_JPRB, 0.60327261E-06_JPRB, 0.56248274E-06_JPRB, &
  & 0.53693697E-06_JPRB, 0.51293631E-06_JPRB, 0.49168290E-06_JPRB, 0.47495047E-06_JPRB, 0.46662353E-06_JPRB, 0.45866670E-06_JPRB, &
  & 0.44913020E-06_JPRB, 0.44010727E-06_JPRB, 0.43408807E-06_JPRB, 0.43107693E-06_JPRB, 0.43481285E-06_JPRB, 0.44444289E-06_JPRB, &
  & 0.44270641E-06_JPRB, 0.44261628E-06_JPRB, 0.44115941E-06_JPRB, 0.43907067E-06_JPRB, 0.43650437E-06_JPRB, 0.43346623E-06_JPRB, &
  & 0.42981966E-06_JPRB, 0.42642731E-06_JPRB, 0.42824195E-06_JPRB, 0.43460895E-06_JPRB, 0.42690453E-06_JPRB, 0.42224795E-06_JPRB, &
  & 0.41353965E-06_JPRB, 0.40165094E-06_JPRB, 0.38983671E-06_JPRB, 0.38214347E-06_JPRB, 0.37679723E-06_JPRB, 0.37562606E-06_JPRB, &
  & 0.37714003E-06_JPRB, 0.37196500E-06_JPRB, 0.36930837E-06_JPRB, 0.36455208E-06_JPRB, 0.36062195E-06_JPRB, 0.35665443E-06_JPRB, &
  & 0.35325027E-06_JPRB, 0.35165576E-06_JPRB, 0.34234429E-06_JPRB, 0.32647350E-06_JPRB, 0.30411593E-06_JPRB, 0.27950054E-06_JPRB, &
  & 0.24913456E-06_JPRB, 0.22238939E-06_JPRB, 0.19704088E-06_JPRB, 0.17993840E-06_JPRB, 0.18402177E-06_JPRB, 0.20222190E-05_JPRB, &
  & 0.21622218E-05_JPRB, 0.23116593E-05_JPRB, 0.24017538E-05_JPRB, 0.25089994E-05_JPRB /)

RGHG7(:, 4,10) = (/ &
  & 0.19395252E-05_JPRB, 0.18022000E-05_JPRB, 0.15770635E-05_JPRB, 0.13905086E-05_JPRB, 0.12517954E-05_JPRB, 0.11628537E-05_JPRB, &
  & 0.10750738E-05_JPRB, 0.97076565E-06_JPRB, 0.86252669E-06_JPRB, 0.81822282E-06_JPRB, 0.80274810E-06_JPRB, 0.79339316E-06_JPRB, &
  & 0.79133997E-06_JPRB, 0.78282477E-06_JPRB, 0.77291918E-06_JPRB, 0.76631329E-06_JPRB, 0.76739917E-06_JPRB, 0.76553425E-06_JPRB, &
  & 0.76076907E-06_JPRB, 0.75458610E-06_JPRB, 0.75062428E-06_JPRB, 0.75114320E-06_JPRB, 0.76710069E-06_JPRB, 0.77949062E-06_JPRB, &
  & 0.78169512E-06_JPRB, 0.77908112E-06_JPRB, 0.77621831E-06_JPRB, 0.77169017E-06_JPRB, 0.76496775E-06_JPRB, 0.75703639E-06_JPRB, &
  & 0.74848435E-06_JPRB, 0.74203342E-06_JPRB, 0.74772686E-06_JPRB, 0.75500793E-06_JPRB, 0.73601933E-06_JPRB, 0.72452610E-06_JPRB, &
  & 0.70878900E-06_JPRB, 0.70250678E-06_JPRB, 0.68884776E-06_JPRB, 0.67689689E-06_JPRB, 0.66438952E-06_JPRB, 0.65917772E-06_JPRB, &
  & 0.65537699E-06_JPRB, 0.63808824E-06_JPRB, 0.62398789E-06_JPRB, 0.60780843E-06_JPRB, 0.59092798E-06_JPRB, 0.57663584E-06_JPRB, &
  & 0.56444543E-06_JPRB, 0.55227497E-06_JPRB, 0.52587308E-06_JPRB, 0.49791828E-06_JPRB, 0.47418231E-06_JPRB, 0.46171840E-06_JPRB, &
  & 0.45168963E-06_JPRB, 0.44218766E-06_JPRB, 0.43547453E-06_JPRB, 0.42909639E-06_JPRB, 0.47349369E-06_JPRB, 0.19192596E-05_JPRB, &
  & 0.18873220E-05_JPRB, 0.18383309E-05_JPRB, 0.18030526E-05_JPRB, 0.17909782E-05_JPRB /)

RGHG7(:, 5,10) = (/ &
  & 0.15211299E-05_JPRB, 0.13685916E-05_JPRB, 0.12537735E-05_JPRB, 0.11290306E-05_JPRB, 0.10487944E-05_JPRB, 0.10316472E-05_JPRB, &
  & 0.10320402E-05_JPRB, 0.10140589E-05_JPRB, 0.99533020E-06_JPRB, 0.99715476E-06_JPRB, 0.10151192E-05_JPRB, 0.10295142E-05_JPRB, &
  & 0.10454099E-05_JPRB, 0.10532032E-05_JPRB, 0.10585452E-05_JPRB, 0.10670657E-05_JPRB, 0.10838357E-05_JPRB, 0.10928287E-05_JPRB, &
  & 0.10972309E-05_JPRB, 0.10997984E-05_JPRB, 0.11013350E-05_JPRB, 0.11054719E-05_JPRB, 0.11338878E-05_JPRB, 0.11434158E-05_JPRB, &
  & 0.11456657E-05_JPRB, 0.11437998E-05_JPRB, 0.11418584E-05_JPRB, 0.11362424E-05_JPRB, 0.11312079E-05_JPRB, 0.11192702E-05_JPRB, &
  & 0.11086488E-05_JPRB, 0.10992101E-05_JPRB, 0.11042146E-05_JPRB, 0.11109590E-05_JPRB, 0.10855947E-05_JPRB, 0.10797536E-05_JPRB, &
  & 0.10535647E-05_JPRB, 0.10389026E-05_JPRB, 0.10162568E-05_JPRB, 0.10009198E-05_JPRB, 0.98488317E-06_JPRB, 0.97794066E-06_JPRB, &
  & 0.97085410E-06_JPRB, 0.94302135E-06_JPRB, 0.91697501E-06_JPRB, 0.89201728E-06_JPRB, 0.86492702E-06_JPRB, 0.84438153E-06_JPRB, &
  & 0.82337544E-06_JPRB, 0.80243734E-06_JPRB, 0.77290014E-06_JPRB, 0.74920780E-06_JPRB, 0.73493857E-06_JPRB, 0.71478973E-06_JPRB, &
  & 0.68700962E-06_JPRB, 0.64955327E-06_JPRB, 0.61549406E-06_JPRB, 0.57332812E-06_JPRB, 0.59365459E-06_JPRB, 0.10876109E-05_JPRB, &
  & 0.11702987E-05_JPRB, 0.12819290E-05_JPRB, 0.13605818E-05_JPRB, 0.14441480E-05_JPRB /)

RGHG7(:, 6,10) = (/ &
  & 0.18301191E-05_JPRB, 0.15444224E-05_JPRB, 0.13679853E-05_JPRB, 0.12633581E-05_JPRB, 0.11818281E-05_JPRB, 0.11722201E-05_JPRB, &
  & 0.11866206E-05_JPRB, 0.12013671E-05_JPRB, 0.12223236E-05_JPRB, 0.12498800E-05_JPRB, 0.12840450E-05_JPRB, 0.13168971E-05_JPRB, &
  & 0.13518481E-05_JPRB, 0.13769553E-05_JPRB, 0.13980442E-05_JPRB, 0.14202365E-05_JPRB, 0.14491236E-05_JPRB, 0.14684832E-05_JPRB, &
  & 0.14797889E-05_JPRB, 0.14855407E-05_JPRB, 0.14879870E-05_JPRB, 0.14954510E-05_JPRB, 0.15313741E-05_JPRB, 0.15424503E-05_JPRB, &
  & 0.15432931E-05_JPRB, 0.15374313E-05_JPRB, 0.15318144E-05_JPRB, 0.15233422E-05_JPRB, 0.15124739E-05_JPRB, 0.15054828E-05_JPRB, &
  & 0.14874281E-05_JPRB, 0.14847592E-05_JPRB, 0.14863548E-05_JPRB, 0.14951474E-05_JPRB, 0.14637465E-05_JPRB, 0.14556845E-05_JPRB, &
  & 0.14308058E-05_JPRB, 0.14163687E-05_JPRB, 0.13947682E-05_JPRB, 0.13760340E-05_JPRB, 0.13584582E-05_JPRB, 0.13495479E-05_JPRB, &
  & 0.13375252E-05_JPRB, 0.13034883E-05_JPRB, 0.12672587E-05_JPRB, 0.12383658E-05_JPRB, 0.12050921E-05_JPRB, 0.11801359E-05_JPRB, &
  & 0.11596287E-05_JPRB, 0.11428943E-05_JPRB, 0.11231416E-05_JPRB, 0.11062405E-05_JPRB, 0.10963512E-05_JPRB, 0.10856365E-05_JPRB, &
  & 0.10888098E-05_JPRB, 0.10874649E-05_JPRB, 0.10941330E-05_JPRB, 0.10990757E-05_JPRB, 0.11688001E-05_JPRB, 0.13592849E-05_JPRB, &
  & 0.13057398E-05_JPRB, 0.12761819E-05_JPRB, 0.12688264E-05_JPRB, 0.12801004E-05_JPRB /)

RGHG7(:, 7,10) = (/ &
  & 0.18327551E-05_JPRB, 0.16674836E-05_JPRB, 0.15598566E-05_JPRB, 0.14926509E-05_JPRB, 0.14681083E-05_JPRB, 0.14664191E-05_JPRB, &
  & 0.14887760E-05_JPRB, 0.15239639E-05_JPRB, 0.15640920E-05_JPRB, 0.16038018E-05_JPRB, 0.16514452E-05_JPRB, 0.16957966E-05_JPRB, &
  & 0.17411160E-05_JPRB, 0.17778913E-05_JPRB, 0.18104686E-05_JPRB, 0.18433652E-05_JPRB, 0.18819247E-05_JPRB, 0.19115030E-05_JPRB, &
  & 0.19330130E-05_JPRB, 0.19501467E-05_JPRB, 0.19650156E-05_JPRB, 0.19826628E-05_JPRB, 0.20210277E-05_JPRB, 0.20286398E-05_JPRB, &
  & 0.20273103E-05_JPRB, 0.20229015E-05_JPRB, 0.20181224E-05_JPRB, 0.20128132E-05_JPRB, 0.20039281E-05_JPRB, 0.19981460E-05_JPRB, &
  & 0.19832200E-05_JPRB, 0.19799475E-05_JPRB, 0.19861013E-05_JPRB, 0.19917677E-05_JPRB, 0.19580552E-05_JPRB, 0.19459217E-05_JPRB, &
  & 0.19176737E-05_JPRB, 0.19012796E-05_JPRB, 0.18778793E-05_JPRB, 0.18575495E-05_JPRB, 0.18401427E-05_JPRB, 0.18348559E-05_JPRB, &
  & 0.18216488E-05_JPRB, 0.17932903E-05_JPRB, 0.17586269E-05_JPRB, 0.17352830E-05_JPRB, 0.17121735E-05_JPRB, 0.16941461E-05_JPRB, &
  & 0.16805180E-05_JPRB, 0.16710605E-05_JPRB, 0.16578964E-05_JPRB, 0.16401502E-05_JPRB, 0.16376183E-05_JPRB, 0.16390238E-05_JPRB, &
  & 0.16474889E-05_JPRB, 0.16366757E-05_JPRB, 0.16197947E-05_JPRB, 0.15846690E-05_JPRB, 0.15261677E-05_JPRB, 0.15375183E-05_JPRB, &
  & 0.15141172E-05_JPRB, 0.14990056E-05_JPRB, 0.14901893E-05_JPRB, 0.14724426E-05_JPRB /)

RGHG7(:, 8,10) = (/ &
  & 0.20340494E-05_JPRB, 0.19487118E-05_JPRB, 0.18859862E-05_JPRB, 0.18300142E-05_JPRB, 0.18160696E-05_JPRB, 0.18480549E-05_JPRB, &
  & 0.18866408E-05_JPRB, 0.19170113E-05_JPRB, 0.19519125E-05_JPRB, 0.19938516E-05_JPRB, 0.20421874E-05_JPRB, 0.20897076E-05_JPRB, &
  & 0.21394094E-05_JPRB, 0.21816420E-05_JPRB, 0.22194749E-05_JPRB, 0.22559191E-05_JPRB, 0.22950696E-05_JPRB, 0.23248540E-05_JPRB, &
  & 0.23474383E-05_JPRB, 0.23646940E-05_JPRB, 0.23769223E-05_JPRB, 0.23935154E-05_JPRB, 0.24373076E-05_JPRB, 0.24593646E-05_JPRB, &
  & 0.24729627E-05_JPRB, 0.24803462E-05_JPRB, 0.24838189E-05_JPRB, 0.24825613E-05_JPRB, 0.24796921E-05_JPRB, 0.24732237E-05_JPRB, &
  & 0.24642391E-05_JPRB, 0.24612536E-05_JPRB, 0.24735471E-05_JPRB, 0.24794981E-05_JPRB, 0.24484989E-05_JPRB, 0.24375095E-05_JPRB, &
  & 0.24117410E-05_JPRB, 0.23941989E-05_JPRB, 0.23733689E-05_JPRB, 0.23535742E-05_JPRB, 0.23388964E-05_JPRB, 0.23408484E-05_JPRB, &
  & 0.23294183E-05_JPRB, 0.23119569E-05_JPRB, 0.22901859E-05_JPRB, 0.22744553E-05_JPRB, 0.22630099E-05_JPRB, 0.22604013E-05_JPRB, &
  & 0.22640131E-05_JPRB, 0.22664678E-05_JPRB, 0.22719623E-05_JPRB, 0.22779859E-05_JPRB, 0.23022378E-05_JPRB, 0.23270109E-05_JPRB, &
  & 0.23574130E-05_JPRB, 0.23737034E-05_JPRB, 0.23618827E-05_JPRB, 0.22808033E-05_JPRB, 0.21332871E-05_JPRB, 0.20784880E-05_JPRB, &
  & 0.20189166E-05_JPRB, 0.19736915E-05_JPRB, 0.19404624E-05_JPRB, 0.18882231E-05_JPRB /)

RGHG7(:, 9,10) = (/ &
  & 0.25787149E-05_JPRB, 0.24419078E-05_JPRB, 0.23802702E-05_JPRB, 0.23474574E-05_JPRB, 0.23232835E-05_JPRB, 0.23214793E-05_JPRB, &
  & 0.23413827E-05_JPRB, 0.23767138E-05_JPRB, 0.24187430E-05_JPRB, 0.24604346E-05_JPRB, 0.25091824E-05_JPRB, 0.25568436E-05_JPRB, &
  & 0.26052535E-05_JPRB, 0.26469529E-05_JPRB, 0.26852517E-05_JPRB, 0.27226531E-05_JPRB, 0.27626218E-05_JPRB, 0.27946801E-05_JPRB, &
  & 0.28212139E-05_JPRB, 0.28451495E-05_JPRB, 0.28710058E-05_JPRB, 0.29055491E-05_JPRB, 0.29618234E-05_JPRB, 0.29916912E-05_JPRB, &
  & 0.30075423E-05_JPRB, 0.30190979E-05_JPRB, 0.30300703E-05_JPRB, 0.30403753E-05_JPRB, 0.30484609E-05_JPRB, 0.30514345E-05_JPRB, &
  & 0.30507529E-05_JPRB, 0.30517533E-05_JPRB, 0.30737510E-05_JPRB, 0.30832675E-05_JPRB, 0.30592462E-05_JPRB, 0.30471517E-05_JPRB, &
  & 0.30262179E-05_JPRB, 0.30078718E-05_JPRB, 0.29893920E-05_JPRB, 0.29718326E-05_JPRB, 0.29598900E-05_JPRB, 0.29687981E-05_JPRB, &
  & 0.29645480E-05_JPRB, 0.29592554E-05_JPRB, 0.29548896E-05_JPRB, 0.29579683E-05_JPRB, 0.29651649E-05_JPRB, 0.29812950E-05_JPRB, &
  & 0.30084050E-05_JPRB, 0.30309068E-05_JPRB, 0.30554647E-05_JPRB, 0.30845538E-05_JPRB, 0.31255313E-05_JPRB, 0.31585387E-05_JPRB, &
  & 0.31777965E-05_JPRB, 0.31407765E-05_JPRB, 0.30191418E-05_JPRB, 0.28090039E-05_JPRB, 0.26132998E-05_JPRB, 0.25390598E-05_JPRB, &
  & 0.24817959E-05_JPRB, 0.24316166E-05_JPRB, 0.23889540E-05_JPRB, 0.23371001E-05_JPRB /)

RGHG7(:,10,10) = (/ &
  & 0.28070986E-05_JPRB, 0.27918329E-05_JPRB, 0.27756994E-05_JPRB, 0.27828332E-05_JPRB, 0.28149398E-05_JPRB, 0.28608663E-05_JPRB, &
  & 0.29050211E-05_JPRB, 0.29428072E-05_JPRB, 0.29832020E-05_JPRB, 0.30273386E-05_JPRB, 0.30779954E-05_JPRB, 0.31282041E-05_JPRB, &
  & 0.31804796E-05_JPRB, 0.32256719E-05_JPRB, 0.32667820E-05_JPRB, 0.33072372E-05_JPRB, 0.33484657E-05_JPRB, 0.33795254E-05_JPRB, &
  & 0.34036109E-05_JPRB, 0.34262748E-05_JPRB, 0.34524103E-05_JPRB, 0.34895315E-05_JPRB, 0.35499402E-05_JPRB, 0.35947162E-05_JPRB, &
  & 0.36336548E-05_JPRB, 0.36698543E-05_JPRB, 0.36977581E-05_JPRB, 0.37191553E-05_JPRB, 0.37270072E-05_JPRB, 0.37366701E-05_JPRB, &
  & 0.37423222E-05_JPRB, 0.37528632E-05_JPRB, 0.37830500E-05_JPRB, 0.37959212E-05_JPRB, 0.37814600E-05_JPRB, 0.37704517E-05_JPRB, &
  & 0.37569982E-05_JPRB, 0.37425623E-05_JPRB, 0.37275395E-05_JPRB, 0.37137161E-05_JPRB, 0.37083414E-05_JPRB, 0.37246170E-05_JPRB, &
  & 0.37308621E-05_JPRB, 0.37384477E-05_JPRB, 0.37489754E-05_JPRB, 0.37670236E-05_JPRB, 0.37898781E-05_JPRB, 0.38200201E-05_JPRB, &
  & 0.38618523E-05_JPRB, 0.38980384E-05_JPRB, 0.39318202E-05_JPRB, 0.39664910E-05_JPRB, 0.40013538E-05_JPRB, 0.40038049E-05_JPRB, &
  & 0.39531747E-05_JPRB, 0.38070143E-05_JPRB, 0.35685578E-05_JPRB, 0.32881985E-05_JPRB, 0.30715300E-05_JPRB, 0.29820385E-05_JPRB, &
  & 0.29182522E-05_JPRB, 0.28777051E-05_JPRB, 0.28405348E-05_JPRB, 0.27777592E-05_JPRB /)

RGHG7(:,11,10) = (/ &
  & 0.36037629E-05_JPRB, 0.36106064E-05_JPRB, 0.36054580E-05_JPRB, 0.35999706E-05_JPRB, 0.36131373E-05_JPRB, 0.36489459E-05_JPRB, &
  & 0.36932586E-05_JPRB, 0.37446314E-05_JPRB, 0.38006765E-05_JPRB, 0.38558137E-05_JPRB, 0.39162110E-05_JPRB, 0.39744314E-05_JPRB, &
  & 0.40323016E-05_JPRB, 0.40788127E-05_JPRB, 0.41174094E-05_JPRB, 0.41535409E-05_JPRB, 0.41919247E-05_JPRB, 0.42199817E-05_JPRB, &
  & 0.42410911E-05_JPRB, 0.42600177E-05_JPRB, 0.42829638E-05_JPRB, 0.43175023E-05_JPRB, 0.43742871E-05_JPRB, 0.44188919E-05_JPRB, &
  & 0.44552180E-05_JPRB, 0.44868029E-05_JPRB, 0.45100423E-05_JPRB, 0.45271117E-05_JPRB, 0.45353313E-05_JPRB, 0.45418215E-05_JPRB, &
  & 0.45401439E-05_JPRB, 0.45465131E-05_JPRB, 0.45733309E-05_JPRB, 0.45841907E-05_JPRB, 0.45784845E-05_JPRB, 0.45747647E-05_JPRB, &
  & 0.45719298E-05_JPRB, 0.45698866E-05_JPRB, 0.45696970E-05_JPRB, 0.45739534E-05_JPRB, 0.45900720E-05_JPRB, 0.46298192E-05_JPRB, &
  & 0.46596006E-05_JPRB, 0.46871355E-05_JPRB, 0.47135040E-05_JPRB, 0.47410003E-05_JPRB, 0.47681920E-05_JPRB, 0.47970498E-05_JPRB, &
  & 0.48321099E-05_JPRB, 0.48499510E-05_JPRB, 0.48515763E-05_JPRB, 0.48372813E-05_JPRB, 0.47963522E-05_JPRB, 0.46914124E-05_JPRB, &
  & 0.45100842E-05_JPRB, 0.42434544E-05_JPRB, 0.39360257E-05_JPRB, 0.36797410E-05_JPRB, 0.34853863E-05_JPRB, 0.34337111E-05_JPRB, &
  & 0.33363490E-05_JPRB, 0.33250465E-05_JPRB, 0.32303058E-05_JPRB, 0.32001117E-05_JPRB /)

RGHG7(:,12,10) = (/ &
  & 0.40632831E-05_JPRB, 0.41418571E-05_JPRB, 0.42159763E-05_JPRB, 0.43044242E-05_JPRB, 0.43985051E-05_JPRB, 0.45004326E-05_JPRB, &
  & 0.45938091E-05_JPRB, 0.46737741E-05_JPRB, 0.47447411E-05_JPRB, 0.48103057E-05_JPRB, 0.48773245E-05_JPRB, 0.49392670E-05_JPRB, &
  & 0.50009990E-05_JPRB, 0.50529579E-05_JPRB, 0.50971357E-05_JPRB, 0.51365296E-05_JPRB, 0.51778002E-05_JPRB, 0.52072851E-05_JPRB, &
  & 0.52292239E-05_JPRB, 0.52484306E-05_JPRB, 0.52708929E-05_JPRB, 0.53026142E-05_JPRB, 0.53554099E-05_JPRB, 0.53963831E-05_JPRB, &
  & 0.54258890E-05_JPRB, 0.54558232E-05_JPRB, 0.54816937E-05_JPRB, 0.55035348E-05_JPRB, 0.55110113E-05_JPRB, 0.55101495E-05_JPRB, &
  & 0.55017927E-05_JPRB, 0.55040005E-05_JPRB, 0.55305663E-05_JPRB, 0.55411515E-05_JPRB, 0.55381320E-05_JPRB, 0.55327673E-05_JPRB, &
  & 0.55278683E-05_JPRB, 0.55253395E-05_JPRB, 0.55262849E-05_JPRB, 0.55335959E-05_JPRB, 0.55515293E-05_JPRB, 0.55891910E-05_JPRB, &
  & 0.56133849E-05_JPRB, 0.56269564E-05_JPRB, 0.56312774E-05_JPRB, 0.56281156E-05_JPRB, 0.56193790E-05_JPRB, 0.56075946E-05_JPRB, &
  & 0.55982155E-05_JPRB, 0.55665578E-05_JPRB, 0.55090250E-05_JPRB, 0.54183706E-05_JPRB, 0.52817691E-05_JPRB, 0.50734056E-05_JPRB, &
  & 0.47937342E-05_JPRB, 0.44513276E-05_JPRB, 0.40862878E-05_JPRB, 0.38045789E-05_JPRB, 0.36232359E-05_JPRB, 0.35804312E-05_JPRB, &
  & 0.35472990E-05_JPRB, 0.35389876E-05_JPRB, 0.35078767E-05_JPRB, 0.35040493E-05_JPRB /)

RGHG7(:,13,10) = (/ &
  & 0.46108271E-05_JPRB, 0.47453846E-05_JPRB, 0.48313536E-05_JPRB, 0.49194005E-05_JPRB, 0.50315293E-05_JPRB, 0.51649258E-05_JPRB, &
  & 0.52935061E-05_JPRB, 0.54107350E-05_JPRB, 0.55182500E-05_JPRB, 0.56155154E-05_JPRB, 0.57093289E-05_JPRB, 0.57948987E-05_JPRB, &
  & 0.58772875E-05_JPRB, 0.59478616E-05_JPRB, 0.60123198E-05_JPRB, 0.60719271E-05_JPRB, 0.61313131E-05_JPRB, 0.61789951E-05_JPRB, &
  & 0.62183308E-05_JPRB, 0.62521513E-05_JPRB, 0.62842905E-05_JPRB, 0.63232706E-05_JPRB, 0.63757675E-05_JPRB, 0.64129740E-05_JPRB, &
  & 0.64383248E-05_JPRB, 0.64597757E-05_JPRB, 0.64711535E-05_JPRB, 0.64761575E-05_JPRB, 0.64730034E-05_JPRB, 0.64664514E-05_JPRB, &
  & 0.64567453E-05_JPRB, 0.64575661E-05_JPRB, 0.64780556E-05_JPRB, 0.64794363E-05_JPRB, 0.64711789E-05_JPRB, 0.64609312E-05_JPRB, &
  & 0.64501783E-05_JPRB, 0.64398623E-05_JPRB, 0.64308879E-05_JPRB, 0.64245514E-05_JPRB, 0.64241135E-05_JPRB, 0.64334426E-05_JPRB, &
  & 0.64195851E-05_JPRB, 0.63856583E-05_JPRB, 0.63341013E-05_JPRB, 0.62681133E-05_JPRB, 0.61936885E-05_JPRB, 0.61150640E-05_JPRB, &
  & 0.60374541E-05_JPRB, 0.59370923E-05_JPRB, 0.58098749E-05_JPRB, 0.56514632E-05_JPRB, 0.54561974E-05_JPRB, 0.52166956E-05_JPRB, &
  & 0.49510882E-05_JPRB, 0.46989103E-05_JPRB, 0.44896419E-05_JPRB, 0.43205141E-05_JPRB, 0.41834278E-05_JPRB, 0.40871864E-05_JPRB, &
  & 0.39936699E-05_JPRB, 0.39084653E-05_JPRB, 0.38199755E-05_JPRB, 0.37441787E-05_JPRB /)

RGHG7(:,14,10) = (/ &
  & 0.47941944E-05_JPRB, 0.48922266E-05_JPRB, 0.50101489E-05_JPRB, 0.51529078E-05_JPRB, 0.53167623E-05_JPRB, 0.55055830E-05_JPRB, &
  & 0.56932331E-05_JPRB, 0.58654505E-05_JPRB, 0.60219872E-05_JPRB, 0.61642727E-05_JPRB, 0.63007469E-05_JPRB, 0.64266164E-05_JPRB, &
  & 0.65475829E-05_JPRB, 0.66556690E-05_JPRB, 0.67561127E-05_JPRB, 0.68524751E-05_JPRB, 0.69465268E-05_JPRB, 0.70275569E-05_JPRB, &
  & 0.70992814E-05_JPRB, 0.71634449E-05_JPRB, 0.72192456E-05_JPRB, 0.72717112E-05_JPRB, 0.73254482E-05_JPRB, 0.73536448E-05_JPRB, &
  & 0.73615724E-05_JPRB, 0.73581750E-05_JPRB, 0.73479705E-05_JPRB, 0.73361589E-05_JPRB, 0.73201495E-05_JPRB, 0.73054757E-05_JPRB, &
  & 0.72890280E-05_JPRB, 0.72804683E-05_JPRB, 0.72913513E-05_JPRB, 0.72869175E-05_JPRB, 0.72743483E-05_JPRB, 0.72593480E-05_JPRB, &
  & 0.72414659E-05_JPRB, 0.72195671E-05_JPRB, 0.71932918E-05_JPRB, 0.71634199E-05_JPRB, 0.71317472E-05_JPRB, 0.71001909E-05_JPRB, &
  & 0.70386031E-05_JPRB, 0.69505099E-05_JPRB, 0.68398954E-05_JPRB, 0.67122278E-05_JPRB, 0.65744839E-05_JPRB, 0.64321412E-05_JPRB, &
  & 0.62895633E-05_JPRB, 0.61281353E-05_JPRB, 0.59446302E-05_JPRB, 0.57391903E-05_JPRB, 0.55136570E-05_JPRB, 0.52685537E-05_JPRB, &
  & 0.50125400E-05_JPRB, 0.47503263E-05_JPRB, 0.44944127E-05_JPRB, 0.42813649E-05_JPRB, 0.41554681E-05_JPRB, 0.40868117E-05_JPRB, &
  & 0.40410214E-05_JPRB, 0.40223085E-05_JPRB, 0.40300547E-05_JPRB, 0.40070740E-05_JPRB /)

RGHG7(:,15,10) = (/ &
  & 0.49045066E-05_JPRB, 0.50429539E-05_JPRB, 0.51661018E-05_JPRB, 0.53091421E-05_JPRB, 0.54862494E-05_JPRB, 0.56961480E-05_JPRB, &
  & 0.59101035E-05_JPRB, 0.61150995E-05_JPRB, 0.63102339E-05_JPRB, 0.64934452E-05_JPRB, 0.66705093E-05_JPRB, 0.68365985E-05_JPRB, &
  & 0.69957923E-05_JPRB, 0.71417644E-05_JPRB, 0.72784496E-05_JPRB, 0.74094301E-05_JPRB, 0.75367129E-05_JPRB, 0.76495708E-05_JPRB, &
  & 0.77497198E-05_JPRB, 0.78421499E-05_JPRB, 0.79258507E-05_JPRB, 0.79995752E-05_JPRB, 0.80667560E-05_JPRB, 0.81033804E-05_JPRB, &
  & 0.81136632E-05_JPRB, 0.81061835E-05_JPRB, 0.80824238E-05_JPRB, 0.80485988E-05_JPRB, 0.80157242E-05_JPRB, 0.79879746E-05_JPRB, &
  & 0.79656047E-05_JPRB, 0.79582678E-05_JPRB, 0.79699967E-05_JPRB, 0.79659067E-05_JPRB, 0.79535730E-05_JPRB, 0.79359170E-05_JPRB, &
  & 0.79104602E-05_JPRB, 0.78747635E-05_JPRB, 0.78272069E-05_JPRB, 0.77680506E-05_JPRB, 0.76987853E-05_JPRB, 0.76212305E-05_JPRB, &
  & 0.75106727E-05_JPRB, 0.73717124E-05_JPRB, 0.72111557E-05_JPRB, 0.70361166E-05_JPRB, 0.68539271E-05_JPRB, 0.66704024E-05_JPRB, &
  & 0.64875130E-05_JPRB, 0.62929371E-05_JPRB, 0.60864463E-05_JPRB, 0.58708579E-05_JPRB, 0.56480976E-05_JPRB, 0.54170205E-05_JPRB, &
  & 0.51815173E-05_JPRB, 0.49498617E-05_JPRB, 0.47287258E-05_JPRB, 0.45475281E-05_JPRB, 0.44382396E-05_JPRB, 0.43690989E-05_JPRB, &
  & 0.43171631E-05_JPRB, 0.42708766E-05_JPRB, 0.42041138E-05_JPRB, 0.41243502E-05_JPRB /)

RGHG7(:,16,10) = (/ &
  & 0.49362229E-05_JPRB, 0.50368644E-05_JPRB, 0.51545862E-05_JPRB, 0.53005429E-05_JPRB, 0.54799793E-05_JPRB, 0.56971189E-05_JPRB, &
  & 0.59267263E-05_JPRB, 0.61538053E-05_JPRB, 0.63737766E-05_JPRB, 0.65844883E-05_JPRB, 0.67906462E-05_JPRB, 0.69879748E-05_JPRB, &
  & 0.71794811E-05_JPRB, 0.73595920E-05_JPRB, 0.75323442E-05_JPRB, 0.77005943E-05_JPRB, 0.78654739E-05_JPRB, 0.80186073E-05_JPRB, &
  & 0.81575936E-05_JPRB, 0.82824990E-05_JPRB, 0.83965460E-05_JPRB, 0.84971925E-05_JPRB, 0.85838210E-05_JPRB, 0.86352593E-05_JPRB, &
  & 0.86509663E-05_JPRB, 0.86339360E-05_JPRB, 0.85928432E-05_JPRB, 0.85479260E-05_JPRB, 0.85024849E-05_JPRB, 0.84632393E-05_JPRB, &
  & 0.84328940E-05_JPRB, 0.84187441E-05_JPRB, 0.84254989E-05_JPRB, 0.84230051E-05_JPRB, 0.84106132E-05_JPRB, 0.83877158E-05_JPRB, &
  & 0.83535760E-05_JPRB, 0.83057776E-05_JPRB, 0.82416473E-05_JPRB, 0.81598755E-05_JPRB, 0.80601731E-05_JPRB, 0.79439151E-05_JPRB, &
  & 0.77919976E-05_JPRB, 0.76116507E-05_JPRB, 0.74108998E-05_JPRB, 0.71999757E-05_JPRB, 0.69859948E-05_JPRB, 0.67752476E-05_JPRB, &
  & 0.65699687E-05_JPRB, 0.63619573E-05_JPRB, 0.61507071E-05_JPRB, 0.59368608E-05_JPRB, 0.57214534E-05_JPRB, 0.55022933E-05_JPRB, &
  & 0.52822929E-05_JPRB, 0.50655390E-05_JPRB, 0.48620718E-05_JPRB, 0.47015033E-05_JPRB, 0.45992069E-05_JPRB, 0.45308097E-05_JPRB, &
  & 0.44755802E-05_JPRB, 0.44284002E-05_JPRB, 0.43843115E-05_JPRB, 0.43354084E-05_JPRB /)

RGHG7(:,17,10) = (/ &
  & 0.49370842E-05_JPRB, 0.50463404E-05_JPRB, 0.51595721E-05_JPRB, 0.52979908E-05_JPRB, 0.54731604E-05_JPRB, 0.56869926E-05_JPRB, &
  & 0.59170757E-05_JPRB, 0.61509963E-05_JPRB, 0.63850762E-05_JPRB, 0.66163670E-05_JPRB, 0.68470595E-05_JPRB, 0.70717019E-05_JPRB, &
  & 0.72914413E-05_JPRB, 0.75003418E-05_JPRB, 0.77004170E-05_JPRB, 0.78949543E-05_JPRB, 0.80844147E-05_JPRB, 0.82619872E-05_JPRB, &
  & 0.84299318E-05_JPRB, 0.85853899E-05_JPRB, 0.87277549E-05_JPRB, 0.88574316E-05_JPRB, 0.89714968E-05_JPRB, 0.90486228E-05_JPRB, &
  & 0.90865733E-05_JPRB, 0.90874000E-05_JPRB, 0.90595295E-05_JPRB, 0.90105050E-05_JPRB, 0.89504620E-05_JPRB, 0.88999495E-05_JPRB, &
  & 0.88597453E-05_JPRB, 0.88394099E-05_JPRB, 0.88357265E-05_JPRB, 0.88241040E-05_JPRB, 0.88034676E-05_JPRB, 0.87704557E-05_JPRB, &
  & 0.87215158E-05_JPRB, 0.86560431E-05_JPRB, 0.85724514E-05_JPRB, 0.84685462E-05_JPRB, 0.83434034E-05_JPRB, 0.81986818E-05_JPRB, &
  & 0.80196323E-05_JPRB, 0.78139574E-05_JPRB, 0.75911580E-05_JPRB, 0.73613110E-05_JPRB, 0.71334948E-05_JPRB, 0.69121302E-05_JPRB, &
  & 0.66997227E-05_JPRB, 0.64892893E-05_JPRB, 0.62797189E-05_JPRB, 0.60698790E-05_JPRB, 0.58589835E-05_JPRB, 0.56451854E-05_JPRB, &
  & 0.54295565E-05_JPRB, 0.52128876E-05_JPRB, 0.50105323E-05_JPRB, 0.48631655E-05_JPRB, 0.47623698E-05_JPRB, 0.46895125E-05_JPRB, &
  & 0.46297355E-05_JPRB, 0.45776765E-05_JPRB, 0.45364582E-05_JPRB, 0.44639869E-05_JPRB /)

RGHG7(:,18,10) = (/ &
  & 0.49800547E-05_JPRB, 0.50840663E-05_JPRB, 0.51910570E-05_JPRB, 0.53139843E-05_JPRB, 0.54742595E-05_JPRB, 0.56704826E-05_JPRB, &
  & 0.58881810E-05_JPRB, 0.61149221E-05_JPRB, 0.63460511E-05_JPRB, 0.65783324E-05_JPRB, 0.68131071E-05_JPRB, 0.70452411E-05_JPRB, &
  & 0.72745288E-05_JPRB, 0.74953159E-05_JPRB, 0.77079767E-05_JPRB, 0.79134188E-05_JPRB, 0.81141961E-05_JPRB, 0.83027735E-05_JPRB, &
  & 0.84808144E-05_JPRB, 0.86516829E-05_JPRB, 0.88133047E-05_JPRB, 0.89657469E-05_JPRB, 0.91080519E-05_JPRB, 0.92198443E-05_JPRB, &
  & 0.92967375E-05_JPRB, 0.93400231E-05_JPRB, 0.93523850E-05_JPRB, 0.93367125E-05_JPRB, 0.93052604E-05_JPRB, 0.92605260E-05_JPRB, &
  & 0.92121954E-05_JPRB, 0.91719130E-05_JPRB, 0.91457196E-05_JPRB, 0.91085421E-05_JPRB, 0.90622707E-05_JPRB, 0.90026069E-05_JPRB, &
  & 0.89260129E-05_JPRB, 0.88333172E-05_JPRB, 0.87248445E-05_JPRB, 0.85984320E-05_JPRB, 0.84540407E-05_JPRB, 0.82932065E-05_JPRB, &
  & 0.81043609E-05_JPRB, 0.78937319E-05_JPRB, 0.76698825E-05_JPRB, 0.74422042E-05_JPRB, 0.72192211E-05_JPRB, 0.70048281E-05_JPRB, &
  & 0.68003815E-05_JPRB, 0.65999552E-05_JPRB, 0.64006358E-05_JPRB, 0.61991541E-05_JPRB, 0.59925924E-05_JPRB, 0.57782381E-05_JPRB, &
  & 0.55567416E-05_JPRB, 0.53400072E-05_JPRB, 0.51513539E-05_JPRB, 0.50102112E-05_JPRB, 0.49089153E-05_JPRB, 0.48323059E-05_JPRB, &
  & 0.47694098E-05_JPRB, 0.47166905E-05_JPRB, 0.46670762E-05_JPRB, 0.46020768E-05_JPRB /)

RGHG7(:,19,10) = (/ &
  & 0.50167332E-05_JPRB, 0.51165102E-05_JPRB, 0.51998495E-05_JPRB, 0.53105391E-05_JPRB, 0.54505135E-05_JPRB, 0.56243816E-05_JPRB, &
  & 0.58207006E-05_JPRB, 0.60292432E-05_JPRB, 0.62460449E-05_JPRB, 0.64681262E-05_JPRB, 0.66947455E-05_JPRB, 0.69206512E-05_JPRB, &
  & 0.71446466E-05_JPRB, 0.73608398E-05_JPRB, 0.75688376E-05_JPRB, 0.77685554E-05_JPRB, 0.79600040E-05_JPRB, 0.81410753E-05_JPRB, &
  & 0.83113291E-05_JPRB, 0.84751537E-05_JPRB, 0.86356558E-05_JPRB, 0.87933004E-05_JPRB, 0.89488258E-05_JPRB, 0.90879366E-05_JPRB, &
  & 0.92064638E-05_JPRB, 0.92991195E-05_JPRB, 0.93615763E-05_JPRB, 0.93939152E-05_JPRB, 0.94006173E-05_JPRB, 0.93846975E-05_JPRB, &
  & 0.93540639E-05_JPRB, 0.93151366E-05_JPRB, 0.92726286E-05_JPRB, 0.92144319E-05_JPRB, 0.91384481E-05_JPRB, 0.90443773E-05_JPRB, &
  & 0.89412606E-05_JPRB, 0.88219986E-05_JPRB, 0.86874516E-05_JPRB, 0.85398942E-05_JPRB, 0.83793584E-05_JPRB, 0.82112556E-05_JPRB, &
  & 0.80232448E-05_JPRB, 0.78219755E-05_JPRB, 0.76130104E-05_JPRB, 0.74032155E-05_JPRB, 0.71995992E-05_JPRB, 0.70051669E-05_JPRB, &
  & 0.68199956E-05_JPRB, 0.66385132E-05_JPRB, 0.64561000E-05_JPRB, 0.62679760E-05_JPRB, 0.60699490E-05_JPRB, 0.58593582E-05_JPRB, &
  & 0.56434201E-05_JPRB, 0.54358511E-05_JPRB, 0.52647792E-05_JPRB, 0.51322754E-05_JPRB, 0.50331751E-05_JPRB, 0.49547425E-05_JPRB, &
  & 0.48887732E-05_JPRB, 0.48348588E-05_JPRB, 0.47826238E-05_JPRB, 0.47162289E-05_JPRB /)

RGHG7(:,20,10) = (/ &
  & 0.49954460E-05_JPRB, 0.50944782E-05_JPRB, 0.51593652E-05_JPRB, 0.52569530E-05_JPRB, 0.53794924E-05_JPRB, 0.55315909E-05_JPRB, &
  & 0.57057600E-05_JPRB, 0.58935962E-05_JPRB, 0.60905204E-05_JPRB, 0.62928616E-05_JPRB, 0.64996138E-05_JPRB, 0.67051819E-05_JPRB, &
  & 0.69077150E-05_JPRB, 0.71019103E-05_JPRB, 0.72866355E-05_JPRB, 0.74618461E-05_JPRB, 0.76280708E-05_JPRB, 0.77820987E-05_JPRB, &
  & 0.79273450E-05_JPRB, 0.80656673E-05_JPRB, 0.82035294E-05_JPRB, 0.83441828E-05_JPRB, 0.84916310E-05_JPRB, 0.86340206E-05_JPRB, &
  & 0.87682456E-05_JPRB, 0.88899969E-05_JPRB, 0.89937694E-05_JPRB, 0.90737112E-05_JPRB, 0.91247666E-05_JPRB, 0.91524844E-05_JPRB, &
  & 0.91585462E-05_JPRB, 0.91456159E-05_JPRB, 0.91133252E-05_JPRB, 0.90595231E-05_JPRB, 0.89800687E-05_JPRB, 0.88763036E-05_JPRB, &
  & 0.87500675E-05_JPRB, 0.86041873E-05_JPRB, 0.84461317E-05_JPRB, 0.82788529E-05_JPRB, 0.81082035E-05_JPRB, 0.79323891E-05_JPRB, &
  & 0.77540026E-05_JPRB, 0.75711623E-05_JPRB, 0.73867836E-05_JPRB, 0.72055518E-05_JPRB, 0.70313058E-05_JPRB, 0.68661575E-05_JPRB, &
  & 0.67083238E-05_JPRB, 0.65519648E-05_JPRB, 0.63917314E-05_JPRB, 0.62225986E-05_JPRB, 0.60401680E-05_JPRB, 0.58465739E-05_JPRB, &
  & 0.56507351E-05_JPRB, 0.54723437E-05_JPRB, 0.53226131E-05_JPRB, 0.52031492E-05_JPRB, 0.51108609E-05_JPRB, 0.50352369E-05_JPRB, &
  & 0.49720693E-05_JPRB, 0.49170098E-05_JPRB, 0.48719826E-05_JPRB, 0.48059906E-05_JPRB /)

RGHG7(:,21,10) = (/ &
  & 0.48679926E-05_JPRB, 0.49400928E-05_JPRB, 0.49993846E-05_JPRB, 0.50811364E-05_JPRB, 0.51937418E-05_JPRB, 0.53318950E-05_JPRB, &
  & 0.54897118E-05_JPRB, 0.56597619E-05_JPRB, 0.58373239E-05_JPRB, 0.60186298E-05_JPRB, 0.62010554E-05_JPRB, 0.63799848E-05_JPRB, &
  & 0.65535114E-05_JPRB, 0.67174051E-05_JPRB, 0.68708705E-05_JPRB, 0.70133729E-05_JPRB, 0.71455547E-05_JPRB, 0.72662588E-05_JPRB, &
  & 0.73776951E-05_JPRB, 0.74840696E-05_JPRB, 0.75875473E-05_JPRB, 0.76947363E-05_JPRB, 0.78081175E-05_JPRB, 0.79252322E-05_JPRB, &
  & 0.80455047E-05_JPRB, 0.81642311E-05_JPRB, 0.82746383E-05_JPRB, 0.83712594E-05_JPRB, 0.84509811E-05_JPRB, 0.85106622E-05_JPRB, &
  & 0.85565889E-05_JPRB, 0.85890033E-05_JPRB, 0.85994243E-05_JPRB, 0.85791762E-05_JPRB, 0.85230604E-05_JPRB, 0.84313679E-05_JPRB, &
  & 0.83089126E-05_JPRB, 0.81602975E-05_JPRB, 0.79909023E-05_JPRB, 0.78131980E-05_JPRB, 0.76343340E-05_JPRB, 0.74650920E-05_JPRB, &
  & 0.72977464E-05_JPRB, 0.71367040E-05_JPRB, 0.69814350E-05_JPRB, 0.68336408E-05_JPRB, 0.66939647E-05_JPRB, 0.65619547E-05_JPRB, &
  & 0.64346509E-05_JPRB, 0.63066100E-05_JPRB, 0.61725791E-05_JPRB, 0.60276839E-05_JPRB, 0.58709370E-05_JPRB, 0.57066004E-05_JPRB, &
  & 0.55462965E-05_JPRB, 0.54045349E-05_JPRB, 0.52845007E-05_JPRB, 0.51867637E-05_JPRB, 0.51090110E-05_JPRB, 0.50447061E-05_JPRB, &
  & 0.49901187E-05_JPRB, 0.49467176E-05_JPRB, 0.49050786E-05_JPRB, 0.48566239E-05_JPRB /)

RGHG7(:,22,10) = (/ &
  & 0.45950578E-05_JPRB, 0.45967554E-05_JPRB, 0.46527866E-05_JPRB, 0.47317217E-05_JPRB, 0.48469574E-05_JPRB, 0.49854070E-05_JPRB, &
  & 0.51411339E-05_JPRB, 0.53061499E-05_JPRB, 0.54751004E-05_JPRB, 0.56430713E-05_JPRB, 0.58076553E-05_JPRB, 0.59643035E-05_JPRB, &
  & 0.61115134E-05_JPRB, 0.62465324E-05_JPRB, 0.63688935E-05_JPRB, 0.64791720E-05_JPRB, 0.65776339E-05_JPRB, 0.66634466E-05_JPRB, &
  & 0.67390051E-05_JPRB, 0.68080344E-05_JPRB, 0.68721256E-05_JPRB, 0.69370940E-05_JPRB, 0.70074498E-05_JPRB, 0.70819196E-05_JPRB, &
  & 0.71610825E-05_JPRB, 0.72461871E-05_JPRB, 0.73335318E-05_JPRB, 0.74205118E-05_JPRB, 0.75047233E-05_JPRB, 0.75846260E-05_JPRB, &
  & 0.76590668E-05_JPRB, 0.77286031E-05_JPRB, 0.77892555E-05_JPRB, 0.78203902E-05_JPRB, 0.78087523E-05_JPRB, 0.77567165E-05_JPRB, &
  & 0.76576107E-05_JPRB, 0.75187381E-05_JPRB, 0.73557071E-05_JPRB, 0.71816203E-05_JPRB, 0.70080077E-05_JPRB, 0.68460713E-05_JPRB, &
  & 0.66996749E-05_JPRB, 0.65634235E-05_JPRB, 0.64374626E-05_JPRB, 0.63244565E-05_JPRB, 0.62228924E-05_JPRB, 0.61264363E-05_JPRB, &
  & 0.60341740E-05_JPRB, 0.59387480E-05_JPRB, 0.58345731E-05_JPRB, 0.57200791E-05_JPRB, 0.55970750E-05_JPRB, 0.54701341E-05_JPRB, &
  & 0.53523663E-05_JPRB, 0.52476962E-05_JPRB, 0.51580591E-05_JPRB, 0.50841109E-05_JPRB, 0.50241670E-05_JPRB, 0.49735036E-05_JPRB, &
  & 0.49315881E-05_JPRB, 0.48978968E-05_JPRB, 0.48728543E-05_JPRB, 0.48492407E-05_JPRB /)

RGHG7(:,23,10) = (/ &
  & 0.41039934E-05_JPRB, 0.40362306E-05_JPRB, 0.40827085E-05_JPRB, 0.41729318E-05_JPRB, 0.43038099E-05_JPRB, 0.44612161E-05_JPRB, &
  & 0.46338500E-05_JPRB, 0.48116508E-05_JPRB, 0.49874302E-05_JPRB, 0.51560851E-05_JPRB, 0.53138206E-05_JPRB, 0.54574912E-05_JPRB, &
  & 0.55863497E-05_JPRB, 0.56992903E-05_JPRB, 0.57971624E-05_JPRB, 0.58814690E-05_JPRB, 0.59526428E-05_JPRB, 0.60111365E-05_JPRB, &
  & 0.60562957E-05_JPRB, 0.60938423E-05_JPRB, 0.61247433E-05_JPRB, 0.61503524E-05_JPRB, 0.61768651E-05_JPRB, 0.62043910E-05_JPRB, &
  & 0.62371878E-05_JPRB, 0.62777722E-05_JPRB, 0.63275061E-05_JPRB, 0.63860216E-05_JPRB, 0.64539086E-05_JPRB, 0.65312192E-05_JPRB, &
  & 0.66181401E-05_JPRB, 0.67129254E-05_JPRB, 0.68042395E-05_JPRB, 0.68791292E-05_JPRB, 0.69117168E-05_JPRB, 0.68986769E-05_JPRB, &
  & 0.68351774E-05_JPRB, 0.67249757E-05_JPRB, 0.65838558E-05_JPRB, 0.64271239E-05_JPRB, 0.62726758E-05_JPRB, 0.61263559E-05_JPRB, &
  & 0.59981612E-05_JPRB, 0.58913797E-05_JPRB, 0.58007699E-05_JPRB, 0.57222633E-05_JPRB, 0.56573276E-05_JPRB, 0.55987148E-05_JPRB, &
  & 0.55413730E-05_JPRB, 0.54791394E-05_JPRB, 0.54085713E-05_JPRB, 0.53273648E-05_JPRB, 0.52404043E-05_JPRB, 0.51536445E-05_JPRB, &
  & 0.50735339E-05_JPRB, 0.50026579E-05_JPRB, 0.49425839E-05_JPRB, 0.48942215E-05_JPRB, 0.48561433E-05_JPRB, 0.48245051E-05_JPRB, &
  & 0.47994117E-05_JPRB, 0.47818457E-05_JPRB, 0.47739190E-05_JPRB, 0.47764602E-05_JPRB /)

RGHG7(:,24,10) = (/ &
  & 0.33951485E-05_JPRB, 0.32512696E-05_JPRB, 0.32899134E-05_JPRB, 0.34068912E-05_JPRB, 0.35707465E-05_JPRB, 0.37660416E-05_JPRB, &
  & 0.39740953E-05_JPRB, 0.41826465E-05_JPRB, 0.43824311E-05_JPRB, 0.45671363E-05_JPRB, 0.47332792E-05_JPRB, 0.48778793E-05_JPRB, &
  & 0.50013668E-05_JPRB, 0.51039642E-05_JPRB, 0.51881698E-05_JPRB, 0.52564319E-05_JPRB, 0.53109015E-05_JPRB, 0.53508875E-05_JPRB, &
  & 0.53776525E-05_JPRB, 0.53923932E-05_JPRB, 0.53968320E-05_JPRB, 0.53930294E-05_JPRB, 0.53839572E-05_JPRB, 0.53729195E-05_JPRB, &
  & 0.53666549E-05_JPRB, 0.53693930E-05_JPRB, 0.53835761E-05_JPRB, 0.54089087E-05_JPRB, 0.54492411E-05_JPRB, 0.55073074E-05_JPRB, &
  & 0.55848709E-05_JPRB, 0.56799850E-05_JPRB, 0.57826455E-05_JPRB, 0.58724804E-05_JPRB, 0.59351605E-05_JPRB, 0.59557333E-05_JPRB, &
  & 0.59232848E-05_JPRB, 0.58480437E-05_JPRB, 0.57401226E-05_JPRB, 0.56150548E-05_JPRB, 0.54888551E-05_JPRB, 0.53724025E-05_JPRB, &
  & 0.52705032E-05_JPRB, 0.51893348E-05_JPRB, 0.51312054E-05_JPRB, 0.50889848E-05_JPRB, 0.50590820E-05_JPRB, 0.50350559E-05_JPRB, &
  & 0.50123031E-05_JPRB, 0.49829368E-05_JPRB, 0.49442956E-05_JPRB, 0.48964835E-05_JPRB, 0.48433762E-05_JPRB, 0.47913500E-05_JPRB, &
  & 0.47427106E-05_JPRB, 0.46999071E-05_JPRB, 0.46643781E-05_JPRB, 0.46374880E-05_JPRB, 0.46187065E-05_JPRB, 0.46055388E-05_JPRB, &
  & 0.45978304E-05_JPRB, 0.45977513E-05_JPRB, 0.46064147E-05_JPRB, 0.46461864E-05_JPRB /)

RGHG7(:,25,10) = (/ &
  & 0.25289112E-05_JPRB, 0.23712519E-05_JPRB, 0.24277163E-05_JPRB, 0.25658878E-05_JPRB, 0.27637223E-05_JPRB, 0.29959190E-05_JPRB, &
  & 0.32416810E-05_JPRB, 0.34838570E-05_JPRB, 0.37125039E-05_JPRB, 0.39200618E-05_JPRB, 0.41027529E-05_JPRB, 0.42577658E-05_JPRB, &
  & 0.43862688E-05_JPRB, 0.44893141E-05_JPRB, 0.45702050E-05_JPRB, 0.46326636E-05_JPRB, 0.46791934E-05_JPRB, 0.47104172E-05_JPRB, &
  & 0.47271487E-05_JPRB, 0.47298745E-05_JPRB, 0.47185117E-05_JPRB, 0.46958526E-05_JPRB, 0.46630093E-05_JPRB, 0.46259115E-05_JPRB, &
  & 0.45895017E-05_JPRB, 0.45592778E-05_JPRB, 0.45401489E-05_JPRB, 0.45385482E-05_JPRB, 0.45552556E-05_JPRB, 0.45914644E-05_JPRB, &
  & 0.46488112E-05_JPRB, 0.47265175E-05_JPRB, 0.48172151E-05_JPRB, 0.49026398E-05_JPRB, 0.49719806E-05_JPRB, 0.50102426E-05_JPRB, &
  & 0.50071490E-05_JPRB, 0.49679525E-05_JPRB, 0.48950528E-05_JPRB, 0.48072461E-05_JPRB, 0.47163089E-05_JPRB, 0.46358487E-05_JPRB, &
  & 0.45678544E-05_JPRB, 0.45163579E-05_JPRB, 0.44862973E-05_JPRB, 0.44738508E-05_JPRB, 0.44746248E-05_JPRB, 0.44799017E-05_JPRB, &
  & 0.44843969E-05_JPRB, 0.44830704E-05_JPRB, 0.44743992E-05_JPRB, 0.44569706E-05_JPRB, 0.44351873E-05_JPRB, 0.44116418E-05_JPRB, &
  & 0.43886448E-05_JPRB, 0.43687805E-05_JPRB, 0.43539994E-05_JPRB, 0.43452110E-05_JPRB, 0.43422801E-05_JPRB, 0.43440164E-05_JPRB, &
  & 0.43509453E-05_JPRB, 0.43646683E-05_JPRB, 0.43927721E-05_JPRB, 0.44612721E-05_JPRB /)

RGHG7(:,26,10) = (/ &
  & 0.16671997E-05_JPRB, 0.15529489E-05_JPRB, 0.16394142E-05_JPRB, 0.18074139E-05_JPRB, 0.20263765E-05_JPRB, 0.22787208E-05_JPRB, &
  & 0.25445274E-05_JPRB, 0.28060115E-05_JPRB, 0.30521931E-05_JPRB, 0.32764308E-05_JPRB, 0.34734903E-05_JPRB, 0.36405204E-05_JPRB, &
  & 0.37781213E-05_JPRB, 0.38875128E-05_JPRB, 0.39719571E-05_JPRB, 0.40355153E-05_JPRB, 0.40809650E-05_JPRB, 0.41098042E-05_JPRB, &
  & 0.41228586E-05_JPRB, 0.41205153E-05_JPRB, 0.41024491E-05_JPRB, 0.40695654E-05_JPRB, 0.40246478E-05_JPRB, 0.39717897E-05_JPRB, &
  & 0.39156284E-05_JPRB, 0.38665830E-05_JPRB, 0.38282292E-05_JPRB, 0.38037306E-05_JPRB, 0.37970558E-05_JPRB, 0.38102521E-05_JPRB, &
  & 0.38433050E-05_JPRB, 0.38946660E-05_JPRB, 0.39603947E-05_JPRB, 0.40279724E-05_JPRB, 0.40846771E-05_JPRB, 0.41259068E-05_JPRB, &
  & 0.41436579E-05_JPRB, 0.41317826E-05_JPRB, 0.40978925E-05_JPRB, 0.40503114E-05_JPRB, 0.39970155E-05_JPRB, 0.39504407E-05_JPRB, &
  & 0.39151450E-05_JPRB, 0.38946182E-05_JPRB, 0.38923140E-05_JPRB, 0.39062779E-05_JPRB, 0.39329002E-05_JPRB, 0.39657002E-05_JPRB, &
  & 0.39975594E-05_JPRB, 0.40215878E-05_JPRB, 0.40352611E-05_JPRB, 0.40405798E-05_JPRB, 0.40405862E-05_JPRB, 0.40374571E-05_JPRB, &
  & 0.40337463E-05_JPRB, 0.40316886E-05_JPRB, 0.40331738E-05_JPRB, 0.40389896E-05_JPRB, 0.40492296E-05_JPRB, 0.40629848E-05_JPRB, &
  & 0.40808636E-05_JPRB, 0.41057856E-05_JPRB, 0.41452913E-05_JPRB, 0.42358060E-05_JPRB /)

RGHG7(:,27,10) = (/ &
  & 0.95056231E-06_JPRB, 0.94248423E-06_JPRB, 0.10625959E-05_JPRB, 0.12371646E-05_JPRB, 0.14560907E-05_JPRB, 0.17031380E-05_JPRB, &
  & 0.19613319E-05_JPRB, 0.22179447E-05_JPRB, 0.24632677E-05_JPRB, 0.26891814E-05_JPRB, 0.28914781E-05_JPRB, 0.30652939E-05_JPRB, &
  & 0.32102364E-05_JPRB, 0.33265846E-05_JPRB, 0.34169491E-05_JPRB, 0.34843404E-05_JPRB, 0.35324144E-05_JPRB, 0.35608136E-05_JPRB, &
  & 0.35743110E-05_JPRB, 0.35699281E-05_JPRB, 0.35506773E-05_JPRB, 0.35141159E-05_JPRB, 0.34647749E-05_JPRB, 0.34054340E-05_JPRB, &
  & 0.33421261E-05_JPRB, 0.32822290E-05_JPRB, 0.32308055E-05_JPRB, 0.31928753E-05_JPRB, 0.31690222E-05_JPRB, 0.31606633E-05_JPRB, &
  & 0.31688605E-05_JPRB, 0.31924681E-05_JPRB, 0.32289818E-05_JPRB, 0.32715884E-05_JPRB, 0.33123599E-05_JPRB, 0.33460180E-05_JPRB, &
  & 0.33724621E-05_JPRB, 0.33835929E-05_JPRB, 0.33811978E-05_JPRB, 0.33698636E-05_JPRB, 0.33526314E-05_JPRB, 0.33379124E-05_JPRB, &
  & 0.33315243E-05_JPRB, 0.33375652E-05_JPRB, 0.33592921E-05_JPRB, 0.33958042E-05_JPRB, 0.34422335E-05_JPRB, 0.34921547E-05_JPRB, &
  & 0.35386147E-05_JPRB, 0.35806067E-05_JPRB, 0.36165250E-05_JPRB, 0.36441168E-05_JPRB, 0.36635838E-05_JPRB, 0.36782833E-05_JPRB, &
  & 0.36903234E-05_JPRB, 0.37018467E-05_JPRB, 0.37148427E-05_JPRB, 0.37306295E-05_JPRB, 0.37500179E-05_JPRB, 0.37729542E-05_JPRB, &
  & 0.38002190E-05_JPRB, 0.38349149E-05_JPRB, 0.38821072E-05_JPRB, 0.39878828E-05_JPRB /)

RGHG7(:,28,10) = (/ &
  & 0.51970818E-06_JPRB, 0.58582305E-06_JPRB, 0.70182102E-06_JPRB, 0.86173378E-06_JPRB, 0.10558000E-05_JPRB, 0.12761766E-05_JPRB, &
  & 0.15108950E-05_JPRB, 0.17468419E-05_JPRB, 0.19755196E-05_JPRB, 0.21912831E-05_JPRB, 0.23879350E-05_JPRB, 0.25610045E-05_JPRB, &
  & 0.27078956E-05_JPRB, 0.28276370E-05_JPRB, 0.29224989E-05_JPRB, 0.29924399E-05_JPRB, 0.30420597E-05_JPRB, 0.30719805E-05_JPRB, &
  & 0.30855620E-05_JPRB, 0.30810436E-05_JPRB, 0.30614740E-05_JPRB, 0.30249194E-05_JPRB, 0.29751009E-05_JPRB, 0.29156868E-05_JPRB, &
  & 0.28508568E-05_JPRB, 0.27875365E-05_JPRB, 0.27328674E-05_JPRB, 0.26846440E-05_JPRB, 0.26478424E-05_JPRB, 0.26227187E-05_JPRB, &
  & 0.26098819E-05_JPRB, 0.26088658E-05_JPRB, 0.26188932E-05_JPRB, 0.26372488E-05_JPRB, 0.26605728E-05_JPRB, 0.26862547E-05_JPRB, &
  & 0.27145559E-05_JPRB, 0.27398712E-05_JPRB, 0.27606256E-05_JPRB, 0.27772264E-05_JPRB, 0.27900703E-05_JPRB, 0.28032953E-05_JPRB, &
  & 0.28223180E-05_JPRB, 0.28510444E-05_JPRB, 0.28924735E-05_JPRB, 0.29469513E-05_JPRB, 0.30094843E-05_JPRB, 0.30753056E-05_JPRB, &
  & 0.31397881E-05_JPRB, 0.31995064E-05_JPRB, 0.32479684E-05_JPRB, 0.32865487E-05_JPRB, 0.33183082E-05_JPRB, 0.33447909E-05_JPRB, &
  & 0.33677545E-05_JPRB, 0.33895099E-05_JPRB, 0.34119098E-05_JPRB, 0.34367044E-05_JPRB, 0.34645502E-05_JPRB, 0.34951972E-05_JPRB, &
  & 0.35290393E-05_JPRB, 0.35667620E-05_JPRB, 0.36188349E-05_JPRB, 0.37284956E-05_JPRB /)

RGHG7(:,29,10) = (/ &
  & 0.33656929E-06_JPRB, 0.40228801E-06_JPRB, 0.50066677E-06_JPRB, 0.63108905E-06_JPRB, 0.79332170E-06_JPRB, 0.98043063E-06_JPRB, &
  & 0.11828366E-05_JPRB, 0.13904692E-05_JPRB, 0.15962199E-05_JPRB, 0.17934045E-05_JPRB, 0.19775430E-05_JPRB, 0.21426101E-05_JPRB, &
  & 0.22855577E-05_JPRB, 0.24039166E-05_JPRB, 0.24981739E-05_JPRB, 0.25673571E-05_JPRB, 0.26160299E-05_JPRB, 0.26455646E-05_JPRB, &
  & 0.26574478E-05_JPRB, 0.26521852E-05_JPRB, 0.26313483E-05_JPRB, 0.25959935E-05_JPRB, 0.25476675E-05_JPRB, 0.24899487E-05_JPRB, &
  & 0.24274386E-05_JPRB, 0.23651990E-05_JPRB, 0.23071955E-05_JPRB, 0.22555982E-05_JPRB, 0.22114903E-05_JPRB, 0.21750575E-05_JPRB, &
  & 0.21466615E-05_JPRB, 0.21268397E-05_JPRB, 0.21159988E-05_JPRB, 0.21144726E-05_JPRB, 0.21222686E-05_JPRB, 0.21391243E-05_JPRB, &
  & 0.21666467E-05_JPRB, 0.22002780E-05_JPRB, 0.22361307E-05_JPRB, 0.22721101E-05_JPRB, 0.23074631E-05_JPRB, 0.23427488E-05_JPRB, &
  & 0.23819052E-05_JPRB, 0.24289604E-05_JPRB, 0.24855665E-05_JPRB, 0.25533498E-05_JPRB, 0.26282341E-05_JPRB, 0.27056985E-05_JPRB, &
  & 0.27813239E-05_JPRB, 0.28485576E-05_JPRB, 0.29062007E-05_JPRB, 0.29557348E-05_JPRB, 0.29980620E-05_JPRB, 0.30342410E-05_JPRB, &
  & 0.30665956E-05_JPRB, 0.30972903E-05_JPRB, 0.31280697E-05_JPRB, 0.31604775E-05_JPRB, 0.31947770E-05_JPRB, 0.32298658E-05_JPRB, &
  & 0.32659659E-05_JPRB, 0.33070371E-05_JPRB, 0.33612509E-05_JPRB, 0.34740847E-05_JPRB /)

RGHG7(:,30,10) = (/ &
  & 0.24695262E-06_JPRB, 0.30767336E-06_JPRB, 0.38530908E-06_JPRB, 0.49125191E-06_JPRB, 0.62293003E-06_JPRB, 0.77800030E-06_JPRB, &
  & 0.95022017E-06_JPRB, 0.11299311E-05_JPRB, 0.13113208E-05_JPRB, 0.14887544E-05_JPRB, 0.16567574E-05_JPRB, 0.18097113E-05_JPRB, &
  & 0.19437334E-05_JPRB, 0.20563705E-05_JPRB, 0.21442572E-05_JPRB, 0.22091961E-05_JPRB, 0.22535376E-05_JPRB, 0.22787387E-05_JPRB, &
  & 0.22867096E-05_JPRB, 0.22785287E-05_JPRB, 0.22561242E-05_JPRB, 0.22204536E-05_JPRB, 0.21740047E-05_JPRB, 0.21190374E-05_JPRB, &
  & 0.20599734E-05_JPRB, 0.20009973E-05_JPRB, 0.19439481E-05_JPRB, 0.18912466E-05_JPRB, 0.18428634E-05_JPRB, 0.17994782E-05_JPRB, &
  & 0.17608623E-05_JPRB, 0.17281260E-05_JPRB, 0.17028253E-05_JPRB, 0.16870878E-05_JPRB, 0.16832546E-05_JPRB, 0.16926118E-05_JPRB, &
  & 0.17173287E-05_JPRB, 0.17540248E-05_JPRB, 0.17990870E-05_JPRB, 0.18472792E-05_JPRB, 0.18979659E-05_JPRB, 0.19491863E-05_JPRB, &
  & 0.20030980E-05_JPRB, 0.20635612E-05_JPRB, 0.21316603E-05_JPRB, 0.22085001E-05_JPRB, 0.22914855E-05_JPRB, 0.23752934E-05_JPRB, &
  & 0.24553842E-05_JPRB, 0.25278000E-05_JPRB, 0.25936306E-05_JPRB, 0.26525772E-05_JPRB, 0.27037922E-05_JPRB, 0.27484821E-05_JPRB, &
  & 0.27886942E-05_JPRB, 0.28265763E-05_JPRB, 0.28634602E-05_JPRB, 0.29007015E-05_JPRB, 0.29384901E-05_JPRB, 0.29768723E-05_JPRB, &
  & 0.30174440E-05_JPRB, 0.30621525E-05_JPRB, 0.31193360E-05_JPRB, 0.32313681E-05_JPRB /)

RGHG7(:,31,10) = (/ &
  & 0.19987432E-06_JPRB, 0.25489635E-06_JPRB, 0.32026605E-06_JPRB, 0.40545760E-06_JPRB, 0.51532345E-06_JPRB, 0.64452291E-06_JPRB, &
  & 0.79094610E-06_JPRB, 0.94588665E-06_JPRB, 0.11047487E-05_JPRB, 0.12620498E-05_JPRB, 0.14128558E-05_JPRB, 0.15514338E-05_JPRB, &
  & 0.16734327E-05_JPRB, 0.17761839E-05_JPRB, 0.18545772E-05_JPRB, 0.19117183E-05_JPRB, 0.19484391E-05_JPRB, 0.19663032E-05_JPRB, &
  & 0.19680172E-05_JPRB, 0.19550969E-05_JPRB, 0.19290956E-05_JPRB, 0.18924281E-05_JPRB, 0.18467930E-05_JPRB, 0.17946094E-05_JPRB, &
  & 0.17389131E-05_JPRB, 0.16832175E-05_JPRB, 0.16288510E-05_JPRB, 0.15771393E-05_JPRB, 0.15279530E-05_JPRB, 0.14811085E-05_JPRB, &
  & 0.14367881E-05_JPRB, 0.13964501E-05_JPRB, 0.13625159E-05_JPRB, 0.13380659E-05_JPRB, 0.13266828E-05_JPRB, 0.13307774E-05_JPRB, &
  & 0.13523660E-05_JPRB, 0.13891464E-05_JPRB, 0.14383463E-05_JPRB, 0.14932698E-05_JPRB, 0.15531307E-05_JPRB, 0.16149467E-05_JPRB, &
  & 0.16790209E-05_JPRB, 0.17486100E-05_JPRB, 0.18250146E-05_JPRB, 0.19081569E-05_JPRB, 0.19966492E-05_JPRB, 0.20859343E-05_JPRB, &
  & 0.21709884E-05_JPRB, 0.22498020E-05_JPRB, 0.23214545E-05_JPRB, 0.23839823E-05_JPRB, 0.24384697E-05_JPRB, 0.24872807E-05_JPRB, &
  & 0.25323784E-05_JPRB, 0.25753657E-05_JPRB, 0.26172847E-05_JPRB, 0.26591345E-05_JPRB, 0.27018295E-05_JPRB, 0.27448900E-05_JPRB, &
  & 0.27882804E-05_JPRB, 0.28342477E-05_JPRB, 0.28894945E-05_JPRB, 0.30027136E-05_JPRB /)

RGHG7(:,32,10) = (/ &
  & 0.17711896E-06_JPRB, 0.22745866E-06_JPRB, 0.28284299E-06_JPRB, 0.35512844E-06_JPRB, 0.44703856E-06_JPRB, 0.55739173E-06_JPRB, &
  & 0.68280281E-06_JPRB, 0.81792501E-06_JPRB, 0.95714950E-06_JPRB, 0.10962140E-05_JPRB, 0.12299322E-05_JPRB, 0.13530472E-05_JPRB, &
  & 0.14613635E-05_JPRB, 0.15511480E-05_JPRB, 0.16184158E-05_JPRB, 0.16653719E-05_JPRB, 0.16922792E-05_JPRB, 0.17010395E-05_JPRB, &
  & 0.16946551E-05_JPRB, 0.16745282E-05_JPRB, 0.16442725E-05_JPRB, 0.16053821E-05_JPRB, 0.15593612E-05_JPRB, 0.15091033E-05_JPRB, &
  & 0.14566177E-05_JPRB, 0.14047072E-05_JPRB, 0.13539581E-05_JPRB, 0.13043905E-05_JPRB, 0.12558047E-05_JPRB, 0.12081724E-05_JPRB, &
  & 0.11616536E-05_JPRB, 0.11181017E-05_JPRB, 0.10802731E-05_JPRB, 0.10517998E-05_JPRB, 0.10364428E-05_JPRB, 0.10374374E-05_JPRB, &
  & 0.10563144E-05_JPRB, 0.10918292E-05_JPRB, 0.11415848E-05_JPRB, 0.11994890E-05_JPRB, 0.12637995E-05_JPRB, 0.13316785E-05_JPRB, &
  & 0.14026432E-05_JPRB, 0.14776986E-05_JPRB, 0.15593801E-05_JPRB, 0.16466960E-05_JPRB, 0.17370116E-05_JPRB, 0.18272091E-05_JPRB, &
  & 0.19133579E-05_JPRB, 0.19940428E-05_JPRB, 0.20671371E-05_JPRB, 0.21325011E-05_JPRB, 0.21913108E-05_JPRB, 0.22449167E-05_JPRB, &
  & 0.22948782E-05_JPRB, 0.23426032E-05_JPRB, 0.23891816E-05_JPRB, 0.24354865E-05_JPRB, 0.24816070E-05_JPRB, 0.25266440E-05_JPRB, &
  & 0.25713873E-05_JPRB, 0.26183006E-05_JPRB, 0.26777220E-05_JPRB, 0.27899107E-05_JPRB /)

RGHG7(:,33,10) = (/ &
  & 0.16707449E-06_JPRB, 0.21499487E-06_JPRB, 0.26549623E-06_JPRB, 0.32917606E-06_JPRB, 0.40992938E-06_JPRB, 0.50545975E-06_JPRB, &
  & 0.61549906E-06_JPRB, 0.73318728E-06_JPRB, 0.85532326E-06_JPRB, 0.97703060E-06_JPRB, 0.10937690E-05_JPRB, 0.12008828E-05_JPRB, &
  & 0.12942586E-05_JPRB, 0.13697490E-05_JPRB, 0.14249079E-05_JPRB, 0.14603664E-05_JPRB, 0.14764938E-05_JPRB, 0.14760549E-05_JPRB, &
  & 0.14604216E-05_JPRB, 0.14335109E-05_JPRB, 0.13971679E-05_JPRB, 0.13541832E-05_JPRB, 0.13068424E-05_JPRB, 0.12571367E-05_JPRB, &
  & 0.12071573E-05_JPRB, 0.11582695E-05_JPRB, 0.11108374E-05_JPRB, 0.10643828E-05_JPRB, 0.10180581E-05_JPRB, 0.97166844E-06_JPRB, &
  & 0.92587482E-06_JPRB, 0.88250903E-06_JPRB, 0.84464529E-06_JPRB, 0.81563019E-06_JPRB, 0.79926326E-06_JPRB, 0.79889747E-06_JPRB, &
  & 0.81570704E-06_JPRB, 0.84926614E-06_JPRB, 0.89767855E-06_JPRB, 0.95575570E-06_JPRB, 0.10212203E-05_JPRB, 0.10922058E-05_JPRB, &
  & 0.11666926E-05_JPRB, 0.12449515E-05_JPRB, 0.13294920E-05_JPRB, 0.14182613E-05_JPRB, 0.15089427E-05_JPRB, 0.15989885E-05_JPRB, &
  & 0.16851887E-05_JPRB, 0.17655105E-05_JPRB, 0.18386928E-05_JPRB, 0.19053276E-05_JPRB, 0.19661759E-05_JPRB, 0.20228008E-05_JPRB, &
  & 0.20761465E-05_JPRB, 0.21274525E-05_JPRB, 0.21775056E-05_JPRB, 0.22266088E-05_JPRB, 0.22750985E-05_JPRB, 0.23226928E-05_JPRB, &
  & 0.23700084E-05_JPRB, 0.24195458E-05_JPRB, 0.24773274E-05_JPRB, 0.25886977E-05_JPRB /)

RGHG7(:,34,10) = (/ &
  & 0.16600639E-06_JPRB, 0.21349747E-06_JPRB, 0.26143721E-06_JPRB, 0.32042823E-06_JPRB, 0.39347793E-06_JPRB, 0.47972316E-06_JPRB, &
  & 0.57641574E-06_JPRB, 0.68047763E-06_JPRB, 0.78689084E-06_JPRB, 0.89226143E-06_JPRB, 0.99243414E-06_JPRB, 0.10833251E-05_JPRB, &
  & 0.11611587E-05_JPRB, 0.12223616E-05_JPRB, 0.12649157E-05_JPRB, 0.12888862E-05_JPRB, 0.12944388E-05_JPRB, 0.12842688E-05_JPRB, &
  & 0.12600225E-05_JPRB, 0.12253960E-05_JPRB, 0.11826847E-05_JPRB, 0.11349534E-05_JPRB, 0.10850176E-05_JPRB, 0.10348112E-05_JPRB, &
  & 0.98599560E-06_JPRB, 0.93957914E-06_JPRB, 0.89505806E-06_JPRB, 0.85164589E-06_JPRB, 0.80840084E-06_JPRB, 0.76501561E-06_JPRB, &
  & 0.72216386E-06_JPRB, 0.68174882E-06_JPRB, 0.64659213E-06_JPRB, 0.61973907E-06_JPRB, 0.60455204E-06_JPRB, 0.60415050E-06_JPRB, &
  & 0.61934861E-06_JPRB, 0.65071566E-06_JPRB, 0.69661752E-06_JPRB, 0.75283344E-06_JPRB, 0.81778728E-06_JPRB, 0.88937401E-06_JPRB, &
  & 0.96480539E-06_JPRB, 0.10449620E-05_JPRB, 0.11304228E-05_JPRB, 0.12187961E-05_JPRB, 0.13083603E-05_JPRB, 0.13964494E-05_JPRB, &
  & 0.14803184E-05_JPRB, 0.15594746E-05_JPRB, 0.16327155E-05_JPRB, 0.16996192E-05_JPRB, 0.17615698E-05_JPRB, 0.18193899E-05_JPRB, &
  & 0.18744272E-05_JPRB, 0.19277627E-05_JPRB, 0.19800721E-05_JPRB, 0.20318007E-05_JPRB, 0.20832188E-05_JPRB, 0.21332391E-05_JPRB, &
  & 0.21818926E-05_JPRB, 0.22307206E-05_JPRB, 0.22889624E-05_JPRB, 0.24003255E-05_JPRB /)

RGHG7(:,35,10) = (/ &
  & 0.17180113E-06_JPRB, 0.22034845E-06_JPRB, 0.26797707E-06_JPRB, 0.32484803E-06_JPRB, 0.39274741E-06_JPRB, 0.47111996E-06_JPRB, &
  & 0.55834141E-06_JPRB, 0.64954361E-06_JPRB, 0.74213074E-06_JPRB, 0.83231333E-06_JPRB, 0.91653288E-06_JPRB, 0.99160115E-06_JPRB, &
  & 0.10541482E-05_JPRB, 0.11014939E-05_JPRB, 0.11318433E-05_JPRB, 0.11447817E-05_JPRB, 0.11404171E-05_JPRB, 0.11211745E-05_JPRB, &
  & 0.10885122E-05_JPRB, 0.10462400E-05_JPRB, 0.99717658E-06_JPRB, 0.94435302E-06_JPRB, 0.89066566E-06_JPRB, 0.83848846E-06_JPRB, &
  & 0.78953661E-06_JPRB, 0.74433854E-06_JPRB, 0.70237394E-06_JPRB, 0.66229308E-06_JPRB, 0.62308851E-06_JPRB, 0.58417760E-06_JPRB, &
  & 0.54617630E-06_JPRB, 0.51068605E-06_JPRB, 0.48033093E-06_JPRB, 0.45739162E-06_JPRB, 0.44493345E-06_JPRB, 0.44522767E-06_JPRB, &
  & 0.45907652E-06_JPRB, 0.48792452E-06_JPRB, 0.53019915E-06_JPRB, 0.58339629E-06_JPRB, 0.64653165E-06_JPRB, 0.71665511E-06_JPRB, &
  & 0.79203124E-06_JPRB, 0.87278829E-06_JPRB, 0.95781866E-06_JPRB, 0.10447457E-05_JPRB, 0.11320491E-05_JPRB, 0.12172311E-05_JPRB, &
  & 0.12985299E-05_JPRB, 0.13750696E-05_JPRB, 0.14469620E-05_JPRB, 0.15130644E-05_JPRB, 0.15747090E-05_JPRB, 0.16329843E-05_JPRB, &
  & 0.16889945E-05_JPRB, 0.17434843E-05_JPRB, 0.17974377E-05_JPRB, 0.18511644E-05_JPRB, 0.19039494E-05_JPRB, 0.19548311E-05_JPRB, &
  & 0.20039722E-05_JPRB, 0.20540463E-05_JPRB, 0.21129420E-05_JPRB, 0.22211191E-05_JPRB /)

RGHG7(:,36,10) = (/ &
  & 0.18445223E-06_JPRB, 0.23674750E-06_JPRB, 0.28463720E-06_JPRB, 0.33891166E-06_JPRB, 0.40290422E-06_JPRB, 0.47500609E-06_JPRB, &
  & 0.55287092E-06_JPRB, 0.63348494E-06_JPRB, 0.71299309E-06_JPRB, 0.78885614E-06_JPRB, 0.85819499E-06_JPRB, 0.91834858E-06_JPRB, &
  & 0.96662234E-06_JPRB, 0.10011287E-05_JPRB, 0.10203064E-05_JPRB, 0.10229419E-05_JPRB, 0.10105375E-05_JPRB, 0.98238525E-06_JPRB, &
  & 0.94294472E-06_JPRB, 0.89323737E-06_JPRB, 0.83722460E-06_JPRB, 0.77829048E-06_JPRB, 0.72005969E-06_JPRB, 0.66504123E-06_JPRB, &
  & 0.61537008E-06_JPRB, 0.57151289E-06_JPRB, 0.53219634E-06_JPRB, 0.49603511E-06_JPRB, 0.46161944E-06_JPRB, 0.42833187E-06_JPRB, &
  & 0.39643641E-06_JPRB, 0.36747190E-06_JPRB, 0.34316321E-06_JPRB, 0.32533430E-06_JPRB, 0.31637387E-06_JPRB, 0.31753811E-06_JPRB, &
  & 0.33001254E-06_JPRB, 0.35543766E-06_JPRB, 0.39289137E-06_JPRB, 0.44188366E-06_JPRB, 0.50132888E-06_JPRB, 0.56897284E-06_JPRB, &
  & 0.64347176E-06_JPRB, 0.72389150E-06_JPRB, 0.80773816E-06_JPRB, 0.89246026E-06_JPRB, 0.97670420E-06_JPRB, 0.10587124E-05_JPRB, &
  & 0.11370149E-05_JPRB, 0.12108698E-05_JPRB, 0.12811141E-05_JPRB, 0.13460334E-05_JPRB, 0.14066467E-05_JPRB, 0.14641213E-05_JPRB, &
  & 0.15198183E-05_JPRB, 0.15742190E-05_JPRB, 0.16282715E-05_JPRB, 0.16824187E-05_JPRB, 0.17358049E-05_JPRB, 0.17876587E-05_JPRB, &
  & 0.18378689E-05_JPRB, 0.18880603E-05_JPRB, 0.19450094E-05_JPRB, 0.20532602E-05_JPRB /)

RGHG7(:,37,10) = (/ &
  & 0.20543720E-06_JPRB, 0.26165546E-06_JPRB, 0.30992126E-06_JPRB, 0.36188487E-06_JPRB, 0.42164748E-06_JPRB, 0.48762701E-06_JPRB, &
  & 0.55725275E-06_JPRB, 0.62669773E-06_JPRB, 0.69387880E-06_JPRB, 0.75636427E-06_JPRB, 0.81167161E-06_JPRB, 0.85801906E-06_JPRB, &
  & 0.89333304E-06_JPRB, 0.91620501E-06_JPRB, 0.92554234E-06_JPRB, 0.91965160E-06_JPRB, 0.89934122E-06_JPRB, 0.86582099E-06_JPRB, &
  & 0.81917443E-06_JPRB, 0.76323556E-06_JPRB, 0.70069348E-06_JPRB, 0.63599271E-06_JPRB, 0.57362740E-06_JPRB, 0.51738533E-06_JPRB, &
  & 0.46881760E-06_JPRB, 0.42768005E-06_JPRB, 0.39236318E-06_JPRB, 0.36093030E-06_JPRB, 0.33196670E-06_JPRB, 0.30488070E-06_JPRB, &
  & 0.27989512E-06_JPRB, 0.25779008E-06_JPRB, 0.23989443E-06_JPRB, 0.22730278E-06_JPRB, 0.22166986E-06_JPRB, 0.22338683E-06_JPRB, &
  & 0.23394477E-06_JPRB, 0.25453488E-06_JPRB, 0.28546134E-06_JPRB, 0.32754633E-06_JPRB, 0.38061165E-06_JPRB, 0.44360493E-06_JPRB, &
  & 0.51557373E-06_JPRB, 0.59433086E-06_JPRB, 0.67611728E-06_JPRB, 0.75862488E-06_JPRB, 0.84002528E-06_JPRB, 0.91855037E-06_JPRB, &
  & 0.99394447E-06_JPRB, 0.10654828E-05_JPRB, 0.11333661E-05_JPRB, 0.11968579E-05_JPRB, 0.12557769E-05_JPRB, 0.13118151E-05_JPRB, &
  & 0.13659721E-05_JPRB, 0.14189899E-05_JPRB, 0.14717607E-05_JPRB, 0.15252971E-05_JPRB, 0.15785764E-05_JPRB, 0.16305219E-05_JPRB, &
  & 0.16805217E-05_JPRB, 0.17301782E-05_JPRB, 0.17882719E-05_JPRB, 0.18933304E-05_JPRB /)

RGHG7(:,38,10) = (/ &
  & 0.23657172E-06_JPRB, 0.29587991E-06_JPRB, 0.34194952E-06_JPRB, 0.39106209E-06_JPRB, 0.44599429E-06_JPRB, 0.50559458E-06_JPRB, &
  & 0.56628096E-06_JPRB, 0.62552698E-06_JPRB, 0.68073814E-06_JPRB, 0.73025387E-06_JPRB, 0.77258784E-06_JPRB, 0.80625875E-06_JPRB, &
  & 0.83013589E-06_JPRB, 0.84306305E-06_JPRB, 0.84359527E-06_JPRB, 0.83146034E-06_JPRB, 0.80439980E-06_JPRB, 0.76509440E-06_JPRB, &
  & 0.71446567E-06_JPRB, 0.65420090E-06_JPRB, 0.58768626E-06_JPRB, 0.52043038E-06_JPRB, 0.45802165E-06_JPRB, 0.40403174E-06_JPRB, &
  & 0.35966278E-06_JPRB, 0.32356658E-06_JPRB, 0.29349857E-06_JPRB, 0.26743459E-06_JPRB, 0.24410383E-06_JPRB, 0.22289949E-06_JPRB, &
  & 0.20380587E-06_JPRB, 0.18749456E-06_JPRB, 0.17459941E-06_JPRB, 0.16603580E-06_JPRB, 0.16267450E-06_JPRB, 0.16445489E-06_JPRB, &
  & 0.17282647E-06_JPRB, 0.18832820E-06_JPRB, 0.21189194E-06_JPRB, 0.24506258E-06_JPRB, 0.28860237E-06_JPRB, 0.34342372E-06_JPRB, &
  & 0.40933890E-06_JPRB, 0.48338757E-06_JPRB, 0.56191737E-06_JPRB, 0.64128727E-06_JPRB, 0.71930180E-06_JPRB, 0.79460102E-06_JPRB, &
  & 0.86721343E-06_JPRB, 0.93657621E-06_JPRB, 0.10024786E-05_JPRB, 0.10643288E-05_JPRB, 0.11213132E-05_JPRB, 0.11749514E-05_JPRB, &
  & 0.12264419E-05_JPRB, 0.12768977E-05_JPRB, 0.13272573E-05_JPRB, 0.13788911E-05_JPRB, 0.14307850E-05_JPRB, 0.14819079E-05_JPRB, &
  & 0.15315591E-05_JPRB, 0.15814544E-05_JPRB, 0.16377232E-05_JPRB, 0.17427544E-05_JPRB /)

RGHG7(:,39,10) = (/ &
  & 0.27870340E-06_JPRB, 0.33714855E-06_JPRB, 0.38003748E-06_JPRB, 0.42475344E-06_JPRB, 0.47404501E-06_JPRB, 0.52631140E-06_JPRB, &
  & 0.57816897E-06_JPRB, 0.62650503E-06_JPRB, 0.66986860E-06_JPRB, 0.70732972E-06_JPRB, 0.73754074E-06_JPRB, 0.76014226E-06_JPRB, &
  & 0.77416354E-06_JPRB, 0.77888200E-06_JPRB, 0.77256834E-06_JPRB, 0.75444018E-06_JPRB, 0.72449239E-06_JPRB, 0.68115475E-06_JPRB, &
  & 0.62712115E-06_JPRB, 0.56441633E-06_JPRB, 0.49761371E-06_JPRB, 0.43205887E-06_JPRB, 0.37390427E-06_JPRB, 0.32588875E-06_JPRB, &
  & 0.28774849E-06_JPRB, 0.25748358E-06_JPRB, 0.23260434E-06_JPRB, 0.21131568E-06_JPRB, 0.19244999E-06_JPRB, 0.17552432E-06_JPRB, &
  & 0.16054197E-06_JPRB, 0.14791921E-06_JPRB, 0.13817782E-06_JPRB, 0.13204087E-06_JPRB, 0.12991167E-06_JPRB, 0.13159806E-06_JPRB, &
  & 0.13829585E-06_JPRB, 0.14992295E-06_JPRB, 0.16766556E-06_JPRB, 0.19272373E-06_JPRB, 0.22658035E-06_JPRB, 0.27120043E-06_JPRB, &
  & 0.32716019E-06_JPRB, 0.39272231E-06_JPRB, 0.46484971E-06_JPRB, 0.53968893E-06_JPRB, 0.61374027E-06_JPRB, 0.68564577E-06_JPRB, &
  & 0.75535360E-06_JPRB, 0.82263068E-06_JPRB, 0.88673789E-06_JPRB, 0.94639341E-06_JPRB, 0.10013638E-05_JPRB, 0.10521721E-05_JPRB, &
  & 0.11003442E-05_JPRB, 0.11471458E-05_JPRB, 0.11941913E-05_JPRB, 0.12426482E-05_JPRB, 0.12923066E-05_JPRB, 0.13419069E-05_JPRB, &
  & 0.13907020E-05_JPRB, 0.14393690E-05_JPRB, 0.14958605E-05_JPRB, 0.15985545E-05_JPRB /)

RGHG7(:,40,10) = (/ &
  & 0.32838426E-06_JPRB, 0.38250346E-06_JPRB, 0.42079986E-06_JPRB, 0.45987406E-06_JPRB, 0.50245376E-06_JPRB, 0.54695539E-06_JPRB, &
  & 0.58906858E-06_JPRB, 0.62679271E-06_JPRB, 0.65887394E-06_JPRB, 0.68492142E-06_JPRB, 0.70461130E-06_JPRB, 0.71756693E-06_JPRB, &
  & 0.72347575E-06_JPRB, 0.72142586E-06_JPRB, 0.71005826E-06_JPRB, 0.68770015E-06_JPRB, 0.65381124E-06_JPRB, 0.60933502E-06_JPRB, &
  & 0.55442462E-06_JPRB, 0.49228242E-06_JPRB, 0.42753970E-06_JPRB, 0.36714010E-06_JPRB, 0.31556073E-06_JPRB, 0.27429306E-06_JPRB, &
  & 0.24214702E-06_JPRB, 0.21680596E-06_JPRB, 0.19596767E-06_JPRB, 0.17810204E-06_JPRB, 0.16231337E-06_JPRB, 0.14817081E-06_JPRB, &
  & 0.13573197E-06_JPRB, 0.12535313E-06_JPRB, 0.11742690E-06_JPRB, 0.11272066E-06_JPRB, 0.11122641E-06_JPRB, 0.11287338E-06_JPRB, &
  & 0.11848803E-06_JPRB, 0.12768743E-06_JPRB, 0.14153844E-06_JPRB, 0.16084273E-06_JPRB, 0.18708170E-06_JPRB, 0.22237830E-06_JPRB, &
  & 0.26738050E-06_JPRB, 0.32221209E-06_JPRB, 0.38556539E-06_JPRB, 0.45350762E-06_JPRB, 0.52228995E-06_JPRB, 0.59026439E-06_JPRB, &
  & 0.65699356E-06_JPRB, 0.72188567E-06_JPRB, 0.78423295E-06_JPRB, 0.84212627E-06_JPRB, 0.89449867E-06_JPRB, 0.94210719E-06_JPRB, &
  & 0.98631347E-06_JPRB, 0.10291067E-05_JPRB, 0.10720743E-05_JPRB, 0.11168410E-05_JPRB, 0.11633317E-05_JPRB, 0.12105556E-05_JPRB, &
  & 0.12573859E-05_JPRB, 0.13050371E-05_JPRB, 0.13595924E-05_JPRB, 0.14610887E-05_JPRB /)

RGHG7(:,41,10) = (/ &
  & 0.38104298E-06_JPRB, 0.42822288E-06_JPRB, 0.46051559E-06_JPRB, 0.49304498E-06_JPRB, 0.52864721E-06_JPRB, 0.56447055E-06_JPRB, &
  & 0.59699710E-06_JPRB, 0.62401443E-06_JPRB, 0.64539603E-06_JPRB, 0.66137108E-06_JPRB, 0.67181946E-06_JPRB, 0.67693787E-06_JPRB, &
  & 0.67628713E-06_JPRB, 0.66900134E-06_JPRB, 0.65356289E-06_JPRB, 0.62862898E-06_JPRB, 0.59338106E-06_JPRB, 0.54767969E-06_JPRB, &
  & 0.49340866E-06_JPRB, 0.43336883E-06_JPRB, 0.37339947E-06_JPRB, 0.31920504E-06_JPRB, 0.27455621E-06_JPRB, 0.23936559E-06_JPRB, &
  & 0.21195601E-06_JPRB, 0.19019441E-06_JPRB, 0.17224437E-06_JPRB, 0.15677006E-06_JPRB, 0.14305192E-06_JPRB, 0.13076588E-06_JPRB, &
  & 0.11996384E-06_JPRB, 0.11100107E-06_JPRB, 0.10420167E-06_JPRB, 0.10040439E-06_JPRB, 0.99259182E-07_JPRB, 0.10096418E-06_JPRB, &
  & 0.10586864E-06_JPRB, 0.11355043E-06_JPRB, 0.12490317E-06_JPRB, 0.14027802E-06_JPRB, 0.16112986E-06_JPRB, 0.18893270E-06_JPRB, &
  & 0.22450172E-06_JPRB, 0.26918360E-06_JPRB, 0.32246786E-06_JPRB, 0.38153243E-06_JPRB, 0.44427338E-06_JPRB, 0.50746303E-06_JPRB, &
  & 0.57049681E-06_JPRB, 0.63295494E-06_JPRB, 0.69327632E-06_JPRB, 0.74875908E-06_JPRB, 0.79857540E-06_JPRB, 0.84269868E-06_JPRB, &
  & 0.88300175E-06_JPRB, 0.92147548E-06_JPRB, 0.96029635E-06_JPRB, 0.10009129E-05_JPRB, 0.10437573E-05_JPRB, 0.10877853E-05_JPRB, &
  & 0.11321936E-05_JPRB, 0.11771987E-05_JPRB, 0.12298965E-05_JPRB, 0.13278778E-05_JPRB /)

RGHG7(:,42,10) = (/ &
  & 0.43116364E-06_JPRB, 0.47023093E-06_JPRB, 0.49560140E-06_JPRB, 0.52139103E-06_JPRB, 0.54906798E-06_JPRB, 0.57606007E-06_JPRB, &
  & 0.59859286E-06_JPRB, 0.61554306E-06_JPRB, 0.62723478E-06_JPRB, 0.63440666E-06_JPRB, 0.63740850E-06_JPRB, 0.63624429E-06_JPRB, &
  & 0.63060344E-06_JPRB, 0.61940818E-06_JPRB, 0.60109477E-06_JPRB, 0.57417003E-06_JPRB, 0.53795424E-06_JPRB, 0.49295119E-06_JPRB, &
  & 0.44034840E-06_JPRB, 0.38399787E-06_JPRB, 0.32943987E-06_JPRB, 0.28215388E-06_JPRB, 0.24386986E-06_JPRB, 0.21383342E-06_JPRB, &
  & 0.19026784E-06_JPRB, 0.17123145E-06_JPRB, 0.15536583E-06_JPRB, 0.14161320E-06_JPRB, 0.12937636E-06_JPRB, 0.11837802E-06_JPRB, &
  & 0.10871268E-06_JPRB, 0.10071595E-06_JPRB, 0.94687984E-07_JPRB, 0.91536137E-07_JPRB, 0.90617078E-07_JPRB, 0.92437972E-07_JPRB, &
  & 0.96828714E-07_JPRB, 0.10355846E-06_JPRB, 0.11316052E-06_JPRB, 0.12584030E-06_JPRB, 0.14278818E-06_JPRB, 0.16490021E-06_JPRB, &
  & 0.19313453E-06_JPRB, 0.22886033E-06_JPRB, 0.27186798E-06_JPRB, 0.32233157E-06_JPRB, 0.37745932E-06_JPRB, 0.43554320E-06_JPRB, &
  & 0.49465342E-06_JPRB, 0.55396811E-06_JPRB, 0.61170391E-06_JPRB, 0.66477855E-06_JPRB, 0.71134343E-06_JPRB, 0.75191156E-06_JPRB, &
  & 0.78819477E-06_JPRB, 0.82256889E-06_JPRB, 0.85718773E-06_JPRB, 0.89369422E-06_JPRB, 0.93259024E-06_JPRB, 0.97298539E-06_JPRB, &
  & 0.10136949E-05_JPRB, 0.10554909E-05_JPRB, 0.11043541E-05_JPRB, 0.11971630E-05_JPRB /)

RGHG7(:,43,10) = (/ &
  & 0.47439997E-06_JPRB, 0.50377918E-06_JPRB, 0.52265665E-06_JPRB, 0.54139690E-06_JPRB, 0.56108314E-06_JPRB, 0.57868596E-06_JPRB, &
  & 0.59151336E-06_JPRB, 0.59906239E-06_JPRB, 0.60231673E-06_JPRB, 0.60232259E-06_JPRB, 0.59942795E-06_JPRB, 0.59365129E-06_JPRB, &
  & 0.58438013E-06_JPRB, 0.57048595E-06_JPRB, 0.55029972E-06_JPRB, 0.52242626E-06_JPRB, 0.48634189E-06_JPRB, 0.44231308E-06_JPRB, &
  & 0.39240120E-06_JPRB, 0.34056865E-06_JPRB, 0.29261304E-06_JPRB, 0.25203659E-06_JPRB, 0.21964924E-06_JPRB, 0.19396612E-06_JPRB, &
  & 0.17346902E-06_JPRB, 0.15664634E-06_JPRB, 0.14238583E-06_JPRB, 0.12992143E-06_JPRB, 0.11878029E-06_JPRB, 0.10873789E-06_JPRB, &
  & 0.99893647E-07_JPRB, 0.92621114E-07_JPRB, 0.87169106E-07_JPRB, 0.84501259E-07_JPRB, 0.83783938E-07_JPRB, 0.85714937E-07_JPRB, &
  & 0.89743374E-07_JPRB, 0.95818095E-07_JPRB, 0.10415080E-06_JPRB, 0.11488130E-06_JPRB, 0.12889859E-06_JPRB, 0.14668763E-06_JPRB, &
  & 0.16924635E-06_JPRB, 0.19728122E-06_JPRB, 0.23175519E-06_JPRB, 0.27297702E-06_JPRB, 0.32105476E-06_JPRB, 0.37296945E-06_JPRB, &
  & 0.42753217E-06_JPRB, 0.48324796E-06_JPRB, 0.53770970E-06_JPRB, 0.58747736E-06_JPRB, 0.63070695E-06_JPRB, 0.66755780E-06_JPRB, &
  & 0.69988300E-06_JPRB, 0.73035000E-06_JPRB, 0.76097513E-06_JPRB, 0.79347149E-06_JPRB, 0.82826978E-06_JPRB, 0.86452070E-06_JPRB, &
  & 0.90107216E-06_JPRB, 0.93832352E-06_JPRB, 0.98207533E-06_JPRB, 0.10667350E-05_JPRB /)

RGHG7(:,44,10) = (/ &
  & 0.50647162E-06_JPRB, 0.52626513E-06_JPRB, 0.53855399E-06_JPRB, 0.55040596E-06_JPRB, 0.56176918E-06_JPRB, 0.57005940E-06_JPRB, &
  & 0.57356141E-06_JPRB, 0.57271944E-06_JPRB, 0.56896238E-06_JPRB, 0.56341605E-06_JPRB, 0.55628806E-06_JPRB, 0.54733221E-06_JPRB, &
  & 0.53582050E-06_JPRB, 0.52028662E-06_JPRB, 0.49917384E-06_JPRB, 0.47103350E-06_JPRB, 0.43551609E-06_JPRB, 0.39362953E-06_JPRB, &
  & 0.34744781E-06_JPRB, 0.30166288E-06_JPRB, 0.26065152E-06_JPRB, 0.22692669E-06_JPRB, 0.19975639E-06_JPRB, 0.17786095E-06_JPRB, &
  & 0.15988995E-06_JPRB, 0.14483548E-06_JPRB, 0.13185442E-06_JPRB, 0.12039746E-06_JPRB, 0.11008100E-06_JPRB, 0.10077247E-06_JPRB, &
  & 0.92549662E-07_JPRB, 0.85833143E-07_JPRB, 0.80865142E-07_JPRB, 0.78563986E-07_JPRB, 0.78064240E-07_JPRB, 0.80060197E-07_JPRB, &
  & 0.83850075E-07_JPRB, 0.89441372E-07_JPRB, 0.96823058E-07_JPRB, 0.10610862E-06_JPRB, 0.11784261E-06_JPRB, 0.13236337E-06_JPRB, &
  & 0.15037033E-06_JPRB, 0.17233360E-06_JPRB, 0.19905329E-06_JPRB, 0.23228472E-06_JPRB, 0.27208424E-06_JPRB, 0.31810350E-06_JPRB, &
  & 0.36774676E-06_JPRB, 0.41916607E-06_JPRB, 0.46962990E-06_JPRB, 0.51562819E-06_JPRB, 0.55490932E-06_JPRB, 0.58781427E-06_JPRB, &
  & 0.61644852E-06_JPRB, 0.64309251E-06_JPRB, 0.66996148E-06_JPRB, 0.69853121E-06_JPRB, 0.72919829E-06_JPRB, 0.76113719E-06_JPRB, &
  & 0.79289595E-06_JPRB, 0.82495018E-06_JPRB, 0.86263537E-06_JPRB, 0.93598061E-06_JPRB /)

RGHG7(:,45,10) = (/ &
  & 0.52433182E-06_JPRB, 0.53490663E-06_JPRB, 0.54082278E-06_JPRB, 0.54572359E-06_JPRB, 0.54895168E-06_JPRB, 0.54800358E-06_JPRB, &
  & 0.54289745E-06_JPRB, 0.53512133E-06_JPRB, 0.52601649E-06_JPRB, 0.51662113E-06_JPRB, 0.50690682E-06_JPRB, 0.49625214E-06_JPRB, &
  & 0.48357276E-06_JPRB, 0.46765319E-06_JPRB, 0.44642326E-06_JPRB, 0.41878803E-06_JPRB, 0.38484802E-06_JPRB, 0.34576516E-06_JPRB, &
  & 0.30502358E-06_JPRB, 0.26628669E-06_JPRB, 0.23309899E-06_JPRB, 0.20557489E-06_JPRB, 0.18312784E-06_JPRB, 0.16441325E-06_JPRB, &
  & 0.14860098E-06_JPRB, 0.13499945E-06_JPRB, 0.12305686E-06_JPRB, 0.11238014E-06_JPRB, 0.10269970E-06_JPRB, 0.93950000E-07_JPRB, &
  & 0.86217156E-07_JPRB, 0.79954646E-07_JPRB, 0.75396358E-07_JPRB, 0.73386602E-07_JPRB, 0.73117860E-07_JPRB, 0.75136839E-07_JPRB, &
  & 0.78784282E-07_JPRB, 0.83992020E-07_JPRB, 0.90662709E-07_JPRB, 0.98835571E-07_JPRB, 0.10880552E-06_JPRB, 0.12082540E-06_JPRB, &
  & 0.13524119E-06_JPRB, 0.15222631E-06_JPRB, 0.17273754E-06_JPRB, 0.19811588E-06_JPRB, 0.23036959E-06_JPRB, 0.26936829E-06_JPRB, &
  & 0.31364775E-06_JPRB, 0.36048760E-06_JPRB, 0.40655405E-06_JPRB, 0.44796198E-06_JPRB, 0.48303014E-06_JPRB, 0.51194274E-06_JPRB, &
  & 0.53667225E-06_JPRB, 0.55977000E-06_JPRB, 0.58294694E-06_JPRB, 0.60767024E-06_JPRB, 0.63427490E-06_JPRB, 0.66172566E-06_JPRB, &
  & 0.68865472E-06_JPRB, 0.71547328E-06_JPRB, 0.74646238E-06_JPRB, 0.80761197E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART20',0,ZHOOK_HANDLE)



RGHG7(:,46,10) = (/ &
  & 0.52565315E-06_JPRB, 0.52717905E-06_JPRB, 0.52728336E-06_JPRB, 0.52608243E-06_JPRB, 0.52156730E-06_JPRB, 0.51200709E-06_JPRB, &
  & 0.49974449E-06_JPRB, 0.48653141E-06_JPRB, 0.47376668E-06_JPRB, 0.46227575E-06_JPRB, 0.45133763E-06_JPRB, 0.44010972E-06_JPRB, &
  & 0.42759217E-06_JPRB, 0.41185558E-06_JPRB, 0.39155782E-06_JPRB, 0.36530810E-06_JPRB, 0.33360610E-06_JPRB, 0.29933867E-06_JPRB, &
  & 0.26528721E-06_JPRB, 0.23502784E-06_JPRB, 0.20909573E-06_JPRB, 0.18749807E-06_JPRB, 0.16901758E-06_JPRB, 0.15304768E-06_JPRB, &
  & 0.13904506E-06_JPRB, 0.12665926E-06_JPRB, 0.11555397E-06_JPRB, 0.10549562E-06_JPRB, 0.96305925E-07_JPRB, 0.87974904E-07_JPRB, &
  & 0.80657401E-07_JPRB, 0.74752037E-07_JPRB, 0.70571794E-07_JPRB, 0.68798244E-07_JPRB, 0.68761317E-07_JPRB, 0.70777524E-07_JPRB, &
  & 0.74346516E-07_JPRB, 0.79243001E-07_JPRB, 0.85384634E-07_JPRB, 0.92686427E-07_JPRB, 0.10130920E-06_JPRB, 0.11136665E-06_JPRB, &
  & 0.12297332E-06_JPRB, 0.13617122E-06_JPRB, 0.15151052E-06_JPRB, 0.17040773E-06_JPRB, 0.19489681E-06_JPRB, 0.22647157E-06_JPRB, &
  & 0.26472495E-06_JPRB, 0.30637617E-06_JPRB, 0.34746239E-06_JPRB, 0.38438154E-06_JPRB, 0.41462911E-06_JPRB, 0.43945931E-06_JPRB, &
  & 0.46049578E-06_JPRB, 0.48004722E-06_JPRB, 0.49973664E-06_JPRB, 0.52075313E-06_JPRB, 0.54336357E-06_JPRB, 0.56654176E-06_JPRB, &
  & 0.58896097E-06_JPRB, 0.61081641E-06_JPRB, 0.63599447E-06_JPRB, 0.68529556E-06_JPRB /)

RGHG7(:,47,10) = (/ &
  & 0.50882801E-06_JPRB, 0.50212299E-06_JPRB, 0.49700634E-06_JPRB, 0.49018661E-06_JPRB, 0.47864438E-06_JPRB, 0.46228720E-06_JPRB, &
  & 0.44420685E-06_JPRB, 0.42767454E-06_JPRB, 0.41321920E-06_JPRB, 0.40103077E-06_JPRB, 0.39024732E-06_JPRB, 0.37963690E-06_JPRB, &
  & 0.36778323E-06_JPRB, 0.35355788E-06_JPRB, 0.33473438E-06_JPRB, 0.31085290E-06_JPRB, 0.28341154E-06_JPRB, 0.25526197E-06_JPRB, &
  & 0.22985920E-06_JPRB, 0.20769698E-06_JPRB, 0.18882781E-06_JPRB, 0.17207732E-06_JPRB, 0.15706226E-06_JPRB, 0.14334856E-06_JPRB, &
  & 0.13086822E-06_JPRB, 0.11948801E-06_JPRB, 0.10906938E-06_JPRB, 0.99480395E-07_JPRB, 0.90679151E-07_JPRB, 0.82669750E-07_JPRB, &
  & 0.75699795E-07_JPRB, 0.70118908E-07_JPRB, 0.66268548E-07_JPRB, 0.64701311E-07_JPRB, 0.64889946E-07_JPRB, 0.66895105E-07_JPRB, &
  & 0.70416036E-07_JPRB, 0.75070048E-07_JPRB, 0.80814544E-07_JPRB, 0.87437954E-07_JPRB, 0.95029804E-07_JPRB, 0.10357717E-06_JPRB, &
  & 0.11303551E-06_JPRB, 0.12332882E-06_JPRB, 0.13475780E-06_JPRB, 0.14835648E-06_JPRB, 0.16596697E-06_JPRB, 0.18997406E-06_JPRB, &
  & 0.22062146E-06_JPRB, 0.25638786E-06_JPRB, 0.29228329E-06_JPRB, 0.32398222E-06_JPRB, 0.35008193E-06_JPRB, 0.37078360E-06_JPRB, &
  & 0.38835327E-06_JPRB, 0.40467751E-06_JPRB, 0.42105611E-06_JPRB, 0.43870253E-06_JPRB, 0.45761473E-06_JPRB, 0.47695738E-06_JPRB, &
  & 0.49534378E-06_JPRB, 0.51313782E-06_JPRB, 0.53329234E-06_JPRB, 0.57287963E-06_JPRB /)

RGHG7(:,48,10) = (/ &
  & 0.47380377E-06_JPRB, 0.45942247E-06_JPRB, 0.44977412E-06_JPRB, 0.43812574E-06_JPRB, 0.42156589E-06_JPRB, 0.39927826E-06_JPRB, &
  & 0.37815704E-06_JPRB, 0.36013134E-06_JPRB, 0.34560483E-06_JPRB, 0.33434256E-06_JPRB, 0.32471263E-06_JPRB, 0.31548933E-06_JPRB, &
  & 0.30553934E-06_JPRB, 0.29312704E-06_JPRB, 0.27733481E-06_JPRB, 0.25749443E-06_JPRB, 0.23612907E-06_JPRB, 0.21644226E-06_JPRB, &
  & 0.19942324E-06_JPRB, 0.18490215E-06_JPRB, 0.17164898E-06_JPRB, 0.15908333E-06_JPRB, 0.14684255E-06_JPRB, 0.13503083E-06_JPRB, &
  & 0.12380158E-06_JPRB, 0.11323716E-06_JPRB, 0.10335999E-06_JPRB, 0.94143260E-07_JPRB, 0.85640522E-07_JPRB, 0.77902115E-07_JPRB, &
  & 0.71239768E-07_JPRB, 0.65954033E-07_JPRB, 0.62414038E-07_JPRB, 0.61030157E-07_JPRB, 0.61424416E-07_JPRB, 0.63426405E-07_JPRB, &
  & 0.66915888E-07_JPRB, 0.71385763E-07_JPRB, 0.76819973E-07_JPRB, 0.82928608E-07_JPRB, 0.89733533E-07_JPRB, 0.97127440E-07_JPRB, &
  & 0.10498426E-06_JPRB, 0.11313084E-06_JPRB, 0.12170571E-06_JPRB, 0.13134104E-06_JPRB, 0.14357369E-06_JPRB, 0.16020937E-06_JPRB, &
  & 0.18310605E-06_JPRB, 0.21087121E-06_JPRB, 0.24060515E-06_JPRB, 0.26734841E-06_JPRB, 0.28888832E-06_JPRB, 0.30616772E-06_JPRB, &
  & 0.32064196E-06_JPRB, 0.33411573E-06_JPRB, 0.34769732E-06_JPRB, 0.36235949E-06_JPRB, 0.37816105E-06_JPRB, 0.39417108E-06_JPRB, &
  & 0.40933475E-06_JPRB, 0.42379591E-06_JPRB, 0.44019160E-06_JPRB, 0.47237549E-06_JPRB /)

RGHG7(:,49,10) = (/ &
  & 0.42252100E-06_JPRB, 0.40148345E-06_JPRB, 0.38802466E-06_JPRB, 0.37298565E-06_JPRB, 0.35216010E-06_JPRB, 0.32730259E-06_JPRB, &
  & 0.30469175E-06_JPRB, 0.28747849E-06_JPRB, 0.27462880E-06_JPRB, 0.26525859E-06_JPRB, 0.25779224E-06_JPRB, 0.25082090E-06_JPRB, &
  & 0.24328281E-06_JPRB, 0.23431660E-06_JPRB, 0.22261273E-06_JPRB, 0.20925887E-06_JPRB, 0.19591340E-06_JPRB, 0.18448004E-06_JPRB, &
  & 0.17490730E-06_JPRB, 0.16619597E-06_JPRB, 0.15742896E-06_JPRB, 0.14805715E-06_JPRB, 0.13811095E-06_JPRB, 0.12783606E-06_JPRB, &
  & 0.11762055E-06_JPRB, 0.10770020E-06_JPRB, 0.98243554E-07_JPRB, 0.89313893E-07_JPRB, 0.81060428E-07_JPRB, 0.73572409E-07_JPRB, &
  & 0.67185546E-07_JPRB, 0.62197728E-07_JPRB, 0.58945684E-07_JPRB, 0.57733214E-07_JPRB, 0.58299417E-07_JPRB, 0.60331040E-07_JPRB, &
  & 0.63766919E-07_JPRB, 0.68124073E-07_JPRB, 0.73285946E-07_JPRB, 0.79024922E-07_JPRB, 0.85216811E-07_JPRB, 0.91756505E-07_JPRB, &
  & 0.98412414E-07_JPRB, 0.10502777E-06_JPRB, 0.11155640E-06_JPRB, 0.11849670E-06_JPRB, 0.12674545E-06_JPRB, 0.13781214E-06_JPRB, &
  & 0.15288974E-06_JPRB, 0.17248853E-06_JPRB, 0.19398334E-06_JPRB, 0.21465596E-06_JPRB, 0.23182980E-06_JPRB, 0.24573043E-06_JPRB, &
  & 0.25756782E-06_JPRB, 0.26862068E-06_JPRB, 0.27986616E-06_JPRB, 0.29209224E-06_JPRB, 0.30526891E-06_JPRB, 0.31866389E-06_JPRB, &
  & 0.33121830E-06_JPRB, 0.34319831E-06_JPRB, 0.35687771E-06_JPRB, 0.38362367E-06_JPRB /)

RGHG7(:,50,10) = (/ &
  & 0.36077961E-06_JPRB, 0.33560556E-06_JPRB, 0.32007142E-06_JPRB, 0.30323977E-06_JPRB, 0.28110568E-06_JPRB, 0.25567758E-06_JPRB, &
  & 0.23493556E-06_JPRB, 0.22025964E-06_JPRB, 0.21024805E-06_JPRB, 0.20356865E-06_JPRB, 0.19847293E-06_JPRB, 0.19403110E-06_JPRB, &
  & 0.18948803E-06_JPRB, 0.18413786E-06_JPRB, 0.17804570E-06_JPRB, 0.17126396E-06_JPRB, 0.16523011E-06_JPRB, 0.16019197E-06_JPRB, &
  & 0.15578999E-06_JPRB, 0.15114564E-06_JPRB, 0.14558032E-06_JPRB, 0.13868994E-06_JPRB, 0.13056642E-06_JPRB, 0.12154986E-06_JPRB, &
  & 0.11213749E-06_JPRB, 0.10271652E-06_JPRB, 0.93568836E-07_JPRB, 0.84884938E-07_JPRB, 0.76836585E-07_JPRB, 0.69605008E-07_JPRB, &
  & 0.63485018E-07_JPRB, 0.58788011E-07_JPRB, 0.55813814E-07_JPRB, 0.54770076E-07_JPRB, 0.55464763E-07_JPRB, 0.57559610E-07_JPRB, &
  & 0.60899815E-07_JPRB, 0.65214273E-07_JPRB, 0.70121366E-07_JPRB, 0.75587543E-07_JPRB, 0.81316323E-07_JPRB, 0.87230234E-07_JPRB, &
  & 0.93032732E-07_JPRB, 0.98516161E-07_JPRB, 0.10368432E-06_JPRB, 0.10876742E-06_JPRB, 0.11445968E-06_JPRB, 0.12158830E-06_JPRB, &
  & 0.13100123E-06_JPRB, 0.14275312E-06_JPRB, 0.15633617E-06_JPRB, 0.16958896E-06_JPRB, 0.18151442E-06_JPRB, 0.19157682E-06_JPRB, &
  & 0.20059686E-06_JPRB, 0.20919386E-06_JPRB, 0.21813825E-06_JPRB, 0.22813515E-06_JPRB, 0.23899344E-06_JPRB, 0.25011707E-06_JPRB, &
  & 0.26054587E-06_JPRB, 0.27071783E-06_JPRB, 0.28229880E-06_JPRB, 0.30562214E-06_JPRB /)

RGHG7(:,51,10) = (/ &
  & 0.29780244E-06_JPRB, 0.27278514E-06_JPRB, 0.25812270E-06_JPRB, 0.24217096E-06_JPRB, 0.22172630E-06_JPRB, 0.19915768E-06_JPRB, &
  & 0.18212344E-06_JPRB, 0.17120790E-06_JPRB, 0.16430728E-06_JPRB, 0.15985005E-06_JPRB, 0.15676029E-06_JPRB, 0.15422617E-06_JPRB, &
  & 0.15189129E-06_JPRB, 0.14961155E-06_JPRB, 0.14719960E-06_JPRB, 0.14511053E-06_JPRB, 0.14348508E-06_JPRB, 0.14229093E-06_JPRB, &
  & 0.14098769E-06_JPRB, 0.13897798E-06_JPRB, 0.13562511E-06_JPRB, 0.13061560E-06_JPRB, 0.12394430E-06_JPRB, 0.11595539E-06_JPRB, &
  & 0.10718472E-06_JPRB, 0.98155688E-07_JPRB, 0.89243912E-07_JPRB, 0.80775209E-07_JPRB, 0.72937482E-07_JPRB, 0.65948356E-07_JPRB, &
  & 0.60099886E-07_JPRB, 0.55686222E-07_JPRB, 0.52978553E-07_JPRB, 0.52097583E-07_JPRB, 0.52887042E-07_JPRB, 0.55052254E-07_JPRB, &
  & 0.58315699E-07_JPRB, 0.62516371E-07_JPRB, 0.67293023E-07_JPRB, 0.72486053E-07_JPRB, 0.77907274E-07_JPRB, 0.83366274E-07_JPRB, &
  & 0.88534115E-07_JPRB, 0.93259565E-07_JPRB, 0.97426444E-07_JPRB, 0.10134470E-06_JPRB, 0.10538044E-06_JPRB, 0.11003370E-06_JPRB, &
  & 0.11565349E-06_JPRB, 0.12226195E-06_JPRB, 0.12935084E-06_JPRB, 0.13647275E-06_JPRB, 0.14289780E-06_JPRB, 0.14881432E-06_JPRB, &
  & 0.15423032E-06_JPRB, 0.15980703E-06_JPRB, 0.16601277E-06_JPRB, 0.17314827E-06_JPRB, 0.18141949E-06_JPRB, 0.18995941E-06_JPRB, &
  & 0.19837263E-06_JPRB, 0.20661473E-06_JPRB, 0.21669609E-06_JPRB, 0.23706609E-06_JPRB /)

RGHG7(:,52,10) = (/ &
  & 0.23975835E-06_JPRB, 0.22099759E-06_JPRB, 0.20969019E-06_JPRB, 0.19664661E-06_JPRB, 0.17930857E-06_JPRB, 0.16113788E-06_JPRB, &
  & 0.14849384E-06_JPRB, 0.14085605E-06_JPRB, 0.13621529E-06_JPRB, 0.13343930E-06_JPRB, 0.13149797E-06_JPRB, 0.13007836E-06_JPRB, &
  & 0.12897988E-06_JPRB, 0.12809835E-06_JPRB, 0.12764725E-06_JPRB, 0.12770543E-06_JPRB, 0.12823180E-06_JPRB, 0.12894105E-06_JPRB, &
  & 0.12935575E-06_JPRB, 0.12891606E-06_JPRB, 0.12711314E-06_JPRB, 0.12349585E-06_JPRB, 0.11799846E-06_JPRB, 0.11084872E-06_JPRB, &
  & 0.10261993E-06_JPRB, 0.93907246E-07_JPRB, 0.85228898E-07_JPRB, 0.76956660E-07_JPRB, 0.69324265E-07_JPRB, 0.62592406E-07_JPRB, &
  & 0.57007480E-07_JPRB, 0.52869606E-07_JPRB, 0.50409305E-07_JPRB, 0.49685976E-07_JPRB, 0.50541850E-07_JPRB, 0.52744213E-07_JPRB, &
  & 0.55988043E-07_JPRB, 0.60023090E-07_JPRB, 0.64689921E-07_JPRB, 0.69650639E-07_JPRB, 0.74859784E-07_JPRB, 0.79964835E-07_JPRB, &
  & 0.84739455E-07_JPRB, 0.88840338E-07_JPRB, 0.92407326E-07_JPRB, 0.95482314E-07_JPRB, 0.98493196E-07_JPRB, 0.10164459E-06_JPRB, &
  & 0.10503370E-06_JPRB, 0.10858640E-06_JPRB, 0.11212036E-06_JPRB, 0.11536491E-06_JPRB, 0.11832311E-06_JPRB, 0.12094394E-06_JPRB, &
  & 0.12355017E-06_JPRB, 0.12632410E-06_JPRB, 0.12964006E-06_JPRB, 0.13388744E-06_JPRB, 0.13891059E-06_JPRB, 0.14455487E-06_JPRB, &
  & 0.15018337E-06_JPRB, 0.15612007E-06_JPRB, 0.16356461E-06_JPRB, 0.18034004E-06_JPRB /)

RGHG7(:,53,10) = (/ &
  & 0.19917593E-06_JPRB, 0.18500731E-06_JPRB, 0.17548879E-06_JPRB, 0.16470287E-06_JPRB, 0.15061435E-06_JPRB, 0.13666948E-06_JPRB, &
  & 0.12744745E-06_JPRB, 0.12227905E-06_JPRB, 0.11927986E-06_JPRB, 0.11740112E-06_JPRB, 0.11619994E-06_JPRB, 0.11532921E-06_JPRB, &
  & 0.11476943E-06_JPRB, 0.11456352E-06_JPRB, 0.11481870E-06_JPRB, 0.11567852E-06_JPRB, 0.11708993E-06_JPRB, 0.11863593E-06_JPRB, &
  & 0.11990922E-06_JPRB, 0.12043721E-06_JPRB, 0.11965707E-06_JPRB, 0.11709483E-06_JPRB, 0.11250344E-06_JPRB, 0.10607588E-06_JPRB, &
  & 0.98295459E-07_JPRB, 0.89936407E-07_JPRB, 0.81456783E-07_JPRB, 0.73424729E-07_JPRB, 0.65999984E-07_JPRB, 0.59514111E-07_JPRB, &
  & 0.54194565E-07_JPRB, 0.50324680E-07_JPRB, 0.48089394E-07_JPRB, 0.47505292E-07_JPRB, 0.48417100E-07_JPRB, 0.50607120E-07_JPRB, &
  & 0.53819946E-07_JPRB, 0.57759216E-07_JPRB, 0.62212429E-07_JPRB, 0.67079249E-07_JPRB, 0.72038127E-07_JPRB, 0.76962934E-07_JPRB, &
  & 0.81351509E-07_JPRB, 0.85124988E-07_JPRB, 0.88145036E-07_JPRB, 0.90759862E-07_JPRB, 0.93080445E-07_JPRB, 0.95344156E-07_JPRB, &
  & 0.97515596E-07_JPRB, 0.99539598E-07_JPRB, 0.10133579E-06_JPRB, 0.10287577E-06_JPRB, 0.10416122E-06_JPRB, 0.10533923E-06_JPRB, &
  & 0.10645133E-06_JPRB, 0.10775085E-06_JPRB, 0.10940862E-06_JPRB, 0.11154389E-06_JPRB, 0.11432131E-06_JPRB, 0.11737670E-06_JPRB, &
  & 0.12053462E-06_JPRB, 0.12380021E-06_JPRB, 0.12820205E-06_JPRB, 0.13932953E-06_JPRB /)

RGHG7(:,54,10) = (/ &
  & 0.17221902E-06_JPRB, 0.15858728E-06_JPRB, 0.15088388E-06_JPRB, 0.14189088E-06_JPRB, 0.13089678E-06_JPRB, 0.12021182E-06_JPRB, &
  & 0.11379537E-06_JPRB, 0.11019421E-06_JPRB, 0.10815161E-06_JPRB, 0.10694909E-06_JPRB, 0.10611935E-06_JPRB, 0.10558862E-06_JPRB, &
  & 0.10526280E-06_JPRB, 0.10524513E-06_JPRB, 0.10570246E-06_JPRB, 0.10681654E-06_JPRB, 0.10843704E-06_JPRB, 0.11030455E-06_JPRB, &
  & 0.11200665E-06_JPRB, 0.11308147E-06_JPRB, 0.11300616E-06_JPRB, 0.11119619E-06_JPRB, 0.10732457E-06_JPRB, 0.10147090E-06_JPRB, &
  & 0.94184344E-07_JPRB, 0.86116245E-07_JPRB, 0.77976772E-07_JPRB, 0.70120691E-07_JPRB, 0.62945062E-07_JPRB, 0.56701698E-07_JPRB, &
  & 0.51644097E-07_JPRB, 0.48035883E-07_JPRB, 0.46003645E-07_JPRB, 0.45533238E-07_JPRB, 0.46478110E-07_JPRB, 0.48643990E-07_JPRB, &
  & 0.51780308E-07_JPRB, 0.55628732E-07_JPRB, 0.59964826E-07_JPRB, 0.64621688E-07_JPRB, 0.69469024E-07_JPRB, 0.74145142E-07_JPRB, &
  & 0.78332988E-07_JPRB, 0.81758181E-07_JPRB, 0.84507036E-07_JPRB, 0.86737685E-07_JPRB, 0.88690264E-07_JPRB, 0.90435869E-07_JPRB, &
  & 0.91991609E-07_JPRB, 0.93290907E-07_JPRB, 0.94369646E-07_JPRB, 0.95208527E-07_JPRB, 0.95879351E-07_JPRB, 0.96444531E-07_JPRB, &
  & 0.97029002E-07_JPRB, 0.97682261E-07_JPRB, 0.98564058E-07_JPRB, 0.99759909E-07_JPRB, 0.10125007E-06_JPRB, 0.10291648E-06_JPRB, &
  & 0.10451588E-06_JPRB, 0.10604604E-06_JPRB, 0.10791056E-06_JPRB, 0.11243299E-06_JPRB /)

RGHG7(:,55,10) = (/ &
  & 0.14792573E-06_JPRB, 0.13859493E-06_JPRB, 0.13230913E-06_JPRB, 0.12547324E-06_JPRB, 0.11656691E-06_JPRB, 0.10891757E-06_JPRB, &
  & 0.10423466E-06_JPRB, 0.10178068E-06_JPRB, 0.10035381E-06_JPRB, 0.99465097E-07_JPRB, 0.98879077E-07_JPRB, 0.98469918E-07_JPRB, &
  & 0.98263421E-07_JPRB, 0.98284367E-07_JPRB, 0.98726005E-07_JPRB, 0.99739111E-07_JPRB, 0.10137091E-06_JPRB, 0.10329605E-06_JPRB, &
  & 0.10517080E-06_JPRB, 0.10658366E-06_JPRB, 0.10695703E-06_JPRB, 0.10568515E-06_JPRB, 0.10234620E-06_JPRB, 0.97007209E-07_JPRB, &
  & 0.90158821E-07_JPRB, 0.82512436E-07_JPRB, 0.74641811E-07_JPRB, 0.67060611E-07_JPRB, 0.60131505E-07_JPRB, 0.54126890E-07_JPRB, &
  & 0.49340745E-07_JPRB, 0.45980808E-07_JPRB, 0.44129948E-07_JPRB, 0.43741991E-07_JPRB, 0.44696360E-07_JPRB, 0.46819139E-07_JPRB, &
  & 0.49870920E-07_JPRB, 0.53609782E-07_JPRB, 0.57823929E-07_JPRB, 0.62355582E-07_JPRB, 0.67007221E-07_JPRB, 0.71518876E-07_JPRB, &
  & 0.75487634E-07_JPRB, 0.78692892E-07_JPRB, 0.81210658E-07_JPRB, 0.83246888E-07_JPRB, 0.84977110E-07_JPRB, 0.86470969E-07_JPRB, &
  & 0.87731600E-07_JPRB, 0.88750149E-07_JPRB, 0.89521777E-07_JPRB, 0.90114227E-07_JPRB, 0.90542990E-07_JPRB, 0.90923983E-07_JPRB, &
  & 0.91266635E-07_JPRB, 0.91688307E-07_JPRB, 0.92229300E-07_JPRB, 0.92951908E-07_JPRB, 0.93884751E-07_JPRB, 0.94881962E-07_JPRB, &
  & 0.95814549E-07_JPRB, 0.96719681E-07_JPRB, 0.97665847E-07_JPRB, 0.99153084E-07_JPRB /)

RGHG7(:,56,10) = (/ &
  & 0.13303251E-06_JPRB, 0.12382112E-06_JPRB, 0.11866879E-06_JPRB, 0.11284767E-06_JPRB, 0.10622573E-06_JPRB, 0.10031186E-06_JPRB, &
  & 0.97050396E-07_JPRB, 0.95264603E-07_JPRB, 0.94261729E-07_JPRB, 0.93618198E-07_JPRB, 0.93168865E-07_JPRB, 0.92840594E-07_JPRB, &
  & 0.92648605E-07_JPRB, 0.92636917E-07_JPRB, 0.92957670E-07_JPRB, 0.93828838E-07_JPRB, 0.95290417E-07_JPRB, 0.97168140E-07_JPRB, &
  & 0.99120129E-07_JPRB, 0.10070309E-06_JPRB, 0.10136987E-06_JPRB, 0.10045594E-06_JPRB, 0.97533203E-07_JPRB, 0.92638444E-07_JPRB, &
  & 0.86250360E-07_JPRB, 0.78996543E-07_JPRB, 0.71497347E-07_JPRB, 0.64174266E-07_JPRB, 0.57506718E-07_JPRB, 0.51769042E-07_JPRB, &
  & 0.47255437E-07_JPRB, 0.44140162E-07_JPRB, 0.42437250E-07_JPRB, 0.42105508E-07_JPRB, 0.43045635E-07_JPRB, 0.45105949E-07_JPRB, &
  & 0.48061896E-07_JPRB, 0.51692659E-07_JPRB, 0.55802431E-07_JPRB, 0.60182465E-07_JPRB, 0.64711294E-07_JPRB, 0.69016096E-07_JPRB, &
  & 0.72767946E-07_JPRB, 0.75818868E-07_JPRB, 0.78180690E-07_JPRB, 0.80098282E-07_JPRB, 0.81731883E-07_JPRB, 0.83134161E-07_JPRB, &
  & 0.84296190E-07_JPRB, 0.85211902E-07_JPRB, 0.85908781E-07_JPRB, 0.86411013E-07_JPRB, 0.86790756E-07_JPRB, 0.87074007E-07_JPRB, &
  & 0.87368441E-07_JPRB, 0.87669648E-07_JPRB, 0.88073179E-07_JPRB, 0.88607237E-07_JPRB, 0.89250392E-07_JPRB, 0.89936002E-07_JPRB, &
  & 0.90587996E-07_JPRB, 0.91247998E-07_JPRB, 0.92146870E-07_JPRB, 0.94361965E-07_JPRB /)

RGHG7(:,57,10) = (/ &
  & 0.11843807E-06_JPRB, 0.11175351E-06_JPRB, 0.10777213E-06_JPRB, 0.10338810E-06_JPRB, 0.98105012E-07_JPRB, 0.93871563E-07_JPRB, &
  & 0.91398640E-07_JPRB, 0.90076114E-07_JPRB, 0.89284136E-07_JPRB, 0.88750262E-07_JPRB, 0.88377234E-07_JPRB, 0.88072710E-07_JPRB, &
  & 0.87879897E-07_JPRB, 0.87800920E-07_JPRB, 0.87991289E-07_JPRB, 0.88636860E-07_JPRB, 0.89918601E-07_JPRB, 0.91690261E-07_JPRB, &
  & 0.93630277E-07_JPRB, 0.95304138E-07_JPRB, 0.96131124E-07_JPRB, 0.95463875E-07_JPRB, 0.92861811E-07_JPRB, 0.88365326E-07_JPRB, &
  & 0.82428507E-07_JPRB, 0.75584602E-07_JPRB, 0.68426885E-07_JPRB, 0.61450130E-07_JPRB, 0.55049266E-07_JPRB, 0.49596512E-07_JPRB, &
  & 0.45376023E-07_JPRB, 0.42477080E-07_JPRB, 0.40899199E-07_JPRB, 0.40603936E-07_JPRB, 0.41513140E-07_JPRB, 0.43488953E-07_JPRB, &
  & 0.46338180E-07_JPRB, 0.49859608E-07_JPRB, 0.53844747E-07_JPRB, 0.58133033E-07_JPRB, 0.62470455E-07_JPRB, 0.66608401E-07_JPRB, &
  & 0.70209815E-07_JPRB, 0.73063852E-07_JPRB, 0.75357335E-07_JPRB, 0.77212007E-07_JPRB, 0.78817521E-07_JPRB, 0.80219657E-07_JPRB, &
  & 0.81390219E-07_JPRB, 0.82330708E-07_JPRB, 0.83033271E-07_JPRB, 0.83542773E-07_JPRB, 0.83898591E-07_JPRB, 0.84192429E-07_JPRB, &
  & 0.84441510E-07_JPRB, 0.84723759E-07_JPRB, 0.85059952E-07_JPRB, 0.85480359E-07_JPRB, 0.85979451E-07_JPRB, 0.86483432E-07_JPRB, &
  & 0.86934840E-07_JPRB, 0.87368157E-07_JPRB, 0.87826557E-07_JPRB, 0.88916558E-07_JPRB /)

RGHG7(:,58,10) = (/ &
  & 0.10879991E-06_JPRB, 0.10290853E-06_JPRB, 0.99403458E-07_JPRB, 0.95811757E-07_JPRB, 0.91748248E-07_JPRB, 0.88469804E-07_JPRB, &
  & 0.86640696E-07_JPRB, 0.85606153E-07_JPRB, 0.84978254E-07_JPRB, 0.84516515E-07_JPRB, 0.84159488E-07_JPRB, 0.83865778E-07_JPRB, &
  & 0.83627334E-07_JPRB, 0.83483080E-07_JPRB, 0.83530033E-07_JPRB, 0.83979501E-07_JPRB, 0.85047319E-07_JPRB, 0.86695628E-07_JPRB, &
  & 0.88584031E-07_JPRB, 0.90264244E-07_JPRB, 0.91169298E-07_JPRB, 0.90664038E-07_JPRB, 0.88342375E-07_JPRB, 0.84200309E-07_JPRB, &
  & 0.78668300E-07_JPRB, 0.72248341E-07_JPRB, 0.65435870E-07_JPRB, 0.58825435E-07_JPRB, 0.52729579E-07_JPRB, 0.47606413E-07_JPRB, &
  & 0.43664347E-07_JPRB, 0.40967844E-07_JPRB, 0.39501725E-07_JPRB, 0.39234969E-07_JPRB, 0.40094577E-07_JPRB, 0.41969781E-07_JPRB, &
  & 0.44693486E-07_JPRB, 0.48094680E-07_JPRB, 0.51978091E-07_JPRB, 0.56115947E-07_JPRB, 0.60338628E-07_JPRB, 0.64308431E-07_JPRB, &
  & 0.67719107E-07_JPRB, 0.70511192E-07_JPRB, 0.72689261E-07_JPRB, 0.74529417E-07_JPRB, 0.76151444E-07_JPRB, 0.77598614E-07_JPRB, &
  & 0.78855351E-07_JPRB, 0.79865998E-07_JPRB, 0.80640355E-07_JPRB, 0.81177546E-07_JPRB, 0.81573376E-07_JPRB, 0.81860129E-07_JPRB, &
  & 0.82130171E-07_JPRB, 0.82397605E-07_JPRB, 0.82710450E-07_JPRB, 0.83096488E-07_JPRB, 0.83521343E-07_JPRB, 0.83945480E-07_JPRB, &
  & 0.84331226E-07_JPRB, 0.84720632E-07_JPRB, 0.85252736E-07_JPRB, 0.86392291E-07_JPRB /)

RGHG7(:,59,10) = (/ &
  & 0.99749641E-07_JPRB, 0.95157553E-07_JPRB, 0.92667840E-07_JPRB, 0.89769870E-07_JPRB, 0.86648889E-07_JPRB, 0.84080973E-07_JPRB, &
  & 0.82579575E-07_JPRB, 0.81705252E-07_JPRB, 0.81133329E-07_JPRB, 0.80708219E-07_JPRB, 0.80348443E-07_JPRB, 0.80019561E-07_JPRB, &
  & 0.79744083E-07_JPRB, 0.79519182E-07_JPRB, 0.79439431E-07_JPRB, 0.79701806E-07_JPRB, 0.80567020E-07_JPRB, 0.82074479E-07_JPRB, &
  & 0.83883535E-07_JPRB, 0.85521982E-07_JPRB, 0.86440942E-07_JPRB, 0.86047237E-07_JPRB, 0.83955108E-07_JPRB, 0.80156148E-07_JPRB, &
  & 0.74989970E-07_JPRB, 0.68963857E-07_JPRB, 0.62524030E-07_JPRB, 0.56288343E-07_JPRB, 0.50531078E-07_JPRB, 0.45772897E-07_JPRB, &
  & 0.42099003E-07_JPRB, 0.39601478E-07_JPRB, 0.38250601E-07_JPRB, 0.38006792E-07_JPRB, 0.38801055E-07_JPRB, 0.40556682E-07_JPRB, &
  & 0.43149420E-07_JPRB, 0.46424734E-07_JPRB, 0.50171526E-07_JPRB, 0.54204236E-07_JPRB, 0.58271599E-07_JPRB, 0.62094600E-07_JPRB, &
  & 0.65397600E-07_JPRB, 0.68046454E-07_JPRB, 0.70216842E-07_JPRB, 0.72035725E-07_JPRB, 0.73688284E-07_JPRB, 0.75205044E-07_JPRB, &
  & 0.76559353E-07_JPRB, 0.77697550E-07_JPRB, 0.78560888E-07_JPRB, 0.79175756E-07_JPRB, 0.79590215E-07_JPRB, 0.79923737E-07_JPRB, &
  & 0.80198845E-07_JPRB, 0.80485258E-07_JPRB, 0.80803517E-07_JPRB, 0.81167542E-07_JPRB, 0.81561694E-07_JPRB, 0.81926935E-07_JPRB, &
  & 0.82243730E-07_JPRB, 0.82543281E-07_JPRB, 0.82891511E-07_JPRB, 0.83839879E-07_JPRB /)

RGHG7(:,60,10) = (/ &
  & 0.93752490E-07_JPRB, 0.89632117E-07_JPRB, 0.87143412E-07_JPRB, 0.84859622E-07_JPRB, 0.82284103E-07_JPRB, 0.80247240E-07_JPRB, &
  & 0.78975987E-07_JPRB, 0.78202824E-07_JPRB, 0.77657660E-07_JPRB, 0.77220200E-07_JPRB, 0.76835256E-07_JPRB, 0.76462143E-07_JPRB, &
  & 0.76109117E-07_JPRB, 0.75796308E-07_JPRB, 0.75588197E-07_JPRB, 0.75692689E-07_JPRB, 0.76403950E-07_JPRB, 0.77767837E-07_JPRB, &
  & 0.79479442E-07_JPRB, 0.81024041E-07_JPRB, 0.81914294E-07_JPRB, 0.81599268E-07_JPRB, 0.79726021E-07_JPRB, 0.76206469E-07_JPRB, &
  & 0.71409744E-07_JPRB, 0.65754520E-07_JPRB, 0.59706096E-07_JPRB, 0.53839294E-07_JPRB, 0.48486349E-07_JPRB, 0.44067459E-07_JPRB, &
  & 0.40669008E-07_JPRB, 0.38382229E-07_JPRB, 0.37152013E-07_JPRB, 0.36923275E-07_JPRB, 0.37646469E-07_JPRB, 0.39283652E-07_JPRB, &
  & 0.41738861E-07_JPRB, 0.44867022E-07_JPRB, 0.48485536E-07_JPRB, 0.52365003E-07_JPRB, 0.56308110E-07_JPRB, 0.59996253E-07_JPRB, &
  & 0.63165480E-07_JPRB, 0.65775311E-07_JPRB, 0.67886809E-07_JPRB, 0.69720691E-07_JPRB, 0.71397984E-07_JPRB, 0.72991327E-07_JPRB, &
  & 0.74454476E-07_JPRB, 0.75727080E-07_JPRB, 0.76703827E-07_JPRB, 0.77394461E-07_JPRB, 0.77881829E-07_JPRB, 0.78237761E-07_JPRB, &
  & 0.78556830E-07_JPRB, 0.78863891E-07_JPRB, 0.79199019E-07_JPRB, 0.79573375E-07_JPRB, 0.79953779E-07_JPRB, 0.80303501E-07_JPRB, &
  & 0.80607812E-07_JPRB, 0.80898452E-07_JPRB, 0.81273065E-07_JPRB, 0.82072020E-07_JPRB /)

RGHG7(:,61,10) = (/ &
  & 0.87889063E-07_JPRB, 0.84332974E-07_JPRB, 0.82607144E-07_JPRB, 0.80676159E-07_JPRB, 0.78677850E-07_JPRB, 0.76908357E-07_JPRB, &
  & 0.75756908E-07_JPRB, 0.74998631E-07_JPRB, 0.74448018E-07_JPRB, 0.73983330E-07_JPRB, 0.73540015E-07_JPRB, 0.73109852E-07_JPRB, &
  & 0.72667440E-07_JPRB, 0.72225795E-07_JPRB, 0.71902278E-07_JPRB, 0.71883747E-07_JPRB, 0.72480624E-07_JPRB, 0.73730405E-07_JPRB, &
  & 0.75303724E-07_JPRB, 0.76743071E-07_JPRB, 0.77586712E-07_JPRB, 0.77325765E-07_JPRB, 0.75618217E-07_JPRB, 0.72396531E-07_JPRB, &
  & 0.67918499E-07_JPRB, 0.62637540E-07_JPRB, 0.56989649E-07_JPRB, 0.51502408E-07_JPRB, 0.46569856E-07_JPRB, 0.42489614E-07_JPRB, &
  & 0.39379390E-07_JPRB, 0.37315559E-07_JPRB, 0.36206401E-07_JPRB, 0.35996273E-07_JPRB, 0.36656481E-07_JPRB, 0.38182979E-07_JPRB, &
  & 0.40496442E-07_JPRB, 0.43471189E-07_JPRB, 0.46925145E-07_JPRB, 0.50664017E-07_JPRB, 0.54451863E-07_JPRB, 0.58008585E-07_JPRB, &
  & 0.61087889E-07_JPRB, 0.63619545E-07_JPRB, 0.65735058E-07_JPRB, 0.67574973E-07_JPRB, 0.69296625E-07_JPRB, 0.70936053E-07_JPRB, &
  & 0.72496761E-07_JPRB, 0.73876102E-07_JPRB, 0.74999008E-07_JPRB, 0.75783952E-07_JPRB, 0.76335191E-07_JPRB, 0.76759534E-07_JPRB, &
  & 0.77113043E-07_JPRB, 0.77464186E-07_JPRB, 0.77832006E-07_JPRB, 0.78224957E-07_JPRB, 0.78613915E-07_JPRB, 0.78951956E-07_JPRB, &
  & 0.79232301E-07_JPRB, 0.79492168E-07_JPRB, 0.79805382E-07_JPRB, 0.80575433E-07_JPRB /)

RGHG7(:,62,10) = (/ &
  & 0.83419941E-07_JPRB, 0.80422708E-07_JPRB, 0.78675818E-07_JPRB, 0.77152826E-07_JPRB, 0.75433505E-07_JPRB, 0.73925712E-07_JPRB, &
  & 0.72831682E-07_JPRB, 0.72071110E-07_JPRB, 0.71472243E-07_JPRB, 0.70953284E-07_JPRB, 0.70435057E-07_JPRB, 0.69906783E-07_JPRB, &
  & 0.69331463E-07_JPRB, 0.68779919E-07_JPRB, 0.68323573E-07_JPRB, 0.68237149E-07_JPRB, 0.68771065E-07_JPRB, 0.69918535E-07_JPRB, &
  & 0.71352140E-07_JPRB, 0.72676343E-07_JPRB, 0.73443005E-07_JPRB, 0.73215261E-07_JPRB, 0.71668154E-07_JPRB, 0.68685203E-07_JPRB, &
  & 0.64550633E-07_JPRB, 0.59625606E-07_JPRB, 0.54381257E-07_JPRB, 0.49288623E-07_JPRB, 0.44781849E-07_JPRB, 0.41028944E-07_JPRB, &
  & 0.38240554E-07_JPRB, 0.36403780E-07_JPRB, 0.35425341E-07_JPRB, 0.35246590E-07_JPRB, 0.35857582E-07_JPRB, 0.37274489E-07_JPRB, &
  & 0.39447389E-07_JPRB, 0.42255255E-07_JPRB, 0.45538489E-07_JPRB, 0.49108085E-07_JPRB, 0.52739320E-07_JPRB, 0.56160545E-07_JPRB, &
  & 0.59141509E-07_JPRB, 0.61643412E-07_JPRB, 0.63745425E-07_JPRB, 0.65610898E-07_JPRB, 0.67361547E-07_JPRB, 0.69053428E-07_JPRB, &
  & 0.70652021E-07_JPRB, 0.72148474E-07_JPRB, 0.73364781E-07_JPRB, 0.74281679E-07_JPRB, 0.74924849E-07_JPRB, 0.75413823E-07_JPRB, &
  & 0.75831707E-07_JPRB, 0.76235061E-07_JPRB, 0.76648632E-07_JPRB, 0.77079498E-07_JPRB, 0.77483605E-07_JPRB, 0.77829178E-07_JPRB, &
  & 0.78116820E-07_JPRB, 0.78377532E-07_JPRB, 0.78689581E-07_JPRB, 0.79364618E-07_JPRB /)

RGHG7(:,63,10) = (/ &
  & 0.79387355E-07_JPRB, 0.76644831E-07_JPRB, 0.75355111E-07_JPRB, 0.74011119E-07_JPRB, 0.72600322E-07_JPRB, 0.71217180E-07_JPRB, &
  & 0.70146129E-07_JPRB, 0.69331541E-07_JPRB, 0.68667532E-07_JPRB, 0.68065944E-07_JPRB, 0.67452000E-07_JPRB, 0.66792147E-07_JPRB, &
  & 0.66090088E-07_JPRB, 0.65387098E-07_JPRB, 0.64863684E-07_JPRB, 0.64765104E-07_JPRB, 0.65267017E-07_JPRB, 0.66306335E-07_JPRB, &
  & 0.67603388E-07_JPRB, 0.68801683E-07_JPRB, 0.69498533E-07_JPRB, 0.69280162E-07_JPRB, 0.67849257E-07_JPRB, 0.65122187E-07_JPRB, &
  & 0.61296483E-07_JPRB, 0.56738017E-07_JPRB, 0.51891615E-07_JPRB, 0.47216727E-07_JPRB, 0.43118316E-07_JPRB, 0.39733759E-07_JPRB, &
  & 0.37267260E-07_JPRB, 0.35671786E-07_JPRB, 0.34837736E-07_JPRB, 0.34706225E-07_JPRB, 0.35277388E-07_JPRB, 0.36592198E-07_JPRB, &
  & 0.38616598E-07_JPRB, 0.41248970E-07_JPRB, 0.44349136E-07_JPRB, 0.47732641E-07_JPRB, 0.51197944E-07_JPRB, 0.54480378E-07_JPRB, &
  & 0.57366279E-07_JPRB, 0.59820337E-07_JPRB, 0.61928169E-07_JPRB, 0.63818540E-07_JPRB, 0.65606571E-07_JPRB, 0.67330447E-07_JPRB, &
  & 0.68981073E-07_JPRB, 0.70499759E-07_JPRB, 0.71836396E-07_JPRB, 0.72844287E-07_JPRB, 0.73591259E-07_JPRB, 0.74172242E-07_JPRB, &
  & 0.74661259E-07_JPRB, 0.75134579E-07_JPRB, 0.75608526E-07_JPRB, 0.76083730E-07_JPRB, 0.76520038E-07_JPRB, 0.76879751E-07_JPRB, &
  & 0.77169950E-07_JPRB, 0.77430109E-07_JPRB, 0.77730988E-07_JPRB, 0.78380502E-07_JPRB /)

RGHG7(:,64,10) = (/ &
  & 0.76059280E-07_JPRB, 0.73661077E-07_JPRB, 0.72354005E-07_JPRB, 0.71235768E-07_JPRB, 0.69975272E-07_JPRB, 0.68732369E-07_JPRB, &
  & 0.67652216E-07_JPRB, 0.66788644E-07_JPRB, 0.66012348E-07_JPRB, 0.65299439E-07_JPRB, 0.64563565E-07_JPRB, 0.63764858E-07_JPRB, &
  & 0.62914729E-07_JPRB, 0.62127626E-07_JPRB, 0.61604318E-07_JPRB, 0.61522023E-07_JPRB, 0.61984338E-07_JPRB, 0.62920478E-07_JPRB, &
  & 0.64086954E-07_JPRB, 0.65159504E-07_JPRB, 0.65764112E-07_JPRB, 0.65539183E-07_JPRB, 0.64224984E-07_JPRB, 0.61707468E-07_JPRB, &
  & 0.58204847E-07_JPRB, 0.54009334E-07_JPRB, 0.49567429E-07_JPRB, 0.45322484E-07_JPRB, 0.41634252E-07_JPRB, 0.38634692E-07_JPRB, &
  & 0.36502222E-07_JPRB, 0.35155129E-07_JPRB, 0.34478216E-07_JPRB, 0.34406259E-07_JPRB, 0.34948972E-07_JPRB, 0.36164870E-07_JPRB, &
  & 0.38037822E-07_JPRB, 0.40486857E-07_JPRB, 0.43386347E-07_JPRB, 0.46574876E-07_JPRB, 0.49852662E-07_JPRB, 0.52985357E-07_JPRB, &
  & 0.55780408E-07_JPRB, 0.58197262E-07_JPRB, 0.60307507E-07_JPRB, 0.62221332E-07_JPRB, 0.64039440E-07_JPRB, 0.65795135E-07_JPRB, &
  & 0.67455787E-07_JPRB, 0.69012621E-07_JPRB, 0.70374021E-07_JPRB, 0.71485118E-07_JPRB, 0.72337158E-07_JPRB, 0.73004244E-07_JPRB, &
  & 0.73586072E-07_JPRB, 0.74131229E-07_JPRB, 0.74675228E-07_JPRB, 0.75208376E-07_JPRB, 0.75678663E-07_JPRB, 0.76061902E-07_JPRB, &
  & 0.76373524E-07_JPRB, 0.76649258E-07_JPRB, 0.76962642E-07_JPRB, 0.77584012E-07_JPRB /)

RGHG7(:,65,10) = (/ &
  & 0.73083768E-07_JPRB, 0.70776991E-07_JPRB, 0.69687502E-07_JPRB, 0.68646841E-07_JPRB, 0.67550374E-07_JPRB, 0.66381268E-07_JPRB, &
  & 0.65320123E-07_JPRB, 0.64339041E-07_JPRB, 0.63469955E-07_JPRB, 0.62596200E-07_JPRB, 0.61734831E-07_JPRB, 0.60792772E-07_JPRB, &
  & 0.59859538E-07_JPRB, 0.59074516E-07_JPRB, 0.58580508E-07_JPRB, 0.58515784E-07_JPRB, 0.58938568E-07_JPRB, 0.59772539E-07_JPRB, &
  & 0.60814635E-07_JPRB, 0.61760680E-07_JPRB, 0.62274296E-07_JPRB, 0.62034111E-07_JPRB, 0.60804524E-07_JPRB, 0.58515162E-07_JPRB, &
  & 0.55306824E-07_JPRB, 0.51489661E-07_JPRB, 0.47462660E-07_JPRB, 0.43657518E-07_JPRB, 0.40383124E-07_JPRB, 0.37773635E-07_JPRB, &
  & 0.35980012E-07_JPRB, 0.34883449E-07_JPRB, 0.34365815E-07_JPRB, 0.34361136E-07_JPRB, 0.34885637E-07_JPRB, 0.36009219E-07_JPRB, &
  & 0.37736552E-07_JPRB, 0.39997222E-07_JPRB, 0.42684867E-07_JPRB, 0.45656812E-07_JPRB, 0.48738126E-07_JPRB, 0.51715368E-07_JPRB, &
  & 0.54409888E-07_JPRB, 0.56786437E-07_JPRB, 0.58891828E-07_JPRB, 0.60828356E-07_JPRB, 0.62666821E-07_JPRB, 0.64445722E-07_JPRB, &
  & 0.66122588E-07_JPRB, 0.67680666E-07_JPRB, 0.69064036E-07_JPRB, 0.70224594E-07_JPRB, 0.71142928E-07_JPRB, 0.71913000E-07_JPRB, &
  & 0.72567445E-07_JPRB, 0.73197121E-07_JPRB, 0.73815087E-07_JPRB, 0.74400496E-07_JPRB, 0.74910666E-07_JPRB, 0.75323698E-07_JPRB, &
  & 0.75659898E-07_JPRB, 0.75962703E-07_JPRB, 0.76302591E-07_JPRB, 0.76946741E-07_JPRB /)

RGHG7(:,66,10) = (/ &
  & 0.70453552E-07_JPRB, 0.68280109E-07_JPRB, 0.67170710E-07_JPRB, 0.66224402E-07_JPRB, 0.65198975E-07_JPRB, 0.64118467E-07_JPRB, &
  & 0.63040211E-07_JPRB, 0.62033827E-07_JPRB, 0.60940607E-07_JPRB, 0.59979023E-07_JPRB, 0.58948771E-07_JPRB, 0.57954242E-07_JPRB, &
  & 0.57010155E-07_JPRB, 0.56261658E-07_JPRB, 0.55822824E-07_JPRB, 0.55758896E-07_JPRB, 0.56136972E-07_JPRB, 0.56872345E-07_JPRB, &
  & 0.57791965E-07_JPRB, 0.58610787E-07_JPRB, 0.59033713E-07_JPRB, 0.58778461E-07_JPRB, 0.57647625E-07_JPRB, 0.55560001E-07_JPRB, &
  & 0.52660916E-07_JPRB, 0.49227033E-07_JPRB, 0.45628695E-07_JPRB, 0.42267555E-07_JPRB, 0.39402693E-07_JPRB, 0.37188876E-07_JPRB, &
  & 0.35713484E-07_JPRB, 0.34858331E-07_JPRB, 0.34496594E-07_JPRB, 0.34563179E-07_JPRB, 0.35079129E-07_JPRB, 0.36122366E-07_JPRB, &
  & 0.37710670E-07_JPRB, 0.39784979E-07_JPRB, 0.42257383E-07_JPRB, 0.45006331E-07_JPRB, 0.47881265E-07_JPRB, 0.50689401E-07_JPRB, &
  & 0.53277954E-07_JPRB, 0.55604822E-07_JPRB, 0.57695420E-07_JPRB, 0.59642730E-07_JPRB, 0.61491512E-07_JPRB, 0.63281171E-07_JPRB, &
  & 0.64957035E-07_JPRB, 0.66511589E-07_JPRB, 0.67891648E-07_JPRB, 0.69068392E-07_JPRB, 0.70051051E-07_JPRB, 0.70880951E-07_JPRB, &
  & 0.71613783E-07_JPRB, 0.72311423E-07_JPRB, 0.72994162E-07_JPRB, 0.73624982E-07_JPRB, 0.74170323E-07_JPRB, 0.74617653E-07_JPRB, &
  & 0.74990190E-07_JPRB, 0.75332991E-07_JPRB, 0.75726440E-07_JPRB, 0.76427277E-07_JPRB /)

RGHG7(:,67,10) = (/ &
  & 0.68133510E-07_JPRB, 0.65888997E-07_JPRB, 0.64797163E-07_JPRB, 0.63856767E-07_JPRB, 0.62892383E-07_JPRB, 0.61861229E-07_JPRB, &
  & 0.60804368E-07_JPRB, 0.59683074E-07_JPRB, 0.58522261E-07_JPRB, 0.57343271E-07_JPRB, 0.56298756E-07_JPRB, 0.55260355E-07_JPRB, &
  & 0.54380646E-07_JPRB, 0.53687980E-07_JPRB, 0.53293672E-07_JPRB, 0.53238832E-07_JPRB, 0.53575341E-07_JPRB, 0.54226195E-07_JPRB, &
  & 0.55031826E-07_JPRB, 0.55738674E-07_JPRB, 0.56077766E-07_JPRB, 0.55815232E-07_JPRB, 0.54777619E-07_JPRB, 0.52906987E-07_JPRB, &
  & 0.50311026E-07_JPRB, 0.47268330E-07_JPRB, 0.44099945E-07_JPRB, 0.41175891E-07_JPRB, 0.38709366E-07_JPRB, 0.36876052E-07_JPRB, &
  & 0.35698093E-07_JPRB, 0.35067728E-07_JPRB, 0.34851897E-07_JPRB, 0.34990549E-07_JPRB, 0.35506748E-07_JPRB, 0.36484774E-07_JPRB, &
  & 0.37946293E-07_JPRB, 0.39850537E-07_JPRB, 0.42102965E-07_JPRB, 0.44627921E-07_JPRB, 0.47287973E-07_JPRB, 0.49925660E-07_JPRB, &
  & 0.52393819E-07_JPRB, 0.54655285E-07_JPRB, 0.56726545E-07_JPRB, 0.58667290E-07_JPRB, 0.60508448E-07_JPRB, 0.62294781E-07_JPRB, &
  & 0.63964549E-07_JPRB, 0.65504167E-07_JPRB, 0.66871323E-07_JPRB, 0.68054902E-07_JPRB, 0.69046216E-07_JPRB, 0.69932113E-07_JPRB, &
  & 0.70710684E-07_JPRB, 0.71461741E-07_JPRB, 0.72190545E-07_JPRB, 0.72857077E-07_JPRB, 0.73429142E-07_JPRB, 0.73911004E-07_JPRB, &
  & 0.74318422E-07_JPRB, 0.74715651E-07_JPRB, 0.75180573E-07_JPRB, 0.75997619E-07_JPRB /)

RGHG7(:,68,10) = (/ &
  & 0.65988011E-07_JPRB, 0.63604467E-07_JPRB, 0.62452152E-07_JPRB, 0.61512438E-07_JPRB, 0.60574145E-07_JPRB, 0.59573043E-07_JPRB, &
  & 0.58538394E-07_JPRB, 0.57394534E-07_JPRB, 0.56043543E-07_JPRB, 0.54849139E-07_JPRB, 0.53750675E-07_JPRB, 0.52777207E-07_JPRB, &
  & 0.51966261E-07_JPRB, 0.51343363E-07_JPRB, 0.50997798E-07_JPRB, 0.50957521E-07_JPRB, 0.51259128E-07_JPRB, 0.51834107E-07_JPRB, &
  & 0.52538152E-07_JPRB, 0.53139402E-07_JPRB, 0.53418450E-07_JPRB, 0.53167145E-07_JPRB, 0.52241106E-07_JPRB, 0.50574943E-07_JPRB, &
  & 0.48293888E-07_JPRB, 0.45633783E-07_JPRB, 0.42884739E-07_JPRB, 0.40379415E-07_JPRB, 0.38297159E-07_JPRB, 0.36805751E-07_JPRB, &
  & 0.35905135E-07_JPRB, 0.35485701E-07_JPRB, 0.35407670E-07_JPRB, 0.35618125E-07_JPRB, 0.36143522E-07_JPRB, 0.37066226E-07_JPRB, &
  & 0.38415667E-07_JPRB, 0.40155740E-07_JPRB, 0.42214896E-07_JPRB, 0.44521887E-07_JPRB, 0.46974201E-07_JPRB, 0.49427758E-07_JPRB, &
  & 0.51771838E-07_JPRB, 0.53949382E-07_JPRB, 0.55973988E-07_JPRB, 0.57893672E-07_JPRB, 0.59709940E-07_JPRB, 0.61480193E-07_JPRB, &
  & 0.63116673E-07_JPRB, 0.64626377E-07_JPRB, 0.65970802E-07_JPRB, 0.67143290E-07_JPRB, 0.68143279E-07_JPRB, 0.69052852E-07_JPRB, &
  & 0.69856306E-07_JPRB, 0.70644539E-07_JPRB, 0.71403093E-07_JPRB, 0.72086813E-07_JPRB, 0.72683264E-07_JPRB, 0.73185475E-07_JPRB, &
  & 0.73631639E-07_JPRB, 0.74073355E-07_JPRB, 0.74637398E-07_JPRB, 0.75592069E-07_JPRB /)

RGHG7(:,69,10) = (/ &
  & 0.63939368E-07_JPRB, 0.61334710E-07_JPRB, 0.60105315E-07_JPRB, 0.59139754E-07_JPRB, 0.58215115E-07_JPRB, 0.57253413E-07_JPRB, &
  & 0.56204325E-07_JPRB, 0.55061911E-07_JPRB, 0.53658450E-07_JPRB, 0.52384628E-07_JPRB, 0.51366406E-07_JPRB, 0.50452641E-07_JPRB, &
  & 0.49731096E-07_JPRB, 0.49187154E-07_JPRB, 0.48901928E-07_JPRB, 0.48887877E-07_JPRB, 0.49172709E-07_JPRB, 0.49691923E-07_JPRB, &
  & 0.50313126E-07_JPRB, 0.50843393E-07_JPRB, 0.51077595E-07_JPRB, 0.50852982E-07_JPRB, 0.50041418E-07_JPRB, 0.48590689E-07_JPRB, &
  & 0.46613071E-07_JPRB, 0.44319759E-07_JPRB, 0.41972768E-07_JPRB, 0.39858826E-07_JPRB, 0.38149636E-07_JPRB, 0.36966401E-07_JPRB, &
  & 0.36327656E-07_JPRB, 0.36099184E-07_JPRB, 0.36147462E-07_JPRB, 0.36428538E-07_JPRB, 0.36969176E-07_JPRB, 0.37850185E-07_JPRB, &
  & 0.39098957E-07_JPRB, 0.40696705E-07_JPRB, 0.42565368E-07_JPRB, 0.44664457E-07_JPRB, 0.46912589E-07_JPRB, 0.49191907E-07_JPRB, &
  & 0.51395645E-07_JPRB, 0.53484182E-07_JPRB, 0.55443259E-07_JPRB, 0.57310629E-07_JPRB, 0.59094340E-07_JPRB, 0.60819886E-07_JPRB, &
  & 0.62412916E-07_JPRB, 0.63883569E-07_JPRB, 0.65196396E-07_JPRB, 0.66344519E-07_JPRB, 0.67329616E-07_JPRB, 0.68236524E-07_JPRB, &
  & 0.69049904E-07_JPRB, 0.69853030E-07_JPRB, 0.70622988E-07_JPRB, 0.71317331E-07_JPRB, 0.71917981E-07_JPRB, 0.72441409E-07_JPRB, &
  & 0.72905912E-07_JPRB, 0.73392528E-07_JPRB, 0.74033096E-07_JPRB, 0.75163555E-07_JPRB /)

RGHG7(:,70,10) = (/ &
  & 0.61924723E-07_JPRB, 0.59022579E-07_JPRB, 0.57695512E-07_JPRB, 0.56708263E-07_JPRB, 0.55794203E-07_JPRB, 0.54843749E-07_JPRB, &
  & 0.53853036E-07_JPRB, 0.52680864E-07_JPRB, 0.51264884E-07_JPRB, 0.50052048E-07_JPRB, 0.49107342E-07_JPRB, 0.48296112E-07_JPRB, &
  & 0.47681059E-07_JPRB, 0.47230174E-07_JPRB, 0.47013003E-07_JPRB, 0.47033552E-07_JPRB, 0.47311847E-07_JPRB, 0.47789094E-07_JPRB, &
  & 0.48351723E-07_JPRB, 0.48824479E-07_JPRB, 0.49042988E-07_JPRB, 0.48865537E-07_JPRB, 0.48176936E-07_JPRB, 0.46938176E-07_JPRB, &
  & 0.45252648E-07_JPRB, 0.43315129E-07_JPRB, 0.41341710E-07_JPRB, 0.39598106E-07_JPRB, 0.38230162E-07_JPRB, 0.37338442E-07_JPRB, &
  & 0.36929315E-07_JPRB, 0.36879399E-07_JPRB, 0.37048427E-07_JPRB, 0.37399960E-07_JPRB, 0.37961975E-07_JPRB, 0.38808377E-07_JPRB, &
  & 0.39965670E-07_JPRB, 0.41423856E-07_JPRB, 0.43134175E-07_JPRB, 0.45042693E-07_JPRB, 0.47098002E-07_JPRB, 0.49195926E-07_JPRB, &
  & 0.51261129E-07_JPRB, 0.53234558E-07_JPRB, 0.55119735E-07_JPRB, 0.56919561E-07_JPRB, 0.58642243E-07_JPRB, 0.60306888E-07_JPRB, &
  & 0.61831557E-07_JPRB, 0.63246851E-07_JPRB, 0.64512584E-07_JPRB, 0.65619105E-07_JPRB, 0.66582473E-07_JPRB, 0.67477828E-07_JPRB, &
  & 0.68282496E-07_JPRB, 0.69082041E-07_JPRB, 0.69852220E-07_JPRB, 0.70537986E-07_JPRB, 0.71139056E-07_JPRB, 0.71662576E-07_JPRB, &
  & 0.72143244E-07_JPRB, 0.72652654E-07_JPRB, 0.73365761E-07_JPRB, 0.74670119E-07_JPRB /)

RGHG7(:,71,10) = (/ &
  & 0.59843060E-07_JPRB, 0.56619662E-07_JPRB, 0.55200360E-07_JPRB, 0.54194860E-07_JPRB, 0.53297011E-07_JPRB, 0.52388369E-07_JPRB, &
  & 0.51405678E-07_JPRB, 0.50314199E-07_JPRB, 0.48928847E-07_JPRB, 0.47831179E-07_JPRB, 0.46978975E-07_JPRB, 0.46290243E-07_JPRB, &
  & 0.45786123E-07_JPRB, 0.45441183E-07_JPRB, 0.45304354E-07_JPRB, 0.45373525E-07_JPRB, 0.45665143E-07_JPRB, 0.46120700E-07_JPRB, &
  & 0.46646214E-07_JPRB, 0.47091824E-07_JPRB, 0.47306852E-07_JPRB, 0.47184940E-07_JPRB, 0.46627829E-07_JPRB, 0.45597023E-07_JPRB, &
  & 0.44199545E-07_JPRB, 0.42591758E-07_JPRB, 0.40980428E-07_JPRB, 0.39579099E-07_JPRB, 0.38520110E-07_JPRB, 0.37902986E-07_JPRB, &
  & 0.37714990E-07_JPRB, 0.37823281E-07_JPRB, 0.38100875E-07_JPRB, 0.38520543E-07_JPRB, 0.39107551E-07_JPRB, 0.39931166E-07_JPRB, &
  & 0.41009709E-07_JPRB, 0.42345160E-07_JPRB, 0.43895351E-07_JPRB, 0.45616037E-07_JPRB, 0.47492723E-07_JPRB, 0.49421775E-07_JPRB, &
  & 0.51341953E-07_JPRB, 0.53203390E-07_JPRB, 0.54988472E-07_JPRB, 0.56702081E-07_JPRB, 0.58344447E-07_JPRB, 0.59927643E-07_JPRB, &
  & 0.61380113E-07_JPRB, 0.62729377E-07_JPRB, 0.63934344E-07_JPRB, 0.64988562E-07_JPRB, 0.65916076E-07_JPRB, 0.66773765E-07_JPRB, &
  & 0.67544519E-07_JPRB, 0.68333499E-07_JPRB, 0.69077899E-07_JPRB, 0.69753476E-07_JPRB, 0.70341770E-07_JPRB, 0.70852870E-07_JPRB, &
  & 0.71335322E-07_JPRB, 0.71848426E-07_JPRB, 0.72611165E-07_JPRB, 0.74056352E-07_JPRB /)

RGHG7(:,72,10) = (/ &
  & 0.57591304E-07_JPRB, 0.54069368E-07_JPRB, 0.52605468E-07_JPRB, 0.51601663E-07_JPRB, 0.50740745E-07_JPRB, 0.49870934E-07_JPRB, &
  & 0.48968623E-07_JPRB, 0.47909364E-07_JPRB, 0.46732151E-07_JPRB, 0.45695568E-07_JPRB, 0.45023732E-07_JPRB, 0.44447329E-07_JPRB, &
  & 0.44070884E-07_JPRB, 0.43836515E-07_JPRB, 0.43783775E-07_JPRB, 0.43907662E-07_JPRB, 0.44220531E-07_JPRB, 0.44668500E-07_JPRB, &
  & 0.45174684E-07_JPRB, 0.45601958E-07_JPRB, 0.45835343E-07_JPRB, 0.45784624E-07_JPRB, 0.45361254E-07_JPRB, 0.44544166E-07_JPRB, &
  & 0.43418538E-07_JPRB, 0.42136104E-07_JPRB, 0.40859728E-07_JPRB, 0.39778982E-07_JPRB, 0.39008654E-07_JPRB, 0.38637726E-07_JPRB, &
  & 0.38633342E-07_JPRB, 0.38889130E-07_JPRB, 0.39272503E-07_JPRB, 0.39761723E-07_JPRB, 0.40376296E-07_JPRB, 0.41183576E-07_JPRB, &
  & 0.42184730E-07_JPRB, 0.43402906E-07_JPRB, 0.44817718E-07_JPRB, 0.46382763E-07_JPRB, 0.48080437E-07_JPRB, 0.49841610E-07_JPRB, &
  & 0.51617647E-07_JPRB, 0.53351631E-07_JPRB, 0.55032153E-07_JPRB, 0.56643419E-07_JPRB, 0.58192853E-07_JPRB, 0.59674541E-07_JPRB, &
  & 0.61042883E-07_JPRB, 0.62299776E-07_JPRB, 0.63431763E-07_JPRB, 0.64428328E-07_JPRB, 0.65312385E-07_JPRB, 0.66106431E-07_JPRB, &
  & 0.66861645E-07_JPRB, 0.67592538E-07_JPRB, 0.68321761E-07_JPRB, 0.68971040E-07_JPRB, 0.69526827E-07_JPRB, 0.70030303E-07_JPRB, &
  & 0.70490657E-07_JPRB, 0.70991369E-07_JPRB, 0.71769691E-07_JPRB, 0.73303525E-07_JPRB /)

RGHG7(:,73,10) = (/ &
  & 0.55070668E-07_JPRB, 0.51394927E-07_JPRB, 0.49920583E-07_JPRB, 0.48972325E-07_JPRB, 0.48164548E-07_JPRB, 0.47371262E-07_JPRB, &
  & 0.46537185E-07_JPRB, 0.45648573E-07_JPRB, 0.44568388E-07_JPRB, 0.43798369E-07_JPRB, 0.43172591E-07_JPRB, 0.42769607E-07_JPRB, &
  & 0.42501359E-07_JPRB, 0.42382524E-07_JPRB, 0.42423821E-07_JPRB, 0.42614992E-07_JPRB, 0.42963670E-07_JPRB, 0.43422496E-07_JPRB, &
  & 0.43917737E-07_JPRB, 0.44347857E-07_JPRB, 0.44606903E-07_JPRB, 0.44633435E-07_JPRB, 0.44354479E-07_JPRB, 0.43746937E-07_JPRB, &
  & 0.42891926E-07_JPRB, 0.41913463E-07_JPRB, 0.40959513E-07_JPRB, 0.40169091E-07_JPRB, 0.39679762E-07_JPRB, 0.39522881E-07_JPRB, &
  & 0.39704734E-07_JPRB, 0.40087457E-07_JPRB, 0.40561854E-07_JPRB, 0.41114475E-07_JPRB, 0.41759350E-07_JPRB, 0.42560554E-07_JPRB, &
  & 0.43498510E-07_JPRB, 0.44618591E-07_JPRB, 0.45885599E-07_JPRB, 0.47287720E-07_JPRB, 0.48823942E-07_JPRB, 0.50427936E-07_JPRB, &
  & 0.52054034E-07_JPRB, 0.53660926E-07_JPRB, 0.55218109E-07_JPRB, 0.56725575E-07_JPRB, 0.58163145E-07_JPRB, 0.59532585E-07_JPRB, &
  & 0.60804496E-07_JPRB, 0.61971974E-07_JPRB, 0.63028494E-07_JPRB, 0.63964499E-07_JPRB, 0.64776572E-07_JPRB, 0.65528532E-07_JPRB, &
  & 0.66205196E-07_JPRB, 0.66919668E-07_JPRB, 0.67587351E-07_JPRB, 0.68201139E-07_JPRB, 0.68737727E-07_JPRB, 0.69194883E-07_JPRB, &
  & 0.69646525E-07_JPRB, 0.70105408E-07_JPRB, 0.70869241E-07_JPRB, 0.72423724E-07_JPRB /)

RGHG7(:,74,10) = (/ &
  & 0.52261633E-07_JPRB, 0.48608868E-07_JPRB, 0.47229285E-07_JPRB, 0.46353716E-07_JPRB, 0.45640235E-07_JPRB, 0.44939572E-07_JPRB, &
  & 0.44232191E-07_JPRB, 0.43450981E-07_JPRB, 0.42659881E-07_JPRB, 0.41958579E-07_JPRB, 0.41555346E-07_JPRB, 0.41245869E-07_JPRB, &
  & 0.41114806E-07_JPRB, 0.41103906E-07_JPRB, 0.41230972E-07_JPRB, 0.41488029E-07_JPRB, 0.41873193E-07_JPRB, 0.42346201E-07_JPRB, &
  & 0.42849635E-07_JPRB, 0.43290555E-07_JPRB, 0.43589761E-07_JPRB, 0.43704077E-07_JPRB, 0.43574623E-07_JPRB, 0.43178332E-07_JPRB, &
  & 0.42580556E-07_JPRB, 0.41899632E-07_JPRB, 0.41242441E-07_JPRB, 0.40724807E-07_JPRB, 0.40499774E-07_JPRB, 0.40522984E-07_JPRB, &
  & 0.40844771E-07_JPRB, 0.41341679E-07_JPRB, 0.41906503E-07_JPRB, 0.42523467E-07_JPRB, 0.43201918E-07_JPRB, 0.43993676E-07_JPRB, &
  & 0.44870863E-07_JPRB, 0.45897430E-07_JPRB, 0.47053380E-07_JPRB, 0.48333764E-07_JPRB, 0.49706706E-07_JPRB, 0.51150522E-07_JPRB, &
  & 0.52631087E-07_JPRB, 0.54095253E-07_JPRB, 0.55528815E-07_JPRB, 0.56909709E-07_JPRB, 0.58232978E-07_JPRB, 0.59491541E-07_JPRB, &
  & 0.60650400E-07_JPRB, 0.61726176E-07_JPRB, 0.62694156E-07_JPRB, 0.63558936E-07_JPRB, 0.64318193E-07_JPRB, 0.64987212E-07_JPRB, &
  & 0.65659208E-07_JPRB, 0.66267781E-07_JPRB, 0.66916058E-07_JPRB, 0.67491584E-07_JPRB, 0.67965225E-07_JPRB, 0.68404013E-07_JPRB, &
  & 0.68817180E-07_JPRB, 0.69236428E-07_JPRB, 0.69946729E-07_JPRB, 0.71468435E-07_JPRB /)

RGHG7(:,75,10) = (/ &
  & 0.49373185E-07_JPRB, 0.45853099E-07_JPRB, 0.44577043E-07_JPRB, 0.43818332E-07_JPRB, 0.43210111E-07_JPRB, 0.42634738E-07_JPRB, &
  & 0.42052058E-07_JPRB, 0.41467246E-07_JPRB, 0.40792155E-07_JPRB, 0.40346858E-07_JPRB, 0.40024386E-07_JPRB, 0.39879122E-07_JPRB, &
  & 0.39857753E-07_JPRB, 0.39959339E-07_JPRB, 0.40176481E-07_JPRB, 0.40503171E-07_JPRB, 0.40929137E-07_JPRB, 0.41430592E-07_JPRB, &
  & 0.41946706E-07_JPRB, 0.42411983E-07_JPRB, 0.42758749E-07_JPRB, 0.42964697E-07_JPRB, 0.42988663E-07_JPRB, 0.42800256E-07_JPRB, &
  & 0.42450846E-07_JPRB, 0.42057774E-07_JPRB, 0.41675488E-07_JPRB, 0.41422233E-07_JPRB, 0.41425746E-07_JPRB, 0.41641556E-07_JPRB, &
  & 0.42100840E-07_JPRB, 0.42701267E-07_JPRB, 0.43339618E-07_JPRB, 0.44010704E-07_JPRB, 0.44723780E-07_JPRB, 0.45510511E-07_JPRB, &
  & 0.46350184E-07_JPRB, 0.47290190E-07_JPRB, 0.48324512E-07_JPRB, 0.49441972E-07_JPRB, 0.50678565E-07_JPRB, 0.51977377E-07_JPRB, &
  & 0.53303175E-07_JPRB, 0.54629567E-07_JPRB, 0.55926400E-07_JPRB, 0.57179449E-07_JPRB, 0.58382742E-07_JPRB, 0.59518360E-07_JPRB, &
  & 0.60574834E-07_JPRB, 0.61551575E-07_JPRB, 0.62443220E-07_JPRB, 0.63236854E-07_JPRB, 0.63922847E-07_JPRB, 0.64563089E-07_JPRB, &
  & 0.65137939E-07_JPRB, 0.65725544E-07_JPRB, 0.66309532E-07_JPRB, 0.66806535E-07_JPRB, 0.67278108E-07_JPRB, 0.67645637E-07_JPRB, &
  & 0.68040478E-07_JPRB, 0.68403750E-07_JPRB, 0.69058196E-07_JPRB, 0.70482486E-07_JPRB /)

RGHG7(:,76,10) = (/ &
  & 0.46478107E-07_JPRB, 0.43151914E-07_JPRB, 0.42007429E-07_JPRB, 0.41377113E-07_JPRB, 0.40906794E-07_JPRB, 0.40459902E-07_JPRB, &
  & 0.40031178E-07_JPRB, 0.39583760E-07_JPRB, 0.39143785E-07_JPRB, 0.38821025E-07_JPRB, 0.38690946E-07_JPRB, 0.38672543E-07_JPRB, &
  & 0.38769983E-07_JPRB, 0.38970551E-07_JPRB, 0.39262240E-07_JPRB, 0.39646185E-07_JPRB, 0.40117285E-07_JPRB, 0.40639524E-07_JPRB, &
  & 0.41178090E-07_JPRB, 0.41677794E-07_JPRB, 0.42081087E-07_JPRB, 0.42385366E-07_JPRB, 0.42561037E-07_JPRB, 0.42574410E-07_JPRB, &
  & 0.42465228E-07_JPRB, 0.42353722E-07_JPRB, 0.42213721E-07_JPRB, 0.42239758E-07_JPRB, 0.42412626E-07_JPRB, 0.42810026E-07_JPRB, &
  & 0.43338400E-07_JPRB, 0.44014616E-07_JPRB, 0.44721812E-07_JPRB, 0.45443851E-07_JPRB, 0.46189527E-07_JPRB, 0.46971433E-07_JPRB, &
  & 0.47779949E-07_JPRB, 0.48652709E-07_JPRB, 0.49613565E-07_JPRB, 0.50632973E-07_JPRB, 0.51732670E-07_JPRB, 0.52875386E-07_JPRB, &
  & 0.54051863E-07_JPRB, 0.55231574E-07_JPRB, 0.56386334E-07_JPRB, 0.57513986E-07_JPRB, 0.58586483E-07_JPRB, 0.59608261E-07_JPRB, &
  & 0.60553226E-07_JPRB, 0.61430477E-07_JPRB, 0.62234498E-07_JPRB, 0.62948786E-07_JPRB, 0.63599998E-07_JPRB, 0.64162592E-07_JPRB, &
  & 0.64719657E-07_JPRB, 0.65227695E-07_JPRB, 0.65754506E-07_JPRB, 0.66222746E-07_JPRB, 0.66619585E-07_JPRB, 0.66960347E-07_JPRB, &
  & 0.67312399E-07_JPRB, 0.67629635E-07_JPRB, 0.68196925E-07_JPRB, 0.69520787E-07_JPRB /)

RGHG7(:,77,10) = (/ &
  & 0.43630564E-07_JPRB, 0.40529617E-07_JPRB, 0.39546084E-07_JPRB, 0.39063906E-07_JPRB, 0.38729436E-07_JPRB, 0.38433221E-07_JPRB, &
  & 0.38155068E-07_JPRB, 0.37884615E-07_JPRB, 0.37604231E-07_JPRB, 0.37472180E-07_JPRB, 0.37483932E-07_JPRB, 0.37593615E-07_JPRB, &
  & 0.37807396E-07_JPRB, 0.38100662E-07_JPRB, 0.38468599E-07_JPRB, 0.38909224E-07_JPRB, 0.39411436E-07_JPRB, 0.39963876E-07_JPRB, &
  & 0.40528651E-07_JPRB, 0.41065302E-07_JPRB, 0.41535628E-07_JPRB, 0.41935703E-07_JPRB, 0.42259508E-07_JPRB, 0.42461352E-07_JPRB, &
  & 0.42595705E-07_JPRB, 0.42734499E-07_JPRB, 0.42816328E-07_JPRB, 0.43126857E-07_JPRB, 0.43422780E-07_JPRB, 0.44014975E-07_JPRB, &
  & 0.44652179E-07_JPRB, 0.45395353E-07_JPRB, 0.46169077E-07_JPRB, 0.46936375E-07_JPRB, 0.47711922E-07_JPRB, 0.48493181E-07_JPRB, &
  & 0.49274526E-07_JPRB, 0.50076761E-07_JPRB, 0.50923276E-07_JPRB, 0.51807515E-07_JPRB, 0.52786859E-07_JPRB, 0.53796882E-07_JPRB, &
  & 0.54832658E-07_JPRB, 0.55863044E-07_JPRB, 0.56887092E-07_JPRB, 0.57875006E-07_JPRB, 0.58831198E-07_JPRB, 0.59732706E-07_JPRB, &
  & 0.60572695E-07_JPRB, 0.61356424E-07_JPRB, 0.62076971E-07_JPRB, 0.62720105E-07_JPRB, 0.63313898E-07_JPRB, 0.63840609E-07_JPRB, &
  & 0.64330955E-07_JPRB, 0.64801270E-07_JPRB, 0.65277142E-07_JPRB, 0.65662626E-07_JPRB, 0.66044329E-07_JPRB, 0.66332397E-07_JPRB, &
  & 0.66643523E-07_JPRB, 0.66910978E-07_JPRB, 0.67400620E-07_JPRB, 0.68573250E-07_JPRB /)

RGHG7(:,78,10) = (/ &
  & 0.40833715E-07_JPRB, 0.38089617E-07_JPRB, 0.37309832E-07_JPRB, 0.36990329E-07_JPRB, 0.36808913E-07_JPRB, 0.36657312E-07_JPRB, &
  & 0.36531013E-07_JPRB, 0.36423149E-07_JPRB, 0.36339596E-07_JPRB, 0.36380950E-07_JPRB, 0.36530302E-07_JPRB, 0.36769883E-07_JPRB, &
  & 0.37065497E-07_JPRB, 0.37426286E-07_JPRB, 0.37844579E-07_JPRB, 0.38319598E-07_JPRB, 0.38847894E-07_JPRB, 0.39416062E-07_JPRB, &
  & 0.39998309E-07_JPRB, 0.40575777E-07_JPRB, 0.41107246E-07_JPRB, 0.41604039E-07_JPRB, 0.42056630E-07_JPRB, 0.42425334E-07_JPRB, &
  & 0.42797154E-07_JPRB, 0.43117165E-07_JPRB, 0.43439282E-07_JPRB, 0.43945093E-07_JPRB, 0.44394117E-07_JPRB, 0.45041325E-07_JPRB, &
  & 0.45753790E-07_JPRB, 0.46479670E-07_JPRB, 0.47270614E-07_JPRB, 0.48049049E-07_JPRB, 0.48837158E-07_JPRB, 0.49634671E-07_JPRB, &
  & 0.50431733E-07_JPRB, 0.51239468E-07_JPRB, 0.52061065E-07_JPRB, 0.52916025E-07_JPRB, 0.53778361E-07_JPRB, 0.54671119E-07_JPRB, &
  & 0.55566783E-07_JPRB, 0.56469748E-07_JPRB, 0.57358204E-07_JPRB, 0.58231080E-07_JPRB, 0.59070889E-07_JPRB, 0.59869457E-07_JPRB, &
  & 0.60616458E-07_JPRB, 0.61310494E-07_JPRB, 0.61957074E-07_JPRB, 0.62544586E-07_JPRB, 0.63086063E-07_JPRB, 0.63568621E-07_JPRB, &
  & 0.64023816E-07_JPRB, 0.64452472E-07_JPRB, 0.64857041E-07_JPRB, 0.65219076E-07_JPRB, 0.65542466E-07_JPRB, 0.65791369E-07_JPRB, &
  & 0.66072161E-07_JPRB, 0.66280919E-07_JPRB, 0.66667376E-07_JPRB, 0.67655513E-07_JPRB /)

RGHG7(:,79,10) = (/ &
  & 0.38289841E-07_JPRB, 0.36276294E-07_JPRB, 0.35818367E-07_JPRB, 0.35694669E-07_JPRB, 0.35645979E-07_JPRB, 0.35625106E-07_JPRB, &
  & 0.35626769E-07_JPRB, 0.35648977E-07_JPRB, 0.35695937E-07_JPRB, 0.35831633E-07_JPRB, 0.36061177E-07_JPRB, 0.36344890E-07_JPRB, &
  & 0.36688935E-07_JPRB, 0.37085798E-07_JPRB, 0.37527101E-07_JPRB, 0.38013471E-07_JPRB, 0.38544208E-07_JPRB, 0.39108038E-07_JPRB, &
  & 0.39697557E-07_JPRB, 0.40288217E-07_JPRB, 0.40860481E-07_JPRB, 0.41418438E-07_JPRB, 0.41941512E-07_JPRB, 0.42424940E-07_JPRB, &
  & 0.42941494E-07_JPRB, 0.43307200E-07_JPRB, 0.43857224E-07_JPRB, 0.44323290E-07_JPRB, 0.44954021E-07_JPRB, 0.45530882E-07_JPRB, &
  & 0.46333575E-07_JPRB, 0.47049930E-07_JPRB, 0.47832078E-07_JPRB, 0.48618283E-07_JPRB, 0.49411263E-07_JPRB, 0.50217750E-07_JPRB, &
  & 0.51031108E-07_JPRB, 0.51845802E-07_JPRB, 0.52667755E-07_JPRB, 0.53505012E-07_JPRB, 0.54337637E-07_JPRB, 0.55187972E-07_JPRB, &
  & 0.56018131E-07_JPRB, 0.56833024E-07_JPRB, 0.57642129E-07_JPRB, 0.58439404E-07_JPRB, 0.59208919E-07_JPRB, 0.59948874E-07_JPRB, &
  & 0.60639991E-07_JPRB, 0.61291644E-07_JPRB, 0.61900373E-07_JPRB, 0.62448287E-07_JPRB, 0.62967551E-07_JPRB, 0.63437184E-07_JPRB, &
  & 0.63858650E-07_JPRB, 0.64268633E-07_JPRB, 0.64638229E-07_JPRB, 0.64964702E-07_JPRB, 0.65255861E-07_JPRB, 0.65490958E-07_JPRB, &
  & 0.65719178E-07_JPRB, 0.65890859E-07_JPRB, 0.66150726E-07_JPRB, 0.66852870E-07_JPRB /)

RGHG7(:,80,10) = (/ &
  & 0.36667274E-07_JPRB, 0.35497820E-07_JPRB, 0.35250672E-07_JPRB, 0.35238475E-07_JPRB, 0.35239673E-07_JPRB, 0.35248220E-07_JPRB, &
  & 0.35274404E-07_JPRB, 0.35332242E-07_JPRB, 0.35413802E-07_JPRB, 0.35587433E-07_JPRB, 0.35850160E-07_JPRB, 0.36162881E-07_JPRB, &
  & 0.36524717E-07_JPRB, 0.36929688E-07_JPRB, 0.37384083E-07_JPRB, 0.37876347E-07_JPRB, 0.38415450E-07_JPRB, 0.38982435E-07_JPRB, &
  & 0.39570015E-07_JPRB, 0.40170224E-07_JPRB, 0.40756728E-07_JPRB, 0.41341078E-07_JPRB, 0.41875754E-07_JPRB, 0.42434532E-07_JPRB, &
  & 0.42967574E-07_JPRB, 0.43356888E-07_JPRB, 0.44063952E-07_JPRB, 0.44442704E-07_JPRB, 0.45224819E-07_JPRB, 0.45775916E-07_JPRB, &
  & 0.46557929E-07_JPRB, 0.47314064E-07_JPRB, 0.48076888E-07_JPRB, 0.48870401E-07_JPRB, 0.49664550E-07_JPRB, 0.50481763E-07_JPRB, &
  & 0.51299491E-07_JPRB, 0.52121653E-07_JPRB, 0.52946103E-07_JPRB, 0.53767767E-07_JPRB, 0.54580497E-07_JPRB, 0.55383424E-07_JPRB, &
  & 0.56174567E-07_JPRB, 0.56961561E-07_JPRB, 0.57741936E-07_JPRB, 0.58508238E-07_JPRB, 0.59262621E-07_JPRB, 0.59976955E-07_JPRB, &
  & 0.60651693E-07_JPRB, 0.61280964E-07_JPRB, 0.61879327E-07_JPRB, 0.62410386E-07_JPRB, 0.62915184E-07_JPRB, 0.63381954E-07_JPRB, &
  & 0.63785286E-07_JPRB, 0.64200485E-07_JPRB, 0.64544444E-07_JPRB, 0.64876957E-07_JPRB, 0.65150843E-07_JPRB, 0.65376021E-07_JPRB, &
  & 0.65600098E-07_JPRB, 0.65746967E-07_JPRB, 0.65931587E-07_JPRB, 0.66372401E-07_JPRB /)

RGHG7(:,81,10) = (/ &
  & 0.35649762E-07_JPRB, 0.35069156E-07_JPRB, 0.34935582E-07_JPRB, 0.34993075E-07_JPRB, 0.34994386E-07_JPRB, 0.35025177E-07_JPRB, &
  & 0.35087421E-07_JPRB, 0.35183437E-07_JPRB, 0.35293883E-07_JPRB, 0.35497930E-07_JPRB, 0.35759079E-07_JPRB, 0.36084892E-07_JPRB, &
  & 0.36450356E-07_JPRB, 0.36868549E-07_JPRB, 0.37325663E-07_JPRB, 0.37817312E-07_JPRB, 0.38353715E-07_JPRB, 0.38916067E-07_JPRB, &
  & 0.39505174E-07_JPRB, 0.40106450E-07_JPRB, 0.40706190E-07_JPRB, 0.41304460E-07_JPRB, 0.41847510E-07_JPRB, 0.42469395E-07_JPRB, &
  & 0.42929472E-07_JPRB, 0.43470614E-07_JPRB, 0.44082508E-07_JPRB, 0.44565706E-07_JPRB, 0.45255831E-07_JPRB, 0.45923844E-07_JPRB, &
  & 0.46628745E-07_JPRB, 0.47427250E-07_JPRB, 0.48183534E-07_JPRB, 0.48979473E-07_JPRB, 0.49781097E-07_JPRB, 0.50600146E-07_JPRB, &
  & 0.51427616E-07_JPRB, 0.52249188E-07_JPRB, 0.53073691E-07_JPRB, 0.53881987E-07_JPRB, 0.54701761E-07_JPRB, 0.55496507E-07_JPRB, &
  & 0.56281181E-07_JPRB, 0.57047384E-07_JPRB, 0.57808400E-07_JPRB, 0.58566194E-07_JPRB, 0.59296838E-07_JPRB, 0.60003160E-07_JPRB, &
  & 0.60663552E-07_JPRB, 0.61277049E-07_JPRB, 0.61870075E-07_JPRB, 0.62396914E-07_JPRB, 0.62889100E-07_JPRB, 0.63368674E-07_JPRB, &
  & 0.63752260E-07_JPRB, 0.64169399E-07_JPRB, 0.64498842E-07_JPRB, 0.64830296E-07_JPRB, 0.65088187E-07_JPRB, 0.65322922E-07_JPRB, &
  & 0.65521114E-07_JPRB, 0.65681022E-07_JPRB, 0.65802972E-07_JPRB, 0.66065326E-07_JPRB /)

RGHG7(:,82,10) = (/ &
  & 0.35042142E-07_JPRB, 0.34879058E-07_JPRB, 0.34849773E-07_JPRB, 0.34951441E-07_JPRB, 0.34914912E-07_JPRB, 0.34973553E-07_JPRB, &
  & 0.35039172E-07_JPRB, 0.35121104E-07_JPRB, 0.35246060E-07_JPRB, 0.35428926E-07_JPRB, 0.35719388E-07_JPRB, 0.36040777E-07_JPRB, &
  & 0.36417507E-07_JPRB, 0.36831665E-07_JPRB, 0.37292040E-07_JPRB, 0.37788901E-07_JPRB, 0.38328377E-07_JPRB, 0.38894559E-07_JPRB, &
  & 0.39481080E-07_JPRB, 0.40079531E-07_JPRB, 0.40690818E-07_JPRB, 0.41280153E-07_JPRB, 0.41837691E-07_JPRB, 0.42471019E-07_JPRB, &
  & 0.42869345E-07_JPRB, 0.43581412E-07_JPRB, 0.43984084E-07_JPRB, 0.44705502E-07_JPRB, 0.45228695E-07_JPRB, 0.46002263E-07_JPRB, &
  & 0.46667314E-07_JPRB, 0.47467804E-07_JPRB, 0.48236348E-07_JPRB, 0.49033162E-07_JPRB, 0.49838565E-07_JPRB, 0.50669705E-07_JPRB, &
  & 0.51494666E-07_JPRB, 0.52320821E-07_JPRB, 0.53135700E-07_JPRB, 0.53948320E-07_JPRB, 0.54748753E-07_JPRB, 0.55531430E-07_JPRB, &
  & 0.56304849E-07_JPRB, 0.57070231E-07_JPRB, 0.57830324E-07_JPRB, 0.58579452E-07_JPRB, 0.59312594E-07_JPRB, 0.60009690E-07_JPRB, &
  & 0.60674246E-07_JPRB, 0.61278548E-07_JPRB, 0.61868327E-07_JPRB, 0.62399494E-07_JPRB, 0.62868168E-07_JPRB, 0.63363039E-07_JPRB, &
  & 0.63740593E-07_JPRB, 0.64159408E-07_JPRB, 0.64481576E-07_JPRB, 0.64821407E-07_JPRB, 0.65069727E-07_JPRB, 0.65311418E-07_JPRB, &
  & 0.65495328E-07_JPRB, 0.65675323E-07_JPRB, 0.65754705E-07_JPRB, 0.65890873E-07_JPRB /)

RGHG7(:,83,10) = (/ &
  & 0.35033821E-07_JPRB, 0.34750403E-07_JPRB, 0.34833153E-07_JPRB, 0.34888256E-07_JPRB, 0.34805630E-07_JPRB, 0.34925105E-07_JPRB, &
  & 0.34965947E-07_JPRB, 0.35082468E-07_JPRB, 0.35207055E-07_JPRB, 0.35433231E-07_JPRB, 0.35679875E-07_JPRB, 0.36028304E-07_JPRB, &
  & 0.36393438E-07_JPRB, 0.36814303E-07_JPRB, 0.37276774E-07_JPRB, 0.37772335E-07_JPRB, 0.38306609E-07_JPRB, 0.38871573E-07_JPRB, &
  & 0.39456815E-07_JPRB, 0.40057049E-07_JPRB, 0.40670198E-07_JPRB, 0.41255216E-07_JPRB, 0.41839012E-07_JPRB, 0.42441389E-07_JPRB, &
  & 0.42888960E-07_JPRB, 0.43598646E-07_JPRB, 0.43975284E-07_JPRB, 0.44729049E-07_JPRB, 0.45247873E-07_JPRB, 0.46002278E-07_JPRB, &
  & 0.46700851E-07_JPRB, 0.47478643E-07_JPRB, 0.48261757E-07_JPRB, 0.49061352E-07_JPRB, 0.49878988E-07_JPRB, 0.50708863E-07_JPRB, &
  & 0.51545552E-07_JPRB, 0.52361727E-07_JPRB, 0.53181534E-07_JPRB, 0.53980923E-07_JPRB, 0.54785016E-07_JPRB, 0.55571036E-07_JPRB, &
  & 0.56349560E-07_JPRB, 0.57112477E-07_JPRB, 0.57871759E-07_JPRB, 0.58618394E-07_JPRB, 0.59345385E-07_JPRB, 0.60022337E-07_JPRB, &
  & 0.60693409E-07_JPRB, 0.61283039E-07_JPRB, 0.61859211E-07_JPRB, 0.62412376E-07_JPRB, 0.62859549E-07_JPRB, 0.63355749E-07_JPRB, &
  & 0.63732578E-07_JPRB, 0.64153220E-07_JPRB, 0.64466001E-07_JPRB, 0.64809349E-07_JPRB, 0.65046557E-07_JPRB, 0.65304292E-07_JPRB, &
  & 0.65456518E-07_JPRB, 0.65677654E-07_JPRB, 0.65725210E-07_JPRB, 0.65903819E-07_JPRB /)

RGHG7(:,84,10) = (/ &
  & 0.35084259E-07_JPRB, 0.34611446E-07_JPRB, 0.34898736E-07_JPRB, 0.34818569E-07_JPRB, 0.34783863E-07_JPRB, 0.34945540E-07_JPRB, &
  & 0.34936296E-07_JPRB, 0.35092295E-07_JPRB, 0.35200131E-07_JPRB, 0.35415759E-07_JPRB, 0.35686913E-07_JPRB, 0.36006053E-07_JPRB, &
  & 0.36381831E-07_JPRB, 0.36798074E-07_JPRB, 0.37253976E-07_JPRB, 0.37758763E-07_JPRB, 0.38294047E-07_JPRB, 0.38860012E-07_JPRB, &
  & 0.39448139E-07_JPRB, 0.40037381E-07_JPRB, 0.40663100E-07_JPRB, 0.41221018E-07_JPRB, 0.41848558E-07_JPRB, 0.42386148E-07_JPRB, &
  & 0.42942911E-07_JPRB, 0.43513101E-07_JPRB, 0.44042228E-07_JPRB, 0.44678814E-07_JPRB, 0.45288726E-07_JPRB, 0.45988322E-07_JPRB, &
  & 0.46712607E-07_JPRB, 0.47484161E-07_JPRB, 0.48273474E-07_JPRB, 0.49079645E-07_JPRB, 0.49901281E-07_JPRB, 0.50743246E-07_JPRB, &
  & 0.51575370E-07_JPRB, 0.52398345E-07_JPRB, 0.53211686E-07_JPRB, 0.54011974E-07_JPRB, 0.54803603E-07_JPRB, 0.55590629E-07_JPRB, &
  & 0.56363049E-07_JPRB, 0.57134681E-07_JPRB, 0.57898493E-07_JPRB, 0.58629166E-07_JPRB, 0.59373953E-07_JPRB, 0.60026927E-07_JPRB, &
  & 0.60697111E-07_JPRB, 0.61306061E-07_JPRB, 0.61850749E-07_JPRB, 0.62421357E-07_JPRB, 0.62864586E-07_JPRB, 0.63352964E-07_JPRB, &
  & 0.63729559E-07_JPRB, 0.64156986E-07_JPRB, 0.64459527E-07_JPRB, 0.64819339E-07_JPRB, 0.65029425E-07_JPRB, 0.65322780E-07_JPRB, &
  & 0.65430548E-07_JPRB, 0.65689669E-07_JPRB, 0.65702693E-07_JPRB, 0.65902199E-07_JPRB /)

RGHG7(:,85,10) = (/ &
  & 0.35115779E-07_JPRB, 0.34496274E-07_JPRB, 0.34990965E-07_JPRB, 0.34684319E-07_JPRB, 0.34813027E-07_JPRB, 0.34903234E-07_JPRB, &
  & 0.34905291E-07_JPRB, 0.35116674E-07_JPRB, 0.35201833E-07_JPRB, 0.35463394E-07_JPRB, 0.35695212E-07_JPRB, 0.36025614E-07_JPRB, &
  & 0.36373130E-07_JPRB, 0.36775635E-07_JPRB, 0.37233956E-07_JPRB, 0.37726515E-07_JPRB, 0.38264048E-07_JPRB, 0.38832194E-07_JPRB, &
  & 0.39420588E-07_JPRB, 0.40018918E-07_JPRB, 0.40630525E-07_JPRB, 0.41196447E-07_JPRB, 0.41839169E-07_JPRB, 0.42346262E-07_JPRB, &
  & 0.42952976E-07_JPRB, 0.43467647E-07_JPRB, 0.44069722E-07_JPRB, 0.44638728E-07_JPRB, 0.45298684E-07_JPRB, 0.45969973E-07_JPRB, &
  & 0.46715382E-07_JPRB, 0.47477862E-07_JPRB, 0.48276963E-07_JPRB, 0.49087991E-07_JPRB, 0.49917833E-07_JPRB, 0.50761081E-07_JPRB, &
  & 0.51599699E-07_JPRB, 0.52425086E-07_JPRB, 0.53242793E-07_JPRB, 0.54034174E-07_JPRB, 0.54847298E-07_JPRB, 0.55615384E-07_JPRB, &
  & 0.56422021E-07_JPRB, 0.57163497E-07_JPRB, 0.57961799E-07_JPRB, 0.58656486E-07_JPRB, 0.59405554E-07_JPRB, 0.60062824E-07_JPRB, &
  & 0.60691384E-07_JPRB, 0.61325679E-07_JPRB, 0.61849605E-07_JPRB, 0.62418728E-07_JPRB, 0.62870171E-07_JPRB, 0.63357369E-07_JPRB, &
  & 0.63723320E-07_JPRB, 0.64161057E-07_JPRB, 0.64448017E-07_JPRB, 0.64821869E-07_JPRB, 0.65011562E-07_JPRB, 0.65329303E-07_JPRB, &
  & 0.65408898E-07_JPRB, 0.65693897E-07_JPRB, 0.65689825E-07_JPRB, 0.65892863E-07_JPRB /)

RGHG7(:,86,10) = (/ &
  & 0.35138775E-07_JPRB, 0.34411933E-07_JPRB, 0.35070286E-07_JPRB, 0.34560429E-07_JPRB, 0.34917246E-07_JPRB, 0.34832837E-07_JPRB, &
  & 0.34993008E-07_JPRB, 0.35124756E-07_JPRB, 0.35283811E-07_JPRB, 0.35500118E-07_JPRB, 0.35749032E-07_JPRB, 0.36034915E-07_JPRB, &
  & 0.36376697E-07_JPRB, 0.36760323E-07_JPRB, 0.37189203E-07_JPRB, 0.37688071E-07_JPRB, 0.38220243E-07_JPRB, 0.38791260E-07_JPRB, &
  & 0.39395928E-07_JPRB, 0.39977564E-07_JPRB, 0.40602060E-07_JPRB, 0.41178545E-07_JPRB, 0.41798749E-07_JPRB, 0.42315552E-07_JPRB, &
  & 0.42927958E-07_JPRB, 0.43443219E-07_JPRB, 0.44041549E-07_JPRB, 0.44626315E-07_JPRB, 0.45277400E-07_JPRB, 0.45962565E-07_JPRB, &
  & 0.46702144E-07_JPRB, 0.47478753E-07_JPRB, 0.48274359E-07_JPRB, 0.49091085E-07_JPRB, 0.49923326E-07_JPRB, 0.50766744E-07_JPRB, &
  & 0.51613959E-07_JPRB, 0.52443109E-07_JPRB, 0.53273208E-07_JPRB, 0.54073293E-07_JPRB, 0.54885092E-07_JPRB, 0.55660877E-07_JPRB, &
  & 0.56461861E-07_JPRB, 0.57204005E-07_JPRB, 0.57988824E-07_JPRB, 0.58699008E-07_JPRB, 0.59398985E-07_JPRB, 0.60096930E-07_JPRB, &
  & 0.60697303E-07_JPRB, 0.61340586E-07_JPRB, 0.61868057E-07_JPRB, 0.62423645E-07_JPRB, 0.62873433E-07_JPRB, 0.63365320E-07_JPRB, &
  & 0.63724421E-07_JPRB, 0.64168603E-07_JPRB, 0.64446375E-07_JPRB, 0.64835440E-07_JPRB, 0.65001942E-07_JPRB, 0.65341858E-07_JPRB, &
  & 0.65403071E-07_JPRB, 0.65695012E-07_JPRB, 0.65684311E-07_JPRB, 0.65892685E-07_JPRB /)

RGHG7(:,87,10) = (/ &
  & 0.35159193E-07_JPRB, 0.34379379E-07_JPRB, 0.35090380E-07_JPRB, 0.34499195E-07_JPRB, 0.34979646E-07_JPRB, 0.34772931E-07_JPRB, &
  & 0.35064144E-07_JPRB, 0.35140403E-07_JPRB, 0.35352937E-07_JPRB, 0.35538029E-07_JPRB, 0.35799136E-07_JPRB, 0.36063156E-07_JPRB, &
  & 0.36381447E-07_JPRB, 0.36740037E-07_JPRB, 0.37164632E-07_JPRB, 0.37629679E-07_JPRB, 0.38164945E-07_JPRB, 0.38741273E-07_JPRB, &
  & 0.39332296E-07_JPRB, 0.39943338E-07_JPRB, 0.40564714E-07_JPRB, 0.41150638E-07_JPRB, 0.41742801E-07_JPRB, 0.42306500E-07_JPRB, &
  & 0.42872813E-07_JPRB, 0.43424350E-07_JPRB, 0.44008392E-07_JPRB, 0.44605869E-07_JPRB, 0.45257384E-07_JPRB, 0.45951143E-07_JPRB, &
  & 0.46694360E-07_JPRB, 0.47471911E-07_JPRB, 0.48274412E-07_JPRB, 0.49090733E-07_JPRB, 0.49921503E-07_JPRB, 0.50770339E-07_JPRB, &
  & 0.51611845E-07_JPRB, 0.52459221E-07_JPRB, 0.53289909E-07_JPRB, 0.54113869E-07_JPRB, 0.54927128E-07_JPRB, 0.55716367E-07_JPRB, &
  & 0.56511887E-07_JPRB, 0.57269784E-07_JPRB, 0.58011214E-07_JPRB, 0.58752907E-07_JPRB, 0.59414802E-07_JPRB, 0.60110935E-07_JPRB, &
  & 0.60709894E-07_JPRB, 0.61334994E-07_JPRB, 0.61874779E-07_JPRB, 0.62426814E-07_JPRB, 0.62878044E-07_JPRB, 0.63365505E-07_JPRB, &
  & 0.63728955E-07_JPRB, 0.64164048E-07_JPRB, 0.64450241E-07_JPRB, 0.64825080E-07_JPRB, 0.65010568E-07_JPRB, 0.65328599E-07_JPRB, &
  & 0.65410283E-07_JPRB, 0.65688042E-07_JPRB, 0.65685342E-07_JPRB, 0.65891093E-07_JPRB /)

RGHG7(:,88,10) = (/ &
  & 0.35151437E-07_JPRB, 0.34395786E-07_JPRB, 0.35064772E-07_JPRB, 0.34507071E-07_JPRB, 0.34986865E-07_JPRB, 0.34754020E-07_JPRB, &
  & 0.35131837E-07_JPRB, 0.35114674E-07_JPRB, 0.35404071E-07_JPRB, 0.35540275E-07_JPRB, 0.35802405E-07_JPRB, 0.36055884E-07_JPRB, &
  & 0.36372917E-07_JPRB, 0.36726146E-07_JPRB, 0.37130402E-07_JPRB, 0.37606974E-07_JPRB, 0.38130917E-07_JPRB, 0.38697824E-07_JPRB, &
  & 0.39299955E-07_JPRB, 0.39913854E-07_JPRB, 0.40529780E-07_JPRB, 0.41111921E-07_JPRB, 0.41708809E-07_JPRB, 0.42267033E-07_JPRB, &
  & 0.42827956E-07_JPRB, 0.43389687E-07_JPRB, 0.43964370E-07_JPRB, 0.44569710E-07_JPRB, 0.45223786E-07_JPRB, 0.45922953E-07_JPRB, &
  & 0.46675662E-07_JPRB, 0.47458109E-07_JPRB, 0.48262986E-07_JPRB, 0.49084157E-07_JPRB, 0.49920146E-07_JPRB, 0.50767081E-07_JPRB, &
  & 0.51623733E-07_JPRB, 0.52479898E-07_JPRB, 0.53329266E-07_JPRB, 0.54161116E-07_JPRB, 0.54977548E-07_JPRB, 0.55776791E-07_JPRB, &
  & 0.56546021E-07_JPRB, 0.57318470E-07_JPRB, 0.58034061E-07_JPRB, 0.58767061E-07_JPRB, 0.59436744E-07_JPRB, 0.60116797E-07_JPRB, &
  & 0.60732376E-07_JPRB, 0.61343556E-07_JPRB, 0.61885906E-07_JPRB, 0.62429748E-07_JPRB, 0.62888674E-07_JPRB, 0.63364752E-07_JPRB, &
  & 0.63741886E-07_JPRB, 0.64161526E-07_JPRB, 0.64463975E-07_JPRB, 0.64821009E-07_JPRB, 0.65020544E-07_JPRB, 0.65324834E-07_JPRB, &
  & 0.65420373E-07_JPRB, 0.65679814E-07_JPRB, 0.65693406E-07_JPRB, 0.65884727E-07_JPRB /)

RGHG7(:,89,10) = (/ &
  & 0.35125030E-07_JPRB, 0.34425419E-07_JPRB, 0.35024016E-07_JPRB, 0.34543337E-07_JPRB, 0.34929311E-07_JPRB, 0.34784616E-07_JPRB, &
  & 0.35041278E-07_JPRB, 0.35119609E-07_JPRB, 0.35338804E-07_JPRB, 0.35492445E-07_JPRB, 0.35760397E-07_JPRB, 0.36011990E-07_JPRB, &
  & 0.36340925E-07_JPRB, 0.36695400E-07_JPRB, 0.37120508E-07_JPRB, 0.37588194E-07_JPRB, 0.38114845E-07_JPRB, 0.38686814E-07_JPRB, &
  & 0.39277353E-07_JPRB, 0.39894395E-07_JPRB, 0.40480295E-07_JPRB, 0.41085414E-07_JPRB, 0.41656378E-07_JPRB, 0.42217717E-07_JPRB, &
  & 0.42774001E-07_JPRB, 0.43332363E-07_JPRB, 0.43908514E-07_JPRB, 0.44514607E-07_JPRB, 0.45170189E-07_JPRB, 0.45877346E-07_JPRB, &
  & 0.46634781E-07_JPRB, 0.47428948E-07_JPRB, 0.48243763E-07_JPRB, 0.49073947E-07_JPRB, 0.49917290E-07_JPRB, 0.50776073E-07_JPRB, &
  & 0.51643998E-07_JPRB, 0.52515166E-07_JPRB, 0.53376077E-07_JPRB, 0.54219893E-07_JPRB, 0.55041742E-07_JPRB, 0.55842062E-07_JPRB, &
  & 0.56610318E-07_JPRB, 0.57363835E-07_JPRB, 0.58084090E-07_JPRB, 0.58791660E-07_JPRB, 0.59465410E-07_JPRB, 0.60125778E-07_JPRB, &
  & 0.60745464E-07_JPRB, 0.61351578E-07_JPRB, 0.61900820E-07_JPRB, 0.62434999E-07_JPRB, 0.62904334E-07_JPRB, 0.63366500E-07_JPRB, &
  & 0.63756588E-07_JPRB, 0.64160048E-07_JPRB, 0.64477938E-07_JPRB, 0.64816213E-07_JPRB, 0.65035294E-07_JPRB, 0.65316073E-07_JPRB, &
  & 0.65434129E-07_JPRB, 0.65674485E-07_JPRB, 0.65702189E-07_JPRB, 0.65878943E-07_JPRB /)

RGHG7(:,90,10) = (/ &
  & 0.35082902E-07_JPRB, 0.34496061E-07_JPRB, 0.34949363E-07_JPRB, 0.34613265E-07_JPRB, 0.34849016E-07_JPRB, 0.34799282E-07_JPRB, &
  & 0.34958536E-07_JPRB, 0.35051169E-07_JPRB, 0.35211830E-07_JPRB, 0.35401321E-07_JPRB, 0.35638585E-07_JPRB, 0.35937251E-07_JPRB, &
  & 0.36269661E-07_JPRB, 0.36660641E-07_JPRB, 0.37095948E-07_JPRB, 0.37584428E-07_JPRB, 0.38121954E-07_JPRB, 0.38679893E-07_JPRB, &
  & 0.39276234E-07_JPRB, 0.39857117E-07_JPRB, 0.40454076E-07_JPRB, 0.41029281E-07_JPRB, 0.41590450E-07_JPRB, 0.42148017E-07_JPRB, &
  & 0.42695341E-07_JPRB, 0.43248562E-07_JPRB, 0.43821913E-07_JPRB, 0.44426180E-07_JPRB, 0.45085450E-07_JPRB, 0.45797933E-07_JPRB, &
  & 0.46564917E-07_JPRB, 0.47371337E-07_JPRB, 0.48200235E-07_JPRB, 0.49052112E-07_JPRB, 0.49917006E-07_JPRB, 0.50790533E-07_JPRB, &
  & 0.51684985E-07_JPRB, 0.52582518E-07_JPRB, 0.53459523E-07_JPRB, 0.54310892E-07_JPRB, 0.55132158E-07_JPRB, 0.55923419E-07_JPRB, &
  & 0.56684325E-07_JPRB, 0.57420028E-07_JPRB, 0.58133793E-07_JPRB, 0.58827624E-07_JPRB, 0.59500586E-07_JPRB, 0.60153511E-07_JPRB, &
  & 0.60771619E-07_JPRB, 0.61369420E-07_JPRB, 0.61923814E-07_JPRB, 0.62449864E-07_JPRB, 0.62926937E-07_JPRB, 0.63378913E-07_JPRB, &
  & 0.63779162E-07_JPRB, 0.64169726E-07_JPRB, 0.64500448E-07_JPRB, 0.64819467E-07_JPRB, 0.65057016E-07_JPRB, 0.65315362E-07_JPRB, &
  & 0.65454429E-07_JPRB, 0.65668374E-07_JPRB, 0.65721395E-07_JPRB, 0.65871198E-07_JPRB /)

RGHG7(:,91,10) = (/ &
  & 0.34937781E-07_JPRB, 0.34653674E-07_JPRB, 0.34824946E-07_JPRB, 0.34699280E-07_JPRB, 0.34771400E-07_JPRB, 0.34808082E-07_JPRB, &
  & 0.34867217E-07_JPRB, 0.34954738E-07_JPRB, 0.35080543E-07_JPRB, 0.35209865E-07_JPRB, 0.35475502E-07_JPRB, 0.35807446E-07_JPRB, &
  & 0.36182005E-07_JPRB, 0.36608252E-07_JPRB, 0.37075072E-07_JPRB, 0.37579120E-07_JPRB, 0.38112773E-07_JPRB, 0.38671601E-07_JPRB, &
  & 0.39240756E-07_JPRB, 0.39814005E-07_JPRB, 0.40380677E-07_JPRB, 0.40937486E-07_JPRB, 0.41485574E-07_JPRB, 0.42025992E-07_JPRB, &
  & 0.42568200E-07_JPRB, 0.43117687E-07_JPRB, 0.43688761E-07_JPRB, 0.44295213E-07_JPRB, 0.44957400E-07_JPRB, 0.45677989E-07_JPRB, &
  & 0.46460748E-07_JPRB, 0.47287450E-07_JPRB, 0.48135814E-07_JPRB, 0.49021324E-07_JPRB, 0.49915975E-07_JPRB, 0.50821303E-07_JPRB, &
  & 0.51751357E-07_JPRB, 0.52687454E-07_JPRB, 0.53585417E-07_JPRB, 0.54447579E-07_JPRB, 0.55271265E-07_JPRB, 0.56058887E-07_JPRB, &
  & 0.56810453E-07_JPRB, 0.57529618E-07_JPRB, 0.58223737E-07_JPRB, 0.58898706E-07_JPRB, 0.59557472E-07_JPRB, 0.60198680E-07_JPRB, &
  & 0.60813129E-07_JPRB, 0.61404712E-07_JPRB, 0.61959220E-07_JPRB, 0.62480197E-07_JPRB, 0.62960204E-07_JPRB, 0.63406191E-07_JPRB, &
  & 0.63809395E-07_JPRB, 0.64194957E-07_JPRB, 0.64531072E-07_JPRB, 0.64834474E-07_JPRB, 0.65087235E-07_JPRB, 0.65321473E-07_JPRB, &
  & 0.65487768E-07_JPRB, 0.65664061E-07_JPRB, 0.65758584E-07_JPRB, 0.65851630E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG7(:, 1,11) = (/ &
  & 0.19546465E-06_JPRB, 0.13800866E-06_JPRB, 0.11801129E-06_JPRB, 0.10077249E-06_JPRB, 0.91063100E-07_JPRB, 0.82920941E-07_JPRB, &
  & 0.77615496E-07_JPRB, 0.73615425E-07_JPRB, 0.71258249E-07_JPRB, 0.70014018E-07_JPRB, 0.70006649E-07_JPRB, 0.70076105E-07_JPRB, &
  & 0.70415695E-07_JPRB, 0.70806536E-07_JPRB, 0.71039217E-07_JPRB, 0.71347138E-07_JPRB, 0.71358741E-07_JPRB, 0.71415187E-07_JPRB, &
  & 0.71162980E-07_JPRB, 0.70854568E-07_JPRB, 0.70510126E-07_JPRB, 0.70319849E-07_JPRB, 0.70006934E-07_JPRB, 0.69650149E-07_JPRB, &
  & 0.69329374E-07_JPRB, 0.69009516E-07_JPRB, 0.68748307E-07_JPRB, 0.68412149E-07_JPRB, 0.68067017E-07_JPRB, 0.67803732E-07_JPRB, &
  & 0.67678606E-07_JPRB, 0.67726383E-07_JPRB, 0.67967292E-07_JPRB, 0.68455819E-07_JPRB, 0.68989131E-07_JPRB, 0.69496672E-07_JPRB, &
  & 0.69872677E-07_JPRB, 0.70012369E-07_JPRB, 0.69893957E-07_JPRB, 0.69676219E-07_JPRB, 0.69159917E-07_JPRB, 0.68598816E-07_JPRB, &
  & 0.68025905E-07_JPRB, 0.67387845E-07_JPRB, 0.66771690E-07_JPRB, 0.66223301E-07_JPRB, 0.65688276E-07_JPRB, 0.65196438E-07_JPRB, &
  & 0.64776749E-07_JPRB, 0.64522091E-07_JPRB, 0.64403231E-07_JPRB, 0.64495225E-07_JPRB, 0.64754815E-07_JPRB, 0.65224050E-07_JPRB, &
  & 0.65953209E-07_JPRB, 0.67346356E-07_JPRB, 0.59405897E-05_JPRB, 0.59620347E-05_JPRB, 0.59632353E-05_JPRB, 0.59645954E-05_JPRB, &
  & 0.59626509E-05_JPRB, 0.59707004E-05_JPRB, 0.59565750E-05_JPRB, 0.59258650E-05_JPRB /)

RGHG7(:, 2,11) = (/ &
  & 0.79857870E-06_JPRB, 0.10183896E-05_JPRB, 0.99954025E-06_JPRB, 0.88380358E-06_JPRB, 0.76436402E-06_JPRB, 0.64844664E-06_JPRB, &
  & 0.53967875E-06_JPRB, 0.43985980E-06_JPRB, 0.35743247E-06_JPRB, 0.29851296E-06_JPRB, 0.27800314E-06_JPRB, 0.26102086E-06_JPRB, &
  & 0.25012321E-06_JPRB, 0.24390010E-06_JPRB, 0.23517131E-06_JPRB, 0.23306042E-06_JPRB, 0.22632581E-06_JPRB, 0.22581216E-06_JPRB, &
  & 0.22088263E-06_JPRB, 0.21715462E-06_JPRB, 0.21541612E-06_JPRB, 0.21906227E-06_JPRB, 0.21990265E-06_JPRB, 0.21992271E-06_JPRB, &
  & 0.22006903E-06_JPRB, 0.22023455E-06_JPRB, 0.22450972E-06_JPRB, 0.22535319E-06_JPRB, 0.22448103E-06_JPRB, 0.22358479E-06_JPRB, &
  & 0.22280661E-06_JPRB, 0.22243377E-06_JPRB, 0.22291327E-06_JPRB, 0.22976803E-06_JPRB, 0.23164829E-06_JPRB, 0.23061642E-06_JPRB, &
  & 0.22815240E-06_JPRB, 0.22428122E-06_JPRB, 0.21995208E-06_JPRB, 0.22007310E-06_JPRB, 0.21646531E-06_JPRB, 0.21492254E-06_JPRB, &
  & 0.21230080E-06_JPRB, 0.20988112E-06_JPRB, 0.21033752E-06_JPRB, 0.21343901E-06_JPRB, 0.21571894E-06_JPRB, 0.21810369E-06_JPRB, &
  & 0.21792196E-06_JPRB, 0.21723757E-06_JPRB, 0.21194639E-06_JPRB, 0.20411233E-06_JPRB, 0.19226549E-06_JPRB, 0.18086909E-06_JPRB, &
  & 0.17084494E-06_JPRB, 0.16729442E-06_JPRB, 0.52036021E-05_JPRB, 0.51228326E-05_JPRB, 0.50422900E-05_JPRB, 0.49246132E-05_JPRB, &
  & 0.47432354E-05_JPRB, 0.45668348E-05_JPRB, 0.43165455E-05_JPRB, 0.39043457E-05_JPRB /)

RGHG7(:, 3,11) = (/ &
  & 0.10167822E-05_JPRB, 0.13059671E-05_JPRB, 0.12933401E-05_JPRB, 0.11926720E-05_JPRB, 0.10804195E-05_JPRB, 0.96306394E-06_JPRB, &
  & 0.84939666E-06_JPRB, 0.72866754E-06_JPRB, 0.62099616E-06_JPRB, 0.54281020E-06_JPRB, 0.52361253E-06_JPRB, 0.49037675E-06_JPRB, &
  & 0.47626935E-06_JPRB, 0.45853122E-06_JPRB, 0.44804668E-06_JPRB, 0.44068793E-06_JPRB, 0.43295148E-06_JPRB, 0.43148506E-06_JPRB, &
  & 0.42153215E-06_JPRB, 0.41660897E-06_JPRB, 0.41622903E-06_JPRB, 0.42320826E-06_JPRB, 0.42122264E-06_JPRB, 0.41996458E-06_JPRB, &
  & 0.41859948E-06_JPRB, 0.41982440E-06_JPRB, 0.42717633E-06_JPRB, 0.42542010E-06_JPRB, 0.42225744E-06_JPRB, 0.41858951E-06_JPRB, &
  & 0.41552235E-06_JPRB, 0.41387554E-06_JPRB, 0.41549742E-06_JPRB, 0.42407444E-06_JPRB, 0.42229163E-06_JPRB, 0.41792845E-06_JPRB, &
  & 0.41210279E-06_JPRB, 0.40628856E-06_JPRB, 0.40193294E-06_JPRB, 0.40361851E-06_JPRB, 0.39667049E-06_JPRB, 0.38980380E-06_JPRB, &
  & 0.38384459E-06_JPRB, 0.37967826E-06_JPRB, 0.37752204E-06_JPRB, 0.37943991E-06_JPRB, 0.37555273E-06_JPRB, 0.36755955E-06_JPRB, &
  & 0.35469731E-06_JPRB, 0.34130593E-06_JPRB, 0.32394064E-06_JPRB, 0.30813766E-06_JPRB, 0.28721107E-06_JPRB, 0.26648351E-06_JPRB, &
  & 0.25030820E-06_JPRB, 0.25497596E-06_JPRB, 0.29686773E-05_JPRB, 0.30278773E-05_JPRB, 0.29611490E-05_JPRB, 0.28699205E-05_JPRB, &
  & 0.27535330E-05_JPRB, 0.26488322E-05_JPRB, 0.24806384E-05_JPRB, 0.22391371E-05_JPRB /)

RGHG7(:, 4,11) = (/ &
  & 0.11719153E-05_JPRB, 0.13363973E-05_JPRB, 0.12919394E-05_JPRB, 0.11897279E-05_JPRB, 0.10779337E-05_JPRB, 0.95960149E-06_JPRB, &
  & 0.86459806E-06_JPRB, 0.78503274E-06_JPRB, 0.75396787E-06_JPRB, 0.74435258E-06_JPRB, 0.74888845E-06_JPRB, 0.74148221E-06_JPRB, &
  & 0.74247481E-06_JPRB, 0.73437792E-06_JPRB, 0.73967595E-06_JPRB, 0.73657714E-06_JPRB, 0.74257434E-06_JPRB, 0.74761908E-06_JPRB, &
  & 0.73869063E-06_JPRB, 0.73876140E-06_JPRB, 0.74459246E-06_JPRB, 0.75827364E-06_JPRB, 0.75166008E-06_JPRB, 0.75027538E-06_JPRB, &
  & 0.74667969E-06_JPRB, 0.75153275E-06_JPRB, 0.76261375E-06_JPRB, 0.75491863E-06_JPRB, 0.74957768E-06_JPRB, 0.74207071E-06_JPRB, &
  & 0.73588075E-06_JPRB, 0.73055725E-06_JPRB, 0.73103615E-06_JPRB, 0.73716103E-06_JPRB, 0.72546032E-06_JPRB, 0.71417611E-06_JPRB, &
  & 0.70117977E-06_JPRB, 0.69058848E-06_JPRB, 0.68410822E-06_JPRB, 0.68332514E-06_JPRB, 0.66712744E-06_JPRB, 0.64992241E-06_JPRB, &
  & 0.63180892E-06_JPRB, 0.61608415E-06_JPRB, 0.60298498E-06_JPRB, 0.59564104E-06_JPRB, 0.58356983E-06_JPRB, 0.57049715E-06_JPRB, &
  & 0.55659729E-06_JPRB, 0.54647001E-06_JPRB, 0.52923207E-06_JPRB, 0.50700822E-06_JPRB, 0.47896577E-06_JPRB, 0.46017755E-06_JPRB, &
  & 0.44901097E-06_JPRB, 0.47020987E-06_JPRB, 0.20622599E-05_JPRB, 0.20571922E-05_JPRB, 0.20064767E-05_JPRB, 0.19315237E-05_JPRB, &
  & 0.18569117E-05_JPRB, 0.17714743E-05_JPRB, 0.16850142E-05_JPRB, 0.15815082E-05_JPRB /)

RGHG7(:, 5,11) = (/ &
  & 0.12319130E-05_JPRB, 0.12213712E-05_JPRB, 0.11506991E-05_JPRB, 0.10760339E-05_JPRB, 0.10284638E-05_JPRB, 0.99207625E-06_JPRB, &
  & 0.94942345E-06_JPRB, 0.91345947E-06_JPRB, 0.93029303E-06_JPRB, 0.95966550E-06_JPRB, 0.98619239E-06_JPRB, 0.99662577E-06_JPRB, &
  & 0.10133185E-05_JPRB, 0.10190114E-05_JPRB, 0.10397565E-05_JPRB, 0.10466470E-05_JPRB, 0.10655039E-05_JPRB, 0.10782680E-05_JPRB, &
  & 0.10741049E-05_JPRB, 0.10802256E-05_JPRB, 0.10998127E-05_JPRB, 0.11198847E-05_JPRB, 0.11128432E-05_JPRB, 0.11155012E-05_JPRB, &
  & 0.11117779E-05_JPRB, 0.11232491E-05_JPRB, 0.11375968E-05_JPRB, 0.11230856E-05_JPRB, 0.11161986E-05_JPRB, 0.11009466E-05_JPRB, &
  & 0.10889503E-05_JPRB, 0.10762351E-05_JPRB, 0.10739828E-05_JPRB, 0.10752449E-05_JPRB, 0.10520197E-05_JPRB, 0.10338771E-05_JPRB, &
  & 0.10120390E-05_JPRB, 0.99547344E-06_JPRB, 0.98641783E-06_JPRB, 0.98334249E-06_JPRB, 0.95837152E-06_JPRB, 0.93932624E-06_JPRB, &
  & 0.91676065E-06_JPRB, 0.90181692E-06_JPRB, 0.89156674E-06_JPRB, 0.88245821E-06_JPRB, 0.85900359E-06_JPRB, 0.82804974E-06_JPRB, &
  & 0.79793324E-06_JPRB, 0.77575669E-06_JPRB, 0.75154554E-06_JPRB, 0.73723771E-06_JPRB, 0.72273787E-06_JPRB, 0.70751685E-06_JPRB, &
  & 0.69116129E-06_JPRB, 0.71793215E-06_JPRB, 0.14706533E-05_JPRB, 0.14890137E-05_JPRB, 0.14989052E-05_JPRB, 0.14949107E-05_JPRB, &
  & 0.14541602E-05_JPRB, 0.14318440E-05_JPRB, 0.14197566E-05_JPRB, 0.14401675E-05_JPRB /)

RGHG7(:, 6,11) = (/ &
  & 0.14782958E-05_JPRB, 0.14658044E-05_JPRB, 0.14051978E-05_JPRB, 0.13360899E-05_JPRB, 0.12560350E-05_JPRB, 0.11855000E-05_JPRB, &
  & 0.11465911E-05_JPRB, 0.11399756E-05_JPRB, 0.11841355E-05_JPRB, 0.12304567E-05_JPRB, 0.12689176E-05_JPRB, 0.12943951E-05_JPRB, &
  & 0.13279312E-05_JPRB, 0.13497622E-05_JPRB, 0.13883167E-05_JPRB, 0.14122232E-05_JPRB, 0.14490432E-05_JPRB, 0.14738541E-05_JPRB, &
  & 0.14794875E-05_JPRB, 0.14876634E-05_JPRB, 0.15135265E-05_JPRB, 0.15322242E-05_JPRB, 0.15223405E-05_JPRB, 0.15175002E-05_JPRB, &
  & 0.15123422E-05_JPRB, 0.15200679E-05_JPRB, 0.15329499E-05_JPRB, 0.15156093E-05_JPRB, 0.15115446E-05_JPRB, 0.14959893E-05_JPRB, &
  & 0.14841789E-05_JPRB, 0.14671775E-05_JPRB, 0.14643291E-05_JPRB, 0.14605852E-05_JPRB, 0.14284424E-05_JPRB, 0.14079471E-05_JPRB, &
  & 0.13827708E-05_JPRB, 0.13667116E-05_JPRB, 0.13595916E-05_JPRB, 0.13560592E-05_JPRB, 0.13189560E-05_JPRB, 0.12915281E-05_JPRB, &
  & 0.12608203E-05_JPRB, 0.12315396E-05_JPRB, 0.12037825E-05_JPRB, 0.11730283E-05_JPRB, 0.11389972E-05_JPRB, 0.11244969E-05_JPRB, &
  & 0.11266204E-05_JPRB, 0.11283807E-05_JPRB, 0.11197811E-05_JPRB, 0.11135031E-05_JPRB, 0.10990475E-05_JPRB, 0.10857566E-05_JPRB, &
  & 0.10836980E-05_JPRB, 0.11226626E-05_JPRB, 0.13987866E-05_JPRB, 0.13675809E-05_JPRB, 0.13490888E-05_JPRB, 0.13447471E-05_JPRB, &
  & 0.13780979E-05_JPRB, 0.14255277E-05_JPRB, 0.14830694E-05_JPRB, 0.16077913E-05_JPRB /)

RGHG7(:, 7,11) = (/ &
  & 0.16366755E-05_JPRB, 0.15819851E-05_JPRB, 0.15311722E-05_JPRB, 0.14952896E-05_JPRB, 0.14850568E-05_JPRB, 0.14823496E-05_JPRB, &
  & 0.14745027E-05_JPRB, 0.14722727E-05_JPRB, 0.15167756E-05_JPRB, 0.15730682E-05_JPRB, 0.16231663E-05_JPRB, 0.16611332E-05_JPRB, &
  & 0.17056143E-05_JPRB, 0.17377541E-05_JPRB, 0.17822545E-05_JPRB, 0.18127535E-05_JPRB, 0.18575001E-05_JPRB, 0.18904976E-05_JPRB, &
  & 0.19100016E-05_JPRB, 0.19291026E-05_JPRB, 0.19684142E-05_JPRB, 0.19933709E-05_JPRB, 0.19961201E-05_JPRB, 0.19952183E-05_JPRB, &
  & 0.19990089E-05_JPRB, 0.20175908E-05_JPRB, 0.20327586E-05_JPRB, 0.20145974E-05_JPRB, 0.20071734E-05_JPRB, 0.19837553E-05_JPRB, &
  & 0.19665667E-05_JPRB, 0.19452762E-05_JPRB, 0.19440533E-05_JPRB, 0.19440913E-05_JPRB, 0.19100196E-05_JPRB, 0.18901354E-05_JPRB, &
  & 0.18620561E-05_JPRB, 0.18454725E-05_JPRB, 0.18401892E-05_JPRB, 0.18380914E-05_JPRB, 0.17992555E-05_JPRB, 0.17677993E-05_JPRB, &
  & 0.17404083E-05_JPRB, 0.17134473E-05_JPRB, 0.16965394E-05_JPRB, 0.16832665E-05_JPRB, 0.16751907E-05_JPRB, 0.16694635E-05_JPRB, &
  & 0.16471392E-05_JPRB, 0.16220963E-05_JPRB, 0.16096128E-05_JPRB, 0.16123784E-05_JPRB, 0.16162340E-05_JPRB, 0.16171260E-05_JPRB, &
  & 0.16196925E-05_JPRB, 0.16170345E-05_JPRB, 0.16353877E-05_JPRB, 0.15816272E-05_JPRB, 0.15886794E-05_JPRB, 0.16298915E-05_JPRB, &
  & 0.16728158E-05_JPRB, 0.17281443E-05_JPRB, 0.17903918E-05_JPRB, 0.19125052E-05_JPRB /)

RGHG7(:, 8,11) = (/ &
  & 0.20370337E-05_JPRB, 0.19944296E-05_JPRB, 0.19504239E-05_JPRB, 0.19030415E-05_JPRB, 0.18539197E-05_JPRB, 0.18165665E-05_JPRB, &
  & 0.18027822E-05_JPRB, 0.18166663E-05_JPRB, 0.18651309E-05_JPRB, 0.19203251E-05_JPRB, 0.19709728E-05_JPRB, 0.20135408E-05_JPRB, &
  & 0.20630337E-05_JPRB, 0.21082033E-05_JPRB, 0.21642568E-05_JPRB, 0.22057218E-05_JPRB, 0.22558320E-05_JPRB, 0.22913164E-05_JPRB, &
  & 0.23182106E-05_JPRB, 0.23445168E-05_JPRB, 0.23906578E-05_JPRB, 0.24192527E-05_JPRB, 0.24323519E-05_JPRB, 0.24384155E-05_JPRB, &
  & 0.24475819E-05_JPRB, 0.24721771E-05_JPRB, 0.24881701E-05_JPRB, 0.24734004E-05_JPRB, 0.24694364E-05_JPRB, 0.24520559E-05_JPRB, &
  & 0.24405454E-05_JPRB, 0.24290919E-05_JPRB, 0.24325238E-05_JPRB, 0.24321964E-05_JPRB, 0.23979378E-05_JPRB, 0.23795928E-05_JPRB, &
  & 0.23529826E-05_JPRB, 0.23373696E-05_JPRB, 0.23334419E-05_JPRB, 0.23299053E-05_JPRB, 0.23016325E-05_JPRB, 0.22734855E-05_JPRB, &
  & 0.22554482E-05_JPRB, 0.22376198E-05_JPRB, 0.22326062E-05_JPRB, 0.22273603E-05_JPRB, 0.22176816E-05_JPRB, 0.22065531E-05_JPRB, &
  & 0.22070637E-05_JPRB, 0.22303407E-05_JPRB, 0.22583736E-05_JPRB, 0.22791833E-05_JPRB, 0.22932338E-05_JPRB, 0.22901984E-05_JPRB, &
  & 0.22612705E-05_JPRB, 0.21722683E-05_JPRB, 0.20985160E-05_JPRB, 0.20268494E-05_JPRB, 0.20130610E-05_JPRB, 0.20306154E-05_JPRB, &
  & 0.20705809E-05_JPRB, 0.21177675E-05_JPRB, 0.21661056E-05_JPRB, 0.22360434E-05_JPRB /)

RGHG7(:, 9,11) = (/ &
  & 0.22797096E-05_JPRB, 0.22274578E-05_JPRB, 0.21929450E-05_JPRB, 0.21763926E-05_JPRB, 0.21772021E-05_JPRB, 0.21866406E-05_JPRB, &
  & 0.21998385E-05_JPRB, 0.22211534E-05_JPRB, 0.22650427E-05_JPRB, 0.23202426E-05_JPRB, 0.23744765E-05_JPRB, 0.24215742E-05_JPRB, &
  & 0.24699148E-05_JPRB, 0.25132897E-05_JPRB, 0.25692432E-05_JPRB, 0.26191444E-05_JPRB, 0.26777957E-05_JPRB, 0.27204012E-05_JPRB, &
  & 0.27559054E-05_JPRB, 0.27935098E-05_JPRB, 0.28501029E-05_JPRB, 0.28891968E-05_JPRB, 0.29170985E-05_JPRB, 0.29401922E-05_JPRB, &
  & 0.29660359E-05_JPRB, 0.30067026E-05_JPRB, 0.30361318E-05_JPRB, 0.30324911E-05_JPRB, 0.30375413E-05_JPRB, 0.30293552E-05_JPRB, &
  & 0.30206647E-05_JPRB, 0.30159840E-05_JPRB, 0.30297961E-05_JPRB, 0.30397562E-05_JPRB, 0.30120698E-05_JPRB, 0.29915941E-05_JPRB, &
  & 0.29604093E-05_JPRB, 0.29424380E-05_JPRB, 0.29385917E-05_JPRB, 0.29310947E-05_JPRB, 0.29125977E-05_JPRB, 0.28928655E-05_JPRB, &
  & 0.28880581E-05_JPRB, 0.28892221E-05_JPRB, 0.29071336E-05_JPRB, 0.29228322E-05_JPRB, 0.29340363E-05_JPRB, 0.29536648E-05_JPRB, &
  & 0.29848484E-05_JPRB, 0.30132514E-05_JPRB, 0.30339443E-05_JPRB, 0.30472306E-05_JPRB, 0.30487849E-05_JPRB, 0.29912037E-05_JPRB, &
  & 0.28620370E-05_JPRB, 0.26793518E-05_JPRB, 0.25779743E-05_JPRB, 0.25223774E-05_JPRB, 0.25281545E-05_JPRB, 0.25465454E-05_JPRB, &
  & 0.25648110E-05_JPRB, 0.25907636E-05_JPRB, 0.26291516E-05_JPRB, 0.26982564E-05_JPRB /)

RGHG7(:,10,11) = (/ &
  & 0.28462850E-05_JPRB, 0.27735925E-05_JPRB, 0.27276603E-05_JPRB, 0.26920552E-05_JPRB, 0.26678499E-05_JPRB, 0.26599421E-05_JPRB, &
  & 0.26713637E-05_JPRB, 0.27040367E-05_JPRB, 0.27566723E-05_JPRB, 0.28165484E-05_JPRB, 0.28737099E-05_JPRB, 0.29276130E-05_JPRB, &
  & 0.29865507E-05_JPRB, 0.30394142E-05_JPRB, 0.30972203E-05_JPRB, 0.31507000E-05_JPRB, 0.32146979E-05_JPRB, 0.32660794E-05_JPRB, &
  & 0.33106353E-05_JPRB, 0.33621925E-05_JPRB, 0.34328771E-05_JPRB, 0.34861323E-05_JPRB, 0.35293192E-05_JPRB, 0.35690437E-05_JPRB, &
  & 0.36094327E-05_JPRB, 0.36639549E-05_JPRB, 0.37030404E-05_JPRB, 0.37054472E-05_JPRB, 0.37114828E-05_JPRB, 0.37074356E-05_JPRB, &
  & 0.37047175E-05_JPRB, 0.37106415E-05_JPRB, 0.37318248E-05_JPRB, 0.37422562E-05_JPRB, 0.37182201E-05_JPRB, 0.37010534E-05_JPRB, &
  & 0.36737079E-05_JPRB, 0.36578529E-05_JPRB, 0.36555573E-05_JPRB, 0.36498066E-05_JPRB, 0.36411366E-05_JPRB, 0.36365313E-05_JPRB, &
  & 0.36509180E-05_JPRB, 0.36796739E-05_JPRB, 0.37213424E-05_JPRB, 0.37564455E-05_JPRB, 0.37875031E-05_JPRB, 0.38206608E-05_JPRB, &
  & 0.38591952E-05_JPRB, 0.38866488E-05_JPRB, 0.39047713E-05_JPRB, 0.38870635E-05_JPRB, 0.38119911E-05_JPRB, 0.36382764E-05_JPRB, &
  & 0.34033915E-05_JPRB, 0.31865729E-05_JPRB, 0.30802794E-05_JPRB, 0.30310075E-05_JPRB, 0.30175204E-05_JPRB, 0.30118413E-05_JPRB, &
  & 0.30182346E-05_JPRB, 0.30349393E-05_JPRB, 0.30461827E-05_JPRB, 0.30642693E-05_JPRB /)

RGHG7(:,11,11) = (/ &
  & 0.35228229E-05_JPRB, 0.34157670E-05_JPRB, 0.33713061E-05_JPRB, 0.33557528E-05_JPRB, 0.33569522E-05_JPRB, 0.33707618E-05_JPRB, &
  & 0.33979418E-05_JPRB, 0.34380489E-05_JPRB, 0.34918783E-05_JPRB, 0.35514640E-05_JPRB, 0.36071290E-05_JPRB, 0.36570636E-05_JPRB, &
  & 0.37105397E-05_JPRB, 0.37637062E-05_JPRB, 0.38222111E-05_JPRB, 0.38764506E-05_JPRB, 0.39416091E-05_JPRB, 0.39964198E-05_JPRB, &
  & 0.40460095E-05_JPRB, 0.41058338E-05_JPRB, 0.41864378E-05_JPRB, 0.42495590E-05_JPRB, 0.43032483E-05_JPRB, 0.43537493E-05_JPRB, &
  & 0.44029907E-05_JPRB, 0.44666799E-05_JPRB, 0.45110896E-05_JPRB, 0.45213715E-05_JPRB, 0.45323163E-05_JPRB, 0.45329612E-05_JPRB, &
  & 0.45266620E-05_JPRB, 0.45240554E-05_JPRB, 0.45395100E-05_JPRB, 0.45444140E-05_JPRB, 0.45194615E-05_JPRB, 0.45017691E-05_JPRB, &
  & 0.44778517E-05_JPRB, 0.44686335E-05_JPRB, 0.44753028E-05_JPRB, 0.44866651E-05_JPRB, 0.45031602E-05_JPRB, 0.45250126E-05_JPRB, &
  & 0.45601455E-05_JPRB, 0.46077380E-05_JPRB, 0.46667383E-05_JPRB, 0.47081758E-05_JPRB, 0.47370727E-05_JPRB, 0.47540907E-05_JPRB, &
  & 0.47596950E-05_JPRB, 0.47394838E-05_JPRB, 0.46805485E-05_JPRB, 0.45565175E-05_JPRB, 0.43638820E-05_JPRB, 0.40982418E-05_JPRB, &
  & 0.38268900E-05_JPRB, 0.36290282E-05_JPRB, 0.35443272E-05_JPRB, 0.35077408E-05_JPRB, 0.34888178E-05_JPRB, 0.34700936E-05_JPRB, &
  & 0.34641450E-05_JPRB, 0.34679269E-05_JPRB, 0.34607785E-05_JPRB, 0.34761647E-05_JPRB /)

RGHG7(:,12,11) = (/ &
  & 0.42806323E-05_JPRB, 0.42221122E-05_JPRB, 0.41879607E-05_JPRB, 0.41652488E-05_JPRB, 0.41585067E-05_JPRB, 0.41693479E-05_JPRB, &
  & 0.41983294E-05_JPRB, 0.42476904E-05_JPRB, 0.43173341E-05_JPRB, 0.43900777E-05_JPRB, 0.44551139E-05_JPRB, 0.45124916E-05_JPRB, &
  & 0.45722563E-05_JPRB, 0.46312216E-05_JPRB, 0.46976866E-05_JPRB, 0.47625149E-05_JPRB, 0.48390029E-05_JPRB, 0.49068694E-05_JPRB, &
  & 0.49720047E-05_JPRB, 0.50467356E-05_JPRB, 0.51427251E-05_JPRB, 0.52189580E-05_JPRB, 0.52854643E-05_JPRB, 0.53460735E-05_JPRB, &
  & 0.54047755E-05_JPRB, 0.54765287E-05_JPRB, 0.55259375E-05_JPRB, 0.55400747E-05_JPRB, 0.55439791E-05_JPRB, 0.55372702E-05_JPRB, &
  & 0.55228975E-05_JPRB, 0.55105852E-05_JPRB, 0.55116193E-05_JPRB, 0.55010255E-05_JPRB, 0.54636903E-05_JPRB, 0.54302300E-05_JPRB, &
  & 0.53960157E-05_JPRB, 0.53880831E-05_JPRB, 0.54027246E-05_JPRB, 0.54146103E-05_JPRB, 0.54280854E-05_JPRB, 0.54472889E-05_JPRB, &
  & 0.54747993E-05_JPRB, 0.55070109E-05_JPRB, 0.55413188E-05_JPRB, 0.55477553E-05_JPRB, 0.55292135E-05_JPRB, 0.54904785E-05_JPRB, &
  & 0.54274547E-05_JPRB, 0.53237268E-05_JPRB, 0.51737497E-05_JPRB, 0.49563942E-05_JPRB, 0.46936966E-05_JPRB, 0.44052899E-05_JPRB, &
  & 0.41527264E-05_JPRB, 0.39813422E-05_JPRB, 0.39054949E-05_JPRB, 0.38595767E-05_JPRB, 0.38262642E-05_JPRB, 0.38006519E-05_JPRB, &
  & 0.37885588E-05_JPRB, 0.37880004E-05_JPRB, 0.37651973E-05_JPRB, 0.37817845E-05_JPRB /)

RGHG7(:,13,11) = (/ &
  & 0.46980581E-05_JPRB, 0.46720556E-05_JPRB, 0.46829782E-05_JPRB, 0.47111280E-05_JPRB, 0.47502758E-05_JPRB, 0.48029246E-05_JPRB, &
  & 0.48724728E-05_JPRB, 0.49610067E-05_JPRB, 0.50698723E-05_JPRB, 0.51770235E-05_JPRB, 0.52726259E-05_JPRB, 0.53567078E-05_JPRB, &
  & 0.54394723E-05_JPRB, 0.55194782E-05_JPRB, 0.56057952E-05_JPRB, 0.56900381E-05_JPRB, 0.57843440E-05_JPRB, 0.58695027E-05_JPRB, &
  & 0.59536264E-05_JPRB, 0.60454222E-05_JPRB, 0.61552696E-05_JPRB, 0.62429986E-05_JPRB, 0.63157536E-05_JPRB, 0.63789389E-05_JPRB, &
  & 0.64370533E-05_JPRB, 0.65037557E-05_JPRB, 0.65464346E-05_JPRB, 0.65559670E-05_JPRB, 0.65525041E-05_JPRB, 0.65309205E-05_JPRB, &
  & 0.64948845E-05_JPRB, 0.64553883E-05_JPRB, 0.64351771E-05_JPRB, 0.63935540E-05_JPRB, 0.63358348E-05_JPRB, 0.63007378E-05_JPRB, &
  & 0.62745721E-05_JPRB, 0.62601953E-05_JPRB, 0.62578356E-05_JPRB, 0.62469585E-05_JPRB, 0.62306362E-05_JPRB, 0.62095037E-05_JPRB, &
  & 0.61843070E-05_JPRB, 0.61509713E-05_JPRB, 0.61106639E-05_JPRB, 0.60417042E-05_JPRB, 0.59497411E-05_JPRB, 0.58379169E-05_JPRB, &
  & 0.57058792E-05_JPRB, 0.55381224E-05_JPRB, 0.53401104E-05_JPRB, 0.51028519E-05_JPRB, 0.48489064E-05_JPRB, 0.45995571E-05_JPRB, &
  & 0.43892505E-05_JPRB, 0.42434217E-05_JPRB, 0.41825733E-05_JPRB, 0.41479029E-05_JPRB, 0.41219191E-05_JPRB, 0.41014482E-05_JPRB, &
  & 0.40842224E-05_JPRB, 0.40858749E-05_JPRB, 0.40521077E-05_JPRB, 0.40638520E-05_JPRB /)

RGHG7(:,14,11) = (/ &
  & 0.49753453E-05_JPRB, 0.50101958E-05_JPRB, 0.50491512E-05_JPRB, 0.51006882E-05_JPRB, 0.51689722E-05_JPRB, 0.52550545E-05_JPRB, &
  & 0.53613135E-05_JPRB, 0.54929683E-05_JPRB, 0.56532722E-05_JPRB, 0.58111118E-05_JPRB, 0.59542285E-05_JPRB, 0.60827656E-05_JPRB, &
  & 0.62062786E-05_JPRB, 0.63231905E-05_JPRB, 0.64449846E-05_JPRB, 0.65639460E-05_JPRB, 0.66895022E-05_JPRB, 0.68040795E-05_JPRB, &
  & 0.69138778E-05_JPRB, 0.70264623E-05_JPRB, 0.71505856E-05_JPRB, 0.72494622E-05_JPRB, 0.73266747E-05_JPRB, 0.73865167E-05_JPRB, &
  & 0.74350696E-05_JPRB, 0.74829004E-05_JPRB, 0.75022313E-05_JPRB, 0.74849622E-05_JPRB, 0.74416616E-05_JPRB, 0.73844949E-05_JPRB, &
  & 0.73142151E-05_JPRB, 0.72462253E-05_JPRB, 0.71852005E-05_JPRB, 0.71303152E-05_JPRB, 0.70765436E-05_JPRB, 0.70298165E-05_JPRB, &
  & 0.69862876E-05_JPRB, 0.69511984E-05_JPRB, 0.69251309E-05_JPRB, 0.68836730E-05_JPRB, 0.68283803E-05_JPRB, 0.67585493E-05_JPRB, &
  & 0.66760063E-05_JPRB, 0.65790100E-05_JPRB, 0.64681581E-05_JPRB, 0.63328371E-05_JPRB, 0.61770070E-05_JPRB, 0.60041862E-05_JPRB, &
  & 0.58180935E-05_JPRB, 0.56111212E-05_JPRB, 0.53921835E-05_JPRB, 0.51581815E-05_JPRB, 0.49275613E-05_JPRB, 0.47128847E-05_JPRB, &
  & 0.45339425E-05_JPRB, 0.44083299E-05_JPRB, 0.43468899E-05_JPRB, 0.43113105E-05_JPRB, 0.42815577E-05_JPRB, 0.42577099E-05_JPRB, &
  & 0.42352513E-05_JPRB, 0.42286065E-05_JPRB, 0.42090637E-05_JPRB, 0.41942235E-05_JPRB /)

RGHG7(:,15,11) = (/ &
  & 0.50621775E-05_JPRB, 0.51209972E-05_JPRB, 0.51886309E-05_JPRB, 0.52717751E-05_JPRB, 0.53730168E-05_JPRB, 0.54961197E-05_JPRB, &
  & 0.56446474E-05_JPRB, 0.58224432E-05_JPRB, 0.60325201E-05_JPRB, 0.62403165E-05_JPRB, 0.64317733E-05_JPRB, 0.66058292E-05_JPRB, &
  & 0.67714077E-05_JPRB, 0.69256789E-05_JPRB, 0.70794858E-05_JPRB, 0.72299613E-05_JPRB, 0.73844053E-05_JPRB, 0.75291864E-05_JPRB, &
  & 0.76664337E-05_JPRB, 0.78013381E-05_JPRB, 0.79389238E-05_JPRB, 0.80476530E-05_JPRB, 0.81275721E-05_JPRB, 0.81819453E-05_JPRB, &
  & 0.82168472E-05_JPRB, 0.82426777E-05_JPRB, 0.82350252E-05_JPRB, 0.81904946E-05_JPRB, 0.81239741E-05_JPRB, 0.80344298E-05_JPRB, &
  & 0.79385436E-05_JPRB, 0.78467774E-05_JPRB, 0.77929408E-05_JPRB, 0.77325703E-05_JPRB, 0.76642236E-05_JPRB, 0.76046854E-05_JPRB, &
  & 0.75503249E-05_JPRB, 0.74984519E-05_JPRB, 0.74482214E-05_JPRB, 0.73778810E-05_JPRB, 0.72879839E-05_JPRB, 0.71788904E-05_JPRB, &
  & 0.70497995E-05_JPRB, 0.69029902E-05_JPRB, 0.67445412E-05_JPRB, 0.65667405E-05_JPRB, 0.63730658E-05_JPRB, 0.61668447E-05_JPRB, &
  & 0.59527206E-05_JPRB, 0.57287812E-05_JPRB, 0.55022970E-05_JPRB, 0.52750365E-05_JPRB, 0.50594435E-05_JPRB, 0.48628349E-05_JPRB, &
  & 0.46982136E-05_JPRB, 0.45941547E-05_JPRB, 0.45402157E-05_JPRB, 0.45055995E-05_JPRB, 0.44713138E-05_JPRB, 0.44419135E-05_JPRB, &
  & 0.44210151E-05_JPRB, 0.44072376E-05_JPRB, 0.43991563E-05_JPRB, 0.43784780E-05_JPRB /)

RGHG7(:,16,11) = (/ &
  & 0.50473154E-05_JPRB, 0.51228544E-05_JPRB, 0.51992570E-05_JPRB, 0.52931077E-05_JPRB, 0.54097800E-05_JPRB, 0.55525711E-05_JPRB, &
  & 0.57247694E-05_JPRB, 0.59311469E-05_JPRB, 0.61747241E-05_JPRB, 0.64207302E-05_JPRB, 0.66538269E-05_JPRB, 0.68704103E-05_JPRB, &
  & 0.70779242E-05_JPRB, 0.72742610E-05_JPRB, 0.74668064E-05_JPRB, 0.76532933E-05_JPRB, 0.78412204E-05_JPRB, 0.80170184E-05_JPRB, &
  & 0.81821900E-05_JPRB, 0.83382738E-05_JPRB, 0.84881876E-05_JPRB, 0.86041564E-05_JPRB, 0.86860582E-05_JPRB, 0.87358803E-05_JPRB, &
  & 0.87571098E-05_JPRB, 0.87578710E-05_JPRB, 0.87191856E-05_JPRB, 0.86464333E-05_JPRB, 0.85470010E-05_JPRB, 0.84430267E-05_JPRB, &
  & 0.83390678E-05_JPRB, 0.82541974E-05_JPRB, 0.81854832E-05_JPRB, 0.81173894E-05_JPRB, 0.80508871E-05_JPRB, 0.79836709E-05_JPRB, &
  & 0.79131560E-05_JPRB, 0.78397088E-05_JPRB, 0.77633713E-05_JPRB, 0.76650231E-05_JPRB, 0.75462299E-05_JPRB, 0.74050522E-05_JPRB, &
  & 0.72439684E-05_JPRB, 0.70683068E-05_JPRB, 0.68843992E-05_JPRB, 0.66876164E-05_JPRB, 0.64806554E-05_JPRB, 0.62673384E-05_JPRB, &
  & 0.60515094E-05_JPRB, 0.58342307E-05_JPRB, 0.56197796E-05_JPRB, 0.54094203E-05_JPRB, 0.52084838E-05_JPRB, 0.50235576E-05_JPRB, &
  & 0.48686693E-05_JPRB, 0.47711765E-05_JPRB, 0.47145541E-05_JPRB, 0.46745995E-05_JPRB, 0.46359360E-05_JPRB, 0.46023870E-05_JPRB, &
  & 0.45787588E-05_JPRB, 0.45602847E-05_JPRB, 0.45294278E-05_JPRB, 0.44885628E-05_JPRB /)

RGHG7(:,17,11) = (/ &
  & 0.50586068E-05_JPRB, 0.51346196E-05_JPRB, 0.52152059E-05_JPRB, 0.53148192E-05_JPRB, 0.54394950E-05_JPRB, 0.55941455E-05_JPRB, &
  & 0.57827897E-05_JPRB, 0.60084376E-05_JPRB, 0.62728845E-05_JPRB, 0.65426775E-05_JPRB, 0.68024315E-05_JPRB, 0.70469951E-05_JPRB, &
  & 0.72808816E-05_JPRB, 0.75030871E-05_JPRB, 0.77207924E-05_JPRB, 0.79309048E-05_JPRB, 0.81398275E-05_JPRB, 0.83365330E-05_JPRB, &
  & 0.85199426E-05_JPRB, 0.86902946E-05_JPRB, 0.88495681E-05_JPRB, 0.89741807E-05_JPRB, 0.90608573E-05_JPRB, 0.91121810E-05_JPRB, &
  & 0.91304119E-05_JPRB, 0.91234888E-05_JPRB, 0.90753992E-05_JPRB, 0.89923369E-05_JPRB, 0.88908300E-05_JPRB, 0.87789203E-05_JPRB, &
  & 0.86728151E-05_JPRB, 0.85795255E-05_JPRB, 0.85121455E-05_JPRB, 0.84468211E-05_JPRB, 0.83798604E-05_JPRB, 0.83076538E-05_JPRB, &
  & 0.82276974E-05_JPRB, 0.81374374E-05_JPRB, 0.80391073E-05_JPRB, 0.79166011E-05_JPRB, 0.77727846E-05_JPRB, 0.76064734E-05_JPRB, &
  & 0.74241707E-05_JPRB, 0.72320286E-05_JPRB, 0.70359865E-05_JPRB, 0.68332738E-05_JPRB, 0.66254115E-05_JPRB, 0.64146748E-05_JPRB, &
  & 0.62028835E-05_JPRB, 0.59902231E-05_JPRB, 0.57797688E-05_JPRB, 0.55726600E-05_JPRB, 0.53760227E-05_JPRB, 0.51945972E-05_JPRB, &
  & 0.50514450E-05_JPRB, 0.49571308E-05_JPRB, 0.48989127E-05_JPRB, 0.48533348E-05_JPRB, 0.48131101E-05_JPRB, 0.47775193E-05_JPRB, &
  & 0.47434819E-05_JPRB, 0.47141170E-05_JPRB, 0.46997766E-05_JPRB, 0.46785267E-05_JPRB /)

RGHG7(:,18,11) = (/ &
  & 0.50653312E-05_JPRB, 0.51372490E-05_JPRB, 0.52145547E-05_JPRB, 0.53107015E-05_JPRB, 0.54331431E-05_JPRB, 0.55872542E-05_JPRB, &
  & 0.57768802E-05_JPRB, 0.60052917E-05_JPRB, 0.62725321E-05_JPRB, 0.65480904E-05_JPRB, 0.68165223E-05_JPRB, 0.70718638E-05_JPRB, &
  & 0.73168553E-05_JPRB, 0.75493890E-05_JPRB, 0.77759187E-05_JPRB, 0.79949523E-05_JPRB, 0.82098240E-05_JPRB, 0.84122275E-05_JPRB, &
  & 0.86008786E-05_JPRB, 0.87758117E-05_JPRB, 0.89387904E-05_JPRB, 0.90726408E-05_JPRB, 0.91724969E-05_JPRB, 0.92391410E-05_JPRB, &
  & 0.92731534E-05_JPRB, 0.92813652E-05_JPRB, 0.92509599E-05_JPRB, 0.91902739E-05_JPRB, 0.91114043E-05_JPRB, 0.90236945E-05_JPRB, &
  & 0.89308860E-05_JPRB, 0.88497300E-05_JPRB, 0.87804383E-05_JPRB, 0.87059634E-05_JPRB, 0.86231921E-05_JPRB, 0.85305674E-05_JPRB, &
  & 0.84273152E-05_JPRB, 0.83145396E-05_JPRB, 0.81925318E-05_JPRB, 0.80489935E-05_JPRB, 0.78883422E-05_JPRB, 0.77100267E-05_JPRB, &
  & 0.75213607E-05_JPRB, 0.73284868E-05_JPRB, 0.71352601E-05_JPRB, 0.69402968E-05_JPRB, 0.67433034E-05_JPRB, 0.65453055E-05_JPRB, &
  & 0.63474581E-05_JPRB, 0.61477385E-05_JPRB, 0.59480558E-05_JPRB, 0.57489538E-05_JPRB, 0.55544488E-05_JPRB, 0.53803178E-05_JPRB, &
  & 0.52494229E-05_JPRB, 0.51597135E-05_JPRB, 0.50984122E-05_JPRB, 0.50416293E-05_JPRB, 0.49879482E-05_JPRB, 0.49457149E-05_JPRB, &
  & 0.49163937E-05_JPRB, 0.48958327E-05_JPRB, 0.48720221E-05_JPRB, 0.48208744E-05_JPRB /)

RGHG7(:,19,11) = (/ &
  & 0.50853168E-05_JPRB, 0.51498369E-05_JPRB, 0.52213245E-05_JPRB, 0.53092740E-05_JPRB, 0.54239181E-05_JPRB, 0.55694463E-05_JPRB, &
  & 0.57506359E-05_JPRB, 0.59683525E-05_JPRB, 0.62219574E-05_JPRB, 0.64840483E-05_JPRB, 0.67404972E-05_JPRB, 0.69852094E-05_JPRB, &
  & 0.72197990E-05_JPRB, 0.74426780E-05_JPRB, 0.76579317E-05_JPRB, 0.78644889E-05_JPRB, 0.80662294E-05_JPRB, 0.82548968E-05_JPRB, &
  & 0.84321664E-05_JPRB, 0.85996817E-05_JPRB, 0.87602584E-05_JPRB, 0.89010618E-05_JPRB, 0.90206604E-05_JPRB, 0.91159618E-05_JPRB, &
  & 0.91853690E-05_JPRB, 0.92314895E-05_JPRB, 0.92382397E-05_JPRB, 0.92148175E-05_JPRB, 0.91668498E-05_JPRB, 0.91006277E-05_JPRB, &
  & 0.90326548E-05_JPRB, 0.89617370E-05_JPRB, 0.88915285E-05_JPRB, 0.88063507E-05_JPRB, 0.87071949E-05_JPRB, 0.85935753E-05_JPRB, &
  & 0.84704334E-05_JPRB, 0.83335954E-05_JPRB, 0.81918170E-05_JPRB, 0.80362342E-05_JPRB, 0.78679132E-05_JPRB, 0.76912884E-05_JPRB, &
  & 0.75101798E-05_JPRB, 0.73290062E-05_JPRB, 0.71514401E-05_JPRB, 0.69736116E-05_JPRB, 0.67957676E-05_JPRB, 0.66171801E-05_JPRB, &
  & 0.64373899E-05_JPRB, 0.62536355E-05_JPRB, 0.60663115E-05_JPRB, 0.58762475E-05_JPRB, 0.56970662E-05_JPRB, 0.55428973E-05_JPRB, &
  & 0.54242014E-05_JPRB, 0.53379431E-05_JPRB, 0.52716923E-05_JPRB, 0.52147961E-05_JPRB, 0.51645829E-05_JPRB, 0.51195107E-05_JPRB, &
  & 0.50800377E-05_JPRB, 0.50483050E-05_JPRB, 0.50152289E-05_JPRB, 0.49835367E-05_JPRB /)

RGHG7(:,20,11) = (/ &
  & 0.51033203E-05_JPRB, 0.51638258E-05_JPRB, 0.52258279E-05_JPRB, 0.53037325E-05_JPRB, 0.54055035E-05_JPRB, 0.55361129E-05_JPRB, &
  & 0.56983063E-05_JPRB, 0.58929395E-05_JPRB, 0.61167443E-05_JPRB, 0.63467310E-05_JPRB, 0.65708855E-05_JPRB, 0.67838546E-05_JPRB, &
  & 0.69869448E-05_JPRB, 0.71785275E-05_JPRB, 0.73626238E-05_JPRB, 0.75379462E-05_JPRB, 0.77086552E-05_JPRB, 0.78704461E-05_JPRB, &
  & 0.80244272E-05_JPRB, 0.81753224E-05_JPRB, 0.83282421E-05_JPRB, 0.84732346E-05_JPRB, 0.86108794E-05_JPRB, 0.87377948E-05_JPRB, &
  & 0.88481711E-05_JPRB, 0.89373161E-05_JPRB, 0.89912337E-05_JPRB, 0.90123594E-05_JPRB, 0.89987143E-05_JPRB, 0.89644273E-05_JPRB, &
  & 0.89098448E-05_JPRB, 0.88430925E-05_JPRB, 0.87686221E-05_JPRB, 0.86772216E-05_JPRB, 0.85652327E-05_JPRB, 0.84406911E-05_JPRB, &
  & 0.83008799E-05_JPRB, 0.81496073E-05_JPRB, 0.79988222E-05_JPRB, 0.78345847E-05_JPRB, 0.76734132E-05_JPRB, 0.75087619E-05_JPRB, &
  & 0.73487008E-05_JPRB, 0.71901982E-05_JPRB, 0.70368765E-05_JPRB, 0.68852887E-05_JPRB, 0.67326419E-05_JPRB, 0.65785321E-05_JPRB, &
  & 0.64214851E-05_JPRB, 0.62591516E-05_JPRB, 0.60917309E-05_JPRB, 0.59230792E-05_JPRB, 0.57671555E-05_JPRB, 0.56392796E-05_JPRB, &
  & 0.55405399E-05_JPRB, 0.54658194E-05_JPRB, 0.54051102E-05_JPRB, 0.53489334E-05_JPRB, 0.52968530E-05_JPRB, 0.52509881E-05_JPRB, &
  & 0.52131923E-05_JPRB, 0.51804591E-05_JPRB, 0.51582865E-05_JPRB, 0.51112384E-05_JPRB /)

RGHG7(:,21,11) = (/ &
  & 0.50854460E-05_JPRB, 0.51357661E-05_JPRB, 0.51855031E-05_JPRB, 0.52496766E-05_JPRB, 0.53345257E-05_JPRB, 0.54432317E-05_JPRB, &
  & 0.55784762E-05_JPRB, 0.57388961E-05_JPRB, 0.59214517E-05_JPRB, 0.61070768E-05_JPRB, 0.62865356E-05_JPRB, 0.64557571E-05_JPRB, &
  & 0.66164271E-05_JPRB, 0.67683632E-05_JPRB, 0.69132734E-05_JPRB, 0.70511423E-05_JPRB, 0.71851091E-05_JPRB, 0.73137790E-05_JPRB, &
  & 0.74406503E-05_JPRB, 0.75694097E-05_JPRB, 0.77057512E-05_JPRB, 0.78450084E-05_JPRB, 0.79870342E-05_JPRB, 0.81280832E-05_JPRB, &
  & 0.82601200E-05_JPRB, 0.83743535E-05_JPRB, 0.84547910E-05_JPRB, 0.84975354E-05_JPRB, 0.85088714E-05_JPRB, 0.84894509E-05_JPRB, &
  & 0.84459689E-05_JPRB, 0.83882524E-05_JPRB, 0.83206605E-05_JPRB, 0.82391389E-05_JPRB, 0.81372154E-05_JPRB, 0.80202399E-05_JPRB, &
  & 0.78852754E-05_JPRB, 0.77380228E-05_JPRB, 0.75848479E-05_JPRB, 0.74321301E-05_JPRB, 0.72771663E-05_JPRB, 0.71380168E-05_JPRB, &
  & 0.70034257E-05_JPRB, 0.68731965E-05_JPRB, 0.67533988E-05_JPRB, 0.66313687E-05_JPRB, 0.65088575E-05_JPRB, 0.63850348E-05_JPRB, &
  & 0.62553745E-05_JPRB, 0.61192891E-05_JPRB, 0.59787776E-05_JPRB, 0.58438532E-05_JPRB, 0.57279635E-05_JPRB, 0.56338840E-05_JPRB, &
  & 0.55602763E-05_JPRB, 0.55029805E-05_JPRB, 0.54544003E-05_JPRB, 0.54092802E-05_JPRB, 0.53662634E-05_JPRB, 0.53265821E-05_JPRB, &
  & 0.52919936E-05_JPRB, 0.52656010E-05_JPRB, 0.52363175E-05_JPRB, 0.52041923E-05_JPRB /)

RGHG7(:,22,11) = (/ &
  & 0.50047875E-05_JPRB, 0.50371900E-05_JPRB, 0.50743647E-05_JPRB, 0.51239776E-05_JPRB, 0.51903039E-05_JPRB, 0.52758805E-05_JPRB, &
  & 0.53811009E-05_JPRB, 0.55047162E-05_JPRB, 0.56429385E-05_JPRB, 0.57815191E-05_JPRB, 0.59134600E-05_JPRB, 0.60362463E-05_JPRB, &
  & 0.61512851E-05_JPRB, 0.62600207E-05_JPRB, 0.63655443E-05_JPRB, 0.64667283E-05_JPRB, 0.65658364E-05_JPRB, 0.66620564E-05_JPRB, &
  & 0.67589890E-05_JPRB, 0.68604595E-05_JPRB, 0.69703615E-05_JPRB, 0.70856545E-05_JPRB, 0.72083903E-05_JPRB, 0.73367537E-05_JPRB, &
  & 0.74612458E-05_JPRB, 0.75702878E-05_JPRB, 0.76485776E-05_JPRB, 0.76919241E-05_JPRB, 0.77052619E-05_JPRB, 0.76921724E-05_JPRB, &
  & 0.76611432E-05_JPRB, 0.76238757E-05_JPRB, 0.75836369E-05_JPRB, 0.75309536E-05_JPRB, 0.74622199E-05_JPRB, 0.73748379E-05_JPRB, &
  & 0.72628200E-05_JPRB, 0.71338673E-05_JPRB, 0.69963271E-05_JPRB, 0.68550744E-05_JPRB, 0.67208089E-05_JPRB, 0.65992831E-05_JPRB, &
  & 0.64962637E-05_JPRB, 0.63969419E-05_JPRB, 0.63085745E-05_JPRB, 0.62247400E-05_JPRB, 0.61358128E-05_JPRB, 0.60446209E-05_JPRB, &
  & 0.59480813E-05_JPRB, 0.58454357E-05_JPRB, 0.57414859E-05_JPRB, 0.56457984E-05_JPRB, 0.55659921E-05_JPRB, 0.55039077E-05_JPRB, &
  & 0.54574798E-05_JPRB, 0.54225816E-05_JPRB, 0.53938807E-05_JPRB, 0.53656731E-05_JPRB, 0.53376066E-05_JPRB, 0.53104477E-05_JPRB, &
  & 0.52864002E-05_JPRB, 0.52650935E-05_JPRB, 0.52492296E-05_JPRB, 0.52297582E-05_JPRB /)

RGHG7(:,23,11) = (/ &
  & 0.48363654E-05_JPRB, 0.48344614E-05_JPRB, 0.48561419E-05_JPRB, 0.48886973E-05_JPRB, 0.49362079E-05_JPRB, 0.49982323E-05_JPRB, &
  & 0.50744752E-05_JPRB, 0.51627339E-05_JPRB, 0.52598193E-05_JPRB, 0.53555400E-05_JPRB, 0.54451980E-05_JPRB, 0.55280379E-05_JPRB, &
  & 0.56052836E-05_JPRB, 0.56788635E-05_JPRB, 0.57520961E-05_JPRB, 0.58255278E-05_JPRB, 0.58991059E-05_JPRB, 0.59702033E-05_JPRB, &
  & 0.60403800E-05_JPRB, 0.61118899E-05_JPRB, 0.61872825E-05_JPRB, 0.62653994E-05_JPRB, 0.63477314E-05_JPRB, 0.64335159E-05_JPRB, &
  & 0.65196473E-05_JPRB, 0.65979325E-05_JPRB, 0.66545599E-05_JPRB, 0.66861658E-05_JPRB, 0.66970642E-05_JPRB, 0.66944140E-05_JPRB, &
  & 0.66834696E-05_JPRB, 0.66735515E-05_JPRB, 0.66667985E-05_JPRB, 0.66540474E-05_JPRB, 0.66246716E-05_JPRB, 0.65771819E-05_JPRB, &
  & 0.64982537E-05_JPRB, 0.63976590E-05_JPRB, 0.62816407E-05_JPRB, 0.61605615E-05_JPRB, 0.60496841E-05_JPRB, 0.59491617E-05_JPRB, &
  & 0.58691744E-05_JPRB, 0.58033388E-05_JPRB, 0.57447915E-05_JPRB, 0.56932158E-05_JPRB, 0.56422700E-05_JPRB, 0.55872015E-05_JPRB, &
  & 0.55277342E-05_JPRB, 0.54613174E-05_JPRB, 0.53975409E-05_JPRB, 0.53423651E-05_JPRB, 0.52989403E-05_JPRB, 0.52678670E-05_JPRB, &
  & 0.52477158E-05_JPRB, 0.52357850E-05_JPRB, 0.52275277E-05_JPRB, 0.52187911E-05_JPRB, 0.52088735E-05_JPRB, 0.51979173E-05_JPRB, &
  & 0.51876677E-05_JPRB, 0.51793995E-05_JPRB, 0.51765232E-05_JPRB, 0.51797920E-05_JPRB /)

RGHG7(:,24,11) = (/ &
  & 0.45485003E-05_JPRB, 0.45018169E-05_JPRB, 0.45027232E-05_JPRB, 0.45193174E-05_JPRB, 0.45503848E-05_JPRB, 0.45942197E-05_JPRB, &
  & 0.46488249E-05_JPRB, 0.47119361E-05_JPRB, 0.47803960E-05_JPRB, 0.48471647E-05_JPRB, 0.49092987E-05_JPRB, 0.49666128E-05_JPRB, &
  & 0.50207213E-05_JPRB, 0.50724720E-05_JPRB, 0.51255611E-05_JPRB, 0.51797347E-05_JPRB, 0.52352761E-05_JPRB, 0.52888809E-05_JPRB, &
  & 0.53376421E-05_JPRB, 0.53809035E-05_JPRB, 0.54190718E-05_JPRB, 0.54514157E-05_JPRB, 0.54810062E-05_JPRB, 0.55123328E-05_JPRB, &
  & 0.55474088E-05_JPRB, 0.55817527E-05_JPRB, 0.56092008E-05_JPRB, 0.56272120E-05_JPRB, 0.56380359E-05_JPRB, 0.56460849E-05_JPRB, &
  & 0.56558574E-05_JPRB, 0.56743042E-05_JPRB, 0.56990866E-05_JPRB, 0.57230764E-05_JPRB, 0.57326583E-05_JPRB, 0.57183083E-05_JPRB, &
  & 0.56751469E-05_JPRB, 0.56050717E-05_JPRB, 0.55157802E-05_JPRB, 0.54194029E-05_JPRB, 0.53285648E-05_JPRB, 0.52522987E-05_JPRB, &
  & 0.51933225E-05_JPRB, 0.51543830E-05_JPRB, 0.51278262E-05_JPRB, 0.51071452E-05_JPRB, 0.50897165E-05_JPRB, 0.50677149E-05_JPRB, &
  & 0.50439176E-05_JPRB, 0.50162021E-05_JPRB, 0.49906280E-05_JPRB, 0.49691780E-05_JPRB, 0.49554556E-05_JPRB, 0.49500718E-05_JPRB, &
  & 0.49528153E-05_JPRB, 0.49619011E-05_JPRB, 0.49735108E-05_JPRB, 0.49843511E-05_JPRB, 0.49934483E-05_JPRB, 0.50006120E-05_JPRB, &
  & 0.50068029E-05_JPRB, 0.50154185E-05_JPRB, 0.50275594E-05_JPRB, 0.50649855E-05_JPRB /)

RGHG7(:,25,11) = (/ &
  & 0.41244434E-05_JPRB, 0.40354798E-05_JPRB, 0.40164678E-05_JPRB, 0.40212362E-05_JPRB, 0.40427626E-05_JPRB, 0.40773457E-05_JPRB, &
  & 0.41219600E-05_JPRB, 0.41735029E-05_JPRB, 0.42288261E-05_JPRB, 0.42826600E-05_JPRB, 0.43332989E-05_JPRB, 0.43807299E-05_JPRB, &
  & 0.44267426E-05_JPRB, 0.44719991E-05_JPRB, 0.45181705E-05_JPRB, 0.45647839E-05_JPRB, 0.46099972E-05_JPRB, 0.46496530E-05_JPRB, &
  & 0.46807199E-05_JPRB, 0.46994987E-05_JPRB, 0.47035601E-05_JPRB, 0.46933146E-05_JPRB, 0.46742102E-05_JPRB, 0.46535170E-05_JPRB, &
  & 0.46384698E-05_JPRB, 0.46311643E-05_JPRB, 0.46297182E-05_JPRB, 0.46340379E-05_JPRB, 0.46454929E-05_JPRB, 0.46649520E-05_JPRB, &
  & 0.46947180E-05_JPRB, 0.47358403E-05_JPRB, 0.47835010E-05_JPRB, 0.48290094E-05_JPRB, 0.48642187E-05_JPRB, 0.48754246E-05_JPRB, &
  & 0.48584975E-05_JPRB, 0.48162733E-05_JPRB, 0.47527556E-05_JPRB, 0.46827568E-05_JPRB, 0.46152963E-05_JPRB, 0.45625247E-05_JPRB, &
  & 0.45257684E-05_JPRB, 0.45088605E-05_JPRB, 0.45080633E-05_JPRB, 0.45162328E-05_JPRB, 0.45292218E-05_JPRB, 0.45400993E-05_JPRB, &
  & 0.45478910E-05_JPRB, 0.45514948E-05_JPRB, 0.45563638E-05_JPRB, 0.45631723E-05_JPRB, 0.45738752E-05_JPRB, 0.45891597E-05_JPRB, &
  & 0.46098921E-05_JPRB, 0.46356008E-05_JPRB, 0.46635278E-05_JPRB, 0.46907312E-05_JPRB, 0.47162944E-05_JPRB, 0.47401154E-05_JPRB, &
  & 0.47634371E-05_JPRB, 0.47877402E-05_JPRB, 0.48219022E-05_JPRB, 0.48912216E-05_JPRB /)

RGHG7(:,26,11) = (/ &
  & 0.35837027E-05_JPRB, 0.34595703E-05_JPRB, 0.34283662E-05_JPRB, 0.34289428E-05_JPRB, 0.34499969E-05_JPRB, 0.34859190E-05_JPRB, &
  & 0.35324560E-05_JPRB, 0.35857449E-05_JPRB, 0.36421843E-05_JPRB, 0.36976492E-05_JPRB, 0.37507077E-05_JPRB, 0.38012381E-05_JPRB, &
  & 0.38506055E-05_JPRB, 0.38990706E-05_JPRB, 0.39475576E-05_JPRB, 0.39942474E-05_JPRB, 0.40365862E-05_JPRB, 0.40684868E-05_JPRB, &
  & 0.40852387E-05_JPRB, 0.40835239E-05_JPRB, 0.40607520E-05_JPRB, 0.40176533E-05_JPRB, 0.39618499E-05_JPRB, 0.39024744E-05_JPRB, &
  & 0.38507342E-05_JPRB, 0.38115847E-05_JPRB, 0.37872810E-05_JPRB, 0.37796988E-05_JPRB, 0.37893387E-05_JPRB, 0.38149706E-05_JPRB, &
  & 0.38558201E-05_JPRB, 0.39082443E-05_JPRB, 0.39663632E-05_JPRB, 0.40198329E-05_JPRB, 0.40653927E-05_JPRB, 0.40925461E-05_JPRB, &
  & 0.40936629E-05_JPRB, 0.40722662E-05_JPRB, 0.40348928E-05_JPRB, 0.39884608E-05_JPRB, 0.39448983E-05_JPRB, 0.39144270E-05_JPRB, &
  & 0.38994126E-05_JPRB, 0.39027836E-05_JPRB, 0.39229053E-05_JPRB, 0.39543206E-05_JPRB, 0.39920246E-05_JPRB, 0.40299842E-05_JPRB, &
  & 0.40653240E-05_JPRB, 0.40978557E-05_JPRB, 0.41276749E-05_JPRB, 0.41554513E-05_JPRB, 0.41838484E-05_JPRB, 0.42146762E-05_JPRB, &
  & 0.42488196E-05_JPRB, 0.42867409E-05_JPRB, 0.43262598E-05_JPRB, 0.43653999E-05_JPRB, 0.44035896E-05_JPRB, 0.44408816E-05_JPRB, &
  & 0.44777498E-05_JPRB, 0.45173006E-05_JPRB, 0.45677448E-05_JPRB, 0.46679588E-05_JPRB /)

RGHG7(:,27,11) = (/ &
  & 0.29739344E-05_JPRB, 0.28361187E-05_JPRB, 0.28054280E-05_JPRB, 0.28109700E-05_JPRB, 0.28398217E-05_JPRB, 0.28845709E-05_JPRB, &
  & 0.29405924E-05_JPRB, 0.30033482E-05_JPRB, 0.30691676E-05_JPRB, 0.31340612E-05_JPRB, 0.31968796E-05_JPRB, 0.32568321E-05_JPRB, &
  & 0.33147217E-05_JPRB, 0.33701876E-05_JPRB, 0.34240970E-05_JPRB, 0.34722136E-05_JPRB, 0.35131643E-05_JPRB, 0.35398573E-05_JPRB, &
  & 0.35474898E-05_JPRB, 0.35326552E-05_JPRB, 0.34938460E-05_JPRB, 0.34306527E-05_JPRB, 0.33537081E-05_JPRB, 0.32713328E-05_JPRB, &
  & 0.31966981E-05_JPRB, 0.31373056E-05_JPRB, 0.30968331E-05_JPRB, 0.30787201E-05_JPRB, 0.30830365E-05_JPRB, 0.31079608E-05_JPRB, &
  & 0.31503375E-05_JPRB, 0.32037183E-05_JPRB, 0.32616836E-05_JPRB, 0.33146766E-05_JPRB, 0.33589979E-05_JPRB, 0.33916208E-05_JPRB, &
  & 0.34042314E-05_JPRB, 0.33985693E-05_JPRB, 0.33827537E-05_JPRB, 0.33591755E-05_JPRB, 0.33381730E-05_JPRB, 0.33278043E-05_JPRB, &
  & 0.33320830E-05_JPRB, 0.33535762E-05_JPRB, 0.33916347E-05_JPRB, 0.34417646E-05_JPRB, 0.34981385E-05_JPRB, 0.35552334E-05_JPRB, &
  & 0.36106653E-05_JPRB, 0.36639603E-05_JPRB, 0.37136492E-05_JPRB, 0.37594816E-05_JPRB, 0.38025107E-05_JPRB, 0.38454405E-05_JPRB, &
  & 0.38898334E-05_JPRB, 0.39361571E-05_JPRB, 0.39833790E-05_JPRB, 0.40305281E-05_JPRB, 0.40772698E-05_JPRB, 0.41232038E-05_JPRB, &
  & 0.41692465E-05_JPRB, 0.42183174E-05_JPRB, 0.42787597E-05_JPRB, 0.44034095E-05_JPRB /)

RGHG7(:,28,11) = (/ &
  & 0.23801856E-05_JPRB, 0.22570521E-05_JPRB, 0.22364081E-05_JPRB, 0.22502879E-05_JPRB, 0.22866834E-05_JPRB, 0.23395953E-05_JPRB, &
  & 0.24041537E-05_JPRB, 0.24758979E-05_JPRB, 0.25509412E-05_JPRB, 0.26258137E-05_JPRB, 0.26986627E-05_JPRB, 0.27681031E-05_JPRB, &
  & 0.28345714E-05_JPRB, 0.28965701E-05_JPRB, 0.29546397E-05_JPRB, 0.30043282E-05_JPRB, 0.30439296E-05_JPRB, 0.30664066E-05_JPRB, &
  & 0.30680178E-05_JPRB, 0.30460781E-05_JPRB, 0.29988141E-05_JPRB, 0.29277301E-05_JPRB, 0.28412210E-05_JPRB, 0.27497586E-05_JPRB, &
  & 0.26638918E-05_JPRB, 0.25937575E-05_JPRB, 0.25425998E-05_JPRB, 0.25150978E-05_JPRB, 0.25113754E-05_JPRB, 0.25302802E-05_JPRB, &
  & 0.25669437E-05_JPRB, 0.26140333E-05_JPRB, 0.26649054E-05_JPRB, 0.27113012E-05_JPRB, 0.27497563E-05_JPRB, 0.27808776E-05_JPRB, &
  & 0.27996828E-05_JPRB, 0.28053901E-05_JPRB, 0.28059203E-05_JPRB, 0.28020786E-05_JPRB, 0.28011727E-05_JPRB, 0.28094296E-05_JPRB, &
  & 0.28306581E-05_JPRB, 0.28676673E-05_JPRB, 0.29205617E-05_JPRB, 0.29855105E-05_JPRB, 0.30576200E-05_JPRB, 0.31330262E-05_JPRB, &
  & 0.32076339E-05_JPRB, 0.32757409E-05_JPRB, 0.33353922E-05_JPRB, 0.33899785E-05_JPRB, 0.34419988E-05_JPRB, 0.34931072E-05_JPRB, &
  & 0.35443827E-05_JPRB, 0.35966834E-05_JPRB, 0.36492677E-05_JPRB, 0.37015616E-05_JPRB, 0.37532523E-05_JPRB, 0.38041489E-05_JPRB, &
  & 0.38545732E-05_JPRB, 0.39076690E-05_JPRB, 0.39748666E-05_JPRB, 0.41064050E-05_JPRB /)

RGHG7(:,29,11) = (/ &
  & 0.18706894E-05_JPRB, 0.17761821E-05_JPRB, 0.17678557E-05_JPRB, 0.17893568E-05_JPRB, 0.18313739E-05_JPRB, 0.18882428E-05_JPRB, &
  & 0.19565921E-05_JPRB, 0.20323414E-05_JPRB, 0.21122557E-05_JPRB, 0.21925750E-05_JPRB, 0.22715622E-05_JPRB, 0.23470463E-05_JPRB, &
  & 0.24189010E-05_JPRB, 0.24847177E-05_JPRB, 0.25438005E-05_JPRB, 0.25932557E-05_JPRB, 0.26301584E-05_JPRB, 0.26494220E-05_JPRB, &
  & 0.26468265E-05_JPRB, 0.26205937E-05_JPRB, 0.25700217E-05_JPRB, 0.24976794E-05_JPRB, 0.24100900E-05_JPRB, 0.23180521E-05_JPRB, &
  & 0.22294198E-05_JPRB, 0.21549492E-05_JPRB, 0.20980119E-05_JPRB, 0.20626667E-05_JPRB, 0.20503107E-05_JPRB, 0.20599689E-05_JPRB, &
  & 0.20869568E-05_JPRB, 0.21238670E-05_JPRB, 0.21644018E-05_JPRB, 0.22013962E-05_JPRB, 0.22325307E-05_JPRB, 0.22593290E-05_JPRB, &
  & 0.22804350E-05_JPRB, 0.22939446E-05_JPRB, 0.23063915E-05_JPRB, 0.23183077E-05_JPRB, 0.23342543E-05_JPRB, 0.23586138E-05_JPRB, &
  & 0.23945290E-05_JPRB, 0.24443300E-05_JPRB, 0.25086522E-05_JPRB, 0.25843997E-05_JPRB, 0.26677392E-05_JPRB, 0.27535109E-05_JPRB, &
  & 0.28345405E-05_JPRB, 0.29099097E-05_JPRB, 0.29814591E-05_JPRB, 0.30480974E-05_JPRB, 0.31085629E-05_JPRB, 0.31655293E-05_JPRB, &
  & 0.32217033E-05_JPRB, 0.32778257E-05_JPRB, 0.33336478E-05_JPRB, 0.33888391E-05_JPRB, 0.34430868E-05_JPRB, 0.34957059E-05_JPRB, &
  & 0.35478274E-05_JPRB, 0.36024060E-05_JPRB, 0.36692502E-05_JPRB, 0.38023113E-05_JPRB /)

RGHG7(:,30,11) = (/ &
  & 0.14613452E-05_JPRB, 0.13963884E-05_JPRB, 0.14000971E-05_JPRB, 0.14291902E-05_JPRB, 0.14745011E-05_JPRB, 0.15332641E-05_JPRB, &
  & 0.16020202E-05_JPRB, 0.16778513E-05_JPRB, 0.17577186E-05_JPRB, 0.18387358E-05_JPRB, 0.19186937E-05_JPRB, 0.19955537E-05_JPRB, &
  & 0.20679011E-05_JPRB, 0.21332949E-05_JPRB, 0.21906176E-05_JPRB, 0.22364648E-05_JPRB, 0.22686615E-05_JPRB, 0.22830161E-05_JPRB, &
  & 0.22767781E-05_JPRB, 0.22479251E-05_JPRB, 0.21976361E-05_JPRB, 0.21279784E-05_JPRB, 0.20448722E-05_JPRB, 0.19566232E-05_JPRB, &
  & 0.18711072E-05_JPRB, 0.17966926E-05_JPRB, 0.17371254E-05_JPRB, 0.16960024E-05_JPRB, 0.16753426E-05_JPRB, 0.16749440E-05_JPRB, &
  & 0.16908052E-05_JPRB, 0.17164895E-05_JPRB, 0.17460053E-05_JPRB, 0.17733079E-05_JPRB, 0.17973349E-05_JPRB, 0.18196780E-05_JPRB, &
  & 0.18408938E-05_JPRB, 0.18596335E-05_JPRB, 0.18807414E-05_JPRB, 0.19044694E-05_JPRB, 0.19335532E-05_JPRB, 0.19707113E-05_JPRB, &
  & 0.20185826E-05_JPRB, 0.20784789E-05_JPRB, 0.21513881E-05_JPRB, 0.22352169E-05_JPRB, 0.23259504E-05_JPRB, 0.24185108E-05_JPRB, &
  & 0.25081126E-05_JPRB, 0.25935999E-05_JPRB, 0.26706111E-05_JPRB, 0.27383742E-05_JPRB, 0.28011273E-05_JPRB, 0.28616635E-05_JPRB, &
  & 0.29212640E-05_JPRB, 0.29802993E-05_JPRB, 0.30388228E-05_JPRB, 0.30963031E-05_JPRB, 0.31519546E-05_JPRB, 0.32057580E-05_JPRB, &
  & 0.32582050E-05_JPRB, 0.33129343E-05_JPRB, 0.33787660E-05_JPRB, 0.35085302E-05_JPRB /)

RGHG7(:,31,11) = (/ &
  & 0.11438865E-05_JPRB, 0.11075584E-05_JPRB, 0.11225197E-05_JPRB, 0.11563186E-05_JPRB, 0.12046096E-05_JPRB, 0.12627596E-05_JPRB, &
  & 0.13301612E-05_JPRB, 0.14031848E-05_JPRB, 0.14799265E-05_JPRB, 0.15575156E-05_JPRB, 0.16342857E-05_JPRB, 0.17083393E-05_JPRB, &
  & 0.17766607E-05_JPRB, 0.18380348E-05_JPRB, 0.18904137E-05_JPRB, 0.19304132E-05_JPRB, 0.19558388E-05_JPRB, 0.19639267E-05_JPRB, &
  & 0.19528516E-05_JPRB, 0.19228407E-05_JPRB, 0.18738757E-05_JPRB, 0.18089454E-05_JPRB, 0.17318660E-05_JPRB, 0.16499322E-05_JPRB, &
  & 0.15698631E-05_JPRB, 0.14984109E-05_JPRB, 0.14385313E-05_JPRB, 0.13937076E-05_JPRB, 0.13662567E-05_JPRB, 0.13564871E-05_JPRB, &
  & 0.13617523E-05_JPRB, 0.13767482E-05_JPRB, 0.13961735E-05_JPRB, 0.14150856E-05_JPRB, 0.14331667E-05_JPRB, 0.14521878E-05_JPRB, &
  & 0.14727078E-05_JPRB, 0.14950311E-05_JPRB, 0.15220538E-05_JPRB, 0.15542288E-05_JPRB, 0.15929634E-05_JPRB, 0.16397853E-05_JPRB, &
  & 0.16967992E-05_JPRB, 0.17644081E-05_JPRB, 0.18437148E-05_JPRB, 0.19328593E-05_JPRB, 0.20279886E-05_JPRB, 0.21240160E-05_JPRB, &
  & 0.22172123E-05_JPRB, 0.23027478E-05_JPRB, 0.23804298E-05_JPRB, 0.24521889E-05_JPRB, 0.25194768E-05_JPRB, 0.25833294E-05_JPRB, &
  & 0.26454684E-05_JPRB, 0.27068841E-05_JPRB, 0.27674719E-05_JPRB, 0.28264330E-05_JPRB, 0.28833879E-05_JPRB, 0.29379237E-05_JPRB, &
  & 0.29909272E-05_JPRB, 0.30441818E-05_JPRB, 0.31090847E-05_JPRB, 0.32325954E-05_JPRB /)

RGHG7(:,32,11) = (/ &
  & 0.90900818E-06_JPRB, 0.89688427E-06_JPRB, 0.91957355E-06_JPRB, 0.95706889E-06_JPRB, 0.10053305E-05_JPRB, 0.10622103E-05_JPRB, &
  & 0.11263751E-05_JPRB, 0.11951375E-05_JPRB, 0.12664023E-05_JPRB, 0.13381430E-05_JPRB, 0.14086479E-05_JPRB, 0.14763827E-05_JPRB, &
  & 0.15377406E-05_JPRB, 0.15924099E-05_JPRB, 0.16373714E-05_JPRB, 0.16695833E-05_JPRB, 0.16874521E-05_JPRB, 0.16888042E-05_JPRB, &
  & 0.16728899E-05_JPRB, 0.16402745E-05_JPRB, 0.15924426E-05_JPRB, 0.15317801E-05_JPRB, 0.14609798E-05_JPRB, 0.13857268E-05_JPRB, &
  & 0.13117606E-05_JPRB, 0.12440934E-05_JPRB, 0.11857562E-05_JPRB, 0.11392890E-05_JPRB, 0.11069288E-05_JPRB, 0.10895543E-05_JPRB, &
  & 0.10857107E-05_JPRB, 0.10916727E-05_JPRB, 0.11027613E-05_JPRB, 0.11151458E-05_JPRB, 0.11290780E-05_JPRB, 0.11457702E-05_JPRB, &
  & 0.11656599E-05_JPRB, 0.11904408E-05_JPRB, 0.12212718E-05_JPRB, 0.12592360E-05_JPRB, 0.13046314E-05_JPRB, 0.13585359E-05_JPRB, &
  & 0.14221138E-05_JPRB, 0.14953754E-05_JPRB, 0.15790549E-05_JPRB, 0.16711182E-05_JPRB, 0.17672858E-05_JPRB, 0.18636678E-05_JPRB, &
  & 0.19564443E-05_JPRB, 0.20431253E-05_JPRB, 0.21229748E-05_JPRB, 0.21961582E-05_JPRB, 0.22643030E-05_JPRB, 0.23290390E-05_JPRB, &
  & 0.23924913E-05_JPRB, 0.24555054E-05_JPRB, 0.25175684E-05_JPRB, 0.25782958E-05_JPRB, 0.26365692E-05_JPRB, 0.26917817E-05_JPRB, &
  & 0.27437441E-05_JPRB, 0.27968911E-05_JPRB, 0.28588306E-05_JPRB, 0.29793434E-05_JPRB /)

RGHG7(:,33,11) = (/ &
  & 0.74335600E-06_JPRB, 0.74927357E-06_JPRB, 0.77684103E-06_JPRB, 0.81491163E-06_JPRB, 0.86251134E-06_JPRB, 0.91624719E-06_JPRB, &
  & 0.97634450E-06_JPRB, 0.10396388E-05_JPRB, 0.11042611E-05_JPRB, 0.11685079E-05_JPRB, 0.12309050E-05_JPRB, 0.12898969E-05_JPRB, &
  & 0.13428669E-05_JPRB, 0.13889158E-05_JPRB, 0.14249489E-05_JPRB, 0.14486438E-05_JPRB, 0.14576550E-05_JPRB, 0.14510384E-05_JPRB, &
  & 0.14297432E-05_JPRB, 0.13947995E-05_JPRB, 0.13477638E-05_JPRB, 0.12900924E-05_JPRB, 0.12248404E-05_JPRB, 0.11559075E-05_JPRB, &
  & 0.10879902E-05_JPRB, 0.10250158E-05_JPRB, 0.96893154E-06_JPRB, 0.92205369E-06_JPRB, 0.88644686E-06_JPRB, 0.86335456E-06_JPRB, &
  & 0.85246370E-06_JPRB, 0.85121638E-06_JPRB, 0.85593945E-06_JPRB, 0.86374831E-06_JPRB, 0.87507516E-06_JPRB, 0.88999798E-06_JPRB, &
  & 0.90983838E-06_JPRB, 0.93597157E-06_JPRB, 0.96922736E-06_JPRB, 0.10108994E-05_JPRB, 0.10606182E-05_JPRB, 0.11194368E-05_JPRB, &
  & 0.11875251E-05_JPRB, 0.12647465E-05_JPRB, 0.13508493E-05_JPRB, 0.14433365E-05_JPRB, 0.15393146E-05_JPRB, 0.16349513E-05_JPRB, &
  & 0.17270272E-05_JPRB, 0.18126526E-05_JPRB, 0.18910542E-05_JPRB, 0.19632507E-05_JPRB, 0.20306886E-05_JPRB, 0.20957539E-05_JPRB, &
  & 0.21601754E-05_JPRB, 0.22243848E-05_JPRB, 0.22880713E-05_JPRB, 0.23501277E-05_JPRB, 0.24092744E-05_JPRB, 0.24643207E-05_JPRB, &
  & 0.25166030E-05_JPRB, 0.25682039E-05_JPRB, 0.26296102E-05_JPRB, 0.27432757E-05_JPRB /)

RGHG7(:,34,11) = (/ &
  & 0.63068774E-06_JPRB, 0.64933181E-06_JPRB, 0.67965561E-06_JPRB, 0.71722366E-06_JPRB, 0.76235079E-06_JPRB, 0.81279740E-06_JPRB, &
  & 0.86765544E-06_JPRB, 0.92476023E-06_JPRB, 0.98198132E-06_JPRB, 0.10377531E-05_JPRB, 0.10909871E-05_JPRB, 0.11401611E-05_JPRB, &
  & 0.11838596E-05_JPRB, 0.12206333E-05_JPRB, 0.12473928E-05_JPRB, 0.12623924E-05_JPRB, 0.12629645E-05_JPRB, 0.12492986E-05_JPRB, &
  & 0.12220639E-05_JPRB, 0.11833397E-05_JPRB, 0.11348932E-05_JPRB, 0.10786021E-05_JPRB, 0.10169391E-05_JPRB, 0.95306024E-06_JPRB, &
  & 0.89037923E-06_JPRB, 0.83188644E-06_JPRB, 0.77891053E-06_JPRB, 0.73304864E-06_JPRB, 0.69610519E-06_JPRB, 0.66959007E-06_JPRB, &
  & 0.65379379E-06_JPRB, 0.64739965E-06_JPRB, 0.64767295E-06_JPRB, 0.65269478E-06_JPRB, 0.66209884E-06_JPRB, 0.67593055E-06_JPRB, &
  & 0.69586434E-06_JPRB, 0.72226362E-06_JPRB, 0.75707140E-06_JPRB, 0.80062790E-06_JPRB, 0.85305095E-06_JPRB, 0.91513687E-06_JPRB, &
  & 0.98631233E-06_JPRB, 0.10661530E-05_JPRB, 0.11534435E-05_JPRB, 0.12456908E-05_JPRB, 0.13399037E-05_JPRB, 0.14328115E-05_JPRB, &
  & 0.15208644E-05_JPRB, 0.16032221E-05_JPRB, 0.16793836E-05_JPRB, 0.17503778E-05_JPRB, 0.18180172E-05_JPRB, 0.18838081E-05_JPRB, &
  & 0.19488893E-05_JPRB, 0.20138007E-05_JPRB, 0.20779030E-05_JPRB, 0.21404724E-05_JPRB, 0.21997394E-05_JPRB, 0.22551426E-05_JPRB, &
  & 0.23064392E-05_JPRB, 0.23573318E-05_JPRB, 0.24150265E-05_JPRB, 0.25256593E-05_JPRB /)

RGHG7(:,35,11) = (/ &
  & 0.55902899E-06_JPRB, 0.58570737E-06_JPRB, 0.61582955E-06_JPRB, 0.65164414E-06_JPRB, 0.69357202E-06_JPRB, 0.73968937E-06_JPRB, &
  & 0.78942912E-06_JPRB, 0.83990062E-06_JPRB, 0.88936486E-06_JPRB, 0.93646088E-06_JPRB, 0.98014607E-06_JPRB, 0.10195737E-05_JPRB, &
  & 0.10538383E-05_JPRB, 0.10813822E-05_JPRB, 0.10993067E-05_JPRB, 0.11058219E-05_JPRB, 0.10985619E-05_JPRB, 0.10780703E-05_JPRB, &
  & 0.10447067E-05_JPRB, 0.10013296E-05_JPRB, 0.95003014E-06_JPRB, 0.89307213E-06_JPRB, 0.83295390E-06_JPRB, 0.77239628E-06_JPRB, &
  & 0.71406697E-06_JPRB, 0.65999353E-06_JPRB, 0.61091021E-06_JPRB, 0.56761110E-06_JPRB, 0.53147301E-06_JPRB, 0.50382488E-06_JPRB, &
  & 0.48550822E-06_JPRB, 0.47593366E-06_JPRB, 0.47345034E-06_JPRB, 0.47659569E-06_JPRB, 0.48428848E-06_JPRB, 0.49758023E-06_JPRB, &
  & 0.51663147E-06_JPRB, 0.54262125E-06_JPRB, 0.57753709E-06_JPRB, 0.62132131E-06_JPRB, 0.67509524E-06_JPRB, 0.73903192E-06_JPRB, &
  & 0.81228973E-06_JPRB, 0.89399077E-06_JPRB, 0.98168755E-06_JPRB, 0.10726598E-05_JPRB, 0.11644413E-05_JPRB, 0.12536125E-05_JPRB, &
  & 0.13387389E-05_JPRB, 0.14181801E-05_JPRB, 0.14919273E-05_JPRB, 0.15615005E-05_JPRB, 0.16278226E-05_JPRB, 0.16925039E-05_JPRB, &
  & 0.17567621E-05_JPRB, 0.18211821E-05_JPRB, 0.18852171E-05_JPRB, 0.19478589E-05_JPRB, 0.20073892E-05_JPRB, 0.20621503E-05_JPRB, &
  & 0.21127580E-05_JPRB, 0.21614251E-05_JPRB, 0.22186164E-05_JPRB, 0.23222817E-05_JPRB /)

RGHG7(:,36,11) = (/ &
  & 0.51837242E-06_JPRB, 0.54833777E-06_JPRB, 0.57756336E-06_JPRB, 0.60990607E-06_JPRB, 0.64745404E-06_JPRB, 0.68901954E-06_JPRB, &
  & 0.73272361E-06_JPRB, 0.77660928E-06_JPRB, 0.81838334E-06_JPRB, 0.85686116E-06_JPRB, 0.89138098E-06_JPRB, 0.92161173E-06_JPRB, &
  & 0.94692666E-06_JPRB, 0.96590077E-06_JPRB, 0.97590419E-06_JPRB, 0.97475720E-06_JPRB, 0.96016083E-06_JPRB, 0.93236798E-06_JPRB, &
  & 0.89325397E-06_JPRB, 0.84472663E-06_JPRB, 0.78970152E-06_JPRB, 0.73071163E-06_JPRB, 0.67086575E-06_JPRB, 0.61257754E-06_JPRB, &
  & 0.55803525E-06_JPRB, 0.50856033E-06_JPRB, 0.46418486E-06_JPRB, 0.42523354E-06_JPRB, 0.39223545E-06_JPRB, 0.36626179E-06_JPRB, &
  & 0.34792745E-06_JPRB, 0.33718010E-06_JPRB, 0.33335462E-06_JPRB, 0.33477377E-06_JPRB, 0.34121678E-06_JPRB, 0.35327761E-06_JPRB, &
  & 0.37038680E-06_JPRB, 0.39492900E-06_JPRB, 0.42761729E-06_JPRB, 0.46964468E-06_JPRB, 0.52263022E-06_JPRB, 0.58641723E-06_JPRB, &
  & 0.66081299E-06_JPRB, 0.74320559E-06_JPRB, 0.83074303E-06_JPRB, 0.92040881E-06_JPRB, 0.10091851E-05_JPRB, 0.10949418E-05_JPRB, &
  & 0.11760442E-05_JPRB, 0.12521286E-05_JPRB, 0.13233870E-05_JPRB, 0.13909394E-05_JPRB, 0.14561789E-05_JPRB, 0.15195500E-05_JPRB, &
  & 0.15829440E-05_JPRB, 0.16464484E-05_JPRB, 0.17097906E-05_JPRB, 0.17717672E-05_JPRB, 0.18304586E-05_JPRB, 0.18844146E-05_JPRB, &
  & 0.19337601E-05_JPRB, 0.19819677E-05_JPRB, 0.20351129E-05_JPRB, 0.21352473E-05_JPRB /)

RGHG7(:,37,11) = (/ &
  & 0.50091620E-06_JPRB, 0.53129764E-06_JPRB, 0.55696535E-06_JPRB, 0.58521374E-06_JPRB, 0.61802837E-06_JPRB, 0.65376128E-06_JPRB, &
  & 0.69165645E-06_JPRB, 0.72849383E-06_JPRB, 0.76261603E-06_JPRB, 0.79298212E-06_JPRB, 0.81896872E-06_JPRB, 0.84091101E-06_JPRB, &
  & 0.85827361E-06_JPRB, 0.86953031E-06_JPRB, 0.87292517E-06_JPRB, 0.86452673E-06_JPRB, 0.84437090E-06_JPRB, 0.81007863E-06_JPRB, &
  & 0.76427898E-06_JPRB, 0.70985857E-06_JPRB, 0.65045037E-06_JPRB, 0.58919630E-06_JPRB, 0.52952424E-06_JPRB, 0.47434546E-06_JPRB, &
  & 0.42515182E-06_JPRB, 0.38226003E-06_JPRB, 0.34497074E-06_JPRB, 0.31272700E-06_JPRB, 0.28552054E-06_JPRB, 0.26367954E-06_JPRB, &
  & 0.24766197E-06_JPRB, 0.23763891E-06_JPRB, 0.23334948E-06_JPRB, 0.23342736E-06_JPRB, 0.23861864E-06_JPRB, 0.24822094E-06_JPRB, &
  & 0.26279690E-06_JPRB, 0.28369490E-06_JPRB, 0.31170254E-06_JPRB, 0.34905048E-06_JPRB, 0.39704287E-06_JPRB, 0.45758009E-06_JPRB, &
  & 0.52967897E-06_JPRB, 0.61099939E-06_JPRB, 0.69760858E-06_JPRB, 0.78563124E-06_JPRB, 0.87171759E-06_JPRB, 0.95406949E-06_JPRB, &
  & 0.10320863E-05_JPRB, 0.11052933E-05_JPRB, 0.11741148E-05_JPRB, 0.12394535E-05_JPRB, 0.13029307E-05_JPRB, 0.13647239E-05_JPRB, &
  & 0.14262292E-05_JPRB, 0.14878905E-05_JPRB, 0.15493695E-05_JPRB, 0.16095951E-05_JPRB, 0.16670421E-05_JPRB, 0.17201584E-05_JPRB, &
  & 0.17687441E-05_JPRB, 0.18145910E-05_JPRB, 0.18674031E-05_JPRB, 0.19618703E-05_JPRB /)

RGHG7(:,38,11) = (/ &
  & 0.50046185E-06_JPRB, 0.52741234E-06_JPRB, 0.54923220E-06_JPRB, 0.57262110E-06_JPRB, 0.59950645E-06_JPRB, 0.62987453E-06_JPRB, &
  & 0.66090399E-06_JPRB, 0.69086286E-06_JPRB, 0.71756568E-06_JPRB, 0.74020005E-06_JPRB, 0.75874226E-06_JPRB, 0.77340968E-06_JPRB, &
  & 0.78400217E-06_JPRB, 0.78883608E-06_JPRB, 0.78604336E-06_JPRB, 0.77267168E-06_JPRB, 0.74534228E-06_JPRB, 0.70603329E-06_JPRB, &
  & 0.65489064E-06_JPRB, 0.59550894E-06_JPRB, 0.53272942E-06_JPRB, 0.47140756E-06_JPRB, 0.41539590E-06_JPRB, 0.36669752E-06_JPRB, &
  & 0.32564469E-06_JPRB, 0.29124274E-06_JPRB, 0.26204614E-06_JPRB, 0.23712168E-06_JPRB, 0.21600322E-06_JPRB, 0.19880913E-06_JPRB, &
  & 0.18570987E-06_JPRB, 0.17716386E-06_JPRB, 0.17294241E-06_JPRB, 0.17237328E-06_JPRB, 0.17631204E-06_JPRB, 0.18352901E-06_JPRB, &
  & 0.19530944E-06_JPRB, 0.21178461E-06_JPRB, 0.23426779E-06_JPRB, 0.26447691E-06_JPRB, 0.30476551E-06_JPRB, 0.35723360E-06_JPRB, &
  & 0.42240001E-06_JPRB, 0.49839912E-06_JPRB, 0.58200692E-06_JPRB, 0.66719201E-06_JPRB, 0.75031068E-06_JPRB, 0.82967563E-06_JPRB, &
  & 0.90464727E-06_JPRB, 0.97525265E-06_JPRB, 0.10420786E-05_JPRB, 0.11055988E-05_JPRB, 0.11670609E-05_JPRB, 0.12265792E-05_JPRB, &
  & 0.12850408E-05_JPRB, 0.13434877E-05_JPRB, 0.14018290E-05_JPRB, 0.14595768E-05_JPRB, 0.15152885E-05_JPRB, 0.15671853E-05_JPRB, &
  & 0.16145470E-05_JPRB, 0.16603384E-05_JPRB, 0.17104080E-05_JPRB, 0.18024060E-05_JPRB /)

RGHG7(:,39,11) = (/ &
  & 0.50962791E-06_JPRB, 0.53193025E-06_JPRB, 0.54888523E-06_JPRB, 0.56703021E-06_JPRB, 0.58877862E-06_JPRB, 0.61252678E-06_JPRB, &
  & 0.63727543E-06_JPRB, 0.66007527E-06_JPRB, 0.67967318E-06_JPRB, 0.69555159E-06_JPRB, 0.70757079E-06_JPRB, 0.71619388E-06_JPRB, &
  & 0.72103461E-06_JPRB, 0.72101193E-06_JPRB, 0.71280402E-06_JPRB, 0.69463044E-06_JPRB, 0.66375014E-06_JPRB, 0.61890489E-06_JPRB, &
  & 0.56375569E-06_JPRB, 0.50239095E-06_JPRB, 0.44041829E-06_JPRB, 0.38349972E-06_JPRB, 0.33456405E-06_JPRB, 0.29407337E-06_JPRB, &
  & 0.26103979E-06_JPRB, 0.23399612E-06_JPRB, 0.21127718E-06_JPRB, 0.19184822E-06_JPRB, 0.17522744E-06_JPRB, 0.16138931E-06_JPRB, &
  & 0.15051526E-06_JPRB, 0.14327678E-06_JPRB, 0.13915354E-06_JPRB, 0.13858863E-06_JPRB, 0.14140333E-06_JPRB, 0.14718324E-06_JPRB, &
  & 0.15664931E-06_JPRB, 0.16961849E-06_JPRB, 0.18751227E-06_JPRB, 0.21143914E-06_JPRB, 0.24378673E-06_JPRB, 0.28660781E-06_JPRB, &
  & 0.34106486E-06_JPRB, 0.40857003E-06_JPRB, 0.48516222E-06_JPRB, 0.56524920E-06_JPRB, 0.64466423E-06_JPRB, 0.72066103E-06_JPRB, &
  & 0.79273775E-06_JPRB, 0.86101886E-06_JPRB, 0.92589880E-06_JPRB, 0.98747455E-06_JPRB, 0.10463735E-05_JPRB, 0.11029649E-05_JPRB, &
  & 0.11577810E-05_JPRB, 0.12119859E-05_JPRB, 0.12663072E-05_JPRB, 0.13205295E-05_JPRB, 0.13735842E-05_JPRB, 0.14239567E-05_JPRB, &
  & 0.14707684E-05_JPRB, 0.15151999E-05_JPRB, 0.15653712E-05_JPRB, 0.16541733E-05_JPRB /)

RGHG7(:,40,11) = (/ &
  & 0.52201597E-06_JPRB, 0.53867541E-06_JPRB, 0.55123212E-06_JPRB, 0.56503126E-06_JPRB, 0.58098368E-06_JPRB, 0.59936627E-06_JPRB, &
  & 0.61729907E-06_JPRB, 0.63353872E-06_JPRB, 0.64663976E-06_JPRB, 0.65643775E-06_JPRB, 0.66309349E-06_JPRB, 0.66683344E-06_JPRB, &
  & 0.66708549E-06_JPRB, 0.66271457E-06_JPRB, 0.65112931E-06_JPRB, 0.62827706E-06_JPRB, 0.59305228E-06_JPRB, 0.54561832E-06_JPRB, &
  & 0.48877007E-06_JPRB, 0.42831249E-06_JPRB, 0.37101543E-06_JPRB, 0.32107539E-06_JPRB, 0.28011922E-06_JPRB, 0.24711414E-06_JPRB, &
  & 0.22056888E-06_JPRB, 0.19880777E-06_JPRB, 0.18044338E-06_JPRB, 0.16459673E-06_JPRB, 0.15079453E-06_JPRB, 0.13911814E-06_JPRB, &
  & 0.12969893E-06_JPRB, 0.12340971E-06_JPRB, 0.11936032E-06_JPRB, 0.11902340E-06_JPRB, 0.12100409E-06_JPRB, 0.12609196E-06_JPRB, &
  & 0.13380850E-06_JPRB, 0.14459231E-06_JPRB, 0.15913051E-06_JPRB, 0.17851298E-06_JPRB, 0.20447369E-06_JPRB, 0.23844717E-06_JPRB, &
  & 0.28344706E-06_JPRB, 0.34054449E-06_JPRB, 0.40734790E-06_JPRB, 0.48034718E-06_JPRB, 0.55409453E-06_JPRB, 0.62601691E-06_JPRB, &
  & 0.69490233E-06_JPRB, 0.76073218E-06_JPRB, 0.82359287E-06_JPRB, 0.88319820E-06_JPRB, 0.93932914E-06_JPRB, 0.99255919E-06_JPRB, &
  & 0.10429150E-05_JPRB, 0.10924393E-05_JPRB, 0.11417835E-05_JPRB, 0.11918487E-05_JPRB, 0.12416845E-05_JPRB, 0.12901236E-05_JPRB, &
  & 0.13354608E-05_JPRB, 0.13796674E-05_JPRB, 0.14283189E-05_JPRB, 0.15159676E-05_JPRB /)

RGHG7(:,41,11) = (/ &
  & 0.53262011E-06_JPRB, 0.54423685E-06_JPRB, 0.55295732E-06_JPRB, 0.56243562E-06_JPRB, 0.57411233E-06_JPRB, 0.58667558E-06_JPRB, &
  & 0.59887907E-06_JPRB, 0.60888345E-06_JPRB, 0.61624780E-06_JPRB, 0.62102703E-06_JPRB, 0.62323312E-06_JPRB, 0.62303349E-06_JPRB, &
  & 0.61974049E-06_JPRB, 0.61195084E-06_JPRB, 0.59691320E-06_JPRB, 0.57174361E-06_JPRB, 0.53358752E-06_JPRB, 0.48379860E-06_JPRB, &
  & 0.42680935E-06_JPRB, 0.36978963E-06_JPRB, 0.31845238E-06_JPRB, 0.27615954E-06_JPRB, 0.24240890E-06_JPRB, 0.21552566E-06_JPRB, &
  & 0.19373478E-06_JPRB, 0.17566404E-06_JPRB, 0.16019294E-06_JPRB, 0.14661620E-06_JPRB, 0.13467591E-06_JPRB, 0.12437975E-06_JPRB, &
  & 0.11601541E-06_JPRB, 0.11027744E-06_JPRB, 0.10649279E-06_JPRB, 0.10621056E-06_JPRB, 0.10783138E-06_JPRB, 0.11241013E-06_JPRB, &
  & 0.11902211E-06_JPRB, 0.12833357E-06_JPRB, 0.14054480E-06_JPRB, 0.15665132E-06_JPRB, 0.17765228E-06_JPRB, 0.20543206E-06_JPRB, &
  & 0.24241967E-06_JPRB, 0.28924870E-06_JPRB, 0.34616781E-06_JPRB, 0.41017623E-06_JPRB, 0.47771050E-06_JPRB, 0.54442580E-06_JPRB, &
  & 0.60951999E-06_JPRB, 0.67256474E-06_JPRB, 0.73319467E-06_JPRB, 0.79030411E-06_JPRB, 0.84381412E-06_JPRB, 0.89283907E-06_JPRB, &
  & 0.93908477E-06_JPRB, 0.98333749E-06_JPRB, 0.10277801E-05_JPRB, 0.10731901E-05_JPRB, 0.11192766E-05_JPRB, 0.11647035E-05_JPRB, &
  & 0.12083660E-05_JPRB, 0.12509365E-05_JPRB, 0.12990631E-05_JPRB, 0.13845273E-05_JPRB /)

RGHG7(:,42,11) = (/ &
  & 0.53884696E-06_JPRB, 0.54615816E-06_JPRB, 0.55153157E-06_JPRB, 0.55778185E-06_JPRB, 0.56494900E-06_JPRB, 0.57278822E-06_JPRB, &
  & 0.57938433E-06_JPRB, 0.58409967E-06_JPRB, 0.58655343E-06_JPRB, 0.58704256E-06_JPRB, 0.58570134E-06_JPRB, 0.58232285E-06_JPRB, &
  & 0.57630211E-06_JPRB, 0.56588459E-06_JPRB, 0.54848982E-06_JPRB, 0.52043237E-06_JPRB, 0.48047747E-06_JPRB, 0.43012696E-06_JPRB, &
  & 0.37519229E-06_JPRB, 0.32257628E-06_JPRB, 0.27821261E-06_JPRB, 0.24282375E-06_JPRB, 0.21508026E-06_JPRB, 0.19278201E-06_JPRB, &
  & 0.17450186E-06_JPRB, 0.15899759E-06_JPRB, 0.14551696E-06_JPRB, 0.13355262E-06_JPRB, 0.12281384E-06_JPRB, 0.11349489E-06_JPRB, &
  & 0.10600318E-06_JPRB, 0.10044128E-06_JPRB, 0.97237191E-07_JPRB, 0.96721386E-07_JPRB, 0.98398452E-07_JPRB, 0.10247936E-06_JPRB, &
  & 0.10845219E-06_JPRB, 0.11666277E-06_JPRB, 0.12721227E-06_JPRB, 0.14085370E-06_JPRB, 0.15828742E-06_JPRB, 0.18137709E-06_JPRB, &
  & 0.21137370E-06_JPRB, 0.24976796E-06_JPRB, 0.29735068E-06_JPRB, 0.35308113E-06_JPRB, 0.41267475E-06_JPRB, 0.47394857E-06_JPRB, &
  & 0.53464191E-06_JPRB, 0.59420665E-06_JPRB, 0.65200010E-06_JPRB, 0.70683336E-06_JPRB, 0.75684551E-06_JPRB, 0.80225334E-06_JPRB, &
  & 0.84361852E-06_JPRB, 0.88320974E-06_JPRB, 0.92264668E-06_JPRB, 0.96335771E-06_JPRB, 0.10051920E-05_JPRB, 0.10470219E-05_JPRB, &
  & 0.10876403E-05_JPRB, 0.11280764E-05_JPRB, 0.11738128E-05_JPRB, 0.12565447E-05_JPRB /)

RGHG7(:,43,11) = (/ &
  & 0.53969524E-06_JPRB, 0.54317763E-06_JPRB, 0.54596467E-06_JPRB, 0.54883935E-06_JPRB, 0.55234705E-06_JPRB, 0.55532826E-06_JPRB, &
  & 0.55707051E-06_JPRB, 0.55697177E-06_JPRB, 0.55527278E-06_JPRB, 0.55230788E-06_JPRB, 0.54806458E-06_JPRB, 0.54234954E-06_JPRB, &
  & 0.53417284E-06_JPRB, 0.52199073E-06_JPRB, 0.50280647E-06_JPRB, 0.47356039E-06_JPRB, 0.43231631E-06_JPRB, 0.38233833E-06_JPRB, &
  & 0.33021379E-06_JPRB, 0.28372563E-06_JPRB, 0.24600885E-06_JPRB, 0.21682141E-06_JPRB, 0.19391923E-06_JPRB, 0.17529028E-06_JPRB, &
  & 0.15963195E-06_JPRB, 0.14608325E-06_JPRB, 0.13401869E-06_JPRB, 0.12319066E-06_JPRB, 0.11336345E-06_JPRB, 0.10469420E-06_JPRB, &
  & 0.97947932E-07_JPRB, 0.92518761E-07_JPRB, 0.89839332E-07_JPRB, 0.89159066E-07_JPRB, 0.90958771E-07_JPRB, 0.94670021E-07_JPRB, &
  & 0.10024699E-06_JPRB, 0.10760160E-06_JPRB, 0.11693211E-06_JPRB, 0.12861764E-06_JPRB, 0.14343860E-06_JPRB, 0.16256045E-06_JPRB, &
  & 0.18705194E-06_JPRB, 0.21853653E-06_JPRB, 0.25806813E-06_JPRB, 0.30484270E-06_JPRB, 0.35766510E-06_JPRB, 0.41269868E-06_JPRB, &
  & 0.46837164E-06_JPRB, 0.52387253E-06_JPRB, 0.57834160E-06_JPRB, 0.62973271E-06_JPRB, 0.67642992E-06_JPRB, 0.71763623E-06_JPRB, &
  & 0.75475282E-06_JPRB, 0.78977666E-06_JPRB, 0.82460201E-06_JPRB, 0.86069048E-06_JPRB, 0.89803893E-06_JPRB, 0.93545418E-06_JPRB, &
  & 0.97201939E-06_JPRB, 0.10087122E-05_JPRB, 0.10509810E-05_JPRB, 0.11284785E-05_JPRB /)

RGHG7(:,44,11) = (/ &
  & 0.53455381E-06_JPRB, 0.53476100E-06_JPRB, 0.53486673E-06_JPRB, 0.53499696E-06_JPRB, 0.53455705E-06_JPRB, 0.53296452E-06_JPRB, &
  & 0.52997558E-06_JPRB, 0.52569163E-06_JPRB, 0.52045419E-06_JPRB, 0.51465008E-06_JPRB, 0.50824411E-06_JPRB, 0.50074459E-06_JPRB, &
  & 0.49127806E-06_JPRB, 0.47792338E-06_JPRB, 0.45790202E-06_JPRB, 0.42763835E-06_JPRB, 0.38635250E-06_JPRB, 0.33805185E-06_JPRB, &
  & 0.29077859E-06_JPRB, 0.25064767E-06_JPRB, 0.21959255E-06_JPRB, 0.19580038E-06_JPRB, 0.17687118E-06_JPRB, 0.16113646E-06_JPRB, &
  & 0.14753692E-06_JPRB, 0.13550800E-06_JPRB, 0.12450593E-06_JPRB, 0.11449746E-06_JPRB, 0.10537087E-06_JPRB, 0.97199518E-07_JPRB, &
  & 0.91034224E-07_JPRB, 0.85841940E-07_JPRB, 0.83497852E-07_JPRB, 0.82857987E-07_JPRB, 0.84694484E-07_JPRB, 0.88213618E-07_JPRB, &
  & 0.93474114E-07_JPRB, 0.10020177E-06_JPRB, 0.10857156E-06_JPRB, 0.11877221E-06_JPRB, 0.13143095E-06_JPRB, 0.14733273E-06_JPRB, &
  & 0.16749881E-06_JPRB, 0.19312151E-06_JPRB, 0.22513190E-06_JPRB, 0.26455160E-06_JPRB, 0.30980280E-06_JPRB, 0.35893518E-06_JPRB, &
  & 0.40928001E-06_JPRB, 0.46001423E-06_JPRB, 0.51026717E-06_JPRB, 0.55787865E-06_JPRB, 0.60058073E-06_JPRB, 0.63751480E-06_JPRB, &
  & 0.67051809E-06_JPRB, 0.70124486E-06_JPRB, 0.73185964E-06_JPRB, 0.76355138E-06_JPRB, 0.79619349E-06_JPRB, 0.82869900E-06_JPRB, &
  & 0.86039631E-06_JPRB, 0.89223278E-06_JPRB, 0.92941832E-06_JPRB, 0.99882868E-06_JPRB /)

RGHG7(:,45,11) = (/ &
  & 0.52295320E-06_JPRB, 0.51992743E-06_JPRB, 0.51779728E-06_JPRB, 0.51501519E-06_JPRB, 0.51073027E-06_JPRB, 0.50449739E-06_JPRB, &
  & 0.49701464E-06_JPRB, 0.48891525E-06_JPRB, 0.48066829E-06_JPRB, 0.47265326E-06_JPRB, 0.46467861E-06_JPRB, 0.45616670E-06_JPRB, &
  & 0.44596166E-06_JPRB, 0.43231739E-06_JPRB, 0.41226593E-06_JPRB, 0.38219827E-06_JPRB, 0.34190114E-06_JPRB, 0.29684597E-06_JPRB, &
  & 0.25559885E-06_JPRB, 0.22261536E-06_JPRB, 0.19764872E-06_JPRB, 0.17835939E-06_JPRB, 0.16275223E-06_JPRB, 0.14933778E-06_JPRB, &
  & 0.13739840E-06_JPRB, 0.12652283E-06_JPRB, 0.11641226E-06_JPRB, 0.10693622E-06_JPRB, 0.98357745E-07_JPRB, 0.90647731E-07_JPRB, &
  & 0.84880760E-07_JPRB, 0.80040010E-07_JPRB, 0.77910364E-07_JPRB, 0.77426250E-07_JPRB, 0.79256331E-07_JPRB, 0.82702286E-07_JPRB, &
  & 0.87701238E-07_JPRB, 0.93968573E-07_JPRB, 0.10156262E-06_JPRB, 0.11058147E-06_JPRB, 0.12148166E-06_JPRB, 0.13485221E-06_JPRB, &
  & 0.15140255E-06_JPRB, 0.17201988E-06_JPRB, 0.19782259E-06_JPRB, 0.22974974E-06_JPRB, 0.26823673E-06_JPRB, 0.31093458E-06_JPRB, &
  & 0.35587442E-06_JPRB, 0.40172890E-06_JPRB, 0.44725371E-06_JPRB, 0.49014710E-06_JPRB, 0.52823776E-06_JPRB, 0.56101550E-06_JPRB, &
  & 0.58972751E-06_JPRB, 0.61662905E-06_JPRB, 0.64317896E-06_JPRB, 0.67057823E-06_JPRB, 0.69855997E-06_JPRB, 0.72600477E-06_JPRB, &
  & 0.75232316E-06_JPRB, 0.77888450E-06_JPRB, 0.81000326E-06_JPRB, 0.86944584E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART22',0,ZHOOK_HANDLE)



RGHG7(:,46,11) = (/ &
  & 0.50429924E-06_JPRB, 0.49829077E-06_JPRB, 0.49391718E-06_JPRB, 0.48840235E-06_JPRB, 0.48042745E-06_JPRB, 0.46942932E-06_JPRB, &
  & 0.45779819E-06_JPRB, 0.44628669E-06_JPRB, 0.43552950E-06_JPRB, 0.42598879E-06_JPRB, 0.41709956E-06_JPRB, 0.40812239E-06_JPRB, &
  & 0.39793039E-06_JPRB, 0.38461732E-06_JPRB, 0.36504534E-06_JPRB, 0.33641390E-06_JPRB, 0.29832432E-06_JPRB, 0.25885893E-06_JPRB, &
  & 0.22482227E-06_JPRB, 0.19890622E-06_JPRB, 0.17931906E-06_JPRB, 0.16388356E-06_JPRB, 0.15084227E-06_JPRB, 0.13931412E-06_JPRB, &
  & 0.12871543E-06_JPRB, 0.11873583E-06_JPRB, 0.10930512E-06_JPRB, 0.10027611E-06_JPRB, 0.92060837E-07_JPRB, 0.84800760E-07_JPRB, &
  & 0.79318333E-07_JPRB, 0.74894636E-07_JPRB, 0.72924536E-07_JPRB, 0.72654117E-07_JPRB, 0.74471103E-07_JPRB, 0.77904346E-07_JPRB, &
  & 0.82694186E-07_JPRB, 0.88620816E-07_JPRB, 0.95591076E-07_JPRB, 0.10366591E-06_JPRB, 0.11315363E-06_JPRB, 0.12445469E-06_JPRB, &
  & 0.13809418E-06_JPRB, 0.15461001E-06_JPRB, 0.17488426E-06_JPRB, 0.20022490E-06_JPRB, 0.23138736E-06_JPRB, 0.26775757E-06_JPRB, &
  & 0.30727736E-06_JPRB, 0.34801303E-06_JPRB, 0.38838462E-06_JPRB, 0.42642282E-06_JPRB, 0.45936017E-06_JPRB, 0.48767481E-06_JPRB, &
  & 0.51232877E-06_JPRB, 0.53539446E-06_JPRB, 0.55812984E-06_JPRB, 0.58143507E-06_JPRB, 0.60486235E-06_JPRB, 0.62734415E-06_JPRB, &
  & 0.64869965E-06_JPRB, 0.66997643E-06_JPRB, 0.69527454E-06_JPRB, 0.74417272E-06_JPRB /)

RGHG7(:,47,11) = (/ &
  & 0.47815837E-06_JPRB, 0.46925842E-06_JPRB, 0.46288878E-06_JPRB, 0.45507915E-06_JPRB, 0.44323946E-06_JPRB, 0.42822975E-06_JPRB, &
  & 0.41249865E-06_JPRB, 0.39813230E-06_JPRB, 0.38563491E-06_JPRB, 0.37510469E-06_JPRB, 0.36598368E-06_JPRB, 0.35715874E-06_JPRB, &
  & 0.34740719E-06_JPRB, 0.33488303E-06_JPRB, 0.31701518E-06_JPRB, 0.29031443E-06_JPRB, 0.25727761E-06_JPRB, 0.22458144E-06_JPRB, &
  & 0.19859603E-06_JPRB, 0.17899842E-06_JPRB, 0.16401759E-06_JPRB, 0.15163575E-06_JPRB, 0.14075805E-06_JPRB, 0.13067445E-06_JPRB, &
  & 0.12114529E-06_JPRB, 0.11189289E-06_JPRB, 0.10294313E-06_JPRB, 0.94293711E-07_JPRB, 0.86344329E-07_JPRB, 0.79489027E-07_JPRB, &
  & 0.74292693E-07_JPRB, 0.70275156E-07_JPRB, 0.68451371E-07_JPRB, 0.68421571E-07_JPRB, 0.70238258E-07_JPRB, 0.73677946E-07_JPRB, &
  & 0.78322905E-07_JPRB, 0.83973916E-07_JPRB, 0.90450847E-07_JPRB, 0.97776571E-07_JPRB, 0.10613086E-06_JPRB, 0.11580484E-06_JPRB, &
  & 0.12706884E-06_JPRB, 0.14029436E-06_JPRB, 0.15600200E-06_JPRB, 0.17532250E-06_JPRB, 0.19945935E-06_JPRB, 0.22897571E-06_JPRB, &
  & 0.26237819E-06_JPRB, 0.29791013E-06_JPRB, 0.33337827E-06_JPRB, 0.36572396E-06_JPRB, 0.39417080E-06_JPRB, 0.41771483E-06_JPRB, &
  & 0.43865265E-06_JPRB, 0.45803063E-06_JPRB, 0.47719129E-06_JPRB, 0.49670604E-06_JPRB, 0.51593469E-06_JPRB, 0.53412043E-06_JPRB, &
  & 0.55095126E-06_JPRB, 0.56786894E-06_JPRB, 0.58786185E-06_JPRB, 0.62745130E-06_JPRB /)

RGHG7(:,48,11) = (/ &
  & 0.44451610E-06_JPRB, 0.43292661E-06_JPRB, 0.42491061E-06_JPRB, 0.41476505E-06_JPRB, 0.40034197E-06_JPRB, 0.38099191E-06_JPRB, &
  & 0.36213581E-06_JPRB, 0.34552346E-06_JPRB, 0.33174956E-06_JPRB, 0.32110884E-06_JPRB, 0.31220313E-06_JPRB, 0.30398644E-06_JPRB, &
  & 0.29515274E-06_JPRB, 0.28405177E-06_JPRB, 0.26827897E-06_JPRB, 0.24599345E-06_JPRB, 0.21942998E-06_JPRB, 0.19530550E-06_JPRB, &
  & 0.17660322E-06_JPRB, 0.16257847E-06_JPRB, 0.15123150E-06_JPRB, 0.14132392E-06_JPRB, 0.13208867E-06_JPRB, 0.12318016E-06_JPRB, &
  & 0.11443885E-06_JPRB, 0.10575034E-06_JPRB, 0.97130872E-07_JPRB, 0.88838206E-07_JPRB, 0.81122103E-07_JPRB, 0.74615073E-07_JPRB, &
  & 0.69732238E-07_JPRB, 0.66113955E-07_JPRB, 0.64434218E-07_JPRB, 0.64627933E-07_JPRB, 0.66502444E-07_JPRB, 0.69932504E-07_JPRB, &
  & 0.74483815E-07_JPRB, 0.79907977E-07_JPRB, 0.85995303E-07_JPRB, 0.92717457E-07_JPRB, 0.10017445E-06_JPRB, 0.10855095E-06_JPRB, &
  & 0.11799212E-06_JPRB, 0.12860097E-06_JPRB, 0.14069504E-06_JPRB, 0.15489969E-06_JPRB, 0.17259372E-06_JPRB, 0.19467092E-06_JPRB, &
  & 0.22134792E-06_JPRB, 0.25090318E-06_JPRB, 0.28069314E-06_JPRB, 0.30844456E-06_JPRB, 0.33157653E-06_JPRB, 0.35149182E-06_JPRB, &
  & 0.36866567E-06_JPRB, 0.38492334E-06_JPRB, 0.40090350E-06_JPRB, 0.41710271E-06_JPRB, 0.43285254E-06_JPRB, 0.44734225E-06_JPRB, &
  & 0.46073063E-06_JPRB, 0.47397674E-06_JPRB, 0.48990364E-06_JPRB, 0.52190160E-06_JPRB /)

RGHG7(:,49,11) = (/ &
  & 0.40387894E-06_JPRB, 0.39001034E-06_JPRB, 0.38044760E-06_JPRB, 0.36880354E-06_JPRB, 0.35141940E-06_JPRB, 0.32923293E-06_JPRB, &
  & 0.30732343E-06_JPRB, 0.28928085E-06_JPRB, 0.27535941E-06_JPRB, 0.26510935E-06_JPRB, 0.25713135E-06_JPRB, 0.25003496E-06_JPRB, &
  & 0.24261746E-06_JPRB, 0.23383519E-06_JPRB, 0.22154750E-06_JPRB, 0.20554181E-06_JPRB, 0.18709105E-06_JPRB, 0.17111630E-06_JPRB, &
  & 0.15873678E-06_JPRB, 0.14894010E-06_JPRB, 0.14049535E-06_JPRB, 0.13250541E-06_JPRB, 0.12459111E-06_JPRB, 0.11658003E-06_JPRB, &
  & 0.10841429E-06_JPRB, 0.10014878E-06_JPRB, 0.91795286E-07_JPRB, 0.83740247E-07_JPRB, 0.76323090E-07_JPRB, 0.70148857E-07_JPRB, &
  & 0.65568280E-07_JPRB, 0.62346231E-07_JPRB, 0.60852337E-07_JPRB, 0.61196211E-07_JPRB, 0.63199373E-07_JPRB, 0.66602801E-07_JPRB, &
  & 0.71096501E-07_JPRB, 0.76324255E-07_JPRB, 0.82104009E-07_JPRB, 0.88338631E-07_JPRB, 0.95098343E-07_JPRB, 0.10247548E-06_JPRB, &
  & 0.11049463E-06_JPRB, 0.11914327E-06_JPRB, 0.12841785E-06_JPRB, 0.13873074E-06_JPRB, 0.15086091E-06_JPRB, 0.16606462E-06_JPRB, &
  & 0.18504785E-06_JPRB, 0.20735693E-06_JPRB, 0.23107293E-06_JPRB, 0.25293193E-06_JPRB, 0.27209899E-06_JPRB, 0.28803390E-06_JPRB, &
  & 0.30229850E-06_JPRB, 0.31577119E-06_JPRB, 0.32916140E-06_JPRB, 0.34269695E-06_JPRB, 0.35558296E-06_JPRB, 0.36735656E-06_JPRB, &
  & 0.37799518E-06_JPRB, 0.38859585E-06_JPRB, 0.40146267E-06_JPRB, 0.42776253E-06_JPRB /)

RGHG7(:,50,11) = (/ &
  & 0.35755804E-06_JPRB, 0.34179865E-06_JPRB, 0.33116746E-06_JPRB, 0.31813457E-06_JPRB, 0.29891456E-06_JPRB, 0.27388586E-06_JPRB, &
  & 0.25074033E-06_JPRB, 0.23260165E-06_JPRB, 0.21967988E-06_JPRB, 0.21101452E-06_JPRB, 0.20465082E-06_JPRB, 0.19932271E-06_JPRB, &
  & 0.19428393E-06_JPRB, 0.18828213E-06_JPRB, 0.18128644E-06_JPRB, 0.17154913E-06_JPRB, 0.16132425E-06_JPRB, 0.15190159E-06_JPRB, &
  & 0.14427688E-06_JPRB, 0.13770041E-06_JPRB, 0.13138795E-06_JPRB, 0.12490315E-06_JPRB, 0.11801252E-06_JPRB, 0.11067453E-06_JPRB, &
  & 0.10293741E-06_JPRB, 0.94913233E-07_JPRB, 0.86772452E-07_JPRB, 0.79007116E-07_JPRB, 0.71883598E-07_JPRB, 0.66061091E-07_JPRB, &
  & 0.61768105E-07_JPRB, 0.58900909E-07_JPRB, 0.57656919E-07_JPRB, 0.58120399E-07_JPRB, 0.60225673E-07_JPRB, 0.63656628E-07_JPRB, &
  & 0.68069149E-07_JPRB, 0.73153046E-07_JPRB, 0.78664755E-07_JPRB, 0.84518291E-07_JPRB, 0.90732094E-07_JPRB, 0.97347197E-07_JPRB, &
  & 0.10431121E-06_JPRB, 0.11147321E-06_JPRB, 0.11871204E-06_JPRB, 0.12607691E-06_JPRB, 0.13408979E-06_JPRB, 0.14361224E-06_JPRB, &
  & 0.15548902E-06_JPRB, 0.16996907E-06_JPRB, 0.18590998E-06_JPRB, 0.20175914E-06_JPRB, 0.21565580E-06_JPRB, 0.22808641E-06_JPRB, &
  & 0.23941297E-06_JPRB, 0.25038000E-06_JPRB, 0.26155595E-06_JPRB, 0.27283477E-06_JPRB, 0.28350473E-06_JPRB, 0.29315080E-06_JPRB, &
  & 0.30177767E-06_JPRB, 0.31047742E-06_JPRB, 0.32111660E-06_JPRB, 0.34378019E-06_JPRB /)

RGHG7(:,51,11) = (/ &
  & 0.30786973E-06_JPRB, 0.29093908E-06_JPRB, 0.27955593E-06_JPRB, 0.26560994E-06_JPRB, 0.24532255E-06_JPRB, 0.21995984E-06_JPRB, &
  & 0.19753925E-06_JPRB, 0.18217604E-06_JPRB, 0.17224853E-06_JPRB, 0.16607980E-06_JPRB, 0.16195629E-06_JPRB, 0.15883150E-06_JPRB, &
  & 0.15602569E-06_JPRB, 0.15343484E-06_JPRB, 0.15004798E-06_JPRB, 0.14625616E-06_JPRB, 0.14147409E-06_JPRB, 0.13686105E-06_JPRB, &
  & 0.13253216E-06_JPRB, 0.12820928E-06_JPRB, 0.12353286E-06_JPRB, 0.11821698E-06_JPRB, 0.11212028E-06_JPRB, 0.10531075E-06_JPRB, &
  & 0.97844996E-07_JPRB, 0.90000725E-07_JPRB, 0.82099717E-07_JPRB, 0.74534533E-07_JPRB, 0.67815414E-07_JPRB, 0.62322037E-07_JPRB, &
  & 0.58316640E-07_JPRB, 0.55747925E-07_JPRB, 0.54762349E-07_JPRB, 0.55386238E-07_JPRB, 0.57539253E-07_JPRB, 0.61018312E-07_JPRB, &
  & 0.65354584E-07_JPRB, 0.70304900E-07_JPRB, 0.75592055E-07_JPRB, 0.81136086E-07_JPRB, 0.86932161E-07_JPRB, 0.92985786E-07_JPRB, &
  & 0.99157198E-07_JPRB, 0.10524287E-06_JPRB, 0.11095839E-06_JPRB, 0.11625860E-06_JPRB, 0.12138865E-06_JPRB, 0.12690555E-06_JPRB, &
  & 0.13343669E-06_JPRB, 0.14123535E-06_JPRB, 0.15000334E-06_JPRB, 0.15883953E-06_JPRB, 0.16745602E-06_JPRB, 0.17543510E-06_JPRB, &
  & 0.18327670E-06_JPRB, 0.19146563E-06_JPRB, 0.20002881E-06_JPRB, 0.20892087E-06_JPRB, 0.21747906E-06_JPRB, 0.22516548E-06_JPRB, &
  & 0.23212451E-06_JPRB, 0.23920526E-06_JPRB, 0.24836373E-06_JPRB, 0.26816693E-06_JPRB /)

RGHG7(:,52,11) = (/ &
  & 0.25859896E-06_JPRB, 0.24121479E-06_JPRB, 0.22989170E-06_JPRB, 0.21621692E-06_JPRB, 0.19666642E-06_JPRB, 0.17360924E-06_JPRB, &
  & 0.15624906E-06_JPRB, 0.14530869E-06_JPRB, 0.13897612E-06_JPRB, 0.13539253E-06_JPRB, 0.13311519E-06_JPRB, 0.13160543E-06_JPRB, &
  & 0.13049345E-06_JPRB, 0.12954824E-06_JPRB, 0.12884250E-06_JPRB, 0.12789346E-06_JPRB, 0.12663087E-06_JPRB, 0.12493426E-06_JPRB, &
  & 0.12279922E-06_JPRB, 0.12009511E-06_JPRB, 0.11661044E-06_JPRB, 0.11218660E-06_JPRB, 0.10676192E-06_JPRB, 0.10029093E-06_JPRB, &
  & 0.93096055E-07_JPRB, 0.85390717E-07_JPRB, 0.77660026E-07_JPRB, 0.70436656E-07_JPRB, 0.64051399E-07_JPRB, 0.58915607E-07_JPRB, &
  & 0.55190075E-07_JPRB, 0.52892620E-07_JPRB, 0.52126417E-07_JPRB, 0.52921493E-07_JPRB, 0.55146678E-07_JPRB, 0.58589222E-07_JPRB, &
  & 0.62922020E-07_JPRB, 0.67702047E-07_JPRB, 0.72808305E-07_JPRB, 0.78094075E-07_JPRB, 0.83579955E-07_JPRB, 0.89206303E-07_JPRB, &
  & 0.94815157E-07_JPRB, 0.10006963E-06_JPRB, 0.10469216E-06_JPRB, 0.10850669E-06_JPRB, 0.11172921E-06_JPRB, 0.11474867E-06_JPRB, &
  & 0.11798230E-06_JPRB, 0.12159205E-06_JPRB, 0.12552108E-06_JPRB, 0.12959907E-06_JPRB, 0.13358358E-06_JPRB, 0.13770976E-06_JPRB, &
  & 0.14211335E-06_JPRB, 0.14693624E-06_JPRB, 0.15251705E-06_JPRB, 0.15850416E-06_JPRB, 0.16441786E-06_JPRB, 0.16980948E-06_JPRB, &
  & 0.17473515E-06_JPRB, 0.18000320E-06_JPRB, 0.18698147E-06_JPRB, 0.20358078E-06_JPRB /)

RGHG7(:,53,11) = (/ &
  & 0.21374900E-06_JPRB, 0.19775810E-06_JPRB, 0.18712186E-06_JPRB, 0.17495574E-06_JPRB, 0.15840904E-06_JPRB, 0.14100610E-06_JPRB, &
  & 0.12879160E-06_JPRB, 0.12212527E-06_JPRB, 0.11846171E-06_JPRB, 0.11645220E-06_JPRB, 0.11530526E-06_JPRB, 0.11459469E-06_JPRB, &
  & 0.11422654E-06_JPRB, 0.11413463E-06_JPRB, 0.11433585E-06_JPRB, 0.11476406E-06_JPRB, 0.11525390E-06_JPRB, 0.11525434E-06_JPRB, &
  & 0.11454833E-06_JPRB, 0.11295187E-06_JPRB, 0.11036047E-06_JPRB, 0.10665759E-06_JPRB, 0.10168718E-06_JPRB, 0.95604562E-07_JPRB, &
  & 0.88526235E-07_JPRB, 0.81044348E-07_JPRB, 0.73573368E-07_JPRB, 0.66626946E-07_JPRB, 0.60612287E-07_JPRB, 0.55796786E-07_JPRB, &
  & 0.52364477E-07_JPRB, 0.50321031E-07_JPRB, 0.49750806E-07_JPRB, 0.50672803E-07_JPRB, 0.52990409E-07_JPRB, 0.56398910E-07_JPRB, &
  & 0.60656134E-07_JPRB, 0.65323519E-07_JPRB, 0.70245875E-07_JPRB, 0.75319633E-07_JPRB, 0.80555196E-07_JPRB, 0.85879833E-07_JPRB, &
  & 0.91033591E-07_JPRB, 0.95696421E-07_JPRB, 0.99455306E-07_JPRB, 0.10226832E-06_JPRB, 0.10428368E-06_JPRB, 0.10589245E-06_JPRB, &
  & 0.10738992E-06_JPRB, 0.10895400E-06_JPRB, 0.11059954E-06_JPRB, 0.11230015E-06_JPRB, 0.11409897E-06_JPRB, 0.11600395E-06_JPRB, &
  & 0.11814313E-06_JPRB, 0.12078600E-06_JPRB, 0.12383003E-06_JPRB, 0.12732139E-06_JPRB, 0.13077349E-06_JPRB, 0.13389374E-06_JPRB, &
  & 0.13677010E-06_JPRB, 0.13982655E-06_JPRB, 0.14407226E-06_JPRB, 0.15540471E-06_JPRB /)

RGHG7(:,54,11) = (/ &
  & 0.17718547E-06_JPRB, 0.16303765E-06_JPRB, 0.15446430E-06_JPRB, 0.14468974E-06_JPRB, 0.13214294E-06_JPRB, 0.11955507E-06_JPRB, &
  & 0.11196546E-06_JPRB, 0.10784460E-06_JPRB, 0.10571946E-06_JPRB, 0.10455768E-06_JPRB, 0.10391435E-06_JPRB, 0.10356506E-06_JPRB, &
  & 0.10344808E-06_JPRB, 0.10360598E-06_JPRB, 0.10406445E-06_JPRB, 0.10503840E-06_JPRB, 0.10619198E-06_JPRB, 0.10717155E-06_JPRB, &
  & 0.10736133E-06_JPRB, 0.10654765E-06_JPRB, 0.10460844E-06_JPRB, 0.10141379E-06_JPRB, 0.96901900E-07_JPRB, 0.91027786E-07_JPRB, &
  & 0.84262759E-07_JPRB, 0.76936018E-07_JPRB, 0.69751458E-07_JPRB, 0.63130379E-07_JPRB, 0.57443508E-07_JPRB, 0.52953670E-07_JPRB, &
  & 0.49801297E-07_JPRB, 0.48011483E-07_JPRB, 0.47617711E-07_JPRB, 0.48633559E-07_JPRB, 0.50984816E-07_JPRB, 0.54409131E-07_JPRB, &
  & 0.58527387E-07_JPRB, 0.63119636E-07_JPRB, 0.67848973E-07_JPRB, 0.72759356E-07_JPRB, 0.77784321E-07_JPRB, 0.82842313E-07_JPRB, &
  & 0.87674131E-07_JPRB, 0.91815075E-07_JPRB, 0.94984038E-07_JPRB, 0.97086357E-07_JPRB, 0.98412805E-07_JPRB, 0.99288172E-07_JPRB, &
  & 0.10001025E-06_JPRB, 0.10070858E-06_JPRB, 0.10145798E-06_JPRB, 0.10226140E-06_JPRB, 0.10311645E-06_JPRB, 0.10408278E-06_JPRB, &
  & 0.10525372E-06_JPRB, 0.10663249E-06_JPRB, 0.10840659E-06_JPRB, 0.11036943E-06_JPRB, 0.11230658E-06_JPRB, 0.11400361E-06_JPRB, &
  & 0.11547501E-06_JPRB, 0.11689517E-06_JPRB, 0.11872709E-06_JPRB, 0.12361591E-06_JPRB /)

RGHG7(:,55,11) = (/ &
  & 0.14935560E-06_JPRB, 0.13802655E-06_JPRB, 0.13110467E-06_JPRB, 0.12379240E-06_JPRB, 0.11447074E-06_JPRB, 0.10598303E-06_JPRB, &
  & 0.10090805E-06_JPRB, 0.98379097E-07_JPRB, 0.97056564E-07_JPRB, 0.96358207E-07_JPRB, 0.95951812E-07_JPRB, 0.95753734E-07_JPRB, &
  & 0.95721447E-07_JPRB, 0.95880807E-07_JPRB, 0.96388874E-07_JPRB, 0.97289266E-07_JPRB, 0.98776724E-07_JPRB, 0.10020735E-06_JPRB, &
  & 0.10096286E-06_JPRB, 0.10067969E-06_JPRB, 0.99204364E-07_JPRB, 0.96418319E-07_JPRB, 0.92209284E-07_JPRB, 0.86686505E-07_JPRB, &
  & 0.80112919E-07_JPRB, 0.73142076E-07_JPRB, 0.66191085E-07_JPRB, 0.59896159E-07_JPRB, 0.54525543E-07_JPRB, 0.50349936E-07_JPRB, &
  & 0.47485933E-07_JPRB, 0.45925979E-07_JPRB, 0.45689468E-07_JPRB, 0.46775799E-07_JPRB, 0.49121979E-07_JPRB, 0.52507129E-07_JPRB, &
  & 0.56578596E-07_JPRB, 0.60978948E-07_JPRB, 0.65616526E-07_JPRB, 0.70351035E-07_JPRB, 0.75182150E-07_JPRB, 0.80027171E-07_JPRB, &
  & 0.84537014E-07_JPRB, 0.88303096E-07_JPRB, 0.91011522E-07_JPRB, 0.92695679E-07_JPRB, 0.93639962E-07_JPRB, 0.94200047E-07_JPRB, &
  & 0.94612389E-07_JPRB, 0.95008254E-07_JPRB, 0.95426245E-07_JPRB, 0.95885241E-07_JPRB, 0.96396725E-07_JPRB, 0.96975263E-07_JPRB, &
  & 0.97645994E-07_JPRB, 0.98521127E-07_JPRB, 0.99566932E-07_JPRB, 0.10078771E-06_JPRB, 0.10196607E-06_JPRB, 0.10298690E-06_JPRB, &
  & 0.10383957E-06_JPRB, 0.10471952E-06_JPRB, 0.10568036E-06_JPRB, 0.10753053E-06_JPRB /)

RGHG7(:,56,11) = (/ &
  & 0.12870454E-06_JPRB, 0.11981801E-06_JPRB, 0.11468826E-06_JPRB, 0.10936482E-06_JPRB, 0.10263534E-06_JPRB, 0.96568385E-07_JPRB, &
  & 0.93258606E-07_JPRB, 0.91549744E-07_JPRB, 0.90662539E-07_JPRB, 0.90169621E-07_JPRB, 0.89873836E-07_JPRB, 0.89706568E-07_JPRB, &
  & 0.89668639E-07_JPRB, 0.89800118E-07_JPRB, 0.90161869E-07_JPRB, 0.91018642E-07_JPRB, 0.92385484E-07_JPRB, 0.94048282E-07_JPRB, &
  & 0.95146511E-07_JPRB, 0.95207575E-07_JPRB, 0.94062315E-07_JPRB, 0.91580866E-07_JPRB, 0.87675559E-07_JPRB, 0.82421813E-07_JPRB, &
  & 0.76200173E-07_JPRB, 0.69480997E-07_JPRB, 0.62894230E-07_JPRB, 0.56874836E-07_JPRB, 0.51830785E-07_JPRB, 0.47975551E-07_JPRB, &
  & 0.45380865E-07_JPRB, 0.44038394E-07_JPRB, 0.43928914E-07_JPRB, 0.45055963E-07_JPRB, 0.47376112E-07_JPRB, 0.50687053E-07_JPRB, &
  & 0.54666177E-07_JPRB, 0.58988864E-07_JPRB, 0.63473713E-07_JPRB, 0.68045843E-07_JPRB, 0.72714776E-07_JPRB, 0.77336793E-07_JPRB, &
  & 0.81558419E-07_JPRB, 0.85024851E-07_JPRB, 0.87422798E-07_JPRB, 0.88863509E-07_JPRB, 0.89647045E-07_JPRB, 0.90095348E-07_JPRB, &
  & 0.90435229E-07_JPRB, 0.90753517E-07_JPRB, 0.91093227E-07_JPRB, 0.91450239E-07_JPRB, 0.91820020E-07_JPRB, 0.92222336E-07_JPRB, &
  & 0.92701953E-07_JPRB, 0.93273769E-07_JPRB, 0.94007092E-07_JPRB, 0.94820976E-07_JPRB, 0.95619441E-07_JPRB, 0.96293554E-07_JPRB, &
  & 0.96913944E-07_JPRB, 0.97534233E-07_JPRB, 0.98458862E-07_JPRB, 0.10094853E-06_JPRB /)

RGHG7(:,57,11) = (/ &
  & 0.11395916E-06_JPRB, 0.10681028E-06_JPRB, 0.10304294E-06_JPRB, 0.99012624E-07_JPRB, 0.94087987E-07_JPRB, 0.89778439E-07_JPRB, &
  & 0.87365905E-07_JPRB, 0.86170218E-07_JPRB, 0.85506635E-07_JPRB, 0.85110614E-07_JPRB, 0.84859629E-07_JPRB, 0.84694847E-07_JPRB, &
  & 0.84625619E-07_JPRB, 0.84685055E-07_JPRB, 0.84954067E-07_JPRB, 0.85570996E-07_JPRB, 0.86836394E-07_JPRB, 0.88489756E-07_JPRB, &
  & 0.89758203E-07_JPRB, 0.90047678E-07_JPRB, 0.89125614E-07_JPRB, 0.86877506E-07_JPRB, 0.83251663E-07_JPRB, 0.78307856E-07_JPRB, &
  & 0.72396517E-07_JPRB, 0.66007644E-07_JPRB, 0.59719873E-07_JPRB, 0.54056642E-07_JPRB, 0.49342173E-07_JPRB, 0.45798870E-07_JPRB, &
  & 0.43471747E-07_JPRB, 0.42315701E-07_JPRB, 0.42304983E-07_JPRB, 0.43447862E-07_JPRB, 0.45715769E-07_JPRB, 0.48940393E-07_JPRB, &
  & 0.52802783E-07_JPRB, 0.57005646E-07_JPRB, 0.61367849E-07_JPRB, 0.65828488E-07_JPRB, 0.70330259E-07_JPRB, 0.74720781E-07_JPRB, &
  & 0.78727865E-07_JPRB, 0.81907878E-07_JPRB, 0.84141611E-07_JPRB, 0.85456939E-07_JPRB, 0.86194660E-07_JPRB, 0.86661530E-07_JPRB, &
  & 0.87031879E-07_JPRB, 0.87394220E-07_JPRB, 0.87738684E-07_JPRB, 0.88072554E-07_JPRB, 0.88398870E-07_JPRB, 0.88735128E-07_JPRB, &
  & 0.89103935E-07_JPRB, 0.89557062E-07_JPRB, 0.90085351E-07_JPRB, 0.90692566E-07_JPRB, 0.91261228E-07_JPRB, 0.91753869E-07_JPRB, &
  & 0.92160207E-07_JPRB, 0.92577118E-07_JPRB, 0.93039041E-07_JPRB, 0.94108223E-07_JPRB /)

RGHG7(:,58,11) = (/ &
  & 0.10160628E-06_JPRB, 0.96884484E-07_JPRB, 0.94205340E-07_JPRB, 0.91496332E-07_JPRB, 0.87745342E-07_JPRB, 0.84466976E-07_JPRB, &
  & 0.82660378E-07_JPRB, 0.81672447E-07_JPRB, 0.81135425E-07_JPRB, 0.80766831E-07_JPRB, 0.80509068E-07_JPRB, 0.80319566E-07_JPRB, &
  & 0.80204984E-07_JPRB, 0.80196209E-07_JPRB, 0.80350667E-07_JPRB, 0.80828947E-07_JPRB, 0.81842401E-07_JPRB, 0.83413127E-07_JPRB, &
  & 0.84727844E-07_JPRB, 0.85126928E-07_JPRB, 0.84357211E-07_JPRB, 0.82319247E-07_JPRB, 0.78933205E-07_JPRB, 0.74306804E-07_JPRB, &
  & 0.68726429E-07_JPRB, 0.62672321E-07_JPRB, 0.56730116E-07_JPRB, 0.51409245E-07_JPRB, 0.47040398E-07_JPRB, 0.43813991E-07_JPRB, &
  & 0.41727933E-07_JPRB, 0.40741380E-07_JPRB, 0.40806750E-07_JPRB, 0.41940744E-07_JPRB, 0.44137234E-07_JPRB, 0.47249035E-07_JPRB, &
  & 0.50984767E-07_JPRB, 0.55076576E-07_JPRB, 0.59325981E-07_JPRB, 0.63652550E-07_JPRB, 0.67991110E-07_JPRB, 0.72222512E-07_JPRB, &
  & 0.75963598E-07_JPRB, 0.79010611E-07_JPRB, 0.81078433E-07_JPRB, 0.82376552E-07_JPRB, 0.83147249E-07_JPRB, 0.83682892E-07_JPRB, &
  & 0.84156184E-07_JPRB, 0.84589352E-07_JPRB, 0.84992507E-07_JPRB, 0.85350308E-07_JPRB, 0.85669548E-07_JPRB, 0.85979906E-07_JPRB, &
  & 0.86312234E-07_JPRB, 0.86683876E-07_JPRB, 0.87136947E-07_JPRB, 0.87623881E-07_JPRB, 0.88092833E-07_JPRB, 0.88489607E-07_JPRB, &
  & 0.88865633E-07_JPRB, 0.89250157E-07_JPRB, 0.89841876E-07_JPRB, 0.91159677E-07_JPRB /)

RGHG7(:,59,11) = (/ &
  & 0.92433034E-07_JPRB, 0.89459839E-07_JPRB, 0.87704841E-07_JPRB, 0.85502798E-07_JPRB, 0.82748507E-07_JPRB, 0.80181472E-07_JPRB, &
  & 0.78655631E-07_JPRB, 0.77814306E-07_JPRB, 0.77273306E-07_JPRB, 0.76908997E-07_JPRB, 0.76612025E-07_JPRB, 0.76379465E-07_JPRB, &
  & 0.76208842E-07_JPRB, 0.76122276E-07_JPRB, 0.76168313E-07_JPRB, 0.76488590E-07_JPRB, 0.77329510E-07_JPRB, 0.78722984E-07_JPRB, &
  & 0.79993846E-07_JPRB, 0.80421223E-07_JPRB, 0.79756248E-07_JPRB, 0.77894249E-07_JPRB, 0.74762220E-07_JPRB, 0.70418572E-07_JPRB, &
  & 0.65174305E-07_JPRB, 0.59477372E-07_JPRB, 0.53907282E-07_JPRB, 0.48938624E-07_JPRB, 0.44930399E-07_JPRB, 0.41999890E-07_JPRB, &
  & 0.40147373E-07_JPRB, 0.39313662E-07_JPRB, 0.39441215E-07_JPRB, 0.40550326E-07_JPRB, 0.42651600E-07_JPRB, 0.45625033E-07_JPRB, &
  & 0.49229225E-07_JPRB, 0.53190870E-07_JPRB, 0.57327785E-07_JPRB, 0.61526812E-07_JPRB, 0.65740792E-07_JPRB, 0.69765257E-07_JPRB, &
  & 0.73383390E-07_JPRB, 0.76221291E-07_JPRB, 0.78266424E-07_JPRB, 0.79549864E-07_JPRB, 0.80392226E-07_JPRB, 0.81043929E-07_JPRB, &
  & 0.81627853E-07_JPRB, 0.82182225E-07_JPRB, 0.82656101E-07_JPRB, 0.83046615E-07_JPRB, 0.83385871E-07_JPRB, 0.83696484E-07_JPRB, &
  & 0.84011127E-07_JPRB, 0.84368722E-07_JPRB, 0.84763890E-07_JPRB, 0.85192262E-07_JPRB, 0.85592788E-07_JPRB, 0.85940094E-07_JPRB, &
  & 0.86226514E-07_JPRB, 0.86526803E-07_JPRB, 0.86898048E-07_JPRB, 0.87937259E-07_JPRB /)

RGHG7(:,60,11) = (/ &
  & 0.86881684E-07_JPRB, 0.84052665E-07_JPRB, 0.82489834E-07_JPRB, 0.80912464E-07_JPRB, 0.78658736E-07_JPRB, 0.76529162E-07_JPRB, &
  & 0.75184708E-07_JPRB, 0.74356656E-07_JPRB, 0.73818455E-07_JPRB, 0.73401260E-07_JPRB, 0.73056597E-07_JPRB, 0.72758695E-07_JPRB, &
  & 0.72517715E-07_JPRB, 0.72338764E-07_JPRB, 0.72285793E-07_JPRB, 0.72470080E-07_JPRB, 0.73149060E-07_JPRB, 0.74367762E-07_JPRB, &
  & 0.75509178E-07_JPRB, 0.75913903E-07_JPRB, 0.75338058E-07_JPRB, 0.73630538E-07_JPRB, 0.70708587E-07_JPRB, 0.66660839E-07_JPRB, &
  & 0.61747720E-07_JPRB, 0.56422056E-07_JPRB, 0.51225136E-07_JPRB, 0.46640480E-07_JPRB, 0.42992955E-07_JPRB, 0.40353324E-07_JPRB, &
  & 0.38729013E-07_JPRB, 0.38041041E-07_JPRB, 0.38218872E-07_JPRB, 0.39288476E-07_JPRB, 0.41277417E-07_JPRB, 0.44109523E-07_JPRB, &
  & 0.47560789E-07_JPRB, 0.51391329E-07_JPRB, 0.55395475E-07_JPRB, 0.59486247E-07_JPRB, 0.63546565E-07_JPRB, 0.67458963E-07_JPRB, &
  & 0.70873050E-07_JPRB, 0.73653595E-07_JPRB, 0.75613180E-07_JPRB, 0.76953896E-07_JPRB, 0.77879498E-07_JPRB, 0.78641470E-07_JPRB, &
  & 0.79375447E-07_JPRB, 0.80033075E-07_JPRB, 0.80592343E-07_JPRB, 0.81042778E-07_JPRB, 0.81409929E-07_JPRB, 0.81736566E-07_JPRB, &
  & 0.82067714E-07_JPRB, 0.82411738E-07_JPRB, 0.82799843E-07_JPRB, 0.83202487E-07_JPRB, 0.83578506E-07_JPRB, 0.83891557E-07_JPRB, &
  & 0.84185835E-07_JPRB, 0.84489429E-07_JPRB, 0.84923535E-07_JPRB, 0.85858119E-07_JPRB /)

RGHG7(:,61,11) = (/ &
  & 0.81211219E-07_JPRB, 0.79348631E-07_JPRB, 0.78277715E-07_JPRB, 0.76968469E-07_JPRB, 0.75224570E-07_JPRB, 0.73415144E-07_JPRB, &
  & 0.72139073E-07_JPRB, 0.71298516E-07_JPRB, 0.70675341E-07_JPRB, 0.70193856E-07_JPRB, 0.69764596E-07_JPRB, 0.69380071E-07_JPRB, &
  & 0.69041057E-07_JPRB, 0.68758055E-07_JPRB, 0.68593422E-07_JPRB, 0.68667653E-07_JPRB, 0.69219539E-07_JPRB, 0.70268825E-07_JPRB, &
  & 0.71263692E-07_JPRB, 0.71629053E-07_JPRB, 0.71098498E-07_JPRB, 0.69513327E-07_JPRB, 0.66810721E-07_JPRB, 0.63041142E-07_JPRB, &
  & 0.58469144E-07_JPRB, 0.53512018E-07_JPRB, 0.48710810E-07_JPRB, 0.44516906E-07_JPRB, 0.41228951E-07_JPRB, 0.38881172E-07_JPRB, &
  & 0.37478831E-07_JPRB, 0.36928643E-07_JPRB, 0.37148013E-07_JPRB, 0.38171645E-07_JPRB, 0.40048427E-07_JPRB, 0.42736172E-07_JPRB, &
  & 0.46038604E-07_JPRB, 0.49717912E-07_JPRB, 0.53595056E-07_JPRB, 0.57545293E-07_JPRB, 0.61493459E-07_JPRB, 0.65224178E-07_JPRB, &
  & 0.68552723E-07_JPRB, 0.71201363E-07_JPRB, 0.73180530E-07_JPRB, 0.74546300E-07_JPRB, 0.75560976E-07_JPRB, 0.76438134E-07_JPRB, &
  & 0.77284724E-07_JPRB, 0.78079900E-07_JPRB, 0.78734480E-07_JPRB, 0.79239577E-07_JPRB, 0.79658484E-07_JPRB, 0.80023007E-07_JPRB, &
  & 0.80371038E-07_JPRB, 0.80740186E-07_JPRB, 0.81129102E-07_JPRB, 0.81523851E-07_JPRB, 0.81880934E-07_JPRB, 0.82188109E-07_JPRB, &
  & 0.82449461E-07_JPRB, 0.82718529E-07_JPRB, 0.83071896E-07_JPRB, 0.83990784E-07_JPRB /)

RGHG7(:,62,11) = (/ &
  & 0.77624861E-07_JPRB, 0.75721601E-07_JPRB, 0.74712396E-07_JPRB, 0.73668751E-07_JPRB, 0.72235871E-07_JPRB, 0.70647616E-07_JPRB, &
  & 0.69401942E-07_JPRB, 0.68506147E-07_JPRB, 0.67816309E-07_JPRB, 0.67223276E-07_JPRB, 0.66691271E-07_JPRB, 0.66189955E-07_JPRB, &
  & 0.65717138E-07_JPRB, 0.65322212E-07_JPRB, 0.65041206E-07_JPRB, 0.65038144E-07_JPRB, 0.65508885E-07_JPRB, 0.66405960E-07_JPRB, &
  & 0.67247733E-07_JPRB, 0.67548790E-07_JPRB, 0.67045036E-07_JPRB, 0.65575101E-07_JPRB, 0.63070878E-07_JPRB, 0.59581787E-07_JPRB, &
  & 0.55349499E-07_JPRB, 0.50775665E-07_JPRB, 0.46375497E-07_JPRB, 0.42579934E-07_JPRB, 0.39642412E-07_JPRB, 0.37584972E-07_JPRB, &
  & 0.36404387E-07_JPRB, 0.35986268E-07_JPRB, 0.36247968E-07_JPRB, 0.37228627E-07_JPRB, 0.39001193E-07_JPRB, 0.41542616E-07_JPRB, &
  & 0.44682444E-07_JPRB, 0.48199240E-07_JPRB, 0.51929444E-07_JPRB, 0.55759013E-07_JPRB, 0.59543133E-07_JPRB, 0.63167207E-07_JPRB, &
  & 0.66337130E-07_JPRB, 0.68953725E-07_JPRB, 0.70901606E-07_JPRB, 0.72333393E-07_JPRB, 0.73426300E-07_JPRB, 0.74389177E-07_JPRB, &
  & 0.75344886E-07_JPRB, 0.76240461E-07_JPRB, 0.76996741E-07_JPRB, 0.77602103E-07_JPRB, 0.78072304E-07_JPRB, 0.78491013E-07_JPRB, &
  & 0.78880198E-07_JPRB, 0.79277420E-07_JPRB, 0.79686707E-07_JPRB, 0.80089350E-07_JPRB, 0.80448423E-07_JPRB, 0.80749111E-07_JPRB, &
  & 0.81018648E-07_JPRB, 0.81296584E-07_JPRB, 0.81667316E-07_JPRB, 0.82494658E-07_JPRB /)

RGHG7(:,63,11) = (/ &
  & 0.73767666E-07_JPRB, 0.72321249E-07_JPRB, 0.71563591E-07_JPRB, 0.70729122E-07_JPRB, 0.69538302E-07_JPRB, 0.68163196E-07_JPRB, &
  & 0.66957547E-07_JPRB, 0.65974724E-07_JPRB, 0.65152470E-07_JPRB, 0.64448059E-07_JPRB, 0.63770621E-07_JPRB, 0.63123686E-07_JPRB, &
  & 0.62514665E-07_JPRB, 0.61986981E-07_JPRB, 0.61634715E-07_JPRB, 0.61598989E-07_JPRB, 0.62009619E-07_JPRB, 0.62757756E-07_JPRB, &
  & 0.63455715E-07_JPRB, 0.63687807E-07_JPRB, 0.63196183E-07_JPRB, 0.61825673E-07_JPRB, 0.59516410E-07_JPRB, 0.56301971E-07_JPRB, &
  & 0.52415135E-07_JPRB, 0.48230476E-07_JPRB, 0.44243446E-07_JPRB, 0.40843759E-07_JPRB, 0.38251194E-07_JPRB, 0.36493997E-07_JPRB, &
  & 0.35530405E-07_JPRB, 0.35246021E-07_JPRB, 0.35555104E-07_JPRB, 0.36498385E-07_JPRB, 0.38164057E-07_JPRB, 0.40547349E-07_JPRB, &
  & 0.43516383E-07_JPRB, 0.46864603E-07_JPRB, 0.50444854E-07_JPRB, 0.54112405E-07_JPRB, 0.57776631E-07_JPRB, 0.61229031E-07_JPRB, &
  & 0.64318215E-07_JPRB, 0.66849125E-07_JPRB, 0.68823901E-07_JPRB, 0.70296224E-07_JPRB, 0.71460455E-07_JPRB, 0.72501813E-07_JPRB, &
  & 0.73521768E-07_JPRB, 0.74509131E-07_JPRB, 0.75371034E-07_JPRB, 0.76053503E-07_JPRB, 0.76615493E-07_JPRB, 0.77090803E-07_JPRB, &
  & 0.77539752E-07_JPRB, 0.77982939E-07_JPRB, 0.78422509E-07_JPRB, 0.78841197E-07_JPRB, 0.79205130E-07_JPRB, 0.79510755E-07_JPRB, &
  & 0.79778196E-07_JPRB, 0.80049276E-07_JPRB, 0.80405684E-07_JPRB, 0.81226680E-07_JPRB /)

RGHG7(:,64,11) = (/ &
  & 0.70941290E-07_JPRB, 0.69513838E-07_JPRB, 0.68778633E-07_JPRB, 0.68043811E-07_JPRB, 0.67079540E-07_JPRB, 0.65839146E-07_JPRB, &
  & 0.64636950E-07_JPRB, 0.63608930E-07_JPRB, 0.62644375E-07_JPRB, 0.61793230E-07_JPRB, 0.60983780E-07_JPRB, 0.60176141E-07_JPRB, &
  & 0.59442620E-07_JPRB, 0.58830938E-07_JPRB, 0.58455623E-07_JPRB, 0.58406279E-07_JPRB, 0.58746647E-07_JPRB, 0.59356196E-07_JPRB, &
  & 0.59920389E-07_JPRB, 0.60080701E-07_JPRB, 0.59590423E-07_JPRB, 0.58312288E-07_JPRB, 0.56188075E-07_JPRB, 0.53251927E-07_JPRB, &
  & 0.49713439E-07_JPRB, 0.45932691E-07_JPRB, 0.42355090E-07_JPRB, 0.39356660E-07_JPRB, 0.37110979E-07_JPRB, 0.35641779E-07_JPRB, &
  & 0.34897649E-07_JPRB, 0.34746591E-07_JPRB, 0.35106329E-07_JPRB, 0.36014082E-07_JPRB, 0.37570789E-07_JPRB, 0.39795491E-07_JPRB, &
  & 0.42585189E-07_JPRB, 0.45749466E-07_JPRB, 0.49162178E-07_JPRB, 0.52675869E-07_JPRB, 0.56162229E-07_JPRB, 0.59495779E-07_JPRB, &
  & 0.62454738E-07_JPRB, 0.64955429E-07_JPRB, 0.66922006E-07_JPRB, 0.68452515E-07_JPRB, 0.69681448E-07_JPRB, 0.70776572E-07_JPRB, &
  & 0.71845633E-07_JPRB, 0.72879523E-07_JPRB, 0.73814803E-07_JPRB, 0.74607108E-07_JPRB, 0.75246064E-07_JPRB, 0.75807684E-07_JPRB, &
  & 0.76320447E-07_JPRB, 0.76818424E-07_JPRB, 0.77296484E-07_JPRB, 0.77738584E-07_JPRB, 0.78115328E-07_JPRB, 0.78434290E-07_JPRB, &
  & 0.78714734E-07_JPRB, 0.79005488E-07_JPRB, 0.79375845E-07_JPRB, 0.80173180E-07_JPRB /)

RGHG7(:,65,11) = (/ &
  & 0.68107646E-07_JPRB, 0.66796076E-07_JPRB, 0.66178615E-07_JPRB, 0.65561530E-07_JPRB, 0.64707223E-07_JPRB, 0.63632974E-07_JPRB, &
  & 0.62483359E-07_JPRB, 0.61322623E-07_JPRB, 0.60228750E-07_JPRB, 0.59214457E-07_JPRB, 0.58276957E-07_JPRB, 0.57363852E-07_JPRB, &
  & 0.56546309E-07_JPRB, 0.55915987E-07_JPRB, 0.55537811E-07_JPRB, 0.55471020E-07_JPRB, 0.55738020E-07_JPRB, 0.56222330E-07_JPRB, &
  & 0.56667833E-07_JPRB, 0.56754200E-07_JPRB, 0.56263879E-07_JPRB, 0.55073862E-07_JPRB, 0.53135107E-07_JPRB, 0.50479755E-07_JPRB, &
  & 0.47296840E-07_JPRB, 0.43926381E-07_JPRB, 0.40762291E-07_JPRB, 0.38158710E-07_JPRB, 0.36258022E-07_JPRB, 0.35071128E-07_JPRB, &
  & 0.34534107E-07_JPRB, 0.34512155E-07_JPRB, 0.34920728E-07_JPRB, 0.35796297E-07_JPRB, 0.37249254E-07_JPRB, 0.39318500E-07_JPRB, &
  & 0.41923990E-07_JPRB, 0.44887599E-07_JPRB, 0.48109527E-07_JPRB, 0.51430899E-07_JPRB, 0.54770531E-07_JPRB, 0.57938056E-07_JPRB, &
  & 0.60810471E-07_JPRB, 0.63246304E-07_JPRB, 0.65230296E-07_JPRB, 0.66798002E-07_JPRB, 0.68083466E-07_JPRB, 0.69233209E-07_JPRB, &
  & 0.70331133E-07_JPRB, 0.71394510E-07_JPRB, 0.72376523E-07_JPRB, 0.73231149E-07_JPRB, 0.73964713E-07_JPRB, 0.74598013E-07_JPRB, &
  & 0.75188481E-07_JPRB, 0.75743813E-07_JPRB, 0.76267092E-07_JPRB, 0.76733755E-07_JPRB, 0.77133777E-07_JPRB, 0.77468883E-07_JPRB, &
  & 0.77771858E-07_JPRB, 0.78080824E-07_JPRB, 0.78480937E-07_JPRB, 0.79304506E-07_JPRB /)

RGHG7(:,66,11) = (/ &
  & 0.65713564E-07_JPRB, 0.64405484E-07_JPRB, 0.63760943E-07_JPRB, 0.63169615E-07_JPRB, 0.62439362E-07_JPRB, 0.61446983E-07_JPRB, &
  & 0.60317895E-07_JPRB, 0.59143179E-07_JPRB, 0.57809373E-07_JPRB, 0.56720705E-07_JPRB, 0.55669204E-07_JPRB, 0.54713652E-07_JPRB, &
  & 0.53886879E-07_JPRB, 0.53256635E-07_JPRB, 0.52891146E-07_JPRB, 0.52800385E-07_JPRB, 0.52997219E-07_JPRB, 0.53371370E-07_JPRB, &
  & 0.53709030E-07_JPRB, 0.53732514E-07_JPRB, 0.53246730E-07_JPRB, 0.52147197E-07_JPRB, 0.50398629E-07_JPRB, 0.48029403E-07_JPRB, &
  & 0.45212985E-07_JPRB, 0.42250804E-07_JPRB, 0.39494129E-07_JPRB, 0.37280234E-07_JPRB, 0.35705661E-07_JPRB, 0.34781575E-07_JPRB, &
  & 0.34440010E-07_JPRB, 0.34539941E-07_JPRB, 0.34992961E-07_JPRB, 0.35841349E-07_JPRB, 0.37199055E-07_JPRB, 0.39121549E-07_JPRB, &
  & 0.41536996E-07_JPRB, 0.44294719E-07_JPRB, 0.47301313E-07_JPRB, 0.50435126E-07_JPRB, 0.53575977E-07_JPRB, 0.56607721E-07_JPRB, &
  & 0.59358975E-07_JPRB, 0.61754015E-07_JPRB, 0.63728976E-07_JPRB, 0.65336508E-07_JPRB, 0.66667255E-07_JPRB, 0.67854693E-07_JPRB, &
  & 0.68976043E-07_JPRB, 0.70047797E-07_JPRB, 0.71047992E-07_JPRB, 0.71959668E-07_JPRB, 0.72740782E-07_JPRB, 0.73458033E-07_JPRB, &
  & 0.74105884E-07_JPRB, 0.74724809E-07_JPRB, 0.75286898E-07_JPRB, 0.75787192E-07_JPRB, 0.76211393E-07_JPRB, 0.76577166E-07_JPRB, &
  & 0.76907781E-07_JPRB, 0.77259401E-07_JPRB, 0.77708592E-07_JPRB, 0.78594830E-07_JPRB /)

RGHG7(:,67,11) = (/ &
  & 0.63446805E-07_JPRB, 0.62046702E-07_JPRB, 0.61417893E-07_JPRB, 0.60865290E-07_JPRB, 0.60171075E-07_JPRB, 0.59293853E-07_JPRB, &
  & 0.58198090E-07_JPRB, 0.56933676E-07_JPRB, 0.55510746E-07_JPRB, 0.54260553E-07_JPRB, 0.53207831E-07_JPRB, 0.52246779E-07_JPRB, &
  & 0.51448126E-07_JPRB, 0.50841280E-07_JPRB, 0.50492041E-07_JPRB, 0.50388007E-07_JPRB, 0.50528467E-07_JPRB, 0.50815281E-07_JPRB, &
  & 0.51064909E-07_JPRB, 0.51039990E-07_JPRB, 0.50570623E-07_JPRB, 0.49572481E-07_JPRB, 0.48021349E-07_JPRB, 0.45944315E-07_JPRB, &
  & 0.43482736E-07_JPRB, 0.40923371E-07_JPRB, 0.38562781E-07_JPRB, 0.36709110E-07_JPRB, 0.35446604E-07_JPRB, 0.34767190E-07_JPRB, &
  & 0.34600262E-07_JPRB, 0.34808597E-07_JPRB, 0.35302310E-07_JPRB, 0.36128238E-07_JPRB, 0.37402163E-07_JPRB, 0.39187050E-07_JPRB, &
  & 0.41419764E-07_JPRB, 0.43970690E-07_JPRB, 0.46751499E-07_JPRB, 0.49668117E-07_JPRB, 0.52629595E-07_JPRB, 0.55487295E-07_JPRB, &
  & 0.58135001E-07_JPRB, 0.60461147E-07_JPRB, 0.62431205E-07_JPRB, 0.64055513E-07_JPRB, 0.65421297E-07_JPRB, 0.66640432E-07_JPRB, &
  & 0.67778672E-07_JPRB, 0.68855663E-07_JPRB, 0.69865074E-07_JPRB, 0.70780644E-07_JPRB, 0.71612170E-07_JPRB, 0.72358510E-07_JPRB, &
  & 0.73069337E-07_JPRB, 0.73727129E-07_JPRB, 0.74333265E-07_JPRB, 0.74862413E-07_JPRB, 0.75318063E-07_JPRB, 0.75711185E-07_JPRB, &
  & 0.76081264E-07_JPRB, 0.76478180E-07_JPRB, 0.77005751E-07_JPRB, 0.78013024E-07_JPRB /)

RGHG7(:,68,11) = (/ &
  & 0.61284858E-07_JPRB, 0.59814191E-07_JPRB, 0.59144497E-07_JPRB, 0.58576134E-07_JPRB, 0.57944515E-07_JPRB, 0.57088254E-07_JPRB, &
  & 0.56060816E-07_JPRB, 0.54763756E-07_JPRB, 0.53214833E-07_JPRB, 0.51952256E-07_JPRB, 0.50887202E-07_JPRB, 0.49963472E-07_JPRB, &
  & 0.49226735E-07_JPRB, 0.48662127E-07_JPRB, 0.48342230E-07_JPRB, 0.48237290E-07_JPRB, 0.48340098E-07_JPRB, 0.48559826E-07_JPRB, &
  & 0.48747602E-07_JPRB, 0.48697000E-07_JPRB, 0.48259999E-07_JPRB, 0.47375341E-07_JPRB, 0.46024592E-07_JPRB, 0.44227406E-07_JPRB, &
  & 0.42118216E-07_JPRB, 0.39941209E-07_JPRB, 0.37952272E-07_JPRB, 0.36428414E-07_JPRB, 0.35450640E-07_JPRB, 0.34988638E-07_JPRB, &
  & 0.34982911E-07_JPRB, 0.35289997E-07_JPRB, 0.35821788E-07_JPRB, 0.36629363E-07_JPRB, 0.37828588E-07_JPRB, 0.39484355E-07_JPRB, &
  & 0.41544073E-07_JPRB, 0.43901817E-07_JPRB, 0.46455593E-07_JPRB, 0.49163617E-07_JPRB, 0.51909844E-07_JPRB, 0.54607547E-07_JPRB, &
  & 0.57123859E-07_JPRB, 0.59383080E-07_JPRB, 0.61320613E-07_JPRB, 0.62951507E-07_JPRB, 0.64335211E-07_JPRB, 0.65565324E-07_JPRB, &
  & 0.66708537E-07_JPRB, 0.67780086E-07_JPRB, 0.68779514E-07_JPRB, 0.69715846E-07_JPRB, 0.70545404E-07_JPRB, 0.71328969E-07_JPRB, &
  & 0.72059287E-07_JPRB, 0.72753373E-07_JPRB, 0.73388286E-07_JPRB, 0.73942488E-07_JPRB, 0.74423717E-07_JPRB, 0.74846930E-07_JPRB, &
  & 0.75248352E-07_JPRB, 0.75699226E-07_JPRB, 0.76327048E-07_JPRB, 0.77493119E-07_JPRB /)

RGHG7(:,69,11) = (/ &
  & 0.59254614E-07_JPRB, 0.57607192E-07_JPRB, 0.56879468E-07_JPRB, 0.56315216E-07_JPRB, 0.55680765E-07_JPRB, 0.54907403E-07_JPRB, &
  & 0.53865925E-07_JPRB, 0.52617171E-07_JPRB, 0.51002935E-07_JPRB, 0.49702585E-07_JPRB, 0.48728111E-07_JPRB, 0.47854225E-07_JPRB, &
  & 0.47190550E-07_JPRB, 0.46693568E-07_JPRB, 0.46420183E-07_JPRB, 0.46335920E-07_JPRB, 0.46423168E-07_JPRB, 0.46605976E-07_JPRB, &
  & 0.46758128E-07_JPRB, 0.46701661E-07_JPRB, 0.46316941E-07_JPRB, 0.45554977E-07_JPRB, 0.44399950E-07_JPRB, 0.42875563E-07_JPRB, &
  & 0.41099351E-07_JPRB, 0.39280430E-07_JPRB, 0.37638291E-07_JPRB, 0.36412320E-07_JPRB, 0.35696313E-07_JPRB, 0.35436514E-07_JPRB, &
  & 0.35571624E-07_JPRB, 0.35965559E-07_JPRB, 0.36532331E-07_JPRB, 0.37325229E-07_JPRB, 0.38458992E-07_JPRB, 0.39996106E-07_JPRB, &
  & 0.41893557E-07_JPRB, 0.44054861E-07_JPRB, 0.46397226E-07_JPRB, 0.48882459E-07_JPRB, 0.51435212E-07_JPRB, 0.53950870E-07_JPRB, &
  & 0.56339317E-07_JPRB, 0.58504689E-07_JPRB, 0.60397177E-07_JPRB, 0.62009789E-07_JPRB, 0.63390253E-07_JPRB, 0.64621410E-07_JPRB, &
  & 0.65759615E-07_JPRB, 0.66820682E-07_JPRB, 0.67811847E-07_JPRB, 0.68728639E-07_JPRB, 0.69563214E-07_JPRB, 0.70341521E-07_JPRB, &
  & 0.71085317E-07_JPRB, 0.71794723E-07_JPRB, 0.72445168E-07_JPRB, 0.73017709E-07_JPRB, 0.73515452E-07_JPRB, 0.73952506E-07_JPRB, &
  & 0.74383578E-07_JPRB, 0.74870762E-07_JPRB, 0.75604603E-07_JPRB, 0.76916102E-07_JPRB /)

RGHG7(:,70,11) = (/ &
  & 0.57215274E-07_JPRB, 0.55379633E-07_JPRB, 0.54604659E-07_JPRB, 0.54010016E-07_JPRB, 0.53413078E-07_JPRB, 0.52637883E-07_JPRB, &
  & 0.51692471E-07_JPRB, 0.50410510E-07_JPRB, 0.48851103E-07_JPRB, 0.47608122E-07_JPRB, 0.46696069E-07_JPRB, 0.45923592E-07_JPRB, &
  & 0.45355279E-07_JPRB, 0.44940077E-07_JPRB, 0.44725862E-07_JPRB, 0.44676170E-07_JPRB, 0.44770591E-07_JPRB, 0.44941764E-07_JPRB, &
  & 0.45082238E-07_JPRB, 0.45046047E-07_JPRB, 0.44723446E-07_JPRB, 0.44087507E-07_JPRB, 0.43123791E-07_JPRB, 0.41860023E-07_JPRB, &
  & 0.40399101E-07_JPRB, 0.38911843E-07_JPRB, 0.37586432E-07_JPRB, 0.36640373E-07_JPRB, 0.36149739E-07_JPRB, 0.36068407E-07_JPRB, &
  & 0.36334956E-07_JPRB, 0.36808817E-07_JPRB, 0.37408924E-07_JPRB, 0.38191605E-07_JPRB, 0.39264904E-07_JPRB, 0.40689557E-07_JPRB, &
  & 0.42431449E-07_JPRB, 0.44417643E-07_JPRB, 0.46556117E-07_JPRB, 0.48829889E-07_JPRB, 0.51176617E-07_JPRB, 0.53519038E-07_JPRB, &
  & 0.55761436E-07_JPRB, 0.57824924E-07_JPRB, 0.59643526E-07_JPRB, 0.61221499E-07_JPRB, 0.62579105E-07_JPRB, 0.63792996E-07_JPRB, &
  & 0.64909734E-07_JPRB, 0.65948882E-07_JPRB, 0.66916236E-07_JPRB, 0.67820267E-07_JPRB, 0.68636346E-07_JPRB, 0.69405701E-07_JPRB, &
  & 0.70136920E-07_JPRB, 0.70844600E-07_JPRB, 0.71501624E-07_JPRB, 0.72075139E-07_JPRB, 0.72574572E-07_JPRB, 0.73026847E-07_JPRB, &
  & 0.73457393E-07_JPRB, 0.73976153E-07_JPRB, 0.74776509E-07_JPRB, 0.76259809E-07_JPRB /)

RGHG7(:,71,11) = (/ &
  & 0.55134535E-07_JPRB, 0.53118715E-07_JPRB, 0.52276391E-07_JPRB, 0.51688609E-07_JPRB, 0.51088502E-07_JPRB, 0.50382873E-07_JPRB, &
  & 0.49430692E-07_JPRB, 0.48279279E-07_JPRB, 0.46760857E-07_JPRB, 0.45652065E-07_JPRB, 0.44819146E-07_JPRB, 0.44167248E-07_JPRB, &
  & 0.43698723E-07_JPRB, 0.43382610E-07_JPRB, 0.43240707E-07_JPRB, 0.43243997E-07_JPRB, 0.43364491E-07_JPRB, 0.43546319E-07_JPRB, &
  & 0.43697984E-07_JPRB, 0.43693831E-07_JPRB, 0.43447386E-07_JPRB, 0.42940282E-07_JPRB, 0.42165272E-07_JPRB, 0.41148482E-07_JPRB, &
  & 0.39986382E-07_JPRB, 0.38806448E-07_JPRB, 0.37764440E-07_JPRB, 0.37085869E-07_JPRB, 0.36807027E-07_JPRB, 0.36888810E-07_JPRB, &
  & 0.37266531E-07_JPRB, 0.37808640E-07_JPRB, 0.38439552E-07_JPRB, 0.39215500E-07_JPRB, 0.40237982E-07_JPRB, 0.41560209E-07_JPRB, &
  & 0.43157218E-07_JPRB, 0.44950177E-07_JPRB, 0.46903246E-07_JPRB, 0.48971234E-07_JPRB, 0.51125664E-07_JPRB, 0.53288041E-07_JPRB, &
  & 0.55382500E-07_JPRB, 0.57325490E-07_JPRB, 0.59056127E-07_JPRB, 0.60575829E-07_JPRB, 0.61891662E-07_JPRB, 0.63074239E-07_JPRB, &
  & 0.64160020E-07_JPRB, 0.65163427E-07_JPRB, 0.66103659E-07_JPRB, 0.66976803E-07_JPRB, 0.67763509E-07_JPRB, 0.68505315E-07_JPRB, &
  & 0.69208497E-07_JPRB, 0.69906363E-07_JPRB, 0.70545866E-07_JPRB, 0.71114442E-07_JPRB, 0.71615020E-07_JPRB, 0.72047357E-07_JPRB, &
  & 0.72490124E-07_JPRB, 0.72992933E-07_JPRB, 0.73837988E-07_JPRB, 0.75467490E-07_JPRB /)

RGHG7(:,72,11) = (/ &
  & 0.52939853E-07_JPRB, 0.50764946E-07_JPRB, 0.49911559E-07_JPRB, 0.49317364E-07_JPRB, 0.48761315E-07_JPRB, 0.48069303E-07_JPRB, &
  & 0.47231502E-07_JPRB, 0.46105882E-07_JPRB, 0.44836010E-07_JPRB, 0.43807521E-07_JPRB, 0.43141178E-07_JPRB, 0.42595172E-07_JPRB, &
  & 0.42242629E-07_JPRB, 0.42026723E-07_JPRB, 0.41959289E-07_JPRB, 0.42022762E-07_JPRB, 0.42182680E-07_JPRB, 0.42389246E-07_JPRB, &
  & 0.42568942E-07_JPRB, 0.42615653E-07_JPRB, 0.42451823E-07_JPRB, 0.42076184E-07_JPRB, 0.41484800E-07_JPRB, 0.40709409E-07_JPRB, &
  & 0.39822851E-07_JPRB, 0.38940030E-07_JPRB, 0.38144719E-07_JPRB, 0.37718564E-07_JPRB, 0.37611745E-07_JPRB, 0.37842327E-07_JPRB, &
  & 0.38323673E-07_JPRB, 0.38929546E-07_JPRB, 0.39591693E-07_JPRB, 0.40365119E-07_JPRB, 0.41340400E-07_JPRB, 0.42561588E-07_JPRB, &
  & 0.44016918E-07_JPRB, 0.45660034E-07_JPRB, 0.47420720E-07_JPRB, 0.49294577E-07_JPRB, 0.51255181E-07_JPRB, 0.53242900E-07_JPRB, &
  & 0.55176869E-07_JPRB, 0.56992207E-07_JPRB, 0.58617683E-07_JPRB, 0.60063385E-07_JPRB, 0.61322183E-07_JPRB, 0.62457104E-07_JPRB, &
  & 0.63499314E-07_JPRB, 0.64460764E-07_JPRB, 0.65364809E-07_JPRB, 0.66196343E-07_JPRB, 0.66944537E-07_JPRB, 0.67642048E-07_JPRB, &
  & 0.68315579E-07_JPRB, 0.68972966E-07_JPRB, 0.69596908E-07_JPRB, 0.70154613E-07_JPRB, 0.70625909E-07_JPRB, 0.71062821E-07_JPRB, &
  & 0.71475746E-07_JPRB, 0.71965559E-07_JPRB, 0.72807559E-07_JPRB, 0.74533538E-07_JPRB /)

RGHG7(:,73,11) = (/ &
  & 0.50587619E-07_JPRB, 0.48363788E-07_JPRB, 0.47507125E-07_JPRB, 0.46962285E-07_JPRB, 0.46437346E-07_JPRB, 0.45829619E-07_JPRB, &
  & 0.45039538E-07_JPRB, 0.44119368E-07_JPRB, 0.42976190E-07_JPRB, 0.42199314E-07_JPRB, 0.41594287E-07_JPRB, 0.41205805E-07_JPRB, &
  & 0.40952642E-07_JPRB, 0.40842345E-07_JPRB, 0.40860442E-07_JPRB, 0.40992688E-07_JPRB, 0.41202743E-07_JPRB, 0.41450232E-07_JPRB, &
  & 0.41667743E-07_JPRB, 0.41772896E-07_JPRB, 0.41701334E-07_JPRB, 0.41461377E-07_JPRB, 0.41051635E-07_JPRB, 0.40502481E-07_JPRB, &
  & 0.39881414E-07_JPRB, 0.39272766E-07_JPRB, 0.38710372E-07_JPRB, 0.38510493E-07_JPRB, 0.38592137E-07_JPRB, 0.38948556E-07_JPRB, &
  & 0.39510979E-07_JPRB, 0.40168580E-07_JPRB, 0.40860140E-07_JPRB, 0.41633655E-07_JPRB, 0.42573344E-07_JPRB, 0.43703395E-07_JPRB, &
  & 0.45025818E-07_JPRB, 0.46503821E-07_JPRB, 0.48072746E-07_JPRB, 0.49772005E-07_JPRB, 0.51548646E-07_JPRB, 0.53353904E-07_JPRB, &
  & 0.55129593E-07_JPRB, 0.56798509E-07_JPRB, 0.58317102E-07_JPRB, 0.59666903E-07_JPRB, 0.60862021E-07_JPRB, 0.61937897E-07_JPRB, &
  & 0.62924741E-07_JPRB, 0.63840382E-07_JPRB, 0.64697069E-07_JPRB, 0.65480222E-07_JPRB, 0.66179126E-07_JPRB, 0.66836819E-07_JPRB, &
  & 0.67451602E-07_JPRB, 0.68089811E-07_JPRB, 0.68677139E-07_JPRB, 0.69203850E-07_JPRB, 0.69672254E-07_JPRB, 0.70069277E-07_JPRB, &
  & 0.70476680E-07_JPRB, 0.70922219E-07_JPRB, 0.71735066E-07_JPRB, 0.73497276E-07_JPRB /)

RGHG7(:,74,11) = (/ &
  & 0.48117464E-07_JPRB, 0.45918000E-07_JPRB, 0.45134431E-07_JPRB, 0.44637240E-07_JPRB, 0.44190710E-07_JPRB, 0.43654421E-07_JPRB, &
  & 0.43016623E-07_JPRB, 0.42199954E-07_JPRB, 0.41358049E-07_JPRB, 0.40661195E-07_JPRB, 0.40262034E-07_JPRB, 0.39971148E-07_JPRB, &
  & 0.39839534E-07_JPRB, 0.39828308E-07_JPRB, 0.39929095E-07_JPRB, 0.40128572E-07_JPRB, 0.40395388E-07_JPRB, 0.40690288E-07_JPRB, &
  & 0.40958302E-07_JPRB, 0.41133827E-07_JPRB, 0.41162654E-07_JPRB, 0.41058655E-07_JPRB, 0.40827945E-07_JPRB, 0.40494292E-07_JPRB, &
  & 0.40122906E-07_JPRB, 0.39766860E-07_JPRB, 0.39437914E-07_JPRB, 0.39416367E-07_JPRB, 0.39645375E-07_JPRB, 0.40115552E-07_JPRB, &
  & 0.40754689E-07_JPRB, 0.41461725E-07_JPRB, 0.42184347E-07_JPRB, 0.42962405E-07_JPRB, 0.43866319E-07_JPRB, 0.44909914E-07_JPRB, &
  & 0.46107743E-07_JPRB, 0.47469882E-07_JPRB, 0.48848776E-07_JPRB, 0.50379054E-07_JPRB, 0.51972922E-07_JPRB, 0.53602179E-07_JPRB, &
  & 0.55207753E-07_JPRB, 0.56730865E-07_JPRB, 0.58124886E-07_JPRB, 0.59380227E-07_JPRB, 0.60492425E-07_JPRB, 0.61504160E-07_JPRB, &
  & 0.62433010E-07_JPRB, 0.63287224E-07_JPRB, 0.64098550E-07_JPRB, 0.64829088E-07_JPRB, 0.65487384E-07_JPRB, 0.66089711E-07_JPRB, &
  & 0.66683143E-07_JPRB, 0.67254149E-07_JPRB, 0.67812842E-07_JPRB, 0.68324212E-07_JPRB, 0.68746303E-07_JPRB, 0.69134792E-07_JPRB, &
  & 0.69504345E-07_JPRB, 0.69919082E-07_JPRB, 0.70657876E-07_JPRB, 0.72409506E-07_JPRB /)

RGHG7(:,75,11) = (/ &
  & 0.45665352E-07_JPRB, 0.43539298E-07_JPRB, 0.42807415E-07_JPRB, 0.42397925E-07_JPRB, 0.42034152E-07_JPRB, 0.41619561E-07_JPRB, &
  & 0.41096374E-07_JPRB, 0.40493497E-07_JPRB, 0.39776612E-07_JPRB, 0.39331415E-07_JPRB, 0.39019671E-07_JPRB, 0.38878706E-07_JPRB, &
  & 0.38855045E-07_JPRB, 0.38944563E-07_JPRB, 0.39134239E-07_JPRB, 0.39410338E-07_JPRB, 0.39736257E-07_JPRB, 0.40085585E-07_JPRB, &
  & 0.40410761E-07_JPRB, 0.40662698E-07_JPRB, 0.40798241E-07_JPRB, 0.40834983E-07_JPRB, 0.40775635E-07_JPRB, 0.40648324E-07_JPRB, &
  & 0.40518447E-07_JPRB, 0.40375919E-07_JPRB, 0.40300229E-07_JPRB, 0.40439758E-07_JPRB, 0.40825523E-07_JPRB, 0.41399719E-07_JPRB, &
  & 0.42096204E-07_JPRB, 0.42840238E-07_JPRB, 0.43590219E-07_JPRB, 0.44375128E-07_JPRB, 0.45251724E-07_JPRB, 0.46218837E-07_JPRB, &
  & 0.47299768E-07_JPRB, 0.48501203E-07_JPRB, 0.49711261E-07_JPRB, 0.51086470E-07_JPRB, 0.52503513E-07_JPRB, 0.53954260E-07_JPRB, &
  & 0.55391979E-07_JPRB, 0.56759774E-07_JPRB, 0.58028959E-07_JPRB, 0.59175097E-07_JPRB, 0.60212443E-07_JPRB, 0.61147247E-07_JPRB, &
  & 0.62011274E-07_JPRB, 0.62813463E-07_JPRB, 0.63567924E-07_JPRB, 0.64248091E-07_JPRB, 0.64860203E-07_JPRB, 0.65433539E-07_JPRB, &
  & 0.65959931E-07_JPRB, 0.66518005E-07_JPRB, 0.67034009E-07_JPRB, 0.67494142E-07_JPRB, 0.67901958E-07_JPRB, 0.68252149E-07_JPRB, &
  & 0.68597814E-07_JPRB, 0.68961079E-07_JPRB, 0.69637153E-07_JPRB, 0.71289165E-07_JPRB /)

RGHG7(:,76,11) = (/ &
  & 0.43228308E-07_JPRB, 0.41200405E-07_JPRB, 0.40563418E-07_JPRB, 0.40238728E-07_JPRB, 0.39981803E-07_JPRB, 0.39685844E-07_JPRB, &
  & 0.39327016E-07_JPRB, 0.38878031E-07_JPRB, 0.38398273E-07_JPRB, 0.38069135E-07_JPRB, 0.37939589E-07_JPRB, 0.37923236E-07_JPRB, &
  & 0.38011986E-07_JPRB, 0.38198923E-07_JPRB, 0.38469196E-07_JPRB, 0.38808832E-07_JPRB, 0.39197019E-07_JPRB, 0.39601890E-07_JPRB, &
  & 0.39989143E-07_JPRB, 0.40324441E-07_JPRB, 0.40571813E-07_JPRB, 0.40749438E-07_JPRB, 0.40860289E-07_JPRB, 0.40927553E-07_JPRB, &
  & 0.41030429E-07_JPRB, 0.41066606E-07_JPRB, 0.41249955E-07_JPRB, 0.41530505E-07_JPRB, 0.41999648E-07_JPRB, 0.42647279E-07_JPRB, &
  & 0.43392102E-07_JPRB, 0.44168129E-07_JPRB, 0.44944706E-07_JPRB, 0.45739018E-07_JPRB, 0.46588575E-07_JPRB, 0.47495561E-07_JPRB, &
  & 0.48492399E-07_JPRB, 0.49578254E-07_JPRB, 0.50658752E-07_JPRB, 0.51855263E-07_JPRB, 0.53110085E-07_JPRB, 0.54386685E-07_JPRB, &
  & 0.55656116E-07_JPRB, 0.56867279E-07_JPRB, 0.58005529E-07_JPRB, 0.59047597E-07_JPRB, 0.59993475E-07_JPRB, 0.60861133E-07_JPRB, &
  & 0.61658241E-07_JPRB, 0.62400161E-07_JPRB, 0.63096017E-07_JPRB, 0.63732948E-07_JPRB, 0.64308189E-07_JPRB, 0.64832420E-07_JPRB, &
  & 0.65349624E-07_JPRB, 0.65839394E-07_JPRB, 0.66314257E-07_JPRB, 0.66752747E-07_JPRB, 0.67117007E-07_JPRB, 0.67434776E-07_JPRB, &
  & 0.67753682E-07_JPRB, 0.68072829E-07_JPRB, 0.68648703E-07_JPRB, 0.70207300E-07_JPRB /)

RGHG7(:,77,11) = (/ &
  & 0.40842458E-07_JPRB, 0.38966792E-07_JPRB, 0.38418005E-07_JPRB, 0.38192500E-07_JPRB, 0.38038632E-07_JPRB, 0.37871906E-07_JPRB, &
  & 0.37657941E-07_JPRB, 0.37392095E-07_JPRB, 0.37089478E-07_JPRB, 0.36964618E-07_JPRB, 0.36976157E-07_JPRB, 0.37080039E-07_JPRB, &
  & 0.37284671E-07_JPRB, 0.37559559E-07_JPRB, 0.37906819E-07_JPRB, 0.38315445E-07_JPRB, 0.38756514E-07_JPRB, 0.39217664E-07_JPRB, &
  & 0.39668311E-07_JPRB, 0.40087798E-07_JPRB, 0.40449692E-07_JPRB, 0.40765869E-07_JPRB, 0.41040227E-07_JPRB, 0.41297319E-07_JPRB, &
  & 0.41603496E-07_JPRB, 0.41810956E-07_JPRB, 0.42216293E-07_JPRB, 0.42659867E-07_JPRB, 0.43235538E-07_JPRB, 0.43964555E-07_JPRB, &
  & 0.44752365E-07_JPRB, 0.45555488E-07_JPRB, 0.46354963E-07_JPRB, 0.47158068E-07_JPRB, 0.47983168E-07_JPRB, 0.48828564E-07_JPRB, &
  & 0.49719119E-07_JPRB, 0.50647696E-07_JPRB, 0.51618002E-07_JPRB, 0.52657143E-07_JPRB, 0.53755265E-07_JPRB, 0.54868398E-07_JPRB, &
  & 0.55974311E-07_JPRB, 0.57035020E-07_JPRB, 0.58039941E-07_JPRB, 0.58977431E-07_JPRB, 0.59836005E-07_JPRB, 0.60625695E-07_JPRB, &
  & 0.61362726E-07_JPRB, 0.62043448E-07_JPRB, 0.62684940E-07_JPRB, 0.63274825E-07_JPRB, 0.63815833E-07_JPRB, 0.64316822E-07_JPRB, &
  & 0.64774660E-07_JPRB, 0.65250106E-07_JPRB, 0.65680119E-07_JPRB, 0.66065624E-07_JPRB, 0.66396005E-07_JPRB, 0.66691385E-07_JPRB, &
  & 0.66973278E-07_JPRB, 0.67238446E-07_JPRB, 0.67742626E-07_JPRB, 0.69143766E-07_JPRB /)

RGHG7(:,78,11) = (/ &
  & 0.38534662E-07_JPRB, 0.36911665E-07_JPRB, 0.36504428E-07_JPRB, 0.36374242E-07_JPRB, 0.36320447E-07_JPRB, 0.36271334E-07_JPRB, &
  & 0.36197992E-07_JPRB, 0.36119456E-07_JPRB, 0.36014605E-07_JPRB, 0.36053702E-07_JPRB, 0.36203197E-07_JPRB, 0.36436155E-07_JPRB, &
  & 0.36721730E-07_JPRB, 0.37074916E-07_JPRB, 0.37478262E-07_JPRB, 0.37927414E-07_JPRB, 0.38416772E-07_JPRB, 0.38922373E-07_JPRB, &
  & 0.39431637E-07_JPRB, 0.39929734E-07_JPRB, 0.40397492E-07_JPRB, 0.40842654E-07_JPRB, 0.41265512E-07_JPRB, 0.41694619E-07_JPRB, &
  & 0.42146159E-07_JPRB, 0.42549782E-07_JPRB, 0.43068219E-07_JPRB, 0.43645638E-07_JPRB, 0.44277112E-07_JPRB, 0.45019085E-07_JPRB, &
  & 0.45814680E-07_JPRB, 0.46614229E-07_JPRB, 0.47416279E-07_JPRB, 0.48222876E-07_JPRB, 0.49045628E-07_JPRB, 0.49889668E-07_JPRB, &
  & 0.50760381E-07_JPRB, 0.51623374E-07_JPRB, 0.52523131E-07_JPRB, 0.53424621E-07_JPRB, 0.54373370E-07_JPRB, 0.55351268E-07_JPRB, &
  & 0.56303477E-07_JPRB, 0.57224160E-07_JPRB, 0.58114498E-07_JPRB, 0.58944430E-07_JPRB, 0.59724158E-07_JPRB, 0.60450311E-07_JPRB, &
  & 0.61126677E-07_JPRB, 0.61759359E-07_JPRB, 0.62353045E-07_JPRB, 0.62904000E-07_JPRB, 0.63413111E-07_JPRB, 0.63875802E-07_JPRB, &
  & 0.64323515E-07_JPRB, 0.64740817E-07_JPRB, 0.65127153E-07_JPRB, 0.65478808E-07_JPRB, 0.65793792E-07_JPRB, 0.66026423E-07_JPRB, &
  & 0.66305674E-07_JPRB, 0.66508406E-07_JPRB, 0.66896483E-07_JPRB, 0.68112620E-07_JPRB /)

RGHG7(:,79,11) = (/ &
  & 0.36598742E-07_JPRB, 0.35515740E-07_JPRB, 0.35306989E-07_JPRB, 0.35289130E-07_JPRB, 0.35316710E-07_JPRB, 0.35349522E-07_JPRB, &
  & 0.35382541E-07_JPRB, 0.35406408E-07_JPRB, 0.35444398E-07_JPRB, 0.35591935E-07_JPRB, 0.35818992E-07_JPRB, 0.36099628E-07_JPRB, &
  & 0.36441328E-07_JPRB, 0.36825021E-07_JPRB, 0.37257312E-07_JPRB, 0.37730047E-07_JPRB, 0.38231565E-07_JPRB, 0.38761907E-07_JPRB, &
  & 0.39301902E-07_JPRB, 0.39845411E-07_JPRB, 0.40378115E-07_JPRB, 0.40899142E-07_JPRB, 0.41409304E-07_JPRB, 0.41928057E-07_JPRB, &
  & 0.42433292E-07_JPRB, 0.42957986E-07_JPRB, 0.43503423E-07_JPRB, 0.44159894E-07_JPRB, 0.44826940E-07_JPRB, 0.45568026E-07_JPRB, &
  & 0.46364875E-07_JPRB, 0.47161542E-07_JPRB, 0.47961667E-07_JPRB, 0.48770222E-07_JPRB, 0.49597741E-07_JPRB, 0.50443091E-07_JPRB, &
  & 0.51284289E-07_JPRB, 0.52153858E-07_JPRB, 0.53028121E-07_JPRB, 0.53921294E-07_JPRB, 0.54778571E-07_JPRB, 0.55668306E-07_JPRB, &
  & 0.56528567E-07_JPRB, 0.57359330E-07_JPRB, 0.58158584E-07_JPRB, 0.58939133E-07_JPRB, 0.59663542E-07_JPRB, 0.60355276E-07_JPRB, &
  & 0.61003860E-07_JPRB, 0.61613505E-07_JPRB, 0.62183965E-07_JPRB, 0.62712473E-07_JPRB, 0.63211580E-07_JPRB, 0.63656877E-07_JPRB, &
  & 0.64078620E-07_JPRB, 0.64471315E-07_JPRB, 0.64838559E-07_JPRB, 0.65140071E-07_JPRB, 0.65429511E-07_JPRB, 0.65646702E-07_JPRB, &
  & 0.65887129E-07_JPRB, 0.66044237E-07_JPRB, 0.66294909E-07_JPRB, 0.67200943E-07_JPRB /)

RGHG7(:,80,11) = (/ &
  & 0.35507433E-07_JPRB, 0.34948393E-07_JPRB, 0.34860395E-07_JPRB, 0.34898015E-07_JPRB, 0.34956344E-07_JPRB, 0.35013841E-07_JPRB, &
  & 0.35071604E-07_JPRB, 0.35137937E-07_JPRB, 0.35216832E-07_JPRB, 0.35379255E-07_JPRB, 0.35647613E-07_JPRB, 0.35954479E-07_JPRB, &
  & 0.36310762E-07_JPRB, 0.36718216E-07_JPRB, 0.37159747E-07_JPRB, 0.37640181E-07_JPRB, 0.38155715E-07_JPRB, 0.38692306E-07_JPRB, &
  & 0.39242842E-07_JPRB, 0.39805339E-07_JPRB, 0.40359588E-07_JPRB, 0.40915626E-07_JPRB, 0.41464588E-07_JPRB, 0.41998938E-07_JPRB, &
  & 0.42577241E-07_JPRB, 0.43118110E-07_JPRB, 0.43746663E-07_JPRB, 0.44366381E-07_JPRB, 0.45074341E-07_JPRB, 0.45813412E-07_JPRB, &
  & 0.46607333E-07_JPRB, 0.47404583E-07_JPRB, 0.48205330E-07_JPRB, 0.49016943E-07_JPRB, 0.49848495E-07_JPRB, 0.50692417E-07_JPRB, &
  & 0.51548447E-07_JPRB, 0.52416706E-07_JPRB, 0.53229709E-07_JPRB, 0.54112721E-07_JPRB, 0.54928190E-07_JPRB, 0.55771803E-07_JPRB, &
  & 0.56601607E-07_JPRB, 0.57396363E-07_JPRB, 0.58177147E-07_JPRB, 0.58920758E-07_JPRB, 0.59640897E-07_JPRB, 0.60313518E-07_JPRB, &
  & 0.60950057E-07_JPRB, 0.61547951E-07_JPRB, 0.62107802E-07_JPRB, 0.62627890E-07_JPRB, 0.63120147E-07_JPRB, 0.63555937E-07_JPRB, &
  & 0.63984622E-07_JPRB, 0.64353536E-07_JPRB, 0.64723793E-07_JPRB, 0.65008521E-07_JPRB, 0.65318645E-07_JPRB, 0.65491463E-07_JPRB, &
  & 0.65746896E-07_JPRB, 0.65878979E-07_JPRB, 0.66027241E-07_JPRB, 0.66645882E-07_JPRB /)

RGHG7(:,81,11) = (/ &
  & 0.34745771E-07_JPRB, 0.34617976E-07_JPRB, 0.34594361E-07_JPRB, 0.34672777E-07_JPRB, 0.34747131E-07_JPRB, 0.34815926E-07_JPRB, &
  & 0.34899291E-07_JPRB, 0.34990432E-07_JPRB, 0.35097663E-07_JPRB, 0.35310130E-07_JPRB, 0.35568803E-07_JPRB, 0.35893663E-07_JPRB, &
  & 0.36259326E-07_JPRB, 0.36666055E-07_JPRB, 0.37118532E-07_JPRB, 0.37602458E-07_JPRB, 0.38117243E-07_JPRB, 0.38658996E-07_JPRB, &
  & 0.39219351E-07_JPRB, 0.39786674E-07_JPRB, 0.40361389E-07_JPRB, 0.40937280E-07_JPRB, 0.41492864E-07_JPRB, 0.42049471E-07_JPRB, &
  & 0.42650274E-07_JPRB, 0.43171202E-07_JPRB, 0.43826276E-07_JPRB, 0.44456684E-07_JPRB, 0.45170129E-07_JPRB, 0.45920721E-07_JPRB, &
  & 0.46708724E-07_JPRB, 0.47510973E-07_JPRB, 0.48314639E-07_JPRB, 0.49130449E-07_JPRB, 0.49967035E-07_JPRB, 0.50813245E-07_JPRB, &
  & 0.51663989E-07_JPRB, 0.52512746E-07_JPRB, 0.53358544E-07_JPRB, 0.54209728E-07_JPRB, 0.55047430E-07_JPRB, 0.55840008E-07_JPRB, &
  & 0.56653434E-07_JPRB, 0.57434931E-07_JPRB, 0.58187837E-07_JPRB, 0.58932152E-07_JPRB, 0.59628874E-07_JPRB, 0.60298845E-07_JPRB, &
  & 0.60927071E-07_JPRB, 0.61521988E-07_JPRB, 0.62078712E-07_JPRB, 0.62594218E-07_JPRB, 0.63085238E-07_JPRB, 0.63516111E-07_JPRB, &
  & 0.63943141E-07_JPRB, 0.64302746E-07_JPRB, 0.64674509E-07_JPRB, 0.64936216E-07_JPRB, 0.65242872E-07_JPRB, 0.65425745E-07_JPRB, &
  & 0.65650269E-07_JPRB, 0.65809516E-07_JPRB, 0.65870417E-07_JPRB, 0.66294305E-07_JPRB /)

RGHG7(:,82,11) = (/ &
  & 0.34375248E-07_JPRB, 0.34518965E-07_JPRB, 0.34520991E-07_JPRB, 0.34637342E-07_JPRB, 0.34696669E-07_JPRB, 0.34767144E-07_JPRB, &
  & 0.34855354E-07_JPRB, 0.34949320E-07_JPRB, 0.35064897E-07_JPRB, 0.35248270E-07_JPRB, 0.35538783E-07_JPRB, 0.35855436E-07_JPRB, &
  & 0.36226972E-07_JPRB, 0.36645762E-07_JPRB, 0.37096015E-07_JPRB, 0.37583963E-07_JPRB, 0.38104652E-07_JPRB, 0.38646853E-07_JPRB, &
  & 0.39204846E-07_JPRB, 0.39777166E-07_JPRB, 0.40354049E-07_JPRB, 0.40939216E-07_JPRB, 0.41479730E-07_JPRB, 0.42084935E-07_JPRB, &
  & 0.42629356E-07_JPRB, 0.43239599E-07_JPRB, 0.43830166E-07_JPRB, 0.44525603E-07_JPRB, 0.45202373E-07_JPRB, 0.45971102E-07_JPRB, &
  & 0.46755076E-07_JPRB, 0.47560015E-07_JPRB, 0.48369746E-07_JPRB, 0.49191790E-07_JPRB, 0.50033211E-07_JPRB, 0.50881830E-07_JPRB, &
  & 0.51740379E-07_JPRB, 0.52578518E-07_JPRB, 0.53425897E-07_JPRB, 0.54232569E-07_JPRB, 0.55078949E-07_JPRB, 0.55868430E-07_JPRB, &
  & 0.56660248E-07_JPRB, 0.57443167E-07_JPRB, 0.58200271E-07_JPRB, 0.58927743E-07_JPRB, 0.59632697E-07_JPRB, 0.60291583E-07_JPRB, &
  & 0.60917991E-07_JPRB, 0.61510683E-07_JPRB, 0.62063258E-07_JPRB, 0.62576646E-07_JPRB, 0.63065428E-07_JPRB, 0.63496877E-07_JPRB, &
  & 0.63923650E-07_JPRB, 0.64281217E-07_JPRB, 0.64654223E-07_JPRB, 0.64923427E-07_JPRB, 0.65222260E-07_JPRB, 0.65411022E-07_JPRB, &
  & 0.65610941E-07_JPRB, 0.65812721E-07_JPRB, 0.65804628E-07_JPRB, 0.66090024E-07_JPRB /)

RGHG7(:,83,11) = (/ &
  & 0.34471590E-07_JPRB, 0.34424364E-07_JPRB, 0.34458704E-07_JPRB, 0.34589469E-07_JPRB, 0.34606451E-07_JPRB, 0.34699848E-07_JPRB, &
  & 0.34797935E-07_JPRB, 0.34899987E-07_JPRB, 0.35025646E-07_JPRB, 0.35245751E-07_JPRB, 0.35510123E-07_JPRB, 0.35846458E-07_JPRB, &
  & 0.36211123E-07_JPRB, 0.36626339E-07_JPRB, 0.37085822E-07_JPRB, 0.37573390E-07_JPRB, 0.38092271E-07_JPRB, 0.38634578E-07_JPRB, &
  & 0.39197044E-07_JPRB, 0.39767254E-07_JPRB, 0.40356262E-07_JPRB, 0.40930708E-07_JPRB, 0.41485197E-07_JPRB, 0.42113356E-07_JPRB, &
  & 0.42613696E-07_JPRB, 0.43279286E-07_JPRB, 0.43822666E-07_JPRB, 0.44539259E-07_JPRB, 0.45224052E-07_JPRB, 0.45989982E-07_JPRB, &
  & 0.46777696E-07_JPRB, 0.47583992E-07_JPRB, 0.48401873E-07_JPRB, 0.49231229E-07_JPRB, 0.50078768E-07_JPRB, 0.50931785E-07_JPRB, &
  & 0.51781321E-07_JPRB, 0.52619377E-07_JPRB, 0.53461989E-07_JPRB, 0.54277347E-07_JPRB, 0.55108124E-07_JPRB, 0.55902319E-07_JPRB, &
  & 0.56684243E-07_JPRB, 0.57458784E-07_JPRB, 0.58217442E-07_JPRB, 0.58946348E-07_JPRB, 0.59637820E-07_JPRB, 0.60296166E-07_JPRB, &
  & 0.60914907E-07_JPRB, 0.61505880E-07_JPRB, 0.62056507E-07_JPRB, 0.62570905E-07_JPRB, 0.63055495E-07_JPRB, 0.63489615E-07_JPRB, &
  & 0.63909248E-07_JPRB, 0.64272918E-07_JPRB, 0.64629475E-07_JPRB, 0.64911326E-07_JPRB, 0.65183890E-07_JPRB, 0.65416046E-07_JPRB, &
  & 0.65554225E-07_JPRB, 0.65826093E-07_JPRB, 0.65767949E-07_JPRB, 0.66100576E-07_JPRB /)

RGHG7(:,84,11) = (/ &
  & 0.34475967E-07_JPRB, 0.34325538E-07_JPRB, 0.34484010E-07_JPRB, 0.34584289E-07_JPRB, 0.34567705E-07_JPRB, 0.34721563E-07_JPRB, &
  & 0.34786797E-07_JPRB, 0.34903131E-07_JPRB, 0.35033587E-07_JPRB, 0.35229004E-07_JPRB, 0.35508130E-07_JPRB, 0.35823565E-07_JPRB, &
  & 0.36196205E-07_JPRB, 0.36611652E-07_JPRB, 0.37071128E-07_JPRB, 0.37565286E-07_JPRB, 0.38086821E-07_JPRB, 0.38627913E-07_JPRB, &
  & 0.39190525E-07_JPRB, 0.39755161E-07_JPRB, 0.40349455E-07_JPRB, 0.40904194E-07_JPRB, 0.41495550E-07_JPRB, 0.42082871E-07_JPRB, &
  & 0.42627338E-07_JPRB, 0.43263245E-07_JPRB, 0.43848011E-07_JPRB, 0.44530143E-07_JPRB, 0.45236742E-07_JPRB, 0.45994270E-07_JPRB, &
  & 0.46789339E-07_JPRB, 0.47595030E-07_JPRB, 0.48422006E-07_JPRB, 0.49258375E-07_JPRB, 0.50111776E-07_JPRB, 0.50966634E-07_JPRB, &
  & 0.51820884E-07_JPRB, 0.52656063E-07_JPRB, 0.53488520E-07_JPRB, 0.54319123E-07_JPRB, 0.55106252E-07_JPRB, 0.55926179E-07_JPRB, &
  & 0.56696962E-07_JPRB, 0.57475422E-07_JPRB, 0.58231098E-07_JPRB, 0.58959007E-07_JPRB, 0.59652770E-07_JPRB, 0.60303748E-07_JPRB, &
  & 0.60914722E-07_JPRB, 0.61505652E-07_JPRB, 0.62053779E-07_JPRB, 0.62568752E-07_JPRB, 0.63047246E-07_JPRB, 0.63489402E-07_JPRB, &
  & 0.63897915E-07_JPRB, 0.64278382E-07_JPRB, 0.64615371E-07_JPRB, 0.64928543E-07_JPRB, 0.65156804E-07_JPRB, 0.65439664E-07_JPRB, &
  & 0.65518513E-07_JPRB, 0.65842471E-07_JPRB, 0.65742832E-07_JPRB, 0.66098039E-07_JPRB /)

RGHG7(:,85,11) = (/ &
  & 0.34506915E-07_JPRB, 0.34212810E-07_JPRB, 0.34546314E-07_JPRB, 0.34500843E-07_JPRB, 0.34533134E-07_JPRB, 0.34719118E-07_JPRB, &
  & 0.34734480E-07_JPRB, 0.34920884E-07_JPRB, 0.35029139E-07_JPRB, 0.35274464E-07_JPRB, 0.35509494E-07_JPRB, 0.35836266E-07_JPRB, &
  & 0.36177635E-07_JPRB, 0.36590524E-07_JPRB, 0.37048849E-07_JPRB, 0.37547689E-07_JPRB, 0.38069253E-07_JPRB, 0.38614395E-07_JPRB, &
  & 0.39172839E-07_JPRB, 0.39746215E-07_JPRB, 0.40330907E-07_JPRB, 0.40882206E-07_JPRB, 0.41508944E-07_JPRB, 0.42035538E-07_JPRB, &
  & 0.42657948E-07_JPRB, 0.43222698E-07_JPRB, 0.43862769E-07_JPRB, 0.44513410E-07_JPRB, 0.45237524E-07_JPRB, 0.45990610E-07_JPRB, &
  & 0.46790614E-07_JPRB, 0.47602342E-07_JPRB, 0.48433890E-07_JPRB, 0.49278285E-07_JPRB, 0.50135196E-07_JPRB, 0.50995297E-07_JPRB, &
  & 0.51839169E-07_JPRB, 0.52688915E-07_JPRB, 0.53516427E-07_JPRB, 0.54341157E-07_JPRB, 0.55166254E-07_JPRB, 0.55940237E-07_JPRB, &
  & 0.56742127E-07_JPRB, 0.57501708E-07_JPRB, 0.58265250E-07_JPRB, 0.58979378E-07_JPRB, 0.59664238E-07_JPRB, 0.60322492E-07_JPRB, &
  & 0.60921586E-07_JPRB, 0.61508572E-07_JPRB, 0.62053097E-07_JPRB, 0.62572092E-07_JPRB, 0.63041952E-07_JPRB, 0.63493452E-07_JPRB, &
  & 0.63886020E-07_JPRB, 0.64283270E-07_JPRB, 0.64591994E-07_JPRB, 0.64938945E-07_JPRB, 0.65126784E-07_JPRB, 0.65455502E-07_JPRB, &
  & 0.65490092E-07_JPRB, 0.65846820E-07_JPRB, 0.65732948E-07_JPRB, 0.66081896E-07_JPRB /)

RGHG7(:,86,11) = (/ &
  & 0.34557448E-07_JPRB, 0.34102140E-07_JPRB, 0.34657290E-07_JPRB, 0.34383156E-07_JPRB, 0.34613350E-07_JPRB, 0.34700331E-07_JPRB, &
  & 0.34769233E-07_JPRB, 0.34972047E-07_JPRB, 0.35079722E-07_JPRB, 0.35320181E-07_JPRB, 0.35544122E-07_JPRB, 0.35830176E-07_JPRB, &
  & 0.36174690E-07_JPRB, 0.36557086E-07_JPRB, 0.37015944E-07_JPRB, 0.37514205E-07_JPRB, 0.38045545E-07_JPRB, 0.38587824E-07_JPRB, &
  & 0.39161492E-07_JPRB, 0.39711296E-07_JPRB, 0.40307640E-07_JPRB, 0.40868912E-07_JPRB, 0.41469693E-07_JPRB, 0.42012889E-07_JPRB, &
  & 0.42639364E-07_JPRB, 0.43204384E-07_JPRB, 0.43850505E-07_JPRB, 0.44505185E-07_JPRB, 0.45226979E-07_JPRB, 0.45987171E-07_JPRB, &
  & 0.46785608E-07_JPRB, 0.47605326E-07_JPRB, 0.48436366E-07_JPRB, 0.49285578E-07_JPRB, 0.50145992E-07_JPRB, 0.51001745E-07_JPRB, &
  & 0.51865147E-07_JPRB, 0.52709598E-07_JPRB, 0.53560427E-07_JPRB, 0.54383285E-07_JPRB, 0.55188995E-07_JPRB, 0.56002104E-07_JPRB, &
  & 0.56774834E-07_JPRB, 0.57547059E-07_JPRB, 0.58294304E-07_JPRB, 0.59016731E-07_JPRB, 0.59673603E-07_JPRB, 0.60332802E-07_JPRB, &
  & 0.60934624E-07_JPRB, 0.61517639E-07_JPRB, 0.62056564E-07_JPRB, 0.62577769E-07_JPRB, 0.63040460E-07_JPRB, 0.63499620E-07_JPRB, &
  & 0.63882396E-07_JPRB, 0.64293602E-07_JPRB, 0.64585912E-07_JPRB, 0.64950520E-07_JPRB, 0.65118336E-07_JPRB, 0.65461549E-07_JPRB, &
  & 0.65487797E-07_JPRB, 0.65841888E-07_JPRB, 0.65732991E-07_JPRB, 0.66075060E-07_JPRB /)

RGHG7(:,87,11) = (/ &
  & 0.34602330E-07_JPRB, 0.34023053E-07_JPRB, 0.34739340E-07_JPRB, 0.34252157E-07_JPRB, 0.34721889E-07_JPRB, 0.34604202E-07_JPRB, &
  & 0.34845534E-07_JPRB, 0.34969382E-07_JPRB, 0.35143000E-07_JPRB, 0.35345256E-07_JPRB, 0.35593711E-07_JPRB, 0.35847339E-07_JPRB, &
  & 0.36168615E-07_JPRB, 0.36541675E-07_JPRB, 0.36977447E-07_JPRB, 0.37477506E-07_JPRB, 0.38004071E-07_JPRB, 0.38563488E-07_JPRB, &
  & 0.39115605E-07_JPRB, 0.39694214E-07_JPRB, 0.40278902E-07_JPRB, 0.40844011E-07_JPRB, 0.41433513E-07_JPRB, 0.42003336E-07_JPRB, &
  & 0.42604327E-07_JPRB, 0.43194305E-07_JPRB, 0.43828024E-07_JPRB, 0.44493671E-07_JPRB, 0.45215113E-07_JPRB, 0.45977949E-07_JPRB, &
  & 0.46780489E-07_JPRB, 0.47603947E-07_JPRB, 0.48434309E-07_JPRB, 0.49287486E-07_JPRB, 0.50143562E-07_JPRB, 0.51008495E-07_JPRB, &
  & 0.51865822E-07_JPRB, 0.52729717E-07_JPRB, 0.53577672E-07_JPRB, 0.54426575E-07_JPRB, 0.55251387E-07_JPRB, 0.56039429E-07_JPRB, &
  & 0.56835717E-07_JPRB, 0.57597063E-07_JPRB, 0.58322630E-07_JPRB, 0.59046723E-07_JPRB, 0.59700724E-07_JPRB, 0.60342977E-07_JPRB, &
  & 0.60941225E-07_JPRB, 0.61524737E-07_JPRB, 0.62060408E-07_JPRB, 0.62581272E-07_JPRB, 0.63041121E-07_JPRB, 0.63500352E-07_JPRB, &
  & 0.63880513E-07_JPRB, 0.64290433E-07_JPRB, 0.64584540E-07_JPRB, 0.64943421E-07_JPRB, 0.65122975E-07_JPRB, 0.65448340E-07_JPRB, &
  & 0.65498163E-07_JPRB, 0.65824906E-07_JPRB, 0.65745823E-07_JPRB, 0.66063109E-07_JPRB /)

RGHG7(:,88,11) = (/ &
  & 0.34620875E-07_JPRB, 0.33990066E-07_JPRB, 0.34776907E-07_JPRB, 0.34187007E-07_JPRB, 0.34813461E-07_JPRB, 0.34510723E-07_JPRB, &
  & 0.34971436E-07_JPRB, 0.34907174E-07_JPRB, 0.35223220E-07_JPRB, 0.35327936E-07_JPRB, 0.35608153E-07_JPRB, 0.35833967E-07_JPRB, &
  & 0.36167396E-07_JPRB, 0.36515534E-07_JPRB, 0.36965258E-07_JPRB, 0.37448167E-07_JPRB, 0.37987032E-07_JPRB, 0.38529162E-07_JPRB, &
  & 0.39098357E-07_JPRB, 0.39666805E-07_JPRB, 0.40253660E-07_JPRB, 0.40815078E-07_JPRB, 0.41400870E-07_JPRB, 0.41975309E-07_JPRB, &
  & 0.42568200E-07_JPRB, 0.43171742E-07_JPRB, 0.43801780E-07_JPRB, 0.44473211E-07_JPRB, 0.45193556E-07_JPRB, 0.45962487E-07_JPRB, &
  & 0.46766193E-07_JPRB, 0.47594948E-07_JPRB, 0.48429200E-07_JPRB, 0.49283514E-07_JPRB, 0.50149083E-07_JPRB, 0.51015167E-07_JPRB, &
  & 0.51890904E-07_JPRB, 0.52760104E-07_JPRB, 0.53626117E-07_JPRB, 0.54470881E-07_JPRB, 0.55297228E-07_JPRB, 0.56106089E-07_JPRB, &
  & 0.56872128E-07_JPRB, 0.57643778E-07_JPRB, 0.58359483E-07_JPRB, 0.59060078E-07_JPRB, 0.59718552E-07_JPRB, 0.60358637E-07_JPRB, &
  & 0.60954640E-07_JPRB, 0.61533683E-07_JPRB, 0.62069660E-07_JPRB, 0.62587127E-07_JPRB, 0.63047580E-07_JPRB, 0.63503215E-07_JPRB, &
  & 0.63887839E-07_JPRB, 0.64289857E-07_JPRB, 0.64593671E-07_JPRB, 0.64937439E-07_JPRB, 0.65134820E-07_JPRB, 0.65437412E-07_JPRB, &
  & 0.65513767E-07_JPRB, 0.65807022E-07_JPRB, 0.65766152E-07_JPRB, 0.66042112E-07_JPRB /)

RGHG7(:,89,11) = (/ &
  & 0.34627636E-07_JPRB, 0.33984620E-07_JPRB, 0.34768380E-07_JPRB, 0.34182467E-07_JPRB, 0.34795661E-07_JPRB, 0.34494271E-07_JPRB, &
  & 0.34932384E-07_JPRB, 0.34873949E-07_JPRB, 0.35188009E-07_JPRB, 0.35281854E-07_JPRB, 0.35581937E-07_JPRB, 0.35807908E-07_JPRB, &
  & 0.36146613E-07_JPRB, 0.36511324E-07_JPRB, 0.36953004E-07_JPRB, 0.37444863E-07_JPRB, 0.37976637E-07_JPRB, 0.38519115E-07_JPRB, &
  & 0.39080131E-07_JPRB, 0.39656523E-07_JPRB, 0.40212207E-07_JPRB, 0.40791715E-07_JPRB, 0.41362004E-07_JPRB, 0.41935813E-07_JPRB, &
  & 0.42528313E-07_JPRB, 0.43132758E-07_JPRB, 0.43763158E-07_JPRB, 0.44437176E-07_JPRB, 0.45160313E-07_JPRB, 0.45933742E-07_JPRB, &
  & 0.46745317E-07_JPRB, 0.47580084E-07_JPRB, 0.48422827E-07_JPRB, 0.49289763E-07_JPRB, 0.50160708E-07_JPRB, 0.51039752E-07_JPRB, &
  & 0.51930925E-07_JPRB, 0.52817331E-07_JPRB, 0.53688293E-07_JPRB, 0.54539761E-07_JPRB, 0.55363856E-07_JPRB, 0.56165415E-07_JPRB, &
  & 0.56937999E-07_JPRB, 0.57683142E-07_JPRB, 0.58402385E-07_JPRB, 0.59090926E-07_JPRB, 0.59740415E-07_JPRB, 0.60372230E-07_JPRB, &
  & 0.60969398E-07_JPRB, 0.61543830E-07_JPRB, 0.62081298E-07_JPRB, 0.62595497E-07_JPRB, 0.63057669E-07_JPRB, 0.63507549E-07_JPRB, &
  & 0.63897794E-07_JPRB, 0.64290020E-07_JPRB, 0.64604116E-07_JPRB, 0.64933019E-07_JPRB, 0.65147596E-07_JPRB, 0.65427493E-07_JPRB, &
  & 0.65531239E-07_JPRB, 0.65791504E-07_JPRB, 0.65787901E-07_JPRB, 0.66022942E-07_JPRB /)

RGHG7(:,90,11) = (/ &
  & 0.34605979E-07_JPRB, 0.34030755E-07_JPRB, 0.34703039E-07_JPRB, 0.34244493E-07_JPRB, 0.34711956E-07_JPRB, 0.34529553E-07_JPRB, &
  & 0.34837299E-07_JPRB, 0.34848348E-07_JPRB, 0.35066911E-07_JPRB, 0.35223035E-07_JPRB, 0.35484142E-07_JPRB, 0.35765744E-07_JPRB, &
  & 0.36107615E-07_JPRB, 0.36501007E-07_JPRB, 0.36955075E-07_JPRB, 0.37453667E-07_JPRB, 0.37975038E-07_JPRB, 0.38515733E-07_JPRB, &
  & 0.39073331E-07_JPRB, 0.39617916E-07_JPRB, 0.40187842E-07_JPRB, 0.40746887E-07_JPRB, 0.41306080E-07_JPRB, 0.41880480E-07_JPRB, &
  & 0.42466333E-07_JPRB, 0.43071811E-07_JPRB, 0.43701661E-07_JPRB, 0.44377405E-07_JPRB, 0.45105239E-07_JPRB, 0.45885670E-07_JPRB, &
  & 0.46706067E-07_JPRB, 0.47554028E-07_JPRB, 0.48410161E-07_JPRB, 0.49297576E-07_JPRB, 0.50183058E-07_JPRB, 0.51091416E-07_JPRB, &
  & 0.52012133E-07_JPRB, 0.52914331E-07_JPRB, 0.53792522E-07_JPRB, 0.54641877E-07_JPRB, 0.55461431E-07_JPRB, 0.56251327E-07_JPRB, &
  & 0.57012965E-07_JPRB, 0.57745023E-07_JPRB, 0.58449299E-07_JPRB, 0.59129551E-07_JPRB, 0.59777172E-07_JPRB, 0.60401810E-07_JPRB, &
  & 0.60997209E-07_JPRB, 0.61566830E-07_JPRB, 0.62103624E-07_JPRB, 0.62613793E-07_JPRB, 0.63077600E-07_JPRB, 0.63521121E-07_JPRB, &
  & 0.63916978E-07_JPRB, 0.64299620E-07_JPRB, 0.64622796E-07_JPRB, 0.64935556E-07_JPRB, 0.65167931E-07_JPRB, 0.65422746E-07_JPRB, &
  & 0.65555575E-07_JPRB, 0.65777506E-07_JPRB, 0.65817929E-07_JPRB, 0.66003032E-07_JPRB /)

RGHG7(:,91,11) = (/ &
  & 0.34465998E-07_JPRB, 0.34198994E-07_JPRB, 0.34533837E-07_JPRB, 0.34369606E-07_JPRB, 0.34582310E-07_JPRB, 0.34587885E-07_JPRB, &
  & 0.34715779E-07_JPRB, 0.34800014E-07_JPRB, 0.34936782E-07_JPRB, 0.35067387E-07_JPRB, 0.35359186E-07_JPRB, 0.35689148E-07_JPRB, &
  & 0.36071263E-07_JPRB, 0.36496481E-07_JPRB, 0.36959722E-07_JPRB, 0.37453120E-07_JPRB, 0.37968853E-07_JPRB, 0.38499405E-07_JPRB, &
  & 0.39035303E-07_JPRB, 0.39582627E-07_JPRB, 0.40127315E-07_JPRB, 0.40672003E-07_JPRB, 0.41224610E-07_JPRB, 0.41789395E-07_JPRB, &
  & 0.42371251E-07_JPRB, 0.42976183E-07_JPRB, 0.43608015E-07_JPRB, 0.44286313E-07_JPRB, 0.45021086E-07_JPRB, 0.45813898E-07_JPRB, &
  & 0.46652648E-07_JPRB, 0.47519489E-07_JPRB, 0.48396362E-07_JPRB, 0.49322132E-07_JPRB, 0.50236835E-07_JPRB, 0.51178016E-07_JPRB, &
  & 0.52145797E-07_JPRB, 0.53070163E-07_JPRB, 0.53958018E-07_JPRB, 0.54809490E-07_JPRB, 0.55618329E-07_JPRB, 0.56394803E-07_JPRB, &
  & 0.57140902E-07_JPRB, 0.57853782E-07_JPRB, 0.58537459E-07_JPRB, 0.59196875E-07_JPRB, 0.59831336E-07_JPRB, 0.60446936E-07_JPRB, &
  & 0.61036843E-07_JPRB, 0.61602492E-07_JPRB, 0.62138717E-07_JPRB, 0.62644794E-07_JPRB, 0.63109084E-07_JPRB, 0.63547411E-07_JPRB, &
  & 0.63945478E-07_JPRB, 0.64323203E-07_JPRB, 0.64650770E-07_JPRB, 0.64948331E-07_JPRB, 0.65196630E-07_JPRB, 0.65426974E-07_JPRB, &
  & 0.65589752E-07_JPRB, 0.65766820E-07_JPRB, 0.65865464E-07_JPRB, 0.65971506E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG7(:, 1,12) = (/ &
  & 0.13507636E-06_JPRB, 0.10668850E-06_JPRB, 0.96417857E-07_JPRB, 0.85160650E-07_JPRB, 0.79439232E-07_JPRB, 0.74467195E-07_JPRB, &
  & 0.71678343E-07_JPRB, 0.69675416E-07_JPRB, 0.68739574E-07_JPRB, 0.68407161E-07_JPRB, 0.68597799E-07_JPRB, 0.68934128E-07_JPRB, &
  & 0.69515792E-07_JPRB, 0.70126710E-07_JPRB, 0.70598205E-07_JPRB, 0.71085076E-07_JPRB, 0.71205932E-07_JPRB, 0.71132568E-07_JPRB, &
  & 0.71139624E-07_JPRB, 0.70870840E-07_JPRB, 0.70454476E-07_JPRB, 0.70034531E-07_JPRB, 0.69717942E-07_JPRB, 0.69226765E-07_JPRB, &
  & 0.68762887E-07_JPRB, 0.68340093E-07_JPRB, 0.67897162E-07_JPRB, 0.67543382E-07_JPRB, 0.67227070E-07_JPRB, 0.67021361E-07_JPRB, &
  & 0.66985287E-07_JPRB, 0.67162247E-07_JPRB, 0.67569516E-07_JPRB, 0.68231174E-07_JPRB, 0.68923967E-07_JPRB, 0.69546211E-07_JPRB, &
  & 0.69977119E-07_JPRB, 0.70131605E-07_JPRB, 0.69985916E-07_JPRB, 0.69686003E-07_JPRB, 0.69134295E-07_JPRB, 0.68545667E-07_JPRB, &
  & 0.67968358E-07_JPRB, 0.67465834E-07_JPRB, 0.67060761E-07_JPRB, 0.66623819E-07_JPRB, 0.66152701E-07_JPRB, 0.65618337E-07_JPRB, &
  & 0.65120247E-07_JPRB, 0.64695257E-07_JPRB, 0.64435646E-07_JPRB, 0.64434566E-07_JPRB, 0.64680471E-07_JPRB, 0.65235362E-07_JPRB, &
  & 0.66238286E-07_JPRB, 0.68917572E-07_JPRB, 0.59361810E-05_JPRB, 0.59655049E-05_JPRB, 0.59796507E-05_JPRB, 0.59881954E-05_JPRB, &
  & 0.59787581E-05_JPRB, 0.59823997E-05_JPRB, 0.59878071E-05_JPRB, 0.59843260E-05_JPRB /)

RGHG7(:, 2,12) = (/ &
  & 0.49619928E-06_JPRB, 0.62017415E-06_JPRB, 0.61107107E-06_JPRB, 0.53676393E-06_JPRB, 0.46084628E-06_JPRB, 0.39120502E-06_JPRB, &
  & 0.33187888E-06_JPRB, 0.28403383E-06_JPRB, 0.24797961E-06_JPRB, 0.22437520E-06_JPRB, 0.21505981E-06_JPRB, 0.21122804E-06_JPRB, &
  & 0.21216184E-06_JPRB, 0.21264454E-06_JPRB, 0.21049307E-06_JPRB, 0.21095587E-06_JPRB, 0.20720546E-06_JPRB, 0.20427727E-06_JPRB, &
  & 0.20620990E-06_JPRB, 0.20538225E-06_JPRB, 0.20464027E-06_JPRB, 0.20525941E-06_JPRB, 0.20940384E-06_JPRB, 0.21114649E-06_JPRB, &
  & 0.21222719E-06_JPRB, 0.21291291E-06_JPRB, 0.21255983E-06_JPRB, 0.21565099E-06_JPRB, 0.21628277E-06_JPRB, 0.21666462E-06_JPRB, &
  & 0.21667282E-06_JPRB, 0.21586867E-06_JPRB, 0.21601295E-06_JPRB, 0.22294140E-06_JPRB, 0.22603251E-06_JPRB, 0.22741395E-06_JPRB, &
  & 0.22704371E-06_JPRB, 0.22393878E-06_JPRB, 0.22068576E-06_JPRB, 0.22245422E-06_JPRB, 0.22083867E-06_JPRB, 0.22103521E-06_JPRB, &
  & 0.21898165E-06_JPRB, 0.21911700E-06_JPRB, 0.22191722E-06_JPRB, 0.22489252E-06_JPRB, 0.22762165E-06_JPRB, 0.22731311E-06_JPRB, &
  & 0.22759569E-06_JPRB, 0.22557116E-06_JPRB, 0.22142045E-06_JPRB, 0.21570351E-06_JPRB, 0.20630198E-06_JPRB, 0.19692804E-06_JPRB, &
  & 0.18933109E-06_JPRB, 0.19357360E-06_JPRB, 0.56898671E-05_JPRB, 0.55702676E-05_JPRB, 0.54668958E-05_JPRB, 0.53895146E-05_JPRB, &
  & 0.53250874E-05_JPRB, 0.52211822E-05_JPRB, 0.50708077E-05_JPRB, 0.47820008E-05_JPRB /)

RGHG7(:, 3,12) = (/ &
  & 0.70406821E-06_JPRB, 0.89680458E-06_JPRB, 0.89454193E-06_JPRB, 0.83834226E-06_JPRB, 0.76619830E-06_JPRB, 0.69516653E-06_JPRB, &
  & 0.62397498E-06_JPRB, 0.55787478E-06_JPRB, 0.50110020E-06_JPRB, 0.46404685E-06_JPRB, 0.44822113E-06_JPRB, 0.43514581E-06_JPRB, &
  & 0.43045935E-06_JPRB, 0.42255337E-06_JPRB, 0.41551550E-06_JPRB, 0.41276357E-06_JPRB, 0.40337517E-06_JPRB, 0.40240735E-06_JPRB, &
  & 0.40558447E-06_JPRB, 0.40170502E-06_JPRB, 0.40078609E-06_JPRB, 0.40263780E-06_JPRB, 0.40977577E-06_JPRB, 0.40979953E-06_JPRB, &
  & 0.40927358E-06_JPRB, 0.40801075E-06_JPRB, 0.40847192E-06_JPRB, 0.41529765E-06_JPRB, 0.41425770E-06_JPRB, 0.41202702E-06_JPRB, &
  & 0.41006561E-06_JPRB, 0.40949845E-06_JPRB, 0.41202102E-06_JPRB, 0.42177879E-06_JPRB, 0.42212690E-06_JPRB, 0.41955565E-06_JPRB, &
  & 0.41537572E-06_JPRB, 0.41095277E-06_JPRB, 0.40787484E-06_JPRB, 0.41125728E-06_JPRB, 0.40760193E-06_JPRB, 0.40333191E-06_JPRB, &
  & 0.40027638E-06_JPRB, 0.39881425E-06_JPRB, 0.40276083E-06_JPRB, 0.40244024E-06_JPRB, 0.40150462E-06_JPRB, 0.40043406E-06_JPRB, &
  & 0.40130351E-06_JPRB, 0.39403881E-06_JPRB, 0.37905639E-06_JPRB, 0.36083091E-06_JPRB, 0.33950576E-06_JPRB, 0.32347990E-06_JPRB, &
  & 0.31729385E-06_JPRB, 0.35786852E-06_JPRB, 0.36926617E-05_JPRB, 0.38234602E-05_JPRB, 0.38252447E-05_JPRB, 0.37515726E-05_JPRB, &
  & 0.36314273E-05_JPRB, 0.35068201E-05_JPRB, 0.33275792E-05_JPRB, 0.30041319E-05_JPRB /)

RGHG7(:, 4,12) = (/ &
  & 0.90061252E-06_JPRB, 0.10173786E-05_JPRB, 0.99531951E-06_JPRB, 0.93290970E-06_JPRB, 0.86297894E-06_JPRB, 0.79934114E-06_JPRB, &
  & 0.74652689E-06_JPRB, 0.70413728E-06_JPRB, 0.68511412E-06_JPRB, 0.68726143E-06_JPRB, 0.69452511E-06_JPRB, 0.70269971E-06_JPRB, &
  & 0.71051880E-06_JPRB, 0.71195439E-06_JPRB, 0.71534328E-06_JPRB, 0.71963916E-06_JPRB, 0.71345920E-06_JPRB, 0.72323894E-06_JPRB, &
  & 0.73055941E-06_JPRB, 0.72732456E-06_JPRB, 0.72939883E-06_JPRB, 0.73611153E-06_JPRB, 0.74807679E-06_JPRB, 0.74272697E-06_JPRB, &
  & 0.74086370E-06_JPRB, 0.73623096E-06_JPRB, 0.73902038E-06_JPRB, 0.74802369E-06_JPRB, 0.74143566E-06_JPRB, 0.73715711E-06_JPRB, &
  & 0.73185566E-06_JPRB, 0.72831398E-06_JPRB, 0.72924615E-06_JPRB, 0.73540969E-06_JPRB, 0.72479583E-06_JPRB, 0.71321858E-06_JPRB, &
  & 0.69989346E-06_JPRB, 0.68809237E-06_JPRB, 0.68020637E-06_JPRB, 0.67944359E-06_JPRB, 0.66739460E-06_JPRB, 0.65685538E-06_JPRB, &
  & 0.64730642E-06_JPRB, 0.63997607E-06_JPRB, 0.63798240E-06_JPRB, 0.63081228E-06_JPRB, 0.62321851E-06_JPRB, 0.61193077E-06_JPRB, &
  & 0.59523677E-06_JPRB, 0.56854492E-06_JPRB, 0.54554641E-06_JPRB, 0.53265717E-06_JPRB, 0.52101643E-06_JPRB, 0.51663085E-06_JPRB, &
  & 0.52653070E-06_JPRB, 0.66800879E-06_JPRB, 0.24105714E-05_JPRB, 0.24727156E-05_JPRB, 0.24532596E-05_JPRB, 0.24180001E-05_JPRB, &
  & 0.23414259E-05_JPRB, 0.22445424E-05_JPRB, 0.21333947E-05_JPRB, 0.19500812E-05_JPRB /)

RGHG7(:, 5,12) = (/ &
  & 0.10802028E-05_JPRB, 0.10672827E-05_JPRB, 0.10212237E-05_JPRB, 0.98119483E-06_JPRB, 0.95129957E-06_JPRB, 0.92675083E-06_JPRB, &
  & 0.90535070E-06_JPRB, 0.88942494E-06_JPRB, 0.90032501E-06_JPRB, 0.92820852E-06_JPRB, 0.95260867E-06_JPRB, 0.97550014E-06_JPRB, &
  & 0.99805447E-06_JPRB, 0.10095574E-05_JPRB, 0.10269232E-05_JPRB, 0.10416568E-05_JPRB, 0.10459048E-05_JPRB, 0.10699609E-05_JPRB, &
  & 0.10823753E-05_JPRB, 0.10837755E-05_JPRB, 0.10897819E-05_JPRB, 0.11039393E-05_JPRB, 0.11188055E-05_JPRB, 0.11087892E-05_JPRB, &
  & 0.11076257E-05_JPRB, 0.10994002E-05_JPRB, 0.11061809E-05_JPRB, 0.11141219E-05_JPRB, 0.11010366E-05_JPRB, 0.10941392E-05_JPRB, &
  & 0.10827911E-05_JPRB, 0.10745355E-05_JPRB, 0.10725554E-05_JPRB, 0.10745160E-05_JPRB, 0.10521243E-05_JPRB, 0.10335325E-05_JPRB, &
  & 0.10126610E-05_JPRB, 0.99674969E-06_JPRB, 0.98792987E-06_JPRB, 0.98663588E-06_JPRB, 0.96761005E-06_JPRB, 0.95082981E-06_JPRB, &
  & 0.93347046E-06_JPRB, 0.91997424E-06_JPRB, 0.91128959E-06_JPRB, 0.89544346E-06_JPRB, 0.87492793E-06_JPRB, 0.84832340E-06_JPRB, &
  & 0.83035752E-06_JPRB, 0.82224796E-06_JPRB, 0.81799516E-06_JPRB, 0.80613421E-06_JPRB, 0.78766823E-06_JPRB, 0.77940376E-06_JPRB, &
  & 0.79113408E-06_JPRB, 0.10190017E-05_JPRB, 0.16895252E-05_JPRB, 0.17845545E-05_JPRB, 0.18027357E-05_JPRB, 0.17772376E-05_JPRB, &
  & 0.17388854E-05_JPRB, 0.16964103E-05_JPRB, 0.16611209E-05_JPRB, 0.16159755E-05_JPRB /)

RGHG7(:, 6,12) = (/ &
  & 0.13237741E-05_JPRB, 0.13296460E-05_JPRB, 0.12978187E-05_JPRB, 0.12542258E-05_JPRB, 0.12109824E-05_JPRB, 0.11762571E-05_JPRB, &
  & 0.11512893E-05_JPRB, 0.11404441E-05_JPRB, 0.11657755E-05_JPRB, 0.12120211E-05_JPRB, 0.12537472E-05_JPRB, 0.12927836E-05_JPRB, &
  & 0.13318515E-05_JPRB, 0.13582313E-05_JPRB, 0.13908643E-05_JPRB, 0.14161800E-05_JPRB, 0.14308121E-05_JPRB, 0.14676223E-05_JPRB, &
  & 0.14866201E-05_JPRB, 0.14933175E-05_JPRB, 0.15032512E-05_JPRB, 0.15225838E-05_JPRB, 0.15373023E-05_JPRB, 0.15238893E-05_JPRB, &
  & 0.15218618E-05_JPRB, 0.15104041E-05_JPRB, 0.15200026E-05_JPRB, 0.15241581E-05_JPRB, 0.15042932E-05_JPRB, 0.14912357E-05_JPRB, &
  & 0.14701442E-05_JPRB, 0.14542468E-05_JPRB, 0.14482420E-05_JPRB, 0.14479484E-05_JPRB, 0.14191972E-05_JPRB, 0.14010749E-05_JPRB, &
  & 0.13788789E-05_JPRB, 0.13627550E-05_JPRB, 0.13541238E-05_JPRB, 0.13521957E-05_JPRB, 0.13271157E-05_JPRB, 0.13058711E-05_JPRB, &
  & 0.12826886E-05_JPRB, 0.12643509E-05_JPRB, 0.12471925E-05_JPRB, 0.12204420E-05_JPRB, 0.11966195E-05_JPRB, 0.11869744E-05_JPRB, &
  & 0.11907250E-05_JPRB, 0.11771808E-05_JPRB, 0.11554498E-05_JPRB, 0.11444786E-05_JPRB, 0.11423456E-05_JPRB, 0.11519666E-05_JPRB, &
  & 0.11885749E-05_JPRB, 0.13734552E-05_JPRB, 0.15530916E-05_JPRB, 0.15591354E-05_JPRB, 0.15441144E-05_JPRB, 0.15503319E-05_JPRB, &
  & 0.15523120E-05_JPRB, 0.15687443E-05_JPRB, 0.15878718E-05_JPRB, 0.16406058E-05_JPRB /)

RGHG7(:, 7,12) = (/ &
  & 0.15873213E-05_JPRB, 0.15532281E-05_JPRB, 0.15089236E-05_JPRB, 0.14792146E-05_JPRB, 0.14622726E-05_JPRB, 0.14555731E-05_JPRB, &
  & 0.14540512E-05_JPRB, 0.14597042E-05_JPRB, 0.14946907E-05_JPRB, 0.15492111E-05_JPRB, 0.15990614E-05_JPRB, 0.16500190E-05_JPRB, &
  & 0.17018406E-05_JPRB, 0.17422325E-05_JPRB, 0.17902277E-05_JPRB, 0.18286538E-05_JPRB, 0.18556167E-05_JPRB, 0.19041671E-05_JPRB, &
  & 0.19330569E-05_JPRB, 0.19488459E-05_JPRB, 0.19684758E-05_JPRB, 0.19974491E-05_JPRB, 0.20178418E-05_JPRB, 0.20081206E-05_JPRB, &
  & 0.20089531E-05_JPRB, 0.19996144E-05_JPRB, 0.20138662E-05_JPRB, 0.20170285E-05_JPRB, 0.19923850E-05_JPRB, 0.19739962E-05_JPRB, &
  & 0.19444740E-05_JPRB, 0.19220363E-05_JPRB, 0.19134645E-05_JPRB, 0.19129620E-05_JPRB, 0.18832386E-05_JPRB, 0.18710989E-05_JPRB, &
  & 0.18549327E-05_JPRB, 0.18461976E-05_JPRB, 0.18438037E-05_JPRB, 0.18438153E-05_JPRB, 0.18141332E-05_JPRB, 0.17893310E-05_JPRB, &
  & 0.17620239E-05_JPRB, 0.17421534E-05_JPRB, 0.17244398E-05_JPRB, 0.17053138E-05_JPRB, 0.16972821E-05_JPRB, 0.16879129E-05_JPRB, &
  & 0.16653677E-05_JPRB, 0.16423501E-05_JPRB, 0.16441240E-05_JPRB, 0.16508449E-05_JPRB, 0.16548549E-05_JPRB, 0.16687703E-05_JPRB, &
  & 0.16868098E-05_JPRB, 0.17067809E-05_JPRB, 0.17041961E-05_JPRB, 0.16687563E-05_JPRB, 0.16467631E-05_JPRB, 0.16575914E-05_JPRB, &
  & 0.16792757E-05_JPRB, 0.17085930E-05_JPRB, 0.17515076E-05_JPRB, 0.18323042E-05_JPRB /)

RGHG7(:, 8,12) = (/ &
  & 0.18720664E-05_JPRB, 0.18521509E-05_JPRB, 0.18325994E-05_JPRB, 0.18126719E-05_JPRB, 0.17962002E-05_JPRB, 0.17843334E-05_JPRB, &
  & 0.17802889E-05_JPRB, 0.17884447E-05_JPRB, 0.18271739E-05_JPRB, 0.18874177E-05_JPRB, 0.19446807E-05_JPRB, 0.20021080E-05_JPRB, &
  & 0.20590892E-05_JPRB, 0.21058265E-05_JPRB, 0.21611575E-05_JPRB, 0.22077199E-05_JPRB, 0.22448137E-05_JPRB, 0.23014070E-05_JPRB, &
  & 0.23384155E-05_JPRB, 0.23623609E-05_JPRB, 0.23910654E-05_JPRB, 0.24291894E-05_JPRB, 0.24568676E-05_JPRB, 0.24565659E-05_JPRB, &
  & 0.24634987E-05_JPRB, 0.24619840E-05_JPRB, 0.24825010E-05_JPRB, 0.24892531E-05_JPRB, 0.24671021E-05_JPRB, 0.24519659E-05_JPRB, &
  & 0.24265908E-05_JPRB, 0.24103924E-05_JPRB, 0.24091323E-05_JPRB, 0.24114522E-05_JPRB, 0.23798832E-05_JPRB, 0.23626033E-05_JPRB, &
  & 0.23395191E-05_JPRB, 0.23262176E-05_JPRB, 0.23232926E-05_JPRB, 0.23239338E-05_JPRB, 0.22982344E-05_JPRB, 0.22832453E-05_JPRB, &
  & 0.22699937E-05_JPRB, 0.22677552E-05_JPRB, 0.22641566E-05_JPRB, 0.22557356E-05_JPRB, 0.22484553E-05_JPRB, 0.22403824E-05_JPRB, &
  & 0.22479364E-05_JPRB, 0.22635777E-05_JPRB, 0.22744916E-05_JPRB, 0.22804002E-05_JPRB, 0.22875640E-05_JPRB, 0.22801430E-05_JPRB, &
  & 0.22232705E-05_JPRB, 0.21039268E-05_JPRB, 0.20083130E-05_JPRB, 0.19545414E-05_JPRB, 0.19238278E-05_JPRB, 0.19309252E-05_JPRB, &
  & 0.19529441E-05_JPRB, 0.19939830E-05_JPRB, 0.20372813E-05_JPRB, 0.21149249E-05_JPRB /)

RGHG7(:, 9,12) = (/ &
  & 0.22216373E-05_JPRB, 0.21707256E-05_JPRB, 0.21333626E-05_JPRB, 0.21077080E-05_JPRB, 0.21012888E-05_JPRB, 0.21104979E-05_JPRB, &
  & 0.21253263E-05_JPRB, 0.21492997E-05_JPRB, 0.21952092E-05_JPRB, 0.22567478E-05_JPRB, 0.23182267E-05_JPRB, 0.23844595E-05_JPRB, &
  & 0.24525475E-05_JPRB, 0.25099907E-05_JPRB, 0.25748400E-05_JPRB, 0.26304413E-05_JPRB, 0.26782232E-05_JPRB, 0.27454275E-05_JPRB, &
  & 0.27945805E-05_JPRB, 0.28326001E-05_JPRB, 0.28768911E-05_JPRB, 0.29329533E-05_JPRB, 0.29752491E-05_JPRB, 0.29926528E-05_JPRB, &
  & 0.30127360E-05_JPRB, 0.30248300E-05_JPRB, 0.30561846E-05_JPRB, 0.30709130E-05_JPRB, 0.30557235E-05_JPRB, 0.30480812E-05_JPRB, &
  & 0.30310571E-05_JPRB, 0.30245951E-05_JPRB, 0.30327196E-05_JPRB, 0.30391675E-05_JPRB, 0.30076515E-05_JPRB, 0.29831274E-05_JPRB, &
  & 0.29481066E-05_JPRB, 0.29227335E-05_JPRB, 0.29118225E-05_JPRB, 0.29072673E-05_JPRB, 0.28824550E-05_JPRB, 0.28730519E-05_JPRB, &
  & 0.28677332E-05_JPRB, 0.28800766E-05_JPRB, 0.28947527E-05_JPRB, 0.29091348E-05_JPRB, 0.29273447E-05_JPRB, 0.29505031E-05_JPRB, &
  & 0.29710941E-05_JPRB, 0.29758639E-05_JPRB, 0.29846965E-05_JPRB, 0.29871730E-05_JPRB, 0.29569458E-05_JPRB, 0.28677080E-05_JPRB, &
  & 0.27020010E-05_JPRB, 0.25066270E-05_JPRB, 0.23841487E-05_JPRB, 0.23388100E-05_JPRB, 0.23053674E-05_JPRB, 0.23166290E-05_JPRB, &
  & 0.23415389E-05_JPRB, 0.23631303E-05_JPRB, 0.23931455E-05_JPRB, 0.24442575E-05_JPRB /)

RGHG7(:,10,12) = (/ &
  & 0.27320407E-05_JPRB, 0.26480061E-05_JPRB, 0.25990569E-05_JPRB, 0.25766431E-05_JPRB, 0.25636966E-05_JPRB, 0.25661834E-05_JPRB, &
  & 0.25822671E-05_JPRB, 0.26112566E-05_JPRB, 0.26624648E-05_JPRB, 0.27296380E-05_JPRB, 0.27980225E-05_JPRB, 0.28711140E-05_JPRB, &
  & 0.29475607E-05_JPRB, 0.30159140E-05_JPRB, 0.30930169E-05_JPRB, 0.31612838E-05_JPRB, 0.32243161E-05_JPRB, 0.33068532E-05_JPRB, &
  & 0.33723500E-05_JPRB, 0.34275035E-05_JPRB, 0.34893226E-05_JPRB, 0.35662215E-05_JPRB, 0.36267461E-05_JPRB, 0.36640647E-05_JPRB, &
  & 0.37010814E-05_JPRB, 0.37297932E-05_JPRB, 0.37750012E-05_JPRB, 0.38024189E-05_JPRB, 0.37975233E-05_JPRB, 0.37987418E-05_JPRB, &
  & 0.37898492E-05_JPRB, 0.37897200E-05_JPRB, 0.38006895E-05_JPRB, 0.38003263E-05_JPRB, 0.37571165E-05_JPRB, 0.37154709E-05_JPRB, &
  & 0.36622923E-05_JPRB, 0.36231970E-05_JPRB, 0.36066017E-05_JPRB, 0.35982334E-05_JPRB, 0.35775649E-05_JPRB, 0.35796525E-05_JPRB, &
  & 0.35997878E-05_JPRB, 0.36482995E-05_JPRB, 0.36899517E-05_JPRB, 0.37235434E-05_JPRB, 0.37565758E-05_JPRB, 0.37870152E-05_JPRB, &
  & 0.38066619E-05_JPRB, 0.38134676E-05_JPRB, 0.38024996E-05_JPRB, 0.37394079E-05_JPRB, 0.36112863E-05_JPRB, 0.34055188E-05_JPRB, &
  & 0.31467123E-05_JPRB, 0.29202524E-05_JPRB, 0.28062336E-05_JPRB, 0.27581523E-05_JPRB, 0.27168610E-05_JPRB, 0.27206972E-05_JPRB, &
  & 0.27246579E-05_JPRB, 0.27362394E-05_JPRB, 0.27545639E-05_JPRB, 0.27761182E-05_JPRB /)

RGHG7(:,11,12) = (/ &
  & 0.34877262E-05_JPRB, 0.33659912E-05_JPRB, 0.32942726E-05_JPRB, 0.32529144E-05_JPRB, 0.32341238E-05_JPRB, 0.32311677E-05_JPRB, &
  & 0.32430560E-05_JPRB, 0.32740970E-05_JPRB, 0.33279257E-05_JPRB, 0.33937181E-05_JPRB, 0.34609477E-05_JPRB, 0.35343894E-05_JPRB, &
  & 0.36121980E-05_JPRB, 0.36833917E-05_JPRB, 0.37659024E-05_JPRB, 0.38400967E-05_JPRB, 0.39129905E-05_JPRB, 0.40073978E-05_JPRB, &
  & 0.40877339E-05_JPRB, 0.41596568E-05_JPRB, 0.42378433E-05_JPRB, 0.43329446E-05_JPRB, 0.44095746E-05_JPRB, 0.44647845E-05_JPRB, &
  & 0.45183683E-05_JPRB, 0.45655484E-05_JPRB, 0.46270425E-05_JPRB, 0.46715172E-05_JPRB, 0.46832301E-05_JPRB, 0.46963191E-05_JPRB, &
  & 0.46949776E-05_JPRB, 0.46952514E-05_JPRB, 0.47011431E-05_JPRB, 0.46868458E-05_JPRB, 0.46280693E-05_JPRB, 0.45678553E-05_JPRB, &
  & 0.45056104E-05_JPRB, 0.44590670E-05_JPRB, 0.44276981E-05_JPRB, 0.44100311E-05_JPRB, 0.44058183E-05_JPRB, 0.44352910E-05_JPRB, &
  & 0.44805588E-05_JPRB, 0.45481238E-05_JPRB, 0.46021341E-05_JPRB, 0.46438877E-05_JPRB, 0.46744585E-05_JPRB, 0.46870464E-05_JPRB, &
  & 0.46736650E-05_JPRB, 0.46160476E-05_JPRB, 0.45109523E-05_JPRB, 0.43413083E-05_JPRB, 0.41048033E-05_JPRB, 0.38122978E-05_JPRB, &
  & 0.35260778E-05_JPRB, 0.33190879E-05_JPRB, 0.32249334E-05_JPRB, 0.31751126E-05_JPRB, 0.31421380E-05_JPRB, 0.31433538E-05_JPRB, &
  & 0.31380748E-05_JPRB, 0.31453108E-05_JPRB, 0.31518682E-05_JPRB, 0.31566121E-05_JPRB /)

RGHG7(:,12,12) = (/ &
  & 0.42409083E-05_JPRB, 0.41241469E-05_JPRB, 0.40562209E-05_JPRB, 0.40151567E-05_JPRB, 0.39896045E-05_JPRB, 0.39789766E-05_JPRB, &
  & 0.39821666E-05_JPRB, 0.40070922E-05_JPRB, 0.40636010E-05_JPRB, 0.41361859E-05_JPRB, 0.42118108E-05_JPRB, 0.42961979E-05_JPRB, &
  & 0.43863097E-05_JPRB, 0.44704911E-05_JPRB, 0.45681054E-05_JPRB, 0.46578621E-05_JPRB, 0.47488852E-05_JPRB, 0.48606648E-05_JPRB, &
  & 0.49598125E-05_JPRB, 0.50526965E-05_JPRB, 0.51517527E-05_JPRB, 0.52683895E-05_JPRB, 0.53656422E-05_JPRB, 0.54425245E-05_JPRB, &
  & 0.55157570E-05_JPRB, 0.55841970E-05_JPRB, 0.56645067E-05_JPRB, 0.57260258E-05_JPRB, 0.57521993E-05_JPRB, 0.57709753E-05_JPRB, &
  & 0.57667085E-05_JPRB, 0.57517814E-05_JPRB, 0.57339898E-05_JPRB, 0.56907575E-05_JPRB, 0.56080589E-05_JPRB, 0.55302744E-05_JPRB, &
  & 0.54445959E-05_JPRB, 0.53800954E-05_JPRB, 0.53535000E-05_JPRB, 0.53377371E-05_JPRB, 0.53232438E-05_JPRB, 0.53365857E-05_JPRB, &
  & 0.53731587E-05_JPRB, 0.54299358E-05_JPRB, 0.54629490E-05_JPRB, 0.54644293E-05_JPRB, 0.54436209E-05_JPRB, 0.53964750E-05_JPRB, &
  & 0.53052072E-05_JPRB, 0.51619982E-05_JPRB, 0.49728960E-05_JPRB, 0.47214457E-05_JPRB, 0.44241988E-05_JPRB, 0.41180811E-05_JPRB, &
  & 0.38613884E-05_JPRB, 0.36933525E-05_JPRB, 0.36129268E-05_JPRB, 0.35696214E-05_JPRB, 0.35426290E-05_JPRB, 0.35303844E-05_JPRB, &
  & 0.35142173E-05_JPRB, 0.35107576E-05_JPRB, 0.35040539E-05_JPRB, 0.34680515E-05_JPRB /)

RGHG7(:,13,12) = (/ &
  & 0.47740032E-05_JPRB, 0.46938276E-05_JPRB, 0.46556811E-05_JPRB, 0.46345440E-05_JPRB, 0.46271753E-05_JPRB, 0.46331825E-05_JPRB, &
  & 0.46539631E-05_JPRB, 0.46984474E-05_JPRB, 0.47800731E-05_JPRB, 0.48776283E-05_JPRB, 0.49757800E-05_JPRB, 0.50813233E-05_JPRB, &
  & 0.51914672E-05_JPRB, 0.52946339E-05_JPRB, 0.54089624E-05_JPRB, 0.55152859E-05_JPRB, 0.56255826E-05_JPRB, 0.57557918E-05_JPRB, &
  & 0.58751789E-05_JPRB, 0.59908029E-05_JPRB, 0.61124019E-05_JPRB, 0.62501535E-05_JPRB, 0.63677362E-05_JPRB, 0.64656297E-05_JPRB, &
  & 0.65570171E-05_JPRB, 0.66417210E-05_JPRB, 0.67308060E-05_JPRB, 0.67918841E-05_JPRB, 0.68081686E-05_JPRB, 0.68013246E-05_JPRB, &
  & 0.67625824E-05_JPRB, 0.67092428E-05_JPRB, 0.66528073E-05_JPRB, 0.65789836E-05_JPRB, 0.64828505E-05_JPRB, 0.63911357E-05_JPRB, &
  & 0.63136977E-05_JPRB, 0.62561890E-05_JPRB, 0.62064892E-05_JPRB, 0.61572950E-05_JPRB, 0.61134401E-05_JPRB, 0.60798411E-05_JPRB, &
  & 0.60505654E-05_JPRB, 0.60230027E-05_JPRB, 0.59733925E-05_JPRB, 0.58969963E-05_JPRB, 0.58016108E-05_JPRB, 0.56874378E-05_JPRB, &
  & 0.55364430E-05_JPRB, 0.53472613E-05_JPRB, 0.51232269E-05_JPRB, 0.48617071E-05_JPRB, 0.45883453E-05_JPRB, 0.43323316E-05_JPRB, &
  & 0.41278386E-05_JPRB, 0.40015739E-05_JPRB, 0.39383531E-05_JPRB, 0.39015913E-05_JPRB, 0.38729072E-05_JPRB, 0.38546532E-05_JPRB, &
  & 0.38401104E-05_JPRB, 0.38360899E-05_JPRB, 0.38226117E-05_JPRB, 0.38008304E-05_JPRB /)

RGHG7(:,14,12) = (/ &
  & 0.50748458E-05_JPRB, 0.50480148E-05_JPRB, 0.50456561E-05_JPRB, 0.50582157E-05_JPRB, 0.50835110E-05_JPRB, 0.51229827E-05_JPRB, &
  & 0.51799793E-05_JPRB, 0.52631358E-05_JPRB, 0.53878807E-05_JPRB, 0.55272531E-05_JPRB, 0.56643489E-05_JPRB, 0.58037967E-05_JPRB, &
  & 0.59441741E-05_JPRB, 0.60765328E-05_JPRB, 0.62169506E-05_JPRB, 0.63472248E-05_JPRB, 0.64809369E-05_JPRB, 0.66326061E-05_JPRB, &
  & 0.67754768E-05_JPRB, 0.69156490E-05_JPRB, 0.70609958E-05_JPRB, 0.72187086E-05_JPRB, 0.73541169E-05_JPRB, 0.74662958E-05_JPRB, &
  & 0.75665180E-05_JPRB, 0.76525612E-05_JPRB, 0.77315826E-05_JPRB, 0.77693940E-05_JPRB, 0.77503037E-05_JPRB, 0.76948627E-05_JPRB, &
  & 0.75992216E-05_JPRB, 0.74934410E-05_JPRB, 0.73947840E-05_JPRB, 0.72848047E-05_JPRB, 0.71678660E-05_JPRB, 0.70779338E-05_JPRB, &
  & 0.69894108E-05_JPRB, 0.69117073E-05_JPRB, 0.68498757E-05_JPRB, 0.67780866E-05_JPRB, 0.66928933E-05_JPRB, 0.65996569E-05_JPRB, &
  & 0.65016579E-05_JPRB, 0.63983894E-05_JPRB, 0.62767317E-05_JPRB, 0.61322608E-05_JPRB, 0.59743625E-05_JPRB, 0.58020455E-05_JPRB, &
  & 0.56033805E-05_JPRB, 0.53823746E-05_JPRB, 0.51491288E-05_JPRB, 0.49058135E-05_JPRB, 0.46674654E-05_JPRB, 0.44527746E-05_JPRB, &
  & 0.42851361E-05_JPRB, 0.41999097E-05_JPRB, 0.41643243E-05_JPRB, 0.41378280E-05_JPRB, 0.41168933E-05_JPRB, 0.41032094E-05_JPRB, &
  & 0.40888481E-05_JPRB, 0.40793989E-05_JPRB, 0.40671557E-05_JPRB, 0.40358477E-05_JPRB /)

RGHG7(:,15,12) = (/ &
  & 0.51399970E-05_JPRB, 0.51691418E-05_JPRB, 0.52059804E-05_JPRB, 0.52545615E-05_JPRB, 0.53182184E-05_JPRB, 0.53992148E-05_JPRB, &
  & 0.55011114E-05_JPRB, 0.56327945E-05_JPRB, 0.58087116E-05_JPRB, 0.59980903E-05_JPRB, 0.61812525E-05_JPRB, 0.63607999E-05_JPRB, &
  & 0.65351051E-05_JPRB, 0.66980319E-05_JPRB, 0.68659069E-05_JPRB, 0.70231727E-05_JPRB, 0.71820982E-05_JPRB, 0.73549118E-05_JPRB, &
  & 0.75190401E-05_JPRB, 0.76775759E-05_JPRB, 0.78380099E-05_JPRB, 0.80044465E-05_JPRB, 0.81443823E-05_JPRB, 0.82557854E-05_JPRB, &
  & 0.83481518E-05_JPRB, 0.84169396E-05_JPRB, 0.84680305E-05_JPRB, 0.84710837E-05_JPRB, 0.84139911E-05_JPRB, 0.83192417E-05_JPRB, &
  & 0.81921744E-05_JPRB, 0.80581813E-05_JPRB, 0.79345082E-05_JPRB, 0.78140383E-05_JPRB, 0.76924534E-05_JPRB, 0.75696616E-05_JPRB, &
  & 0.74667223E-05_JPRB, 0.73780466E-05_JPRB, 0.72918879E-05_JPRB, 0.71913437E-05_JPRB, 0.70769538E-05_JPRB, 0.69490425E-05_JPRB, &
  & 0.68097693E-05_JPRB, 0.66609086E-05_JPRB, 0.64963997E-05_JPRB, 0.63153520E-05_JPRB, 0.61231408E-05_JPRB, 0.59179661E-05_JPRB, &
  & 0.56972049E-05_JPRB, 0.54668694E-05_JPRB, 0.52365135E-05_JPRB, 0.50078497E-05_JPRB, 0.47902063E-05_JPRB, 0.45969668E-05_JPRB, &
  & 0.44516396E-05_JPRB, 0.43828650E-05_JPRB, 0.43561608E-05_JPRB, 0.43313862E-05_JPRB, 0.43145992E-05_JPRB, 0.43008758E-05_JPRB, &
  & 0.42868301E-05_JPRB, 0.42770616E-05_JPRB, 0.42643373E-05_JPRB, 0.42405832E-05_JPRB /)

RGHG7(:,16,12) = (/ &
  & 0.50928720E-05_JPRB, 0.51447514E-05_JPRB, 0.51987404E-05_JPRB, 0.52688260E-05_JPRB, 0.53577064E-05_JPRB, 0.54671914E-05_JPRB, &
  & 0.56013796E-05_JPRB, 0.57688621E-05_JPRB, 0.59835638E-05_JPRB, 0.62153267E-05_JPRB, 0.64430019E-05_JPRB, 0.66656035E-05_JPRB, &
  & 0.68811637E-05_JPRB, 0.70837141E-05_JPRB, 0.72871971E-05_JPRB, 0.74792488E-05_JPRB, 0.76699507E-05_JPRB, 0.78684652E-05_JPRB, &
  & 0.80550863E-05_JPRB, 0.82288707E-05_JPRB, 0.83976292E-05_JPRB, 0.85628935E-05_JPRB, 0.86969458E-05_JPRB, 0.87956387E-05_JPRB, &
  & 0.88664319E-05_JPRB, 0.89038358E-05_JPRB, 0.89154082E-05_JPRB, 0.88771321E-05_JPRB, 0.87857197E-05_JPRB, 0.86605141E-05_JPRB, &
  & 0.85163965E-05_JPRB, 0.83721807E-05_JPRB, 0.82524512E-05_JPRB, 0.81213884E-05_JPRB, 0.79952115E-05_JPRB, 0.78832127E-05_JPRB, &
  & 0.77670011E-05_JPRB, 0.76535125E-05_JPRB, 0.75436674E-05_JPRB, 0.74194722E-05_JPRB, 0.72785747E-05_JPRB, 0.71237259E-05_JPRB, &
  & 0.69576845E-05_JPRB, 0.67843248E-05_JPRB, 0.66007356E-05_JPRB, 0.64056248E-05_JPRB, 0.62030340E-05_JPRB, 0.59928861E-05_JPRB, &
  & 0.57759048E-05_JPRB, 0.55561804E-05_JPRB, 0.53404947E-05_JPRB, 0.51291149E-05_JPRB, 0.49289529E-05_JPRB, 0.47532662E-05_JPRB, &
  & 0.46317932E-05_JPRB, 0.45702150E-05_JPRB, 0.45386892E-05_JPRB, 0.45079523E-05_JPRB, 0.44861281E-05_JPRB, 0.44673411E-05_JPRB, &
  & 0.44489652E-05_JPRB, 0.44373528E-05_JPRB, 0.44208791E-05_JPRB, 0.44005719E-05_JPRB /)

RGHG7(:,17,12) = (/ &
  & 0.50268854E-05_JPRB, 0.50881213E-05_JPRB, 0.51555248E-05_JPRB, 0.52411806E-05_JPRB, 0.53494432E-05_JPRB, 0.54822322E-05_JPRB, &
  & 0.56435347E-05_JPRB, 0.58407218E-05_JPRB, 0.60858174E-05_JPRB, 0.63514185E-05_JPRB, 0.66162465E-05_JPRB, 0.68763443E-05_JPRB, &
  & 0.71288805E-05_JPRB, 0.73683132E-05_JPRB, 0.76042083E-05_JPRB, 0.78253497E-05_JPRB, 0.80402042E-05_JPRB, 0.82558845E-05_JPRB, &
  & 0.84533485E-05_JPRB, 0.86301015E-05_JPRB, 0.87949911E-05_JPRB, 0.89463274E-05_JPRB, 0.90637814E-05_JPRB, 0.91418178E-05_JPRB, &
  & 0.91874126E-05_JPRB, 0.91969741E-05_JPRB, 0.91809125E-05_JPRB, 0.91216925E-05_JPRB, 0.90172061E-05_JPRB, 0.88886891E-05_JPRB, &
  & 0.87432772E-05_JPRB, 0.86044902E-05_JPRB, 0.84813282E-05_JPRB, 0.83649820E-05_JPRB, 0.82438537E-05_JPRB, 0.81208564E-05_JPRB, &
  & 0.80014570E-05_JPRB, 0.78807598E-05_JPRB, 0.77559380E-05_JPRB, 0.76135320E-05_JPRB, 0.74539980E-05_JPRB, 0.72832049E-05_JPRB, &
  & 0.71035292E-05_JPRB, 0.69209023E-05_JPRB, 0.67320480E-05_JPRB, 0.65352956E-05_JPRB, 0.63335447E-05_JPRB, 0.61252040E-05_JPRB, &
  & 0.59120252E-05_JPRB, 0.56970734E-05_JPRB, 0.54867287E-05_JPRB, 0.52837545E-05_JPRB, 0.50918748E-05_JPRB, 0.49271985E-05_JPRB, &
  & 0.48225911E-05_JPRB, 0.47672056E-05_JPRB, 0.47312210E-05_JPRB, 0.46985501E-05_JPRB, 0.46735991E-05_JPRB, 0.46518726E-05_JPRB, &
  & 0.46319101E-05_JPRB, 0.46152918E-05_JPRB, 0.45974884E-05_JPRB, 0.45622046E-05_JPRB /)

RGHG7(:,18,12) = (/ &
  & 0.49631444E-05_JPRB, 0.50259291E-05_JPRB, 0.50968019E-05_JPRB, 0.51881480E-05_JPRB, 0.53043968E-05_JPRB, 0.54478483E-05_JPRB, &
  & 0.56216913E-05_JPRB, 0.58351666E-05_JPRB, 0.60964016E-05_JPRB, 0.63809507E-05_JPRB, 0.66680527E-05_JPRB, 0.69512553E-05_JPRB, &
  & 0.72260559E-05_JPRB, 0.74868790E-05_JPRB, 0.77401473E-05_JPRB, 0.79740239E-05_JPRB, 0.81953322E-05_JPRB, 0.84109561E-05_JPRB, &
  & 0.86044147E-05_JPRB, 0.87725721E-05_JPRB, 0.89252035E-05_JPRB, 0.90615740E-05_JPRB, 0.91657694E-05_JPRB, 0.92319624E-05_JPRB, &
  & 0.92670944E-05_JPRB, 0.92698619E-05_JPRB, 0.92490036E-05_JPRB, 0.91928523E-05_JPRB, 0.91038683E-05_JPRB, 0.89976638E-05_JPRB, &
  & 0.88800216E-05_JPRB, 0.87666931E-05_JPRB, 0.86630780E-05_JPRB, 0.85477732E-05_JPRB, 0.84320645E-05_JPRB, 0.83106179E-05_JPRB, &
  & 0.81800254E-05_JPRB, 0.80410382E-05_JPRB, 0.78955518E-05_JPRB, 0.77356708E-05_JPRB, 0.75625626E-05_JPRB, 0.73830120E-05_JPRB, &
  & 0.71998602E-05_JPRB, 0.70180140E-05_JPRB, 0.68331174E-05_JPRB, 0.66435950E-05_JPRB, 0.64519354E-05_JPRB, 0.62562553E-05_JPRB, &
  & 0.60572306E-05_JPRB, 0.58559785E-05_JPRB, 0.56559102E-05_JPRB, 0.54587031E-05_JPRB, 0.52758096E-05_JPRB, 0.51283787E-05_JPRB, &
  & 0.50318044E-05_JPRB, 0.49730297E-05_JPRB, 0.49281448E-05_JPRB, 0.48896218E-05_JPRB, 0.48575926E-05_JPRB, 0.48301044E-05_JPRB, &
  & 0.48068518E-05_JPRB, 0.47878762E-05_JPRB, 0.47686049E-05_JPRB, 0.47325670E-05_JPRB /)

RGHG7(:,19,12) = (/ &
  & 0.49308433E-05_JPRB, 0.49900636E-05_JPRB, 0.50592862E-05_JPRB, 0.51492830E-05_JPRB, 0.52657160E-05_JPRB, 0.54102288E-05_JPRB, &
  & 0.55869345E-05_JPRB, 0.58021146E-05_JPRB, 0.60632733E-05_JPRB, 0.63476969E-05_JPRB, 0.66353255E-05_JPRB, 0.69183775E-05_JPRB, &
  & 0.71907716E-05_JPRB, 0.74466539E-05_JPRB, 0.76897677E-05_JPRB, 0.79100992E-05_JPRB, 0.81124244E-05_JPRB, 0.83034683E-05_JPRB, &
  & 0.84752155E-05_JPRB, 0.86263844E-05_JPRB, 0.87652979E-05_JPRB, 0.88959432E-05_JPRB, 0.90046824E-05_JPRB, 0.90841404E-05_JPRB, &
  & 0.91368684E-05_JPRB, 0.91610964E-05_JPRB, 0.91624970E-05_JPRB, 0.91276725E-05_JPRB, 0.90655858E-05_JPRB, 0.89785553E-05_JPRB, &
  & 0.88886827E-05_JPRB, 0.87930512E-05_JPRB, 0.87012659E-05_JPRB, 0.85960237E-05_JPRB, 0.84784824E-05_JPRB, 0.83491377E-05_JPRB, &
  & 0.82077131E-05_JPRB, 0.80557520E-05_JPRB, 0.78990406E-05_JPRB, 0.77303084E-05_JPRB, 0.75594517E-05_JPRB, 0.73860469E-05_JPRB, &
  & 0.72153057E-05_JPRB, 0.70470792E-05_JPRB, 0.68780923E-05_JPRB, 0.67065566E-05_JPRB, 0.65345375E-05_JPRB, 0.63587286E-05_JPRB, &
  & 0.61778032E-05_JPRB, 0.59914182E-05_JPRB, 0.58030200E-05_JPRB, 0.56213094E-05_JPRB, 0.54579082E-05_JPRB, 0.53357853E-05_JPRB, &
  & 0.52525843E-05_JPRB, 0.51938468E-05_JPRB, 0.51452557E-05_JPRB, 0.51028346E-05_JPRB, 0.50657891E-05_JPRB, 0.50343906E-05_JPRB, &
  & 0.50074655E-05_JPRB, 0.49866344E-05_JPRB, 0.49629602E-05_JPRB, 0.49231262E-05_JPRB /)

RGHG7(:,20,12) = (/ &
  & 0.49185360E-05_JPRB, 0.49754367E-05_JPRB, 0.50407234E-05_JPRB, 0.51252791E-05_JPRB, 0.52345426E-05_JPRB, 0.53710319E-05_JPRB, &
  & 0.55365313E-05_JPRB, 0.57383140E-05_JPRB, 0.59792860E-05_JPRB, 0.62392082E-05_JPRB, 0.65002941E-05_JPRB, 0.67532660E-05_JPRB, &
  & 0.69924049E-05_JPRB, 0.72129965E-05_JPRB, 0.74183845E-05_JPRB, 0.76019433E-05_JPRB, 0.77688865E-05_JPRB, 0.79250885E-05_JPRB, &
  & 0.80675936E-05_JPRB, 0.82025199E-05_JPRB, 0.83364757E-05_JPRB, 0.84738458E-05_JPRB, 0.86034352E-05_JPRB, 0.87169101E-05_JPRB, &
  & 0.88109382E-05_JPRB, 0.88772958E-05_JPRB, 0.89165296E-05_JPRB, 0.89186633E-05_JPRB, 0.88811676E-05_JPRB, 0.88240413E-05_JPRB, &
  & 0.87424351E-05_JPRB, 0.86519140E-05_JPRB, 0.85538622E-05_JPRB, 0.84374906E-05_JPRB, 0.83065515E-05_JPRB, 0.81643475E-05_JPRB, &
  & 0.80082009E-05_JPRB, 0.78494477E-05_JPRB, 0.76923525E-05_JPRB, 0.75374815E-05_JPRB, 0.73839501E-05_JPRB, 0.72369749E-05_JPRB, &
  & 0.70965339E-05_JPRB, 0.69574694E-05_JPRB, 0.68198838E-05_JPRB, 0.66770281E-05_JPRB, 0.65320623E-05_JPRB, 0.63805437E-05_JPRB, &
  & 0.62210656E-05_JPRB, 0.60536145E-05_JPRB, 0.58853789E-05_JPRB, 0.57256466E-05_JPRB, 0.55943119E-05_JPRB, 0.54957750E-05_JPRB, &
  & 0.54249276E-05_JPRB, 0.53717149E-05_JPRB, 0.53272256E-05_JPRB, 0.52869109E-05_JPRB, 0.52507621E-05_JPRB, 0.52193709E-05_JPRB, &
  & 0.51933794E-05_JPRB, 0.51703200E-05_JPRB, 0.51502816E-05_JPRB, 0.51069846E-05_JPRB /)

RGHG7(:,21,12) = (/ &
  & 0.48916090E-05_JPRB, 0.49417677E-05_JPRB, 0.49980581E-05_JPRB, 0.50715448E-05_JPRB, 0.51669190E-05_JPRB, 0.52856435E-05_JPRB, &
  & 0.54299207E-05_JPRB, 0.56027334E-05_JPRB, 0.58067976E-05_JPRB, 0.60245766E-05_JPRB, 0.62395388E-05_JPRB, 0.64443193E-05_JPRB, &
  & 0.66329226E-05_JPRB, 0.68028744E-05_JPRB, 0.69576927E-05_JPRB, 0.70943297E-05_JPRB, 0.72199214E-05_JPRB, 0.73427459E-05_JPRB, &
  & 0.74612522E-05_JPRB, 0.75835082E-05_JPRB, 0.77172599E-05_JPRB, 0.78660678E-05_JPRB, 0.80184427E-05_JPRB, 0.81656990E-05_JPRB, &
  & 0.82985052E-05_JPRB, 0.84052490E-05_JPRB, 0.84784824E-05_JPRB, 0.85012025E-05_JPRB, 0.84842113E-05_JPRB, 0.84231733E-05_JPRB, &
  & 0.83376390E-05_JPRB, 0.82319384E-05_JPRB, 0.81151220E-05_JPRB, 0.79829770E-05_JPRB, 0.78423654E-05_JPRB, 0.76960969E-05_JPRB, &
  & 0.75441990E-05_JPRB, 0.73971069E-05_JPRB, 0.72563612E-05_JPRB, 0.71275854E-05_JPRB, 0.70097913E-05_JPRB, 0.69048419E-05_JPRB, &
  & 0.68052004E-05_JPRB, 0.67101514E-05_JPRB, 0.66090356E-05_JPRB, 0.65082395E-05_JPRB, 0.63980788E-05_JPRB, 0.62783770E-05_JPRB, &
  & 0.61501009E-05_JPRB, 0.60142652E-05_JPRB, 0.58799046E-05_JPRB, 0.57587822E-05_JPRB, 0.56620670E-05_JPRB, 0.55907708E-05_JPRB, &
  & 0.55374526E-05_JPRB, 0.54958359E-05_JPRB, 0.54589500E-05_JPRB, 0.54244260E-05_JPRB, 0.53929962E-05_JPRB, 0.53655267E-05_JPRB, &
  & 0.53420954E-05_JPRB, 0.53237995E-05_JPRB, 0.53032213E-05_JPRB, 0.52705823E-05_JPRB /)

RGHG7(:,22,12) = (/ &
  & 0.48334218E-05_JPRB, 0.48725501E-05_JPRB, 0.49176706E-05_JPRB, 0.49768428E-05_JPRB, 0.50535577E-05_JPRB, 0.51491306E-05_JPRB, &
  & 0.52636046E-05_JPRB, 0.53991434E-05_JPRB, 0.55554633E-05_JPRB, 0.57185098E-05_JPRB, 0.58760652E-05_JPRB, 0.60221782E-05_JPRB, &
  & 0.61532141E-05_JPRB, 0.62696972E-05_JPRB, 0.63766065E-05_JPRB, 0.64734299E-05_JPRB, 0.65659679E-05_JPRB, 0.66607072E-05_JPRB, &
  & 0.67585879E-05_JPRB, 0.68676504E-05_JPRB, 0.69941980E-05_JPRB, 0.71414438E-05_JPRB, 0.72985213E-05_JPRB, 0.74614063E-05_JPRB, &
  & 0.76113488E-05_JPRB, 0.77384075E-05_JPRB, 0.78256971E-05_JPRB, 0.78630246E-05_JPRB, 0.78377407E-05_JPRB, 0.77708501E-05_JPRB, &
  & 0.76681190E-05_JPRB, 0.75419662E-05_JPRB, 0.74078289E-05_JPRB, 0.72724206E-05_JPRB, 0.71352747E-05_JPRB, 0.70007604E-05_JPRB, &
  & 0.68683503E-05_JPRB, 0.67475653E-05_JPRB, 0.66387770E-05_JPRB, 0.65501858E-05_JPRB, 0.64719984E-05_JPRB, 0.64079322E-05_JPRB, &
  & 0.63558809E-05_JPRB, 0.63049920E-05_JPRB, 0.62517415E-05_JPRB, 0.61900214E-05_JPRB, 0.61206310E-05_JPRB, 0.60377524E-05_JPRB, &
  & 0.59477834E-05_JPRB, 0.58518590E-05_JPRB, 0.57587281E-05_JPRB, 0.56812423E-05_JPRB, 0.56217273E-05_JPRB, 0.55783958E-05_JPRB, &
  & 0.55472710E-05_JPRB, 0.55237806E-05_JPRB, 0.55020946E-05_JPRB, 0.54805923E-05_JPRB, 0.54598145E-05_JPRB, 0.54406446E-05_JPRB, &
  & 0.54235970E-05_JPRB, 0.54087568E-05_JPRB, 0.53943863E-05_JPRB, 0.53731933E-05_JPRB /)

RGHG7(:,23,12) = (/ &
  & 0.47087938E-05_JPRB, 0.47242256E-05_JPRB, 0.47533499E-05_JPRB, 0.47941048E-05_JPRB, 0.48481957E-05_JPRB, 0.49157884E-05_JPRB, &
  & 0.49970008E-05_JPRB, 0.50919953E-05_JPRB, 0.52000992E-05_JPRB, 0.53112908E-05_JPRB, 0.54160651E-05_JPRB, 0.55118840E-05_JPRB, &
  & 0.55969967E-05_JPRB, 0.56717936E-05_JPRB, 0.57422581E-05_JPRB, 0.58094033E-05_JPRB, 0.58782789E-05_JPRB, 0.59530630E-05_JPRB, &
  & 0.60326684E-05_JPRB, 0.61211808E-05_JPRB, 0.62239187E-05_JPRB, 0.63436987E-05_JPRB, 0.64765127E-05_JPRB, 0.66146749E-05_JPRB, &
  & 0.67471906E-05_JPRB, 0.68620407E-05_JPRB, 0.69442040E-05_JPRB, 0.69717603E-05_JPRB, 0.69466355E-05_JPRB, 0.68754612E-05_JPRB, &
  & 0.67687211E-05_JPRB, 0.66429056E-05_JPRB, 0.65219028E-05_JPRB, 0.64010806E-05_JPRB, 0.62859231E-05_JPRB, 0.61793785E-05_JPRB, &
  & 0.60805387E-05_JPRB, 0.59934723E-05_JPRB, 0.59180852E-05_JPRB, 0.58630744E-05_JPRB, 0.58250816E-05_JPRB, 0.58008804E-05_JPRB, &
  & 0.57901134E-05_JPRB, 0.57796365E-05_JPRB, 0.57710067E-05_JPRB, 0.57501798E-05_JPRB, 0.57216384E-05_JPRB, 0.56787121E-05_JPRB, &
  & 0.56279973E-05_JPRB, 0.55737974E-05_JPRB, 0.55243700E-05_JPRB, 0.54865104E-05_JPRB, 0.54612765E-05_JPRB, 0.54463312E-05_JPRB, &
  & 0.54399361E-05_JPRB, 0.54382758E-05_JPRB, 0.54361035E-05_JPRB, 0.54317429E-05_JPRB, 0.54253010E-05_JPRB, 0.54181810E-05_JPRB, &
  & 0.54112038E-05_JPRB, 0.54044549E-05_JPRB, 0.54015036E-05_JPRB, 0.53953395E-05_JPRB /)

RGHG7(:,24,12) = (/ &
  & 0.44863068E-05_JPRB, 0.44749436E-05_JPRB, 0.44872763E-05_JPRB, 0.45103179E-05_JPRB, 0.45437819E-05_JPRB, 0.45871334E-05_JPRB, &
  & 0.46395558E-05_JPRB, 0.47009939E-05_JPRB, 0.47706612E-05_JPRB, 0.48410830E-05_JPRB, 0.49067958E-05_JPRB, 0.49664891E-05_JPRB, &
  & 0.50212152E-05_JPRB, 0.50715839E-05_JPRB, 0.51211541E-05_JPRB, 0.51707830E-05_JPRB, 0.52230926E-05_JPRB, 0.52780438E-05_JPRB, &
  & 0.53323583E-05_JPRB, 0.53883155E-05_JPRB, 0.54511956E-05_JPRB, 0.55231503E-05_JPRB, 0.56008735E-05_JPRB, 0.56832687E-05_JPRB, &
  & 0.57672901E-05_JPRB, 0.58408641E-05_JPRB, 0.58973606E-05_JPRB, 0.59184326E-05_JPRB, 0.58974765E-05_JPRB, 0.58428836E-05_JPRB, &
  & 0.57607185E-05_JPRB, 0.56720619E-05_JPRB, 0.55808155E-05_JPRB, 0.54946318E-05_JPRB, 0.54132652E-05_JPRB, 0.53412919E-05_JPRB, &
  & 0.52777118E-05_JPRB, 0.52221540E-05_JPRB, 0.51819725E-05_JPRB, 0.51564184E-05_JPRB, 0.51440434E-05_JPRB, 0.51509924E-05_JPRB, &
  & 0.51666771E-05_JPRB, 0.51902252E-05_JPRB, 0.52113901E-05_JPRB, 0.52284986E-05_JPRB, 0.52359237E-05_JPRB, 0.52346054E-05_JPRB, &
  & 0.52222281E-05_JPRB, 0.52082337E-05_JPRB, 0.51983038E-05_JPRB, 0.51953534E-05_JPRB, 0.52004571E-05_JPRB, 0.52123273E-05_JPRB, &
  & 0.52298233E-05_JPRB, 0.52491196E-05_JPRB, 0.52663913E-05_JPRB, 0.52801743E-05_JPRB, 0.52902428E-05_JPRB, 0.52971236E-05_JPRB, &
  & 0.53018184E-05_JPRB, 0.53076028E-05_JPRB, 0.53134813E-05_JPRB, 0.53351937E-05_JPRB /)

RGHG7(:,25,12) = (/ &
  & 0.41682524E-05_JPRB, 0.41290978E-05_JPRB, 0.41251205E-05_JPRB, 0.41338176E-05_JPRB, 0.41518656E-05_JPRB, 0.41776666E-05_JPRB, &
  & 0.42101888E-05_JPRB, 0.42487527E-05_JPRB, 0.42928555E-05_JPRB, 0.43375517E-05_JPRB, 0.43794462E-05_JPRB, 0.44179278E-05_JPRB, &
  & 0.44551011E-05_JPRB, 0.44924527E-05_JPRB, 0.45310780E-05_JPRB, 0.45700717E-05_JPRB, 0.46078871E-05_JPRB, 0.46431046E-05_JPRB, &
  & 0.46737177E-05_JPRB, 0.46975611E-05_JPRB, 0.47149110E-05_JPRB, 0.47278359E-05_JPRB, 0.47392414E-05_JPRB, 0.47552790E-05_JPRB, &
  & 0.47782196E-05_JPRB, 0.48050174E-05_JPRB, 0.48273855E-05_JPRB, 0.48367415E-05_JPRB, 0.48313213E-05_JPRB, 0.48082720E-05_JPRB, &
  & 0.47719641E-05_JPRB, 0.47267285E-05_JPRB, 0.46808609E-05_JPRB, 0.46361793E-05_JPRB, 0.45920283E-05_JPRB, 0.45514416E-05_JPRB, &
  & 0.45184911E-05_JPRB, 0.44919134E-05_JPRB, 0.44744220E-05_JPRB, 0.44718718E-05_JPRB, 0.44818125E-05_JPRB, 0.45063925E-05_JPRB, &
  & 0.45405914E-05_JPRB, 0.45846859E-05_JPRB, 0.46296332E-05_JPRB, 0.46750615E-05_JPRB, 0.47129361E-05_JPRB, 0.47442954E-05_JPRB, &
  & 0.47690646E-05_JPRB, 0.47907033E-05_JPRB, 0.48135839E-05_JPRB, 0.48382958E-05_JPRB, 0.48681741E-05_JPRB, 0.49020223E-05_JPRB, &
  & 0.49392652E-05_JPRB, 0.49768582E-05_JPRB, 0.50119943E-05_JPRB, 0.50430322E-05_JPRB, 0.50694475E-05_JPRB, 0.50912695E-05_JPRB, &
  & 0.51097086E-05_JPRB, 0.51261709E-05_JPRB, 0.51485740E-05_JPRB, 0.51943844E-05_JPRB /)

RGHG7(:,26,12) = (/ &
  & 0.37586194E-05_JPRB, 0.36993438E-05_JPRB, 0.36853728E-05_JPRB, 0.36861197E-05_JPRB, 0.36962106E-05_JPRB, 0.37134787E-05_JPRB, &
  & 0.37365062E-05_JPRB, 0.37644254E-05_JPRB, 0.37967641E-05_JPRB, 0.38302928E-05_JPRB, 0.38626922E-05_JPRB, 0.38938383E-05_JPRB, &
  & 0.39240440E-05_JPRB, 0.39551965E-05_JPRB, 0.39880401E-05_JPRB, 0.40195682E-05_JPRB, 0.40501800E-05_JPRB, 0.40745613E-05_JPRB, &
  & 0.40838540E-05_JPRB, 0.40739124E-05_JPRB, 0.40463733E-05_JPRB, 0.40057948E-05_JPRB, 0.39586293E-05_JPRB, 0.39152978E-05_JPRB, &
  & 0.38820708E-05_JPRB, 0.38637459E-05_JPRB, 0.38586327E-05_JPRB, 0.38614871E-05_JPRB, 0.38687176E-05_JPRB, 0.38742837E-05_JPRB, &
  & 0.38765388E-05_JPRB, 0.38757576E-05_JPRB, 0.38743210E-05_JPRB, 0.38680910E-05_JPRB, 0.38580720E-05_JPRB, 0.38456733E-05_JPRB, &
  & 0.38359781E-05_JPRB, 0.38307180E-05_JPRB, 0.38310718E-05_JPRB, 0.38413154E-05_JPRB, 0.38645680E-05_JPRB, 0.38998305E-05_JPRB, &
  & 0.39462757E-05_JPRB, 0.40035334E-05_JPRB, 0.40667228E-05_JPRB, 0.41325629E-05_JPRB, 0.41949984E-05_JPRB, 0.42511679E-05_JPRB, &
  & 0.43024511E-05_JPRB, 0.43504060E-05_JPRB, 0.43987438E-05_JPRB, 0.44461258E-05_JPRB, 0.44947974E-05_JPRB, 0.45452921E-05_JPRB, &
  & 0.45976321E-05_JPRB, 0.46498035E-05_JPRB, 0.46990644E-05_JPRB, 0.47443732E-05_JPRB, 0.47845028E-05_JPRB, 0.48196453E-05_JPRB, &
  & 0.48505576E-05_JPRB, 0.48802776E-05_JPRB, 0.49165583E-05_JPRB, 0.49891537E-05_JPRB /)

RGHG7(:,27,12) = (/ &
  & 0.32858541E-05_JPRB, 0.32197108E-05_JPRB, 0.32024816E-05_JPRB, 0.32012128E-05_JPRB, 0.32101018E-05_JPRB, 0.32264936E-05_JPRB, &
  & 0.32488410E-05_JPRB, 0.32759187E-05_JPRB, 0.33070228E-05_JPRB, 0.33397507E-05_JPRB, 0.33728177E-05_JPRB, 0.34059981E-05_JPRB, &
  & 0.34397392E-05_JPRB, 0.34728689E-05_JPRB, 0.35067137E-05_JPRB, 0.35375870E-05_JPRB, 0.35604789E-05_JPRB, 0.35684120E-05_JPRB, &
  & 0.35556282E-05_JPRB, 0.35190642E-05_JPRB, 0.34597906E-05_JPRB, 0.33823530E-05_JPRB, 0.32948190E-05_JPRB, 0.32098933E-05_JPRB, &
  & 0.31363650E-05_JPRB, 0.30842668E-05_JPRB, 0.30537938E-05_JPRB, 0.30473554E-05_JPRB, 0.30583744E-05_JPRB, 0.30832832E-05_JPRB, &
  & 0.31132820E-05_JPRB, 0.31465649E-05_JPRB, 0.31789693E-05_JPRB, 0.32028217E-05_JPRB, 0.32195912E-05_JPRB, 0.32294383E-05_JPRB, &
  & 0.32366595E-05_JPRB, 0.32468386E-05_JPRB, 0.32592941E-05_JPRB, 0.32775270E-05_JPRB, 0.33074680E-05_JPRB, 0.33483345E-05_JPRB, &
  & 0.34015552E-05_JPRB, 0.34666791E-05_JPRB, 0.35409446E-05_JPRB, 0.36202089E-05_JPRB, 0.36994115E-05_JPRB, 0.37754239E-05_JPRB, &
  & 0.38490348E-05_JPRB, 0.39180818E-05_JPRB, 0.39835390E-05_JPRB, 0.40466957E-05_JPRB, 0.41095591E-05_JPRB, 0.41719459E-05_JPRB, &
  & 0.42344263E-05_JPRB, 0.42958254E-05_JPRB, 0.43543432E-05_JPRB, 0.44090689E-05_JPRB, 0.44593326E-05_JPRB, 0.45044380E-05_JPRB, &
  & 0.45452625E-05_JPRB, 0.45855018E-05_JPRB, 0.46320997E-05_JPRB, 0.47306748E-05_JPRB /)

RGHG7(:,28,12) = (/ &
  & 0.27908441E-05_JPRB, 0.27266956E-05_JPRB, 0.27126312E-05_JPRB, 0.27149704E-05_JPRB, 0.27277956E-05_JPRB, 0.27487447E-05_JPRB, &
  & 0.27760636E-05_JPRB, 0.28082084E-05_JPRB, 0.28441018E-05_JPRB, 0.28816291E-05_JPRB, 0.29197161E-05_JPRB, 0.29573982E-05_JPRB, &
  & 0.29955404E-05_JPRB, 0.30320418E-05_JPRB, 0.30653093E-05_JPRB, 0.30919414E-05_JPRB, 0.31072409E-05_JPRB, 0.31061031E-05_JPRB, &
  & 0.30821054E-05_JPRB, 0.30317281E-05_JPRB, 0.29561711E-05_JPRB, 0.28597551E-05_JPRB, 0.27513051E-05_JPRB, 0.26430523E-05_JPRB, &
  & 0.25465963E-05_JPRB, 0.24719541E-05_JPRB, 0.24230769E-05_JPRB, 0.24047506E-05_JPRB, 0.24117999E-05_JPRB, 0.24428057E-05_JPRB, &
  & 0.24860815E-05_JPRB, 0.25383738E-05_JPRB, 0.25919808E-05_JPRB, 0.26360924E-05_JPRB, 0.26713617E-05_JPRB, 0.26970638E-05_JPRB, &
  & 0.27163962E-05_JPRB, 0.27356703E-05_JPRB, 0.27560964E-05_JPRB, 0.27796355E-05_JPRB, 0.28126715E-05_JPRB, 0.28561299E-05_JPRB, &
  & 0.29120517E-05_JPRB, 0.29810678E-05_JPRB, 0.30613421E-05_JPRB, 0.31492750E-05_JPRB, 0.32410373E-05_JPRB, 0.33323363E-05_JPRB, &
  & 0.34205623E-05_JPRB, 0.35043117E-05_JPRB, 0.35835189E-05_JPRB, 0.36583099E-05_JPRB, 0.37302648E-05_JPRB, 0.38002440E-05_JPRB, &
  & 0.38691096E-05_JPRB, 0.39359902E-05_JPRB, 0.39996767E-05_JPRB, 0.40600157E-05_JPRB, 0.41159342E-05_JPRB, 0.41672970E-05_JPRB, &
  & 0.42144834E-05_JPRB, 0.42604925E-05_JPRB, 0.43171599E-05_JPRB, 0.44270937E-05_JPRB /)

RGHG7(:,29,12) = (/ &
  & 0.23176069E-05_JPRB, 0.22658733E-05_JPRB, 0.22588144E-05_JPRB, 0.22669105E-05_JPRB, 0.22856561E-05_JPRB, 0.23127313E-05_JPRB, &
  & 0.23467560E-05_JPRB, 0.23856562E-05_JPRB, 0.24278640E-05_JPRB, 0.24713006E-05_JPRB, 0.25150707E-05_JPRB, 0.25576032E-05_JPRB, &
  & 0.25983818E-05_JPRB, 0.26360187E-05_JPRB, 0.26689850E-05_JPRB, 0.26938114E-05_JPRB, 0.27061824E-05_JPRB, 0.27001443E-05_JPRB, &
  & 0.26696753E-05_JPRB, 0.26123053E-05_JPRB, 0.25293054E-05_JPRB, 0.24263322E-05_JPRB, 0.23110467E-05_JPRB, 0.21943129E-05_JPRB, &
  & 0.20874324E-05_JPRB, 0.19998713E-05_JPRB, 0.19387605E-05_JPRB, 0.19078764E-05_JPRB, 0.19064663E-05_JPRB, 0.19336480E-05_JPRB, &
  & 0.19789225E-05_JPRB, 0.20372804E-05_JPRB, 0.21008864E-05_JPRB, 0.21566384E-05_JPRB, 0.22032000E-05_JPRB, 0.22392114E-05_JPRB, &
  & 0.22670567E-05_JPRB, 0.22919028E-05_JPRB, 0.23167872E-05_JPRB, 0.23436191E-05_JPRB, 0.23782243E-05_JPRB, 0.24227534E-05_JPRB, &
  & 0.24797710E-05_JPRB, 0.25505749E-05_JPRB, 0.26343901E-05_JPRB, 0.27286412E-05_JPRB, 0.28293132E-05_JPRB, 0.29305768E-05_JPRB, &
  & 0.30288245E-05_JPRB, 0.31215689E-05_JPRB, 0.32083829E-05_JPRB, 0.32901742E-05_JPRB, 0.33679637E-05_JPRB, 0.34428845E-05_JPRB, &
  & 0.35151199E-05_JPRB, 0.35848896E-05_JPRB, 0.36513993E-05_JPRB, 0.37145094E-05_JPRB, 0.37736372E-05_JPRB, 0.38278890E-05_JPRB, &
  & 0.38780890E-05_JPRB, 0.39275383E-05_JPRB, 0.39855004E-05_JPRB, 0.41034014E-05_JPRB /)

RGHG7(:,30,12) = (/ &
  & 0.19072060E-05_JPRB, 0.18711096E-05_JPRB, 0.18711069E-05_JPRB, 0.18847279E-05_JPRB, 0.19082015E-05_JPRB, 0.19403446E-05_JPRB, &
  & 0.19793063E-05_JPRB, 0.20229775E-05_JPRB, 0.20694617E-05_JPRB, 0.21168569E-05_JPRB, 0.21639478E-05_JPRB, 0.22091349E-05_JPRB, &
  & 0.22515596E-05_JPRB, 0.22892516E-05_JPRB, 0.23201667E-05_JPRB, 0.23408688E-05_JPRB, 0.23477305E-05_JPRB, 0.23367268E-05_JPRB, &
  & 0.23033654E-05_JPRB, 0.22458869E-05_JPRB, 0.21638627E-05_JPRB, 0.20629029E-05_JPRB, 0.19499671E-05_JPRB, 0.18342710E-05_JPRB, &
  & 0.17256433E-05_JPRB, 0.16331688E-05_JPRB, 0.15642034E-05_JPRB, 0.15227733E-05_JPRB, 0.15111440E-05_JPRB, 0.15293473E-05_JPRB, &
  & 0.15692807E-05_JPRB, 0.16251514E-05_JPRB, 0.16902278E-05_JPRB, 0.17508676E-05_JPRB, 0.18030353E-05_JPRB, 0.18454051E-05_JPRB, &
  & 0.18792445E-05_JPRB, 0.19080792E-05_JPRB, 0.19353786E-05_JPRB, 0.19640258E-05_JPRB, 0.19994291E-05_JPRB, 0.20445248E-05_JPRB, &
  & 0.21021515E-05_JPRB, 0.21740118E-05_JPRB, 0.22599077E-05_JPRB, 0.23576781E-05_JPRB, 0.24624321E-05_JPRB, 0.25690315E-05_JPRB, &
  & 0.26727744E-05_JPRB, 0.27710837E-05_JPRB, 0.28623865E-05_JPRB, 0.29479363E-05_JPRB, 0.30289423E-05_JPRB, 0.31066495E-05_JPRB, &
  & 0.31810898E-05_JPRB, 0.32524304E-05_JPRB, 0.33205231E-05_JPRB, 0.33853414E-05_JPRB, 0.34458044E-05_JPRB, 0.35013027E-05_JPRB, &
  & 0.35520654E-05_JPRB, 0.36019183E-05_JPRB, 0.36609708E-05_JPRB, 0.37784732E-05_JPRB /)

RGHG7(:,31,12) = (/ &
  & 0.15773915E-05_JPRB, 0.15557639E-05_JPRB, 0.15616210E-05_JPRB, 0.15787099E-05_JPRB, 0.16048874E-05_JPRB, 0.16388659E-05_JPRB, &
  & 0.16795316E-05_JPRB, 0.17244594E-05_JPRB, 0.17715992E-05_JPRB, 0.18191059E-05_JPRB, 0.18656837E-05_JPRB, 0.19099070E-05_JPRB, &
  & 0.19504589E-05_JPRB, 0.19852148E-05_JPRB, 0.20124958E-05_JPRB, 0.20288126E-05_JPRB, 0.20310649E-05_JPRB, 0.20163086E-05_JPRB, &
  & 0.19807603E-05_JPRB, 0.19242282E-05_JPRB, 0.18469833E-05_JPRB, 0.17527351E-05_JPRB, 0.16469385E-05_JPRB, 0.15371420E-05_JPRB, &
  & 0.14325069E-05_JPRB, 0.13407995E-05_JPRB, 0.12680671E-05_JPRB, 0.12190509E-05_JPRB, 0.11977033E-05_JPRB, 0.12052269E-05_JPRB, &
  & 0.12361488E-05_JPRB, 0.12847152E-05_JPRB, 0.13455189E-05_JPRB, 0.14059385E-05_JPRB, 0.14595080E-05_JPRB, 0.15051639E-05_JPRB, &
  & 0.15428451E-05_JPRB, 0.15744956E-05_JPRB, 0.16034638E-05_JPRB, 0.16337387E-05_JPRB, 0.16701302E-05_JPRB, 0.17160083E-05_JPRB, &
  & 0.17744437E-05_JPRB, 0.18470483E-05_JPRB, 0.19339584E-05_JPRB, 0.20328089E-05_JPRB, 0.21391600E-05_JPRB, 0.22474526E-05_JPRB, &
  & 0.23529612E-05_JPRB, 0.24526480E-05_JPRB, 0.25460276E-05_JPRB, 0.26339019E-05_JPRB, 0.27169108E-05_JPRB, 0.27958761E-05_JPRB, &
  & 0.28709387E-05_JPRB, 0.29433670E-05_JPRB, 0.30127176E-05_JPRB, 0.30784684E-05_JPRB, 0.31396085E-05_JPRB, 0.31950033E-05_JPRB, &
  & 0.32456874E-05_JPRB, 0.32946039E-05_JPRB, 0.33526501E-05_JPRB, 0.34661841E-05_JPRB /)

RGHG7(:,32,12) = (/ &
  & 0.13225149E-05_JPRB, 0.13127066E-05_JPRB, 0.13226148E-05_JPRB, 0.13416299E-05_JPRB, 0.13684036E-05_JPRB, 0.14021848E-05_JPRB, &
  & 0.14418812E-05_JPRB, 0.14850472E-05_JPRB, 0.15297313E-05_JPRB, 0.15741539E-05_JPRB, 0.16167210E-05_JPRB, 0.16569611E-05_JPRB, &
  & 0.16929762E-05_JPRB, 0.17226353E-05_JPRB, 0.17441690E-05_JPRB, 0.17550410E-05_JPRB, 0.17522913E-05_JPRB, 0.17337129E-05_JPRB, &
  & 0.16965453E-05_JPRB, 0.16416589E-05_JPRB, 0.15694069E-05_JPRB, 0.14826845E-05_JPRB, 0.13857954E-05_JPRB, 0.12853825E-05_JPRB, &
  & 0.11877605E-05_JPRB, 0.10996870E-05_JPRB, 0.10267814E-05_JPRB, 0.97346197E-06_JPRB, 0.94441020E-06_JPRB, 0.94157213E-06_JPRB, &
  & 0.96218639E-06_JPRB, 0.10011669E-05_JPRB, 0.10542378E-05_JPRB, 0.11105293E-05_JPRB, 0.11625931E-05_JPRB, 0.12092090E-05_JPRB, &
  & 0.12486522E-05_JPRB, 0.12818881E-05_JPRB, 0.13125858E-05_JPRB, 0.13449909E-05_JPRB, 0.13830515E-05_JPRB, 0.14306678E-05_JPRB, &
  & 0.14904463E-05_JPRB, 0.15641082E-05_JPRB, 0.16515014E-05_JPRB, 0.17499315E-05_JPRB, 0.18553579E-05_JPRB, 0.19633210E-05_JPRB, &
  & 0.20682287E-05_JPRB, 0.21680751E-05_JPRB, 0.22611453E-05_JPRB, 0.23483442E-05_JPRB, 0.24311175E-05_JPRB, 0.25100628E-05_JPRB, &
  & 0.25863271E-05_JPRB, 0.26595085E-05_JPRB, 0.27294670E-05_JPRB, 0.27956257E-05_JPRB, 0.28567335E-05_JPRB, 0.29119105E-05_JPRB, &
  & 0.29614928E-05_JPRB, 0.30098786E-05_JPRB, 0.30655763E-05_JPRB, 0.31766215E-05_JPRB /)

RGHG7(:,33,12) = (/ &
  & 0.11303885E-05_JPRB, 0.11287565E-05_JPRB, 0.11409762E-05_JPRB, 0.11602457E-05_JPRB, 0.11864902E-05_JPRB, 0.12185454E-05_JPRB, &
  & 0.12556435E-05_JPRB, 0.12953310E-05_JPRB, 0.13354298E-05_JPRB, 0.13745238E-05_JPRB, 0.14110931E-05_JPRB, 0.14451954E-05_JPRB, &
  & 0.14748293E-05_JPRB, 0.14982485E-05_JPRB, 0.15133970E-05_JPRB, 0.15176041E-05_JPRB, 0.15085353E-05_JPRB, 0.14851271E-05_JPRB, &
  & 0.14463888E-05_JPRB, 0.13925707E-05_JPRB, 0.13244240E-05_JPRB, 0.12448552E-05_JPRB, 0.11568497E-05_JPRB, 0.10653149E-05_JPRB, &
  & 0.97622353E-06_JPRB, 0.89458302E-06_JPRB, 0.82446041E-06_JPRB, 0.77004927E-06_JPRB, 0.73561847E-06_JPRB, 0.72421386E-06_JPRB, &
  & 0.73468664E-06_JPRB, 0.76338057E-06_JPRB, 0.80673584E-06_JPRB, 0.85624208E-06_JPRB, 0.90459571E-06_JPRB, 0.95007533E-06_JPRB, &
  & 0.98928660E-06_JPRB, 0.10233185E-05_JPRB, 0.10560065E-05_JPRB, 0.10906365E-05_JPRB, 0.11313111E-05_JPRB, 0.11815800E-05_JPRB, &
  & 0.12435584E-05_JPRB, 0.13188456E-05_JPRB, 0.14065304E-05_JPRB, 0.15037555E-05_JPRB, 0.16077080E-05_JPRB, 0.17128745E-05_JPRB, &
  & 0.18153125E-05_JPRB, 0.19115685E-05_JPRB, 0.20027628E-05_JPRB, 0.20895081E-05_JPRB, 0.21721034E-05_JPRB, 0.22511144E-05_JPRB, &
  & 0.23268699E-05_JPRB, 0.23998646E-05_JPRB, 0.24698822E-05_JPRB, 0.25361212E-05_JPRB, 0.25971256E-05_JPRB, 0.26515872E-05_JPRB, &
  & 0.27008086E-05_JPRB, 0.27475940E-05_JPRB, 0.28028721E-05_JPRB, 0.29087723E-05_JPRB /)

RGHG7(:,34,12) = (/ &
  & 0.98700434E-06_JPRB, 0.99089903E-06_JPRB, 0.10036933E-05_JPRB, 0.10220162E-05_JPRB, 0.10464915E-05_JPRB, 0.10759783E-05_JPRB, &
  & 0.11095093E-05_JPRB, 0.11446289E-05_JPRB, 0.11792213E-05_JPRB, 0.12118275E-05_JPRB, 0.12415709E-05_JPRB, 0.12684549E-05_JPRB, &
  & 0.12908795E-05_JPRB, 0.13075464E-05_JPRB, 0.13158880E-05_JPRB, 0.13136346E-05_JPRB, 0.12992681E-05_JPRB, 0.12708615E-05_JPRB, &
  & 0.12285926E-05_JPRB, 0.11737676E-05_JPRB, 0.11083279E-05_JPRB, 0.10341245E-05_JPRB, 0.95337481E-06_JPRB, 0.87033561E-06_JPRB, &
  & 0.78982538E-06_JPRB, 0.71575113E-06_JPRB, 0.65089449E-06_JPRB, 0.59821292E-06_JPRB, 0.56155693E-06_JPRB, 0.54383185E-06_JPRB, &
  & 0.54559018E-06_JPRB, 0.56415610E-06_JPRB, 0.59680519E-06_JPRB, 0.63768789E-06_JPRB, 0.68033972E-06_JPRB, 0.72203119E-06_JPRB, &
  & 0.75950481E-06_JPRB, 0.79389730E-06_JPRB, 0.82798005E-06_JPRB, 0.86498227E-06_JPRB, 0.90886255E-06_JPRB, 0.96243718E-06_JPRB, &
  & 0.10278380E-05_JPRB, 0.11053119E-05_JPRB, 0.11936602E-05_JPRB, 0.12901969E-05_JPRB, 0.13912880E-05_JPRB, 0.14929565E-05_JPRB, &
  & 0.15908726E-05_JPRB, 0.16847853E-05_JPRB, 0.17740138E-05_JPRB, 0.18585522E-05_JPRB, 0.19389111E-05_JPRB, 0.20162299E-05_JPRB, &
  & 0.20914329E-05_JPRB, 0.21640835E-05_JPRB, 0.22339286E-05_JPRB, 0.22997610E-05_JPRB, 0.23600319E-05_JPRB, 0.24140534E-05_JPRB, &
  & 0.24620672E-05_JPRB, 0.25085585E-05_JPRB, 0.25614147E-05_JPRB, 0.26650252E-05_JPRB /)

RGHG7(:,35,12) = (/ &
  & 0.88133032E-06_JPRB, 0.88786038E-06_JPRB, 0.90003522E-06_JPRB, 0.91667607E-06_JPRB, 0.93851310E-06_JPRB, 0.96461417E-06_JPRB, &
  & 0.99394595E-06_JPRB, 0.10240074E-05_JPRB, 0.10525656E-05_JPRB, 0.10784635E-05_JPRB, 0.11012716E-05_JPRB, 0.11209402E-05_JPRB, &
  & 0.11362853E-05_JPRB, 0.11463237E-05_JPRB, 0.11480691E-05_JPRB, 0.11392174E-05_JPRB, 0.11179990E-05_JPRB, 0.10846400E-05_JPRB, &
  & 0.10386627E-05_JPRB, 0.98219164E-06_JPRB, 0.91737911E-06_JPRB, 0.84614106E-06_JPRB, 0.77109485E-06_JPRB, 0.69603487E-06_JPRB, &
  & 0.62428586E-06_JPRB, 0.55881475E-06_JPRB, 0.50130723E-06_JPRB, 0.45351436E-06_JPRB, 0.41809787E-06_JPRB, 0.39768156E-06_JPRB, &
  & 0.39322856E-06_JPRB, 0.40286838E-06_JPRB, 0.42497354E-06_JPRB, 0.45614624E-06_JPRB, 0.49063323E-06_JPRB, 0.52637819E-06_JPRB, &
  & 0.56050249E-06_JPRB, 0.59356540E-06_JPRB, 0.62791611E-06_JPRB, 0.66655747E-06_JPRB, 0.71295267E-06_JPRB, 0.77009105E-06_JPRB, &
  & 0.83889677E-06_JPRB, 0.91901217E-06_JPRB, 0.10083568E-05_JPRB, 0.11036481E-05_JPRB, 0.12020502E-05_JPRB, 0.12991943E-05_JPRB, &
  & 0.13939035E-05_JPRB, 0.14838914E-05_JPRB, 0.15694212E-05_JPRB, 0.16512521E-05_JPRB, 0.17300256E-05_JPRB, 0.18066842E-05_JPRB, &
  & 0.18805575E-05_JPRB, 0.19522411E-05_JPRB, 0.20209120E-05_JPRB, 0.20858795E-05_JPRB, 0.21453941E-05_JPRB, 0.21983612E-05_JPRB, &
  & 0.22457559E-05_JPRB, 0.22906702E-05_JPRB, 0.23428006E-05_JPRB, 0.24422263E-05_JPRB /)

RGHG7(:,36,12) = (/ &
  & 0.80354579E-06_JPRB, 0.81080265E-06_JPRB, 0.82167224E-06_JPRB, 0.83576907E-06_JPRB, 0.85450614E-06_JPRB, 0.87683981E-06_JPRB, &
  & 0.90149916E-06_JPRB, 0.92610918E-06_JPRB, 0.94862759E-06_JPRB, 0.96803717E-06_JPRB, 0.98430064E-06_JPRB, 0.99739543E-06_JPRB, &
  & 0.10064724E-05_JPRB, 0.10104917E-05_JPRB, 0.10062284E-05_JPRB, 0.99175156E-06_JPRB, 0.96413771E-06_JPRB, 0.92479962E-06_JPRB, &
  & 0.87456948E-06_JPRB, 0.81491652E-06_JPRB, 0.74872042E-06_JPRB, 0.67874356E-06_JPRB, 0.60837186E-06_JPRB, 0.54089912E-06_JPRB, &
  & 0.47920065E-06_JPRB, 0.42430730E-06_JPRB, 0.37686289E-06_JPRB, 0.33753008E-06_JPRB, 0.30738951E-06_JPRB, 0.28836141E-06_JPRB, &
  & 0.28125680E-06_JPRB, 0.28444151E-06_JPRB, 0.29804903E-06_JPRB, 0.31928454E-06_JPRB, 0.34477821E-06_JPRB, 0.37323645E-06_JPRB, &
  & 0.40184466E-06_JPRB, 0.43156908E-06_JPRB, 0.46377573E-06_JPRB, 0.50119900E-06_JPRB, 0.54756134E-06_JPRB, 0.60527174E-06_JPRB, &
  & 0.67546017E-06_JPRB, 0.75705572E-06_JPRB, 0.84662338E-06_JPRB, 0.94129558E-06_JPRB, 0.10365603E-05_JPRB, 0.11304659E-05_JPRB, &
  & 0.12204206E-05_JPRB, 0.13064608E-05_JPRB, 0.13891422E-05_JPRB, 0.14689308E-05_JPRB, 0.15461312E-05_JPRB, 0.16205769E-05_JPRB, &
  & 0.16927838E-05_JPRB, 0.17626691E-05_JPRB, 0.18300630E-05_JPRB, 0.18936730E-05_JPRB, 0.19519782E-05_JPRB, 0.20038769E-05_JPRB, &
  & 0.20499854E-05_JPRB, 0.20938069E-05_JPRB, 0.21436215E-05_JPRB, 0.22391930E-05_JPRB /)

RGHG7(:,37,12) = (/ &
  & 0.74610074E-06_JPRB, 0.75272226E-06_JPRB, 0.76145767E-06_JPRB, 0.77291185E-06_JPRB, 0.78811530E-06_JPRB, 0.80622027E-06_JPRB, &
  & 0.82607511E-06_JPRB, 0.84520451E-06_JPRB, 0.86179870E-06_JPRB, 0.87536029E-06_JPRB, 0.88580401E-06_JPRB, 0.89331706E-06_JPRB, &
  & 0.89716747E-06_JPRB, 0.89605010E-06_JPRB, 0.88679082E-06_JPRB, 0.86689323E-06_JPRB, 0.83513987E-06_JPRB, 0.78958755E-06_JPRB, &
  & 0.73363611E-06_JPRB, 0.67003526E-06_JPRB, 0.60218207E-06_JPRB, 0.53428926E-06_JPRB, 0.46994080E-06_JPRB, 0.41210041E-06_JPRB, &
  & 0.36190772E-06_JPRB, 0.31951532E-06_JPRB, 0.28394217E-06_JPRB, 0.25463899E-06_JPRB, 0.23181275E-06_JPRB, 0.21644918E-06_JPRB, &
  & 0.20926936E-06_JPRB, 0.20900089E-06_JPRB, 0.21710245E-06_JPRB, 0.23041855E-06_JPRB, 0.24868328E-06_JPRB, 0.26967462E-06_JPRB, &
  & 0.29237890E-06_JPRB, 0.31707083E-06_JPRB, 0.34457210E-06_JPRB, 0.37768339E-06_JPRB, 0.41924369E-06_JPRB, 0.47261662E-06_JPRB, &
  & 0.53929591E-06_JPRB, 0.61849624E-06_JPRB, 0.70734427E-06_JPRB, 0.80006862E-06_JPRB, 0.89292661E-06_JPRB, 0.98270596E-06_JPRB, &
  & 0.10689852E-05_JPRB, 0.11517808E-05_JPRB, 0.12317413E-05_JPRB, 0.13092113E-05_JPRB, 0.13839011E-05_JPRB, 0.14564349E-05_JPRB, &
  & 0.15263394E-05_JPRB, 0.15939137E-05_JPRB, 0.16588922E-05_JPRB, 0.17205093E-05_JPRB, 0.17770826E-05_JPRB, 0.18277144E-05_JPRB, &
  & 0.18723908E-05_JPRB, 0.19145632E-05_JPRB, 0.19623640E-05_JPRB, 0.20538378E-05_JPRB /)

RGHG7(:,38,12) = (/ &
  & 0.70229606E-06_JPRB, 0.70733910E-06_JPRB, 0.71407459E-06_JPRB, 0.72266801E-06_JPRB, 0.73417681E-06_JPRB, 0.74815796E-06_JPRB, &
  & 0.76292866E-06_JPRB, 0.77674235E-06_JPRB, 0.78797569E-06_JPRB, 0.79640233E-06_JPRB, 0.80205712E-06_JPRB, 0.80504191E-06_JPRB, &
  & 0.80493908E-06_JPRB, 0.79943095E-06_JPRB, 0.78665352E-06_JPRB, 0.76146017E-06_JPRB, 0.72364844E-06_JPRB, 0.67421252E-06_JPRB, &
  & 0.61429154E-06_JPRB, 0.54794384E-06_JPRB, 0.48105477E-06_JPRB, 0.41840752E-06_JPRB, 0.36356016E-06_JPRB, 0.31744239E-06_JPRB, &
  & 0.27968829E-06_JPRB, 0.24876226E-06_JPRB, 0.22327589E-06_JPRB, 0.20224174E-06_JPRB, 0.18534143E-06_JPRB, 0.17348044E-06_JPRB, &
  & 0.16665089E-06_JPRB, 0.16528259E-06_JPRB, 0.16977019E-06_JPRB, 0.17862182E-06_JPRB, 0.19178715E-06_JPRB, 0.20740005E-06_JPRB, &
  & 0.22540016E-06_JPRB, 0.24525599E-06_JPRB, 0.26801160E-06_JPRB, 0.29531913E-06_JPRB, 0.32996968E-06_JPRB, 0.37527013E-06_JPRB, &
  & 0.43402835E-06_JPRB, 0.50698804E-06_JPRB, 0.59083095E-06_JPRB, 0.68012537E-06_JPRB, 0.76909470E-06_JPRB, 0.85529251E-06_JPRB, &
  & 0.93770939E-06_JPRB, 0.10169582E-05_JPRB, 0.10941407E-05_JPRB, 0.11691485E-05_JPRB, 0.12419461E-05_JPRB, 0.13119717E-05_JPRB, &
  & 0.13790036E-05_JPRB, 0.14428867E-05_JPRB, 0.15044271E-05_JPRB, 0.15630716E-05_JPRB, 0.16176273E-05_JPRB, 0.16664434E-05_JPRB, &
  & 0.17097325E-05_JPRB, 0.17501873E-05_JPRB, 0.17959771E-05_JPRB, 0.18828663E-05_JPRB /)

RGHG7(:,39,12) = (/ &
  & 0.66692434E-06_JPRB, 0.67007431E-06_JPRB, 0.67460104E-06_JPRB, 0.68056193E-06_JPRB, 0.68885845E-06_JPRB, 0.69853041E-06_JPRB, &
  & 0.70874773E-06_JPRB, 0.71755943E-06_JPRB, 0.72410040E-06_JPRB, 0.72832523E-06_JPRB, 0.73028610E-06_JPRB, 0.72984909E-06_JPRB, &
  & 0.72666830E-06_JPRB, 0.71847791E-06_JPRB, 0.70175736E-06_JPRB, 0.67469227E-06_JPRB, 0.63300843E-06_JPRB, 0.57851702E-06_JPRB, &
  & 0.51611954E-06_JPRB, 0.45105597E-06_JPRB, 0.38895323E-06_JPRB, 0.33521121E-06_JPRB, 0.29113107E-06_JPRB, 0.25595804E-06_JPRB, &
  & 0.22774003E-06_JPRB, 0.20496357E-06_JPRB, 0.18610923E-06_JPRB, 0.17030592E-06_JPRB, 0.15718157E-06_JPRB, 0.14767262E-06_JPRB, &
  & 0.14107538E-06_JPRB, 0.13959000E-06_JPRB, 0.14161988E-06_JPRB, 0.14835896E-06_JPRB, 0.15800960E-06_JPRB, 0.17048302E-06_JPRB, &
  & 0.18499263E-06_JPRB, 0.20139197E-06_JPRB, 0.22043334E-06_JPRB, 0.24305237E-06_JPRB, 0.27165359E-06_JPRB, 0.30939344E-06_JPRB, &
  & 0.35912686E-06_JPRB, 0.42257250E-06_JPRB, 0.49809381E-06_JPRB, 0.58048823E-06_JPRB, 0.66474701E-06_JPRB, 0.74628855E-06_JPRB, &
  & 0.82475566E-06_JPRB, 0.90099962E-06_JPRB, 0.97547957E-06_JPRB, 0.10483004E-05_JPRB, 0.11185939E-05_JPRB, 0.11850904E-05_JPRB, &
  & 0.12481371E-05_JPRB, 0.13072281E-05_JPRB, 0.13644168E-05_JPRB, 0.14191720E-05_JPRB, 0.14707497E-05_JPRB, 0.15174376E-05_JPRB, &
  & 0.15588639E-05_JPRB, 0.15976367E-05_JPRB, 0.16411857E-05_JPRB, 0.17241007E-05_JPRB /)

RGHG7(:,40,12) = (/ &
  & 0.63616358E-06_JPRB, 0.63741737E-06_JPRB, 0.64009356E-06_JPRB, 0.64378060E-06_JPRB, 0.64882443E-06_JPRB, 0.65502815E-06_JPRB, &
  & 0.66083169E-06_JPRB, 0.66547238E-06_JPRB, 0.66816983E-06_JPRB, 0.66908530E-06_JPRB, 0.66826925E-06_JPRB, 0.66550490E-06_JPRB, &
  & 0.65984352E-06_JPRB, 0.64975853E-06_JPRB, 0.63128692E-06_JPRB, 0.59980118E-06_JPRB, 0.55598429E-06_JPRB, 0.50036721E-06_JPRB, &
  & 0.43799847E-06_JPRB, 0.37695395E-06_JPRB, 0.32330155E-06_JPRB, 0.27916118E-06_JPRB, 0.24431000E-06_JPRB, 0.21690560E-06_JPRB, &
  & 0.19512279E-06_JPRB, 0.17733520E-06_JPRB, 0.16249906E-06_JPRB, 0.14977186E-06_JPRB, 0.13903772E-06_JPRB, 0.13070388E-06_JPRB, &
  & 0.12483696E-06_JPRB, 0.12274742E-06_JPRB, 0.12394143E-06_JPRB, 0.12898782E-06_JPRB, 0.13673672E-06_JPRB, 0.14712832E-06_JPRB, &
  & 0.15924937E-06_JPRB, 0.17334258E-06_JPRB, 0.18949822E-06_JPRB, 0.20876448E-06_JPRB, 0.23303609E-06_JPRB, 0.26469661E-06_JPRB, &
  & 0.30639126E-06_JPRB, 0.36011676E-06_JPRB, 0.42582835E-06_JPRB, 0.50054291E-06_JPRB, 0.57754005E-06_JPRB, 0.65390606E-06_JPRB, &
  & 0.72814299E-06_JPRB, 0.80067815E-06_JPRB, 0.87247179E-06_JPRB, 0.94299617E-06_JPRB, 0.10102808E-05_JPRB, 0.10734996E-05_JPRB, &
  & 0.11314485E-05_JPRB, 0.11857961E-05_JPRB, 0.12372572E-05_JPRB, 0.12873129E-05_JPRB, 0.13349504E-05_JPRB, 0.13786830E-05_JPRB, &
  & 0.14177988E-05_JPRB, 0.14544098E-05_JPRB, 0.14956908E-05_JPRB, 0.15743449E-05_JPRB /)

RGHG7(:,41,12) = (/ &
  & 0.60790967E-06_JPRB, 0.60751773E-06_JPRB, 0.60847316E-06_JPRB, 0.61016698E-06_JPRB, 0.61270242E-06_JPRB, 0.61543841E-06_JPRB, &
  & 0.61776279E-06_JPRB, 0.61883662E-06_JPRB, 0.61851239E-06_JPRB, 0.61698870E-06_JPRB, 0.61402670E-06_JPRB, 0.60968904E-06_JPRB, &
  & 0.60243337E-06_JPRB, 0.59065474E-06_JPRB, 0.57086322E-06_JPRB, 0.53915346E-06_JPRB, 0.49278805E-06_JPRB, 0.43694581E-06_JPRB, &
  & 0.37750681E-06_JPRB, 0.32236923E-06_JPRB, 0.27636031E-06_JPRB, 0.24046230E-06_JPRB, 0.21257584E-06_JPRB, 0.19066677E-06_JPRB, &
  & 0.17303510E-06_JPRB, 0.15845634E-06_JPRB, 0.14605087E-06_JPRB, 0.13523169E-06_JPRB, 0.12614879E-06_JPRB, 0.11827797E-06_JPRB, &
  & 0.11335544E-06_JPRB, 0.11058805E-06_JPRB, 0.11157239E-06_JPRB, 0.11535225E-06_JPRB, 0.12205557E-06_JPRB, 0.13089350E-06_JPRB, &
  & 0.14149795E-06_JPRB, 0.15379314E-06_JPRB, 0.16794544E-06_JPRB, 0.18473764E-06_JPRB, 0.20554634E-06_JPRB, 0.23232786E-06_JPRB, &
  & 0.26745795E-06_JPRB, 0.31329623E-06_JPRB, 0.37039047E-06_JPRB, 0.43561346E-06_JPRB, 0.50546936E-06_JPRB, 0.57551892E-06_JPRB, &
  & 0.64481202E-06_JPRB, 0.71376246E-06_JPRB, 0.78287911E-06_JPRB, 0.85064687E-06_JPRB, 0.91564078E-06_JPRB, 0.97423288E-06_JPRB, &
  & 0.10277121E-05_JPRB, 0.10760498E-05_JPRB, 0.11219479E-05_JPRB, 0.11664134E-05_JPRB, 0.12093029E-05_JPRB, 0.12490217E-05_JPRB, &
  & 0.12847645E-05_JPRB, 0.13186332E-05_JPRB, 0.13569581E-05_JPRB, 0.14308218E-05_JPRB /)

RGHG7(:,42,12) = (/ &
  & 0.58103973E-06_JPRB, 0.57914275E-06_JPRB, 0.57871580E-06_JPRB, 0.57868976E-06_JPRB, 0.57875332E-06_JPRB, 0.57873024E-06_JPRB, &
  & 0.57787054E-06_JPRB, 0.57618678E-06_JPRB, 0.57349052E-06_JPRB, 0.56999772E-06_JPRB, 0.56561970E-06_JPRB, 0.55980342E-06_JPRB, &
  & 0.55172342E-06_JPRB, 0.53889318E-06_JPRB, 0.51805318E-06_JPRB, 0.48455962E-06_JPRB, 0.43830443E-06_JPRB, 0.38356222E-06_JPRB, &
  & 0.32883142E-06_JPRB, 0.28041563E-06_JPRB, 0.24186014E-06_JPRB, 0.21227368E-06_JPRB, 0.18960306E-06_JPRB, 0.17154471E-06_JPRB, &
  & 0.15673831E-06_JPRB, 0.14430717E-06_JPRB, 0.13355643E-06_JPRB, 0.12389359E-06_JPRB, 0.11591975E-06_JPRB, 0.10860493E-06_JPRB, &
  & 0.10406608E-06_JPRB, 0.10128883E-06_JPRB, 0.10186374E-06_JPRB, 0.10502549E-06_JPRB, 0.11091588E-06_JPRB, 0.11873167E-06_JPRB, &
  & 0.12822757E-06_JPRB, 0.13915610E-06_JPRB, 0.15174693E-06_JPRB, 0.16658879E-06_JPRB, 0.18476862E-06_JPRB, 0.20793722E-06_JPRB, &
  & 0.23816233E-06_JPRB, 0.27721151E-06_JPRB, 0.32574283E-06_JPRB, 0.38281735E-06_JPRB, 0.44464207E-06_JPRB, 0.50836007E-06_JPRB, &
  & 0.57234519E-06_JPRB, 0.63722803E-06_JPRB, 0.70308221E-06_JPRB, 0.76894128E-06_JPRB, 0.83022030E-06_JPRB, 0.88544215E-06_JPRB, &
  & 0.93324303E-06_JPRB, 0.97628470E-06_JPRB, 0.10162008E-05_JPRB, 0.10549194E-05_JPRB, 0.10921943E-05_JPRB, 0.11269217E-05_JPRB, &
  & 0.11584677E-05_JPRB, 0.11884605E-05_JPRB, 0.12230529E-05_JPRB, 0.12906055E-05_JPRB /)

RGHG7(:,43,12) = (/ &
  & 0.55489414E-06_JPRB, 0.55164799E-06_JPRB, 0.54988220E-06_JPRB, 0.54818111E-06_JPRB, 0.54611758E-06_JPRB, 0.54331281E-06_JPRB, &
  & 0.53988362E-06_JPRB, 0.53580231E-06_JPRB, 0.53120880E-06_JPRB, 0.52624864E-06_JPRB, 0.52060074E-06_JPRB, 0.51391237E-06_JPRB, &
  & 0.50484084E-06_JPRB, 0.49165436E-06_JPRB, 0.47045268E-06_JPRB, 0.43748199E-06_JPRB, 0.39092660E-06_JPRB, 0.33788706E-06_JPRB, &
  & 0.28780943E-06_JPRB, 0.24656404E-06_JPRB, 0.21479136E-06_JPRB, 0.19059352E-06_JPRB, 0.17179697E-06_JPRB, 0.15662532E-06_JPRB, &
  & 0.14388387E-06_JPRB, 0.13284226E-06_JPRB, 0.12327421E-06_JPRB, 0.11460446E-06_JPRB, 0.10698604E-06_JPRB, 0.10063905E-06_JPRB, &
  & 0.96000456E-07_JPRB, 0.93630192E-07_JPRB, 0.93778503E-07_JPRB, 0.96640072E-07_JPRB, 0.10189432E-06_JPRB, 0.10904002E-06_JPRB, &
  & 0.11766583E-06_JPRB, 0.12757870E-06_JPRB, 0.13892441E-06_JPRB, 0.15216499E-06_JPRB, 0.16820172E-06_JPRB, 0.18837673E-06_JPRB, &
  & 0.21417212E-06_JPRB, 0.24729641E-06_JPRB, 0.28897412E-06_JPRB, 0.33840817E-06_JPRB, 0.39309515E-06_JPRB, 0.45001681E-06_JPRB, &
  & 0.50845051E-06_JPRB, 0.56877371E-06_JPRB, 0.63144876E-06_JPRB, 0.69369361E-06_JPRB, 0.75211204E-06_JPRB, 0.80255853E-06_JPRB, &
  & 0.84552278E-06_JPRB, 0.88302494E-06_JPRB, 0.91742930E-06_JPRB, 0.95033010E-06_JPRB, 0.98181329E-06_JPRB, 0.10110451E-05_JPRB, &
  & 0.10374346E-05_JPRB, 0.10629421E-05_JPRB, 0.10926527E-05_JPRB, 0.11522520E-05_JPRB /)

RGHG7(:,44,12) = (/ &
  & 0.52874697E-06_JPRB, 0.52407125E-06_JPRB, 0.52108282E-06_JPRB, 0.51778426E-06_JPRB, 0.51345245E-06_JPRB, 0.50809228E-06_JPRB, &
  & 0.50217096E-06_JPRB, 0.49604228E-06_JPRB, 0.48977643E-06_JPRB, 0.48345555E-06_JPRB, 0.47687837E-06_JPRB, 0.46935864E-06_JPRB, &
  & 0.45994611E-06_JPRB, 0.44637781E-06_JPRB, 0.42539921E-06_JPRB, 0.39224977E-06_JPRB, 0.34750335E-06_JPRB, 0.29814032E-06_JPRB, &
  & 0.25368334E-06_JPRB, 0.21888074E-06_JPRB, 0.19289040E-06_JPRB, 0.17313133E-06_JPRB, 0.15739499E-06_JPRB, 0.14434553E-06_JPRB, &
  & 0.13324561E-06_JPRB, 0.12318257E-06_JPRB, 0.11440041E-06_JPRB, 0.10646963E-06_JPRB, 0.99135967E-07_JPRB, 0.93467712E-07_JPRB, &
  & 0.89002022E-07_JPRB, 0.86856623E-07_JPRB, 0.86873548E-07_JPRB, 0.89486484E-07_JPRB, 0.94315219E-07_JPRB, 0.10096377E-06_JPRB, &
  & 0.10892568E-06_JPRB, 0.11802850E-06_JPRB, 0.12833182E-06_JPRB, 0.14023853E-06_JPRB, 0.15445994E-06_JPRB, 0.17198373E-06_JPRB, &
  & 0.19414679E-06_JPRB, 0.22244757E-06_JPRB, 0.25791394E-06_JPRB, 0.30039385E-06_JPRB, 0.34803344E-06_JPRB, 0.39874226E-06_JPRB, &
  & 0.45153638E-06_JPRB, 0.50703744E-06_JPRB, 0.56516643E-06_JPRB, 0.62382372E-06_JPRB, 0.67779865E-06_JPRB, 0.72341817E-06_JPRB, &
  & 0.76147853E-06_JPRB, 0.79371443E-06_JPRB, 0.82302267E-06_JPRB, 0.85053580E-06_JPRB, 0.87645441E-06_JPRB, 0.90007785E-06_JPRB, &
  & 0.92135258E-06_JPRB, 0.94190045E-06_JPRB, 0.96630527E-06_JPRB, 0.10162603E-05_JPRB /)

RGHG7(:,45,12) = (/ &
  & 0.50176953E-06_JPRB, 0.49553626E-06_JPRB, 0.49130421E-06_JPRB, 0.48627697E-06_JPRB, 0.47977187E-06_JPRB, 0.47176482E-06_JPRB, &
  & 0.46348623E-06_JPRB, 0.45526940E-06_JPRB, 0.44738891E-06_JPRB, 0.43990650E-06_JPRB, 0.43248318E-06_JPRB, 0.42450077E-06_JPRB, &
  & 0.41484810E-06_JPRB, 0.40157542E-06_JPRB, 0.38139163E-06_JPRB, 0.34988051E-06_JPRB, 0.30705579E-06_JPRB, 0.26207860E-06_JPRB, &
  & 0.22447772E-06_JPRB, 0.19597145E-06_JPRB, 0.17489420E-06_JPRB, 0.15865419E-06_JPRB, 0.14546147E-06_JPRB, 0.13396831E-06_JPRB, &
  & 0.12407911E-06_JPRB, 0.11484991E-06_JPRB, 0.10652322E-06_JPRB, 0.99125273E-07_JPRB, 0.92148596E-07_JPRB, 0.86846612E-07_JPRB, &
  & 0.82785881E-07_JPRB, 0.80778698E-07_JPRB, 0.80835193E-07_JPRB, 0.83256708E-07_JPRB, 0.87815607E-07_JPRB, 0.94081024E-07_JPRB, &
  & 0.10155323E-06_JPRB, 0.10999997E-06_JPRB, 0.11944637E-06_JPRB, 0.13021878E-06_JPRB, 0.14285459E-06_JPRB, 0.15820454E-06_JPRB, &
  & 0.17720713E-06_JPRB, 0.20101830E-06_JPRB, 0.23075279E-06_JPRB, 0.26682389E-06_JPRB, 0.30821380E-06_JPRB, 0.35292209E-06_JPRB, &
  & 0.40019987E-06_JPRB, 0.45044402E-06_JPRB, 0.50391242E-06_JPRB, 0.55724547E-06_JPRB, 0.60598768E-06_JPRB, 0.64644928E-06_JPRB, &
  & 0.67918302E-06_JPRB, 0.70688196E-06_JPRB, 0.73136334E-06_JPRB, 0.75413647E-06_JPRB, 0.77502591E-06_JPRB, 0.79369102E-06_JPRB, &
  & 0.81023870E-06_JPRB, 0.82621227E-06_JPRB, 0.84540557E-06_JPRB, 0.88566571E-06_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART24',0,ZHOOK_HANDLE)



RGHG7(:,46,12) = (/ &
  & 0.47299437E-06_JPRB, 0.46514975E-06_JPRB, 0.45952359E-06_JPRB, 0.45295803E-06_JPRB, 0.44410052E-06_JPRB, 0.43357002E-06_JPRB, &
  & 0.42278282E-06_JPRB, 0.41253693E-06_JPRB, 0.40297638E-06_JPRB, 0.39444959E-06_JPRB, 0.38639848E-06_JPRB, 0.37826069E-06_JPRB, &
  & 0.36871020E-06_JPRB, 0.35629088E-06_JPRB, 0.33703182E-06_JPRB, 0.30800990E-06_JPRB, 0.26899164E-06_JPRB, 0.23040975E-06_JPRB, &
  & 0.19942614E-06_JPRB, 0.17688031E-06_JPRB, 0.15996589E-06_JPRB, 0.14652448E-06_JPRB, 0.13525197E-06_JPRB, 0.12517974E-06_JPRB, &
  & 0.11594781E-06_JPRB, 0.10753192E-06_JPRB, 0.99447362E-07_JPRB, 0.92394359E-07_JPRB, 0.85770132E-07_JPRB, 0.80805684E-07_JPRB, &
  & 0.77128213E-07_JPRB, 0.75322951E-07_JPRB, 0.75478532E-07_JPRB, 0.77795335E-07_JPRB, 0.82174651E-07_JPRB, 0.88160760E-07_JPRB, &
  & 0.95256503E-07_JPRB, 0.10317987E-06_JPRB, 0.11192245E-06_JPRB, 0.12172725E-06_JPRB, 0.13302345E-06_JPRB, 0.14640018E-06_JPRB, &
  & 0.16259385E-06_JPRB, 0.18249114E-06_JPRB, 0.20706783E-06_JPRB, 0.23705491E-06_JPRB, 0.27209992E-06_JPRB, 0.31101820E-06_JPRB, &
  & 0.35287155E-06_JPRB, 0.39798562E-06_JPRB, 0.44555850E-06_JPRB, 0.49374540E-06_JPRB, 0.53593544E-06_JPRB, 0.57091415E-06_JPRB, &
  & 0.59870285E-06_JPRB, 0.62181203E-06_JPRB, 0.64224321E-06_JPRB, 0.66075586E-06_JPRB, 0.67749897E-06_JPRB, 0.69200718E-06_JPRB, &
  & 0.70470617E-06_JPRB, 0.71690096E-06_JPRB, 0.73175744E-06_JPRB, 0.76335402E-06_JPRB /)

RGHG7(:,47,12) = (/ &
  & 0.44181127E-06_JPRB, 0.43210005E-06_JPRB, 0.42522379E-06_JPRB, 0.41685101E-06_JPRB, 0.40593798E-06_JPRB, 0.39273689E-06_JPRB, &
  & 0.37959305E-06_JPRB, 0.36704762E-06_JPRB, 0.35605132E-06_JPRB, 0.34661406E-06_JPRB, 0.33842070E-06_JPRB, 0.33029488E-06_JPRB, &
  & 0.32159414E-06_JPRB, 0.30984353E-06_JPRB, 0.29335033E-06_JPRB, 0.26711757E-06_JPRB, 0.23420807E-06_JPRB, 0.20253144E-06_JPRB, &
  & 0.17848919E-06_JPRB, 0.16088165E-06_JPRB, 0.14745962E-06_JPRB, 0.13629320E-06_JPRB, 0.12645089E-06_JPRB, 0.11752684E-06_JPRB, &
  & 0.10881681E-06_JPRB, 0.10086213E-06_JPRB, 0.93030771E-07_JPRB, 0.86196344E-07_JPRB, 0.79913754E-07_JPRB, 0.75257830E-07_JPRB, &
  & 0.71995736E-07_JPRB, 0.70409001E-07_JPRB, 0.70711252E-07_JPRB, 0.72994744E-07_JPRB, 0.77263387E-07_JPRB, 0.83045109E-07_JPRB, &
  & 0.89850495E-07_JPRB, 0.97351979E-07_JPRB, 0.10551027E-06_JPRB, 0.11449826E-06_JPRB, 0.12463306E-06_JPRB, 0.13638591E-06_JPRB, &
  & 0.15018908E-06_JPRB, 0.16661161E-06_JPRB, 0.18637245E-06_JPRB, 0.21032361E-06_JPRB, 0.23905324E-06_JPRB, 0.27191436E-06_JPRB, &
  & 0.30821320E-06_JPRB, 0.34768669E-06_JPRB, 0.39027688E-06_JPRB, 0.43119482E-06_JPRB, 0.46819511E-06_JPRB, 0.49695029E-06_JPRB, &
  & 0.52022716E-06_JPRB, 0.53934525E-06_JPRB, 0.55602095E-06_JPRB, 0.57115500E-06_JPRB, 0.58442822E-06_JPRB, 0.59577906E-06_JPRB, &
  & 0.60550332E-06_JPRB, 0.61484292E-06_JPRB, 0.62627231E-06_JPRB, 0.65127273E-06_JPRB /)

RGHG7(:,48,12) = (/ &
  & 0.40783232E-06_JPRB, 0.39621224E-06_JPRB, 0.38788374E-06_JPRB, 0.37797125E-06_JPRB, 0.36484107E-06_JPRB, 0.34925031E-06_JPRB, &
  & 0.33338091E-06_JPRB, 0.31898568E-06_JPRB, 0.30650028E-06_JPRB, 0.29683068E-06_JPRB, 0.28866995E-06_JPRB, 0.28134082E-06_JPRB, &
  & 0.27328090E-06_JPRB, 0.26360092E-06_JPRB, 0.24919251E-06_JPRB, 0.22857937E-06_JPRB, 0.20253702E-06_JPRB, 0.17886111E-06_JPRB, &
  & 0.16092584E-06_JPRB, 0.14760602E-06_JPRB, 0.13688262E-06_JPRB, 0.12758187E-06_JPRB, 0.11883142E-06_JPRB, 0.11068209E-06_JPRB, &
  & 0.10246563E-06_JPRB, 0.94758093E-07_JPRB, 0.87104297E-07_JPRB, 0.80464773E-07_JPRB, 0.74528280E-07_JPRB, 0.70197849E-07_JPRB, &
  & 0.67322262E-07_JPRB, 0.65999664E-07_JPRB, 0.66460935E-07_JPRB, 0.68785866E-07_JPRB, 0.72979780E-07_JPRB, 0.78617042E-07_JPRB, &
  & 0.85195090E-07_JPRB, 0.92355151E-07_JPRB, 0.10003595E-06_JPRB, 0.10834361E-06_JPRB, 0.11752459E-06_JPRB, 0.12786920E-06_JPRB, &
  & 0.13962337E-06_JPRB, 0.15304931E-06_JPRB, 0.16852823E-06_JPRB, 0.18684450E-06_JPRB, 0.20884782E-06_JPRB, 0.23506767E-06_JPRB, &
  & 0.26522667E-06_JPRB, 0.29907042E-06_JPRB, 0.33503471E-06_JPRB, 0.37092414E-06_JPRB, 0.40080101E-06_JPRB, 0.42508333E-06_JPRB, &
  & 0.44387536E-06_JPRB, 0.45956904E-06_JPRB, 0.47326333E-06_JPRB, 0.48553943E-06_JPRB, 0.49626425E-06_JPRB, 0.50520714E-06_JPRB, &
  & 0.51282808E-06_JPRB, 0.52009773E-06_JPRB, 0.52913794E-06_JPRB, 0.54923788E-06_JPRB /)

RGHG7(:,49,12) = (/ &
  & 0.37111195E-06_JPRB, 0.35763966E-06_JPRB, 0.34787206E-06_JPRB, 0.33633722E-06_JPRB, 0.32109477E-06_JPRB, 0.30285477E-06_JPRB, &
  & 0.28465053E-06_JPRB, 0.26827232E-06_JPRB, 0.25533919E-06_JPRB, 0.24578179E-06_JPRB, 0.23846798E-06_JPRB, 0.23204397E-06_JPRB, &
  & 0.22561305E-06_JPRB, 0.21800645E-06_JPRB, 0.20763440E-06_JPRB, 0.19321917E-06_JPRB, 0.17538817E-06_JPRB, 0.15906268E-06_JPRB, &
  & 0.14639420E-06_JPRB, 0.13643685E-06_JPRB, 0.12790186E-06_JPRB, 0.12000788E-06_JPRB, 0.11221064E-06_JPRB, 0.10450439E-06_JPRB, &
  & 0.96724598E-07_JPRB, 0.89053479E-07_JPRB, 0.81633516E-07_JPRB, 0.75140015E-07_JPRB, 0.69608120E-07_JPRB, 0.65593561E-07_JPRB, &
  & 0.63078481E-07_JPRB, 0.62061240E-07_JPRB, 0.62675149E-07_JPRB, 0.65087505E-07_JPRB, 0.69249076E-07_JPRB, 0.74778583E-07_JPRB, &
  & 0.81163670E-07_JPRB, 0.88050236E-07_JPRB, 0.95332815E-07_JPRB, 0.10308084E-06_JPRB, 0.11146432E-06_JPRB, 0.12066853E-06_JPRB, &
  & 0.13074157E-06_JPRB, 0.14166609E-06_JPRB, 0.15347906E-06_JPRB, 0.16663213E-06_JPRB, 0.18212290E-06_JPRB, 0.20101994E-06_JPRB, &
  & 0.22408081E-06_JPRB, 0.25121065E-06_JPRB, 0.28102428E-06_JPRB, 0.30978956E-06_JPRB, 0.33446523E-06_JPRB, 0.35369143E-06_JPRB, &
  & 0.36904132E-06_JPRB, 0.38180983E-06_JPRB, 0.39311752E-06_JPRB, 0.40330070E-06_JPRB, 0.41209509E-06_JPRB, 0.41943139E-06_JPRB, &
  & 0.42558074E-06_JPRB, 0.43151380E-06_JPRB, 0.43894619E-06_JPRB, 0.45582257E-06_JPRB /)

RGHG7(:,50,12) = (/ &
  & 0.33265238E-06_JPRB, 0.31687387E-06_JPRB, 0.30604406E-06_JPRB, 0.29260687E-06_JPRB, 0.27532909E-06_JPRB, 0.25433332E-06_JPRB, &
  & 0.23403037E-06_JPRB, 0.21710431E-06_JPRB, 0.20475871E-06_JPRB, 0.19662720E-06_JPRB, 0.19078530E-06_JPRB, 0.18606495E-06_JPRB, &
  & 0.18183476E-06_JPRB, 0.17692079E-06_JPRB, 0.17130475E-06_JPRB, 0.16296514E-06_JPRB, 0.15293104E-06_JPRB, 0.14279171E-06_JPRB, &
  & 0.13430783E-06_JPRB, 0.12701817E-06_JPRB, 0.12015060E-06_JPRB, 0.11334571E-06_JPRB, 0.10631222E-06_JPRB, 0.98932503E-07_JPRB, &
  & 0.91342322E-07_JPRB, 0.83783149E-07_JPRB, 0.76493563E-07_JPRB, 0.70261919E-07_JPRB, 0.65105112E-07_JPRB, 0.61447047E-07_JPRB, &
  & 0.59233670E-07_JPRB, 0.58529491E-07_JPRB, 0.59325725E-07_JPRB, 0.61832601E-07_JPRB, 0.65991649E-07_JPRB, 0.71432112E-07_JPRB, &
  & 0.77659990E-07_JPRB, 0.84309235E-07_JPRB, 0.91262798E-07_JPRB, 0.98554693E-07_JPRB, 0.10629836E-06_JPRB, 0.11457163E-06_JPRB, &
  & 0.12326289E-06_JPRB, 0.13213480E-06_JPRB, 0.14096543E-06_JPRB, 0.14984656E-06_JPRB, 0.15961014E-06_JPRB, 0.17154427E-06_JPRB, &
  & 0.18684183E-06_JPRB, 0.20597173E-06_JPRB, 0.22792648E-06_JPRB, 0.24933303E-06_JPRB, 0.26792122E-06_JPRB, 0.28262639E-06_JPRB, &
  & 0.29466489E-06_JPRB, 0.30503429E-06_JPRB, 0.31428405E-06_JPRB, 0.32289171E-06_JPRB, 0.33030372E-06_JPRB, 0.33654737E-06_JPRB, &
  & 0.34180275E-06_JPRB, 0.34694455E-06_JPRB, 0.35349976E-06_JPRB, 0.36873402E-06_JPRB /)

RGHG7(:,51,12) = (/ &
  & 0.29281631E-06_JPRB, 0.27622175E-06_JPRB, 0.26328649E-06_JPRB, 0.24891699E-06_JPRB, 0.22889995E-06_JPRB, 0.20635284E-06_JPRB, &
  & 0.18537500E-06_JPRB, 0.17046159E-06_JPRB, 0.16096135E-06_JPRB, 0.15534266E-06_JPRB, 0.15168538E-06_JPRB, 0.14913715E-06_JPRB, &
  & 0.14692144E-06_JPRB, 0.14506722E-06_JPRB, 0.14264566E-06_JPRB, 0.13968788E-06_JPRB, 0.13496327E-06_JPRB, 0.12955515E-06_JPRB, &
  & 0.12416955E-06_JPRB, 0.11886215E-06_JPRB, 0.11335853E-06_JPRB, 0.10739886E-06_JPRB, 0.10085661E-06_JPRB, 0.93768122E-07_JPRB, &
  & 0.86341913E-07_JPRB, 0.78801207E-07_JPRB, 0.71767069E-07_JPRB, 0.65784889E-07_JPRB, 0.61023762E-07_JPRB, 0.57702444E-07_JPRB, &
  & 0.55799269E-07_JPRB, 0.55338177E-07_JPRB, 0.56364527E-07_JPRB, 0.58969292E-07_JPRB, 0.63129974E-07_JPRB, 0.68501059E-07_JPRB, &
  & 0.74580520E-07_JPRB, 0.81021611E-07_JPRB, 0.87700400E-07_JPRB, 0.94620368E-07_JPRB, 0.10184871E-06_JPRB, 0.10937279E-06_JPRB, &
  & 0.11695391E-06_JPRB, 0.12419137E-06_JPRB, 0.13062272E-06_JPRB, 0.13628269E-06_JPRB, 0.14169825E-06_JPRB, 0.14801056E-06_JPRB, &
  & 0.15639618E-06_JPRB, 0.16740296E-06_JPRB, 0.18029118E-06_JPRB, 0.19364556E-06_JPRB, 0.20527163E-06_JPRB, 0.21533936E-06_JPRB, &
  & 0.22384067E-06_JPRB, 0.23148209E-06_JPRB, 0.23881978E-06_JPRB, 0.24560569E-06_JPRB, 0.25181706E-06_JPRB, 0.25712467E-06_JPRB, &
  & 0.26164912E-06_JPRB, 0.26625432E-06_JPRB, 0.27236862E-06_JPRB, 0.28665050E-06_JPRB /)

RGHG7(:,52,12) = (/ &
  & 0.25486221E-06_JPRB, 0.23555138E-06_JPRB, 0.22321494E-06_JPRB, 0.20636396E-06_JPRB, 0.18656520E-06_JPRB, 0.16353052E-06_JPRB, &
  & 0.14646930E-06_JPRB, 0.13570742E-06_JPRB, 0.12994586E-06_JPRB, 0.12683911E-06_JPRB, 0.12510505E-06_JPRB, 0.12395391E-06_JPRB, &
  & 0.12333382E-06_JPRB, 0.12285473E-06_JPRB, 0.12263679E-06_JPRB, 0.12224206E-06_JPRB, 0.12105528E-06_JPRB, 0.11870336E-06_JPRB, &
  & 0.11553785E-06_JPRB, 0.11172711E-06_JPRB, 0.10722634E-06_JPRB, 0.10193473E-06_JPRB, 0.95837763E-07_JPRB, 0.88935288E-07_JPRB, &
  & 0.81565815E-07_JPRB, 0.74214086E-07_JPRB, 0.67401047E-07_JPRB, 0.61730496E-07_JPRB, 0.57331942E-07_JPRB, 0.54316125E-07_JPRB, &
  & 0.52742529E-07_JPRB, 0.52494652E-07_JPRB, 0.53706309E-07_JPRB, 0.56455587E-07_JPRB, 0.60604386E-07_JPRB, 0.65908409E-07_JPRB, &
  & 0.71841207E-07_JPRB, 0.78097756E-07_JPRB, 0.84533120E-07_JPRB, 0.91142653E-07_JPRB, 0.97953972E-07_JPRB, 0.10487164E-06_JPRB, &
  & 0.11155362E-06_JPRB, 0.11744200E-06_JPRB, 0.12208871E-06_JPRB, 0.12538420E-06_JPRB, 0.12796482E-06_JPRB, 0.13069011E-06_JPRB, &
  & 0.13434600E-06_JPRB, 0.13931255E-06_JPRB, 0.14538637E-06_JPRB, 0.15165266E-06_JPRB, 0.15772716E-06_JPRB, 0.16305556E-06_JPRB, &
  & 0.16802431E-06_JPRB, 0.17283467E-06_JPRB, 0.17748393E-06_JPRB, 0.18230836E-06_JPRB, 0.18670619E-06_JPRB, 0.19060842E-06_JPRB, &
  & 0.19402871E-06_JPRB, 0.19764164E-06_JPRB, 0.20256100E-06_JPRB, 0.21486021E-06_JPRB /)

RGHG7(:,53,12) = (/ &
  & 0.21820824E-06_JPRB, 0.20030619E-06_JPRB, 0.18524061E-06_JPRB, 0.17061139E-06_JPRB, 0.15037061E-06_JPRB, 0.13259339E-06_JPRB, &
  & 0.12021452E-06_JPRB, 0.11400628E-06_JPRB, 0.11085910E-06_JPRB, 0.10933874E-06_JPRB, 0.10853127E-06_JPRB, 0.10815469E-06_JPRB, &
  & 0.10807117E-06_JPRB, 0.10826015E-06_JPRB, 0.10883547E-06_JPRB, 0.10953924E-06_JPRB, 0.11011897E-06_JPRB, 0.10968064E-06_JPRB, &
  & 0.10804625E-06_JPRB, 0.10532767E-06_JPRB, 0.10159497E-06_JPRB, 0.96832153E-07_JPRB, 0.91005276E-07_JPRB, 0.84324526E-07_JPRB, &
  & 0.77097880E-07_JPRB, 0.69940647E-07_JPRB, 0.63426754E-07_JPRB, 0.58052599E-07_JPRB, 0.53996711E-07_JPRB, 0.51266316E-07_JPRB, &
  & 0.49994117E-07_JPRB, 0.49984262E-07_JPRB, 0.51345776E-07_JPRB, 0.54188320E-07_JPRB, 0.58384970E-07_JPRB, 0.63574177E-07_JPRB, &
  & 0.69393778E-07_JPRB, 0.75454032E-07_JPRB, 0.81666933E-07_JPRB, 0.88006146E-07_JPRB, 0.94461015E-07_JPRB, 0.10088397E-06_JPRB, &
  & 0.10680549E-06_JPRB, 0.11165075E-06_JPRB, 0.11490414E-06_JPRB, 0.11669640E-06_JPRB, 0.11759106E-06_JPRB, 0.11836633E-06_JPRB, &
  & 0.11960174E-06_JPRB, 0.12151948E-06_JPRB, 0.12400058E-06_JPRB, 0.12680243E-06_JPRB, 0.12949921E-06_JPRB, 0.13215374E-06_JPRB, &
  & 0.13468923E-06_JPRB, 0.13720546E-06_JPRB, 0.13994294E-06_JPRB, 0.14262500E-06_JPRB, 0.14530785E-06_JPRB, 0.14762630E-06_JPRB, &
  & 0.14963928E-06_JPRB, 0.15174557E-06_JPRB, 0.15462885E-06_JPRB, 0.16273476E-06_JPRB /)

RGHG7(:,54,12) = (/ &
  & 0.18683637E-06_JPRB, 0.16708178E-06_JPRB, 0.15550226E-06_JPRB, 0.14006980E-06_JPRB, 0.12527588E-06_JPRB, 0.11166768E-06_JPRB, &
  & 0.10435456E-06_JPRB, 0.10074186E-06_JPRB, 0.99073986E-07_JPRB, 0.98301207E-07_JPRB, 0.97947655E-07_JPRB, 0.97810663E-07_JPRB, &
  & 0.97891068E-07_JPRB, 0.98241124E-07_JPRB, 0.98845426E-07_JPRB, 0.10006485E-06_JPRB, 0.10128407E-06_JPRB, 0.10199204E-06_JPRB, &
  & 0.10140884E-06_JPRB, 0.99485568E-07_JPRB, 0.96324257E-07_JPRB, 0.91949019E-07_JPRB, 0.86416584E-07_JPRB, 0.79901618E-07_JPRB, &
  & 0.72909259E-07_JPRB, 0.66006614E-07_JPRB, 0.59788249E-07_JPRB, 0.54707499E-07_JPRB, 0.50979803E-07_JPRB, 0.48537014E-07_JPRB, &
  & 0.47513481E-07_JPRB, 0.47736222E-07_JPRB, 0.49267360E-07_JPRB, 0.52140336E-07_JPRB, 0.56359571E-07_JPRB, 0.61482559E-07_JPRB, &
  & 0.67144377E-07_JPRB, 0.73026612E-07_JPRB, 0.79022662E-07_JPRB, 0.85109413E-07_JPRB, 0.91246378E-07_JPRB, 0.97223221E-07_JPRB, &
  & 0.10252938E-06_JPRB, 0.10650867E-06_JPRB, 0.10881038E-06_JPRB, 0.10963920E-06_JPRB, 0.10967222E-06_JPRB, 0.10958239E-06_JPRB, &
  & 0.10978635E-06_JPRB, 0.11044585E-06_JPRB, 0.11152122E-06_JPRB, 0.11279000E-06_JPRB, 0.11416873E-06_JPRB, 0.11550945E-06_JPRB, &
  & 0.11685654E-06_JPRB, 0.11829996E-06_JPRB, 0.11977043E-06_JPRB, 0.12140382E-06_JPRB, 0.12290893E-06_JPRB, 0.12416733E-06_JPRB, &
  & 0.12521565E-06_JPRB, 0.12612742E-06_JPRB, 0.12723390E-06_JPRB, 0.13042791E-06_JPRB /)

RGHG7(:,55,12) = (/ &
  & 0.15922865E-06_JPRB, 0.14215625E-06_JPRB, 0.12975293E-06_JPRB, 0.11922093E-06_JPRB, 0.10728166E-06_JPRB, 0.98837859E-07_JPRB, &
  & 0.94149989E-07_JPRB, 0.92099015E-07_JPRB, 0.91168772E-07_JPRB, 0.90714494E-07_JPRB, 0.90516778E-07_JPRB, 0.90468482E-07_JPRB, &
  & 0.90565429E-07_JPRB, 0.90833169E-07_JPRB, 0.91476146E-07_JPRB, 0.92433510E-07_JPRB, 0.94009408E-07_JPRB, 0.95279333E-07_JPRB, &
  & 0.95380422E-07_JPRB, 0.94036594E-07_JPRB, 0.91306276E-07_JPRB, 0.87250676E-07_JPRB, 0.81968807E-07_JPRB, 0.75720024E-07_JPRB, &
  & 0.68965107E-07_JPRB, 0.62364911E-07_JPRB, 0.56436711E-07_JPRB, 0.51666543E-07_JPRB, 0.48236682E-07_JPRB, 0.46087550E-07_JPRB, &
  & 0.45282338E-07_JPRB, 0.45704066E-07_JPRB, 0.47376741E-07_JPRB, 0.50319006E-07_JPRB, 0.54451945E-07_JPRB, 0.59554409E-07_JPRB, &
  & 0.65040552E-07_JPRB, 0.70755448E-07_JPRB, 0.76539543E-07_JPRB, 0.82368786E-07_JPRB, 0.88203642E-07_JPRB, 0.93773167E-07_JPRB, &
  & 0.98541754E-07_JPRB, 0.10187890E-06_JPRB, 0.10351987E-06_JPRB, 0.10382001E-06_JPRB, 0.10346813E-06_JPRB, 0.10304709E-06_JPRB, &
  & 0.10289624E-06_JPRB, 0.10310985E-06_JPRB, 0.10362620E-06_JPRB, 0.10433753E-06_JPRB, 0.10509187E-06_JPRB, 0.10586687E-06_JPRB, &
  & 0.10667161E-06_JPRB, 0.10750413E-06_JPRB, 0.10845609E-06_JPRB, 0.10943467E-06_JPRB, 0.11040035E-06_JPRB, 0.11125219E-06_JPRB, &
  & 0.11192353E-06_JPRB, 0.11254839E-06_JPRB, 0.11325930E-06_JPRB, 0.11444700E-06_JPRB /)

RGHG7(:,56,12) = (/ &
  & 0.13641134E-06_JPRB, 0.12101178E-06_JPRB, 0.11223284E-06_JPRB, 0.10359752E-06_JPRB, 0.95853039E-07_JPRB, 0.89938382E-07_JPRB, &
  & 0.87115218E-07_JPRB, 0.85797467E-07_JPRB, 0.85222453E-07_JPRB, 0.84941270E-07_JPRB, 0.84788851E-07_JPRB, 0.84744357E-07_JPRB, &
  & 0.84786024E-07_JPRB, 0.85009127E-07_JPRB, 0.85426016E-07_JPRB, 0.86353694E-07_JPRB, 0.87713595E-07_JPRB, 0.89256737E-07_JPRB, &
  & 0.89812254E-07_JPRB, 0.88882217E-07_JPRB, 0.86481769E-07_JPRB, 0.82715296E-07_JPRB, 0.77686160E-07_JPRB, 0.71711590E-07_JPRB, &
  & 0.65276161E-07_JPRB, 0.58956694E-07_JPRB, 0.53356448E-07_JPRB, 0.48876142E-07_JPRB, 0.45745843E-07_JPRB, 0.43873886E-07_JPRB, &
  & 0.43273868E-07_JPRB, 0.43856581E-07_JPRB, 0.45629559E-07_JPRB, 0.48619665E-07_JPRB, 0.52706469E-07_JPRB, 0.57656070E-07_JPRB, &
  & 0.63048979E-07_JPRB, 0.68574259E-07_JPRB, 0.74141767E-07_JPRB, 0.79735230E-07_JPRB, 0.85248075E-07_JPRB, 0.90452133E-07_JPRB, &
  & 0.94753879E-07_JPRB, 0.97621914E-07_JPRB, 0.98850890E-07_JPRB, 0.98891569E-07_JPRB, 0.98403135E-07_JPRB, 0.97932791E-07_JPRB, &
  & 0.97719287E-07_JPRB, 0.97816539E-07_JPRB, 0.98160115E-07_JPRB, 0.98617747E-07_JPRB, 0.99125465E-07_JPRB, 0.99645433E-07_JPRB, &
  & 0.10017413E-06_JPRB, 0.10075725E-06_JPRB, 0.10138488E-06_JPRB, 0.10208810E-06_JPRB, 0.10278767E-06_JPRB, 0.10338905E-06_JPRB, &
  & 0.10391962E-06_JPRB, 0.10445893E-06_JPRB, 0.10522323E-06_JPRB, 0.10735084E-06_JPRB /)

RGHG7(:,57,12) = (/ &
  & 0.11904481E-06_JPRB, 0.10560863E-06_JPRB, 0.99031254E-07_JPRB, 0.93113364E-07_JPRB, 0.87709317E-07_JPRB, 0.83807393E-07_JPRB, &
  & 0.81790084E-07_JPRB, 0.80887993E-07_JPRB, 0.80439897E-07_JPRB, 0.80206490E-07_JPRB, 0.80057781E-07_JPRB, 0.79969986E-07_JPRB, &
  & 0.79963925E-07_JPRB, 0.80082252E-07_JPRB, 0.80404618E-07_JPRB, 0.81035076E-07_JPRB, 0.82288231E-07_JPRB, 0.83797374E-07_JPRB, &
  & 0.84606228E-07_JPRB, 0.83948130E-07_JPRB, 0.81812225E-07_JPRB, 0.78298172E-07_JPRB, 0.73564372E-07_JPRB, 0.67890667E-07_JPRB, &
  & 0.61758634E-07_JPRB, 0.55786156E-07_JPRB, 0.50488531E-07_JPRB, 0.46337714E-07_JPRB, 0.43479599E-07_JPRB, 0.41863398E-07_JPRB, &
  & 0.41457643E-07_JPRB, 0.42175682E-07_JPRB, 0.44000693E-07_JPRB, 0.46983285E-07_JPRB, 0.51036906E-07_JPRB, 0.55824746E-07_JPRB, &
  & 0.61087555E-07_JPRB, 0.66418508E-07_JPRB, 0.71797210E-07_JPRB, 0.77137557E-07_JPRB, 0.82365275E-07_JPRB, 0.87194849E-07_JPRB, &
  & 0.91142759E-07_JPRB, 0.93652645E-07_JPRB, 0.94667158E-07_JPRB, 0.94606257E-07_JPRB, 0.94138862E-07_JPRB, 0.93730030E-07_JPRB, &
  & 0.93585896E-07_JPRB, 0.93710597E-07_JPRB, 0.94005273E-07_JPRB, 0.94384710E-07_JPRB, 0.94778613E-07_JPRB, 0.95169625E-07_JPRB, &
  & 0.95571927E-07_JPRB, 0.95994515E-07_JPRB, 0.96466195E-07_JPRB, 0.96971895E-07_JPRB, 0.97481973E-07_JPRB, 0.97942795E-07_JPRB, &
  & 0.98329885E-07_JPRB, 0.98694500E-07_JPRB, 0.99116974E-07_JPRB, 0.10013009E-06_JPRB /)

RGHG7(:,58,12) = (/ &
  & 0.10430269E-06_JPRB, 0.94778017E-07_JPRB, 0.89509747E-07_JPRB, 0.85695639E-07_JPRB, 0.81801190E-07_JPRB, 0.78980086E-07_JPRB, &
  & 0.77480635E-07_JPRB, 0.76734032E-07_JPRB, 0.76336889E-07_JPRB, 0.76088703E-07_JPRB, 0.75914635E-07_JPRB, 0.75787923E-07_JPRB, &
  & 0.75728295E-07_JPRB, 0.75767645E-07_JPRB, 0.75949828E-07_JPRB, 0.76452906E-07_JPRB, 0.77397118E-07_JPRB, 0.78827163E-07_JPRB, &
  & 0.79687680E-07_JPRB, 0.79194479E-07_JPRB, 0.77287801E-07_JPRB, 0.74036279E-07_JPRB, 0.69561885E-07_JPRB, 0.64220302E-07_JPRB, &
  & 0.58428203E-07_JPRB, 0.52793812E-07_JPRB, 0.47852527E-07_JPRB, 0.44012410E-07_JPRB, 0.41430340E-07_JPRB, 0.40047585E-07_JPRB, &
  & 0.39816751E-07_JPRB, 0.40635193E-07_JPRB, 0.42490601E-07_JPRB, 0.45418663E-07_JPRB, 0.49370762E-07_JPRB, 0.54045749E-07_JPRB, &
  & 0.59106970E-07_JPRB, 0.64284464E-07_JPRB, 0.69464726E-07_JPRB, 0.74565833E-07_JPRB, 0.79511445E-07_JPRB, 0.84044821E-07_JPRB, &
  & 0.87652822E-07_JPRB, 0.89960146E-07_JPRB, 0.90848829E-07_JPRB, 0.90807049E-07_JPRB, 0.90423356E-07_JPRB, 0.90148639E-07_JPRB, &
  & 0.90128204E-07_JPRB, 0.90330957E-07_JPRB, 0.90658403E-07_JPRB, 0.91016510E-07_JPRB, 0.91366502E-07_JPRB, 0.91706774E-07_JPRB, &
  & 0.92039990E-07_JPRB, 0.92394892E-07_JPRB, 0.92777029E-07_JPRB, 0.93209351E-07_JPRB, 0.93642655E-07_JPRB, 0.94037865E-07_JPRB, &
  & 0.94396114E-07_JPRB, 0.94764196E-07_JPRB, 0.95302532E-07_JPRB, 0.96574226E-07_JPRB /)

RGHG7(:,59,12) = (/ &
  & 0.93756434E-07_JPRB, 0.85704478E-07_JPRB, 0.82798380E-07_JPRB, 0.79866119E-07_JPRB, 0.77305543E-07_JPRB, 0.75115487E-07_JPRB, &
  & 0.73828126E-07_JPRB, 0.73125051E-07_JPRB, 0.72706264E-07_JPRB, 0.72419937E-07_JPRB, 0.72191440E-07_JPRB, 0.72005797E-07_JPRB, &
  & 0.71882560E-07_JPRB, 0.71832297E-07_JPRB, 0.71924880E-07_JPRB, 0.72242237E-07_JPRB, 0.73026087E-07_JPRB, 0.74222513E-07_JPRB, &
  & 0.75026485E-07_JPRB, 0.74641676E-07_JPRB, 0.72917857E-07_JPRB, 0.69887442E-07_JPRB, 0.65720400E-07_JPRB, 0.60687881E-07_JPRB, &
  & 0.55261218E-07_JPRB, 0.50003447E-07_JPRB, 0.45416037E-07_JPRB, 0.41914138E-07_JPRB, 0.39588670E-07_JPRB, 0.38426009E-07_JPRB, &
  & 0.38341067E-07_JPRB, 0.39233058E-07_JPRB, 0.41082924E-07_JPRB, 0.43935966E-07_JPRB, 0.47746674E-07_JPRB, 0.52269282E-07_JPRB, &
  & 0.57148188E-07_JPRB, 0.62156111E-07_JPRB, 0.67128198E-07_JPRB, 0.72029302E-07_JPRB, 0.76722074E-07_JPRB, 0.80959744E-07_JPRB, &
  & 0.84352536E-07_JPRB, 0.86469512E-07_JPRB, 0.87350692E-07_JPRB, 0.87375120E-07_JPRB, 0.87127582E-07_JPRB, 0.87007827E-07_JPRB, &
  & 0.87135930E-07_JPRB, 0.87453209E-07_JPRB, 0.87824695E-07_JPRB, 0.88196991E-07_JPRB, 0.88545534E-07_JPRB, 0.88860389E-07_JPRB, &
  & 0.89171174E-07_JPRB, 0.89487230E-07_JPRB, 0.89831154E-07_JPRB, 0.90187164E-07_JPRB, 0.90553847E-07_JPRB, 0.90892378E-07_JPRB, &
  & 0.91184901E-07_JPRB, 0.91477112E-07_JPRB, 0.91850900E-07_JPRB, 0.92895725E-07_JPRB /)

RGHG7(:,60,12) = (/ &
  & 0.83394184E-07_JPRB, 0.79356802E-07_JPRB, 0.77190904E-07_JPRB, 0.75549423E-07_JPRB, 0.73549423E-07_JPRB, 0.71855446E-07_JPRB, &
  & 0.70681658E-07_JPRB, 0.69929555E-07_JPRB, 0.69435103E-07_JPRB, 0.69069003E-07_JPRB, 0.68774426E-07_JPRB, 0.68519178E-07_JPRB, &
  & 0.68315970E-07_JPRB, 0.68178565E-07_JPRB, 0.68160873E-07_JPRB, 0.68359448E-07_JPRB, 0.68947472E-07_JPRB, 0.69942168E-07_JPRB, &
  & 0.70630016E-07_JPRB, 0.70275732E-07_JPRB, 0.68697410E-07_JPRB, 0.65898327E-07_JPRB, 0.62003998E-07_JPRB, 0.57323437E-07_JPRB, &
  & 0.52262674E-07_JPRB, 0.47401009E-07_JPRB, 0.43195055E-07_JPRB, 0.40025288E-07_JPRB, 0.37965570E-07_JPRB, 0.36996560E-07_JPRB, &
  & 0.37032052E-07_JPRB, 0.37968974E-07_JPRB, 0.39786741E-07_JPRB, 0.42536087E-07_JPRB, 0.46193001E-07_JPRB, 0.50523209E-07_JPRB, &
  & 0.55234814E-07_JPRB, 0.60037344E-07_JPRB, 0.64849971E-07_JPRB, 0.69534053E-07_JPRB, 0.73999963E-07_JPRB, 0.78016903E-07_JPRB, &
  & 0.81175386E-07_JPRB, 0.83226524E-07_JPRB, 0.84103583E-07_JPRB, 0.84244007E-07_JPRB, 0.84147352E-07_JPRB, 0.84194625E-07_JPRB, &
  & 0.84478906E-07_JPRB, 0.84893401E-07_JPRB, 0.85348361E-07_JPRB, 0.85753136E-07_JPRB, 0.86115492E-07_JPRB, 0.86442682E-07_JPRB, &
  & 0.86747420E-07_JPRB, 0.87058226E-07_JPRB, 0.87373820E-07_JPRB, 0.87724324E-07_JPRB, 0.88074884E-07_JPRB, 0.88401642E-07_JPRB, &
  & 0.88698009E-07_JPRB, 0.88999194E-07_JPRB, 0.89414520E-07_JPRB, 0.90369547E-07_JPRB /)

RGHG7(:,61,12) = (/ &
  & 0.76320426E-07_JPRB, 0.74270062E-07_JPRB, 0.73155491E-07_JPRB, 0.71843651E-07_JPRB, 0.70458100E-07_JPRB, 0.69013566E-07_JPRB, &
  & 0.67897453E-07_JPRB, 0.67086340E-07_JPRB, 0.66477739E-07_JPRB, 0.66015438E-07_JPRB, 0.65610003E-07_JPRB, 0.65264160E-07_JPRB, &
  & 0.64956396E-07_JPRB, 0.64719330E-07_JPRB, 0.64590090E-07_JPRB, 0.64666402E-07_JPRB, 0.65124198E-07_JPRB, 0.65918741E-07_JPRB, &
  & 0.66453467E-07_JPRB, 0.66104285E-07_JPRB, 0.64656632E-07_JPRB, 0.62062128E-07_JPRB, 0.58464099E-07_JPRB, 0.54117429E-07_JPRB, &
  & 0.49456609E-07_JPRB, 0.45001133E-07_JPRB, 0.41190312E-07_JPRB, 0.38361062E-07_JPRB, 0.36558241E-07_JPRB, 0.35766380E-07_JPRB, &
  & 0.35900548E-07_JPRB, 0.36858925E-07_JPRB, 0.38621568E-07_JPRB, 0.41242650E-07_JPRB, 0.44721375E-07_JPRB, 0.48864052E-07_JPRB, &
  & 0.53366723E-07_JPRB, 0.58002211E-07_JPRB, 0.62624629E-07_JPRB, 0.67131126E-07_JPRB, 0.71393210E-07_JPRB, 0.75177248E-07_JPRB, &
  & 0.78205886E-07_JPRB, 0.80155132E-07_JPRB, 0.81105341E-07_JPRB, 0.81366117E-07_JPRB, 0.81420943E-07_JPRB, 0.81629082E-07_JPRB, &
  & 0.82051983E-07_JPRB, 0.82593964E-07_JPRB, 0.83121236E-07_JPRB, 0.83583728E-07_JPRB, 0.83977270E-07_JPRB, 0.84325208E-07_JPRB, &
  & 0.84646935E-07_JPRB, 0.84956341E-07_JPRB, 0.85283581E-07_JPRB, 0.85615028E-07_JPRB, 0.85951051E-07_JPRB, 0.86257835E-07_JPRB, &
  & 0.86528260E-07_JPRB, 0.86800775E-07_JPRB, 0.87161979E-07_JPRB, 0.88111847E-07_JPRB /)

RGHG7(:,62,12) = (/ &
  & 0.72991611E-07_JPRB, 0.70764507E-07_JPRB, 0.69691765E-07_JPRB, 0.68792389E-07_JPRB, 0.67721182E-07_JPRB, 0.66532792E-07_JPRB, &
  & 0.65447352E-07_JPRB, 0.64536323E-07_JPRB, 0.63798247E-07_JPRB, 0.63183258E-07_JPRB, 0.62662984E-07_JPRB, 0.62179893E-07_JPRB, &
  & 0.61754541E-07_JPRB, 0.61400343E-07_JPRB, 0.61167171E-07_JPRB, 0.61155177E-07_JPRB, 0.61507443E-07_JPRB, 0.62122616E-07_JPRB, &
  & 0.62513010E-07_JPRB, 0.62155110E-07_JPRB, 0.60804695E-07_JPRB, 0.58410929E-07_JPRB, 0.55098749E-07_JPRB, 0.51112583E-07_JPRB, &
  & 0.46852421E-07_JPRB, 0.42816851E-07_JPRB, 0.39411002E-07_JPRB, 0.36924387E-07_JPRB, 0.35373670E-07_JPRB, 0.34744751E-07_JPRB, &
  & 0.34961353E-07_JPRB, 0.35923581E-07_JPRB, 0.37608419E-07_JPRB, 0.40083453E-07_JPRB, 0.43370800E-07_JPRB, 0.47297807E-07_JPRB, &
  & 0.51621090E-07_JPRB, 0.56055956E-07_JPRB, 0.60517394E-07_JPRB, 0.64834232E-07_JPRB, 0.68898984E-07_JPRB, 0.72519690E-07_JPRB, &
  & 0.75377777E-07_JPRB, 0.77318902E-07_JPRB, 0.78310485E-07_JPRB, 0.78710194E-07_JPRB, 0.78913168E-07_JPRB, 0.79242376E-07_JPRB, &
  & 0.79800571E-07_JPRB, 0.80451315E-07_JPRB, 0.81080749E-07_JPRB, 0.81613770E-07_JPRB, 0.82058222E-07_JPRB, 0.82443407E-07_JPRB, &
  & 0.82787267E-07_JPRB, 0.83123879E-07_JPRB, 0.83457138E-07_JPRB, 0.83807819E-07_JPRB, 0.84148404E-07_JPRB, 0.84465839E-07_JPRB, &
  & 0.84748748E-07_JPRB, 0.85030521E-07_JPRB, 0.85400401E-07_JPRB, 0.86267100E-07_JPRB /)

RGHG7(:,63,12) = (/ &
  & 0.68783635E-07_JPRB, 0.67399775E-07_JPRB, 0.66726074E-07_JPRB, 0.66058334E-07_JPRB, 0.65203331E-07_JPRB, 0.64225027E-07_JPRB, &
  & 0.63196509E-07_JPRB, 0.62221432E-07_JPRB, 0.61304533E-07_JPRB, 0.60560318E-07_JPRB, 0.59860980E-07_JPRB, 0.59245700E-07_JPRB, &
  & 0.58677792E-07_JPRB, 0.58217292E-07_JPRB, 0.57907233E-07_JPRB, 0.57842765E-07_JPRB, 0.58104607E-07_JPRB, 0.58555202E-07_JPRB, &
  & 0.58809562E-07_JPRB, 0.58426536E-07_JPRB, 0.57167167E-07_JPRB, 0.54972546E-07_JPRB, 0.51947218E-07_JPRB, 0.48325106E-07_JPRB, &
  & 0.44487201E-07_JPRB, 0.40876490E-07_JPRB, 0.37884938E-07_JPRB, 0.35736036E-07_JPRB, 0.34433260E-07_JPRB, 0.33957111E-07_JPRB, &
  & 0.34244334E-07_JPRB, 0.35195516E-07_JPRB, 0.36786421E-07_JPRB, 0.39095546E-07_JPRB, 0.42171312E-07_JPRB, 0.45887319E-07_JPRB, &
  & 0.49999475E-07_JPRB, 0.54261680E-07_JPRB, 0.58530706E-07_JPRB, 0.62675397E-07_JPRB, 0.66569193E-07_JPRB, 0.70003026E-07_JPRB, &
  & 0.72771257E-07_JPRB, 0.74660946E-07_JPRB, 0.75742136E-07_JPRB, 0.76257066E-07_JPRB, 0.76593764E-07_JPRB, 0.77038692E-07_JPRB, &
  & 0.77679843E-07_JPRB, 0.78443982E-07_JPRB, 0.79166711E-07_JPRB, 0.79785217E-07_JPRB, 0.80298300E-07_JPRB, 0.80725215E-07_JPRB, &
  & 0.81116440E-07_JPRB, 0.81481538E-07_JPRB, 0.81847752E-07_JPRB, 0.82208558E-07_JPRB, 0.82566942E-07_JPRB, 0.82887162E-07_JPRB, &
  & 0.83169851E-07_JPRB, 0.83450011E-07_JPRB, 0.83813930E-07_JPRB, 0.84683158E-07_JPRB /)

RGHG7(:,64,12) = (/ &
  & 0.66118673E-07_JPRB, 0.64730663E-07_JPRB, 0.64093484E-07_JPRB, 0.63535872E-07_JPRB, 0.62920918E-07_JPRB, 0.62055584E-07_JPRB, &
  & 0.61082041E-07_JPRB, 0.60034949E-07_JPRB, 0.58967906E-07_JPRB, 0.58024117E-07_JPRB, 0.57215821E-07_JPRB, 0.56436544E-07_JPRB, &
  & 0.55778678E-07_JPRB, 0.55235716E-07_JPRB, 0.54888989E-07_JPRB, 0.54782163E-07_JPRB, 0.54951020E-07_JPRB, 0.55252045E-07_JPRB, &
  & 0.55384554E-07_JPRB, 0.54975736E-07_JPRB, 0.53799752E-07_JPRB, 0.51793918E-07_JPRB, 0.49063139E-07_JPRB, 0.45813415E-07_JPRB, &
  & 0.42405382E-07_JPRB, 0.39227789E-07_JPRB, 0.36649006E-07_JPRB, 0.34828382E-07_JPRB, 0.33765399E-07_JPRB, 0.33434944E-07_JPRB, &
  & 0.33784158E-07_JPRB, 0.34714333E-07_JPRB, 0.36198600E-07_JPRB, 0.38329148E-07_JPRB, 0.41187565E-07_JPRB, 0.44677364E-07_JPRB, &
  & 0.48571504E-07_JPRB, 0.52635261E-07_JPRB, 0.56716573E-07_JPRB, 0.60687420E-07_JPRB, 0.64397156E-07_JPRB, 0.67699169E-07_JPRB, &
  & 0.70347042E-07_JPRB, 0.72243765E-07_JPRB, 0.73378743E-07_JPRB, 0.74018537E-07_JPRB, 0.74471835E-07_JPRB, 0.75000749E-07_JPRB, &
  & 0.75711306E-07_JPRB, 0.76542975E-07_JPRB, 0.77367183E-07_JPRB, 0.78075750E-07_JPRB, 0.78660811E-07_JPRB, 0.79163598E-07_JPRB, &
  & 0.79597392E-07_JPRB, 0.80012256E-07_JPRB, 0.80406480E-07_JPRB, 0.80808462E-07_JPRB, 0.81185583E-07_JPRB, 0.81529059E-07_JPRB, &
  & 0.81831395E-07_JPRB, 0.82128494E-07_JPRB, 0.82503043E-07_JPRB, 0.83340396E-07_JPRB /)

RGHG7(:,65,12) = (/ &
  & 0.63243512E-07_JPRB, 0.62146675E-07_JPRB, 0.61662718E-07_JPRB, 0.61245721E-07_JPRB, 0.60671127E-07_JPRB, 0.59967313E-07_JPRB, &
  & 0.59028757E-07_JPRB, 0.57913965E-07_JPRB, 0.56670636E-07_JPRB, 0.55609718E-07_JPRB, 0.54656002E-07_JPRB, 0.53815661E-07_JPRB, &
  & 0.53080672E-07_JPRB, 0.52508721E-07_JPRB, 0.52140923E-07_JPRB, 0.51991236E-07_JPRB, 0.52069112E-07_JPRB, 0.52241237E-07_JPRB, &
  & 0.52268813E-07_JPRB, 0.51836015E-07_JPRB, 0.50741566E-07_JPRB, 0.48928570E-07_JPRB, 0.46493490E-07_JPRB, 0.43626997E-07_JPRB, &
  & 0.40643052E-07_JPRB, 0.37918220E-07_JPRB, 0.35726821E-07_JPRB, 0.34220800E-07_JPRB, 0.33386009E-07_JPRB, 0.33192233E-07_JPRB, &
  & 0.33596532E-07_JPRB, 0.34500747E-07_JPRB, 0.35876518E-07_JPRB, 0.37829796E-07_JPRB, 0.40465935E-07_JPRB, 0.43714184E-07_JPRB, &
  & 0.47376538E-07_JPRB, 0.51224681E-07_JPRB, 0.55105421E-07_JPRB, 0.58885231E-07_JPRB, 0.62435269E-07_JPRB, 0.65587102E-07_JPRB, &
  & 0.68163892E-07_JPRB, 0.70037451E-07_JPRB, 0.71250014E-07_JPRB, 0.71986143E-07_JPRB, 0.72546364E-07_JPRB, 0.73151028E-07_JPRB, &
  & 0.73898555E-07_JPRB, 0.74774569E-07_JPRB, 0.75663941E-07_JPRB, 0.76454853E-07_JPRB, 0.77128270E-07_JPRB, 0.77689414E-07_JPRB, &
  & 0.78199605E-07_JPRB, 0.78658822E-07_JPRB, 0.79110997E-07_JPRB, 0.79541003E-07_JPRB, 0.79952159E-07_JPRB, 0.80318124E-07_JPRB, &
  & 0.80643318E-07_JPRB, 0.80963510E-07_JPRB, 0.81364142E-07_JPRB, 0.82220112E-07_JPRB /)

RGHG7(:,66,12) = (/ &
  & 0.60988391E-07_JPRB, 0.59934912E-07_JPRB, 0.59449565E-07_JPRB, 0.59037710E-07_JPRB, 0.58598587E-07_JPRB, 0.57914512E-07_JPRB, &
  & 0.57012418E-07_JPRB, 0.55845501E-07_JPRB, 0.54424536E-07_JPRB, 0.53257150E-07_JPRB, 0.52253501E-07_JPRB, 0.51370478E-07_JPRB, &
  & 0.50625008E-07_JPRB, 0.50042608E-07_JPRB, 0.49665353E-07_JPRB, 0.49476228E-07_JPRB, 0.49475670E-07_JPRB, 0.49542233E-07_JPRB, &
  & 0.49483386E-07_JPRB, 0.49038356E-07_JPRB, 0.48031943E-07_JPRB, 0.46416218E-07_JPRB, 0.44280220E-07_JPRB, 0.41798081E-07_JPRB, &
  & 0.39238511E-07_JPRB, 0.36940321E-07_JPRB, 0.35119914E-07_JPRB, 0.33910950E-07_JPRB, 0.33286359E-07_JPRB, 0.33218246E-07_JPRB, &
  & 0.33672208E-07_JPRB, 0.34549736E-07_JPRB, 0.35822353E-07_JPRB, 0.37605243E-07_JPRB, 0.40022389E-07_JPRB, 0.43035399E-07_JPRB, &
  & 0.46448385E-07_JPRB, 0.50063296E-07_JPRB, 0.53717034E-07_JPRB, 0.57305307E-07_JPRB, 0.60678559E-07_JPRB, 0.63701151E-07_JPRB, &
  & 0.66193600E-07_JPRB, 0.68067422E-07_JPRB, 0.69326774E-07_JPRB, 0.70162272E-07_JPRB, 0.70809719E-07_JPRB, 0.71480208E-07_JPRB, &
  & 0.72257883E-07_JPRB, 0.73149721E-07_JPRB, 0.74071231E-07_JPRB, 0.74925531E-07_JPRB, 0.75663593E-07_JPRB, 0.76309682E-07_JPRB, &
  & 0.76876582E-07_JPRB, 0.77406646E-07_JPRB, 0.77901284E-07_JPRB, 0.78380189E-07_JPRB, 0.78824037E-07_JPRB, 0.79225345E-07_JPRB, &
  & 0.79583856E-07_JPRB, 0.79942474E-07_JPRB, 0.80389853E-07_JPRB, 0.81294957E-07_JPRB /)

RGHG7(:,67,12) = (/ &
  & 0.58847956E-07_JPRB, 0.57783083E-07_JPRB, 0.57331906E-07_JPRB, 0.56977008E-07_JPRB, 0.56515862E-07_JPRB, 0.55921038E-07_JPRB, &
  & 0.55017928E-07_JPRB, 0.53791901E-07_JPRB, 0.52270895E-07_JPRB, 0.51018727E-07_JPRB, 0.49995808E-07_JPRB, 0.49125347E-07_JPRB, &
  & 0.48397862E-07_JPRB, 0.47819356E-07_JPRB, 0.47450577E-07_JPRB, 0.47240377E-07_JPRB, 0.47182294E-07_JPRB, 0.47170467E-07_JPRB, &
  & 0.47052996E-07_JPRB, 0.46615355E-07_JPRB, 0.45705914E-07_JPRB, 0.44289902E-07_JPRB, 0.42452609E-07_JPRB, 0.40340723E-07_JPRB, &
  & 0.38195733E-07_JPRB, 0.36291510E-07_JPRB, 0.34816562E-07_JPRB, 0.33876368E-07_JPRB, 0.33441356E-07_JPRB, 0.33487261E-07_JPRB, &
  & 0.33986392E-07_JPRB, 0.34839470E-07_JPRB, 0.36018598E-07_JPRB, 0.37644160E-07_JPRB, 0.39860904E-07_JPRB, 0.42627708E-07_JPRB, &
  & 0.45791417E-07_JPRB, 0.49161020E-07_JPRB, 0.52586227E-07_JPRB, 0.55956392E-07_JPRB, 0.59156449E-07_JPRB, 0.62033976E-07_JPRB, &
  & 0.64455286E-07_JPRB, 0.66308338E-07_JPRB, 0.67619141E-07_JPRB, 0.68523725E-07_JPRB, 0.69252209E-07_JPRB, 0.69977496E-07_JPRB, &
  & 0.70780075E-07_JPRB, 0.71675544E-07_JPRB, 0.72609815E-07_JPRB, 0.73481985E-07_JPRB, 0.74280194E-07_JPRB, 0.74973713E-07_JPRB, &
  & 0.75614814E-07_JPRB, 0.76198226E-07_JPRB, 0.76750140E-07_JPRB, 0.77266023E-07_JPRB, 0.77747636E-07_JPRB, 0.78181294E-07_JPRB, &
  & 0.78579021E-07_JPRB, 0.78988919E-07_JPRB, 0.79510805E-07_JPRB, 0.80534591E-07_JPRB /)

RGHG7(:,68,12) = (/ &
  & 0.56805082E-07_JPRB, 0.55773693E-07_JPRB, 0.55318992E-07_JPRB, 0.54946415E-07_JPRB, 0.54553283E-07_JPRB, 0.53939736E-07_JPRB, &
  & 0.53051519E-07_JPRB, 0.51791236E-07_JPRB, 0.50194494E-07_JPRB, 0.48897675E-07_JPRB, 0.47915133E-07_JPRB, 0.47057490E-07_JPRB, &
  & 0.46396543E-07_JPRB, 0.45847418E-07_JPRB, 0.45496904E-07_JPRB, 0.45286235E-07_JPRB, 0.45195282E-07_JPRB, 0.45136716E-07_JPRB, &
  & 0.44988713E-07_JPRB, 0.44577444E-07_JPRB, 0.43777565E-07_JPRB, 0.42563418E-07_JPRB, 0.41012285E-07_JPRB, 0.39255568E-07_JPRB, &
  & 0.37482128E-07_JPRB, 0.35943930E-07_JPRB, 0.34778420E-07_JPRB, 0.34082564E-07_JPRB, 0.33819656E-07_JPRB, 0.33970604E-07_JPRB, &
  & 0.34511821E-07_JPRB, 0.35342715E-07_JPRB, 0.36436450E-07_JPRB, 0.37917072E-07_JPRB, 0.39944197E-07_JPRB, 0.42492726E-07_JPRB, &
  & 0.45402430E-07_JPRB, 0.48525500E-07_JPRB, 0.51707339E-07_JPRB, 0.54858187E-07_JPRB, 0.57864533E-07_JPRB, 0.60599142E-07_JPRB, &
  & 0.62935534E-07_JPRB, 0.64763562E-07_JPRB, 0.66098210E-07_JPRB, 0.67067283E-07_JPRB, 0.67853072E-07_JPRB, 0.68624999E-07_JPRB, &
  & 0.69446230E-07_JPRB, 0.70346438E-07_JPRB, 0.71268410E-07_JPRB, 0.72154876E-07_JPRB, 0.72963061E-07_JPRB, 0.73708250E-07_JPRB, &
  & 0.74387451E-07_JPRB, 0.75025184E-07_JPRB, 0.75617557E-07_JPRB, 0.76169023E-07_JPRB, 0.76680223E-07_JPRB, 0.77144627E-07_JPRB, &
  & 0.77579578E-07_JPRB, 0.78044955E-07_JPRB, 0.78667867E-07_JPRB, 0.79883641E-07_JPRB /)

RGHG7(:,69,12) = (/ &
  & 0.54923891E-07_JPRB, 0.53824898E-07_JPRB, 0.53353258E-07_JPRB, 0.52995990E-07_JPRB, 0.52564360E-07_JPRB, 0.51993577E-07_JPRB, &
  & 0.51096659E-07_JPRB, 0.49827609E-07_JPRB, 0.48201521E-07_JPRB, 0.46923002E-07_JPRB, 0.45998998E-07_JPRB, 0.45191264E-07_JPRB, &
  & 0.44590415E-07_JPRB, 0.44104759E-07_JPRB, 0.43793047E-07_JPRB, 0.43606509E-07_JPRB, 0.43511019E-07_JPRB, 0.43438074E-07_JPRB, &
  & 0.43288949E-07_JPRB, 0.42923663E-07_JPRB, 0.42239815E-07_JPRB, 0.41220488E-07_JPRB, 0.39940076E-07_JPRB, 0.38508741E-07_JPRB, &
  & 0.37075473E-07_JPRB, 0.35869057E-07_JPRB, 0.34984311E-07_JPRB, 0.34505415E-07_JPRB, 0.34397942E-07_JPRB, 0.34646067E-07_JPRB, &
  & 0.35227874E-07_JPRB, 0.36040625E-07_JPRB, 0.37057429E-07_JPRB, 0.38410626E-07_JPRB, 0.40262783E-07_JPRB, 0.42585995E-07_JPRB, &
  & 0.45262983E-07_JPRB, 0.48137672E-07_JPRB, 0.51077389E-07_JPRB, 0.54000708E-07_JPRB, 0.56805899E-07_JPRB, 0.59395056E-07_JPRB, &
  & 0.61628711E-07_JPRB, 0.63415150E-07_JPRB, 0.64759170E-07_JPRB, 0.65763217E-07_JPRB, 0.66597387E-07_JPRB, 0.67399569E-07_JPRB, &
  & 0.68231763E-07_JPRB, 0.69128838E-07_JPRB, 0.70041139E-07_JPRB, 0.70914737E-07_JPRB, 0.71736324E-07_JPRB, 0.72478542E-07_JPRB, &
  & 0.73193526E-07_JPRB, 0.73861592E-07_JPRB, 0.74481854E-07_JPRB, 0.75060036E-07_JPRB, 0.75588844E-07_JPRB, 0.76069703E-07_JPRB, &
  & 0.76535272E-07_JPRB, 0.77047993E-07_JPRB, 0.77781834E-07_JPRB, 0.79223426E-07_JPRB /)

RGHG7(:,70,12) = (/ &
  & 0.53070362E-07_JPRB, 0.51911101E-07_JPRB, 0.51417963E-07_JPRB, 0.51032995E-07_JPRB, 0.50635538E-07_JPRB, 0.50035222E-07_JPRB, &
  & 0.49145566E-07_JPRB, 0.47894428E-07_JPRB, 0.46307338E-07_JPRB, 0.45082299E-07_JPRB, 0.44234223E-07_JPRB, 0.43518693E-07_JPRB, &
  & 0.43000060E-07_JPRB, 0.42593090E-07_JPRB, 0.42334317E-07_JPRB, 0.42190429E-07_JPRB, 0.42115190E-07_JPRB, 0.42053511E-07_JPRB, &
  & 0.41927056E-07_JPRB, 0.41625551E-07_JPRB, 0.41060567E-07_JPRB, 0.40230919E-07_JPRB, 0.39197822E-07_JPRB, 0.38067316E-07_JPRB, &
  & 0.36938179E-07_JPRB, 0.36021973E-07_JPRB, 0.35393612E-07_JPRB, 0.35114134E-07_JPRB, 0.35149849E-07_JPRB, 0.35489244E-07_JPRB, &
  & 0.36109959E-07_JPRB, 0.36907746E-07_JPRB, 0.37853475E-07_JPRB, 0.39092662E-07_JPRB, 0.40775188E-07_JPRB, 0.42900446E-07_JPRB, &
  & 0.45352699E-07_JPRB, 0.47975526E-07_JPRB, 0.50677471E-07_JPRB, 0.53368115E-07_JPRB, 0.55977093E-07_JPRB, 0.58404062E-07_JPRB, &
  & 0.60529082E-07_JPRB, 0.62248269E-07_JPRB, 0.63582299E-07_JPRB, 0.64606752E-07_JPRB, 0.65465890E-07_JPRB, 0.66289765E-07_JPRB, &
  & 0.67126166E-07_JPRB, 0.68011545E-07_JPRB, 0.68906189E-07_JPRB, 0.69764837E-07_JPRB, 0.70565832E-07_JPRB, 0.71308484E-07_JPRB, &
  & 0.72019795E-07_JPRB, 0.72695926E-07_JPRB, 0.73336750E-07_JPRB, 0.73919892E-07_JPRB, 0.74454462E-07_JPRB, 0.74949071E-07_JPRB, &
  & 0.75421994E-07_JPRB, 0.75974718E-07_JPRB, 0.76797974E-07_JPRB, 0.78490579E-07_JPRB /)

RGHG7(:,71,12) = (/ &
  & 0.51275542E-07_JPRB, 0.50008676E-07_JPRB, 0.49472789E-07_JPRB, 0.49084576E-07_JPRB, 0.48654581E-07_JPRB, 0.48074252E-07_JPRB, &
  & 0.47197762E-07_JPRB, 0.45990706E-07_JPRB, 0.44496446E-07_JPRB, 0.43410054E-07_JPRB, 0.42634440E-07_JPRB, 0.42040543E-07_JPRB, &
  & 0.41609297E-07_JPRB, 0.41294555E-07_JPRB, 0.41106606E-07_JPRB, 0.41020453E-07_JPRB, 0.40987025E-07_JPRB, 0.40959854E-07_JPRB, &
  & 0.40875161E-07_JPRB, 0.40646317E-07_JPRB, 0.40203993E-07_JPRB, 0.39551367E-07_JPRB, 0.38748922E-07_JPRB, 0.37891720E-07_JPRB, &
  & 0.37048480E-07_JPRB, 0.36406149E-07_JPRB, 0.35999502E-07_JPRB, 0.35895575E-07_JPRB, 0.36060648E-07_JPRB, 0.36483875E-07_JPRB, &
  & 0.37141607E-07_JPRB, 0.37928341E-07_JPRB, 0.38816726E-07_JPRB, 0.39956255E-07_JPRB, 0.41486945E-07_JPRB, 0.43405915E-07_JPRB, &
  & 0.45626987E-07_JPRB, 0.48033538E-07_JPRB, 0.50479890E-07_JPRB, 0.52952252E-07_JPRB, 0.55356637E-07_JPRB, 0.57623009E-07_JPRB, &
  & 0.59611324E-07_JPRB, 0.61260543E-07_JPRB, 0.62557532E-07_JPRB, 0.63580721E-07_JPRB, 0.64454397E-07_JPRB, 0.65284340E-07_JPRB, &
  & 0.66111419E-07_JPRB, 0.66984235E-07_JPRB, 0.67852945E-07_JPRB, 0.68684102E-07_JPRB, 0.69462367E-07_JPRB, 0.70169698E-07_JPRB, &
  & 0.70871145E-07_JPRB, 0.71530465E-07_JPRB, 0.72165641E-07_JPRB, 0.72749593E-07_JPRB, 0.73285086E-07_JPRB, 0.73765371E-07_JPRB, &
  & 0.74250032E-07_JPRB, 0.74806408E-07_JPRB, 0.75693549E-07_JPRB, 0.77594301E-07_JPRB /)

RGHG7(:,72,12) = (/ &
  & 0.49469161E-07_JPRB, 0.48072234E-07_JPRB, 0.47498677E-07_JPRB, 0.47092779E-07_JPRB, 0.46684900E-07_JPRB, 0.46094556E-07_JPRB, &
  & 0.45245933E-07_JPRB, 0.44130196E-07_JPRB, 0.42838440E-07_JPRB, 0.41863309E-07_JPRB, 0.41244601E-07_JPRB, 0.40745100E-07_JPRB, &
  & 0.40425988E-07_JPRB, 0.40207208E-07_JPRB, 0.40094971E-07_JPRB, 0.40073658E-07_JPRB, 0.40096776E-07_JPRB, 0.40118252E-07_JPRB, &
  & 0.40088942E-07_JPRB, 0.39943668E-07_JPRB, 0.39623487E-07_JPRB, 0.39146084E-07_JPRB, 0.38554060E-07_JPRB, 0.37952290E-07_JPRB, &
  & 0.37363545E-07_JPRB, 0.36949590E-07_JPRB, 0.36752201E-07_JPRB, 0.36812615E-07_JPRB, 0.37098236E-07_JPRB, 0.37600071E-07_JPRB, &
  & 0.38291148E-07_JPRB, 0.39067483E-07_JPRB, 0.39910269E-07_JPRB, 0.40951452E-07_JPRB, 0.42354397E-07_JPRB, 0.44089248E-07_JPRB, &
  & 0.46090214E-07_JPRB, 0.48267371E-07_JPRB, 0.50480235E-07_JPRB, 0.52726428E-07_JPRB, 0.54933146E-07_JPRB, 0.57021744E-07_JPRB, &
  & 0.58874729E-07_JPRB, 0.60426089E-07_JPRB, 0.61678278E-07_JPRB, 0.62685800E-07_JPRB, 0.63555788E-07_JPRB, 0.64373886E-07_JPRB, &
  & 0.65196652E-07_JPRB, 0.66036549E-07_JPRB, 0.66880332E-07_JPRB, 0.67673334E-07_JPRB, 0.68401874E-07_JPRB, 0.69085139E-07_JPRB, &
  & 0.69734106E-07_JPRB, 0.70382505E-07_JPRB, 0.70991753E-07_JPRB, 0.71569282E-07_JPRB, 0.72082457E-07_JPRB, 0.72562578E-07_JPRB, &
  & 0.73024921E-07_JPRB, 0.73577610E-07_JPRB, 0.74483573E-07_JPRB, 0.76498431E-07_JPRB /)

RGHG7(:,73,12) = (/ &
  & 0.47559020E-07_JPRB, 0.46060840E-07_JPRB, 0.45475634E-07_JPRB, 0.45092317E-07_JPRB, 0.44687567E-07_JPRB, 0.44138410E-07_JPRB, &
  & 0.43367404E-07_JPRB, 0.42384624E-07_JPRB, 0.41282370E-07_JPRB, 0.40535696E-07_JPRB, 0.39985725E-07_JPRB, 0.39644824E-07_JPRB, &
  & 0.39413088E-07_JPRB, 0.39296140E-07_JPRB, 0.39272877E-07_JPRB, 0.39324302E-07_JPRB, 0.39411926E-07_JPRB, 0.39493475E-07_JPRB, &
  & 0.39532949E-07_JPRB, 0.39477580E-07_JPRB, 0.39283943E-07_JPRB, 0.38974022E-07_JPRB, 0.38587562E-07_JPRB, 0.38209190E-07_JPRB, &
  & 0.37868396E-07_JPRB, 0.37672194E-07_JPRB, 0.37659806E-07_JPRB, 0.37863366E-07_JPRB, 0.38254807E-07_JPRB, 0.38825892E-07_JPRB, &
  & 0.39546947E-07_JPRB, 0.40318191E-07_JPRB, 0.41131909E-07_JPRB, 0.42083165E-07_JPRB, 0.43393452E-07_JPRB, 0.44900592E-07_JPRB, &
  & 0.46724058E-07_JPRB, 0.48657579E-07_JPRB, 0.50648044E-07_JPRB, 0.52676175E-07_JPRB, 0.54683461E-07_JPRB, 0.56584849E-07_JPRB, &
  & 0.58295452E-07_JPRB, 0.59740195E-07_JPRB, 0.60933182E-07_JPRB, 0.61907215E-07_JPRB, 0.62766674E-07_JPRB, 0.63570404E-07_JPRB, &
  & 0.64362069E-07_JPRB, 0.65180849E-07_JPRB, 0.65973737E-07_JPRB, 0.66727139E-07_JPRB, 0.67424430E-07_JPRB, 0.68040464E-07_JPRB, &
  & 0.68670687E-07_JPRB, 0.69257602E-07_JPRB, 0.69859048E-07_JPRB, 0.70401626E-07_JPRB, 0.70906950E-07_JPRB, 0.71356553E-07_JPRB, &
  & 0.71804465E-07_JPRB, 0.72321953E-07_JPRB, 0.73222807E-07_JPRB, 0.75264552E-07_JPRB /)

RGHG7(:,74,12) = (/ &
  & 0.45483400E-07_JPRB, 0.43986820E-07_JPRB, 0.43442846E-07_JPRB, 0.43091021E-07_JPRB, 0.42746507E-07_JPRB, 0.42257753E-07_JPRB, &
  & 0.41591264E-07_JPRB, 0.40771155E-07_JPRB, 0.39918994E-07_JPRB, 0.39287105E-07_JPRB, 0.38932793E-07_JPRB, 0.38678557E-07_JPRB, &
  & 0.38569112E-07_JPRB, 0.38547601E-07_JPRB, 0.38611027E-07_JPRB, 0.38740772E-07_JPRB, 0.38899703E-07_JPRB, 0.39053734E-07_JPRB, &
  & 0.39167126E-07_JPRB, 0.39209215E-07_JPRB, 0.39144627E-07_JPRB, 0.38999161E-07_JPRB, 0.38810082E-07_JPRB, 0.38631669E-07_JPRB, &
  & 0.38493500E-07_JPRB, 0.38494587E-07_JPRB, 0.38645201E-07_JPRB, 0.38982755E-07_JPRB, 0.39473164E-07_JPRB, 0.40107409E-07_JPRB, &
  & 0.40852743E-07_JPRB, 0.41621039E-07_JPRB, 0.42405190E-07_JPRB, 0.43302194E-07_JPRB, 0.44516440E-07_JPRB, 0.45826205E-07_JPRB, &
  & 0.47521372E-07_JPRB, 0.49170179E-07_JPRB, 0.50962186E-07_JPRB, 0.52778670E-07_JPRB, 0.54574858E-07_JPRB, 0.56303701E-07_JPRB, &
  & 0.57846741E-07_JPRB, 0.59190732E-07_JPRB, 0.60305155E-07_JPRB, 0.61249558E-07_JPRB, 0.62076310E-07_JPRB, 0.62854696E-07_JPRB, &
  & 0.63631283E-07_JPRB, 0.64391585E-07_JPRB, 0.65155568E-07_JPRB, 0.65861819E-07_JPRB, 0.66494174E-07_JPRB, 0.67096479E-07_JPRB, &
  & 0.67657837E-07_JPRB, 0.68234989E-07_JPRB, 0.68779670E-07_JPRB, 0.69309486E-07_JPRB, 0.69775915E-07_JPRB, 0.70206653E-07_JPRB, &
  & 0.70622235E-07_JPRB, 0.71094021E-07_JPRB, 0.71956855E-07_JPRB, 0.73960351E-07_JPRB /)

RGHG7(:,75,12) = (/ &
  & 0.43446736E-07_JPRB, 0.41955715E-07_JPRB, 0.41434532E-07_JPRB, 0.41148255E-07_JPRB, 0.40863593E-07_JPRB, 0.40484039E-07_JPRB, &
  & 0.39960952E-07_JPRB, 0.39326203E-07_JPRB, 0.38648061E-07_JPRB, 0.38230056E-07_JPRB, 0.37963172E-07_JPRB, 0.37856378E-07_JPRB, &
  & 0.37845549E-07_JPRB, 0.37924142E-07_JPRB, 0.38082131E-07_JPRB, 0.38295870E-07_JPRB, 0.38531560E-07_JPRB, 0.38760277E-07_JPRB, &
  & 0.38957513E-07_JPRB, 0.39101920E-07_JPRB, 0.39168320E-07_JPRB, 0.39179081E-07_JPRB, 0.39186478E-07_JPRB, 0.39186279E-07_JPRB, &
  & 0.39258975E-07_JPRB, 0.39441808E-07_JPRB, 0.39750766E-07_JPRB, 0.40204128E-07_JPRB, 0.40777120E-07_JPRB, 0.41462620E-07_JPRB, &
  & 0.42227825E-07_JPRB, 0.42999769E-07_JPRB, 0.43771585E-07_JPRB, 0.44632262E-07_JPRB, 0.45707782E-07_JPRB, 0.46867019E-07_JPRB, &
  & 0.48387392E-07_JPRB, 0.49814041E-07_JPRB, 0.51391854E-07_JPRB, 0.52996697E-07_JPRB, 0.54599774E-07_JPRB, 0.56129409E-07_JPRB, &
  & 0.57532944E-07_JPRB, 0.58744991E-07_JPRB, 0.59792441E-07_JPRB, 0.60680968E-07_JPRB, 0.61484243E-07_JPRB, 0.62235742E-07_JPRB, &
  & 0.62958947E-07_JPRB, 0.63693101E-07_JPRB, 0.64397817E-07_JPRB, 0.65060064E-07_JPRB, 0.65677071E-07_JPRB, 0.66216018E-07_JPRB, &
  & 0.66766304E-07_JPRB, 0.67281668E-07_JPRB, 0.67807591E-07_JPRB, 0.68292366E-07_JPRB, 0.68726969E-07_JPRB, 0.69123836E-07_JPRB, &
  & 0.69508701E-07_JPRB, 0.69918855E-07_JPRB, 0.70722344E-07_JPRB, 0.72631558E-07_JPRB /)

RGHG7(:,76,12) = (/ &
  & 0.41409898E-07_JPRB, 0.39942382E-07_JPRB, 0.39482490E-07_JPRB, 0.39259767E-07_JPRB, 0.39073829E-07_JPRB, 0.38808544E-07_JPRB, &
  & 0.38443520E-07_JPRB, 0.37988322E-07_JPRB, 0.37517868E-07_JPRB, 0.37237577E-07_JPRB, 0.37140637E-07_JPRB, 0.37147721E-07_JPRB, &
  & 0.37243044E-07_JPRB, 0.37424517E-07_JPRB, 0.37665995E-07_JPRB, 0.37961254E-07_JPRB, 0.38274123E-07_JPRB, 0.38582634E-07_JPRB, &
  & 0.38867213E-07_JPRB, 0.39118508E-07_JPRB, 0.39316937E-07_JPRB, 0.39475260E-07_JPRB, 0.39674521E-07_JPRB, 0.39835061E-07_JPRB, &
  & 0.40082561E-07_JPRB, 0.40403620E-07_JPRB, 0.40839577E-07_JPRB, 0.41392269E-07_JPRB, 0.42037748E-07_JPRB, 0.42766317E-07_JPRB, &
  & 0.43547075E-07_JPRB, 0.44323095E-07_JPRB, 0.45090534E-07_JPRB, 0.45930282E-07_JPRB, 0.46907228E-07_JPRB, 0.48007976E-07_JPRB, &
  & 0.49268611E-07_JPRB, 0.50561876E-07_JPRB, 0.51914380E-07_JPRB, 0.53310274E-07_JPRB, 0.54710974E-07_JPRB, 0.56070256E-07_JPRB, &
  & 0.57303993E-07_JPRB, 0.58406297E-07_JPRB, 0.59365330E-07_JPRB, 0.60209857E-07_JPRB, 0.60969469E-07_JPRB, 0.61690812E-07_JPRB, &
  & 0.62387336E-07_JPRB, 0.63063325E-07_JPRB, 0.63729416E-07_JPRB, 0.64352712E-07_JPRB, 0.64912058E-07_JPRB, 0.65441768E-07_JPRB, &
  & 0.65943162E-07_JPRB, 0.66439178E-07_JPRB, 0.66914879E-07_JPRB, 0.67361100E-07_JPRB, 0.67760553E-07_JPRB, 0.68111277E-07_JPRB, &
  & 0.68467628E-07_JPRB, 0.68813186E-07_JPRB, 0.69533087E-07_JPRB, 0.71311803E-07_JPRB /)

RGHG7(:,77,12) = (/ &
  & 0.39414804E-07_JPRB, 0.38015060E-07_JPRB, 0.37611944E-07_JPRB, 0.37467675E-07_JPRB, 0.37368139E-07_JPRB, 0.37231114E-07_JPRB, &
  & 0.37028716E-07_JPRB, 0.36760120E-07_JPRB, 0.36488171E-07_JPRB, 0.36388450E-07_JPRB, 0.36428570E-07_JPRB, 0.36541817E-07_JPRB, &
  & 0.36753111E-07_JPRB, 0.37014647E-07_JPRB, 0.37345163E-07_JPRB, 0.37714297E-07_JPRB, 0.38102090E-07_JPRB, 0.38489752E-07_JPRB, &
  & 0.38863678E-07_JPRB, 0.39220932E-07_JPRB, 0.39551562E-07_JPRB, 0.39852008E-07_JPRB, 0.40223711E-07_JPRB, 0.40542588E-07_JPRB, &
  & 0.40949494E-07_JPRB, 0.41440671E-07_JPRB, 0.42005244E-07_JPRB, 0.42650662E-07_JPRB, 0.43359762E-07_JPRB, 0.44122181E-07_JPRB, &
  & 0.44914049E-07_JPRB, 0.45699405E-07_JPRB, 0.46469243E-07_JPRB, 0.47270071E-07_JPRB, 0.48140567E-07_JPRB, 0.49127511E-07_JPRB, &
  & 0.50180962E-07_JPRB, 0.51328438E-07_JPRB, 0.52502752E-07_JPRB, 0.53689334E-07_JPRB, 0.54899449E-07_JPRB, 0.56073084E-07_JPRB, &
  & 0.57167838E-07_JPRB, 0.58144359E-07_JPRB, 0.59019520E-07_JPRB, 0.59808094E-07_JPRB, 0.60537097E-07_JPRB, 0.61218699E-07_JPRB, &
  & 0.61872512E-07_JPRB, 0.62510594E-07_JPRB, 0.63128439E-07_JPRB, 0.63704377E-07_JPRB, 0.64251459E-07_JPRB, 0.64738636E-07_JPRB, &
  & 0.65217932E-07_JPRB, 0.65673547E-07_JPRB, 0.66107127E-07_JPRB, 0.66514545E-07_JPRB, 0.66866775E-07_JPRB, 0.67177055E-07_JPRB, &
  & 0.67505383E-07_JPRB, 0.67773968E-07_JPRB, 0.68409733E-07_JPRB, 0.70011595E-07_JPRB /)

RGHG7(:,78,12) = (/ &
  & 0.37469228E-07_JPRB, 0.36239662E-07_JPRB, 0.35941191E-07_JPRB, 0.35873711E-07_JPRB, 0.35865124E-07_JPRB, 0.35837669E-07_JPRB, &
  & 0.35781600E-07_JPRB, 0.35710126E-07_JPRB, 0.35630631E-07_JPRB, 0.35694026E-07_JPRB, 0.35852469E-07_JPRB, 0.36091468E-07_JPRB, &
  & 0.36373144E-07_JPRB, 0.36719904E-07_JPRB, 0.37109412E-07_JPRB, 0.37538410E-07_JPRB, 0.37989345E-07_JPRB, 0.38449350E-07_JPRB, &
  & 0.38909096E-07_JPRB, 0.39367322E-07_JPRB, 0.39816445E-07_JPRB, 0.40252985E-07_JPRB, 0.40753161E-07_JPRB, 0.41225555E-07_JPRB, &
  & 0.41737376E-07_JPRB, 0.42308258E-07_JPRB, 0.42938165E-07_JPRB, 0.43626006E-07_JPRB, 0.44361062E-07_JPRB, 0.45135611E-07_JPRB, &
  & 0.45934293E-07_JPRB, 0.46732254E-07_JPRB, 0.47517293E-07_JPRB, 0.48332367E-07_JPRB, 0.49206609E-07_JPRB, 0.50110355E-07_JPRB, &
  & 0.51078011E-07_JPRB, 0.52030266E-07_JPRB, 0.53073812E-07_JPRB, 0.54101477E-07_JPRB, 0.55117741E-07_JPRB, 0.56133100E-07_JPRB, &
  & 0.57085622E-07_JPRB, 0.57954768E-07_JPRB, 0.58757493E-07_JPRB, 0.59488290E-07_JPRB, 0.60183709E-07_JPRB, 0.60833941E-07_JPRB, &
  & 0.61461691E-07_JPRB, 0.62065361E-07_JPRB, 0.62646372E-07_JPRB, 0.63191322E-07_JPRB, 0.63693989E-07_JPRB, 0.64160353E-07_JPRB, &
  & 0.64607995E-07_JPRB, 0.65026533E-07_JPRB, 0.65421006E-07_JPRB, 0.65774913E-07_JPRB, 0.66106026E-07_JPRB, 0.66356058E-07_JPRB, &
  & 0.66660419E-07_JPRB, 0.66865340E-07_JPRB, 0.67367182E-07_JPRB, 0.68741180E-07_JPRB /)

RGHG7(:,79,12) = (/ &
  & 0.35868176E-07_JPRB, 0.35050181E-07_JPRB, 0.34914400E-07_JPRB, 0.34941500E-07_JPRB, 0.34993327E-07_JPRB, 0.35042525E-07_JPRB, &
  & 0.35085346E-07_JPRB, 0.35117598E-07_JPRB, 0.35172238E-07_JPRB, 0.35338282E-07_JPRB, 0.35573716E-07_JPRB, 0.35851489E-07_JPRB, &
  & 0.36188911E-07_JPRB, 0.36567208E-07_JPRB, 0.36989807E-07_JPRB, 0.37447862E-07_JPRB, 0.37931635E-07_JPRB, 0.38432979E-07_JPRB, &
  & 0.38942815E-07_JPRB, 0.39460041E-07_JPRB, 0.39978488E-07_JPRB, 0.40496410E-07_JPRB, 0.41033918E-07_JPRB, 0.41588454E-07_JPRB, &
  & 0.42140570E-07_JPRB, 0.42756831E-07_JPRB, 0.43423810E-07_JPRB, 0.44131504E-07_JPRB, 0.44878963E-07_JPRB, 0.45659153E-07_JPRB, &
  & 0.46462347E-07_JPRB, 0.47265885E-07_JPRB, 0.48064564E-07_JPRB, 0.48890477E-07_JPRB, 0.49738379E-07_JPRB, 0.50631321E-07_JPRB, &
  & 0.51567699E-07_JPRB, 0.52503182E-07_JPRB, 0.53428042E-07_JPRB, 0.54396299E-07_JPRB, 0.55299548E-07_JPRB, 0.56181911E-07_JPRB, &
  & 0.57050372E-07_JPRB, 0.57852102E-07_JPRB, 0.58597575E-07_JPRB, 0.59312427E-07_JPRB, 0.59988231E-07_JPRB, 0.60629148E-07_JPRB, &
  & 0.61246240E-07_JPRB, 0.61834641E-07_JPRB, 0.62400218E-07_JPRB, 0.62920925E-07_JPRB, 0.63417524E-07_JPRB, 0.63860426E-07_JPRB, &
  & 0.64286240E-07_JPRB, 0.64669784E-07_JPRB, 0.65037277E-07_JPRB, 0.65340572E-07_JPRB, 0.65658156E-07_JPRB, 0.65849662E-07_JPRB, &
  & 0.66142441E-07_JPRB, 0.66270957E-07_JPRB, 0.66615016E-07_JPRB, 0.67610600E-07_JPRB /)

RGHG7(:,80,12) = (/ &
  & 0.34981717E-07_JPRB, 0.34567172E-07_JPRB, 0.34532665E-07_JPRB, 0.34606625E-07_JPRB, 0.34680735E-07_JPRB, 0.34750418E-07_JPRB, &
  & 0.34819241E-07_JPRB, 0.34900467E-07_JPRB, 0.34994212E-07_JPRB, 0.35171592E-07_JPRB, 0.35438681E-07_JPRB, 0.35744616E-07_JPRB, &
  & 0.36101945E-07_JPRB, 0.36499490E-07_JPRB, 0.36936495E-07_JPRB, 0.37406991E-07_JPRB, 0.37903373E-07_JPRB, 0.38418815E-07_JPRB, &
  & 0.38947178E-07_JPRB, 0.39489713E-07_JPRB, 0.40033985E-07_JPRB, 0.40590624E-07_JPRB, 0.41156451E-07_JPRB, 0.41739582E-07_JPRB, &
  & 0.42326942E-07_JPRB, 0.42960814E-07_JPRB, 0.43640647E-07_JPRB, 0.44356323E-07_JPRB, 0.45108781E-07_JPRB, 0.45893877E-07_JPRB, &
  & 0.46699750E-07_JPRB, 0.47507893E-07_JPRB, 0.48314355E-07_JPRB, 0.49144685E-07_JPRB, 0.50000740E-07_JPRB, 0.50902269E-07_JPRB, &
  & 0.51772510E-07_JPRB, 0.52702781E-07_JPRB, 0.53561163E-07_JPRB, 0.54483504E-07_JPRB, 0.55374457E-07_JPRB, 0.56196669E-07_JPRB, &
  & 0.57019992E-07_JPRB, 0.57804769E-07_JPRB, 0.58539737E-07_JPRB, 0.59232644E-07_JPRB, 0.59905119E-07_JPRB, 0.60538838E-07_JPRB, &
  & 0.61150857E-07_JPRB, 0.61731271E-07_JPRB, 0.62291285E-07_JPRB, 0.62803636E-07_JPRB, 0.63295509E-07_JPRB, 0.63725885E-07_JPRB, &
  & 0.64161220E-07_JPRB, 0.64520556E-07_JPRB, 0.64904214E-07_JPRB, 0.65168557E-07_JPRB, 0.65509404E-07_JPRB, 0.65667209E-07_JPRB, &
  & 0.65949422E-07_JPRB, 0.66067003E-07_JPRB, 0.66277082E-07_JPRB, 0.66915767E-07_JPRB /)

RGHG7(:,81,12) = (/ &
  & 0.34342886E-07_JPRB, 0.34273871E-07_JPRB, 0.34312148E-07_JPRB, 0.34416683E-07_JPRB, 0.34493478E-07_JPRB, 0.34579820E-07_JPRB, &
  & 0.34670219E-07_JPRB, 0.34771748E-07_JPRB, 0.34889414E-07_JPRB, 0.35116660E-07_JPRB, 0.35384186E-07_JPRB, 0.35702751E-07_JPRB, &
  & 0.36066538E-07_JPRB, 0.36470556E-07_JPRB, 0.36914034E-07_JPRB, 0.37389640E-07_JPRB, 0.37892686E-07_JPRB, 0.38417546E-07_JPRB, &
  & 0.38959140E-07_JPRB, 0.39510560E-07_JPRB, 0.40077516E-07_JPRB, 0.40637357E-07_JPRB, 0.41230273E-07_JPRB, 0.41794276E-07_JPRB, &
  & 0.42413927E-07_JPRB, 0.43045670E-07_JPRB, 0.43730005E-07_JPRB, 0.44452253E-07_JPRB, 0.45209340E-07_JPRB, 0.45997133E-07_JPRB, &
  & 0.46806697E-07_JPRB, 0.47618901E-07_JPRB, 0.48432412E-07_JPRB, 0.49264916E-07_JPRB, 0.50125212E-07_JPRB, 0.50998985E-07_JPRB, &
  & 0.51900624E-07_JPRB, 0.52789456E-07_JPRB, 0.53690083E-07_JPRB, 0.54519877E-07_JPRB, 0.55431091E-07_JPRB, 0.56226703E-07_JPRB, &
  & 0.57008229E-07_JPRB, 0.57790690E-07_JPRB, 0.58506480E-07_JPRB, 0.59205203E-07_JPRB, 0.59863154E-07_JPRB, 0.60501840E-07_JPRB, &
  & 0.61109539E-07_JPRB, 0.61688681E-07_JPRB, 0.62246215E-07_JPRB, 0.62753529E-07_JPRB, 0.63248144E-07_JPRB, 0.63668494E-07_JPRB, &
  & 0.64108299E-07_JPRB, 0.64443114E-07_JPRB, 0.64838723E-07_JPRB, 0.65075348E-07_JPRB, 0.65421517E-07_JPRB, 0.65575541E-07_JPRB, &
  & 0.65831621E-07_JPRB, 0.65979584E-07_JPRB, 0.66080652E-07_JPRB, 0.66485491E-07_JPRB /)

RGHG7(:,82,12) = (/ &
  & 0.34061603E-07_JPRB, 0.34189853E-07_JPRB, 0.34268044E-07_JPRB, 0.34384335E-07_JPRB, 0.34447037E-07_JPRB, 0.34540601E-07_JPRB, &
  & 0.34634063E-07_JPRB, 0.34742975E-07_JPRB, 0.34873921E-07_JPRB, 0.35063291E-07_JPRB, 0.35358266E-07_JPRB, 0.35669355E-07_JPRB, &
  & 0.36045545E-07_JPRB, 0.36455262E-07_JPRB, 0.36901227E-07_JPRB, 0.37381735E-07_JPRB, 0.37887116E-07_JPRB, 0.38413081E-07_JPRB, &
  & 0.38954017E-07_JPRB, 0.39514873E-07_JPRB, 0.40074287E-07_JPRB, 0.40655571E-07_JPRB, 0.41245993E-07_JPRB, 0.41824094E-07_JPRB, &
  & 0.42452303E-07_JPRB, 0.43086406E-07_JPRB, 0.43769496E-07_JPRB, 0.44496598E-07_JPRB, 0.45254545E-07_JPRB, 0.46045884E-07_JPRB, &
  & 0.46858332E-07_JPRB, 0.47676245E-07_JPRB, 0.48495480E-07_JPRB, 0.49334762E-07_JPRB, 0.50198572E-07_JPRB, 0.51073719E-07_JPRB, &
  & 0.51973274E-07_JPRB, 0.52821623E-07_JPRB, 0.53738006E-07_JPRB, 0.54553102E-07_JPRB, 0.55413341E-07_JPRB, 0.56265026E-07_JPRB, &
  & 0.56989947E-07_JPRB, 0.57784810E-07_JPRB, 0.58504572E-07_JPRB, 0.59191429E-07_JPRB, 0.59855438E-07_JPRB, 0.60485810E-07_JPRB, &
  & 0.61092024E-07_JPRB, 0.61668239E-07_JPRB, 0.62221638E-07_JPRB, 0.62730905E-07_JPRB, 0.63220604E-07_JPRB, 0.63644144E-07_JPRB, &
  & 0.64082514E-07_JPRB, 0.64422728E-07_JPRB, 0.64811751E-07_JPRB, 0.65062999E-07_JPRB, 0.65379453E-07_JPRB, 0.65576337E-07_JPRB, &
  & 0.65764610E-07_JPRB, 0.65990747E-07_JPRB, 0.65990506E-07_JPRB, 0.66237078E-07_JPRB /)

RGHG7(:,83,12) = (/ &
  & 0.34147654E-07_JPRB, 0.34100751E-07_JPRB, 0.34228719E-07_JPRB, 0.34325673E-07_JPRB, 0.34367641E-07_JPRB, 0.34483197E-07_JPRB, &
  & 0.34580577E-07_JPRB, 0.34696594E-07_JPRB, 0.34825607E-07_JPRB, 0.35069945E-07_JPRB, 0.35334399E-07_JPRB, 0.35672475E-07_JPRB, &
  & 0.36029498E-07_JPRB, 0.36446945E-07_JPRB, 0.36894708E-07_JPRB, 0.37375660E-07_JPRB, 0.37883499E-07_JPRB, 0.38411766E-07_JPRB, &
  & 0.38960813E-07_JPRB, 0.39515538E-07_JPRB, 0.40092242E-07_JPRB, 0.40668883E-07_JPRB, 0.41247528E-07_JPRB, 0.41851926E-07_JPRB, &
  & 0.42446246E-07_JPRB, 0.43109505E-07_JPRB, 0.43783952E-07_JPRB, 0.44512579E-07_JPRB, 0.45276881E-07_JPRB, 0.46069783E-07_JPRB, &
  & 0.46886566E-07_JPRB, 0.47711207E-07_JPRB, 0.48537050E-07_JPRB, 0.49386756E-07_JPRB, 0.50244175E-07_JPRB, 0.51126396E-07_JPRB, &
  & 0.51999820E-07_JPRB, 0.52890616E-07_JPRB, 0.53740269E-07_JPRB, 0.54627552E-07_JPRB, 0.55384803E-07_JPRB, 0.56290261E-07_JPRB, &
  & 0.56997621E-07_JPRB, 0.57776191E-07_JPRB, 0.58509848E-07_JPRB, 0.59188775E-07_JPRB, 0.59850741E-07_JPRB, 0.60481945E-07_JPRB, &
  & 0.61083995E-07_JPRB, 0.61660096E-07_JPRB, 0.62208485E-07_JPRB, 0.62724538E-07_JPRB, 0.63201277E-07_JPRB, 0.63640762E-07_JPRB, &
  & 0.64053232E-07_JPRB, 0.64420441E-07_JPRB, 0.64765480E-07_JPRB, 0.65068448E-07_JPRB, 0.65315206E-07_JPRB, 0.65594037E-07_JPRB, &
  & 0.65687210E-07_JPRB, 0.66014550E-07_JPRB, 0.65937002E-07_JPRB, 0.66252404E-07_JPRB /)

RGHG7(:,84,12) = (/ &
  & 0.34123424E-07_JPRB, 0.34028680E-07_JPRB, 0.34264509E-07_JPRB, 0.34303380E-07_JPRB, 0.34350368E-07_JPRB, 0.34497980E-07_JPRB, &
  & 0.34576203E-07_JPRB, 0.34698147E-07_JPRB, 0.34851098E-07_JPRB, 0.35040586E-07_JPRB, 0.35342751E-07_JPRB, 0.35641122E-07_JPRB, &
  & 0.36022048E-07_JPRB, 0.36430144E-07_JPRB, 0.36886224E-07_JPRB, 0.37372196E-07_JPRB, 0.37880792E-07_JPRB, 0.38407656E-07_JPRB, &
  & 0.38953850E-07_JPRB, 0.39510276E-07_JPRB, 0.40079637E-07_JPRB, 0.40664453E-07_JPRB, 0.41234248E-07_JPRB, 0.41858428E-07_JPRB, &
  & 0.42453330E-07_JPRB, 0.43110592E-07_JPRB, 0.43795591E-07_JPRB, 0.44518579E-07_JPRB, 0.45284494E-07_JPRB, 0.46080995E-07_JPRB, &
  & 0.46901427E-07_JPRB, 0.47731746E-07_JPRB, 0.48568609E-07_JPRB, 0.49421725E-07_JPRB, 0.50283841E-07_JPRB, 0.51166449E-07_JPRB, &
  & 0.52033990E-07_JPRB, 0.52936151E-07_JPRB, 0.53737043E-07_JPRB, 0.54679102E-07_JPRB, 0.55384966E-07_JPRB, 0.56283607E-07_JPRB, &
  & 0.57020678E-07_JPRB, 0.57774763E-07_JPRB, 0.58522247E-07_JPRB, 0.59199049E-07_JPRB, 0.59858309E-07_JPRB, 0.60484723E-07_JPRB, &
  & 0.61082837E-07_JPRB, 0.61660288E-07_JPRB, 0.62198616E-07_JPRB, 0.62724638E-07_JPRB, 0.63183158E-07_JPRB, 0.63648216E-07_JPRB, &
  & 0.64027596E-07_JPRB, 0.64442588E-07_JPRB, 0.64728312E-07_JPRB, 0.65105567E-07_JPRB, 0.65262988E-07_JPRB, 0.65639860E-07_JPRB, &
  & 0.65628114E-07_JPRB, 0.66043967E-07_JPRB, 0.65894973E-07_JPRB, 0.66263297E-07_JPRB /)

RGHG7(:,85,12) = (/ &
  & 0.34145380E-07_JPRB, 0.33949327E-07_JPRB, 0.34308016E-07_JPRB, 0.34214992E-07_JPRB, 0.34333695E-07_JPRB, 0.34481388E-07_JPRB, &
  & 0.34533546E-07_JPRB, 0.34701714E-07_JPRB, 0.34840735E-07_JPRB, 0.35084692E-07_JPRB, 0.35338818E-07_JPRB, 0.35657717E-07_JPRB, &
  & 0.35998514E-07_JPRB, 0.36412910E-07_JPRB, 0.36868784E-07_JPRB, 0.37360351E-07_JPRB, 0.37870883E-07_JPRB, 0.38402213E-07_JPRB, &
  & 0.38947572E-07_JPRB, 0.39502314E-07_JPRB, 0.40082234E-07_JPRB, 0.40638554E-07_JPRB, 0.41256190E-07_JPRB, 0.41830432E-07_JPRB, &
  & 0.42460776E-07_JPRB, 0.43097540E-07_JPRB, 0.43792717E-07_JPRB, 0.44520167E-07_JPRB, 0.45283976E-07_JPRB, 0.46087436E-07_JPRB, &
  & 0.46911197E-07_JPRB, 0.47749367E-07_JPRB, 0.48593190E-07_JPRB, 0.49452812E-07_JPRB, 0.50313741E-07_JPRB, 0.51193311E-07_JPRB, &
  & 0.52062404E-07_JPRB, 0.52958711E-07_JPRB, 0.53801138E-07_JPRB, 0.54656628E-07_JPRB, 0.55477226E-07_JPRB, 0.56250755E-07_JPRB, &
  & 0.57074736E-07_JPRB, 0.57783335E-07_JPRB, 0.58540948E-07_JPRB, 0.59217253E-07_JPRB, 0.59869720E-07_JPRB, 0.60492852E-07_JPRB, &
  & 0.61083213E-07_JPRB, 0.61665801E-07_JPRB, 0.62192512E-07_JPRB, 0.62730578E-07_JPRB, 0.63171214E-07_JPRB, 0.63657914E-07_JPRB, &
  & 0.64003714E-07_JPRB, 0.64459137E-07_JPRB, 0.64689267E-07_JPRB, 0.65131623E-07_JPRB, 0.65213989E-07_JPRB, 0.65667933E-07_JPRB, &
  & 0.65587038E-07_JPRB, 0.66057197E-07_JPRB, 0.65871134E-07_JPRB, 0.66255105E-07_JPRB /)

RGHG7(:,86,12) = (/ &
  & 0.34168259E-07_JPRB, 0.33882678E-07_JPRB, 0.34382271E-07_JPRB, 0.34122554E-07_JPRB, 0.34411542E-07_JPRB, 0.34458871E-07_JPRB, &
  & 0.34557168E-07_JPRB, 0.34754940E-07_JPRB, 0.34884021E-07_JPRB, 0.35124863E-07_JPRB, 0.35353509E-07_JPRB, 0.35652576E-07_JPRB, &
  & 0.35979838E-07_JPRB, 0.36383820E-07_JPRB, 0.36840479E-07_JPRB, 0.37338125E-07_JPRB, 0.37858321E-07_JPRB, 0.38383682E-07_JPRB, &
  & 0.38936630E-07_JPRB, 0.39476056E-07_JPRB, 0.40058254E-07_JPRB, 0.40629747E-07_JPRB, 0.41222684E-07_JPRB, 0.41814701E-07_JPRB, &
  & 0.42450949E-07_JPRB, 0.43093550E-07_JPRB, 0.43786923E-07_JPRB, 0.44515858E-07_JPRB, 0.45282651E-07_JPRB, 0.46085297E-07_JPRB, &
  & 0.46913186E-07_JPRB, 0.47755048E-07_JPRB, 0.48606285E-07_JPRB, 0.49464845E-07_JPRB, 0.50333554E-07_JPRB, 0.51205497E-07_JPRB, &
  & 0.52098002E-07_JPRB, 0.52975317E-07_JPRB, 0.53852766E-07_JPRB, 0.54692457E-07_JPRB, 0.55518640E-07_JPRB, 0.56304916E-07_JPRB, &
  & 0.57097779E-07_JPRB, 0.57842385E-07_JPRB, 0.58558843E-07_JPRB, 0.59245764E-07_JPRB, 0.59885004E-07_JPRB, 0.60509869E-07_JPRB, &
  & 0.61088691E-07_JPRB, 0.61676900E-07_JPRB, 0.62193607E-07_JPRB, 0.62736270E-07_JPRB, 0.63167711E-07_JPRB, 0.63664807E-07_JPRB, &
  & 0.63996445E-07_JPRB, 0.64471891E-07_JPRB, 0.64677991E-07_JPRB, 0.65146978E-07_JPRB, 0.65201732E-07_JPRB, 0.65677291E-07_JPRB, &
  & 0.65578398E-07_JPRB, 0.66058348E-07_JPRB, 0.65858892E-07_JPRB, 0.66258700E-07_JPRB /)

RGHG7(:,87,12) = (/ &
  & 0.34188105E-07_JPRB, 0.33839729E-07_JPRB, 0.34419696E-07_JPRB, 0.34028144E-07_JPRB, 0.34494917E-07_JPRB, 0.34358504E-07_JPRB, &
  & 0.34631316E-07_JPRB, 0.34738218E-07_JPRB, 0.34935528E-07_JPRB, 0.35147345E-07_JPRB, 0.35397782E-07_JPRB, 0.35651350E-07_JPRB, &
  & 0.35988062E-07_JPRB, 0.36351196E-07_JPRB, 0.36813578E-07_JPRB, 0.37310699E-07_JPRB, 0.37829583E-07_JPRB, 0.38370999E-07_JPRB, &
  & 0.38902332E-07_JPRB, 0.39469530E-07_JPRB, 0.40041957E-07_JPRB, 0.40599023E-07_JPRB, 0.41207823E-07_JPRB, 0.41797804E-07_JPRB, &
  & 0.42428862E-07_JPRB, 0.43080821E-07_JPRB, 0.43775991E-07_JPRB, 0.44508838E-07_JPRB, 0.45278949E-07_JPRB, 0.46078384E-07_JPRB, &
  & 0.46911293E-07_JPRB, 0.47757212E-07_JPRB, 0.48607653E-07_JPRB, 0.49470987E-07_JPRB, 0.50334396E-07_JPRB, 0.51213970E-07_JPRB, &
  & 0.52104525E-07_JPRB, 0.53004207E-07_JPRB, 0.53884946E-07_JPRB, 0.54734087E-07_JPRB, 0.55577122E-07_JPRB, 0.56358957E-07_JPRB, &
  & 0.57144597E-07_JPRB, 0.57890443E-07_JPRB, 0.58594402E-07_JPRB, 0.59270349E-07_JPRB, 0.59898952E-07_JPRB, 0.60525110E-07_JPRB, &
  & 0.61094923E-07_JPRB, 0.61682499E-07_JPRB, 0.62196726E-07_JPRB, 0.62737229E-07_JPRB, 0.63169729E-07_JPRB, 0.63661794E-07_JPRB, &
  & 0.63997511E-07_JPRB, 0.64463379E-07_JPRB, 0.64682325E-07_JPRB, 0.65131502E-07_JPRB, 0.65212937E-07_JPRB, 0.65657147E-07_JPRB, &
  & 0.65592204E-07_JPRB, 0.66042141E-07_JPRB, 0.65863340E-07_JPRB, 0.66257336E-07_JPRB /)

RGHG7(:,88,12) = (/ &
  & 0.34192418E-07_JPRB, 0.33825824E-07_JPRB, 0.34432905E-07_JPRB, 0.33995263E-07_JPRB, 0.34557786E-07_JPRB, 0.34287091E-07_JPRB, &
  & 0.34733038E-07_JPRB, 0.34689378E-07_JPRB, 0.35005289E-07_JPRB, 0.35125225E-07_JPRB, 0.35411450E-07_JPRB, 0.35643030E-07_JPRB, &
  & 0.35968494E-07_JPRB, 0.36345241E-07_JPRB, 0.36793530E-07_JPRB, 0.37289762E-07_JPRB, 0.37818889E-07_JPRB, 0.38342915E-07_JPRB, &
  & 0.38892665E-07_JPRB, 0.39447432E-07_JPRB, 0.40008636E-07_JPRB, 0.40587654E-07_JPRB, 0.41173699E-07_JPRB, 0.41779423E-07_JPRB, &
  & 0.42404995E-07_JPRB, 0.43065047E-07_JPRB, 0.43759886E-07_JPRB, 0.44495128E-07_JPRB, 0.45269125E-07_JPRB, 0.46068291E-07_JPRB, &
  & 0.46906564E-07_JPRB, 0.47754096E-07_JPRB, 0.48610360E-07_JPRB, 0.49480143E-07_JPRB, 0.50349517E-07_JPRB, 0.51239812E-07_JPRB, &
  & 0.52142560E-07_JPRB, 0.53044047E-07_JPRB, 0.53933793E-07_JPRB, 0.54791947E-07_JPRB, 0.55619012E-07_JPRB, 0.56433674E-07_JPRB, &
  & 0.57188092E-07_JPRB, 0.57935306E-07_JPRB, 0.58626732E-07_JPRB, 0.59296756E-07_JPRB, 0.59917006E-07_JPRB, 0.60539911E-07_JPRB, &
  & 0.61110143E-07_JPRB, 0.61692582E-07_JPRB, 0.62208578E-07_JPRB, 0.62740227E-07_JPRB, 0.63179677E-07_JPRB, 0.63659670E-07_JPRB, &
  & 0.64009853E-07_JPRB, 0.64455456E-07_JPRB, 0.64699464E-07_JPRB, 0.65117206E-07_JPRB, 0.65233102E-07_JPRB, 0.65638851E-07_JPRB, &
  & 0.65611346E-07_JPRB, 0.66023667E-07_JPRB, 0.65879227E-07_JPRB, 0.66242926E-07_JPRB /)

RGHG7(:,89,12) = (/ &
  & 0.34194155E-07_JPRB, 0.33824744E-07_JPRB, 0.34417297E-07_JPRB, 0.33998145E-07_JPRB, 0.34534221E-07_JPRB, 0.34267902E-07_JPRB, &
  & 0.34719722E-07_JPRB, 0.34631785E-07_JPRB, 0.34991455E-07_JPRB, 0.35078330E-07_JPRB, 0.35395630E-07_JPRB, 0.35617106E-07_JPRB, &
  & 0.35972185E-07_JPRB, 0.36332196E-07_JPRB, 0.36794077E-07_JPRB, 0.37289183E-07_JPRB, 0.37808221E-07_JPRB, 0.38334566E-07_JPRB, &
  & 0.38877527E-07_JPRB, 0.39431264E-07_JPRB, 0.39985707E-07_JPRB, 0.40559769E-07_JPRB, 0.41144702E-07_JPRB, 0.41748006E-07_JPRB, &
  & 0.42375106E-07_JPRB, 0.43036447E-07_JPRB, 0.43734065E-07_JPRB, 0.44473111E-07_JPRB, 0.45250946E-07_JPRB, 0.46057725E-07_JPRB, &
  & 0.46903249E-07_JPRB, 0.47759450E-07_JPRB, 0.48624258E-07_JPRB, 0.49502379E-07_JPRB, 0.50385385E-07_JPRB, 0.51290314E-07_JPRB, &
  & 0.52208307E-07_JPRB, 0.53118999E-07_JPRB, 0.54009885E-07_JPRB, 0.54869592E-07_JPRB, 0.55695605E-07_JPRB, 0.56492468E-07_JPRB, &
  & 0.57256191E-07_JPRB, 0.57979747E-07_JPRB, 0.58664160E-07_JPRB, 0.59323447E-07_JPRB, 0.59942437E-07_JPRB, 0.60554832E-07_JPRB, &
  & 0.61127139E-07_JPRB, 0.61701357E-07_JPRB, 0.62223862E-07_JPRB, 0.62745059E-07_JPRB, 0.63194584E-07_JPRB, 0.63658796E-07_JPRB, &
  & 0.64026409E-07_JPRB, 0.64447136E-07_JPRB, 0.64719252E-07_JPRB, 0.65102583E-07_JPRB, 0.65256671E-07_JPRB, 0.65619879E-07_JPRB, &
  & 0.65635874E-07_JPRB, 0.66004922E-07_JPRB, 0.65899478E-07_JPRB, 0.66227805E-07_JPRB /)

RGHG7(:,90,12) = (/ &
  & 0.34178967E-07_JPRB, 0.33853276E-07_JPRB, 0.34369638E-07_JPRB, 0.34045598E-07_JPRB, 0.34466151E-07_JPRB, 0.34315644E-07_JPRB, &
  & 0.34622072E-07_JPRB, 0.34632102E-07_JPRB, 0.34880795E-07_JPRB, 0.35029853E-07_JPRB, 0.35316980E-07_JPRB, 0.35589242E-07_JPRB, &
  & 0.35943177E-07_JPRB, 0.36337902E-07_JPRB, 0.36805325E-07_JPRB, 0.37287073E-07_JPRB, 0.37809144E-07_JPRB, 0.38322955E-07_JPRB, &
  & 0.38866194E-07_JPRB, 0.39395264E-07_JPRB, 0.39958515E-07_JPRB, 0.40518685E-07_JPRB, 0.41099245E-07_JPRB, 0.41702453E-07_JPRB, &
  & 0.42327962E-07_JPRB, 0.42991402E-07_JPRB, 0.43693039E-07_JPRB, 0.44437417E-07_JPRB, 0.45222944E-07_JPRB, 0.46042796E-07_JPRB, &
  & 0.46895654E-07_JPRB, 0.47761343E-07_JPRB, 0.48643830E-07_JPRB, 0.49552529E-07_JPRB, 0.50453895E-07_JPRB, 0.51393247E-07_JPRB, &
  & 0.52330417E-07_JPRB, 0.53246147E-07_JPRB, 0.54130371E-07_JPRB, 0.54982785E-07_JPRB, 0.55802388E-07_JPRB, 0.56585112E-07_JPRB, &
  & 0.57331214E-07_JPRB, 0.58043302E-07_JPRB, 0.58716662E-07_JPRB, 0.59362179E-07_JPRB, 0.59981318E-07_JPRB, 0.60585243E-07_JPRB, &
  & 0.61160108E-07_JPRB, 0.61724236E-07_JPRB, 0.62251658E-07_JPRB, 0.62760733E-07_JPRB, 0.63219780E-07_JPRB, 0.63667521E-07_JPRB, &
  & 0.64053530E-07_JPRB, 0.64448109E-07_JPRB, 0.64749308E-07_JPRB, 0.65093808E-07_JPRB, 0.65291516E-07_JPRB, 0.65601029E-07_JPRB, &
  & 0.65673795E-07_JPRB, 0.65980707E-07_JPRB, 0.65935453E-07_JPRB, 0.66207953E-07_JPRB /)

RGHG7(:,91,12) = (/ &
  & 0.34094512E-07_JPRB, 0.33958397E-07_JPRB, 0.34243612E-07_JPRB, 0.34141145E-07_JPRB, 0.34356631E-07_JPRB, 0.34370519E-07_JPRB, &
  & 0.34518056E-07_JPRB, 0.34601069E-07_JPRB, 0.34750983E-07_JPRB, 0.34906094E-07_JPRB, 0.35214473E-07_JPRB, 0.35544396E-07_JPRB, &
  & 0.35928466E-07_JPRB, 0.36350450E-07_JPRB, 0.36806949E-07_JPRB, 0.37290601E-07_JPRB, 0.37793093E-07_JPRB, 0.38304066E-07_JPRB, &
  & 0.38825785E-07_JPRB, 0.39360202E-07_JPRB, 0.39902822E-07_JPRB, 0.40455859E-07_JPRB, 0.41029860E-07_JPRB, 0.41630003E-07_JPRB, &
  & 0.42255529E-07_JPRB, 0.42921481E-07_JPRB, 0.43631321E-07_JPRB, 0.44385811E-07_JPRB, 0.45185892E-07_JPRB, 0.46025416E-07_JPRB, &
  & 0.46896162E-07_JPRB, 0.47783573E-07_JPRB, 0.48691977E-07_JPRB, 0.49654428E-07_JPRB, 0.50563603E-07_JPRB, 0.51561312E-07_JPRB, &
  & 0.52531977E-07_JPRB, 0.53454286E-07_JPRB, 0.54333828E-07_JPRB, 0.55175846E-07_JPRB, 0.55974983E-07_JPRB, 0.56735018E-07_JPRB, &
  & 0.57460245E-07_JPRB, 0.58147950E-07_JPRB, 0.58802279E-07_JPRB, 0.59429244E-07_JPRB, 0.60038403E-07_JPRB, 0.60631812E-07_JPRB, &
  & 0.61204631E-07_JPRB, 0.61762343E-07_JPRB, 0.62291434E-07_JPRB, 0.62793013E-07_JPRB, 0.63255989E-07_JPRB, 0.63691949E-07_JPRB, &
  & 0.64089946E-07_JPRB, 0.64464729E-07_JPRB, 0.64787770E-07_JPRB, 0.65097680E-07_JPRB, 0.65336138E-07_JPRB, 0.65588253E-07_JPRB, &
  & 0.65729814E-07_JPRB, 0.65947823E-07_JPRB, 0.66006827E-07_JPRB, 0.66159451E-07_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_OZOCLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_OZOCLIM
